<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>adaptive.h</h1>  </div>
</div>
<div class="contents">
<a href="adaptive_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: adaptive.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __adaptive_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __adaptive_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="linear_8h.php">linear.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;error_vector.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;kelly_error_estimator.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;mesh_refinement.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;mesh.h&quot;</span>
<a name="l00034"></a>00034 
<a name="l00043"></a>00043 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00044"></a>00044 <span class="comment">// Adaptive class definition</span>
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T = Linear&lt;&gt; &gt;
<a name="l00047"></a><a class="code" href="classAdaptive.php">00047</a> <span class="keyword">class </span><a class="code" href="classAdaptive.php">Adaptive</a> : <span class="keyword">public</span> T
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049 <span class="keyword">public</span>:
<a name="l00050"></a>00050   
<a name="l00054"></a>00054   <a class="code" href="classAdaptive.php#ae7444a3c809ff6507e8a58efc0446a07">Adaptive</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es);
<a name="l00055"></a>00055 
<a name="l00059"></a>00059   <a class="code" href="classAdaptive.php#ae7444a3c809ff6507e8a58efc0446a07">Adaptive</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00060"></a>00060             <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00061"></a>00061             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number);
<a name="l00062"></a>00062 
<a name="l00066"></a>00066   <a class="code" href="classAdaptive.php#a5655a67c1ef8dbce5d3ac21325e0b751">~Adaptive</a> ();
<a name="l00067"></a>00067 
<a name="l00072"></a>00072   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classAdaptive.php#a3d58bac83e3561ef8c4f46d578f27ee4">solve</a> ();
<a name="l00073"></a>00073 
<a name="l00077"></a><a class="code" href="classAdaptive.php#a022f331d34aa1b3ac2183950ae41dda4">00077</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classAdaptive.php#a022f331d34aa1b3ac2183950ae41dda4">refinement_step</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classAdaptive.php#a424db2426ec955563c8898810715f9d4">_refinement_step</a>; }
<a name="l00078"></a>00078 
<a name="l00082"></a><a class="code" href="classAdaptive.php#a3590044f5b4a775a5293b444d29d65ca">00082</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classAdaptive.php#a3590044f5b4a775a5293b444d29d65ca">n_refinement_steps</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classAdaptive.php#a63934b8d616fc849ac950d2d90eca7ac">_n_refinement_steps</a>; }
<a name="l00083"></a>00083 
<a name="l00087"></a><a class="code" href="classAdaptive.php#a9e04bcdfeb38c7e110887fff0d6025fb">00087</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp; <a class="code" href="classAdaptive.php#a9e04bcdfeb38c7e110887fff0d6025fb">n_refinement_steps</a> () { <span class="keywordflow">return</span> <a class="code" href="classAdaptive.php#a63934b8d616fc849ac950d2d90eca7ac">_n_refinement_steps</a>; }  
<a name="l00088"></a>00088 
<a name="l00092"></a><a class="code" href="classAdaptive.php#aac7a86a601e231a7d9df61989658ce5a">00092</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classAdaptive.php#aac7a86a601e231a7d9df61989658ce5a">max_refinement_level</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classAdaptive.php#abac5fb78920579d32b3d98575ccebccc">_max_refinement_level</a>; }
<a name="l00093"></a>00093 
<a name="l00097"></a><a class="code" href="classAdaptive.php#aeb0e770385d466a74664b02c71cc4188">00097</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp; <a class="code" href="classAdaptive.php#aeb0e770385d466a74664b02c71cc4188">max_refinement_level</a> () { <span class="keywordflow">return</span> <a class="code" href="classAdaptive.php#abac5fb78920579d32b3d98575ccebccc">_max_refinement_level</a>; }
<a name="l00098"></a>00098   
<a name="l00099"></a>00099   
<a name="l00100"></a>00100 <span class="keyword">protected</span>:
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   
<a name="l00106"></a><a class="code" href="classAdaptive.php#ab11846531d1bf3ba53f210f76d83dbd4">00106</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp; <a class="code" href="classAdaptive.php#ab11846531d1bf3ba53f210f76d83dbd4">refinement_step</a> () { <span class="keywordflow">return</span> <a class="code" href="classAdaptive.php#a424db2426ec955563c8898810715f9d4">_refinement_step</a>; }
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   
<a name="l00109"></a>00109 <span class="keyword">private</span>:
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 
<a name="l00115"></a><a class="code" href="classAdaptive.php#a424db2426ec955563c8898810715f9d4">00115</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classAdaptive.php#a424db2426ec955563c8898810715f9d4">_refinement_step</a>;
<a name="l00116"></a>00116   
<a name="l00120"></a><a class="code" href="classAdaptive.php#a63934b8d616fc849ac950d2d90eca7ac">00120</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classAdaptive.php#a63934b8d616fc849ac950d2d90eca7ac">_n_refinement_steps</a>;
<a name="l00121"></a>00121 
<a name="l00125"></a><a class="code" href="classAdaptive.php#abac5fb78920579d32b3d98575ccebccc">00125</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classAdaptive.php#abac5fb78920579d32b3d98575ccebccc">_max_refinement_level</a>;
<a name="l00126"></a>00126 };
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00131"></a>00131 <span class="comment">// Adaptive inline members</span>
<a name="l00132"></a>00132 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00133"></a><a class="code" href="classAdaptive.php#ae7444a3c809ff6507e8a58efc0446a07">00133</a> <a class="code" href="classAdaptive.php#ae7444a3c809ff6507e8a58efc0446a07">Adaptive&lt;T&gt;::Adaptive</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es) :
<a name="l00134"></a>00134   T                    (es), <span class="comment">// Call the base class constructor</span>
<a name="l00135"></a>00135   _refinement_step     (0),  <span class="comment">// Solver parameters</span>
<a name="l00136"></a>00136   _n_refinement_steps  (1),
<a name="l00137"></a>00137   _max_refinement_level(100)
<a name="l00138"></a>00138 {
<a name="l00139"></a>00139 }
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00144"></a><a class="code" href="classAdaptive.php#a3178168789869cac6f97b044388b1470">00144</a> <a class="code" href="classAdaptive.php#ae7444a3c809ff6507e8a58efc0446a07">Adaptive&lt;T&gt;::Adaptive</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00145"></a>00145                        <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00146"></a>00146                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :
<a name="l00147"></a>00147   <a class="code" href="classAdaptive.php">Adaptive</a> (es),
<a name="l00148"></a>00148   T        (es, name, number)
<a name="l00149"></a>00149 {
<a name="l00150"></a>00150 }
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00155"></a><a class="code" href="classAdaptive.php#a5655a67c1ef8dbce5d3ac21325e0b751">00155</a> <a class="code" href="classAdaptive.php#a5655a67c1ef8dbce5d3ac21325e0b751">Adaptive&lt;T&gt;::~Adaptive</a> ()
<a name="l00156"></a>00156 {
<a name="l00157"></a>00157 }
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00162"></a><a class="code" href="classAdaptive.php#a3d58bac83e3561ef8c4f46d578f27ee4">00162</a> <span class="keywordtype">void</span> <a class="code" href="classAdaptive.php#a3d58bac83e3561ef8c4f46d578f27ee4">Adaptive&lt;T&gt;::solve</a> ()
<a name="l00163"></a>00163 {
<a name="l00164"></a>00164   <span class="comment">// First solve the base system</span>
<a name="l00165"></a>00165   T::solve ();
<a name="l00166"></a>00166       
<a name="l00167"></a>00167   <span class="keywordflow">for</span> (this-&gt;refinement_step()=0;
<a name="l00168"></a>00168        this-&gt;refinement_step() &lt; this-&gt;n_refinement_steps();
<a name="l00169"></a>00169        this-&gt;refinement_step()++)
<a name="l00170"></a>00170     {  
<a name="l00171"></a>00171       <span class="comment">// Then estimate the error in the base system</span>
<a name="l00172"></a>00172       <span class="comment">// and refine the mesh</span>
<a name="l00173"></a>00173       {
<a name="l00174"></a>00174         <a class="code" href="classErrorVector.php">ErrorVector</a> error;
<a name="l00175"></a>00175         
<a name="l00176"></a>00176         <a class="code" href="classKellyErrorEstimator.php">KellyErrorEstimator</a> error_estimator;
<a name="l00177"></a>00177         
<a name="l00178"></a>00178         error_estimator.<a class="code" href="classJumpErrorEstimator.php#ad3e546c8f4df715b82faea55b5fc7a59">estimate_error</a> (this-&gt;system(), <span class="stringliteral">&quot;incomp_ns&quot;</span>, error);
<a name="l00179"></a>00179         
<a name="l00180"></a>00180         <a class="code" href="classMeshRefinement.php">MeshRefinement</a> mesh_refinement (this-&gt;mesh());
<a name="l00181"></a>00181         
<a name="l00182"></a>00182         mesh_refinement.<a class="code" href="classMeshRefinement.php#ae6ecd83fa4d99cb8ca0523343e920dba">flag_elements_by_error_fraction</a> (error,
<a name="l00183"></a>00183                                                          0.40,
<a name="l00184"></a>00184                                                          0.40,
<a name="l00185"></a>00185                                                          this-&gt;max_refinement_level());
<a name="l00186"></a>00186         
<a name="l00187"></a>00187         mesh_refinement.<a class="code" href="classMeshRefinement.php#a0c992129fc3ed9b157eb98f2b75db7d9">refine_and_coarsen_elements</a> ();
<a name="l00188"></a>00188 
<a name="l00189"></a>00189         this-&gt;system().reinit ();
<a name="l00190"></a>00190       }
<a name="l00191"></a>00191   
<a name="l00192"></a>00192       <span class="comment">// Then re-solve the base system</span>
<a name="l00193"></a>00193       T::solve ();
<a name="l00194"></a>00194     }
<a name="l00195"></a>00195 }
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 <span class="preprocessor">#endif // #define __adaptive_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
