<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_60be1125a39495b698d2d56e8e5b50b1.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>adaptive_time_solver.C</h1>  </div>
</div>
<div class="contents">
<a href="adaptive__time__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: adaptive_time_solver.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;adaptive_time_solver.h&quot;</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;diff_system.h&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;euler_solver.h&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a><a class="code" href="classAdaptiveTimeSolver.php#aafa679e869a2f96308d3475199014615">00027</a> <a class="code" href="classAdaptiveTimeSolver.php#aafa679e869a2f96308d3475199014615">AdaptiveTimeSolver::AdaptiveTimeSolver</a> (<a class="code" href="classDifferentiableSystem.php">sys_type</a>&amp; s)
<a name="l00028"></a>00028  : <a class="code" href="classUnsteadySolver.php">UnsteadySolver</a>(s),
<a name="l00029"></a>00029    core_time_solver(NULL),
<a name="l00030"></a>00030    target_tolerance(1.e-3), upper_tolerance(0.0),
<a name="l00031"></a>00031    max_deltat(0.),
<a name="l00032"></a>00032    min_deltat(0.),
<a name="l00033"></a>00033    max_growth(0.),
<a name="l00034"></a>00034    global_tolerance(true)
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036   <span class="comment">// the child class must populate core_time_solver</span>
<a name="l00037"></a>00037   <span class="comment">// with whatever actual time solver is to be used</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039   <span class="comment">// As an UnsteadySolver, we have an old_local_nonlinear_solution, but we&#39;re</span>
<a name="l00040"></a>00040   <span class="comment">// going to drop it and use our core time solver&#39;s instead.</span>
<a name="l00041"></a>00041   <a class="code" href="classUnsteadySolver.php#a6375bafc6aac07ec0937feb5b732fc98">old_local_nonlinear_solution</a>.<a class="code" href="classAutoPtr.php#afba95dd5fca7f83ababa4eaf6a57c511" title="Forcibly deletes the managed object.">reset</a>();
<a name="l00042"></a>00042 }
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a><a class="code" href="classAdaptiveTimeSolver.php#a4239b02ae37490bf0a6f8c9c0bcd6b4e">00046</a> <a class="code" href="classAdaptiveTimeSolver.php#a4239b02ae37490bf0a6f8c9c0bcd6b4e">AdaptiveTimeSolver::~AdaptiveTimeSolver</a> ()
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048   <span class="comment">// As an UnsteadySolver, we have an old_local_nonlinear_solution, but it</span>
<a name="l00049"></a>00049   <span class="comment">// is being managed by our core_time_solver.  Make sure we don&#39;t delete</span>
<a name="l00050"></a>00050   <span class="comment">// it out from under them, in case the user wants to keep using the core</span>
<a name="l00051"></a>00051   <span class="comment">// solver after they&#39;re done with us.</span>
<a name="l00052"></a>00052   <a class="code" href="classUnsteadySolver.php#a6375bafc6aac07ec0937feb5b732fc98">old_local_nonlinear_solution</a>.<a class="code" href="classAutoPtr.php#af9d9cdff0aa3e2df96b18b197be2c9ac" title="Bypassing the smart pointer.">release</a>();
<a name="l00053"></a>00053 }
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00057"></a><a class="code" href="classAdaptiveTimeSolver.php#a9479b5694eff35a465161089e64ddef8">00057</a> <span class="keywordtype">void</span> <a class="code" href="classAdaptiveTimeSolver.php#a9479b5694eff35a465161089e64ddef8">AdaptiveTimeSolver::init</a>()
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059   libmesh_assert(<a class="code" href="classAdaptiveTimeSolver.php#a149f07022abd7c6130f6f8647f1f9eb9">core_time_solver</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>());
<a name="l00060"></a>00060 
<a name="l00061"></a>00061   <span class="comment">// We override this because our core_time_solver is the one that</span>
<a name="l00062"></a>00062   <span class="comment">// needs to handle new vectors, diff_solver-&gt;init(), etc</span>
<a name="l00063"></a>00063   <a class="code" href="classAdaptiveTimeSolver.php#a149f07022abd7c6130f6f8647f1f9eb9">core_time_solver</a>-&gt;init();
<a name="l00064"></a>00064 
<a name="l00065"></a>00065   <span class="comment">// As an UnsteadySolver, we have an old_local_nonlinear_solution, but it</span>
<a name="l00066"></a>00066   <span class="comment">// isn&#39;t pointing to the right place - fix it</span>
<a name="l00067"></a>00067   <span class="comment">//</span>
<a name="l00068"></a>00068   <span class="comment">// This leaves us with two AutoPtrs holding the same pointer - dangerous</span>
<a name="l00069"></a>00069   <span class="comment">// for future use.  Replace with shared_ptr?</span>
<a name="l00070"></a>00070   <a class="code" href="classUnsteadySolver.php#a6375bafc6aac07ec0937feb5b732fc98">old_local_nonlinear_solution</a> = 
<a name="l00071"></a>00071     <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt;(<a class="code" href="classAdaptiveTimeSolver.php#a149f07022abd7c6130f6f8647f1f9eb9">core_time_solver</a>-&gt;old_local_nonlinear_solution.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>());
<a name="l00072"></a>00072 }
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00076"></a><a class="code" href="classAdaptiveTimeSolver.php#ae1ebc66293a633e530b60fc5850686d1">00076</a> <span class="keywordtype">void</span> <a class="code" href="classAdaptiveTimeSolver.php#ae1ebc66293a633e530b60fc5850686d1">AdaptiveTimeSolver::reinit</a>()
<a name="l00077"></a>00077 {
<a name="l00078"></a>00078   libmesh_assert(<a class="code" href="classAdaptiveTimeSolver.php#a149f07022abd7c6130f6f8647f1f9eb9">core_time_solver</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>());
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   <span class="comment">// We override this because our core_time_solver is the one that</span>
<a name="l00081"></a>00081   <span class="comment">// needs to handle new vectors, diff_solver-&gt;reinit(), etc</span>
<a name="l00082"></a>00082   <a class="code" href="classAdaptiveTimeSolver.php#a149f07022abd7c6130f6f8647f1f9eb9">core_time_solver</a>-&gt;reinit();
<a name="l00083"></a>00083 }
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a><a class="code" href="classAdaptiveTimeSolver.php#ac0e72b3de22efc02663e9640f8b40a00">00086</a> <span class="keywordtype">void</span> <a class="code" href="classAdaptiveTimeSolver.php#ac0e72b3de22efc02663e9640f8b40a00">AdaptiveTimeSolver::advance_timestep</a> ()
<a name="l00087"></a>00087 {
<a name="l00088"></a>00088   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp;<a class="code" href="classUnsteadySolver.php#ad14f2816697932209a6996937dd8ff18">old_nonlinear_solution</a> =
<a name="l00089"></a>00089   <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;_old_nonlinear_solution&quot;</span>);
<a name="l00090"></a>00090   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp;nonlinear_solution =
<a name="l00091"></a>00091     *(<a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>);
<a name="l00092"></a>00092 <span class="comment">//    _system.get_vector(&quot;_nonlinear_solution&quot;);</span>
<a name="l00093"></a>00093 
<a name="l00094"></a>00094   old_nonlinear_solution = nonlinear_solution;
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   <span class="keywordflow">if</span> (!<a class="code" href="classUnsteadySolver.php#a7b5693645b13d3556af0a88dab40edee">first_solve</a>)
<a name="l00097"></a>00097     <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a011fade55c7e62bea01e1e195a9d78b1">time</a> += <a class="code" href="classAdaptiveTimeSolver.php#aca1f6df28e288b850e4121e111b846c4">last_deltat</a>;
<a name="l00098"></a>00098 }
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 
<a name="l00102"></a><a class="code" href="classAdaptiveTimeSolver.php#af9b255cc809ec0b6ab7a16cfcbd642f3">00102</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classAdaptiveTimeSolver.php#af9b255cc809ec0b6ab7a16cfcbd642f3">AdaptiveTimeSolver::error_order</a> ()<span class="keyword"> const</span>
<a name="l00103"></a>00103 <span class="keyword"></span>{
<a name="l00104"></a>00104   libmesh_assert(<a class="code" href="classAdaptiveTimeSolver.php#a149f07022abd7c6130f6f8647f1f9eb9">core_time_solver</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>());
<a name="l00105"></a>00105 
<a name="l00106"></a>00106   <span class="keywordflow">return</span> <a class="code" href="classAdaptiveTimeSolver.php#a149f07022abd7c6130f6f8647f1f9eb9">core_time_solver</a>-&gt;error_order();
<a name="l00107"></a>00107 }
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 
<a name="l00111"></a><a class="code" href="classAdaptiveTimeSolver.php#af1051b3522f388c1df700246ba81341e">00111</a> <span class="keywordtype">bool</span> <a class="code" href="classAdaptiveTimeSolver.php#af1051b3522f388c1df700246ba81341e">AdaptiveTimeSolver::element_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00112"></a>00112                                            <a class="code" href="classDiffContext.php">DiffContext</a> &amp;context)
<a name="l00113"></a>00113 {
<a name="l00114"></a>00114   libmesh_assert(<a class="code" href="classAdaptiveTimeSolver.php#a149f07022abd7c6130f6f8647f1f9eb9">core_time_solver</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>());
<a name="l00115"></a>00115 
<a name="l00116"></a>00116   <span class="keywordflow">return</span> <a class="code" href="classAdaptiveTimeSolver.php#a149f07022abd7c6130f6f8647f1f9eb9">core_time_solver</a>-&gt;element_residual(request_jacobian, context);
<a name="l00117"></a>00117 }
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a><a class="code" href="classAdaptiveTimeSolver.php#ab1a76c8b211ba5acaa253dc300e93505">00121</a> <span class="keywordtype">bool</span> <a class="code" href="classAdaptiveTimeSolver.php#ab1a76c8b211ba5acaa253dc300e93505">AdaptiveTimeSolver::side_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00122"></a>00122                                         <a class="code" href="classDiffContext.php">DiffContext</a> &amp;context)
<a name="l00123"></a>00123 {
<a name="l00124"></a>00124   libmesh_assert(<a class="code" href="classAdaptiveTimeSolver.php#a149f07022abd7c6130f6f8647f1f9eb9">core_time_solver</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>());
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   <span class="keywordflow">return</span> <a class="code" href="classAdaptiveTimeSolver.php#a149f07022abd7c6130f6f8647f1f9eb9">core_time_solver</a>-&gt;side_residual(request_jacobian, context);
<a name="l00127"></a>00127 }
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 
<a name="l00131"></a><a class="code" href="classAdaptiveTimeSolver.php#ae3b18e0a953046236ca9d285a64a9562">00131</a> <a class="code" href="classAutoPtr.php">AutoPtr&lt;DiffSolver&gt;</a> &amp; <a class="code" href="classAdaptiveTimeSolver.php#ae3b18e0a953046236ca9d285a64a9562">AdaptiveTimeSolver::diff_solver</a>()
<a name="l00132"></a>00132 {
<a name="l00133"></a>00133   <span class="keywordflow">return</span> <a class="code" href="classAdaptiveTimeSolver.php#a149f07022abd7c6130f6f8647f1f9eb9">core_time_solver</a>-&gt;diff_solver();
<a name="l00134"></a>00134 }
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 
<a name="l00138"></a><a class="code" href="classAdaptiveTimeSolver.php#a7a8452001ba8eec730fa8d6917f7e846">00138</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classAdaptiveTimeSolver.php#a7a8452001ba8eec730fa8d6917f7e846">AdaptiveTimeSolver::calculate_norm</a>(<a class="code" href="classSystem.php">System</a> &amp;s,
<a name="l00139"></a>00139                                         <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp;v)
<a name="l00140"></a>00140 {
<a name="l00141"></a>00141   <span class="keywordflow">return</span> s.<a class="code" href="classSystem.php#a9b8d41c541d5fba295a6e9989939b443">calculate_norm</a>(v, <a class="code" href="classAdaptiveTimeSolver.php#a176b2f9a48610c8ab147c71163ea9a17">component_norm</a>);
<a name="l00142"></a>00142 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
