<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>adaptive_time_solver.h</h1>  </div>
</div>
<div class="contents">
<a href="adaptive__time__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: adaptive_time_solver.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __adaptive_time_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __adaptive_time_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="unsteady__solver_8h.php">unsteady_solver.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Forward declarations</span>
<a name="l00031"></a>00031 <span class="keyword">class </span><a class="code" href="classSystem.php">System</a>;
<a name="l00032"></a>00032 
<a name="l00047"></a>00047 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00048"></a>00048 <span class="comment">// Solver class definition</span>
<a name="l00049"></a><a class="code" href="classAdaptiveTimeSolver.php">00049</a> <span class="keyword">class </span><a class="code" href="classAdaptiveTimeSolver.php">AdaptiveTimeSolver</a> : <span class="keyword">public</span> <a class="code" href="classUnsteadySolver.php">UnsteadySolver</a>
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 <span class="keyword">public</span>:
<a name="l00055"></a><a class="code" href="classAdaptiveTimeSolver.php#a40c570f85890a230e83788815779cadd">00055</a>   <span class="keyword">typedef</span> <a class="code" href="classUnsteadySolver.php">UnsteadySolver</a> <a class="code" href="classAdaptiveTimeSolver.php#a40c570f85890a230e83788815779cadd">Parent</a>;
<a name="l00056"></a>00056   
<a name="l00061"></a>00061   <a class="code" href="classAdaptiveTimeSolver.php#aafa679e869a2f96308d3475199014615">AdaptiveTimeSolver</a> (<a class="code" href="classDifferentiableSystem.php">sys_type</a>&amp; s);
<a name="l00062"></a>00062   
<a name="l00066"></a>00066   <span class="keyword">virtual</span> <a class="code" href="classAdaptiveTimeSolver.php#a4239b02ae37490bf0a6f8c9c0bcd6b4e">~AdaptiveTimeSolver</a> ();
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classAdaptiveTimeSolver.php#a9479b5694eff35a465161089e64ddef8">init</a>();
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classAdaptiveTimeSolver.php#ae1ebc66293a633e530b60fc5850686d1">reinit</a>();
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classAdaptiveTimeSolver.php#a82ae9a0a41b3afe6691eb09a7f63ab44">solve</a>() = 0;
<a name="l00073"></a>00073 
<a name="l00074"></a>00074   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classAdaptiveTimeSolver.php#ac0e72b3de22efc02663e9640f8b40a00">advance_timestep</a>();
<a name="l00075"></a>00075 
<a name="l00079"></a>00079   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classAdaptiveTimeSolver.php#af9b255cc809ec0b6ab7a16cfcbd642f3">error_order</a> () <span class="keyword">const</span>;
<a name="l00080"></a>00080 
<a name="l00084"></a>00084   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classAdaptiveTimeSolver.php#af1051b3522f388c1df700246ba81341e">element_residual</a> (<span class="keywordtype">bool</span> get_jacobian,
<a name="l00085"></a>00085                                  <a class="code" href="classDiffContext.php">DiffContext</a>&amp;);
<a name="l00086"></a>00086 
<a name="l00090"></a>00090   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classAdaptiveTimeSolver.php#ab1a76c8b211ba5acaa253dc300e93505">side_residual</a> (<span class="keywordtype">bool</span> get_jacobian,
<a name="l00091"></a>00091                               <a class="code" href="classDiffContext.php">DiffContext</a>&amp;);
<a name="l00092"></a>00092 
<a name="l00096"></a>00096   <span class="keyword">virtual</span> <a class="code" href="classAutoPtr.php">AutoPtr&lt;DiffSolver&gt;</a> &amp;<a class="code" href="classAdaptiveTimeSolver.php#ae3b18e0a953046236ca9d285a64a9562">diff_solver</a>();
<a name="l00097"></a>00097 
<a name="l00101"></a><a class="code" href="classAdaptiveTimeSolver.php#a149f07022abd7c6130f6f8647f1f9eb9">00101</a>   <a class="code" href="classAutoPtr.php">AutoPtr&lt;UnsteadySolver&gt;</a> <a class="code" href="classAdaptiveTimeSolver.php#a149f07022abd7c6130f6f8647f1f9eb9">core_time_solver</a>;
<a name="l00102"></a>00102 
<a name="l00106"></a><a class="code" href="classAdaptiveTimeSolver.php#a176b2f9a48610c8ab147c71163ea9a17">00106</a>   <a class="code" href="classSystemNorm.php">SystemNorm</a> <a class="code" href="classAdaptiveTimeSolver.php#a176b2f9a48610c8ab147c71163ea9a17">component_norm</a>;
<a name="l00107"></a>00107 
<a name="l00114"></a><a class="code" href="classAdaptiveTimeSolver.php#a692fbf4e130a568455bc62de46142104">00114</a>   std::vector&lt;float&gt; <a class="code" href="classAdaptiveTimeSolver.php#a692fbf4e130a568455bc62de46142104">component_scale</a>;
<a name="l00115"></a>00115 
<a name="l00125"></a><a class="code" href="classAdaptiveTimeSolver.php#a3110c951714fc646d215fc85469397ad">00125</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classAdaptiveTimeSolver.php#a3110c951714fc646d215fc85469397ad">target_tolerance</a>;
<a name="l00126"></a>00126 
<a name="l00134"></a><a class="code" href="classAdaptiveTimeSolver.php#a36ef788a194a1eafd46776213ecd6816">00134</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classAdaptiveTimeSolver.php#a36ef788a194a1eafd46776213ecd6816">upper_tolerance</a>;
<a name="l00135"></a>00135 
<a name="l00140"></a><a class="code" href="classAdaptiveTimeSolver.php#a3651c373f66a89f02942aaffff8ea7bd">00140</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classAdaptiveTimeSolver.php#a3651c373f66a89f02942aaffff8ea7bd">max_deltat</a>;
<a name="l00141"></a>00141 
<a name="l00146"></a><a class="code" href="classAdaptiveTimeSolver.php#a368823c5f0a3856313ca907b324474bb">00146</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classAdaptiveTimeSolver.php#a368823c5f0a3856313ca907b324474bb">min_deltat</a>;
<a name="l00147"></a>00147   
<a name="l00154"></a><a class="code" href="classAdaptiveTimeSolver.php#a00e6c3f8c3076ad6da5aff808f5bd5c5">00154</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classAdaptiveTimeSolver.php#a00e6c3f8c3076ad6da5aff808f5bd5c5">max_growth</a>;
<a name="l00155"></a>00155 
<a name="l00170"></a><a class="code" href="classAdaptiveTimeSolver.php#a62231a112593811d4b3f251001660974">00170</a>   <span class="keywordtype">bool</span> <a class="code" href="classAdaptiveTimeSolver.php#a62231a112593811d4b3f251001660974">global_tolerance</a>;
<a name="l00171"></a>00171   
<a name="l00172"></a>00172 <span class="keyword">protected</span>:
<a name="l00173"></a>00173 
<a name="l00179"></a><a class="code" href="classAdaptiveTimeSolver.php#aca1f6df28e288b850e4121e111b846c4">00179</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classAdaptiveTimeSolver.php#aca1f6df28e288b850e4121e111b846c4">last_deltat</a>;
<a name="l00180"></a>00180 
<a name="l00184"></a>00184   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classAdaptiveTimeSolver.php#a7a8452001ba8eec730fa8d6917f7e846">calculate_norm</a>(<a class="code" href="classSystem.php">System</a> &amp;, <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp;);
<a name="l00185"></a>00185 };
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 <span class="preprocessor">#endif // #define __adaptive_time_solver_</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
