<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_570b8306c88722caf9b7ae131e1a07b6.php">error_estimation</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>adjoint_residual_error_estimator.C</h1>  </div>
</div>
<div class="contents">
<a href="adjoint__residual__error__estimator_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: adjoint_residual_error_estimator.C 3411 2009-06-26 21:03:58Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;adjoint_residual_error_estimator.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;error_vector.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;patch_recovery_error_estimator.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;system.h&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00034"></a>00034 <span class="comment">// AdjointResidualErrorEstimator implementations</span>
<a name="l00035"></a><a class="code" href="classAdjointResidualErrorEstimator.php#ab6705e0378988309ce3e52188a08f7dd">00035</a> <a class="code" href="classAdjointResidualErrorEstimator.php#ab6705e0378988309ce3e52188a08f7dd">AdjointResidualErrorEstimator::AdjointResidualErrorEstimator</a> () :
<a name="l00036"></a>00036   adjoint_already_solved(false),
<a name="l00037"></a>00037   error_plot_suffix(),
<a name="l00038"></a>00038   _primal_error_estimator(new <a class="code" href="classPatchRecoveryErrorEstimator.php">PatchRecoveryErrorEstimator</a>()),
<a name="l00039"></a>00039   _dual_error_estimator(new <a class="code" href="classPatchRecoveryErrorEstimator.php">PatchRecoveryErrorEstimator</a>())
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041 }
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a><a class="code" href="classAdjointResidualErrorEstimator.php#aab306d35853814bbafa495920d8fc2f3">00045</a> <span class="keywordtype">void</span> <a class="code" href="classAdjointResidualErrorEstimator.php#aab306d35853814bbafa495920d8fc2f3">AdjointResidualErrorEstimator::estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; _system,
<a name="l00046"></a>00046                                                     <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00047"></a>00047                                                     <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector,
<a name="l00048"></a>00048                                                     <span class="keywordtype">bool</span> estimate_parent_error)
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050   START_LOG(<span class="stringliteral">&quot;estimate_error()&quot;</span>, <span class="stringliteral">&quot;AdjointResidualErrorEstimator&quot;</span>);
<a name="l00051"></a>00051 
<a name="l00052"></a>00052   <span class="comment">// Start by estimating the primal problem error</span>
<a name="l00053"></a>00053   <a class="code" href="classAdjointResidualErrorEstimator.php#a7d708cad8b719b9273db16a3563aa2df">_primal_error_estimator</a>-&gt;estimate_error
<a name="l00054"></a>00054     (_system, error_per_cell, solution_vector, estimate_parent_error);
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   <span class="comment">// Solve the dual problem if we have to</span>
<a name="l00057"></a>00057   <span class="keywordflow">if</span> (!<a class="code" href="classAdjointResidualErrorEstimator.php#a4fc519b144f470ec5a3085f901a01e2e">adjoint_already_solved</a>)
<a name="l00058"></a>00058     {
<a name="l00059"></a>00059       <span class="comment">// FIXME - we&#39;ll need to change a lot of APIs to make this trick</span>
<a name="l00060"></a>00060       <span class="comment">// work with a const System...</span>
<a name="l00061"></a>00061       <a class="code" href="classSystem.php">System</a>&amp;  system = <span class="keyword">const_cast&lt;</span><a class="code" href="classSystem.php">System</a>&amp;<span class="keyword">&gt;</span>(_system);
<a name="l00062"></a>00062       system.<a class="code" href="classSystem.php#af8a033911a3c5403f68baf10320ef7f1">adjoint_solve</a>();
<a name="l00063"></a>00063     }
<a name="l00064"></a>00064 
<a name="l00065"></a>00065   <span class="comment">// This bookkeeping should now be taken care of in subestimators</span>
<a name="l00066"></a>00066   <span class="comment">// when they see a non-default solution_vector</span>
<a name="l00067"></a>00067   <span class="comment">//</span>
<a name="l00068"></a>00068   <span class="comment">// // Swap the system solution and dual solution, so our next error</span>
<a name="l00069"></a>00069   <span class="comment">// // estimate will use the latter</span>
<a name="l00070"></a>00070   <span class="comment">// // system.solution-&gt;swap(system.get_adjoint_solution());</span>
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   <span class="comment">// // Don&#39;t forget to keep the current_local_solution consistent, as</span>
<a name="l00073"></a>00073   <span class="comment">// // error estimators are likely to use that!</span>
<a name="l00074"></a>00074   <span class="comment">// // system.update();</span>
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <span class="comment">// Get a separate estimate of the dual problem error</span>
<a name="l00077"></a>00077   <a class="code" href="classErrorVector.php">ErrorVector</a> dual_error_per_cell;
<a name="l00078"></a>00078   <a class="code" href="classAdjointResidualErrorEstimator.php#a0697abf7ce0191d9fd81f4e6593c1e28">_dual_error_estimator</a>-&gt;estimate_error
<a name="l00079"></a>00079     (_system, dual_error_per_cell, &amp;(_system.<a class="code" href="classSystem.php#ad86b44047ff7beb018105be1b20cab82">get_adjoint_solution</a>()),
<a name="l00080"></a>00080      estimate_parent_error);
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   <span class="comment">// Do some debugging plots if requested</span>
<a name="l00083"></a>00083   <span class="keywordflow">if</span> (!<a class="code" href="classAdjointResidualErrorEstimator.php#a5be027e048cb14caec9462aa8be81317">error_plot_suffix</a>.empty())
<a name="l00084"></a>00084     {
<a name="l00085"></a>00085       std::string primal_out = <span class="stringliteral">&quot;primal_&quot;</span>;
<a name="l00086"></a>00086       std::string dual_out = <span class="stringliteral">&quot;dual_&quot;</span>;
<a name="l00087"></a>00087       primal_out += <a class="code" href="classAdjointResidualErrorEstimator.php#a5be027e048cb14caec9462aa8be81317">error_plot_suffix</a>;
<a name="l00088"></a>00088       dual_out += <a class="code" href="classAdjointResidualErrorEstimator.php#a5be027e048cb14caec9462aa8be81317">error_plot_suffix</a>;
<a name="l00089"></a>00089       error_per_cell.<a class="code" href="classErrorVector.php#a0ec5505f9b491872c007609e864b6821">plot_error</a>(primal_out, _system.<a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">get_mesh</a>());
<a name="l00090"></a>00090       dual_error_per_cell.<a class="code" href="classErrorVector.php#a0ec5505f9b491872c007609e864b6821">plot_error</a>(dual_out, _system.<a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">get_mesh</a>());
<a name="l00091"></a>00091     }
<a name="l00092"></a>00092 
<a name="l00093"></a>00093   <span class="comment">// More bookkeeping for subestimators to do</span>
<a name="l00094"></a>00094   <span class="comment">//</span>
<a name="l00095"></a>00095   <span class="comment">// // Swap the system solution and dual solution back to their proper</span>
<a name="l00096"></a>00096   <span class="comment">// // places</span>
<a name="l00097"></a>00097   <span class="comment">// system.solution-&gt;swap(system.get_adjoint_solution());</span>
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   <span class="comment">// // Don&#39;t forget to fix the current_local_solution</span>
<a name="l00100"></a>00100   <span class="comment">// system.update();</span>
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   <span class="comment">// Weight the primal error by the dual error</span>
<a name="l00103"></a>00103   <span class="comment">// FIXME: we ought to thread this</span>
<a name="l00104"></a>00104   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != error_per_cell.size(); ++i)
<a name="l00105"></a>00105     error_per_cell[i] *= dual_error_per_cell[i];
<a name="l00106"></a>00106 
<a name="l00107"></a>00107   STOP_LOG(<span class="stringliteral">&quot;estimate_error()&quot;</span>, <span class="stringliteral">&quot;AdjointResidualErrorEstimator&quot;</span>);
<a name="l00108"></a>00108 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
