<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c8cf73965feff5280e8b0581da1a9d14.php">error_estimation</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>adjoint_residual_error_estimator.h</h1>  </div>
</div>
<div class="contents">
<a href="adjoint__residual__error__estimator_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: adjoint_residual_error_estimator.h 3434 2009-07-17 21:55:15Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __adjoint_residual_error_estimator_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __adjoint_residual_error_estimator_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;auto_ptr.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="error__estimator_8h.php">error_estimator.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Forward Declarations</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00051"></a><a class="code" href="classAdjointResidualErrorEstimator.php">00051</a> <span class="keyword">class </span><a class="code" href="classAdjointResidualErrorEstimator.php">AdjointResidualErrorEstimator</a> : <span class="keyword">public</span> <a class="code" href="classErrorEstimator.php">ErrorEstimator</a>
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053 <span class="keyword">public</span>:
<a name="l00054"></a>00054 
<a name="l00058"></a>00058   <a class="code" href="classAdjointResidualErrorEstimator.php#ab6705e0378988309ce3e52188a08f7dd">AdjointResidualErrorEstimator</a>();
<a name="l00059"></a>00059   
<a name="l00063"></a><a class="code" href="classAdjointResidualErrorEstimator.php#adf727fd823c30efd1e9d88f548f533cd">00063</a>   <a class="code" href="classAdjointResidualErrorEstimator.php#adf727fd823c30efd1e9d88f548f533cd">~AdjointResidualErrorEstimator</a>() {}
<a name="l00064"></a>00064 
<a name="l00068"></a><a class="code" href="classAdjointResidualErrorEstimator.php#abc89932b9422b76aa5f9c50cf44bc808">00068</a>   <a class="code" href="classAutoPtr.php">AutoPtr&lt;ErrorEstimator&gt;</a> &amp;<a class="code" href="classAdjointResidualErrorEstimator.php#abc89932b9422b76aa5f9c50cf44bc808">primal_error_estimator</a>() { <span class="keywordflow">return</span> <a class="code" href="classAdjointResidualErrorEstimator.php#a7d708cad8b719b9273db16a3563aa2df">_primal_error_estimator</a>; }
<a name="l00069"></a>00069   
<a name="l00073"></a><a class="code" href="classAdjointResidualErrorEstimator.php#a9a14deaa5cc421dcf169bdf239253c21">00073</a>   <a class="code" href="classAutoPtr.php">AutoPtr&lt;ErrorEstimator&gt;</a> &amp;<a class="code" href="classAdjointResidualErrorEstimator.php#a9a14deaa5cc421dcf169bdf239253c21">dual_error_estimator</a>() { <span class="keywordflow">return</span> <a class="code" href="classAdjointResidualErrorEstimator.php#a0697abf7ce0191d9fd81f4e6593c1e28">_dual_error_estimator</a>; }
<a name="l00074"></a>00074   
<a name="l00080"></a><a class="code" href="classAdjointResidualErrorEstimator.php#a4fc519b144f470ec5a3085f901a01e2e">00080</a>   <span class="keywordtype">bool</span> <a class="code" href="classAdjointResidualErrorEstimator.php#a4fc519b144f470ec5a3085f901a01e2e">adjoint_already_solved</a>;
<a name="l00081"></a>00081 
<a name="l00089"></a><a class="code" href="classAdjointResidualErrorEstimator.php#a5be027e048cb14caec9462aa8be81317">00089</a>   std::string <a class="code" href="classAdjointResidualErrorEstimator.php#a5be027e048cb14caec9462aa8be81317">error_plot_suffix</a>;
<a name="l00090"></a>00090 
<a name="l00099"></a>00099   <span class="keywordtype">void</span> <a class="code" href="classAdjointResidualErrorEstimator.php#aab306d35853814bbafa495920d8fc2f3">estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; system,
<a name="l00100"></a>00100                        <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00101"></a>00101                        <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector = NULL,
<a name="l00102"></a>00102                        <span class="keywordtype">bool</span> estimate_parent_error = <span class="keyword">false</span>);
<a name="l00103"></a>00103   
<a name="l00104"></a>00104 <span class="keyword">protected</span>:
<a name="l00105"></a>00105 
<a name="l00109"></a><a class="code" href="classAdjointResidualErrorEstimator.php#a7d708cad8b719b9273db16a3563aa2df">00109</a>   <a class="code" href="classAutoPtr.php">AutoPtr&lt;ErrorEstimator&gt;</a> <a class="code" href="classAdjointResidualErrorEstimator.php#a7d708cad8b719b9273db16a3563aa2df">_primal_error_estimator</a>;
<a name="l00110"></a>00110 
<a name="l00114"></a><a class="code" href="classAdjointResidualErrorEstimator.php#a0697abf7ce0191d9fd81f4e6593c1e28">00114</a>   <a class="code" href="classAutoPtr.php">AutoPtr&lt;ErrorEstimator&gt;</a> <a class="code" href="classAdjointResidualErrorEstimator.php#a0697abf7ce0191d9fd81f4e6593c1e28">_dual_error_estimator</a>;
<a name="l00115"></a>00115 };
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 <span class="preprocessor">#endif //__adjoint_residual_error_estimator_h__</span>
<a name="l00119"></a>00119 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
