<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_f10759d5ac6297fe611079c3c15b8f2c.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>analytic_function.C</h1>  </div>
</div>
<div class="contents">
<a href="analytic__function_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: analytic_function.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local Includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;analytic_function.h&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00031"></a>00031 <span class="comment">// AnalyticFunction methods</span>
<a name="l00032"></a><a class="code" href="classAnalyticFunction.php#a0f52e71e381366af4998d8172f095144">00032</a> <a class="code" href="classAnalyticFunction.php#a0f52e71e381366af4998d8172f095144">AnalyticFunction::AnalyticFunction</a> (<a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> fptr(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00033"></a>00033                                                 <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> time)) :
<a name="l00034"></a>00034   <a class="code" href="classFunctionBase.php">FunctionBase</a> (),
<a name="l00035"></a>00035   _number_fptr (fptr)
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037   libmesh_assert (fptr != NULL);
<a name="l00038"></a>00038   this-&gt;<a class="code" href="classFunctionBase.php#ab72922e367786eca3b3497ea6710722c">_initialized</a> = <span class="keyword">true</span>;
<a name="l00039"></a>00039 }
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a><a class="code" href="classAnalyticFunction.php#ad4f2aa98c4da47ae2a9f05df51b98410">00044</a> <a class="code" href="classAnalyticFunction.php#a0f52e71e381366af4998d8172f095144">AnalyticFunction::AnalyticFunction</a> (<span class="keywordtype">void</span> fptr(<a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a>&amp; output,
<a name="l00045"></a>00045                                               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00046"></a>00046                                               <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> time)) :
<a name="l00047"></a>00047   <a class="code" href="classFunctionBase.php">FunctionBase</a> (),
<a name="l00048"></a>00048   _vector_fptr (fptr)
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050   libmesh_assert (fptr != NULL);
<a name="l00051"></a>00051   this-&gt;<a class="code" href="classFunctionBase.php#ab72922e367786eca3b3497ea6710722c">_initialized</a> = <span class="keyword">true</span>;
<a name="l00052"></a>00052 }
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00057"></a><a class="code" href="classAnalyticFunction.php#a8a46f7e42d0a6a947013956ea31e562d">00057</a> <a class="code" href="classAnalyticFunction.php#a8a46f7e42d0a6a947013956ea31e562d">AnalyticFunction::~AnalyticFunction</a> ()
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059 }
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a><a class="code" href="classAnalyticFunction.php#a486f37ecd5918a4dac471bb8345adb2c">00065</a> <span class="keywordtype">void</span> <a class="code" href="classAnalyticFunction.php#a486f37ecd5918a4dac471bb8345adb2c">AnalyticFunction::init</a> ()
<a name="l00066"></a>00066 {
<a name="l00067"></a>00067   <span class="comment">// dumb double-test</span>
<a name="l00068"></a>00068   libmesh_assert ((<a class="code" href="classAnalyticFunction.php#a51f41473bfa5f064a1d8faea7ec721d2">_number_fptr</a> != NULL) || (<a class="code" href="classAnalyticFunction.php#ac488e8185ffdcb9030f0de0b1e5665a6">_vector_fptr</a> != NULL));
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="comment">// definitely ready</span>
<a name="l00071"></a>00071   this-&gt;<a class="code" href="classFunctionBase.php#ab72922e367786eca3b3497ea6710722c">_initialized</a> = <span class="keyword">true</span>;
<a name="l00072"></a>00072 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
