<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>analytic_function.h</h1>  </div>
</div>
<div class="contents">
<a href="analytic__function_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: analytic_function.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __analytic_function_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __analytic_function_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="function__base_8h.php">function_base.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Forward Declarations</span>
<a name="l00034"></a>00034 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00035"></a>00035 <span class="keyword">class </span><a class="code" href="classDenseVector.php">DenseVector</a>;
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00046"></a>00046 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00047"></a>00047 <span class="comment">// AnalyticFunction class definition</span>
<a name="l00048"></a><a class="code" href="classAnalyticFunction.php">00048</a> <span class="keyword">class </span><a class="code" href="classAnalyticFunction.php">AnalyticFunction</a> : <span class="keyword">public</span> <a class="code" href="classFunctionBase.php">FunctionBase</a>
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050 <span class="keyword">public</span>:
<a name="l00051"></a>00051 
<a name="l00056"></a>00056   <a class="code" href="classAnalyticFunction.php#a0f52e71e381366af4998d8172f095144">AnalyticFunction</a> (<a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> fptr(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00057"></a>00057                                 <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> time));
<a name="l00058"></a>00058 
<a name="l00063"></a>00063   <a class="code" href="classAnalyticFunction.php#a0f52e71e381366af4998d8172f095144">AnalyticFunction</a> (<span class="keywordtype">void</span> fptr(<a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a>&amp; output,
<a name="l00064"></a>00064                               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00065"></a>00065                               <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> time));
<a name="l00069"></a>00069   <a class="code" href="classAnalyticFunction.php#a8a46f7e42d0a6a947013956ea31e562d">~AnalyticFunction</a> ();
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 
<a name="l00077"></a><a class="code" href="classAnalyticFunction.php#a51f41473bfa5f064a1d8faea7ec721d2">00077</a>   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> (* <a class="code" href="classAnalyticFunction.php#a51f41473bfa5f064a1d8faea7ec721d2">_number_fptr</a>) (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00078"></a>00078                            <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> time);
<a name="l00079"></a>00079 
<a name="l00083"></a><a class="code" href="classAnalyticFunction.php#ac488e8185ffdcb9030f0de0b1e5665a6">00083</a>   void (* <a class="code" href="classAnalyticFunction.php#ac488e8185ffdcb9030f0de0b1e5665a6">_vector_fptr</a>) (<a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a>&amp; output,
<a name="l00084"></a>00084                          <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00085"></a>00085                          <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> time);
<a name="l00086"></a>00086 
<a name="l00090"></a>00090   <span class="keywordtype">void</span> <a class="code" href="classAnalyticFunction.php#a486f37ecd5918a4dac471bb8345adb2c">init</a> ();
<a name="l00091"></a>00091 
<a name="l00096"></a>00096   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classAnalyticFunction.php#a2f5925539cb50c1b6881854ced37b0c4">operator() </a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p, 
<a name="l00097"></a>00097                      <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> time=0.);
<a name="l00098"></a>00098 
<a name="l00103"></a>00103   <span class="keywordtype">void</span> <a class="code" href="classAnalyticFunction.php#a2f5925539cb50c1b6881854ced37b0c4">operator() </a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00104"></a>00104                    <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> time,
<a name="l00105"></a>00105                    <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a>&amp; output);
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 };
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00112"></a>00112 <span class="comment">// AnalyticFunction inline methods</span>
<a name="l00113"></a>00113 <span class="keyword">inline</span>
<a name="l00114"></a><a class="code" href="classAnalyticFunction.php#a2f5925539cb50c1b6881854ced37b0c4">00114</a> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classAnalyticFunction.php#a2f5925539cb50c1b6881854ced37b0c4">AnalyticFunction::operator() </a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p, 
<a name="l00115"></a>00115                                      <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> time)
<a name="l00116"></a>00116 {
<a name="l00117"></a>00117   libmesh_assert (this-&gt;<a class="code" href="classFunctionBase.php#a19afe60a9016248664396f20200a43cb">initialized</a>());
<a name="l00118"></a>00118   <span class="keywordflow">return</span> (this-&gt;<a class="code" href="classAnalyticFunction.php#a51f41473bfa5f064a1d8faea7ec721d2">_number_fptr</a>(p, time));
<a name="l00119"></a>00119 }
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 <span class="keyword">inline</span>
<a name="l00124"></a><a class="code" href="classAnalyticFunction.php#a0b55f3123d02d17e6f3f54b4135720c1">00124</a> <span class="keywordtype">void</span> <a class="code" href="classAnalyticFunction.php#a2f5925539cb50c1b6881854ced37b0c4">AnalyticFunction::operator() </a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00125"></a>00125                                    <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> time,
<a name="l00126"></a>00126                                    <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a>&amp; output)
<a name="l00127"></a>00127 {
<a name="l00128"></a>00128   libmesh_assert (this-&gt;<a class="code" href="classFunctionBase.php#a19afe60a9016248664396f20200a43cb">initialized</a>());
<a name="l00129"></a>00129   this-&gt;<a class="code" href="classAnalyticFunction.php#ac488e8185ffdcb9030f0de0b1e5665a6">_vector_fptr</a>(output, p, time);
<a name="l00130"></a>00130   <span class="keywordflow">return</span>;
<a name="l00131"></a>00131 }
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 <span class="preprocessor">#endif</span>
<a name="l00136"></a>00136 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
