<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_a444518d96d2df902338d2a7eb3a040c.php">base</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>auto_ptr.h</h1>  </div>
</div>
<div class="contents">
<a href="auto__ptr_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: auto_ptr.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// Copyright (C) 2001, 2002 Free Software Foundation, Inc.</span>
<a name="l00004"></a>00004 <span class="comment">//</span>
<a name="l00005"></a>00005 <span class="comment">// This file is part of the GNU ISO C++ Library.  This library is free</span>
<a name="l00006"></a>00006 <span class="comment">// software; you can redistribute it and/or modify it under the</span>
<a name="l00007"></a>00007 <span class="comment">// terms of the GNU General Public License as published by the</span>
<a name="l00008"></a>00008 <span class="comment">// Free Software Foundation; either version 2, or (at your option)</span>
<a name="l00009"></a>00009 <span class="comment">// any later version.</span>
<a name="l00010"></a>00010 
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00014"></a>00014 <span class="comment">// GNU General Public License for more details.</span>
<a name="l00015"></a>00015 
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU General Public License along</span>
<a name="l00017"></a>00017 <span class="comment">// with this library; see the file COPYING.  If not, write to the Free</span>
<a name="l00018"></a>00018 <span class="comment">// Software Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307,</span>
<a name="l00019"></a>00019 <span class="comment">// USA.</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// As a special exception, you may use this file as part of a free software</span>
<a name="l00022"></a>00022 <span class="comment">// library without restriction.  Specifically, if other files instantiate</span>
<a name="l00023"></a>00023 <span class="comment">// templates or use macros or inline functions from this file, or you compile</span>
<a name="l00024"></a>00024 <span class="comment">// this file and link it with other files to produce an executable, this</span>
<a name="l00025"></a>00025 <span class="comment">// file does not by itself cause the resulting executable to be covered by</span>
<a name="l00026"></a>00026 <span class="comment">// the GNU General Public License.  This exception does not however</span>
<a name="l00027"></a>00027 <span class="comment">// invalidate any other reasons why the executable file might be covered by</span>
<a name="l00028"></a>00028 <span class="comment">// the GNU General Public License.</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">/*</span>
<a name="l00031"></a>00031 <span class="comment"> * Copyright (c) 1997-1999</span>
<a name="l00032"></a>00032 <span class="comment"> * Silicon Graphics Computer Systems, Inc.</span>
<a name="l00033"></a>00033 <span class="comment"> *</span>
<a name="l00034"></a>00034 <span class="comment"> * Permission to use, copy, modify, distribute and sell this software</span>
<a name="l00035"></a>00035 <span class="comment"> * and its documentation for any purpose is hereby granted without fee,</span>
<a name="l00036"></a>00036 <span class="comment"> * provided that the above copyright notice appear in all copies and</span>
<a name="l00037"></a>00037 <span class="comment"> * that both that copyright notice and this permission notice appear</span>
<a name="l00038"></a>00038 <span class="comment"> * in supporting documentation.  Silicon Graphics makes no</span>
<a name="l00039"></a>00039 <span class="comment"> * representations about the suitability of this software for any</span>
<a name="l00040"></a>00040 <span class="comment"> * purpose.  It is provided &quot;as is&quot; without express or implied warranty.</span>
<a name="l00041"></a>00041 <span class="comment"> *</span>
<a name="l00042"></a>00042 <span class="comment"> */</span>
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="preprocessor">#ifndef __auto_ptr_h__</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span><span class="preprocessor">#define __auto_ptr_h__</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span>
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00058"></a>00058 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Tp1&gt;
<a name="l00059"></a><a class="code" href="structAutoPtrRef.php">00059</a> <span class="keyword">struct </span><a class="code" href="structAutoPtrRef.php">AutoPtrRef</a>
<a name="l00060"></a>00060 {
<a name="l00064"></a><a class="code" href="structAutoPtrRef.php#af862d923b8e88e77cca4606b5e0d6e4d">00064</a>   Tp1* <a class="code" href="structAutoPtrRef.php#af862d923b8e88e77cca4606b5e0d6e4d">_ptr</a>;
<a name="l00065"></a>00065 
<a name="l00069"></a>00069   <span class="keyword">explicit</span>
<a name="l00070"></a><a class="code" href="structAutoPtrRef.php#ab272880801ee18f8d015bbe61be15562">00070</a>   <a class="code" href="structAutoPtrRef.php#ab272880801ee18f8d015bbe61be15562">AutoPtrRef</a>(Tp1* p)
<a name="l00071"></a>00071     : <a class="code" href="structAutoPtrRef.php#af862d923b8e88e77cca4606b5e0d6e4d">_ptr</a>(p) {}
<a name="l00072"></a>00072 };
<a name="l00073"></a>00073   
<a name="l00074"></a>00074   
<a name="l00102"></a>00102 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Tp&gt;
<a name="l00103"></a><a class="code" href="classAutoPtr.php">00103</a> <span class="keyword">class </span><a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr</a>
<a name="l00104"></a>00104 {
<a name="l00105"></a>00105 <span class="keyword">private</span>:
<a name="l00106"></a>00106 
<a name="l00110"></a><a class="code" href="classAutoPtr.php#a9a7196c2f56ef43249426cc314cc4d05">00110</a>   Tp* <a class="code" href="classAutoPtr.php#a9a7196c2f56ef43249426cc314cc4d05">_ptr</a>;
<a name="l00111"></a>00111     
<a name="l00112"></a>00112 <span class="keyword">public</span>:
<a name="l00116"></a><a class="code" href="classAutoPtr.php#ad382178b84a33a5534bcdc9024b9d0ca">00116</a>   <span class="keyword">typedef</span> Tp <a class="code" href="classAutoPtr.php#ad382178b84a33a5534bcdc9024b9d0ca">element_type</a>;
<a name="l00117"></a>00117     
<a name="l00124"></a>00124   <span class="keyword">explicit</span>
<a name="l00125"></a><a class="code" href="classAutoPtr.php#a6d0b14cd31845e26fca57cfdfdf35552">00125</a>   <a class="code" href="classAutoPtr.php#a6d0b14cd31845e26fca57cfdfdf35552" title="An AutoPtr is usually constructed from a raw pointer.">AutoPtr</a>(<a class="code" href="classLinearSolver.php">element_type</a>* p = 0) 
<a name="l00126"></a>00126     : <a class="code" href="classAutoPtr.php#a9a7196c2f56ef43249426cc314cc4d05">_ptr</a>(p) {}
<a name="l00127"></a>00127 
<a name="l00135"></a><a class="code" href="classAutoPtr.php#a337e3009ef93b9388f340d832572f969">00135</a>   <a class="code" href="classAutoPtr.php#a6d0b14cd31845e26fca57cfdfdf35552" title="An AutoPtr is usually constructed from a raw pointer.">AutoPtr</a>(<a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr</a>&amp; a) 
<a name="l00136"></a>00136     : <a class="code" href="classAutoPtr.php#a9a7196c2f56ef43249426cc314cc4d05">_ptr</a>(a.<a class="code" href="classAutoPtr.php#af9d9cdff0aa3e2df96b18b197be2c9ac" title="Bypassing the smart pointer.">release</a>()) {}
<a name="l00137"></a>00137 
<a name="l00147"></a>00147   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Tp1&gt;
<a name="l00148"></a><a class="code" href="classAutoPtr.php#a1fa7a9a9bbcd658f83b02d6eec25adc4">00148</a>   <a class="code" href="classAutoPtr.php#a6d0b14cd31845e26fca57cfdfdf35552" title="An AutoPtr is usually constructed from a raw pointer.">AutoPtr</a>(<a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Tp1&gt;</a>&amp; a) 
<a name="l00149"></a>00149     : <a class="code" href="classAutoPtr.php#a9a7196c2f56ef43249426cc314cc4d05">_ptr</a>(a.<a class="code" href="classAutoPtr.php#af9d9cdff0aa3e2df96b18b197be2c9ac" title="Bypassing the smart pointer.">release</a>()) {}
<a name="l00150"></a>00150 
<a name="l00159"></a>00159   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr</a>&amp;
<a name="l00160"></a><a class="code" href="classAutoPtr.php#adc175dd251b60787e9af8567785fdd31">00160</a>   <a class="code" href="classAutoPtr.php#adc175dd251b60787e9af8567785fdd31" title="AutoPtr assignment operator.">operator=</a>(<a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr</a>&amp; a) 
<a name="l00161"></a>00161   {
<a name="l00162"></a>00162     <a class="code" href="classAutoPtr.php#afba95dd5fca7f83ababa4eaf6a57c511" title="Forcibly deletes the managed object.">reset</a>(a.<a class="code" href="classAutoPtr.php#af9d9cdff0aa3e2df96b18b197be2c9ac" title="Bypassing the smart pointer.">release</a>());
<a name="l00163"></a>00163     <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00164"></a>00164   }
<a name="l00165"></a>00165     
<a name="l00176"></a>00176   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Tp1&gt;
<a name="l00177"></a>00177   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr</a>&amp;
<a name="l00178"></a><a class="code" href="classAutoPtr.php#a1036fdc4bac8432908d539f3ec662113">00178</a>   <a class="code" href="classAutoPtr.php#adc175dd251b60787e9af8567785fdd31" title="AutoPtr assignment operator.">operator=</a>(<a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Tp1&gt;</a>&amp; a) 
<a name="l00179"></a>00179   {
<a name="l00180"></a>00180     <a class="code" href="classAutoPtr.php#afba95dd5fca7f83ababa4eaf6a57c511" title="Forcibly deletes the managed object.">reset</a>(a.<a class="code" href="classAutoPtr.php#af9d9cdff0aa3e2df96b18b197be2c9ac" title="Bypassing the smart pointer.">release</a>());
<a name="l00181"></a>00181     <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00182"></a>00182   }
<a name="l00183"></a>00183 
<a name="l00196"></a><a class="code" href="classAutoPtr.php#ae6f7f30932b47a8e23848b5232f8e00a">00196</a>   <a class="code" href="classAutoPtr.php#ae6f7f30932b47a8e23848b5232f8e00a">~AutoPtr</a>() { <span class="keyword">delete</span> <a class="code" href="classAutoPtr.php#a9a7196c2f56ef43249426cc314cc4d05">_ptr</a>; }
<a name="l00197"></a>00197     
<a name="l00206"></a>00206   <a class="code" href="classAutoPtr.php#ad382178b84a33a5534bcdc9024b9d0ca">element_type</a>&amp;
<a name="l00207"></a><a class="code" href="classAutoPtr.php#a364b3bfe740aa44fe3531c0c6a867b99">00207</a>   <a class="code" href="classAutoPtr.php#a364b3bfe740aa44fe3531c0c6a867b99" title="Smart pointer dereferencing.">operator*</a>()<span class="keyword"> const  </span>{ <span class="keywordflow">return</span> *<a class="code" href="classAutoPtr.php#a9a7196c2f56ef43249426cc314cc4d05">_ptr</a>; }
<a name="l00208"></a>00208     
<a name="l00215"></a>00215   <a class="code" href="classAutoPtr.php#ad382178b84a33a5534bcdc9024b9d0ca">element_type</a>*
<a name="l00216"></a><a class="code" href="classAutoPtr.php#a1ee7439768a8d163137149d8736c2ec0">00216</a>   <a class="code" href="classAutoPtr.php#a1ee7439768a8d163137149d8736c2ec0" title="Smart pointer dereferencing.">operator-&gt;</a>()<span class="keyword"> const  </span>{ <span class="keywordflow">return</span> <a class="code" href="classAutoPtr.php#a9a7196c2f56ef43249426cc314cc4d05">_ptr</a>; }
<a name="l00217"></a>00217     
<a name="l00228"></a>00228   <a class="code" href="classAutoPtr.php#ad382178b84a33a5534bcdc9024b9d0ca">element_type</a>*
<a name="l00229"></a><a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce">00229</a>   <span class="keyword">get</span>() <span class="keyword">const</span>  { <span class="keywordflow">return</span> <a class="code" href="classAutoPtr.php#a9a7196c2f56ef43249426cc314cc4d05">_ptr</a>; }
<a name="l00230"></a>00230     
<a name="l00242"></a>00242   <a class="code" href="classAutoPtr.php#ad382178b84a33a5534bcdc9024b9d0ca">element_type</a>*
<a name="l00243"></a><a class="code" href="classAutoPtr.php#af9d9cdff0aa3e2df96b18b197be2c9ac">00243</a>   <a class="code" href="classAutoPtr.php#af9d9cdff0aa3e2df96b18b197be2c9ac" title="Bypassing the smart pointer.">release</a>() 
<a name="l00244"></a>00244   {
<a name="l00245"></a>00245     <a class="code" href="classLinearSolver.php">element_type</a>* tmp = <a class="code" href="classAutoPtr.php#a9a7196c2f56ef43249426cc314cc4d05">_ptr</a>;
<a name="l00246"></a>00246     <a class="code" href="classAutoPtr.php#a9a7196c2f56ef43249426cc314cc4d05">_ptr</a> = 0;
<a name="l00247"></a>00247     <span class="keywordflow">return</span> tmp;
<a name="l00248"></a>00248   }
<a name="l00249"></a>00249     
<a name="l00257"></a>00257   <span class="keywordtype">void</span>
<a name="l00258"></a><a class="code" href="classAutoPtr.php#afba95dd5fca7f83ababa4eaf6a57c511">00258</a>   <a class="code" href="classAutoPtr.php#afba95dd5fca7f83ababa4eaf6a57c511" title="Forcibly deletes the managed object.">reset</a>(<a class="code" href="classLinearSolver.php">element_type</a>* p = 0) 
<a name="l00259"></a>00259   {
<a name="l00260"></a>00260     <span class="keywordflow">if</span> (p != <a class="code" href="classAutoPtr.php#a9a7196c2f56ef43249426cc314cc4d05">_ptr</a>)
<a name="l00261"></a>00261       {
<a name="l00262"></a>00262         <span class="keyword">delete</span> <a class="code" href="classAutoPtr.php#a9a7196c2f56ef43249426cc314cc4d05">_ptr</a>;
<a name="l00263"></a>00263         <a class="code" href="classAutoPtr.php#a9a7196c2f56ef43249426cc314cc4d05">_ptr</a> = p;
<a name="l00264"></a>00264       }
<a name="l00265"></a>00265   }
<a name="l00266"></a>00266     
<a name="l00278"></a><a class="code" href="classAutoPtr.php#ac272f5320cf2328017edde6a57123a5c">00278</a>   <a class="code" href="classAutoPtr.php#a6d0b14cd31845e26fca57cfdfdf35552" title="An AutoPtr is usually constructed from a raw pointer.">AutoPtr</a>(<a class="code" href="structAutoPtrRef.php">AutoPtrRef&lt;element_type&gt;</a> ref) 
<a name="l00279"></a>00279     : <a class="code" href="classAutoPtr.php#a9a7196c2f56ef43249426cc314cc4d05">_ptr</a>(ref.<a class="code" href="classAutoPtr.php#a9a7196c2f56ef43249426cc314cc4d05">_ptr</a>) {}
<a name="l00280"></a>00280 
<a name="l00287"></a>00287   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr</a>&amp;
<a name="l00288"></a><a class="code" href="classAutoPtr.php#a9a3cb55d742a5a34fdf33a7a21a45f95">00288</a>   <a class="code" href="classAutoPtr.php#adc175dd251b60787e9af8567785fdd31" title="AutoPtr assignment operator.">operator=</a>(<a class="code" href="structAutoPtrRef.php">AutoPtrRef&lt;element_type&gt;</a> ref) 
<a name="l00289"></a>00289   {
<a name="l00290"></a>00290     <span class="keywordflow">if</span> (ref.<a class="code" href="structAutoPtrRef.php#af862d923b8e88e77cca4606b5e0d6e4d">_ptr</a> != this-&gt;get())
<a name="l00291"></a>00291       {
<a name="l00292"></a>00292         <span class="keyword">delete</span> <a class="code" href="classAutoPtr.php#a9a7196c2f56ef43249426cc314cc4d05">_ptr</a>;
<a name="l00293"></a>00293         <a class="code" href="classAutoPtr.php#a9a7196c2f56ef43249426cc314cc4d05">_ptr</a> = ref.<a class="code" href="structAutoPtrRef.php#af862d923b8e88e77cca4606b5e0d6e4d">_ptr</a>;
<a name="l00294"></a>00294       }
<a name="l00295"></a>00295     <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00296"></a>00296   }
<a name="l00297"></a>00297 
<a name="l00301"></a>00301   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Tp1&gt;
<a name="l00302"></a><a class="code" href="classAutoPtr.php#a5916b4ba6c4cf75f21c19bf37b4836dc">00302</a>   <a class="code" href="classAutoPtr.php#a5916b4ba6c4cf75f21c19bf37b4836dc">operator AutoPtrRef&lt;Tp1&gt;</a>() 
<a name="l00303"></a>00303   { <span class="keywordflow">return</span> <a class="code" href="structAutoPtrRef.php">AutoPtrRef&lt;Tp1&gt;</a>(this-&gt;<a class="code" href="classAutoPtr.php#af9d9cdff0aa3e2df96b18b197be2c9ac" title="Bypassing the smart pointer.">release</a>()); }
<a name="l00304"></a>00304     
<a name="l00308"></a>00308   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Tp1&gt;
<a name="l00309"></a><a class="code" href="classAutoPtr.php#a0ed99ebb37f62464934803248e77e5cd">00309</a>   <a class="code" href="classAutoPtr.php#a0ed99ebb37f62464934803248e77e5cd">operator AutoPtr&lt;Tp1&gt;</a>() 
<a name="l00310"></a>00310   { <span class="keywordflow">return</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Tp1&gt;</a>(this-&gt;<a class="code" href="classAutoPtr.php#af9d9cdff0aa3e2df96b18b197be2c9ac" title="Bypassing the smart pointer.">release</a>()); }
<a name="l00311"></a>00311 };
<a name="l00312"></a>00312 
<a name="l00313"></a>00313 
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 
<a name="l00316"></a>00316 <span class="preprocessor">#endif </span><span class="comment">/* __auto_ptr_h__ */</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
