<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>boundary_info.C</h1>  </div>
</div>
<div class="contents">
<a href="boundary__info_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: boundary_info.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;boundary_info.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;boundary_mesh.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;mesh_data.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;parallel.h&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">//------------------------------------------------------</span>
<a name="l00036"></a>00036 <span class="comment">// BoundaryInfo static member initializations</span>
<a name="l00037"></a>00037 <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classBoundaryInfo.php#a2a9670c3471907601fb62ae9dcce2eb4">BoundaryInfo::invalid_id</a> = -1234;
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">//------------------------------------------------------</span>
<a name="l00042"></a>00042 <span class="comment">// BoundaryInfo functions</span>
<a name="l00043"></a><a class="code" href="classBoundaryInfo.php#a3f1039c4f988f5bd446b82872e07ad47">00043</a> <a class="code" href="classBoundaryInfo.php#a3f1039c4f988f5bd446b82872e07ad47">BoundaryInfo::BoundaryInfo</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; m) :
<a name="l00044"></a>00044   _mesh (m)
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046 }
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00050"></a><a class="code" href="classBoundaryInfo.php#aeef02a29ae74cfa9384cd1db9fbfe372">00050</a> <a class="code" href="classBoundaryInfo.php#aeef02a29ae74cfa9384cd1db9fbfe372">BoundaryInfo::~BoundaryInfo</a>()
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052   this-&gt;<a class="code" href="classBoundaryInfo.php#a0565fdb81d365b6bf7dd1c99aad1da86">clear</a>();
<a name="l00053"></a>00053 }
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00057"></a><a class="code" href="classBoundaryInfo.php#a0565fdb81d365b6bf7dd1c99aad1da86">00057</a> <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#a0565fdb81d365b6bf7dd1c99aad1da86">BoundaryInfo::clear</a>()
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059   <a class="code" href="classBoundaryInfo.php#ab084520a55072f62c9acc7ca6afe420b">_boundary_node_id</a>.clear();
<a name="l00060"></a>00060   <a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.clear();
<a name="l00061"></a>00061   <a class="code" href="classBoundaryInfo.php#a2159b8b97781503d5a9e4331506edd4a">_boundary_ids</a>.clear();
<a name="l00062"></a>00062 }
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 
<a name="l00066"></a><a class="code" href="classBoundaryInfo.php#af5727161cb9ac9c2aa037e72debe9280">00066</a> <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#af5727161cb9ac9c2aa037e72debe9280">BoundaryInfo::sync</a> (<a class="code" href="classBoundaryMesh.php">BoundaryMesh</a>&amp; boundary_mesh,
<a name="l00067"></a>00067                          <a class="code" href="classMeshData.php">MeshData</a>*     boundary_mesh_data,
<a name="l00068"></a>00068                          <a class="code" href="classMeshData.php">MeshData</a>*     this_mesh_data)
<a name="l00069"></a>00069 {
<a name="l00070"></a>00070   boundary_mesh.<a class="code" href="classParallelMesh.php#ad0429ae4ae81a253098ff659bae00de4">clear</a>();
<a name="l00071"></a>00071 
<a name="l00076"></a>00076   <span class="comment">// Map boundary ids to side subdomain/partition ids</span>
<a name="l00077"></a>00077   std::map&lt;short int, unsigned int&gt; id_map;
<a name="l00078"></a>00078 
<a name="l00079"></a>00079   <span class="comment">// Original Code</span>
<a name="l00080"></a>00080   <span class="comment">//     unsigned int cnt = 0;</span>
<a name="l00081"></a>00081   <span class="comment">//     for (std::set&lt;short int&gt;::iterator pos = boundary_ids.begin();</span>
<a name="l00082"></a>00082   <span class="comment">//     pos != boundary_ids.end(); ++pos)</span>
<a name="l00083"></a>00083   <span class="comment">//       id_map[*pos] = cnt++;</span>
<a name="l00084"></a>00084   
<a name="l00085"></a>00085   <span class="comment">//     id_map[invalid_id] = cnt;</span>
<a name="l00086"></a>00086 
<a name="l00087"></a>00087     
<a name="l00088"></a>00088   <span class="comment">// New code</span>
<a name="l00089"></a>00089   <span class="comment">// Here we need to use iota() once it is in the</span>
<a name="l00090"></a>00090   <span class="comment">// Utility namespace.</span>
<a name="l00091"></a>00091   std::for_each(<a class="code" href="classBoundaryInfo.php#a2159b8b97781503d5a9e4331506edd4a">_boundary_ids</a>.begin(),
<a name="l00092"></a>00092                 <a class="code" href="classBoundaryInfo.php#a2159b8b97781503d5a9e4331506edd4a">_boundary_ids</a>.end(),
<a name="l00093"></a>00093                 <a class="code" href="classBoundaryInfo_1_1Fill.php">Fill</a>(id_map));
<a name="l00094"></a>00094     
<a name="l00095"></a>00095   boundary_mesh.<a class="code" href="classMeshBase.php#a5b09171a87347ea1d0134314b1f99c6e">set_n_subdomains</a>() = id_map.size();
<a name="l00096"></a>00096   boundary_mesh.<a class="code" href="classMeshBase.php#aafa827a5ddf0645ec7c5aa926f9d19e0">set_n_partitions</a>() = id_map.size();
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   <span class="comment">// Make individual copies of all the nodes in the current mesh</span>
<a name="l00100"></a>00100   <span class="comment">// and add them to the boundary mesh.  Yes, this is overkill because</span>
<a name="l00101"></a>00101   <span class="comment">// all of the current mesh nodes will not end up in the the boundary</span>
<a name="l00102"></a>00102   <span class="comment">// mesh.  These nodes can be trimmed later via a call to prepare_for_use().</span>
<a name="l00103"></a>00103   {
<a name="l00104"></a>00104     libmesh_assert (boundary_mesh.<a class="code" href="classParallelMesh.php#a0b5505cdbb6799aed76cafb62a7e0135">n_nodes</a>() == 0);
<a name="l00105"></a>00105     boundary_mesh.<a class="code" href="classParallelMesh.php#a6dd52893b2c31897caa37a6b2821a143">reserve_nodes</a>(<a class="code" href="classBoundaryInfo.php#a6f76c9f3d88c4e3a4354d8f16c22d4b8">_mesh</a>.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l00106"></a>00106     
<a name="l00107"></a>00107     <a class="code" href="structMeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> it  = <a class="code" href="classBoundaryInfo.php#a6f76c9f3d88c4e3a4354d8f16c22d4b8">_mesh</a>.<a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
<a name="l00108"></a>00108     <a class="code" href="structMeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> end = <a class="code" href="classBoundaryInfo.php#a6f76c9f3d88c4e3a4354d8f16c22d4b8">_mesh</a>.<a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
<a name="l00109"></a>00109     
<a name="l00110"></a>00110     <span class="keywordflow">for</span>(; it != end; ++it)
<a name="l00111"></a>00111       {
<a name="l00112"></a>00112         <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node = *it;
<a name="l00113"></a>00113         boundary_mesh.<a class="code" href="classParallelMesh.php#a9a458dd93052e3707da352e1ca0ea0b6">add_point</a>(*node); <span class="comment">// calls Node::build(Point, id)</span>
<a name="l00114"></a>00114       }
<a name="l00115"></a>00115   }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117   <span class="comment">// Add additional sides that aren&#39;t flagged with boundary conditions</span>
<a name="l00118"></a>00118   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     = <a class="code" href="classBoundaryInfo.php#a6f76c9f3d88c4e3a4354d8f16c22d4b8">_mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00119"></a>00119   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = <a class="code" href="classBoundaryInfo.php#a6f76c9f3d88c4e3a4354d8f16c22d4b8">_mesh</a>.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00120"></a>00120 
<a name="l00121"></a>00121   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00122"></a>00122     {
<a name="l00123"></a>00123       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *el;
<a name="l00124"></a>00124       
<a name="l00125"></a>00125       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>(); s++)
<a name="l00126"></a>00126         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s) == NULL) <span class="comment">// on the boundary</span>
<a name="l00127"></a>00127           {
<a name="l00128"></a>00128 
<a name="l00129"></a>00129             <span class="comment">// Build the side - do not use a &quot;proxy&quot; element here:</span>
<a name="l00130"></a>00130             <span class="comment">// This will be going into the BoundaryMesh and needs to</span>
<a name="l00131"></a>00131             <span class="comment">// stand on its own.</span>
<a name="l00132"></a>00132             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> side (elem-&gt;<a class="code" href="classElem.php#a554c146bcfb5537636bd77a157f21b85">build_side</a>(s, <span class="keyword">false</span>));
<a name="l00133"></a>00133             
<a name="l00134"></a>00134             <span class="comment">// Get the top-level parent for this element</span>
<a name="l00135"></a>00135             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* top_parent = elem-&gt;<a class="code" href="classElem.php#a6bc01ad4901efb64eb4f584ed5e1bd0b">top_parent</a>();
<a name="l00136"></a>00136 
<a name="l00137"></a>00137             <span class="comment">// A convenient typedef</span>
<a name="l00138"></a>00138             <span class="keyword">typedef</span>
<a name="l00139"></a>00139               std::multimap&lt;const Elem*, std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator
<a name="l00140"></a>00140               Iter;
<a name="l00141"></a>00141               
<a name="l00142"></a>00142             <span class="comment">// Find the right id number for that side</span>
<a name="l00143"></a>00143             std::pair&lt;Iter, Iter&gt; pos = <a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.equal_range(top_parent);
<a name="l00144"></a>00144 
<a name="l00145"></a>00145             <span class="keywordflow">while</span> (pos.first != pos.second)
<a name="l00146"></a>00146               {
<a name="l00147"></a>00147                 <span class="keywordflow">if</span> (pos.first-&gt;second.first == s) <span class="comment">// already flagged with a boundary condition</span>
<a name="l00148"></a>00148                   {
<a name="l00149"></a>00149                     side-&gt;subdomain_id() =
<a name="l00150"></a>00150                       id_map[pos.first-&gt;second.second];
<a name="l00151"></a>00151                     <span class="keywordflow">break</span>;
<a name="l00152"></a>00152                   }
<a name="l00153"></a>00153                 
<a name="l00154"></a>00154                 ++pos.first;
<a name="l00155"></a>00155               }
<a name="l00156"></a>00156 
<a name="l00157"></a>00157             <span class="comment">// either the element wasn&#39;t found or side s</span>
<a name="l00158"></a>00158             <span class="comment">// doesn&#39;t have a boundary condition</span>
<a name="l00159"></a>00159             <span class="keywordflow">if</span> (pos.first == pos.second)
<a name="l00160"></a>00160               {
<a name="l00161"></a>00161                 side-&gt;subdomain_id() = id_map[<a class="code" href="classBoundaryInfo.php#a2a9670c3471907601fb62ae9dcce2eb4">invalid_id</a>];
<a name="l00162"></a>00162               }
<a name="l00163"></a>00163 
<a name="l00164"></a>00164             side-&gt;processor_id() = side-&gt;subdomain_id(); <span class="comment">//elem-&gt;processor_id();</span>
<a name="l00165"></a>00165             
<a name="l00166"></a>00166             <span class="comment">// Add the side</span>
<a name="l00167"></a>00167             <a class="code" href="classElem.php">Elem</a>* new_elem = boundary_mesh.<a class="code" href="classParallelMesh.php#a070d9e8636ce1e4fc4fe6ab0265462b0">add_elem</a>(side.release());
<a name="l00168"></a>00168 
<a name="l00169"></a>00169             <span class="comment">// This side&#39;s Node pointers still point to the nodes of the  original mesh.</span>
<a name="l00170"></a>00170             <span class="comment">// We need to re-point them to the boundary mesh&#39;s nodes!  Since we copied *ALL* of</span>
<a name="l00171"></a>00171             <span class="comment">// the original mesh&#39;s nodes over, we should be guaranteed to have the same ordering.</span>
<a name="l00172"></a>00172             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn=0; nn&lt;new_elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); ++nn)
<a name="l00173"></a>00173               {
<a name="l00174"></a>00174                 <span class="comment">// Get the correct node pointer, based on the id()</span>
<a name="l00175"></a>00175                 <a class="code" href="classNode.php">Node</a>* new_node = boundary_mesh.<a class="code" href="classParallelMesh.php#a39d1343ddfc925e1012d021d9a11e42f">node_ptr</a>(new_elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(nn));
<a name="l00176"></a>00176                 
<a name="l00177"></a>00177                 <span class="comment">// sanity check: be sure that the new Nodes global id really matches</span>
<a name="l00178"></a>00178                 libmesh_assert (new_node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() == new_elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(nn));
<a name="l00179"></a>00179 
<a name="l00180"></a>00180                 <span class="comment">// Assign the new node pointer</span>
<a name="l00181"></a>00181                 new_elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(nn) = new_node;
<a name="l00182"></a>00182               }
<a name="l00183"></a>00183           }
<a name="l00184"></a>00184     } <span class="comment">// end loop over active elements</span>
<a name="l00185"></a>00185 
<a name="l00186"></a>00186   
<a name="l00187"></a>00187   
<a name="l00188"></a>00188   <span class="comment">// When desired, copy the MeshData</span>
<a name="l00189"></a>00189   <span class="comment">// to the boundary_mesh</span>
<a name="l00190"></a>00190   <span class="keywordflow">if</span> ((boundary_mesh_data != NULL) &amp;&amp; (this_mesh_data != NULL))
<a name="l00191"></a>00191     boundary_mesh_data-&gt;<a class="code" href="classMeshData.php#aad19633f57c520c4f448045ebb8808df">assign</a>(*this_mesh_data);
<a name="l00192"></a>00192 
<a name="l00193"></a>00193   <span class="comment">// Don&#39;t repartition this mesh; we&#39;re using the processor_id values</span>
<a name="l00194"></a>00194   <span class="comment">// as a hack to display bcids for now.</span>
<a name="l00195"></a>00195   boundary_mesh.<a class="code" href="classMeshBase.php#a4e91618481bb34ffff7e85ab2ee9b78f">partitioner</a>().<a class="code" href="classAutoPtr.php#afba95dd5fca7f83ababa4eaf6a57c511" title="Forcibly deletes the managed object.">reset</a>(NULL);
<a name="l00196"></a>00196 
<a name="l00197"></a>00197   <span class="comment">// Trim any un-used nodes from the Mesh</span>
<a name="l00198"></a>00198   boundary_mesh.<a class="code" href="classMeshBase.php#a7c79bc3b9a75a580ed1ef91195eb77e5">prepare_for_use</a>();
<a name="l00199"></a>00199 }
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 
<a name="l00202"></a>00202                          
<a name="l00203"></a>00203 
<a name="l00204"></a><a class="code" href="classBoundaryInfo.php#ae61e319b5137eaf7715ca909f83030d1">00204</a> <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#af5727161cb9ac9c2aa037e72debe9280">BoundaryInfo::sync</a> (<span class="keyword">const</span> std::set&lt;short int&gt; &amp;requested_boundary_ids,
<a name="l00205"></a>00205                          <a class="code" href="classBoundaryMesh.php">BoundaryMesh</a>&amp; boundary_mesh)
<a name="l00206"></a>00206 {
<a name="l00207"></a>00207   <span class="comment">// Re-create the boundary mesh.</span>
<a name="l00208"></a>00208   boundary_mesh.<a class="code" href="classParallelMesh.php#ad0429ae4ae81a253098ff659bae00de4">clear</a>();
<a name="l00209"></a>00209     
<a name="l00210"></a>00210   boundary_mesh.<a class="code" href="classMeshBase.php#a5b09171a87347ea1d0134314b1f99c6e">set_n_subdomains</a>() = <a class="code" href="classBoundaryInfo.php#a6f76c9f3d88c4e3a4354d8f16c22d4b8">_mesh</a>.<a class="code" href="classMeshBase.php#a1f288668ce5a732f9946f08c73166d73">n_subdomains</a>();
<a name="l00211"></a>00211   boundary_mesh.<a class="code" href="classMeshBase.php#aafa827a5ddf0645ec7c5aa926f9d19e0">set_n_partitions</a>() = <a class="code" href="classBoundaryInfo.php#a6f76c9f3d88c4e3a4354d8f16c22d4b8">_mesh</a>.<a class="code" href="classMeshBase.php#ac0228a08dd00ee27d137a89fa831ab0f">n_partitions</a>();
<a name="l00212"></a>00212 
<a name="l00213"></a>00213   <span class="comment">// Make individual copies of all the nodes in the current mesh</span>
<a name="l00214"></a>00214   <span class="comment">// and add them to the boundary mesh.  Yes, this is overkill because</span>
<a name="l00215"></a>00215   <span class="comment">// all of the current mesh nodes will not end up in the the boundary</span>
<a name="l00216"></a>00216   <span class="comment">// mesh.  These nodes can be trimmed later via a call to prepare_for_use().</span>
<a name="l00217"></a>00217   {
<a name="l00218"></a>00218     libmesh_assert (boundary_mesh.<a class="code" href="classParallelMesh.php#a0b5505cdbb6799aed76cafb62a7e0135">n_nodes</a>() == 0);
<a name="l00219"></a>00219     boundary_mesh.<a class="code" href="classParallelMesh.php#a6dd52893b2c31897caa37a6b2821a143">reserve_nodes</a>(<a class="code" href="classBoundaryInfo.php#a6f76c9f3d88c4e3a4354d8f16c22d4b8">_mesh</a>.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l00220"></a>00220     
<a name="l00221"></a>00221     <a class="code" href="structMeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> it  = <a class="code" href="classBoundaryInfo.php#a6f76c9f3d88c4e3a4354d8f16c22d4b8">_mesh</a>.<a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
<a name="l00222"></a>00222     <a class="code" href="structMeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> end = <a class="code" href="classBoundaryInfo.php#a6f76c9f3d88c4e3a4354d8f16c22d4b8">_mesh</a>.<a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
<a name="l00223"></a>00223     
<a name="l00224"></a>00224     <span class="keywordflow">for</span>(; it != end; ++it)
<a name="l00225"></a>00225       {
<a name="l00226"></a>00226         <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node = *it;
<a name="l00227"></a>00227         boundary_mesh.<a class="code" href="classParallelMesh.php#a9a458dd93052e3707da352e1ca0ea0b6">add_point</a>(*node); <span class="comment">// calls Node::build(Point, id)</span>
<a name="l00228"></a>00228       }
<a name="l00229"></a>00229   }
<a name="l00230"></a>00230 
<a name="l00231"></a>00231   <span class="comment">// Add additional sides that aren&#39;t flagged with boundary conditions</span>
<a name="l00232"></a>00232   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     = <a class="code" href="classBoundaryInfo.php#a6f76c9f3d88c4e3a4354d8f16c22d4b8">_mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00233"></a>00233   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = <a class="code" href="classBoundaryInfo.php#a6f76c9f3d88c4e3a4354d8f16c22d4b8">_mesh</a>.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00234"></a>00234 
<a name="l00235"></a>00235   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00236"></a>00236     {
<a name="l00237"></a>00237       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *el;
<a name="l00238"></a>00238       
<a name="l00239"></a>00239       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>(); s++)
<a name="l00240"></a>00240         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s) == NULL) <span class="comment">// on the boundary</span>
<a name="l00241"></a>00241           {
<a name="l00242"></a>00242             <span class="comment">// Get the top-level parent for this element</span>
<a name="l00243"></a>00243             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* top_parent = elem-&gt;<a class="code" href="classElem.php#a6bc01ad4901efb64eb4f584ed5e1bd0b">top_parent</a>();
<a name="l00244"></a>00244 
<a name="l00245"></a>00245             <span class="comment">// A convenient typedef</span>
<a name="l00246"></a>00246             <span class="keyword">typedef</span>
<a name="l00247"></a>00247               std::multimap&lt;const Elem*, std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator
<a name="l00248"></a>00248               Iter;
<a name="l00249"></a>00249               
<a name="l00250"></a>00250             <span class="comment">// Find all the bcs asociated with top_parent</span>
<a name="l00251"></a>00251             std::pair&lt;Iter, Iter&gt; pos = <a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.equal_range(top_parent);
<a name="l00252"></a>00252 
<a name="l00253"></a>00253             <span class="comment">// look for a bcid which is (i) in the user-requested set, and</span>
<a name="l00254"></a>00254             <span class="comment">// (ii) matches the current side #s</span>
<a name="l00255"></a>00255             <span class="keywordflow">while</span> (pos.first != pos.second)
<a name="l00256"></a>00256               {
<a name="l00257"></a>00257                 <span class="comment">// if this side is flagged with a boundary condition</span>
<a name="l00258"></a>00258                 <span class="comment">// and the user wants this id</span>
<a name="l00259"></a>00259                 <span class="keywordflow">if</span> ((pos.first-&gt;second.first == s) &amp;&amp;
<a name="l00260"></a>00260                     (requested_boundary_ids.count(pos.first-&gt;second.second)))
<a name="l00261"></a>00261                   {
<a name="l00262"></a>00262                     <span class="comment">// Build the side - do not use a &quot;proxy&quot; element here:</span>
<a name="l00263"></a>00263                     <span class="comment">// This will be going into the BoundaryMesh and needs to</span>
<a name="l00264"></a>00264                     <span class="comment">// stand on its own.</span>
<a name="l00265"></a>00265                     <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> side (elem-&gt;<a class="code" href="classElem.php#a554c146bcfb5537636bd77a157f21b85">build_side</a>(s, <span class="keyword">false</span>));
<a name="l00266"></a>00266                     
<a name="l00267"></a>00267                     <span class="comment">// inherit processor_id and subdomain_id from parent</span>
<a name="l00268"></a>00268                     side-&gt;subdomain_id() = elem-&gt;<a class="code" href="classElem.php#acc4746605aad9169ad38cfd0b9b97123">subdomain_id</a>();
<a name="l00269"></a>00269                     side-&gt;processor_id() = elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>();
<a name="l00270"></a>00270 
<a name="l00271"></a>00271                     <span class="comment">// Add the side</span>
<a name="l00272"></a>00272                     <a class="code" href="classElem.php">Elem</a>* new_elem = boundary_mesh.<a class="code" href="classParallelMesh.php#a070d9e8636ce1e4fc4fe6ab0265462b0">add_elem</a>(side.release());
<a name="l00273"></a>00273 
<a name="l00274"></a>00274                     <span class="comment">// and set the parent</span>
<a name="l00275"></a>00275                     new_elem-&gt;<a class="code" href="classElem.php#a64542f4d4b1e359b605cdf29ce0db943">set_parent</a> (const_cast&lt;Elem*&gt;(elem));
<a name="l00276"></a>00276 
<a name="l00277"></a>00277                     <span class="comment">// This side&#39;s Node pointers still point to the nodes of the  original mesh.</span>
<a name="l00278"></a>00278                     <span class="comment">// We need to re-point them to the boundary mesh&#39;s nodes!  Since we copied *ALL* of</span>
<a name="l00279"></a>00279                     <span class="comment">// the original mesh&#39;s nodes over, we should be guaranteed to have the same ordering.</span>
<a name="l00280"></a>00280                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn=0; nn&lt;new_elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); ++nn)
<a name="l00281"></a>00281                       {
<a name="l00282"></a>00282                         <span class="comment">// Get the correct node pointer, based on the id()</span>
<a name="l00283"></a>00283                         <a class="code" href="classNode.php">Node</a>* new_node = boundary_mesh.<a class="code" href="classParallelMesh.php#a39d1343ddfc925e1012d021d9a11e42f">node_ptr</a>(new_elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(nn));
<a name="l00284"></a>00284                         
<a name="l00285"></a>00285                         <span class="comment">// sanity check: be sure that the new Nodes global id really matches</span>
<a name="l00286"></a>00286                         libmesh_assert (new_node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() == new_elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(nn));
<a name="l00287"></a>00287 
<a name="l00288"></a>00288                         <span class="comment">// Assign the new node pointer</span>
<a name="l00289"></a>00289                         new_elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(nn) = new_node;
<a name="l00290"></a>00290                       }
<a name="l00291"></a>00291 
<a name="l00292"></a>00292                     <span class="comment">// go on to the next side</span>
<a name="l00293"></a>00293                     <span class="keywordflow">break</span>;
<a name="l00294"></a>00294                   }
<a name="l00295"></a>00295                 
<a name="l00296"></a>00296                 ++pos.first;
<a name="l00297"></a>00297               } <span class="comment">// end loop over bcs matching top_parent</span>
<a name="l00298"></a>00298             
<a name="l00299"></a>00299           } <span class="comment">// end if neighbor is NULL</span>
<a name="l00300"></a>00300     } <span class="comment">// end loop over active elements</span>
<a name="l00301"></a>00301 
<a name="l00302"></a>00302   <span class="comment">// Don&#39;t repartition this mesh; but rather inherit the partitioning</span>
<a name="l00303"></a>00303   boundary_mesh.<a class="code" href="classMeshBase.php#a4e91618481bb34ffff7e85ab2ee9b78f">partitioner</a>().<a class="code" href="classAutoPtr.php#afba95dd5fca7f83ababa4eaf6a57c511" title="Forcibly deletes the managed object.">reset</a>(NULL);
<a name="l00304"></a>00304   
<a name="l00305"></a>00305   <span class="comment">// Trim any un-used nodes from the Mesh</span>
<a name="l00306"></a>00306   boundary_mesh.<a class="code" href="classMeshBase.php#a7c79bc3b9a75a580ed1ef91195eb77e5">prepare_for_use</a>();
<a name="l00307"></a>00307 
<a name="l00308"></a>00308   <span class="comment">// and finally distribute element partitioning to the nodes</span>
<a name="l00309"></a>00309   <a class="code" href="classPartitioner.php#adc818fcff7a1cdc8c2eff63c72ac7a42">Partitioner::set_node_processor_ids</a>(boundary_mesh);
<a name="l00310"></a>00310 }
<a name="l00311"></a>00311 
<a name="l00312"></a>00312 
<a name="l00313"></a>00313 
<a name="l00314"></a>00314 
<a name="l00315"></a><a class="code" href="classBoundaryInfo.php#ac308096e81e5f6321a0573e1d6f56af3">00315</a> <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#ad1b6927a343e6a084e384fcf7b8e9e8a">BoundaryInfo::add_node</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node,
<a name="l00316"></a>00316                             <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>)
<a name="l00317"></a>00317 {
<a name="l00318"></a>00318   this-&gt;<a class="code" href="classBoundaryInfo.php#ad1b6927a343e6a084e384fcf7b8e9e8a">add_node</a> (<a class="code" href="classBoundaryInfo.php#a6f76c9f3d88c4e3a4354d8f16c22d4b8">_mesh</a>.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(node), id);
<a name="l00319"></a>00319 }
<a name="l00320"></a>00320 
<a name="l00321"></a>00321 
<a name="l00322"></a>00322 
<a name="l00323"></a><a class="code" href="classBoundaryInfo.php#ad1b6927a343e6a084e384fcf7b8e9e8a">00323</a> <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#ad1b6927a343e6a084e384fcf7b8e9e8a">BoundaryInfo::add_node</a>(<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node,
<a name="l00324"></a>00324                             <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>)
<a name="l00325"></a>00325 {
<a name="l00326"></a>00326   <span class="keywordflow">if</span> (<span class="keywordtype">id</span> == <a class="code" href="classBoundaryInfo.php#a2a9670c3471907601fb62ae9dcce2eb4">invalid_id</a>)
<a name="l00327"></a>00327     {
<a name="l00328"></a>00328       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: You may not set a boundary ID of &quot;</span>
<a name="l00329"></a>00329                 &lt;&lt; <a class="code" href="classBoundaryInfo.php#a2a9670c3471907601fb62ae9dcce2eb4">invalid_id</a> &lt;&lt; std::endl
<a name="l00330"></a>00330                 &lt;&lt; <span class="stringliteral">&quot; That is reserved for internal use.\n&quot;</span>
<a name="l00331"></a>00331                 &lt;&lt; std::endl;
<a name="l00332"></a>00332 
<a name="l00333"></a>00333       libmesh_error();
<a name="l00334"></a>00334     }
<a name="l00335"></a>00335 
<a name="l00336"></a>00336   <span class="comment">// A convenient typedef</span>
<a name="l00337"></a>00337   <span class="keyword">typedef</span> std::multimap&lt;const Node*, short int&gt;::const_iterator Iter;
<a name="l00338"></a>00338               
<a name="l00339"></a>00339   <span class="comment">// Don&#39;t add the same ID twice</span>
<a name="l00340"></a>00340   std::pair&lt;Iter, Iter&gt; pos = <a class="code" href="classBoundaryInfo.php#ab084520a55072f62c9acc7ca6afe420b">_boundary_node_id</a>.equal_range(node);
<a name="l00341"></a>00341 
<a name="l00342"></a>00342   <span class="keywordflow">for</span> (;pos.first != pos.second; ++pos.first)
<a name="l00343"></a>00343     <span class="keywordflow">if</span> (pos.first-&gt;second == <span class="keywordtype">id</span>)
<a name="l00344"></a>00344       <span class="keywordflow">return</span>;
<a name="l00345"></a>00345 
<a name="l00346"></a>00346   std::pair&lt;const Node*, short int&gt; kv (node, <span class="keywordtype">id</span>);
<a name="l00347"></a>00347   
<a name="l00348"></a>00348   <a class="code" href="classBoundaryInfo.php#ab084520a55072f62c9acc7ca6afe420b">_boundary_node_id</a>.insert(kv);
<a name="l00349"></a>00349   <a class="code" href="classBoundaryInfo.php#a2159b8b97781503d5a9e4331506edd4a">_boundary_ids</a>.insert(<span class="keywordtype">id</span>);
<a name="l00350"></a>00350 }
<a name="l00351"></a>00351 
<a name="l00352"></a>00352 
<a name="l00353"></a>00353 
<a name="l00354"></a><a class="code" href="classBoundaryInfo.php#a98ca8858756f9d549cbf8b3bb324f363">00354</a> <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#a98ca8858756f9d549cbf8b3bb324f363">BoundaryInfo::add_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e,
<a name="l00355"></a>00355                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> side,
<a name="l00356"></a>00356                             <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>)
<a name="l00357"></a>00357 {
<a name="l00358"></a>00358   this-&gt;<a class="code" href="classBoundaryInfo.php#a98ca8858756f9d549cbf8b3bb324f363">add_side</a> (<a class="code" href="classBoundaryInfo.php#a6f76c9f3d88c4e3a4354d8f16c22d4b8">_mesh</a>.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(e), side, id);
<a name="l00359"></a>00359 }
<a name="l00360"></a>00360 
<a name="l00361"></a>00361 
<a name="l00362"></a>00362 
<a name="l00363"></a><a class="code" href="classBoundaryInfo.php#a46ef479286ac58d9fec374672a6b424d">00363</a> <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#a98ca8858756f9d549cbf8b3bb324f363">BoundaryInfo::add_side</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00364"></a>00364                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> side,
<a name="l00365"></a>00365                             <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>)
<a name="l00366"></a>00366 {
<a name="l00367"></a>00367   libmesh_assert (elem != NULL);
<a name="l00368"></a>00368 
<a name="l00369"></a>00369   <span class="comment">// Only add BCs for level-0 elements.</span>
<a name="l00370"></a>00370   libmesh_assert (elem-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() == 0);
<a name="l00371"></a>00371   
<a name="l00372"></a>00372   <span class="keywordflow">if</span> (<span class="keywordtype">id</span> == <a class="code" href="classBoundaryInfo.php#a2a9670c3471907601fb62ae9dcce2eb4">invalid_id</a>)
<a name="l00373"></a>00373     {
<a name="l00374"></a>00374       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: You may not set a boundary ID of &quot;</span>
<a name="l00375"></a>00375                 &lt;&lt; <a class="code" href="classBoundaryInfo.php#a2a9670c3471907601fb62ae9dcce2eb4">invalid_id</a> &lt;&lt; std::endl
<a name="l00376"></a>00376                 &lt;&lt; <span class="stringliteral">&quot; That is reserved for internal use.\n&quot;</span>
<a name="l00377"></a>00377                 &lt;&lt; std::endl;
<a name="l00378"></a>00378 
<a name="l00379"></a>00379       libmesh_error();
<a name="l00380"></a>00380     }
<a name="l00381"></a>00381   
<a name="l00382"></a>00382   <span class="comment">// A convenient typedef</span>
<a name="l00383"></a>00383   <span class="keyword">typedef</span> std::multimap&lt;const Elem*, std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator Iter;
<a name="l00384"></a>00384               
<a name="l00385"></a>00385   <span class="comment">// Don&#39;t add the same ID twice</span>
<a name="l00386"></a>00386   std::pair&lt;Iter, Iter&gt; pos = <a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.equal_range(elem);
<a name="l00387"></a>00387 
<a name="l00388"></a>00388   <span class="keywordflow">for</span> (;pos.first != pos.second; ++pos.first)
<a name="l00389"></a>00389     <span class="keywordflow">if</span> (pos.first-&gt;second.first == side &amp;&amp;
<a name="l00390"></a>00390         pos.first-&gt;second.second == <span class="keywordtype">id</span>)
<a name="l00391"></a>00391       <span class="keywordflow">return</span>;
<a name="l00392"></a>00392 
<a name="l00393"></a>00393   std::pair&lt;unsigned short int, short int&gt; p(side,<span class="keywordtype">id</span>);
<a name="l00394"></a>00394   std::pair&lt;const Elem*, std::pair&lt;unsigned short int, short int&gt; &gt;
<a name="l00395"></a>00395     kv (elem, p);
<a name="l00396"></a>00396   
<a name="l00397"></a>00397   <a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.insert(kv);
<a name="l00398"></a>00398   <a class="code" href="classBoundaryInfo.php#a2159b8b97781503d5a9e4331506edd4a">_boundary_ids</a>.insert(<span class="keywordtype">id</span>);
<a name="l00399"></a>00399 }
<a name="l00400"></a>00400 
<a name="l00401"></a>00401 
<a name="l00402"></a>00402 
<a name="l00403"></a><a class="code" href="classBoundaryInfo.php#a6a64efef3fe0ce6b4c23e29abb2f1ebb">00403</a> std::vector&lt;short int&gt; <a class="code" href="classBoundaryInfo.php#a6a64efef3fe0ce6b4c23e29abb2f1ebb">BoundaryInfo::boundary_ids</a>(<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node)<span class="keyword"> const</span>
<a name="l00404"></a>00404 <span class="keyword"></span>{
<a name="l00405"></a>00405   std::vector&lt;short int&gt; ids;
<a name="l00406"></a>00406   
<a name="l00407"></a>00407   <span class="comment">// A convenient typedef</span>
<a name="l00408"></a>00408   <span class="keyword">typedef</span> std::multimap&lt;const Node*, short int&gt;::const_iterator Iter;
<a name="l00409"></a>00409               
<a name="l00410"></a>00410   <span class="comment">// Don&#39;t add the same ID twice</span>
<a name="l00411"></a>00411   std::pair&lt;Iter, Iter&gt; pos = <a class="code" href="classBoundaryInfo.php#ab084520a55072f62c9acc7ca6afe420b">_boundary_node_id</a>.equal_range(node);
<a name="l00412"></a>00412 
<a name="l00413"></a>00413   <span class="keywordflow">for</span> (;pos.first != pos.second; ++pos.first)
<a name="l00414"></a>00414     ids.push_back(pos.first-&gt;second);
<a name="l00415"></a>00415 
<a name="l00416"></a>00416   <span class="keywordflow">return</span> ids;
<a name="l00417"></a>00417 }
<a name="l00418"></a>00418 
<a name="l00419"></a>00419 
<a name="l00420"></a>00420 
<a name="l00421"></a><a class="code" href="classBoundaryInfo.php#a800c9cb9f884fbe11705729f9517e01f">00421</a> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classBoundaryInfo.php#a800c9cb9f884fbe11705729f9517e01f">BoundaryInfo::boundary_id</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00422"></a>00422                                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> side)<span class="keyword"> const</span>
<a name="l00423"></a>00423 <span class="keyword"></span>{
<a name="l00424"></a>00424   libmesh_assert (elem != NULL);
<a name="l00425"></a>00425 
<a name="l00426"></a>00426   <span class="comment">// Only level-0 elements store BCs.  If this is not a level-0</span>
<a name="l00427"></a>00427   <span class="comment">// element get its level-0 parent and infer the BCs.</span>
<a name="l00428"></a>00428   <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*  searched_elem = elem;
<a name="l00429"></a>00429   <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() != 0)
<a name="l00430"></a>00430     searched_elem = elem-&gt;<a class="code" href="classElem.php#a6bc01ad4901efb64eb4f584ed5e1bd0b">top_parent</a> ();
<a name="l00431"></a>00431   
<a name="l00432"></a>00432   std::pair&lt;std::multimap&lt;<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*,
<a name="l00433"></a>00433                           std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator,
<a name="l00434"></a>00434             std::multimap&lt;<span class="keyword">const</span> Elem*,
<a name="l00435"></a>00435                           std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator &gt; 
<a name="l00436"></a>00436     e = <a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.equal_range(searched_elem);
<a name="l00437"></a>00437 
<a name="l00438"></a>00438   <span class="comment">// elem not in the data structure</span>
<a name="l00439"></a>00439   <span class="keywordflow">if</span> (e.first == e.second)
<a name="l00440"></a>00440     <span class="keywordflow">return</span> <a class="code" href="classBoundaryInfo.php#a2a9670c3471907601fb62ae9dcce2eb4">invalid_id</a>;
<a name="l00441"></a>00441 
<a name="l00442"></a>00442   <span class="comment">// elem is there, maybe multiple occurances</span>
<a name="l00443"></a>00443   <span class="keywordflow">while</span> (e.first != e.second)
<a name="l00444"></a>00444     {
<a name="l00445"></a>00445       <span class="comment">// if this is true we found the requested side</span>
<a name="l00446"></a>00446       <span class="comment">// of the element and want to return the id</span>
<a name="l00447"></a>00447       <span class="keywordflow">if</span> (e.first-&gt;second.first == side)
<a name="l00448"></a>00448         <span class="keywordflow">return</span> e.first-&gt;second.second;
<a name="l00449"></a>00449 
<a name="l00450"></a>00450       ++e.first;
<a name="l00451"></a>00451     }
<a name="l00452"></a>00452 
<a name="l00453"></a>00453   <span class="comment">// if we get here, we found elem in the data structure but not</span>
<a name="l00454"></a>00454   <span class="comment">// the requested side, so return the default value</span>
<a name="l00455"></a>00455   <span class="keywordflow">return</span> <a class="code" href="classBoundaryInfo.php#a2a9670c3471907601fb62ae9dcce2eb4">invalid_id</a>;  
<a name="l00456"></a>00456 }
<a name="l00457"></a>00457 
<a name="l00458"></a>00458 
<a name="l00459"></a><a class="code" href="classBoundaryInfo.php#a22555b7ef00e2ead7c46778672abbfa2">00459</a> <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#a22555b7ef00e2ead7c46778672abbfa2">BoundaryInfo::remove_side</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00460"></a>00460                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> side)
<a name="l00461"></a>00461 {
<a name="l00462"></a>00462   libmesh_assert (elem != NULL);
<a name="l00463"></a>00463 
<a name="l00464"></a>00464   <span class="comment">// The user shouldn&#39;t be trying to remove only one child&#39;s boundary</span>
<a name="l00465"></a>00465   <span class="comment">// id</span>
<a name="l00466"></a>00466   libmesh_assert (elem-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() == 0);
<a name="l00467"></a>00467   
<a name="l00468"></a>00468   std::pair&lt;std::multimap&lt;<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*,
<a name="l00469"></a>00469                           std::pair&lt;unsigned short int, short int&gt; &gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a>,
<a name="l00470"></a>00470             std::multimap&lt;<span class="keyword">const</span> Elem*,
<a name="l00471"></a>00471                           std::pair&lt;unsigned short int, short int&gt; &gt;::iterator &gt; 
<a name="l00472"></a>00472     e = <a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.equal_range(elem);
<a name="l00473"></a>00473 
<a name="l00474"></a>00474   <span class="comment">// elem may be there, maybe multiple occurances</span>
<a name="l00475"></a>00475   <span class="keywordflow">while</span> (e.first != e.second)
<a name="l00476"></a>00476     {
<a name="l00477"></a>00477       <span class="comment">// if this is true we found the requested side</span>
<a name="l00478"></a>00478       <span class="comment">// of the element and want to erase the id</span>
<a name="l00479"></a>00479       <span class="keywordflow">if</span> (e.first-&gt;second.first == side)
<a name="l00480"></a>00480         {
<a name="l00481"></a>00481           <span class="comment">// (postfix++ - increment the iterator before it&#39;s invalid)</span>
<a name="l00482"></a>00482           <a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.erase(e.first++);
<a name="l00483"></a>00483         }
<a name="l00484"></a>00484       <span class="keywordflow">else</span>
<a name="l00485"></a>00485         ++e.first;
<a name="l00486"></a>00486     }
<a name="l00487"></a>00487 }
<a name="l00488"></a>00488 
<a name="l00489"></a>00489 
<a name="l00490"></a>00490 
<a name="l00491"></a><a class="code" href="classBoundaryInfo.php#a34bc65f5c2b80d3bc76d29e629b5a462">00491</a> <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#a22555b7ef00e2ead7c46778672abbfa2">BoundaryInfo::remove_side</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00492"></a>00492                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> side,
<a name="l00493"></a>00493                                 <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>)
<a name="l00494"></a>00494 {
<a name="l00495"></a>00495   libmesh_assert (elem != NULL);
<a name="l00496"></a>00496 
<a name="l00497"></a>00497   <span class="comment">// The user shouldn&#39;t be trying to remove only one child&#39;s boundary</span>
<a name="l00498"></a>00498   <span class="comment">// id</span>
<a name="l00499"></a>00499   libmesh_assert (elem-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() == 0);
<a name="l00500"></a>00500   
<a name="l00501"></a>00501   std::pair&lt;std::multimap&lt;<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*,
<a name="l00502"></a>00502                           std::pair&lt;unsigned short int, short int&gt; &gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a>,
<a name="l00503"></a>00503             std::multimap&lt;<span class="keyword">const</span> Elem*,
<a name="l00504"></a>00504                           std::pair&lt;unsigned short int, short int&gt; &gt;::iterator &gt; 
<a name="l00505"></a>00505     e = <a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.equal_range(elem);
<a name="l00506"></a>00506 
<a name="l00507"></a>00507   <span class="comment">// elem may be there, maybe multiple occurances</span>
<a name="l00508"></a>00508   <span class="keywordflow">while</span> (e.first != e.second)
<a name="l00509"></a>00509     {
<a name="l00510"></a>00510       <span class="comment">// if this is true we found the requested side</span>
<a name="l00511"></a>00511       <span class="comment">// of the element and want to erase the requested id</span>
<a name="l00512"></a>00512       <span class="keywordflow">if</span> (e.first-&gt;second.first == side &amp;&amp;
<a name="l00513"></a>00513           e.first-&gt;second.second == <span class="keywordtype">id</span>)
<a name="l00514"></a>00514         {
<a name="l00515"></a>00515           <span class="comment">// (postfix++ - increment the iterator before it&#39;s invalid)</span>
<a name="l00516"></a>00516           <a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.erase(e.first++);
<a name="l00517"></a>00517         }
<a name="l00518"></a>00518       <span class="keywordflow">else</span>
<a name="l00519"></a>00519         ++e.first;
<a name="l00520"></a>00520     }
<a name="l00521"></a>00521 }
<a name="l00522"></a>00522 
<a name="l00523"></a>00523 
<a name="l00524"></a>00524 
<a name="l00525"></a><a class="code" href="classBoundaryInfo.php#a535bc3df5f90a56c75d97ba827d21bbd">00525</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classBoundaryInfo.php#a535bc3df5f90a56c75d97ba827d21bbd">BoundaryInfo::side_with_boundary_id</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00526"></a>00526                                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> boundary_id)<span class="keyword"> const</span>
<a name="l00527"></a>00527 <span class="keyword"></span>{
<a name="l00528"></a>00528   <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* searched_elem = elem;
<a name="l00529"></a>00529   <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() != 0)
<a name="l00530"></a>00530     searched_elem = elem-&gt;<a class="code" href="classElem.php#a6bc01ad4901efb64eb4f584ed5e1bd0b">top_parent</a>();
<a name="l00531"></a>00531 
<a name="l00532"></a>00532   std::pair&lt;std::multimap&lt;<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*,
<a name="l00533"></a>00533                           std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator,
<a name="l00534"></a>00534             std::multimap&lt;<span class="keyword">const</span> Elem*,
<a name="l00535"></a>00535                           std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator &gt; 
<a name="l00536"></a>00536     e = <a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.equal_range(searched_elem);
<a name="l00537"></a>00537 
<a name="l00538"></a>00538   <span class="comment">// elem not in the data structure</span>
<a name="l00539"></a>00539   <span class="keywordflow">if</span> (e.first == e.second)
<a name="l00540"></a>00540     <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00541"></a>00541 
<a name="l00542"></a>00542   <span class="comment">// elem is there, maybe multiple occurances</span>
<a name="l00543"></a>00543   <span class="keywordflow">while</span> (e.first != e.second)
<a name="l00544"></a>00544     {
<a name="l00545"></a>00545       <span class="comment">// if this is true we found the requested boundary_id</span>
<a name="l00546"></a>00546       <span class="comment">// of the element and want to return the side</span>
<a name="l00547"></a>00547       <span class="keywordflow">if</span> (e.first-&gt;second.second == boundary_id)
<a name="l00548"></a>00548         <span class="keywordflow">return</span> e.first-&gt;second.first;
<a name="l00549"></a>00549 
<a name="l00550"></a>00550       ++e.first;
<a name="l00551"></a>00551     }
<a name="l00552"></a>00552 
<a name="l00553"></a>00553   <span class="comment">// if we get here, we found elem in the data structure but not</span>
<a name="l00554"></a>00554   <span class="comment">// the requested boundary id, so return the default value</span>
<a name="l00555"></a>00555   <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;  
<a name="l00556"></a>00556 }
<a name="l00557"></a>00557 
<a name="l00558"></a><a class="code" href="classBoundaryInfo.php#adf7c759da8c5147f79bb04cf338e19aa">00558</a> <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#adf7c759da8c5147f79bb04cf338e19aa">BoundaryInfo::build_node_boundary_ids</a>(std::vector&lt;short int&gt; &amp;b_ids)
<a name="l00559"></a>00559 {
<a name="l00560"></a>00560   b_ids.clear();
<a name="l00561"></a>00561 
<a name="l00562"></a>00562   std::multimap&lt;const Node*, short int&gt;::const_iterator pos
<a name="l00563"></a>00563     = <a class="code" href="classBoundaryInfo.php#ab084520a55072f62c9acc7ca6afe420b">_boundary_node_id</a>.begin();
<a name="l00564"></a>00564 
<a name="l00565"></a>00565   <span class="keywordflow">for</span> (; pos != <a class="code" href="classBoundaryInfo.php#ab084520a55072f62c9acc7ca6afe420b">_boundary_node_id</a>.end(); ++pos)
<a name="l00566"></a>00566     {
<a name="l00567"></a>00567       <span class="keywordtype">short</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span> = pos-&gt;second;
<a name="l00568"></a>00568       
<a name="l00569"></a>00569       <span class="keywordflow">if</span>(std::find(b_ids.begin(),b_ids.end(),id) == b_ids.end())
<a name="l00570"></a>00570         b_ids.push_back(<span class="keywordtype">id</span>);
<a name="l00571"></a>00571     }
<a name="l00572"></a>00572 }
<a name="l00573"></a>00573 
<a name="l00574"></a><a class="code" href="classBoundaryInfo.php#a8c85515e269e32593894ee1307620f41">00574</a> <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#a8c85515e269e32593894ee1307620f41">BoundaryInfo::build_side_boundary_ids</a>(std::vector&lt;short int&gt; &amp;b_ids)
<a name="l00575"></a>00575 {
<a name="l00576"></a>00576   b_ids.clear();
<a name="l00577"></a>00577 
<a name="l00578"></a>00578   std::multimap&lt;const Elem*, std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator pos
<a name="l00579"></a>00579     = <a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.begin();
<a name="l00580"></a>00580 
<a name="l00581"></a>00581   <span class="keywordflow">for</span> (; pos != <a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.end(); ++pos)
<a name="l00582"></a>00582     {
<a name="l00583"></a>00583       <span class="keywordtype">short</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span> = pos-&gt;second.second;
<a name="l00584"></a>00584       
<a name="l00585"></a>00585       <span class="keywordflow">if</span>(std::find(b_ids.begin(),b_ids.end(),id) == b_ids.end())
<a name="l00586"></a>00586         b_ids.push_back(<span class="keywordtype">id</span>);
<a name="l00587"></a>00587     }
<a name="l00588"></a>00588 }
<a name="l00589"></a>00589 
<a name="l00590"></a><a class="code" href="classBoundaryInfo.php#a5e47551a54f82221b511e08f966f359d">00590</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classBoundaryInfo.php#a5e47551a54f82221b511e08f966f359d">BoundaryInfo::n_boundary_conds</a> ()<span class="keyword"> const</span>
<a name="l00591"></a>00591 <span class="keyword"></span>{
<a name="l00592"></a>00592   <span class="comment">// in serial we know the number of bcs from the</span>
<a name="l00593"></a>00593   <span class="comment">// size of the container</span>
<a name="l00594"></a>00594   <span class="keywordflow">if</span> (<a class="code" href="classBoundaryInfo.php#a6f76c9f3d88c4e3a4354d8f16c22d4b8">_mesh</a>.<a class="code" href="classMeshBase.php#a660bb92c9fb94527d1cabfb1fdd6d056">is_serial</a>())
<a name="l00595"></a>00595     <span class="keywordflow">return</span> <a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.size();
<a name="l00596"></a>00596 
<a name="l00597"></a>00597   <span class="comment">// in parallel we need to sum the number of local bcs</span>
<a name="l00598"></a>00598   parallel_only();
<a name="l00599"></a>00599   
<a name="l00600"></a>00600   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nbcs=0;
<a name="l00601"></a>00601 
<a name="l00602"></a>00602   std::multimap&lt;<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*,
<a name="l00603"></a>00603                 std::pair&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> int,
<a name="l00604"></a>00604                           <span class="keywordtype">short</span> <span class="keywordtype">int</span>&gt; &gt;::const_iterator pos;
<a name="l00605"></a>00605 
<a name="l00606"></a>00606   <span class="keywordflow">for</span> (pos=<a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.begin(); pos != <a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.end(); ++pos)
<a name="l00607"></a>00607     <span class="keywordflow">if</span> (pos-&gt;first-&gt;processor_id() == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00608"></a>00608       nbcs++;
<a name="l00609"></a>00609   
<a name="l00610"></a>00610   Parallel::sum (nbcs);
<a name="l00611"></a>00611   
<a name="l00612"></a>00612   <span class="keywordflow">return</span> nbcs;
<a name="l00613"></a>00613 }
<a name="l00614"></a>00614 
<a name="l00615"></a>00615 
<a name="l00616"></a>00616 
<a name="l00617"></a><a class="code" href="classBoundaryInfo.php#a6b5c5e582386fd889c7fba624cd45c57">00617</a> <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#a6b5c5e582386fd889c7fba624cd45c57">BoundaryInfo::build_node_list</a> (std::vector&lt;unsigned int&gt;&amp; nl,
<a name="l00618"></a>00618                                     std::vector&lt;short int&gt;&amp;    il)<span class="keyword"> const</span>
<a name="l00619"></a>00619 <span class="keyword"></span>{
<a name="l00620"></a>00620   <span class="comment">// Reserve the size, then use push_back</span>
<a name="l00621"></a>00621   nl.reserve (<a class="code" href="classBoundaryInfo.php#ab084520a55072f62c9acc7ca6afe420b">_boundary_node_id</a>.size());
<a name="l00622"></a>00622   il.reserve (<a class="code" href="classBoundaryInfo.php#ab084520a55072f62c9acc7ca6afe420b">_boundary_node_id</a>.size());
<a name="l00623"></a>00623   
<a name="l00624"></a>00624   std::multimap&lt;const Node*, short int&gt;::const_iterator pos
<a name="l00625"></a>00625     = <a class="code" href="classBoundaryInfo.php#ab084520a55072f62c9acc7ca6afe420b">_boundary_node_id</a>.begin();
<a name="l00626"></a>00626 
<a name="l00627"></a>00627   <span class="keywordflow">for</span> (; pos != <a class="code" href="classBoundaryInfo.php#ab084520a55072f62c9acc7ca6afe420b">_boundary_node_id</a>.end(); ++pos)
<a name="l00628"></a>00628     {
<a name="l00629"></a>00629       nl.push_back (pos-&gt;first-&gt;id());
<a name="l00630"></a>00630       il.push_back (pos-&gt;second);
<a name="l00631"></a>00631     }
<a name="l00632"></a>00632 }
<a name="l00633"></a>00633 
<a name="l00634"></a>00634 
<a name="l00635"></a>00635 <span class="keywordtype">void</span>
<a name="l00636"></a><a class="code" href="classBoundaryInfo.php#a8c8ed40d217d0b486f18375a6721ec71">00636</a> <a class="code" href="classBoundaryInfo.php#a8c8ed40d217d0b486f18375a6721ec71">BoundaryInfo::build_node_list_from_side_list</a>()
<a name="l00637"></a>00637 {
<a name="l00638"></a>00638   std::multimap&lt;<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*,
<a name="l00639"></a>00639                 std::pair&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> int,
<a name="l00640"></a>00640                           <span class="keywordtype">short</span> <span class="keywordtype">int</span>&gt; &gt;::const_iterator pos;
<a name="l00641"></a>00641   
<a name="l00642"></a>00642   <span class="comment">//Loop over the side list</span>
<a name="l00643"></a>00643   <span class="keywordflow">for</span> (pos=<a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.begin(); pos != <a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.end(); ++pos)
<a name="l00644"></a>00644   {
<a name="l00645"></a>00645     <span class="comment">//Need to loop over the sides of any possible children</span>
<a name="l00646"></a>00646     std::vector&lt; const Elem * &gt; family;
<a name="l00647"></a>00647 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00648"></a>00648 <span class="preprocessor"></span>    pos-&gt;first-&gt;<a class="code" href="classElem.php#a5c362d52b5c393691357633fb337ced0">active_family_tree_by_side</a> (family, pos-&gt;second.first);
<a name="l00649"></a>00649 <span class="preprocessor">#else</span>
<a name="l00650"></a>00650 <span class="preprocessor"></span>    family.push_back(pos-&gt;first);
<a name="l00651"></a>00651 <span class="preprocessor">#endif</span>
<a name="l00652"></a>00652 <span class="preprocessor"></span>
<a name="l00653"></a>00653     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_it=0; elem_it &lt; family.size(); elem_it++)
<a name="l00654"></a>00654     {
<a name="l00655"></a>00655       <span class="keyword">const</span> Elem * cur_elem = family[elem_it];
<a name="l00656"></a>00656       
<a name="l00657"></a>00657       <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> side = cur_elem-&gt;<a class="code" href="classElem.php#a554c146bcfb5537636bd77a157f21b85">build_side</a>(pos-&gt;second.first);
<a name="l00658"></a>00658 
<a name="l00659"></a>00659       <span class="comment">//Add each node node on the side with the side&#39;s boundary id</span>
<a name="l00660"></a>00660       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;side-&gt;n_nodes(); i++)
<a name="l00661"></a>00661       {
<a name="l00662"></a>00662         <a class="code" href="classNode.php">Node</a> * node = side-&gt;get_node(i);
<a name="l00663"></a>00663         
<a name="l00664"></a>00664         this-&gt;<a class="code" href="classBoundaryInfo.php#ad1b6927a343e6a084e384fcf7b8e9e8a">add_node</a>(node, pos-&gt;second.second);
<a name="l00665"></a>00665       }
<a name="l00666"></a>00666     }
<a name="l00667"></a>00667   }
<a name="l00668"></a>00668 }
<a name="l00669"></a>00669 
<a name="l00670"></a><a class="code" href="classBoundaryInfo.php#af5e88d4226dd6141a31c63a32fa647e0">00670</a> <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#af5e88d4226dd6141a31c63a32fa647e0">BoundaryInfo::build_side_list</a> (std::vector&lt;unsigned int&gt;&amp;       el,
<a name="l00671"></a>00671                                     std::vector&lt;unsigned short int&gt;&amp; sl,
<a name="l00672"></a>00672                                     std::vector&lt;short int&gt;&amp;          il)<span class="keyword"> const</span>
<a name="l00673"></a>00673 <span class="keyword"></span>{
<a name="l00674"></a>00674   <span class="comment">// Reserve the size, then use push_back</span>
<a name="l00675"></a>00675   el.reserve (<a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.size());
<a name="l00676"></a>00676   sl.reserve (<a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.size());
<a name="l00677"></a>00677   il.reserve (<a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.size());
<a name="l00678"></a>00678 
<a name="l00679"></a>00679   std::multimap&lt;<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*,
<a name="l00680"></a>00680                 std::pair&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> int,
<a name="l00681"></a>00681                           <span class="keywordtype">short</span> <span class="keywordtype">int</span>&gt; &gt;::const_iterator pos;
<a name="l00682"></a>00682 
<a name="l00683"></a>00683   <span class="keywordflow">for</span> (pos=<a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.begin(); pos != <a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.end();
<a name="l00684"></a>00684        ++pos)
<a name="l00685"></a>00685     {
<a name="l00686"></a>00686       el.push_back (pos-&gt;first-&gt;id());
<a name="l00687"></a>00687       sl.push_back (pos-&gt;second.first);
<a name="l00688"></a>00688       il.push_back (pos-&gt;second.second);
<a name="l00689"></a>00689     }
<a name="l00690"></a>00690 }
<a name="l00691"></a>00691 
<a name="l00692"></a>00692 
<a name="l00693"></a>00693 
<a name="l00694"></a><a class="code" href="classBoundaryInfo.php#a194d57836baae9c820d0b5ffa4dacfb6">00694</a> <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#a194d57836baae9c820d0b5ffa4dacfb6">BoundaryInfo::print_info</a>()<span class="keyword"> const</span>
<a name="l00695"></a>00695 <span class="keyword"></span>{
<a name="l00696"></a>00696   <span class="comment">// Print out the nodal BCs</span>
<a name="l00697"></a>00697   <span class="keywordflow">if</span> (!<a class="code" href="classBoundaryInfo.php#ab084520a55072f62c9acc7ca6afe420b">_boundary_node_id</a>.empty())
<a name="l00698"></a>00698     {
<a name="l00699"></a>00699       std::cout &lt;&lt; <span class="stringliteral">&quot;Nodal Boundary conditions:&quot;</span> &lt;&lt; std::endl
<a name="l00700"></a>00700                 &lt;&lt; <span class="stringliteral">&quot;--------------------------&quot;</span> &lt;&lt; std::endl
<a name="l00701"></a>00701                 &lt;&lt; <span class="stringliteral">&quot;  (Node No., ID)               &quot;</span> &lt;&lt; std::endl;
<a name="l00702"></a>00702 
<a name="l00703"></a>00703 <span class="comment">//       std::for_each(_boundary_node_id.begin(),</span>
<a name="l00704"></a>00704 <span class="comment">//                  _boundary_node_id.end(),</span>
<a name="l00705"></a>00705 <span class="comment">//                  PrintNodeInfo());</span>
<a name="l00706"></a>00706 
<a name="l00707"></a>00707       std::multimap&lt;const Node*, short int&gt;::const_iterator it        = <a class="code" href="classBoundaryInfo.php#ab084520a55072f62c9acc7ca6afe420b">_boundary_node_id</a>.begin();
<a name="l00708"></a>00708       <span class="keyword">const</span> std::multimap&lt;const Node*, short int&gt;::const_iterator end = <a class="code" href="classBoundaryInfo.php#ab084520a55072f62c9acc7ca6afe420b">_boundary_node_id</a>.end();
<a name="l00709"></a>00709 
<a name="l00710"></a>00710       <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00711"></a>00711         std::cout &lt;&lt; <span class="stringliteral">&quot;  (&quot;</span> &lt;&lt; (*it).first-&gt;id()
<a name="l00712"></a>00712                   &lt;&lt; <span class="stringliteral">&quot;, &quot;</span>  &lt;&lt; (*it).second
<a name="l00713"></a>00713                   &lt;&lt; <span class="stringliteral">&quot;)&quot;</span>  &lt;&lt; std::endl;
<a name="l00714"></a>00714     }
<a name="l00715"></a>00715   
<a name="l00716"></a>00716   <span class="comment">// Print out the element BCs</span>
<a name="l00717"></a>00717   <span class="keywordflow">if</span> (!<a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.empty())
<a name="l00718"></a>00718     {
<a name="l00719"></a>00719       std::cout &lt;&lt; std::endl
<a name="l00720"></a>00720                 &lt;&lt; <span class="stringliteral">&quot;Side Boundary conditions:&quot;</span> &lt;&lt; std::endl
<a name="l00721"></a>00721                 &lt;&lt; <span class="stringliteral">&quot;-------------------------&quot;</span> &lt;&lt; std::endl
<a name="l00722"></a>00722                 &lt;&lt; <span class="stringliteral">&quot;  (Elem No., Side No., ID)      &quot;</span> &lt;&lt; std::endl;
<a name="l00723"></a>00723 
<a name="l00724"></a>00724 <span class="comment">//       std::for_each(_boundary_side_id.begin(),</span>
<a name="l00725"></a>00725 <span class="comment">//                  _boundary_side_id.end(),</span>
<a name="l00726"></a>00726 <span class="comment">//                  PrintSideInfo());</span>
<a name="l00727"></a>00727 
<a name="l00728"></a>00728       std::multimap&lt;<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*,
<a name="l00729"></a>00729         std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator it = <a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.begin();
<a name="l00730"></a>00730       <span class="keyword">const</span> std::multimap&lt;<span class="keyword">const</span> Elem*,
<a name="l00731"></a>00731         std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator end = <a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.end();
<a name="l00732"></a>00732 
<a name="l00733"></a>00733      <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00734"></a>00734        std::cout &lt;&lt; <span class="stringliteral">&quot;  (&quot;</span> &lt;&lt; (*it).first-&gt;id()
<a name="l00735"></a>00735                  &lt;&lt; <span class="stringliteral">&quot;, &quot;</span>  &lt;&lt; (*it).second.first
<a name="l00736"></a>00736                  &lt;&lt; <span class="stringliteral">&quot;, &quot;</span>  &lt;&lt; (*it).second.second 
<a name="l00737"></a>00737                  &lt;&lt; <span class="stringliteral">&quot;)&quot;</span>   &lt;&lt; std::endl;
<a name="l00738"></a>00738     }
<a name="l00739"></a>00739 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
