<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>boundary_info.h</h1>  </div>
</div>
<div class="contents">
<a href="boundary__info_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: boundary_info.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __boundary_info_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __boundary_info_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward declarations</span>
<a name="l00035"></a>00035 <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00036"></a>00036 <span class="keyword">class </span><a class="code" href="classNode.php">Node</a>;
<a name="l00037"></a>00037 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00038"></a>00038 <span class="keyword">class </span><a class="code" href="classBoundaryMesh.php">BoundaryMesh</a>;
<a name="l00039"></a>00039 <span class="keyword">class </span><a class="code" href="classMeshData.php">MeshData</a>;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00053"></a>00053 <span class="comment">//------------------------------------------------------</span>
<a name="l00054"></a>00054 <span class="comment">// BoundaryInfo class definition</span>
<a name="l00055"></a><a class="code" href="classBoundaryInfo.php">00055</a> <span class="keyword">class </span><a class="code" href="classBoundaryInfo.php">BoundaryInfo</a>
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057 <span class="keyword">protected</span>:
<a name="l00058"></a><a class="code" href="classBoundaryInfo.php#ad3a3c9ef9c9ca3ff5642ac40daaedd99">00058</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00059"></a>00059   
<a name="l00066"></a>00066   <a class="code" href="classBoundaryInfo.php#a3f1039c4f988f5bd446b82872e07ad47">BoundaryInfo</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; m);
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 <span class="keyword">public</span>:
<a name="l00069"></a>00069 
<a name="l00073"></a>00073   <a class="code" href="classBoundaryInfo.php#aeef02a29ae74cfa9384cd1db9fbfe372">~BoundaryInfo</a> ();
<a name="l00074"></a>00074 
<a name="l00080"></a>00080   <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#a0565fdb81d365b6bf7dd1c99aad1da86">clear</a> ();
<a name="l00081"></a>00081   
<a name="l00094"></a>00094   <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#af5727161cb9ac9c2aa037e72debe9280">sync</a> (<a class="code" href="classBoundaryMesh.php">BoundaryMesh</a>&amp; boundary_mesh,
<a name="l00095"></a>00095              <a class="code" href="classMeshData.php">MeshData</a>* boundary_mesh_data=NULL,
<a name="l00096"></a>00096              <a class="code" href="classMeshData.php">MeshData</a>* this_mesh_data=NULL);
<a name="l00097"></a>00097   
<a name="l00111"></a>00111   <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#af5727161cb9ac9c2aa037e72debe9280">sync</a> (<span class="keyword">const</span> std::set&lt;short int&gt; &amp;requested_boundary_ids,
<a name="l00112"></a>00112              <a class="code" href="classBoundaryMesh.php">BoundaryMesh</a>&amp; boundary_mesh);
<a name="l00113"></a>00113   
<a name="l00118"></a>00118   <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#ad1b6927a343e6a084e384fcf7b8e9e8a">add_node</a> (<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classMeshBase.php#a298477f2d67d6a85f6c7fb5a640e2b64">node</a>,
<a name="l00119"></a>00119                  <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>);
<a name="l00120"></a>00120 
<a name="l00125"></a>00125   <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#ad1b6927a343e6a084e384fcf7b8e9e8a">add_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#a298477f2d67d6a85f6c7fb5a640e2b64">node</a>,
<a name="l00126"></a>00126                  <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>);
<a name="l00127"></a>00127 
<a name="l00132"></a>00132   <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#a98ca8858756f9d549cbf8b3bb324f363">add_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>,
<a name="l00133"></a>00133                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> side,
<a name="l00134"></a>00134                  <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>);
<a name="l00135"></a>00135 
<a name="l00140"></a>00140   <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#a98ca8858756f9d549cbf8b3bb324f363">add_side</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>,
<a name="l00141"></a>00141                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> side,
<a name="l00142"></a>00142                  <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>);
<a name="l00143"></a>00143 
<a name="l00148"></a>00148   <span class="keywordtype">void</span> <span class="keyword">remove</span> (<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classMeshBase.php#a298477f2d67d6a85f6c7fb5a640e2b64">node</a>);
<a name="l00149"></a>00149 
<a name="l00154"></a>00154   <span class="keywordtype">void</span> <span class="keyword">remove</span> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>);
<a name="l00155"></a>00155 
<a name="l00160"></a>00160   <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#a22555b7ef00e2ead7c46778672abbfa2">remove_side</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>,
<a name="l00161"></a>00161                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> side);
<a name="l00162"></a>00162 
<a name="l00167"></a>00167   <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#a22555b7ef00e2ead7c46778672abbfa2">remove_side</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>,
<a name="l00168"></a>00168                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> side,
<a name="l00169"></a>00169                     <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>);
<a name="l00170"></a>00170 
<a name="l00174"></a><a class="code" href="classBoundaryInfo.php#ae4a9fe24ebb554775311ceda65a21708">00174</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classBoundaryInfo.php#ae4a9fe24ebb554775311ceda65a21708">n_boundary_ids</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classBoundaryInfo.php#a2159b8b97781503d5a9e4331506edd4a">_boundary_ids</a>.size(); }
<a name="l00175"></a>00175 
<a name="l00179"></a>00179   std::vector&lt;short int&gt; <a class="code" href="classBoundaryInfo.php#a6a64efef3fe0ce6b4c23e29abb2f1ebb">boundary_ids</a> (<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classMeshBase.php#a298477f2d67d6a85f6c7fb5a640e2b64">node</a>) <span class="keyword">const</span>;
<a name="l00180"></a>00180 
<a name="l00188"></a>00188   <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classBoundaryInfo.php#a800c9cb9f884fbe11705729f9517e01f">boundary_id</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <span class="keyword">const</span> <a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>,
<a name="l00189"></a>00189                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> side) <span class="keyword">const</span>;
<a name="l00190"></a>00190 
<a name="l00199"></a>00199   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classBoundaryInfo.php#a535bc3df5f90a56c75d97ba827d21bbd">side_with_boundary_id</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <span class="keyword">const</span> <a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>,
<a name="l00200"></a>00200                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classBoundaryInfo.php#a800c9cb9f884fbe11705729f9517e01f">boundary_id</a>) <span class="keyword">const</span>;
<a name="l00201"></a>00201 
<a name="l00205"></a>00205   <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#adf7c759da8c5147f79bb04cf338e19aa">build_node_boundary_ids</a>(std::vector&lt;short int&gt; &amp;b_ids);
<a name="l00206"></a>00206 
<a name="l00210"></a>00210   <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#a8c85515e269e32593894ee1307620f41">build_side_boundary_ids</a>(std::vector&lt;short int&gt; &amp;b_ids);
<a name="l00211"></a>00211 
<a name="l00215"></a>00215   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classBoundaryInfo.php#a5e47551a54f82221b511e08f966f359d">n_boundary_conds</a> () <span class="keyword">const</span>;
<a name="l00216"></a>00216   
<a name="l00220"></a>00220   <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#a6b5c5e582386fd889c7fba624cd45c57">build_node_list</a> (std::vector&lt;unsigned int&gt;&amp; nl,
<a name="l00221"></a>00221                         std::vector&lt;short int&gt;&amp;    il) <span class="keyword">const</span>;
<a name="l00222"></a>00222 
<a name="l00227"></a>00227   <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#a8c8ed40d217d0b486f18375a6721ec71">build_node_list_from_side_list</a>();
<a name="l00228"></a>00228 
<a name="l00232"></a>00232   <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#af5e88d4226dd6141a31c63a32fa647e0">build_side_list</a> (std::vector&lt;unsigned int&gt;&amp;       el,
<a name="l00233"></a>00233                         std::vector&lt;unsigned short int&gt;&amp; sl,
<a name="l00234"></a>00234                         std::vector&lt;short int&gt;&amp;          il) <span class="keyword">const</span>;
<a name="l00235"></a>00235 
<a name="l00239"></a><a class="code" href="classBoundaryInfo.php#afa70b9aabad828d762d7b5741980ab47">00239</a>   <span class="keyword">const</span> std::set&lt;short int&gt;&amp; <a class="code" href="classBoundaryInfo.php#afa70b9aabad828d762d7b5741980ab47">get_boundary_ids</a> ()<span class="keyword"> const</span>
<a name="l00240"></a>00240 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classBoundaryInfo.php#a2159b8b97781503d5a9e4331506edd4a">_boundary_ids</a>; }
<a name="l00241"></a>00241 
<a name="l00245"></a>00245   <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#a194d57836baae9c820d0b5ffa4dacfb6">print_info</a> () <span class="keyword">const</span>;
<a name="l00246"></a>00246   
<a name="l00251"></a><a class="code" href="classBoundaryInfo.php#a2a9670c3471907601fb62ae9dcce2eb4">00251</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classBoundaryInfo.php#a2a9670c3471907601fb62ae9dcce2eb4">invalid_id</a>;
<a name="l00252"></a>00252 
<a name="l00253"></a>00253 
<a name="l00254"></a>00254  <span class="keyword">private</span>:
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 
<a name="l00260"></a><a class="code" href="classBoundaryInfo.php#a6f76c9f3d88c4e3a4354d8f16c22d4b8">00260</a>   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classBoundaryInfo.php#a6f76c9f3d88c4e3a4354d8f16c22d4b8">_mesh</a>;
<a name="l00261"></a>00261 
<a name="l00266"></a>00266   std::multimap&lt;<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>*,
<a name="l00267"></a><a class="code" href="classBoundaryInfo.php#ab084520a55072f62c9acc7ca6afe420b">00267</a>                 <span class="keywordtype">short</span> <span class="keywordtype">int</span>&gt; <a class="code" href="classBoundaryInfo.php#ab084520a55072f62c9acc7ca6afe420b">_boundary_node_id</a>;
<a name="l00268"></a>00268 
<a name="l00273"></a>00273   std::multimap&lt;<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*,
<a name="l00274"></a>00274                 std::pair&lt;unsigned short int, short int&gt; &gt;
<a name="l00275"></a><a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">00275</a>                                              <a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>;
<a name="l00276"></a>00276 
<a name="l00280"></a><a class="code" href="classBoundaryInfo.php#a2159b8b97781503d5a9e4331506edd4a">00280</a>   std::set&lt;short int&gt; <a class="code" href="classBoundaryInfo.php#a2159b8b97781503d5a9e4331506edd4a">_boundary_ids</a>;
<a name="l00281"></a>00281 
<a name="l00282"></a>00282 
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 <span class="comment">//   /**</span>
<a name="l00285"></a>00285 <span class="comment">//    * Functor class for printing a single node&#39;s info</span>
<a name="l00286"></a>00286 <span class="comment">//    * To be used with &quot;for_each&quot;.</span>
<a name="l00287"></a>00287 <span class="comment">//    */</span>
<a name="l00288"></a>00288 <span class="comment">//   class PrintNodeInfo </span>
<a name="l00289"></a>00289 <span class="comment">//   {</span>
<a name="l00290"></a>00290 <span class="comment">//   public:</span>
<a name="l00291"></a>00291 <span class="comment">//     inline</span>
<a name="l00292"></a>00292 <span class="comment">//     void operator() (const std::pair&lt;const Node*, short int&gt;&amp; np) const</span>
<a name="l00293"></a>00293 <span class="comment">//     {</span>
<a name="l00294"></a>00294 <span class="comment">//       std::cout &lt;&lt; &quot;  (&quot; &lt;&lt; np.first-&gt;id()</span>
<a name="l00295"></a>00295 <span class="comment">//              &lt;&lt; &quot;, &quot;  &lt;&lt; np.second</span>
<a name="l00296"></a>00296 <span class="comment">//              &lt;&lt; &quot;)&quot;  &lt;&lt; std::endl;</span>
<a name="l00297"></a>00297 <span class="comment">//     }</span>
<a name="l00298"></a>00298 <span class="comment">//   };</span>
<a name="l00299"></a>00299 
<a name="l00300"></a>00300 
<a name="l00301"></a>00301 <span class="comment">//   /**</span>
<a name="l00302"></a>00302 <span class="comment">//    * Functor class for printing a single side&#39;s info.</span>
<a name="l00303"></a>00303 <span class="comment">//    * To be used with &quot;for_each&quot;.</span>
<a name="l00304"></a>00304 <span class="comment">//    */</span>
<a name="l00305"></a>00305 <span class="comment">//   class PrintSideInfo</span>
<a name="l00306"></a>00306 <span class="comment">//   {</span>
<a name="l00307"></a>00307 <span class="comment">//   public:</span>
<a name="l00308"></a>00308 <span class="comment">//     PrintSideInfo() {}</span>
<a name="l00309"></a>00309 <span class="comment">//     inline</span>
<a name="l00310"></a>00310 <span class="comment">//     void operator() (const std::pair&lt;const Elem*, std::pair&lt;unsigned short int,short int&gt; &gt;&amp; sp) const</span>
<a name="l00311"></a>00311 <span class="comment">//     {</span>
<a name="l00312"></a>00312 <span class="comment">//       std::cout &lt;&lt; &quot;  (&quot; &lt;&lt; sp.first-&gt;id()</span>
<a name="l00313"></a>00313 <span class="comment">//              &lt;&lt; &quot;, &quot;  &lt;&lt; sp.second.first</span>
<a name="l00314"></a>00314 <span class="comment">//              &lt;&lt; &quot;, &quot;  &lt;&lt; sp.second.second </span>
<a name="l00315"></a>00315 <span class="comment">//              &lt;&lt; &quot;)&quot;   &lt;&lt; std::endl;</span>
<a name="l00316"></a>00316 <span class="comment">//     }</span>
<a name="l00317"></a>00317 <span class="comment">//   };</span>
<a name="l00318"></a>00318 
<a name="l00319"></a>00319 
<a name="l00320"></a>00320   
<a name="l00328"></a><a class="code" href="classBoundaryInfo_1_1Fill.php">00328</a>   <span class="keyword">class </span><a class="code" href="classBoundaryInfo_1_1Fill.php">Fill</a>
<a name="l00329"></a>00329   {
<a name="l00330"></a>00330   <span class="keyword">public</span>:
<a name="l00331"></a><a class="code" href="classBoundaryInfo_1_1Fill.php#a41cecd61b50278c047d4b1eda2788faa">00331</a>     <a class="code" href="classBoundaryInfo_1_1Fill.php#a41cecd61b50278c047d4b1eda2788faa">Fill</a>(std::map&lt;short int, unsigned int&gt;&amp; im) : <a class="code" href="classBoundaryInfo_1_1Fill.php#af8d27388298ec69e30d8f44edcf0474c">id_map</a>(im), <a class="code" href="classBoundaryInfo_1_1Fill.php#a9b71ed5e0774d05f1e3037ebdf268c89">cnt</a>(0) {}
<a name="l00332"></a>00332 
<a name="l00333"></a><a class="code" href="classBoundaryInfo_1_1Fill.php#a813d209b55c1c03034b98e338a1c7782">00333</a>     <a class="code" href="classBoundaryInfo_1_1Fill.php#a813d209b55c1c03034b98e338a1c7782">~Fill</a>()
<a name="l00334"></a>00334     {
<a name="l00335"></a>00335       <a class="code" href="classBoundaryInfo_1_1Fill.php#af8d27388298ec69e30d8f44edcf0474c">id_map</a>[<a class="code" href="classBoundaryInfo.php#a2a9670c3471907601fb62ae9dcce2eb4">invalid_id</a>] = <a class="code" href="classBoundaryInfo_1_1Fill.php#a9b71ed5e0774d05f1e3037ebdf268c89">cnt</a>;
<a name="l00336"></a>00336     }
<a name="l00337"></a>00337     
<a name="l00338"></a>00338     <span class="keyword">inline</span>
<a name="l00339"></a><a class="code" href="classBoundaryInfo_1_1Fill.php#ab3f7631e93173a89c87ec038960c0774">00339</a>     <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo_1_1Fill.php#ab3f7631e93173a89c87ec038960c0774">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> &amp; pos)
<a name="l00340"></a>00340     {
<a name="l00341"></a>00341       <a class="code" href="classBoundaryInfo_1_1Fill.php#af8d27388298ec69e30d8f44edcf0474c">id_map</a>[pos] = <a class="code" href="classBoundaryInfo_1_1Fill.php#a9b71ed5e0774d05f1e3037ebdf268c89">cnt</a>++;
<a name="l00342"></a>00342     }
<a name="l00343"></a>00343     
<a name="l00344"></a>00344   <span class="keyword">private</span>:
<a name="l00345"></a><a class="code" href="classBoundaryInfo_1_1Fill.php#af8d27388298ec69e30d8f44edcf0474c">00345</a>     std::map&lt;short int, unsigned int&gt;&amp; <a class="code" href="classBoundaryInfo_1_1Fill.php#af8d27388298ec69e30d8f44edcf0474c">id_map</a>;
<a name="l00346"></a><a class="code" href="classBoundaryInfo_1_1Fill.php#a9b71ed5e0774d05f1e3037ebdf268c89">00346</a>     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classBoundaryInfo_1_1Fill.php#a9b71ed5e0774d05f1e3037ebdf268c89">cnt</a>;
<a name="l00347"></a>00347   };
<a name="l00348"></a>00348   
<a name="l00349"></a>00349 };
<a name="l00350"></a>00350 
<a name="l00351"></a>00351 
<a name="l00352"></a>00352 
<a name="l00353"></a>00353 
<a name="l00354"></a>00354 
<a name="l00355"></a>00355 
<a name="l00356"></a>00356 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00357"></a>00357 <span class="comment">// BoundaryInfo inline methods</span>
<a name="l00358"></a>00358 <span class="keyword">inline</span>
<a name="l00359"></a><a class="code" href="classBoundaryInfo.php#a04ff8d475a1084942f5da52cc301354e">00359</a> <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#a04ff8d475a1084942f5da52cc301354e">BoundaryInfo::remove</a> (<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node)
<a name="l00360"></a>00360 {
<a name="l00361"></a>00361   libmesh_assert (node != NULL);
<a name="l00362"></a>00362   
<a name="l00363"></a>00363   <span class="comment">// Erase everything associated with node</span>
<a name="l00364"></a>00364   <a class="code" href="classBoundaryInfo.php#ab084520a55072f62c9acc7ca6afe420b">_boundary_node_id</a>.erase (node);
<a name="l00365"></a>00365 }
<a name="l00366"></a>00366 
<a name="l00367"></a>00367 
<a name="l00368"></a>00368 
<a name="l00369"></a>00369 <span class="keyword">inline</span>
<a name="l00370"></a><a class="code" href="classBoundaryInfo.php#a4b6d7a7398dffc429e0373c17d6218aa">00370</a> <span class="keywordtype">void</span> <a class="code" href="classBoundaryInfo.php#a04ff8d475a1084942f5da52cc301354e">BoundaryInfo::remove</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem)
<a name="l00371"></a>00371 {
<a name="l00372"></a>00372   libmesh_assert (elem != NULL);
<a name="l00373"></a>00373   
<a name="l00374"></a>00374   <span class="comment">// Erase everything associated with elem</span>
<a name="l00375"></a>00375   <a class="code" href="classBoundaryInfo.php#abe21d186f6740639a6728b3ea1efb8d9">_boundary_side_id</a>.erase (elem);
<a name="l00376"></a>00376 }
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
