<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1665b3ccb6c776ec6797fe204e2359e5.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>cell_hex20.C</h1>  </div>
</div>
<div class="contents">
<a href="cell__hex20_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_hex20.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;side.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;cell_hex20.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;edge_edge3.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;face_quad8.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00032"></a>00032 <span class="comment">// Hex20 class static member initializations</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classHex20.php#acce8123ed3728d1395c63f3ce727b121">Hex20::side_nodes_map</a>[6][8] =
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036   {0, 3, 2, 1, 11, 10,  9,  8}, <span class="comment">// Side 0</span>
<a name="l00037"></a>00037   {0, 1, 5, 4,  8, 13, 16, 12}, <span class="comment">// Side 1</span>
<a name="l00038"></a>00038   {1, 2, 6, 5,  9, 14, 17, 13}, <span class="comment">// Side 2</span>
<a name="l00039"></a>00039   {2, 3, 7, 6, 10, 15, 18, 14}, <span class="comment">// Side 3</span>
<a name="l00040"></a>00040   {3, 0, 4, 7, 11, 12, 19, 15}, <span class="comment">// Side 4</span>
<a name="l00041"></a>00041   {4, 5, 6, 7, 16, 17, 18, 19}  <span class="comment">// Side 5</span>
<a name="l00042"></a>00042 };
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classHex20.php#a8a916f7e011c1e16881e44233bf41a3b">Hex20::edge_nodes_map</a>[12][3] =
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046   {0, 1, 8},  <span class="comment">// Side 0</span>
<a name="l00047"></a>00047   {1, 2, 9},  <span class="comment">// Side 1</span>
<a name="l00048"></a>00048   {2, 3, 10}, <span class="comment">// Side 2</span>
<a name="l00049"></a>00049   {0, 3, 11}, <span class="comment">// Side 3</span>
<a name="l00050"></a>00050   {0, 4, 12}, <span class="comment">// Side 4</span>
<a name="l00051"></a>00051   {1, 5, 13}, <span class="comment">// Side 5</span>
<a name="l00052"></a>00052   {2, 6, 14}, <span class="comment">// Side 6</span>
<a name="l00053"></a>00053   {3, 7, 15}, <span class="comment">// Side 7</span>
<a name="l00054"></a>00054   {4, 5, 16}, <span class="comment">// Side 8</span>
<a name="l00055"></a>00055   {5, 6, 17}, <span class="comment">// Side 9</span>
<a name="l00056"></a>00056   {6, 7, 18}, <span class="comment">// Side 10</span>
<a name="l00057"></a>00057   {4, 7, 19}  <span class="comment">// Side 11</span>
<a name="l00058"></a>00058 };
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00063"></a>00063 <span class="comment">// Hex20 class member functions</span>
<a name="l00064"></a>00064 
<a name="l00065"></a><a class="code" href="classHex20.php#a60bcd9b21346c9cb8ad38be2ab48765e">00065</a> <span class="keywordtype">bool</span> <a class="code" href="classHex20.php#a60bcd9b21346c9cb8ad38be2ab48765e">Hex20::is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00066"></a>00066 <span class="keyword"></span>{
<a name="l00067"></a>00067   <span class="keywordflow">if</span> (i &lt; 8)
<a name="l00068"></a>00068     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00069"></a>00069   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00070"></a>00070 }
<a name="l00071"></a>00071 
<a name="l00072"></a><a class="code" href="classHex20.php#a7a63a86187a43a94f5d98b3196086e54">00072</a> <span class="keywordtype">bool</span> <a class="code" href="classHex20.php#a7a63a86187a43a94f5d98b3196086e54">Hex20::is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00073"></a>00073 <span class="keyword"></span>{
<a name="l00074"></a>00074   <span class="keywordflow">if</span> (i &gt; 7)
<a name="l00075"></a>00075     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00076"></a>00076   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00077"></a>00077 }
<a name="l00078"></a>00078 
<a name="l00079"></a><a class="code" href="classHex20.php#ab9f2067fecae18d64b9f25228805f719">00079</a> <span class="keywordtype">bool</span> <a class="code" href="classHex20.php#ab9f2067fecae18d64b9f25228805f719">Hex20::is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00080"></a>00080 <span class="keyword"></span>{
<a name="l00081"></a>00081   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00082"></a>00082 }
<a name="l00083"></a>00083 
<a name="l00084"></a><a class="code" href="classHex20.php#a78e1c69d53190d56ab024ec20accaf91">00084</a> <span class="keywordtype">bool</span> <a class="code" href="classHex20.php#a78e1c69d53190d56ab024ec20accaf91">Hex20::is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00085"></a>00085                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00086"></a>00086 <span class="keyword"></span>{
<a name="l00087"></a>00087   libmesh_assert(s &lt; <a class="code" href="classHex.php#add801d90fe993236069c69ee46003731">n_sides</a>());
<a name="l00088"></a>00088   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 8; ++i)
<a name="l00089"></a>00089     <span class="keywordflow">if</span> (<a class="code" href="classHex20.php#acce8123ed3728d1395c63f3ce727b121">side_nodes_map</a>[s][i] == n)
<a name="l00090"></a>00090       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00091"></a>00091   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00092"></a>00092 }
<a name="l00093"></a>00093 
<a name="l00094"></a><a class="code" href="classHex20.php#af7c2e735a7a5181a4119ffc3dad76df4">00094</a> <span class="keywordtype">bool</span> <a class="code" href="classHex20.php#af7c2e735a7a5181a4119ffc3dad76df4">Hex20::is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00095"></a>00095                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00096"></a>00096 <span class="keyword"></span>{
<a name="l00097"></a>00097   libmesh_assert(e &lt; <a class="code" href="classHex.php#a571b4b2f2a63a14f2017009bb16ba32b">n_edges</a>());
<a name="l00098"></a>00098   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 3; ++i)
<a name="l00099"></a>00099     <span class="keywordflow">if</span> (<a class="code" href="classHex20.php#a8a916f7e011c1e16881e44233bf41a3b">edge_nodes_map</a>[e][i] == n)
<a name="l00100"></a>00100       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00101"></a>00101   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00102"></a>00102 }
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a><a class="code" href="classHex20.php#a305af78157ea4f7986208b34a996e2be">00106</a> <span class="keywordtype">bool</span> <a class="code" href="classHex20.php#a305af78157ea4f7986208b34a996e2be">Hex20::has_affine_map</a>()<span class="keyword"> const</span>
<a name="l00107"></a>00107 <span class="keyword"></span>{
<a name="l00108"></a>00108   <span class="comment">// Make sure x-edge endpoints are affine</span>
<a name="l00109"></a>00109   <a class="code" href="classPoint.php">Point</a> v = this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0);
<a name="l00110"></a>00110   <span class="keywordflow">if</span> (!v.<a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">relative_fuzzy_equals</a>(this-&gt;point(2) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3)) ||
<a name="l00111"></a>00111       !v.<a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">relative_fuzzy_equals</a>(this-&gt;point(5) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(4)) ||
<a name="l00112"></a>00112       !v.<a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">relative_fuzzy_equals</a>(this-&gt;point(6) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(7)))
<a name="l00113"></a>00113     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00114"></a>00114   <span class="comment">// Make sure x-edges are straight</span>
<a name="l00115"></a>00115   v /= 2;
<a name="l00116"></a>00116   <span class="keywordflow">if</span> (!v.<a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">relative_fuzzy_equals</a>(this-&gt;point(8) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0)) ||
<a name="l00117"></a>00117       !v.<a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">relative_fuzzy_equals</a>(this-&gt;point(10) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3)) ||
<a name="l00118"></a>00118       !v.<a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">relative_fuzzy_equals</a>(this-&gt;point(16) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(4)) ||
<a name="l00119"></a>00119       !v.<a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">relative_fuzzy_equals</a>(this-&gt;point(18) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(7)))
<a name="l00120"></a>00120     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00121"></a>00121   <span class="comment">// Make sure xz-faces are identical parallelograms</span>
<a name="l00122"></a>00122   v = this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(4) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0);
<a name="l00123"></a>00123   <span class="keywordflow">if</span> (!v.<a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">relative_fuzzy_equals</a>(this-&gt;point(7) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3)))
<a name="l00124"></a>00124     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00125"></a>00125   v /= 2;
<a name="l00126"></a>00126   <span class="keywordflow">if</span> (!v.<a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">relative_fuzzy_equals</a>(this-&gt;point(12) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0)) ||
<a name="l00127"></a>00127       !v.<a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">relative_fuzzy_equals</a>(this-&gt;point(13) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1)) ||
<a name="l00128"></a>00128       !v.<a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">relative_fuzzy_equals</a>(this-&gt;point(14) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2)) ||
<a name="l00129"></a>00129       !v.<a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">relative_fuzzy_equals</a>(this-&gt;point(15) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3)))
<a name="l00130"></a>00130     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00131"></a>00131   <span class="comment">// Make sure y-edges are straight</span>
<a name="l00132"></a>00132   v = (this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0))/2;
<a name="l00133"></a>00133   <span class="keywordflow">if</span> (!v.<a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">relative_fuzzy_equals</a>(this-&gt;point(11) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0)) ||
<a name="l00134"></a>00134       !v.<a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">relative_fuzzy_equals</a>(this-&gt;point(9) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1)) ||
<a name="l00135"></a>00135       !v.<a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">relative_fuzzy_equals</a>(this-&gt;point(17) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(5)) ||
<a name="l00136"></a>00136       !v.<a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">relative_fuzzy_equals</a>(this-&gt;point(19) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(4)))
<a name="l00137"></a>00137     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00138"></a>00138   <span class="comment">// If all the above checks out, the map is affine</span>
<a name="l00139"></a>00139   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00140"></a>00140 }
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a><a class="code" href="classHex20.php#a78d97d503a229b1645fc36affb7becb0">00144</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classHex20.php#a78d97d503a229b1645fc36affb7becb0">Hex20::build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00145"></a>00145                                  <span class="keywordtype">bool</span> proxy )<span class="keyword"> const</span>
<a name="l00146"></a>00146 <span class="keyword"></span>{
<a name="l00147"></a>00147   libmesh_assert (i &lt; this-&gt;<a class="code" href="classHex.php#add801d90fe993236069c69ee46003731">n_sides</a>());
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   <span class="keywordflow">if</span> (proxy)
<a name="l00150"></a>00150     {
<a name="l00151"></a>00151       <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classSide.php">Side&lt;Quad8,Hex20&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00152"></a>00152       <span class="keywordflow">return</span> ap;
<a name="l00153"></a>00153     }
<a name="l00154"></a>00154 
<a name="l00155"></a>00155   <span class="keywordflow">else</span>
<a name="l00156"></a>00156     {
<a name="l00157"></a>00157       <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classQuad8.php">Quad8</a>);
<a name="l00158"></a>00158 
<a name="l00159"></a>00159       <span class="comment">// Think of a unit cube: (-1,1) x (-1,1)x (1,1)</span>
<a name="l00160"></a>00160       <span class="keywordflow">switch</span> (i)
<a name="l00161"></a>00161         {
<a name="l00162"></a>00162         <span class="keywordflow">case</span> 0:  <span class="comment">// the face at z=0</span>
<a name="l00163"></a>00163           {
<a name="l00164"></a>00164             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00165"></a>00165             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00166"></a>00166             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00167"></a>00167             face-&gt;set_node(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00168"></a>00168             face-&gt;set_node(4) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(11);
<a name="l00169"></a>00169             face-&gt;set_node(5) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(10);
<a name="l00170"></a>00170             face-&gt;set_node(6) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(9);
<a name="l00171"></a>00171             face-&gt;set_node(7) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(8);
<a name="l00172"></a>00172 
<a name="l00173"></a>00173             <span class="keywordflow">return</span> face;
<a name="l00174"></a>00174           }
<a name="l00175"></a>00175         <span class="keywordflow">case</span> 1:  <span class="comment">// the face at y = 0</span>
<a name="l00176"></a>00176           {
<a name="l00177"></a>00177             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00178"></a>00178             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00179"></a>00179             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(5);
<a name="l00180"></a>00180             face-&gt;set_node(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(4);
<a name="l00181"></a>00181             face-&gt;set_node(4) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(8);
<a name="l00182"></a>00182             face-&gt;set_node(5) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(13);
<a name="l00183"></a>00183             face-&gt;set_node(6) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(16);
<a name="l00184"></a>00184             face-&gt;set_node(7) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(12);
<a name="l00185"></a>00185 
<a name="l00186"></a>00186             <span class="keywordflow">return</span> face;
<a name="l00187"></a>00187           }
<a name="l00188"></a>00188         <span class="keywordflow">case</span> 2:  <span class="comment">// the face at x=1</span>
<a name="l00189"></a>00189           {
<a name="l00190"></a>00190             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00191"></a>00191             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00192"></a>00192             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(6);
<a name="l00193"></a>00193             face-&gt;set_node(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(5);
<a name="l00194"></a>00194             face-&gt;set_node(4) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(9);
<a name="l00195"></a>00195             face-&gt;set_node(5) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(14);
<a name="l00196"></a>00196             face-&gt;set_node(6) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(17);
<a name="l00197"></a>00197             face-&gt;set_node(7) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(13);
<a name="l00198"></a>00198 
<a name="l00199"></a>00199             <span class="keywordflow">return</span> face;
<a name="l00200"></a>00200           }
<a name="l00201"></a>00201         <span class="keywordflow">case</span> 3: <span class="comment">// the face at y=1</span>
<a name="l00202"></a>00202           {
<a name="l00203"></a>00203             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00204"></a>00204             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00205"></a>00205             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(7);
<a name="l00206"></a>00206             face-&gt;set_node(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(6);
<a name="l00207"></a>00207             face-&gt;set_node(4) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(10);
<a name="l00208"></a>00208             face-&gt;set_node(5) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(15);
<a name="l00209"></a>00209             face-&gt;set_node(6) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(18);
<a name="l00210"></a>00210             face-&gt;set_node(7) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(14);
<a name="l00211"></a>00211 
<a name="l00212"></a>00212             <span class="keywordflow">return</span> face;
<a name="l00213"></a>00213           }
<a name="l00214"></a>00214         <span class="keywordflow">case</span> 4: <span class="comment">// the face at x=0</span>
<a name="l00215"></a>00215           {
<a name="l00216"></a>00216             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00217"></a>00217             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00218"></a>00218             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(4);
<a name="l00219"></a>00219             face-&gt;set_node(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(7);
<a name="l00220"></a>00220             face-&gt;set_node(4) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(11);
<a name="l00221"></a>00221             face-&gt;set_node(5) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(12);
<a name="l00222"></a>00222             face-&gt;set_node(6) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(19);
<a name="l00223"></a>00223             face-&gt;set_node(7) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(15);
<a name="l00224"></a>00224 
<a name="l00225"></a>00225             <span class="keywordflow">return</span> face;
<a name="l00226"></a>00226           }
<a name="l00227"></a>00227         <span class="keywordflow">case</span> 5: <span class="comment">// the face at z=1</span>
<a name="l00228"></a>00228           {
<a name="l00229"></a>00229             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(4);
<a name="l00230"></a>00230             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(5);
<a name="l00231"></a>00231             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(6);
<a name="l00232"></a>00232             face-&gt;set_node(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(7);
<a name="l00233"></a>00233             face-&gt;set_node(4) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(16);
<a name="l00234"></a>00234             face-&gt;set_node(5) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(17);
<a name="l00235"></a>00235             face-&gt;set_node(6) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(18);
<a name="l00236"></a>00236             face-&gt;set_node(7) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(19);
<a name="l00237"></a>00237 
<a name="l00238"></a>00238             <span class="keywordflow">return</span> face;
<a name="l00239"></a>00239           }
<a name="l00240"></a>00240         <span class="keywordflow">default</span>:
<a name="l00241"></a>00241           {
<a name="l00242"></a>00242             libmesh_error();
<a name="l00243"></a>00243             <span class="keywordflow">return</span> face;
<a name="l00244"></a>00244           }
<a name="l00245"></a>00245         }
<a name="l00246"></a>00246     }
<a name="l00247"></a>00247   
<a name="l00248"></a>00248   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00249"></a>00249   libmesh_error();
<a name="l00250"></a>00250   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00251"></a>00251 }
<a name="l00252"></a>00252 
<a name="l00253"></a>00253 
<a name="l00254"></a>00254 
<a name="l00255"></a><a class="code" href="classHex20.php#a34de07c6160bb22ece10837bb426345e">00255</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classHex20.php#a34de07c6160bb22ece10837bb426345e">Hex20::build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00256"></a>00256 <span class="keyword"></span>{
<a name="l00257"></a>00257   libmesh_assert (i &lt; this-&gt;<a class="code" href="classHex.php#a571b4b2f2a63a14f2017009bb16ba32b">n_edges</a>());
<a name="l00258"></a>00258 
<a name="l00259"></a>00259   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classSideEdge.php">SideEdge&lt;Edge3,Hex20&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00260"></a>00260   <span class="keywordflow">return</span> ap;
<a name="l00261"></a>00261 }
<a name="l00262"></a>00262 
<a name="l00263"></a>00263 
<a name="l00264"></a>00264 
<a name="l00265"></a><a class="code" href="classHex20.php#a75063d4af2427f047e0470f957efe635">00265</a> <span class="keywordtype">void</span> <a class="code" href="classHex20.php#a75063d4af2427f047e0470f957efe635">Hex20::connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00266"></a>00266                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00267"></a>00267                          std::vector&lt;unsigned int&gt;&amp; conn)<span class="keyword"> const</span>
<a name="l00268"></a>00268 <span class="keyword"></span>{
<a name="l00269"></a>00269   libmesh_assert (<a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a> != NULL);
<a name="l00270"></a>00270   libmesh_assert (sc &lt; this-&gt;<a class="code" href="classHex20.php#a4198e276f1482ff0f5307aef23c00993">n_sub_elem</a>());
<a name="l00271"></a>00271   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00272"></a>00272 
<a name="l00273"></a>00273   
<a name="l00274"></a>00274   <span class="keywordflow">switch</span> (iop)
<a name="l00275"></a>00275     {
<a name="l00276"></a>00276     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00277"></a>00277       {
<a name="l00278"></a>00278         <span class="keywordflow">switch</span> (sc)
<a name="l00279"></a>00279           {
<a name="l00280"></a>00280           <span class="keywordflow">case</span> 0:
<a name="l00281"></a>00281             conn.resize(8);
<a name="l00282"></a>00282             conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0)+1;
<a name="l00283"></a>00283             conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1)+1;
<a name="l00284"></a>00284             conn[2] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2)+1;
<a name="l00285"></a>00285             conn[3] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3)+1;
<a name="l00286"></a>00286             conn[4] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(4)+1;
<a name="l00287"></a>00287             conn[5] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(5)+1;
<a name="l00288"></a>00288             conn[6] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(6)+1;
<a name="l00289"></a>00289             conn[7] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(7)+1;
<a name="l00290"></a>00290 
<a name="l00291"></a>00291             <span class="keywordflow">return</span>;
<a name="l00292"></a>00292       
<a name="l00293"></a>00293           <span class="keywordflow">default</span>:
<a name="l00294"></a>00294             libmesh_error();
<a name="l00295"></a>00295           }
<a name="l00296"></a>00296       }
<a name="l00297"></a>00297 
<a name="l00298"></a>00298     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa1affb8987f83b5e4acb22d9401dd44ef">VTK</a>:
<a name="l00299"></a>00299       {
<a name="l00300"></a>00300         <span class="keywordflow">switch</span> (sc)
<a name="l00301"></a>00301           {
<a name="l00302"></a>00302           <span class="keywordflow">case</span> 0:
<a name="l00303"></a>00303             conn.resize(20);
<a name="l00304"></a>00304             conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0);
<a name="l00305"></a>00305             conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1);
<a name="l00306"></a>00306             conn[2] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2);
<a name="l00307"></a>00307             conn[3] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3);
<a name="l00308"></a>00308             conn[4] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(4);
<a name="l00309"></a>00309             conn[5] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(5);
<a name="l00310"></a>00310             conn[6] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(6);
<a name="l00311"></a>00311             conn[7] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(7);
<a name="l00312"></a>00312             conn[8] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(8);
<a name="l00313"></a>00313             conn[9] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(9);
<a name="l00314"></a>00314             conn[10] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(10);
<a name="l00315"></a>00315             conn[11] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(11);
<a name="l00316"></a>00316             conn[12] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(16);
<a name="l00317"></a>00317             conn[13] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(17);
<a name="l00318"></a>00318             conn[14] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(18);
<a name="l00319"></a>00319             conn[15] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(19);
<a name="l00320"></a>00320             conn[16] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(12);
<a name="l00321"></a>00321             conn[17] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(13);
<a name="l00322"></a>00322             conn[18] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(14);
<a name="l00323"></a>00323             conn[19] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(15);
<a name="l00324"></a>00324             <span class="keywordflow">return</span>;
<a name="l00325"></a>00325             
<a name="l00326"></a>00326           <span class="keywordflow">default</span>:
<a name="l00327"></a>00327             libmesh_error();
<a name="l00328"></a>00328           }
<a name="l00329"></a>00329       }
<a name="l00330"></a>00330       
<a name="l00331"></a>00331     <span class="keywordflow">default</span>:
<a name="l00332"></a>00332       libmesh_error();
<a name="l00333"></a>00333     }
<a name="l00334"></a>00334 
<a name="l00335"></a>00335   libmesh_error();
<a name="l00336"></a>00336 }
<a name="l00337"></a>00337 
<a name="l00338"></a>00338 
<a name="l00339"></a>00339 
<a name="l00340"></a>00340 
<a name="l00341"></a><a class="code" href="classHex20.php#acd6d65daa161f21ec0bd54030156c5ab">00341</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classHex20.php#acd6d65daa161f21ec0bd54030156c5ab">Hex20::second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00342"></a>00342                                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v)<span class="keyword"> const</span>
<a name="l00343"></a>00343 <span class="keyword"></span>{ 
<a name="l00344"></a>00344   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classHex.php#aa814798ab64aa2001cf35277016619c0">n_vertices</a>());
<a name="l00345"></a>00345   libmesh_assert (n &lt;  this-&gt;<a class="code" href="classHex20.php#acd6d2aa06805ea8b0dc568f710684a7b">n_nodes</a>());
<a name="l00346"></a>00346   libmesh_assert (v &lt; 2);
<a name="l00347"></a>00347   <span class="comment">/*</span>
<a name="l00348"></a>00348 <span class="comment">   * the _second_order_adjacent_vertices matrix is</span>
<a name="l00349"></a>00349 <span class="comment">   * stored in cell_hex.C, since this matrix is identical</span>
<a name="l00350"></a>00350 <span class="comment">   * for Hex20 and Hex27 (for the first 12 higher-order nodes)</span>
<a name="l00351"></a>00351 <span class="comment">   */</span>
<a name="l00352"></a>00352   <span class="keywordflow">return</span> <a class="code" href="classHex.php#ae4a983049fc2584356208c65d11b20f5">_second_order_adjacent_vertices</a>[n-this-&gt;<a class="code" href="classHex.php#aa814798ab64aa2001cf35277016619c0">n_vertices</a>()][v]; 
<a name="l00353"></a>00353 }
<a name="l00354"></a>00354 
<a name="l00355"></a>00355 
<a name="l00356"></a>00356 
<a name="l00357"></a>00357 std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00358"></a><a class="code" href="classHex20.php#a63c5839547fe9b1c8671b5722f51a75d">00358</a> <a class="code" href="classHex20.php#a63c5839547fe9b1c8671b5722f51a75d">Hex20::second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00359"></a>00359 <span class="keyword"></span>{
<a name="l00360"></a>00360   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classHex.php#aa814798ab64aa2001cf35277016619c0">n_vertices</a>());
<a name="l00361"></a>00361   libmesh_assert (n &lt; this-&gt;<a class="code" href="classHex20.php#acd6d2aa06805ea8b0dc568f710684a7b">n_nodes</a>());
<a name="l00362"></a>00362   <span class="comment">/*</span>
<a name="l00363"></a>00363 <span class="comment">   * the _second_order_vertex_child_* vectors are</span>
<a name="l00364"></a>00364 <span class="comment">   * stored in cell_hex.C, since they are identical</span>
<a name="l00365"></a>00365 <span class="comment">   * for Hex20 and Hex27 (for the first 12 higher-order nodes)</span>
<a name="l00366"></a>00366 <span class="comment">   */</span>
<a name="l00367"></a>00367   <span class="keywordflow">return</span> std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00368"></a>00368     (<a class="code" href="classHex.php#a720e4b95cc878516fef569c1dc856d82">_second_order_vertex_child_number</a>[n],
<a name="l00369"></a>00369      <a class="code" href="classHex.php#afdb88b84b0a7f31864786b3a3f8d7969">_second_order_vertex_child_index</a>[n]);
<a name="l00370"></a>00370 }
<a name="l00371"></a>00371 
<a name="l00372"></a>00372 
<a name="l00373"></a>00373 
<a name="l00374"></a>00374 
<a name="l00375"></a>00375 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00376"></a>00376 <span class="preprocessor"></span>
<a name="l00377"></a>00377 <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classHex20.php#a69cb7b61ce280019ba83413d1e4a9b58">Hex20::_embedding_matrix</a>[8][20][20] =
<a name="l00378"></a>00378 {
<a name="l00379"></a>00379   <span class="comment">// embedding matrix for child 0</span>
<a name="l00380"></a>00380   {
<a name="l00381"></a>00381     <span class="comment">//  0     1     2     3     4     5     6     7    8  9  10 11  12  13  14  15  16  17  18  19</span>
<a name="l00382"></a>00382     {    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 0</span>
<a name="l00383"></a>00383     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 1</span>
<a name="l00384"></a>00384     {  -0.250000,  -0.250000,  -0.250000,  -0.250000,    0.00000,    0.00000,    0.00000,    0.00000,   0.500000,   0.500000,   0.500000,   0.500000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 2</span>
<a name="l00385"></a>00385     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 3</span>
<a name="l00386"></a>00386     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 4</span>
<a name="l00387"></a>00387     {  -0.250000,  -0.250000,    0.00000,    0.00000,  -0.250000,  -0.250000,    0.00000,    0.00000,   0.500000,    0.00000,    0.00000,    0.00000,   0.500000,   0.500000,    0.00000,    0.00000,   0.500000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 5</span>
<a name="l00388"></a>00388     {  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000 }, <span class="comment">// 6</span>
<a name="l00389"></a>00389     {  -0.250000,    0.00000,    0.00000,  -0.250000,  -0.250000,    0.00000,    0.00000,  -0.250000,    0.00000,    0.00000,    0.00000,   0.500000,   0.500000,    0.00000,    0.00000,   0.500000,    0.00000,    0.00000,    0.00000,   0.500000 }, <span class="comment">// 7</span>
<a name="l00390"></a>00390     {   0.375000,  -0.125000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 8</span>
<a name="l00391"></a>00391     {  -0.187500,  -0.187500,  -0.187500,  -0.187500,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,   0.375000,   0.250000,   0.375000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 9</span>
<a name="l00392"></a>00392     {  -0.187500,  -0.187500,  -0.187500,  -0.187500,    0.00000,    0.00000,    0.00000,    0.00000,   0.375000,   0.250000,   0.375000,   0.750000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 10</span>
<a name="l00393"></a>00393     {   0.375000,    0.00000,    0.00000,  -0.125000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 11</span>
<a name="l00394"></a>00394     {   0.375000,    0.00000,    0.00000,    0.00000,  -0.125000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 12</span>
<a name="l00395"></a>00395     {  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,   0.375000,   0.375000,    0.00000,    0.00000,   0.250000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 13</span>
<a name="l00396"></a>00396     {  -0.281250,  -0.281250,  -0.281250,  -0.281250,  -0.156250,  -0.156250,  -0.156250,  -0.156250,   0.375000,   0.375000,   0.375000,   0.375000,   0.187500,   0.187500,   0.187500,   0.187500,   0.125000,   0.125000,   0.125000,   0.125000 }, <span class="comment">// 14</span>
<a name="l00397"></a>00397     {  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,    0.00000,    0.00000,    0.00000,   0.750000,   0.375000,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,   0.250000 }, <span class="comment">// 15</span>
<a name="l00398"></a>00398     {  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,   0.750000,   0.250000,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 16</span>
<a name="l00399"></a>00399     {  -0.281250,  -0.281250,  -0.156250,  -0.156250,  -0.281250,  -0.281250,  -0.156250,  -0.156250,   0.375000,   0.187500,   0.125000,   0.187500,   0.375000,   0.375000,   0.125000,   0.125000,   0.375000,   0.187500,   0.125000,   0.187500 }, <span class="comment">// 17</span>
<a name="l00400"></a>00400     {  -0.281250,  -0.156250,  -0.156250,  -0.281250,  -0.281250,  -0.156250,  -0.156250,  -0.281250,   0.187500,   0.125000,   0.187500,   0.375000,   0.375000,   0.125000,   0.125000,   0.375000,   0.187500,   0.125000,   0.187500,   0.375000 }, <span class="comment">// 18</span>
<a name="l00401"></a>00401     {  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,    0.00000,    0.00000,    0.00000,   0.375000,   0.750000,    0.00000,    0.00000,   0.250000,    0.00000,    0.00000,    0.00000,   0.375000 }  <span class="comment">// 19</span>
<a name="l00402"></a>00402   },
<a name="l00403"></a>00403 
<a name="l00404"></a>00404   <span class="comment">// embedding matrix for child 1</span>
<a name="l00405"></a>00405   {
<a name="l00406"></a>00406     <span class="comment">//  0     1     2     3     4     5     6     7    8  9  11  12  13  14  15  16  17  18  19</span>
<a name="l00407"></a>00407     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 0</span>
<a name="l00408"></a>00408     {    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 1</span>
<a name="l00409"></a>00409     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 2</span>
<a name="l00410"></a>00410     {  -0.250000,  -0.250000,  -0.250000,  -0.250000,    0.00000,    0.00000,    0.00000,    0.00000,   0.500000,   0.500000,   0.500000,   0.500000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 3</span>
<a name="l00411"></a>00411     {  -0.250000,  -0.250000,    0.00000,    0.00000,  -0.250000,  -0.250000,    0.00000,    0.00000,   0.500000,    0.00000,    0.00000,    0.00000,   0.500000,   0.500000,    0.00000,    0.00000,   0.500000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 4</span>
<a name="l00412"></a>00412     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 5</span>
<a name="l00413"></a>00413     {    0.00000,  -0.250000,  -0.250000,    0.00000,    0.00000,  -0.250000,  -0.250000,    0.00000,    0.00000,   0.500000,    0.00000,    0.00000,    0.00000,   0.500000,   0.500000,    0.00000,    0.00000,   0.500000,    0.00000,    0.00000 }, <span class="comment">// 6</span>
<a name="l00414"></a>00414     {  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000 }, <span class="comment">// 7</span>
<a name="l00415"></a>00415     {  -0.125000,   0.375000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 8</span>
<a name="l00416"></a>00416     {    0.00000,   0.375000,  -0.125000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 9</span>
<a name="l00417"></a>00417     {  -0.187500,  -0.187500,  -0.187500,  -0.187500,    0.00000,    0.00000,    0.00000,    0.00000,   0.375000,   0.750000,   0.375000,   0.250000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 10</span>
<a name="l00418"></a>00418     {  -0.187500,  -0.187500,  -0.187500,  -0.187500,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,   0.375000,   0.250000,   0.375000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 11</span>
<a name="l00419"></a>00419     {  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,   0.375000,   0.375000,    0.00000,    0.00000,   0.250000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 12</span>
<a name="l00420"></a>00420     {    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,  -0.125000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 13</span>
<a name="l00421"></a>00421     {    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,   0.375000,   0.375000,    0.00000,    0.00000,   0.250000,    0.00000,    0.00000 }, <span class="comment">// 14</span>
<a name="l00422"></a>00422     {  -0.281250,  -0.281250,  -0.281250,  -0.281250,  -0.156250,  -0.156250,  -0.156250,  -0.156250,   0.375000,   0.375000,   0.375000,   0.375000,   0.187500,   0.187500,   0.187500,   0.187500,   0.125000,   0.125000,   0.125000,   0.125000 }, <span class="comment">// 15</span>
<a name="l00423"></a>00423     {  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,   0.250000,   0.750000,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 16</span>
<a name="l00424"></a>00424     {    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,   0.750000,   0.250000,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000 }, <span class="comment">// 17</span>
<a name="l00425"></a>00425     {  -0.156250,  -0.281250,  -0.281250,  -0.156250,  -0.156250,  -0.281250,  -0.281250,  -0.156250,   0.187500,   0.375000,   0.187500,   0.125000,   0.125000,   0.375000,   0.375000,   0.125000,   0.187500,   0.375000,   0.187500,   0.125000 }, <span class="comment">// 18</span>
<a name="l00426"></a>00426     {  -0.281250,  -0.281250,  -0.156250,  -0.156250,  -0.281250,  -0.281250,  -0.156250,  -0.156250,   0.375000,   0.187500,   0.125000,   0.187500,   0.375000,   0.375000,   0.125000,   0.125000,   0.375000,   0.187500,   0.125000,   0.187500 }  <span class="comment">// 19</span>
<a name="l00427"></a>00427   },
<a name="l00428"></a>00428 
<a name="l00429"></a>00429   <span class="comment">// embedding matrix for child 2</span>
<a name="l00430"></a>00430   {
<a name="l00431"></a>00431     <span class="comment">//  0     1     2     3     4     5     6     7    8  9  11  12  13  14  15  16  17  18  19</span>
<a name="l00432"></a>00432     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 0</span>
<a name="l00433"></a>00433     {  -0.250000,  -0.250000,  -0.250000,  -0.250000,    0.00000,    0.00000,    0.00000,    0.00000,   0.500000,   0.500000,   0.500000,   0.500000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 1</span>
<a name="l00434"></a>00434     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 2</span>
<a name="l00435"></a>00435     {    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 3</span>
<a name="l00436"></a>00436     {  -0.250000,    0.00000,    0.00000,  -0.250000,  -0.250000,    0.00000,    0.00000,  -0.250000,    0.00000,    0.00000,    0.00000,   0.500000,   0.500000,    0.00000,    0.00000,   0.500000,    0.00000,    0.00000,    0.00000,   0.500000 }, <span class="comment">// 4</span>
<a name="l00437"></a>00437     {  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000 }, <span class="comment">// 5</span>
<a name="l00438"></a>00438     {    0.00000,    0.00000,  -0.250000,  -0.250000,    0.00000,    0.00000,  -0.250000,  -0.250000,    0.00000,    0.00000,   0.500000,    0.00000,    0.00000,    0.00000,   0.500000,   0.500000,    0.00000,    0.00000,   0.500000,    0.00000 }, <span class="comment">// 6</span>
<a name="l00439"></a>00439     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 7</span>
<a name="l00440"></a>00440     {  -0.187500,  -0.187500,  -0.187500,  -0.187500,    0.00000,    0.00000,    0.00000,    0.00000,   0.375000,   0.250000,   0.375000,   0.750000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 8</span>
<a name="l00441"></a>00441     {  -0.187500,  -0.187500,  -0.187500,  -0.187500,    0.00000,    0.00000,    0.00000,    0.00000,   0.250000,   0.375000,   0.750000,   0.375000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 9</span>
<a name="l00442"></a>00442     {    0.00000,    0.00000,  -0.125000,   0.375000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 10</span>
<a name="l00443"></a>00443     {  -0.125000,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 11</span>
<a name="l00444"></a>00444     {  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,    0.00000,    0.00000,    0.00000,   0.750000,   0.375000,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,   0.250000 }, <span class="comment">// 12</span>
<a name="l00445"></a>00445     {  -0.281250,  -0.281250,  -0.281250,  -0.281250,  -0.156250,  -0.156250,  -0.156250,  -0.156250,   0.375000,   0.375000,   0.375000,   0.375000,   0.187500,   0.187500,   0.187500,   0.187500,   0.125000,   0.125000,   0.125000,   0.125000 }, <span class="comment">// 13</span>
<a name="l00446"></a>00446     {    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,   0.375000,   0.375000,    0.00000,    0.00000,   0.250000,    0.00000 }, <span class="comment">// 14</span>
<a name="l00447"></a>00447     {    0.00000,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,  -0.125000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 15</span>
<a name="l00448"></a>00448     {  -0.281250,  -0.156250,  -0.156250,  -0.281250,  -0.281250,  -0.156250,  -0.156250,  -0.281250,   0.187500,   0.125000,   0.187500,   0.375000,   0.375000,   0.125000,   0.125000,   0.375000,   0.187500,   0.125000,   0.187500,   0.375000 }, <span class="comment">// 16</span>
<a name="l00449"></a>00449     {  -0.156250,  -0.156250,  -0.281250,  -0.281250,  -0.156250,  -0.156250,  -0.281250,  -0.281250,   0.125000,   0.187500,   0.375000,   0.187500,   0.125000,   0.125000,   0.375000,   0.375000,   0.125000,   0.187500,   0.375000,   0.187500 }, <span class="comment">// 17</span>
<a name="l00450"></a>00450     {    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,   0.250000,   0.750000,    0.00000,    0.00000,   0.375000,    0.00000 }, <span class="comment">// 18</span>
<a name="l00451"></a>00451     {  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,    0.00000,    0.00000,    0.00000,   0.375000,   0.250000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,   0.375000 }  <span class="comment">// 19</span>
<a name="l00452"></a>00452   },
<a name="l00453"></a>00453 
<a name="l00454"></a>00454   <span class="comment">// embedding matrix for child 3</span>
<a name="l00455"></a>00455   {
<a name="l00456"></a>00456     <span class="comment">//  0     1     2     3     4     5     6     7    8  9  11  12  13  14  15  16  17  18  19</span>
<a name="l00457"></a>00457     {  -0.250000,  -0.250000,  -0.250000,  -0.250000,    0.00000,    0.00000,    0.00000,    0.00000,   0.500000,   0.500000,   0.500000,   0.500000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 0</span>
<a name="l00458"></a>00458     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 1</span>
<a name="l00459"></a>00459     {    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 2</span>
<a name="l00460"></a>00460     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 3</span>
<a name="l00461"></a>00461     {  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000 }, <span class="comment">// 4</span>
<a name="l00462"></a>00462     {    0.00000,  -0.250000,  -0.250000,    0.00000,    0.00000,  -0.250000,  -0.250000,    0.00000,    0.00000,   0.500000,    0.00000,    0.00000,    0.00000,   0.500000,   0.500000,    0.00000,    0.00000,   0.500000,    0.00000,    0.00000 }, <span class="comment">// 5</span>
<a name="l00463"></a>00463     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 6</span>
<a name="l00464"></a>00464     {    0.00000,    0.00000,  -0.250000,  -0.250000,    0.00000,    0.00000,  -0.250000,  -0.250000,    0.00000,    0.00000,   0.500000,    0.00000,    0.00000,    0.00000,   0.500000,   0.500000,    0.00000,    0.00000,   0.500000,    0.00000 }, <span class="comment">// 7</span>
<a name="l00465"></a>00465     {  -0.187500,  -0.187500,  -0.187500,  -0.187500,    0.00000,    0.00000,    0.00000,    0.00000,   0.375000,   0.750000,   0.375000,   0.250000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 8</span>
<a name="l00466"></a>00466     {    0.00000,  -0.125000,   0.375000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 9</span>
<a name="l00467"></a>00467     {    0.00000,    0.00000,   0.375000,  -0.125000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 10</span>
<a name="l00468"></a>00468     {  -0.187500,  -0.187500,  -0.187500,  -0.187500,    0.00000,    0.00000,    0.00000,    0.00000,   0.250000,   0.375000,   0.750000,   0.375000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 11</span>
<a name="l00469"></a>00469     {  -0.281250,  -0.281250,  -0.281250,  -0.281250,  -0.156250,  -0.156250,  -0.156250,  -0.156250,   0.375000,   0.375000,   0.375000,   0.375000,   0.187500,   0.187500,   0.187500,   0.187500,   0.125000,   0.125000,   0.125000,   0.125000 }, <span class="comment">// 12</span>
<a name="l00470"></a>00470     {    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,   0.375000,   0.375000,    0.00000,    0.00000,   0.250000,    0.00000,    0.00000 }, <span class="comment">// 13</span>
<a name="l00471"></a>00471     {    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,  -0.125000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 14</span>
<a name="l00472"></a>00472     {    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,   0.375000,   0.375000,    0.00000,    0.00000,   0.250000,    0.00000 }, <span class="comment">// 15</span>
<a name="l00473"></a>00473     {  -0.156250,  -0.281250,  -0.281250,  -0.156250,  -0.156250,  -0.281250,  -0.281250,  -0.156250,   0.187500,   0.375000,   0.187500,   0.125000,   0.125000,   0.375000,   0.375000,   0.125000,   0.187500,   0.375000,   0.187500,   0.125000 }, <span class="comment">// 16</span>
<a name="l00474"></a>00474     {    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,   0.250000,   0.750000,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000 }, <span class="comment">// 17</span>
<a name="l00475"></a>00475     {    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,   0.750000,   0.250000,    0.00000,    0.00000,   0.375000,    0.00000 }, <span class="comment">// 18</span>
<a name="l00476"></a>00476     {  -0.156250,  -0.156250,  -0.281250,  -0.281250,  -0.156250,  -0.156250,  -0.281250,  -0.281250,   0.125000,   0.187500,   0.375000,   0.187500,   0.125000,   0.125000,   0.375000,   0.375000,   0.125000,   0.187500,   0.375000,   0.187500 }  <span class="comment">// 19</span>
<a name="l00477"></a>00477   },
<a name="l00478"></a>00478 
<a name="l00479"></a>00479   <span class="comment">// embedding matrix for child 4</span>
<a name="l00480"></a>00480   {
<a name="l00481"></a>00481     <span class="comment">//  0     1     2     3     4     5     6     7    8  9  11  12  13  14  15  16  17  18  19</span>
<a name="l00482"></a>00482     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 0</span>
<a name="l00483"></a>00483     {  -0.250000,  -0.250000,    0.00000,    0.00000,  -0.250000,  -0.250000,    0.00000,    0.00000,   0.500000,    0.00000,    0.00000,    0.00000,   0.500000,   0.500000,    0.00000,    0.00000,   0.500000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 1</span>
<a name="l00484"></a>00484     {  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000 }, <span class="comment">// 2</span>
<a name="l00485"></a>00485     {  -0.250000,    0.00000,    0.00000,  -0.250000,  -0.250000,    0.00000,    0.00000,  -0.250000,    0.00000,    0.00000,    0.00000,   0.500000,   0.500000,    0.00000,    0.00000,   0.500000,    0.00000,    0.00000,    0.00000,   0.500000 }, <span class="comment">// 3</span>
<a name="l00486"></a>00486     {    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 4</span>
<a name="l00487"></a>00487     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 5</span>
<a name="l00488"></a>00488     {    0.00000,    0.00000,    0.00000,    0.00000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.500000,   0.500000,   0.500000,   0.500000 }, <span class="comment">// 6</span>
<a name="l00489"></a>00489     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000 }, <span class="comment">// 7</span>
<a name="l00490"></a>00490     {  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,   0.750000,   0.250000,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 8</span>
<a name="l00491"></a>00491     {  -0.281250,  -0.281250,  -0.156250,  -0.156250,  -0.281250,  -0.281250,  -0.156250,  -0.156250,   0.375000,   0.187500,   0.125000,   0.187500,   0.375000,   0.375000,   0.125000,   0.125000,   0.375000,   0.187500,   0.125000,   0.187500 }, <span class="comment">// 9</span>
<a name="l00492"></a>00492     {  -0.281250,  -0.156250,  -0.156250,  -0.281250,  -0.281250,  -0.156250,  -0.156250,  -0.281250,   0.187500,   0.125000,   0.187500,   0.375000,   0.375000,   0.125000,   0.125000,   0.375000,   0.187500,   0.125000,   0.187500,   0.375000 }, <span class="comment">// 10</span>
<a name="l00493"></a>00493     {  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,    0.00000,    0.00000,    0.00000,   0.375000,   0.750000,    0.00000,    0.00000,   0.250000,    0.00000,    0.00000,    0.00000,   0.375000 }, <span class="comment">// 11</span>
<a name="l00494"></a>00494     {  -0.125000,    0.00000,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 12</span>
<a name="l00495"></a>00495     {  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,   0.250000,    0.00000,    0.00000,    0.00000,   0.375000,   0.375000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 13</span>
<a name="l00496"></a>00496     {  -0.156250,  -0.156250,  -0.156250,  -0.156250,  -0.281250,  -0.281250,  -0.281250,  -0.281250,   0.125000,   0.125000,   0.125000,   0.125000,   0.187500,   0.187500,   0.187500,   0.187500,   0.375000,   0.375000,   0.375000,   0.375000 }, <span class="comment">// 14</span>
<a name="l00497"></a>00497     {  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,    0.00000,    0.00000,    0.00000,   0.250000,   0.375000,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,   0.750000 }, <span class="comment">// 15</span>
<a name="l00498"></a>00498     {    0.00000,    0.00000,    0.00000,    0.00000,   0.375000,  -0.125000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 16</span>
<a name="l00499"></a>00499     {    0.00000,    0.00000,    0.00000,    0.00000,  -0.187500,  -0.187500,  -0.187500,  -0.187500,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,   0.375000,   0.250000,   0.375000 }, <span class="comment">// 17</span>
<a name="l00500"></a>00500     {    0.00000,    0.00000,    0.00000,    0.00000,  -0.187500,  -0.187500,  -0.187500,  -0.187500,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.375000,   0.250000,   0.375000,   0.750000 }, <span class="comment">// 18</span>
<a name="l00501"></a>00501     {    0.00000,    0.00000,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,  -0.125000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000 }  <span class="comment">// 19</span>
<a name="l00502"></a>00502   },
<a name="l00503"></a>00503 
<a name="l00504"></a>00504   <span class="comment">// embedding matrix for child 5</span>
<a name="l00505"></a>00505   {
<a name="l00506"></a>00506     <span class="comment">//  0     1     2     3     4     5     6     7    8  9  11  12  13  14  15  16  17  18  19</span>
<a name="l00507"></a>00507     {  -0.250000,  -0.250000,    0.00000,    0.00000,  -0.250000,  -0.250000,    0.00000,    0.00000,   0.500000,    0.00000,    0.00000,    0.00000,   0.500000,   0.500000,    0.00000,    0.00000,   0.500000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 0</span>
<a name="l00508"></a>00508     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 1</span>
<a name="l00509"></a>00509     {    0.00000,  -0.250000,  -0.250000,    0.00000,    0.00000,  -0.250000,  -0.250000,    0.00000,    0.00000,   0.500000,    0.00000,    0.00000,    0.00000,   0.500000,   0.500000,    0.00000,    0.00000,   0.500000,    0.00000,    0.00000 }, <span class="comment">// 2</span>
<a name="l00510"></a>00510     {  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000 }, <span class="comment">// 3</span>
<a name="l00511"></a>00511     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 4</span>
<a name="l00512"></a>00512     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 5</span>
<a name="l00513"></a>00513     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000 }, <span class="comment">// 6</span>
<a name="l00514"></a>00514     {    0.00000,    0.00000,    0.00000,    0.00000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.500000,   0.500000,   0.500000,   0.500000 }, <span class="comment">// 7</span>
<a name="l00515"></a>00515     {  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,   0.250000,   0.750000,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 8</span>
<a name="l00516"></a>00516     {    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,   0.750000,   0.250000,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000 }, <span class="comment">// 9</span>
<a name="l00517"></a>00517     {  -0.156250,  -0.281250,  -0.281250,  -0.156250,  -0.156250,  -0.281250,  -0.281250,  -0.156250,   0.187500,   0.375000,   0.187500,   0.125000,   0.125000,   0.375000,   0.375000,   0.125000,   0.187500,   0.375000,   0.187500,   0.125000 }, <span class="comment">// 10</span>
<a name="l00518"></a>00518     {  -0.281250,  -0.281250,  -0.156250,  -0.156250,  -0.281250,  -0.281250,  -0.156250,  -0.156250,   0.375000,   0.187500,   0.125000,   0.187500,   0.375000,   0.375000,   0.125000,   0.125000,   0.375000,   0.187500,   0.125000,   0.187500 }, <span class="comment">// 11</span>
<a name="l00519"></a>00519     {  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,   0.250000,    0.00000,    0.00000,    0.00000,   0.375000,   0.375000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 12</span>
<a name="l00520"></a>00520     {    0.00000,  -0.125000,    0.00000,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 13</span>
<a name="l00521"></a>00521     {    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,   0.250000,    0.00000,    0.00000,    0.00000,   0.375000,   0.375000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000 }, <span class="comment">// 14</span>
<a name="l00522"></a>00522     {  -0.156250,  -0.156250,  -0.156250,  -0.156250,  -0.281250,  -0.281250,  -0.281250,  -0.281250,   0.125000,   0.125000,   0.125000,   0.125000,   0.187500,   0.187500,   0.187500,   0.187500,   0.375000,   0.375000,   0.375000,   0.375000 }, <span class="comment">// 15</span>
<a name="l00523"></a>00523     {    0.00000,    0.00000,    0.00000,    0.00000,  -0.125000,   0.375000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 16</span>
<a name="l00524"></a>00524     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.375000,  -0.125000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000 }, <span class="comment">// 17</span>
<a name="l00525"></a>00525     {    0.00000,    0.00000,    0.00000,    0.00000,  -0.187500,  -0.187500,  -0.187500,  -0.187500,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.375000,   0.750000,   0.375000,   0.250000 }, <span class="comment">// 18</span>
<a name="l00526"></a>00526     {    0.00000,    0.00000,    0.00000,    0.00000,  -0.187500,  -0.187500,  -0.187500,  -0.187500,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,   0.375000,   0.250000,   0.375000 }  <span class="comment">// 19</span>
<a name="l00527"></a>00527   },
<a name="l00528"></a>00528 
<a name="l00529"></a>00529   <span class="comment">// embedding matrix for child 6</span>
<a name="l00530"></a>00530   {
<a name="l00531"></a>00531     <span class="comment">//  0     1     2     3     4     5     6     7    8  9  11  12  13  14  15  16  17  18  19</span>
<a name="l00532"></a>00532     {  -0.250000,    0.00000,    0.00000,  -0.250000,  -0.250000,    0.00000,    0.00000,  -0.250000,    0.00000,    0.00000,    0.00000,   0.500000,   0.500000,    0.00000,    0.00000,   0.500000,    0.00000,    0.00000,    0.00000,   0.500000 }, <span class="comment">// 0</span>
<a name="l00533"></a>00533     {  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000 }, <span class="comment">// 1</span>
<a name="l00534"></a>00534     {    0.00000,    0.00000,  -0.250000,  -0.250000,    0.00000,    0.00000,  -0.250000,  -0.250000,    0.00000,    0.00000,   0.500000,    0.00000,    0.00000,    0.00000,   0.500000,   0.500000,    0.00000,    0.00000,   0.500000,    0.00000 }, <span class="comment">// 2</span>
<a name="l00535"></a>00535     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 3</span>
<a name="l00536"></a>00536     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000 }, <span class="comment">// 4</span>
<a name="l00537"></a>00537     {    0.00000,    0.00000,    0.00000,    0.00000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.500000,   0.500000,   0.500000,   0.500000 }, <span class="comment">// 5</span>
<a name="l00538"></a>00538     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000 }, <span class="comment">// 6</span>
<a name="l00539"></a>00539     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 7</span>
<a name="l00540"></a>00540     {  -0.281250,  -0.156250,  -0.156250,  -0.281250,  -0.281250,  -0.156250,  -0.156250,  -0.281250,   0.187500,   0.125000,   0.187500,   0.375000,   0.375000,   0.125000,   0.125000,   0.375000,   0.187500,   0.125000,   0.187500,   0.375000 }, <span class="comment">// 8</span>
<a name="l00541"></a>00541     {  -0.156250,  -0.156250,  -0.281250,  -0.281250,  -0.156250,  -0.156250,  -0.281250,  -0.281250,   0.125000,   0.187500,   0.375000,   0.187500,   0.125000,   0.125000,   0.375000,   0.375000,   0.125000,   0.187500,   0.375000,   0.187500 }, <span class="comment">// 9</span>
<a name="l00542"></a>00542     {    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,   0.250000,   0.750000,    0.00000,    0.00000,   0.375000,    0.00000 }, <span class="comment">// 10</span>
<a name="l00543"></a>00543     {  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,    0.00000,    0.00000,    0.00000,   0.375000,   0.250000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,   0.375000 }, <span class="comment">// 11</span>
<a name="l00544"></a>00544     {  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,    0.00000,    0.00000,    0.00000,   0.250000,   0.375000,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,   0.750000 }, <span class="comment">// 12</span>
<a name="l00545"></a>00545     {  -0.156250,  -0.156250,  -0.156250,  -0.156250,  -0.281250,  -0.281250,  -0.281250,  -0.281250,   0.125000,   0.125000,   0.125000,   0.125000,   0.187500,   0.187500,   0.187500,   0.187500,   0.375000,   0.375000,   0.375000,   0.375000 }, <span class="comment">// 13</span>
<a name="l00546"></a>00546     {    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,   0.250000,    0.00000,    0.00000,    0.00000,   0.375000,   0.375000,    0.00000,    0.00000,   0.750000,    0.00000 }, <span class="comment">// 14</span>
<a name="l00547"></a>00547     {    0.00000,    0.00000,    0.00000,  -0.125000,    0.00000,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 15</span>
<a name="l00548"></a>00548     {    0.00000,    0.00000,    0.00000,    0.00000,  -0.187500,  -0.187500,  -0.187500,  -0.187500,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.375000,   0.250000,   0.375000,   0.750000 }, <span class="comment">// 16</span>
<a name="l00549"></a>00549     {    0.00000,    0.00000,    0.00000,    0.00000,  -0.187500,  -0.187500,  -0.187500,  -0.187500,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.250000,   0.375000,   0.750000,   0.375000 }, <span class="comment">// 17</span>
<a name="l00550"></a>00550     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,  -0.125000,   0.375000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,    0.00000 }, <span class="comment">// 18</span>
<a name="l00551"></a>00551     {    0.00000,    0.00000,    0.00000,    0.00000,  -0.125000,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000 }  <span class="comment">// 19</span>
<a name="l00552"></a>00552   },
<a name="l00553"></a>00553 
<a name="l00554"></a>00554   <span class="comment">// embedding matrix for child 7</span>
<a name="l00555"></a>00555   {
<a name="l00556"></a>00556     <span class="comment">//  0     1     2     3     4     5     6     7    8  9  11  12  13  14  15  16  17  18  19</span>
<a name="l00557"></a>00557     {  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000,   0.250000 }, <span class="comment">// 0</span>
<a name="l00558"></a>00558     {    0.00000,  -0.250000,  -0.250000,    0.00000,    0.00000,  -0.250000,  -0.250000,    0.00000,    0.00000,   0.500000,    0.00000,    0.00000,    0.00000,   0.500000,   0.500000,    0.00000,    0.00000,   0.500000,    0.00000,    0.00000 }, <span class="comment">// 1</span>
<a name="l00559"></a>00559     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 2</span>
<a name="l00560"></a>00560     {    0.00000,    0.00000,  -0.250000,  -0.250000,    0.00000,    0.00000,  -0.250000,  -0.250000,    0.00000,    0.00000,   0.500000,    0.00000,    0.00000,    0.00000,   0.500000,   0.500000,    0.00000,    0.00000,   0.500000,    0.00000 }, <span class="comment">// 3</span>
<a name="l00561"></a>00561     {    0.00000,    0.00000,    0.00000,    0.00000,  -0.250000,  -0.250000,  -0.250000,  -0.250000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.500000,   0.500000,   0.500000,   0.500000 }, <span class="comment">// 4</span>
<a name="l00562"></a>00562     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000 }, <span class="comment">// 5</span>
<a name="l00563"></a>00563     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 6</span>
<a name="l00564"></a>00564     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000 }, <span class="comment">// 7</span>
<a name="l00565"></a>00565     {  -0.156250,  -0.281250,  -0.281250,  -0.156250,  -0.156250,  -0.281250,  -0.281250,  -0.156250,   0.187500,   0.375000,   0.187500,   0.125000,   0.125000,   0.375000,   0.375000,   0.125000,   0.187500,   0.375000,   0.187500,   0.125000 }, <span class="comment">// 8</span>
<a name="l00566"></a>00566     {    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,   0.250000,   0.750000,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000 }, <span class="comment">// 9</span>
<a name="l00567"></a>00567     {    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,   0.750000,   0.250000,    0.00000,    0.00000,   0.375000,    0.00000 }, <span class="comment">// 10</span>
<a name="l00568"></a>00568     {  -0.156250,  -0.156250,  -0.281250,  -0.281250,  -0.156250,  -0.156250,  -0.281250,  -0.281250,   0.125000,   0.187500,   0.375000,   0.187500,   0.125000,   0.125000,   0.375000,   0.375000,   0.125000,   0.187500,   0.375000,   0.187500 }, <span class="comment">// 11</span>
<a name="l00569"></a>00569     {  -0.156250,  -0.156250,  -0.156250,  -0.156250,  -0.281250,  -0.281250,  -0.281250,  -0.281250,   0.125000,   0.125000,   0.125000,   0.125000,   0.187500,   0.187500,   0.187500,   0.187500,   0.375000,   0.375000,   0.375000,   0.375000 }, <span class="comment">// 12</span>
<a name="l00570"></a>00570     {    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,   0.250000,    0.00000,    0.00000,    0.00000,   0.375000,   0.375000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000 }, <span class="comment">// 13</span>
<a name="l00571"></a>00571     {    0.00000,    0.00000,  -0.125000,    0.00000,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 14</span>
<a name="l00572"></a>00572     {    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,  -0.187500,  -0.187500,    0.00000,    0.00000,   0.250000,    0.00000,    0.00000,    0.00000,   0.375000,   0.375000,    0.00000,    0.00000,   0.750000,    0.00000 }, <span class="comment">// 15</span>
<a name="l00573"></a>00573     {    0.00000,    0.00000,    0.00000,    0.00000,  -0.187500,  -0.187500,  -0.187500,  -0.187500,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.375000,   0.750000,   0.375000,   0.250000 }, <span class="comment">// 16</span>
<a name="l00574"></a>00574     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,  -0.125000,   0.375000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000 }, <span class="comment">// 17</span>
<a name="l00575"></a>00575     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.375000,  -0.125000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.750000,    0.00000 }, <span class="comment">// 18</span>
<a name="l00576"></a>00576     {    0.00000,    0.00000,    0.00000,    0.00000,  -0.187500,  -0.187500,  -0.187500,  -0.187500,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.250000,   0.375000,   0.750000,   0.375000 }  <span class="comment">// 19</span>
<a name="l00577"></a>00577   }
<a name="l00578"></a>00578 };
<a name="l00579"></a>00579 
<a name="l00580"></a>00580 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
