<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1665b3ccb6c776ec6797fe204e2359e5.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>cell_hex8.C</h1>  </div>
</div>
<div class="contents">
<a href="cell__hex8_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_hex8.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;side.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;cell_hex8.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;edge_edge2.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;face_quad4.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00033"></a>00033 <span class="comment">// Hex8 class static member initializations</span>
<a name="l00034"></a>00034 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classHex8.php#a6847e22fe32c16f13897be904734d580">Hex8::side_nodes_map</a>[6][4] =
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036   {0, 3, 2, 1}, <span class="comment">// Side 0</span>
<a name="l00037"></a>00037   {0, 1, 5, 4}, <span class="comment">// Side 1</span>
<a name="l00038"></a>00038   {1, 2, 6, 5}, <span class="comment">// Side 2</span>
<a name="l00039"></a>00039   {2, 3, 7, 6}, <span class="comment">// Side 3</span>
<a name="l00040"></a>00040   {3, 0, 4, 7}, <span class="comment">// Side 4</span>
<a name="l00041"></a>00041   {4, 5, 6, 7}  <span class="comment">// Side 5</span>
<a name="l00042"></a>00042 };
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classHex8.php#a4ba2f70a41f100c069ce89533fcdbc48">Hex8::edge_nodes_map</a>[12][2] =
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046   {0, 1}, <span class="comment">// Side 0</span>
<a name="l00047"></a>00047   {1, 2}, <span class="comment">// Side 1</span>
<a name="l00048"></a>00048   {2, 3}, <span class="comment">// Side 2</span>
<a name="l00049"></a>00049   {0, 3}, <span class="comment">// Side 3</span>
<a name="l00050"></a>00050   {0, 4}, <span class="comment">// Side 4</span>
<a name="l00051"></a>00051   {1, 5}, <span class="comment">// Side 5</span>
<a name="l00052"></a>00052   {2, 6}, <span class="comment">// Side 6</span>
<a name="l00053"></a>00053   {3, 7}, <span class="comment">// Side 7</span>
<a name="l00054"></a>00054   {4, 5}, <span class="comment">// Side 8</span>
<a name="l00055"></a>00055   {5, 6}, <span class="comment">// Side 9</span>
<a name="l00056"></a>00056   {6, 7}, <span class="comment">// Side 10</span>
<a name="l00057"></a>00057   {4, 7}  <span class="comment">// Side 11</span>
<a name="l00058"></a>00058 };
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00062"></a>00062 <span class="comment">// Hex8 class member functions</span>
<a name="l00063"></a>00063 
<a name="l00064"></a><a class="code" href="classHex8.php#a57ef01d522bb67ba8f589f220ceaadaa">00064</a> <span class="keywordtype">bool</span> <a class="code" href="classHex8.php#a57ef01d522bb67ba8f589f220ceaadaa">Hex8::is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00065"></a>00065 <span class="keyword"></span>{
<a name="l00066"></a>00066   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00067"></a>00067 }
<a name="l00068"></a>00068 
<a name="l00069"></a><a class="code" href="classHex8.php#aa0d25670743affa84cd0dd7129a02312">00069</a> <span class="keywordtype">bool</span> <a class="code" href="classHex8.php#aa0d25670743affa84cd0dd7129a02312">Hex8::is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00070"></a>00070 <span class="keyword"></span>{
<a name="l00071"></a>00071   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00072"></a>00072 }
<a name="l00073"></a>00073 
<a name="l00074"></a><a class="code" href="classHex8.php#a869a96a3e0a43f53cd802233bd59bf86">00074</a> <span class="keywordtype">bool</span> <a class="code" href="classHex8.php#a869a96a3e0a43f53cd802233bd59bf86">Hex8::is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00075"></a>00075 <span class="keyword"></span>{
<a name="l00076"></a>00076   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00077"></a>00077 }
<a name="l00078"></a>00078 
<a name="l00079"></a><a class="code" href="classHex8.php#a9fd4332b21c8d6ce20770bb5a45515f4">00079</a> <span class="keywordtype">bool</span> <a class="code" href="classHex8.php#a9fd4332b21c8d6ce20770bb5a45515f4">Hex8::is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00080"></a>00080                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00081"></a>00081 <span class="keyword"></span>{
<a name="l00082"></a>00082   libmesh_assert(s &lt; <a class="code" href="classHex.php#add801d90fe993236069c69ee46003731">n_sides</a>());
<a name="l00083"></a>00083   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 4; ++i)
<a name="l00084"></a>00084     <span class="keywordflow">if</span> (<a class="code" href="classHex8.php#a6847e22fe32c16f13897be904734d580">side_nodes_map</a>[s][i] == n)
<a name="l00085"></a>00085       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00086"></a>00086   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00087"></a>00087 }
<a name="l00088"></a>00088 
<a name="l00089"></a><a class="code" href="classHex8.php#a838c75b0d164ea8b0e1a1d72ed8a6294">00089</a> <span class="keywordtype">bool</span> <a class="code" href="classHex8.php#a838c75b0d164ea8b0e1a1d72ed8a6294">Hex8::is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00090"></a>00090                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00091"></a>00091 <span class="keyword"></span>{
<a name="l00092"></a>00092   libmesh_assert(e &lt; <a class="code" href="classHex.php#a571b4b2f2a63a14f2017009bb16ba32b">n_edges</a>());
<a name="l00093"></a>00093   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 2; ++i)
<a name="l00094"></a>00094     <span class="keywordflow">if</span> (<a class="code" href="classHex8.php#a4ba2f70a41f100c069ce89533fcdbc48">edge_nodes_map</a>[e][i] == n)
<a name="l00095"></a>00095       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00096"></a>00096   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00097"></a>00097 }
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00101"></a><a class="code" href="classHex8.php#a4582141d5aaa8655355055cd1065fa31">00101</a> <span class="keywordtype">bool</span> <a class="code" href="classHex8.php#a4582141d5aaa8655355055cd1065fa31">Hex8::has_affine_map</a>()<span class="keyword"> const</span>
<a name="l00102"></a>00102 <span class="keyword"></span>{
<a name="l00103"></a>00103   <span class="comment">// Make sure x-edge endpoints are affine</span>
<a name="l00104"></a>00104   <a class="code" href="classPoint.php">Point</a> v = this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0);
<a name="l00105"></a>00105   <span class="keywordflow">if</span> (!v.<a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">relative_fuzzy_equals</a>(this-&gt;point(2) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3)) ||
<a name="l00106"></a>00106       !v.<a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">relative_fuzzy_equals</a>(this-&gt;point(5) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(4)) ||
<a name="l00107"></a>00107       !v.<a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">relative_fuzzy_equals</a>(this-&gt;point(6) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(7)))
<a name="l00108"></a>00108     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00109"></a>00109   <span class="comment">// Make sure xz-faces are identical parallelograms</span>
<a name="l00110"></a>00110   v = this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(4) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0);
<a name="l00111"></a>00111   <span class="keywordflow">if</span> (!v.<a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">relative_fuzzy_equals</a>(this-&gt;point(7) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3)))
<a name="l00112"></a>00112     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00113"></a>00113   <span class="comment">// If all the above checks out, the map is affine</span>
<a name="l00114"></a>00114   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00115"></a>00115 }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a><a class="code" href="classHex8.php#ab137e41af9d83a16872cd4e0abb679ff">00119</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classHex8.php#ab137e41af9d83a16872cd4e0abb679ff">Hex8::build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00120"></a>00120                                 <span class="keywordtype">bool</span> proxy)<span class="keyword"> const</span>
<a name="l00121"></a>00121 <span class="keyword"></span>{
<a name="l00122"></a>00122   libmesh_assert (i &lt; this-&gt;<a class="code" href="classHex.php#add801d90fe993236069c69ee46003731">n_sides</a>());
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <span class="keywordflow">if</span> (proxy)
<a name="l00125"></a>00125     {
<a name="l00126"></a>00126       <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classSide.php">Side&lt;Quad4,Hex8&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00127"></a>00127       <span class="keywordflow">return</span> ap;
<a name="l00128"></a>00128     }
<a name="l00129"></a>00129   
<a name="l00130"></a>00130   <span class="keywordflow">else</span>
<a name="l00131"></a>00131     {
<a name="l00132"></a>00132       <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classQuad4.php">Quad4</a>);
<a name="l00133"></a>00133 
<a name="l00134"></a>00134       <span class="comment">// Think of a unit cube: (-1,1) x (-1,1)x (-1,1)</span>
<a name="l00135"></a>00135       <span class="keywordflow">switch</span> (i)
<a name="l00136"></a>00136         {
<a name="l00137"></a>00137         <span class="keywordflow">case</span> 0:  <span class="comment">// the face at z = -1</span>
<a name="l00138"></a>00138           {
<a name="l00139"></a>00139             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00140"></a>00140             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00141"></a>00141             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00142"></a>00142             face-&gt;set_node(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00143"></a>00143 
<a name="l00144"></a>00144             <span class="keywordflow">return</span> face;
<a name="l00145"></a>00145           }
<a name="l00146"></a>00146         <span class="keywordflow">case</span> 1:  <span class="comment">// the face at y = -1</span>
<a name="l00147"></a>00147           {
<a name="l00148"></a>00148             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00149"></a>00149             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00150"></a>00150             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(5);
<a name="l00151"></a>00151             face-&gt;set_node(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(4);
<a name="l00152"></a>00152         
<a name="l00153"></a>00153             <span class="keywordflow">return</span> face;
<a name="l00154"></a>00154           }
<a name="l00155"></a>00155         <span class="keywordflow">case</span> 2:  <span class="comment">// the face at x = 1</span>
<a name="l00156"></a>00156           {
<a name="l00157"></a>00157             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00158"></a>00158             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00159"></a>00159             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(6);
<a name="l00160"></a>00160             face-&gt;set_node(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(5);
<a name="l00161"></a>00161 
<a name="l00162"></a>00162             <span class="keywordflow">return</span> face;
<a name="l00163"></a>00163           }
<a name="l00164"></a>00164         <span class="keywordflow">case</span> 3: <span class="comment">// the face at y = 1</span>
<a name="l00165"></a>00165           {
<a name="l00166"></a>00166             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00167"></a>00167             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00168"></a>00168             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(7);
<a name="l00169"></a>00169             face-&gt;set_node(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(6);
<a name="l00170"></a>00170         
<a name="l00171"></a>00171             <span class="keywordflow">return</span> face;
<a name="l00172"></a>00172           }
<a name="l00173"></a>00173         <span class="keywordflow">case</span> 4: <span class="comment">// the face at x = -1</span>
<a name="l00174"></a>00174           {
<a name="l00175"></a>00175             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00176"></a>00176             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00177"></a>00177             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(4);
<a name="l00178"></a>00178             face-&gt;set_node(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(7);
<a name="l00179"></a>00179 
<a name="l00180"></a>00180             <span class="keywordflow">return</span> face;
<a name="l00181"></a>00181           }
<a name="l00182"></a>00182         <span class="keywordflow">case</span> 5: <span class="comment">// the face at z = 1</span>
<a name="l00183"></a>00183           {
<a name="l00184"></a>00184             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(4);
<a name="l00185"></a>00185             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(5);
<a name="l00186"></a>00186             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(6);
<a name="l00187"></a>00187             face-&gt;set_node(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(7);
<a name="l00188"></a>00188         
<a name="l00189"></a>00189             <span class="keywordflow">return</span> face;
<a name="l00190"></a>00190           }
<a name="l00191"></a>00191         <span class="keywordflow">default</span>:
<a name="l00192"></a>00192           {
<a name="l00193"></a>00193             libmesh_error();
<a name="l00194"></a>00194             <span class="keywordflow">return</span> face;
<a name="l00195"></a>00195           }
<a name="l00196"></a>00196         }
<a name="l00197"></a>00197     }
<a name="l00198"></a>00198   
<a name="l00199"></a>00199   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00200"></a>00200   libmesh_error();
<a name="l00201"></a>00201   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00202"></a>00202 }
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 
<a name="l00206"></a><a class="code" href="classHex8.php#a610db3de819f3149231e6b77bbf5060e">00206</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classHex8.php#a610db3de819f3149231e6b77bbf5060e">Hex8::build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00207"></a>00207 <span class="keyword"></span>{
<a name="l00208"></a>00208   libmesh_assert (i &lt; this-&gt;<a class="code" href="classHex.php#a571b4b2f2a63a14f2017009bb16ba32b">n_edges</a>());
<a name="l00209"></a>00209 
<a name="l00210"></a>00210   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classSideEdge.php">SideEdge&lt;Edge2,Hex8&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00211"></a>00211   <span class="keywordflow">return</span> ap;
<a name="l00212"></a>00212 }
<a name="l00213"></a>00213   
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 
<a name="l00216"></a><a class="code" href="classHex8.php#a8b86bd715ca2ad32d702a6ceeef55cdc">00216</a> <span class="keywordtype">void</span> <a class="code" href="classHex8.php#a8b86bd715ca2ad32d702a6ceeef55cdc">Hex8::connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00217"></a>00217                         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00218"></a>00218                         std::vector&lt;unsigned int&gt;&amp; conn)<span class="keyword"> const</span>
<a name="l00219"></a>00219 <span class="keyword"></span>{
<a name="l00220"></a>00220   libmesh_assert (<a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a> != NULL);
<a name="l00221"></a>00221   libmesh_assert (sc &lt; this-&gt;<a class="code" href="classHex8.php#a4c0da8f9693f996c83748cbd6f2a00e0">n_sub_elem</a>());
<a name="l00222"></a>00222   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00223"></a>00223 
<a name="l00224"></a>00224   conn.resize(8);
<a name="l00225"></a>00225 
<a name="l00226"></a>00226   <span class="keywordflow">switch</span> (iop)
<a name="l00227"></a>00227     {
<a name="l00228"></a>00228     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00229"></a>00229       {
<a name="l00230"></a>00230         conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0)+1;
<a name="l00231"></a>00231         conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1)+1;
<a name="l00232"></a>00232         conn[2] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2)+1;
<a name="l00233"></a>00233         conn[3] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3)+1;
<a name="l00234"></a>00234         conn[4] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(4)+1;
<a name="l00235"></a>00235         conn[5] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(5)+1;
<a name="l00236"></a>00236         conn[6] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(6)+1;
<a name="l00237"></a>00237         conn[7] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(7)+1;
<a name="l00238"></a>00238         <span class="keywordflow">return</span>;
<a name="l00239"></a>00239       }
<a name="l00240"></a>00240 
<a name="l00241"></a>00241     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa1affb8987f83b5e4acb22d9401dd44ef">VTK</a>:
<a name="l00242"></a>00242       {
<a name="l00243"></a>00243         conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0);
<a name="l00244"></a>00244         conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1);
<a name="l00245"></a>00245         conn[2] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2);
<a name="l00246"></a>00246         conn[3] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3);
<a name="l00247"></a>00247         conn[4] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(4);
<a name="l00248"></a>00248         conn[5] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(5);
<a name="l00249"></a>00249         conn[6] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(6);
<a name="l00250"></a>00250         conn[7] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(7);
<a name="l00251"></a>00251         <span class="keywordflow">return</span>;
<a name="l00252"></a>00252       }
<a name="l00253"></a>00253 
<a name="l00254"></a>00254     <span class="keywordflow">default</span>:
<a name="l00255"></a>00255       libmesh_error();
<a name="l00256"></a>00256     }
<a name="l00257"></a>00257 
<a name="l00258"></a>00258   libmesh_error();
<a name="l00259"></a>00259 }
<a name="l00260"></a>00260 
<a name="l00261"></a>00261 
<a name="l00262"></a>00262 
<a name="l00263"></a>00263 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00264"></a>00264 <span class="preprocessor"></span>
<a name="l00265"></a>00265 <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classHex8.php#a8a149dee1712413765a21c3d5f9658dc">Hex8::_embedding_matrix</a>[8][8][8] =
<a name="l00266"></a>00266 {
<a name="l00267"></a>00267   <span class="comment">// The 8 children of the Hex-type elements can be thought of as being</span>
<a name="l00268"></a>00268   <span class="comment">// associated with the 8 vertices of the Hex.  Some of the children are</span>
<a name="l00269"></a>00269   <span class="comment">// numbered the same as their corresponding vertex, while some are</span>
<a name="l00270"></a>00270   <span class="comment">// not.  The children which are numbered differently have been marked</span>
<a name="l00271"></a>00271   <span class="comment">// with ** in the comments below.</span>
<a name="l00272"></a>00272   
<a name="l00273"></a>00273   <span class="comment">// embedding matrix for child 0 (child 0 is associated with vertex 0)</span>
<a name="l00274"></a>00274   {
<a name="l00275"></a>00275     <span class="comment">//  0     1     2     3     4     5     6     7</span>
<a name="l00276"></a>00276     { 1.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0}, <span class="comment">// 0</span>
<a name="l00277"></a>00277     { 0.5,  0.5,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0}, <span class="comment">// 1</span>
<a name="l00278"></a>00278     { .25,  .25,  .25,  .25,  0.0,  0.0,  0.0,  0.0}, <span class="comment">// 2</span>
<a name="l00279"></a>00279     { 0.5,  0.0,  0.0,  0.5,  0.0,  0.0,  0.0,  0.0}, <span class="comment">// 3</span>
<a name="l00280"></a>00280     { 0.5,  0.0,  0.0,  0.0,  0.5,  0.0,  0.0,  0.0}, <span class="comment">// 4</span>
<a name="l00281"></a>00281     { .25,  .25,  0.0,  0.0,  .25,  .25,  0.0,  0.0}, <span class="comment">// 5</span>
<a name="l00282"></a>00282     {.125, .125, .125, .125, .125, .125, .125, .125}, <span class="comment">// 6</span>
<a name="l00283"></a>00283     { .25,  0.0,  0.0,  .25,  .25,  0.0,  0.0,  .25}  <span class="comment">// 7</span>
<a name="l00284"></a>00284   },
<a name="l00285"></a>00285 
<a name="l00286"></a>00286   <span class="comment">// embedding matrix for child 1 (child 1 is associated with vertex 1)</span>
<a name="l00287"></a>00287   {
<a name="l00288"></a>00288     <span class="comment">//  0     1     2     3     4     5     6     7</span>
<a name="l00289"></a>00289     { 0.5,  0.5,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0}, <span class="comment">// 0</span>
<a name="l00290"></a>00290     { 0.0,  1.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0}, <span class="comment">// 1</span>
<a name="l00291"></a>00291     { 0.0,  0.5,  0.5,  0.0,  0.0,  0.0,  0.0,  0.0}, <span class="comment">// 2</span>
<a name="l00292"></a>00292     { .25,  .25,  .25,  .25,  0.0,  0.0,  0.0,  0.0}, <span class="comment">// 3</span>
<a name="l00293"></a>00293     { .25,  .25,  0.0,  0.0,  .25,  .25,  0.0,  0.0}, <span class="comment">// 4</span>
<a name="l00294"></a>00294     { 0.0,  0.5,  0.0,  0.0,  0.0,  0.5,  0.0,  0.0}, <span class="comment">// 5</span>
<a name="l00295"></a>00295     { 0.0,  .25,  .25,  0.0,  0.0,  .25,  .25,  0.0}, <span class="comment">// 6</span>
<a name="l00296"></a>00296     {.125, .125, .125, .125, .125, .125, .125, .125}  <span class="comment">// 7</span>
<a name="l00297"></a>00297   },
<a name="l00298"></a>00298 
<a name="l00299"></a>00299   <span class="comment">// embedding matrix for child 2 (child 2 is associated with vertex 3**)</span>
<a name="l00300"></a>00300   {
<a name="l00301"></a>00301     <span class="comment">//  0      1    2     3     4     5     6     7</span>
<a name="l00302"></a>00302     { 0.5,  0.0,  0.0,  0.5,  0.0,  0.0,  0.0,  0.0}, <span class="comment">// 0</span>
<a name="l00303"></a>00303     { .25,  .25,  .25,  .25,  0.0,  0.0,  0.0,  0.0}, <span class="comment">// 1</span>
<a name="l00304"></a>00304     { 0.0,  0.0,  0.5,  0.5,  0.0,  0.0,  0.0,  0.0}, <span class="comment">// 2</span>
<a name="l00305"></a>00305     { 0.0,  0.0,  0.0,  1.0,  0.0,  0.0,  0.0,  0.0}, <span class="comment">// 3</span>
<a name="l00306"></a>00306     { .25,  0.0,  0.0,  .25,  .25,  0.0,  0.0,  .25}, <span class="comment">// 4</span>
<a name="l00307"></a>00307     {.125, .125, .125, .125, .125, .125, .125, .125}, <span class="comment">// 5</span>
<a name="l00308"></a>00308     { 0.0,  0.0,  .25,  .25,  0.0,  0.0,  .25,  .25}, <span class="comment">// 6</span>
<a name="l00309"></a>00309     { 0.0,  0.0,  0.0,  0.5,  0.0,  0.0,  0.0,  0.5}  <span class="comment">// 7</span>
<a name="l00310"></a>00310   },
<a name="l00311"></a>00311 
<a name="l00312"></a>00312   <span class="comment">// embedding matrix for child 3 (child 3 is associated with vertex 2**)</span>
<a name="l00313"></a>00313   {
<a name="l00314"></a>00314     <span class="comment">//  0      1    2     3     4     5     6     7</span>
<a name="l00315"></a>00315     { .25,  .25,  .25,  .25,  0.0,  0.0,  0.0,  0.0}, <span class="comment">// 0</span>
<a name="l00316"></a>00316     { 0.0,  0.5,  0.5,  0.0,  0.0,  0.0,  0.0,  0.0}, <span class="comment">// 1</span>
<a name="l00317"></a>00317     { 0.0,  0.0,  1.0,  0.0,  0.0,  0.0,  0.0,  0.0}, <span class="comment">// 2</span>
<a name="l00318"></a>00318     { 0.0,  0.0,  0.5,  0.5,  0.0,  0.0,  0.0,  0.0}, <span class="comment">// 3</span>
<a name="l00319"></a>00319     {.125, .125, .125, .125, .125, .125, .125, .125}, <span class="comment">// 4</span>
<a name="l00320"></a>00320     { 0.0,  .25,  .25,  0.0,  0.0,  .25,  .25,  0.0}, <span class="comment">// 5</span>
<a name="l00321"></a>00321     { 0.0,  0.0,  0.5,  0.0,  0.0,  0.0,  0.5,  0.0}, <span class="comment">// 6</span>
<a name="l00322"></a>00322     { 0.0,  0.0,  .25,  .25,  0.0,  0.0,  .25,  .25}  <span class="comment">// 7</span>
<a name="l00323"></a>00323   },
<a name="l00324"></a>00324 
<a name="l00325"></a>00325   <span class="comment">// embedding matrix for child 4 (child 4 is associated with vertex 4)</span>
<a name="l00326"></a>00326   {
<a name="l00327"></a>00327     <span class="comment">//  0      1    2     3     4     5     6     7</span>
<a name="l00328"></a>00328     { 0.5,  0.0,  0.0,  0.0,  0.5,  0.0,  0.0,  0.0}, <span class="comment">// 0</span>
<a name="l00329"></a>00329     { .25,  .25,  0.0,  0.0,  .25,  .25,  0.0,  0.0}, <span class="comment">// 1</span>
<a name="l00330"></a>00330     {.125, .125, .125, .125, .125, .125, .125, .125}, <span class="comment">// 2</span>
<a name="l00331"></a>00331     { .25,  0.0,  0.0,  .25,  .25,  0.0,  0.0,  .25}, <span class="comment">// 3</span>
<a name="l00332"></a>00332     { 0.0,  0.0,  0.0,  0.0,  1.0,  0.0,  0.0,  0.0}, <span class="comment">// 4</span>
<a name="l00333"></a>00333     { 0.0,  0.0,  0.0,  0.0,  0.5,  0.5,  0.0,  0.0}, <span class="comment">// 5</span>
<a name="l00334"></a>00334     { 0.0,  0.0,  0.0,  0.0,  .25,  .25,  .25,  .25}, <span class="comment">// 6</span>
<a name="l00335"></a>00335     { 0.0,  0.0,  0.0,  0.0,  0.5,  0.0,  0.0,  0.5}  <span class="comment">// 7</span>
<a name="l00336"></a>00336   },
<a name="l00337"></a>00337 
<a name="l00338"></a>00338   <span class="comment">// embedding matrix for child 5 (child 5 is associated with vertex 5)</span>
<a name="l00339"></a>00339   {
<a name="l00340"></a>00340     <span class="comment">//  0      1    2     3     4     5     6     7</span>
<a name="l00341"></a>00341     { .25,  .25,  0.0,  0.0,  .25,  .25,  0.0,  0.0}, <span class="comment">// 0</span>
<a name="l00342"></a>00342     { 0.0,  0.5,  0.0,  0.0,  0.0,  0.5,  0.0,  0.0}, <span class="comment">// 1</span>
<a name="l00343"></a>00343     { 0.0,  .25,  .25,  0.0,  0.0,  .25,  .25,  0.0}, <span class="comment">// 2</span>
<a name="l00344"></a>00344     {.125, .125, .125, .125, .125, .125, .125, .125}, <span class="comment">// 3</span>
<a name="l00345"></a>00345     { 0.0,  0.0,  0.0,  0.0,  0.5,  0.5,  0.0,  0.0}, <span class="comment">// 4</span>
<a name="l00346"></a>00346     { 0.0,  0.0,  0.0,  0.0,  0.0,  1.0,  0.0,  0.0}, <span class="comment">// 5</span>
<a name="l00347"></a>00347     { 0.0,  0.0,  0.0,  0.0,  0.0,  0.5,  0.5,  0.0}, <span class="comment">// 6</span>
<a name="l00348"></a>00348     { 0.0,  0.0,  0.0,  0.0,  .25,  .25,  .25,  .25}  <span class="comment">// 7</span>
<a name="l00349"></a>00349   },
<a name="l00350"></a>00350 
<a name="l00351"></a>00351   <span class="comment">// embedding matrix for child 6 (child 6 is associated with vertex 7**)</span>
<a name="l00352"></a>00352   {
<a name="l00353"></a>00353     <span class="comment">//  0      1    2     3     4     5     6     7</span>
<a name="l00354"></a>00354     { .25,  0.0,  0.0,  .25,  .25,  0.0,  0.0,  .25}, <span class="comment">// 0</span>
<a name="l00355"></a>00355     {.125, .125, .125, .125, .125, .125, .125, .125}, <span class="comment">// 1</span>
<a name="l00356"></a>00356     { 0.0,  0.0,  .25,  .25,  0.0,  0.0,  .25,  .25}, <span class="comment">// 2</span>
<a name="l00357"></a>00357     { 0.0,  0.0,  0.0,  0.5,  0.0,  0.0,  0.0,  0.5}, <span class="comment">// 3</span>
<a name="l00358"></a>00358     { 0.0,  0.0,  0.0,  0.0,  0.5,  0.0,  0.0,  0.5}, <span class="comment">// 4</span>
<a name="l00359"></a>00359     { 0.0,  0.0,  0.0,  0.0,  .25,  .25,  .25,  .25}, <span class="comment">// 5</span>
<a name="l00360"></a>00360     { 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.5,  0.5}, <span class="comment">// 6</span>
<a name="l00361"></a>00361     { 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  1.0}  <span class="comment">// 7</span>
<a name="l00362"></a>00362   },
<a name="l00363"></a>00363 
<a name="l00364"></a>00364   <span class="comment">// embedding matrix for child 7 (child 7 is associated with vertex 6**)</span>
<a name="l00365"></a>00365   {
<a name="l00366"></a>00366     <span class="comment">//  0      1    2     3     4     5     6     7</span>
<a name="l00367"></a>00367     {.125, .125, .125, .125, .125, .125, .125, .125}, <span class="comment">// 0</span>
<a name="l00368"></a>00368     { 0.0,  .25,  .25,  0.0,  0.0,  .25,  .25,  0.0}, <span class="comment">// 1</span>
<a name="l00369"></a>00369     { 0.0,  0.0,  0.5,  0.0,  0.0,  0.0,  0.5,  0.0}, <span class="comment">// 2</span>
<a name="l00370"></a>00370     { 0.0,  0.0,  .25,  .25,  0.0,  0.0,  .25,  .25}, <span class="comment">// 3</span>
<a name="l00371"></a>00371     { 0.0,  0.0,  0.0,  0.0,  .25,  .25,  .25,  .25}, <span class="comment">// 4</span>
<a name="l00372"></a>00372     { 0.0,  0.0,  0.0,  0.0,  0.0,  0.5,  0.5,  0.0}, <span class="comment">// 5</span>
<a name="l00373"></a>00373     { 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  1.0,  0.0}, <span class="comment">// 6</span>
<a name="l00374"></a>00374     { 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.5,  0.5}  <span class="comment">// 7</span>
<a name="l00375"></a>00375   }
<a name="l00376"></a>00376 };
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 <span class="preprocessor">#endif</span>
<a name="l00379"></a>00379 <span class="preprocessor"></span>
<a name="l00380"></a>00380 
<a name="l00381"></a>00381 
<a name="l00382"></a><a class="code" href="classHex8.php#af579ca835303903d2ab02913aeefb16e">00382</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classHex8.php#af579ca835303903d2ab02913aeefb16e">Hex8::volume</a> ()<span class="keyword"> const</span>
<a name="l00383"></a>00383 <span class="keyword"></span>{
<a name="l00384"></a>00384   <span class="comment">// Compute the volume of the tri-linear hex by splitting it</span>
<a name="l00385"></a>00385   <span class="comment">// into 6 sub-pyramids and applying the formula in:</span>
<a name="l00386"></a>00386   <span class="comment">// &quot;Calculation of the Volume of a General Hexahedron</span>
<a name="l00387"></a>00387   <span class="comment">// for Flow Predictions&quot;, AIAA Journal v.23, no.6, 1984, p.954-</span>
<a name="l00388"></a>00388   
<a name="l00389"></a>00389   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> sub_pyr[6][4] =
<a name="l00390"></a>00390     {
<a name="l00391"></a>00391       {0, 3, 2, 1},
<a name="l00392"></a>00392       {6, 7, 4, 5},
<a name="l00393"></a>00393       {0, 1, 5, 4},
<a name="l00394"></a>00394       {3, 7, 6, 2},
<a name="l00395"></a>00395       {0, 4, 7, 3},
<a name="l00396"></a>00396       {1, 2, 6, 5}
<a name="l00397"></a>00397     };
<a name="l00398"></a>00398 
<a name="l00399"></a>00399   <span class="comment">// The centroid is a convenient point to use</span>
<a name="l00400"></a>00400   <span class="comment">// for the apex of all the pyramids.</span>
<a name="l00401"></a>00401   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> R = this-&gt;<a class="code" href="classElem.php#a46ce080150f08ce9d367b69f16dd0452">centroid</a>();
<a name="l00402"></a>00402   <a class="code" href="classNode.php">Node</a>* pyr_base[4];
<a name="l00403"></a>00403   
<a name="l00404"></a>00404   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> vol=0.;
<a name="l00405"></a>00405 
<a name="l00406"></a>00406   <span class="comment">// Compute the volume using 6 sub-pyramids</span>
<a name="l00407"></a>00407   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;6; ++n)
<a name="l00408"></a>00408     {
<a name="l00409"></a>00409       <span class="comment">// Set the nodes of the pyramid base</span>
<a name="l00410"></a>00410       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;4; ++i)
<a name="l00411"></a>00411         pyr_base[i] = this-&gt;<a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a>[sub_pyr[n][i]];
<a name="l00412"></a>00412       
<a name="l00413"></a>00413       <span class="comment">// Compute diff vectors</span>
<a name="l00414"></a>00414       <a class="code" href="classPoint.php">Point</a> a ( *pyr_base[0] - R );
<a name="l00415"></a>00415       <a class="code" href="classPoint.php">Point</a> b ( *pyr_base[1] - *pyr_base[3] );
<a name="l00416"></a>00416       <a class="code" href="classPoint.php">Point</a> c ( *pyr_base[2] - *pyr_base[0] );
<a name="l00417"></a>00417       <a class="code" href="classPoint.php">Point</a> d ( *pyr_base[3] - *pyr_base[0] );
<a name="l00418"></a>00418       <a class="code" href="classPoint.php">Point</a> e ( *pyr_base[1] - *pyr_base[0] );
<a name="l00419"></a>00419 
<a name="l00420"></a>00420       <span class="comment">// Compute pyramid volume</span>
<a name="l00421"></a>00421       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> sub_vol = (1./6.)*(a*(b.<a class="code" href="classTypeVector.php#a1347e1223f3e31f8a2c0496736e60dc5">cross</a>(c))) + (1./12.)*(c*(d.<a class="code" href="classTypeVector.php#a1347e1223f3e31f8a2c0496736e60dc5">cross</a>(e)));
<a name="l00422"></a>00422 
<a name="l00423"></a>00423       libmesh_assert (sub_vol&gt;0.);
<a name="l00424"></a>00424 
<a name="l00425"></a>00425       vol += sub_vol;
<a name="l00426"></a>00426     }
<a name="l00427"></a>00427   
<a name="l00428"></a>00428   <span class="keywordflow">return</span> vol;
<a name="l00429"></a>00429 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
