<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1665b3ccb6c776ec6797fe204e2359e5.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>cell_hex.C</h1>  </div>
</div>
<div class="contents">
<a href="cell__hex_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_hex.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::min, std::max</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;cell_hex.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;cell_hex8.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;face_quad4.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00033"></a>00033 <span class="comment">// Hex class member functions</span>
<a name="l00034"></a><a class="code" href="classHex.php#a1621dabb5a5b4a087a4406d1620b5a1b">00034</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classHex.php#a1621dabb5a5b4a087a4406d1620b5a1b">Hex::key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00035"></a>00035 <span class="keyword"></span>{
<a name="l00036"></a>00036   libmesh_assert (s &lt; this-&gt;<a class="code" href="classHex.php#add801d90fe993236069c69ee46003731">n_sides</a>());
<a name="l00037"></a>00037 
<a name="l00038"></a>00038   <span class="comment">// Think of a unit cube: (-1,1) x (-1,1)x (-1,1)</span>
<a name="l00039"></a>00039   <span class="keywordflow">switch</span> (s)
<a name="l00040"></a>00040     {
<a name="l00041"></a>00041     <span class="keywordflow">case</span> 0:  <span class="comment">// the face at z = -1</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043       <span class="keywordflow">return</span>
<a name="l00044"></a>00044         this-&gt;<a class="code" href="classElem.php#a859c8236824914afa005cacf1ee86959">compute_key</a> (this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0),
<a name="l00045"></a>00045                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3),
<a name="l00046"></a>00046                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2),
<a name="l00047"></a>00047                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1));
<a name="l00048"></a>00048       
<a name="l00049"></a>00049     <span class="keywordflow">case</span> 1:  <span class="comment">// the face at y = -1</span>
<a name="l00050"></a>00050 
<a name="l00051"></a>00051       <span class="keywordflow">return</span>
<a name="l00052"></a>00052         this-&gt;<a class="code" href="classElem.php#a859c8236824914afa005cacf1ee86959">compute_key</a> (this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0),
<a name="l00053"></a>00053                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1),
<a name="l00054"></a>00054                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(5),
<a name="l00055"></a>00055                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(4));
<a name="l00056"></a>00056       
<a name="l00057"></a>00057     <span class="keywordflow">case</span> 2:  <span class="comment">// the face at x = 1</span>
<a name="l00058"></a>00058 
<a name="l00059"></a>00059       <span class="keywordflow">return</span>
<a name="l00060"></a>00060         this-&gt;<a class="code" href="classElem.php#a859c8236824914afa005cacf1ee86959">compute_key</a> (this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1),
<a name="l00061"></a>00061                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2),
<a name="l00062"></a>00062                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(6),
<a name="l00063"></a>00063                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(5));
<a name="l00064"></a>00064 
<a name="l00065"></a>00065     <span class="keywordflow">case</span> 3: <span class="comment">// the face at y = 1</span>
<a name="l00066"></a>00066 
<a name="l00067"></a>00067       <span class="keywordflow">return</span>
<a name="l00068"></a>00068         this-&gt;<a class="code" href="classElem.php#a859c8236824914afa005cacf1ee86959">compute_key</a> (this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2),
<a name="l00069"></a>00069                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3),
<a name="l00070"></a>00070                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(7),
<a name="l00071"></a>00071                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(6));
<a name="l00072"></a>00072       
<a name="l00073"></a>00073     <span class="keywordflow">case</span> 4: <span class="comment">// the face at x = -1</span>
<a name="l00074"></a>00074       
<a name="l00075"></a>00075       <span class="keywordflow">return</span>
<a name="l00076"></a>00076         this-&gt;<a class="code" href="classElem.php#a859c8236824914afa005cacf1ee86959">compute_key</a> (this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3),
<a name="l00077"></a>00077                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0),
<a name="l00078"></a>00078                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(4),
<a name="l00079"></a>00079                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(7));
<a name="l00080"></a>00080 
<a name="l00081"></a>00081     <span class="keywordflow">case</span> 5: <span class="comment">// the face at z = 1</span>
<a name="l00082"></a>00082 
<a name="l00083"></a>00083       <span class="keywordflow">return</span>
<a name="l00084"></a>00084         this-&gt;<a class="code" href="classElem.php#a859c8236824914afa005cacf1ee86959">compute_key</a> (this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(4),
<a name="l00085"></a>00085                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(5),
<a name="l00086"></a>00086                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(6),
<a name="l00087"></a>00087                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(7));      
<a name="l00088"></a>00088     }
<a name="l00089"></a>00089 
<a name="l00090"></a>00090   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00091"></a>00091   libmesh_error();
<a name="l00092"></a>00092   <span class="keywordflow">return</span> 0;
<a name="l00093"></a>00093 }
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a><a class="code" href="classHex.php#aed0a65f7f80d35bac11b2de4fae558e0">00097</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> <a class="code" href="classHex.php#aed0a65f7f80d35bac11b2de4fae558e0">Hex::side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00098"></a>00098 <span class="keyword"></span>{
<a name="l00099"></a>00099   libmesh_assert (i &lt; this-&gt;<a class="code" href="classHex.php#add801d90fe993236069c69ee46003731">n_sides</a>());
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   
<a name="l00103"></a>00103   <a class="code" href="classElem.php">Elem</a>* face = <span class="keyword">new</span> <a class="code" href="classQuad4.php">Quad4</a>;
<a name="l00104"></a>00104 
<a name="l00105"></a>00105   <span class="comment">// Think of a unit cube: (-1,1) x (-1,1)x (-1,1)</span>
<a name="l00106"></a>00106   <span class="keywordflow">switch</span> (i)
<a name="l00107"></a>00107     {
<a name="l00108"></a>00108     <span class="keywordflow">case</span> 0:  <span class="comment">// the face at z = -1</span>
<a name="l00109"></a>00109       {
<a name="l00110"></a>00110         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00111"></a>00111         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00112"></a>00112         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00113"></a>00113         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00114"></a>00114 
<a name="l00115"></a>00115         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> ap(face);
<a name="l00116"></a>00116         <span class="keywordflow">return</span> ap;
<a name="l00117"></a>00117       }
<a name="l00118"></a>00118     <span class="keywordflow">case</span> 1:  <span class="comment">// the face at y = -1</span>
<a name="l00119"></a>00119       {
<a name="l00120"></a>00120         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00121"></a>00121         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00122"></a>00122         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(5);
<a name="l00123"></a>00123         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(4);
<a name="l00124"></a>00124         
<a name="l00125"></a>00125         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> ap(face);
<a name="l00126"></a>00126         <span class="keywordflow">return</span> ap;
<a name="l00127"></a>00127       }
<a name="l00128"></a>00128     <span class="keywordflow">case</span> 2:  <span class="comment">// the face at x = 1</span>
<a name="l00129"></a>00129       {
<a name="l00130"></a>00130         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00131"></a>00131         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00132"></a>00132         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(6);
<a name="l00133"></a>00133         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(5);
<a name="l00134"></a>00134 
<a name="l00135"></a>00135         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> ap(face);
<a name="l00136"></a>00136         <span class="keywordflow">return</span> ap;
<a name="l00137"></a>00137       }
<a name="l00138"></a>00138     <span class="keywordflow">case</span> 3: <span class="comment">// the face at y = 1</span>
<a name="l00139"></a>00139       {
<a name="l00140"></a>00140         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00141"></a>00141         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00142"></a>00142         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(7);
<a name="l00143"></a>00143         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(6);
<a name="l00144"></a>00144         
<a name="l00145"></a>00145         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> ap(face);
<a name="l00146"></a>00146         <span class="keywordflow">return</span> ap;
<a name="l00147"></a>00147       }
<a name="l00148"></a>00148     <span class="keywordflow">case</span> 4: <span class="comment">// the face at x = -1</span>
<a name="l00149"></a>00149       {
<a name="l00150"></a>00150         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00151"></a>00151         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00152"></a>00152         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(4);
<a name="l00153"></a>00153         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(7);
<a name="l00154"></a>00154 
<a name="l00155"></a>00155         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> ap(face);
<a name="l00156"></a>00156         <span class="keywordflow">return</span> ap;
<a name="l00157"></a>00157       }
<a name="l00158"></a>00158     <span class="keywordflow">case</span> 5: <span class="comment">// the face at z = 1</span>
<a name="l00159"></a>00159       {
<a name="l00160"></a>00160         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(4);
<a name="l00161"></a>00161         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(5);
<a name="l00162"></a>00162         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(6);
<a name="l00163"></a>00163         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(7);
<a name="l00164"></a>00164         
<a name="l00165"></a>00165         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> ap(face);
<a name="l00166"></a>00166         <span class="keywordflow">return</span> ap;
<a name="l00167"></a>00167       }
<a name="l00168"></a>00168     <span class="keywordflow">default</span>:
<a name="l00169"></a>00169       {
<a name="l00170"></a>00170         libmesh_error();
<a name="l00171"></a>00171         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> ap(face);
<a name="l00172"></a>00172         <span class="keywordflow">return</span> ap;
<a name="l00173"></a>00173       }
<a name="l00174"></a>00174     }
<a name="l00175"></a>00175 
<a name="l00176"></a>00176   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00177"></a>00177   libmesh_error();
<a name="l00178"></a>00178   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> ap(face);
<a name="l00179"></a>00179   <span class="keywordflow">return</span> ap;
<a name="l00180"></a>00180 }
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 
<a name="l00184"></a><a class="code" href="classHex.php#a20d5cf2581f924b30b76cb92d5e3cc88">00184</a> <span class="keywordtype">bool</span> <a class="code" href="classHex.php#a20d5cf2581f924b30b76cb92d5e3cc88">Hex::is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00185"></a>00185                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00186"></a>00186 <span class="keyword"></span>{
<a name="l00187"></a>00187   libmesh_assert (c &lt; this-&gt;<a class="code" href="classHex.php#a49a11cc793d08bb82bed9aaec6130b30">n_children</a>());
<a name="l00188"></a>00188   libmesh_assert (s &lt; this-&gt;<a class="code" href="classHex.php#add801d90fe993236069c69ee46003731">n_sides</a>());
<a name="l00189"></a>00189 
<a name="l00190"></a>00190   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 4; ++i)
<a name="l00191"></a>00191     <span class="keywordflow">if</span> (<a class="code" href="classHex8.php#a6847e22fe32c16f13897be904734d580">Hex8::side_nodes_map</a>[s][i] == c)
<a name="l00192"></a>00192       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00193"></a>00193   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00194"></a>00194 }
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a><a class="code" href="classHex.php#a20fc5bf67bd1cc532c3bf94c5869795d">00198</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classHex.php#a20fc5bf67bd1cc532c3bf94c5869795d">Hex::quality</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q)<span class="keyword"> const</span>
<a name="l00199"></a>00199 <span class="keyword"></span>{
<a name="l00200"></a>00200   <span class="keywordflow">switch</span> (q)
<a name="l00201"></a>00201     {
<a name="l00202"></a>00202       
<a name="l00207"></a>00207     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a89d0f252b1485d9b6012ffde9431e227">DIAGONAL</a>:
<a name="l00208"></a>00208       {
<a name="l00209"></a>00209         <span class="comment">// Diagonal between node 0 and node 6</span>
<a name="l00210"></a>00210         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> d06 = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(0,6);
<a name="l00211"></a>00211 
<a name="l00212"></a>00212         <span class="comment">// Diagonal between node 3 and node 5</span>
<a name="l00213"></a>00213         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> d35 = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(3,5);
<a name="l00214"></a>00214 
<a name="l00215"></a>00215         <span class="comment">// Diagonal between node 1 and node 7</span>
<a name="l00216"></a>00216         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> d17 = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(1,7);
<a name="l00217"></a>00217 
<a name="l00218"></a>00218         <span class="comment">// Diagonal between node 2 and node 4 </span>
<a name="l00219"></a>00219         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> d24 = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(2,4);
<a name="l00220"></a>00220 
<a name="l00221"></a>00221         <span class="comment">// Find the biggest and smallest diagonals</span>
<a name="l00222"></a>00222         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a> = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d06, <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d35, <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d17, d24)));
<a name="l00223"></a>00223         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a> = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d06, <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d35, <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d17, d24)));
<a name="l00224"></a>00224 
<a name="l00225"></a>00225         libmesh_assert (max != 0.0);
<a name="l00226"></a>00226         
<a name="l00227"></a>00227         <span class="keywordflow">return</span> min / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>;
<a name="l00228"></a>00228 
<a name="l00229"></a>00229         <span class="keywordflow">break</span>;
<a name="l00230"></a>00230       }
<a name="l00231"></a>00231 
<a name="l00236"></a>00236     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a74f44b3ae7234b35337fbd0c71b112af">TAPER</a>:
<a name="l00237"></a>00237       {
<a name="l00238"></a>00238 
<a name="l00242"></a>00242         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> d01 = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(0,1);
<a name="l00243"></a>00243         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> d12 = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(1,2);
<a name="l00244"></a>00244         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> d23 = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(2,3);
<a name="l00245"></a>00245         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> d03 = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(0,3);
<a name="l00246"></a>00246         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> d45 = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(4,5);
<a name="l00247"></a>00247         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> d56 = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(5,6);
<a name="l00248"></a>00248         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> d67 = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(6,7);
<a name="l00249"></a>00249         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> d47 = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(4,7);
<a name="l00250"></a>00250         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> d04 = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(0,4);
<a name="l00251"></a>00251         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> d15 = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(1,5);
<a name="l00252"></a>00252         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> d37 = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(3,7);
<a name="l00253"></a>00253         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> d26 = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(2,6);
<a name="l00254"></a>00254 
<a name="l00255"></a>00255         std::vector&lt;Real&gt; edge_ratios(12);
<a name="l00256"></a>00256         <span class="comment">// Front</span>
<a name="l00257"></a>00257         edge_ratios[0] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d01, d45) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d01, d45);
<a name="l00258"></a>00258         edge_ratios[1] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d04, d15) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d04, d15);
<a name="l00259"></a>00259 
<a name="l00260"></a>00260         <span class="comment">// Right</span>
<a name="l00261"></a>00261         edge_ratios[2] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d15, d26) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d15, d26);
<a name="l00262"></a>00262         edge_ratios[3] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d12, d56) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d12, d56);
<a name="l00263"></a>00263 
<a name="l00264"></a>00264         <span class="comment">// Back</span>
<a name="l00265"></a>00265         edge_ratios[4] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d67, d23) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d67, d23);
<a name="l00266"></a>00266         edge_ratios[5] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d26, d37) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d26, d37);
<a name="l00267"></a>00267 
<a name="l00268"></a>00268         <span class="comment">// Left</span>
<a name="l00269"></a>00269         edge_ratios[6] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d04, d37) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d04, d37);
<a name="l00270"></a>00270         edge_ratios[7] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d03, d47) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d03, d47);
<a name="l00271"></a>00271 
<a name="l00272"></a>00272         <span class="comment">// Bottom</span>
<a name="l00273"></a>00273         edge_ratios[8] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d01, d23) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d01, d23);
<a name="l00274"></a>00274         edge_ratios[9] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d03, d12) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d03, d12);
<a name="l00275"></a>00275 
<a name="l00276"></a>00276         <span class="comment">// Top</span>
<a name="l00277"></a>00277         edge_ratios[10] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d45, d67) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d45, d67);
<a name="l00278"></a>00278         edge_ratios[11] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d56, d47) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d56, d47);
<a name="l00279"></a>00279         
<a name="l00280"></a>00280         <span class="keywordflow">return</span> *(std::min_element(edge_ratios.begin(), edge_ratios.end())) ;
<a name="l00281"></a>00281 
<a name="l00282"></a>00282         <span class="keywordflow">break</span>;
<a name="l00283"></a>00283       }
<a name="l00284"></a>00284 
<a name="l00285"></a>00285 
<a name="l00290"></a>00290     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad7b656d7a4cdf057a09a9a9c328c5b3a">STRETCH</a>:
<a name="l00291"></a>00291       {
<a name="l00292"></a>00292         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> sqrt3 = 1.73205080756888;
<a name="l00293"></a>00293 
<a name="l00297"></a>00297         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> d06 = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(0,6);
<a name="l00298"></a>00298         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> d17 = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(1,7);
<a name="l00299"></a>00299         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> d35 = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(3,5);
<a name="l00300"></a>00300         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> d24 = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(2,4);
<a name="l00301"></a>00301         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> max_diag = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d06, <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d17, <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d35, d24)));
<a name="l00302"></a>00302 
<a name="l00303"></a>00303         libmesh_assert ( max_diag != 0.0 );
<a name="l00304"></a>00304 
<a name="l00308"></a>00308         std::vector&lt;Real&gt; edges(12);
<a name="l00309"></a>00309         edges[0]  = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(0,1);
<a name="l00310"></a>00310         edges[1]  = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(1,2);
<a name="l00311"></a>00311         edges[2]  = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(2,3);
<a name="l00312"></a>00312         edges[3]  = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(0,3);
<a name="l00313"></a>00313         edges[4]  = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(4,5);
<a name="l00314"></a>00314         edges[5]  = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(5,6);
<a name="l00315"></a>00315         edges[6]  = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(6,7);
<a name="l00316"></a>00316         edges[7]  = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(4,7);
<a name="l00317"></a>00317         edges[8]  = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(0,4);
<a name="l00318"></a>00318         edges[9]  = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(1,5);
<a name="l00319"></a>00319         edges[10] = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(2,6);
<a name="l00320"></a>00320         edges[11] = this-&gt;<a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a>(3,7);
<a name="l00321"></a>00321 
<a name="l00322"></a>00322         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> min_edge = *(std::min_element(edges.begin(), edges.end()));
<a name="l00323"></a>00323         <span class="keywordflow">return</span> sqrt3 * min_edge / max_diag ;
<a name="l00324"></a>00324         <span class="keywordflow">break</span>;
<a name="l00325"></a>00325       }
<a name="l00326"></a>00326 
<a name="l00327"></a>00327       
<a name="l00332"></a>00332     <span class="keywordflow">default</span>:
<a name="l00333"></a>00333       {
<a name="l00334"></a>00334         <span class="keywordflow">return</span> <a class="code" href="classHex.php#a20fc5bf67bd1cc532c3bf94c5869795d">Elem::quality</a>(q);
<a name="l00335"></a>00335       }
<a name="l00336"></a>00336     }
<a name="l00337"></a>00337 
<a name="l00338"></a>00338     
<a name="l00339"></a>00339     <span class="comment">// Will never get here...</span>
<a name="l00340"></a>00340     libmesh_error();
<a name="l00341"></a>00341     <span class="keywordflow">return</span> 0.;
<a name="l00342"></a>00342 }
<a name="l00343"></a>00343 
<a name="l00344"></a>00344 
<a name="l00345"></a>00345 
<a name="l00346"></a><a class="code" href="classHex.php#ae354eeee58c19bf40e8f3fb2c181664c">00346</a> std::pair&lt;Real, Real&gt; <a class="code" href="classHex.php#ae354eeee58c19bf40e8f3fb2c181664c">Hex::qual_bounds</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q)<span class="keyword"> const</span>
<a name="l00347"></a>00347 <span class="keyword"></span>{
<a name="l00348"></a>00348   std::pair&lt;Real, Real&gt; bounds;
<a name="l00349"></a>00349   
<a name="l00350"></a>00350   <span class="keywordflow">switch</span> (q)
<a name="l00351"></a>00351     {
<a name="l00352"></a>00352 
<a name="l00353"></a>00353     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad84ce9cc13267ffa231163dc658d5e23">ASPECT_RATIO</a>:
<a name="l00354"></a>00354       bounds.first  = 1.;
<a name="l00355"></a>00355       bounds.second = 4.;
<a name="l00356"></a>00356       <span class="keywordflow">break</span>;
<a name="l00357"></a>00357       
<a name="l00358"></a>00358     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a221d6d85c3c750560623002387ab06b2">SKEW</a>:
<a name="l00359"></a>00359       bounds.first  = 0.;
<a name="l00360"></a>00360       bounds.second = 0.5;
<a name="l00361"></a>00361       <span class="keywordflow">break</span>;
<a name="l00362"></a>00362 
<a name="l00363"></a>00363     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a41601385ca9d2f055200e85cfe782e5b">SHEAR</a>:
<a name="l00364"></a>00364     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a44883df285a1b32254467277e46343df">SHAPE</a>:
<a name="l00365"></a>00365       bounds.first  = 0.3;
<a name="l00366"></a>00366       bounds.second = 1.;
<a name="l00367"></a>00367       <span class="keywordflow">break</span>;
<a name="l00368"></a>00368 
<a name="l00369"></a>00369     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a29e1db5c60b32bcee224ac441c04274b">CONDITION</a>:
<a name="l00370"></a>00370       bounds.first  = 1.;
<a name="l00371"></a>00371       bounds.second = 8.;
<a name="l00372"></a>00372       <span class="keywordflow">break</span>;
<a name="l00373"></a>00373 
<a name="l00374"></a>00374     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012adce510f6954c2ac2cd6b1c6bf91210cc">JACOBIAN</a>:
<a name="l00375"></a>00375       bounds.first  = 0.5;
<a name="l00376"></a>00376       bounds.second = 1.;
<a name="l00377"></a>00377       <span class="keywordflow">break</span>;  
<a name="l00378"></a>00378       
<a name="l00379"></a>00379     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a3fe96cbcdc284192e960220fc49fa942">DISTORTION</a>:
<a name="l00380"></a>00380       bounds.first  = 0.6;
<a name="l00381"></a>00381       bounds.second = 1.;
<a name="l00382"></a>00382       <span class="keywordflow">break</span>;  
<a name="l00383"></a>00383 
<a name="l00384"></a>00384     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a74f44b3ae7234b35337fbd0c71b112af">TAPER</a>:
<a name="l00385"></a>00385       bounds.first  = 0.;
<a name="l00386"></a>00386       bounds.second = 0.4;
<a name="l00387"></a>00387       <span class="keywordflow">break</span>;
<a name="l00388"></a>00388       
<a name="l00389"></a>00389     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad7b656d7a4cdf057a09a9a9c328c5b3a">STRETCH</a>:
<a name="l00390"></a>00390       bounds.first  = 0.25;
<a name="l00391"></a>00391       bounds.second = 1.;
<a name="l00392"></a>00392       <span class="keywordflow">break</span>;
<a name="l00393"></a>00393       
<a name="l00394"></a>00394     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a89d0f252b1485d9b6012ffde9431e227">DIAGONAL</a>:
<a name="l00395"></a>00395       bounds.first  = 0.65;
<a name="l00396"></a>00396       bounds.second = 1.;
<a name="l00397"></a>00397       <span class="keywordflow">break</span>;
<a name="l00398"></a>00398 
<a name="l00399"></a>00399     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012afe883232d33e91404f7669f2aab854a6">SIZE</a>:
<a name="l00400"></a>00400       bounds.first  = 0.5;
<a name="l00401"></a>00401       bounds.second = 1.;
<a name="l00402"></a>00402       <span class="keywordflow">break</span>;
<a name="l00403"></a>00403       
<a name="l00404"></a>00404     <span class="keywordflow">default</span>:
<a name="l00405"></a>00405       std::cout &lt;&lt; <span class="stringliteral">&quot;Warning: Invalid quality measure chosen.&quot;</span> &lt;&lt; std::endl;
<a name="l00406"></a>00406       bounds.first  = -1;
<a name="l00407"></a>00407       bounds.second = -1;
<a name="l00408"></a>00408     }
<a name="l00409"></a>00409 
<a name="l00410"></a>00410   <span class="keywordflow">return</span> bounds;
<a name="l00411"></a>00411 }
<a name="l00412"></a>00412 
<a name="l00413"></a>00413 
<a name="l00414"></a>00414 
<a name="l00415"></a>00415 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classHex.php#a720e4b95cc878516fef569c1dc856d82">Hex::_second_order_vertex_child_number</a>[27] =
<a name="l00416"></a>00416 {
<a name="l00417"></a>00417   99,99,99,99,99,99,99,99, <span class="comment">// Vertices</span>
<a name="l00418"></a>00418   0,1,2,0,0,1,2,3,4,5,6,5, <span class="comment">// Edges</span>
<a name="l00419"></a>00419   0,0,1,2,0,4,             <span class="comment">// Faces</span>
<a name="l00420"></a>00420   0                        <span class="comment">// Interior</span>
<a name="l00421"></a>00421 };
<a name="l00422"></a>00422 
<a name="l00423"></a>00423 
<a name="l00424"></a>00424 
<a name="l00425"></a>00425 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classHex.php#afdb88b84b0a7f31864786b3a3f8d7969">Hex::_second_order_vertex_child_index</a>[27] =
<a name="l00426"></a>00426 {
<a name="l00427"></a>00427   99,99,99,99,99,99,99,99, <span class="comment">// Vertices</span>
<a name="l00428"></a>00428   1,2,3,3,4,5,6,7,5,6,7,7, <span class="comment">// Edges</span>
<a name="l00429"></a>00429   2,5,6,7,7,6,             <span class="comment">// Faces</span>
<a name="l00430"></a>00430   6                        <span class="comment">// Interior</span>
<a name="l00431"></a>00431 };
<a name="l00432"></a>00432 
<a name="l00433"></a>00433 
<a name="l00434"></a>00434 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classHex.php#ae4a983049fc2584356208c65d11b20f5">Hex::_second_order_adjacent_vertices</a>[12][2] = 
<a name="l00435"></a>00435 {
<a name="l00436"></a>00436   { 0,  1}, <span class="comment">// vertices adjacent to node 8 </span>
<a name="l00437"></a>00437   { 1,  2}, <span class="comment">// vertices adjacent to node 9 </span>
<a name="l00438"></a>00438   { 2,  3}, <span class="comment">// vertices adjacent to node 10 </span>
<a name="l00439"></a>00439   { 0,  3}, <span class="comment">// vertices adjacent to node 11</span>
<a name="l00440"></a>00440 
<a name="l00441"></a>00441   { 0,  4}, <span class="comment">// vertices adjacent to node 12</span>
<a name="l00442"></a>00442   { 1,  5}, <span class="comment">// vertices adjacent to node 13</span>
<a name="l00443"></a>00443   { 2,  6}, <span class="comment">// vertices adjacent to node 14</span>
<a name="l00444"></a>00444   { 3,  7}, <span class="comment">// vertices adjacent to node 15</span>
<a name="l00445"></a>00445 
<a name="l00446"></a>00446   { 4,  5}, <span class="comment">// vertices adjacent to node 16</span>
<a name="l00447"></a>00447   { 5,  6}, <span class="comment">// vertices adjacent to node 17</span>
<a name="l00448"></a>00448   { 6,  7}, <span class="comment">// vertices adjacent to node 18</span>
<a name="l00449"></a>00449   { 4,  7}  <span class="comment">// vertices adjacent to node 19</span>
<a name="l00450"></a>00450 };
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
