<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1665b3ccb6c776ec6797fe204e2359e5.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>cell_inf_hex16.C</h1>  </div>
</div>
<div class="contents">
<a href="cell__inf__hex16_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_inf_hex16.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// Local includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes cont&#39;d</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;cell_inf_hex16.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;edge_edge3.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;edge_inf_edge2.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;face_quad8.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;face_inf_quad6.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;side.h&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00037"></a>00037 <span class="comment">// InfHex16 class static member initializations</span>
<a name="l00038"></a>00038 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex16.php#a793ea9d007dc06b231300689de7f7378">InfHex16::side_nodes_map</a>[5][8] =
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040   { 0, 1, 2, 3, 8, 9, 10, 11},   <span class="comment">// Side 0</span>
<a name="l00041"></a>00041   { 0, 1, 4, 5, 8, 12, 99, 99},  <span class="comment">// Side 1</span>
<a name="l00042"></a>00042   { 1, 2, 5, 6, 9, 13, 99, 99},  <span class="comment">// Side 2</span>
<a name="l00043"></a>00043   { 2, 3, 6, 7, 10, 14, 99, 99}, <span class="comment">// Side 3</span>
<a name="l00044"></a>00044   { 3, 0, 7, 4, 11, 15, 99, 99}  <span class="comment">// Side 4</span>
<a name="l00045"></a>00045 };
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex16.php#affb989b12d5324903603687d2dba2c9c">InfHex16::edge_nodes_map</a>[8][3] =
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049   { 0, 1, 8},  <span class="comment">// Side 0</span>
<a name="l00050"></a>00050   { 1, 2, 9},  <span class="comment">// Side 1</span>
<a name="l00051"></a>00051   { 2, 3, 10}, <span class="comment">// Side 2</span>
<a name="l00052"></a>00052   { 0, 3, 11}, <span class="comment">// Side 3</span>
<a name="l00053"></a>00053   { 0, 4, 99}, <span class="comment">// Side 4</span>
<a name="l00054"></a>00054   { 1, 5, 99}, <span class="comment">// Side 5</span>
<a name="l00055"></a>00055   { 2, 6, 99}, <span class="comment">// Side 6</span>
<a name="l00056"></a>00056   { 3, 7, 99}  <span class="comment">// Side 7</span>
<a name="l00057"></a>00057 };
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00061"></a>00061 <span class="comment">// InfHex16 class member functions</span>
<a name="l00062"></a>00062 
<a name="l00063"></a><a class="code" href="classInfHex16.php#a0007edc761d761e41ff6ebf7fb725444">00063</a> <span class="keywordtype">bool</span> <a class="code" href="classInfHex16.php#a0007edc761d761e41ff6ebf7fb725444">InfHex16::is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00064"></a>00064 <span class="keyword"></span>{
<a name="l00065"></a>00065   <span class="keywordflow">if</span> (i &lt; 4)
<a name="l00066"></a>00066     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00067"></a>00067   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00068"></a>00068 }
<a name="l00069"></a>00069 
<a name="l00070"></a><a class="code" href="classInfHex16.php#acfda0416d277f59701643ed48ce4ff30">00070</a> <span class="keywordtype">bool</span> <a class="code" href="classInfHex16.php#acfda0416d277f59701643ed48ce4ff30">InfHex16::is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00071"></a>00071 <span class="keyword"></span>{
<a name="l00072"></a>00072   <span class="keywordflow">if</span> (i &lt; 4)
<a name="l00073"></a>00073     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00074"></a>00074   <span class="keywordflow">if</span> (i &gt; 11)
<a name="l00075"></a>00075     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00076"></a>00076   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00077"></a>00077 }
<a name="l00078"></a>00078 
<a name="l00079"></a><a class="code" href="classInfHex16.php#adb1d3dfe5d798eed22c50f6eab44c7a2">00079</a> <span class="keywordtype">bool</span> <a class="code" href="classInfHex16.php#adb1d3dfe5d798eed22c50f6eab44c7a2">InfHex16::is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00080"></a>00080 <span class="keyword"></span>{
<a name="l00081"></a>00081   <span class="keywordflow">if</span> (i &gt; 11)
<a name="l00082"></a>00082     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00083"></a>00083   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00084"></a>00084 }
<a name="l00085"></a>00085 
<a name="l00086"></a><a class="code" href="classInfHex16.php#a047ddd03a0ed44a812ffd638d88335e3">00086</a> <span class="keywordtype">bool</span> <a class="code" href="classInfHex16.php#a047ddd03a0ed44a812ffd638d88335e3">InfHex16::is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00087"></a>00087                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00088"></a>00088 <span class="keyword"></span>{
<a name="l00089"></a>00089   libmesh_assert(s &lt; <a class="code" href="classInfHex.php#a5eaab4848a84970b67843470f5dad072">n_sides</a>());
<a name="l00090"></a>00090   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 8; ++i)
<a name="l00091"></a>00091     <span class="keywordflow">if</span> (<a class="code" href="classInfHex16.php#a793ea9d007dc06b231300689de7f7378">side_nodes_map</a>[s][i] == n)
<a name="l00092"></a>00092       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00093"></a>00093   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00094"></a>00094 }
<a name="l00095"></a>00095 
<a name="l00096"></a><a class="code" href="classInfHex16.php#a5df1e4027d1462e8de9723b1109a64c3">00096</a> <span class="keywordtype">bool</span> <a class="code" href="classInfHex16.php#a5df1e4027d1462e8de9723b1109a64c3">InfHex16::is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00097"></a>00097                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00098"></a>00098 <span class="keyword"></span>{
<a name="l00099"></a>00099   libmesh_assert(e &lt; <a class="code" href="classInfHex.php#af118b4b04772734c29f4c91ca3982917">n_edges</a>());
<a name="l00100"></a>00100   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 3; ++i)
<a name="l00101"></a>00101     <span class="keywordflow">if</span> (<a class="code" href="classInfHex16.php#affb989b12d5324903603687d2dba2c9c">edge_nodes_map</a>[e][i] == n)
<a name="l00102"></a>00102       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00103"></a>00103   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00104"></a>00104 }
<a name="l00105"></a>00105 
<a name="l00106"></a><a class="code" href="classInfHex16.php#a863251b33507165bcdcd0d8c4c9cccb6">00106</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classInfHex16.php#a863251b33507165bcdcd0d8c4c9cccb6">InfHex16::build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00107"></a>00107                                     <span class="keywordtype">bool</span> proxy)<span class="keyword"> const</span>
<a name="l00108"></a>00108 <span class="keyword"></span>{
<a name="l00109"></a>00109   libmesh_assert (i &lt; this-&gt;<a class="code" href="classInfHex.php#a5eaab4848a84970b67843470f5dad072">n_sides</a>());
<a name="l00110"></a>00110 
<a name="l00111"></a>00111   <span class="keywordflow">if</span> (proxy)
<a name="l00112"></a>00112     {
<a name="l00113"></a>00113       <span class="keywordflow">switch</span> (i)
<a name="l00114"></a>00114         {
<a name="l00115"></a>00115           <span class="comment">// base</span>
<a name="l00116"></a>00116         <span class="keywordflow">case</span> 0:
<a name="l00117"></a>00117           {
<a name="l00118"></a>00118             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classSide.php">Side&lt;Quad8,InfHex16&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00119"></a>00119             <span class="keywordflow">return</span> ap;
<a name="l00120"></a>00120           }
<a name="l00121"></a>00121           <span class="comment">// ifem sides</span>
<a name="l00122"></a>00122         <span class="keywordflow">case</span> 1:
<a name="l00123"></a>00123         <span class="keywordflow">case</span> 2:
<a name="l00124"></a>00124         <span class="keywordflow">case</span> 3:
<a name="l00125"></a>00125         <span class="keywordflow">case</span> 4:
<a name="l00126"></a>00126           {
<a name="l00127"></a>00127             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classSide.php">Side&lt;InfQuad6,InfHex16&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00128"></a>00128             <span class="keywordflow">return</span> ap;
<a name="l00129"></a>00129           }
<a name="l00130"></a>00130         <span class="keywordflow">default</span>:
<a name="l00131"></a>00131           libmesh_error();
<a name="l00132"></a>00132         }
<a name="l00133"></a>00133     }
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   <span class="keywordflow">else</span>
<a name="l00136"></a>00136     {
<a name="l00137"></a>00137       <span class="comment">// Think of a unit cube: (-1,1) x (-1,1)x (1,1)</span>
<a name="l00138"></a>00138       <span class="keywordflow">switch</span> (i)
<a name="l00139"></a>00139         {
<a name="l00140"></a>00140         <span class="keywordflow">case</span> 0: <span class="comment">// the base face</span>
<a name="l00141"></a>00141           {
<a name="l00142"></a>00142             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classQuad8.php">Quad8</a>);
<a name="l00143"></a>00143 
<a name="l00144"></a>00144             <span class="comment">// Only here, the face element&#39;s normal points inward</span>
<a name="l00145"></a>00145             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00146"></a>00146             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00147"></a>00147             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00148"></a>00148             face-&gt;set_node(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00149"></a>00149             face-&gt;set_node(4) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(8);
<a name="l00150"></a>00150             face-&gt;set_node(5) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(9);
<a name="l00151"></a>00151             face-&gt;set_node(6) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(10);
<a name="l00152"></a>00152             face-&gt;set_node(7) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(11);
<a name="l00153"></a>00153 
<a name="l00154"></a>00154             <span class="keywordflow">return</span> face;
<a name="l00155"></a>00155           }
<a name="l00156"></a>00156 
<a name="l00157"></a>00157         <span class="keywordflow">case</span> 1:  <span class="comment">// connecting to another infinite element</span>
<a name="l00158"></a>00158           {
<a name="l00159"></a>00159             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classInfQuad6.php">InfQuad6</a>);
<a name="l00160"></a>00160 
<a name="l00161"></a>00161             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00162"></a>00162             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00163"></a>00163             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(4);
<a name="l00164"></a>00164             face-&gt;set_node(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(5);
<a name="l00165"></a>00165             face-&gt;set_node(4) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(8);
<a name="l00166"></a>00166             face-&gt;set_node(5) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(12);
<a name="l00167"></a>00167 
<a name="l00168"></a>00168             <span class="keywordflow">return</span> face;
<a name="l00169"></a>00169           }
<a name="l00170"></a>00170 
<a name="l00171"></a>00171         <span class="keywordflow">case</span> 2:  <span class="comment">// connecting to another infinite element</span>
<a name="l00172"></a>00172           {
<a name="l00173"></a>00173             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classInfQuad6.php">InfQuad6</a>);
<a name="l00174"></a>00174 
<a name="l00175"></a>00175             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00176"></a>00176             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00177"></a>00177             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(5);
<a name="l00178"></a>00178             face-&gt;set_node(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(6);
<a name="l00179"></a>00179             face-&gt;set_node(4) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(9);
<a name="l00180"></a>00180             face-&gt;set_node(5) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(13);
<a name="l00181"></a>00181 
<a name="l00182"></a>00182             <span class="keywordflow">return</span> face;
<a name="l00183"></a>00183           }
<a name="l00184"></a>00184 
<a name="l00185"></a>00185         <span class="keywordflow">case</span> 3:  <span class="comment">// connecting to another infinite element</span>
<a name="l00186"></a>00186           {
<a name="l00187"></a>00187             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classInfQuad6.php">InfQuad6</a>);
<a name="l00188"></a>00188         
<a name="l00189"></a>00189             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00190"></a>00190             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00191"></a>00191             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(6);
<a name="l00192"></a>00192             face-&gt;set_node(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(7);
<a name="l00193"></a>00193             face-&gt;set_node(4) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(10);
<a name="l00194"></a>00194             face-&gt;set_node(5) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(14);
<a name="l00195"></a>00195 
<a name="l00196"></a>00196             <span class="keywordflow">return</span> face;
<a name="l00197"></a>00197           }
<a name="l00198"></a>00198 
<a name="l00199"></a>00199         <span class="keywordflow">case</span> 4:  <span class="comment">// connecting to another infinite element</span>
<a name="l00200"></a>00200           {
<a name="l00201"></a>00201             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classInfQuad6.php">InfQuad6</a>);
<a name="l00202"></a>00202 
<a name="l00203"></a>00203             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00204"></a>00204             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00205"></a>00205             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(7);
<a name="l00206"></a>00206             face-&gt;set_node(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(4);
<a name="l00207"></a>00207             face-&gt;set_node(4) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(11);
<a name="l00208"></a>00208             face-&gt;set_node(5) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(15);
<a name="l00209"></a>00209 
<a name="l00210"></a>00210             <span class="keywordflow">return</span> face;
<a name="l00211"></a>00211           }
<a name="l00212"></a>00212 
<a name="l00213"></a>00213         <span class="keywordflow">default</span>:
<a name="l00214"></a>00214           {
<a name="l00215"></a>00215             libmesh_error();
<a name="l00216"></a>00216             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00217"></a>00217           }
<a name="l00218"></a>00218         }
<a name="l00219"></a>00219     }
<a name="l00220"></a>00220 
<a name="l00221"></a>00221   
<a name="l00222"></a>00222   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00223"></a>00223   libmesh_error();
<a name="l00224"></a>00224   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00225"></a>00225 }
<a name="l00226"></a>00226 
<a name="l00227"></a><a class="code" href="classInfHex16.php#a265363abf9f058447022ac5bba2c5276">00227</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classInfHex16.php#a265363abf9f058447022ac5bba2c5276">InfHex16::build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00228"></a>00228 <span class="keyword"></span>{
<a name="l00229"></a>00229   libmesh_assert (i &lt; this-&gt;<a class="code" href="classInfHex.php#af118b4b04772734c29f4c91ca3982917">n_edges</a>());
<a name="l00230"></a>00230 
<a name="l00231"></a>00231   <span class="keywordflow">if</span> (i &lt; 4) <span class="comment">// base edges</span>
<a name="l00232"></a>00232     <span class="keywordflow">return</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a>(<span class="keyword">new</span> <a class="code" href="classSideEdge.php">SideEdge&lt;Edge3,InfHex16&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00233"></a>00233   <span class="comment">// infinite edges</span>
<a name="l00234"></a>00234   <span class="keywordflow">return</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a>(<span class="keyword">new</span> <a class="code" href="classSideEdge.php">SideEdge&lt;InfEdge2,InfHex16&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00235"></a>00235 }
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 
<a name="l00238"></a><a class="code" href="classInfHex16.php#a5fc6a618df6c71c1127beadcb8ea6866">00238</a> <span class="keywordtype">void</span> <a class="code" href="classInfHex16.php#a5fc6a618df6c71c1127beadcb8ea6866">InfHex16::connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00239"></a>00239                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00240"></a>00240                             std::vector&lt;unsigned int&gt;&amp; conn)<span class="keyword"> const</span>
<a name="l00241"></a>00241 <span class="keyword"></span>{
<a name="l00242"></a>00242   libmesh_assert (<a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a> != NULL);
<a name="l00243"></a>00243   libmesh_assert (sc &lt; this-&gt;<a class="code" href="classInfHex16.php#adab687a7db938a96efbc1a84cfa58eec">n_sub_elem</a>());
<a name="l00244"></a>00244   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00245"></a>00245 
<a name="l00246"></a>00246   <span class="keywordflow">switch</span> (iop)
<a name="l00247"></a>00247     {
<a name="l00248"></a>00248     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00249"></a>00249       {
<a name="l00250"></a>00250         <span class="keywordflow">switch</span> (sc)
<a name="l00251"></a>00251           {
<a name="l00252"></a>00252           <span class="keywordflow">case</span> 0:
<a name="l00253"></a>00253 
<a name="l00254"></a>00254             conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0)+1;
<a name="l00255"></a>00255             conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1)+1;
<a name="l00256"></a>00256             conn[2] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2)+1;
<a name="l00257"></a>00257             conn[3] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3)+1;
<a name="l00258"></a>00258             conn[4] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(4)+1;
<a name="l00259"></a>00259             conn[5] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(5)+1;
<a name="l00260"></a>00260             conn[6] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(6)+1;
<a name="l00261"></a>00261             conn[7] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(7)+1;
<a name="l00262"></a>00262             <span class="keywordflow">return</span>;
<a name="l00263"></a>00263       
<a name="l00264"></a>00264           <span class="keywordflow">default</span>:
<a name="l00265"></a>00265             libmesh_error();
<a name="l00266"></a>00266       
<a name="l00267"></a>00267           }
<a name="l00268"></a>00268       }
<a name="l00269"></a>00269 
<a name="l00270"></a>00270     <span class="keywordflow">default</span>:
<a name="l00271"></a>00271       libmesh_error();
<a name="l00272"></a>00272     }
<a name="l00273"></a>00273 
<a name="l00274"></a>00274   libmesh_error();
<a name="l00275"></a>00275 }
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 
<a name="l00278"></a>00278 
<a name="l00279"></a>00279 
<a name="l00280"></a><a class="code" href="classInfHex16.php#ada87bfe93c70a09755f5038128570eb6">00280</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex16.php#ada87bfe93c70a09755f5038128570eb6">InfHex16::second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00281"></a>00281                                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v)<span class="keyword"> const</span>
<a name="l00282"></a>00282 <span class="keyword"></span>{ 
<a name="l00283"></a>00283   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classInfHex.php#ac967186f3ed81045514b61d8ad18f03f">n_vertices</a>());
<a name="l00284"></a>00284   libmesh_assert (n &lt;  this-&gt;<a class="code" href="classInfHex16.php#a7642c153e967770fd4ebdca16542d243">n_nodes</a>());
<a name="l00285"></a>00285   libmesh_assert (v &lt;  2);
<a name="l00286"></a>00286   <span class="comment">// note that the _second_order_adjacent_vertices matrix is</span>
<a name="l00287"></a>00287   <span class="comment">// stored in \p InfHex</span>
<a name="l00288"></a>00288   <span class="keywordflow">return</span> <a class="code" href="classInfHex.php#ad376a383b93c5febee213f2baee1a799">_second_order_adjacent_vertices</a>[n-this-&gt;<a class="code" href="classInfHex.php#ac967186f3ed81045514b61d8ad18f03f">n_vertices</a>()][v]; 
<a name="l00289"></a>00289 }
<a name="l00290"></a>00290 
<a name="l00291"></a>00291 
<a name="l00292"></a>00292 
<a name="l00293"></a>00293 std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00294"></a><a class="code" href="classInfHex16.php#aee8aedfd36a2643615ebc6e4eb34a0ba">00294</a> <a class="code" href="classInfHex16.php#aee8aedfd36a2643615ebc6e4eb34a0ba">InfHex16::second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00295"></a>00295 <span class="keyword"></span>{
<a name="l00296"></a>00296   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classInfHex.php#ac967186f3ed81045514b61d8ad18f03f">n_vertices</a>());
<a name="l00297"></a>00297   libmesh_assert (n &lt; this-&gt;<a class="code" href="classInfHex16.php#a7642c153e967770fd4ebdca16542d243">n_nodes</a>());
<a name="l00298"></a>00298   <span class="comment">/*</span>
<a name="l00299"></a>00299 <span class="comment">   * the _second_order_vertex_child_* vectors are</span>
<a name="l00300"></a>00300 <span class="comment">   * stored in cell_inf_hex.C, since they are identical</span>
<a name="l00301"></a>00301 <span class="comment">   * for InfHex16 and InfHex18</span>
<a name="l00302"></a>00302 <span class="comment">   */</span>
<a name="l00303"></a>00303   <span class="keywordflow">return</span> std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00304"></a>00304     (<a class="code" href="classInfHex.php#ac15d63075635e85c1297d03606728911">_second_order_vertex_child_number</a>[n],
<a name="l00305"></a>00305      <a class="code" href="classInfHex.php#a4e086e1ae6bff9a110166e2ec7452ea8">_second_order_vertex_child_index</a>[n]);
<a name="l00306"></a>00306 }
<a name="l00307"></a>00307 
<a name="l00308"></a>00308 
<a name="l00309"></a>00309 
<a name="l00310"></a>00310 
<a name="l00311"></a>00311 
<a name="l00312"></a>00312 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00313"></a>00313 <span class="preprocessor"></span>
<a name="l00314"></a>00314 <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classInfHex16.php#ae0412e79514037774b17648c3b6dba29">InfHex16::_embedding_matrix</a>[4][16][16] =
<a name="l00315"></a>00315 {
<a name="l00316"></a>00316   <span class="comment">// embedding matrix for child 0</span>
<a name="l00317"></a>00317   {
<a name="l00318"></a>00318     <span class="comment">//          0           1           2           3           4           5           6           7           8           9          10          11          12          13          14          15 th parent Node</span>
<a name="l00319"></a>00319     {         1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 0th child N.</span>
<a name="l00320"></a>00320     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 1</span>
<a name="l00321"></a>00321     {       -0.25,      -0.25,      -0.25,      -0.25,        0.0,        0.0,        0.0,        0.0,        0.5,        0.5,        0.5,        0.5,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 2</span>
<a name="l00322"></a>00322     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 3</span>
<a name="l00323"></a>00323     {         0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 4</span>
<a name="l00324"></a>00324     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0}, <span class="comment">// 5</span>
<a name="l00325"></a>00325     {         0.0,        0.0,        0.0,        0.0,      -0.25,      -0.25,      -0.25,      -0.25,        0.0,        0.0,        0.0,        0.0,        0.5,        0.5,        0.5,        0.5}, <span class="comment">// 6</span>
<a name="l00326"></a>00326     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0}, <span class="comment">// 7</span>
<a name="l00327"></a>00327     {       0.375,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 8</span>
<a name="l00328"></a>00328     {     -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,       0.75,      0.375,       0.25,      0.375,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 9</span>
<a name="l00329"></a>00329     {     -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,      0.375,       0.25,      0.375,       0.75,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 10</span>
<a name="l00330"></a>00330     {       0.375,        0.0,        0.0,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 11</span>
<a name="l00331"></a>00331     {         0.0,        0.0,        0.0,        0.0,      0.375,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0}, <span class="comment">// 12</span>
<a name="l00332"></a>00332     {         0.0,        0.0,        0.0,        0.0,    -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,       0.75,      0.375,       0.25,      0.375}, <span class="comment">// 13</span>
<a name="l00333"></a>00333     {         0.0,        0.0,        0.0,        0.0,    -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,      0.375,       0.25,      0.375,       0.75}, <span class="comment">// 14</span>
<a name="l00334"></a>00334     {         0.0,        0.0,        0.0,        0.0,      0.375,        0.0,        0.0,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75}  <span class="comment">// 15</span>
<a name="l00335"></a>00335   },
<a name="l00336"></a>00336 
<a name="l00337"></a>00337   <span class="comment">// embedding matrix for child 1</span>
<a name="l00338"></a>00338   {
<a name="l00339"></a>00339     <span class="comment">//          0           1           2           3           4           5           6           7           8           9          10          11          12          13          14          15 th parent Node</span>
<a name="l00340"></a>00340     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 0th child N.</span>
<a name="l00341"></a>00341     {         0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 1</span>
<a name="l00342"></a>00342     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 2</span>
<a name="l00343"></a>00343     {       -0.25,      -0.25,      -0.25,      -0.25,        0.0,        0.0,        0.0,        0.0,        0.5,        0.5,        0.5,        0.5,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 3</span>
<a name="l00344"></a>00344     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0}, <span class="comment">// 4</span>
<a name="l00345"></a>00345     {         0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 5</span>
<a name="l00346"></a>00346     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0}, <span class="comment">// 6</span>
<a name="l00347"></a>00347     {         0.0,        0.0,        0.0,        0.0,      -0.25,      -0.25,      -0.25,      -0.25,        0.0,        0.0,        0.0,        0.0,        0.5,        0.5,        0.5,        0.5}, <span class="comment">// 7</span>
<a name="l00348"></a>00348     {      -0.125,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 8</span>
<a name="l00349"></a>00349     {         0.0,      0.375,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 9</span>
<a name="l00350"></a>00350     {     -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,      0.375,       0.75,      0.375,       0.25,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 10</span>
<a name="l00351"></a>00351     {     -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,       0.75,      0.375,       0.25,      0.375,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 11</span>
<a name="l00352"></a>00352     {         0.0,        0.0,        0.0,        0.0,     -0.125,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0}, <span class="comment">// 12</span>
<a name="l00353"></a>00353     {         0.0,        0.0,        0.0,        0.0,        0.0,      0.375,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0}, <span class="comment">// 13</span>
<a name="l00354"></a>00354     {         0.0,        0.0,        0.0,        0.0,    -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,      0.375,       0.75,      0.375,       0.25}, <span class="comment">// 14</span>
<a name="l00355"></a>00355     {         0.0,        0.0,        0.0,        0.0,    -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,       0.75,      0.375,       0.25,      0.375}  <span class="comment">// 15</span>
<a name="l00356"></a>00356   },
<a name="l00357"></a>00357 
<a name="l00358"></a>00358   <span class="comment">// embedding matrix for child 2</span>
<a name="l00359"></a>00359   {
<a name="l00360"></a>00360     <span class="comment">//          0           1           2           3           4           5           6           7           8           9          10          11          12          13          14          15 th parent Node</span>
<a name="l00361"></a>00361     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 0th child N.</span>
<a name="l00362"></a>00362     {       -0.25,      -0.25,      -0.25,      -0.25,        0.0,        0.0,        0.0,        0.0,        0.5,        0.5,        0.5,        0.5,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 1</span>
<a name="l00363"></a>00363     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 2</span>
<a name="l00364"></a>00364     {         0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 3</span>
<a name="l00365"></a>00365     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0}, <span class="comment">// 4</span>
<a name="l00366"></a>00366     {         0.0,        0.0,        0.0,        0.0,      -0.25,      -0.25,      -0.25,      -0.25,        0.0,        0.0,        0.0,        0.0,        0.5,        0.5,        0.5,        0.5}, <span class="comment">// 5</span>
<a name="l00367"></a>00367     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0}, <span class="comment">// 6</span>
<a name="l00368"></a>00368     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 7</span>
<a name="l00369"></a>00369     {     -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,      0.375,       0.25,      0.375,       0.75,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 8</span>
<a name="l00370"></a>00370     {     -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,       0.25,      0.375,       0.75,      0.375,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 9</span>
<a name="l00371"></a>00371     {         0.0,        0.0,     -0.125,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 10</span>
<a name="l00372"></a>00372     {      -0.125,        0.0,        0.0,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 11</span>
<a name="l00373"></a>00373     {         0.0,        0.0,        0.0,        0.0,    -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,      0.375,       0.25,      0.375,       0.75}, <span class="comment">// 12</span>
<a name="l00374"></a>00374     {         0.0,        0.0,        0.0,        0.0,    -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,       0.25,      0.375,       0.75,      0.375}, <span class="comment">// 13</span>
<a name="l00375"></a>00375     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,     -0.125,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0}, <span class="comment">// 14</span>
<a name="l00376"></a>00376     {         0.0,        0.0,        0.0,        0.0,     -0.125,        0.0,        0.0,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75}  <span class="comment">// 15</span>
<a name="l00377"></a>00377   },
<a name="l00378"></a>00378 
<a name="l00379"></a>00379   <span class="comment">// embedding matrix for child 3</span>
<a name="l00380"></a>00380   {
<a name="l00381"></a>00381     <span class="comment">//          0           1           2           3           4           5           6           7           8           9          10          11          12          13          14          15 th parent Node</span>
<a name="l00382"></a>00382     {       -0.25,      -0.25,      -0.25,      -0.25,        0.0,        0.0,        0.0,        0.0,        0.5,        0.5,        0.5,        0.5,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 0th child N.</span>
<a name="l00383"></a>00383     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 1</span>
<a name="l00384"></a>00384     {         0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 2</span>
<a name="l00385"></a>00385     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 3</span>
<a name="l00386"></a>00386     {         0.0,        0.0,        0.0,        0.0,      -0.25,      -0.25,      -0.25,      -0.25,        0.0,        0.0,        0.0,        0.0,        0.5,        0.5,        0.5,        0.5}, <span class="comment">// 4</span>
<a name="l00387"></a>00387     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0}, <span class="comment">// 5</span>
<a name="l00388"></a>00388     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 6</span>
<a name="l00389"></a>00389     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0}, <span class="comment">// 7</span>
<a name="l00390"></a>00390     {     -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,      0.375,       0.75,      0.375,       0.25,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 8</span>
<a name="l00391"></a>00391     {         0.0,     -0.125,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 9</span>
<a name="l00392"></a>00392     {         0.0,        0.0,      0.375,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 10</span>
<a name="l00393"></a>00393     {     -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,       0.25,      0.375,       0.75,      0.375,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 11</span>
<a name="l00394"></a>00394     {         0.0,        0.0,        0.0,        0.0,    -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,      0.375,       0.75,      0.375,       0.25}, <span class="comment">// 12</span>
<a name="l00395"></a>00395     {         0.0,        0.0,        0.0,        0.0,        0.0,     -0.125,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0}, <span class="comment">// 13</span>
<a name="l00396"></a>00396     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,      0.375,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0}, <span class="comment">// 14</span>
<a name="l00397"></a>00397     {         0.0,        0.0,        0.0,        0.0,    -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,       0.25,      0.375,       0.75,      0.375}  <span class="comment">// 15</span>
<a name="l00398"></a>00398   }
<a name="l00399"></a>00399 };
<a name="l00400"></a>00400 
<a name="l00401"></a>00401 
<a name="l00402"></a>00402 
<a name="l00403"></a>00403 <span class="preprocessor">#endif</span>
<a name="l00404"></a>00404 <span class="preprocessor"></span>
<a name="l00405"></a>00405 <span class="preprocessor">#endif  // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
