<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>cell_inf_hex16.h</h1>  </div>
</div>
<div class="contents">
<a href="cell__inf__hex16_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_inf_hex16.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __cell_inf_hex16_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __cell_inf_hex16_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="cell__inf__hex_8h.php">cell_inf_hex.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00070"></a>00070 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00071"></a>00071 <span class="comment">// InfHex16 class definition</span>
<a name="l00072"></a><a class="code" href="classInfHex16.php">00072</a> <span class="keyword">class </span><a class="code" href="classInfHex16.php">InfHex16</a> : <span class="keyword">public</span> <a class="code" href="classInfHex.php">InfHex</a>
<a name="l00073"></a>00073 {
<a name="l00074"></a>00074 <span class="keyword">public</span>:
<a name="l00075"></a>00075 
<a name="l00079"></a>00079   <a class="code" href="classInfHex16.php#ac3e3cf512693d2e6d35d8117821cac42">InfHex16</a>  (<a class="code" href="classElem.php">Elem</a>* p=NULL);
<a name="l00080"></a>00080     
<a name="l00084"></a><a class="code" href="classInfHex16.php#a7642c153e967770fd4ebdca16542d243">00084</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex16.php#a7642c153e967770fd4ebdca16542d243">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 16; }
<a name="l00085"></a>00085   
<a name="l00089"></a><a class="code" href="classInfHex16.php#ad77d5149882d1ff5fe77c1b6b9e16bb4">00089</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>     <a class="code" href="classInfHex16.php#ad77d5149882d1ff5fe77c1b6b9e16bb4">type</a> ()<span class="keyword">   const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a583e72df1b20e339d9f8fcea6a94c1d4">INFHEX16</a>; }
<a name="l00090"></a>00090   
<a name="l00094"></a><a class="code" href="classInfHex16.php#adab687a7db938a96efbc1a84cfa58eec">00094</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex16.php#adab687a7db938a96efbc1a84cfa58eec">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00095"></a>00095   
<a name="l00099"></a>00099   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfHex16.php#a0007edc761d761e41ff6ebf7fb725444">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00100"></a>00100 
<a name="l00104"></a>00104   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfHex16.php#acfda0416d277f59701643ed48ce4ff30">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00105"></a>00105 
<a name="l00109"></a>00109   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfHex16.php#adb1d3dfe5d798eed22c50f6eab44c7a2">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00110"></a>00110   
<a name="l00111"></a>00111   <span class="comment">/*</span>
<a name="l00112"></a>00112 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00113"></a>00113 <span class="comment">   * specified side</span>
<a name="l00114"></a>00114 <span class="comment">   */</span>
<a name="l00115"></a>00115   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfHex16.php#a047ddd03a0ed44a812ffd638d88335e3">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00116"></a>00116                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00117"></a>00117   
<a name="l00118"></a>00118   <span class="comment">/*</span>
<a name="l00119"></a>00119 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00120"></a>00120 <span class="comment">   * specified edge</span>
<a name="l00121"></a>00121 <span class="comment">   */</span>
<a name="l00122"></a>00122   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfHex16.php#a5df1e4027d1462e8de9723b1109a64c3">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00123"></a>00123                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e) <span class="keyword">const</span>;
<a name="l00124"></a>00124   
<a name="l00128"></a><a class="code" href="classInfHex16.php#ab19f88f3968d5603906d1aacfe642a7f">00128</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classInfHex16.php#ab19f88f3968d5603906d1aacfe642a7f">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>; }
<a name="l00129"></a>00129   
<a name="l00135"></a>00135   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classInfHex16.php#a863251b33507165bcdcd0d8c4c9cccb6">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00136"></a>00136                             <span class="keywordtype">bool</span> proxy) <span class="keyword">const</span>;
<a name="l00137"></a>00137 
<a name="l00143"></a>00143   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classInfHex16.php#a265363abf9f058447022ac5bba2c5276">build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00144"></a>00144 
<a name="l00145"></a>00145   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classInfHex16.php#a5fc6a618df6c71c1127beadcb8ea6866">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00146"></a>00146                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00147"></a>00147                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 <span class="comment">//   void tecplot_connectivity(const unsigned int sc,</span>
<a name="l00150"></a>00150 <span class="comment">//                          std::vector&lt;unsigned int&gt;&amp; conn) const;</span>
<a name="l00151"></a>00151   
<a name="l00152"></a>00152 <span class="comment">//   void vtk_connectivity(const unsigned int,</span>
<a name="l00153"></a>00153 <span class="comment">//                      std::vector&lt;unsigned int&gt;*) const</span>
<a name="l00154"></a>00154 <span class="comment">//   { libmesh_error(); }</span>
<a name="l00155"></a>00155   
<a name="l00156"></a><a class="code" href="classInfHex16.php#ad53dad20bc3734f7b2f82bcf66eb516d">00156</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex16.php#ad53dad20bc3734f7b2f82bcf66eb516d">vtk_element_type</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00157"></a>00157 <span class="keyword">  </span>{ <span class="keywordflow">return</span> 12; }
<a name="l00158"></a>00158 
<a name="l00162"></a><a class="code" href="classInfHex16.php#a6caf6a22002d1145a4960ba1f46f0026">00162</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex16.php#a6caf6a22002d1145a4960ba1f46f0026">n_second_order_adjacent_vertices</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00163"></a>00163 <span class="keyword">      </span>{ <span class="keywordflow">return</span> 2; }
<a name="l00164"></a>00164 
<a name="l00170"></a>00170   <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex16.php#ada87bfe93c70a09755f5038128570eb6">second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00171"></a>00171                                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v) <span class="keyword">const</span>;
<a name="l00172"></a>00172 
<a name="l00182"></a>00182   <span class="keyword">virtual</span> std::pair&lt;unsigned short int, unsigned short int&gt; 
<a name="l00183"></a>00183           <a class="code" href="classInfHex16.php#aee8aedfd36a2643615ebc6e4eb34a0ba">second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span>;
<a name="l00184"></a>00184 
<a name="l00189"></a><a class="code" href="classInfHex16.php#a793ea9d007dc06b231300689de7f7378">00189</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex16.php#a793ea9d007dc06b231300689de7f7378">side_nodes_map</a>[5][8];
<a name="l00190"></a>00190 
<a name="l00195"></a><a class="code" href="classInfHex16.php#affb989b12d5324903603687d2dba2c9c">00195</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex16.php#affb989b12d5324903603687d2dba2c9c">edge_nodes_map</a>[8][3];
<a name="l00196"></a>00196   
<a name="l00197"></a>00197   
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 <span class="keyword">protected</span>:  
<a name="l00200"></a>00200 
<a name="l00201"></a>00201   
<a name="l00202"></a>00202 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00203"></a>00203 <span class="preprocessor"></span>
<a name="l00207"></a><a class="code" href="classInfHex16.php#a9969aad5a88e39a0b4559984d15f1e02">00207</a>   <span class="keywordtype">float</span> <a class="code" href="classInfHex16.php#a9969aad5a88e39a0b4559984d15f1e02">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00208"></a>00208                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00209"></a>00209                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00210"></a>00210 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classInfHex16.php#ae0412e79514037774b17648c3b6dba29">_embedding_matrix</a>[i][j][k]; }
<a name="l00211"></a>00211 
<a name="l00216"></a><a class="code" href="classInfHex16.php#ae0412e79514037774b17648c3b6dba29">00216</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classInfHex16.php#ae0412e79514037774b17648c3b6dba29">_embedding_matrix</a>[4][16][16];
<a name="l00217"></a>00217   
<a name="l00218"></a>00218 <span class="preprocessor">#endif</span>
<a name="l00219"></a>00219 <span class="preprocessor"></span>
<a name="l00220"></a>00220 };
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00225"></a>00225 <span class="comment">// InfHex16 class member functions</span>
<a name="l00226"></a>00226 <span class="keyword">inline</span>
<a name="l00227"></a><a class="code" href="classInfHex16.php#ac3e3cf512693d2e6d35d8117821cac42">00227</a> <a class="code" href="classInfHex16.php#ac3e3cf512693d2e6d35d8117821cac42">InfHex16::InfHex16</a>(<a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00228"></a>00228   <a class="code" href="classInfHex.php">InfHex</a>(<a class="code" href="classInfHex16.php">InfHex16</a>::<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>(), p) 
<a name="l00229"></a>00229 {
<a name="l00230"></a>00230 }
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 <span class="preprocessor">#endif  // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00234"></a>00234 <span class="preprocessor"></span>
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
