<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>cell_inf_hex18.h</h1>  </div>
</div>
<div class="contents">
<a href="cell__inf__hex18_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_inf_hex18.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __cell_inf_hex18_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __cell_inf_hex18_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="cell__inf__hex_8h.php">cell_inf_hex.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00070"></a>00070 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00071"></a>00071 <span class="comment">// InfHex18 class definition</span>
<a name="l00072"></a><a class="code" href="classInfHex18.php">00072</a> <span class="keyword">class </span><a class="code" href="classInfHex18.php">InfHex18</a> : <span class="keyword">public</span> <a class="code" href="classInfHex.php">InfHex</a>
<a name="l00073"></a>00073 {
<a name="l00074"></a>00074 <span class="keyword">public</span>:
<a name="l00075"></a>00075 
<a name="l00079"></a>00079   <a class="code" href="classInfHex18.php#a197c05e01f39ff67f8a130ed3f34392a">InfHex18</a>  (<a class="code" href="classElem.php">Elem</a>* p=NULL);
<a name="l00080"></a>00080     
<a name="l00084"></a><a class="code" href="classInfHex18.php#aac0adfc6214e5c53332c2e1953a59229">00084</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex18.php#aac0adfc6214e5c53332c2e1953a59229">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 18; }
<a name="l00085"></a>00085   
<a name="l00089"></a><a class="code" href="classInfHex18.php#a107c16564383faf340dea6cae53a0da3">00089</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>     <a class="code" href="classInfHex18.php#a107c16564383faf340dea6cae53a0da3">type</a> ()<span class="keyword">   const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4e68f53177cc7d1366225dfc8f7bbbed">INFHEX18</a>; }
<a name="l00090"></a>00090   
<a name="l00094"></a><a class="code" href="classInfHex18.php#a9be35c7e8c7d7d016318d3fdf9ed492c">00094</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex18.php#a9be35c7e8c7d7d016318d3fdf9ed492c">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00095"></a>00095   
<a name="l00099"></a><a class="code" href="classInfHex18.php#a9f39a24d62aa33c3a2d806c6c1dc0365">00099</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classInfHex18.php#a9f39a24d62aa33c3a2d806c6c1dc0365">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>; }
<a name="l00100"></a>00100 
<a name="l00104"></a>00104   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfHex18.php#a06977ce0ee85dfc1f8eb7d116c611084">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00105"></a>00105 
<a name="l00109"></a>00109   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfHex18.php#ac104532818b34a0a6eeb7db1236b987b">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00110"></a>00110 
<a name="l00114"></a>00114   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfHex18.php#a5e22ca67399b22626e5bc224be43c1cd">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00115"></a>00115   
<a name="l00116"></a>00116   <span class="comment">/*</span>
<a name="l00117"></a>00117 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00118"></a>00118 <span class="comment">   * specified side</span>
<a name="l00119"></a>00119 <span class="comment">   */</span>
<a name="l00120"></a>00120   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfHex18.php#aec3a4a0f7b33f2813251a382bef49d55">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00121"></a>00121                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00122"></a>00122   
<a name="l00123"></a>00123   <span class="comment">/*</span>
<a name="l00124"></a>00124 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00125"></a>00125 <span class="comment">   * specified edge</span>
<a name="l00126"></a>00126 <span class="comment">   */</span>
<a name="l00127"></a>00127   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfHex18.php#a64e0bf423d9927aa8685298cc51dad03">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00128"></a>00128                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e) <span class="keyword">const</span>;
<a name="l00129"></a>00129   
<a name="l00135"></a>00135   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classInfHex18.php#ace28817409b61c94447e42a650685040">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00136"></a>00136                             <span class="keywordtype">bool</span> proxy) <span class="keyword">const</span>;
<a name="l00137"></a>00137 
<a name="l00143"></a>00143   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classInfHex18.php#af12a6312f4d9b98b3545fa682de41bbb">build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00144"></a>00144 
<a name="l00154"></a>00154   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex18.php#a9a5f5fe731f880b845ad04cc6975469a">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00155"></a>00155 
<a name="l00156"></a>00156   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classInfHex18.php#a552445027795df831f619d7eb70111fd">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00157"></a>00157                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00158"></a>00158                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 <span class="comment">//   void tecplot_connectivity(const unsigned int sc,</span>
<a name="l00161"></a>00161 <span class="comment">//                          std::vector&lt;unsigned int&gt;&amp; conn) const;</span>
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 <span class="comment">//   void vtk_connectivity(const unsigned int,</span>
<a name="l00164"></a>00164 <span class="comment">//                      std::vector&lt;unsigned int&gt;*) const</span>
<a name="l00165"></a>00165 <span class="comment">//   { libmesh_error(); }</span>
<a name="l00166"></a>00166   
<a name="l00167"></a><a class="code" href="classInfHex18.php#abd4bc49dc7d1318351aae66f0c7fdc6b">00167</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex18.php#abd4bc49dc7d1318351aae66f0c7fdc6b">vtk_element_type</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00168"></a>00168 <span class="keyword">  </span>{ <span class="keywordflow">return</span> 12; }
<a name="l00169"></a>00169 
<a name="l00173"></a>00173   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex18.php#a1d21f86a7cd53b2f331ef8ee2350c286">n_second_order_adjacent_vertices</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>) <span class="keyword">const</span>;
<a name="l00174"></a>00174 
<a name="l00180"></a>00180   <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex18.php#ad699a788a1979363b50b7f224eb2639d">second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00181"></a>00181                                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v) <span class="keyword">const</span>;
<a name="l00182"></a>00182 
<a name="l00192"></a>00192   <span class="keyword">virtual</span> std::pair&lt;unsigned short int, unsigned short int&gt; 
<a name="l00193"></a>00193           <a class="code" href="classInfHex18.php#acdd05d4c91bff93b2ef12532f5d56b81">second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span>;
<a name="l00194"></a>00194 
<a name="l00199"></a><a class="code" href="classInfHex18.php#a29e4896310cf33653c257d5432384fa6">00199</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex18.php#a29e4896310cf33653c257d5432384fa6">side_nodes_map</a>[5][9];
<a name="l00200"></a>00200 
<a name="l00205"></a><a class="code" href="classInfHex18.php#adc27d9f9f5c217c2857205d2fd6c329b">00205</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex18.php#adc27d9f9f5c217c2857205d2fd6c329b">edge_nodes_map</a>[8][3];
<a name="l00206"></a>00206    
<a name="l00207"></a>00207 
<a name="l00208"></a>00208 <span class="keyword">protected</span>:
<a name="l00209"></a>00209   
<a name="l00210"></a>00210   
<a name="l00211"></a>00211 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00212"></a>00212 <span class="preprocessor"></span>
<a name="l00216"></a><a class="code" href="classInfHex18.php#a253277c438567055844726b24b84bcc2">00216</a>   <span class="keywordtype">float</span> <a class="code" href="classInfHex18.php#a253277c438567055844726b24b84bcc2">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00217"></a>00217                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00218"></a>00218                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00219"></a>00219 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classInfHex18.php#a167d0b1c1582dcdbc89cfd52b43bf476">_embedding_matrix</a>[i][j][k]; }
<a name="l00220"></a>00220 
<a name="l00225"></a><a class="code" href="classInfHex18.php#a167d0b1c1582dcdbc89cfd52b43bf476">00225</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classInfHex18.php#a167d0b1c1582dcdbc89cfd52b43bf476">_embedding_matrix</a>[4][18][18];
<a name="l00226"></a>00226   
<a name="l00227"></a>00227   
<a name="l00228"></a>00228 <span class="preprocessor">#endif</span>
<a name="l00229"></a>00229 <span class="preprocessor"></span>
<a name="l00230"></a>00230 };
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00235"></a>00235 <span class="comment">// InfHex18 class member functions</span>
<a name="l00236"></a>00236 <span class="keyword">inline</span>
<a name="l00237"></a><a class="code" href="classInfHex18.php#a197c05e01f39ff67f8a130ed3f34392a">00237</a> <a class="code" href="classInfHex18.php#a197c05e01f39ff67f8a130ed3f34392a">InfHex18::InfHex18</a>(<a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00238"></a>00238   <a class="code" href="classInfHex.php">InfHex</a>(<a class="code" href="classInfHex18.php">InfHex18</a>::<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>(), p) 
<a name="l00239"></a>00239 {
<a name="l00240"></a>00240 }
<a name="l00241"></a>00241 
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 <span class="preprocessor">#endif  // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00244"></a>00244 <span class="preprocessor"></span>
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
