<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>cell_inf_hex.h</h1>  </div>
</div>
<div class="contents">
<a href="cell__inf__hex_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_inf_hex.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __cell_inf_hex_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __cell_inf_hex_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="cell__inf_8h.php">cell_inf.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00045"></a>00045 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00046"></a>00046 <span class="comment">// InfHex class definition</span>
<a name="l00047"></a><a class="code" href="classInfHex.php">00047</a> <span class="keyword">class </span><a class="code" href="classInfHex.php">InfHex</a> : <span class="keyword">public</span> <a class="code" href="classInfCell.php">InfCell</a>
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049 <span class="keyword">public</span>:
<a name="l00050"></a>00050 
<a name="l00055"></a>00055   <a class="code" href="classInfHex.php#a812308e540f381c59a2f26d88cc81ed0">InfHex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn, <a class="code" href="classElem.php">Elem</a>* p);
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 <span class="comment">//   /**</span>
<a name="l00058"></a>00058 <span class="comment">//    * @returns 4 for the base \p s=0 and 2 for side faces. </span>
<a name="l00059"></a>00059 <span class="comment">//    */</span>
<a name="l00060"></a>00060 <span class="comment">//   unsigned int n_children_per_side(const unsigned int s) const;</span>
<a name="l00061"></a>00061 
<a name="l00067"></a><a class="code" href="classInfHex.php#a5eaab4848a84970b67843470f5dad072">00067</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex.php#a5eaab4848a84970b67843470f5dad072">n_sides</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 5; }
<a name="l00068"></a>00068 
<a name="l00073"></a><a class="code" href="classInfHex.php#ac967186f3ed81045514b61d8ad18f03f">00073</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex.php#ac967186f3ed81045514b61d8ad18f03f">n_vertices</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 8; }
<a name="l00074"></a>00074 
<a name="l00079"></a><a class="code" href="classInfHex.php#af118b4b04772734c29f4c91ca3982917">00079</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex.php#af118b4b04772734c29f4c91ca3982917">n_edges</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 8; }
<a name="l00080"></a>00080 
<a name="l00084"></a><a class="code" href="classInfHex.php#a4559a394cc854f47948c7ba03d0fb9c1">00084</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex.php#a4559a394cc854f47948c7ba03d0fb9c1">n_faces</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 5; }
<a name="l00085"></a>00085   
<a name="l00089"></a><a class="code" href="classInfHex.php#af8f66671e24ce961c87193e5f605a905">00089</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex.php#af8f66671e24ce961c87193e5f605a905">n_children</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00090"></a>00090   
<a name="l00091"></a>00091   <span class="comment">/*</span>
<a name="l00092"></a>00092 <span class="comment">   * @returns true iff the specified child is on the</span>
<a name="l00093"></a>00093 <span class="comment">   * specified side</span>
<a name="l00094"></a>00094 <span class="comment">   */</span>
<a name="l00095"></a>00095   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfHex.php#abcf0761680a7828a5b3fd4ad16d9bc2c">is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00096"></a>00096                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00097"></a>00097   
<a name="l00103"></a>00103   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex.php#a74d7b4216bb31f0936fa8e11f2789550">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00104"></a>00104 
<a name="l00109"></a>00109   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> <a class="code" href="classInfHex.php#ae6ff54ebfdf0a0a764e8ac2e6dab5eac">side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00110"></a>00110 
<a name="l00115"></a>00115   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classInfHex.php#a5fe521b6ff0408ee38dbb2592f086598">quality</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) <span class="keyword">const</span>;
<a name="l00116"></a>00116 
<a name="l00122"></a>00122   std::pair&lt;Real, Real&gt; <a class="code" href="classInfHex.php#ad0596e53eefc10dfab051b9ac7bad615">qual_bounds</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) <span class="keyword">const</span>;
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 
<a name="l00125"></a>00125   
<a name="l00126"></a>00126 <span class="keyword">protected</span>:
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   
<a name="l00139"></a><a class="code" href="classInfHex.php#ad376a383b93c5febee213f2baee1a799">00139</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex.php#ad376a383b93c5febee213f2baee1a799">_second_order_adjacent_vertices</a>[8][2];
<a name="l00140"></a>00140 
<a name="l00144"></a><a class="code" href="classInfHex.php#ac15d63075635e85c1297d03606728911">00144</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex.php#ac15d63075635e85c1297d03606728911">_second_order_vertex_child_number</a>[18];
<a name="l00145"></a>00145 
<a name="l00149"></a><a class="code" href="classInfHex.php#a4e086e1ae6bff9a110166e2ec7452ea8">00149</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classInfHex.php#a4e086e1ae6bff9a110166e2ec7452ea8">_second_order_vertex_child_index</a>[18];
<a name="l00150"></a>00150 };
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00155"></a>00155 <span class="comment">// InfHex class member functions</span>
<a name="l00156"></a>00156 <span class="keyword">inline</span>
<a name="l00157"></a><a class="code" href="classInfHex.php#a812308e540f381c59a2f26d88cc81ed0">00157</a> <a class="code" href="classInfHex.php#a812308e540f381c59a2f26d88cc81ed0">InfHex::InfHex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn, <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00158"></a>00158   <a class="code" href="classInfCell.php">InfCell</a>(nn, <a class="code" href="classInfHex.php">InfHex</a>::n_sides(), p) 
<a name="l00159"></a>00159 {
<a name="l00160"></a>00160 }
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 <span class="comment">// inline</span>
<a name="l00164"></a>00164 <span class="comment">// unsigned int InfHex::n_children_per_side(const unsigned int s) const</span>
<a name="l00165"></a>00165 <span class="comment">// {</span>
<a name="l00166"></a>00166 <span class="comment">//   libmesh_assert (s &lt; this-&gt;n_sides());</span>
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 <span class="comment">//   switch (s)</span>
<a name="l00169"></a>00169 <span class="comment">//   {</span>
<a name="l00170"></a>00170 <span class="comment">//     case 0:</span>
<a name="l00171"></a>00171 <span class="comment">//       // every infinite element has 4 children in the base side</span>
<a name="l00172"></a>00172 <span class="comment">//       return 4;</span>
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 <span class="comment">//     default:</span>
<a name="l00175"></a>00175 <span class="comment">//       // on infinite faces (sides), only 2 children exist</span>
<a name="l00176"></a>00176 <span class="comment">//       //</span>
<a name="l00177"></a>00177 <span class="comment">//       // note that the face at infinity is already caught by the libmesh_assertion</span>
<a name="l00178"></a>00178 <span class="comment">//       return 2;</span>
<a name="l00179"></a>00179 <span class="comment">//   }</span>
<a name="l00180"></a>00180 <span class="comment">// }</span>
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00184"></a>00184 <span class="preprocessor"></span>
<a name="l00185"></a>00185 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
