<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>cell_inf_prism12.h</h1>  </div>
</div>
<div class="contents">
<a href="cell__inf__prism12_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_inf_prism12.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __cell_inf_prism12_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __cell_inf_prism12_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="cell__inf__prism_8h.php">cell_inf_prism.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00061"></a>00061 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00062"></a>00062 <span class="comment">// InfPrism12 class definition</span>
<a name="l00063"></a><a class="code" href="classInfPrism12.php">00063</a> <span class="keyword">class </span><a class="code" href="classInfPrism12.php">InfPrism12</a> : <span class="keyword">public</span> <a class="code" href="classInfPrism.php">InfPrism</a>
<a name="l00064"></a>00064 {
<a name="l00065"></a>00065 <span class="keyword">public</span>:
<a name="l00066"></a>00066 
<a name="l00070"></a>00070   <a class="code" href="classInfPrism12.php#a51ccb2b63bd7379b210765bd2bad9315">InfPrism12</a>  (<a class="code" href="classElem.php">Elem</a>* p=NULL);
<a name="l00071"></a>00071 
<a name="l00075"></a><a class="code" href="classInfPrism12.php#aadbfc7e684481a716ac44de1036a5001">00075</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfPrism12.php#aadbfc7e684481a716ac44de1036a5001">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 12; }
<a name="l00076"></a>00076   
<a name="l00080"></a><a class="code" href="classInfPrism12.php#a6641d1558b78f4b7273bd6947796ab87">00080</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>     <a class="code" href="classInfPrism12.php#a6641d1558b78f4b7273bd6947796ab87">type</a> ()<span class="keyword"> const   </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a89630f5af6a58aaa9ae731d924139c61">INFPRISM12</a>; }
<a name="l00081"></a>00081   
<a name="l00085"></a><a class="code" href="classInfPrism12.php#a371a42f5736f309a66c21f802d95ab3f">00085</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfPrism12.php#a371a42f5736f309a66c21f802d95ab3f">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00086"></a>00086   
<a name="l00090"></a>00090   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfPrism12.php#ae4fc2106640103eea00bc2d28ecb1f75">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00091"></a>00091 
<a name="l00095"></a>00095   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfPrism12.php#adf11f3cf388bd6f0f906a7e4cb52a7b4">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00096"></a>00096 
<a name="l00100"></a>00100   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfPrism12.php#a13fb8301f646aa7f28c4184d89967580">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00101"></a>00101   
<a name="l00102"></a>00102   <span class="comment">/*</span>
<a name="l00103"></a>00103 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00104"></a>00104 <span class="comment">   * specified side</span>
<a name="l00105"></a>00105 <span class="comment">   */</span>
<a name="l00106"></a>00106   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfPrism12.php#a72011e4f914a82b93cde3725b20a8c0f">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00107"></a>00107                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00108"></a>00108   
<a name="l00109"></a>00109   <span class="comment">/*</span>
<a name="l00110"></a>00110 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00111"></a>00111 <span class="comment">   * specified edge</span>
<a name="l00112"></a>00112 <span class="comment">   */</span>
<a name="l00113"></a>00113   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfPrism12.php#ae2f6a018c09391fce429093e78d7a790">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00114"></a>00114                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e) <span class="keyword">const</span>;
<a name="l00115"></a>00115   
<a name="l00119"></a><a class="code" href="classInfPrism12.php#a1b710c0d8d069e9ab1dd99a7a1ae9f49">00119</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classInfPrism12.php#a1b710c0d8d069e9ab1dd99a7a1ae9f49">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>; }
<a name="l00120"></a>00120   
<a name="l00126"></a>00126   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classInfPrism12.php#ac4aad926c6eb5f76911544ce51ac874e">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00127"></a>00127                             <span class="keywordtype">bool</span> proxy) <span class="keyword">const</span>;
<a name="l00128"></a>00128 
<a name="l00134"></a>00134   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classInfPrism12.php#aff84464f3168ad5498729d24203867b8">build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classInfPrism12.php#a69db6e428b90e5037cf484a28cfc5150">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00137"></a>00137                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00138"></a>00138                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 <span class="comment">//   void tecplot_connectivity(const unsigned int sc,</span>
<a name="l00141"></a>00141 <span class="comment">//                          std::vector&lt;unsigned int&gt;&amp; conn) const;</span>
<a name="l00142"></a>00142   
<a name="l00143"></a>00143 <span class="comment">//   void vtk_connectivity(const unsigned int,</span>
<a name="l00144"></a>00144 <span class="comment">//                      std::vector&lt;unsigned int&gt;*) const</span>
<a name="l00145"></a>00145 <span class="comment">//   { libmesh_error(); }</span>
<a name="l00146"></a>00146   
<a name="l00147"></a>00147 <span class="comment">//   unsigned int vtk_element_type (const unsigned int) const</span>
<a name="l00148"></a>00148 <span class="comment">//   { return 13; }</span>
<a name="l00149"></a>00149 
<a name="l00153"></a><a class="code" href="classInfPrism12.php#aa8550f80ff99db52b9eeb72928a3af9f">00153</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfPrism12.php#aa8550f80ff99db52b9eeb72928a3af9f">n_second_order_adjacent_vertices</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00154"></a>00154 <span class="keyword">      </span>{ <span class="keywordflow">return</span> 2; }
<a name="l00155"></a>00155 
<a name="l00161"></a>00161   <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classInfPrism12.php#adfd219e5b17ab3ae964e9e5c5a42bf99">second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00162"></a>00162                                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v) <span class="keyword">const</span>;
<a name="l00163"></a>00163 
<a name="l00173"></a>00173   <span class="keyword">virtual</span> std::pair&lt;unsigned short int, unsigned short int&gt; 
<a name="l00174"></a>00174           <a class="code" href="classInfPrism12.php#a95e9dd0c482c1053b1047ea9c3404549">second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span>;
<a name="l00175"></a>00175 
<a name="l00180"></a><a class="code" href="classInfPrism12.php#a20817a57ab23849f7ab9c31299dbe304">00180</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfPrism12.php#a20817a57ab23849f7ab9c31299dbe304">side_nodes_map</a>[4][6];
<a name="l00181"></a>00181 
<a name="l00186"></a><a class="code" href="classInfPrism12.php#aafd683408f1604e2d6a2ec4f4e2d2bdb">00186</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfPrism12.php#aafd683408f1604e2d6a2ec4f4e2d2bdb">edge_nodes_map</a>[6][3];
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 <span class="keyword">protected</span>:  
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00193"></a>00193 <span class="preprocessor"></span>  
<a name="l00197"></a><a class="code" href="classInfPrism12.php#a9644aae743dcc93d1cbf6a4d7694141a">00197</a>   <span class="keywordtype">float</span> <a class="code" href="classInfPrism12.php#a9644aae743dcc93d1cbf6a4d7694141a">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00198"></a>00198                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00199"></a>00199                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00200"></a>00200 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classInfPrism12.php#add8dc112df066ae743c2339fabf680e4">_embedding_matrix</a>[i][j][k]; }
<a name="l00201"></a>00201 
<a name="l00206"></a><a class="code" href="classInfPrism12.php#add8dc112df066ae743c2339fabf680e4">00206</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classInfPrism12.php#add8dc112df066ae743c2339fabf680e4">_embedding_matrix</a>[4][12][12];
<a name="l00207"></a>00207   
<a name="l00208"></a>00208 <span class="preprocessor">#endif</span>
<a name="l00209"></a>00209 <span class="preprocessor"></span>
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 <span class="keyword">private</span>:
<a name="l00212"></a>00212   
<a name="l00217"></a><a class="code" href="classInfPrism12.php#ae78073ccc1ee13873659bd8c881e4ce4">00217</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classInfPrism12.php#ae78073ccc1ee13873659bd8c881e4ce4">_second_order_adjacent_vertices</a>[6][2];
<a name="l00218"></a>00218 
<a name="l00222"></a><a class="code" href="classInfPrism12.php#ad3b014c235e374d507f416de4baabfbf">00222</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classInfPrism12.php#ad3b014c235e374d507f416de4baabfbf">_second_order_vertex_child_number</a>[12];
<a name="l00223"></a>00223 
<a name="l00227"></a><a class="code" href="classInfPrism12.php#a189628e9a7cf55eace4e8d50cdc4aead">00227</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classInfPrism12.php#a189628e9a7cf55eace4e8d50cdc4aead">_second_order_vertex_child_index</a>[12];
<a name="l00228"></a>00228 };
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00233"></a>00233 <span class="comment">// InfPrism12 class member functions</span>
<a name="l00234"></a>00234 <span class="keyword">inline</span>
<a name="l00235"></a><a class="code" href="classInfPrism12.php#a51ccb2b63bd7379b210765bd2bad9315">00235</a> <a class="code" href="classInfPrism12.php#a51ccb2b63bd7379b210765bd2bad9315">InfPrism12::InfPrism12</a>(<a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00236"></a>00236   <a class="code" href="classInfPrism.php">InfPrism</a>(<a class="code" href="classInfPrism12.php">InfPrism12</a>::<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>(), p) 
<a name="l00237"></a>00237 {
<a name="l00238"></a>00238 }
<a name="l00239"></a>00239 
<a name="l00240"></a>00240 
<a name="l00241"></a>00241 <span class="preprocessor">#endif  // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00242"></a>00242 <span class="preprocessor"></span>
<a name="l00243"></a>00243 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
