<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>cell_inf_prism6.h</h1>  </div>
</div>
<div class="contents">
<a href="cell__inf__prism6_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_inf_prism6.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __cell_inf_prism6_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __cell_inf_prism6_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="cell__inf__prism_8h.php">cell_inf_prism.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00057"></a>00057 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00058"></a>00058 <span class="comment">// InfPrism6 class definition</span>
<a name="l00059"></a><a class="code" href="classInfPrism6.php">00059</a> <span class="keyword">class </span><a class="code" href="classInfPrism6.php">InfPrism6</a> : <span class="keyword">public</span> <a class="code" href="classInfPrism.php">InfPrism</a>
<a name="l00060"></a>00060 {
<a name="l00061"></a>00061 <span class="keyword">public</span>:
<a name="l00062"></a>00062 
<a name="l00066"></a>00066   <a class="code" href="classInfPrism6.php#a5662fc60da61778873cc55fce070d397">InfPrism6</a>  (<a class="code" href="classElem.php">Elem</a>* p=NULL);
<a name="l00067"></a>00067     
<a name="l00071"></a><a class="code" href="classInfPrism6.php#a2deb872c934e6281ec2942901dfc0ba9">00071</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfPrism6.php#a2deb872c934e6281ec2942901dfc0ba9">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 6; }
<a name="l00072"></a>00072   
<a name="l00076"></a><a class="code" href="classInfPrism6.php#abd9802d62712b8d7f20bc2c92d6865eb">00076</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>     <a class="code" href="classInfPrism6.php#abd9802d62712b8d7f20bc2c92d6865eb">type</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac6743a9a04524105e37159e924c4a33b">INFPRISM6</a>; }
<a name="l00077"></a>00077 
<a name="l00081"></a><a class="code" href="classInfPrism6.php#a0fdf63085d2be2f18c01ea366f7a7d9b">00081</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfPrism6.php#a0fdf63085d2be2f18c01ea366f7a7d9b">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00082"></a>00082   
<a name="l00086"></a>00086   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfPrism6.php#af4c0962912a7f5da1427787a9ba695e6">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00087"></a>00087 
<a name="l00091"></a>00091   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfPrism6.php#af1881666a64ee196c5c57a5df45f6a64">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00092"></a>00092 
<a name="l00096"></a>00096   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfPrism6.php#a523c542b1735ff148bd1b24d090c15bd">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00097"></a>00097   
<a name="l00098"></a>00098   <span class="comment">/*</span>
<a name="l00099"></a>00099 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00100"></a>00100 <span class="comment">   * specified side</span>
<a name="l00101"></a>00101 <span class="comment">   */</span>
<a name="l00102"></a>00102   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfPrism6.php#af26c760d2ff07724f6fa986050684549">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00103"></a>00103                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00104"></a>00104   
<a name="l00105"></a>00105   <span class="comment">/*</span>
<a name="l00106"></a>00106 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00107"></a>00107 <span class="comment">   * specified edge</span>
<a name="l00108"></a>00108 <span class="comment">   */</span>
<a name="l00109"></a>00109   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfPrism6.php#aad1b5dcd5cc221d69bcfc82052233bee">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00110"></a>00110                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e) <span class="keyword">const</span>;
<a name="l00111"></a>00111   
<a name="l00115"></a><a class="code" href="classInfPrism6.php#a1aee21925953fd6a9cb5a1bf054c3017">00115</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>        <a class="code" href="classInfPrism6.php#a1aee21925953fd6a9cb5a1bf054c3017">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>; }
<a name="l00116"></a>00116   
<a name="l00122"></a>00122   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classInfPrism6.php#adbfb235bb76bac1d0f5e86d77cc23f1b">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00123"></a>00123                             <span class="keywordtype">bool</span> proxy) <span class="keyword">const</span>;
<a name="l00124"></a>00124 <span class="comment">/*   {  */</span>
<a name="l00125"></a>00125 <span class="comment">/*     // side() returns an AutoPtr to a DofObject, hence need to cast to Elem* */</span>
<a name="l00126"></a>00126 <span class="comment">/*     AutoPtr&lt;DofObject&gt; ap_dof_object(this-&gt;side(i)); */</span>
<a name="l00127"></a>00127 <span class="comment">/*     Elem* side = dynamic_cast&lt;Elem*&gt;(ap_dof_object.release()); */</span>
<a name="l00128"></a>00128 <span class="comment">/*     libmesh_assert(side); // libmesh_assert that the cast was successful */</span>
<a name="l00129"></a>00129     
<a name="l00130"></a>00130 <span class="comment">/*     AutoPtr&lt;Elem&gt; ap(side); */</span>
<a name="l00131"></a>00131 <span class="comment">/*     return ap; */</span>
<a name="l00132"></a>00132 <span class="comment">/*   } */</span>
<a name="l00133"></a>00133   
<a name="l00139"></a>00139   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classInfPrism6.php#aaf7f2ce3c4e5fffc4dc0f2649e67e8b2">build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00140"></a>00140 
<a name="l00141"></a>00141   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classInfPrism6.php#ab4070f688ad3eae1e849cfa9bfb40f55">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00142"></a>00142                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00143"></a>00143                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 <span class="comment">//   void tecplot_connectivity(const unsigned int sc,</span>
<a name="l00146"></a>00146 <span class="comment">//                          std::vector&lt;unsigned int&gt;&amp; conn) const;</span>
<a name="l00147"></a>00147   
<a name="l00148"></a>00148 <span class="comment">//   void vtk_connectivity(const unsigned int,</span>
<a name="l00149"></a>00149 <span class="comment">//                      std::vector&lt;unsigned int&gt;*) const</span>
<a name="l00150"></a>00150 <span class="comment">//   { libmesh_error(); }</span>
<a name="l00151"></a>00151   
<a name="l00152"></a>00152 <span class="comment">//   unsigned int vtk_element_type (const unsigned int) const</span>
<a name="l00153"></a>00153 <span class="comment">//   { return 13; }</span>
<a name="l00154"></a>00154 
<a name="l00160"></a>00160   <span class="keywordtype">bool</span> <a class="code" href="classInfPrism6.php#abaa11909fe039b84cd0dc7483176a8f8">contains_point</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00161"></a>00161 
<a name="l00166"></a><a class="code" href="classInfPrism6.php#a3d76ad989599595353f8c44d6099c1e7">00166</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfPrism6.php#a3d76ad989599595353f8c44d6099c1e7">side_nodes_map</a>[4][4];
<a name="l00167"></a>00167 
<a name="l00172"></a><a class="code" href="classInfPrism6.php#aea68a4f90f857321a8e0bf8ca16fe395">00172</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfPrism6.php#aea68a4f90f857321a8e0bf8ca16fe395">edge_nodes_map</a>[6][2];
<a name="l00173"></a>00173   
<a name="l00174"></a>00174   
<a name="l00175"></a>00175 <span class="keyword">protected</span>:
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   
<a name="l00178"></a>00178 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00179"></a>00179 <span class="preprocessor"></span>  
<a name="l00183"></a><a class="code" href="classInfPrism6.php#aedb219a4c84d4d8f99adf08712ca93e1">00183</a>   <span class="keywordtype">float</span> <a class="code" href="classInfPrism6.php#aedb219a4c84d4d8f99adf08712ca93e1">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00184"></a>00184                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00185"></a>00185                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00186"></a>00186 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classInfPrism6.php#aa6825ae8efe217eba1b7434a2d66710d">_embedding_matrix</a>[i][j][k]; }
<a name="l00187"></a>00187 
<a name="l00192"></a><a class="code" href="classInfPrism6.php#aa6825ae8efe217eba1b7434a2d66710d">00192</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classInfPrism6.php#aa6825ae8efe217eba1b7434a2d66710d">_embedding_matrix</a>[4][6][6];
<a name="l00193"></a>00193   
<a name="l00194"></a>00194 <span class="preprocessor">#endif</span>
<a name="l00195"></a>00195 <span class="preprocessor"></span>  
<a name="l00196"></a>00196 };
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00201"></a>00201 <span class="comment">// InfPrism6 class member functions</span>
<a name="l00202"></a>00202 <span class="keyword">inline</span>
<a name="l00203"></a><a class="code" href="classInfPrism6.php#a5662fc60da61778873cc55fce070d397">00203</a> <a class="code" href="classInfPrism6.php#a5662fc60da61778873cc55fce070d397">InfPrism6::InfPrism6</a>(<a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00204"></a>00204   <a class="code" href="classInfPrism.php">InfPrism</a>(<a class="code" href="classInfPrism6.php">InfPrism6</a>::<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>(), p) 
<a name="l00205"></a>00205 {
<a name="l00206"></a>00206 }
<a name="l00207"></a>00207 
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 <span class="preprocessor">#endif  // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00210"></a>00210 <span class="preprocessor"></span>
<a name="l00211"></a>00211 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
