<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>cell_inf_prism.h</h1>  </div>
</div>
<div class="contents">
<a href="cell__inf__prism_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_inf_prism.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __cell_inf_prism_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __cell_inf_prism_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="cell__inf_8h.php">cell_inf.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00046"></a>00046 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00047"></a>00047 <span class="comment">// InfPrism class definition</span>
<a name="l00048"></a><a class="code" href="classInfPrism.php">00048</a> <span class="keyword">class </span><a class="code" href="classInfPrism.php">InfPrism</a> : <span class="keyword">public</span> <a class="code" href="classInfCell.php">InfCell</a>
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050 <span class="keyword">public</span>:
<a name="l00051"></a>00051 
<a name="l00056"></a>00056   <a class="code" href="classInfPrism.php#a041db135bbf2117807947ba64279a934">InfPrism</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn, <a class="code" href="classElem.php">Elem</a>* p);
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 <span class="comment">//   /**</span>
<a name="l00059"></a>00059 <span class="comment">//    * @returns 4 for the base \p s=0 and 2 for side faces. </span>
<a name="l00060"></a>00060 <span class="comment">//    */</span>
<a name="l00061"></a>00061 <span class="comment">//   unsigned int n_children_per_side(const unsigned int s) const;</span>
<a name="l00062"></a>00062 
<a name="l00068"></a><a class="code" href="classInfPrism.php#a36b28ace5c6c6fab80879303bc1a78cf">00068</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfPrism.php#a36b28ace5c6c6fab80879303bc1a78cf">n_sides</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00069"></a>00069 
<a name="l00074"></a><a class="code" href="classInfPrism.php#afb7bf8b7c7ce65fb6b41e5ad96b10862">00074</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfPrism.php#afb7bf8b7c7ce65fb6b41e5ad96b10862">n_vertices</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 6; }
<a name="l00075"></a>00075 
<a name="l00080"></a><a class="code" href="classInfPrism.php#aa19adf4fbb0795e54e1ec7f8add37e74">00080</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfPrism.php#aa19adf4fbb0795e54e1ec7f8add37e74">n_edges</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 6; }
<a name="l00081"></a>00081 
<a name="l00085"></a><a class="code" href="classInfPrism.php#af0e2cf24615c195eab7f73113cf72ab5">00085</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfPrism.php#af0e2cf24615c195eab7f73113cf72ab5">n_faces</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00086"></a>00086   
<a name="l00090"></a><a class="code" href="classInfPrism.php#a7fcc8b1baa3f6a0f787a572391adcde2">00090</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfPrism.php#a7fcc8b1baa3f6a0f787a572391adcde2">n_children</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00091"></a>00091   
<a name="l00092"></a>00092   <span class="comment">/*</span>
<a name="l00093"></a>00093 <span class="comment">   * @returns true iff the specified child is on the</span>
<a name="l00094"></a>00094 <span class="comment">   * specified side</span>
<a name="l00095"></a>00095 <span class="comment">   */</span>
<a name="l00096"></a>00096   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfPrism.php#aecd76c8aee126ab3c02b70f23e088de9">is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00097"></a>00097                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00098"></a>00098   
<a name="l00104"></a>00104   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfPrism.php#af281ad5e91150a913d470ace9c85ed28">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00105"></a>00105 
<a name="l00110"></a>00110   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> <a class="code" href="classInfPrism.php#a7f69319c5a9c8d0d37dbbbbbab15dff8">side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 };
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00117"></a>00117 <span class="comment">// InfPrism class member functions</span>
<a name="l00118"></a>00118 <span class="keyword">inline</span>
<a name="l00119"></a><a class="code" href="classInfPrism.php#a041db135bbf2117807947ba64279a934">00119</a> <a class="code" href="classInfPrism.php#a041db135bbf2117807947ba64279a934">InfPrism::InfPrism</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn, <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00120"></a>00120   <a class="code" href="classInfCell.php">InfCell</a>(nn, <a class="code" href="classInfPrism.php">InfPrism</a>::n_sides(), p) 
<a name="l00121"></a>00121 {
<a name="l00122"></a>00122 }
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 <span class="comment">// inline</span>
<a name="l00126"></a>00126 <span class="comment">// unsigned int InfPrism::n_children_per_side(const unsigned int s) const</span>
<a name="l00127"></a>00127 <span class="comment">// {</span>
<a name="l00128"></a>00128 <span class="comment">//   libmesh_assert (s &lt; this-&gt;n_sides());</span>
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 <span class="comment">//   switch (s)</span>
<a name="l00131"></a>00131 <span class="comment">//   {</span>
<a name="l00132"></a>00132 <span class="comment">//     case 0:</span>
<a name="l00133"></a>00133 <span class="comment">//       // every infinite prism has 4 children in the base side</span>
<a name="l00134"></a>00134 <span class="comment">//       return 4;</span>
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 <span class="comment">//     default:</span>
<a name="l00137"></a>00137 <span class="comment">//       // on infinite faces (sides), only 2 children exist</span>
<a name="l00138"></a>00138 <span class="comment">//       //</span>
<a name="l00139"></a>00139 <span class="comment">//       // note that the face at infinity is already caught by the libmesh_assertion</span>
<a name="l00140"></a>00140 <span class="comment">//       return 2;</span>
<a name="l00141"></a>00141 <span class="comment">//   }</span>
<a name="l00142"></a>00142 <span class="comment">// }</span>
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00146"></a>00146 <span class="preprocessor"></span>
<a name="l00147"></a>00147 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
