<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1665b3ccb6c776ec6797fe204e2359e5.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>cell_prism6.C</h1>  </div>
</div>
<div class="contents">
<a href="cell__prism6_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_prism6.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;side.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;cell_prism6.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;edge_edge2.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;face_quad4.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;face_tri3.h&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00033"></a>00033 <span class="comment">// Prism6 class static member initializations</span>
<a name="l00034"></a>00034 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPrism6.php#ae55cb11dcfebeebfbaee16ab99c65987">Prism6::side_nodes_map</a>[5][4] =
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036   {0, 2, 1, 99}, <span class="comment">// Side 0</span>
<a name="l00037"></a>00037   {0, 1, 4,  3}, <span class="comment">// Side 1</span>
<a name="l00038"></a>00038   {1, 2, 5,  4}, <span class="comment">// Side 2</span>
<a name="l00039"></a>00039   {2, 0, 3,  5}, <span class="comment">// Side 3</span>
<a name="l00040"></a>00040   {3, 4, 5, 99}  <span class="comment">// Side 4</span>
<a name="l00041"></a>00041 };
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPrism6.php#ae675a49adb97432507a14c144791cd01">Prism6::edge_nodes_map</a>[9][2] =
<a name="l00044"></a>00044 {
<a name="l00045"></a>00045   {0, 1}, <span class="comment">// Side 0</span>
<a name="l00046"></a>00046   {1, 2}, <span class="comment">// Side 1</span>
<a name="l00047"></a>00047   {0, 2}, <span class="comment">// Side 2</span>
<a name="l00048"></a>00048   {0, 3}, <span class="comment">// Side 3</span>
<a name="l00049"></a>00049   {1, 4}, <span class="comment">// Side 4</span>
<a name="l00050"></a>00050   {2, 5}, <span class="comment">// Side 5</span>
<a name="l00051"></a>00051   {3, 4}, <span class="comment">// Side 6</span>
<a name="l00052"></a>00052   {4, 5}, <span class="comment">// Side 7</span>
<a name="l00053"></a>00053   {3, 5}  <span class="comment">// Side 8</span>
<a name="l00054"></a>00054 };
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00058"></a>00058 <span class="comment">// Prism6 class member functions</span>
<a name="l00059"></a>00059 
<a name="l00060"></a><a class="code" href="classPrism6.php#aff807bca0e4d8c129f3a7da0e5c9ac8a">00060</a> <span class="keywordtype">bool</span> <a class="code" href="classPrism6.php#aff807bca0e4d8c129f3a7da0e5c9ac8a">Prism6::is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00061"></a>00061 <span class="keyword"></span>{
<a name="l00062"></a>00062   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00063"></a>00063 }
<a name="l00064"></a>00064 
<a name="l00065"></a><a class="code" href="classPrism6.php#a023de951f3e3a9d455235d57d5a047fd">00065</a> <span class="keywordtype">bool</span> <a class="code" href="classPrism6.php#a023de951f3e3a9d455235d57d5a047fd">Prism6::is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00066"></a>00066 <span class="keyword"></span>{
<a name="l00067"></a>00067   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00068"></a>00068 }
<a name="l00069"></a>00069 
<a name="l00070"></a><a class="code" href="classPrism6.php#a802146defdae6e1fb2329367ca4e905d">00070</a> <span class="keywordtype">bool</span> <a class="code" href="classPrism6.php#a802146defdae6e1fb2329367ca4e905d">Prism6::is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00071"></a>00071 <span class="keyword"></span>{
<a name="l00072"></a>00072   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00073"></a>00073 }
<a name="l00074"></a>00074 
<a name="l00075"></a><a class="code" href="classPrism6.php#aad51a04f16e60bcb036e4bf925c67da5">00075</a> <span class="keywordtype">bool</span> <a class="code" href="classPrism6.php#aad51a04f16e60bcb036e4bf925c67da5">Prism6::is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00076"></a>00076                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00077"></a>00077 <span class="keyword"></span>{
<a name="l00078"></a>00078   libmesh_assert(s &lt; <a class="code" href="classPrism.php#a5c2bbf078434f0afc4a696489ef6e048">n_sides</a>());
<a name="l00079"></a>00079   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 4; ++i)
<a name="l00080"></a>00080     <span class="keywordflow">if</span> (<a class="code" href="classPrism6.php#ae55cb11dcfebeebfbaee16ab99c65987">side_nodes_map</a>[s][i] == n)
<a name="l00081"></a>00081       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00082"></a>00082   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00083"></a>00083 }
<a name="l00084"></a>00084 
<a name="l00085"></a><a class="code" href="classPrism6.php#a1b589a26bac6b25ef85633bf59aca366">00085</a> <span class="keywordtype">bool</span> <a class="code" href="classPrism6.php#a1b589a26bac6b25ef85633bf59aca366">Prism6::is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00086"></a>00086                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00087"></a>00087 <span class="keyword"></span>{
<a name="l00088"></a>00088   libmesh_assert(e &lt; <a class="code" href="classPrism.php#aeba2ca53522e43fd4fff305007e66a87">n_edges</a>());
<a name="l00089"></a>00089   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 2; ++i)
<a name="l00090"></a>00090     <span class="keywordflow">if</span> (<a class="code" href="classPrism6.php#ae675a49adb97432507a14c144791cd01">edge_nodes_map</a>[e][i] == n)
<a name="l00091"></a>00091       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00092"></a>00092   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00093"></a>00093 }
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a><a class="code" href="classPrism6.php#a7c207beaa54fd6b0adc26715cca3326c">00097</a> <span class="keywordtype">bool</span> <a class="code" href="classPrism6.php#a7c207beaa54fd6b0adc26715cca3326c">Prism6::has_affine_map</a>()<span class="keyword"> const</span>
<a name="l00098"></a>00098 <span class="keyword"></span>{
<a name="l00099"></a>00099   <span class="comment">// Make sure z edges are affine</span>
<a name="l00100"></a>00100   <a class="code" href="classPoint.php">Point</a> v = this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0);
<a name="l00101"></a>00101   <span class="keywordflow">if</span> (!v.<a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">relative_fuzzy_equals</a>(this-&gt;point(4) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1)) ||
<a name="l00102"></a>00102       !v.<a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">relative_fuzzy_equals</a>(this-&gt;point(5) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2)))
<a name="l00103"></a>00103     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00104"></a>00104   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00105"></a>00105 }
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a><a class="code" href="classPrism6.php#a96f037a5f8f45017572946342ec93482">00109</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classPrism6.php#a96f037a5f8f45017572946342ec93482">Prism6::build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00110"></a>00110                                   <span class="keywordtype">bool</span> proxy)<span class="keyword"> const</span>
<a name="l00111"></a>00111 <span class="keyword"></span>{
<a name="l00112"></a>00112   libmesh_assert (i &lt; this-&gt;<a class="code" href="classPrism.php#a5c2bbf078434f0afc4a696489ef6e048">n_sides</a>());
<a name="l00113"></a>00113 
<a name="l00114"></a>00114   <span class="keywordflow">if</span> (proxy)
<a name="l00115"></a>00115     {
<a name="l00116"></a>00116       <span class="keywordflow">switch</span>(i)
<a name="l00117"></a>00117         {
<a name="l00118"></a>00118         <span class="keywordflow">case</span> 0:
<a name="l00119"></a>00119         <span class="keywordflow">case</span> 4:
<a name="l00120"></a>00120           {
<a name="l00121"></a>00121             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classSide.php">Side&lt;Tri3,Prism6&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00122"></a>00122             <span class="keywordflow">return</span> face;
<a name="l00123"></a>00123           }
<a name="l00124"></a>00124 
<a name="l00125"></a>00125         <span class="keywordflow">case</span> 1:
<a name="l00126"></a>00126         <span class="keywordflow">case</span> 2:
<a name="l00127"></a>00127         <span class="keywordflow">case</span> 3:
<a name="l00128"></a>00128           {
<a name="l00129"></a>00129             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classSide.php">Side&lt;Quad4,Prism6&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00130"></a>00130             <span class="keywordflow">return</span> face;
<a name="l00131"></a>00131           }
<a name="l00132"></a>00132 
<a name="l00133"></a>00133         <span class="keywordflow">default</span>:
<a name="l00134"></a>00134           {
<a name="l00135"></a>00135             libmesh_error();
<a name="l00136"></a>00136           }
<a name="l00137"></a>00137         }
<a name="l00138"></a>00138     }
<a name="l00139"></a>00139 
<a name="l00140"></a>00140   <span class="keywordflow">else</span>
<a name="l00141"></a>00141     {
<a name="l00142"></a>00142       <span class="keywordflow">switch</span> (i)
<a name="l00143"></a>00143         {
<a name="l00144"></a>00144         <span class="keywordflow">case</span> 0:  <span class="comment">// the triangular face at z=-1</span>
<a name="l00145"></a>00145           {
<a name="l00146"></a>00146             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classTri3.php">Tri3</a>);
<a name="l00147"></a>00147 
<a name="l00148"></a>00148             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00149"></a>00149             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00150"></a>00150             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00151"></a>00151 
<a name="l00152"></a>00152             <span class="keywordflow">return</span> face;
<a name="l00153"></a>00153           }
<a name="l00154"></a>00154         <span class="keywordflow">case</span> 1:  <span class="comment">// the quad face at y=0</span>
<a name="l00155"></a>00155           {
<a name="l00156"></a>00156             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classQuad4.php">Quad4</a>);
<a name="l00157"></a>00157         
<a name="l00158"></a>00158             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00159"></a>00159             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00160"></a>00160             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(4);
<a name="l00161"></a>00161             face-&gt;set_node(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00162"></a>00162         
<a name="l00163"></a>00163             <span class="keywordflow">return</span> face;
<a name="l00164"></a>00164           }
<a name="l00165"></a>00165         <span class="keywordflow">case</span> 2:  <span class="comment">// the other quad face</span>
<a name="l00166"></a>00166           {
<a name="l00167"></a>00167             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classQuad4.php">Quad4</a>);
<a name="l00168"></a>00168 
<a name="l00169"></a>00169             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00170"></a>00170             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00171"></a>00171             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(5);
<a name="l00172"></a>00172             face-&gt;set_node(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(4);
<a name="l00173"></a>00173 
<a name="l00174"></a>00174             <span class="keywordflow">return</span> face;
<a name="l00175"></a>00175           }
<a name="l00176"></a>00176         <span class="keywordflow">case</span> 3: <span class="comment">// the quad face at x=0</span>
<a name="l00177"></a>00177           {
<a name="l00178"></a>00178             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classQuad4.php">Quad4</a>);
<a name="l00179"></a>00179 
<a name="l00180"></a>00180             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00181"></a>00181             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00182"></a>00182             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00183"></a>00183             face-&gt;set_node(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(5);
<a name="l00184"></a>00184         
<a name="l00185"></a>00185             <span class="keywordflow">return</span> face;
<a name="l00186"></a>00186           }
<a name="l00187"></a>00187         <span class="keywordflow">case</span> 4: <span class="comment">// the triangular face at z=1</span>
<a name="l00188"></a>00188           {
<a name="l00189"></a>00189             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classTri3.php">Tri3</a>);
<a name="l00190"></a>00190 
<a name="l00191"></a>00191             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00192"></a>00192             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(4);
<a name="l00193"></a>00193             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(5);
<a name="l00194"></a>00194 
<a name="l00195"></a>00195             <span class="keywordflow">return</span> face;
<a name="l00196"></a>00196           }
<a name="l00197"></a>00197         <span class="keywordflow">default</span>:
<a name="l00198"></a>00198           {
<a name="l00199"></a>00199             libmesh_error();
<a name="l00200"></a>00200           }
<a name="l00201"></a>00201         }
<a name="l00202"></a>00202     }
<a name="l00203"></a>00203   
<a name="l00204"></a>00204   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00205"></a>00205   libmesh_error();
<a name="l00206"></a>00206   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00207"></a>00207 }
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 
<a name="l00211"></a><a class="code" href="classPrism6.php#aa7ca826ef1a99ee1de0d7c0194543f57">00211</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classPrism6.php#aa7ca826ef1a99ee1de0d7c0194543f57">Prism6::build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00212"></a>00212 <span class="keyword"></span>{
<a name="l00213"></a>00213   libmesh_assert (i &lt; this-&gt;<a class="code" href="classPrism.php#aeba2ca53522e43fd4fff305007e66a87">n_edges</a>());
<a name="l00214"></a>00214 
<a name="l00215"></a>00215   <span class="keywordflow">return</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a>(<span class="keyword">new</span> <a class="code" href="classSideEdge.php">SideEdge&lt;Edge2,Prism6&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00216"></a>00216 }
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 
<a name="l00220"></a><a class="code" href="classPrism6.php#a81ab86ef1e6b2f256ab4d11cdcffcd6d">00220</a> <span class="keywordtype">void</span> <a class="code" href="classPrism6.php#a81ab86ef1e6b2f256ab4d11cdcffcd6d">Prism6::connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00221"></a>00221                           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00222"></a>00222                           std::vector&lt;unsigned int&gt;&amp; conn)<span class="keyword"> const</span>
<a name="l00223"></a>00223 <span class="keyword"></span>{
<a name="l00224"></a>00224   libmesh_assert (<a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a> != NULL);
<a name="l00225"></a>00225   libmesh_assert (sc &lt; this-&gt;<a class="code" href="classPrism6.php#a35b4d8fd55c35b6e71c9aa3dfc65c058">n_sub_elem</a>());
<a name="l00226"></a>00226   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00227"></a>00227 
<a name="l00228"></a>00228   <span class="keywordflow">switch</span> (iop)
<a name="l00229"></a>00229     {
<a name="l00230"></a>00230     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00231"></a>00231       {
<a name="l00232"></a>00232         conn.resize(8);
<a name="l00233"></a>00233         conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0)+1;
<a name="l00234"></a>00234         conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1)+1;
<a name="l00235"></a>00235         conn[2] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2)+1;
<a name="l00236"></a>00236         conn[3] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2)+1;
<a name="l00237"></a>00237         conn[4] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3)+1;
<a name="l00238"></a>00238         conn[5] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(4)+1;
<a name="l00239"></a>00239         conn[6] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(5)+1;
<a name="l00240"></a>00240         conn[7] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(5)+1;
<a name="l00241"></a>00241         <span class="keywordflow">return</span>;
<a name="l00242"></a>00242       }
<a name="l00243"></a>00243 
<a name="l00244"></a>00244     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa1affb8987f83b5e4acb22d9401dd44ef">VTK</a>:
<a name="l00245"></a>00245       {
<a name="l00246"></a>00246         conn.resize(6);
<a name="l00247"></a>00247         conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0);
<a name="l00248"></a>00248         conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2);
<a name="l00249"></a>00249         conn[2] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1);
<a name="l00250"></a>00250         conn[3] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3);
<a name="l00251"></a>00251         conn[4] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(5);
<a name="l00252"></a>00252         conn[5] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(4);
<a name="l00253"></a>00253         <span class="keywordflow">return</span>;
<a name="l00254"></a>00254       }
<a name="l00255"></a>00255 
<a name="l00256"></a>00256     <span class="keywordflow">default</span>:
<a name="l00257"></a>00257       libmesh_error();
<a name="l00258"></a>00258     }
<a name="l00259"></a>00259 
<a name="l00260"></a>00260   libmesh_error();
<a name="l00261"></a>00261 }
<a name="l00262"></a>00262 
<a name="l00263"></a>00263 
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00266"></a>00266 <span class="preprocessor"></span>
<a name="l00267"></a>00267 <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classPrism6.php#a622a8b3c54420e51c0539ff3c2c50a70">Prism6::_embedding_matrix</a>[8][6][6] =
<a name="l00268"></a>00268 {
<a name="l00269"></a>00269   <span class="comment">// embedding matrix for child 0</span>
<a name="l00270"></a>00270   {
<a name="l00271"></a>00271     <span class="comment">//  0     1     2     3     4     5</span>
<a name="l00272"></a>00272     { 1.0,  0.0,  0.0,  0.0,  0.0,  0.0}, <span class="comment">// 0</span>
<a name="l00273"></a>00273     { 0.5,  0.5,  0.0,  0.0,  0.0,  0.0}, <span class="comment">// 1</span>
<a name="l00274"></a>00274     { 0.5,  0.0,  0.5,  0.0,  0.0,  0.0}, <span class="comment">// 2</span>
<a name="l00275"></a>00275     { 0.5,  0.0,  0.0,  0.5,  0.0,  0.0}, <span class="comment">// 3</span>
<a name="l00276"></a>00276     { .25,  .25,  0.0,  .25,  .25,  0.0}, <span class="comment">// 4</span>
<a name="l00277"></a>00277     { .25,  0.0,  .25,  .25,  0.0,  .25}  <span class="comment">// 5</span>
<a name="l00278"></a>00278   },
<a name="l00279"></a>00279 
<a name="l00280"></a>00280   <span class="comment">// embedding matrix for child 1</span>
<a name="l00281"></a>00281   {
<a name="l00282"></a>00282     <span class="comment">//  0     1     2     3     4     5</span>
<a name="l00283"></a>00283     { 0.5,  0.5,  0.0,  0.0,  0.0,  0.0}, <span class="comment">// 0</span>
<a name="l00284"></a>00284     { 0.0,  1.0,  0.0,  0.0,  0.0,  0.0}, <span class="comment">// 1</span>
<a name="l00285"></a>00285     { 0.0,  0.5,  0.5,  0.0,  0.0,  0.0}, <span class="comment">// 2</span>
<a name="l00286"></a>00286     { .25,  .25,  0.0,  .25,  .25,  0.0}, <span class="comment">// 3</span>
<a name="l00287"></a>00287     { 0.0,  0.5,  0.0,  0.0,  0.5,  0.0}, <span class="comment">// 4</span>
<a name="l00288"></a>00288     { 0.0,  .25,  .25,  0.0,  .25,  .25}  <span class="comment">// 5</span>
<a name="l00289"></a>00289   },
<a name="l00290"></a>00290 
<a name="l00291"></a>00291   <span class="comment">// embedding matrix for child 2</span>
<a name="l00292"></a>00292   {
<a name="l00293"></a>00293     <span class="comment">//  0     1     2     3     4     5</span>
<a name="l00294"></a>00294     { 0.5,  0.0,  0.5,  0.0,  0.0,  0.0}, <span class="comment">// 0</span>
<a name="l00295"></a>00295     { 0.0,  0.5,  0.5,  0.0,  0.0,  0.0}, <span class="comment">// 1</span>
<a name="l00296"></a>00296     { 0.0,  0.0,  1.0,  0.0,  0.0,  0.0}, <span class="comment">// 2</span>
<a name="l00297"></a>00297     { .25,  0.0,  .25,  .25,  0.0,  .25}, <span class="comment">// 3</span>
<a name="l00298"></a>00298     { 0.0,  .25,  .25,  0.0,  .25,  .25}, <span class="comment">// 4</span>
<a name="l00299"></a>00299     { 0.0,  0.0,  0.5,  0.0,  0.0,  0.5}  <span class="comment">// 5</span>
<a name="l00300"></a>00300   },
<a name="l00301"></a>00301 
<a name="l00302"></a>00302   <span class="comment">// embedding matrix for child 3</span>
<a name="l00303"></a>00303   {
<a name="l00304"></a>00304     <span class="comment">//  0     1     2     3     4     5</span>
<a name="l00305"></a>00305     { 0.5,  0.5,  0.0,  0.0,  0.0,  0.0}, <span class="comment">// 0</span>
<a name="l00306"></a>00306     { 0.0,  0.5,  0.5,  0.0,  0.0,  0.0}, <span class="comment">// 1</span>
<a name="l00307"></a>00307     { 0.5,  0.0,  0.5,  0.0,  0.0,  0.0}, <span class="comment">// 2</span>
<a name="l00308"></a>00308     { .25,  .25,  0.0,  .25,  .25,  0.0}, <span class="comment">// 3</span>
<a name="l00309"></a>00309     { 0.0,  .25,  .25,  0.0,  .25,  .25}, <span class="comment">// 4</span>
<a name="l00310"></a>00310     { .25,  0.0,  .25,  .25,  0.0,  .25}  <span class="comment">// 5</span>
<a name="l00311"></a>00311   },
<a name="l00312"></a>00312 
<a name="l00313"></a>00313   <span class="comment">// embedding matrix for child 4</span>
<a name="l00314"></a>00314   {
<a name="l00315"></a>00315     <span class="comment">//  0     1     2     3     4     5</span>
<a name="l00316"></a>00316     { 0.5,  0.0,  0.0,  0.5,  0.0,  0.0}, <span class="comment">// 0</span>
<a name="l00317"></a>00317     { .25,  .25,  0.0,  .25,  .25,  0.0}, <span class="comment">// 1</span>
<a name="l00318"></a>00318     { .25,  0.0,  .25,  .25,  0.0,  .25}, <span class="comment">// 2</span>
<a name="l00319"></a>00319     { 0.0,  0.0,  0.0,  1.0,  0.0,  0.0}, <span class="comment">// 3</span>
<a name="l00320"></a>00320     { 0.0,  0.0,  0.0,  0.5,  0.5,  0.0}, <span class="comment">// 4</span>
<a name="l00321"></a>00321     { 0.0,  0.0,  0.0,  0.5,  0.0,  0.5}  <span class="comment">// 5</span>
<a name="l00322"></a>00322   },
<a name="l00323"></a>00323 
<a name="l00324"></a>00324   <span class="comment">// embedding matrix for child 5</span>
<a name="l00325"></a>00325   {
<a name="l00326"></a>00326     <span class="comment">//  0     1     2     3     4     5</span>
<a name="l00327"></a>00327     { .25,  .25,  0.0,  .25,  .25,  0.0}, <span class="comment">// 0</span>
<a name="l00328"></a>00328     { 0.0,  0.5,  0.0,  0.0,  0.5,  0.0}, <span class="comment">// 1</span>
<a name="l00329"></a>00329     { 0.0,  .25,  .25,  0.0,  .25,  .25}, <span class="comment">// 2</span>
<a name="l00330"></a>00330     { 0.0,  0.0,  0.0,  0.5,  0.5,  0.0}, <span class="comment">// 3</span>
<a name="l00331"></a>00331     { 0.0,  0.0,  0.0,  0.0,  1.0,  0.0}, <span class="comment">// 4</span>
<a name="l00332"></a>00332     { 0.0,  0.0,  0.0,  0.0,  0.5,  0.5}  <span class="comment">// 5</span>
<a name="l00333"></a>00333   },
<a name="l00334"></a>00334 
<a name="l00335"></a>00335   <span class="comment">// embedding matrix for child 6</span>
<a name="l00336"></a>00336   {
<a name="l00337"></a>00337     <span class="comment">//  0     1     2     3     4     5</span>
<a name="l00338"></a>00338     { .25,  0.0,  .25,  .25,  0.0,  .25}, <span class="comment">// 0</span>
<a name="l00339"></a>00339     { 0.0,  .25,  .25,  0.0,  .25,  .25}, <span class="comment">// 1</span>
<a name="l00340"></a>00340     { 0.0,  0.0,  0.5,  0.0,  0.0,  0.5}, <span class="comment">// 2</span>
<a name="l00341"></a>00341     { 0.0,  0.0,  0.0,  0.5,  0.0,  0.5}, <span class="comment">// 3</span>
<a name="l00342"></a>00342     { 0.0,  0.0,  0.0,  0.0,  0.5,  0.5}, <span class="comment">// 4</span>
<a name="l00343"></a>00343     { 0.0,  0.0,  0.0,  0.0,  0.0,  1.0}  <span class="comment">// 5</span>
<a name="l00344"></a>00344   },
<a name="l00345"></a>00345 
<a name="l00346"></a>00346   <span class="comment">// embedding matrix for child 7</span>
<a name="l00347"></a>00347   {
<a name="l00348"></a>00348     <span class="comment">//  0     1     2     3     4     5</span>
<a name="l00349"></a>00349     { .25,  .25,  0.0,  .25,  .25,  0.0}, <span class="comment">// 0</span>
<a name="l00350"></a>00350     { 0.0,  .25,  .25,  0.0,  .25,  .25}, <span class="comment">// 1</span>
<a name="l00351"></a>00351     { .25,  0.0,  .25,  .25,  0.0,  .25}, <span class="comment">// 2</span>
<a name="l00352"></a>00352     { 0.0,  0.0,  0.0,  0.5,  0.5,  0.0}, <span class="comment">// 3</span>
<a name="l00353"></a>00353     { 0.0,  0.0,  0.0,  0.0,  0.5,  0.5}, <span class="comment">// 4</span>
<a name="l00354"></a>00354     { 0.0,  0.0,  0.0,  0.5,  0.0,  0.5}  <span class="comment">// 5</span>
<a name="l00355"></a>00355   }
<a name="l00356"></a>00356 };
<a name="l00357"></a>00357 
<a name="l00358"></a>00358 <span class="preprocessor">#endif</span>
<a name="l00359"></a>00359 <span class="preprocessor"></span>
<a name="l00360"></a>00360 
<a name="l00361"></a>00361 
<a name="l00362"></a><a class="code" href="classPrism6.php#a7918693ad2bde7c718ced281b3d569e3">00362</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classPrism6.php#a7918693ad2bde7c718ced281b3d569e3">Prism6::volume</a> ()<span class="keyword"> const</span>
<a name="l00363"></a>00363 <span class="keyword"></span>{
<a name="l00364"></a>00364   <span class="comment">// The volume of the prism is computed by splitting</span>
<a name="l00365"></a>00365   <span class="comment">// it into 2 tetrahedra and 3 pyramids with bilinear bases.</span>
<a name="l00366"></a>00366   <span class="comment">// Then the volume formulae for the tetrahedron and pyramid</span>
<a name="l00367"></a>00367   <span class="comment">// are applied and summed to obtain the prism&#39;s volume.</span>
<a name="l00368"></a>00368 
<a name="l00369"></a>00369   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> sub_pyr[3][4] =
<a name="l00370"></a>00370     {
<a name="l00371"></a>00371       {0, 1, 4, 3},
<a name="l00372"></a>00372       {1, 2, 5, 4},
<a name="l00373"></a>00373       {0, 3, 5, 2}
<a name="l00374"></a>00374     };
<a name="l00375"></a>00375 
<a name="l00376"></a>00376   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> sub_tet[2][3] =
<a name="l00377"></a>00377     {
<a name="l00378"></a>00378       {0, 1, 2},
<a name="l00379"></a>00379       {5, 4, 3}
<a name="l00380"></a>00380     };
<a name="l00381"></a>00381 
<a name="l00382"></a>00382   <span class="comment">// The centroid is a convenient point to use</span>
<a name="l00383"></a>00383   <span class="comment">// for the apex of all the pyramids.</span>
<a name="l00384"></a>00384   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> R = this-&gt;<a class="code" href="classElem.php#a46ce080150f08ce9d367b69f16dd0452">centroid</a>();
<a name="l00385"></a>00385 
<a name="l00386"></a>00386   <span class="comment">// temporary storage for Nodes which form the base of the</span>
<a name="l00387"></a>00387   <span class="comment">// subelements</span>
<a name="l00388"></a>00388   <a class="code" href="classNode.php">Node</a>* base[4];
<a name="l00389"></a>00389 
<a name="l00390"></a>00390   <span class="comment">// volume accumulation variable</span>
<a name="l00391"></a>00391   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> vol=0.;
<a name="l00392"></a>00392 
<a name="l00393"></a>00393   <span class="comment">// Add up the sub-pyramid volumes</span>
<a name="l00394"></a>00394   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;3; ++n)
<a name="l00395"></a>00395     {
<a name="l00396"></a>00396       <span class="comment">// Set the nodes of the pyramid base</span>
<a name="l00397"></a>00397       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;4; ++i)
<a name="l00398"></a>00398         base[i] = this-&gt;<a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a>[sub_pyr[n][i]];
<a name="l00399"></a>00399       
<a name="l00400"></a>00400       <span class="comment">// Compute diff vectors</span>
<a name="l00401"></a>00401       <a class="code" href="classPoint.php">Point</a> a ( *base[0] - R );
<a name="l00402"></a>00402       <a class="code" href="classPoint.php">Point</a> b ( *base[1] - *base[3] );
<a name="l00403"></a>00403       <a class="code" href="classPoint.php">Point</a> c ( *base[2] - *base[0] );
<a name="l00404"></a>00404       <a class="code" href="classPoint.php">Point</a> d ( *base[3] - *base[0] );
<a name="l00405"></a>00405       <a class="code" href="classPoint.php">Point</a> e ( *base[1] - *base[0] );
<a name="l00406"></a>00406 
<a name="l00407"></a>00407       <span class="comment">// Compute pyramid volume</span>
<a name="l00408"></a>00408       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> sub_vol = (1./6.)*(a*(b.<a class="code" href="classTypeVector.php#a1347e1223f3e31f8a2c0496736e60dc5">cross</a>(c))) + (1./12.)*(c*(d.<a class="code" href="classTypeVector.php#a1347e1223f3e31f8a2c0496736e60dc5">cross</a>(e)));
<a name="l00409"></a>00409 
<a name="l00410"></a>00410       libmesh_assert (sub_vol&gt;0.);
<a name="l00411"></a>00411 
<a name="l00412"></a>00412       vol += sub_vol;
<a name="l00413"></a>00413     }
<a name="l00414"></a>00414 
<a name="l00415"></a>00415 
<a name="l00416"></a>00416   <span class="comment">// Add up the sub-tet volumes</span>
<a name="l00417"></a>00417   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;2; ++n)
<a name="l00418"></a>00418     {
<a name="l00419"></a>00419       <span class="comment">// Set the nodes of the pyramid base</span>
<a name="l00420"></a>00420       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;3; ++i)
<a name="l00421"></a>00421         base[i] = this-&gt;<a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a>[sub_tet[n][i]];
<a name="l00422"></a>00422 
<a name="l00423"></a>00423       <span class="comment">// The volume of a tetrahedron is 1/6 the box product formed</span>
<a name="l00424"></a>00424       <span class="comment">// by its base and apex vectors</span>
<a name="l00425"></a>00425       <a class="code" href="classPoint.php">Point</a> a ( R - *base[0] );
<a name="l00426"></a>00426       
<a name="l00427"></a>00427       <span class="comment">// b is the vector pointing from 0 to 1</span>
<a name="l00428"></a>00428       <a class="code" href="classPoint.php">Point</a> b ( *base[1] - *base[0] );
<a name="l00429"></a>00429       
<a name="l00430"></a>00430       <span class="comment">// c is the vector pointing from 0 to 2</span>
<a name="l00431"></a>00431       <a class="code" href="classPoint.php">Point</a> c ( *base[2] - *base[0] );
<a name="l00432"></a>00432       
<a name="l00433"></a>00433       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> sub_vol =  (1.0 / 6.0) * (a * (b.<a class="code" href="classTypeVector.php#a1347e1223f3e31f8a2c0496736e60dc5">cross</a>(c)));
<a name="l00434"></a>00434 
<a name="l00435"></a>00435       libmesh_assert (sub_vol&gt;0.);
<a name="l00436"></a>00436 
<a name="l00437"></a>00437       vol += sub_vol;
<a name="l00438"></a>00438     }  
<a name="l00439"></a>00439 
<a name="l00440"></a>00440 
<a name="l00441"></a>00441   <span class="comment">// Done with all sub-volumes, so return</span>
<a name="l00442"></a>00442   <span class="keywordflow">return</span> vol;
<a name="l00443"></a>00443  }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
