<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1665b3ccb6c776ec6797fe204e2359e5.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>cell_prism.C</h1>  </div>
</div>
<div class="contents">
<a href="cell__prism_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_prism.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;cell_prism.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;cell_prism6.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;face_quad4.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;face_tri3.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00031"></a>00031 <span class="comment">// Prism class member functions</span>
<a name="l00032"></a><a class="code" href="classPrism.php#ac22d13e7cf75b87b4b933e6cd22482f8">00032</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPrism.php#ac22d13e7cf75b87b4b933e6cd22482f8">Prism::key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00033"></a>00033 <span class="keyword"></span>{
<a name="l00034"></a>00034   libmesh_assert (s &lt; this-&gt;<a class="code" href="classPrism.php#a5c2bbf078434f0afc4a696489ef6e048">n_sides</a>());
<a name="l00035"></a>00035 
<a name="l00036"></a>00036   <span class="keywordflow">switch</span> (s)
<a name="l00037"></a>00037     {
<a name="l00038"></a>00038     <span class="keywordflow">case</span> 0:  <span class="comment">// the triangular face at z=0</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040       <span class="keywordflow">return</span>    
<a name="l00041"></a>00041         this-&gt;<a class="code" href="classElem.php#a859c8236824914afa005cacf1ee86959">compute_key</a> (this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0),
<a name="l00042"></a>00042                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2),
<a name="l00043"></a>00043                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1));
<a name="l00044"></a>00044       
<a name="l00045"></a>00045     <span class="keywordflow">case</span> 1:  <span class="comment">// the quad face at y=0</span>
<a name="l00046"></a>00046 
<a name="l00047"></a>00047       <span class="keywordflow">return</span>
<a name="l00048"></a>00048         this-&gt;<a class="code" href="classElem.php#a859c8236824914afa005cacf1ee86959">compute_key</a> (this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0),
<a name="l00049"></a>00049                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1),
<a name="l00050"></a>00050                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(4),
<a name="l00051"></a>00051                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3));
<a name="l00052"></a>00052         
<a name="l00053"></a>00053     <span class="keywordflow">case</span> 2:  <span class="comment">// the other quad face</span>
<a name="l00054"></a>00054 
<a name="l00055"></a>00055       <span class="keywordflow">return</span>
<a name="l00056"></a>00056         this-&gt;<a class="code" href="classElem.php#a859c8236824914afa005cacf1ee86959">compute_key</a> (this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1),
<a name="l00057"></a>00057                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2),
<a name="l00058"></a>00058                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(5),
<a name="l00059"></a>00059                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(4));
<a name="l00060"></a>00060 
<a name="l00061"></a>00061     <span class="keywordflow">case</span> 3: <span class="comment">// the quad face at x=0</span>
<a name="l00062"></a>00062 
<a name="l00063"></a>00063       <span class="keywordflow">return</span>
<a name="l00064"></a>00064         this-&gt;<a class="code" href="classElem.php#a859c8236824914afa005cacf1ee86959">compute_key</a> (this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2),
<a name="l00065"></a>00065                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0),
<a name="l00066"></a>00066                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3),
<a name="l00067"></a>00067                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(5));      
<a name="l00068"></a>00068     <span class="keywordflow">case</span> 4: <span class="comment">// the triangular face at z=1</span>
<a name="l00069"></a>00069 
<a name="l00070"></a>00070       <span class="keywordflow">return</span>
<a name="l00071"></a>00071         this-&gt;<a class="code" href="classElem.php#a859c8236824914afa005cacf1ee86959">compute_key</a> (this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3),
<a name="l00072"></a>00072                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(4),
<a name="l00073"></a>00073                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(5));
<a name="l00074"></a>00074     }
<a name="l00075"></a>00075   
<a name="l00076"></a>00076   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00077"></a>00077   libmesh_error();
<a name="l00078"></a>00078   <span class="keywordflow">return</span> 0;
<a name="l00079"></a>00079 }
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a><a class="code" href="classPrism.php#acb1a4627e68d279b5993b75bd787a0f6">00083</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> <a class="code" href="classPrism.php#acb1a4627e68d279b5993b75bd787a0f6">Prism::side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00084"></a>00084 <span class="keyword"></span>{
<a name="l00085"></a>00085   libmesh_assert (i &lt; this-&gt;<a class="code" href="classPrism.php#a5c2bbf078434f0afc4a696489ef6e048">n_sides</a>());
<a name="l00086"></a>00086 
<a name="l00087"></a>00087   <span class="keywordflow">switch</span> (i)
<a name="l00088"></a>00088     {
<a name="l00089"></a>00089     <span class="keywordflow">case</span> 0:  <span class="comment">// the triangular face at z=0</span>
<a name="l00090"></a>00090       {
<a name="l00091"></a>00091         <a class="code" href="classElem.php">Elem</a>* facet = <span class="keyword">new</span> <a class="code" href="classTri3.php">Tri3</a>;
<a name="l00092"></a>00092         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> ap_facet(facet);
<a name="l00093"></a>00093   
<a name="l00094"></a>00094         facet-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00095"></a>00095         facet-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00096"></a>00096         facet-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00097"></a>00097 
<a name="l00098"></a>00098         <span class="keywordflow">return</span> ap_facet;
<a name="l00099"></a>00099       }
<a name="l00100"></a>00100     <span class="keywordflow">case</span> 1:  <span class="comment">// the quad face at y=0</span>
<a name="l00101"></a>00101       {
<a name="l00102"></a>00102         <a class="code" href="classElem.php">Elem</a>* faceq = <span class="keyword">new</span> <a class="code" href="classQuad4.php">Quad4</a>;
<a name="l00103"></a>00103         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> ap_faceq(faceq);
<a name="l00104"></a>00104         
<a name="l00105"></a>00105         faceq-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00106"></a>00106         faceq-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00107"></a>00107         faceq-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(4);
<a name="l00108"></a>00108         faceq-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00109"></a>00109         
<a name="l00110"></a>00110         <span class="keywordflow">return</span> ap_faceq;
<a name="l00111"></a>00111       }
<a name="l00112"></a>00112     <span class="keywordflow">case</span> 2:  <span class="comment">// the other quad face</span>
<a name="l00113"></a>00113       {
<a name="l00114"></a>00114         <a class="code" href="classElem.php">Elem</a>* faceq = <span class="keyword">new</span> <a class="code" href="classQuad4.php">Quad4</a>;
<a name="l00115"></a>00115         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> ap_faceq(faceq);
<a name="l00116"></a>00116       
<a name="l00117"></a>00117         faceq-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00118"></a>00118         faceq-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00119"></a>00119         faceq-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(5);
<a name="l00120"></a>00120         faceq-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(4);
<a name="l00121"></a>00121 
<a name="l00122"></a>00122         <span class="keywordflow">return</span> ap_faceq;
<a name="l00123"></a>00123       }
<a name="l00124"></a>00124     <span class="keywordflow">case</span> 3: <span class="comment">// the quad face at x=0</span>
<a name="l00125"></a>00125       {
<a name="l00126"></a>00126         <a class="code" href="classElem.php">Elem</a>* faceq = <span class="keyword">new</span> <a class="code" href="classQuad4.php">Quad4</a>;
<a name="l00127"></a>00127         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> ap_faceq(faceq);
<a name="l00128"></a>00128 
<a name="l00129"></a>00129         faceq-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00130"></a>00130         faceq-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00131"></a>00131         faceq-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00132"></a>00132         faceq-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(5);
<a name="l00133"></a>00133         
<a name="l00134"></a>00134         <span class="keywordflow">return</span> ap_faceq;
<a name="l00135"></a>00135       }
<a name="l00136"></a>00136     <span class="keywordflow">case</span> 4: <span class="comment">// the triangular face at z=1</span>
<a name="l00137"></a>00137       {
<a name="l00138"></a>00138         <a class="code" href="classElem.php">Elem</a>* facet = <span class="keyword">new</span> <a class="code" href="classTri3.php">Tri3</a>;
<a name="l00139"></a>00139         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> ap_facet(facet);
<a name="l00140"></a>00140       
<a name="l00141"></a>00141         facet-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00142"></a>00142         facet-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(4);
<a name="l00143"></a>00143         facet-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(5);
<a name="l00144"></a>00144         
<a name="l00145"></a>00145         <span class="keywordflow">return</span> ap_facet;
<a name="l00146"></a>00146       }
<a name="l00147"></a>00147     <span class="keywordflow">default</span>:
<a name="l00148"></a>00148       {
<a name="l00149"></a>00149         libmesh_error();
<a name="l00150"></a>00150         <a class="code" href="classElem.php">Elem</a>* facet = <span class="keyword">new</span> <a class="code" href="classTri3.php">Tri3</a>;
<a name="l00151"></a>00151         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> ap_facet(facet);
<a name="l00152"></a>00152         <span class="keywordflow">return</span> ap_facet;
<a name="l00153"></a>00153       }
<a name="l00154"></a>00154     }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00157"></a>00157   libmesh_error();
<a name="l00158"></a>00158   <a class="code" href="classElem.php">Elem</a>* facet = <span class="keyword">new</span> <a class="code" href="classTri3.php">Tri3</a>;
<a name="l00159"></a>00159   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> ap_facet(facet);
<a name="l00160"></a>00160   <span class="keywordflow">return</span> ap_facet;
<a name="l00161"></a>00161 }
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 
<a name="l00165"></a><a class="code" href="classPrism.php#a19f70a4b9f203af5474bcce6d2db4f3a">00165</a> <span class="keywordtype">bool</span> <a class="code" href="classPrism.php#a19f70a4b9f203af5474bcce6d2db4f3a">Prism::is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00166"></a>00166                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00167"></a>00167 <span class="keyword"></span>{
<a name="l00168"></a>00168   libmesh_assert (c &lt; this-&gt;<a class="code" href="classPrism.php#aef4baf93d801cd51deab47e3070760b2">n_children</a>());
<a name="l00169"></a>00169   libmesh_assert (s &lt; this-&gt;<a class="code" href="classPrism.php#a5c2bbf078434f0afc4a696489ef6e048">n_sides</a>());
<a name="l00170"></a>00170 
<a name="l00171"></a>00171   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 4; ++i)
<a name="l00172"></a>00172     <span class="keywordflow">if</span> (<a class="code" href="classPrism6.php#ae55cb11dcfebeebfbaee16ab99c65987">Prism6::side_nodes_map</a>[s][i] == c)
<a name="l00173"></a>00173       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00174"></a>00174   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00175"></a>00175 }
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classPrism.php#ac783041466bb3e2d84a12f6b09d11fa4">Prism::_second_order_vertex_child_number</a>[18] =
<a name="l00180"></a>00180 {
<a name="l00181"></a>00181   99,99,99,99,99,99, <span class="comment">// Vertices</span>
<a name="l00182"></a>00182   0,1,0,0,1,2,3,4,3, <span class="comment">// Edges</span>
<a name="l00183"></a>00183   0,1,0              <span class="comment">// Faces</span>
<a name="l00184"></a>00184 };
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classPrism.php#abad86c0b55af2e58f94764a9ded7175b">Prism::_second_order_vertex_child_index</a>[18] =
<a name="l00189"></a>00189 {
<a name="l00190"></a>00190   99,99,99,99,99,99, <span class="comment">// Vertices</span>
<a name="l00191"></a>00191   1,2,2,3,4,5,4,5,5, <span class="comment">// Edges</span>
<a name="l00192"></a>00192   4,5,5              <span class="comment">// Faces</span>
<a name="l00193"></a>00193 };
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classPrism.php#a6795fe0fba0d8400d1eb3da1b9608166">Prism::_second_order_adjacent_vertices</a>[9][2] = 
<a name="l00197"></a>00197 {
<a name="l00198"></a>00198   { 0,  1}, <span class="comment">// vertices adjacent to node 6 </span>
<a name="l00199"></a>00199   { 1,  2}, <span class="comment">// vertices adjacent to node 7 </span>
<a name="l00200"></a>00200   { 0,  2}, <span class="comment">// vertices adjacent to node 8 </span>
<a name="l00201"></a>00201 
<a name="l00202"></a>00202   { 0,  3}, <span class="comment">// vertices adjacent to node 9 </span>
<a name="l00203"></a>00203   { 1,  4}, <span class="comment">// vertices adjacent to node 10 </span>
<a name="l00204"></a>00204   { 2,  5}, <span class="comment">// vertices adjacent to node 11</span>
<a name="l00205"></a>00205 
<a name="l00206"></a>00206   { 3,  4}, <span class="comment">// vertices adjacent to node 12</span>
<a name="l00207"></a>00207   { 4,  5}, <span class="comment">// vertices adjacent to node 13</span>
<a name="l00208"></a>00208   { 3,  5}  <span class="comment">// vertices adjacent to node 14</span>
<a name="l00209"></a>00209 };
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
