<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>cell_prism.h</h1>  </div>
</div>
<div class="contents">
<a href="cell__prism_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_prism.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __cell_prism_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __cell_prism_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="cell_8h.php">cell.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00037"></a>00037 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00038"></a>00038 <span class="comment">// Prism class definition</span>
<a name="l00039"></a><a class="code" href="classPrism.php">00039</a> <span class="keyword">class </span><a class="code" href="classPrism.php">Prism</a> : <span class="keyword">public</span> <a class="code" href="classCell.php">Cell</a>
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041 <span class="keyword">public</span>:
<a name="l00042"></a>00042 
<a name="l00047"></a>00047   <a class="code" href="classPrism.php#aadf0e698735d7c5809ed86b366f5fe18">Prism</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn, <a class="code" href="classElem.php">Elem</a>* p);
<a name="l00048"></a>00048   
<a name="l00053"></a><a class="code" href="classPrism.php#af5f1e22b97335adc3680963de85c91cd">00053</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPrism.php#af5f1e22b97335adc3680963de85c91cd">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 6; }
<a name="l00054"></a>00054 
<a name="l00058"></a><a class="code" href="classPrism.php#a5c2bbf078434f0afc4a696489ef6e048">00058</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPrism.php#a5c2bbf078434f0afc4a696489ef6e048">n_sides</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 5; }
<a name="l00059"></a>00059 
<a name="l00063"></a><a class="code" href="classPrism.php#a5ab57fdd039730ae8a7911eccbfefe29">00063</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPrism.php#a5ab57fdd039730ae8a7911eccbfefe29">n_vertices</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 6; }
<a name="l00064"></a>00064 
<a name="l00068"></a><a class="code" href="classPrism.php#aeba2ca53522e43fd4fff305007e66a87">00068</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPrism.php#aeba2ca53522e43fd4fff305007e66a87">n_edges</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 9; }
<a name="l00069"></a>00069 
<a name="l00073"></a><a class="code" href="classPrism.php#a49eb64fa59e7118cbefe97b1d6c533d8">00073</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPrism.php#a49eb64fa59e7118cbefe97b1d6c533d8">n_faces</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 5; }
<a name="l00074"></a>00074   
<a name="l00078"></a><a class="code" href="classPrism.php#aef4baf93d801cd51deab47e3070760b2">00078</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPrism.php#aef4baf93d801cd51deab47e3070760b2">n_children</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 8; }
<a name="l00079"></a>00079   
<a name="l00080"></a>00080   <span class="comment">/*</span>
<a name="l00081"></a>00081 <span class="comment">   * @returns true iff the specified child is on the</span>
<a name="l00082"></a>00082 <span class="comment">   * specified side</span>
<a name="l00083"></a>00083 <span class="comment">   */</span>
<a name="l00084"></a>00084   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classPrism.php#a19f70a4b9f203af5474bcce6d2db4f3a">is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00085"></a>00085                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00086"></a>00086   
<a name="l00092"></a>00092   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPrism.php#ac22d13e7cf75b87b4b933e6cd22482f8">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00093"></a>00093 
<a name="l00098"></a>00098   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> <a class="code" href="classPrism.php#acb1a4627e68d279b5993b75bd787a0f6">side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 <span class="keyword">protected</span>:
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00105"></a>00105   
<a name="l00112"></a><a class="code" href="classPrism.php#a6795fe0fba0d8400d1eb3da1b9608166">00112</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classPrism.php#a6795fe0fba0d8400d1eb3da1b9608166">_second_order_adjacent_vertices</a>[9][2];
<a name="l00113"></a>00113 
<a name="l00117"></a><a class="code" href="classPrism.php#ac783041466bb3e2d84a12f6b09d11fa4">00117</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classPrism.php#ac783041466bb3e2d84a12f6b09d11fa4">_second_order_vertex_child_number</a>[18];
<a name="l00118"></a>00118 
<a name="l00122"></a><a class="code" href="classPrism.php#abad86c0b55af2e58f94764a9ded7175b">00122</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classPrism.php#abad86c0b55af2e58f94764a9ded7175b">_second_order_vertex_child_index</a>[18];
<a name="l00123"></a>00123 };
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00128"></a>00128 <span class="comment">// Prism class member functions</span>
<a name="l00129"></a>00129 <span class="keyword">inline</span>
<a name="l00130"></a><a class="code" href="classPrism.php#aadf0e698735d7c5809ed86b366f5fe18">00130</a> <a class="code" href="classPrism.php#aadf0e698735d7c5809ed86b366f5fe18">Prism::Prism</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn, <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00131"></a>00131   <a class="code" href="classCell.php">Cell</a>(nn, <a class="code" href="classPrism.php">Prism</a>::n_sides(), p) 
<a name="l00132"></a>00132 {
<a name="l00133"></a>00133 }
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
