<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1665b3ccb6c776ec6797fe204e2359e5.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>cell_pyramid5.C</h1>  </div>
</div>
<div class="contents">
<a href="cell__pyramid5_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_pyramid5.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;side.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;cell_pyramid5.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;edge_edge2.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;face_tri3.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;face_quad4.h&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00034"></a>00034 <span class="comment">// Pyramid5 class static member initializations</span>
<a name="l00035"></a>00035 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPyramid5.php#af1874f7158485cfaa1e2a295070896b8">Pyramid5::side_nodes_map</a>[5][4] =
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037   {0, 1, 4, 99}, <span class="comment">// Side 0</span>
<a name="l00038"></a>00038   {1, 2, 4, 99}, <span class="comment">// Side 1</span>
<a name="l00039"></a>00039   {2, 3, 4, 99}, <span class="comment">// Side 2</span>
<a name="l00040"></a>00040   {3, 0, 4, 99}, <span class="comment">// Side 3</span>
<a name="l00041"></a>00041   {0, 3, 2,  1}  <span class="comment">// Side 4</span>
<a name="l00042"></a>00042 };
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPyramid5.php#aa4c3e10102ad6d57212efb50f3e16eb3">Pyramid5::edge_nodes_map</a>[8][2] =
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046   {0, 1}, <span class="comment">// Side 0</span>
<a name="l00047"></a>00047   {1, 2}, <span class="comment">// Side 1</span>
<a name="l00048"></a>00048   {2, 3}, <span class="comment">// Side 2</span>
<a name="l00049"></a>00049   {0, 3}, <span class="comment">// Side 3</span>
<a name="l00050"></a>00050   {0, 4}, <span class="comment">// Side 4</span>
<a name="l00051"></a>00051   {1, 4}, <span class="comment">// Side 5</span>
<a name="l00052"></a>00052   {2, 4}, <span class="comment">// Side 6</span>
<a name="l00053"></a>00053   {3, 4}  <span class="comment">// Side 7</span>
<a name="l00054"></a>00054 };
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00059"></a>00059 <span class="comment">// Pyramid5 class member functions</span>
<a name="l00060"></a>00060 
<a name="l00061"></a><a class="code" href="classPyramid5.php#afbf7efb253117ef43a97964b475d5792">00061</a> <span class="keywordtype">bool</span> <a class="code" href="classPyramid5.php#afbf7efb253117ef43a97964b475d5792">Pyramid5::is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00062"></a>00062 <span class="keyword"></span>{
<a name="l00063"></a>00063   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00064"></a>00064 }
<a name="l00065"></a>00065 
<a name="l00066"></a><a class="code" href="classPyramid5.php#adc33dbfce646ac935180b450ade82d25">00066</a> <span class="keywordtype">bool</span> <a class="code" href="classPyramid5.php#adc33dbfce646ac935180b450ade82d25">Pyramid5::is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00067"></a>00067 <span class="keyword"></span>{
<a name="l00068"></a>00068   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00069"></a>00069 }
<a name="l00070"></a>00070 
<a name="l00071"></a><a class="code" href="classPyramid5.php#ae2b4d72afffa8fe642e0e5550630fb3b">00071</a> <span class="keywordtype">bool</span> <a class="code" href="classPyramid5.php#ae2b4d72afffa8fe642e0e5550630fb3b">Pyramid5::is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00072"></a>00072 <span class="keyword"></span>{
<a name="l00073"></a>00073   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00074"></a>00074 }
<a name="l00075"></a>00075 
<a name="l00076"></a><a class="code" href="classPyramid5.php#adedf7620b34ae45a7c81f77dff74022a">00076</a> <span class="keywordtype">bool</span> <a class="code" href="classPyramid5.php#adedf7620b34ae45a7c81f77dff74022a">Pyramid5::is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00077"></a>00077                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00078"></a>00078 <span class="keyword"></span>{
<a name="l00079"></a>00079   libmesh_assert(s &lt; <a class="code" href="classPyramid.php#af1794dd76bff2944cadbe1eb04dc6676">n_sides</a>());
<a name="l00080"></a>00080   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 4; ++i)
<a name="l00081"></a>00081     <span class="keywordflow">if</span> (<a class="code" href="classPyramid5.php#af1874f7158485cfaa1e2a295070896b8">side_nodes_map</a>[s][i] == n)
<a name="l00082"></a>00082       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00083"></a>00083   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00084"></a>00084 }
<a name="l00085"></a>00085 
<a name="l00086"></a><a class="code" href="classPyramid5.php#a13c79a8ec7946671437cd282ad1ffedd">00086</a> <span class="keywordtype">bool</span> <a class="code" href="classPyramid5.php#a13c79a8ec7946671437cd282ad1ffedd">Pyramid5::is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00087"></a>00087                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00088"></a>00088 <span class="keyword"></span>{
<a name="l00089"></a>00089   libmesh_assert(e &lt; <a class="code" href="classPyramid.php#a86a1a574209be2d727881a6df9ebe0b6">n_edges</a>());
<a name="l00090"></a>00090   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 2; ++i)
<a name="l00091"></a>00091     <span class="keywordflow">if</span> (<a class="code" href="classPyramid5.php#aa4c3e10102ad6d57212efb50f3e16eb3">edge_nodes_map</a>[e][i] == n)
<a name="l00092"></a>00092       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00093"></a>00093   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00094"></a>00094 }
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a><a class="code" href="classPyramid5.php#ae7c583713c05f4b0abadb856689d8178">00098</a> <span class="keywordtype">bool</span> <a class="code" href="classPyramid5.php#ae7c583713c05f4b0abadb856689d8178">Pyramid5::has_affine_map</a>()<span class="keyword"> const</span>
<a name="l00099"></a>00099 <span class="keyword"></span>{
<a name="l00100"></a>00100 <span class="comment">//  Point v = this-&gt;point(3) - this-&gt;point(0);</span>
<a name="l00101"></a>00101 <span class="comment">//  return (v.relative_fuzzy_equals(this-&gt;point(2) - this-&gt;point(1)));</span>
<a name="l00102"></a>00102   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00103"></a>00103 }
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a><a class="code" href="classPyramid5.php#a8b57680aa1ea36a315aeeb20d859304c">00107</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classPyramid5.php#a8b57680aa1ea36a315aeeb20d859304c">Pyramid5::build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00108"></a>00108                                     <span class="keywordtype">bool</span> proxy)<span class="keyword"> const</span>
<a name="l00109"></a>00109 <span class="keyword"></span>{
<a name="l00110"></a>00110   libmesh_assert (i &lt; this-&gt;<a class="code" href="classPyramid.php#af1794dd76bff2944cadbe1eb04dc6676">n_sides</a>());
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   <span class="keywordflow">if</span> (proxy)
<a name="l00113"></a>00113     {
<a name="l00114"></a>00114       <span class="keywordflow">switch</span> (i)
<a name="l00115"></a>00115         {
<a name="l00116"></a>00116         <span class="keywordflow">case</span> 0:  
<a name="l00117"></a>00117         <span class="keywordflow">case</span> 1:
<a name="l00118"></a>00118         <span class="keywordflow">case</span> 2:
<a name="l00119"></a>00119         <span class="keywordflow">case</span> 3:
<a name="l00120"></a>00120           {
<a name="l00121"></a>00121             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classSide.php">Side&lt;Tri3,Pyramid5&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00122"></a>00122             <span class="keywordflow">return</span> face;
<a name="l00123"></a>00123           }
<a name="l00124"></a>00124 
<a name="l00125"></a>00125         <span class="keywordflow">case</span> 4:
<a name="l00126"></a>00126           {
<a name="l00127"></a>00127             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classSide.php">Side&lt;Quad4,Pyramid5&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00128"></a>00128             <span class="keywordflow">return</span> face;
<a name="l00129"></a>00129           }
<a name="l00130"></a>00130 
<a name="l00131"></a>00131         <span class="keywordflow">default</span>:
<a name="l00132"></a>00132           {
<a name="l00133"></a>00133             libmesh_error();
<a name="l00134"></a>00134           }
<a name="l00135"></a>00135         }
<a name="l00136"></a>00136     }
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <span class="keywordflow">else</span>
<a name="l00139"></a>00139     {
<a name="l00140"></a>00140       <span class="keywordflow">switch</span> (i)
<a name="l00141"></a>00141         {
<a name="l00142"></a>00142         <span class="keywordflow">case</span> 0:  <span class="comment">// triangular face 1</span>
<a name="l00143"></a>00143           {
<a name="l00144"></a>00144             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classTri3.php">Tri3</a>);
<a name="l00145"></a>00145 
<a name="l00146"></a>00146             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00147"></a>00147             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00148"></a>00148             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(4);
<a name="l00149"></a>00149 
<a name="l00150"></a>00150             <span class="keywordflow">return</span> face;
<a name="l00151"></a>00151           }
<a name="l00152"></a>00152         <span class="keywordflow">case</span> 1:  <span class="comment">// triangular face 2</span>
<a name="l00153"></a>00153           {
<a name="l00154"></a>00154             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classTri3.php">Tri3</a>);
<a name="l00155"></a>00155 
<a name="l00156"></a>00156             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00157"></a>00157             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00158"></a>00158             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(4);
<a name="l00159"></a>00159 
<a name="l00160"></a>00160             <span class="keywordflow">return</span> face;
<a name="l00161"></a>00161           }
<a name="l00162"></a>00162         <span class="keywordflow">case</span> 2:  <span class="comment">// triangular face 3</span>
<a name="l00163"></a>00163           {
<a name="l00164"></a>00164             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classTri3.php">Tri3</a>);
<a name="l00165"></a>00165 
<a name="l00166"></a>00166             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00167"></a>00167             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00168"></a>00168             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(4);
<a name="l00169"></a>00169 
<a name="l00170"></a>00170             <span class="keywordflow">return</span> face;
<a name="l00171"></a>00171           }
<a name="l00172"></a>00172         <span class="keywordflow">case</span> 3:  <span class="comment">// triangular face 4</span>
<a name="l00173"></a>00173           {
<a name="l00174"></a>00174             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classTri3.php">Tri3</a>);
<a name="l00175"></a>00175 
<a name="l00176"></a>00176             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00177"></a>00177             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00178"></a>00178             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(4);
<a name="l00179"></a>00179 
<a name="l00180"></a>00180             <span class="keywordflow">return</span> face;
<a name="l00181"></a>00181           }
<a name="l00182"></a>00182         <span class="keywordflow">case</span> 4:  <span class="comment">// the quad face at z=0</span>
<a name="l00183"></a>00183           {
<a name="l00184"></a>00184             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classQuad4.php">Quad4</a>);
<a name="l00185"></a>00185 
<a name="l00186"></a>00186             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00187"></a>00187             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00188"></a>00188             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00189"></a>00189             face-&gt;set_node(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00190"></a>00190 
<a name="l00191"></a>00191             <span class="keywordflow">return</span> face;
<a name="l00192"></a>00192           }
<a name="l00193"></a>00193         <span class="keywordflow">default</span>:
<a name="l00194"></a>00194           {
<a name="l00195"></a>00195             libmesh_error();
<a name="l00196"></a>00196           }
<a name="l00197"></a>00197         }
<a name="l00198"></a>00198     }
<a name="l00199"></a>00199 
<a name="l00200"></a>00200   
<a name="l00201"></a>00201   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00202"></a>00202   libmesh_error();
<a name="l00203"></a>00203   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00204"></a>00204 }
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 
<a name="l00208"></a><a class="code" href="classPyramid5.php#a50564b08b33a9df5378ff52a2e631602">00208</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classPyramid5.php#a50564b08b33a9df5378ff52a2e631602">Pyramid5::build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00209"></a>00209 <span class="keyword"></span>{
<a name="l00210"></a>00210   libmesh_assert (i &lt; this-&gt;<a class="code" href="classPyramid.php#a86a1a574209be2d727881a6df9ebe0b6">n_edges</a>());
<a name="l00211"></a>00211 
<a name="l00212"></a>00212   <span class="keywordflow">return</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a>(<span class="keyword">new</span> <a class="code" href="classSideEdge.php">SideEdge&lt;Edge2,Pyramid5&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00213"></a>00213 }
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 
<a name="l00216"></a>00216 
<a name="l00217"></a><a class="code" href="classPyramid5.php#a8cee7d19d0a0a850d15017a2ddd48e82">00217</a> <span class="keywordtype">void</span> <a class="code" href="classPyramid5.php#a8cee7d19d0a0a850d15017a2ddd48e82">Pyramid5::connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00218"></a>00218                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00219"></a>00219                             std::vector&lt;unsigned int&gt;&amp; conn)<span class="keyword"> const</span>
<a name="l00220"></a>00220 <span class="keyword"></span>{
<a name="l00221"></a>00221   libmesh_assert (<a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a> != NULL);
<a name="l00222"></a>00222   libmesh_assert (sc &lt; this-&gt;<a class="code" href="classPyramid5.php#ad4dd3704ce5c356a1ffe9baccfb6b35b">n_sub_elem</a>());
<a name="l00223"></a>00223   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00224"></a>00224 
<a name="l00225"></a>00225     <span class="keywordflow">switch</span> (iop)
<a name="l00226"></a>00226     {
<a name="l00227"></a>00227     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00228"></a>00228       {
<a name="l00229"></a>00229         conn.resize(8);
<a name="l00230"></a>00230         conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0)+1;
<a name="l00231"></a>00231         conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1)+1;
<a name="l00232"></a>00232         conn[2] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2)+1;
<a name="l00233"></a>00233         conn[3] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3)+1;
<a name="l00234"></a>00234         conn[4] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(4)+1;
<a name="l00235"></a>00235         conn[5] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(4)+1;
<a name="l00236"></a>00236         conn[6] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(4)+1;
<a name="l00237"></a>00237         conn[7] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(4)+1;
<a name="l00238"></a>00238         <span class="keywordflow">return</span>;
<a name="l00239"></a>00239       }
<a name="l00240"></a>00240 
<a name="l00241"></a>00241     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa1affb8987f83b5e4acb22d9401dd44ef">VTK</a>:
<a name="l00242"></a>00242       {
<a name="l00243"></a>00243         conn.resize(5);
<a name="l00244"></a>00244         conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3);
<a name="l00245"></a>00245         conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2);
<a name="l00246"></a>00246         conn[2] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1);
<a name="l00247"></a>00247         conn[3] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0);
<a name="l00248"></a>00248         conn[4] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(4);
<a name="l00249"></a>00249         <span class="keywordflow">return</span>;
<a name="l00250"></a>00250       }
<a name="l00251"></a>00251       
<a name="l00252"></a>00252     <span class="keywordflow">default</span>:
<a name="l00253"></a>00253       libmesh_error();
<a name="l00254"></a>00254     }
<a name="l00255"></a>00255 
<a name="l00256"></a>00256     libmesh_error();
<a name="l00257"></a>00257 }
<a name="l00258"></a>00258 
<a name="l00259"></a>00259 
<a name="l00260"></a><a class="code" href="classPyramid5.php#aa5d4723fe93d0bfa50884dae31281eb2">00260</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classPyramid5.php#aa5d4723fe93d0bfa50884dae31281eb2">Pyramid5::volume</a> ()<span class="keyword"> const</span>
<a name="l00261"></a>00261 <span class="keyword"></span>{
<a name="l00262"></a>00262   <span class="comment">// The pyramid with a bilinear base has volume given by the</span>
<a name="l00263"></a>00263   <span class="comment">// formula in: &quot;Calculation of the Volume of a General Hexahedron</span>
<a name="l00264"></a>00264   <span class="comment">// for Flow Predictions&quot;, AIAA Journal v.23, no.6, 1984, p.954-</span>
<a name="l00265"></a>00265   <a class="code" href="classNode.php">Node</a>* node0 = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00266"></a>00266   <a class="code" href="classNode.php">Node</a>* node1 = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1); 
<a name="l00267"></a>00267   <a class="code" href="classNode.php">Node</a>* node2 = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00268"></a>00268   <a class="code" href="classNode.php">Node</a>* node3 = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00269"></a>00269   <a class="code" href="classNode.php">Node</a>* node4 = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(4);
<a name="l00270"></a>00270 
<a name="l00271"></a>00271   <span class="comment">// Construct Various edge and diagonal vectors</span>
<a name="l00272"></a>00272   <a class="code" href="classPoint.php">Point</a> v40 ( *node0 - *node4 );
<a name="l00273"></a>00273   <a class="code" href="classPoint.php">Point</a> v13 ( *node3 - *node1 );
<a name="l00274"></a>00274   <a class="code" href="classPoint.php">Point</a> v02 ( *node2 - *node0 );
<a name="l00275"></a>00275   <a class="code" href="classPoint.php">Point</a> v03 ( *node3 - *node0 );
<a name="l00276"></a>00276   <a class="code" href="classPoint.php">Point</a> v01 ( *node1 - *node0 );
<a name="l00277"></a>00277   
<a name="l00278"></a>00278   <span class="comment">// Finally, ready to return the volume!</span>
<a name="l00279"></a>00279   <span class="keywordflow">return</span> (1./6.)*(v40*(v13.<a class="code" href="classTypeVector.php#a1347e1223f3e31f8a2c0496736e60dc5">cross</a>(v02))) + (1./12.)*(v02*(v01.<a class="code" href="classTypeVector.php#a1347e1223f3e31f8a2c0496736e60dc5">cross</a>(v03)));
<a name="l00280"></a>00280 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
