<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>cell_pyramid.h</h1>  </div>
</div>
<div class="contents">
<a href="cell__pyramid_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_pyramid.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __cell_pyramid_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __cell_pyramid_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="cell_8h.php">cell.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00037"></a>00037 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00038"></a>00038 <span class="comment">// Pyramid class definition</span>
<a name="l00039"></a><a class="code" href="classPyramid.php">00039</a> <span class="keyword">class </span><a class="code" href="classPyramid.php">Pyramid</a> : <span class="keyword">public</span> <a class="code" href="classCell.php">Cell</a>
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041 <span class="keyword">public</span>:
<a name="l00042"></a>00042 
<a name="l00048"></a>00048   <a class="code" href="classPyramid.php#a792191ef4695f437bb1c5e35c5eee823">Pyramid</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn, <a class="code" href="classElem.php">Elem</a>* p);
<a name="l00049"></a>00049   
<a name="l00054"></a><a class="code" href="classPyramid.php#adb2768baaa819e9a311cb392caa4fdf2">00054</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPyramid.php#adb2768baaa819e9a311cb392caa4fdf2">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 5; }
<a name="l00055"></a>00055 
<a name="l00059"></a><a class="code" href="classPyramid.php#af1794dd76bff2944cadbe1eb04dc6676">00059</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPyramid.php#af1794dd76bff2944cadbe1eb04dc6676">n_sides</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 5; }
<a name="l00060"></a>00060 
<a name="l00064"></a><a class="code" href="classPyramid.php#afdabc9387ba2ada771d1a0c6efe26d90">00064</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPyramid.php#afdabc9387ba2ada771d1a0c6efe26d90">n_vertices</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 5; }
<a name="l00065"></a>00065 
<a name="l00069"></a><a class="code" href="classPyramid.php#a86a1a574209be2d727881a6df9ebe0b6">00069</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPyramid.php#a86a1a574209be2d727881a6df9ebe0b6">n_edges</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 8; }
<a name="l00070"></a>00070 
<a name="l00074"></a><a class="code" href="classPyramid.php#a53fa7cff31661057c565d9b3a7b67637">00074</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPyramid.php#a53fa7cff31661057c565d9b3a7b67637">n_faces</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 5; }
<a name="l00075"></a>00075   
<a name="l00079"></a><a class="code" href="classPyramid.php#aad75c2d7324bccaa9a760a7693c86bc4">00079</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPyramid.php#aad75c2d7324bccaa9a760a7693c86bc4">n_children</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 10; }
<a name="l00080"></a>00080   
<a name="l00081"></a>00081   <span class="comment">/*</span>
<a name="l00082"></a>00082 <span class="comment">   * @returns true iff the specified child is on the</span>
<a name="l00083"></a>00083 <span class="comment">   * specified side</span>
<a name="l00084"></a>00084 <span class="comment">   */</span>
<a name="l00085"></a>00085   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classPyramid.php#a53ea1345da812c3620c113fd14ca6379">is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00086"></a>00086                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00087"></a>00087   
<a name="l00093"></a>00093   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPyramid.php#a1274d3f777891ceffddd8b80bed03c45">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00094"></a>00094 
<a name="l00099"></a>00099   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> <a class="code" href="classPyramid.php#a3f092005fecbb17d5f3cec1accb75f87">side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00100"></a>00100   
<a name="l00101"></a>00101   
<a name="l00102"></a>00102  <span class="keyword">protected</span>:
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00106"></a>00106 <span class="preprocessor"></span>  
<a name="l00110"></a><a class="code" href="classPyramid.php#a2be33f690bb779c72d40dba43845965d">00110</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPyramid.php#a2be33f690bb779c72d40dba43845965d">side_children_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, 
<a name="l00111"></a>00111                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00112"></a>00112 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> 0; }
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 <span class="preprocessor">#endif</span>
<a name="l00115"></a>00115 <span class="preprocessor"></span>  
<a name="l00116"></a>00116 };
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00121"></a>00121 <span class="comment">// Pyramid class member functions</span>
<a name="l00122"></a>00122 <span class="keyword">inline</span>
<a name="l00123"></a><a class="code" href="classPyramid.php#a792191ef4695f437bb1c5e35c5eee823">00123</a> <a class="code" href="classPyramid.php#a792191ef4695f437bb1c5e35c5eee823">Pyramid::Pyramid</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn, <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00124"></a>00124   <a class="code" href="classCell.php">Cell</a>(nn, <a class="code" href="classPyramid.php">Pyramid</a>::n_sides(), p) 
<a name="l00125"></a>00125 {
<a name="l00126"></a>00126 }
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
