<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1665b3ccb6c776ec6797fe204e2359e5.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>cell_tet10.C</h1>  </div>
</div>
<div class="contents">
<a href="cell__tet10_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_tet10.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;side.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;cell_tet10.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;edge_edge3.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;face_tri6.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00032"></a>00032 <span class="comment">// Tet10 class static member initializations</span>
<a name="l00033"></a>00033 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTet10.php#af8252a68a6be84a2692ca245fd7d16ea">Tet10::side_nodes_map</a>[4][6] =
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035   {0, 2, 1, 6, 5, 4}, <span class="comment">// Side 0</span>
<a name="l00036"></a>00036   {0, 1, 3, 4, 8, 7}, <span class="comment">// Side 1</span>
<a name="l00037"></a>00037   {1, 2, 3, 5, 9, 8}, <span class="comment">// Side 2</span>
<a name="l00038"></a>00038   {2, 0, 3, 6, 7, 9}  <span class="comment">// Side 3</span>
<a name="l00039"></a>00039 };
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTet10.php#ac0fab230035f425482d89b1e5f7bd3e6">Tet10::edge_nodes_map</a>[6][3] =
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043   {0, 1, 4}, <span class="comment">// Side 0</span>
<a name="l00044"></a>00044   {1, 2, 5}, <span class="comment">// Side 1</span>
<a name="l00045"></a>00045   {0, 2, 6}, <span class="comment">// Side 2</span>
<a name="l00046"></a>00046   {0, 3, 7}, <span class="comment">// Side 3</span>
<a name="l00047"></a>00047   {1, 3, 8}, <span class="comment">// Side 4</span>
<a name="l00048"></a>00048   {2, 3, 9}  <span class="comment">// Side 5</span>
<a name="l00049"></a>00049 };
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00054"></a>00054 <span class="comment">// Tet10 class member functions</span>
<a name="l00055"></a>00055 
<a name="l00056"></a><a class="code" href="classTet10.php#ab4f149940b43fe61492bac38b9b9d820">00056</a> <span class="keywordtype">bool</span> <a class="code" href="classTet10.php#ab4f149940b43fe61492bac38b9b9d820">Tet10::is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00057"></a>00057 <span class="keyword"></span>{
<a name="l00058"></a>00058   <span class="keywordflow">if</span> (i &lt; 4)
<a name="l00059"></a>00059     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00060"></a>00060   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00061"></a>00061 }
<a name="l00062"></a>00062 
<a name="l00063"></a><a class="code" href="classTet10.php#ac72691c118fe565884786aa5aeac4f3e">00063</a> <span class="keywordtype">bool</span> <a class="code" href="classTet10.php#ac72691c118fe565884786aa5aeac4f3e">Tet10::is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00064"></a>00064 <span class="keyword"></span>{
<a name="l00065"></a>00065   <span class="keywordflow">if</span> (i &lt; 4)
<a name="l00066"></a>00066     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00067"></a>00067   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00068"></a>00068 }
<a name="l00069"></a>00069 
<a name="l00070"></a><a class="code" href="classTet10.php#ab72aae0911dd2fc6713537af8cfca19a">00070</a> <span class="keywordtype">bool</span> <a class="code" href="classTet10.php#ab72aae0911dd2fc6713537af8cfca19a">Tet10::is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00071"></a>00071 <span class="keyword"></span>{
<a name="l00072"></a>00072   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00073"></a>00073 }
<a name="l00074"></a>00074 
<a name="l00075"></a><a class="code" href="classTet10.php#ae336257b714f4ef76d63c98472edb952">00075</a> <span class="keywordtype">bool</span> <a class="code" href="classTet10.php#ae336257b714f4ef76d63c98472edb952">Tet10::is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00076"></a>00076                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00077"></a>00077 <span class="keyword"></span>{
<a name="l00078"></a>00078   libmesh_assert(s &lt; <a class="code" href="classTet.php#a0285d48cf5afd40aebafc91694256e2a">n_sides</a>());
<a name="l00079"></a>00079   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 6; ++i)
<a name="l00080"></a>00080     <span class="keywordflow">if</span> (<a class="code" href="classTet10.php#af8252a68a6be84a2692ca245fd7d16ea">side_nodes_map</a>[s][i] == n)
<a name="l00081"></a>00081       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00082"></a>00082   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00083"></a>00083 }
<a name="l00084"></a>00084 
<a name="l00085"></a><a class="code" href="classTet10.php#a3f4baf2eff13afe85fb5c04f328952c4">00085</a> <span class="keywordtype">bool</span> <a class="code" href="classTet10.php#a3f4baf2eff13afe85fb5c04f328952c4">Tet10::is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00086"></a>00086                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00087"></a>00087 <span class="keyword"></span>{
<a name="l00088"></a>00088   libmesh_assert(e &lt; <a class="code" href="classTet.php#a145f530a16d029da337e7d3629d6b2c5">n_edges</a>());
<a name="l00089"></a>00089   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 3; ++i)
<a name="l00090"></a>00090     <span class="keywordflow">if</span> (<a class="code" href="classTet10.php#ac0fab230035f425482d89b1e5f7bd3e6">edge_nodes_map</a>[e][i] == n)
<a name="l00091"></a>00091       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00092"></a>00092   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00093"></a>00093 }
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a><a class="code" href="classTet10.php#ae2f7e3ca14392087b89dd5be04a18d0e">00097</a> <span class="keywordtype">bool</span> <a class="code" href="classTet10.php#ae2f7e3ca14392087b89dd5be04a18d0e">Tet10::has_affine_map</a>()<span class="keyword"> const</span>
<a name="l00098"></a>00098 <span class="keyword"></span>{
<a name="l00099"></a>00099   <span class="comment">// Make sure edges are straight</span>
<a name="l00100"></a>00100   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(4).relative_fuzzy_equals
<a name="l00101"></a>00101       (this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0) + this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1)/2))
<a name="l00102"></a>00102     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00103"></a>00103   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(5).relative_fuzzy_equals
<a name="l00104"></a>00104       (this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1) + this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2)/2))
<a name="l00105"></a>00105     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00106"></a>00106   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(6).relative_fuzzy_equals
<a name="l00107"></a>00107       (this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2) + this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0)/2))
<a name="l00108"></a>00108     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00109"></a>00109   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(7).relative_fuzzy_equals
<a name="l00110"></a>00110       (this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3) + this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0)/2))
<a name="l00111"></a>00111     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00112"></a>00112   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(8).relative_fuzzy_equals
<a name="l00113"></a>00113       (this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3) + this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1)/2))
<a name="l00114"></a>00114     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00115"></a>00115   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(9).relative_fuzzy_equals
<a name="l00116"></a>00116       (this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3) + this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2)/2))
<a name="l00117"></a>00117     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00118"></a>00118   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00119"></a>00119 }
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a><a class="code" href="classTet10.php#a051491defc0a303576d87a06d3c757e3">00123</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classTet10.php#a051491defc0a303576d87a06d3c757e3">Tet10::build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00124"></a>00124                                  <span class="keywordtype">bool</span> proxy)<span class="keyword"> const</span>
<a name="l00125"></a>00125 <span class="keyword"></span>{
<a name="l00126"></a>00126   libmesh_assert (i &lt; this-&gt;<a class="code" href="classTet.php#a0285d48cf5afd40aebafc91694256e2a">n_sides</a>());
<a name="l00127"></a>00127 
<a name="l00128"></a>00128   <span class="keywordflow">if</span> (proxy)
<a name="l00129"></a>00129     {
<a name="l00130"></a>00130       <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classSide.php">Side&lt;Tri6,Tet10&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00131"></a>00131       <span class="keywordflow">return</span> ap;
<a name="l00132"></a>00132     }
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   <span class="keywordflow">else</span>
<a name="l00135"></a>00135     {
<a name="l00136"></a>00136       <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classTri6.php">Tri6</a>);
<a name="l00137"></a>00137   
<a name="l00138"></a>00138       <span class="keywordflow">switch</span> (i)
<a name="l00139"></a>00139         {
<a name="l00140"></a>00140         <span class="keywordflow">case</span> 0:
<a name="l00141"></a>00141           {
<a name="l00142"></a>00142             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00143"></a>00143             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00144"></a>00144             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00145"></a>00145             face-&gt;set_node(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(6);
<a name="l00146"></a>00146             face-&gt;set_node(4) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(5);
<a name="l00147"></a>00147             face-&gt;set_node(5) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(4);
<a name="l00148"></a>00148 
<a name="l00149"></a>00149             <span class="keywordflow">return</span> face;
<a name="l00150"></a>00150           }
<a name="l00151"></a>00151         <span class="keywordflow">case</span> 1:
<a name="l00152"></a>00152           {
<a name="l00153"></a>00153             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00154"></a>00154             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00155"></a>00155             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00156"></a>00156             face-&gt;set_node(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(4);
<a name="l00157"></a>00157             face-&gt;set_node(4) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(8);
<a name="l00158"></a>00158             face-&gt;set_node(5) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(7);
<a name="l00159"></a>00159 
<a name="l00160"></a>00160             <span class="keywordflow">return</span> face;
<a name="l00161"></a>00161           }
<a name="l00162"></a>00162         <span class="keywordflow">case</span> 2:
<a name="l00163"></a>00163           {
<a name="l00164"></a>00164             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00165"></a>00165             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00166"></a>00166             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00167"></a>00167             face-&gt;set_node(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(5);
<a name="l00168"></a>00168             face-&gt;set_node(4) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(9);
<a name="l00169"></a>00169             face-&gt;set_node(5) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(8);
<a name="l00170"></a>00170 
<a name="l00171"></a>00171             <span class="keywordflow">return</span> face;
<a name="l00172"></a>00172           }
<a name="l00173"></a>00173         <span class="keywordflow">case</span> 3:
<a name="l00174"></a>00174           {
<a name="l00175"></a>00175             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00176"></a>00176             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00177"></a>00177             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00178"></a>00178             face-&gt;set_node(3) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(6);
<a name="l00179"></a>00179             face-&gt;set_node(4) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(7);
<a name="l00180"></a>00180             face-&gt;set_node(5) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(9);
<a name="l00181"></a>00181 
<a name="l00182"></a>00182             <span class="keywordflow">return</span> face;
<a name="l00183"></a>00183           }
<a name="l00184"></a>00184         <span class="keywordflow">default</span>:
<a name="l00185"></a>00185           {
<a name="l00186"></a>00186             libmesh_error();
<a name="l00187"></a>00187           }
<a name="l00188"></a>00188         }
<a name="l00189"></a>00189     }
<a name="l00190"></a>00190 
<a name="l00191"></a>00191   
<a name="l00192"></a>00192   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00193"></a>00193   libmesh_error();
<a name="l00194"></a>00194   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00195"></a>00195 }
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 
<a name="l00199"></a><a class="code" href="classTet10.php#a9c566544bc737bfce13b49261dea18c9">00199</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classTet10.php#a9c566544bc737bfce13b49261dea18c9">Tet10::build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00200"></a>00200 <span class="keyword"></span>{
<a name="l00201"></a>00201   libmesh_assert (i &lt; this-&gt;<a class="code" href="classTet.php#a145f530a16d029da337e7d3629d6b2c5">n_edges</a>());
<a name="l00202"></a>00202 
<a name="l00203"></a>00203   <span class="keywordflow">return</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a>(<span class="keyword">new</span> <a class="code" href="classSideEdge.php">SideEdge&lt;Edge3,Tet10&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00204"></a>00204 }
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 
<a name="l00208"></a><a class="code" href="classTet10.php#a18aa5a151b20b01ff4eb316983fbb853">00208</a> <span class="keywordtype">void</span> <a class="code" href="classTet10.php#a18aa5a151b20b01ff4eb316983fbb853">Tet10::connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00209"></a>00209                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00210"></a>00210                          std::vector&lt;unsigned int&gt;&amp; conn)<span class="keyword"> const</span>
<a name="l00211"></a>00211 <span class="keyword"></span>{
<a name="l00212"></a>00212   libmesh_assert (<a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a> != NULL);
<a name="l00213"></a>00213   libmesh_assert (sc &lt; this-&gt;<a class="code" href="classTet10.php#a5ca689b5d61f16cb3af07282022271c2">n_sub_elem</a>());
<a name="l00214"></a>00214   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00215"></a>00215 
<a name="l00216"></a>00216   <span class="keywordflow">switch</span> (iop)
<a name="l00217"></a>00217     {
<a name="l00218"></a>00218     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00219"></a>00219       {
<a name="l00220"></a>00220         conn.resize(8);
<a name="l00221"></a>00221         <span class="keywordflow">switch</span> (sc)
<a name="l00222"></a>00222           {
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00225"></a>00225             <span class="comment">// Linear sub-tet 0</span>
<a name="l00226"></a>00226           <span class="keywordflow">case</span> 0:
<a name="l00227"></a>00227 
<a name="l00228"></a>00228             conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0)+1;
<a name="l00229"></a>00229             conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(4)+1;
<a name="l00230"></a>00230             conn[2] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(6)+1;
<a name="l00231"></a>00231             conn[3] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(6)+1;
<a name="l00232"></a>00232             conn[4] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(7)+1;
<a name="l00233"></a>00233             conn[5] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(7)+1;
<a name="l00234"></a>00234             conn[6] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(7)+1;
<a name="l00235"></a>00235             conn[7] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(7)+1;
<a name="l00236"></a>00236  
<a name="l00237"></a>00237             <span class="keywordflow">return</span>;
<a name="l00238"></a>00238   
<a name="l00239"></a>00239             <span class="comment">// Linear sub-tet 1</span>
<a name="l00240"></a>00240           <span class="keywordflow">case</span> 1:
<a name="l00241"></a>00241 
<a name="l00242"></a>00242             conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(4)+1;
<a name="l00243"></a>00243             conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1)+1;
<a name="l00244"></a>00244             conn[2] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(5)+1;
<a name="l00245"></a>00245             conn[3] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(5)+1;
<a name="l00246"></a>00246             conn[4] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(8)+1;
<a name="l00247"></a>00247             conn[5] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(8)+1;
<a name="l00248"></a>00248             conn[6] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(8)+1;
<a name="l00249"></a>00249             conn[7] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(8)+1;
<a name="l00250"></a>00250 
<a name="l00251"></a>00251             <span class="keywordflow">return</span>;
<a name="l00252"></a>00252 
<a name="l00253"></a>00253             <span class="comment">// Linear sub-tet 2</span>
<a name="l00254"></a>00254           <span class="keywordflow">case</span> 2:
<a name="l00255"></a>00255 
<a name="l00256"></a>00256             conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(5)+1;
<a name="l00257"></a>00257             conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2)+1;
<a name="l00258"></a>00258             conn[2] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(6)+1;
<a name="l00259"></a>00259             conn[3] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(6)+1;
<a name="l00260"></a>00260             conn[4] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(9)+1;
<a name="l00261"></a>00261             conn[5] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(9)+1;
<a name="l00262"></a>00262             conn[6] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(9)+1;
<a name="l00263"></a>00263             conn[7] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(9)+1;
<a name="l00264"></a>00264 
<a name="l00265"></a>00265             <span class="keywordflow">return</span>;
<a name="l00266"></a>00266 
<a name="l00267"></a>00267             <span class="comment">// Linear sub-tet 3</span>
<a name="l00268"></a>00268           <span class="keywordflow">case</span> 3:
<a name="l00269"></a>00269 
<a name="l00270"></a>00270             conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(7)+1;
<a name="l00271"></a>00271             conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(8)+1;
<a name="l00272"></a>00272             conn[2] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(9)+1;
<a name="l00273"></a>00273             conn[3] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(9)+1;
<a name="l00274"></a>00274             conn[4] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3)+1;
<a name="l00275"></a>00275             conn[5] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3)+1;
<a name="l00276"></a>00276             conn[6] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3)+1;
<a name="l00277"></a>00277             conn[7] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3)+1;
<a name="l00278"></a>00278 
<a name="l00279"></a>00279             <span class="keywordflow">return</span>;
<a name="l00280"></a>00280 
<a name="l00281"></a>00281             <span class="comment">// Linear sub-tet 4</span>
<a name="l00282"></a>00282           <span class="keywordflow">case</span> 4:
<a name="l00283"></a>00283 
<a name="l00284"></a>00284             conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(4)+1;
<a name="l00285"></a>00285             conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(8)+1;
<a name="l00286"></a>00286             conn[2] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(6)+1;
<a name="l00287"></a>00287             conn[3] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(6)+1;
<a name="l00288"></a>00288             conn[4] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(7)+1;
<a name="l00289"></a>00289             conn[5] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(7)+1;
<a name="l00290"></a>00290             conn[6] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(7)+1;
<a name="l00291"></a>00291             conn[7] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(7)+1;
<a name="l00292"></a>00292 
<a name="l00293"></a>00293             <span class="keywordflow">return</span>;
<a name="l00294"></a>00294 
<a name="l00295"></a>00295             <span class="comment">// Linear sub-tet 5</span>
<a name="l00296"></a>00296           <span class="keywordflow">case</span> 5:
<a name="l00297"></a>00297 
<a name="l00298"></a>00298             conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(4)+1;
<a name="l00299"></a>00299             conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(5)+1;
<a name="l00300"></a>00300             conn[2] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(6)+1;
<a name="l00301"></a>00301             conn[3] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(6)+1;
<a name="l00302"></a>00302             conn[4] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(8)+1;
<a name="l00303"></a>00303             conn[5] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(8)+1;
<a name="l00304"></a>00304             conn[6] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(8)+1;
<a name="l00305"></a>00305             conn[7] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(8)+1;
<a name="l00306"></a>00306 
<a name="l00307"></a>00307             <span class="keywordflow">return</span>;
<a name="l00308"></a>00308 
<a name="l00309"></a>00309             <span class="comment">// Linear sub-tet 6</span>
<a name="l00310"></a>00310           <span class="keywordflow">case</span> 6:
<a name="l00311"></a>00311 
<a name="l00312"></a>00312             conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(5)+1;
<a name="l00313"></a>00313             conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(9)+1;
<a name="l00314"></a>00314             conn[2] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(6)+1;
<a name="l00315"></a>00315             conn[3] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(6)+1;
<a name="l00316"></a>00316             conn[4] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(8)+1;
<a name="l00317"></a>00317             conn[5] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(8)+1;
<a name="l00318"></a>00318             conn[6] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(8)+1;
<a name="l00319"></a>00319             conn[7] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(8)+1;
<a name="l00320"></a>00320 
<a name="l00321"></a>00321             <span class="keywordflow">return</span>;
<a name="l00322"></a>00322 
<a name="l00323"></a>00323             <span class="comment">// Linear sub-tet 7</span>
<a name="l00324"></a>00324           <span class="keywordflow">case</span> 7:
<a name="l00325"></a>00325 
<a name="l00326"></a>00326             conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(7)+1;
<a name="l00327"></a>00327             conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(6)+1;
<a name="l00328"></a>00328             conn[2] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(9)+1;
<a name="l00329"></a>00329             conn[3] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(9)+1;
<a name="l00330"></a>00330             conn[4] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(8)+1;
<a name="l00331"></a>00331             conn[5] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(8)+1;
<a name="l00332"></a>00332             conn[6] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(8)+1;
<a name="l00333"></a>00333             conn[7] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(8)+1;
<a name="l00334"></a>00334 
<a name="l00335"></a>00335             <span class="keywordflow">return</span>;
<a name="l00336"></a>00336 
<a name="l00337"></a>00337 
<a name="l00338"></a>00338           <span class="keywordflow">default</span>:
<a name="l00339"></a>00339 
<a name="l00340"></a>00340             libmesh_error();
<a name="l00341"></a>00341         }
<a name="l00342"></a>00342       }
<a name="l00343"></a>00343 
<a name="l00344"></a>00344     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa1affb8987f83b5e4acb22d9401dd44ef">VTK</a>:
<a name="l00345"></a>00345       {
<a name="l00346"></a>00346         conn.resize(10);
<a name="l00347"></a>00347         conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0);
<a name="l00348"></a>00348         conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1);
<a name="l00349"></a>00349         conn[2] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2);
<a name="l00350"></a>00350         conn[3] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3);
<a name="l00351"></a>00351         conn[4] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(4);
<a name="l00352"></a>00352         conn[5] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(5);
<a name="l00353"></a>00353         conn[6] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(6);
<a name="l00354"></a>00354         conn[7] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(7);
<a name="l00355"></a>00355         conn[8] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(8);
<a name="l00356"></a>00356         conn[9] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(9);
<a name="l00357"></a>00357         <span class="keywordflow">return</span>;
<a name="l00358"></a>00358         <span class="comment">/*</span>
<a name="l00359"></a>00359 <span class="comment">           conn.resize(4);</span>
<a name="l00360"></a>00360 <span class="comment">           switch (sc)</span>
<a name="l00361"></a>00361 <span class="comment">           {            </span>
<a name="l00362"></a>00362 <span class="comment">        // Linear sub-tet 0</span>
<a name="l00363"></a>00363 <span class="comment">        case 0:</span>
<a name="l00364"></a>00364 <span class="comment"></span>
<a name="l00365"></a>00365 <span class="comment">        conn[0] = this-&gt;node(0);</span>
<a name="l00366"></a>00366 <span class="comment">        conn[1] = this-&gt;node(4);</span>
<a name="l00367"></a>00367 <span class="comment">        conn[2] = this-&gt;node(6);</span>
<a name="l00368"></a>00368 <span class="comment">        conn[3] = this-&gt;node(7);</span>
<a name="l00369"></a>00369 <span class="comment"></span>
<a name="l00370"></a>00370 <span class="comment">        return;</span>
<a name="l00371"></a>00371 <span class="comment"></span>
<a name="l00372"></a>00372 <span class="comment">        // Linear sub-tet 1</span>
<a name="l00373"></a>00373 <span class="comment">        case 1:</span>
<a name="l00374"></a>00374 <span class="comment"></span>
<a name="l00375"></a>00375 <span class="comment">        conn[0] = this-&gt;node(4);</span>
<a name="l00376"></a>00376 <span class="comment">        conn[1] = this-&gt;node(1);</span>
<a name="l00377"></a>00377 <span class="comment">        conn[2] = this-&gt;node(5);</span>
<a name="l00378"></a>00378 <span class="comment">        conn[3] = this-&gt;node(8);</span>
<a name="l00379"></a>00379 <span class="comment"></span>
<a name="l00380"></a>00380 <span class="comment">        return;</span>
<a name="l00381"></a>00381 <span class="comment"></span>
<a name="l00382"></a>00382 <span class="comment">        // Linear sub-tet 2</span>
<a name="l00383"></a>00383 <span class="comment">        case 2:</span>
<a name="l00384"></a>00384 <span class="comment"></span>
<a name="l00385"></a>00385 <span class="comment">        conn[0] = this-&gt;node(5);</span>
<a name="l00386"></a>00386 <span class="comment">        conn[1] = this-&gt;node(2);</span>
<a name="l00387"></a>00387 <span class="comment">        conn[2] = this-&gt;node(6);</span>
<a name="l00388"></a>00388 <span class="comment">        conn[3] = this-&gt;node(9);</span>
<a name="l00389"></a>00389 <span class="comment"></span>
<a name="l00390"></a>00390 <span class="comment">        return;</span>
<a name="l00391"></a>00391 <span class="comment"></span>
<a name="l00392"></a>00392 <span class="comment">        // Linear sub-tet 3</span>
<a name="l00393"></a>00393 <span class="comment">        case 3:</span>
<a name="l00394"></a>00394 <span class="comment"></span>
<a name="l00395"></a>00395 <span class="comment">        conn[0] = this-&gt;node(7);</span>
<a name="l00396"></a>00396 <span class="comment">        conn[1] = this-&gt;node(8);</span>
<a name="l00397"></a>00397 <span class="comment">        conn[2] = this-&gt;node(9);</span>
<a name="l00398"></a>00398 <span class="comment">        conn[3] = this-&gt;node(3);</span>
<a name="l00399"></a>00399 <span class="comment"></span>
<a name="l00400"></a>00400 <span class="comment">        return;</span>
<a name="l00401"></a>00401 <span class="comment"></span>
<a name="l00402"></a>00402 <span class="comment">        // Linear sub-tet 4</span>
<a name="l00403"></a>00403 <span class="comment">        case 4:</span>
<a name="l00404"></a>00404 <span class="comment"></span>
<a name="l00405"></a>00405 <span class="comment">        conn[0] = this-&gt;node(4);</span>
<a name="l00406"></a>00406 <span class="comment">        conn[1] = this-&gt;node(8);</span>
<a name="l00407"></a>00407 <span class="comment">        conn[2] = this-&gt;node(6);</span>
<a name="l00408"></a>00408 <span class="comment">        conn[3] = this-&gt;node(7);</span>
<a name="l00409"></a>00409 <span class="comment"></span>
<a name="l00410"></a>00410 <span class="comment">        return;</span>
<a name="l00411"></a>00411 <span class="comment"></span>
<a name="l00412"></a>00412 <span class="comment">        // Linear sub-tet 5</span>
<a name="l00413"></a>00413 <span class="comment">        case 5:</span>
<a name="l00414"></a>00414 <span class="comment"></span>
<a name="l00415"></a>00415 <span class="comment">        conn[0] = this-&gt;node(4);</span>
<a name="l00416"></a>00416 <span class="comment">        conn[1] = this-&gt;node(5);</span>
<a name="l00417"></a>00417 <span class="comment">        conn[2] = this-&gt;node(6);</span>
<a name="l00418"></a>00418 <span class="comment">        conn[3] = this-&gt;node(8);</span>
<a name="l00419"></a>00419 <span class="comment"></span>
<a name="l00420"></a>00420 <span class="comment">        return;</span>
<a name="l00421"></a>00421 <span class="comment"></span>
<a name="l00422"></a>00422 <span class="comment">        // Linear sub-tet 6</span>
<a name="l00423"></a>00423 <span class="comment">        case 6:</span>
<a name="l00424"></a>00424 <span class="comment"></span>
<a name="l00425"></a>00425 <span class="comment">        conn[0] = this-&gt;node(5);</span>
<a name="l00426"></a>00426 <span class="comment">        conn[1] = this-&gt;node(9);</span>
<a name="l00427"></a>00427 <span class="comment">        conn[2] = this-&gt;node(6);</span>
<a name="l00428"></a>00428 <span class="comment">        conn[3] = this-&gt;node(8);</span>
<a name="l00429"></a>00429 <span class="comment"></span>
<a name="l00430"></a>00430 <span class="comment">        return;</span>
<a name="l00431"></a>00431 <span class="comment"></span>
<a name="l00432"></a>00432 <span class="comment">        // Linear sub-tet 7</span>
<a name="l00433"></a>00433 <span class="comment">        case 7:</span>
<a name="l00434"></a>00434 <span class="comment"></span>
<a name="l00435"></a>00435 <span class="comment">        conn[0] = this-&gt;node(7);</span>
<a name="l00436"></a>00436 <span class="comment">        conn[1] = this-&gt;node(6);</span>
<a name="l00437"></a>00437 <span class="comment">        conn[2] = this-&gt;node(9);</span>
<a name="l00438"></a>00438 <span class="comment">        conn[3] = this-&gt;node(8);</span>
<a name="l00439"></a>00439 <span class="comment"></span>
<a name="l00440"></a>00440 <span class="comment">        return;</span>
<a name="l00441"></a>00441 <span class="comment"></span>
<a name="l00442"></a>00442 <span class="comment"></span>
<a name="l00443"></a>00443 <span class="comment">        default:</span>
<a name="l00444"></a>00444 <span class="comment"></span>
<a name="l00445"></a>00445 <span class="comment">        libmesh_error();</span>
<a name="l00446"></a>00446 <span class="comment">      }</span>
<a name="l00447"></a>00447 <span class="comment">      */</span>
<a name="l00448"></a>00448       }
<a name="l00449"></a>00449 
<a name="l00450"></a>00450     <span class="keywordflow">default</span>:
<a name="l00451"></a>00451       libmesh_error();
<a name="l00452"></a>00452   }
<a name="l00453"></a>00453 
<a name="l00454"></a>00454   libmesh_error();
<a name="l00455"></a>00455 }
<a name="l00456"></a>00456 
<a name="l00457"></a>00457 
<a name="l00458"></a>00458 
<a name="l00459"></a>00459 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classTet10.php#a8d5927013d3bbb3cad1d7c1625b319aa">Tet10::_second_order_vertex_child_number</a>[10] =
<a name="l00460"></a>00460 {
<a name="l00461"></a>00461   99,99,99,99, <span class="comment">// Vertices</span>
<a name="l00462"></a>00462   0,1,0,0,1,2  <span class="comment">// Edges</span>
<a name="l00463"></a>00463 };
<a name="l00464"></a>00464 
<a name="l00465"></a>00465 
<a name="l00466"></a>00466 
<a name="l00467"></a>00467 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classTet10.php#ac1945361e3842ea20c5d2281192a132e">Tet10::_second_order_vertex_child_index</a>[10] =
<a name="l00468"></a>00468 {
<a name="l00469"></a>00469   99,99,99,99, <span class="comment">// Vertices</span>
<a name="l00470"></a>00470   1,2,2,3,3,3  <span class="comment">// Edges</span>
<a name="l00471"></a>00471 };
<a name="l00472"></a>00472 
<a name="l00473"></a>00473 
<a name="l00474"></a>00474 
<a name="l00475"></a>00475 std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00476"></a><a class="code" href="classTet10.php#a91b4508aff96b0be616f95672a434bf8">00476</a> <a class="code" href="classTet10.php#a91b4508aff96b0be616f95672a434bf8">Tet10::second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00477"></a>00477 <span class="keyword"></span>{
<a name="l00478"></a>00478   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classTet.php#a9aa4bf67228dc098ef3de8b7ea69e4ae">n_vertices</a>());
<a name="l00479"></a>00479   libmesh_assert (n &lt; this-&gt;<a class="code" href="classTet10.php#a2f9302b22750725ad7e8497325df694f">n_nodes</a>());
<a name="l00480"></a>00480   <span class="keywordflow">return</span> std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00481"></a>00481     (<a class="code" href="classTet10.php#a8d5927013d3bbb3cad1d7c1625b319aa">_second_order_vertex_child_number</a>[n],
<a name="l00482"></a>00482      <a class="code" href="classTet10.php#ac1945361e3842ea20c5d2281192a132e">_second_order_vertex_child_index</a>[n]);
<a name="l00483"></a>00483 }
<a name="l00484"></a>00484 
<a name="l00485"></a>00485 
<a name="l00486"></a>00486 
<a name="l00487"></a><a class="code" href="classTet10.php#a217e2808353373564c8a9daa1c49d8ee">00487</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classTet10.php#a217e2808353373564c8a9daa1c49d8ee">Tet10::second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00488"></a>00488                                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v)<span class="keyword"> const</span>
<a name="l00489"></a>00489 <span class="keyword"></span>{ 
<a name="l00490"></a>00490   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classTet.php#a9aa4bf67228dc098ef3de8b7ea69e4ae">n_vertices</a>());
<a name="l00491"></a>00491   libmesh_assert (n &lt;  this-&gt;<a class="code" href="classTet10.php#a2f9302b22750725ad7e8497325df694f">n_nodes</a>());
<a name="l00492"></a>00492   libmesh_assert (v &lt; 2);
<a name="l00493"></a>00493   <span class="keywordflow">return</span> <a class="code" href="classTet10.php#a6c3d835a54de7232212729655397c30d">_second_order_adjacent_vertices</a>[n-this-&gt;<a class="code" href="classTet.php#a9aa4bf67228dc098ef3de8b7ea69e4ae">n_vertices</a>()][v]; 
<a name="l00494"></a>00494 }
<a name="l00495"></a>00495 
<a name="l00496"></a>00496 
<a name="l00497"></a>00497 
<a name="l00498"></a>00498 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classTet10.php#a6c3d835a54de7232212729655397c30d">Tet10::_second_order_adjacent_vertices</a>[6][2] = 
<a name="l00499"></a>00499 {
<a name="l00500"></a>00500   {0, 1}, <span class="comment">// vertices adjacent to node 4 </span>
<a name="l00501"></a>00501   {1, 2}, <span class="comment">// vertices adjacent to node 5 </span>
<a name="l00502"></a>00502   {0, 2}, <span class="comment">// vertices adjacent to node 6 </span>
<a name="l00503"></a>00503   {0, 3}, <span class="comment">// vertices adjacent to node 7 </span>
<a name="l00504"></a>00504   {1, 3}, <span class="comment">// vertices adjacent to node 8 </span>
<a name="l00505"></a>00505   {2, 3}  <span class="comment">// vertices adjacent to node 9 </span>
<a name="l00506"></a>00506 };
<a name="l00507"></a>00507 
<a name="l00508"></a>00508 
<a name="l00509"></a>00509 
<a name="l00510"></a>00510 
<a name="l00511"></a>00511 
<a name="l00512"></a>00512 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00513"></a>00513 <span class="preprocessor"></span>
<a name="l00514"></a>00514 <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classTet10.php#a827ebc74eb9ffc83bd6604fadcdb3fbb">Tet10::_embedding_matrix</a>[8][10][10] =
<a name="l00515"></a>00515 {
<a name="l00516"></a>00516   <span class="comment">// embedding matrix for child 0</span>
<a name="l00517"></a>00517   {
<a name="l00518"></a>00518     <span class="comment">//    0      1      2      3      4      5      6      7      8      9</span>
<a name="l00519"></a>00519     {    1.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.}, <span class="comment">// 0</span>
<a name="l00520"></a>00520     {    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.,    0.,    0.}, <span class="comment">// 1</span>
<a name="l00521"></a>00521     {    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.}, <span class="comment">// 2</span>
<a name="l00522"></a>00522     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.}, <span class="comment">// 3</span>
<a name="l00523"></a>00523     { 0.375,-0.125,    0.,    0.,  0.75,    0.,    0.,    0.,    0.,    0.}, <span class="comment">// 4</span>
<a name="l00524"></a>00524     {    0.,-0.125,-0.125,    0.,   0.5,  0.25,   0.5,    0.,    0.,    0.}, <span class="comment">// 5</span>
<a name="l00525"></a>00525     { 0.375,    0.,-0.125,    0.,    0.,    0.,  0.75,    0.,    0.,    0.}, <span class="comment">// 6</span>
<a name="l00526"></a>00526     { 0.375,    0.,    0.,-0.125,    0.,    0.,    0.,  0.75,    0.,    0.}, <span class="comment">// 7</span>
<a name="l00527"></a>00527     {    0.,-0.125,    0.,-0.125,   0.5,    0.,    0.,   0.5,  0.25,    0.}, <span class="comment">// 8</span>
<a name="l00528"></a>00528     {    0.,    0.,-0.125,-0.125,    0.,    0.,   0.5,   0.5,    0.,  0.25}  <span class="comment">// 9</span>
<a name="l00529"></a>00529   },
<a name="l00530"></a>00530 
<a name="l00531"></a>00531   <span class="comment">// embedding matrix for child 1</span>
<a name="l00532"></a>00532   {
<a name="l00533"></a>00533     <span class="comment">//    0      1      2      3      4      5      6      7      8      9</span>
<a name="l00534"></a>00534     {    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.,    0.,    0.}, <span class="comment">// 0</span>
<a name="l00535"></a>00535     {    0.,    1.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.}, <span class="comment">// 1</span>
<a name="l00536"></a>00536     {    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.,    0.}, <span class="comment">// 2</span>
<a name="l00537"></a>00537     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.}, <span class="comment">// 3</span>
<a name="l00538"></a>00538     {-0.125, 0.375,    0.,    0.,  0.75,    0.,    0.,    0.,    0.,    0.}, <span class="comment">// 4</span>
<a name="l00539"></a>00539     {    0., 0.375,-0.125,    0.,    0.,  0.75,    0.,    0.,    0.,    0.}, <span class="comment">// 5</span>
<a name="l00540"></a>00540     {-0.125,    0.,-0.125,    0.,   0.5,   0.5,  0.25,    0.,    0.,    0.}, <span class="comment">// 6</span>
<a name="l00541"></a>00541     {-0.125,    0.,    0.,-0.125,   0.5,    0.,    0.,  0.25,   0.5,    0.}, <span class="comment">// 7</span>
<a name="l00542"></a>00542     {    0., 0.375,    0.,-0.125,    0.,    0.,    0.,    0.,  0.75,    0.}, <span class="comment">// 8</span>
<a name="l00543"></a>00543     {    0.,    0.,-0.125,-0.125,    0.,   0.5,    0.,    0.,   0.5,  0.25}  <span class="comment">// 9</span>
<a name="l00544"></a>00544   },
<a name="l00545"></a>00545 
<a name="l00546"></a>00546   <span class="comment">// embedding matrix for child 2</span>
<a name="l00547"></a>00547   {
<a name="l00548"></a>00548     <span class="comment">//    0      1      2      3      4      5      6      7      8      9</span>
<a name="l00549"></a>00549     {    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.}, <span class="comment">// 0</span>
<a name="l00550"></a>00550     {    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.,    0.}, <span class="comment">// 1</span>
<a name="l00551"></a>00551     {    0.,    0.,    1.,    0.,    0.,    0.,    0.,    0.,    0.,    0.}, <span class="comment">// 2</span>
<a name="l00552"></a>00552     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.}, <span class="comment">// 3</span>
<a name="l00553"></a>00553     {-0.125,-0.125,    0.,    0.,  0.25,   0.5,   0.5,    0.,    0.,    0.}, <span class="comment">// 4</span>
<a name="l00554"></a>00554     {    0.,-0.125, 0.375,    0.,    0.,  0.75,    0.,    0.,    0.,    0.}, <span class="comment">// 5</span>
<a name="l00555"></a>00555     {-0.125,    0., 0.375,    0.,    0.,    0.,  0.75,    0.,    0.,    0.}, <span class="comment">// 6</span>
<a name="l00556"></a>00556     {-0.125,    0.,    0.,-0.125,    0.,    0.,   0.5,  0.25,    0.,   0.5}, <span class="comment">// 7</span>
<a name="l00557"></a>00557     {    0.,-0.125,    0.,-0.125,    0.,   0.5,    0.,    0.,  0.25,   0.5}, <span class="comment">// 8</span>
<a name="l00558"></a>00558     {    0.,    0., 0.375,-0.125,    0.,    0.,    0.,    0.,    0.,  0.75}  <span class="comment">// 9</span>
<a name="l00559"></a>00559   },
<a name="l00560"></a>00560 
<a name="l00561"></a>00561   <span class="comment">// embedding matrix for child 3</span>
<a name="l00562"></a>00562   {
<a name="l00563"></a>00563     <span class="comment">//    0      1      2      3      4      5      6      7      8      9</span>
<a name="l00564"></a>00564     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.}, <span class="comment">// 0</span>
<a name="l00565"></a>00565     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.}, <span class="comment">// 1</span>
<a name="l00566"></a>00566     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.}, <span class="comment">// 2</span>
<a name="l00567"></a>00567     {    0.,    0.,    0.,    1.,    0.,    0.,    0.,    0.,    0.,    0.}, <span class="comment">// 3</span>
<a name="l00568"></a>00568     {-0.125,-0.125,    0.,    0.,  0.25,    0.,    0.,   0.5,   0.5,    0.}, <span class="comment">// 4</span>
<a name="l00569"></a>00569     {    0.,-0.125,-0.125,    0.,    0.,  0.25,    0.,    0.,   0.5,   0.5}, <span class="comment">// 5</span>
<a name="l00570"></a>00570     {-0.125,    0.,-0.125,    0.,    0.,    0.,  0.25,   0.5,    0.,   0.5}, <span class="comment">// 6</span>
<a name="l00571"></a>00571     {-0.125,    0.,    0., 0.375,    0.,    0.,    0.,  0.75,    0.,    0.}, <span class="comment">// 7</span>
<a name="l00572"></a>00572     {    0.,-0.125,    0., 0.375,    0.,    0.,    0.,    0.,  0.75,    0.}, <span class="comment">// 8</span>
<a name="l00573"></a>00573     {    0.,    0.,-0.125, 0.375,    0.,    0.,    0.,    0.,    0.,  0.75}  <span class="comment">// 9</span>
<a name="l00574"></a>00574   },
<a name="l00575"></a>00575 
<a name="l00576"></a>00576   <span class="comment">// embedding matrix for child 4</span>
<a name="l00577"></a>00577   {
<a name="l00578"></a>00578     <span class="comment">//    0      1      2      3      4      5      6      7      8      9</span>
<a name="l00579"></a>00579     {    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.,    0.,    0.}, <span class="comment">// 0</span>
<a name="l00580"></a>00580     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.}, <span class="comment">// 1</span>
<a name="l00581"></a>00581     {    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.}, <span class="comment">// 2</span>
<a name="l00582"></a>00582     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.}, <span class="comment">// 3</span>
<a name="l00583"></a>00583     {-0.125,    0.,    0.,-0.125,   0.5,    0.,    0.,  0.25,   0.5,    0.}, <span class="comment">// 4</span>
<a name="l00584"></a>00584     {-0.125,-0.125,-0.125,-0.125,  0.25,  0.25,  0.25,  0.25,  0.25,  0.25}, <span class="comment">// 5</span>
<a name="l00585"></a>00585     {    0.,-0.125,-0.125,    0.,   0.5,  0.25,   0.5,    0.,    0.,    0.}, <span class="comment">// 6</span>
<a name="l00586"></a>00586     {    0.,-0.125,    0.,-0.125,   0.5,    0.,    0.,   0.5,  0.25,    0.}, <span class="comment">// 7</span>
<a name="l00587"></a>00587     {-0.125,-0.125,    0.,    0.,  0.25,    0.,    0.,   0.5,   0.5,    0.}, <span class="comment">// 8</span>
<a name="l00588"></a>00588     {    0.,    0.,-0.125,-0.125,    0.,    0.,   0.5,   0.5,    0.,  0.25}  <span class="comment">// 9</span>
<a name="l00589"></a>00589   },
<a name="l00590"></a>00590 
<a name="l00591"></a>00591   <span class="comment">// embedding matrix for child 5</span>
<a name="l00592"></a>00592   {
<a name="l00593"></a>00593     <span class="comment">//    0      1      2      3      4      5      6      7      8      9</span>
<a name="l00594"></a>00594     {    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.,    0.,    0.}, <span class="comment">// 0</span>
<a name="l00595"></a>00595     {    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.,    0.}, <span class="comment">// 1</span>
<a name="l00596"></a>00596     {    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.}, <span class="comment">// 2</span>
<a name="l00597"></a>00597     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.}, <span class="comment">// 3</span>
<a name="l00598"></a>00598     {-0.125,    0.,-0.125,    0.,   0.5,   0.5,  0.25,    0.,    0.,    0.}, <span class="comment">// 4</span>
<a name="l00599"></a>00599     {-0.125,-0.125,    0.,    0.,  0.25,   0.5,   0.5,    0.,    0.,    0.}, <span class="comment">// 5</span>
<a name="l00600"></a>00600     {    0.,-0.125,-0.125,    0.,   0.5,  0.25,   0.5,    0.,    0.,    0.}, <span class="comment">// 6</span>
<a name="l00601"></a>00601     {-0.125,    0.,    0.,-0.125,   0.5,    0.,    0.,  0.25,   0.5,    0.}, <span class="comment">// 7</span>
<a name="l00602"></a>00602     {    0.,    0.,-0.125,-0.125,    0.,   0.5,    0.,    0.,   0.5,  0.25}, <span class="comment">// 8</span>
<a name="l00603"></a>00603     {-0.125,-0.125,-0.125,-0.125,  0.25,  0.25,  0.25,  0.25,  0.25,  0.25}  <span class="comment">// 9</span>
<a name="l00604"></a>00604   },
<a name="l00605"></a>00605 
<a name="l00606"></a>00606   <span class="comment">// embedding matrix for child 6</span>
<a name="l00607"></a>00607   {
<a name="l00608"></a>00608     <span class="comment">//    0      1      2      3      4      5      6      7      8      9</span>
<a name="l00609"></a>00609     {    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.}, <span class="comment">// 0</span>
<a name="l00610"></a>00610     {    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.,    0.}, <span class="comment">// 1</span>
<a name="l00611"></a>00611     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.}, <span class="comment">// 2</span>
<a name="l00612"></a>00612     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.}, <span class="comment">// 3</span>
<a name="l00613"></a>00613     {-0.125,-0.125,    0.,    0.,  0.25,   0.5,   0.5,    0.,    0.,    0.}, <span class="comment">// 4</span>
<a name="l00614"></a>00614     {    0.,-0.125,    0.,-0.125,    0.,   0.5,    0.,    0.,  0.25,   0.5}, <span class="comment">// 5</span>
<a name="l00615"></a>00615     {-0.125,    0.,    0.,-0.125,    0.,    0.,   0.5,  0.25,    0.,   0.5}, <span class="comment">// 6</span>
<a name="l00616"></a>00616     {-0.125,-0.125,-0.125,-0.125,  0.25,  0.25,  0.25,  0.25,  0.25,  0.25}, <span class="comment">// 7</span>
<a name="l00617"></a>00617     {    0.,    0.,-0.125,-0.125,    0.,   0.5,    0.,    0.,   0.5,  0.25}, <span class="comment">// 8</span>
<a name="l00618"></a>00618     {    0.,-0.125,-0.125,    0.,    0.,  0.25,    0.,    0.,   0.5,   0.5}  <span class="comment">// 9</span>
<a name="l00619"></a>00619   },
<a name="l00620"></a>00620 
<a name="l00621"></a>00621   <span class="comment">// embedding matrix for child 7</span>
<a name="l00622"></a>00622   {
<a name="l00623"></a>00623     <span class="comment">//    0      1      2      3      4      5      6      7      8      9</span>
<a name="l00624"></a>00624     {    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.}, <span class="comment">// 0</span>
<a name="l00625"></a>00625     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.}, <span class="comment">// 1</span>
<a name="l00626"></a>00626     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.}, <span class="comment">// 2</span>
<a name="l00627"></a>00627     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.}, <span class="comment">// 3</span>
<a name="l00628"></a>00628     {-0.125,-0.125,-0.125,-0.125,  0.25,  0.25,  0.25,  0.25,  0.25,  0.25}, <span class="comment">// 4</span>
<a name="l00629"></a>00629     {    0.,-0.125,-0.125,    0.,    0.,  0.25,    0.,    0.,   0.5,   0.5}, <span class="comment">// 5</span>
<a name="l00630"></a>00630     {-0.125,    0.,    0.,-0.125,    0.,    0.,   0.5,  0.25,    0.,   0.5}, <span class="comment">// 6</span>
<a name="l00631"></a>00631     {    0.,    0.,-0.125,-0.125,    0.,    0.,   0.5,   0.5,    0.,  0.25}, <span class="comment">// 7</span>
<a name="l00632"></a>00632     {-0.125,-0.125,    0.,    0.,  0.25,    0.,    0.,   0.5,   0.5,    0.}, <span class="comment">// 8</span>
<a name="l00633"></a>00633     {-0.125,    0.,-0.125,    0.,    0.,    0.,  0.25,   0.5,    0.,   0.5}  <span class="comment">// 9</span>
<a name="l00634"></a>00634   }
<a name="l00635"></a>00635 };
<a name="l00636"></a>00636 
<a name="l00637"></a>00637 
<a name="l00638"></a>00638 
<a name="l00639"></a>00639 
<a name="l00640"></a>00640 
<a name="l00641"></a>00641 
<a name="l00642"></a><a class="code" href="classTet10.php#a642ce5778c5e00ef82341fe5d714adc6">00642</a> <span class="keywordtype">float</span> <a class="code" href="classTet10.php#a642ce5778c5e00ef82341fe5d714adc6">Tet10::embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00643"></a>00643                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00644"></a>00644                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00645"></a>00645 <span class="keyword"></span>{
<a name="l00646"></a>00646   <span class="comment">// Check for uninitialized diagonal selection</span>
<a name="l00647"></a>00647   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classTet10.php#a3996501465b8a1e00633cc7bdebfe336">_diagonal_selection</a>==<a class="code" href="classTet10.php#ada51356cc4552611214e112da122039ba894223f78a930a854a6c32259fab6af4">INVALID_DIAG</a>)
<a name="l00648"></a>00648     {
<a name="l00649"></a>00649       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> diag_01_23 = (this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0)+this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1)-this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2)-this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3)).size_sq();
<a name="l00650"></a>00650       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> diag_02_13 = (this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0)-this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1)+this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2)-this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3)).size_sq();
<a name="l00651"></a>00651       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> diag_03_12 = (this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0)-this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1)-this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2)+this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3)).size_sq();
<a name="l00652"></a>00652 
<a name="l00653"></a>00653       this-&gt;<a class="code" href="classTet10.php#a3996501465b8a1e00633cc7bdebfe336">_diagonal_selection</a>=<a class="code" href="classTet10.php#ada51356cc4552611214e112da122039bac5f66010057f306065c87cd815df6613">DIAG_02_13</a>;
<a name="l00654"></a>00654 
<a name="l00655"></a>00655       <span class="keywordflow">if</span> (diag_01_23 &lt; diag_02_13 || diag_03_12 &lt; diag_02_13)
<a name="l00656"></a>00656       {
<a name="l00657"></a>00657         <span class="keywordflow">if</span> (diag_01_23 &lt; diag_03_12)
<a name="l00658"></a>00658           this-&gt;<a class="code" href="classTet10.php#a3996501465b8a1e00633cc7bdebfe336">_diagonal_selection</a>=<a class="code" href="classTet10.php#ada51356cc4552611214e112da122039ba587dedf6cd4b9c7faa75d4bd60d6b9da">DIAG_01_23</a>;
<a name="l00659"></a>00659 
<a name="l00660"></a>00660         <span class="keywordflow">else</span>
<a name="l00661"></a>00661           this-&gt;<a class="code" href="classTet10.php#a3996501465b8a1e00633cc7bdebfe336">_diagonal_selection</a>=<a class="code" href="classTet10.php#ada51356cc4552611214e112da122039ba37a22afa6ae63bad2bec48f5b3bdb4d2">DIAG_03_12</a>;
<a name="l00662"></a>00662       }
<a name="l00663"></a>00663     }
<a name="l00664"></a>00664 
<a name="l00665"></a>00665   <span class="comment">// Permuted j and k indices</span>
<a name="l00666"></a>00666   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00667"></a>00667     jp=j,
<a name="l00668"></a>00668     kp=k;
<a name="l00669"></a>00669 
<a name="l00670"></a>00670   <span class="keywordflow">if</span> ((i&gt;3) &amp;&amp; (this-&gt;<a class="code" href="classTet10.php#a3996501465b8a1e00633cc7bdebfe336">_diagonal_selection</a>!=<a class="code" href="classTet10.php#ada51356cc4552611214e112da122039bac5f66010057f306065c87cd815df6613">DIAG_02_13</a>))
<a name="l00671"></a>00671     {
<a name="l00672"></a>00672       <span class="comment">// Permute j, k</span>
<a name="l00673"></a>00673       <span class="keywordflow">if</span> (jp&lt;3) jp=(jp+<span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(this-&gt;<a class="code" href="classTet10.php#a3996501465b8a1e00633cc7bdebfe336">_diagonal_selection</a>))%3;
<a name="l00674"></a>00674       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (jp&gt;3) jp=(jp-1+<span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(this-&gt;<a class="code" href="classTet10.php#a3996501465b8a1e00633cc7bdebfe336">_diagonal_selection</a>))%3+1+3*((jp-1)/3);
<a name="l00675"></a>00675       <span class="keywordflow">if</span> (kp&lt;3) kp=(kp+<span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(this-&gt;<a class="code" href="classTet10.php#a3996501465b8a1e00633cc7bdebfe336">_diagonal_selection</a>))%3;
<a name="l00676"></a>00676       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (kp&gt;3) kp=(kp-1+<span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(this-&gt;<a class="code" href="classTet10.php#a3996501465b8a1e00633cc7bdebfe336">_diagonal_selection</a>))%3+1+3*((kp-1)/3);
<a name="l00677"></a>00677     }
<a name="l00678"></a>00678 
<a name="l00679"></a>00679   <span class="comment">// Call embedding matrx with permuted indices</span>
<a name="l00680"></a>00680   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classTet10.php#a827ebc74eb9ffc83bd6604fadcdb3fbb">_embedding_matrix</a>[i][jp][kp];
<a name="l00681"></a>00681 }
<a name="l00682"></a>00682 
<a name="l00683"></a>00683 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
