<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1665b3ccb6c776ec6797fe204e2359e5.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>cell_tet4.C</h1>  </div>
</div>
<div class="contents">
<a href="cell__tet4_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_tet4.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;side.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;cell_tet4.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;edge_edge2.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;face_tri3.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00032"></a>00032 <span class="comment">// Tet4 class static member initializations</span>
<a name="l00033"></a>00033 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTet4.php#a59c4b4acec809257a7a3ab68a73ea0e1">Tet4::side_nodes_map</a>[4][3] =
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035   {0, 2, 1}, <span class="comment">// Side 0</span>
<a name="l00036"></a>00036   {0, 1, 3}, <span class="comment">// Side 1</span>
<a name="l00037"></a>00037   {1, 2, 3}, <span class="comment">// Side 2</span>
<a name="l00038"></a>00038   {2, 0, 3}  <span class="comment">// Side 3</span>
<a name="l00039"></a>00039 };
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTet4.php#a4d4f3df8a619b62ef5dc85b47b725c56">Tet4::edge_nodes_map</a>[6][2] =
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043   {0, 1}, <span class="comment">// Side 0</span>
<a name="l00044"></a>00044   {1, 2}, <span class="comment">// Side 1</span>
<a name="l00045"></a>00045   {0, 2}, <span class="comment">// Side 2</span>
<a name="l00046"></a>00046   {0, 3}, <span class="comment">// Side 3</span>
<a name="l00047"></a>00047   {1, 3}, <span class="comment">// Side 4</span>
<a name="l00048"></a>00048   {2, 3}  <span class="comment">// Side 5</span>
<a name="l00049"></a>00049 };
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00053"></a>00053 <span class="comment">// Tet4 class member functions</span>
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="classTet4.php#a2451eefda45509ba376d0b7940897dbc">00055</a> <span class="keywordtype">bool</span> <a class="code" href="classTet4.php#a2451eefda45509ba376d0b7940897dbc">Tet4::is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00056"></a>00056 <span class="keyword"></span>{
<a name="l00057"></a>00057   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00058"></a>00058 }
<a name="l00059"></a>00059 
<a name="l00060"></a><a class="code" href="classTet4.php#a604b59376232cbe82ed7062e53afa4e2">00060</a> <span class="keywordtype">bool</span> <a class="code" href="classTet4.php#a604b59376232cbe82ed7062e53afa4e2">Tet4::is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00061"></a>00061 <span class="keyword"></span>{
<a name="l00062"></a>00062   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00063"></a>00063 }
<a name="l00064"></a>00064 
<a name="l00065"></a><a class="code" href="classTet4.php#a299204c63a06b12367de741f40c8a637">00065</a> <span class="keywordtype">bool</span> <a class="code" href="classTet4.php#a299204c63a06b12367de741f40c8a637">Tet4::is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00066"></a>00066 <span class="keyword"></span>{
<a name="l00067"></a>00067   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00068"></a>00068 }
<a name="l00069"></a>00069 
<a name="l00070"></a><a class="code" href="classTet4.php#a825049624fd8f9550efa7d2172268e15">00070</a> <span class="keywordtype">bool</span> <a class="code" href="classTet4.php#a825049624fd8f9550efa7d2172268e15">Tet4::is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00071"></a>00071                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00072"></a>00072 <span class="keyword"></span>{
<a name="l00073"></a>00073   libmesh_assert(e &lt; <a class="code" href="classTet.php#a145f530a16d029da337e7d3629d6b2c5">n_edges</a>());
<a name="l00074"></a>00074   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 2; ++i)
<a name="l00075"></a>00075     <span class="keywordflow">if</span> (<a class="code" href="classTet4.php#a4d4f3df8a619b62ef5dc85b47b725c56">edge_nodes_map</a>[e][i] == n)
<a name="l00076"></a>00076       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00077"></a>00077   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00078"></a>00078 }
<a name="l00079"></a>00079 
<a name="l00080"></a><a class="code" href="classTet4.php#aa19cf7f8947cafd04916bccce30de89e">00080</a> <span class="keywordtype">bool</span> <a class="code" href="classTet4.php#aa19cf7f8947cafd04916bccce30de89e">Tet4::is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00081"></a>00081                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00082"></a>00082 <span class="keyword"></span>{
<a name="l00083"></a>00083   libmesh_assert(s &lt; <a class="code" href="classTet.php#a0285d48cf5afd40aebafc91694256e2a">n_sides</a>());
<a name="l00084"></a>00084   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 3; ++i)
<a name="l00085"></a>00085     <span class="keywordflow">if</span> (<a class="code" href="classTet4.php#a59c4b4acec809257a7a3ab68a73ea0e1">side_nodes_map</a>[s][i] == n)
<a name="l00086"></a>00086       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00087"></a>00087   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00088"></a>00088 }
<a name="l00089"></a>00089 
<a name="l00090"></a><a class="code" href="classTet4.php#acf52bfe48d584c5685a41350e33c95f7">00090</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classTet4.php#acf52bfe48d584c5685a41350e33c95f7">Tet4::build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00091"></a>00091                                 <span class="keywordtype">bool</span> proxy)<span class="keyword"> const</span>
<a name="l00092"></a>00092 <span class="keyword"></span>{
<a name="l00093"></a>00093   libmesh_assert (i &lt; this-&gt;<a class="code" href="classTet.php#a0285d48cf5afd40aebafc91694256e2a">n_sides</a>());
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   <span class="keywordflow">if</span> (proxy)
<a name="l00096"></a>00096     {
<a name="l00097"></a>00097       <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classSide.php">Side&lt;Tri3,Tet4&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00098"></a>00098       <span class="keywordflow">return</span> ap;
<a name="l00099"></a>00099     }
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   <span class="keywordflow">else</span>
<a name="l00102"></a>00102     {
<a name="l00103"></a>00103       <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classTri3.php">Tri3</a>);
<a name="l00104"></a>00104 
<a name="l00105"></a>00105       <span class="keywordflow">switch</span> (i)
<a name="l00106"></a>00106         {
<a name="l00107"></a>00107         <span class="keywordflow">case</span> 0:
<a name="l00108"></a>00108           {
<a name="l00109"></a>00109             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00110"></a>00110             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00111"></a>00111             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00112"></a>00112 
<a name="l00113"></a>00113             <span class="keywordflow">return</span> face;
<a name="l00114"></a>00114           }
<a name="l00115"></a>00115         <span class="keywordflow">case</span> 1:
<a name="l00116"></a>00116           {
<a name="l00117"></a>00117             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00118"></a>00118             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00119"></a>00119             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00120"></a>00120 
<a name="l00121"></a>00121             <span class="keywordflow">return</span> face;
<a name="l00122"></a>00122           }
<a name="l00123"></a>00123         <span class="keywordflow">case</span> 2:
<a name="l00124"></a>00124           {
<a name="l00125"></a>00125             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00126"></a>00126             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00127"></a>00127             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00128"></a>00128 
<a name="l00129"></a>00129             <span class="keywordflow">return</span> face;
<a name="l00130"></a>00130           }
<a name="l00131"></a>00131         <span class="keywordflow">case</span> 3:
<a name="l00132"></a>00132           {
<a name="l00133"></a>00133             face-&gt;set_node(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00134"></a>00134             face-&gt;set_node(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00135"></a>00135             face-&gt;set_node(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00136"></a>00136         
<a name="l00137"></a>00137             <span class="keywordflow">return</span> face;
<a name="l00138"></a>00138           }
<a name="l00139"></a>00139         <span class="keywordflow">default</span>:
<a name="l00140"></a>00140           {
<a name="l00141"></a>00141             libmesh_error();
<a name="l00142"></a>00142           }
<a name="l00143"></a>00143         }
<a name="l00144"></a>00144     }
<a name="l00145"></a>00145   
<a name="l00146"></a>00146   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00147"></a>00147   libmesh_error();  
<a name="l00148"></a>00148   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00149"></a>00149 }
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00152"></a><a class="code" href="classTet4.php#af21c71afbbc6e0fdc8fd8314dbcbf4b9">00152</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classTet4.php#af21c71afbbc6e0fdc8fd8314dbcbf4b9">Tet4::build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00153"></a>00153 <span class="keyword"></span>{
<a name="l00154"></a>00154   libmesh_assert (i &lt; this-&gt;<a class="code" href="classTet.php#a145f530a16d029da337e7d3629d6b2c5">n_edges</a>());
<a name="l00155"></a>00155 
<a name="l00156"></a>00156   <span class="keywordflow">return</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a>(<span class="keyword">new</span> <a class="code" href="classSideEdge.php">SideEdge&lt;Edge2,Tet4&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00157"></a>00157 }
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 
<a name="l00160"></a><a class="code" href="classTet4.php#aa5fd2766d2649bca8b2eabbf90dc3e05">00160</a> <span class="keywordtype">void</span> <a class="code" href="classTet4.php#aa5fd2766d2649bca8b2eabbf90dc3e05">Tet4::connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00161"></a>00161                         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00162"></a>00162                         std::vector&lt;unsigned int&gt;&amp; conn)<span class="keyword"> const</span>
<a name="l00163"></a>00163 <span class="keyword"></span>{
<a name="l00164"></a>00164   libmesh_assert (<a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a> != NULL);
<a name="l00165"></a>00165   libmesh_assert (sc &lt; this-&gt;<a class="code" href="classTet4.php#ac44c86815df8f61530cf5ca416ec426c">n_sub_elem</a>());
<a name="l00166"></a>00166   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 
<a name="l00169"></a>00169   <span class="keywordflow">switch</span> (iop)
<a name="l00170"></a>00170     {
<a name="l00171"></a>00171     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00172"></a>00172       {
<a name="l00173"></a>00173         conn.resize(8);
<a name="l00174"></a>00174         conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0)+1;
<a name="l00175"></a>00175         conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1)+1;
<a name="l00176"></a>00176         conn[2] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2)+1;
<a name="l00177"></a>00177         conn[3] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2)+1;
<a name="l00178"></a>00178         conn[4] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3)+1;
<a name="l00179"></a>00179         conn[5] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3)+1;
<a name="l00180"></a>00180         conn[6] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3)+1;
<a name="l00181"></a>00181         conn[7] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3)+1;
<a name="l00182"></a>00182         <span class="keywordflow">return</span>;
<a name="l00183"></a>00183       }
<a name="l00184"></a>00184 
<a name="l00185"></a>00185     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa1affb8987f83b5e4acb22d9401dd44ef">VTK</a>:
<a name="l00186"></a>00186       {
<a name="l00187"></a>00187         conn.resize(4);
<a name="l00188"></a>00188         conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0);
<a name="l00189"></a>00189         conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1);
<a name="l00190"></a>00190         conn[2] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2);
<a name="l00191"></a>00191         conn[3] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3);
<a name="l00192"></a>00192         <span class="keywordflow">return</span>;
<a name="l00193"></a>00193       }
<a name="l00194"></a>00194 
<a name="l00195"></a>00195     <span class="keywordflow">default</span>:
<a name="l00196"></a>00196       libmesh_error();
<a name="l00197"></a>00197     }
<a name="l00198"></a>00198 
<a name="l00199"></a>00199   libmesh_error();
<a name="l00200"></a>00200 }
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00205"></a>00205 <span class="preprocessor"></span>
<a name="l00206"></a>00206 <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classTet4.php#a803f24b95c8c10bf49215b573f03e092">Tet4::_embedding_matrix</a>[8][4][4] =
<a name="l00207"></a>00207   {
<a name="l00208"></a>00208     <span class="comment">// embedding matrix for child 0</span>
<a name="l00209"></a>00209     {
<a name="l00210"></a>00210       <span class="comment">// 0    1    2    3  </span>
<a name="l00211"></a>00211       {1.0, 0.0, 0.0, 0.0}, <span class="comment">// 0</span>
<a name="l00212"></a>00212       {0.5, 0.5, 0.0, 0.0}, <span class="comment">// 1</span>
<a name="l00213"></a>00213       {0.5, 0.0, 0.5, 0.0}, <span class="comment">// 2</span>
<a name="l00214"></a>00214       {0.5, 0.0, 0.0, 0.5}  <span class="comment">// 3</span>
<a name="l00215"></a>00215     },
<a name="l00216"></a>00216   
<a name="l00217"></a>00217     <span class="comment">// embedding matrix for child 1</span>
<a name="l00218"></a>00218     {
<a name="l00219"></a>00219       <span class="comment">// 0    1    2    3  </span>
<a name="l00220"></a>00220       {0.5, 0.5, 0.0, 0.0}, <span class="comment">// 0</span>
<a name="l00221"></a>00221       {0.0, 1.0, 0.0, 0.0}, <span class="comment">// 1</span>
<a name="l00222"></a>00222       {0.0, 0.5, 0.5, 0.0}, <span class="comment">// 2</span>
<a name="l00223"></a>00223       {0.0, 0.5, 0.0, 0.5}  <span class="comment">// 3</span>
<a name="l00224"></a>00224     },
<a name="l00225"></a>00225   
<a name="l00226"></a>00226     <span class="comment">// embedding matrix for child 2</span>
<a name="l00227"></a>00227     {
<a name="l00228"></a>00228       <span class="comment">// 0    1    2    3  </span>
<a name="l00229"></a>00229       {0.5, 0.0, 0.5, 0.0}, <span class="comment">// 0</span>
<a name="l00230"></a>00230       {0.0, 0.5, 0.5, 0.0}, <span class="comment">// 1</span>
<a name="l00231"></a>00231       {0.0, 0.0, 1.0, 0.0}, <span class="comment">// 2</span>
<a name="l00232"></a>00232       {0.0, 0.0, 0.5, 0.5}  <span class="comment">// 3</span>
<a name="l00233"></a>00233     },
<a name="l00234"></a>00234   
<a name="l00235"></a>00235     <span class="comment">// embedding matrix for child 3</span>
<a name="l00236"></a>00236     {
<a name="l00237"></a>00237       <span class="comment">// 0    1    2    3  </span>
<a name="l00238"></a>00238       {0.5, 0.0, 0.0, 0.5}, <span class="comment">// 0</span>
<a name="l00239"></a>00239       {0.0, 0.5, 0.0, 0.5}, <span class="comment">// 1</span>
<a name="l00240"></a>00240       {0.0, 0.0, 0.5, 0.5}, <span class="comment">// 2</span>
<a name="l00241"></a>00241       {0.0, 0.0, 0.0, 1.0}  <span class="comment">// 3</span>
<a name="l00242"></a>00242     },
<a name="l00243"></a>00243   
<a name="l00244"></a>00244     <span class="comment">// embedding matrix for child 4</span>
<a name="l00245"></a>00245     {
<a name="l00246"></a>00246       <span class="comment">// 0    1    2    3  </span>
<a name="l00247"></a>00247       {0.5, 0.5, 0.0, 0.0}, <span class="comment">// 0</span>
<a name="l00248"></a>00248       {0.0, 0.5, 0.0, 0.5}, <span class="comment">// 1</span>
<a name="l00249"></a>00249       {0.5, 0.0, 0.5, 0.0}, <span class="comment">// 2</span>
<a name="l00250"></a>00250       {0.5, 0.0, 0.0, 0.5}  <span class="comment">// 3</span>
<a name="l00251"></a>00251     },
<a name="l00252"></a>00252   
<a name="l00253"></a>00253     <span class="comment">// embedding matrix for child 5</span>
<a name="l00254"></a>00254     {
<a name="l00255"></a>00255       <span class="comment">// 0    1    2    3  </span>
<a name="l00256"></a>00256       {0.5, 0.5, 0.0, 0.0}, <span class="comment">// 0</span>
<a name="l00257"></a>00257       {0.0, 0.5, 0.5, 0.0}, <span class="comment">// 1</span>
<a name="l00258"></a>00258       {0.5, 0.0, 0.5, 0.0}, <span class="comment">// 2</span>
<a name="l00259"></a>00259       {0.0, 0.5, 0.0, 0.5}  <span class="comment">// 3</span>
<a name="l00260"></a>00260     },
<a name="l00261"></a>00261   
<a name="l00262"></a>00262     <span class="comment">// embedding matrix for child 6</span>
<a name="l00263"></a>00263     {
<a name="l00264"></a>00264       <span class="comment">// 0    1    2    3  </span>
<a name="l00265"></a>00265       {0.5, 0.0, 0.5, 0.0}, <span class="comment">// 0</span>
<a name="l00266"></a>00266       {0.0, 0.5, 0.5, 0.0}, <span class="comment">// 1</span>
<a name="l00267"></a>00267       {0.0, 0.0, 0.5, 0.5}, <span class="comment">// 2</span>
<a name="l00268"></a>00268       {0.0, 0.5, 0.0, 0.5}  <span class="comment">// 3</span>
<a name="l00269"></a>00269     },
<a name="l00270"></a>00270   
<a name="l00271"></a>00271     <span class="comment">// embedding matrix for child 7</span>
<a name="l00272"></a>00272     {
<a name="l00273"></a>00273       <span class="comment">// 0    1    2    3  </span>
<a name="l00274"></a>00274       {0.5, 0.0, 0.5, 0.0}, <span class="comment">// 0</span>
<a name="l00275"></a>00275       {0.0, 0.5, 0.0, 0.5}, <span class="comment">// 1</span>
<a name="l00276"></a>00276       {0.0, 0.0, 0.5, 0.5}, <span class="comment">// 2</span>
<a name="l00277"></a>00277       {0.5, 0.0, 0.0, 0.5}  <span class="comment">// 3</span>
<a name="l00278"></a>00278     }
<a name="l00279"></a>00279   };
<a name="l00280"></a>00280 
<a name="l00281"></a>00281 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00282"></a>00282 <span class="preprocessor"></span>
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 
<a name="l00285"></a>00285 
<a name="l00286"></a>00286 
<a name="l00287"></a><a class="code" href="classTet4.php#aaf69f8e494ce45cbfeda3fa30f5cbc49">00287</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classTet4.php#aaf69f8e494ce45cbfeda3fa30f5cbc49">Tet4::volume</a> ()<span class="keyword"> const</span>
<a name="l00288"></a>00288 <span class="keyword"></span>{
<a name="l00289"></a>00289   <span class="comment">// The volume of a tetrahedron is 1/6 the box product formed</span>
<a name="l00290"></a>00290   <span class="comment">// by its base and apex vectors</span>
<a name="l00291"></a>00291   <a class="code" href="classPoint.php">Point</a> a ( *this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3) - *this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0) );
<a name="l00292"></a>00292 
<a name="l00293"></a>00293   <span class="comment">// b is the vector pointing from 0 to 1</span>
<a name="l00294"></a>00294   <a class="code" href="classPoint.php">Point</a> b ( *this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1) - *this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0) );
<a name="l00295"></a>00295 
<a name="l00296"></a>00296   <span class="comment">// c is the vector pointing from 0 to 2</span>
<a name="l00297"></a>00297   <a class="code" href="classPoint.php">Point</a> c ( *this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2) - *this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0) );
<a name="l00298"></a>00298 
<a name="l00299"></a>00299   <span class="keywordflow">return</span> (1.0 / 6.0) * (a * (b.<a class="code" href="classTypeVector.php#a1347e1223f3e31f8a2c0496736e60dc5">cross</a>(c)));
<a name="l00300"></a>00300 }
<a name="l00301"></a>00301 
<a name="l00302"></a>00302 
<a name="l00303"></a>00303 
<a name="l00304"></a>00304 
<a name="l00305"></a><a class="code" href="classTet4.php#a82acc3c5661ddbc1c800fa00250830a0">00305</a> std::pair&lt;Real, Real&gt; <a class="code" href="classTet4.php#a82acc3c5661ddbc1c800fa00250830a0">Tet4::min_and_max_angle</a>()<span class="keyword"> const</span>
<a name="l00306"></a>00306 <span class="keyword"></span>{
<a name="l00307"></a>00307   <a class="code" href="classPoint.php">Point</a> n[4];
<a name="l00308"></a>00308   
<a name="l00309"></a>00309   <span class="comment">// Compute the outward normal vectors on each face</span>
<a name="l00310"></a>00310   n[0] = (this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0)).cross(this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0));
<a name="l00311"></a>00311   n[1] = (this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0)).cross(this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0));
<a name="l00312"></a>00312   n[2] = (this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1)).cross(this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1));
<a name="l00313"></a>00313   n[3] = (this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2)).cross(this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2));
<a name="l00314"></a>00314 
<a name="l00315"></a>00315   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> dihedral_angles[6]; <span class="comment">// 01, 02, 03, 12, 13, 23</span>
<a name="l00316"></a>00316 
<a name="l00317"></a>00317   <span class="comment">// Compute dihedral angles</span>
<a name="l00318"></a>00318   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0,i=0; i&lt;4; ++i)
<a name="l00319"></a>00319     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=i+1; j&lt;4; ++j,k+=1)
<a name="l00320"></a>00320       dihedral_angles[k] = std::acos(n[i]*n[j] / n[i].size() / n[j].<a class="code" href="classTypeVector.php#a34f47a12e12990aad2910a934bdaac7d">size</a>()); <span class="comment">// return value is between 0 and PI</span>
<a name="l00321"></a>00321 
<a name="l00322"></a>00322   <span class="comment">// Return max/min dihedral angles</span>
<a name="l00323"></a>00323   <span class="keywordflow">return</span> std::make_pair(*std::min_element(dihedral_angles, dihedral_angles+6),
<a name="l00324"></a>00324                         *std::max_element(dihedral_angles, dihedral_angles+6));
<a name="l00325"></a>00325 
<a name="l00326"></a>00326 }
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00331"></a><a class="code" href="classTet4.php#a4919c1846c6b90f85f184f8627a9afd9">00331</a> <span class="preprocessor"></span><span class="keywordtype">float</span> <a class="code" href="classTet4.php#a4919c1846c6b90f85f184f8627a9afd9">Tet4::embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00332"></a>00332                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00333"></a>00333                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00334"></a>00334 <span class="keyword"></span>{
<a name="l00335"></a>00335   <span class="comment">// Check for uninitialized diagonal selection</span>
<a name="l00336"></a>00336   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classTet4.php#ae50704b760a31e01130842af65800482">_diagonal_selection</a>==<a class="code" href="classTet4.php#af5aae1566fcbfab5b1bb8ee5d5d69006a9937a7912ff4f7cad49c2771cbe682f1">INVALID_DIAG</a>)
<a name="l00337"></a>00337     {
<a name="l00338"></a>00338       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> diag_01_23 = (this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0)+this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1)-this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2)-this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3)).size_sq();
<a name="l00339"></a>00339       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> diag_02_13 = (this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0)-this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1)+this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2)-this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3)).size_sq();
<a name="l00340"></a>00340       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> diag_03_12 = (this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0)-this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1)-this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2)+this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3)).size_sq();
<a name="l00341"></a>00341 
<a name="l00342"></a>00342       this-&gt;<a class="code" href="classTet4.php#ae50704b760a31e01130842af65800482">_diagonal_selection</a>=<a class="code" href="classTet4.php#af5aae1566fcbfab5b1bb8ee5d5d69006ab0587f3676bda86a1c3e643f2d48f956">DIAG_02_13</a>;
<a name="l00343"></a>00343       
<a name="l00344"></a>00344       <span class="keywordflow">if</span> (diag_01_23 &lt; diag_02_13 || diag_03_12 &lt; diag_02_13)
<a name="l00345"></a>00345         {
<a name="l00346"></a>00346           <span class="keywordflow">if</span> (diag_01_23 &lt; diag_03_12)
<a name="l00347"></a>00347             this-&gt;<a class="code" href="classTet4.php#ae50704b760a31e01130842af65800482">_diagonal_selection</a>=<a class="code" href="classTet4.php#af5aae1566fcbfab5b1bb8ee5d5d69006a9c0fa021989add489792b2d2d74b7f52">DIAG_01_23</a>;
<a name="l00348"></a>00348 
<a name="l00349"></a>00349           <span class="keywordflow">else</span>
<a name="l00350"></a>00350             this-&gt;<a class="code" href="classTet4.php#ae50704b760a31e01130842af65800482">_diagonal_selection</a>=<a class="code" href="classTet4.php#af5aae1566fcbfab5b1bb8ee5d5d69006a19408e5a7a75d0c48f5ea875e1a90cc2">DIAG_03_12</a>;
<a name="l00351"></a>00351         }
<a name="l00352"></a>00352     }
<a name="l00353"></a>00353 
<a name="l00354"></a>00354   <span class="comment">// Permuted j and k indices</span>
<a name="l00355"></a>00355   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00356"></a>00356     jp=j,
<a name="l00357"></a>00357     kp=k;
<a name="l00358"></a>00358 
<a name="l00359"></a>00359   <span class="keywordflow">if</span> ((i&gt;3) &amp;&amp; (this-&gt;<a class="code" href="classTet4.php#ae50704b760a31e01130842af65800482">_diagonal_selection</a>!=<a class="code" href="classTet4.php#af5aae1566fcbfab5b1bb8ee5d5d69006ab0587f3676bda86a1c3e643f2d48f956">DIAG_02_13</a>))
<a name="l00360"></a>00360     {
<a name="l00361"></a>00361       <span class="comment">// Permute j, k</span>
<a name="l00362"></a>00362       <span class="keywordflow">if</span> (jp!=3) jp=(jp+<span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(this-&gt;<a class="code" href="classTet4.php#ae50704b760a31e01130842af65800482">_diagonal_selection</a>))%3;
<a name="l00363"></a>00363       <span class="keywordflow">if</span> (kp!=3) kp=(kp+<span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(this-&gt;<a class="code" href="classTet4.php#ae50704b760a31e01130842af65800482">_diagonal_selection</a>))%3;
<a name="l00364"></a>00364     }
<a name="l00365"></a>00365 
<a name="l00366"></a>00366   <span class="comment">// Call embedding matrx with permuted indices</span>
<a name="l00367"></a>00367   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classTet4.php#a803f24b95c8c10bf49215b573f03e092">_embedding_matrix</a>[i][jp][kp]; 
<a name="l00368"></a>00368 }
<a name="l00369"></a>00369 
<a name="l00370"></a>00370 
<a name="l00371"></a>00371 
<a name="l00372"></a><a class="code" href="classTet4.php#a6a180452989e89dc40dab957b0aafcff">00372</a> <span class="keywordtype">void</span> <a class="code" href="classTet4.php#a6a180452989e89dc40dab957b0aafcff">Tet4::select_diagonal</a> (<span class="keyword">const</span> <a class="code" href="classTet4.php#af5aae1566fcbfab5b1bb8ee5d5d69006">Diagonal</a> diag)<span class="keyword"> const</span>
<a name="l00373"></a>00373 <span class="keyword"></span>{
<a name="l00374"></a>00374   libmesh_assert (<a class="code" href="classTet4.php#ae50704b760a31e01130842af65800482">_diagonal_selection</a>==<a class="code" href="classTet4.php#af5aae1566fcbfab5b1bb8ee5d5d69006a9937a7912ff4f7cad49c2771cbe682f1">INVALID_DIAG</a>);
<a name="l00375"></a>00375   <a class="code" href="classTet4.php#ae50704b760a31e01130842af65800482">_diagonal_selection</a> = diag;
<a name="l00376"></a>00376 }
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 
<a name="l00379"></a>00379 
<a name="l00380"></a><a class="code" href="classTet4.php#adb7719b5b52e824d2b8a79a134285935">00380</a> <span class="keywordtype">void</span> <a class="code" href="classTet4.php#adb7719b5b52e824d2b8a79a134285935">Tet4::reselect_diagonal</a> (<span class="keyword">const</span> <a class="code" href="classTet4.php#af5aae1566fcbfab5b1bb8ee5d5d69006">Diagonal</a> diag)
<a name="l00381"></a>00381 {
<a name="l00382"></a>00382   <span class="comment">/* Make sure that the element has just been refined.  */</span>
<a name="l00383"></a>00383   libmesh_assert (<a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>!=NULL);
<a name="l00384"></a>00384   libmesh_assert (<a class="code" href="classTet.php#af206637e6e74858694ac94b7af907976">n_children</a>()==8);
<a name="l00385"></a>00385   libmesh_assert (<a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>[0]-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>()==<a class="code" href="classElem.php#a946039859488cca879512de516fef829a28fd8e260b7464210efa6f4f24d54310">JUST_REFINED</a>);
<a name="l00386"></a>00386   libmesh_assert (<a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>[1]-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>()==<a class="code" href="classElem.php#a946039859488cca879512de516fef829a28fd8e260b7464210efa6f4f24d54310">JUST_REFINED</a>);
<a name="l00387"></a>00387   libmesh_assert (<a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>[2]-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>()==<a class="code" href="classElem.php#a946039859488cca879512de516fef829a28fd8e260b7464210efa6f4f24d54310">JUST_REFINED</a>);
<a name="l00388"></a>00388   libmesh_assert (<a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>[3]-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>()==<a class="code" href="classElem.php#a946039859488cca879512de516fef829a28fd8e260b7464210efa6f4f24d54310">JUST_REFINED</a>);
<a name="l00389"></a>00389   libmesh_assert (<a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>[4]-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>()==<a class="code" href="classElem.php#a946039859488cca879512de516fef829a28fd8e260b7464210efa6f4f24d54310">JUST_REFINED</a>);
<a name="l00390"></a>00390   libmesh_assert (<a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>[5]-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>()==<a class="code" href="classElem.php#a946039859488cca879512de516fef829a28fd8e260b7464210efa6f4f24d54310">JUST_REFINED</a>);
<a name="l00391"></a>00391   libmesh_assert (<a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>[6]-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>()==<a class="code" href="classElem.php#a946039859488cca879512de516fef829a28fd8e260b7464210efa6f4f24d54310">JUST_REFINED</a>);
<a name="l00392"></a>00392   libmesh_assert (<a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>[7]-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>()==<a class="code" href="classElem.php#a946039859488cca879512de516fef829a28fd8e260b7464210efa6f4f24d54310">JUST_REFINED</a>);
<a name="l00393"></a>00393 
<a name="l00394"></a>00394   <span class="comment">/* Check whether anything has to be changed.  */</span>
<a name="l00395"></a>00395   <span class="keywordflow">if</span> (<a class="code" href="classTet4.php#ae50704b760a31e01130842af65800482">_diagonal_selection</a>!=diag)
<a name="l00396"></a>00396     {
<a name="l00397"></a>00397       <span class="comment">/* Set new diagonal selection.  */</span>
<a name="l00398"></a>00398       <a class="code" href="classTet4.php#ae50704b760a31e01130842af65800482">_diagonal_selection</a> = diag;
<a name="l00399"></a>00399 
<a name="l00400"></a>00400       <span class="comment">/* The first four children do not have to be changed.  For the</span>
<a name="l00401"></a>00401 <span class="comment">         others, only the nodes have to be changed.  Note that we have</span>
<a name="l00402"></a>00402 <span class="comment">         to keep track of the nodes ourselves since there is no \p</span>
<a name="l00403"></a>00403 <span class="comment">         MeshRefinement object with a valid \p _new_nodes_map</span>
<a name="l00404"></a>00404 <span class="comment">         available.  */</span>
<a name="l00405"></a>00405       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=4; c&lt;this-&gt;<a class="code" href="classTet.php#af206637e6e74858694ac94b7af907976">n_children</a>(); c++)
<a name="l00406"></a>00406         {
<a name="l00407"></a>00407           <a class="code" href="classElem.php">Elem</a> *<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a> = this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c);
<a name="l00408"></a>00408           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc=0; nc&lt;child-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); nc++)
<a name="l00409"></a>00409             {
<a name="l00410"></a>00410               <span class="comment">/* Unassign the current node.  */</span>
<a name="l00411"></a>00411               child-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(nc) = NULL;
<a name="l00412"></a>00412 
<a name="l00413"></a>00413               <span class="comment">/* We have to find the correct new node now.  We know</span>
<a name="l00414"></a>00414 <span class="comment">                 that it exists somewhere.  We make use of the fact</span>
<a name="l00415"></a>00415 <span class="comment">                 that the embedding matrix for these children consists</span>
<a name="l00416"></a>00416 <span class="comment">                 of entries 0.0 and 0.5 only.  Also, we make use of</span>
<a name="l00417"></a>00417 <span class="comment">                 the properties of the embedding matrix for the first</span>
<a name="l00418"></a>00418 <span class="comment">                 (unchanged) four children, which allow us to use a</span>
<a name="l00419"></a>00419 <span class="comment">                 simple mechanism to find the required node.  */</span>
<a name="l00420"></a>00420               
<a name="l00421"></a>00421               
<a name="l00422"></a>00422               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_05_in_embedding_matrix = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00423"></a>00423               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;this-&gt;<a class="code" href="classTet4.php#aa7d9a4b093f2e9c2893918fcc6241fb2">n_nodes</a>(); n++)
<a name="l00424"></a>00424                 {
<a name="l00425"></a>00425                   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classTet4.php#a4919c1846c6b90f85f184f8627a9afd9">embedding_matrix</a>(c,nc,n) != 0.0)
<a name="l00426"></a>00426                     {
<a name="l00427"></a>00427                       <span class="comment">/* It must be 0.5 then.  Check whether it&#39;s the</span>
<a name="l00428"></a>00428 <span class="comment">                         first or second time that we get a 0.5</span>
<a name="l00429"></a>00429 <span class="comment">                         value.  */</span>
<a name="l00430"></a>00430                       <span class="keywordflow">if</span> (first_05_in_embedding_matrix==<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00431"></a>00431                         {
<a name="l00432"></a>00432                           <span class="comment">/* First time, so just remeber this position.  */</span>
<a name="l00433"></a>00433                           first_05_in_embedding_matrix = n;
<a name="l00434"></a>00434                         }
<a name="l00435"></a>00435                       <span class="keywordflow">else</span>
<a name="l00436"></a>00436                         {
<a name="l00437"></a>00437                           <span class="comment">/* Second time, so we know now which node to</span>
<a name="l00438"></a>00438 <span class="comment">                             use.  */</span>
<a name="l00439"></a>00439                           child-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(nc) = this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(n)-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(first_05_in_embedding_matrix);
<a name="l00440"></a>00440                         }
<a name="l00441"></a>00441 
<a name="l00442"></a>00442                     }
<a name="l00443"></a>00443                 }
<a name="l00444"></a>00444 
<a name="l00445"></a>00445               <span class="comment">/* Make sure that a node has been found.  */</span>
<a name="l00446"></a>00446               libmesh_assert (child-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(nc)!=NULL);
<a name="l00447"></a>00447             }
<a name="l00448"></a>00448         }
<a name="l00449"></a>00449     }
<a name="l00450"></a>00450 }
<a name="l00451"></a>00451 
<a name="l00452"></a>00452 
<a name="l00453"></a>00453 
<a name="l00454"></a><a class="code" href="classTet4.php#ab229d39e30facab418e6dba3fd9b7c5d">00454</a> <span class="keywordtype">void</span> <a class="code" href="classTet4.php#ab229d39e30facab418e6dba3fd9b7c5d">Tet4::reselect_optimal_diagonal</a> (<span class="keyword">const</span> <a class="code" href="classTet4.php#af5aae1566fcbfab5b1bb8ee5d5d69006">Diagonal</a> exclude_this)
<a name="l00455"></a>00455 {
<a name="l00456"></a>00456   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> diag_01_23 = (this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0)+this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1)-this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2)-this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3)).size_sq();
<a name="l00457"></a>00457   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> diag_02_13 = (this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0)-this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1)+this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2)-this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3)).size_sq();
<a name="l00458"></a>00458   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> diag_03_12 = (this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0)-this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1)-this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2)+this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3)).size_sq();
<a name="l00459"></a>00459   
<a name="l00460"></a>00460   <a class="code" href="classTet4.php#af5aae1566fcbfab5b1bb8ee5d5d69006">Diagonal</a> use_this = <a class="code" href="classTet4.php#af5aae1566fcbfab5b1bb8ee5d5d69006a9937a7912ff4f7cad49c2771cbe682f1">INVALID_DIAG</a>;
<a name="l00461"></a>00461   <span class="keywordflow">switch</span> (exclude_this)
<a name="l00462"></a>00462     {
<a name="l00463"></a>00463     <span class="keywordflow">case</span> <a class="code" href="classTet4.php#af5aae1566fcbfab5b1bb8ee5d5d69006a9c0fa021989add489792b2d2d74b7f52">DIAG_01_23</a>:
<a name="l00464"></a>00464       use_this = <a class="code" href="classTet4.php#af5aae1566fcbfab5b1bb8ee5d5d69006ab0587f3676bda86a1c3e643f2d48f956">DIAG_02_13</a>;
<a name="l00465"></a>00465       <span class="keywordflow">if</span> (diag_03_12 &lt; diag_02_13)
<a name="l00466"></a>00466         {
<a name="l00467"></a>00467           use_this = <a class="code" href="classTet4.php#af5aae1566fcbfab5b1bb8ee5d5d69006a19408e5a7a75d0c48f5ea875e1a90cc2">DIAG_03_12</a>;
<a name="l00468"></a>00468         }
<a name="l00469"></a>00469       <span class="keywordflow">break</span>;
<a name="l00470"></a>00470 
<a name="l00471"></a>00471     <span class="keywordflow">case</span> <a class="code" href="classTet4.php#af5aae1566fcbfab5b1bb8ee5d5d69006ab0587f3676bda86a1c3e643f2d48f956">DIAG_02_13</a>:
<a name="l00472"></a>00472       use_this = <a class="code" href="classTet4.php#af5aae1566fcbfab5b1bb8ee5d5d69006a19408e5a7a75d0c48f5ea875e1a90cc2">DIAG_03_12</a>;
<a name="l00473"></a>00473       <span class="keywordflow">if</span> (diag_01_23 &lt; diag_03_12)
<a name="l00474"></a>00474         {
<a name="l00475"></a>00475           use_this = <a class="code" href="classTet4.php#af5aae1566fcbfab5b1bb8ee5d5d69006a9c0fa021989add489792b2d2d74b7f52">DIAG_01_23</a>;
<a name="l00476"></a>00476         }
<a name="l00477"></a>00477       <span class="keywordflow">break</span>;
<a name="l00478"></a>00478 
<a name="l00479"></a>00479     <span class="keywordflow">case</span> <a class="code" href="classTet4.php#af5aae1566fcbfab5b1bb8ee5d5d69006a19408e5a7a75d0c48f5ea875e1a90cc2">DIAG_03_12</a>:
<a name="l00480"></a>00480       use_this = <a class="code" href="classTet4.php#af5aae1566fcbfab5b1bb8ee5d5d69006ab0587f3676bda86a1c3e643f2d48f956">DIAG_02_13</a>;
<a name="l00481"></a>00481       <span class="keywordflow">if</span> (diag_01_23 &lt; diag_02_13)
<a name="l00482"></a>00482         {
<a name="l00483"></a>00483           use_this = <a class="code" href="classTet4.php#af5aae1566fcbfab5b1bb8ee5d5d69006a9c0fa021989add489792b2d2d74b7f52">DIAG_01_23</a>;
<a name="l00484"></a>00484         }
<a name="l00485"></a>00485       <span class="keywordflow">break</span>;
<a name="l00486"></a>00486 
<a name="l00487"></a>00487     <span class="keywordflow">default</span>:
<a name="l00488"></a>00488       use_this = <a class="code" href="classTet4.php#af5aae1566fcbfab5b1bb8ee5d5d69006ab0587f3676bda86a1c3e643f2d48f956">DIAG_02_13</a>;
<a name="l00489"></a>00489       <span class="keywordflow">if</span> (diag_01_23 &lt; diag_02_13 || diag_03_12 &lt; diag_02_13)
<a name="l00490"></a>00490         {
<a name="l00491"></a>00491           <span class="keywordflow">if</span> (diag_01_23 &lt; diag_03_12)
<a name="l00492"></a>00492             {
<a name="l00493"></a>00493               use_this = <a class="code" href="classTet4.php#af5aae1566fcbfab5b1bb8ee5d5d69006a9c0fa021989add489792b2d2d74b7f52">DIAG_01_23</a>;
<a name="l00494"></a>00494             }
<a name="l00495"></a>00495           <span class="keywordflow">else</span>
<a name="l00496"></a>00496             {
<a name="l00497"></a>00497               use_this = <a class="code" href="classTet4.php#af5aae1566fcbfab5b1bb8ee5d5d69006a19408e5a7a75d0c48f5ea875e1a90cc2">DIAG_03_12</a>;
<a name="l00498"></a>00498             }
<a name="l00499"></a>00499         }
<a name="l00500"></a>00500       <span class="keywordflow">break</span>;
<a name="l00501"></a>00501     }
<a name="l00502"></a>00502 
<a name="l00503"></a>00503   <a class="code" href="classTet4.php#adb7719b5b52e824d2b8a79a134285935">reselect_diagonal</a> (use_this);  
<a name="l00504"></a>00504 } 
<a name="l00505"></a>00505 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
