<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1665b3ccb6c776ec6797fe204e2359e5.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>cell_tet.C</h1>  </div>
</div>
<div class="contents">
<a href="cell__tet_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_tet.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;cell_tet.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;cell_tet4.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;face_tri3.h&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00031"></a>00031 <span class="comment">// Tet class member functions</span>
<a name="l00032"></a><a class="code" href="classTet.php#ae8963e241ab0e3889cc1780c3346911e">00032</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTet.php#ae8963e241ab0e3889cc1780c3346911e">Tet::key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00033"></a>00033 <span class="keyword"></span>{
<a name="l00034"></a>00034   libmesh_assert (s &lt; this-&gt;<a class="code" href="classTet.php#a0285d48cf5afd40aebafc91694256e2a">n_sides</a>());
<a name="l00035"></a>00035 
<a name="l00036"></a>00036   <span class="keywordflow">switch</span> (s)
<a name="l00037"></a>00037     {
<a name="l00038"></a>00038     <span class="keywordflow">case</span> 0:
<a name="l00039"></a>00039       <span class="keywordflow">return</span>
<a name="l00040"></a>00040         this-&gt;<a class="code" href="classElem.php#a859c8236824914afa005cacf1ee86959">compute_key</a> (this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0),
<a name="l00041"></a>00041                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2),
<a name="l00042"></a>00042                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1));
<a name="l00043"></a>00043       
<a name="l00044"></a>00044     <span class="keywordflow">case</span> 1:
<a name="l00045"></a>00045       <span class="keywordflow">return</span>
<a name="l00046"></a>00046         this-&gt;<a class="code" href="classElem.php#a859c8236824914afa005cacf1ee86959">compute_key</a> (this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0),
<a name="l00047"></a>00047                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1),
<a name="l00048"></a>00048                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3));
<a name="l00049"></a>00049 
<a name="l00050"></a>00050     <span class="keywordflow">case</span> 2:
<a name="l00051"></a>00051       <span class="keywordflow">return</span>
<a name="l00052"></a>00052         this-&gt;<a class="code" href="classElem.php#a859c8236824914afa005cacf1ee86959">compute_key</a> (this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1),
<a name="l00053"></a>00053                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2),
<a name="l00054"></a>00054                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3));
<a name="l00055"></a>00055 
<a name="l00056"></a>00056     <span class="keywordflow">case</span> 3:
<a name="l00057"></a>00057       <span class="keywordflow">return</span>
<a name="l00058"></a>00058         this-&gt;<a class="code" href="classElem.php#a859c8236824914afa005cacf1ee86959">compute_key</a> (this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2),
<a name="l00059"></a>00059                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0),
<a name="l00060"></a>00060                            this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3));      
<a name="l00061"></a>00061     }
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00064"></a>00064   libmesh_error();
<a name="l00065"></a>00065   <span class="keywordflow">return</span> 0;
<a name="l00066"></a>00066 }
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 
<a name="l00070"></a><a class="code" href="classTet.php#afc1a7c74de397806a9307b5f89b625fb">00070</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> <a class="code" href="classTet.php#afc1a7c74de397806a9307b5f89b625fb">Tet::side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00071"></a>00071 <span class="keyword"></span>{
<a name="l00072"></a>00072   libmesh_assert (i &lt; this-&gt;<a class="code" href="classTet.php#a0285d48cf5afd40aebafc91694256e2a">n_sides</a>());
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 
<a name="l00075"></a>00075   
<a name="l00076"></a>00076   <a class="code" href="classElem.php">Elem</a>* face = <span class="keyword">new</span> <a class="code" href="classTri3.php">Tri3</a>;
<a name="l00077"></a>00077   
<a name="l00078"></a>00078   <span class="keywordflow">switch</span> (i)
<a name="l00079"></a>00079     {
<a name="l00080"></a>00080     <span class="keywordflow">case</span> 0:
<a name="l00081"></a>00081       {
<a name="l00082"></a>00082         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00083"></a>00083         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00084"></a>00084         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00085"></a>00085 
<a name="l00086"></a>00086         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> ap_face(face);
<a name="l00087"></a>00087         <span class="keywordflow">return</span> ap_face;
<a name="l00088"></a>00088       }
<a name="l00089"></a>00089     <span class="keywordflow">case</span> 1:
<a name="l00090"></a>00090       {
<a name="l00091"></a>00091         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00092"></a>00092         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00093"></a>00093         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00094"></a>00094 
<a name="l00095"></a>00095         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> ap_face(face);
<a name="l00096"></a>00096         <span class="keywordflow">return</span> ap_face;
<a name="l00097"></a>00097       }
<a name="l00098"></a>00098     <span class="keywordflow">case</span> 2:
<a name="l00099"></a>00099       {
<a name="l00100"></a>00100         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00101"></a>00101         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00102"></a>00102         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00103"></a>00103 
<a name="l00104"></a>00104         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> ap_face(face);
<a name="l00105"></a>00105         <span class="keywordflow">return</span> ap_face;
<a name="l00106"></a>00106       }
<a name="l00107"></a>00107     <span class="keywordflow">case</span> 3:
<a name="l00108"></a>00108       {
<a name="l00109"></a>00109         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00110"></a>00110         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00111"></a>00111         face-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00112"></a>00112         
<a name="l00113"></a>00113         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> ap_face(face);
<a name="l00114"></a>00114         <span class="keywordflow">return</span> ap_face;
<a name="l00115"></a>00115       }
<a name="l00116"></a>00116     <span class="keywordflow">default</span>:
<a name="l00117"></a>00117       {
<a name="l00118"></a>00118         libmesh_error();
<a name="l00119"></a>00119       }
<a name="l00120"></a>00120     }
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00123"></a>00123   libmesh_error();
<a name="l00124"></a>00124   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> ap_face(face);
<a name="l00125"></a>00125   <span class="keywordflow">return</span> ap_face;
<a name="l00126"></a>00126 }
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a><a class="code" href="classTet.php#a2c80c1826be3754371addd3140af3bcf">00130</a> <span class="keywordtype">bool</span> <a class="code" href="classTet.php#a2c80c1826be3754371addd3140af3bcf">Tet::is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00131"></a>00131                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00132"></a>00132 <span class="keyword"></span>{
<a name="l00133"></a>00133   libmesh_assert (c &lt; this-&gt;<a class="code" href="classTet.php#af206637e6e74858694ac94b7af907976">n_children</a>());
<a name="l00134"></a>00134   libmesh_assert (s &lt; this-&gt;<a class="code" href="classTet.php#a0285d48cf5afd40aebafc91694256e2a">n_sides</a>());
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 3; ++i)
<a name="l00137"></a>00137     <span class="keywordflow">if</span> (<a class="code" href="classTet4.php#a59c4b4acec809257a7a3ab68a73ea0e1">Tet4::side_nodes_map</a>[s][i] == c)
<a name="l00138"></a>00138       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00139"></a>00139   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00140"></a>00140 }
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a><a class="code" href="classTet.php#a58f3f65f6f13103375d20ee4d0c2d5b0">00144</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classTet.php#a58f3f65f6f13103375d20ee4d0c2d5b0">Tet::quality</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q)<span class="keyword"> const</span>
<a name="l00145"></a>00145 <span class="keyword"></span>{
<a name="l00146"></a>00146   <span class="keywordflow">return</span> <a class="code" href="classTet.php#a58f3f65f6f13103375d20ee4d0c2d5b0">Elem::quality</a>(q); <span class="comment">// Not implemented</span>
<a name="l00147"></a>00147 }
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00152"></a><a class="code" href="classTet.php#a5a13fb37731656c35d55ef152a808a05">00152</a> std::pair&lt;Real, Real&gt; <a class="code" href="classTet.php#a5a13fb37731656c35d55ef152a808a05">Tet::qual_bounds</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q)<span class="keyword"> const</span>
<a name="l00153"></a>00153 <span class="keyword"></span>{
<a name="l00154"></a>00154   std::pair&lt;Real, Real&gt; bounds;
<a name="l00155"></a>00155   
<a name="l00156"></a>00156   <span class="keywordflow">switch</span> (q)
<a name="l00157"></a>00157     {
<a name="l00158"></a>00158 
<a name="l00159"></a>00159     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a77ceaa502eaeff5313a279f08699e9d5">ASPECT_RATIO_BETA</a>:
<a name="l00160"></a>00160     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad1cac69d1c38539e42934ab8dd2cb5a8">ASPECT_RATIO_GAMMA</a>:
<a name="l00161"></a>00161       bounds.first  = 1.;
<a name="l00162"></a>00162       bounds.second = 3.;
<a name="l00163"></a>00163       <span class="keywordflow">break</span>;
<a name="l00164"></a>00164       
<a name="l00165"></a>00165     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012afe883232d33e91404f7669f2aab854a6">SIZE</a>:
<a name="l00166"></a>00166     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a44883df285a1b32254467277e46343df">SHAPE</a>:
<a name="l00167"></a>00167       bounds.first  = 0.2;
<a name="l00168"></a>00168       bounds.second = 1.;
<a name="l00169"></a>00169       <span class="keywordflow">break</span>;
<a name="l00170"></a>00170 
<a name="l00171"></a>00171     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a29e1db5c60b32bcee224ac441c04274b">CONDITION</a>:
<a name="l00172"></a>00172       bounds.first  = 1.;
<a name="l00173"></a>00173       bounds.second = 3.;
<a name="l00174"></a>00174       <span class="keywordflow">break</span>;
<a name="l00175"></a>00175       
<a name="l00176"></a>00176     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a3fe96cbcdc284192e960220fc49fa942">DISTORTION</a>:
<a name="l00177"></a>00177       bounds.first  = 0.6;
<a name="l00178"></a>00178       bounds.second = 1.;
<a name="l00179"></a>00179       <span class="keywordflow">break</span>;  
<a name="l00180"></a>00180 
<a name="l00181"></a>00181     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012adce510f6954c2ac2cd6b1c6bf91210cc">JACOBIAN</a>:
<a name="l00182"></a>00182       bounds.first  = 0.5;
<a name="l00183"></a>00183       bounds.second = 1.414;
<a name="l00184"></a>00184       <span class="keywordflow">break</span>;
<a name="l00185"></a>00185       
<a name="l00186"></a>00186     <span class="keywordflow">default</span>:
<a name="l00187"></a>00187       std::cout &lt;&lt; <span class="stringliteral">&quot;Warning: Invalid quality measure chosen.&quot;</span> &lt;&lt; std::endl;
<a name="l00188"></a>00188       bounds.first  = -1;
<a name="l00189"></a>00189       bounds.second = -1;
<a name="l00190"></a>00190     }
<a name="l00191"></a>00191 
<a name="l00192"></a>00192   <span class="keywordflow">return</span> bounds;
<a name="l00193"></a>00193 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
