<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>cell_tet.h</h1>  </div>
</div>
<div class="contents">
<a href="cell__tet_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_tet.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __cell_tet_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __cell_tet_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="cell_8h.php">cell.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00037"></a>00037 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00038"></a>00038 <span class="comment">// Tet class definition</span>
<a name="l00039"></a><a class="code" href="classTet.php">00039</a> <span class="keyword">class </span><a class="code" href="classTet.php">Tet</a> : <span class="keyword">public</span> <a class="code" href="classCell.php">Cell</a>
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041 <span class="keyword">public</span>:
<a name="l00042"></a>00042 
<a name="l00047"></a>00047   <a class="code" href="classTet.php#ab15467ce2856d11a8bb8be2389fb398b">Tet</a>  (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn, <a class="code" href="classElem.php">Elem</a>* p);
<a name="l00048"></a>00048 
<a name="l00052"></a><a class="code" href="classTet.php#a0285d48cf5afd40aebafc91694256e2a">00052</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTet.php#a0285d48cf5afd40aebafc91694256e2a">n_sides</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00053"></a>00053 
<a name="l00057"></a><a class="code" href="classTet.php#a9aa4bf67228dc098ef3de8b7ea69e4ae">00057</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTet.php#a9aa4bf67228dc098ef3de8b7ea69e4ae">n_vertices</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00058"></a>00058 
<a name="l00062"></a><a class="code" href="classTet.php#a145f530a16d029da337e7d3629d6b2c5">00062</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTet.php#a145f530a16d029da337e7d3629d6b2c5">n_edges</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 6; }
<a name="l00063"></a>00063 
<a name="l00067"></a><a class="code" href="classTet.php#a0e21bcedab94959f098e1a6207f74835">00067</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTet.php#a0e21bcedab94959f098e1a6207f74835">n_faces</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00068"></a>00068 
<a name="l00072"></a><a class="code" href="classTet.php#af206637e6e74858694ac94b7af907976">00072</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTet.php#af206637e6e74858694ac94b7af907976">n_children</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 8; } 
<a name="l00073"></a>00073   
<a name="l00074"></a>00074   <span class="comment">/*</span>
<a name="l00075"></a>00075 <span class="comment">   * @returns true iff the specified child is on the</span>
<a name="l00076"></a>00076 <span class="comment">   * specified side</span>
<a name="l00077"></a>00077 <span class="comment">   */</span>
<a name="l00078"></a>00078   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classTet.php#a2c80c1826be3754371addd3140af3bcf">is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00079"></a>00079                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00080"></a>00080   
<a name="l00086"></a>00086   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTet.php#ae8963e241ab0e3889cc1780c3346911e">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00087"></a>00087 
<a name="l00092"></a>00092   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> <a class="code" href="classTet.php#afc1a7c74de397806a9307b5f89b625fb">side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00093"></a>00093   
<a name="l00098"></a>00098   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classTet.php#a58f3f65f6f13103375d20ee4d0c2d5b0">quality</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) <span class="keyword">const</span>;
<a name="l00099"></a>00099 
<a name="l00105"></a>00105   std::pair&lt;Real, Real&gt; <a class="code" href="classTet.php#a5a13fb37731656c35d55ef152a808a05">qual_bounds</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) <span class="keyword">const</span>;
<a name="l00106"></a>00106   
<a name="l00107"></a>00107 };
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00112"></a>00112 <span class="comment">// Tet class member functions</span>
<a name="l00113"></a>00113 <span class="keyword">inline</span>
<a name="l00114"></a><a class="code" href="classTet.php#ab15467ce2856d11a8bb8be2389fb398b">00114</a> <a class="code" href="classTet.php#ab15467ce2856d11a8bb8be2389fb398b">Tet::Tet</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn, <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00115"></a>00115   <a class="code" href="classCell.php">Cell</a>(nn, <a class="code" href="classTet.php">Tet</a>::n_sides(), p) 
<a name="l00116"></a>00116 {
<a name="l00117"></a>00117 }
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
