<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_7059df55b9d3d0975f6468fedce13a55.php">partitioning</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>centroid_partitioner.C</h1>  </div>
</div>
<div class="contents">
<a href="centroid__partitioner_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: centroid_partitioner.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// C++ includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::sort</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;centroid_partitioner.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">//---------------------------------------------------------</span>
<a name="l00030"></a>00030 <span class="comment">// CentroidPartitioner methods</span>
<a name="l00031"></a><a class="code" href="classCentroidPartitioner.php#ac6ba838027367160a7e22967899c9f3e">00031</a> <span class="keywordtype">void</span> <a class="code" href="classCentroidPartitioner.php#ac6ba838027367160a7e22967899c9f3e">CentroidPartitioner::_do_partition</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00032"></a>00032                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034   <span class="comment">// Check for an easy return</span>
<a name="l00035"></a>00035   <span class="keywordflow">if</span> (n == 1)
<a name="l00036"></a>00036     {
<a name="l00037"></a>00037       this-&gt;<a class="code" href="classPartitioner.php#a1108dd58c055d536d489dc06cc0823ec">single_partition</a> (mesh);
<a name="l00038"></a>00038       <span class="keywordflow">return</span>;
<a name="l00039"></a>00039     }
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   <span class="comment">// Possibly reconstruct centroids</span>
<a name="l00043"></a>00043   <span class="keywordflow">if</span> (mesh.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>() != <a class="code" href="classCentroidPartitioner.php#abc3e691e2bcd90f1c584df4201a45e1f">_elem_centroids</a>.size())
<a name="l00044"></a>00044     this-&gt;<a class="code" href="classCentroidPartitioner.php#a3977a587ad161ca852d2583041fdb982">compute_centroids</a> (mesh);
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a>00047   
<a name="l00048"></a>00048   <span class="keywordflow">switch</span> (this-&gt;<a class="code" href="classCentroidPartitioner.php#a8fc29dfa48f0c5dff5d2697358f43f33">sort_method</a>())
<a name="l00049"></a>00049     {
<a name="l00050"></a>00050     <span class="keywordflow">case</span> <a class="code" href="classCentroidPartitioner.php#a8f27afb85a7bf4fb756e5c1a96de9b00a51b555f10e4b91a283cbf9a27685e726">X</a>:
<a name="l00051"></a>00051       {
<a name="l00052"></a>00052         std::sort(<a class="code" href="classCentroidPartitioner.php#abc3e691e2bcd90f1c584df4201a45e1f">_elem_centroids</a>.begin(),
<a name="l00053"></a>00053                   <a class="code" href="classCentroidPartitioner.php#abc3e691e2bcd90f1c584df4201a45e1f">_elem_centroids</a>.end(),
<a name="l00054"></a>00054                   <a class="code" href="classCentroidPartitioner.php#a1378aa2abe98f417b9281fd41033da97">CentroidPartitioner::sort_x</a>);
<a name="l00055"></a>00055         
<a name="l00056"></a>00056         <span class="keywordflow">break</span>;
<a name="l00057"></a>00057       }
<a name="l00058"></a>00058 
<a name="l00059"></a>00059       
<a name="l00060"></a>00060     <span class="keywordflow">case</span> <a class="code" href="classCentroidPartitioner.php#a8f27afb85a7bf4fb756e5c1a96de9b00a37ddc8d11af8ad391c96fd03bb5866db">Y</a>:
<a name="l00061"></a>00061       {
<a name="l00062"></a>00062         std::sort(<a class="code" href="classCentroidPartitioner.php#abc3e691e2bcd90f1c584df4201a45e1f">_elem_centroids</a>.begin(),
<a name="l00063"></a>00063                   <a class="code" href="classCentroidPartitioner.php#abc3e691e2bcd90f1c584df4201a45e1f">_elem_centroids</a>.end(),
<a name="l00064"></a>00064                   <a class="code" href="classCentroidPartitioner.php#a784c0b2a1330202e1752ce1f90086e9a">CentroidPartitioner::sort_y</a>);
<a name="l00065"></a>00065         
<a name="l00066"></a>00066         <span class="keywordflow">break</span>;
<a name="l00067"></a>00067         
<a name="l00068"></a>00068       }
<a name="l00069"></a>00069 
<a name="l00070"></a>00070       
<a name="l00071"></a>00071     <span class="keywordflow">case</span> <a class="code" href="classCentroidPartitioner.php#a8f27afb85a7bf4fb756e5c1a96de9b00a92c0216244d240d508c634d89a36bed8">Z</a>:
<a name="l00072"></a>00072       {
<a name="l00073"></a>00073         std::sort(<a class="code" href="classCentroidPartitioner.php#abc3e691e2bcd90f1c584df4201a45e1f">_elem_centroids</a>.begin(),
<a name="l00074"></a>00074                   <a class="code" href="classCentroidPartitioner.php#abc3e691e2bcd90f1c584df4201a45e1f">_elem_centroids</a>.end(),
<a name="l00075"></a>00075                   <a class="code" href="classCentroidPartitioner.php#a3dda5ad9d4c7ea4dd43f9ea88bb2251e">CentroidPartitioner::sort_z</a>);
<a name="l00076"></a>00076         
<a name="l00077"></a>00077         <span class="keywordflow">break</span>;
<a name="l00078"></a>00078       }
<a name="l00079"></a>00079 
<a name="l00080"></a>00080       
<a name="l00081"></a>00081      <span class="keywordflow">case</span> <a class="code" href="classCentroidPartitioner.php#a8f27afb85a7bf4fb756e5c1a96de9b00a718c91717de62e2f6e69305a3116324b">RADIAL</a>:
<a name="l00082"></a>00082       {
<a name="l00083"></a>00083         std::sort(<a class="code" href="classCentroidPartitioner.php#abc3e691e2bcd90f1c584df4201a45e1f">_elem_centroids</a>.begin(),
<a name="l00084"></a>00084                   <a class="code" href="classCentroidPartitioner.php#abc3e691e2bcd90f1c584df4201a45e1f">_elem_centroids</a>.end(),
<a name="l00085"></a>00085                   <a class="code" href="classCentroidPartitioner.php#a3612197cde5a8048b5c8673b67482588">CentroidPartitioner::sort_radial</a>);
<a name="l00086"></a>00086         
<a name="l00087"></a>00087         <span class="keywordflow">break</span>;
<a name="l00088"></a>00088       } 
<a name="l00089"></a>00089     <span class="keywordflow">default</span>:
<a name="l00090"></a>00090       libmesh_error();
<a name="l00091"></a>00091     }
<a name="l00092"></a>00092 
<a name="l00093"></a>00093   
<a name="l00094"></a>00094   <span class="comment">// Make sure the user has not handed us an</span>
<a name="l00095"></a>00095   <span class="comment">// invalid number of partitions.</span>
<a name="l00096"></a>00096   libmesh_assert (n &gt; 0);
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   <span class="comment">// the number of elements, e.g. 1000</span>
<a name="l00099"></a>00099   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a337ed123c95f0ba57b665456c413db4b">n_elem</a>      = mesh.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>();
<a name="l00100"></a>00100   <span class="comment">// the number of elements per processor, e.g 400</span>
<a name="l00101"></a>00101   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> target_size = n_elem / n;
<a name="l00102"></a>00102 
<a name="l00103"></a>00103   <span class="comment">// Make sure the mesh hasn&#39;t changed since the</span>
<a name="l00104"></a>00104   <span class="comment">// last time we computed the centroids.</span>
<a name="l00105"></a>00105   libmesh_assert (mesh.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>() == <a class="code" href="classCentroidPartitioner.php#abc3e691e2bcd90f1c584df4201a45e1f">_elem_centroids</a>.size());
<a name="l00106"></a>00106 
<a name="l00107"></a>00107   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="namespaceMeshTools.php#a337ed123c95f0ba57b665456c413db4b">n_elem</a>; i++)
<a name="l00108"></a>00108     {
<a name="l00109"></a>00109       <a class="code" href="classElem.php">Elem</a>* elem = <a class="code" href="classCentroidPartitioner.php#abc3e691e2bcd90f1c584df4201a45e1f">_elem_centroids</a>[i].second;
<a name="l00110"></a>00110 
<a name="l00111"></a>00111       elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a> (i / target_size, n-1);
<a name="l00112"></a>00112     }   
<a name="l00113"></a>00113 }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a><a class="code" href="classCentroidPartitioner.php#a3977a587ad161ca852d2583041fdb982">00122</a> <span class="keywordtype">void</span> <a class="code" href="classCentroidPartitioner.php#a3977a587ad161ca852d2583041fdb982">CentroidPartitioner::compute_centroids</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh)
<a name="l00123"></a>00123 {
<a name="l00124"></a>00124   <a class="code" href="classCentroidPartitioner.php#abc3e691e2bcd90f1c584df4201a45e1f">_elem_centroids</a>.clear();
<a name="l00125"></a>00125   <a class="code" href="classCentroidPartitioner.php#abc3e691e2bcd90f1c584df4201a45e1f">_elem_centroids</a>.reserve(mesh.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>());
<a name="l00126"></a>00126   
<a name="l00127"></a>00127 <span class="comment">//   elem_iterator it(mesh.elements_begin());</span>
<a name="l00128"></a>00128 <span class="comment">//   const elem_iterator it_end(mesh.elements_end());</span>
<a name="l00129"></a>00129 
<a name="l00130"></a>00130   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       it     = mesh.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00131"></a>00131   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> it_end = mesh.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>(); 
<a name="l00132"></a>00132 
<a name="l00133"></a>00133   <span class="keywordflow">for</span> (; it != it_end; ++it)
<a name="l00134"></a>00134     {
<a name="l00135"></a>00135       <a class="code" href="classElem.php">Elem</a>* elem = *it;
<a name="l00136"></a>00136 
<a name="l00137"></a>00137       <a class="code" href="classCentroidPartitioner.php#abc3e691e2bcd90f1c584df4201a45e1f">_elem_centroids</a>.push_back(std::make_pair(elem-&gt;<a class="code" href="classElem.php#a46ce080150f08ce9d367b69f16dd0452">centroid</a>(), elem));
<a name="l00138"></a>00138     }
<a name="l00139"></a>00139 }
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a><a class="code" href="classCentroidPartitioner.php#a1378aa2abe98f417b9281fd41033da97">00144</a> <span class="keywordtype">bool</span> <a class="code" href="classCentroidPartitioner.php#a1378aa2abe98f417b9281fd41033da97">CentroidPartitioner::sort_x</a> (<span class="keyword">const</span> std::pair&lt;Point, Elem*&gt;&amp; lhs,
<a name="l00145"></a>00145                                   <span class="keyword">const</span> std::pair&lt;Point, Elem*&gt;&amp; rhs)
<a name="l00146"></a>00146 {
<a name="l00147"></a>00147   <span class="keywordflow">return</span> (lhs.first(0) &lt; rhs.first(0));
<a name="l00148"></a>00148 }
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 
<a name="l00153"></a><a class="code" href="classCentroidPartitioner.php#a784c0b2a1330202e1752ce1f90086e9a">00153</a> <span class="keywordtype">bool</span> <a class="code" href="classCentroidPartitioner.php#a784c0b2a1330202e1752ce1f90086e9a">CentroidPartitioner::sort_y</a> (<span class="keyword">const</span> std::pair&lt;Point, Elem*&gt;&amp; lhs,
<a name="l00154"></a>00154                                   <span class="keyword">const</span> std::pair&lt;Point, Elem*&gt;&amp; rhs)
<a name="l00155"></a>00155 {
<a name="l00156"></a>00156   <span class="keywordflow">return</span> (lhs.first(1) &lt; rhs.first(1));
<a name="l00157"></a>00157 }
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 
<a name="l00163"></a><a class="code" href="classCentroidPartitioner.php#a3dda5ad9d4c7ea4dd43f9ea88bb2251e">00163</a> <span class="keywordtype">bool</span> <a class="code" href="classCentroidPartitioner.php#a3dda5ad9d4c7ea4dd43f9ea88bb2251e">CentroidPartitioner::sort_z</a> (<span class="keyword">const</span> std::pair&lt;Point, Elem*&gt;&amp; lhs,
<a name="l00164"></a>00164                                   <span class="keyword">const</span> std::pair&lt;Point, Elem*&gt;&amp; rhs)
<a name="l00165"></a>00165 {
<a name="l00166"></a>00166   <span class="keywordflow">return</span> (lhs.first(2) &lt; rhs.first(2));
<a name="l00167"></a>00167 }
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00171"></a><a class="code" href="classCentroidPartitioner.php#a3612197cde5a8048b5c8673b67482588">00171</a> <span class="keywordtype">bool</span> <a class="code" href="classCentroidPartitioner.php#a3612197cde5a8048b5c8673b67482588">CentroidPartitioner::sort_radial</a> (<span class="keyword">const</span> std::pair&lt;Point, Elem*&gt;&amp; lhs,
<a name="l00172"></a>00172                                        <span class="keyword">const</span> std::pair&lt;Point, Elem*&gt;&amp; rhs)
<a name="l00173"></a>00173 {
<a name="l00174"></a>00174   <span class="keywordflow">return</span> (lhs.first.size() &lt; rhs.first.size());
<a name="l00175"></a>00175 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
