<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c614ad117abf49b5c733d084008febbb.php">partitioning</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>centroid_partitioner.h</h1>  </div>
</div>
<div class="contents">
<a href="centroid__partitioner_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: centroid_partitioner.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __centroid_partitioner_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __centroid_partitioner_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// C++ includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;utility&gt;</span> <span class="comment">// pair</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="partitioner_8h.php">partitioner.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;point.h&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Forward declarations</span>
<a name="l00034"></a>00034 <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00050"></a>00050 <span class="comment">// CentroidPartitioner class definition</span>
<a name="l00051"></a><a class="code" href="classCentroidPartitioner.php">00051</a> <span class="keyword">class </span><a class="code" href="classCentroidPartitioner.php">CentroidPartitioner</a> : <span class="keyword">public</span> <a class="code" href="classPartitioner.php">Partitioner</a>
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053 <span class="keyword">public</span>:
<a name="l00054"></a>00054 
<a name="l00055"></a>00055   
<a name="l00061"></a><a class="code" href="classCentroidPartitioner.php#a8f27afb85a7bf4fb756e5c1a96de9b00a51b555f10e4b91a283cbf9a27685e726">00061</a>   <span class="keyword">enum</span> <a class="code" href="classCentroidPartitioner.php#a8f27afb85a7bf4fb756e5c1a96de9b00">CentroidSortMethod</a> {<a class="code" href="classCentroidPartitioner.php#a8f27afb85a7bf4fb756e5c1a96de9b00a51b555f10e4b91a283cbf9a27685e726">X</a>=0,
<a name="l00062"></a><a class="code" href="classCentroidPartitioner.php#a8f27afb85a7bf4fb756e5c1a96de9b00a37ddc8d11af8ad391c96fd03bb5866db">00062</a>                            <a class="code" href="classCentroidPartitioner.php#a8f27afb85a7bf4fb756e5c1a96de9b00a37ddc8d11af8ad391c96fd03bb5866db">Y</a>,
<a name="l00063"></a><a class="code" href="classCentroidPartitioner.php#a8f27afb85a7bf4fb756e5c1a96de9b00a92c0216244d240d508c634d89a36bed8">00063</a>                            <a class="code" href="classCentroidPartitioner.php#a8f27afb85a7bf4fb756e5c1a96de9b00a92c0216244d240d508c634d89a36bed8">Z</a>,
<a name="l00064"></a><a class="code" href="classCentroidPartitioner.php#a8f27afb85a7bf4fb756e5c1a96de9b00a718c91717de62e2f6e69305a3116324b">00064</a>                            <a class="code" href="classCentroidPartitioner.php#a8f27afb85a7bf4fb756e5c1a96de9b00a718c91717de62e2f6e69305a3116324b">RADIAL</a>,
<a name="l00065"></a><a class="code" href="classCentroidPartitioner.php#a8f27afb85a7bf4fb756e5c1a96de9b00a7b45a752ab47f01837dc6296e5c492d2">00065</a>                            <a class="code" href="classCentroidPartitioner.php#a8f27afb85a7bf4fb756e5c1a96de9b00a7b45a752ab47f01837dc6296e5c492d2">INVALID_METHOD</a>};
<a name="l00066"></a>00066 
<a name="l00071"></a><a class="code" href="classCentroidPartitioner.php#af48fd6c35d070c68a658b1bf895d1d2d">00071</a>   <a class="code" href="classCentroidPartitioner.php#af48fd6c35d070c68a658b1bf895d1d2d">CentroidPartitioner</a> (<span class="keyword">const</span> <a class="code" href="classCentroidPartitioner.php#a8f27afb85a7bf4fb756e5c1a96de9b00">CentroidSortMethod</a> sm=<a class="code" href="classCentroidPartitioner.php#a8f27afb85a7bf4fb756e5c1a96de9b00a51b555f10e4b91a283cbf9a27685e726">X</a>) : <a class="code" href="classCentroidPartitioner.php#a9d32404d525013ec01219995ea9d73d8">_sort_method</a>(sm) {}
<a name="l00072"></a>00072 
<a name="l00077"></a><a class="code" href="classCentroidPartitioner.php#abc1121c21837a0a624aeba181b01b9eb">00077</a>   <span class="keyword">virtual</span> <a class="code" href="classAutoPtr.php">AutoPtr&lt;Partitioner&gt;</a> <a class="code" href="classCentroidPartitioner.php#abc1121c21837a0a624aeba181b01b9eb">clone</a> ()<span class="keyword"> const </span>{
<a name="l00078"></a>00078     <a class="code" href="classAutoPtr.php">AutoPtr&lt;Partitioner&gt;</a> cloned_partitioner
<a name="l00079"></a>00079       (<span class="keyword">new</span> <a class="code" href="classCentroidPartitioner.php#af48fd6c35d070c68a658b1bf895d1d2d">CentroidPartitioner</a>(<a class="code" href="classCentroidPartitioner.php#a8fc29dfa48f0c5dff5d2697358f43f33">sort_method</a>()));
<a name="l00080"></a>00080     <span class="keywordflow">return</span> cloned_partitioner;
<a name="l00081"></a>00081   }
<a name="l00082"></a>00082 
<a name="l00086"></a><a class="code" href="classCentroidPartitioner.php#a8fc29dfa48f0c5dff5d2697358f43f33">00086</a>   <a class="code" href="classCentroidPartitioner.php#a8f27afb85a7bf4fb756e5c1a96de9b00">CentroidSortMethod</a> <a class="code" href="classCentroidPartitioner.php#a8fc29dfa48f0c5dff5d2697358f43f33">sort_method</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classCentroidPartitioner.php#a9d32404d525013ec01219995ea9d73d8">_sort_method</a>; }
<a name="l00087"></a>00087 
<a name="l00091"></a><a class="code" href="classCentroidPartitioner.php#a2e5797fa0fe76986892863a3a3393ca5">00091</a>   <span class="keywordtype">void</span> <a class="code" href="classCentroidPartitioner.php#a2e5797fa0fe76986892863a3a3393ca5">set_sort_method</a> (<span class="keyword">const</span> <a class="code" href="classCentroidPartitioner.php#a8f27afb85a7bf4fb756e5c1a96de9b00">CentroidSortMethod</a> sm) {<a class="code" href="classCentroidPartitioner.php#a9d32404d525013ec01219995ea9d73d8">_sort_method</a> = sm; }
<a name="l00092"></a>00092 
<a name="l00093"></a>00093   
<a name="l00094"></a>00094 <span class="keyword">protected</span>:
<a name="l00099"></a>00099   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classCentroidPartitioner.php#ac6ba838027367160a7e22967899c9f3e">_do_partition</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00100"></a>00100                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 <span class="keyword">private</span>:
<a name="l00103"></a>00103 
<a name="l00109"></a>00109   <span class="keywordtype">void</span> <a class="code" href="classCentroidPartitioner.php#a3977a587ad161ca852d2583041fdb982">compute_centroids</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00110"></a>00110 
<a name="l00117"></a>00117   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classCentroidPartitioner.php#a1378aa2abe98f417b9281fd41033da97">sort_x</a> (<span class="keyword">const</span> std::pair&lt;Point, Elem*&gt;&amp; lhs,
<a name="l00118"></a>00118                       <span class="keyword">const</span> std::pair&lt;Point, Elem*&gt;&amp; rhs);
<a name="l00119"></a>00119 
<a name="l00126"></a>00126   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classCentroidPartitioner.php#a784c0b2a1330202e1752ce1f90086e9a">sort_y</a> (<span class="keyword">const</span> std::pair&lt;Point, Elem*&gt;&amp; lhs,
<a name="l00127"></a>00127                       <span class="keyword">const</span> std::pair&lt;Point, Elem*&gt;&amp; rhs);
<a name="l00128"></a>00128 
<a name="l00135"></a>00135   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classCentroidPartitioner.php#a3dda5ad9d4c7ea4dd43f9ea88bb2251e">sort_z</a> (<span class="keyword">const</span> std::pair&lt;Point, Elem*&gt;&amp; lhs,
<a name="l00136"></a>00136                       <span class="keyword">const</span> std::pair&lt;Point, Elem*&gt;&amp; rhs);
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   
<a name="l00145"></a>00145   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classCentroidPartitioner.php#a3612197cde5a8048b5c8673b67482588">sort_radial</a> (<span class="keyword">const</span> std::pair&lt;Point, Elem*&gt;&amp; lhs,
<a name="l00146"></a>00146                            <span class="keyword">const</span> std::pair&lt;Point, Elem*&gt;&amp; rhs);
<a name="l00147"></a>00147 
<a name="l00152"></a><a class="code" href="classCentroidPartitioner.php#a9d32404d525013ec01219995ea9d73d8">00152</a>   <a class="code" href="classCentroidPartitioner.php#a8f27afb85a7bf4fb756e5c1a96de9b00">CentroidSortMethod</a> <a class="code" href="classCentroidPartitioner.php#a9d32404d525013ec01219995ea9d73d8">_sort_method</a>;
<a name="l00153"></a>00153 
<a name="l00158"></a><a class="code" href="classCentroidPartitioner.php#abc3e691e2bcd90f1c584df4201a45e1f">00158</a>   std::vector&lt;std::pair&lt;Point, Elem*&gt; &gt; <a class="code" href="classCentroidPartitioner.php#abc3e691e2bcd90f1c584df4201a45e1f">_elem_centroids</a>;
<a name="l00159"></a>00159 };
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
