<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.php"><span>Classes</span></a></li>
      <li><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.php"><span>Class&#160;List</span></a></li>
      <li><a href="classes.php"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.php"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.php"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a>  </div>
  <div class="headertitle">
<h1>CouplingMatrix Class Reference</h1>  </div>
</div>
<div class="contents">
<!-- doxytag: class="CouplingMatrix" -->
<p><code>#include &lt;<a class="el" href="coupling__matrix_8h_source.php">coupling_matrix.h</a>&gt;</code></p>

<p><a href="classCouplingMatrix-members.php">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCouplingMatrix.php#a27461cd0e280757b87b97f4051f419f6">CouplingMatrix</a> (const unsigned int n=0)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCouplingMatrix.php#a50d7daefb61625abc6f03782ab138070">operator()</a> (const unsigned int i, const unsigned int j) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned char &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCouplingMatrix.php#a65795b99e2b1c8b4bf1080021a680856">operator()</a> (const unsigned int i, const unsigned int j)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCouplingMatrix.php#a873ea83161bff58bc9f4b5ff771500ea">size</a> () const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCouplingMatrix.php#a4e4d272c9773d38902de9a9068ca6229">resize</a> (const unsigned int n)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCouplingMatrix.php#aa0f80d14dabd7a4dba808b4b0ed3cf0a">clear</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCouplingMatrix.php#aed22bc105cd6bd1925ebbdc1e833848e">empty</a> () const </td></tr>
<tr><td colspan="2"><h2><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">std::vector&lt; unsigned char &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCouplingMatrix.php#a76d27153a0a07a0a55052d310a86f7e6">_values</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a></td></tr>
</table>
<hr/><a name="_details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This class defines a coupling matrix. A coupling matrix is simply a matrix of ones and zeros describing how different components in a system couple with each other. A coupling matrix is necessarily square but not necessarily symmetric. </p>

<p>Definition at line <a class="el" href="coupling__matrix_8h_source.php#l00041">41</a> of file <a class="el" href="coupling__matrix_8h_source.php">coupling_matrix.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a27461cd0e280757b87b97f4051f419f6"></a><!-- doxytag: member="CouplingMatrix::CouplingMatrix" ref="a27461cd0e280757b87b97f4051f419f6" args="(const unsigned int n=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CouplingMatrix::CouplingMatrix </td>
          <td>(</td>
          <td class="paramtype">const unsigned int&#160;</td>
          <td class="paramname"><em>n</em> = <code>0</code></td><td>)</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Constructor. </p>

<p>Definition at line <a class="el" href="coupling__matrix_8h_source.php#l00109">109</a> of file <a class="el" href="coupling__matrix_8h_source.php">coupling_matrix.h</a>.</p>

<p>References <a class="el" href="coupling__matrix_8h_source.php#l00150">resize()</a>.</p>
<div class="fragment"><pre class="fragment">                                                    :
  <a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a>(n)
{
  this-&gt;<a class="code" href="classCouplingMatrix.php#a4e4d272c9773d38902de9a9068ca6229">resize</a>(n);
}
</pre></div>
</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="aa0f80d14dabd7a4dba808b4b0ed3cf0a"></a><!-- doxytag: member="CouplingMatrix::clear" ref="aa0f80d14dabd7a4dba808b4b0ed3cf0a" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void CouplingMatrix::clear </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Clears the matrix. </p>

<p>Definition at line <a class="el" href="coupling__matrix_8h_source.php#l00163">163</a> of file <a class="el" href="coupling__matrix_8h_source.php">coupling_matrix.h</a>.</p>

<p>References <a class="el" href="coupling__matrix_8h_source.php#l00098">_size</a>, and <a class="el" href="coupling__matrix_8h_source.php#l00093">_values</a>.</p>
<div class="fragment"><pre class="fragment">{
  <a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a> = 0;

  <a class="code" href="classCouplingMatrix.php#a76d27153a0a07a0a55052d310a86f7e6">_values</a>.clear();
}
</pre></div>
</div>
</div>
<a class="anchor" id="aed22bc105cd6bd1925ebbdc1e833848e"></a><!-- doxytag: member="CouplingMatrix::empty" ref="aed22bc105cd6bd1925ebbdc1e833848e" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool CouplingMatrix::empty </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl class="return"><dt><b>Returns:</b></dt><dd>true if the matrix is empty. </dd></dl>

<p>Definition at line <a class="el" href="coupling__matrix_8h_source.php#l00173">173</a> of file <a class="el" href="coupling__matrix_8h_source.php">coupling_matrix.h</a>.</p>

<p>References <a class="el" href="coupling__matrix_8h_source.php#l00098">_size</a>.</p>

<p>Referenced by <a class="el" href="dof__map_8C_source.php#l01814">SparsityPattern::Build::operator()()</a>.</p>
<div class="fragment"><pre class="fragment">{
  <span class="keywordflow">return</span> (<a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a> == 0);
}
</pre></div>
</div>
</div>
<a class="anchor" id="a65795b99e2b1c8b4bf1080021a680856"></a><!-- doxytag: member="CouplingMatrix::operator()" ref="a65795b99e2b1c8b4bf1080021a680856" args="(const unsigned int i, const unsigned int j)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned char &amp; CouplingMatrix::operator() </td>
          <td>(</td>
          <td class="paramtype">const unsigned int&#160;</td>
          <td class="paramname"><em>i</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const unsigned int&#160;</td>
          <td class="paramname"><em>j</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl class="return"><dt><b>Returns:</b></dt><dd>the (i,j) entry of the matrix as a writeable reference. </dd></dl>

<p>Definition at line <a class="el" href="coupling__matrix_8h_source.php#l00130">130</a> of file <a class="el" href="coupling__matrix_8h_source.php">coupling_matrix.h</a>.</p>

<p>References <a class="el" href="coupling__matrix_8h_source.php#l00098">_size</a>, and <a class="el" href="coupling__matrix_8h_source.php#l00093">_values</a>.</p>
<div class="fragment"><pre class="fragment">{
  libmesh_assert (i &lt; <a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a>);
  libmesh_assert (j &lt; <a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a>);

  <span class="keywordflow">return</span> <a class="code" href="classCouplingMatrix.php#a76d27153a0a07a0a55052d310a86f7e6">_values</a>[i*<a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a> + j];
}
</pre></div>
</div>
</div>
<a class="anchor" id="a50d7daefb61625abc6f03782ab138070"></a><!-- doxytag: member="CouplingMatrix::operator()" ref="a50d7daefb61625abc6f03782ab138070" args="(const unsigned int i, const unsigned int j) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned char CouplingMatrix::operator() </td>
          <td>(</td>
          <td class="paramtype">const unsigned int&#160;</td>
          <td class="paramname"><em>i</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const unsigned int&#160;</td>
          <td class="paramname"><em>j</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const<code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl class="return"><dt><b>Returns:</b></dt><dd>the (i,j) entry of the matrix. </dd></dl>

<p>Definition at line <a class="el" href="coupling__matrix_8h_source.php#l00118">118</a> of file <a class="el" href="coupling__matrix_8h_source.php">coupling_matrix.h</a>.</p>

<p>References <a class="el" href="coupling__matrix_8h_source.php#l00098">_size</a>, and <a class="el" href="coupling__matrix_8h_source.php#l00093">_values</a>.</p>
<div class="fragment"><pre class="fragment">{
  libmesh_assert (i &lt; <a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a>);
  libmesh_assert (j &lt; <a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a>);

  <span class="keywordflow">return</span> <a class="code" href="classCouplingMatrix.php#a76d27153a0a07a0a55052d310a86f7e6">_values</a>[i*<a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a> + j];
}
</pre></div>
</div>
</div>
<a class="anchor" id="a4e4d272c9773d38902de9a9068ca6229"></a><!-- doxytag: member="CouplingMatrix::resize" ref="a4e4d272c9773d38902de9a9068ca6229" args="(const unsigned int n)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void CouplingMatrix::resize </td>
          <td>(</td>
          <td class="paramtype">const unsigned int&#160;</td>
          <td class="paramname"><em>n</em></td><td>)</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Resizes the matrix and initializes all entries to be 0. </p>

<p>Definition at line <a class="el" href="coupling__matrix_8h_source.php#l00150">150</a> of file <a class="el" href="coupling__matrix_8h_source.php">coupling_matrix.h</a>.</p>

<p>References <a class="el" href="coupling__matrix_8h_source.php#l00098">_size</a>, and <a class="el" href="coupling__matrix_8h_source.php#l00093">_values</a>.</p>

<p>Referenced by <a class="el" href="coupling__matrix_8h_source.php#l00109">CouplingMatrix()</a>.</p>
<div class="fragment"><pre class="fragment">{
  <a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a> = n;

  <a class="code" href="classCouplingMatrix.php#a76d27153a0a07a0a55052d310a86f7e6">_values</a>.resize(<a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a>*<a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a>);

  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classCouplingMatrix.php#a76d27153a0a07a0a55052d310a86f7e6">_values</a>.size(); i++)
    <a class="code" href="classCouplingMatrix.php#a76d27153a0a07a0a55052d310a86f7e6">_values</a>[i] = 0;
}
</pre></div>
</div>
</div>
<a class="anchor" id="a873ea83161bff58bc9f4b5ff771500ea"></a><!-- doxytag: member="CouplingMatrix::size" ref="a873ea83161bff58bc9f4b5ff771500ea" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int CouplingMatrix::size </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl class="return"><dt><b>Returns:</b></dt><dd>the size of the matrix, i.e. N for an NxN matrix. </dd></dl>

<p>Definition at line <a class="el" href="coupling__matrix_8h_source.php#l00142">142</a> of file <a class="el" href="coupling__matrix_8h_source.php">coupling_matrix.h</a>.</p>

<p>References <a class="el" href="coupling__matrix_8h_source.php#l00098">_size</a>.</p>

<p>Referenced by <a class="el" href="dof__map_8C_source.php#l01814">SparsityPattern::Build::operator()()</a>.</p>
<div class="fragment"><pre class="fragment">{
  <span class="keywordflow">return</span> <a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a>;
}
</pre></div>
</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="ae04509ff743b77bceb1ee7212223e16c"></a><!-- doxytag: member="CouplingMatrix::_size" ref="ae04509ff743b77bceb1ee7212223e16c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int <a class="el" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">CouplingMatrix::_size</a><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>The size of the matrix. </p>

<p>Definition at line <a class="el" href="coupling__matrix_8h_source.php#l00098">98</a> of file <a class="el" href="coupling__matrix_8h_source.php">coupling_matrix.h</a>.</p>

<p>Referenced by <a class="el" href="coupling__matrix_8h_source.php#l00163">clear()</a>, <a class="el" href="coupling__matrix_8h_source.php#l00173">empty()</a>, <a class="el" href="coupling__matrix_8h_source.php#l00118">operator()()</a>, <a class="el" href="coupling__matrix_8h_source.php#l00150">resize()</a>, and <a class="el" href="coupling__matrix_8h_source.php#l00142">size()</a>.</p>

</div>
</div>
<a class="anchor" id="a76d27153a0a07a0a55052d310a86f7e6"></a><!-- doxytag: member="CouplingMatrix::_values" ref="a76d27153a0a07a0a55052d310a86f7e6" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;unsigned char&gt; <a class="el" href="classCouplingMatrix.php#a76d27153a0a07a0a55052d310a86f7e6">CouplingMatrix::_values</a><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>The actual matrix values. These are stored as unsigned chars because a vector of bools is not what you think. </p>

<p>Definition at line <a class="el" href="coupling__matrix_8h_source.php#l00093">93</a> of file <a class="el" href="coupling__matrix_8h_source.php">coupling_matrix.h</a>.</p>

<p>Referenced by <a class="el" href="coupling__matrix_8h_source.php#l00163">clear()</a>, <a class="el" href="coupling__matrix_8h_source.php#l00118">operator()()</a>, and <a class="el" href="coupling__matrix_8h_source.php#l00150">resize()</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="coupling__matrix_8h_source.php">coupling_matrix.h</a></li>
</ul>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
