<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.php"><span>Classes</span></a></li>
      <li><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.php"><span>Class&#160;List</span></a></li>
      <li><a href="classes.php"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.php"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.php"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a>  </div>
  <div class="headertitle">
<h1>FroIO Class Reference</h1>  </div>
</div>
<div class="contents">
<!-- doxytag: class="FroIO" --><!-- doxytag: inherits="MeshOutput&lt; MeshBase &gt;" -->
<p><code>#include &lt;<a class="el" href="fro__io_8h_source.php">fro_io.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for FroIO:</div>
<div class="dyncontent">
<div class="center"><img src="classFroIO__inherit__graph.png" border="0" usemap="#FroIO_inherit__map" alt="Inheritance graph"/></div>
<map name="FroIO_inherit__map" id="FroIO_inherit__map">
<area shape="rect" id="node2" href="classMeshOutput.php" title="MeshOutput\&lt; MeshBase \&gt;" alt="" coords="5,5,200,35"/></map>
<center><span class="legend">[<a href="graph_legend.php">legend</a>]</span></center></div>

<p><a href="classFroIO-members.php">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFroIO.php#a3633960f65073811cf74ee34c01506e4">FroIO</a> (const <a class="el" href="classMeshBase.php">MeshBase</a> &amp;)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFroIO.php#aae64762a1ea4411677d4a1e8231e37f0">write</a> (const std::string &amp;)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMeshOutput.php#a5e0df1f5cd00cc7ae3cbe73e6a68fe0e">write_equation_systems</a> (const std::string &amp;, const <a class="el" href="classEquationSystems.php">EquationSystems</a> &amp;)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMeshOutput.php#a8365780c326915d5da092628a3e85038">write_nodal_data</a> (const std::string &amp;, const std::vector&lt; <a class="el" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> &gt; &amp;, const std::vector&lt; std::string &gt; &amp;)</td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const <a class="el" href="classMeshBase.php">MeshBase</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMeshOutput.php#af923657f1dcc7c26a973332295d94f13">mesh</a> () const</td></tr>
</table>
<hr/><a name="_details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This class implements writing meshes in the .fro format used by the MIT ACDL. Valid only for triangular meshes.</p>
<dl class="author"><dt><b>Author:</b></dt><dd>Benjamin S. Kirk, 2007 </dd></dl>

<p>Definition at line <a class="el" href="fro__io_8h_source.php#l00043">43</a> of file <a class="el" href="fro__io_8h_source.php">fro_io.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a3633960f65073811cf74ee34c01506e4"></a><!-- doxytag: member="FroIO::FroIO" ref="a3633960f65073811cf74ee34c01506e4" args="(const MeshBase &amp;)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">FroIO::FroIO </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classMeshBase.php">MeshBase</a> &amp;&#160;</td>
          <td class="paramname"><em>mesh</em></td><td>)</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Constructor. Takes a reference to a constant mesh object. This constructor will only allow us to write the mesh. </p>

<p>Definition at line <a class="el" href="fro__io_8h_source.php#l00068">68</a> of file <a class="el" href="fro__io_8h_source.php">fro_io.h</a>.</p>
<div class="fragment"><pre class="fragment">                                  :
  <a class="code" href="classMeshOutput.php">MeshOutput&lt;MeshBase&gt;</a> (<a class="code" href="classMeshOutput.php#af923657f1dcc7c26a973332295d94f13">mesh</a>)
{
}
</pre></div>
</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="af923657f1dcc7c26a973332295d94f13"></a><!-- doxytag: member="FroIO::mesh" ref="af923657f1dcc7c26a973332295d94f13" args="() const" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classMeshBase.php">MeshBase</a> &amp; <a class="el" href="classMeshOutput.php">MeshOutput</a>&lt; <a class="el" href="classMeshBase.php">MeshBase</a>  &gt;::mesh </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Returns the object as a read-only reference. </p>

<p>Referenced by <a class="el" href="postscript__io_8C_source.php#l00067">PostscriptIO::write()</a>, <a class="el" href="fro__io_8C_source.php#l00038">write()</a>, <a class="el" href="medit__io_8C_source.php#l00055">MEDITIO::write_ascii()</a>, <a class="el" href="ensight__io_8C_source.php#l00138">EnsightIO::write_geometry_ascii()</a>, <a class="el" href="ensight__io_8C_source.php#l00346">EnsightIO::write_scalar_ascii()</a>, <a class="el" href="gnuplot__io_8C_source.php#l00061">GnuPlotIO::write_solution()</a>, <a class="el" href="diva__io_8C_source.php#l00048">DivaIO::write_stream()</a>, and <a class="el" href="ensight__io_8C_source.php#l00425">EnsightIO::write_vector_ascii()</a>.</p>

</div>
</div>
<a class="anchor" id="aae64762a1ea4411677d4a1e8231e37f0"></a><!-- doxytag: member="FroIO::write" ref="aae64762a1ea4411677d4a1e8231e37f0" args="(const std::string &amp;)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void FroIO::write </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>fname</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>This method implements writing a mesh to a specified file. </p>

<p>Implements <a class="el" href="classMeshOutput.php#acffc6928a8a14b6b51fe1d3649d6d3f8">MeshOutput&lt; MeshBase &gt;</a>.</p>

<p>Definition at line <a class="el" href="fro__io_8C_source.php#l00038">38</a> of file <a class="el" href="fro__io_8C_source.php">fro_io.C</a>.</p>

<p>References <a class="el" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">MeshBase::active_elements_begin()</a>, <a class="el" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">MeshBase::active_elements_end()</a>, <a class="el" href="mesh__base_8h_source.php#l00098">MeshBase::boundary_info</a>, <a class="el" href="classElem.php#a554c146bcfb5537636bd77a157f21b85">Elem::build_side()</a>, <a class="el" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">MeshBase::elem()</a>, <a class="el" href="classMeshOutput.php#af923657f1dcc7c26a973332295d94f13">MeshOutput&lt; MeshBase &gt;::mesh()</a>, <a class="el" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">MeshBase::n_elem()</a>, <a class="el" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">MeshBase::n_nodes()</a>, <a class="el" href="classMeshBase.php#a06af1f178519c606d0bdca7857f95ba6">MeshBase::point()</a>, <a class="el" href="libmesh__base_8h_source.php#l00088">libMesh::processor_id()</a>, and <a class="el" href="enum__elem__type_8h_source.php#l00041">libMeshEnums::TRI3</a>.</p>

<p>Referenced by <a class="el" href="unstructured__mesh_8C_source.php#l00637">UnstructuredMesh::write()</a>.</p>
<div class="fragment"><pre class="fragment">{
  <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
    {
      <span class="comment">// Open the output file stream</span>
      std::ofstream out (fname.c_str());
      libmesh_assert (out.good());

      <span class="comment">// Make sure it opened correctly</span>
      <span class="keywordflow">if</span> (!out.good())
        libmesh_file_error(fname.c_str());

      <span class="comment">// Get a reference to the mesh</span>
      <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshOutput.php#af923657f1dcc7c26a973332295d94f13">mesh</a> = <a class="code" href="classMeshOutput.php#af923657f1dcc7c26a973332295d94f13">MeshOutput&lt;MeshBase&gt;::mesh</a>();

      <span class="comment">// Write the header</span>
      out &lt;&lt; mesh.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>()  &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
          &lt;&lt; mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>() &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
          &lt;&lt; <span class="stringliteral">&quot;0 0 &quot;</span>
          &lt;&lt; mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;n_boundary_ids()  &lt;&lt; <span class="stringliteral">&quot; 1\n&quot;</span>;

      <span class="comment">// Write the nodes -- 1-based!</span>
      <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>(); n++)
        out &lt;&lt; n+1 &lt;&lt; <span class="stringliteral">&quot; \t&quot;</span>
            &lt;&lt; std::scientific
            &lt;&lt; std::setprecision(12)
            &lt;&lt; mesh.<a class="code" href="classMeshBase.php#a06af1f178519c606d0bdca7857f95ba6">point</a>(n)(0) &lt;&lt; <span class="stringliteral">&quot; \t&quot;</span>
            &lt;&lt; mesh.<a class="code" href="classMeshBase.php#a06af1f178519c606d0bdca7857f95ba6">point</a>(n)(1) &lt;&lt; <span class="stringliteral">&quot; \t&quot;</span>
            &lt;&lt; 0. &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;

      <span class="comment">// Write the elements -- 1-based!</span>
      <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
      <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>();
      <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0;
      
      <span class="keywordflow">for</span> ( ; it != end; ++it)
        {
          <span class="comment">// .fro likes TRI3&#39;s</span>
          <span class="keywordflow">if</span> ((*it)-&gt;type() != <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>)
            {
              std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR:  .fro format only valid for triangles!\n&quot;</span>
                        &lt;&lt; <span class="stringliteral">&quot;  writing of &quot;</span> &lt;&lt; fname &lt;&lt; <span class="stringliteral">&quot; aborted.\n&quot;</span>
                        &lt;&lt; std::endl;
              libmesh_error();
            }
          
          out &lt;&lt; ++e &lt;&lt; <span class="stringliteral">&quot; \t&quot;</span>;

          <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;(*it)-&gt;n_nodes(); n++)
            out &lt;&lt; (*it)-&gt;node(n)+1 &lt;&lt; <span class="stringliteral">&quot; \t&quot;</span>;

<span class="comment">//        // LHS -&gt; RHS Mapping, for inverted triangles</span>
<span class="comment">//        out &lt;&lt; (*it)-&gt;node(0)+1 &lt;&lt; &quot; \t&quot;;</span>
<span class="comment">//        out &lt;&lt; (*it)-&gt;node(2)+1 &lt;&lt; &quot; \t&quot;;</span>
<span class="comment">//        out &lt;&lt; (*it)-&gt;node(1)+1 &lt;&lt; &quot; \t&quot;;</span>

          out &lt;&lt; <span class="stringliteral">&quot;1\n&quot;</span>;
        }

      <span class="comment">// Write BCs.</span>
      {
        <span class="keyword">const</span> std::set&lt;short int&gt;&amp; bc_ids =
          mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;get_boundary_ids();

        std::vector&lt;unsigned int&gt;       el;
        std::vector&lt;unsigned short int&gt; sl;
        std::vector&lt;short int&gt;          il;
        
        mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;build_side_list (el, sl, il);


        <span class="comment">// Map the boundary ids into [1,n_bc_ids],</span>
        <span class="comment">// treat them one at a time.</span>
        <span class="keywordtype">short</span> <span class="keywordtype">int</span> bc_id=0;
        <span class="keywordflow">for</span> (std::set&lt;short int&gt;::const_iterator <span class="keywordtype">id</span> = bc_ids.begin();
             <span class="keywordtype">id</span> != bc_ids.end(); ++id)
          {
            std::deque&lt;unsigned int&gt; node_list;
            
            std::map&lt;unsigned int, unsigned int&gt;
              forward_edges, backward_edges;
            
            <span class="comment">// Get all sides on this element with the relevant BC id.</span>
            <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;el.size(); e++)
              <span class="keywordflow">if</span> (il[e] == *<span class="keywordtype">id</span>)
                {
                  <span class="comment">// need to build up node_list as a sorted array of edge nodes...</span>
                  <span class="comment">// for the following:</span>
                  <span class="comment">// a---b---c---d---e</span>
                  <span class="comment">// node_list [ a b c d e];</span>
                  <span class="comment">//</span>
                  <span class="comment">// the issue is just how to get this out of the elem/side based data structure.</span>
                  <span class="comment">// the approach is to build up &#39;chain links&#39; like this:</span>
                  <span class="comment">// a---b b---c c---d d---e</span>
                  <span class="comment">// and piece them together.</span>
                  <span class="comment">//</span>
                  <span class="comment">// so, for an arbitray edge n0---n1, we build the</span>
                  <span class="comment">// &quot;forward_edges&quot;  map n0--&gt;n1</span>
                  <span class="comment">// &quot;backward_edges&quot; map n1--&gt;n0</span>
                  <span class="comment">// and then start with one chain link, and add on...</span>
                  <span class="comment">//</span>
                  <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> side = mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(el[e])-&gt;<a class="code" href="classElem.php#a554c146bcfb5537636bd77a157f21b85">build_side</a>(sl[e]);

                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
                    n0 = side-&gt;node(0),
                    n1 = side-&gt;node(1);

                  <span class="comment">// insert into forward-edge set</span>
                  forward_edges.insert (std::make_pair(n0, n1));

                  <span class="comment">// insert into backward-edge set</span>
                  backward_edges.insert (std::make_pair(n1, n0));

                  <span class="comment">// go ahead and add one edge to the list -- this will give us the beginning of a</span>
                  <span class="comment">// chain to work from!</span>
                  <span class="keywordflow">if</span> (node_list.empty())
                    {
                      node_list.push_front(n0);
                      node_list.push_back (n1);
                    }
                }

            <span class="comment">// we now have the node_list with one edge, the forward_edges, and the backward_edges</span>
            <span class="comment">// the node_list will be filled when (node_list.size() == (n_edges+1))</span>
            <span class="comment">// until that is the case simply add on to the beginning and end of the node_list,</span>
            <span class="comment">// building up a chain of ordered nodes...</span>
            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_edges = forward_edges.size();
            
            <span class="keywordflow">while</span> (node_list.size() != (n_edges+1))
              {
                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
                  front_node = node_list.front(),
                  back_node  = node_list.back();

                <span class="comment">// look for front_pair in the backward_edges list</span>
                {
                  std::map&lt;unsigned int, unsigned int&gt;::iterator
                    pos = backward_edges.find(front_node);

                  <span class="keywordflow">if</span> (pos != backward_edges.end())
                    {
                      node_list.push_front(pos-&gt;second);
                       
                      backward_edges.erase(pos);
                    }
                }

                <span class="comment">// look for back_pair in the forward_edges list</span>
                {
                  std::map&lt;unsigned int, unsigned int&gt;::iterator
                    pos = forward_edges.find(back_node);

                  <span class="keywordflow">if</span> (pos != forward_edges.end())
                    {
                      node_list.push_back(pos-&gt;second);
                       
                      forward_edges.erase(pos);
                    }
                }

<span class="comment">//              std::cout &lt;&lt; &quot;node_list.size()=&quot; &lt;&lt; node_list.size()</span>
<span class="comment">//                        &lt;&lt; &quot;, n_edges+1=&quot; &lt;&lt; n_edges+1 &lt;&lt; std::endl;            </span>
              }
                    

            out &lt;&lt; ++bc_id &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; node_list.size() &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;

            std::deque&lt;unsigned int&gt;::iterator pos = node_list.begin();
            <span class="keywordflow">for</span> ( ; pos != node_list.end(); ++pos)
                out &lt;&lt; *pos+1 &lt;&lt; <span class="stringliteral">&quot; \t0\n&quot;</span>;
          }     
      }      
    }
}
</pre></div>
</div>
</div>
<a class="anchor" id="a5e0df1f5cd00cc7ae3cbe73e6a68fe0e"></a><!-- doxytag: member="FroIO::write_equation_systems" ref="a5e0df1f5cd00cc7ae3cbe73e6a68fe0e" args="(const std::string &amp;, const EquationSystems &amp;)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classMeshOutput.php">MeshOutput</a>&lt; <a class="el" href="classMeshBase.php">MeshBase</a>  &gt;::write_equation_systems </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classEquationSystems.php">EquationSystems</a> &amp;&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>This method implements writing a mesh with data to a specified file where the data is taken from the <code><a class="el" href="classEquationSystems.php">EquationSystems</a></code> object. </p>

<p>Reimplemented in <a class="el" href="classVTKIO.php#aad1651ac3d6b53bd48923e30dd50f243">VTKIO</a>.</p>

</div>
</div>
<a class="anchor" id="a8365780c326915d5da092628a3e85038"></a><!-- doxytag: member="FroIO::write_nodal_data" ref="a8365780c326915d5da092628a3e85038" args="(const std::string &amp;, const std::vector&lt; Number &gt; &amp;, const std::vector&lt; std::string &gt; &amp;)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classMeshOutput.php">MeshOutput</a>&lt; <a class="el" href="classMeshBase.php">MeshBase</a>  &gt;::write_nodal_data </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; <a class="el" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> &gt; &amp;&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; std::string &gt; &amp;&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inline, virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>This method implements writing a mesh with nodal data to a specified file where the nodal data and variable names are provided. </p>

<p>Reimplemented in <a class="el" href="classExodusII__IO.php#ac114febf1bd1647ad2a35c11d9cc8f25">ExodusII_IO</a>, <a class="el" href="classGmshIO.php#a316b217296ecdbd9fc99054c89c59cdd">GmshIO</a>, <a class="el" href="classGMVIO.php#afcadf7ebf7bded1774d490ea06365d83">GMVIO</a>, <a class="el" href="classGnuPlotIO.php#a96381894e9bafd93374a154dd4eb4a5a">GnuPlotIO</a>, <a class="el" href="classMEDITIO.php#af08dd6969502b328d92d8fcd5a025659">MEDITIO</a>, and <a class="el" href="classTecplotIO.php#a5677240e026f182aefaf10f803d1df65">TecplotIO</a>.</p>

<p>Definition at line <a class="el" href="mesh__output_8h_source.php#l00091">91</a> of file <a class="el" href="mesh__output_8h_source.php">mesh_output.h</a>.</p>
<div class="fragment"><pre class="fragment">  { libmesh_error(); }
</pre></div>
</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="fro__io_8h_source.php">fro_io.h</a></li>
<li><a class="el" href="fro__io_8C_source.php">fro_io.C</a></li>
</ul>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
