<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.php"><span>Classes</span></a></li>
      <li><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.php"><span>Class&#160;List</span></a></li>
      <li><a href="classes.php"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.php"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.php"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="#pri-attribs">Private Attributes</a>  </div>
  <div class="headertitle">
<h1>LaplaceMeshSmoother Class Reference</h1>  </div>
</div>
<div class="contents">
<!-- doxytag: class="LaplaceMeshSmoother" --><!-- doxytag: inherits="MeshSmoother" -->
<p><code>#include &lt;<a class="el" href="mesh__smoother__laplace_8h_source.php">mesh_smoother_laplace.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for LaplaceMeshSmoother:</div>
<div class="dyncontent">
<div class="center"><img src="classLaplaceMeshSmoother__inherit__graph.png" border="0" usemap="#LaplaceMeshSmoother_inherit__map" alt="Inheritance graph"/></div>
<map name="LaplaceMeshSmoother_inherit__map" id="LaplaceMeshSmoother_inherit__map">
<area shape="rect" id="node2" href="classMeshSmoother.php" title="MeshSmoother" alt="" coords="29,5,149,35"/></map>
<center><span class="legend">[<a href="graph_legend.php">legend</a>]</span></center></div>

<p><a href="classLaplaceMeshSmoother-members.php">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLaplaceMeshSmoother.php#a319cc639d5a11d8ef5113b7d6beea374">LaplaceMeshSmoother</a> (<a class="el" href="classUnstructuredMesh.php">UnstructuredMesh</a> &amp;mesh)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLaplaceMeshSmoother.php#a0a1720664a007ac7c622eec34efa2ea5">~LaplaceMeshSmoother</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLaplaceMeshSmoother.php#a836c8d87c7e6ae66de9462a7a587eaaf">smooth</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLaplaceMeshSmoother.php#aa9eb8b9ba1fbaefab44b3e950e4d4e20">smooth</a> (unsigned int n_iterations)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLaplaceMeshSmoother.php#ab70683d8eaa560136b8423a734afeb68">init</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLaplaceMeshSmoother.php#a8195e341cfaf73c63b07afaa1b7c903a">print_graph</a> () const </td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classUnstructuredMesh.php">UnstructuredMesh</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a></td></tr>
<tr><td colspan="2"><h2><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLaplaceMeshSmoother.php#aad041b842be1c1813c57744ec8b467dc">_initialized</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">std::vector&lt; std::vector<br class="typebreak"/>
&lt; unsigned int &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a></td></tr>
</table>
<hr/><a name="_details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This class defines the data structures necessary for Laplace smoothing. Note that this is a simple averaging smoother, which does NOT guarantee that points will be smoothed to valid locations, e.g. locations inside the boundary! This aspect could use work.</p>
<dl class="author"><dt><b>Author:</b></dt><dd>John W. Peterson </dd></dl>
<dl class="date"><dt><b>Date:</b></dt><dd>2002-2007 </dd></dl>
<dl class="version"><dt><b>Version:</b></dt><dd></dd></dl>
<dl class="rcs"><dt><b>Revision:</b></dt><dd>3391 </dd></dl>

<p>Definition at line <a class="el" href="mesh__smoother__laplace_8h_source.php#l00053">53</a> of file <a class="el" href="mesh__smoother__laplace_8h_source.php">mesh_smoother_laplace.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a319cc639d5a11d8ef5113b7d6beea374"></a><!-- doxytag: member="LaplaceMeshSmoother::LaplaceMeshSmoother" ref="a319cc639d5a11d8ef5113b7d6beea374" args="(UnstructuredMesh &amp;mesh)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">LaplaceMeshSmoother::LaplaceMeshSmoother </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classUnstructuredMesh.php">UnstructuredMesh</a> &amp;&#160;</td>
          <td class="paramname"><em>mesh</em></td><td>)</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Constructor. Sets the constant mesh reference in the protected data section of the class. </p>

<p>Definition at line <a class="el" href="mesh__smoother__laplace_8h_source.php#l00060">60</a> of file <a class="el" href="mesh__smoother__laplace_8h_source.php">mesh_smoother_laplace.h</a>.</p>
<div class="fragment"><pre class="fragment">    : <a class="code" href="classMeshSmoother.php#a7e21469c23699a6f526581a080e5d7ba">MeshSmoother</a>(mesh),
      <a class="code" href="classLaplaceMeshSmoother.php#aad041b842be1c1813c57744ec8b467dc">_initialized</a>(<span class="keyword">false</span>) {}
</pre></div>
</div>
</div>
<a class="anchor" id="a0a1720664a007ac7c622eec34efa2ea5"></a><!-- doxytag: member="LaplaceMeshSmoother::~LaplaceMeshSmoother" ref="a0a1720664a007ac7c622eec34efa2ea5" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual LaplaceMeshSmoother::~LaplaceMeshSmoother </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Destructor. </p>

<p>Definition at line <a class="el" href="mesh__smoother__laplace_8h_source.php#l00067">67</a> of file <a class="el" href="mesh__smoother__laplace_8h_source.php">mesh_smoother_laplace.h</a>.</p>
<div class="fragment"><pre class="fragment">{}
</pre></div>
</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="ab70683d8eaa560136b8423a734afeb68"></a><!-- doxytag: member="LaplaceMeshSmoother::init" ref="ab70683d8eaa560136b8423a734afeb68" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LaplaceMeshSmoother::init </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Initialization for the Laplace smoothing routine is basically identical to building an "L-graph" which is expensive. It's provided separately from the constructor since you may or may not want to build the L-graph on construction. </p>

<p>Definition at line <a class="el" href="mesh__smoother__laplace_8C_source.php#l00124">124</a> of file <a class="el" href="mesh__smoother__laplace_8C_source.php">mesh_smoother_laplace.C</a>.</p>

<p>References <a class="el" href="mesh__smoother__laplace_8h_source.php#l00109">_graph</a>, <a class="el" href="mesh__smoother__laplace_8h_source.php#l00104">_initialized</a>, <a class="el" href="mesh__smoother_8h_source.php#l00070">MeshSmoother::_mesh</a>, <a class="el" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">MeshBase::active_elements_begin()</a>, <a class="el" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">MeshBase::active_elements_end()</a>, <a class="el" href="classElem.php#a554c146bcfb5537636bd77a157f21b85">Elem::build_side()</a>, <a class="el" href="dof__object_8h_source.php#l00449">DofObject::id()</a>, <a class="el" href="mesh__base_8h_source.php#l00140">MeshBase::mesh_dimension()</a>, <a class="el" href="elem_8h_source.php#l00301">Elem::n_neighbors()</a>, <a class="el" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">MeshBase::n_nodes()</a>, and <a class="el" href="elem_8h_source.php#l01213">Elem::neighbor()</a>.</p>

<p>Referenced by <a class="el" href="mesh__smoother__laplace_8C_source.php#l00033">smooth()</a>.</p>
<div class="fragment"><pre class="fragment">{


  <span class="keywordflow">switch</span> (<a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>())
    {
      
      <span class="comment">// TODO:[BSK] Fix this to work for refined meshes...  I think</span>
      <span class="comment">// the implementation was done quickly for Damien, who did not have</span>
      <span class="comment">// refined grids.  Fix it here and in the original Mesh member.</span>
      
    <span class="keywordflow">case</span> 2: <span class="comment">// Stolen directly from build_L_graph in mesh_base.C</span>
      {
        <span class="comment">// Initialize space in the graph.  It is n_nodes</span>
        <span class="comment">// long and each node is assumed to be connected to</span>
        <span class="comment">// approximately 4 neighbors.</span>
        <a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>.resize(<a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<span class="comment">//      for (unsigned int i=0; i&lt;_mesh.n_nodes(); ++i)</span>
<span class="comment">//        _graph[i].reserve(4);</span>
        
        <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el  = <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
        <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
        
        <span class="keywordflow">for</span> (; el != end; ++el)
          {
            <span class="comment">// Constant handle for the element</span>
            <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *el;
            
            <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); s++)
              {
                <span class="comment">// Only operate on sides which are on the</span>
                <span class="comment">// boundary or for which the current element&#39;s</span>
                <span class="comment">// id is greater than its neighbor&#39;s.</span>
                <span class="comment">// Sides get only built once.</span>
                <span class="keywordflow">if</span> ((elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s) == NULL) ||
                    (elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() &gt; elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s)-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()))
                  {
                    <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> side(elem-&gt;<a class="code" href="classElem.php#a554c146bcfb5537636bd77a157f21b85">build_side</a>(s));
                    <a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[side-&gt;node(0)].push_back(side-&gt;node(1));
                    <a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[side-&gt;node(1)].push_back(side-&gt;node(0));
                }
              }
          }
        <a class="code" href="classLaplaceMeshSmoother.php#aad041b842be1c1813c57744ec8b467dc">_initialized</a> = <span class="keyword">true</span>;
        <span class="keywordflow">break</span>;
      }

    <span class="keywordflow">case</span> 3: <span class="comment">// Stolen blatantly from build_L_graph in mesh_base.C</span>
      {
        <span class="comment">// Initialize space in the graph.  In 3D, I&#39;ve assumed</span>
        <span class="comment">// that each node was connected to approximately 3 neighbors.</span>
        <a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>.resize(<a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<span class="comment">//      for (unsigned int i=0; i&lt;_mesh.n_nodes(); ++i)</span>
<span class="comment">//        _graph[i].reserve(8);</span>
        
        <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el  = <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
        <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 

        <span class="keywordflow">for</span> (; el != end; ++el)
          {
            <span class="comment">// Shortcut notation for simplicity</span>
            <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *el;
            
            <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> f=0; f&lt;elem-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); f++) <span class="comment">// Loop over faces</span>
              <span class="keywordflow">if</span> ((elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(f) == NULL) ||
                  (elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() &gt; elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(f)-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()))
                {
                  <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(elem-&gt;<a class="code" href="classElem.php#a554c146bcfb5537636bd77a157f21b85">build_side</a>(f));
                
                  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;face-&gt;n_neighbors(); s++) <span class="comment">// Loop over face&#39;s edges</span>
                    {
                      <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> side(face-&gt;build_side(s));
                    
                      <span class="comment">// At this point, we just insert the node numbers</span>
                      <span class="comment">// again.  At the end we&#39;ll call sort and unique</span>
                      <span class="comment">// to make sure there are no duplicates</span>
                      <a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[side-&gt;node(0)].push_back(side-&gt;node(1));
                      <a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[side-&gt;node(1)].push_back(side-&gt;node(0));
                    }
                }
          }

        <span class="comment">// Now call sort and unique to remove duplicate entries.</span>
        <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>(); ++i)
          {
            std::sort  (<a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[i].begin(), <a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[i].end());
            <a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[i].erase(std::unique(<a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[i].begin(), <a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[i].end()), <a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[i].end());
          }
        
        <a class="code" href="classLaplaceMeshSmoother.php#aad041b842be1c1813c57744ec8b467dc">_initialized</a> = <span class="keyword">true</span>;
        <span class="keywordflow">break</span>;
      }

    <span class="keywordflow">default</span>:
      {
        std::cerr &lt;&lt; <span class="stringliteral">&quot;At this time it is not possible &quot;</span>
                  &lt;&lt; <span class="stringliteral">&quot;to smooth a dimension &quot;</span>
                  &lt;&lt; <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>()
                  &lt;&lt; <span class="stringliteral">&quot;mesh.  Aborting...&quot;</span>
                  &lt;&lt; std::endl;
        libmesh_error();
      }
      
    }
}
</pre></div>
</div>
</div>
<a class="anchor" id="a8195e341cfaf73c63b07afaa1b7c903a"></a><!-- doxytag: member="LaplaceMeshSmoother::print_graph" ref="a8195e341cfaf73c63b07afaa1b7c903a" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LaplaceMeshSmoother::print_graph </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Mainly for debugging, this function will print out the connectivity graph which has been created. </p>

<p>Definition at line <a class="el" href="mesh__smoother__laplace_8C_source.php#l00233">233</a> of file <a class="el" href="mesh__smoother__laplace_8C_source.php">mesh_smoother_laplace.C</a>.</p>

<p>References <a class="el" href="mesh__smoother__laplace_8h_source.php#l00109">_graph</a>.</p>
<div class="fragment"><pre class="fragment">{
  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>.size(); ++i)
    {
      std::cout &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;: &quot;</span>;
      std::copy(<a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[i].begin(),
                <a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[i].end(),
                std::ostream_iterator&lt;unsigned int&gt;(std::cout, <span class="stringliteral">&quot; &quot;</span>));
      std::cout &lt;&lt; std::endl;
    }
}
</pre></div>
</div>
</div>
<a class="anchor" id="a836c8d87c7e6ae66de9462a7a587eaaf"></a><!-- doxytag: member="LaplaceMeshSmoother::smooth" ref="a836c8d87c7e6ae66de9462a7a587eaaf" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void LaplaceMeshSmoother::smooth </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Redefinition of the smooth function from the base class. All this does is call the smooth function in this class which takes an int, using a default value of 1. </p>

<p>Implements <a class="el" href="classMeshSmoother.php#a2f860e9c2cfbe3e14f363f223ed5baab">MeshSmoother</a>.</p>

<p>Definition at line <a class="el" href="mesh__smoother__laplace_8h_source.php#l00075">75</a> of file <a class="el" href="mesh__smoother__laplace_8h_source.php">mesh_smoother_laplace.h</a>.</p>

<p>References <a class="el" href="mesh__smoother__laplace_8h_source.php#l00075">smooth()</a>.</p>

<p>Referenced by <a class="el" href="mesh__smoother__laplace_8h_source.php#l00075">smooth()</a>, and <a class="el" href="mesh__triangle__support_8C_source.php#l00287">TriangleInterface::triangulate()</a>.</p>
<div class="fragment"><pre class="fragment">{ this-&gt;<a class="code" href="classLaplaceMeshSmoother.php#a836c8d87c7e6ae66de9462a7a587eaaf">smooth</a>(1); }
</pre></div>
</div>
</div>
<a class="anchor" id="aa9eb8b9ba1fbaefab44b3e950e4d4e20"></a><!-- doxytag: member="LaplaceMeshSmoother::smooth" ref="aa9eb8b9ba1fbaefab44b3e950e4d4e20" args="(unsigned int n_iterations)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LaplaceMeshSmoother::smooth </td>
          <td>(</td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>n_iterations</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>The actual smoothing function, gets called whenever the user specifies an actual number of smoothing iterations. </p>

<p>Definition at line <a class="el" href="mesh__smoother__laplace_8C_source.php#l00033">33</a> of file <a class="el" href="mesh__smoother__laplace_8C_source.php">mesh_smoother_laplace.C</a>.</p>

<p>References <a class="el" href="mesh__smoother__laplace_8h_source.php#l00109">_graph</a>, <a class="el" href="mesh__smoother__laplace_8h_source.php#l00104">_initialized</a>, <a class="el" href="mesh__smoother_8h_source.php#l00070">MeshSmoother::_mesh</a>, <a class="el" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">MeshBase::active_elements_begin()</a>, <a class="el" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">MeshBase::active_elements_end()</a>, <a class="el" href="type__vector_8h_source.php#l00426">TypeVector&lt; T &gt;::add()</a>, <a class="el" href="mesh__tools_8C_source.php#l00245">MeshTools::find_boundary_nodes()</a>, <a class="el" href="dof__object_8h_source.php#l00449">DofObject::id()</a>, <a class="el" href="mesh__smoother__laplace_8C_source.php#l00124">init()</a>, <a class="el" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">Elem::n_nodes()</a>, <a class="el" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">MeshBase::n_nodes()</a>, <a class="el" href="elem_8C_source.php#l01209">Elem::n_second_order_adjacent_vertices()</a>, <a class="el" href="classElem.php#a6bbe1895127c069722e36ee4e2a8a6e1">Elem::n_vertices()</a>, <a class="el" href="elem_8h_source.php#l01164">Elem::node()</a>, <a class="el" href="classMeshBase.php#a298477f2d67d6a85f6c7fb5a640e2b64">MeshBase::node()</a>, <a class="el" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">MeshBase::nodes_begin()</a>, <a class="el" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">MeshBase::nodes_end()</a>, <a class="el" href="classMeshBase.php#a06af1f178519c606d0bdca7857f95ba6">MeshBase::point()</a>, and <a class="el" href="elem_8C_source.php#l01217">Elem::second_order_adjacent_vertex()</a>.</p>
<div class="fragment"><pre class="fragment">{
  <span class="keywordflow">if</span> (!<a class="code" href="classLaplaceMeshSmoother.php#aad041b842be1c1813c57744ec8b467dc">_initialized</a>)
    this-&gt;<a class="code" href="classLaplaceMeshSmoother.php#ab70683d8eaa560136b8423a734afeb68">init</a>();
  
  <span class="comment">// Don&#39;t smooth the nodes on the boundary...</span>
  <span class="comment">// this would change the mesh geometry which</span>
  <span class="comment">// is probably not something we want!</span>
  std::vector&lt;bool&gt; on_boundary;
  <a class="code" href="namespaceMeshTools.php#ab24d347f09559cc4fa6ea2c1a238b2d4">MeshTools::find_boundary_nodes</a>(<a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>, on_boundary);

  <span class="comment">// We can only update the nodes after all new positions were</span>
  <span class="comment">// determined. We store the new positions here</span>
  std::vector&lt;Point&gt; new_positions;

  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;n_iterations; n++)
    {
      new_positions.resize(<a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
      
      <span class="keywordflow">for</span> (<a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> it  = <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
           it != <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
           ++it) 
        {
          <a class="code" href="classNode.php">Node</a>* node = *it;
          <span class="comment">// leave the boundary intact</span>
          <span class="comment">// Only relocate the nodes which are vertices of an element</span>
          <span class="comment">// All other entries of _graph (the secondary nodes) are empty</span>
          <span class="keywordflow">if</span> (!on_boundary[node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] &amp;&amp; (<a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()].size() &gt; 0) )
            {
              <a class="code" href="classPoint.php">Point</a> avg_position(0.,0.,0.);
              <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()].size(); ++j)
                avg_position.add(<a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a298477f2d67d6a85f6c7fb5a640e2b64">node</a>(<a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()][j]));
              new_positions[node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] = avg_position /
                <span class="keyword">static_cast&lt;</span><a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a><span class="keyword">&gt;</span>(<a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()].size());
            }
        }
      
      <span class="comment">// now update the node positions</span>
      <span class="keywordflow">for</span> (<a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> it  = <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
           it != <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
           ++it)
        {
          <a class="code" href="classNode.php">Node</a>* node = *it;
          
          <span class="keywordflow">if</span> (!on_boundary[node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] &amp;&amp; (<a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()].size() &gt; 0) )
            {
              <span class="comment">// Should call Point::op=</span>
              <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a298477f2d67d6a85f6c7fb5a640e2b64">node</a>(node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()) = new_positions[node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()];
            }
        }
    }
  
  <span class="comment">// finally adjust the second order nodes (those located between vertices)</span>
  <span class="comment">// these nodes will be located between their adjacent nodes</span>
  <span class="comment">// do this element-wise</span>
  <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el  = <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
  <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
        
  <span class="keywordflow">for</span> (; el != end; ++el)
    {
      <span class="comment">// Constant handle for the element</span>
      <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *el;

      <span class="comment">// get the second order nodes (son)</span>
      <span class="comment">// their element indices start at n_vertices and go to n_nodes</span>
      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> son_begin = elem-&gt;<a class="code" href="classElem.php#a6bbe1895127c069722e36ee4e2a8a6e1">n_vertices</a>();
      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> son_end   = elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>();
      
      <span class="comment">// loop over all second order nodes (son)</span>
      <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> son=son_begin; son&lt;son_end; son++)
        {
          <span class="comment">// Don&#39;t smooth second-order nodes which are on the boundary</span>
          <span class="keywordflow">if</span> (!on_boundary[elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(son)])
            {
              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_adjacent_vertices =
                elem-&gt;<a class="code" href="classElem.php#a9f073eee0a8cd4d87e72f0834b4b1815">n_second_order_adjacent_vertices</a>(son);

              <span class="comment">// calculate the new position which is the average of the</span>
              <span class="comment">// position of the adjacent vertices</span>
              <a class="code" href="classPoint.php">Point</a> avg_position(0,0,0);
              <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;n_adjacent_vertices; v++)
                avg_position +=
                  <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a06af1f178519c606d0bdca7857f95ba6">point</a>( elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>( elem-&gt;<a class="code" href="classElem.php#a51e4bd9931fa1378113784f76ac13d6a">second_order_adjacent_vertex</a>(son,v) ) );

              <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a298477f2d67d6a85f6c7fb5a640e2b64">node</a>(elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(son)) = avg_position / n_adjacent_vertices;
            }
        }
    }
}
</pre></div>
</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a9b4ece7f6dd69aae5c30db7619a8d82e"></a><!-- doxytag: member="LaplaceMeshSmoother::_graph" ref="a9b4ece7f6dd69aae5c30db7619a8d82e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;std::vector&lt;unsigned int&gt; &gt; <a class="el" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">LaplaceMeshSmoother::_graph</a><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Data structure for holding the L-graph </p>

<p>Definition at line <a class="el" href="mesh__smoother__laplace_8h_source.php#l00109">109</a> of file <a class="el" href="mesh__smoother__laplace_8h_source.php">mesh_smoother_laplace.h</a>.</p>

<p>Referenced by <a class="el" href="mesh__smoother__laplace_8C_source.php#l00124">init()</a>, <a class="el" href="mesh__smoother__laplace_8C_source.php#l00233">print_graph()</a>, and <a class="el" href="mesh__smoother__laplace_8C_source.php#l00033">smooth()</a>.</p>

</div>
</div>
<a class="anchor" id="aad041b842be1c1813c57744ec8b467dc"></a><!-- doxytag: member="LaplaceMeshSmoother::_initialized" ref="aad041b842be1c1813c57744ec8b467dc" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classLaplaceMeshSmoother.php#aad041b842be1c1813c57744ec8b467dc">LaplaceMeshSmoother::_initialized</a><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>True if the L-graph has been created, false otherwise. </p>

<p>Definition at line <a class="el" href="mesh__smoother__laplace_8h_source.php#l00104">104</a> of file <a class="el" href="mesh__smoother__laplace_8h_source.php">mesh_smoother_laplace.h</a>.</p>

<p>Referenced by <a class="el" href="mesh__smoother__laplace_8C_source.php#l00124">init()</a>, and <a class="el" href="mesh__smoother__laplace_8C_source.php#l00033">smooth()</a>.</p>

</div>
</div>
<a class="anchor" id="a7f5ff11e687f8df03f58b73499e63549"></a><!-- doxytag: member="LaplaceMeshSmoother::_mesh" ref="a7f5ff11e687f8df03f58b73499e63549" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; <a class="el" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">MeshSmoother::_mesh</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="mesh__smoother_8h_source.php#l00070">70</a> of file <a class="el" href="mesh__smoother_8h_source.php">mesh_smoother.h</a>.</p>

<p>Referenced by <a class="el" href="mesh__smoother__vsmoother_8C_source.php#l00501">VariationalMeshSmoother::adjust_adapt_data()</a>, <a class="el" href="mesh__smoother__laplace_8C_source.php#l00124">init()</a>, <a class="el" href="mesh__smoother__vsmoother_8C_source.php#l00245">VariationalMeshSmoother::readgr()</a>, <a class="el" href="mesh__smoother__vsmoother_8C_source.php#l00041">VariationalMeshSmoother::smooth()</a>, <a class="el" href="mesh__smoother__laplace_8C_source.php#l00033">smooth()</a>, and <a class="el" href="mesh__smoother__vsmoother_8C_source.php#l00148">VariationalMeshSmoother::writegr()</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="mesh__smoother__laplace_8h_source.php">mesh_smoother_laplace.h</a></li>
<li><a class="el" href="mesh__smoother__laplace_8C_source.php">mesh_smoother_laplace.C</a></li>
</ul>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
