<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.php"><span>Classes</span></a></li>
      <li><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.php"><span>Class&#160;List</span></a></li>
      <li><a href="classes.php"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.php"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.php"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<h1>LibMeshInit Class Reference</h1>  </div>
</div>
<div class="contents">
<!-- doxytag: class="LibMeshInit" -->
<p><code>#include &lt;<a class="el" href="libmesh_8h_source.php">libmesh.h</a>&gt;</code></p>

<p><a href="classLibMeshInit-members.php">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLibMeshInit.php#add6b58803b50693f2a7456e53299b567">LibMeshInit</a> (int &amp;argc, char **&amp;argv, MPI_Comm COMM_WORLD_IN=MPI_COMM_WORLD)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLibMeshInit.php#a5cc7d9b6d88be7ffd63ee4552e91cd6f">LibMeshInit</a> (int &amp;argc, char **&amp;argv)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLibMeshInit.php#a6359955a36bb80820be9aeab2378df08">~LibMeshInit</a> ()</td></tr>
</table>
<hr/><a name="_details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>The <code><a class="el" href="classLibMeshInit.php">LibMeshInit</a></code> class, when constructed, initializes the dependent libraries (e.g. MPI or PETSC) and does the command line parsing needed by <a class="el" href="namespacelibMesh.php">libMesh</a>. The <a class="el" href="classLibMeshInit.php">LibMeshInit</a> destructor closes those libraries properly.</p>
<p>For most users, a single <a class="el" href="classLibMeshInit.php">LibMeshInit</a> object should be created at the start of your main() function. This object replaces the previous <a class="el" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">libMesh::init()</a>/libMesh<a class="el" href="namespacelibMesh.php#a6e41d4c43a417f7b9e20302af9736247">close()</a> methods, which are now deprecated. </p>

<p>Definition at line <a class="el" href="libmesh_8h_source.php#l00057">57</a> of file <a class="el" href="libmesh_8h_source.php">libmesh.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="add6b58803b50693f2a7456e53299b567"></a><!-- doxytag: member="LibMeshInit::LibMeshInit" ref="add6b58803b50693f2a7456e53299b567" args="(int &amp;argc, char **&amp;argv, MPI_Comm COMM_WORLD_IN=MPI_COMM_WORLD)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">LibMeshInit::LibMeshInit </td>
          <td>(</td>
          <td class="paramtype">int &amp;&#160;</td>
          <td class="paramname"><em>argc</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char **&amp;&#160;</td>
          <td class="paramname"><em>argv</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MPI_Comm&#160;</td>
          <td class="paramname"><em>COMM_WORLD_IN</em> = <code>MPI_COMM_WORLD</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Initialize the library for use, with the command line options provided. This will e.g. call PetscInitialize if PETSC is available. You must create a <a class="el" href="classLibMeshInit.php">LibMeshInit</a> object before using any of the library functionality. This method may take an optional parameter to use a user-specified MPI communicator. </p>

<p>Definition at line <a class="el" href="libmesh_8C_source.php#l00378">378</a> of file <a class="el" href="libmesh_8C_source.php">libmesh.C</a>.</p>

<p>References <a class="el" href="namespacelibMesh.php#aad6fecb8ebe53b4daffa683eaa02d4dc">libMesh::_init()</a>, <a class="el" href="namespaceEXTERN__C__FOR__PETSC__END.php#abef0573f7a973208f7c638bfc4f5690a">EXTERN_C_FOR_PETSC_END::_ofstream</a>, <a class="el" href="namespaceEXTERN__C__FOR__PETSC__END.php#a955fd6be1d12cb90dc6dfa9c0b45fb8b">EXTERN_C_FOR_PETSC_END::cerr_buf()</a>, <a class="el" href="namespaceEXTERN__C__FOR__PETSC__END.php#a98a29cfa172dacc7ab68e0ca77079cd6">EXTERN_C_FOR_PETSC_END::cout_buf()</a>, <a class="el" href="libmesh_8C_source.php#l00408">libMesh::on_command_line()</a>, and <a class="el" href="libmesh__base_8h_source.php#l00088">libMesh::processor_id()</a>.</p>
<div class="fragment"><pre class="fragment">{
  <a class="code" href="namespacelibMesh.php#aad6fecb8ebe53b4daffa683eaa02d4dc">libMesh::_init</a>(argc, <a class="code" href="namespacelibMesh.php#a417881714cb540579a186977f22143a2">argv</a>, COMM_WORLD_IN);

  <span class="comment">// Honor the --redirect-stdout command-line option.</span>
  <span class="comment">// When this is specified each processor sends</span>
  <span class="comment">// std::cout/std::cerr messages to</span>
  <span class="comment">// stdout.processor.####</span>
  <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--redirect-stdout&quot;</span>))
    {
      <span class="keywordtype">char</span> filechar[80];
      sprintf (filechar, <span class="stringliteral">&quot;stdout.processor.%04d&quot;</span>,
               <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>());
      <a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#abef0573f7a973208f7c638bfc4f5690a">_ofstream</a>.reset (<span class="keyword">new</span> std::ofstream (filechar));
      <span class="comment">// Redirect, saving the original streambufs!</span>
      <a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#a98a29cfa172dacc7ab68e0ca77079cd6">cout_buf</a> = std::cout.rdbuf (<a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#abef0573f7a973208f7c638bfc4f5690a">_ofstream</a>-&gt;rdbuf());
      <a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#a955fd6be1d12cb90dc6dfa9c0b45fb8b">cerr_buf</a> = std::cerr.rdbuf (<a class="code" href="namespaceEXTERN__C__FOR__PETSC__END.php#abef0573f7a973208f7c638bfc4f5690a">_ofstream</a>-&gt;rdbuf());
    }
}
</pre></div>
</div>
</div>
<a class="anchor" id="a5cc7d9b6d88be7ffd63ee4552e91cd6f"></a><!-- doxytag: member="LibMeshInit::LibMeshInit" ref="a5cc7d9b6d88be7ffd63ee4552e91cd6f" args="(int &amp;argc, char **&amp;argv)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">LibMeshInit::LibMeshInit </td>
          <td>(</td>
          <td class="paramtype">int &amp;&#160;</td>
          <td class="paramname"><em>argc</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char **&amp;&#160;</td>
          <td class="paramname"><em>argv</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="libmesh_8C_source.php#l00373">373</a> of file <a class="el" href="libmesh_8C_source.php">libmesh.C</a>.</p>

<p>References <a class="el" href="namespacelibMesh.php#aad6fecb8ebe53b4daffa683eaa02d4dc">libMesh::_init()</a>.</p>
<div class="fragment"><pre class="fragment">{
  <a class="code" href="namespacelibMesh.php#aad6fecb8ebe53b4daffa683eaa02d4dc">libMesh::_init</a>(argc, <a class="code" href="namespacelibMesh.php#a417881714cb540579a186977f22143a2">argv</a>);
}
</pre></div>
</div>
</div>
<a class="anchor" id="a6359955a36bb80820be9aeab2378df08"></a><!-- doxytag: member="LibMeshInit::~LibMeshInit" ref="a6359955a36bb80820be9aeab2378df08" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">LibMeshInit::~LibMeshInit </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="libmesh_8C_source.php#l00400">400</a> of file <a class="el" href="libmesh_8C_source.php">libmesh.C</a>.</p>
<div class="fragment"><pre class="fragment">{
  libMesh::_close();
}
</pre></div>
</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="libmesh_8h_source.php">libmesh.h</a></li>
<li><a class="el" href="libmesh_8C_source.php">libmesh.C</a></li>
</ul>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
