<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.php"><span>Classes</span></a></li>
      <li><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.php"><span>Class&#160;List</span></a></li>
      <li><a href="classes.php"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.php"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.php"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a>  </div>
  <div class="headertitle">
<h1>MatlabIO Class Reference</h1>  </div>
</div>
<div class="contents">
<!-- doxytag: class="MatlabIO" --><!-- doxytag: inherits="MeshInput&lt; MeshBase &gt;" -->
<p><code>#include &lt;<a class="el" href="matlab__io_8h_source.php">matlab_io.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for MatlabIO:</div>
<div class="dyncontent">
<div class="center"><img src="classMatlabIO__inherit__graph.png" border="0" usemap="#MatlabIO_inherit__map" alt="Inheritance graph"/></div>
<map name="MatlabIO_inherit__map" id="MatlabIO_inherit__map">
<area shape="rect" id="node2" href="classMeshInput.php" title="MeshInput\&lt; MeshBase \&gt;" alt="" coords="5,5,189,35"/></map>
<center><span class="legend">[<a href="graph_legend.php">legend</a>]</span></center></div>

<p><a href="classMatlabIO-members.php">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMatlabIO.php#a15202601cb2b0fd0852fb6f203c9c6f2">MatlabIO</a> (<a class="el" href="classMeshBase.php">MeshBase</a> &amp;)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMatlabIO.php#a3a6ccb2025cb0c6e64c6813acdada143">read</a> (const std::string &amp;name)</td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classMeshBase.php">MeshBase</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMeshInput.php#a1261f0e7a0d6284c4a1e321d13c3c3ec">skip_comment_lines</a> (std::istream &amp;in, const char comment_start)</td></tr>
<tr><td colspan="2"><h2><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMatlabIO.php#a207f96c9be8ef76f489b8b84e491e823">read_stream</a> (std::istream &amp;in)</td></tr>
</table>
<hr/><a name="_details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This class implements reading meshes in the Matlab PDE toolkit in a proprietary format.</p>
<p>A VALID INPUT FILE for this type of mesh should be generated in Matlab with the following steps: 1.) Draw the domain and triangulate it in the GUI 2.) Export the mesh to matlab using Mesh-&gt;Export <a class="el" href="classMesh.php">Mesh</a> 3.) Create a file with this script: fid = fopen('filename', 'w'); fprintf(fid, 'd d <br/>
', length(p), length(t)); fprintf(fid, 'f f <br/>
', p); fprintf(fid, 'd d d d <br/>
', t); fclose(fid);</p>
<p>What's going on here? There is no standard for exporting PDE toolkit meshes to files in Matlab. When you choose "export mesh" in the GUI, it returns three matrices that it likes to call p, e, and t. All meshes (as far as I can tell) that come from the PDE toolkit are 2D triangle meshes.</p>
<p>p is the point matrix... Row 1: x coordinate Row 2: y coordinate</p>
<p>e is the edge matrix ... Row 1: starting point number (dummy) Row 2: ending point number (dummy) Row 3: starting parameter value (?) (dummy) Row 4: ending parameter value (?) (dummy) Row 5: boundary segment number (?) (dummy) Row 6: left-hand subdomain number (dummy) Row 7: right-hand subdomain number (dummy)</p>
<p>t is the triangle matrix ... Row 1: <a class="el" href="classNode.php">Node</a> number 1 Row 2: <a class="el" href="classNode.php">Node</a> number 2 Row 3: <a class="el" href="classNode.php">Node</a> number 3 Row 4: subdomain number (dummy)</p>
<p>There are some important things to notice here: o The implied ordering of the p matrix is 1..N o The e matrix is entirely irrelevant in this code o All of the matrices are row based</p>
<dl class="author"><dt><b>Author:</b></dt><dd>John W. Peterson, 2004 </dd></dl>

<p>Definition at line <a class="el" href="matlab__io_8h_source.php#l00086">86</a> of file <a class="el" href="matlab__io_8h_source.php">matlab_io.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a15202601cb2b0fd0852fb6f203c9c6f2"></a><!-- doxytag: member="MatlabIO::MatlabIO" ref="a15202601cb2b0fd0852fb6f203c9c6f2" args="(MeshBase &amp;)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">MatlabIO::MatlabIO </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classMeshBase.php">MeshBase</a> &amp;&#160;</td>
          <td class="paramname"><em>mesh</em></td><td>)</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Constructor. Takes a non-const <a class="el" href="classMesh.php">Mesh</a> reference which it will fill up with elements. </p>

<p>Definition at line <a class="el" href="matlab__io_8h_source.php#l00114">114</a> of file <a class="el" href="matlab__io_8h_source.php">matlab_io.h</a>.</p>
<div class="fragment"><pre class="fragment">                                  :
  <a class="code" href="classMeshInput.php">MeshInput&lt;MeshBase&gt;</a>  (<a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a>)
{}
</pre></div>
</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a2e8be596b1583aa3348740f461562d24"></a><!-- doxytag: member="MatlabIO::mesh" ref="a2e8be596b1583aa3348740f461562d24" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classMeshBase.php">MeshBase</a> &amp; <a class="el" href="classMeshInput.php">MeshInput</a>&lt; <a class="el" href="classMeshBase.php">MeshBase</a>  &gt;::mesh </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Returns the object as a writeable reference. </p>

<p>Referenced by <a class="el" href="gmv__io_8C_source.php#l02008">GMVIO::_read_materials()</a>, <a class="el" href="gmv__io_8C_source.php#l02051">GMVIO::_read_nodes()</a>, <a class="el" href="gmv__io_8C_source.php#l02086">GMVIO::_read_one_cell()</a>, <a class="el" href="gmv__io_8C_source.php#l01837">GMVIO::add_cell_centered_data()</a>, <a class="el" href="gmv__io_8C_source.php#l02226">GMVIO::copy_nodal_solution()</a>, <a class="el" href="unv__io_8C_source.php#l00642">UNVIO::element_in()</a>, <a class="el" href="tetgen__io_8C_source.php#l00175">TetGenIO::element_in()</a>, <a class="el" href="unv__io_8C_source.php#l01018">UNVIO::element_out()</a>, <a class="el" href="unv__io_8C_source.php#l00535">UNVIO::node_in()</a>, <a class="el" href="tetgen__io_8C_source.php#l00119">TetGenIO::node_in()</a>, <a class="el" href="unv__io_8C_source.php#l00952">UNVIO::node_out()</a>, <a class="el" href="xdr__io_8C_source.php#l00743">XdrIO::read()</a>, <a class="el" href="vtk__io_8C_source.php#l00449">VTKIO::read()</a>, <a class="el" href="gmv__io_8C_source.php#l01854">GMVIO::read()</a>, <a class="el" href="exodusII__io_8C_source.php#l00082">ExodusII_IO::read()</a>, <a class="el" href="legacy__xdr__io_8C_source.php#l00205">LegacyXdrIO::read_ascii()</a>, <a class="el" href="legacy__xdr__io_8C_source.php#l00219">LegacyXdrIO::read_binary()</a>, <a class="el" href="ucd__io_8C_source.php#l00107">UCDIO::read_implementation()</a>, <a class="el" href="legacy__xdr__io_8C_source.php#l00269">LegacyXdrIO::read_mesh()</a>, <a class="el" href="gmsh__io_8C_source.php#l00319">GmshIO::read_mesh()</a>, <a class="el" href="xdr__io_8C_source.php#l01009">XdrIO::read_serialized_bcs()</a>, <a class="el" href="xdr__io_8C_source.php#l00813">XdrIO::read_serialized_connectivity()</a>, <a class="el" href="xdr__io_8C_source.php#l00935">XdrIO::read_serialized_nodes()</a>, <a class="el" href="off__io_8C_source.php#l00042">OFFIO::read_stream()</a>, <a class="el" href="matlab__io_8C_source.php#l00040">read_stream()</a>, <a class="el" href="vtk__io_8C_source.php#l00300">VTKIO::solution_to_vtk()</a>, <a class="el" href="xdr__io_8C_source.php#l00147">XdrIO::write()</a>, <a class="el" href="vtk__io_8C_source.php#l00619">VTKIO::write()</a>, <a class="el" href="tetgen__io_8C_source.php#l00252">TetGenIO::write()</a>, <a class="el" href="gmv__io_8C_source.php#l00256">GMVIO::write_ascii_new_impl()</a>, <a class="el" href="gmv__io_8C_source.php#l00530">GMVIO::write_ascii_old_impl()</a>, <a class="el" href="gmv__io_8C_source.php#l01108">GMVIO::write_binary()</a>, <a class="el" href="gmv__io_8C_source.php#l01501">GMVIO::write_discontinuous_gmv()</a>, <a class="el" href="unv__io_8C_source.php#l00308">UNVIO::write_implementation()</a>, <a class="el" href="ucd__io_8C_source.php#l00214">UCDIO::write_implementation()</a>, <a class="el" href="legacy__xdr__io_8C_source.php#l00635">LegacyXdrIO::write_mesh()</a>, <a class="el" href="gmsh__io_8C_source.php#l00620">GmshIO::write_mesh()</a>, <a class="el" href="gmsh__io_8C_source.php#l00705">GmshIO::write_post()</a>, <a class="el" href="xdr__io_8C_source.php#l00665">XdrIO::write_serialized_bcs()</a>, <a class="el" href="xdr__io_8C_source.php#l00229">XdrIO::write_serialized_connectivity()</a>, <a class="el" href="xdr__io_8C_source.php#l00527">XdrIO::write_serialized_nodes()</a>, and <a class="el" href="legacy__xdr__io_8C_source.php#l00997">LegacyXdrIO::write_soln()</a>.</p>

</div>
</div>
<a class="anchor" id="a3a6ccb2025cb0c6e64c6813acdada143"></a><!-- doxytag: member="MatlabIO::read" ref="a3a6ccb2025cb0c6e64c6813acdada143" args="(const std::string &amp;name)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void MatlabIO::read </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Reads in a matlab data file based on the string you pass it. </p>

<p>Implements <a class="el" href="classMeshInput.php#a9d70b68a1cf29ba6a123c9270aac0c07">MeshInput&lt; MeshBase &gt;</a>.</p>

<p>Definition at line <a class="el" href="matlab__io_8C_source.php#l00032">32</a> of file <a class="el" href="matlab__io_8C_source.php">matlab_io.C</a>.</p>

<p>References <a class="el" href="matlab__io_8C_source.php#l00040">read_stream()</a>.</p>

<p>Referenced by <a class="el" href="unstructured__mesh_8C_source.php#l00465">UnstructuredMesh::read()</a>.</p>
<div class="fragment"><pre class="fragment">{
  std::ifstream in (<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>.c_str());

  this-&gt;<a class="code" href="classMatlabIO.php#a207f96c9be8ef76f489b8b84e491e823">read_stream</a>(in);
}
</pre></div>
</div>
</div>
<a class="anchor" id="a207f96c9be8ef76f489b8b84e491e823"></a><!-- doxytag: member="MatlabIO::read_stream" ref="a207f96c9be8ef76f489b8b84e491e823" args="(std::istream &amp;in)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void MatlabIO::read_stream </td>
          <td>(</td>
          <td class="paramtype">std::istream &amp;&#160;</td>
          <td class="paramname"><em>in</em></td><td>)</td>
          <td><code> [private, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Implementation of the <a class="el" href="classMatlabIO.php#a3a6ccb2025cb0c6e64c6813acdada143">read()</a> function. This function is called by the public interface function and implements reading the file. </p>

<p>Definition at line <a class="el" href="matlab__io_8C_source.php#l00040">40</a> of file <a class="el" href="matlab__io_8C_source.php">matlab_io.C</a>.</p>

<p>References <a class="el" href="classMeshBase.php#a0f6974cf3e413cfe9caa1fcb4ce8153e">MeshBase::add_elem()</a>, <a class="el" href="classMeshBase.php#a01b66468d3e9d8b5db82c6f3d9131f5e">MeshBase::add_point()</a>, <a class="el" href="mesh__base_8C_source.php#l00117">MeshBase::clear()</a>, <a class="el" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshInput&lt; MeshBase &gt;::mesh()</a>, <a class="el" href="mesh__base_8h_source.php#l00140">MeshBase::mesh_dimension()</a>, <a class="el" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">MeshBase::node_ptr()</a>, <a class="el" href="libmesh__base_8h_source.php#l00088">libMesh::processor_id()</a>, <a class="el" href="dof__object_8h_source.php#l00458">DofObject::set_id()</a>, and <a class="el" href="elem_8h_source.php#l01187">Elem::set_node()</a>.</p>

<p>Referenced by <a class="el" href="matlab__io_8C_source.php#l00032">read()</a>.</p>
<div class="fragment"><pre class="fragment">{
  <span class="comment">// This is a serial-only process for now;</span>
  <span class="comment">// the Mesh should be read on processor 0 and</span>
  <span class="comment">// broadcast later</span>
  libmesh_assert(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0);

  <span class="comment">// Get a reference to the mesh</span>
  <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshInput&lt;MeshBase&gt;::mesh</a>();

  <span class="comment">// Clear any existing mesh data</span>
  mesh.<a class="code" href="classMeshBase.php#aefd56c4c29285d5e845f8869112b2b67">clear</a>();
  
  <span class="comment">// PDE toolkit only works in 2D</span>
  libmesh_assert(mesh.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>() == 2);

  <span class="comment">// Check the input buffer</span>
  libmesh_assert (in.good());

  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nNodes=0, nElem=0;

  in &gt;&gt; nNodes   <span class="comment">// Read the number of nodes</span>
     &gt;&gt; nElem;   <span class="comment">// Read the number of elements</span>

  <span class="comment">// Sort of check that it worked</span>
  libmesh_assert(nNodes &gt; 0);
  libmesh_assert(nElem &gt; 0);

  <span class="comment">// Read the nodal coordinates</span>
  {
    <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> x=0., y=0., z=0.;

    <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nNodes; i++)
      {
        in &gt;&gt; x   <span class="comment">// x-coordinate value</span>
           &gt;&gt; y;  <span class="comment">// y-coordinate value</span>

        mesh.<a class="code" href="classMeshBase.php#a01b66468d3e9d8b5db82c6f3d9131f5e">add_point</a> ( <a class="code" href="classPoint.php">Point</a>(x,y,z), i);
      }
  }

  <span class="comment">// Read the elements (elements)</span>
  {
    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node=0, dummy=0;
    
    <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nElem; i++)
      {
        <a class="code" href="classElem.php">Elem</a>* elem = <span class="keyword">new</span> <a class="code" href="classTri3.php">Tri3</a>; <span class="comment">// Always build a triangle</span>
        elem-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a>(i);
        mesh.<a class="code" href="classMeshBase.php#a0f6974cf3e413cfe9caa1fcb4ce8153e">add_elem</a> (elem);
        
        <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;3; n++)  <span class="comment">// Always read three 3 nodes</span>
          {
            in &gt;&gt; node;
            elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(n) = mesh.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(node-1);  <span class="comment">// Assign the node number</span>
          }
        
        <span class="comment">// There is an additional subdomain number here,</span>
        <span class="comment">// so we read it and get rid of it!</span>
        in &gt;&gt; dummy;
      }
  }
  
}
</pre></div>
</div>
</div>
<a class="anchor" id="a1261f0e7a0d6284c4a1e321d13c3c3ec"></a><!-- doxytag: member="MatlabIO::skip_comment_lines" ref="a1261f0e7a0d6284c4a1e321d13c3c3ec" args="(std::istream &amp;in, const char comment_start)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classMeshInput.php">MeshInput</a>&lt; <a class="el" href="classMeshBase.php">MeshBase</a>  &gt;::skip_comment_lines </td>
          <td>(</td>
          <td class="paramtype">std::istream &amp;&#160;</td>
          <td class="paramname"><em>in</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char&#160;</td>
          <td class="paramname"><em>comment_start</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Reads input from <code>in</code>, skipping all the lines that start with the character <code>comment_start</code>. </p>

<p>Referenced by <a class="el" href="tetgen__io_8C_source.php#l00033">TetGenIO::read()</a>, and <a class="el" href="ucd__io_8C_source.php#l00107">UCDIO::read_implementation()</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="matlab__io_8h_source.php">matlab_io.h</a></li>
<li><a class="el" href="matlab__io_8C_source.php">matlab_io.C</a></li>
</ul>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
