<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.php"><span>Classes</span></a></li>
      <li><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.php"><span>Class&#160;List</span></a></li>
      <li><a href="classes.php"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.php"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.php"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a>  </div>
  <div class="headertitle">
<h1>RefinementSelector Class Reference</h1>  </div>
</div>
<div class="contents">
<!-- doxytag: class="RefinementSelector" -->
<p><code>#include &lt;<a class="el" href="refinement__selector_8h_source.php">refinement_selector.h</a>&gt;</code></p>

<p><a href="classRefinementSelector-members.php">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classRefinementSelector.php#a8e7a9f23515246948381ff7bc92fc5e7">RefinementSelector</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classRefinementSelector.php#addddaebb143b3695f23809b93ef7acff">~RefinementSelector</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classRefinementSelector.php#a9891700e7928634b66a4359689f76ff9">select_refinement</a> (const <a class="el" href="classSystem.php">System</a> &amp;system)</td></tr>
<tr><td colspan="2"><h2><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">std::vector&lt; float &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classRefinementSelector.php#ab59c0cb5e36a5788c86424be2db92be3">component_scale</a></td></tr>
</table>
<hr/><a name="_details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This abstract class provides an interface to methods for selecting the type of refinement to be used on each element in a given mesh. Currently we assume that a set of elements has already been flagged for h refinement, and the only concrete subclass will change some of those elements to be flagged for p refinement. Future subclasses may handle anisotropic refinement instead.</p>
<dl class="author"><dt><b>Author:</b></dt><dd>Roy H. Stogner, 2006. </dd></dl>

<p>Definition at line <a class="el" href="refinement__selector_8h_source.php#l00046">46</a> of file <a class="el" href="refinement__selector_8h_source.php">refinement_selector.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a8e7a9f23515246948381ff7bc92fc5e7"></a><!-- doxytag: member="RefinementSelector::RefinementSelector" ref="a8e7a9f23515246948381ff7bc92fc5e7" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">RefinementSelector::RefinementSelector </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Constructor. Empty. </p>

<p>Definition at line <a class="el" href="refinement__selector_8h_source.php#l00053">53</a> of file <a class="el" href="refinement__selector_8h_source.php">refinement_selector.h</a>.</p>
<div class="fragment"><pre class="fragment">{}
</pre></div>
</div>
</div>
<a class="anchor" id="addddaebb143b3695f23809b93ef7acff"></a><!-- doxytag: member="RefinementSelector::~RefinementSelector" ref="addddaebb143b3695f23809b93ef7acff" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual RefinementSelector::~RefinementSelector </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Destructor. </p>

<p>Definition at line <a class="el" href="refinement__selector_8h_source.php#l00058">58</a> of file <a class="el" href="refinement__selector_8h_source.php">refinement_selector.h</a>.</p>
<div class="fragment"><pre class="fragment">{}
</pre></div>
</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a9891700e7928634b66a4359689f76ff9"></a><!-- doxytag: member="RefinementSelector::select_refinement" ref="a9891700e7928634b66a4359689f76ff9" args="(const System &amp;system)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void RefinementSelector::select_refinement </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classSystem.php">System</a> &amp;&#160;</td>
          <td class="paramname"><em>system</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>This pure virtual function must be redefined in derived classes to take a mesh flagged for h refinement and potentially change the desired refinement type. </p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="ab59c0cb5e36a5788c86424be2db92be3"></a><!-- doxytag: member="RefinementSelector::component_scale" ref="ab59c0cb5e36a5788c86424be2db92be3" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;float&gt; <a class="el" href="classRefinementSelector.php#ab59c0cb5e36a5788c86424be2db92be3">RefinementSelector::component_scale</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>This vector can be used to "scale" certain variables in a system. If the mask is not empty, the consideration given to each component will be scaled by component_scale[c]. </p>

<p>Definition at line <a class="el" href="refinement__selector_8h_source.php#l00075">75</a> of file <a class="el" href="refinement__selector_8h_source.php">refinement_selector.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="refinement__selector_8h_source.php">refinement_selector.h</a></li>
</ul>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
