<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.php"><span>Classes</span></a></li>
      <li><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.php"><span>Class&#160;List</span></a></li>
      <li><a href="classes.php"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.php"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.php"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<h1>Surface Class Reference</h1>  </div>
</div>
<div class="contents">
<!-- doxytag: class="Surface" -->
<p><code>#include &lt;<a class="el" href="surface_8h_source.php">surface.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Surface:</div>
<div class="dyncontent">
<div class="center"><img src="classSurface__inherit__graph.png" border="0" usemap="#Surface_inherit__map" alt="Inheritance graph"/></div>
<map name="Surface_inherit__map" id="Surface_inherit__map">
<area shape="rect" id="node3" href="classPlane.php" title="Plane" alt="" coords="5,83,61,112"/><area shape="rect" id="node5" href="classSphere.php" title="Sphere" alt="" coords="85,83,152,112"/></map>
<center><span class="legend">[<a href="graph_legend.php">legend</a>]</span></center></div>

<p><a href="classSurface-members.php">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSurface.php#a8fc57f2a15292135c00545c9d224ec68">Surface</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSurface.php#a6a06e68159b7c22878599d81b3defbdc">Surface</a> (const <a class="el" href="classSurface.php">Surface</a> &amp;)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSurface.php#a44ff6a911acc4ada428c3d734f342a8a">~Surface</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSurface.php#a37cfeede124f5d1e9ada0ce5c791706a">above_surface</a> (const <a class="el" href="classPoint.php">Point</a> &amp;p) const =0</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSurface.php#a3105b56b3069916cb60dbb5afa5f6a62">below_surface</a> (const <a class="el" href="classPoint.php">Point</a> &amp;p) const =0</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSurface.php#aaa7f101ff25a02957c7a9e53e6d57532">on_surface</a> (const <a class="el" href="classPoint.php">Point</a> &amp;p) const =0</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classPoint.php">Point</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSurface.php#aae21735f15cf140d7c313d66226e007f">closest_point</a> (const <a class="el" href="classPoint.php">Point</a> &amp;p) const =0</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classPoint.php">Point</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSurface.php#a8d8a8631247ff64332be872c5828be5a">unit_normal</a> (const <a class="el" href="classPoint.php">Point</a> &amp;p) const =0</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classPoint.php">Point</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSurface.php#a00afc929b46acf6554a5be50c79a5769">surface_coords</a> (const <a class="el" href="classPoint.php">Point</a> &amp;world_coords) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classPoint.php">Point</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSurface.php#a1e47cede5e7f87673132d27ef72633bb">world_coords</a> (const <a class="el" href="classPoint.php">Point</a> &amp;surf_coords) const </td></tr>
</table>
<hr/><a name="_details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This class defines a surface. A surface is a two-dimensional object living in three-dimensional space. Examples of surfaces are planes, hollow spheres, hollow cylinders, etc... This is a generic base class that describes the useful functionality a surface will provide. Specific derived classes actually implement the functionality, so this class has pure virtual members.</p>
<dl class="author"><dt><b>Author:</b></dt><dd>Benjamin S. Kirk, 2002 </dd></dl>

<p>Definition at line <a class="el" href="surface_8h_source.php#l00044">44</a> of file <a class="el" href="surface_8h_source.php">surface.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a8fc57f2a15292135c00545c9d224ec68"></a><!-- doxytag: member="Surface::Surface" ref="a8fc57f2a15292135c00545c9d224ec68" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Surface::Surface </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Constructor. Does nothing at the moment. </p>

<p>Definition at line <a class="el" href="surface_8h_source.php#l00051">51</a> of file <a class="el" href="surface_8h_source.php">surface.h</a>.</p>
<div class="fragment"><pre class="fragment">{}
</pre></div>
</div>
</div>
<a class="anchor" id="a6a06e68159b7c22878599d81b3defbdc"></a><!-- doxytag: member="Surface::Surface" ref="a6a06e68159b7c22878599d81b3defbdc" args="(const Surface &amp;)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Surface::Surface </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classSurface.php">Surface</a> &amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Copy-constructor. </p>

<p>Definition at line <a class="el" href="surface_8h_source.php#l00056">56</a> of file <a class="el" href="surface_8h_source.php">surface.h</a>.</p>
<div class="fragment"><pre class="fragment">{}
</pre></div>
</div>
</div>
<a class="anchor" id="a44ff6a911acc4ada428c3d734f342a8a"></a><!-- doxytag: member="Surface::~Surface" ref="a44ff6a911acc4ada428c3d734f342a8a" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual Surface::~Surface </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Destructor. </p>

<p>Definition at line <a class="el" href="surface_8h_source.php#l00061">61</a> of file <a class="el" href="surface_8h_source.php">surface.h</a>.</p>
<div class="fragment"><pre class="fragment">{}
</pre></div>
</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a37cfeede124f5d1e9ada0ce5c791706a"></a><!-- doxytag: member="Surface::above_surface" ref="a37cfeede124f5d1e9ada0ce5c791706a" args="(const Point &amp;p) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool Surface::above_surface </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classPoint.php">Point</a> &amp;&#160;</td>
          <td class="paramname"><em>p</em></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl class="return"><dt><b>Returns:</b></dt><dd>true if the point p is above the surface, false otherwise. </dd></dl>

<p>Implemented in <a class="el" href="classPlane.php#a4602c3eac515d90e7391b44f661eb0f9">Plane</a>, and <a class="el" href="classSphere.php#a7c55ddf6e71f18aec75c7b836d75b84f">Sphere</a>.</p>

</div>
</div>
<a class="anchor" id="a3105b56b3069916cb60dbb5afa5f6a62"></a><!-- doxytag: member="Surface::below_surface" ref="a3105b56b3069916cb60dbb5afa5f6a62" args="(const Point &amp;p) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool Surface::below_surface </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classPoint.php">Point</a> &amp;&#160;</td>
          <td class="paramname"><em>p</em></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl class="return"><dt><b>Returns:</b></dt><dd>true if the point p is below the surface, false otherwise. </dd></dl>

<p>Implemented in <a class="el" href="classPlane.php#ab7ab4751a24bb7211cfea1796216b1c0">Plane</a>, and <a class="el" href="classSphere.php#a97a59b2ab1a320b4739b52b388387a68">Sphere</a>.</p>

</div>
</div>
<a class="anchor" id="aae21735f15cf140d7c313d66226e007f"></a><!-- doxytag: member="Surface::closest_point" ref="aae21735f15cf140d7c313d66226e007f" args="(const Point &amp;p) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classPoint.php">Point</a> Surface::closest_point </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classPoint.php">Point</a> &amp;&#160;</td>
          <td class="paramname"><em>p</em></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl class="return"><dt><b>Returns:</b></dt><dd>the closest point on the surface to point p. </dd></dl>

<p>Implemented in <a class="el" href="classPlane.php#a501daecf11d3b630e00a9d9146fc056e">Plane</a>, and <a class="el" href="classSphere.php#a2d75d8d43b1e2d5549a068c7167d97e6">Sphere</a>.</p>

</div>
</div>
<a class="anchor" id="aaa7f101ff25a02957c7a9e53e6d57532"></a><!-- doxytag: member="Surface::on_surface" ref="aaa7f101ff25a02957c7a9e53e6d57532" args="(const Point &amp;p) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool Surface::on_surface </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classPoint.php">Point</a> &amp;&#160;</td>
          <td class="paramname"><em>p</em></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl class="return"><dt><b>Returns:</b></dt><dd>true if the point p is on the surface, false otherwise. Note that the definition of on the surface really means "very close" to account for roundoff error. </dd></dl>

<p>Implemented in <a class="el" href="classPlane.php#adb2b4ea766a9da6df0e131825c8d1cff">Plane</a>, and <a class="el" href="classSphere.php#aa76dbb36091a83101c8812ec96913193">Sphere</a>.</p>

</div>
</div>
<a class="anchor" id="a00afc929b46acf6554a5be50c79a5769"></a><!-- doxytag: member="Surface::surface_coords" ref="a00afc929b46acf6554a5be50c79a5769" args="(const Point &amp;world_coords) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classPoint.php">Point</a> Surface::surface_coords </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classPoint.php">Point</a> &amp;&#160;</td>
          <td class="paramname"><em>world_coords</em></td><td>)</td>
          <td> const<code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl class="return"><dt><b>Returns:</b></dt><dd>the <code><a class="el" href="classPoint.php">Point</a></code> <code>world_coords</code> in the surface's coordinate system. <code>world_coords</code> is in the world coordinate system. This method is not purely virtual, because there may be surfaces that do not have an own coordinate system. These simply do not have to overload this method. </dd></dl>

<p>Reimplemented in <a class="el" href="classSphere.php#abf39c91886c0d9e5e8cfc6f1f8bf3a51">Sphere</a>.</p>

<p>Definition at line <a class="el" href="surface_8h_source.php#l00120">120</a> of file <a class="el" href="surface_8h_source.php">surface.h</a>.</p>
<div class="fragment"><pre class="fragment">{
  <a class="code" href="classPoint.php">Point</a> p (world_coords);
  <span class="keywordflow">return</span> p;
}
</pre></div>
</div>
</div>
<a class="anchor" id="a8d8a8631247ff64332be872c5828be5a"></a><!-- doxytag: member="Surface::unit_normal" ref="a8d8a8631247ff64332be872c5828be5a" args="(const Point &amp;p) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classPoint.php">Point</a> Surface::unit_normal </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classPoint.php">Point</a> &amp;&#160;</td>
          <td class="paramname"><em>p</em></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl class="return"><dt><b>Returns:</b></dt><dd>a unit vector normal to the surface at point p. </dd></dl>

<p>Implemented in <a class="el" href="classPlane.php#a7ea7aadc47cd4adec76933cf2d445553">Plane</a>, and <a class="el" href="classSphere.php#a60b23e8ca4e87e8f0b1637546d4fb869">Sphere</a>.</p>

</div>
</div>
<a class="anchor" id="a1e47cede5e7f87673132d27ef72633bb"></a><!-- doxytag: member="Surface::world_coords" ref="a1e47cede5e7f87673132d27ef72633bb" args="(const Point &amp;surf_coords) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classPoint.php">Point</a> Surface::world_coords </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classPoint.php">Point</a> &amp;&#160;</td>
          <td class="paramname"><em>surf_coords</em></td><td>)</td>
          <td> const<code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl class="return"><dt><b>Returns:</b></dt><dd>the world (cartesian) coordinates for the surface coordinates <code>surf_coords</code>. This method is not purely virtual, because there may be surfaces that do not have an own coordinate system. These simply do not have to overload this method. </dd></dl>

<p>Reimplemented in <a class="el" href="classSphere.php#afa113ecc10c66fa8ba2e2c22626b32fe">Sphere</a>.</p>

<p>Definition at line <a class="el" href="surface_8h_source.php#l00129">129</a> of file <a class="el" href="surface_8h_source.php">surface.h</a>.</p>
<div class="fragment"><pre class="fragment">{
  <a class="code" href="classPoint.php">Point</a> p (surf_coords);
  <span class="keywordflow">return</span> p;
}
</pre></div>
</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="surface_8h_source.php">surface.h</a></li>
</ul>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
