<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>continuation_system.h</h1>  </div>
</div>
<div class="contents">
<a href="continuation__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: continuation_system.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __continuation_system_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __continuation_system_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="fem__system_8h.php">fem_system.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Forward Declarations</span>
<a name="l00031"></a>00031 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classLinearSolver.php">LinearSolver</a>;
<a name="l00032"></a>00032 <span class="keyword">class </span><a class="code" href="classNewtonSolver.php">NewtonSolver</a>;
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00055"></a><a class="code" href="classContinuationSystem.php">00055</a> <span class="keyword">class </span><a class="code" href="classContinuationSystem.php">ContinuationSystem</a> : <span class="keyword">public</span> <a class="code" href="classFEMSystem.php">FEMSystem</a>
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057 <span class="keyword">public</span>:
<a name="l00062"></a>00062   <a class="code" href="classContinuationSystem.php#aaea8d3dfeca094eaa136aa801e0602a4">ContinuationSystem</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00063"></a>00063                       <span class="keyword">const</span> std::string&amp; <a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>,
<a name="l00064"></a>00064                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">number</a>);
<a name="l00065"></a>00065 
<a name="l00069"></a>00069   <span class="keyword">virtual</span> <a class="code" href="classContinuationSystem.php#af629ad0916ccf8e72970aef9d12755c3">~ContinuationSystem</a> ();
<a name="l00070"></a>00070 
<a name="l00074"></a><a class="code" href="classContinuationSystem.php#a6c63264ab05fceb33fb56c4e63fd82db">00074</a>   <span class="keyword">typedef</span> <a class="code" href="classContinuationSystem.php">ContinuationSystem</a> <a class="code" href="classContinuationSystem.php#a6c63264ab05fceb33fb56c4e63fd82db">sys_type</a>;
<a name="l00075"></a>00075 
<a name="l00079"></a><a class="code" href="classContinuationSystem.php#a6dd5067df610497f31c18f1e378ed771">00079</a>   <span class="keyword">typedef</span> <a class="code" href="classFEMSystem.php">FEMSystem</a> <a class="code" href="classContinuationSystem.php#a6dd5067df610497f31c18f1e378ed771">Parent</a>;
<a name="l00080"></a>00080   
<a name="l00085"></a>00085   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classContinuationSystem.php#ae7ecba187782ef81987dd7238e7884eb">clear</a> ();
<a name="l00086"></a>00086 
<a name="l00090"></a>00090   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classContinuationSystem.php#a618eff9ade61bac0772011e3d039d240">solve</a>();
<a name="l00091"></a>00091   
<a name="l00098"></a>00098   <span class="keywordtype">void</span> <a class="code" href="classContinuationSystem.php#ac5db6064e83a2ded7e54a34b268fcaf0">continuation_solve</a>();
<a name="l00099"></a>00099 
<a name="l00104"></a>00104   <span class="keywordtype">void</span> <a class="code" href="classContinuationSystem.php#ac9bb0018abc53bff0ef04fe356fda45b">advance_arcstep</a>();
<a name="l00105"></a>00105   
<a name="l00115"></a><a class="code" href="classContinuationSystem.php#a5850beafb36289a8f6057bbffac96c57">00115</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>* <a class="code" href="classContinuationSystem.php#a5850beafb36289a8f6057bbffac96c57">continuation_parameter</a>;
<a name="l00116"></a>00116 
<a name="l00121"></a><a class="code" href="classContinuationSystem.php#aba940d7aed8afbed487f1a8ae21c89d9">00121</a>   <span class="keywordtype">bool</span> <a class="code" href="classContinuationSystem.php#aba940d7aed8afbed487f1a8ae21c89d9">quiet</a>;
<a name="l00122"></a>00122 
<a name="l00128"></a><a class="code" href="classContinuationSystem.php#a297c43af044eeadd99a8fc08fa8e390b">00128</a>   <span class="keywordtype">void</span> <a class="code" href="classContinuationSystem.php#a297c43af044eeadd99a8fc08fa8e390b">set_max_arclength_stepsize</a>(<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> maxds) { <a class="code" href="classContinuationSystem.php#a5e17ce5db305e2031df3c1545e6f1577">ds</a>=maxds; <a class="code" href="classContinuationSystem.php#a7490bb8212f6e1cae64b4c66e19452f5">ds_current</a>=maxds; }
<a name="l00129"></a>00129   
<a name="l00134"></a><a class="code" href="classContinuationSystem.php#a4c6026d4a740fc13151317e89a22e38f">00134</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classContinuationSystem.php#a4c6026d4a740fc13151317e89a22e38f">continuation_parameter_tolerance</a>;
<a name="l00135"></a>00135 
<a name="l00140"></a><a class="code" href="classContinuationSystem.php#a6b80de02c3fc03c160e9100fac1ecaa6">00140</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classContinuationSystem.php#a6b80de02c3fc03c160e9100fac1ecaa6">solution_tolerance</a>;
<a name="l00141"></a>00141 
<a name="l00147"></a><a class="code" href="classContinuationSystem.php#af84059046ff164bf3e226d82483a71fe">00147</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classContinuationSystem.php#af84059046ff164bf3e226d82483a71fe">initial_newton_tolerance</a>;
<a name="l00148"></a>00148   
<a name="l00156"></a>00156   <span class="keywordtype">void</span> <a class="code" href="classContinuationSystem.php#aebfded1e2e3f5571a3daa4e5514bbbd1">save_current_solution</a>();
<a name="l00157"></a>00157 
<a name="l00161"></a><a class="code" href="classContinuationSystem.php#a26aacc4912f2695aac79925fb06f2b2a">00161</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classContinuationSystem.php#a26aacc4912f2695aac79925fb06f2b2a">old_continuation_parameter</a>;
<a name="l00162"></a>00162 
<a name="l00167"></a><a class="code" href="classContinuationSystem.php#ad8ad6a083f28ee199c5a87a6ae67bc0e">00167</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classContinuationSystem.php#ad8ad6a083f28ee199c5a87a6ae67bc0e">min_continuation_parameter</a>;
<a name="l00168"></a>00168 
<a name="l00174"></a><a class="code" href="classContinuationSystem.php#a3faf700dd3121a84cce17239982be5e2">00174</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classContinuationSystem.php#a3faf700dd3121a84cce17239982be5e2">max_continuation_parameter</a>;
<a name="l00175"></a>00175 
<a name="l00181"></a><a class="code" href="classContinuationSystem.php#afe689d3ea706b719e5e61a430e142b31">00181</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classContinuationSystem.php#afe689d3ea706b719e5e61a430e142b31">Theta</a>;
<a name="l00182"></a>00182   
<a name="l00188"></a><a class="code" href="classContinuationSystem.php#a3e9164f932c5ab82cebd82405b5d61b9">00188</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classContinuationSystem.php#a3e9164f932c5ab82cebd82405b5d61b9">Theta_LOCA</a>;
<a name="l00189"></a>00189 
<a name="l00195"></a>00195   <span class="comment">//Real tau;</span>
<a name="l00196"></a>00196 
<a name="l00202"></a><a class="code" href="classContinuationSystem.php#ac9638420f813c72d27e5d017b5e77ab4">00202</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classContinuationSystem.php#ac9638420f813c72d27e5d017b5e77ab4">n_backtrack_steps</a>;
<a name="l00203"></a>00203 
<a name="l00209"></a><a class="code" href="classContinuationSystem.php#af446c6a215f6973c06a477a356b4eb29">00209</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classContinuationSystem.php#af446c6a215f6973c06a477a356b4eb29">n_arclength_reductions</a>;
<a name="l00210"></a>00210 
<a name="l00214"></a><a class="code" href="classContinuationSystem.php#ac44a1885509e69da0cc48783844cb416">00214</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classContinuationSystem.php#ac44a1885509e69da0cc48783844cb416">ds_min</a>;
<a name="l00215"></a>00215 
<a name="l00221"></a><a class="code" href="classContinuationSystem.php#ad3acbe877cce535847a6256ebc7fbdf1">00221</a>   <span class="keyword">enum</span> <a class="code" href="classContinuationSystem.php#ad3acbe877cce535847a6256ebc7fbdf1">Predictor</a> {
<a name="l00225"></a><a class="code" href="classContinuationSystem.php#ad3acbe877cce535847a6256ebc7fbdf1afdcc67d75e2b5f29fe823f9f034eeef5">00225</a>     <a class="code" href="classContinuationSystem.php#ad3acbe877cce535847a6256ebc7fbdf1afdcc67d75e2b5f29fe823f9f034eeef5">Euler</a>,
<a name="l00226"></a>00226 
<a name="l00230"></a><a class="code" href="classContinuationSystem.php#ad3acbe877cce535847a6256ebc7fbdf1ab54e96a63051219d7fba51a28994f70d">00230</a>     <a class="code" href="classContinuationSystem.php#ad3acbe877cce535847a6256ebc7fbdf1ab54e96a63051219d7fba51a28994f70d">AB2</a>,
<a name="l00231"></a>00231 
<a name="l00235"></a><a class="code" href="classContinuationSystem.php#ad3acbe877cce535847a6256ebc7fbdf1a152396b066c5dc2a3cc3eb6d7b7d9aed">00235</a>     <a class="code" href="classContinuationSystem.php#ad3acbe877cce535847a6256ebc7fbdf1a152396b066c5dc2a3cc3eb6d7b7d9aed">Invalid_Predictor</a>
<a name="l00236"></a>00236   };
<a name="l00237"></a>00237 
<a name="l00238"></a><a class="code" href="classContinuationSystem.php#a7b4093aad95dba9d254d32dd77bf289e">00238</a>   <a class="code" href="classContinuationSystem.php#ad3acbe877cce535847a6256ebc7fbdf1">Predictor</a> <a class="code" href="classContinuationSystem.php#a7b4093aad95dba9d254d32dd77bf289e">predictor</a>;
<a name="l00239"></a>00239 
<a name="l00247"></a><a class="code" href="classContinuationSystem.php#ac26a043d21806b211db92aad5b9f5068">00247</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classContinuationSystem.php#ac26a043d21806b211db92aad5b9f5068">newton_stepgrowth_aggressiveness</a>;
<a name="l00248"></a>00248 
<a name="l00256"></a><a class="code" href="classContinuationSystem.php#a4198c02853f3548d1508bc690d521a7a">00256</a>   <span class="keywordtype">bool</span> <a class="code" href="classContinuationSystem.php#a4198c02853f3548d1508bc690d521a7a">newton_progress_check</a>;
<a name="l00257"></a>00257   
<a name="l00258"></a>00258 <span class="keyword">protected</span>:
<a name="l00263"></a>00263   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classContinuationSystem.php#aae1e8ef3137dcfa02cc1e96490d663f2">init_data</a> ();
<a name="l00264"></a>00264 
<a name="l00286"></a><a class="code" href="classContinuationSystem.php#adab4bd86e374548da173a11d27d0e0ae">00286</a>   <span class="keyword">enum</span> <a class="code" href="classContinuationSystem.php#adab4bd86e374548da173a11d27d0e0ae">RHS_Mode</a> {<a class="code" href="classContinuationSystem.php#adab4bd86e374548da173a11d27d0e0aeace737916cb7aefd379e1811c5ba24c98">Residual</a>,
<a name="l00287"></a><a class="code" href="classContinuationSystem.php#adab4bd86e374548da173a11d27d0e0aeaec07fc2bec9c0003b0ec1cc644734d21">00287</a>                  <a class="code" href="classContinuationSystem.php#adab4bd86e374548da173a11d27d0e0aeaec07fc2bec9c0003b0ec1cc644734d21">G_Lambda</a>};
<a name="l00288"></a>00288   
<a name="l00289"></a><a class="code" href="classContinuationSystem.php#a7fff96efdbbaafa870422ede293a679a">00289</a>   <a class="code" href="classContinuationSystem.php#adab4bd86e374548da173a11d27d0e0ae">RHS_Mode</a> <a class="code" href="classContinuationSystem.php#a7fff96efdbbaafa870422ede293a679a">rhs_mode</a>;
<a name="l00290"></a>00290 
<a name="l00291"></a>00291 
<a name="l00292"></a>00292 
<a name="l00293"></a>00293 <span class="keyword">private</span>:
<a name="l00300"></a>00300   <span class="keywordtype">void</span> <a class="code" href="classContinuationSystem.php#a0c4a5b2215e4c84bdfbdd7e7bf2bbc45">initialize_tangent</a>();
<a name="l00301"></a>00301 
<a name="l00305"></a>00305   <span class="keywordtype">void</span> <a class="code" href="classContinuationSystem.php#ab82a1834c7abb09cd1656f421529b803">solve_tangent</a>();
<a name="l00306"></a>00306 
<a name="l00312"></a>00312   <span class="keywordtype">void</span> <a class="code" href="classContinuationSystem.php#a04ca7b8afa0212f6b5cddc6f1118d415">update_solution</a>();
<a name="l00313"></a>00313 
<a name="l00317"></a>00317   <span class="keywordtype">void</span> <a class="code" href="classContinuationSystem.php#abf39505fccd5becd1922b2c922513a73">set_Theta</a>();
<a name="l00318"></a>00318 
<a name="l00323"></a>00323   <span class="keywordtype">void</span> <a class="code" href="classContinuationSystem.php#a835b5c0d6b9b6f523e293b5fb3a7b15b">set_Theta_LOCA</a>();
<a name="l00324"></a>00324 
<a name="l00329"></a>00329   <span class="keywordtype">void</span> <a class="code" href="classContinuationSystem.php#a1b7c051f596bb7aa5b16b73408f19cc3">apply_predictor</a>();
<a name="l00330"></a>00330   
<a name="l00338"></a><a class="code" href="classContinuationSystem.php#a99d8eceb31d2bbd6aba72ac495b7240e">00338</a>   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* <a class="code" href="classContinuationSystem.php#a99d8eceb31d2bbd6aba72ac495b7240e">du_ds</a>;
<a name="l00339"></a>00339 
<a name="l00343"></a><a class="code" href="classContinuationSystem.php#a47957227164fda9733513756e39925ea">00343</a>   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* <a class="code" href="classContinuationSystem.php#a47957227164fda9733513756e39925ea">previous_du_ds</a>;
<a name="l00344"></a>00344 
<a name="l00348"></a><a class="code" href="classContinuationSystem.php#affdf1a8491e5f1290df6cefb0841d217">00348</a>   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* <a class="code" href="classContinuationSystem.php#affdf1a8491e5f1290df6cefb0841d217">previous_u</a>;
<a name="l00349"></a>00349 
<a name="l00353"></a><a class="code" href="classContinuationSystem.php#a830cc86c1134f9618c01360e1a07d9b1">00353</a>   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* <a class="code" href="classContinuationSystem.php#a830cc86c1134f9618c01360e1a07d9b1">y</a>;
<a name="l00354"></a>00354 
<a name="l00359"></a><a class="code" href="classContinuationSystem.php#acb0a9b3ec10c178e997036e55186ea15">00359</a>   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* <a class="code" href="classContinuationSystem.php#acb0a9b3ec10c178e997036e55186ea15">y_old</a>;
<a name="l00360"></a>00360 
<a name="l00364"></a><a class="code" href="classContinuationSystem.php#a170c3e7f37ee7170fa42054ae9315c2a">00364</a>   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* <a class="code" href="classContinuationSystem.php#a170c3e7f37ee7170fa42054ae9315c2a">z</a>;
<a name="l00365"></a>00365 
<a name="l00370"></a><a class="code" href="classContinuationSystem.php#a846f6b079e8b48bbda06b9e2b499d28b">00370</a>   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* <a class="code" href="classContinuationSystem.php#a846f6b079e8b48bbda06b9e2b499d28b">delta_u</a>;
<a name="l00371"></a>00371 
<a name="l00377"></a><a class="code" href="classContinuationSystem.php#a0e8a9732992685ca22208038a9454476">00377</a>   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;LinearSolver&lt;Number&gt;</a> &gt; <a class="code" href="classContinuationSystem.php#a0e8a9732992685ca22208038a9454476">linear_solver</a>;
<a name="l00378"></a>00378   
<a name="l00382"></a><a class="code" href="classContinuationSystem.php#aa61c7f58e3ecd3b75ee6f7fede3bb11e">00382</a>   <span class="keywordtype">bool</span> <a class="code" href="classContinuationSystem.php#aa61c7f58e3ecd3b75ee6f7fede3bb11e">tangent_initialized</a>;
<a name="l00383"></a>00383 
<a name="l00389"></a><a class="code" href="classContinuationSystem.php#acee9bcc4f50f1c56df4ad0387636b897">00389</a>   <a class="code" href="classNewtonSolver.php">NewtonSolver</a>* <a class="code" href="classContinuationSystem.php#acee9bcc4f50f1c56df4ad0387636b897">newton_solver</a>;
<a name="l00390"></a>00390   
<a name="l00396"></a><a class="code" href="classContinuationSystem.php#a63d4406dad44196f7d5c2f9ac77acae8">00396</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classContinuationSystem.php#a63d4406dad44196f7d5c2f9ac77acae8">dlambda_ds</a>;
<a name="l00397"></a>00397 
<a name="l00403"></a><a class="code" href="classContinuationSystem.php#a5e17ce5db305e2031df3c1545e6f1577">00403</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classContinuationSystem.php#a5e17ce5db305e2031df3c1545e6f1577">ds</a>;
<a name="l00404"></a>00404   
<a name="l00409"></a><a class="code" href="classContinuationSystem.php#a7490bb8212f6e1cae64b4c66e19452f5">00409</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classContinuationSystem.php#a7490bb8212f6e1cae64b4c66e19452f5">ds_current</a>;
<a name="l00410"></a>00410 
<a name="l00414"></a><a class="code" href="classContinuationSystem.php#a533d677c9239775290cc7e45b7bb7225">00414</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classContinuationSystem.php#a533d677c9239775290cc7e45b7bb7225">previous_dlambda_ds</a>;
<a name="l00415"></a>00415 
<a name="l00419"></a><a class="code" href="classContinuationSystem.php#a95f4bb8745c05a179c6563f8205c2f25">00419</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classContinuationSystem.php#a95f4bb8745c05a179c6563f8205c2f25">previous_ds</a>;
<a name="l00420"></a>00420 
<a name="l00424"></a><a class="code" href="classContinuationSystem.php#aac5cc022af28b5849d470c5956ab4bb0">00424</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classContinuationSystem.php#aac5cc022af28b5849d470c5956ab4bb0">newton_step</a>;
<a name="l00425"></a>00425 };
<a name="l00426"></a>00426 
<a name="l00427"></a>00427 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
