<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>coupling_matrix.h</h1>  </div>
</div>
<div class="contents">
<a href="coupling__matrix_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: coupling_matrix.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __coupling_matrix_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __coupling_matrix_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00041"></a><a class="code" href="classCouplingMatrix.php">00041</a> <span class="keyword">class </span><a class="code" href="classCouplingMatrix.php">CouplingMatrix</a>
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043 <span class="keyword">public</span>:
<a name="l00044"></a>00044   
<a name="l00048"></a>00048   <a class="code" href="classCouplingMatrix.php#a27461cd0e280757b87b97f4051f419f6">CouplingMatrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0);
<a name="l00049"></a>00049 
<a name="l00053"></a>00053   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="classCouplingMatrix.php#a50d7daefb61625abc6f03782ab138070">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00054"></a>00054                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span>;
<a name="l00055"></a>00055   
<a name="l00060"></a>00060   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> &amp; <a class="code" href="classCouplingMatrix.php#a50d7daefb61625abc6f03782ab138070">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00061"></a>00061                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j);
<a name="l00062"></a>00062   
<a name="l00067"></a>00067   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classCouplingMatrix.php#a873ea83161bff58bc9f4b5ff771500ea">size</a>() <span class="keyword">const</span>;
<a name="l00068"></a>00068 
<a name="l00073"></a>00073   <span class="keywordtype">void</span> <a class="code" href="classCouplingMatrix.php#a4e4d272c9773d38902de9a9068ca6229">resize</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l00074"></a>00074 
<a name="l00078"></a>00078   <span class="keywordtype">void</span> <a class="code" href="classCouplingMatrix.php#aa0f80d14dabd7a4dba808b4b0ed3cf0a">clear</a>();
<a name="l00079"></a>00079 
<a name="l00083"></a>00083   <span class="keywordtype">bool</span> <a class="code" href="classCouplingMatrix.php#aed22bc105cd6bd1925ebbdc1e833848e">empty</a>() <span class="keyword">const</span>;
<a name="l00084"></a>00084   
<a name="l00085"></a>00085 <span class="keyword">private</span>:
<a name="l00086"></a>00086   
<a name="l00093"></a><a class="code" href="classCouplingMatrix.php#a76d27153a0a07a0a55052d310a86f7e6">00093</a>   std::vector&lt;unsigned char&gt; <a class="code" href="classCouplingMatrix.php#a76d27153a0a07a0a55052d310a86f7e6">_values</a>;  
<a name="l00094"></a>00094 
<a name="l00098"></a><a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">00098</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a>;
<a name="l00099"></a>00099 };
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 <span class="comment">//--------------------------------------------------</span>
<a name="l00107"></a>00107 <span class="comment">// CouplingMatrix inline methods</span>
<a name="l00108"></a>00108 <span class="keyword">inline</span>
<a name="l00109"></a><a class="code" href="classCouplingMatrix.php#a27461cd0e280757b87b97f4051f419f6">00109</a> <a class="code" href="classCouplingMatrix.php#a27461cd0e280757b87b97f4051f419f6">CouplingMatrix::CouplingMatrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) :
<a name="l00110"></a>00110   _size(n)
<a name="l00111"></a>00111 {
<a name="l00112"></a>00112   this-&gt;<a class="code" href="classCouplingMatrix.php#a4e4d272c9773d38902de9a9068ca6229">resize</a>(n);
<a name="l00113"></a>00113 }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 <span class="keyword">inline</span>
<a name="l00118"></a><a class="code" href="classCouplingMatrix.php#a50d7daefb61625abc6f03782ab138070">00118</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="classCouplingMatrix.php#a50d7daefb61625abc6f03782ab138070">CouplingMatrix::operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00119"></a>00119                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const</span>
<a name="l00120"></a>00120 <span class="keyword"></span>{
<a name="l00121"></a>00121   libmesh_assert (i &lt; <a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a>);
<a name="l00122"></a>00122   libmesh_assert (j &lt; <a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a>);
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <span class="keywordflow">return</span> <a class="code" href="classCouplingMatrix.php#a76d27153a0a07a0a55052d310a86f7e6">_values</a>[i*<a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a> + j];
<a name="l00125"></a>00125 }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 <span class="keyword">inline</span>
<a name="l00130"></a><a class="code" href="classCouplingMatrix.php#a65795b99e2b1c8b4bf1080021a680856">00130</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> &amp; <a class="code" href="classCouplingMatrix.php#a50d7daefb61625abc6f03782ab138070">CouplingMatrix::operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00131"></a>00131                                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)
<a name="l00132"></a>00132 {
<a name="l00133"></a>00133   libmesh_assert (i &lt; <a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a>);
<a name="l00134"></a>00134   libmesh_assert (j &lt; <a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a>);
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   <span class="keywordflow">return</span> <a class="code" href="classCouplingMatrix.php#a76d27153a0a07a0a55052d310a86f7e6">_values</a>[i*<a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a> + j];
<a name="l00137"></a>00137 }
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 <span class="keyword">inline</span>
<a name="l00142"></a><a class="code" href="classCouplingMatrix.php#a873ea83161bff58bc9f4b5ff771500ea">00142</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classCouplingMatrix.php#a873ea83161bff58bc9f4b5ff771500ea">CouplingMatrix::size</a>()<span class="keyword"> const</span>
<a name="l00143"></a>00143 <span class="keyword"></span>{
<a name="l00144"></a>00144   <span class="keywordflow">return</span> <a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a>;
<a name="l00145"></a>00145 }
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 <span class="keyword">inline</span>
<a name="l00150"></a><a class="code" href="classCouplingMatrix.php#a4e4d272c9773d38902de9a9068ca6229">00150</a> <span class="keywordtype">void</span> <a class="code" href="classCouplingMatrix.php#a4e4d272c9773d38902de9a9068ca6229">CouplingMatrix::resize</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00151"></a>00151 {
<a name="l00152"></a>00152   <a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a> = n;
<a name="l00153"></a>00153 
<a name="l00154"></a>00154   <a class="code" href="classCouplingMatrix.php#a76d27153a0a07a0a55052d310a86f7e6">_values</a>.resize(<a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a>*<a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a>);
<a name="l00155"></a>00155 
<a name="l00156"></a>00156   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classCouplingMatrix.php#a76d27153a0a07a0a55052d310a86f7e6">_values</a>.size(); i++)
<a name="l00157"></a>00157     <a class="code" href="classCouplingMatrix.php#a76d27153a0a07a0a55052d310a86f7e6">_values</a>[i] = 0;
<a name="l00158"></a>00158 }
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 <span class="keyword">inline</span>
<a name="l00163"></a><a class="code" href="classCouplingMatrix.php#aa0f80d14dabd7a4dba808b4b0ed3cf0a">00163</a> <span class="keywordtype">void</span> <a class="code" href="classCouplingMatrix.php#aa0f80d14dabd7a4dba808b4b0ed3cf0a">CouplingMatrix::clear</a>()
<a name="l00164"></a>00164 {
<a name="l00165"></a>00165   <a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a> = 0;
<a name="l00166"></a>00166 
<a name="l00167"></a>00167   <a class="code" href="classCouplingMatrix.php#a76d27153a0a07a0a55052d310a86f7e6">_values</a>.clear();
<a name="l00168"></a>00168 }
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 <span class="keyword">inline</span>
<a name="l00173"></a><a class="code" href="classCouplingMatrix.php#aed22bc105cd6bd1925ebbdc1e833848e">00173</a> <span class="keywordtype">bool</span> <a class="code" href="classCouplingMatrix.php#aed22bc105cd6bd1925ebbdc1e833848e">CouplingMatrix::empty</a>()<span class="keyword"> const</span>
<a name="l00174"></a>00174 <span class="keyword"></span>{
<a name="l00175"></a>00175   <span class="keywordflow">return</span> (<a class="code" href="classCouplingMatrix.php#ae04509ff743b77bceb1ee7212223e16c">_size</a> == 0);
<a name="l00176"></a>00176 }
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
