<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_f10759d5ac6297fe611079c3c15b8f2c.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>dense_matrix.C</h1>  </div>
</div>
<div class="contents">
<a href="dense__matrix_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: dense_matrix.C 3492 2009-10-10 02:23:41Z jwpeterson $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ Includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;cmath&gt;</span> <span class="comment">// for sqrt</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;dense_matrix.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;dense_vector.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;libmesh.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#if (LIBMESH_HAVE_PETSC &amp;&amp; LIBMESH_USE_REAL_NUMBERS)</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#include &quot;petsc_macro.h&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 EXTERN_C_FOR_PETSC_BEGIN
<a name="l00034"></a>00034 <span class="preprocessor">#include &lt;petscblaslapack.h&gt;</span>
<a name="l00035"></a>00035 EXTERN_C_FOR_PETSC_END
<a name="l00036"></a>00036 <span class="preprocessor">#endif</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span>
<a name="l00038"></a>00038 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00039"></a>00039 <span class="comment">// Dense Matrix member functions</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00044"></a><a class="code" href="classDenseMatrix.php#a433dced554023601bd1f044f5d643f20">00044</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a433dced554023601bd1f044f5d643f20">DenseMatrix&lt;T&gt;::left_multiply</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M2)
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046   <span class="keywordflow">if</span> (this-&gt;use_blas)
<a name="l00047"></a>00047     this-&gt;_multiply_blas(M2, LEFT_MULTIPLY);
<a name="l00048"></a>00048   <span class="keywordflow">else</span>
<a name="l00049"></a>00049     {
<a name="l00050"></a>00050       <span class="comment">// (*this) &lt;- M2 * (*this)</span>
<a name="l00051"></a>00051       <span class="comment">// Where:</span>
<a name="l00052"></a>00052       <span class="comment">// (*this) = (m x n),</span>
<a name="l00053"></a>00053       <span class="comment">// M2      = (m x p),</span>
<a name="l00054"></a>00054       <span class="comment">// M3      = (p x n)</span>
<a name="l00055"></a>00055   
<a name="l00056"></a>00056       <span class="comment">// M3 is a copy of *this before it gets resize()d</span>
<a name="l00057"></a>00057       <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> M3(*<span class="keyword">this</span>);
<a name="l00058"></a>00058 
<a name="l00059"></a>00059       <span class="comment">// Resize *this so that the result can fit</span>
<a name="l00060"></a>00060       this-&gt;resize (M2.<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>(), M3.<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>());
<a name="l00061"></a>00061 
<a name="l00062"></a>00062       <span class="comment">// Call the multiply function in the base class</span>
<a name="l00063"></a>00063       this-&gt;multiply(*<span class="keyword">this</span>, M2, M3);
<a name="l00064"></a>00064     }
<a name="l00065"></a>00065 }
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00071"></a><a class="code" href="classDenseMatrix.php#a62832696c265cff213ff133f9e73ef34">00071</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a62832696c265cff213ff133f9e73ef34">DenseMatrix&lt;T&gt;::left_multiply_transpose</a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; A)
<a name="l00072"></a>00072 {
<a name="l00073"></a>00073   <span class="keywordflow">if</span> (this-&gt;use_blas)
<a name="l00074"></a>00074     this-&gt;_multiply_blas(A, LEFT_MULTIPLY_TRANSPOSE);
<a name="l00075"></a>00075   <span class="keywordflow">else</span>
<a name="l00076"></a>00076     {
<a name="l00077"></a>00077       <span class="comment">//Check to see if we are doing (A^T)*A</span>
<a name="l00078"></a>00078       <span class="keywordflow">if</span> (<span class="keyword">this</span> == &amp;A)
<a name="l00079"></a>00079         {
<a name="l00080"></a>00080           <span class="comment">//libmesh_here();</span>
<a name="l00081"></a>00081           <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> B(*<span class="keyword">this</span>);
<a name="l00082"></a>00082       
<a name="l00083"></a>00083           <span class="comment">// Simple but inefficient way</span>
<a name="l00084"></a>00084           <span class="comment">// return this-&gt;left_multiply_transpose(B);</span>
<a name="l00085"></a>00085 
<a name="l00086"></a>00086           <span class="comment">// More efficient, but more code way</span>
<a name="l00087"></a>00087           <span class="comment">// If A is mxn, the result will be a square matrix of Size n x n.</span>
<a name="l00088"></a>00088           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m = A.<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>();
<a name="l00089"></a>00089           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = A.<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>();
<a name="l00090"></a>00090 
<a name="l00091"></a>00091           <span class="comment">// resize() *this and also zero out all entries.</span>
<a name="l00092"></a>00092           this-&gt;resize(n,n);
<a name="l00093"></a>00093 
<a name="l00094"></a>00094           <span class="comment">// Compute the lower-triangular part</span>
<a name="l00095"></a>00095           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; ++i)
<a name="l00096"></a>00096             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;=i; ++j)
<a name="l00097"></a>00097               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;m; ++k) <span class="comment">// inner products are over m</span>
<a name="l00098"></a>00098                 (*<span class="keyword">this</span>)(i,j) += B(k,i)*B(k,j);
<a name="l00099"></a>00099 
<a name="l00100"></a>00100           <span class="comment">// Copy lower-triangular part into upper-triangular part</span>
<a name="l00101"></a>00101           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; ++i)
<a name="l00102"></a>00102             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=i+1; j&lt;n; ++j)
<a name="l00103"></a>00103               (*<span class="keyword">this</span>)(i,j) = (*<span class="keyword">this</span>)(j,i);
<a name="l00104"></a>00104         }
<a name="l00105"></a>00105 
<a name="l00106"></a>00106       <span class="keywordflow">else</span>
<a name="l00107"></a>00107         {
<a name="l00108"></a>00108           <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> B(*<span class="keyword">this</span>);
<a name="l00109"></a>00109   
<a name="l00110"></a>00110           this-&gt;resize (A.<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>(), B.<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>());
<a name="l00111"></a>00111       
<a name="l00112"></a>00112           libmesh_assert (A.<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>() == B.<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>());
<a name="l00113"></a>00113           libmesh_assert (this-&gt;m() == A.<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>());
<a name="l00114"></a>00114           libmesh_assert (this-&gt;n() == B.<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>());
<a name="l00115"></a>00115       
<a name="l00116"></a>00116           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_s = A.<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>();
<a name="l00117"></a>00117           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p_s = A.<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>(); 
<a name="l00118"></a>00118           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_s = this-&gt;n();
<a name="l00119"></a>00119   
<a name="l00120"></a>00120           <span class="comment">// Do it this way because there is a</span>
<a name="l00121"></a>00121           <span class="comment">// decent chance (at least for constraint matrices)</span>
<a name="l00122"></a>00122           <span class="comment">// that A.transpose(i,k) = 0.</span>
<a name="l00123"></a>00123           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;m_s; i++)
<a name="l00124"></a>00124             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;p_s; k++)
<a name="l00125"></a>00125               <span class="keywordflow">if</span> (A.<a class="code" href="classDenseMatrix.php#a4ce520268efceb0e68897595d3b38318">transpose</a>(i,k) != 0.)
<a name="l00126"></a>00126                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_s; j++)
<a name="l00127"></a>00127                   (*<span class="keyword">this</span>)(i,j) += A.<a class="code" href="classDenseMatrix.php#a4ce520268efceb0e68897595d3b38318">transpose</a>(i,k)*B(k,j);
<a name="l00128"></a>00128         }
<a name="l00129"></a>00129     }
<a name="l00130"></a>00130   
<a name="l00131"></a>00131 }
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00139"></a><a class="code" href="classDenseMatrix.php#a56e32ffe655816974245f3daef9f6581">00139</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a56e32ffe655816974245f3daef9f6581">DenseMatrix&lt;T&gt;::right_multiply</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M3)
<a name="l00140"></a>00140 {
<a name="l00141"></a>00141   <span class="keywordflow">if</span> (this-&gt;use_blas)
<a name="l00142"></a>00142     this-&gt;_multiply_blas(M3, RIGHT_MULTIPLY);
<a name="l00143"></a>00143   <span class="keywordflow">else</span>
<a name="l00144"></a>00144     {
<a name="l00145"></a>00145       <span class="comment">// (*this) &lt;- M3 * (*this)</span>
<a name="l00146"></a>00146       <span class="comment">// Where:</span>
<a name="l00147"></a>00147       <span class="comment">// (*this) = (m x n),</span>
<a name="l00148"></a>00148       <span class="comment">// M2      = (m x p),</span>
<a name="l00149"></a>00149       <span class="comment">// M3      = (p x n)</span>
<a name="l00150"></a>00150 
<a name="l00151"></a>00151       <span class="comment">// M2 is a copy of *this before it gets resize()d</span>
<a name="l00152"></a>00152       <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> M2(*<span class="keyword">this</span>);
<a name="l00153"></a>00153 
<a name="l00154"></a>00154       <span class="comment">// Resize *this so that the result can fit</span>
<a name="l00155"></a>00155       this-&gt;resize (M2.<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>(), M3.<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>());
<a name="l00156"></a>00156   
<a name="l00157"></a>00157       this-&gt;multiply(*<span class="keyword">this</span>, M2, M3);
<a name="l00158"></a>00158     }
<a name="l00159"></a>00159 }
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00165"></a><a class="code" href="classDenseMatrix.php#a8a041f8b6c2f50de27565618331b16fb">00165</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a8a041f8b6c2f50de27565618331b16fb">DenseMatrix&lt;T&gt;::right_multiply_transpose</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; B)
<a name="l00166"></a>00166 {
<a name="l00167"></a>00167   <span class="keywordflow">if</span> (this-&gt;use_blas)
<a name="l00168"></a>00168     this-&gt;_multiply_blas(B, RIGHT_MULTIPLY_TRANSPOSE);
<a name="l00169"></a>00169   <span class="keywordflow">else</span>
<a name="l00170"></a>00170     {
<a name="l00171"></a>00171       <span class="comment">//Check to see if we are doing B*(B^T)</span>
<a name="l00172"></a>00172       <span class="keywordflow">if</span> (<span class="keyword">this</span> == &amp;B)
<a name="l00173"></a>00173         {
<a name="l00174"></a>00174           <span class="comment">//libmesh_here();</span>
<a name="l00175"></a>00175           <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> A(*<span class="keyword">this</span>);
<a name="l00176"></a>00176       
<a name="l00177"></a>00177           <span class="comment">// Simple but inefficient way</span>
<a name="l00178"></a>00178           <span class="comment">// return this-&gt;right_multiply_transpose(A);</span>
<a name="l00179"></a>00179 
<a name="l00180"></a>00180           <span class="comment">// More efficient, more code</span>
<a name="l00181"></a>00181           <span class="comment">// If B is mxn, the result will be a square matrix of Size m x m.</span>
<a name="l00182"></a>00182           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m = B.<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>();
<a name="l00183"></a>00183           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = B.<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>();
<a name="l00184"></a>00184 
<a name="l00185"></a>00185           <span class="comment">// resize() *this and also zero out all entries.</span>
<a name="l00186"></a>00186           this-&gt;resize(m,m);
<a name="l00187"></a>00187 
<a name="l00188"></a>00188           <span class="comment">// Compute the lower-triangular part</span>
<a name="l00189"></a>00189           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;m; ++i)
<a name="l00190"></a>00190             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;=i; ++j)
<a name="l00191"></a>00191               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;n; ++k) <span class="comment">// inner products are over n</span>
<a name="l00192"></a>00192                 (*<span class="keyword">this</span>)(i,j) += A(i,k)*A(j,k);
<a name="l00193"></a>00193 
<a name="l00194"></a>00194           <span class="comment">// Copy lower-triangular part into upper-triangular part</span>
<a name="l00195"></a>00195           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;m; ++i)
<a name="l00196"></a>00196             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=i+1; j&lt;m; ++j)
<a name="l00197"></a>00197               (*<span class="keyword">this</span>)(i,j) = (*<span class="keyword">this</span>)(j,i);
<a name="l00198"></a>00198         }
<a name="l00199"></a>00199 
<a name="l00200"></a>00200       <span class="keywordflow">else</span>
<a name="l00201"></a>00201         {
<a name="l00202"></a>00202           <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> A(*<span class="keyword">this</span>);
<a name="l00203"></a>00203   
<a name="l00204"></a>00204           this-&gt;resize (A.<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>(), B.<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>());
<a name="l00205"></a>00205       
<a name="l00206"></a>00206           libmesh_assert (A.<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>() == B.<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>());
<a name="l00207"></a>00207           libmesh_assert (this-&gt;m() == A.<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>());
<a name="l00208"></a>00208           libmesh_assert (this-&gt;n() == B.<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>());
<a name="l00209"></a>00209       
<a name="l00210"></a>00210           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_s = A.<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>();
<a name="l00211"></a>00211           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p_s = A.<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>(); 
<a name="l00212"></a>00212           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_s = this-&gt;n();
<a name="l00213"></a>00213 
<a name="l00214"></a>00214           <span class="comment">// Do it this way because there is a</span>
<a name="l00215"></a>00215           <span class="comment">// decent chance (at least for constraint matrices)</span>
<a name="l00216"></a>00216           <span class="comment">// that B.transpose(k,j) = 0.</span>
<a name="l00217"></a>00217           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_s; j++)
<a name="l00218"></a>00218             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;p_s; k++)
<a name="l00219"></a>00219               <span class="keywordflow">if</span> (B.<a class="code" href="classDenseMatrix.php#a4ce520268efceb0e68897595d3b38318">transpose</a>(k,j) != 0.)
<a name="l00220"></a>00220                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;m_s; i++)
<a name="l00221"></a>00221                   (*<span class="keyword">this</span>)(i,j) += A(i,k)*B.<a class="code" href="classDenseMatrix.php#a4ce520268efceb0e68897595d3b38318">transpose</a>(k,j);
<a name="l00222"></a>00222         }
<a name="l00223"></a>00223     }
<a name="l00224"></a>00224 }
<a name="l00225"></a>00225 
<a name="l00226"></a>00226 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00227"></a><a class="code" href="classDenseMatrix.php#a0c25dd3e8d8093f7443c4b6689c73b10">00227</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a0c25dd3e8d8093f7443c4b6689c73b10">DenseMatrix&lt;T&gt;::vector_mult</a> (<a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; dest, 
<a name="l00228"></a>00228                                   <span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; arg)<span class="keyword"> const</span>
<a name="l00229"></a>00229 <span class="keyword"></span>{
<a name="l00230"></a>00230   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_rows = this-&gt;m();
<a name="l00231"></a>00231   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_cols = this-&gt;n();
<a name="l00232"></a>00232 
<a name="l00233"></a>00233   <span class="comment">// Make sure the sizes are compatible</span>
<a name="l00234"></a>00234   libmesh_assert(n_cols == arg.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>());
<a name="l00235"></a>00235   libmesh_assert(n_rows == dest.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>());
<a name="l00236"></a>00236 
<a name="l00237"></a>00237   dest.<a class="code" href="classDenseVector.php#a4e0123eb5cc4054e8069155f0faf4425">zero</a>();
<a name="l00238"></a>00238   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> A(*<span class="keyword">this</span>);
<a name="l00239"></a>00239 
<a name="l00240"></a>00240   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_rows; i++)
<a name="l00241"></a>00241     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_cols; j++)
<a name="l00242"></a>00242       dest(i) += A(i,j)*arg(j);
<a name="l00243"></a>00243 }
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00246"></a><a class="code" href="classDenseMatrix.php#a793bc1a660afe34dc0cbd511690e8e4f">00246</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a793bc1a660afe34dc0cbd511690e8e4f">DenseMatrix&lt;T&gt;::vector_mult_add</a> (<a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; dest, 
<a name="l00247"></a>00247                                       <span class="keyword">const</span> T factor,
<a name="l00248"></a>00248                                       <span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; arg)<span class="keyword"> const</span>
<a name="l00249"></a>00249 <span class="keyword"></span>{
<a name="l00250"></a>00250   <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a> temp(arg.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>());
<a name="l00251"></a>00251   this-&gt;vector_mult(temp, arg);
<a name="l00252"></a>00252   dest.<a class="code" href="classDenseVector.php#a8eedf23f82b65005d0b5066fb3e0d3f5">add</a>(factor, temp);
<a name="l00253"></a>00253 }
<a name="l00254"></a>00254 
<a name="l00255"></a>00255 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00256"></a><a class="code" href="classDenseMatrix.php#a626560df7c0156c3df968de490fae49d">00256</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a626560df7c0156c3df968de490fae49d">DenseMatrix&lt;T&gt;::get_principal_submatrix</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sub_m,
<a name="l00257"></a>00257                                               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sub_n,
<a name="l00258"></a>00258                                               <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dest)<span class="keyword"> const</span>
<a name="l00259"></a>00259 <span class="keyword"></span>{
<a name="l00260"></a>00260   libmesh_assert( (sub_m &lt;= this-&gt;m()) &amp;&amp; (sub_n &lt;= this-&gt;n()) );
<a name="l00261"></a>00261 
<a name="l00262"></a>00262   dest.<a class="code" href="classDenseMatrix.php#a8c19724598a1ac1e3c758aaad73beb1b">resize</a>(sub_m, sub_n);
<a name="l00263"></a>00263   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;sub_m; i++)
<a name="l00264"></a>00264     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;sub_n; j++)
<a name="l00265"></a>00265       dest(i,j) = (*this)(i,j);
<a name="l00266"></a>00266 }
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00269"></a><a class="code" href="classDenseMatrix.php#a8a62a1a6a51e09c1d2c4fbb85e674fa7">00269</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a626560df7c0156c3df968de490fae49d">DenseMatrix&lt;T&gt;::get_principal_submatrix</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sub_m, <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dest)<span class="keyword"> const</span>
<a name="l00270"></a>00270 <span class="keyword"></span>{
<a name="l00271"></a>00271   get_principal_submatrix(sub_m, sub_m, dest);
<a name="l00272"></a>00272 }
<a name="l00273"></a>00273 
<a name="l00274"></a>00274 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00275"></a><a class="code" href="classDenseMatrix.php#a638003ba25276a17569443b196d5fb33">00275</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a638003ba25276a17569443b196d5fb33">DenseMatrix&lt;T&gt;::get_transpose</a> (<a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dest)<span class="keyword"> const</span>
<a name="l00276"></a>00276 <span class="keyword"></span>{
<a name="l00277"></a>00277   dest.<a class="code" href="classDenseMatrix.php#a8c19724598a1ac1e3c758aaad73beb1b">resize</a>(this-&gt;n(), this-&gt;m());
<a name="l00278"></a>00278 
<a name="l00279"></a>00279   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;dest.<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>(); i++)
<a name="l00280"></a>00280     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;dest.<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>(); j++)
<a name="l00281"></a>00281       dest(i,j) = (*this)(j,i);
<a name="l00282"></a>00282 }
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 
<a name="l00285"></a>00285 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00286"></a><a class="code" href="classDenseMatrix.php#a477240f22a12d4bcf761b490414f4491">00286</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a477240f22a12d4bcf761b490414f4491">DenseMatrix&lt;T&gt;::lu_solve</a> (<a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; b,
<a name="l00287"></a>00287                                <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; x,
<a name="l00288"></a>00288                                <span class="keyword">const</span> <span class="keywordtype">bool</span> partial_pivot)
<a name="l00289"></a>00289 {
<a name="l00290"></a>00290   <span class="comment">// Check for a previous decomposition</span>
<a name="l00291"></a>00291   <span class="keywordflow">switch</span>(this-&gt;_decomposition_type)
<a name="l00292"></a>00292     {
<a name="l00293"></a>00293     <span class="keywordflow">case</span> NONE:
<a name="l00294"></a>00294       {
<a name="l00295"></a>00295         this-&gt;_lu_decompose (partial_pivot);
<a name="l00296"></a>00296         <span class="keywordflow">break</span>;
<a name="l00297"></a>00297       }
<a name="l00298"></a>00298 
<a name="l00299"></a>00299     <span class="keywordflow">case</span> LU:
<a name="l00300"></a>00300       {
<a name="l00301"></a>00301         <span class="comment">// Already factored, just need to call back_substitute.</span>
<a name="l00302"></a>00302         <span class="keywordflow">break</span>;
<a name="l00303"></a>00303       }
<a name="l00304"></a>00304 
<a name="l00305"></a>00305     <span class="keywordflow">default</span>:
<a name="l00306"></a>00306       {
<a name="l00307"></a>00307         std::cerr &lt;&lt; <span class="stringliteral">&quot;Error! This matrix already has a &quot;</span>
<a name="l00308"></a>00308                   &lt;&lt; <span class="stringliteral">&quot;different decomposition...&quot;</span>
<a name="l00309"></a>00309                   &lt;&lt; std::endl;
<a name="l00310"></a>00310         libmesh_error();
<a name="l00311"></a>00311       }
<a name="l00312"></a>00312     }
<a name="l00313"></a>00313 
<a name="l00314"></a>00314   <span class="comment">// Perform back substitution</span>
<a name="l00315"></a>00315   this-&gt;_lu_back_substitute (b, x, partial_pivot);
<a name="l00316"></a>00316 }
<a name="l00317"></a>00317 
<a name="l00318"></a>00318   
<a name="l00319"></a>00319 
<a name="l00320"></a>00320 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00321"></a><a class="code" href="classDenseMatrix.php#a7162cded87fb34d00501233ca808c3fa">00321</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a7162cded87fb34d00501233ca808c3fa">DenseMatrix&lt;T&gt;::_lu_back_substitute</a> (<a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; b,
<a name="l00322"></a>00322                                           <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; x,
<a name="l00323"></a>00323                                           <span class="keyword">const</span> <span class="keywordtype">bool</span> )<span class="keyword"> const</span>
<a name="l00324"></a>00324 <span class="keyword"></span>{
<a name="l00325"></a>00325   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00326"></a>00326     n = this-&gt;n();
<a name="l00327"></a>00327 
<a name="l00328"></a>00328   libmesh_assert (this-&gt;m() == n);
<a name="l00329"></a>00329   libmesh_assert (this-&gt;m() == b.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>());
<a name="l00330"></a>00330   
<a name="l00331"></a>00331   x.<a class="code" href="classDenseVector.php#a3a9af103dc052f1dfdef1626692cd8cd">resize</a> (n);
<a name="l00332"></a>00332 
<a name="l00333"></a>00333   <span class="comment">// A convenient reference to *this</span>
<a name="l00334"></a>00334   <span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; A = *<span class="keyword">this</span>;
<a name="l00335"></a>00335 
<a name="l00336"></a>00336   <span class="comment">// Transform the RHS vector</span>
<a name="l00337"></a>00337   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;(n-1); i++)
<a name="l00338"></a>00338     {
<a name="l00339"></a>00339       <span class="comment">// Get the diagonal entry and take its inverse</span>
<a name="l00340"></a>00340       <span class="keyword">const</span> T diag = A(i,i);
<a name="l00341"></a>00341       
<a name="l00342"></a>00342       libmesh_assert (diag != <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>);
<a name="l00343"></a>00343   
<a name="l00344"></a>00344       <span class="keyword">const</span> T diag_inv = 1./diag;
<a name="l00345"></a>00345 
<a name="l00346"></a>00346       <span class="comment">// Get the entry b(i) and store it</span>
<a name="l00347"></a>00347       <span class="keyword">const</span> T bi = b(i);
<a name="l00348"></a>00348       
<a name="l00349"></a>00349       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=(i+1); j&lt;n; j++)
<a name="l00350"></a>00350         b(j) -= bi*A(j,i)*diag_inv;
<a name="l00351"></a>00351     }
<a name="l00352"></a>00352 
<a name="l00353"></a>00353 
<a name="l00354"></a>00354   <span class="comment">// Perform back-substitution</span>
<a name="l00355"></a>00355   {
<a name="l00356"></a>00356     x(n-1) = b(n-1)/A(n-1,n-1);
<a name="l00357"></a>00357 
<a name="l00358"></a>00358     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;=(n-1); i++)
<a name="l00359"></a>00359       {
<a name="l00360"></a>00360         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ib = (n-1)-i;
<a name="l00361"></a>00361 
<a name="l00362"></a>00362         <span class="comment">// Get the diagonal and take its inverse</span>
<a name="l00363"></a>00363         <span class="keyword">const</span> T diag = A(ib,ib);
<a name="l00364"></a>00364 
<a name="l00365"></a>00365         libmesh_assert (diag != <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>);
<a name="l00366"></a>00366 
<a name="l00367"></a>00367         <span class="keyword">const</span> T diag_inv = 1./diag;
<a name="l00368"></a>00368         
<a name="l00369"></a>00369         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=(ib+1); j&lt;n; j++)
<a name="l00370"></a>00370           {
<a name="l00371"></a>00371             b(ib) -= A(ib,j)*x(j);
<a name="l00372"></a>00372             x(ib)  = b(ib)*diag_inv;
<a name="l00373"></a>00373           }
<a name="l00374"></a>00374       }
<a name="l00375"></a>00375   }
<a name="l00376"></a>00376 }
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 
<a name="l00379"></a>00379 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00380"></a><a class="code" href="classDenseMatrix.php#ad8001c2fe3b274823a2bcf237887886a">00380</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#ad8001c2fe3b274823a2bcf237887886a">DenseMatrix&lt;T&gt;::_lu_decompose</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> partial_pivot)
<a name="l00381"></a>00381 {
<a name="l00382"></a>00382   <span class="comment">// If this function was called, there better not be any</span>
<a name="l00383"></a>00383   <span class="comment">// previous decomposition of the matrix.</span>
<a name="l00384"></a>00384   libmesh_assert(this-&gt;_decomposition_type == NONE);
<a name="l00385"></a>00385   
<a name="l00386"></a>00386   <span class="comment">// Get the matrix size and make sure it is square</span>
<a name="l00387"></a>00387   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00388"></a>00388     m = this-&gt;m();
<a name="l00389"></a>00389 
<a name="l00390"></a>00390   libmesh_assert (m == this-&gt;n());
<a name="l00391"></a>00391 
<a name="l00392"></a>00392   <span class="comment">// A convenient reference to *this</span>
<a name="l00393"></a>00393   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; A = *<span class="keyword">this</span>;
<a name="l00394"></a>00394   
<a name="l00395"></a>00395   <span class="comment">// Straight, vanilla LU factorization without pivoting</span>
<a name="l00396"></a>00396   <span class="keywordflow">if</span> (!partial_pivot)
<a name="l00397"></a>00397     {
<a name="l00398"></a>00398       
<a name="l00399"></a>00399       <span class="comment">// For each row in the matrix</span>
<a name="l00400"></a>00400       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;m; i++)
<a name="l00401"></a>00401         {
<a name="l00402"></a>00402           <span class="comment">// Get the diagonal entry and take its inverse</span>
<a name="l00403"></a>00403           <span class="keyword">const</span> T diag = A(i,i);
<a name="l00404"></a>00404 
<a name="l00405"></a>00405           libmesh_assert (diag != <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>);
<a name="l00406"></a>00406 
<a name="l00407"></a>00407           <span class="keyword">const</span> T diag_inv = 1./diag;
<a name="l00408"></a>00408           
<a name="l00409"></a>00409           <span class="comment">// For each row in the submatrix</span>
<a name="l00410"></a>00410           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=i+1; j&lt;m; j++)
<a name="l00411"></a>00411             {
<a name="l00412"></a>00412               <span class="comment">// Get the scale factor for this row</span>
<a name="l00413"></a>00413               <span class="keyword">const</span> T fact = A(j,i)*diag_inv;
<a name="l00414"></a>00414               
<a name="l00415"></a>00415               <span class="comment">// For each column in the subrow scale it</span>
<a name="l00416"></a>00416               <span class="comment">// by the factor</span>
<a name="l00417"></a>00417               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=i+1; k&lt;m; k++)
<a name="l00418"></a>00418                 A(j,k) -= fact*A(i,k);        
<a name="l00419"></a>00419             }
<a name="l00420"></a>00420         }
<a name="l00421"></a>00421     }
<a name="l00422"></a>00422   
<a name="l00423"></a>00423   <span class="comment">// Do partial pivoting.</span>
<a name="l00424"></a>00424   <span class="keywordflow">else</span>
<a name="l00425"></a>00425     {
<a name="l00426"></a>00426       libmesh_error();
<a name="l00427"></a>00427     }
<a name="l00428"></a>00428   
<a name="l00429"></a>00429   <span class="comment">// Set the flag for LU decomposition</span>
<a name="l00430"></a>00430   this-&gt;_decomposition_type = LU;
<a name="l00431"></a>00431 }
<a name="l00432"></a>00432 
<a name="l00433"></a>00433 
<a name="l00434"></a>00434 
<a name="l00435"></a>00435 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00436"></a><a class="code" href="classDenseMatrix.php#a9555f223e2e4e08461ffc68b9b252fb5">00436</a> T <a class="code" href="classDenseMatrix.php#a9555f223e2e4e08461ffc68b9b252fb5">DenseMatrix&lt;T&gt;::det</a> ()
<a name="l00437"></a>00437 {
<a name="l00438"></a>00438   <span class="comment">// First LU decompose the matrix (without partial pivoting).</span>
<a name="l00439"></a>00439   <span class="comment">// Note that the lu_decompose routine will check to see if the</span>
<a name="l00440"></a>00440   <span class="comment">// matrix is square so we don&#39;t worry about it.</span>
<a name="l00441"></a>00441   <span class="keywordflow">if</span> (this-&gt;_decomposition_type == NONE)
<a name="l00442"></a>00442     this-&gt;_lu_decompose(<span class="keyword">false</span>);
<a name="l00443"></a>00443   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (this-&gt;_decomposition_type != LU)
<a name="l00444"></a>00444     {
<a name="l00445"></a>00445       std::cerr &lt;&lt; <span class="stringliteral">&quot;Error! Can&#39;t compute the determinant under &quot;</span>
<a name="l00446"></a>00446                 &lt;&lt; <span class="stringliteral">&quot;the current decomposition.&quot;</span>
<a name="l00447"></a>00447                 &lt;&lt; std::endl;
<a name="l00448"></a>00448       libmesh_error();
<a name="l00449"></a>00449     }
<a name="l00450"></a>00450   
<a name="l00451"></a>00451   <span class="comment">// A variable to keep track of the running product of diagonal terms.</span>
<a name="l00452"></a>00452   T determinant = 1.;
<a name="l00453"></a>00453   
<a name="l00454"></a>00454   <span class="comment">// Loop over diagonal terms, computing the product.  In practice,</span>
<a name="l00455"></a>00455   <span class="comment">// be careful because this value could easily become too large to</span>
<a name="l00456"></a>00456   <span class="comment">// fit in a double or float.  To be safe, one should keep track of</span>
<a name="l00457"></a>00457   <span class="comment">// the power (of 10) of the determinant in a separate variable</span>
<a name="l00458"></a>00458   <span class="comment">// and maintain an order 1 value for the determinant itself.</span>
<a name="l00459"></a>00459   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;m(); i++)
<a name="l00460"></a>00460     determinant *= (*<span class="keyword">this</span>)(i,i);
<a name="l00461"></a>00461 
<a name="l00462"></a>00462   <span class="comment">// Return the determinant</span>
<a name="l00463"></a>00463   <span class="keywordflow">return</span> determinant;
<a name="l00464"></a>00464 }
<a name="l00465"></a>00465 
<a name="l00466"></a>00466 
<a name="l00467"></a>00467 
<a name="l00468"></a>00468 <span class="comment">// The cholesky solve function first decomposes the matrix</span>
<a name="l00469"></a>00469 <span class="comment">// with cholesky_decompose and then uses the cholesky_back_substitute</span>
<a name="l00470"></a>00470 <span class="comment">// routine to find the solution x.</span>
<a name="l00471"></a>00471 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00472"></a>00472 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00473"></a><a class="code" href="classDenseMatrix.php#a7303f17ad11891bc43f2533688347f15">00473</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a7303f17ad11891bc43f2533688347f15">DenseMatrix&lt;T&gt;::cholesky_solve</a> (<a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a>&amp; b,
<a name="l00474"></a>00474                                      <a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a>&amp; x)
<a name="l00475"></a>00475 {
<a name="l00476"></a>00476   <span class="comment">// Check for a previous decomposition</span>
<a name="l00477"></a>00477   <span class="keywordflow">switch</span>(this-&gt;_decomposition_type)
<a name="l00478"></a>00478     {
<a name="l00479"></a>00479     <span class="keywordflow">case</span> NONE:
<a name="l00480"></a>00480       {
<a name="l00481"></a>00481         this-&gt;_cholesky_decompose ();
<a name="l00482"></a>00482         <span class="keywordflow">break</span>;
<a name="l00483"></a>00483       }
<a name="l00484"></a>00484 
<a name="l00485"></a>00485     <span class="keywordflow">case</span> CHOLESKY:
<a name="l00486"></a>00486       {
<a name="l00487"></a>00487         <span class="comment">// Already factored, just need to call back_substitute.</span>
<a name="l00488"></a>00488         <span class="keywordflow">break</span>;
<a name="l00489"></a>00489       }
<a name="l00490"></a>00490       
<a name="l00491"></a>00491     <span class="keywordflow">default</span>:
<a name="l00492"></a>00492       {
<a name="l00493"></a>00493         std::cerr &lt;&lt; <span class="stringliteral">&quot;Error! This matrix already has a &quot;</span>
<a name="l00494"></a>00494                   &lt;&lt; <span class="stringliteral">&quot;different decomposition...&quot;</span>
<a name="l00495"></a>00495                   &lt;&lt; std::endl;
<a name="l00496"></a>00496         libmesh_error();
<a name="l00497"></a>00497       }
<a name="l00498"></a>00498     }
<a name="l00499"></a>00499 
<a name="l00500"></a>00500   <span class="comment">// Perform back substitution</span>
<a name="l00501"></a>00501   this-&gt;_cholesky_back_substitute (b, x);
<a name="l00502"></a>00502 }
<a name="l00503"></a>00503 
<a name="l00504"></a>00504 
<a name="l00505"></a>00505 
<a name="l00506"></a>00506 
<a name="l00507"></a>00507 <span class="comment">// This algorithm is based on the Cholesky decomposition in</span>
<a name="l00508"></a>00508 <span class="comment">// the Numerical Recipes in C book.</span>
<a name="l00509"></a>00509 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00510"></a><a class="code" href="classDenseMatrix.php#aa501a38d3d515b0abc6c83b243004aed">00510</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#aa501a38d3d515b0abc6c83b243004aed">DenseMatrix&lt;T&gt;::_cholesky_decompose</a> ()
<a name="l00511"></a>00511 {
<a name="l00512"></a>00512   <span class="comment">// If we called this function, there better not be any</span>
<a name="l00513"></a>00513   <span class="comment">// previous decomposition of the matrix.</span>
<a name="l00514"></a>00514   libmesh_assert(this-&gt;_decomposition_type == NONE);
<a name="l00515"></a>00515   
<a name="l00516"></a>00516   <span class="comment">// Shorthand notation for number of rows and columns.</span>
<a name="l00517"></a>00517   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00518"></a>00518     m = this-&gt;m(),
<a name="l00519"></a>00519     n = this-&gt;n();
<a name="l00520"></a>00520 
<a name="l00521"></a>00521   <span class="comment">// Just to be really sure...</span>
<a name="l00522"></a>00522   libmesh_assert(m==n);
<a name="l00523"></a>00523 
<a name="l00524"></a>00524   <span class="comment">// A convenient reference to *this</span>
<a name="l00525"></a>00525   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; A = *<span class="keyword">this</span>;
<a name="l00526"></a>00526   
<a name="l00527"></a>00527   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;m; ++i)
<a name="l00528"></a>00528     {
<a name="l00529"></a>00529       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=i; j&lt;n; ++j)
<a name="l00530"></a>00530         {
<a name="l00531"></a>00531           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;i; ++k)
<a name="l00532"></a>00532             A(i,j) -= A(i,k) * A(j,k);
<a name="l00533"></a>00533 
<a name="l00534"></a>00534           <span class="keywordflow">if</span> (i == j)
<a name="l00535"></a>00535             {
<a name="l00536"></a>00536 <span class="preprocessor">#ifndef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00537"></a>00537 <span class="preprocessor"></span>              <span class="keywordflow">if</span> (A(i,j) &lt;= 0.0)
<a name="l00538"></a>00538                 {
<a name="l00539"></a>00539                   std::cerr &lt;&lt; <span class="stringliteral">&quot;Error! Can only use Cholesky decomposition &quot;</span>
<a name="l00540"></a>00540                             &lt;&lt; <span class="stringliteral">&quot;with symmetric positive definite matrices.&quot;</span>
<a name="l00541"></a>00541                             &lt;&lt; std::endl;
<a name="l00542"></a>00542                   libmesh_error();
<a name="l00543"></a>00543                 }
<a name="l00544"></a>00544 <span class="preprocessor">#endif</span>
<a name="l00545"></a>00545 <span class="preprocessor"></span>
<a name="l00546"></a>00546               A(i,i) = std::sqrt(A(i,j));
<a name="l00547"></a>00547             }
<a name="l00548"></a>00548           <span class="keywordflow">else</span>
<a name="l00549"></a>00549             A(j,i) = A(i,j) / A(i,i);
<a name="l00550"></a>00550         }
<a name="l00551"></a>00551     }
<a name="l00552"></a>00552   
<a name="l00553"></a>00553   <span class="comment">// Set the flag for CHOLESKY decomposition</span>
<a name="l00554"></a>00554   this-&gt;_decomposition_type = CHOLESKY;
<a name="l00555"></a>00555 }
<a name="l00556"></a>00556 
<a name="l00557"></a>00557 
<a name="l00558"></a>00558 
<a name="l00559"></a>00559 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00560"></a>00560 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00561"></a><a class="code" href="classDenseMatrix.php#a1dd46dd8b694003773ba285c3d0a7857">00561</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a1dd46dd8b694003773ba285c3d0a7857">DenseMatrix&lt;T&gt;::_cholesky_back_substitute</a> (<a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a>&amp; b,
<a name="l00562"></a>00562                                                 <a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a>&amp; x)<span class="keyword"> const</span>
<a name="l00563"></a>00563 <span class="keyword"></span>{
<a name="l00564"></a>00564   <span class="comment">// Shorthand notation for number of rows and columns.</span>
<a name="l00565"></a>00565   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00566"></a>00566     m = this-&gt;m(),
<a name="l00567"></a>00567     n = this-&gt;n();
<a name="l00568"></a>00568 
<a name="l00569"></a>00569   <span class="comment">// Just to be really sure...</span>
<a name="l00570"></a>00570   libmesh_assert(m==n);
<a name="l00571"></a>00571 
<a name="l00572"></a>00572   <span class="comment">// A convenient reference to *this</span>
<a name="l00573"></a>00573   <span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; A = *<span class="keyword">this</span>;
<a name="l00574"></a>00574    
<a name="l00575"></a>00575   <span class="comment">// Now compute the solution to Ax =b using the factorization.</span>
<a name="l00576"></a>00576   x.<a class="code" href="classDenseVector.php#a3a9af103dc052f1dfdef1626692cd8cd">resize</a>(m);
<a name="l00577"></a>00577   
<a name="l00578"></a>00578   <span class="comment">// Solve for Ly=b</span>
<a name="l00579"></a>00579   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; ++i)
<a name="l00580"></a>00580     {
<a name="l00581"></a>00581       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;i; ++k)
<a name="l00582"></a>00582         b(i) -= A(i,k)*x(k);
<a name="l00583"></a>00583       
<a name="l00584"></a>00584       x(i) = b(i) / A(i,i);
<a name="l00585"></a>00585     }
<a name="l00586"></a>00586   
<a name="l00587"></a>00587   <span class="comment">// Solve for L^T x = y</span>
<a name="l00588"></a>00588   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; ++i)
<a name="l00589"></a>00589     {
<a name="l00590"></a>00590       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ib = (n-1)-i;
<a name="l00591"></a>00591 
<a name="l00592"></a>00592       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=(ib+1); k&lt;n; ++k)
<a name="l00593"></a>00593         x(ib) -= A(k,ib) * x(k);
<a name="l00594"></a>00594       
<a name="l00595"></a>00595       x(ib) /= A(ib,ib);
<a name="l00596"></a>00596     }
<a name="l00597"></a>00597 }
<a name="l00598"></a>00598 
<a name="l00599"></a>00599 
<a name="l00600"></a>00600 
<a name="l00601"></a>00601 
<a name="l00602"></a>00602 
<a name="l00603"></a>00603 <span class="preprocessor">#if (LIBMESH_HAVE_PETSC &amp;&amp; LIBMESH_USE_REAL_NUMBERS)</span>
<a name="l00604"></a>00604 <span class="preprocessor"></span>
<a name="l00605"></a>00605 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00606"></a><a class="code" href="classDenseMatrix.php#ac6e3d04b71255db7b69410ed71fbb579">00606</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#ac6e3d04b71255db7b69410ed71fbb579">DenseMatrix&lt;T&gt;::_multiply_blas</a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; other,
<a name="l00607"></a>00607                                     <a class="code" href="classDenseMatrix.php#a8098ef9aa70df77446f58c5bf11b31df">_BLAS_Multiply_Flag</a> flag)
<a name="l00608"></a>00608 {
<a name="l00609"></a>00609   <span class="keywordtype">int</span> result_size = 0;
<a name="l00610"></a>00610   
<a name="l00611"></a>00611   <span class="comment">// For each case, determine the size of the final result make sure</span>
<a name="l00612"></a>00612   <span class="comment">// that the inner dimensions match</span>
<a name="l00613"></a>00613   <span class="keywordflow">switch</span> (flag)
<a name="l00614"></a>00614     {
<a name="l00615"></a>00615     <span class="keywordflow">case</span> LEFT_MULTIPLY:
<a name="l00616"></a>00616       {
<a name="l00617"></a>00617         result_size = other.<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>() * this-&gt;n();
<a name="l00618"></a>00618         <span class="keywordflow">if</span> (other.<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>() == this-&gt;m())
<a name="l00619"></a>00619           <span class="keywordflow">break</span>;
<a name="l00620"></a>00620       }
<a name="l00621"></a>00621     <span class="keywordflow">case</span> RIGHT_MULTIPLY:
<a name="l00622"></a>00622       {
<a name="l00623"></a>00623         result_size = other.<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>() * this-&gt;m();
<a name="l00624"></a>00624         <span class="keywordflow">if</span> (other.<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>() == this-&gt;n())
<a name="l00625"></a>00625           <span class="keywordflow">break</span>;
<a name="l00626"></a>00626       }
<a name="l00627"></a>00627     <span class="keywordflow">case</span> LEFT_MULTIPLY_TRANSPOSE:
<a name="l00628"></a>00628       {
<a name="l00629"></a>00629         result_size = other.<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>() * this-&gt;n();
<a name="l00630"></a>00630         <span class="keywordflow">if</span> (other.<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>() == this-&gt;m())
<a name="l00631"></a>00631           <span class="keywordflow">break</span>;
<a name="l00632"></a>00632       }
<a name="l00633"></a>00633     <span class="keywordflow">case</span> RIGHT_MULTIPLY_TRANSPOSE:
<a name="l00634"></a>00634       {
<a name="l00635"></a>00635         result_size = other.<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>() * this-&gt;m();
<a name="l00636"></a>00636         <span class="keywordflow">if</span> (other.<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>() == this-&gt;n())
<a name="l00637"></a>00637           <span class="keywordflow">break</span>;
<a name="l00638"></a>00638       }
<a name="l00639"></a>00639     <span class="keywordflow">default</span>:
<a name="l00640"></a>00640       {
<a name="l00641"></a>00641         std::cout &lt;&lt; <span class="stringliteral">&quot;Unknown flag selected or matrices are &quot;</span>;
<a name="l00642"></a>00642         std::cout &lt;&lt; <span class="stringliteral">&quot;incompatible for multiplication.&quot;</span> &lt;&lt; std::endl;
<a name="l00643"></a>00643         libmesh_error();
<a name="l00644"></a>00644       }
<a name="l00645"></a>00645     }
<a name="l00646"></a>00646 
<a name="l00647"></a>00647   <span class="comment">// For this to work, the passed arg. must actually be a DenseMatrix&lt;T&gt;</span>
<a name="l00648"></a>00648   <span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>* const_that = <span class="keyword">dynamic_cast&lt;</span> <span class="keyword">const </span><a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>* <span class="keyword">&gt;</span>(&amp;other);
<a name="l00649"></a>00649   <span class="keywordflow">if</span> (!const_that)
<a name="l00650"></a>00650     {
<a name="l00651"></a>00651       std::cerr &lt;&lt; <span class="stringliteral">&quot;Unable to cast input matrix to usable type.&quot;</span> &lt;&lt; std::endl;
<a name="l00652"></a>00652       libmesh_error();
<a name="l00653"></a>00653     }
<a name="l00654"></a>00654 
<a name="l00655"></a>00655   <span class="comment">// Also, although &#39;that&#39; is logically const in this BLAS routine,</span>
<a name="l00656"></a>00656   <span class="comment">// the PETSc BLAS interface does not specify that any of the inputs are</span>
<a name="l00657"></a>00657   <span class="comment">// const.  To use it, I must cast away const-ness.</span>
<a name="l00658"></a>00658   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>* that = <span class="keyword">const_cast&lt;</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>* <span class="keyword">&gt;</span> (const_that);
<a name="l00659"></a>00659 
<a name="l00660"></a>00660   <span class="comment">// Initialize A, B pointers for LEFT_MULTIPLY* cases</span>
<a name="l00661"></a>00661   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>
<a name="l00662"></a>00662     *A = <span class="keyword">this</span>,
<a name="l00663"></a>00663     *B = that;
<a name="l00664"></a>00664 
<a name="l00665"></a>00665   <span class="comment">// For RIGHT_MULTIPLY* cases, swap the meaning of A and B.</span>
<a name="l00666"></a>00666   <span class="comment">// Here is a full table of combinations we can pass to BLASgemm, and what the answer is when finished:</span>
<a name="l00667"></a>00667   <span class="comment">// pass A B   -&gt; (Fortran) -&gt; A^T B^T -&gt; (C++) -&gt; (A^T B^T)^T -&gt; (identity) -&gt; B A   &quot;lt multiply&quot;</span>
<a name="l00668"></a>00668   <span class="comment">// pass B A   -&gt; (Fortran) -&gt; B^T A^T -&gt; (C++) -&gt; (B^T A^T)^T -&gt; (identity) -&gt; A B   &quot;rt multiply&quot;</span>
<a name="l00669"></a>00669   <span class="comment">// pass A B^T -&gt; (Fortran) -&gt; A^T B   -&gt; (C++) -&gt; (A^T B)^T   -&gt; (identity) -&gt; B^T A &quot;lt multiply t&quot;</span>
<a name="l00670"></a>00670   <span class="comment">// pass B^T A -&gt; (Fortran) -&gt; B A^T   -&gt; (C++) -&gt; (B A^T)^T   -&gt; (identity) -&gt; A B^T &quot;rt multiply t&quot;</span>
<a name="l00671"></a>00671   <span class="keywordflow">if</span> (flag==RIGHT_MULTIPLY || flag==RIGHT_MULTIPLY_TRANSPOSE)
<a name="l00672"></a>00672     std::swap(A,B);
<a name="l00673"></a>00673 
<a name="l00674"></a>00674   <span class="comment">// transa, transb values to pass to blas</span>
<a name="l00675"></a>00675   <span class="keywordtype">char</span>
<a name="l00676"></a>00676     transa[] = <span class="stringliteral">&quot;n&quot;</span>,
<a name="l00677"></a>00677     transb[] = <span class="stringliteral">&quot;n&quot;</span>;
<a name="l00678"></a>00678 
<a name="l00679"></a>00679   <span class="comment">// Integer values to pass to BLAS:</span>
<a name="l00680"></a>00680   <span class="comment">//</span>
<a name="l00681"></a>00681   <span class="comment">// M  </span>
<a name="l00682"></a>00682   <span class="comment">// In Fortran, the number of rows of op(A),</span>
<a name="l00683"></a>00683   <span class="comment">// In the BLAS documentation, typically known as &#39;M&#39;.</span>
<a name="l00684"></a>00684   <span class="comment">//</span>
<a name="l00685"></a>00685   <span class="comment">// In C/C++, we set:</span>
<a name="l00686"></a>00686   <span class="comment">// M = n_cols(A) if (transa=&#39;n&#39;)</span>
<a name="l00687"></a>00687   <span class="comment">//     n_rows(A) if (transa=&#39;t&#39;)</span>
<a name="l00688"></a>00688   <span class="keywordtype">int</span> M = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>( A-&gt;<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>() );
<a name="l00689"></a>00689 
<a name="l00690"></a>00690   <span class="comment">// N</span>
<a name="l00691"></a>00691   <span class="comment">// In Fortran, the number of cols of op(B), and also the number of cols of C.</span>
<a name="l00692"></a>00692   <span class="comment">// In the BLAS documentation, typically known as &#39;N&#39;.</span>
<a name="l00693"></a>00693   <span class="comment">//        </span>
<a name="l00694"></a>00694   <span class="comment">// In C/C++, we set:</span>
<a name="l00695"></a>00695   <span class="comment">// N = n_rows(B) if (transb=&#39;n&#39;)</span>
<a name="l00696"></a>00696   <span class="comment">//     n_cols(B) if (transb=&#39;t&#39;)</span>
<a name="l00697"></a>00697   <span class="keywordtype">int</span> N = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>( B-&gt;m() );
<a name="l00698"></a>00698 
<a name="l00699"></a>00699   <span class="comment">// K</span>
<a name="l00700"></a>00700   <span class="comment">// In Fortran, the number of cols of op(A), and also</span>
<a name="l00701"></a>00701   <span class="comment">// the number of rows of op(B). In the BLAS documentation,</span>
<a name="l00702"></a>00702   <span class="comment">// typically known as &#39;K&#39;.</span>
<a name="l00703"></a>00703   <span class="comment">//</span>
<a name="l00704"></a>00704   <span class="comment">// In C/C++, we set:</span>
<a name="l00705"></a>00705   <span class="comment">// K = n_rows(A) if (transa=&#39;n&#39;)</span>
<a name="l00706"></a>00706   <span class="comment">//     n_cols(A) if (transa=&#39;t&#39;)</span>
<a name="l00707"></a>00707   <span class="keywordtype">int</span> K = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>( A-&gt;<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>() );
<a name="l00708"></a>00708 
<a name="l00709"></a>00709   <span class="comment">// LDA (leading dimension of A). In our cases,</span>
<a name="l00710"></a>00710   <span class="comment">// LDA is always the number of columns of A.</span>
<a name="l00711"></a>00711   <span class="keywordtype">int</span> LDA = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>( A-&gt;<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>() );
<a name="l00712"></a>00712 
<a name="l00713"></a>00713   <span class="comment">// LDB (leading dimension of B).  In our cases,</span>
<a name="l00714"></a>00714   <span class="comment">// LDB is always the number of columns of B.</span>
<a name="l00715"></a>00715   <span class="keywordtype">int</span> LDB = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>( B-&gt;n() );
<a name="l00716"></a>00716 
<a name="l00717"></a>00717   <span class="keywordflow">if</span> (flag == LEFT_MULTIPLY_TRANSPOSE)
<a name="l00718"></a>00718     {
<a name="l00719"></a>00719       transb[0] = <span class="charliteral">&#39;t&#39;</span>;
<a name="l00720"></a>00720       N = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>( B-&gt;n() );
<a name="l00721"></a>00721     }
<a name="l00722"></a>00722 
<a name="l00723"></a>00723   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (flag == RIGHT_MULTIPLY_TRANSPOSE)
<a name="l00724"></a>00724     {
<a name="l00725"></a>00725       transa[0] = <span class="charliteral">&#39;t&#39;</span>;
<a name="l00726"></a>00726       std::swap(M,K);
<a name="l00727"></a>00727     }
<a name="l00728"></a>00728 
<a name="l00729"></a>00729   <span class="comment">// LDC (leading dimension of C).  LDC is the</span>
<a name="l00730"></a>00730   <span class="comment">// number of columns in the solution matrix.</span>
<a name="l00731"></a>00731   <span class="keywordtype">int</span> LDC = M;
<a name="l00732"></a>00732   
<a name="l00733"></a>00733   <span class="comment">// Scalar values to pass to BLAS</span>
<a name="l00734"></a>00734   <span class="comment">//</span>
<a name="l00735"></a>00735   <span class="comment">// scalar multiplying the whole product AB </span>
<a name="l00736"></a>00736   T alpha = 1.;
<a name="l00737"></a>00737   
<a name="l00738"></a>00738   <span class="comment">// scalar multiplying C, which is the original matrix.</span>
<a name="l00739"></a>00739   T beta  = 0.;
<a name="l00740"></a>00740 
<a name="l00741"></a>00741   <span class="comment">// Storage for the result</span>
<a name="l00742"></a>00742   std::vector&lt;T&gt; result (result_size);
<a name="l00743"></a>00743 
<a name="l00744"></a>00744   <span class="comment">// Finally ready to call the BLAS</span>
<a name="l00745"></a>00745   BLASgemm_(transa, transb, &amp;M, &amp;N, &amp;K, &amp;alpha, &amp;(A-&gt;<a class="code" href="classDenseMatrix.php#a67fff9b9c3f340ec72d6dcc41c553857">_val</a>[0]), &amp;LDA, &amp;(B-&gt;_val[0]), &amp;LDB, &amp;beta, &amp;result[0], &amp;LDC);
<a name="l00746"></a>00746 
<a name="l00747"></a>00747   <span class="comment">// Update the relevant dimension for this matrix.</span>
<a name="l00748"></a>00748   <span class="keywordflow">switch</span> (flag)
<a name="l00749"></a>00749     {
<a name="l00750"></a>00750     <span class="keywordflow">case</span> LEFT_MULTIPLY:            { this-&gt;_m = other.<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>(); <span class="keywordflow">break</span>; }
<a name="l00751"></a>00751     <span class="keywordflow">case</span> RIGHT_MULTIPLY:           { this-&gt;_n = other.<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>(); <span class="keywordflow">break</span>; }
<a name="l00752"></a>00752     <span class="keywordflow">case</span> LEFT_MULTIPLY_TRANSPOSE:  { this-&gt;_m = other.<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>(); <span class="keywordflow">break</span>; }
<a name="l00753"></a>00753     <span class="keywordflow">case</span> RIGHT_MULTIPLY_TRANSPOSE: { this-&gt;_n = other.<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>(); <span class="keywordflow">break</span>; }
<a name="l00754"></a>00754     <span class="keywordflow">default</span>:
<a name="l00755"></a>00755       {
<a name="l00756"></a>00756         std::cout &lt;&lt; <span class="stringliteral">&quot;Unknown flag selected.&quot;</span> &lt;&lt; std::endl;
<a name="l00757"></a>00757         libmesh_error();
<a name="l00758"></a>00758       }
<a name="l00759"></a>00759     }
<a name="l00760"></a>00760   
<a name="l00761"></a>00761   <span class="comment">// Swap my data vector with the result</span>
<a name="l00762"></a>00762   this-&gt;_val.swap(result);
<a name="l00763"></a>00763 }
<a name="l00764"></a>00764 
<a name="l00765"></a>00765 <span class="preprocessor">#else</span>
<a name="l00766"></a>00766 <span class="preprocessor"></span>
<a name="l00767"></a>00767 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00768"></a>00768 <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#ac6e3d04b71255db7b69410ed71fbb579">DenseMatrix&lt;T&gt;::_multiply_blas</a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; ,
<a name="l00769"></a>00769                                     _BLAS_Multiply_Flag )
<a name="l00770"></a>00770 {
<a name="l00771"></a>00771   std::cerr &lt;&lt; <span class="stringliteral">&quot;No PETSc-provided BLAS available!&quot;</span> &lt;&lt; std::endl;
<a name="l00772"></a>00772   libmesh_error();
<a name="l00773"></a>00773 }
<a name="l00774"></a>00774 
<a name="l00775"></a>00775 <span class="preprocessor">#endif</span>
<a name="l00776"></a>00776 <span class="preprocessor"></span>
<a name="l00777"></a>00777 
<a name="l00778"></a>00778 <span class="comment">// This routine is commented out since it is not really a memory</span>
<a name="l00779"></a>00779 <span class="comment">// efficient implementation.  Also, you don&#39;t *need* the inverse</span>
<a name="l00780"></a>00780 <span class="comment">// for anything, instead just use lu_solve to solve Ax=b.</span>
<a name="l00781"></a>00781 <span class="comment">// template&lt;typename T&gt;</span>
<a name="l00782"></a>00782 <span class="comment">// void DenseMatrix&lt;T&gt;::inverse ()</span>
<a name="l00783"></a>00783 <span class="comment">// {</span>
<a name="l00784"></a>00784 <span class="comment">//   // First LU decompose the matrix (without partial pivoting).</span>
<a name="l00785"></a>00785 <span class="comment">//   // Note that the lu_decompose routine will check to see if the</span>
<a name="l00786"></a>00786 <span class="comment">//   // matrix is square so we don&#39;t worry about it.</span>
<a name="l00787"></a>00787 <span class="comment">//   if (!this-&gt;_lu_decomposed)</span>
<a name="l00788"></a>00788 <span class="comment">//     this-&gt;_lu_decompose(false);</span>
<a name="l00789"></a>00789 
<a name="l00790"></a>00790 <span class="comment">//   // A unit vector which will be used as a rhs</span>
<a name="l00791"></a>00791 <span class="comment">//   // to pick off a single value each time.</span>
<a name="l00792"></a>00792 <span class="comment">//   DenseVector&lt;T&gt; e;</span>
<a name="l00793"></a>00793 <span class="comment">//   e.resize(this-&gt;m());</span>
<a name="l00794"></a>00794 
<a name="l00795"></a>00795 <span class="comment">//   // An empty vector which will be used to hold the solution</span>
<a name="l00796"></a>00796 <span class="comment">//   // to the back substitutions.</span>
<a name="l00797"></a>00797 <span class="comment">//   DenseVector&lt;T&gt; x;</span>
<a name="l00798"></a>00798 <span class="comment">//   x.resize(this-&gt;m());</span>
<a name="l00799"></a>00799 
<a name="l00800"></a>00800 <span class="comment">//   // An empty dense matrix to store the resulting inverse</span>
<a name="l00801"></a>00801 <span class="comment">//   // temporarily until we can overwrite A.</span>
<a name="l00802"></a>00802 <span class="comment">//   DenseMatrix&lt;T&gt; inv;</span>
<a name="l00803"></a>00803 <span class="comment">//   inv.resize(this-&gt;m(), this-&gt;n());</span>
<a name="l00804"></a>00804   
<a name="l00805"></a>00805 <span class="comment">//   // Resize the passed in matrix to hold the inverse</span>
<a name="l00806"></a>00806 <span class="comment">//   inv.resize(this-&gt;m(), this-&gt;n());</span>
<a name="l00807"></a>00807   
<a name="l00808"></a>00808 <span class="comment">//   for (unsigned int j=0; j&lt;this-&gt;n(); ++j)</span>
<a name="l00809"></a>00809 <span class="comment">//     {</span>
<a name="l00810"></a>00810 <span class="comment">//       e.zero();</span>
<a name="l00811"></a>00811 <span class="comment">//       e(j) = 1.;</span>
<a name="l00812"></a>00812 <span class="comment">//       this-&gt;_lu_back_substitute(e, x, false);</span>
<a name="l00813"></a>00813 <span class="comment">//       for (unsigned int i=0; i&lt;this-&gt;n(); ++i)</span>
<a name="l00814"></a>00814 <span class="comment">//      inv(i,j) = x(i);</span>
<a name="l00815"></a>00815 <span class="comment">//     }</span>
<a name="l00816"></a>00816 
<a name="l00817"></a>00817 <span class="comment">//   // Now overwrite all the entries</span>
<a name="l00818"></a>00818 <span class="comment">//   *this = inv;</span>
<a name="l00819"></a>00819 <span class="comment">// }</span>
<a name="l00820"></a>00820 
<a name="l00821"></a>00821 
<a name="l00822"></a>00822 <span class="comment">//--------------------------------------------------------------</span>
<a name="l00823"></a>00823 <span class="comment">// Explicit instantiations</span>
<a name="l00824"></a>00824 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Real&gt;</a>;
<a name="l00825"></a>00825 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a7303f17ad11891bc43f2533688347f15">DenseMatrix&lt;Real&gt;::cholesky_solve</a>(<a class="code" href="classDenseVector.php">DenseVector&lt;Real&gt;</a>&amp;, <a class="code" href="classDenseVector.php">DenseVector&lt;Real&gt;</a>&amp;);
<a name="l00826"></a>00826 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a1dd46dd8b694003773ba285c3d0a7857">DenseMatrix&lt;Real&gt;::_cholesky_back_substitute</a>(<a class="code" href="classDenseVector.php">DenseVector&lt;Real&gt;</a>&amp;, <a class="code" href="classDenseVector.php">DenseVector&lt;Real&gt;</a>&amp;) <span class="keyword">const</span>;
<a name="l00827"></a>00827 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a7303f17ad11891bc43f2533688347f15">DenseMatrix&lt;Real&gt;::cholesky_solve</a>(<a class="code" href="classDenseVector.php">DenseVector&lt;Complex&gt;</a>&amp;, <a class="code" href="classDenseVector.php">DenseVector&lt;Complex&gt;</a>&amp;);
<a name="l00828"></a>00828 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a1dd46dd8b694003773ba285c3d0a7857">DenseMatrix&lt;Real&gt;::_cholesky_back_substitute</a>(<a class="code" href="classDenseVector.php">DenseVector&lt;Complex&gt;</a>&amp;, <a class="code" href="classDenseVector.php">DenseVector&lt;Complex&gt;</a>&amp;) <span class="keyword">const</span>;
<a name="l00829"></a>00829 
<a name="l00830"></a>00830 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00831"></a>00831 <span class="preprocessor"></span><span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Complex&gt;</a>;
<a name="l00832"></a>00832 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a7303f17ad11891bc43f2533688347f15">DenseMatrix&lt;Complex&gt;::cholesky_solve</a>(<a class="code" href="classDenseVector.php">DenseVector&lt;Complex&gt;</a>&amp;,<a class="code" href="classDenseVector.php">DenseVector&lt;Complex&gt;</a>&amp;);
<a name="l00833"></a>00833 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a1dd46dd8b694003773ba285c3d0a7857">DenseMatrix&lt;Complex&gt;::_cholesky_back_substitute</a>(<a class="code" href="classDenseVector.php">DenseVector&lt;Complex&gt;</a>&amp;, <a class="code" href="classDenseVector.php">DenseVector&lt;Complex&gt;</a>&amp;) <span class="keyword">const</span>;
<a name="l00834"></a>00834 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
