<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>dense_matrix.h</h1>  </div>
</div>
<div class="contents">
<a href="dense__matrix_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: dense_matrix.h 3500 2009-10-19 18:28:00Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __dense_matrix_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __dense_matrix_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix__base_8h.php">dense_matrix_base.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Forward Declarations</span>
<a name="l00034"></a>00034 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classDenseVector.php">DenseVector</a>;
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00046"></a>00046 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00047"></a>00047 <span class="comment">// Dense Matrix class definition</span>
<a name="l00048"></a>00048 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00049"></a><a class="code" href="classDenseMatrix.php">00049</a> <span class="keyword">class </span><a class="code" href="classDenseMatrix.php">DenseMatrix</a> : <span class="keyword">public</span> <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase</a>&lt;T&gt;
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 <span class="keyword">public</span>:
<a name="l00052"></a>00052   
<a name="l00056"></a>00056   <a class="code" href="classDenseMatrix.php#a07f24658c14f42b8891fed8e5890a765">DenseMatrix</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>=0,
<a name="l00057"></a>00057               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>=0);
<a name="l00058"></a>00058   
<a name="l00062"></a>00062   <span class="comment">//DenseMatrix (const DenseMatrix&lt;T&gt;&amp; other_matrix);</span>
<a name="l00063"></a>00063   
<a name="l00067"></a><a class="code" href="classDenseMatrix.php#af6829cfab27070260b9dd97cdc87e8f1">00067</a>   <span class="keyword">virtual</span> <a class="code" href="classDenseMatrix.php#af6829cfab27070260b9dd97cdc87e8f1">~DenseMatrix</a>() {}
<a name="l00068"></a>00068   
<a name="l00069"></a>00069 
<a name="l00073"></a>00073   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a3d3f0e57fc2e9dc7ed292cbd2124581e">zero</a>();
<a name="l00074"></a>00074 
<a name="l00078"></a>00078   T <a class="code" href="classDenseMatrix.php#a0fa309492ca2d0c29ac04200d4c4c21a">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00079"></a>00079                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span>;
<a name="l00080"></a>00080 
<a name="l00084"></a>00084   T &amp; <a class="code" href="classDenseMatrix.php#a0fa309492ca2d0c29ac04200d4c4c21a">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00085"></a>00085                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j);
<a name="l00086"></a>00086 
<a name="l00090"></a><a class="code" href="classDenseMatrix.php#a402a0f179fe89e492352ba0a27879995">00090</a>   <span class="keyword">virtual</span> T <a class="code" href="classDenseMatrix.php#a402a0f179fe89e492352ba0a27879995">el</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00091"></a>00091                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (*<span class="keyword">this</span>)(i,j); }
<a name="l00092"></a>00092 
<a name="l00096"></a><a class="code" href="classDenseMatrix.php#aaa467e14640bb1b4f1858d55775e13b3">00096</a>   <span class="keyword">virtual</span> T &amp; <a class="code" href="classDenseMatrix.php#a402a0f179fe89e492352ba0a27879995">el</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00097"></a>00097                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)     { <span class="keywordflow">return</span> (*<span class="keyword">this</span>)(i,j); } 
<a name="l00098"></a>00098 
<a name="l00102"></a>00102   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a433dced554023601bd1f044f5d643f20">left_multiply</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M2);
<a name="l00103"></a>00103   
<a name="l00107"></a>00107   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a56e32ffe655816974245f3daef9f6581">right_multiply</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M3);
<a name="l00108"></a>00108 
<a name="l00112"></a>00112   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a0c25dd3e8d8093f7443c4b6689c73b10">vector_mult</a>(<a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; dest, <span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; arg) <span class="keyword">const</span>;
<a name="l00113"></a>00113   
<a name="l00117"></a>00117   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a793bc1a660afe34dc0cbd511690e8e4f">vector_mult_add</a> (<a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; dest, 
<a name="l00118"></a>00118                         <span class="keyword">const</span> T factor,
<a name="l00119"></a>00119                         <span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; arg) <span class="keyword">const</span>;
<a name="l00120"></a>00120 
<a name="l00124"></a>00124   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a626560df7c0156c3df968de490fae49d">get_principal_submatrix</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sub_m, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sub_n, <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00125"></a>00125 
<a name="l00129"></a>00129   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a626560df7c0156c3df968de490fae49d">get_principal_submatrix</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sub_m, <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00130"></a>00130 
<a name="l00134"></a>00134   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classDenseMatrix.php#ad293df7ee6583e348ec9b8499d4a75a8">operator = </a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; other_matrix);
<a name="l00135"></a>00135   
<a name="l00139"></a>00139   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a0df961e52a0694a9300dea1714a1a369">swap</a>(<a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; other_matrix);
<a name="l00140"></a>00140   
<a name="l00145"></a>00145   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a8c19724598a1ac1e3c758aaad73beb1b">resize</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>,
<a name="l00146"></a>00146               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>);
<a name="l00147"></a>00147   
<a name="l00151"></a>00151   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a351267a7851c029a0d004459503a11c6">scale</a> (<span class="keyword">const</span> T factor);
<a name="l00152"></a>00152 
<a name="l00156"></a>00156   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classDenseMatrix.php#ad7ff0060ad66019fd38e2fffbe8236f7">operator *= </a>(<span class="keyword">const</span> T factor);
<a name="l00157"></a>00157 
<a name="l00161"></a>00161   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a926f9d5c2903ba947f73176bdcafaa42">add</a> (<span class="keyword">const</span> T factor,
<a name="l00162"></a>00162             <span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; mat);
<a name="l00163"></a>00163 
<a name="l00167"></a>00167   <span class="keywordtype">bool</span> <a class="code" href="classDenseMatrix.php#adc172d92b644a789155f8bcbe3c0a39c">operator== </a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat) <span class="keyword">const</span>;
<a name="l00168"></a>00168 
<a name="l00172"></a>00172   <span class="keywordtype">bool</span> <a class="code" href="classDenseMatrix.php#a9d051182d046604b61eabefa4a7993d5">operator!= </a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat) <span class="keyword">const</span>;
<a name="l00173"></a>00173 
<a name="l00177"></a>00177   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classDenseMatrix.php#a37f84c6f02c320236ee22d4d11689282">operator+= </a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat);
<a name="l00178"></a>00178 
<a name="l00182"></a>00182   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classDenseMatrix.php#aff9623357e0dc5e47117353306cae23b">operator-= </a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat);
<a name="l00183"></a>00183 
<a name="l00189"></a>00189   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseMatrix.php#a89a7071cbca32b759c2b0955728578d0">min</a> () <span class="keyword">const</span>;
<a name="l00190"></a>00190 
<a name="l00196"></a>00196   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseMatrix.php#a860d9f18d875b6eb752443aaf6beff99">max</a> () <span class="keyword">const</span>;
<a name="l00197"></a>00197 
<a name="l00208"></a>00208   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseMatrix.php#a6abd86dc2628f0ebffc9661e98824cb5">l1_norm</a> () <span class="keyword">const</span>;
<a name="l00209"></a>00209 
<a name="l00221"></a>00221   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseMatrix.php#abc88ec7696ac80853dcebb1c9636e81c">linfty_norm</a> () <span class="keyword">const</span>;
<a name="l00222"></a>00222 
<a name="l00226"></a>00226   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a62832696c265cff213ff133f9e73ef34">left_multiply_transpose</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; A);
<a name="l00227"></a>00227   
<a name="l00228"></a>00228 
<a name="l00232"></a>00232   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a8a041f8b6c2f50de27565618331b16fb">right_multiply_transpose</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; A);
<a name="l00233"></a>00233   
<a name="l00237"></a>00237   T <a class="code" href="classDenseMatrix.php#a4ce520268efceb0e68897595d3b38318">transpose</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00238"></a>00238                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span>;
<a name="l00239"></a>00239 
<a name="l00243"></a>00243   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a638003ba25276a17569443b196d5fb33">get_transpose</a>(<a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00244"></a>00244  
<a name="l00250"></a><a class="code" href="classDenseMatrix.php#a528bde8c704176e220f23b79acdb11ec">00250</a>   std::vector&lt;T&gt;&amp; <a class="code" href="classDenseMatrix.php#a528bde8c704176e220f23b79acdb11ec">get_values</a>() { <span class="keywordflow">return</span> <a class="code" href="classDenseMatrix.php#a67fff9b9c3f340ec72d6dcc41c553857">_val</a>; }
<a name="l00251"></a>00251 
<a name="l00255"></a><a class="code" href="classDenseMatrix.php#a716972aab21d2fd0d20aefc48ab6acff">00255</a>   <span class="keyword">const</span> std::vector&lt;T&gt;&amp; <a class="code" href="classDenseMatrix.php#a716972aab21d2fd0d20aefc48ab6acff">get_values</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classDenseMatrix.php#a67fff9b9c3f340ec72d6dcc41c553857">_val</a>; }
<a name="l00256"></a>00256 
<a name="l00263"></a><a class="code" href="classDenseMatrix.php#a044d522b54b850609e6cee8b359373b9">00263</a>   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a044d522b54b850609e6cee8b359373b9">condense</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00264"></a>00264                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00265"></a>00265                 <span class="keyword">const</span> T val,
<a name="l00266"></a>00266                 <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; rhs)
<a name="l00267"></a>00267   { <a class="code" href="classDenseMatrix.php#a044d522b54b850609e6cee8b359373b9">DenseMatrixBase&lt;T&gt;::condense</a> (i, j, val, rhs); }
<a name="l00268"></a>00268 
<a name="l00272"></a>00272   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a477240f22a12d4bcf761b490414f4491">lu_solve</a> (<a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; b,
<a name="l00273"></a>00273                  <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; x,
<a name="l00274"></a>00274                  <span class="keyword">const</span> <span class="keywordtype">bool</span> partial_pivot = <span class="keyword">false</span>);
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 
<a name="l00287"></a>00287   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00288"></a>00288   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a7303f17ad11891bc43f2533688347f15">cholesky_solve</a>(<a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a>&amp; b,
<a name="l00289"></a>00289                       <a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a>&amp; x);
<a name="l00290"></a>00290 
<a name="l00291"></a>00291   
<a name="l00297"></a>00297   T <a class="code" href="classDenseMatrix.php#a9555f223e2e4e08461ffc68b9b252fb5">det</a>();
<a name="l00298"></a>00298 
<a name="l00307"></a>00307   <span class="comment">// void inverse();</span>
<a name="l00308"></a>00308 
<a name="l00314"></a><a class="code" href="classDenseMatrix.php#ad875ab4fccf4c80aa715e1819cc34a59">00314</a>   <span class="keywordtype">bool</span> <a class="code" href="classDenseMatrix.php#ad875ab4fccf4c80aa715e1819cc34a59">use_blas</a>;
<a name="l00315"></a>00315   
<a name="l00316"></a>00316 <span class="keyword">private</span>:
<a name="l00317"></a>00317 
<a name="l00321"></a><a class="code" href="classDenseMatrix.php#a67fff9b9c3f340ec72d6dcc41c553857">00321</a>   std::vector&lt;T&gt; <a class="code" href="classDenseMatrix.php#a67fff9b9c3f340ec72d6dcc41c553857">_val</a>;
<a name="l00322"></a>00322 
<a name="l00328"></a>00328   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#ad8001c2fe3b274823a2bcf237887886a">_lu_decompose</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> partial_pivot = <span class="keyword">false</span>);
<a name="l00329"></a>00329   
<a name="l00335"></a>00335   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a7162cded87fb34d00501233ca808c3fa">_lu_back_substitute</a> (<a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; b,
<a name="l00336"></a>00336                             <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; x,
<a name="l00337"></a>00337                             <span class="keyword">const</span> <span class="keywordtype">bool</span> partial_pivot = <span class="keyword">false</span>) <span class="keyword">const</span>;
<a name="l00338"></a>00338   
<a name="l00345"></a>00345   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#aa501a38d3d515b0abc6c83b243004aed">_cholesky_decompose</a>();
<a name="l00346"></a>00346 
<a name="l00353"></a>00353   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00354"></a>00354   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a1dd46dd8b694003773ba285c3d0a7857">_cholesky_back_substitute</a>(<a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a>&amp; b,
<a name="l00355"></a>00355                                  <a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a>&amp; x) <span class="keyword">const</span>;
<a name="l00356"></a>00356 
<a name="l00364"></a><a class="code" href="classDenseMatrix.php#a8f4bb90f1f58e9725d0fdfb2136edf79ad27bac3460e39a7265587840269e7de7">00364</a>   <span class="keyword">enum</span> <a class="code" href="classDenseMatrix.php#a8f4bb90f1f58e9725d0fdfb2136edf79">DecompositionType</a> {<a class="code" href="classDenseMatrix.php#a8f4bb90f1f58e9725d0fdfb2136edf79ab75f9cd205ebf1b98c8b6763531a9d4b">LU</a>=0, <a class="code" href="classDenseMatrix.php#a8f4bb90f1f58e9725d0fdfb2136edf79a0fd7d13452689b7c2cc7fab76c43c1db">CHOLESKY</a>=1, <a class="code" href="classDenseMatrix.php#a8f4bb90f1f58e9725d0fdfb2136edf79ad27bac3460e39a7265587840269e7de7">NONE</a>};
<a name="l00365"></a>00365 
<a name="l00370"></a><a class="code" href="classDenseMatrix.php#acf91e81fcfedfa7315e3d50a17a4d601">00370</a>   <a class="code" href="classDenseMatrix.php#a8f4bb90f1f58e9725d0fdfb2136edf79">DecompositionType</a> <a class="code" href="classDenseMatrix.php#acf91e81fcfedfa7315e3d50a17a4d601">_decomposition_type</a>;
<a name="l00371"></a>00371 
<a name="l00377"></a><a class="code" href="classDenseMatrix.php#a8098ef9aa70df77446f58c5bf11b31df">00377</a>   <span class="keyword">enum</span> <a class="code" href="classDenseMatrix.php#a8098ef9aa70df77446f58c5bf11b31df">_BLAS_Multiply_Flag</a> {
<a name="l00378"></a><a class="code" href="classDenseMatrix.php#a8098ef9aa70df77446f58c5bf11b31dfa80acd7cf5acacf600111b83d883f2bfb">00378</a>     <a class="code" href="classDenseMatrix.php#a8098ef9aa70df77446f58c5bf11b31dfa80acd7cf5acacf600111b83d883f2bfb">LEFT_MULTIPLY</a> = 0,
<a name="l00379"></a><a class="code" href="classDenseMatrix.php#a8098ef9aa70df77446f58c5bf11b31dfaa19235d419d1c9913b4f00017d6e6705">00379</a>     <a class="code" href="classDenseMatrix.php#a8098ef9aa70df77446f58c5bf11b31dfaa19235d419d1c9913b4f00017d6e6705">RIGHT_MULTIPLY</a>,
<a name="l00380"></a><a class="code" href="classDenseMatrix.php#a8098ef9aa70df77446f58c5bf11b31dfa0bc6d72861e896984f7f43a1584bd766">00380</a>     <a class="code" href="classDenseMatrix.php#a8098ef9aa70df77446f58c5bf11b31dfa0bc6d72861e896984f7f43a1584bd766">LEFT_MULTIPLY_TRANSPOSE</a>,
<a name="l00381"></a><a class="code" href="classDenseMatrix.php#a8098ef9aa70df77446f58c5bf11b31dfa7b911eec21546aefa521021ee09f1b62">00381</a>     <a class="code" href="classDenseMatrix.php#a8098ef9aa70df77446f58c5bf11b31dfa7b911eec21546aefa521021ee09f1b62">RIGHT_MULTIPLY_TRANSPOSE</a>
<a name="l00382"></a>00382   };
<a name="l00383"></a>00383   
<a name="l00384"></a>00384   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#ac6e3d04b71255db7b69410ed71fbb579">_multiply_blas</a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; other,
<a name="l00385"></a>00385                       <a class="code" href="classDenseMatrix.php#a8098ef9aa70df77446f58c5bf11b31df">_BLAS_Multiply_Flag</a> flag);
<a name="l00386"></a>00386 };
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 
<a name="l00389"></a>00389 
<a name="l00390"></a>00390 
<a name="l00391"></a>00391 
<a name="l00392"></a>00392 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00396"></a><a class="code" href="namespaceDenseMatrices.php">00396</a> <span class="comment"></span><span class="keyword">namespace </span>DenseMatrices
<a name="l00397"></a>00397 {
<a name="l00398"></a>00398 
<a name="l00403"></a><a class="code" href="namespaceDenseMatrices.php#af147cb4fc0cc650438e683ae70b742aa">00403</a>   <span class="keyword">typedef</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Real&gt;</a> <a class="code" href="namespaceDenseMatrices.php#af147cb4fc0cc650438e683ae70b742aa">RealDenseMatrix</a>;
<a name="l00404"></a>00404 
<a name="l00414"></a><a class="code" href="namespaceDenseMatrices.php#a7a41ed10c5fac190d994359a809de205">00414</a>   <span class="keyword">typedef</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Complex&gt;</a> <a class="code" href="namespaceDenseMatrices.php#a7a41ed10c5fac190d994359a809de205">ComplexDenseMatrix</a>;  
<a name="l00415"></a>00415 
<a name="l00416"></a>00416 }
<a name="l00417"></a>00417 
<a name="l00418"></a>00418 
<a name="l00419"></a>00419 
<a name="l00420"></a>00420 <span class="keyword">using namespace </span>DenseMatrices;
<a name="l00421"></a>00421 
<a name="l00422"></a>00422 
<a name="l00423"></a>00423 
<a name="l00424"></a>00424 
<a name="l00425"></a>00425 
<a name="l00426"></a>00426 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00427"></a>00427 <span class="comment">// Dense Matrix member functions</span>
<a name="l00428"></a>00428 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00429"></a>00429 <span class="keyword">inline</span>
<a name="l00430"></a><a class="code" href="classDenseMatrix.php#a07f24658c14f42b8891fed8e5890a765">00430</a> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;::DenseMatrix</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m,
<a name="l00431"></a>00431                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00432"></a>00432   : <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase</a>&lt;T&gt;(m,n),
<a name="l00433"></a>00433 #if defined(LIBMESH_HAVE_PETSC) &amp;&amp; defined(LIBMESH_USE_REAL_NUMBERS)
<a name="l00434"></a>00434     use_blas(true),
<a name="l00435"></a>00435 #else
<a name="l00436"></a>00436     use_blas(false),
<a name="l00437"></a>00437 #endif
<a name="l00438"></a>00438     _decomposition_type(NONE)
<a name="l00439"></a>00439 {
<a name="l00440"></a>00440   this-&gt;<a class="code" href="classDenseMatrix.php#a8c19724598a1ac1e3c758aaad73beb1b">resize</a>(m,n);
<a name="l00441"></a>00441 }
<a name="l00442"></a>00442 
<a name="l00443"></a>00443 
<a name="l00444"></a>00444 
<a name="l00445"></a>00445 <span class="comment">// FIXME[JWP]: This copy ctor has not been maintained along with</span>
<a name="l00446"></a>00446 <span class="comment">// the rest of the class...</span>
<a name="l00447"></a>00447 <span class="comment">// Can we just use the compiler-generated copy ctor here?</span>
<a name="l00448"></a>00448 <span class="comment">// template&lt;typename T&gt;</span>
<a name="l00449"></a>00449 <span class="comment">// inline</span>
<a name="l00450"></a>00450 <span class="comment">// DenseMatrix&lt;T&gt;::DenseMatrix (const DenseMatrix&lt;T&gt;&amp; other_matrix)</span>
<a name="l00451"></a>00451 <span class="comment">//   : DenseMatrixBase&lt;T&gt;(other_matrix._m, other_matrix._n)</span>
<a name="l00452"></a>00452 <span class="comment">// {</span>
<a name="l00453"></a>00453 <span class="comment">//   _val = other_matrix._val;</span>
<a name="l00454"></a>00454 <span class="comment">// }</span>
<a name="l00455"></a>00455 
<a name="l00456"></a>00456 
<a name="l00457"></a>00457 
<a name="l00458"></a>00458 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00459"></a>00459 <span class="keyword">inline</span>
<a name="l00460"></a><a class="code" href="classDenseMatrix.php#a0df961e52a0694a9300dea1714a1a369">00460</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a0df961e52a0694a9300dea1714a1a369">DenseMatrix&lt;T&gt;::swap</a>(<a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; other_matrix)
<a name="l00461"></a>00461 {
<a name="l00462"></a>00462   std::swap(this-&gt;_m, other_matrix.<a class="code" href="classDenseMatrixBase.php#aaecdb483ac1742384dcf2e8f6f5fc3e5">_m</a>);
<a name="l00463"></a>00463   std::swap(this-&gt;_n, other_matrix.<a class="code" href="classDenseMatrixBase.php#a0dcd22fecda2c896e16ff7cb957233a3">_n</a>);
<a name="l00464"></a>00464   _val.swap(other_matrix.<a class="code" href="classDenseMatrix.php#a67fff9b9c3f340ec72d6dcc41c553857">_val</a>);
<a name="l00465"></a>00465   <a class="code" href="classDenseMatrix.php#a8f4bb90f1f58e9725d0fdfb2136edf79">DecompositionType</a> _temp = _decomposition_type;
<a name="l00466"></a>00466   _decomposition_type = other_matrix.<a class="code" href="classDenseMatrix.php#acf91e81fcfedfa7315e3d50a17a4d601">_decomposition_type</a>;
<a name="l00467"></a>00467   other_matrix.<a class="code" href="classDenseMatrix.php#acf91e81fcfedfa7315e3d50a17a4d601">_decomposition_type</a> = _temp;
<a name="l00468"></a>00468 }
<a name="l00469"></a>00469 
<a name="l00470"></a>00470 
<a name="l00471"></a>00471   
<a name="l00472"></a>00472 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00473"></a>00473 <span class="keyword">inline</span>
<a name="l00474"></a><a class="code" href="classDenseMatrix.php#a8c19724598a1ac1e3c758aaad73beb1b">00474</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a8c19724598a1ac1e3c758aaad73beb1b">DenseMatrix&lt;T&gt;::resize</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m,
<a name="l00475"></a>00475                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00476"></a>00476 {
<a name="l00477"></a>00477   _val.resize(m*n);
<a name="l00478"></a>00478 
<a name="l00479"></a>00479   this-&gt;_m = m;
<a name="l00480"></a>00480   this-&gt;_n = n;
<a name="l00481"></a>00481 
<a name="l00482"></a>00482   _decomposition_type = NONE;
<a name="l00483"></a>00483   this-&gt;<a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a>();
<a name="l00484"></a>00484 }
<a name="l00485"></a>00485 
<a name="l00486"></a>00486 
<a name="l00487"></a>00487 
<a name="l00488"></a>00488 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00489"></a>00489 <span class="keyword">inline</span>
<a name="l00490"></a><a class="code" href="classDenseMatrix.php#a3d3f0e57fc2e9dc7ed292cbd2124581e">00490</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a3d3f0e57fc2e9dc7ed292cbd2124581e">DenseMatrix&lt;T&gt;::zero</a>()
<a name="l00491"></a>00491 {
<a name="l00492"></a>00492   _decomposition_type = NONE;
<a name="l00493"></a>00493 
<a name="l00494"></a>00494   std::fill (_val.begin(), _val.end(), 0.);
<a name="l00495"></a>00495 }
<a name="l00496"></a>00496 
<a name="l00497"></a>00497 
<a name="l00498"></a>00498 
<a name="l00499"></a>00499 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00500"></a>00500 <span class="keyword">inline</span>
<a name="l00501"></a><a class="code" href="classDenseMatrix.php#ad293df7ee6583e348ec9b8499d4a75a8">00501</a> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classDenseMatrix.php#ad293df7ee6583e348ec9b8499d4a75a8">DenseMatrix&lt;T&gt;::operator = </a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; other_matrix)
<a name="l00502"></a>00502 {
<a name="l00503"></a>00503   this-&gt;_m = other_matrix.<a class="code" href="classDenseMatrixBase.php#aaecdb483ac1742384dcf2e8f6f5fc3e5">_m</a>;
<a name="l00504"></a>00504   this-&gt;_n = other_matrix.<a class="code" href="classDenseMatrixBase.php#a0dcd22fecda2c896e16ff7cb957233a3">_n</a>;
<a name="l00505"></a>00505 
<a name="l00506"></a>00506   _val                = other_matrix.<a class="code" href="classDenseMatrix.php#a67fff9b9c3f340ec72d6dcc41c553857">_val</a>;
<a name="l00507"></a>00507   _decomposition_type = other_matrix.<a class="code" href="classDenseMatrix.php#acf91e81fcfedfa7315e3d50a17a4d601">_decomposition_type</a>;
<a name="l00508"></a>00508 
<a name="l00509"></a>00509   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00510"></a>00510 }
<a name="l00511"></a>00511 
<a name="l00512"></a>00512 
<a name="l00513"></a>00513 
<a name="l00514"></a>00514 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00515"></a>00515 <span class="keyword">inline</span>
<a name="l00516"></a><a class="code" href="classDenseMatrix.php#a0fa309492ca2d0c29ac04200d4c4c21a">00516</a> T <a class="code" href="classDenseMatrix.php#a0fa309492ca2d0c29ac04200d4c4c21a">DenseMatrix&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00517"></a>00517                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const</span>
<a name="l00518"></a>00518 <span class="keyword"></span>{
<a name="l00519"></a>00519   libmesh_assert (i*j&lt;_val.size());
<a name="l00520"></a>00520   libmesh_assert (i &lt; this-&gt;_m);
<a name="l00521"></a>00521   libmesh_assert (j &lt; this-&gt;_n);
<a name="l00522"></a>00522   
<a name="l00523"></a>00523   
<a name="l00524"></a>00524   <span class="comment">//  return _val[(i) + (this-&gt;_m)*(j)]; // col-major</span>
<a name="l00525"></a>00525   <span class="keywordflow">return</span> _val[(i)*(this-&gt;_n) + (j)]; <span class="comment">// row-major</span>
<a name="l00526"></a>00526 }
<a name="l00527"></a>00527 
<a name="l00528"></a>00528 
<a name="l00529"></a>00529 
<a name="l00530"></a>00530 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00531"></a>00531 <span class="keyword">inline</span>
<a name="l00532"></a><a class="code" href="classDenseMatrix.php#ac79773a59c9ea041f31f92840897dd30">00532</a> T &amp; <a class="code" href="classDenseMatrix.php#a0fa309492ca2d0c29ac04200d4c4c21a">DenseMatrix&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00533"></a>00533                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)
<a name="l00534"></a>00534 {
<a name="l00535"></a>00535   libmesh_assert (i*j&lt;_val.size());
<a name="l00536"></a>00536   libmesh_assert (i &lt; this-&gt;_m);
<a name="l00537"></a>00537   libmesh_assert (j &lt; this-&gt;_n);
<a name="l00538"></a>00538   
<a name="l00539"></a>00539   <span class="comment">//return _val[(i) + (this-&gt;_m)*(j)]; // col-major</span>
<a name="l00540"></a>00540   <span class="keywordflow">return</span> _val[(i)*(this-&gt;_n) + (j)]; <span class="comment">// row-major</span>
<a name="l00541"></a>00541 }
<a name="l00542"></a>00542 
<a name="l00543"></a>00543 
<a name="l00544"></a>00544      
<a name="l00545"></a>00545 
<a name="l00546"></a>00546 
<a name="l00547"></a>00547 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00548"></a>00548 <span class="keyword">inline</span>
<a name="l00549"></a><a class="code" href="classDenseMatrix.php#a351267a7851c029a0d004459503a11c6">00549</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a351267a7851c029a0d004459503a11c6">DenseMatrix&lt;T&gt;::scale</a> (<span class="keyword">const</span> T factor)
<a name="l00550"></a>00550 {
<a name="l00551"></a>00551   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;_val.size(); i++)
<a name="l00552"></a>00552     _val[i] *= factor;
<a name="l00553"></a>00553 }
<a name="l00554"></a>00554 
<a name="l00555"></a>00555 
<a name="l00556"></a>00556 
<a name="l00557"></a>00557 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00558"></a>00558 <span class="keyword">inline</span>
<a name="l00559"></a><a class="code" href="classDenseMatrix.php#ad7ff0060ad66019fd38e2fffbe8236f7">00559</a> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classDenseMatrix.php#ad7ff0060ad66019fd38e2fffbe8236f7">DenseMatrix&lt;T&gt;::operator *= </a>(<span class="keyword">const</span> T factor)
<a name="l00560"></a>00560 {
<a name="l00561"></a>00561   this-&gt;<a class="code" href="namespaceMeshTools_1_1Modification.php#ae71416e394dfbc45fe3d8b37b9b0c7ba">scale</a>(factor);
<a name="l00562"></a>00562   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00563"></a>00563 }
<a name="l00564"></a>00564 
<a name="l00565"></a>00565 
<a name="l00566"></a>00566 
<a name="l00567"></a>00567 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00568"></a>00568 <span class="keyword">inline</span>
<a name="l00569"></a><a class="code" href="classDenseMatrix.php#a926f9d5c2903ba947f73176bdcafaa42">00569</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a926f9d5c2903ba947f73176bdcafaa42">DenseMatrix&lt;T&gt;::add</a> (<span class="keyword">const</span> T factor, <span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; mat)
<a name="l00570"></a>00570 {
<a name="l00571"></a>00571   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;_val.size(); i++)
<a name="l00572"></a>00572     _val[i] += factor * mat.<a class="code" href="classDenseMatrix.php#a67fff9b9c3f340ec72d6dcc41c553857">_val</a>[i];
<a name="l00573"></a>00573 }
<a name="l00574"></a>00574 
<a name="l00575"></a>00575 
<a name="l00576"></a>00576 
<a name="l00577"></a>00577 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00578"></a>00578 <span class="keyword">inline</span>
<a name="l00579"></a><a class="code" href="classDenseMatrix.php#adc172d92b644a789155f8bcbe3c0a39c">00579</a> <span class="keywordtype">bool</span> <a class="code" href="classDenseMatrix.php#adc172d92b644a789155f8bcbe3c0a39c">DenseMatrix&lt;T&gt;::operator == </a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat)<span class="keyword"> const</span>
<a name="l00580"></a>00580 <span class="keyword"></span>{
<a name="l00581"></a>00581   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;_val.size(); i++)
<a name="l00582"></a>00582     <span class="keywordflow">if</span> (_val[i] != mat.<a class="code" href="classDenseMatrix.php#a67fff9b9c3f340ec72d6dcc41c553857">_val</a>[i])
<a name="l00583"></a>00583       <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00584"></a>00584 
<a name="l00585"></a>00585   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00586"></a>00586 }
<a name="l00587"></a>00587 
<a name="l00588"></a>00588 
<a name="l00589"></a>00589 
<a name="l00590"></a>00590 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00591"></a>00591 <span class="keyword">inline</span>
<a name="l00592"></a><a class="code" href="classDenseMatrix.php#a9d051182d046604b61eabefa4a7993d5">00592</a> <span class="keywordtype">bool</span> <a class="code" href="classDenseMatrix.php#a9d051182d046604b61eabefa4a7993d5">DenseMatrix&lt;T&gt;::operator != </a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat)<span class="keyword"> const</span>
<a name="l00593"></a>00593 <span class="keyword"></span>{
<a name="l00594"></a>00594   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;_val.size(); i++)
<a name="l00595"></a>00595     <span class="keywordflow">if</span> (_val[i] != mat.<a class="code" href="classDenseMatrix.php#a67fff9b9c3f340ec72d6dcc41c553857">_val</a>[i])
<a name="l00596"></a>00596       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00597"></a>00597 
<a name="l00598"></a>00598   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00599"></a>00599 }
<a name="l00600"></a>00600 
<a name="l00601"></a>00601 
<a name="l00602"></a>00602 
<a name="l00603"></a>00603 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00604"></a>00604 <span class="keyword">inline</span>
<a name="l00605"></a><a class="code" href="classDenseMatrix.php#a37f84c6f02c320236ee22d4d11689282">00605</a> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classDenseMatrix.php#a37f84c6f02c320236ee22d4d11689282">DenseMatrix&lt;T&gt;::operator += </a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat)
<a name="l00606"></a>00606 {
<a name="l00607"></a>00607   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;_val.size(); i++)
<a name="l00608"></a>00608     _val[i] += mat.<a class="code" href="classDenseMatrix.php#a67fff9b9c3f340ec72d6dcc41c553857">_val</a>[i];
<a name="l00609"></a>00609 
<a name="l00610"></a>00610   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00611"></a>00611 }
<a name="l00612"></a>00612 
<a name="l00613"></a>00613 
<a name="l00614"></a>00614 
<a name="l00615"></a>00615 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00616"></a>00616 <span class="keyword">inline</span>
<a name="l00617"></a><a class="code" href="classDenseMatrix.php#aff9623357e0dc5e47117353306cae23b">00617</a> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classDenseMatrix.php#aff9623357e0dc5e47117353306cae23b">DenseMatrix&lt;T&gt;::operator -= </a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat)
<a name="l00618"></a>00618 {
<a name="l00619"></a>00619   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;_val.size(); i++)
<a name="l00620"></a>00620     _val[i] -= mat.<a class="code" href="classDenseMatrix.php#a67fff9b9c3f340ec72d6dcc41c553857">_val</a>[i];
<a name="l00621"></a>00621 
<a name="l00622"></a>00622   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00623"></a>00623 }
<a name="l00624"></a>00624 
<a name="l00625"></a>00625 
<a name="l00626"></a>00626 
<a name="l00627"></a>00627 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00628"></a>00628 <span class="keyword">inline</span>
<a name="l00629"></a><a class="code" href="classDenseMatrix.php#a89a7071cbca32b759c2b0955728578d0">00629</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseMatrix.php#a89a7071cbca32b759c2b0955728578d0">DenseMatrix&lt;T&gt;::min</a> ()<span class="keyword"> const</span>
<a name="l00630"></a>00630 <span class="keyword"></span>{
<a name="l00631"></a>00631   libmesh_assert (this-&gt;_m);
<a name="l00632"></a>00632   libmesh_assert (this-&gt;_n);
<a name="l00633"></a>00633   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> my_min = <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>((*<span class="keyword">this</span>)(0,0));
<a name="l00634"></a>00634 
<a name="l00635"></a>00635   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=this-&gt;_m; i++)
<a name="l00636"></a>00636     {
<a name="l00637"></a>00637       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j!=this-&gt;_n; j++)
<a name="l00638"></a>00638         {
<a name="l00639"></a>00639           <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> current = <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>((*<span class="keyword">this</span>)(i,j));
<a name="l00640"></a>00640           my_min = (my_min &lt; current? my_min : current);
<a name="l00641"></a>00641         }
<a name="l00642"></a>00642     }
<a name="l00643"></a>00643   <span class="keywordflow">return</span> my_min;
<a name="l00644"></a>00644 }
<a name="l00645"></a>00645 
<a name="l00646"></a>00646 
<a name="l00647"></a>00647 
<a name="l00648"></a>00648 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00649"></a>00649 <span class="keyword">inline</span>
<a name="l00650"></a><a class="code" href="classDenseMatrix.php#a860d9f18d875b6eb752443aaf6beff99">00650</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseMatrix.php#a860d9f18d875b6eb752443aaf6beff99">DenseMatrix&lt;T&gt;::max</a> ()<span class="keyword"> const</span>
<a name="l00651"></a>00651 <span class="keyword"></span>{
<a name="l00652"></a>00652   libmesh_assert (this-&gt;_m);
<a name="l00653"></a>00653   libmesh_assert (this-&gt;_n);
<a name="l00654"></a>00654   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> my_max = <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>((*<span class="keyword">this</span>)(0,0));
<a name="l00655"></a>00655 
<a name="l00656"></a>00656   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=this-&gt;_m; i++)
<a name="l00657"></a>00657     {
<a name="l00658"></a>00658       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j!=this-&gt;_n; j++)
<a name="l00659"></a>00659         {
<a name="l00660"></a>00660           <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> current = <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>((*<span class="keyword">this</span>)(i,j));
<a name="l00661"></a>00661           my_max = (my_max &gt; current? my_max : current);
<a name="l00662"></a>00662         }
<a name="l00663"></a>00663     }
<a name="l00664"></a>00664   <span class="keywordflow">return</span> my_max;
<a name="l00665"></a>00665 }
<a name="l00666"></a>00666 
<a name="l00667"></a>00667 
<a name="l00668"></a>00668 
<a name="l00669"></a>00669 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00670"></a>00670 <span class="keyword">inline</span>
<a name="l00671"></a><a class="code" href="classDenseMatrix.php#a6abd86dc2628f0ebffc9661e98824cb5">00671</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseMatrix.php#a6abd86dc2628f0ebffc9661e98824cb5">DenseMatrix&lt;T&gt;::l1_norm</a> ()<span class="keyword"> const</span>
<a name="l00672"></a>00672 <span class="keyword"></span>{
<a name="l00673"></a>00673   libmesh_assert (this-&gt;_m);
<a name="l00674"></a>00674   libmesh_assert (this-&gt;_n);
<a name="l00675"></a>00675 
<a name="l00676"></a>00676   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> columnsum = 0.;
<a name="l00677"></a>00677   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=this-&gt;_m; i++)
<a name="l00678"></a>00678     {
<a name="l00679"></a>00679       columnsum += std::abs((*<span class="keyword">this</span>)(i,0));
<a name="l00680"></a>00680     }
<a name="l00681"></a>00681   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> my_max = columnsum;
<a name="l00682"></a>00682   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=1; j!=this-&gt;_n; j++)
<a name="l00683"></a>00683     {
<a name="l00684"></a>00684       columnsum = 0.;
<a name="l00685"></a>00685       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=this-&gt;_m; i++)
<a name="l00686"></a>00686         {
<a name="l00687"></a>00687           columnsum += std::abs((*<span class="keyword">this</span>)(i,j));
<a name="l00688"></a>00688         }
<a name="l00689"></a>00689       my_max = (my_max &gt; columnsum? my_max : columnsum);
<a name="l00690"></a>00690     }
<a name="l00691"></a>00691   <span class="keywordflow">return</span> my_max;
<a name="l00692"></a>00692 }
<a name="l00693"></a>00693 
<a name="l00694"></a>00694 
<a name="l00695"></a>00695 
<a name="l00696"></a>00696 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00697"></a>00697 <span class="keyword">inline</span>
<a name="l00698"></a><a class="code" href="classDenseMatrix.php#abc88ec7696ac80853dcebb1c9636e81c">00698</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseMatrix.php#abc88ec7696ac80853dcebb1c9636e81c">DenseMatrix&lt;T&gt;::linfty_norm</a> ()<span class="keyword"> const</span>
<a name="l00699"></a>00699 <span class="keyword"></span>{
<a name="l00700"></a>00700   libmesh_assert (this-&gt;_m);
<a name="l00701"></a>00701   libmesh_assert (this-&gt;_n);
<a name="l00702"></a>00702 
<a name="l00703"></a>00703   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> rowsum = 0.;
<a name="l00704"></a>00704   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j!=this-&gt;_n; j++)
<a name="l00705"></a>00705     {
<a name="l00706"></a>00706       rowsum += std::abs((*<span class="keyword">this</span>)(0,j));
<a name="l00707"></a>00707     }
<a name="l00708"></a>00708   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> my_max = rowsum;
<a name="l00709"></a>00709   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i!=this-&gt;_m; i++)
<a name="l00710"></a>00710     {
<a name="l00711"></a>00711       rowsum = 0.;
<a name="l00712"></a>00712       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j!=this-&gt;_n; j++)
<a name="l00713"></a>00713         {
<a name="l00714"></a>00714           rowsum += std::abs((*<span class="keyword">this</span>)(i,j));
<a name="l00715"></a>00715         }
<a name="l00716"></a>00716       my_max = (my_max &gt; rowsum? my_max : rowsum);
<a name="l00717"></a>00717     }
<a name="l00718"></a>00718   <span class="keywordflow">return</span> my_max;
<a name="l00719"></a>00719 }
<a name="l00720"></a>00720 
<a name="l00721"></a>00721 
<a name="l00722"></a>00722 
<a name="l00723"></a>00723 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00724"></a>00724 <span class="keyword">inline</span>
<a name="l00725"></a><a class="code" href="classDenseMatrix.php#a4ce520268efceb0e68897595d3b38318">00725</a> T <a class="code" href="classDenseMatrix.php#a4ce520268efceb0e68897595d3b38318">DenseMatrix&lt;T&gt;::transpose</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00726"></a>00726                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const</span>
<a name="l00727"></a>00727 <span class="keyword"></span>{
<a name="l00728"></a>00728   <span class="comment">// Implement in terms of operator()</span>
<a name="l00729"></a>00729   <span class="keywordflow">return</span> (*<span class="keyword">this</span>)(j,i);
<a name="l00730"></a>00730 }
<a name="l00731"></a>00731 
<a name="l00732"></a>00732 
<a name="l00733"></a>00733 
<a name="l00734"></a>00734 
<a name="l00735"></a>00735 
<a name="l00736"></a>00736 <span class="comment">// template&lt;typename T&gt;</span>
<a name="l00737"></a>00737 <span class="comment">// inline</span>
<a name="l00738"></a>00738 <span class="comment">// void DenseMatrix&lt;T&gt;::condense(const unsigned int iv,</span>
<a name="l00739"></a>00739 <span class="comment">//                            const unsigned int jv,</span>
<a name="l00740"></a>00740 <span class="comment">//                            const T val,</span>
<a name="l00741"></a>00741 <span class="comment">//                            DenseVector&lt;T&gt;&amp; rhs)</span>
<a name="l00742"></a>00742 <span class="comment">// {</span>
<a name="l00743"></a>00743 <span class="comment">//   libmesh_assert (this-&gt;_m == rhs.size());</span>
<a name="l00744"></a>00744 <span class="comment">//   libmesh_assert (iv == jv);</span>
<a name="l00745"></a>00745 
<a name="l00746"></a>00746 
<a name="l00747"></a>00747 <span class="comment">//   // move the known value into the RHS</span>
<a name="l00748"></a>00748 <span class="comment">//   // and zero the column</span>
<a name="l00749"></a>00749 <span class="comment">//   for (unsigned int i=0; i&lt;this-&gt;m(); i++)</span>
<a name="l00750"></a>00750 <span class="comment">//     {</span>
<a name="l00751"></a>00751 <span class="comment">//       rhs(i) -= ((*this)(i,jv))*val;</span>
<a name="l00752"></a>00752 <span class="comment">//       (*this)(i,jv) = 0.;</span>
<a name="l00753"></a>00753 <span class="comment">//     }</span>
<a name="l00754"></a>00754 
<a name="l00755"></a>00755 <span class="comment">//   // zero the row</span>
<a name="l00756"></a>00756 <span class="comment">//   for (unsigned int j=0; j&lt;this-&gt;n(); j++)</span>
<a name="l00757"></a>00757 <span class="comment">//     (*this)(iv,j) = 0.;</span>
<a name="l00758"></a>00758 
<a name="l00759"></a>00759 <span class="comment">//   (*this)(iv,jv) = 1.;</span>
<a name="l00760"></a>00760 <span class="comment">//   rhs(iv) = val;</span>
<a name="l00761"></a>00761   
<a name="l00762"></a>00762 <span class="comment">// }</span>
<a name="l00763"></a>00763 
<a name="l00764"></a>00764 
<a name="l00765"></a>00765 
<a name="l00766"></a>00766 
<a name="l00767"></a>00767 
<a name="l00768"></a>00768 
<a name="l00769"></a>00769 
<a name="l00770"></a>00770 <span class="preprocessor">#endif // #ifndef __dense_matrix_h__</span>
<a name="l00771"></a>00771 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
