<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>dense_matrix_base.h</h1>  </div>
</div>
<div class="contents">
<a href="dense__matrix__base_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: dense_matrix_base.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __dense_matrix_base_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __dense_matrix_base_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;compare_types.h&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Forward Delcarations</span>
<a name="l00032"></a>00032 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classDenseVectorBase.php">DenseVectorBase</a>;
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00044"></a>00044 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00045"></a><a class="code" href="classDenseMatrixBase.php">00045</a> <span class="keyword">class </span><a class="code" href="classDenseMatrixBase.php">DenseMatrixBase</a>
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047   
<a name="l00048"></a>00048 <span class="keyword">protected</span>:
<a name="l00053"></a><a class="code" href="classDenseMatrixBase.php#af1f484e27a090121d1d9fb4595cb2833">00053</a>   <a class="code" href="classDenseMatrixBase.php#af1f484e27a090121d1d9fb4595cb2833">DenseMatrixBase</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>=0,
<a name="l00054"></a>00054                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>=0) : <a class="code" href="classDenseMatrixBase.php#aaecdb483ac1742384dcf2e8f6f5fc3e5">_m</a>(<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>), <a class="code" href="classDenseMatrixBase.php#a0dcd22fecda2c896e16ff7cb957233a3">_n</a>(<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>) {};
<a name="l00055"></a>00055   
<a name="l00056"></a>00056 <span class="keyword">public</span>:
<a name="l00060"></a><a class="code" href="classDenseMatrixBase.php#a3dbf18bfd20475cd34b2ea634a34fa2e">00060</a>   <span class="keyword">virtual</span> <a class="code" href="classDenseMatrixBase.php#a3dbf18bfd20475cd34b2ea634a34fa2e">~DenseMatrixBase</a>() {};
<a name="l00061"></a>00061 
<a name="l00067"></a>00067   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrixBase.php#aac8564a5e9883b966a1c4f6b96226545">zero</a>() = 0;
<a name="l00068"></a>00068 
<a name="l00074"></a>00074   <span class="keyword">virtual</span> T <a class="code" href="classDenseMatrixBase.php#a6676d359596d4ac4eec2817122401431">el</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00075"></a>00075                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span> = 0;
<a name="l00076"></a>00076   
<a name="l00082"></a>00082   <span class="keyword">virtual</span> T &amp; <a class="code" href="classDenseMatrixBase.php#a6676d359596d4ac4eec2817122401431">el</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00083"></a>00083                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) = 0;
<a name="l00084"></a>00084 
<a name="l00088"></a>00088   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrixBase.php#a22c9b8385e1a7e2d4d4c2d58a94eabd6">left_multiply</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M2) = 0;
<a name="l00089"></a>00089 
<a name="l00093"></a>00093   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrixBase.php#afa4bf0c3247dcfdaeec683ee8d555ad5">right_multiply</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M3) = 0;
<a name="l00094"></a>00094   
<a name="l00098"></a><a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">00098</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classDenseMatrixBase.php#aaecdb483ac1742384dcf2e8f6f5fc3e5">_m</a>; }
<a name="l00099"></a>00099   
<a name="l00103"></a><a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">00103</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classDenseMatrixBase.php#a0dcd22fecda2c896e16ff7cb957233a3">_n</a>; }
<a name="l00104"></a>00104   
<a name="l00108"></a>00108   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrixBase.php#a446b0386d2cef34898b459a1fd1a3158">print</a>(std::ostream&amp; os) <span class="keyword">const</span>;
<a name="l00109"></a>00109 
<a name="l00115"></a><a class="code" href="classDenseMatrixBase.php#ae69bcf4703696e88fb14522c77f46567">00115</a>   <span class="keyword">friend</span> std::ostream&amp; operator &lt;&lt; (std::ostream&amp; os, const DenseMatrixBase&lt;T&gt;&amp; <a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>)
<a name="l00116"></a>00116   {
<a name="l00117"></a>00117     <a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>.print(os);
<a name="l00118"></a>00118     <span class="keywordflow">return</span> os;
<a name="l00119"></a>00119   }
<a name="l00120"></a>00120   
<a name="l00125"></a>00125   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrixBase.php#a2166a959b27ffbc0f9ea99259469d0cc">print_scientific</a>(std::ostream&amp; os) <span class="keyword">const</span>;
<a name="l00126"></a>00126   
<a name="l00132"></a>00132   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2, <span class="keyword">typename</span> T3&gt;
<a name="l00133"></a>00133   <span class="keyword">typename</span> <a class="code" href="structboostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00134"></a>00134     <a class="code" href="structScalarTraits.php">ScalarTraits&lt;T2&gt;::value</a>, <span class="keywordtype">void</span> &gt;::type
<a name="l00135"></a>00135   <a class="code" href="classDenseMatrixBase.php#a577930023e818fddcde1a65f5b0a3ed7">add</a> (<span class="keyword">const</span> T2 factor,
<a name="l00136"></a>00136        <span class="keyword">const</span> <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase&lt;T3&gt;</a>&amp; mat);
<a name="l00137"></a>00137    
<a name="l00138"></a>00138 <span class="keyword">protected</span>:
<a name="l00139"></a>00139   
<a name="l00146"></a>00146   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrixBase.php#a504aa639ac3d2619555b947bb8c9bb9b">multiply</a> (<a class="code" href="classDenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M1,
<a name="l00147"></a>00147                  <span class="keyword">const</span> <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M2,
<a name="l00148"></a>00148                  <span class="keyword">const</span> <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M3);
<a name="l00149"></a>00149 
<a name="l00156"></a>00156   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrixBase.php#ae7e9d57e9dd7ef85b1615f6c02039305">condense</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00157"></a>00157                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00158"></a>00158                 <span class="keyword">const</span> T val,
<a name="l00159"></a>00159                 <a class="code" href="classDenseVectorBase.php">DenseVectorBase&lt;T&gt;</a>&amp; rhs);
<a name="l00160"></a>00160 
<a name="l00164"></a><a class="code" href="classDenseMatrixBase.php#aaecdb483ac1742384dcf2e8f6f5fc3e5">00164</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDenseMatrixBase.php#aaecdb483ac1742384dcf2e8f6f5fc3e5">_m</a>;
<a name="l00165"></a>00165 
<a name="l00169"></a><a class="code" href="classDenseMatrixBase.php#a0dcd22fecda2c896e16ff7cb957233a3">00169</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDenseMatrixBase.php#a0dcd22fecda2c896e16ff7cb957233a3">_n</a>;
<a name="l00170"></a>00170 };
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00179"></a>00179 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2, <span class="keyword">typename</span> T3&gt;
<a name="l00180"></a>00180 <span class="keyword">inline</span>
<a name="l00181"></a>00181 <span class="keyword">typename</span> <a class="code" href="structboostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00182"></a>00182   <a class="code" href="structScalarTraits.php">ScalarTraits&lt;T2&gt;::value</a>, <span class="keywordtype">void</span> &gt;::type
<a name="l00183"></a><a class="code" href="classDenseMatrixBase.php#a577930023e818fddcde1a65f5b0a3ed7">00183</a> <a class="code" href="classDenseMatrixBase.php#a577930023e818fddcde1a65f5b0a3ed7">DenseMatrixBase&lt;T&gt;::add</a> (<span class="keyword">const</span> T2 factor,
<a name="l00184"></a>00184                          <span class="keyword">const</span> <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase&lt;T3&gt;</a>&amp; mat)
<a name="l00185"></a>00185 {
<a name="l00186"></a>00186   libmesh_assert (this-&gt;m() == mat.<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>());
<a name="l00187"></a>00187   libmesh_assert (this-&gt;n() == mat.<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>());
<a name="l00188"></a>00188 
<a name="l00189"></a>00189   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;n(); j++)
<a name="l00190"></a>00190     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;m(); i++)
<a name="l00191"></a>00191       this-&gt;el(i,j) += factor*mat.<a class="code" href="classDenseMatrixBase.php#a6676d359596d4ac4eec2817122401431">el</a>(i,j);
<a name="l00192"></a>00192 }
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 <span class="preprocessor">#endif // #ifndef __dense_matrix_base_h__</span>
<a name="l00196"></a>00196 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
