<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>dense_submatrix.h</h1>  </div>
</div>
<div class="contents">
<a href="dense__submatrix_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: dense_submatrix.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __dense_submatrix_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __dense_submatrix_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix__base_8h.php">dense_matrix_base.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="dense__subvector_8h.php">dense_subvector.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00043"></a>00043 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00044"></a>00044 <span class="comment">// DenseSubMatrix class definition</span>
<a name="l00045"></a>00045 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00046"></a><a class="code" href="classDenseSubMatrix.php">00046</a> <span class="keyword">class </span><a class="code" href="classDenseSubMatrix.php">DenseSubMatrix</a> : <span class="keyword">public</span> <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase</a>&lt;T&gt;
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048 <span class="keyword">public</span>:
<a name="l00049"></a>00049 
<a name="l00056"></a>00056   <a class="code" href="classDenseSubMatrix.php">DenseSubMatrix</a>(<a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; parent,
<a name="l00057"></a>00057                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ioff=0,
<a name="l00058"></a>00058                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> joff=0,
<a name="l00059"></a>00059                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>=0,
<a name="l00060"></a>00060                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>=0);
<a name="l00061"></a>00061 
<a name="l00065"></a>00065   <a class="code" href="classDenseSubMatrix.php">DenseSubMatrix</a> (<span class="keyword">const</span> <a class="code" href="classDenseSubMatrix.php">DenseSubMatrix&lt;T&gt;</a>&amp; other_matrix);
<a name="l00066"></a>00066   
<a name="l00070"></a>00070   <span class="keyword">virtual</span> ~<a class="code" href="classDenseSubMatrix.php">DenseSubMatrix</a>() {};
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   
<a name="l00076"></a>00076   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; parent () { <span class="keywordflow">return</span> _parent_matrix; }
<a name="l00077"></a>00077   
<a name="l00081"></a>00081   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrixBase.php#aac8564a5e9883b966a1c4f6b96226545">zero</a>();
<a name="l00082"></a>00082 
<a name="l00086"></a>00086   T operator() (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00087"></a>00087                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span>;
<a name="l00088"></a>00088 
<a name="l00092"></a>00092   T &amp; operator() (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00093"></a>00093                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j);
<a name="l00094"></a>00094   
<a name="l00098"></a>00098   <span class="keyword">virtual</span> T <a class="code" href="classDenseMatrixBase.php#a6676d359596d4ac4eec2817122401431">el</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00099"></a>00099                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (*<span class="keyword">this</span>)(i,j); }
<a name="l00100"></a>00100 
<a name="l00104"></a>00104   <span class="keyword">virtual</span> T &amp; <a class="code" href="classDenseMatrixBase.php#a6676d359596d4ac4eec2817122401431">el</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00105"></a>00105                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)     { <span class="keywordflow">return</span> (*<span class="keyword">this</span>)(i,j); } 
<a name="l00106"></a>00106 
<a name="l00110"></a>00110   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrixBase.php#a22c9b8385e1a7e2d4d4c2d58a94eabd6">left_multiply</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M2);
<a name="l00111"></a>00111 
<a name="l00115"></a>00115   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrixBase.php#afa4bf0c3247dcfdaeec683ee8d555ad5">right_multiply</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M3);
<a name="l00116"></a>00116   
<a name="l00120"></a>00120   <span class="keywordtype">void</span> reposition(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ioff,
<a name="l00121"></a>00121                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> joff,
<a name="l00122"></a>00122                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>,
<a name="l00123"></a>00123                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>);
<a name="l00124"></a>00124 
<a name="l00128"></a>00128   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i_off()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> _i_off; }
<a name="l00129"></a>00129 
<a name="l00133"></a>00133   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j_off()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> _j_off; }
<a name="l00134"></a>00134 
<a name="l00141"></a>00141   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrixBase.php#ae7e9d57e9dd7ef85b1615f6c02039305">condense</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00142"></a>00142                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00143"></a>00143                 <span class="keyword">const</span> T val,
<a name="l00144"></a>00144                 <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;T&gt;</a>&amp; rhs)
<a name="l00145"></a>00145   {
<a name="l00146"></a>00146     this-&gt;parent().<a class="code" href="classDenseMatrix.php#a044d522b54b850609e6cee8b359373b9">condense</a>(this-&gt;i_off()+i,
<a name="l00147"></a>00147                             this-&gt;j_off()+j,
<a name="l00148"></a>00148                             val, rhs.parent());
<a name="l00149"></a>00149   }
<a name="l00150"></a>00150   
<a name="l00151"></a>00151 <span class="keyword">private</span>:
<a name="l00152"></a>00152   
<a name="l00156"></a>00156   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; _parent_matrix;
<a name="l00157"></a>00157   
<a name="l00161"></a>00161   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _i_off;
<a name="l00162"></a>00162 
<a name="l00166"></a>00166   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _j_off;
<a name="l00167"></a>00167 };
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 <span class="comment">// -------------------------------------------------- </span>
<a name="l00171"></a>00171 <span class="comment">// Constructor</span>
<a name="l00172"></a>00172 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00173"></a>00173 <span class="keyword">inline</span>
<a name="l00174"></a>00174 <a class="code" href="classDenseSubMatrix.php">DenseSubMatrix&lt;T&gt;::DenseSubMatrix</a>(<a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; parent,
<a name="l00175"></a>00175                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ioff,
<a name="l00176"></a>00176                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> joff,
<a name="l00177"></a>00177                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m,
<a name="l00178"></a>00178                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) 
<a name="l00179"></a>00179   : <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase</a>&lt;T&gt;(m,n),
<a name="l00180"></a>00180     _parent_matrix(parent)
<a name="l00181"></a>00181 {
<a name="l00182"></a>00182   this-&gt;reposition (ioff, joff, m, n);
<a name="l00183"></a>00183 }
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 <span class="comment">// Copy Constructor</span>
<a name="l00187"></a>00187 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00188"></a>00188 <span class="keyword">inline</span>
<a name="l00189"></a>00189 <a class="code" href="classDenseSubMatrix.php">DenseSubMatrix&lt;T&gt;::DenseSubMatrix</a>(<span class="keyword">const</span> <a class="code" href="classDenseSubMatrix.php">DenseSubMatrix&lt;T&gt;</a>&amp; other_matrix)
<a name="l00190"></a>00190   : <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase</a>&lt;T&gt;(other_matrix._m, other_matrix._n),
<a name="l00191"></a>00191     _parent_matrix(other_matrix._parent_matrix)
<a name="l00192"></a>00192 {
<a name="l00193"></a>00193   _i_off = other_matrix._i_off; 
<a name="l00194"></a>00194   _j_off = other_matrix._j_off; 
<a name="l00195"></a>00195 }
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00199"></a>00199 <span class="keyword">inline</span>
<a name="l00200"></a>00200 <span class="keywordtype">void</span> <a class="code" href="classDenseSubMatrix.php">DenseSubMatrix&lt;T&gt;::reposition</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ioff,
<a name="l00201"></a>00201                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> joff,
<a name="l00202"></a>00202                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m,
<a name="l00203"></a>00203                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00204"></a>00204 {                                  
<a name="l00205"></a>00205   _i_off = ioff;
<a name="l00206"></a>00206   _j_off = joff;
<a name="l00207"></a>00207   this-&gt;_m = m;
<a name="l00208"></a>00208   this-&gt;_n = n;
<a name="l00209"></a>00209 
<a name="l00210"></a>00210   <span class="comment">// Make sure we still fit in the parent matrix.</span>
<a name="l00211"></a>00211   libmesh_assert ((this-&gt;i_off() + this-&gt;m()) &lt;= _parent_matrix.m());
<a name="l00212"></a>00212   libmesh_assert ((this-&gt;j_off() + this-&gt;n()) &lt;= _parent_matrix.n());
<a name="l00213"></a>00213 }
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00218"></a>00218 <span class="keyword">inline</span>
<a name="l00219"></a>00219 <span class="keywordtype">void</span> <a class="code" href="classDenseMatrixBase.php#aac8564a5e9883b966a1c4f6b96226545">DenseSubMatrix&lt;T&gt;::zero</a>()
<a name="l00220"></a>00220 {
<a name="l00221"></a>00221   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;m(); i++)
<a name="l00222"></a>00222     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;n(); j++)
<a name="l00223"></a>00223       _parent_matrix(i + this-&gt;i_off(),
<a name="l00224"></a>00224                      j + this-&gt;j_off()) = 0.;
<a name="l00225"></a>00225 }
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00230"></a>00230 <span class="keyword">inline</span>
<a name="l00231"></a>00231 T <a class="code" href="classDenseSubMatrix.php">DenseSubMatrix&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00232"></a>00232                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const</span>
<a name="l00233"></a>00233 <span class="keyword"></span>{
<a name="l00234"></a>00234   libmesh_assert (i &lt; this-&gt;m());
<a name="l00235"></a>00235   libmesh_assert (j &lt; this-&gt;n());
<a name="l00236"></a>00236   libmesh_assert (i + this-&gt;i_off() &lt; _parent_matrix.m());
<a name="l00237"></a>00237   libmesh_assert (j + this-&gt;j_off() &lt; _parent_matrix.n());
<a name="l00238"></a>00238   
<a name="l00239"></a>00239   <span class="keywordflow">return</span> _parent_matrix (i + this-&gt;i_off(),
<a name="l00240"></a>00240                          j + this-&gt;j_off());
<a name="l00241"></a>00241 }
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 
<a name="l00244"></a>00244 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00245"></a>00245 <span class="keyword">inline</span>
<a name="l00246"></a>00246 T &amp; <a class="code" href="classDenseSubMatrix.php">DenseSubMatrix&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00247"></a>00247                                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)
<a name="l00248"></a>00248 {
<a name="l00249"></a>00249   libmesh_assert (i &lt; this-&gt;m());
<a name="l00250"></a>00250   libmesh_assert (j &lt; this-&gt;n());
<a name="l00251"></a>00251   libmesh_assert (i + this-&gt;i_off() &lt; _parent_matrix.m());
<a name="l00252"></a>00252   libmesh_assert (j + this-&gt;j_off() &lt; _parent_matrix.n());
<a name="l00253"></a>00253   
<a name="l00254"></a>00254   <span class="keywordflow">return</span> _parent_matrix (i + this-&gt;i_off(),
<a name="l00255"></a>00255                          j + this-&gt;j_off());
<a name="l00256"></a>00256 }
<a name="l00257"></a>00257 
<a name="l00258"></a>00258 
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 <span class="preprocessor">#endif // #ifndef __dense_matrix_h__</span>
<a name="l00261"></a>00261 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
