<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>dense_vector.h</h1>  </div>
</div>
<div class="contents">
<a href="dense__vector_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: dense_vector.h 3481 2009-10-02 16:20:23Z knezed01 $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __dense_vector_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __dense_vector_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;compare_types.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector__base_8h.php">dense_vector_base.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Forward Declarations</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00046"></a>00046 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00047"></a>00047 <span class="comment">// DenseVector class definition</span>
<a name="l00048"></a>00048 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00049"></a><a class="code" href="classDenseVector.php">00049</a> <span class="keyword">class </span><a class="code" href="classDenseVector.php">DenseVector</a> : <span class="keyword">public</span> <a class="code" href="classDenseVectorBase.php">DenseVectorBase</a>&lt;T&gt;
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 <span class="keyword">public</span>:
<a name="l00052"></a>00052 
<a name="l00056"></a>00056   <span class="keyword">explicit</span>
<a name="l00057"></a>00057   <a class="code" href="classDenseVector.php#aafdc4ed8412f10d2ab445426b72338e7">DenseVector</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0);
<a name="l00058"></a>00058 
<a name="l00062"></a>00062   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00063"></a>00063   <a class="code" href="classDenseVector.php#aafdc4ed8412f10d2ab445426b72338e7">DenseVector</a> (<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a>&amp; other_vector);
<a name="l00064"></a>00064 
<a name="l00068"></a>00068   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00069"></a>00069   <a class="code" href="classDenseVector.php#aafdc4ed8412f10d2ab445426b72338e7">DenseVector</a> (<span class="keyword">const</span> std::vector&lt;T2&gt;&amp; other_vector);
<a name="l00070"></a>00070   
<a name="l00074"></a><a class="code" href="classDenseVector.php#ae50f719af1ec99a330ca4ddf6ba88d98">00074</a>   <a class="code" href="classDenseVector.php#ae50f719af1ec99a330ca4ddf6ba88d98">~DenseVector</a>() {}
<a name="l00075"></a>00075 
<a name="l00079"></a><a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">00079</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classDenseVector.php#a0dfe6a5628191d41311c37a122007b95">_val</a>.size(); }
<a name="l00080"></a>00080 
<a name="l00084"></a>00084   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDenseVector.php#a4e0123eb5cc4054e8069155f0faf4425">zero</a>();
<a name="l00085"></a>00085   
<a name="l00089"></a>00089   T <a class="code" href="classDenseVector.php#a7b2507f48a19d7b1091f6a6974e7788c">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00090"></a>00090 
<a name="l00094"></a>00094   T &amp; <a class="code" href="classDenseVector.php#a7b2507f48a19d7b1091f6a6974e7788c">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00095"></a>00095 
<a name="l00099"></a><a class="code" href="classDenseVector.php#ac5ee368bf81d33d030a3cffe1c3f9aa3">00099</a>   <span class="keyword">virtual</span> T <a class="code" href="classDenseVector.php#ac5ee368bf81d33d030a3cffe1c3f9aa3">el</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (*<span class="keyword">this</span>)(i); }
<a name="l00100"></a>00100 
<a name="l00104"></a><a class="code" href="classDenseVector.php#af1248a7eedaaf22ff4b71fcd21750500">00104</a>   <span class="keyword">virtual</span> T &amp; <a class="code" href="classDenseVector.php#af1248a7eedaaf22ff4b71fcd21750500">el</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)     { <span class="keywordflow">return</span> (*<span class="keyword">this</span>)(i); }
<a name="l00105"></a>00105   
<a name="l00109"></a>00109   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00110"></a>00110   <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; <a class="code" href="classDenseVector.php#ace606898d6230d9b8c2cae6db9acf93d">operator = </a>(<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a>&amp; other_vector);
<a name="l00111"></a>00111   
<a name="l00115"></a>00115   <span class="keywordtype">void</span> <a class="code" href="classDenseVector.php#a4abb869315266cf9938c66a64189c65f">swap</a>(<a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; other_vector);
<a name="l00116"></a>00116   
<a name="l00120"></a>00120   <span class="keywordtype">void</span> <a class="code" href="classDenseVector.php#a3a9af103dc052f1dfdef1626692cd8cd">resize</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l00121"></a>00121 
<a name="l00125"></a>00125   <span class="keywordtype">void</span> <a class="code" href="classDenseVector.php#a9adb1286d39afec924a7503955bf6e62">scale</a> (<span class="keyword">const</span> T factor);
<a name="l00126"></a>00126   
<a name="l00130"></a>00130   <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; <a class="code" href="classDenseVector.php#a83a36dfb3ca8dc9c48a1006c089753f8">operator*= </a>(<span class="keyword">const</span> T factor);
<a name="l00131"></a>00131   
<a name="l00137"></a>00137   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2, <span class="keyword">typename</span> T3&gt;
<a name="l00138"></a>00138   <span class="keyword">typename</span> <a class="code" href="structboostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00139"></a>00139     <a class="code" href="structScalarTraits.php">ScalarTraits&lt;T2&gt;::value</a>, <span class="keywordtype">void</span> &gt;::type
<a name="l00140"></a>00140   <a class="code" href="classDenseVector.php#a8eedf23f82b65005d0b5066fb3e0d3f5">add</a> (<span class="keyword">const</span> T2 factor,
<a name="l00141"></a>00141        <span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T3&gt;</a>&amp; vec);
<a name="l00142"></a>00142 
<a name="l00146"></a>00146   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00147"></a>00147   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classDenseVector.php#a2d33bf4355e4115838e2a63c0ab231bc">dot</a> (<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a> &amp;vec) <span class="keyword">const</span>;
<a name="l00148"></a>00148 
<a name="l00152"></a>00152   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00153"></a>00153   <span class="keywordtype">bool</span> <a class="code" href="classDenseVector.php#a227d48cba47bc1eac028373f4afd00d5">operator== </a>(<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a> &amp;vec) <span class="keyword">const</span>;
<a name="l00154"></a>00154   
<a name="l00158"></a>00158   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00159"></a>00159   <span class="keywordtype">bool</span> <a class="code" href="classDenseVector.php#a5f0c18176b372b802e119a9741e4097a">operator!= </a>(<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a> &amp;vec) <span class="keyword">const</span>;
<a name="l00160"></a>00160   
<a name="l00164"></a>00164   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00165"></a>00165   <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; <a class="code" href="classDenseVector.php#a73631e73fa6e7ad8822b852edc9af86b">operator+= </a>(<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a> &amp;vec);
<a name="l00166"></a>00166   
<a name="l00170"></a>00170   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00171"></a>00171   <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; <a class="code" href="classDenseVector.php#a78eb382d101b568d1f028157e8d472fa">operator-= </a>(<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a> &amp;vec);
<a name="l00172"></a>00172   
<a name="l00178"></a>00178   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseVector.php#a2849676e141353a7becfc3f89dac5844">min</a> () <span class="keyword">const</span>;
<a name="l00179"></a>00179 
<a name="l00185"></a>00185   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseVector.php#abf12650e1e67b2410afec966ab5aceb9">max</a> () <span class="keyword">const</span>;
<a name="l00186"></a>00186 
<a name="l00191"></a>00191   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseVector.php#ab4a5433fb65515db5e55470e260b32c2">l1_norm</a> () <span class="keyword">const</span>;
<a name="l00192"></a>00192 
<a name="l00198"></a>00198   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseVector.php#aa182572da067c6737eecbe8e36c73c07">l2_norm</a> () <span class="keyword">const</span>;
<a name="l00199"></a>00199 
<a name="l00205"></a>00205   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseVector.php#aabcc1f68ed29b73d118239cd1a40c3eb">linfty_norm</a> () <span class="keyword">const</span>;
<a name="l00206"></a>00206 
<a name="l00211"></a>00211   <span class="keywordtype">void</span> <a class="code" href="classDenseVector.php#af147831d63db685c0b7152f54dd4ebce">get_principal_subvector</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sub_n, <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00212"></a>00212 
<a name="l00218"></a><a class="code" href="classDenseVector.php#a4224acb56f9068ad928c015a0ad14e7d">00218</a>   std::vector&lt;T&gt;&amp; <a class="code" href="classDenseVector.php#a4224acb56f9068ad928c015a0ad14e7d">get_values</a>() { <span class="keywordflow">return</span> <a class="code" href="classDenseVector.php#a0dfe6a5628191d41311c37a122007b95">_val</a>; }
<a name="l00219"></a>00219 
<a name="l00225"></a><a class="code" href="classDenseVector.php#aa8ec12e14a485e5c5194f1156911de36">00225</a>   <span class="keyword">const</span> std::vector&lt;T&gt;&amp; <a class="code" href="classDenseVector.php#aa8ec12e14a485e5c5194f1156911de36">get_values</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classDenseVector.php#a0dfe6a5628191d41311c37a122007b95">_val</a>; }
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 <span class="keyword">private</span>:
<a name="l00228"></a>00228 
<a name="l00232"></a><a class="code" href="classDenseVector.php#a0dfe6a5628191d41311c37a122007b95">00232</a>   std::vector&lt;T&gt; <a class="code" href="classDenseVector.php#a0dfe6a5628191d41311c37a122007b95">_val</a>;
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 };
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 
<a name="l00238"></a>00238 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00239"></a>00239 <span class="comment">// DenseVector member functions</span>
<a name="l00240"></a>00240 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00241"></a>00241 <span class="keyword">inline</span>
<a name="l00242"></a><a class="code" href="classDenseVector.php#aafdc4ed8412f10d2ab445426b72338e7">00242</a> <a class="code" href="classDenseVector.php#aafdc4ed8412f10d2ab445426b72338e7">DenseVector&lt;T&gt;::DenseVector</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) :
<a name="l00243"></a>00243   _val (n, 0.)
<a name="l00244"></a>00244 {
<a name="l00245"></a>00245 }
<a name="l00246"></a>00246 
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00250"></a>00250 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00251"></a>00251 <span class="keyword">inline</span>
<a name="l00252"></a><a class="code" href="classDenseVector.php#ae2d6882875e383744ce71031121f8e90">00252</a> <a class="code" href="classDenseVector.php#aafdc4ed8412f10d2ab445426b72338e7">DenseVector&lt;T&gt;::DenseVector</a> (<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a>&amp; other_vector) :
<a name="l00253"></a>00253   <a class="code" href="classDenseVectorBase.php">DenseVectorBase</a>&lt;T&gt;()
<a name="l00254"></a>00254 {
<a name="l00255"></a>00255   <span class="keyword">const</span> std::vector&lt;T2&gt; &amp;other_vals = other_vector.<a class="code" href="classDenseVector.php#a4224acb56f9068ad928c015a0ad14e7d">get_values</a>();
<a name="l00256"></a>00256 
<a name="l00257"></a>00257   <a class="code" href="classDenseVector.php#a0dfe6a5628191d41311c37a122007b95">_val</a>.clear();
<a name="l00258"></a>00258   <a class="code" href="classDenseVector.php#a0dfe6a5628191d41311c37a122007b95">_val</a>.reserve(other_vals.size());
<a name="l00259"></a>00259 
<a name="l00260"></a>00260   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;other_vals.size(); i++)
<a name="l00261"></a>00261     <a class="code" href="classDenseVector.php#a0dfe6a5628191d41311c37a122007b95">_val</a>.push_back(other_vals[i]);
<a name="l00262"></a>00262 }
<a name="l00263"></a>00263 
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 
<a name="l00266"></a>00266 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00267"></a>00267 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00268"></a>00268 <span class="keyword">inline</span>
<a name="l00269"></a><a class="code" href="classDenseVector.php#af7a15b47121fcedcbc2fc01503b5e210">00269</a> <a class="code" href="classDenseVector.php#aafdc4ed8412f10d2ab445426b72338e7">DenseVector&lt;T&gt;::DenseVector</a> (<span class="keyword">const</span> std::vector&lt;T2&gt;&amp; other_vector) :
<a name="l00270"></a>00270   _val(other_vector)
<a name="l00271"></a>00271 {  
<a name="l00272"></a>00272 }
<a name="l00273"></a>00273 
<a name="l00274"></a>00274 
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 
<a name="l00278"></a>00278 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00279"></a>00279 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00280"></a>00280 <span class="keyword">inline</span>
<a name="l00281"></a><a class="code" href="classDenseVector.php#ace606898d6230d9b8c2cae6db9acf93d">00281</a> <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; <a class="code" href="classDenseVector.php#ace606898d6230d9b8c2cae6db9acf93d">DenseVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a>&amp; other_vector)
<a name="l00282"></a>00282 {
<a name="l00283"></a>00283   <span class="comment">//  _val = other_vector._val;</span>
<a name="l00284"></a>00284 
<a name="l00285"></a>00285   <span class="keyword">const</span> std::vector&lt;T2&gt; &amp;other_vals = other_vector.<a class="code" href="classDenseVector.php#a4224acb56f9068ad928c015a0ad14e7d">get_values</a>();
<a name="l00286"></a>00286 
<a name="l00287"></a>00287   _val.clear();
<a name="l00288"></a>00288   _val.reserve(other_vals.size());
<a name="l00289"></a>00289 
<a name="l00290"></a>00290   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;other_vals.size(); i++)
<a name="l00291"></a>00291     _val.push_back(other_vals[i]);
<a name="l00292"></a>00292 
<a name="l00293"></a>00293   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00294"></a>00294 }
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 
<a name="l00297"></a>00297 
<a name="l00298"></a>00298 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00299"></a>00299 <span class="keyword">inline</span>
<a name="l00300"></a><a class="code" href="classDenseVector.php#a4abb869315266cf9938c66a64189c65f">00300</a> <span class="keywordtype">void</span> <a class="code" href="classDenseVector.php#a4abb869315266cf9938c66a64189c65f">DenseVector&lt;T&gt;::swap</a>(<a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; other_vector)
<a name="l00301"></a>00301 {
<a name="l00302"></a>00302   _val.swap(other_vector.<a class="code" href="classDenseVector.php#a0dfe6a5628191d41311c37a122007b95">_val</a>);
<a name="l00303"></a>00303 }
<a name="l00304"></a>00304 
<a name="l00305"></a>00305 
<a name="l00306"></a>00306 
<a name="l00307"></a>00307 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00308"></a>00308 <span class="keyword">inline</span>
<a name="l00309"></a><a class="code" href="classDenseVector.php#a3a9af103dc052f1dfdef1626692cd8cd">00309</a> <span class="keywordtype">void</span> <a class="code" href="classDenseVector.php#a3a9af103dc052f1dfdef1626692cd8cd">DenseVector&lt;T&gt;::resize</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00310"></a>00310 {
<a name="l00311"></a>00311   _val.resize(n);
<a name="l00312"></a>00312 
<a name="l00313"></a>00313   <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a>();
<a name="l00314"></a>00314 }
<a name="l00315"></a>00315 
<a name="l00316"></a>00316 
<a name="l00317"></a>00317 
<a name="l00318"></a>00318 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00319"></a>00319 <span class="keyword">inline</span>
<a name="l00320"></a><a class="code" href="classDenseVector.php#a4e0123eb5cc4054e8069155f0faf4425">00320</a> <span class="keywordtype">void</span> <a class="code" href="classDenseVector.php#a4e0123eb5cc4054e8069155f0faf4425">DenseVector&lt;T&gt;::zero</a>()
<a name="l00321"></a>00321 {
<a name="l00322"></a>00322   std::fill (_val.begin(),
<a name="l00323"></a>00323              _val.end(),
<a name="l00324"></a>00324              0.);
<a name="l00325"></a>00325 }
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00330"></a>00330 <span class="keyword">inline</span>
<a name="l00331"></a><a class="code" href="classDenseVector.php#a7b2507f48a19d7b1091f6a6974e7788c">00331</a> T <a class="code" href="classDenseVector.php#a7b2507f48a19d7b1091f6a6974e7788c">DenseVector&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00332"></a>00332 <span class="keyword"></span>{
<a name="l00333"></a>00333   libmesh_assert (i &lt; _val.size());
<a name="l00334"></a>00334   
<a name="l00335"></a>00335   <span class="keywordflow">return</span> _val[i]; 
<a name="l00336"></a>00336 }
<a name="l00337"></a>00337 
<a name="l00338"></a>00338 
<a name="l00339"></a>00339 
<a name="l00340"></a>00340 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00341"></a>00341 <span class="keyword">inline</span>
<a name="l00342"></a><a class="code" href="classDenseVector.php#a62d384e59445ec2768a792fa68c3e60d">00342</a> T &amp; <a class="code" href="classDenseVector.php#a7b2507f48a19d7b1091f6a6974e7788c">DenseVector&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00343"></a>00343 {
<a name="l00344"></a>00344   libmesh_assert (i &lt; _val.size());
<a name="l00345"></a>00345   
<a name="l00346"></a>00346   <span class="keywordflow">return</span> _val[i]; 
<a name="l00347"></a>00347 }
<a name="l00348"></a>00348       
<a name="l00349"></a>00349 
<a name="l00350"></a>00350 
<a name="l00351"></a>00351 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00352"></a>00352 <span class="keyword">inline</span>
<a name="l00353"></a><a class="code" href="classDenseVector.php#a9adb1286d39afec924a7503955bf6e62">00353</a> <span class="keywordtype">void</span> <a class="code" href="classDenseVector.php#a9adb1286d39afec924a7503955bf6e62">DenseVector&lt;T&gt;::scale</a> (<span class="keyword">const</span> T factor)
<a name="l00354"></a>00354 {
<a name="l00355"></a>00355   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;_val.size(); i++)
<a name="l00356"></a>00356     _val[i] *= factor;
<a name="l00357"></a>00357 }
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 
<a name="l00361"></a>00361 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00362"></a>00362 <span class="keyword">inline</span>
<a name="l00363"></a><a class="code" href="classDenseVector.php#a83a36dfb3ca8dc9c48a1006c089753f8">00363</a> <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; <a class="code" href="classDenseVector.php#a83a36dfb3ca8dc9c48a1006c089753f8">DenseVector&lt;T&gt;::operator*= </a>(<span class="keyword">const</span> T factor)
<a name="l00364"></a>00364 {
<a name="l00365"></a>00365   this-&gt;<a class="code" href="namespaceMeshTools_1_1Modification.php#ae71416e394dfbc45fe3d8b37b9b0c7ba">scale</a>(factor);
<a name="l00366"></a>00366   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00367"></a>00367 }
<a name="l00368"></a>00368 
<a name="l00369"></a>00369 
<a name="l00370"></a>00370 
<a name="l00371"></a>00371 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00372"></a>00372 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2, <span class="keyword">typename</span> T3&gt;
<a name="l00373"></a>00373 <span class="keyword">inline</span>
<a name="l00374"></a>00374 <span class="keyword">typename</span> <a class="code" href="structboostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00375"></a>00375   <a class="code" href="structScalarTraits.php">ScalarTraits&lt;T2&gt;::value</a>, <span class="keywordtype">void</span> &gt;::type
<a name="l00376"></a><a class="code" href="classDenseVector.php#a8eedf23f82b65005d0b5066fb3e0d3f5">00376</a> <a class="code" href="classDenseVector.php#a8eedf23f82b65005d0b5066fb3e0d3f5">DenseVector&lt;T&gt;::add</a> (<span class="keyword">const</span> T2 factor,
<a name="l00377"></a>00377                      <span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T3&gt;</a>&amp; vec)
<a name="l00378"></a>00378 {
<a name="l00379"></a>00379   libmesh_assert (this-&gt;size() == vec.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>());
<a name="l00380"></a>00380 
<a name="l00381"></a>00381   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;size(); i++)
<a name="l00382"></a>00382     (*<span class="keyword">this</span>)(i) += factor*vec(i);
<a name="l00383"></a>00383 }
<a name="l00384"></a>00384 
<a name="l00385"></a>00385 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00386"></a>00386 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00387"></a>00387 <span class="keyword">inline</span>
<a name="l00388"></a><a class="code" href="classDenseVector.php#a2d33bf4355e4115838e2a63c0ab231bc">00388</a> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classDenseVector.php#a2d33bf4355e4115838e2a63c0ab231bc">DenseVector&lt;T&gt;::dot</a> (<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a>&amp; vec)<span class="keyword"> const</span>
<a name="l00389"></a>00389 <span class="keyword"></span>{
<a name="l00390"></a>00390   libmesh_assert(this-&gt;size() == vec.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>());
<a name="l00391"></a>00391 
<a name="l00392"></a>00392   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> val = 0.;
<a name="l00393"></a>00393 
<a name="l00394"></a>00394   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;size(); i++)
<a name="l00395"></a>00395     val += (*<span class="keyword">this</span>)(i)*vec(i);
<a name="l00396"></a>00396 
<a name="l00397"></a>00397   <span class="keywordflow">return</span> val;
<a name="l00398"></a>00398 }
<a name="l00399"></a>00399 
<a name="l00400"></a>00400 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00401"></a>00401 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00402"></a>00402 <span class="keyword">inline</span>
<a name="l00403"></a><a class="code" href="classDenseVector.php#a227d48cba47bc1eac028373f4afd00d5">00403</a> <span class="keywordtype">bool</span> <a class="code" href="classDenseVector.php#a227d48cba47bc1eac028373f4afd00d5">DenseVector&lt;T&gt;::operator== </a>(<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a>&amp; vec)<span class="keyword"> const</span>
<a name="l00404"></a>00404 <span class="keyword"></span>{
<a name="l00405"></a>00405   libmesh_assert (this-&gt;size() == vec.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>());
<a name="l00406"></a>00406 
<a name="l00407"></a>00407   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;size(); i++)
<a name="l00408"></a>00408     <span class="keywordflow">if</span> ((*<span class="keyword">this</span>)(i) != vec(i))
<a name="l00409"></a>00409       <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00410"></a>00410 
<a name="l00411"></a>00411   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00412"></a>00412 }
<a name="l00413"></a>00413 
<a name="l00414"></a>00414 
<a name="l00415"></a>00415 
<a name="l00416"></a>00416 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00417"></a>00417 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00418"></a>00418 <span class="keyword">inline</span>
<a name="l00419"></a><a class="code" href="classDenseVector.php#a5f0c18176b372b802e119a9741e4097a">00419</a> <span class="keywordtype">bool</span> <a class="code" href="classDenseVector.php#a5f0c18176b372b802e119a9741e4097a">DenseVector&lt;T&gt;::operator!= </a>(<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a>&amp; vec)<span class="keyword"> const</span>
<a name="l00420"></a>00420 <span class="keyword"></span>{
<a name="l00421"></a>00421   libmesh_assert (this-&gt;size() == vec.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>());
<a name="l00422"></a>00422 
<a name="l00423"></a>00423   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;size(); i++)
<a name="l00424"></a>00424     <span class="keywordflow">if</span> ((*<span class="keyword">this</span>)(i) != vec(i))
<a name="l00425"></a>00425       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00426"></a>00426 
<a name="l00427"></a>00427   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00428"></a>00428 }
<a name="l00429"></a>00429 
<a name="l00430"></a>00430 
<a name="l00431"></a>00431 
<a name="l00432"></a>00432 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00433"></a>00433 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00434"></a>00434 <span class="keyword">inline</span>
<a name="l00435"></a><a class="code" href="classDenseVector.php#a73631e73fa6e7ad8822b852edc9af86b">00435</a> <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; <a class="code" href="classDenseVector.php#a73631e73fa6e7ad8822b852edc9af86b">DenseVector&lt;T&gt;::operator+= </a>(<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a>&amp; vec)
<a name="l00436"></a>00436 {
<a name="l00437"></a>00437   libmesh_assert (this-&gt;size() == vec.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>());
<a name="l00438"></a>00438 
<a name="l00439"></a>00439   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;size(); i++)
<a name="l00440"></a>00440     (*<span class="keyword">this</span>)(i) += vec(i);
<a name="l00441"></a>00441 
<a name="l00442"></a>00442   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00443"></a>00443 }
<a name="l00444"></a>00444 
<a name="l00445"></a>00445 
<a name="l00446"></a>00446 
<a name="l00447"></a>00447 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00448"></a>00448 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00449"></a>00449 <span class="keyword">inline</span>
<a name="l00450"></a><a class="code" href="classDenseVector.php#a78eb382d101b568d1f028157e8d472fa">00450</a> <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; <a class="code" href="classDenseVector.php#a78eb382d101b568d1f028157e8d472fa">DenseVector&lt;T&gt;::operator-= </a>(<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a>&amp; vec)
<a name="l00451"></a>00451 {
<a name="l00452"></a>00452   libmesh_assert (this-&gt;size() == vec.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>());
<a name="l00453"></a>00453 
<a name="l00454"></a>00454   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;size(); i++)
<a name="l00455"></a>00455     (*<span class="keyword">this</span>)(i) -= vec(i);
<a name="l00456"></a>00456 
<a name="l00457"></a>00457   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00458"></a>00458 }
<a name="l00459"></a>00459 
<a name="l00460"></a>00460 
<a name="l00461"></a>00461 
<a name="l00462"></a>00462 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00463"></a>00463 <span class="keyword">inline</span>
<a name="l00464"></a><a class="code" href="classDenseVector.php#a2849676e141353a7becfc3f89dac5844">00464</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseVector.php#a2849676e141353a7becfc3f89dac5844">DenseVector&lt;T&gt;::min</a> ()<span class="keyword"> const</span>
<a name="l00465"></a>00465 <span class="keyword"></span>{
<a name="l00466"></a>00466   libmesh_assert (this-&gt;size());
<a name="l00467"></a>00467   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> my_min = <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>((*<span class="keyword">this</span>)(0));
<a name="l00468"></a>00468 
<a name="l00469"></a>00469   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i!=this-&gt;size(); i++)
<a name="l00470"></a>00470     {
<a name="l00471"></a>00471       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> current = <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>((*<span class="keyword">this</span>)(i));
<a name="l00472"></a>00472       my_min = (my_min &lt; current? my_min : current);
<a name="l00473"></a>00473     }
<a name="l00474"></a>00474   <span class="keywordflow">return</span> my_min;
<a name="l00475"></a>00475 }
<a name="l00476"></a>00476 
<a name="l00477"></a>00477 
<a name="l00478"></a>00478 
<a name="l00479"></a>00479 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00480"></a>00480 <span class="keyword">inline</span>
<a name="l00481"></a><a class="code" href="classDenseVector.php#abf12650e1e67b2410afec966ab5aceb9">00481</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseVector.php#abf12650e1e67b2410afec966ab5aceb9">DenseVector&lt;T&gt;::max</a> ()<span class="keyword"> const</span>
<a name="l00482"></a>00482 <span class="keyword"></span>{
<a name="l00483"></a>00483   libmesh_assert (this-&gt;size());
<a name="l00484"></a>00484   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> my_max = <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>((*<span class="keyword">this</span>)(0));
<a name="l00485"></a>00485 
<a name="l00486"></a>00486   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i!=this-&gt;size(); i++)
<a name="l00487"></a>00487     {
<a name="l00488"></a>00488       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> current = <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>((*<span class="keyword">this</span>)(i));
<a name="l00489"></a>00489       my_max = (my_max &gt; current? my_max : current);
<a name="l00490"></a>00490     }
<a name="l00491"></a>00491   <span class="keywordflow">return</span> my_max;
<a name="l00492"></a>00492 }
<a name="l00493"></a>00493 
<a name="l00494"></a>00494 
<a name="l00495"></a>00495 
<a name="l00496"></a>00496 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00497"></a>00497 <span class="keyword">inline</span>
<a name="l00498"></a><a class="code" href="classDenseVector.php#ab4a5433fb65515db5e55470e260b32c2">00498</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseVector.php#ab4a5433fb65515db5e55470e260b32c2">DenseVector&lt;T&gt;::l1_norm</a> ()<span class="keyword"> const</span>
<a name="l00499"></a>00499 <span class="keyword"></span>{
<a name="l00500"></a>00500   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> my_norm = 0.;
<a name="l00501"></a>00501   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=this-&gt;size(); i++)
<a name="l00502"></a>00502     {
<a name="l00503"></a>00503       my_norm += std::abs((*<span class="keyword">this</span>)(i));
<a name="l00504"></a>00504     }
<a name="l00505"></a>00505   <span class="keywordflow">return</span> my_norm;
<a name="l00506"></a>00506 }
<a name="l00507"></a>00507 
<a name="l00508"></a>00508 
<a name="l00509"></a>00509 
<a name="l00510"></a>00510 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00511"></a>00511 <span class="keyword">inline</span>
<a name="l00512"></a><a class="code" href="classDenseVector.php#aa182572da067c6737eecbe8e36c73c07">00512</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseVector.php#aa182572da067c6737eecbe8e36c73c07">DenseVector&lt;T&gt;::l2_norm</a> ()<span class="keyword"> const</span>
<a name="l00513"></a>00513 <span class="keyword"></span>{
<a name="l00514"></a>00514   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> my_norm = 0.;
<a name="l00515"></a>00515   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=this-&gt;size(); i++)
<a name="l00516"></a>00516     {
<a name="l00517"></a>00517       my_norm += <a class="code" href="libmesh__common_8h.php#af9cdd07341b53cc644199f6aec5e1420">libmesh_norm</a>((*<span class="keyword">this</span>)(i));
<a name="l00518"></a>00518     }
<a name="l00519"></a>00519   <span class="keywordflow">return</span> sqrt(my_norm);
<a name="l00520"></a>00520 }
<a name="l00521"></a>00521 
<a name="l00522"></a>00522 
<a name="l00523"></a>00523 
<a name="l00524"></a>00524 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00525"></a>00525 <span class="keyword">inline</span>
<a name="l00526"></a><a class="code" href="classDenseVector.php#aabcc1f68ed29b73d118239cd1a40c3eb">00526</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseVector.php#aabcc1f68ed29b73d118239cd1a40c3eb">DenseVector&lt;T&gt;::linfty_norm</a> ()<span class="keyword"> const</span>
<a name="l00527"></a>00527 <span class="keyword"></span>{
<a name="l00528"></a>00528   <span class="keywordflow">if</span> (!this-&gt;size())
<a name="l00529"></a>00529     <span class="keywordflow">return</span> 0.;
<a name="l00530"></a>00530   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> my_norm = <a class="code" href="libmesh__common_8h.php#af9cdd07341b53cc644199f6aec5e1420">libmesh_norm</a>((*<span class="keyword">this</span>)(0));
<a name="l00531"></a>00531 
<a name="l00532"></a>00532   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i!=this-&gt;size(); i++)
<a name="l00533"></a>00533     {
<a name="l00534"></a>00534       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> current = <a class="code" href="libmesh__common_8h.php#af9cdd07341b53cc644199f6aec5e1420">libmesh_norm</a>((*<span class="keyword">this</span>)(i));
<a name="l00535"></a>00535       my_norm = (my_norm &gt; current? my_norm : current);
<a name="l00536"></a>00536     }
<a name="l00537"></a>00537   <span class="keywordflow">return</span> sqrt(my_norm);
<a name="l00538"></a>00538 }
<a name="l00539"></a>00539 
<a name="l00540"></a>00540 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00541"></a>00541 <span class="keyword">inline</span>
<a name="l00542"></a><a class="code" href="classDenseVector.php#af147831d63db685c0b7152f54dd4ebce">00542</a> <span class="keywordtype">void</span> <a class="code" href="classDenseVector.php#af147831d63db685c0b7152f54dd4ebce">DenseVector&lt;T&gt;::get_principal_subvector</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sub_n,
<a name="l00543"></a>00543                                               <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; dest)<span class="keyword"> const</span>
<a name="l00544"></a>00544 <span class="keyword"></span>{
<a name="l00545"></a>00545   libmesh_assert( sub_n &lt;= this-&gt;size() );
<a name="l00546"></a>00546 
<a name="l00547"></a>00547   dest.<a class="code" href="classDenseVector.php#a3a9af103dc052f1dfdef1626692cd8cd">resize</a>(sub_n);
<a name="l00548"></a>00548   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;sub_n; i++)
<a name="l00549"></a>00549     dest(i) = (*this)(i);
<a name="l00550"></a>00550 }
<a name="l00551"></a>00551 
<a name="l00552"></a>00552 <span class="preprocessor">#endif // #ifndef __dense_vector_h__</span>
<a name="l00553"></a>00553 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
