<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>dense_vector_base.h</h1>  </div>
</div>
<div class="contents">
<a href="dense__vector__base_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: dense_vector_base.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __dense_vector_base_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __dense_vector_base_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local Includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00040"></a>00040 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00041"></a>00041 <span class="comment">// DenseVectorBase class definition</span>
<a name="l00042"></a>00042 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00043"></a><a class="code" href="classDenseVectorBase.php">00043</a> <span class="keyword">class </span><a class="code" href="classDenseVectorBase.php">DenseVectorBase</a>
<a name="l00044"></a>00044 {
<a name="l00045"></a>00045 <span class="keyword">public</span>:
<a name="l00046"></a>00046 
<a name="l00050"></a><a class="code" href="classDenseVectorBase.php#a56d3f682d013afe48137c623b40b5430">00050</a>   <a class="code" href="classDenseVectorBase.php#a56d3f682d013afe48137c623b40b5430">DenseVectorBase</a>() {}
<a name="l00051"></a>00051   
<a name="l00055"></a><a class="code" href="classDenseVectorBase.php#a5834c6fa7bef05c27f24f2d44878de42">00055</a>   <span class="keyword">virtual</span> <a class="code" href="classDenseVectorBase.php#a5834c6fa7bef05c27f24f2d44878de42">~DenseVectorBase</a>() {}
<a name="l00056"></a>00056 
<a name="l00062"></a>00062   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDenseVectorBase.php#ae88adbbd553f5498793694254e3c6cbb">zero</a>() = 0;
<a name="l00063"></a>00063 
<a name="l00067"></a>00067   <span class="keyword">virtual</span> T <a class="code" href="classDenseVectorBase.php#aab66dfa4cd02da710e367a112ac9f64f">el</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> = 0;
<a name="l00068"></a>00068 
<a name="l00072"></a>00072   <span class="keyword">virtual</span> T &amp; <a class="code" href="classDenseVectorBase.php#aab66dfa4cd02da710e367a112ac9f64f">el</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) = 0;
<a name="l00073"></a>00073 
<a name="l00077"></a>00077   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDenseVectorBase.php#af27a452cf8a2a5ec845e040c85761572">size</a>() <span class="keyword">const</span> = 0; 
<a name="l00078"></a>00078 
<a name="l00082"></a>00082   <span class="keywordtype">void</span> <a class="code" href="classDenseVectorBase.php#ac45d4ba435583b1b43df8946fa4767e5">print</a>(std::ostream&amp; os) <span class="keyword">const</span>;
<a name="l00083"></a>00083 
<a name="l00088"></a><a class="code" href="classDenseVectorBase.php#a2170f26c731219d31e49c900b29489e7">00088</a>   <span class="keyword">friend</span> std::ostream&amp; operator &lt;&lt; (std::ostream&amp; os, const DenseVectorBase&lt;T&gt;&amp; v)
<a name="l00089"></a>00089   {
<a name="l00090"></a>00090     v.print(os);
<a name="l00091"></a>00091     <span class="keywordflow">return</span> os;
<a name="l00092"></a>00092   }
<a name="l00093"></a>00093   
<a name="l00098"></a>00098   <span class="keywordtype">void</span> <a class="code" href="classDenseVectorBase.php#a29e7886a322b78f3be9eadcf5d999c42">print_scientific</a>(std::ostream&amp; os) <span class="keyword">const</span>;
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 };
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00105"></a>00105 <span class="comment">// DenseVectorBase member functions</span>
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 <span class="preprocessor">#endif // #ifndef __dense_vector_base_h__</span>
<a name="l00113"></a>00113 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
