<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_60be1125a39495b698d2d56e8e5b50b1.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>diff_context.C</h1>  </div>
</div>
<div class="contents">
<a href="diff__context_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: diff_context.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;diff_context.h&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;diff_system.h&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a><a class="code" href="classDiffContext.php#adeef399d7c3835b042d4ed081f6b3382">00026</a> <a class="code" href="classDiffContext.php#adeef399d7c3835b042d4ed081f6b3382">DiffContext::DiffContext</a> (<span class="keyword">const</span> <a class="code" href="classDifferentiableSystem.php">DifferentiableSystem</a>&amp; sys) :
<a name="l00027"></a>00027   time(sys.time),
<a name="l00028"></a>00028   elem_solution_derivative(1.),
<a name="l00029"></a>00029   fixed_solution_derivative(0.),
<a name="l00030"></a>00030   dof_indices_var(sys.n_vars())
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032   <span class="comment">// Finally initialize solution/residual/jacobian data structures</span>
<a name="l00033"></a>00033   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_vars = sys.<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>();
<a name="l00034"></a>00034 
<a name="l00035"></a>00035   <a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>.reserve(n_vars);
<a name="l00036"></a>00036   <a class="code" href="classDiffContext.php#a92489ca01a154b956107acd5eab14e1c">elem_subresiduals</a>.reserve(n_vars);
<a name="l00037"></a>00037   <a class="code" href="classDiffContext.php#a314b50e71d312179bb30b1800d7677ee">elem_subjacobians</a>.resize(n_vars);
<a name="l00038"></a>00038   <span class="keywordflow">if</span> (sys.<a class="code" href="classDifferentiableSystem.php#a3e9645837798cc7d10d127b9ce54b0e1">use_fixed_solution</a>)
<a name="l00039"></a>00039     <a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>.reserve(n_vars);
<a name="l00040"></a>00040 
<a name="l00041"></a>00041   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_vars; ++i)
<a name="l00042"></a>00042     {
<a name="l00043"></a>00043       <a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>.push_back(<span class="keyword">new</span> <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;Number&gt;</a>(<a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>));
<a name="l00044"></a>00044       <a class="code" href="classDiffContext.php#a92489ca01a154b956107acd5eab14e1c">elem_subresiduals</a>.push_back(<span class="keyword">new</span> <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;Number&gt;</a>(<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>));
<a name="l00045"></a>00045       <a class="code" href="classDiffContext.php#a314b50e71d312179bb30b1800d7677ee">elem_subjacobians</a>[i].reserve(n_vars);
<a name="l00046"></a>00046 
<a name="l00047"></a>00047       <span class="keywordflow">if</span> (sys.<a class="code" href="classDifferentiableSystem.php#a3e9645837798cc7d10d127b9ce54b0e1">use_fixed_solution</a>)
<a name="l00048"></a>00048         <a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>.push_back
<a name="l00049"></a>00049           (<span class="keyword">new</span> <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;Number&gt;</a>(<a class="code" href="classDiffContext.php#a1ab7c2721bfd00d5483f7625fb49e421">elem_fixed_solution</a>));
<a name="l00050"></a>00050 
<a name="l00051"></a>00051       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j != n_vars; ++j)
<a name="l00052"></a>00052         <a class="code" href="classDiffContext.php#a314b50e71d312179bb30b1800d7677ee">elem_subjacobians</a>[i].push_back
<a name="l00053"></a>00053           (<span class="keyword">new</span> <a class="code" href="classDenseSubMatrix.php">DenseSubMatrix&lt;Number&gt;</a>(<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>));
<a name="l00054"></a>00054     }
<a name="l00055"></a>00055 }
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 
<a name="l00059"></a><a class="code" href="classDiffContext.php#a229937969e30d9e36a907ecd6a03a90b">00059</a> <a class="code" href="classDiffContext.php#a229937969e30d9e36a907ecd6a03a90b">DiffContext::~DiffContext</a> ()
<a name="l00060"></a>00060 {
<a name="l00061"></a>00061   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>.size(); ++i)
<a name="l00062"></a>00062     {
<a name="l00063"></a>00063       <span class="keyword">delete</span> <a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[i];
<a name="l00064"></a>00064       <span class="keyword">delete</span> <a class="code" href="classDiffContext.php#a92489ca01a154b956107acd5eab14e1c">elem_subresiduals</a>[i];
<a name="l00065"></a>00065       <span class="keywordflow">if</span> (!<a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>.empty())
<a name="l00066"></a>00066         <span class="keyword">delete</span> <a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>[i];
<a name="l00067"></a>00067 
<a name="l00068"></a>00068       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j != <a class="code" href="classDiffContext.php#a314b50e71d312179bb30b1800d7677ee">elem_subjacobians</a>[i].size(); ++j)
<a name="l00069"></a>00069         <span class="keyword">delete</span> <a class="code" href="classDiffContext.php#a314b50e71d312179bb30b1800d7677ee">elem_subjacobians</a>[i][j];
<a name="l00070"></a>00070     }
<a name="l00071"></a>00071 }
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
