<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>diff_context.h</h1>  </div>
</div>
<div class="contents">
<a href="diff__context_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 <span class="comment">// $Id: diff_context.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00005"></a>00005 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00006"></a>00006   
<a name="l00007"></a>00007 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00008"></a>00008 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00009"></a>00009 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00010"></a>00010 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00011"></a>00011   
<a name="l00012"></a>00012 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00013"></a>00013 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00014"></a>00014 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00015"></a>00015 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00016"></a>00016   
<a name="l00017"></a>00017 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00018"></a>00018 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00019"></a>00019 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifndef __diff_context_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#define __diff_context_h__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;dense_matrix.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;dense_submatrix.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;dense_subvector.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;dense_vector.h&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward declarations</span>
<a name="l00035"></a>00035 <span class="keyword">class </span><a class="code" href="classDifferentiableSystem.php">DifferentiableSystem</a>;
<a name="l00036"></a>00036 
<a name="l00049"></a>00049 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00050"></a>00050 <span class="comment">// DifferentiableSystem class definition</span>
<a name="l00051"></a>00051 
<a name="l00052"></a><a class="code" href="classDiffContext.php">00052</a> <span class="keyword">class </span><a class="code" href="classDiffContext.php">DiffContext</a>
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054 <span class="keyword">public</span>:
<a name="l00055"></a>00055 
<a name="l00060"></a>00060   <a class="code" href="classDiffContext.php#adeef399d7c3835b042d4ed081f6b3382">DiffContext</a> (<span class="keyword">const</span> <a class="code" href="classDifferentiableSystem.php">DifferentiableSystem</a> &amp;);
<a name="l00061"></a>00061 
<a name="l00065"></a>00065   <span class="keyword">virtual</span> <a class="code" href="classDiffContext.php#a229937969e30d9e36a907ecd6a03a90b">~DiffContext</a> ();
<a name="l00066"></a>00066 
<a name="l00071"></a><a class="code" href="classDiffContext.php#a42a65033568ec2514f0de4babec7d4e9">00071</a>   <span class="keywordtype">bool</span> <a class="code" href="classDiffContext.php#a42a65033568ec2514f0de4babec7d4e9">postprocess_sides</a>;
<a name="l00072"></a>00072 
<a name="l00078"></a><a class="code" href="classDiffContext.php#a19ff1c41b089cfccb6b419a7540332f0">00078</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDiffContext.php#a19ff1c41b089cfccb6b419a7540332f0">elem_reinit</a>(<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>) {}
<a name="l00079"></a>00079 
<a name="l00084"></a><a class="code" href="classDiffContext.php#a2eac885c9584bdf1a5abb05fbdfa6eb1">00084</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDiffContext.php#a2eac885c9584bdf1a5abb05fbdfa6eb1">elem_side_reinit</a>(<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>) {}
<a name="l00085"></a>00085 
<a name="l00091"></a><a class="code" href="classDiffContext.php#a6f0aa0edbd2d57babeee796d43e9c40d">00091</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDiffContext.php#a6f0aa0edbd2d57babeee796d43e9c40d">time</a>;
<a name="l00092"></a>00092 
<a name="l00097"></a><a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">00097</a>   <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>;
<a name="l00098"></a><a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">00098</a>   std::vector&lt;DenseSubVector&lt;Number&gt; *&gt; <a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>;
<a name="l00099"></a>00099 
<a name="l00105"></a><a class="code" href="classDiffContext.php#a1ab7c2721bfd00d5483f7625fb49e421">00105</a>   <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classDiffContext.php#a1ab7c2721bfd00d5483f7625fb49e421">elem_fixed_solution</a>;
<a name="l00106"></a><a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">00106</a>   std::vector&lt;DenseSubVector&lt;Number&gt; *&gt; <a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>;
<a name="l00107"></a>00107 
<a name="l00112"></a><a class="code" href="classDiffContext.php#aca099ee5e8431aeb96145d24dacc04cb">00112</a>   <span class="keywordtype">bool</span> <a class="code" href="classDiffContext.php#aca099ee5e8431aeb96145d24dacc04cb">request_jacobian</a>;
<a name="l00113"></a>00113 
<a name="l00119"></a><a class="code" href="classDiffContext.php#a9cb6e53f5be4dbbbff17d3c9986ec423">00119</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDiffContext.php#a9cb6e53f5be4dbbbff17d3c9986ec423">elem_solution_derivative</a>;
<a name="l00120"></a>00120 
<a name="l00126"></a><a class="code" href="classDiffContext.php#aad59fbaa6442d15ef901607827ed9e9c">00126</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDiffContext.php#aad59fbaa6442d15ef901607827ed9e9c">fixed_solution_derivative</a>;
<a name="l00127"></a>00127 
<a name="l00131"></a><a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">00131</a>   <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>;
<a name="l00132"></a>00132 
<a name="l00137"></a><a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">00137</a>   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Number&gt;</a> <a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>;
<a name="l00138"></a>00138 
<a name="l00142"></a><a class="code" href="classDiffContext.php#a92489ca01a154b956107acd5eab14e1c">00142</a>   std::vector&lt;DenseSubVector&lt;Number&gt; *&gt; <a class="code" href="classDiffContext.php#a92489ca01a154b956107acd5eab14e1c">elem_subresiduals</a>;
<a name="l00143"></a><a class="code" href="classDiffContext.php#a314b50e71d312179bb30b1800d7677ee">00143</a>   std::vector&lt;std::vector&lt;DenseSubMatrix&lt;Number&gt; *&gt; &gt; <a class="code" href="classDiffContext.php#a314b50e71d312179bb30b1800d7677ee">elem_subjacobians</a>;
<a name="l00144"></a>00144 
<a name="l00148"></a><a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">00148</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>;
<a name="l00149"></a><a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">00149</a>   std::vector&lt;std::vector&lt;unsigned int&gt; &gt; <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>;
<a name="l00150"></a>00150 };
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
