<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_60be1125a39495b698d2d56e8e5b50b1.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>diff_solver.C</h1>  </div>
</div>
<div class="contents">
<a href="diff__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: diff_solver.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;diff_solver.h&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;newton_solver.h&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a><a class="code" href="classDiffSolver.php#a111d032fdca36678c1eb6e84847f9048">00026</a> <a class="code" href="classDiffSolver.php#a111d032fdca36678c1eb6e84847f9048">DiffSolver::DiffSolver</a> (<a class="code" href="classDifferentiableSystem.php">sys_type</a>&amp; s)
<a name="l00027"></a>00027     : max_linear_iterations(1000),
<a name="l00028"></a>00028       max_nonlinear_iterations(100),
<a name="l00029"></a>00029       quiet(true),
<a name="l00030"></a>00030       continue_after_max_iterations(true),
<a name="l00031"></a>00031       continue_after_backtrack_failure(false),
<a name="l00032"></a>00032       absolute_residual_tolerance(0.),
<a name="l00033"></a>00033       relative_residual_tolerance(0.),
<a name="l00034"></a>00034       absolute_step_tolerance(0.),
<a name="l00035"></a>00035       relative_step_tolerance(0.),
<a name="l00036"></a>00036       initial_linear_tolerance(1e-12),
<a name="l00037"></a>00037       minimum_linear_tolerance(TOLERANCE*TOLERANCE),
<a name="l00038"></a>00038       max_solution_norm(0.),
<a name="l00039"></a>00039       max_residual_norm(0.),
<a name="l00040"></a>00040       _system (s),
<a name="l00041"></a>00041       _solve_result(INVALID_SOLVE_RESULT)
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043 }
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a><a class="code" href="classDiffSolver.php#a4329eed9150ced6af7f969015fc14dfb">00047</a> <a class="code" href="classAutoPtr.php">AutoPtr&lt;DiffSolver&gt;</a> <a class="code" href="classDiffSolver.php#a4329eed9150ced6af7f969015fc14dfb">DiffSolver::build</a> (<a class="code" href="classDifferentiableSystem.php">sys_type</a>&amp; s)
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049   <span class="keywordflow">return</span> <a class="code" href="classAutoPtr.php">AutoPtr&lt;DiffSolver&gt;</a>(<span class="keyword">new</span> <a class="code" href="classNewtonSolver.php">NewtonSolver</a>(s));
<a name="l00050"></a>00050 }
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a><a class="code" href="classDiffSolver.php#af577460d7836c62c1aed2455c9085e32">00054</a> <span class="keywordtype">void</span> <a class="code" href="classDiffSolver.php#af577460d7836c62c1aed2455c9085e32">DiffSolver::reinit</a> ()
<a name="l00055"></a>00055 {
<a name="l00056"></a>00056   <span class="comment">// Reset the max_step_size and max_residual_norm for a new mesh</span>
<a name="l00057"></a>00057   <a class="code" href="classDiffSolver.php#ae59b11ad5467539e63a8427289c3d897">max_solution_norm</a> = 0.;
<a name="l00058"></a>00058   <a class="code" href="classDiffSolver.php#a90458811c5dc49c07ec3447553529a6d">max_residual_norm</a> = 0.;
<a name="l00059"></a>00059 }
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a><a class="code" href="classDiffSolver.php#ae5b8b414c326206370ffffeda5184815">00063</a> <span class="keywordtype">void</span> <a class="code" href="classDiffSolver.php#ae5b8b414c326206370ffffeda5184815">DiffSolver::init</a> ()
<a name="l00064"></a>00064 {
<a name="l00065"></a>00065   <span class="comment">// Reset the max_step_size and max_residual_norm for a new problem</span>
<a name="l00066"></a>00066   <a class="code" href="classDiffSolver.php#ae59b11ad5467539e63a8427289c3d897">max_solution_norm</a> = 0.;
<a name="l00067"></a>00067   <a class="code" href="classDiffSolver.php#a90458811c5dc49c07ec3447553529a6d">max_residual_norm</a> = 0.;
<a name="l00068"></a>00068 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
