<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>diff_solver.h</h1>  </div>
</div>
<div class="contents">
<a href="diff__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: diff_solver.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __diff_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __diff_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;auto_ptr.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;reference_counted_object.h&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Forward Declarations</span>
<a name="l00033"></a>00033 <span class="keyword">class </span><a class="code" href="classDiffSolver.php">DiffSolver</a>;
<a name="l00034"></a>00034 <span class="keyword">class </span><a class="code" href="classDifferentiableSystem.php">DifferentiableSystem</a>;
<a name="l00035"></a>00035 
<a name="l00048"></a>00048 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00049"></a>00049 <span class="comment">// Solver class definition</span>
<a name="l00050"></a><a class="code" href="classDiffSolver.php">00050</a> <span class="keyword">class </span><a class="code" href="classDiffSolver.php">DiffSolver</a> : <span class="keyword">public</span> <a class="code" href="classReferenceCountedObject.php">ReferenceCountedObject</a>&lt;DiffSolver&gt;
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052 <span class="keyword">public</span>:
<a name="l00056"></a><a class="code" href="classDiffSolver.php#af2611d146b303228ce02ffc397007c79">00056</a>   <span class="keyword">typedef</span> <a class="code" href="classDifferentiableSystem.php">DifferentiableSystem</a> <a class="code" href="classDiffSolver.php#af2611d146b303228ce02ffc397007c79">sys_type</a>;
<a name="l00057"></a>00057   
<a name="l00062"></a>00062   <a class="code" href="classDiffSolver.php#a111d032fdca36678c1eb6e84847f9048">DiffSolver</a> (<a class="code" href="classDifferentiableSystem.php">sys_type</a>&amp; s);
<a name="l00063"></a>00063 
<a name="l00068"></a>00068   <span class="keyword">static</span> <a class="code" href="classAutoPtr.php">AutoPtr&lt;DiffSolver&gt;</a> <a class="code" href="classDiffSolver.php#a4329eed9150ced6af7f969015fc14dfb">build</a>(<a class="code" href="classDifferentiableSystem.php">sys_type</a>&amp; s);
<a name="l00069"></a>00069   
<a name="l00073"></a><a class="code" href="classDiffSolver.php#ad8f33dad4fa2e08296d077245b0bfee1">00073</a>   <span class="keyword">virtual</span> <a class="code" href="classDiffSolver.php#ad8f33dad4fa2e08296d077245b0bfee1">~DiffSolver</a> () {}
<a name="l00074"></a>00074 
<a name="l00079"></a>00079   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDiffSolver.php#ae5b8b414c326206370ffffeda5184815">init</a> ();
<a name="l00080"></a>00080 
<a name="l00085"></a>00085   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDiffSolver.php#af577460d7836c62c1aed2455c9085e32">reinit</a> ();
<a name="l00086"></a>00086 
<a name="l00092"></a>00092   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDiffSolver.php#a719a0326983c96a4b1ce201640e88e1a">solve</a> () = 0;
<a name="l00093"></a>00093 
<a name="l00099"></a>00099   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDiffSolver.php#aad23c14d0117f3d21d9cd5d7a2d0f062">adjoint_solve</a> () = 0;
<a name="l00100"></a>00100 
<a name="l00105"></a><a class="code" href="classDiffSolver.php#ad4736f527b018dd46faa1016f7617e3d">00105</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDiffSolver.php#ad4736f527b018dd46faa1016f7617e3d">total_outer_iterations</a>() { <span class="keywordflow">return</span> <a class="code" href="classDiffSolver.php#a79d256bff5a88d89aec8941041dc89a9">_outer_iterations</a>; }
<a name="l00106"></a>00106 
<a name="l00111"></a><a class="code" href="classDiffSolver.php#a09585e2c55a369d290e36bb52da41207">00111</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDiffSolver.php#a09585e2c55a369d290e36bb52da41207">total_inner_iterations</a>() { <span class="keywordflow">return</span> <a class="code" href="classDiffSolver.php#a80e331cee9e385b0a96eae02f680ef52">_inner_iterations</a>; }
<a name="l00112"></a>00112 
<a name="l00116"></a><a class="code" href="classDiffSolver.php#ae46cce88c658ff07af7fef537026388f">00116</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDiffSolver.php#ae46cce88c658ff07af7fef537026388f">solve_result</a>() { <span class="keywordflow">return</span> <a class="code" href="classDiffSolver.php#aec36f54268296d66ff6bf995521edb5c">_solve_result</a>; }
<a name="l00117"></a>00117 
<a name="l00121"></a><a class="code" href="classDiffSolver.php#a4caf9ee24e332e6cda6c8bb3ea032b87">00121</a>   <span class="keyword">const</span> <a class="code" href="classDifferentiableSystem.php">sys_type</a> &amp; <a class="code" href="classDiffSolver.php#a4caf9ee24e332e6cda6c8bb3ea032b87">system</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>; }
<a name="l00122"></a>00122 
<a name="l00126"></a><a class="code" href="classDiffSolver.php#a99ec87d0d1146555a6b4dda7187951d7">00126</a>   <a class="code" href="classDifferentiableSystem.php">sys_type</a> &amp; <a class="code" href="classDiffSolver.php#a99ec87d0d1146555a6b4dda7187951d7">system</a> () { <span class="keywordflow">return</span> <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>; }
<a name="l00127"></a>00127   
<a name="l00132"></a><a class="code" href="classDiffSolver.php#a44125d46d2f5df9f29392cbe81069bf6">00132</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDiffSolver.php#a44125d46d2f5df9f29392cbe81069bf6">max_linear_iterations</a>;
<a name="l00133"></a>00133 
<a name="l00140"></a><a class="code" href="classDiffSolver.php#af19d007c437a3f5a6e7be54e3c0d0bea">00140</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDiffSolver.php#af19d007c437a3f5a6e7be54e3c0d0bea">max_nonlinear_iterations</a>;
<a name="l00141"></a>00141 
<a name="l00146"></a><a class="code" href="classDiffSolver.php#ae6aee54a1508db27cbaa0a6045ef44e9">00146</a>   <span class="keywordtype">bool</span> <a class="code" href="classDiffSolver.php#ae6aee54a1508db27cbaa0a6045ef44e9">quiet</a>;
<a name="l00147"></a>00147 
<a name="l00152"></a><a class="code" href="classDiffSolver.php#a97ca05c97f03bd17340b1a361a98e80f">00152</a>   <span class="keywordtype">bool</span> <a class="code" href="classDiffSolver.php#a97ca05c97f03bd17340b1a361a98e80f">continue_after_max_iterations</a>;
<a name="l00153"></a>00153 
<a name="l00158"></a><a class="code" href="classDiffSolver.php#a37c6a1d3285402138026b4ad79d4e5a8">00158</a>   <span class="keywordtype">bool</span> <a class="code" href="classDiffSolver.php#a37c6a1d3285402138026b4ad79d4e5a8">continue_after_backtrack_failure</a>;
<a name="l00159"></a>00159 
<a name="l00169"></a><a class="code" href="classDiffSolver.php#a3cbd27e0c7686f2b8679cfda8ef10688">00169</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDiffSolver.php#a3cbd27e0c7686f2b8679cfda8ef10688">absolute_residual_tolerance</a>;
<a name="l00170"></a><a class="code" href="classDiffSolver.php#aa61c00b75cbbd6910882c7a415d9d22a">00170</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDiffSolver.php#aa61c00b75cbbd6910882c7a415d9d22a">relative_residual_tolerance</a>;
<a name="l00171"></a>00171 
<a name="l00181"></a><a class="code" href="classDiffSolver.php#a84dcc061d26122fae4918c2c31bf7112">00181</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDiffSolver.php#a84dcc061d26122fae4918c2c31bf7112">absolute_step_tolerance</a>;
<a name="l00182"></a><a class="code" href="classDiffSolver.php#abd9adb33f150f9d5af8241e38e64d218">00182</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDiffSolver.php#abd9adb33f150f9d5af8241e38e64d218">relative_step_tolerance</a>;
<a name="l00183"></a>00183 
<a name="l00188"></a><a class="code" href="classDiffSolver.php#aeef97d8c12a932bfd59a7e1aa703fc92">00188</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDiffSolver.php#aeef97d8c12a932bfd59a7e1aa703fc92">initial_linear_tolerance</a>;
<a name="l00189"></a>00189 
<a name="l00193"></a><a class="code" href="classDiffSolver.php#a13f56127884c9aada9af23517b804a3c">00193</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDiffSolver.php#a13f56127884c9aada9af23517b804a3c">minimum_linear_tolerance</a>;
<a name="l00194"></a>00194   
<a name="l00200"></a><a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071ee">00200</a>   <span class="keyword">enum</span> <a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071ee">SolveResult</a> {
<a name="l00205"></a><a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eeae038bac4d2139f7fc5c4244a07c7a3d2">00205</a>     <a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eeae038bac4d2139f7fc5c4244a07c7a3d2">INVALID_SOLVE_RESULT</a> = 0,
<a name="l00206"></a>00206     
<a name="l00211"></a><a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eea9297f23243b1589696d58a5a8ecab608">00211</a>     <a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eea9297f23243b1589696d58a5a8ecab608">CONVERGED_NO_REASON</a> = 1,
<a name="l00212"></a>00212 
<a name="l00217"></a><a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eea6cf0082a1c732ae88bb52a5d35ae52ae">00217</a>     <a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eea6cf0082a1c732ae88bb52a5d35ae52ae">CONVERGED_ABSOLUTE_RESIDUAL</a> = 2,
<a name="l00218"></a>00218 
<a name="l00223"></a><a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eea7a3ff540e243e45764a90666389ba012">00223</a>     <a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eea7a3ff540e243e45764a90666389ba012">CONVERGED_RELATIVE_RESIDUAL</a> = 4,
<a name="l00224"></a>00224 
<a name="l00229"></a><a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eeac8730b88876c08be2436d12d17dcb42f">00229</a>     <a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eeac8730b88876c08be2436d12d17dcb42f">CONVERGED_ABSOLUTE_STEP</a> = 8,
<a name="l00230"></a>00230 
<a name="l00235"></a><a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eea2f1371f17746515eeba38c85bc8676e1">00235</a>     <a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eea2f1371f17746515eeba38c85bc8676e1">CONVERGED_RELATIVE_STEP</a> = 16,
<a name="l00236"></a>00236 
<a name="l00241"></a><a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eea60748e91f2e07f4497a422f747f92523">00241</a>     <a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eea60748e91f2e07f4497a422f747f92523">DIVERGED_NO_REASON</a> = 32,
<a name="l00242"></a>00242 
<a name="l00248"></a><a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eeabe4e5d049d7a788b52deae9ce8865b34">00248</a>     <a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eeabe4e5d049d7a788b52deae9ce8865b34">DIVERGED_MAX_NONLINEAR_ITERATIONS</a> = 64,
<a name="l00249"></a>00249 
<a name="l00254"></a><a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eea130376f697142abacfd339d3f8d28edc">00254</a>     <a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eea130376f697142abacfd339d3f8d28edc">DIVERGED_BACKTRACKING_FAILURE</a> = 128
<a name="l00255"></a>00255   };
<a name="l00256"></a>00256 
<a name="l00257"></a>00257 <span class="keyword">protected</span>:
<a name="l00258"></a>00258 
<a name="l00263"></a><a class="code" href="classDiffSolver.php#ae59b11ad5467539e63a8427289c3d897">00263</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDiffSolver.php#ae59b11ad5467539e63a8427289c3d897">max_solution_norm</a>;
<a name="l00264"></a>00264 
<a name="l00270"></a><a class="code" href="classDiffSolver.php#a90458811c5dc49c07ec3447553529a6d">00270</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDiffSolver.php#a90458811c5dc49c07ec3447553529a6d">max_residual_norm</a>;
<a name="l00271"></a>00271 
<a name="l00275"></a><a class="code" href="classDiffSolver.php#a79d256bff5a88d89aec8941041dc89a9">00275</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDiffSolver.php#a79d256bff5a88d89aec8941041dc89a9">_outer_iterations</a>;
<a name="l00276"></a>00276 
<a name="l00280"></a><a class="code" href="classDiffSolver.php#a80e331cee9e385b0a96eae02f680ef52">00280</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDiffSolver.php#a80e331cee9e385b0a96eae02f680ef52">_inner_iterations</a>;
<a name="l00281"></a>00281 
<a name="l00285"></a><a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">00285</a>   <a class="code" href="classDifferentiableSystem.php">sys_type</a>&amp; <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>;
<a name="l00286"></a>00286 
<a name="l00293"></a><a class="code" href="classDiffSolver.php#aec36f54268296d66ff6bf995521edb5c">00293</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDiffSolver.php#aec36f54268296d66ff6bf995521edb5c">_solve_result</a>;
<a name="l00294"></a>00294 };
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 
<a name="l00297"></a>00297 
<a name="l00298"></a>00298 <span class="preprocessor">#endif // #define __diff_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
