<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_60be1125a39495b698d2d56e8e5b50b1.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>diff_system.C</h1>  </div>
</div>
<div class="contents">
<a href="diff__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: diff_system.C 3502 2009-10-20 18:06:50Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;diff_system.h&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;dof_map.h&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;time_solver.h&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <a class="code" href="classDifferentiableSystem.php#a7e66a8d68f94ed6b4a2a76fb2d15de4b">DifferentiableSystem::DifferentiableSystem</a>
<a name="l00029"></a><a class="code" href="classDifferentiableSystem.php#a7e66a8d68f94ed6b4a2a76fb2d15de4b">00029</a>                       (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00030"></a>00030                        <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00031"></a>00031                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :
<a name="l00032"></a>00032   <a class="code" href="classImplicitSystem.php">Parent</a>      (es, name, number),
<a name="l00033"></a>00033   compute_internal_sides(<span class="keyword">false</span>),
<a name="l00034"></a>00034   postprocess_sides(<span class="keyword">false</span>),
<a name="l00035"></a>00035   time_solver (NULL),
<a name="l00036"></a>00036   time(0.),
<a name="l00037"></a>00037   deltat(1.),
<a name="l00038"></a>00038   print_solution_norms(<span class="keyword">false</span>),
<a name="l00039"></a>00039   print_solutions(<span class="keyword">false</span>),
<a name="l00040"></a>00040   print_residual_norms(<span class="keyword">false</span>),
<a name="l00041"></a>00041   print_residuals(<span class="keyword">false</span>),
<a name="l00042"></a>00042   print_jacobian_norms(<span class="keyword">false</span>),
<a name="l00043"></a>00043   print_jacobians(<span class="keyword">false</span>),
<a name="l00044"></a>00044   print_element_jacobians(<span class="keyword">false</span>),
<a name="l00045"></a>00045   use_fixed_solution(<span class="keyword">false</span>)
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047 }
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a><a class="code" href="classDifferentiableSystem.php#ac15d3cf6af13910d0b32226a0fdbf45a">00051</a> <a class="code" href="classDifferentiableSystem.php#ac15d3cf6af13910d0b32226a0fdbf45a">DifferentiableSystem::~DifferentiableSystem</a> ()
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053   this-&gt;<a class="code" href="classDifferentiableSystem.php#a9072ddeb46f6a483595e93621a38d391">clear</a>();
<a name="l00054"></a>00054 }
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a><a class="code" href="classDifferentiableSystem.php#a9072ddeb46f6a483595e93621a38d391">00058</a> <span class="keywordtype">void</span> <a class="code" href="classDifferentiableSystem.php#a9072ddeb46f6a483595e93621a38d391">DifferentiableSystem::clear</a> ()
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060   <a class="code" href="classDifferentiableSystem.php#a457f7ba8b9e434c07935e23d33c41cc4">_time_evolving</a>.resize(0);
<a name="l00061"></a>00061 
<a name="l00062"></a>00062   <a class="code" href="classDifferentiableSystem.php#a3e9645837798cc7d10d127b9ce54b0e1">use_fixed_solution</a> = <span class="keyword">false</span>;
<a name="l00063"></a>00063 }
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00067"></a><a class="code" href="classDifferentiableSystem.php#a1e8208241db74ae237f9d8490f489d20">00067</a> <span class="keywordtype">void</span> <a class="code" href="classDifferentiableSystem.php#a1e8208241db74ae237f9d8490f489d20">DifferentiableSystem::reinit</a> ()
<a name="l00068"></a>00068 {
<a name="l00069"></a>00069   <a class="code" href="classImplicitSystem.php#a292ff27cdaef1d65974cad561ad1beed">Parent::reinit</a>();
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   <a class="code" href="classDifferentiableSystem.php#a0dab4aeae88234a06d041519b219fbc4">time_solver</a>-&gt;reinit();
<a name="l00072"></a>00072 }
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00076"></a><a class="code" href="classDifferentiableSystem.php#a4fe36b066e7b028d6403a858ec75fa1d">00076</a> <span class="keywordtype">void</span> <a class="code" href="classDifferentiableSystem.php#a4fe36b066e7b028d6403a858ec75fa1d">DifferentiableSystem::init_data</a> ()
<a name="l00077"></a>00077 {
<a name="l00078"></a>00078   <span class="comment">// give us flags for every variable that might be time evolving</span>
<a name="l00079"></a>00079   <a class="code" href="classDifferentiableSystem.php#a457f7ba8b9e434c07935e23d33c41cc4">_time_evolving</a>.resize(this-&gt;<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>(), <span class="keyword">false</span>);
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <span class="comment">// Do any initialization our solvers need</span>
<a name="l00082"></a>00082   libmesh_assert (<a class="code" href="classDifferentiableSystem.php#a0dab4aeae88234a06d041519b219fbc4">time_solver</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL);
<a name="l00083"></a>00083   <a class="code" href="classDifferentiableSystem.php#a0dab4aeae88234a06d041519b219fbc4">time_solver</a>-&gt;init();
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="comment">// Next initialize ImplicitSystem data</span>
<a name="l00086"></a>00086   <a class="code" href="classImplicitSystem.php#a98ef29b55b9c0f64e7a07a94276f6c57">Parent::init_data</a>();
<a name="l00087"></a>00087 }
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 
<a name="l00091"></a><a class="code" href="classDifferentiableSystem.php#a8ce5ce27069dd193ede7bb1005b2425a">00091</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DiffContext&gt;</a> <a class="code" href="classDifferentiableSystem.php#a8ce5ce27069dd193ede7bb1005b2425a">DifferentiableSystem::build_context</a> ()
<a name="l00092"></a>00092 {
<a name="l00093"></a>00093   <span class="keywordflow">return</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DiffContext&gt;</a>(<span class="keyword">new</span> <a class="code" href="classDiffContext.php">DiffContext</a>(*<span class="keyword">this</span>));
<a name="l00094"></a>00094 }
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a><a class="code" href="classDifferentiableSystem.php#a13fdfacb2b04b10e4266444f1beb1fe2">00098</a> <span class="keywordtype">void</span> <a class="code" href="classDifferentiableSystem.php#a13fdfacb2b04b10e4266444f1beb1fe2">DifferentiableSystem::assemble</a> ()
<a name="l00099"></a>00099 {
<a name="l00100"></a>00100   this-&gt;<a class="code" href="classDifferentiableSystem.php#af2770154003897eef7c70a5318478393">assembly</a>(<span class="keyword">true</span>, <span class="keyword">true</span>);
<a name="l00101"></a>00101 }
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00105"></a><a class="code" href="classDifferentiableSystem.php#afe25c7be93c504e4505de2f5b3da7dc9">00105</a> <span class="keywordtype">void</span> <a class="code" href="classDifferentiableSystem.php#afe25c7be93c504e4505de2f5b3da7dc9">DifferentiableSystem::solve</a> ()
<a name="l00106"></a>00106 {
<a name="l00107"></a>00107   <a class="code" href="classDifferentiableSystem.php#a0dab4aeae88234a06d041519b219fbc4">time_solver</a>-&gt;solve();
<a name="l00108"></a>00108 }
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 
<a name="l00112"></a><a class="code" href="classDifferentiableSystem.php#a72627af86f19c8a43bdeec9f8ec49b64">00112</a> <span class="keywordtype">void</span> <a class="code" href="classDifferentiableSystem.php#a72627af86f19c8a43bdeec9f8ec49b64">DifferentiableSystem::adjoint_solve</a> ()
<a name="l00113"></a>00113 {
<a name="l00114"></a>00114   <a class="code" href="classDifferentiableSystem.php#a0dab4aeae88234a06d041519b219fbc4">time_solver</a>-&gt;adjoint_solve();
<a name="l00115"></a>00115 }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 <span class="keywordtype">void</span> <a class="code" href="classDifferentiableSystem.php#ade211173ed9d7afb4dde0a156881c73a">DifferentiableSystem::qoi_parameter_sensitivity</a>
<a name="l00120"></a><a class="code" href="classDifferentiableSystem.php#ade211173ed9d7afb4dde0a156881c73a">00120</a>   (std::vector&lt;Number *&gt;&amp; parameters,
<a name="l00121"></a>00121    std::vector&lt;Number&gt;&amp;   sensitivities)
<a name="l00122"></a>00122 {
<a name="l00123"></a>00123   <span class="comment">// Get ready to fill in senstivities:</span>
<a name="l00124"></a>00124   sensitivities.clear();
<a name="l00125"></a>00125   sensitivities.resize(parameters.size(), 0);
<a name="l00126"></a>00126 
<a name="l00127"></a>00127   <span class="comment">// An introduction to the problem:</span>
<a name="l00128"></a>00128   <span class="comment">//</span>
<a name="l00129"></a>00129   <span class="comment">// Residual R(u(p),p) = 0</span>
<a name="l00130"></a>00130   <span class="comment">// partial R / partial u = J = system matrix</span>
<a name="l00131"></a>00131   <span class="comment">//</span>
<a name="l00132"></a>00132   <span class="comment">// This implies that:</span>
<a name="l00133"></a>00133   <span class="comment">// d/dp(R) = 0</span>
<a name="l00134"></a>00134   <span class="comment">// (partial R / partial p) + </span>
<a name="l00135"></a>00135   <span class="comment">// (partial R / partial u) * (partial u / partial p) = 0</span>
<a name="l00136"></a>00136 
<a name="l00137"></a>00137   <span class="comment">// We first do an adjoint solve:</span>
<a name="l00138"></a>00138   <span class="comment">// J^T * z = (partial q / partial u)</span>
<a name="l00139"></a>00139 
<a name="l00140"></a>00140   this-&gt;adjoint_solve();
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   <span class="comment">// We use the identities:</span>
<a name="l00143"></a>00143   <span class="comment">// dq/dp = (partial q / partial p) + (partial q / partial u) *</span>
<a name="l00144"></a>00144   <span class="comment">//         (partial u / partial p)</span>
<a name="l00145"></a>00145   <span class="comment">// dq/dp = (partial q / partial p) + (J^T * z) *</span>
<a name="l00146"></a>00146   <span class="comment">//         (partial u / partial p)</span>
<a name="l00147"></a>00147   <span class="comment">// dq/dp = (partial q / partial p) + z * J *</span>
<a name="l00148"></a>00148   <span class="comment">//         (partial u / partial p)</span>
<a name="l00149"></a>00149  
<a name="l00150"></a>00150   <span class="comment">// Leading to our final formula:</span>
<a name="l00151"></a>00151   <span class="comment">// dq/dp = (partial q / partial p) - z * (partial R / partial p)</span>
<a name="l00152"></a>00152 
<a name="l00153"></a>00153   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != parameters.size(); ++i)
<a name="l00154"></a>00154     {
<a name="l00155"></a>00155       <span class="comment">// We currently get partial derivatives via central differencing</span>
<a name="l00156"></a>00156       <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> delta_p = 1e-6;
<a name="l00157"></a>00157 
<a name="l00158"></a>00158       <span class="comment">// (partial q / partial p) ~= (q(p+dp)-q(p-dp))/(2*dp)</span>
<a name="l00159"></a>00159       <span class="comment">// (partial R / partial p) ~= (rhs(p+dp) - rhs(p-dp))/(2*dp)</span>
<a name="l00160"></a>00160 
<a name="l00161"></a>00161       <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> old_parameter = *parameters[i];
<a name="l00162"></a>00162       <span class="comment">// Number old_qoi = this-&gt;qoi;</span>
<a name="l00163"></a>00163 
<a name="l00164"></a>00164       *parameters[i] = old_parameter - delta_p;
<a name="l00165"></a>00165       this-&gt;assemble_qoi();
<a name="l00166"></a>00166       <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> qoi_minus = this-&gt;qoi;
<a name="l00167"></a>00167 
<a name="l00168"></a>00168       this-&gt;assembly(<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l00169"></a>00169       this-&gt;rhs-&gt;close();
<a name="l00170"></a>00170       <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; partialR_partialp = this-&gt;rhs-&gt;clone();
<a name="l00171"></a>00171       *partialR_partialp *= -1;
<a name="l00172"></a>00172 
<a name="l00173"></a>00173       *parameters[i] = old_parameter + delta_p;
<a name="l00174"></a>00174       this-&gt;assemble_qoi();
<a name="l00175"></a>00175       <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> qoi_plus = this-&gt;qoi;
<a name="l00176"></a>00176       <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> partialq_partialp = (qoi_plus - qoi_minus) / (2.*delta_p);
<a name="l00177"></a>00177 
<a name="l00178"></a>00178       this-&gt;assembly(<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l00179"></a>00179       this-&gt;rhs-&gt;close();
<a name="l00180"></a>00180       *partialR_partialp += *this-&gt;rhs;
<a name="l00181"></a>00181       *partialR_partialp /= (2.*delta_p);
<a name="l00182"></a>00182 
<a name="l00183"></a>00183       <span class="comment">// Don&#39;t leave the parameter changed</span>
<a name="l00184"></a>00184       *parameters[i] = old_parameter;
<a name="l00185"></a>00185 
<a name="l00186"></a>00186       sensitivities[i] = partialq_partialp -
<a name="l00187"></a>00187                          partialR_partialp-&gt;dot(this-&gt;get_adjoint_solution());
<a name="l00188"></a>00188     }
<a name="l00189"></a>00189 
<a name="l00190"></a>00190   <span class="comment">// All parameters have been reset.</span>
<a name="l00191"></a>00191   <span class="comment">// Don&#39;t leave the qoi or system changed - principle of least</span>
<a name="l00192"></a>00192   <span class="comment">// surprise.</span>
<a name="l00193"></a>00193   this-&gt;assembly(<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l00194"></a>00194   this-&gt;rhs-&gt;close();
<a name="l00195"></a>00195   this-&gt;assemble_qoi();
<a name="l00196"></a>00196 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
