<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>diff_system.h</h1>  </div>
</div>
<div class="contents">
<a href="diff__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 <span class="comment">// $Id: diff_system.h 3414 2009-06-30 23:15:45Z roystgnr $</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00005"></a>00005 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00006"></a>00006   
<a name="l00007"></a>00007 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00008"></a>00008 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00009"></a>00009 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00010"></a>00010 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00011"></a>00011   
<a name="l00012"></a>00012 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00013"></a>00013 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00014"></a>00014 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00015"></a>00015 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00016"></a>00016   
<a name="l00017"></a>00017 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00018"></a>00018 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00019"></a>00019 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifndef __diff_system_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#define __diff_system_h__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;dense_matrix.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;dense_submatrix.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;dense_subvector.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;dense_vector.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="diff__context_8h.php">diff_context.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="linear__implicit__system_8h.php">linear_implicit_system.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="transient__system_8h.php">transient_system.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Forward Declarations</span>
<a name="l00038"></a>00038 <span class="keyword">class </span><a class="code" href="classTimeSolver.php">TimeSolver</a>;
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classNumericVector.php">NumericVector</a>;
<a name="l00041"></a>00041 
<a name="l00054"></a>00054 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00055"></a>00055 <span class="comment">// DifferentiableSystem class definition</span>
<a name="l00056"></a>00056 
<a name="l00057"></a><a class="code" href="classDifferentiableSystem.php">00057</a> <span class="keyword">class </span><a class="code" href="classDifferentiableSystem.php">DifferentiableSystem</a> : <span class="keyword">public</span> <a class="code" href="classImplicitSystem.php">ImplicitSystem</a>
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059 <span class="keyword">public</span>:
<a name="l00060"></a>00060 
<a name="l00065"></a>00065   <a class="code" href="classDifferentiableSystem.php#a7e66a8d68f94ed6b4a2a76fb2d15de4b">DifferentiableSystem</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00066"></a>00066                  <span class="keyword">const</span> std::string&amp; <a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>,
<a name="l00067"></a>00067                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">number</a>);
<a name="l00068"></a>00068 
<a name="l00072"></a>00072   <span class="keyword">virtual</span> <a class="code" href="classDifferentiableSystem.php#ac15d3cf6af13910d0b32226a0fdbf45a">~DifferentiableSystem</a> ();
<a name="l00073"></a>00073 
<a name="l00077"></a><a class="code" href="classDifferentiableSystem.php#ae2e56aec1c85c6aef914817f22d3e6f4">00077</a>   <span class="keyword">typedef</span> <a class="code" href="classDifferentiableSystem.php">DifferentiableSystem</a> <a class="code" href="classDifferentiableSystem.php#ae2e56aec1c85c6aef914817f22d3e6f4">sys_type</a>;
<a name="l00078"></a>00078 
<a name="l00082"></a><a class="code" href="classDifferentiableSystem.php#a13094f066281d2bebfe6499c12e62079">00082</a>   <span class="keyword">typedef</span> <a class="code" href="classImplicitSystem.php">ImplicitSystem</a> <a class="code" href="classDifferentiableSystem.php#a13094f066281d2bebfe6499c12e62079">Parent</a>;
<a name="l00083"></a>00083   
<a name="l00088"></a>00088   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDifferentiableSystem.php#a9072ddeb46f6a483595e93621a38d391">clear</a> ();
<a name="l00089"></a>00089 
<a name="l00094"></a>00094   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDifferentiableSystem.php#a1e8208241db74ae237f9d8490f489d20">reinit</a> ();
<a name="l00095"></a>00095    
<a name="l00100"></a>00100   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDifferentiableSystem.php#a13fdfacb2b04b10e4266444f1beb1fe2">assemble</a> ();
<a name="l00101"></a>00101 
<a name="l00105"></a>00105   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDifferentiableSystem.php#af2770154003897eef7c70a5318478393">assembly</a> (<span class="keywordtype">bool</span> get_residual, <span class="keywordtype">bool</span> get_jacobian) = 0;
<a name="l00106"></a>00106 
<a name="l00119"></a><a class="code" href="classDifferentiableSystem.php#a518a1763297cc2706185c539cc4fcec5">00119</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classDifferentiableSystem.php#a518a1763297cc2706185c539cc4fcec5">element_time_derivative</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00120"></a>00120                                         <a class="code" href="classDiffContext.php">DiffContext</a> &amp;) {
<a name="l00121"></a>00121     <span class="keywordflow">return</span> request_jacobian;
<a name="l00122"></a>00122   }
<a name="l00123"></a>00123 
<a name="l00136"></a><a class="code" href="classDifferentiableSystem.php#a516241801a3773a0c9d4a4b0d12de174">00136</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classDifferentiableSystem.php#a516241801a3773a0c9d4a4b0d12de174">element_constraint</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00137"></a>00137                                    <a class="code" href="classDiffContext.php">DiffContext</a> &amp;) {
<a name="l00138"></a>00138     <span class="keywordflow">return</span> request_jacobian;
<a name="l00139"></a>00139   }
<a name="l00140"></a>00140 
<a name="l00147"></a><a class="code" href="classDifferentiableSystem.php#ae412e18a407ba499d9e492facde2bb73">00147</a>   <span class="keywordtype">bool</span> <a class="code" href="classDifferentiableSystem.php#ae412e18a407ba499d9e492facde2bb73">compute_internal_sides</a>;
<a name="l00148"></a>00148 
<a name="l00160"></a><a class="code" href="classDifferentiableSystem.php#a990b76eb7ed84572c0384d90fe51fbaf">00160</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classDifferentiableSystem.php#a990b76eb7ed84572c0384d90fe51fbaf">side_time_derivative</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00161"></a>00161                                      <a class="code" href="classDiffContext.php">DiffContext</a> &amp;) {
<a name="l00162"></a>00162     <span class="keywordflow">return</span> request_jacobian;
<a name="l00163"></a>00163   }
<a name="l00164"></a>00164 
<a name="l00176"></a><a class="code" href="classDifferentiableSystem.php#a9520b686cc6181bff6888e0a96dd0c27">00176</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classDifferentiableSystem.php#a9520b686cc6181bff6888e0a96dd0c27">side_constraint</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00177"></a>00177                                 <a class="code" href="classDiffContext.php">DiffContext</a> &amp;) {
<a name="l00178"></a>00178     <span class="keywordflow">return</span> request_jacobian;
<a name="l00179"></a>00179   }
<a name="l00180"></a>00180 
<a name="l00185"></a>00185   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDifferentiableSystem.php#af9f2a03ed4fd292a711a46431c5d800f">postprocess</a> () = 0;
<a name="l00186"></a>00186 
<a name="l00192"></a><a class="code" href="classDifferentiableSystem.php#a18c9cb33536527dfd2de6d528ddac53b">00192</a>   <span class="keywordtype">bool</span> <a class="code" href="classDifferentiableSystem.php#a18c9cb33536527dfd2de6d528ddac53b">postprocess_sides</a>;
<a name="l00193"></a>00193 
<a name="l00199"></a><a class="code" href="classDifferentiableSystem.php#ae1f7058cb6e13a05fb26814863a9193b">00199</a>   <span class="keywordtype">bool</span> <a class="code" href="classDifferentiableSystem.php#ae1f7058cb6e13a05fb26814863a9193b">assemble_qoi_sides</a>;
<a name="l00200"></a>00200 
<a name="l00204"></a><a class="code" href="classDifferentiableSystem.php#a12f0464741acd101c4492e174e3e4c42">00204</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDifferentiableSystem.php#a12f0464741acd101c4492e174e3e4c42">element_postprocess</a> (<a class="code" href="classDiffContext.php">DiffContext</a> &amp;) {}
<a name="l00205"></a>00205  
<a name="l00210"></a><a class="code" href="classDifferentiableSystem.php#a5f65430b3abb73725ce9921ed980d6a5">00210</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDifferentiableSystem.php#a5f65430b3abb73725ce9921ed980d6a5">side_postprocess</a> (<a class="code" href="classDiffContext.php">DiffContext</a> &amp;) {}
<a name="l00211"></a>00211  
<a name="l00216"></a><a class="code" href="classDifferentiableSystem.php#a3e088a59d3fa7989b85d9250492e98c7">00216</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDifferentiableSystem.php#a3e088a59d3fa7989b85d9250492e98c7">element_qoi</a> (<a class="code" href="classDiffContext.php">DiffContext</a> &amp;) {}
<a name="l00217"></a>00217  
<a name="l00222"></a><a class="code" href="classDifferentiableSystem.php#ac0d9e6dba8bae252e04fde5b618c9ee8">00222</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDifferentiableSystem.php#ac0d9e6dba8bae252e04fde5b618c9ee8">element_qoi_derivative</a> (<a class="code" href="classDiffContext.php">DiffContext</a> &amp;) {}
<a name="l00223"></a>00223  
<a name="l00228"></a><a class="code" href="classDifferentiableSystem.php#acc54a0b5205d6f09e76a729f71952edd">00228</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDifferentiableSystem.php#acc54a0b5205d6f09e76a729f71952edd">side_qoi</a> (<a class="code" href="classDiffContext.php">DiffContext</a> &amp;) {}
<a name="l00229"></a>00229  
<a name="l00235"></a><a class="code" href="classDifferentiableSystem.php#a91191d2563c42c9512c1dce6d431025b">00235</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDifferentiableSystem.php#a91191d2563c42c9512c1dce6d431025b">side_qoi_derivative</a> (<a class="code" href="classDiffContext.php">DiffContext</a> &amp;) {}
<a name="l00236"></a>00236  
<a name="l00248"></a><a class="code" href="classDifferentiableSystem.php#a5e69fc9aa17d53f9f3ceaf0c6ddc4f78">00248</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDifferentiableSystem.php#a5e69fc9aa17d53f9f3ceaf0c6ddc4f78">time_evolving</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var) {
<a name="l00249"></a>00249     libmesh_assert(<a class="code" href="classDifferentiableSystem.php#a457f7ba8b9e434c07935e23d33c41cc4">_time_evolving</a>.size() &gt; var);
<a name="l00250"></a>00250     <a class="code" href="classDifferentiableSystem.php#a457f7ba8b9e434c07935e23d33c41cc4">_time_evolving</a>[var] = <span class="keyword">true</span>;
<a name="l00251"></a>00251   }
<a name="l00252"></a>00252 
<a name="l00261"></a><a class="code" href="classDifferentiableSystem.php#a6d3a069bc2476e64954fd7dd9f4a6ead">00261</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classDifferentiableSystem.php#a6d3a069bc2476e64954fd7dd9f4a6ead">eulerian_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00262"></a>00262                                   <a class="code" href="classDiffContext.php">DiffContext</a> &amp;) {
<a name="l00263"></a>00263     <span class="keywordflow">return</span> request_jacobian;
<a name="l00264"></a>00264   }
<a name="l00265"></a>00265 
<a name="l00277"></a><a class="code" href="classDifferentiableSystem.php#aa69fa37b59f37a015d907d9833a4d053">00277</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classDifferentiableSystem.php#aa69fa37b59f37a015d907d9833a4d053">mass_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00278"></a>00278                               <a class="code" href="classDiffContext.php">DiffContext</a> &amp;) {
<a name="l00279"></a>00279     <span class="keywordflow">return</span> request_jacobian;
<a name="l00280"></a>00280   }
<a name="l00281"></a>00281 
<a name="l00294"></a><a class="code" href="classDifferentiableSystem.php#a5c1dd0b32156465b148fc35ca29d70e8">00294</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classDifferentiableSystem.php#a5c1dd0b32156465b148fc35ca29d70e8">side_mass_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00295"></a>00295                                    <a class="code" href="classDiffContext.php">DiffContext</a> &amp;) {
<a name="l00296"></a>00296     <span class="keywordflow">return</span> request_jacobian;
<a name="l00297"></a>00297   }
<a name="l00298"></a>00298 
<a name="l00307"></a>00307   <span class="keyword">virtual</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DiffContext&gt;</a> <a class="code" href="classDifferentiableSystem.php#a8ce5ce27069dd193ede7bb1005b2425a">build_context</a>();
<a name="l00308"></a>00308 
<a name="l00309"></a>00309   <span class="comment">/*</span>
<a name="l00310"></a>00310 <span class="comment">   * Prepares the result of a build_context() call for use.</span>
<a name="l00311"></a>00311 <span class="comment">   * </span>
<a name="l00312"></a>00312 <span class="comment">   * Most FEMSystem-based problems will need to reimplement this in order to</span>
<a name="l00313"></a>00313 <span class="comment">   * call FE::get_*() as their particular physics requires.</span>
<a name="l00314"></a>00314 <span class="comment">   */</span>
<a name="l00315"></a><a class="code" href="classDifferentiableSystem.php#a177812e4bc63042f07a008161ab29b86">00315</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDifferentiableSystem.php#a177812e4bc63042f07a008161ab29b86">init_context</a>(<a class="code" href="classDiffContext.php">DiffContext</a> &amp;) {}
<a name="l00316"></a>00316  
<a name="l00322"></a>00322   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDifferentiableSystem.php#afe25c7be93c504e4505de2f5b3da7dc9">solve</a> ();
<a name="l00323"></a>00323  
<a name="l00331"></a>00331   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDifferentiableSystem.php#a72627af86f19c8a43bdeec9f8ec49b64">adjoint_solve</a> ();
<a name="l00332"></a>00332 
<a name="l00344"></a>00344   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDifferentiableSystem.php#ade211173ed9d7afb4dde0a156881c73a">qoi_parameter_sensitivity</a> (std::vector&lt;Number *&gt;&amp; parameters,
<a name="l00345"></a>00345                                           std::vector&lt;Number&gt;&amp; sensitivities);
<a name="l00346"></a>00346  
<a name="l00351"></a><a class="code" href="classDifferentiableSystem.php#a0dab4aeae88234a06d041519b219fbc4">00351</a>   <a class="code" href="classAutoPtr.php">AutoPtr&lt;TimeSolver&gt;</a> <a class="code" href="classDifferentiableSystem.php#a0dab4aeae88234a06d041519b219fbc4">time_solver</a>;
<a name="l00352"></a>00352 
<a name="l00359"></a><a class="code" href="classDifferentiableSystem.php#a011fade55c7e62bea01e1e195a9d78b1">00359</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDifferentiableSystem.php#a011fade55c7e62bea01e1e195a9d78b1">time</a>;
<a name="l00360"></a>00360 
<a name="l00365"></a><a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">00365</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a>;
<a name="l00366"></a>00366 
<a name="l00371"></a><a class="code" href="classDifferentiableSystem.php#a43462955105f77ba4d0e9f676658d975">00371</a>   <span class="keywordtype">bool</span> <a class="code" href="classDifferentiableSystem.php#a43462955105f77ba4d0e9f676658d975">print_solution_norms</a>;
<a name="l00372"></a>00372 
<a name="l00377"></a><a class="code" href="classDifferentiableSystem.php#aaa5c109a92a60968afd1fad729342563">00377</a>   <span class="keywordtype">bool</span> <a class="code" href="classDifferentiableSystem.php#aaa5c109a92a60968afd1fad729342563">print_solutions</a>;
<a name="l00378"></a>00378 
<a name="l00382"></a><a class="code" href="classDifferentiableSystem.php#aad66358e9d4cee14b2bad49234e95b85">00382</a>   <span class="keywordtype">bool</span> <a class="code" href="classDifferentiableSystem.php#aad66358e9d4cee14b2bad49234e95b85">print_residual_norms</a>;
<a name="l00383"></a>00383 
<a name="l00387"></a><a class="code" href="classDifferentiableSystem.php#a759d8b336a87cb9ca16b92a0129a72b0">00387</a>   <span class="keywordtype">bool</span> <a class="code" href="classDifferentiableSystem.php#a759d8b336a87cb9ca16b92a0129a72b0">print_residuals</a>;
<a name="l00388"></a>00388 
<a name="l00392"></a><a class="code" href="classDifferentiableSystem.php#a05ef6936334fcd8da39c5521d7728c16">00392</a>   <span class="keywordtype">bool</span> <a class="code" href="classDifferentiableSystem.php#a05ef6936334fcd8da39c5521d7728c16">print_jacobian_norms</a>;
<a name="l00393"></a>00393 
<a name="l00397"></a><a class="code" href="classDifferentiableSystem.php#a34062be5513df753b1d7cc6ef2954f34">00397</a>   <span class="keywordtype">bool</span> <a class="code" href="classDifferentiableSystem.php#a34062be5513df753b1d7cc6ef2954f34">print_jacobians</a>;
<a name="l00398"></a>00398 
<a name="l00402"></a><a class="code" href="classDifferentiableSystem.php#a405d284eba03efd74d02b11121958af1">00402</a>   <span class="keywordtype">bool</span> <a class="code" href="classDifferentiableSystem.php#a405d284eba03efd74d02b11121958af1">print_element_jacobians</a>;
<a name="l00403"></a>00403 
<a name="l00411"></a><a class="code" href="classDifferentiableSystem.php#a3e9645837798cc7d10d127b9ce54b0e1">00411</a>   <span class="keywordtype">bool</span> <a class="code" href="classDifferentiableSystem.php#a3e9645837798cc7d10d127b9ce54b0e1">use_fixed_solution</a>;
<a name="l00412"></a>00412 
<a name="l00413"></a>00413 <span class="keyword">protected</span>:
<a name="l00418"></a>00418   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDifferentiableSystem.php#a4fe36b066e7b028d6403a858ec75fa1d">init_data</a> ();
<a name="l00419"></a>00419 
<a name="l00424"></a><a class="code" href="classDifferentiableSystem.php#a457f7ba8b9e434c07935e23d33c41cc4">00424</a>   std::vector&lt;bool&gt; <a class="code" href="classDifferentiableSystem.php#a457f7ba8b9e434c07935e23d33c41cc4">_time_evolving</a>;
<a name="l00425"></a>00425 };
<a name="l00426"></a>00426 
<a name="l00427"></a>00427 
<a name="l00428"></a>00428 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
