<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_f10759d5ac6297fe611079c3c15b8f2c.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>distributed_vector.C</h1>  </div>
</div>
<div class="contents">
<a href="distributed__vector_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: distributed_vector.C 3466 2009-09-17 18:01:17Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// C++ includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;cmath&gt;</span> <span class="comment">// for std::abs</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;distributed_vector.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;dense_vector.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;dense_subvector.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;parallel.h&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">//--------------------------------------------------------------------------</span>
<a name="l00036"></a>00036 <span class="comment">// DistributedVector methods</span>
<a name="l00037"></a>00037 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00038"></a><a class="code" href="classDistributedVector.php#ae97f9cb8f5d691754926c2bb6ac2f463">00038</a> T <a class="code" href="classDistributedVector.php#ae97f9cb8f5d691754926c2bb6ac2f463">DistributedVector&lt;T&gt;::sum</a> ()<span class="keyword"> const</span>
<a name="l00039"></a>00039 <span class="keyword"></span>{
<a name="l00040"></a>00040   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00041"></a>00041   parallel_only();
<a name="l00042"></a>00042 
<a name="l00043"></a>00043   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00044"></a>00044   libmesh_assert (_values.size() == _local_size);
<a name="l00045"></a>00045   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00046"></a>00046 
<a name="l00047"></a>00047   T local_sum = 0.;
<a name="l00048"></a>00048 
<a name="l00049"></a>00049   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;local_size(); i++)
<a name="l00050"></a>00050     local_sum += _values[i];
<a name="l00051"></a>00051   
<a name="l00052"></a>00052   Parallel::sum(local_sum);
<a name="l00053"></a>00053 
<a name="l00054"></a>00054   <span class="keywordflow">return</span> local_sum;
<a name="l00055"></a>00055 }
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00060"></a><a class="code" href="classDistributedVector.php#a205d2c517ba74d12e6d937af21d811d2">00060</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDistributedVector.php#a205d2c517ba74d12e6d937af21d811d2">DistributedVector&lt;T&gt;::l1_norm</a> ()<span class="keyword"> const</span>
<a name="l00061"></a>00061 <span class="keyword"></span>{
<a name="l00062"></a>00062   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00063"></a>00063   parallel_only();
<a name="l00064"></a>00064 
<a name="l00065"></a>00065   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00066"></a>00066   libmesh_assert (_values.size() == _local_size);
<a name="l00067"></a>00067   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   <span class="keywordtype">double</span> local_l1 = 0.;
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;local_size(); i++)
<a name="l00072"></a>00072     local_l1 += std::abs(_values[i]);
<a name="l00073"></a>00073   
<a name="l00074"></a>00074   Parallel::sum(local_l1);
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <span class="keywordflow">return</span> local_l1;
<a name="l00077"></a>00077 }
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00082"></a><a class="code" href="classDistributedVector.php#a2e615b26df8a90c2d719da69f1465a26">00082</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDistributedVector.php#a2e615b26df8a90c2d719da69f1465a26">DistributedVector&lt;T&gt;::l2_norm</a> ()<span class="keyword"> const</span>
<a name="l00083"></a>00083 <span class="keyword"></span>{
<a name="l00084"></a>00084   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00085"></a>00085   parallel_only();
<a name="l00086"></a>00086 
<a name="l00087"></a>00087   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00088"></a>00088   libmesh_assert (_values.size() == _local_size);
<a name="l00089"></a>00089   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00090"></a>00090 
<a name="l00091"></a>00091   <span class="keywordtype">double</span> local_l2 = 0.;
<a name="l00092"></a>00092   
<a name="l00093"></a>00093   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;local_size(); i++)
<a name="l00094"></a>00094     local_l2 += <a class="code" href="libmesh__common_8h.php#af9cdd07341b53cc644199f6aec5e1420">libmesh_norm</a>(_values[i]);
<a name="l00095"></a>00095   
<a name="l00096"></a>00096   Parallel::sum(local_l2);
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   <span class="keywordflow">return</span> std::sqrt(local_l2);
<a name="l00099"></a>00099 }
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00104"></a><a class="code" href="classDistributedVector.php#a35a1523920f97781725294c62235788f">00104</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDistributedVector.php#a35a1523920f97781725294c62235788f">DistributedVector&lt;T&gt;::linfty_norm</a> ()<span class="keyword"> const</span>
<a name="l00105"></a>00105 <span class="keyword"></span>{
<a name="l00106"></a>00106   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00107"></a>00107   parallel_only();
<a name="l00108"></a>00108 
<a name="l00109"></a>00109   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00110"></a>00110   libmesh_assert (_values.size() == _local_size);
<a name="l00111"></a>00111   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00112"></a>00112 
<a name="l00113"></a>00113   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> local_linfty = 0.;
<a name="l00114"></a>00114   
<a name="l00115"></a>00115   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;local_size(); i++)
<a name="l00116"></a>00116     local_linfty  = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(local_linfty,
<a name="l00117"></a>00117                              static_cast&lt;Real&gt;(std::abs(_values[i]))
<a name="l00118"></a>00118                              ); <span class="comment">// Note we static_cast so that both</span>
<a name="l00119"></a>00119                                 <span class="comment">// types are the same, as required</span>
<a name="l00120"></a>00120                                 <span class="comment">// by std::max</span>
<a name="l00121"></a>00121   
<a name="l00122"></a>00122   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(local_linfty);
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <span class="keywordflow">return</span> local_linfty;
<a name="l00125"></a>00125 }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00130"></a><a class="code" href="classDistributedVector.php#af84ea090f4cf4b8f19201471d63cad1e">00130</a> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; <a class="code" href="classDistributedVector.php#af84ea090f4cf4b8f19201471d63cad1e">DistributedVector&lt;T&gt;::operator += </a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v)
<a name="l00131"></a>00131 {
<a name="l00132"></a>00132   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00133"></a>00133   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00134"></a>00134   libmesh_assert (_values.size() == _local_size);
<a name="l00135"></a>00135   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00136"></a>00136   
<a name="l00137"></a>00137   add(1., v);
<a name="l00138"></a>00138   
<a name="l00139"></a>00139   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00140"></a>00140 }
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00145"></a><a class="code" href="classDistributedVector.php#a0f9bc1bf33631ed1b55be031185fef0f">00145</a> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; <a class="code" href="classDistributedVector.php#a0f9bc1bf33631ed1b55be031185fef0f">DistributedVector&lt;T&gt;::operator -= </a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v)
<a name="l00146"></a>00146 {
<a name="l00147"></a>00147   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00148"></a>00148   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00149"></a>00149   libmesh_assert (_values.size() == _local_size);
<a name="l00150"></a>00150   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00151"></a>00151   
<a name="l00152"></a>00152   add(-1., v);
<a name="l00153"></a>00153   
<a name="l00154"></a>00154   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00155"></a>00155 }
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00160"></a><a class="code" href="classDistributedVector.php#a0dca4b17bc440a4447796348b001decd">00160</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a0dca4b17bc440a4447796348b001decd">DistributedVector&lt;T&gt;::add_vector</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00161"></a>00161                                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00162"></a>00162 {
<a name="l00163"></a>00163   libmesh_assert (!v.empty());
<a name="l00164"></a>00164   libmesh_assert (v.size() == dof_indices.size());
<a name="l00165"></a>00165   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00166"></a>00166   libmesh_assert (_values.size() == _local_size);
<a name="l00167"></a>00167   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00168"></a>00168   
<a name="l00169"></a>00169   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l00170"></a>00170     add (dof_indices[i], v[i]);
<a name="l00171"></a>00171 }
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00176"></a><a class="code" href="classDistributedVector.php#a4d7dea9210a48051a4a04041f039e184">00176</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a0dca4b17bc440a4447796348b001decd">DistributedVector&lt;T&gt;::add_vector</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00177"></a>00177                                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00178"></a>00178 {
<a name="l00179"></a>00179   libmesh_assert (V.<a class="code" href="classNumericVector.php#ae21bc89e89e895ac26b851a31926e194">size</a>() == dof_indices.size());
<a name="l00180"></a>00180   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00181"></a>00181   libmesh_assert (_values.size() == _local_size);
<a name="l00182"></a>00182   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00183"></a>00183 
<a name="l00184"></a>00184   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classNumericVector.php#ae21bc89e89e895ac26b851a31926e194">size</a>(); i++)
<a name="l00185"></a>00185     add (dof_indices[i], V(i));
<a name="l00186"></a>00186 }
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00191"></a><a class="code" href="classDistributedVector.php#a13060d198d0b967a452990b3a926f0c4">00191</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a0dca4b17bc440a4447796348b001decd">DistributedVector&lt;T&gt;::add_vector</a> (<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00192"></a>00192                                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00193"></a>00193 {
<a name="l00194"></a>00194   libmesh_assert (V.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>() == dof_indices.size());
<a name="l00195"></a>00195   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00196"></a>00196   libmesh_assert (_values.size() == _local_size);
<a name="l00197"></a>00197   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00198"></a>00198 
<a name="l00199"></a>00199   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>(); i++)
<a name="l00200"></a>00200     add (dof_indices[i], V(i));
<a name="l00201"></a>00201 }
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00206"></a><a class="code" href="classDistributedVector.php#ac33f585fb9a12c93478b5e9308f8c91c">00206</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a978b40c4470e61bd9f61baa69c64a9b8">DistributedVector&lt;T&gt;::add</a> (<span class="keyword">const</span> T v)
<a name="l00207"></a>00207 {
<a name="l00208"></a>00208   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00209"></a>00209   libmesh_assert (_values.size() == _local_size);
<a name="l00210"></a>00210   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00211"></a>00211 
<a name="l00212"></a>00212   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;local_size(); i++)
<a name="l00213"></a>00213     _values[i] += v;
<a name="l00214"></a>00214 }
<a name="l00215"></a>00215 
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00219"></a><a class="code" href="classDistributedVector.php#acf3263559e5d6fe8d835ffc184be56a4">00219</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a978b40c4470e61bd9f61baa69c64a9b8">DistributedVector&lt;T&gt;::add</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v)
<a name="l00220"></a>00220 {
<a name="l00221"></a>00221   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00222"></a>00222   libmesh_assert (_values.size() == _local_size);
<a name="l00223"></a>00223   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00224"></a>00224 
<a name="l00225"></a>00225   add (1., v);
<a name="l00226"></a>00226 }
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00231"></a><a class="code" href="classDistributedVector.php#a96cc670d459a1f935ce09c6d26879f66">00231</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a978b40c4470e61bd9f61baa69c64a9b8">DistributedVector&lt;T&gt;::add</a> (<span class="keyword">const</span> T a, <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v)
<a name="l00232"></a>00232 {
<a name="l00233"></a>00233   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00234"></a>00234   libmesh_assert (_values.size() == _local_size);
<a name="l00235"></a>00235   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00236"></a>00236 
<a name="l00237"></a>00237   add(a, v);
<a name="l00238"></a>00238 }
<a name="l00239"></a>00239 
<a name="l00240"></a>00240 
<a name="l00241"></a>00241 
<a name="l00242"></a>00242 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00243"></a><a class="code" href="classDistributedVector.php#a767eeb6fb229ffab133521d3a318b55d">00243</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a767eeb6fb229ffab133521d3a318b55d">DistributedVector&lt;T&gt;::insert</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00244"></a>00244                                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00245"></a>00245 {
<a name="l00246"></a>00246   libmesh_assert (!v.empty());
<a name="l00247"></a>00247   libmesh_assert (v.size() == dof_indices.size());
<a name="l00248"></a>00248   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00249"></a>00249   libmesh_assert (_values.size() == _local_size);
<a name="l00250"></a>00250   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00251"></a>00251   
<a name="l00252"></a>00252   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l00253"></a>00253     this-&gt;<span class="keyword">set</span> (dof_indices[i], v[i]);
<a name="l00254"></a>00254 }
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 
<a name="l00257"></a>00257 
<a name="l00258"></a>00258 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00259"></a><a class="code" href="classDistributedVector.php#a0039b784c1a95320befa54a7ae12df7f">00259</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a767eeb6fb229ffab133521d3a318b55d">DistributedVector&lt;T&gt;::insert</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00260"></a>00260                                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00261"></a>00261 {
<a name="l00262"></a>00262   libmesh_assert (V.<a class="code" href="classNumericVector.php#ae21bc89e89e895ac26b851a31926e194">size</a>() == dof_indices.size());
<a name="l00263"></a>00263   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00264"></a>00264   libmesh_assert (_values.size() == _local_size);
<a name="l00265"></a>00265   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00266"></a>00266 
<a name="l00267"></a>00267   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classNumericVector.php#ae21bc89e89e895ac26b851a31926e194">size</a>(); i++)
<a name="l00268"></a>00268     this-&gt;<span class="keyword">set</span> (dof_indices[i], V(i));
<a name="l00269"></a>00269 }
<a name="l00270"></a>00270 
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 
<a name="l00273"></a>00273 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00274"></a><a class="code" href="classDistributedVector.php#a7221603d76a28655783e1314fd14d914">00274</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a767eeb6fb229ffab133521d3a318b55d">DistributedVector&lt;T&gt;::insert</a> (<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00275"></a>00275                                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00276"></a>00276 {
<a name="l00277"></a>00277   libmesh_assert (V.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>() == dof_indices.size());
<a name="l00278"></a>00278   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00279"></a>00279   libmesh_assert (_values.size() == _local_size);
<a name="l00280"></a>00280   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00281"></a>00281 
<a name="l00282"></a>00282   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>(); i++)
<a name="l00283"></a>00283     this-&gt;<span class="keyword">set</span> (dof_indices[i], V(i));
<a name="l00284"></a>00284 }
<a name="l00285"></a>00285 
<a name="l00286"></a>00286 
<a name="l00287"></a>00287 
<a name="l00288"></a>00288 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00289"></a><a class="code" href="classDistributedVector.php#a33165b697f34be89971f3301e0ce5cd8">00289</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a767eeb6fb229ffab133521d3a318b55d">DistributedVector&lt;T&gt;::insert</a> (<span class="keyword">const</span> <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;T&gt;</a>&amp; V,
<a name="l00290"></a>00290                                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00291"></a>00291 {
<a name="l00292"></a>00292   libmesh_assert (V.<a class="code" href="classDenseVectorBase.php#af27a452cf8a2a5ec845e040c85761572">size</a>() == dof_indices.size());
<a name="l00293"></a>00293   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00294"></a>00294   libmesh_assert (_values.size() == _local_size);
<a name="l00295"></a>00295   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00296"></a>00296 
<a name="l00297"></a>00297   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classDenseVectorBase.php#af27a452cf8a2a5ec845e040c85761572">size</a>(); i++)
<a name="l00298"></a>00298     this-&gt;<span class="keyword">set</span> (dof_indices[i], V(i));
<a name="l00299"></a>00299 }
<a name="l00300"></a>00300 
<a name="l00301"></a>00301 
<a name="l00302"></a>00302 
<a name="l00303"></a>00303 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00304"></a><a class="code" href="classDistributedVector.php#adf3d0121e4e7c7f96659f2a15416679e">00304</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#adf3d0121e4e7c7f96659f2a15416679e">DistributedVector&lt;T&gt;::scale</a> (<span class="keyword">const</span> T factor)
<a name="l00305"></a>00305 {
<a name="l00306"></a>00306   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00307"></a>00307   libmesh_assert (_values.size() == _local_size);
<a name="l00308"></a>00308   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00309"></a>00309 
<a name="l00310"></a>00310   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;local_size(); i++)
<a name="l00311"></a>00311     _values[i] *= factor;  
<a name="l00312"></a>00312 }
<a name="l00313"></a>00313 
<a name="l00314"></a>00314 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00315"></a><a class="code" href="classDistributedVector.php#a8740c844ac11f34696b9c2d161eb5ed8">00315</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a8740c844ac11f34696b9c2d161eb5ed8">DistributedVector&lt;T&gt;::abs</a>()
<a name="l00316"></a>00316 {
<a name="l00317"></a>00317   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00318"></a>00318   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00319"></a>00319 
<a name="l00320"></a>00320   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;local_size(); i++)
<a name="l00321"></a>00321     this-&gt;<span class="keyword">set</span>(i,std::abs(_values[i]));
<a name="l00322"></a>00322 }
<a name="l00323"></a>00323 
<a name="l00324"></a>00324 
<a name="l00325"></a>00325 
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00329"></a><a class="code" href="classDistributedVector.php#ac84fb8f1ba586b3b514bf109b819e12c">00329</a> T <a class="code" href="classDistributedVector.php#ac84fb8f1ba586b3b514bf109b819e12c">DistributedVector&lt;T&gt;::dot</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; V)<span class="keyword"> const</span>
<a name="l00330"></a>00330 <span class="keyword"></span>{
<a name="l00331"></a>00331   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00332"></a>00332   parallel_only();
<a name="l00333"></a>00333 
<a name="l00334"></a>00334   <span class="comment">// Make sure the NumericVector passed in is really a DistributedVector</span>
<a name="l00335"></a>00335   <span class="keyword">const</span> <a class="code" href="classDistributedVector.php">DistributedVector&lt;T&gt;</a>* v = libmesh_cast_ptr&lt;const DistributedVector&lt;T&gt;*&gt;(&amp;V);
<a name="l00336"></a>00336 
<a name="l00337"></a>00337   <span class="comment">// Make sure that the two vectors are distributed in the same way.</span>
<a name="l00338"></a>00338   libmesh_assert ( this-&gt;first_local_index() == v-&gt;<a class="code" href="classDistributedVector.php#aa4edb69f0f9c1269375f9b395243e772">first_local_index</a>() );
<a name="l00339"></a>00339   libmesh_assert ( this-&gt;last_local_index()  == v-&gt;<a class="code" href="classDistributedVector.php#a39c2dcd617ef30d1d696fca05bef6341">last_local_index</a>()  );
<a name="l00340"></a>00340   
<a name="l00341"></a>00341   <span class="comment">// The result of dotting together the local parts of the vector.</span>
<a name="l00342"></a>00342   T local_dot = 0;
<a name="l00343"></a>00343 
<a name="l00344"></a>00344   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;local_size(); i++)
<a name="l00345"></a>00345     local_dot += this-&gt;_values[i] * v-&gt;<a class="code" href="classDistributedVector.php#ace6b6b6829d5dccfe3cd40b26d905b6b">_values</a>[i];
<a name="l00346"></a>00346 
<a name="l00347"></a>00347   <span class="comment">// The local dot products are now summed via MPI</span>
<a name="l00348"></a>00348   Parallel::sum(local_dot);
<a name="l00349"></a>00349 
<a name="l00350"></a>00350   <span class="keywordflow">return</span> local_dot;
<a name="l00351"></a>00351 } 
<a name="l00352"></a>00352 
<a name="l00353"></a>00353 
<a name="l00354"></a>00354 
<a name="l00355"></a>00355 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00356"></a>00356 <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; 
<a name="l00357"></a><a class="code" href="classDistributedVector.php#a7bccc62719c23527b1986bb7698121d2">00357</a> <a class="code" href="classDistributedVector.php#a7bccc62719c23527b1986bb7698121d2">DistributedVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> T s)
<a name="l00358"></a>00358 {
<a name="l00359"></a>00359   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00360"></a>00360   libmesh_assert (_values.size() == _local_size);
<a name="l00361"></a>00361   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00362"></a>00362 
<a name="l00363"></a>00363   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;local_size(); i++)
<a name="l00364"></a>00364     _values[i] = s;
<a name="l00365"></a>00365   
<a name="l00366"></a>00366   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00367"></a>00367 }
<a name="l00368"></a>00368 
<a name="l00369"></a>00369 
<a name="l00370"></a>00370 
<a name="l00371"></a>00371 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00372"></a>00372 <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;
<a name="l00373"></a><a class="code" href="classDistributedVector.php#ac40f9d855f53403496fd49bd5e5395ac">00373</a> <a class="code" href="classDistributedVector.php#a7bccc62719c23527b1986bb7698121d2">DistributedVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_in)
<a name="l00374"></a>00374 {
<a name="l00375"></a>00375   <span class="comment">// Make sure the NumericVector passed in is really a DistributedVector</span>
<a name="l00376"></a>00376   <span class="keyword">const</span> <a class="code" href="classDistributedVector.php">DistributedVector&lt;T&gt;</a>* v = libmesh_cast_ptr&lt;const DistributedVector&lt;T&gt;*&gt;(&amp;v_in);
<a name="l00377"></a>00377   
<a name="l00378"></a>00378   *<span class="keyword">this</span> = *v;
<a name="l00379"></a>00379   
<a name="l00380"></a>00380   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00381"></a>00381 }
<a name="l00382"></a>00382 
<a name="l00383"></a>00383 
<a name="l00384"></a>00384 
<a name="l00385"></a>00385 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00386"></a>00386 <a class="code" href="classDistributedVector.php">DistributedVector&lt;T&gt;</a>&amp;
<a name="l00387"></a><a class="code" href="classDistributedVector.php#ad9b2bd3ddb224d8a1cfe6db0ca4d5e78">00387</a> <a class="code" href="classDistributedVector.php#a7bccc62719c23527b1986bb7698121d2">DistributedVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> <a class="code" href="classDistributedVector.php">DistributedVector&lt;T&gt;</a>&amp; v)
<a name="l00388"></a>00388 {
<a name="l00389"></a>00389   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a>    = v.<a class="code" href="classNumericVector.php#ac4a667077b6ec42b9a35a9aed43fc92e">_is_initialized</a>;
<a name="l00390"></a>00390   this-&gt;_is_closed         = v.<a class="code" href="classNumericVector.php#a5fb110426b9570de8690d317424a310b">_is_closed</a>;
<a name="l00391"></a>00391 
<a name="l00392"></a>00392   _global_size       = v.<a class="code" href="classDistributedVector.php#af1cbdb64d6640e9610911751c51a59dc">_global_size</a>;
<a name="l00393"></a>00393   _local_size        = v.<a class="code" href="classDistributedVector.php#a1f541d4c59a29debfcd06fc363bc8f38">_local_size</a>;
<a name="l00394"></a>00394   _first_local_index = v.<a class="code" href="classDistributedVector.php#a25389a27877969170e40e0014eac27c7">_first_local_index</a>;
<a name="l00395"></a>00395   _last_local_index  = v.<a class="code" href="classDistributedVector.php#a598071bc263849c6922f66d1975ac613">_last_local_index</a>;
<a name="l00396"></a>00396   
<a name="l00397"></a>00397   <span class="keywordflow">if</span> (v.<a class="code" href="classDistributedVector.php#a2ab30ea1f0a79c3e3e67dff5c87f3659">local_size</a>() == this-&gt;local_size())
<a name="l00398"></a>00398     {
<a name="l00399"></a>00399       _values = v.<a class="code" href="classDistributedVector.php#ace6b6b6829d5dccfe3cd40b26d905b6b">_values</a>;
<a name="l00400"></a>00400     }
<a name="l00401"></a>00401   <span class="keywordflow">else</span>
<a name="l00402"></a>00402     {
<a name="l00403"></a>00403       libmesh_error();
<a name="l00404"></a>00404     }
<a name="l00405"></a>00405   
<a name="l00406"></a>00406   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00407"></a>00407 }
<a name="l00408"></a>00408 
<a name="l00409"></a>00409 
<a name="l00410"></a>00410 
<a name="l00411"></a>00411 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00412"></a>00412 <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;
<a name="l00413"></a><a class="code" href="classDistributedVector.php#a955191292c63bfcc550a6a0d30ae97e1">00413</a> <a class="code" href="classDistributedVector.php#a7bccc62719c23527b1986bb7698121d2">DistributedVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v)
<a name="l00414"></a>00414 {
<a name="l00415"></a>00415   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00416"></a>00416   libmesh_assert (_values.size() == _local_size);
<a name="l00417"></a>00417   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00418"></a>00418 
<a name="l00419"></a>00419   <span class="keywordflow">if</span> (v.size() == local_size())
<a name="l00420"></a>00420     _values = v;
<a name="l00421"></a>00421 
<a name="l00422"></a>00422   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (v.size() == size())
<a name="l00423"></a>00423     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=first_local_index(); i&lt;last_local_index(); i++)
<a name="l00424"></a>00424       _values[i-first_local_index()] = v[i];
<a name="l00425"></a>00425 
<a name="l00426"></a>00426   <span class="keywordflow">else</span>
<a name="l00427"></a>00427     {
<a name="l00428"></a>00428       libmesh_error();
<a name="l00429"></a>00429     }
<a name="l00430"></a>00430 
<a name="l00431"></a>00431   
<a name="l00432"></a>00432   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00433"></a>00433 }
<a name="l00434"></a>00434 
<a name="l00435"></a>00435 
<a name="l00436"></a>00436 
<a name="l00437"></a>00437 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00438"></a><a class="code" href="classDistributedVector.php#aa5dfed55524e8935f8d0cab2216b826d">00438</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a3ccd4d2718bbbccdcfe5b55607ca87d5">DistributedVector&lt;T&gt;::localize</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local_in)<span class="keyword"> const</span>
<a name="l00439"></a>00439 <span class="keyword"></span>
<a name="l00440"></a>00440 <span class="keyword"></span>{
<a name="l00441"></a>00441   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00442"></a>00442   libmesh_assert (_values.size() == _local_size);
<a name="l00443"></a>00443   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00444"></a>00444 
<a name="l00445"></a>00445   <a class="code" href="classDistributedVector.php">DistributedVector&lt;T&gt;</a>* v_local = libmesh_cast_ptr&lt;DistributedVector&lt;T&gt;*&gt;(&amp;v_local_in);
<a name="l00446"></a>00446 
<a name="l00447"></a>00447   v_local-&gt;<a class="code" href="classDistributedVector.php#a25389a27877969170e40e0014eac27c7">_first_local_index</a> = 0;
<a name="l00448"></a>00448   
<a name="l00449"></a>00449   v_local-&gt;<a class="code" href="classDistributedVector.php#af1cbdb64d6640e9610911751c51a59dc">_global_size</a> =
<a name="l00450"></a>00450     v_local-&gt;<a class="code" href="classDistributedVector.php#a1f541d4c59a29debfcd06fc363bc8f38">_local_size</a> =
<a name="l00451"></a>00451     v_local-&gt;<a class="code" href="classDistributedVector.php#a598071bc263849c6922f66d1975ac613">_last_local_index</a> = size();
<a name="l00452"></a>00452 
<a name="l00453"></a>00453   v_local-&gt;<a class="code" href="classNumericVector.php#ac4a667077b6ec42b9a35a9aed43fc92e">_is_initialized</a> =
<a name="l00454"></a>00454     v_local-&gt;<a class="code" href="classNumericVector.php#a5fb110426b9570de8690d317424a310b">_is_closed</a> = <span class="keyword">true</span>;
<a name="l00455"></a>00455   
<a name="l00456"></a>00456   <span class="comment">// Call localize on the vector&#39;s values.  This will help</span>
<a name="l00457"></a>00457   <span class="comment">// prevent code duplication</span>
<a name="l00458"></a>00458   localize (v_local-&gt;<a class="code" href="classDistributedVector.php#ace6b6b6829d5dccfe3cd40b26d905b6b">_values</a>);    
<a name="l00459"></a>00459   
<a name="l00460"></a>00460 <span class="preprocessor">#ifndef LIBMESH_HAVE_MPI</span>
<a name="l00461"></a>00461 <span class="preprocessor"></span>
<a name="l00462"></a>00462   libmesh_assert (local_size() == size());
<a name="l00463"></a>00463   
<a name="l00464"></a>00464 <span class="preprocessor">#endif</span>
<a name="l00465"></a>00465 <span class="preprocessor"></span>}
<a name="l00466"></a>00466 
<a name="l00467"></a>00467 
<a name="l00468"></a>00468 
<a name="l00469"></a>00469 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00470"></a><a class="code" href="classDistributedVector.php#a33c6b37fa3dd39a8fe17c08df12198fb">00470</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a3ccd4d2718bbbccdcfe5b55607ca87d5">DistributedVector&lt;T&gt;::localize</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local_in,
<a name="l00471"></a>00471                                      <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp;)<span class="keyword"> const</span>
<a name="l00472"></a>00472 <span class="keyword"></span>{
<a name="l00473"></a>00473   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00474"></a>00474   libmesh_assert (_values.size() == _local_size);
<a name="l00475"></a>00475   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00476"></a>00476 
<a name="l00477"></a>00477   <span class="comment">// TODO: We don&#39;t yet support the send list; this is inefficient:</span>
<a name="l00478"></a>00478   localize (v_local_in);
<a name="l00479"></a>00479 }
<a name="l00480"></a>00480 
<a name="l00481"></a>00481 
<a name="l00482"></a>00482 
<a name="l00483"></a>00483 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00484"></a><a class="code" href="classDistributedVector.php#a4c9571f36920e4c781be1ec0ba792090">00484</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a3ccd4d2718bbbccdcfe5b55607ca87d5">DistributedVector&lt;T&gt;::localize</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_idx,
<a name="l00485"></a>00485                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> last_local_idx,
<a name="l00486"></a>00486                                      <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list)
<a name="l00487"></a>00487 {
<a name="l00488"></a>00488   <span class="comment">// Only good for serial vectors</span>
<a name="l00489"></a>00489   libmesh_assert (this-&gt;size() == this-&gt;local_size());
<a name="l00490"></a>00490   libmesh_assert (last_local_idx &gt; first_local_idx);
<a name="l00491"></a>00491   libmesh_assert (send_list.size() &lt;= this-&gt;size());
<a name="l00492"></a>00492   libmesh_assert (last_local_idx &lt; this-&gt;size());
<a name="l00493"></a>00493   
<a name="l00494"></a>00494   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> size       = this-&gt;size();
<a name="l00495"></a>00495   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_size = (last_local_idx - first_local_idx + 1);
<a name="l00496"></a>00496 
<a name="l00497"></a>00497     <span class="comment">// Don&#39;t bother for serial cases</span>
<a name="l00498"></a>00498   <span class="keywordflow">if</span> ((first_local_idx == 0) &amp;&amp;
<a name="l00499"></a>00499       (local_size == size))
<a name="l00500"></a>00500     <span class="keywordflow">return</span>;
<a name="l00501"></a>00501   
<a name="l00502"></a>00502           
<a name="l00503"></a>00503   <span class="comment">// Build a parallel vector, initialize it with the local</span>
<a name="l00504"></a>00504   <span class="comment">// parts of (*this)</span>
<a name="l00505"></a>00505   <a class="code" href="classDistributedVector.php">DistributedVector&lt;T&gt;</a> parallel_vec;
<a name="l00506"></a>00506 
<a name="l00507"></a>00507   parallel_vec.<a class="code" href="classDistributedVector.php#acf0cd7f33594127736250a5e581580be">init</a> (size, local_size, <span class="keyword">true</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>);
<a name="l00508"></a>00508 
<a name="l00509"></a>00509   <span class="comment">// Copy part of *this into the parallel_vec</span>
<a name="l00510"></a>00510   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=first_local_idx; i&lt;=last_local_idx; i++)
<a name="l00511"></a>00511     parallel_vec.<a class="code" href="classDistributedVector.php#ace6b6b6829d5dccfe3cd40b26d905b6b">_values</a>[i-first_local_idx] = _values[i];
<a name="l00512"></a>00512 
<a name="l00513"></a>00513   <span class="comment">// localize like normal</span>
<a name="l00514"></a>00514   parallel_vec.<a class="code" href="classDistributedVector.php#a3ccd4d2718bbbccdcfe5b55607ca87d5">localize</a> (*<span class="keyword">this</span>, send_list);    
<a name="l00515"></a>00515 }
<a name="l00516"></a>00516 
<a name="l00517"></a>00517 
<a name="l00518"></a>00518 
<a name="l00519"></a>00519 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00520"></a><a class="code" href="classDistributedVector.php#a3ccd4d2718bbbccdcfe5b55607ca87d5">00520</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a3ccd4d2718bbbccdcfe5b55607ca87d5">DistributedVector&lt;T&gt;::localize</a> (std::vector&lt;T&gt;&amp; v_local)<span class="keyword"> const</span>
<a name="l00521"></a>00521 <span class="keyword"></span>{
<a name="l00522"></a>00522   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00523"></a>00523   parallel_only();
<a name="l00524"></a>00524 
<a name="l00525"></a>00525   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00526"></a>00526   libmesh_assert (_values.size() == _local_size);
<a name="l00527"></a>00527   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00528"></a>00528 
<a name="l00529"></a>00529   v_local = this-&gt;_values;
<a name="l00530"></a>00530 
<a name="l00531"></a>00531   Parallel::allgather (v_local);
<a name="l00532"></a>00532 
<a name="l00533"></a>00533 <span class="preprocessor">#ifndef LIBMESH_HAVE_MPI</span>
<a name="l00534"></a>00534 <span class="preprocessor"></span>  libmesh_assert (local_size() == size());
<a name="l00535"></a>00535 <span class="preprocessor">#endif  </span>
<a name="l00536"></a>00536 <span class="preprocessor"></span>}
<a name="l00537"></a>00537 
<a name="l00538"></a>00538 
<a name="l00539"></a>00539 
<a name="l00540"></a>00540 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00541"></a><a class="code" href="classDistributedVector.php#a77166e931b6161ce3f30e06cb8881d14">00541</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a77166e931b6161ce3f30e06cb8881d14">DistributedVector&lt;T&gt;::localize_to_one</a> (std::vector&lt;T&gt;&amp; v_local,
<a name="l00542"></a>00542                                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid)<span class="keyword"> const</span>
<a name="l00543"></a>00543 <span class="keyword"></span>{
<a name="l00544"></a>00544   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00545"></a>00545   parallel_only();
<a name="l00546"></a>00546 
<a name="l00547"></a>00547   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00548"></a>00548   libmesh_assert (_values.size() == _local_size);
<a name="l00549"></a>00549   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00550"></a>00550 
<a name="l00551"></a>00551   v_local = this-&gt;_values;
<a name="l00552"></a>00552 
<a name="l00553"></a>00553   Parallel::gather (pid, v_local);
<a name="l00554"></a>00554 
<a name="l00555"></a>00555 <span class="preprocessor">#ifndef LIBMESH_HAVE_MPI</span>
<a name="l00556"></a>00556 <span class="preprocessor"></span>  libmesh_assert (local_size() == size());
<a name="l00557"></a>00557 <span class="preprocessor">#endif  </span>
<a name="l00558"></a>00558 <span class="preprocessor"></span>}
<a name="l00559"></a>00559 
<a name="l00560"></a>00560 
<a name="l00561"></a>00561 
<a name="l00562"></a>00562 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00563"></a><a class="code" href="classDistributedVector.php#a4b85359af70eee3643408f7e360b02e0">00563</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a4b85359af70eee3643408f7e360b02e0">DistributedVector&lt;T&gt;::pointwise_mult</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;,
<a name="l00564"></a>00564                                            <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;)
<a name="l00565"></a>00565 <span class="comment">//void DistributedVector&lt;T&gt;::pointwise_mult (const NumericVector&lt;T&gt;&amp; vec1,</span>
<a name="l00566"></a>00566 <span class="comment">//                                         const NumericVector&lt;T&gt;&amp; vec2)</span>
<a name="l00567"></a>00567 {
<a name="l00568"></a>00568   libmesh_not_implemented();
<a name="l00569"></a>00569 }
<a name="l00570"></a>00570 
<a name="l00571"></a>00571 
<a name="l00572"></a>00572 
<a name="l00573"></a>00573 <span class="comment">//--------------------------------------------------------------</span>
<a name="l00574"></a>00574 <span class="comment">// Explicit instantiations</span>
<a name="l00575"></a>00575 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classDistributedVector.php">DistributedVector&lt;Number&gt;</a>;
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
