<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>distributed_vector.h</h1>  </div>
</div>
<div class="contents">
<a href="distributed__vector_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: distributed_vector.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="preprocessor">#ifndef __distributed_vector_h__</span>
<a name="l00027"></a>00027 <span class="preprocessor"></span><span class="preprocessor">#define __distributed_vector_h__</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// C++ includes</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &lt;complex&gt;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &lt;limits&gt;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// Local includes</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;parallel.h&quot;</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00054"></a>00054 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00055"></a><a class="code" href="classDistributedVector.php">00055</a> <span class="keyword">class </span><a class="code" href="classDistributedVector.php">DistributedVector</a> : <span class="keyword">public</span> <a class="code" href="classNumericVector.php">NumericVector</a>&lt;T&gt;
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057 <span class="keyword">public</span>:
<a name="l00058"></a>00058 
<a name="l00062"></a>00062   <span class="keyword">explicit</span>
<a name="l00063"></a>00063   <a class="code" href="classDistributedVector.php#a3fd79d8313370a1e457f79a7e5112e7d">DistributedVector</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00064"></a>00064   
<a name="l00068"></a>00068   <span class="keyword">explicit</span>
<a name="l00069"></a>00069   <a class="code" href="classDistributedVector.php#a3fd79d8313370a1e457f79a7e5112e7d">DistributedVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00070"></a>00070                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00071"></a>00071     
<a name="l00076"></a>00076   <a class="code" href="classDistributedVector.php#a3fd79d8313370a1e457f79a7e5112e7d">DistributedVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00077"></a>00077                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00078"></a>00078                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00079"></a>00079     
<a name="l00085"></a>00085   <a class="code" href="classDistributedVector.php#a3fd79d8313370a1e457f79a7e5112e7d">DistributedVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00086"></a>00086                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00087"></a>00087                      <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ghost,
<a name="l00088"></a>00088                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00089"></a>00089     
<a name="l00094"></a>00094   <a class="code" href="classDistributedVector.php#a40b4fb499f3c6adcce6facfbcf16571e">~DistributedVector</a> ();
<a name="l00095"></a>00095 
<a name="l00099"></a>00099   <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a94c8769bd89d4dfa034e650be1c7ca1b">close</a> (); 
<a name="l00100"></a>00100 
<a name="l00104"></a>00104   <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a462dd01276a42d53c950ddd6ddb51274">clear</a> ();
<a name="l00105"></a>00105   
<a name="l00110"></a>00110   <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#aaf4e2b357e25e5d0895f32af75e48c57">zero</a> ();    
<a name="l00111"></a>00111 
<a name="l00115"></a>00115   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classDistributedVector.php#a8be915bf46675741bdf29364ba8720fc">clone</a> () <span class="keyword">const</span>;
<a name="l00116"></a>00116 
<a name="l00129"></a>00129   <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#acf0cd7f33594127736250a5e581580be">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00130"></a>00130              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00131"></a>00131              <span class="keyword">const</span> <span class="keywordtype">bool</span>         fast=<span class="keyword">false</span>,
<a name="l00132"></a>00132              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a>=<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00133"></a>00133     
<a name="l00137"></a>00137   <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#acf0cd7f33594127736250a5e581580be">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00138"></a>00138              <span class="keyword">const</span> <span class="keywordtype">bool</span>         fast=<span class="keyword">false</span>,
<a name="l00139"></a>00139              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a>=<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00140"></a>00140     
<a name="l00145"></a>00145   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#acf0cd7f33594127736250a5e581580be">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*N*/</span>,
<a name="l00146"></a>00146                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*n_local*/</span>,
<a name="l00147"></a>00147                      <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <span class="comment">/*ghost*/</span>,
<a name="l00148"></a>00148                      <span class="keyword">const</span> <span class="keywordtype">bool</span> <span class="comment">/*fast*/</span> = <span class="keyword">false</span>,
<a name="l00149"></a>00149                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00150"></a>00150     
<a name="l00155"></a>00155   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#acf0cd7f33594127736250a5e581580be">init</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; other,
<a name="l00156"></a>00156                      <span class="keyword">const</span> <span class="keywordtype">bool</span> fast = <span class="keyword">false</span>);
<a name="l00157"></a>00157 
<a name="l00161"></a>00161   <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classDistributedVector.php#a7bccc62719c23527b1986bb7698121d2">operator= </a>(<span class="keyword">const</span> T s);
<a name="l00162"></a>00162     
<a name="l00166"></a>00166   <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classDistributedVector.php#a7bccc62719c23527b1986bb7698121d2">operator= </a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00167"></a>00167 
<a name="l00171"></a>00171   <a class="code" href="classDistributedVector.php">DistributedVector&lt;T&gt;</a> &amp; <a class="code" href="classDistributedVector.php#a7bccc62719c23527b1986bb7698121d2">operator= </a>(<span class="keyword">const</span> <a class="code" href="classDistributedVector.php">DistributedVector&lt;T&gt;</a> &amp;V);
<a name="l00172"></a>00172 
<a name="l00176"></a>00176   <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classDistributedVector.php#a7bccc62719c23527b1986bb7698121d2">operator= </a>(<span class="keyword">const</span> std::vector&lt;T&gt; &amp;v);
<a name="l00177"></a>00177   
<a name="l00183"></a>00183   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDistributedVector.php#ab7561d7a8ebf96642ff50066f482a331">min</a> () <span class="keyword">const</span>;
<a name="l00184"></a>00184   
<a name="l00190"></a>00190   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDistributedVector.php#a5adee79fe9f6bad2c195014ba3157a84">max</a> () <span class="keyword">const</span>;
<a name="l00191"></a>00191   
<a name="l00195"></a>00195   T <a class="code" href="classDistributedVector.php#ae97f9cb8f5d691754926c2bb6ac2f463">sum</a>() <span class="keyword">const</span>;
<a name="l00196"></a>00196 
<a name="l00201"></a>00201   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDistributedVector.php#a205d2c517ba74d12e6d937af21d811d2">l1_norm</a> () <span class="keyword">const</span>;
<a name="l00202"></a>00202 
<a name="l00208"></a>00208   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDistributedVector.php#a2e615b26df8a90c2d719da69f1465a26">l2_norm</a> () <span class="keyword">const</span>;
<a name="l00209"></a>00209 
<a name="l00215"></a>00215   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDistributedVector.php#a35a1523920f97781725294c62235788f">linfty_norm</a> () <span class="keyword">const</span>;
<a name="l00216"></a>00216 
<a name="l00224"></a>00224   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDistributedVector.php#a5f536e5e0c7ff161e41ca9ec98da2463">size</a> () <span class="keyword">const</span>;
<a name="l00225"></a>00225 
<a name="l00230"></a>00230   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDistributedVector.php#a2ab30ea1f0a79c3e3e67dff5c87f3659">local_size</a>() <span class="keyword">const</span>;
<a name="l00231"></a>00231 
<a name="l00236"></a>00236   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDistributedVector.php#aa4edb69f0f9c1269375f9b395243e772">first_local_index</a>() <span class="keyword">const</span>;
<a name="l00237"></a>00237 
<a name="l00242"></a>00242   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDistributedVector.php#a39c2dcd617ef30d1d696fca05bef6341">last_local_index</a>() <span class="keyword">const</span>;
<a name="l00243"></a>00243     
<a name="l00247"></a>00247   T <a class="code" href="classDistributedVector.php#a379dc779b17a226e37f13e7ee4acce08">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00248"></a>00248     
<a name="l00253"></a>00253   <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classDistributedVector.php#af84ea090f4cf4b8f19201471d63cad1e">operator += </a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00254"></a>00254 
<a name="l00259"></a>00259   <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classDistributedVector.php#a0f9bc1bf33631ed1b55be031185fef0f">operator -= </a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00260"></a>00260     
<a name="l00264"></a>00264   <span class="keywordtype">void</span> <span class="keyword">set</span> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value);
<a name="l00265"></a>00265     
<a name="l00269"></a>00269   <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a978b40c4470e61bd9f61baa69c64a9b8">add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value);
<a name="l00270"></a>00270     
<a name="l00276"></a>00276   <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a978b40c4470e61bd9f61baa69c64a9b8">add</a> (<span class="keyword">const</span> T s);
<a name="l00277"></a>00277     
<a name="l00283"></a>00283   <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a978b40c4470e61bd9f61baa69c64a9b8">add</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; V);
<a name="l00284"></a>00284 
<a name="l00290"></a>00290   <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a978b40c4470e61bd9f61baa69c64a9b8">add</a> (<span class="keyword">const</span> T a, <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v);
<a name="l00291"></a>00291   
<a name="l00297"></a>00297   <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a0dca4b17bc440a4447796348b001decd">add_vector</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00298"></a>00298                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00299"></a>00299 
<a name="l00306"></a>00306   <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a0dca4b17bc440a4447796348b001decd">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00307"></a>00307                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00308"></a>00308   
<a name="l00315"></a><a class="code" href="classDistributedVector.php#a5b51305f9ece81f3900af73659c9c5b7">00315</a>   <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a0dca4b17bc440a4447796348b001decd">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;,
<a name="l00316"></a>00316                    <span class="keyword">const</span> <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;)
<a name="l00317"></a>00317   { libmesh_error(); }
<a name="l00318"></a>00318   
<a name="l00325"></a>00325   <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a0dca4b17bc440a4447796348b001decd">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00326"></a>00326                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00327"></a>00327   
<a name="l00332"></a>00332   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a767eeb6fb229ffab133521d3a318b55d">insert</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00333"></a>00333                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00334"></a>00334 
<a name="l00341"></a>00341   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a767eeb6fb229ffab133521d3a318b55d">insert</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00342"></a>00342                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00343"></a>00343       
<a name="l00349"></a>00349   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a767eeb6fb229ffab133521d3a318b55d">insert</a> (<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00350"></a>00350                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00351"></a>00351     
<a name="l00357"></a>00357   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a767eeb6fb229ffab133521d3a318b55d">insert</a> (<span class="keyword">const</span> <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;T&gt;</a>&amp; V,
<a name="l00358"></a>00358                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00359"></a>00359     
<a name="l00364"></a>00364   <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#adf3d0121e4e7c7f96659f2a15416679e">scale</a> (<span class="keyword">const</span> T factor);
<a name="l00365"></a>00365 
<a name="l00370"></a>00370   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a8740c844ac11f34696b9c2d161eb5ed8">abs</a>();
<a name="l00371"></a>00371   
<a name="l00375"></a>00375   <span class="keyword">virtual</span> T <a class="code" href="classDistributedVector.php#ac84fb8f1ba586b3b514bf109b819e12c">dot</a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; V) <span class="keyword">const</span>;
<a name="l00376"></a>00376   
<a name="l00381"></a>00381   <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a3ccd4d2718bbbccdcfe5b55607ca87d5">localize</a> (std::vector&lt;T&gt;&amp; v_local) <span class="keyword">const</span>;
<a name="l00382"></a>00382 
<a name="l00387"></a>00387   <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a3ccd4d2718bbbccdcfe5b55607ca87d5">localize</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local) <span class="keyword">const</span>;
<a name="l00388"></a>00388 
<a name="l00394"></a>00394   <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a3ccd4d2718bbbccdcfe5b55607ca87d5">localize</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local,
<a name="l00395"></a>00395                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list) <span class="keyword">const</span>;
<a name="l00396"></a>00396   
<a name="l00401"></a>00401   <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a3ccd4d2718bbbccdcfe5b55607ca87d5">localize</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_idx,
<a name="l00402"></a>00402                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> last_local_idx,
<a name="l00403"></a>00403                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list);
<a name="l00404"></a>00404 
<a name="l00411"></a>00411   <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a77166e931b6161ce3f30e06cb8881d14">localize_to_one</a> (std::vector&lt;T&gt;&amp; v_local,
<a name="l00412"></a>00412                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id=0) <span class="keyword">const</span>;
<a name="l00413"></a>00413     
<a name="l00418"></a>00418   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a4b85359af70eee3643408f7e360b02e0">pointwise_mult</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec1,
<a name="l00419"></a>00419                                <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec2);
<a name="l00420"></a>00420 
<a name="l00424"></a>00424   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a8ddc822f913bf45fd611094e1dec65d8">swap</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;v);
<a name="l00425"></a>00425 
<a name="l00426"></a>00426 <span class="keyword">private</span>:
<a name="l00427"></a>00427 
<a name="l00432"></a><a class="code" href="classDistributedVector.php#ace6b6b6829d5dccfe3cd40b26d905b6b">00432</a>   std::vector&lt;T&gt; <a class="code" href="classDistributedVector.php#ace6b6b6829d5dccfe3cd40b26d905b6b">_values</a>;
<a name="l00433"></a>00433 
<a name="l00437"></a><a class="code" href="classDistributedVector.php#af1cbdb64d6640e9610911751c51a59dc">00437</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDistributedVector.php#af1cbdb64d6640e9610911751c51a59dc">_global_size</a>;
<a name="l00438"></a>00438 
<a name="l00442"></a><a class="code" href="classDistributedVector.php#a1f541d4c59a29debfcd06fc363bc8f38">00442</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDistributedVector.php#a1f541d4c59a29debfcd06fc363bc8f38">_local_size</a>;
<a name="l00443"></a>00443 
<a name="l00447"></a><a class="code" href="classDistributedVector.php#a25389a27877969170e40e0014eac27c7">00447</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDistributedVector.php#a25389a27877969170e40e0014eac27c7">_first_local_index</a>;
<a name="l00448"></a>00448 
<a name="l00452"></a><a class="code" href="classDistributedVector.php#a598071bc263849c6922f66d1975ac613">00452</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDistributedVector.php#a598071bc263849c6922f66d1975ac613">_last_local_index</a>;
<a name="l00453"></a>00453 };
<a name="l00454"></a>00454 
<a name="l00455"></a>00455 
<a name="l00456"></a>00456 <span class="comment">//--------------------------------------------------------------------------</span>
<a name="l00457"></a>00457 <span class="comment">// DistributedVector inline methods</span>
<a name="l00458"></a>00458 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00459"></a>00459 <span class="keyword">inline</span>
<a name="l00460"></a><a class="code" href="classDistributedVector.php#a3fd79d8313370a1e457f79a7e5112e7d">00460</a> <a class="code" href="classDistributedVector.php#a3fd79d8313370a1e457f79a7e5112e7d">DistributedVector&lt;T&gt;::DistributedVector</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type) :
<a name="l00461"></a>00461   _global_size      (0),
<a name="l00462"></a>00462   _local_size       (0),
<a name="l00463"></a>00463   _first_local_index(0),
<a name="l00464"></a>00464   _last_local_index (0)
<a name="l00465"></a>00465 {
<a name="l00466"></a>00466   this-&gt;<a class="code" href="classNumericVector.php#a26410625410635a53bf754077ff88173">_type</a> = <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a>;
<a name="l00467"></a>00467 }
<a name="l00468"></a>00468 
<a name="l00469"></a>00469 
<a name="l00470"></a>00470 
<a name="l00471"></a>00471 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00472"></a>00472 <span class="keyword">inline</span>
<a name="l00473"></a><a class="code" href="classDistributedVector.php#ac60e9da828d4393e8556bbc70298c82d">00473</a> <a class="code" href="classDistributedVector.php#a3fd79d8313370a1e457f79a7e5112e7d">DistributedVector&lt;T&gt;::DistributedVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00474"></a>00474                                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00475"></a>00475 {
<a name="l00476"></a>00476   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(n, n, <span class="keyword">false</span>, type);
<a name="l00477"></a>00477 }
<a name="l00478"></a>00478 
<a name="l00479"></a>00479 
<a name="l00480"></a>00480 
<a name="l00481"></a>00481 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00482"></a>00482 <span class="keyword">inline</span>
<a name="l00483"></a><a class="code" href="classDistributedVector.php#a7d23eae418d36ab6c2141eb00270715d">00483</a> <a class="code" href="classDistributedVector.php#a3fd79d8313370a1e457f79a7e5112e7d">DistributedVector&lt;T&gt;::DistributedVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00484"></a>00484                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00485"></a>00485                                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00486"></a>00486 {
<a name="l00487"></a>00487   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(n, n_local, <span class="keyword">false</span>, type);
<a name="l00488"></a>00488 }
<a name="l00489"></a>00489 
<a name="l00490"></a>00490 
<a name="l00491"></a>00491 
<a name="l00492"></a>00492 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00493"></a>00493 <span class="keyword">inline</span>
<a name="l00494"></a><a class="code" href="classDistributedVector.php#acf479e4084202c18ac9f85f54861cfee">00494</a> <a class="code" href="classDistributedVector.php#a3fd79d8313370a1e457f79a7e5112e7d">DistributedVector&lt;T&gt;::DistributedVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00495"></a>00495                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00496"></a>00496                                          <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ghost,
<a name="l00497"></a>00497                                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00498"></a>00498 {
<a name="l00499"></a>00499   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(n, n_local, ghost, <span class="keyword">false</span>, type);
<a name="l00500"></a>00500 }
<a name="l00501"></a>00501 
<a name="l00502"></a>00502 
<a name="l00503"></a>00503 
<a name="l00504"></a>00504 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00505"></a>00505 <span class="keyword">inline</span>
<a name="l00506"></a><a class="code" href="classDistributedVector.php#a40b4fb499f3c6adcce6facfbcf16571e">00506</a> <a class="code" href="classDistributedVector.php#a40b4fb499f3c6adcce6facfbcf16571e">DistributedVector&lt;T&gt;::~DistributedVector</a> ()
<a name="l00507"></a>00507 {
<a name="l00508"></a>00508   this-&gt;clear ();
<a name="l00509"></a>00509 }
<a name="l00510"></a>00510 
<a name="l00511"></a>00511 
<a name="l00512"></a>00512 
<a name="l00513"></a>00513 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00514"></a>00514 <span class="keyword">inline</span>
<a name="l00515"></a><a class="code" href="classDistributedVector.php#acf0cd7f33594127736250a5e581580be">00515</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#acf0cd7f33594127736250a5e581580be">DistributedVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00516"></a>00516                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00517"></a>00517                                  <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00518"></a>00518                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00519"></a>00519 {
<a name="l00520"></a>00520   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00521"></a>00521   parallel_only();
<a name="l00522"></a>00522 
<a name="l00523"></a>00523   libmesh_assert (n_local &lt;= n);
<a name="l00524"></a>00524 
<a name="l00525"></a>00525   <span class="keywordflow">if</span> (type == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>)
<a name="l00526"></a>00526     {
<a name="l00527"></a>00527       <span class="keywordflow">if</span> (n == n_local)
<a name="l00528"></a>00528         this-&gt;_type = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>;
<a name="l00529"></a>00529       <span class="keywordflow">else</span>
<a name="l00530"></a>00530         this-&gt;_type = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>;
<a name="l00531"></a>00531     }
<a name="l00532"></a>00532   <span class="keywordflow">else</span>
<a name="l00533"></a>00533     this-&gt;_type = type;
<a name="l00534"></a>00534 
<a name="l00535"></a>00535   libmesh_assert ((this-&gt;_type==<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a> &amp;&amp; n==n_local) || 
<a name="l00536"></a>00536                   this-&gt;_type==<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>);
<a name="l00537"></a>00537 
<a name="l00538"></a>00538   <span class="comment">// Clear the data structures if already initialized</span>
<a name="l00539"></a>00539   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00540"></a>00540     this-&gt;clear();
<a name="l00541"></a>00541     
<a name="l00542"></a>00542   <span class="comment">// Initialize data structures</span>
<a name="l00543"></a>00543   _values.resize(n_local);
<a name="l00544"></a>00544   _local_size  = n_local;
<a name="l00545"></a>00545   _global_size = n;
<a name="l00546"></a>00546 
<a name="l00547"></a>00547   _first_local_index = 0;
<a name="l00548"></a>00548   
<a name="l00549"></a>00549 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00550"></a>00550 <span class="preprocessor"></span>
<a name="l00551"></a>00551   <span class="keywordtype">int</span> n_proc=0, proc_id=0;
<a name="l00552"></a>00552   
<a name="l00553"></a>00553   MPI_Comm_rank (<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>, &amp;proc_id);
<a name="l00554"></a>00554   MPI_Comm_size (<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>, &amp;n_proc);
<a name="l00555"></a>00555   
<a name="l00556"></a>00556   std::vector&lt;int&gt; local_sizes     (n_proc, 0);
<a name="l00557"></a>00557   
<a name="l00558"></a>00558   local_sizes[proc_id] = n_local;
<a name="l00559"></a>00559 
<a name="l00560"></a>00560   Parallel::sum(local_sizes);
<a name="l00561"></a>00561 
<a name="l00562"></a>00562   <span class="comment">// _first_local_index is the sum of _local_size</span>
<a name="l00563"></a>00563   <span class="comment">// for all processor ids less than ours</span>
<a name="l00564"></a>00564   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> p=0; p&lt;proc_id; p++)
<a name="l00565"></a>00565     _first_local_index += local_sizes[p];
<a name="l00566"></a>00566 
<a name="l00567"></a>00567 
<a name="l00568"></a>00568 <span class="preprocessor">#  ifdef DEBUG</span>
<a name="l00569"></a>00569 <span class="preprocessor"></span>  <span class="comment">// Make sure all the local sizes sum up to the global</span>
<a name="l00570"></a>00570   <span class="comment">// size, otherwise there is big trouble!</span>
<a name="l00571"></a>00571   <span class="keywordtype">int</span> sum=0;
<a name="l00572"></a>00572 
<a name="l00573"></a>00573   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> p=0; p&lt;n_proc; p++)
<a name="l00574"></a>00574     sum += local_sizes[p];
<a name="l00575"></a>00575 
<a name="l00576"></a>00576   libmesh_assert (sum == static_cast&lt;int&gt;(n));
<a name="l00577"></a>00577   
<a name="l00578"></a>00578 <span class="preprocessor">#  endif</span>
<a name="l00579"></a>00579 <span class="preprocessor"></span>  
<a name="l00580"></a>00580 <span class="preprocessor">#else</span>
<a name="l00581"></a>00581 <span class="preprocessor"></span>  
<a name="l00582"></a>00582   <span class="comment">// No other options without MPI!</span>
<a name="l00583"></a>00583   <span class="keywordflow">if</span> (n != n_local)
<a name="l00584"></a>00584     {
<a name="l00585"></a>00585       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR:  MPI is required for n != n_local!&quot;</span>
<a name="l00586"></a>00586                 &lt;&lt; std::endl;
<a name="l00587"></a>00587       libmesh_error();
<a name="l00588"></a>00588     }
<a name="l00589"></a>00589   
<a name="l00590"></a>00590 <span class="preprocessor">#endif</span>
<a name="l00591"></a>00591 <span class="preprocessor"></span>
<a name="l00592"></a>00592   _last_local_index = _first_local_index + n_local;
<a name="l00593"></a>00593   
<a name="l00594"></a>00594   <span class="comment">// Set the initialized flag</span>
<a name="l00595"></a>00595   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00596"></a>00596 
<a name="l00597"></a>00597   <span class="comment">// Zero the components unless directed otherwise</span>
<a name="l00598"></a>00598   <span class="keywordflow">if</span> (!fast)
<a name="l00599"></a>00599     this-&gt;<a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a>();
<a name="l00600"></a>00600 }
<a name="l00601"></a>00601 
<a name="l00602"></a>00602 
<a name="l00603"></a>00603 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00604"></a>00604 <span class="keyword">inline</span>
<a name="l00605"></a><a class="code" href="classDistributedVector.php#ab8074fed04cc2531c809bf1ebc290b70">00605</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#acf0cd7f33594127736250a5e581580be">DistributedVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00606"></a>00606                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00607"></a>00607                                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <span class="comment">/*ghost*/</span>,
<a name="l00608"></a>00608                                  <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00609"></a>00609                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00610"></a>00610 {
<a name="l00611"></a>00611   <span class="comment">// TODO: we shouldn&#39;t ignore the ghost sparsity pattern</span>
<a name="l00612"></a>00612   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(n, n_local, fast, type);
<a name="l00613"></a>00613 }
<a name="l00614"></a>00614 
<a name="l00615"></a>00615 
<a name="l00616"></a>00616 
<a name="l00617"></a>00617 <span class="comment">/* Default implementation for solver packages for which ghosted</span>
<a name="l00618"></a>00618 <span class="comment">   vectors are not yet implemented.  */</span>
<a name="l00619"></a>00619 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00620"></a><a class="code" href="classDistributedVector.php#a35be519b81aca72205be9cf1a1c8c86e">00620</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#acf0cd7f33594127736250a5e581580be">DistributedVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; other,
<a name="l00621"></a>00621                                  <span class="keyword">const</span> <span class="keywordtype">bool</span> fast)
<a name="l00622"></a>00622 {
<a name="l00623"></a>00623   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(other.<a class="code" href="classNumericVector.php#ae21bc89e89e895ac26b851a31926e194">size</a>(),other.<a class="code" href="classNumericVector.php#a400307e324862d460ff6b3b83a72e867">local_size</a>(),fast,other.<a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a>());
<a name="l00624"></a>00624 }
<a name="l00625"></a>00625 
<a name="l00626"></a>00626 
<a name="l00627"></a>00627 
<a name="l00628"></a>00628 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00629"></a>00629 <span class="keyword">inline</span>
<a name="l00630"></a><a class="code" href="classDistributedVector.php#ab8142b5e3297a1fec3cc812df0558162">00630</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#acf0cd7f33594127736250a5e581580be">DistributedVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00631"></a>00631                                  <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00632"></a>00632                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00633"></a>00633 {
<a name="l00634"></a>00634   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(n,n,fast,type);
<a name="l00635"></a>00635 }
<a name="l00636"></a>00636 
<a name="l00637"></a>00637 
<a name="l00638"></a>00638 
<a name="l00639"></a>00639 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00640"></a>00640 <span class="keyword">inline</span>
<a name="l00641"></a><a class="code" href="classDistributedVector.php#a94c8769bd89d4dfa034e650be1c7ca1b">00641</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a94c8769bd89d4dfa034e650be1c7ca1b">DistributedVector&lt;T&gt;::close</a> ()
<a name="l00642"></a>00642 {
<a name="l00643"></a>00643   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00644"></a>00644   
<a name="l00645"></a>00645   this-&gt;_is_closed = <span class="keyword">true</span>;
<a name="l00646"></a>00646 }
<a name="l00647"></a>00647 
<a name="l00648"></a>00648 
<a name="l00649"></a>00649 
<a name="l00650"></a>00650 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00651"></a>00651 <span class="keyword">inline</span>
<a name="l00652"></a><a class="code" href="classDistributedVector.php#a462dd01276a42d53c950ddd6ddb51274">00652</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a462dd01276a42d53c950ddd6ddb51274">DistributedVector&lt;T&gt;::clear</a> ()
<a name="l00653"></a>00653 {
<a name="l00654"></a>00654   _values.clear();
<a name="l00655"></a>00655   
<a name="l00656"></a>00656   _global_size =
<a name="l00657"></a>00657     _local_size =
<a name="l00658"></a>00658     _first_local_index =
<a name="l00659"></a>00659     _last_local_index = 0;
<a name="l00660"></a>00660   
<a name="l00661"></a>00661   
<a name="l00662"></a>00662   this-&gt;_is_closed = this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00663"></a>00663 }
<a name="l00664"></a>00664 
<a name="l00665"></a>00665 
<a name="l00666"></a>00666 
<a name="l00667"></a>00667 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00668"></a>00668 <span class="keyword">inline</span>
<a name="l00669"></a><a class="code" href="classDistributedVector.php#aaf4e2b357e25e5d0895f32af75e48c57">00669</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#aaf4e2b357e25e5d0895f32af75e48c57">DistributedVector&lt;T&gt;::zero</a> ()
<a name="l00670"></a>00670 {
<a name="l00671"></a>00671   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00672"></a>00672   libmesh_assert (_values.size() == _local_size);
<a name="l00673"></a>00673   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00674"></a>00674   
<a name="l00675"></a>00675   std::fill (_values.begin(),
<a name="l00676"></a>00676              _values.end(),
<a name="l00677"></a>00677              0.);
<a name="l00678"></a>00678 }
<a name="l00679"></a>00679 
<a name="l00680"></a>00680 
<a name="l00681"></a>00681 
<a name="l00682"></a>00682 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00683"></a>00683 <span class="keyword">inline</span>
<a name="l00684"></a><a class="code" href="classDistributedVector.php#a8be915bf46675741bdf29364ba8720fc">00684</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classDistributedVector.php#a8be915bf46675741bdf29364ba8720fc">DistributedVector&lt;T&gt;::clone</a> ()<span class="keyword"> const</span>
<a name="l00685"></a>00685 <span class="keyword"></span>{
<a name="l00686"></a>00686   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; cloned_vector (<span class="keyword">new</span> <a class="code" href="classDistributedVector.php">DistributedVector&lt;T&gt;</a>);
<a name="l00687"></a>00687 
<a name="l00688"></a>00688   cloned_vector-&gt;init(*<span class="keyword">this</span>, <span class="keyword">true</span>);
<a name="l00689"></a>00689 
<a name="l00690"></a>00690   *cloned_vector = *<span class="keyword">this</span>;
<a name="l00691"></a>00691 
<a name="l00692"></a>00692   <span class="keywordflow">return</span> cloned_vector;
<a name="l00693"></a>00693 }
<a name="l00694"></a>00694 
<a name="l00695"></a>00695 
<a name="l00696"></a>00696 
<a name="l00697"></a>00697 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00698"></a>00698 <span class="keyword">inline</span>
<a name="l00699"></a><a class="code" href="classDistributedVector.php#a5f536e5e0c7ff161e41ca9ec98da2463">00699</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDistributedVector.php#a5f536e5e0c7ff161e41ca9ec98da2463">DistributedVector&lt;T&gt;::size</a> ()<span class="keyword"> const</span>
<a name="l00700"></a>00700 <span class="keyword"></span>{
<a name="l00701"></a>00701   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00702"></a>00702   libmesh_assert (_values.size() == _local_size);
<a name="l00703"></a>00703   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00704"></a>00704 
<a name="l00705"></a>00705   <span class="keywordflow">return</span> _global_size;
<a name="l00706"></a>00706 }
<a name="l00707"></a>00707 
<a name="l00708"></a>00708 
<a name="l00709"></a>00709 
<a name="l00710"></a>00710 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00711"></a>00711 <span class="keyword">inline</span>
<a name="l00712"></a><a class="code" href="classDistributedVector.php#a2ab30ea1f0a79c3e3e67dff5c87f3659">00712</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDistributedVector.php#a2ab30ea1f0a79c3e3e67dff5c87f3659">DistributedVector&lt;T&gt;::local_size</a> ()<span class="keyword"> const</span>
<a name="l00713"></a>00713 <span class="keyword"></span>{
<a name="l00714"></a>00714   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00715"></a>00715   libmesh_assert (_values.size() == _local_size);
<a name="l00716"></a>00716   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00717"></a>00717 
<a name="l00718"></a>00718   <span class="keywordflow">return</span> _local_size;
<a name="l00719"></a>00719 }
<a name="l00720"></a>00720 
<a name="l00721"></a>00721 
<a name="l00722"></a>00722 
<a name="l00723"></a>00723 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00724"></a>00724 <span class="keyword">inline</span>
<a name="l00725"></a><a class="code" href="classDistributedVector.php#aa4edb69f0f9c1269375f9b395243e772">00725</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDistributedVector.php#aa4edb69f0f9c1269375f9b395243e772">DistributedVector&lt;T&gt;::first_local_index</a> ()<span class="keyword"> const</span>
<a name="l00726"></a>00726 <span class="keyword"></span>{
<a name="l00727"></a>00727   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00728"></a>00728   libmesh_assert (_values.size() == _local_size);
<a name="l00729"></a>00729   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00730"></a>00730 
<a name="l00731"></a>00731   <span class="keywordflow">return</span> _first_local_index;
<a name="l00732"></a>00732 }
<a name="l00733"></a>00733 
<a name="l00734"></a>00734 
<a name="l00735"></a>00735 
<a name="l00736"></a>00736 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00737"></a>00737 <span class="keyword">inline</span>
<a name="l00738"></a><a class="code" href="classDistributedVector.php#a39c2dcd617ef30d1d696fca05bef6341">00738</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDistributedVector.php#a39c2dcd617ef30d1d696fca05bef6341">DistributedVector&lt;T&gt;::last_local_index</a> ()<span class="keyword"> const</span>
<a name="l00739"></a>00739 <span class="keyword"></span>{
<a name="l00740"></a>00740   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00741"></a>00741   libmesh_assert (_values.size() == _local_size);
<a name="l00742"></a>00742   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00743"></a>00743 
<a name="l00744"></a>00744   <span class="keywordflow">return</span> _last_local_index;
<a name="l00745"></a>00745 }
<a name="l00746"></a>00746 
<a name="l00747"></a>00747 
<a name="l00748"></a>00748 
<a name="l00749"></a>00749 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00750"></a>00750 <span class="keyword">inline</span>
<a name="l00751"></a><a class="code" href="classDistributedVector.php#a379dc779b17a226e37f13e7ee4acce08">00751</a> T <a class="code" href="classDistributedVector.php#a379dc779b17a226e37f13e7ee4acce08">DistributedVector&lt;T&gt;::operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00752"></a>00752 <span class="keyword"></span>{
<a name="l00753"></a>00753   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00754"></a>00754   libmesh_assert (_values.size() == _local_size);
<a name="l00755"></a>00755   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00756"></a>00756   libmesh_assert ( ((i &gt;= first_local_index()) &amp;&amp;
<a name="l00757"></a>00757             (i &lt;  last_local_index())) );
<a name="l00758"></a>00758 
<a name="l00759"></a>00759   <span class="keywordflow">return</span> _values[i - _first_local_index];
<a name="l00760"></a>00760 }
<a name="l00761"></a>00761 
<a name="l00762"></a>00762 
<a name="l00763"></a>00763 
<a name="l00764"></a>00764 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00765"></a>00765 <span class="keyword">inline</span>
<a name="l00766"></a><a class="code" href="classDistributedVector.php#ab5bacbb0910bafbdb99ab5117604bd34">00766</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#ab5bacbb0910bafbdb99ab5117604bd34">DistributedVector&lt;T&gt;::set</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value)
<a name="l00767"></a>00767 {
<a name="l00768"></a>00768   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00769"></a>00769   libmesh_assert (_values.size() == _local_size);
<a name="l00770"></a>00770   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00771"></a>00771   libmesh_assert (i&lt;size());
<a name="l00772"></a>00772   libmesh_assert (i-first_local_index() &lt; local_size());
<a name="l00773"></a>00773   
<a name="l00774"></a>00774   _values[i - _first_local_index] = value;
<a name="l00775"></a>00775 }
<a name="l00776"></a>00776 
<a name="l00777"></a>00777 
<a name="l00778"></a>00778 
<a name="l00779"></a>00779 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00780"></a>00780 <span class="keyword">inline</span>
<a name="l00781"></a><a class="code" href="classDistributedVector.php#a978b40c4470e61bd9f61baa69c64a9b8">00781</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a978b40c4470e61bd9f61baa69c64a9b8">DistributedVector&lt;T&gt;::add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value)
<a name="l00782"></a>00782 {
<a name="l00783"></a>00783   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00784"></a>00784   libmesh_assert (_values.size() == _local_size);
<a name="l00785"></a>00785   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00786"></a>00786   libmesh_assert (i&lt;size());
<a name="l00787"></a>00787   libmesh_assert (i-first_local_index() &lt; local_size());
<a name="l00788"></a>00788   
<a name="l00789"></a>00789   _values[i - _first_local_index] += value;
<a name="l00790"></a>00790 }
<a name="l00791"></a>00791 
<a name="l00792"></a>00792 
<a name="l00793"></a>00793 
<a name="l00794"></a>00794 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00795"></a>00795 <span class="keyword">inline</span>
<a name="l00796"></a><a class="code" href="classDistributedVector.php#ab7561d7a8ebf96642ff50066f482a331">00796</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDistributedVector.php#ab7561d7a8ebf96642ff50066f482a331">DistributedVector&lt;T&gt;::min</a> ()<span class="keyword"> const</span>
<a name="l00797"></a>00797 <span class="keyword"></span>{
<a name="l00798"></a>00798   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00799"></a>00799   parallel_only();
<a name="l00800"></a>00800 
<a name="l00801"></a>00801   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00802"></a>00802   libmesh_assert (_values.size() == _local_size);
<a name="l00803"></a>00803   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00804"></a>00804 
<a name="l00805"></a>00805   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> local_min = _values.size() ? 
<a name="l00806"></a>00806     <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>(_values[0]) : <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;Real&gt;::max</a>();
<a name="l00807"></a>00807   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 1; i &lt; _values.size(); ++i)
<a name="l00808"></a>00808     local_min = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(<a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>(_values[i]), local_min);
<a name="l00809"></a>00809   
<a name="l00810"></a>00810   <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(local_min);
<a name="l00811"></a>00811 
<a name="l00812"></a>00812   <span class="keywordflow">return</span> local_min;
<a name="l00813"></a>00813 }
<a name="l00814"></a>00814 
<a name="l00815"></a>00815 
<a name="l00816"></a>00816 
<a name="l00817"></a>00817 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00818"></a>00818 <span class="keyword">inline</span>
<a name="l00819"></a><a class="code" href="classDistributedVector.php#a5adee79fe9f6bad2c195014ba3157a84">00819</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDistributedVector.php#a5adee79fe9f6bad2c195014ba3157a84">DistributedVector&lt;T&gt;::max</a>()<span class="keyword"> const</span>
<a name="l00820"></a>00820 <span class="keyword"></span>{
<a name="l00821"></a>00821   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00822"></a>00822   parallel_only();
<a name="l00823"></a>00823 
<a name="l00824"></a>00824   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00825"></a>00825   libmesh_assert (_values.size() == _local_size);
<a name="l00826"></a>00826   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00827"></a>00827 
<a name="l00828"></a>00828   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> local_max = _values.size() ? 
<a name="l00829"></a>00829     <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>(_values[0]) : -<a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;Real&gt;::max</a>();
<a name="l00830"></a>00830   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 1; i &lt; _values.size(); ++i)
<a name="l00831"></a>00831     local_max = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(<a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>(_values[i]), local_max);
<a name="l00832"></a>00832   
<a name="l00833"></a>00833   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(local_max);
<a name="l00834"></a>00834 
<a name="l00835"></a>00835   <span class="keywordflow">return</span> local_max;
<a name="l00836"></a>00836 }
<a name="l00837"></a>00837 
<a name="l00838"></a>00838 
<a name="l00839"></a>00839 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00840"></a>00840 <span class="keyword">inline</span>
<a name="l00841"></a><a class="code" href="classDistributedVector.php#a8ddc822f913bf45fd611094e1dec65d8">00841</a> <span class="keywordtype">void</span> <a class="code" href="classDistributedVector.php#a8ddc822f913bf45fd611094e1dec65d8">DistributedVector&lt;T&gt;::swap</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;other)
<a name="l00842"></a>00842 {
<a name="l00843"></a>00843   <a class="code" href="classDistributedVector.php">DistributedVector&lt;T&gt;</a>&amp; v = libmesh_cast_ref&lt;DistributedVector&lt;T&gt;&amp;&gt;(other);
<a name="l00844"></a>00844 
<a name="l00845"></a>00845   std::swap(_global_size, v.<a class="code" href="classDistributedVector.php#af1cbdb64d6640e9610911751c51a59dc">_global_size</a>);
<a name="l00846"></a>00846   std::swap(_local_size, v.<a class="code" href="classDistributedVector.php#a1f541d4c59a29debfcd06fc363bc8f38">_local_size</a>);
<a name="l00847"></a>00847   std::swap(_first_local_index, v.<a class="code" href="classDistributedVector.php#a25389a27877969170e40e0014eac27c7">_first_local_index</a>);
<a name="l00848"></a>00848   std::swap(_last_local_index, v.<a class="code" href="classDistributedVector.php#a598071bc263849c6922f66d1975ac613">_last_local_index</a>);
<a name="l00849"></a>00849 
<a name="l00850"></a>00850   <span class="comment">// This should be O(1) with any reasonable STL implementation</span>
<a name="l00851"></a>00851   std::swap(_values, v.<a class="code" href="classDistributedVector.php#ace6b6b6829d5dccfe3cd40b26d905b6b">_values</a>);
<a name="l00852"></a>00852 }
<a name="l00853"></a>00853 
<a name="l00854"></a>00854 
<a name="l00855"></a>00855 <span class="preprocessor">#endif  // #ifdef __distributed_vector_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
