<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>diva_io.h</h1>  </div>
</div>
<div class="contents">
<a href="diva__io_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: diva_io.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __diva_io_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __diva_io_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="mesh__output_8h.php">mesh_output.h</a>&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Forward declarations</span>
<a name="l00029"></a>00029 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00042"></a>00042 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00043"></a>00043 <span class="comment">// DivaIO class definition</span>
<a name="l00044"></a><a class="code" href="classDivaIO.php">00044</a> <span class="keyword">class </span><a class="code" href="classDivaIO.php">DivaIO</a> : <span class="keyword">public</span> <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;MeshBase&gt;
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046 <span class="keyword">public</span>:
<a name="l00051"></a>00051   <span class="comment">//TODO:[JWP] figure out how to implement a const write method!</span>
<a name="l00052"></a>00052   <a class="code" href="classDivaIO.php#a646d506c92cc4ab3e15f40cbef320911">DivaIO</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp;);
<a name="l00053"></a>00053 
<a name="l00057"></a>00057   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDivaIO.php#add86954e5f8443c52f2e2d4f9db25c4e">write</a> (<span class="keyword">const</span> std::string&amp; );
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 <span class="keyword">private</span>:
<a name="l00060"></a>00060   
<a name="l00066"></a>00066   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDivaIO.php#a230bab910d58e209fa7f7b40335ac6bc">write_stream</a>(std::ostream&amp; out);
<a name="l00067"></a>00067 };
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 
<a name="l00072"></a>00072 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00073"></a>00073 <span class="comment">// DivaIO inline members</span>
<a name="l00074"></a>00074 <span class="keyword">inline</span>
<a name="l00075"></a><a class="code" href="classDivaIO.php#a646d506c92cc4ab3e15f40cbef320911">00075</a> <a class="code" href="classDivaIO.php#a646d506c92cc4ab3e15f40cbef320911">DivaIO::DivaIO</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh) :
<a name="l00076"></a>00076   <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt;  (mesh)
<a name="l00077"></a>00077 {}
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 <span class="preprocessor">#endif // #define __diva_io_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
