<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_a444518d96d2df902338d2a7eb3a040c.php">base</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>dof_map.h</h1>  </div>
</div>
<div class="contents">
<a href="dof__map_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: dof_map.h 3504 2009-10-21 18:58:45Z knezed01 $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __dof_map_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __dof_map_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;iterator&gt;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;enum_order.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span> <span class="comment">// libMesh::invalid_uint</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;vector_value.h&quot;</span> <span class="comment">// RealVectorValue</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;system.h&quot;</span> <span class="comment">// System::Variable</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;threads.h&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;threads_allocators.h&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;elem_range.h&quot;</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="comment">// Forward Declarations</span>
<a name="l00045"></a>00045 <span class="keyword">class </span><a class="code" href="classDofMap.php">DofMap</a>;
<a name="l00046"></a>00046 <span class="keyword">class </span><a class="code" href="classDofObject.php">DofObject</a>;
<a name="l00047"></a>00047 <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00048"></a>00048 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00049"></a>00049 <span class="keyword">class </span><a class="code" href="classMesh.php">Mesh</a>;
<a name="l00050"></a>00050 <span class="keyword">class </span><a class="code" href="classFEType.php">FEType</a>;
<a name="l00051"></a>00051 <span class="keyword">class </span><a class="code" href="classCouplingMatrix.php">CouplingMatrix</a>;
<a name="l00052"></a>00052 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classDenseVectorBase.php">DenseVectorBase</a>;
<a name="l00053"></a>00053 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classDenseVector.php">DenseVector</a>;
<a name="l00054"></a>00054 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classDenseMatrix.php">DenseMatrix</a>;
<a name="l00055"></a>00055 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classSparseMatrix.php">SparseMatrix</a>;
<a name="l00056"></a>00056 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classNumericVector.php">NumericVector</a>;
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00062"></a>00062 <span class="comment">// Sparsity Pattern</span>
<a name="l00063"></a>00063 
<a name="l00070"></a><a class="code" href="namespaceSparsityPattern.php">00070</a> <span class="keyword">namespace </span>SparsityPattern <span class="comment">// use a namespace so member classes can be forward-declared.</span>
<a name="l00071"></a>00071 {
<a name="l00072"></a><a class="code" href="namespaceSparsityPattern.php#a380dc3cd41bc4aab23a1c916181104b3">00072</a>   <span class="keyword">typedef</span> std::vector&lt;unsigned int, Threads::scalable_allocator&lt;unsigned int&gt; &gt; <a class="code" href="namespaceSparsityPattern.php#a380dc3cd41bc4aab23a1c916181104b3">Row</a>;
<a name="l00073"></a><a class="code" href="classSparsityPattern_1_1Graph.php">00073</a>   <span class="keyword">class </span><a class="code" href="classSparsityPattern_1_1Graph.php">Graph</a> : <span class="keyword">public</span> std::<a class="code" href="classstd_1_1vector.php">vector</a>&lt;Row&gt; {};
<a name="l00074"></a>00074   
<a name="l00084"></a>00084   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> B<span class="keywordtype">id</span>irectionalIterator&gt;
<a name="l00085"></a>00085   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="namespaceSparsityPattern.php#abcab8a87e8229861015b1de4bc8f60ff">sort_row</a> (<span class="keyword">const</span> BidirectionalIterator begin,
<a name="l00086"></a>00086                         BidirectionalIterator       middle,
<a name="l00087"></a>00087                         <span class="keyword">const</span> BidirectionalIterator end);
<a name="l00088"></a>00088 
<a name="l00100"></a><a class="code" href="classSparsityPattern_1_1Build.php">00100</a>   <span class="keyword">class </span><a class="code" href="classSparsityPattern_1_1Build.php">Build</a>
<a name="l00101"></a>00101   {
<a name="l00102"></a>00102   <span class="keyword">private</span>:
<a name="l00103"></a><a class="code" href="classSparsityPattern_1_1Build.php#a8dfe00458fdffa32b6461df05b7b4f16">00103</a>     <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;<a class="code" href="classSparsityPattern_1_1Build.php#a8dfe00458fdffa32b6461df05b7b4f16">mesh</a>;
<a name="l00104"></a><a class="code" href="classSparsityPattern_1_1Build.php#aa25aa26eabe02d301da420af81f8d38f">00104</a>     <span class="keyword">const</span> <a class="code" href="classDofMap.php">DofMap</a> &amp;<a class="code" href="classSparsityPattern_1_1Build.php#aa25aa26eabe02d301da420af81f8d38f">dof_map</a>;
<a name="l00105"></a><a class="code" href="classSparsityPattern_1_1Build.php#accbeb2e353d5791440f9d2b1ef1742e7">00105</a>     <span class="keyword">const</span> <a class="code" href="classCouplingMatrix.php">CouplingMatrix</a> *<a class="code" href="classSparsityPattern_1_1Build.php#accbeb2e353d5791440f9d2b1ef1742e7">dof_coupling</a>;
<a name="l00106"></a><a class="code" href="classSparsityPattern_1_1Build.php#ae23a805dd67ee6f28494b0477f59173f">00106</a>     <span class="keyword">const</span> <span class="keywordtype">bool</span> <a class="code" href="classSparsityPattern_1_1Build.php#ae23a805dd67ee6f28494b0477f59173f">implicit_neighbor_dofs</a>;
<a name="l00107"></a><a class="code" href="classSparsityPattern_1_1Build.php#a7391c2b856f66ea6e659fcf1fb9d02e4">00107</a>     <span class="keyword">const</span> <span class="keywordtype">bool</span> <a class="code" href="classSparsityPattern_1_1Build.php#a7391c2b856f66ea6e659fcf1fb9d02e4">need_full_sparsity_pattern</a>;
<a name="l00108"></a>00108 
<a name="l00109"></a>00109   <span class="keyword">public</span>:
<a name="l00110"></a>00110 
<a name="l00111"></a><a class="code" href="classSparsityPattern_1_1Build.php#a8f5b5c39334d20908f82d7921a526289">00111</a>     <a class="code" href="classSparsityPattern_1_1Graph.php">SparsityPattern::Graph</a> <a class="code" href="classSparsityPattern_1_1Build.php#a8f5b5c39334d20908f82d7921a526289">sparsity_pattern</a>;
<a name="l00112"></a><a class="code" href="classSparsityPattern_1_1Build.php#af60829aa8bb28e66372629218421bb65">00112</a>     std::vector&lt;unsigned int&gt; <a class="code" href="classSparsityPattern_1_1Build.php#af60829aa8bb28e66372629218421bb65">n_nz</a>;
<a name="l00113"></a><a class="code" href="classSparsityPattern_1_1Build.php#a86edb077e8f9a93385d516a9b45be9d1">00113</a>     std::vector&lt;unsigned int&gt; <a class="code" href="classSparsityPattern_1_1Build.php#a86edb077e8f9a93385d516a9b45be9d1">n_oz</a>;
<a name="l00114"></a>00114     
<a name="l00115"></a><a class="code" href="classSparsityPattern_1_1Build.php#a11a6fe530cdf7387ea3359f961bdcc9d">00115</a>     <a class="code" href="classSparsityPattern_1_1Build.php#a11a6fe530cdf7387ea3359f961bdcc9d">Build</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh_in,
<a name="l00116"></a>00116            <span class="keyword">const</span> <a class="code" href="classDofMap.php">DofMap</a> &amp;dof_map_in,
<a name="l00117"></a>00117            <span class="keyword">const</span> <a class="code" href="classCouplingMatrix.php">CouplingMatrix</a> *dof_coupling_in,
<a name="l00118"></a>00118            <span class="keyword">const</span> <span class="keywordtype">bool</span> implicit_neighbor_dofs_in,
<a name="l00119"></a>00119            <span class="keyword">const</span> <span class="keywordtype">bool</span> need_full_sparsity_pattern_in) :
<a name="l00120"></a>00120       <a class="code" href="classSparsityPattern_1_1Build.php#a8dfe00458fdffa32b6461df05b7b4f16">mesh</a>(mesh_in),
<a name="l00121"></a>00121       <a class="code" href="classSparsityPattern_1_1Build.php#aa25aa26eabe02d301da420af81f8d38f">dof_map</a>(dof_map_in),
<a name="l00122"></a>00122       <a class="code" href="classSparsityPattern_1_1Build.php#accbeb2e353d5791440f9d2b1ef1742e7">dof_coupling</a>(dof_coupling_in),
<a name="l00123"></a>00123       <a class="code" href="classSparsityPattern_1_1Build.php#ae23a805dd67ee6f28494b0477f59173f">implicit_neighbor_dofs</a>(implicit_neighbor_dofs_in),
<a name="l00124"></a>00124       <a class="code" href="classSparsityPattern_1_1Build.php#a7391c2b856f66ea6e659fcf1fb9d02e4">need_full_sparsity_pattern</a>(need_full_sparsity_pattern_in)
<a name="l00125"></a>00125     {}
<a name="l00126"></a>00126 
<a name="l00127"></a><a class="code" href="classSparsityPattern_1_1Build.php#a768fc8d2c13599397d4b41a20ea1f3c7">00127</a>     <a class="code" href="classSparsityPattern_1_1Build.php#a11a6fe530cdf7387ea3359f961bdcc9d">Build</a> (<a class="code" href="classSparsityPattern_1_1Build.php">Build</a> &amp;other, <a class="code" href="classThreads_1_1split.php">Threads::split</a>) :
<a name="l00128"></a>00128       <a class="code" href="classSparsityPattern_1_1Build.php#a8dfe00458fdffa32b6461df05b7b4f16">mesh</a>(other.<a class="code" href="classSparsityPattern_1_1Build.php#a8dfe00458fdffa32b6461df05b7b4f16">mesh</a>),
<a name="l00129"></a>00129       <a class="code" href="classSparsityPattern_1_1Build.php#aa25aa26eabe02d301da420af81f8d38f">dof_map</a>(other.<a class="code" href="classSparsityPattern_1_1Build.php#aa25aa26eabe02d301da420af81f8d38f">dof_map</a>),
<a name="l00130"></a>00130       <a class="code" href="classSparsityPattern_1_1Build.php#accbeb2e353d5791440f9d2b1ef1742e7">dof_coupling</a>(other.<a class="code" href="classSparsityPattern_1_1Build.php#accbeb2e353d5791440f9d2b1ef1742e7">dof_coupling</a>),
<a name="l00131"></a>00131       <a class="code" href="classSparsityPattern_1_1Build.php#ae23a805dd67ee6f28494b0477f59173f">implicit_neighbor_dofs</a>(other.<a class="code" href="classSparsityPattern_1_1Build.php#ae23a805dd67ee6f28494b0477f59173f">implicit_neighbor_dofs</a>),
<a name="l00132"></a>00132       <a class="code" href="classSparsityPattern_1_1Build.php#a7391c2b856f66ea6e659fcf1fb9d02e4">need_full_sparsity_pattern</a>(other.<a class="code" href="classSparsityPattern_1_1Build.php#a7391c2b856f66ea6e659fcf1fb9d02e4">need_full_sparsity_pattern</a>)
<a name="l00133"></a>00133     {}
<a name="l00134"></a>00134 
<a name="l00135"></a>00135     <span class="keywordtype">void</span> <a class="code" href="classSparsityPattern_1_1Build.php#ab923b00f57240c48fa6171f762e92f47">operator()</a>(<span class="keyword">const</span> <a class="code" href="classStoredRange.php">ConstElemRange</a> &amp;range);
<a name="l00136"></a>00136 
<a name="l00137"></a>00137     <span class="keywordtype">void</span> <a class="code" href="classSparsityPattern_1_1Build.php#a6bd8b255d207b566d298bba535e0f2e0">join</a> (<span class="keyword">const</span> <a class="code" href="classSparsityPattern_1_1Build.php">Build</a> &amp;other);
<a name="l00138"></a>00138   };
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 <span class="preprocessor">#if defined(__GNUC__) &amp;&amp; (__GNUC__ &lt; 4) &amp;&amp; !defined(__INTEL_COMPILER)</span>
<a name="l00141"></a>00141 <span class="preprocessor"></span>
<a name="l00146"></a>00146   <span class="keywordtype">void</span> <a class="code" href="namespaceSparsityPattern.php#a853789831aeb290de9ca4a4a33c71ea9">_dummy_function</a>(<span class="keywordtype">void</span>);
<a name="l00147"></a>00147 <span class="preprocessor">#endif</span>
<a name="l00148"></a>00148 <span class="preprocessor"></span>  
<a name="l00149"></a>00149 }
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00155"></a>00155 <span class="comment">// AMR constraint matrix types</span>
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l00158"></a>00158 <span class="preprocessor"></span>
<a name="l00161"></a>00161 <span class="keyword">typedef</span> std::map&lt;<span class="keywordtype">unsigned</span> int, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>, 
<a name="l00162"></a>00162                  std::less&lt;unsigned int&gt;, 
<a name="l00163"></a><a class="code" href="dof__map_8h.php#a553e286d6e25f03a15b1c300bc373791">00163</a>                  <a class="code" href="classThreads_1_1scalable__allocator.php">Threads::scalable_allocator&lt;std::pair&lt;const unsigned int, Real&gt;</a> &gt; &gt; <a class="code" href="dof__map_8h.php#a553e286d6e25f03a15b1c300bc373791">DofConstraintRow</a>;
<a name="l00164"></a>00164 
<a name="l00171"></a><a class="code" href="classDofConstraints.php">00171</a> <span class="keyword">class </span><a class="code" href="classDofConstraints.php">DofConstraints</a> : <span class="keyword">public</span> std::<a class="code" href="classstd_1_1map.php">map</a>&lt;unsigned int, 
<a name="l00172"></a>00172                                        DofConstraintRow, 
<a name="l00173"></a>00173                                        std::less&lt;unsigned int&gt;, 
<a name="l00174"></a>00174                                        Threads::scalable_allocator&lt;std::pair&lt;const unsigned int, DofConstraintRow&gt; &gt; &gt;
<a name="l00175"></a>00175 {
<a name="l00176"></a>00176 };
<a name="l00177"></a>00177 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR || LIBMESH_ENABLE_PERIODIC</span>
<a name="l00178"></a>00178 <span class="preprocessor"></span>
<a name="l00179"></a>00179   
<a name="l00180"></a>00180 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00181"></a>00181 <span class="comment">// Periodic boundary conditions information</span>
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00184"></a>00184 <span class="preprocessor"></span>
<a name="l00187"></a><a class="code" href="classPeriodicBoundary.php">00187</a> <span class="keyword">class </span><a class="code" href="classPeriodicBoundary.php">PeriodicBoundary</a>
<a name="l00188"></a>00188 {
<a name="l00189"></a>00189 <span class="keyword">public</span>:
<a name="l00190"></a>00190   <span class="comment">// The boundary ID of this boundary and it&#39;s counterpart</span>
<a name="l00191"></a><a class="code" href="classPeriodicBoundary.php#a5fbfff381a611f2c487053f0f16df31a">00191</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPeriodicBoundary.php#ac9859c1b6fb690dc75bff9a075b1247c">myboundary</a>,
<a name="l00192"></a>00192                <a class="code" href="classPeriodicBoundary.php#a5fbfff381a611f2c487053f0f16df31a">pairedboundary</a>;
<a name="l00193"></a>00193 
<a name="l00194"></a>00194   <span class="comment">// One of these days we&#39;ll support rotated boundaries</span>
<a name="l00195"></a>00195   <span class="comment">// RealTensor rotation_matrix;</span>
<a name="l00196"></a>00196 
<a name="l00197"></a>00197   <span class="comment">// The vector which is added to points in myboundary</span>
<a name="l00198"></a>00198   <span class="comment">// to produce corresponding points in pairedboundary</span>
<a name="l00199"></a><a class="code" href="classPeriodicBoundary.php#a81e56f6ab6dd6f6c8ff1c5b71516bc1f">00199</a>   <a class="code" href="classVectorValue.php">RealVectorValue</a> <a class="code" href="classPeriodicBoundary.php#a81e56f6ab6dd6f6c8ff1c5b71516bc1f">translation_vector</a>;
<a name="l00200"></a>00200 };
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 
<a name="l00210"></a><a class="code" href="classPeriodicBoundaries.php">00210</a> <span class="keyword">class </span><a class="code" href="classPeriodicBoundaries.php">PeriodicBoundaries</a> : <span class="keyword">public</span> std::<a class="code" href="classstd_1_1map.php">map</a>&lt;unsigned int, PeriodicBoundary&gt;
<a name="l00211"></a>00211 {
<a name="l00212"></a>00212 <span class="keyword">public</span>:
<a name="l00213"></a>00213   <a class="code" href="classPeriodicBoundary.php">PeriodicBoundary</a> *<a class="code" href="classPeriodicBoundaries.php#a685df5a1090d311007db34328ec1647e">boundary</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>);
<a name="l00214"></a>00214 
<a name="l00215"></a><a class="code" href="classPeriodicBoundaries.php#ab5708a5f5e97b69a057230191a4dd8fc">00215</a>   <a class="code" href="classPeriodicBoundaries.php#ab5708a5f5e97b69a057230191a4dd8fc">PeriodicBoundaries</a>() {}
<a name="l00216"></a>00216 
<a name="l00217"></a>00217   <a class="code" href="classPeriodicBoundaries.php#a7248049b4616123c759f861519f8a579">~PeriodicBoundaries</a>();
<a name="l00218"></a>00218 
<a name="l00219"></a>00219   <span class="comment">// The periodic neighbor of \p e in direction \p side, if it</span>
<a name="l00220"></a>00220   <span class="comment">// exists.  NULL otherwise</span>
<a name="l00221"></a>00221   <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *<a class="code" href="classPeriodicBoundaries.php#a316ac41209dd43c1e8a777ea743dff97">neighbor</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> boundary_id, <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh, <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *e, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> side);
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 <span class="keyword">private</span>:
<a name="l00224"></a>00224 };
<a name="l00225"></a>00225 <span class="preprocessor">#endif // LIBMESH_ENABLE_PERIODIC</span>
<a name="l00226"></a>00226 <span class="preprocessor"></span>
<a name="l00227"></a>00227 
<a name="l00228"></a>00228   
<a name="l00229"></a>00229 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00230"></a>00230 <span class="comment">// DofMap class definition</span>
<a name="l00231"></a>00231 
<a name="l00241"></a><a class="code" href="classDofMap.php">00241</a> <span class="keyword">class </span><a class="code" href="classDofMap.php">DofMap</a> : <span class="keyword">public</span> <a class="code" href="classReferenceCountedObject.php">ReferenceCountedObject</a>&lt;DofMap&gt;
<a name="l00242"></a>00242 {
<a name="l00243"></a>00243 <span class="keyword">public</span>:
<a name="l00244"></a>00244 
<a name="l00249"></a>00249   <a class="code" href="classDofMap.php#abefa4b0ae5d29379ef2bad3214415e96">DofMap</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#aec0a44994fb968a2104423cca68ff500">sys_number</a>);
<a name="l00250"></a>00250 
<a name="l00254"></a>00254   <a class="code" href="classDofMap.php#aa7869f6f73f55a110c2667de5a33cfc9">~DofMap</a>();
<a name="l00255"></a>00255 
<a name="l00261"></a>00261   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#abf8a314c9f21240129e140664d04ed53">attach_matrix</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;Number&gt;</a>&amp; matrix);
<a name="l00262"></a>00262 
<a name="l00268"></a>00268   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#acb78beb9cb3a932223a6577457c686d4">distribute_dofs</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp;);
<a name="l00269"></a>00269 
<a name="l00275"></a>00275   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#ab51821ee7bdb1c6fb8f92821afea2530">compute_sparsity</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp;);
<a name="l00276"></a>00276 
<a name="l00282"></a>00282   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#ad46e1ea51922aeb2828beb1527294694">prepare_send_list</a> ();
<a name="l00283"></a>00283   
<a name="l00291"></a><a class="code" href="classDofMap.php#a6c7f0c7286f9f067563e8da24d4f3955">00291</a>   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <a class="code" href="classDofMap.php#a6c7f0c7286f9f067563e8da24d4f3955">get_send_list</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classDofMap.php#a83806e00bbf1297f50e95d1c93f7a8b6">_send_list</a>; }
<a name="l00292"></a>00292   
<a name="l00299"></a><a class="code" href="classDofMap.php#a6925ec300924237ddc0e82987ada4b97">00299</a>   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <a class="code" href="classDofMap.php#a6925ec300924237ddc0e82987ada4b97">get_n_nz</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classDofMap.php#a1a3d7ce4ddc7c2a899156b236494fe23">_n_nz</a>; }
<a name="l00300"></a>00300   
<a name="l00307"></a><a class="code" href="classDofMap.php#ad9998efe9dab85e9beee90367d116fb5">00307</a>   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <a class="code" href="classDofMap.php#ad9998efe9dab85e9beee90367d116fb5">get_n_oz</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classDofMap.php#a3fbe36d4243308c59f7ddd273bae51f0">_n_oz</a>; }
<a name="l00308"></a>00308 
<a name="l00313"></a>00313   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#a71c41090c25a812734d342fbcaf12498">add_variable</a> (<span class="keyword">const</span> <a class="code" href="classSystem_1_1Variable.php">System::Variable</a> &amp;var);
<a name="l00314"></a>00314   
<a name="l00318"></a>00318   <span class="keyword">const</span> <a class="code" href="classSystem_1_1Variable.php">System::Variable</a>&amp; <a class="code" href="classDofMap.php#a77e4bce38abc337921ce8a0d4ee9460d">variable</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c) <span class="keyword">const</span>;
<a name="l00319"></a>00319 
<a name="l00323"></a>00323   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classDofMap.php#a32045dc65a75bb5c78c5ca20358a10f4">variable_order</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c) <span class="keyword">const</span>;
<a name="l00324"></a>00324   
<a name="l00328"></a>00328   <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; <a class="code" href="classDofMap.php#ae3c63266417020f38af6e5cc40efca76">variable_type</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c) <span class="keyword">const</span>;
<a name="l00329"></a>00329   
<a name="l00335"></a><a class="code" href="classDofMap.php#a9658690be6efd4fdfb0cdd5b806748d2">00335</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#a9658690be6efd4fdfb0cdd5b806748d2">n_variables</a>()<span class="keyword"> const</span>
<a name="l00336"></a>00336 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classDofMap.php#a3e9ccce69be8f933be4f077b45ad4104">_variables</a>.size(); }
<a name="l00337"></a>00337   
<a name="l00342"></a><a class="code" href="classDofMap.php#ae7db3f0773e85ababc4f9db1cfa24d3e">00342</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#ae7db3f0773e85ababc4f9db1cfa24d3e">n_dofs</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classDofMap.php#ae6954665b4f9471893dfff74fd70c643">_n_dfs</a>; }
<a name="l00346"></a><a class="code" href="classDofMap.php#a01ce910408a9aca97a8898d11e6adce8">00346</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#a01ce910408a9aca97a8898d11e6adce8">n_SCALAR_dofs</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classDofMap.php#ae00169f4e682f51d64ea1f4e95c5f2df">_n_SCALAR_dofs</a>; }
<a name="l00347"></a>00347 
<a name="l00351"></a><a class="code" href="classDofMap.php#a637eb423db5f6da5838d0d738668e91f">00351</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#a637eb423db5f6da5838d0d738668e91f">n_local_dofs</a> ()<span class="keyword"> const</span>
<a name="l00352"></a>00352 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classDofMap.php#a9c7492c5d5f1eacd327f0c902590eda7">n_dofs_on_processor</a> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()); }
<a name="l00353"></a>00353 
<a name="l00357"></a><a class="code" href="classDofMap.php#a9c7492c5d5f1eacd327f0c902590eda7">00357</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#a9c7492c5d5f1eacd327f0c902590eda7">n_dofs_on_processor</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc)<span class="keyword"> const</span>
<a name="l00358"></a>00358 <span class="keyword">  </span>{ libmesh_assert(proc &lt; <a class="code" href="classDofMap.php#a12a958965f4c50fcb94b8ac7967ee472">_first_df</a>.size()); <span class="keywordflow">return</span> (<a class="code" href="classDofMap.php#a269555a44eebdf18497433c382ba29e9">_end_df</a>[proc] - <a class="code" href="classDofMap.php#a12a958965f4c50fcb94b8ac7967ee472">_first_df</a>[proc]); }
<a name="l00359"></a>00359 
<a name="l00363"></a><a class="code" href="classDofMap.php#a4908535aa4a29e6441c197c8f7cd594e">00363</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#a4908535aa4a29e6441c197c8f7cd594e">first_dof</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc = <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())<span class="keyword"> const</span>
<a name="l00364"></a>00364 <span class="keyword">  </span>{ libmesh_assert(proc &lt; <a class="code" href="classDofMap.php#a12a958965f4c50fcb94b8ac7967ee472">_first_df</a>.size()); <span class="keywordflow">return</span> <a class="code" href="classDofMap.php#a12a958965f4c50fcb94b8ac7967ee472">_first_df</a>[proc]; }
<a name="l00365"></a>00365   
<a name="l00371"></a><a class="code" href="classDofMap.php#a3659b9da884289985c8b22df20954172">00371</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#a3659b9da884289985c8b22df20954172">last_dof</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc = <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())<span class="keyword"> const</span>
<a name="l00372"></a>00372 <span class="keyword">  </span>{ libmesh_deprecated(); libmesh_assert(proc &lt; <a class="code" href="classDofMap.php#a269555a44eebdf18497433c382ba29e9">_end_df</a>.size()); <span class="keywordflow">return</span> (<a class="code" href="classDofMap.php#a269555a44eebdf18497433c382ba29e9">_end_df</a>[proc] - 1); }  
<a name="l00373"></a>00373 
<a name="l00378"></a><a class="code" href="classDofMap.php#ab838f2e72aaf8614c97fcd47a13781b8">00378</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#ab838f2e72aaf8614c97fcd47a13781b8">end_dof</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc = <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())<span class="keyword"> const</span>
<a name="l00379"></a>00379 <span class="keyword">  </span>{ libmesh_assert(proc &lt; <a class="code" href="classDofMap.php#a269555a44eebdf18497433c382ba29e9">_end_df</a>.size()); <span class="keywordflow">return</span> <a class="code" href="classDofMap.php#a269555a44eebdf18497433c382ba29e9">_end_df</a>[proc]; }
<a name="l00380"></a>00380   
<a name="l00384"></a><a class="code" href="classDofMap.php#aebd72b516a005ebaad60efa986c9134c">00384</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#aebd72b516a005ebaad60efa986c9134c">variable_first_local_dof</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)<span class="keyword"> const</span>
<a name="l00385"></a>00385 <span class="keyword">  </span>{ 
<a name="l00386"></a>00386     libmesh_assert ((var+1) &lt; <a class="code" href="classDofMap.php#a8592d66151f1635707d6522dfb1bb59e">_var_first_local_df</a>.size());
<a name="l00387"></a>00387     libmesh_assert (<a class="code" href="classDofMap.php#a8592d66151f1635707d6522dfb1bb59e">_var_first_local_df</a>[var] != <a class="code" href="classDofObject.php#a35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>);
<a name="l00388"></a>00388     <span class="keywordflow">return</span> <a class="code" href="classDofMap.php#a8592d66151f1635707d6522dfb1bb59e">_var_first_local_df</a>[var];
<a name="l00389"></a>00389   }
<a name="l00390"></a>00390 
<a name="l00395"></a><a class="code" href="classDofMap.php#a1b1d4cbc0b77ed7309e6d3c45b821fd0">00395</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#a1b1d4cbc0b77ed7309e6d3c45b821fd0">variable_last_local_dof</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)<span class="keyword"> const</span>
<a name="l00396"></a>00396 <span class="keyword">  </span>{ 
<a name="l00397"></a>00397     libmesh_assert ((var+1) &lt; <a class="code" href="classDofMap.php#a8592d66151f1635707d6522dfb1bb59e">_var_first_local_df</a>.size());
<a name="l00398"></a>00398     libmesh_assert (<a class="code" href="classDofMap.php#a8592d66151f1635707d6522dfb1bb59e">_var_first_local_df</a>[var+1] != <a class="code" href="classDofObject.php#a35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>);
<a name="l00399"></a>00399     <span class="keywordflow">return</span> <a class="code" href="classDofMap.php#a8592d66151f1635707d6522dfb1bb59e">_var_first_local_df</a>[var+1];
<a name="l00400"></a>00400   }
<a name="l00401"></a>00401 
<a name="l00407"></a>00407   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#afc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00408"></a>00408                     std::vector&lt;unsigned int&gt;&amp; di,
<a name="l00409"></a>00409                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>) <span class="keyword">const</span>;
<a name="l00410"></a>00410 
<a name="l00417"></a>00417   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#aae2de9e948e710370f568bfde80d70b1">SCALAR_dof_indices</a> (std::vector&lt;unsigned int&gt;&amp; di,
<a name="l00418"></a>00418                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn,
<a name="l00419"></a>00419                            <span class="keyword">const</span> <span class="keywordtype">bool</span> old_dofs=<span class="keyword">false</span>) <span class="keyword">const</span>;
<a name="l00420"></a>00420 
<a name="l00427"></a>00427   <span class="keywordtype">bool</span> <a class="code" href="classDofMap.php#ab8138ba1a23074b2424c6fd85c9a6d0b">use_coupled_neighbor_dofs</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh) <span class="keyword">const</span>;
<a name="l00428"></a>00428 
<a name="l00439"></a>00439   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#acfbb9dbe71246f5d086077a3f4a5cced">extract_local_vector</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp; Ug,
<a name="l00440"></a>00440                              <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <a class="code" href="classDofMap.php#afc5ee41412dcab63d5507efbf5d8482d">dof_indices</a>,
<a name="l00441"></a>00441                              <a class="code" href="classDenseVectorBase.php">DenseVectorBase&lt;Number&gt;</a>&amp; Ue) <span class="keyword">const</span>;
<a name="l00442"></a>00442 
<a name="l00443"></a>00443 
<a name="l00444"></a>00444 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l00445"></a>00445 <span class="preprocessor"></span>
<a name="l00446"></a>00446   <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00447"></a>00447   <span class="comment">// Constraint-specific methods</span>
<a name="l00452"></a><a class="code" href="classDofMap.php#a21b11cc37b86c4f3acb07ab195bcfe9e">00452</a> <span class="comment"></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#a21b11cc37b86c4f3acb07ab195bcfe9e">n_constrained_dofs</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classDofMap.php#af301f7e968260dd826d4479a1a8884e8">_dof_constraints</a>.size(); }
<a name="l00453"></a>00453 
<a name="l00457"></a>00457   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#af1f92941497518ad397931254d1b64dd">create_dof_constraints</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00458"></a>00458 
<a name="l00462"></a>00462   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#abb16f3e9dad6705d0e9c3cb3d844e2c3">allgather_recursive_constraints</a> ();
<a name="l00463"></a>00463 
<a name="l00471"></a>00471   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#a82bc3d59f228ea13ec3ab2effe4b8334">process_constraints</a> ();
<a name="l00472"></a>00472 
<a name="l00477"></a>00477   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#a057a39ab5121834878855aaaff7160db">add_constraint_row</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dof_number,
<a name="l00478"></a>00478                            <span class="keyword">const</span> DofConstraintRow&amp; constraint_row,
<a name="l00479"></a>00479                            <span class="keyword">const</span> <span class="keywordtype">bool</span> forbid_constraint_overwrite = <span class="keyword">true</span>);
<a name="l00480"></a>00480   
<a name="l00485"></a>00485   <span class="keywordtype">bool</span> <a class="code" href="classDofMap.php#a923a6811ca54a01cc1e6dee8570a281f">is_constrained_dof</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dof) <span class="keyword">const</span>;
<a name="l00486"></a>00486   
<a name="l00490"></a>00490   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#a05b33347b0a592da5de72a406868684b">print_dof_constraints</a>(std::ostream&amp; os=std::cout) <span class="keyword">const</span>;
<a name="l00491"></a>00491 
<a name="l00500"></a>00500   std::pair&lt;Real, Real&gt; <a class="code" href="classDofMap.php#af8c7226ce43e029feb5d16da70480725">max_constraint_error</a>(<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a> &amp;system,
<a name="l00501"></a>00501                                              <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> *v = NULL) <span class="keyword">const</span>;
<a name="l00502"></a>00502 
<a name="l00503"></a>00503 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR || LIBMESH_ENABLE_PERIODIC</span>
<a name="l00504"></a>00504 <span class="preprocessor"></span>
<a name="l00505"></a>00505   <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00506"></a>00506   <span class="comment">// Constraint-specific methods</span>
<a name="l00507"></a>00507   <span class="comment">// Some of these methods are enabled (but inlined away to nothing)</span>
<a name="l00508"></a>00508   <span class="comment">// when constraints are disabled at configure-time.  This is to</span>
<a name="l00509"></a>00509   <span class="comment">// increase API compatibility of user code with different library</span>
<a name="l00510"></a>00510   <span class="comment">// builds.</span>
<a name="l00511"></a>00511 
<a name="l00525"></a>00525   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#ab03892878c3a760e5ffdcf16dd6a7db9">constrain_element_matrix</a> (<a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Number&gt;</a>&amp; matrix,
<a name="l00526"></a>00526                                  std::vector&lt;unsigned int&gt;&amp; elem_dofs,
<a name="l00527"></a>00527                                  <span class="keywordtype">bool</span> asymmetric_constraint_rows = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00528"></a>00528   
<a name="l00535"></a>00535   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#ab03892878c3a760e5ffdcf16dd6a7db9">constrain_element_matrix</a> (<a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Number&gt;</a>&amp; matrix,
<a name="l00536"></a>00536                                  std::vector&lt;unsigned int&gt;&amp; row_dofs,
<a name="l00537"></a>00537                                  std::vector&lt;unsigned int&gt;&amp; col_dofs,
<a name="l00538"></a>00538                                  <span class="keywordtype">bool</span> asymmetric_constraint_rows = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00539"></a>00539   
<a name="l00543"></a>00543   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#a60d43d6b832336a9c70527024e1ffdc8">constrain_element_vector</a> (<a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a>&amp;       rhs,
<a name="l00544"></a>00544                                  std::vector&lt;unsigned int&gt;&amp; dofs,
<a name="l00545"></a>00545                                  <span class="keywordtype">bool</span> asymmetric_constraint_rows = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00546"></a>00546   
<a name="l00555"></a>00555   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#af32c351cce81588e65370dd14e820fb4">constrain_element_matrix_and_vector</a> (<a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Number&gt;</a>&amp; matrix,
<a name="l00556"></a>00556                                             <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a>&amp; rhs,
<a name="l00557"></a>00557                                             std::vector&lt;unsigned int&gt;&amp; elem_dofs,
<a name="l00558"></a>00558                                             <span class="keywordtype">bool</span> asymmetric_constraint_rows = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00559"></a>00559 
<a name="l00568"></a>00568   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#a0af0331bbbec5019a9fca56b136a7521">constrain_element_dyad_matrix</a> (<a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a>&amp; v,
<a name="l00569"></a>00569                                       <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a>&amp; w,
<a name="l00570"></a>00570                                       std::vector&lt;unsigned int&gt;&amp; row_dofs,
<a name="l00571"></a>00571                                       <span class="keywordtype">bool</span> asymmetric_constraint_rows = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00572"></a>00572 
<a name="l00579"></a>00579   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#a53f0029cc281bc056a3c1cb6e59fbe56">constrain_nothing</a> (std::vector&lt;unsigned int&gt;&amp; dofs) <span class="keyword">const</span>;
<a name="l00580"></a>00580   
<a name="l00589"></a>00589   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#ab8f806aded3f8351a9f0f6bbf8ae8274">enforce_constraints_exactly</a> (<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a> &amp;system,
<a name="l00590"></a>00590                                     <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> *v = NULL) <span class="keyword">const</span>;
<a name="l00591"></a>00591   
<a name="l00592"></a>00592 
<a name="l00593"></a>00593 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00594"></a>00594 <span class="preprocessor"></span>
<a name="l00595"></a>00595   <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00596"></a>00596   <span class="comment">// PeriodicBoundary-specific methods</span>
<a name="l00597"></a>00597 
<a name="l00601"></a>00601   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#a480d0f46133d4110d6e64fc3fdbb4495">add_periodic_boundary</a> (<span class="keyword">const</span> <a class="code" href="classPeriodicBoundary.php">PeriodicBoundary</a>&amp; periodic_boundary);
<a name="l00602"></a>00602 
<a name="l00607"></a>00607   <span class="keywordtype">bool</span> <a class="code" href="classDofMap.php#ae73a049769b3029331b5de3ff734c030">is_periodic_boundary</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> boundaryid) <span class="keyword">const</span>;
<a name="l00608"></a>00608 
<a name="l00609"></a>00609 <span class="preprocessor">#endif // LIBMESH_ENABLE_PERIODIC</span>
<a name="l00610"></a>00610 <span class="preprocessor"></span>
<a name="l00611"></a>00611 
<a name="l00612"></a>00612 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00613"></a>00613 <span class="preprocessor"></span>
<a name="l00614"></a>00614   <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00615"></a>00615   <span class="comment">// AMR-specific methods</span>
<a name="l00616"></a>00616 
<a name="l00625"></a>00625   <span class="comment">// void augment_send_list_for_projection(const MeshBase &amp;);</span>
<a name="l00626"></a>00626 
<a name="l00633"></a>00633   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#a36e8bfaebc24fb9ac8919e5fc1e6f687">old_dof_indices</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00634"></a>00634                         std::vector&lt;unsigned int&gt;&amp; di,
<a name="l00635"></a>00635                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>) <span class="keyword">const</span>;
<a name="l00640"></a><a class="code" href="classDofMap.php#a17f186f2dad6ab7bf0bf88f148149b06">00640</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#a17f186f2dad6ab7bf0bf88f148149b06">n_old_dofs</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classDofMap.php#a9073a73bc3c155cc0a89884b97860c19">_n_old_dfs</a>; }
<a name="l00641"></a>00641 
<a name="l00647"></a>00647   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#a46e33bcb48c4ecf870dc5b39862f9340">constrain_p_dofs</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00648"></a>00648                          <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *elem,
<a name="l00649"></a>00649                          <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00650"></a>00650                          <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p);
<a name="l00651"></a>00651   
<a name="l00652"></a>00652 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR</span>
<a name="l00653"></a>00653 <span class="preprocessor"></span>
<a name="l00657"></a>00657   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#aed3c9f2c9e0ef0019fba7bb1c1c2a6db">reinit</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00658"></a>00658   
<a name="l00662"></a>00662   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#ae0336e2fe65c48efdc56ea25f3d4126e">clear</a> ();
<a name="l00663"></a>00663   
<a name="l00677"></a><a class="code" href="classDofMap.php#a4d50b4c013a93b8036c126ced15ecbe6">00677</a>   <a class="code" href="classCouplingMatrix.php">CouplingMatrix</a>* <a class="code" href="classDofMap.php#a4d50b4c013a93b8036c126ced15ecbe6">_dof_coupling</a>;
<a name="l00678"></a>00678 
<a name="l00679"></a>00679   
<a name="l00680"></a>00680 <span class="keyword">private</span>:
<a name="l00681"></a>00681   
<a name="l00685"></a>00685   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#aec0a44994fb968a2104423cca68ff500">sys_number</a>() <span class="keyword">const</span>;
<a name="l00686"></a>00686 
<a name="l00690"></a>00690   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#af4df7a1bb1553a016e9c9828e5bfabca">invalidate_dofs</a>(<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh) <span class="keyword">const</span>;
<a name="l00691"></a>00691 
<a name="l00695"></a>00695   <a class="code" href="classDofObject.php">DofObject</a>* <a class="code" href="classDofMap.php#ace354d1aea94151ea259e3e084fdac37">node_ptr</a>(<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00696"></a>00696 
<a name="l00700"></a>00700   <a class="code" href="classDofObject.php">DofObject</a>* <a class="code" href="classDofMap.php#a7769da176038f8f29b8de691c838f19d">elem_ptr</a>(<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00701"></a>00701 
<a name="l00705"></a>00705   <span class="keyword">typedef</span> <a class="code" href="classDofObject.php">DofObject</a>* (<a class="code" href="classDofMap.php">DofMap</a>::*<a class="code" href="classDofMap.php#a0dd777e2f2d8102a6247aed2204907fa">dofobject_accessor</a>)
<a name="l00706"></a><a class="code" href="classDofMap.php#a0dd777e2f2d8102a6247aed2204907fa">00706</a>     (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00707"></a>00707   
<a name="l00711"></a>00711   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> iterator_type&gt;
<a name="l00712"></a>00712   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#a6d4ceeec9e3656d39038f9f8030edbeb">set_nonlocal_dof_objects</a>(iterator_type objects_begin,
<a name="l00713"></a>00713                                 iterator_type objects_end,
<a name="l00714"></a>00714                                 <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00715"></a>00715                                 <a class="code" href="classDofMap.php#a0dd777e2f2d8102a6247aed2204907fa">dofobject_accessor</a> objects);
<a name="l00716"></a>00716 
<a name="l00725"></a>00725   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#ab4b5f48efe6a8994e673ba1fe9b87409">distribute_local_dofs_var_major</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; next_free_dof,
<a name="l00726"></a>00726                                         <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00727"></a>00727   
<a name="l00740"></a>00740   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#a60d9bace2cf72a1d02d22b4976a5fb67">distribute_local_dofs_node_major</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; next_free_dof,
<a name="l00741"></a>00741                                          <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00742"></a>00742     
<a name="l00747"></a>00747   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#a2f3a85a70469f194d37b1e13f222683a">add_neighbors_to_send_list</a>(<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00748"></a>00748 
<a name="l00749"></a>00749 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l00750"></a>00750 <span class="preprocessor"></span>
<a name="l00761"></a>00761   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#ac6f698a546466fbd8a8b5ca355d54013">build_constraint_matrix</a> (<a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Number&gt;</a>&amp; C,
<a name="l00762"></a>00762                                 std::vector&lt;unsigned int&gt;&amp; elem_dofs,
<a name="l00763"></a>00763                                 <span class="keyword">const</span> <span class="keywordtype">bool</span> called_recursively=<span class="keyword">false</span>) <span class="keyword">const</span>;
<a name="l00764"></a>00764 
<a name="l00769"></a>00769   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#a7020b9e29c89828384a6480f07eadd43">find_connected_dofs</a> (std::vector&lt;unsigned int&gt; &amp;elem_dofs) <span class="keyword">const</span>;
<a name="l00770"></a>00770   
<a name="l00776"></a>00776   <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#ac043fc716f4efbf815bb85c34050a892">add_constraints_to_send_list</a>();
<a name="l00777"></a>00777 
<a name="l00778"></a>00778 <span class="preprocessor">#endif</span>
<a name="l00779"></a>00779 <span class="preprocessor"></span>
<a name="l00780"></a>00780 
<a name="l00784"></a><a class="code" href="classDofMap.php#a3e9ccce69be8f933be4f077b45ad4104">00784</a>   std::vector&lt;System::Variable&gt; <a class="code" href="classDofMap.php#a3e9ccce69be8f933be4f077b45ad4104">_variables</a>;
<a name="l00785"></a>00785 
<a name="l00789"></a><a class="code" href="classDofMap.php#a1095597fa928f23c87e5963224e7a1c7">00789</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#a1095597fa928f23c87e5963224e7a1c7">_sys_number</a>;
<a name="l00790"></a>00790   
<a name="l00796"></a><a class="code" href="classDofMap.php#afcf540dc957d2a3d4c3acff70e6513c1">00796</a>   std::vector&lt;SparseMatrix&lt;Number&gt;* &gt; <a class="code" href="classDofMap.php#afcf540dc957d2a3d4c3acff70e6513c1">_matrices</a>;
<a name="l00797"></a>00797   
<a name="l00801"></a><a class="code" href="classDofMap.php#a12a958965f4c50fcb94b8ac7967ee472">00801</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classDofMap.php#a12a958965f4c50fcb94b8ac7967ee472">_first_df</a>;
<a name="l00802"></a>00802 
<a name="l00806"></a><a class="code" href="classDofMap.php#a269555a44eebdf18497433c382ba29e9">00806</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classDofMap.php#a269555a44eebdf18497433c382ba29e9">_end_df</a>;
<a name="l00807"></a>00807 
<a name="l00811"></a><a class="code" href="classDofMap.php#a8592d66151f1635707d6522dfb1bb59e">00811</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classDofMap.php#a8592d66151f1635707d6522dfb1bb59e">_var_first_local_df</a>;
<a name="l00812"></a>00812   
<a name="l00817"></a><a class="code" href="classDofMap.php#a83806e00bbf1297f50e95d1c93f7a8b6">00817</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classDofMap.php#a83806e00bbf1297f50e95d1c93f7a8b6">_send_list</a>;
<a name="l00818"></a>00818 
<a name="l00823"></a><a class="code" href="classDofMap.php#a1a3d7ce4ddc7c2a899156b236494fe23">00823</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classDofMap.php#a1a3d7ce4ddc7c2a899156b236494fe23">_n_nz</a>;
<a name="l00824"></a>00824   
<a name="l00829"></a><a class="code" href="classDofMap.php#a3fbe36d4243308c59f7ddd273bae51f0">00829</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classDofMap.php#a3fbe36d4243308c59f7ddd273bae51f0">_n_oz</a>;
<a name="l00830"></a>00830 
<a name="l00834"></a><a class="code" href="classDofMap.php#ae6954665b4f9471893dfff74fd70c643">00834</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#ae6954665b4f9471893dfff74fd70c643">_n_dfs</a>;
<a name="l00835"></a>00835 
<a name="l00840"></a><a class="code" href="classDofMap.php#ae00169f4e682f51d64ea1f4e95c5f2df">00840</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#ae00169f4e682f51d64ea1f4e95c5f2df">_n_SCALAR_dofs</a>;
<a name="l00841"></a>00841 
<a name="l00842"></a>00842 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00843"></a>00843 <span class="preprocessor"></span>
<a name="l00847"></a><a class="code" href="classDofMap.php#a9073a73bc3c155cc0a89884b97860c19">00847</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#a9073a73bc3c155cc0a89884b97860c19">_n_old_dfs</a>;
<a name="l00848"></a>00848 
<a name="l00849"></a>00849 <span class="preprocessor">#endif</span>
<a name="l00850"></a>00850 <span class="preprocessor"></span>
<a name="l00851"></a>00851 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l00852"></a>00852 <span class="preprocessor"></span>
<a name="l00857"></a><a class="code" href="classDofMap.php#af301f7e968260dd826d4479a1a8884e8">00857</a>   <a class="code" href="classDofConstraints.php">DofConstraints</a> <a class="code" href="classDofMap.php#af301f7e968260dd826d4479a1a8884e8">_dof_constraints</a>;
<a name="l00858"></a>00858 
<a name="l00859"></a>00859 <span class="preprocessor">#endif</span>
<a name="l00860"></a>00860 <span class="preprocessor"></span>
<a name="l00861"></a>00861 
<a name="l00862"></a>00862 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00863"></a>00863 <span class="preprocessor"></span>
<a name="l00867"></a><a class="code" href="classDofMap.php#a1000052a5ccbd8482c3072cfb2621b17">00867</a>   <a class="code" href="classPeriodicBoundaries.php">PeriodicBoundaries</a> <a class="code" href="classDofMap.php#a1000052a5ccbd8482c3072cfb2621b17">_periodic_boundaries</a>;
<a name="l00868"></a>00868 <span class="preprocessor">#endif</span>
<a name="l00869"></a>00869 <span class="preprocessor"></span>
<a name="l00870"></a><a class="code" href="classDofMap.php#a298e05b1935249e7045795d918f46d70">00870</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classSparsityPattern_1_1Build.php">SparsityPattern::Build</a>;
<a name="l00871"></a>00871 };
<a name="l00872"></a>00872 
<a name="l00873"></a>00873 
<a name="l00874"></a>00874 
<a name="l00875"></a>00875 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00876"></a>00876 <span class="comment">// Dof Map inline member functions</span>
<a name="l00877"></a>00877 <span class="keyword">inline</span>
<a name="l00878"></a><a class="code" href="classDofMap.php#abefa4b0ae5d29379ef2bad3214415e96">00878</a> <a class="code" href="classDofMap.php#abefa4b0ae5d29379ef2bad3214415e96">DofMap::DofMap</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :
<a name="l00879"></a>00879   _dof_coupling(NULL),
<a name="l00880"></a>00880   _sys_number(number),
<a name="l00881"></a>00881 <span class="comment">//  _matrix(NULL),</span>
<a name="l00882"></a>00882   _n_dfs(0),
<a name="l00883"></a>00883   _n_SCALAR_dofs(0)
<a name="l00884"></a>00884 #ifdef LIBMESH_ENABLE_AMR
<a name="l00885"></a>00885   , _n_old_dfs(0)
<a name="l00886"></a>00886 #endif
<a name="l00887"></a>00887 {
<a name="l00888"></a>00888   <a class="code" href="classDofMap.php#afcf540dc957d2a3d4c3acff70e6513c1">_matrices</a>.clear();
<a name="l00889"></a>00889 }
<a name="l00890"></a>00890 
<a name="l00891"></a>00891 
<a name="l00892"></a>00892 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l00893"></a>00893 <span class="preprocessor"></span>
<a name="l00894"></a>00894 <span class="keyword">inline</span>
<a name="l00895"></a><a class="code" href="classDofMap.php#a923a6811ca54a01cc1e6dee8570a281f">00895</a> <span class="keywordtype">bool</span> <a class="code" href="classDofMap.php#a923a6811ca54a01cc1e6dee8570a281f">DofMap::is_constrained_dof</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dof)<span class="keyword"> const</span>
<a name="l00896"></a>00896 <span class="keyword"></span>{
<a name="l00897"></a>00897   <span class="keywordflow">if</span> (<a class="code" href="classDofMap.php#af301f7e968260dd826d4479a1a8884e8">_dof_constraints</a>.count(dof) != 0)
<a name="l00898"></a>00898     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00899"></a>00899 
<a name="l00900"></a>00900   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00901"></a>00901 }
<a name="l00902"></a>00902 
<a name="l00903"></a>00903 <span class="preprocessor">#endif</span>
<a name="l00904"></a>00904 <span class="preprocessor"></span>
<a name="l00905"></a>00905 
<a name="l00906"></a>00906 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00907"></a>00907 <span class="preprocessor"></span>
<a name="l00908"></a>00908 <span class="keyword">inline</span>
<a name="l00909"></a><a class="code" href="classDofMap.php#ae73a049769b3029331b5de3ff734c030">00909</a> <span class="keywordtype">bool</span> <a class="code" href="classDofMap.php#ae73a049769b3029331b5de3ff734c030">DofMap::is_periodic_boundary</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> boundaryid)<span class="keyword"> const</span>
<a name="l00910"></a>00910 <span class="keyword"></span>{
<a name="l00911"></a>00911   <span class="keywordflow">if</span> (<a class="code" href="classDofMap.php#a1000052a5ccbd8482c3072cfb2621b17">_periodic_boundaries</a>.count(boundaryid) != 0)
<a name="l00912"></a>00912     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00913"></a>00913 
<a name="l00914"></a>00914   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00915"></a>00915 }
<a name="l00916"></a>00916 
<a name="l00917"></a>00917 <span class="preprocessor">#endif</span>
<a name="l00918"></a>00918 <span class="preprocessor"></span>
<a name="l00919"></a>00919 
<a name="l00920"></a>00920 <span class="keyword">inline</span>
<a name="l00921"></a><a class="code" href="classDofMap.php#aec0a44994fb968a2104423cca68ff500">00921</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#aec0a44994fb968a2104423cca68ff500">DofMap::sys_number</a>()<span class="keyword"> const</span>
<a name="l00922"></a>00922 <span class="keyword"></span>{
<a name="l00923"></a>00923   <span class="keywordflow">return</span> <a class="code" href="classDofMap.php#a1095597fa928f23c87e5963224e7a1c7">_sys_number</a>;
<a name="l00924"></a>00924 }
<a name="l00925"></a>00925 
<a name="l00926"></a>00926 
<a name="l00927"></a>00927 
<a name="l00928"></a>00928 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00929"></a>00929 <span class="comment">// SparsityPattern inline member functions</span>
<a name="l00930"></a>00930 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> B<span class="keywordtype">id</span>irectionalIterator&gt;
<a name="l00931"></a>00931 <span class="keyword">inline</span>
<a name="l00932"></a><a class="code" href="namespaceSparsityPattern.php#abcab8a87e8229861015b1de4bc8f60ff">00932</a> <span class="keywordtype">void</span> <a class="code" href="namespaceSparsityPattern.php#abcab8a87e8229861015b1de4bc8f60ff">SparsityPattern::sort_row</a> (<span class="keyword">const</span> BidirectionalIterator begin,
<a name="l00933"></a>00933                                 BidirectionalIterator       middle,
<a name="l00934"></a>00934                                 <span class="keyword">const</span> BidirectionalIterator end)
<a name="l00935"></a>00935 {
<a name="l00936"></a>00936   <span class="keywordflow">if</span> ((begin == middle) || (middle == end)) <span class="keywordflow">return</span>;
<a name="l00937"></a>00937 
<a name="l00938"></a>00938   libmesh_assert (std::distance (begin,  middle) &gt; 0);
<a name="l00939"></a>00939   libmesh_assert (std::distance (middle, end)    &gt; 0);
<a name="l00940"></a>00940   libmesh_assert (std::unique (begin,  middle) == middle);
<a name="l00941"></a>00941   libmesh_assert (std::unique (middle, end)    == end);
<a name="l00942"></a>00942   
<a name="l00943"></a>00943   <span class="keywordflow">while</span> (middle != end)
<a name="l00944"></a>00944     {
<a name="l00945"></a>00945       BidirectionalIterator
<a name="l00946"></a>00946         b = middle,
<a name="l00947"></a>00947         a = b-1;
<a name="l00948"></a>00948 
<a name="l00949"></a>00949       <span class="comment">// Bubble-sort the middle value downward</span>
<a name="l00950"></a>00950       <span class="keywordflow">while</span> (!(*a &lt; *b)) <span class="comment">// *a &amp; *b are less-than comparable, so use &lt;</span>
<a name="l00951"></a>00951         {
<a name="l00952"></a>00952           std::swap (*a, *b);
<a name="l00953"></a>00953 
<a name="l00954"></a>00954 <span class="preprocessor">#if defined(__GNUC__) &amp;&amp; (__GNUC__ &lt; 4) &amp;&amp; !defined(__INTEL_COMPILER)</span>
<a name="l00955"></a>00955 <span class="preprocessor"></span>          <span class="comment">/* Prohibit optimization at this point since gcc 3.3.5 seems</span>
<a name="l00956"></a>00956 <span class="comment">             to have a bug.  */</span>
<a name="l00957"></a>00957           <a class="code" href="namespaceSparsityPattern.php#a853789831aeb290de9ca4a4a33c71ea9">SparsityPattern::_dummy_function</a>();
<a name="l00958"></a>00958 <span class="preprocessor">#endif</span>
<a name="l00959"></a>00959 <span class="preprocessor"></span>
<a name="l00960"></a>00960           <span class="keywordflow">if</span> (a == begin) <span class="keywordflow">break</span>;
<a name="l00961"></a>00961           
<a name="l00962"></a>00962           b=a;
<a name="l00963"></a>00963           --a;
<a name="l00964"></a>00964         }
<a name="l00965"></a>00965       
<a name="l00966"></a>00966       ++middle;
<a name="l00967"></a>00967     }
<a name="l00968"></a>00968 
<a name="l00969"></a>00969   <span class="comment">// Assure the algorithm worked if we are in DEBUG mode</span>
<a name="l00970"></a>00970 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00971"></a>00971 <span class="preprocessor"></span>  {
<a name="l00972"></a>00972     <span class="comment">// SGI STL extension!</span>
<a name="l00973"></a>00973     <span class="comment">// libmesh_assert (std::is_sorted(begin,end));</span>
<a name="l00974"></a>00974     
<a name="l00975"></a>00975     BidirectionalIterator
<a name="l00976"></a>00976       prev  = begin,
<a name="l00977"></a>00977       first = begin;
<a name="l00978"></a>00978 
<a name="l00979"></a>00979     <span class="keywordflow">for</span> (++first; first != end; prev=first, ++first)
<a name="l00980"></a>00980       <span class="keywordflow">if</span> (*first &lt; *prev)
<a name="l00981"></a>00981         libmesh_assert(<span class="keyword">false</span>);
<a name="l00982"></a>00982   }  
<a name="l00983"></a>00983 <span class="preprocessor">#endif</span>
<a name="l00984"></a>00984 <span class="preprocessor"></span>
<a name="l00985"></a>00985   <span class="comment">// Make sure the two ranges did not contain any common elements</span>
<a name="l00986"></a>00986   libmesh_assert (std::unique (begin, end) == end);
<a name="l00987"></a>00987 }
<a name="l00988"></a>00988 
<a name="l00989"></a>00989 
<a name="l00990"></a>00990 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00991"></a>00991 <span class="comment">// PeriodicBoundary inline member functions</span>
<a name="l00992"></a>00992 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00993"></a>00993 <span class="preprocessor"></span>
<a name="l00994"></a>00994 <span class="keyword">inline</span>
<a name="l00995"></a><a class="code" href="classPeriodicBoundaries.php#a685df5a1090d311007db34328ec1647e">00995</a> <a class="code" href="classPeriodicBoundary.php">PeriodicBoundary</a> *<a class="code" href="classPeriodicBoundaries.php#a685df5a1090d311007db34328ec1647e">PeriodicBoundaries::boundary</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>)
<a name="l00996"></a>00996 {
<a name="l00997"></a>00997   <a class="code" href="classstd_1_1iterator.php">iterator</a> i = this-&gt;find(<span class="keywordtype">id</span>);
<a name="l00998"></a>00998   <span class="keywordflow">if</span> (i == this-&gt;end())
<a name="l00999"></a>00999     <span class="keywordflow">return</span> NULL;
<a name="l01000"></a>01000   <span class="keywordflow">return</span> &amp;i-&gt;second;
<a name="l01001"></a>01001 }
<a name="l01002"></a>01002 
<a name="l01003"></a>01003 <span class="preprocessor">#endif // LIBMESH_ENABLE_PERIODIC</span>
<a name="l01004"></a>01004 <span class="preprocessor"></span>
<a name="l01005"></a>01005 <span class="preprocessor">#if !defined(LIBMESH_ENABLE_AMR) &amp;&amp; !defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l01006"></a>01006 <span class="preprocessor"></span>  <span class="comment">//--------------------------------------------------------------------</span>
<a name="l01007"></a>01007   <span class="comment">// Constraint-specific methods get inlined into nothing if</span>
<a name="l01008"></a>01008   <span class="comment">// constraints are disabled, so there&#39;s no reason for users not to </span>
<a name="l01009"></a>01009   <span class="comment">// use them.</span>
<a name="l01010"></a>01010 
<a name="l01011"></a>01011 <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#ab03892878c3a760e5ffdcf16dd6a7db9">DofMap::constrain_element_matrix</a> (<a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Number&gt;</a>&amp;,
<a name="l01012"></a>01012                                               std::vector&lt;unsigned int&gt;&amp;,
<a name="l01013"></a>01013                                               <span class="keywordtype">bool</span>)<span class="keyword"> const </span>{}
<a name="l01014"></a>01014   
<a name="l01015"></a>01015 <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#ab03892878c3a760e5ffdcf16dd6a7db9">DofMap::constrain_element_matrix</a> (<a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Number&gt;</a>&amp;,
<a name="l01016"></a>01016                                               std::vector&lt;unsigned int&gt;&amp;,
<a name="l01017"></a>01017                                               std::vector&lt;unsigned int&gt;&amp;,
<a name="l01018"></a>01018                                               <span class="keywordtype">bool</span>)<span class="keyword"> const </span>{}
<a name="l01019"></a>01019   
<a name="l01020"></a>01020 <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#a60d43d6b832336a9c70527024e1ffdc8">DofMap::constrain_element_vector</a> (<a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a>&amp;,
<a name="l01021"></a>01021                                               std::vector&lt;unsigned int&gt;&amp;,
<a name="l01022"></a>01022                                               <span class="keywordtype">bool</span>)<span class="keyword"> const </span>{}
<a name="l01023"></a>01023   
<a name="l01024"></a>01024 <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#af32c351cce81588e65370dd14e820fb4">DofMap::constrain_element_matrix_and_vector</a> (<a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Number&gt;</a>&amp;,
<a name="l01025"></a>01025                                                          <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a>&amp;,
<a name="l01026"></a>01026                                                          std::vector&lt;unsigned int&gt;&amp;,
<a name="l01027"></a>01027                                                          <span class="keywordtype">bool</span>)<span class="keyword"> const </span>{}
<a name="l01028"></a>01028 
<a name="l01029"></a>01029 <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#a0af0331bbbec5019a9fca56b136a7521">DofMap::constrain_element_dyad_matrix</a> (<a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a>&amp;,
<a name="l01030"></a>01030                                                    <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a>&amp;,
<a name="l01031"></a>01031                                                    std::vector&lt;unsigned int&gt;&amp;,
<a name="l01032"></a>01032                                                    <span class="keywordtype">bool</span>)<span class="keyword"> const </span>{}
<a name="l01033"></a>01033 
<a name="l01034"></a>01034 <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#ab8f806aded3f8351a9f0f6bbf8ae8274">DofMap::enforce_constraints_exactly</a> (<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a> &amp;,
<a name="l01035"></a>01035                                                  <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> *)<span class="keyword"> const </span>{}
<a name="l01036"></a>01036 
<a name="l01037"></a>01037 <span class="preprocessor">#endif // !defined(LIBMESH_ENABLE_AMR) &amp;&amp; !defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l01038"></a>01038 <span class="preprocessor"></span>
<a name="l01039"></a>01039 <span class="preprocessor">#endif // __dof_map_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
