<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_a444518d96d2df902338d2a7eb3a040c.php">base</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>dof_object.h</h1>  </div>
</div>
<div class="contents">
<a href="dof__object_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: dof_object.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __dof_object_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __dof_object_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span> <span class="comment">// libMesh::invalid_uint</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Forward declarations</span>
<a name="l00034"></a>00034 <span class="keyword">class </span><a class="code" href="classDofObject.php">DofObject</a>;
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00053"></a><a class="code" href="classDofObject.php">00053</a> <span class="keyword">class </span><a class="code" href="classDofObject.php">DofObject</a> : <span class="keyword">public</span> <a class="code" href="classReferenceCountedObject.php">ReferenceCountedObject</a>&lt;DofObject&gt;
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055   
<a name="l00056"></a>00056 <span class="keyword">protected</span>:
<a name="l00057"></a>00057   
<a name="l00061"></a>00061   <a class="code" href="classDofObject.php#a84032b81eb96051ef73223bfe2fdadb6">DofObject</a> ();
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 <span class="keyword">public</span>:
<a name="l00064"></a>00064   
<a name="l00068"></a>00068   <a class="code" href="classDofObject.php#a84032b81eb96051ef73223bfe2fdadb6">DofObject</a> (<span class="keyword">const</span> <a class="code" href="classDofObject.php">DofObject</a>&amp;);
<a name="l00069"></a>00069 
<a name="l00073"></a>00073   <span class="keyword">virtual</span> <a class="code" href="classDofObject.php#adf914ac48ca8100a26237a0ca357276c">~DofObject</a> ();
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00076"></a>00076 <span class="preprocessor"></span>  
<a name="l00081"></a><a class="code" href="classDofObject.php#ad56c44a9df5498f7816988dc1e3445e0">00081</a>   <a class="code" href="classDofObject.php">DofObject</a>* <a class="code" href="classDofObject.php#ad56c44a9df5498f7816988dc1e3445e0">old_dof_object</a>;
<a name="l00082"></a>00082 
<a name="l00086"></a>00086   <span class="keywordtype">void</span> <a class="code" href="classDofObject.php#a377bc5b4ef40ec25245ce23f2c47e5db">clear_old_dof_object</a> ();
<a name="l00087"></a>00087 
<a name="l00091"></a>00091   <span class="keywordtype">void</span> <a class="code" href="classDofObject.php#a1c5a6980e35d8420b13fe2d7bff63a67">set_old_dof_object</a> ();
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 <span class="preprocessor">#endif</span>
<a name="l00094"></a>00094 <span class="preprocessor"></span>  
<a name="l00099"></a>00099   <span class="keywordtype">void</span> <a class="code" href="classDofObject.php#a5e9f7a24e9e5489b1675270fef7960ba">clear_dofs</a> ();
<a name="l00100"></a>00100 
<a name="l00104"></a>00104   <span class="keywordtype">void</span> <a class="code" href="classDofObject.php#a9a32ce8c1afea76a9bd50d78cf74fd47">invalidate_dofs</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>);
<a name="l00105"></a>00105 
<a name="l00109"></a>00109   <span class="keywordtype">void</span> <a class="code" href="classDofObject.php#ad6a467828c98850473d1eca9a89799d8">invalidate_id</a> ();
<a name="l00110"></a>00110 
<a name="l00114"></a>00114   <span class="keywordtype">void</span> <a class="code" href="classDofObject.php#aca6ecb4f00416a9682d3912ecce7c867">invalidate_processor_id</a> ();
<a name="l00115"></a>00115 
<a name="l00119"></a>00119   <span class="keywordtype">void</span> <a class="code" href="classDofObject.php#a85c571ece64d58b5f9019e9b771149d0">invalidate</a> ();
<a name="l00120"></a>00120   
<a name="l00126"></a>00126   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofObject.php#aa7e98a2c859e67d21c87472992d5c4cd">n_dofs</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s, 
<a name="l00127"></a>00127                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var =
<a name="l00128"></a>00128                        <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>) <span class="keyword">const</span>;
<a name="l00129"></a>00129   
<a name="l00133"></a>00133   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a> () <span class="keyword">const</span>;
<a name="l00134"></a>00134 
<a name="l00138"></a>00138   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp; <a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a> ();
<a name="l00139"></a>00139 
<a name="l00143"></a><a class="code" href="classDofObject.php#a13f8b3c7156c800825d27380c6fc9596">00143</a>   <span class="keywordtype">void</span> <a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>)
<a name="l00144"></a>00144   { this-&gt;<a class="code" href="classDofObject.php#a13f8b3c7156c800825d27380c6fc9596">set_id</a>() = <a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>; }
<a name="l00145"></a>00145 
<a name="l00150"></a>00150   <span class="keywordtype">bool</span> <a class="code" href="classDofObject.php#a941814a36472764092ae352543f3ecd7">valid_id</a> () <span class="keyword">const</span>;
<a name="l00151"></a>00151   
<a name="l00156"></a>00156   <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a> () <span class="keyword">const</span>;
<a name="l00157"></a>00157   
<a name="l00162"></a>00162   <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> &amp; <a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a> ();
<a name="l00163"></a>00163 
<a name="l00167"></a>00167   <span class="keywordtype">void</span> <a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>);
<a name="l00168"></a>00168 
<a name="l00173"></a>00173   <span class="keywordtype">bool</span> <a class="code" href="classDofObject.php#aac6d68aa1e9075b84fa20aecb25d5ebe">valid_processor_id</a> () <span class="keyword">const</span>;
<a name="l00174"></a>00174   
<a name="l00179"></a>00179   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofObject.php#a221af22104bf374c293dc59f9afb8226">n_systems</a>() <span class="keyword">const</span>;
<a name="l00180"></a>00180 
<a name="l00184"></a>00184   <span class="keywordtype">void</span> <a class="code" href="classDofObject.php#a6e22aa41575c516980aab9eaaae7cec1">set_n_systems</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s);
<a name="l00185"></a>00185 
<a name="l00189"></a>00189   <span class="keywordtype">void</span> <a class="code" href="classDofObject.php#ac4b2647ffcc987bc421d5e572a7bf2bf">add_system</a> ();
<a name="l00190"></a>00190   
<a name="l00195"></a>00195   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofObject.php#a39e3c25ce80fe829a2f8b8cff46b7731">n_vars</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00196"></a>00196   
<a name="l00201"></a>00201   <span class="keywordtype">void</span> <a class="code" href="classDofObject.php#aff802106869ba8dcf1f8cef28c168293">set_n_vars</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00202"></a>00202                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nvars);
<a name="l00203"></a>00203   
<a name="l00213"></a>00213   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofObject.php#a9388a06483961ab49a5da79e476bd255">n_comp</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00214"></a>00214                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var) <span class="keyword">const</span>;
<a name="l00215"></a>00215   
<a name="l00220"></a>00220   <span class="keywordtype">void</span> <a class="code" href="classDofObject.php#a3874991f58387ca4b4a8c4a3e570d315">set_n_comp</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00221"></a>00221                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00222"></a>00222                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ncomp);
<a name="l00223"></a>00223   
<a name="l00228"></a>00228   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofObject.php#a7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00229"></a>00229                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00230"></a>00230                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comp) <span class="keyword">const</span>;
<a name="l00231"></a>00231   
<a name="l00236"></a>00236   <span class="keywordtype">void</span> <a class="code" href="classDofObject.php#a13635f9e4f4d398bbc4015cfaeaa5f99">set_dof_number</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00237"></a>00237                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00238"></a>00238                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comp,
<a name="l00239"></a>00239                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dn);
<a name="l00240"></a>00240 
<a name="l00245"></a>00245   <span class="keywordtype">bool</span> <a class="code" href="classDofObject.php#a2821e7fa9b17c8c6d76949e397cea418">has_dofs</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>) <span class="keyword">const</span>;
<a name="l00246"></a>00246   
<a name="l00250"></a><a class="code" href="classDofObject.php#a93ed2296a2a2f3885cfd237761d16c8a">00250</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classDofObject.php#a93ed2296a2a2f3885cfd237761d16c8a">operator==</a>(<span class="keyword">const</span> <a class="code" href="classDofObject.php">DofObject</a>&amp; )<span class="keyword"> const</span>
<a name="l00251"></a>00251 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00252"></a>00252 
<a name="l00253"></a>00253   
<a name="l00257"></a><a class="code" href="classDofObject.php#a35a5c88688334a8a3b8f0ff45105fb36">00257</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofObject.php#a35a5c88688334a8a3b8f0ff45105fb36">invalid_id</a>;
<a name="l00258"></a>00258 
<a name="l00263"></a><a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">00263</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">invalid_processor_id</a>;
<a name="l00264"></a>00264 
<a name="l00265"></a>00265   
<a name="l00266"></a>00266 <span class="keyword">private</span>:
<a name="l00267"></a>00267 
<a name="l00268"></a>00268   
<a name="l00272"></a><a class="code" href="classDofObject.php#a2b534c71c895ca32a521c936e3407954">00272</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofObject.php#a2b534c71c895ca32a521c936e3407954">_id</a>;
<a name="l00273"></a>00273 
<a name="l00283"></a><a class="code" href="classDofObject.php#a04cf886a8b43416cdd1dabab424db387">00283</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classDofObject.php#a04cf886a8b43416cdd1dabab424db387">_processor_id</a>;
<a name="l00284"></a>00284 
<a name="l00288"></a><a class="code" href="classDofObject.php#a813b82a13c53d39c1d056579f1cca4e0">00288</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="classDofObject.php#a813b82a13c53d39c1d056579f1cca4e0">_n_systems</a>;
<a name="l00289"></a>00289 
<a name="l00298"></a><a class="code" href="classDofObject.php#a4fd89f525134e2dcc28220ec4f6d8581">00298</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> **<a class="code" href="classDofObject.php#a4fd89f525134e2dcc28220ec4f6d8581">_n_v_comp</a>;
<a name="l00299"></a>00299 
<a name="l00304"></a><a class="code" href="classDofObject.php#a761efc708de17e51745b9175ee455864">00304</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> **<a class="code" href="classDofObject.php#a761efc708de17e51745b9175ee455864">_dof_ids</a>;
<a name="l00305"></a>00305 };
<a name="l00306"></a>00306 
<a name="l00307"></a>00307 
<a name="l00308"></a>00308 
<a name="l00309"></a>00309 <span class="comment">//------------------------------------------------------</span>
<a name="l00310"></a>00310 <span class="comment">// Inline functions</span>
<a name="l00311"></a>00311 <span class="keyword">inline</span>
<a name="l00312"></a><a class="code" href="classDofObject.php#a84032b81eb96051ef73223bfe2fdadb6">00312</a> <a class="code" href="classDofObject.php#a84032b81eb96051ef73223bfe2fdadb6">DofObject::DofObject</a> () :
<a name="l00313"></a>00313 #ifdef LIBMESH_ENABLE_AMR
<a name="l00314"></a>00314   old_dof_object(NULL),
<a name="l00315"></a>00315 #endif
<a name="l00316"></a>00316   _id (invalid_id),
<a name="l00317"></a>00317   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#a6a7e7a746767771468fcc0c6e165edfc">_processor_id</a> (invalid_processor_id),
<a name="l00318"></a>00318   _n_systems  (0),
<a name="l00319"></a>00319   _n_v_comp (NULL),
<a name="l00320"></a>00320   _dof_ids (NULL)
<a name="l00321"></a>00321 {
<a name="l00322"></a>00322   this-&gt;<a class="code" href="classDofObject.php#a85c571ece64d58b5f9019e9b771149d0">invalidate</a>();
<a name="l00323"></a>00323 }
<a name="l00324"></a>00324 
<a name="l00325"></a>00325 
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 <span class="keyword">inline</span>
<a name="l00330"></a><a class="code" href="classDofObject.php#adf914ac48ca8100a26237a0ca357276c">00330</a> <a class="code" href="classDofObject.php#adf914ac48ca8100a26237a0ca357276c">DofObject::~DofObject</a> ()
<a name="l00331"></a>00331 {
<a name="l00332"></a>00332   <span class="comment">// Free all memory.</span>
<a name="l00333"></a>00333 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00334"></a>00334 <span class="preprocessor"></span>  this-&gt;<a class="code" href="classDofObject.php#a377bc5b4ef40ec25245ce23f2c47e5db">clear_old_dof_object</a> ();
<a name="l00335"></a>00335 <span class="preprocessor">#endif</span>
<a name="l00336"></a>00336 <span class="preprocessor"></span>  this-&gt;<a class="code" href="classDofObject.php#a5e9f7a24e9e5489b1675270fef7960ba">clear_dofs</a> ();
<a name="l00337"></a>00337 }
<a name="l00338"></a>00338 
<a name="l00339"></a>00339 
<a name="l00340"></a>00340 
<a name="l00341"></a>00341 <span class="keyword">inline</span>
<a name="l00342"></a><a class="code" href="classDofObject.php#a9a32ce8c1afea76a9bd50d78cf74fd47">00342</a> <span class="keywordtype">void</span> <a class="code" href="classDofObject.php#a9a32ce8c1afea76a9bd50d78cf74fd47">DofObject::invalidate_dofs</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num)
<a name="l00343"></a>00343 {
<a name="l00344"></a>00344   <span class="comment">// If the user does not specify the system number...</span>
<a name="l00345"></a>00345   <span class="keywordflow">if</span> (sys_num &gt;= this-&gt;<a class="code" href="classDofObject.php#a221af22104bf374c293dc59f9afb8226">n_systems</a>()) 
<a name="l00346"></a>00346     {
<a name="l00347"></a>00347       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;this-&gt;<a class="code" href="classDofObject.php#a221af22104bf374c293dc59f9afb8226">n_systems</a>(); s++)
<a name="l00348"></a>00348         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;this-&gt;<a class="code" href="classDofObject.php#a39e3c25ce80fe829a2f8b8cff46b7731">n_vars</a>(s); v++)
<a name="l00349"></a>00349           <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classDofObject.php#a9388a06483961ab49a5da79e476bd255">n_comp</a>(s,v))
<a name="l00350"></a>00350             this-&gt;<a class="code" href="classDofObject.php#a13635f9e4f4d398bbc4015cfaeaa5f99">set_dof_number</a>(s,v,0,<a class="code" href="classDofObject.php#a35a5c88688334a8a3b8f0ff45105fb36">invalid_id</a>);
<a name="l00351"></a>00351     }
<a name="l00352"></a>00352   <span class="comment">// ...otherwise invalidate the dofs for all systems</span>
<a name="l00353"></a>00353   <span class="keywordflow">else</span>
<a name="l00354"></a>00354     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;<a class="code" href="classDofObject.php#a39e3c25ce80fe829a2f8b8cff46b7731">n_vars</a>(sys_num); v++)
<a name="l00355"></a>00355       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classDofObject.php#a9388a06483961ab49a5da79e476bd255">n_comp</a>(sys_num,v))
<a name="l00356"></a>00356         this-&gt;<a class="code" href="classDofObject.php#a13635f9e4f4d398bbc4015cfaeaa5f99">set_dof_number</a>(sys_num,v,0,<a class="code" href="classDofObject.php#a35a5c88688334a8a3b8f0ff45105fb36">invalid_id</a>);
<a name="l00357"></a>00357 }
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 
<a name="l00361"></a>00361 <span class="keyword">inline</span>
<a name="l00362"></a><a class="code" href="classDofObject.php#ad6a467828c98850473d1eca9a89799d8">00362</a> <span class="keywordtype">void</span> <a class="code" href="classDofObject.php#ad6a467828c98850473d1eca9a89799d8">DofObject::invalidate_id</a> ()
<a name="l00363"></a>00363 {
<a name="l00364"></a>00364   this-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a> (<a class="code" href="classDofObject.php#a35a5c88688334a8a3b8f0ff45105fb36">invalid_id</a>);
<a name="l00365"></a>00365 }
<a name="l00366"></a>00366 
<a name="l00367"></a>00367 
<a name="l00368"></a>00368 
<a name="l00369"></a>00369 <span class="keyword">inline</span>
<a name="l00370"></a><a class="code" href="classDofObject.php#aca6ecb4f00416a9682d3912ecce7c867">00370</a> <span class="keywordtype">void</span> <a class="code" href="classDofObject.php#aca6ecb4f00416a9682d3912ecce7c867">DofObject::invalidate_processor_id</a> ()
<a name="l00371"></a>00371 {
<a name="l00372"></a>00372   this-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a> (<a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">invalid_processor_id</a>);
<a name="l00373"></a>00373 }
<a name="l00374"></a>00374 
<a name="l00375"></a>00375 
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 <span class="keyword">inline</span>
<a name="l00378"></a><a class="code" href="classDofObject.php#a85c571ece64d58b5f9019e9b771149d0">00378</a> <span class="keywordtype">void</span> <a class="code" href="classDofObject.php#a85c571ece64d58b5f9019e9b771149d0">DofObject::invalidate</a> ()
<a name="l00379"></a>00379 {
<a name="l00380"></a>00380   this-&gt;<a class="code" href="classDofObject.php#a9a32ce8c1afea76a9bd50d78cf74fd47">invalidate_dofs</a> ();
<a name="l00381"></a>00381   this-&gt;<a class="code" href="classDofObject.php#ad6a467828c98850473d1eca9a89799d8">invalidate_id</a> ();
<a name="l00382"></a>00382   this-&gt;<a class="code" href="classDofObject.php#aca6ecb4f00416a9682d3912ecce7c867">invalidate_processor_id</a> ();
<a name="l00383"></a>00383 }
<a name="l00384"></a>00384 
<a name="l00385"></a>00385 
<a name="l00386"></a>00386 
<a name="l00387"></a>00387 <span class="keyword">inline</span>
<a name="l00388"></a><a class="code" href="classDofObject.php#a5e9f7a24e9e5489b1675270fef7960ba">00388</a> <span class="keywordtype">void</span> <a class="code" href="classDofObject.php#a5e9f7a24e9e5489b1675270fef7960ba">DofObject::clear_dofs</a> ()
<a name="l00389"></a>00389 {
<a name="l00390"></a>00390   <span class="comment">// Only clear if there is data</span>
<a name="l00391"></a>00391   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classDofObject.php#a221af22104bf374c293dc59f9afb8226">n_systems</a>() != 0)
<a name="l00392"></a>00392     {
<a name="l00393"></a>00393       libmesh_assert (<a class="code" href="classDofObject.php#a4fd89f525134e2dcc28220ec4f6d8581">_n_v_comp</a> != NULL);
<a name="l00394"></a>00394       libmesh_assert (<a class="code" href="classDofObject.php#a761efc708de17e51745b9175ee455864">_dof_ids</a>  != NULL);
<a name="l00395"></a>00395       
<a name="l00396"></a>00396       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;this-&gt;<a class="code" href="classDofObject.php#a221af22104bf374c293dc59f9afb8226">n_systems</a>(); s++)
<a name="l00397"></a>00397         {
<a name="l00398"></a>00398           <span class="keywordflow">if</span> (<a class="code" href="classDofObject.php#a761efc708de17e51745b9175ee455864">_dof_ids</a>[s] != NULL) <span class="comment">// This has only been allocated if </span>
<a name="l00399"></a>00399             {                      <span class="comment">// variables were declared</span>
<a name="l00400"></a>00400               <span class="keyword">delete</span> [] <a class="code" href="classDofObject.php#a761efc708de17e51745b9175ee455864">_dof_ids</a>[s]; <a class="code" href="classDofObject.php#a761efc708de17e51745b9175ee455864">_dof_ids</a>[s] = NULL;
<a name="l00401"></a>00401             }
<a name="l00402"></a>00402           
<a name="l00403"></a>00403           <span class="keywordflow">if</span> (<a class="code" href="classDofObject.php#a4fd89f525134e2dcc28220ec4f6d8581">_n_v_comp</a>[s] != NULL) <span class="comment">// it is possible the number of variables is 0,</span>
<a name="l00404"></a>00404             {                       <span class="comment">// but this was allocated (_n_v_comp[s][0] == 0)</span>
<a name="l00405"></a>00405               <span class="keyword">delete</span> [] <a class="code" href="classDofObject.php#a4fd89f525134e2dcc28220ec4f6d8581">_n_v_comp</a>[s]; <a class="code" href="classDofObject.php#a4fd89f525134e2dcc28220ec4f6d8581">_n_v_comp</a>[s] = NULL;
<a name="l00406"></a>00406             }
<a name="l00407"></a>00407         }
<a name="l00408"></a>00408       
<a name="l00409"></a>00409       <span class="keyword">delete</span> [] <a class="code" href="classDofObject.php#a4fd89f525134e2dcc28220ec4f6d8581">_n_v_comp</a>; <a class="code" href="classDofObject.php#a4fd89f525134e2dcc28220ec4f6d8581">_n_v_comp</a> = NULL;
<a name="l00410"></a>00410       <span class="keyword">delete</span> [] <a class="code" href="classDofObject.php#a761efc708de17e51745b9175ee455864">_dof_ids</a>;  <a class="code" href="classDofObject.php#a761efc708de17e51745b9175ee455864">_dof_ids</a>  = NULL;
<a name="l00411"></a>00411     }
<a name="l00412"></a>00412   
<a name="l00413"></a>00413   <span class="comment">// Make sure we cleaned up</span>
<a name="l00414"></a>00414   <span class="comment">// (or there was nothing there)</span>
<a name="l00415"></a>00415   libmesh_assert (<a class="code" href="classDofObject.php#a4fd89f525134e2dcc28220ec4f6d8581">_n_v_comp</a> == NULL);
<a name="l00416"></a>00416   libmesh_assert (<a class="code" href="classDofObject.php#a761efc708de17e51745b9175ee455864">_dof_ids</a>  == NULL);
<a name="l00417"></a>00417   
<a name="l00418"></a>00418   <span class="comment">// No systems now.</span>
<a name="l00419"></a>00419   <a class="code" href="classDofObject.php#a813b82a13c53d39c1d056579f1cca4e0">_n_systems</a> = 0;
<a name="l00420"></a>00420 }
<a name="l00421"></a>00421   
<a name="l00422"></a>00422 
<a name="l00423"></a>00423 
<a name="l00424"></a>00424 <span class="keyword">inline</span>
<a name="l00425"></a><a class="code" href="classDofObject.php#aa7e98a2c859e67d21c87472992d5c4cd">00425</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofObject.php#aa7e98a2c859e67d21c87472992d5c4cd">DofObject::n_dofs</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00426"></a>00426                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)<span class="keyword"> const</span>
<a name="l00427"></a>00427 <span class="keyword"></span>{
<a name="l00428"></a>00428   libmesh_assert (s &lt; this-&gt;<a class="code" href="classDofObject.php#a221af22104bf374c293dc59f9afb8226">n_systems</a>());
<a name="l00429"></a>00429   
<a name="l00430"></a>00430   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num = 0;
<a name="l00431"></a>00431 
<a name="l00432"></a>00432   <span class="comment">// Count all variables</span>
<a name="l00433"></a>00433   <span class="keywordflow">if</span> (var == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00434"></a>00434     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;this-&gt;<a class="code" href="classDofObject.php#a39e3c25ce80fe829a2f8b8cff46b7731">n_vars</a>(s); v++)
<a name="l00435"></a>00435       num += this-&gt;<a class="code" href="classDofObject.php#a9388a06483961ab49a5da79e476bd255">n_comp</a>(s,v);
<a name="l00436"></a>00436   
<a name="l00437"></a>00437   <span class="comment">// Only count specified variable</span>
<a name="l00438"></a>00438   <span class="keywordflow">else</span>
<a name="l00439"></a>00439     {
<a name="l00440"></a>00440       num = this-&gt;<a class="code" href="classDofObject.php#a9388a06483961ab49a5da79e476bd255">n_comp</a>(s,var);
<a name="l00441"></a>00441     }
<a name="l00442"></a>00442 
<a name="l00443"></a>00443   <span class="keywordflow">return</span> num;
<a name="l00444"></a>00444 }
<a name="l00445"></a>00445 
<a name="l00446"></a>00446 
<a name="l00447"></a>00447 
<a name="l00448"></a>00448 <span class="keyword">inline</span>
<a name="l00449"></a><a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">00449</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">DofObject::id</a> ()<span class="keyword"> const</span>
<a name="l00450"></a>00450 <span class="keyword"></span>{
<a name="l00451"></a>00451   libmesh_assert (this-&gt;<a class="code" href="classDofObject.php#a941814a36472764092ae352543f3ecd7">valid_id</a>());
<a name="l00452"></a>00452   <span class="keywordflow">return</span> <a class="code" href="classDofObject.php#a2b534c71c895ca32a521c936e3407954">_id</a>;
<a name="l00453"></a>00453 }
<a name="l00454"></a>00454 
<a name="l00455"></a>00455 
<a name="l00456"></a>00456 
<a name="l00457"></a>00457 <span class="keyword">inline</span>
<a name="l00458"></a><a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">00458</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp; <a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">DofObject::set_id</a> ()
<a name="l00459"></a>00459 {
<a name="l00460"></a>00460   <span class="keywordflow">return</span> <a class="code" href="classDofObject.php#a2b534c71c895ca32a521c936e3407954">_id</a>;
<a name="l00461"></a>00461 }
<a name="l00462"></a>00462 
<a name="l00463"></a>00463 
<a name="l00464"></a>00464 
<a name="l00465"></a>00465 <span class="keyword">inline</span>
<a name="l00466"></a><a class="code" href="classDofObject.php#a941814a36472764092ae352543f3ecd7">00466</a> <span class="keywordtype">bool</span> <a class="code" href="classDofObject.php#a941814a36472764092ae352543f3ecd7">DofObject::valid_id</a> ()<span class="keyword"> const</span>
<a name="l00467"></a>00467 <span class="keyword"></span>{
<a name="l00468"></a>00468   <span class="keywordflow">return</span> (<a class="code" href="classDofObject.php#a35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a> != <a class="code" href="classDofObject.php#a2b534c71c895ca32a521c936e3407954">_id</a>);
<a name="l00469"></a>00469 }
<a name="l00470"></a>00470 
<a name="l00471"></a>00471 
<a name="l00472"></a>00472 <span class="keyword">inline</span>
<a name="l00473"></a><a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">00473</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">DofObject::processor_id</a> ()<span class="keyword"> const</span>
<a name="l00474"></a>00474 <span class="keyword"></span>{
<a name="l00475"></a>00475   <span class="keywordflow">return</span> <a class="code" href="classDofObject.php#a04cf886a8b43416cdd1dabab424db387">_processor_id</a>;
<a name="l00476"></a>00476 }
<a name="l00477"></a>00477 
<a name="l00478"></a>00478 
<a name="l00479"></a>00479 
<a name="l00480"></a>00480 <span class="keyword">inline</span>
<a name="l00481"></a><a class="code" href="classDofObject.php#a66e3a6a1baa5982e931c4dcf50d3d04e">00481</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> &amp; <a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">DofObject::processor_id</a> ()
<a name="l00482"></a>00482 {
<a name="l00483"></a>00483   <span class="keywordflow">return</span> <a class="code" href="classDofObject.php#a04cf886a8b43416cdd1dabab424db387">_processor_id</a>;
<a name="l00484"></a>00484 }
<a name="l00485"></a>00485 
<a name="l00486"></a>00486 
<a name="l00487"></a>00487 
<a name="l00488"></a>00488 <span class="keyword">inline</span>
<a name="l00489"></a><a class="code" href="classDofObject.php#a6527a94161c0a84f40b2d88d0b41eedd">00489</a> <span class="keywordtype">void</span> <a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">DofObject::processor_id</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>)
<a name="l00490"></a>00490 {
<a name="l00491"></a>00491 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00492"></a>00492 <span class="preprocessor"></span>  
<a name="l00493"></a>00493   <span class="keywordflow">if</span> (<span class="keywordtype">id</span> != static_cast&lt;unsigned int&gt;(static_cast&lt;unsigned short int&gt;(<span class="keywordtype">id</span>)))
<a name="l00494"></a>00494     {
<a name="l00495"></a>00495       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: id too large for unsigned short int!&quot;</span> &lt;&lt; std::endl
<a name="l00496"></a>00496                 &lt;&lt; <span class="stringliteral">&quot;Recompile with DofObject::_processor_id larger!&quot;</span> &lt;&lt; std::endl;
<a name="l00497"></a>00497       
<a name="l00498"></a>00498       libmesh_error();
<a name="l00499"></a>00499     }
<a name="l00500"></a>00500 
<a name="l00501"></a>00501 <span class="preprocessor">#endif</span>
<a name="l00502"></a>00502 <span class="preprocessor"></span>  
<a name="l00503"></a>00503   this-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() = <a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>;
<a name="l00504"></a>00504 }
<a name="l00505"></a>00505 
<a name="l00506"></a>00506 
<a name="l00507"></a>00507 
<a name="l00508"></a>00508 <span class="keyword">inline</span>
<a name="l00509"></a><a class="code" href="classDofObject.php#aac6d68aa1e9075b84fa20aecb25d5ebe">00509</a> <span class="keywordtype">bool</span> <a class="code" href="classDofObject.php#aac6d68aa1e9075b84fa20aecb25d5ebe">DofObject::valid_processor_id</a> ()<span class="keyword"> const</span>
<a name="l00510"></a>00510 <span class="keyword"></span>{
<a name="l00511"></a>00511   <span class="keywordflow">return</span> (<a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a> != <a class="code" href="classDofObject.php#a04cf886a8b43416cdd1dabab424db387">_processor_id</a>);
<a name="l00512"></a>00512 }
<a name="l00513"></a>00513 
<a name="l00514"></a>00514 
<a name="l00515"></a>00515 
<a name="l00516"></a>00516 <span class="keyword">inline</span>
<a name="l00517"></a><a class="code" href="classDofObject.php#a221af22104bf374c293dc59f9afb8226">00517</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofObject.php#a221af22104bf374c293dc59f9afb8226">DofObject::n_systems</a> ()<span class="keyword"> const</span>
<a name="l00518"></a>00518 <span class="keyword"></span>{
<a name="l00519"></a>00519   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(<a class="code" href="classDofObject.php#a813b82a13c53d39c1d056579f1cca4e0">_n_systems</a>);
<a name="l00520"></a>00520 }
<a name="l00521"></a>00521 
<a name="l00522"></a>00522 
<a name="l00523"></a>00523 
<a name="l00524"></a>00524 <span class="keyword">inline</span>
<a name="l00525"></a><a class="code" href="classDofObject.php#a39e3c25ce80fe829a2f8b8cff46b7731">00525</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofObject.php#a39e3c25ce80fe829a2f8b8cff46b7731">DofObject::n_vars</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00526"></a>00526 <span class="keyword"></span>{
<a name="l00527"></a>00527   libmesh_assert (s &lt; this-&gt;<a class="code" href="classDofObject.php#a221af22104bf374c293dc59f9afb8226">n_systems</a>());
<a name="l00528"></a>00528   libmesh_assert (<a class="code" href="classDofObject.php#a4fd89f525134e2dcc28220ec4f6d8581">_n_v_comp</a> != NULL);
<a name="l00529"></a>00529   <span class="keywordflow">if</span> (<a class="code" href="classDofObject.php#a4fd89f525134e2dcc28220ec4f6d8581">_n_v_comp</a>[s] == NULL)
<a name="l00530"></a>00530     <span class="keywordflow">return</span> 0;
<a name="l00531"></a>00531   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(<a class="code" href="classDofObject.php#a4fd89f525134e2dcc28220ec4f6d8581">_n_v_comp</a>[s][0]);
<a name="l00532"></a>00532 }
<a name="l00533"></a>00533 
<a name="l00534"></a>00534 
<a name="l00535"></a>00535 
<a name="l00536"></a>00536 
<a name="l00537"></a>00537 <span class="keyword">inline</span>
<a name="l00538"></a><a class="code" href="classDofObject.php#a9388a06483961ab49a5da79e476bd255">00538</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofObject.php#a9388a06483961ab49a5da79e476bd255">DofObject::n_comp</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00539"></a>00539                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)<span class="keyword"> const</span>
<a name="l00540"></a>00540 <span class="keyword"></span>{
<a name="l00541"></a>00541   libmesh_assert (s &lt; this-&gt;<a class="code" href="classDofObject.php#a221af22104bf374c293dc59f9afb8226">n_systems</a>());
<a name="l00542"></a>00542   libmesh_assert (<a class="code" href="classDofObject.php#a761efc708de17e51745b9175ee455864">_dof_ids</a> != NULL);
<a name="l00543"></a>00543   libmesh_assert (<a class="code" href="classDofObject.php#a761efc708de17e51745b9175ee455864">_dof_ids</a>[s] != NULL);
<a name="l00544"></a>00544   libmesh_assert (<a class="code" href="classDofObject.php#a4fd89f525134e2dcc28220ec4f6d8581">_n_v_comp</a> != NULL);
<a name="l00545"></a>00545   libmesh_assert (<a class="code" href="classDofObject.php#a4fd89f525134e2dcc28220ec4f6d8581">_n_v_comp</a>[s] != NULL);
<a name="l00546"></a>00546 
<a name="l00547"></a>00547 <span class="preprocessor"># ifdef DEBUG</span>
<a name="l00548"></a>00548 <span class="preprocessor"></span>  <span class="comment">// Does this ever happen?  I doubt it... 3/7/2003 (BSK)</span>
<a name="l00549"></a>00549   <span class="keywordflow">if</span> (var &gt;= this-&gt;<a class="code" href="classDofObject.php#a39e3c25ce80fe829a2f8b8cff46b7731">n_vars</a>(s))
<a name="l00550"></a>00550     {
<a name="l00551"></a>00551       std::cout &lt;&lt; <span class="stringliteral">&quot;s=&quot;</span> &lt;&lt; s &lt;&lt; <span class="stringliteral">&quot;, var=&quot;</span> &lt;&lt; var &lt;&lt; std::endl
<a name="l00552"></a>00552                 &lt;&lt; <span class="stringliteral">&quot;this-&gt;n_vars(s)=&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classDofObject.php#a39e3c25ce80fe829a2f8b8cff46b7731">n_vars</a>(s) &lt;&lt; std::endl
<a name="l00553"></a>00553                 &lt;&lt; <span class="stringliteral">&quot;this-&gt;n_systems()=&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classDofObject.php#a221af22104bf374c293dc59f9afb8226">n_systems</a>() &lt;&lt; std::endl;
<a name="l00554"></a>00554       libmesh_error();
<a name="l00555"></a>00555     }
<a name="l00556"></a>00556 <span class="preprocessor"># endif</span>
<a name="l00557"></a>00557 <span class="preprocessor"></span>  
<a name="l00558"></a>00558   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(<a class="code" href="classDofObject.php#a4fd89f525134e2dcc28220ec4f6d8581">_n_v_comp</a>[s][var+1]);
<a name="l00559"></a>00559 }
<a name="l00560"></a>00560 
<a name="l00561"></a>00561 
<a name="l00562"></a>00562 
<a name="l00563"></a>00563 <span class="keyword">inline</span>
<a name="l00564"></a><a class="code" href="classDofObject.php#a7a6fadd50e52b87f098acfd4c833087f">00564</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofObject.php#a7a6fadd50e52b87f098acfd4c833087f">DofObject::dof_number</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00565"></a>00565                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00566"></a>00566                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comp)<span class="keyword"> const</span>
<a name="l00567"></a>00567 <span class="keyword"></span>{
<a name="l00568"></a>00568   libmesh_assert (s &lt; this-&gt;<a class="code" href="classDofObject.php#a221af22104bf374c293dc59f9afb8226">n_systems</a>());
<a name="l00569"></a>00569   libmesh_assert (var  &lt; this-&gt;<a class="code" href="classDofObject.php#a39e3c25ce80fe829a2f8b8cff46b7731">n_vars</a>(s));
<a name="l00570"></a>00570   libmesh_assert (<a class="code" href="classDofObject.php#a761efc708de17e51745b9175ee455864">_dof_ids</a> != NULL);
<a name="l00571"></a>00571   libmesh_assert (<a class="code" href="classDofObject.php#a761efc708de17e51745b9175ee455864">_dof_ids</a>[s] != NULL);  
<a name="l00572"></a>00572   libmesh_assert (comp &lt; this-&gt;<a class="code" href="classDofObject.php#a9388a06483961ab49a5da79e476bd255">n_comp</a>(s,var));
<a name="l00573"></a>00573   
<a name="l00574"></a>00574   <span class="keywordflow">if</span> (<a class="code" href="classDofObject.php#a761efc708de17e51745b9175ee455864">_dof_ids</a>[s][var] == <a class="code" href="classDofObject.php#a35a5c88688334a8a3b8f0ff45105fb36">invalid_id</a>)
<a name="l00575"></a>00575     <span class="keywordflow">return</span> <a class="code" href="classDofObject.php#a35a5c88688334a8a3b8f0ff45105fb36">invalid_id</a>;
<a name="l00576"></a>00576   <span class="keywordflow">else</span>
<a name="l00577"></a>00577     <span class="keywordflow">return</span> (<a class="code" href="classDofObject.php#a761efc708de17e51745b9175ee455864">_dof_ids</a>[s][var] + comp);
<a name="l00578"></a>00578 }
<a name="l00579"></a>00579 
<a name="l00580"></a>00580 
<a name="l00581"></a>00581 
<a name="l00582"></a>00582 <span class="keyword">inline</span>
<a name="l00583"></a><a class="code" href="classDofObject.php#a2821e7fa9b17c8c6d76949e397cea418">00583</a> <span class="keywordtype">bool</span> <a class="code" href="classDofObject.php#a2821e7fa9b17c8c6d76949e397cea418">DofObject::has_dofs</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys)<span class="keyword"> const</span>
<a name="l00584"></a>00584 <span class="keyword"></span>{
<a name="l00585"></a>00585   <span class="keywordflow">if</span> (sys == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00586"></a>00586     {
<a name="l00587"></a>00587       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;this-&gt;<a class="code" href="classDofObject.php#a221af22104bf374c293dc59f9afb8226">n_systems</a>(); s++)
<a name="l00588"></a>00588         <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classDofObject.php#a39e3c25ce80fe829a2f8b8cff46b7731">n_vars</a>(s))
<a name="l00589"></a>00589           <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00590"></a>00590     }
<a name="l00591"></a>00591   
<a name="l00592"></a>00592   <span class="keywordflow">else</span>
<a name="l00593"></a>00593     {
<a name="l00594"></a>00594       libmesh_assert (sys &lt; this-&gt;<a class="code" href="classDofObject.php#a221af22104bf374c293dc59f9afb8226">n_systems</a>());
<a name="l00595"></a>00595 
<a name="l00596"></a>00596       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classDofObject.php#a39e3c25ce80fe829a2f8b8cff46b7731">n_vars</a>(sys))
<a name="l00597"></a>00597         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00598"></a>00598     }
<a name="l00599"></a>00599   
<a name="l00600"></a>00600   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00601"></a>00601 }
<a name="l00602"></a>00602   
<a name="l00603"></a>00603 
<a name="l00604"></a>00604 
<a name="l00605"></a>00605 
<a name="l00606"></a>00606 <span class="preprocessor">#endif // #ifndef __dof_object_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
