<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1665b3ccb6c776ec6797fe204e2359e5.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>edge.C</h1>  </div>
</div>
<div class="contents">
<a href="edge_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: edge.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;edge.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;node_elem.h&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a><a class="code" href="classEdge.php#a3674868ed5da7dac7543c936db7000b4">00027</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> <a class="code" href="classEdge.php#a3674868ed5da7dac7543c936db7000b4">Edge::side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00028"></a>00028 <span class="keyword"></span>{
<a name="l00029"></a>00029   libmesh_assert(i &lt; 2);
<a name="l00030"></a>00030   <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a> = <span class="keyword">this</span>;
<a name="l00031"></a>00031   <a class="code" href="classElem.php">Elem</a> *nodeelem = <span class="keyword">new</span> <a class="code" href="classNodeElem.php">NodeElem</a>(const_cast&lt;Elem*&gt;(parent));
<a name="l00032"></a>00032   nodeelem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(i);
<a name="l00033"></a>00033   <span class="keywordflow">return</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a>(nodeelem);
<a name="l00034"></a>00034 }
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a><a class="code" href="classEdge.php#adccfe2dddb5cd52ab03c5b4e6911ebf4">00037</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classEdge.php#adccfe2dddb5cd52ab03c5b4e6911ebf4">Edge::build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keywordtype">bool</span>)<span class="keyword"> const</span>
<a name="l00038"></a>00038 <span class="keyword"></span>{
<a name="l00039"></a>00039   libmesh_assert(i &lt; 2);
<a name="l00040"></a>00040   <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a> = <span class="keyword">this</span>;
<a name="l00041"></a>00041   <a class="code" href="classElem.php">Elem</a> *nodeelem = <span class="keyword">new</span> <a class="code" href="classNodeElem.php">NodeElem</a>(const_cast&lt;Elem*&gt;(parent));
<a name="l00042"></a>00042   nodeelem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(i);
<a name="l00043"></a>00043   <span class="keywordflow">return</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a>(nodeelem);
<a name="l00044"></a>00044 }
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a><a class="code" href="classEdge.php#a4dcdb70537fa49173e43e41e5e280a29">00047</a> <span class="keywordtype">bool</span> <a class="code" href="classEdge.php#a4dcdb70537fa49173e43e41e5e280a29">Edge::is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00048"></a>00048                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00049"></a>00049 <span class="keyword"></span>{
<a name="l00050"></a>00050   libmesh_assert (c &lt; this-&gt;<a class="code" href="classEdge.php#a7719d85e1bb2587a24e8edfb8372cae4">n_children</a>());
<a name="l00051"></a>00051   libmesh_assert (s &lt; this-&gt;<a class="code" href="classEdge.php#ac075db352e5f42d921a8bf3d990e2262">n_sides</a>());
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   <span class="keywordflow">return</span> (c == s);
<a name="l00054"></a>00054 }
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
