<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>edge.h</h1>  </div>
</div>
<div class="contents">
<a href="edge_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: edge.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __edge_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __edge_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Forward declarations</span>
<a name="l00032"></a>00032 <span class="keyword">class </span><a class="code" href="classMesh.php">Mesh</a>;
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00041"></a>00041 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00042"></a>00042 <span class="comment">// Edge class definition</span>
<a name="l00043"></a><a class="code" href="classEdge.php">00043</a> <span class="keyword">class </span><a class="code" href="classEdge.php">Edge</a> : <span class="keyword">public</span> <a class="code" href="classElem.php">Elem</a>
<a name="l00044"></a>00044 {
<a name="l00045"></a>00045  <span class="keyword">public</span>:
<a name="l00046"></a>00046 
<a name="l00051"></a><a class="code" href="classEdge.php#a6ff8e02f80577415951b5783a52da80b">00051</a>   <a class="code" href="classEdge.php#a6ff8e02f80577415951b5783a52da80b">Edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00052"></a>00052         <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00053"></a>00053     <a class="code" href="classElem.php">Elem</a>(nn, <a class="code" href="classEdge.php">Edge</a>::<a class="code" href="classEdge.php#ac075db352e5f42d921a8bf3d990e2262">n_sides</a>(), p) {}
<a name="l00054"></a>00054    
<a name="l00059"></a><a class="code" href="classEdge.php#a4e2c00c2d1e4fc773d96218ce4f71f7f">00059</a>   <a class="code" href="classEdge.php#a6ff8e02f80577415951b5783a52da80b">Edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00060"></a>00060         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00061"></a>00061         <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00062"></a>00062     <a class="code" href="classElem.php">Elem</a>(nn, ns, p) {}
<a name="l00063"></a>00063 
<a name="l00067"></a><a class="code" href="classEdge.php#a2c3afe102f064aafa4f53cb3da82b74a">00067</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEdge.php#a2c3afe102f064aafa4f53cb3da82b74a">dim</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00068"></a>00068   
<a name="l00072"></a><a class="code" href="classEdge.php#a62ec9c9510d0e3c385cd6daaad5aca28">00072</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEdge.php#a62ec9c9510d0e3c385cd6daaad5aca28">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 2; }
<a name="l00073"></a>00073 
<a name="l00077"></a><a class="code" href="classEdge.php#ac075db352e5f42d921a8bf3d990e2262">00077</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEdge.php#ac075db352e5f42d921a8bf3d990e2262">n_sides</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 2; }
<a name="l00078"></a>00078 
<a name="l00082"></a><a class="code" href="classEdge.php#ad390ec6a9a8ad118235cf13239969f56">00082</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEdge.php#ad390ec6a9a8ad118235cf13239969f56">n_vertices</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 2; }
<a name="l00083"></a>00083   
<a name="l00087"></a><a class="code" href="classEdge.php#a4b7fc91479bc84bc0c36c6158f23d64e">00087</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEdge.php#a4b7fc91479bc84bc0c36c6158f23d64e">n_edges</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; }
<a name="l00088"></a>00088   
<a name="l00092"></a><a class="code" href="classEdge.php#a1bb328b1eab63b1a966694c38503a803">00092</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEdge.php#a1bb328b1eab63b1a966694c38503a803">n_faces</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; }
<a name="l00093"></a>00093   
<a name="l00097"></a><a class="code" href="classEdge.php#a7719d85e1bb2587a24e8edfb8372cae4">00097</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEdge.php#a7719d85e1bb2587a24e8edfb8372cae4">n_children</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 2; }
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   <span class="comment">/*</span>
<a name="l00100"></a>00100 <span class="comment">   * @returns true iff the specified child is on the</span>
<a name="l00101"></a>00101 <span class="comment">   * specified side</span>
<a name="l00102"></a>00102 <span class="comment">   */</span>
<a name="l00103"></a>00103   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classEdge.php#a4dcdb70537fa49173e43e41e5e280a29">is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00104"></a>00104                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00105"></a>00105   
<a name="l00106"></a>00106 <span class="comment">//   /**</span>
<a name="l00107"></a>00107 <span class="comment">//    * @returns 1</span>
<a name="l00108"></a>00108 <span class="comment">//    */</span>
<a name="l00109"></a>00109 <span class="comment">//   unsigned int n_children_per_side(const unsigned int) const { return 1; }</span>
<a name="l00110"></a>00110   
<a name="l00116"></a><a class="code" href="classEdge.php#a9245aba48603f6e3439fa0803024606c">00116</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEdge.php#a9245aba48603f6e3439fa0803024606c">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00117"></a>00117 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classElem.php#a859c8236824914afa005cacf1ee86959">compute_key</a>(this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(s)); }
<a name="l00118"></a>00118   
<a name="l00123"></a>00123   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> <a class="code" href="classEdge.php#a3674868ed5da7dac7543c936db7000b4">side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00124"></a>00124 
<a name="l00129"></a>00129   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classEdge.php#adccfe2dddb5cd52ab03c5b4e6911ebf4">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00130"></a>00130                             <span class="keywordtype">bool</span> proxy) <span class="keyword">const</span>;
<a name="l00131"></a>00131 
<a name="l00135"></a><a class="code" href="classEdge.php#a620fa963d064bd59d8f79f0ba4348388">00135</a>   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classEdge.php#a620fa963d064bd59d8f79f0ba4348388">build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>) <span class="keyword">const</span>
<a name="l00136"></a>00136   <span class="comment">//{ libmesh_assert(i &lt; n_nodes()); AutoPtr&lt;DofObject&gt; ap(new Node(*get_node(i))); return ap; }</span>
<a name="l00137"></a>00137   { libmesh_error(); <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(NULL); <span class="keywordflow">return</span> ap; }
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   
<a name="l00140"></a>00140  <span class="keyword">protected</span>:
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00144"></a>00144 <span class="preprocessor"></span>  
<a name="l00148"></a><a class="code" href="classEdge.php#a05b85a96363f1171a8bf3cabde29e931">00148</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEdge.php#a05b85a96363f1171a8bf3cabde29e931">side_children_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, 
<a name="l00149"></a>00149                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00150"></a>00150 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> 0; }
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 <span class="preprocessor">#endif</span>
<a name="l00153"></a>00153 <span class="preprocessor"></span>  
<a name="l00154"></a>00154 };
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00161"></a>00161 <span class="comment">// Edge class member functions</span>
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
