<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>edge_edge2.h</h1>  </div>
</div>
<div class="contents">
<a href="edge__edge2_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: edge_edge2.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __edge2_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __edge2_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="edge_8h.php">edge.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00043"></a>00043 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00044"></a>00044 <span class="comment">// Edge class definition</span>
<a name="l00045"></a><a class="code" href="classEdge2.php">00045</a> <span class="keyword">class </span><a class="code" href="classEdge2.php">Edge2</a> : <span class="keyword">public</span> <a class="code" href="classEdge.php">Edge</a>
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047  <span class="keyword">public</span>:
<a name="l00048"></a>00048 
<a name="l00052"></a><a class="code" href="classEdge2.php#aa1a5c7d42db1234176e7081b3ebb6662">00052</a>   <a class="code" href="classEdge2.php#aa1a5c7d42db1234176e7081b3ebb6662">Edge2</a> (<a class="code" href="classElem.php">Elem</a>* p=NULL) :
<a name="l00053"></a>00053     <a class="code" href="classEdge.php">Edge</a>(<a class="code" href="classEdge2.php">Edge2</a>::<a class="code" href="classEdge.php#a62ec9c9510d0e3c385cd6daaad5aca28">n_nodes</a>(), p) {} 
<a name="l00054"></a>00054 
<a name="l00059"></a><a class="code" href="classEdge2.php#ade890635b7bb7b31d67622d90e169905">00059</a>   <a class="code" href="classEdge2.php#aa1a5c7d42db1234176e7081b3ebb6662">Edge2</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00060"></a>00060          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00061"></a>00061          <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00062"></a>00062     <a class="code" href="classEdge.php">Edge</a>(nn, p) { libmesh_assert (ns == 0); }
<a name="l00063"></a>00063 
<a name="l00067"></a><a class="code" href="classEdge2.php#aef045f62a97de4911e4a1db5c49d60d0">00067</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEdge2.php#aef045f62a97de4911e4a1db5c49d60d0">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00068"></a>00068   
<a name="l00072"></a>00072   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classEdge2.php#ae3eed61d96b467d564bd15e907a466fd">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00073"></a>00073 
<a name="l00077"></a>00077   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classEdge2.php#a5e3462f8d89203c0c556ad1ffd427fb5">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00078"></a>00078 
<a name="l00082"></a>00082   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classEdge2.php#a61a9cb68fc38930598c4e908d86ff609">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00083"></a>00083   
<a name="l00084"></a>00084   <span class="comment">/*</span>
<a name="l00085"></a>00085 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00086"></a>00086 <span class="comment">   * specified side</span>
<a name="l00087"></a>00087 <span class="comment">   */</span>
<a name="l00088"></a>00088   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classEdge2.php#a6b2346e13fb7c93d3a1a5be21929f250">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00089"></a>00089                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00090"></a>00090   
<a name="l00091"></a>00091   <span class="comment">/*</span>
<a name="l00092"></a>00092 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00093"></a>00093 <span class="comment">   * specified edge (i.e. &quot;returns true&quot; in 1D)</span>
<a name="l00094"></a>00094 <span class="comment">   */</span>
<a name="l00095"></a>00095   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classEdge2.php#ad566cb2415c3d40008dc10f2f5002574">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00096"></a>00096                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e) <span class="keyword">const</span>;
<a name="l00097"></a>00097   
<a name="l00098"></a>00098   <span class="comment">/*</span>
<a name="l00099"></a>00099 <span class="comment">   * @returns true iff the element map is definitely affine within</span>
<a name="l00100"></a>00100 <span class="comment">   * numerical tolerances</span>
<a name="l00101"></a>00101 <span class="comment">   */</span>
<a name="l00102"></a><a class="code" href="classEdge2.php#a8a88ca4d3540a0d645e848d07c8093f9">00102</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classEdge2.php#a8a88ca4d3540a0d645e848d07c8093f9">has_affine_map</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00103"></a>00103 
<a name="l00107"></a><a class="code" href="classEdge2.php#a02e4d01e90c0846710db1ee5ec6775df">00107</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classEdge2.php#a02e4d01e90c0846710db1ee5ec6775df">type</a>()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>; }
<a name="l00108"></a>00108   
<a name="l00112"></a><a class="code" href="classEdge2.php#a76d30256e20a7a88e5df9ce6d12e6b38">00112</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classEdge2.php#a76d30256e20a7a88e5df9ce6d12e6b38">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>; }
<a name="l00113"></a>00113 
<a name="l00114"></a>00114   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEdge2.php#abe8d965970add52dc83db3c6a687100b">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00115"></a>00115                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00116"></a>00116                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00117"></a>00117 
<a name="l00121"></a>00121   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classEdge2.php#ac1bf50aaaa08c469e3ad49296944e3ef">volume</a> () <span class="keyword">const</span>;
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00124"></a>00124 <span class="preprocessor"></span>
<a name="l00128"></a><a class="code" href="classEdge2.php#ae7b07f09ed783a32e0b6541164737db6">00128</a>   <span class="keywordtype">bool</span> <a class="code" href="classEdge2.php#ae7b07f09ed783a32e0b6541164737db6">infinite</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 <span class="preprocessor">#endif</span>
<a name="l00131"></a>00131 <span class="preprocessor"></span>
<a name="l00132"></a>00132   
<a name="l00133"></a>00133 <span class="keyword">protected</span>:
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   
<a name="l00136"></a>00136 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00137"></a>00137 <span class="preprocessor"></span>
<a name="l00141"></a><a class="code" href="classEdge2.php#a765ede241baf7c5d6317fab4723e5b67">00141</a>   <span class="keywordtype">float</span> <a class="code" href="classEdge2.php#a765ede241baf7c5d6317fab4723e5b67">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00142"></a>00142                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00143"></a>00143                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00144"></a>00144 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classEdge2.php#a12f5f87581842af8a8fdddc353dff04a">_embedding_matrix</a>[i][j][k]; }
<a name="l00145"></a>00145   
<a name="l00150"></a><a class="code" href="classEdge2.php#a12f5f87581842af8a8fdddc353dff04a">00150</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classEdge2.php#a12f5f87581842af8a8fdddc353dff04a">_embedding_matrix</a>[2][2][2];
<a name="l00151"></a>00151   
<a name="l00152"></a>00152 <span class="preprocessor">#endif</span>
<a name="l00153"></a>00153 <span class="preprocessor"></span>};
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
