<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>edge_edge3.h</h1>  </div>
</div>
<div class="contents">
<a href="edge__edge3_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: edge_edge3.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __edge3_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __edge3_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="edge_8h.php">edge.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00042"></a>00042 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00043"></a>00043 <span class="comment">// Edge3 class definition</span>
<a name="l00044"></a><a class="code" href="classEdge3.php">00044</a> <span class="keyword">class </span><a class="code" href="classEdge3.php">Edge3</a> : <span class="keyword">public</span> <a class="code" href="classEdge.php">Edge</a>
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046  <span class="keyword">public</span>:
<a name="l00047"></a>00047 
<a name="l00051"></a><a class="code" href="classEdge3.php#ace5bff302dfb1119b9ad55584e6bb6ca">00051</a>   <a class="code" href="classEdge3.php#ace5bff302dfb1119b9ad55584e6bb6ca">Edge3</a> (<a class="code" href="classElem.php">Elem</a>* p=NULL) :
<a name="l00052"></a>00052     <a class="code" href="classEdge.php">Edge</a>(<a class="code" href="classEdge3.php">Edge3</a>::<a class="code" href="classEdge3.php#ab8415a7458a0dccc9e698af70f253105">n_nodes</a>(), p) {}
<a name="l00053"></a>00053   
<a name="l00058"></a><a class="code" href="classEdge3.php#aafe56ce2c88fb07ce9d7d7b36968e8d9">00058</a>   <a class="code" href="classEdge3.php#ace5bff302dfb1119b9ad55584e6bb6ca">Edge3</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00059"></a>00059          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00060"></a>00060          <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00061"></a>00061     <a class="code" href="classEdge.php">Edge</a>(nn, p) { libmesh_assert (ns == 0); }
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   
<a name="l00067"></a><a class="code" href="classEdge3.php#ab8415a7458a0dccc9e698af70f253105">00067</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEdge3.php#ab8415a7458a0dccc9e698af70f253105">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 3; }
<a name="l00068"></a>00068 
<a name="l00072"></a><a class="code" href="classEdge3.php#a6efe50c4d822971bef44d58f73c5a543">00072</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEdge3.php#a6efe50c4d822971bef44d58f73c5a543">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 2; }
<a name="l00073"></a>00073 
<a name="l00077"></a>00077   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classEdge3.php#ab3cad8aeccf1e67e4182d77e02af740e">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00078"></a>00078 
<a name="l00082"></a>00082   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classEdge3.php#a4d4ae085f15b55b18a2fb8603ab56f58">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00083"></a>00083 
<a name="l00087"></a>00087   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classEdge3.php#ac2057c51602ee5070d8b5faa8581ad16">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00088"></a>00088   
<a name="l00089"></a>00089   <span class="comment">/*</span>
<a name="l00090"></a>00090 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00091"></a>00091 <span class="comment">   * specified side</span>
<a name="l00092"></a>00092 <span class="comment">   */</span>
<a name="l00093"></a>00093   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classEdge3.php#aea92c235110b30e1a8cfef34e773719d">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00094"></a>00094                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00095"></a>00095   
<a name="l00096"></a>00096   <span class="comment">/*</span>
<a name="l00097"></a>00097 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00098"></a>00098 <span class="comment">   * specified edge (i.e. &quot;returns true&quot; in 1D)</span>
<a name="l00099"></a>00099 <span class="comment">   */</span>
<a name="l00100"></a>00100   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classEdge3.php#a5d7738f448cace3756a839fa1f828669">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00101"></a>00101                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e) <span class="keyword">const</span>;
<a name="l00102"></a>00102   
<a name="l00103"></a>00103   <span class="comment">/*</span>
<a name="l00104"></a>00104 <span class="comment">   * @returns true iff the element map is definitely affine within</span>
<a name="l00105"></a>00105 <span class="comment">   * numerical tolerances</span>
<a name="l00106"></a>00106 <span class="comment">   */</span>
<a name="l00107"></a>00107   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classEdge3.php#af4d000e6793f66c73566aebee8e0f818">has_affine_map</a> () <span class="keyword">const</span>;
<a name="l00108"></a>00108 
<a name="l00112"></a><a class="code" href="classEdge3.php#a00556ca848bfdd87a81a168f6c991513">00112</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classEdge3.php#a00556ca848bfdd87a81a168f6c991513">type</a>()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>; }
<a name="l00113"></a>00113   
<a name="l00117"></a><a class="code" href="classEdge3.php#a68f7d182efdd8a590ae9680648f276c7">00117</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classEdge3.php#a68f7d182efdd8a590ae9680648f276c7">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>; }
<a name="l00118"></a>00118 
<a name="l00119"></a>00119   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEdge3.php#aa2c8187f9ada5943e0dc9137c721687e">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00120"></a>00120                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00121"></a>00121                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00122"></a>00122 
<a name="l00126"></a><a class="code" href="classEdge3.php#a7ea8334efc9e758ed3593f03bdc0ba74">00126</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEdge3.php#a7ea8334efc9e758ed3593f03bdc0ba74">n_second_order_adjacent_vertices</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00127"></a>00127 <span class="keyword">      </span>{ <span class="keywordflow">return</span> 2; }
<a name="l00128"></a>00128 
<a name="l00133"></a><a class="code" href="classEdge3.php#a7452270a448b976ac45d0ac4bec421dd">00133</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classEdge3.php#a7452270a448b976ac45d0ac4bec421dd">second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00134"></a>00134                                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v)<span class="keyword"> const</span>
<a name="l00135"></a>00135 <span class="keyword">      </span>{ <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(v); }
<a name="l00136"></a>00136 
<a name="l00146"></a>00146   <span class="keyword">virtual</span> std::pair&lt;unsigned short int, unsigned short int&gt; 
<a name="l00147"></a>00147           <a class="code" href="classEdge3.php#a615759cdaa2a670ab4a8d2a29460b486">second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span>;
<a name="l00148"></a>00148 
<a name="l00152"></a>00152   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classEdge3.php#a2a3bea77648fa91e9b6c95cff537cf71">volume</a> () <span class="keyword">const</span>;
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00155"></a>00155 <span class="preprocessor"></span>
<a name="l00159"></a><a class="code" href="classEdge3.php#aecaed4d52be0c5e21f0d0b4b0e7fda77">00159</a>   <span class="keywordtype">bool</span> <a class="code" href="classEdge3.php#aecaed4d52be0c5e21f0d0b4b0e7fda77">infinite</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 <span class="preprocessor">#endif</span>
<a name="l00162"></a>00162 <span class="preprocessor"></span>
<a name="l00163"></a>00163   
<a name="l00164"></a>00164 <span class="keyword">protected</span>:
<a name="l00165"></a>00165 
<a name="l00166"></a>00166   
<a name="l00167"></a>00167 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00168"></a>00168 <span class="preprocessor"></span>
<a name="l00172"></a><a class="code" href="classEdge3.php#a16895633d2f67146d4dee41061f6c0c1">00172</a>   <span class="keywordtype">float</span> <a class="code" href="classEdge3.php#a16895633d2f67146d4dee41061f6c0c1">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00173"></a>00173                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00174"></a>00174                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00175"></a>00175 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classEdge3.php#a167c15e41eb5201d57745eeb375f0a92">_embedding_matrix</a>[i][j][k]; }
<a name="l00176"></a>00176   
<a name="l00181"></a><a class="code" href="classEdge3.php#a167c15e41eb5201d57745eeb375f0a92">00181</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classEdge3.php#a167c15e41eb5201d57745eeb375f0a92">_embedding_matrix</a>[2][3][3];
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 <span class="preprocessor">#endif</span>
<a name="l00184"></a>00184 <span class="preprocessor"></span>};
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
