<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1665b3ccb6c776ec6797fe204e2359e5.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>edge_edge4.C</h1>  </div>
</div>
<div class="contents">
<a href="edge__edge4_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: edge_edge4.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;edge_edge4.h&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00026"></a>00026 <span class="preprocessor"></span>
<a name="l00027"></a>00027 <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classEdge4.php#ae8eec66dac808ef938dc2981da752b4c">Edge4::_embedding_matrix</a>[2][4][4] =
<a name="l00028"></a>00028 {
<a name="l00029"></a>00029   <span class="comment">// embedding matrix for child 0</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031   {
<a name="l00032"></a>00032     <span class="comment">// 0       1       2        3        // Shape function index</span>
<a name="l00033"></a>00033     {1.0,      0.0,    0.0,     0.0},    <span class="comment">// left,  xi = -1</span>
<a name="l00034"></a>00034     {-0.0625, -0.0625, 0.5625,  0.5625}, <span class="comment">// right, xi = 0</span>
<a name="l00035"></a>00035     {0.3125,   0.0625, 0.9375, -0.3125}, <span class="comment">// middle left,  xi = -2/3</span>
<a name="l00036"></a>00036     {0.0,      0.0,    1.0,     0.0}     <span class="comment">// middle right, xi = -1/3</span>
<a name="l00037"></a>00037   },
<a name="l00038"></a>00038 
<a name="l00039"></a>00039   <span class="comment">// embedding matrix for child 1</span>
<a name="l00040"></a>00040   {
<a name="l00041"></a>00041     <span class="comment">// 0       1        2        3        // Shape function index</span>
<a name="l00042"></a>00042     {-0.0625, -0.0625,  0.5625,  0.5625}, <span class="comment">// left,  xi = 0</span>
<a name="l00043"></a>00043     {0.0,      1.0,     0.0,     0.0},    <span class="comment">// right, xi = 1</span>
<a name="l00044"></a>00044     {0.0,      0.0,     0.0,     1.0},    <span class="comment">// middle left,  xi = 1/3</span>
<a name="l00045"></a>00045     {0.0625,   0.3125, -0.3125,  0.9375}  <span class="comment">// middle right, xi = 2/3</span>
<a name="l00046"></a>00046   }
<a name="l00047"></a>00047 };
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="preprocessor">#endif</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span>
<a name="l00051"></a><a class="code" href="classEdge4.php#a6b0bf025fe054a05c5b5bbfeb411a8c4">00051</a> <span class="keywordtype">bool</span> <a class="code" href="classEdge4.php#a6b0bf025fe054a05c5b5bbfeb411a8c4">Edge4::is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00052"></a>00052 <span class="keyword"></span>{
<a name="l00053"></a>00053   <span class="keywordflow">return</span> (i==0) || (i==1);
<a name="l00054"></a>00054 }
<a name="l00055"></a>00055 
<a name="l00056"></a><a class="code" href="classEdge4.php#ad253e08501a85977aaef6abfcccebe92">00056</a> <span class="keywordtype">bool</span> <a class="code" href="classEdge4.php#ad253e08501a85977aaef6abfcccebe92">Edge4::is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00057"></a>00057 <span class="keyword"></span>{
<a name="l00058"></a>00058   <span class="keywordflow">return</span> (i==2) || (i==3);
<a name="l00059"></a>00059 }
<a name="l00060"></a>00060 
<a name="l00061"></a><a class="code" href="classEdge4.php#a511c74fe460ccbbad5f3871334aec743">00061</a> <span class="keywordtype">bool</span> <a class="code" href="classEdge4.php#a511c74fe460ccbbad5f3871334aec743">Edge4::is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> )<span class="keyword"> const</span>
<a name="l00062"></a>00062 <span class="keyword"></span>{
<a name="l00063"></a>00063   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00064"></a>00064 }
<a name="l00065"></a>00065 
<a name="l00066"></a><a class="code" href="classEdge4.php#a1680b37b7d8f9fefdb8b6f36bbc5d197">00066</a> <span class="keywordtype">bool</span> <a class="code" href="classEdge4.php#a1680b37b7d8f9fefdb8b6f36bbc5d197">Edge4::is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00067"></a>00067                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00068"></a>00068 <span class="keyword"></span>{
<a name="l00069"></a>00069   libmesh_assert(s &lt; 2);
<a name="l00070"></a>00070   libmesh_assert(n &lt; 4);
<a name="l00071"></a>00071   <span class="keywordflow">return</span> (s == n);
<a name="l00072"></a>00072 }
<a name="l00073"></a>00073 
<a name="l00074"></a><a class="code" href="classEdge4.php#a1ed3af274c5fe572fe16c3ed77cb18ec">00074</a> <span class="keywordtype">bool</span> <a class="code" href="classEdge4.php#a1ed3af274c5fe572fe16c3ed77cb18ec">Edge4::is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00075"></a>00075                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00076"></a>00076 <span class="keyword"></span>{
<a name="l00077"></a>00077   libmesh_assert(e == 0);
<a name="l00078"></a>00078   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00079"></a>00079 }
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a><a class="code" href="classEdge4.php#ad2f1e15b8b600614176d0b82962b943b">00083</a> <span class="keywordtype">bool</span> <a class="code" href="classEdge4.php#ad2f1e15b8b600614176d0b82962b943b">Edge4::has_affine_map</a>()<span class="keyword"> const</span>
<a name="l00084"></a>00084 <span class="keyword"></span>{
<a name="l00085"></a>00085   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2).relative_fuzzy_equals
<a name="l00086"></a>00086       ((this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0)*2. + this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1))/3.))
<a name="l00087"></a>00087     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00088"></a>00088   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3).relative_fuzzy_equals
<a name="l00089"></a>00089       ((this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0) + this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1)*2.)/3.))
<a name="l00090"></a>00090     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00091"></a>00091   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00092"></a>00092 }
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a><a class="code" href="classEdge4.php#afd60cb0317b25cc533f0092ac2a0f1cd">00096</a> <span class="keywordtype">void</span> <a class="code" href="classEdge4.php#afd60cb0317b25cc533f0092ac2a0f1cd">Edge4::connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00097"></a>00097                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00098"></a>00098                          std::vector&lt;unsigned int&gt;&amp; conn)<span class="keyword"> const</span>
<a name="l00099"></a>00099 <span class="keyword"></span>{
<a name="l00100"></a>00100   libmesh_assert (sc &lt;= 2);
<a name="l00101"></a>00101   libmesh_assert (sc &lt; this-&gt;<a class="code" href="classEdge4.php#adb9a97d1bdbb0f09cd4735e22022093d">n_sub_elem</a>());
<a name="l00102"></a>00102   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="comment">// Create storage</span>
<a name="l00105"></a>00105   conn.resize(2);
<a name="l00106"></a>00106 
<a name="l00107"></a>00107   <span class="keywordflow">switch</span>(iop)
<a name="l00108"></a>00108   {
<a name="l00109"></a>00109     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00110"></a>00110     {
<a name="l00111"></a>00111       <span class="keywordflow">switch</span> (sc)
<a name="l00112"></a>00112       {
<a name="l00113"></a>00113         <span class="keywordflow">case</span> 0:
<a name="l00114"></a>00114           conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0)+1;
<a name="l00115"></a>00115           conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2)+1;
<a name="l00116"></a>00116           <span class="keywordflow">return</span>;
<a name="l00117"></a>00117         
<a name="l00118"></a>00118         <span class="keywordflow">case</span> 1:
<a name="l00119"></a>00119           conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2)+1;
<a name="l00120"></a>00120           conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3)+1;
<a name="l00121"></a>00121           <span class="keywordflow">return</span>;
<a name="l00122"></a>00122 
<a name="l00123"></a>00123         <span class="keywordflow">case</span> 2:
<a name="l00124"></a>00124           conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3)+1;
<a name="l00125"></a>00125           conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1)+1;
<a name="l00126"></a>00126           <span class="keywordflow">return</span>;
<a name="l00127"></a>00127 
<a name="l00128"></a>00128         <span class="keywordflow">default</span>:
<a name="l00129"></a>00129           libmesh_error();
<a name="l00130"></a>00130       }
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   }
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa1affb8987f83b5e4acb22d9401dd44ef">VTK</a>:
<a name="l00135"></a>00135   {
<a name="l00136"></a>00136   
<a name="l00137"></a>00137       <span class="keywordflow">switch</span> (sc)
<a name="l00138"></a>00138       {
<a name="l00139"></a>00139         <span class="keywordflow">case</span> 0:
<a name="l00140"></a>00140           conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0);
<a name="l00141"></a>00141           conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2);
<a name="l00142"></a>00142           <span class="keywordflow">return</span>;
<a name="l00143"></a>00143         
<a name="l00144"></a>00144         <span class="keywordflow">case</span> 1:
<a name="l00145"></a>00145           conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2);
<a name="l00146"></a>00146           conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3);
<a name="l00147"></a>00147           <span class="keywordflow">return</span>;
<a name="l00148"></a>00148 
<a name="l00149"></a>00149         <span class="keywordflow">case</span> 2:
<a name="l00150"></a>00150           conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3);
<a name="l00151"></a>00151           conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1);
<a name="l00152"></a>00152           <span class="keywordflow">return</span>;
<a name="l00153"></a>00153 
<a name="l00154"></a>00154         <span class="keywordflow">default</span>:
<a name="l00155"></a>00155           libmesh_error();
<a name="l00156"></a>00156       }
<a name="l00157"></a>00157    }
<a name="l00158"></a>00158   
<a name="l00159"></a>00159   <span class="keywordflow">default</span>:
<a name="l00160"></a>00160     libmesh_error();
<a name="l00161"></a>00161 
<a name="l00162"></a>00162   }
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
