<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>edge_edge4.h</h1>  </div>
</div>
<div class="contents">
<a href="edge__edge4_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: edge_edge4.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __edge4_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __edge4_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="edge_8h.php">edge.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00039"></a>00039 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00040"></a>00040 <span class="comment">// Edge4 class definition</span>
<a name="l00041"></a><a class="code" href="classEdge4.php">00041</a> <span class="keyword">class </span><a class="code" href="classEdge4.php">Edge4</a> : <span class="keyword">public</span> <a class="code" href="classEdge.php">Edge</a>
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043   <span class="keyword">public</span>:
<a name="l00044"></a>00044 
<a name="l00048"></a><a class="code" href="classEdge4.php#aa3d4e3ac48573103f4634428cd444f0f">00048</a>   <a class="code" href="classEdge4.php#aa3d4e3ac48573103f4634428cd444f0f">Edge4</a> (<a class="code" href="classElem.php">Elem</a>* p=NULL) :
<a name="l00049"></a>00049     <a class="code" href="classEdge.php">Edge</a>(<a class="code" href="classEdge4.php">Edge4</a>::<a class="code" href="classEdge4.php#a28932370750adccd39f5b46472a4db91">n_nodes</a>(), p) {}
<a name="l00050"></a>00050 
<a name="l00055"></a><a class="code" href="classEdge4.php#ad9883f8f2fd3ff60bbb79bdc12a3fa9c">00055</a>   <a class="code" href="classEdge4.php#aa3d4e3ac48573103f4634428cd444f0f">Edge4</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00056"></a>00056         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00057"></a>00057         <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00058"></a>00058     <a class="code" href="classEdge.php">Edge</a>(nn, p) { libmesh_assert (ns == 0); }
<a name="l00059"></a>00059 
<a name="l00063"></a><a class="code" href="classEdge4.php#a28932370750adccd39f5b46472a4db91">00063</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEdge4.php#a28932370750adccd39f5b46472a4db91">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00064"></a>00064 
<a name="l00068"></a><a class="code" href="classEdge4.php#adb9a97d1bdbb0f09cd4735e22022093d">00068</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEdge4.php#adb9a97d1bdbb0f09cd4735e22022093d">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 2; }
<a name="l00069"></a>00069 
<a name="l00073"></a>00073   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classEdge4.php#a6b0bf025fe054a05c5b5bbfeb411a8c4">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00074"></a>00074 
<a name="l00078"></a>00078   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classEdge4.php#ad253e08501a85977aaef6abfcccebe92">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00079"></a>00079 
<a name="l00083"></a>00083   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classEdge4.php#a511c74fe460ccbbad5f3871334aec743">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00084"></a>00084   
<a name="l00085"></a>00085   <span class="comment">/*</span>
<a name="l00086"></a>00086 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00087"></a>00087 <span class="comment">   * specified side</span>
<a name="l00088"></a>00088 <span class="comment">   */</span>
<a name="l00089"></a>00089   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classEdge4.php#a1680b37b7d8f9fefdb8b6f36bbc5d197">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00090"></a>00090                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00091"></a>00091   
<a name="l00092"></a>00092   <span class="comment">/*</span>
<a name="l00093"></a>00093 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00094"></a>00094 <span class="comment">   * specified edge (i.e. &quot;returns true&quot; in 1D)</span>
<a name="l00095"></a>00095 <span class="comment">   */</span>
<a name="l00096"></a>00096   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classEdge4.php#a1ed3af274c5fe572fe16c3ed77cb18ec">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00097"></a>00097                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e) <span class="keyword">const</span>;
<a name="l00098"></a>00098   
<a name="l00099"></a>00099   <span class="comment">/*</span>
<a name="l00100"></a>00100 <span class="comment">   * @returns true iff the element map is definitely affine within</span>
<a name="l00101"></a>00101 <span class="comment">   * numerical tolerances</span>
<a name="l00102"></a>00102 <span class="comment">   */</span>
<a name="l00103"></a>00103   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classEdge4.php#ad2f1e15b8b600614176d0b82962b943b">has_affine_map</a> () <span class="keyword">const</span>;
<a name="l00104"></a>00104 
<a name="l00108"></a><a class="code" href="classEdge4.php#a77f704da57b9b34e4556919ce6b8d408">00108</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classEdge4.php#a77f704da57b9b34e4556919ce6b8d408">type</a>()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>; }
<a name="l00109"></a>00109   
<a name="l00113"></a><a class="code" href="classEdge4.php#a6ac9b82a08653cbfd0bb0c3beda9c4c1">00113</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classEdge4.php#a6ac9b82a08653cbfd0bb0c3beda9c4c1">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>; }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEdge4.php#afd60cb0317b25cc533f0092ac2a0f1cd">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00116"></a>00116                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00117"></a>00117                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00118"></a>00118 
<a name="l00121"></a><a class="code" href="classEdge4.php#a37d4dfdb3bf67578babe588f081578d9">00121</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEdge4.php#a37d4dfdb3bf67578babe588f081578d9">n_second_order_adjacent_vertices</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00122"></a>00122 <span class="keyword">      </span>{ libmesh_error(); <span class="keywordflow">return</span> 0;  }
<a name="l00123"></a>00123 
<a name="l00126"></a><a class="code" href="classEdge4.php#a477c940e43cda15cc874e0fa1fe22890">00126</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classEdge4.php#a477c940e43cda15cc874e0fa1fe22890">second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00127"></a>00127                                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00128"></a>00128 <span class="keyword">      </span>{ libmesh_error(); <span class="keywordflow">return</span> 0; }
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00132"></a>00132 <span class="preprocessor"></span>
<a name="l00136"></a><a class="code" href="classEdge4.php#a1ff40337544202993a5cf23673e3b34e">00136</a>   <span class="keywordtype">bool</span> <a class="code" href="classEdge4.php#a1ff40337544202993a5cf23673e3b34e">infinite</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 <span class="preprocessor">#endif</span>
<a name="l00139"></a>00139 <span class="preprocessor"></span>
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 <span class="keyword">protected</span>:
<a name="l00142"></a>00142 
<a name="l00143"></a>00143   
<a name="l00144"></a>00144 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00145"></a>00145 <span class="preprocessor"></span>
<a name="l00149"></a><a class="code" href="classEdge4.php#a91b654681e5f25348be681de0b8e8be6">00149</a>   <span class="keywordtype">float</span> <a class="code" href="classEdge4.php#a91b654681e5f25348be681de0b8e8be6">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00150"></a>00150                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00151"></a>00151                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00152"></a>00152 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classEdge4.php#ae8eec66dac808ef938dc2981da752b4c">_embedding_matrix</a>[i][j][k]; }
<a name="l00153"></a>00153   
<a name="l00158"></a><a class="code" href="classEdge4.php#ae8eec66dac808ef938dc2981da752b4c">00158</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classEdge4.php#ae8eec66dac808ef938dc2981da752b4c">_embedding_matrix</a>[2][4][4];
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 <span class="preprocessor">#endif</span>
<a name="l00162"></a>00162 <span class="preprocessor"></span>};
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
