<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1665b3ccb6c776ec6797fe204e2359e5.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>edge_inf_edge2.C</h1>  </div>
</div>
<div class="contents">
<a href="edge__inf__edge2_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: edge_inf_edge2.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;edge_inf_edge2.h&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00030"></a>00030 <span class="comment">// InfEdge2 class member functions</span>
<a name="l00031"></a>00031 
<a name="l00032"></a><a class="code" href="classInfEdge2.php#a7a79d26b65ff4bcbd0f62d8712559029">00032</a> <span class="keywordtype">bool</span> <a class="code" href="classInfEdge2.php#a7a79d26b65ff4bcbd0f62d8712559029">InfEdge2::is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00033"></a>00033 <span class="keyword"></span>{
<a name="l00034"></a>00034   <span class="keywordflow">if</span> (i)
<a name="l00035"></a>00035     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00036"></a>00036   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00037"></a>00037 }
<a name="l00038"></a>00038 
<a name="l00039"></a><a class="code" href="classInfEdge2.php#ad5997817e2658f5c696aebc923542a3d">00039</a> <span class="keywordtype">bool</span> <a class="code" href="classInfEdge2.php#ad5997817e2658f5c696aebc923542a3d">InfEdge2::is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00040"></a>00040 <span class="keyword"></span>{
<a name="l00041"></a>00041   <span class="keywordflow">if</span> (i)
<a name="l00042"></a>00042     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00043"></a>00043   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00044"></a>00044 }
<a name="l00045"></a>00045 
<a name="l00046"></a><a class="code" href="classInfEdge2.php#aac402dc559e8e35e325553e91cdc586d">00046</a> <span class="keywordtype">bool</span> <a class="code" href="classInfEdge2.php#aac402dc559e8e35e325553e91cdc586d">InfEdge2::is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00047"></a>00047 <span class="keyword"></span>{
<a name="l00048"></a>00048   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00049"></a>00049 }
<a name="l00050"></a>00050 
<a name="l00051"></a><a class="code" href="classInfEdge2.php#a01dd57a219cc30ef081f27153b3bc2d2">00051</a> <span class="keywordtype">bool</span> <a class="code" href="classInfEdge2.php#a01dd57a219cc30ef081f27153b3bc2d2">InfEdge2::is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00052"></a>00052                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00053"></a>00053 <span class="keyword"></span>{
<a name="l00054"></a>00054   libmesh_assert(s &lt; 1);
<a name="l00055"></a>00055   <span class="keywordflow">return</span> (s == n);
<a name="l00056"></a>00056 }
<a name="l00057"></a>00057 
<a name="l00058"></a><a class="code" href="classInfEdge2.php#afc41c27a9af7e353500ffadcfba77696">00058</a> <span class="keywordtype">bool</span> <a class="code" href="classInfEdge2.php#afc41c27a9af7e353500ffadcfba77696">InfEdge2::is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00059"></a>00059                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00060"></a>00060 <span class="keyword"></span>{
<a name="l00061"></a>00061   libmesh_assert(e == 0);
<a name="l00062"></a>00062   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00063"></a>00063 }
<a name="l00064"></a>00064 
<a name="l00065"></a><a class="code" href="classInfEdge2.php#a6d14638fe940b555bc070e1d60aa1770">00065</a> <span class="keywordtype">void</span> <a class="code" href="classInfEdge2.php#a6d14638fe940b555bc070e1d60aa1770">InfEdge2::connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> se,
<a name="l00066"></a>00066                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00067"></a>00067                             std::vector&lt;unsigned int&gt;&amp; conn)<span class="keyword"> const</span>
<a name="l00068"></a>00068 <span class="keyword"></span>{
<a name="l00069"></a>00069   libmesh_assert (se == 0);
<a name="l00070"></a>00070   libmesh_assert (se &lt; this-&gt;<a class="code" href="classInfEdge2.php#a2ce1490c6a6b9adfa64b6fe98c628ec1">n_sub_elem</a>());
<a name="l00071"></a>00071   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   conn.resize(2);
<a name="l00074"></a>00074   
<a name="l00075"></a>00075   <span class="keywordflow">switch</span> (iop)
<a name="l00076"></a>00076     {
<a name="l00077"></a>00077     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00078"></a>00078       {
<a name="l00079"></a>00079         conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0)+1;
<a name="l00080"></a>00080         conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1)+1;
<a name="l00081"></a>00081         <span class="keywordflow">return</span>;
<a name="l00082"></a>00082       }
<a name="l00083"></a>00083 
<a name="l00084"></a>00084     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa1affb8987f83b5e4acb22d9401dd44ef">VTK</a>:
<a name="l00085"></a>00085       {
<a name="l00086"></a>00086         conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0);
<a name="l00087"></a>00087         conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1);
<a name="l00088"></a>00088         <span class="keywordflow">return</span>;
<a name="l00089"></a>00089       }
<a name="l00090"></a>00090 
<a name="l00091"></a>00091     <span class="keywordflow">default</span>:
<a name="l00092"></a>00092       libmesh_error();
<a name="l00093"></a>00093     }
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   libmesh_error();
<a name="l00096"></a>00096 }
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 <span class="preprocessor">#endif</span>
<a name="l00100"></a>00100 <span class="preprocessor"></span>
<a name="l00101"></a>00101 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
