<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>edge_inf_edge2.h</h1>  </div>
</div>
<div class="contents">
<a href="edge__inf__edge2_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: edge_inf_edge2.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __edge_inf_edge2_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __edge_inf_edge2_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="edge_8h.php">edge.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00050"></a>00050 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00051"></a>00051 <span class="comment">// InfEdge2 class definition</span>
<a name="l00052"></a><a class="code" href="classInfEdge2.php">00052</a> <span class="keyword">class </span><a class="code" href="classInfEdge2.php">InfEdge2</a> : <span class="keyword">public</span> <a class="code" href="classEdge.php">Edge</a>
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054  <span class="keyword">public</span>:
<a name="l00055"></a>00055 
<a name="l00059"></a><a class="code" href="classInfEdge2.php#a64c809afe20d3eed26e3edeb9fc11ed6">00059</a>   <a class="code" href="classInfEdge2.php#a64c809afe20d3eed26e3edeb9fc11ed6">InfEdge2</a> (<a class="code" href="classElem.php">Elem</a>* p=NULL) :
<a name="l00060"></a>00060     <a class="code" href="classEdge.php">Edge</a>(<a class="code" href="classInfEdge2.php">InfEdge2</a>::<a class="code" href="classEdge.php#a62ec9c9510d0e3c385cd6daaad5aca28">n_nodes</a>(), p) {}
<a name="l00061"></a>00061 
<a name="l00066"></a><a class="code" href="classInfEdge2.php#adb811b8b7b441490e21466c850353d1c">00066</a>   <a class="code" href="classInfEdge2.php#a64c809afe20d3eed26e3edeb9fc11ed6">InfEdge2</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00067"></a>00067            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00068"></a>00068            <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00069"></a>00069     <a class="code" href="classEdge.php">Edge</a>(nn, ns, p) {}
<a name="l00070"></a>00070 
<a name="l00074"></a><a class="code" href="classInfEdge2.php#a2ce1490c6a6b9adfa64b6fe98c628ec1">00074</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfEdge2.php#a2ce1490c6a6b9adfa64b6fe98c628ec1">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00075"></a>00075   
<a name="l00079"></a>00079   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfEdge2.php#a7a79d26b65ff4bcbd0f62d8712559029">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00080"></a>00080 
<a name="l00084"></a>00084   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfEdge2.php#ad5997817e2658f5c696aebc923542a3d">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00085"></a>00085 
<a name="l00089"></a>00089   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfEdge2.php#aac402dc559e8e35e325553e91cdc586d">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00090"></a>00090   
<a name="l00091"></a>00091   <span class="comment">/*</span>
<a name="l00092"></a>00092 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00093"></a>00093 <span class="comment">   * specified side</span>
<a name="l00094"></a>00094 <span class="comment">   */</span>
<a name="l00095"></a>00095   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfEdge2.php#a01dd57a219cc30ef081f27153b3bc2d2">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00096"></a>00096                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00097"></a>00097   
<a name="l00098"></a>00098   <span class="comment">/*</span>
<a name="l00099"></a>00099 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00100"></a>00100 <span class="comment">   * specified edge (i.e. &quot;returns true&quot; in 1D)</span>
<a name="l00101"></a>00101 <span class="comment">   */</span>
<a name="l00102"></a>00102   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfEdge2.php#afc41c27a9af7e353500ffadcfba77696">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00103"></a>00103                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e) <span class="keyword">const</span>;
<a name="l00104"></a>00104   
<a name="l00108"></a><a class="code" href="classInfEdge2.php#a58805a5c8ce9007d51900cded572945e">00108</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classInfEdge2.php#a58805a5c8ce9007d51900cded572945e">type</a>()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a278476b80069e0630827235779c82c47">INFEDGE2</a>; }
<a name="l00109"></a>00109   
<a name="l00113"></a><a class="code" href="classInfEdge2.php#a2e4e90ace8af09c129ab51b8363b623c">00113</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classInfEdge2.php#a2e4e90ace8af09c129ab51b8363b623c">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>; }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classInfEdge2.php#a6d14638fe940b555bc070e1d60aa1770">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> se,
<a name="l00116"></a>00116                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00117"></a>00117                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 <span class="comment">//   const std::vector&lt;unsigned int&gt; tecplot_connectivity(const unsigned int se=0) const;</span>
<a name="l00120"></a>00120   
<a name="l00121"></a>00121 <span class="comment">//   void vtk_connectivity(const unsigned int se,</span>
<a name="l00122"></a>00122 <span class="comment">//                      std::vector&lt;unsigned int&gt;*conn = NULL) const;</span>
<a name="l00123"></a>00123   
<a name="l00124"></a>00124 <span class="comment">//   unsigned int vtk_element_type (const unsigned int) const</span>
<a name="l00125"></a>00125 <span class="comment">//   { return 3; }</span>
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00129"></a>00129 <span class="preprocessor"></span>
<a name="l00133"></a><a class="code" href="classInfEdge2.php#ad839c061e1761619dc928d9ba0a87b9a">00133</a>   <span class="keywordtype">bool</span> <a class="code" href="classInfEdge2.php#ad839c061e1761619dc928d9ba0a87b9a">infinite</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00134"></a>00134 
<a name="l00138"></a>00138   <a class="code" href="classPoint.php">Point</a> <a class="code" href="classInfEdge2.php#aa39f5bd6420e17040c6f931eb7055487">origin</a> () <span class="keyword">const</span>;
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 <span class="preprocessor">#endif</span>
<a name="l00141"></a>00141 <span class="preprocessor"></span>
<a name="l00142"></a>00142   
<a name="l00143"></a>00143 <span class="keyword">protected</span>:
<a name="l00144"></a>00144 
<a name="l00145"></a>00145   
<a name="l00146"></a>00146 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00147"></a>00147 <span class="preprocessor"></span>
<a name="l00151"></a><a class="code" href="classInfEdge2.php#a1abda3bd8c0dbe33218e4032f9c29c70">00151</a>   <span class="keywordtype">float</span> <a class="code" href="classInfEdge2.php#a1abda3bd8c0dbe33218e4032f9c29c70">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00152"></a>00152                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00153"></a>00153                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00154"></a>00154 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> 0.; }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 <span class="preprocessor">#endif</span>
<a name="l00157"></a>00157 <span class="preprocessor"></span>};
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00163"></a>00163 <span class="comment">// InfEdge2 class member functions</span>
<a name="l00164"></a>00164 <span class="keyword">inline</span>
<a name="l00165"></a><a class="code" href="classInfEdge2.php#aa39f5bd6420e17040c6f931eb7055487">00165</a> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classInfEdge2.php#aa39f5bd6420e17040c6f931eb7055487">InfEdge2::origin</a> ()<span class="keyword"> const</span>
<a name="l00166"></a>00166 <span class="keyword"></span>{
<a name="l00167"></a>00167   <span class="keywordflow">return</span> ( this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0)*2. - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1) );
<a name="l00168"></a>00168 }
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 <span class="preprocessor">#endif</span>
<a name="l00172"></a>00172 <span class="preprocessor"></span>
<a name="l00173"></a>00173 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
