<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>eigen_solver.h</h1>  </div>
</div>
<div class="contents">
<a href="eigen__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: eigen_solver.h 3416 2009-07-03 14:30:29Z knezed01 $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributd in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __eigen_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __eigen_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#ifdef LIBMESH_HAVE_SLEPC</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="comment">// C++ includes</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Local includes</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;enum_solver_package.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;enum_eigen_solver_type.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;reference_counted_object.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;libmesh.h&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// forward declarations</span>
<a name="l00039"></a>00039 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr</a>;
<a name="l00040"></a>00040 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classSparseMatrix.php">SparseMatrix</a>;
<a name="l00041"></a>00041 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classShellMatrix.php">ShellMatrix</a>;
<a name="l00042"></a>00042 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classNumericVector.php">NumericVector</a>;
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00050"></a>00050 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00051"></a><a class="code" href="classEigenSolver.php">00051</a> <span class="keyword">class </span><a class="code" href="classEigenSolver.php">EigenSolver</a> : <span class="keyword">public</span> <a class="code" href="classReferenceCountedObject.php">ReferenceCountedObject</a>&lt;EigenSolver&lt;T&gt; &gt;
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053 <span class="keyword">public</span>:
<a name="l00054"></a>00054   
<a name="l00058"></a>00058   <a class="code" href="classEigenSolver.php#a45b7878a069b0ecbc3e0ea2b5e013a4a">EigenSolver</a> ();
<a name="l00059"></a>00059     
<a name="l00063"></a>00063   <span class="keyword">virtual</span> <a class="code" href="classEigenSolver.php#a35593642d04f5120f166d02a5a88d49e">~EigenSolver</a> ();
<a name="l00064"></a>00064   
<a name="l00069"></a>00069   <span class="keyword">static</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;EigenSolver&lt;T&gt;</a> &gt; <a class="code" href="classEigenSolver.php#a1ee6e46c7137921191b9952a4beba911">build</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> solver_package =
<a name="l00070"></a>00070                                         <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8acd9cb691eeae568b29133157cab34ef4">SLEPC_SOLVERS</a>);
<a name="l00071"></a>00071   
<a name="l00076"></a><a class="code" href="classEigenSolver.php#a1d1fd0f056ab23fe75588d87d9ee509b">00076</a>   <span class="keywordtype">bool</span> <a class="code" href="classEigenSolver.php#a1d1fd0f056ab23fe75588d87d9ee509b">initialized</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classEigenSolver.php#a3b77d0b82252f4fb51cb2a9e1b4c8f70">_is_initialized</a>; }
<a name="l00077"></a>00077   
<a name="l00078"></a>00078   
<a name="l00082"></a><a class="code" href="classEigenSolver.php#a4ffbcba8a4185e7682a8fce076c92665">00082</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEigenSolver.php#a4ffbcba8a4185e7682a8fce076c92665">clear</a> () {}
<a name="l00083"></a>00083 
<a name="l00087"></a>00087   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEigenSolver.php#a937a405e635500596439edbc35712f6a">init</a> () = 0;
<a name="l00088"></a>00088 
<a name="l00092"></a><a class="code" href="classEigenSolver.php#a4cf40b10e607f6505ca3c077145ecb8b">00092</a>   <a class="code" href="namespacelibMeshEnums.php#a4b230c3a7c3d5488c3c46bd9d03ce802">EigenSolverType</a> <a class="code" href="classEigenSolver.php#a4cf40b10e607f6505ca3c077145ecb8b">eigen_solver_type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classEigenSolver.php#a29dd62ae6fea3bc7240d50e3b785c1f7">_eigen_solver_type</a>; }
<a name="l00093"></a>00093 
<a name="l00097"></a><a class="code" href="classEigenSolver.php#ac7dc81f9aa3c7628bf5b57e0b3f750a8">00097</a>   <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301">EigenProblemType</a> <a class="code" href="classEigenSolver.php#ac7dc81f9aa3c7628bf5b57e0b3f750a8">eigen_problem_type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classEigenSolver.php#a2c8c9a52b3ad05719e53fae54edb47e8">_eigen_problem_type</a>;}
<a name="l00098"></a>00098 
<a name="l00102"></a><a class="code" href="classEigenSolver.php#a9c9b42061bf6d83bc1f4f8aee507e1bb">00102</a>   <a class="code" href="namespacelibMeshEnums.php#a0630b52d8fe07f56702ddb7c6ff14d84">PositionOfSpectrum</a> <a class="code" href="classEigenSolver.php#a9c9b42061bf6d83bc1f4f8aee507e1bb">postition_of_spectrum</a> ()<span class="keyword"> const</span>
<a name="l00103"></a>00103 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classEigenSolver.php#a60879fa040958d5fe972d47d0399e050">_position_of_spectrum</a>;}
<a name="l00104"></a>00104 
<a name="l00108"></a><a class="code" href="classEigenSolver.php#a98fd1de87cfbad42b29738f176f5f22b">00108</a>   <span class="keywordtype">void</span> <a class="code" href="classEigenSolver.php#a98fd1de87cfbad42b29738f176f5f22b">set_eigensolver_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a4b230c3a7c3d5488c3c46bd9d03ce802">EigenSolverType</a> est)
<a name="l00109"></a>00109     { <a class="code" href="classEigenSolver.php#a29dd62ae6fea3bc7240d50e3b785c1f7">_eigen_solver_type</a> = est; }
<a name="l00110"></a>00110 
<a name="l00114"></a><a class="code" href="classEigenSolver.php#a8166a0c7c7e0129472cff3de5d82e673">00114</a>   <span class="keywordtype">void</span> <a class="code" href="classEigenSolver.php#a8166a0c7c7e0129472cff3de5d82e673">set_eigenproblem_type</a> ( <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301">EigenProblemType</a> ept) 
<a name="l00115"></a>00115     {<a class="code" href="classEigenSolver.php#a2c8c9a52b3ad05719e53fae54edb47e8">_eigen_problem_type</a> = ept;}
<a name="l00116"></a>00116 
<a name="l00120"></a><a class="code" href="classEigenSolver.php#ae3fbea502cbe3e2845e8f2ba68e9cafa">00120</a>   <span class="keywordtype">void</span> <a class="code" href="classEigenSolver.php#ae3fbea502cbe3e2845e8f2ba68e9cafa">set_position_of_spectrum</a> (<a class="code" href="namespacelibMeshEnums.php#a0630b52d8fe07f56702ddb7c6ff14d84">PositionOfSpectrum</a> pos)
<a name="l00121"></a>00121     {<a class="code" href="classEigenSolver.php#a60879fa040958d5fe972d47d0399e050">_position_of_spectrum</a>= pos;}
<a name="l00122"></a>00122 
<a name="l00128"></a>00128   <span class="keyword">virtual</span> std::pair&lt;unsigned int, unsigned int&gt; <a class="code" href="classEigenSolver.php#afa0889953927eec01604472d0ffa20ab">solve_standard</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_A,  
<a name="l00129"></a>00129                                                                 <span class="keywordtype">int</span> nev,
<a name="l00130"></a>00130                                                                 <span class="keywordtype">int</span> ncv,
<a name="l00131"></a>00131                                                                 <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00132"></a>00132                                                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its) = 0;
<a name="l00133"></a>00133 
<a name="l00139"></a>00139   <span class="keyword">virtual</span> std::pair&lt;unsigned int, unsigned int&gt; <a class="code" href="classEigenSolver.php#afa0889953927eec01604472d0ffa20ab">solve_standard</a> (<a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;matrix_A,  
<a name="l00140"></a>00140                                                                 <span class="keywordtype">int</span> nev,
<a name="l00141"></a>00141                                                                 <span class="keywordtype">int</span> ncv,
<a name="l00142"></a>00142                                                                 <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00143"></a>00143                                                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its) = 0;
<a name="l00144"></a>00144 
<a name="l00145"></a>00145   
<a name="l00152"></a>00152   <span class="keyword">virtual</span> std::pair&lt;unsigned int, unsigned int&gt; <a class="code" href="classEigenSolver.php#ac77834e02c6ccbb6c6239ecc9023422e">solve_generalized</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_A, 
<a name="l00153"></a>00153                                                                    <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_B,  
<a name="l00154"></a>00154                                                                    <span class="keywordtype">int</span> nev,
<a name="l00155"></a>00155                                                                    <span class="keywordtype">int</span> ncv,
<a name="l00156"></a>00156                                                                    <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00157"></a>00157                                                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its) = 0;
<a name="l00158"></a>00158 
<a name="l00163"></a>00163    <span class="keyword">virtual</span> std::pair&lt;unsigned int, unsigned int&gt; <a class="code" href="classEigenSolver.php#ac77834e02c6ccbb6c6239ecc9023422e">solve_generalized</a> (<a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;matrix_A, 
<a name="l00164"></a>00164                                                                    <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_B,  
<a name="l00165"></a>00165                                                                    <span class="keywordtype">int</span> nev,
<a name="l00166"></a>00166                                                                    <span class="keywordtype">int</span> ncv,
<a name="l00167"></a>00167                                                                    <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00168"></a>00168                                                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its) = 0;
<a name="l00169"></a>00169 
<a name="l00174"></a>00174    <span class="keyword">virtual</span> std::pair&lt;unsigned int, unsigned int&gt; <a class="code" href="classEigenSolver.php#ac77834e02c6ccbb6c6239ecc9023422e">solve_generalized</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_A, 
<a name="l00175"></a>00175                                                                    <a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;matrix_B,  
<a name="l00176"></a>00176                                                                    <span class="keywordtype">int</span> nev,
<a name="l00177"></a>00177                                                                    <span class="keywordtype">int</span> ncv,
<a name="l00178"></a>00178                                                                    <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00179"></a>00179                                                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its) = 0;
<a name="l00180"></a>00180 
<a name="l00185"></a>00185    <span class="keyword">virtual</span> std::pair&lt;unsigned int, unsigned int&gt; <a class="code" href="classEigenSolver.php#ac77834e02c6ccbb6c6239ecc9023422e">solve_generalized</a> (<a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;matrix_A, 
<a name="l00186"></a>00186                                                                    <a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;matrix_B,  
<a name="l00187"></a>00187                                                                    <span class="keywordtype">int</span> nev,
<a name="l00188"></a>00188                                                                    <span class="keywordtype">int</span> ncv,
<a name="l00189"></a>00189                                                                    <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00190"></a>00190                                                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its) = 0;
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 
<a name="l00197"></a>00197   <span class="keyword">virtual</span> std::pair&lt;Real, Real&gt; <a class="code" href="classEigenSolver.php#a8883e67a71c387233c33eb0a92cc9b96">get_eigenpair</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00198"></a>00198                                                <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;solution) = 0;
<a name="l00199"></a>00199 
<a name="l00203"></a>00203   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEigenSolver.php#a0d2aac73712e466db6f840572d0083a4">attach_deflation_space</a>(<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;deflation_vector) = 0;
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 <span class="keyword">protected</span>:
<a name="l00206"></a>00206 
<a name="l00210"></a><a class="code" href="classEigenSolver.php#a29dd62ae6fea3bc7240d50e3b785c1f7">00210</a>   <a class="code" href="namespacelibMeshEnums.php#a4b230c3a7c3d5488c3c46bd9d03ce802">EigenSolverType</a> <a class="code" href="classEigenSolver.php#a29dd62ae6fea3bc7240d50e3b785c1f7">_eigen_solver_type</a>;
<a name="l00211"></a>00211 
<a name="l00215"></a><a class="code" href="classEigenSolver.php#a2c8c9a52b3ad05719e53fae54edb47e8">00215</a>   <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301">EigenProblemType</a> <a class="code" href="classEigenSolver.php#a2c8c9a52b3ad05719e53fae54edb47e8">_eigen_problem_type</a>;
<a name="l00216"></a>00216 
<a name="l00220"></a><a class="code" href="classEigenSolver.php#a60879fa040958d5fe972d47d0399e050">00220</a>   <a class="code" href="namespacelibMeshEnums.php#a0630b52d8fe07f56702ddb7c6ff14d84">PositionOfSpectrum</a> <a class="code" href="classEigenSolver.php#a60879fa040958d5fe972d47d0399e050">_position_of_spectrum</a>;     
<a name="l00221"></a>00221 
<a name="l00225"></a><a class="code" href="classEigenSolver.php#a3b77d0b82252f4fb51cb2a9e1b4c8f70">00225</a>   <span class="keywordtype">bool</span> <a class="code" href="classEigenSolver.php#a3b77d0b82252f4fb51cb2a9e1b4c8f70">_is_initialized</a>;
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 };
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 <span class="comment">/*----------------------- inline functions ----------------------------------*/</span>
<a name="l00233"></a>00233 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00234"></a>00234 <span class="keyword">inline</span>
<a name="l00235"></a><a class="code" href="classEigenSolver.php#a45b7878a069b0ecbc3e0ea2b5e013a4a">00235</a> <a class="code" href="classEigenSolver.php#a45b7878a069b0ecbc3e0ea2b5e013a4a">EigenSolver&lt;T&gt;::EigenSolver</a> () :
<a name="l00236"></a>00236   
<a name="l00237"></a>00237   _eigen_solver_type    (<a class="code" href="namespacelibMeshEnums.php#a4b230c3a7c3d5488c3c46bd9d03ce802a12dfe2dfbb1204d9ac57ca8efc947146">ARNOLDI</a>),
<a name="l00238"></a>00238   _eigen_problem_type   (<a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301a2b61471cb234c46e5f054bc73c2221de">NHEP</a>),
<a name="l00239"></a>00239   _position_of_spectrum (<a class="code" href="namespacelibMeshEnums.php#a0630b52d8fe07f56702ddb7c6ff14d84aa33e7e94f5eba77558dbdb57a640e964">LARGEST_MAGNITUDE</a>),
<a name="l00240"></a>00240   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a>       (false)
<a name="l00241"></a>00241 {
<a name="l00242"></a>00242 }
<a name="l00243"></a>00243 
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00247"></a>00247 <span class="keyword">inline</span>
<a name="l00248"></a><a class="code" href="classEigenSolver.php#a35593642d04f5120f166d02a5a88d49e">00248</a> <a class="code" href="classEigenSolver.php#a35593642d04f5120f166d02a5a88d49e">EigenSolver&lt;T&gt;::~EigenSolver</a> ()
<a name="l00249"></a>00249 {
<a name="l00250"></a>00250   this-&gt;clear ();
<a name="l00251"></a>00251 }
<a name="l00252"></a>00252 
<a name="l00253"></a>00253 <span class="preprocessor">#endif // LIBMESH_HAVE_SLEPC</span>
<a name="l00254"></a>00254 <span class="preprocessor"></span>
<a name="l00255"></a>00255 <span class="preprocessor">#endif // #ifdef __eigen_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
