<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_60be1125a39495b698d2d56e8e5b50b1.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>eigen_system.C</h1>  </div>
</div>
<div class="contents">
<a href="eigen__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: eigen_system.C 3414 2009-06-30 23:15:45Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Currently, the EigenSystem should only be available</span>
<a name="l00024"></a>00024 <span class="comment">// if SLEPc support is enabled. </span>
<a name="l00025"></a>00025 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC)</span>
<a name="l00026"></a>00026 <span class="preprocessor"></span>
<a name="l00027"></a>00027 <span class="comment">// C++ includes</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;eigen_system.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;equation_systems.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;sparse_matrix.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;eigen_solver.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;dof_map.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;mesh.h&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00039"></a>00039 <span class="comment">// EigenSystem implementation</span>
<a name="l00040"></a><a class="code" href="classEigenSystem.php#af8bb02f23fb6a666ef34c8b602bdafc5">00040</a> <a class="code" href="classEigenSystem.php#af8bb02f23fb6a666ef34c8b602bdafc5">EigenSystem::EigenSystem</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00041"></a>00041                           <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00042"></a>00042                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number
<a name="l00043"></a>00043                           ) :
<a name="l00044"></a>00044   <a class="code" href="classSystem.php">Parent</a>           (es, name, number),
<a name="l00045"></a>00045   matrix_A         (NULL),
<a name="l00046"></a>00046   matrix_B         (NULL),
<a name="l00047"></a>00047   eigen_solver     (<a class="code" href="classEigenSolver.php">EigenSolver</a>&lt;<a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>&gt;::build()),
<a name="l00048"></a>00048   _n_converged_eigenpairs (0),
<a name="l00049"></a>00049   _n_iterations           (0),
<a name="l00050"></a>00050   _is_generalized_eigenproblem (false),
<a name="l00051"></a>00051   _eigen_problem_type (<a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301a2b61471cb234c46e5f054bc73c2221de">NHEP</a>)
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053 }
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00057"></a><a class="code" href="classEigenSystem.php#a821daab8517a843411a2f50ad1fe2229">00057</a> <a class="code" href="classEigenSystem.php#a821daab8517a843411a2f50ad1fe2229">EigenSystem::~EigenSystem</a> ()
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059   <span class="comment">// clear data</span>
<a name="l00060"></a>00060   this-&gt;<a class="code" href="classEigenSystem.php#ad0aa71bba22ef71e16b81edb3930c171">clear</a>();
<a name="l00061"></a>00061 }
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a><a class="code" href="classEigenSystem.php#ad0aa71bba22ef71e16b81edb3930c171">00065</a> <span class="keywordtype">void</span> <a class="code" href="classEigenSystem.php#ad0aa71bba22ef71e16b81edb3930c171">EigenSystem::clear</a> ()
<a name="l00066"></a>00066 {
<a name="l00067"></a>00067   <span class="comment">// Clear the parent data</span>
<a name="l00068"></a>00068   <a class="code" href="classSystem.php#a66bdd137db3fc914bbfe9518b6c71017">Parent::clear</a>();
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="comment">// delete the matricies</span>
<a name="l00071"></a>00071   <span class="keyword">delete</span> <a class="code" href="classEigenSystem.php#a164a61a629d13eb618f31091b07ea905">matrix_A</a>;
<a name="l00072"></a>00072   <span class="keyword">delete</span> <a class="code" href="classEigenSystem.php#a45431ded5fcf8a09c65435c75a71b522">matrix_B</a>;
<a name="l00073"></a>00073 
<a name="l00074"></a>00074   <span class="comment">// NULL-out the matricies.</span>
<a name="l00075"></a>00075   <a class="code" href="classEigenSystem.php#a164a61a629d13eb618f31091b07ea905">matrix_A</a> = NULL;
<a name="l00076"></a>00076   <a class="code" href="classEigenSystem.php#a45431ded5fcf8a09c65435c75a71b522">matrix_B</a> = NULL;
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   <span class="comment">// clear the solver</span>
<a name="l00079"></a>00079   <a class="code" href="classEigenSystem.php#a074981c327971f345faae5d52612c8cb">eigen_solver</a>-&gt;clear();
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 }
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00084"></a><a class="code" href="classEigenSystem.php#a5036e4b330bebb41cbb08ee0f8068695">00084</a> <span class="keywordtype">void</span> <a class="code" href="classEigenSystem.php#a5036e4b330bebb41cbb08ee0f8068695">EigenSystem::set_eigenproblem_type</a> (<a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301">EigenProblemType</a> ept)
<a name="l00085"></a>00085 {
<a name="l00086"></a>00086   <a class="code" href="classEigenSystem.php#a5061bbfe9a901b12818f2480f22d25e7">_eigen_problem_type</a> = ept;
<a name="l00087"></a>00087 
<a name="l00088"></a>00088   <a class="code" href="classEigenSystem.php#a074981c327971f345faae5d52612c8cb">eigen_solver</a>-&gt;set_eigenproblem_type(ept);
<a name="l00089"></a>00089 
<a name="l00090"></a>00090   <span class="comment">// std::cout&lt;&lt; &quot;The Problem type is set to be: &quot;&lt;&lt;std::endl;</span>
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   <span class="keywordflow">switch</span> (<a class="code" href="classEigenSystem.php#a5061bbfe9a901b12818f2480f22d25e7">_eigen_problem_type</a>)
<a name="l00093"></a>00093     {
<a name="l00094"></a>00094     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301a0fbfb4356e45e29380946d58569abdff">HEP</a>: <span class="comment">// std::cout&lt;&lt;&quot;Hermitian&quot;&lt;&lt;std::endl;</span>
<a name="l00095"></a>00095       <span class="keywordflow">break</span>;
<a name="l00096"></a>00096       
<a name="l00097"></a>00097     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301a2b61471cb234c46e5f054bc73c2221de">NHEP</a>: <span class="comment">// std::cout&lt;&lt;&quot;Non-Hermitian&quot;&lt;&lt;std::endl;</span>
<a name="l00098"></a>00098       <span class="keywordflow">break</span>;
<a name="l00099"></a>00099       
<a name="l00100"></a>00100     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301a2249b7b4acec69dfdd4212b7a0333c22">GHEP</a>: <span class="comment">// std::cout&lt;&lt;&quot;Gerneralized Hermitian&quot;&lt;&lt;std::endl;</span>
<a name="l00101"></a>00101       <span class="keywordflow">break</span>;
<a name="l00102"></a>00102       
<a name="l00103"></a>00103     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301a456841f5f527e93817e4bcea61b6cdfb">GNHEP</a>: <span class="comment">// std::cout&lt;&lt;&quot;Generalized Non-Hermitian&quot;&lt;&lt;std::endl;</span>
<a name="l00104"></a>00104       <span class="keywordflow">break</span>;
<a name="l00105"></a>00105       
<a name="l00106"></a>00106     <span class="keywordflow">default</span>: <span class="comment">// std::cout&lt;&lt;&quot;not properly specified&quot;&lt;&lt;std::endl;</span>
<a name="l00107"></a>00107       libmesh_error();
<a name="l00108"></a>00108       <span class="keywordflow">break</span>;
<a name="l00109"></a>00109       
<a name="l00110"></a>00110     } 
<a name="l00111"></a>00111 }
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a><a class="code" href="classEigenSystem.php#a326dcd6dcedfbba8fbd8f5833b0bfd6a">00116</a> <span class="keywordtype">void</span> <a class="code" href="classEigenSystem.php#a326dcd6dcedfbba8fbd8f5833b0bfd6a">EigenSystem::init_data</a> ()
<a name="l00117"></a>00117 {
<a name="l00118"></a>00118  
<a name="l00119"></a>00119   <span class="comment">// initialize parent data</span>
<a name="l00120"></a>00120   <a class="code" href="classSystem.php#a1ee0d1111c06a94c271b2830dbc69421">Parent::init_data</a>();
<a name="l00121"></a>00121   
<a name="l00122"></a>00122   <span class="comment">// define the type of eigenproblem</span>
<a name="l00123"></a>00123   <span class="keywordflow">if</span> (<a class="code" href="classEigenSystem.php#a5061bbfe9a901b12818f2480f22d25e7">_eigen_problem_type</a> == <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301a456841f5f527e93817e4bcea61b6cdfb">GNHEP</a> || <a class="code" href="classEigenSystem.php#a5061bbfe9a901b12818f2480f22d25e7">_eigen_problem_type</a> == <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301a2249b7b4acec69dfdd4212b7a0333c22">GHEP</a>) 
<a name="l00124"></a>00124     <a class="code" href="classEigenSystem.php#a97508587f94671839513e5e7726eaf98">_is_generalized_eigenproblem</a> = <span class="keyword">true</span>;
<a name="l00125"></a>00125   
<a name="l00126"></a>00126   <span class="comment">// build the system matrix</span>
<a name="l00127"></a>00127   <a class="code" href="classEigenSystem.php#a164a61a629d13eb618f31091b07ea905">matrix_A</a> = <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;Number&gt;::build</a>().release();
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   <span class="comment">// add matrix to the _dof_map</span>
<a name="l00130"></a>00130   <span class="comment">// and compute the sparsity</span>
<a name="l00131"></a>00131   <a class="code" href="classDofMap.php">DofMap</a>&amp; dof_map = this-&gt;<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>();
<a name="l00132"></a>00132 
<a name="l00133"></a>00133   dof_map.<a class="code" href="classDofMap.php#abf8a314c9f21240129e140664d04ed53">attach_matrix</a>(*<a class="code" href="classEigenSystem.php#a164a61a629d13eb618f31091b07ea905">matrix_A</a>);
<a name="l00134"></a>00134   
<a name="l00135"></a>00135   <span class="comment">// build matrix_B only in case of a</span>
<a name="l00136"></a>00136   <span class="comment">// generalized problem</span>
<a name="l00137"></a>00137   <span class="keywordflow">if</span> (<a class="code" href="classEigenSystem.php#a97508587f94671839513e5e7726eaf98">_is_generalized_eigenproblem</a>)
<a name="l00138"></a>00138     {
<a name="l00139"></a>00139       <a class="code" href="classEigenSystem.php#a45431ded5fcf8a09c65435c75a71b522">matrix_B</a> = <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;Number&gt;::build</a>().release();
<a name="l00140"></a>00140       dof_map.<a class="code" href="classDofMap.php#abf8a314c9f21240129e140664d04ed53">attach_matrix</a>(*<a class="code" href="classEigenSystem.php#a45431ded5fcf8a09c65435c75a71b522">matrix_B</a>);
<a name="l00141"></a>00141     }
<a name="l00142"></a>00142   
<a name="l00143"></a>00143   dof_map.<a class="code" href="classDofMap.php#ab51821ee7bdb1c6fb8f92821afea2530">compute_sparsity</a>(this-&gt;<a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">get_mesh</a>());
<a name="l00144"></a>00144   
<a name="l00145"></a>00145   <span class="comment">// initialize and zero system matrix</span>
<a name="l00146"></a>00146   <a class="code" href="classEigenSystem.php#a164a61a629d13eb618f31091b07ea905">matrix_A</a>-&gt;<a class="code" href="classSparseMatrix.php#a2c8e7371cd56d4d569c814ec4096f1e9">init</a>();
<a name="l00147"></a>00147   <a class="code" href="classEigenSystem.php#a164a61a629d13eb618f31091b07ea905">matrix_A</a>-&gt;<a class="code" href="classSparseMatrix.php#ac9c04c5748478399f1eff3f337a7e647">zero</a>();
<a name="l00148"></a>00148   
<a name="l00149"></a>00149   <span class="comment">// eventually initialize and zero system matrix_B  </span>
<a name="l00150"></a>00150   <span class="keywordflow">if</span> (<a class="code" href="classEigenSystem.php#a97508587f94671839513e5e7726eaf98">_is_generalized_eigenproblem</a>)
<a name="l00151"></a>00151     {
<a name="l00152"></a>00152       <a class="code" href="classEigenSystem.php#a45431ded5fcf8a09c65435c75a71b522">matrix_B</a>-&gt;<a class="code" href="classSparseMatrix.php#a2c8e7371cd56d4d569c814ec4096f1e9">init</a>();
<a name="l00153"></a>00153       <a class="code" href="classEigenSystem.php#a45431ded5fcf8a09c65435c75a71b522">matrix_B</a>-&gt;<a class="code" href="classSparseMatrix.php#ac9c04c5748478399f1eff3f337a7e647">zero</a>();
<a name="l00154"></a>00154     }   
<a name="l00155"></a>00155   
<a name="l00156"></a>00156 }
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 
<a name="l00160"></a><a class="code" href="classEigenSystem.php#ab7d42c5fbfd8dd39840ab00d594b0718">00160</a> <span class="keywordtype">void</span> <a class="code" href="classEigenSystem.php#ab7d42c5fbfd8dd39840ab00d594b0718">EigenSystem::reinit</a> ()
<a name="l00161"></a>00161 {
<a name="l00162"></a>00162   <span class="comment">// initialize parent data</span>
<a name="l00163"></a>00163   <a class="code" href="classSystem.php#a60f6078e475e01e19aad618766f2cd7b">Parent::reinit</a>();  
<a name="l00164"></a>00164   
<a name="l00165"></a>00165 }
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 
<a name="l00169"></a><a class="code" href="classEigenSystem.php#a0aad526a1a447036c754bccb2803b73e">00169</a> <span class="keywordtype">void</span> <a class="code" href="classEigenSystem.php#a0aad526a1a447036c754bccb2803b73e">EigenSystem::solve</a> ()
<a name="l00170"></a>00170 {
<a name="l00171"></a>00171 
<a name="l00172"></a>00172   <span class="comment">// A reference to the EquationSystems</span>
<a name="l00173"></a>00173   <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es = this-&gt;<a class="code" href="classSystem.php#a51da3ea6211cf1888377c9c4b1554232">get_equation_systems</a>();
<a name="l00174"></a>00174 
<a name="l00175"></a>00175   <span class="comment">// check that necessary parameters have been set</span>
<a name="l00176"></a>00176   libmesh_assert (es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a20587dd7120a79624ebc7095aea0390c">have_parameter</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;eigenpairs&quot;</span>));
<a name="l00177"></a>00177   libmesh_assert (es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a20587dd7120a79624ebc7095aea0390c">have_parameter</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;basis vectors&quot;</span>));
<a name="l00178"></a>00178 
<a name="l00179"></a>00179   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classSystem.php#ac1684646af433b1cdeb4c97ca1f31216">assemble_before_solve</a>)
<a name="l00180"></a>00180     <span class="comment">// Assemble the linear system</span>
<a name="l00181"></a>00181     this-&gt;<a class="code" href="classEigenSystem.php#aec909ae4e751619ec3c65f5d10e72484">assemble</a> ();
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   <span class="comment">// Get the tolerance for the solver and the maximum</span>
<a name="l00184"></a>00184   <span class="comment">// number of iterations. Here, we simply adopt the linear solver</span>
<a name="l00185"></a>00185   <span class="comment">// specific parameters.</span>
<a name="l00186"></a>00186   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tol            =
<a name="l00187"></a>00187     es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#ac4c5e3f411568e6defcdd2ace5829d96">get</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;linear solver tolerance&quot;</span>);
<a name="l00188"></a>00188 
<a name="l00189"></a>00189   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxits =
<a name="l00190"></a>00190     es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#ac4c5e3f411568e6defcdd2ace5829d96">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;linear solver maximum iterations&quot;</span>);
<a name="l00191"></a>00191 
<a name="l00192"></a>00192   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nev    =
<a name="l00193"></a>00193     es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#ac4c5e3f411568e6defcdd2ace5829d96">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;eigenpairs&quot;</span>);
<a name="l00194"></a>00194 
<a name="l00195"></a>00195   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ncv    =
<a name="l00196"></a>00196     es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#ac4c5e3f411568e6defcdd2ace5829d96">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;basis vectors&quot;</span>);
<a name="l00197"></a>00197     
<a name="l00198"></a>00198   std::pair&lt;unsigned int, unsigned int&gt; solve_data;
<a name="l00199"></a>00199 
<a name="l00200"></a>00200   <span class="comment">// call the solver depending on the type of eigenproblem</span>
<a name="l00201"></a>00201   <span class="keywordflow">if</span> (<a class="code" href="classEigenSystem.php#a97508587f94671839513e5e7726eaf98">_is_generalized_eigenproblem</a>)
<a name="l00202"></a>00202     { 
<a name="l00203"></a>00203       <span class="comment">//in case of a generalized eigenproblem</span>
<a name="l00204"></a>00204       solve_data = <a class="code" href="classEigenSystem.php#a074981c327971f345faae5d52612c8cb">eigen_solver</a>-&gt;solve_generalized (*<a class="code" href="classEigenSystem.php#a164a61a629d13eb618f31091b07ea905">matrix_A</a>,*<a class="code" href="classEigenSystem.php#a45431ded5fcf8a09c65435c75a71b522">matrix_B</a>, nev, ncv, tol, maxits);
<a name="l00205"></a>00205       
<a name="l00206"></a>00206     }
<a name="l00207"></a>00207   
<a name="l00208"></a>00208   <span class="keywordflow">else</span>
<a name="l00209"></a>00209     {
<a name="l00210"></a>00210       libmesh_assert (<a class="code" href="classEigenSystem.php#a45431ded5fcf8a09c65435c75a71b522">matrix_B</a> == NULL);
<a name="l00211"></a>00211       
<a name="l00212"></a>00212       <span class="comment">//in case of a standard eigenproblem</span>
<a name="l00213"></a>00213       solve_data = <a class="code" href="classEigenSystem.php#a074981c327971f345faae5d52612c8cb">eigen_solver</a>-&gt;solve_standard (*<a class="code" href="classEigenSystem.php#a164a61a629d13eb618f31091b07ea905">matrix_A</a>, nev, ncv, tol, maxits);
<a name="l00214"></a>00214       
<a name="l00215"></a>00215     }
<a name="l00216"></a>00216   
<a name="l00217"></a>00217   this-&gt;<a class="code" href="classEigenSystem.php#ac94a484092ca9d6a60c7a0c2bb85aa9b">_n_converged_eigenpairs</a> = solve_data.first;
<a name="l00218"></a>00218   this-&gt;<a class="code" href="classEigenSystem.php#a05770a2675b6bb018f8fa65fc98bdb5b">_n_iterations</a>           = solve_data.second;
<a name="l00219"></a>00219   
<a name="l00220"></a>00220 }
<a name="l00221"></a>00221 
<a name="l00222"></a><a class="code" href="classEigenSystem.php#ae9a0d81ef8cda5ab6ba9a92836fdde1a">00222</a> <span class="keywordtype">void</span> <a class="code" href="classEigenSystem.php#ae9a0d81ef8cda5ab6ba9a92836fdde1a">EigenSystem::adjoint_solve</a>() 
<a name="l00223"></a>00223 {
<a name="l00224"></a>00224   libmesh_not_implemented();
<a name="l00225"></a>00225 }
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 <span class="keywordtype">void</span> <a class="code" href="classEigenSystem.php#a8265bd7adccea0203a3c9d334540c49f">EigenSystem::qoi_parameter_sensitivity</a>
<a name="l00228"></a><a class="code" href="classEigenSystem.php#a8265bd7adccea0203a3c9d334540c49f">00228</a>   (std::vector&lt;Number *&gt;&amp; parameters,
<a name="l00229"></a>00229    std::vector&lt;Number&gt;&amp; sensitivities)
<a name="l00230"></a>00230 {
<a name="l00231"></a>00231   libmesh_not_implemented();
<a name="l00232"></a>00232 }
<a name="l00233"></a>00233 
<a name="l00234"></a><a class="code" href="classEigenSystem.php#aec909ae4e751619ec3c65f5d10e72484">00234</a> <span class="keywordtype">void</span> <a class="code" href="classEigenSystem.php#aec909ae4e751619ec3c65f5d10e72484">EigenSystem::assemble</a> ()
<a name="l00235"></a>00235 {
<a name="l00236"></a>00236 
<a name="l00237"></a>00237   <span class="comment">// Assemble the linear system</span>
<a name="l00238"></a>00238   <a class="code" href="classSystem.php#abca899f8ae44d10c606fe28b5e8420dd">Parent::assemble</a> (); 
<a name="l00239"></a>00239 
<a name="l00240"></a>00240 }
<a name="l00241"></a>00241 
<a name="l00242"></a>00242 
<a name="l00243"></a><a class="code" href="classEigenSystem.php#a6510cecffe0a26e6b748790807f386c4">00243</a> std::pair&lt;Real, Real&gt; <a class="code" href="classEigenSystem.php#a6510cecffe0a26e6b748790807f386c4">EigenSystem::get_eigenpair</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00244"></a>00244 {
<a name="l00245"></a>00245   <span class="comment">// call the eigen_solver get_eigenpair method</span>
<a name="l00246"></a>00246   <span class="keywordflow">return</span> <a class="code" href="classEigenSystem.php#a074981c327971f345faae5d52612c8cb">eigen_solver</a>-&gt;get_eigenpair (i, *<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>);
<a name="l00247"></a>00247 }
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 <span class="preprocessor">#endif // LIBMESH_HAVE_SLEPC</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
