<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>eigen_system.h</h1>  </div>
</div>
<div class="contents">
<a href="eigen__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: eigen_system.h 3461 2009-09-15 15:38:39Z knezed01 $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributd in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __eigen_system_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __eigen_system_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Currently, the EigenSystem should only be available</span>
<a name="l00027"></a>00027 <span class="comment">// if SLEPc support is enabled. </span>
<a name="l00028"></a>00028 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC)</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="comment">// C++ includes</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Local Includes</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;eigen_solver.h&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Forward Declarations</span>
<a name="l00038"></a>00038 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classSparseMatrix.php">SparseMatrix</a>;
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00049"></a>00049 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00050"></a>00050 <span class="comment">// EigenSystem class definition</span>
<a name="l00051"></a>00051 
<a name="l00052"></a><a class="code" href="classEigenSystem.php">00052</a> <span class="keyword">class </span><a class="code" href="classEigenSystem.php">EigenSystem</a> : <span class="keyword">public</span> <a class="code" href="classSystem.php">System</a>
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054 <span class="keyword">public</span>:
<a name="l00055"></a>00055 
<a name="l00060"></a>00060   <a class="code" href="classEigenSystem.php#af8bb02f23fb6a666ef34c8b602bdafc5">EigenSystem</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00061"></a>00061                <span class="keyword">const</span> std::string&amp; <a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>,
<a name="l00062"></a>00062                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">number</a>);
<a name="l00063"></a>00063 
<a name="l00067"></a>00067   <span class="keyword">virtual</span> <a class="code" href="classEigenSystem.php#a821daab8517a843411a2f50ad1fe2229">~EigenSystem</a> ();
<a name="l00068"></a>00068  
<a name="l00072"></a><a class="code" href="classEigenSystem.php#a2e82f45f7e7a643fd981685d216f32c3">00072</a>   <span class="keyword">typedef</span> <a class="code" href="classEigenSystem.php">EigenSystem</a> <a class="code" href="classEigenSystem.php#a2e82f45f7e7a643fd981685d216f32c3">sys_type</a>;
<a name="l00073"></a>00073 
<a name="l00077"></a><a class="code" href="classEigenSystem.php#a234eac6d4c56752d6ae1efa1e89cb461">00077</a>   <span class="keyword">typedef</span> <a class="code" href="classSystem.php">System</a> <a class="code" href="classEigenSystem.php#a234eac6d4c56752d6ae1efa1e89cb461">Parent</a>;
<a name="l00078"></a>00078   
<a name="l00082"></a><a class="code" href="classEigenSystem.php#a5305f621fe53077a795936b42114d5f8">00082</a>   <a class="code" href="classEigenSystem.php">sys_type</a> &amp; <a class="code" href="classEigenSystem.php#a5305f621fe53077a795936b42114d5f8">system</a> () { <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00083"></a>00083   
<a name="l00088"></a>00088   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEigenSystem.php#ad0aa71bba22ef71e16b81edb3930c171">clear</a> ();
<a name="l00089"></a>00089 
<a name="l00094"></a>00094   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEigenSystem.php#ab7d42c5fbfd8dd39840ab00d594b0718">reinit</a> ();
<a name="l00095"></a>00095   
<a name="l00099"></a>00099   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEigenSystem.php#a0aad526a1a447036c754bccb2803b73e">solve</a> ();
<a name="l00100"></a>00100 
<a name="l00106"></a>00106   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEigenSystem.php#ae9a0d81ef8cda5ab6ba9a92836fdde1a">adjoint_solve</a> ();
<a name="l00107"></a>00107 
<a name="l00116"></a>00116   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEigenSystem.php#a8265bd7adccea0203a3c9d334540c49f">qoi_parameter_sensitivity</a> (std::vector&lt;Number *&gt;&amp; parameters,
<a name="l00117"></a>00117                                           std::vector&lt;Number&gt;&amp; sensitivities);
<a name="l00118"></a>00118  
<a name="l00122"></a>00122   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEigenSystem.php#aec909ae4e751619ec3c65f5d10e72484">assemble</a> ();
<a name="l00123"></a>00123 
<a name="l00128"></a>00128   <span class="keyword">virtual</span> std::pair&lt;Real, Real&gt; <a class="code" href="classEigenSystem.php#a6510cecffe0a26e6b748790807f386c4">get_eigenpair</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00129"></a>00129   
<a name="l00134"></a><a class="code" href="classEigenSystem.php#a2ec35e7f9233dbd0a73e17ff441a20da">00134</a>   <span class="keyword">virtual</span> std::string <a class="code" href="classEigenSystem.php#a2ec35e7f9233dbd0a73e17ff441a20da">system_type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="stringliteral">&quot;Eigen&quot;</span>; }
<a name="l00135"></a>00135 
<a name="l00139"></a><a class="code" href="classEigenSystem.php#ae2f5a00675e50069fca0e6af16e7c92a">00139</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEigenSystem.php#ae2f5a00675e50069fca0e6af16e7c92a">get_n_converged</a> ()<span class="keyword"> const </span>{<span class="keywordflow">return</span> <a class="code" href="classEigenSystem.php#ac94a484092ca9d6a60c7a0c2bb85aa9b">_n_converged_eigenpairs</a>;}
<a name="l00140"></a>00140 
<a name="l00144"></a><a class="code" href="classEigenSystem.php#a485406c48f7849787481476fb1fa9a06">00144</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEigenSystem.php#a485406c48f7849787481476fb1fa9a06">get_n_iterations</a> ()<span class="keyword"> const </span>{<span class="keywordflow">return</span> <a class="code" href="classEigenSystem.php#a05770a2675b6bb018f8fa65fc98bdb5b">_n_iterations</a>;}
<a name="l00145"></a>00145   
<a name="l00149"></a>00149   <span class="keywordtype">void</span> <a class="code" href="classEigenSystem.php#a5036e4b330bebb41cbb08ee0f8068695">set_eigenproblem_type</a> (<a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301">EigenProblemType</a> ept);
<a name="l00150"></a>00150   
<a name="l00154"></a><a class="code" href="classEigenSystem.php#a2be7b0bed329078dd7be3760acbf770d">00154</a>   <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301">EigenProblemType</a> <a class="code" href="classEigenSystem.php#a2be7b0bed329078dd7be3760acbf770d">get_eigenproblem_type</a> ()<span class="keyword"> const </span>{<span class="keywordflow">return</span> <a class="code" href="classEigenSystem.php#a5061bbfe9a901b12818f2480f22d25e7">_eigen_problem_type</a>;}
<a name="l00155"></a>00155   
<a name="l00160"></a><a class="code" href="classEigenSystem.php#a221ec03865872d60108d9b7bf40808f3">00160</a>   <span class="keywordtype">bool</span> <a class="code" href="classEigenSystem.php#a221ec03865872d60108d9b7bf40808f3">generalized</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classEigenSystem.php#a97508587f94671839513e5e7726eaf98">_is_generalized_eigenproblem</a>; }
<a name="l00161"></a>00161   
<a name="l00165"></a><a class="code" href="classEigenSystem.php#a164a61a629d13eb618f31091b07ea905">00165</a>   <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;Number&gt;</a> *<a class="code" href="classEigenSystem.php#a164a61a629d13eb618f31091b07ea905">matrix_A</a>;
<a name="l00166"></a>00166 
<a name="l00170"></a><a class="code" href="classEigenSystem.php#a45431ded5fcf8a09c65435c75a71b522">00170</a>   <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;Number&gt;</a> *<a class="code" href="classEigenSystem.php#a45431ded5fcf8a09c65435c75a71b522">matrix_B</a>;
<a name="l00171"></a>00171 
<a name="l00176"></a><a class="code" href="classEigenSystem.php#a074981c327971f345faae5d52612c8cb">00176</a>   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;EigenSolver&lt;Number&gt;</a> &gt; <a class="code" href="classEigenSystem.php#a074981c327971f345faae5d52612c8cb">eigen_solver</a>;
<a name="l00177"></a>00177  
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 <span class="keyword">protected</span>:
<a name="l00180"></a>00180 
<a name="l00181"></a>00181   
<a name="l00186"></a>00186   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEigenSystem.php#a326dcd6dcedfbba8fbd8f5833b0bfd6a">init_data</a> ();
<a name="l00187"></a>00187 
<a name="l00192"></a><a class="code" href="classEigenSystem.php#a8d751fc92ac9a6f49e9a895ff8c5fa29">00192</a>   <span class="keywordtype">void</span> <a class="code" href="classEigenSystem.php#a8d751fc92ac9a6f49e9a895ff8c5fa29">set_n_converged</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nconv)
<a name="l00193"></a>00193     { <a class="code" href="classEigenSystem.php#ac94a484092ca9d6a60c7a0c2bb85aa9b">_n_converged_eigenpairs</a> = nconv; }
<a name="l00194"></a>00194 
<a name="l00199"></a><a class="code" href="classEigenSystem.php#ad1323985914b1030cc24f1ebb54fa140">00199</a>   <span class="keywordtype">void</span> <a class="code" href="classEigenSystem.php#ad1323985914b1030cc24f1ebb54fa140">set_n_iterations</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> its) 
<a name="l00200"></a>00200     { <a class="code" href="classEigenSystem.php#a05770a2675b6bb018f8fa65fc98bdb5b">_n_iterations</a> = its;}
<a name="l00201"></a>00201 
<a name="l00202"></a>00202  
<a name="l00203"></a>00203 <span class="keyword">private</span>:
<a name="l00204"></a>00204 
<a name="l00208"></a><a class="code" href="classEigenSystem.php#ac94a484092ca9d6a60c7a0c2bb85aa9b">00208</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEigenSystem.php#ac94a484092ca9d6a60c7a0c2bb85aa9b">_n_converged_eigenpairs</a>;
<a name="l00209"></a>00209 
<a name="l00213"></a><a class="code" href="classEigenSystem.php#a05770a2675b6bb018f8fa65fc98bdb5b">00213</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEigenSystem.php#a05770a2675b6bb018f8fa65fc98bdb5b">_n_iterations</a>;
<a name="l00214"></a>00214   
<a name="l00219"></a><a class="code" href="classEigenSystem.php#a97508587f94671839513e5e7726eaf98">00219</a>   <span class="keywordtype">bool</span> <a class="code" href="classEigenSystem.php#a97508587f94671839513e5e7726eaf98">_is_generalized_eigenproblem</a>;
<a name="l00220"></a>00220   
<a name="l00224"></a><a class="code" href="classEigenSystem.php#a5061bbfe9a901b12818f2480f22d25e7">00224</a>   <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301">EigenProblemType</a> <a class="code" href="classEigenSystem.php#a5061bbfe9a901b12818f2480f22d25e7">_eigen_problem_type</a>;
<a name="l00225"></a>00225   
<a name="l00226"></a>00226   
<a name="l00227"></a>00227 };
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00232"></a>00232 <span class="comment">// EigenSystem inline methods</span>
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 <span class="preprocessor">#endif // LIBMESH_HAVE_SLEPC</span>
<a name="l00236"></a>00236 <span class="preprocessor"></span>
<a name="l00237"></a>00237 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
