<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_60be1125a39495b698d2d56e8e5b50b1.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>eigen_time_solver.C</h1>  </div>
</div>
<div class="contents">
<a href="eigen__time__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: eigen_time_solver.C 3502 2009-10-20 18:06:50Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#ifdef LIBMESH_HAVE_SLEPC</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;diff_solver.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;diff_system.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;eigen_time_solver.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;eigen_solver.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;sparse_matrix.h&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Constructor</span>
<a name="l00032"></a><a class="code" href="classEigenTimeSolver.php#a1b063e1445eb3218979a7476a007e937">00032</a> <a class="code" href="classEigenTimeSolver.php#a1b063e1445eb3218979a7476a007e937">EigenTimeSolver::EigenTimeSolver</a> (<a class="code" href="classDifferentiableSystem.php">sys_type</a>&amp; s)
<a name="l00033"></a>00033   : <a class="code" href="classTimeSolver.php">Parent</a>(s),
<a name="l00034"></a>00034     eigen_solver     (<a class="code" href="classEigenSolver.php">EigenSolver</a>&lt;<a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>&gt;::build()),
<a name="l00035"></a>00035     tol(<a class="code" href="namespaceUtility.php#aa31a2ff44b735ae86eea0446796a3b42">pow</a>(TOLERANCE, 5./3.)),
<a name="l00036"></a>00036     maxits(1000),
<a name="l00037"></a>00037     n_eigenpairs_to_compute(5),
<a name="l00038"></a>00038     n_basis_vectors_to_use(3*n_eigenpairs_to_compute),
<a name="l00039"></a>00039     n_converged_eigenpairs(0),    
<a name="l00040"></a>00040     n_iterations_reqd(0)
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042   libmesh_experimental();
<a name="l00043"></a>00043   <a class="code" href="classEigenTimeSolver.php#a46a3a8c4f2856295004a862267b02807">eigen_solver</a>-&gt;set_eigenproblem_type(<a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301a2249b7b4acec69dfdd4212b7a0333c22">GHEP</a>);<span class="comment">//or GNHEP</span>
<a name="l00044"></a>00044   <a class="code" href="classEigenTimeSolver.php#a46a3a8c4f2856295004a862267b02807">eigen_solver</a>-&gt;set_position_of_spectrum(<a class="code" href="namespacelibMeshEnums.php#a0630b52d8fe07f56702ddb7c6ff14d84aa33e7e94f5eba77558dbdb57a640e964">LARGEST_MAGNITUDE</a>);
<a name="l00045"></a>00045 }
<a name="l00046"></a>00046 
<a name="l00047"></a><a class="code" href="classEigenTimeSolver.php#a2924c8dbef275148c88d538b2190f040">00047</a> <a class="code" href="classEigenTimeSolver.php#a2924c8dbef275148c88d538b2190f040">EigenTimeSolver::~EigenTimeSolver</a> ()
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049 }
<a name="l00050"></a>00050 
<a name="l00051"></a><a class="code" href="classEigenTimeSolver.php#af5f077bc553356e65802bc6cbefb644f">00051</a> <span class="keywordtype">void</span> <a class="code" href="classEigenTimeSolver.php#af5f077bc553356e65802bc6cbefb644f">EigenTimeSolver::reinit</a> ()
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053   <span class="comment">// empty...</span>
<a name="l00054"></a>00054 }
<a name="l00055"></a>00055   
<a name="l00056"></a><a class="code" href="classEigenTimeSolver.php#a8dbd7cdaa354a52159eae9a8099806ec">00056</a> <span class="keywordtype">void</span> <a class="code" href="classEigenTimeSolver.php#a8dbd7cdaa354a52159eae9a8099806ec">EigenTimeSolver::init</a> ()
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058   <span class="comment">// Add matrix &quot;B&quot; to _system if not already there.</span>
<a name="l00059"></a>00059   <span class="comment">// The user may have already added a matrix &quot;B&quot; before</span>
<a name="l00060"></a>00060   <span class="comment">// calling the System initialization.  This would be</span>
<a name="l00061"></a>00061   <span class="comment">// necessary if e.g. the System originally started life</span>
<a name="l00062"></a>00062   <span class="comment">// with a different type of TimeSolver and only later</span>
<a name="l00063"></a>00063   <span class="comment">// had its TimeSolver changed to an EigenTimeSolver.</span>
<a name="l00064"></a>00064   <span class="keywordflow">if</span> (!<a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classImplicitSystem.php#aa23d50b0a898aaee758d4a98c996a4df">have_matrix</a>(<span class="stringliteral">&quot;B&quot;</span>))
<a name="l00065"></a>00065     <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classImplicitSystem.php#acad3dc8b26c91f6c82c3e9708a1dc2e1">add_matrix</a>(<span class="stringliteral">&quot;B&quot;</span>);
<a name="l00066"></a>00066 }
<a name="l00067"></a>00067 
<a name="l00068"></a><a class="code" href="classEigenTimeSolver.php#ab53f5293245866e3bef76fd7755a3cff">00068</a> <span class="keywordtype">void</span> <a class="code" href="classEigenTimeSolver.php#ab53f5293245866e3bef76fd7755a3cff">EigenTimeSolver::solve</a> ()
<a name="l00069"></a>00069 {
<a name="l00070"></a>00070   <span class="comment">// The standard implementation is basically to call:</span>
<a name="l00071"></a>00071   <span class="comment">// _diff_solver-&gt;solve();</span>
<a name="l00072"></a>00072   <span class="comment">// which internally assembles (when necessary) matrices and vectors</span>
<a name="l00073"></a>00073   <span class="comment">// and calls linear solver software while also doing Newton steps (see newton_solver.C)</span>
<a name="l00074"></a>00074   <span class="comment">//</span>
<a name="l00075"></a>00075   <span class="comment">// The element_residual and side_residual functions below control</span>
<a name="l00076"></a>00076   <span class="comment">// what happens in the interior of the element assembly loops.</span>
<a name="l00077"></a>00077   <span class="comment">// We have a system reference, so it&#39;s possible to call _system.assembly()</span>
<a name="l00078"></a>00078   <span class="comment">// ourselves if we want to...</span>
<a name="l00079"></a>00079   <span class="comment">//</span>
<a name="l00080"></a>00080   <span class="comment">// Interestingly, for the EigenSolver we don&#39;t need residuals...just Jacobians.</span>
<a name="l00081"></a>00081   <span class="comment">// The Jacobian should therefore always be requested, and always return</span>
<a name="l00082"></a>00082   <span class="comment">// jacobian_computed as being true.</span>
<a name="l00083"></a>00083 
<a name="l00084"></a>00084   <span class="comment">// The basic plan of attack is:</span>
<a name="l00085"></a>00085   <span class="comment">// .) Construct the Jacobian using _system.assembly(true,true) as we</span>
<a name="l00086"></a>00086   <span class="comment">//    would for a steady system.  Use a flag in this class to</span>
<a name="l00087"></a>00087   <span class="comment">//    control behavior in element_residual and side_residual</span>
<a name="l00088"></a>00088   <span class="comment">// .) Swap _system.matrix to matrix &quot;B&quot; (be sure to add this extra matrix during init)</span>
<a name="l00089"></a>00089   <span class="comment">// .) Call _system.assembly(true,true) again, using the flag in element_residual</span>
<a name="l00090"></a>00090   <span class="comment">//    and side_residual to only get the mass matrix terms.</span>
<a name="l00091"></a>00091   <span class="comment">// .) Send A and B to Steffen&#39;s EigenSolver interface.</span>
<a name="l00092"></a>00092 
<a name="l00093"></a>00093   <span class="comment">// Assemble the spatial part (matrix A) of the operator</span>
<a name="l00094"></a>00094   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classTimeSolver.php#a89d506f1634a4d0a9578ff3773050a8b">quiet</a>)
<a name="l00095"></a>00095     std::cout &lt;&lt; <span class="stringliteral">&quot;Assembling matrix A.&quot;</span> &lt;&lt; std::endl;
<a name="l00096"></a>00096   <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a> =   &amp;( <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classImplicitSystem.php#a719365410b024d2ddab0b1bada55753d">get_matrix</a> (<span class="stringliteral">&quot;System Matrix&quot;</span>) );
<a name="l00097"></a>00097   this-&gt;<a class="code" href="classEigenTimeSolver.php#a8db31aa0d7e6fdb9b9fcbbe133adbf63">now_assembling</a> = <a class="code" href="classEigenTimeSolver.php#a9347fe06b54485ffc4709dfd9fee1973a8c21002592845367a024b72f41e406fb">Matrix_A</a>;
<a name="l00098"></a>00098   <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#af2770154003897eef7c70a5318478393">assembly</a>(<span class="keyword">true</span>, <span class="keyword">true</span>);
<a name="l00099"></a>00099   <span class="comment">//_system.matrix-&gt;print_matlab(&quot;matrix_A.m&quot;);</span>
<a name="l00100"></a>00100   
<a name="l00101"></a>00101   <span class="comment">// Point the system&#39;s matrix at B, call assembly again.</span>
<a name="l00102"></a>00102   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classTimeSolver.php#a89d506f1634a4d0a9578ff3773050a8b">quiet</a>)
<a name="l00103"></a>00103     std::cout &lt;&lt; <span class="stringliteral">&quot;Assembling matrix B.&quot;</span> &lt;&lt; std::endl;
<a name="l00104"></a>00104   <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a> =   &amp;( <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classImplicitSystem.php#a719365410b024d2ddab0b1bada55753d">get_matrix</a> (<span class="stringliteral">&quot;B&quot;</span>) );
<a name="l00105"></a>00105   this-&gt;<a class="code" href="classEigenTimeSolver.php#a8db31aa0d7e6fdb9b9fcbbe133adbf63">now_assembling</a> = <a class="code" href="classEigenTimeSolver.php#a9347fe06b54485ffc4709dfd9fee1973a339cfc1245f1df0cb7669fc6ff61292c">Matrix_B</a>;
<a name="l00106"></a>00106   <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#af2770154003897eef7c70a5318478393">assembly</a>(<span class="keyword">true</span>, <span class="keyword">true</span>);
<a name="l00107"></a>00107   <span class="comment">//_system.matrix-&gt;print_matlab(&quot;matrix_B.m&quot;);</span>
<a name="l00108"></a>00108   
<a name="l00109"></a>00109   <span class="comment">// Send matrices A, B to Steffen&#39;s SlepcEigenSolver interface</span>
<a name="l00110"></a>00110   <span class="comment">//libmesh_here();</span>
<a name="l00111"></a>00111   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classTimeSolver.php#a89d506f1634a4d0a9578ff3773050a8b">quiet</a>)
<a name="l00112"></a>00112     std::cout &lt;&lt; <span class="stringliteral">&quot;Calling the EigenSolver.&quot;</span> &lt;&lt; std::endl;
<a name="l00113"></a>00113   std::pair&lt;unsigned int, unsigned int&gt; solve_data =
<a name="l00114"></a>00114     <a class="code" href="classEigenTimeSolver.php#a46a3a8c4f2856295004a862267b02807">eigen_solver</a>-&gt;solve_generalized (<a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classImplicitSystem.php#a719365410b024d2ddab0b1bada55753d">get_matrix</a> (<span class="stringliteral">&quot;System Matrix&quot;</span>),
<a name="l00115"></a>00115                                      <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classImplicitSystem.php#a719365410b024d2ddab0b1bada55753d">get_matrix</a> (<span class="stringliteral">&quot;B&quot;</span>),
<a name="l00116"></a>00116                                      <a class="code" href="classEigenTimeSolver.php#a63f7d3fcdf43068e53170e2a90b1b82c">n_eigenpairs_to_compute</a>,
<a name="l00117"></a>00117                                      <a class="code" href="classEigenTimeSolver.php#a55c63a8c25371e8325eee178f04e91f7">n_basis_vectors_to_use</a>,
<a name="l00118"></a>00118                                      <a class="code" href="classEigenTimeSolver.php#a181723b877a4edf43ca8acc98bceb434">tol</a>,
<a name="l00119"></a>00119                                      <a class="code" href="classEigenTimeSolver.php#a18a2e19bbe7655cb3de1fcd39b5fa438">maxits</a>);
<a name="l00120"></a>00120   
<a name="l00121"></a>00121   this-&gt;<a class="code" href="classEigenTimeSolver.php#a56fcccdf9d62f077671c787c170bde44">n_converged_eigenpairs</a> = solve_data.first;
<a name="l00122"></a>00122   this-&gt;<a class="code" href="classEigenTimeSolver.php#a575ffeef932270dcab08935dde26596d">n_iterations_reqd</a>      = solve_data.second;
<a name="l00123"></a>00123 }
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a><a class="code" href="classEigenTimeSolver.php#a8dea6463bf379d19f5f53e309a591e82">00127</a> <span class="keywordtype">bool</span> <a class="code" href="classEigenTimeSolver.php#a8dea6463bf379d19f5f53e309a591e82">EigenTimeSolver::element_residual</a>(<span class="keywordtype">bool</span> request_jacobian,
<a name="l00128"></a>00128                                        <a class="code" href="classDiffContext.php">DiffContext</a> &amp;context)
<a name="l00129"></a>00129 {
<a name="l00130"></a>00130   <span class="comment">// The EigenTimeSolver always computes jacobians!</span>
<a name="l00131"></a>00131   libmesh_assert (request_jacobian);
<a name="l00132"></a>00132   
<a name="l00133"></a>00133   <span class="comment">// Assemble the operator for the spatial part.</span>
<a name="l00134"></a>00134   <span class="keywordflow">if</span> (<a class="code" href="classEigenTimeSolver.php#a8db31aa0d7e6fdb9b9fcbbe133adbf63">now_assembling</a> == <a class="code" href="classEigenTimeSolver.php#a9347fe06b54485ffc4709dfd9fee1973a8c21002592845367a024b72f41e406fb">Matrix_A</a>)
<a name="l00135"></a>00135     {
<a name="l00136"></a>00136       <span class="keywordtype">bool</span> jacobian_computed =
<a name="l00137"></a>00137         <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a518a1763297cc2706185c539cc4fcec5">element_time_derivative</a>(request_jacobian, context);
<a name="l00138"></a>00138 
<a name="l00139"></a>00139       <span class="comment">// The user shouldn&#39;t compute a jacobian unless requested</span>
<a name="l00140"></a>00140       libmesh_assert(request_jacobian || !jacobian_computed);
<a name="l00141"></a>00141 
<a name="l00142"></a>00142       <span class="keywordtype">bool</span> jacobian_computed2 =
<a name="l00143"></a>00143         <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a516241801a3773a0c9d4a4b0d12de174">element_constraint</a>(jacobian_computed, context);
<a name="l00144"></a>00144 
<a name="l00145"></a>00145       <span class="comment">// The user shouldn&#39;t compute a jacobian unless requested</span>
<a name="l00146"></a>00146       libmesh_assert (jacobian_computed || !jacobian_computed2);
<a name="l00147"></a>00147 
<a name="l00148"></a>00148       <span class="keywordflow">return</span> jacobian_computed &amp;&amp; jacobian_computed2;
<a name="l00149"></a>00149   
<a name="l00150"></a>00150     }
<a name="l00151"></a>00151 
<a name="l00152"></a>00152   <span class="comment">// Assemble the mass matrix operator</span>
<a name="l00153"></a>00153   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classEigenTimeSolver.php#a8db31aa0d7e6fdb9b9fcbbe133adbf63">now_assembling</a> == <a class="code" href="classEigenTimeSolver.php#a9347fe06b54485ffc4709dfd9fee1973a339cfc1245f1df0cb7669fc6ff61292c">Matrix_B</a>)
<a name="l00154"></a>00154     {
<a name="l00155"></a>00155       <span class="keywordtype">bool</span> mass_jacobian_computed =
<a name="l00156"></a>00156         <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#aa69fa37b59f37a015d907d9833a4d053">mass_residual</a>(request_jacobian, context);
<a name="l00157"></a>00157 
<a name="l00158"></a>00158       <span class="comment">// Scale Jacobian by -1?</span>
<a name="l00159"></a>00159       <span class="comment">//context.elem_jacobian *= -1.0;</span>
<a name="l00160"></a>00160 
<a name="l00161"></a>00161       <span class="keywordflow">return</span> mass_jacobian_computed;
<a name="l00162"></a>00162     }
<a name="l00163"></a>00163 
<a name="l00164"></a>00164   <span class="keywordflow">else</span>
<a name="l00165"></a>00165     {
<a name="l00166"></a>00166       libmesh_error();
<a name="l00167"></a>00167       <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00168"></a>00168     }
<a name="l00169"></a>00169 }
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 
<a name="l00173"></a><a class="code" href="classEigenTimeSolver.php#a19451a2a85620178bb49c5c4681d7d0f">00173</a> <span class="keywordtype">bool</span> <a class="code" href="classEigenTimeSolver.php#a19451a2a85620178bb49c5c4681d7d0f">EigenTimeSolver::side_residual</a>(<span class="keywordtype">bool</span> request_jacobian,
<a name="l00174"></a>00174                                     <a class="code" href="classDiffContext.php">DiffContext</a> &amp;context)
<a name="l00175"></a>00175 {
<a name="l00176"></a>00176   <span class="comment">// The EigenTimeSolver always requests jacobians?</span>
<a name="l00177"></a>00177   <span class="comment">//libmesh_assert (request_jacobian);</span>
<a name="l00178"></a>00178 
<a name="l00179"></a>00179   <span class="comment">// Assemble the operator for the spatial part.</span>
<a name="l00180"></a>00180   <span class="keywordflow">if</span> (<a class="code" href="classEigenTimeSolver.php#a8db31aa0d7e6fdb9b9fcbbe133adbf63">now_assembling</a> == <a class="code" href="classEigenTimeSolver.php#a9347fe06b54485ffc4709dfd9fee1973a8c21002592845367a024b72f41e406fb">Matrix_A</a>)
<a name="l00181"></a>00181     {
<a name="l00182"></a>00182       <span class="keywordtype">bool</span> jacobian_computed =
<a name="l00183"></a>00183         <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a990b76eb7ed84572c0384d90fe51fbaf">side_time_derivative</a>(request_jacobian, context);
<a name="l00184"></a>00184 
<a name="l00185"></a>00185       <span class="comment">// The user shouldn&#39;t compute a jacobian unless requested</span>
<a name="l00186"></a>00186       libmesh_assert (request_jacobian || !jacobian_computed);
<a name="l00187"></a>00187 
<a name="l00188"></a>00188       <span class="keywordtype">bool</span> jacobian_computed2 =
<a name="l00189"></a>00189         <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a9520b686cc6181bff6888e0a96dd0c27">side_constraint</a>(jacobian_computed, context);
<a name="l00190"></a>00190 
<a name="l00191"></a>00191       <span class="comment">// The user shouldn&#39;t compute a jacobian unless requested</span>
<a name="l00192"></a>00192       libmesh_assert (jacobian_computed || !jacobian_computed2);
<a name="l00193"></a>00193   
<a name="l00194"></a>00194       <span class="keywordflow">return</span> jacobian_computed &amp;&amp; jacobian_computed2;
<a name="l00195"></a>00195   
<a name="l00196"></a>00196     }
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   <span class="comment">// There is now a &quot;side&quot; equivalent for the mass matrix</span>
<a name="l00199"></a>00199   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classEigenTimeSolver.php#a8db31aa0d7e6fdb9b9fcbbe133adbf63">now_assembling</a> == <a class="code" href="classEigenTimeSolver.php#a9347fe06b54485ffc4709dfd9fee1973a339cfc1245f1df0cb7669fc6ff61292c">Matrix_B</a>)
<a name="l00200"></a>00200     {
<a name="l00201"></a>00201       <span class="keywordtype">bool</span> mass_jacobian_computed =
<a name="l00202"></a>00202         <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a5c1dd0b32156465b148fc35ca29d70e8">side_mass_residual</a>(request_jacobian, context);
<a name="l00203"></a>00203 
<a name="l00204"></a>00204       <span class="keywordflow">return</span> mass_jacobian_computed;
<a name="l00205"></a>00205     }
<a name="l00206"></a>00206 
<a name="l00207"></a>00207   <span class="keywordflow">else</span>
<a name="l00208"></a>00208     {
<a name="l00209"></a>00209       libmesh_error();
<a name="l00210"></a>00210       <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00211"></a>00211     }
<a name="l00212"></a>00212 }
<a name="l00213"></a>00213 
<a name="l00214"></a>00214 <span class="preprocessor">#endif // LIBMESH_HAVE_SLEPC</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
