<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>eigen_time_solver.h</h1>  </div>
</div>
<div class="contents">
<a href="eigen__time__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: eigen_time_solver.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __eigen_time_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __eigen_time_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#ifdef LIBMESH_HAVE_SLEPC</span>
<a name="l00027"></a>00027 <span class="preprocessor"></span>
<a name="l00028"></a>00028 <span class="comment">// C++ includes</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="time__solver_8h.php">time_solver.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Forward declarations</span>
<a name="l00034"></a>00034 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classEigenSolver.php">EigenSolver</a>;
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00066"></a><a class="code" href="classEigenTimeSolver.php">00066</a> <span class="keyword">class </span><a class="code" href="classEigenTimeSolver.php">EigenTimeSolver</a> : <span class="keyword">public</span> <a class="code" href="classTimeSolver.php">TimeSolver</a>
<a name="l00067"></a>00067 {
<a name="l00068"></a>00068 <span class="keyword">public</span>:
<a name="l00072"></a><a class="code" href="classEigenTimeSolver.php#ab9b0b948d2c62635efd32e2875f5e5a0">00072</a>   <span class="keyword">typedef</span> <a class="code" href="classDifferentiableSystem.php">DifferentiableSystem</a> <a class="code" href="classEigenTimeSolver.php#ab9b0b948d2c62635efd32e2875f5e5a0">sys_type</a>;
<a name="l00073"></a>00073 
<a name="l00077"></a><a class="code" href="classEigenTimeSolver.php#a4dec0f6c1f55ebdf3477cab5d89124e8">00077</a>   <span class="keyword">typedef</span> <a class="code" href="classTimeSolver.php">TimeSolver</a> <a class="code" href="classEigenTimeSolver.php#a4dec0f6c1f55ebdf3477cab5d89124e8">Parent</a>;
<a name="l00078"></a>00078   
<a name="l00083"></a>00083   <a class="code" href="classEigenTimeSolver.php#a1b063e1445eb3218979a7476a007e937">EigenTimeSolver</a> (<a class="code" href="classDifferentiableSystem.php">sys_type</a>&amp; s);
<a name="l00084"></a>00084   
<a name="l00088"></a>00088   <span class="keyword">virtual</span> <a class="code" href="classEigenTimeSolver.php#a2924c8dbef275148c88d538b2190f040">~EigenTimeSolver</a> ();
<a name="l00089"></a>00089 
<a name="l00094"></a>00094   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEigenTimeSolver.php#a8dbd7cdaa354a52159eae9a8099806ec">init</a> ();
<a name="l00095"></a>00095 
<a name="l00100"></a>00100   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEigenTimeSolver.php#af5f077bc553356e65802bc6cbefb644f">reinit</a> ();
<a name="l00101"></a>00101 
<a name="l00106"></a>00106   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEigenTimeSolver.php#ab53f5293245866e3bef76fd7755a3cff">solve</a> ();
<a name="l00107"></a>00107 
<a name="l00111"></a><a class="code" href="classEigenTimeSolver.php#a61e5ad6959ebf875c364c97543d026d5">00111</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEigenTimeSolver.php#a61e5ad6959ebf875c364c97543d026d5">advance_timestep</a> () { }
<a name="l00112"></a>00112 
<a name="l00117"></a><a class="code" href="classEigenTimeSolver.php#a167cb54ad007e9ba6550e86a7acc4b48">00117</a>   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classEigenTimeSolver.php#a167cb54ad007e9ba6550e86a7acc4b48">error_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0.; }
<a name="l00118"></a>00118 
<a name="l00123"></a>00123   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classEigenTimeSolver.php#a8dea6463bf379d19f5f53e309a591e82">element_residual</a> (<span class="keywordtype">bool</span> get_jacobian,
<a name="l00124"></a>00124                                  <a class="code" href="classDiffContext.php">DiffContext</a>&amp;);
<a name="l00125"></a>00125 
<a name="l00129"></a>00129   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classEigenTimeSolver.php#a19451a2a85620178bb49c5c4681d7d0f">side_residual</a> (<span class="keywordtype">bool</span> get_jacobian,
<a name="l00130"></a>00130                               <a class="code" href="classDiffContext.php">DiffContext</a>&amp;);
<a name="l00131"></a>00131 
<a name="l00137"></a><a class="code" href="classEigenTimeSolver.php#aec422d4b1ffe6b9f545f086a0fda4358">00137</a>   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classEigenTimeSolver.php#aec422d4b1ffe6b9f545f086a0fda4358">du</a> (<span class="keyword">const</span> <a class="code" href="classSystemNorm.php">SystemNorm</a>&amp;)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0.; }
<a name="l00138"></a>00138 
<a name="l00143"></a><a class="code" href="classEigenTimeSolver.php#a46a3a8c4f2856295004a862267b02807">00143</a>   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;EigenSolver&lt;Number&gt;</a> &gt; <a class="code" href="classEigenTimeSolver.php#a46a3a8c4f2856295004a862267b02807">eigen_solver</a>;
<a name="l00144"></a>00144 
<a name="l00149"></a><a class="code" href="classEigenTimeSolver.php#a181723b877a4edf43ca8acc98bceb434">00149</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classEigenTimeSolver.php#a181723b877a4edf43ca8acc98bceb434">tol</a>;
<a name="l00150"></a>00150 
<a name="l00154"></a><a class="code" href="classEigenTimeSolver.php#a18a2e19bbe7655cb3de1fcd39b5fa438">00154</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEigenTimeSolver.php#a18a2e19bbe7655cb3de1fcd39b5fa438">maxits</a>;
<a name="l00155"></a>00155 
<a name="l00159"></a><a class="code" href="classEigenTimeSolver.php#a63f7d3fcdf43068e53170e2a90b1b82c">00159</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEigenTimeSolver.php#a63f7d3fcdf43068e53170e2a90b1b82c">n_eigenpairs_to_compute</a>;    
<a name="l00160"></a>00160 
<a name="l00170"></a><a class="code" href="classEigenTimeSolver.php#a55c63a8c25371e8325eee178f04e91f7">00170</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEigenTimeSolver.php#a55c63a8c25371e8325eee178f04e91f7">n_basis_vectors_to_use</a>;
<a name="l00171"></a>00171 
<a name="l00176"></a><a class="code" href="classEigenTimeSolver.php#a56fcccdf9d62f077671c787c170bde44">00176</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEigenTimeSolver.php#a56fcccdf9d62f077671c787c170bde44">n_converged_eigenpairs</a>;
<a name="l00177"></a>00177 
<a name="l00182"></a><a class="code" href="classEigenTimeSolver.php#a575ffeef932270dcab08935dde26596d">00182</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEigenTimeSolver.php#a575ffeef932270dcab08935dde26596d">n_iterations_reqd</a>;
<a name="l00183"></a>00183   
<a name="l00184"></a>00184 <span class="keyword">private</span>:
<a name="l00185"></a>00185   
<a name="l00186"></a><a class="code" href="classEigenTimeSolver.php#a9347fe06b54485ffc4709dfd9fee1973">00186</a>   <span class="keyword">enum</span> <a class="code" href="classEigenTimeSolver.php#a9347fe06b54485ffc4709dfd9fee1973">NowAssembling</a> {
<a name="l00190"></a><a class="code" href="classEigenTimeSolver.php#a9347fe06b54485ffc4709dfd9fee1973a8c21002592845367a024b72f41e406fb">00190</a>     <a class="code" href="classEigenTimeSolver.php#a9347fe06b54485ffc4709dfd9fee1973a8c21002592845367a024b72f41e406fb">Matrix_A</a>,
<a name="l00191"></a>00191 
<a name="l00195"></a><a class="code" href="classEigenTimeSolver.php#a9347fe06b54485ffc4709dfd9fee1973a339cfc1245f1df0cb7669fc6ff61292c">00195</a>     <a class="code" href="classEigenTimeSolver.php#a9347fe06b54485ffc4709dfd9fee1973a339cfc1245f1df0cb7669fc6ff61292c">Matrix_B</a>,
<a name="l00196"></a>00196 
<a name="l00200"></a><a class="code" href="classEigenTimeSolver.php#a9347fe06b54485ffc4709dfd9fee1973a0c8343e13aad325af27cf939a3e33342">00200</a>     <a class="code" href="classEigenTimeSolver.php#a9347fe06b54485ffc4709dfd9fee1973a0c8343e13aad325af27cf939a3e33342">Invalid_Matrix</a>
<a name="l00201"></a>00201   };
<a name="l00202"></a>00202 
<a name="l00206"></a><a class="code" href="classEigenTimeSolver.php#a8db31aa0d7e6fdb9b9fcbbe133adbf63">00206</a>   <a class="code" href="classEigenTimeSolver.php#a9347fe06b54485ffc4709dfd9fee1973">NowAssembling</a> <a class="code" href="classEigenTimeSolver.php#a8db31aa0d7e6fdb9b9fcbbe133adbf63">now_assembling</a>;
<a name="l00207"></a>00207   
<a name="l00208"></a>00208 };
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 <span class="preprocessor">#endif // LIBMESH_HAVE_SLEPC</span>
<a name="l00212"></a>00212 <span class="preprocessor"></span><span class="preprocessor">#endif // #define __eigen_time_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
