<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>elem.h</h1>  </div>
</div>
<div class="contents">
<a href="elem_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: elem.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __elem_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __elem_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;dof_object.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;id_types.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;reference_counted_object.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="node_8h.php">node.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;enum_elem_type.h&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;enum_elem_quality.h&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;enum_order.h&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;enum_io_package.h&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;auto_ptr.h&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;multi_predicates.h&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &quot;variant_filter_iterator.h&quot;</span>
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="comment">// Forward declarations</span>
<a name="l00045"></a>00045 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00046"></a>00046 <span class="keyword">class </span><a class="code" href="classMeshRefinement.php">MeshRefinement</a>;
<a name="l00047"></a>00047 <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00048"></a>00048 
<a name="l00082"></a>00082 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00083"></a>00083 <span class="comment">// Elem class definition</span>
<a name="l00084"></a><a class="code" href="classElem.php">00084</a> <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a> : <span class="keyword">public</span> <a class="code" href="classReferenceCountedObject.php">ReferenceCountedObject</a>&lt;Elem&gt;,
<a name="l00085"></a>00085              <span class="keyword">public</span> <a class="code" href="classDofObject.php">DofObject</a>
<a name="l00086"></a>00086 {
<a name="l00087"></a>00087  <span class="keyword">protected</span>:
<a name="l00088"></a>00088   
<a name="l00095"></a>00095   <a class="code" href="classElem.php#a1838d1aa0463f44fb789f478dc6f837c">Elem</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>=0,
<a name="l00096"></a>00096         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>=0,
<a name="l00097"></a>00097         <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>=NULL);
<a name="l00098"></a>00098 
<a name="l00099"></a>00099  <span class="keyword">public</span>:
<a name="l00100"></a>00100 
<a name="l00104"></a>00104   <span class="keyword">virtual</span> <a class="code" href="classElem.php#a2c81decbba9e35bab7664f9c2f4039ba">~Elem</a>();
<a name="l00105"></a>00105 
<a name="l00109"></a>00109   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> &amp; <a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00110"></a>00110 
<a name="l00115"></a>00115   <span class="keyword">virtual</span> <a class="code" href="classPoint.php">Point</a> &amp; <a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00116"></a>00116 
<a name="l00120"></a>00120   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00121"></a>00121 
<a name="l00125"></a>00125   <span class="keyword">virtual</span> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00126"></a>00126 
<a name="l00130"></a>00130   <span class="keyword">virtual</span> <a class="code" href="classNode.php">Node</a>* &amp; <a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00131"></a>00131   
<a name="l00136"></a>00136   <a class="code" href="classTestClass.php">subdomain_id_type</a> <a class="code" href="classElem.php#acc4746605aad9169ad38cfd0b9b97123">subdomain_id</a> () <span class="keyword">const</span>;
<a name="l00137"></a>00137   
<a name="l00142"></a>00142   <a class="code" href="classTestClass.php">subdomain_id_type</a> &amp; <a class="code" href="classElem.php#acc4746605aad9169ad38cfd0b9b97123">subdomain_id</a> ();
<a name="l00143"></a>00143 
<a name="l00149"></a>00149   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#af52fd4fdab067f6ba696257af8d3992a">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span> = 0;
<a name="l00150"></a>00150   
<a name="l00157"></a>00157   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classElem.php#acab7543901989ae1f909101f89f3d4d4">operator == </a>(<span class="keyword">const</span> <a class="code" href="classDofObject.php">DofObject</a>&amp; rhs) <span class="keyword">const</span>;
<a name="l00158"></a>00158 
<a name="l00166"></a>00166   <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00167"></a>00167 
<a name="l00171"></a>00171   <span class="keywordtype">void</span> <a class="code" href="classElem.php#a88d676b002db35d70e0915d10c606f7f">set_neighbor</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <a class="code" href="classElem.php">Elem</a>* n);
<a name="l00172"></a>00172 
<a name="l00177"></a>00177   <span class="keywordtype">bool</span> <a class="code" href="classElem.php#a7213196f7c76938ee380d331c4abd1ea">has_neighbor</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem) <span class="keyword">const</span>;
<a name="l00178"></a>00178   
<a name="l00184"></a>00184   <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classElem.php#acd0a6126ed9ab0eee4a968bd7345888b">child_neighbor</a> (<a class="code" href="classElem.php">Elem</a>* elem) <span class="keyword">const</span>;
<a name="l00185"></a>00185   
<a name="l00191"></a>00191   <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classElem.php#acd0a6126ed9ab0eee4a968bd7345888b">child_neighbor</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem) <span class="keyword">const</span>;
<a name="l00192"></a>00192   
<a name="l00198"></a>00198   <span class="keywordtype">bool</span> <a class="code" href="classElem.php#ad8c7675fc46286f2824582d9c4cb8177">on_boundary</a> () <span class="keyword">const</span>;
<a name="l00199"></a>00199   
<a name="l00205"></a>00205   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#acab8fea073846b18b149ed2b88d43aff">which_neighbor_am_i</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *e) <span class="keyword">const</span>; 
<a name="l00206"></a>00206 
<a name="l00211"></a>00211   <span class="keywordtype">bool</span> <a class="code" href="classElem.php#a9fedc0a0b8f1671e9fc67d2d297131b0">contains_vertex_of</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *e) <span class="keyword">const</span>;
<a name="l00212"></a>00212 
<a name="l00217"></a>00217   <span class="keywordtype">void</span> <a class="code" href="classElem.php#ab7749393ce65ac42d075e53c86e698bd">find_point_neighbors</a>(std::set&lt;const Elem *&gt; &amp;neighbor_set) <span class="keyword">const</span>;
<a name="l00218"></a>00218 
<a name="l00226"></a>00226   <span class="keywordtype">void</span> <a class="code" href="classElem.php#aa4989bf7c952831c59b6204075f7b8ab">make_links_to_me_remote</a> ();
<a name="l00227"></a>00227 
<a name="l00238"></a><a class="code" href="classElem.php#a42551a956e815faffedd7a634c731bff">00238</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classElem.php#a42551a956e815faffedd7a634c731bff">is_remote</a> ()<span class="keyword"> const</span>
<a name="l00239"></a>00239 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00240"></a>00240 
<a name="l00247"></a>00247   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classElem.php#a7bef5c7f5ff5cc734c3d27c42da78ed9">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00248"></a>00248                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00249"></a>00249                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span> = 0;
<a name="l00250"></a>00250 
<a name="l00258"></a>00258   <span class="keywordtype">void</span> <a class="code" href="classElem.php#a4f4c796a0808855560c6119e22796146">write_connectivity</a> (std::ostream&amp; out,
<a name="l00259"></a>00259                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop) <span class="keyword">const</span>;
<a name="l00260"></a>00260 
<a name="l00261"></a>00261 <span class="comment">//   /**</span>
<a name="l00262"></a>00262 <span class="comment">//    * @returns the VTK element type of the sc-th sub-element.</span>
<a name="l00263"></a>00263 <span class="comment">//    */</span>
<a name="l00264"></a>00264 <span class="comment">//   virtual unsigned int vtk_element_type (const unsigned int sc) const = 0;</span>
<a name="l00265"></a>00265 
<a name="l00270"></a>00270   <span class="keyword">virtual</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a> () <span class="keyword">const</span> = 0;
<a name="l00271"></a>00271 
<a name="l00276"></a><a class="code" href="classElem.php#aef05e33c03cee6724a1e26b8fb9d19fd">00276</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#aef05e33c03cee6724a1e26b8fb9d19fd">type_to_n_nodes_map</a>[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>];
<a name="l00277"></a>00277   
<a name="l00281"></a>00281   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a72c710c9b4ebbbdebb707e74165d9625">dim</a> () <span class="keyword">const</span> = 0;
<a name="l00282"></a>00282   
<a name="l00286"></a>00286   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a> () <span class="keyword">const</span> = 0;
<a name="l00287"></a>00287 
<a name="l00293"></a>00293   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a> () <span class="keyword">const</span> = 0;
<a name="l00294"></a>00294 
<a name="l00301"></a><a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">00301</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a> ()<span class="keyword"> const</span>
<a name="l00302"></a>00302 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>(); }
<a name="l00303"></a>00303 
<a name="l00308"></a>00308   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a6bbe1895127c069722e36ee4e2a8a6e1">n_vertices</a> () <span class="keyword">const</span> = 0;
<a name="l00309"></a>00309 
<a name="l00314"></a>00314   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a99de950a1c73b7bcdd63fc2535bb8adf">n_edges</a> () <span class="keyword">const</span> = 0;
<a name="l00315"></a>00315 
<a name="l00320"></a>00320   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#aae14343e02232e5d6e9050bb816acc9e">n_faces</a> () <span class="keyword">const</span> = 0;
<a name="l00321"></a>00321   
<a name="l00326"></a>00326   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a> () <span class="keyword">const</span> = 0;
<a name="l00327"></a>00327 
<a name="l00331"></a>00331   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classElem.php#afb4be0284f273d7d53cd0e994e6f1d7e">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> = 0;
<a name="l00332"></a>00332 
<a name="l00336"></a>00336   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classElem.php#a94208b7040d39112dcfa6882d2598ef1">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> = 0;
<a name="l00337"></a>00337 
<a name="l00341"></a>00341   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classElem.php#a4a699e46ae04c0c8eb0d9474436f350a">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> = 0;
<a name="l00342"></a>00342   
<a name="l00343"></a>00343   <span class="comment">/*</span>
<a name="l00344"></a>00344 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00345"></a>00345 <span class="comment">   * specified side</span>
<a name="l00346"></a>00346 <span class="comment">   */</span>
<a name="l00347"></a>00347   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classElem.php#a85c5162cacd439d80d2262dec568c87a">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00348"></a>00348                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span> = 0;
<a name="l00349"></a>00349   
<a name="l00350"></a>00350   <span class="comment">/*</span>
<a name="l00351"></a>00351 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00352"></a>00352 <span class="comment">   * specified edge</span>
<a name="l00353"></a>00353 <span class="comment">   */</span>
<a name="l00354"></a>00354   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classElem.php#a7942494caae96df757abd6e9ac5bd5b8">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00355"></a>00355                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e) <span class="keyword">const</span> = 0;
<a name="l00356"></a>00356 
<a name="l00357"></a>00357 <span class="comment">//   /**</span>
<a name="l00358"></a>00358 <span class="comment">//    * @returns the number of children this element has that</span>
<a name="l00359"></a>00359 <span class="comment">//    * share side \p s</span>
<a name="l00360"></a>00360 <span class="comment">//    */</span>
<a name="l00361"></a>00361 <span class="comment">//   virtual unsigned int n_children_per_side (const unsigned int) const = 0;</span>
<a name="l00362"></a>00362   
<a name="l00368"></a>00368   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a493c7cbea2731fbc218a65ceed27efbd">n_sub_elem</a> () <span class="keyword">const</span> = 0;
<a name="l00369"></a>00369 
<a name="l00378"></a>00378   <span class="keyword">virtual</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> <a class="code" href="classElem.php#a1688266bb86a98ef253c70807fb94fc5">side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> = 0;
<a name="l00379"></a>00379   
<a name="l00396"></a>00396   <span class="keyword">virtual</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classElem.php#a554c146bcfb5537636bd77a157f21b85">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00397"></a>00397                                     <span class="keywordtype">bool</span> proxy=<span class="keyword">true</span>) <span class="keyword">const</span> = 0;
<a name="l00398"></a>00398 
<a name="l00407"></a>00407   <span class="keyword">virtual</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classElem.php#a53d7b548eddc81a770c6459264a07115">build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> = 0;
<a name="l00408"></a>00408 
<a name="l00414"></a>00414   <span class="keyword">virtual</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classElem.php#a6cef8ca882c2fc1081fd27132851627a">default_order</a> () <span class="keyword">const</span> = 0;
<a name="l00415"></a>00415   
<a name="l00422"></a>00422   <span class="keyword">virtual</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classElem.php#a46ce080150f08ce9d367b69f16dd0452">centroid</a> () <span class="keyword">const</span>;
<a name="l00423"></a>00423   
<a name="l00427"></a>00427   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classElem.php#a8483eb75ec4ccc49b41596557a3a367b">hmin</a> () <span class="keyword">const</span>;
<a name="l00428"></a>00428   
<a name="l00432"></a>00432   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classElem.php#aed45dccf181d13107eab2c2947d1afe6">hmax</a> () <span class="keyword">const</span>;
<a name="l00433"></a>00433 
<a name="l00437"></a>00437   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classElem.php#a685f1f6f6fa337eda690b115e66858f4">volume</a> () <span class="keyword">const</span>;
<a name="l00438"></a>00438   
<a name="l00443"></a>00443   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classElem.php#a52f2b13c389f06b9a8e9d969ddf7ffe7">quality</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) <span class="keyword">const</span>;  
<a name="l00444"></a>00444 
<a name="l00452"></a><a class="code" href="classElem.php#a7be330c8b1d8a9dc5711d73cab09cbcd">00452</a>   <span class="keyword">virtual</span> std::pair&lt;Real,Real&gt; <a class="code" href="classElem.php#a7be330c8b1d8a9dc5711d73cab09cbcd">qual_bounds</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a>)<span class="keyword"> const</span>
<a name="l00453"></a>00453 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> std::make_pair(0.,0.); }
<a name="l00454"></a>00454   
<a name="l00459"></a>00459   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classElem.php#ace5226376cf53804d20073a0d21b0cbc">contains_point</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00460"></a>00460 
<a name="l00465"></a><a class="code" href="classElem.php#aff14264607cb433fd12a19ea0ffd1d89">00465</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classElem.php#aff14264607cb433fd12a19ea0ffd1d89">has_affine_map</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00466"></a>00466 
<a name="l00472"></a>00472   <span class="keywordtype">bool</span> <a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a> () <span class="keyword">const</span>;
<a name="l00473"></a>00473   
<a name="l00479"></a>00479   <span class="keywordtype">bool</span> <a class="code" href="classElem.php#a3ad156b66b45310da85b653c791bd790">ancestor</a> () <span class="keyword">const</span>;
<a name="l00480"></a>00480   
<a name="l00486"></a>00486   <span class="keywordtype">bool</span> <a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a> () <span class="keyword">const</span>;
<a name="l00487"></a>00487   
<a name="l00492"></a>00492   <span class="keywordtype">bool</span> <a class="code" href="classElem.php#a2ff2cfd3b4b05b8f091ba91eb068f81c">has_children</a> () <span class="keyword">const</span>;
<a name="l00493"></a>00493 
<a name="l00499"></a>00499   <span class="keywordtype">bool</span> <a class="code" href="classElem.php#a7369dff866f654afd6606c393e22cf55">has_ancestor_children</a> () <span class="keyword">const</span>;
<a name="l00500"></a>00500 
<a name="l00506"></a>00506   <span class="keywordtype">bool</span> <a class="code" href="classElem.php#aa7fc177516bf85923273fef18cad56bd">is_ancestor_of</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *descendant) <span class="keyword">const</span>;
<a name="l00507"></a>00507 
<a name="l00512"></a>00512   <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a> () <span class="keyword">const</span>;
<a name="l00513"></a>00513 
<a name="l00518"></a>00518   <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a> ();
<a name="l00519"></a>00519 
<a name="l00524"></a>00524   <span class="keywordtype">void</span> <a class="code" href="classElem.php#a64542f4d4b1e359b605cdf29ce0db943">set_parent</a> (<a class="code" href="classElem.php">Elem</a> *p);
<a name="l00525"></a>00525 
<a name="l00532"></a>00532   <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classElem.php#a6bc01ad4901efb64eb4f584ed5e1bd0b">top_parent</a> () <span class="keyword">const</span>;
<a name="l00533"></a>00533   
<a name="l00542"></a>00542   <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classElem.php#a82c29e6b178e335f607a65f61a524e13">interior_parent</a> () <span class="keyword">const</span>;
<a name="l00543"></a>00543 
<a name="l00548"></a>00548   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">length</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1, 
<a name="l00549"></a>00549                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n2) <span class="keyword">const</span>;
<a name="l00550"></a>00550 
<a name="l00559"></a>00559   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a9f073eee0a8cd4d87e72f0834b4b1815">n_second_order_adjacent_vertices</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span>;
<a name="l00560"></a>00560 
<a name="l00568"></a>00568   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a51e4bd9931fa1378113784f76ac13d6a">second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00569"></a>00569                                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v) <span class="keyword">const</span>;
<a name="l00570"></a>00570 
<a name="l00580"></a>00580   <span class="keyword">virtual</span> std::pair&lt;unsigned short int, unsigned short int&gt; 
<a name="l00581"></a>00581           <a class="code" href="classElem.php#a82dfd0c1670e2718e6f5bd9485f45547">second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span>;
<a name="l00582"></a>00582 
<a name="l00594"></a>00594   <span class="keyword">static</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classElem.php#a8d206442321a9b73bdbf58e72eb9e82b">second_order_equivalent_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> et,
<a name="l00595"></a>00595                                                 <span class="keyword">const</span> <span class="keywordtype">bool</span> full_ordered=<span class="keyword">true</span>);
<a name="l00596"></a>00596 
<a name="l00603"></a>00603   <span class="keyword">static</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classElem.php#a58feb7c95394c30be3ef4d991d8bfc7e">first_order_equivalent_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> et);
<a name="l00604"></a>00604                                                
<a name="l00605"></a>00605 
<a name="l00612"></a>00612   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a> () <span class="keyword">const</span>;
<a name="l00613"></a>00613   
<a name="l00619"></a>00619   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a> () <span class="keyword">const</span>;
<a name="l00620"></a>00620 
<a name="l00621"></a>00621 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00622"></a>00622 <span class="preprocessor"></span>
<a name="l00627"></a><a class="code" href="classElem.php#a946039859488cca879512de516fef829">00627</a>   <span class="keyword">enum</span> <a class="code" href="classElem.php#a946039859488cca879512de516fef829">RefinementState</a> { <a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">COARSEN</a> = 0,
<a name="l00628"></a><a class="code" href="classElem.php#a946039859488cca879512de516fef829a3bc34bb09879a3388ad735a75317b3c3">00628</a>                          <a class="code" href="classElem.php#a946039859488cca879512de516fef829a3bc34bb09879a3388ad735a75317b3c3">DO_NOTHING</a>,
<a name="l00629"></a><a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">00629</a>                          <a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">REFINE</a>,
<a name="l00630"></a><a class="code" href="classElem.php#a946039859488cca879512de516fef829a28fd8e260b7464210efa6f4f24d54310">00630</a>                          <a class="code" href="classElem.php#a946039859488cca879512de516fef829a28fd8e260b7464210efa6f4f24d54310">JUST_REFINED</a>,
<a name="l00631"></a><a class="code" href="classElem.php#a946039859488cca879512de516fef829ad2c57c7a107071f8229a64a5af22202f">00631</a>                          <a class="code" href="classElem.php#a946039859488cca879512de516fef829ad2c57c7a107071f8229a64a5af22202f">JUST_COARSENED</a>,
<a name="l00632"></a><a class="code" href="classElem.php#a946039859488cca879512de516fef829aa5b67adf7b456724c4a0a07034a0adbf">00632</a>                          <a class="code" href="classElem.php#a946039859488cca879512de516fef829aa5b67adf7b456724c4a0a07034a0adbf">INACTIVE</a>,
<a name="l00633"></a><a class="code" href="classElem.php#a946039859488cca879512de516fef829a1d4c57ce97a2dff1f6dd0e2b8855f80e">00633</a>                          <a class="code" href="classElem.php#a946039859488cca879512de516fef829a1d4c57ce97a2dff1f6dd0e2b8855f80e">COARSEN_INACTIVE</a> };
<a name="l00634"></a>00634   
<a name="l00639"></a>00639   <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00640"></a>00640 
<a name="l00646"></a>00646   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a72cd45e535e8bebac68a57a362a60fef">which_child_am_i</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *e) <span class="keyword">const</span>; 
<a name="l00647"></a>00647 
<a name="l00652"></a>00652   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classElem.php#ad62bfc036a0b1303dad54d20e9fd86b6">is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00653"></a>00653                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span> = 0;
<a name="l00654"></a>00654   
<a name="l00659"></a>00659   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classElem.php#a17cad0bd2ceef85bb9696c01d2b16802">is_child_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00660"></a>00660                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e) <span class="keyword">const</span>;
<a name="l00661"></a>00661 
<a name="l00668"></a>00668   <span class="keywordtype">void</span> <a class="code" href="classElem.php#a791ed16f88c661c7ed22e10e0cf8d8ff">add_child</a> (<a class="code" href="classElem.php">Elem</a>* elem);
<a name="l00669"></a>00669 
<a name="l00676"></a>00676   <span class="keywordtype">void</span> <a class="code" href="classElem.php#a791ed16f88c661c7ed22e10e0cf8d8ff">add_child</a> (<a class="code" href="classElem.php">Elem</a>* elem, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c);
<a name="l00677"></a>00677 
<a name="l00686"></a>00686   <span class="keywordtype">void</span> <a class="code" href="classElem.php#abafd34cacabfdf831cc86e781c211fa1">family_tree</a> (std::vector&lt;const Elem*&gt;&amp; family,
<a name="l00687"></a>00687                     <span class="keyword">const</span> <span class="keywordtype">bool</span> reset=<span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00688"></a>00688 
<a name="l00695"></a>00695   <span class="keywordtype">void</span> <a class="code" href="classElem.php#a51ae47d8c3c024b8dc1098b9392a1161">active_family_tree</a> (std::vector&lt;const Elem*&gt;&amp; active_family,
<a name="l00696"></a>00696                            <span class="keyword">const</span> <span class="keywordtype">bool</span> reset=<span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00697"></a>00697 
<a name="l00702"></a>00702   <span class="keywordtype">void</span> <a class="code" href="classElem.php#af8c9a0eda098174dfe1ee49901c229dd">family_tree_by_side</a> (std::vector&lt;const Elem*&gt;&amp; family,
<a name="l00703"></a>00703                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a1688266bb86a98ef253c70807fb94fc5">side</a>,
<a name="l00704"></a>00704                             <span class="keyword">const</span> <span class="keywordtype">bool</span> reset=<span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00705"></a>00705 
<a name="l00710"></a>00710   <span class="keywordtype">void</span> <a class="code" href="classElem.php#a5c362d52b5c393691357633fb337ced0">active_family_tree_by_side</a> (std::vector&lt;const Elem*&gt;&amp; family,
<a name="l00711"></a>00711                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a1688266bb86a98ef253c70807fb94fc5">side</a>,
<a name="l00712"></a>00712                                    <span class="keyword">const</span> <span class="keywordtype">bool</span> reset=<span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00713"></a>00713   
<a name="l00718"></a>00718   <span class="keywordtype">void</span> <a class="code" href="classElem.php#a69eebe1336fd5446432172a7f30fcc97">family_tree_by_neighbor</a> (std::vector&lt;const Elem*&gt;&amp; family,
<a name="l00719"></a>00719                                 <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *neighbor,
<a name="l00720"></a>00720                                 <span class="keyword">const</span> <span class="keywordtype">bool</span> reset=<span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00721"></a>00721 
<a name="l00728"></a>00728   <span class="keywordtype">void</span> <a class="code" href="classElem.php#ab4446eecc9b887765a7d47ddb009a875">family_tree_by_subneighbor</a> (std::vector&lt;const Elem*&gt;&amp; family,
<a name="l00729"></a>00729                                    <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *neighbor,
<a name="l00730"></a>00730                                    <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *subneighbor,
<a name="l00731"></a>00731                                    <span class="keyword">const</span> <span class="keywordtype">bool</span> reset=<span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00732"></a>00732 
<a name="l00737"></a>00737   <span class="keywordtype">void</span> <a class="code" href="classElem.php#a26ca00dd9c91f9f086d755eb3f58d4ff">active_family_tree_by_neighbor</a> (std::vector&lt;const Elem*&gt;&amp; family,
<a name="l00738"></a>00738                                        <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *neighbor,
<a name="l00739"></a>00739                                        <span class="keyword">const</span> <span class="keywordtype">bool</span> reset=<span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00740"></a>00740 
<a name="l00744"></a>00744   <a class="code" href="classElem.php#a946039859488cca879512de516fef829">RefinementState</a> <a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a> () <span class="keyword">const</span>;
<a name="l00745"></a>00745 
<a name="l00749"></a>00749   <span class="keywordtype">void</span> <a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a> (<span class="keyword">const</span> <a class="code" href="classElem.php#a946039859488cca879512de516fef829">RefinementState</a> rflag);
<a name="l00750"></a>00750 
<a name="l00754"></a>00754   <a class="code" href="classElem.php#a946039859488cca879512de516fef829">RefinementState</a> <a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a> () <span class="keyword">const</span>;
<a name="l00755"></a>00755 
<a name="l00759"></a>00759   <span class="keywordtype">void</span> <a class="code" href="classElem.php#a40b62e384088baa756c3481b6631d7c4">set_p_refinement_flag</a> (<span class="keyword">const</span> <a class="code" href="classElem.php#a946039859488cca879512de516fef829">RefinementState</a> pflag);
<a name="l00760"></a>00760 
<a name="l00765"></a>00765   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#aa6287a74c5d39a6a53bb23fa67ad6e10">max_descendant_p_level</a> () <span class="keyword">const</span>;
<a name="l00766"></a>00766 
<a name="l00772"></a>00772   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#af0de16afb3e685147942b802d0f57a14">min_p_level_by_neighbor</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* neighbor,
<a name="l00773"></a>00773                                         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_min) <span class="keyword">const</span>;
<a name="l00774"></a>00774 
<a name="l00781"></a>00781   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a85d83dead47981e29ec191e0701e6147">min_new_p_level_by_neighbor</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* neighbor,
<a name="l00782"></a>00782                                             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_min) <span class="keyword">const</span>;
<a name="l00783"></a>00783 
<a name="l00788"></a>00788   <span class="keywordtype">void</span> <a class="code" href="classElem.php#ae5dda58cdd729c5ee19c0a44bc1dd7bf">set_p_level</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p);
<a name="l00789"></a>00789 
<a name="l00794"></a>00794   <span class="keywordtype">void</span> <a class="code" href="classElem.php#aa9e1248d65ada8cd61e5af270d01cf53">hack_p_level</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p);
<a name="l00795"></a>00795 
<a name="l00799"></a>00799   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classElem.php#a3df9b2e814ba0232402084d688ce34a2">refine</a> (<a class="code" href="classMeshRefinement.php">MeshRefinement</a>&amp; mesh_refinement);
<a name="l00800"></a>00800  
<a name="l00806"></a>00806   <span class="keywordtype">void</span> <a class="code" href="classElem.php#a404022768f8be8b29a31c2f021d4304d">coarsen</a> ();
<a name="l00807"></a>00807 
<a name="l00814"></a>00814   <span class="keywordtype">void</span> <a class="code" href="classElem.php#a0d3684188ff7e647bb565e3de3439e7d">contract</a> ();
<a name="l00815"></a>00815 
<a name="l00816"></a>00816 <span class="preprocessor">#endif</span>
<a name="l00817"></a>00817 <span class="preprocessor"></span>
<a name="l00818"></a>00818 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00819"></a>00819 <span class="preprocessor"></span>
<a name="l00823"></a>00823   <span class="keywordtype">void</span> <a class="code" href="classElem.php#a8130d32feced4528a2a08cfb3d8270af">libmesh_assert_valid_neighbors</a>() <span class="keyword">const</span>;
<a name="l00824"></a>00824 
<a name="l00829"></a>00829   <span class="keywordtype">void</span> <a class="code" href="classElem.php#a527c92ecb5322b14ef5649c3970cab87">libmesh_assert_valid_node_pointers</a>() <span class="keyword">const</span>;
<a name="l00830"></a>00830 <span class="preprocessor">#endif // DEBUG</span>
<a name="l00831"></a>00831 <span class="preprocessor"></span>
<a name="l00832"></a>00832 <span class="keyword">protected</span>:
<a name="l00833"></a>00833 
<a name="l00844"></a><a class="code" href="classElem.php#a2b62f8279d6e76786766d896e2b2cf8f">00844</a>   <span class="keyword">class </span>SideIter;
<a name="l00845"></a>00845   
<a name="l00846"></a>00846 <span class="keyword">public</span>:
<a name="l00850"></a>00850   <span class="keyword">typedef</span> <a class="code" href="structPredicates_1_1multi__predicate.php">Predicates::multi_predicate</a> <a class="code" href="classElem.php#a2b62f8279d6e76786766d896e2b2cf8f">Predicate</a>;
<a name="l00851"></a>00851   <span class="comment">//typedef variant_filter_iterator&lt;Elem*, Predicate&gt; side_iterator;</span>
<a name="l00852"></a>00852 
<a name="l00857"></a>00857   <span class="keyword">struct </span>side_iterator;
<a name="l00858"></a>00858   
<a name="l00862"></a>00862   side_iterator <a class="code" href="classElem.php#abaf5f7c64e723cb6e83ee2b710c6e76a">boundary_sides_begin</a>();
<a name="l00863"></a>00863   side_iterator <a class="code" href="classElem.php#a7448c298c2f8c4fce6348039e923fc91">boundary_sides_end</a>();
<a name="l00864"></a>00864 
<a name="l00865"></a>00865 <span class="keyword">private</span>:
<a name="l00870"></a>00870   SideIter <a class="code" href="classElem.php#ad956038473223519d323d3cb50d92622">_first_side</a>(); 
<a name="l00871"></a>00871   SideIter <a class="code" href="classElem.php#a4616bd8795259ad31ffe346a2abbb8df">_last_side</a>();  
<a name="l00872"></a>00872   
<a name="l00873"></a>00873 <span class="keyword">public</span>:
<a name="l00874"></a>00874   
<a name="l00875"></a>00875 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00876"></a>00876 <span class="preprocessor"></span>
<a name="l00881"></a>00881   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classElem.php#ab552f89411c1786564c63daec764d47a">infinite</a> () <span class="keyword">const</span> = 0;
<a name="l00882"></a>00882 
<a name="l00891"></a><a class="code" href="classElem.php#adcaedd09dd644bec38f2460c1e770f16">00891</a>   <span class="keyword">virtual</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classElem.php#adcaedd09dd644bec38f2460c1e770f16">origin</a> ()<span class="keyword"> const </span>{ libmesh_error(); <span class="keywordflow">return</span> <a class="code" href="classPoint.php">Point</a>(); }
<a name="l00892"></a>00892 
<a name="l00893"></a>00893 <span class="preprocessor">#endif</span>
<a name="l00894"></a>00894 <span class="preprocessor"></span>
<a name="l00895"></a>00895 
<a name="l00896"></a>00896 
<a name="l00897"></a>00897   
<a name="l00903"></a>00903   <span class="keyword">static</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classElem.php#a7f46524fbd44a76f940435d6a1434a9d">build</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>,
<a name="l00904"></a>00904                               <a class="code" href="classElem.php">Elem</a>* p=NULL);
<a name="l00905"></a>00905 
<a name="l00906"></a>00906 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00907"></a>00907 <span class="preprocessor"></span>  
<a name="l00912"></a>00912   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="classElem.php#a018d328d79c727dbe66196980fcaf50a">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00913"></a>00913                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00914"></a>00914                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k) <span class="keyword">const</span> = 0;
<a name="l00915"></a>00915 
<a name="l00916"></a>00916 <span class="preprocessor">#endif</span>
<a name="l00917"></a>00917 <span class="preprocessor"></span>  
<a name="l00918"></a>00918 
<a name="l00919"></a>00919   <span class="comment">//--------------------------------------------------------</span>
<a name="l00928"></a>00928 <span class="comment"></span>  <span class="keyword">class </span>PackedElem;
<a name="l00929"></a>00929 
<a name="l00930"></a>00930 
<a name="l00931"></a>00931  <span class="keyword">protected</span>:
<a name="l00932"></a>00932 
<a name="l00933"></a>00933   <span class="comment">//-------------------------------------------------------</span>
<a name="l00934"></a>00934   <span class="comment">// These methods compute has keys from the specified</span>
<a name="l00935"></a>00935   <span class="comment">// global node numbers</span>
<a name="l00936"></a>00936   <span class="comment">//</span>
<a name="l00940"></a>00940 <span class="comment"></span>  <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a859c8236824914afa005cacf1ee86959">compute_key</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n0);
<a name="l00941"></a>00941 
<a name="l00945"></a>00945   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a859c8236824914afa005cacf1ee86959">compute_key</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n0,
<a name="l00946"></a>00946                                    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1);
<a name="l00947"></a>00947 
<a name="l00951"></a>00951   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a859c8236824914afa005cacf1ee86959">compute_key</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n0,
<a name="l00952"></a>00952                                    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1,
<a name="l00953"></a>00953                                    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n2);
<a name="l00954"></a>00954 
<a name="l00958"></a>00958   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a859c8236824914afa005cacf1ee86959">compute_key</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n0,
<a name="l00959"></a>00959                                    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1,
<a name="l00960"></a>00960                                    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n2,
<a name="l00961"></a>00961                                    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n3);
<a name="l00962"></a>00962   <span class="comment">//-------------------------------------------------------</span>
<a name="l00963"></a>00963 
<a name="l00964"></a>00964 
<a name="l00965"></a>00965   
<a name="l00971"></a>00971   <span class="keywordtype">void</span> <a class="code" href="classElem.php#a0c6afe5c0a0f5b304bb3846098c30a85">nullify_neighbors</a> ();
<a name="l00972"></a>00972   
<a name="l00976"></a><a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">00976</a>   <a class="code" href="classNode.php">Node</a>** <a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a>;
<a name="l00977"></a>00977 
<a name="l00981"></a><a class="code" href="classElem.php#a2e02da07d0cbbf585262713c59f48773">00981</a>   <a class="code" href="classElem.php">Elem</a>** <a class="code" href="classElem.php#a2e02da07d0cbbf585262713c59f48773">_neighbors</a>;
<a name="l00982"></a>00982  
<a name="l00986"></a><a class="code" href="classElem.php#a7f0bf473aeb272308a559de595ba7e04">00986</a>   <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classElem.php#a7f0bf473aeb272308a559de595ba7e04">_parent</a>;
<a name="l00987"></a>00987 
<a name="l00988"></a>00988 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00989"></a>00989 <span class="preprocessor"></span>  
<a name="l00993"></a><a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">00993</a>   <a class="code" href="classElem.php">Elem</a>** <a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>;
<a name="l00994"></a>00994 
<a name="l00999"></a><a class="code" href="classElem.php#a876cfb60b44d8571a7a7daf4854f91d4">00999</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="classElem.php#a876cfb60b44d8571a7a7daf4854f91d4">_rflag</a>;
<a name="l01000"></a>01000   <span class="comment">//RefinementState _rflag;</span>
<a name="l01001"></a>01001   
<a name="l01006"></a><a class="code" href="classElem.php#aa9f306d36014fbfdc27a284c9ce4b750">01006</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="classElem.php#aa9f306d36014fbfdc27a284c9ce4b750">_pflag</a>;
<a name="l01007"></a>01007   <span class="comment">//RefinementState _pflag;</span>
<a name="l01008"></a>01008   
<a name="l01017"></a><a class="code" href="classElem.php#a71cf2733e27d827a2947f0e92276c02e">01017</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="classElem.php#a71cf2733e27d827a2947f0e92276c02e">_p_level</a>;
<a name="l01018"></a>01018 
<a name="l01019"></a>01019 <span class="preprocessor">#endif</span>
<a name="l01020"></a>01020 <span class="preprocessor"></span>
<a name="l01024"></a><a class="code" href="classElem.php#a418d7d3e0a2bcb7a1c9dfa5889536b82">01024</a>   <a class="code" href="classTestClass.php">subdomain_id_type</a> <a class="code" href="classElem.php#a418d7d3e0a2bcb7a1c9dfa5889536b82">_sbd_id</a>;
<a name="l01025"></a>01025 
<a name="l01037"></a><a class="code" href="classElem.php#a7eb42a58c387442456965deba0fd97fd">01037</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classMeshRefinement.php">MeshRefinement</a>;    <span class="comment">// (Elem::nullify_neighbors)</span>
<a name="l01038"></a>01038 
<a name="l01039"></a>01039  <span class="keyword">private</span>:
<a name="l01044"></a>01044   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#ab65844b6b7edc68786155a52ceb0865a">_cast_node_address_to_unsigned_int</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l01045"></a>01045 
<a name="l01046"></a>01046   <span class="comment">// Prime numbers used for computing node keys.  These are the same</span>
<a name="l01047"></a>01047   <span class="comment">// for every instance of the Elem class.</span>
<a name="l01048"></a><a class="code" href="classElem.php#a50fdd3a0d5528931f0168689b1e6a2cd">01048</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a50fdd3a0d5528931f0168689b1e6a2cd">_bp1</a>;
<a name="l01049"></a><a class="code" href="classElem.php#a39777f85fbd4c499d89378fb84f01ed8">01049</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a39777f85fbd4c499d89378fb84f01ed8">_bp2</a>;
<a name="l01050"></a>01050 };
<a name="l01051"></a>01051 
<a name="l01052"></a>01052 
<a name="l01053"></a>01053 
<a name="l01054"></a>01054 
<a name="l01055"></a>01055 <span class="comment">// ------------------------------------------------------------</span>
<a name="l01056"></a>01056 <span class="comment">// Elem class member functions</span>
<a name="l01057"></a>01057 <span class="keyword">inline</span>
<a name="l01058"></a><a class="code" href="classElem.php#a1838d1aa0463f44fb789f478dc6f837c">01058</a> <a class="code" href="classElem.php#a1838d1aa0463f44fb789f478dc6f837c">Elem::Elem</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l01059"></a>01059            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l01060"></a>01060            <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l01061"></a>01061   _parent(p)
<a name="l01062"></a>01062 #ifdef LIBMESH_ENABLE_AMR
<a name="l01063"></a>01063   , _p_level(0)
<a name="l01064"></a>01064 #endif
<a name="l01065"></a>01065 {
<a name="l01066"></a>01066   this-&gt;<a class="code" href="classElem.php#acc4746605aad9169ad38cfd0b9b97123">subdomain_id</a>() = 0;
<a name="l01067"></a>01067   this-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() = <a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>;
<a name="l01068"></a>01068   
<a name="l01069"></a>01069   <span class="comment">// Initialize the nodes data structure</span>
<a name="l01070"></a>01070   <a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a> = NULL;
<a name="l01071"></a>01071   
<a name="l01072"></a>01072   <span class="keywordflow">if</span> (nn != 0)
<a name="l01073"></a>01073     {
<a name="l01074"></a>01074       <a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a> = <span class="keyword">new</span> <a class="code" href="classNode.php">Node</a>*[nn]; 
<a name="l01075"></a>01075       
<a name="l01076"></a>01076       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;nn; n++)
<a name="l01077"></a>01077         <a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a>[n] = NULL;
<a name="l01078"></a>01078     }
<a name="l01079"></a>01079   
<a name="l01080"></a>01080   <span class="comment">// Initialize the neighbors data structure</span>
<a name="l01081"></a>01081   <a class="code" href="classElem.php#a2e02da07d0cbbf585262713c59f48773">_neighbors</a> = NULL;
<a name="l01082"></a>01082   
<a name="l01083"></a>01083   <span class="keywordflow">if</span> (ns != 0)
<a name="l01084"></a>01084     {
<a name="l01085"></a>01085       <a class="code" href="classElem.php#a2e02da07d0cbbf585262713c59f48773">_neighbors</a> = <span class="keyword">new</span> <a class="code" href="classElem.php">Elem</a>*[ns]; 
<a name="l01086"></a>01086       
<a name="l01087"></a>01087       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;ns; n++)
<a name="l01088"></a>01088         <a class="code" href="classElem.php#a2e02da07d0cbbf585262713c59f48773">_neighbors</a>[n] = NULL;
<a name="l01089"></a>01089     }
<a name="l01090"></a>01090 
<a name="l01091"></a>01091   <span class="comment">// Optionally initialize data from the parent</span>
<a name="l01092"></a>01092   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>() != NULL)
<a name="l01093"></a>01093     {
<a name="l01094"></a>01094       this-&gt;<a class="code" href="classElem.php#acc4746605aad9169ad38cfd0b9b97123">subdomain_id</a>() = this-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>()-&gt;<a class="code" href="classElem.php#acc4746605aad9169ad38cfd0b9b97123">subdomain_id</a>();
<a name="l01095"></a>01095       this-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() = this-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>()-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>();
<a name="l01096"></a>01096     }  
<a name="l01097"></a>01097 
<a name="l01098"></a>01098 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01099"></a>01099 <span class="preprocessor"></span>  
<a name="l01100"></a>01100   <a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a> = NULL;
<a name="l01101"></a>01101 
<a name="l01102"></a>01102   this-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a3bc34bb09879a3388ad735a75317b3c3">Elem::DO_NOTHING</a>);
<a name="l01103"></a>01103 
<a name="l01104"></a>01104   this-&gt;<a class="code" href="classElem.php#a40b62e384088baa756c3481b6631d7c4">set_p_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a3bc34bb09879a3388ad735a75317b3c3">Elem::DO_NOTHING</a>);
<a name="l01105"></a>01105 
<a name="l01106"></a>01106   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>())
<a name="l01107"></a>01107     this-&gt;<a class="code" href="classElem.php#ae5dda58cdd729c5ee19c0a44bc1dd7bf">set_p_level</a>(<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>()-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>());
<a name="l01108"></a>01108   <span class="keywordflow">else</span>
<a name="l01109"></a>01109     this-&gt;<a class="code" href="classElem.php#ae5dda58cdd729c5ee19c0a44bc1dd7bf">set_p_level</a>(0);
<a name="l01110"></a>01110 
<a name="l01111"></a>01111 <span class="preprocessor">#endif</span>
<a name="l01112"></a>01112 <span class="preprocessor"></span>}
<a name="l01113"></a>01113 
<a name="l01114"></a>01114 
<a name="l01115"></a>01115 
<a name="l01116"></a>01116 <span class="keyword">inline</span>
<a name="l01117"></a><a class="code" href="classElem.php#a2c81decbba9e35bab7664f9c2f4039ba">01117</a> <a class="code" href="classElem.php#a2c81decbba9e35bab7664f9c2f4039ba">Elem::~Elem</a>() 
<a name="l01118"></a>01118 {
<a name="l01119"></a>01119   <span class="comment">// Delete my node storage</span>
<a name="l01120"></a>01120   <span class="keywordflow">if</span> (<a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a> != NULL)
<a name="l01121"></a>01121     <span class="keyword">delete</span> [] <a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a>;
<a name="l01122"></a>01122   <a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a> = NULL;
<a name="l01123"></a>01123 
<a name="l01124"></a>01124   <span class="comment">// Delete my neighbor storage</span>
<a name="l01125"></a>01125   <span class="keywordflow">if</span> (<a class="code" href="classElem.php#a2e02da07d0cbbf585262713c59f48773">_neighbors</a> != NULL)
<a name="l01126"></a>01126     <span class="keyword">delete</span> [] <a class="code" href="classElem.php#a2e02da07d0cbbf585262713c59f48773">_neighbors</a>;
<a name="l01127"></a>01127   <a class="code" href="classElem.php#a2e02da07d0cbbf585262713c59f48773">_neighbors</a> = NULL;
<a name="l01128"></a>01128 
<a name="l01129"></a>01129 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01130"></a>01130 <span class="preprocessor"></span>
<a name="l01131"></a>01131   <span class="comment">// Delete my children&#39;s storage</span>
<a name="l01132"></a>01132   <span class="keywordflow">if</span> (<a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a> != NULL)
<a name="l01133"></a>01133     <span class="keyword">delete</span> [] <a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>;
<a name="l01134"></a>01134   <a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a> = NULL;
<a name="l01135"></a>01135   
<a name="l01136"></a>01136 <span class="preprocessor">#endif</span>
<a name="l01137"></a>01137 <span class="preprocessor"></span>}
<a name="l01138"></a>01138 
<a name="l01139"></a>01139 
<a name="l01140"></a>01140 
<a name="l01141"></a>01141 <span class="keyword">inline</span>
<a name="l01142"></a><a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">01142</a> <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> &amp; <a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">Elem::point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l01143"></a>01143 <span class="keyword"></span>{
<a name="l01144"></a>01144   libmesh_assert (i &lt; this-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>());
<a name="l01145"></a>01145   libmesh_assert (<a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a>[i] != NULL);
<a name="l01146"></a>01146   libmesh_assert (<a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a>[i]-&gt;<span class="keywordtype">id</span>() != <a class="code" href="classDofObject.php#a35a5c88688334a8a3b8f0ff45105fb36">Node::invalid_id</a>);
<a name="l01147"></a>01147 
<a name="l01148"></a>01148   <span class="keywordflow">return</span> *<a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a>[i];
<a name="l01149"></a>01149 }
<a name="l01150"></a>01150 
<a name="l01151"></a>01151 
<a name="l01152"></a>01152 
<a name="l01153"></a>01153 <span class="keyword">inline</span>
<a name="l01154"></a><a class="code" href="classElem.php#a1b8460c2b39ff306d79aecd9c9a25f19">01154</a> <a class="code" href="classPoint.php">Point</a> &amp; <a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">Elem::point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l01155"></a>01155 {
<a name="l01156"></a>01156   libmesh_assert (i &lt; this-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>());
<a name="l01157"></a>01157 
<a name="l01158"></a>01158   <span class="keywordflow">return</span> *<a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a>[i];
<a name="l01159"></a>01159 }
<a name="l01160"></a>01160 
<a name="l01161"></a>01161 
<a name="l01162"></a>01162 
<a name="l01163"></a>01163 <span class="keyword">inline</span>
<a name="l01164"></a><a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">01164</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">Elem::node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l01165"></a>01165 <span class="keyword"></span>{
<a name="l01166"></a>01166   libmesh_assert (i &lt; this-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>());
<a name="l01167"></a>01167   libmesh_assert (<a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a>[i] != NULL);
<a name="l01168"></a>01168   libmesh_assert (<a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a>[i]-&gt;<span class="keywordtype">id</span>() != <a class="code" href="classDofObject.php#a35a5c88688334a8a3b8f0ff45105fb36">Node::invalid_id</a>);
<a name="l01169"></a>01169 
<a name="l01170"></a>01170   <span class="keywordflow">return</span> <a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a>[i]-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l01171"></a>01171 }
<a name="l01172"></a>01172 
<a name="l01173"></a>01173 
<a name="l01174"></a>01174 
<a name="l01175"></a>01175 <span class="keyword">inline</span>
<a name="l01176"></a><a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">01176</a> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">Elem::get_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l01177"></a>01177 <span class="keyword"></span>{
<a name="l01178"></a>01178   libmesh_assert (i &lt; this-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>());
<a name="l01179"></a>01179   libmesh_assert (<a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a>[i] != NULL);
<a name="l01180"></a>01180 
<a name="l01181"></a>01181   <span class="keywordflow">return</span> <a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a>[i];
<a name="l01182"></a>01182 }
<a name="l01183"></a>01183 
<a name="l01184"></a>01184 
<a name="l01185"></a>01185 
<a name="l01186"></a>01186 <span class="keyword">inline</span>
<a name="l01187"></a><a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">01187</a> <a class="code" href="classNode.php">Node</a>* &amp; <a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">Elem::set_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l01188"></a>01188 {
<a name="l01189"></a>01189   libmesh_assert (i &lt; this-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>());
<a name="l01190"></a>01190 
<a name="l01191"></a>01191   <span class="keywordflow">return</span> <a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a>[i];
<a name="l01192"></a>01192 }
<a name="l01193"></a>01193 
<a name="l01194"></a>01194 
<a name="l01195"></a>01195 
<a name="l01196"></a>01196 <span class="keyword">inline</span>
<a name="l01197"></a><a class="code" href="classElem.php#acc4746605aad9169ad38cfd0b9b97123">01197</a> <a class="code" href="classTestClass.php">subdomain_id_type</a> <a class="code" href="classElem.php#acc4746605aad9169ad38cfd0b9b97123">Elem::subdomain_id</a> ()<span class="keyword"> const</span>
<a name="l01198"></a>01198 <span class="keyword"></span>{
<a name="l01199"></a>01199   <span class="keywordflow">return</span> <a class="code" href="classElem.php#a418d7d3e0a2bcb7a1c9dfa5889536b82">_sbd_id</a>;
<a name="l01200"></a>01200 }
<a name="l01201"></a>01201 
<a name="l01202"></a>01202 
<a name="l01203"></a>01203 
<a name="l01204"></a>01204 <span class="keyword">inline</span>
<a name="l01205"></a><a class="code" href="classElem.php#a61d39dbd698e40b7f5a81fea7e50eb76">01205</a> <a class="code" href="classTestClass.php">subdomain_id_type</a> &amp; <a class="code" href="classElem.php#acc4746605aad9169ad38cfd0b9b97123">Elem::subdomain_id</a> ()
<a name="l01206"></a>01206 {
<a name="l01207"></a>01207   <span class="keywordflow">return</span> <a class="code" href="classElem.php#a418d7d3e0a2bcb7a1c9dfa5889536b82">_sbd_id</a>;
<a name="l01208"></a>01208 }
<a name="l01209"></a>01209 
<a name="l01210"></a>01210 
<a name="l01211"></a>01211 
<a name="l01212"></a>01212 <span class="keyword">inline</span>
<a name="l01213"></a><a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">01213</a> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">Elem::neighbor</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l01214"></a>01214 <span class="keyword"></span>{
<a name="l01215"></a>01215   libmesh_assert (i &lt; this-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>());
<a name="l01216"></a>01216 
<a name="l01217"></a>01217   <span class="keywordflow">return</span> <a class="code" href="classElem.php#a2e02da07d0cbbf585262713c59f48773">_neighbors</a>[i];
<a name="l01218"></a>01218 }
<a name="l01219"></a>01219 
<a name="l01220"></a>01220 
<a name="l01221"></a>01221 
<a name="l01222"></a>01222 <span class="keyword">inline</span>
<a name="l01223"></a><a class="code" href="classElem.php#a88d676b002db35d70e0915d10c606f7f">01223</a> <span class="keywordtype">void</span> <a class="code" href="classElem.php#a88d676b002db35d70e0915d10c606f7f">Elem::set_neighbor</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <a class="code" href="classElem.php">Elem</a>* n)
<a name="l01224"></a>01224 {
<a name="l01225"></a>01225   libmesh_assert (i &lt; this-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>());
<a name="l01226"></a>01226   
<a name="l01227"></a>01227   <a class="code" href="classElem.php#a2e02da07d0cbbf585262713c59f48773">_neighbors</a>[i] = n;
<a name="l01228"></a>01228 }
<a name="l01229"></a>01229 
<a name="l01230"></a>01230 
<a name="l01231"></a>01231 
<a name="l01232"></a>01232 <span class="keyword">inline</span>
<a name="l01233"></a><a class="code" href="classElem.php#a7213196f7c76938ee380d331c4abd1ea">01233</a> <span class="keywordtype">bool</span> <a class="code" href="classElem.php#a7213196f7c76938ee380d331c4abd1ea">Elem::has_neighbor</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem)<span class="keyword"> const</span>
<a name="l01234"></a>01234 <span class="keyword"></span>{
<a name="l01235"></a>01235   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;this-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); n++)
<a name="l01236"></a>01236     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(n) == elem)
<a name="l01237"></a>01237       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01238"></a>01238 
<a name="l01239"></a>01239   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01240"></a>01240 }
<a name="l01241"></a>01241 
<a name="l01242"></a>01242 
<a name="l01243"></a>01243 
<a name="l01244"></a>01244 <span class="keyword">inline</span>
<a name="l01245"></a><a class="code" href="classElem.php#acd0a6126ed9ab0eee4a968bd7345888b">01245</a> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classElem.php#acd0a6126ed9ab0eee4a968bd7345888b">Elem::child_neighbor</a> (<a class="code" href="classElem.php">Elem</a>* elem)<span class="keyword"> const</span>
<a name="l01246"></a>01246 <span class="keyword"></span>{
<a name="l01247"></a>01247   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); n++)
<a name="l01248"></a>01248     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(n) &amp;&amp;
<a name="l01249"></a>01249         elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(n)-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>() == <span class="keyword">this</span>)
<a name="l01250"></a>01250       <span class="keywordflow">return</span> elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(n);
<a name="l01251"></a>01251 
<a name="l01252"></a>01252   <span class="keywordflow">return</span> NULL;
<a name="l01253"></a>01253 }
<a name="l01254"></a>01254 
<a name="l01255"></a>01255 
<a name="l01256"></a>01256 
<a name="l01257"></a>01257 <span class="keyword">inline</span>
<a name="l01258"></a><a class="code" href="classElem.php#aecc6bb3e4ef350cfeb3c7c0ca9286819">01258</a> <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classElem.php#acd0a6126ed9ab0eee4a968bd7345888b">Elem::child_neighbor</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem)<span class="keyword"> const</span>
<a name="l01259"></a>01259 <span class="keyword"></span>{
<a name="l01260"></a>01260   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); n++)
<a name="l01261"></a>01261     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(n) &amp;&amp;
<a name="l01262"></a>01262         elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(n)-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>() == <span class="keyword">this</span>)
<a name="l01263"></a>01263       <span class="keywordflow">return</span> elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(n);
<a name="l01264"></a>01264 
<a name="l01265"></a>01265   <span class="keywordflow">return</span> NULL;
<a name="l01266"></a>01266 }
<a name="l01267"></a>01267 
<a name="l01268"></a>01268 
<a name="l01269"></a>01269 
<a name="l01270"></a>01270 <span class="keyword">inline</span>
<a name="l01271"></a><a class="code" href="classElem.php#ad8c7675fc46286f2824582d9c4cb8177">01271</a> <span class="keywordtype">bool</span> <a class="code" href="classElem.php#ad8c7675fc46286f2824582d9c4cb8177">Elem::on_boundary</a> ()<span class="keyword"> const</span>
<a name="l01272"></a>01272 <span class="keyword"></span>{
<a name="l01273"></a>01273   <span class="comment">// By convention, the element is on the boundary</span>
<a name="l01274"></a>01274   <span class="comment">// if it has a NULL neighbor.</span>
<a name="l01275"></a>01275   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classElem.php#a7213196f7c76938ee380d331c4abd1ea">has_neighbor</a>(NULL);
<a name="l01276"></a>01276 }
<a name="l01277"></a>01277 
<a name="l01278"></a>01278 
<a name="l01279"></a>01279 
<a name="l01280"></a>01280 <span class="keyword">inline</span>
<a name="l01281"></a><a class="code" href="classElem.php#acab8fea073846b18b149ed2b88d43aff">01281</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#acab8fea073846b18b149ed2b88d43aff">Elem::which_neighbor_am_i</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* e)<span class="keyword"> const</span>
<a name="l01282"></a>01282 <span class="keyword"></span>{
<a name="l01283"></a>01283   libmesh_assert (e != NULL);
<a name="l01284"></a>01284 
<a name="l01285"></a>01285   <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* eparent = e;
<a name="l01286"></a>01286 
<a name="l01287"></a>01287   <span class="keywordflow">while</span> (eparent-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() &gt; this-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>())
<a name="l01288"></a>01288     {
<a name="l01289"></a>01289       eparent = eparent-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>();
<a name="l01290"></a>01290       libmesh_assert(eparent);
<a name="l01291"></a>01291     }
<a name="l01292"></a>01292   
<a name="l01293"></a>01293   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;this-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); s++)
<a name="l01294"></a>01294     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s) == eparent)
<a name="l01295"></a>01295       <span class="keywordflow">return</span> s;
<a name="l01296"></a>01296     
<a name="l01297"></a>01297   <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l01298"></a>01298 }
<a name="l01299"></a>01299 
<a name="l01300"></a>01300 
<a name="l01301"></a>01301 
<a name="l01302"></a>01302 <span class="keyword">inline</span>
<a name="l01303"></a><a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">01303</a> <span class="keywordtype">bool</span> <a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">Elem::active</a>()<span class="keyword"> const</span>
<a name="l01304"></a>01304 <span class="keyword"></span>{
<a name="l01305"></a>01305 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01306"></a>01306 <span class="preprocessor"></span>  <span class="keywordflow">if</span> ((this-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829aa5b67adf7b456724c4a0a07034a0adbf">INACTIVE</a>) ||
<a name="l01307"></a>01307       (this-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a1d4c57ce97a2dff1f6dd0e2b8855f80e">COARSEN_INACTIVE</a>))
<a name="l01308"></a>01308     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01309"></a>01309   <span class="keywordflow">else</span>
<a name="l01310"></a>01310     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01311"></a>01311 <span class="preprocessor">#else</span>
<a name="l01312"></a>01312 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01313"></a>01313 <span class="preprocessor">#endif</span>
<a name="l01314"></a>01314 <span class="preprocessor"></span>}
<a name="l01315"></a>01315 
<a name="l01316"></a>01316 
<a name="l01317"></a>01317 
<a name="l01318"></a>01318 
<a name="l01319"></a>01319 
<a name="l01320"></a>01320 <span class="keyword">inline</span>
<a name="l01321"></a><a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">01321</a> <span class="keywordtype">bool</span> <a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">Elem::subactive</a>()<span class="keyword"> const</span>
<a name="l01322"></a>01322 <span class="keyword"></span>{
<a name="l01323"></a>01323 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01324"></a>01324 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l01325"></a>01325     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01326"></a>01326   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classElem.php#a2ff2cfd3b4b05b8f091ba91eb068f81c">has_children</a>())
<a name="l01327"></a>01327     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01328"></a>01328   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(0)-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>();
<a name="l01329"></a>01329 <span class="preprocessor">#else</span>
<a name="l01330"></a>01330 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01331"></a>01331 <span class="preprocessor">#endif</span>
<a name="l01332"></a>01332 <span class="preprocessor"></span>}
<a name="l01333"></a>01333 
<a name="l01334"></a>01334 
<a name="l01335"></a>01335 
<a name="l01336"></a>01336 <span class="keyword">inline</span>
<a name="l01337"></a><a class="code" href="classElem.php#a2ff2cfd3b4b05b8f091ba91eb068f81c">01337</a> <span class="keywordtype">bool</span> <a class="code" href="classElem.php#a2ff2cfd3b4b05b8f091ba91eb068f81c">Elem::has_children</a>()<span class="keyword"> const</span>
<a name="l01338"></a>01338 <span class="keyword"></span>{
<a name="l01339"></a>01339 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01340"></a>01340 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (<a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a> == NULL)
<a name="l01341"></a>01341     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01342"></a>01342   <span class="keywordflow">else</span>
<a name="l01343"></a>01343     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01344"></a>01344 <span class="preprocessor">#else</span>
<a name="l01345"></a>01345 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01346"></a>01346 <span class="preprocessor">#endif</span>
<a name="l01347"></a>01347 <span class="preprocessor"></span>}
<a name="l01348"></a>01348 
<a name="l01349"></a>01349 
<a name="l01350"></a>01350 <span class="keyword">inline</span>
<a name="l01351"></a><a class="code" href="classElem.php#a7369dff866f654afd6606c393e22cf55">01351</a> <span class="keywordtype">bool</span> <a class="code" href="classElem.php#a7369dff866f654afd6606c393e22cf55">Elem::has_ancestor_children</a>()<span class="keyword"> const</span>
<a name="l01352"></a>01352 <span class="keyword"></span>{
<a name="l01353"></a>01353 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01354"></a>01354 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (<a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a> == NULL)
<a name="l01355"></a>01355     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01356"></a>01356   <span class="keywordflow">else</span>
<a name="l01357"></a>01357     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c != this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++)
<a name="l01358"></a>01358       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c)-&gt;<a class="code" href="classElem.php#a2ff2cfd3b4b05b8f091ba91eb068f81c">has_children</a>())
<a name="l01359"></a>01359         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01360"></a>01360 <span class="preprocessor">#endif</span>
<a name="l01361"></a>01361 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01362"></a>01362 }
<a name="l01363"></a>01363 
<a name="l01364"></a>01364 
<a name="l01365"></a>01365 
<a name="l01366"></a>01366 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01367"></a>01367 <span class="preprocessor"></span><span class="keyword">inline</span>
<a name="l01368"></a><a class="code" href="classElem.php#aa7fc177516bf85923273fef18cad56bd">01368</a> <span class="keywordtype">bool</span> <a class="code" href="classElem.php#aa7fc177516bf85923273fef18cad56bd">Elem::is_ancestor_of</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *descendant)<span class="keyword"> const</span>
<a name="l01369"></a>01369 <span class="keyword"></span>{
<a name="l01370"></a>01370   <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *e = descendant;
<a name="l01371"></a>01371   <span class="keywordflow">while</span> (e)
<a name="l01372"></a>01372     {
<a name="l01373"></a>01373       <span class="keywordflow">if</span> (<span class="keyword">this</span> == e)
<a name="l01374"></a>01374         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01375"></a>01375       e = e-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>();
<a name="l01376"></a>01376     }
<a name="l01377"></a>01377 <span class="preprocessor">#else</span>
<a name="l01378"></a>01378 <span class="preprocessor"></span><span class="keyword">inline</span>
<a name="l01379"></a>01379 <span class="keywordtype">bool</span> <a class="code" href="classElem.php#aa7fc177516bf85923273fef18cad56bd">Elem::is_ancestor_of</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *)<span class="keyword"> const</span>
<a name="l01380"></a>01380 <span class="keyword"></span>{
<a name="l01381"></a>01381 <span class="preprocessor">#endif</span>
<a name="l01382"></a>01382 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01383"></a>01383 }
<a name="l01384"></a>01384 
<a name="l01385"></a>01385 
<a name="l01386"></a>01386 
<a name="l01387"></a>01387 <span class="keyword">inline</span>
<a name="l01388"></a>01388 <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">Elem::parent</a> ()<span class="keyword"> const</span>
<a name="l01389"></a>01389 <span class="keyword"></span>{
<a name="l01390"></a>01390   <span class="keywordflow">return</span> <a class="code" href="classElem.php#a7f0bf473aeb272308a559de595ba7e04">_parent</a>;
<a name="l01391"></a>01391 }
<a name="l01392"></a>01392 
<a name="l01393"></a>01393 
<a name="l01394"></a>01394 
<a name="l01395"></a>01395 <span class="keyword">inline</span>
<a name="l01396"></a>01396 <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">Elem::parent</a> ()
<a name="l01397"></a>01397 {
<a name="l01398"></a>01398   <span class="keywordflow">return</span> <a class="code" href="classElem.php#a7f0bf473aeb272308a559de595ba7e04">_parent</a>;
<a name="l01399"></a>01399 }
<a name="l01400"></a>01400 
<a name="l01401"></a>01401 
<a name="l01402"></a>01402 
<a name="l01403"></a>01403 <span class="keyword">inline</span>
<a name="l01404"></a>01404 <span class="keywordtype">void</span> <a class="code" href="classElem.php#a64542f4d4b1e359b605cdf29ce0db943">Elem::set_parent</a> (<a class="code" href="classElem.php">Elem</a> *p)
<a name="l01405"></a>01405 {
<a name="l01406"></a>01406   <a class="code" href="classElem.php#a7f0bf473aeb272308a559de595ba7e04">_parent</a> = p;
<a name="l01407"></a>01407 }
<a name="l01408"></a>01408 
<a name="l01409"></a>01409 
<a name="l01410"></a>01410 
<a name="l01411"></a>01411 <span class="keyword">inline</span>
<a name="l01412"></a>01412 <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classElem.php#a6bc01ad4901efb64eb4f584ed5e1bd0b">Elem::top_parent</a> ()<span class="keyword"> const</span>
<a name="l01413"></a>01413 <span class="keyword"></span>{
<a name="l01414"></a>01414   <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* tp = <span class="keyword">this</span>;
<a name="l01415"></a>01415 
<a name="l01416"></a>01416   <span class="comment">// Keep getting the element&#39;s parent</span>
<a name="l01417"></a>01417   <span class="comment">// until that parent is at level-0</span>
<a name="l01418"></a>01418   <span class="keywordflow">while</span> (tp-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>() != NULL)
<a name="l01419"></a>01419     tp = tp-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>();
<a name="l01420"></a>01420   
<a name="l01421"></a>01421   libmesh_assert (tp != NULL);
<a name="l01422"></a>01422   libmesh_assert (tp-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() == 0);
<a name="l01423"></a>01423 
<a name="l01424"></a>01424   <span class="keywordflow">return</span> tp;  
<a name="l01425"></a>01425 }
<a name="l01426"></a>01426 
<a name="l01427"></a>01427 
<a name="l01428"></a>01428 
<a name="l01429"></a>01429 <span class="keyword">inline</span>
<a name="l01430"></a>01430 <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classElem.php#a82c29e6b178e335f607a65f61a524e13">Elem::interior_parent</a> ()<span class="keyword"> const</span>
<a name="l01431"></a>01431 <span class="keyword"></span>{
<a name="l01432"></a>01432   <span class="comment">// interior parents make no sense for 3D elements.</span>
<a name="l01433"></a>01433   libmesh_assert (this-&gt;<a class="code" href="classElem.php#a72c710c9b4ebbbdebb707e74165d9625">dim</a>() != 3);
<a name="l01434"></a>01434 
<a name="l01435"></a>01435   <span class="comment">// and they are only good for level-0 elements</span>
<a name="l01436"></a>01436   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() != 0)
<a name="l01437"></a>01437     <span class="keywordflow">return</span> this-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>()-&gt;<a class="code" href="classElem.php#a82c29e6b178e335f607a65f61a524e13">interior_parent</a>();
<a name="l01438"></a>01438   
<a name="l01439"></a>01439   <span class="comment">// if we are at level-0 and our parent is not NULL</span>
<a name="l01440"></a>01440   <span class="comment">// then it better be the higher-dimensional </span>
<a name="l01441"></a>01441   <span class="comment">// interior element we are looking for.</span>
<a name="l01442"></a>01442   <span class="keywordflow">if</span> (<a class="code" href="classElem.php#a7f0bf473aeb272308a559de595ba7e04">_parent</a>)
<a name="l01443"></a>01443     libmesh_assert (<a class="code" href="classElem.php#a7f0bf473aeb272308a559de595ba7e04">_parent</a>-&gt;<a class="code" href="classElem.php#a72c710c9b4ebbbdebb707e74165d9625">dim</a>() == (this-&gt;<a class="code" href="classElem.php#a72c710c9b4ebbbdebb707e74165d9625">dim</a>()+1));
<a name="l01444"></a>01444 
<a name="l01445"></a>01445   <span class="keywordflow">return</span> <a class="code" href="classElem.php#a7f0bf473aeb272308a559de595ba7e04">_parent</a>;
<a name="l01446"></a>01446 }
<a name="l01447"></a>01447 
<a name="l01448"></a>01448 
<a name="l01449"></a>01449 
<a name="l01450"></a>01450 <span class="keyword">inline</span>
<a name="l01451"></a>01451 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">Elem::level</a>()<span class="keyword"> const</span>
<a name="l01452"></a>01452 <span class="keyword"></span>{
<a name="l01453"></a>01453 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01454"></a>01454 <span class="preprocessor"></span>
<a name="l01455"></a>01455   <span class="comment">// if I don&#39;t have a parent I was</span>
<a name="l01456"></a>01456   <span class="comment">// created directly from file</span>
<a name="l01457"></a>01457   <span class="comment">// or by the user, so I am a</span>
<a name="l01458"></a>01458   <span class="comment">// level-0 element</span>
<a name="l01459"></a>01459   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>() == NULL)
<a name="l01460"></a>01460     <span class="keywordflow">return</span> 0;
<a name="l01461"></a>01461 
<a name="l01462"></a>01462   <span class="comment">// if the parent and this element are of different</span>
<a name="l01463"></a>01463   <span class="comment">// dimensionality we are at the same level as </span>
<a name="l01464"></a>01464   <span class="comment">// the parent (e.g. we are the 2D side of a </span>
<a name="l01465"></a>01465   <span class="comment">// 3D element)</span>
<a name="l01466"></a>01466   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#a72c710c9b4ebbbdebb707e74165d9625">dim</a>() != this-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>()-&gt;<a class="code" href="classElem.php#a72c710c9b4ebbbdebb707e74165d9625">dim</a>())
<a name="l01467"></a>01467     <span class="keywordflow">return</span> this-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>()-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>();
<a name="l01468"></a>01468 
<a name="l01469"></a>01469   <span class="comment">// otherwise we are at a level one</span>
<a name="l01470"></a>01470   <span class="comment">// higher than our parent</span>
<a name="l01471"></a>01471   <span class="keywordflow">return</span> (this-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>()-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() + 1);
<a name="l01472"></a>01472 
<a name="l01473"></a>01473 <span class="preprocessor">#else</span>
<a name="l01474"></a>01474 <span class="preprocessor"></span>
<a name="l01475"></a>01475   <span class="comment">// Without AMR all elements are</span>
<a name="l01476"></a>01476   <span class="comment">// at level 0.</span>
<a name="l01477"></a>01477   <span class="keywordflow">return</span> 0;
<a name="l01478"></a>01478   
<a name="l01479"></a>01479 <span class="preprocessor">#endif</span>
<a name="l01480"></a>01480 <span class="preprocessor"></span>}
<a name="l01481"></a>01481 
<a name="l01482"></a>01482 
<a name="l01483"></a>01483 
<a name="l01484"></a>01484 <span class="keyword">inline</span>
<a name="l01485"></a>01485 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">Elem::p_level</a>()<span class="keyword"> const</span>
<a name="l01486"></a>01486 <span class="keyword"></span>{
<a name="l01487"></a>01487 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01488"></a>01488 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classElem.php#a71cf2733e27d827a2947f0e92276c02e">_p_level</a>;
<a name="l01489"></a>01489 <span class="preprocessor">#else</span>
<a name="l01490"></a>01490 <span class="preprocessor"></span>  <span class="keywordflow">return</span> 0;
<a name="l01491"></a>01491 <span class="preprocessor">#endif</span>
<a name="l01492"></a>01492 <span class="preprocessor"></span>}
<a name="l01493"></a>01493 
<a name="l01494"></a>01494 
<a name="l01495"></a>01495 
<a name="l01496"></a>01496 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01497"></a>01497 <span class="preprocessor"></span>
<a name="l01498"></a>01498 <span class="keyword">inline</span>
<a name="l01499"></a>01499 <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">Elem::child</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l01500"></a>01500 <span class="keyword"></span>{
<a name="l01501"></a>01501   libmesh_assert (<a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>    != NULL);
<a name="l01502"></a>01502   libmesh_assert (<a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>[i] != NULL);
<a name="l01503"></a>01503   
<a name="l01504"></a>01504   <span class="keywordflow">return</span> <a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>[i];
<a name="l01505"></a>01505 }
<a name="l01506"></a>01506 
<a name="l01507"></a>01507 
<a name="l01508"></a>01508 
<a name="l01509"></a>01509 <span class="keyword">inline</span>
<a name="l01510"></a>01510 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a72cd45e535e8bebac68a57a362a60fef">Elem::which_child_am_i</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* e)<span class="keyword"> const</span>
<a name="l01511"></a>01511 <span class="keyword"></span>{
<a name="l01512"></a>01512   libmesh_assert (e != NULL);
<a name="l01513"></a>01513   libmesh_assert (this-&gt;<a class="code" href="classElem.php#a2ff2cfd3b4b05b8f091ba91eb068f81c">has_children</a>());
<a name="l01514"></a>01514 
<a name="l01515"></a>01515   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++)
<a name="l01516"></a>01516     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c) == e)
<a name="l01517"></a>01517       <span class="keywordflow">return</span> c;
<a name="l01518"></a>01518 
<a name="l01519"></a>01519   std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR:  which_child_am_i() was called with a non-child!&quot;</span> 
<a name="l01520"></a>01520             &lt;&lt; std::endl;
<a name="l01521"></a>01521 
<a name="l01522"></a>01522   libmesh_error();
<a name="l01523"></a>01523 
<a name="l01524"></a>01524   <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l01525"></a>01525 }
<a name="l01526"></a>01526 
<a name="l01527"></a>01527 
<a name="l01528"></a>01528 
<a name="l01529"></a>01529 <span class="keyword">inline</span>
<a name="l01530"></a>01530 <a class="code" href="classElem.php#a946039859488cca879512de516fef829">Elem::RefinementState</a> <a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">Elem::refinement_flag</a> ()<span class="keyword"> const</span>
<a name="l01531"></a>01531 <span class="keyword"></span>{
<a name="l01532"></a>01532   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="classElem.php#a946039859488cca879512de516fef829">RefinementState</a><span class="keyword">&gt;</span>(<a class="code" href="classElem.php#a876cfb60b44d8571a7a7daf4854f91d4">_rflag</a>);
<a name="l01533"></a>01533 }
<a name="l01534"></a>01534 
<a name="l01535"></a>01535 
<a name="l01536"></a>01536 
<a name="l01537"></a>01537 <span class="keyword">inline</span>
<a name="l01538"></a>01538 <span class="keywordtype">void</span> <a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">Elem::set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829">RefinementState</a> rflag)
<a name="l01539"></a>01539 {
<a name="l01540"></a>01540 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01541"></a>01541 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (rflag != static_cast&lt;RefinementState&gt;(static_cast&lt;unsigned char&gt;(rflag)))
<a name="l01542"></a>01542     {
<a name="l01543"></a>01543       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: unsigned char too small to hold Elem::_rflag!&quot;</span>
<a name="l01544"></a>01544                 &lt;&lt; std::endl
<a name="l01545"></a>01545                 &lt;&lt; <span class="stringliteral">&quot;Recompile with Elem:_*flag set to something bigger!&quot;</span>
<a name="l01546"></a>01546                 &lt;&lt; std::endl;
<a name="l01547"></a>01547       libmesh_error();
<a name="l01548"></a>01548     }
<a name="l01549"></a>01549 <span class="preprocessor">#endif</span>
<a name="l01550"></a>01550 <span class="preprocessor"></span>
<a name="l01551"></a>01551   <a class="code" href="classElem.php#a876cfb60b44d8571a7a7daf4854f91d4">_rflag</a> = rflag;
<a name="l01552"></a>01552 }
<a name="l01553"></a>01553 
<a name="l01554"></a>01554 
<a name="l01555"></a>01555 
<a name="l01556"></a>01556 <span class="keyword">inline</span>
<a name="l01557"></a>01557 <a class="code" href="classElem.php#a946039859488cca879512de516fef829">Elem::RefinementState</a> <a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">Elem::p_refinement_flag</a> ()<span class="keyword"> const</span>
<a name="l01558"></a>01558 <span class="keyword"></span>{
<a name="l01559"></a>01559   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="classElem.php#a946039859488cca879512de516fef829">RefinementState</a><span class="keyword">&gt;</span>(<a class="code" href="classElem.php#aa9f306d36014fbfdc27a284c9ce4b750">_pflag</a>);
<a name="l01560"></a>01560 }
<a name="l01561"></a>01561 
<a name="l01562"></a>01562 
<a name="l01563"></a>01563 
<a name="l01564"></a>01564 <span class="keyword">inline</span>
<a name="l01565"></a>01565 <span class="keywordtype">void</span> <a class="code" href="classElem.php#a40b62e384088baa756c3481b6631d7c4">Elem::set_p_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829">RefinementState</a> pflag)
<a name="l01566"></a>01566 {
<a name="l01567"></a>01567 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01568"></a>01568 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (pflag != static_cast&lt;RefinementState&gt;(static_cast&lt;unsigned char&gt;(pflag)))
<a name="l01569"></a>01569     {
<a name="l01570"></a>01570       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: unsigned char too small to hold Elem::_pflag!&quot;</span>
<a name="l01571"></a>01571                 &lt;&lt; std::endl
<a name="l01572"></a>01572                 &lt;&lt; <span class="stringliteral">&quot;Recompile with Elem:_*flag set to something bigger!&quot;</span>
<a name="l01573"></a>01573                 &lt;&lt; std::endl;
<a name="l01574"></a>01574       libmesh_error();
<a name="l01575"></a>01575     }
<a name="l01576"></a>01576 <span class="preprocessor">#endif</span>
<a name="l01577"></a>01577 <span class="preprocessor"></span>
<a name="l01578"></a>01578   <a class="code" href="classElem.php#aa9f306d36014fbfdc27a284c9ce4b750">_pflag</a> = pflag;
<a name="l01579"></a>01579 }
<a name="l01580"></a>01580 
<a name="l01581"></a>01581 
<a name="l01582"></a>01582 
<a name="l01583"></a>01583 <span class="keyword">inline</span>
<a name="l01584"></a>01584 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#aa6287a74c5d39a6a53bb23fa67ad6e10">Elem::max_descendant_p_level</a> ()<span class="keyword"> const</span>
<a name="l01585"></a>01585 <span class="keyword"></span>{
<a name="l01586"></a>01586   <span class="comment">// This is undefined for subactive elements,</span>
<a name="l01587"></a>01587   <span class="comment">// which have no active descendants</span>
<a name="l01588"></a>01588   libmesh_assert (!this-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>());
<a name="l01589"></a>01589   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l01590"></a>01590     <span class="keywordflow">return</span> this-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>();
<a name="l01591"></a>01591   
<a name="l01592"></a>01592   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_p_level = <a class="code" href="classElem.php#a71cf2733e27d827a2947f0e92276c02e">_p_level</a>;
<a name="l01593"></a>01593   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c != this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++)
<a name="l01594"></a>01594     max_p_level = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(max_p_level,
<a name="l01595"></a>01595                            this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c)-&gt;<a class="code" href="classElem.php#aa6287a74c5d39a6a53bb23fa67ad6e10">max_descendant_p_level</a>());
<a name="l01596"></a>01596   <span class="keywordflow">return</span> max_p_level;
<a name="l01597"></a>01597 }
<a name="l01598"></a>01598 
<a name="l01599"></a>01599 
<a name="l01600"></a>01600 
<a name="l01601"></a>01601 <span class="keyword">inline</span>
<a name="l01602"></a>01602 <span class="keywordtype">void</span> <a class="code" href="classElem.php#ae5dda58cdd729c5ee19c0a44bc1dd7bf">Elem::set_p_level</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)
<a name="l01603"></a>01603 {
<a name="l01604"></a>01604 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01605"></a>01605 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (p != static_cast&lt;unsigned int&gt;(static_cast&lt;unsigned char&gt;(p)))
<a name="l01606"></a>01606     {
<a name="l01607"></a>01607       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: unsigned char too small to hold Elem::_p_level!&quot;</span>
<a name="l01608"></a>01608                 &lt;&lt; std::endl
<a name="l01609"></a>01609                 &lt;&lt; <span class="stringliteral">&quot;Recompile with Elem:_p_level set to something bigger!&quot;</span>
<a name="l01610"></a>01610                 &lt;&lt; std::endl;
<a name="l01611"></a>01611       libmesh_error();
<a name="l01612"></a>01612     }
<a name="l01613"></a>01613 <span class="preprocessor">#endif</span>
<a name="l01614"></a>01614 <span class="preprocessor"></span>
<a name="l01615"></a>01615   <span class="comment">// Maintain the parent&#39;s p level as the minimum of it&#39;s children</span>
<a name="l01616"></a>01616   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>() != NULL)
<a name="l01617"></a>01617     {
<a name="l01618"></a>01618       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parent_p_level = this-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>()-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>();
<a name="l01619"></a>01619 
<a name="l01620"></a>01620       <span class="comment">// If our new p level is less than our parents, our parents drops</span>
<a name="l01621"></a>01621       <span class="keywordflow">if</span> (parent_p_level &gt; p)
<a name="l01622"></a>01622         {
<a name="l01623"></a>01623           this-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>()-&gt;<a class="code" href="classElem.php#ae5dda58cdd729c5ee19c0a44bc1dd7bf">set_p_level</a>(p);
<a name="l01624"></a>01624         }
<a name="l01625"></a>01625       <span class="comment">// If we are the lowest p level and it increases, so might</span>
<a name="l01626"></a>01626       <span class="comment">// our parent&#39;s, but we have to check every other child to see</span>
<a name="l01627"></a>01627       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (parent_p_level == <a class="code" href="classElem.php#a71cf2733e27d827a2947f0e92276c02e">_p_level</a> &amp;&amp; <a class="code" href="classElem.php#a71cf2733e27d827a2947f0e92276c02e">_p_level</a> &lt; p)
<a name="l01628"></a>01628         {
<a name="l01629"></a>01629           <a class="code" href="classElem.php#a71cf2733e27d827a2947f0e92276c02e">_p_level</a> = p;
<a name="l01630"></a>01630           parent_p_level = p;
<a name="l01631"></a>01631           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c != this-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>()-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++)
<a name="l01632"></a>01632             parent_p_level = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(parent_p_level,
<a name="l01633"></a>01633                                       this-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>()-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c)-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>());
<a name="l01634"></a>01634 
<a name="l01635"></a>01635           <span class="keywordflow">if</span> (parent_p_level != this-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>()-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>())
<a name="l01636"></a>01636             this-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>()-&gt;<a class="code" href="classElem.php#ae5dda58cdd729c5ee19c0a44bc1dd7bf">set_p_level</a>(parent_p_level);
<a name="l01637"></a>01637 
<a name="l01638"></a>01638           <span class="keywordflow">return</span>;
<a name="l01639"></a>01639         }
<a name="l01640"></a>01640     }
<a name="l01641"></a>01641 
<a name="l01642"></a>01642   <a class="code" href="classElem.php#a71cf2733e27d827a2947f0e92276c02e">_p_level</a> = p;
<a name="l01643"></a>01643 }
<a name="l01644"></a>01644 
<a name="l01645"></a>01645 
<a name="l01646"></a>01646 
<a name="l01647"></a>01647 <span class="keyword">inline</span>
<a name="l01648"></a>01648 <span class="keywordtype">void</span> <a class="code" href="classElem.php#aa9e1248d65ada8cd61e5af270d01cf53">Elem::hack_p_level</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)
<a name="l01649"></a>01649 {
<a name="l01650"></a>01650   <a class="code" href="classElem.php#a71cf2733e27d827a2947f0e92276c02e">_p_level</a> = p;
<a name="l01651"></a>01651 }
<a name="l01652"></a>01652 
<a name="l01653"></a>01653 
<a name="l01654"></a>01654 
<a name="l01655"></a>01655 <span class="preprocessor">#endif </span><span class="comment">/* ifdef LIBMESH_ENABLE_AMR */</span>
<a name="l01656"></a>01656 
<a name="l01657"></a>01657 
<a name="l01658"></a>01658 <span class="keyword">inline</span>
<a name="l01659"></a>01659 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a859c8236824914afa005cacf1ee86959">Elem::compute_key</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n0)
<a name="l01660"></a>01660 {
<a name="l01661"></a>01661   <span class="keywordflow">return</span> n0;
<a name="l01662"></a>01662 }
<a name="l01663"></a>01663 
<a name="l01664"></a>01664 
<a name="l01665"></a>01665 
<a name="l01666"></a>01666 <span class="keyword">inline</span>
<a name="l01667"></a>01667 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a859c8236824914afa005cacf1ee86959">Elem::compute_key</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n0,
<a name="l01668"></a>01668                                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1)
<a name="l01669"></a>01669 {
<a name="l01670"></a>01670   <span class="comment">// big prime number</span>
<a name="l01671"></a>01671   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bp = 65449;
<a name="l01672"></a>01672   
<a name="l01673"></a>01673   <span class="comment">// Order the two so that n0 &lt; n1</span>
<a name="l01674"></a>01674   <span class="keywordflow">if</span> (n0 &gt; n1) std::swap (n0, n1);
<a name="l01675"></a>01675 
<a name="l01676"></a>01676   <span class="keywordflow">return</span> (n0%bp + (n1&lt;&lt;5)%bp);  
<a name="l01677"></a>01677 }
<a name="l01678"></a>01678 
<a name="l01679"></a>01679 
<a name="l01680"></a>01680 
<a name="l01681"></a>01681 <span class="keyword">inline</span>
<a name="l01682"></a>01682 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a859c8236824914afa005cacf1ee86959">Elem::compute_key</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n0,
<a name="l01683"></a>01683                                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1,
<a name="l01684"></a>01684                                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n2)
<a name="l01685"></a>01685 {
<a name="l01686"></a>01686   <span class="comment">// big prime number</span>
<a name="l01687"></a>01687   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bp = 65449;
<a name="l01688"></a>01688 
<a name="l01689"></a>01689   <span class="comment">// Order the numbers such that n0 &lt; n1 &lt; n2.</span>
<a name="l01690"></a>01690   <span class="comment">// We&#39;ll do it in 3 steps like this:</span>
<a name="l01691"></a>01691   <span class="comment">//</span>
<a name="l01692"></a>01692   <span class="comment">//     n0         n1                n2</span>
<a name="l01693"></a>01693   <span class="comment">//     min(n0,n1) max(n0,n1)        n2</span>
<a name="l01694"></a>01694   <span class="comment">//     min(n0,n1) min(n2,max(n0,n1) max(n2,max(n0,n1)</span>
<a name="l01695"></a>01695   <span class="comment">//           |\   /|                  |</span>
<a name="l01696"></a>01696   <span class="comment">//           | \ / |                  |</span>
<a name="l01697"></a>01697   <span class="comment">//           |  /  |                  |</span>
<a name="l01698"></a>01698   <span class="comment">//           | /  \|                  |</span>
<a name="l01699"></a>01699   <span class="comment">//  gb min= min   max              gb max</span>
<a name="l01700"></a>01700 
<a name="l01701"></a>01701 
<a name="l01702"></a>01702 
<a name="l01703"></a>01703   <span class="comment">// Step 1</span>
<a name="l01704"></a>01704   <span class="keywordflow">if</span> (n0 &gt; n1) std::swap (n0, n1);
<a name="l01705"></a>01705 
<a name="l01706"></a>01706   <span class="comment">// Step 2</span>
<a name="l01707"></a>01707   <span class="keywordflow">if</span> (n1 &gt; n2) std::swap (n1, n2);
<a name="l01708"></a>01708 
<a name="l01709"></a>01709   <span class="comment">// Step 3</span>
<a name="l01710"></a>01710   <span class="keywordflow">if</span> (n0 &gt; n1) std::swap (n0, n1);
<a name="l01711"></a>01711 
<a name="l01712"></a>01712   libmesh_assert ((n0 &lt; n1) &amp;&amp; (n1 &lt; n2));
<a name="l01713"></a>01713 
<a name="l01714"></a>01714   
<a name="l01715"></a>01715   <span class="keywordflow">return</span> (n0%bp + (n1&lt;&lt;5)%bp + (n2&lt;&lt;10)%bp);
<a name="l01716"></a>01716 }
<a name="l01717"></a>01717 
<a name="l01718"></a>01718 
<a name="l01719"></a>01719 
<a name="l01720"></a>01720 <span class="keyword">inline</span>
<a name="l01721"></a>01721 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a859c8236824914afa005cacf1ee86959">Elem::compute_key</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n0,
<a name="l01722"></a>01722                                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1,
<a name="l01723"></a>01723                                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n2,
<a name="l01724"></a>01724                                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n3)
<a name="l01725"></a>01725 {
<a name="l01726"></a>01726   <span class="comment">// big prime number</span>
<a name="l01727"></a>01727   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bp = 65449;
<a name="l01728"></a>01728 
<a name="l01729"></a>01729   <span class="comment">// Step 1</span>
<a name="l01730"></a>01730   <span class="keywordflow">if</span> (n0 &gt; n1) std::swap (n0, n1);
<a name="l01731"></a>01731 
<a name="l01732"></a>01732   <span class="comment">// Step 2</span>
<a name="l01733"></a>01733   <span class="keywordflow">if</span> (n2 &gt; n3) std::swap (n2, n3);
<a name="l01734"></a>01734 
<a name="l01735"></a>01735   <span class="comment">// Step 3</span>
<a name="l01736"></a>01736   <span class="keywordflow">if</span> (n0 &gt; n2) std::swap (n0, n2);
<a name="l01737"></a>01737 
<a name="l01738"></a>01738   <span class="comment">// Step 4</span>
<a name="l01739"></a>01739   <span class="keywordflow">if</span> (n1 &gt; n3) std::swap (n1, n3);
<a name="l01740"></a>01740 
<a name="l01741"></a>01741   <span class="comment">// Finally step 5</span>
<a name="l01742"></a>01742   <span class="keywordflow">if</span> (n1 &gt; n2) std::swap (n1, n2);
<a name="l01743"></a>01743 
<a name="l01744"></a>01744   libmesh_assert ((n0 &lt; n1) &amp;&amp; (n1 &lt; n2) &amp;&amp; (n2 &lt; n3));
<a name="l01745"></a>01745   
<a name="l01746"></a>01746   <span class="keywordflow">return</span> (n0%bp + (n1&lt;&lt;5)%bp + (n2&lt;&lt;10)%bp + (n3&lt;&lt;15)%bp);
<a name="l01747"></a>01747 }
<a name="l01748"></a>01748 
<a name="l01749"></a>01749 
<a name="l01750"></a>01750 
<a name="l01751"></a>01751 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l01760"></a>01760 <span class="comment"></span><span class="keyword">class </span>Elem::PackedElem
<a name="l01761"></a>01761 {
<a name="l01762"></a>01762 <span class="keyword">private</span>:
<a name="l01763"></a>01763     
<a name="l01767"></a>01767   <span class="keyword">const</span> std::vector&lt;int&gt;::const_iterator _buf_begin;
<a name="l01768"></a>01768 
<a name="l01769"></a>01769 <span class="keyword">public</span>:
<a name="l01770"></a>01770 
<a name="l01775"></a>01775   PackedElem (<span class="keyword">const</span> std::vector&lt;int&gt;::const_iterator _buf_in) :
<a name="l01776"></a>01776     _buf_begin(_buf_in)
<a name="l01777"></a>01777   {}
<a name="l01778"></a>01778     
<a name="l01783"></a>01783   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> header_size; <span class="comment">/* = 10 with AMR, 4 without */</span>
<a name="l01784"></a>01784     
<a name="l01791"></a>01791   <span class="keyword">static</span> <span class="keywordtype">void</span> pack (std::vector&lt;int&gt; &amp;conn, <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem);    
<a name="l01792"></a>01792 
<a name="l01798"></a>01798   <a class="code" href="classElem.php">Elem</a> * unpack (<a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh, <a class="code" href="classElem.php">Elem</a> *<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a> = NULL) <span class="keyword">const</span>;
<a name="l01799"></a>01799 
<a name="l01803"></a>01803   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a> ()<span class="keyword"> const</span>
<a name="l01804"></a>01804 <span class="keyword">  </span>{
<a name="l01805"></a>01805     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(*_buf_begin);
<a name="l01806"></a>01806   }
<a name="l01807"></a>01807 
<a name="l01811"></a>01811   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a> ()<span class="keyword"> const</span>
<a name="l01812"></a>01812 <span class="keyword">  </span>{
<a name="l01813"></a>01813     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(*(_buf_begin+1));
<a name="l01814"></a>01814   }
<a name="l01815"></a>01815 
<a name="l01816"></a>01816 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01817"></a>01817 <span class="preprocessor"></span>
<a name="l01820"></a>01820   <a class="code" href="classElem.php#a946039859488cca879512de516fef829">Elem::RefinementState</a> <a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a> ()<span class="keyword"> const</span>
<a name="l01821"></a>01821 <span class="keyword">  </span>{
<a name="l01822"></a>01822     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="classElem.php#a946039859488cca879512de516fef829">Elem::RefinementState</a><span class="keyword">&gt;</span>(*(_buf_begin+2));
<a name="l01823"></a>01823   }
<a name="l01824"></a>01824 
<a name="l01828"></a>01828   <a class="code" href="classElem.php#a946039859488cca879512de516fef829">Elem::RefinementState</a> <a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a> ()<span class="keyword"> const</span>
<a name="l01829"></a>01829 <span class="keyword">  </span>{
<a name="l01830"></a>01830     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="classElem.php#a946039859488cca879512de516fef829">Elem::RefinementState</a><span class="keyword">&gt;</span>(*(_buf_begin+3));
<a name="l01831"></a>01831   }
<a name="l01832"></a>01832 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR</span>
<a name="l01833"></a>01833 <span class="preprocessor"></span>
<a name="l01837"></a>01837   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a> ()<span class="keyword"> const</span>
<a name="l01838"></a>01838 <span class="keyword">  </span>{
<a name="l01839"></a>01839     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a><span class="keyword">&gt;</span>(*(_buf_begin+4));
<a name="l01840"></a>01840   }
<a name="l01841"></a>01841 
<a name="l01845"></a>01845   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a> ()<span class="keyword"> const</span>
<a name="l01846"></a>01846 <span class="keyword">  </span>{
<a name="l01847"></a>01847     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(*(_buf_begin+5));
<a name="l01848"></a>01848   }
<a name="l01849"></a>01849 
<a name="l01853"></a>01853   <a class="code" href="classTestClass.php">subdomain_id_type</a> <a class="code" href="classElem.php#acc4746605aad9169ad38cfd0b9b97123">subdomain_id</a> ()<span class="keyword"> const</span>
<a name="l01854"></a>01854 <span class="keyword">  </span>{
<a name="l01855"></a>01855     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="classTestClass.php">subdomain_id_type</a><span class="keyword">&gt;</span>(*(_buf_begin+6));
<a name="l01856"></a>01856   }
<a name="l01857"></a>01857 
<a name="l01861"></a>01861   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a> ()<span class="keyword"> const</span>
<a name="l01862"></a>01862 <span class="keyword">  </span>{
<a name="l01863"></a>01863     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(*(_buf_begin+7));
<a name="l01864"></a>01864   }
<a name="l01865"></a>01865 
<a name="l01869"></a>01869   <span class="keywordtype">int</span> parent_id ()<span class="keyword"> const</span>
<a name="l01870"></a>01870 <span class="keyword">  </span>{
<a name="l01871"></a>01871     <span class="keywordflow">return</span> *(_buf_begin+8);
<a name="l01872"></a>01872   }
<a name="l01873"></a>01873 
<a name="l01877"></a>01877   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a72cd45e535e8bebac68a57a362a60fef">which_child_am_i</a> ()<span class="keyword"> const</span>
<a name="l01878"></a>01878 <span class="keyword">  </span>{
<a name="l01879"></a>01879     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(*(_buf_begin+9));
<a name="l01880"></a>01880   }
<a name="l01881"></a>01881     
<a name="l01885"></a>01885   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a> ()<span class="keyword"> const</span>
<a name="l01886"></a>01886 <span class="keyword">  </span>{
<a name="l01887"></a>01887     <span class="keywordflow">return</span> <a class="code" href="classElem.php#aef05e33c03cee6724a1e26b8fb9d19fd">Elem::type_to_n_nodes_map</a>[this-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>()];
<a name="l01888"></a>01888   }
<a name="l01889"></a>01889 
<a name="l01893"></a>01893   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l01894"></a>01894 <span class="keyword">  </span>{
<a name="l01895"></a>01895     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(*(_buf_begin+10+n));
<a name="l01896"></a>01896   }    
<a name="l01897"></a>01897 }; <span class="comment">// end class PackedElem</span>
<a name="l01898"></a>01898 
<a name="l01899"></a>01899 
<a name="l01903"></a>01903 <span class="keyword">class </span>Elem::SideIter
<a name="l01904"></a>01904 {
<a name="l01905"></a>01905 <span class="keyword">public</span>:
<a name="l01906"></a>01906   <span class="comment">// Constructor with arguments.</span>
<a name="l01907"></a>01907   SideIter(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> side_number,
<a name="l01908"></a>01908            <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>)
<a name="l01909"></a>01909     : _side_number(side_number),
<a name="l01910"></a>01910       _side_ptr(NULL),
<a name="l01911"></a>01911       <a class="code" href="classElem.php#a7f0bf473aeb272308a559de595ba7e04">_parent</a>(parent)
<a name="l01912"></a>01912   {}
<a name="l01913"></a>01913 
<a name="l01914"></a>01914     
<a name="l01915"></a>01915   <span class="comment">// Empty constructor.</span>
<a name="l01916"></a>01916   SideIter()
<a name="l01917"></a>01917     : _side_number(<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>),
<a name="l01918"></a>01918       _side_ptr(NULL),
<a name="l01919"></a>01919       <a class="code" href="classElem.php#a7f0bf473aeb272308a559de595ba7e04">_parent</a>(NULL)
<a name="l01920"></a>01920   {}
<a name="l01921"></a>01921 
<a name="l01922"></a>01922 
<a name="l01923"></a>01923   <span class="comment">// Copy constructor</span>
<a name="l01924"></a>01924   SideIter(<span class="keyword">const</span> SideIter&amp; other)
<a name="l01925"></a>01925     : _side_number(other._side_number),
<a name="l01926"></a>01926       <a class="code" href="classElem.php#a7f0bf473aeb272308a559de595ba7e04">_parent</a>(other._parent)
<a name="l01927"></a>01927   {}
<a name="l01928"></a>01928 
<a name="l01929"></a>01929 
<a name="l01930"></a>01930   <span class="comment">// op=</span>
<a name="l01931"></a>01931   SideIter&amp; operator=(<span class="keyword">const</span> SideIter&amp; other)
<a name="l01932"></a>01932   {
<a name="l01933"></a>01933     this-&gt;_side_number = other._side_number;
<a name="l01934"></a>01934     this-&gt;<a class="code" href="classElem.php#a7f0bf473aeb272308a559de595ba7e04">_parent</a>      = other.<a class="code" href="classElem.php#a7f0bf473aeb272308a559de595ba7e04">_parent</a>;
<a name="l01935"></a>01935     <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l01936"></a>01936   }
<a name="l01937"></a>01937 
<a name="l01938"></a>01938   <span class="comment">// unary op*</span>
<a name="l01939"></a>01939   <a class="code" href="classElem.php">Elem</a>*&amp; <a class="code" href="type__tensor_8h.php#a529f0725b8766b811e4681bfd79b124f">operator*</a>()<span class="keyword"> const</span>
<a name="l01940"></a>01940 <span class="keyword">  </span>{
<a name="l01941"></a>01941     <span class="comment">// Set the AutoPtr</span>
<a name="l01942"></a>01942     this-&gt;_update_side_ptr();
<a name="l01943"></a>01943 
<a name="l01944"></a>01944     <span class="comment">// Return a reference to _side_ptr</span>
<a name="l01945"></a>01945     <span class="keywordflow">return</span> this-&gt;_side_ptr;
<a name="l01946"></a>01946   }
<a name="l01947"></a>01947 
<a name="l01948"></a>01948   <span class="comment">// op++</span>
<a name="l01949"></a>01949   SideIter&amp; operator++()
<a name="l01950"></a>01950   {
<a name="l01951"></a>01951     ++_side_number;
<a name="l01952"></a>01952     <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l01953"></a>01953   }
<a name="l01954"></a>01954   
<a name="l01955"></a>01955   <span class="comment">// op==  Two side iterators are equal if they have</span>
<a name="l01956"></a>01956   <span class="comment">// the same side number and the same parent element.</span>
<a name="l01957"></a>01957   <span class="keywordtype">bool</span> <a class="code" href="classElem.php#acab7543901989ae1f909101f89f3d4d4">operator == </a>(<span class="keyword">const</span> SideIter&amp; other)<span class="keyword"> const</span>
<a name="l01958"></a>01958 <span class="keyword">  </span>{
<a name="l01959"></a>01959     <span class="keywordflow">return</span> (this-&gt;_side_number == other._side_number &amp;&amp;
<a name="l01960"></a>01960             this-&gt;_parent      == other._parent);
<a name="l01961"></a>01961   }
<a name="l01962"></a>01962 
<a name="l01963"></a>01963 
<a name="l01964"></a>01964   <span class="comment">// Consults the parent Elem to determine if the side</span>
<a name="l01965"></a>01965   <span class="comment">// is a boundary side.  Note: currently side N is a</span>
<a name="l01966"></a>01966   <span class="comment">// boundary side if nieghbor N is NULL.  Be careful,</span>
<a name="l01967"></a>01967   <span class="comment">// this could possibly change in the future?</span>
<a name="l01968"></a>01968   <span class="keywordtype">bool</span> side_on_boundary()<span class="keyword"> const</span>
<a name="l01969"></a>01969 <span class="keyword">  </span>{
<a name="l01970"></a>01970     <span class="keywordflow">return</span> this-&gt;<a class="code" href="classElem.php#a7f0bf473aeb272308a559de595ba7e04">_parent</a>-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(_side_number) == NULL;
<a name="l01971"></a>01971   }
<a name="l01972"></a>01972     
<a name="l01973"></a>01973 <span class="keyword">private</span>:
<a name="l01974"></a>01974   <span class="comment">// Update the _side pointer by building the correct side.</span>
<a name="l01975"></a>01975   <span class="comment">// This has to be called before dereferencing.</span>
<a name="l01976"></a>01976   <span class="keywordtype">void</span> _update_side_ptr()<span class="keyword"> const</span>
<a name="l01977"></a>01977 <span class="keyword">  </span>{
<a name="l01978"></a>01978     <span class="comment">// Construct new side, store in AutoPtr</span>
<a name="l01979"></a>01979     this-&gt;_side = this-&gt;<a class="code" href="classElem.php#a7f0bf473aeb272308a559de595ba7e04">_parent</a>-&gt;<a class="code" href="classElem.php#a554c146bcfb5537636bd77a157f21b85">build_side</a>(this-&gt;_side_number);
<a name="l01980"></a>01980 
<a name="l01981"></a>01981     <span class="comment">// Also set our internal naked pointer.  Memory is still owned</span>
<a name="l01982"></a>01982     <span class="comment">// by the AutoPtr.</span>
<a name="l01983"></a>01983     this-&gt;_side_ptr = _side.get();
<a name="l01984"></a>01984   }
<a name="l01985"></a>01985     
<a name="l01986"></a>01986   <span class="comment">// A counter variable which keeps track of the side number</span>
<a name="l01987"></a>01987   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _side_number;
<a name="l01988"></a>01988     
<a name="l01989"></a>01989   <span class="comment">// AutoPtr to the actual side, handles memory management for</span>
<a name="l01990"></a>01990   <span class="comment">// the sides which are created during the course of iteration.</span>
<a name="l01991"></a>01991   <span class="keyword">mutable</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> _side;
<a name="l01992"></a>01992 
<a name="l01993"></a>01993   <span class="comment">// Raw pointer needed to facilitate passing back to the user a</span>
<a name="l01994"></a>01994   <span class="comment">// reference to a non-temporary raw pointer in order to conform to</span>
<a name="l01995"></a>01995   <span class="comment">// the variant_filter_iterator interface.  It points to the same</span>
<a name="l01996"></a>01996   <span class="comment">// thing the AutoPtr &quot;_side&quot; above holds.  What happens if the user</span>
<a name="l01997"></a>01997   <span class="comment">// calls delete on the pointer passed back?  Well, this is an issue</span>
<a name="l01998"></a>01998   <span class="comment">// which is not addressed by the iterators in libMesh.  Basically it</span>
<a name="l01999"></a>01999   <span class="comment">// is a bad idea to ever call delete on an iterator from the library.</span>
<a name="l02000"></a>02000   <span class="keyword">mutable</span> <a class="code" href="classElem.php">Elem</a>* _side_ptr;
<a name="l02001"></a>02001   
<a name="l02002"></a>02002   <span class="comment">// Pointer to the parent Elem class which generated this iterator</span>
<a name="l02003"></a>02003   <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classElem.php#a7f0bf473aeb272308a559de595ba7e04">_parent</a>;
<a name="l02004"></a>02004 
<a name="l02005"></a>02005 };
<a name="l02006"></a>02006 
<a name="l02007"></a>02007 
<a name="l02008"></a>02008 
<a name="l02009"></a>02009 
<a name="l02010"></a>02010 
<a name="l02011"></a>02011 
<a name="l02012"></a>02012 <span class="comment">// Private implementation functions in the Elem class for the side iterators.</span>
<a name="l02013"></a>02013 <span class="comment">// They have to come after the definition of the SideIter class.</span>
<a name="l02014"></a>02014 <span class="keyword">inline</span>
<a name="l02015"></a>02015 Elem::SideIter <a class="code" href="classElem.php#ad956038473223519d323d3cb50d92622">Elem::_first_side</a>()
<a name="l02016"></a>02016 {
<a name="l02017"></a>02017   <span class="keywordflow">return</span> SideIter(0, <span class="keyword">this</span>);
<a name="l02018"></a>02018 }
<a name="l02019"></a>02019 
<a name="l02020"></a>02020 
<a name="l02021"></a>02021 
<a name="l02022"></a>02022 <span class="keyword">inline</span>
<a name="l02023"></a>02023 Elem::SideIter <a class="code" href="classElem.php#a4616bd8795259ad31ffe346a2abbb8df">Elem::_last_side</a>()
<a name="l02024"></a>02024 {
<a name="l02025"></a>02025   <span class="keywordflow">return</span> SideIter(this-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(), <span class="keyword">this</span>);
<a name="l02026"></a>02026 }
<a name="l02027"></a>02027                                 
<a name="l02028"></a>02028 
<a name="l02029"></a>02029 
<a name="l02030"></a>02030 
<a name="l02034"></a>02034 <span class="keyword">struct</span>
<a name="l02035"></a>02035 Elem::side_iterator :
<a name="l02036"></a>02036 <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&lt;<a class="code" href="classElem.php#a2b62f8279d6e76786766d896e2b2cf8f">Elem::Predicate</a>,
<a name="l02037"></a>02037                         <a class="code" href="classElem.php">Elem</a>*&gt;
<a name="l02038"></a>02038 {
<a name="l02039"></a>02039   <span class="comment">// Templated forwarding ctor -- forwards to appropriate variant_filter_iterator ctor</span>
<a name="l02040"></a>02040   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> PredType, <span class="keyword">typename</span> IterType&gt;
<a name="l02041"></a>02041   side_iterator (<span class="keyword">const</span> IterType&amp; d,
<a name="l02042"></a>02042                  <span class="keyword">const</span> IterType&amp; e,
<a name="l02043"></a>02043                  <span class="keyword">const</span> PredType&amp; p ) :
<a name="l02044"></a>02044     <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&lt;<a class="code" href="classElem.php#a2b62f8279d6e76786766d896e2b2cf8f">Elem::Predicate</a>,
<a name="l02045"></a>02045                             <a class="code" href="classElem.php">Elem</a>*&gt;(d,e,p) {}
<a name="l02046"></a>02046 };
<a name="l02047"></a>02047 
<a name="l02048"></a>02048 
<a name="l02049"></a>02049 
<a name="l02050"></a>02050 
<a name="l02051"></a>02051 <span class="preprocessor">#endif // end #ifndef __elem_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
