<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1665b3ccb6c776ec6797fe204e2359e5.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>elem_quality.C</h1>  </div>
</div>
<div class="contents">
<a href="elem__quality_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: elem_quality.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// C++ includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &lt;iostream&gt;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;sstream&gt;</span> 
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;elem_quality.h&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00029"></a>00029 <span class="comment">// Quality function definitions</span>
<a name="l00030"></a>00030 
<a name="l00038"></a><a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">00038</a> std::string <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">Quality::name</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) 
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040   std::string its_name;
<a name="l00041"></a>00041   
<a name="l00042"></a>00042   <span class="keywordflow">switch</span> (q)
<a name="l00043"></a>00043     {
<a name="l00044"></a>00044       
<a name="l00045"></a>00045     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad84ce9cc13267ffa231163dc658d5e23">ASPECT_RATIO</a>:
<a name="l00046"></a>00046       its_name = <span class="stringliteral">&quot;Aspect Ratio&quot;</span>;
<a name="l00047"></a>00047       <span class="keywordflow">break</span>;
<a name="l00048"></a>00048       
<a name="l00049"></a>00049     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a221d6d85c3c750560623002387ab06b2">SKEW</a>:
<a name="l00050"></a>00050       its_name = <span class="stringliteral">&quot;Skew&quot;</span>;
<a name="l00051"></a>00051       <span class="keywordflow">break</span>;
<a name="l00052"></a>00052       
<a name="l00053"></a>00053     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a41601385ca9d2f055200e85cfe782e5b">SHEAR</a>:
<a name="l00054"></a>00054       its_name = <span class="stringliteral">&quot;Shear&quot;</span>;
<a name="l00055"></a>00055       <span class="keywordflow">break</span>;
<a name="l00056"></a>00056       
<a name="l00057"></a>00057     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a44883df285a1b32254467277e46343df">SHAPE</a>:
<a name="l00058"></a>00058       its_name = <span class="stringliteral">&quot;Shape&quot;</span>;
<a name="l00059"></a>00059       <span class="keywordflow">break</span>;
<a name="l00060"></a>00060       
<a name="l00061"></a>00061     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a2c906ab7c9aca6cca231949a86b430a0">MAX_ANGLE</a>:
<a name="l00062"></a>00062       its_name = <span class="stringliteral">&quot;Maximum Angle&quot;</span>;
<a name="l00063"></a>00063       <span class="keywordflow">break</span>;
<a name="l00064"></a>00064 
<a name="l00065"></a>00065     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012aa567a4d684ebdd698e26a3e10456126b">MIN_ANGLE</a>:
<a name="l00066"></a>00066       its_name = <span class="stringliteral">&quot;Minimum Angle&quot;</span>;
<a name="l00067"></a>00067       <span class="keywordflow">break</span>;
<a name="l00068"></a>00068       
<a name="l00069"></a>00069     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a29e1db5c60b32bcee224ac441c04274b">CONDITION</a>:
<a name="l00070"></a>00070       its_name = <span class="stringliteral">&quot;Condition Number&quot;</span>;
<a name="l00071"></a>00071       <span class="keywordflow">break</span>;
<a name="l00072"></a>00072       
<a name="l00073"></a>00073     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a3fe96cbcdc284192e960220fc49fa942">DISTORTION</a>:
<a name="l00074"></a>00074       its_name = <span class="stringliteral">&quot;Distortion&quot;</span>;
<a name="l00075"></a>00075       <span class="keywordflow">break</span>;
<a name="l00076"></a>00076       
<a name="l00077"></a>00077     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a74f44b3ae7234b35337fbd0c71b112af">TAPER</a>:
<a name="l00078"></a>00078       its_name = <span class="stringliteral">&quot;Taper&quot;</span>;
<a name="l00079"></a>00079       <span class="keywordflow">break</span>;
<a name="l00080"></a>00080       
<a name="l00081"></a>00081     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a4ac2c62ea7ca226c3586825a77dd64a8">WARP</a>:
<a name="l00082"></a>00082       its_name = <span class="stringliteral">&quot;Warp&quot;</span>;
<a name="l00083"></a>00083       <span class="keywordflow">break</span>;
<a name="l00084"></a>00084       
<a name="l00085"></a>00085     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad7b656d7a4cdf057a09a9a9c328c5b3a">STRETCH</a>:
<a name="l00086"></a>00086       its_name = <span class="stringliteral">&quot;Stretch&quot;</span>;
<a name="l00087"></a>00087       <span class="keywordflow">break</span>;
<a name="l00088"></a>00088       
<a name="l00089"></a>00089     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a89d0f252b1485d9b6012ffde9431e227">DIAGONAL</a>:
<a name="l00090"></a>00090       its_name = <span class="stringliteral">&quot;Diagonal&quot;</span>;
<a name="l00091"></a>00091       <span class="keywordflow">break</span>;
<a name="l00092"></a>00092 
<a name="l00093"></a>00093     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a77ceaa502eaeff5313a279f08699e9d5">ASPECT_RATIO_BETA</a>:
<a name="l00094"></a>00094       its_name = <span class="stringliteral">&quot;AR Beta&quot;</span>;
<a name="l00095"></a>00095       <span class="keywordflow">break</span>;
<a name="l00096"></a>00096       
<a name="l00097"></a>00097     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad1cac69d1c38539e42934ab8dd2cb5a8">ASPECT_RATIO_GAMMA</a>:
<a name="l00098"></a>00098       its_name = <span class="stringliteral">&quot;AR Gamma&quot;</span>;
<a name="l00099"></a>00099       <span class="keywordflow">break</span>;
<a name="l00100"></a>00100 
<a name="l00101"></a>00101     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012afe883232d33e91404f7669f2aab854a6">SIZE</a>:
<a name="l00102"></a>00102       its_name = <span class="stringliteral">&quot;Size&quot;</span>;
<a name="l00103"></a>00103       <span class="keywordflow">break</span>;
<a name="l00104"></a>00104       
<a name="l00105"></a>00105     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012adce510f6954c2ac2cd6b1c6bf91210cc">JACOBIAN</a>:
<a name="l00106"></a>00106       its_name = <span class="stringliteral">&quot;Jacobian&quot;</span>;
<a name="l00107"></a>00107       <span class="keywordflow">break</span>;
<a name="l00108"></a>00108 
<a name="l00109"></a>00109     <span class="keywordflow">default</span>:
<a name="l00110"></a>00110       its_name = <span class="stringliteral">&quot;Unknown&quot;</span>;
<a name="l00111"></a>00111       <span class="keywordflow">break</span>;
<a name="l00112"></a>00112     }
<a name="l00113"></a>00113   
<a name="l00114"></a>00114   <span class="keywordflow">return</span> its_name;
<a name="l00115"></a>00115 }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00126"></a><a class="code" href="namespaceQuality.php#aad6761250e4cbb712ec221037262a734">00126</a> std::string <a class="code" href="namespaceQuality.php#aad6761250e4cbb712ec221037262a734">Quality::describe</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) 
<a name="l00127"></a>00127 {
<a name="l00128"></a>00128   
<a name="l00129"></a>00129   std::ostringstream desc; 
<a name="l00130"></a>00130   
<a name="l00131"></a>00131   <span class="keywordflow">switch</span> (q)
<a name="l00132"></a>00132     {
<a name="l00133"></a>00133       
<a name="l00134"></a>00134     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad84ce9cc13267ffa231163dc658d5e23">ASPECT_RATIO</a>:
<a name="l00135"></a>00135       desc &lt;&lt; <span class="stringliteral">&quot;Max edge length ratio\n&quot;</span>
<a name="l00136"></a>00136            &lt;&lt; <span class="stringliteral">&quot;at element center.\n&quot;</span>
<a name="l00137"></a>00137            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00138"></a>00138            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00139"></a>00139            &lt;&lt; <span class="stringliteral">&quot;Hexes: (1 -&gt; 4)\n&quot;</span>
<a name="l00140"></a>00140            &lt;&lt; <span class="stringliteral">&quot;Quads: (1 -&gt; 4)&quot;</span>;
<a name="l00141"></a>00141       <span class="keywordflow">break</span>;
<a name="l00142"></a>00142       
<a name="l00143"></a>00143     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a221d6d85c3c750560623002387ab06b2">SKEW</a>:
<a name="l00144"></a>00144       desc &lt;&lt; <span class="stringliteral">&quot;Maximum |cos A|, where A\n&quot;</span>
<a name="l00145"></a>00145            &lt;&lt; <span class="stringliteral">&quot;is the angle between edges\n&quot;</span>
<a name="l00146"></a>00146            &lt;&lt; <span class="stringliteral">&quot;at element center.\n&quot;</span>
<a name="l00147"></a>00147            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00148"></a>00148            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00149"></a>00149            &lt;&lt; <span class="stringliteral">&quot;Hexes: (0 -&gt; 0.5)\n&quot;</span>
<a name="l00150"></a>00150            &lt;&lt; <span class="stringliteral">&quot;Quads: (0 -&gt; 0.5)&quot;</span>;
<a name="l00151"></a>00151       <span class="keywordflow">break</span>;
<a name="l00152"></a>00152       
<a name="l00153"></a>00153     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a41601385ca9d2f055200e85cfe782e5b">SHEAR</a>:
<a name="l00154"></a>00154       desc &lt;&lt; <span class="stringliteral">&quot;LIBMESH_DIM / K(Js)\n&quot;</span>
<a name="l00155"></a>00155            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00156"></a>00156            &lt;&lt; <span class="stringliteral">&quot;LIBMESH_DIM   = element dimension.\n&quot;</span>
<a name="l00157"></a>00157            &lt;&lt; <span class="stringliteral">&quot;K(Js) = Condition number of \n&quot;</span>
<a name="l00158"></a>00158            &lt;&lt; <span class="stringliteral">&quot;        Jacobian skew matrix.\n&quot;</span>
<a name="l00159"></a>00159            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00160"></a>00160            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00161"></a>00161            &lt;&lt; <span class="stringliteral">&quot;Hexes(LIBMESH_DIM=3): (0.3 -&gt; 1)\n&quot;</span>
<a name="l00162"></a>00162            &lt;&lt; <span class="stringliteral">&quot;Quads(LIBMESH_DIM=2): (0.3 -&gt; 1)&quot;</span>;
<a name="l00163"></a>00163       <span class="keywordflow">break</span>;
<a name="l00164"></a>00164       
<a name="l00165"></a>00165     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a44883df285a1b32254467277e46343df">SHAPE</a>:
<a name="l00166"></a>00166       desc &lt;&lt; <span class="stringliteral">&quot;LIBMESH_DIM / K(Jw)\n&quot;</span>
<a name="l00167"></a>00167            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00168"></a>00168            &lt;&lt; <span class="stringliteral">&quot;LIBMESH_DIM   = element dimension.\n&quot;</span>
<a name="l00169"></a>00169            &lt;&lt; <span class="stringliteral">&quot;K(Jw) = Condition number of \n&quot;</span>
<a name="l00170"></a>00170            &lt;&lt; <span class="stringliteral">&quot;        weighted Jacobian\n&quot;</span>
<a name="l00171"></a>00171            &lt;&lt; <span class="stringliteral">&quot;        matrix.\n&quot;</span>
<a name="l00172"></a>00172            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00173"></a>00173            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00174"></a>00174            &lt;&lt; <span class="stringliteral">&quot;Hexes(LIBMESH_DIM=3): (0.3 -&gt; 1)\n&quot;</span>
<a name="l00175"></a>00175            &lt;&lt; <span class="stringliteral">&quot;Tets(LIBMESH_DIM=3): (0.2 -&gt; 1)\n&quot;</span>
<a name="l00176"></a>00176            &lt;&lt; <span class="stringliteral">&quot;Quads(LIBMESH_DIM=2): (0.3 -&gt; 1).&quot;</span>;
<a name="l00177"></a>00177       <span class="keywordflow">break</span>;
<a name="l00178"></a>00178       
<a name="l00179"></a>00179     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a2c906ab7c9aca6cca231949a86b430a0">MAX_ANGLE</a>:
<a name="l00180"></a>00180       desc &lt;&lt; <span class="stringliteral">&quot;Largest included angle.\n&quot;</span>
<a name="l00181"></a>00181            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00182"></a>00182            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00183"></a>00183            &lt;&lt; <span class="stringliteral">&quot;Quads: (90 -&gt; 135)\n&quot;</span>
<a name="l00184"></a>00184            &lt;&lt; <span class="stringliteral">&quot;Triangles: (60 -&gt; 90)&quot;</span>;
<a name="l00185"></a>00185       <span class="keywordflow">break</span>;
<a name="l00186"></a>00186 
<a name="l00187"></a>00187     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012aa567a4d684ebdd698e26a3e10456126b">MIN_ANGLE</a>:
<a name="l00188"></a>00188       desc &lt;&lt; <span class="stringliteral">&quot;Smallest included angle.\n&quot;</span>
<a name="l00189"></a>00189            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00190"></a>00190            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00191"></a>00191            &lt;&lt; <span class="stringliteral">&quot;Quads: (45 -&gt; 90)\n&quot;</span>
<a name="l00192"></a>00192            &lt;&lt; <span class="stringliteral">&quot;Triangles: (30 -&gt; 60)&quot;</span>;
<a name="l00193"></a>00193       <span class="keywordflow">break</span>;
<a name="l00194"></a>00194       
<a name="l00195"></a>00195     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a29e1db5c60b32bcee224ac441c04274b">CONDITION</a>:
<a name="l00196"></a>00196       desc &lt;&lt; <span class="stringliteral">&quot;Condition number of the\n&quot;</span>
<a name="l00197"></a>00197            &lt;&lt; <span class="stringliteral">&quot;Jacobian matrix.\n&quot;</span>
<a name="l00198"></a>00198            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00199"></a>00199            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00200"></a>00200            &lt;&lt; <span class="stringliteral">&quot;Quads: (1 -&gt; 4)\n&quot;</span> 
<a name="l00201"></a>00201            &lt;&lt; <span class="stringliteral">&quot;Hexes: (1 -&gt; 8)\n&quot;</span>
<a name="l00202"></a>00202            &lt;&lt; <span class="stringliteral">&quot;Tris: (1 -&gt; 1.3)\n&quot;</span>
<a name="l00203"></a>00203            &lt;&lt; <span class="stringliteral">&quot;Tets: (1 -&gt; 3)&quot;</span>;
<a name="l00204"></a>00204       <span class="keywordflow">break</span>;
<a name="l00205"></a>00205       
<a name="l00206"></a>00206     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a3fe96cbcdc284192e960220fc49fa942">DISTORTION</a>:
<a name="l00207"></a>00207       desc &lt;&lt; <span class="stringliteral">&quot;min |J| * A / &lt;A&gt;\n&quot;</span>
<a name="l00208"></a>00208            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00209"></a>00209            &lt;&lt; <span class="stringliteral">&quot;|J| = norm of Jacobian matrix\n&quot;</span>
<a name="l00210"></a>00210            &lt;&lt; <span class="stringliteral">&quot; A  = actual area\n&quot;</span>
<a name="l00211"></a>00211            &lt;&lt; <span class="stringliteral">&quot;&lt;A&gt; = reference area\n&quot;</span>
<a name="l00212"></a>00212            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00213"></a>00213            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00214"></a>00214            &lt;&lt; <span class="stringliteral">&quot;Quads: (0.6 -&gt; 1), &lt;A&gt;=4\n&quot;</span> 
<a name="l00215"></a>00215            &lt;&lt; <span class="stringliteral">&quot;Hexes: (0.6 -&gt; 1), &lt;A&gt;=8\n&quot;</span>
<a name="l00216"></a>00216            &lt;&lt; <span class="stringliteral">&quot;Tris: (0.6 -&gt; 1), &lt;A&gt;=1/2\n&quot;</span>
<a name="l00217"></a>00217            &lt;&lt; <span class="stringliteral">&quot;Tets: (0.6 -&gt; 1), &lt;A&gt;=1/6&quot;</span>;
<a name="l00218"></a>00218       <span class="keywordflow">break</span>;
<a name="l00219"></a>00219       
<a name="l00220"></a>00220     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a74f44b3ae7234b35337fbd0c71b112af">TAPER</a>:
<a name="l00221"></a>00221       desc &lt;&lt; <span class="stringliteral">&quot;Maximum ratio of lengths\n&quot;</span>
<a name="l00222"></a>00222            &lt;&lt; <span class="stringliteral">&quot;derived from opposited edges.\n&quot;</span>
<a name="l00223"></a>00223            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00224"></a>00224            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00225"></a>00225            &lt;&lt; <span class="stringliteral">&quot;Quads: (0.7 -&gt; 1)\n&quot;</span>
<a name="l00226"></a>00226            &lt;&lt; <span class="stringliteral">&quot;Hexes: (0.4 -&gt; 1)&quot;</span>;
<a name="l00227"></a>00227       <span class="keywordflow">break</span>;
<a name="l00228"></a>00228       
<a name="l00229"></a>00229     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a4ac2c62ea7ca226c3586825a77dd64a8">WARP</a>:
<a name="l00230"></a>00230       desc &lt;&lt; <span class="stringliteral">&quot;cos D\n&quot;</span>
<a name="l00231"></a>00231            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00232"></a>00232            &lt;&lt; <span class="stringliteral">&quot;D = minimum dihedral angle\n&quot;</span>
<a name="l00233"></a>00233            &lt;&lt; <span class="stringliteral">&quot;    formed by diagonals.\n&quot;</span>
<a name="l00234"></a>00234            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00235"></a>00235            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00236"></a>00236            &lt;&lt; <span class="stringliteral">&quot;Quads: (0.9 -&gt; 1)&quot;</span>;
<a name="l00237"></a>00237       <span class="keywordflow">break</span>;
<a name="l00238"></a>00238       
<a name="l00239"></a>00239     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad7b656d7a4cdf057a09a9a9c328c5b3a">STRETCH</a>:
<a name="l00240"></a>00240       desc &lt;&lt; <span class="stringliteral">&quot;Sqrt(3) * L_min / L_max\n&quot;</span>
<a name="l00241"></a>00241            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00242"></a>00242            &lt;&lt; <span class="stringliteral">&quot;L_min = minimum edge length.\n&quot;</span>
<a name="l00243"></a>00243            &lt;&lt; <span class="stringliteral">&quot;L_max = maximum edge length.\n&quot;</span>
<a name="l00244"></a>00244            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00245"></a>00245            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00246"></a>00246            &lt;&lt; <span class="stringliteral">&quot;Quads: (0.25 -&gt; 1)\n&quot;</span>
<a name="l00247"></a>00247            &lt;&lt; <span class="stringliteral">&quot;Hexes: (0.25 -&gt; 1)&quot;</span>;
<a name="l00248"></a>00248       <span class="keywordflow">break</span>;
<a name="l00249"></a>00249       
<a name="l00250"></a>00250     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a89d0f252b1485d9b6012ffde9431e227">DIAGONAL</a>:
<a name="l00251"></a>00251       desc &lt;&lt; <span class="stringliteral">&quot;D_min / D_max\n&quot;</span>
<a name="l00252"></a>00252            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00253"></a>00253            &lt;&lt; <span class="stringliteral">&quot;D_min = minimum diagonal.\n&quot;</span>
<a name="l00254"></a>00254            &lt;&lt; <span class="stringliteral">&quot;D_max = maximum diagonal.\n&quot;</span>
<a name="l00255"></a>00255            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00256"></a>00256            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00257"></a>00257            &lt;&lt; <span class="stringliteral">&quot;Hexes: (0.65 -&gt; 1)&quot;</span>;
<a name="l00258"></a>00258       <span class="keywordflow">break</span>;
<a name="l00259"></a>00259 
<a name="l00260"></a>00260     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a77ceaa502eaeff5313a279f08699e9d5">ASPECT_RATIO_BETA</a>:
<a name="l00261"></a>00261       desc &lt;&lt; <span class="stringliteral">&quot;CR / (3 * IR)\n&quot;</span>
<a name="l00262"></a>00262            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00263"></a>00263            &lt;&lt; <span class="stringliteral">&quot;CR = circumsphere radius\n&quot;</span>
<a name="l00264"></a>00264            &lt;&lt; <span class="stringliteral">&quot;IR = inscribed sphere radius\n&quot;</span>
<a name="l00265"></a>00265            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00266"></a>00266            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00267"></a>00267            &lt;&lt; <span class="stringliteral">&quot;Tets: (1 -&gt; 3)&quot;</span>;
<a name="l00268"></a>00268       <span class="keywordflow">break</span>;
<a name="l00269"></a>00269       
<a name="l00270"></a>00270     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad1cac69d1c38539e42934ab8dd2cb5a8">ASPECT_RATIO_GAMMA</a>:
<a name="l00271"></a>00271       desc &lt;&lt; <span class="stringliteral">&quot;S^(3/2) / 8.479670 * V\n&quot;</span>
<a name="l00272"></a>00272            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00273"></a>00273            &lt;&lt; <span class="stringliteral">&quot;S = sum(si*si/6)\n&quot;</span>
<a name="l00274"></a>00274            &lt;&lt; <span class="stringliteral">&quot;si = edge length\n&quot;</span>
<a name="l00275"></a>00275            &lt;&lt; <span class="stringliteral">&quot;V = volume\n&quot;</span>
<a name="l00276"></a>00276            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00277"></a>00277            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00278"></a>00278            &lt;&lt; <span class="stringliteral">&quot;Tets: (1 -&gt; 3)&quot;</span>;
<a name="l00279"></a>00279       <span class="keywordflow">break</span>;
<a name="l00280"></a>00280 
<a name="l00281"></a>00281     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012afe883232d33e91404f7669f2aab854a6">SIZE</a>:
<a name="l00282"></a>00282       desc &lt;&lt; <span class="stringliteral">&quot;min (|J|, |1/J|)\n&quot;</span>
<a name="l00283"></a>00283            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00284"></a>00284            &lt;&lt; <span class="stringliteral">&quot;|J| = norm of Jacobian matrix.\n&quot;</span>
<a name="l00285"></a>00285            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00286"></a>00286            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00287"></a>00287            &lt;&lt; <span class="stringliteral">&quot;Quads: (0.3 -&gt; 1)\n&quot;</span> 
<a name="l00288"></a>00288            &lt;&lt; <span class="stringliteral">&quot;Hexes: (0.5 -&gt; 1)\n&quot;</span>
<a name="l00289"></a>00289            &lt;&lt; <span class="stringliteral">&quot;Tris: (0.25 -&gt; 1)\n&quot;</span>
<a name="l00290"></a>00290            &lt;&lt; <span class="stringliteral">&quot;Tets: (0.2 -&gt; 1)&quot;</span>;
<a name="l00291"></a>00291       <span class="keywordflow">break</span>;
<a name="l00292"></a>00292       
<a name="l00293"></a>00293     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012adce510f6954c2ac2cd6b1c6bf91210cc">JACOBIAN</a>:
<a name="l00294"></a>00294       desc &lt;&lt; <span class="stringliteral">&quot;Minimum Jacobian divided by\n&quot;</span>
<a name="l00295"></a>00295            &lt;&lt; <span class="stringliteral">&quot;the lengths of the LIBMESH_DIM\n&quot;</span>
<a name="l00296"></a>00296            &lt;&lt; <span class="stringliteral">&quot;largest edge vectors.\n&quot;</span>
<a name="l00297"></a>00297            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00298"></a>00298            &lt;&lt; <span class="stringliteral">&quot;LIBMESH_DIM = element dimension.\n&quot;</span>
<a name="l00299"></a>00299            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00300"></a>00300            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00301"></a>00301            &lt;&lt; <span class="stringliteral">&quot;Quads: (0.5 -&gt; 1)\n&quot;</span> 
<a name="l00302"></a>00302            &lt;&lt; <span class="stringliteral">&quot;Hexes: (0.5 -&gt; 1)\n&quot;</span>
<a name="l00303"></a>00303            &lt;&lt; <span class="stringliteral">&quot;Tris: (0.5 -&gt; 1.155)\n&quot;</span>
<a name="l00304"></a>00304            &lt;&lt; <span class="stringliteral">&quot;Tets: (0.5 -&gt; 1.414)&quot;</span>;
<a name="l00305"></a>00305       <span class="keywordflow">break</span>;
<a name="l00306"></a>00306 
<a name="l00307"></a>00307     <span class="keywordflow">default</span>:
<a name="l00308"></a>00308       desc &lt;&lt; <span class="stringliteral">&quot;Unknown&quot;</span>;
<a name="l00309"></a>00309       <span class="keywordflow">break</span>;
<a name="l00310"></a>00310     }
<a name="l00311"></a>00311   
<a name="l00312"></a>00312   <span class="keywordflow">return</span> desc.str();
<a name="l00313"></a>00313 }
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 
<a name="l00320"></a><a class="code" href="namespaceQuality.php#ae66af30d2e47f44f6d2a2df385d7fb3a">00320</a> std::vector&lt;ElemQuality&gt; <a class="code" href="namespaceQuality.php#ae66af30d2e47f44f6d2a2df385d7fb3a">Quality::valid</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t)
<a name="l00321"></a>00321 {
<a name="l00322"></a>00322   std::vector&lt;ElemQuality&gt; v;
<a name="l00323"></a>00323   
<a name="l00324"></a>00324   <span class="keywordflow">switch</span> (t)
<a name="l00325"></a>00325     {
<a name="l00326"></a>00326     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00327"></a>00327     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00328"></a>00328     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l00329"></a>00329       {
<a name="l00330"></a>00330         <span class="comment">// None yet</span>
<a name="l00331"></a>00331         <span class="keywordflow">break</span>;
<a name="l00332"></a>00332       }
<a name="l00333"></a>00333 
<a name="l00334"></a>00334     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00335"></a>00335     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00336"></a>00336       {
<a name="l00337"></a>00337         v.resize(7);
<a name="l00338"></a>00338         v[0] = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a2c906ab7c9aca6cca231949a86b430a0">MAX_ANGLE</a>;
<a name="l00339"></a>00339         v[1] = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012aa567a4d684ebdd698e26a3e10456126b">MIN_ANGLE</a>;
<a name="l00340"></a>00340         v[2] = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a29e1db5c60b32bcee224ac441c04274b">CONDITION</a>;
<a name="l00341"></a>00341         v[3] = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012adce510f6954c2ac2cd6b1c6bf91210cc">JACOBIAN</a>;
<a name="l00342"></a>00342         v[4] = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012afe883232d33e91404f7669f2aab854a6">SIZE</a>;
<a name="l00343"></a>00343         v[5] = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a44883df285a1b32254467277e46343df">SHAPE</a>;
<a name="l00344"></a>00344         v[6] = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a3fe96cbcdc284192e960220fc49fa942">DISTORTION</a>;
<a name="l00345"></a>00345         <span class="keywordflow">break</span>;
<a name="l00346"></a>00346       }
<a name="l00347"></a>00347 
<a name="l00348"></a>00348     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l00349"></a>00349     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00350"></a>00350     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00351"></a>00351       {
<a name="l00352"></a>00352         v.resize(13);
<a name="l00353"></a>00353         v[0]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad84ce9cc13267ffa231163dc658d5e23">ASPECT_RATIO</a>;
<a name="l00354"></a>00354         v[1]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a221d6d85c3c750560623002387ab06b2">SKEW</a>;
<a name="l00355"></a>00355         v[2]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a74f44b3ae7234b35337fbd0c71b112af">TAPER</a>;
<a name="l00356"></a>00356         v[3]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a4ac2c62ea7ca226c3586825a77dd64a8">WARP</a>;
<a name="l00357"></a>00357         v[4]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad7b656d7a4cdf057a09a9a9c328c5b3a">STRETCH</a>;
<a name="l00358"></a>00358         v[5]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012aa567a4d684ebdd698e26a3e10456126b">MIN_ANGLE</a>;
<a name="l00359"></a>00359         v[6]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a2c906ab7c9aca6cca231949a86b430a0">MAX_ANGLE</a>;
<a name="l00360"></a>00360         v[7]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a29e1db5c60b32bcee224ac441c04274b">CONDITION</a>;
<a name="l00361"></a>00361         v[8]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012adce510f6954c2ac2cd6b1c6bf91210cc">JACOBIAN</a>;
<a name="l00362"></a>00362         v[9]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a41601385ca9d2f055200e85cfe782e5b">SHEAR</a>;
<a name="l00363"></a>00363         v[10] = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a44883df285a1b32254467277e46343df">SHAPE</a>;
<a name="l00364"></a>00364         v[11] = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012afe883232d33e91404f7669f2aab854a6">SIZE</a>;
<a name="l00365"></a>00365         v[12] = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a3fe96cbcdc284192e960220fc49fa942">DISTORTION</a>;
<a name="l00366"></a>00366         <span class="keywordflow">break</span>;
<a name="l00367"></a>00367       }
<a name="l00368"></a>00368 
<a name="l00369"></a>00369     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l00370"></a>00370     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l00371"></a>00371       {
<a name="l00372"></a>00372         v.resize(7);
<a name="l00373"></a>00373         v[0]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a77ceaa502eaeff5313a279f08699e9d5">ASPECT_RATIO_BETA</a>;
<a name="l00374"></a>00374         v[1]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad1cac69d1c38539e42934ab8dd2cb5a8">ASPECT_RATIO_GAMMA</a>;
<a name="l00375"></a>00375         v[2]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a29e1db5c60b32bcee224ac441c04274b">CONDITION</a>;
<a name="l00376"></a>00376         v[3]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012adce510f6954c2ac2cd6b1c6bf91210cc">JACOBIAN</a>;
<a name="l00377"></a>00377         v[4]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a44883df285a1b32254467277e46343df">SHAPE</a>;
<a name="l00378"></a>00378         v[5]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012afe883232d33e91404f7669f2aab854a6">SIZE</a>;
<a name="l00379"></a>00379         v[6]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a3fe96cbcdc284192e960220fc49fa942">DISTORTION</a>;
<a name="l00380"></a>00380         <span class="keywordflow">break</span>;
<a name="l00381"></a>00381       }
<a name="l00382"></a>00382 
<a name="l00383"></a>00383     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00384"></a>00384     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00385"></a>00385     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00386"></a>00386       {
<a name="l00387"></a>00387         v.resize(11);
<a name="l00388"></a>00388         v[0]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad84ce9cc13267ffa231163dc658d5e23">ASPECT_RATIO</a>;
<a name="l00389"></a>00389         v[1]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a221d6d85c3c750560623002387ab06b2">SKEW</a>;
<a name="l00390"></a>00390         v[2]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a41601385ca9d2f055200e85cfe782e5b">SHEAR</a>;
<a name="l00391"></a>00391         v[3] = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a44883df285a1b32254467277e46343df">SHAPE</a>;
<a name="l00392"></a>00392         v[4]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a29e1db5c60b32bcee224ac441c04274b">CONDITION</a>;
<a name="l00393"></a>00393         v[5]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012adce510f6954c2ac2cd6b1c6bf91210cc">JACOBIAN</a>;
<a name="l00394"></a>00394         v[6]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a3fe96cbcdc284192e960220fc49fa942">DISTORTION</a>;
<a name="l00395"></a>00395         v[7]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a74f44b3ae7234b35337fbd0c71b112af">TAPER</a>;
<a name="l00396"></a>00396         v[8]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad7b656d7a4cdf057a09a9a9c328c5b3a">STRETCH</a>;
<a name="l00397"></a>00397         v[9]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a89d0f252b1485d9b6012ffde9431e227">DIAGONAL</a>;
<a name="l00398"></a>00398         v[10]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012afe883232d33e91404f7669f2aab854a6">SIZE</a>;
<a name="l00399"></a>00399         <span class="keywordflow">break</span>;
<a name="l00400"></a>00400       }
<a name="l00401"></a>00401 
<a name="l00402"></a>00402     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l00403"></a>00403     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l00404"></a>00404       {
<a name="l00405"></a>00405         <span class="comment">// None yet</span>
<a name="l00406"></a>00406         <span class="keywordflow">break</span>;
<a name="l00407"></a>00407       }
<a name="l00408"></a>00408 
<a name="l00409"></a>00409     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l00410"></a>00410       {
<a name="l00411"></a>00411         <span class="comment">// None yet</span>
<a name="l00412"></a>00412         <span class="keywordflow">break</span>;
<a name="l00413"></a>00413       }
<a name="l00414"></a>00414 
<a name="l00415"></a>00415 
<a name="l00416"></a>00416 
<a name="l00417"></a>00417 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00418"></a>00418 <span class="preprocessor"></span>
<a name="l00419"></a>00419     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a278476b80069e0630827235779c82c47">INFEDGE2</a>:
<a name="l00420"></a>00420       {
<a name="l00421"></a>00421         <span class="comment">// None yet</span>
<a name="l00422"></a>00422         <span class="keywordflow">break</span>;
<a name="l00423"></a>00423       }
<a name="l00424"></a>00424 
<a name="l00425"></a>00425     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a23d0ae825ee3f493b6504b71f28e2aef">INFQUAD4</a>:
<a name="l00426"></a>00426     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a669ef57bb0d4c72fd22fa0f4febe6ac1">INFQUAD6</a>:
<a name="l00427"></a>00427       {
<a name="l00428"></a>00428         <span class="comment">// None yet</span>
<a name="l00429"></a>00429         <span class="keywordflow">break</span>;
<a name="l00430"></a>00430       }
<a name="l00431"></a>00431 
<a name="l00432"></a>00432     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a54cedbd05931dd2cb7dcabf0109bddcb">INFHEX8</a>:
<a name="l00433"></a>00433     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a583e72df1b20e339d9f8fcea6a94c1d4">INFHEX16</a>:
<a name="l00434"></a>00434     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4e68f53177cc7d1366225dfc8f7bbbed">INFHEX18</a>:
<a name="l00435"></a>00435       {
<a name="l00436"></a>00436         <span class="comment">// None yet</span>
<a name="l00437"></a>00437         <span class="keywordflow">break</span>;
<a name="l00438"></a>00438       }
<a name="l00439"></a>00439 
<a name="l00440"></a>00440     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac6743a9a04524105e37159e924c4a33b">INFPRISM6</a>:
<a name="l00441"></a>00441     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a89630f5af6a58aaa9ae731d924139c61">INFPRISM12</a>:
<a name="l00442"></a>00442       {
<a name="l00443"></a>00443         <span class="comment">// None yet</span>
<a name="l00444"></a>00444         <span class="keywordflow">break</span>;
<a name="l00445"></a>00445       }
<a name="l00446"></a>00446 
<a name="l00447"></a>00447 <span class="preprocessor">#endif</span>
<a name="l00448"></a>00448 <span class="preprocessor"></span>
<a name="l00449"></a>00449       
<a name="l00450"></a>00450     <span class="keywordflow">default</span>:
<a name="l00451"></a>00451       {
<a name="l00452"></a>00452         std::cout &lt;&lt; <span class="stringliteral">&quot;Undefined element type!.&quot;</span> &lt;&lt; std::endl;
<a name="l00453"></a>00453         libmesh_error();
<a name="l00454"></a>00454       }
<a name="l00455"></a>00455     }
<a name="l00456"></a>00456   
<a name="l00457"></a>00457   <span class="keywordflow">return</span> v;
<a name="l00458"></a>00458 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
