<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1665b3ccb6c776ec6797fe204e2359e5.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>elem_refinement.C</h1>  </div>
</div>
<div class="contents">
<a href="elem__refinement_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: elem_refinement.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;mesh_refinement.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;remote_elem.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00031"></a>00031 <span class="comment">// Elem methods</span>
<a name="l00032"></a>00032 
<a name="l00038"></a>00038 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span>
<a name="l00040"></a><a class="code" href="classElem.php#a3df9b2e814ba0232402084d688ce34a2">00040</a> <span class="keywordtype">void</span> <a class="code" href="classElem.php#a3df9b2e814ba0232402084d688ce34a2">Elem::refine</a> (<a class="code" href="classMeshRefinement.php">MeshRefinement</a>&amp; mesh_refinement)
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042   libmesh_assert (this-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>);
<a name="l00043"></a>00043   libmesh_assert (this-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>());
<a name="l00044"></a>00044   
<a name="l00045"></a>00045   <span class="comment">// Create my children if necessary</span>
<a name="l00046"></a>00046   <span class="keywordflow">if</span> (!<a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>)
<a name="l00047"></a>00047     {
<a name="l00048"></a>00048       <a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a> = <span class="keyword">new</span> <a class="code" href="classElem.php">Elem</a>*[this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>()];
<a name="l00049"></a>00049 
<a name="l00050"></a>00050       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parent_p_level = this-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>();
<a name="l00051"></a>00051       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++)
<a name="l00052"></a>00052         {
<a name="l00053"></a>00053           <a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>[c] = <a class="code" href="classElem.php#a7f46524fbd44a76f940435d6a1434a9d">Elem::build</a>(this-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>(), <span class="keyword">this</span>).release();
<a name="l00054"></a>00054           <a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>[c]-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a28fd8e260b7464210efa6f4f24d54310">Elem::JUST_REFINED</a>);
<a name="l00055"></a>00055           <a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>[c]-&gt;<a class="code" href="classElem.php#ae5dda58cdd729c5ee19c0a44bc1dd7bf">set_p_level</a>(parent_p_level);
<a name="l00056"></a>00056           <a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>[c]-&gt;<a class="code" href="classElem.php#a40b62e384088baa756c3481b6631d7c4">set_p_refinement_flag</a>(this-&gt;<a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>());
<a name="l00057"></a>00057         }
<a name="l00058"></a>00058 
<a name="l00059"></a>00059       <span class="comment">// Compute new nodal locations</span>
<a name="l00060"></a>00060       <span class="comment">// and asssign nodes to children</span>
<a name="l00061"></a>00061       <span class="comment">// Make these static.  It is unlikely the</span>
<a name="l00062"></a>00062       <span class="comment">// sizes will change from call to call, so having these</span>
<a name="l00063"></a>00063       <span class="comment">// static should save on reallocations</span>
<a name="l00064"></a>00064       std::vector&lt;std::vector&lt;Point&gt; &gt;        p    (this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>());
<a name="l00065"></a>00065       std::vector&lt;std::vector&lt;Node*&gt; &gt;        nodes(this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>());
<a name="l00066"></a>00066     
<a name="l00067"></a>00067 
<a name="l00068"></a>00068       <span class="comment">// compute new nodal locations</span>
<a name="l00069"></a>00069       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++)
<a name="l00070"></a>00070         {       
<a name="l00071"></a>00071           <a class="code" href="classElem.php">Elem</a> *<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a> = this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c);
<a name="l00072"></a>00072           p[c].resize    (child-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>());
<a name="l00073"></a>00073           nodes[c].resize(child-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>());
<a name="l00074"></a>00074 
<a name="l00075"></a>00075           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc=0; nc&lt;child-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); nc++)
<a name="l00076"></a>00076             {
<a name="l00077"></a>00077               <span class="comment">// zero entries</span>
<a name="l00078"></a>00078               p[c][nc].zero();
<a name="l00079"></a>00079               nodes[c][nc] = NULL;
<a name="l00080"></a>00080           
<a name="l00081"></a>00081               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;this-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); n++)
<a name="l00082"></a>00082                 {
<a name="l00083"></a>00083                   <span class="comment">// The value from the embedding matrix</span>
<a name="l00084"></a>00084                   <span class="keyword">const</span> <span class="keywordtype">float</span> em_val = this-&gt;<a class="code" href="classElem.php#a018d328d79c727dbe66196980fcaf50a">embedding_matrix</a>(c,nc,n);
<a name="l00085"></a>00085               
<a name="l00086"></a>00086                   <span class="keywordflow">if</span> (em_val != 0.)
<a name="l00087"></a>00087                     {
<a name="l00088"></a>00088                       p[c][nc].add_scaled (this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(n), em_val);
<a name="l00089"></a>00089                   
<a name="l00090"></a>00090                       <span class="comment">// We may have found the node, in which case we</span>
<a name="l00091"></a>00091                       <span class="comment">// won&#39;t need to look it up later.</span>
<a name="l00092"></a>00092                       <span class="keywordflow">if</span> (em_val == 1.)
<a name="l00093"></a>00093                         nodes[c][nc] = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(n);
<a name="l00094"></a>00094                     }
<a name="l00095"></a>00095                 }
<a name="l00096"></a>00096             }
<a name="l00097"></a>00097       
<a name="l00098"></a>00098         <span class="comment">// assign nodes to children &amp; add them to the mesh</span>
<a name="l00099"></a>00099           <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> pointtol = this-&gt;<a class="code" href="classElem.php#a8483eb75ec4ccc49b41596557a3a367b">hmin</a>() * TOLERANCE;
<a name="l00100"></a>00100           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc=0; nc&lt;child-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); nc++)
<a name="l00101"></a>00101             {
<a name="l00102"></a>00102               <span class="keywordflow">if</span> (nodes[c][nc] != NULL)
<a name="l00103"></a>00103                 {
<a name="l00104"></a>00104                   child-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(nc) = nodes[c][nc];
<a name="l00105"></a>00105                 }
<a name="l00106"></a>00106               <span class="keywordflow">else</span>
<a name="l00107"></a>00107                 {
<a name="l00108"></a>00108                   child-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(nc) =
<a name="l00109"></a>00109                     mesh_refinement.<a class="code" href="classMeshRefinement.php#a1ba6d819dde6739791062d14a25e49aa">add_point</a>(p[c][nc],
<a name="l00110"></a>00110                                               child-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>(),
<a name="l00111"></a>00111                                               pointtol);
<a name="l00112"></a>00112                   child-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(nc)-&gt;<a class="code" href="classDofObject.php#a6e22aa41575c516980aab9eaaae7cec1">set_n_systems</a>
<a name="l00113"></a>00113                     (this-&gt;<a class="code" href="classDofObject.php#a221af22104bf374c293dc59f9afb8226">n_systems</a>());
<a name="l00114"></a>00114                 }
<a name="l00115"></a>00115             }
<a name="l00116"></a>00116       
<a name="l00117"></a>00117           mesh_refinement.<a class="code" href="classMeshRefinement.php#a2227d3f4c2e3cde51213d2845c0ce508">add_elem</a> (child);
<a name="l00118"></a>00118           child-&gt;<a class="code" href="classDofObject.php#a6e22aa41575c516980aab9eaaae7cec1">set_n_systems</a>(this-&gt;<a class="code" href="classDofObject.php#a221af22104bf374c293dc59f9afb8226">n_systems</a>());
<a name="l00119"></a>00119         }
<a name="l00120"></a>00120     }
<a name="l00121"></a>00121   <span class="keywordflow">else</span>
<a name="l00122"></a>00122     {
<a name="l00123"></a>00123       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parent_p_level = this-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>();
<a name="l00124"></a>00124       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++)
<a name="l00125"></a>00125         {       
<a name="l00126"></a>00126           <a class="code" href="classElem.php">Elem</a> *<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a> = this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c);
<a name="l00127"></a>00127           libmesh_assert(child-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>());
<a name="l00128"></a>00128           child-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a28fd8e260b7464210efa6f4f24d54310">Elem::JUST_REFINED</a>);
<a name="l00129"></a>00129           child-&gt;<a class="code" href="classElem.php#ae5dda58cdd729c5ee19c0a44bc1dd7bf">set_p_level</a>(parent_p_level);
<a name="l00130"></a>00130           child-&gt;<a class="code" href="classElem.php#a40b62e384088baa756c3481b6631d7c4">set_p_refinement_flag</a>(this-&gt;<a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>());
<a name="l00131"></a>00131         }
<a name="l00132"></a>00132     }
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   <span class="comment">// Un-set my refinement flag now</span>
<a name="l00135"></a>00135   this-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829aa5b67adf7b456724c4a0a07034a0adbf">Elem::INACTIVE</a>);
<a name="l00136"></a>00136   this-&gt;<a class="code" href="classElem.php#a40b62e384088baa756c3481b6631d7c4">set_p_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829aa5b67adf7b456724c4a0a07034a0adbf">Elem::INACTIVE</a>);
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++)
<a name="l00139"></a>00139     {   
<a name="l00140"></a>00140       libmesh_assert(this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c)-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>() == <span class="keyword">this</span>);
<a name="l00141"></a>00141       libmesh_assert(this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c)-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>());
<a name="l00142"></a>00142     }
<a name="l00143"></a>00143   libmesh_assert (this-&gt;<a class="code" href="classElem.php#a3ad156b66b45310da85b653c791bd790">ancestor</a>());
<a name="l00144"></a>00144 }
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 
<a name="l00148"></a><a class="code" href="classElem.php#ab65844b6b7edc68786155a52ceb0865a">00148</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#ab65844b6b7edc68786155a52ceb0865a">Elem::_cast_node_address_to_unsigned_int</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00149"></a>00149 {
<a name="l00150"></a>00150   <span class="comment">// An unsigned int associated with the</span>
<a name="l00151"></a>00151   <span class="comment">// address of the node n.  We can&#39;t use the</span>
<a name="l00152"></a>00152   <span class="comment">// node number since they can change, so we use the</span>
<a name="l00153"></a>00153   <span class="comment">// Node&#39;s address.  (We also can&#39;t use the x,y,z</span>
<a name="l00154"></a>00154   <span class="comment">// location of the node since that can change too!)</span>
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 <span class="preprocessor">#if LIBMESH_SIZEOF_INT == LIBMESH_SIZEOF_VOID_P</span>
<a name="l00157"></a>00157 <span class="preprocessor"></span>
<a name="l00158"></a>00158   <span class="comment">// 32-bit machines</span>
<a name="l00159"></a>00159   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_id =
<a name="l00160"></a>00160     <span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(n));
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 <span class="preprocessor">#elif LIBMESH_SIZEOF_LONG_INT == LIBMESH_SIZEOF_VOID_P</span>
<a name="l00163"></a>00163 <span class="preprocessor"></span>
<a name="l00164"></a>00164   <span class="comment">// 64-bit machines </span>
<a name="l00165"></a>00165   <span class="comment">// Another big prime number less than max_unsigned_int</span>
<a name="l00166"></a>00166   <span class="comment">// for key creation on 64-bit machines</span>
<a name="l00167"></a>00167   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bp3 = 4294967291;
<a name="l00168"></a>00168   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_id =                     
<a name="l00169"></a>00169     <span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">long</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(n))%bp3;
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 <span class="preprocessor">#else</span>
<a name="l00172"></a>00172 <span class="preprocessor"></span>  <span class="comment">// Huh?</span>
<a name="l00173"></a>00173 <span class="preprocessor">#error                  WHAT KIND OF CRAZY MACHINE IS THIS? CANNOT COMPILE</span>
<a name="l00174"></a>00174 <span class="preprocessor"></span>
<a name="l00175"></a>00175 <span class="preprocessor">#endif</span>
<a name="l00176"></a>00176 <span class="preprocessor"></span>
<a name="l00177"></a>00177   <span class="keywordflow">return</span> n_id;
<a name="l00178"></a>00178 }
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 
<a name="l00184"></a><a class="code" href="classElem.php#a404022768f8be8b29a31c2f021d4304d">00184</a> <span class="keywordtype">void</span> <a class="code" href="classElem.php#a404022768f8be8b29a31c2f021d4304d">Elem::coarsen</a>()
<a name="l00185"></a>00185 {
<a name="l00186"></a>00186   libmesh_assert (this-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a1d4c57ce97a2dff1f6dd0e2b8855f80e">Elem::COARSEN_INACTIVE</a>);
<a name="l00187"></a>00187   libmesh_assert (!this-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>());
<a name="l00188"></a>00188 
<a name="l00189"></a>00189   <span class="comment">// We no longer delete children until MeshRefinement::contract()</span>
<a name="l00190"></a>00190   <span class="comment">// delete [] _children;</span>
<a name="l00191"></a>00191   <span class="comment">// _children = NULL;</span>
<a name="l00192"></a>00192 
<a name="l00193"></a>00193   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parent_p_level = 0;
<a name="l00194"></a>00194 
<a name="l00195"></a>00195   <span class="comment">// re-compute hanging node nodal locations</span>
<a name="l00196"></a>00196   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++)
<a name="l00197"></a>00197   {     
<a name="l00198"></a>00198     <a class="code" href="classElem.php">Elem</a> *mychild = this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c);
<a name="l00199"></a>00199     <span class="keywordflow">if</span> (mychild == <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>)
<a name="l00200"></a>00200       <span class="keywordflow">continue</span>;
<a name="l00201"></a>00201     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc=0; nc&lt;mychild-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); nc++)
<a name="l00202"></a>00202     {
<a name="l00203"></a>00203       <a class="code" href="classPoint.php">Point</a> new_pos;
<a name="l00204"></a>00204       <span class="keywordtype">bool</span> calculated_new_pos = <span class="keyword">false</span>;
<a name="l00205"></a>00205 
<a name="l00206"></a>00206       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;this-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); n++)
<a name="l00207"></a>00207       {
<a name="l00208"></a>00208         <span class="comment">// The value from the embedding matrix</span>
<a name="l00209"></a>00209         <span class="keyword">const</span> <span class="keywordtype">float</span> em_val = this-&gt;<a class="code" href="classElem.php#a018d328d79c727dbe66196980fcaf50a">embedding_matrix</a>(c,nc,n);
<a name="l00210"></a>00210          
<a name="l00211"></a>00211         <span class="comment">// The node location is somewhere between existing vertices</span>
<a name="l00212"></a>00212         <span class="keywordflow">if</span> ((em_val != 0.) &amp;&amp; (em_val != 1.)) 
<a name="l00213"></a>00213         {
<a name="l00214"></a>00214           new_pos.<a class="code" href="classTypeVector.php#ac9000695cb19991b893cb79a07249e9c">add_scaled</a> (this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(n), em_val);
<a name="l00215"></a>00215           calculated_new_pos = <span class="keyword">true</span>;
<a name="l00216"></a>00216         }
<a name="l00217"></a>00217       }
<a name="l00218"></a>00218 
<a name="l00219"></a>00219       <span class="keywordflow">if</span>(calculated_new_pos)
<a name="l00220"></a>00220       { 
<a name="l00221"></a>00221         <span class="comment">//Move the existing node back into it&#39;s original location</span>
<a name="l00222"></a>00222         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00223"></a>00223         {
<a name="l00224"></a>00224           <a class="code" href="classPoint.php">Point</a> &amp; child_node = *(mychild-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(nc));
<a name="l00225"></a>00225           child_node(i)=new_pos(i);
<a name="l00226"></a>00226         }
<a name="l00227"></a>00227       }
<a name="l00228"></a>00228     }
<a name="l00229"></a>00229   }
<a name="l00230"></a>00230 
<a name="l00231"></a>00231   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++)
<a name="l00232"></a>00232     {   
<a name="l00233"></a>00233       <a class="code" href="classElem.php">Elem</a> *mychild = this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c);
<a name="l00234"></a>00234       <span class="keywordflow">if</span> (mychild == <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>)
<a name="l00235"></a>00235         <span class="keywordflow">continue</span>;
<a name="l00236"></a>00236       libmesh_assert (mychild-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>);
<a name="l00237"></a>00237       mychild-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829aa5b67adf7b456724c4a0a07034a0adbf">Elem::INACTIVE</a>);
<a name="l00238"></a>00238       <span class="keywordflow">if</span> (mychild-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>() &gt; parent_p_level)
<a name="l00239"></a>00239         parent_p_level = mychild-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>();
<a name="l00240"></a>00240     }
<a name="l00241"></a>00241 
<a name="l00242"></a>00242   this-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829ad2c57c7a107071f8229a64a5af22202f">Elem::JUST_COARSENED</a>);
<a name="l00243"></a>00243   this-&gt;<a class="code" href="classElem.php#ae5dda58cdd729c5ee19c0a44bc1dd7bf">set_p_level</a>(parent_p_level);
<a name="l00244"></a>00244 
<a name="l00245"></a>00245   libmesh_assert (this-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>());
<a name="l00246"></a>00246 }
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 
<a name="l00250"></a><a class="code" href="classElem.php#a0d3684188ff7e647bb565e3de3439e7d">00250</a> <span class="keywordtype">void</span> <a class="code" href="classElem.php#a0d3684188ff7e647bb565e3de3439e7d">Elem::contract</a>()
<a name="l00251"></a>00251 {
<a name="l00252"></a>00252   <span class="comment">// Subactive elements get deleted entirely, not contracted</span>
<a name="l00253"></a>00253   libmesh_assert (this-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>());
<a name="l00254"></a>00254 
<a name="l00255"></a>00255   <span class="comment">// Active contracted elements no longer can have children</span>
<a name="l00256"></a>00256   <span class="keywordflow">if</span> (<a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>)
<a name="l00257"></a>00257     {
<a name="l00258"></a>00258       <span class="keyword">delete</span> [] <a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>;
<a name="l00259"></a>00259       <a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a> = NULL;
<a name="l00260"></a>00260     }
<a name="l00261"></a>00261   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829ad2c57c7a107071f8229a64a5af22202f">Elem::JUST_COARSENED</a>)
<a name="l00262"></a>00262     this-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a3bc34bb09879a3388ad735a75317b3c3">Elem::DO_NOTHING</a>);
<a name="l00263"></a>00263 }
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00266"></a>00266 <span class="preprocessor"></span>
<a name="l00267"></a>00267 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
