<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>ensight_io.C</h1>  </div>
</div>
<div class="contents">
<a href="ensight__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: ensight_io.C 3467 2009-09-17 18:01:58Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;sstream&gt;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;cstring&gt;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;stdio.h&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;dof_map.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;system.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;o_string_stream.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;fe_interface.h&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;ensight_io.h&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a><a class="code" href="classEnsightIO.php#a59a3ff309de3630f9f66627ef9e0ed27">00037</a> <a class="code" href="classEnsightIO.php#a59a3ff309de3630f9f66627ef9e0ed27">EnsightIO::EnsightIO</a> (<span class="keyword">const</span> std::string &amp;filename, <span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a> &amp;eq) :
<a name="l00038"></a>00038   <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt; (eq.get_mesh()),
<a name="l00039"></a>00039   _equation_systems(eq)
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041   
<a name="l00042"></a>00042   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l00043"></a>00043     <a class="code" href="classEnsightIO.php#a26123e820e7ae4454d1d046f783216b7">_ensight_file_name</a> = filename;
<a name="l00044"></a>00044   <span class="keywordflow">else</span>
<a name="l00045"></a>00045     {
<a name="l00046"></a>00046       std::stringstream tmp_file;
<a name="l00047"></a>00047       tmp_file &lt;&lt; filename &lt;&lt; <span class="stringliteral">&quot;_rank&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>();
<a name="l00048"></a>00048       <a class="code" href="classEnsightIO.php#a26123e820e7ae4454d1d046f783216b7">_ensight_file_name</a> = tmp_file.str();      
<a name="l00049"></a>00049     }
<a name="l00050"></a>00050 }
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a><a class="code" href="classEnsightIO.php#a81f515ab95ef956e90dd4e01bb86991c">00054</a> <a class="code" href="classEnsightIO.php#a81f515ab95ef956e90dd4e01bb86991c">EnsightIO::~EnsightIO</a> ()
<a name="l00055"></a>00055 {}
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 
<a name="l00059"></a><a class="code" href="classEnsightIO.php#a12b0bb2ce4bc5b38db6655045ff4db24">00059</a> <span class="keywordtype">void</span> <a class="code" href="classEnsightIO.php#a12b0bb2ce4bc5b38db6655045ff4db24">EnsightIO::add_vector</a> (<span class="keyword">const</span> std::string &amp;system_name, <span class="keyword">const</span> std::string &amp;vec_description, 
<a name="l00060"></a>00060                             <span class="keyword">const</span> std::string &amp;u, <span class="keyword">const</span> std::string &amp;v)
<a name="l00061"></a>00061 {
<a name="l00062"></a>00062   libmesh_assert (<a class="code" href="classEnsightIO.php#afa6e269c0a2821c2efd8a4d8ae3be3fb">_equation_systems</a>.<a class="code" href="classEquationSystems.php#a547e381d557dd9c29b9f08aa87f146a0">has_system</a>(system_name));
<a name="l00063"></a>00063   libmesh_assert (<a class="code" href="classEnsightIO.php#afa6e269c0a2821c2efd8a4d8ae3be3fb">_equation_systems</a>.<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(system_name).has_variable(u));
<a name="l00064"></a>00064   libmesh_assert (<a class="code" href="classEnsightIO.php#afa6e269c0a2821c2efd8a4d8ae3be3fb">_equation_systems</a>.<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(system_name).has_variable(v));
<a name="l00065"></a>00065   
<a name="l00066"></a>00066   <a class="code" href="structEnsightIO_1_1Vectors.php">Vectors</a> vec; 
<a name="l00067"></a>00067   vec.<a class="code" href="structEnsightIO_1_1Vectors.php#a17f8f3b6b2332d26e0e394063ba40e50">description</a> = vec_description;
<a name="l00068"></a>00068   vec.components.push_back(u);
<a name="l00069"></a>00069   vec.components.push_back(v);  
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   <a class="code" href="classEnsightIO.php#a86a549664452d5cf88ac02add2873431">_systems_vars_map</a>[system_name].EnsightVectors.push_back(vec);
<a name="l00072"></a>00072 }
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 
<a name="l00075"></a>00075                 
<a name="l00076"></a><a class="code" href="classEnsightIO.php#a8a27ff262d49324f5c1b3a5385c2781b">00076</a> <span class="keywordtype">void</span> <a class="code" href="classEnsightIO.php#a12b0bb2ce4bc5b38db6655045ff4db24">EnsightIO::add_vector</a> (<span class="keyword">const</span> std::string &amp;system_name, <span class="keyword">const</span> std::string &amp;vec_name, 
<a name="l00077"></a>00077                             <span class="keyword">const</span> std::string &amp;u, <span class="keyword">const</span> std::string &amp;v, <span class="keyword">const</span> std::string &amp;w)
<a name="l00078"></a>00078 {
<a name="l00079"></a>00079   libmesh_assert(<a class="code" href="classEnsightIO.php#afa6e269c0a2821c2efd8a4d8ae3be3fb">_equation_systems</a>.<a class="code" href="classEquationSystems.php#a547e381d557dd9c29b9f08aa87f146a0">has_system</a>(system_name));
<a name="l00080"></a>00080   libmesh_assert(<a class="code" href="classEnsightIO.php#afa6e269c0a2821c2efd8a4d8ae3be3fb">_equation_systems</a>.<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(system_name).has_variable(u));
<a name="l00081"></a>00081   libmesh_assert(<a class="code" href="classEnsightIO.php#afa6e269c0a2821c2efd8a4d8ae3be3fb">_equation_systems</a>.<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(system_name).has_variable(v));
<a name="l00082"></a>00082   libmesh_assert(<a class="code" href="classEnsightIO.php#afa6e269c0a2821c2efd8a4d8ae3be3fb">_equation_systems</a>.<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(system_name).has_variable(w));
<a name="l00083"></a>00083 
<a name="l00084"></a>00084   <a class="code" href="structEnsightIO_1_1Vectors.php">Vectors</a> vec; 
<a name="l00085"></a>00085   vec.<a class="code" href="structEnsightIO_1_1Vectors.php#a17f8f3b6b2332d26e0e394063ba40e50">description</a> = vec_name;
<a name="l00086"></a>00086   vec.components.push_back(u);
<a name="l00087"></a>00087   vec.components.push_back(v);  
<a name="l00088"></a>00088   vec.components.push_back(w);  
<a name="l00089"></a>00089   <a class="code" href="classEnsightIO.php#a86a549664452d5cf88ac02add2873431">_systems_vars_map</a>[system_name].EnsightVectors.push_back(vec);
<a name="l00090"></a>00090 }
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 
<a name="l00093"></a>00093                 
<a name="l00094"></a><a class="code" href="classEnsightIO.php#a5981bac9c3cf066d0ebeafa3e94bb69a">00094</a> <span class="keywordtype">void</span> <a class="code" href="classEnsightIO.php#a5981bac9c3cf066d0ebeafa3e94bb69a">EnsightIO::add_scalar</a>(<span class="keyword">const</span> std::string &amp;system_name, <span class="keyword">const</span> std::string &amp;scl_description, 
<a name="l00095"></a>00095                            <span class="keyword">const</span> std::string &amp;s)
<a name="l00096"></a>00096 {
<a name="l00097"></a>00097   libmesh_assert(<a class="code" href="classEnsightIO.php#afa6e269c0a2821c2efd8a4d8ae3be3fb">_equation_systems</a>.<a class="code" href="classEquationSystems.php#a547e381d557dd9c29b9f08aa87f146a0">has_system</a>(system_name));
<a name="l00098"></a>00098   libmesh_assert(<a class="code" href="classEnsightIO.php#afa6e269c0a2821c2efd8a4d8ae3be3fb">_equation_systems</a>.<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(system_name).has_variable(s));
<a name="l00099"></a>00099   
<a name="l00100"></a>00100   <a class="code" href="structEnsightIO_1_1Scalars.php">Scalars</a> scl;
<a name="l00101"></a>00101   scl.<a class="code" href="structEnsightIO_1_1Scalars.php#a6edf2bb009c5fe9b661c3a297529345e">description</a> = scl_description;
<a name="l00102"></a>00102   scl.scalar_name = s;
<a name="l00103"></a>00103   
<a name="l00104"></a>00104   <a class="code" href="classEnsightIO.php#a86a549664452d5cf88ac02add2873431">_systems_vars_map</a>[system_name].EnsightScalars.push_back(scl);
<a name="l00105"></a>00105 }
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 <span class="comment">// This method must be implemented as it is pure virtual in</span>
<a name="l00110"></a>00110 <span class="comment">// the MeshOutput base class.</span>
<a name="l00111"></a><a class="code" href="classEnsightIO.php#adbbd4999cbccbf3f4377d3e2f721df1f">00111</a> <span class="keywordtype">void</span> <a class="code" href="classEnsightIO.php#adbbd4999cbccbf3f4377d3e2f721df1f">EnsightIO::write</a> (<span class="keyword">const</span> std::string &amp;<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00112"></a>00112 {
<a name="l00113"></a>00113   <a class="code" href="classEnsightIO.php#a26123e820e7ae4454d1d046f783216b7">_ensight_file_name</a> = <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>;
<a name="l00114"></a>00114   this-&gt;<a class="code" href="classEnsightIO.php#adbbd4999cbccbf3f4377d3e2f721df1f">write</a>();
<a name="l00115"></a>00115 }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a><a class="code" href="classEnsightIO.php#a94f853977f6154c241ed9453b5d5e7c4">00119</a> <span class="keywordtype">void</span> <a class="code" href="classEnsightIO.php#adbbd4999cbccbf3f4377d3e2f721df1f">EnsightIO::write</a> (<span class="keyword">const</span> <span class="keywordtype">double</span> time)
<a name="l00120"></a>00120 {
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   this-&gt;<a class="code" href="classEnsightIO.php#ae729673c375a167ac8b652796a0fec8f">write_ascii</a>(time);
<a name="l00123"></a>00123   this-&gt;<a class="code" href="classEnsightIO.php#ae59d22212040f468aee1f459c85c7152">write_case</a>();
<a name="l00124"></a>00124 }
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a><a class="code" href="classEnsightIO.php#ae729673c375a167ac8b652796a0fec8f">00128</a> <span class="keywordtype">void</span> <a class="code" href="classEnsightIO.php#ae729673c375a167ac8b652796a0fec8f">EnsightIO::write_ascii</a> (<span class="keyword">const</span> <span class="keywordtype">double</span> time)
<a name="l00129"></a>00129 {
<a name="l00130"></a>00130   <a class="code" href="classEnsightIO.php#a85be1ca8961e4e91b1022ad8913ca3aa">_time_steps</a>.push_back(time);
<a name="l00131"></a>00131   
<a name="l00132"></a>00132   this-&gt;<a class="code" href="classEnsightIO.php#afa628528bd8d126fad6767c21f782fc2">write_geometry_ascii</a>();
<a name="l00133"></a>00133   this-&gt;<a class="code" href="classEnsightIO.php#aba26c0e6baea7b450366a42c0d53a582">write_solution_ascii</a>();
<a name="l00134"></a>00134 }
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a>00137         
<a name="l00138"></a><a class="code" href="classEnsightIO.php#afa628528bd8d126fad6767c21f782fc2">00138</a> <span class="keywordtype">void</span> <a class="code" href="classEnsightIO.php#afa628528bd8d126fad6767c21f782fc2">EnsightIO::write_geometry_ascii</a>()
<a name="l00139"></a>00139 {
<a name="l00140"></a>00140   <a class="code" href="classOStringStream.php">OStringStream</a> file;
<a name="l00141"></a>00141   file &lt;&lt; <a class="code" href="classEnsightIO.php#a26123e820e7ae4454d1d046f783216b7">_ensight_file_name</a> &lt;&lt; <span class="stringliteral">&quot;.geo&quot;</span>;
<a name="l00142"></a>00142   
<a name="l00143"></a>00143   OSSRealzeroright(file,3,0,<a class="code" href="classEnsightIO.php#a85be1ca8961e4e91b1022ad8913ca3aa">_time_steps</a>.size()-1);
<a name="l00144"></a>00144   
<a name="l00145"></a>00145   FILE* fout = fopen(file.str().c_str(),<span class="stringliteral">&quot;w&quot;</span>);
<a name="l00146"></a>00146   
<a name="l00147"></a>00147   <span class="keywordtype">char</span> buffer[80];
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   fprintf(fout,<span class="stringliteral">&quot;EnSight Gold Geometry File Format\n&quot;</span>);
<a name="l00150"></a>00150   fprintf(fout,<span class="stringliteral">&quot;Generated by \n&quot;</span>);
<a name="l00151"></a>00151   fprintf(fout,<span class="stringliteral">&quot;node id off\n&quot;</span>);
<a name="l00152"></a>00152   fprintf(fout,<span class="stringliteral">&quot;element id given\n&quot;</span>);
<a name="l00153"></a>00153   fprintf(fout,<span class="stringliteral">&quot;part\n&quot;</span>);
<a name="l00154"></a>00154   fprintf(fout,<span class="stringliteral">&quot;%10d\n&quot;</span>,1);
<a name="l00155"></a>00155   fprintf(fout,<span class="stringliteral">&quot;uns-elements\n&quot;</span>);
<a name="l00156"></a>00156   fprintf(fout,<span class="stringliteral">&quot;coordinates\n&quot;</span>);
<a name="l00157"></a>00157   
<a name="l00158"></a>00158   <span class="comment">// mapping between nodal index and your coordinates</span>
<a name="l00159"></a>00159   std::map&lt;int, Point&gt;                     mesh_nodes_map;
<a name="l00160"></a>00160   <span class="keyword">typedef</span> std::map &lt;int, Point&gt;::iterator  mesh_nodes_iterator;
<a name="l00161"></a>00161   <span class="keyword">typedef</span> std::pair&lt;int, Point&gt;            mesh_node_value;
<a name="l00162"></a>00162   
<a name="l00163"></a>00163   <span class="comment">// Mapping between global and local indices</span>
<a name="l00164"></a>00164   std::map &lt;int, int&gt;       ensight_node_index;
<a name="l00165"></a>00165 
<a name="l00166"></a>00166   <span class="comment">// Grouping elements of the same type</span>
<a name="l00167"></a>00167   std::map&lt;ElemType, std::vector&lt;const Elem*&gt; &gt;                    ensight_parts_map;
<a name="l00168"></a>00168   <span class="keyword">typedef</span> std::map&lt;ElemType, std::vector&lt;const Elem*&gt; &gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a>  ensight_parts_iterator; 
<a name="l00169"></a>00169   <span class="keyword">typedef</span> std::pair&lt;ElemType, std::vector&lt;const Elem*&gt; &gt;           ensight_parts_value;   
<a name="l00170"></a>00170         
<a name="l00171"></a>00171   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshOutput.php#af923657f1dcc7c26a973332295d94f13">mesh</a> = <a class="code" href="classMeshOutput.php#af923657f1dcc7c26a973332295d94f13">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00172"></a>00172 
<a name="l00173"></a>00173   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     = mesh.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00174"></a>00174   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = mesh.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>();
<a name="l00175"></a>00175 
<a name="l00176"></a>00176   <span class="keywordflow">for</span> ( ; el != end_el ; ++el) 
<a name="l00177"></a>00177     {
<a name="l00178"></a>00178       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *el;
<a name="l00179"></a>00179       ensight_parts_map[elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>()].push_back(elem);
<a name="l00180"></a>00180     
<a name="l00181"></a>00181       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); i++)
<a name="l00182"></a>00182         mesh_nodes_map[elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(i)] = elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(i);    
<a name="l00183"></a>00183     }
<a name="l00184"></a>00184       
<a name="l00185"></a>00185   <span class="comment">// Write number of local points</span>
<a name="l00186"></a>00186   fprintf(fout,<span class="stringliteral">&quot;%10d\n&quot;</span>,static_cast&lt;int&gt;(mesh_nodes_map.size()));
<a name="l00187"></a>00187 
<a name="l00188"></a>00188   mesh_nodes_iterator           no_it = mesh_nodes_map.begin();
<a name="l00189"></a>00189   <span class="keyword">const</span> mesh_nodes_iterator no_end_it = mesh_nodes_map.end();
<a name="l00190"></a>00190         
<a name="l00191"></a>00191   <span class="comment">// write x</span>
<a name="l00192"></a>00192   <span class="keywordflow">for</span>(<span class="keywordtype">int</span> i = 1; no_it != no_end_it; ++no_it, i++)
<a name="l00193"></a>00193     {
<a name="l00194"></a>00194       <span class="keyword">const</span> mesh_node_value pn = *no_it;
<a name="l00195"></a>00195       fprintf(fout,<span class="stringliteral">&quot;%12.5e\n&quot;</span>,pn.second(0));
<a name="l00196"></a>00196       ensight_node_index[pn.first] = i;
<a name="l00197"></a>00197     }
<a name="l00198"></a>00198 
<a name="l00199"></a>00199   <span class="comment">// write y</span>
<a name="l00200"></a>00200   no_it = mesh_nodes_map.begin();
<a name="l00201"></a>00201   <span class="keywordflow">for</span>(; no_it != no_end_it; ++no_it)
<a name="l00202"></a>00202     {
<a name="l00203"></a>00203       <span class="keyword">const</span> mesh_node_value pn = *no_it;
<a name="l00204"></a>00204       fprintf(fout,<span class="stringliteral">&quot;%12.5e\n&quot;</span>,pn.second(1));
<a name="l00205"></a>00205     }
<a name="l00206"></a>00206   
<a name="l00207"></a>00207   <span class="comment">// write z</span>
<a name="l00208"></a>00208   no_it = mesh_nodes_map.begin();
<a name="l00209"></a>00209   <span class="keywordflow">for</span>(; no_it != no_end_it; ++no_it)
<a name="l00210"></a>00210     {
<a name="l00211"></a>00211       <span class="keyword">const</span> mesh_node_value pn = *no_it;
<a name="l00212"></a>00212       fprintf(fout,<span class="stringliteral">&quot;%12.5e\n&quot;</span>,pn.second(2));
<a name="l00213"></a>00213     }
<a name="l00214"></a>00214 
<a name="l00215"></a>00215   ensight_parts_iterator            parts_it  =  ensight_parts_map.begin();
<a name="l00216"></a>00216   <span class="keyword">const</span> ensight_parts_iterator  end_parts_it  =  ensight_parts_map.end();
<a name="l00217"></a>00217   
<a name="l00218"></a>00218   <span class="comment">// Write parts</span>
<a name="l00219"></a>00219   <span class="keywordflow">for</span> (; parts_it != end_parts_it; ++parts_it)
<a name="l00220"></a>00220     {
<a name="l00221"></a>00221       ensight_parts_value kvp = *parts_it;
<a name="l00222"></a>00222       
<a name="l00223"></a>00223       <span class="comment">// Write element type</span>
<a name="l00224"></a>00224       <a class="code" href="classEnsightIO.php#a5f59cf4ee8e7149cad8c65c7527ada0b">elem_type_to_string</a>(kvp.first,buffer);
<a name="l00225"></a>00225       fprintf(fout,<span class="stringliteral">&quot;\n%s\n&quot;</span>, buffer);
<a name="l00226"></a>00226 
<a name="l00227"></a>00227       std::vector&lt;const Elem*&gt; elem_ref  = kvp.second;
<a name="l00228"></a>00228       
<a name="l00229"></a>00229       <span class="comment">// Write number of element</span>
<a name="l00230"></a>00230       fprintf(fout,<span class="stringliteral">&quot;%10d\n&quot;</span>,static_cast&lt;int&gt;(elem_ref.size()));
<a name="l00231"></a>00231       
<a name="l00232"></a>00232       <span class="comment">// Write element id</span>
<a name="l00233"></a>00233       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; elem_ref.size(); i++)
<a name="l00234"></a>00234         fprintf(fout,<span class="stringliteral">&quot;%10d\n&quot;</span>,elem_ref[i]-&gt;<span class="keywordtype">id</span>());
<a name="l00235"></a>00235       
<a name="l00236"></a>00236       <span class="comment">// Write connectivity</span>
<a name="l00237"></a>00237       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; elem_ref.size(); i++)
<a name="l00238"></a>00238         {
<a name="l00239"></a>00239           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = 0; j &lt; elem_ref[i]-&gt;n_nodes(); j++) {
<a name="l00240"></a>00240             <span class="comment">// tests!</span>
<a name="l00241"></a>00241             <span class="keywordflow">if</span>(kvp.first == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a> &amp;&amp; i==4)
<a name="l00242"></a>00242               <span class="keywordflow">continue</span>;
<a name="l00243"></a>00243             <span class="comment">// tests!</span>
<a name="l00244"></a>00244             <span class="keywordflow">if</span>(kvp.first == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a> &amp;&amp; (i==4    || i ==10 || i == 12 ||
<a name="l00245"></a>00245                                       i == 13 || i ==14 || i == 16 || i == 22))
<a name="l00246"></a>00246               <span class="keywordflow">continue</span>;
<a name="l00247"></a>00247             
<a name="l00248"></a>00248             fprintf(fout,<span class="stringliteral">&quot;%10d&quot;</span>,ensight_node_index[elem_ref[i]-&gt;node(j)]);
<a name="l00249"></a>00249           }
<a name="l00250"></a>00250           fprintf(fout,<span class="stringliteral">&quot;\n&quot;</span>);
<a name="l00251"></a>00251         }      
<a name="l00252"></a>00252     }
<a name="l00253"></a>00253   fclose(fout);
<a name="l00254"></a>00254 }
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 
<a name="l00257"></a>00257 
<a name="l00258"></a>00258 
<a name="l00259"></a>00259 
<a name="l00260"></a><a class="code" href="classEnsightIO.php#ae59d22212040f468aee1f459c85c7152">00260</a> <span class="keywordtype">void</span> <a class="code" href="classEnsightIO.php#ae59d22212040f468aee1f459c85c7152">EnsightIO::write_case</a>()
<a name="l00261"></a>00261 {
<a name="l00262"></a>00262   std::stringstream case_file, geo_file, scl_file;
<a name="l00263"></a>00263   case_file &lt;&lt; <a class="code" href="classEnsightIO.php#a26123e820e7ae4454d1d046f783216b7">_ensight_file_name</a> &lt;&lt; <span class="stringliteral">&quot;.case&quot;</span>;
<a name="l00264"></a>00264   
<a name="l00265"></a>00265   FILE* fout = fopen(case_file.str().c_str(),<span class="stringliteral">&quot;w&quot;</span>);
<a name="l00266"></a>00266   fprintf(fout,<span class="stringliteral">&quot;FORMAT\n&quot;</span>);
<a name="l00267"></a>00267   fprintf(fout,<span class="stringliteral">&quot;type:  ensight gold\n\n&quot;</span>);
<a name="l00268"></a>00268   fprintf(fout,<span class="stringliteral">&quot;GEOMETRY\n&quot;</span>);
<a name="l00269"></a>00269   
<a name="l00270"></a>00270   geo_file &lt;&lt; _ensight_file_name &lt;&lt; <span class="stringliteral">&quot;.geo&quot;</span>;
<a name="l00271"></a>00271   
<a name="l00272"></a>00272   
<a name="l00273"></a>00273   fprintf(fout,<span class="stringliteral">&quot;model:            1     %s***\n&quot;</span>,geo_file.str().c_str());
<a name="l00274"></a>00274       
<a name="l00275"></a>00275   <a class="code" href="classEnsightIO.php#a5e7dc75cddfa9b52d904cd2d34468872">SystemsVarsMapIterator</a>       sys      = <a class="code" href="classEnsightIO.php#a86a549664452d5cf88ac02add2873431">_systems_vars_map</a>.begin();
<a name="l00276"></a>00276   <span class="keyword">const</span> <a class="code" href="classEnsightIO.php#a5e7dc75cddfa9b52d904cd2d34468872">SystemsVarsMapIterator</a> sys_end  = <a class="code" href="classEnsightIO.php#a86a549664452d5cf88ac02add2873431">_systems_vars_map</a>.end();
<a name="l00277"></a>00277   
<a name="l00278"></a>00278   <span class="comment">// Write Variable per node section</span>
<a name="l00279"></a>00279   <span class="keywordflow">if</span> ( sys != sys_end )
<a name="l00280"></a>00280     fprintf(fout,<span class="stringliteral">&quot;\n\nVARIABLE\n&quot;</span>);
<a name="l00281"></a>00281   
<a name="l00282"></a>00282   <span class="keywordflow">for</span> (; sys != sys_end; ++sys)
<a name="l00283"></a>00283     {
<a name="l00284"></a>00284       <a class="code" href="classEnsightIO.php#a3da579f7f3b36a26f8523a477de6d6a2">SystemsVarsValue</a> value = *sys;
<a name="l00285"></a>00285       
<a name="l00286"></a>00286       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i &lt; value.second.EnsightScalars.size(); i++)
<a name="l00287"></a>00287         {
<a name="l00288"></a>00288           std::stringstream scl_file;
<a name="l00289"></a>00289           <a class="code" href="structEnsightIO_1_1Scalars.php">Scalars</a> scalar = value.second.EnsightScalars[i];
<a name="l00290"></a>00290           scl_file &lt;&lt; _ensight_file_name
<a name="l00291"></a>00291                    &lt;&lt; <span class="stringliteral">&quot;_&quot;</span> &lt;&lt; scalar.<a class="code" href="structEnsightIO_1_1Scalars.php#aed3b5e7fb5e9bd08f326cbe471425c02">scalar_name</a>
<a name="l00292"></a>00292                    &lt;&lt; <span class="stringliteral">&quot;.scl&quot;</span>;
<a name="l00293"></a>00293           
<a name="l00294"></a>00294           fprintf(fout,<span class="stringliteral">&quot;scalar per node:   1  %s %s***\n&quot;</span>,scalar.<a class="code" href="structEnsightIO_1_1Scalars.php#a6edf2bb009c5fe9b661c3a297529345e">description</a>.c_str(), scl_file.str().c_str());    
<a name="l00295"></a>00295         }
<a name="l00296"></a>00296       
<a name="l00297"></a>00297       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i &lt; value.second.EnsightVectors.size(); i++) 
<a name="l00298"></a>00298         {
<a name="l00299"></a>00299           std::stringstream vec_file;
<a name="l00300"></a>00300           <a class="code" href="structEnsightIO_1_1Vectors.php">Vectors</a> vec = value.second.EnsightVectors[i];
<a name="l00301"></a>00301           vec_file&lt;&lt;_ensight_file_name&lt;&lt;<span class="stringliteral">&quot;_&quot;</span>&lt;&lt;vec.<a class="code" href="structEnsightIO_1_1Vectors.php#a17f8f3b6b2332d26e0e394063ba40e50">description</a>&lt;&lt;<span class="stringliteral">&quot;.vec&quot;</span>;
<a name="l00302"></a>00302         
<a name="l00303"></a>00303           fprintf(fout,<span class="stringliteral">&quot;vector per node:      1    %s %s***\n&quot;</span>,vec.<a class="code" href="structEnsightIO_1_1Vectors.php#a17f8f3b6b2332d26e0e394063ba40e50">description</a>.c_str(), vec_file.str().c_str());          
<a name="l00304"></a>00304         }
<a name="l00305"></a>00305       
<a name="l00306"></a>00306       <span class="comment">// Write time step section</span>
<a name="l00307"></a>00307       <span class="keywordflow">if</span>( <a class="code" href="classEnsightIO.php#a85be1ca8961e4e91b1022ad8913ca3aa">_time_steps</a>.size() != 0) 
<a name="l00308"></a>00308         {
<a name="l00309"></a>00309           fprintf(fout,<span class="stringliteral">&quot;\n\nTIME\n&quot;</span>);
<a name="l00310"></a>00310           fprintf(fout,<span class="stringliteral">&quot;time set:             1\n&quot;</span>);
<a name="l00311"></a>00311           fprintf(fout,<span class="stringliteral">&quot;number of steps:   %10d\n&quot;</span>, static_cast&lt;int&gt;(<a class="code" href="classEnsightIO.php#a85be1ca8961e4e91b1022ad8913ca3aa">_time_steps</a>.size()));
<a name="l00312"></a>00312           fprintf(fout,<span class="stringliteral">&quot;filename start number:   %10d\n&quot;</span>, 0);
<a name="l00313"></a>00313           fprintf(fout,<span class="stringliteral">&quot;filename increment:  %10d\n&quot;</span>, 1);
<a name="l00314"></a>00314           fprintf(fout,<span class="stringliteral">&quot;time values:\n&quot;</span>);
<a name="l00315"></a>00315           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; <a class="code" href="classEnsightIO.php#a85be1ca8961e4e91b1022ad8913ca3aa">_time_steps</a>.size(); i++)
<a name="l00316"></a>00316             fprintf(fout,<span class="stringliteral">&quot;%12.5e\n&quot;</span>, <a class="code" href="classEnsightIO.php#a85be1ca8961e4e91b1022ad8913ca3aa">_time_steps</a>[i]);     
<a name="l00317"></a>00317         }
<a name="l00318"></a>00318     }
<a name="l00319"></a>00319   fclose(fout);
<a name="l00320"></a>00320 }
<a name="l00321"></a>00321 
<a name="l00322"></a>00322 
<a name="l00323"></a>00323 <span class="comment">// Write scalar and vector solution</span>
<a name="l00324"></a><a class="code" href="classEnsightIO.php#aba26c0e6baea7b450366a42c0d53a582">00324</a> <span class="keywordtype">void</span> <a class="code" href="classEnsightIO.php#aba26c0e6baea7b450366a42c0d53a582">EnsightIO::write_solution_ascii</a>()
<a name="l00325"></a>00325 {
<a name="l00326"></a>00326   
<a name="l00327"></a>00327   <a class="code" href="classEnsightIO.php#a5e7dc75cddfa9b52d904cd2d34468872">SystemsVarsMapIterator</a>       sys     = <a class="code" href="classEnsightIO.php#a86a549664452d5cf88ac02add2873431">_systems_vars_map</a>.begin();
<a name="l00328"></a>00328   <span class="keyword">const</span> <a class="code" href="classEnsightIO.php#a5e7dc75cddfa9b52d904cd2d34468872">SystemsVarsMapIterator</a> sys_end = <a class="code" href="classEnsightIO.php#a86a549664452d5cf88ac02add2873431">_systems_vars_map</a>.end();
<a name="l00329"></a>00329   
<a name="l00330"></a>00330   <span class="keywordflow">for</span> (; sys != sys_end; ++sys)
<a name="l00331"></a>00331     {
<a name="l00332"></a>00332       <a class="code" href="classEnsightIO.php#a3da579f7f3b36a26f8523a477de6d6a2">SystemsVarsValue</a> value = *sys;
<a name="l00333"></a>00333       
<a name="l00334"></a>00334       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; value.second.EnsightScalars.size(); i++) 
<a name="l00335"></a>00335         this-&gt;<a class="code" href="classEnsightIO.php#abaefc8e0e9b51686af6dd4150add59a1">write_scalar_ascii</a>(value.first,
<a name="l00336"></a>00336                                  value.second.EnsightScalars[i].scalar_name);   
<a name="l00337"></a>00337       
<a name="l00338"></a>00338       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; value.second.EnsightVectors.size(); i++)
<a name="l00339"></a>00339         this-&gt;<a class="code" href="classEnsightIO.php#a1a0d6a6e5f5f0c4aebe3fb51489049cc">write_vector_ascii</a>(value.first, 
<a name="l00340"></a>00340                                  value.second.EnsightVectors[i].components,
<a name="l00341"></a>00341                                  value.second.EnsightVectors[i].description);
<a name="l00342"></a>00342     }
<a name="l00343"></a>00343 }
<a name="l00344"></a>00344 
<a name="l00345"></a>00345 
<a name="l00346"></a><a class="code" href="classEnsightIO.php#abaefc8e0e9b51686af6dd4150add59a1">00346</a> <span class="keywordtype">void</span> <a class="code" href="classEnsightIO.php#abaefc8e0e9b51686af6dd4150add59a1">EnsightIO::write_scalar_ascii</a>(<span class="keyword">const</span> std::string &amp;sys, <span class="keyword">const</span> std::string &amp;var_name)
<a name="l00347"></a>00347 {
<a name="l00348"></a>00348   <a class="code" href="classOStringStream.php">OStringStream</a> scl_file;
<a name="l00349"></a>00349   scl_file &lt;&lt; <a class="code" href="classEnsightIO.php#a26123e820e7ae4454d1d046f783216b7">_ensight_file_name</a> &lt;&lt; <span class="stringliteral">&quot;_&quot;</span> &lt;&lt; var_name &lt;&lt; <span class="stringliteral">&quot;.scl&quot;</span>;
<a name="l00350"></a>00350   OSSRealzeroright(scl_file,3,0,<a class="code" href="classEnsightIO.php#a85be1ca8961e4e91b1022ad8913ca3aa">_time_steps</a>.size()-1);
<a name="l00351"></a>00351   
<a name="l00352"></a>00352   FILE * fout = fopen(scl_file.str().c_str(),<span class="stringliteral">&quot;w&quot;</span>);
<a name="l00353"></a>00353   
<a name="l00354"></a>00354   fprintf(fout,<span class="stringliteral">&quot;Per node scalar value\n&quot;</span>);
<a name="l00355"></a>00355   fprintf(fout,<span class="stringliteral">&quot;part\n&quot;</span>);
<a name="l00356"></a>00356   fprintf(fout,<span class="stringliteral">&quot;%10d\n&quot;</span>,1);
<a name="l00357"></a>00357   fprintf(fout,<span class="stringliteral">&quot;coordinates\n&quot;</span>);
<a name="l00358"></a>00358   
<a name="l00359"></a>00359   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshOutput.php#af923657f1dcc7c26a973332295d94f13">mesh</a> = <a class="code" href="classMeshOutput.php#af923657f1dcc7c26a973332295d94f13">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00360"></a>00360 
<a name="l00361"></a>00361   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = mesh.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>();
<a name="l00362"></a>00362 
<a name="l00363"></a>00363   <span class="keyword">const</span> <a class="code" href="classSystem.php">System</a> &amp;system = <a class="code" href="classEnsightIO.php#afa6e269c0a2821c2efd8a4d8ae3be3fb">_equation_systems</a>.<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(sys);
<a name="l00364"></a>00364                 
<a name="l00365"></a>00365   <span class="keyword">const</span> <a class="code" href="classDofMap.php">DofMap</a>&amp; dof_map = system.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>();
<a name="l00366"></a>00366   
<a name="l00367"></a>00367         
<a name="l00368"></a>00368   <span class="keywordtype">int</span> var = system.<a class="code" href="classSystem.php#ace6000ea1d0dc7e3635fe98761f95838">variable_number</a>(var_name);
<a name="l00369"></a>00369 
<a name="l00370"></a>00370 
<a name="l00371"></a>00371   std::vector&lt;unsigned int&gt; dof_indices;
<a name="l00372"></a>00372   std::vector&lt;unsigned int&gt; dof_indices_scl;
<a name="l00373"></a>00373 
<a name="l00374"></a>00374   <span class="comment">// Now we will loop over all the elements in the mesh.</span>
<a name="l00375"></a>00375 
<a name="l00376"></a>00376   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     = mesh.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00377"></a>00377   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = mesh.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>();
<a name="l00378"></a>00378                 
<a name="l00379"></a>00379   <span class="keyword">typedef</span> std::map&lt;int,Real&gt; map_local_soln;
<a name="l00380"></a>00380   <span class="keyword">typedef</span> map_local_soln::iterator local_soln_iterator;
<a name="l00381"></a>00381 
<a name="l00382"></a>00382   map_local_soln local_soln;
<a name="l00383"></a>00383     
<a name="l00384"></a>00384   std::vector&lt;Number&gt;       elem_soln;
<a name="l00385"></a>00385   std::vector&lt;Number&gt;       nodal_soln;
<a name="l00386"></a>00386         
<a name="l00387"></a>00387   <span class="keywordflow">for</span> ( ; el != end_el ; ++el){
<a name="l00388"></a>00388   
<a name="l00389"></a>00389     <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *el;
<a name="l00390"></a>00390 
<a name="l00391"></a>00391     <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_type    = system.<a class="code" href="classSystem.php#aa917dd59a348a46e9adab63d9767460f">variable_type</a>(var);
<a name="l00392"></a>00392 
<a name="l00393"></a>00393     dof_map.<a class="code" href="classDofMap.php#afc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (elem, dof_indices);
<a name="l00394"></a>00394     dof_map.<a class="code" href="classDofMap.php#afc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (elem, dof_indices_scl, var);
<a name="l00395"></a>00395 
<a name="l00396"></a>00396     elem_soln.resize(dof_indices_scl.size());
<a name="l00397"></a>00397                                 
<a name="l00398"></a>00398     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; dof_indices_scl.size(); i++)
<a name="l00399"></a>00399       elem_soln[i] = system.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(dof_indices_scl[i]);
<a name="l00400"></a>00400                         
<a name="l00401"></a>00401     <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FEInterface::nodal_soln</a> (dim,fe_type, elem, elem_soln, nodal_soln);
<a name="l00402"></a>00402                                                 
<a name="l00403"></a>00403     libmesh_assert (nodal_soln.size() == elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>());
<a name="l00404"></a>00404                    
<a name="l00405"></a>00405 <span class="preprocessor">#ifdef LIBMESH_ENABLE_COMPLEX</span>
<a name="l00406"></a>00406 <span class="preprocessor"></span>    std::cerr &lt;&lt; <span class="stringliteral">&quot;Complex-valued Ensight output not yet supported&quot;</span> &lt;&lt; std::endl;
<a name="l00407"></a>00407     libmesh_not_implemented()
<a name="l00408"></a>00408 <span class="preprocessor">#endif</span>
<a name="l00409"></a>00409 <span class="preprocessor"></span>                   
<a name="l00410"></a>00410     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); n++)
<a name="l00411"></a>00411       local_soln[elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n)] = <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>(nodal_soln[n]);
<a name="l00412"></a>00412  
<a name="l00413"></a>00413   }
<a name="l00414"></a>00414 
<a name="l00415"></a>00415   local_soln_iterator sol = local_soln.begin();
<a name="l00416"></a>00416   <span class="keyword">const</span> local_soln_iterator sol_end = local_soln.end();
<a name="l00417"></a>00417   <span class="keywordflow">for</span>(; sol != sol_end; ++sol)
<a name="l00418"></a>00418     fprintf(fout,<span class="stringliteral">&quot;%12.5e\n&quot;</span>,(*sol).second);
<a name="l00419"></a>00419         
<a name="l00420"></a>00420   fclose(fout);
<a name="l00421"></a>00421                 
<a name="l00422"></a>00422 }
<a name="l00423"></a>00423 
<a name="l00424"></a>00424 
<a name="l00425"></a><a class="code" href="classEnsightIO.php#a1a0d6a6e5f5f0c4aebe3fb51489049cc">00425</a> <span class="keywordtype">void</span> <a class="code" href="classEnsightIO.php#a1a0d6a6e5f5f0c4aebe3fb51489049cc">EnsightIO::write_vector_ascii</a>(<span class="keyword">const</span> std::string &amp;sys, <span class="keyword">const</span> std::vector&lt;std::string&gt; &amp;vec, <span class="keyword">const</span> std::string &amp;var_name)
<a name="l00426"></a>00426 {
<a name="l00427"></a>00427   <a class="code" href="classOStringStream.php">OStringStream</a> vec_file;
<a name="l00428"></a>00428   vec_file&lt;&lt;<a class="code" href="classEnsightIO.php#a26123e820e7ae4454d1d046f783216b7">_ensight_file_name</a>&lt;&lt;<span class="stringliteral">&quot;_&quot;</span>&lt;&lt;var_name&lt;&lt;<span class="stringliteral">&quot;.vec&quot;</span>;
<a name="l00429"></a>00429   OSSRealzeroright(vec_file,3,0,<a class="code" href="classEnsightIO.php#a85be1ca8961e4e91b1022ad8913ca3aa">_time_steps</a>.size()-1);
<a name="l00430"></a>00430                         
<a name="l00431"></a>00431   FILE * fout = fopen(vec_file.str().c_str(),<span class="stringliteral">&quot;w&quot;</span>);
<a name="l00432"></a>00432   fprintf(fout,<span class="stringliteral">&quot;Per vector per value\n&quot;</span>);
<a name="l00433"></a>00433   fprintf(fout,<span class="stringliteral">&quot;part\n&quot;</span>);
<a name="l00434"></a>00434   fprintf(fout,<span class="stringliteral">&quot;%10d\n&quot;</span>,1);
<a name="l00435"></a>00435   fprintf(fout,<span class="stringliteral">&quot;coordinates\n&quot;</span>);
<a name="l00436"></a>00436   
<a name="l00437"></a>00437   <span class="comment">// Get a constant reference to the mesh object.</span>
<a name="l00438"></a>00438   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshOutput.php#af923657f1dcc7c26a973332295d94f13">mesh</a> = <a class="code" href="classMeshOutput.php#af923657f1dcc7c26a973332295d94f13">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00439"></a>00439 
<a name="l00440"></a>00440   <span class="comment">// The dimension that we are running</span>
<a name="l00441"></a>00441   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = mesh.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>();
<a name="l00442"></a>00442 
<a name="l00443"></a>00443   <span class="keyword">const</span> <a class="code" href="classSystem.php">System</a> &amp;system = <a class="code" href="classEnsightIO.php#afa6e269c0a2821c2efd8a4d8ae3be3fb">_equation_systems</a>.<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(sys);
<a name="l00444"></a>00444                 
<a name="l00445"></a>00445   <span class="keyword">const</span> <a class="code" href="classDofMap.php">DofMap</a>&amp; dof_map = system.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>();
<a name="l00446"></a>00446         
<a name="l00447"></a>00447   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> u_var = system.<a class="code" href="classSystem.php#ace6000ea1d0dc7e3635fe98761f95838">variable_number</a>(vec[0]);
<a name="l00448"></a>00448   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v_var = system.<a class="code" href="classSystem.php#ace6000ea1d0dc7e3635fe98761f95838">variable_number</a>(vec[1]);
<a name="l00449"></a>00449   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> w_var = (dim==3) ? system.<a class="code" href="classSystem.php#ace6000ea1d0dc7e3635fe98761f95838">variable_number</a>(vec[2]) : 0;
<a name="l00450"></a>00450         
<a name="l00451"></a>00451   std::vector&lt;unsigned int&gt; dof_indices;
<a name="l00452"></a>00452   std::vector&lt;unsigned int&gt; dof_indices_u;
<a name="l00453"></a>00453   std::vector&lt;unsigned int&gt; dof_indices_v;
<a name="l00454"></a>00454   std::vector&lt;unsigned int&gt; dof_indices_w;
<a name="l00455"></a>00455                 
<a name="l00456"></a>00456   <span class="comment">// Now we will loop over all the elements in the mesh.</span>
<a name="l00457"></a>00457   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     = mesh.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00458"></a>00458   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = mesh.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>();
<a name="l00459"></a>00459                
<a name="l00460"></a>00460   <span class="keyword">typedef</span> std::map&lt;int,std::vector&lt;Real&gt; &gt; map_local_soln;
<a name="l00461"></a>00461   <span class="keyword">typedef</span> map_local_soln::iterator  local_soln_iterator;
<a name="l00462"></a>00462 
<a name="l00463"></a>00463   map_local_soln local_soln;
<a name="l00464"></a>00464         
<a name="l00465"></a>00465   <span class="keywordflow">for</span> ( ; el != end_el ; ++el){
<a name="l00466"></a>00466                 
<a name="l00467"></a>00467     <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *el;
<a name="l00468"></a>00468                                 
<a name="l00469"></a>00469     <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_type    = system.<a class="code" href="classSystem.php#aa917dd59a348a46e9adab63d9767460f">variable_type</a>(u_var);
<a name="l00470"></a>00470               
<a name="l00471"></a>00471     dof_map.<a class="code" href="classDofMap.php#afc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (elem, dof_indices);
<a name="l00472"></a>00472     dof_map.<a class="code" href="classDofMap.php#afc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (elem, dof_indices_u,u_var);
<a name="l00473"></a>00473     dof_map.<a class="code" href="classDofMap.php#afc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (elem, dof_indices_v,v_var);
<a name="l00474"></a>00474     <span class="keywordflow">if</span>(dim==3)  dof_map.<a class="code" href="classDofMap.php#afc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (elem, dof_indices,w_var);
<a name="l00475"></a>00475 
<a name="l00476"></a>00476 
<a name="l00477"></a>00477     std::vector&lt;Number&gt;       elem_soln_u;
<a name="l00478"></a>00478     std::vector&lt;Number&gt;       elem_soln_v;
<a name="l00479"></a>00479     std::vector&lt;Number&gt;       elem_soln_w;
<a name="l00480"></a>00480 
<a name="l00481"></a>00481     std::vector&lt;Number&gt;       nodal_soln_u;
<a name="l00482"></a>00482     std::vector&lt;Number&gt;       nodal_soln_v;
<a name="l00483"></a>00483     std::vector&lt;Number&gt;       nodal_soln_w;
<a name="l00484"></a>00484                 
<a name="l00485"></a>00485     elem_soln_u.resize(dof_indices_u.size());
<a name="l00486"></a>00486     elem_soln_v.resize(dof_indices_v.size());
<a name="l00487"></a>00487     <span class="keywordflow">if</span>(dim == 3) elem_soln_w.resize(dof_indices_w.size());
<a name="l00488"></a>00488 
<a name="l00489"></a>00489     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; dof_indices_u.size(); i++)
<a name="l00490"></a>00490       {
<a name="l00491"></a>00491         elem_soln_u[i] = system.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(dof_indices_u[i]);
<a name="l00492"></a>00492         elem_soln_v[i] = system.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(dof_indices_v[i]);
<a name="l00493"></a>00493         <span class="keywordflow">if</span>(dim==3) elem_soln_w[i] = system.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(dof_indices_w[i]);
<a name="l00494"></a>00494       }                
<a name="l00495"></a>00495 
<a name="l00496"></a>00496     <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FEInterface::nodal_soln</a> (dim,fe_type,elem,elem_soln_u,nodal_soln_u);
<a name="l00497"></a>00497     <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FEInterface::nodal_soln</a> (dim,fe_type,elem,elem_soln_v,nodal_soln_v);
<a name="l00498"></a>00498     <span class="keywordflow">if</span>(dim == 3) <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FEInterface::nodal_soln</a> (dim,fe_type,elem,elem_soln_w,nodal_soln_w);
<a name="l00499"></a>00499     
<a name="l00500"></a>00500                  
<a name="l00501"></a>00501     libmesh_assert (nodal_soln_u.size() == elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>());
<a name="l00502"></a>00502     libmesh_assert (nodal_soln_v.size() == elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>());
<a name="l00503"></a>00503                   
<a name="l00504"></a>00504 <span class="preprocessor">#ifdef LIBMESH_ENABLE_COMPLEX</span>
<a name="l00505"></a>00505 <span class="preprocessor"></span>    std::cerr &lt;&lt; <span class="stringliteral">&quot;Complex-valued Ensight output not yet supported&quot;</span> &lt;&lt; std::endl;
<a name="l00506"></a>00506     libmesh_not_implemented()
<a name="l00507"></a>00507 <span class="preprocessor">#endif</span>
<a name="l00508"></a>00508 <span class="preprocessor"></span>                   
<a name="l00509"></a>00509     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); n++)
<a name="l00510"></a>00510       {
<a name="l00511"></a>00511         std::vector&lt;Real&gt; vec(3);
<a name="l00512"></a>00512         vec[0]= <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>(nodal_soln_u[n]);
<a name="l00513"></a>00513         vec[1]= <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>(nodal_soln_v[n]);
<a name="l00514"></a>00514         vec[2]=0.0;
<a name="l00515"></a>00515         <span class="keywordflow">if</span>(dim==3) vec[2]= <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>(nodal_soln_w[n]);
<a name="l00516"></a>00516         local_soln[elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n)] = vec;        
<a name="l00517"></a>00517       }
<a name="l00518"></a>00518 
<a name="l00519"></a>00519   }
<a name="l00520"></a>00520         
<a name="l00521"></a>00521   local_soln_iterator sol = local_soln.begin();
<a name="l00522"></a>00522   <span class="keyword">const</span> local_soln_iterator sol_end = local_soln.end();
<a name="l00523"></a>00523         
<a name="l00524"></a>00524   <span class="keywordflow">for</span>(; sol != sol_end; ++sol)
<a name="l00525"></a>00525     fprintf(fout,<span class="stringliteral">&quot;%12.5e\n&quot;</span>,(*sol).second[0]);
<a name="l00526"></a>00526   sol = local_soln.begin();
<a name="l00527"></a>00527   <span class="keywordflow">for</span>(; sol != sol_end; ++sol)
<a name="l00528"></a>00528     fprintf(fout,<span class="stringliteral">&quot;%12.5e\n&quot;</span>,(*sol).second[1]);
<a name="l00529"></a>00529   sol = local_soln.begin();
<a name="l00530"></a>00530   <span class="keywordflow">for</span>(; sol != sol_end; ++sol)
<a name="l00531"></a>00531     fprintf(fout,<span class="stringliteral">&quot;%12.5e\n&quot;</span>,(*sol).second[2]);
<a name="l00532"></a>00532                 
<a name="l00533"></a>00533   fclose(fout);
<a name="l00534"></a>00534         
<a name="l00535"></a>00535 }
<a name="l00536"></a>00536 
<a name="l00537"></a><a class="code" href="classEnsightIO.php#a5f59cf4ee8e7149cad8c65c7527ada0b">00537</a> <span class="keywordtype">void</span> <a class="code" href="classEnsightIO.php#a5f59cf4ee8e7149cad8c65c7527ada0b">EnsightIO::elem_type_to_string</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type, <span class="keywordtype">char</span>* buffer)
<a name="l00538"></a>00538 {
<a name="l00539"></a>00539   <span class="keywordflow">switch</span>(type){
<a name="l00540"></a>00540   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00541"></a>00541     std::strcpy(buffer,<span class="stringliteral">&quot;bar2&quot;</span>);
<a name="l00542"></a>00542     <span class="keywordflow">break</span>;
<a name="l00543"></a>00543   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00544"></a>00544     std::strcpy(buffer,<span class="stringliteral">&quot;bar3&quot;</span>);
<a name="l00545"></a>00545     <span class="keywordflow">break</span>;
<a name="l00546"></a>00546   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l00547"></a>00547     std::strcpy(buffer,<span class="stringliteral">&quot;quad4&quot;</span>);
<a name="l00548"></a>00548     <span class="keywordflow">break</span>;
<a name="l00549"></a>00549   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00550"></a>00550     std::strcpy(buffer,<span class="stringliteral">&quot;quad8&quot;</span>);
<a name="l00551"></a>00551     <span class="keywordflow">break</span>;
<a name="l00552"></a>00552   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00553"></a>00553     std::cout&lt;&lt;<span class="stringliteral">&quot;QUAD9: element not supported!&quot;</span>&lt;&lt;std::endl;
<a name="l00554"></a>00554     libmesh_error();
<a name="l00555"></a>00555     <span class="keywordflow">break</span>;
<a name="l00556"></a>00556                 
<a name="l00557"></a>00557   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00558"></a>00558     std::strcpy(buffer,<span class="stringliteral">&quot;tria3&quot;</span>);
<a name="l00559"></a>00559     <span class="keywordflow">break</span>;
<a name="l00560"></a>00560   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00561"></a>00561     std::strcpy(buffer,<span class="stringliteral">&quot;tria6&quot;</span>);
<a name="l00562"></a>00562     <span class="keywordflow">break</span>;
<a name="l00563"></a>00563   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l00564"></a>00564     std::strcpy(buffer,<span class="stringliteral">&quot;tetra4&quot;</span>);
<a name="l00565"></a>00565     <span class="keywordflow">break</span>;
<a name="l00566"></a>00566   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l00567"></a>00567     std::strcpy(buffer,<span class="stringliteral">&quot;tetra10&quot;</span>);
<a name="l00568"></a>00568     <span class="keywordflow">break</span>;
<a name="l00569"></a>00569   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00570"></a>00570     std::strcpy(buffer,<span class="stringliteral">&quot;hexa8&quot;</span>);
<a name="l00571"></a>00571     <span class="keywordflow">break</span>;
<a name="l00572"></a>00572   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00573"></a>00573     std::strcpy(buffer,<span class="stringliteral">&quot;hexa20&quot;</span>);
<a name="l00574"></a>00574     <span class="keywordflow">break</span>;
<a name="l00575"></a>00575   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00576"></a>00576     std::cout&lt;&lt;<span class="stringliteral">&quot;HEX27: element not supported!&quot;</span>&lt;&lt;std::endl;
<a name="l00577"></a>00577     libmesh_error();
<a name="l00578"></a>00578     <span class="keywordflow">break</span>;
<a name="l00579"></a>00579   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l00580"></a>00580     std::strcpy(buffer,<span class="stringliteral">&quot;pyramid5&quot;</span>);
<a name="l00581"></a>00581     <span class="keywordflow">break</span>;
<a name="l00582"></a>00582   <span class="keywordflow">default</span>:
<a name="l00583"></a>00583     <span class="keywordflow">break</span>;
<a name="l00584"></a>00584   }
<a name="l00585"></a>00585 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
