<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>ensight_io.h</h1>  </div>
</div>
<div class="contents">
<a href="ensight__io_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: ensight_io.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __ensight_io_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __ensight_io_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// The c++ include </span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// libMesh includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;libmesh.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;equation_systems.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;linear_implicit_system.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="mesh_8h.php">mesh.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="mesh__output_8h.php">mesh_output.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00042"></a><a class="code" href="classEnsightIO.php">00042</a> <span class="keyword">class </span><a class="code" href="classEnsightIO.php">EnsightIO</a> : <span class="keyword">public</span> <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;MeshBase&gt;
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044  <span class="keyword">public</span>:
<a name="l00045"></a>00045   
<a name="l00049"></a>00049   <a class="code" href="classEnsightIO.php#a59a3ff309de3630f9f66627ef9e0ed27">EnsightIO</a> (<span class="keyword">const</span> std::string &amp;filename, <span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a> &amp;eq);
<a name="l00050"></a>00050   
<a name="l00051"></a>00051   <a class="code" href="classEnsightIO.php#a81f515ab95ef956e90dd4e01bb86991c">~EnsightIO</a> ();
<a name="l00052"></a>00052 
<a name="l00057"></a>00057   <span class="keywordtype">void</span> <a class="code" href="classEnsightIO.php#a12b0bb2ce4bc5b38db6655045ff4db24">add_vector</a> (<span class="keyword">const</span> std::string &amp;system, <span class="keyword">const</span> std::string &amp;vec_description, 
<a name="l00058"></a>00058                    <span class="keyword">const</span> std::string &amp;u, <span class="keyword">const</span> std::string &amp;v);
<a name="l00059"></a>00059   
<a name="l00063"></a>00063   <span class="keywordtype">void</span> <a class="code" href="classEnsightIO.php#a12b0bb2ce4bc5b38db6655045ff4db24">add_vector</a> (<span class="keyword">const</span> std::string &amp;system, <span class="keyword">const</span> std::string &amp;vec_description, 
<a name="l00064"></a>00064                    <span class="keyword">const</span> std::string &amp;u, <span class="keyword">const</span> std::string &amp;v, <span class="keyword">const</span> std::string &amp;w);
<a name="l00065"></a>00065   
<a name="l00069"></a>00069   <span class="keywordtype">void</span> <a class="code" href="classEnsightIO.php#a5981bac9c3cf066d0ebeafa3e94bb69a">add_scalar</a> (<span class="keyword">const</span> std::string &amp;system, <span class="keyword">const</span> std::string &amp;scalar_description, 
<a name="l00070"></a>00070                    <span class="keyword">const</span> std::string &amp;s);               
<a name="l00071"></a>00071                 
<a name="l00075"></a>00075   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEnsightIO.php#adbbd4999cbccbf3f4377d3e2f721df1f">write</a> (<span class="keyword">const</span> std::string &amp;<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>);
<a name="l00076"></a>00076 
<a name="l00080"></a>00080   <span class="keywordtype">void</span> <a class="code" href="classEnsightIO.php#adbbd4999cbccbf3f4377d3e2f721df1f">write</a> (<span class="keyword">const</span> <span class="keywordtype">double</span> time = 0);
<a name="l00081"></a>00081   
<a name="l00082"></a>00082   <span class="keywordtype">bool</span>&amp; <a class="code" href="classEnsightIO.php#a221983f4a2388b0cd5a98f3985281b37">has_mesh_refinement</a>();
<a name="l00083"></a>00083                         
<a name="l00084"></a>00084 <span class="keyword">private</span>:
<a name="l00085"></a>00085 
<a name="l00086"></a>00086   <span class="comment">// Define aux. structures</span>
<a name="l00087"></a>00087   
<a name="l00088"></a>00088   <span class="comment">// Represents the vectors that are used by the EnsightIO</span>
<a name="l00089"></a><a class="code" href="structEnsightIO_1_1Vectors.php">00089</a>   <span class="keyword">struct </span><a class="code" href="structEnsightIO_1_1Vectors.php">Vectors</a>
<a name="l00090"></a>00090   {
<a name="l00091"></a><a class="code" href="structEnsightIO_1_1Vectors.php#a17f8f3b6b2332d26e0e394063ba40e50">00091</a>     std::string <a class="code" href="structEnsightIO_1_1Vectors.php#a17f8f3b6b2332d26e0e394063ba40e50">description</a>;          
<a name="l00092"></a><a class="code" href="structEnsightIO_1_1Vectors.php#aca03cbc810f17ed4e0d43e3690eccc7b">00092</a>     std::vector&lt;std::string&gt; <a class="code" href="structEnsightIO_1_1Vectors.php#aca03cbc810f17ed4e0d43e3690eccc7b">components</a>;
<a name="l00093"></a>00093   };
<a name="l00094"></a>00094   
<a name="l00095"></a>00095   <span class="comment">// Represents the scalars </span>
<a name="l00096"></a><a class="code" href="structEnsightIO_1_1Scalars.php">00096</a>   <span class="keyword">struct </span><a class="code" href="structEnsightIO_1_1Scalars.php">Scalars</a> 
<a name="l00097"></a>00097   {
<a name="l00098"></a><a class="code" href="structEnsightIO_1_1Scalars.php#aed3b5e7fb5e9bd08f326cbe471425c02">00098</a>     std::string <a class="code" href="structEnsightIO_1_1Scalars.php#aed3b5e7fb5e9bd08f326cbe471425c02">scalar_name</a>;
<a name="l00099"></a><a class="code" href="structEnsightIO_1_1Scalars.php#a6edf2bb009c5fe9b661c3a297529345e">00099</a>     std::string <a class="code" href="structEnsightIO_1_1Scalars.php#a6edf2bb009c5fe9b661c3a297529345e">description</a>;
<a name="l00100"></a>00100   };
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   <span class="comment">// Store the variables of system</span>
<a name="l00103"></a><a class="code" href="structEnsightIO_1_1SystemVars.php">00103</a>   <span class="keyword">struct </span><a class="code" href="structEnsightIO_1_1SystemVars.php">SystemVars</a> 
<a name="l00104"></a>00104   {
<a name="l00105"></a><a class="code" href="structEnsightIO_1_1SystemVars.php#a2ae4fc3c4c3759f19ce28d5d59570ac1">00105</a>     std::vector&lt;Vectors&gt; <a class="code" href="structEnsightIO_1_1SystemVars.php#a2ae4fc3c4c3759f19ce28d5d59570ac1">EnsightVectors</a>;
<a name="l00106"></a><a class="code" href="structEnsightIO_1_1SystemVars.php#a0a231d53f39a5149f9d0faa2b04fc7d0">00106</a>     std::vector&lt;Scalars&gt; <a class="code" href="structEnsightIO_1_1SystemVars.php#a0a231d53f39a5149f9d0faa2b04fc7d0">EnsightScalars</a>;
<a name="l00107"></a>00107   };
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 
<a name="l00110"></a><a class="code" href="classEnsightIO.php#ae408ea26144c78c109d3e08c53b7e0bc">00110</a>   <span class="keyword">typedef</span> std::map &lt;std::string, SystemVars&gt;           <a class="code" href="classEnsightIO.php#ae408ea26144c78c109d3e08c53b7e0bc">SystemsVarsMap</a>;
<a name="l00111"></a><a class="code" href="classEnsightIO.php#a5e7dc75cddfa9b52d904cd2d34468872">00111</a>   <span class="keyword">typedef</span> std::map &lt;std::string, SystemVars&gt;::iterator <a class="code" href="classEnsightIO.php#a5e7dc75cddfa9b52d904cd2d34468872">SystemsVarsMapIterator</a>;
<a name="l00112"></a><a class="code" href="classEnsightIO.php#a3da579f7f3b36a26f8523a477de6d6a2">00112</a>   <span class="keyword">typedef</span> std::pair&lt;std::string, SystemVars&gt;           <a class="code" href="classEnsightIO.php#a3da579f7f3b36a26f8523a477de6d6a2">SystemsVarsValue</a>;
<a name="l00113"></a>00113 
<a name="l00114"></a>00114   <span class="comment">// private methods</span>
<a name="l00115"></a>00115   <span class="comment">// write solution in ascii format file</span>
<a name="l00116"></a>00116   <span class="keywordtype">void</span> <a class="code" href="classEnsightIO.php#ae729673c375a167ac8b652796a0fec8f">write_ascii</a> (<span class="keyword">const</span> <span class="keywordtype">double</span> time = 0);
<a name="l00117"></a>00117   <span class="keywordtype">void</span> <a class="code" href="classEnsightIO.php#abaefc8e0e9b51686af6dd4150add59a1">write_scalar_ascii</a> (<span class="keyword">const</span> std::string &amp;sys, <span class="keyword">const</span> std::string &amp;var);
<a name="l00118"></a>00118   <span class="keywordtype">void</span> <a class="code" href="classEnsightIO.php#a1a0d6a6e5f5f0c4aebe3fb51489049cc">write_vector_ascii</a> (<span class="keyword">const</span> std::string &amp;sys, <span class="keyword">const</span> std::vector&lt;std::string&gt; &amp;vec, <span class="keyword">const</span> std::string &amp;var_name);
<a name="l00119"></a>00119   <span class="keywordtype">void</span> <a class="code" href="classEnsightIO.php#aba26c0e6baea7b450366a42c0d53a582">write_solution_ascii</a> ();
<a name="l00120"></a>00120   <span class="keywordtype">void</span> <a class="code" href="classEnsightIO.php#afa628528bd8d126fad6767c21f782fc2">write_geometry_ascii</a> ();
<a name="l00121"></a>00121   
<a name="l00122"></a>00122 
<a name="l00123"></a>00123   <span class="keywordtype">void</span> <a class="code" href="classEnsightIO.php#ae59d22212040f468aee1f459c85c7152">write_case</a>();
<a name="l00124"></a>00124   <span class="keywordtype">void</span> <a class="code" href="classEnsightIO.php#a5f59cf4ee8e7149cad8c65c7527ada0b">elem_type_to_string</a> (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>, <span class="keywordtype">char</span>*);
<a name="l00125"></a>00125   
<a name="l00126"></a>00126   <span class="comment">// private Attributes</span>
<a name="l00127"></a><a class="code" href="classEnsightIO.php#a26123e820e7ae4454d1d046f783216b7">00127</a>   std::string     <a class="code" href="classEnsightIO.php#a26123e820e7ae4454d1d046f783216b7">_ensight_file_name</a>;
<a name="l00128"></a><a class="code" href="classEnsightIO.php#a85be1ca8961e4e91b1022ad8913ca3aa">00128</a>   std::vector&lt;double&gt;   <a class="code" href="classEnsightIO.php#a85be1ca8961e4e91b1022ad8913ca3aa">_time_steps</a>;
<a name="l00129"></a><a class="code" href="classEnsightIO.php#a86a549664452d5cf88ac02add2873431">00129</a>   <a class="code" href="classEnsightIO.php#ae408ea26144c78c109d3e08c53b7e0bc">SystemsVarsMap</a>   <a class="code" href="classEnsightIO.php#a86a549664452d5cf88ac02add2873431">_systems_vars_map</a>;
<a name="l00130"></a><a class="code" href="classEnsightIO.php#afa6e269c0a2821c2efd8a4d8ae3be3fb">00130</a>   <span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a> &amp;<a class="code" href="classEnsightIO.php#afa6e269c0a2821c2efd8a4d8ae3be3fb">_equation_systems</a>;             
<a name="l00131"></a>00131 };
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 <span class="preprocessor">#endif // #define __ensight_io_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
