<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_60be1125a39495b698d2d56e8e5b50b1.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>equation_systems.C</h1>  </div>
</div>
<div class="contents">
<a href="equation__systems_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: equation_systems.C 3502 2009-10-20 18:06:50Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// System includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;sstream&gt;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;explicit_system.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;fe_interface.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;frequency_system.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;linear_implicit_system.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;mesh_refinement.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;newmark_system.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;nonlinear_implicit_system.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;parallel.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;transient_system.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;dof_map.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">// Include the systems before this one to avoid</span>
<a name="l00040"></a>00040 <span class="comment">// overlapping forward declarations.</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;equation_systems.h&quot;</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="comment">// Forward Declarations</span>
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00049"></a>00049 <span class="comment">// EquationSystems class implementation</span>
<a name="l00050"></a><a class="code" href="classEquationSystems.php#ac9b651e5c2f2bf9a0f0afa6cde26ee0c">00050</a> <a class="code" href="classEquationSystems.php#ac9b651e5c2f2bf9a0f0afa6cde26ee0c">EquationSystems::EquationSystems</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; m, <a class="code" href="classMeshData.php">MeshData</a>* mesh_data) :
<a name="l00051"></a>00051   _mesh      (m),
<a name="l00052"></a>00052   _mesh_data (mesh_data)
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054   <span class="comment">// Set default parameters</span>
<a name="l00055"></a>00055   this-&gt;<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;        (<span class="stringliteral">&quot;linear solver tolerance&quot;</span>) = TOLERANCE * TOLERANCE;
<a name="l00056"></a>00056   this-&gt;<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;linear solver maximum iterations&quot;</span>) = 5000;  
<a name="l00057"></a>00057 }
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 
<a name="l00061"></a><a class="code" href="classEquationSystems.php#acfcb6bbe16cc1e340d99892e29f53093">00061</a> <a class="code" href="classEquationSystems.php#acfcb6bbe16cc1e340d99892e29f53093">EquationSystems::~EquationSystems</a> ()
<a name="l00062"></a>00062 {
<a name="l00063"></a>00063   this-&gt;<a class="code" href="classEquationSystems.php#aa6c27c022e0616ccbce649cfdccdeae8">clear</a> ();
<a name="l00064"></a>00064 }
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a><a class="code" href="classEquationSystems.php#aa6c27c022e0616ccbce649cfdccdeae8">00068</a> <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#aa6c27c022e0616ccbce649cfdccdeae8">EquationSystems::clear</a> ()
<a name="l00069"></a>00069 {
<a name="l00070"></a>00070   <span class="comment">// Clear any additional parameters</span>
<a name="l00071"></a>00071   <a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a9d44875d9fa9f8569d56673e8344279d">clear</a> ();
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   <span class="comment">// clear the systems.  We must delete them</span>
<a name="l00074"></a>00074   <span class="comment">// since we newed them!</span>
<a name="l00075"></a>00075   <span class="keywordflow">while</span> (!<a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.empty())
<a name="l00076"></a>00076     {
<a name="l00077"></a>00077       <a class="code" href="classEquationSystems.php#a5f8dd96a6d9202f5da5e9f201c4d0d03">system_iterator</a> pos = <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.begin();
<a name="l00078"></a>00078       
<a name="l00079"></a>00079       <a class="code" href="classSystem.php">System</a> *sys = pos-&gt;second;
<a name="l00080"></a>00080       <span class="keyword">delete</span> sys;
<a name="l00081"></a>00081       sys = NULL;
<a name="l00082"></a>00082       
<a name="l00083"></a>00083       <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.erase (pos);
<a name="l00084"></a>00084     }
<a name="l00085"></a>00085 }
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 
<a name="l00089"></a><a class="code" href="classEquationSystems.php#a759b6d1f3fa9dff14c6618bf725f060a">00089</a> <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#a759b6d1f3fa9dff14c6618bf725f060a">EquationSystems::init</a> ()
<a name="l00090"></a>00090 {
<a name="l00091"></a>00091   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sys = this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>();
<a name="l00092"></a>00092 
<a name="l00093"></a>00093   libmesh_assert (n_sys != 0);
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   <span class="comment">// Distribute the mesh if possible</span>
<a name="l00096"></a>00096   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l00097"></a>00097     <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#a882442bc00428fb36c010cec0668c0e8">delete_remote_elements</a>();
<a name="l00098"></a>00098   
<a name="l00099"></a>00099   <span class="comment">// Tell all the \p DofObject entities how many systems</span>
<a name="l00100"></a>00100   <span class="comment">// there are.</span>
<a name="l00101"></a>00101   {
<a name="l00102"></a>00102     <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>       node_it  = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
<a name="l00103"></a>00103     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> node_end = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
<a name="l00104"></a>00104 
<a name="l00105"></a>00105     <span class="keywordflow">for</span> ( ; node_it != node_end; ++node_it)
<a name="l00106"></a>00106       (*node_it)-&gt;set_n_systems(n_sys);
<a name="l00107"></a>00107     
<a name="l00108"></a>00108     <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00109"></a>00109     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00110"></a>00110     
<a name="l00111"></a>00111     <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00112"></a>00112       (*elem_it)-&gt;set_n_systems(n_sys);
<a name="l00113"></a>00113   }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>(); ++i)
<a name="l00116"></a>00116     this-&gt;<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(i).init();
<a name="l00117"></a>00117 }
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a><a class="code" href="classEquationSystems.php#a55f8c311a2ff890d0919b3fa4609d9df">00121</a> <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#a55f8c311a2ff890d0919b3fa4609d9df">EquationSystems::reinit</a> ()
<a name="l00122"></a>00122 {
<a name="l00123"></a>00123   libmesh_assert (this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>() != 0);
<a name="l00124"></a>00124   
<a name="l00125"></a>00125 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00126"></a>00126 <span class="preprocessor"></span>  <span class="comment">// Make sure all the \p DofObject entities know how many systems</span>
<a name="l00127"></a>00127   <span class="comment">// there are.</span>
<a name="l00128"></a>00128   {
<a name="l00129"></a>00129     <span class="comment">// All the nodes</span>
<a name="l00130"></a>00130     <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>       node_it  = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
<a name="l00131"></a>00131     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> node_end = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
<a name="l00132"></a>00132 
<a name="l00133"></a>00133     <span class="keywordflow">for</span> ( ; node_it != node_end; ++node_it)
<a name="l00134"></a>00134       libmesh_assert((*node_it)-&gt;n_systems() == this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>());
<a name="l00135"></a>00135     
<a name="l00136"></a>00136     <span class="comment">// All the elements</span>
<a name="l00137"></a>00137     <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00138"></a>00138     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00139"></a>00139     
<a name="l00140"></a>00140     <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00141"></a>00141       libmesh_assert((*elem_it)-&gt;n_systems() == this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>());
<a name="l00142"></a>00142   }
<a name="l00143"></a>00143 <span class="preprocessor">#endif</span>
<a name="l00144"></a>00144 <span class="preprocessor"></span>
<a name="l00145"></a>00145   <span class="comment">// Localize each system&#39;s vectors</span>
<a name="l00146"></a>00146   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>(); ++i)
<a name="l00147"></a>00147     this-&gt;<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(i).re_update();
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00150"></a>00150 <span class="preprocessor"></span>
<a name="l00151"></a>00151   <span class="keywordtype">bool</span> dof_constraints_created = <span class="keyword">false</span>;
<a name="l00152"></a>00152   <span class="keywordtype">bool</span> mesh_changed = <span class="keyword">false</span>;
<a name="l00153"></a>00153 
<a name="l00154"></a>00154   <span class="comment">// FIXME: For backwards compatibility, assume</span>
<a name="l00155"></a>00155   <span class="comment">// refine_and_coarsen_elements or refine_uniformly have already</span>
<a name="l00156"></a>00156   <span class="comment">// been called</span>
<a name="l00157"></a>00157   {
<a name="l00158"></a>00158     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>(); ++i)
<a name="l00159"></a>00159       {
<a name="l00160"></a>00160         <a class="code" href="classSystem.php">System</a> &amp;sys = this-&gt;<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(i);
<a name="l00161"></a>00161 
<a name="l00162"></a>00162         <span class="comment">// Don&#39;t do anything if the system doesn&#39;t have any variables in it</span>
<a name="l00163"></a>00163         <span class="keywordflow">if</span>(!sys.<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>())
<a name="l00164"></a>00164           <span class="keywordflow">continue</span>;
<a name="l00165"></a>00165         
<a name="l00166"></a>00166         sys.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#acb78beb9cb3a932223a6577457c686d4">distribute_dofs</a>(<a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>);
<a name="l00167"></a>00167 
<a name="l00168"></a>00168         <span class="comment">// Recreate any hanging node constraints</span>
<a name="l00169"></a>00169         sys.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#af1f92941497518ad397931254d1b64dd">create_dof_constraints</a>(<a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>);
<a name="l00170"></a>00170 
<a name="l00171"></a>00171         <span class="comment">// Apply any user-defined constraints</span>
<a name="l00172"></a>00172         sys.<a class="code" href="classSystem.php#a8dd9e548cdc41149155da0a92eefa591">user_constrain</a>();
<a name="l00173"></a>00173 
<a name="l00174"></a>00174         <span class="comment">// Expand any recursive constraints</span>
<a name="l00175"></a>00175         sys.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#a82bc3d59f228ea13ec3ab2effe4b8334">process_constraints</a>();
<a name="l00176"></a>00176 
<a name="l00177"></a>00177         <span class="comment">// And clean up the send_list before we use it again</span>
<a name="l00178"></a>00178         sys.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#ad46e1ea51922aeb2828beb1527294694">prepare_send_list</a>();
<a name="l00179"></a>00179 
<a name="l00180"></a>00180         sys.<a class="code" href="classSystem.php#a557fe073d299e4382e5058644ebf452e">prolong_vectors</a>();
<a name="l00181"></a>00181       }
<a name="l00182"></a>00182     mesh_changed = <span class="keyword">true</span>;
<a name="l00183"></a>00183     dof_constraints_created = <span class="keyword">true</span>;
<a name="l00184"></a>00184   }
<a name="l00185"></a>00185   
<a name="l00186"></a>00186   <span class="comment">// FIXME: Where should the user set maintain_level_one now??</span>
<a name="l00187"></a>00187   <span class="comment">// Don&#39;t override previous settings, for now</span>
<a name="l00188"></a>00188 
<a name="l00189"></a>00189   <a class="code" href="classMeshRefinement.php">MeshRefinement</a> mesh_refine(<a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>);
<a name="l00190"></a>00190 
<a name="l00191"></a>00191   mesh_refine.<a class="code" href="classMeshRefinement.php#a16a41a634500d59084544c3d146aaaf4">face_level_mismatch_limit</a>() = <span class="keyword">false</span>;
<a name="l00192"></a>00192 
<a name="l00193"></a>00193   <span class="comment">// Try to coarsen the mesh, then restrict each system&#39;s vectors</span>
<a name="l00194"></a>00194   <span class="comment">// if necessary</span>
<a name="l00195"></a>00195   <span class="keywordflow">if</span> (mesh_refine.<a class="code" href="classMeshRefinement.php#a34f81cc5a33c88fffe936b191e48cb24">coarsen_elements</a>())
<a name="l00196"></a>00196     {
<a name="l00197"></a>00197       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>(); ++i)
<a name="l00198"></a>00198         {
<a name="l00199"></a>00199           <a class="code" href="classSystem.php">System</a> &amp;sys = this-&gt;<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(i);
<a name="l00200"></a>00200           <span class="keywordflow">if</span> (!dof_constraints_created)
<a name="l00201"></a>00201             {
<a name="l00202"></a>00202               sys.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#acb78beb9cb3a932223a6577457c686d4">distribute_dofs</a>(<a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>);
<a name="l00203"></a>00203               sys.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#af1f92941497518ad397931254d1b64dd">create_dof_constraints</a>(<a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>);
<a name="l00204"></a>00204               sys.<a class="code" href="classSystem.php#a8dd9e548cdc41149155da0a92eefa591">user_constrain</a>();
<a name="l00205"></a>00205               sys.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#a82bc3d59f228ea13ec3ab2effe4b8334">process_constraints</a>();
<a name="l00206"></a>00206               sys.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#ad46e1ea51922aeb2828beb1527294694">prepare_send_list</a>();
<a name="l00207"></a>00207 
<a name="l00208"></a>00208             }
<a name="l00209"></a>00209           sys.<a class="code" href="classSystem.php#af92311614385b58e619b19c958acf6c9">restrict_vectors</a>();
<a name="l00210"></a>00210         }
<a name="l00211"></a>00211       mesh_changed = <span class="keyword">true</span>;
<a name="l00212"></a>00212       dof_constraints_created = <span class="keyword">true</span>;
<a name="l00213"></a>00213     }
<a name="l00214"></a>00214 
<a name="l00215"></a>00215   <span class="comment">// Once vectors are all restricted, we can delete</span>
<a name="l00216"></a>00216   <span class="comment">// children of coarsened elements</span>
<a name="l00217"></a>00217   <span class="keywordflow">if</span> (mesh_changed)
<a name="l00218"></a>00218     this-&gt;<a class="code" href="classEquationSystems.php#ad8d458ae6a34c460e72b3279373d4a70">get_mesh</a>().<a class="code" href="classMeshBase.php#a02856a9f06eb0d5837ef4917e3ce6da8">contract</a>();
<a name="l00219"></a>00219   
<a name="l00220"></a>00220   <span class="comment">// Try to refine the mesh, then prolong each system&#39;s vectors</span>
<a name="l00221"></a>00221   <span class="comment">// if necessary</span>
<a name="l00222"></a>00222   <span class="keywordflow">if</span> (mesh_refine.<a class="code" href="classMeshRefinement.php#ae8312ffdcfe06d7e83c4fde95480c299">refine_elements</a>())
<a name="l00223"></a>00223     {
<a name="l00224"></a>00224       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>(); ++i)
<a name="l00225"></a>00225         {
<a name="l00226"></a>00226           <a class="code" href="classSystem.php">System</a> &amp;sys = this-&gt;<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(i);
<a name="l00227"></a>00227           <span class="keywordflow">if</span> (!dof_constraints_created)
<a name="l00228"></a>00228             {
<a name="l00229"></a>00229               sys.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#acb78beb9cb3a932223a6577457c686d4">distribute_dofs</a>(<a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>);
<a name="l00230"></a>00230               sys.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#af1f92941497518ad397931254d1b64dd">create_dof_constraints</a>(<a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>);
<a name="l00231"></a>00231               sys.<a class="code" href="classSystem.php#a8dd9e548cdc41149155da0a92eefa591">user_constrain</a>();
<a name="l00232"></a>00232               sys.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#a82bc3d59f228ea13ec3ab2effe4b8334">process_constraints</a>();
<a name="l00233"></a>00233               sys.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#ad46e1ea51922aeb2828beb1527294694">prepare_send_list</a>();
<a name="l00234"></a>00234 
<a name="l00235"></a>00235             }
<a name="l00236"></a>00236           sys.<a class="code" href="classSystem.php#a557fe073d299e4382e5058644ebf452e">prolong_vectors</a>();
<a name="l00237"></a>00237         }
<a name="l00238"></a>00238       mesh_changed = <span class="keyword">true</span>;
<a name="l00239"></a>00239       dof_constraints_created = <span class="keyword">true</span>;
<a name="l00240"></a>00240     }
<a name="l00241"></a>00241 
<a name="l00242"></a>00242   <span class="comment">// If the mesh has changed, systems will need to create new dof</span>
<a name="l00243"></a>00243   <span class="comment">// constraints and update their global solution vectors</span>
<a name="l00244"></a>00244   <span class="keywordflow">if</span> (mesh_changed)
<a name="l00245"></a>00245     {
<a name="l00246"></a>00246       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>(); ++i)
<a name="l00247"></a>00247         this-&gt;<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(i).reinit();
<a name="l00248"></a>00248     }
<a name="l00249"></a>00249 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00250"></a>00250 <span class="preprocessor"></span>}
<a name="l00251"></a>00251 
<a name="l00252"></a>00252 
<a name="l00253"></a>00253 
<a name="l00254"></a><a class="code" href="classEquationSystems.php#a89388a8d069d1ea2e24f3e8853e6d621">00254</a> <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#a89388a8d069d1ea2e24f3e8853e6d621">EquationSystems::allgather</a> ()
<a name="l00255"></a>00255 {
<a name="l00256"></a>00256   <span class="comment">// A serial mesh means nothing needs to be done</span>
<a name="l00257"></a>00257   <span class="keywordflow">if</span> (<a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#a660bb92c9fb94527d1cabfb1fdd6d056">is_serial</a>())
<a name="l00258"></a>00258     <span class="keywordflow">return</span>;
<a name="l00259"></a>00259 
<a name="l00260"></a>00260   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sys = this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>();
<a name="l00261"></a>00261 
<a name="l00262"></a>00262   libmesh_assert (n_sys != 0);
<a name="l00263"></a>00263 
<a name="l00264"></a>00264   <span class="comment">// Gather the mesh</span>
<a name="l00265"></a>00265   <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#aa465e5e27d0ac948ecee50d0a03f2c82">allgather</a>();
<a name="l00266"></a>00266   
<a name="l00267"></a>00267   <span class="comment">// Tell all the \p DofObject entities how many systems</span>
<a name="l00268"></a>00268   <span class="comment">// there are.</span>
<a name="l00269"></a>00269   {
<a name="l00270"></a>00270     <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>       node_it  = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
<a name="l00271"></a>00271     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> node_end = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
<a name="l00272"></a>00272 
<a name="l00273"></a>00273     <span class="keywordflow">for</span> ( ; node_it != node_end; ++node_it)
<a name="l00274"></a>00274       (*node_it)-&gt;set_n_systems(n_sys);
<a name="l00275"></a>00275     
<a name="l00276"></a>00276     <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00277"></a>00277     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00278"></a>00278     
<a name="l00279"></a>00279     <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00280"></a>00280       (*elem_it)-&gt;set_n_systems(n_sys);
<a name="l00281"></a>00281   }
<a name="l00282"></a>00282 
<a name="l00283"></a>00283   <span class="comment">// And distribute each system&#39;s dofs</span>
<a name="l00284"></a>00284   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>(); ++i)
<a name="l00285"></a>00285     this-&gt;<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(i).get_dof_map().distribute_dofs(<a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>);
<a name="l00286"></a>00286 }
<a name="l00287"></a>00287 
<a name="l00288"></a>00288 
<a name="l00289"></a>00289 
<a name="l00290"></a>00290 
<a name="l00291"></a><a class="code" href="classEquationSystems.php#a1ca915358810720dbfba739ddaedaa6f">00291</a> <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#a1ca915358810720dbfba739ddaedaa6f">EquationSystems::update</a> ()
<a name="l00292"></a>00292 {
<a name="l00293"></a>00293   START_LOG(<span class="stringliteral">&quot;update()&quot;</span>,<span class="stringliteral">&quot;EquationSystems&quot;</span>);
<a name="l00294"></a>00294   
<a name="l00295"></a>00295   <span class="comment">// Localize each system&#39;s vectors</span>
<a name="l00296"></a>00296   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>(); ++i)
<a name="l00297"></a>00297     this-&gt;<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(i).update();
<a name="l00298"></a>00298   
<a name="l00299"></a>00299   STOP_LOG(<span class="stringliteral">&quot;update()&quot;</span>,<span class="stringliteral">&quot;EquationSystems&quot;</span>);
<a name="l00300"></a>00300 }
<a name="l00301"></a>00301 
<a name="l00302"></a>00302 
<a name="l00303"></a>00303 
<a name="l00304"></a><a class="code" href="classEquationSystems.php#a6fbb47f48cfad09bb1b9562ae1e9b24a">00304</a> <a class="code" href="classSystem.php">System</a> &amp; <a class="code" href="classEquationSystems.php#a6fbb47f48cfad09bb1b9562ae1e9b24a">EquationSystems::add_system</a> (<span class="keyword">const</span> std::string&amp; sys_type,
<a name="l00305"></a>00305                                       <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00306"></a>00306 {
<a name="l00307"></a>00307   <span class="comment">// Build a Newmark system</span>
<a name="l00308"></a>00308   <span class="keywordflow">if</span>      (sys_type == <span class="stringliteral">&quot;Newmark&quot;</span>)
<a name="l00309"></a>00309     this-&gt;add_system&lt;NewmarkSystem&gt; (<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>);
<a name="l00310"></a>00310 
<a name="l00311"></a>00311   <span class="comment">// Build an Explicit system</span>
<a name="l00312"></a>00312   <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((sys_type == <span class="stringliteral">&quot;Explicit&quot;</span>))
<a name="l00313"></a>00313     this-&gt;add_system&lt;ExplicitSystem&gt; (name);
<a name="l00314"></a>00314 
<a name="l00315"></a>00315   <span class="comment">// Build an Implicit system</span>
<a name="l00316"></a>00316   <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((sys_type == <span class="stringliteral">&quot;Implicit&quot;</span>) ||
<a name="l00317"></a>00317            (sys_type == <span class="stringliteral">&quot;Steady&quot;</span>  ))
<a name="l00318"></a>00318     this-&gt;add_system&lt;ImplicitSystem&gt; (<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>);
<a name="l00319"></a>00319 
<a name="l00320"></a>00320   <span class="comment">// build a transient implicit linear system</span>
<a name="l00321"></a>00321   <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((sys_type == <span class="stringliteral">&quot;Transient&quot;</span>) ||
<a name="l00322"></a>00322            (sys_type == <span class="stringliteral">&quot;TransientImplicit&quot;</span>) ||
<a name="l00323"></a>00323            (sys_type == <span class="stringliteral">&quot;TransientLinearImplicit&quot;</span>))
<a name="l00324"></a>00324     this-&gt;add_system&lt;TransientLinearImplicitSystem&gt; (name);
<a name="l00325"></a>00325 
<a name="l00326"></a>00326   <span class="comment">// build a transient implicit nonlinear system</span>
<a name="l00327"></a>00327   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (sys_type == <span class="stringliteral">&quot;TransientNonlinearImplicit&quot;</span>)
<a name="l00328"></a>00328     this-&gt;add_system&lt;TransientNonlinearImplicitSystem&gt; (<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>);
<a name="l00329"></a>00329 
<a name="l00330"></a>00330   <span class="comment">// build a transient explicit system</span>
<a name="l00331"></a>00331   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (sys_type == <span class="stringliteral">&quot;TransientExplicit&quot;</span>)
<a name="l00332"></a>00332     this-&gt;add_system&lt;TransientExplicitSystem&gt; (<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>);
<a name="l00333"></a>00333 
<a name="l00334"></a>00334   <span class="comment">// build a linear implicit system</span>
<a name="l00335"></a>00335   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (sys_type == <span class="stringliteral">&quot;LinearImplicit&quot;</span>)
<a name="l00336"></a>00336     this-&gt;add_system&lt;LinearImplicitSystem&gt; (<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>);
<a name="l00337"></a>00337 
<a name="l00338"></a>00338   <span class="comment">// build a nonlinear implicit system</span>
<a name="l00339"></a>00339   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (sys_type == <span class="stringliteral">&quot;NonlinearImplicit&quot;</span>)
<a name="l00340"></a>00340     this-&gt;add_system&lt;NonlinearImplicitSystem&gt; (<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>);
<a name="l00341"></a>00341 
<a name="l00342"></a>00342 <span class="preprocessor">#if defined(LIBMESH_USE_COMPLEX_NUMBERS)</span>
<a name="l00343"></a>00343 <span class="preprocessor"></span>  <span class="comment">// build a frequency system</span>
<a name="l00344"></a>00344   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (sys_type == <span class="stringliteral">&quot;Frequency&quot;</span>)
<a name="l00345"></a>00345     this-&gt;add_system&lt;FrequencySystem&gt; (<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>);
<a name="l00346"></a>00346 <span class="preprocessor">#endif</span>
<a name="l00347"></a>00347 <span class="preprocessor"></span>
<a name="l00348"></a>00348   <span class="keywordflow">else</span>
<a name="l00349"></a>00349     {
<a name="l00350"></a>00350       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Unknown system type: &quot;</span>
<a name="l00351"></a>00351                 &lt;&lt; sys_type
<a name="l00352"></a>00352                 &lt;&lt; std::endl;
<a name="l00353"></a>00353       libmesh_error();
<a name="l00354"></a>00354     }
<a name="l00355"></a>00355 
<a name="l00356"></a>00356   <span class="comment">// Return a reference to the new system</span>
<a name="l00357"></a>00357   <span class="comment">//return (*this)(name);</span>
<a name="l00358"></a>00358   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(name);
<a name="l00359"></a>00359 }
<a name="l00360"></a>00360 
<a name="l00361"></a>00361 
<a name="l00362"></a>00362 
<a name="l00363"></a>00363 
<a name="l00364"></a>00364 
<a name="l00365"></a>00365 
<a name="l00366"></a><a class="code" href="classEquationSystems.php#a25930bf00b3b3ebb7dfdbc6954ae99d0">00366</a> <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#a25930bf00b3b3ebb7dfdbc6954ae99d0">EquationSystems::delete_system</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00367"></a>00367 {
<a name="l00368"></a>00368   libmesh_deprecated();
<a name="l00369"></a>00369 
<a name="l00370"></a>00370   <span class="keywordflow">if</span> (!<a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.count(name))
<a name="l00371"></a>00371     {
<a name="l00372"></a>00372       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: no system named &quot;</span>
<a name="l00373"></a>00373                 &lt;&lt; name  &lt;&lt; std::endl;
<a name="l00374"></a>00374 
<a name="l00375"></a>00375       libmesh_error();
<a name="l00376"></a>00376     }
<a name="l00377"></a>00377   
<a name="l00378"></a>00378   <span class="keyword">delete</span> <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>[<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>];
<a name="l00379"></a>00379   
<a name="l00380"></a>00380   <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.erase (name);
<a name="l00381"></a>00381 }
<a name="l00382"></a>00382 
<a name="l00383"></a>00383 
<a name="l00384"></a>00384 
<a name="l00385"></a><a class="code" href="classEquationSystems.php#aef3aa48d457508bf35043667dab8bd5b">00385</a> <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#aef3aa48d457508bf35043667dab8bd5b">EquationSystems::solve</a> ()
<a name="l00386"></a>00386 {
<a name="l00387"></a>00387   libmesh_assert (this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>());
<a name="l00388"></a>00388 
<a name="l00389"></a>00389   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>(); ++i)
<a name="l00390"></a>00390     this-&gt;<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(i).solve();
<a name="l00391"></a>00391 }
<a name="l00392"></a>00392 
<a name="l00393"></a>00393 
<a name="l00394"></a>00394  
<a name="l00395"></a><a class="code" href="classEquationSystems.php#a92d62c14a28b6a0010801da36511ff37">00395</a> <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#a92d62c14a28b6a0010801da36511ff37">EquationSystems::adjoint_solve</a> ()
<a name="l00396"></a>00396 {
<a name="l00397"></a>00397   libmesh_assert (this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>());
<a name="l00398"></a>00398 
<a name="l00399"></a>00399   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>(); i != 0; --i)
<a name="l00400"></a>00400     this-&gt;<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(i-1).adjoint_solve();
<a name="l00401"></a>00401 }
<a name="l00402"></a>00402  
<a name="l00403"></a>00403 
<a name="l00404"></a>00404  
<a name="l00405"></a><a class="code" href="classEquationSystems.php#a90e9f4c77f1abf585f741c303e5edc29">00405</a> <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#a90e9f4c77f1abf585f741c303e5edc29">EquationSystems::build_variable_names</a> (std::vector&lt;std::string&gt;&amp; var_names)<span class="keyword"> const</span>
<a name="l00406"></a>00406 <span class="keyword"></span>{
<a name="l00407"></a>00407   libmesh_assert (this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>());
<a name="l00408"></a>00408   
<a name="l00409"></a>00409   var_names.resize (this-&gt;<a class="code" href="classEquationSystems.php#af52cb13b16614472c431787e868aba25">n_vars</a>());
<a name="l00410"></a>00410 
<a name="l00411"></a>00411   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var_num=0;
<a name="l00412"></a>00412   
<a name="l00413"></a>00413   <a class="code" href="classEquationSystems.php#aea46ae961d94d413e72251c3e9ed5a43">const_system_iterator</a>       pos = <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.begin();
<a name="l00414"></a>00414   <span class="keyword">const</span> <a class="code" href="classEquationSystems.php#aea46ae961d94d413e72251c3e9ed5a43">const_system_iterator</a> end = <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.end();
<a name="l00415"></a>00415 
<a name="l00416"></a>00416   <span class="keywordflow">for</span> (; pos != end; ++pos)
<a name="l00417"></a>00417     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn=0; vn&lt;pos-&gt;second-&gt;n_vars(); vn++)
<a name="l00418"></a>00418       var_names[var_num++] = pos-&gt;second-&gt;variable_name(vn);       
<a name="l00419"></a>00419 }
<a name="l00420"></a>00420 
<a name="l00421"></a>00421 
<a name="l00422"></a>00422 
<a name="l00423"></a><a class="code" href="classEquationSystems.php#aa7e2afc9d649b35d6bf1a2e8185b4169">00423</a> <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#aa7e2afc9d649b35d6bf1a2e8185b4169">EquationSystems::build_solution_vector</a> (std::vector&lt;Number&gt;&amp;,
<a name="l00424"></a>00424                                              <span class="keyword">const</span> std::string&amp;,
<a name="l00425"></a>00425                                              <span class="keyword">const</span> std::string&amp;)<span class="keyword"> const</span>
<a name="l00426"></a>00426 <span class="keyword"></span>{
<a name="l00427"></a>00427   <span class="comment">//TODO:[BSK] re-implement this from the method below</span>
<a name="l00428"></a>00428   libmesh_error();
<a name="l00429"></a>00429 
<a name="l00430"></a>00430 <span class="comment">//   // Get a reference to the named system</span>
<a name="l00431"></a>00431 <span class="comment">//   const System&amp; system = this-&gt;get_system(system_name);</span>
<a name="l00432"></a>00432 
<a name="l00433"></a>00433 <span class="comment">//   // Get the number associated with the variable_name we are passed</span>
<a name="l00434"></a>00434 <span class="comment">//   const unsigned short int variable_num = system.variable_number(variable_name);</span>
<a name="l00435"></a>00435 
<a name="l00436"></a>00436 <span class="comment">//   // Get the dimension of the current mesh</span>
<a name="l00437"></a>00437 <span class="comment">//   const unsigned int dim = _mesh.mesh_dimension();</span>
<a name="l00438"></a>00438 
<a name="l00439"></a>00439 <span class="comment">//   // If we&#39;re on processor 0, allocate enough memory to hold the solution.</span>
<a name="l00440"></a>00440 <span class="comment">//   // Since we&#39;re only looking at one variable, there will be one solution value</span>
<a name="l00441"></a>00441 <span class="comment">//   // for each node in the mesh.</span>
<a name="l00442"></a>00442 <span class="comment">//   if (_mesh.processor_id() == 0)</span>
<a name="l00443"></a>00443 <span class="comment">//     soln.resize(_mesh.n_nodes());</span>
<a name="l00444"></a>00444 
<a name="l00445"></a>00445 <span class="comment">//   // Vector to hold the global solution from all processors</span>
<a name="l00446"></a>00446 <span class="comment">//   std::vector&lt;Number&gt; sys_soln;</span>
<a name="l00447"></a>00447   
<a name="l00448"></a>00448 <span class="comment">//   // Update the global solution from all processors</span>
<a name="l00449"></a>00449 <span class="comment">//   system.update_global_solution (sys_soln, 0);</span>
<a name="l00450"></a>00450   
<a name="l00451"></a>00451 <span class="comment">//   // Temporary vector to store the solution on an individual element.</span>
<a name="l00452"></a>00452 <span class="comment">//   std::vector&lt;Number&gt;       elem_soln;   </span>
<a name="l00453"></a>00453 
<a name="l00454"></a>00454 <span class="comment">//   // The FE solution interpolated to the nodes</span>
<a name="l00455"></a>00455 <span class="comment">//   std::vector&lt;Number&gt;       nodal_soln;  </span>
<a name="l00456"></a>00456 
<a name="l00457"></a>00457 <span class="comment">//   // The DOF indices for the element</span>
<a name="l00458"></a>00458 <span class="comment">//   std::vector&lt;unsigned int&gt; dof_indices; </span>
<a name="l00459"></a>00459 
<a name="l00460"></a>00460 <span class="comment">//   // Determine the finite/infinite element type used in this system </span>
<a name="l00461"></a>00461 <span class="comment">//   const FEType&amp; fe_type    = system.variable_type(variable_num);</span>
<a name="l00462"></a>00462 
<a name="l00463"></a>00463 <span class="comment">//   // Define iterators to iterate over all the elements of the mesh</span>
<a name="l00464"></a>00464 <span class="comment">//   const_active_elem_iterator       it (_mesh.elements_begin());</span>
<a name="l00465"></a>00465 <span class="comment">//   const const_active_elem_iterator end(_mesh.elements_end());</span>
<a name="l00466"></a>00466 
<a name="l00467"></a>00467 <span class="comment">//   // Loop over elements</span>
<a name="l00468"></a>00468 <span class="comment">//   for ( ; it != end; ++it)</span>
<a name="l00469"></a>00469 <span class="comment">//     {</span>
<a name="l00470"></a>00470 <span class="comment">//       // Convenient shortcut to the element pointer</span>
<a name="l00471"></a>00471 <span class="comment">//       const Elem* elem = *it;</span>
<a name="l00472"></a>00472 
<a name="l00473"></a>00473 <span class="comment">//       // Fill the dof_indices vector for this variable</span>
<a name="l00474"></a>00474 <span class="comment">//       system.get_dof_map().dof_indices(elem,</span>
<a name="l00475"></a>00475 <span class="comment">//                                     dof_indices,</span>
<a name="l00476"></a>00476 <span class="comment">//                                     variable_num);</span>
<a name="l00477"></a>00477 
<a name="l00478"></a>00478 <span class="comment">//       // Resize the element solution vector to fit the</span>
<a name="l00479"></a>00479 <span class="comment">//       // dof_indices for this element.</span>
<a name="l00480"></a>00480 <span class="comment">//       elem_soln.resize(dof_indices.size());</span>
<a name="l00481"></a>00481 
<a name="l00482"></a>00482 <span class="comment">//       // Transfer the system solution to the element</span>
<a name="l00483"></a>00483 <span class="comment">//       // solution by mapping it through the dof_indices vector.</span>
<a name="l00484"></a>00484 <span class="comment">//       for (unsigned int i=0; i&lt;dof_indices.size(); i++)</span>
<a name="l00485"></a>00485 <span class="comment">//      elem_soln[i] = sys_soln[dof_indices[i]];</span>
<a name="l00486"></a>00486 
<a name="l00487"></a>00487 <span class="comment">//       // Using the FE interface, compute the nodal_soln</span>
<a name="l00488"></a>00488 <span class="comment">//       // for the current elemnt type given the elem_soln</span>
<a name="l00489"></a>00489 <span class="comment">//       FEInterface::nodal_soln (dim,</span>
<a name="l00490"></a>00490 <span class="comment">//                             fe_type,</span>
<a name="l00491"></a>00491 <span class="comment">//                             elem,</span>
<a name="l00492"></a>00492 <span class="comment">//                             elem_soln,</span>
<a name="l00493"></a>00493 <span class="comment">//                             nodal_soln);</span>
<a name="l00494"></a>00494 
<a name="l00495"></a>00495 <span class="comment">//       // Sanity check -- make sure that there are the same number</span>
<a name="l00496"></a>00496 <span class="comment">//       // of entries in the nodal_soln as there are nodes in the</span>
<a name="l00497"></a>00497 <span class="comment">//       // element!</span>
<a name="l00498"></a>00498 <span class="comment">//       libmesh_assert (nodal_soln.size() == elem-&gt;n_nodes());</span>
<a name="l00499"></a>00499 
<a name="l00500"></a>00500 <span class="comment">//       // Copy the nodal solution over into the correct place in</span>
<a name="l00501"></a>00501 <span class="comment">//       // the global soln vector which will be returned to the user.</span>
<a name="l00502"></a>00502 <span class="comment">//       for (unsigned int n=0; n&lt;elem-&gt;n_nodes(); n++)</span>
<a name="l00503"></a>00503 <span class="comment">//      soln[elem-&gt;node(n)] = nodal_soln[n];</span>
<a name="l00504"></a>00504 <span class="comment">//     }</span>
<a name="l00505"></a>00505 }
<a name="l00506"></a>00506 
<a name="l00507"></a>00507 
<a name="l00508"></a>00508 
<a name="l00509"></a>00509 
<a name="l00510"></a><a class="code" href="classEquationSystems.php#abeba0e82ca5a0884420f784212f62fec">00510</a> <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#aa7e2afc9d649b35d6bf1a2e8185b4169">EquationSystems::build_solution_vector</a> (std::vector&lt;Number&gt;&amp; soln)<span class="keyword"> const</span>
<a name="l00511"></a>00511 <span class="keyword"></span>{
<a name="l00512"></a>00512   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00513"></a>00513   parallel_only();
<a name="l00514"></a>00514 
<a name="l00515"></a>00515   libmesh_assert (this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>());
<a name="l00516"></a>00516 
<a name="l00517"></a>00517   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>();
<a name="l00518"></a>00518   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn  = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>();
<a name="l00519"></a>00519   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nv  = this-&gt;<a class="code" href="classEquationSystems.php#af52cb13b16614472c431787e868aba25">n_vars</a>();
<a name="l00520"></a>00520   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> one = 1;
<a name="l00521"></a>00521 
<a name="l00522"></a>00522   <span class="comment">// We&#39;d better have a contiguous node numbering</span>
<a name="l00523"></a>00523   libmesh_assert (nn == <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#a5a56e1b57f60d011b67f1f43ff8a5891">max_node_id</a>());
<a name="l00524"></a>00524 
<a name="l00525"></a>00525   <span class="comment">// allocate storage to hold</span>
<a name="l00526"></a>00526   <span class="comment">// (number_of_nodes)*(number_of_variables) entries.</span>
<a name="l00527"></a>00527   soln.resize(nn*nv);
<a name="l00528"></a>00528   
<a name="l00529"></a>00529   <span class="comment">// Zero out the soln vector</span>
<a name="l00530"></a>00530   std::fill (soln.begin(), soln.end(), <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>);
<a name="l00531"></a>00531 
<a name="l00532"></a>00532   std::vector&lt;Number&gt;  sys_soln;
<a name="l00533"></a>00533 
<a name="l00534"></a>00534   <span class="comment">// (Note that we use an unsigned short int here even though an</span>
<a name="l00535"></a>00535   <span class="comment">// unsigned char would be more that sufficient.  The MPI 1.1</span>
<a name="l00536"></a>00536   <span class="comment">// standard does not require that MPI_SUM, MPI_PROD etc... be</span>
<a name="l00537"></a>00537   <span class="comment">// implemented for char data types. 12/23/2003 - BSK)  </span>
<a name="l00538"></a>00538   std::vector&lt;unsigned short int&gt; node_conn(nn), repeat_count(nn);
<a name="l00539"></a>00539 
<a name="l00540"></a>00540   <span class="comment">// Get the number of elements that share each node.  We will</span>
<a name="l00541"></a>00541   <span class="comment">// compute the average value at each node.  This is particularly</span>
<a name="l00542"></a>00542   <span class="comment">// useful for plotting discontinuous data.</span>
<a name="l00543"></a>00543   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       e_it  = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00544"></a>00544   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> e_end = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>(); 
<a name="l00545"></a>00545 
<a name="l00546"></a>00546   <span class="keywordflow">for</span> ( ; e_it != e_end; ++e_it)
<a name="l00547"></a>00547     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;(*e_it)-&gt;n_nodes(); n++)
<a name="l00548"></a>00548       node_conn[(*e_it)-&gt;node(n)]++;
<a name="l00549"></a>00549 
<a name="l00550"></a>00550   <span class="comment">// Gather the distributed node_conn arrays in the case of</span>
<a name="l00551"></a>00551   <span class="comment">// multiple processors.</span>
<a name="l00552"></a>00552   Parallel::sum(node_conn);
<a name="l00553"></a>00553 
<a name="l00554"></a>00554   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var_num=0;
<a name="l00555"></a>00555 
<a name="l00556"></a>00556   <span class="comment">// For each system in this EquationSystems object,</span>
<a name="l00557"></a>00557   <span class="comment">// update the global solution and if we are on processor 0,</span>
<a name="l00558"></a>00558   <span class="comment">// loop over the elements and build the nodal solution</span>
<a name="l00559"></a>00559   <span class="comment">// from the element solution.  Then insert this nodal solution</span>
<a name="l00560"></a>00560   <span class="comment">// into the vector passed to build_solution_vector.</span>
<a name="l00561"></a>00561   <a class="code" href="classEquationSystems.php#aea46ae961d94d413e72251c3e9ed5a43">const_system_iterator</a>       pos = <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.begin();
<a name="l00562"></a>00562   <span class="keyword">const</span> <a class="code" href="classEquationSystems.php#aea46ae961d94d413e72251c3e9ed5a43">const_system_iterator</a> end = <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.end();
<a name="l00563"></a>00563   
<a name="l00564"></a>00564   <span class="keywordflow">for</span> (; pos != end; ++pos)
<a name="l00565"></a>00565     {  
<a name="l00566"></a>00566       <span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; system  = *(pos-&gt;second);
<a name="l00567"></a>00567       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nv_sys = system.<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>();
<a name="l00568"></a>00568       
<a name="l00569"></a>00569       system.<a class="code" href="classSystem.php#afb0ea08442d8a71cf040f598f767a396">update_global_solution</a> (sys_soln);
<a name="l00570"></a>00570       
<a name="l00571"></a>00571       std::vector&lt;Number&gt;       elem_soln;   <span class="comment">// The finite element solution</span>
<a name="l00572"></a>00572       std::vector&lt;Number&gt;       nodal_soln;  <span class="comment">// The FE solution interpolated to the nodes</span>
<a name="l00573"></a>00573       std::vector&lt;unsigned int&gt; dof_indices; <span class="comment">// The DOF indices for the finite element </span>
<a name="l00574"></a>00574       
<a name="l00575"></a>00575       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;nv_sys; var++)
<a name="l00576"></a>00576         {
<a name="l00577"></a>00577           <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_type                   = system.<a class="code" href="classSystem.php#aa917dd59a348a46e9adab63d9767460f">variable_type</a>(var);
<a name="l00578"></a>00578           <span class="keyword">const</span> <a class="code" href="classSystem_1_1Variable.php">System::Variable</a> &amp;var_description = system.<a class="code" href="classSystem.php#a8b1d32d0a3a3848906c07107a7f03762">variable</a>(var);
<a name="l00579"></a>00579           <span class="keyword">const</span> <a class="code" href="classDofMap.php">DofMap</a> &amp;dof_map                   = system.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>();
<a name="l00580"></a>00580 
<a name="l00581"></a>00581           std::fill (repeat_count.begin(), repeat_count.end(), 0);
<a name="l00582"></a>00582 
<a name="l00583"></a>00583           <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       it  = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00584"></a>00584           <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>(); 
<a name="l00585"></a>00585 
<a name="l00586"></a>00586           <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l00587"></a>00587             <span class="keywordflow">if</span> (var_description.<a class="code" href="classSystem_1_1Variable.php#ad6639756dcb5050d014cddb818d13df9">active_on_subdomain</a>((*it)-&gt;subdomain_id()))
<a name="l00588"></a>00588               {
<a name="l00589"></a>00589                 <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *it;      
<a name="l00590"></a>00590 
<a name="l00591"></a>00591                 dof_map.<a class="code" href="classDofMap.php#afc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (elem, dof_indices, var);
<a name="l00592"></a>00592               
<a name="l00593"></a>00593                 elem_soln.resize(dof_indices.size());
<a name="l00594"></a>00594               
<a name="l00595"></a>00595                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;dof_indices.size(); i++)
<a name="l00596"></a>00596                   elem_soln[i] = sys_soln[dof_indices[i]];
<a name="l00597"></a>00597                   
<a name="l00598"></a>00598                 <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FEInterface::nodal_soln</a> (dim,
<a name="l00599"></a>00599                                          fe_type,
<a name="l00600"></a>00600                                          elem,
<a name="l00601"></a>00601                                          elem_soln,
<a name="l00602"></a>00602                                          nodal_soln);
<a name="l00603"></a>00603 
<a name="l00604"></a>00604 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00605"></a>00605 <span class="preprocessor"></span>                <span class="comment">// infinite elements should be skipped...</span>
<a name="l00606"></a>00606                 <span class="keywordflow">if</span> (!elem-&gt;<a class="code" href="classElem.php#ab552f89411c1786564c63daec764d47a">infinite</a>())
<a name="l00607"></a>00607 #endif
<a name="l00608"></a>00608                   { 
<a name="l00609"></a>00609                     libmesh_assert (nodal_soln.size() == elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>());
<a name="l00610"></a>00610                   
<a name="l00611"></a>00611                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); n++)
<a name="l00612"></a>00612                       {
<a name="l00613"></a>00613                         repeat_count[elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n)]++;
<a name="l00614"></a>00614                         soln[nv*(elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n)) + (var + var_num)] += nodal_soln[n];
<a name="l00615"></a>00615                       }
<a name="l00616"></a>00616                   }
<a name="l00617"></a>00617               } <span class="comment">// end loop over elements        </span>
<a name="l00618"></a>00618 
<a name="l00619"></a>00619           <span class="comment">// when a variable is active everywhere the repeat_count</span>
<a name="l00620"></a>00620           <span class="comment">// and node_conn arrays should be identical, so let&#39;s</span>
<a name="l00621"></a>00621           <span class="comment">// use that information to avoid unnecessary communication</span>
<a name="l00622"></a>00622           <span class="keywordflow">if</span> (var_description.<a class="code" href="classSystem_1_1Variable.php#a37a8efab345c850b3fa2b4f9ec544f8e">implicitly_active</a>())
<a name="l00623"></a>00623             repeat_count = node_conn;
<a name="l00624"></a>00624             
<a name="l00625"></a>00625           <span class="keywordflow">else</span>
<a name="l00626"></a>00626             Parallel::sum (repeat_count);
<a name="l00627"></a>00627 
<a name="l00628"></a>00628           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;nn; n++)
<a name="l00629"></a>00629             soln[nv*n + (var + var_num)] /= 
<a name="l00630"></a>00630               <span class="keyword">static_cast&lt;</span><a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a><span class="keyword">&gt;</span>(<a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a> (repeat_count[n], one));
<a name="l00631"></a>00631           
<a name="l00632"></a>00632       
<a name="l00633"></a>00633         } <span class="comment">// end loop on variables in this system</span>
<a name="l00634"></a>00634   
<a name="l00635"></a>00635       var_num += nv_sys;
<a name="l00636"></a>00636     } <span class="comment">// end loop over systems</span>
<a name="l00637"></a>00637 
<a name="l00638"></a>00638   <span class="comment">// Now each processor has computed contriburions to the</span>
<a name="l00639"></a>00639   <span class="comment">// soln vector.  Gather them all up.</span>
<a name="l00640"></a>00640   Parallel::sum(soln);
<a name="l00641"></a>00641 }
<a name="l00642"></a>00642 
<a name="l00643"></a>00643 
<a name="l00644"></a>00644 
<a name="l00645"></a>00645 
<a name="l00646"></a><a class="code" href="classEquationSystems.php#a5a54b3b13598a5d9db59b9053253af5b">00646</a> <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#a5a54b3b13598a5d9db59b9053253af5b">EquationSystems::build_discontinuous_solution_vector</a> (std::vector&lt;Number&gt;&amp; soln)<span class="keyword"> const</span>
<a name="l00647"></a>00647 <span class="keyword"></span>{
<a name="l00648"></a>00648   libmesh_assert (this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>());
<a name="l00649"></a>00649 
<a name="l00650"></a>00650   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>();
<a name="l00651"></a>00651   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nv  = this-&gt;<a class="code" href="classEquationSystems.php#af52cb13b16614472c431787e868aba25">n_vars</a>();
<a name="l00652"></a>00652   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tw=0;
<a name="l00653"></a>00653 
<a name="l00654"></a>00654   <span class="comment">// get the total weight</span>
<a name="l00655"></a>00655   {
<a name="l00656"></a>00656     <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       it  = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00657"></a>00657     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00658"></a>00658 
<a name="l00659"></a>00659     <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l00660"></a>00660       tw += (*it)-&gt;n_nodes();
<a name="l00661"></a>00661   }
<a name="l00662"></a>00662   
<a name="l00663"></a>00663 
<a name="l00664"></a>00664   <span class="comment">// Only if we are on processor zero, allocate the storage</span>
<a name="l00665"></a>00665   <span class="comment">// to hold (number_of_nodes)*(number_of_variables) entries.</span>
<a name="l00666"></a>00666   <span class="keywordflow">if</span> (<a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#aba369b64ee6185d86a6b60089ba5af60">processor_id</a>() == 0)
<a name="l00667"></a>00667     soln.resize(tw*nv);
<a name="l00668"></a>00668 
<a name="l00669"></a>00669   std::vector&lt;Number&gt; sys_soln; 
<a name="l00670"></a>00670 
<a name="l00671"></a>00671   
<a name="l00672"></a>00672   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var_num=0;
<a name="l00673"></a>00673 
<a name="l00674"></a>00674   <span class="comment">// For each system in this EquationSystems object,</span>
<a name="l00675"></a>00675   <span class="comment">// update the global solution and if we are on processor 0,</span>
<a name="l00676"></a>00676   <span class="comment">// loop over the elements and build the nodal solution</span>
<a name="l00677"></a>00677   <span class="comment">// from the element solution.  Then insert this nodal solution</span>
<a name="l00678"></a>00678   <span class="comment">// into the vector passed to build_solution_vector.</span>
<a name="l00679"></a>00679   <a class="code" href="classEquationSystems.php#aea46ae961d94d413e72251c3e9ed5a43">const_system_iterator</a>       pos = <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.begin();
<a name="l00680"></a>00680   <span class="keyword">const</span> <a class="code" href="classEquationSystems.php#aea46ae961d94d413e72251c3e9ed5a43">const_system_iterator</a> end = <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.end();
<a name="l00681"></a>00681 
<a name="l00682"></a>00682   <span class="keywordflow">for</span> (; pos != end; ++pos)
<a name="l00683"></a>00683     {  
<a name="l00684"></a>00684       <span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; system  = *(pos-&gt;second);
<a name="l00685"></a>00685       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nv_sys = system.<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>();
<a name="l00686"></a>00686       
<a name="l00687"></a>00687       system.<a class="code" href="classSystem.php#afb0ea08442d8a71cf040f598f767a396">update_global_solution</a> (sys_soln, 0);
<a name="l00688"></a>00688       
<a name="l00689"></a>00689       <span class="keywordflow">if</span> (<a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#aba369b64ee6185d86a6b60089ba5af60">processor_id</a>() == 0)
<a name="l00690"></a>00690         {
<a name="l00691"></a>00691           std::vector&lt;Number&gt;       elem_soln;   <span class="comment">// The finite element solution</span>
<a name="l00692"></a>00692           std::vector&lt;Number&gt;       nodal_soln;  <span class="comment">// The FE solution interpolated to the nodes</span>
<a name="l00693"></a>00693           std::vector&lt;unsigned int&gt; dof_indices; <span class="comment">// The DOF indices for the finite element </span>
<a name="l00694"></a>00694               
<a name="l00695"></a>00695           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;nv_sys; var++)
<a name="l00696"></a>00696             {
<a name="l00697"></a>00697               <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_type    = system.<a class="code" href="classSystem.php#aa917dd59a348a46e9adab63d9767460f">variable_type</a>(var);
<a name="l00698"></a>00698 
<a name="l00699"></a>00699               <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       it  = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00700"></a>00700               <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00701"></a>00701 
<a name="l00702"></a>00702               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn=0;
<a name="l00703"></a>00703               
<a name="l00704"></a>00704               <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l00705"></a>00705                 {
<a name="l00706"></a>00706                   <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *it;
<a name="l00707"></a>00707                   system.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#afc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (elem, dof_indices, var);
<a name="l00708"></a>00708                   
<a name="l00709"></a>00709                   elem_soln.resize(dof_indices.size());
<a name="l00710"></a>00710                   
<a name="l00711"></a>00711                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;dof_indices.size(); i++)
<a name="l00712"></a>00712                     elem_soln[i] = sys_soln[dof_indices[i]];
<a name="l00713"></a>00713                   
<a name="l00714"></a>00714                   <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FEInterface::nodal_soln</a> (dim,
<a name="l00715"></a>00715                                            fe_type,
<a name="l00716"></a>00716                                            elem,
<a name="l00717"></a>00717                                            elem_soln,
<a name="l00718"></a>00718                                            nodal_soln);
<a name="l00719"></a>00719 
<a name="l00720"></a>00720 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00721"></a>00721 <span class="preprocessor"></span>                  <span class="comment">// infinite elements should be skipped...</span>
<a name="l00722"></a>00722                   <span class="keywordflow">if</span> (!elem-&gt;<a class="code" href="classElem.php#ab552f89411c1786564c63daec764d47a">infinite</a>())
<a name="l00723"></a>00723 #endif
<a name="l00724"></a>00724                     { 
<a name="l00725"></a>00725                       libmesh_assert (nodal_soln.size() == elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>());
<a name="l00726"></a>00726                   
<a name="l00727"></a>00727                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); n++)
<a name="l00728"></a>00728                         {
<a name="l00729"></a>00729                           soln[nv*(nn++) + (var + var_num)] +=
<a name="l00730"></a>00730                             nodal_soln[n];
<a name="l00731"></a>00731                         }
<a name="l00732"></a>00732                     }
<a name="l00733"></a>00733                 }
<a name="l00734"></a>00734             }    
<a name="l00735"></a>00735         }
<a name="l00736"></a>00736 
<a name="l00737"></a>00737       var_num += nv_sys;
<a name="l00738"></a>00738     }
<a name="l00739"></a>00739 }
<a name="l00740"></a>00740 
<a name="l00741"></a>00741 
<a name="l00742"></a>00742 
<a name="l00743"></a><a class="code" href="classEquationSystems.php#a7f8f6056eeb487a21bb626a522772a65">00743</a> <span class="keywordtype">bool</span> <a class="code" href="classEquationSystems.php#a7f8f6056eeb487a21bb626a522772a65">EquationSystems::compare</a> (<span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; other_es, 
<a name="l00744"></a>00744                                <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> threshold,
<a name="l00745"></a>00745                                <span class="keyword">const</span> <span class="keywordtype">bool</span> verbose)<span class="keyword"> const</span>
<a name="l00746"></a>00746 <span class="keyword"></span>{
<a name="l00747"></a>00747   <span class="comment">// safety check, whether we handle at least the same number</span>
<a name="l00748"></a>00748   <span class="comment">// of systems</span>
<a name="l00749"></a>00749   std::vector&lt;bool&gt; os_result;
<a name="l00750"></a>00750 
<a name="l00751"></a>00751   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>() != other_es.<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>())
<a name="l00752"></a>00752     {
<a name="l00753"></a>00753       <span class="keywordflow">if</span> (verbose)
<a name="l00754"></a>00754         {
<a name="l00755"></a>00755           std::cout &lt;&lt; <span class="stringliteral">&quot;  Fatal difference. This system handles &quot;</span> 
<a name="l00756"></a>00756                     &lt;&lt; this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>() &lt;&lt; <span class="stringliteral">&quot; systems,&quot;</span> &lt;&lt; std::endl
<a name="l00757"></a>00757                     &lt;&lt; <span class="stringliteral">&quot;  while the other system handles &quot;</span>
<a name="l00758"></a>00758                     &lt;&lt; other_es.<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>() 
<a name="l00759"></a>00759                     &lt;&lt; <span class="stringliteral">&quot; systems.&quot;</span> &lt;&lt; std::endl
<a name="l00760"></a>00760                     &lt;&lt; <span class="stringliteral">&quot;  Aborting comparison.&quot;</span> &lt;&lt; std::endl;
<a name="l00761"></a>00761         }
<a name="l00762"></a>00762       <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00763"></a>00763     }
<a name="l00764"></a>00764   <span class="keywordflow">else</span>
<a name="l00765"></a>00765     {
<a name="l00766"></a>00766       <span class="comment">// start comparing each system      </span>
<a name="l00767"></a>00767       <a class="code" href="classEquationSystems.php#aea46ae961d94d413e72251c3e9ed5a43">const_system_iterator</a>       pos = <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.begin();
<a name="l00768"></a>00768       <span class="keyword">const</span> <a class="code" href="classEquationSystems.php#aea46ae961d94d413e72251c3e9ed5a43">const_system_iterator</a> end = <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.end();
<a name="l00769"></a>00769 
<a name="l00770"></a>00770       <span class="keywordflow">for</span> (; pos != end; ++pos)
<a name="l00771"></a>00771         {
<a name="l00772"></a>00772           <span class="keyword">const</span> std::string&amp; sys_name = pos-&gt;first;
<a name="l00773"></a>00773           <span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp;  system        = *(pos-&gt;second);
<a name="l00774"></a>00774       
<a name="l00775"></a>00775           <span class="comment">// get the other system</span>
<a name="l00776"></a>00776           <span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; other_system   = other_es.<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a> (sys_name);
<a name="l00777"></a>00777 
<a name="l00778"></a>00778           os_result.push_back (system.<a class="code" href="classSystem.php#aaf10bae4e91cb13989a0824283c1865e">compare</a> (other_system, threshold, verbose));
<a name="l00779"></a>00779 
<a name="l00780"></a>00780         }
<a name="l00781"></a>00781 
<a name="l00782"></a>00782     }
<a name="l00783"></a>00783   
<a name="l00784"></a>00784 
<a name="l00785"></a>00785   <span class="comment">// sum up the results</span>
<a name="l00786"></a>00786   <span class="keywordflow">if</span> (os_result.size()==0)
<a name="l00787"></a>00787     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00788"></a>00788   <span class="keywordflow">else</span>
<a name="l00789"></a>00789     {
<a name="l00790"></a>00790       <span class="keywordtype">bool</span> os_identical;
<a name="l00791"></a>00791       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = 0;
<a name="l00792"></a>00792           <span class="keywordflow">do</span>
<a name="l00793"></a>00793             {
<a name="l00794"></a>00794               os_identical = os_result[n];
<a name="l00795"></a>00795               n++;
<a name="l00796"></a>00796             }
<a name="l00797"></a>00797           <span class="keywordflow">while</span> (os_identical &amp;&amp; n&lt;os_result.size());
<a name="l00798"></a>00798           <span class="keywordflow">return</span> os_identical;
<a name="l00799"></a>00799         }
<a name="l00800"></a>00800 }
<a name="l00801"></a>00801 
<a name="l00802"></a>00802 
<a name="l00803"></a>00803 
<a name="l00804"></a><a class="code" href="classEquationSystems.php#ad91f3e2b02488efe96ff90482823abf6">00804</a> std::string <a class="code" href="classEquationSystems.php#ad91f3e2b02488efe96ff90482823abf6">EquationSystems::get_info</a> ()<span class="keyword"> const</span>
<a name="l00805"></a>00805 <span class="keyword"></span>{
<a name="l00806"></a>00806   std::ostringstream out;
<a name="l00807"></a>00807   
<a name="l00808"></a>00808   out &lt;&lt; <span class="stringliteral">&quot; EquationSystems\n&quot;</span>
<a name="l00809"></a>00809       &lt;&lt; <span class="stringliteral">&quot;  n_systems()=&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>() &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00810"></a>00810 
<a name="l00811"></a>00811   <span class="comment">// Print the info for the individual systems</span>
<a name="l00812"></a>00812   <a class="code" href="classEquationSystems.php#aea46ae961d94d413e72251c3e9ed5a43">const_system_iterator</a>       pos = <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.begin();
<a name="l00813"></a>00813   <span class="keyword">const</span> <a class="code" href="classEquationSystems.php#aea46ae961d94d413e72251c3e9ed5a43">const_system_iterator</a> end = <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.end();
<a name="l00814"></a>00814 
<a name="l00815"></a>00815   <span class="keywordflow">for</span> (; pos != end; ++pos)
<a name="l00816"></a>00816     out &lt;&lt; pos-&gt;second-&gt;get_info();
<a name="l00817"></a>00817 
<a name="l00818"></a>00818   
<a name="l00819"></a>00819 <span class="comment">//   // Possibly print the parameters  </span>
<a name="l00820"></a>00820 <span class="comment">//   if (!this-&gt;parameters.empty())</span>
<a name="l00821"></a>00821 <span class="comment">//     {  </span>
<a name="l00822"></a>00822 <span class="comment">//       out &lt;&lt; &quot;  n_parameters()=&quot; &lt;&lt; this-&gt;n_parameters() &lt;&lt; &#39;\n&#39;;</span>
<a name="l00823"></a>00823 <span class="comment">//       out &lt;&lt; &quot;   Parameters:\n&quot;;</span>
<a name="l00824"></a>00824       
<a name="l00825"></a>00825 <span class="comment">//       for (std::map&lt;std::string, Real&gt;::const_iterator</span>
<a name="l00826"></a>00826 <span class="comment">//           param = _parameters.begin(); param != _parameters.end();</span>
<a name="l00827"></a>00827 <span class="comment">//         ++param)</span>
<a name="l00828"></a>00828 <span class="comment">//      out &lt;&lt; &quot;    &quot;</span>
<a name="l00829"></a>00829 <span class="comment">//          &lt;&lt; &quot;\&quot;&quot;</span>
<a name="l00830"></a>00830 <span class="comment">//          &lt;&lt; param-&gt;first</span>
<a name="l00831"></a>00831 <span class="comment">//          &lt;&lt; &quot;\&quot;&quot;</span>
<a name="l00832"></a>00832 <span class="comment">//          &lt;&lt; &quot;=&quot;</span>
<a name="l00833"></a>00833 <span class="comment">//          &lt;&lt; param-&gt;second</span>
<a name="l00834"></a>00834 <span class="comment">//          &lt;&lt; &#39;\n&#39;;</span>
<a name="l00835"></a>00835 <span class="comment">//     }</span>
<a name="l00836"></a>00836   
<a name="l00837"></a>00837   <span class="keywordflow">return</span> out.str();
<a name="l00838"></a>00838 }
<a name="l00839"></a>00839 
<a name="l00840"></a>00840 
<a name="l00841"></a>00841 
<a name="l00842"></a><a class="code" href="classEquationSystems.php#a930d1917878bd26eddbe8a1184479cc8">00842</a> <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#a930d1917878bd26eddbe8a1184479cc8">EquationSystems::print_info</a> (std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00843"></a>00843 <span class="keyword"></span>{
<a name="l00844"></a>00844   os &lt;&lt; this-&gt;<a class="code" href="classEquationSystems.php#ad91f3e2b02488efe96ff90482823abf6">get_info</a>()
<a name="l00845"></a>00845      &lt;&lt; std::endl;
<a name="l00846"></a>00846 }
<a name="l00847"></a>00847 
<a name="l00848"></a>00848 
<a name="l00849"></a>00849 
<a name="l00850"></a><a class="code" href="equation__systems_8C.php#ae8191f2a6f0692077b46bbe60899a860">00850</a> std::ostream&amp; <a class="code" href="fe__base_8C.php#af707d8f04488db8220405623626a146a">operator &lt;&lt; </a>(std::ostream&amp; os, <span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es)
<a name="l00851"></a>00851 {
<a name="l00852"></a>00852   es.<a class="code" href="classEquationSystems.php#a930d1917878bd26eddbe8a1184479cc8">print_info</a>(os);
<a name="l00853"></a>00853   <span class="keywordflow">return</span> os;
<a name="l00854"></a>00854 }
<a name="l00855"></a>00855 
<a name="l00856"></a>00856 
<a name="l00857"></a>00857 
<a name="l00858"></a><a class="code" href="classEquationSystems.php#af52cb13b16614472c431787e868aba25">00858</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEquationSystems.php#af52cb13b16614472c431787e868aba25">EquationSystems::n_vars</a> ()<span class="keyword"> const</span>
<a name="l00859"></a>00859 <span class="keyword"></span>{
<a name="l00860"></a>00860   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tot=0;
<a name="l00861"></a>00861   
<a name="l00862"></a>00862   <a class="code" href="classEquationSystems.php#aea46ae961d94d413e72251c3e9ed5a43">const_system_iterator</a>       pos = <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.begin();
<a name="l00863"></a>00863   <span class="keyword">const</span> <a class="code" href="classEquationSystems.php#aea46ae961d94d413e72251c3e9ed5a43">const_system_iterator</a> end = <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.end();
<a name="l00864"></a>00864 
<a name="l00865"></a>00865   <span class="keywordflow">for</span> (; pos != end; ++pos)
<a name="l00866"></a>00866     tot += pos-&gt;second-&gt;n_vars();
<a name="l00867"></a>00867 
<a name="l00868"></a>00868   <span class="keywordflow">return</span> tot;
<a name="l00869"></a>00869 }
<a name="l00870"></a>00870 
<a name="l00871"></a>00871 
<a name="l00872"></a>00872 
<a name="l00873"></a><a class="code" href="classEquationSystems.php#ac548420db0ce387f33b20f218b1b4487">00873</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEquationSystems.php#ac548420db0ce387f33b20f218b1b4487">EquationSystems::n_dofs</a> ()<span class="keyword"> const</span>
<a name="l00874"></a>00874 <span class="keyword"></span>{
<a name="l00875"></a>00875   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tot=0;
<a name="l00876"></a>00876 
<a name="l00877"></a>00877   <a class="code" href="classEquationSystems.php#aea46ae961d94d413e72251c3e9ed5a43">const_system_iterator</a>       pos = <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.begin();
<a name="l00878"></a>00878   <span class="keyword">const</span> <a class="code" href="classEquationSystems.php#aea46ae961d94d413e72251c3e9ed5a43">const_system_iterator</a> end = <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.end();
<a name="l00879"></a>00879 
<a name="l00880"></a>00880   <span class="keywordflow">for</span> (; pos != end; ++pos)
<a name="l00881"></a>00881     tot += pos-&gt;second-&gt;n_dofs();
<a name="l00882"></a>00882 
<a name="l00883"></a>00883   <span class="keywordflow">return</span> tot;      
<a name="l00884"></a>00884 }
<a name="l00885"></a>00885 
<a name="l00886"></a>00886 
<a name="l00887"></a>00887 
<a name="l00888"></a>00888 
<a name="l00889"></a><a class="code" href="classEquationSystems.php#a135b732614c018d669fd524d9856336f">00889</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEquationSystems.php#a135b732614c018d669fd524d9856336f">EquationSystems::n_active_dofs</a> ()<span class="keyword"> const</span>
<a name="l00890"></a>00890 <span class="keyword"></span>{
<a name="l00891"></a>00891   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tot=0;
<a name="l00892"></a>00892 
<a name="l00893"></a>00893   <a class="code" href="classEquationSystems.php#aea46ae961d94d413e72251c3e9ed5a43">const_system_iterator</a>       pos = <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.begin();
<a name="l00894"></a>00894   <span class="keyword">const</span> <a class="code" href="classEquationSystems.php#aea46ae961d94d413e72251c3e9ed5a43">const_system_iterator</a> end = <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.end();
<a name="l00895"></a>00895 
<a name="l00896"></a>00896   <span class="keywordflow">for</span> (; pos != end; ++pos)
<a name="l00897"></a>00897     tot += pos-&gt;second-&gt;n_active_dofs();
<a name="l00898"></a>00898 
<a name="l00899"></a>00899   <span class="keywordflow">return</span> tot;      
<a name="l00900"></a>00900 }
<a name="l00901"></a>00901 
<a name="l00902"></a>00902 
<a name="l00903"></a><a class="code" href="classEquationSystems.php#a0dbc28100a1ce4eefc85063525d36670">00903</a> <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#a0dbc28100a1ce4eefc85063525d36670">EquationSystems::_add_system_to_nodes_and_elems</a>()
<a name="l00904"></a>00904 {
<a name="l00905"></a>00905   <span class="comment">// All the nodes</span>
<a name="l00906"></a>00906   <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>       node_it  = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
<a name="l00907"></a>00907   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> node_end = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
<a name="l00908"></a>00908  
<a name="l00909"></a>00909   <span class="keywordflow">for</span> ( ; node_it != node_end; ++node_it)
<a name="l00910"></a>00910     (*node_it)-&gt;add_system();
<a name="l00911"></a>00911  
<a name="l00912"></a>00912   <span class="comment">// All the elements</span>
<a name="l00913"></a>00913   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00914"></a>00914   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00915"></a>00915  
<a name="l00916"></a>00916   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00917"></a>00917     (*elem_it)-&gt;add_system();
<a name="l00918"></a>00918 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
