<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>equation_systems.h</h1>  </div>
</div>
<div class="contents">
<a href="equation__systems_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: equation_systems.h 3482 2009-10-06 01:22:40Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __equation_systems_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __equation_systems_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Local Includes</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;parameters.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;enum_xdr_mode.h&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// HP aCC needs these for some reason</span>
<a name="l00038"></a>00038 <span class="preprocessor">#ifdef __HP_aCC</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span><span class="preprocessor"># include &quot;<a class="code" href="frequency__system_8h.php">frequency_system.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor"># include &quot;<a class="code" href="transient__system_8h.php">transient_system.h</a>&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor"># include &quot;<a class="code" href="newmark__system_8h.php">newmark_system.h</a>&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor"># include &quot;<a class="code" href="steady__system_8h.php">steady_system.h</a>&quot;</span>
<a name="l00043"></a>00043 <span class="preprocessor">#endif</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span>
<a name="l00045"></a>00045 <span class="comment">// Forward Declarations</span>
<a name="l00046"></a>00046 <span class="keyword">class </span><a class="code" href="classMeshData.php">MeshData</a>;
<a name="l00047"></a>00047 <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00048"></a>00048 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00049"></a>00049 
<a name="l00063"></a>00063 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00064"></a>00064 <span class="comment">// EquationSystems class definition</span>
<a name="l00065"></a><a class="code" href="classEquationSystems.php">00065</a> <span class="keyword">class </span><a class="code" href="classEquationSystems.php">EquationSystems</a>
<a name="l00066"></a>00066 {
<a name="l00067"></a>00067 <span class="keyword">public</span>:
<a name="l00068"></a>00068 
<a name="l00072"></a><a class="code" href="classEquationSystems.php#ab5d246c73c9a7ebce00573b3480c4ba3">00072</a>   <span class="keyword">enum</span> <a class="code" href="classEquationSystems.php#ab5d246c73c9a7ebce00573b3480c4ba3">ReadFlags</a> { <a class="code" href="classEquationSystems.php#ab5d246c73c9a7ebce00573b3480c4ba3af34797f4808b79eb41ac35fcb87a0d20">READ_HEADER</a>           = 1,
<a name="l00073"></a><a class="code" href="classEquationSystems.php#ab5d246c73c9a7ebce00573b3480c4ba3a08dd597897f473115b36a60089112624">00073</a>                    <a class="code" href="classEquationSystems.php#ab5d246c73c9a7ebce00573b3480c4ba3a08dd597897f473115b36a60089112624">READ_DATA</a>             = 2,
<a name="l00074"></a><a class="code" href="classEquationSystems.php#ab5d246c73c9a7ebce00573b3480c4ba3a4832aa2eb40b4e1eb401f21da720c875">00074</a>                    <a class="code" href="classEquationSystems.php#ab5d246c73c9a7ebce00573b3480c4ba3a4832aa2eb40b4e1eb401f21da720c875">READ_ADDITIONAL_DATA</a>  = 4,
<a name="l00075"></a><a class="code" href="classEquationSystems.php#ab5d246c73c9a7ebce00573b3480c4ba3acf384725d79f5aee1d6db80df595216e">00075</a>                    <a class="code" href="classEquationSystems.php#ab5d246c73c9a7ebce00573b3480c4ba3acf384725d79f5aee1d6db80df595216e">READ_LEGACY_FORMAT</a>    = 8,
<a name="l00076"></a><a class="code" href="classEquationSystems.php#ab5d246c73c9a7ebce00573b3480c4ba3a577bc1042334eba9e962a4899c7aba06">00076</a>                    <a class="code" href="classEquationSystems.php#ab5d246c73c9a7ebce00573b3480c4ba3a577bc1042334eba9e962a4899c7aba06">TRY_READ_IFEMS</a>        = 16 };
<a name="l00077"></a>00077 
<a name="l00081"></a><a class="code" href="classEquationSystems.php#a08518bf8e6e6861f938ee5b7bac479ef">00081</a>   <span class="keyword">enum</span> <a class="code" href="classEquationSystems.php#a08518bf8e6e6861f938ee5b7bac479ef">WriteFlags</a> { <a class="code" href="classEquationSystems.php#a08518bf8e6e6861f938ee5b7bac479efa73894e56d1841b32c10e7558fb2ef1c5">WRITE_DATA</a>             = 1,
<a name="l00082"></a><a class="code" href="classEquationSystems.php#a08518bf8e6e6861f938ee5b7bac479efa01128f79269492739c7742619c3201f8">00082</a>                     <a class="code" href="classEquationSystems.php#a08518bf8e6e6861f938ee5b7bac479efa01128f79269492739c7742619c3201f8">WRITE_ADDITIONAL_DATA</a>  = 2,
<a name="l00083"></a><a class="code" href="classEquationSystems.php#a08518bf8e6e6861f938ee5b7bac479efa4823cffb8989a2c529f992d92cee9b50">00083</a>                     <a class="code" href="classEquationSystems.php#a08518bf8e6e6861f938ee5b7bac479efa4823cffb8989a2c529f992d92cee9b50">WRITE_PARALLEL_FILES</a>   = 4 };
<a name="l00084"></a>00084   
<a name="l00088"></a>00088   <a class="code" href="classEquationSystems.php#ac9b651e5c2f2bf9a0f0afa6cde26ee0c">EquationSystems</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh, <a class="code" href="classMeshData.php">MeshData</a>* mesh_data=NULL);
<a name="l00089"></a>00089 
<a name="l00094"></a>00094   <span class="keyword">virtual</span> <a class="code" href="classEquationSystems.php#acfcb6bbe16cc1e340d99892e29f53093">~EquationSystems</a> ();
<a name="l00095"></a>00095  
<a name="l00099"></a>00099   <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#aa6c27c022e0616ccbce649cfdccdeae8">clear</a> ();
<a name="l00100"></a>00100   
<a name="l00104"></a>00104   <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#a759b6d1f3fa9dff14c6618bf725f060a">init</a> ();
<a name="l00105"></a>00105   
<a name="l00109"></a>00109   <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#a55f8c311a2ff890d0919b3fa4609d9df">reinit</a> ();
<a name="l00110"></a>00110 
<a name="l00114"></a>00114   <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#a1ca915358810720dbfba739ddaedaa6f">update</a> ();
<a name="l00115"></a>00115 
<a name="l00119"></a>00119   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>() <span class="keyword">const</span>;
<a name="l00120"></a>00120 
<a name="l00125"></a>00125   <span class="keywordtype">bool</span> <a class="code" href="classEquationSystems.php#a547e381d557dd9c29b9f08aa87f146a0">has_system</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>) <span class="keyword">const</span>;
<a name="l00126"></a>00126 
<a name="l00133"></a>00133   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T_sys&gt;
<a name="l00134"></a>00134   <span class="keyword">const</span> T_sys &amp; <a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>) <span class="keyword">const</span>;
<a name="l00135"></a>00135 
<a name="l00142"></a>00142   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T_sys&gt;
<a name="l00143"></a>00143   T_sys &amp; <a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>);
<a name="l00144"></a>00144 
<a name="l00151"></a>00151   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T_sys&gt;
<a name="l00152"></a>00152   <span class="keyword">const</span> T_sys &amp; <a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num) <span class="keyword">const</span>;
<a name="l00153"></a>00153 
<a name="l00160"></a>00160   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T_sys&gt;
<a name="l00161"></a>00161   T_sys &amp; <a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num);
<a name="l00162"></a>00162 
<a name="l00166"></a>00166   <span class="keyword">const</span> <a class="code" href="classSystem.php">System</a> &amp; <a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>) <span class="keyword">const</span>;
<a name="l00167"></a>00167 
<a name="l00171"></a>00171   <a class="code" href="classSystem.php">System</a> &amp; <a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>);
<a name="l00172"></a>00172 
<a name="l00176"></a>00176   <span class="keyword">const</span> <a class="code" href="classSystem.php">System</a> &amp; <a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num) <span class="keyword">const</span>;
<a name="l00177"></a>00177 
<a name="l00181"></a>00181   <a class="code" href="classSystem.php">System</a> &amp; <a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num);
<a name="l00182"></a>00182   
<a name="l00187"></a>00187   <a class="code" href="classSystem.php">System</a> &amp; <a class="code" href="classEquationSystems.php#a6fbb47f48cfad09bb1b9562ae1e9b24a">add_system</a> (<span class="keyword">const</span> std::string&amp; system_type,
<a name="l00188"></a>00188                        <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>);
<a name="l00189"></a>00189   
<a name="l00193"></a>00193   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T_sys&gt;
<a name="l00194"></a>00194   T_sys &amp; <a class="code" href="classEquationSystems.php#a6fbb47f48cfad09bb1b9562ae1e9b24a">add_system</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>);
<a name="l00195"></a>00195   
<a name="l00201"></a>00201   <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#a25930bf00b3b3ebb7dfdbc6954ae99d0">delete_system</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>);
<a name="l00202"></a>00202 
<a name="l00207"></a>00207   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEquationSystems.php#af52cb13b16614472c431787e868aba25">n_vars</a> () <span class="keyword">const</span>;
<a name="l00208"></a>00208   
<a name="l00213"></a>00213   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEquationSystems.php#ac548420db0ce387f33b20f218b1b4487">n_dofs</a> () <span class="keyword">const</span>;
<a name="l00214"></a>00214 
<a name="l00219"></a>00219   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEquationSystems.php#a135b732614c018d669fd524d9856336f">n_active_dofs</a>() <span class="keyword">const</span>;
<a name="l00220"></a>00220   
<a name="l00229"></a>00229   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#aef3aa48d457508bf35043667dab8bd5b">solve</a> ();
<a name="l00230"></a>00230   
<a name="l00239"></a>00239   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#a92d62c14a28b6a0010801da36511ff37">adjoint_solve</a> ();
<a name="l00240"></a>00240 
<a name="l00245"></a>00245   <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#a90e9f4c77f1abf585f741c303e5edc29">build_variable_names</a> (std::vector&lt;std::string&gt;&amp; var_names) <span class="keyword">const</span>;
<a name="l00246"></a>00246 
<a name="l00253"></a>00253   <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#aa7e2afc9d649b35d6bf1a2e8185b4169">build_solution_vector</a> (std::vector&lt;Number&gt;&amp; soln,
<a name="l00254"></a>00254                               <span class="keyword">const</span> std::string&amp; system_name,
<a name="l00255"></a>00255                               <span class="keyword">const</span> std::string&amp; variable_name = <span class="stringliteral">&quot;all_vars&quot;</span>) <span class="keyword">const</span>;
<a name="l00256"></a>00256   
<a name="l00262"></a>00262   <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#aa7e2afc9d649b35d6bf1a2e8185b4169">build_solution_vector</a> (std::vector&lt;Number&gt;&amp; soln) <span class="keyword">const</span>;
<a name="l00263"></a>00263   
<a name="l00269"></a>00269   <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#a5a54b3b13598a5d9db59b9053253af5b">build_discontinuous_solution_vector</a> (std::vector&lt;Number&gt;&amp; soln) <span class="keyword">const</span>;
<a name="l00270"></a>00270   
<a name="l00284"></a>00284   <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#a5cc0bc9190e5b732e9dde79fe021896e">read</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00285"></a>00285              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">libMeshEnums::XdrMODE</a>,
<a name="l00286"></a>00286              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> read_flags=(<a class="code" href="classEquationSystems.php#ab5d246c73c9a7ebce00573b3480c4ba3af34797f4808b79eb41ac35fcb87a0d20">READ_HEADER</a> | <a class="code" href="classEquationSystems.php#ab5d246c73c9a7ebce00573b3480c4ba3a08dd597897f473115b36a60089112624">READ_DATA</a>));
<a name="l00287"></a>00287 
<a name="l00300"></a>00300   <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#a9bd64dc690ae78f452306407434a615b">write</a> (<span class="keyword">const</span> std::string&amp; name,
<a name="l00301"></a>00301               <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">libMeshEnums::XdrMODE</a>,
<a name="l00302"></a>00302               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> write_flags=(<a class="code" href="classEquationSystems.php#a08518bf8e6e6861f938ee5b7bac479efa73894e56d1841b32c10e7558fb2ef1c5">WRITE_DATA</a>)) <span class="keyword">const</span>;
<a name="l00303"></a>00303 
<a name="l00310"></a>00310   <span class="keywordtype">bool</span> <a class="code" href="classEquationSystems.php#a7f8f6056eeb487a21bb626a522772a65">compare</a> (<span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; other_es, 
<a name="l00311"></a>00311                 <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> threshold,
<a name="l00312"></a>00312                 <span class="keyword">const</span> <span class="keywordtype">bool</span> verbose) <span class="keyword">const</span>;
<a name="l00313"></a>00313 
<a name="l00318"></a>00318   std::string <a class="code" href="classEquationSystems.php#ad91f3e2b02488efe96ff90482823abf6">get_info</a>() <span class="keyword">const</span>;
<a name="l00319"></a>00319     
<a name="l00323"></a>00323   <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#a930d1917878bd26eddbe8a1184479cc8">print_info</a> (std::ostream&amp; os=std::cout) <span class="keyword">const</span>;
<a name="l00324"></a>00324 
<a name="l00328"></a>00328   <span class="keyword">friend</span> std::ostream&amp; <a class="code" href="classEquationSystems.php#ae8191f2a6f0692077b46bbe60899a860">operator &lt;&lt; </a>(std::ostream&amp; os, <span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es);
<a name="l00329"></a>00329 
<a name="l00333"></a>00333   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp; <a class="code" href="classEquationSystems.php#ad8d458ae6a34c460e72b3279373d4a70">get_mesh</a>() <span class="keyword">const</span>;
<a name="l00334"></a>00334 
<a name="l00338"></a>00338   <a class="code" href="classMeshBase.php">MeshBase</a> &amp; <a class="code" href="classEquationSystems.php#ad8d458ae6a34c460e72b3279373d4a70">get_mesh</a>();
<a name="l00339"></a>00339 
<a name="l00344"></a>00344   <span class="keywordtype">bool</span> <a class="code" href="classEquationSystems.php#a0c776f91f0bf06b8fa98421667987d7e">has_mesh_data</a>() <span class="keyword">const</span>;
<a name="l00345"></a>00345 
<a name="l00349"></a>00349   <span class="keyword">const</span> <a class="code" href="classMeshData.php">MeshData</a> &amp; <a class="code" href="classEquationSystems.php#a64744b85321ab2d4e7bbaed594b5f2b2">get_mesh_data</a>() <span class="keyword">const</span>;
<a name="l00350"></a>00350 
<a name="l00354"></a>00354   <a class="code" href="classMeshData.php">MeshData</a> &amp; <a class="code" href="classEquationSystems.php#a64744b85321ab2d4e7bbaed594b5f2b2">get_mesh_data</a>();
<a name="l00355"></a>00355 
<a name="l00360"></a>00360   <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#a89388a8d069d1ea2e24f3e8853e6d621">allgather</a> ();
<a name="l00361"></a>00361 
<a name="l00362"></a>00362 
<a name="l00366"></a><a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">00366</a>   <a class="code" href="classParameters.php">Parameters</a> <a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>;
<a name="l00367"></a>00367 
<a name="l00368"></a>00368   
<a name="l00369"></a>00369 <span class="keyword">protected</span>:
<a name="l00370"></a>00370 
<a name="l00371"></a>00371   
<a name="l00375"></a><a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">00375</a>   <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>;
<a name="l00376"></a>00376 
<a name="l00381"></a><a class="code" href="classEquationSystems.php#a2115824972d00c5f58d3af3a3c72b436">00381</a>   <a class="code" href="classMeshData.php">MeshData</a>* <a class="code" href="classEquationSystems.php#a2115824972d00c5f58d3af3a3c72b436">_mesh_data</a>;
<a name="l00382"></a>00382 
<a name="l00386"></a><a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">00386</a>   std::map&lt;std::string, System*&gt; <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>;
<a name="l00387"></a>00387 
<a name="l00391"></a><a class="code" href="classEquationSystems.php#a5f8dd96a6d9202f5da5e9f201c4d0d03">00391</a>   <span class="keyword">typedef</span> std::map&lt;std::string, System*&gt;::iterator       <a class="code" href="classEquationSystems.php#a5f8dd96a6d9202f5da5e9f201c4d0d03">system_iterator</a>;
<a name="l00392"></a>00392 
<a name="l00396"></a><a class="code" href="classEquationSystems.php#aea46ae961d94d413e72251c3e9ed5a43">00396</a>   <span class="keyword">typedef</span> std::map&lt;std::string, System*&gt;::const_iterator <a class="code" href="classEquationSystems.php#aea46ae961d94d413e72251c3e9ed5a43">const_system_iterator</a>;
<a name="l00397"></a>00397 
<a name="l00398"></a>00398 <span class="keyword">private</span>:
<a name="l00399"></a>00399     
<a name="l00404"></a>00404   <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#a58c6c81777499821aac070121a66172e">_read_impl</a> (<span class="keyword">const</span> std::string&amp; name,
<a name="l00405"></a>00405                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">libMeshEnums::XdrMODE</a>,
<a name="l00406"></a>00406                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> read_flags);
<a name="l00407"></a>00407 
<a name="l00414"></a>00414   <span class="keywordtype">void</span> <a class="code" href="classEquationSystems.php#a0dbc28100a1ce4eefc85063525d36670">_add_system_to_nodes_and_elems</a>();
<a name="l00415"></a>00415 };
<a name="l00416"></a>00416 
<a name="l00417"></a>00417 
<a name="l00418"></a>00418 
<a name="l00419"></a>00419 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00420"></a>00420 <span class="comment">// EquationSystems inline methods</span>
<a name="l00421"></a>00421 <span class="keyword">inline</span>
<a name="l00422"></a><a class="code" href="classEquationSystems.php#ad8d458ae6a34c460e72b3279373d4a70">00422</a> <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp; <a class="code" href="classEquationSystems.php#ad8d458ae6a34c460e72b3279373d4a70">EquationSystems::get_mesh</a> ()<span class="keyword"> const</span>
<a name="l00423"></a>00423 <span class="keyword"></span>{
<a name="l00424"></a>00424   <span class="keywordflow">return</span> <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>;
<a name="l00425"></a>00425 }
<a name="l00426"></a>00426 
<a name="l00427"></a>00427 
<a name="l00428"></a>00428 
<a name="l00429"></a>00429 <span class="keyword">inline</span>
<a name="l00430"></a><a class="code" href="classEquationSystems.php#a3ac4145330dc95053ec77193f2cb18e8">00430</a> <a class="code" href="classMeshBase.php">MeshBase</a> &amp; <a class="code" href="classEquationSystems.php#ad8d458ae6a34c460e72b3279373d4a70">EquationSystems::get_mesh</a> ()
<a name="l00431"></a>00431 {
<a name="l00432"></a>00432   <span class="keywordflow">return</span> <a class="code" href="classEquationSystems.php#ae44b6124ec3527af2e7c897b8ee13ccb">_mesh</a>;
<a name="l00433"></a>00433 }
<a name="l00434"></a>00434 
<a name="l00435"></a>00435 
<a name="l00436"></a>00436 <span class="keyword">inline</span>
<a name="l00437"></a><a class="code" href="classEquationSystems.php#a64744b85321ab2d4e7bbaed594b5f2b2">00437</a> <span class="keyword">const</span> <a class="code" href="classMeshData.php">MeshData</a> &amp; <a class="code" href="classEquationSystems.php#a64744b85321ab2d4e7bbaed594b5f2b2">EquationSystems::get_mesh_data</a> ()<span class="keyword"> const</span>
<a name="l00438"></a>00438 <span class="keyword"></span>{
<a name="l00439"></a>00439   libmesh_assert (<a class="code" href="classEquationSystems.php#a2115824972d00c5f58d3af3a3c72b436">_mesh_data</a> != NULL);
<a name="l00440"></a>00440   <span class="keywordflow">return</span> *<a class="code" href="classEquationSystems.php#a2115824972d00c5f58d3af3a3c72b436">_mesh_data</a>;
<a name="l00441"></a>00441 }
<a name="l00442"></a>00442 
<a name="l00443"></a>00443 
<a name="l00444"></a>00444 <span class="keyword">inline</span>
<a name="l00445"></a><a class="code" href="classEquationSystems.php#afaf6b6d97461428917269795cda9707c">00445</a> <a class="code" href="classMeshData.php">MeshData</a> &amp; <a class="code" href="classEquationSystems.php#a64744b85321ab2d4e7bbaed594b5f2b2">EquationSystems::get_mesh_data</a> ()
<a name="l00446"></a>00446 {
<a name="l00447"></a>00447   libmesh_assert (<a class="code" href="classEquationSystems.php#a2115824972d00c5f58d3af3a3c72b436">_mesh_data</a> != NULL);
<a name="l00448"></a>00448   <span class="keywordflow">return</span> *<a class="code" href="classEquationSystems.php#a2115824972d00c5f58d3af3a3c72b436">_mesh_data</a>;
<a name="l00449"></a>00449 }
<a name="l00450"></a>00450 
<a name="l00451"></a>00451 <span class="keyword">inline</span>
<a name="l00452"></a><a class="code" href="classEquationSystems.php#a0c776f91f0bf06b8fa98421667987d7e">00452</a> <span class="keywordtype">bool</span> <a class="code" href="classEquationSystems.php#a0c776f91f0bf06b8fa98421667987d7e">EquationSystems::has_mesh_data</a> ()<span class="keyword"> const </span>
<a name="l00453"></a>00453 <span class="keyword"></span>{
<a name="l00454"></a>00454   <span class="keywordflow">return</span> (<a class="code" href="classEquationSystems.php#a2115824972d00c5f58d3af3a3c72b436">_mesh_data</a>!=NULL);
<a name="l00455"></a>00455 }
<a name="l00456"></a>00456 
<a name="l00457"></a>00457 
<a name="l00458"></a>00458 <span class="keyword">inline</span>
<a name="l00459"></a><a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">00459</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">EquationSystems::n_systems</a> ()<span class="keyword"> const</span>
<a name="l00460"></a>00460 <span class="keyword"></span>{
<a name="l00461"></a>00461   <span class="keywordflow">return</span> <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.size();
<a name="l00462"></a>00462 }
<a name="l00463"></a>00463 
<a name="l00464"></a>00464 
<a name="l00465"></a>00465 
<a name="l00466"></a>00466 
<a name="l00467"></a>00467 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T_sys&gt;
<a name="l00468"></a>00468 <span class="keyword">inline</span>
<a name="l00469"></a><a class="code" href="classEquationSystems.php#a200ac21bf2e26e968de75a9936343205">00469</a> T_sys &amp; <a class="code" href="classEquationSystems.php#a6fbb47f48cfad09bb1b9562ae1e9b24a">EquationSystems::add_system</a> (<span class="keyword">const</span> std::string&amp; name)
<a name="l00470"></a>00470 {
<a name="l00471"></a>00471   T_sys* ptr = NULL;
<a name="l00472"></a>00472   
<a name="l00473"></a>00473   <span class="keywordflow">if</span> (!<a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.count(name))
<a name="l00474"></a>00474     {
<a name="l00475"></a>00475       ptr = <span class="keyword">new</span> T_sys(*<span class="keyword">this</span>, name, this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>());
<a name="l00476"></a>00476 
<a name="l00477"></a>00477       <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.insert (std::make_pair(name, ptr));   
<a name="l00478"></a>00478 
<a name="l00479"></a>00479       <span class="comment">// Tell all the \p DofObject entities to add a system.</span>
<a name="l00480"></a>00480       this-&gt;<a class="code" href="classEquationSystems.php#a0dbc28100a1ce4eefc85063525d36670">_add_system_to_nodes_and_elems</a>();
<a name="l00481"></a>00481     }
<a name="l00482"></a>00482   <span class="keywordflow">else</span>
<a name="l00483"></a>00483     {
<a name="l00484"></a>00484       <span class="comment">// We now allow redundant add_system calls, to make it</span>
<a name="l00485"></a>00485       <span class="comment">// easier to load data from files for user-derived system</span>
<a name="l00486"></a>00486       <span class="comment">// subclasses</span>
<a name="l00487"></a>00487 <span class="comment">//      std::cerr &lt;&lt; &quot;ERROR: There was already a system&quot;</span>
<a name="l00488"></a>00488 <span class="comment">//              &lt;&lt; &quot; named &quot; &lt;&lt; name</span>
<a name="l00489"></a>00489 <span class="comment">//              &lt;&lt; std::endl;</span>
<a name="l00490"></a>00490 
<a name="l00491"></a>00491 <span class="comment">//      libmesh_error();</span>
<a name="l00492"></a>00492 
<a name="l00493"></a>00493       ptr = &amp;(this-&gt;get_system&lt;T_sys&gt;(<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>));
<a name="l00494"></a>00494     }
<a name="l00495"></a>00495 
<a name="l00496"></a>00496   <span class="comment">// Return a dynamically casted reference to the newly added System.</span>
<a name="l00497"></a>00497   <span class="keywordflow">return</span> *ptr;
<a name="l00498"></a>00498 }
<a name="l00499"></a>00499 
<a name="l00500"></a>00500 
<a name="l00501"></a>00501 
<a name="l00502"></a>00502 <span class="keyword">inline</span>
<a name="l00503"></a><a class="code" href="classEquationSystems.php#a547e381d557dd9c29b9f08aa87f146a0">00503</a> <span class="keywordtype">bool</span> <a class="code" href="classEquationSystems.php#a547e381d557dd9c29b9f08aa87f146a0">EquationSystems::has_system</a> (<span class="keyword">const</span> std::string&amp; name)<span class="keyword"> const</span>
<a name="l00504"></a>00504 <span class="keyword"></span>{
<a name="l00505"></a>00505   <span class="keywordflow">if</span> (<a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.find(name) == <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.end())
<a name="l00506"></a>00506     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00507"></a>00507   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00508"></a>00508 }
<a name="l00509"></a>00509 
<a name="l00510"></a>00510 
<a name="l00511"></a>00511 
<a name="l00512"></a>00512 
<a name="l00513"></a>00513 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T_sys&gt;
<a name="l00514"></a>00514 <span class="keyword">inline</span>
<a name="l00515"></a><a class="code" href="classEquationSystems.php#a16bb0d71bc46992d2bc8296f6d64dc05">00515</a> <span class="keyword">const</span> T_sys &amp; <a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">EquationSystems::get_system</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num)<span class="keyword"> const</span>
<a name="l00516"></a>00516 <span class="keyword"></span>{
<a name="l00517"></a>00517   libmesh_assert (num &lt; this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>());
<a name="l00518"></a>00518 
<a name="l00519"></a>00519 
<a name="l00520"></a>00520   <a class="code" href="classEquationSystems.php#aea46ae961d94d413e72251c3e9ed5a43">const_system_iterator</a>       pos = <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.begin();
<a name="l00521"></a>00521   <span class="keyword">const</span> <a class="code" href="classEquationSystems.php#aea46ae961d94d413e72251c3e9ed5a43">const_system_iterator</a> end = <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.end();
<a name="l00522"></a>00522 
<a name="l00523"></a>00523   <span class="keywordflow">for</span> (; pos != end; ++pos)
<a name="l00524"></a>00524     <span class="keywordflow">if</span> (pos-&gt;second-&gt;number() == num)
<a name="l00525"></a>00525       <span class="keywordflow">break</span>;
<a name="l00526"></a>00526 
<a name="l00527"></a>00527   <span class="comment">// Check for errors</span>
<a name="l00528"></a>00528   <span class="keywordflow">if</span> (pos == end)
<a name="l00529"></a>00529     {
<a name="l00530"></a>00530       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: no system number &quot;</span> &lt;&lt; num &lt;&lt; <span class="stringliteral">&quot; found!&quot;</span>
<a name="l00531"></a>00531                 &lt;&lt; std::endl;
<a name="l00532"></a>00532       libmesh_error();
<a name="l00533"></a>00533     }
<a name="l00534"></a>00534 
<a name="l00535"></a>00535   <span class="comment">// Attempt dynamic cast</span>
<a name="l00536"></a>00536   T_sys* ptr = <span class="keyword">dynamic_cast&lt;</span>T_sys*<span class="keyword">&gt;</span>(pos-&gt;second);
<a name="l00537"></a>00537 
<a name="l00538"></a>00538   <span class="comment">// Check for failure of dynamic cast</span>
<a name="l00539"></a>00539   <span class="keywordflow">if</span> (ptr == NULL)
<a name="l00540"></a>00540     {
<a name="l00541"></a>00541       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: cannot convert system &quot;</span>
<a name="l00542"></a>00542                 &lt;&lt; num &lt;&lt; <span class="stringliteral">&quot; to requested type!&quot;</span>
<a name="l00543"></a>00543                 &lt;&lt; std::endl;
<a name="l00544"></a>00544       libmesh_error();
<a name="l00545"></a>00545     }
<a name="l00546"></a>00546   
<a name="l00547"></a>00547   <span class="keywordflow">return</span> *ptr;
<a name="l00548"></a>00548 }
<a name="l00549"></a>00549 
<a name="l00550"></a>00550 
<a name="l00551"></a>00551 
<a name="l00552"></a>00552 
<a name="l00553"></a>00553 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T_sys&gt;
<a name="l00554"></a>00554 <span class="keyword">inline</span>
<a name="l00555"></a><a class="code" href="classEquationSystems.php#a300409f6f7612c71538bc0e7270b6486">00555</a> T_sys &amp; <a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">EquationSystems::get_system</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num)
<a name="l00556"></a>00556 {
<a name="l00557"></a>00557   libmesh_assert (num &lt; this-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>());
<a name="l00558"></a>00558   
<a name="l00559"></a>00559   <a class="code" href="classEquationSystems.php#aea46ae961d94d413e72251c3e9ed5a43">const_system_iterator</a>       pos = <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.begin();
<a name="l00560"></a>00560   <span class="keyword">const</span> <a class="code" href="classEquationSystems.php#aea46ae961d94d413e72251c3e9ed5a43">const_system_iterator</a> end = <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.end();
<a name="l00561"></a>00561 
<a name="l00562"></a>00562   <span class="keywordflow">for</span> (; pos != end; ++pos)
<a name="l00563"></a>00563     <span class="keywordflow">if</span> (pos-&gt;second-&gt;number() == num)
<a name="l00564"></a>00564       <span class="keywordflow">break</span>;
<a name="l00565"></a>00565 
<a name="l00566"></a>00566   <span class="comment">// Check for errors</span>
<a name="l00567"></a>00567   <span class="keywordflow">if</span> (pos == end)
<a name="l00568"></a>00568     {
<a name="l00569"></a>00569       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: no system number &quot;</span> &lt;&lt; num &lt;&lt; <span class="stringliteral">&quot; found!&quot;</span>
<a name="l00570"></a>00570                 &lt;&lt; std::endl;
<a name="l00571"></a>00571       libmesh_error();
<a name="l00572"></a>00572     }
<a name="l00573"></a>00573 
<a name="l00574"></a>00574   <span class="comment">// Attempt dynamic cast</span>
<a name="l00575"></a>00575   T_sys* ptr = <span class="keyword">dynamic_cast&lt;</span>T_sys*<span class="keyword">&gt;</span>(pos-&gt;second);
<a name="l00576"></a>00576 
<a name="l00577"></a>00577   <span class="comment">// Check for failure of dynamic cast</span>
<a name="l00578"></a>00578   <span class="keywordflow">if</span> (ptr == NULL)
<a name="l00579"></a>00579     {
<a name="l00580"></a>00580       LIBMESH_THROW(<a class="code" href="classlibMesh_1_1DynamicCastFailure.php">libMesh::DynamicCastFailure</a>());
<a name="l00581"></a>00581     }
<a name="l00582"></a>00582 
<a name="l00583"></a>00583   <span class="keywordflow">return</span> *ptr; 
<a name="l00584"></a>00584 }
<a name="l00585"></a>00585 
<a name="l00586"></a>00586 
<a name="l00587"></a>00587 
<a name="l00588"></a>00588 
<a name="l00589"></a>00589 
<a name="l00590"></a>00590 
<a name="l00591"></a>00591 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T_sys&gt;
<a name="l00592"></a>00592 <span class="keyword">inline</span>
<a name="l00593"></a><a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">00593</a> <span class="keyword">const</span> T_sys &amp; <a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">EquationSystems::get_system</a> (<span class="keyword">const</span> std::string&amp; name)<span class="keyword"> const</span>
<a name="l00594"></a>00594 <span class="keyword"></span>{
<a name="l00595"></a>00595   <a class="code" href="classEquationSystems.php#aea46ae961d94d413e72251c3e9ed5a43">const_system_iterator</a> pos = <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.find(name);
<a name="l00596"></a>00596 
<a name="l00597"></a>00597   <span class="comment">// Check for errors</span>
<a name="l00598"></a>00598   <span class="keywordflow">if</span> (pos == <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.end())
<a name="l00599"></a>00599     {
<a name="l00600"></a>00600       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: no system named \&quot;&quot;</span> &lt;&lt; name &lt;&lt; <span class="stringliteral">&quot;\&quot; found!&quot;</span>
<a name="l00601"></a>00601                 &lt;&lt; std::endl;
<a name="l00602"></a>00602       libmesh_error();
<a name="l00603"></a>00603     }
<a name="l00604"></a>00604 
<a name="l00605"></a>00605   <span class="comment">// Attempt dynamic cast</span>
<a name="l00606"></a>00606   T_sys* ptr = <span class="keyword">dynamic_cast&lt;</span>T_sys*<span class="keyword">&gt;</span>(pos-&gt;second);
<a name="l00607"></a>00607 
<a name="l00608"></a>00608   <span class="comment">// Check for failure of dynamic cast</span>
<a name="l00609"></a>00609   <span class="keywordflow">if</span> (ptr == NULL)
<a name="l00610"></a>00610     {
<a name="l00611"></a>00611       LIBMESH_THROW(<a class="code" href="classlibMesh_1_1DynamicCastFailure.php">libMesh::DynamicCastFailure</a>());
<a name="l00612"></a>00612     }
<a name="l00613"></a>00613 
<a name="l00614"></a>00614   <span class="keywordflow">return</span> *ptr; 
<a name="l00615"></a>00615 }
<a name="l00616"></a>00616 
<a name="l00617"></a>00617 
<a name="l00618"></a>00618 
<a name="l00619"></a>00619 
<a name="l00620"></a>00620 
<a name="l00621"></a>00621 
<a name="l00622"></a>00622 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T_sys&gt;
<a name="l00623"></a>00623 <span class="keyword">inline</span>
<a name="l00624"></a><a class="code" href="classEquationSystems.php#acbff821205306cdfe825698f158193e1">00624</a> T_sys &amp; <a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">EquationSystems::get_system</a> (<span class="keyword">const</span> std::string&amp; name)
<a name="l00625"></a>00625 {
<a name="l00626"></a>00626   <a class="code" href="classEquationSystems.php#a5f8dd96a6d9202f5da5e9f201c4d0d03">system_iterator</a> pos = <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.find(name);
<a name="l00627"></a>00627 
<a name="l00628"></a>00628   <span class="comment">// Check for errors</span>
<a name="l00629"></a>00629   <span class="keywordflow">if</span> (pos == <a class="code" href="classEquationSystems.php#a307379ffa1a24c4abd479460ce2c92f3">_systems</a>.end())
<a name="l00630"></a>00630     {
<a name="l00631"></a>00631       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: no system named &quot;</span> &lt;&lt; name &lt;&lt; <span class="stringliteral">&quot; found!&quot;</span>
<a name="l00632"></a>00632                 &lt;&lt; std::endl;
<a name="l00633"></a>00633       libmesh_error();
<a name="l00634"></a>00634     }
<a name="l00635"></a>00635 
<a name="l00636"></a>00636   <span class="comment">// Attempt dynamic cast</span>
<a name="l00637"></a>00637   T_sys* ptr = <span class="keyword">dynamic_cast&lt;</span>T_sys*<span class="keyword">&gt;</span>(pos-&gt;second);
<a name="l00638"></a>00638 
<a name="l00639"></a>00639   <span class="comment">// Check for failure of dynamic cast</span>
<a name="l00640"></a>00640   <span class="keywordflow">if</span> (ptr == NULL)
<a name="l00641"></a>00641     {
<a name="l00642"></a>00642       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: cannot convert system \&quot;&quot;</span>
<a name="l00643"></a>00643                 &lt;&lt; name &lt;&lt; <span class="stringliteral">&quot;\&quot; to requested type!&quot;</span>
<a name="l00644"></a>00644                 &lt;&lt; std::endl;
<a name="l00645"></a>00645       libmesh_error();
<a name="l00646"></a>00646     }
<a name="l00647"></a>00647 
<a name="l00648"></a>00648   <span class="keywordflow">return</span> *ptr; 
<a name="l00649"></a>00649 }
<a name="l00650"></a>00650 
<a name="l00651"></a>00651 
<a name="l00652"></a>00652 
<a name="l00653"></a>00653 
<a name="l00654"></a>00654 
<a name="l00655"></a>00655 
<a name="l00656"></a>00656 
<a name="l00657"></a>00657 <span class="keyword">inline</span>
<a name="l00658"></a>00658 <span class="keyword">const</span> <a class="code" href="classSystem.php">System</a> &amp; <a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">EquationSystems::get_system</a> (<span class="keyword">const</span> std::string&amp; name)<span class="keyword"> const</span>
<a name="l00659"></a>00659 <span class="keyword"></span>{
<a name="l00660"></a>00660   <span class="keywordflow">return</span> this-&gt;get_system&lt;System&gt;(<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>);
<a name="l00661"></a>00661 }
<a name="l00662"></a>00662 
<a name="l00663"></a>00663 
<a name="l00664"></a>00664 
<a name="l00665"></a>00665 <span class="keyword">inline</span>
<a name="l00666"></a>00666 <a class="code" href="classSystem.php">System</a> &amp; <a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">EquationSystems::get_system</a> (<span class="keyword">const</span> std::string&amp; name)
<a name="l00667"></a>00667 {
<a name="l00668"></a>00668   <span class="keywordflow">return</span> this-&gt;get_system&lt;System&gt;(<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>);
<a name="l00669"></a>00669 }
<a name="l00670"></a>00670 
<a name="l00671"></a>00671 
<a name="l00672"></a>00672 
<a name="l00673"></a>00673 <span class="keyword">inline</span>
<a name="l00674"></a>00674 <span class="keyword">const</span> <a class="code" href="classSystem.php">System</a> &amp; <a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">EquationSystems::get_system</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num)<span class="keyword"> const</span>
<a name="l00675"></a>00675 <span class="keyword"></span>{
<a name="l00676"></a>00676   <span class="keywordflow">return</span> this-&gt;get_system&lt;System&gt;(num);
<a name="l00677"></a>00677 }
<a name="l00678"></a>00678 
<a name="l00679"></a>00679 
<a name="l00680"></a>00680 
<a name="l00681"></a>00681 <span class="keyword">inline</span>
<a name="l00682"></a>00682 <a class="code" href="classSystem.php">System</a> &amp; <a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">EquationSystems::get_system</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num)
<a name="l00683"></a>00683 {
<a name="l00684"></a>00684   <span class="keywordflow">return</span> this-&gt;get_system&lt;System&gt;(num);
<a name="l00685"></a>00685 }
<a name="l00686"></a>00686 
<a name="l00687"></a>00687 
<a name="l00688"></a>00688 
<a name="l00689"></a>00689 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
