<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_570b8306c88722caf9b7ae131e1a07b6.php">error_estimation</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>error_estimator.C</h1>  </div>
</div>
<div class="contents">
<a href="error__estimator_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: error_estimator.C 3428 2009-07-17 01:51:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// Local include files</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;error_estimator.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;error_vector.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;equation_systems.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;parallel.h&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// ErrorEstimator functions</span>
<a name="l00032"></a><a class="code" href="classErrorEstimator.php#a6b108b6e9e10fd97df826209c15c8618">00032</a> <span class="keywordtype">void</span> <a class="code" href="classErrorEstimator.php#a6b108b6e9e10fd97df826209c15c8618">ErrorEstimator::reduce_error</a> (std::vector&lt;ErrorVectorReal&gt;&amp; error_per_cell)<span class="keyword"> const</span>
<a name="l00033"></a>00033 <span class="keyword"></span>{
<a name="l00034"></a>00034   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00035"></a>00035   parallel_only();
<a name="l00036"></a>00036 
<a name="l00037"></a>00037   <span class="comment">// Each processor has now computed the error contribuions</span>
<a name="l00038"></a>00038   <span class="comment">// for its local elements.  We may need to sum the vector to</span>
<a name="l00039"></a>00039   <span class="comment">// recover the error for each element.</span>
<a name="l00040"></a>00040   
<a name="l00041"></a>00041   Parallel::sum(error_per_cell);
<a name="l00042"></a>00042 }
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a><a class="code" href="classErrorEstimator.php#abc6e5368fd8d9727c36f0291cb7e27ef">00046</a> <span class="keywordtype">void</span> <a class="code" href="classErrorEstimator.php#abc6e5368fd8d9727c36f0291cb7e27ef">ErrorEstimator::estimate_errors</a>(<span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; equation_systems,
<a name="l00047"></a>00047                                      <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00048"></a>00048                                      <span class="keyword">const</span> std::map&lt;const System*, SystemNorm&gt;&amp; error_norms,
<a name="l00049"></a>00049                                      <span class="keyword">const</span> std::map&lt;<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>*, <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* &gt;* solution_vectors,
<a name="l00050"></a>00050                                      <span class="keywordtype">bool</span> estimate_parent_error)
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052   <a class="code" href="classSystemNorm.php">SystemNorm</a> old_error_norm = this-&gt;<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>;
<a name="l00053"></a>00053 
<a name="l00054"></a>00054   <span class="comment">// Sum the error values from each system</span>
<a name="l00055"></a>00055   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s = 0; s != equation_systems.<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>(); ++s)
<a name="l00056"></a>00056     {
<a name="l00057"></a>00057       <a class="code" href="classErrorVector.php">ErrorVector</a> system_error_per_cell;
<a name="l00058"></a>00058       <span class="keyword">const</span> <a class="code" href="classSystem.php">System</a> &amp;sys = equation_systems.<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(s);
<a name="l00059"></a>00059       <span class="keywordflow">if</span> (error_norms.find(&amp;sys) == error_norms.end())
<a name="l00060"></a>00060         this-&gt;<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a> = old_error_norm;
<a name="l00061"></a>00061       <span class="keywordflow">else</span>
<a name="l00062"></a>00062         this-&gt;<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a> = error_norms.find(&amp;sys)-&gt;second;
<a name="l00063"></a>00063 
<a name="l00064"></a>00064       <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector = NULL;
<a name="l00065"></a>00065       <span class="keywordflow">if</span> (solution_vectors &amp;&amp;
<a name="l00066"></a>00066           solution_vectors-&gt;find(&amp;sys) != solution_vectors-&gt;end())
<a name="l00067"></a>00067         solution_vector = solution_vectors-&gt;find(&amp;sys)-&gt;second;
<a name="l00068"></a>00068 
<a name="l00069"></a>00069       this-&gt;<a class="code" href="classErrorEstimator.php#a614a5ac29ec34ca4dc41c92dce9ed5ab">estimate_error</a>(sys, system_error_per_cell,
<a name="l00070"></a>00070                            solution_vector, estimate_parent_error);
<a name="l00071"></a>00071 
<a name="l00072"></a>00072       <span class="keywordflow">if</span> (s)
<a name="l00073"></a>00073         {
<a name="l00074"></a>00074           libmesh_assert(error_per_cell.size() == system_error_per_cell.size());
<a name="l00075"></a>00075           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != error_per_cell.size(); ++i)
<a name="l00076"></a>00076             error_per_cell[i] += system_error_per_cell[i];
<a name="l00077"></a>00077         }
<a name="l00078"></a>00078       <span class="keywordflow">else</span>
<a name="l00079"></a>00079         error_per_cell = system_error_per_cell;
<a name="l00080"></a>00080     }
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   <span class="comment">// Restore our old state before returning</span>
<a name="l00083"></a>00083   this-&gt;<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a> = old_error_norm;
<a name="l00084"></a>00084 }
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
<a name="l00092"></a><a class="code" href="classErrorEstimator.php#a2194545c5f62cc2ef2de8e97b8cd4a5a">00092</a> <span class="keywordtype">void</span> <a class="code" href="classErrorEstimator.php#abc6e5368fd8d9727c36f0291cb7e27ef">ErrorEstimator::estimate_errors</a>(<span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; equation_systems,
<a name="l00093"></a>00093                                      <a class="code" href="classErrorEstimator.php#a355a4dd519a02dca211c653b239dc597">ErrorMap</a>&amp; errors_per_cell,
<a name="l00094"></a>00094                                      <span class="keyword">const</span> std::map&lt;<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>*, <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* &gt;* solution_vectors,
<a name="l00095"></a>00095                                      <span class="keywordtype">bool</span> estimate_parent_error)
<a name="l00096"></a>00096 {
<a name="l00097"></a>00097   <a class="code" href="classSystemNorm.php">SystemNorm</a> old_error_norm = this-&gt;<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>;
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   <span class="comment">// Find the requested error values from each system</span>
<a name="l00100"></a>00100   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s = 0; s != equation_systems.<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>(); ++s)
<a name="l00101"></a>00101     {
<a name="l00102"></a>00102       <span class="keyword">const</span> <a class="code" href="classSystem.php">System</a> &amp;sys = equation_systems.<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(s);
<a name="l00103"></a>00103 
<a name="l00104"></a>00104       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_vars = sys.<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>();
<a name="l00105"></a>00105 
<a name="l00106"></a>00106       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v = 0; v != n_vars; ++v)
<a name="l00107"></a>00107         {
<a name="l00108"></a>00108           <span class="comment">// Only fill in ErrorVectors the user asks for</span>
<a name="l00109"></a>00109           <span class="keywordflow">if</span> (errors_per_cell.find(std::make_pair(&amp;sys, v)) ==
<a name="l00110"></a>00110               errors_per_cell.end())
<a name="l00111"></a>00111             <span class="keywordflow">continue</span>;
<a name="l00112"></a>00112 
<a name="l00113"></a>00113           <span class="comment">// Calculate error in only one variable</span>
<a name="l00114"></a>00114           std::vector&lt;Real&gt; weights(n_vars, 0.0);
<a name="l00115"></a>00115           weights[v] = 1.0;
<a name="l00116"></a>00116           this-&gt;<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a> =
<a name="l00117"></a>00117             <a class="code" href="classSystemNorm.php">SystemNorm</a>(std::vector&lt;FEMNormType&gt;(n_vars, old_error_norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(0)),
<a name="l00118"></a>00118                        weights);
<a name="l00119"></a>00119 
<a name="l00120"></a>00120           <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector = NULL;
<a name="l00121"></a>00121           <span class="keywordflow">if</span> (solution_vectors &amp;&amp;
<a name="l00122"></a>00122               solution_vectors-&gt;find(&amp;sys) != solution_vectors-&gt;end())
<a name="l00123"></a>00123             solution_vector = solution_vectors-&gt;find(&amp;sys)-&gt;second;
<a name="l00124"></a>00124 
<a name="l00125"></a>00125           this-&gt;<a class="code" href="classErrorEstimator.php#a614a5ac29ec34ca4dc41c92dce9ed5ab">estimate_error</a>
<a name="l00126"></a>00126             (sys, *errors_per_cell[std::make_pair(&amp;sys, v)],
<a name="l00127"></a>00127              solution_vector, estimate_parent_error);
<a name="l00128"></a>00128         }
<a name="l00129"></a>00129     }
<a name="l00130"></a>00130 
<a name="l00131"></a>00131   <span class="comment">// Restore our old state before returning</span>
<a name="l00132"></a>00132   this-&gt;<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a> = old_error_norm;
<a name="l00133"></a>00133 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
