<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c8cf73965feff5280e8b0581da1a9d14.php">error_estimation</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>error_estimator.h</h1>  </div>
</div>
<div class="contents">
<a href="error__estimator_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: error_estimator.h 3428 2009-07-17 01:51:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __error_estimator_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __error_estimator_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local Includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;system_norm.h&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward Declarations</span>
<a name="l00035"></a>00035 <span class="keyword">class </span><a class="code" href="classErrorVector.php">ErrorVector</a>;
<a name="l00036"></a>00036 <span class="keyword">class </span><a class="code" href="classEquationSystems.php">EquationSystems</a>;
<a name="l00037"></a>00037 <span class="keyword">class </span><a class="code" href="classSystem.php">System</a>;
<a name="l00038"></a>00038 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classNumericVector.php">NumericVector</a>;
<a name="l00039"></a>00039 
<a name="l00050"></a><a class="code" href="classErrorEstimator.php">00050</a> <span class="keyword">class </span><a class="code" href="classErrorEstimator.php">ErrorEstimator</a>
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052 <span class="keyword">public</span>:
<a name="l00053"></a>00053 
<a name="l00058"></a><a class="code" href="classErrorEstimator.php#a3be142a6ffce1761a674c0eda760b46b">00058</a>   <a class="code" href="classErrorEstimator.php#a3be142a6ffce1761a674c0eda760b46b">ErrorEstimator</a>() : <a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>() {}
<a name="l00059"></a>00059   
<a name="l00063"></a><a class="code" href="classErrorEstimator.php#a70923c8dc409a46d9625945b3b5f61f7">00063</a>   <span class="keyword">virtual</span> <a class="code" href="classErrorEstimator.php#a70923c8dc409a46d9625945b3b5f61f7">~ErrorEstimator</a>() {}
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 
<a name="l00079"></a>00079   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classErrorEstimator.php#a614a5ac29ec34ca4dc41c92dce9ed5ab">estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; system,
<a name="l00080"></a>00080                                <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00081"></a>00081                                <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector = NULL,
<a name="l00082"></a>00082                                <span class="keywordtype">bool</span> estimate_parent_error = <span class="keyword">false</span>) = 0;
<a name="l00083"></a>00083 
<a name="l00095"></a>00095   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classErrorEstimator.php#abc6e5368fd8d9727c36f0291cb7e27ef">estimate_errors</a> (<span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; equation_systems,
<a name="l00096"></a>00096                                 <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00097"></a>00097                                 <span class="keyword">const</span> std::map&lt;const System*, SystemNorm&gt;&amp; error_norms,
<a name="l00098"></a>00098                                 <span class="keyword">const</span> std::map&lt;<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>*, <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* &gt;* solution_vectors = NULL,
<a name="l00099"></a>00099                                 <span class="keywordtype">bool</span> estimate_parent_error = <span class="keyword">false</span>);
<a name="l00100"></a>00100 
<a name="l00105"></a><a class="code" href="classErrorEstimator.php#a355a4dd519a02dca211c653b239dc597">00105</a>   <span class="keyword">typedef</span> std::map&lt;std::pair&lt;const System*, unsigned int&gt;, <a class="code" href="classErrorVector.php">ErrorVector</a>*&gt; <a class="code" href="classErrorEstimator.php#a355a4dd519a02dca211c653b239dc597">ErrorMap</a>;
<a name="l00106"></a>00106 
<a name="l00119"></a>00119   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classErrorEstimator.php#abc6e5368fd8d9727c36f0291cb7e27ef">estimate_errors</a> (<span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; equation_systems,
<a name="l00120"></a>00120                                 <a class="code" href="classErrorEstimator.php#a355a4dd519a02dca211c653b239dc597">ErrorMap</a>&amp; errors_per_cell,
<a name="l00121"></a>00121                                 <span class="keyword">const</span> std::map&lt;<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>*, <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* &gt;* solution_vectors = NULL,
<a name="l00122"></a>00122                                 <span class="keywordtype">bool</span> estimate_parent_error = <span class="keyword">false</span>);
<a name="l00123"></a>00123 
<a name="l00137"></a><a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">00137</a>   <a class="code" href="classSystemNorm.php">SystemNorm</a> <a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>;
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 <span class="keyword">protected</span>:
<a name="l00140"></a>00140 
<a name="l00146"></a>00146   <span class="keywordtype">void</span> <a class="code" href="classErrorEstimator.php#a6b108b6e9e10fd97df826209c15c8618">reduce_error</a> (std::vector&lt;float&gt;&amp; error_per_cell) <span class="keyword">const</span>;
<a name="l00147"></a>00147 };
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 <span class="preprocessor">#endif</span>
<a name="l00151"></a>00151 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
