<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_4f64d75cac7489d141591c33108e86ff.php">utils</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>error_vector.h</h1>  </div>
</div>
<div class="contents">
<a href="error__vector_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: error_vector.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __error_vector_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __error_vector_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="statistics_8h.php">statistics.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Now defined in libmesh_common.h:</span>
<a name="l00031"></a>00031 <span class="comment">// typedef float ErrorVectorReal;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Forward Declarations</span>
<a name="l00034"></a>00034 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00035"></a>00035 <span class="keyword">class </span><a class="code" href="classMesh.php">Mesh</a>;
<a name="l00036"></a>00036 
<a name="l00050"></a><a class="code" href="classErrorVector.php">00050</a> <span class="keyword">class </span><a class="code" href="classErrorVector.php">ErrorVector</a> : <span class="keyword">public</span> <a class="code" href="classStatisticsVector.php">StatisticsVector</a>&lt;ErrorVectorReal&gt;
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052   
<a name="l00053"></a>00053 <span class="keyword">public</span>:
<a name="l00054"></a>00054   
<a name="l00063"></a><a class="code" href="classErrorVector.php#ad24bc3201a4ef0121b05663f7a900358">00063</a>   <a class="code" href="classErrorVector.php#ad24bc3201a4ef0121b05663f7a900358">ErrorVector</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0, <a class="code" href="classMeshBase.php">MeshBase</a> *mesh = NULL) : <a class="code" href="classStatisticsVector.php">StatisticsVector</a>&lt;<a class="code" href="libmesh__common_8h.php#a4fde6363fef26bb083463d8f7b40ab22">ErrorVectorReal</a>&gt; (i), <a class="code" href="classErrorVector.php#a434eef645f3861e35e5b543ab32d1478">_mesh</a>(mesh) {}
<a name="l00064"></a>00064   
<a name="l00073"></a><a class="code" href="classErrorVector.php#a043ac9992147cbe49bb5335159ce9d66">00073</a>   <a class="code" href="classErrorVector.php#ad24bc3201a4ef0121b05663f7a900358">ErrorVector</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <a class="code" href="libmesh__common_8h.php#a4fde6363fef26bb083463d8f7b40ab22">ErrorVectorReal</a> val) :
<a name="l00074"></a>00074       <a class="code" href="classStatisticsVector.php">StatisticsVector</a>&lt;<a class="code" href="libmesh__common_8h.php#a4fde6363fef26bb083463d8f7b40ab22">ErrorVectorReal</a>&gt; (i,val) {}
<a name="l00075"></a>00075 
<a name="l00079"></a>00079   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#a4fde6363fef26bb083463d8f7b40ab22">ErrorVectorReal</a> <a class="code" href="classErrorVector.php#aa332f02b61eec08099d25d090a13c9c1">minimum</a>() <span class="keyword">const</span>;
<a name="l00080"></a>00080 
<a name="l00085"></a>00085   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classErrorVector.php#a959bacdc9d596c5212137c9221ff6f14">mean</a>() <span class="keyword">const</span>;
<a name="l00086"></a>00086   
<a name="l00095"></a>00095   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classErrorVector.php#a22b79d5b0962687992c115e79f0bef63">median</a>();
<a name="l00096"></a>00096 
<a name="l00102"></a>00102   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classErrorVector.php#a22b79d5b0962687992c115e79f0bef63">median</a>() <span class="keyword">const</span>;
<a name="l00103"></a>00103 
<a name="l00114"></a><a class="code" href="classErrorVector.php#a0b1a9d39bb54ac0cd9b8659e4360f54a">00114</a>   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classErrorVector.php#a0b1a9d39bb54ac0cd9b8659e4360f54a">variance</a>()<span class="keyword"> const</span>
<a name="l00115"></a>00115 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classErrorVector.php#a0b1a9d39bb54ac0cd9b8659e4360f54a">variance</a>(this-&gt;<a class="code" href="classErrorVector.php#a959bacdc9d596c5212137c9221ff6f14">mean</a>()); }
<a name="l00116"></a>00116 
<a name="l00128"></a>00128   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classErrorVector.php#a0b1a9d39bb54ac0cd9b8659e4360f54a">variance</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classErrorVector.php#a959bacdc9d596c5212137c9221ff6f14">mean</a>) <span class="keyword">const</span>;
<a name="l00129"></a>00129 
<a name="l00135"></a>00135   <span class="keyword">virtual</span> std::vector&lt;unsigned int&gt; <a class="code" href="classErrorVector.php#a1346b8d48f272d76fdf692b13d7b21af">cut_below</a>(<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> cut) <span class="keyword">const</span>;
<a name="l00136"></a>00136 
<a name="l00142"></a>00142   <span class="keyword">virtual</span> std::vector&lt;unsigned int&gt; <a class="code" href="classErrorVector.php#aa6f887944cf5ef0a26f4f3d141e9155c">cut_above</a>(<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> cut) <span class="keyword">const</span>;
<a name="l00143"></a>00143 
<a name="l00149"></a>00149   <span class="keywordtype">void</span> <a class="code" href="classErrorVector.php#a0ec5505f9b491872c007609e864b6821">plot_error</a>(<span class="keyword">const</span> std::string &amp;filename,
<a name="l00150"></a>00150                   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh) <span class="keyword">const</span>;
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 <span class="keyword">protected</span>:
<a name="l00156"></a>00156   <span class="keywordtype">bool</span> <a class="code" href="classErrorVector.php#a24ac7f1c0dad5714c956afa4bed94425">is_active_elem</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00157"></a>00157 
<a name="l00162"></a><a class="code" href="classErrorVector.php#a434eef645f3861e35e5b543ab32d1478">00162</a>   <a class="code" href="classMeshBase.php">MeshBase</a> *<a class="code" href="classErrorVector.php#a434eef645f3861e35e5b543ab32d1478">_mesh</a>;
<a name="l00163"></a>00163 };
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 <span class="preprocessor">#endif</span>
<a name="l00167"></a>00167 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
