<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_60be1125a39495b698d2d56e8e5b50b1.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>euler2_solver.C</h1>  </div>
</div>
<div class="contents">
<a href="euler2__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: euler2_solver.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;diff_system.h&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;euler2_solver.h&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a><a class="code" href="classEuler2Solver.php#a9339d2429f8adeb8c6536617b06334cb">00027</a> <a class="code" href="classEuler2Solver.php#a9339d2429f8adeb8c6536617b06334cb">Euler2Solver::Euler2Solver</a> (<a class="code" href="classDifferentiableSystem.php">sys_type</a>&amp; s)
<a name="l00028"></a>00028  : <a class="code" href="classUnsteadySolver.php">UnsteadySolver</a>(s), theta(1.)
<a name="l00029"></a>00029 {
<a name="l00030"></a>00030 }
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a><a class="code" href="classEuler2Solver.php#a2c0a52388ac870049492a54214612f6b">00034</a> <a class="code" href="classEuler2Solver.php#a2c0a52388ac870049492a54214612f6b">Euler2Solver::~Euler2Solver</a> ()
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 }
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a><a class="code" href="classEuler2Solver.php#a224bc3d8f2076ded02f8f7043fd09223">00040</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classEuler2Solver.php#a224bc3d8f2076ded02f8f7043fd09223">Euler2Solver::error_order</a>()<span class="keyword"> const</span>
<a name="l00041"></a>00041 <span class="keyword"></span>{
<a name="l00042"></a>00042   <span class="keywordflow">if</span> (<a class="code" href="classEuler2Solver.php#a578d9b496a74dcb1d989f67550dace79">theta</a> == 0.5)
<a name="l00043"></a>00043     <span class="keywordflow">return</span> 2.;
<a name="l00044"></a>00044   <span class="keywordflow">return</span> 1.;
<a name="l00045"></a>00045 }
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00050"></a><a class="code" href="classEuler2Solver.php#ab0988e7a5f18b095c83b67c5302b1256">00050</a> <span class="keywordtype">bool</span> <a class="code" href="classEuler2Solver.php#ab0988e7a5f18b095c83b67c5302b1256">Euler2Solver::element_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00051"></a>00051                                      <a class="code" href="classDiffContext.php">DiffContext</a> &amp;context)
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = context.<a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>();
<a name="l00054"></a>00054 
<a name="l00055"></a>00055   <span class="comment">// Local nonlinear solution at old timestep</span>
<a name="l00056"></a>00056   <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a> old_elem_solution(n_dofs);
<a name="l00057"></a>00057   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_dofs; ++i)
<a name="l00058"></a>00058     old_elem_solution(i) =
<a name="l00059"></a>00059       <a class="code" href="classUnsteadySolver.php#ad14f2816697932209a6996937dd8ff18">old_nonlinear_solution</a>(context.<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>[i]);
<a name="l00060"></a>00060 
<a name="l00061"></a>00061   <span class="comment">// We evaluate mass_residual with the change in solution</span>
<a name="l00062"></a>00062   <span class="comment">// to get the mass matrix, reusing old_elem_solution to hold that</span>
<a name="l00063"></a>00063   <span class="comment">// delta_solution.</span>
<a name="l00064"></a>00064   <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a> delta_elem_solution(context.<a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>);
<a name="l00065"></a>00065   delta_elem_solution -= old_elem_solution;
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   <span class="comment">// Our first evaluations are at the true elem_solution</span>
<a name="l00068"></a>00068   context.<a class="code" href="classDiffContext.php#a9cb6e53f5be4dbbbff17d3c9986ec423">elem_solution_derivative</a> = 1.0;
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="comment">// If a fixed solution is requested, we&#39;ll use the elem_solution</span>
<a name="l00071"></a>00071   <span class="comment">// at the new timestep</span>
<a name="l00072"></a>00072   <span class="keywordflow">if</span> (<a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a3e9645837798cc7d10d127b9ce54b0e1">use_fixed_solution</a>)
<a name="l00073"></a>00073     context.<a class="code" href="classDiffContext.php#a1ab7c2721bfd00d5483f7625fb49e421">elem_fixed_solution</a> = context.<a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>;
<a name="l00074"></a>00074 
<a name="l00075"></a>00075   context.<a class="code" href="classDiffContext.php#aad59fbaa6442d15ef901607827ed9e9c">fixed_solution_derivative</a> = 1.0;
<a name="l00076"></a>00076 
<a name="l00077"></a>00077   <span class="comment">// We&#39;re going to compute just the change in elem_residual</span>
<a name="l00078"></a>00078   <span class="comment">// (and possibly elem_jacobian), then add back the old values</span>
<a name="l00079"></a>00079   <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a> total_elem_residual(context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>);
<a name="l00080"></a>00080   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Number&gt;</a> old_elem_jacobian, total_elem_jacobian;
<a name="l00081"></a>00081   <span class="keywordflow">if</span> (request_jacobian)
<a name="l00082"></a>00082     {
<a name="l00083"></a>00083       old_elem_jacobian = context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>;
<a name="l00084"></a>00084       total_elem_jacobian = context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>;
<a name="l00085"></a>00085       context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>.<a class="code" href="classDenseMatrix.php#a3d3f0e57fc2e9dc7ed292cbd2124581e">zero</a>();
<a name="l00086"></a>00086     }
<a name="l00087"></a>00087   context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>.<a class="code" href="classDenseVector.php#a4e0123eb5cc4054e8069155f0faf4425">zero</a>();
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   <span class="comment">// First, evaluate time derivative at the new timestep.</span>
<a name="l00090"></a>00090   <span class="comment">// The element should already be in the proper place</span>
<a name="l00091"></a>00091   <span class="comment">// even for a moving mesh problem.</span>
<a name="l00092"></a>00092   <span class="keywordtype">bool</span> jacobian_computed =
<a name="l00093"></a>00093     <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a518a1763297cc2706185c539cc4fcec5">element_time_derivative</a>(request_jacobian, context);
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   <span class="comment">// For a moving mesh problem we may need the pseudoconvection term too</span>
<a name="l00096"></a>00096   jacobian_computed =
<a name="l00097"></a>00097     <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a6d3a069bc2476e64954fd7dd9f4a6ead">eulerian_residual</a>(jacobian_computed, context) &amp;&amp; jacobian_computed;
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   <span class="comment">// Scale the new time-dependent residual and jacobian correctly</span>
<a name="l00100"></a>00100   context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a> *= (<a class="code" href="classEuler2Solver.php#a578d9b496a74dcb1d989f67550dace79">theta</a> * <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a>);
<a name="l00101"></a>00101   total_elem_residual += context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>;
<a name="l00102"></a>00102   context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>.<a class="code" href="classDenseVector.php#a4e0123eb5cc4054e8069155f0faf4425">zero</a>();
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="keywordflow">if</span> (jacobian_computed)
<a name="l00105"></a>00105     {
<a name="l00106"></a>00106       context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a> *= (<a class="code" href="classEuler2Solver.php#a578d9b496a74dcb1d989f67550dace79">theta</a> * <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a>);
<a name="l00107"></a>00107       total_elem_jacobian += context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>;
<a name="l00108"></a>00108       context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>.<a class="code" href="classDenseMatrix.php#a3d3f0e57fc2e9dc7ed292cbd2124581e">zero</a>();
<a name="l00109"></a>00109     }
<a name="l00110"></a>00110 
<a name="l00111"></a>00111   <span class="comment">// Next, evaluate the mass residual at the new timestep,</span>
<a name="l00112"></a>00112   <span class="comment">// with the delta_solution.</span>
<a name="l00113"></a>00113   <span class="comment">// Evaluating the mass residual at both old and new timesteps will be</span>
<a name="l00114"></a>00114   <span class="comment">// redundant in most problems but may be necessary for time accuracy</span>
<a name="l00115"></a>00115   <span class="comment">// or stability in moving mesh problems or problems with user-overridden</span>
<a name="l00116"></a>00116   <span class="comment">// mass_residual functions</span>
<a name="l00117"></a>00117 
<a name="l00118"></a>00118   <span class="comment">// Move elem_-&gt;delta_, delta_-&gt;elem_</span>
<a name="l00119"></a>00119   context.<a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>.<a class="code" href="classDenseVector.php#a4abb869315266cf9938c66a64189c65f">swap</a>(delta_elem_solution);
<a name="l00120"></a>00120 
<a name="l00121"></a>00121   jacobian_computed = <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#aa69fa37b59f37a015d907d9833a4d053">mass_residual</a>(jacobian_computed, context) &amp;&amp;
<a name="l00122"></a>00122     jacobian_computed;
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a> *= -<a class="code" href="classEuler2Solver.php#a578d9b496a74dcb1d989f67550dace79">theta</a>;
<a name="l00125"></a>00125   total_elem_residual += context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>;
<a name="l00126"></a>00126   context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>.<a class="code" href="classDenseVector.php#a4e0123eb5cc4054e8069155f0faf4425">zero</a>();
<a name="l00127"></a>00127 
<a name="l00128"></a>00128   <span class="keywordflow">if</span> (jacobian_computed)
<a name="l00129"></a>00129     {
<a name="l00130"></a>00130       <span class="comment">// The minus sign trick here is to avoid using a non-1</span>
<a name="l00131"></a>00131       <span class="comment">// elem_solution_derivative:</span>
<a name="l00132"></a>00132       context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a> *= -<a class="code" href="classEuler2Solver.php#a578d9b496a74dcb1d989f67550dace79">theta</a>;
<a name="l00133"></a>00133       total_elem_jacobian += context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>;
<a name="l00134"></a>00134       context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>.<a class="code" href="classDenseMatrix.php#a3d3f0e57fc2e9dc7ed292cbd2124581e">zero</a>();
<a name="l00135"></a>00135     }
<a name="l00136"></a>00136 
<a name="l00137"></a>00137   <span class="comment">// Add the time-dependent term for the old solution</span>
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   <span class="comment">// Make sure elem_solution is set up for elem_reinit to use</span>
<a name="l00140"></a>00140   <span class="comment">// Move delta_-&gt;old_, old_-&gt;elem_</span>
<a name="l00141"></a>00141   context.<a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>.<a class="code" href="classDenseVector.php#a4abb869315266cf9938c66a64189c65f">swap</a>(old_elem_solution);
<a name="l00142"></a>00142 
<a name="l00143"></a>00143   <span class="comment">// Move the mesh into place first if necessary</span>
<a name="l00144"></a>00144   context.<a class="code" href="classDiffContext.php#a19ff1c41b089cfccb6b419a7540332f0">elem_reinit</a>(0.);
<a name="l00145"></a>00145 
<a name="l00146"></a>00146   <span class="keywordflow">if</span> (<a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a3e9645837798cc7d10d127b9ce54b0e1">use_fixed_solution</a>)
<a name="l00147"></a>00147     {
<a name="l00148"></a>00148       context.<a class="code" href="classDiffContext.php#a9cb6e53f5be4dbbbff17d3c9986ec423">elem_solution_derivative</a> = 0.0;
<a name="l00149"></a>00149       jacobian_computed =
<a name="l00150"></a>00150         <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a518a1763297cc2706185c539cc4fcec5">element_time_derivative</a>(jacobian_computed, context) &amp;&amp;
<a name="l00151"></a>00151         jacobian_computed;
<a name="l00152"></a>00152       jacobian_computed = 
<a name="l00153"></a>00153         <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a6d3a069bc2476e64954fd7dd9f4a6ead">eulerian_residual</a>(jacobian_computed, context) &amp;&amp;
<a name="l00154"></a>00154         jacobian_computed;
<a name="l00155"></a>00155       context.<a class="code" href="classDiffContext.php#a9cb6e53f5be4dbbbff17d3c9986ec423">elem_solution_derivative</a> = 1.0;
<a name="l00156"></a>00156       context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a> *= ((1. - <a class="code" href="classEuler2Solver.php#a578d9b496a74dcb1d989f67550dace79">theta</a>) * <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a>);
<a name="l00157"></a>00157       total_elem_residual += context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>;
<a name="l00158"></a>00158       <span class="keywordflow">if</span> (jacobian_computed)
<a name="l00159"></a>00159         {
<a name="l00160"></a>00160           context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a> *= ((1. - <a class="code" href="classEuler2Solver.php#a578d9b496a74dcb1d989f67550dace79">theta</a>) * <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a>);
<a name="l00161"></a>00161           total_elem_jacobian += context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>;
<a name="l00162"></a>00162           context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>.<a class="code" href="classDenseMatrix.php#a3d3f0e57fc2e9dc7ed292cbd2124581e">zero</a>();
<a name="l00163"></a>00163         }
<a name="l00164"></a>00164     }
<a name="l00165"></a>00165   <span class="keywordflow">else</span>
<a name="l00166"></a>00166     {
<a name="l00167"></a>00167       <span class="comment">// FIXME - we should detect if element_time_derivative() edits</span>
<a name="l00168"></a>00168       <span class="comment">// elem_jacobian and lies about it!</span>
<a name="l00169"></a>00169       <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a518a1763297cc2706185c539cc4fcec5">element_time_derivative</a>(<span class="keyword">false</span>, context);
<a name="l00170"></a>00170       <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a6d3a069bc2476e64954fd7dd9f4a6ead">eulerian_residual</a>(<span class="keyword">false</span>, context);
<a name="l00171"></a>00171       context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a> *= ((1. - <a class="code" href="classEuler2Solver.php#a578d9b496a74dcb1d989f67550dace79">theta</a>) * <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a>);
<a name="l00172"></a>00172       total_elem_residual += context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>;
<a name="l00173"></a>00173     }
<a name="l00174"></a>00174 
<a name="l00175"></a>00175   context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>.<a class="code" href="classDenseVector.php#a4e0123eb5cc4054e8069155f0faf4425">zero</a>();
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   <span class="comment">// Add the mass residual term for the old solution</span>
<a name="l00178"></a>00178 
<a name="l00179"></a>00179   <span class="comment">// Move old_-&gt;old_, delta_-&gt;elem_</span>
<a name="l00180"></a>00180   context.<a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>.<a class="code" href="classDenseVector.php#a4abb869315266cf9938c66a64189c65f">swap</a>(old_elem_solution);
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   jacobian_computed = <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#aa69fa37b59f37a015d907d9833a4d053">mass_residual</a>(jacobian_computed, context) &amp;&amp;
<a name="l00183"></a>00183     jacobian_computed;
<a name="l00184"></a>00184 
<a name="l00185"></a>00185   context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a> *= -(1. - <a class="code" href="classEuler2Solver.php#a578d9b496a74dcb1d989f67550dace79">theta</a>);
<a name="l00186"></a>00186   total_elem_residual += context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>;
<a name="l00187"></a>00187   context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>.<a class="code" href="classDenseVector.php#a4e0123eb5cc4054e8069155f0faf4425">zero</a>();
<a name="l00188"></a>00188 
<a name="l00189"></a>00189   <span class="keywordflow">if</span> (jacobian_computed)
<a name="l00190"></a>00190     {
<a name="l00191"></a>00191       <span class="comment">// The minus sign trick here is to avoid using a non-1</span>
<a name="l00192"></a>00192       <span class="comment">// *_solution_derivative:</span>
<a name="l00193"></a>00193       context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a> *= -(1. - <a class="code" href="classEuler2Solver.php#a578d9b496a74dcb1d989f67550dace79">theta</a>);
<a name="l00194"></a>00194       total_elem_jacobian += context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>;
<a name="l00195"></a>00195       context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>.<a class="code" href="classDenseMatrix.php#a3d3f0e57fc2e9dc7ed292cbd2124581e">zero</a>();
<a name="l00196"></a>00196     }
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   <span class="comment">// Restore the elem_solution</span>
<a name="l00199"></a>00199   <span class="comment">// Move elem_-&gt;elem_, delta_-&gt;delta_</span>
<a name="l00200"></a>00200   context.<a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>.<a class="code" href="classDenseVector.php#a4abb869315266cf9938c66a64189c65f">swap</a>(delta_elem_solution);
<a name="l00201"></a>00201 
<a name="l00202"></a>00202   <span class="comment">// Restore the elem position if necessary</span>
<a name="l00203"></a>00203   context.<a class="code" href="classDiffContext.php#a19ff1c41b089cfccb6b419a7540332f0">elem_reinit</a>(1.);
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   <span class="comment">// Add the constraint term</span>
<a name="l00206"></a>00206   jacobian_computed = <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a516241801a3773a0c9d4a4b0d12de174">element_constraint</a>(jacobian_computed, context) &amp;&amp;
<a name="l00207"></a>00207     jacobian_computed;
<a name="l00208"></a>00208 
<a name="l00209"></a>00209   <span class="comment">// Add back the previously accumulated residual and jacobian</span>
<a name="l00210"></a>00210   context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a> += total_elem_residual;
<a name="l00211"></a>00211   <span class="keywordflow">if</span> (request_jacobian)
<a name="l00212"></a>00212     {
<a name="l00213"></a>00213       <span class="keywordflow">if</span> (jacobian_computed)
<a name="l00214"></a>00214         context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a> += total_elem_jacobian;
<a name="l00215"></a>00215       <span class="keywordflow">else</span>
<a name="l00216"></a>00216         context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>.<a class="code" href="classDenseMatrix.php#a0df961e52a0694a9300dea1714a1a369">swap</a>(old_elem_jacobian);
<a name="l00217"></a>00217     }
<a name="l00218"></a>00218 
<a name="l00219"></a>00219   <span class="keywordflow">return</span> jacobian_computed;
<a name="l00220"></a>00220 }
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 
<a name="l00224"></a><a class="code" href="classEuler2Solver.php#a93eb4e2360faffd6cea2de1b06dc9c75">00224</a> <span class="keywordtype">bool</span> <a class="code" href="classEuler2Solver.php#a93eb4e2360faffd6cea2de1b06dc9c75">Euler2Solver::side_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00225"></a>00225                                   <a class="code" href="classDiffContext.php">DiffContext</a> &amp;context)
<a name="l00226"></a>00226 {
<a name="l00227"></a>00227   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = context.<a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>();
<a name="l00228"></a>00228 
<a name="l00229"></a>00229   <span class="comment">// Local nonlinear solution at old timestep</span>
<a name="l00230"></a>00230   <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a> old_elem_solution(n_dofs);
<a name="l00231"></a>00231   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_dofs; ++i)
<a name="l00232"></a>00232     old_elem_solution(i) =
<a name="l00233"></a>00233       <a class="code" href="classUnsteadySolver.php#ad14f2816697932209a6996937dd8ff18">old_nonlinear_solution</a>(context.<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>[i]);
<a name="l00234"></a>00234 
<a name="l00235"></a>00235   <span class="comment">// We evaluate mass_residual with the change in solution</span>
<a name="l00236"></a>00236   <span class="comment">// to get the mass matrix, reusing old_elem_solution to hold that</span>
<a name="l00237"></a>00237   <span class="comment">// delta_solution.</span>
<a name="l00238"></a>00238   <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a> delta_elem_solution(context.<a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>);
<a name="l00239"></a>00239   delta_elem_solution -= old_elem_solution;
<a name="l00240"></a>00240 
<a name="l00241"></a>00241   <span class="comment">// Our first evaluations are at the true elem_solution</span>
<a name="l00242"></a>00242   context.<a class="code" href="classDiffContext.php#a9cb6e53f5be4dbbbff17d3c9986ec423">elem_solution_derivative</a> = 1.0;
<a name="l00243"></a>00243 
<a name="l00244"></a>00244   <span class="comment">// If a fixed solution is requested, we&#39;ll use the elem_solution</span>
<a name="l00245"></a>00245   <span class="comment">// at the new timestep</span>
<a name="l00246"></a>00246   <span class="keywordflow">if</span> (<a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a3e9645837798cc7d10d127b9ce54b0e1">use_fixed_solution</a>)
<a name="l00247"></a>00247     context.<a class="code" href="classDiffContext.php#a1ab7c2721bfd00d5483f7625fb49e421">elem_fixed_solution</a> = context.<a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>;
<a name="l00248"></a>00248 
<a name="l00249"></a>00249   context.<a class="code" href="classDiffContext.php#aad59fbaa6442d15ef901607827ed9e9c">fixed_solution_derivative</a> = 1.0;
<a name="l00250"></a>00250 
<a name="l00251"></a>00251   <span class="comment">// We&#39;re going to compute just the change in elem_residual</span>
<a name="l00252"></a>00252   <span class="comment">// (and possibly elem_jacobian), then add back the old values</span>
<a name="l00253"></a>00253   <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a> total_elem_residual(context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>);
<a name="l00254"></a>00254   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Number&gt;</a> old_elem_jacobian, total_elem_jacobian;
<a name="l00255"></a>00255   <span class="keywordflow">if</span> (request_jacobian)
<a name="l00256"></a>00256     {
<a name="l00257"></a>00257       old_elem_jacobian = context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>;
<a name="l00258"></a>00258       total_elem_jacobian = context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>;
<a name="l00259"></a>00259       context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>.<a class="code" href="classDenseMatrix.php#a3d3f0e57fc2e9dc7ed292cbd2124581e">zero</a>();
<a name="l00260"></a>00260     }
<a name="l00261"></a>00261   context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>.<a class="code" href="classDenseVector.php#a4e0123eb5cc4054e8069155f0faf4425">zero</a>();
<a name="l00262"></a>00262 
<a name="l00263"></a>00263   <span class="comment">// First, evaluate time derivative at the new timestep.</span>
<a name="l00264"></a>00264   <span class="comment">// The element should already be in the proper place</span>
<a name="l00265"></a>00265   <span class="comment">// even for a moving mesh problem.</span>
<a name="l00266"></a>00266   <span class="keywordtype">bool</span> jacobian_computed =
<a name="l00267"></a>00267     <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a990b76eb7ed84572c0384d90fe51fbaf">side_time_derivative</a>(request_jacobian, context);
<a name="l00268"></a>00268 
<a name="l00269"></a>00269   <span class="comment">// Scale the time-dependent residual and jacobian correctly</span>
<a name="l00270"></a>00270   context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a> *= (<a class="code" href="classEuler2Solver.php#a578d9b496a74dcb1d989f67550dace79">theta</a> * <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a>);
<a name="l00271"></a>00271   total_elem_residual += context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>;
<a name="l00272"></a>00272   context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>.<a class="code" href="classDenseVector.php#a4e0123eb5cc4054e8069155f0faf4425">zero</a>();
<a name="l00273"></a>00273 
<a name="l00274"></a>00274   <span class="keywordflow">if</span> (jacobian_computed)
<a name="l00275"></a>00275     {
<a name="l00276"></a>00276       context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a> *= (<a class="code" href="classEuler2Solver.php#a578d9b496a74dcb1d989f67550dace79">theta</a> * <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a>);
<a name="l00277"></a>00277       total_elem_jacobian += context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>;
<a name="l00278"></a>00278       context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>.<a class="code" href="classDenseMatrix.php#a3d3f0e57fc2e9dc7ed292cbd2124581e">zero</a>();
<a name="l00279"></a>00279     }
<a name="l00280"></a>00280 
<a name="l00281"></a>00281   <span class="comment">// Next, evaluate the mass residual at the new timestep,</span>
<a name="l00282"></a>00282   <span class="comment">// with the delta_solution.</span>
<a name="l00283"></a>00283   <span class="comment">// Evaluating the mass residual at both old and new timesteps will be</span>
<a name="l00284"></a>00284   <span class="comment">// redundant in most problems but may be necessary for time accuracy</span>
<a name="l00285"></a>00285   <span class="comment">// or stability in moving mesh problems or problems with user-overridden</span>
<a name="l00286"></a>00286   <span class="comment">// mass_residual functions</span>
<a name="l00287"></a>00287 
<a name="l00288"></a>00288   <span class="comment">// Move elem_-&gt;delta_, delta_-&gt;elem_</span>
<a name="l00289"></a>00289   context.<a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>.<a class="code" href="classDenseVector.php#a4abb869315266cf9938c66a64189c65f">swap</a>(delta_elem_solution);
<a name="l00290"></a>00290 
<a name="l00291"></a>00291   jacobian_computed = <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a5c1dd0b32156465b148fc35ca29d70e8">side_mass_residual</a>(jacobian_computed, context) &amp;&amp;
<a name="l00292"></a>00292     jacobian_computed;
<a name="l00293"></a>00293 
<a name="l00294"></a>00294   context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a> *= -<a class="code" href="classEuler2Solver.php#a578d9b496a74dcb1d989f67550dace79">theta</a>;
<a name="l00295"></a>00295   total_elem_residual += context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>;
<a name="l00296"></a>00296   context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>.<a class="code" href="classDenseVector.php#a4e0123eb5cc4054e8069155f0faf4425">zero</a>();
<a name="l00297"></a>00297 
<a name="l00298"></a>00298   <span class="keywordflow">if</span> (jacobian_computed)
<a name="l00299"></a>00299     {
<a name="l00300"></a>00300       <span class="comment">// The minus sign trick here is to avoid using a non-1</span>
<a name="l00301"></a>00301       <span class="comment">// elem_solution_derivative:</span>
<a name="l00302"></a>00302       context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a> *= -<a class="code" href="classEuler2Solver.php#a578d9b496a74dcb1d989f67550dace79">theta</a>;
<a name="l00303"></a>00303       total_elem_jacobian += context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>;
<a name="l00304"></a>00304       context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>.<a class="code" href="classDenseMatrix.php#a3d3f0e57fc2e9dc7ed292cbd2124581e">zero</a>();
<a name="l00305"></a>00305     }
<a name="l00306"></a>00306 
<a name="l00307"></a>00307   <span class="comment">// Add the time-dependent term for the old solution</span>
<a name="l00308"></a>00308 
<a name="l00309"></a>00309   <span class="comment">// Make sure elem_solution is set up for elem_reinit to use</span>
<a name="l00310"></a>00310   <span class="comment">// Move delta_-&gt;old_, old_-&gt;elem_</span>
<a name="l00311"></a>00311   context.<a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>.<a class="code" href="classDenseVector.php#a4abb869315266cf9938c66a64189c65f">swap</a>(old_elem_solution);
<a name="l00312"></a>00312 
<a name="l00313"></a>00313   <span class="comment">// Move the mesh into place first if necessary</span>
<a name="l00314"></a>00314   context.<a class="code" href="classDiffContext.php#a2eac885c9584bdf1a5abb05fbdfa6eb1">elem_side_reinit</a>(0.);
<a name="l00315"></a>00315 
<a name="l00316"></a>00316   <span class="keywordflow">if</span> (<a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a3e9645837798cc7d10d127b9ce54b0e1">use_fixed_solution</a>)
<a name="l00317"></a>00317     {
<a name="l00318"></a>00318       context.<a class="code" href="classDiffContext.php#a9cb6e53f5be4dbbbff17d3c9986ec423">elem_solution_derivative</a> = 0.0;
<a name="l00319"></a>00319       jacobian_computed = 
<a name="l00320"></a>00320         <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a990b76eb7ed84572c0384d90fe51fbaf">side_time_derivative</a>(jacobian_computed, context) &amp;&amp;
<a name="l00321"></a>00321           jacobian_computed;
<a name="l00322"></a>00322       context.<a class="code" href="classDiffContext.php#a9cb6e53f5be4dbbbff17d3c9986ec423">elem_solution_derivative</a> = 1.0;
<a name="l00323"></a>00323       context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a> *= ((1. - <a class="code" href="classEuler2Solver.php#a578d9b496a74dcb1d989f67550dace79">theta</a>) * <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a>);
<a name="l00324"></a>00324       total_elem_residual += context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>;
<a name="l00325"></a>00325       <span class="keywordflow">if</span> (jacobian_computed)
<a name="l00326"></a>00326         {
<a name="l00327"></a>00327           context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a> *= ((1. - <a class="code" href="classEuler2Solver.php#a578d9b496a74dcb1d989f67550dace79">theta</a>) * <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a>);
<a name="l00328"></a>00328           total_elem_jacobian += context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>;
<a name="l00329"></a>00329           context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>.<a class="code" href="classDenseMatrix.php#a3d3f0e57fc2e9dc7ed292cbd2124581e">zero</a>();
<a name="l00330"></a>00330         }
<a name="l00331"></a>00331     }
<a name="l00332"></a>00332   <span class="keywordflow">else</span>
<a name="l00333"></a>00333     {
<a name="l00334"></a>00334       <span class="comment">// FIXME - we should detect if side_time_derivative() edits</span>
<a name="l00335"></a>00335       <span class="comment">// elem_jacobian and lies about it!</span>
<a name="l00336"></a>00336       <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a990b76eb7ed84572c0384d90fe51fbaf">side_time_derivative</a>(<span class="keyword">false</span>, context);
<a name="l00337"></a>00337       context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a> *= ((1. - <a class="code" href="classEuler2Solver.php#a578d9b496a74dcb1d989f67550dace79">theta</a>) * <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a>);
<a name="l00338"></a>00338       total_elem_residual += context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>;
<a name="l00339"></a>00339     }
<a name="l00340"></a>00340 
<a name="l00341"></a>00341   context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>.<a class="code" href="classDenseVector.php#a4e0123eb5cc4054e8069155f0faf4425">zero</a>();
<a name="l00342"></a>00342 
<a name="l00343"></a>00343   <span class="comment">// Add the mass residual term for the old solution</span>
<a name="l00344"></a>00344 
<a name="l00345"></a>00345   <span class="comment">// Move old_-&gt;old_, delta_-&gt;elem_</span>
<a name="l00346"></a>00346   context.<a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>.<a class="code" href="classDenseVector.php#a4abb869315266cf9938c66a64189c65f">swap</a>(old_elem_solution);
<a name="l00347"></a>00347 
<a name="l00348"></a>00348   jacobian_computed = 
<a name="l00349"></a>00349     <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a5c1dd0b32156465b148fc35ca29d70e8">side_mass_residual</a>(jacobian_computed, context) &amp;&amp;
<a name="l00350"></a>00350       jacobian_computed;
<a name="l00351"></a>00351 
<a name="l00352"></a>00352   context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a> *= -(1. - <a class="code" href="classEuler2Solver.php#a578d9b496a74dcb1d989f67550dace79">theta</a>);
<a name="l00353"></a>00353   total_elem_residual += context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>;
<a name="l00354"></a>00354   context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>.<a class="code" href="classDenseVector.php#a4e0123eb5cc4054e8069155f0faf4425">zero</a>();
<a name="l00355"></a>00355 
<a name="l00356"></a>00356   <span class="keywordflow">if</span> (jacobian_computed)
<a name="l00357"></a>00357     {
<a name="l00358"></a>00358       <span class="comment">// The minus sign trick here is to avoid using a non-1</span>
<a name="l00359"></a>00359       <span class="comment">// *_solution_derivative:</span>
<a name="l00360"></a>00360       context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a> *= -(1. - <a class="code" href="classEuler2Solver.php#a578d9b496a74dcb1d989f67550dace79">theta</a>);
<a name="l00361"></a>00361       total_elem_jacobian += context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>;
<a name="l00362"></a>00362       context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>.<a class="code" href="classDenseMatrix.php#a3d3f0e57fc2e9dc7ed292cbd2124581e">zero</a>();
<a name="l00363"></a>00363     }
<a name="l00364"></a>00364 
<a name="l00365"></a>00365   <span class="comment">// Restore the elem_solution</span>
<a name="l00366"></a>00366   <span class="comment">// Move elem_-&gt;elem_, delta_-&gt;delta_</span>
<a name="l00367"></a>00367   context.<a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>.<a class="code" href="classDenseVector.php#a4abb869315266cf9938c66a64189c65f">swap</a>(delta_elem_solution);
<a name="l00368"></a>00368 
<a name="l00369"></a>00369   <span class="comment">// Restore the elem position if necessary</span>
<a name="l00370"></a>00370   context.<a class="code" href="classDiffContext.php#a2eac885c9584bdf1a5abb05fbdfa6eb1">elem_side_reinit</a>(1.);
<a name="l00371"></a>00371 
<a name="l00372"></a>00372   <span class="comment">// Add the constraint term</span>
<a name="l00373"></a>00373   jacobian_computed = <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a9520b686cc6181bff6888e0a96dd0c27">side_constraint</a>(jacobian_computed, context) &amp;&amp;
<a name="l00374"></a>00374     jacobian_computed;
<a name="l00375"></a>00375 
<a name="l00376"></a>00376   <span class="comment">// Add back the previously accumulated residual and jacobian</span>
<a name="l00377"></a>00377   context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a> += total_elem_residual;
<a name="l00378"></a>00378   <span class="keywordflow">if</span> (request_jacobian)
<a name="l00379"></a>00379     {
<a name="l00380"></a>00380       <span class="keywordflow">if</span> (jacobian_computed)
<a name="l00381"></a>00381         context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a> += total_elem_jacobian;
<a name="l00382"></a>00382       <span class="keywordflow">else</span>
<a name="l00383"></a>00383         context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>.<a class="code" href="classDenseMatrix.php#a0df961e52a0694a9300dea1714a1a369">swap</a>(old_elem_jacobian);
<a name="l00384"></a>00384     }
<a name="l00385"></a>00385 
<a name="l00386"></a>00386   <span class="keywordflow">return</span> jacobian_computed;
<a name="l00387"></a>00387 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
