<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>euler_solver.h</h1>  </div>
</div>
<div class="contents">
<a href="euler__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: euler_solver.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __euler_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __euler_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="unsteady__solver_8h.php">unsteady_solver.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00042"></a>00042 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00043"></a>00043 <span class="comment">// Solver class definition</span>
<a name="l00044"></a><a class="code" href="classEulerSolver.php">00044</a> <span class="keyword">class </span><a class="code" href="classEulerSolver.php">EulerSolver</a> : <span class="keyword">public</span> <a class="code" href="classUnsteadySolver.php">UnsteadySolver</a>
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046 <span class="keyword">public</span>:
<a name="l00050"></a><a class="code" href="classEulerSolver.php#a68250ad991df5554e8dd9d5d42f82abf">00050</a>   <span class="keyword">typedef</span> <a class="code" href="classUnsteadySolver.php">UnsteadySolver</a> <a class="code" href="classEulerSolver.php#a68250ad991df5554e8dd9d5d42f82abf">Parent</a>;
<a name="l00051"></a>00051   
<a name="l00056"></a>00056   <a class="code" href="classEulerSolver.php#a42ff640954c107d48fdd69eced8c5ee8">EulerSolver</a> (<a class="code" href="classDifferentiableSystem.php">sys_type</a>&amp; s);
<a name="l00057"></a>00057   
<a name="l00061"></a>00061   <span class="keyword">virtual</span> <a class="code" href="classEulerSolver.php#a8eb10a045c2aae2c31130b9cb2a6d1c4">~EulerSolver</a> ();
<a name="l00062"></a>00062 
<a name="l00066"></a>00066   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classEulerSolver.php#aaec7515f7dbde3ef80bebaa99f172eb7">error_order</a>() <span class="keyword">const</span>;
<a name="l00067"></a>00067 
<a name="l00074"></a>00074   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classEulerSolver.php#a671b6b6a02be44750e130d4215f8530f">element_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00075"></a>00075                                  <a class="code" href="classDiffContext.php">DiffContext</a>&amp;);
<a name="l00076"></a>00076 
<a name="l00083"></a>00083   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classEulerSolver.php#a325308585a0b3a59c44720a0f481d647">side_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00084"></a>00084                               <a class="code" href="classDiffContext.php">DiffContext</a>&amp;);
<a name="l00085"></a>00085 
<a name="l00091"></a><a class="code" href="classEulerSolver.php#a6722e51d9c5c03009578099096351dff">00091</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classEulerSolver.php#a6722e51d9c5c03009578099096351dff">theta</a>;
<a name="l00092"></a>00092 };
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 <span class="preprocessor">#endif // #define __euler_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
