<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_570b8306c88722caf9b7ae131e1a07b6.php">error_estimation</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>exact_error_estimator.C</h1>  </div>
</div>
<div class="contents">
<a href="exact__error__estimator_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: exact_error_estimator.C 3428 2009-07-17 01:51:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::fill</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;cmath&gt;</span>    <span class="comment">// for sqrt</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local Includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;exact_error_estimator.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;dof_map.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;equation_systems.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;error_vector.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;fe.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;fe_interface.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;mesh.h&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;mesh_function.h&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;quadrature.h&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;system.h&quot;</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00043"></a>00043 <span class="comment">// ErrorEstimator implementations</span>
<a name="l00044"></a><a class="code" href="classExactSolution.php#adf85a62f95cf446dc568c2540142e424">00044</a> <span class="keywordtype">void</span> <a class="code" href="classExactErrorEstimator.php#a3ae1d7676aea73a605811142c42a6dfe">ExactErrorEstimator::attach_exact_value</a> (<a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> fptr(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00045"></a>00045                                                           <span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; parameters,
<a name="l00046"></a>00046                                                           <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00047"></a>00047                                                           <span class="keyword">const</span> std::string&amp; unknown_name))
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049   libmesh_assert (fptr != NULL);
<a name="l00050"></a>00050   <a class="code" href="classExactErrorEstimator.php#a23103779753cca554de3816385ee43ea">_exact_value</a> = fptr;
<a name="l00051"></a>00051 
<a name="l00052"></a>00052   <span class="comment">// If we&#39;re not using a fine grid solution</span>
<a name="l00053"></a>00053   <a class="code" href="classExactErrorEstimator.php#ad3c314550179f33ed25d7f6d16ceaad3">_equation_systems_fine</a> = NULL;
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 }
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a><a class="code" href="classExactErrorEstimator.php#a77dc4e34427bd363b8d2ac4da7a2d5e4">00058</a> <span class="keywordtype">void</span> <a class="code" href="classExactErrorEstimator.php#a77dc4e34427bd363b8d2ac4da7a2d5e4">ExactErrorEstimator::attach_exact_deriv</a> (<a class="code" href="classVectorValue.php">Gradient</a> fptr(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00059"></a>00059                                                             <span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; parameters,
<a name="l00060"></a>00060                                                             <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00061"></a>00061                                                             <span class="keyword">const</span> std::string&amp; unknown_name))
<a name="l00062"></a>00062 {
<a name="l00063"></a>00063   libmesh_assert (fptr != NULL);
<a name="l00064"></a>00064   <a class="code" href="classExactErrorEstimator.php#af277dc01661de2824d27895efe424d0c">_exact_deriv</a> = fptr;
<a name="l00065"></a>00065 
<a name="l00066"></a>00066   <span class="comment">// If we&#39;re not using a fine grid solution</span>
<a name="l00067"></a>00067   <a class="code" href="classExactErrorEstimator.php#ad3c314550179f33ed25d7f6d16ceaad3">_equation_systems_fine</a> = NULL;
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 }
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 
<a name="l00072"></a><a class="code" href="classExactErrorEstimator.php#a32caefcffa2c417b9e14f05779c396b8">00072</a> <span class="keywordtype">void</span> <a class="code" href="classExactErrorEstimator.php#a32caefcffa2c417b9e14f05779c396b8">ExactErrorEstimator::attach_exact_hessian</a> (<a class="code" href="classTensorValue.php">Tensor</a> fptr(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00073"></a>00073                                                             <span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; parameters,
<a name="l00074"></a>00074                                                             <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00075"></a>00075                                                             <span class="keyword">const</span> std::string&amp; unknown_name))
<a name="l00076"></a>00076 {
<a name="l00077"></a>00077   libmesh_assert (fptr != NULL);
<a name="l00078"></a>00078   <a class="code" href="classExactErrorEstimator.php#a04184fa52c05e36febe6e2d68e82a8f8">_exact_hessian</a> = fptr;
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   <span class="comment">// If we&#39;re not using a fine grid solution</span>
<a name="l00081"></a>00081   <a class="code" href="classExactErrorEstimator.php#ad3c314550179f33ed25d7f6d16ceaad3">_equation_systems_fine</a> = NULL;
<a name="l00082"></a>00082 }
<a name="l00083"></a>00083 
<a name="l00084"></a><a class="code" href="classExactErrorEstimator.php#a24e494960f1e823f40d00639bf81896c">00084</a> <span class="keywordtype">void</span> <a class="code" href="classExactErrorEstimator.php#a24e494960f1e823f40d00639bf81896c">ExactErrorEstimator::attach_reference_solution</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>* es_fine)
<a name="l00085"></a>00085 {
<a name="l00086"></a>00086   libmesh_assert (es_fine != NULL);
<a name="l00087"></a>00087   <a class="code" href="classExactErrorEstimator.php#ad3c314550179f33ed25d7f6d16ceaad3">_equation_systems_fine</a> = es_fine;
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   <span class="comment">// If we&#39;re using a fine grid solution, we&#39;re not using exact values</span>
<a name="l00090"></a>00090   <a class="code" href="classExactErrorEstimator.php#a23103779753cca554de3816385ee43ea">_exact_value</a> = NULL;
<a name="l00091"></a>00091   <a class="code" href="classExactErrorEstimator.php#af277dc01661de2824d27895efe424d0c">_exact_deriv</a> = NULL;
<a name="l00092"></a>00092   <a class="code" href="classExactErrorEstimator.php#a04184fa52c05e36febe6e2d68e82a8f8">_exact_hessian</a> = NULL;
<a name="l00093"></a>00093 }
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00096"></a><a class="code" href="classExactErrorEstimator.php#a7c187e02f2557081fa852c7de18a468c">00096</a> <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="classExactErrorEstimator.php#a7c187e02f2557081fa852c7de18a468c">ExactErrorEstimator::estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; system,
<a name="l00097"></a>00097                                           <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00098"></a>00098                                           <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector,
<a name="l00099"></a>00099                                           <span class="keywordtype">bool</span> estimate_parent_error)
<a name="l00100"></a>00100 <span class="preprocessor">#else</span>
<a name="l00101"></a>00101 <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="classExactErrorEstimator.php#a7c187e02f2557081fa852c7de18a468c">ExactErrorEstimator::estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; system,
<a name="l00102"></a>00102                                           <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00103"></a>00103                                           <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector,
<a name="l00104"></a>00104                                           <span class="keywordtype">bool</span> <span class="comment">/* estimate_parent_error */</span> )
<a name="l00105"></a>00105 <span class="preprocessor">#endif</span>
<a name="l00106"></a>00106 <span class="preprocessor"></span>{
<a name="l00107"></a>00107   <span class="comment">// The current mesh</span>
<a name="l00108"></a>00108   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh = system.<a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">get_mesh</a>();
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   <span class="comment">// The dimensionality of the mesh</span>
<a name="l00111"></a>00111   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = mesh.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>();
<a name="l00112"></a>00112   
<a name="l00113"></a>00113   <span class="comment">// The number of variables in the system</span>
<a name="l00114"></a>00114   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_vars = system.<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>();
<a name="l00115"></a>00115   
<a name="l00116"></a>00116   <span class="comment">// The DofMap for this system</span>
<a name="l00117"></a>00117   <span class="keyword">const</span> <a class="code" href="classDofMap.php">DofMap</a>&amp; dof_map = system.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>();
<a name="l00118"></a>00118 
<a name="l00119"></a>00119   <span class="comment">// Resize the error_per_cell vector to be</span>
<a name="l00120"></a>00120   <span class="comment">// the number of elements, initialize it to 0.</span>
<a name="l00121"></a>00121   error_per_cell.resize (mesh.<a class="code" href="classMeshBase.php#a05c0414e5c91b36e9698fc4f60cff642">max_elem_id</a>());
<a name="l00122"></a>00122   std::fill (error_per_cell.begin(), error_per_cell.end(), 0.);
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <span class="comment">// Prepare current_local_solution to localize a non-standard</span>
<a name="l00125"></a>00125   <span class="comment">// solution vector if necessary</span>
<a name="l00126"></a>00126   <span class="keywordflow">if</span> (solution_vector &amp;&amp; solution_vector != system.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>())
<a name="l00127"></a>00127     {
<a name="l00128"></a>00128       <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* newsol =
<a name="l00129"></a>00129         <span class="keyword">const_cast&lt;</span><a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>*<span class="keyword">&gt;</span>(solution_vector);
<a name="l00130"></a>00130       <a class="code" href="classSystem.php">System</a> &amp;sys = <span class="keyword">const_cast&lt;</span><a class="code" href="classSystem.php">System</a>&amp;<span class="keyword">&gt;</span>(system);
<a name="l00131"></a>00131       newsol-&gt;<a class="code" href="classNumericVector.php#a51e2011eeca6faa30e349c1950352eb8">swap</a>(*sys.solution);
<a name="l00132"></a>00132       sys.update();
<a name="l00133"></a>00133     }
<a name="l00134"></a>00134   
<a name="l00135"></a>00135   <span class="comment">// Loop over all the variables in the system</span>
<a name="l00136"></a>00136   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;n_vars; var++)
<a name="l00137"></a>00137     {
<a name="l00138"></a>00138       <span class="comment">// Possibly skip this variable</span>
<a name="l00139"></a>00139       <span class="keywordflow">if</span> (error_norm.weight(var) == 0.0) <span class="keywordflow">continue</span>;
<a name="l00140"></a>00140 
<a name="l00141"></a>00141       <span class="comment">// The (string) name of this variable</span>
<a name="l00142"></a>00142       <span class="keyword">const</span> std::string&amp; var_name = system.<a class="code" href="classSystem.php#af3a38b172dd6322eff9f30b3f63d3b63">variable_name</a>(var);
<a name="l00143"></a>00143       
<a name="l00144"></a>00144       <span class="comment">// The type of finite element to use for this variable</span>
<a name="l00145"></a>00145       <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_type = dof_map.<a class="code" href="classDofMap.php#ae3c63266417020f38af6e5cc40efca76">variable_type</a> (var);
<a name="l00146"></a>00146       
<a name="l00147"></a>00147       <a class="code" href="classAutoPtr.php">AutoPtr&lt;FEBase&gt;</a> fe (<a class="code" href="classFEBase.php#a3e86219b79ce4f881e9c48f4fd7b860e">FEBase::build</a> (dim, fe_type));
<a name="l00148"></a>00148 
<a name="l00149"></a>00149       <span class="comment">// Build an appropriate Gaussian quadrature rule</span>
<a name="l00150"></a>00150       <a class="code" href="classAutoPtr.php">AutoPtr&lt;QBase&gt;</a> qrule =
<a name="l00151"></a>00151         fe_type.<a class="code" href="classFEType.php#a33013296ee9643faec0262714ad9163c">default_quadrature_rule</a> (dim,
<a name="l00152"></a>00152                                          _extra_order);
<a name="l00153"></a>00153 
<a name="l00154"></a>00154       fe-&gt;attach_quadrature_rule (qrule.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>());
<a name="l00155"></a>00155 
<a name="l00156"></a>00156       <span class="comment">// Prepare a global solution and a MeshFunction of the fine system if we need one</span>
<a name="l00157"></a>00157       <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;MeshFunction&gt;</a> fine_values;
<a name="l00158"></a>00158       <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; fine_soln = <a class="code" href="classNumericVector.php#a5c1d43e1a85ffb0487d1e0ae43918bd4">NumericVector&lt;Number&gt;::build</a>();
<a name="l00159"></a>00159       <span class="keywordflow">if</span> (_equation_systems_fine)
<a name="l00160"></a>00160       {
<a name="l00161"></a>00161         <span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; fine_system = _equation_systems_fine-&gt;get_system(system.<a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>());
<a name="l00162"></a>00162 
<a name="l00163"></a>00163         std::vector&lt;Number&gt; global_soln;
<a name="l00164"></a>00164         <span class="comment">// FIXME - we&#39;re assuming that the fine system solution gets</span>
<a name="l00165"></a>00165         <span class="comment">// used even when a different vector is used for the coarse</span>
<a name="l00166"></a>00166         <span class="comment">// system</span>
<a name="l00167"></a>00167         fine_system.<a class="code" href="classSystem.php#afb0ea08442d8a71cf040f598f767a396">update_global_solution</a>(global_soln);
<a name="l00168"></a>00168         fine_soln-&gt;init (global_soln.size(), <span class="keyword">true</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>);
<a name="l00169"></a>00169         (*fine_soln) = global_soln;
<a name="l00170"></a>00170 
<a name="l00171"></a>00171         fine_values = <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;MeshFunction&gt;</a>
<a name="l00172"></a>00172           (<span class="keyword">new</span> <a class="code" href="classMeshFunction.php">MeshFunction</a>(*_equation_systems_fine,
<a name="l00173"></a>00173                             *fine_soln,
<a name="l00174"></a>00174                             fine_system.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>(),
<a name="l00175"></a>00175                             fine_system.<a class="code" href="classSystem.php#ace6000ea1d0dc7e3635fe98761f95838">variable_number</a>(var_name)));
<a name="l00176"></a>00176         fine_values-&gt;init();
<a name="l00177"></a>00177       }
<a name="l00178"></a>00178 
<a name="l00179"></a>00179       <span class="comment">// Request the data we&#39;ll need to compute with</span>
<a name="l00180"></a>00180       fe-&gt;get_JxW();
<a name="l00181"></a>00181       fe-&gt;get_phi();
<a name="l00182"></a>00182       fe-&gt;get_dphi();
<a name="l00183"></a>00183 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00184"></a>00184 <span class="preprocessor"></span>      fe-&gt;get_d2phi();
<a name="l00185"></a>00185 <span class="preprocessor">#endif</span>
<a name="l00186"></a>00186 <span class="preprocessor"></span>      fe-&gt;get_xyz();
<a name="l00187"></a>00187 
<a name="l00188"></a>00188       <span class="comment">// Iterate over all the active elements in the mesh</span>
<a name="l00189"></a>00189       <span class="comment">// that live on this processor.</span>
<a name="l00190"></a>00190       <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>
<a name="l00191"></a>00191         elem_it  = mesh.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00192"></a>00192       <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>
<a name="l00193"></a>00193         elem_end = mesh.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>(); 
<a name="l00194"></a>00194 
<a name="l00195"></a>00195       <span class="keywordflow">for</span> (;elem_it != elem_end; ++elem_it)
<a name="l00196"></a>00196         {
<a name="l00197"></a>00197           <span class="comment">// e is necessarily an active element on the local processor</span>
<a name="l00198"></a>00198           <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *elem_it;
<a name="l00199"></a>00199           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e_id = elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00202"></a>00202 <span class="preprocessor"></span>          <span class="comment">// See if the parent of element e has been examined yet;</span>
<a name="l00203"></a>00203           <span class="comment">// if not, we may want to compute the estimator on it</span>
<a name="l00204"></a>00204           <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* parent = elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>();
<a name="l00205"></a>00205 
<a name="l00206"></a>00206           <span class="comment">// We only can compute and only need to compute on</span>
<a name="l00207"></a>00207           <span class="comment">// parents with all active children</span>
<a name="l00208"></a>00208           <span class="keywordtype">bool</span> compute_on_parent = <span class="keyword">true</span>;
<a name="l00209"></a>00209           <span class="keywordflow">if</span> (!parent || !estimate_parent_error)
<a name="l00210"></a>00210             compute_on_parent = <span class="keyword">false</span>;
<a name="l00211"></a>00211           <span class="keywordflow">else</span>
<a name="l00212"></a>00212             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c != parent-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); ++c)
<a name="l00213"></a>00213               <span class="keywordflow">if</span> (!parent-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c)-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l00214"></a>00214                 compute_on_parent = <span class="keyword">false</span>;
<a name="l00215"></a>00215 
<a name="l00216"></a>00216           <span class="keywordflow">if</span> (compute_on_parent &amp;&amp;
<a name="l00217"></a>00217               !error_per_cell[parent-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()])
<a name="l00218"></a>00218             {
<a name="l00219"></a>00219               <span class="comment">// Compute a projection onto the parent</span>
<a name="l00220"></a>00220               <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a> Uparent;
<a name="l00221"></a>00221               <a class="code" href="classFEBase.php#aa40da3a01b0a89422bd2477fb4baf149">FEBase::coarsened_dof_values</a>(*(system.<a class="code" href="classSystem.php#a47b00cd00684aebe3c095aba010626e5">current_local_solution</a>),
<a name="l00222"></a>00222                                            dof_map, parent, Uparent,
<a name="l00223"></a>00223                                            var, <span class="keyword">false</span>);
<a name="l00224"></a>00224 
<a name="l00225"></a>00225               error_per_cell[parent-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] =
<a name="l00226"></a>00226                 find_squared_element_error(system, var_name, parent, Uparent,
<a name="l00227"></a>00227                                            fe.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>(), fine_values.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>());
<a name="l00228"></a>00228             }
<a name="l00229"></a>00229 <span class="preprocessor">#endif</span>
<a name="l00230"></a>00230 <span class="preprocessor"></span>
<a name="l00231"></a>00231           <span class="comment">// Get the local to global degree of freedom maps</span>
<a name="l00232"></a>00232           std::vector&lt;unsigned int&gt; dof_indices;
<a name="l00233"></a>00233           dof_map.<a class="code" href="classDofMap.php#afc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (elem, dof_indices, var);
<a name="l00234"></a>00234           <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a> Uelem(dof_indices.size());
<a name="l00235"></a>00235           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != dof_indices.size(); ++i)
<a name="l00236"></a>00236             Uelem(i) = system.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(dof_indices[i]);
<a name="l00237"></a>00237 
<a name="l00238"></a>00238           error_per_cell[e_id] =
<a name="l00239"></a>00239             find_squared_element_error(system, var_name, elem, Uelem,
<a name="l00240"></a>00240                                        fe.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>(), fine_values.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>());
<a name="l00241"></a>00241 
<a name="l00242"></a>00242         } <span class="comment">// End loop over active local elements</span>
<a name="l00243"></a>00243     } <span class="comment">// End loop over variables</span>
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 
<a name="l00246"></a>00246   
<a name="l00247"></a>00247   <span class="comment">// Each processor has now computed the error contribuions</span>
<a name="l00248"></a>00248   <span class="comment">// for its local elements.  We need to sum the vector</span>
<a name="l00249"></a>00249   <span class="comment">// and then take the square-root of each component.  Note</span>
<a name="l00250"></a>00250   <span class="comment">// that we only need to sum if we are running on multiple</span>
<a name="l00251"></a>00251   <span class="comment">// processors, and we only need to take the square-root</span>
<a name="l00252"></a>00252   <span class="comment">// if the value is nonzero.  There will in general be many</span>
<a name="l00253"></a>00253   <span class="comment">// zeros for the inactive elements.</span>
<a name="l00254"></a>00254 
<a name="l00255"></a>00255   <span class="comment">// First sum the vector of estimated error values</span>
<a name="l00256"></a>00256   this-&gt;reduce_error(error_per_cell);
<a name="l00257"></a>00257 
<a name="l00258"></a>00258   <span class="comment">// Compute the square-root of each component.</span>
<a name="l00259"></a>00259   START_LOG(<span class="stringliteral">&quot;std::sqrt()&quot;</span>, <span class="stringliteral">&quot;ExactErrorEstimator&quot;</span>);
<a name="l00260"></a>00260   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;error_per_cell.size(); i++)
<a name="l00261"></a>00261     {
<a name="l00262"></a>00262       
<a name="l00263"></a>00263       <span class="keywordflow">if</span> (error_per_cell[i] != 0.)
<a name="l00264"></a>00264         {
<a name="l00265"></a>00265           libmesh_assert (error_per_cell[i] &gt; 0.);
<a name="l00266"></a>00266           error_per_cell[i] = std::sqrt(error_per_cell[i]);
<a name="l00267"></a>00267         }
<a name="l00268"></a>00268       
<a name="l00269"></a>00269       
<a name="l00270"></a>00270     }
<a name="l00271"></a>00271   STOP_LOG(<span class="stringliteral">&quot;std::sqrt()&quot;</span>, <span class="stringliteral">&quot;ExactErrorEstimator&quot;</span>);
<a name="l00272"></a>00272 
<a name="l00273"></a>00273   <span class="comment">// If we used a non-standard solution before, now is the time to fix</span>
<a name="l00274"></a>00274   <span class="comment">// the current_local_solution</span>
<a name="l00275"></a>00275   <span class="keywordflow">if</span> (solution_vector &amp;&amp; solution_vector != system.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>())
<a name="l00276"></a>00276     {
<a name="l00277"></a>00277       <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* newsol =
<a name="l00278"></a>00278         <span class="keyword">const_cast&lt;</span><a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>*<span class="keyword">&gt;</span>(solution_vector);
<a name="l00279"></a>00279       <a class="code" href="classSystem.php">System</a> &amp;sys = <span class="keyword">const_cast&lt;</span><a class="code" href="classSystem.php">System</a>&amp;<span class="keyword">&gt;</span>(system);
<a name="l00280"></a>00280       newsol-&gt;<a class="code" href="classNumericVector.php#a51e2011eeca6faa30e349c1950352eb8">swap</a>(*sys.solution);
<a name="l00281"></a>00281       sys.update();
<a name="l00282"></a>00282     }
<a name="l00283"></a>00283 }
<a name="l00284"></a>00284 
<a name="l00285"></a>00285 
<a name="l00286"></a>00286 
<a name="l00287"></a><a class="code" href="classExactErrorEstimator.php#ac0fb2ffeae1a3458d3c69bd13dcef804">00287</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classExactErrorEstimator.php#ac0fb2ffeae1a3458d3c69bd13dcef804">ExactErrorEstimator::find_squared_element_error</a>(<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; system,
<a name="l00288"></a>00288                                                      <span class="keyword">const</span> std::string&amp; var_name,
<a name="l00289"></a>00289                                                      <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *elem,
<a name="l00290"></a>00290                                                      <span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a> &amp;Uelem,
<a name="l00291"></a>00291                                                      <a class="code" href="classFEBase.php">FEBase</a> *fe,
<a name="l00292"></a>00292                                                      <a class="code" href="classMeshFunction.php">MeshFunction</a> *fine_values)<span class="keyword"> const</span>
<a name="l00293"></a>00293 <span class="keyword"></span>{
<a name="l00294"></a>00294   <span class="comment">// The (string) name of this system</span>
<a name="l00295"></a>00295   <span class="keyword">const</span> std::string&amp; sys_name = system.<a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>();
<a name="l00296"></a>00296 
<a name="l00297"></a>00297   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = system.<a class="code" href="classSystem.php#ace6000ea1d0dc7e3635fe98761f95838">variable_number</a>(var_name);
<a name="l00298"></a>00298   
<a name="l00299"></a>00299   <span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; parameters = system.<a class="code" href="classSystem.php#a51da3ea6211cf1888377c9c4b1554232">get_equation_systems</a>().<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>;
<a name="l00300"></a>00300 
<a name="l00301"></a>00301   <span class="comment">// reinitialize the element-specific data</span>
<a name="l00302"></a>00302   <span class="comment">// for the current element</span>
<a name="l00303"></a>00303   fe-&gt;<a class="code" href="classFEBase.php#a2e8aa83ccd81231f77faa31f9009f414">reinit</a> (elem);
<a name="l00304"></a>00304 
<a name="l00305"></a>00305   <span class="comment">// Get the data we need to compute with</span>
<a name="l00306"></a>00306   <span class="keyword">const</span> std::vector&lt;Real&gt; &amp;                      JxW          = fe-&gt;<a class="code" href="classFEBase.php#adec8e65552df156ed36073da4709b8a5">get_JxW</a>();
<a name="l00307"></a>00307   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp;         phi_values   = fe-&gt;<a class="code" href="classFEBase.php#a27e841f837a1517dd0bfe68b99515df7">get_phi</a>();
<a name="l00308"></a>00308   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt;&amp; dphi_values  = fe-&gt;<a class="code" href="classFEBase.php#a11642793fbc6a37ea9b912ce92c7d1be">get_dphi</a>();
<a name="l00309"></a>00309   <span class="keyword">const</span> std::vector&lt;Point&gt;&amp;                      q_point      = fe-&gt;<a class="code" href="classFEBase.php#a25ce71d550e75e00f29df0ae04c957cc">get_xyz</a>();
<a name="l00310"></a>00310 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00311"></a>00311 <span class="preprocessor"></span>  <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealTensor&gt; &gt;&amp;   d2phi_values = fe-&gt;<a class="code" href="classFEBase.php#ae80dd03eb2074ecf0d0e734a213cdb4e">get_d2phi</a>();
<a name="l00312"></a>00312 <span class="preprocessor">#endif</span>
<a name="l00313"></a>00313 <span class="preprocessor"></span>
<a name="l00314"></a>00314   <span class="comment">// The number of shape functions</span>
<a name="l00315"></a>00315   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sf = Uelem.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>();
<a name="l00316"></a>00316 
<a name="l00317"></a>00317   <span class="comment">// The number of quadrature points</span>
<a name="l00318"></a>00318   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = JxW.size();
<a name="l00319"></a>00319 
<a name="l00320"></a>00320   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> error_val = 0;
<a name="l00321"></a>00321 
<a name="l00322"></a>00322   <span class="comment">// Begin the loop over the Quadrature points.</span>
<a name="l00323"></a>00323   <span class="comment">//</span>
<a name="l00324"></a>00324   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;n_qp; qp++)
<a name="l00325"></a>00325     {
<a name="l00326"></a>00326       <span class="comment">// Real u_h = 0.;</span>
<a name="l00327"></a>00327       <span class="comment">// RealGradient grad_u_h;</span>
<a name="l00328"></a>00328 
<a name="l00329"></a>00329       <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> u_h = 0.;
<a name="l00330"></a>00330 
<a name="l00331"></a>00331       <a class="code" href="classVectorValue.php">Gradient</a> grad_u_h;
<a name="l00332"></a>00332 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00333"></a>00333 <span class="preprocessor"></span>      <a class="code" href="classTensorValue.php">Tensor</a> grad2_u_h;
<a name="l00334"></a>00334 <span class="preprocessor">#endif</span>
<a name="l00335"></a>00335 <span class="preprocessor"></span>
<a name="l00336"></a>00336       <span class="comment">// Compute solution values at the current</span>
<a name="l00337"></a>00337       <span class="comment">// quadrature point.  This reqiures a sum</span>
<a name="l00338"></a>00338       <span class="comment">// over all the shape functions evaluated</span>
<a name="l00339"></a>00339       <span class="comment">// at the quadrature point.</span>
<a name="l00340"></a>00340       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_sf; i++)
<a name="l00341"></a>00341         {
<a name="l00342"></a>00342           <span class="comment">// Values from current solution.</span>
<a name="l00343"></a>00343           u_h      += phi_values[i][qp]*Uelem(i);
<a name="l00344"></a>00344           grad_u_h += dphi_values[i][qp]*Uelem(i);
<a name="l00345"></a>00345 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00346"></a>00346 <span class="preprocessor"></span>          grad2_u_h += d2phi_values[i][qp]*Uelem(i);
<a name="l00347"></a>00347 <span class="preprocessor">#endif</span>
<a name="l00348"></a>00348 <span class="preprocessor"></span>        }
<a name="l00349"></a>00349 
<a name="l00350"></a>00350       <span class="comment">// Compute the value of the error at this quadrature point</span>
<a name="l00351"></a>00351       <span class="keywordflow">if</span> (<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a> ||
<a name="l00352"></a>00352           <a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a7a46908fc35e8855517abd137413214c">H1</a> ||
<a name="l00353"></a>00353           <a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a>)
<a name="l00354"></a>00354         {
<a name="l00355"></a>00355           <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> val_error = 0;
<a name="l00356"></a>00356           <span class="keywordflow">if</span>(<a class="code" href="classExactErrorEstimator.php#a23103779753cca554de3816385ee43ea">_exact_value</a>)
<a name="l00357"></a>00357             val_error = u_h - <a class="code" href="classExactErrorEstimator.php#a23103779753cca554de3816385ee43ea">_exact_value</a>(q_point[qp],parameters,sys_name,var_name);
<a name="l00358"></a>00358           <span class="keywordflow">else</span> <span class="keywordflow">if</span>(<a class="code" href="classExactErrorEstimator.php#ad3c314550179f33ed25d7f6d16ceaad3">_equation_systems_fine</a>)
<a name="l00359"></a>00359             val_error = u_h - (*fine_values)(q_point[qp]);
<a name="l00360"></a>00360 
<a name="l00361"></a>00361           <span class="comment">// Add the squares of the error to each contribution</span>
<a name="l00362"></a>00362           error_val += JxW[qp]*<a class="code" href="libmesh__common_8h.php#af9cdd07341b53cc644199f6aec5e1420">libmesh_norm</a>(val_error);
<a name="l00363"></a>00363         }
<a name="l00364"></a>00364 
<a name="l00365"></a>00365       <span class="comment">// Compute the value of the error in the gradient at this</span>
<a name="l00366"></a>00366       <span class="comment">// quadrature point</span>
<a name="l00367"></a>00367       <span class="keywordflow">if</span> ((<a class="code" href="classExactErrorEstimator.php#af277dc01661de2824d27895efe424d0c">_exact_deriv</a> || <a class="code" href="classExactErrorEstimator.php#ad3c314550179f33ed25d7f6d16ceaad3">_equation_systems_fine</a>) &amp;&amp; 
<a name="l00368"></a>00368           (<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a7a46908fc35e8855517abd137413214c">H1</a> ||
<a name="l00369"></a>00369            <a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a> ||
<a name="l00370"></a>00370            <a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a>))
<a name="l00371"></a>00371         {
<a name="l00372"></a>00372           <a class="code" href="classVectorValue.php">Gradient</a> grad_error;
<a name="l00373"></a>00373           <span class="keywordflow">if</span>(<a class="code" href="classExactErrorEstimator.php#af277dc01661de2824d27895efe424d0c">_exact_deriv</a>)
<a name="l00374"></a>00374             grad_error = grad_u_h - <a class="code" href="classExactErrorEstimator.php#af277dc01661de2824d27895efe424d0c">_exact_deriv</a>(q_point[qp],parameters,sys_name,var_name);
<a name="l00375"></a>00375           <span class="keywordflow">else</span> <span class="keywordflow">if</span>(<a class="code" href="classExactErrorEstimator.php#ad3c314550179f33ed25d7f6d16ceaad3">_equation_systems_fine</a>)
<a name="l00376"></a>00376             grad_error = grad_u_h - fine_values-&gt;<a class="code" href="classMeshFunction.php#a37bc6d22da064994a924034ddc1d5b2f">gradient</a>(q_point[qp]);
<a name="l00377"></a>00377 
<a name="l00378"></a>00378           error_val += JxW[qp]*grad_error.<a class="code" href="classTypeVector.php#a099aac580a3a6fce9276cf5443d0c0e9">size_sq</a>();
<a name="l00379"></a>00379         }
<a name="l00380"></a>00380 
<a name="l00381"></a>00381 
<a name="l00382"></a>00382 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00383"></a>00383 <span class="preprocessor"></span>      <span class="comment">// Compute the value of the error in the hessian at this</span>
<a name="l00384"></a>00384       <span class="comment">// quadrature point</span>
<a name="l00385"></a>00385       <span class="keywordflow">if</span> ((<a class="code" href="classExactErrorEstimator.php#a04184fa52c05e36febe6e2d68e82a8f8">_exact_hessian</a> || <a class="code" href="classExactErrorEstimator.php#ad3c314550179f33ed25d7f6d16ceaad3">_equation_systems_fine</a>) &amp;&amp; 
<a name="l00386"></a>00386           (<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a> ||
<a name="l00387"></a>00387            <a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a>))
<a name="l00388"></a>00388         {
<a name="l00389"></a>00389           <a class="code" href="classTensorValue.php">Tensor</a> grad2_error;
<a name="l00390"></a>00390           <span class="keywordflow">if</span>(<a class="code" href="classExactErrorEstimator.php#a04184fa52c05e36febe6e2d68e82a8f8">_exact_hessian</a>)
<a name="l00391"></a>00391             grad2_error = grad2_u_h - <a class="code" href="classExactErrorEstimator.php#a04184fa52c05e36febe6e2d68e82a8f8">_exact_hessian</a>(q_point[qp],parameters,sys_name,var_name);
<a name="l00392"></a>00392           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classExactErrorEstimator.php#ad3c314550179f33ed25d7f6d16ceaad3">_equation_systems_fine</a>)
<a name="l00393"></a>00393             grad2_error = grad2_u_h - fine_values-&gt;<a class="code" href="classMeshFunction.php#a020bc9e4fcb430939b3dd92be8fe78c9">hessian</a>(q_point[qp]);
<a name="l00394"></a>00394 
<a name="l00395"></a>00395           error_val += JxW[qp]*grad2_error.<a class="code" href="classTypeTensor.php#a7be64b1de5e558f2de032bde1f881220">size_sq</a>();
<a name="l00396"></a>00396         }
<a name="l00397"></a>00397 <span class="preprocessor">#endif</span>
<a name="l00398"></a>00398 <span class="preprocessor"></span>
<a name="l00399"></a>00399     } <span class="comment">// end qp loop</span>
<a name="l00400"></a>00400 
<a name="l00401"></a>00401   libmesh_assert (error_val &gt;= 0.);
<a name="l00402"></a>00402           
<a name="l00403"></a>00403   <span class="keywordflow">return</span> error_val;
<a name="l00404"></a>00404 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
