<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c8cf73965feff5280e8b0581da1a9d14.php">error_estimation</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>exact_error_estimator.h</h1>  </div>
</div>
<div class="contents">
<a href="exact__error__estimator_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: exact_error_estimator.h 3428 2009-07-17 01:51:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __exact_error_estimator_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __exact_error_estimator_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="error__estimator_8h.php">error_estimator.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Forward Declarations</span>
<a name="l00033"></a>00033 <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00034"></a>00034 <span class="keyword">class </span><a class="code" href="classFEBase.php">FEBase</a>;
<a name="l00035"></a>00035 <span class="keyword">class </span><a class="code" href="classMeshFunction.php">MeshFunction</a>;
<a name="l00036"></a>00036 <span class="keyword">class </span><a class="code" href="classPoint.php">Point</a>;
<a name="l00037"></a>00037 <span class="keyword">class </span><a class="code" href="classParameters.php">Parameters</a>;
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classDenseVector.php">DenseVector</a>;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">// Is there any way to simplify this?</span>
<a name="l00042"></a>00042 <span class="comment">// All we need are Tensor and Gradient. - RHS</span>
<a name="l00043"></a>00043 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classTensorValue.php">TensorValue</a>;
<a name="l00044"></a><a class="code" href="exact__error__estimator_8h.php#a2b366093afa6b61a59776dfa7e77de92">00044</a> <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classVectorValue.php">VectorValue</a>;
<a name="l00045"></a>00045 <span class="keyword">typedef</span> <a class="code" href="classTensorValue.php">TensorValue&lt;Number&gt;</a> <a class="code" href="exact__error__estimator_8h.php#a2b366093afa6b61a59776dfa7e77de92">NumberTensorValue</a>;
<a name="l00046"></a><a class="code" href="exact__error__estimator_8h.php#a58d868eeb8275e1659eb7680a618f0d7">00046</a> <span class="keyword">typedef</span> <a class="code" href="classTensorValue.php">NumberTensorValue</a>   <a class="code" href="exact__error__estimator_8h.php#a58d868eeb8275e1659eb7680a618f0d7">Tensor</a>;
<a name="l00047"></a><a class="code" href="exact__error__estimator_8h.php#a08d743aadc7b1860846e8aa6dfa7ae41">00047</a> <span class="keyword">typedef</span> <a class="code" href="classVectorValue.php">VectorValue&lt;Number&gt;</a> <a class="code" href="exact__error__estimator_8h.php#a08d743aadc7b1860846e8aa6dfa7ae41">NumberVectorValue</a>;
<a name="l00048"></a><a class="code" href="exact__error__estimator_8h.php#aff779e61aca326de0c3649ec86a15866">00048</a> <span class="keyword">typedef</span> <a class="code" href="classVectorValue.php">NumberVectorValue</a>   <a class="code" href="exact__error__estimator_8h.php#aff779e61aca326de0c3649ec86a15866">Gradient</a>;
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00062"></a><a class="code" href="classExactErrorEstimator.php">00062</a> <span class="keyword">class </span><a class="code" href="classExactErrorEstimator.php">ExactErrorEstimator</a> : <span class="keyword">public</span> <a class="code" href="classErrorEstimator.php">ErrorEstimator</a>
<a name="l00063"></a>00063 {
<a name="l00064"></a>00064 <span class="keyword">public</span>:
<a name="l00065"></a>00065 
<a name="l00070"></a><a class="code" href="classExactErrorEstimator.php#ae3e729d6bf11063bd6abf998003dc3ec">00070</a>   <a class="code" href="classExactErrorEstimator.php#ae3e729d6bf11063bd6abf998003dc3ec">ExactErrorEstimator</a>() : <a class="code" href="classExactErrorEstimator.php#a23103779753cca554de3816385ee43ea">_exact_value</a>(NULL), 
<a name="l00071"></a>00071                           <a class="code" href="classExactErrorEstimator.php#af277dc01661de2824d27895efe424d0c">_exact_deriv</a>(NULL),
<a name="l00072"></a>00072                           <a class="code" href="classExactErrorEstimator.php#a04184fa52c05e36febe6e2d68e82a8f8">_exact_hessian</a>(NULL),
<a name="l00073"></a>00073                           <a class="code" href="classExactErrorEstimator.php#a413963f66ca87164f69d3f532c8be410">_extra_order</a>(0)
<a name="l00074"></a>00074   { <a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a> = <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a7a46908fc35e8855517abd137413214c">H1</a>; }
<a name="l00075"></a>00075   
<a name="l00079"></a><a class="code" href="classExactErrorEstimator.php#af3a33fb7d35c66dfbd68bfa274c021f2">00079</a>   <a class="code" href="classExactErrorEstimator.php#af3a33fb7d35c66dfbd68bfa274c021f2">~ExactErrorEstimator</a>() {}
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00088"></a>00088   <span class="keywordtype">void</span> <a class="code" href="classExactErrorEstimator.php#a3ae1d7676aea73a605811142c42a6dfe">attach_exact_value</a> ( <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> fptr(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00089"></a>00089                                         <span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; <a class="code" href="classParameters.php">Parameters</a>,
<a name="l00090"></a>00090                                         <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00091"></a>00091                                         <span class="keyword">const</span> std::string&amp; unknown_name));
<a name="l00092"></a>00092 
<a name="l00099"></a>00099   <span class="keywordtype">void</span> <a class="code" href="classExactErrorEstimator.php#a77dc4e34427bd363b8d2ac4da7a2d5e4">attach_exact_deriv</a> ( <a class="code" href="classVectorValue.php">Gradient</a> fptr(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00100"></a>00100                                           <span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; parameters,
<a name="l00101"></a>00101                                           <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00102"></a>00102                                           <span class="keyword">const</span> std::string&amp; unknown_name));
<a name="l00103"></a>00103 
<a name="l00110"></a>00110   <span class="keywordtype">void</span> <a class="code" href="classExactErrorEstimator.php#a32caefcffa2c417b9e14f05779c396b8">attach_exact_hessian</a> ( <a class="code" href="classTensorValue.php">Tensor</a> fptr(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00111"></a>00111                                           <span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; parameters,
<a name="l00112"></a>00112                                           <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00113"></a>00113                                           <span class="keyword">const</span> std::string&amp; unknown_name));
<a name="l00114"></a>00114 
<a name="l00120"></a>00120   <span class="keywordtype">void</span> <a class="code" href="classExactErrorEstimator.php#a24e494960f1e823f40d00639bf81896c">attach_reference_solution</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>* es_fine);
<a name="l00121"></a>00121   
<a name="l00122"></a>00122 
<a name="l00127"></a><a class="code" href="classExactErrorEstimator.php#ad9a4a02c57bc153426b3d63a130d0a19">00127</a>   <span class="keywordtype">void</span> <a class="code" href="classExactErrorEstimator.php#ad9a4a02c57bc153426b3d63a130d0a19">extra_quadrature_order</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> extraorder)
<a name="l00128"></a>00128     { <a class="code" href="classExactErrorEstimator.php#a413963f66ca87164f69d3f532c8be410">_extra_order</a> = extraorder; }
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 
<a name="l00131"></a>00131   <span class="comment">// Bring the base class functionality into the name lookup</span>
<a name="l00132"></a>00132   <span class="comment">// procedure.  This allows for alternative calling formats</span>
<a name="l00133"></a>00133   <span class="comment">// defined in the base class.  Thanks Wolfgang.</span>
<a name="l00134"></a>00134   <span class="comment">// GCC 2.95.3 cannot compile such code.  Since it was not really</span>
<a name="l00135"></a>00135   <span class="comment">// essential to the functioning of this class, it&#39;s been removed.</span>
<a name="l00136"></a>00136   <span class="comment">// using ErrorEstimator::estimate_error;</span>
<a name="l00137"></a>00137 
<a name="l00144"></a>00144   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classExactErrorEstimator.php#a7c187e02f2557081fa852c7de18a468c">estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; system,
<a name="l00145"></a>00145                                <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00146"></a>00146                                <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector = NULL,
<a name="l00147"></a>00147                                <span class="keywordtype">bool</span> estimate_parent_error = <span class="keyword">false</span>);
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 <span class="keyword">private</span>:
<a name="l00150"></a>00150 
<a name="l00155"></a><a class="code" href="classExactErrorEstimator.php#a23103779753cca554de3816385ee43ea">00155</a>   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> (* <a class="code" href="classExactErrorEstimator.php#a23103779753cca554de3816385ee43ea">_exact_value</a>) (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00156"></a>00156                            <span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; parameters,
<a name="l00157"></a>00157                            <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00158"></a>00158                            <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00159"></a>00159 
<a name="l00164"></a><a class="code" href="classExactErrorEstimator.php#af277dc01661de2824d27895efe424d0c">00164</a>   <a class="code" href="exact__error__estimator_8h.php#aff779e61aca326de0c3649ec86a15866">Gradient</a> (* <a class="code" href="classExactErrorEstimator.php#af277dc01661de2824d27895efe424d0c">_exact_deriv</a>) (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00165"></a>00165                              <span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; parameters,
<a name="l00166"></a>00166                              <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00167"></a>00167                              <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00168"></a>00168 
<a name="l00173"></a><a class="code" href="classExactErrorEstimator.php#a04184fa52c05e36febe6e2d68e82a8f8">00173</a>   <a class="code" href="exact__error__estimator_8h.php#a58d868eeb8275e1659eb7680a618f0d7">Tensor</a> (* <a class="code" href="classExactErrorEstimator.php#a04184fa52c05e36febe6e2d68e82a8f8">_exact_hessian</a>) (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00174"></a>00174                              <span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; parameters,
<a name="l00175"></a>00175                              <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00176"></a>00176                              <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00177"></a>00177 
<a name="l00182"></a><a class="code" href="classExactErrorEstimator.php#ad3c314550179f33ed25d7f6d16ceaad3">00182</a>   <a class="code" href="classEquationSystems.php">EquationSystems</a>* <a class="code" href="classExactErrorEstimator.php#ad3c314550179f33ed25d7f6d16ceaad3">_equation_systems_fine</a>;
<a name="l00183"></a>00183 
<a name="l00187"></a>00187   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classExactErrorEstimator.php#ac0fb2ffeae1a3458d3c69bd13dcef804">find_squared_element_error</a> (<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; system,
<a name="l00188"></a>00188                                    <span class="keyword">const</span> std::string&amp; var_name,
<a name="l00189"></a>00189                                    <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *elem,
<a name="l00190"></a>00190                                    <span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a> &amp;Uelem,
<a name="l00191"></a>00191                                    <a class="code" href="classFEBase.php">FEBase</a> *fe,
<a name="l00192"></a>00192                                    <a class="code" href="classMeshFunction.php">MeshFunction</a> *fine_values) <span class="keyword">const</span>;
<a name="l00193"></a>00193 
<a name="l00197"></a><a class="code" href="classExactErrorEstimator.php#a413963f66ca87164f69d3f532c8be410">00197</a>   <span class="keywordtype">int</span> <a class="code" href="classExactErrorEstimator.php#a413963f66ca87164f69d3f532c8be410">_extra_order</a>;
<a name="l00198"></a>00198 };
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 <span class="preprocessor">#endif</span>
<a name="l00202"></a>00202 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
