<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>exact_solution.h</h1>  </div>
</div>
<div class="contents">
<a href="exact__solution_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: exact_solution.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __exact_solution_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __exact_solution_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// C++ includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span> <span class="comment">// for Number</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;enum_norm_type.h&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Forward Declarations</span>
<a name="l00034"></a>00034 <span class="keyword">class </span><a class="code" href="classPoint.php">Point</a>;
<a name="l00035"></a>00035 <span class="keyword">class </span><a class="code" href="classEquationSystems.php">EquationSystems</a>;
<a name="l00036"></a>00036 <span class="keyword">class </span><a class="code" href="classParameters.php">Parameters</a>;
<a name="l00037"></a>00037 <span class="keyword">class </span><a class="code" href="classMesh.php">Mesh</a>;
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">// Is there any way to simplify this?</span>
<a name="l00040"></a>00040 <span class="comment">// All we need are Tensor and Gradient. - RHS</span>
<a name="l00041"></a>00041 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classTensorValue.php">TensorValue</a>;
<a name="l00042"></a><a class="code" href="exact__solution_8h.php#a2b366093afa6b61a59776dfa7e77de92">00042</a> <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classVectorValue.php">VectorValue</a>;
<a name="l00043"></a>00043 <span class="keyword">typedef</span> <a class="code" href="classTensorValue.php">TensorValue&lt;Number&gt;</a> <a class="code" href="exact__error__estimator_8h.php#a2b366093afa6b61a59776dfa7e77de92">NumberTensorValue</a>;
<a name="l00044"></a><a class="code" href="exact__solution_8h.php#a58d868eeb8275e1659eb7680a618f0d7">00044</a> <span class="keyword">typedef</span> <a class="code" href="classTensorValue.php">NumberTensorValue</a>   <a class="code" href="exact__error__estimator_8h.php#a58d868eeb8275e1659eb7680a618f0d7">Tensor</a>;
<a name="l00045"></a><a class="code" href="exact__solution_8h.php#a08d743aadc7b1860846e8aa6dfa7ae41">00045</a> <span class="keyword">typedef</span> <a class="code" href="classVectorValue.php">VectorValue&lt;Number&gt;</a> <a class="code" href="exact__error__estimator_8h.php#a08d743aadc7b1860846e8aa6dfa7ae41">NumberVectorValue</a>;
<a name="l00046"></a><a class="code" href="exact__solution_8h.php#aff779e61aca326de0c3649ec86a15866">00046</a> <span class="keyword">typedef</span> <a class="code" href="classVectorValue.php">NumberVectorValue</a>   <a class="code" href="exact__error__estimator_8h.php#aff779e61aca326de0c3649ec86a15866">Gradient</a>;
<a name="l00047"></a>00047 
<a name="l00062"></a><a class="code" href="classExactSolution.php">00062</a> <span class="keyword">class </span><a class="code" href="classExactSolution.php">ExactSolution</a>
<a name="l00063"></a>00063 {
<a name="l00064"></a>00064   
<a name="l00065"></a>00065 <span class="keyword">public</span>:
<a name="l00071"></a>00071   <a class="code" href="classExactSolution.php#a33ce4c5c82af2f98688a6d5a0e6f320e">ExactSolution</a> (<span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es);
<a name="l00072"></a>00072 
<a name="l00076"></a><a class="code" href="classExactSolution.php#ae14c2eb4ae399b01be2c4808923aec58">00076</a>   <a class="code" href="classExactSolution.php#ae14c2eb4ae399b01be2c4808923aec58">~ExactSolution</a>() {}
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   
<a name="l00084"></a>00084   <span class="keywordtype">void</span> <a class="code" href="classExactSolution.php#ac431a497960daef4da43bae9c1c88dda">attach_reference_solution</a> (<span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>* es_fine);
<a name="l00085"></a>00085 
<a name="l00092"></a>00092   <span class="keywordtype">void</span> <a class="code" href="classExactSolution.php#adf85a62f95cf446dc568c2540142e424">attach_exact_value</a> ( <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> fptr(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00093"></a>00093                                         <span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; <a class="code" href="classParameters.php">Parameters</a>,
<a name="l00094"></a>00094                                         <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00095"></a>00095                                         <span class="keyword">const</span> std::string&amp; unknown_name));
<a name="l00096"></a>00096 
<a name="l00103"></a>00103   <span class="keywordtype">void</span> <a class="code" href="classExactSolution.php#aa264668d620b66f15c383ef54fd59161">attach_exact_deriv</a> ( <a class="code" href="classVectorValue.php">Gradient</a> fptr(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00104"></a>00104                                           <span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; parameters,
<a name="l00105"></a>00105                                           <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00106"></a>00106                                           <span class="keyword">const</span> std::string&amp; unknown_name));
<a name="l00107"></a>00107 
<a name="l00114"></a>00114   <span class="keywordtype">void</span> <a class="code" href="classExactSolution.php#ad661abe959cdab65f6126683ac986c89">attach_exact_hessian</a> ( <a class="code" href="classTensorValue.php">Tensor</a> fptr(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00115"></a>00115                                           <span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; parameters,
<a name="l00116"></a>00116                                           <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00117"></a>00117                                           <span class="keyword">const</span> std::string&amp; unknown_name));
<a name="l00118"></a>00118 
<a name="l00123"></a><a class="code" href="classExactSolution.php#a9805e8b884259d1c0da5c2d659e36c53">00123</a>   <span class="keywordtype">void</span> <a class="code" href="classExactSolution.php#a9805e8b884259d1c0da5c2d659e36c53">extra_quadrature_order</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> extraorder)
<a name="l00124"></a>00124     { <a class="code" href="classExactSolution.php#a67458eda2c1302a55c82912646f8c77c">_extra_order</a> = extraorder; }
<a name="l00125"></a>00125 
<a name="l00133"></a>00133   <span class="keywordtype">void</span> <a class="code" href="classExactSolution.php#a6bd67d0b3e33011b0e1664bbcb994573">compute_error</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00134"></a>00134                      <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00135"></a>00135   
<a name="l00141"></a>00141   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classExactSolution.php#a1882fe22e0e826bdee9d7ba39582fe40">l2_error</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00142"></a>00142                 <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00143"></a>00143   
<a name="l00149"></a>00149   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classExactSolution.php#a6973baa054415ecc5432557f365c236f">l1_error</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00150"></a>00150                 <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00151"></a>00151   
<a name="l00161"></a>00161   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classExactSolution.php#ab5697fe68192a270d34c5abd718954d4">l_inf_error</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00162"></a>00162                    <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00163"></a>00163   
<a name="l00169"></a>00169   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classExactSolution.php#a00267e789b9f0c4083edeb89be2f267c">h1_error</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00170"></a>00170                 <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00171"></a>00171   
<a name="l00177"></a>00177   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classExactSolution.php#aaf29082d8d9bc0a335f0d535e5fdf864">h2_error</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00178"></a>00178                 <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00179"></a>00179   
<a name="l00187"></a>00187   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classExactSolution.php#a7c8b48eaf9f8a3e0745991a92f1a7fef">error_norm</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00188"></a>00188                   <span class="keyword">const</span> std::string&amp; unknown_name,
<a name="l00189"></a>00189                   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a>&amp; norm);
<a name="l00190"></a>00190 <span class="keyword">private</span>:
<a name="l00191"></a>00191   
<a name="l00198"></a>00198   <span class="keywordtype">void</span> <a class="code" href="classExactSolution.php#aacf138b286bc1f1b815a9b2b7047b80f">_compute_error</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00199"></a>00199                       <span class="keyword">const</span> std::string&amp; unknown_name,
<a name="l00200"></a>00200                       std::vector&lt;Real&gt;&amp; error_vals);
<a name="l00201"></a>00201 
<a name="l00207"></a>00207   std::vector&lt;Real&gt;&amp; <a class="code" href="classExactSolution.php#aefa13b5831827d5999f0b49e41691f19">_check_inputs</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00208"></a>00208                                    <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00209"></a>00209   
<a name="l00214"></a><a class="code" href="classExactSolution.php#a8d969e09ba29f1f4268b6746aa6305cb">00214</a>   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> (* <a class="code" href="classExactSolution.php#a8d969e09ba29f1f4268b6746aa6305cb">_exact_value</a>) (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00215"></a>00215                            <span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; parameters,
<a name="l00216"></a>00216                            <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00217"></a>00217                            <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00218"></a>00218 
<a name="l00223"></a><a class="code" href="classExactSolution.php#acdf4955d43fca9a9db6d5a70022aa8bb">00223</a>   <a class="code" href="exact__error__estimator_8h.php#aff779e61aca326de0c3649ec86a15866">Gradient</a> (* <a class="code" href="classExactSolution.php#acdf4955d43fca9a9db6d5a70022aa8bb">_exact_deriv</a>) (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00224"></a>00224                              <span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; parameters,
<a name="l00225"></a>00225                              <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00226"></a>00226                              <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00227"></a>00227 
<a name="l00232"></a><a class="code" href="classExactSolution.php#ab259b11c2df99abe673c40e39ff9e551">00232</a>   <a class="code" href="exact__error__estimator_8h.php#a58d868eeb8275e1659eb7680a618f0d7">Tensor</a> (* <a class="code" href="classExactSolution.php#ab259b11c2df99abe673c40e39ff9e551">_exact_hessian</a>) (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00233"></a>00233                              <span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; parameters,
<a name="l00234"></a>00234                              <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00235"></a>00235                              <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00236"></a>00236 
<a name="l00245"></a><a class="code" href="classExactSolution.php#aab76f3a2a8afc395844a4abb65928e25">00245</a>   <span class="keyword">typedef</span> std::map&lt;std::string, std::vector&lt;Real&gt; &gt; <a class="code" href="classExactSolution.php#aab76f3a2a8afc395844a4abb65928e25">SystemErrorMap</a>;
<a name="l00246"></a>00246 
<a name="l00253"></a><a class="code" href="classExactSolution.php#ab3ee5159232d75c2d04a47eb9ea5dcf8">00253</a>   std::map&lt;std::string, SystemErrorMap&gt; <a class="code" href="classExactSolution.php#ab3ee5159232d75c2d04a47eb9ea5dcf8">_errors</a>;
<a name="l00254"></a>00254   
<a name="l00259"></a><a class="code" href="classExactSolution.php#a3bd76bf4b11236d2ea00630f53bf212e">00259</a>   <span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; <a class="code" href="classExactSolution.php#a3bd76bf4b11236d2ea00630f53bf212e">_equation_systems</a>;
<a name="l00260"></a>00260 
<a name="l00265"></a><a class="code" href="classExactSolution.php#a22fa48648f1adb22d566911f460b07af">00265</a>   <span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>* <a class="code" href="classExactSolution.php#a22fa48648f1adb22d566911f460b07af">_equation_systems_fine</a>;
<a name="l00266"></a>00266 
<a name="l00270"></a><a class="code" href="classExactSolution.php#a67458eda2c1302a55c82912646f8c77c">00270</a>   <span class="keywordtype">int</span> <a class="code" href="classExactSolution.php#a67458eda2c1302a55c82912646f8c77c">_extra_order</a>;
<a name="l00271"></a>00271 };
<a name="l00272"></a>00272 
<a name="l00273"></a>00273 
<a name="l00274"></a>00274 
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
