<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>exodusII_io.C</h1>  </div>
</div>
<div class="contents">
<a href="exodusII__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: exodusII_io.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;cstring&gt;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;exodusII_io.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;boundary_info.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;enum_elem_type.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;system.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;exodusII_io_helper.h&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00040"></a>00040 <span class="comment">// ExodusII_IO class members</span>
<a name="l00041"></a><a class="code" href="classExodusII__IO.php#af6a9a480b03f9daae86f4ea9668e5cc9">00041</a> <a class="code" href="classExodusII__IO.php#af6a9a480b03f9daae86f4ea9668e5cc9">ExodusII_IO::ExodusII_IO</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh) :
<a name="l00042"></a>00042   <a class="code" href="classMeshInput.php">MeshInput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt; (mesh),
<a name="l00043"></a>00043   <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt; (mesh),
<a name="l00044"></a>00044   _timestep(1),
<a name="l00045"></a>00045   _verbose (false)
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047 }
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a><a class="code" href="classExodusII__IO.php#a745c4cee07f43d57b7d53a9cdfe281cb">00051</a> <a class="code" href="classExodusII__IO.php#a745c4cee07f43d57b7d53a9cdfe281cb">ExodusII_IO::~ExodusII_IO</a> ()
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053 <span class="preprocessor">#ifndef LIBMESH_HAVE_EXODUS_API</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span>
<a name="l00055"></a>00055   std::cerr &lt;&lt;  <span class="stringliteral">&quot;ERROR, ExodusII API is not defined.\n&quot;</span>
<a name="l00056"></a>00056             &lt;&lt; std::endl;
<a name="l00057"></a>00057   libmesh_error();
<a name="l00058"></a>00058     
<a name="l00059"></a>00059 <span class="preprocessor">#else</span>
<a name="l00060"></a>00060 <span class="preprocessor"></span>  
<a name="l00061"></a>00061   <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00062"></a>00062     <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a462c7ef49bde1edaead57b7f7e932901">close</a>();
<a name="l00063"></a>00063   
<a name="l00064"></a>00064 <span class="preprocessor">#endif</span>
<a name="l00065"></a>00065 <span class="preprocessor"></span>}
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00069"></a><a class="code" href="classExodusII__IO.php#a7be8ae4b6f1bfbdbd91d94a93d2d848d">00069</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO.php#a7be8ae4b6f1bfbdbd91d94a93d2d848d">ExodusII_IO::verbose</a> (<span class="keywordtype">bool</span> set_verbosity)
<a name="l00070"></a>00070 {
<a name="l00071"></a>00071   <a class="code" href="classExodusII__IO.php#a398a71df49bee40403d08e05955d8a46">_verbose</a> = set_verbosity;
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 <span class="preprocessor">#ifdef LIBMESH_HAVE_EXODUS_API</span>
<a name="l00074"></a>00074 <span class="preprocessor"></span>  <span class="comment">// Set the verbose flag in the helper object</span>
<a name="l00075"></a>00075   <span class="comment">// as well.</span>
<a name="l00076"></a>00076   <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a90ab6ea1557ee6785027f28eee726836">verbose</a>(<a class="code" href="classExodusII__IO.php#a398a71df49bee40403d08e05955d8a46">_verbose</a>);
<a name="l00077"></a>00077 <span class="preprocessor">#endif</span>
<a name="l00078"></a>00078 <span class="preprocessor"></span>}
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a><a class="code" href="classExodusII__IO.php#a71cded634eaffef4c0f2441ef65d5860">00082</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO.php#a71cded634eaffef4c0f2441ef65d5860">ExodusII_IO::read</a> (<span class="keyword">const</span> std::string&amp; fname)
<a name="l00083"></a>00083 {
<a name="l00084"></a>00084   <span class="comment">// This is a serial-only process for now;</span>
<a name="l00085"></a>00085   <span class="comment">// the Mesh should be read on processor 0 and</span>
<a name="l00086"></a>00086   <span class="comment">// broadcast later</span>
<a name="l00087"></a>00087 <span class="comment">//  libmesh_assert(libMesh::processor_id() == 0);</span>
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 <span class="preprocessor">#ifndef LIBMESH_HAVE_EXODUS_API</span>
<a name="l00090"></a>00090 <span class="preprocessor"></span>
<a name="l00091"></a>00091   std::cerr &lt;&lt;  <span class="stringliteral">&quot;ERROR, ExodusII API is not defined.\n&quot;</span>
<a name="l00092"></a>00092             &lt;&lt; <span class="stringliteral">&quot;Input file &quot;</span> &lt;&lt; fname &lt;&lt; <span class="stringliteral">&quot; cannot be read&quot;</span>
<a name="l00093"></a>00093             &lt;&lt; std::endl;
<a name="l00094"></a>00094   libmesh_error();
<a name="l00095"></a>00095     
<a name="l00096"></a>00096 <span class="preprocessor">#else</span>
<a name="l00097"></a>00097 <span class="preprocessor"></span>  
<a name="l00098"></a>00098   <span class="comment">// Get a reference to the mesh we are reading</span>
<a name="l00099"></a>00099   <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00100"></a>00100   
<a name="l00101"></a>00101   <span class="comment">// Clear any existing mesh data</span>
<a name="l00102"></a>00102   mesh.<a class="code" href="classMeshBase.php#aefd56c4c29285d5e845f8869112b2b67">clear</a>();
<a name="l00103"></a>00103   
<a name="l00104"></a>00104   <span class="keywordflow">if</span> (mesh.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>() == 1) <span class="comment">// No support for 1D ExodusII meshes</span>
<a name="l00105"></a>00105     libmesh_not_implemented();
<a name="l00106"></a>00106   
<a name="l00107"></a>00107 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00108"></a>00108 <span class="preprocessor"></span>  this-&gt;<a class="code" href="classExodusII__IO.php#a7be8ae4b6f1bfbdbd91d94a93d2d848d">verbose</a>(<span class="keyword">true</span>);
<a name="l00109"></a>00109 <span class="preprocessor">#endif</span>
<a name="l00110"></a>00110 <span class="preprocessor"></span>
<a name="l00111"></a>00111   
<a name="l00112"></a>00112   <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php">ExodusII_IO_Helper::ElementMaps</a> em;     <span class="comment">// Instantiate the ElementMaps interface</span>
<a name="l00113"></a>00113     
<a name="l00114"></a>00114   <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#af979d5fd7cffa411bdd0a16b3a3011ee">open</a>(fname.c_str());       <span class="comment">// Open the exodus file, if possible</span>
<a name="l00115"></a>00115   <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a3e2c4651800daaa7c199c63c4e49f161">read_header</a>();             <span class="comment">// Get header information from exodus file</span>
<a name="l00116"></a>00116   <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a814335b8f7e05a408917b3d422078e61">print_header</a>();            <span class="comment">// Print header information</span>
<a name="l00117"></a>00117 
<a name="l00118"></a>00118   <span class="comment">//assertion fails due to inconsistent mesh dimension</span>
<a name="l00119"></a>00119 <span class="comment">//  libmesh_assert(static_cast&lt;unsigned int&gt;(exio_helper.get_num_dim()) == mesh.mesh_dimension()); // Be sure number of dimensions</span>
<a name="l00120"></a>00120                                                                                 <span class="comment">// is equal to the number of </span>
<a name="l00121"></a>00121                                                                                 <span class="comment">// dimensions in the mesh supplied.</span>
<a name="l00122"></a>00122   
<a name="l00123"></a>00123   <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a0ae664b1cc9421fff23daeff6049b591">read_nodes</a>();                        <span class="comment">// Read nodes from the exodus file</span>
<a name="l00124"></a>00124   mesh.<a class="code" href="classMeshBase.php#a641a3da2df67396c48c9a9b2434b4d68">reserve_nodes</a>(<a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a5591987a38e4e478474f0ed50169de42">get_num_nodes</a>()); <span class="comment">// Reserve space for the nodes.</span>
<a name="l00125"></a>00125   
<a name="l00126"></a>00126   <span class="comment">// Loop over the nodes, create Nodes with local processor_id 0.</span>
<a name="l00127"></a>00127   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a5591987a38e4e478474f0ed50169de42">get_num_nodes</a>(); i++)
<a name="l00128"></a>00128     mesh.<a class="code" href="classMeshBase.php#a01b66468d3e9d8b5db82c6f3d9131f5e">add_point</a> (<a class="code" href="classPoint.php">Point</a>(<a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a97e4c1e13108b9037ac2219e24e4db98">get_x</a>(i),
<a name="l00129"></a>00129                           <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a0a4b8030d945f767cf334944c394165b">get_y</a>(i),
<a name="l00130"></a>00130                           <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#ac028f19361d92aa4f69a34b1ad7144d8">get_z</a>(i)), i);
<a name="l00131"></a>00131   
<a name="l00132"></a>00132   libmesh_assert (static_cast&lt;unsigned int&gt;(<a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a5591987a38e4e478474f0ed50169de42">get_num_nodes</a>()) == mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#aac7883fbd864085b82ef0305205037b5">read_block_info</a>();                 <span class="comment">// Get information about all the blocks</span>
<a name="l00135"></a>00135   mesh.<a class="code" href="classMeshBase.php#ae034eb4ecaa04c32b89909d9eee85411">reserve_elem</a>(<a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a961c0dc9cc1b7d2eccdb5b1f24e27a97">get_num_elem</a>()); <span class="comment">// Reserve space for the elements</span>
<a name="l00136"></a>00136    
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <span class="comment">// Read in the element connectivity for each block.</span>
<a name="l00139"></a>00139   <span class="keywordtype">int</span> nelem_last_block = 0;
<a name="l00140"></a>00140 
<a name="l00141"></a>00141   std::map&lt;int, unsigned int&gt; exodus_id_to_mesh_id;
<a name="l00142"></a>00142 
<a name="l00143"></a>00143   <span class="comment">// Loop over all the blocks</span>
<a name="l00144"></a>00144   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#acd40cd9f9ad82b932fd2b691845c5778">get_num_elem_blk</a>(); i++)
<a name="l00145"></a>00145     {
<a name="l00146"></a>00146       <span class="comment">// Read the information for block i</span>
<a name="l00147"></a>00147       <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#af2bf9e3fea0115a5e5da62074fca5968">read_elem_in_block</a> (i);
<a name="l00148"></a>00148       <span class="keywordtype">int</span> subdomain_id = <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#accf630acdb0aab66a0cd6daf3973b59d">get_block_id</a>(i);
<a name="l00149"></a>00149 
<a name="l00150"></a>00150       <span class="comment">// Set any relevant node/edge maps for this element</span>
<a name="l00151"></a>00151       <span class="keyword">const</span> std::string type_str (<a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a1be93484618b94756d2554a492ec79dd">get_elem_type</a>());
<a name="l00152"></a>00152       <span class="keyword">const</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">ExodusII_IO_Helper::Conversion</a> conv = em.<a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a572ac41c49e11af4a560e4a731186590">assign_conversion</a>(type_str); 
<a name="l00153"></a>00153       <span class="comment">//if (_verbose)</span>
<a name="l00154"></a>00154       <span class="comment">//std::cout &lt;&lt; &quot;Reading a block of &quot; &lt;&lt; type_str &lt;&lt; &quot; elements.&quot; &lt;&lt; std::endl;</span>
<a name="l00155"></a>00155       
<a name="l00156"></a>00156       <span class="comment">// Loop over all the faces in this block</span>
<a name="l00157"></a>00157       <span class="keywordtype">int</span> jmax = nelem_last_block+<a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a8dc14619b9c4381b9a8dacac29c68558">get_num_elem_this_blk</a>();
<a name="l00158"></a>00158       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=nelem_last_block; j&lt;jmax; j++)
<a name="l00159"></a>00159         {
<a name="l00160"></a>00160           <a class="code" href="classElem.php">Elem</a>* elem = <a class="code" href="classElem.php#a7f46524fbd44a76f940435d6a1434a9d">Elem::build</a> (conv.get_canonical_type()).release();
<a name="l00161"></a>00161           libmesh_assert (elem);
<a name="l00162"></a>00162           elem-&gt;<a class="code" href="classElem.php#acc4746605aad9169ad38cfd0b9b97123">subdomain_id</a>() = <span class="keyword">static_cast&lt;</span><a class="code" href="classTestClass.php">subdomain_id_type</a><span class="keyword">&gt;</span>(subdomain_id) ;
<a name="l00163"></a>00163           <span class="comment">//elem-&gt;set_id(j);// Don&#39;t try to second guess the Element ID setting scheme!</span>
<a name="l00164"></a>00164           elem = mesh.<a class="code" href="classMeshBase.php#a0f6974cf3e413cfe9caa1fcb4ce8153e">add_elem</a> (elem); <span class="comment">// Catch the Elem pointer that the Mesh throws back</span>
<a name="l00165"></a>00165 
<a name="l00166"></a>00166           exodus_id_to_mesh_id[j+1] = elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l00167"></a>00167             
<a name="l00168"></a>00168           <span class="comment">// Set all the nodes for this element</span>
<a name="l00169"></a>00169           <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0; k&lt;<a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a18880e0c3ff0385f14329e2f14b6b24b">get_num_nodes_per_elem</a>(); k++)
<a name="l00170"></a>00170             {
<a name="l00171"></a>00171               <span class="keywordtype">int</span> gi = (j-nelem_last_block)*<a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a18880e0c3ff0385f14329e2f14b6b24b">get_num_nodes_per_elem</a>() + conv.get_node_map(k); <span class="comment">// global index </span>
<a name="l00172"></a>00172               <span class="keywordtype">int</span> node_number   = <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a19bc630eb8a5cbedf035bfd44f03dac6">get_connect</a>(gi);             <span class="comment">// Global node number (1-based)</span>
<a name="l00173"></a>00173               elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(k) = mesh.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>((node_number-1)); <span class="comment">// Set node number</span>
<a name="l00174"></a>00174                                                                   <span class="comment">// Subtract 1 since</span>
<a name="l00175"></a>00175                                                                   <span class="comment">// exodus is internally 1-based</span>
<a name="l00176"></a>00176             }
<a name="l00177"></a>00177         }
<a name="l00178"></a>00178       
<a name="l00179"></a>00179       <span class="comment">// running sum of # of elements per block,</span>
<a name="l00180"></a>00180       <span class="comment">// (should equal total number of elements in the end)</span>
<a name="l00181"></a>00181       nelem_last_block += <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a8dc14619b9c4381b9a8dacac29c68558">get_num_elem_this_blk</a>();
<a name="l00182"></a>00182     }
<a name="l00183"></a>00183   libmesh_assert (static_cast&lt;unsigned int&gt;(nelem_last_block) == mesh.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>());
<a name="l00184"></a>00184 
<a name="l00185"></a>00185   <span class="comment">// Read in sideset information -- this is useful for applying boundary conditions</span>
<a name="l00186"></a>00186   {
<a name="l00187"></a>00187     <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a55da723215f331f1cda00391f057dd5e">read_sideset_info</a>(); <span class="comment">// Get basic information about ALL sidesets</span>
<a name="l00188"></a>00188     <span class="keywordtype">int</span> offset=0;
<a name="l00189"></a>00189     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a4eea4e8654ab2d2dfc55ae00e392c7b7">get_num_side_sets</a>(); i++)
<a name="l00190"></a>00190       {
<a name="l00191"></a>00191         offset += (i &gt; 0 ? <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a9b94c7908a54cb1d3a072e16d0c1443c">get_num_sides_per_set</a>(i-1) : 0); <span class="comment">// Compute new offset</span>
<a name="l00192"></a>00192         <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a81a6fca6d1b75d688d3430b42ac23b5e">read_sideset</a> (i, offset);
<a name="l00193"></a>00193       }
<a name="l00194"></a>00194     
<a name="l00195"></a>00195     <span class="keyword">const</span> std::vector&lt;int&gt;&amp; elem_list = <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#af50336b6ea80997d5a26969737f87437">get_elem_list</a>();
<a name="l00196"></a>00196     <span class="keyword">const</span> std::vector&lt;int&gt;&amp; side_list = <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a4714f663fb266b4e005c078d1529182b">get_side_list</a>();
<a name="l00197"></a>00197     <span class="keyword">const</span> std::vector&lt;int&gt;&amp; id_list   = <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#abbd58a166cbfb6b0ca6e2db154a72b42">get_id_list</a>();
<a name="l00198"></a>00198 
<a name="l00199"></a>00199     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;elem_list.size(); e++)
<a name="l00200"></a>00200       {
<a name="l00201"></a>00201         <span class="comment">// Set any relevant node/edge maps for this element</span>
<a name="l00202"></a>00202 
<a name="l00203"></a>00203         <a class="code" href="classElem.php">Elem</a> * elem = mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(exodus_id_to_mesh_id[elem_list[e]]);
<a name="l00204"></a>00204         
<a name="l00205"></a>00205         <span class="keyword">const</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">ExodusII_IO_Helper::Conversion</a> conv =
<a name="l00206"></a>00206           em.<a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a572ac41c49e11af4a560e4a731186590">assign_conversion</a>(elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>());
<a name="l00207"></a>00207         
<a name="l00208"></a>00208         mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;add_side (exodus_id_to_mesh_id[elem_list[e]],
<a name="l00209"></a>00209                                       conv.<a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#a14a7e9d21c19ddb9362dd13abb7da4ab">get_side_map</a>(side_list[e]-1),
<a name="l00210"></a>00210                                       id_list[e]);
<a name="l00211"></a>00211       }
<a name="l00212"></a>00212   }
<a name="l00213"></a>00213 
<a name="l00214"></a>00214   <span class="comment">// Read nodeset info</span>
<a name="l00215"></a>00215   {
<a name="l00216"></a>00216     <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#ae9c3256ae51c60ff819bf08b2570159a">read_nodeset_info</a>();
<a name="l00217"></a>00217 
<a name="l00218"></a>00218     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> nodeset=0; nodeset&lt;<a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#aa68cb4e747d7943cf7edad365eafd493">get_num_node_sets</a>(); nodeset++)
<a name="l00219"></a>00219       {
<a name="l00220"></a>00220         <span class="keywordtype">int</span> nodeset_id = <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#abf15f4b4c33857f884dd7c679e8d2d78">get_nodeset_id</a>(nodeset);
<a name="l00221"></a>00221         
<a name="l00222"></a>00222         <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a914c2e29f12d8118cb2bbe7e02817a6a">read_nodeset</a>(nodeset);
<a name="l00223"></a>00223 
<a name="l00224"></a>00224         <span class="keyword">const</span> std::vector&lt;int&gt;&amp; node_list = <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a2b0cad9fd62d701c8d2c0a98dad05dbd">get_node_list</a>();
<a name="l00225"></a>00225 
<a name="l00226"></a>00226         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node=0; node&lt;node_list.size(); node++)
<a name="l00227"></a>00227           mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;add_node(node_list[node], nodeset_id);
<a name="l00228"></a>00228       }
<a name="l00229"></a>00229   }
<a name="l00230"></a>00230       
<a name="l00231"></a>00231 <span class="preprocessor">#endif</span>
<a name="l00232"></a>00232 <span class="preprocessor"></span>}
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 <span class="preprocessor">#ifndef LIBMESH_HAVE_EXODUS_API</span>
<a name="l00237"></a>00237 <span class="preprocessor"></span>
<a name="l00238"></a><a class="code" href="classExodusII__IO.php#a55892412989599880fb49c6cf2440493">00238</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO.php#a55892412989599880fb49c6cf2440493">ExodusII_IO::copy_nodal_solution</a>(<a class="code" href="classSystem.php">System</a>&amp; , std::string, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)
<a name="l00239"></a>00239 {
<a name="l00240"></a>00240 
<a name="l00241"></a>00241   std::cerr &lt;&lt;  <span class="stringliteral">&quot;ERROR, ExodusII API is not defined.\n&quot;</span>
<a name="l00242"></a>00242             &lt;&lt; std::endl;
<a name="l00243"></a>00243   libmesh_error();
<a name="l00244"></a>00244 }
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 <span class="preprocessor">#else</span>
<a name="l00247"></a>00247 <span class="preprocessor"></span>
<a name="l00248"></a>00248 <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO.php#a55892412989599880fb49c6cf2440493">ExodusII_IO::copy_nodal_solution</a>(<a class="code" href="classSystem.php">System</a>&amp; system, std::string nodal_var_name, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> timestep)
<a name="l00249"></a>00249 {
<a name="l00250"></a>00250   <span class="comment">// FIXME: Do we need to call get_time_steps() at all?</span>
<a name="l00251"></a>00251   <span class="comment">/*const std::vector&lt;double&gt;&amp; time_steps = */</span>
<a name="l00252"></a>00252   <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#abf39efd05686e6303298f7268eb979c1">get_time_steps</a>();
<a name="l00253"></a>00253 
<a name="l00254"></a>00254   <span class="keyword">const</span> std::vector&lt;double&gt; &amp; nodal_values = <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#ad35b6ec1c430b200cb69331455c3f252">get_nodal_var_values</a>(nodal_var_name,timestep);
<a name="l00255"></a>00255 
<a name="l00256"></a>00256   <span class="comment">//const DofMap &amp; dof_map = system.get_dof_map();</span>
<a name="l00257"></a>00257 
<a name="l00258"></a>00258   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var_num = system.<a class="code" href="classSystem.php#ace6000ea1d0dc7e3635fe98761f95838">variable_number</a>(nodal_var_name);
<a name="l00259"></a>00259 
<a name="l00260"></a>00260   
<a name="l00261"></a>00261   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nodal_values.size(); ++i)
<a name="l00262"></a>00262     {
<a name="l00263"></a>00263       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dof_index = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshInput&lt;MeshBase&gt;::mesh</a>().<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(i)-&gt;<a class="code" href="classDofObject.php#a7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(system.<a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">number</a>(),var_num,0);
<a name="l00264"></a>00264 
<a name="l00265"></a>00265       <span class="comment">// If the dof_index is local to this processor, set the value</span>
<a name="l00266"></a>00266       <span class="keywordflow">if</span> ((dof_index &gt;= system.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;first_local_index()) &amp;&amp; (dof_index &lt;  system.solution-&gt;last_local_index()))
<a name="l00267"></a>00267         system.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;set (dof_index, nodal_values[i]);
<a name="l00268"></a>00268     }
<a name="l00269"></a>00269 
<a name="l00270"></a>00270   system.<a class="code" href="classSystem.php#add4b09ec4fb0679b8623c01218cafa5b">update</a>();
<a name="l00271"></a>00271 }
<a name="l00272"></a>00272   
<a name="l00273"></a>00273 <span class="preprocessor">#endif</span>
<a name="l00274"></a>00274 <span class="preprocessor"></span>
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 <span class="preprocessor">#ifndef LIBMESH_HAVE_EXODUS_API</span>
<a name="l00278"></a>00278 <span class="preprocessor"></span>
<a name="l00279"></a><a class="code" href="classExodusII__IO.php#ac114febf1bd1647ad2a35c11d9cc8f25">00279</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO.php#ac114febf1bd1647ad2a35c11d9cc8f25">ExodusII_IO::write_nodal_data</a> (<span class="keyword">const</span> std::string&amp; ,
<a name="l00280"></a>00280                                     <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; ,
<a name="l00281"></a>00281                                     <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; )
<a name="l00282"></a>00282 {
<a name="l00283"></a>00283 
<a name="l00284"></a>00284   std::cerr &lt;&lt;  <span class="stringliteral">&quot;ERROR, ExodusII API is not defined.\n&quot;</span>
<a name="l00285"></a>00285             &lt;&lt; std::endl;
<a name="l00286"></a>00286   libmesh_error();
<a name="l00287"></a>00287 }
<a name="l00288"></a>00288 
<a name="l00289"></a>00289 <span class="preprocessor">#else</span>
<a name="l00290"></a>00290 <span class="preprocessor"></span>
<a name="l00291"></a>00291 <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO.php#ac114febf1bd1647ad2a35c11d9cc8f25">ExodusII_IO::write_nodal_data</a> (<span class="keyword">const</span> std::string&amp; fname,
<a name="l00292"></a>00292                                     <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; soln,
<a name="l00293"></a>00293                                     <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; names)
<a name="l00294"></a>00294 {
<a name="l00295"></a>00295   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00296"></a>00296     {
<a name="l00297"></a>00297       <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00298"></a>00298 
<a name="l00299"></a>00299       <span class="keywordtype">int</span> num_vars = names.size();
<a name="l00300"></a>00300       <span class="keywordtype">int</span> num_nodes = mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>();
<a name="l00301"></a>00301   
<a name="l00302"></a>00302       <span class="comment">// FIXME: Will we ever _not_ need to do this?</span>
<a name="l00303"></a>00303       <span class="comment">// DRG: Yes... when writing multiple timesteps to the same file.</span>
<a name="l00304"></a>00304       <span class="keywordflow">if</span> (!<a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a5349c806da1104e3470c039140757c4f">created</a>())
<a name="l00305"></a>00305         {
<a name="l00306"></a>00306           <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#af2040df8fd7a0bab0437dbec94f750c6">create</a>(fname);
<a name="l00307"></a>00307           <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a74c2b9572e8fe56e849c4003095b6495">initialize</a>(fname,mesh);
<a name="l00308"></a>00308           <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a3779067e84b6f238b935a0a917871c0e">write_nodal_coordinates</a>(mesh);
<a name="l00309"></a>00309           <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a08434fa54c2aef8dd158630dcdd008f0">write_elements</a>(mesh);
<a name="l00310"></a>00310           <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a62037f5803622a70a0c7e5cf836c971c">write_sidesets</a>(mesh);
<a name="l00311"></a>00311           <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a636d799fce0f1edbdf114bc368c558ac">write_nodesets</a>(mesh);
<a name="l00312"></a>00312           <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#aaa7f63ddf6f23522b56fe72b63167d2f">initialize_nodal_variables</a>(names);
<a name="l00313"></a>00313         }
<a name="l00314"></a>00314     
<a name="l00315"></a>00315       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> c=0; c&lt;num_vars; c++)
<a name="l00316"></a>00316         {
<a name="l00317"></a>00317           std::vector&lt;Number&gt; cur_soln(num_nodes);
<a name="l00318"></a>00318 
<a name="l00319"></a>00319           <span class="comment">//Copy out this variable&#39;s solution</span>
<a name="l00320"></a>00320           <span class="keywordflow">for</span>(<span class="keywordtype">int</span> i=0; i&lt;num_nodes; i++)
<a name="l00321"></a>00321             cur_soln[i] = soln[i*num_vars + c];<span class="comment">//c*num_nodes+i];</span>
<a name="l00322"></a>00322     
<a name="l00323"></a>00323           <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#ab5181082ac9f4d72f1feda8b0a6fcdad">write_nodal_values</a>(c+1,cur_soln,<a class="code" href="classExodusII__IO.php#aaeddf4036f344bf505e47b87ddb5fcf2">_timestep</a>);
<a name="l00324"></a>00324         }  
<a name="l00325"></a>00325     }
<a name="l00326"></a>00326 }
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 <span class="preprocessor">#endif</span>
<a name="l00329"></a>00329 <span class="preprocessor"></span>
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 
<a name="l00332"></a>00332 <span class="preprocessor">#ifndef LIBMESH_HAVE_EXODUS_API</span>
<a name="l00333"></a>00333 <span class="preprocessor"></span>
<a name="l00334"></a><a class="code" href="classExodusII__IO.php#a338a74fccc6053b4d43e02f552e4d091">00334</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO.php#a338a74fccc6053b4d43e02f552e4d091">ExodusII_IO::write_timestep</a> (<span class="keyword">const</span> std::string&amp; ,
<a name="l00335"></a>00335                                   <span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; ,
<a name="l00336"></a>00336                                   <span class="keyword">const</span> <span class="keywordtype">int</span> ,
<a name="l00337"></a>00337                                   <span class="keyword">const</span> <span class="keywordtype">double</span> )
<a name="l00338"></a>00338 {
<a name="l00339"></a>00339 
<a name="l00340"></a>00340   std::cerr &lt;&lt;  <span class="stringliteral">&quot;ERROR, ExodusII API is not defined.\n&quot;</span>
<a name="l00341"></a>00341             &lt;&lt; std::endl;
<a name="l00342"></a>00342   libmesh_error();
<a name="l00343"></a>00343 }
<a name="l00344"></a>00344 
<a name="l00345"></a>00345 <span class="preprocessor">#else</span>
<a name="l00346"></a>00346 <span class="preprocessor"></span>
<a name="l00347"></a>00347 <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO.php#a338a74fccc6053b4d43e02f552e4d091">ExodusII_IO::write_timestep</a> (<span class="keyword">const</span> std::string&amp; fname,
<a name="l00348"></a>00348                                   <span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00349"></a>00349                                   <span class="keyword">const</span> <span class="keywordtype">int</span> timestep,
<a name="l00350"></a>00350                                   <span class="keyword">const</span> <span class="keywordtype">double</span> time)
<a name="l00351"></a>00351 {
<a name="l00352"></a>00352   <a class="code" href="classExodusII__IO.php#aaeddf4036f344bf505e47b87ddb5fcf2">_timestep</a>=timestep; 
<a name="l00353"></a>00353   <a class="code" href="classMeshOutput.php#a5e0df1f5cd00cc7ae3cbe73e6a68fe0e">write_equation_systems</a>(fname,es);
<a name="l00354"></a>00354 
<a name="l00355"></a>00355   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00356"></a>00356     <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a1c32bbd0b8d72eac0809bab8549d9ff7">write_timestep</a>(timestep, time);
<a name="l00357"></a>00357 }
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 <span class="preprocessor">#endif</span>
<a name="l00360"></a>00360 <span class="preprocessor"></span>
<a name="l00361"></a>00361 
<a name="l00362"></a>00362 
<a name="l00363"></a>00363 <span class="preprocessor">#ifndef LIBMESH_HAVE_EXODUS_API</span>
<a name="l00364"></a>00364 <span class="preprocessor"></span>
<a name="l00365"></a><a class="code" href="classExodusII__IO.php#ac2302f2c4760c5f7297208fe51eec14a">00365</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO.php#ac2302f2c4760c5f7297208fe51eec14a">ExodusII_IO::write</a> (<span class="keyword">const</span> std::string&amp; )
<a name="l00366"></a>00366 {
<a name="l00367"></a>00367   std::cerr &lt;&lt;  <span class="stringliteral">&quot;ERROR, ExodusII API is not defined.\n&quot;</span>
<a name="l00368"></a>00368             &lt;&lt; std::endl;
<a name="l00369"></a>00369   libmesh_error();
<a name="l00370"></a>00370 }
<a name="l00371"></a>00371 
<a name="l00372"></a>00372 
<a name="l00373"></a>00373 <span class="preprocessor">#else</span>
<a name="l00374"></a>00374 <span class="preprocessor"></span>
<a name="l00375"></a>00375 <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO.php#ac2302f2c4760c5f7297208fe51eec14a">ExodusII_IO::write</a> (<span class="keyword">const</span> std::string&amp; fname)
<a name="l00376"></a>00376 {
<a name="l00377"></a>00377   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00378"></a>00378     {
<a name="l00379"></a>00379       <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp; mesh = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00380"></a>00380 
<a name="l00381"></a>00381   
<a name="l00382"></a>00382       libmesh_assert( !<a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a5349c806da1104e3470c039140757c4f">created</a>() );
<a name="l00383"></a>00383 
<a name="l00384"></a>00384       <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#af2040df8fd7a0bab0437dbec94f750c6">create</a>(fname);
<a name="l00385"></a>00385       <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a74c2b9572e8fe56e849c4003095b6495">initialize</a>(fname,mesh);
<a name="l00386"></a>00386       <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a3779067e84b6f238b935a0a917871c0e">write_nodal_coordinates</a>(mesh);
<a name="l00387"></a>00387       <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a08434fa54c2aef8dd158630dcdd008f0">write_elements</a>(mesh);
<a name="l00388"></a>00388       <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a62037f5803622a70a0c7e5cf836c971c">write_sidesets</a>(mesh);
<a name="l00389"></a>00389       <a class="code" href="classExodusII__IO.php#a3c60a07fe4616818923ffb3991e5f492">exio_helper</a>.<a class="code" href="classExodusII__IO__Helper.php#a636d799fce0f1edbdf114bc368c558ac">write_nodesets</a>(mesh);
<a name="l00390"></a>00390 
<a name="l00391"></a>00391       <span class="comment">// Note: the file is closed automatically by the ExodusII_IO destructor.</span>
<a name="l00392"></a>00392     }
<a name="l00393"></a>00393 }
<a name="l00394"></a>00394 
<a name="l00395"></a>00395 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
