<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>exodusII_io_helper.C</h1>  </div>
</div>
<div class="contents">
<a href="exodusII__io__helper_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: exodusII_io_helper.C 3462 2009-09-15 17:00:11Z friedmud $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;exodusII_io_helper.h&quot;</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="preprocessor">#ifdef LIBMESH_HAVE_EXODUS_API</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;cstring&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;boundary_info.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;enum_elem_type.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;system.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span><span class="preprocessor">#include &quot;mesh_tools.h&quot;</span>  <span class="comment">// for elem_types warning</span>
<a name="l00036"></a>00036 <span class="preprocessor">#endif</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span>
<a name="l00038"></a>00038 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00039"></a>00039 <span class="comment">// ExodusII_IO_Helper::ElementMaps static data</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">// 2D node map definitions</span>
<a name="l00042"></a>00042 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#aa4cbe1d3a11e6c5e0d8ae26f9e1dd6b3">ExodusII_IO_Helper::ElementMaps::quad4_node_map</a>[4] = {0, 1, 2, 3};
<a name="l00043"></a>00043 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a67133d375c12289b7b5a4e2fea6ae34b">ExodusII_IO_Helper::ElementMaps::quad8_node_map</a>[8] = {0, 1, 2, 3, 4, 5, 6, 7};
<a name="l00044"></a>00044 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a40a3ef6b90a9ce68a5fb2bee16655186">ExodusII_IO_Helper::ElementMaps::quad9_node_map</a>[9] = {0, 1, 2, 3, 4, 5, 6, 7, 8};
<a name="l00045"></a>00045 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a36a35c18b1f25c0434786afa4b76fe3e">ExodusII_IO_Helper::ElementMaps::tri3_node_map</a>[3]  = {0, 1, 2};
<a name="l00046"></a>00046 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a54e545df3df0202d756f4271c2aa3247">ExodusII_IO_Helper::ElementMaps::tri6_node_map</a>[6]  = {0, 1, 2, 3, 4, 5};
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 <span class="comment">// 2D edge map definitions</span>
<a name="l00049"></a>00049 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a733d1fd7a1e39f01d87a6efb7126a07a">ExodusII_IO_Helper::ElementMaps::tri_edge_map</a>[3] = {0, 1, 2};
<a name="l00050"></a>00050 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#ac15c1362094451a0a21c89fb5a75697f">ExodusII_IO_Helper::ElementMaps::quad_edge_map</a>[4] = {0, 1, 2, 3};
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 <span class="comment">//These take a libMesh ID and turn it into an Exodus ID</span>
<a name="l00053"></a>00053 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a219a0c2529b2d4ed2673a5ffb02d821b">ExodusII_IO_Helper::ElementMaps::tri_inverse_edge_map</a>[3] = {1, 2, 3};
<a name="l00054"></a>00054 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#aaf51ca253efe26844d82f9f409b62ba1">ExodusII_IO_Helper::ElementMaps::quad_inverse_edge_map</a>[4] = {1, 2, 3, 4};
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 <span class="comment">// 3D node map definitions</span>
<a name="l00057"></a>00057 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#ab9067833fd1a65acfcd089ba44c0eb57">ExodusII_IO_Helper::ElementMaps::hex8_node_map</a>[8]   = {0, 1, 2, 3, 4, 5, 6, 7};
<a name="l00058"></a>00058 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a3f79cdc1a19bb798755319f188fa6026">ExodusII_IO_Helper::ElementMaps::hex20_node_map</a>[20] = { 0,  1,  2,  3,  4,  5,  6,  7,  8,  9,
<a name="l00059"></a>00059                                                         10, 11, 12, 13, 14, 15, 16, 17, 18, 19};  
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 <span class="comment">// Perhaps an older Hex27 node numbering?  This no longer works.</span>
<a name="l00062"></a>00062 <span class="comment">//const int ExodusII_IO_Helper::ElementMaps::hex27_node_map[27] = { 1,  5,  6,  2,  0,  4,  7,  3, 13, 17, 14,  9,  8, 16,</span>
<a name="l00063"></a>00063 <span class="comment">//                                                        18, 10, 12, 19, 15, 11, 24, 25, 22, 26, 21, 23, 20};</span>
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 <span class="comment">//DRG: Using the newest exodus documentation available on sourceforge and using Table 2 to see</span>
<a name="l00066"></a>00066 <span class="comment">// where all of the nodes over 21 are supposed to go... we come up with:</span>
<a name="l00067"></a>00067 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a2c504b9c83619a98824d17ace1489182">ExodusII_IO_Helper::ElementMaps::hex27_node_map</a>[27] = {
<a name="l00068"></a>00068   <span class="comment">// Vertex and mid-edge nodes</span>
<a name="l00069"></a>00069   0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19,
<a name="l00070"></a>00070   <span class="comment">// Mid-face nodes and centroid</span>
<a name="l00071"></a>00071   21, 25, 24, 26, 23, 22, 20};
<a name="l00072"></a>00072 <span class="comment">//20  21  22  23  24  25  26 // LibMesh indices</span>
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#aefecc7306a608139ea1fda3af32fc985">ExodusII_IO_Helper::ElementMaps::tet4_node_map</a>[4]   = {0, 1, 2, 3};
<a name="l00076"></a>00076 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a62d8436770d6c73b23c38c617dd3344b">ExodusII_IO_Helper::ElementMaps::tet10_node_map</a>[10] = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9};
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a4d0d5459cd76af45d9df7adacb1cee40">ExodusII_IO_Helper::ElementMaps::prism6_node_map</a>[6]   = {0, 1, 2, 3, 4, 5};
<a name="l00079"></a>00079 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#abcfcb88ebc8ba404020469498327bc14">ExodusII_IO_Helper::ElementMaps::prism15_node_map</a>[15]   = {0, 1, 2, 3, 4, 5, 6,  7,  8,  9,
<a name="l00080"></a>00080                                                                      10, 11, 12, 13, 14};
<a name="l00081"></a>00081 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a362c6d282f0957508d2582c5c89ff9e5">ExodusII_IO_Helper::ElementMaps::prism18_node_map</a>[18]   = {0, 1, 2, 3, 4, 5, 6,  7,  8,  9,
<a name="l00082"></a>00082                                                                      10, 11, 12, 13, 14, 15, 16, 17};
<a name="l00083"></a>00083 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#ab44a54133a87456544527428eb538e8f">ExodusII_IO_Helper::ElementMaps::pyramid5_node_map</a>[5] = {0, 1, 2, 3, 4};
<a name="l00084"></a>00084   
<a name="l00085"></a>00085 <span class="comment">// 3D face map definitions</span>
<a name="l00086"></a>00086 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a9816fe8dfc5cea06f8d075ee36bdc5b7">ExodusII_IO_Helper::ElementMaps::tet_face_map</a>[4]     = {1, 2, 3, 0};
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a5c6ccb065ccf1261744d9fd1e296e139">ExodusII_IO_Helper::ElementMaps::hex_face_map</a>[6]     = {1, 2, 3, 4, 0, 5};
<a name="l00089"></a>00089 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#ae233c86a0d59ff1a4b4e20fe0f2ee502">ExodusII_IO_Helper::ElementMaps::hex27_face_map</a>[6]   = {1, 2, 3, 4, 0, 5};
<a name="l00090"></a>00090 <span class="comment">//const int ExodusII_IO_Helper::ElementMaps::hex27_face_map[6]   = {1, 0, 3, 5, 4, 2};</span>
<a name="l00091"></a>00091 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#af42ffe4e1804df076fe5d93f68127da9">ExodusII_IO_Helper::ElementMaps::prism_face_map</a>[5]   = {-1,-1,-1,-1,-1}; <span class="comment">// Not Implemented!</span>
<a name="l00092"></a>00092 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a45d1621f3ea61101a6674741f14fed9f">ExodusII_IO_Helper::ElementMaps::pyramid_face_map</a>[5] = {-1,-1,-1,-1,-1}; <span class="comment">// Not Implemented!</span>
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 <span class="comment">//These take a libMesh ID and turn it into an Exodus ID</span>
<a name="l00095"></a>00095 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a8461aae160cf037098a95e2635953075">ExodusII_IO_Helper::ElementMaps::tet_inverse_face_map</a>[4]     = {4, 1, 2, 3};
<a name="l00096"></a>00096 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#ad4ba9582436d8efbc8415ccaf9755baf">ExodusII_IO_Helper::ElementMaps::hex_inverse_face_map</a>[6]     = {5, 1, 2, 3, 4, 6};
<a name="l00097"></a>00097 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a4b6b050eec2a2a10ac246d4b20f1160d">ExodusII_IO_Helper::ElementMaps::hex27_inverse_face_map</a>[6]   = {5, 1, 2, 3, 4, 6};
<a name="l00098"></a>00098 <span class="comment">//const int ExodusII_IO_Helper::ElementMaps::hex27_inverse_face_map[6]   = {2, 1, 6, 3, 5, 4};</span>
<a name="l00099"></a>00099 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#ad678dd9d31ae99763519c1ff5d62c468">ExodusII_IO_Helper::ElementMaps::prism_inverse_face_map</a>[5]   = {-1,-1,-1,-1,-1}; <span class="comment">// Not Implemented!</span>
<a name="l00100"></a>00100 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a6c445c9e83a8aff165262f0594441df1">ExodusII_IO_Helper::ElementMaps::pyramid_inverse_face_map</a>[5] = {-1,-1,-1,-1,-1}; <span class="comment">// Not Implemented!</span>
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00104"></a>00104 <span class="comment">// ExodusII_IO_Helper class members</span>
<a name="l00105"></a><a class="code" href="classExodusII__IO__Helper.php#a6bfdbf5cc31e63601cd8787f8ea96b78">00105</a> <a class="code" href="classExodusII__IO__Helper.php#a6bfdbf5cc31e63601cd8787f8ea96b78">ExodusII_IO_Helper::~ExodusII_IO_Helper</a>()
<a name="l00106"></a>00106 {
<a name="l00107"></a>00107 }
<a name="l00108"></a>00108 
<a name="l00109"></a><a class="code" href="classExodusII__IO__Helper.php#a90ab6ea1557ee6785027f28eee726836">00109</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a90ab6ea1557ee6785027f28eee726836">ExodusII_IO_Helper::verbose</a> (<span class="keywordtype">bool</span> set_verbosity)
<a name="l00110"></a>00110 {
<a name="l00111"></a>00111   <a class="code" href="classExodusII__IO__Helper.php#a2b09a9ee467e376882fc62e6d20aa539">_verbose</a> = set_verbosity;
<a name="l00112"></a>00112 }
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a><a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">00116</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">ExodusII_IO_Helper::check_err</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> err, <span class="keyword">const</span> std::string msg)
<a name="l00117"></a>00117 {
<a name="l00118"></a>00118   <span class="keywordflow">if</span> (err &lt; 0)
<a name="l00119"></a>00119     {
<a name="l00120"></a>00120       std::cout &lt;&lt; msg &lt;&lt; std::endl;
<a name="l00121"></a>00121       libmesh_error();
<a name="l00122"></a>00122     }
<a name="l00123"></a>00123 }
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a><a class="code" href="classExodusII__IO__Helper.php#a85099098d2972a91ff19be7128579b70">00127</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a85099098d2972a91ff19be7128579b70">ExodusII_IO_Helper::message</a>(<span class="keyword">const</span> std::string msg)
<a name="l00128"></a>00128 {
<a name="l00129"></a>00129   <span class="keywordflow">if</span> (<a class="code" href="classExodusII__IO__Helper.php#a2b09a9ee467e376882fc62e6d20aa539">_verbose</a>) std::cout &lt;&lt; msg &lt;&lt; std::endl;
<a name="l00130"></a>00130 }
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a><a class="code" href="classExodusII__IO__Helper.php#ac97b7886560ed2681aa5156847bfa7ac">00134</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a85099098d2972a91ff19be7128579b70">ExodusII_IO_Helper::message</a>(<span class="keyword">const</span> std::string msg, <span class="keywordtype">int</span> i)
<a name="l00135"></a>00135 {
<a name="l00136"></a>00136   <span class="keywordflow">if</span> (<a class="code" href="classExodusII__IO__Helper.php#a2b09a9ee467e376882fc62e6d20aa539">_verbose</a>) std::cout &lt;&lt; msg &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;.&quot;</span> &lt;&lt; std::endl;
<a name="l00137"></a>00137 }
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a><a class="code" href="classExodusII__IO__Helper.php#af979d5fd7cffa411bdd0a16b3a3011ee">00141</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#af979d5fd7cffa411bdd0a16b3a3011ee">ExodusII_IO_Helper::open</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* filename)
<a name="l00142"></a>00142 {
<a name="l00143"></a>00143   <a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a> = exII::ex_open(filename,
<a name="l00144"></a>00144                         EX_READ,
<a name="l00145"></a>00145                         &amp;<a class="code" href="classExodusII__IO__Helper.php#a3466b6b8813cc1922994e8308315c61d">comp_ws</a>,
<a name="l00146"></a>00146                         &amp;<a class="code" href="classExodusII__IO__Helper.php#a19b8a443d7d7865cc6b390dbf9679c11">io_ws</a>,
<a name="l00147"></a>00147                         &amp;<a class="code" href="classExodusII__IO__Helper.php#a5f322262349988a56beb178216674b04">ex_version</a>);
<a name="l00148"></a>00148   
<a name="l00149"></a>00149   <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>, <span class="stringliteral">&quot;Error opening ExodusII mesh file.&quot;</span>);
<a name="l00150"></a>00150   <span class="keywordflow">if</span> (<a class="code" href="classExodusII__IO__Helper.php#a2b09a9ee467e376882fc62e6d20aa539">_verbose</a>) std::cout &lt;&lt; <span class="stringliteral">&quot;File opened successfully.&quot;</span> &lt;&lt; std::endl;
<a name="l00151"></a>00151 }
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a><a class="code" href="classExodusII__IO__Helper.php#a3e2c4651800daaa7c199c63c4e49f161">00155</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a3e2c4651800daaa7c199c63c4e49f161">ExodusII_IO_Helper::read_header</a>()
<a name="l00156"></a>00156 {
<a name="l00157"></a>00157   <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a> = exII::ex_get_init(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>,
<a name="l00158"></a>00158                              <a class="code" href="classExodusII__IO__Helper.php#a2b14ab70ad213522ee14e81d71530e5d">title</a>.empty() ? NULL : &amp;<a class="code" href="classExodusII__IO__Helper.php#a2b14ab70ad213522ee14e81d71530e5d">title</a>[0],
<a name="l00159"></a>00159                              &amp;<a class="code" href="classExodusII__IO__Helper.php#aa514ad80ba187511d8dd81cb97a6a2aa">num_dim</a>,
<a name="l00160"></a>00160                              &amp;<a class="code" href="classExodusII__IO__Helper.php#a5f58455a10a22df08b2733e4b5e39aef">num_nodes</a>,
<a name="l00161"></a>00161                              &amp;<a class="code" href="classExodusII__IO__Helper.php#a5f3697a4d820cb9b2b4f18dd3a035f12">num_elem</a>,
<a name="l00162"></a>00162                              &amp;<a class="code" href="classExodusII__IO__Helper.php#af8020c0bd24728e12beea02d7f6fb44c">num_elem_blk</a>,
<a name="l00163"></a>00163                              &amp;<a class="code" href="classExodusII__IO__Helper.php#a9f6bce1eed82131d3df95bf2dabd92bc">num_node_sets</a>,
<a name="l00164"></a>00164                              &amp;<a class="code" href="classExodusII__IO__Helper.php#a873bc78e0c49f13ce9c5853d0d806e86">num_side_sets</a>);
<a name="l00165"></a>00165 
<a name="l00166"></a>00166   <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(<a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a>, <span class="stringliteral">&quot;Error retrieving header info.&quot;</span>);
<a name="l00167"></a>00167 
<a name="l00168"></a>00168   <a class="code" href="classExodusII__IO__Helper.php#a4a459c0bb6dcc4d06200f2682dc2ed1f">num_time_steps</a> = <a class="code" href="classExodusII__IO__Helper.php#a55079b2750dbdbf7ea02c7118c917d28">inquire</a>(exII::EX_INQ_TIME, <span class="stringliteral">&quot;Error retrieving time steps&quot;</span>);
<a name="l00169"></a>00169 
<a name="l00170"></a>00170   exII::ex_get_var_param(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>, <span class="stringliteral">&quot;n&quot;</span>, &amp;<a class="code" href="classExodusII__IO__Helper.php#ada52eac822ab7a679227cf3a927aef74">num_nodal_vars</a>);
<a name="l00171"></a>00171 
<a name="l00172"></a>00172   <a class="code" href="classExodusII__IO__Helper.php#a85099098d2972a91ff19be7128579b70">message</a>(<span class="stringliteral">&quot;Exodus header info retrieved successfully.&quot;</span>);
<a name="l00173"></a>00173 }
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a><a class="code" href="classExodusII__IO__Helper.php#a814335b8f7e05a408917b3d422078e61">00178</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a814335b8f7e05a408917b3d422078e61">ExodusII_IO_Helper::print_header</a>()
<a name="l00179"></a>00179 {
<a name="l00180"></a>00180   <span class="keywordflow">if</span> (<a class="code" href="classExodusII__IO__Helper.php#a2b09a9ee467e376882fc62e6d20aa539">_verbose</a>)
<a name="l00181"></a>00181     std::cout &lt;&lt; <span class="stringliteral">&quot;Title: \t&quot;</span> &lt;&lt; &amp;<a class="code" href="classExodusII__IO__Helper.php#a2b14ab70ad213522ee14e81d71530e5d">title</a>[0] &lt;&lt; std::endl
<a name="l00182"></a>00182               &lt;&lt; <span class="stringliteral">&quot;Mesh Dimension: \t&quot;</span>   &lt;&lt; <a class="code" href="classExodusII__IO__Helper.php#aa514ad80ba187511d8dd81cb97a6a2aa">num_dim</a> &lt;&lt; std::endl
<a name="l00183"></a>00183               &lt;&lt; <span class="stringliteral">&quot;Number of Nodes: \t&quot;</span> &lt;&lt; <a class="code" href="classExodusII__IO__Helper.php#a5f58455a10a22df08b2733e4b5e39aef">num_nodes</a> &lt;&lt; std::endl
<a name="l00184"></a>00184               &lt;&lt; <span class="stringliteral">&quot;Number of elements: \t&quot;</span> &lt;&lt; <a class="code" href="classExodusII__IO__Helper.php#a5f3697a4d820cb9b2b4f18dd3a035f12">num_elem</a> &lt;&lt; std::endl
<a name="l00185"></a>00185               &lt;&lt; <span class="stringliteral">&quot;Number of elt blocks: \t&quot;</span> &lt;&lt; <a class="code" href="classExodusII__IO__Helper.php#af8020c0bd24728e12beea02d7f6fb44c">num_elem_blk</a> &lt;&lt; std::endl
<a name="l00186"></a>00186               &lt;&lt; <span class="stringliteral">&quot;Number of node sets: \t&quot;</span> &lt;&lt; <a class="code" href="classExodusII__IO__Helper.php#a9f6bce1eed82131d3df95bf2dabd92bc">num_node_sets</a> &lt;&lt; std::endl
<a name="l00187"></a>00187               &lt;&lt; <span class="stringliteral">&quot;Number of side sets: \t&quot;</span> &lt;&lt; <a class="code" href="classExodusII__IO__Helper.php#a873bc78e0c49f13ce9c5853d0d806e86">num_side_sets</a> &lt;&lt; std::endl;
<a name="l00188"></a>00188 }
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 
<a name="l00192"></a><a class="code" href="classExodusII__IO__Helper.php#a0ae664b1cc9421fff23daeff6049b591">00192</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a0ae664b1cc9421fff23daeff6049b591">ExodusII_IO_Helper::read_nodes</a>()
<a name="l00193"></a>00193 {
<a name="l00194"></a>00194   <a class="code" href="classExodusII__IO__Helper.php#a168332624b026270a5424916f638c0f7">x</a>.resize(<a class="code" href="classExodusII__IO__Helper.php#a5f58455a10a22df08b2733e4b5e39aef">num_nodes</a>);
<a name="l00195"></a>00195   <a class="code" href="classExodusII__IO__Helper.php#a1c72a90256cbff143f3685f97648f958">y</a>.resize(<a class="code" href="classExodusII__IO__Helper.php#a5f58455a10a22df08b2733e4b5e39aef">num_nodes</a>); 
<a name="l00196"></a>00196   <a class="code" href="classExodusII__IO__Helper.php#a952624a5decb9b620eb59ffb41c948e4">z</a>.resize(<a class="code" href="classExodusII__IO__Helper.php#a5f58455a10a22df08b2733e4b5e39aef">num_nodes</a>); 
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a> = exII::ex_get_coord(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>,
<a name="l00199"></a>00199                               static_cast&lt;void*&gt;(&amp;<a class="code" href="classExodusII__IO__Helper.php#a168332624b026270a5424916f638c0f7">x</a>[0]),
<a name="l00200"></a>00200                               static_cast&lt;void*&gt;(&amp;<a class="code" href="classExodusII__IO__Helper.php#a1c72a90256cbff143f3685f97648f958">y</a>[0]),
<a name="l00201"></a>00201                               static_cast&lt;void*&gt;(&amp;<a class="code" href="classExodusII__IO__Helper.php#a952624a5decb9b620eb59ffb41c948e4">z</a>[0]));
<a name="l00202"></a>00202   
<a name="l00203"></a>00203   <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(<a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a>, <span class="stringliteral">&quot;Error retrieving nodal data.&quot;</span>);
<a name="l00204"></a>00204   <a class="code" href="classExodusII__IO__Helper.php#a85099098d2972a91ff19be7128579b70">message</a>(<span class="stringliteral">&quot;Nodal data retrieved successfully.&quot;</span>); 
<a name="l00205"></a>00205 }
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 
<a name="l00208"></a>00208 
<a name="l00209"></a><a class="code" href="classExodusII__IO__Helper.php#a0fb998fe79e5d8f206925d29c363eb45">00209</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a0fb998fe79e5d8f206925d29c363eb45">ExodusII_IO_Helper::read_node_num_map</a> ()
<a name="l00210"></a>00210 {
<a name="l00211"></a>00211   <a class="code" href="classExodusII__IO__Helper.php#a24538ef46d1309b8dc1fca2a9e937ad0">node_num_map</a>.resize(<a class="code" href="classExodusII__IO__Helper.php#a5f58455a10a22df08b2733e4b5e39aef">num_nodes</a>);
<a name="l00212"></a>00212 
<a name="l00213"></a>00213   <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a> = exII::ex_get_node_num_map (<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>,
<a name="l00214"></a>00214                                       <a class="code" href="classExodusII__IO__Helper.php#a24538ef46d1309b8dc1fca2a9e937ad0">node_num_map</a>.empty() ? NULL : &amp;<a class="code" href="classExodusII__IO__Helper.php#a24538ef46d1309b8dc1fca2a9e937ad0">node_num_map</a>[0]);
<a name="l00215"></a>00215                                       
<a name="l00216"></a>00216   <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(<a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a>, <span class="stringliteral">&quot;Error retrieving nodal number map.&quot;</span>);
<a name="l00217"></a>00217   <a class="code" href="classExodusII__IO__Helper.php#a85099098d2972a91ff19be7128579b70">message</a>(<span class="stringliteral">&quot;Nodal numbering map retrieved successfully.&quot;</span>); 
<a name="l00218"></a>00218 
<a name="l00219"></a>00219   <span class="keywordflow">if</span> (<a class="code" href="classExodusII__IO__Helper.php#a2b09a9ee467e376882fc62e6d20aa539">_verbose</a>)
<a name="l00220"></a>00220     {
<a name="l00221"></a>00221       std::cout &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] node_num_map[i] = &quot;</span>;
<a name="l00222"></a>00222       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt; static_cast&lt;unsigned int&gt;(<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(10, <a class="code" href="classExodusII__IO__Helper.php#a5f58455a10a22df08b2733e4b5e39aef">num_nodes</a>-1)); ++i)
<a name="l00223"></a>00223         std::cout &lt;&lt; <a class="code" href="classExodusII__IO__Helper.php#a24538ef46d1309b8dc1fca2a9e937ad0">node_num_map</a>[i] &lt;&lt; <span class="stringliteral">&quot;, &quot;</span>;
<a name="l00224"></a>00224       std::cout &lt;&lt; <span class="stringliteral">&quot;... &quot;</span> &lt;&lt; <a class="code" href="classExodusII__IO__Helper.php#a24538ef46d1309b8dc1fca2a9e937ad0">node_num_map</a>.back() &lt;&lt; std::endl;
<a name="l00225"></a>00225     }
<a name="l00226"></a>00226 }
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 
<a name="l00229"></a><a class="code" href="classExodusII__IO__Helper.php#ac1e6e372be3d30b50f9163c95e1ad73c">00229</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#ac1e6e372be3d30b50f9163c95e1ad73c">ExodusII_IO_Helper::print_nodes</a>()
<a name="l00230"></a>00230 {
<a name="l00231"></a>00231   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classExodusII__IO__Helper.php#a5f58455a10a22df08b2733e4b5e39aef">num_nodes</a>; i++)
<a name="l00232"></a>00232     {
<a name="l00233"></a>00233       std::cout &lt;&lt; <span class="stringliteral">&quot;(&quot;</span> &lt;&lt; <a class="code" href="classExodusII__IO__Helper.php#a168332624b026270a5424916f638c0f7">x</a>[i] &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; <a class="code" href="classExodusII__IO__Helper.php#a1c72a90256cbff143f3685f97648f958">y</a>[i] &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; <a class="code" href="classExodusII__IO__Helper.php#a952624a5decb9b620eb59ffb41c948e4">z</a>[i] &lt;&lt; <span class="stringliteral">&quot;)&quot;</span> &lt;&lt; std::endl;
<a name="l00234"></a>00234     }
<a name="l00235"></a>00235 }
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 
<a name="l00238"></a>00238 
<a name="l00239"></a><a class="code" href="classExodusII__IO__Helper.php#aac7883fbd864085b82ef0305205037b5">00239</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#aac7883fbd864085b82ef0305205037b5">ExodusII_IO_Helper::read_block_info</a>()
<a name="l00240"></a>00240 {
<a name="l00241"></a>00241   <a class="code" href="classExodusII__IO__Helper.php#afc7339f25064d90005a6b7a6aff429b0">block_ids</a>.resize(<a class="code" href="classExodusII__IO__Helper.php#af8020c0bd24728e12beea02d7f6fb44c">num_elem_blk</a>);
<a name="l00242"></a>00242   <span class="comment">// Get all element block IDs.</span>
<a name="l00243"></a>00243   <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a> = exII::ex_get_elem_blk_ids(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>,
<a name="l00244"></a>00244                                      <a class="code" href="classExodusII__IO__Helper.php#afc7339f25064d90005a6b7a6aff429b0">block_ids</a>.empty() ? NULL : &amp;<a class="code" href="classExodusII__IO__Helper.php#afc7339f25064d90005a6b7a6aff429b0">block_ids</a>[0]);
<a name="l00245"></a>00245   <span class="comment">// Usually, there is only one</span>
<a name="l00246"></a>00246   <span class="comment">// block since there is only</span>
<a name="l00247"></a>00247   <span class="comment">// one type of element.</span>
<a name="l00248"></a>00248   <span class="comment">// However, there could be more.</span>
<a name="l00249"></a>00249 
<a name="l00250"></a>00250   <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(<a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a>, <span class="stringliteral">&quot;Error getting block IDs.&quot;</span>);
<a name="l00251"></a>00251   <a class="code" href="classExodusII__IO__Helper.php#a85099098d2972a91ff19be7128579b70">message</a>(<span class="stringliteral">&quot;All block IDs retrieved successfully.&quot;</span>); 
<a name="l00252"></a>00252 }
<a name="l00253"></a>00253 
<a name="l00254"></a>00254 
<a name="l00255"></a>00255 
<a name="l00256"></a><a class="code" href="classExodusII__IO__Helper.php#accf630acdb0aab66a0cd6daf3973b59d">00256</a> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper.php#accf630acdb0aab66a0cd6daf3973b59d">ExodusII_IO_Helper::get_block_id</a>(<span class="keywordtype">int</span> block)
<a name="l00257"></a>00257 {
<a name="l00258"></a>00258   libmesh_assert (static_cast&lt;unsigned int&gt;(block) &lt; <a class="code" href="classExodusII__IO__Helper.php#afc7339f25064d90005a6b7a6aff429b0">block_ids</a>.size());
<a name="l00259"></a>00259     
<a name="l00260"></a>00260   <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#afc7339f25064d90005a6b7a6aff429b0">block_ids</a>[block];
<a name="l00261"></a>00261 }
<a name="l00262"></a>00262 
<a name="l00263"></a>00263 
<a name="l00264"></a>00264 
<a name="l00265"></a><a class="code" href="classExodusII__IO__Helper.php#af2bf9e3fea0115a5e5da62074fca5968">00265</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#af2bf9e3fea0115a5e5da62074fca5968">ExodusII_IO_Helper::read_elem_in_block</a>(<span class="keywordtype">int</span> block)
<a name="l00266"></a>00266 {
<a name="l00267"></a>00267   libmesh_assert (static_cast&lt;unsigned int&gt;(block) &lt; <a class="code" href="classExodusII__IO__Helper.php#afc7339f25064d90005a6b7a6aff429b0">block_ids</a>.size());
<a name="l00268"></a>00268   
<a name="l00269"></a>00269   <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a> = exII::ex_get_elem_block(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>,
<a name="l00270"></a>00270                                    <a class="code" href="classExodusII__IO__Helper.php#afc7339f25064d90005a6b7a6aff429b0">block_ids</a>[block],
<a name="l00271"></a>00271                                    &amp;<a class="code" href="classExodusII__IO__Helper.php#a63b094665cd526058573859ea7ec7a9f">elem_type</a>[0],
<a name="l00272"></a>00272                                    &amp;<a class="code" href="classExodusII__IO__Helper.php#a856f2a0dc5850f1957a2072ef1ce2e5f">num_elem_this_blk</a>,
<a name="l00273"></a>00273                                    &amp;<a class="code" href="classExodusII__IO__Helper.php#a944f1231f4dfbdafc94ac3371ae0cf0b">num_nodes_per_elem</a>,
<a name="l00274"></a>00274                                    &amp;<a class="code" href="classExodusII__IO__Helper.php#a314b2dc9e24c82945a534f3adefe077d">num_attr</a>);
<a name="l00275"></a>00275   <span class="keywordflow">if</span> (<a class="code" href="classExodusII__IO__Helper.php#a2b09a9ee467e376882fc62e6d20aa539">_verbose</a>)
<a name="l00276"></a>00276     std::cout &lt;&lt; <span class="stringliteral">&quot;Reading a block of &quot;</span> &lt;&lt; <a class="code" href="classExodusII__IO__Helper.php#a856f2a0dc5850f1957a2072ef1ce2e5f">num_elem_this_blk</a>
<a name="l00277"></a>00277               &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; &amp;<a class="code" href="classExodusII__IO__Helper.php#a63b094665cd526058573859ea7ec7a9f">elem_type</a>[0] &lt;&lt; <span class="stringliteral">&quot;(s)&quot;</span>
<a name="l00278"></a>00278               &lt;&lt; <span class="stringliteral">&quot; having &quot;</span> &lt;&lt; <a class="code" href="classExodusII__IO__Helper.php#a944f1231f4dfbdafc94ac3371ae0cf0b">num_nodes_per_elem</a>
<a name="l00279"></a>00279               &lt;&lt; <span class="stringliteral">&quot; nodes per element.&quot;</span> &lt;&lt; std::endl;
<a name="l00280"></a>00280       
<a name="l00281"></a>00281   <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(ex_err, <span class="stringliteral">&quot;Error getting block info.&quot;</span>);
<a name="l00282"></a>00282   <a class="code" href="classExodusII__IO__Helper.php#a85099098d2972a91ff19be7128579b70">message</a>(<span class="stringliteral">&quot;Info retrieved successfully for block: &quot;</span>, block); 
<a name="l00283"></a>00283   
<a name="l00284"></a>00284   
<a name="l00285"></a>00285   
<a name="l00286"></a>00286   <span class="comment">// Read in the connectivity of the elements of this block,</span>
<a name="l00287"></a>00287   <span class="comment">// watching out for the case where we actually have no</span>
<a name="l00288"></a>00288   <span class="comment">// elements in this block (possible with parallel files)</span>
<a name="l00289"></a>00289   <a class="code" href="classExodusII__IO__Helper.php#aa1399def5bca722af0eed2adcbc4cd73">connect</a>.resize(<a class="code" href="classExodusII__IO__Helper.php#a944f1231f4dfbdafc94ac3371ae0cf0b">num_nodes_per_elem</a>*<a class="code" href="classExodusII__IO__Helper.php#a856f2a0dc5850f1957a2072ef1ce2e5f">num_elem_this_blk</a>);
<a name="l00290"></a>00290 
<a name="l00291"></a>00291   <span class="keywordflow">if</span> (!<a class="code" href="classExodusII__IO__Helper.php#aa1399def5bca722af0eed2adcbc4cd73">connect</a>.empty())
<a name="l00292"></a>00292     {
<a name="l00293"></a>00293       ex_err = exII::ex_get_elem_conn(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>,
<a name="l00294"></a>00294                                       <a class="code" href="classExodusII__IO__Helper.php#afc7339f25064d90005a6b7a6aff429b0">block_ids</a>[block],
<a name="l00295"></a>00295                                       &amp;<a class="code" href="classExodusII__IO__Helper.php#aa1399def5bca722af0eed2adcbc4cd73">connect</a>[0]);
<a name="l00296"></a>00296   
<a name="l00297"></a>00297       <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(ex_err, <span class="stringliteral">&quot;Error reading block connectivity.&quot;</span>);
<a name="l00298"></a>00298       <a class="code" href="classExodusII__IO__Helper.php#a85099098d2972a91ff19be7128579b70">message</a>(<span class="stringliteral">&quot;Connectivity retrieved successfully for block: &quot;</span>, block);
<a name="l00299"></a>00299     }
<a name="l00300"></a>00300 }
<a name="l00301"></a>00301 
<a name="l00302"></a>00302 
<a name="l00303"></a>00303 
<a name="l00304"></a><a class="code" href="classExodusII__IO__Helper.php#a65706a7896b35a9f4befee2bed02cc8f">00304</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a65706a7896b35a9f4befee2bed02cc8f">ExodusII_IO_Helper::read_elem_num_map</a> () 
<a name="l00305"></a>00305 {
<a name="l00306"></a>00306   <a class="code" href="classExodusII__IO__Helper.php#ac72e1899b5ff58a2c433c4fed45877f7">elem_num_map</a>.resize(<a class="code" href="classExodusII__IO__Helper.php#a5f3697a4d820cb9b2b4f18dd3a035f12">num_elem</a>);
<a name="l00307"></a>00307 
<a name="l00308"></a>00308   <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a> = exII::ex_get_elem_num_map (<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>,
<a name="l00309"></a>00309                                       <a class="code" href="classExodusII__IO__Helper.php#ac72e1899b5ff58a2c433c4fed45877f7">elem_num_map</a>.empty() ? NULL : &amp;<a class="code" href="classExodusII__IO__Helper.php#ac72e1899b5ff58a2c433c4fed45877f7">elem_num_map</a>[0]);
<a name="l00310"></a>00310                                       
<a name="l00311"></a>00311   <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(<a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a>, <span class="stringliteral">&quot;Error retrieving element number map.&quot;</span>);
<a name="l00312"></a>00312   <a class="code" href="classExodusII__IO__Helper.php#a85099098d2972a91ff19be7128579b70">message</a>(<span class="stringliteral">&quot;Element numbering map retrieved successfully.&quot;</span>); 
<a name="l00313"></a>00313 
<a name="l00314"></a>00314 
<a name="l00315"></a>00315   <span class="keywordflow">if</span> (<a class="code" href="classExodusII__IO__Helper.php#a2b09a9ee467e376882fc62e6d20aa539">_verbose</a>)
<a name="l00316"></a>00316     {
<a name="l00317"></a>00317       std::cout &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] elem_num_map[i] = &quot;</span>;
<a name="l00318"></a>00318       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt; static_cast&lt;unsigned int&gt;(<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(10, <a class="code" href="classExodusII__IO__Helper.php#a5f3697a4d820cb9b2b4f18dd3a035f12">num_elem</a>-1)); ++i)
<a name="l00319"></a>00319         std::cout &lt;&lt; <a class="code" href="classExodusII__IO__Helper.php#ac72e1899b5ff58a2c433c4fed45877f7">elem_num_map</a>[i] &lt;&lt; <span class="stringliteral">&quot;, &quot;</span>;
<a name="l00320"></a>00320       std::cout &lt;&lt; <span class="stringliteral">&quot;... &quot;</span> &lt;&lt; <a class="code" href="classExodusII__IO__Helper.php#ac72e1899b5ff58a2c433c4fed45877f7">elem_num_map</a>.back() &lt;&lt; std::endl;
<a name="l00321"></a>00321     }
<a name="l00322"></a>00322 }
<a name="l00323"></a>00323 
<a name="l00324"></a>00324 
<a name="l00325"></a>00325 
<a name="l00326"></a><a class="code" href="classExodusII__IO__Helper.php#a55da723215f331f1cda00391f057dd5e">00326</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a55da723215f331f1cda00391f057dd5e">ExodusII_IO_Helper::read_sideset_info</a>()
<a name="l00327"></a>00327 {
<a name="l00328"></a>00328   <a class="code" href="classExodusII__IO__Helper.php#a3e7da200b8d4811be400c463914a1f0f">ss_ids</a>.resize(<a class="code" href="classExodusII__IO__Helper.php#a873bc78e0c49f13ce9c5853d0d806e86">num_side_sets</a>);
<a name="l00329"></a>00329   <span class="keywordflow">if</span> (<a class="code" href="classExodusII__IO__Helper.php#a873bc78e0c49f13ce9c5853d0d806e86">num_side_sets</a> &gt; 0)
<a name="l00330"></a>00330     {
<a name="l00331"></a>00331       <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a> = exII::ex_get_side_set_ids(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>,
<a name="l00332"></a>00332                                          &amp;<a class="code" href="classExodusII__IO__Helper.php#a3e7da200b8d4811be400c463914a1f0f">ss_ids</a>[0]);
<a name="l00333"></a>00333       <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(<a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a>, <span class="stringliteral">&quot;Error retrieving sideset information.&quot;</span>);
<a name="l00334"></a>00334       <a class="code" href="classExodusII__IO__Helper.php#a85099098d2972a91ff19be7128579b70">message</a>(<span class="stringliteral">&quot;All sideset information retrieved successfully.&quot;</span>); 
<a name="l00335"></a>00335 
<a name="l00336"></a>00336       <span class="comment">// Resize appropriate data structures -- only do this once outside the loop</span>
<a name="l00337"></a>00337       <a class="code" href="classExodusII__IO__Helper.php#a7b09767c31d40dda95f53f71d8429a02">num_sides_per_set</a>.resize(<a class="code" href="classExodusII__IO__Helper.php#a873bc78e0c49f13ce9c5853d0d806e86">num_side_sets</a>);
<a name="l00338"></a>00338       <a class="code" href="classExodusII__IO__Helper.php#a00e94b15e780714b25e17d21662c12df">num_df_per_set</a>.resize(<a class="code" href="classExodusII__IO__Helper.php#a873bc78e0c49f13ce9c5853d0d806e86">num_side_sets</a>);
<a name="l00339"></a>00339 
<a name="l00340"></a>00340       <span class="comment">// Inquire about the length of the</span>
<a name="l00341"></a>00341       <span class="comment">// concatenated side sets element list</span>
<a name="l00342"></a>00342       <a class="code" href="classExodusII__IO__Helper.php#a7e318ac727f824a86a20348f19975c41">req_info</a> = exII::EX_INQ_SS_ELEM_LEN; 
<a name="l00343"></a>00343       <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a> = exII::ex_inquire(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>,
<a name="l00344"></a>00344                                 <a class="code" href="classExodusII__IO__Helper.php#a7e318ac727f824a86a20348f19975c41">req_info</a>,
<a name="l00345"></a>00345                                 &amp;<a class="code" href="classExodusII__IO__Helper.php#a539fcb6f02f6a3bfcfc93378c451ad7d">ret_int</a>,
<a name="l00346"></a>00346                                 &amp;<a class="code" href="classExodusII__IO__Helper.php#ae78db4dd9b9859612bc2dd4b943d0afb">ret_float</a>,
<a name="l00347"></a>00347                                 &amp;<a class="code" href="classExodusII__IO__Helper.php#aaf703b9deb6ce245117f4d0fb0bc9305">ret_char</a>);
<a name="l00348"></a>00348       <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(<a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a>, <span class="stringliteral">&quot;Error inquiring about side set element list length.&quot;</span>);
<a name="l00349"></a>00349 
<a name="l00350"></a>00350       <span class="comment">//std::cout &lt;&lt; &quot;Value returned by ex_inquire was: &quot; &lt;&lt; ret_int &lt;&lt; std::endl;</span>
<a name="l00351"></a>00351       <a class="code" href="classExodusII__IO__Helper.php#a26ec622cfba94e10bb0670d874b77732">num_elem_all_sidesets</a> = <a class="code" href="classExodusII__IO__Helper.php#a539fcb6f02f6a3bfcfc93378c451ad7d">ret_int</a>;  
<a name="l00352"></a>00352       <a class="code" href="classExodusII__IO__Helper.php#a15aec6a71e5aa0b3ce8973148e089502">elem_list</a>.resize (<a class="code" href="classExodusII__IO__Helper.php#a26ec622cfba94e10bb0670d874b77732">num_elem_all_sidesets</a>);
<a name="l00353"></a>00353       <a class="code" href="classExodusII__IO__Helper.php#a5323c8fc862f0933976b898fbc2428a2">side_list</a>.resize (<a class="code" href="classExodusII__IO__Helper.php#a26ec622cfba94e10bb0670d874b77732">num_elem_all_sidesets</a>);
<a name="l00354"></a>00354       <a class="code" href="classExodusII__IO__Helper.php#ab74abbcd9a919d57adf0f7ab0e234980">id_list</a>.resize   (<a class="code" href="classExodusII__IO__Helper.php#a26ec622cfba94e10bb0670d874b77732">num_elem_all_sidesets</a>);
<a name="l00355"></a>00355     }
<a name="l00356"></a>00356 }
<a name="l00357"></a>00357 
<a name="l00358"></a><a class="code" href="classExodusII__IO__Helper.php#ae9c3256ae51c60ff819bf08b2570159a">00358</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#ae9c3256ae51c60ff819bf08b2570159a">ExodusII_IO_Helper::read_nodeset_info</a>()
<a name="l00359"></a>00359 {
<a name="l00360"></a>00360   <a class="code" href="classExodusII__IO__Helper.php#a2db3d404f6920aa585d270e57895a943">nodeset_ids</a>.resize(<a class="code" href="classExodusII__IO__Helper.php#a9f6bce1eed82131d3df95bf2dabd92bc">num_node_sets</a>);
<a name="l00361"></a>00361   <span class="keywordflow">if</span> (<a class="code" href="classExodusII__IO__Helper.php#a9f6bce1eed82131d3df95bf2dabd92bc">num_node_sets</a> &gt; 0)
<a name="l00362"></a>00362     {
<a name="l00363"></a>00363       <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a> = exII::ex_get_node_set_ids(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>,
<a name="l00364"></a>00364                                          &amp;<a class="code" href="classExodusII__IO__Helper.php#a2db3d404f6920aa585d270e57895a943">nodeset_ids</a>[0]);
<a name="l00365"></a>00365       <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(<a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a>, <span class="stringliteral">&quot;Error retrieving nodeset information.&quot;</span>);
<a name="l00366"></a>00366       <a class="code" href="classExodusII__IO__Helper.php#a85099098d2972a91ff19be7128579b70">message</a>(<span class="stringliteral">&quot;All nodeset information retrieved successfully.&quot;</span>); 
<a name="l00367"></a>00367 
<a name="l00368"></a>00368       <span class="comment">// Resize appropriate data structures -- only do this once outnode the loop</span>
<a name="l00369"></a>00369       <a class="code" href="classExodusII__IO__Helper.php#aa4733dda048befbcebf8f3ac4046c09f">num_nodes_per_set</a>.resize(<a class="code" href="classExodusII__IO__Helper.php#a9f6bce1eed82131d3df95bf2dabd92bc">num_node_sets</a>);
<a name="l00370"></a>00370       <a class="code" href="classExodusII__IO__Helper.php#a75a028adaa62026790c57f857da1fc86">num_node_df_per_set</a>.resize(<a class="code" href="classExodusII__IO__Helper.php#a9f6bce1eed82131d3df95bf2dabd92bc">num_node_sets</a>);
<a name="l00371"></a>00371     }
<a name="l00372"></a>00372 }
<a name="l00373"></a>00373 
<a name="l00374"></a>00374 
<a name="l00375"></a><a class="code" href="classExodusII__IO__Helper.php#a81a6fca6d1b75d688d3430b42ac23b5e">00375</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a81a6fca6d1b75d688d3430b42ac23b5e">ExodusII_IO_Helper::read_sideset</a>(<span class="keywordtype">int</span> <span class="keywordtype">id</span>, <span class="keywordtype">int</span> offset)
<a name="l00376"></a>00376 {
<a name="l00377"></a>00377   libmesh_assert (static_cast&lt;unsigned int&gt;(<span class="keywordtype">id</span>) &lt; <a class="code" href="classExodusII__IO__Helper.php#a3e7da200b8d4811be400c463914a1f0f">ss_ids</a>.size());
<a name="l00378"></a>00378   libmesh_assert (static_cast&lt;unsigned int&gt;(<span class="keywordtype">id</span>) &lt; <a class="code" href="classExodusII__IO__Helper.php#a7b09767c31d40dda95f53f71d8429a02">num_sides_per_set</a>.size());
<a name="l00379"></a>00379   libmesh_assert (static_cast&lt;unsigned int&gt;(<span class="keywordtype">id</span>) &lt; <a class="code" href="classExodusII__IO__Helper.php#a00e94b15e780714b25e17d21662c12df">num_df_per_set</a>.size());
<a name="l00380"></a>00380   libmesh_assert (static_cast&lt;unsigned int&gt;(offset) &lt; <a class="code" href="classExodusII__IO__Helper.php#a15aec6a71e5aa0b3ce8973148e089502">elem_list</a>.size());
<a name="l00381"></a>00381   libmesh_assert (static_cast&lt;unsigned int&gt;(offset) &lt; <a class="code" href="classExodusII__IO__Helper.php#a5323c8fc862f0933976b898fbc2428a2">side_list</a>.size());
<a name="l00382"></a>00382   
<a name="l00383"></a>00383   <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a> = exII::ex_get_side_set_param(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>,
<a name="l00384"></a>00384                                        <a class="code" href="classExodusII__IO__Helper.php#a3e7da200b8d4811be400c463914a1f0f">ss_ids</a>[<span class="keywordtype">id</span>],
<a name="l00385"></a>00385                                        &amp;<a class="code" href="classExodusII__IO__Helper.php#a7b09767c31d40dda95f53f71d8429a02">num_sides_per_set</a>[<span class="keywordtype">id</span>],
<a name="l00386"></a>00386                                        &amp;<a class="code" href="classExodusII__IO__Helper.php#a00e94b15e780714b25e17d21662c12df">num_df_per_set</a>[<span class="keywordtype">id</span>]);
<a name="l00387"></a>00387   <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(ex_err, <span class="stringliteral">&quot;Error retrieving sideset parameters.&quot;</span>);
<a name="l00388"></a>00388   <a class="code" href="classExodusII__IO__Helper.php#a85099098d2972a91ff19be7128579b70">message</a>(<span class="stringliteral">&quot;Parameters retrieved successfully for sideset: &quot;</span>, <span class="keywordtype">id</span>);
<a name="l00389"></a>00389 
<a name="l00390"></a>00390   ex_err = exII::ex_get_side_set(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>,
<a name="l00391"></a>00391                                  <a class="code" href="classExodusII__IO__Helper.php#a3e7da200b8d4811be400c463914a1f0f">ss_ids</a>[<span class="keywordtype">id</span>],
<a name="l00392"></a>00392                                  &amp;<a class="code" href="classExodusII__IO__Helper.php#a15aec6a71e5aa0b3ce8973148e089502">elem_list</a>[offset],
<a name="l00393"></a>00393                                  &amp;<a class="code" href="classExodusII__IO__Helper.php#a5323c8fc862f0933976b898fbc2428a2">side_list</a>[offset]);
<a name="l00394"></a>00394   <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(ex_err, <span class="stringliteral">&quot;Error retrieving sideset data.&quot;</span>);
<a name="l00395"></a>00395   <a class="code" href="classExodusII__IO__Helper.php#a85099098d2972a91ff19be7128579b70">message</a>(<span class="stringliteral">&quot;Data retrieved successfully for sideset: &quot;</span>, <span class="keywordtype">id</span>);
<a name="l00396"></a>00396 
<a name="l00397"></a>00397   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classExodusII__IO__Helper.php#a7b09767c31d40dda95f53f71d8429a02">num_sides_per_set</a>[id]; i++)
<a name="l00398"></a>00398     <a class="code" href="classExodusII__IO__Helper.php#ab74abbcd9a919d57adf0f7ab0e234980">id_list</a>[i+offset] = <a class="code" href="classExodusII__IO__Helper.php#a3e7da200b8d4811be400c463914a1f0f">ss_ids</a>[<span class="keywordtype">id</span>];
<a name="l00399"></a>00399 }
<a name="l00400"></a>00400 
<a name="l00401"></a><a class="code" href="classExodusII__IO__Helper.php#a914c2e29f12d8118cb2bbe7e02817a6a">00401</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a914c2e29f12d8118cb2bbe7e02817a6a">ExodusII_IO_Helper::read_nodeset</a>(<span class="keywordtype">int</span> <span class="keywordtype">id</span>)
<a name="l00402"></a>00402 {
<a name="l00403"></a>00403   libmesh_assert (static_cast&lt;unsigned int&gt;(<span class="keywordtype">id</span>) &lt; <a class="code" href="classExodusII__IO__Helper.php#a2db3d404f6920aa585d270e57895a943">nodeset_ids</a>.size());
<a name="l00404"></a>00404   libmesh_assert (static_cast&lt;unsigned int&gt;(<span class="keywordtype">id</span>) &lt; <a class="code" href="classExodusII__IO__Helper.php#aa4733dda048befbcebf8f3ac4046c09f">num_nodes_per_set</a>.size());
<a name="l00405"></a>00405   libmesh_assert (static_cast&lt;unsigned int&gt;(<span class="keywordtype">id</span>) &lt; <a class="code" href="classExodusII__IO__Helper.php#a75a028adaa62026790c57f857da1fc86">num_node_df_per_set</a>.size());
<a name="l00406"></a>00406   
<a name="l00407"></a>00407   <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a> = exII::ex_get_node_set_param(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>,
<a name="l00408"></a>00408                                        <a class="code" href="classExodusII__IO__Helper.php#a2db3d404f6920aa585d270e57895a943">nodeset_ids</a>[<span class="keywordtype">id</span>],
<a name="l00409"></a>00409                                        &amp;<a class="code" href="classExodusII__IO__Helper.php#aa4733dda048befbcebf8f3ac4046c09f">num_nodes_per_set</a>[<span class="keywordtype">id</span>],
<a name="l00410"></a>00410                                        &amp;<a class="code" href="classExodusII__IO__Helper.php#a75a028adaa62026790c57f857da1fc86">num_node_df_per_set</a>[<span class="keywordtype">id</span>]);
<a name="l00411"></a>00411   <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(ex_err, <span class="stringliteral">&quot;Error retrieving nodeset parameters.&quot;</span>);
<a name="l00412"></a>00412   <a class="code" href="classExodusII__IO__Helper.php#a85099098d2972a91ff19be7128579b70">message</a>(<span class="stringliteral">&quot;Parameters retrieved successfully for nodeset: &quot;</span>, <span class="keywordtype">id</span>);
<a name="l00413"></a>00413 
<a name="l00414"></a>00414   <a class="code" href="classExodusII__IO__Helper.php#ae36f3ea52e3c9d05e39eccf8cf435032">node_list</a>.resize(<a class="code" href="classExodusII__IO__Helper.php#aa4733dda048befbcebf8f3ac4046c09f">num_nodes_per_set</a>[<span class="keywordtype">id</span>]);
<a name="l00415"></a>00415 
<a name="l00416"></a>00416   ex_err = exII::ex_get_node_set(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>,
<a name="l00417"></a>00417                                  <a class="code" href="classExodusII__IO__Helper.php#a2db3d404f6920aa585d270e57895a943">nodeset_ids</a>[<span class="keywordtype">id</span>],
<a name="l00418"></a>00418                                  &amp;<a class="code" href="classExodusII__IO__Helper.php#ae36f3ea52e3c9d05e39eccf8cf435032">node_list</a>[0]);
<a name="l00419"></a>00419   
<a name="l00420"></a>00420   <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(ex_err, <span class="stringliteral">&quot;Error retrieving nodeset data.&quot;</span>);
<a name="l00421"></a>00421   <a class="code" href="classExodusII__IO__Helper.php#a85099098d2972a91ff19be7128579b70">message</a>(<span class="stringliteral">&quot;Data retrieved successfully for nodeset: &quot;</span>, <span class="keywordtype">id</span>);
<a name="l00422"></a>00422 }
<a name="l00423"></a>00423 
<a name="l00424"></a>00424 
<a name="l00425"></a><a class="code" href="classExodusII__IO__Helper.php#a19cb114ec9e94f4f56b1f520926175af">00425</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a19cb114ec9e94f4f56b1f520926175af">ExodusII_IO_Helper::print_sideset_info</a>()
<a name="l00426"></a>00426 {
<a name="l00427"></a>00427   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classExodusII__IO__Helper.php#a26ec622cfba94e10bb0670d874b77732">num_elem_all_sidesets</a>; i++)
<a name="l00428"></a>00428     {
<a name="l00429"></a>00429       std::cout &lt;&lt; <a class="code" href="classExodusII__IO__Helper.php#a15aec6a71e5aa0b3ce8973148e089502">elem_list</a>[i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; <a class="code" href="classExodusII__IO__Helper.php#a5323c8fc862f0933976b898fbc2428a2">side_list</a>[i] &lt;&lt; std::endl;
<a name="l00430"></a>00430     }
<a name="l00431"></a>00431 }
<a name="l00432"></a>00432 
<a name="l00433"></a>00433 
<a name="l00434"></a>00434 
<a name="l00435"></a><a class="code" href="classExodusII__IO__Helper.php#a462c7ef49bde1edaead57b7f7e932901">00435</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a462c7ef49bde1edaead57b7f7e932901">ExodusII_IO_Helper::close</a>()
<a name="l00436"></a>00436 {
<a name="l00437"></a>00437   <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a> = exII::ex_close(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>);
<a name="l00438"></a>00438   <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(<a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a>, <span class="stringliteral">&quot;Error closing Exodus file.&quot;</span>);
<a name="l00439"></a>00439   <a class="code" href="classExodusII__IO__Helper.php#a85099098d2972a91ff19be7128579b70">message</a>(<span class="stringliteral">&quot;Exodus file closed successfully.&quot;</span>); 
<a name="l00440"></a>00440 }
<a name="l00441"></a>00441 
<a name="l00442"></a><a class="code" href="classExodusII__IO__Helper.php#a55079b2750dbdbf7ea02c7118c917d28">00442</a> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper.php#a55079b2750dbdbf7ea02c7118c917d28">ExodusII_IO_Helper::inquire</a>(<span class="keywordtype">int</span> req_info, std::string error_msg)
<a name="l00443"></a>00443 {
<a name="l00444"></a>00444   <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a> = exII::ex_inquire(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>,
<a name="l00445"></a>00445                             req_info,
<a name="l00446"></a>00446                             &amp;<a class="code" href="classExodusII__IO__Helper.php#a539fcb6f02f6a3bfcfc93378c451ad7d">ret_int</a>,
<a name="l00447"></a>00447                             &amp;<a class="code" href="classExodusII__IO__Helper.php#ae78db4dd9b9859612bc2dd4b943d0afb">ret_float</a>,
<a name="l00448"></a>00448                             &amp;<a class="code" href="classExodusII__IO__Helper.php#aaf703b9deb6ce245117f4d0fb0bc9305">ret_char</a>);
<a name="l00449"></a>00449     
<a name="l00450"></a>00450   <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(<a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a>, error_msg);
<a name="l00451"></a>00451 
<a name="l00452"></a>00452   <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#a539fcb6f02f6a3bfcfc93378c451ad7d">ret_int</a>;
<a name="l00453"></a>00453 }
<a name="l00454"></a>00454 
<a name="l00455"></a><a class="code" href="classExodusII__IO__Helper.php#abf39efd05686e6303298f7268eb979c1">00455</a> <span class="keyword">const</span> std::vector&lt;double&gt;&amp; <a class="code" href="classExodusII__IO__Helper.php#abf39efd05686e6303298f7268eb979c1">ExodusII_IO_Helper::get_time_steps</a>()
<a name="l00456"></a>00456 {
<a name="l00457"></a>00457   <a class="code" href="classExodusII__IO__Helper.php#ad2837978f4ec72520cc0a9db7117ab36">time_steps</a>.resize(<a class="code" href="classExodusII__IO__Helper.php#a4a459c0bb6dcc4d06200f2682dc2ed1f">num_time_steps</a>);
<a name="l00458"></a>00458   exII::ex_get_all_times(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>, <a class="code" href="classExodusII__IO__Helper.php#ad2837978f4ec72520cc0a9db7117ab36">time_steps</a>.empty() ? NULL : &amp;<a class="code" href="classExodusII__IO__Helper.php#ad2837978f4ec72520cc0a9db7117ab36">time_steps</a>[0]);
<a name="l00459"></a>00459   <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#ad2837978f4ec72520cc0a9db7117ab36">time_steps</a>;
<a name="l00460"></a>00460 }
<a name="l00461"></a>00461 
<a name="l00462"></a>00462 
<a name="l00463"></a>00463 
<a name="l00464"></a><a class="code" href="classExodusII__IO__Helper.php#a7205e826dcb894185021892bdd574a46">00464</a> <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; <a class="code" href="classExodusII__IO__Helper.php#a7205e826dcb894185021892bdd574a46">ExodusII_IO_Helper::get_nodal_var_names</a>()
<a name="l00465"></a>00465 {
<a name="l00466"></a>00466   <span class="comment">// Allocate enough space for our variable name strings.</span>
<a name="l00467"></a>00467   <a class="code" href="classExodusII__IO__Helper.php#a6e657a9beac70f6c7aa15a08320ef5e2">nodal_var_names</a>.resize(<a class="code" href="classExodusII__IO__Helper.php#ada52eac822ab7a679227cf3a927aef74">num_nodal_vars</a>);
<a name="l00468"></a>00468     
<a name="l00469"></a>00469   <span class="comment">// Use the vvc and strings objects to emulate the behavior of</span>
<a name="l00470"></a>00470   <span class="comment">// a char** object.</span>
<a name="l00471"></a>00471   <a class="code" href="classExodusII__IO__Helper.php#addc11763636e66979ee738ffefdecf27">vvc</a>.resize(<a class="code" href="classExodusII__IO__Helper.php#ada52eac822ab7a679227cf3a927aef74">num_nodal_vars</a>);
<a name="l00472"></a>00472   <a class="code" href="classExodusII__IO__Helper.php#ac72001474c7b8e15a58d0dc2c7b33f32">strings</a>.resize(<a class="code" href="classExodusII__IO__Helper.php#ada52eac822ab7a679227cf3a927aef74">num_nodal_vars</a>);
<a name="l00473"></a>00473   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;<a class="code" href="classExodusII__IO__Helper.php#ada52eac822ab7a679227cf3a927aef74">num_nodal_vars</a>;i++)
<a name="l00474"></a>00474     <a class="code" href="classExodusII__IO__Helper.php#addc11763636e66979ee738ffefdecf27">vvc</a>[i].resize(MAX_STR_LENGTH+1);
<a name="l00475"></a>00475 
<a name="l00476"></a>00476   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;<a class="code" href="classExodusII__IO__Helper.php#ada52eac822ab7a679227cf3a927aef74">num_nodal_vars</a>;i++)
<a name="l00477"></a>00477     <a class="code" href="classExodusII__IO__Helper.php#ac72001474c7b8e15a58d0dc2c7b33f32">strings</a>[i]=&amp;(<a class="code" href="classExodusII__IO__Helper.php#addc11763636e66979ee738ffefdecf27">vvc</a>[i][0]); <span class="comment">// set pointer into vvc only *after* all resizing is complete</span>
<a name="l00478"></a>00478     
<a name="l00479"></a>00479   exII::ex_get_var_names(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>,
<a name="l00480"></a>00480                          <span class="stringliteral">&quot;n&quot;</span>,
<a name="l00481"></a>00481                          num_nodal_vars,
<a name="l00482"></a>00482                          &amp;<a class="code" href="classExodusII__IO__Helper.php#ac72001474c7b8e15a58d0dc2c7b33f32">strings</a>[0]<span class="comment">//var_names</span>
<a name="l00483"></a>00483                          );
<a name="l00484"></a>00484 
<a name="l00485"></a>00485   <span class="keywordflow">if</span> (<a class="code" href="classExodusII__IO__Helper.php#a2b09a9ee467e376882fc62e6d20aa539">_verbose</a>)
<a name="l00486"></a>00486     {
<a name="l00487"></a>00487       std::cout &lt;&lt; <span class="stringliteral">&quot;Read the variable(s) from the file:&quot;</span> &lt;&lt; std::endl;
<a name="l00488"></a>00488       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classExodusII__IO__Helper.php#ada52eac822ab7a679227cf3a927aef74">num_nodal_vars</a>; i++)
<a name="l00489"></a>00489         std::cout &lt;&lt; <span class="stringliteral">&quot;strings[&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;]=&quot;</span> &lt;&lt; <a class="code" href="classExodusII__IO__Helper.php#ac72001474c7b8e15a58d0dc2c7b33f32">strings</a>[i] &lt;&lt; std::endl;
<a name="l00490"></a>00490     }
<a name="l00491"></a>00491 
<a name="l00492"></a>00492   
<a name="l00493"></a>00493   <span class="comment">// Copy the char buffers into strings.  </span>
<a name="l00494"></a>00494   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;<a class="code" href="classExodusII__IO__Helper.php#ada52eac822ab7a679227cf3a927aef74">num_nodal_vars</a>;i++)
<a name="l00495"></a>00495     <a class="code" href="classExodusII__IO__Helper.php#a6e657a9beac70f6c7aa15a08320ef5e2">nodal_var_names</a>[i]=<a class="code" href="classExodusII__IO__Helper.php#ac72001474c7b8e15a58d0dc2c7b33f32">strings</a>[i]; <span class="comment">// calls string::op=(const char*)</span>
<a name="l00496"></a>00496 
<a name="l00497"></a>00497   
<a name="l00498"></a>00498   <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#a6e657a9beac70f6c7aa15a08320ef5e2">nodal_var_names</a>;
<a name="l00499"></a>00499 }
<a name="l00500"></a>00500 
<a name="l00501"></a>00501 
<a name="l00502"></a>00502 
<a name="l00503"></a>00503 
<a name="l00504"></a><a class="code" href="classExodusII__IO__Helper.php#ad35b6ec1c430b200cb69331455c3f252">00504</a> <span class="keyword">const</span> std::vector&lt;double&gt;&amp; <a class="code" href="classExodusII__IO__Helper.php#ad35b6ec1c430b200cb69331455c3f252">ExodusII_IO_Helper::get_nodal_var_values</a>(std::string nodal_var_name, <span class="keywordtype">int</span> time_step)
<a name="l00505"></a>00505 {
<a name="l00506"></a>00506   <a class="code" href="classExodusII__IO__Helper.php#a6339b85f37118c2dd5e73e811c429633">nodal_var_values</a>.resize(<a class="code" href="classExodusII__IO__Helper.php#a5f58455a10a22df08b2733e4b5e39aef">num_nodes</a>);
<a name="l00507"></a>00507     
<a name="l00508"></a>00508   this-&gt;<a class="code" href="classExodusII__IO__Helper.php#a7205e826dcb894185021892bdd574a46">get_nodal_var_names</a>();
<a name="l00509"></a>00509 
<a name="l00510"></a>00510   <span class="comment">//See if we can find the variable we are looking for</span>
<a name="l00511"></a>00511   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var_index = 0;
<a name="l00512"></a>00512   <span class="keywordtype">bool</span> found = <span class="keyword">false</span>;
<a name="l00513"></a>00513 
<a name="l00514"></a>00514   found = <a class="code" href="classExodusII__IO__Helper.php#a6e657a9beac70f6c7aa15a08320ef5e2">nodal_var_names</a>[var_index] == nodal_var_name;
<a name="l00515"></a>00515     
<a name="l00516"></a>00516   <span class="keywordflow">while</span>(!found &amp;&amp; var_index &lt; <a class="code" href="classExodusII__IO__Helper.php#a6e657a9beac70f6c7aa15a08320ef5e2">nodal_var_names</a>.size())
<a name="l00517"></a>00517     {
<a name="l00518"></a>00518       var_index++;
<a name="l00519"></a>00519       found = <a class="code" href="classExodusII__IO__Helper.php#a6e657a9beac70f6c7aa15a08320ef5e2">nodal_var_names</a>[var_index] == nodal_var_name;
<a name="l00520"></a>00520     }
<a name="l00521"></a>00521 
<a name="l00522"></a>00522   <span class="keywordflow">if</span>(!found)
<a name="l00523"></a>00523     {
<a name="l00524"></a>00524       std::cerr &lt;&lt; <span class="stringliteral">&quot;Unable to locate variable named: &quot;</span> &lt;&lt; nodal_var_name &lt;&lt; std::endl;
<a name="l00525"></a>00525       <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#a6339b85f37118c2dd5e73e811c429633">nodal_var_values</a>;
<a name="l00526"></a>00526     }
<a name="l00527"></a>00527 
<a name="l00528"></a>00528   exII::ex_get_nodal_var(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>, time_step, var_index+1, <a class="code" href="classExodusII__IO__Helper.php#a5f58455a10a22df08b2733e4b5e39aef">num_nodes</a>, &amp;<a class="code" href="classExodusII__IO__Helper.php#a6339b85f37118c2dd5e73e811c429633">nodal_var_values</a>[0]);
<a name="l00529"></a>00529   
<a name="l00530"></a>00530   <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#a6339b85f37118c2dd5e73e811c429633">nodal_var_values</a>;
<a name="l00531"></a>00531 }
<a name="l00532"></a>00532 
<a name="l00533"></a>00533 
<a name="l00534"></a>00534 
<a name="l00535"></a>00535 
<a name="l00536"></a>00536 <span class="comment">// For Writing Solutions</span>
<a name="l00537"></a>00537 
<a name="l00538"></a><a class="code" href="classExodusII__IO__Helper.php#af2040df8fd7a0bab0437dbec94f750c6">00538</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#af2040df8fd7a0bab0437dbec94f750c6">ExodusII_IO_Helper::create</a>(std::string filename)
<a name="l00539"></a>00539 {
<a name="l00540"></a>00540   <span class="comment">//Store things as doubles</span>
<a name="l00541"></a>00541   <a class="code" href="classExodusII__IO__Helper.php#a3466b6b8813cc1922994e8308315c61d">comp_ws</a> = 8;
<a name="l00542"></a>00542   <a class="code" href="classExodusII__IO__Helper.php#a19b8a443d7d7865cc6b390dbf9679c11">io_ws</a> = 8;
<a name="l00543"></a>00543     
<a name="l00544"></a>00544   <a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a> = exII::ex_create(filename.c_str(), EX_CLOBBER, &amp;<a class="code" href="classExodusII__IO__Helper.php#a3466b6b8813cc1922994e8308315c61d">comp_ws</a>, &amp;<a class="code" href="classExodusII__IO__Helper.php#a19b8a443d7d7865cc6b390dbf9679c11">io_ws</a>);
<a name="l00545"></a>00545     
<a name="l00546"></a>00546   <a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a> = exII::ex_open(filename.c_str(),
<a name="l00547"></a>00547                         EX_WRITE,
<a name="l00548"></a>00548                         &amp;<a class="code" href="classExodusII__IO__Helper.php#a3466b6b8813cc1922994e8308315c61d">comp_ws</a>,
<a name="l00549"></a>00549                         &amp;<a class="code" href="classExodusII__IO__Helper.php#a19b8a443d7d7865cc6b390dbf9679c11">io_ws</a>,
<a name="l00550"></a>00550                         &amp;<a class="code" href="classExodusII__IO__Helper.php#a5f322262349988a56beb178216674b04">ex_version</a>);
<a name="l00551"></a>00551   
<a name="l00552"></a>00552   <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(ex_id, <span class="stringliteral">&quot;Error creating ExodusII mesh file.&quot;</span>);
<a name="l00553"></a>00553   <span class="keywordflow">if</span> (<a class="code" href="classExodusII__IO__Helper.php#a2b09a9ee467e376882fc62e6d20aa539">_verbose</a>) std::cout &lt;&lt; <span class="stringliteral">&quot;File created successfully.&quot;</span> &lt;&lt; std::endl;
<a name="l00554"></a>00554 
<a name="l00555"></a>00555   <a class="code" href="classExodusII__IO__Helper.php#aa8f6e91509adce64436efb3c92158d61">_created</a> = <span class="keyword">true</span>;
<a name="l00556"></a>00556 }
<a name="l00557"></a>00557 
<a name="l00558"></a>00558 
<a name="l00559"></a>00559 
<a name="l00560"></a><a class="code" href="classExodusII__IO__Helper.php#a74c2b9572e8fe56e849c4003095b6495">00560</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a74c2b9572e8fe56e849c4003095b6495">ExodusII_IO_Helper::initialize</a>(std::string str_title, <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp; mesh)
<a name="l00561"></a>00561 {
<a name="l00562"></a>00562   <a class="code" href="classExodusII__IO__Helper.php#aa514ad80ba187511d8dd81cb97a6a2aa">num_dim</a> = mesh.<a class="code" href="classMeshBase.php#acaf87bde8c96b91d8f355dc9ebb72f5f">spatial_dimension</a>();
<a name="l00563"></a>00563   <a class="code" href="classExodusII__IO__Helper.php#a5f58455a10a22df08b2733e4b5e39aef">num_nodes</a> = mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>();
<a name="l00564"></a>00564   <a class="code" href="classExodusII__IO__Helper.php#a5f3697a4d820cb9b2b4f18dd3a035f12">num_elem</a> = mesh.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>();
<a name="l00565"></a>00565 
<a name="l00566"></a>00566   std::vector&lt;short int&gt; unique_side_boundaries;
<a name="l00567"></a>00567   std::vector&lt;short int&gt; unique_node_boundaries;
<a name="l00568"></a>00568 
<a name="l00569"></a>00569   mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;build_side_boundary_ids(unique_side_boundaries);
<a name="l00570"></a>00570   mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;build_node_boundary_ids(unique_node_boundaries);
<a name="l00571"></a>00571 
<a name="l00572"></a>00572   <a class="code" href="classExodusII__IO__Helper.php#a873bc78e0c49f13ce9c5853d0d806e86">num_side_sets</a> = unique_side_boundaries.size();
<a name="l00573"></a>00573   <a class="code" href="classExodusII__IO__Helper.php#a9f6bce1eed82131d3df95bf2dabd92bc">num_node_sets</a> = unique_node_boundaries.size();
<a name="l00574"></a>00574   
<a name="l00575"></a>00575   <span class="comment">//loop through element and map between block and element vector</span>
<a name="l00576"></a>00576   std::map&lt;subdomain_id_type, std::vector&lt;unsigned int&gt;  &gt; subdomain_map;
<a name="l00577"></a>00577   <span class="keywordflow">for</span>(<span class="keywordtype">int</span> i=0;i&lt;<a class="code" href="classExodusII__IO__Helper.php#a5f3697a4d820cb9b2b4f18dd3a035f12">num_elem</a>;i++)
<a name="l00578"></a>00578     {
<a name="l00579"></a>00579       <a class="code" href="classElem.php">Elem</a> * elem = mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(i);
<a name="l00580"></a>00580       <a class="code" href="classTestClass.php">subdomain_id_type</a> cur_subdomain = elem-&gt;<a class="code" href="classElem.php#acc4746605aad9169ad38cfd0b9b97123">subdomain_id</a>();
<a name="l00581"></a>00581      
<a name="l00582"></a>00582       subdomain_map[cur_subdomain].push_back(elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>());
<a name="l00583"></a>00583     }
<a name="l00584"></a>00584   <a class="code" href="classExodusII__IO__Helper.php#af8020c0bd24728e12beea02d7f6fb44c">num_elem_blk</a> = subdomain_map.size();
<a name="l00585"></a>00585 
<a name="l00586"></a>00586   std::cout&lt;&lt;<span class="stringliteral">&quot;Num elem block: &quot;</span>&lt;&lt;<a class="code" href="classExodusII__IO__Helper.php#af8020c0bd24728e12beea02d7f6fb44c">num_elem_blk</a>&lt;&lt;std::endl;
<a name="l00587"></a>00587 
<a name="l00588"></a>00588   <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a> = exII::ex_put_init(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>,
<a name="l00589"></a>00589                              str_title.c_str(),
<a name="l00590"></a>00590                              <a class="code" href="classExodusII__IO__Helper.php#aa514ad80ba187511d8dd81cb97a6a2aa">num_dim</a>,
<a name="l00591"></a>00591                              <a class="code" href="classExodusII__IO__Helper.php#a5f58455a10a22df08b2733e4b5e39aef">num_nodes</a>,
<a name="l00592"></a>00592                              <a class="code" href="classExodusII__IO__Helper.php#a5f3697a4d820cb9b2b4f18dd3a035f12">num_elem</a>,
<a name="l00593"></a>00593                              <a class="code" href="classExodusII__IO__Helper.php#af8020c0bd24728e12beea02d7f6fb44c">num_elem_blk</a>,
<a name="l00594"></a>00594                              <a class="code" href="classExodusII__IO__Helper.php#a9f6bce1eed82131d3df95bf2dabd92bc">num_node_sets</a>,
<a name="l00595"></a>00595                              <a class="code" href="classExodusII__IO__Helper.php#a873bc78e0c49f13ce9c5853d0d806e86">num_side_sets</a>);
<a name="l00596"></a>00596     
<a name="l00597"></a>00597   <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(<a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a>, <span class="stringliteral">&quot;Error initializing new Exodus file.&quot;</span>);
<a name="l00598"></a>00598 }
<a name="l00599"></a>00599 
<a name="l00600"></a><a class="code" href="classExodusII__IO__Helper.php#a3779067e84b6f238b935a0a917871c0e">00600</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a3779067e84b6f238b935a0a917871c0e">ExodusII_IO_Helper::write_nodal_coordinates</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp; mesh)
<a name="l00601"></a>00601 {
<a name="l00602"></a>00602   <a class="code" href="classExodusII__IO__Helper.php#a168332624b026270a5424916f638c0f7">x</a>.resize(<a class="code" href="classExodusII__IO__Helper.php#a5f58455a10a22df08b2733e4b5e39aef">num_nodes</a>);
<a name="l00603"></a>00603   <a class="code" href="classExodusII__IO__Helper.php#a1c72a90256cbff143f3685f97648f958">y</a>.resize(<a class="code" href="classExodusII__IO__Helper.php#a5f58455a10a22df08b2733e4b5e39aef">num_nodes</a>);
<a name="l00604"></a>00604   <a class="code" href="classExodusII__IO__Helper.php#a952624a5decb9b620eb59ffb41c948e4">z</a>.resize(<a class="code" href="classExodusII__IO__Helper.php#a5f58455a10a22df08b2733e4b5e39aef">num_nodes</a>);
<a name="l00605"></a>00605 
<a name="l00606"></a>00606   <span class="keywordflow">for</span> (<span class="comment">/* unsigned */</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classExodusII__IO__Helper.php#a5f58455a10a22df08b2733e4b5e39aef">num_nodes</a>; ++i)
<a name="l00607"></a>00607     {
<a name="l00608"></a>00608       <a class="code" href="classExodusII__IO__Helper.php#a168332624b026270a5424916f638c0f7">x</a>[i]=(*mesh.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(i))(0);
<a name="l00609"></a>00609       <a class="code" href="classExodusII__IO__Helper.php#a1c72a90256cbff143f3685f97648f958">y</a>[i]=(*mesh.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(i))(1);
<a name="l00610"></a>00610       <a class="code" href="classExodusII__IO__Helper.php#a952624a5decb9b620eb59ffb41c948e4">z</a>[i]=(*mesh.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(i))(2);
<a name="l00611"></a>00611     }
<a name="l00612"></a>00612 
<a name="l00613"></a>00613   <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a> = exII::ex_put_coord(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>,
<a name="l00614"></a>00614                               <a class="code" href="classExodusII__IO__Helper.php#a168332624b026270a5424916f638c0f7">x</a>.empty() ? NULL : &amp;<a class="code" href="classExodusII__IO__Helper.php#a168332624b026270a5424916f638c0f7">x</a>[0],
<a name="l00615"></a>00615                               <a class="code" href="classExodusII__IO__Helper.php#a1c72a90256cbff143f3685f97648f958">y</a>.empty() ? NULL : &amp;<a class="code" href="classExodusII__IO__Helper.php#a1c72a90256cbff143f3685f97648f958">y</a>[0],
<a name="l00616"></a>00616                               <a class="code" href="classExodusII__IO__Helper.php#a952624a5decb9b620eb59ffb41c948e4">z</a>.empty() ? NULL : &amp;<a class="code" href="classExodusII__IO__Helper.php#a952624a5decb9b620eb59ffb41c948e4">z</a>[0]);
<a name="l00617"></a>00617 
<a name="l00618"></a>00618   <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(<a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a>, <span class="stringliteral">&quot;Error writing coordinates to Exodus file.&quot;</span>);
<a name="l00619"></a>00619 }
<a name="l00620"></a>00620 
<a name="l00621"></a>00621 
<a name="l00622"></a>00622 
<a name="l00623"></a><a class="code" href="classExodusII__IO__Helper.php#a08434fa54c2aef8dd158630dcdd008f0">00623</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a08434fa54c2aef8dd158630dcdd008f0">ExodusII_IO_Helper::write_elements</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp; mesh)
<a name="l00624"></a>00624 {
<a name="l00625"></a>00625   std::map&lt;unsigned int, std::vector&lt;unsigned int&gt;  &gt; subdomain_map;
<a name="l00626"></a>00626   
<a name="l00627"></a>00627   <span class="comment">//loop through element and map between block and element vector</span>
<a name="l00628"></a>00628   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;static_cast&lt;unsigned int&gt;(<a class="code" href="classExodusII__IO__Helper.php#a5f3697a4d820cb9b2b4f18dd3a035f12">num_elem</a>); i++)
<a name="l00629"></a>00629     {
<a name="l00630"></a>00630       <a class="code" href="classElem.php">Elem</a> * elem = mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(i);
<a name="l00631"></a>00631 
<a name="l00632"></a>00632       <span class="comment">//Only write out the active elements</span>
<a name="l00633"></a>00633       <span class="keywordflow">if</span>(elem-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l00634"></a>00634       {
<a name="l00635"></a>00635         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cur_subdomain = elem-&gt;<a class="code" href="classElem.php#acc4746605aad9169ad38cfd0b9b97123">subdomain_id</a>();
<a name="l00636"></a>00636      
<a name="l00637"></a>00637         subdomain_map[cur_subdomain].push_back(elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>());
<a name="l00638"></a>00638       }
<a name="l00639"></a>00639     }
<a name="l00640"></a>00640 
<a name="l00641"></a>00641   std::vector&lt;int&gt; <a class="code" href="classExodusII__IO__Helper.php#ac72e1899b5ff58a2c433c4fed45877f7">elem_num_map</a>;
<a name="l00642"></a>00642 
<a name="l00643"></a>00643   std::map&lt;unsigned int, std::vector&lt;unsigned int&gt;  &gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a> it;
<a name="l00644"></a>00644   
<a name="l00645"></a>00645   <span class="keywordflow">for</span>(it = subdomain_map.begin() ; it != subdomain_map.end(); it++)
<a name="l00646"></a>00646     {
<a name="l00647"></a>00647       std::vector&lt;unsigned int&gt; &amp; tmp_vec = (*it).second;
<a name="l00648"></a>00648 
<a name="l00649"></a>00649       <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php">ExodusII_IO_Helper::ElementMaps</a> em;
<a name="l00650"></a>00650 
<a name="l00651"></a>00651       <span class="comment">//Use the first element in this block to get representative information.</span>
<a name="l00652"></a>00652       <span class="comment">//Note that Exodus assumes all elements in a block are of the same type!</span>
<a name="l00653"></a>00653       <span class="comment">//We are using that same assumption here!</span>
<a name="l00654"></a>00654       <span class="keyword">const</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">ExodusII_IO_Helper::Conversion</a> conv = em.<a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a572ac41c49e11af4a560e4a731186590">assign_conversion</a>(mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(tmp_vec[0])-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>());
<a name="l00655"></a>00655       <a class="code" href="classExodusII__IO__Helper.php#a944f1231f4dfbdafc94ac3371ae0cf0b">num_nodes_per_elem</a> = mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(tmp_vec[0])-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>();
<a name="l00656"></a>00656     
<a name="l00657"></a>00657       <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a> = exII::ex_put_elem_block(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>, (*it).first, conv.<a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#a096dfd046aac510d1468d625bc304365">exodus_elem_type</a>().c_str(), tmp_vec.size(),<a class="code" href="classExodusII__IO__Helper.php#a944f1231f4dfbdafc94ac3371ae0cf0b">num_nodes_per_elem</a>,0);
<a name="l00658"></a>00658     
<a name="l00659"></a>00659       <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(<a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a>, <span class="stringliteral">&quot;Error writing element block.&quot;</span>);
<a name="l00660"></a>00660   
<a name="l00661"></a>00661       <a class="code" href="classExodusII__IO__Helper.php#aa1399def5bca722af0eed2adcbc4cd73">connect</a>.resize(tmp_vec.size()*<a class="code" href="classExodusII__IO__Helper.php#a944f1231f4dfbdafc94ac3371ae0cf0b">num_nodes_per_elem</a>);
<a name="l00662"></a>00662 
<a name="l00663"></a>00663       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;tmp_vec.size(); i++)
<a name="l00664"></a>00664         {
<a name="l00665"></a>00665           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_id = tmp_vec[i];
<a name="l00666"></a>00666           elem_num_map.push_back(elem_id);
<a name="l00667"></a>00667           <a class="code" href="classExodusII__IO__Helper.php#ac482d48008757b2922803a62fcc36f14">libmesh_elem_num_to_exodus</a>[elem_id] = elem_num_map.size();
<a name="l00668"></a>00668           
<a name="l00669"></a>00669           <a class="code" href="classElem.php">Elem</a> * elem = mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(elem_id);
<a name="l00670"></a>00670           
<a name="l00671"></a>00671           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j &lt; static_cast&lt;unsigned int&gt;(<a class="code" href="classExodusII__IO__Helper.php#a944f1231f4dfbdafc94ac3371ae0cf0b">num_nodes_per_elem</a>); j++)
<a name="l00672"></a>00672             {  
<a name="l00673"></a>00673               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> connect_index   = (i*<a class="code" href="classExodusII__IO__Helper.php#a944f1231f4dfbdafc94ac3371ae0cf0b">num_nodes_per_elem</a>)+j;
<a name="l00674"></a>00674               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_node_index = conv.<a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#ad5ed62938325bdd443bfb24297f605a3">get_node_map</a>(j);
<a name="l00675"></a>00675               <span class="keywordflow">if</span> (<a class="code" href="classExodusII__IO__Helper.php#a2b09a9ee467e376882fc62e6d20aa539">_verbose</a>)
<a name="l00676"></a>00676                 {
<a name="l00677"></a>00677                   std::cout &lt;&lt; <span class="stringliteral">&quot;Exodus node index: &quot;</span> &lt;&lt; j
<a name="l00678"></a>00678                             &lt;&lt; <span class="stringliteral">&quot;=LibMesh node index &quot;</span> &lt;&lt; elem_node_index &lt;&lt; std::endl;
<a name="l00679"></a>00679                 }
<a name="l00680"></a>00680               <a class="code" href="classExodusII__IO__Helper.php#aa1399def5bca722af0eed2adcbc4cd73">connect</a>[connect_index] = elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(elem_node_index)+1;
<a name="l00681"></a>00681             }
<a name="l00682"></a>00682         }
<a name="l00683"></a>00683     <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a> = exII::ex_put_elem_conn(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>, (*it).first, &amp;<a class="code" href="classExodusII__IO__Helper.php#aa1399def5bca722af0eed2adcbc4cd73">connect</a>[0]);
<a name="l00684"></a>00684     <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(<a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a>, <span class="stringliteral">&quot;Error writing element connectivities&quot;</span>);
<a name="l00685"></a>00685   }
<a name="l00686"></a>00686 
<a name="l00687"></a>00687 <span class="comment">//  ex_err = exII::ex_put_elem_num_map(ex_id, &amp;elem_num_map[0]);</span>
<a name="l00688"></a>00688   <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(<a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a>, <span class="stringliteral">&quot;Error writing element connectivities&quot;</span>);
<a name="l00689"></a>00689 }
<a name="l00690"></a>00690 
<a name="l00691"></a><a class="code" href="classExodusII__IO__Helper.php#a62037f5803622a70a0c7e5cf836c971c">00691</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a62037f5803622a70a0c7e5cf836c971c">ExodusII_IO_Helper::write_sidesets</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp; mesh)
<a name="l00692"></a>00692 {
<a name="l00693"></a>00693   <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php">ExodusII_IO_Helper::ElementMaps</a> em;
<a name="l00694"></a>00694 
<a name="l00695"></a>00695   std::vector&lt; unsigned int &gt; el;
<a name="l00696"></a>00696   std::vector&lt; unsigned short int &gt; sl;
<a name="l00697"></a>00697   std::vector&lt; short int &gt; il;
<a name="l00698"></a>00698       
<a name="l00699"></a>00699   mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;build_side_list(el, sl, il);
<a name="l00700"></a>00700 
<a name="l00701"></a>00701   <span class="comment">//Maps from sideset id to the element and sides</span>
<a name="l00702"></a>00702   std::map&lt;int, std::vector&lt;int&gt; &gt; elem;
<a name="l00703"></a>00703   std::map&lt;int, std::vector&lt;int&gt; &gt; side;
<a name="l00704"></a>00704 
<a name="l00705"></a>00705   <span class="comment">//Accumulate the vectors to pass into ex_put_side_set</span>
<a name="l00706"></a>00706   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; el.size(); i++)
<a name="l00707"></a>00707   {
<a name="l00708"></a>00708     <span class="keyword">const</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">ExodusII_IO_Helper::Conversion</a> conv = em.<a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a572ac41c49e11af4a560e4a731186590">assign_conversion</a>(mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(el[i])-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>());
<a name="l00709"></a>00709 
<a name="l00710"></a>00710     elem[il[i]].push_back(el[i]+1);
<a name="l00711"></a>00711     side[il[i]].push_back(conv.<a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#afde72d2d18738a338bca50016da1d7d1">get_inverse_side_map</a>(sl[i]));    
<a name="l00712"></a>00712   }
<a name="l00713"></a>00713   
<a name="l00714"></a>00714   std::vector&lt;short int&gt; side_boundary_ids;
<a name="l00715"></a>00715   mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;build_side_boundary_ids(side_boundary_ids);
<a name="l00716"></a>00716   
<a name="l00717"></a>00717   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; side_boundary_ids.size(); i++)
<a name="l00718"></a>00718   {
<a name="l00719"></a>00719     <span class="keywordtype">int</span> ss_id = side_boundary_ids[i];
<a name="l00720"></a>00720 
<a name="l00721"></a>00721     <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a> = exII::ex_put_side_set_param(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>, ss_id, elem[ss_id].size(), 4);
<a name="l00722"></a>00722     <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(<a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a>, <span class="stringliteral">&quot;Error writing sideset parameters&quot;</span>);
<a name="l00723"></a>00723     
<a name="l00724"></a>00724     <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a> = exII::ex_put_side_set(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>, ss_id, &amp;elem[ss_id][0], &amp;side[ss_id][0]);
<a name="l00725"></a>00725     <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(<a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a>, <span class="stringliteral">&quot;Error writing sidesets&quot;</span>);
<a name="l00726"></a>00726   }
<a name="l00727"></a>00727 }
<a name="l00728"></a>00728 
<a name="l00729"></a>00729 
<a name="l00730"></a><a class="code" href="classExodusII__IO__Helper.php#a636d799fce0f1edbdf114bc368c558ac">00730</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a636d799fce0f1edbdf114bc368c558ac">ExodusII_IO_Helper::write_nodesets</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp; mesh)
<a name="l00731"></a>00731 {
<a name="l00732"></a>00732   <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php">ExodusII_IO_Helper::ElementMaps</a> em;
<a name="l00733"></a>00733 
<a name="l00734"></a>00734   std::vector&lt; unsigned int &gt; nl;
<a name="l00735"></a>00735   std::vector&lt; short int &gt; il;
<a name="l00736"></a>00736       
<a name="l00737"></a>00737   mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;build_node_list(nl, il);
<a name="l00738"></a>00738 
<a name="l00739"></a>00739   <span class="comment">//Maps from nodeset id to the nodes</span>
<a name="l00740"></a>00740   std::map&lt;short int, std::vector&lt;int&gt; &gt; node;
<a name="l00741"></a>00741 
<a name="l00742"></a>00742   <span class="comment">//Accumulate the vectors to pass into ex_put_node_set</span>
<a name="l00743"></a>00743   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; nl.size(); i++)
<a name="l00744"></a>00744     node[il[i]].push_back(nl[i]);    
<a name="l00745"></a>00745   
<a name="l00746"></a>00746   std::vector&lt;short int&gt; node_boundary_ids;
<a name="l00747"></a>00747   mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;build_node_boundary_ids(node_boundary_ids);
<a name="l00748"></a>00748   
<a name="l00749"></a>00749   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; node_boundary_ids.size(); i++)
<a name="l00750"></a>00750   {
<a name="l00751"></a>00751     <span class="keywordtype">int</span> nodeset_id = node_boundary_ids[i];
<a name="l00752"></a>00752 
<a name="l00753"></a>00753     <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a> = exII::ex_put_node_set_param(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>, nodeset_id, node[nodeset_id].size(), 0);
<a name="l00754"></a>00754     <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(<a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a>, <span class="stringliteral">&quot;Error writing nodeset parameters&quot;</span>);
<a name="l00755"></a>00755 
<a name="l00756"></a>00756     <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a> = exII::ex_put_node_set(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>, nodeset_id, &amp;node[nodeset_id][0]);
<a name="l00757"></a>00757     <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(<a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a>, <span class="stringliteral">&quot;Error writing nodesets&quot;</span>);
<a name="l00758"></a>00758   }
<a name="l00759"></a>00759 }
<a name="l00760"></a>00760 
<a name="l00761"></a>00761 
<a name="l00762"></a><a class="code" href="classExodusII__IO__Helper.php#aaa7f63ddf6f23522b56fe72b63167d2f">00762</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#aaa7f63ddf6f23522b56fe72b63167d2f">ExodusII_IO_Helper::initialize_nodal_variables</a>(std::vector&lt;std::string&gt; names)
<a name="l00763"></a>00763 {
<a name="l00764"></a>00764   <a class="code" href="classExodusII__IO__Helper.php#ada52eac822ab7a679227cf3a927aef74">num_nodal_vars</a> = names.size();
<a name="l00765"></a>00765 
<a name="l00766"></a>00766   <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a> = exII::ex_put_var_param(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>, <span class="stringliteral">&quot;n&quot;</span>, <a class="code" href="classExodusII__IO__Helper.php#ada52eac822ab7a679227cf3a927aef74">num_nodal_vars</a>);
<a name="l00767"></a>00767   <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(<a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a>, <span class="stringliteral">&quot;Error setting number of nodal vars.&quot;</span>);
<a name="l00768"></a>00768 
<a name="l00769"></a>00769   <span class="comment">// Use the vvc and strings objects to emulate the behavior of</span>
<a name="l00770"></a>00770   <span class="comment">// a char** object.</span>
<a name="l00771"></a>00771   <a class="code" href="classExodusII__IO__Helper.php#addc11763636e66979ee738ffefdecf27">vvc</a>.resize(<a class="code" href="classExodusII__IO__Helper.php#ada52eac822ab7a679227cf3a927aef74">num_nodal_vars</a>);
<a name="l00772"></a>00772   <a class="code" href="classExodusII__IO__Helper.php#ac72001474c7b8e15a58d0dc2c7b33f32">strings</a>.resize(<a class="code" href="classExodusII__IO__Helper.php#ada52eac822ab7a679227cf3a927aef74">num_nodal_vars</a>);
<a name="l00773"></a>00773 
<a name="l00774"></a>00774   <span class="comment">// For each string in names, allocate enough space in vvc and copy from</span>
<a name="l00775"></a>00775   <span class="comment">// the C++ string into vvc for passing to the C interface.</span>
<a name="l00776"></a>00776   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classExodusII__IO__Helper.php#ada52eac822ab7a679227cf3a927aef74">num_nodal_vars</a>; i++)
<a name="l00777"></a>00777     {
<a name="l00778"></a>00778       <a class="code" href="classExodusII__IO__Helper.php#addc11763636e66979ee738ffefdecf27">vvc</a>[i].resize(names[i].size()+1);
<a name="l00779"></a>00779       std::strcpy(&amp;(<a class="code" href="classExodusII__IO__Helper.php#addc11763636e66979ee738ffefdecf27">vvc</a>[i][0]), names[i].c_str());
<a name="l00780"></a>00780     }
<a name="l00781"></a>00781 
<a name="l00782"></a>00782   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classExodusII__IO__Helper.php#ada52eac822ab7a679227cf3a927aef74">num_nodal_vars</a>; i++)
<a name="l00783"></a>00783     <a class="code" href="classExodusII__IO__Helper.php#ac72001474c7b8e15a58d0dc2c7b33f32">strings</a>[i] = &amp;(<a class="code" href="classExodusII__IO__Helper.php#addc11763636e66979ee738ffefdecf27">vvc</a>[i][0]); <span class="comment">// set pointer into vvc only *after* all resizing is complete</span>
<a name="l00784"></a>00784 
<a name="l00785"></a>00785   <span class="keywordflow">if</span> (<a class="code" href="classExodusII__IO__Helper.php#a2b09a9ee467e376882fc62e6d20aa539">_verbose</a>)
<a name="l00786"></a>00786     {
<a name="l00787"></a>00787       std::cout &lt;&lt; <span class="stringliteral">&quot;Writing variable name(s) to file: &quot;</span> &lt;&lt; std::endl;
<a name="l00788"></a>00788       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;<a class="code" href="classExodusII__IO__Helper.php#ada52eac822ab7a679227cf3a927aef74">num_nodal_vars</a>;i++)
<a name="l00789"></a>00789         std::cout &lt;&lt; <span class="stringliteral">&quot;strings[&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;]=&quot;</span> &lt;&lt; <a class="code" href="classExodusII__IO__Helper.php#ac72001474c7b8e15a58d0dc2c7b33f32">strings</a>[i] &lt;&lt; std::endl;
<a name="l00790"></a>00790     }
<a name="l00791"></a>00791     
<a name="l00792"></a>00792   <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a> = exII::ex_put_var_names(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>,
<a name="l00793"></a>00793                                   <span class="stringliteral">&quot;n&quot;</span>,
<a name="l00794"></a>00794                                   num_nodal_vars,
<a name="l00795"></a>00795                                   &amp;<a class="code" href="classExodusII__IO__Helper.php#ac72001474c7b8e15a58d0dc2c7b33f32">strings</a>[0]<span class="comment">//var_names</span>
<a name="l00796"></a>00796                                   );
<a name="l00797"></a>00797     
<a name="l00798"></a>00798   <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(<a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a>, <span class="stringliteral">&quot;Error setting nodal variable names.&quot;</span>);
<a name="l00799"></a>00799 }
<a name="l00800"></a>00800 
<a name="l00801"></a>00801 
<a name="l00802"></a>00802 
<a name="l00803"></a><a class="code" href="classExodusII__IO__Helper.php#a1c32bbd0b8d72eac0809bab8549d9ff7">00803</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a1c32bbd0b8d72eac0809bab8549d9ff7">ExodusII_IO_Helper::write_timestep</a>(<span class="keywordtype">int</span> timestep, <span class="keywordtype">double</span> time)
<a name="l00804"></a>00804 {
<a name="l00805"></a>00805   <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a> = exII::ex_put_time(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>, timestep, &amp;time);
<a name="l00806"></a>00806   <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(<a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a>, <span class="stringliteral">&quot;Error writing timestep.&quot;</span>);
<a name="l00807"></a>00807 }
<a name="l00808"></a>00808 
<a name="l00809"></a>00809 
<a name="l00810"></a>00810 
<a name="l00811"></a><a class="code" href="classExodusII__IO__Helper.php#ab5181082ac9f4d72f1feda8b0a6fcdad">00811</a> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#ab5181082ac9f4d72f1feda8b0a6fcdad">ExodusII_IO_Helper::write_nodal_values</a>(<span class="keywordtype">int</span> var_id, <span class="keyword">const</span> std::vector&lt;Number&gt; &amp; values, <span class="keywordtype">int</span> timestep)
<a name="l00812"></a>00812 {
<a name="l00813"></a>00813   <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a> = exII::ex_put_nodal_var(<a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>, timestep, var_id, <a class="code" href="classExodusII__IO__Helper.php#a5f58455a10a22df08b2733e4b5e39aef">num_nodes</a>, &amp;values[0]);
<a name="l00814"></a>00814   <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(<a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a>, <span class="stringliteral">&quot;Error writing nodal values.&quot;</span>);
<a name="l00815"></a>00815 }  
<a name="l00816"></a>00816 
<a name="l00817"></a>00817 
<a name="l00818"></a>00818 
<a name="l00819"></a><a class="code" href="classExodusII__IO__Helper.php#a5349c806da1104e3470c039140757c4f">00819</a> <span class="keywordtype">bool</span> <a class="code" href="classExodusII__IO__Helper.php#a5349c806da1104e3470c039140757c4f">ExodusII_IO_Helper::created</a>()
<a name="l00820"></a>00820 {
<a name="l00821"></a>00821   <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#aa8f6e91509adce64436efb3c92158d61">_created</a>;
<a name="l00822"></a>00822 }
<a name="l00823"></a>00823 
<a name="l00824"></a>00824 
<a name="l00825"></a>00825 
<a name="l00826"></a>00826 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00827"></a>00827 <span class="comment">// ExodusII_IO_Helper::Conversion class members</span>
<a name="l00828"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a572ac41c49e11af4a560e4a731186590">00828</a> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">ExodusII_IO_Helper::Conversion</a> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a572ac41c49e11af4a560e4a731186590">ExodusII_IO_Helper::ElementMaps::assign_conversion</a>(<span class="keyword">const</span> std::string type_str)
<a name="l00829"></a>00829 {
<a name="l00830"></a>00830   <span class="comment">// ExodusII defines the following types in contrib/exodusii/Lib/include/exodusII_int.h</span>
<a name="l00831"></a>00831   <span class="comment">// UNK         =  -1     </span>
<a name="l00832"></a>00832   <span class="comment">// NULL_ELEMENT=   0     </span>
<a name="l00833"></a>00833   <span class="comment">// TRIANGLE    =   1     </span>
<a name="l00834"></a>00834   <span class="comment">// QUAD        =   2     </span>
<a name="l00835"></a>00835   <span class="comment">// HEX         =   3     </span>
<a name="l00836"></a>00836   <span class="comment">// WEDGE       =   4     </span>
<a name="l00837"></a>00837   <span class="comment">// TETRA       =   5     </span>
<a name="l00838"></a>00838   <span class="comment">// TRUSS       =   6     </span>
<a name="l00839"></a>00839   <span class="comment">// BEAM        =   7     </span>
<a name="l00840"></a>00840   <span class="comment">// SHELL       =   8     </span>
<a name="l00841"></a>00841   <span class="comment">// SPHERE      =   9     </span>
<a name="l00842"></a>00842   <span class="comment">// CIRCLE      =  10     </span>
<a name="l00843"></a>00843   <span class="comment">// TRISHELL    =  11     </span>
<a name="l00844"></a>00844   <span class="comment">// PYRAMID     =  12      </span>
<a name="l00845"></a>00845   
<a name="l00846"></a>00846   <span class="keywordflow">if</span> ((type_str == <span class="stringliteral">&quot;QUAD4&quot;</span>) || (type_str == <span class="stringliteral">&quot;QUAD&quot;</span>) || (type_str == <span class="stringliteral">&quot;quad&quot;</span>))
<a name="l00847"></a>00847     <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a572ac41c49e11af4a560e4a731186590">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>);
<a name="l00848"></a>00848 
<a name="l00849"></a>00849   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type_str == <span class="stringliteral">&quot;QUAD8&quot;</span>)
<a name="l00850"></a>00850     <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a572ac41c49e11af4a560e4a731186590">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>);
<a name="l00851"></a>00851 
<a name="l00852"></a>00852   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type_str == <span class="stringliteral">&quot;QUAD9&quot;</span>)
<a name="l00853"></a>00853     <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a572ac41c49e11af4a560e4a731186590">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>);
<a name="l00854"></a>00854 
<a name="l00855"></a>00855   <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((type_str == <span class="stringliteral">&quot;TRI3&quot;</span>) || (type_str == <span class="stringliteral">&quot;TRIANGLE&quot;</span>) || (type_str == <span class="stringliteral">&quot;TRI&quot;</span>) || (type_str == <span class="stringliteral">&quot;tri&quot;</span>))
<a name="l00856"></a>00856     <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a572ac41c49e11af4a560e4a731186590">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>);
<a name="l00857"></a>00857 
<a name="l00858"></a>00858   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type_str == <span class="stringliteral">&quot;TRI6&quot;</span>)
<a name="l00859"></a>00859     <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a572ac41c49e11af4a560e4a731186590">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>);
<a name="l00860"></a>00860 
<a name="l00861"></a>00861   <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((type_str == <span class="stringliteral">&quot;HEX8&quot;</span>) || (type_str == <span class="stringliteral">&quot;HEX&quot;</span>) || (type_str==<span class="stringliteral">&quot;hex8&quot;</span>)) 
<a name="l00862"></a>00862     <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a572ac41c49e11af4a560e4a731186590">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>);
<a name="l00863"></a>00863 
<a name="l00864"></a>00864   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type_str == <span class="stringliteral">&quot;HEX20&quot;</span>)
<a name="l00865"></a>00865     <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a572ac41c49e11af4a560e4a731186590">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>);
<a name="l00866"></a>00866 
<a name="l00867"></a>00867   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type_str == <span class="stringliteral">&quot;HEX27&quot;</span>)
<a name="l00868"></a>00868     <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a572ac41c49e11af4a560e4a731186590">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>);
<a name="l00869"></a>00869 
<a name="l00870"></a>00870   <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((type_str == <span class="stringliteral">&quot;TETRA4&quot;</span>) || (type_str == <span class="stringliteral">&quot;TETRA&quot;</span>))
<a name="l00871"></a>00871     <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a572ac41c49e11af4a560e4a731186590">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>);
<a name="l00872"></a>00872 
<a name="l00873"></a>00873   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type_str == <span class="stringliteral">&quot;TETRA10&quot;</span>)
<a name="l00874"></a>00874     <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a572ac41c49e11af4a560e4a731186590">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>);
<a name="l00875"></a>00875 
<a name="l00876"></a>00876   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type_str == <span class="stringliteral">&quot;WEDGE&quot;</span>)
<a name="l00877"></a>00877     <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a572ac41c49e11af4a560e4a731186590">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>);
<a name="l00878"></a>00878 
<a name="l00879"></a>00879   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type_str == <span class="stringliteral">&quot;WEDGE15&quot;</span>)
<a name="l00880"></a>00880     <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a572ac41c49e11af4a560e4a731186590">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>);
<a name="l00881"></a>00881 
<a name="l00882"></a>00882   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type_str == <span class="stringliteral">&quot;WEDGE18&quot;</span>)
<a name="l00883"></a>00883     <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a572ac41c49e11af4a560e4a731186590">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>);
<a name="l00884"></a>00884 
<a name="l00885"></a>00885   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type_str == <span class="stringliteral">&quot;PYRAMID&quot;</span> || type_str == <span class="stringliteral">&quot;PYRAMID5&quot;</span>)
<a name="l00886"></a>00886     <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a572ac41c49e11af4a560e4a731186590">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>);
<a name="l00887"></a>00887 
<a name="l00888"></a>00888   <span class="keywordflow">else</span>
<a name="l00889"></a>00889     {
<a name="l00890"></a>00890       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR! Unrecognized element type_str: &quot;</span> &lt;&lt; type_str &lt;&lt; std::endl;
<a name="l00891"></a>00891       libmesh_error();
<a name="l00892"></a>00892     }
<a name="l00893"></a>00893 
<a name="l00894"></a>00894   libmesh_error();
<a name="l00895"></a>00895   
<a name="l00896"></a>00896   <span class="keyword">const</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(<a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a36a35c18b1f25c0434786afa4b76fe3e">tri3_node_map</a>, <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a733d1fd7a1e39f01d87a6efb7126a07a">tri_edge_map</a>, <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a219a0c2529b2d4ed2673a5ffb02d821b">tri_inverse_edge_map</a>, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>,<span class="stringliteral">&quot;TRI3&quot;</span>); <span class="comment">// dummy</span>
<a name="l00897"></a>00897   <span class="keywordflow">return</span> conv;  
<a name="l00898"></a>00898 }
<a name="l00899"></a>00899 
<a name="l00900"></a>00900 
<a name="l00901"></a>00901 
<a name="l00902"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#ad59f0c67aadc2052447fd334ae9225e3">00902</a> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">ExodusII_IO_Helper::Conversion</a> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a572ac41c49e11af4a560e4a731186590">ExodusII_IO_Helper::ElementMaps::assign_conversion</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)
<a name="l00903"></a>00903 {
<a name="l00904"></a>00904   <span class="keywordflow">switch</span> (type)
<a name="l00905"></a>00905     {
<a name="l00906"></a>00906 
<a name="l00907"></a>00907     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l00908"></a>00908       {
<a name="l00909"></a>00909         <span class="keyword">const</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(quad4_node_map, quad_edge_map, quad_inverse_edge_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>, <span class="stringliteral">&quot;QUAD4&quot;</span>);
<a name="l00910"></a>00910         <span class="keywordflow">return</span> conv;
<a name="l00911"></a>00911       }
<a name="l00912"></a>00912 
<a name="l00913"></a>00913     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00914"></a>00914       {
<a name="l00915"></a>00915         <span class="keyword">const</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(quad8_node_map, quad_edge_map, quad_inverse_edge_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>, <span class="stringliteral">&quot;QUAD8&quot;</span>);
<a name="l00916"></a>00916         <span class="keywordflow">return</span> conv;
<a name="l00917"></a>00917       }
<a name="l00918"></a>00918       
<a name="l00919"></a>00919     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00920"></a>00920       {
<a name="l00921"></a>00921         <span class="keyword">const</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(quad9_node_map, quad_edge_map, quad_inverse_edge_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>, <span class="stringliteral">&quot;QUAD9&quot;</span>);
<a name="l00922"></a>00922         <span class="keywordflow">return</span> conv;
<a name="l00923"></a>00923       }
<a name="l00924"></a>00924       
<a name="l00925"></a>00925     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00926"></a>00926       {
<a name="l00927"></a>00927         <span class="keyword">const</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(tri3_node_map, tri_edge_map, tri_inverse_edge_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>, <span class="stringliteral">&quot;TRI3&quot;</span>);
<a name="l00928"></a>00928         <span class="keywordflow">return</span> conv;
<a name="l00929"></a>00929       }
<a name="l00930"></a>00930       
<a name="l00931"></a>00931     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00932"></a>00932       {
<a name="l00933"></a>00933         <span class="keyword">const</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(tri6_node_map, tri_edge_map, tri_inverse_edge_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>, <span class="stringliteral">&quot;TRI6&quot;</span>);
<a name="l00934"></a>00934         <span class="keywordflow">return</span> conv;
<a name="l00935"></a>00935       }
<a name="l00936"></a>00936       
<a name="l00937"></a>00937     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00938"></a>00938       {
<a name="l00939"></a>00939         <span class="keyword">const</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(hex8_node_map, hex_face_map, hex_inverse_face_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>, <span class="stringliteral">&quot;HEX8&quot;</span>);
<a name="l00940"></a>00940         <span class="keywordflow">return</span> conv;
<a name="l00941"></a>00941       }
<a name="l00942"></a>00942       
<a name="l00943"></a>00943     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00944"></a>00944       {
<a name="l00945"></a>00945         <span class="keyword">const</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(hex20_node_map, hex_face_map, hex_inverse_face_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>, <span class="stringliteral">&quot;HEX20&quot;</span>);
<a name="l00946"></a>00946         <span class="keywordflow">return</span> conv;
<a name="l00947"></a>00947       }
<a name="l00948"></a>00948       
<a name="l00949"></a>00949     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00950"></a>00950       {
<a name="l00951"></a>00951         <span class="keyword">const</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(hex27_node_map, hex27_face_map, hex27_inverse_face_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>, <span class="stringliteral">&quot;HEX27&quot;</span>);
<a name="l00952"></a>00952         <span class="keywordflow">return</span> conv;
<a name="l00953"></a>00953       }
<a name="l00954"></a>00954       
<a name="l00955"></a>00955     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l00956"></a>00956       {
<a name="l00957"></a>00957         <span class="keyword">const</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(tet4_node_map, tet_face_map, tet_inverse_face_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>, <span class="stringliteral">&quot;TETRA4&quot;</span>);
<a name="l00958"></a>00958         <span class="keywordflow">return</span> conv;
<a name="l00959"></a>00959       }
<a name="l00960"></a>00960       
<a name="l00961"></a>00961     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l00962"></a>00962       {
<a name="l00963"></a>00963         <span class="keyword">const</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(tet10_node_map, tet_face_map, tet_inverse_face_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>, <span class="stringliteral">&quot;TETRA10&quot;</span>);
<a name="l00964"></a>00964         <span class="keywordflow">return</span> conv;
<a name="l00965"></a>00965       }
<a name="l00966"></a>00966 
<a name="l00967"></a>00967     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l00968"></a>00968       {
<a name="l00969"></a>00969         <span class="keyword">const</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(prism6_node_map, prism_face_map, prism_inverse_face_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>, <span class="stringliteral">&quot;WEDGE&quot;</span>);
<a name="l00970"></a>00970         <span class="keywordflow">return</span> conv;
<a name="l00971"></a>00971       }
<a name="l00972"></a>00972 
<a name="l00973"></a>00973     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l00974"></a>00974       {
<a name="l00975"></a>00975         <span class="keyword">const</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(prism15_node_map, prism_face_map, prism_inverse_face_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>, <span class="stringliteral">&quot;WEDGE15&quot;</span>);
<a name="l00976"></a>00976         <span class="keywordflow">return</span> conv;
<a name="l00977"></a>00977       }
<a name="l00978"></a>00978 
<a name="l00979"></a>00979     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l00980"></a>00980       {
<a name="l00981"></a>00981         <span class="keyword">const</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(prism18_node_map, prism_face_map, prism_inverse_face_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>, <span class="stringliteral">&quot;WEDGE18&quot;</span>);
<a name="l00982"></a>00982         <span class="keywordflow">return</span> conv;
<a name="l00983"></a>00983       }
<a name="l00984"></a>00984 
<a name="l00985"></a>00985     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l00986"></a>00986       {
<a name="l00987"></a>00987         <span class="keyword">const</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(pyramid5_node_map, pyramid_face_map, pyramid_inverse_face_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>, <span class="stringliteral">&quot;PYRAMID5&quot;</span>);
<a name="l00988"></a>00988         <span class="keywordflow">return</span> conv;
<a name="l00989"></a>00989       }
<a name="l00990"></a>00990         
<a name="l00991"></a>00991     <span class="keywordflow">default</span>:
<a name="l00992"></a>00992       libmesh_error();
<a name="l00993"></a>00993     }
<a name="l00994"></a>00994     
<a name="l00995"></a>00995   libmesh_error();
<a name="l00996"></a>00996     
<a name="l00997"></a>00997   <span class="keyword">const</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(tri3_node_map, tri_edge_map, tri_inverse_edge_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>, <span class="stringliteral">&quot;TRI3&quot;</span>); <span class="comment">// dummy</span>
<a name="l00998"></a>00998   <span class="keywordflow">return</span> conv;  
<a name="l00999"></a>00999 }
<a name="l01000"></a>01000 
<a name="l01001"></a>01001 
<a name="l01002"></a>01002 
<a name="l01003"></a>01003 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_EXODUS_API</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
