<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>exodusII_io_helper.h</h1>  </div>
</div>
<div class="contents">
<a href="exodusII__io__helper_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: exodusII_io_helper.h 3462 2009-09-15 17:00:11Z friedmud $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __exodusII_io_helper_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __exodusII_io_helper_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="preprocessor">#ifdef LIBMESH_HAVE_EXODUS_API</span>
<a name="l00026"></a>00026 <span class="preprocessor"></span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a><a class="code" href="namespaceexII.php">00033</a> <span class="keyword">namespace </span>exII {
<a name="l00034"></a>00034   <span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;exodusII.h&quot;</span> <span class="comment">// defines MAX_LINE_LENGTH, MAX_STR_LENGTH used later</span>
<a name="l00036"></a>00036   }
<a name="l00037"></a>00037 }
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00046"></a><a class="code" href="classExodusII__IO__Helper.php">00046</a> <span class="keyword">class </span><a class="code" href="classExodusII__IO__Helper.php">ExodusII_IO_Helper</a>
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048 <span class="keyword">public</span>:
<a name="l00049"></a>00049 
<a name="l00055"></a><a class="code" href="classExodusII__IO__Helper.php#a0924f22d6f5ed5b7c172134193ce46a6">00055</a>   <a class="code" href="classExodusII__IO__Helper.php#a0924f22d6f5ed5b7c172134193ce46a6">ExodusII_IO_Helper</a>(<span class="keywordtype">bool</span> v=<span class="keyword">false</span>) : 
<a name="l00056"></a>00056     <a class="code" href="classExodusII__IO__Helper.php#a3466b6b8813cc1922994e8308315c61d">comp_ws</a>(sizeof(double)),
<a name="l00057"></a>00057     <a class="code" href="classExodusII__IO__Helper.php#a19b8a443d7d7865cc6b390dbf9679c11">io_ws</a>(0),
<a name="l00058"></a>00058     <a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>(0),
<a name="l00059"></a>00059     <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a>(0),
<a name="l00060"></a>00060     <a class="code" href="classExodusII__IO__Helper.php#aa514ad80ba187511d8dd81cb97a6a2aa">num_dim</a>(0),
<a name="l00061"></a>00061     <a class="code" href="classExodusII__IO__Helper.php#a5f58455a10a22df08b2733e4b5e39aef">num_nodes</a>(0),
<a name="l00062"></a>00062     <a class="code" href="classExodusII__IO__Helper.php#a5f3697a4d820cb9b2b4f18dd3a035f12">num_elem</a>(0),
<a name="l00063"></a>00063     <a class="code" href="classExodusII__IO__Helper.php#af8020c0bd24728e12beea02d7f6fb44c">num_elem_blk</a>(0),
<a name="l00064"></a>00064     <a class="code" href="classExodusII__IO__Helper.php#a9f6bce1eed82131d3df95bf2dabd92bc">num_node_sets</a>(0),
<a name="l00065"></a>00065     <a class="code" href="classExodusII__IO__Helper.php#a873bc78e0c49f13ce9c5853d0d806e86">num_side_sets</a>(0),
<a name="l00066"></a>00066     <a class="code" href="classExodusII__IO__Helper.php#a856f2a0dc5850f1957a2072ef1ce2e5f">num_elem_this_blk</a>(0),
<a name="l00067"></a>00067     <a class="code" href="classExodusII__IO__Helper.php#a944f1231f4dfbdafc94ac3371ae0cf0b">num_nodes_per_elem</a>(0),
<a name="l00068"></a>00068     <a class="code" href="classExodusII__IO__Helper.php#a314b2dc9e24c82945a534f3adefe077d">num_attr</a>(0),
<a name="l00069"></a>00069     <a class="code" href="classExodusII__IO__Helper.php#a7e318ac727f824a86a20348f19975c41">req_info</a>(0),
<a name="l00070"></a>00070     <a class="code" href="classExodusII__IO__Helper.php#a539fcb6f02f6a3bfcfc93378c451ad7d">ret_int</a>(0),
<a name="l00071"></a>00071     <a class="code" href="classExodusII__IO__Helper.php#a26ec622cfba94e10bb0670d874b77732">num_elem_all_sidesets</a>(0),
<a name="l00072"></a>00072     <a class="code" href="classExodusII__IO__Helper.php#a5f322262349988a56beb178216674b04">ex_version</a>(0.0),
<a name="l00073"></a>00073     <a class="code" href="classExodusII__IO__Helper.php#ae78db4dd9b9859612bc2dd4b943d0afb">ret_float</a>(0.0),
<a name="l00074"></a>00074     <a class="code" href="classExodusII__IO__Helper.php#aaf703b9deb6ce245117f4d0fb0bc9305">ret_char</a>(0),
<a name="l00075"></a>00075     <a class="code" href="classExodusII__IO__Helper.php#a4a459c0bb6dcc4d06200f2682dc2ed1f">num_time_steps</a>(0),
<a name="l00076"></a>00076     <a class="code" href="classExodusII__IO__Helper.php#aa8f6e91509adce64436efb3c92158d61">_created</a>(false),
<a name="l00077"></a>00077     <a class="code" href="classExodusII__IO__Helper.php#a2b09a9ee467e376882fc62e6d20aa539">_verbose</a>(v)
<a name="l00078"></a>00078 
<a name="l00079"></a>00079   {
<a name="l00080"></a>00080     <a class="code" href="classExodusII__IO__Helper.php#a2b14ab70ad213522ee14e81d71530e5d">title</a>.resize(MAX_LINE_LENGTH+1);
<a name="l00081"></a>00081     <a class="code" href="classExodusII__IO__Helper.php#a63b094665cd526058573859ea7ec7a9f">elem_type</a>.resize(MAX_STR_LENGTH);
<a name="l00082"></a>00082   }
<a name="l00083"></a>00083 
<a name="l00090"></a>00090   <span class="keyword">virtual</span> <a class="code" href="classExodusII__IO__Helper.php#a6bfdbf5cc31e63601cd8787f8ea96b78">~ExodusII_IO_Helper</a>();
<a name="l00091"></a>00091 
<a name="l00096"></a>00096   <span class="keywordtype">bool</span> <a class="code" href="classExodusII__IO__Helper.php#a5349c806da1104e3470c039140757c4f">created</a>();
<a name="l00097"></a>00097   
<a name="l00101"></a>00101   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a90ab6ea1557ee6785027f28eee726836">verbose</a> (<span class="keywordtype">bool</span> set_verbosity);
<a name="l00102"></a>00102   
<a name="l00107"></a><a class="code" href="classExodusII__IO__Helper.php#a01b5190a7b7a18212628ddd56c75d08d">00107</a>   <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper.php#a01b5190a7b7a18212628ddd56c75d08d">get_num_dim</a>()<span class="keyword">                const </span>{ <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#aa514ad80ba187511d8dd81cb97a6a2aa">num_dim</a>; }
<a name="l00108"></a>00108 
<a name="l00113"></a><a class="code" href="classExodusII__IO__Helper.php#a5591987a38e4e478474f0ed50169de42">00113</a>   <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper.php#a5591987a38e4e478474f0ed50169de42">get_num_nodes</a>()<span class="keyword">              const </span>{ <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#a5f58455a10a22df08b2733e4b5e39aef">num_nodes</a>; }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   
<a name="l00120"></a><a class="code" href="classExodusII__IO__Helper.php#a961c0dc9cc1b7d2eccdb5b1f24e27a97">00120</a>   <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper.php#a961c0dc9cc1b7d2eccdb5b1f24e27a97">get_num_elem</a>()<span class="keyword">               const </span>{ <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#a5f3697a4d820cb9b2b4f18dd3a035f12">num_elem</a>; }
<a name="l00121"></a>00121 
<a name="l00127"></a><a class="code" href="classExodusII__IO__Helper.php#acd40cd9f9ad82b932fd2b691845c5778">00127</a>   <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper.php#acd40cd9f9ad82b932fd2b691845c5778">get_num_elem_blk</a>()<span class="keyword">           const </span>{ <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#af8020c0bd24728e12beea02d7f6fb44c">num_elem_blk</a>; }
<a name="l00128"></a>00128 
<a name="l00134"></a><a class="code" href="classExodusII__IO__Helper.php#a8dc14619b9c4381b9a8dacac29c68558">00134</a>   <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper.php#a8dc14619b9c4381b9a8dacac29c68558">get_num_elem_this_blk</a>()<span class="keyword">      const </span>{ <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#a856f2a0dc5850f1957a2072ef1ce2e5f">num_elem_this_blk</a>; }
<a name="l00135"></a>00135 
<a name="l00142"></a><a class="code" href="classExodusII__IO__Helper.php#a18880e0c3ff0385f14329e2f14b6b24b">00142</a>   <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper.php#a18880e0c3ff0385f14329e2f14b6b24b">get_num_nodes_per_elem</a>()<span class="keyword">     const </span>{ <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#a944f1231f4dfbdafc94ac3371ae0cf0b">num_nodes_per_elem</a>; }
<a name="l00143"></a>00143 
<a name="l00150"></a><a class="code" href="classExodusII__IO__Helper.php#a4eea4e8654ab2d2dfc55ae00e392c7b7">00150</a>   <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper.php#a4eea4e8654ab2d2dfc55ae00e392c7b7">get_num_side_sets</a>()<span class="keyword">          const </span>{ <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#a873bc78e0c49f13ce9c5853d0d806e86">num_side_sets</a>; }
<a name="l00151"></a>00151 
<a name="l00157"></a><a class="code" href="classExodusII__IO__Helper.php#aa68cb4e747d7943cf7edad365eafd493">00157</a>   <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper.php#aa68cb4e747d7943cf7edad365eafd493">get_num_node_sets</a>()<span class="keyword">          const </span>{ <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#a9f6bce1eed82131d3df95bf2dabd92bc">num_node_sets</a>; }
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   <span class="comment">//     /**</span>
<a name="l00160"></a>00160   <span class="comment">//      * @returns the number of</span>
<a name="l00161"></a>00161   <span class="comment">//      * elements in all the sidesets.</span>
<a name="l00162"></a>00162   <span class="comment">//      * Effectively returns the</span>
<a name="l00163"></a>00163   <span class="comment">//      * total number of elements</span>
<a name="l00164"></a>00164   <span class="comment">//      * on the \p ExodusII mesh boundary.</span>
<a name="l00165"></a>00165   <span class="comment">//      */</span>
<a name="l00166"></a>00166   <span class="comment">//     int get_num_elem_all_sidesets()  const { return num_elem_all_sidesets; }</span>
<a name="l00167"></a>00167 
<a name="l00174"></a><a class="code" href="classExodusII__IO__Helper.php#a19bc630eb8a5cbedf035bfd44f03dac6">00174</a>   <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper.php#a19bc630eb8a5cbedf035bfd44f03dac6">get_connect</a>(<span class="keywordtype">int</span> i)<span class="keyword">           const </span>{ <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#aa1399def5bca722af0eed2adcbc4cd73">connect</a>[i]; }
<a name="l00175"></a>00175 
<a name="l00181"></a><a class="code" href="classExodusII__IO__Helper.php#a9b94c7908a54cb1d3a072e16d0c1443c">00181</a>   <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper.php#a9b94c7908a54cb1d3a072e16d0c1443c">get_num_sides_per_set</a>(<span class="keywordtype">int</span> i)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#a7b09767c31d40dda95f53f71d8429a02">num_sides_per_set</a>[i]; }
<a name="l00182"></a>00182   
<a name="l00188"></a><a class="code" href="classExodusII__IO__Helper.php#a77d437c27c044e153b0e1cd6b97d6fba">00188</a>   <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper.php#a77d437c27c044e153b0e1cd6b97d6fba">get_num_nodes_per_set</a>(<span class="keywordtype">int</span> i)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#aa4733dda048befbcebf8f3ac4046c09f">num_nodes_per_set</a>[i]; }
<a name="l00189"></a>00189 
<a name="l00190"></a>00190   <span class="comment">//     /**</span>
<a name="l00191"></a>00191   <span class="comment">//      * @returns the \f$ i^{th} \f$ entry</span>
<a name="l00192"></a>00192   <span class="comment">//      * in the element list.</span>
<a name="l00193"></a>00193   <span class="comment">//      * The element list contains</span>
<a name="l00194"></a>00194   <span class="comment">//      * the numbers of all elements</span>
<a name="l00195"></a>00195   <span class="comment">//      * on the boundary.</span>
<a name="l00196"></a>00196   <span class="comment">//      */</span>
<a name="l00197"></a>00197   <span class="comment">//     int get_elem_list(int i)         const { return elem_list[i]; }</span>
<a name="l00198"></a>00198 
<a name="l00202"></a><a class="code" href="classExodusII__IO__Helper.php#af50336b6ea80997d5a26969737f87437">00202</a>   <span class="keyword">const</span> std::vector&lt;int&gt;&amp; <a class="code" href="classExodusII__IO__Helper.php#af50336b6ea80997d5a26969737f87437">get_elem_list</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#a15aec6a71e5aa0b3ce8973148e089502">elem_list</a>; }
<a name="l00203"></a>00203   
<a name="l00204"></a>00204   <span class="comment">//     /**</span>
<a name="l00205"></a>00205   <span class="comment">//      * @returns the \f$ i^{th} \f$ entry in</span>
<a name="l00206"></a>00206   <span class="comment">//      * the side list.  This is</span>
<a name="l00207"></a>00207   <span class="comment">//      * effectively the &quot;side&quot;</span>
<a name="l00208"></a>00208   <span class="comment">//      * (face in 3D or edge in</span>
<a name="l00209"></a>00209   <span class="comment">//      * 2D) number which lies</span>
<a name="l00210"></a>00210   <span class="comment">//      * on the boundary.</span>
<a name="l00211"></a>00211   <span class="comment">//      */</span>
<a name="l00212"></a>00212   <span class="comment">//     int get_side_list(int i)         const { return side_list[i]; }</span>
<a name="l00213"></a>00213 
<a name="l00217"></a><a class="code" href="classExodusII__IO__Helper.php#a4714f663fb266b4e005c078d1529182b">00217</a>   <span class="keyword">const</span> std::vector&lt;int&gt;&amp; <a class="code" href="classExodusII__IO__Helper.php#a4714f663fb266b4e005c078d1529182b">get_side_list</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#a5323c8fc862f0933976b898fbc2428a2">side_list</a>; }
<a name="l00218"></a>00218 
<a name="l00222"></a><a class="code" href="classExodusII__IO__Helper.php#a2b0cad9fd62d701c8d2c0a98dad05dbd">00222</a>   <span class="keyword">const</span> std::vector&lt;int&gt;&amp; <a class="code" href="classExodusII__IO__Helper.php#a2b0cad9fd62d701c8d2c0a98dad05dbd">get_node_list</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#ae36f3ea52e3c9d05e39eccf8cf435032">node_list</a>; }
<a name="l00223"></a>00223 
<a name="l00227"></a><a class="code" href="classExodusII__IO__Helper.php#abf15f4b4c33857f884dd7c679e8d2d78">00227</a>   <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper.php#abf15f4b4c33857f884dd7c679e8d2d78">get_nodeset_id</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#a2db3d404f6920aa585d270e57895a943">nodeset_ids</a>[i]; }
<a name="l00228"></a>00228 
<a name="l00229"></a>00229   <span class="comment">//     /**</span>
<a name="l00230"></a>00230   <span class="comment">//      * @returns the \f$ i^{th} \f$ entry in</span>
<a name="l00231"></a>00231   <span class="comment">//      * the id list.  This is the id</span>
<a name="l00232"></a>00232   <span class="comment">//      * for the ith face on the boundary.</span>
<a name="l00233"></a>00233   <span class="comment">//      */</span>
<a name="l00234"></a>00234   <span class="comment">//     int get_id_list(int i)         const { return id_list[i]; }</span>
<a name="l00235"></a>00235 
<a name="l00239"></a><a class="code" href="classExodusII__IO__Helper.php#abbd58a166cbfb6b0ca6e2db154a72b42">00239</a>   <span class="keyword">const</span> std::vector&lt;int&gt;&amp; <a class="code" href="classExodusII__IO__Helper.php#abbd58a166cbfb6b0ca6e2db154a72b42">get_id_list</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#ab74abbcd9a919d57adf0f7ab0e234980">id_list</a>; }
<a name="l00240"></a>00240   
<a name="l00249"></a><a class="code" href="classExodusII__IO__Helper.php#a1be93484618b94756d2554a492ec79dd">00249</a>   <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classExodusII__IO__Helper.php#a1be93484618b94756d2554a492ec79dd">get_elem_type</a>()<span class="keyword">            const </span>{ <span class="keywordflow">return</span> &amp;<a class="code" href="classExodusII__IO__Helper.php#a63b094665cd526058573859ea7ec7a9f">elem_type</a>[0]; }
<a name="l00250"></a>00250 
<a name="l00255"></a><a class="code" href="classExodusII__IO__Helper.php#a97e4c1e13108b9037ac2219e24e4db98">00255</a>   <span class="keywordtype">double</span> <a class="code" href="classExodusII__IO__Helper.php#a97e4c1e13108b9037ac2219e24e4db98">get_x</a>(<span class="keywordtype">int</span> i)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#a168332624b026270a5424916f638c0f7">x</a>[i]; }
<a name="l00256"></a>00256 
<a name="l00261"></a><a class="code" href="classExodusII__IO__Helper.php#a0a4b8030d945f767cf334944c394165b">00261</a>   <span class="keywordtype">double</span> <a class="code" href="classExodusII__IO__Helper.php#a0a4b8030d945f767cf334944c394165b">get_y</a>(<span class="keywordtype">int</span> i)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#a1c72a90256cbff143f3685f97648f958">y</a>[i]; }
<a name="l00262"></a>00262 
<a name="l00267"></a><a class="code" href="classExodusII__IO__Helper.php#ac028f19361d92aa4f69a34b1ad7144d8">00267</a>   <span class="keywordtype">double</span> <a class="code" href="classExodusII__IO__Helper.php#ac028f19361d92aa4f69a34b1ad7144d8">get_z</a>(<span class="keywordtype">int</span> i)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#a952624a5decb9b620eb59ffb41c948e4">z</a>[i]; }
<a name="l00268"></a>00268 
<a name="l00274"></a>00274   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#af979d5fd7cffa411bdd0a16b3a3011ee">open</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* filename);
<a name="l00275"></a>00275 
<a name="l00280"></a>00280   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a3e2c4651800daaa7c199c63c4e49f161">read_header</a>();
<a name="l00281"></a>00281 
<a name="l00292"></a>00292   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a814335b8f7e05a408917b3d422078e61">print_header</a>();
<a name="l00293"></a>00293 
<a name="l00300"></a>00300   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a0ae664b1cc9421fff23daeff6049b591">read_nodes</a>();
<a name="l00301"></a>00301 
<a name="l00306"></a>00306   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a0fb998fe79e5d8f206925d29c363eb45">read_node_num_map</a>();
<a name="l00307"></a>00307   
<a name="l00312"></a>00312   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#ac1e6e372be3d30b50f9163c95e1ad73c">print_nodes</a>();
<a name="l00313"></a>00313 
<a name="l00319"></a>00319   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#aac7883fbd864085b82ef0305205037b5">read_block_info</a>();
<a name="l00320"></a>00320 
<a name="l00325"></a>00325   <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper.php#accf630acdb0aab66a0cd6daf3973b59d">get_block_id</a>(<span class="keywordtype">int</span> block);
<a name="l00326"></a>00326   
<a name="l00333"></a>00333   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#af2bf9e3fea0115a5e5da62074fca5968">read_elem_in_block</a>(<span class="keywordtype">int</span> block);
<a name="l00334"></a>00334  
<a name="l00339"></a>00339   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a65706a7896b35a9f4befee2bed02cc8f">read_elem_num_map</a>();
<a name="l00340"></a>00340 
<a name="l00346"></a>00346   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a55da723215f331f1cda00391f057dd5e">read_sideset_info</a>();
<a name="l00347"></a>00347 
<a name="l00353"></a>00353   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#ae9c3256ae51c60ff819bf08b2570159a">read_nodeset_info</a>();
<a name="l00354"></a>00354 
<a name="l00362"></a>00362   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a81a6fca6d1b75d688d3430b42ac23b5e">read_sideset</a>(<span class="keywordtype">int</span> <span class="keywordtype">id</span>, <span class="keywordtype">int</span> offset);
<a name="l00363"></a>00363 
<a name="l00371"></a>00371   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a914c2e29f12d8118cb2bbe7e02817a6a">read_nodeset</a>(<span class="keywordtype">int</span> <span class="keywordtype">id</span>);
<a name="l00372"></a>00372 
<a name="l00377"></a>00377   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a19cb114ec9e94f4f56b1f520926175af">print_sideset_info</a>();
<a name="l00378"></a>00378 
<a name="l00383"></a>00383   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a77bd7ea308b4bd0f747f52917e9736ef">print_nodeset_info</a>();
<a name="l00384"></a>00384 
<a name="l00389"></a>00389   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a462c7ef49bde1edaead57b7f7e932901">close</a>();
<a name="l00390"></a>00390 
<a name="l00394"></a>00394   <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper.php#a55079b2750dbdbf7ea02c7118c917d28">inquire</a>(<span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper.php#a7e318ac727f824a86a20348f19975c41">req_info</a>, std::string error_msg=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00395"></a>00395 
<a name="l00396"></a>00396     
<a name="l00397"></a>00397   <span class="comment">// For reading solutions:</span>
<a name="l00398"></a>00398   <span class="comment">/*</span>
<a name="l00399"></a>00399 <span class="comment">   * Returns an array containing the timesteps in the file</span>
<a name="l00400"></a>00400 <span class="comment">   */</span>
<a name="l00401"></a>00401   <span class="keyword">const</span> std::vector&lt;double&gt;&amp; <a class="code" href="classExodusII__IO__Helper.php#abf39efd05686e6303298f7268eb979c1">get_time_steps</a>();
<a name="l00402"></a>00402 
<a name="l00403"></a>00403 
<a name="l00404"></a>00404   <span class="comment">/*</span>
<a name="l00405"></a>00405 <span class="comment">   * Number of Nodal variables defined.</span>
<a name="l00406"></a>00406 <span class="comment">   */</span>
<a name="l00407"></a><a class="code" href="classExodusII__IO__Helper.php#aef05aa2e2fede1df333d57996f1b81ae">00407</a>   <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper.php#aef05aa2e2fede1df333d57996f1b81ae">get_num_nodal_vars</a>(){ <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper.php#ada52eac822ab7a679227cf3a927aef74">num_nodal_vars</a>; }
<a name="l00408"></a>00408     
<a name="l00409"></a>00409 
<a name="l00410"></a>00410   <span class="comment">/*</span>
<a name="l00411"></a>00411 <span class="comment">   * Returns an array containing the nodal var names in the file</span>
<a name="l00412"></a>00412 <span class="comment">   */</span>
<a name="l00413"></a>00413   <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; <a class="code" href="classExodusII__IO__Helper.php#a7205e826dcb894185021892bdd574a46">get_nodal_var_names</a>();
<a name="l00414"></a>00414 
<a name="l00415"></a>00415   <span class="comment">/*</span>
<a name="l00416"></a>00416 <span class="comment">   * Returns an array containing the nodal variable values</span>
<a name="l00417"></a>00417 <span class="comment">   * at the specified time</span>
<a name="l00418"></a>00418 <span class="comment">   */</span>
<a name="l00419"></a>00419   <span class="keyword">const</span> std::vector&lt;double&gt;&amp; <a class="code" href="classExodusII__IO__Helper.php#ad35b6ec1c430b200cb69331455c3f252">get_nodal_var_values</a>(std::string nodal_var_name, <span class="keywordtype">int</span> time_step);
<a name="l00420"></a>00420 
<a name="l00421"></a>00421   <span class="comment">// For Writing Solutions</span>
<a name="l00427"></a>00427 <span class="comment"></span>  <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#af2040df8fd7a0bab0437dbec94f750c6">create</a>(std::string filename);
<a name="l00428"></a>00428 
<a name="l00432"></a>00432   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a74c2b9572e8fe56e849c4003095b6495">initialize</a>(std::string <a class="code" href="classExodusII__IO__Helper.php#a2b14ab70ad213522ee14e81d71530e5d">title</a>, <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp; mesh);
<a name="l00433"></a>00433 
<a name="l00437"></a>00437   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a3779067e84b6f238b935a0a917871c0e">write_nodal_coordinates</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp; mesh);
<a name="l00438"></a>00438 
<a name="l00443"></a>00443   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a08434fa54c2aef8dd158630dcdd008f0">write_elements</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp; mesh);
<a name="l00444"></a>00444 
<a name="l00448"></a>00448   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a62037f5803622a70a0c7e5cf836c971c">write_sidesets</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp; mesh);
<a name="l00449"></a>00449 
<a name="l00453"></a>00453   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a636d799fce0f1edbdf114bc368c558ac">write_nodesets</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp; mesh);
<a name="l00454"></a>00454 
<a name="l00458"></a>00458   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#aaa7f63ddf6f23522b56fe72b63167d2f">initialize_nodal_variables</a>(std::vector&lt;std::string&gt; names);
<a name="l00459"></a>00459 
<a name="l00463"></a>00463   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a1c32bbd0b8d72eac0809bab8549d9ff7">write_timestep</a>(<span class="keywordtype">int</span> timestep, <span class="keywordtype">double</span> time);
<a name="l00464"></a>00464 
<a name="l00468"></a>00468   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#ab5181082ac9f4d72f1feda8b0a6fcdad">write_nodal_values</a>(<span class="keywordtype">int</span> var_id, <span class="keyword">const</span> std::vector&lt;Number&gt; &amp; values, <span class="keywordtype">int</span> timestep);
<a name="l00469"></a>00469 
<a name="l00470"></a>00470 
<a name="l00471"></a>00471 
<a name="l00477"></a>00477   <span class="keyword">class </span>Conversion;
<a name="l00478"></a>00478   
<a name="l00485"></a>00485   <span class="keyword">class </span>ElementMaps;
<a name="l00486"></a>00486 
<a name="l00487"></a>00487   
<a name="l00488"></a>00488   <span class="comment">//private:</span>
<a name="l00489"></a>00489 
<a name="l00490"></a>00490   
<a name="l00501"></a>00501   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a90f56a04bb2fdfdd25117aeae5392f43">check_err</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> error, <span class="keyword">const</span> std::string msg);
<a name="l00502"></a>00502 
<a name="l00509"></a>00509   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a85099098d2972a91ff19be7128579b70">message</a>(<span class="keyword">const</span> std::string msg);
<a name="l00510"></a>00510 
<a name="l00521"></a>00521   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO__Helper.php#a85099098d2972a91ff19be7128579b70">message</a>(<span class="keyword">const</span> std::string msg, <span class="keywordtype">int</span> i);
<a name="l00522"></a>00522 
<a name="l00523"></a><a class="code" href="classExodusII__IO__Helper.php#a3466b6b8813cc1922994e8308315c61d">00523</a>   <span class="keywordtype">int</span>   <a class="code" href="classExodusII__IO__Helper.php#a3466b6b8813cc1922994e8308315c61d">comp_ws</a>;                       <span class="comment">// ?</span>
<a name="l00524"></a><a class="code" href="classExodusII__IO__Helper.php#a19b8a443d7d7865cc6b390dbf9679c11">00524</a>   <span class="keywordtype">int</span>   <a class="code" href="classExodusII__IO__Helper.php#a19b8a443d7d7865cc6b390dbf9679c11">io_ws</a>;                         <span class="comment">// ?</span>
<a name="l00525"></a><a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">00525</a>   <span class="keywordtype">int</span>   <a class="code" href="classExodusII__IO__Helper.php#a85478318e058f276c366de4e173ed17d">ex_id</a>;                         <span class="comment">// File identification flag</span>
<a name="l00526"></a><a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">00526</a>   <span class="keywordtype">int</span>   <a class="code" href="classExodusII__IO__Helper.php#a6659a94a8507496231f6b54d419b9299">ex_err</a>;                        <span class="comment">// General error flag</span>
<a name="l00527"></a><a class="code" href="classExodusII__IO__Helper.php#aa514ad80ba187511d8dd81cb97a6a2aa">00527</a>   <span class="keywordtype">int</span>   <a class="code" href="classExodusII__IO__Helper.php#aa514ad80ba187511d8dd81cb97a6a2aa">num_dim</a>;                       <span class="comment">// Number of dimensions in the mesh</span>
<a name="l00528"></a><a class="code" href="classExodusII__IO__Helper.php#a5f58455a10a22df08b2733e4b5e39aef">00528</a>   <span class="keywordtype">int</span>   <a class="code" href="classExodusII__IO__Helper.php#a5f58455a10a22df08b2733e4b5e39aef">num_nodes</a>;                     <span class="comment">// Total number of nodes in the mesh</span>
<a name="l00529"></a><a class="code" href="classExodusII__IO__Helper.php#a5f3697a4d820cb9b2b4f18dd3a035f12">00529</a>   <span class="keywordtype">int</span>   <a class="code" href="classExodusII__IO__Helper.php#a5f3697a4d820cb9b2b4f18dd3a035f12">num_elem</a>;                      <span class="comment">// Total number of elements in the mesh</span>
<a name="l00530"></a><a class="code" href="classExodusII__IO__Helper.php#af8020c0bd24728e12beea02d7f6fb44c">00530</a>   <span class="keywordtype">int</span>   <a class="code" href="classExodusII__IO__Helper.php#af8020c0bd24728e12beea02d7f6fb44c">num_elem_blk</a>;                  <span class="comment">// Total number of element blocks</span>
<a name="l00531"></a><a class="code" href="classExodusII__IO__Helper.php#a9f6bce1eed82131d3df95bf2dabd92bc">00531</a>   <span class="keywordtype">int</span>   <a class="code" href="classExodusII__IO__Helper.php#a9f6bce1eed82131d3df95bf2dabd92bc">num_node_sets</a>;                 <span class="comment">// Total number of node sets</span>
<a name="l00532"></a><a class="code" href="classExodusII__IO__Helper.php#a873bc78e0c49f13ce9c5853d0d806e86">00532</a>   <span class="keywordtype">int</span>   <a class="code" href="classExodusII__IO__Helper.php#a873bc78e0c49f13ce9c5853d0d806e86">num_side_sets</a>;                 <span class="comment">// Total number of element sets</span>
<a name="l00533"></a><a class="code" href="classExodusII__IO__Helper.php#a856f2a0dc5850f1957a2072ef1ce2e5f">00533</a>   <span class="keywordtype">int</span>   <a class="code" href="classExodusII__IO__Helper.php#a856f2a0dc5850f1957a2072ef1ce2e5f">num_elem_this_blk</a>;             <span class="comment">// Number of elements in this block</span>
<a name="l00534"></a><a class="code" href="classExodusII__IO__Helper.php#a944f1231f4dfbdafc94ac3371ae0cf0b">00534</a>   <span class="keywordtype">int</span>   <a class="code" href="classExodusII__IO__Helper.php#a944f1231f4dfbdafc94ac3371ae0cf0b">num_nodes_per_elem</a>;            <span class="comment">// Number of nodes in each element</span>
<a name="l00535"></a><a class="code" href="classExodusII__IO__Helper.php#a314b2dc9e24c82945a534f3adefe077d">00535</a>   <span class="keywordtype">int</span>   <a class="code" href="classExodusII__IO__Helper.php#a314b2dc9e24c82945a534f3adefe077d">num_attr</a>;                      <span class="comment">// Number of attributes for a given block</span>
<a name="l00536"></a><a class="code" href="classExodusII__IO__Helper.php#a7e318ac727f824a86a20348f19975c41">00536</a>   <span class="keywordtype">int</span>   <a class="code" href="classExodusII__IO__Helper.php#a7e318ac727f824a86a20348f19975c41">req_info</a>;                      <span class="comment">// Generic required info tag</span>
<a name="l00537"></a><a class="code" href="classExodusII__IO__Helper.php#a539fcb6f02f6a3bfcfc93378c451ad7d">00537</a>   <span class="keywordtype">int</span>   <a class="code" href="classExodusII__IO__Helper.php#a539fcb6f02f6a3bfcfc93378c451ad7d">ret_int</a>;                       <span class="comment">// Generic int returned by ex_inquire</span>
<a name="l00538"></a><a class="code" href="classExodusII__IO__Helper.php#a26ec622cfba94e10bb0670d874b77732">00538</a>   <span class="keywordtype">int</span>   <a class="code" href="classExodusII__IO__Helper.php#a26ec622cfba94e10bb0670d874b77732">num_elem_all_sidesets</a>;         <span class="comment">// Total number of elements in all side sets</span>
<a name="l00539"></a><a class="code" href="classExodusII__IO__Helper.php#afc7339f25064d90005a6b7a6aff429b0">00539</a>   std::vector&lt;int&gt; <a class="code" href="classExodusII__IO__Helper.php#afc7339f25064d90005a6b7a6aff429b0">block_ids</a>;          <span class="comment">// Vector of the block identification numbers</span>
<a name="l00540"></a><a class="code" href="classExodusII__IO__Helper.php#aa1399def5bca722af0eed2adcbc4cd73">00540</a>   std::vector&lt;int&gt; <a class="code" href="classExodusII__IO__Helper.php#aa1399def5bca722af0eed2adcbc4cd73">connect</a>;            <span class="comment">// Vector of nodes in an element</span>
<a name="l00541"></a><a class="code" href="classExodusII__IO__Helper.php#a3e7da200b8d4811be400c463914a1f0f">00541</a>   std::vector&lt;int&gt; <a class="code" href="classExodusII__IO__Helper.php#a3e7da200b8d4811be400c463914a1f0f">ss_ids</a>;             <span class="comment">// Vector of the sideset IDs</span>
<a name="l00542"></a><a class="code" href="classExodusII__IO__Helper.php#a2db3d404f6920aa585d270e57895a943">00542</a>   std::vector&lt;int&gt; <a class="code" href="classExodusII__IO__Helper.php#a2db3d404f6920aa585d270e57895a943">nodeset_ids</a>;        <span class="comment">// Vector of the nodeset IDs</span>
<a name="l00543"></a><a class="code" href="classExodusII__IO__Helper.php#a7b09767c31d40dda95f53f71d8429a02">00543</a>   std::vector&lt;int&gt; <a class="code" href="classExodusII__IO__Helper.php#a7b09767c31d40dda95f53f71d8429a02">num_sides_per_set</a>;  <span class="comment">// Number of sides (edges/faces) in current set</span>
<a name="l00544"></a><a class="code" href="classExodusII__IO__Helper.php#aa4733dda048befbcebf8f3ac4046c09f">00544</a>   std::vector&lt;int&gt; <a class="code" href="classExodusII__IO__Helper.php#aa4733dda048befbcebf8f3ac4046c09f">num_nodes_per_set</a>;  <span class="comment">// Number of nodes in current set</span>
<a name="l00545"></a><a class="code" href="classExodusII__IO__Helper.php#a00e94b15e780714b25e17d21662c12df">00545</a>   std::vector&lt;int&gt; <a class="code" href="classExodusII__IO__Helper.php#a00e94b15e780714b25e17d21662c12df">num_df_per_set</a>;     <span class="comment">// Number of distribution factors per set</span>
<a name="l00546"></a><a class="code" href="classExodusII__IO__Helper.php#a75a028adaa62026790c57f857da1fc86">00546</a>   std::vector&lt;int&gt; <a class="code" href="classExodusII__IO__Helper.php#a75a028adaa62026790c57f857da1fc86">num_node_df_per_set</a>;<span class="comment">// Number of distribution factors per set</span>
<a name="l00547"></a><a class="code" href="classExodusII__IO__Helper.php#a15aec6a71e5aa0b3ce8973148e089502">00547</a>   std::vector&lt;int&gt; <a class="code" href="classExodusII__IO__Helper.php#a15aec6a71e5aa0b3ce8973148e089502">elem_list</a>;          <span class="comment">// List of element numbers in all sidesets</span>
<a name="l00548"></a><a class="code" href="classExodusII__IO__Helper.php#a5323c8fc862f0933976b898fbc2428a2">00548</a>   std::vector&lt;int&gt; <a class="code" href="classExodusII__IO__Helper.php#a5323c8fc862f0933976b898fbc2428a2">side_list</a>;          <span class="comment">// Side (face/edge) number actually on the boundary </span>
<a name="l00549"></a><a class="code" href="classExodusII__IO__Helper.php#ae36f3ea52e3c9d05e39eccf8cf435032">00549</a>   std::vector&lt;int&gt; <a class="code" href="classExodusII__IO__Helper.php#ae36f3ea52e3c9d05e39eccf8cf435032">node_list</a>;          <span class="comment">// Node number actually on the boundary </span>
<a name="l00550"></a><a class="code" href="classExodusII__IO__Helper.php#ab74abbcd9a919d57adf0f7ab0e234980">00550</a>   std::vector&lt;int&gt; <a class="code" href="classExodusII__IO__Helper.php#ab74abbcd9a919d57adf0f7ab0e234980">id_list</a>;            <span class="comment">// Side (face/edge) id number</span>
<a name="l00551"></a><a class="code" href="classExodusII__IO__Helper.php#a24538ef46d1309b8dc1fca2a9e937ad0">00551</a>   std::vector&lt;int&gt; <a class="code" href="classExodusII__IO__Helper.php#a24538ef46d1309b8dc1fca2a9e937ad0">node_num_map</a>;       <span class="comment">// Optional mapping from internal [0,num_nodes) to arbitrary indices</span>
<a name="l00552"></a><a class="code" href="classExodusII__IO__Helper.php#ac72e1899b5ff58a2c433c4fed45877f7">00552</a>   std::vector&lt;int&gt; <a class="code" href="classExodusII__IO__Helper.php#ac72e1899b5ff58a2c433c4fed45877f7">elem_num_map</a>;       <span class="comment">// Optional mapping from internal [0,num_elem) to arbitrary indices</span>
<a name="l00553"></a><a class="code" href="classExodusII__IO__Helper.php#a5f322262349988a56beb178216674b04">00553</a>   <span class="keywordtype">float</span> <a class="code" href="classExodusII__IO__Helper.php#a5f322262349988a56beb178216674b04">ex_version</a>;                    <span class="comment">// Version of Exodus you are using</span>
<a name="l00554"></a><a class="code" href="classExodusII__IO__Helper.php#ae78db4dd9b9859612bc2dd4b943d0afb">00554</a>   <span class="keywordtype">float</span> <a class="code" href="classExodusII__IO__Helper.php#ae78db4dd9b9859612bc2dd4b943d0afb">ret_float</a>;                     <span class="comment">// Generic float returned by ex_inquire</span>
<a name="l00555"></a><a class="code" href="classExodusII__IO__Helper.php#a168332624b026270a5424916f638c0f7">00555</a>   std::vector&lt;double&gt; <a class="code" href="classExodusII__IO__Helper.php#a168332624b026270a5424916f638c0f7">x</a>;               <span class="comment">// x locations of node points</span>
<a name="l00556"></a><a class="code" href="classExodusII__IO__Helper.php#a1c72a90256cbff143f3685f97648f958">00556</a>   std::vector&lt;double&gt; <a class="code" href="classExodusII__IO__Helper.php#a1c72a90256cbff143f3685f97648f958">y</a>;               <span class="comment">// y locations of node points</span>
<a name="l00557"></a><a class="code" href="classExodusII__IO__Helper.php#a952624a5decb9b620eb59ffb41c948e4">00557</a>   std::vector&lt;double&gt; <a class="code" href="classExodusII__IO__Helper.php#a952624a5decb9b620eb59ffb41c948e4">z</a>;               <span class="comment">// z locations of node points</span>
<a name="l00558"></a><a class="code" href="classExodusII__IO__Helper.php#aaf703b9deb6ce245117f4d0fb0bc9305">00558</a>   <span class="keywordtype">char</span>    <a class="code" href="classExodusII__IO__Helper.php#aaf703b9deb6ce245117f4d0fb0bc9305">ret_char</a>;                    <span class="comment">// Generic char returned by ex_inquire</span>
<a name="l00559"></a>00559   <span class="comment">// Use vectors of char to emulate char*&#39;s</span>
<a name="l00560"></a><a class="code" href="classExodusII__IO__Helper.php#a2b14ab70ad213522ee14e81d71530e5d">00560</a>   std::vector&lt;char&gt; <a class="code" href="classExodusII__IO__Helper.php#a2b14ab70ad213522ee14e81d71530e5d">title</a>;             <span class="comment">//  Problem title</span>
<a name="l00561"></a><a class="code" href="classExodusII__IO__Helper.php#a63b094665cd526058573859ea7ec7a9f">00561</a>   std::vector&lt;char&gt; <a class="code" href="classExodusII__IO__Helper.php#a63b094665cd526058573859ea7ec7a9f">elem_type</a>;         <span class="comment">// Type of element in a given block</span>
<a name="l00562"></a>00562 
<a name="l00563"></a>00563   <span class="comment">// Maps libMesh element numbers to Exodus element numbers</span>
<a name="l00564"></a>00564   <span class="comment">// gets filled in when write_elements gets called</span>
<a name="l00565"></a><a class="code" href="classExodusII__IO__Helper.php#ac482d48008757b2922803a62fcc36f14">00565</a>   std::map&lt;int, int&gt; <a class="code" href="classExodusII__IO__Helper.php#ac482d48008757b2922803a62fcc36f14">libmesh_elem_num_to_exodus</a>;
<a name="l00566"></a>00566     
<a name="l00567"></a>00567   <span class="comment">//Solution Data</span>
<a name="l00568"></a><a class="code" href="classExodusII__IO__Helper.php#a4a459c0bb6dcc4d06200f2682dc2ed1f">00568</a>   <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper.php#a4a459c0bb6dcc4d06200f2682dc2ed1f">num_time_steps</a>;
<a name="l00569"></a><a class="code" href="classExodusII__IO__Helper.php#ad2837978f4ec72520cc0a9db7117ab36">00569</a>   std::vector&lt;double&gt; <a class="code" href="classExodusII__IO__Helper.php#ad2837978f4ec72520cc0a9db7117ab36">time_steps</a>;
<a name="l00570"></a><a class="code" href="classExodusII__IO__Helper.php#ada52eac822ab7a679227cf3a927aef74">00570</a>   <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper.php#ada52eac822ab7a679227cf3a927aef74">num_nodal_vars</a>;
<a name="l00571"></a><a class="code" href="classExodusII__IO__Helper.php#a6e657a9beac70f6c7aa15a08320ef5e2">00571</a>   std::vector&lt;std::string&gt; <a class="code" href="classExodusII__IO__Helper.php#a6e657a9beac70f6c7aa15a08320ef5e2">nodal_var_names</a>;
<a name="l00572"></a><a class="code" href="classExodusII__IO__Helper.php#a6339b85f37118c2dd5e73e811c429633">00572</a>   std::vector&lt;double&gt; <a class="code" href="classExodusII__IO__Helper.php#a6339b85f37118c2dd5e73e811c429633">nodal_var_values</a>;
<a name="l00573"></a>00573 
<a name="l00574"></a>00574   <span class="comment">// A pair of containers used to emulate a char** data</span>
<a name="l00575"></a>00575   <span class="comment">// structure without having to worry about dynamic memory</span>
<a name="l00576"></a>00576   <span class="comment">// allocation ourselves.</span>
<a name="l00577"></a><a class="code" href="classExodusII__IO__Helper.php#addc11763636e66979ee738ffefdecf27">00577</a>   std::vector&lt;std::vector&lt;char&gt; &gt; <a class="code" href="classExodusII__IO__Helper.php#addc11763636e66979ee738ffefdecf27">vvc</a>;
<a name="l00578"></a><a class="code" href="classExodusII__IO__Helper.php#ac72001474c7b8e15a58d0dc2c7b33f32">00578</a>   std::vector&lt;char*&gt; <a class="code" href="classExodusII__IO__Helper.php#ac72001474c7b8e15a58d0dc2c7b33f32">strings</a>; <span class="comment">// vector of pointers into vvc</span>
<a name="l00579"></a>00579 
<a name="l00580"></a>00580  <span class="keyword">protected</span>:
<a name="l00581"></a><a class="code" href="classExodusII__IO__Helper.php#aa8f6e91509adce64436efb3c92158d61">00581</a>   <span class="keywordtype">bool</span> <a class="code" href="classExodusII__IO__Helper.php#aa8f6e91509adce64436efb3c92158d61">_created</a>; <span class="comment">// This flag gets set after the the create() function has been successfully called.</span>
<a name="l00582"></a><a class="code" href="classExodusII__IO__Helper.php#a2b09a9ee467e376882fc62e6d20aa539">00582</a>   <span class="keywordtype">bool</span> <a class="code" href="classExodusII__IO__Helper.php#a2b09a9ee467e376882fc62e6d20aa539">_verbose</a>; <span class="comment">// On/Off message flag</span>
<a name="l00583"></a>00583 };
<a name="l00584"></a>00584 
<a name="l00585"></a>00585 
<a name="l00586"></a>00586 
<a name="l00587"></a>00587 
<a name="l00588"></a>00588 
<a name="l00589"></a>00589 
<a name="l00590"></a>00590 
<a name="l00591"></a>00591 
<a name="l00592"></a><a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">00592</a> <span class="keyword">class </span><a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">ExodusII_IO_Helper::Conversion</a>
<a name="l00593"></a>00593 {
<a name="l00594"></a>00594 <span class="keyword">public</span>:
<a name="l00595"></a>00595 
<a name="l00600"></a><a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#ad96f24a2c1c57c55ea6ae7ff7f88c9a4">00600</a>   <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#ad96f24a2c1c57c55ea6ae7ff7f88c9a4">Conversion</a>(<span class="keyword">const</span> <span class="keywordtype">int</span>* nm, <span class="keyword">const</span> <span class="keywordtype">int</span>* sm, <span class="keyword">const</span> <span class="keywordtype">int</span>* ism, <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> ct, std::string ex_type) 
<a name="l00601"></a>00601     : <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#afa0357614e281a3c54f5eb919fb11cf6">node_map</a>(nm),       <span class="comment">// Node map for this element</span>
<a name="l00602"></a>00602       <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#a7a6e9347de35eaa46f67934baf5a710f">side_map</a>(sm),
<a name="l00603"></a>00603       <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#a60720d49843c50949e4791abbd1ca6cf">inverse_side_map</a>(ism),
<a name="l00604"></a>00604       <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#a368ae5e8256c62d99ae8842f29b2412d">canonical_type</a>(ct),    <span class="comment">// Element type name in this code</span>
<a name="l00605"></a>00605       <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#acf3e36fbe3d678f60c2bcc59a4b75645">exodus_type</a>(ex_type)   <span class="comment">// Element type in Exodus</span>
<a name="l00606"></a>00606   {}
<a name="l00607"></a>00607 
<a name="l00613"></a><a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#ad5ed62938325bdd443bfb24297f605a3">00613</a>   <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#ad5ed62938325bdd443bfb24297f605a3">get_node_map</a>(<span class="keywordtype">int</span> i)<span class="keyword">          const </span>{ <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#afa0357614e281a3c54f5eb919fb11cf6">node_map</a>[i]; }
<a name="l00614"></a>00614 
<a name="l00620"></a><a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#a14a7e9d21c19ddb9362dd13abb7da4ab">00620</a>   <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#a14a7e9d21c19ddb9362dd13abb7da4ab">get_side_map</a>(<span class="keywordtype">int</span> i)<span class="keyword">          const </span>{ <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#a7a6e9347de35eaa46f67934baf5a710f">side_map</a>[i]; }
<a name="l00621"></a>00621 
<a name="l00627"></a><a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#afde72d2d18738a338bca50016da1d7d1">00627</a>   <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#afde72d2d18738a338bca50016da1d7d1">get_inverse_side_map</a>(<span class="keywordtype">int</span> i)<span class="keyword">          const </span>{ <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#a60720d49843c50949e4791abbd1ca6cf">inverse_side_map</a>[i]; }
<a name="l00628"></a>00628 
<a name="l00634"></a><a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#a98dc09a31fab74133984df6e76da926a">00634</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#a98dc09a31fab74133984df6e76da926a">get_canonical_type</a>()<span class="keyword">    const </span>{ <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#a368ae5e8256c62d99ae8842f29b2412d">canonical_type</a>; }
<a name="l00635"></a>00635 
<a name="l00639"></a><a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#afa0357614e281a3c54f5eb919fb11cf6">00639</a>   std::string <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#a096dfd046aac510d1468d625bc304365">exodus_elem_type</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#acf3e36fbe3d678f60c2bcc59a4b75645">exodus_type</a>; };
<a name="l00640"></a>00640 
<a name="l00641"></a>00641     
<a name="l00642"></a>00642 <span class="keyword">private</span>:
<a name="l00646"></a>00646   <span class="keyword">const</span> <span class="keywordtype">int</span>* <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#afa0357614e281a3c54f5eb919fb11cf6">node_map</a>;
<a name="l00647"></a>00647       
<a name="l00651"></a><a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#a7a6e9347de35eaa46f67934baf5a710f">00651</a>   <span class="keyword">const</span> <span class="keywordtype">int</span>* <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#a7a6e9347de35eaa46f67934baf5a710f">side_map</a>;
<a name="l00652"></a>00652 
<a name="l00656"></a><a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#a60720d49843c50949e4791abbd1ca6cf">00656</a>   <span class="keyword">const</span> <span class="keywordtype">int</span>* <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#a60720d49843c50949e4791abbd1ca6cf">inverse_side_map</a>;
<a name="l00657"></a>00657 
<a name="l00662"></a><a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#a368ae5e8256c62d99ae8842f29b2412d">00662</a>   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#a368ae5e8256c62d99ae8842f29b2412d">canonical_type</a>;
<a name="l00663"></a>00663 
<a name="l00667"></a><a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#acf3e36fbe3d678f60c2bcc59a4b75645">00667</a>   <span class="keyword">const</span> std::string <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#acf3e36fbe3d678f60c2bcc59a4b75645">exodus_type</a>;
<a name="l00668"></a>00668 };
<a name="l00669"></a>00669 
<a name="l00670"></a>00670 
<a name="l00671"></a>00671 
<a name="l00672"></a>00672 
<a name="l00673"></a>00673 
<a name="l00674"></a>00674 
<a name="l00675"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php">00675</a> <span class="keyword">class </span><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php">ExodusII_IO_Helper::ElementMaps</a>
<a name="l00676"></a>00676 {
<a name="l00677"></a>00677 <span class="keyword">public</span>:
<a name="l00678"></a>00678 
<a name="l00682"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#ac5fbf767a91895c90369728a8bd8ff3e">00682</a>   <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#ac5fbf767a91895c90369728a8bd8ff3e">ElementMaps</a>() {}
<a name="l00683"></a>00683 
<a name="l00695"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#aa4cbe1d3a11e6c5e0d8ae26f9e1dd6b3">00695</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#aa4cbe1d3a11e6c5e0d8ae26f9e1dd6b3">quad4_node_map</a>[4]; 
<a name="l00696"></a>00696 
<a name="l00702"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a67133d375c12289b7b5a4e2fea6ae34b">00702</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a67133d375c12289b7b5a4e2fea6ae34b">quad8_node_map</a>[8]; 
<a name="l00703"></a>00703 
<a name="l00709"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a40a3ef6b90a9ce68a5fb2bee16655186">00709</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a40a3ef6b90a9ce68a5fb2bee16655186">quad9_node_map</a>[9]; 
<a name="l00710"></a>00710 
<a name="l00716"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a36a35c18b1f25c0434786afa4b76fe3e">00716</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a36a35c18b1f25c0434786afa4b76fe3e">tri3_node_map</a>[3];     
<a name="l00717"></a>00717 
<a name="l00723"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a54e545df3df0202d756f4271c2aa3247">00723</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a54e545df3df0202d756f4271c2aa3247">tri6_node_map</a>[6];     
<a name="l00724"></a>00724 
<a name="l00733"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a733d1fd7a1e39f01d87a6efb7126a07a">00733</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a733d1fd7a1e39f01d87a6efb7126a07a">tri_edge_map</a>[3]; 
<a name="l00734"></a>00734 
<a name="l00739"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#ac15c1362094451a0a21c89fb5a75697f">00739</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#ac15c1362094451a0a21c89fb5a75697f">quad_edge_map</a>[4]; 
<a name="l00740"></a>00740 
<a name="l00745"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a219a0c2529b2d4ed2673a5ffb02d821b">00745</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a219a0c2529b2d4ed2673a5ffb02d821b">tri_inverse_edge_map</a>[3]; 
<a name="l00746"></a>00746 
<a name="l00751"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#aaf51ca253efe26844d82f9f409b62ba1">00751</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#aaf51ca253efe26844d82f9f409b62ba1">quad_inverse_edge_map</a>[4];
<a name="l00752"></a>00752       
<a name="l00764"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#ab9067833fd1a65acfcd089ba44c0eb57">00764</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#ab9067833fd1a65acfcd089ba44c0eb57">hex8_node_map</a>[8]; 
<a name="l00765"></a>00765 
<a name="l00771"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a3f79cdc1a19bb798755319f188fa6026">00771</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a3f79cdc1a19bb798755319f188fa6026">hex20_node_map</a>[20]; 
<a name="l00772"></a>00772 
<a name="l00778"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a2c504b9c83619a98824d17ace1489182">00778</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a2c504b9c83619a98824d17ace1489182">hex27_node_map</a>[27]; 
<a name="l00779"></a>00779 
<a name="l00785"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#aefecc7306a608139ea1fda3af32fc985">00785</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#aefecc7306a608139ea1fda3af32fc985">tet4_node_map</a>[4]; 
<a name="l00786"></a>00786 
<a name="l00792"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a62d8436770d6c73b23c38c617dd3344b">00792</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a62d8436770d6c73b23c38c617dd3344b">tet10_node_map</a>[10]; 
<a name="l00793"></a>00793 
<a name="l00797"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a4d0d5459cd76af45d9df7adacb1cee40">00797</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a4d0d5459cd76af45d9df7adacb1cee40">prism6_node_map</a>[6]; 
<a name="l00798"></a>00798 
<a name="l00803"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#abcfcb88ebc8ba404020469498327bc14">00803</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#abcfcb88ebc8ba404020469498327bc14">prism15_node_map</a>[15]; 
<a name="l00804"></a>00804 
<a name="l00808"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a362c6d282f0957508d2582c5c89ff9e5">00808</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a362c6d282f0957508d2582c5c89ff9e5">prism18_node_map</a>[18]; 
<a name="l00809"></a>00809 
<a name="l00815"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#ab44a54133a87456544527428eb538e8f">00815</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#ab44a54133a87456544527428eb538e8f">pyramid5_node_map</a>[5]; 
<a name="l00816"></a>00816 
<a name="l00817"></a>00817 
<a name="l00826"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a5c6ccb065ccf1261744d9fd1e296e139">00826</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a5c6ccb065ccf1261744d9fd1e296e139">hex_face_map</a>[6];
<a name="l00827"></a>00827       
<a name="l00832"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#ae233c86a0d59ff1a4b4e20fe0f2ee502">00832</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#ae233c86a0d59ff1a4b4e20fe0f2ee502">hex27_face_map</a>[6];
<a name="l00833"></a>00833       
<a name="l00838"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a9816fe8dfc5cea06f8d075ee36bdc5b7">00838</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a9816fe8dfc5cea06f8d075ee36bdc5b7">tet_face_map</a>[4];
<a name="l00839"></a>00839       
<a name="l00844"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#af42ffe4e1804df076fe5d93f68127da9">00844</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#af42ffe4e1804df076fe5d93f68127da9">prism_face_map</a>[5];
<a name="l00845"></a>00845       
<a name="l00850"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a45d1621f3ea61101a6674741f14fed9f">00850</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a45d1621f3ea61101a6674741f14fed9f">pyramid_face_map</a>[5];
<a name="l00851"></a>00851 
<a name="l00856"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#ad4ba9582436d8efbc8415ccaf9755baf">00856</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#ad4ba9582436d8efbc8415ccaf9755baf">hex_inverse_face_map</a>[6];
<a name="l00857"></a>00857       
<a name="l00862"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a4b6b050eec2a2a10ac246d4b20f1160d">00862</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a4b6b050eec2a2a10ac246d4b20f1160d">hex27_inverse_face_map</a>[6];
<a name="l00863"></a>00863       
<a name="l00868"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a8461aae160cf037098a95e2635953075">00868</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a8461aae160cf037098a95e2635953075">tet_inverse_face_map</a>[4];
<a name="l00869"></a>00869       
<a name="l00874"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#ad678dd9d31ae99763519c1ff5d62c468">00874</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#ad678dd9d31ae99763519c1ff5d62c468">prism_inverse_face_map</a>[5];
<a name="l00875"></a>00875       
<a name="l00880"></a><a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a6c445c9e83a8aff165262f0594441df1">00880</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a6c445c9e83a8aff165262f0594441df1">pyramid_inverse_face_map</a>[5];
<a name="l00881"></a>00881 
<a name="l00882"></a>00882 
<a name="l00886"></a>00886   <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">ExodusII_IO_Helper::Conversion</a> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a572ac41c49e11af4a560e4a731186590">assign_conversion</a>(<span class="keyword">const</span> std::string type_str);
<a name="l00887"></a>00887       
<a name="l00891"></a>00891   <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">ExodusII_IO_Helper::Conversion</a> <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a572ac41c49e11af4a560e4a731186590">assign_conversion</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00892"></a>00892 };
<a name="l00893"></a>00893 
<a name="l00894"></a>00894 
<a name="l00895"></a>00895 <span class="preprocessor">#endif // LIBMESH_HAVE_EXODUS_API</span>
<a name="l00896"></a>00896 <span class="preprocessor"></span>
<a name="l00897"></a>00897 <span class="preprocessor">#endif // #ifndef __exodusII_io_helper_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
