<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_60be1125a39495b698d2d56e8e5b50b1.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>explicit_system.C</h1>  </div>
</div>
<div class="contents">
<a href="explicit__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: explicit_system.C 3412 2009-06-26 21:50:27Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;explicit_system.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;parallel.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00031"></a>00031 <span class="comment">// ExplicitSystem implementation</span>
<a name="l00032"></a><a class="code" href="classExplicitSystem.php#a4b14ba1b35ec48aec80537f7c389af01">00032</a> <a class="code" href="classExplicitSystem.php#a4b14ba1b35ec48aec80537f7c389af01">ExplicitSystem::ExplicitSystem</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00033"></a>00033                                 <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00034"></a>00034                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :
<a name="l00035"></a>00035   <a class="code" href="classSystem.php">Parent</a> (es, name, number),
<a name="l00036"></a>00036   rhs(NULL)
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039   <span class="comment">//rhs = &amp;(this-&gt;add_vector (&quot;RHS Vector&quot;));</span>
<a name="l00040"></a>00040 }
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a><a class="code" href="classExplicitSystem.php#a38c544c7cfc67728b423b824837a2113">00044</a> <a class="code" href="classExplicitSystem.php#a38c544c7cfc67728b423b824837a2113">ExplicitSystem::~ExplicitSystem</a> ()
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046   <span class="comment">// clear data</span>
<a name="l00047"></a>00047   this-&gt;<a class="code" href="classExplicitSystem.php#a86b23fe483bba238c2f2c68b7c2a953a">clear</a>();
<a name="l00048"></a>00048 }
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00052"></a><a class="code" href="classExplicitSystem.php#a86b23fe483bba238c2f2c68b7c2a953a">00052</a> <span class="keywordtype">void</span> <a class="code" href="classExplicitSystem.php#a86b23fe483bba238c2f2c68b7c2a953a">ExplicitSystem::clear</a> ()
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054   <span class="comment">// Clear the parent data</span>
<a name="l00055"></a>00055   <a class="code" href="classSystem.php#a66bdd137db3fc914bbfe9518b6c71017">Parent::clear</a>();
<a name="l00056"></a>00056 
<a name="l00057"></a>00057   <span class="comment">// NULL-out the vector.  Note that</span>
<a name="l00058"></a>00058   <span class="comment">// System::clear() actually deleted it.</span>
<a name="l00059"></a>00059   <a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a> = NULL;
<a name="l00060"></a>00060 }
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a><a class="code" href="classExplicitSystem.php#a4b9e0459e6889ba4a9fe352055b01af8">00064</a> <span class="keywordtype">void</span> <a class="code" href="classExplicitSystem.php#a4b9e0459e6889ba4a9fe352055b01af8">ExplicitSystem::init_data</a> ()
<a name="l00065"></a>00065 {
<a name="l00066"></a>00066   <span class="comment">// Add the system RHS.</span>
<a name="l00067"></a>00067   <span class="comment">// (We must do this before initializing the System data,</span>
<a name="l00068"></a>00068   <span class="comment">//  then we lose the opportunity to add vectors).</span>
<a name="l00069"></a>00069   this-&gt;<a class="code" href="classExplicitSystem.php#afb63bd2a3214cb62538bab7adc8a72b3">add_system_rhs</a> ();
<a name="l00070"></a>00070   
<a name="l00071"></a>00071   <span class="comment">// initialize parent data</span>
<a name="l00072"></a>00072   <a class="code" href="classSystem.php#a1ee0d1111c06a94c271b2830dbc69421">Parent::init_data</a>();
<a name="l00073"></a>00073 }
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
<a name="l00077"></a><a class="code" href="classExplicitSystem.php#aedfc96903651e6f6e2d7cb347ec43c9f">00077</a> <span class="keywordtype">void</span> <a class="code" href="classExplicitSystem.php#aedfc96903651e6f6e2d7cb347ec43c9f">ExplicitSystem::reinit</a> ()
<a name="l00078"></a>00078 {
<a name="l00079"></a>00079   <span class="comment">// initialize parent data</span>
<a name="l00080"></a>00080   <a class="code" href="classSystem.php#a60f6078e475e01e19aad618766f2cd7b">Parent::reinit</a>();  
<a name="l00081"></a>00081   
<a name="l00082"></a>00082   <span class="comment">// not necessary, handled by the parent!</span>
<a name="l00083"></a>00083   <span class="comment">// Resize the RHS conformal to the current mesh</span>
<a name="l00084"></a>00084   <span class="comment">//rhs-&gt;init (this-&gt;n_dofs(), this-&gt;n_local_dofs());</span>
<a name="l00085"></a>00085 }
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 
<a name="l00089"></a><a class="code" href="classExplicitSystem.php#a91c99d58d66564a2245d2c102181d8b3">00089</a> <span class="keywordtype">void</span> <a class="code" href="classExplicitSystem.php#a91c99d58d66564a2245d2c102181d8b3">ExplicitSystem::assemble_qoi</a> ()
<a name="l00090"></a>00090 {
<a name="l00091"></a>00091   libmesh_assert (<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>    != NULL);
<a name="l00092"></a>00092   libmesh_assert (<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>-&gt;<a class="code" href="classNumericVector.php#a43085d102bac085751371d1a94b5dea9">initialized</a>());
<a name="l00093"></a>00093 
<a name="l00094"></a>00094   <span class="comment">// The user quantity of interest assembly gets to expect to</span>
<a name="l00095"></a>00095   <span class="comment">// accumulate on an initially zero value</span>
<a name="l00096"></a>00096   <a class="code" href="classSystem.php#a49aff017c2708cbddfc91abff099f9cb">qoi</a> = 0;
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   <a class="code" href="classSystem.php#a80a51f5a333e470498740358fac6f959">Parent::assemble_qoi</a> ();
<a name="l00099"></a>00099 }
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 
<a name="l00103"></a><a class="code" href="classExplicitSystem.php#a563d121d2398bdc54dbe60eda789ddaa">00103</a> <span class="keywordtype">void</span> <a class="code" href="classExplicitSystem.php#a563d121d2398bdc54dbe60eda789ddaa">ExplicitSystem::assemble_qoi_derivative</a> ()
<a name="l00104"></a>00104 {
<a name="l00105"></a>00105   libmesh_assert (<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>    != NULL);
<a name="l00106"></a>00106   libmesh_assert (<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>-&gt;<a class="code" href="classNumericVector.php#a43085d102bac085751371d1a94b5dea9">initialized</a>());
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   <span class="comment">// The user quantity of interest derivative assembly gets to expect</span>
<a name="l00109"></a>00109   <span class="comment">// to accumulate on an initially empty vector</span>
<a name="l00110"></a>00110   <a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>-&gt;<a class="code" href="classNumericVector.php#a21ca80e20b0f88490c8f0d5298d47bef">zero</a> ();
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   <a class="code" href="classSystem.php#a70a20011f2bf9131e08fdcac9834e81f">Parent::assemble_qoi_derivative</a> ();
<a name="l00113"></a>00113 }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a><a class="code" href="classExplicitSystem.php#adc9aac0771cd9a36dbf9d5afc5c92627">00117</a> <span class="keywordtype">void</span> <a class="code" href="classExplicitSystem.php#adc9aac0771cd9a36dbf9d5afc5c92627">ExplicitSystem::solve</a> ()
<a name="l00118"></a>00118 {
<a name="l00119"></a>00119   <span class="comment">// Assemble the linear system</span>
<a name="l00120"></a>00120   this-&gt;<a class="code" href="classSystem.php#abca899f8ae44d10c606fe28b5e8420dd">assemble</a> (); 
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   <span class="comment">// Update the system after the solve</span>
<a name="l00123"></a>00123   this-&gt;<a class="code" href="classSystem.php#add4b09ec4fb0679b8623c01218cafa5b">update</a>();  
<a name="l00124"></a>00124 }
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a><a class="code" href="classExplicitSystem.php#afb63bd2a3214cb62538bab7adc8a72b3">00128</a> <span class="keywordtype">void</span> <a class="code" href="classExplicitSystem.php#afb63bd2a3214cb62538bab7adc8a72b3">ExplicitSystem::add_system_rhs</a> ()
<a name="l00129"></a>00129 {
<a name="l00130"></a>00130   <span class="comment">// Possible that we cleared the _vectors but</span>
<a name="l00131"></a>00131   <span class="comment">// forgot to NULL-out the rhs?</span>
<a name="l00132"></a>00132   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classSystem.php#adf187b75dac8c906b0b27ce25e146305">n_vectors</a>() == 0) <a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a> = NULL;
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   <span class="comment">// Only need to add the rhs if it isn&#39;t there</span>
<a name="l00136"></a>00136   <span class="comment">// already!</span>
<a name="l00137"></a>00137   <span class="keywordflow">if</span> (<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a> == NULL)
<a name="l00138"></a>00138     <a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a> = &amp;(this-&gt;<a class="code" href="classSystem.php#abab8a3810cc43d99fe395d449207b786">add_vector</a> (<span class="stringliteral">&quot;RHS Vector&quot;</span>, <span class="keyword">false</span>));
<a name="l00139"></a>00139 
<a name="l00140"></a>00140   libmesh_assert (<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a> != NULL);
<a name="l00141"></a>00141 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
