<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>explicit_system.h</h1>  </div>
</div>
<div class="contents">
<a href="explicit__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: explicit_system.h 3414 2009-06-30 23:15:45Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __explicit_system_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __explicit_system_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Forward Declarations</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00042"></a>00042 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00043"></a>00043 <span class="comment">// ExplicitSystem class definition</span>
<a name="l00044"></a>00044 
<a name="l00045"></a><a class="code" href="classExplicitSystem.php">00045</a> <span class="keyword">class </span><a class="code" href="classExplicitSystem.php">ExplicitSystem</a> : <span class="keyword">public</span> <a class="code" href="classSystem.php">System</a>
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047 <span class="keyword">public</span>:
<a name="l00048"></a>00048 
<a name="l00053"></a>00053   <a class="code" href="classExplicitSystem.php#a4b14ba1b35ec48aec80537f7c389af01">ExplicitSystem</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00054"></a>00054                   <span class="keyword">const</span> std::string&amp; <a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>,
<a name="l00055"></a>00055                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">number</a>);
<a name="l00056"></a>00056 
<a name="l00060"></a>00060   <a class="code" href="classExplicitSystem.php#a38c544c7cfc67728b423b824837a2113">~ExplicitSystem</a> ();
<a name="l00061"></a>00061  
<a name="l00065"></a><a class="code" href="classExplicitSystem.php#ad3a1a5382776fade5e3e82e17c8aa7a6">00065</a>   <span class="keyword">typedef</span> <a class="code" href="classExplicitSystem.php">ExplicitSystem</a> <a class="code" href="classExplicitSystem.php#ad3a1a5382776fade5e3e82e17c8aa7a6">sys_type</a>;
<a name="l00066"></a>00066 
<a name="l00070"></a><a class="code" href="classExplicitSystem.php#a122675ef40eafa82dd958f42def700ee">00070</a>   <span class="keyword">typedef</span> <a class="code" href="classSystem.php">System</a> <a class="code" href="classExplicitSystem.php#a122675ef40eafa82dd958f42def700ee">Parent</a>;
<a name="l00071"></a>00071   
<a name="l00075"></a><a class="code" href="classExplicitSystem.php#aad9f547a8c724e80abf483bf794c4822">00075</a>   <a class="code" href="classExplicitSystem.php">sys_type</a> &amp; <a class="code" href="classExplicitSystem.php#aad9f547a8c724e80abf483bf794c4822">system</a> () { <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00076"></a>00076   
<a name="l00081"></a>00081   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classExplicitSystem.php#a86b23fe483bba238c2f2c68b7c2a953a">clear</a> ();
<a name="l00082"></a>00082 
<a name="l00087"></a>00087   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classExplicitSystem.php#aedfc96903651e6f6e2d7cb347ec43c9f">reinit</a> ();
<a name="l00088"></a>00088   
<a name="l00094"></a>00094   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classExplicitSystem.php#a91c99d58d66564a2245d2c102181d8b3">assemble_qoi</a> ();
<a name="l00095"></a>00095 
<a name="l00101"></a>00101   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classExplicitSystem.php#a563d121d2398bdc54dbe60eda789ddaa">assemble_qoi_derivative</a> ();
<a name="l00102"></a>00102  
<a name="l00106"></a>00106   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classExplicitSystem.php#adc9aac0771cd9a36dbf9d5afc5c92627">solve</a> ();
<a name="l00107"></a>00107  
<a name="l00112"></a><a class="code" href="classExplicitSystem.php#a4d54e60d522844c68df56bff85c14842">00112</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classExplicitSystem.php#a4d54e60d522844c68df56bff85c14842">adjoint_solve</a> () { libmesh_error(); }
<a name="l00113"></a>00113  
<a name="l00118"></a><a class="code" href="classExplicitSystem.php#a084dd47586e537ac34a586f6123dd766">00118</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classExplicitSystem.php#a084dd47586e537ac34a586f6123dd766">qoi_parameter_sensitivity</a> (std::vector&lt;Number *&gt;&amp;, std::vector&lt;Number&gt;&amp;)
<a name="l00119"></a>00119     { libmesh_error(); }
<a name="l00120"></a>00120 
<a name="l00125"></a><a class="code" href="classExplicitSystem.php#af3f2b178ed3b49ffd3edcef7389e46a6">00125</a>   <span class="keyword">virtual</span> std::string <a class="code" href="classExplicitSystem.php#af3f2b178ed3b49ffd3edcef7389e46a6">system_type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="stringliteral">&quot;Explicit&quot;</span>; }
<a name="l00126"></a>00126 
<a name="l00132"></a><a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">00132</a>   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> * <a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>;
<a name="l00133"></a>00133   
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 <span class="keyword">protected</span>:
<a name="l00136"></a>00136 
<a name="l00137"></a>00137   
<a name="l00142"></a>00142   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classExplicitSystem.php#a4b9e0459e6889ba4a9fe352055b01af8">init_data</a> ();
<a name="l00143"></a>00143 
<a name="l00144"></a>00144   
<a name="l00145"></a>00145 <span class="keyword">private</span>:
<a name="l00146"></a>00146 
<a name="l00147"></a>00147   
<a name="l00152"></a>00152   <span class="keywordtype">void</span> <a class="code" href="classExplicitSystem.php#afb63bd2a3214cb62538bab7adc8a72b3">add_system_rhs</a> ();
<a name="l00153"></a>00153 };
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00158"></a>00158 <span class="comment">// ExplicitSystem inline methods</span>
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
