<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>face_inf_quad4.h</h1>  </div>
</div>
<div class="contents">
<a href="face__inf__quad4_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_inf_quad4.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __inf_quad4_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __inf_quad4_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00027"></a>00027 <span class="preprocessor"></span>
<a name="l00028"></a>00028 <span class="comment">// C++ includes</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Local includes</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="face__inf__quad_8h.php">face_inf_quad.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00051"></a>00051 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00052"></a>00052 <span class="comment">// InfQuad4 class definition</span>
<a name="l00053"></a><a class="code" href="classInfQuad4.php">00053</a> <span class="keyword">class </span><a class="code" href="classInfQuad4.php">InfQuad4</a> : <span class="keyword">public</span> <a class="code" href="classInfQuad.php">InfQuad</a>
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055 <span class="keyword">public</span>:
<a name="l00056"></a>00056 
<a name="l00060"></a><a class="code" href="classInfQuad4.php#a021e12cbff0157920eaf800071508ed0">00060</a>   <a class="code" href="classInfQuad4.php#a021e12cbff0157920eaf800071508ed0">InfQuad4</a> (<a class="code" href="classElem.php">Elem</a>* p=NULL) :
<a name="l00061"></a>00061     <a class="code" href="classInfQuad.php">InfQuad</a>(<a class="code" href="classInfQuad4.php">InfQuad4</a>::<a class="code" href="classInfQuad4.php#aedf51ecc0d5de1897e1cdf95f928a6e4">n_nodes</a>(), p) {}
<a name="l00062"></a>00062 
<a name="l00067"></a><a class="code" href="classInfQuad4.php#a49fac950be478453a1baa0cd4707be88">00067</a>   <a class="code" href="classInfQuad4.php#a021e12cbff0157920eaf800071508ed0">InfQuad4</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00068"></a>00068             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00069"></a>00069             <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00070"></a>00070     <a class="code" href="classInfQuad.php">InfQuad</a>(nn, ns, p) {}
<a name="l00071"></a>00071   
<a name="l00075"></a><a class="code" href="classInfQuad4.php#aedf51ecc0d5de1897e1cdf95f928a6e4">00075</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfQuad4.php#aedf51ecc0d5de1897e1cdf95f928a6e4">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00076"></a>00076 
<a name="l00080"></a><a class="code" href="classInfQuad4.php#a5043ab60c0be32da202447a1231df902">00080</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classInfQuad4.php#a5043ab60c0be32da202447a1231df902">type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a23d0ae825ee3f493b6504b71f28e2aef">INFQUAD4</a>; }
<a name="l00081"></a>00081   
<a name="l00085"></a><a class="code" href="classInfQuad4.php#ac56b1039e1f3a004e895460af364ddf1">00085</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfQuad4.php#ac56b1039e1f3a004e895460af364ddf1">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00086"></a>00086   
<a name="l00090"></a>00090   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfQuad4.php#a63a63eae0e5b4150b690994ed0fbbacf">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00091"></a>00091 
<a name="l00095"></a>00095   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfQuad4.php#a53c74c47c291ddd729c0878d7dbdce2a">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00096"></a>00096 
<a name="l00100"></a>00100   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfQuad4.php#a83710e8183d5ac9ef50784e011a9d599">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00101"></a>00101   
<a name="l00102"></a>00102   <span class="comment">/*</span>
<a name="l00103"></a>00103 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00104"></a>00104 <span class="comment">   * specified side</span>
<a name="l00105"></a>00105 <span class="comment">   */</span>
<a name="l00106"></a>00106   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfQuad4.php#aec4d24025ceb56bd82e099403ce198d4">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00107"></a>00107                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00108"></a>00108   
<a name="l00109"></a>00109   <span class="comment">/*</span>
<a name="l00110"></a>00110 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00111"></a>00111 <span class="comment">   * specified edge (== is_node_on_side in 2D)</span>
<a name="l00112"></a>00112 <span class="comment">   */</span>
<a name="l00113"></a><a class="code" href="classInfQuad4.php#aaf65b62bfcdb0289c45ceec5de73ff02">00113</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfQuad4.php#aaf65b62bfcdb0289c45ceec5de73ff02">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00114"></a>00114                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00115"></a>00115 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classInfQuad4.php#aec4d24025ceb56bd82e099403ce198d4">is_node_on_side</a>(n,e); }
<a name="l00116"></a>00116   
<a name="l00120"></a><a class="code" href="classInfQuad4.php#aca32dbb24bbedf25dd4486fee6488fa0">00120</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classInfQuad4.php#aca32dbb24bbedf25dd4486fee6488fa0">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>; }
<a name="l00121"></a>00121   
<a name="l00126"></a>00126   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classInfQuad4.php#a3f8da5f1d31dc73323d70c21d0cc7f33">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00127"></a>00127                             <span class="keywordtype">bool</span> proxy) <span class="keyword">const</span>;
<a name="l00128"></a>00128 <span class="comment">/*    {  */</span>
<a name="l00129"></a>00129 <span class="comment">/*     // side() returns an AutoPtr to a DofObject, hence need to cast to Elem* */</span>
<a name="l00130"></a>00130 <span class="comment">/*     AutoPtr&lt;DofObject&gt; ap_dof_object(this-&gt;side(i)); */</span>
<a name="l00131"></a>00131 <span class="comment">/*     Elem* side = dynamic_cast&lt;Elem*&gt;(ap_dof_object.release()); */</span>
<a name="l00132"></a>00132 <span class="comment">/*     libmesh_assert(side); // libmesh_assert that the cast was successful */</span>
<a name="l00133"></a>00133     
<a name="l00134"></a>00134 <span class="comment">/*     AutoPtr&lt;Elem&gt; ap(side); */</span>
<a name="l00135"></a>00135 <span class="comment">/*     return ap; */</span>
<a name="l00136"></a>00136 <span class="comment">/*   } */</span>
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classInfQuad4.php#a6def554b78ee6d634b9232ca9e3547cc">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sf,
<a name="l00139"></a>00139                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00140"></a>00140                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 <span class="comment">//   void tecplot_connectivity(const unsigned int sf,</span>
<a name="l00143"></a>00143 <span class="comment">//                          std::vector&lt;unsigned int&gt;&amp; conn) const;</span>
<a name="l00144"></a>00144   
<a name="l00145"></a>00145 <span class="comment">//   void vtk_connectivity(const unsigned int sc,</span>
<a name="l00146"></a>00146 <span class="comment">//                      std::vector&lt;unsigned int&gt;*conn = NULL) const;</span>
<a name="l00147"></a>00147   
<a name="l00148"></a>00148 <span class="comment">//   unsigned int vtk_element_type (const unsigned int) const</span>
<a name="l00149"></a>00149 <span class="comment">//   { return 9; }</span>
<a name="l00150"></a>00150   
<a name="l00157"></a>00157   <span class="keywordtype">bool</span> <a class="code" href="classInfQuad4.php#a82ace4a66d2d714f5661a62268d0d4a5">contains_point</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00158"></a>00158 
<a name="l00163"></a><a class="code" href="classInfQuad4.php#ac6f04b4c279c4438687cbcdd22e0b887">00163</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfQuad4.php#ac6f04b4c279c4438687cbcdd22e0b887">side_nodes_map</a>[3][2];
<a name="l00164"></a>00164 
<a name="l00165"></a>00165   
<a name="l00166"></a>00166 <span class="keyword">protected</span>:
<a name="l00167"></a>00167   
<a name="l00168"></a>00168   
<a name="l00169"></a>00169 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00170"></a>00170 <span class="preprocessor"></span>  
<a name="l00174"></a><a class="code" href="classInfQuad4.php#ae7b8e9a4313e1ceabd711cb33671f1d6">00174</a>   <span class="keywordtype">float</span> <a class="code" href="classInfQuad4.php#ae7b8e9a4313e1ceabd711cb33671f1d6">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00175"></a>00175                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00176"></a>00176                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00177"></a>00177 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classInfQuad4.php#a660ba3405ba0350e8bbbef4337dec073">_embedding_matrix</a>[i][j][k]; }
<a name="l00178"></a>00178 
<a name="l00183"></a><a class="code" href="classInfQuad4.php#a660ba3405ba0350e8bbbef4337dec073">00183</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classInfQuad4.php#a660ba3405ba0350e8bbbef4337dec073">_embedding_matrix</a>[2][4][4];
<a name="l00184"></a>00184   
<a name="l00185"></a>00185 <span class="preprocessor">#endif</span>
<a name="l00186"></a>00186 <span class="preprocessor"></span>    
<a name="l00187"></a>00187 };
<a name="l00188"></a>00188   
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00191"></a>00191 <span class="preprocessor"></span>
<a name="l00192"></a>00192 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
