<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1665b3ccb6c776ec6797fe204e2359e5.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>face_inf_quad6.C</h1>  </div>
</div>
<div class="contents">
<a href="face__inf__quad6_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_inf_quad6.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes cont&#39;d</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;face_inf_quad6.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;edge_edge3.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;side.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;edge_inf_edge2.h&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00037"></a>00037 <span class="comment">// InfQuad6 class static member initializations</span>
<a name="l00038"></a>00038 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfQuad6.php#a0ab74e2228c0a5737685752473be1af0">InfQuad6::side_nodes_map</a>[3][3] =
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040   {0, 1, 4}, <span class="comment">// Side 0</span>
<a name="l00041"></a>00041   {1, 3},    <span class="comment">// Side 1</span>
<a name="l00042"></a>00042   {0, 2}     <span class="comment">// Side 2</span>
<a name="l00043"></a>00043 };
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00047"></a>00047 <span class="comment">// InfQuad6 class member functions</span>
<a name="l00048"></a>00048 
<a name="l00049"></a><a class="code" href="classInfQuad6.php#adea0af0d2fae58321df9bbb262cc5229">00049</a> <span class="keywordtype">bool</span> <a class="code" href="classInfQuad6.php#adea0af0d2fae58321df9bbb262cc5229">InfQuad6::is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00050"></a>00050 <span class="keyword"></span>{
<a name="l00051"></a>00051   <span class="keywordflow">if</span> (i &lt; 2)
<a name="l00052"></a>00052     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00053"></a>00053   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00054"></a>00054 }
<a name="l00055"></a>00055 
<a name="l00056"></a><a class="code" href="classInfQuad6.php#a761751f546e9463e56e304fe3e31c021">00056</a> <span class="keywordtype">bool</span> <a class="code" href="classInfQuad6.php#a761751f546e9463e56e304fe3e31c021">InfQuad6::is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00057"></a>00057 <span class="keyword"></span>{
<a name="l00058"></a>00058   <span class="keywordflow">if</span> (i &lt; 2)
<a name="l00059"></a>00059     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00060"></a>00060   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00061"></a>00061 }
<a name="l00062"></a>00062 
<a name="l00063"></a><a class="code" href="classInfQuad6.php#a10f5de7ec9d6d1c4196fbb3d17dc2d77">00063</a> <span class="keywordtype">bool</span> <a class="code" href="classInfQuad6.php#a10f5de7ec9d6d1c4196fbb3d17dc2d77">InfQuad6::is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00064"></a>00064 <span class="keyword"></span>{
<a name="l00065"></a>00065   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00066"></a>00066 }
<a name="l00067"></a>00067 
<a name="l00068"></a><a class="code" href="classInfQuad6.php#a077fc0aa1a2fbabca60936f28a4fafc7">00068</a> <span class="keywordtype">bool</span> <a class="code" href="classInfQuad6.php#a077fc0aa1a2fbabca60936f28a4fafc7">InfQuad6::is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00069"></a>00069                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00070"></a>00070 <span class="keyword"></span>{
<a name="l00071"></a>00071   libmesh_assert(s &lt; <a class="code" href="classInfQuad.php#a0e69da72f3fdd45d53a251017f38b89b">n_sides</a>());
<a name="l00072"></a>00072   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 3; ++i)
<a name="l00073"></a>00073     <span class="keywordflow">if</span> (<a class="code" href="classInfQuad6.php#a0ab74e2228c0a5737685752473be1af0">side_nodes_map</a>[s][i] == n)
<a name="l00074"></a>00074       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00075"></a>00075   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00076"></a>00076 }
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00079"></a>00079 <span class="preprocessor"></span>
<a name="l00080"></a>00080 <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classInfQuad6.php#a0a1d8ecdce31e5fe4d330f5ef25b3e7b">InfQuad6::_embedding_matrix</a>[2][6][6] =
<a name="l00081"></a>00081 {
<a name="l00082"></a>00082   <span class="comment">// embedding matrix for child 0</span>
<a name="l00083"></a>00083   {
<a name="l00084"></a>00084     <span class="comment">//     0       1       2       3       4       5th parent node</span>
<a name="l00085"></a>00085     {    1.0,    0.0,    0.0,    0.0,    0.0,    0.0 }, <span class="comment">// 0th child node</span>
<a name="l00086"></a>00086     {    0.0,    0.0,    0.0,    0.0,    1.0,    0.0 }, <span class="comment">// 1</span>
<a name="l00087"></a>00087     {    0.0,    0.0,    1.0,    0.0,    0.0,    0.0 }, <span class="comment">// 2</span>
<a name="l00088"></a>00088     {    0.0,    0.0,    0.0,    0.0,    0.0,    1.0 }, <span class="comment">// 3</span>
<a name="l00089"></a>00089     {  0.375, -0.125,    0.0,    0.0,   0.75,    0.0 }, <span class="comment">// 4</span>
<a name="l00090"></a>00090     {    0.0,    0.0,  0.375, -0.125,    0.0,   0.75 }  <span class="comment">// 5</span>
<a name="l00091"></a>00091   },
<a name="l00092"></a>00092 
<a name="l00093"></a>00093   <span class="comment">// embedding matrix for child 1</span>
<a name="l00094"></a>00094   {
<a name="l00095"></a>00095     <span class="comment">//     0       1       2       3       4       5th parent node</span>
<a name="l00096"></a>00096     {    0.0,    0.0,    0.0,    0.0,    1.0,    0.0 }, <span class="comment">// 0th child node</span>
<a name="l00097"></a>00097     {    0.0,    1.0,    0.0,    0.0,    0.0,    0.0 }, <span class="comment">// 1</span>
<a name="l00098"></a>00098     {    0.0,    0.0,    0.0,    0.0,    0.0,    1.0 }, <span class="comment">// 2</span>
<a name="l00099"></a>00099     {    0.0,    0.0,    0.0,    1.0,    0.0,    0.0 }, <span class="comment">// 3</span>
<a name="l00100"></a>00100     { -0.125,  0.375,    0.0,    0.0,   0.75,    0.0 }, <span class="comment">// 4</span>
<a name="l00101"></a>00101     {    0.0,    0.0, -0.125,  0.375,    0.0,   0.75 }  <span class="comment">// 5</span>
<a name="l00102"></a>00102   }
<a name="l00103"></a>00103 };
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 <span class="preprocessor">#endif</span>
<a name="l00106"></a>00106 <span class="preprocessor"></span>
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 
<a name="l00110"></a><a class="code" href="classInfQuad6.php#ae874b0749aa3b30d0557e2a635dc19ca">00110</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classInfQuad6.php#ae874b0749aa3b30d0557e2a635dc19ca">InfQuad6::build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00111"></a>00111                                     <span class="keywordtype">bool</span> proxy)<span class="keyword"> const</span>
<a name="l00112"></a>00112 <span class="keyword"></span>{
<a name="l00113"></a>00113   <span class="comment">// libmesh_assert (i &lt; this-&gt;n_sides());</span>
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   <span class="keywordflow">if</span> (proxy)
<a name="l00116"></a>00116     {
<a name="l00117"></a>00117       <span class="keywordflow">switch</span> (i)
<a name="l00118"></a>00118         {
<a name="l00119"></a>00119         <span class="keywordflow">case</span> 0:
<a name="l00120"></a>00120           {
<a name="l00121"></a>00121             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classSide.php">Side&lt;Edge3,InfQuad6&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00122"></a>00122             <span class="keywordflow">return</span> ap;
<a name="l00123"></a>00123           }
<a name="l00124"></a>00124         <span class="keywordflow">case</span> 1:
<a name="l00125"></a>00125         <span class="keywordflow">case</span> 2:
<a name="l00126"></a>00126           {
<a name="l00127"></a>00127             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classSide.php">Side&lt;InfEdge2,InfQuad6&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00128"></a>00128             <span class="keywordflow">return</span> ap;
<a name="l00129"></a>00129           }
<a name="l00130"></a>00130         <span class="keywordflow">default</span>:
<a name="l00131"></a>00131           libmesh_error();
<a name="l00132"></a>00132         }
<a name="l00133"></a>00133     }
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   <span class="keywordflow">else</span>
<a name="l00136"></a>00136     {
<a name="l00137"></a>00137       <span class="keywordflow">switch</span> (i)
<a name="l00138"></a>00138         {
<a name="l00139"></a>00139         <span class="keywordflow">case</span> 0:
<a name="l00140"></a>00140           {
<a name="l00141"></a>00141             <a class="code" href="classEdge3.php">Edge3</a>* edge = <span class="keyword">new</span> <a class="code" href="classEdge3.php">Edge3</a>;
<a name="l00142"></a>00142 
<a name="l00143"></a>00143             edge-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00144"></a>00144             edge-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00145"></a>00145             edge-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(2) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(4);
<a name="l00146"></a>00146         
<a name="l00147"></a>00147             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(edge);  <span class="keywordflow">return</span> ap;
<a name="l00148"></a>00148           }
<a name="l00149"></a>00149 
<a name="l00150"></a>00150         <span class="keywordflow">case</span> 1:
<a name="l00151"></a>00151           {
<a name="l00152"></a>00152             <span class="comment">// adjacent to another infinite element     </span>
<a name="l00153"></a>00153             <a class="code" href="classInfEdge2.php">InfEdge2</a>* edge = <span class="keyword">new</span> <a class="code" href="classInfEdge2.php">InfEdge2</a>;
<a name="l00154"></a>00154 
<a name="l00155"></a>00155             edge-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00156"></a>00156             edge-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00157"></a>00157 
<a name="l00158"></a>00158             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(edge);  <span class="keywordflow">return</span> ap;
<a name="l00159"></a>00159           }
<a name="l00160"></a>00160 
<a name="l00161"></a>00161         <span class="keywordflow">case</span> 2:
<a name="l00162"></a>00162           {
<a name="l00163"></a>00163             <span class="comment">// adjacent to another infinite element     </span>
<a name="l00164"></a>00164             <a class="code" href="classInfEdge2.php">InfEdge2</a>* edge = <span class="keyword">new</span> <a class="code" href="classInfEdge2.php">InfEdge2</a>;
<a name="l00165"></a>00165 
<a name="l00166"></a>00166             edge-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0); <span class="comment">// be aware of swapped nodes,</span>
<a name="l00167"></a>00167             edge-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2); <span class="comment">// compared to conventional side numbering</span>
<a name="l00168"></a>00168 
<a name="l00169"></a>00169             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(edge);  <span class="keywordflow">return</span> ap;
<a name="l00170"></a>00170           }
<a name="l00171"></a>00171         <span class="keywordflow">default</span>:
<a name="l00172"></a>00172           {
<a name="l00173"></a>00173             libmesh_error();
<a name="l00174"></a>00174             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00175"></a>00175           }
<a name="l00176"></a>00176         }
<a name="l00177"></a>00177     }
<a name="l00178"></a>00178 
<a name="l00179"></a>00179   <span class="comment">// We will never get here...  </span>
<a name="l00180"></a>00180   libmesh_error();
<a name="l00181"></a>00181   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00182"></a>00182 }
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 
<a name="l00187"></a><a class="code" href="classInfQuad6.php#a3df4fb3ccff964813b1d9ed9d181baf2">00187</a> <span class="keywordtype">void</span> <a class="code" href="classInfQuad6.php#a3df4fb3ccff964813b1d9ed9d181baf2">InfQuad6::connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sf,
<a name="l00188"></a>00188                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00189"></a>00189                             std::vector&lt;unsigned int&gt;&amp; conn)<span class="keyword"> const</span>
<a name="l00190"></a>00190 <span class="keyword"></span>{
<a name="l00191"></a>00191   libmesh_assert (sf &lt; this-&gt;<a class="code" href="classInfQuad6.php#a1a20b03c6896e08d8b48f21ddd16d9d5">n_sub_elem</a>());
<a name="l00192"></a>00192   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00193"></a>00193 
<a name="l00194"></a>00194   conn.resize(4);
<a name="l00195"></a>00195 
<a name="l00196"></a>00196   <span class="keywordflow">switch</span> (iop)
<a name="l00197"></a>00197     {
<a name="l00198"></a>00198     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00199"></a>00199       {
<a name="l00200"></a>00200         <span class="keywordflow">switch</span>(sf)
<a name="l00201"></a>00201           {
<a name="l00202"></a>00202           <span class="keywordflow">case</span> 0:
<a name="l00203"></a>00203             <span class="comment">// linear sub-quad 0</span>
<a name="l00204"></a>00204             conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0)+1;
<a name="l00205"></a>00205             conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(4)+1;
<a name="l00206"></a>00206             conn[2] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(5)+1;
<a name="l00207"></a>00207             conn[3] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2)+1;
<a name="l00208"></a>00208 
<a name="l00209"></a>00209             <span class="keywordflow">return</span>;
<a name="l00210"></a>00210 
<a name="l00211"></a>00211           <span class="keywordflow">case</span> 1:
<a name="l00212"></a>00212             <span class="comment">// linear sub-quad 1</span>
<a name="l00213"></a>00213             conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(4)+1;
<a name="l00214"></a>00214             conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1)+1;
<a name="l00215"></a>00215             conn[2] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3)+1;
<a name="l00216"></a>00216             conn[3] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(5)+1;
<a name="l00217"></a>00217 
<a name="l00218"></a>00218             <span class="keywordflow">return</span>;
<a name="l00219"></a>00219             
<a name="l00220"></a>00220           <span class="keywordflow">default</span>:
<a name="l00221"></a>00221             libmesh_error();
<a name="l00222"></a>00222           }
<a name="l00223"></a>00223       }
<a name="l00224"></a>00224       
<a name="l00225"></a>00225     <span class="keywordflow">default</span>:
<a name="l00226"></a>00226       libmesh_error();
<a name="l00227"></a>00227     }
<a name="l00228"></a>00228   
<a name="l00229"></a>00229   libmesh_error();
<a name="l00230"></a>00230 }
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 
<a name="l00235"></a><a class="code" href="classInfQuad6.php#a92db2d80a9e68f74bebf87a4850389f2">00235</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classInfQuad6.php#a92db2d80a9e68f74bebf87a4850389f2">InfQuad6::second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00236"></a>00236                                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v)<span class="keyword"> const</span>
<a name="l00237"></a>00237 <span class="keyword"></span>{ 
<a name="l00238"></a>00238   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classInfQuad.php#a3ae05ae6200783811f2c53656223ed29">n_vertices</a>());
<a name="l00239"></a>00239   libmesh_assert (n &lt;  this-&gt;<a class="code" href="classInfQuad6.php#a9c8d46a7144090450dc99daf6b44766d">n_nodes</a>());
<a name="l00240"></a>00240   libmesh_assert (v &lt; 2);
<a name="l00241"></a>00241   <span class="keywordflow">return</span> <a class="code" href="classInfQuad6.php#a2b1639a1708a73918747c62656f0ce0f">_second_order_adjacent_vertices</a>[n-this-&gt;<a class="code" href="classInfQuad.php#a3ae05ae6200783811f2c53656223ed29">n_vertices</a>()][v]; 
<a name="l00242"></a>00242 }
<a name="l00243"></a>00243 
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classInfQuad6.php#a2b1639a1708a73918747c62656f0ce0f">InfQuad6::_second_order_adjacent_vertices</a>[2][2] = 
<a name="l00247"></a>00247 {
<a name="l00248"></a>00248   {0, 1}, <span class="comment">// vertices adjacent to node 4</span>
<a name="l00249"></a>00249   {2, 3}  <span class="comment">// vertices adjacent to node 5  </span>
<a name="l00250"></a>00250 };
<a name="l00251"></a>00251 
<a name="l00252"></a>00252 
<a name="l00253"></a>00253 
<a name="l00254"></a>00254 std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00255"></a><a class="code" href="classInfQuad6.php#a7df44dd01ebe4003bb87709af640fc8b">00255</a> <a class="code" href="classInfQuad6.php#a7df44dd01ebe4003bb87709af640fc8b">InfQuad6::second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00256"></a>00256 <span class="keyword"></span>{
<a name="l00257"></a>00257   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classInfQuad.php#a3ae05ae6200783811f2c53656223ed29">n_vertices</a>());
<a name="l00258"></a>00258   libmesh_assert (n &lt; this-&gt;<a class="code" href="classInfQuad6.php#a9c8d46a7144090450dc99daf6b44766d">n_nodes</a>());
<a name="l00259"></a>00259 
<a name="l00260"></a>00260   <span class="keywordflow">return</span> std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00261"></a>00261     (0, 2*n-7);
<a name="l00262"></a>00262 }
<a name="l00263"></a>00263 
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 
<a name="l00266"></a>00266 
<a name="l00267"></a>00267 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
