<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>face_inf_quad6.h</h1>  </div>
</div>
<div class="contents">
<a href="face__inf__quad6_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_inf_quad6.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __inf_quad6_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __inf_quad6_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// C++ includes</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Local includes</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="face__inf__quad_8h.php">face_inf_quad.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00054"></a>00054 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00055"></a>00055 <span class="comment">// InfQuad6 class definition</span>
<a name="l00056"></a><a class="code" href="classInfQuad6.php">00056</a> <span class="keyword">class </span><a class="code" href="classInfQuad6.php">InfQuad6</a> : <span class="keyword">public</span> <a class="code" href="classInfQuad.php">InfQuad</a>
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058 <span class="keyword">public</span>:
<a name="l00059"></a>00059 
<a name="l00063"></a><a class="code" href="classInfQuad6.php#afa383ff91e8f8eb02432f8f23df679eb">00063</a>   <a class="code" href="classInfQuad6.php#afa383ff91e8f8eb02432f8f23df679eb">InfQuad6</a> (<a class="code" href="classElem.php">Elem</a>* p=NULL):
<a name="l00064"></a>00064     <a class="code" href="classInfQuad.php">InfQuad</a>(<a class="code" href="classInfQuad6.php">InfQuad6</a>::<a class="code" href="classInfQuad6.php#a9c8d46a7144090450dc99daf6b44766d">n_nodes</a>(), p) {}
<a name="l00065"></a>00065 
<a name="l00070"></a><a class="code" href="classInfQuad6.php#a0efe91b62de4ce7b712963a1aaf1b250">00070</a>   <a class="code" href="classInfQuad6.php#afa383ff91e8f8eb02432f8f23df679eb">InfQuad6</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00071"></a>00071             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00072"></a>00072             <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00073"></a>00073     <a class="code" href="classInfQuad.php">InfQuad</a>(nn, ns, p) {}
<a name="l00074"></a>00074   
<a name="l00078"></a><a class="code" href="classInfQuad6.php#a9c8d46a7144090450dc99daf6b44766d">00078</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfQuad6.php#a9c8d46a7144090450dc99daf6b44766d">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 6; }
<a name="l00079"></a>00079   
<a name="l00083"></a><a class="code" href="classInfQuad6.php#ada181e94a72b2dcc76029931e12371ba">00083</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classInfQuad6.php#ada181e94a72b2dcc76029931e12371ba">type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a669ef57bb0d4c72fd22fa0f4febe6ac1">INFQUAD6</a>; }
<a name="l00084"></a>00084   
<a name="l00088"></a><a class="code" href="classInfQuad6.php#a1a20b03c6896e08d8b48f21ddd16d9d5">00088</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfQuad6.php#a1a20b03c6896e08d8b48f21ddd16d9d5">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 2; }
<a name="l00089"></a>00089   
<a name="l00093"></a>00093   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfQuad6.php#adea0af0d2fae58321df9bbb262cc5229">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00094"></a>00094 
<a name="l00098"></a>00098   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfQuad6.php#a761751f546e9463e56e304fe3e31c021">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00099"></a>00099 
<a name="l00103"></a>00103   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfQuad6.php#a10f5de7ec9d6d1c4196fbb3d17dc2d77">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00104"></a>00104   
<a name="l00105"></a>00105   <span class="comment">/*</span>
<a name="l00106"></a>00106 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00107"></a>00107 <span class="comment">   * specified side</span>
<a name="l00108"></a>00108 <span class="comment">   */</span>
<a name="l00109"></a>00109   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfQuad6.php#a077fc0aa1a2fbabca60936f28a4fafc7">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00110"></a>00110                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00111"></a>00111   
<a name="l00112"></a>00112   <span class="comment">/*</span>
<a name="l00113"></a>00113 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00114"></a>00114 <span class="comment">   * specified edge (== is_node_on_side in 2D)</span>
<a name="l00115"></a>00115 <span class="comment">   */</span>
<a name="l00116"></a><a class="code" href="classInfQuad6.php#a5d6340a00adbce63a34d0fb05fd86568">00116</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfQuad6.php#a5d6340a00adbce63a34d0fb05fd86568">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00117"></a>00117                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00118"></a>00118 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classInfQuad6.php#a077fc0aa1a2fbabca60936f28a4fafc7">is_node_on_side</a>(n,e); }
<a name="l00119"></a>00119   
<a name="l00120"></a>00120   
<a name="l00124"></a><a class="code" href="classInfQuad6.php#abe22d8383f43291f550ae7f95830145f">00124</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classInfQuad6.php#abe22d8383f43291f550ae7f95830145f">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>; }
<a name="l00125"></a>00125   
<a name="l00130"></a>00130   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classInfQuad6.php#ae874b0749aa3b30d0557e2a635dc19ca">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00131"></a>00131                             <span class="keywordtype">bool</span> proxy) <span class="keyword">const</span>;
<a name="l00132"></a>00132 
<a name="l00133"></a>00133   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classInfQuad6.php#a3df4fb3ccff964813b1d9ed9d181baf2">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sf,
<a name="l00134"></a>00134                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00135"></a>00135                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00136"></a>00136 
<a name="l00140"></a><a class="code" href="classInfQuad6.php#ab0d072ee7574cfa72fd2afc01ef470ea">00140</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfQuad6.php#ab0d072ee7574cfa72fd2afc01ef470ea">n_second_order_adjacent_vertices</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00141"></a>00141 <span class="keyword">      </span>{ <span class="keywordflow">return</span> 2; }
<a name="l00142"></a>00142 
<a name="l00148"></a>00148   <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classInfQuad6.php#a92db2d80a9e68f74bebf87a4850389f2">second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00149"></a>00149                                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v) <span class="keyword">const</span>;
<a name="l00150"></a>00150   
<a name="l00160"></a>00160   <span class="keyword">virtual</span> std::pair&lt;unsigned short int, unsigned short int&gt; 
<a name="l00161"></a>00161           <a class="code" href="classInfQuad6.php#a7df44dd01ebe4003bb87709af640fc8b">second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span>;
<a name="l00162"></a>00162 
<a name="l00167"></a><a class="code" href="classInfQuad6.php#a0ab74e2228c0a5737685752473be1af0">00167</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfQuad6.php#a0ab74e2228c0a5737685752473be1af0">side_nodes_map</a>[3][3];
<a name="l00168"></a>00168 
<a name="l00169"></a>00169   
<a name="l00170"></a>00170   
<a name="l00171"></a>00171 <span class="keyword">protected</span>:
<a name="l00172"></a>00172   
<a name="l00173"></a>00173   
<a name="l00174"></a>00174 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00175"></a>00175 <span class="preprocessor"></span>  
<a name="l00179"></a><a class="code" href="classInfQuad6.php#aad352e0c9e12395588a8f919ae65f22d">00179</a>   <span class="keywordtype">float</span> <a class="code" href="classInfQuad6.php#aad352e0c9e12395588a8f919ae65f22d">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00180"></a>00180                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00181"></a>00181                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00182"></a>00182 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classInfQuad6.php#a0a1d8ecdce31e5fe4d330f5ef25b3e7b">_embedding_matrix</a>[i][j][k]; }
<a name="l00183"></a>00183 
<a name="l00188"></a><a class="code" href="classInfQuad6.php#a0a1d8ecdce31e5fe4d330f5ef25b3e7b">00188</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classInfQuad6.php#a0a1d8ecdce31e5fe4d330f5ef25b3e7b">_embedding_matrix</a>[2][6][6];
<a name="l00189"></a>00189   
<a name="l00190"></a>00190 <span class="preprocessor">#endif</span>
<a name="l00191"></a>00191 <span class="preprocessor"></span>
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 <span class="keyword">private</span>:
<a name="l00194"></a>00194   
<a name="l00199"></a><a class="code" href="classInfQuad6.php#a2b1639a1708a73918747c62656f0ce0f">00199</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classInfQuad6.php#a2b1639a1708a73918747c62656f0ce0f">_second_order_adjacent_vertices</a>[2][2];
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 };
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00205"></a>00205 <span class="preprocessor"></span>
<a name="l00206"></a>00206 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
