<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>face_inf_quad.h</h1>  </div>
</div>
<div class="contents">
<a href="face__inf__quad_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_inf_quad.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __face_inf_quad_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __face_inf_quad_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward declarations</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00058"></a>00058 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00059"></a>00059 <span class="comment">// InfQuad class definition</span>
<a name="l00060"></a><a class="code" href="classInfQuad.php">00060</a> <span class="keyword">class </span><a class="code" href="classInfQuad.php">InfQuad</a> : <span class="keyword">public</span> <a class="code" href="classElem.php">Elem</a>
<a name="l00061"></a>00061 {
<a name="l00062"></a>00062 <span class="keyword">public</span>:
<a name="l00063"></a>00063 
<a name="l00067"></a><a class="code" href="classInfQuad.php#aed65dd7f7668e2c7b3ebd352b741dc70">00067</a>   <a class="code" href="classInfQuad.php#aed65dd7f7668e2c7b3ebd352b741dc70">InfQuad</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00068"></a>00068            <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00069"></a>00069     <a class="code" href="classElem.php">Elem</a>(nn, <a class="code" href="classInfQuad.php">InfQuad</a>::<a class="code" href="classInfQuad.php#a0e69da72f3fdd45d53a251017f38b89b">n_sides</a>(), p) {}
<a name="l00070"></a>00070 
<a name="l00075"></a><a class="code" href="classInfQuad.php#a327359ec4cfd40e399ac6de44a09a210">00075</a>   <a class="code" href="classInfQuad.php#aed65dd7f7668e2c7b3ebd352b741dc70">InfQuad</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00076"></a>00076            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00077"></a>00077            <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00078"></a>00078     <a class="code" href="classElem.php">Elem</a>(nn, ns, p) {}
<a name="l00079"></a>00079  
<a name="l00083"></a><a class="code" href="classInfQuad.php#ae2e6dc55cb9db57c1c67410b20e3aac6">00083</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfQuad.php#ae2e6dc55cb9db57c1c67410b20e3aac6">dim</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 2; }
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 <span class="comment">//   /**</span>
<a name="l00086"></a>00086 <span class="comment">//    * @returns 2 for the base, 1 otherwise</span>
<a name="l00087"></a>00087 <span class="comment">//    */</span>
<a name="l00088"></a>00088 <span class="comment">//   unsigned int n_children_per_side(const unsigned int s) const;</span>
<a name="l00089"></a>00089 
<a name="l00095"></a><a class="code" href="classInfQuad.php#a0e69da72f3fdd45d53a251017f38b89b">00095</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfQuad.php#a0e69da72f3fdd45d53a251017f38b89b">n_sides</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 3; }
<a name="l00096"></a>00096 
<a name="l00100"></a><a class="code" href="classInfQuad.php#a3ae05ae6200783811f2c53656223ed29">00100</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfQuad.php#a3ae05ae6200783811f2c53656223ed29">n_vertices</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00101"></a>00101 
<a name="l00106"></a><a class="code" href="classInfQuad.php#a87229d1be2eb451729a7d54e80943bfc">00106</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfQuad.php#a87229d1be2eb451729a7d54e80943bfc">n_edges</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 3; }
<a name="l00107"></a>00107 
<a name="l00112"></a><a class="code" href="classInfQuad.php#a182cfe7ad44547e18414adab29dd4f50">00112</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfQuad.php#a182cfe7ad44547e18414adab29dd4f50">n_faces</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; }
<a name="l00113"></a>00113   
<a name="l00117"></a><a class="code" href="classInfQuad.php#acdbaac578cc145ade196241003c61bf5">00117</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfQuad.php#acdbaac578cc145ade196241003c61bf5">n_children</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 2; }
<a name="l00118"></a>00118   
<a name="l00119"></a>00119   <span class="comment">/*</span>
<a name="l00120"></a>00120 <span class="comment">   * @returns true iff the specified child is on the</span>
<a name="l00121"></a>00121 <span class="comment">   * specified side</span>
<a name="l00122"></a>00122 <span class="comment">   */</span>
<a name="l00123"></a>00123   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfQuad.php#a078df57224764961b9dba11e8260ac1c">is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00124"></a>00124                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00125"></a>00125   
<a name="l00131"></a>00131   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfQuad.php#a95156ebd25c47bdadeac7eb1026c8cec">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00132"></a>00132 
<a name="l00137"></a>00137   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> <a class="code" href="classInfQuad.php#a6a796bf632255e540ed45e85abcbdf51">side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00138"></a>00138   
<a name="l00142"></a><a class="code" href="classInfQuad.php#aa5ba73f777cb74b4e1b3c568701cccda">00142</a>   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classInfQuad.php#aa5ba73f777cb74b4e1b3c568701cccda">build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00143"></a>00143 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classElem.php#a554c146bcfb5537636bd77a157f21b85">build_side</a>(i); }
<a name="l00144"></a>00144 
<a name="l00149"></a>00149   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classInfQuad.php#a92f3d0b4dea796797b77d0a540451a4d">quality</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) <span class="keyword">const</span>;
<a name="l00150"></a>00150 
<a name="l00156"></a>00156   std::pair&lt;Real, Real&gt; <a class="code" href="classInfQuad.php#a7a192331afa272a00a0eb4230922b063">qual_bounds</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) <span class="keyword">const</span>;
<a name="l00157"></a>00157 
<a name="l00162"></a><a class="code" href="classInfQuad.php#a105c8c6998143e47feb2857e3d20915c">00162</a>   <span class="keywordtype">bool</span> <a class="code" href="classInfQuad.php#a105c8c6998143e47feb2857e3d20915c">infinite</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00163"></a>00163 
<a name="l00167"></a>00167   <a class="code" href="classPoint.php">Point</a> <a class="code" href="classInfQuad.php#a027becfee3c83a8a14ed9f19ce5ba8f8">origin</a> () <span class="keyword">const</span>;
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 };
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00174"></a>00174 <span class="comment">// InfQuad class member functions</span>
<a name="l00175"></a>00175 <span class="comment">// inline</span>
<a name="l00176"></a>00176 <span class="comment">// unsigned int InfQuad::n_children_per_side(const unsigned int s) const</span>
<a name="l00177"></a>00177 <span class="comment">// {</span>
<a name="l00178"></a>00178 <span class="comment">//   libmesh_assert (s &lt; this-&gt;n_sides());</span>
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 <span class="comment">//   switch (s)</span>
<a name="l00181"></a>00181 <span class="comment">//   {</span>
<a name="l00182"></a>00182 <span class="comment">//     case 0:</span>
<a name="l00183"></a>00183 <span class="comment">//       // every infinite face has 2 children in the base edge</span>
<a name="l00184"></a>00184 <span class="comment">//       return 2;</span>
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 <span class="comment">//     default:</span>
<a name="l00187"></a>00187 <span class="comment">//       // on infinite edges only 1 child</span>
<a name="l00188"></a>00188 <span class="comment">//       return 1;</span>
<a name="l00189"></a>00189 <span class="comment">//   }</span>
<a name="l00190"></a>00190 <span class="comment">// }</span>
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 <span class="keyword">inline</span>
<a name="l00195"></a><a class="code" href="classInfQuad.php#a027becfee3c83a8a14ed9f19ce5ba8f8">00195</a> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classInfQuad.php#a027becfee3c83a8a14ed9f19ce5ba8f8">InfQuad::origin</a> ()<span class="keyword"> const</span>
<a name="l00196"></a>00196 <span class="keyword"></span>{
<a name="l00197"></a>00197   <span class="keywordflow">return</span> ( this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0)*2. - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(this-&gt;<a class="code" href="classInfQuad.php#a3ae05ae6200783811f2c53656223ed29">n_vertices</a>()/2) );
<a name="l00198"></a>00198 }
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00203"></a>00203 <span class="preprocessor"></span>
<a name="l00204"></a>00204 <span class="preprocessor">#endif</span>
<a name="l00205"></a>00205 <span class="preprocessor"></span>
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 
<a name="l00208"></a>00208 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
