<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1665b3ccb6c776ec6797fe204e2359e5.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>face_quad4.C</h1>  </div>
</div>
<div class="contents">
<a href="face__quad4_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_quad4.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// C++ includes</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;side.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;edge_edge2.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;face_quad4.h&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00031"></a>00031 <span class="comment">// Quad class static member initialization</span>
<a name="l00032"></a>00032 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQuad4.php#afff1fbc197221671868f03ad6a9e8555">Quad4::side_nodes_map</a>[4][2] =
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034   {0, 1}, <span class="comment">// Side 0</span>
<a name="l00035"></a>00035   {1, 2}, <span class="comment">// Side 1</span>
<a name="l00036"></a>00036   {2, 3}, <span class="comment">// Side 2</span>
<a name="l00037"></a>00037   {3, 0}  <span class="comment">// Side 3</span>
<a name="l00038"></a>00038 };
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span>
<a name="l00043"></a>00043 <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classQuad4.php#ae0ccacd96028c4ad0513118beff4d419">Quad4::_embedding_matrix</a>[4][4][4] =
<a name="l00044"></a>00044 {
<a name="l00045"></a>00045   <span class="comment">// embedding matrix for child 0</span>
<a name="l00046"></a>00046   {
<a name="l00047"></a>00047     <span class="comment">// 0    1    2    3</span>
<a name="l00048"></a>00048     {1.0, 0.0, 0.0, 0.0}, <span class="comment">// 0</span>
<a name="l00049"></a>00049     {0.5, 0.5, 0.0, 0.0}, <span class="comment">// 1</span>
<a name="l00050"></a>00050     {.25, .25, .25, .25}, <span class="comment">// 2</span>
<a name="l00051"></a>00051     {0.5, 0.0, 0.0, 0.5}  <span class="comment">// 3</span>
<a name="l00052"></a>00052   },
<a name="l00053"></a>00053 
<a name="l00054"></a>00054   <span class="comment">// embedding matrix for child 1</span>
<a name="l00055"></a>00055   {
<a name="l00056"></a>00056     <span class="comment">// 0    1    2    3</span>
<a name="l00057"></a>00057     {0.5, 0.5, 0.0, 0.0}, <span class="comment">// 0</span>
<a name="l00058"></a>00058     {0.0, 1.0, 0.0, 0.0}, <span class="comment">// 1</span>
<a name="l00059"></a>00059     {0.0, 0.5, 0.5, 0.0}, <span class="comment">// 2</span>
<a name="l00060"></a>00060     {.25, .25, .25, .25}  <span class="comment">// 3</span>
<a name="l00061"></a>00061   },
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   <span class="comment">// embedding matrix for child 2</span>
<a name="l00064"></a>00064   {
<a name="l00065"></a>00065     <span class="comment">// 0    1    2    3</span>
<a name="l00066"></a>00066     {0.5, 0.0, 0.0, 0.5}, <span class="comment">// 0</span>
<a name="l00067"></a>00067     {.25, .25, .25, .25}, <span class="comment">// 1</span>
<a name="l00068"></a>00068     {0.0, 0.0, 0.5, 0.5}, <span class="comment">// 2</span>
<a name="l00069"></a>00069     {0.0, 0.0, 0.0, 1.0}  <span class="comment">// 3</span>
<a name="l00070"></a>00070   },
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   <span class="comment">// embedding matrix for child 3</span>
<a name="l00073"></a>00073   {
<a name="l00074"></a>00074     <span class="comment">// 0    1    2    3</span>
<a name="l00075"></a>00075     {.25, .25, .25, .25}, <span class="comment">// 0</span>
<a name="l00076"></a>00076     {0.0, 0.5, 0.5, 0.0}, <span class="comment">// 1</span>
<a name="l00077"></a>00077     {0.0, 0.0, 1.0, 0.0}, <span class="comment">// 2</span>
<a name="l00078"></a>00078     {0.0, 0.0, 0.5, 0.5}  <span class="comment">// 3</span>
<a name="l00079"></a>00079   }
<a name="l00080"></a>00080 };
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 <span class="preprocessor">#endif</span>
<a name="l00083"></a>00083 <span class="preprocessor"></span>
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00089"></a>00089 <span class="comment">// Quad4 class member functions</span>
<a name="l00090"></a>00090 
<a name="l00091"></a><a class="code" href="classQuad4.php#a8ae459e10a03bc7559baf321b3b5b9c9">00091</a> <span class="keywordtype">bool</span> <a class="code" href="classQuad4.php#a8ae459e10a03bc7559baf321b3b5b9c9">Quad4::is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00092"></a>00092 <span class="keyword"></span>{
<a name="l00093"></a>00093   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00094"></a>00094 }
<a name="l00095"></a>00095 
<a name="l00096"></a><a class="code" href="classQuad4.php#ac7a13193887008fd84db6d0072ad3f08">00096</a> <span class="keywordtype">bool</span> <a class="code" href="classQuad4.php#ac7a13193887008fd84db6d0072ad3f08">Quad4::is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00097"></a>00097 <span class="keyword"></span>{
<a name="l00098"></a>00098   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00099"></a>00099 }
<a name="l00100"></a>00100 
<a name="l00101"></a><a class="code" href="classQuad4.php#a89087448df40124989aee9e65e2d56b5">00101</a> <span class="keywordtype">bool</span> <a class="code" href="classQuad4.php#a89087448df40124989aee9e65e2d56b5">Quad4::is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00102"></a>00102 <span class="keyword"></span>{
<a name="l00103"></a>00103   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00104"></a>00104 }
<a name="l00105"></a>00105 
<a name="l00106"></a><a class="code" href="classQuad4.php#a5535e2876dff95d46dc47883e94619ec">00106</a> <span class="keywordtype">bool</span> <a class="code" href="classQuad4.php#a5535e2876dff95d46dc47883e94619ec">Quad4::is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00107"></a>00107                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00108"></a>00108 <span class="keyword"></span>{
<a name="l00109"></a>00109   libmesh_assert(s &lt; <a class="code" href="classQuad.php#a91925fa9fa90565420b633182d67096a">n_sides</a>());
<a name="l00110"></a>00110   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 2; ++i)
<a name="l00111"></a>00111     <span class="keywordflow">if</span> (<a class="code" href="classQuad4.php#afff1fbc197221671868f03ad6a9e8555">side_nodes_map</a>[s][i] == n)
<a name="l00112"></a>00112       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00113"></a>00113   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00114"></a>00114 }
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a><a class="code" href="classQuad4.php#afa89defc742224e7549ae637699baa7b">00118</a> <span class="keywordtype">bool</span> <a class="code" href="classQuad4.php#afa89defc742224e7549ae637699baa7b">Quad4::has_affine_map</a>()<span class="keyword"> const</span>
<a name="l00119"></a>00119 <span class="keyword"></span>{
<a name="l00120"></a>00120   <a class="code" href="classPoint.php">Point</a> v = this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0);
<a name="l00121"></a>00121   <span class="keywordflow">return</span> (v.<a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">relative_fuzzy_equals</a>(this-&gt;point(2) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1)));
<a name="l00122"></a>00122 }
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a><a class="code" href="classQuad4.php#a39ed37ca3d4795ebab75818eb8e1202e">00126</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classQuad4.php#a39ed37ca3d4795ebab75818eb8e1202e">Quad4::build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00127"></a>00127                                  <span class="keywordtype">bool</span> proxy)<span class="keyword"> const</span>
<a name="l00128"></a>00128 <span class="keyword"></span>{
<a name="l00129"></a>00129   libmesh_assert (i &lt; this-&gt;<a class="code" href="classQuad.php#a91925fa9fa90565420b633182d67096a">n_sides</a>());
<a name="l00130"></a>00130 
<a name="l00131"></a>00131   <span class="keywordflow">if</span> (proxy)
<a name="l00132"></a>00132     {
<a name="l00133"></a>00133       <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classSide.php">Side&lt;Edge2,Quad4&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00134"></a>00134       <span class="keywordflow">return</span> ap;
<a name="l00135"></a>00135     }
<a name="l00136"></a>00136 
<a name="l00137"></a>00137   <span class="keywordflow">else</span>
<a name="l00138"></a>00138     {
<a name="l00139"></a>00139 
<a name="l00140"></a>00140       <span class="keywordflow">switch</span> (i)
<a name="l00141"></a>00141         {
<a name="l00142"></a>00142         <span class="keywordflow">case</span> 0:
<a name="l00143"></a>00143           {
<a name="l00144"></a>00144             <a class="code" href="classEdge2.php">Edge2</a>* edge = <span class="keyword">new</span> <a class="code" href="classEdge2.php">Edge2</a>;
<a name="l00145"></a>00145 
<a name="l00146"></a>00146             edge-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00147"></a>00147             edge-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00148"></a>00148         
<a name="l00149"></a>00149             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(edge);  <span class="keywordflow">return</span> ap;
<a name="l00150"></a>00150           }
<a name="l00151"></a>00151         <span class="keywordflow">case</span> 1:
<a name="l00152"></a>00152           {
<a name="l00153"></a>00153             <a class="code" href="classEdge2.php">Edge2</a>* edge = <span class="keyword">new</span> <a class="code" href="classEdge2.php">Edge2</a>;
<a name="l00154"></a>00154 
<a name="l00155"></a>00155             edge-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1);
<a name="l00156"></a>00156             edge-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00157"></a>00157         
<a name="l00158"></a>00158             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(edge);  <span class="keywordflow">return</span> ap;
<a name="l00159"></a>00159           }
<a name="l00160"></a>00160         <span class="keywordflow">case</span> 2:
<a name="l00161"></a>00161           {
<a name="l00162"></a>00162             <a class="code" href="classEdge2.php">Edge2</a>* edge = <span class="keyword">new</span> <a class="code" href="classEdge2.php">Edge2</a>;
<a name="l00163"></a>00163 
<a name="l00164"></a>00164             edge-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(2);
<a name="l00165"></a>00165             edge-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00166"></a>00166         
<a name="l00167"></a>00167             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(edge);  <span class="keywordflow">return</span> ap;
<a name="l00168"></a>00168           }
<a name="l00169"></a>00169         <span class="keywordflow">case</span> 3:
<a name="l00170"></a>00170           {
<a name="l00171"></a>00171             <a class="code" href="classEdge2.php">Edge2</a>* edge = <span class="keyword">new</span> <a class="code" href="classEdge2.php">Edge2</a>;
<a name="l00172"></a>00172 
<a name="l00173"></a>00173             edge-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(0) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(3);
<a name="l00174"></a>00174             edge-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(1) = this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0);
<a name="l00175"></a>00175         
<a name="l00176"></a>00176             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(edge);  <span class="keywordflow">return</span> ap;
<a name="l00177"></a>00177           }
<a name="l00178"></a>00178         <span class="keywordflow">default</span>:
<a name="l00179"></a>00179           {
<a name="l00180"></a>00180             libmesh_error();
<a name="l00181"></a>00181           }
<a name="l00182"></a>00182         }
<a name="l00183"></a>00183     }
<a name="l00184"></a>00184 
<a name="l00185"></a>00185   <span class="comment">// We will never get here...</span>
<a name="l00186"></a>00186   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00187"></a>00187 }
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 
<a name="l00193"></a><a class="code" href="classQuad4.php#a0527e6f1ffe4cd96dfb340d5f672e2c2">00193</a> <span class="keywordtype">void</span> <a class="code" href="classQuad4.php#a0527e6f1ffe4cd96dfb340d5f672e2c2">Quad4::connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sf,
<a name="l00194"></a>00194                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00195"></a>00195                          std::vector&lt;unsigned int&gt;&amp; conn)<span class="keyword"> const</span>
<a name="l00196"></a>00196 <span class="keyword"></span>{
<a name="l00197"></a>00197   libmesh_assert (sf &lt; this-&gt;<a class="code" href="classQuad4.php#a5374c82eae3387604495496d6f59b359">n_sub_elem</a>());
<a name="l00198"></a>00198   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00199"></a>00199 
<a name="l00200"></a>00200   <span class="comment">// Create storage.</span>
<a name="l00201"></a>00201   conn.resize(4);
<a name="l00202"></a>00202 
<a name="l00203"></a>00203   <span class="keywordflow">switch</span> (iop)
<a name="l00204"></a>00204     {
<a name="l00205"></a>00205     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00206"></a>00206       {
<a name="l00207"></a>00207         conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0)+1;
<a name="l00208"></a>00208         conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1)+1;
<a name="l00209"></a>00209         conn[2] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2)+1;
<a name="l00210"></a>00210         conn[3] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3)+1;
<a name="l00211"></a>00211         <span class="keywordflow">return</span>;
<a name="l00212"></a>00212       }
<a name="l00213"></a>00213 
<a name="l00214"></a>00214     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa1affb8987f83b5e4acb22d9401dd44ef">VTK</a>:
<a name="l00215"></a>00215       {
<a name="l00216"></a>00216         conn[0] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0);
<a name="l00217"></a>00217         conn[1] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1);
<a name="l00218"></a>00218         conn[2] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(2);
<a name="l00219"></a>00219         conn[3] = this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(3);
<a name="l00220"></a>00220         <span class="keywordflow">return</span>;
<a name="l00221"></a>00221       }
<a name="l00222"></a>00222 
<a name="l00223"></a>00223     <span class="keywordflow">default</span>:
<a name="l00224"></a>00224       libmesh_error();
<a name="l00225"></a>00225     }
<a name="l00226"></a>00226 
<a name="l00227"></a>00227   libmesh_error();
<a name="l00228"></a>00228 }
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 
<a name="l00232"></a><a class="code" href="classQuad4.php#a71a2cd8d8b2f9cb5d49b55bc7dba6e64">00232</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classQuad4.php#a71a2cd8d8b2f9cb5d49b55bc7dba6e64">Quad4::volume</a> ()<span class="keyword"> const</span>
<a name="l00233"></a>00233 <span class="keyword"></span>{
<a name="l00234"></a>00234   <span class="comment">// The A,B,C,D naming scheme here corresponds exactly to the</span>
<a name="l00235"></a>00235   <span class="comment">// libmesh counter-clockwise numbering scheme.</span>
<a name="l00236"></a>00236   
<a name="l00237"></a>00237   <span class="comment">//        3           2        D           C</span>
<a name="l00238"></a>00238   <span class="comment">// QUAD4: o-----------o        o-----------o</span>
<a name="l00239"></a>00239   <span class="comment">//        |           |        |           |</span>
<a name="l00240"></a>00240   <span class="comment">//        |           |        |           |</span>
<a name="l00241"></a>00241   <span class="comment">//        |           |        |           |</span>
<a name="l00242"></a>00242   <span class="comment">//        |           |        |           |</span>
<a name="l00243"></a>00243   <span class="comment">//        |           |        |           |</span>
<a name="l00244"></a>00244   <span class="comment">//        o-----------o        o-----------o</span>
<a name="l00245"></a>00245   <span class="comment">//        0           1        A           B</span>
<a name="l00246"></a>00246   
<a name="l00247"></a>00247   <span class="comment">// Vector pointing from A to C</span>
<a name="l00248"></a>00248   <a class="code" href="classPoint.php">Point</a> AC ( this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0) );
<a name="l00249"></a>00249   
<a name="l00250"></a>00250   <span class="comment">// Vector pointing from A to B</span>
<a name="l00251"></a>00251   <a class="code" href="classPoint.php">Point</a> AB ( this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0) );
<a name="l00252"></a>00252 
<a name="l00253"></a>00253   <span class="comment">// Vector pointing from A to D</span>
<a name="l00254"></a>00254   <a class="code" href="classPoint.php">Point</a> AD ( this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0) );
<a name="l00255"></a>00255 
<a name="l00256"></a>00256   <span class="comment">// The diagonal vector minus the side vectors</span>
<a name="l00257"></a>00257   <a class="code" href="classPoint.php">Point</a> AC_AB_AD (AC - AB - AD);
<a name="l00258"></a>00258     
<a name="l00259"></a>00259   <span class="comment">// Check for quick return for planar QUAD4.  This will</span>
<a name="l00260"></a>00260   <span class="comment">// be the most common case, occuring for all purely 2D meshes.</span>
<a name="l00261"></a>00261   <span class="keywordflow">if</span> (AC_AB_AD == <a class="code" href="classPoint.php">Point</a>(0.,0.,0.))
<a name="l00262"></a>00262     <span class="keywordflow">return</span> AB.<a class="code" href="classTypeVector.php#a1347e1223f3e31f8a2c0496736e60dc5">cross</a>(AD).size();
<a name="l00263"></a>00263   
<a name="l00264"></a>00264   <span class="keywordflow">else</span>
<a name="l00265"></a>00265     {
<a name="l00266"></a>00266       <span class="comment">// Use 2x2 quadrature to approximate the surface area.  (The</span>
<a name="l00267"></a>00267       <span class="comment">// true integral is too difficult to compute analytically.)  The</span>
<a name="l00268"></a>00268       <span class="comment">// accuracy here is exactly the same as would be obtained via a</span>
<a name="l00269"></a>00269       <span class="comment">// call to Elem::volume(), however it is a bit more optimized to</span>
<a name="l00270"></a>00270       <span class="comment">// do it this way.  The technique used is to integrate the magnitude</span>
<a name="l00271"></a>00271       <span class="comment">// of the normal vector over the whole area.  See for example,</span>
<a name="l00272"></a>00272       <span class="comment">//</span>
<a name="l00273"></a>00273       <span class="comment">// Y. Zhang, C. Bajaj, G. Xu. Surface Smoothing and Quality</span>
<a name="l00274"></a>00274       <span class="comment">// Improvement of Quadrilateral/Hexahedral Meshes with Geometric</span>
<a name="l00275"></a>00275       <span class="comment">// Flow. The special issue of the Journal Communications in</span>
<a name="l00276"></a>00276       <span class="comment">// Numerical Methods in Engineering (CNME), submitted as an</span>
<a name="l00277"></a>00277       <span class="comment">// invited paper, 2006.</span>
<a name="l00278"></a>00278       <span class="comment">// http://www.ices.utexas.edu/~jessica/paper/quadhexgf/quadhex_geomflow_CNM.pdf</span>
<a name="l00279"></a>00279       
<a name="l00280"></a>00280       <span class="comment">// 4-point rule</span>
<a name="l00281"></a>00281       <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> q[2] = {0.5 - std::sqrt(3.) / 6.,
<a name="l00282"></a>00282                          0.5 + std::sqrt(3.) / 6.};
<a name="l00283"></a>00283 
<a name="l00284"></a>00284       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> vol=0.;
<a name="l00285"></a>00285       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;2; ++i)
<a name="l00286"></a>00286         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;2; ++j)
<a name="l00287"></a>00287           vol += (AB + q[i]*AC_AB_AD).cross(AD + q[j]*AC_AB_AD).size();
<a name="l00288"></a>00288       
<a name="l00289"></a>00289       <span class="keywordflow">return</span> 0.25*vol;
<a name="l00290"></a>00290     }
<a name="l00291"></a>00291 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
