<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>face_quad4.h</h1>  </div>
</div>
<div class="contents">
<a href="face__quad4_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_quad4.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __quad4_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __quad4_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="face__quad_8h.php">face_quad.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Forward declarations</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00055"></a>00055 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00056"></a>00056 <span class="comment">// Quad4 class definition</span>
<a name="l00057"></a><a class="code" href="classQuad4.php">00057</a> <span class="keyword">class </span><a class="code" href="classQuad4.php">Quad4</a> : <span class="keyword">public</span> <a class="code" href="classQuad.php">Quad</a>
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059 <span class="keyword">public</span>:
<a name="l00060"></a>00060 
<a name="l00064"></a><a class="code" href="classQuad4.php#a1683b4e991b97a7966f6a9bdd68b11b3">00064</a>   <a class="code" href="classQuad4.php#a1683b4e991b97a7966f6a9bdd68b11b3">Quad4</a> (<a class="code" href="classElem.php">Elem</a>* p=NULL) :
<a name="l00065"></a>00065     <a class="code" href="classQuad.php">Quad</a>(<a class="code" href="classQuad.php">Quad</a>::<a class="code" href="classQuad.php#a4ac73cef6dd6e5c4c9696e475dbbe0bb">n_nodes</a>(), p) {}
<a name="l00066"></a>00066 
<a name="l00071"></a><a class="code" href="classQuad4.php#a7d6d41ea39733b487347d982db3ee452">00071</a>   <a class="code" href="classQuad4.php#a1683b4e991b97a7966f6a9bdd68b11b3">Quad4</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00072"></a>00072          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00073"></a>00073          <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00074"></a>00074     <a class="code" href="classQuad.php">Quad</a>(nn, ns, p) {}
<a name="l00075"></a>00075   
<a name="l00079"></a><a class="code" href="classQuad4.php#a2013788351d83c22aa388dea6027047d">00079</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classQuad4.php#a2013788351d83c22aa388dea6027047d">type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>; }
<a name="l00080"></a>00080   
<a name="l00084"></a><a class="code" href="classQuad4.php#a5374c82eae3387604495496d6f59b359">00084</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQuad4.php#a5374c82eae3387604495496d6f59b359">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00085"></a>00085   
<a name="l00089"></a>00089   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classQuad4.php#a8ae459e10a03bc7559baf321b3b5b9c9">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00090"></a>00090 
<a name="l00094"></a>00094   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classQuad4.php#ac7a13193887008fd84db6d0072ad3f08">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00095"></a>00095 
<a name="l00099"></a>00099   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classQuad4.php#a89087448df40124989aee9e65e2d56b5">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00100"></a>00100   
<a name="l00101"></a>00101   <span class="comment">/*</span>
<a name="l00102"></a>00102 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00103"></a>00103 <span class="comment">   * specified side</span>
<a name="l00104"></a>00104 <span class="comment">   */</span>
<a name="l00105"></a>00105   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classQuad4.php#a5535e2876dff95d46dc47883e94619ec">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00106"></a>00106                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00107"></a>00107   
<a name="l00108"></a>00108   <span class="comment">/*</span>
<a name="l00109"></a>00109 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00110"></a>00110 <span class="comment">   * specified edge (== is_node_on_side in 2D)</span>
<a name="l00111"></a>00111 <span class="comment">   */</span>
<a name="l00112"></a><a class="code" href="classQuad4.php#a59ace5971ceb456040b6a13846bc7fc4">00112</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classQuad4.php#a59ace5971ceb456040b6a13846bc7fc4">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00113"></a>00113                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00114"></a>00114 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classQuad4.php#a5535e2876dff95d46dc47883e94619ec">is_node_on_side</a>(n,e); }
<a name="l00115"></a>00115   
<a name="l00116"></a>00116   <span class="comment">/*</span>
<a name="l00117"></a>00117 <span class="comment">   * @returns true iff the element map is definitely affine within</span>
<a name="l00118"></a>00118 <span class="comment">   * numerical tolerances</span>
<a name="l00119"></a>00119 <span class="comment">   */</span>
<a name="l00120"></a>00120   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classQuad4.php#afa89defc742224e7549ae637699baa7b">has_affine_map</a> () <span class="keyword">const</span>;
<a name="l00121"></a>00121 
<a name="l00125"></a><a class="code" href="classQuad4.php#aba914390bc85f8f55fe48ded8bcc5838">00125</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classQuad4.php#aba914390bc85f8f55fe48ded8bcc5838">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>; }
<a name="l00126"></a>00126   
<a name="l00127"></a>00127   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classQuad4.php#a39ed37ca3d4795ebab75818eb8e1202e">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00128"></a>00128                             <span class="keywordtype">bool</span> proxy) <span class="keyword">const</span>;
<a name="l00129"></a>00129 
<a name="l00130"></a>00130   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classQuad4.php#a0527e6f1ffe4cd96dfb340d5f672e2c2">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sf,
<a name="l00131"></a>00131                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00132"></a>00132                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00133"></a>00133 
<a name="l00138"></a><a class="code" href="classQuad4.php#afff1fbc197221671868f03ad6a9e8555">00138</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQuad4.php#afff1fbc197221671868f03ad6a9e8555">side_nodes_map</a>[4][2];
<a name="l00139"></a>00139 
<a name="l00145"></a>00145   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classQuad4.php#a71a2cd8d8b2f9cb5d49b55bc7dba6e64">volume</a> () <span class="keyword">const</span>;
<a name="l00146"></a>00146   
<a name="l00147"></a>00147 <span class="keyword">protected</span>:
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   
<a name="l00150"></a>00150 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00151"></a>00151 <span class="preprocessor"></span>  
<a name="l00155"></a><a class="code" href="classQuad4.php#ab73ba83ed98c26b376e2a0209ab28449">00155</a>   <span class="keywordtype">float</span> <a class="code" href="classQuad4.php#ab73ba83ed98c26b376e2a0209ab28449">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00156"></a>00156                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00157"></a>00157                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00158"></a>00158 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classQuad4.php#ae0ccacd96028c4ad0513118beff4d419">_embedding_matrix</a>[i][j][k]; }
<a name="l00159"></a>00159 
<a name="l00164"></a><a class="code" href="classQuad4.php#ae0ccacd96028c4ad0513118beff4d419">00164</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classQuad4.php#ae0ccacd96028c4ad0513118beff4d419">_embedding_matrix</a>[4][4][4];
<a name="l00165"></a>00165   
<a name="l00166"></a>00166 <span class="preprocessor">#endif</span>
<a name="l00167"></a>00167 <span class="preprocessor"></span>    
<a name="l00168"></a>00168 };
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
