<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>face_quad8.h</h1>  </div>
</div>
<div class="contents">
<a href="face__quad8_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_quad8.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __quad8_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __quad8_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="face__quad_8h.php">face_quad.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Forward declarations</span>
<a name="l00036"></a>00036 <span class="keyword">class </span><a class="code" href="classMesh.php">Mesh</a>;
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00056"></a>00056 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00057"></a>00057 <span class="comment">// Quad8 class definition</span>
<a name="l00058"></a><a class="code" href="classQuad8.php">00058</a> <span class="keyword">class </span><a class="code" href="classQuad8.php">Quad8</a> : <span class="keyword">public</span> <a class="code" href="classQuad.php">Quad</a>
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060 <span class="keyword">public</span>:
<a name="l00061"></a>00061 
<a name="l00065"></a><a class="code" href="classQuad8.php#a992545d0d0788073741f0490d6f6d972">00065</a>   <a class="code" href="classQuad8.php#a992545d0d0788073741f0490d6f6d972">Quad8</a> (<a class="code" href="classElem.php">Elem</a>* p=NULL) :
<a name="l00066"></a>00066     <a class="code" href="classQuad.php">Quad</a>(<a class="code" href="classQuad8.php">Quad8</a>::<a class="code" href="classQuad8.php#abed1f521cd354557248b088658ae28d5">n_nodes</a>(), p) {}
<a name="l00067"></a>00067  
<a name="l00072"></a><a class="code" href="classQuad8.php#a6d61edba9b1dc6a26511ebc7f51bc6be">00072</a>   <a class="code" href="classQuad8.php#a992545d0d0788073741f0490d6f6d972">Quad8</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00073"></a>00073          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00074"></a>00074          <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00075"></a>00075     <a class="code" href="classQuad.php">Quad</a>(nn, ns, p) {}
<a name="l00076"></a>00076   
<a name="l00080"></a><a class="code" href="classQuad8.php#a358a9197c8eeeda6f2172247335c465c">00080</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classQuad8.php#a358a9197c8eeeda6f2172247335c465c">type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>; }
<a name="l00081"></a>00081 
<a name="l00085"></a><a class="code" href="classQuad8.php#abed1f521cd354557248b088658ae28d5">00085</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQuad8.php#abed1f521cd354557248b088658ae28d5">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 8; }
<a name="l00086"></a>00086   
<a name="l00090"></a><a class="code" href="classQuad8.php#aa774d92eaeb8e2bfd55ddee987f41280">00090</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQuad8.php#aa774d92eaeb8e2bfd55ddee987f41280">n_sides</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00091"></a>00091   
<a name="l00095"></a><a class="code" href="classQuad8.php#ad2326f7ac2f1f6059ad5757abc98a64b">00095</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQuad8.php#ad2326f7ac2f1f6059ad5757abc98a64b">n_children</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00096"></a>00096   
<a name="l00100"></a><a class="code" href="classQuad8.php#a8a527dbc4606f53b877e8dd3d966b26a">00100</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQuad8.php#a8a527dbc4606f53b877e8dd3d966b26a">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 5; }
<a name="l00101"></a>00101   
<a name="l00105"></a>00105   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classQuad8.php#ae674745df1f827e3a76b5cdc8e4722f4">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00106"></a>00106 
<a name="l00110"></a>00110   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classQuad8.php#a9dd33adc88bce59829703e9c11827313">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00111"></a>00111 
<a name="l00115"></a>00115   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classQuad8.php#a42abbb5027187e27db77041cc7dbb618">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00116"></a>00116   
<a name="l00117"></a>00117   <span class="comment">/*</span>
<a name="l00118"></a>00118 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00119"></a>00119 <span class="comment">   * specified side</span>
<a name="l00120"></a>00120 <span class="comment">   */</span>
<a name="l00121"></a>00121   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classQuad8.php#a0c94db0657ba2cc34bf99b92d1188d2d">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00122"></a>00122                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00123"></a>00123   
<a name="l00124"></a>00124   <span class="comment">/*</span>
<a name="l00125"></a>00125 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00126"></a>00126 <span class="comment">   * specified edge (== is_node_on_side in 2D)</span>
<a name="l00127"></a>00127 <span class="comment">   */</span>
<a name="l00128"></a><a class="code" href="classQuad8.php#a3e2f3a5233b536f09af2d25ffbdf6ecc">00128</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classQuad8.php#a3e2f3a5233b536f09af2d25ffbdf6ecc">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00129"></a>00129                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00130"></a>00130 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classQuad8.php#a0c94db0657ba2cc34bf99b92d1188d2d">is_node_on_side</a>(n,e); }
<a name="l00131"></a>00131   
<a name="l00132"></a>00132   <span class="comment">/*</span>
<a name="l00133"></a>00133 <span class="comment">   * @returns true iff the element map is definitely affine within</span>
<a name="l00134"></a>00134 <span class="comment">   * numerical tolerances</span>
<a name="l00135"></a>00135 <span class="comment">   */</span>
<a name="l00136"></a>00136   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classQuad8.php#a5b50f64c1c918078856f99543afde443">has_affine_map</a> () <span class="keyword">const</span>;
<a name="l00137"></a>00137 
<a name="l00141"></a><a class="code" href="classQuad8.php#a67eeacd2f90a14e27be91806019c425f">00141</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classQuad8.php#a67eeacd2f90a14e27be91806019c425f">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>; }
<a name="l00142"></a>00142 
<a name="l00152"></a>00152   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQuad8.php#ace03b91ac84255885d0671ab408a807b">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00153"></a>00153   
<a name="l00154"></a>00154   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classQuad8.php#aced09640d1364b0cdc9d8af5d8dd2782">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00155"></a>00155                             <span class="keywordtype">bool</span> proxy) <span class="keyword">const</span>;
<a name="l00156"></a>00156 
<a name="l00157"></a>00157   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classQuad8.php#a5b27e80fbaa412c42c53751ebbf3ca04">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sf,
<a name="l00158"></a>00158                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00159"></a>00159                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00160"></a>00160 
<a name="l00164"></a><a class="code" href="classQuad8.php#a90448103c21dae9f7f32d9286091f5bb">00164</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQuad8.php#a90448103c21dae9f7f32d9286091f5bb">n_second_order_adjacent_vertices</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00165"></a>00165 <span class="keyword">  </span>{ <span class="keywordflow">return</span> 2; }
<a name="l00166"></a>00166 
<a name="l00172"></a>00172   <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classQuad8.php#a8467ea28ca1fa3a5899d9b019ada9b72">second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00173"></a>00173                                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v) <span class="keyword">const</span>;
<a name="l00174"></a>00174 
<a name="l00184"></a>00184   <span class="keyword">virtual</span> std::pair&lt;unsigned short int, unsigned short int&gt; 
<a name="l00185"></a>00185           <a class="code" href="classQuad8.php#af34a8a28f563e08fe3bc9d9253033335">second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span>;
<a name="l00186"></a>00186 
<a name="l00191"></a><a class="code" href="classQuad8.php#a83b52d0ba6c5d437f36b8b2151c512f0">00191</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQuad8.php#a83b52d0ba6c5d437f36b8b2151c512f0">side_nodes_map</a>[4][3];
<a name="l00192"></a>00192   
<a name="l00193"></a>00193   
<a name="l00194"></a>00194 <span class="keyword">protected</span>:
<a name="l00195"></a>00195   
<a name="l00196"></a>00196   
<a name="l00197"></a>00197 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00198"></a>00198 <span class="preprocessor"></span>  
<a name="l00202"></a><a class="code" href="classQuad8.php#a566759a25e967c585545edcb5ded9911">00202</a>   <span class="keywordtype">float</span> <a class="code" href="classQuad8.php#a566759a25e967c585545edcb5ded9911">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00203"></a>00203                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00204"></a>00204                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00205"></a>00205 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classQuad8.php#aad69ada331b888dbebc27adbc1804bc6">_embedding_matrix</a>[i][j][k]; }
<a name="l00206"></a>00206 
<a name="l00211"></a><a class="code" href="classQuad8.php#aad69ada331b888dbebc27adbc1804bc6">00211</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classQuad8.php#aad69ada331b888dbebc27adbc1804bc6">_embedding_matrix</a>[4][8][8];
<a name="l00212"></a>00212   
<a name="l00213"></a>00213 <span class="preprocessor">#endif</span>
<a name="l00214"></a>00214 <span class="preprocessor"></span> 
<a name="l00215"></a>00215 };
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
