<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>face_quad9.h</h1>  </div>
</div>
<div class="contents">
<a href="face__quad9_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_quad9.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __quad9_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __quad9_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="face__quad_8h.php">face_quad.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward declarations</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00054"></a>00054 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00055"></a>00055 <span class="comment">// Quad9 class definition</span>
<a name="l00056"></a><a class="code" href="classQuad9.php">00056</a> <span class="keyword">class </span><a class="code" href="classQuad9.php">Quad9</a> : <span class="keyword">public</span> <a class="code" href="classQuad.php">Quad</a>
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058 <span class="keyword">public</span>:
<a name="l00059"></a>00059 
<a name="l00063"></a><a class="code" href="classQuad9.php#a5e6178610d50258cfe1da5929f7b84cb">00063</a>   <a class="code" href="classQuad9.php#a5e6178610d50258cfe1da5929f7b84cb">Quad9</a> (<a class="code" href="classElem.php">Elem</a>* p=NULL) :
<a name="l00064"></a>00064     <a class="code" href="classQuad.php">Quad</a>(<a class="code" href="classQuad9.php">Quad9</a>::<a class="code" href="classQuad9.php#ae8e68f3a15204ee4162a487b3a91f0a9">n_nodes</a>(), p) {}
<a name="l00065"></a>00065 
<a name="l00070"></a><a class="code" href="classQuad9.php#aa4f867d1c634142e8545dc537e31989a">00070</a>   <a class="code" href="classQuad9.php#a5e6178610d50258cfe1da5929f7b84cb">Quad9</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00071"></a>00071          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00072"></a>00072          <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00073"></a>00073     <a class="code" href="classQuad.php">Quad</a>(nn, ns, p) {}
<a name="l00074"></a>00074 
<a name="l00078"></a><a class="code" href="classQuad9.php#ae17abed3d01a88f0a262abb004d42aee">00078</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classQuad9.php#ae17abed3d01a88f0a262abb004d42aee">type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>; }
<a name="l00079"></a>00079 
<a name="l00083"></a><a class="code" href="classQuad9.php#ae8e68f3a15204ee4162a487b3a91f0a9">00083</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQuad9.php#ae8e68f3a15204ee4162a487b3a91f0a9">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 9; }
<a name="l00084"></a>00084   
<a name="l00088"></a><a class="code" href="classQuad9.php#ad309064d65bd0b6f51b1008065cd060a">00088</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQuad9.php#ad309064d65bd0b6f51b1008065cd060a">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00089"></a>00089   
<a name="l00093"></a>00093   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classQuad9.php#ab768859dfb31cbcef77f1413a640d81e">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00094"></a>00094 
<a name="l00098"></a>00098   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classQuad9.php#a559cf5b7bb20e2296ada5b6b7c123de4">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00099"></a>00099 
<a name="l00103"></a>00103   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classQuad9.php#a9ae3e91fe15ffeb3b425e159a9ae7d79">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00104"></a>00104   
<a name="l00105"></a>00105   <span class="comment">/*</span>
<a name="l00106"></a>00106 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00107"></a>00107 <span class="comment">   * specified side</span>
<a name="l00108"></a>00108 <span class="comment">   */</span>
<a name="l00109"></a>00109   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classQuad9.php#ab08970ebce56014d4c5e69d8ed97a883">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00110"></a>00110                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00111"></a>00111   
<a name="l00112"></a>00112   <span class="comment">/*</span>
<a name="l00113"></a>00113 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00114"></a>00114 <span class="comment">   * specified edge (== is_node_on_side in 2D)</span>
<a name="l00115"></a>00115 <span class="comment">   */</span>
<a name="l00116"></a><a class="code" href="classQuad9.php#ae0c44ec2f46c0102c09088cbe7ad48e8">00116</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classQuad9.php#ae0c44ec2f46c0102c09088cbe7ad48e8">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00117"></a>00117                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00118"></a>00118 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classQuad9.php#ab08970ebce56014d4c5e69d8ed97a883">is_node_on_side</a>(n,e); }
<a name="l00119"></a>00119   
<a name="l00120"></a>00120   <span class="comment">/*</span>
<a name="l00121"></a>00121 <span class="comment">   * @returns true iff the element map is definitely affine within</span>
<a name="l00122"></a>00122 <span class="comment">   * numerical tolerances</span>
<a name="l00123"></a>00123 <span class="comment">   */</span>
<a name="l00124"></a>00124   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classQuad9.php#a0261a337123ed8746928452b47c27e35">has_affine_map</a> () <span class="keyword">const</span>;
<a name="l00125"></a>00125 
<a name="l00129"></a><a class="code" href="classQuad9.php#a2a623694158039b7d482134aa014b963">00129</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classQuad9.php#a2a623694158039b7d482134aa014b963">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>; }
<a name="l00130"></a>00130 
<a name="l00140"></a>00140   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQuad9.php#ab337f2259f339b2ecb314160098c0e07">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00141"></a>00141   
<a name="l00142"></a>00142   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classQuad9.php#a480aa87ffb77074440e2b636cbb453b3">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00143"></a>00143                             <span class="keywordtype">bool</span> proxy) <span class="keyword">const</span>;
<a name="l00144"></a>00144 
<a name="l00145"></a>00145   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classQuad9.php#a8d0ad2dfd6ecbb74935c5f8e1a03a0a0">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sf,
<a name="l00146"></a>00146                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00147"></a>00147                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00148"></a>00148   
<a name="l00152"></a>00152   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQuad9.php#a9f8365f7cf43764026ebfa308e070852">n_second_order_adjacent_vertices</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span>;
<a name="l00153"></a>00153 
<a name="l00159"></a>00159   <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classQuad9.php#ac498943ce036b3534cae63444baa09e7">second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00160"></a>00160                                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v) <span class="keyword">const</span>;
<a name="l00161"></a>00161   
<a name="l00171"></a>00171   <span class="keyword">virtual</span> std::pair&lt;unsigned short int, unsigned short int&gt; 
<a name="l00172"></a>00172           <a class="code" href="classQuad9.php#a8349c50f8d3892de72db193773260b57">second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span>;
<a name="l00173"></a>00173 
<a name="l00178"></a><a class="code" href="classQuad9.php#a084cd56ab2ce23a63da15e48bb0d8e72">00178</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQuad9.php#a084cd56ab2ce23a63da15e48bb0d8e72">side_nodes_map</a>[4][3];
<a name="l00179"></a>00179 
<a name="l00180"></a>00180   
<a name="l00181"></a>00181 <span class="keyword">protected</span>:
<a name="l00182"></a>00182   
<a name="l00183"></a>00183   
<a name="l00184"></a>00184 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00185"></a>00185 <span class="preprocessor"></span>  
<a name="l00189"></a><a class="code" href="classQuad9.php#a002ad908571da2e7a3af9f852dfecce8">00189</a>   <span class="keywordtype">float</span> <a class="code" href="classQuad9.php#a002ad908571da2e7a3af9f852dfecce8">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00190"></a>00190                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00191"></a>00191                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00192"></a>00192 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classQuad9.php#a507af18477d8838f16a0441f2e731327">_embedding_matrix</a>[i][j][k]; }
<a name="l00193"></a>00193 
<a name="l00198"></a><a class="code" href="classQuad9.php#a507af18477d8838f16a0441f2e731327">00198</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classQuad9.php#a507af18477d8838f16a0441f2e731327">_embedding_matrix</a>[4][9][9];
<a name="l00199"></a>00199   
<a name="l00200"></a>00200 <span class="preprocessor">#endif</span>
<a name="l00201"></a>00201 <span class="preprocessor"></span>
<a name="l00202"></a>00202     
<a name="l00203"></a>00203 };
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
