<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>face_quad.h</h1>  </div>
</div>
<div class="contents">
<a href="face__quad_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_quad.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __quad_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __quad_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="face_8h.php">face.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward declarations</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00053"></a>00053 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00054"></a>00054 <span class="comment">// Quad class definition</span>
<a name="l00055"></a><a class="code" href="classQuad.php">00055</a> <span class="keyword">class </span><a class="code" href="classQuad.php">Quad</a> : <span class="keyword">public</span> <a class="code" href="classFace.php">Face</a>
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057 <span class="keyword">public</span>:
<a name="l00058"></a>00058 
<a name="l00063"></a><a class="code" href="classQuad.php#a2f4bd5b51a80b15a56f9e661adea9964">00063</a>   <a class="code" href="classQuad.php#a2f4bd5b51a80b15a56f9e661adea9964">Quad</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn, <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00064"></a>00064     <a class="code" href="classFace.php">Face</a>(nn, <a class="code" href="classQuad.php">Quad</a>::<a class="code" href="classQuad.php#a91925fa9fa90565420b633182d67096a">n_sides</a>(), p) {}
<a name="l00065"></a>00065  
<a name="l00070"></a><a class="code" href="classQuad.php#ada710429158e61e97250ce3dc25e4e11">00070</a>   <a class="code" href="classQuad.php#a2f4bd5b51a80b15a56f9e661adea9964">Quad</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00071"></a>00071         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00072"></a>00072         <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00073"></a>00073     <a class="code" href="classFace.php">Face</a>(nn, ns, p) {}
<a name="l00074"></a>00074 
<a name="l00079"></a><a class="code" href="classQuad.php#a4ac73cef6dd6e5c4c9696e475dbbe0bb">00079</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQuad.php#a4ac73cef6dd6e5c4c9696e475dbbe0bb">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00080"></a>00080 
<a name="l00084"></a><a class="code" href="classQuad.php#a91925fa9fa90565420b633182d67096a">00084</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQuad.php#a91925fa9fa90565420b633182d67096a">n_sides</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }  
<a name="l00085"></a>00085 
<a name="l00089"></a><a class="code" href="classQuad.php#a36ae9444ffc764a86b568f08db7acec0">00089</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQuad.php#a36ae9444ffc764a86b568f08db7acec0">n_vertices</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00090"></a>00090 
<a name="l00094"></a><a class="code" href="classQuad.php#a586c9864cd86383df297ae0fd66d6517">00094</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQuad.php#a586c9864cd86383df297ae0fd66d6517">n_edges</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00095"></a>00095 
<a name="l00099"></a><a class="code" href="classQuad.php#a33fcd2352adf8df942ab78160c3b24cf">00099</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQuad.php#a33fcd2352adf8df942ab78160c3b24cf">n_children</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00100"></a>00100   
<a name="l00101"></a>00101   <span class="comment">/*</span>
<a name="l00102"></a>00102 <span class="comment">   * @returns true iff the specified child is on the</span>
<a name="l00103"></a>00103 <span class="comment">   * specified side</span>
<a name="l00104"></a>00104 <span class="comment">   */</span>
<a name="l00105"></a>00105   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classQuad.php#a19946b79d088d412b123554e6d216026">is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00106"></a>00106                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00107"></a>00107   
<a name="l00113"></a>00113   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQuad.php#a12c03ab316c6f2c3ec8a75259c43fbe2">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00114"></a>00114 
<a name="l00119"></a>00119   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> <a class="code" href="classQuad.php#ab50167cf9cd64cda832dda8faafdf10c">side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00120"></a>00120   
<a name="l00125"></a>00125   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classQuad.php#a804282d2d0c02703274370ea907abefd">quality</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) <span class="keyword">const</span>;
<a name="l00126"></a>00126 
<a name="l00132"></a>00132   std::pair&lt;Real, Real&gt; <a class="code" href="classQuad.php#a48bc26f5e2c50ffa439e0b774261806a">qual_bounds</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) <span class="keyword">const</span>;
<a name="l00133"></a>00133   
<a name="l00140"></a><a class="code" href="classQuad.php#aaf1e575c0030400a80290d41dbcec0d2">00140</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classQuad.php#aaf1e575c0030400a80290d41dbcec0d2">_second_order_adjacent_vertices</a>[4][2];
<a name="l00141"></a>00141 
<a name="l00145"></a><a class="code" href="classQuad.php#a515296e25eaac5de172ce56174ed07cb">00145</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classQuad.php#a515296e25eaac5de172ce56174ed07cb">_second_order_vertex_child_number</a>[9];
<a name="l00146"></a>00146 
<a name="l00150"></a><a class="code" href="classQuad.php#a982b7d8a89e21e53dbddcf8b8ee6d555">00150</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classQuad.php#a982b7d8a89e21e53dbddcf8b8ee6d555">_second_order_vertex_child_index</a>[9];
<a name="l00151"></a>00151 };
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00155"></a>00155 <span class="comment">// Quad class member functions</span>
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
