<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>face_tri3.h</h1>  </div>
</div>
<div class="contents">
<a href="face__tri3_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_tri3.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __tri3_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __tri3_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="face__tri_8h.php">face_tri.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward declarations</span>
<a name="l00035"></a>00035 
<a name="l00052"></a>00052 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00053"></a>00053 <span class="comment">// Tri3 class definition</span>
<a name="l00054"></a><a class="code" href="classTri3.php">00054</a> <span class="keyword">class </span><a class="code" href="classTri3.php">Tri3</a> : <span class="keyword">public</span> <a class="code" href="classTri.php">Tri</a>
<a name="l00055"></a>00055 {
<a name="l00056"></a>00056 <span class="keyword">public</span>:
<a name="l00057"></a>00057 
<a name="l00061"></a><a class="code" href="classTri3.php#a320eee2d10fcd8c28b9eeccf352c28e5">00061</a>   <a class="code" href="classTri3.php#a320eee2d10fcd8c28b9eeccf352c28e5">Tri3</a> (<a class="code" href="classElem.php">Elem</a>* p=NULL) :
<a name="l00062"></a>00062     <a class="code" href="classTri.php">Tri</a>(<a class="code" href="classTri3.php">Tri3</a>::<a class="code" href="classTri.php#af4b54600b0acd222164bfedc1fb7ae4f">n_nodes</a>(), p) {}
<a name="l00063"></a>00063 
<a name="l00068"></a><a class="code" href="classTri3.php#a6e439c9876e7b8946195026e5681dd9c">00068</a>   <a class="code" href="classTri3.php#a320eee2d10fcd8c28b9eeccf352c28e5">Tri3</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00069"></a>00069         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00070"></a>00070         <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00071"></a>00071     <a class="code" href="classTri.php">Tri</a>(nn, ns, p) {}
<a name="l00072"></a>00072 
<a name="l00076"></a><a class="code" href="classTri3.php#aef6784b3210d8e1e9f5f4bd3de8014d6">00076</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classTri3.php#aef6784b3210d8e1e9f5f4bd3de8014d6">type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>; }
<a name="l00077"></a>00077 
<a name="l00081"></a><a class="code" href="classTri3.php#a36874c4cf9c4d0314d9f2fa996af7400">00081</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTri3.php#a36874c4cf9c4d0314d9f2fa996af7400">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00082"></a>00082   
<a name="l00086"></a>00086   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classTri3.php#a73666f8a8768400f180b687da334c683">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00087"></a>00087 
<a name="l00091"></a>00091   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classTri3.php#a49a0cf86be67693e5d40190e51c7a919">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00092"></a>00092 
<a name="l00096"></a>00096   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classTri3.php#a269c9f6e653e066009e4d8506393f0bd">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00097"></a>00097   
<a name="l00098"></a>00098   <span class="comment">/*</span>
<a name="l00099"></a>00099 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00100"></a>00100 <span class="comment">   * specified side</span>
<a name="l00101"></a>00101 <span class="comment">   */</span>
<a name="l00102"></a>00102   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classTri3.php#ae3a37239997346e9be0f05cedf1721de">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00103"></a>00103                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00104"></a>00104   
<a name="l00105"></a>00105   <span class="comment">/*</span>
<a name="l00106"></a>00106 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00107"></a>00107 <span class="comment">   * specified edge (== is_node_on_side in 2D)</span>
<a name="l00108"></a>00108 <span class="comment">   */</span>
<a name="l00109"></a><a class="code" href="classTri3.php#a6fcaf1acc79e15aedc84d48f8bbf4e1d">00109</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classTri3.php#a6fcaf1acc79e15aedc84d48f8bbf4e1d">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00110"></a>00110                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00111"></a>00111 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classTri3.php#ae3a37239997346e9be0f05cedf1721de">is_node_on_side</a>(n,e); }
<a name="l00112"></a>00112   
<a name="l00113"></a>00113   <span class="comment">/*</span>
<a name="l00114"></a>00114 <span class="comment">   * @returns true iff the element map is definitely affine within</span>
<a name="l00115"></a>00115 <span class="comment">   * numerical tolerances</span>
<a name="l00116"></a>00116 <span class="comment">   */</span>
<a name="l00117"></a><a class="code" href="classTri3.php#abe69343603b3f1be1f1de82aeaa804bd">00117</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classTri3.php#abe69343603b3f1be1f1de82aeaa804bd">has_affine_map</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00118"></a>00118 
<a name="l00122"></a><a class="code" href="classTri3.php#a947cbd24e679c00ac0c31a3022687f55">00122</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classTri3.php#a947cbd24e679c00ac0c31a3022687f55">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>; }
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classTri3.php#a35e6f714a98a3dbbb655d6dec7adcd31">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00125"></a>00125                             <span class="keywordtype">bool</span> proxy) <span class="keyword">const</span>;
<a name="l00126"></a>00126 
<a name="l00127"></a>00127   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classTri3.php#a0c27e12ac3fc13c82845b0ee69a6409c">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sf,
<a name="l00128"></a>00128                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00129"></a>00129                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00130"></a>00130 
<a name="l00135"></a><a class="code" href="classTri3.php#a02c3e603007c98ab9ddb0fed1560eae4">00135</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTri3.php#a02c3e603007c98ab9ddb0fed1560eae4">side_nodes_map</a>[3][2];
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 
<a name="l00141"></a>00141   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classTri3.php#ad1a8bd52331157233759a3a6330247ae">volume</a> () <span class="keyword">const</span>;
<a name="l00142"></a>00142 
<a name="l00148"></a>00148   std::pair&lt;Real, Real&gt; <a class="code" href="classTri3.php#a4d3f3914ad66f8846c4f45ef6367233d">min_and_max_angle</a>() <span class="keyword">const</span>;
<a name="l00149"></a>00149   
<a name="l00150"></a>00150 <span class="keyword">protected</span>:
<a name="l00151"></a>00151 
<a name="l00152"></a>00152   
<a name="l00153"></a>00153 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00154"></a>00154 <span class="preprocessor"></span>  
<a name="l00158"></a><a class="code" href="classTri3.php#a35801ee0f39e12151644f78367b8aaa7">00158</a>   <span class="keywordtype">float</span> <a class="code" href="classTri3.php#a35801ee0f39e12151644f78367b8aaa7">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00159"></a>00159                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00160"></a>00160                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00161"></a>00161 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classTri3.php#a758b75eef04adff468bb92abc318ad92">_embedding_matrix</a>[i][j][k]; }
<a name="l00162"></a>00162 
<a name="l00167"></a><a class="code" href="classTri3.php#a758b75eef04adff468bb92abc318ad92">00167</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classTri3.php#a758b75eef04adff468bb92abc318ad92">_embedding_matrix</a>[4][3][3];
<a name="l00168"></a>00168   
<a name="l00169"></a>00169 <span class="preprocessor">#endif</span>
<a name="l00170"></a>00170 <span class="preprocessor"></span>    
<a name="l00171"></a>00171 };
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
