<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>face_tri6.h</h1>  </div>
</div>
<div class="contents">
<a href="face__tri6_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_tri6.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __tri6_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __tri6_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="face__tri_8h.php">face_tri.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward declarations</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00055"></a>00055 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00056"></a>00056 <span class="comment">// Tri6 class definition</span>
<a name="l00057"></a><a class="code" href="classTri6.php">00057</a> <span class="keyword">class </span><a class="code" href="classTri6.php">Tri6</a> : <span class="keyword">public</span> <a class="code" href="classTri.php">Tri</a>
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059 <span class="keyword">public</span>:
<a name="l00060"></a>00060 
<a name="l00064"></a><a class="code" href="classTri6.php#abf8cd1f93725f0b5daa4e22a92bc1c2c">00064</a>   <a class="code" href="classTri6.php#abf8cd1f93725f0b5daa4e22a92bc1c2c">Tri6</a>  (<a class="code" href="classElem.php">Elem</a>* p=NULL) :
<a name="l00065"></a>00065     <a class="code" href="classTri.php">Tri</a>(<a class="code" href="classTri6.php">Tri6</a>::<a class="code" href="classTri6.php#a145311801f27809f8f387cc0e9773a77">n_nodes</a>(), p) {}
<a name="l00066"></a>00066 
<a name="l00071"></a><a class="code" href="classTri6.php#a257be414680b9ed7512e2332cd952760">00071</a>   <a class="code" href="classTri6.php#abf8cd1f93725f0b5daa4e22a92bc1c2c">Tri6</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00072"></a>00072         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00073"></a>00073         <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00074"></a>00074     <a class="code" href="classTri.php">Tri</a>(nn, ns, p) {}
<a name="l00075"></a>00075 
<a name="l00079"></a><a class="code" href="classTri6.php#a0b80b03e769bd3519e299924794229da">00079</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classTri6.php#a0b80b03e769bd3519e299924794229da">type</a> ()<span class="keyword">   const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>; }
<a name="l00080"></a>00080 
<a name="l00084"></a><a class="code" href="classTri6.php#a145311801f27809f8f387cc0e9773a77">00084</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTri6.php#a145311801f27809f8f387cc0e9773a77">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 6; }
<a name="l00085"></a>00085   
<a name="l00089"></a><a class="code" href="classTri6.php#a5568e8407d72b60bcbc45c6eabb84e10">00089</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTri6.php#a5568e8407d72b60bcbc45c6eabb84e10">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00090"></a>00090   
<a name="l00094"></a>00094   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classTri6.php#a0b7999aa543cba78cf4e3876006b1e4d">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00095"></a>00095 
<a name="l00099"></a>00099   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classTri6.php#acef8c3a426621a3d1c4e3550e0aff0a2">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00100"></a>00100 
<a name="l00104"></a>00104   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classTri6.php#a6c955e5a4db5c55c0e5422b96b9d73de">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00105"></a>00105   
<a name="l00106"></a>00106   <span class="comment">/*</span>
<a name="l00107"></a>00107 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00108"></a>00108 <span class="comment">   * specified side</span>
<a name="l00109"></a>00109 <span class="comment">   */</span>
<a name="l00110"></a>00110   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classTri6.php#a978b981e23291b8de2fbaee38c489de9">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00111"></a>00111                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00112"></a>00112   
<a name="l00113"></a>00113   <span class="comment">/*</span>
<a name="l00114"></a>00114 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00115"></a>00115 <span class="comment">   * specified edge (== is_node_on_side in 2D)</span>
<a name="l00116"></a>00116 <span class="comment">   */</span>
<a name="l00117"></a><a class="code" href="classTri6.php#ad0e7589335c1cbca16ceb20b08b1b876">00117</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classTri6.php#ad0e7589335c1cbca16ceb20b08b1b876">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00118"></a>00118                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00119"></a>00119 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classTri6.php#a978b981e23291b8de2fbaee38c489de9">is_node_on_side</a>(n,e); }
<a name="l00120"></a>00120   
<a name="l00121"></a>00121   <span class="comment">/*</span>
<a name="l00122"></a>00122 <span class="comment">   * @returns true iff the element map is definitely affine within</span>
<a name="l00123"></a>00123 <span class="comment">   * numerical tolerances</span>
<a name="l00124"></a>00124 <span class="comment">   */</span>
<a name="l00125"></a>00125   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classTri6.php#a2d64a97679e5060431c7499163d20400">has_affine_map</a> () <span class="keyword">const</span>;
<a name="l00126"></a>00126 
<a name="l00130"></a><a class="code" href="classTri6.php#a987a5a2ca0c1791ad65ff3933fba5bce">00130</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classTri6.php#a987a5a2ca0c1791ad65ff3933fba5bce">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>; }
<a name="l00131"></a>00131 
<a name="l00141"></a>00141   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTri6.php#adc1294db36cc6e3d9a8195c271274931">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00142"></a>00142   
<a name="l00143"></a>00143   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classTri6.php#aca1fa1a1a45d0ea7eb6955776723a8ad">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00144"></a>00144                             <span class="keywordtype">bool</span> proxy) <span class="keyword">const</span>;
<a name="l00145"></a>00145 
<a name="l00146"></a>00146   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classTri6.php#a651b12108aceb0af0b6a693240a98160">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sf,
<a name="l00147"></a>00147                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00148"></a>00148                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00149"></a>00149 
<a name="l00153"></a><a class="code" href="classTri6.php#a0368ffd94deb5b55034c871474184a20">00153</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTri6.php#a0368ffd94deb5b55034c871474184a20">n_second_order_adjacent_vertices</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00154"></a>00154 <span class="keyword">      </span>{ <span class="keywordflow">return</span> 2; }
<a name="l00155"></a>00155 
<a name="l00161"></a>00161   <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classTri6.php#aa68d7727bf8b46dc3bb4d1b6fab5f8c1">second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00162"></a>00162                                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v) <span class="keyword">const</span>;
<a name="l00163"></a>00163 
<a name="l00173"></a>00173   <span class="keyword">virtual</span> std::pair&lt;unsigned short int, unsigned short int&gt; 
<a name="l00174"></a>00174           <a class="code" href="classTri6.php#a8ef1822fed3e42bfe25c09c7ef42998c">second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span>;
<a name="l00175"></a>00175 
<a name="l00180"></a><a class="code" href="classTri6.php#a048b321a390486e77451b1175d01f348">00180</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTri6.php#a048b321a390486e77451b1175d01f348">side_nodes_map</a>[3][3];
<a name="l00181"></a>00181  
<a name="l00182"></a>00182   
<a name="l00183"></a>00183 <span class="keyword">private</span>:
<a name="l00184"></a>00184   
<a name="l00185"></a>00185   
<a name="l00186"></a>00186 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00187"></a>00187 <span class="preprocessor"></span>  
<a name="l00191"></a><a class="code" href="classTri6.php#a19812c00e62b77d7650e626914554b7d">00191</a>   <span class="keywordtype">float</span> <a class="code" href="classTri6.php#a19812c00e62b77d7650e626914554b7d">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00192"></a>00192                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00193"></a>00193                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00194"></a>00194 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classTri6.php#ae7136014fd51f5c2d4c66c3906545fcc">_embedding_matrix</a>[i][j][k]; }
<a name="l00195"></a>00195 
<a name="l00200"></a><a class="code" href="classTri6.php#ae7136014fd51f5c2d4c66c3906545fcc">00200</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classTri6.php#ae7136014fd51f5c2d4c66c3906545fcc">_embedding_matrix</a>[4][6][6];
<a name="l00201"></a>00201   
<a name="l00202"></a>00202 <span class="preprocessor">#endif</span>
<a name="l00203"></a>00203 <span class="preprocessor"></span>
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 <span class="keyword">private</span>:
<a name="l00206"></a>00206   
<a name="l00211"></a><a class="code" href="classTri6.php#a81cf2750f286ce1b4077a7e36cdab6a2">00211</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classTri6.php#a81cf2750f286ce1b4077a7e36cdab6a2">_second_order_adjacent_vertices</a>[3][2];
<a name="l00212"></a>00212     
<a name="l00216"></a><a class="code" href="classTri6.php#a6379f7abcf2ac6114e9836f56f8d3553">00216</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classTri6.php#a6379f7abcf2ac6114e9836f56f8d3553">_second_order_vertex_child_number</a>[6];
<a name="l00217"></a>00217 
<a name="l00221"></a><a class="code" href="classTri6.php#ab805c93599714157e688956821886d94">00221</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classTri6.php#ab805c93599714157e688956821886d94">_second_order_vertex_child_index</a>[6];
<a name="l00222"></a>00222 };
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
