<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>face_tri.h</h1>  </div>
</div>
<div class="contents">
<a href="face__tri_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_tri.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __tri_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __tri_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="face_8h.php">face.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward declarations</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00055"></a>00055 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00056"></a>00056 <span class="comment">// Tri class definition</span>
<a name="l00057"></a><a class="code" href="classTri.php">00057</a> <span class="keyword">class </span><a class="code" href="classTri.php">Tri</a> : <span class="keyword">public</span> <a class="code" href="classFace.php">Face</a>
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059 <span class="keyword">public</span>:
<a name="l00060"></a>00060 
<a name="l00065"></a><a class="code" href="classTri.php#afbeb21283e29c99c4f1afb8075cc8d08">00065</a>   <a class="code" href="classTri.php#afbeb21283e29c99c4f1afb8075cc8d08">Tri</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00066"></a>00066        <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00067"></a>00067     <a class="code" href="classFace.php">Face</a>(nn, <a class="code" href="classTri.php">Tri</a>::<a class="code" href="classTri.php#a185c254f4964cc61a59de8528e75693d">n_sides</a>(), p) {}
<a name="l00068"></a>00068  
<a name="l00073"></a><a class="code" href="classTri.php#aeeec1a0959dd3a86d7b4102441326e9a">00073</a>   <a class="code" href="classTri.php#afbeb21283e29c99c4f1afb8075cc8d08">Tri</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00074"></a>00074        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00075"></a>00075        <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00076"></a>00076     <a class="code" href="classFace.php">Face</a>(nn, ns, p) {}
<a name="l00077"></a>00077     
<a name="l00082"></a><a class="code" href="classTri.php#af4b54600b0acd222164bfedc1fb7ae4f">00082</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTri.php#af4b54600b0acd222164bfedc1fb7ae4f">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 3; }
<a name="l00083"></a>00083 
<a name="l00087"></a><a class="code" href="classTri.php#a185c254f4964cc61a59de8528e75693d">00087</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTri.php#a185c254f4964cc61a59de8528e75693d">n_sides</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 3; }
<a name="l00088"></a>00088 
<a name="l00092"></a><a class="code" href="classTri.php#a77329b16b92cf7b69bea8534c08a7bbc">00092</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTri.php#a77329b16b92cf7b69bea8534c08a7bbc">n_vertices</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 3; }
<a name="l00093"></a>00093 
<a name="l00097"></a><a class="code" href="classTri.php#a4fef45d930bb989e526eb2fb3a0d0567">00097</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTri.php#a4fef45d930bb989e526eb2fb3a0d0567">n_edges</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 3; }
<a name="l00098"></a>00098 
<a name="l00102"></a><a class="code" href="classTri.php#acff3659d70188d6eb9cb936147279451">00102</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTri.php#acff3659d70188d6eb9cb936147279451">n_children</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00103"></a>00103   
<a name="l00104"></a>00104   <span class="comment">/*</span>
<a name="l00105"></a>00105 <span class="comment">   * @returns true iff the specified child is on the</span>
<a name="l00106"></a>00106 <span class="comment">   * specified side</span>
<a name="l00107"></a>00107 <span class="comment">   */</span>
<a name="l00108"></a>00108   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classTri.php#a2987c2ed6555053259f1cc123b4a0595">is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00109"></a>00109                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00110"></a>00110   
<a name="l00116"></a>00116   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTri.php#a1b8d790049ff1af9059c0e0259904619">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00117"></a>00117 
<a name="l00122"></a>00122   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> <a class="code" href="classTri.php#adaf9315680d9aad4b4f6b3aa54f81a87">side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00123"></a>00123 
<a name="l00128"></a>00128   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classTri.php#a9c77d6eb445cb170294353c1c6b30fbe">quality</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) <span class="keyword">const</span>;
<a name="l00129"></a>00129 
<a name="l00135"></a>00135   std::pair&lt;Real, Real&gt; <a class="code" href="classTri.php#ab3ced41d02a3ef3e13b3c89163e3f437">qual_bounds</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) <span class="keyword">const</span>;
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 };
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00140"></a>00140 <span class="comment">// Tri class member functions</span>
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 <span class="preprocessor">#endif</span>
<a name="l00143"></a>00143 <span class="preprocessor"></span>
<a name="l00144"></a>00144 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
