<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_a444518d96d2df902338d2a7eb3a040c.php">base</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>factory.h</h1>  </div>
</div>
<div class="contents">
<a href="factory_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: factory.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __factory_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __factory_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// System &amp; C++ includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00039"></a>00039 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00040"></a><a class="code" href="classFactory.php">00040</a> <span class="keyword">class </span><a class="code" href="classFactory.php">Factory</a>
<a name="l00041"></a>00041 {  
<a name="l00042"></a>00042 <span class="keyword">protected</span>:
<a name="l00043"></a>00043 
<a name="l00047"></a>00047   <a class="code" href="classFactory.php#a5285e4782bc0ff5a80d098398475cb04">Factory</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>);
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="keyword">public</span>:
<a name="l00050"></a>00050 
<a name="l00054"></a><a class="code" href="classFactory.php#a0de7d23a4c18e0f6bf5518ae440e94b3">00054</a>   <span class="keyword">virtual</span> <a class="code" href="classFactory.php#a0de7d23a4c18e0f6bf5518ae440e94b3">~Factory</a> () {}
<a name="l00055"></a>00055 
<a name="l00059"></a>00059   <span class="keyword">static</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Base&gt;</a> <a class="code" href="classFactory.php#ad893ae00db3e3dd087be0cbc3e22f106">build</a> (<span class="keyword">const</span> std::string&amp; name);
<a name="l00060"></a>00060 
<a name="l00065"></a>00065   <span class="keyword">virtual</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Base&gt;</a> <a class="code" href="classFactory.php#a57fec03149cf23ae6a89c95a4c9bb8f7">create</a> () = 0;
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   
<a name="l00068"></a>00068 <span class="keyword">protected</span>:
<a name="l00069"></a>00069 
<a name="l00073"></a>00073   <span class="keyword">static</span> std::map&lt;std::string, Factory&lt;Base&gt;*&gt;&amp; <a class="code" href="classFactory.php#a90ade05e5c9cdcf4a1437da3bf9e176c">factory_map</a>();
<a name="l00074"></a>00074 };
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00081"></a>00081 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Derived, <span class="keyword">class</span> Base&gt;
<a name="l00082"></a><a class="code" href="classFactoryImp.php">00082</a> <span class="keyword">class </span><a class="code" href="classFactoryImp.php">FactoryImp</a>: <span class="keyword">public</span> <a class="code" href="classFactory.php">Factory</a>&lt;Base&gt;
<a name="l00083"></a>00083 {
<a name="l00084"></a>00084 <span class="keyword">public</span>:
<a name="l00085"></a>00085 
<a name="l00089"></a><a class="code" href="classFactoryImp.php#a77d95eaa86cc01d4b1049c1f62800d2c">00089</a>   <a class="code" href="classFactoryImp.php#a77d95eaa86cc01d4b1049c1f62800d2c">FactoryImp</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>) : <a class="code" href="classFactory.php">Factory</a>&lt;Base&gt;(name) { }
<a name="l00090"></a>00090 
<a name="l00094"></a><a class="code" href="classFactoryImp.php#a0154dff004986f7b3213f2049b3223b3">00094</a>   <a class="code" href="classFactoryImp.php#a0154dff004986f7b3213f2049b3223b3">~FactoryImp</a> () {}
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 <span class="keyword">private</span>:
<a name="l00097"></a>00097 
<a name="l00101"></a>00101   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Base&gt;</a> <a class="code" href="classFactoryImp.php#a0f30bfe261690972ee3eeb2a5a4d2590">create</a> ();
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 };
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 <span class="comment">// -----------------------------------------------------</span>
<a name="l00108"></a>00108 <span class="comment">// Factory members</span>
<a name="l00109"></a>00109 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00110"></a>00110 <span class="keyword">inline</span>
<a name="l00111"></a><a class="code" href="classFactory.php#a5285e4782bc0ff5a80d098398475cb04">00111</a> <a class="code" href="classFactory.php#a5285e4782bc0ff5a80d098398475cb04">Factory&lt;Base&gt;::Factory</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00112"></a>00112 {
<a name="l00113"></a>00113   <span class="comment">// Make sure we haven&#39;t already added this name</span>
<a name="l00114"></a>00114   <span class="comment">// to the map</span>
<a name="l00115"></a>00115   libmesh_assert (!factory_map().count(name));
<a name="l00116"></a>00116 
<a name="l00117"></a>00117   factory_map()[<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>] = <span class="keyword">this</span>;
<a name="l00118"></a>00118 }
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00123"></a>00123 <span class="keyword">inline</span>
<a name="l00124"></a><a class="code" href="classFactory.php#ad893ae00db3e3dd087be0cbc3e22f106">00124</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Base&gt;</a> <a class="code" href="classFactory.php#ad893ae00db3e3dd087be0cbc3e22f106">Factory&lt;Base&gt;::build</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00125"></a>00125 {
<a name="l00126"></a>00126   <span class="comment">// name not found in the map</span>
<a name="l00127"></a>00127   <span class="keywordflow">if</span> (!factory_map().count(name))
<a name="l00128"></a>00128     {
<a name="l00129"></a>00129       std::cerr &lt;&lt; <span class="stringliteral">&quot;Tried to build an unknown type: &quot;</span> &lt;&lt; name &lt;&lt; std::endl;
<a name="l00130"></a>00130 
<a name="l00131"></a>00131       std::cerr &lt;&lt; <span class="stringliteral">&quot;valid options are:&quot;</span> &lt;&lt; std::endl;
<a name="l00132"></a>00132       
<a name="l00133"></a>00133       <span class="keywordflow">for</span> (<span class="keyword">typename</span> std::map&lt;std::string,<a class="code" href="classFactory.php">Factory&lt;Base&gt;</a>*&gt;::const_iterator
<a name="l00134"></a>00134              it = factory_map().begin(); it != factory_map().end(); ++it)
<a name="l00135"></a>00135         std::cerr &lt;&lt; <span class="stringliteral">&quot;  &quot;</span> &lt;&lt; it-&gt;first &lt;&lt; std::endl;
<a name="l00136"></a>00136 
<a name="l00137"></a>00137       libmesh_error();
<a name="l00138"></a>00138       
<a name="l00139"></a>00139       <span class="comment">// Do this the stoopid way for IBM xlC</span>
<a name="l00140"></a>00140       <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Base&gt;</a> ret_val (NULL);
<a name="l00141"></a>00141       
<a name="l00142"></a>00142       <span class="keywordflow">return</span> ret_val;
<a name="l00143"></a>00143     }
<a name="l00144"></a>00144   
<a name="l00145"></a>00145   <span class="comment">// Do this the stoopid way for IBM xlC</span>
<a name="l00146"></a>00146   <a class="code" href="classFactory.php">Factory&lt;Base&gt;</a> *f = factory_map()[<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>];
<a name="l00147"></a>00147   
<a name="l00148"></a>00148   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Base&gt;</a> ret_val (f-&gt;<a class="code" href="classFactory.php#a57fec03149cf23ae6a89c95a4c9bb8f7">create</a>());
<a name="l00149"></a>00149   
<a name="l00150"></a>00150   <span class="keywordflow">return</span> ret_val;
<a name="l00151"></a>00151 }
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 <span class="comment">// Note - this cannot be inlined!</span>
<a name="l00156"></a>00156 <span class="comment">// template &lt;class Base&gt;</span>
<a name="l00157"></a>00157 <span class="comment">// std::map&lt;std::string, Factory&lt;Base&gt;*&gt;&amp; Factory&lt;Base&gt;::factory_map()</span>
<a name="l00158"></a>00158 <span class="comment">// {</span>
<a name="l00159"></a>00159 <span class="comment">//   static std::map&lt;std::string, Factory&lt;Base&gt;*&gt; _factory_map;</span>
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 <span class="comment">//   return _factory_map;</span>
<a name="l00162"></a>00162 <span class="comment">// }</span>
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Derived, <span class="keyword">class</span> Base&gt;
<a name="l00167"></a>00167 <span class="keyword">inline</span>
<a name="l00168"></a><a class="code" href="classFactoryImp.php#a0f30bfe261690972ee3eeb2a5a4d2590">00168</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Base&gt;</a> <a class="code" href="classFactoryImp.php#a0f30bfe261690972ee3eeb2a5a4d2590">FactoryImp&lt;Derived,Base&gt;::create</a> ()
<a name="l00169"></a>00169 {  
<a name="l00170"></a>00170   <span class="comment">// Do this the stoopid way for IBM xlC</span>
<a name="l00171"></a>00171   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Base&gt;</a> ret_val (<span class="keyword">new</span> Derived);
<a name="l00172"></a>00172 
<a name="l00173"></a>00173   <span class="keywordflow">return</span> ret_val;
<a name="l00174"></a>00174 }
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
