<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_a0136eca6b184c0d854bbc4a8414e31c.php">fe</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>fe.C</h1>  </div>
</div>
<div class="contents">
<a href="fe_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;fe.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;fe_macro.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;quadrature.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00032"></a>00032 <span class="comment">// FE class members</span>
<a name="l00033"></a>00033 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00034"></a><a class="code" href="classFE.php#a8168c8902a8a52b2ef9df7d0088bdf75">00034</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFE.php#a8168c8902a8a52b2ef9df7d0088bdf75">FE&lt;Dim,T&gt;::n_shape_functions</a> ()<span class="keyword"> const</span>
<a name="l00035"></a>00035 <span class="keyword"></span>{
<a name="l00036"></a>00036   <span class="keywordflow">return</span> <a class="code" href="classFE.php#abe3e077e0e0cdc2fcd28eadd31ee4226">FE&lt;Dim,T&gt;::n_dofs</a> (elem_type,
<a name="l00037"></a>00037            static_cast&lt;Order&gt;(fe_type.order + _p_level));
<a name="l00038"></a>00038 }
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00042"></a><a class="code" href="classFE.php#a993e6cdde819303a7702fbb09decbf0d">00042</a> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a993e6cdde819303a7702fbb09decbf0d">FE&lt;Dim,T&gt;::attach_quadrature_rule</a> (<a class="code" href="classQBase.php">QBase</a>* q)
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044   libmesh_assert (q != NULL); 
<a name="l00045"></a>00045   qrule = q;
<a name="l00046"></a>00046   <span class="comment">// make sure we don&#39;t cache results from a previous quadrature rule</span>
<a name="l00047"></a>00047   elem_type = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>;
<a name="l00048"></a>00048   <span class="keywordflow">return</span>;
<a name="l00049"></a>00049 }
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00053"></a><a class="code" href="classFE.php#afec059b8f3fa105048273c70466828fa">00053</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFE.php#afec059b8f3fa105048273c70466828fa">FE&lt;Dim,T&gt;::n_quadrature_points</a> ()<span class="keyword"> const</span>
<a name="l00054"></a>00054 <span class="keyword"></span>{ 
<a name="l00055"></a>00055   libmesh_assert (qrule != NULL);  
<a name="l00056"></a>00056   <span class="keywordflow">return</span> qrule-&gt;n_points(); 
<a name="l00057"></a>00057 }
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00061"></a><a class="code" href="classFE.php#a6e9749fb4e337ee996de4f9b2620b7a3">00061</a> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6e9749fb4e337ee996de4f9b2620b7a3">FE&lt;Dim,T&gt;::dofs_on_side</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00062"></a>00062                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00063"></a>00063                              <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00064"></a>00064                              std::vector&lt;unsigned int&gt;&amp; di)
<a name="l00065"></a>00065 {
<a name="l00066"></a>00066   libmesh_assert(elem != NULL);
<a name="l00067"></a>00067   libmesh_assert(s &lt; elem-&gt;n_sides());
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   di.clear();
<a name="l00070"></a>00070   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nodenum = 0;
<a name="l00071"></a>00071   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a> = elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>();
<a name="l00072"></a>00072   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = 0; n != <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>; ++n)
<a name="l00073"></a>00073     {
<a name="l00074"></a>00074       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = n_dofs_at_node(elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>(),
<a name="l00075"></a>00075                                                  <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(o + elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>()), n);
<a name="l00076"></a>00076       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a85c5162cacd439d80d2262dec568c87a">is_node_on_side</a>(n, s))
<a name="l00077"></a>00077         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != n_dofs; ++i)
<a name="l00078"></a>00078           di.push_back(nodenum++);
<a name="l00079"></a>00079       <span class="keywordflow">else</span>
<a name="l00080"></a>00080         nodenum += n_dofs;
<a name="l00081"></a>00081     }
<a name="l00082"></a>00082 }
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00087"></a><a class="code" href="classFE.php#ad78c72e3261d35482599916fb5a17bd6">00087</a> <span class="keywordtype">void</span> <a class="code" href="classFE.php#ad78c72e3261d35482599916fb5a17bd6">FE&lt;Dim,T&gt;::dofs_on_edge</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00088"></a>00088                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00089"></a>00089                              <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e,
<a name="l00090"></a>00090                              std::vector&lt;unsigned int&gt;&amp; di)
<a name="l00091"></a>00091 {
<a name="l00092"></a>00092   libmesh_assert(elem != NULL);
<a name="l00093"></a>00093   libmesh_assert(e &lt; elem-&gt;n_edges());
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   di.clear();
<a name="l00096"></a>00096   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nodenum = 0;
<a name="l00097"></a>00097   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a> = elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>();
<a name="l00098"></a>00098   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = 0; n != <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>; ++n)
<a name="l00099"></a>00099     {
<a name="l00100"></a>00100       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = n_dofs_at_node(elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>(),
<a name="l00101"></a>00101                                                  <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(o + elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>()), n);
<a name="l00102"></a>00102       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a7942494caae96df757abd6e9ac5bd5b8">is_node_on_edge</a>(n, e))
<a name="l00103"></a>00103         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != n_dofs; ++i)
<a name="l00104"></a>00104           di.push_back(nodenum++);
<a name="l00105"></a>00105       <span class="keywordflow">else</span>
<a name="l00106"></a>00106         nodenum += n_dofs;
<a name="l00107"></a>00107     }
<a name="l00108"></a>00108 }
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00113"></a><a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">00113</a> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;Dim,T&gt;::reinit</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00114"></a>00114                        <span class="keyword">const</span> std::vector&lt;Point&gt;* <span class="keyword">const</span> pts)
<a name="l00115"></a>00115 {
<a name="l00116"></a>00116   libmesh_assert (elem != NULL);
<a name="l00117"></a>00117 
<a name="l00118"></a>00118   <span class="comment">// Try to avoid calling init_shape_functions</span>
<a name="l00119"></a>00119   <span class="comment">// even when shapes_need_reinit</span>
<a name="l00120"></a>00120   <span class="keywordtype">bool</span> cached_nodes_still_fit = <span class="keyword">false</span>;
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   <span class="comment">// Initialize the shape functions at the user-specified</span>
<a name="l00123"></a>00123   <span class="comment">// points</span>
<a name="l00124"></a>00124   <span class="keywordflow">if</span> (pts != NULL)
<a name="l00125"></a>00125     {
<a name="l00126"></a>00126       <span class="comment">// Set the type and p level for this element</span>
<a name="l00127"></a>00127       elem_type = elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>();
<a name="l00128"></a>00128       _p_level = elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>();
<a name="l00129"></a>00129 
<a name="l00130"></a>00130       <span class="comment">// Initialize the shape functions</span>
<a name="l00131"></a>00131       this-&gt;init_shape_functions (*pts, elem);
<a name="l00132"></a>00132 
<a name="l00133"></a>00133       <span class="comment">// The shape functions do not correspond to the qrule</span>
<a name="l00134"></a>00134       shapes_on_quadrature = <span class="keyword">false</span>;
<a name="l00135"></a>00135     }
<a name="l00136"></a>00136   
<a name="l00137"></a>00137   <span class="comment">// If there are no user specified points, we use the</span>
<a name="l00138"></a>00138   <span class="comment">// quadrature rule</span>
<a name="l00139"></a>00139   
<a name="l00140"></a>00140   <span class="comment">// update the type in accordance to the current cell</span>
<a name="l00141"></a>00141   <span class="comment">// and reinit if the cell type has changed or (as in</span>
<a name="l00142"></a>00142   <span class="comment">// the case of the hierarchics) the shape functions need</span>
<a name="l00143"></a>00143   <span class="comment">// reinit, since they depend on the particular element shape</span>
<a name="l00144"></a>00144   <span class="keywordflow">else</span> 
<a name="l00145"></a>00145     {
<a name="l00146"></a>00146       libmesh_assert (qrule   != NULL);
<a name="l00147"></a>00147       qrule-&gt;init(elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>(), elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>());
<a name="l00148"></a>00148 
<a name="l00149"></a>00149       <span class="keywordflow">if</span> (elem_type != elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>() ||
<a name="l00150"></a>00150           _p_level != elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>() ||
<a name="l00151"></a>00151           !shapes_on_quadrature)
<a name="l00152"></a>00152         {
<a name="l00153"></a>00153           <span class="comment">// Set the type and p level for this element</span>
<a name="l00154"></a>00154           elem_type = elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>();
<a name="l00155"></a>00155           _p_level = elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>();
<a name="l00156"></a>00156           <span class="comment">// Initialize the shape functions</span>
<a name="l00157"></a>00157           this-&gt;init_shape_functions (qrule-&gt;get_points(), elem);
<a name="l00158"></a>00158 
<a name="l00159"></a>00159           <span class="keywordflow">if</span> (this-&gt;shapes_need_reinit())
<a name="l00160"></a>00160             {
<a name="l00161"></a>00161               cached_nodes.resize(elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>());
<a name="l00162"></a>00162               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = 0; n != elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); ++n)
<a name="l00163"></a>00163                 {
<a name="l00164"></a>00164                   cached_nodes[n] = elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(n);
<a name="l00165"></a>00165                 }
<a name="l00166"></a>00166             }
<a name="l00167"></a>00167         }
<a name="l00168"></a>00168       <span class="keywordflow">else</span>
<a name="l00169"></a>00169         {
<a name="l00170"></a>00170           libmesh_assert(elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>() &gt; 1);
<a name="l00171"></a>00171 
<a name="l00172"></a>00172           cached_nodes_still_fit = <span class="keyword">true</span>;
<a name="l00173"></a>00173           <span class="keywordflow">if</span> (cached_nodes.size() != elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>())
<a name="l00174"></a>00174             cached_nodes_still_fit = <span class="keyword">false</span>;
<a name="l00175"></a>00175           <span class="keywordflow">else</span>
<a name="l00176"></a>00176             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = 1; n &lt; elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); ++n)
<a name="l00177"></a>00177               {
<a name="l00178"></a>00178                 <span class="keywordflow">if</span> ((elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(n) - elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0)) !=
<a name="l00179"></a>00179                     (cached_nodes[n] - cached_nodes[0]))
<a name="l00180"></a>00180                   {
<a name="l00181"></a>00181                     cached_nodes_still_fit = <span class="keyword">false</span>;
<a name="l00182"></a>00182                     <span class="keywordflow">break</span>;
<a name="l00183"></a>00183                   }
<a name="l00184"></a>00184               }
<a name="l00185"></a>00185 
<a name="l00186"></a>00186           <span class="keywordflow">if</span> (this-&gt;shapes_need_reinit() &amp;&amp; !cached_nodes_still_fit)
<a name="l00187"></a>00187             {
<a name="l00188"></a>00188               this-&gt;init_shape_functions (qrule-&gt;get_points(), elem);
<a name="l00189"></a>00189               cached_nodes.resize(elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>());
<a name="l00190"></a>00190               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = 0; n != elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); ++n)
<a name="l00191"></a>00191                 cached_nodes[n] = elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(n);
<a name="l00192"></a>00192             }
<a name="l00193"></a>00193         }
<a name="l00194"></a>00194       
<a name="l00195"></a>00195       <span class="comment">// The shape functions correspond to the qrule</span>
<a name="l00196"></a>00196       shapes_on_quadrature = <span class="keyword">true</span>;
<a name="l00197"></a>00197     }
<a name="l00198"></a>00198   
<a name="l00199"></a>00199   <span class="comment">// Compute the map for this element.  In the future we can specify</span>
<a name="l00200"></a>00200   <span class="comment">// different types of maps</span>
<a name="l00201"></a>00201   <span class="keywordflow">if</span> (pts != NULL)
<a name="l00202"></a>00202     {
<a name="l00203"></a>00203       std::vector&lt;Real&gt; dummy_weights (pts-&gt;size(), 1.);
<a name="l00204"></a>00204       
<a name="l00205"></a>00205       this-&gt;compute_map (dummy_weights, elem);
<a name="l00206"></a>00206     }
<a name="l00207"></a>00207   <span class="keywordflow">else</span>
<a name="l00208"></a>00208     {
<a name="l00209"></a>00209       this-&gt;compute_map (qrule-&gt;get_weights(), elem);
<a name="l00210"></a>00210     }
<a name="l00211"></a>00211 
<a name="l00212"></a>00212   <span class="comment">// Compute the shape functions and the derivatives at all of the</span>
<a name="l00213"></a>00213   <span class="comment">// quadrature points.</span>
<a name="l00214"></a>00214   <span class="keywordflow">if</span> (!cached_nodes_still_fit)
<a name="l00215"></a>00215     this-&gt;compute_shape_functions (elem);
<a name="l00216"></a>00216 }
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 
<a name="l00220"></a>00220 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00221"></a><a class="code" href="classFE.php#acdfc7e0bc7afae0c9cf8f67dbf5e2f57">00221</a> <span class="keywordtype">void</span> <a class="code" href="classFE.php#acdfc7e0bc7afae0c9cf8f67dbf5e2f57">FE&lt;Dim,T&gt;::init_shape_functions</a>(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qp,
<a name="l00222"></a>00222                                      <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem)
<a name="l00223"></a>00223 {
<a name="l00224"></a>00224   libmesh_assert (elem  != NULL);
<a name="l00225"></a>00225   calculations_started = <span class="keyword">true</span>;
<a name="l00226"></a>00226 
<a name="l00227"></a>00227   <span class="comment">// If the user forgot to request anything, we&#39;ll be safe and</span>
<a name="l00228"></a>00228   <span class="comment">// calculate everything:</span>
<a name="l00229"></a>00229 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00230"></a>00230 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (!calculate_phi &amp;&amp; !calculate_dphi &amp;&amp; !calculate_d2phi)
<a name="l00231"></a>00231     calculate_phi = calculate_dphi = calculate_d2phi = <span class="keyword">true</span>;
<a name="l00232"></a>00232 <span class="preprocessor">#else</span>
<a name="l00233"></a>00233 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (!calculate_phi &amp;&amp; !calculate_dphi)
<a name="l00234"></a>00234     calculate_phi = calculate_dphi = <span class="keyword">true</span>;
<a name="l00235"></a>00235 <span class="preprocessor">#endif // LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00236"></a>00236 <span class="preprocessor"></span>  
<a name="l00237"></a>00237   <span class="comment">// Start logging the shape function initialization</span>
<a name="l00238"></a>00238   START_LOG(<span class="stringliteral">&quot;init_shape_functions()&quot;</span>, <span class="stringliteral">&quot;FE&quot;</span>);
<a name="l00239"></a>00239 
<a name="l00240"></a>00240   
<a name="l00241"></a>00241   <span class="comment">// The number of quadrature points.</span>
<a name="l00242"></a>00242   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = qp.size();
<a name="l00243"></a>00243 
<a name="l00244"></a>00244   <span class="comment">// The element type and order to use in</span>
<a name="l00245"></a>00245   <span class="comment">// the map</span>
<a name="l00246"></a>00246   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>    mapping_order     (elem-&gt;<a class="code" href="classElem.php#a6cef8ca882c2fc1081fd27132851627a">default_order</a>());
<a name="l00247"></a>00247   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> mapping_elem_type (elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>());
<a name="l00248"></a>00248     
<a name="l00249"></a>00249   <span class="comment">// Number of shape functions in the finite element approximation</span>
<a name="l00250"></a>00250   <span class="comment">// space.</span>
<a name="l00251"></a>00251   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_approx_shape_functions =
<a name="l00252"></a>00252     this-&gt;n_shape_functions(this-&gt;get_type(),
<a name="l00253"></a>00253                             this-&gt;get_order());
<a name="l00254"></a>00254 
<a name="l00255"></a>00255   <span class="comment">// Number of shape functions used to construt the map</span>
<a name="l00256"></a>00256   <span class="comment">// (Lagrange shape functions are used for mapping)</span>
<a name="l00257"></a>00257   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_mapping_shape_functions =
<a name="l00258"></a>00258     <a class="code" href="classFE.php#a8168c8902a8a52b2ef9df7d0088bdf75">FE&lt;Dim,LAGRANGE&gt;::n_shape_functions</a> (mapping_elem_type,
<a name="l00259"></a>00259                                          mapping_order);
<a name="l00260"></a>00260   
<a name="l00261"></a>00261   <span class="comment">// resize the vectors to hold current data</span>
<a name="l00262"></a>00262   <span class="comment">// Phi are the shape functions used for the FE approximation</span>
<a name="l00263"></a>00263   <span class="comment">// Phi_map are the shape functions used for the FE mapping</span>
<a name="l00264"></a>00264   {
<a name="l00265"></a>00265     <span class="keywordflow">if</span> (calculate_phi)
<a name="l00266"></a>00266       phi.resize     (n_approx_shape_functions);
<a name="l00267"></a>00267     <span class="keywordflow">if</span> (calculate_dphi)
<a name="l00268"></a>00268       {
<a name="l00269"></a>00269         dphi.resize    (n_approx_shape_functions);
<a name="l00270"></a>00270         dphidx.resize  (n_approx_shape_functions);
<a name="l00271"></a>00271         dphidy.resize  (n_approx_shape_functions);
<a name="l00272"></a>00272         dphidz.resize  (n_approx_shape_functions);
<a name="l00273"></a>00273         dphidxi.resize (n_approx_shape_functions);
<a name="l00274"></a>00274 
<a name="l00275"></a>00275         <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00276"></a>00276           dphideta.resize      (n_approx_shape_functions);
<a name="l00277"></a>00277     
<a name="l00278"></a>00278         <span class="keywordflow">if</span> (Dim == 3)
<a name="l00279"></a>00279           dphidzeta.resize     (n_approx_shape_functions);
<a name="l00280"></a>00280       }
<a name="l00281"></a>00281 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00282"></a>00282 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (calculate_d2phi)
<a name="l00283"></a>00283       {
<a name="l00284"></a>00284         d2phi.resize     (n_approx_shape_functions);
<a name="l00285"></a>00285         d2phidx2.resize  (n_approx_shape_functions);
<a name="l00286"></a>00286         d2phidxdy.resize (n_approx_shape_functions);
<a name="l00287"></a>00287         d2phidxdz.resize (n_approx_shape_functions);
<a name="l00288"></a>00288         d2phidy2.resize  (n_approx_shape_functions);
<a name="l00289"></a>00289         d2phidydz.resize (n_approx_shape_functions);
<a name="l00290"></a>00290         d2phidz2.resize  (n_approx_shape_functions);
<a name="l00291"></a>00291         d2phidxi2.resize (n_approx_shape_functions);
<a name="l00292"></a>00292         <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00293"></a>00293           {
<a name="l00294"></a>00294             d2phidxideta.resize (n_approx_shape_functions);
<a name="l00295"></a>00295             d2phideta2.resize   (n_approx_shape_functions);
<a name="l00296"></a>00296           }
<a name="l00297"></a>00297         <span class="keywordflow">if</span> (Dim &gt; 2)
<a name="l00298"></a>00298           {
<a name="l00299"></a>00299             d2phidxidzeta.resize  (n_approx_shape_functions);
<a name="l00300"></a>00300             d2phidetadzeta.resize (n_approx_shape_functions);
<a name="l00301"></a>00301             d2phidzeta2.resize    (n_approx_shape_functions);
<a name="l00302"></a>00302           }
<a name="l00303"></a>00303       }
<a name="l00304"></a>00304 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00305"></a>00305 <span class="preprocessor"></span>    
<a name="l00306"></a>00306     phi_map.resize         (n_mapping_shape_functions);
<a name="l00307"></a>00307     dphidxi_map.resize     (n_mapping_shape_functions);
<a name="l00308"></a>00308 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00309"></a>00309 <span class="preprocessor"></span>    d2phidxi2_map.resize   (n_mapping_shape_functions);
<a name="l00310"></a>00310 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00311"></a>00311 <span class="preprocessor"></span>    
<a name="l00312"></a>00312     <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00313"></a>00313       {
<a name="l00314"></a>00314         dphideta_map.resize  (n_mapping_shape_functions);
<a name="l00315"></a>00315 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00316"></a>00316 <span class="preprocessor"></span>        d2phidxideta_map.resize   (n_mapping_shape_functions);
<a name="l00317"></a>00317         d2phideta2_map.resize     (n_mapping_shape_functions);
<a name="l00318"></a>00318 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00319"></a>00319 <span class="preprocessor"></span>      }
<a name="l00320"></a>00320     
<a name="l00321"></a>00321     <span class="keywordflow">if</span> (Dim == 3)
<a name="l00322"></a>00322       {
<a name="l00323"></a>00323         dphidzeta_map.resize (n_mapping_shape_functions);
<a name="l00324"></a>00324 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00325"></a>00325 <span class="preprocessor"></span>        d2phidxidzeta_map.resize  (n_mapping_shape_functions);
<a name="l00326"></a>00326         d2phidetadzeta_map.resize (n_mapping_shape_functions);
<a name="l00327"></a>00327         d2phidzeta2_map.resize    (n_mapping_shape_functions);
<a name="l00328"></a>00328 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00329"></a>00329 <span class="preprocessor"></span>      }
<a name="l00330"></a>00330     
<a name="l00331"></a>00331     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_approx_shape_functions; i++)
<a name="l00332"></a>00332       {
<a name="l00333"></a>00333         <span class="keywordflow">if</span> (calculate_phi)
<a name="l00334"></a>00334           phi[i].resize         (n_qp);
<a name="l00335"></a>00335         <span class="keywordflow">if</span> (calculate_dphi)
<a name="l00336"></a>00336           {
<a name="l00337"></a>00337             dphi[i].resize        (n_qp);
<a name="l00338"></a>00338             dphidx[i].resize      (n_qp);
<a name="l00339"></a>00339             dphidy[i].resize      (n_qp);
<a name="l00340"></a>00340             dphidz[i].resize      (n_qp);
<a name="l00341"></a>00341             dphidxi[i].resize     (n_qp);
<a name="l00342"></a>00342 
<a name="l00343"></a>00343             <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00344"></a>00344               dphideta[i].resize  (n_qp);
<a name="l00345"></a>00345            
<a name="l00346"></a>00346             <span class="keywordflow">if</span> (Dim == 3)            
<a name="l00347"></a>00347               dphidzeta[i].resize (n_qp);
<a name="l00348"></a>00348           }
<a name="l00349"></a>00349 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00350"></a>00350 <span class="preprocessor"></span>        <span class="keywordflow">if</span> (calculate_d2phi)
<a name="l00351"></a>00351           {
<a name="l00352"></a>00352             d2phi[i].resize     (n_qp);
<a name="l00353"></a>00353             d2phidx2[i].resize  (n_qp);
<a name="l00354"></a>00354             d2phidxdy[i].resize (n_qp);
<a name="l00355"></a>00355             d2phidxdz[i].resize (n_qp);
<a name="l00356"></a>00356             d2phidy2[i].resize  (n_qp);
<a name="l00357"></a>00357             d2phidydz[i].resize (n_qp);
<a name="l00358"></a>00358             d2phidz2[i].resize  (n_qp);
<a name="l00359"></a>00359             d2phidxi2[i].resize (n_qp);
<a name="l00360"></a>00360             <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00361"></a>00361               {
<a name="l00362"></a>00362                 d2phidxideta[i].resize (n_qp);
<a name="l00363"></a>00363                 d2phideta2[i].resize   (n_qp);
<a name="l00364"></a>00364               }
<a name="l00365"></a>00365             <span class="keywordflow">if</span> (Dim &gt; 2)
<a name="l00366"></a>00366               {
<a name="l00367"></a>00367                 d2phidxidzeta[i].resize  (n_qp);
<a name="l00368"></a>00368                 d2phidetadzeta[i].resize (n_qp);
<a name="l00369"></a>00369                 d2phidzeta2[i].resize    (n_qp);
<a name="l00370"></a>00370               }
<a name="l00371"></a>00371           }
<a name="l00372"></a>00372 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00373"></a>00373 <span class="preprocessor"></span>      }
<a name="l00374"></a>00374        
<a name="l00375"></a>00375     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_mapping_shape_functions; i++)
<a name="l00376"></a>00376       {
<a name="l00377"></a>00377         phi_map[i].resize         (n_qp);
<a name="l00378"></a>00378         dphidxi_map[i].resize     (n_qp);
<a name="l00379"></a>00379 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00380"></a>00380 <span class="preprocessor"></span>        d2phidxi2_map[i].resize     (n_qp);
<a name="l00381"></a>00381         <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00382"></a>00382           {
<a name="l00383"></a>00383             d2phidxideta_map[i].resize (n_qp);
<a name="l00384"></a>00384             d2phideta2_map[i].resize (n_qp);
<a name="l00385"></a>00385           }
<a name="l00386"></a>00386         <span class="keywordflow">if</span> (Dim &gt; 2)
<a name="l00387"></a>00387           {
<a name="l00388"></a>00388             d2phidxidzeta_map[i].resize  (n_qp);
<a name="l00389"></a>00389             d2phidetadzeta_map[i].resize (n_qp);
<a name="l00390"></a>00390             d2phidzeta2_map[i].resize    (n_qp);
<a name="l00391"></a>00391           }
<a name="l00392"></a>00392 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00393"></a>00393 <span class="preprocessor"></span>           
<a name="l00394"></a>00394         <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00395"></a>00395           dphideta_map[i].resize  (n_qp);
<a name="l00396"></a>00396            
<a name="l00397"></a>00397         <span class="keywordflow">if</span> (Dim == 3)
<a name="l00398"></a>00398           dphidzeta_map[i].resize (n_qp);
<a name="l00399"></a>00399       }
<a name="l00400"></a>00400   }
<a name="l00401"></a>00401 
<a name="l00402"></a>00402 
<a name="l00403"></a>00403       
<a name="l00404"></a>00404 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00405"></a>00405 <span class="preprocessor"></span>  <span class="comment">//------------------------------------------------------------</span>
<a name="l00406"></a>00406   <span class="comment">// Initialize the data fields, which should only be used for infinite </span>
<a name="l00407"></a>00407   <span class="comment">// elements, to some sensible values, so that using a FE with the</span>
<a name="l00408"></a>00408   <span class="comment">// variational formulation of an InfFE, correct element matrices are</span>
<a name="l00409"></a>00409   <span class="comment">// returned</span>
<a name="l00410"></a>00410 
<a name="l00411"></a>00411  {
<a name="l00412"></a>00412     <a class="code" href="namespaceMeshTools.php#a7c3064eb37925fb5bdda7660e872cf69">weight</a>.resize  (n_qp);
<a name="l00413"></a>00413     dweight.resize (n_qp);
<a name="l00414"></a>00414     dphase.resize  (n_qp);
<a name="l00415"></a>00415     
<a name="l00416"></a>00416     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00417"></a>00417       {
<a name="l00418"></a>00418         <a class="code" href="namespaceMeshTools.php#a7c3064eb37925fb5bdda7660e872cf69">weight</a>[p] = 1.;
<a name="l00419"></a>00419         dweight[p].zero();
<a name="l00420"></a>00420         dphase[p].zero();
<a name="l00421"></a>00421       }
<a name="l00422"></a>00422 
<a name="l00423"></a>00423  }
<a name="l00424"></a>00424 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00425"></a>00425 <span class="preprocessor"></span>
<a name="l00426"></a>00426   <span class="comment">// Optimize for the affine elements case:</span>
<a name="l00427"></a>00427   <span class="keywordtype">bool</span> has_affine_map = elem-&gt;<a class="code" href="classElem.php#aff14264607cb433fd12a19ea0ffd1d89">has_affine_map</a>();
<a name="l00428"></a>00428   
<a name="l00429"></a>00429   <span class="keywordflow">switch</span> (Dim)
<a name="l00430"></a>00430     {
<a name="l00431"></a>00431 
<a name="l00432"></a>00432       <span class="comment">//------------------------------------------------------------</span>
<a name="l00433"></a>00433       <span class="comment">// 1D</span>
<a name="l00434"></a>00434     <span class="keywordflow">case</span> 1:
<a name="l00435"></a>00435       {
<a name="l00436"></a>00436         <span class="comment">// Compute the value of the approximation shape function i at quadrature point p</span>
<a name="l00437"></a>00437         <span class="keywordflow">if</span> (calculate_phi)
<a name="l00438"></a>00438           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_approx_shape_functions; i++)
<a name="l00439"></a>00439             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00440"></a>00440               phi[i][p]      = <a class="code" href="classFE.php">FE&lt;Dim,T&gt;::shape</a>       (elem, fe_type.order, i,    qp[p]);
<a name="l00441"></a>00441         <span class="keywordflow">if</span> (calculate_dphi)
<a name="l00442"></a>00442           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_approx_shape_functions; i++)
<a name="l00443"></a>00443             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00444"></a>00444               dphidxi[i][p]  = <a class="code" href="classFE.php">FE&lt;Dim,T&gt;::shape_deriv</a> (elem, fe_type.order, i, 0, qp[p]);
<a name="l00445"></a>00445 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00446"></a>00446 <span class="preprocessor"></span>        <span class="keywordflow">if</span> (calculate_d2phi)
<a name="l00447"></a>00447           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_approx_shape_functions; i++)
<a name="l00448"></a>00448             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00449"></a>00449               d2phidxi2[i][p] = <a class="code" href="classFE.php">FE&lt;Dim,T&gt;::shape_second_deriv</a> (elem, fe_type.order, i, 0, qp[p]);
<a name="l00450"></a>00450 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00451"></a>00451 <span class="preprocessor"></span>        
<a name="l00452"></a>00452         <span class="comment">// Compute the value of the mapping shape function i at quadrature point p</span>
<a name="l00453"></a>00453         <span class="comment">// (Lagrange shape functions are used for mapping)</span>
<a name="l00454"></a>00454         <span class="keywordflow">if</span> (has_affine_map)
<a name="l00455"></a>00455           {
<a name="l00456"></a>00456             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_mapping_shape_functions; i++)
<a name="l00457"></a>00457               {
<a name="l00458"></a>00458                 phi_map[i][0]      = <a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">FE&lt;Dim,LAGRANGE&gt;::shape</a>       (mapping_elem_type, mapping_order, i,    qp[0]);
<a name="l00459"></a>00459                 dphidxi_map[i][0]  = <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a> (mapping_elem_type, mapping_order, i, 0, qp[0]);
<a name="l00460"></a>00460 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00461"></a>00461 <span class="preprocessor"></span>                d2phidxi2_map[i][0] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 0, qp[0]);
<a name="l00462"></a>00462 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00463"></a>00463 <span class="preprocessor"></span>                <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p&lt;n_qp; p++)
<a name="l00464"></a>00464                   {
<a name="l00465"></a>00465                     phi_map[i][p]      = <a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">FE&lt;Dim,LAGRANGE&gt;::shape</a> (mapping_elem_type, mapping_order, i,    qp[p]);
<a name="l00466"></a>00466                     dphidxi_map[i][p]  = dphidxi_map[i][0];
<a name="l00467"></a>00467 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00468"></a>00468 <span class="preprocessor"></span>                    d2phidxi2_map[i][p] = d2phidxi2_map[i][0];
<a name="l00469"></a>00469 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00470"></a>00470 <span class="preprocessor"></span>                  }
<a name="l00471"></a>00471               }
<a name="l00472"></a>00472           }
<a name="l00473"></a>00473         <span class="keywordflow">else</span>
<a name="l00474"></a>00474           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_mapping_shape_functions; i++)
<a name="l00475"></a>00475             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00476"></a>00476               {
<a name="l00477"></a>00477                 phi_map[i][p]      = <a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">FE&lt;Dim,LAGRANGE&gt;::shape</a>       (mapping_elem_type, mapping_order, i,    qp[p]);
<a name="l00478"></a>00478                 dphidxi_map[i][p]  = <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a> (mapping_elem_type, mapping_order, i, 0, qp[p]);
<a name="l00479"></a>00479 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00480"></a>00480 <span class="preprocessor"></span>                d2phidxi2_map[i][p] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 0, qp[p]);
<a name="l00481"></a>00481 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00482"></a>00482 <span class="preprocessor"></span>              }
<a name="l00483"></a>00483                 
<a name="l00484"></a>00484         <span class="keywordflow">break</span>;
<a name="l00485"></a>00485       }
<a name="l00486"></a>00486 
<a name="l00487"></a>00487 
<a name="l00488"></a>00488       
<a name="l00489"></a>00489       <span class="comment">//------------------------------------------------------------</span>
<a name="l00490"></a>00490       <span class="comment">// 2D</span>
<a name="l00491"></a>00491     <span class="keywordflow">case</span> 2:
<a name="l00492"></a>00492       {
<a name="l00493"></a>00493         <span class="comment">// Compute the value of the approximation shape function i at quadrature point p</span>
<a name="l00494"></a>00494         <span class="keywordflow">if</span> (calculate_phi)
<a name="l00495"></a>00495           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_approx_shape_functions; i++)
<a name="l00496"></a>00496             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00497"></a>00497               phi[i][p]      = <a class="code" href="classFE.php">FE&lt;Dim,T&gt;::shape</a>       (elem, fe_type.order, i,    qp[p]);
<a name="l00498"></a>00498         <span class="keywordflow">if</span> (calculate_dphi)
<a name="l00499"></a>00499           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_approx_shape_functions; i++)
<a name="l00500"></a>00500             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00501"></a>00501               {
<a name="l00502"></a>00502                 dphidxi[i][p]  = <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;Dim,T&gt;::shape_deriv</a> (elem, fe_type.order, i, 0, qp[p]);
<a name="l00503"></a>00503                 dphideta[i][p] = <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;Dim,T&gt;::shape_deriv</a> (elem, fe_type.order, i, 1, qp[p]);
<a name="l00504"></a>00504               }
<a name="l00505"></a>00505 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00506"></a>00506 <span class="preprocessor"></span>        <span class="keywordflow">if</span> (calculate_d2phi)
<a name="l00507"></a>00507           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_approx_shape_functions; i++)
<a name="l00508"></a>00508             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00509"></a>00509               {
<a name="l00510"></a>00510                 d2phidxi2[i][p] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,T&gt;::shape_second_deriv</a> (elem, fe_type.order, i, 0, qp[p]);
<a name="l00511"></a>00511                 d2phidxideta[i][p] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,T&gt;::shape_second_deriv</a> (elem, fe_type.order, i, 1, qp[p]);
<a name="l00512"></a>00512                 d2phideta2[i][p] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,T&gt;::shape_second_deriv</a> (elem, fe_type.order, i, 2, qp[p]);
<a name="l00513"></a>00513               }
<a name="l00514"></a>00514 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00515"></a>00515 <span class="preprocessor"></span>        
<a name="l00516"></a>00516         <span class="comment">// Compute the value of the mapping shape function i at quadrature point p</span>
<a name="l00517"></a>00517         <span class="comment">// (Lagrange shape functions are used for mapping)</span>
<a name="l00518"></a>00518         <span class="keywordflow">if</span> (has_affine_map)
<a name="l00519"></a>00519           {
<a name="l00520"></a>00520             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_mapping_shape_functions; i++)
<a name="l00521"></a>00521               {
<a name="l00522"></a>00522                 phi_map[i][0]      = <a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">FE&lt;Dim,LAGRANGE&gt;::shape</a>       (mapping_elem_type, mapping_order, i,    qp[0]);
<a name="l00523"></a>00523                 dphidxi_map[i][0]  = <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a> (mapping_elem_type, mapping_order, i, 0, qp[0]);
<a name="l00524"></a>00524                 dphideta_map[i][0] = <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a> (mapping_elem_type, mapping_order, i, 1, qp[0]);
<a name="l00525"></a>00525 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00526"></a>00526 <span class="preprocessor"></span>                d2phidxi2_map[i][0] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 0, qp[0]);
<a name="l00527"></a>00527                 d2phidxideta_map[i][0] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 1, qp[0]);
<a name="l00528"></a>00528                 d2phideta2_map[i][0] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 2, qp[0]);
<a name="l00529"></a>00529 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00530"></a>00530 <span class="preprocessor"></span>                <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p&lt;n_qp; p++)
<a name="l00531"></a>00531                   {
<a name="l00532"></a>00532                     phi_map[i][p]      = <a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">FE&lt;Dim,LAGRANGE&gt;::shape</a> (mapping_elem_type, mapping_order, i,    qp[p]);
<a name="l00533"></a>00533                     dphidxi_map[i][p]  = dphidxi_map[i][0];
<a name="l00534"></a>00534                     dphideta_map[i][p] = dphideta_map[i][0];
<a name="l00535"></a>00535 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00536"></a>00536 <span class="preprocessor"></span>                    d2phidxi2_map[i][p] = d2phidxi2_map[i][0];
<a name="l00537"></a>00537                     d2phidxideta_map[i][p] = d2phidxideta_map[i][0];
<a name="l00538"></a>00538                     d2phideta2_map[i][p] = d2phideta2_map[i][0];
<a name="l00539"></a>00539 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00540"></a>00540 <span class="preprocessor"></span>                  }
<a name="l00541"></a>00541               }
<a name="l00542"></a>00542           }
<a name="l00543"></a>00543         <span class="keywordflow">else</span>
<a name="l00544"></a>00544           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_mapping_shape_functions; i++)
<a name="l00545"></a>00545             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00546"></a>00546               {
<a name="l00547"></a>00547                 phi_map[i][p]      = <a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">FE&lt;Dim,LAGRANGE&gt;::shape</a>       (mapping_elem_type, mapping_order, i,    qp[p]);
<a name="l00548"></a>00548                 dphidxi_map[i][p]  = <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a> (mapping_elem_type, mapping_order, i, 0, qp[p]);
<a name="l00549"></a>00549                 dphideta_map[i][p] = <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a> (mapping_elem_type, mapping_order, i, 1, qp[p]);
<a name="l00550"></a>00550 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00551"></a>00551 <span class="preprocessor"></span>                d2phidxi2_map[i][p] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 0, qp[p]);
<a name="l00552"></a>00552                 d2phidxideta_map[i][p] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 1, qp[p]);
<a name="l00553"></a>00553                 d2phideta2_map[i][p] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 2, qp[p]);
<a name="l00554"></a>00554 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00555"></a>00555 <span class="preprocessor"></span>              }
<a name="l00556"></a>00556                         
<a name="l00557"></a>00557         <span class="keywordflow">break</span>;
<a name="l00558"></a>00558       }
<a name="l00559"></a>00559 
<a name="l00560"></a>00560 
<a name="l00561"></a>00561       
<a name="l00562"></a>00562       <span class="comment">//------------------------------------------------------------</span>
<a name="l00563"></a>00563       <span class="comment">// 3D</span>
<a name="l00564"></a>00564     <span class="keywordflow">case</span> 3:
<a name="l00565"></a>00565       {
<a name="l00566"></a>00566         <span class="comment">// Compute the value of the approximation shape function i at quadrature point p</span>
<a name="l00567"></a>00567         <span class="keywordflow">if</span> (calculate_phi)
<a name="l00568"></a>00568           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_approx_shape_functions; i++)
<a name="l00569"></a>00569             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00570"></a>00570               phi[i][p]       = <a class="code" href="classFE.php">FE&lt;Dim,T&gt;::shape</a>       (elem, fe_type.order, i,    qp[p]);
<a name="l00571"></a>00571         <span class="keywordflow">if</span> (calculate_dphi)
<a name="l00572"></a>00572           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_approx_shape_functions; i++)
<a name="l00573"></a>00573             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00574"></a>00574               {
<a name="l00575"></a>00575                 dphidxi[i][p]   = <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;Dim,T&gt;::shape_deriv</a> (elem, fe_type.order, i, 0, qp[p]);
<a name="l00576"></a>00576                 dphideta[i][p]  = <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;Dim,T&gt;::shape_deriv</a> (elem, fe_type.order, i, 1, qp[p]);
<a name="l00577"></a>00577                 dphidzeta[i][p] = <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;Dim,T&gt;::shape_deriv</a> (elem, fe_type.order, i, 2, qp[p]);
<a name="l00578"></a>00578               }
<a name="l00579"></a>00579 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00580"></a>00580 <span class="preprocessor"></span>        <span class="keywordflow">if</span> (calculate_d2phi)
<a name="l00581"></a>00581           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_approx_shape_functions; i++)
<a name="l00582"></a>00582             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00583"></a>00583               {
<a name="l00584"></a>00584                 d2phidxi2[i][p] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,T&gt;::shape_second_deriv</a> (elem, fe_type.order, i, 0, qp[p]);
<a name="l00585"></a>00585                 d2phidxideta[i][p] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,T&gt;::shape_second_deriv</a> (elem, fe_type.order, i, 1, qp[p]);
<a name="l00586"></a>00586                 d2phideta2[i][p] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,T&gt;::shape_second_deriv</a> (elem, fe_type.order, i, 2, qp[p]);
<a name="l00587"></a>00587                 d2phidxidzeta[i][p] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,T&gt;::shape_second_deriv</a> (elem, fe_type.order, i, 3, qp[p]);
<a name="l00588"></a>00588                 d2phidetadzeta[i][p] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,T&gt;::shape_second_deriv</a> (elem, fe_type.order, i, 4, qp[p]);
<a name="l00589"></a>00589                 d2phidzeta2[i][p] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,T&gt;::shape_second_deriv</a> (elem, fe_type.order, i, 5, qp[p]);
<a name="l00590"></a>00590               }
<a name="l00591"></a>00591 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00592"></a>00592 <span class="preprocessor"></span>        
<a name="l00593"></a>00593         <span class="comment">// Compute the value of the mapping shape function i at quadrature point p</span>
<a name="l00594"></a>00594         <span class="comment">// (Lagrange shape functions are used for mapping)</span>
<a name="l00595"></a>00595         <span class="keywordflow">if</span> (has_affine_map)
<a name="l00596"></a>00596           {
<a name="l00597"></a>00597             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_mapping_shape_functions; i++)
<a name="l00598"></a>00598               {
<a name="l00599"></a>00599                 phi_map[i][0]      = <a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">FE&lt;Dim,LAGRANGE&gt;::shape</a>       (mapping_elem_type, mapping_order, i,    qp[0]);
<a name="l00600"></a>00600                 dphidxi_map[i][0]  = <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a> (mapping_elem_type, mapping_order, i, 0, qp[0]);
<a name="l00601"></a>00601                 dphideta_map[i][0] = <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a> (mapping_elem_type, mapping_order, i, 1, qp[0]);
<a name="l00602"></a>00602                 dphidzeta_map[i][0] = <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a> (mapping_elem_type, mapping_order, i, 2, qp[0]);
<a name="l00603"></a>00603 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00604"></a>00604 <span class="preprocessor"></span>                d2phidxi2_map[i][0] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 0, qp[0]);
<a name="l00605"></a>00605                 d2phidxideta_map[i][0] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 1, qp[0]);
<a name="l00606"></a>00606                 d2phideta2_map[i][0] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 2, qp[0]);
<a name="l00607"></a>00607                 d2phidxideta_map[i][0] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 3, qp[0]);
<a name="l00608"></a>00608                 d2phidetadzeta_map[i][0] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 4, qp[0]);
<a name="l00609"></a>00609                 d2phidzeta2_map[i][0] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 5, qp[0]);
<a name="l00610"></a>00610 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00611"></a>00611 <span class="preprocessor"></span>                <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p&lt;n_qp; p++)
<a name="l00612"></a>00612                   {
<a name="l00613"></a>00613                     phi_map[i][p]      = <a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">FE&lt;Dim,LAGRANGE&gt;::shape</a> (mapping_elem_type, mapping_order, i,    qp[p]);
<a name="l00614"></a>00614                     dphidxi_map[i][p]  = dphidxi_map[i][0];
<a name="l00615"></a>00615                     dphideta_map[i][p] = dphideta_map[i][0];
<a name="l00616"></a>00616                     dphidzeta_map[i][p] = dphidzeta_map[i][0];
<a name="l00617"></a>00617 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00618"></a>00618 <span class="preprocessor"></span>                    d2phidxi2_map[i][p] = d2phidxi2_map[i][0];
<a name="l00619"></a>00619                     d2phidxideta_map[i][p] = d2phidxideta_map[i][0];
<a name="l00620"></a>00620                     d2phideta2_map[i][p] = d2phideta2_map[i][0];
<a name="l00621"></a>00621                     d2phidxideta_map[i][p] = d2phidxideta_map[i][0];
<a name="l00622"></a>00622                     d2phidetadzeta_map[i][p] = d2phidetadzeta_map[i][0];
<a name="l00623"></a>00623                     d2phidzeta2_map[i][p] = d2phidzeta2_map[i][0];
<a name="l00624"></a>00624 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00625"></a>00625 <span class="preprocessor"></span>                  }
<a name="l00626"></a>00626               }
<a name="l00627"></a>00627           }
<a name="l00628"></a>00628         <span class="keywordflow">else</span>
<a name="l00629"></a>00629           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_mapping_shape_functions; i++)
<a name="l00630"></a>00630             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00631"></a>00631               {
<a name="l00632"></a>00632                 phi_map[i][p]       = <a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">FE&lt;Dim,LAGRANGE&gt;::shape</a>       (mapping_elem_type, mapping_order, i,    qp[p]);
<a name="l00633"></a>00633                 dphidxi_map[i][p]   = <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a> (mapping_elem_type, mapping_order, i, 0, qp[p]);
<a name="l00634"></a>00634                 dphideta_map[i][p]  = <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a> (mapping_elem_type, mapping_order, i, 1, qp[p]);
<a name="l00635"></a>00635                 dphidzeta_map[i][p] = <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a> (mapping_elem_type, mapping_order, i, 2, qp[p]);
<a name="l00636"></a>00636 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00637"></a>00637 <span class="preprocessor"></span>                d2phidxi2_map[i][p] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 0, qp[p]);
<a name="l00638"></a>00638                 d2phidxideta_map[i][p] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 1, qp[p]);
<a name="l00639"></a>00639                 d2phideta2_map[i][p] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 2, qp[p]);
<a name="l00640"></a>00640                 d2phidxideta_map[i][p] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 3, qp[p]);
<a name="l00641"></a>00641                 d2phidetadzeta_map[i][p] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 4, qp[p]);
<a name="l00642"></a>00642                 d2phidzeta2_map[i][p] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 5, qp[p]);
<a name="l00643"></a>00643 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00644"></a>00644 <span class="preprocessor"></span>              }
<a name="l00645"></a>00645                         
<a name="l00646"></a>00646         <span class="keywordflow">break</span>;
<a name="l00647"></a>00647       }
<a name="l00648"></a>00648 
<a name="l00649"></a>00649 
<a name="l00650"></a>00650     <span class="keywordflow">default</span>:
<a name="l00651"></a>00651       libmesh_error();
<a name="l00652"></a>00652     }
<a name="l00653"></a>00653   
<a name="l00654"></a>00654   <span class="comment">// Stop logging the shape function initialization</span>
<a name="l00655"></a>00655   STOP_LOG(<span class="stringliteral">&quot;init_shape_functions()&quot;</span>, <span class="stringliteral">&quot;FE&quot;</span>);
<a name="l00656"></a>00656 }
<a name="l00657"></a>00657 
<a name="l00658"></a>00658 
<a name="l00659"></a>00659 
<a name="l00660"></a>00660     
<a name="l00661"></a>00661 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00662"></a>00662 <span class="preprocessor"></span>
<a name="l00663"></a>00663 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00664"></a><a class="code" href="classFE.php#a133fa13998cdc6fe5eca9bcf4dcb6216">00664</a> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a133fa13998cdc6fe5eca9bcf4dcb6216">FE&lt;Dim,T&gt;::init_base_shape_functions</a>(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qp,
<a name="l00665"></a>00665                                           <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* e)
<a name="l00666"></a>00666 { 
<a name="l00667"></a>00667   <span class="comment">// I don&#39;t understand infinite elements well enough to risk</span>
<a name="l00668"></a>00668   <span class="comment">// calculating too little.  :-(  RHS</span>
<a name="l00669"></a>00669   calculate_phi = calculate_dphi = calculate_d2phi = <span class="keyword">true</span>;
<a name="l00670"></a>00670 
<a name="l00671"></a>00671   elem_type = e-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>(); 
<a name="l00672"></a>00672   init_shape_functions(qp, e); 
<a name="l00673"></a>00673 }
<a name="l00674"></a>00674 
<a name="l00675"></a>00675 <span class="preprocessor">#endif // LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00676"></a>00676 <span class="preprocessor"></span>    
<a name="l00677"></a>00677 
<a name="l00678"></a>00678 
<a name="l00679"></a>00679 <span class="comment">//--------------------------------------------------------------</span>
<a name="l00680"></a>00680 <span class="comment">// Explicit instantiations using macro from fe_macro.h</span>
<a name="l00681"></a>00681 
<a name="l00682"></a>00682 <a class="code" href="fe_8C.php#a5525a19631bacc32ac49d63bf3fbc09c">INSTANTIATE_FE</a>(0);
<a name="l00683"></a>00683 
<a name="l00684"></a>00684 <a class="code" href="fe_8C.php#a5525a19631bacc32ac49d63bf3fbc09c">INSTANTIATE_FE</a>(1);
<a name="l00685"></a>00685 
<a name="l00686"></a>00686 <a class="code" href="fe_8C.php#a5525a19631bacc32ac49d63bf3fbc09c">INSTANTIATE_FE</a>(2);
<a name="l00687"></a>00687 
<a name="l00688"></a>00688 <a class="code" href="fe_8C.php#a5525a19631bacc32ac49d63bf3fbc09c">INSTANTIATE_FE</a>(3);
<a name="l00689"></a>00689 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
