<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f00dea3e7b839559ab8b1786e03603be.php">fe</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>fe.h</h1>  </div>
</div>
<div class="contents">
<a href="fe_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __fe_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __fe_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="fe__base_8h.php">fe_base.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh.h&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// forward declarations</span>
<a name="l00032"></a>00032 <span class="keyword">class </span><a class="code" href="classDofConstraints.php">DofConstraints</a>;
<a name="l00033"></a>00033 <span class="keyword">class </span><a class="code" href="classDofMap.php">DofMap</a>;
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span>
<a name="l00037"></a>00037 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> friend_Dim, FEFamily friend_T_radial, InfMapType friend_T_map&gt;
<a name="l00038"></a>00038 <span class="keyword">class </span><a class="code" href="classInfFE.php">InfFE</a>;
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="preprocessor">#endif</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00062"></a>00062 <span class="comment">//-------------------------------------------------------------</span>
<a name="l00063"></a>00063 <span class="comment">// FE class definition</span>
<a name="l00064"></a>00064 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00065"></a><a class="code" href="classFE.php">00065</a> <span class="keyword">class </span><a class="code" href="classFE.php">FE</a> : <span class="keyword">public</span> <a class="code" href="classFEBase.php">FEBase</a>
<a name="l00066"></a>00066 {
<a name="l00067"></a>00067 <span class="keyword">public</span>:
<a name="l00068"></a>00068   
<a name="l00072"></a>00072   <a class="code" href="classFE.php#a9e66415299029ff51113eedd25dc6f4d">FE</a>(<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet);
<a name="l00073"></a>00073   
<a name="l00082"></a>00082   <span class="keyword">static</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">shape</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00083"></a>00083                     <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00084"></a>00084                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00085"></a>00085                     <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p);
<a name="l00086"></a>00086 
<a name="l00095"></a>00095   <span class="keyword">static</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">shape</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00096"></a>00096                     <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00097"></a>00097                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00098"></a>00098                     <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p);
<a name="l00099"></a>00099   
<a name="l00107"></a>00107   <span class="keyword">static</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00108"></a>00108                           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00109"></a>00109                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00110"></a>00110                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00111"></a>00111                           <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p);
<a name="l00112"></a>00112 
<a name="l00119"></a>00119   <span class="keyword">static</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00120"></a>00120                           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00121"></a>00121                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00122"></a>00122                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00123"></a>00123                           <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p);
<a name="l00124"></a>00124 
<a name="l00143"></a>00143   <span class="keyword">static</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">shape_second_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00144"></a>00144                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00145"></a>00145                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00146"></a>00146                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00147"></a>00147                                  <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p);
<a name="l00148"></a>00148 
<a name="l00167"></a>00167   <span class="keyword">static</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">shape_second_deriv</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00168"></a>00168                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00169"></a>00169                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00170"></a>00170                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00171"></a>00171                                  <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p);
<a name="l00172"></a>00172   
<a name="l00179"></a>00179   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#ab9eb52fbac1e03dc0752fbf210ef3261">nodal_soln</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem, <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00180"></a>00180                          <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; elem_soln,
<a name="l00181"></a>00181                          std::vector&lt;Number&gt;&amp; <a class="code" href="classFE.php#ab9eb52fbac1e03dc0752fbf210ef3261">nodal_soln</a>);
<a name="l00182"></a>00182 
<a name="l00187"></a>00187   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFE.php#a8168c8902a8a52b2ef9df7d0088bdf75">n_shape_functions</a> () <span class="keyword">const</span>;
<a name="l00188"></a>00188 
<a name="l00195"></a><a class="code" href="classFE.php#a83ed4de3aebdb0cbaa0c2445f11652d8">00195</a>   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFE.php#a8168c8902a8a52b2ef9df7d0088bdf75">n_shape_functions</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00196"></a>00196                                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o)
<a name="l00197"></a>00197   { <span class="keywordflow">return</span> <a class="code" href="classFE.php#abe3e077e0e0cdc2fcd28eadd31ee4226">FE&lt;Dim,T&gt;::n_dofs</a> (t,o); }
<a name="l00198"></a>00198 
<a name="l00205"></a>00205   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFE.php#abe3e077e0e0cdc2fcd28eadd31ee4226">n_dofs</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00206"></a>00206                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o);
<a name="l00207"></a>00207 
<a name="l00214"></a>00214   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFE.php#a5a0c23191aaf003e5dd3707ae6194edb">n_dofs_at_node</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00215"></a>00215                                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00216"></a>00216                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l00217"></a>00217 
<a name="l00224"></a>00224   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFE.php#ac120bc6b3ff89f7468684e6bf5377eae">n_dofs_per_elem</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00225"></a>00225                                       <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o);
<a name="l00226"></a>00226 
<a name="l00230"></a>00230   <span class="keyword">virtual</span> <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14">FEContinuity</a> <a class="code" href="classFE.php#a5b45c9ef72ec7cedf4f5305b17fef80b">get_continuity</a>() <span class="keyword">const</span>;
<a name="l00231"></a>00231                                        
<a name="l00236"></a>00236   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classFE.php#a0fa72e632398f70b693cc8a5278c06fe">is_hierarchic</a>() <span class="keyword">const</span>;
<a name="l00237"></a>00237                                        
<a name="l00244"></a>00244   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6e9749fb4e337ee996de4f9b2620b7a3">dofs_on_side</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00245"></a>00245                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00246"></a>00246                            <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00247"></a>00247                            std::vector&lt;unsigned int&gt;&amp; di);
<a name="l00254"></a>00254   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#ad78c72e3261d35482599916fb5a17bd6">dofs_on_edge</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00255"></a>00255                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00256"></a>00256                            <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e,
<a name="l00257"></a>00257                            std::vector&lt;unsigned int&gt;&amp; di);
<a name="l00258"></a>00258 
<a name="l00268"></a>00268   <span class="keyword">static</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classFE.php#a140b8081b50074b7dbd739857d787428">inverse_map</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00269"></a>00269                             <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00270"></a>00270                             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tolerance = TOLERANCE,
<a name="l00271"></a>00271                             <span class="keyword">const</span> <span class="keywordtype">bool</span> secure = <span class="keyword">true</span>);
<a name="l00272"></a>00272 
<a name="l00283"></a>00283   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a140b8081b50074b7dbd739857d787428">inverse_map</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00284"></a>00284                            <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; physical_points,
<a name="l00285"></a>00285                            std::vector&lt;Point&gt;&amp;       reference_points,
<a name="l00286"></a>00286                            <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tolerance = TOLERANCE,
<a name="l00287"></a>00287                            <span class="keyword">const</span> <span class="keywordtype">bool</span> secure = <span class="keyword">true</span>);
<a name="l00288"></a>00288   
<a name="l00299"></a>00299   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">reinit</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00300"></a>00300                        <span class="keyword">const</span> std::vector&lt;Point&gt;* <span class="keyword">const</span> pts = NULL);
<a name="l00301"></a>00301     
<a name="l00307"></a>00307   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">reinit</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00308"></a>00308                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> side,
<a name="l00309"></a>00309                        <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tolerance = TOLERANCE);
<a name="l00310"></a>00310 
<a name="l00316"></a>00316   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#adb74f797c07e54b20b437fa105d21929">edge_reinit</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00317"></a>00317                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> edge,
<a name="l00318"></a>00318                             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tolerance = TOLERANCE);
<a name="l00319"></a>00319 
<a name="l00325"></a>00325   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a993e6cdde819303a7702fbb09decbf0d">attach_quadrature_rule</a> (<a class="code" href="classQBase.php">QBase</a>* q);
<a name="l00326"></a>00326   
<a name="l00332"></a>00332   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFE.php#afec059b8f3fa105048273c70466828fa">n_quadrature_points</a> () <span class="keyword">const</span>;
<a name="l00333"></a>00333 
<a name="l00334"></a>00334 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00335"></a>00335 <span class="preprocessor"></span>
<a name="l00341"></a>00341   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a42d4509fecc1d24a5107b5af2166020f">compute_constraints</a> (<a class="code" href="classDofConstraints.php">DofConstraints</a> &amp;constraints,
<a name="l00342"></a>00342                                    <a class="code" href="classDofMap.php">DofMap</a> &amp;dof_map,
<a name="l00343"></a>00343                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> variable_number,
<a name="l00344"></a>00344                                    <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem);
<a name="l00345"></a>00345 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00346"></a>00346 <span class="preprocessor"></span>  
<a name="l00347"></a>00347 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00348"></a>00348 <span class="preprocessor"></span>
<a name="l00353"></a>00353   <span class="keywordtype">void</span> <a class="code" href="classFE.php#a133fa13998cdc6fe5eca9bcf4dcb6216">init_base_shape_functions</a>(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qp,
<a name="l00354"></a>00354                                  <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* e);
<a name="l00355"></a>00355 
<a name="l00356"></a>00356 <span class="preprocessor">#endif</span>
<a name="l00357"></a>00357 <span class="preprocessor"></span>
<a name="l00364"></a>00364   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classFE.php#a430150f3095c97d1672991997f93f100">shapes_need_reinit</a>() <span class="keyword">const</span>;
<a name="l00365"></a>00365   
<a name="l00373"></a>00373   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#acdfc7e0bc7afae0c9cf8f67dbf5e2f57">init_shape_functions</a>(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qp,
<a name="l00374"></a>00374                                     <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* e);
<a name="l00375"></a>00375 
<a name="l00380"></a>00380   <span class="keywordtype">void</span> <a class="code" href="classFE.php#a2ecff327bbb449b07bb2a1d28756fc30">init_face_shape_functions</a>(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qp,
<a name="l00381"></a>00381                                  <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* side);
<a name="l00382"></a>00382 
<a name="l00387"></a>00387   <span class="keywordtype">void</span> <a class="code" href="classFE.php#a9ef0db35bb9fba3d69a6dd771c82ab95">init_edge_shape_functions</a>(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qp,
<a name="l00388"></a>00388                                  <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* edge);
<a name="l00389"></a>00389 
<a name="l00394"></a>00394   <span class="keyword">static</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classFE.php#ad693264af6f1ff8f2d736f73cadc8f3d">map</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00395"></a>00395                     <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; reference_point);
<a name="l00396"></a>00396   
<a name="l00401"></a>00401   <span class="keyword">static</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classFE.php#a8c834bbbbdca5a30a49fb9ffa5a3dd95">map_xi</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00402"></a>00402                        <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; reference_point);
<a name="l00403"></a>00403   
<a name="l00408"></a>00408   <span class="keyword">static</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classFE.php#a18463361f35a76dc092bd5ead743e0bb">map_eta</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00409"></a>00409                         <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; reference_point);
<a name="l00410"></a>00410 
<a name="l00415"></a>00415   <span class="keyword">static</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classFE.php#ad75f76061ee489aceabe7767c9763e4e">map_zeta</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00416"></a>00416                          <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; reference_point);
<a name="l00417"></a>00417 
<a name="l00418"></a>00418 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00419"></a>00419 <span class="preprocessor"></span>
<a name="l00423"></a>00423   <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> friend_Dim, FEFamily friend_T_radial, InfMapType friend_T_map&gt;
<a name="l00424"></a><a class="code" href="classFE.php#a30966325e9cd5ef7b41e45148b6919ed">00424</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classInfFE.php">InfFE</a>;
<a name="l00425"></a>00425 <span class="preprocessor">#endif</span>
<a name="l00426"></a>00426 <span class="preprocessor"></span>
<a name="l00427"></a>00427 <span class="keyword">protected</span>:
<a name="l00432"></a><a class="code" href="classFE.php#a5ebef2085e3a26ac5f8c6edb79b4c18b">00432</a>   std::vector&lt;Point&gt; <a class="code" href="classFE.php#a5ebef2085e3a26ac5f8c6edb79b4c18b">cached_nodes</a>;
<a name="l00433"></a>00433 
<a name="l00437"></a><a class="code" href="classFE.php#a96e5fa88e5186a76337f3146e265ddf2">00437</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFE.php#a96e5fa88e5186a76337f3146e265ddf2">last_side</a>, <a class="code" href="classFE.php#a559a10caae6770862cfceb254775779b">last_edge</a>;
<a name="l00438"></a>00438 };
<a name="l00439"></a>00439 
<a name="l00440"></a>00440 
<a name="l00441"></a>00441 
<a name="l00451"></a>00451 <span class="comment">//-------------------------------------------------------------</span>
<a name="l00452"></a>00452 <span class="comment">// FEHierarchic class definition</span>
<a name="l00453"></a>00453 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00454"></a><a class="code" href="classFEClough.php">00454</a> <span class="keyword">class </span><a class="code" href="classFEClough.php">FEClough</a> : <span class="keyword">public</span> <a class="code" href="classFE.php">FE</a>&lt;Dim,CLOUGH&gt;
<a name="l00455"></a>00455 {
<a name="l00456"></a>00456 <span class="keyword">public</span>:
<a name="l00457"></a>00457 
<a name="l00462"></a>00462   <a class="code" href="classFEClough.php#a259669d464a4ad044808d152cffc9c93">FEClough</a>(<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet);
<a name="l00463"></a>00463 };
<a name="l00464"></a>00464 
<a name="l00465"></a>00465 
<a name="l00466"></a>00466 
<a name="l00476"></a>00476 <span class="comment">//-------------------------------------------------------------</span>
<a name="l00477"></a>00477 <span class="comment">// FEHierarchic class definition</span>
<a name="l00478"></a>00478 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00479"></a><a class="code" href="classFEHermite.php">00479</a> <span class="keyword">class </span><a class="code" href="classFEHermite.php">FEHermite</a> : <span class="keyword">public</span> <a class="code" href="classFE.php">FE</a>&lt;Dim,HERMITE&gt;
<a name="l00480"></a>00480 {
<a name="l00481"></a>00481 <span class="keyword">public</span>:
<a name="l00482"></a>00482 
<a name="l00487"></a>00487   <a class="code" href="classFEHermite.php#ace9cf9885c3d7a9b498b839b382461c3">FEHermite</a>(<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet);
<a name="l00488"></a>00488 
<a name="l00492"></a>00492   <span class="keyword">static</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFEHermite.php#acd01fb811ec22bc7de2976a8864de425">hermite_raw_shape_second_deriv</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basis_num,
<a name="l00493"></a>00493                                              <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xi);
<a name="l00494"></a>00494   <span class="keyword">static</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFEHermite.php#a94cde0cfc476e2c20c1f52ceddcb22f9">hermite_raw_shape_deriv</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basis_num,
<a name="l00495"></a>00495                                       <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xi);
<a name="l00496"></a>00496   <span class="keyword">static</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFEHermite.php#a9dec6617e680d08a2b94a60219115833">hermite_raw_shape</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basis_num,
<a name="l00497"></a>00497                                 <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xi);
<a name="l00498"></a>00498 };
<a name="l00499"></a>00499 
<a name="l00500"></a>00500 
<a name="l00501"></a>00501 
<a name="l00511"></a>00511 <span class="comment">//-------------------------------------------------------------</span>
<a name="l00512"></a>00512 <span class="comment">// FEHierarchic class definition</span>
<a name="l00513"></a>00513 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00514"></a><a class="code" href="classFEHierarchic.php">00514</a> <span class="keyword">class </span><a class="code" href="classFEHierarchic.php">FEHierarchic</a> : <span class="keyword">public</span> <a class="code" href="classFE.php">FE</a>&lt;Dim,HIERARCHIC&gt;
<a name="l00515"></a>00515 {
<a name="l00516"></a>00516 <span class="keyword">public</span>:
<a name="l00517"></a>00517 
<a name="l00522"></a>00522   <a class="code" href="classFEHierarchic.php#a5ea3408331cb766be3976262e658cb24">FEHierarchic</a>(<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet);
<a name="l00523"></a>00523 };
<a name="l00524"></a>00524 
<a name="l00525"></a>00525 
<a name="l00526"></a>00526 
<a name="l00536"></a>00536 <span class="comment">//-------------------------------------------------------------</span>
<a name="l00537"></a>00537 <span class="comment">// FELagrange class definition</span>
<a name="l00538"></a>00538 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00539"></a><a class="code" href="classFELagrange.php">00539</a> <span class="keyword">class </span><a class="code" href="classFELagrange.php">FELagrange</a> : <span class="keyword">public</span> <a class="code" href="classFE.php">FE</a>&lt;Dim,LAGRANGE&gt;
<a name="l00540"></a>00540 {
<a name="l00541"></a>00541 <span class="keyword">public</span>:
<a name="l00542"></a>00542 
<a name="l00547"></a>00547   <a class="code" href="classFELagrange.php#a573d37d3cd5ae60a436a7fe340d89ef8">FELagrange</a>(<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet);
<a name="l00548"></a>00548 };
<a name="l00549"></a>00549 
<a name="l00550"></a>00550 
<a name="l00551"></a>00551 
<a name="l00561"></a>00561 <span class="comment">//-------------------------------------------------------------</span>
<a name="l00562"></a>00562 <span class="comment">// FEMonomial class definition</span>
<a name="l00563"></a>00563 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00564"></a><a class="code" href="classFEMonomial.php">00564</a> <span class="keyword">class </span><a class="code" href="classFEMonomial.php">FEMonomial</a> : <span class="keyword">public</span> <a class="code" href="classFE.php">FE</a>&lt;Dim,MONOMIAL&gt;
<a name="l00565"></a>00565 {
<a name="l00566"></a>00566 <span class="keyword">public</span>:
<a name="l00567"></a>00567 
<a name="l00572"></a>00572   <a class="code" href="classFEMonomial.php#abf786b0a3852fa375365d91f5b940bc4">FEMonomial</a>(<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet);
<a name="l00573"></a>00573 };
<a name="l00574"></a>00574 
<a name="l00575"></a>00575 
<a name="l00576"></a>00576 <span class="comment">//-------------------------------------------------------------</span>
<a name="l00577"></a>00577 <span class="comment">// FEScalar class definition</span>
<a name="l00578"></a>00578 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00579"></a><a class="code" href="classFEScalar.php">00579</a> <span class="keyword">class </span><a class="code" href="classFEScalar.php">FEScalar</a> : <span class="keyword">public</span> <a class="code" href="classFE.php">FE</a>&lt;Dim,SCALAR&gt;
<a name="l00580"></a>00580 {
<a name="l00581"></a>00581 <span class="keyword">public</span>:
<a name="l00582"></a>00582 
<a name="l00589"></a>00589   <a class="code" href="classFEScalar.php#a57672d0f819d06f89c3a226008128c15">FEScalar</a>(<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet);
<a name="l00590"></a>00590 };
<a name="l00591"></a>00591 
<a name="l00592"></a>00592 
<a name="l00603"></a>00603 <span class="comment">//-------------------------------------------------------------</span>
<a name="l00604"></a>00604 <span class="comment">// FEXYZ class definition</span>
<a name="l00605"></a>00605 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00606"></a><a class="code" href="classFEXYZ.php">00606</a> <span class="keyword">class </span><a class="code" href="classFEXYZ.php">FEXYZ</a> : <span class="keyword">public</span> <a class="code" href="classFE.php">FE</a>&lt;Dim,XYZ&gt;
<a name="l00607"></a>00607 {
<a name="l00608"></a>00608 <span class="keyword">public</span>:
<a name="l00609"></a>00609   
<a name="l00614"></a>00614   <a class="code" href="classFEXYZ.php#a69fa48300a088eea2af3dadac0a58d0e">FEXYZ</a>(<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet);
<a name="l00615"></a>00615     
<a name="l00620"></a><a class="code" href="classFEXYZ.php#aeed6b095d4bf80dda1ab4a4162071e27">00620</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEXYZ.php#aeed6b095d4bf80dda1ab4a4162071e27">reinit</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00621"></a>00621                        <span class="keyword">const</span> std::vector&lt;Point&gt;* <span class="keyword">const</span> pts = NULL)
<a name="l00622"></a>00622   { <a class="code" href="classFEXYZ.php#aeed6b095d4bf80dda1ab4a4162071e27">FE&lt;Dim,XYZ&gt;::reinit</a> (elem, pts); }
<a name="l00623"></a>00623 
<a name="l00628"></a>00628   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEXYZ.php#aeed6b095d4bf80dda1ab4a4162071e27">reinit</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00629"></a>00629                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> side,
<a name="l00630"></a>00630                        <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tolerance = TOLERANCE);
<a name="l00631"></a>00631 
<a name="l00632"></a>00632 
<a name="l00633"></a>00633 <span class="keyword">protected</span>:
<a name="l00634"></a>00634 
<a name="l00642"></a>00642   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEXYZ.php#a1ee618bda09f939e0d59818823ee3715">init_shape_functions</a>(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qp,
<a name="l00643"></a>00643                                     <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* e);
<a name="l00644"></a>00644 
<a name="l00655"></a>00655   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEXYZ.php#a55d4be750c414956549a641485729b4b">compute_shape_functions</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*);
<a name="l00656"></a>00656 
<a name="l00660"></a>00660   <span class="keywordtype">void</span> <a class="code" href="classFEXYZ.php#a9aa9eee56e336637c6637ea88565df33">compute_face_values</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00661"></a>00661                             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* side);
<a name="l00662"></a>00662 };
<a name="l00663"></a>00663 
<a name="l00664"></a>00664 
<a name="l00665"></a>00665 
<a name="l00666"></a>00666 
<a name="l00670"></a><a class="code" href="namespaceFiniteElements.php">00670</a> <span class="keyword">namespace </span>FiniteElements
<a name="l00671"></a>00671 {
<a name="l00676"></a><a class="code" href="namespaceFiniteElements.php#a35a9e58fabcc581b33711f8f7459d893">00676</a>   <span class="keyword">typedef</span> <a class="code" href="classFEClough.php">FEClough&lt;2&gt;</a> <a class="code" href="namespaceFiniteElements.php#a35a9e58fabcc581b33711f8f7459d893">FEClough2D</a>;
<a name="l00677"></a>00677   
<a name="l00682"></a><a class="code" href="namespaceFiniteElements.php#a79fd12f341c5c1abf7a7898c05e8f472">00682</a>   <span class="keyword">typedef</span> <a class="code" href="classFE.php">FE&lt;1,HIERARCHIC&gt;</a> <a class="code" href="namespaceFiniteElements.php#a79fd12f341c5c1abf7a7898c05e8f472">FEHierarchic1D</a>;
<a name="l00683"></a>00683   
<a name="l00688"></a><a class="code" href="namespaceFiniteElements.php#ab272f177a3d6ace3f7bfb4a1d495e90a">00688</a>   <span class="keyword">typedef</span> <a class="code" href="classFE.php">FE&lt;2,HIERARCHIC&gt;</a> <a class="code" href="namespaceFiniteElements.php#ab272f177a3d6ace3f7bfb4a1d495e90a">FEHierarchic2D</a>;
<a name="l00689"></a>00689   
<a name="l00694"></a><a class="code" href="namespaceFiniteElements.php#ac218b0cbc56d9cdfbaeb78dd0ead970d">00694</a>   <span class="keyword">typedef</span> <a class="code" href="classFE.php">FE&lt;3,HIERARCHIC&gt;</a> <a class="code" href="namespaceFiniteElements.php#ac218b0cbc56d9cdfbaeb78dd0ead970d">FEHierarchic3D</a>;
<a name="l00695"></a>00695   
<a name="l00696"></a>00696 
<a name="l00697"></a>00697 
<a name="l00702"></a><a class="code" href="namespaceFiniteElements.php#a5c72441db38c9d390b13c4ccf4e71ac9">00702</a>   <span class="keyword">typedef</span> <a class="code" href="classFE.php">FE&lt;1,LAGRANGE&gt;</a> <a class="code" href="namespaceFiniteElements.php#a5c72441db38c9d390b13c4ccf4e71ac9">FELagrange1D</a>;
<a name="l00703"></a>00703 
<a name="l00708"></a><a class="code" href="namespaceFiniteElements.php#a54b48f31017d77906ad276fb7b667351">00708</a>   <span class="keyword">typedef</span> <a class="code" href="classFE.php">FE&lt;2,LAGRANGE&gt;</a> <a class="code" href="namespaceFiniteElements.php#a54b48f31017d77906ad276fb7b667351">FELagrange2D</a>;
<a name="l00709"></a>00709 
<a name="l00714"></a><a class="code" href="namespaceFiniteElements.php#a1653a9bd4b9af078eb7be3e656ca4479">00714</a>   <span class="keyword">typedef</span> <a class="code" href="classFE.php">FE&lt;3,LAGRANGE&gt;</a> <a class="code" href="namespaceFiniteElements.php#a1653a9bd4b9af078eb7be3e656ca4479">FELagrange3D</a>;
<a name="l00715"></a>00715 
<a name="l00716"></a>00716 
<a name="l00717"></a>00717   
<a name="l00722"></a><a class="code" href="namespaceFiniteElements.php#a0838030dc6fdaeb7eb202c224765b610">00722</a>   <span class="keyword">typedef</span> <a class="code" href="classFE.php">FE&lt;1,MONOMIAL&gt;</a> <a class="code" href="namespaceFiniteElements.php#a0838030dc6fdaeb7eb202c224765b610">FEMonomial1D</a>;
<a name="l00723"></a>00723   
<a name="l00728"></a><a class="code" href="namespaceFiniteElements.php#a4a3a5def505b89e964ecbf4dd9d40d00">00728</a>   <span class="keyword">typedef</span> <a class="code" href="classFE.php">FE&lt;2,MONOMIAL&gt;</a> <a class="code" href="namespaceFiniteElements.php#a4a3a5def505b89e964ecbf4dd9d40d00">FEMonomial2D</a>;
<a name="l00729"></a>00729 
<a name="l00734"></a><a class="code" href="namespaceFiniteElements.php#acdc9654d8a39d91c1ee1e2e362e8795b">00734</a>   <span class="keyword">typedef</span> <a class="code" href="classFE.php">FE&lt;3,MONOMIAL&gt;</a> <a class="code" href="namespaceFiniteElements.php#acdc9654d8a39d91c1ee1e2e362e8795b">FEMonomial3D</a>;
<a name="l00735"></a>00735 
<a name="l00736"></a>00736 }
<a name="l00737"></a>00737 
<a name="l00738"></a>00738 
<a name="l00739"></a>00739 
<a name="l00740"></a>00740 
<a name="l00741"></a>00741 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00742"></a>00742 <span class="comment">// FE class inline members</span>
<a name="l00743"></a>00743 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00744"></a>00744 <span class="keyword">inline</span>
<a name="l00745"></a><a class="code" href="classFE.php#a9e66415299029ff51113eedd25dc6f4d">00745</a> <a class="code" href="classFE.php#a9e66415299029ff51113eedd25dc6f4d">FE&lt;Dim,T&gt;::FE</a> (<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet) :
<a name="l00746"></a>00746   <a class="code" href="classFEBase.php">FEBase</a> (Dim,fet),
<a name="l00747"></a>00747   last_side(libMesh::<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a>),
<a name="l00748"></a>00748   last_edge(libMesh::<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a>)
<a name="l00749"></a>00749 {
<a name="l00750"></a>00750   <span class="comment">// Sanity check.  Make sure the</span>
<a name="l00751"></a>00751   <span class="comment">// Family specified in the template instantiation</span>
<a name="l00752"></a>00752   <span class="comment">// matches the one in the FEType object</span>
<a name="l00753"></a>00753   libmesh_assert (T == <a class="code" href="classFEBase.php#a129d0b4c88b2bb5a24326a4c5dd7f670">fe_type</a>.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>);
<a name="l00754"></a>00754 }
<a name="l00755"></a>00755 
<a name="l00756"></a>00756 
<a name="l00757"></a>00757 
<a name="l00758"></a>00758 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00759"></a>00759 <span class="comment">// FEClough class inline members</span>
<a name="l00760"></a>00760 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00761"></a>00761 <span class="keyword">inline</span>
<a name="l00762"></a><a class="code" href="classFEClough.php#a259669d464a4ad044808d152cffc9c93">00762</a> <a class="code" href="classFEClough.php#a259669d464a4ad044808d152cffc9c93">FEClough&lt;Dim&gt;::FEClough</a> (<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet) :
<a name="l00763"></a>00763   <a class="code" href="classFE.php">FE</a>&lt;Dim,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>&gt; (fet)
<a name="l00764"></a>00764 {
<a name="l00765"></a>00765 }
<a name="l00766"></a>00766 
<a name="l00767"></a>00767 
<a name="l00768"></a>00768 
<a name="l00769"></a>00769 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00770"></a>00770 <span class="comment">// FEHermite class inline members</span>
<a name="l00771"></a>00771 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00772"></a>00772 <span class="keyword">inline</span>
<a name="l00773"></a><a class="code" href="classFEHermite.php#ace9cf9885c3d7a9b498b839b382461c3">00773</a> <a class="code" href="classFEHermite.php#ace9cf9885c3d7a9b498b839b382461c3">FEHermite&lt;Dim&gt;::FEHermite</a> (<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet) :
<a name="l00774"></a>00774   <a class="code" href="classFE.php">FE</a>&lt;Dim,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>&gt; (fet)
<a name="l00775"></a>00775 {
<a name="l00776"></a>00776 }
<a name="l00777"></a>00777 
<a name="l00778"></a>00778 
<a name="l00779"></a>00779 
<a name="l00780"></a>00780 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00781"></a>00781 <span class="comment">// FEHierarchic class inline members</span>
<a name="l00782"></a>00782 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00783"></a>00783 <span class="keyword">inline</span>
<a name="l00784"></a><a class="code" href="classFEHierarchic.php#a5ea3408331cb766be3976262e658cb24">00784</a> <a class="code" href="classFEHierarchic.php#a5ea3408331cb766be3976262e658cb24">FEHierarchic&lt;Dim&gt;::FEHierarchic</a> (<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet) :
<a name="l00785"></a>00785   <a class="code" href="classFE.php">FE</a>&lt;Dim,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>&gt; (fet)
<a name="l00786"></a>00786 {
<a name="l00787"></a>00787 }
<a name="l00788"></a>00788 
<a name="l00789"></a>00789 
<a name="l00790"></a>00790 
<a name="l00791"></a>00791 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00792"></a>00792 <span class="comment">// FELagrange class inline members</span>
<a name="l00793"></a>00793 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00794"></a>00794 <span class="keyword">inline</span>
<a name="l00795"></a><a class="code" href="classFELagrange.php#a573d37d3cd5ae60a436a7fe340d89ef8">00795</a> <a class="code" href="classFELagrange.php#a573d37d3cd5ae60a436a7fe340d89ef8">FELagrange&lt;Dim&gt;::FELagrange</a> (<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet) :
<a name="l00796"></a>00796   <a class="code" href="classFE.php">FE</a>&lt;Dim,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>&gt; (fet)
<a name="l00797"></a>00797 {
<a name="l00798"></a>00798 }
<a name="l00799"></a>00799 
<a name="l00800"></a>00800 
<a name="l00801"></a>00801 
<a name="l00802"></a>00802 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00803"></a>00803 <span class="comment">// FEMonomial class inline members</span>
<a name="l00804"></a>00804 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00805"></a>00805 <span class="keyword">inline</span>
<a name="l00806"></a><a class="code" href="classFEMonomial.php#abf786b0a3852fa375365d91f5b940bc4">00806</a> <a class="code" href="classFEMonomial.php#abf786b0a3852fa375365d91f5b940bc4">FEMonomial&lt;Dim&gt;::FEMonomial</a> (<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet) :
<a name="l00807"></a>00807   <a class="code" href="classFE.php">FE</a>&lt;Dim,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>&gt; (fet)
<a name="l00808"></a>00808 {
<a name="l00809"></a>00809 }
<a name="l00810"></a>00810 
<a name="l00811"></a>00811 
<a name="l00812"></a>00812 
<a name="l00813"></a>00813 
<a name="l00814"></a>00814 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00815"></a>00815 <span class="comment">// FEXYZ class inline members</span>
<a name="l00816"></a>00816 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00817"></a>00817 <span class="keyword">inline</span>
<a name="l00818"></a><a class="code" href="classFEXYZ.php#a69fa48300a088eea2af3dadac0a58d0e">00818</a> <a class="code" href="classFEXYZ.php#a69fa48300a088eea2af3dadac0a58d0e">FEXYZ&lt;Dim&gt;::FEXYZ</a> (<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet) :
<a name="l00819"></a>00819   <a class="code" href="classFE.php">FE</a>&lt;Dim,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>&gt; (fet)
<a name="l00820"></a>00820 {
<a name="l00821"></a>00821 }
<a name="l00822"></a>00822 
<a name="l00823"></a>00823 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00824"></a>00824 <span class="comment">// FEScalar class inline members</span>
<a name="l00825"></a>00825 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00826"></a>00826 <span class="keyword">inline</span>
<a name="l00827"></a><a class="code" href="classFEScalar.php#a57672d0f819d06f89c3a226008128c15">00827</a> <a class="code" href="classFEScalar.php#a57672d0f819d06f89c3a226008128c15">FEScalar&lt;Dim&gt;::FEScalar</a> (<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet) :
<a name="l00828"></a>00828   <a class="code" href="classFE.php">FE</a>&lt;Dim,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>&gt; (fet)
<a name="l00829"></a>00829 {
<a name="l00830"></a>00830 }
<a name="l00831"></a>00831 
<a name="l00832"></a>00832 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
