<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f00dea3e7b839559ab8b1786e03603be.php">fe</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>fe_base.h</h1>  </div>
</div>
<div class="contents">
<a href="fe__base_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_base.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __fe_base_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __fe_base_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;reference_counted_object.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;point.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;vector_value.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;enum_elem_type.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="fe__type_8h.php">fe_type.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;auto_ptr.h&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span><span class="preprocessor">#include &quot;tensor_value.h&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#endif</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">// forward declarations</span>
<a name="l00042"></a>00042 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classDenseMatrix.php">DenseMatrix</a>;
<a name="l00043"></a>00043 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classDenseVector.php">DenseVector</a>;
<a name="l00044"></a>00044 <span class="keyword">class </span><a class="code" href="classBoundaryInfo.php">BoundaryInfo</a>;
<a name="l00045"></a>00045 <span class="keyword">class </span><a class="code" href="classDofConstraints.php">DofConstraints</a>;
<a name="l00046"></a>00046 <span class="keyword">class </span><a class="code" href="classDofMap.php">DofMap</a>;
<a name="l00047"></a>00047 <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00048"></a>00048 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00049"></a>00049 <span class="keyword">class </span><a class="code" href="classPeriodicBoundaries.php">PeriodicBoundaries</a>;
<a name="l00050"></a>00050 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classNumericVector.php">NumericVector</a>;
<a name="l00051"></a>00051 <span class="keyword">class </span><a class="code" href="classQBase.php">QBase</a>;
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span>
<a name="l00055"></a>00055 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00056"></a>00056 <span class="keyword">class </span><a class="code" href="classInfFE.php">InfFE</a>;
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 <span class="preprocessor">#endif</span>
<a name="l00059"></a>00059 <span class="preprocessor"></span>
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00086"></a>00086 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00087"></a>00087 <span class="comment">// FEBase class definition</span>
<a name="l00088"></a><a class="code" href="classFEBase.php">00088</a> <span class="keyword">class </span><a class="code" href="classFEBase.php">FEBase</a> : <span class="keyword">public</span> <a class="code" href="classReferenceCountedObject.php">ReferenceCountedObject</a>&lt;FEBase&gt;
<a name="l00089"></a>00089 {
<a name="l00090"></a>00090 <span class="keyword">protected</span>:
<a name="l00091"></a>00091 
<a name="l00097"></a>00097   <a class="code" href="classFEBase.php#accbdd6aea90ca887757f7fa930d1ac37">FEBase</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFEBase.php#a883023d0114b38abb42d38479459738e">dim</a>,
<a name="l00098"></a>00098           <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet);
<a name="l00099"></a>00099   
<a name="l00100"></a>00100 <span class="keyword">public</span>:
<a name="l00101"></a>00101   
<a name="l00105"></a>00105   <span class="keyword">virtual</span> <a class="code" href="classFEBase.php#aee9233b9d3f48a3d7f9a80a7ff8ef26b">~FEBase</a>();
<a name="l00106"></a>00106 
<a name="l00112"></a>00112   <span class="keyword">static</span> <a class="code" href="classAutoPtr.php">AutoPtr&lt;FEBase&gt;</a> <a class="code" href="classFEBase.php#a3e86219b79ce4f881e9c48f4fd7b860e">build</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00113"></a>00113                                 <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; type); 
<a name="l00114"></a>00114   
<a name="l00115"></a>00115 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00116"></a>00116 <span class="preprocessor"></span>
<a name="l00122"></a>00122   <span class="keyword">static</span> <a class="code" href="classAutoPtr.php">AutoPtr&lt;FEBase&gt;</a> <a class="code" href="classFEBase.php#a5870b7e7a7214517d5f1f8f5e16fb968">build_InfFE</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00123"></a>00123                                       <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; type); 
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 <span class="preprocessor">#endif</span>
<a name="l00126"></a>00126 <span class="preprocessor"></span>
<a name="l00141"></a>00141   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEBase.php#a2e8aa83ccd81231f77faa31f9009f414">reinit</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00142"></a>00142                        <span class="keyword">const</span> std::vector&lt;Point&gt;* <span class="keyword">const</span> pts = NULL) = 0;
<a name="l00143"></a>00143     
<a name="l00149"></a>00149   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEBase.php#a2e8aa83ccd81231f77faa31f9009f414">reinit</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00150"></a>00150                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> side,
<a name="l00151"></a>00151                        <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tolerance = TOLERANCE) = 0;
<a name="l00152"></a>00152   
<a name="l00158"></a>00158   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEBase.php#a568bbf420646419bdcc4853a1d97001c">edge_reinit</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00159"></a>00159                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> edge,
<a name="l00160"></a>00160                             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tolerance = TOLERANCE) = 0;
<a name="l00161"></a>00161   
<a name="l00169"></a>00169   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classFEBase.php#a99a3ce033c4c09b32be9aec4d4a0f88b">on_reference_element</a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00170"></a>00170                                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00171"></a>00171                                    <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> eps = TOLERANCE);
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00174"></a>00174 <span class="preprocessor"></span>
<a name="l00181"></a>00181   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classFEBase.php#a645ae6b88285e05b45e70cc3b9911d58">compute_proj_constraints</a> (<a class="code" href="classDofConstraints.php">DofConstraints</a> &amp;constraints,
<a name="l00182"></a>00182                                         <a class="code" href="classDofMap.php">DofMap</a> &amp;dof_map,
<a name="l00183"></a>00183                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> variable_number,
<a name="l00184"></a>00184                                         <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem);
<a name="l00185"></a>00185 
<a name="l00191"></a>00191   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classFEBase.php#aa40da3a01b0a89422bd2477fb4baf149">coarsened_dof_values</a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp;global_vector,
<a name="l00192"></a>00192                                    <span class="keyword">const</span> <a class="code" href="classDofMap.php">DofMap</a> &amp;dof_map,
<a name="l00193"></a>00193                                    <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *coarse_elem,
<a name="l00194"></a>00194                                    <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a> &amp;coarse_dofs,
<a name="l00195"></a>00195                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00196"></a>00196                                    <span class="keyword">const</span> <span class="keywordtype">bool</span> use_old_dof_indices = <span class="keyword">false</span>);
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00199"></a>00199 <span class="preprocessor"></span>
<a name="l00200"></a>00200 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00201"></a>00201 <span class="preprocessor"></span>
<a name="l00207"></a>00207   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classFEBase.php#a0bfeac90d7ee4e67e772f0ea53f582a8">compute_periodic_constraints</a> (<a class="code" href="classDofConstraints.php">DofConstraints</a> &amp;constraints,
<a name="l00208"></a>00208                                             <a class="code" href="classDofMap.php">DofMap</a> &amp;dof_map,
<a name="l00209"></a>00209                                             <a class="code" href="classPeriodicBoundaries.php">PeriodicBoundaries</a> &amp;boundaries,
<a name="l00210"></a>00210                                             <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00211"></a>00211                                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> variable_number,
<a name="l00212"></a>00212                                             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem);
<a name="l00213"></a>00213 
<a name="l00214"></a>00214 <span class="preprocessor">#endif // LIBMESH_ENABLE_PERIODIC</span>
<a name="l00215"></a>00215 <span class="preprocessor"></span>
<a name="l00220"></a><a class="code" href="classFEBase.php#a25ce71d550e75e00f29df0ae04c957cc">00220</a>   <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; <a class="code" href="classFEBase.php#a25ce71d550e75e00f29df0ae04c957cc">get_xyz</a>()<span class="keyword"> const</span>
<a name="l00221"></a>00221 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#aae6af9098e4135ab3783b1026f411c9b">xyz</a>; }
<a name="l00222"></a>00222   
<a name="l00227"></a><a class="code" href="classFEBase.php#a27e841f837a1517dd0bfe68b99515df7">00227</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classFEBase.php#a27e841f837a1517dd0bfe68b99515df7">get_phi</a>()<span class="keyword"> const</span>
<a name="l00228"></a>00228 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classFEBase.php#aa0bb301635ac12f83947eecb9f78a18e">calculations_started</a> || <a class="code" href="classFEBase.php#a83ab88e5795f48d8ed2aa17fb7a99d89">calculate_phi</a>);
<a name="l00229"></a>00229     <a class="code" href="classFEBase.php#a83ab88e5795f48d8ed2aa17fb7a99d89">calculate_phi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a39be4313b1f35d7ccde1640f5bd4230a">phi</a>; }
<a name="l00230"></a>00230   
<a name="l00235"></a><a class="code" href="classFEBase.php#adec8e65552df156ed36073da4709b8a5">00235</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classFEBase.php#adec8e65552df156ed36073da4709b8a5">get_JxW</a>()<span class="keyword"> const</span>
<a name="l00236"></a>00236 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#ab12c8cff995327a80e2ec6a76104bb3c">JxW</a>; }
<a name="l00237"></a>00237 
<a name="l00242"></a><a class="code" href="classFEBase.php#a11642793fbc6a37ea9b912ce92c7d1be">00242</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt;&amp; <a class="code" href="classFEBase.php#a11642793fbc6a37ea9b912ce92c7d1be">get_dphi</a>()<span class="keyword"> const</span>
<a name="l00243"></a>00243 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classFEBase.php#aa0bb301635ac12f83947eecb9f78a18e">calculations_started</a> || <a class="code" href="classFEBase.php#a91cd3546db2af19804f6ce4e9d4b6bb1">calculate_dphi</a>); 
<a name="l00244"></a>00244     <a class="code" href="classFEBase.php#a91cd3546db2af19804f6ce4e9d4b6bb1">calculate_dphi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#ad9ed2092822a243ac65c3bde46e180b6">dphi</a>; }
<a name="l00245"></a>00245   
<a name="l00250"></a><a class="code" href="classFEBase.php#ac46d018872cf4bc4b535f88c5d8c544f">00250</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classFEBase.php#ac46d018872cf4bc4b535f88c5d8c544f">get_dphidx</a>()<span class="keyword"> const</span>
<a name="l00251"></a>00251 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classFEBase.php#aa0bb301635ac12f83947eecb9f78a18e">calculations_started</a> || <a class="code" href="classFEBase.php#a91cd3546db2af19804f6ce4e9d4b6bb1">calculate_dphi</a>); 
<a name="l00252"></a>00252     <a class="code" href="classFEBase.php#a91cd3546db2af19804f6ce4e9d4b6bb1">calculate_dphi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#afbd50846403bc98387bdabbaa00a116a">dphidx</a>; }
<a name="l00253"></a>00253   
<a name="l00258"></a><a class="code" href="classFEBase.php#aa21e9f46872b6cc363e296d59b3b51cb">00258</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classFEBase.php#aa21e9f46872b6cc363e296d59b3b51cb">get_dphidy</a>()<span class="keyword"> const</span>
<a name="l00259"></a>00259 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classFEBase.php#aa0bb301635ac12f83947eecb9f78a18e">calculations_started</a> || <a class="code" href="classFEBase.php#a91cd3546db2af19804f6ce4e9d4b6bb1">calculate_dphi</a>); 
<a name="l00260"></a>00260     <a class="code" href="classFEBase.php#a91cd3546db2af19804f6ce4e9d4b6bb1">calculate_dphi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a949e14a05dea791141d5fc5444cf4be3">dphidy</a>; }
<a name="l00261"></a>00261   
<a name="l00266"></a><a class="code" href="classFEBase.php#afa37b574c00c96d36d3e53c96340c427">00266</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classFEBase.php#afa37b574c00c96d36d3e53c96340c427">get_dphidz</a>()<span class="keyword"> const</span>
<a name="l00267"></a>00267 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classFEBase.php#aa0bb301635ac12f83947eecb9f78a18e">calculations_started</a> || <a class="code" href="classFEBase.php#a91cd3546db2af19804f6ce4e9d4b6bb1">calculate_dphi</a>);
<a name="l00268"></a>00268     <a class="code" href="classFEBase.php#a91cd3546db2af19804f6ce4e9d4b6bb1">calculate_dphi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#acc224afaebae870209a8e2ae22c40913">dphidz</a>; }
<a name="l00269"></a>00269 
<a name="l00274"></a><a class="code" href="classFEBase.php#a9f40b96f9f97dbe23ecd7191f611f690">00274</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classFEBase.php#a9f40b96f9f97dbe23ecd7191f611f690">get_dphidxi</a>()<span class="keyword"> const</span>
<a name="l00275"></a>00275 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classFEBase.php#aa0bb301635ac12f83947eecb9f78a18e">calculations_started</a> || <a class="code" href="classFEBase.php#a91cd3546db2af19804f6ce4e9d4b6bb1">calculate_dphi</a>); 
<a name="l00276"></a>00276     <a class="code" href="classFEBase.php#a91cd3546db2af19804f6ce4e9d4b6bb1">calculate_dphi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a5aa52453ee1f8114fb79f0f3713cbc7a">dphidxi</a>; }
<a name="l00277"></a>00277   
<a name="l00282"></a><a class="code" href="classFEBase.php#afb58c4a25ba6b529c75fd85ca9d6031f">00282</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classFEBase.php#afb58c4a25ba6b529c75fd85ca9d6031f">get_dphideta</a>()<span class="keyword"> const</span>
<a name="l00283"></a>00283 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classFEBase.php#aa0bb301635ac12f83947eecb9f78a18e">calculations_started</a> || <a class="code" href="classFEBase.php#a91cd3546db2af19804f6ce4e9d4b6bb1">calculate_dphi</a>); 
<a name="l00284"></a>00284     <a class="code" href="classFEBase.php#a91cd3546db2af19804f6ce4e9d4b6bb1">calculate_dphi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a10845a09f55fa38827cdcbcce94bf24e">dphideta</a>; }
<a name="l00285"></a>00285   
<a name="l00290"></a><a class="code" href="classFEBase.php#ac082d412c75d18b600d616f242726ce6">00290</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classFEBase.php#ac082d412c75d18b600d616f242726ce6">get_dphidzeta</a>()<span class="keyword"> const</span>
<a name="l00291"></a>00291 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classFEBase.php#aa0bb301635ac12f83947eecb9f78a18e">calculations_started</a> || <a class="code" href="classFEBase.php#a91cd3546db2af19804f6ce4e9d4b6bb1">calculate_dphi</a>);
<a name="l00292"></a>00292     <a class="code" href="classFEBase.php#a91cd3546db2af19804f6ce4e9d4b6bb1">calculate_dphi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a2af598df1c2593724b13e72a11e7f624">dphidzeta</a>; }
<a name="l00293"></a>00293 
<a name="l00294"></a>00294 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00295"></a>00295 <span class="preprocessor"></span>
<a name="l00300"></a><a class="code" href="classFEBase.php#ae80dd03eb2074ecf0d0e734a213cdb4e">00300</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealTensor&gt; &gt;&amp; <a class="code" href="classFEBase.php#ae80dd03eb2074ecf0d0e734a213cdb4e">get_d2phi</a>()<span class="keyword"> const</span>
<a name="l00301"></a>00301 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classFEBase.php#aa0bb301635ac12f83947eecb9f78a18e">calculations_started</a> || <a class="code" href="classFEBase.php#aed68f93044753a54349a25322fdd2401">calculate_d2phi</a>); 
<a name="l00302"></a>00302     <a class="code" href="classFEBase.php#aed68f93044753a54349a25322fdd2401">calculate_d2phi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#aabdbc268b498ca93de96b39023b18e70">d2phi</a>; }
<a name="l00303"></a>00303   
<a name="l00308"></a><a class="code" href="classFEBase.php#a010236e683bc02e66f2311734ee37d45">00308</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classFEBase.php#a010236e683bc02e66f2311734ee37d45">get_d2phidx2</a>()<span class="keyword"> const</span>
<a name="l00309"></a>00309 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classFEBase.php#aa0bb301635ac12f83947eecb9f78a18e">calculations_started</a> || <a class="code" href="classFEBase.php#aed68f93044753a54349a25322fdd2401">calculate_d2phi</a>);
<a name="l00310"></a>00310     <a class="code" href="classFEBase.php#aed68f93044753a54349a25322fdd2401">calculate_d2phi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#ace197aa99baaab90134e1f41e8d9977b">d2phidx2</a>; }
<a name="l00311"></a>00311   
<a name="l00316"></a><a class="code" href="classFEBase.php#a5787b7d12cb9794b2d8be55a2e8ea2b0">00316</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classFEBase.php#a5787b7d12cb9794b2d8be55a2e8ea2b0">get_d2phidxdy</a>()<span class="keyword"> const</span>
<a name="l00317"></a>00317 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classFEBase.php#aa0bb301635ac12f83947eecb9f78a18e">calculations_started</a> || <a class="code" href="classFEBase.php#aed68f93044753a54349a25322fdd2401">calculate_d2phi</a>);
<a name="l00318"></a>00318     <a class="code" href="classFEBase.php#aed68f93044753a54349a25322fdd2401">calculate_d2phi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a6867a400854592517857fe857245483f">d2phidxdy</a>; }
<a name="l00319"></a>00319   
<a name="l00324"></a><a class="code" href="classFEBase.php#aafc6985e66a076702719932235874dd2">00324</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classFEBase.php#aafc6985e66a076702719932235874dd2">get_d2phidxdz</a>()<span class="keyword"> const</span>
<a name="l00325"></a>00325 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classFEBase.php#aa0bb301635ac12f83947eecb9f78a18e">calculations_started</a> || <a class="code" href="classFEBase.php#aed68f93044753a54349a25322fdd2401">calculate_d2phi</a>);
<a name="l00326"></a>00326     <a class="code" href="classFEBase.php#aed68f93044753a54349a25322fdd2401">calculate_d2phi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#aa899cad586b2d5860b38cd62d46ddf7b">d2phidxdz</a>; }
<a name="l00327"></a>00327   
<a name="l00332"></a><a class="code" href="classFEBase.php#aa4373c2aeec685dc6e5f31bed34838c5">00332</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classFEBase.php#aa4373c2aeec685dc6e5f31bed34838c5">get_d2phidy2</a>()<span class="keyword"> const</span>
<a name="l00333"></a>00333 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classFEBase.php#aa0bb301635ac12f83947eecb9f78a18e">calculations_started</a> || <a class="code" href="classFEBase.php#aed68f93044753a54349a25322fdd2401">calculate_d2phi</a>);
<a name="l00334"></a>00334     <a class="code" href="classFEBase.php#aed68f93044753a54349a25322fdd2401">calculate_d2phi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a329da092e60a8c3fa0514e71caf45b98">d2phidy2</a>; }
<a name="l00335"></a>00335   
<a name="l00340"></a><a class="code" href="classFEBase.php#ab5973bfa49a15a81d25d5f373d4bf0f9">00340</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classFEBase.php#ab5973bfa49a15a81d25d5f373d4bf0f9">get_d2phidydz</a>()<span class="keyword"> const</span>
<a name="l00341"></a>00341 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classFEBase.php#aa0bb301635ac12f83947eecb9f78a18e">calculations_started</a> || <a class="code" href="classFEBase.php#aed68f93044753a54349a25322fdd2401">calculate_d2phi</a>);
<a name="l00342"></a>00342     <a class="code" href="classFEBase.php#aed68f93044753a54349a25322fdd2401">calculate_d2phi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a385b241ece37af4583a79d381e1e6f4b">d2phidydz</a>; }
<a name="l00343"></a>00343   
<a name="l00348"></a><a class="code" href="classFEBase.php#a1c7bc506141012a29d12b40e747395b2">00348</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classFEBase.php#a1c7bc506141012a29d12b40e747395b2">get_d2phidz2</a>()<span class="keyword"> const</span>
<a name="l00349"></a>00349 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classFEBase.php#aa0bb301635ac12f83947eecb9f78a18e">calculations_started</a> || <a class="code" href="classFEBase.php#aed68f93044753a54349a25322fdd2401">calculate_d2phi</a>);
<a name="l00350"></a>00350     <a class="code" href="classFEBase.php#aed68f93044753a54349a25322fdd2401">calculate_d2phi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a07533a3db23fa0849fad1986baa50007">d2phidz2</a>; }
<a name="l00351"></a>00351 
<a name="l00352"></a>00352 <span class="preprocessor">#endif</span>
<a name="l00353"></a>00353 <span class="preprocessor"></span>  
<a name="l00358"></a><a class="code" href="classFEBase.php#a1e368687132defe059fff6fc501807b1">00358</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classFEBase.php#a1e368687132defe059fff6fc501807b1">get_dxyzdxi</a>()<span class="keyword"> const</span>
<a name="l00359"></a>00359 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>; }
<a name="l00360"></a>00360 
<a name="l00365"></a><a class="code" href="classFEBase.php#a3dfa64e565de9a50a4d94ae3a9ceac5a">00365</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classFEBase.php#a3dfa64e565de9a50a4d94ae3a9ceac5a">get_dxyzdeta</a>()<span class="keyword"> const</span>
<a name="l00366"></a>00366 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a162874d9f938a7e284a38678d0b50ffd">dxyzdeta_map</a>; }
<a name="l00367"></a>00367 
<a name="l00372"></a><a class="code" href="classFEBase.php#ab903a76ec258e9ecbb14e9e1bd645ddb">00372</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classFEBase.php#ab903a76ec258e9ecbb14e9e1bd645ddb">get_dxyzdzeta</a>()<span class="keyword"> const</span>
<a name="l00373"></a>00373 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#ae26fbf33d235bc3dbd1f0296bce2b68c">dxyzdzeta_map</a>; }
<a name="l00374"></a>00374   
<a name="l00378"></a><a class="code" href="classFEBase.php#a3dd7beb4a776bcb3f7f1a89105d60459">00378</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classFEBase.php#a3dd7beb4a776bcb3f7f1a89105d60459">get_d2xyzdxi2</a>()<span class="keyword"> const</span>
<a name="l00379"></a>00379 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a7d557b2fffe299f44ae5ea512aafd23b">d2xyzdxi2_map</a>; }
<a name="l00380"></a>00380 
<a name="l00384"></a><a class="code" href="classFEBase.php#ad583f298913a78dac13cf492b50e80a4">00384</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classFEBase.php#ad583f298913a78dac13cf492b50e80a4">get_d2xyzdeta2</a>()<span class="keyword"> const</span>
<a name="l00385"></a>00385 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a7f82e4dcf3d6143d88900e5050965a29">d2xyzdeta2_map</a>; }
<a name="l00386"></a>00386 
<a name="l00387"></a>00387 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00388"></a>00388 <span class="preprocessor"></span>  
<a name="l00392"></a><a class="code" href="classFEBase.php#aad2a3f39516ac56e0323983e057aebb4">00392</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classFEBase.php#aad2a3f39516ac56e0323983e057aebb4">get_d2xyzdzeta2</a>()<span class="keyword"> const</span>
<a name="l00393"></a>00393 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a13bcf2892cddc25816551eb0bb77492f">d2xyzdzeta2_map</a>; }
<a name="l00394"></a>00394   
<a name="l00395"></a>00395 <span class="preprocessor">#endif</span>
<a name="l00396"></a>00396 <span class="preprocessor"></span>  
<a name="l00400"></a><a class="code" href="classFEBase.php#a3aabf6bf09792804baa07adc00e21d13">00400</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classFEBase.php#a3aabf6bf09792804baa07adc00e21d13">get_d2xyzdxideta</a>()<span class="keyword"> const</span>
<a name="l00401"></a>00401 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a671b095fdbf1ad3226f54e0ac904a0b7">d2xyzdxideta_map</a>; }
<a name="l00402"></a>00402 
<a name="l00403"></a>00403 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00404"></a>00404 <span class="preprocessor"></span>  
<a name="l00408"></a><a class="code" href="classFEBase.php#a68b95f2256ffb7b2cf5df47ec24e87f2">00408</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classFEBase.php#a68b95f2256ffb7b2cf5df47ec24e87f2">get_d2xyzdxidzeta</a>()<span class="keyword"> const</span>
<a name="l00409"></a>00409 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a8486dcbe86b74013af26595d5bffa40e">d2xyzdxidzeta_map</a>; }
<a name="l00410"></a>00410 
<a name="l00414"></a><a class="code" href="classFEBase.php#a97197e302bc831e213d9f7dcee5067a1">00414</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classFEBase.php#a97197e302bc831e213d9f7dcee5067a1">get_d2xyzdetadzeta</a>()<span class="keyword"> const</span>
<a name="l00415"></a>00415 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a9c0fb982bead7d5f2ea284c6022442fe">d2xyzdetadzeta_map</a>; }
<a name="l00416"></a>00416 
<a name="l00417"></a>00417 <span class="preprocessor">#endif</span>
<a name="l00418"></a>00418 <span class="preprocessor"></span>  
<a name="l00423"></a><a class="code" href="classFEBase.php#a92c4a1c241a3b1aea1109f91ba570176">00423</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classFEBase.php#a92c4a1c241a3b1aea1109f91ba570176">get_dxidx</a>()<span class="keyword"> const</span>
<a name="l00424"></a>00424 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a062ecb136bb1c415375b7ad82ad4465c">dxidx_map</a>; }
<a name="l00425"></a>00425 
<a name="l00430"></a><a class="code" href="classFEBase.php#a9f501f9a1869dd38779100ae93b43ba0">00430</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classFEBase.php#a9f501f9a1869dd38779100ae93b43ba0">get_dxidy</a>()<span class="keyword"> const</span>
<a name="l00431"></a>00431 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#ae3060c82e7ae09e22cbc065e9d1f0b35">dxidy_map</a>; }
<a name="l00432"></a>00432 
<a name="l00437"></a><a class="code" href="classFEBase.php#a302bf2be2574094aae7dfe8e728a099b">00437</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classFEBase.php#a302bf2be2574094aae7dfe8e728a099b">get_dxidz</a>()<span class="keyword"> const</span>
<a name="l00438"></a>00438 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#ae6c0e8791380102f4127768c3027e090">dxidz_map</a>; }
<a name="l00439"></a>00439 
<a name="l00444"></a><a class="code" href="classFEBase.php#a948d59ecdc32d64b03d054156aa8f31b">00444</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classFEBase.php#a948d59ecdc32d64b03d054156aa8f31b">get_detadx</a>()<span class="keyword"> const</span>
<a name="l00445"></a>00445 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a8b709cadd6e13dc8805880453d8afb9a">detadx_map</a>; }
<a name="l00446"></a>00446 
<a name="l00451"></a><a class="code" href="classFEBase.php#a706fef9513443cd5f36ab338f77a7174">00451</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classFEBase.php#a706fef9513443cd5f36ab338f77a7174">get_detady</a>()<span class="keyword"> const</span>
<a name="l00452"></a>00452 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a25ef26a33f783b541653b60181510db9">detady_map</a>; }
<a name="l00453"></a>00453 
<a name="l00458"></a><a class="code" href="classFEBase.php#aead3f0e1cc178f70119c2c745a717094">00458</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classFEBase.php#aead3f0e1cc178f70119c2c745a717094">get_detadz</a>()<span class="keyword"> const</span>
<a name="l00459"></a>00459 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a9ac7c0080f39846c231f98c8c8263612">detadz_map</a>; }
<a name="l00460"></a>00460 
<a name="l00465"></a><a class="code" href="classFEBase.php#a8a856db7297b2291f571e7426151262c">00465</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classFEBase.php#a8a856db7297b2291f571e7426151262c">get_dzetadx</a>()<span class="keyword"> const</span>
<a name="l00466"></a>00466 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#ad3c6481bd2b291c172069a7ef5c887ee">dzetadx_map</a>; }
<a name="l00467"></a>00467 
<a name="l00472"></a><a class="code" href="classFEBase.php#a7b7b0a9b2898ba4de94fd3fdaf04c66b">00472</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classFEBase.php#a7b7b0a9b2898ba4de94fd3fdaf04c66b">get_dzetady</a>()<span class="keyword"> const</span>
<a name="l00473"></a>00473 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a23af33176121780df77e771f7cf8e585">dzetady_map</a>; }
<a name="l00474"></a>00474 
<a name="l00479"></a><a class="code" href="classFEBase.php#a4f5bf2cb60ca15efa5230e4dbe51f03d">00479</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classFEBase.php#a4f5bf2cb60ca15efa5230e4dbe51f03d">get_dzetadz</a>()<span class="keyword"> const</span>
<a name="l00480"></a>00480 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a146a0296a6967d0099db163637178b77">dzetadz_map</a>; }
<a name="l00481"></a>00481   
<a name="l00482"></a>00482 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00483"></a>00483 <span class="preprocessor"></span>
<a name="l00494"></a><a class="code" href="classFEBase.php#a8615ee082b59df52ee7094a04a60a304">00494</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classFEBase.php#a8615ee082b59df52ee7094a04a60a304">get_dphase</a>()<span class="keyword"> const</span>
<a name="l00495"></a>00495 <span class="keyword">      </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#af589c437d15ef6a2a7978babec629d91">dphase</a>; }
<a name="l00496"></a>00496 
<a name="l00497"></a>00497 
<a name="l00510"></a><a class="code" href="classFEBase.php#a2b54c61da759220301fb8366efdbade9">00510</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classFEBase.php#a2b54c61da759220301fb8366efdbade9">get_Sobolev_weight</a>()<span class="keyword"> const</span>
<a name="l00511"></a>00511 <span class="keyword">      </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a5e25c4a2a8f89d70b52f0ff0220033af">weight</a>; }
<a name="l00512"></a>00512 
<a name="l00518"></a><a class="code" href="classFEBase.php#a759c0e7e49f201612fed700e55ee3871">00518</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classFEBase.php#a759c0e7e49f201612fed700e55ee3871">get_Sobolev_dweight</a>()<span class="keyword"> const</span>
<a name="l00519"></a>00519 <span class="keyword">      </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#af927c12eeea1b6f535b14b4122d4fb66">dweight</a>; }
<a name="l00520"></a>00520 
<a name="l00521"></a>00521 <span class="preprocessor">#endif</span>
<a name="l00522"></a>00522 <span class="preprocessor"></span>
<a name="l00523"></a>00523   
<a name="l00527"></a><a class="code" href="classFEBase.php#a9b43dd4314dc25f9e158a82e6e8263a0">00527</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Point&gt; &gt;&amp; <a class="code" href="classFEBase.php#a9b43dd4314dc25f9e158a82e6e8263a0">get_tangents</a>()<span class="keyword"> const</span>
<a name="l00528"></a>00528 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a26d01a4ea4a5825a579dbe7dbbda3c45">tangents</a>; }
<a name="l00529"></a>00529   
<a name="l00533"></a><a class="code" href="classFEBase.php#a028716281aa67ec86a3a1bc919cace14">00533</a>   <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; <a class="code" href="classFEBase.php#a028716281aa67ec86a3a1bc919cace14">get_normals</a>()<span class="keyword"> const</span>
<a name="l00534"></a>00534 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a3b1435ecd16c024da965fe28f5ae15b8">normals</a>; }
<a name="l00535"></a>00535 
<a name="l00539"></a><a class="code" href="classFEBase.php#a2c07fd13f920e321e82fc38db44a9bba">00539</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classFEBase.php#a2c07fd13f920e321e82fc38db44a9bba">get_curvatures</a>()<span class="keyword"> const</span>
<a name="l00540"></a>00540 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a4bbc232fa21530fc3ec3270ed03edf0a">curvatures</a>;}
<a name="l00541"></a>00541   
<a name="l00546"></a>00546   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEBase.php#a2c898e2dbc89b6d3d3d1d78fa99c62ac">attach_quadrature_rule</a> (<a class="code" href="classQBase.php">QBase</a>* q) = 0;
<a name="l00547"></a>00547 
<a name="l00553"></a>00553   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFEBase.php#ab0fc9b9946d101b5a51b103a2030103f">n_shape_functions</a> () <span class="keyword">const</span> = 0;
<a name="l00554"></a>00554 
<a name="l00559"></a>00559   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFEBase.php#af88ea568a8b9de0701f0a43813a942db">n_quadrature_points</a> () <span class="keyword">const</span> = 0;
<a name="l00560"></a>00560   
<a name="l00566"></a><a class="code" href="classFEBase.php#af5bbe1e9202c17390ec2b4c545c9ee09">00566</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classFEBase.php#af5bbe1e9202c17390ec2b4c545c9ee09">get_type</a>()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a34c06d973e594fffd1f3307fc34a1f22">elem_type</a>; }
<a name="l00567"></a>00567 
<a name="l00572"></a><a class="code" href="classFEBase.php#a6445c643b26e4b70f915eadef04252f8">00572</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFEBase.php#a6445c643b26e4b70f915eadef04252f8">get_p_level</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a6d1bedff3a8331c2e87ee1daee7ef66b">_p_level</a>; }
<a name="l00573"></a>00573 
<a name="l00577"></a><a class="code" href="classFEBase.php#ac767ea8379d802ccd7c40990410ee58f">00577</a>   <a class="code" href="classFEType.php">FEType</a> <a class="code" href="classFEBase.php#ac767ea8379d802ccd7c40990410ee58f">get_fe_type</a>()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a129d0b4c88b2bb5a24326a4c5dd7f670">fe_type</a>; }
<a name="l00578"></a>00578 
<a name="l00582"></a><a class="code" href="classFEBase.php#a0a2d83b0ba35f59ce4af1ae1c2386387">00582</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classFEBase.php#a0a2d83b0ba35f59ce4af1ae1c2386387">get_order</a>()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(<a class="code" href="classFEBase.php#a129d0b4c88b2bb5a24326a4c5dd7f670">fe_type</a>.<a class="code" href="classFEType.php#a72c29a6dbf3f2a84728111122cec4742">order</a> + <a class="code" href="classFEBase.php#a6d1bedff3a8331c2e87ee1daee7ef66b">_p_level</a>); }
<a name="l00583"></a>00583 
<a name="l00587"></a>00587   <span class="keyword">virtual</span> <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14">FEContinuity</a> <a class="code" href="classFEBase.php#a4c255e85652f8bffa55ce5bbc0705b4b">get_continuity</a>() <span class="keyword">const</span> = 0;
<a name="l00588"></a>00588 
<a name="l00593"></a>00593   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classFEBase.php#accd970179596070b5bd92bd4311d9b9f">is_hierarchic</a>() <span class="keyword">const</span> = 0;
<a name="l00594"></a>00594 
<a name="l00598"></a><a class="code" href="classFEBase.php#a60cd465a8a990adaff8e36f4f4d88a45">00598</a>   <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5">FEFamily</a> <a class="code" href="classFEBase.php#a60cd465a8a990adaff8e36f4f4d88a45">get_family</a>()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a129d0b4c88b2bb5a24326a4c5dd7f670">fe_type</a>.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>; }
<a name="l00599"></a>00599 
<a name="l00603"></a>00603   <span class="keywordtype">void</span> <a class="code" href="classFEBase.php#aa008c784b8288dac74ed2c4ab2fa5e8b">print_JxW</a>(std::ostream&amp; os) <span class="keyword">const</span>; 
<a name="l00604"></a>00604   
<a name="l00608"></a>00608   <span class="keywordtype">void</span> <a class="code" href="classFEBase.php#a39991a0c814dde2b8e0542c1751996f6">print_phi</a>(std::ostream&amp; os) <span class="keyword">const</span>; 
<a name="l00609"></a>00609   
<a name="l00614"></a>00614   <span class="keywordtype">void</span> <a class="code" href="classFEBase.php#a0cc3708a9cb80b0a74140cda27abfe57">print_dphi</a>(std::ostream&amp; os) <span class="keyword">const</span>;
<a name="l00615"></a>00615 
<a name="l00616"></a>00616 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00617"></a>00617 <span class="preprocessor"></span>
<a name="l00622"></a>00622   <span class="keywordtype">void</span> <a class="code" href="classFEBase.php#a40e527c1e2356beff9eb78bcb01b9ee8">print_d2phi</a>(std::ostream&amp; os) <span class="keyword">const</span>;
<a name="l00623"></a>00623 
<a name="l00624"></a>00624 <span class="preprocessor">#endif</span>
<a name="l00625"></a>00625 <span class="preprocessor"></span>  
<a name="l00630"></a>00630   <span class="keywordtype">void</span> <a class="code" href="classFEBase.php#ad1c3b03bff66a78af455e1a6e7c1556f">print_xyz</a>(std::ostream&amp; os) <span class="keyword">const</span>;
<a name="l00631"></a>00631 
<a name="l00635"></a>00635   <span class="keywordtype">void</span> <a class="code" href="classReferenceCounter.php#a96bf10fbce55bcc34c3ab0e469238ee1">print_info</a>(std::ostream&amp; os) <span class="keyword">const</span>;
<a name="l00636"></a>00636 
<a name="l00640"></a>00640   <span class="keyword">friend</span> std::ostream&amp; <a class="code" href="classFEBase.php#af707d8f04488db8220405623626a146a">operator &lt;&lt; </a>(std::ostream&amp; os, <span class="keyword">const</span> <a class="code" href="classFEBase.php">FEBase</a>&amp; fe);
<a name="l00641"></a>00641   
<a name="l00642"></a>00642   
<a name="l00643"></a>00643 <span class="keyword">protected</span>:
<a name="l00644"></a>00644 
<a name="l00645"></a>00645 
<a name="l00646"></a>00646     
<a name="l00647"></a>00647 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00648"></a>00648 <span class="preprocessor"></span>
<a name="l00654"></a>00654   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEBase.php#ac9d97db41aea114c4dbd24116d461ee3">init_base_shape_functions</a>(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qp,
<a name="l00655"></a>00655                                          <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* e) = 0;
<a name="l00656"></a>00656 
<a name="l00657"></a>00657 <span class="preprocessor">#endif</span>
<a name="l00658"></a>00658 <span class="preprocessor"></span>
<a name="l00664"></a>00664   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEBase.php#a50042776fc52e2d95916c2576f6d0e9c">compute_map</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; qw,
<a name="l00665"></a>00665                    <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* e);
<a name="l00666"></a>00666   
<a name="l00673"></a>00673   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEBase.php#abfe8e22dc229c0e559a06047ef850344">compute_affine_map</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; qw,
<a name="l00674"></a>00674                    <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* e);
<a name="l00675"></a>00675 
<a name="l00680"></a>00680   <span class="keywordtype">void</span> <a class="code" href="classFEBase.php#afa92bdfeead15c94256de5317f9fc44f">compute_single_point_map</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; qw,
<a name="l00681"></a>00681                                 <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* e,
<a name="l00682"></a>00682                                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p);
<a name="l00683"></a>00683   
<a name="l00687"></a>00687   <span class="keywordtype">void</span> <a class="code" href="classFEBase.php#ad91cfd71beb9be8a9add45ecd683bdfb">resize_map_vectors</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp);
<a name="l00688"></a>00688 
<a name="l00692"></a>00692   <span class="keywordtype">void</span> <a class="code" href="classFEBase.php#af47ed992fc087681ed2e0b3587657dad">compute_face_map</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; qw,
<a name="l00693"></a>00693                         <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* side);
<a name="l00694"></a>00694 
<a name="l00698"></a>00698   <span class="keywordtype">void</span> <a class="code" href="classFEBase.php#aaf150f783d70df060b2b218a9c84e122">compute_edge_map</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; qw,
<a name="l00699"></a>00699                         <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* side);
<a name="l00700"></a>00700 
<a name="l00711"></a>00711   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEBase.php#a0154249dd5ab1eddbd31da125d9f768f">compute_shape_functions</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*);
<a name="l00712"></a>00712   
<a name="l00713"></a>00713 
<a name="l00719"></a><a class="code" href="classFEBase.php#a939316ee014ca629dc6fd45fce5df914">00719</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFEBase.php#a939316ee014ca629dc6fd45fce5df914">dxdxi_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const   </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>[p](0); }
<a name="l00720"></a>00720 
<a name="l00726"></a><a class="code" href="classFEBase.php#af83d77ab1b58b72554d95cff1a048ee9">00726</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFEBase.php#af83d77ab1b58b72554d95cff1a048ee9">dydxi_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const   </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>[p](1); }
<a name="l00727"></a>00727 
<a name="l00733"></a><a class="code" href="classFEBase.php#a7747378042b2cf03c490b39d46e1f2c6">00733</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFEBase.php#a7747378042b2cf03c490b39d46e1f2c6">dzdxi_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const   </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>[p](2); }
<a name="l00734"></a>00734 
<a name="l00740"></a><a class="code" href="classFEBase.php#a43db73aa5e7f73c6a62ad4bc40535972">00740</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFEBase.php#a43db73aa5e7f73c6a62ad4bc40535972">dxdeta_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a162874d9f938a7e284a38678d0b50ffd">dxyzdeta_map</a>[p](0); }
<a name="l00741"></a>00741 
<a name="l00747"></a><a class="code" href="classFEBase.php#a17789aaeb8fedae09f9ba0119000225f">00747</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFEBase.php#a17789aaeb8fedae09f9ba0119000225f">dydeta_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a162874d9f938a7e284a38678d0b50ffd">dxyzdeta_map</a>[p](1); } 
<a name="l00748"></a>00748 
<a name="l00754"></a><a class="code" href="classFEBase.php#af4518d3bbcbe64f8052747c0f5999876">00754</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFEBase.php#af4518d3bbcbe64f8052747c0f5999876">dzdeta_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const  </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#a162874d9f938a7e284a38678d0b50ffd">dxyzdeta_map</a>[p](2); }
<a name="l00755"></a>00755 
<a name="l00761"></a><a class="code" href="classFEBase.php#a4e06714acdf80c7bde3cace5da31153a">00761</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFEBase.php#a4e06714acdf80c7bde3cace5da31153a">dxdzeta_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#ae26fbf33d235bc3dbd1f0296bce2b68c">dxyzdzeta_map</a>[p](0); }
<a name="l00762"></a>00762 
<a name="l00768"></a><a class="code" href="classFEBase.php#a5299ff41e9a1afee3604cefcf1f3023c">00768</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFEBase.php#a5299ff41e9a1afee3604cefcf1f3023c">dydzeta_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#ae26fbf33d235bc3dbd1f0296bce2b68c">dxyzdzeta_map</a>[p](1); }
<a name="l00769"></a>00769 
<a name="l00775"></a><a class="code" href="classFEBase.php#a3136af93d3e2f0575452193192e2c35e">00775</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFEBase.php#a3136af93d3e2f0575452193192e2c35e">dzdzeta_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classFEBase.php#ae26fbf33d235bc3dbd1f0296bce2b68c">dxyzdzeta_map</a>[p](2); }
<a name="l00776"></a>00776 
<a name="l00777"></a>00777 
<a name="l00778"></a>00778 
<a name="l00779"></a>00779 
<a name="l00780"></a>00780   
<a name="l00784"></a><a class="code" href="classFEBase.php#a883023d0114b38abb42d38479459738e">00784</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFEBase.php#a883023d0114b38abb42d38479459738e">dim</a>;
<a name="l00785"></a>00785 
<a name="l00789"></a><a class="code" href="classFEBase.php#aae6af9098e4135ab3783b1026f411c9b">00789</a>   std::vector&lt;Point&gt; <a class="code" href="classFEBase.php#aae6af9098e4135ab3783b1026f411c9b">xyz</a>;
<a name="l00790"></a>00790 
<a name="l00791"></a>00791 
<a name="l00792"></a>00792   
<a name="l00797"></a><a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">00797</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>;
<a name="l00798"></a>00798 
<a name="l00803"></a><a class="code" href="classFEBase.php#a162874d9f938a7e284a38678d0b50ffd">00803</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classFEBase.php#a162874d9f938a7e284a38678d0b50ffd">dxyzdeta_map</a>;
<a name="l00804"></a>00804 
<a name="l00809"></a><a class="code" href="classFEBase.php#ae26fbf33d235bc3dbd1f0296bce2b68c">00809</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classFEBase.php#ae26fbf33d235bc3dbd1f0296bce2b68c">dxyzdzeta_map</a>;
<a name="l00810"></a>00810   
<a name="l00815"></a><a class="code" href="classFEBase.php#a7d557b2fffe299f44ae5ea512aafd23b">00815</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classFEBase.php#a7d557b2fffe299f44ae5ea512aafd23b">d2xyzdxi2_map</a>;
<a name="l00816"></a>00816 
<a name="l00821"></a><a class="code" href="classFEBase.php#a671b095fdbf1ad3226f54e0ac904a0b7">00821</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classFEBase.php#a671b095fdbf1ad3226f54e0ac904a0b7">d2xyzdxideta_map</a>;
<a name="l00822"></a>00822 
<a name="l00827"></a><a class="code" href="classFEBase.php#a7f82e4dcf3d6143d88900e5050965a29">00827</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classFEBase.php#a7f82e4dcf3d6143d88900e5050965a29">d2xyzdeta2_map</a>;
<a name="l00828"></a>00828 
<a name="l00829"></a>00829 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00830"></a>00830 <span class="preprocessor"></span>
<a name="l00835"></a><a class="code" href="classFEBase.php#a8486dcbe86b74013af26595d5bffa40e">00835</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classFEBase.php#a8486dcbe86b74013af26595d5bffa40e">d2xyzdxidzeta_map</a>;
<a name="l00836"></a>00836 
<a name="l00841"></a><a class="code" href="classFEBase.php#a9c0fb982bead7d5f2ea284c6022442fe">00841</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classFEBase.php#a9c0fb982bead7d5f2ea284c6022442fe">d2xyzdetadzeta_map</a>;
<a name="l00842"></a>00842 
<a name="l00847"></a><a class="code" href="classFEBase.php#a13bcf2892cddc25816551eb0bb77492f">00847</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classFEBase.php#a13bcf2892cddc25816551eb0bb77492f">d2xyzdzeta2_map</a>;
<a name="l00848"></a>00848 
<a name="l00849"></a>00849 <span class="preprocessor">#endif</span>
<a name="l00850"></a>00850 <span class="preprocessor"></span>  
<a name="l00855"></a><a class="code" href="classFEBase.php#a062ecb136bb1c415375b7ad82ad4465c">00855</a>   std::vector&lt;Real&gt;  <a class="code" href="classFEBase.php#a062ecb136bb1c415375b7ad82ad4465c">dxidx_map</a>;
<a name="l00856"></a>00856 
<a name="l00861"></a><a class="code" href="classFEBase.php#ae3060c82e7ae09e22cbc065e9d1f0b35">00861</a>   std::vector&lt;Real&gt;  <a class="code" href="classFEBase.php#ae3060c82e7ae09e22cbc065e9d1f0b35">dxidy_map</a>;
<a name="l00862"></a>00862 
<a name="l00867"></a><a class="code" href="classFEBase.php#ae6c0e8791380102f4127768c3027e090">00867</a>   std::vector&lt;Real&gt;  <a class="code" href="classFEBase.php#ae6c0e8791380102f4127768c3027e090">dxidz_map</a>;
<a name="l00868"></a>00868 
<a name="l00869"></a>00869 
<a name="l00870"></a>00870 
<a name="l00871"></a>00871   
<a name="l00876"></a><a class="code" href="classFEBase.php#a8b709cadd6e13dc8805880453d8afb9a">00876</a>   std::vector&lt;Real&gt;  <a class="code" href="classFEBase.php#a8b709cadd6e13dc8805880453d8afb9a">detadx_map</a>;
<a name="l00877"></a>00877 
<a name="l00882"></a><a class="code" href="classFEBase.php#a25ef26a33f783b541653b60181510db9">00882</a>   std::vector&lt;Real&gt;  <a class="code" href="classFEBase.php#a25ef26a33f783b541653b60181510db9">detady_map</a>;
<a name="l00883"></a>00883 
<a name="l00888"></a><a class="code" href="classFEBase.php#a9ac7c0080f39846c231f98c8c8263612">00888</a>   std::vector&lt;Real&gt;  <a class="code" href="classFEBase.php#a9ac7c0080f39846c231f98c8c8263612">detadz_map</a>;
<a name="l00889"></a>00889 
<a name="l00890"></a>00890 
<a name="l00891"></a>00891 
<a name="l00892"></a>00892 
<a name="l00893"></a>00893   
<a name="l00898"></a><a class="code" href="classFEBase.php#ad3c6481bd2b291c172069a7ef5c887ee">00898</a>   std::vector&lt;Real&gt;  <a class="code" href="classFEBase.php#ad3c6481bd2b291c172069a7ef5c887ee">dzetadx_map</a>;
<a name="l00899"></a>00899 
<a name="l00904"></a><a class="code" href="classFEBase.php#a23af33176121780df77e771f7cf8e585">00904</a>   std::vector&lt;Real&gt;  <a class="code" href="classFEBase.php#a23af33176121780df77e771f7cf8e585">dzetady_map</a>;
<a name="l00905"></a>00905 
<a name="l00910"></a><a class="code" href="classFEBase.php#a146a0296a6967d0099db163637178b77">00910</a>   std::vector&lt;Real&gt;  <a class="code" href="classFEBase.php#a146a0296a6967d0099db163637178b77">dzetadz_map</a>;
<a name="l00911"></a>00911 
<a name="l00915"></a><a class="code" href="classFEBase.php#a39be4313b1f35d7ccde1640f5bd4230a">00915</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#a39be4313b1f35d7ccde1640f5bd4230a">phi</a>;
<a name="l00916"></a>00916 
<a name="l00921"></a><a class="code" href="classFEBase.php#aa0bb301635ac12f83947eecb9f78a18e">00921</a>   <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classFEBase.php#aa0bb301635ac12f83947eecb9f78a18e">calculations_started</a>;
<a name="l00922"></a>00922 
<a name="l00926"></a><a class="code" href="classFEBase.php#a83ab88e5795f48d8ed2aa17fb7a99d89">00926</a>   <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classFEBase.php#a83ab88e5795f48d8ed2aa17fb7a99d89">calculate_phi</a>;
<a name="l00927"></a>00927 
<a name="l00931"></a><a class="code" href="classFEBase.php#a91cd3546db2af19804f6ce4e9d4b6bb1">00931</a>   <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classFEBase.php#a91cd3546db2af19804f6ce4e9d4b6bb1">calculate_dphi</a>;
<a name="l00932"></a>00932 
<a name="l00936"></a><a class="code" href="classFEBase.php#aed68f93044753a54349a25322fdd2401">00936</a>   <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classFEBase.php#aed68f93044753a54349a25322fdd2401">calculate_d2phi</a>;
<a name="l00937"></a>00937 
<a name="l00941"></a><a class="code" href="classFEBase.php#ad9ed2092822a243ac65c3bde46e180b6">00941</a>   std::vector&lt;std::vector&lt;RealGradient&gt; &gt;  <a class="code" href="classFEBase.php#ad9ed2092822a243ac65c3bde46e180b6">dphi</a>;
<a name="l00942"></a>00942 
<a name="l00946"></a><a class="code" href="classFEBase.php#a5aa52453ee1f8114fb79f0f3713cbc7a">00946</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#a5aa52453ee1f8114fb79f0f3713cbc7a">dphidxi</a>;
<a name="l00947"></a>00947 
<a name="l00951"></a><a class="code" href="classFEBase.php#a10845a09f55fa38827cdcbcce94bf24e">00951</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#a10845a09f55fa38827cdcbcce94bf24e">dphideta</a>;
<a name="l00952"></a>00952   
<a name="l00956"></a><a class="code" href="classFEBase.php#a2af598df1c2593724b13e72a11e7f624">00956</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#a2af598df1c2593724b13e72a11e7f624">dphidzeta</a>;
<a name="l00957"></a>00957 
<a name="l00961"></a><a class="code" href="classFEBase.php#afbd50846403bc98387bdabbaa00a116a">00961</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#afbd50846403bc98387bdabbaa00a116a">dphidx</a>;
<a name="l00962"></a>00962 
<a name="l00966"></a><a class="code" href="classFEBase.php#a949e14a05dea791141d5fc5444cf4be3">00966</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#a949e14a05dea791141d5fc5444cf4be3">dphidy</a>;
<a name="l00967"></a>00967 
<a name="l00971"></a><a class="code" href="classFEBase.php#acc224afaebae870209a8e2ae22c40913">00971</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#acc224afaebae870209a8e2ae22c40913">dphidz</a>;
<a name="l00972"></a>00972 
<a name="l00973"></a>00973 
<a name="l00974"></a>00974 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00975"></a>00975 <span class="preprocessor"></span>  
<a name="l00979"></a><a class="code" href="classFEBase.php#aabdbc268b498ca93de96b39023b18e70">00979</a>   std::vector&lt;std::vector&lt;RealTensor&gt; &gt;  <a class="code" href="classFEBase.php#aabdbc268b498ca93de96b39023b18e70">d2phi</a>;
<a name="l00980"></a>00980 
<a name="l00984"></a><a class="code" href="classFEBase.php#ac6e3744d8eea59d3c109838db8590e71">00984</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#ac6e3744d8eea59d3c109838db8590e71">d2phidxi2</a>;
<a name="l00985"></a>00985 
<a name="l00989"></a><a class="code" href="classFEBase.php#a57d205122b7057e557024f805f4a963d">00989</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#a57d205122b7057e557024f805f4a963d">d2phidxideta</a>;
<a name="l00990"></a>00990   
<a name="l00994"></a><a class="code" href="classFEBase.php#a74536e2f3e7ece368fb37f2e44876718">00994</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#a74536e2f3e7ece368fb37f2e44876718">d2phidxidzeta</a>;
<a name="l00995"></a>00995 
<a name="l00999"></a><a class="code" href="classFEBase.php#a6923d74e5539a77046bc9951bd6ebc99">00999</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#a6923d74e5539a77046bc9951bd6ebc99">d2phideta2</a>;
<a name="l01000"></a>01000 
<a name="l01004"></a><a class="code" href="classFEBase.php#af80f1d9cda94e79ddb33396876f7ad0a">01004</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#af80f1d9cda94e79ddb33396876f7ad0a">d2phidetadzeta</a>;
<a name="l01005"></a>01005   
<a name="l01009"></a><a class="code" href="classFEBase.php#adb1ac79f0629c6e3f6aa6b04a90aee9d">01009</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#adb1ac79f0629c6e3f6aa6b04a90aee9d">d2phidzeta2</a>;
<a name="l01010"></a>01010 
<a name="l01014"></a><a class="code" href="classFEBase.php#ace197aa99baaab90134e1f41e8d9977b">01014</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#ace197aa99baaab90134e1f41e8d9977b">d2phidx2</a>;
<a name="l01015"></a>01015 
<a name="l01019"></a><a class="code" href="classFEBase.php#a6867a400854592517857fe857245483f">01019</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#a6867a400854592517857fe857245483f">d2phidxdy</a>;
<a name="l01020"></a>01020 
<a name="l01024"></a><a class="code" href="classFEBase.php#aa899cad586b2d5860b38cd62d46ddf7b">01024</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#aa899cad586b2d5860b38cd62d46ddf7b">d2phidxdz</a>;
<a name="l01025"></a>01025 
<a name="l01029"></a><a class="code" href="classFEBase.php#a329da092e60a8c3fa0514e71caf45b98">01029</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#a329da092e60a8c3fa0514e71caf45b98">d2phidy2</a>;
<a name="l01030"></a>01030 
<a name="l01034"></a><a class="code" href="classFEBase.php#a385b241ece37af4583a79d381e1e6f4b">01034</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#a385b241ece37af4583a79d381e1e6f4b">d2phidydz</a>;
<a name="l01035"></a>01035 
<a name="l01039"></a><a class="code" href="classFEBase.php#a07533a3db23fa0849fad1986baa50007">01039</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#a07533a3db23fa0849fad1986baa50007">d2phidz2</a>;
<a name="l01040"></a>01040   
<a name="l01041"></a>01041 <span class="preprocessor">#endif</span>
<a name="l01042"></a>01042 <span class="preprocessor"></span>
<a name="l01043"></a>01043 
<a name="l01044"></a>01044 
<a name="l01045"></a>01045   
<a name="l01049"></a><a class="code" href="classFEBase.php#aa194d4b149629b11c9eb394aa9c721e6">01049</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#aa194d4b149629b11c9eb394aa9c721e6">phi_map</a>;
<a name="l01050"></a>01050 
<a name="l01054"></a><a class="code" href="classFEBase.php#aab4f649c5f9e3dcc22dcabf009087b4b">01054</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#aab4f649c5f9e3dcc22dcabf009087b4b">dphidxi_map</a>;
<a name="l01055"></a>01055 
<a name="l01059"></a><a class="code" href="classFEBase.php#a3d2ef8a8454a7bcfa2c2c68734e0527c">01059</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#a3d2ef8a8454a7bcfa2c2c68734e0527c">dphideta_map</a>;
<a name="l01060"></a>01060 
<a name="l01064"></a><a class="code" href="classFEBase.php#a78132bbf00b74f72984a425e2694ae1d">01064</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#a78132bbf00b74f72984a425e2694ae1d">dphidzeta_map</a>;
<a name="l01065"></a>01065 
<a name="l01066"></a>01066 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l01067"></a>01067 <span class="preprocessor"></span>
<a name="l01071"></a><a class="code" href="classFEBase.php#a92d7596b9f6762247f6cd19355dd035a">01071</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#a92d7596b9f6762247f6cd19355dd035a">d2phidxi2_map</a>;
<a name="l01072"></a>01072 
<a name="l01076"></a><a class="code" href="classFEBase.php#ad49d68329a8a4d455c2dbe5818cc2cdd">01076</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#ad49d68329a8a4d455c2dbe5818cc2cdd">d2phidxideta_map</a>;
<a name="l01077"></a>01077 
<a name="l01081"></a><a class="code" href="classFEBase.php#abb1b7a7639ffd04fff18422f34662835">01081</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#abb1b7a7639ffd04fff18422f34662835">d2phidxidzeta_map</a>;
<a name="l01082"></a>01082 
<a name="l01086"></a><a class="code" href="classFEBase.php#a0baaf7ce1874d48054d9d36ea53fa403">01086</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#a0baaf7ce1874d48054d9d36ea53fa403">d2phideta2_map</a>;
<a name="l01087"></a>01087 
<a name="l01091"></a><a class="code" href="classFEBase.php#a2b752ebbecd5827c0e30fdf3ac9c4ccc">01091</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#a2b752ebbecd5827c0e30fdf3ac9c4ccc">d2phidetadzeta_map</a>;
<a name="l01092"></a>01092 
<a name="l01096"></a><a class="code" href="classFEBase.php#a2820fd80337fe96623efae7eded3d0b9">01096</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#a2820fd80337fe96623efae7eded3d0b9">d2phidzeta2_map</a>;
<a name="l01097"></a>01097 
<a name="l01098"></a>01098 <span class="preprocessor">#endif</span>
<a name="l01099"></a>01099 <span class="preprocessor"></span>  
<a name="l01100"></a>01100 
<a name="l01101"></a>01101 
<a name="l01102"></a>01102 
<a name="l01103"></a>01103   
<a name="l01107"></a><a class="code" href="classFEBase.php#a4dd1648378169f9df7be04b8ccccf79b">01107</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#a4dd1648378169f9df7be04b8ccccf79b">psi_map</a>;
<a name="l01108"></a>01108 
<a name="l01113"></a><a class="code" href="classFEBase.php#ae81262808ef65f058ffde4107a083cb6">01113</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#ae81262808ef65f058ffde4107a083cb6">dpsidxi_map</a>;
<a name="l01114"></a>01114 
<a name="l01119"></a><a class="code" href="classFEBase.php#a02d881d240576a85a34ae52f53b51d14">01119</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classFEBase.php#a02d881d240576a85a34ae52f53b51d14">dpsideta_map</a>;
<a name="l01120"></a>01120 
<a name="l01126"></a><a class="code" href="classFEBase.php#aa86ebf823af5a31ff5ae1b6f79a62854">01126</a>   std::vector&lt;std::vector&lt;Real&gt; &gt; <a class="code" href="classFEBase.php#aa86ebf823af5a31ff5ae1b6f79a62854">d2psidxi2_map</a>;
<a name="l01127"></a>01127 
<a name="l01133"></a><a class="code" href="classFEBase.php#afaee9565e3e853061b9be24651949f7d">01133</a>   std::vector&lt;std::vector&lt;Real&gt; &gt; <a class="code" href="classFEBase.php#afaee9565e3e853061b9be24651949f7d">d2psidxideta_map</a>;
<a name="l01134"></a>01134 
<a name="l01140"></a><a class="code" href="classFEBase.php#ac25fcbc849c8a91ebf51dbced8d9f4aa">01140</a>   std::vector&lt;std::vector&lt;Real&gt; &gt; <a class="code" href="classFEBase.php#ac25fcbc849c8a91ebf51dbced8d9f4aa">d2psideta2_map</a>;
<a name="l01141"></a>01141 
<a name="l01142"></a>01142   
<a name="l01143"></a>01143 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l01144"></a>01144 <span class="preprocessor"></span>
<a name="l01145"></a>01145   <span class="comment">//--------------------------------------------------------------</span>
<a name="l01146"></a>01146   <span class="comment">/* protected members for infinite elements, which are accessed </span>
<a name="l01147"></a>01147 <span class="comment">   * from the outside through some inline functions</span>
<a name="l01148"></a>01148 <span class="comment">   */</span>
<a name="l01149"></a>01149 
<a name="l01150"></a>01150 
<a name="l01156"></a><a class="code" href="classFEBase.php#af589c437d15ef6a2a7978babec629d91">01156</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classFEBase.php#af589c437d15ef6a2a7978babec629d91">dphase</a>;
<a name="l01157"></a>01157 
<a name="l01163"></a><a class="code" href="classFEBase.php#af927c12eeea1b6f535b14b4122d4fb66">01163</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classFEBase.php#af927c12eeea1b6f535b14b4122d4fb66">dweight</a>;
<a name="l01164"></a>01164 
<a name="l01170"></a><a class="code" href="classFEBase.php#a5e25c4a2a8f89d70b52f0ff0220033af">01170</a>   std::vector&lt;Real&gt;  <a class="code" href="classFEBase.php#a5e25c4a2a8f89d70b52f0ff0220033af">weight</a>;
<a name="l01171"></a>01171 
<a name="l01172"></a>01172 <span class="preprocessor">#endif</span>
<a name="l01173"></a>01173 <span class="preprocessor"></span>
<a name="l01174"></a>01174 
<a name="l01175"></a>01175 
<a name="l01176"></a>01176   
<a name="l01180"></a><a class="code" href="classFEBase.php#a26d01a4ea4a5825a579dbe7dbbda3c45">01180</a>   std::vector&lt;std::vector&lt;Point&gt; &gt;  <a class="code" href="classFEBase.php#a26d01a4ea4a5825a579dbe7dbbda3c45">tangents</a>;
<a name="l01181"></a>01181 
<a name="l01185"></a><a class="code" href="classFEBase.php#a3b1435ecd16c024da965fe28f5ae15b8">01185</a>   std::vector&lt;Point&gt;                <a class="code" href="classFEBase.php#a3b1435ecd16c024da965fe28f5ae15b8">normals</a>;
<a name="l01186"></a>01186 
<a name="l01192"></a><a class="code" href="classFEBase.php#a4bbc232fa21530fc3ec3270ed03edf0a">01192</a>   std::vector&lt;Real&gt;                 <a class="code" href="classFEBase.php#a4bbc232fa21530fc3ec3270ed03edf0a">curvatures</a>;
<a name="l01193"></a>01193   
<a name="l01197"></a><a class="code" href="classFEBase.php#ab12c8cff995327a80e2ec6a76104bb3c">01197</a>   std::vector&lt;Real&gt;                 <a class="code" href="classFEBase.php#ab12c8cff995327a80e2ec6a76104bb3c">JxW</a>;
<a name="l01198"></a>01198 
<a name="l01203"></a><a class="code" href="classFEBase.php#a129d0b4c88b2bb5a24326a4c5dd7f670">01203</a>   <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a> <a class="code" href="classFEBase.php#a129d0b4c88b2bb5a24326a4c5dd7f670">fe_type</a>;
<a name="l01204"></a>01204   
<a name="l01209"></a><a class="code" href="classFEBase.php#a34c06d973e594fffd1f3307fc34a1f22">01209</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classFEBase.php#a34c06d973e594fffd1f3307fc34a1f22">elem_type</a>;
<a name="l01210"></a>01210 
<a name="l01215"></a><a class="code" href="classFEBase.php#a6d1bedff3a8331c2e87ee1daee7ef66b">01215</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFEBase.php#a6d1bedff3a8331c2e87ee1daee7ef66b">_p_level</a>;
<a name="l01216"></a>01216 
<a name="l01220"></a><a class="code" href="classFEBase.php#af3ff470e7bacd59ef8cfde59255082ab">01220</a>   <a class="code" href="classQBase.php">QBase</a>* <a class="code" href="classFEBase.php#af3ff470e7bacd59ef8cfde59255082ab">qrule</a>;
<a name="l01221"></a>01221 
<a name="l01226"></a><a class="code" href="classFEBase.php#a331aa1a23d7c4a744f43affdbade45da">01226</a>   <span class="keywordtype">bool</span> <a class="code" href="classFEBase.php#a331aa1a23d7c4a744f43affdbade45da">shapes_on_quadrature</a>;
<a name="l01227"></a>01227 
<a name="l01228"></a>01228 
<a name="l01229"></a>01229 <span class="keyword">private</span>:
<a name="l01230"></a>01230 
<a name="l01237"></a>01237   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classFEBase.php#a17226678da167d596816fde6fc949176">shapes_need_reinit</a>() <span class="keyword">const</span> = 0;
<a name="l01238"></a>01238 
<a name="l01239"></a>01239 
<a name="l01240"></a>01240 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l01241"></a>01241 <span class="preprocessor"></span>
<a name="l01247"></a>01247   <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> friend_Dim, FEFamily friend_T_radial, InfMapType friend_T_map&gt;
<a name="l01248"></a><a class="code" href="classFEBase.php#a30966325e9cd5ef7b41e45148b6919ed">01248</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classInfFE.php">InfFE</a>;
<a name="l01249"></a>01249 
<a name="l01250"></a>01250 <span class="preprocessor">#endif</span>
<a name="l01251"></a>01251 <span class="preprocessor"></span>
<a name="l01252"></a>01252 
<a name="l01253"></a>01253 };
<a name="l01254"></a>01254 
<a name="l01255"></a>01255 
<a name="l01256"></a>01256 
<a name="l01257"></a>01257 
<a name="l01258"></a>01258 <span class="comment">// ------------------------------------------------------------</span>
<a name="l01259"></a>01259 <span class="comment">// FEBase class inline members</span>
<a name="l01260"></a>01260 <span class="keyword">inline</span>
<a name="l01261"></a><a class="code" href="classFEBase.php#accbdd6aea90ca887757f7fa930d1ac37">01261</a> <a class="code" href="classFEBase.php#accbdd6aea90ca887757f7fa930d1ac37">FEBase::FEBase</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d,
<a name="l01262"></a>01262                <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet) :
<a name="l01263"></a>01263   <a class="code" href="classFEBase.php#a883023d0114b38abb42d38479459738e">dim</a>(d),
<a name="l01264"></a>01264   <a class="code" href="classFEBase.php#aa0bb301635ac12f83947eecb9f78a18e">calculations_started</a>(false),
<a name="l01265"></a>01265   <a class="code" href="classFEBase.php#a83ab88e5795f48d8ed2aa17fb7a99d89">calculate_phi</a>(false),
<a name="l01266"></a>01266   <a class="code" href="classFEBase.php#a91cd3546db2af19804f6ce4e9d4b6bb1">calculate_dphi</a>(false),
<a name="l01267"></a>01267   <a class="code" href="classFEBase.php#aed68f93044753a54349a25322fdd2401">calculate_d2phi</a>(false),
<a name="l01268"></a>01268   <a class="code" href="classFEBase.php#a129d0b4c88b2bb5a24326a4c5dd7f670">fe_type</a>(fet),
<a name="l01269"></a>01269   <a class="code" href="classFEBase.php#a34c06d973e594fffd1f3307fc34a1f22">elem_type</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>),
<a name="l01270"></a>01270   <a class="code" href="classFEBase.php#a6d1bedff3a8331c2e87ee1daee7ef66b">_p_level</a>(0),
<a name="l01271"></a>01271   <a class="code" href="classFEBase.php#af3ff470e7bacd59ef8cfde59255082ab">qrule</a>(NULL),
<a name="l01272"></a>01272   <a class="code" href="classFEBase.php#a331aa1a23d7c4a744f43affdbade45da">shapes_on_quadrature</a>(false)
<a name="l01273"></a>01273 {
<a name="l01274"></a>01274 }
<a name="l01275"></a>01275 
<a name="l01276"></a>01276 
<a name="l01277"></a>01277 
<a name="l01278"></a>01278 <span class="keyword">inline</span>
<a name="l01279"></a><a class="code" href="classFEBase.php#aee9233b9d3f48a3d7f9a80a7ff8ef26b">01279</a> <a class="code" href="classFEBase.php#aee9233b9d3f48a3d7f9a80a7ff8ef26b">FEBase::~FEBase</a>()
<a name="l01280"></a>01280 {
<a name="l01281"></a>01281 }
<a name="l01282"></a>01282 
<a name="l01283"></a>01283 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
