<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_a0136eca6b184c0d854bbc4a8414e31c.php">fe</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>fe_boundary.C</h1>  </div>
</div>
<div class="contents">
<a href="fe__boundary_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_boundary.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;cmath&gt;</span> <span class="comment">// for std::sqrt</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;fe.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;quadrature.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;fe_macro.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">//-------------------------------------------------------</span>
<a name="l00035"></a>00035 <span class="comment">// Full specializations for useless methods in 0D, 1D</span>
<a name="l00036"></a>00036 <span class="preprocessor">#define REINIT_ERROR(_dim, _type, _func)       \</span>
<a name="l00037"></a>00037 <span class="preprocessor">template &lt;&gt;                                    \</span>
<a name="l00038"></a>00038 <span class="preprocessor">void FE&lt;_dim,_type&gt;::_func(const Elem*,        \</span>
<a name="l00039"></a>00039 <span class="preprocessor">                           const unsigned int, \</span>
<a name="l00040"></a>00040 <span class="preprocessor">                           const Real)         \</span>
<a name="l00041"></a>00041 <span class="preprocessor">{                                              \</span>
<a name="l00042"></a>00042 <span class="preprocessor">  std::cerr &lt;&lt; &quot;ERROR: This method makes no sense for low-D elements!&quot; \</span>
<a name="l00043"></a>00043 <span class="preprocessor">            &lt;&lt; std::endl;                      \</span>
<a name="l00044"></a>00044 <span class="preprocessor">  libmesh_error();                                     \</span>
<a name="l00045"></a>00045 <span class="preprocessor">}</span>
<a name="l00046"></a>00046 <span class="preprocessor"></span>
<a name="l00047"></a><a class="code" href="fe__boundary_8C.php#a49c95c624b0f58a4969e28375f8de2ad">00047</a> <a class="code" href="fe__boundary_8C.php#a49c95c624b0f58a4969e28375f8de2ad">REINIT_ERROR</a>(0, <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>, <a class="code" href="classInfFE.php#aa606fecb673215f8e4164215c9dbc03b">reinit</a>)
<a name="l00048"></a>00048 <a class="code" href="fe__boundary_8C.php#a49c95c624b0f58a4969e28375f8de2ad">REINIT_ERROR</a>(0, <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>, <a class="code" href="classInfFE.php#ad3dbb2e882412e50ab162fd524788c0c">edge_reinit</a>)
<a name="l00049"></a>00049 REINIT_ERROR(0, <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>, <a class="code" href="classInfFE.php#aa606fecb673215f8e4164215c9dbc03b">reinit</a>)
<a name="l00050"></a>00050 REINIT_ERROR(0, HERMITE, <a class="code" href="classInfFE.php#ad3dbb2e882412e50ab162fd524788c0c">edge_reinit</a>)
<a name="l00051"></a>00051 REINIT_ERROR(0, <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>, <a class="code" href="classInfFE.php#aa606fecb673215f8e4164215c9dbc03b">reinit</a>)
<a name="l00052"></a>00052 REINIT_ERROR(0, HIERARCHIC, <a class="code" href="classInfFE.php#ad3dbb2e882412e50ab162fd524788c0c">edge_reinit</a>)
<a name="l00053"></a>00053 REINIT_ERROR(0, <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>, <a class="code" href="classInfFE.php#aa606fecb673215f8e4164215c9dbc03b">reinit</a>)
<a name="l00054"></a>00054 REINIT_ERROR(0, LAGRANGE, <a class="code" href="classInfFE.php#ad3dbb2e882412e50ab162fd524788c0c">edge_reinit</a>)
<a name="l00055"></a>00055 REINIT_ERROR(0, <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>, <a class="code" href="classInfFE.php#aa606fecb673215f8e4164215c9dbc03b">reinit</a>)
<a name="l00056"></a>00056 REINIT_ERROR(0, MONOMIAL, <a class="code" href="classInfFE.php#ad3dbb2e882412e50ab162fd524788c0c">edge_reinit</a>)
<a name="l00057"></a>00057 REINIT_ERROR(0, <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>, <a class="code" href="classInfFE.php#aa606fecb673215f8e4164215c9dbc03b">reinit</a>)
<a name="l00058"></a>00058 REINIT_ERROR(0, SCALAR, <a class="code" href="classInfFE.php#ad3dbb2e882412e50ab162fd524788c0c">edge_reinit</a>)
<a name="l00059"></a>00059 REINIT_ERROR(0, <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>, <a class="code" href="classInfFE.php#aa606fecb673215f8e4164215c9dbc03b">reinit</a>)
<a name="l00060"></a>00060 REINIT_ERROR(0, XYZ, <a class="code" href="classInfFE.php#ad3dbb2e882412e50ab162fd524788c0c">edge_reinit</a>)
<a name="l00061"></a>00061 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00062"></a>00062 <span class="preprocessor"></span><a class="code" href="fe__boundary_8C.php#a49c95c624b0f58a4969e28375f8de2ad">REINIT_ERROR</a>(0, <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>, <a class="code" href="classInfFE.php#aa606fecb673215f8e4164215c9dbc03b">reinit</a>)
<a name="l00063"></a>00063 REINIT_ERROR(0, <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>, <a class="code" href="classInfFE.php#ad3dbb2e882412e50ab162fd524788c0c">edge_reinit</a>)
<a name="l00064"></a>00064 REINIT_ERROR(0, <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>, <a class="code" href="classInfFE.php#aa606fecb673215f8e4164215c9dbc03b">reinit</a>)
<a name="l00065"></a>00065 REINIT_ERROR(0, SZABAB, <a class="code" href="classInfFE.php#ad3dbb2e882412e50ab162fd524788c0c">edge_reinit</a>)
<a name="l00066"></a>00066 <span class="preprocessor">#endif</span>
<a name="l00067"></a>00067 <span class="preprocessor"></span>
<a name="l00068"></a>00068 <a class="code" href="fe__boundary_8C.php#a49c95c624b0f58a4969e28375f8de2ad">REINIT_ERROR</a>(1, CLOUGH, <a class="code" href="classInfFE.php#ad3dbb2e882412e50ab162fd524788c0c">edge_reinit</a>)
<a name="l00069"></a>00069 REINIT_ERROR(1, HERMITE, <a class="code" href="classInfFE.php#ad3dbb2e882412e50ab162fd524788c0c">edge_reinit</a>)
<a name="l00070"></a>00070 REINIT_ERROR(1, HIERARCHIC, <a class="code" href="classInfFE.php#ad3dbb2e882412e50ab162fd524788c0c">edge_reinit</a>)
<a name="l00071"></a>00071 REINIT_ERROR(1, LAGRANGE, <a class="code" href="classInfFE.php#ad3dbb2e882412e50ab162fd524788c0c">edge_reinit</a>)
<a name="l00072"></a>00072 REINIT_ERROR(1, XYZ, <a class="code" href="classInfFE.php#ad3dbb2e882412e50ab162fd524788c0c">edge_reinit</a>)
<a name="l00073"></a>00073 REINIT_ERROR(1, MONOMIAL, <a class="code" href="classInfFE.php#ad3dbb2e882412e50ab162fd524788c0c">edge_reinit</a>)
<a name="l00074"></a>00074 REINIT_ERROR(1, SCALAR, <a class="code" href="classInfFE.php#ad3dbb2e882412e50ab162fd524788c0c">edge_reinit</a>)
<a name="l00075"></a>00075 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00076"></a>00076 <span class="preprocessor"></span><a class="code" href="fe__boundary_8C.php#a49c95c624b0f58a4969e28375f8de2ad">REINIT_ERROR</a>(1, BERNSTEIN, <a class="code" href="classInfFE.php#ad3dbb2e882412e50ab162fd524788c0c">edge_reinit</a>)
<a name="l00077"></a>00077 REINIT_ERROR(1, SZABAB, <a class="code" href="classInfFE.php#ad3dbb2e882412e50ab162fd524788c0c">edge_reinit</a>)
<a name="l00078"></a>00078 <span class="preprocessor">#endif</span>
<a name="l00079"></a>00079 <span class="preprocessor"></span>
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 <span class="comment">//-------------------------------------------------------</span>
<a name="l00082"></a>00082 <span class="comment">// Methods for 2D, 3D</span>
<a name="l00083"></a>00083 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00084"></a>00084 <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;Dim,T&gt;::reinit</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00085"></a>00085                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00086"></a>00086                        <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tolerance)
<a name="l00087"></a>00087 {
<a name="l00088"></a>00088   libmesh_assert (elem  != NULL);
<a name="l00089"></a>00089   libmesh_assert (<a class="code" href="classFEBase.php#af3ff470e7bacd59ef8cfde59255082ab">qrule</a> != NULL);
<a name="l00090"></a>00090   <span class="comment">// We now do this for 1D elements!</span>
<a name="l00091"></a>00091   <span class="comment">// libmesh_assert (Dim != 1);</span>
<a name="l00092"></a>00092 
<a name="l00093"></a>00093   <span class="comment">// Build the side of interest </span>
<a name="l00094"></a>00094   <span class="keyword">const</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> side(elem-&gt;<a class="code" href="classElem.php#a554c146bcfb5537636bd77a157f21b85">build_side</a>(s));
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a>00097   <span class="comment">// Find the max p_level to select </span>
<a name="l00098"></a>00098   <span class="comment">// the right quadrature rule for side integration</span>
<a name="l00099"></a>00099   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> side_p_level = elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>();
<a name="l00100"></a>00100   <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s) != NULL)
<a name="l00101"></a>00101      side_p_level = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(side_p_level, elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s)-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>());
<a name="l00102"></a>00102      
<a name="l00103"></a>00103   <span class="comment">// initialize quadrature rule</span>
<a name="l00104"></a>00104   <a class="code" href="classFEBase.php#af3ff470e7bacd59ef8cfde59255082ab">qrule</a>-&gt;<a class="code" href="classQBase.php#a1a0f71b05c7af21a8dd5577474b25818">init</a>(side-&gt;type(), side_p_level);
<a name="l00105"></a>00105 
<a name="l00106"></a>00106   <span class="comment">// FIXME - could this break if the same FE object was used</span>
<a name="l00107"></a>00107   <span class="comment">// for both volume and face integrals? - RHS</span>
<a name="l00108"></a>00108   <span class="comment">// We might not need to reinitialize the shape functions</span>
<a name="l00109"></a>00109   <span class="keywordflow">if</span> ((this-&gt;<a class="code" href="classFEBase.php#af5bbe1e9202c17390ec2b4c545c9ee09">get_type</a>() != elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>())    ||
<a name="l00110"></a>00110       (s != last_side)                      || 
<a name="l00111"></a>00111       (this-&gt;<a class="code" href="classFEBase.php#a6445c643b26e4b70f915eadef04252f8">get_p_level</a>() != side_p_level) ||
<a name="l00112"></a>00112       this-&gt;<a class="code" href="classInfFE.php#a7f0f29771b6d4eece966bf33aee9c330">shapes_need_reinit</a>())
<a name="l00113"></a>00113     {
<a name="l00114"></a>00114       <span class="comment">// Set the element type</span>
<a name="l00115"></a>00115       <a class="code" href="classFEBase.php#a34c06d973e594fffd1f3307fc34a1f22">elem_type</a> = elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>();
<a name="l00116"></a>00116 
<a name="l00117"></a>00117       <span class="comment">// Set the last_side</span>
<a name="l00118"></a>00118       last_side = s;
<a name="l00119"></a>00119       
<a name="l00120"></a>00120       <span class="comment">// Set the last p level</span>
<a name="l00121"></a>00121       <a class="code" href="classFEBase.php#a6d1bedff3a8331c2e87ee1daee7ef66b">_p_level</a> = side_p_level;
<a name="l00122"></a>00122       
<a name="l00123"></a>00123       <span class="comment">// Initialize the face shape functions</span>
<a name="l00124"></a>00124       this-&gt;<a class="code" href="classInfFE.php#a6317dd31e07d5eebce52a7faf7b9a41a">init_face_shape_functions</a> (<a class="code" href="classFEBase.php#af3ff470e7bacd59ef8cfde59255082ab">qrule</a>-&gt;<a class="code" href="classQBase.php#a23bdd4e01c2f6d74307b33c99f83c4e9">get_points</a>(),  side.get());
<a name="l00125"></a>00125     }
<a name="l00126"></a>00126   
<a name="l00127"></a>00127   <span class="comment">// Compute the Jacobian*Weight on the face for integration</span>
<a name="l00128"></a>00128   this-&gt;<a class="code" href="classFEBase.php#af47ed992fc087681ed2e0b3587657dad">compute_face_map</a> (<a class="code" href="classFEBase.php#af3ff470e7bacd59ef8cfde59255082ab">qrule</a>-&gt;<a class="code" href="classQBase.php#a6761747a317f199580691ea574fa9e99">get_weights</a>(), side.get());
<a name="l00129"></a>00129 
<a name="l00130"></a>00130   <span class="comment">// make a copy of the Jacobian for integration</span>
<a name="l00131"></a>00131   <span class="keyword">const</span> std::vector&lt;Real&gt; JxW_int(<a class="code" href="classFEBase.php#ab12c8cff995327a80e2ec6a76104bb3c">JxW</a>);
<a name="l00132"></a>00132 
<a name="l00133"></a>00133   <span class="comment">// Find where the integration points are located on the</span>
<a name="l00134"></a>00134   <span class="comment">// full element.</span>
<a name="l00135"></a>00135   std::vector&lt;Point&gt; qp; this-&gt;<a class="code" href="classInfFE.php#ad3ae911e9714c059f519c72467cda290">inverse_map</a> (elem, <a class="code" href="classFEBase.php#aae6af9098e4135ab3783b1026f411c9b">xyz</a>, qp, tolerance);
<a name="l00136"></a>00136   
<a name="l00137"></a>00137   <span class="comment">// compute the shape function and derivative values</span>
<a name="l00138"></a>00138   <span class="comment">// at the points qp</span>
<a name="l00139"></a>00139   this-&gt;<a class="code" href="classInfFE.php#aa606fecb673215f8e4164215c9dbc03b">reinit</a>  (elem, &amp;qp);
<a name="l00140"></a>00140       
<a name="l00141"></a>00141   <span class="comment">// copy back old data</span>
<a name="l00142"></a>00142   <a class="code" href="classFEBase.php#ab12c8cff995327a80e2ec6a76104bb3c">JxW</a> = JxW_int;
<a name="l00143"></a>00143 }
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00148"></a><a class="code" href="classFE.php#adb74f797c07e54b20b437fa105d21929">00148</a> <span class="keywordtype">void</span> <a class="code" href="classFE.php#adb74f797c07e54b20b437fa105d21929">FE&lt;Dim,T&gt;::edge_reinit</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00149"></a>00149                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e,
<a name="l00150"></a>00150                             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tolerance)
<a name="l00151"></a>00151 {
<a name="l00152"></a>00152   libmesh_assert (elem  != NULL);
<a name="l00153"></a>00153   libmesh_assert (<a class="code" href="classFEBase.php#af3ff470e7bacd59ef8cfde59255082ab">qrule</a> != NULL);
<a name="l00154"></a>00154   <span class="comment">// We don&#39;t do this for 1D elements!</span>
<a name="l00155"></a>00155   libmesh_assert (Dim != 1);
<a name="l00156"></a>00156 
<a name="l00157"></a>00157   <span class="comment">// Build the side of interest </span>
<a name="l00158"></a>00158   <span class="keyword">const</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> edge(elem-&gt;<a class="code" href="classElem.php#a53d7b548eddc81a770c6459264a07115">build_edge</a>(e));
<a name="l00159"></a>00159 
<a name="l00160"></a>00160   <span class="comment">// initialize quadrature rule</span>
<a name="l00161"></a>00161   <a class="code" href="classFEBase.php#af3ff470e7bacd59ef8cfde59255082ab">qrule</a>-&gt;<a class="code" href="classQBase.php#a1a0f71b05c7af21a8dd5577474b25818">init</a>(edge-&gt;type(), elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>());
<a name="l00162"></a>00162 
<a name="l00163"></a>00163   <span class="comment">// We might not need to reinitialize the shape functions</span>
<a name="l00164"></a>00164   <span class="keywordflow">if</span> ((this-&gt;<a class="code" href="classFEBase.php#af5bbe1e9202c17390ec2b4c545c9ee09">get_type</a>() != elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>()) ||
<a name="l00165"></a>00165       (e != last_edge) ||
<a name="l00166"></a>00166       this-&gt;<a class="code" href="classInfFE.php#a7f0f29771b6d4eece966bf33aee9c330">shapes_need_reinit</a>())
<a name="l00167"></a>00167     {
<a name="l00168"></a>00168       <span class="comment">// Set the element type</span>
<a name="l00169"></a>00169       <a class="code" href="classFEBase.php#a34c06d973e594fffd1f3307fc34a1f22">elem_type</a> = elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>();
<a name="l00170"></a>00170 
<a name="l00171"></a>00171       <span class="comment">// Set the last_edge</span>
<a name="l00172"></a>00172       last_edge = e;
<a name="l00173"></a>00173       
<a name="l00174"></a>00174       <span class="comment">// Initialize the edge shape functions</span>
<a name="l00175"></a>00175       this-&gt;init_edge_shape_functions (<a class="code" href="classFEBase.php#af3ff470e7bacd59ef8cfde59255082ab">qrule</a>-&gt;<a class="code" href="classQBase.php#a23bdd4e01c2f6d74307b33c99f83c4e9">get_points</a>(), edge.get());
<a name="l00176"></a>00176     }
<a name="l00177"></a>00177   
<a name="l00178"></a>00178   <span class="comment">// Compute the Jacobian*Weight on the face for integration</span>
<a name="l00179"></a>00179   this-&gt;<a class="code" href="classFEBase.php#aaf150f783d70df060b2b218a9c84e122">compute_edge_map</a> (<a class="code" href="classFEBase.php#af3ff470e7bacd59ef8cfde59255082ab">qrule</a>-&gt;<a class="code" href="classQBase.php#a6761747a317f199580691ea574fa9e99">get_weights</a>(), edge.get());
<a name="l00180"></a>00180 
<a name="l00181"></a>00181   <span class="comment">// make a copy of the Jacobian for integration</span>
<a name="l00182"></a>00182   <span class="keyword">const</span> std::vector&lt;Real&gt; JxW_int(<a class="code" href="classFEBase.php#ab12c8cff995327a80e2ec6a76104bb3c">JxW</a>);
<a name="l00183"></a>00183 
<a name="l00184"></a>00184   <span class="comment">// Find where the integration points are located on the</span>
<a name="l00185"></a>00185   <span class="comment">// full element.</span>
<a name="l00186"></a>00186   std::vector&lt;Point&gt; qp; this-&gt;<a class="code" href="classInfFE.php#ad3ae911e9714c059f519c72467cda290">inverse_map</a> (elem, <a class="code" href="classFEBase.php#aae6af9098e4135ab3783b1026f411c9b">xyz</a>, qp, tolerance);
<a name="l00187"></a>00187   
<a name="l00188"></a>00188   <span class="comment">// compute the shape function and derivative values</span>
<a name="l00189"></a>00189   <span class="comment">// at the points qp</span>
<a name="l00190"></a>00190   this-&gt;<a class="code" href="classInfFE.php#aa606fecb673215f8e4164215c9dbc03b">reinit</a>  (elem, &amp;qp);
<a name="l00191"></a>00191       
<a name="l00192"></a>00192   <span class="comment">// copy back old data</span>
<a name="l00193"></a>00193   <a class="code" href="classFEBase.php#ab12c8cff995327a80e2ec6a76104bb3c">JxW</a> = JxW_int;
<a name="l00194"></a>00194 }
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00199"></a><a class="code" href="classFE.php#a2ecff327bbb449b07bb2a1d28756fc30">00199</a> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a2ecff327bbb449b07bb2a1d28756fc30">FE&lt;Dim,T&gt;::init_face_shape_functions</a>(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qp,
<a name="l00200"></a>00200                                           <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* side)
<a name="l00201"></a>00201 {
<a name="l00202"></a>00202   libmesh_assert (side  != NULL);
<a name="l00203"></a>00203   
<a name="l00207"></a>00207   START_LOG(<span class="stringliteral">&quot;init_face_shape_functions()&quot;</span>, <span class="stringliteral">&quot;FE&quot;</span>);
<a name="l00208"></a>00208 
<a name="l00209"></a>00209   <span class="comment">// The element type and order to use in</span>
<a name="l00210"></a>00210   <span class="comment">// the map</span>
<a name="l00211"></a>00211   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>    mapping_order     (side-&gt;<a class="code" href="classElem.php#a6cef8ca882c2fc1081fd27132851627a">default_order</a>()); 
<a name="l00212"></a>00212   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> mapping_elem_type (side-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>());
<a name="l00213"></a>00213 
<a name="l00214"></a>00214   <span class="comment">// The number of quadrature points.</span>
<a name="l00215"></a>00215   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = qp.size();
<a name="l00216"></a>00216         
<a name="l00217"></a>00217   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_mapping_shape_functions =
<a name="l00218"></a>00218     <a class="code" href="classFE.php#a8168c8902a8a52b2ef9df7d0088bdf75">FE&lt;Dim,LAGRANGE&gt;::n_shape_functions</a> (mapping_elem_type,
<a name="l00219"></a>00219                                          mapping_order);
<a name="l00220"></a>00220   
<a name="l00221"></a>00221   <span class="comment">// resize the vectors to hold current data</span>
<a name="l00222"></a>00222   <span class="comment">// Psi are the shape functions used for the FE mapping</span>
<a name="l00223"></a>00223   <a class="code" href="classFEBase.php#a4dd1648378169f9df7be04b8ccccf79b">psi_map</a>.resize        (n_mapping_shape_functions);
<a name="l00224"></a>00224 
<a name="l00225"></a>00225   <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00226"></a>00226     {
<a name="l00227"></a>00227       <a class="code" href="classFEBase.php#ae81262808ef65f058ffde4107a083cb6">dpsidxi_map</a>.resize    (n_mapping_shape_functions);
<a name="l00228"></a>00228       <a class="code" href="classFEBase.php#aa86ebf823af5a31ff5ae1b6f79a62854">d2psidxi2_map</a>.resize  (n_mapping_shape_functions);
<a name="l00229"></a>00229     }
<a name="l00230"></a>00230   
<a name="l00231"></a>00231   <span class="keywordflow">if</span> (Dim == 3)
<a name="l00232"></a>00232     {
<a name="l00233"></a>00233       <a class="code" href="classFEBase.php#a02d881d240576a85a34ae52f53b51d14">dpsideta_map</a>.resize     (n_mapping_shape_functions);
<a name="l00234"></a>00234       <a class="code" href="classFEBase.php#afaee9565e3e853061b9be24651949f7d">d2psidxideta_map</a>.resize (n_mapping_shape_functions);
<a name="l00235"></a>00235       <a class="code" href="classFEBase.php#ac25fcbc849c8a91ebf51dbced8d9f4aa">d2psideta2_map</a>.resize   (n_mapping_shape_functions);
<a name="l00236"></a>00236     }
<a name="l00237"></a>00237   
<a name="l00238"></a>00238   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_mapping_shape_functions; i++)
<a name="l00239"></a>00239     {
<a name="l00240"></a>00240       <span class="comment">// Allocate space to store the values of the shape functions</span>
<a name="l00241"></a>00241       <span class="comment">// and their first and second derivatives at the quadrature points.</span>
<a name="l00242"></a>00242       <a class="code" href="classFEBase.php#a4dd1648378169f9df7be04b8ccccf79b">psi_map</a>[i].resize        (n_qp);
<a name="l00243"></a>00243       <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00244"></a>00244         {
<a name="l00245"></a>00245           <a class="code" href="classFEBase.php#ae81262808ef65f058ffde4107a083cb6">dpsidxi_map</a>[i].resize    (n_qp);
<a name="l00246"></a>00246           <a class="code" href="classFEBase.php#aa86ebf823af5a31ff5ae1b6f79a62854">d2psidxi2_map</a>[i].resize  (n_qp);
<a name="l00247"></a>00247         }
<a name="l00248"></a>00248       <span class="keywordflow">if</span> (Dim == 3)
<a name="l00249"></a>00249         {
<a name="l00250"></a>00250           <a class="code" href="classFEBase.php#a02d881d240576a85a34ae52f53b51d14">dpsideta_map</a>[i].resize     (n_qp);
<a name="l00251"></a>00251           <a class="code" href="classFEBase.php#afaee9565e3e853061b9be24651949f7d">d2psidxideta_map</a>[i].resize (n_qp);
<a name="l00252"></a>00252           <a class="code" href="classFEBase.php#ac25fcbc849c8a91ebf51dbced8d9f4aa">d2psideta2_map</a>[i].resize   (n_qp);
<a name="l00253"></a>00253         }
<a name="l00254"></a>00254   
<a name="l00255"></a>00255       <span class="comment">// Compute the value of shape function i, and its first and</span>
<a name="l00256"></a>00256       <span class="comment">// second derivatives at quadrature point p</span>
<a name="l00257"></a>00257       <span class="comment">// (Lagrange shape functions are used for the mapping)</span>
<a name="l00258"></a>00258       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00259"></a>00259         {
<a name="l00260"></a>00260           <a class="code" href="classFEBase.php#a4dd1648378169f9df7be04b8ccccf79b">psi_map</a>[i][p]        = <a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">FE&lt;Dim-1,LAGRANGE&gt;::shape</a>             (mapping_elem_type, mapping_order, i,    qp[p]);
<a name="l00261"></a>00261           <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00262"></a>00262             {
<a name="l00263"></a>00263               <a class="code" href="classFEBase.php#ae81262808ef65f058ffde4107a083cb6">dpsidxi_map</a>[i][p]    = <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;Dim-1,LAGRANGE&gt;::shape_deriv</a>       (mapping_elem_type, mapping_order, i, 0, qp[p]);
<a name="l00264"></a>00264               <a class="code" href="classFEBase.php#aa86ebf823af5a31ff5ae1b6f79a62854">d2psidxi2_map</a>[i][p]  = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim-1,LAGRANGE&gt;::shape_second_deriv</a>(mapping_elem_type, mapping_order, i, 0, qp[p]);
<a name="l00265"></a>00265             }
<a name="l00266"></a>00266           <span class="comment">// std::cout &lt;&lt; &quot;d2psidxi2_map[&quot;&lt;&lt;i&lt;&lt;&quot;][p]=&quot; &lt;&lt; d2psidxi2_map[i][p] &lt;&lt; std::endl;</span>
<a name="l00267"></a>00267 
<a name="l00268"></a>00268           <span class="comment">// If we are in 3D, then our sides are 2D faces.</span>
<a name="l00269"></a>00269           <span class="comment">// For the second derivatives, we must also compute the cross</span>
<a name="l00270"></a>00270           <span class="comment">// derivative d^2() / dxi deta</span>
<a name="l00271"></a>00271           <span class="keywordflow">if</span> (Dim == 3)
<a name="l00272"></a>00272             {
<a name="l00273"></a>00273               <a class="code" href="classFEBase.php#a02d881d240576a85a34ae52f53b51d14">dpsideta_map</a>[i][p]     = <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;Dim-1,LAGRANGE&gt;::shape_deriv</a>       (mapping_elem_type, mapping_order, i, 1, qp[p]);
<a name="l00274"></a>00274               <a class="code" href="classFEBase.php#afaee9565e3e853061b9be24651949f7d">d2psidxideta_map</a>[i][p] = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim-1,LAGRANGE&gt;::shape_second_deriv</a>(mapping_elem_type, mapping_order, i, 1, qp[p]); 
<a name="l00275"></a>00275               <a class="code" href="classFEBase.php#ac25fcbc849c8a91ebf51dbced8d9f4aa">d2psideta2_map</a>[i][p]   = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;Dim-1,LAGRANGE&gt;::shape_second_deriv</a>(mapping_elem_type, mapping_order, i, 2, qp[p]);
<a name="l00276"></a>00276             }
<a name="l00277"></a>00277         }
<a name="l00278"></a>00278     }
<a name="l00279"></a>00279 
<a name="l00280"></a>00280   
<a name="l00284"></a>00284   STOP_LOG(<span class="stringliteral">&quot;init_face_shape_functions()&quot;</span>, <span class="stringliteral">&quot;FE&quot;</span>);
<a name="l00285"></a>00285 }
<a name="l00286"></a>00286 
<a name="l00287"></a>00287 
<a name="l00288"></a>00288   
<a name="l00289"></a>00289 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00290"></a><a class="code" href="classFE.php#a9ef0db35bb9fba3d69a6dd771c82ab95">00290</a> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a9ef0db35bb9fba3d69a6dd771c82ab95">FE&lt;Dim,T&gt;::init_edge_shape_functions</a>(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qp,
<a name="l00291"></a>00291                                           <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* edge)
<a name="l00292"></a>00292 {
<a name="l00293"></a>00293   libmesh_assert (edge != NULL);
<a name="l00294"></a>00294   
<a name="l00298"></a>00298   START_LOG(<span class="stringliteral">&quot;init_edge_shape_functions()&quot;</span>, <span class="stringliteral">&quot;FE&quot;</span>);
<a name="l00299"></a>00299 
<a name="l00300"></a>00300   <span class="comment">// The element type and order to use in</span>
<a name="l00301"></a>00301   <span class="comment">// the map</span>
<a name="l00302"></a>00302   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>    mapping_order     (edge-&gt;<a class="code" href="classElem.php#a6cef8ca882c2fc1081fd27132851627a">default_order</a>()); 
<a name="l00303"></a>00303   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> mapping_elem_type (edge-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>());
<a name="l00304"></a>00304 
<a name="l00305"></a>00305   <span class="comment">// The number of quadrature points.</span>
<a name="l00306"></a>00306   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = qp.size();
<a name="l00307"></a>00307         
<a name="l00308"></a>00308   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_mapping_shape_functions =
<a name="l00309"></a>00309     <a class="code" href="classFE.php#a8168c8902a8a52b2ef9df7d0088bdf75">FE&lt;Dim,LAGRANGE&gt;::n_shape_functions</a> (mapping_elem_type,
<a name="l00310"></a>00310                                          mapping_order);
<a name="l00311"></a>00311   
<a name="l00312"></a>00312   <span class="comment">// resize the vectors to hold current data</span>
<a name="l00313"></a>00313   <span class="comment">// Psi are the shape functions used for the FE mapping</span>
<a name="l00314"></a>00314   <a class="code" href="classFEBase.php#a4dd1648378169f9df7be04b8ccccf79b">psi_map</a>.resize        (n_mapping_shape_functions);
<a name="l00315"></a>00315   <a class="code" href="classFEBase.php#ae81262808ef65f058ffde4107a083cb6">dpsidxi_map</a>.resize    (n_mapping_shape_functions);
<a name="l00316"></a>00316   <a class="code" href="classFEBase.php#aa86ebf823af5a31ff5ae1b6f79a62854">d2psidxi2_map</a>.resize  (n_mapping_shape_functions);
<a name="l00317"></a>00317   
<a name="l00318"></a>00318   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_mapping_shape_functions; i++)
<a name="l00319"></a>00319     {
<a name="l00320"></a>00320       <span class="comment">// Allocate space to store the values of the shape functions</span>
<a name="l00321"></a>00321       <span class="comment">// and their first and second derivatives at the quadrature points.</span>
<a name="l00322"></a>00322       <a class="code" href="classFEBase.php#a4dd1648378169f9df7be04b8ccccf79b">psi_map</a>[i].resize        (n_qp);
<a name="l00323"></a>00323       <a class="code" href="classFEBase.php#ae81262808ef65f058ffde4107a083cb6">dpsidxi_map</a>[i].resize    (n_qp);
<a name="l00324"></a>00324       <a class="code" href="classFEBase.php#aa86ebf823af5a31ff5ae1b6f79a62854">d2psidxi2_map</a>[i].resize  (n_qp);
<a name="l00325"></a>00325   
<a name="l00326"></a>00326       <span class="comment">// Compute the value of shape function i, and its first and</span>
<a name="l00327"></a>00327       <span class="comment">// second derivatives at quadrature point p</span>
<a name="l00328"></a>00328       <span class="comment">// (Lagrange shape functions are used for the mapping)</span>
<a name="l00329"></a>00329       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00330"></a>00330         {
<a name="l00331"></a>00331           <a class="code" href="classFEBase.php#a4dd1648378169f9df7be04b8ccccf79b">psi_map</a>[i][p]        = <a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">FE&lt;1,LAGRANGE&gt;::shape</a>             (mapping_elem_type, mapping_order, i,    qp[p]);
<a name="l00332"></a>00332           <a class="code" href="classFEBase.php#ae81262808ef65f058ffde4107a083cb6">dpsidxi_map</a>[i][p]    = <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;1,LAGRANGE&gt;::shape_deriv</a>       (mapping_elem_type, mapping_order, i, 0, qp[p]);
<a name="l00333"></a>00333           <a class="code" href="classFEBase.php#aa86ebf823af5a31ff5ae1b6f79a62854">d2psidxi2_map</a>[i][p]  = <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;1,LAGRANGE&gt;::shape_second_deriv</a>(mapping_elem_type, mapping_order, i, 0, qp[p]);
<a name="l00334"></a>00334         }
<a name="l00335"></a>00335     }
<a name="l00336"></a>00336   
<a name="l00340"></a>00340   STOP_LOG(<span class="stringliteral">&quot;init_edge_shape_functions()&quot;</span>, <span class="stringliteral">&quot;FE&quot;</span>);
<a name="l00341"></a>00341 }
<a name="l00342"></a>00342 
<a name="l00343"></a>00343   
<a name="l00344"></a>00344 
<a name="l00345"></a><a class="code" href="classFEBase.php#af47ed992fc087681ed2e0b3587657dad">00345</a> <span class="keywordtype">void</span> <a class="code" href="classFEBase.php#af47ed992fc087681ed2e0b3587657dad">FEBase::compute_face_map</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; qw,
<a name="l00346"></a>00346                               <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* side)
<a name="l00347"></a>00347 {
<a name="l00348"></a>00348   libmesh_assert (side  != NULL);
<a name="l00349"></a>00349 
<a name="l00350"></a>00350   START_LOG(<span class="stringliteral">&quot;compute_face_map()&quot;</span>, <span class="stringliteral">&quot;FE&quot;</span>);
<a name="l00351"></a>00351 
<a name="l00352"></a>00352   <span class="comment">// The number of quadrature points.</span>
<a name="l00353"></a>00353   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = qw.size();
<a name="l00354"></a>00354   
<a name="l00355"></a>00355   
<a name="l00356"></a>00356   <span class="keywordflow">switch</span> (<a class="code" href="classFEBase.php#a883023d0114b38abb42d38479459738e">dim</a>)
<a name="l00357"></a>00357     {
<a name="l00358"></a>00358     <span class="keywordflow">case</span> 1:
<a name="l00359"></a>00359       {
<a name="l00360"></a>00360         <span class="comment">// A 1D finite element, currently assumed to be in 1D space</span>
<a name="l00361"></a>00361         <span class="comment">// This means the boundary is a &quot;0D finite element&quot;, a</span>
<a name="l00362"></a>00362         <span class="comment">// NODEELEM.</span>
<a name="l00363"></a>00363 
<a name="l00364"></a>00364         <span class="comment">// Resize the vectors to hold data at the quadrature points</span>
<a name="l00365"></a>00365         {  
<a name="l00366"></a>00366           <a class="code" href="classFEBase.php#aae6af9098e4135ab3783b1026f411c9b">xyz</a>.resize(n_qp);
<a name="l00367"></a>00367           <a class="code" href="classFEBase.php#a3b1435ecd16c024da965fe28f5ae15b8">normals</a>.resize(n_qp);
<a name="l00368"></a>00368 
<a name="l00369"></a>00369           <a class="code" href="classFEBase.php#ab12c8cff995327a80e2ec6a76104bb3c">JxW</a>.resize(n_qp);
<a name="l00370"></a>00370         }
<a name="l00371"></a>00371 
<a name="l00372"></a>00372         <span class="comment">// If we have no quadrature points, there&#39;s nothing else to do</span>
<a name="l00373"></a>00373         <span class="keywordflow">if</span> (!n_qp)
<a name="l00374"></a>00374           <span class="keywordflow">break</span>;
<a name="l00375"></a>00375 
<a name="l00376"></a>00376         <span class="comment">// We need to look back at the full edge to figure out the normal</span>
<a name="l00377"></a>00377         <span class="comment">// vector</span>
<a name="l00378"></a>00378         <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *elem = side-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>();
<a name="l00379"></a>00379         libmesh_assert (elem);
<a name="l00380"></a>00380         <span class="keywordflow">if</span> (side-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0) == elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0))
<a name="l00381"></a>00381           <a class="code" href="classFEBase.php#a3b1435ecd16c024da965fe28f5ae15b8">normals</a>[0] = <a class="code" href="classPoint.php">Point</a>(-1.);
<a name="l00382"></a>00382         <span class="keywordflow">else</span>
<a name="l00383"></a>00383           {
<a name="l00384"></a>00384             libmesh_assert (side-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(0) == elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(1));
<a name="l00385"></a>00385             <a class="code" href="classFEBase.php#a3b1435ecd16c024da965fe28f5ae15b8">normals</a>[0] = <a class="code" href="classPoint.php">Point</a>(1.);
<a name="l00386"></a>00386           }
<a name="l00387"></a>00387 
<a name="l00388"></a>00388         <span class="comment">// Calculate x at the point</span>
<a name="l00389"></a>00389         libmesh_assert (<a class="code" href="classFEBase.php#a4dd1648378169f9df7be04b8ccccf79b">psi_map</a>.size() == 1);
<a name="l00390"></a>00390         <span class="comment">// In the unlikely event we have multiple quadrature</span>
<a name="l00391"></a>00391         <span class="comment">// points, they&#39;ll be in the same place</span>
<a name="l00392"></a>00392         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00393"></a>00393           {
<a name="l00394"></a>00394             <a class="code" href="classFEBase.php#aae6af9098e4135ab3783b1026f411c9b">xyz</a>[p].zero();
<a name="l00395"></a>00395             <a class="code" href="classFEBase.php#aae6af9098e4135ab3783b1026f411c9b">xyz</a>[p].add_scaled          (side-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0), <a class="code" href="classFEBase.php#a4dd1648378169f9df7be04b8ccccf79b">psi_map</a>[0][p]);
<a name="l00396"></a>00396             <a class="code" href="classFEBase.php#a3b1435ecd16c024da965fe28f5ae15b8">normals</a>[p] = <a class="code" href="classFEBase.php#a3b1435ecd16c024da965fe28f5ae15b8">normals</a>[0];
<a name="l00397"></a>00397             <a class="code" href="classFEBase.php#ab12c8cff995327a80e2ec6a76104bb3c">JxW</a>[p] = 1.0*qw[p];
<a name="l00398"></a>00398           }
<a name="l00399"></a>00399 
<a name="l00400"></a>00400         <span class="comment">// done computing the map</span>
<a name="l00401"></a>00401         <span class="keywordflow">break</span>;
<a name="l00402"></a>00402       }
<a name="l00403"></a>00403       
<a name="l00404"></a>00404     <span class="keywordflow">case</span> 2:
<a name="l00405"></a>00405       {
<a name="l00406"></a>00406         <span class="comment">// A 2D finite element living in either 2D or 3D space.</span>
<a name="l00407"></a>00407         <span class="comment">// This means the boundary is a 1D finite element, i.e.</span>
<a name="l00408"></a>00408         <span class="comment">// and EDGE2 or EDGE3.</span>
<a name="l00409"></a>00409         <span class="comment">// Resize the vectors to hold data at the quadrature points</span>
<a name="l00410"></a>00410         {  
<a name="l00411"></a>00411           <a class="code" href="classFEBase.php#aae6af9098e4135ab3783b1026f411c9b">xyz</a>.resize(n_qp);
<a name="l00412"></a>00412           <a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>.resize(n_qp);
<a name="l00413"></a>00413           <a class="code" href="classFEBase.php#a7d557b2fffe299f44ae5ea512aafd23b">d2xyzdxi2_map</a>.resize(n_qp);
<a name="l00414"></a>00414           <a class="code" href="classFEBase.php#a26d01a4ea4a5825a579dbe7dbbda3c45">tangents</a>.resize(n_qp);
<a name="l00415"></a>00415           <a class="code" href="classFEBase.php#a3b1435ecd16c024da965fe28f5ae15b8">normals</a>.resize(n_qp);
<a name="l00416"></a>00416           <a class="code" href="classFEBase.php#a4bbc232fa21530fc3ec3270ed03edf0a">curvatures</a>.resize(n_qp);
<a name="l00417"></a>00417           
<a name="l00418"></a>00418           <a class="code" href="classFEBase.php#ab12c8cff995327a80e2ec6a76104bb3c">JxW</a>.resize(n_qp);
<a name="l00419"></a>00419         }
<a name="l00420"></a>00420         
<a name="l00421"></a>00421         <span class="comment">// Clear the entities that will be summed</span>
<a name="l00422"></a>00422         <span class="comment">// Compute the tangent &amp; normal at the quadrature point</span>
<a name="l00423"></a>00423         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00424"></a>00424           {
<a name="l00425"></a>00425             <a class="code" href="classFEBase.php#a26d01a4ea4a5825a579dbe7dbbda3c45">tangents</a>[p].resize(LIBMESH_DIM-1); <span class="comment">// 1 Tangent in 2D, 2 in 3D</span>
<a name="l00426"></a>00426             <a class="code" href="classFEBase.php#aae6af9098e4135ab3783b1026f411c9b">xyz</a>[p].zero();
<a name="l00427"></a>00427             <a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>[p].zero();
<a name="l00428"></a>00428             <a class="code" href="classFEBase.php#a7d557b2fffe299f44ae5ea512aafd23b">d2xyzdxi2_map</a>[p].zero();
<a name="l00429"></a>00429           }
<a name="l00430"></a>00430         
<a name="l00431"></a>00431         <span class="comment">// compute x, dxdxi at the quadrature points    </span>
<a name="l00432"></a>00432         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classFEBase.php#a4dd1648378169f9df7be04b8ccccf79b">psi_map</a>.size(); i++) <span class="comment">// sum over the nodes</span>
<a name="l00433"></a>00433           {
<a name="l00434"></a>00434             <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; side_point = side-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(i);
<a name="l00435"></a>00435             
<a name="l00436"></a>00436             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++) <span class="comment">// for each quadrature point...</span>
<a name="l00437"></a>00437               {   
<a name="l00438"></a>00438                 <a class="code" href="classFEBase.php#aae6af9098e4135ab3783b1026f411c9b">xyz</a>[p].add_scaled          (side_point, <a class="code" href="classFEBase.php#a4dd1648378169f9df7be04b8ccccf79b">psi_map</a>[i][p]);
<a name="l00439"></a>00439                 <a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>[p].add_scaled  (side_point, <a class="code" href="classFEBase.php#ae81262808ef65f058ffde4107a083cb6">dpsidxi_map</a>[i][p]);
<a name="l00440"></a>00440                 <a class="code" href="classFEBase.php#a7d557b2fffe299f44ae5ea512aafd23b">d2xyzdxi2_map</a>[p].add_scaled(side_point, <a class="code" href="classFEBase.php#aa86ebf823af5a31ff5ae1b6f79a62854">d2psidxi2_map</a>[i][p]);
<a name="l00441"></a>00441               }
<a name="l00442"></a>00442           }
<a name="l00443"></a>00443 
<a name="l00444"></a>00444         <span class="comment">// Compute the tangent &amp; normal at the quadrature point</span>
<a name="l00445"></a>00445         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00446"></a>00446           {
<a name="l00447"></a>00447             <span class="comment">// The first tangent comes from just the edge&#39;s Jacobian</span>
<a name="l00448"></a>00448             <a class="code" href="classFEBase.php#a26d01a4ea4a5825a579dbe7dbbda3c45">tangents</a>[p][0] = <a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>[p].unit();
<a name="l00449"></a>00449             
<a name="l00450"></a>00450 <span class="preprocessor">#if LIBMESH_DIM == 2</span>
<a name="l00451"></a>00451 <span class="preprocessor"></span>            <span class="comment">// For a 2D element living in 2D, the normal is given directly</span>
<a name="l00452"></a>00452             <span class="comment">// from the entries in the edge Jacobian.</span>
<a name="l00453"></a>00453             <a class="code" href="classFEBase.php#a3b1435ecd16c024da965fe28f5ae15b8">normals</a>[p] = (<a class="code" href="classPoint.php">Point</a>(<a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>[p](1), -<a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>[p](0), 0.)).unit();
<a name="l00454"></a>00454             
<a name="l00455"></a>00455 <span class="preprocessor">#elif LIBMESH_DIM == 3</span>
<a name="l00456"></a>00456 <span class="preprocessor"></span>            <span class="comment">// For a 2D element living in 3D, there is a second tangent.</span>
<a name="l00457"></a>00457             <span class="comment">// For the second tangent, we need to refer to the full</span>
<a name="l00458"></a>00458             <span class="comment">// element&#39;s (not just the edge&#39;s) Jacobian.</span>
<a name="l00459"></a>00459             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *elem = side-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>();
<a name="l00460"></a>00460             libmesh_assert (elem != NULL);
<a name="l00461"></a>00461 
<a name="l00462"></a>00462             <span class="comment">// Inverse map xyz[p] to a reference point on the parent...</span>
<a name="l00463"></a>00463             <a class="code" href="classPoint.php">Point</a> reference_point = <a class="code" href="classInfFE.php#ad3ae911e9714c059f519c72467cda290">FE&lt;2,LAGRANGE&gt;::inverse_map</a>(elem, <a class="code" href="classFEBase.php#aae6af9098e4135ab3783b1026f411c9b">xyz</a>[p]);
<a name="l00464"></a>00464             
<a name="l00465"></a>00465             <span class="comment">// Get dxyz/dxi and dxyz/deta from the parent map.</span>
<a name="l00466"></a>00466             <a class="code" href="classPoint.php">Point</a> dx_dxi  = <a class="code" href="classFE.php">FE&lt;2,LAGRANGE&gt;::map_xi</a> (elem, reference_point);
<a name="l00467"></a>00467             <a class="code" href="classPoint.php">Point</a> dx_deta = <a class="code" href="classFE.php">FE&lt;2,LAGRANGE&gt;::map_eta</a>(elem, reference_point);
<a name="l00468"></a>00468 
<a name="l00469"></a>00469             <span class="comment">// The second tangent vector is formed by crossing these vectors.</span>
<a name="l00470"></a>00470             <a class="code" href="classFEBase.php#a26d01a4ea4a5825a579dbe7dbbda3c45">tangents</a>[p][1] = dx_dxi.<a class="code" href="classTypeVector.php#a1347e1223f3e31f8a2c0496736e60dc5">cross</a>(dx_deta).unit();
<a name="l00471"></a>00471 
<a name="l00472"></a>00472             <span class="comment">// Finally, the normal in this case is given by crossing these</span>
<a name="l00473"></a>00473             <span class="comment">// two tangents.</span>
<a name="l00474"></a>00474             <a class="code" href="classFEBase.php#a3b1435ecd16c024da965fe28f5ae15b8">normals</a>[p] = <a class="code" href="classFEBase.php#a26d01a4ea4a5825a579dbe7dbbda3c45">tangents</a>[p][0].cross(<a class="code" href="classFEBase.php#a26d01a4ea4a5825a579dbe7dbbda3c45">tangents</a>[p][1]).unit();
<a name="l00475"></a>00475 <span class="preprocessor">#endif </span>
<a name="l00476"></a>00476 <span class="preprocessor"></span>            
<a name="l00477"></a>00477 
<a name="l00478"></a>00478             <span class="comment">// The curvature is computed via the familiar Frenet formula:</span>
<a name="l00479"></a>00479             <span class="comment">// curvature = [d^2(x) / d (xi)^2] dot [normal]</span>
<a name="l00480"></a>00480             <span class="comment">// For a reference, see:</span>
<a name="l00481"></a>00481             <span class="comment">// F.S. Merritt, Mathematics Manual, 1962, McGraw-Hill, p. 310</span>
<a name="l00482"></a>00482             <span class="comment">//</span>
<a name="l00483"></a>00483             <span class="comment">// Note: The sign convention here is different from the</span>
<a name="l00484"></a>00484             <span class="comment">// 3D case.  Concave-upward curves (smiles) have a positive</span>
<a name="l00485"></a>00485             <span class="comment">// curvature.  Concave-downward curves (frowns) have a</span>
<a name="l00486"></a>00486             <span class="comment">// negative curvature.  Be sure to take that into account!</span>
<a name="l00487"></a>00487             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> numerator   = <a class="code" href="classFEBase.php#a7d557b2fffe299f44ae5ea512aafd23b">d2xyzdxi2_map</a>[p] * <a class="code" href="classFEBase.php#a3b1435ecd16c024da965fe28f5ae15b8">normals</a>[p];
<a name="l00488"></a>00488             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> denominator = <a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>[p].size_sq();
<a name="l00489"></a>00489             libmesh_assert (denominator != 0);
<a name="l00490"></a>00490             <a class="code" href="classFEBase.php#a4bbc232fa21530fc3ec3270ed03edf0a">curvatures</a>[p] = numerator / denominator;
<a name="l00491"></a>00491           }
<a name="l00492"></a>00492         
<a name="l00493"></a>00493         <span class="comment">// compute the jacobian at the quadrature points</span>
<a name="l00494"></a>00494         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00495"></a>00495           {
<a name="l00496"></a>00496             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> jac = <a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>[p].size();
<a name="l00497"></a>00497             
<a name="l00498"></a>00498             libmesh_assert (jac &gt; 0.);
<a name="l00499"></a>00499             
<a name="l00500"></a>00500             <a class="code" href="classFEBase.php#ab12c8cff995327a80e2ec6a76104bb3c">JxW</a>[p] = jac*qw[p];
<a name="l00501"></a>00501           }
<a name="l00502"></a>00502         
<a name="l00503"></a>00503         <span class="comment">// done computing the map</span>
<a name="l00504"></a>00504         <span class="keywordflow">break</span>;
<a name="l00505"></a>00505       }
<a name="l00506"></a>00506 
<a name="l00507"></a>00507 
<a name="l00508"></a>00508       
<a name="l00509"></a>00509     <span class="keywordflow">case</span> 3:
<a name="l00510"></a>00510       {
<a name="l00511"></a>00511         <span class="comment">// A 3D finite element living in 3D space.</span>
<a name="l00512"></a>00512         <span class="comment">// Resize the vectors to hold data at the quadrature points</span>
<a name="l00513"></a>00513         {  
<a name="l00514"></a>00514           <a class="code" href="classFEBase.php#aae6af9098e4135ab3783b1026f411c9b">xyz</a>.resize(n_qp);
<a name="l00515"></a>00515           <a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>.resize(n_qp);
<a name="l00516"></a>00516           <a class="code" href="classFEBase.php#a162874d9f938a7e284a38678d0b50ffd">dxyzdeta_map</a>.resize(n_qp);
<a name="l00517"></a>00517           <a class="code" href="classFEBase.php#a7d557b2fffe299f44ae5ea512aafd23b">d2xyzdxi2_map</a>.resize(n_qp);
<a name="l00518"></a>00518           <a class="code" href="classFEBase.php#a671b095fdbf1ad3226f54e0ac904a0b7">d2xyzdxideta_map</a>.resize(n_qp);
<a name="l00519"></a>00519           <a class="code" href="classFEBase.php#a7f82e4dcf3d6143d88900e5050965a29">d2xyzdeta2_map</a>.resize(n_qp);
<a name="l00520"></a>00520           <a class="code" href="classFEBase.php#a26d01a4ea4a5825a579dbe7dbbda3c45">tangents</a>.resize(n_qp);
<a name="l00521"></a>00521           <a class="code" href="classFEBase.php#a3b1435ecd16c024da965fe28f5ae15b8">normals</a>.resize(n_qp);
<a name="l00522"></a>00522           <a class="code" href="classFEBase.php#a4bbc232fa21530fc3ec3270ed03edf0a">curvatures</a>.resize(n_qp);
<a name="l00523"></a>00523 
<a name="l00524"></a>00524           <a class="code" href="classFEBase.php#ab12c8cff995327a80e2ec6a76104bb3c">JxW</a>.resize(n_qp);
<a name="l00525"></a>00525         }
<a name="l00526"></a>00526     
<a name="l00527"></a>00527         <span class="comment">// Clear the entities that will be summed</span>
<a name="l00528"></a>00528         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00529"></a>00529           {
<a name="l00530"></a>00530             <a class="code" href="classFEBase.php#a26d01a4ea4a5825a579dbe7dbbda3c45">tangents</a>[p].resize(LIBMESH_DIM-1); <span class="comment">// 1 Tangent in 2D, 2 in 3D</span>
<a name="l00531"></a>00531             <a class="code" href="classFEBase.php#aae6af9098e4135ab3783b1026f411c9b">xyz</a>[p].zero();
<a name="l00532"></a>00532             <a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>[p].zero();
<a name="l00533"></a>00533             <a class="code" href="classFEBase.php#a162874d9f938a7e284a38678d0b50ffd">dxyzdeta_map</a>[p].zero();
<a name="l00534"></a>00534             <a class="code" href="classFEBase.php#a7d557b2fffe299f44ae5ea512aafd23b">d2xyzdxi2_map</a>[p].zero();
<a name="l00535"></a>00535             <a class="code" href="classFEBase.php#a671b095fdbf1ad3226f54e0ac904a0b7">d2xyzdxideta_map</a>[p].zero();
<a name="l00536"></a>00536             <a class="code" href="classFEBase.php#a7f82e4dcf3d6143d88900e5050965a29">d2xyzdeta2_map</a>[p].zero();
<a name="l00537"></a>00537           }
<a name="l00538"></a>00538         
<a name="l00539"></a>00539         <span class="comment">// compute x, dxdxi at the quadrature points    </span>
<a name="l00540"></a>00540         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classFEBase.php#a4dd1648378169f9df7be04b8ccccf79b">psi_map</a>.size(); i++) <span class="comment">// sum over the nodes</span>
<a name="l00541"></a>00541           {
<a name="l00542"></a>00542             <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; side_point = side-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(i);
<a name="l00543"></a>00543             
<a name="l00544"></a>00544             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++) <span class="comment">// for each quadrature point...</span>
<a name="l00545"></a>00545               {
<a name="l00546"></a>00546                 <a class="code" href="classFEBase.php#aae6af9098e4135ab3783b1026f411c9b">xyz</a>[p].add_scaled         (side_point, <a class="code" href="classFEBase.php#a4dd1648378169f9df7be04b8ccccf79b">psi_map</a>[i][p]);
<a name="l00547"></a>00547                 <a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>[p].add_scaled (side_point, <a class="code" href="classFEBase.php#ae81262808ef65f058ffde4107a083cb6">dpsidxi_map</a>[i][p]);
<a name="l00548"></a>00548                 <a class="code" href="classFEBase.php#a162874d9f938a7e284a38678d0b50ffd">dxyzdeta_map</a>[p].add_scaled(side_point, <a class="code" href="classFEBase.php#a02d881d240576a85a34ae52f53b51d14">dpsideta_map</a>[i][p]);
<a name="l00549"></a>00549                 <a class="code" href="classFEBase.php#a7d557b2fffe299f44ae5ea512aafd23b">d2xyzdxi2_map</a>[p].add_scaled   (side_point, <a class="code" href="classFEBase.php#aa86ebf823af5a31ff5ae1b6f79a62854">d2psidxi2_map</a>[i][p]);
<a name="l00550"></a>00550                 <a class="code" href="classFEBase.php#a671b095fdbf1ad3226f54e0ac904a0b7">d2xyzdxideta_map</a>[p].add_scaled(side_point, <a class="code" href="classFEBase.php#afaee9565e3e853061b9be24651949f7d">d2psidxideta_map</a>[i][p]);
<a name="l00551"></a>00551                 <a class="code" href="classFEBase.php#a7f82e4dcf3d6143d88900e5050965a29">d2xyzdeta2_map</a>[p].add_scaled  (side_point, <a class="code" href="classFEBase.php#ac25fcbc849c8a91ebf51dbced8d9f4aa">d2psideta2_map</a>[i][p]);
<a name="l00552"></a>00552               }
<a name="l00553"></a>00553           }
<a name="l00554"></a>00554 
<a name="l00555"></a>00555         <span class="comment">// Compute the tangents, normal, and curvature at the quadrature point</span>
<a name="l00556"></a>00556         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00557"></a>00557           {         
<a name="l00558"></a>00558             <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> n  = <a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>[p].cross(<a class="code" href="classFEBase.php#a162874d9f938a7e284a38678d0b50ffd">dxyzdeta_map</a>[p]);
<a name="l00559"></a>00559             <a class="code" href="classFEBase.php#a3b1435ecd16c024da965fe28f5ae15b8">normals</a>[p]     = n.<a class="code" href="classTypeVector.php#a0415bcc1a523ea5f0224a711b14b3532">unit</a>();
<a name="l00560"></a>00560             <a class="code" href="classFEBase.php#a26d01a4ea4a5825a579dbe7dbbda3c45">tangents</a>[p][0] = <a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>[p].unit();
<a name="l00561"></a>00561             <a class="code" href="classFEBase.php#a26d01a4ea4a5825a579dbe7dbbda3c45">tangents</a>[p][1] = n.<a class="code" href="classTypeVector.php#a1347e1223f3e31f8a2c0496736e60dc5">cross</a>(<a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>[p]).unit();
<a name="l00562"></a>00562             
<a name="l00563"></a>00563             <span class="comment">// Compute curvature using the typical nomenclature</span>
<a name="l00564"></a>00564             <span class="comment">// of the first and second fundamental forms.</span>
<a name="l00565"></a>00565             <span class="comment">// For reference, see:</span>
<a name="l00566"></a>00566             <span class="comment">// 1) http://mathworld.wolfram.com/MeanCurvature.html</span>
<a name="l00567"></a>00567             <span class="comment">//    (note -- they are using inward normal)</span>
<a name="l00568"></a>00568             <span class="comment">// 2) F.S. Merritt, Mathematics Manual, 1962, McGraw-Hill</span>
<a name="l00569"></a>00569             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> L  = -<a class="code" href="classFEBase.php#a7d557b2fffe299f44ae5ea512aafd23b">d2xyzdxi2_map</a>[p]    * <a class="code" href="classFEBase.php#a3b1435ecd16c024da965fe28f5ae15b8">normals</a>[p];
<a name="l00570"></a>00570             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> M  = -<a class="code" href="classFEBase.php#a671b095fdbf1ad3226f54e0ac904a0b7">d2xyzdxideta_map</a>[p] * normals[p];
<a name="l00571"></a>00571             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> N  = -<a class="code" href="classFEBase.php#a7f82e4dcf3d6143d88900e5050965a29">d2xyzdeta2_map</a>[p]   * normals[p];
<a name="l00572"></a>00572             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> E  =  <a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>[p].size_sq();
<a name="l00573"></a>00573             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> F  =  <a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>[p]      * <a class="code" href="classFEBase.php#a162874d9f938a7e284a38678d0b50ffd">dxyzdeta_map</a>[p];
<a name="l00574"></a>00574             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> G  =  dxyzdeta_map[p].size_sq();
<a name="l00575"></a>00575             
<a name="l00576"></a>00576             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> numerator   = E*N -2.*F*M + G*L;
<a name="l00577"></a>00577             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> denominator = E*G - F*F;
<a name="l00578"></a>00578             libmesh_assert (denominator != 0.);
<a name="l00579"></a>00579             <a class="code" href="classFEBase.php#a4bbc232fa21530fc3ec3270ed03edf0a">curvatures</a>[p] = 0.5*numerator/denominator;
<a name="l00580"></a>00580           }  
<a name="l00581"></a>00581         
<a name="l00582"></a>00582         <span class="comment">// compute the jacobian at the quadrature points, see</span>
<a name="l00583"></a>00583         <span class="comment">// http://sp81.msi.umn.edu:999/fluent/fidap/help/theory/thtoc.htm</span>
<a name="l00584"></a>00584         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00585"></a>00585           {
<a name="l00586"></a>00586             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> g11 = (<a class="code" href="classFEBase.php#a939316ee014ca629dc6fd45fce5df914">dxdxi_map</a>(p)*<a class="code" href="classFEBase.php#a939316ee014ca629dc6fd45fce5df914">dxdxi_map</a>(p) +
<a name="l00587"></a>00587                               <a class="code" href="classFEBase.php#af83d77ab1b58b72554d95cff1a048ee9">dydxi_map</a>(p)*<a class="code" href="classFEBase.php#af83d77ab1b58b72554d95cff1a048ee9">dydxi_map</a>(p) +
<a name="l00588"></a>00588                               <a class="code" href="classFEBase.php#a7747378042b2cf03c490b39d46e1f2c6">dzdxi_map</a>(p)*<a class="code" href="classFEBase.php#a7747378042b2cf03c490b39d46e1f2c6">dzdxi_map</a>(p));
<a name="l00589"></a>00589             
<a name="l00590"></a>00590             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> g12 = (<a class="code" href="classFEBase.php#a939316ee014ca629dc6fd45fce5df914">dxdxi_map</a>(p)*<a class="code" href="classFEBase.php#a43db73aa5e7f73c6a62ad4bc40535972">dxdeta_map</a>(p) +
<a name="l00591"></a>00591                               <a class="code" href="classFEBase.php#af83d77ab1b58b72554d95cff1a048ee9">dydxi_map</a>(p)*<a class="code" href="classFEBase.php#a17789aaeb8fedae09f9ba0119000225f">dydeta_map</a>(p) +
<a name="l00592"></a>00592                               <a class="code" href="classFEBase.php#a7747378042b2cf03c490b39d46e1f2c6">dzdxi_map</a>(p)*<a class="code" href="classFEBase.php#af4518d3bbcbe64f8052747c0f5999876">dzdeta_map</a>(p));
<a name="l00593"></a>00593             
<a name="l00594"></a>00594             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> g21 = g12;
<a name="l00595"></a>00595             
<a name="l00596"></a>00596             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> g22 = (<a class="code" href="classFEBase.php#a43db73aa5e7f73c6a62ad4bc40535972">dxdeta_map</a>(p)*<a class="code" href="classFEBase.php#a43db73aa5e7f73c6a62ad4bc40535972">dxdeta_map</a>(p) +
<a name="l00597"></a>00597                               <a class="code" href="classFEBase.php#a17789aaeb8fedae09f9ba0119000225f">dydeta_map</a>(p)*<a class="code" href="classFEBase.php#a17789aaeb8fedae09f9ba0119000225f">dydeta_map</a>(p) +
<a name="l00598"></a>00598                               <a class="code" href="classFEBase.php#af4518d3bbcbe64f8052747c0f5999876">dzdeta_map</a>(p)*<a class="code" href="classFEBase.php#af4518d3bbcbe64f8052747c0f5999876">dzdeta_map</a>(p));
<a name="l00599"></a>00599             
<a name="l00600"></a>00600             
<a name="l00601"></a>00601             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> jac = std::sqrt(g11*g22 - g12*g21);
<a name="l00602"></a>00602             
<a name="l00603"></a>00603             libmesh_assert (jac &gt; 0.);
<a name="l00604"></a>00604 
<a name="l00605"></a>00605             <a class="code" href="classFEBase.php#ab12c8cff995327a80e2ec6a76104bb3c">JxW</a>[p] = jac*qw[p];
<a name="l00606"></a>00606           }
<a name="l00607"></a>00607         
<a name="l00608"></a>00608         <span class="comment">// done computing the map</span>
<a name="l00609"></a>00609         <span class="keywordflow">break</span>;
<a name="l00610"></a>00610       }
<a name="l00611"></a>00611 
<a name="l00612"></a>00612 
<a name="l00613"></a>00613     <span class="keywordflow">default</span>:
<a name="l00614"></a>00614       libmesh_error();
<a name="l00615"></a>00615       
<a name="l00616"></a>00616     }
<a name="l00617"></a>00617   STOP_LOG(<span class="stringliteral">&quot;compute_face_map()&quot;</span>, <span class="stringliteral">&quot;FE&quot;</span>);
<a name="l00618"></a>00618 }
<a name="l00619"></a>00619 
<a name="l00620"></a>00620 
<a name="l00621"></a>00621 
<a name="l00622"></a>00622 
<a name="l00623"></a><a class="code" href="classFEBase.php#aaf150f783d70df060b2b218a9c84e122">00623</a> <span class="keywordtype">void</span> <a class="code" href="classFEBase.php#aaf150f783d70df060b2b218a9c84e122">FEBase::compute_edge_map</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; qw,
<a name="l00624"></a>00624                               <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* edge)
<a name="l00625"></a>00625 {
<a name="l00626"></a>00626   libmesh_assert (edge != NULL);
<a name="l00627"></a>00627 
<a name="l00628"></a>00628   <span class="keywordflow">if</span> (<a class="code" href="classFEBase.php#a883023d0114b38abb42d38479459738e">dim</a> == 2)
<a name="l00629"></a>00629     {
<a name="l00630"></a>00630       <span class="comment">// A 2D finite element living in either 2D or 3D space.</span>
<a name="l00631"></a>00631       <span class="comment">// The edges here are the sides of the element, so the</span>
<a name="l00632"></a>00632       <span class="comment">// (misnamed) compute_face_map function does what we want</span>
<a name="l00633"></a>00633       <a class="code" href="classFEBase.php#af47ed992fc087681ed2e0b3587657dad">FEBase::compute_face_map</a>(qw, edge);
<a name="l00634"></a>00634       <span class="keywordflow">return</span>;
<a name="l00635"></a>00635     }
<a name="l00636"></a>00636 
<a name="l00637"></a>00637   libmesh_assert (<a class="code" href="classFEBase.php#a883023d0114b38abb42d38479459738e">dim</a> == 3);  <span class="comment">// 1D is unnecessary and currently unsupported</span>
<a name="l00638"></a>00638 
<a name="l00639"></a>00639   START_LOG(<span class="stringliteral">&quot;compute_edge_map()&quot;</span>, <span class="stringliteral">&quot;FE&quot;</span>);
<a name="l00640"></a>00640 
<a name="l00641"></a>00641   <span class="comment">// The number of quadrature points.</span>
<a name="l00642"></a>00642   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = qw.size();
<a name="l00643"></a>00643   
<a name="l00644"></a>00644   <span class="comment">// Resize the vectors to hold data at the quadrature points</span>
<a name="l00645"></a>00645   <a class="code" href="classFEBase.php#aae6af9098e4135ab3783b1026f411c9b">xyz</a>.resize(n_qp);
<a name="l00646"></a>00646   <a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>.resize(n_qp);
<a name="l00647"></a>00647   <a class="code" href="classFEBase.php#a162874d9f938a7e284a38678d0b50ffd">dxyzdeta_map</a>.resize(n_qp);
<a name="l00648"></a>00648   <a class="code" href="classFEBase.php#a7d557b2fffe299f44ae5ea512aafd23b">d2xyzdxi2_map</a>.resize(n_qp);
<a name="l00649"></a>00649   <a class="code" href="classFEBase.php#a671b095fdbf1ad3226f54e0ac904a0b7">d2xyzdxideta_map</a>.resize(n_qp);
<a name="l00650"></a>00650   <a class="code" href="classFEBase.php#a7f82e4dcf3d6143d88900e5050965a29">d2xyzdeta2_map</a>.resize(n_qp);
<a name="l00651"></a>00651   <a class="code" href="classFEBase.php#a26d01a4ea4a5825a579dbe7dbbda3c45">tangents</a>.resize(n_qp);
<a name="l00652"></a>00652   <a class="code" href="classFEBase.php#a3b1435ecd16c024da965fe28f5ae15b8">normals</a>.resize(n_qp);
<a name="l00653"></a>00653   <a class="code" href="classFEBase.php#a4bbc232fa21530fc3ec3270ed03edf0a">curvatures</a>.resize(n_qp);
<a name="l00654"></a>00654 
<a name="l00655"></a>00655   <a class="code" href="classFEBase.php#ab12c8cff995327a80e2ec6a76104bb3c">JxW</a>.resize(n_qp);
<a name="l00656"></a>00656     
<a name="l00657"></a>00657   <span class="comment">// Clear the entities that will be summed</span>
<a name="l00658"></a>00658   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00659"></a>00659     {
<a name="l00660"></a>00660       <a class="code" href="classFEBase.php#a26d01a4ea4a5825a579dbe7dbbda3c45">tangents</a>[p].resize(1);
<a name="l00661"></a>00661       <a class="code" href="classFEBase.php#aae6af9098e4135ab3783b1026f411c9b">xyz</a>[p].zero();
<a name="l00662"></a>00662       <a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>[p].zero();
<a name="l00663"></a>00663       <a class="code" href="classFEBase.php#a162874d9f938a7e284a38678d0b50ffd">dxyzdeta_map</a>[p].zero();
<a name="l00664"></a>00664       <a class="code" href="classFEBase.php#a7d557b2fffe299f44ae5ea512aafd23b">d2xyzdxi2_map</a>[p].zero();
<a name="l00665"></a>00665       <a class="code" href="classFEBase.php#a671b095fdbf1ad3226f54e0ac904a0b7">d2xyzdxideta_map</a>[p].zero();
<a name="l00666"></a>00666       <a class="code" href="classFEBase.php#a7f82e4dcf3d6143d88900e5050965a29">d2xyzdeta2_map</a>[p].zero();
<a name="l00667"></a>00667     }
<a name="l00668"></a>00668 
<a name="l00669"></a>00669   <span class="comment">// compute x, dxdxi at the quadrature points    </span>
<a name="l00670"></a>00670   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classFEBase.php#a4dd1648378169f9df7be04b8ccccf79b">psi_map</a>.size(); i++) <span class="comment">// sum over the nodes</span>
<a name="l00671"></a>00671     {
<a name="l00672"></a>00672       <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; edge_point = edge-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(i);
<a name="l00673"></a>00673       
<a name="l00674"></a>00674       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++) <span class="comment">// for each quadrature point...</span>
<a name="l00675"></a>00675         {
<a name="l00676"></a>00676           <a class="code" href="classFEBase.php#aae6af9098e4135ab3783b1026f411c9b">xyz</a>[p].add_scaled             (edge_point, <a class="code" href="classFEBase.php#a4dd1648378169f9df7be04b8ccccf79b">psi_map</a>[i][p]);
<a name="l00677"></a>00677           <a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>[p].add_scaled     (edge_point, <a class="code" href="classFEBase.php#ae81262808ef65f058ffde4107a083cb6">dpsidxi_map</a>[i][p]);
<a name="l00678"></a>00678           <a class="code" href="classFEBase.php#a7d557b2fffe299f44ae5ea512aafd23b">d2xyzdxi2_map</a>[p].add_scaled   (edge_point, <a class="code" href="classFEBase.php#aa86ebf823af5a31ff5ae1b6f79a62854">d2psidxi2_map</a>[i][p]);
<a name="l00679"></a>00679         }
<a name="l00680"></a>00680     }
<a name="l00681"></a>00681 
<a name="l00682"></a>00682   <span class="comment">// Compute the tangents at the quadrature point</span>
<a name="l00683"></a>00683   <span class="comment">// FIXME: normals (plural!) and curvatures are uncalculated</span>
<a name="l00684"></a>00684   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00685"></a>00685     {    
<a name="l00686"></a>00686       <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> n  = <a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>[p].cross(<a class="code" href="classFEBase.php#a162874d9f938a7e284a38678d0b50ffd">dxyzdeta_map</a>[p]);
<a name="l00687"></a>00687       <a class="code" href="classFEBase.php#a26d01a4ea4a5825a579dbe7dbbda3c45">tangents</a>[p][0] = <a class="code" href="classFEBase.php#a2b4d1b03c19fa3b525e1c4f7e08441c6">dxyzdxi_map</a>[p].unit();
<a name="l00688"></a>00688 
<a name="l00689"></a>00689       <span class="comment">// compute the jacobian at the quadrature points</span>
<a name="l00690"></a>00690       <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> jac = std::sqrt(<a class="code" href="classFEBase.php#a939316ee014ca629dc6fd45fce5df914">dxdxi_map</a>(p)*<a class="code" href="classFEBase.php#a939316ee014ca629dc6fd45fce5df914">dxdxi_map</a>(p) +
<a name="l00691"></a>00691                                  <a class="code" href="classFEBase.php#af83d77ab1b58b72554d95cff1a048ee9">dydxi_map</a>(p)*<a class="code" href="classFEBase.php#af83d77ab1b58b72554d95cff1a048ee9">dydxi_map</a>(p) +
<a name="l00692"></a>00692                                  <a class="code" href="classFEBase.php#a7747378042b2cf03c490b39d46e1f2c6">dzdxi_map</a>(p)*<a class="code" href="classFEBase.php#a7747378042b2cf03c490b39d46e1f2c6">dzdxi_map</a>(p));
<a name="l00693"></a>00693             
<a name="l00694"></a>00694       libmesh_assert (jac &gt; 0.);
<a name="l00695"></a>00695 
<a name="l00696"></a>00696       <a class="code" href="classFEBase.php#ab12c8cff995327a80e2ec6a76104bb3c">JxW</a>[p] = jac*qw[p];
<a name="l00697"></a>00697     }
<a name="l00698"></a>00698 
<a name="l00699"></a>00699   STOP_LOG(<span class="stringliteral">&quot;compute_edge_map()&quot;</span>, <span class="stringliteral">&quot;FE&quot;</span>);
<a name="l00700"></a>00700 }
<a name="l00701"></a>00701 
<a name="l00702"></a>00702 
<a name="l00703"></a>00703 
<a name="l00704"></a>00704 
<a name="l00705"></a>00705 <span class="comment">//--------------------------------------------------------------</span>
<a name="l00706"></a>00706 <span class="comment">// Explicit instantiations</span>
<a name="l00707"></a>00707 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;1,LAGRANGE&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00708"></a>00708 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;1,HIERARCHIC&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00709"></a>00709 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;1,CLOUGH&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00710"></a>00710 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;1,HERMITE&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00711"></a>00711 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;1,MONOMIAL&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00712"></a>00712 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;1,SCALAR&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00713"></a>00713 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00714"></a>00714 <span class="preprocessor"></span><span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;1,BERNSTEIN&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00715"></a>00715 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;1,SZABAB&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00716"></a>00716 <span class="preprocessor">#endif</span>
<a name="l00717"></a>00717 <span class="preprocessor"></span><span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;1,XYZ&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00718"></a>00718 
<a name="l00719"></a>00719 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;2,LAGRANGE&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00720"></a>00720 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#adb74f797c07e54b20b437fa105d21929">FE&lt;2,LAGRANGE&gt;::edge_reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00721"></a>00721 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;2,HIERARCHIC&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00722"></a>00722 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#adb74f797c07e54b20b437fa105d21929">FE&lt;2,HIERARCHIC&gt;::edge_reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00723"></a>00723 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;2,CLOUGH&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00724"></a>00724 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#adb74f797c07e54b20b437fa105d21929">FE&lt;2,CLOUGH&gt;::edge_reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00725"></a>00725 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;2,HERMITE&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00726"></a>00726 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#adb74f797c07e54b20b437fa105d21929">FE&lt;2,HERMITE&gt;::edge_reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00727"></a>00727 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;2,MONOMIAL&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00728"></a>00728 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#adb74f797c07e54b20b437fa105d21929">FE&lt;2,MONOMIAL&gt;::edge_reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00729"></a>00729 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;2,SCALAR&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00730"></a>00730 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#adb74f797c07e54b20b437fa105d21929">FE&lt;2,SCALAR&gt;::edge_reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00731"></a>00731 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00732"></a>00732 <span class="preprocessor"></span><span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;2,BERNSTEIN&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00733"></a>00733 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#adb74f797c07e54b20b437fa105d21929">FE&lt;2,BERNSTEIN&gt;::edge_reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00734"></a>00734 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;2,SZABAB&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00735"></a>00735 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#adb74f797c07e54b20b437fa105d21929">FE&lt;2,SZABAB&gt;::edge_reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00736"></a>00736 <span class="preprocessor">#endif</span>
<a name="l00737"></a>00737 <span class="preprocessor"></span><span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;2,XYZ&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00738"></a>00738 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#adb74f797c07e54b20b437fa105d21929">FE&lt;2,XYZ&gt;::edge_reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00739"></a>00739 
<a name="l00740"></a>00740 <span class="comment">// Intel 9.1 complained it needed this in devel mode.</span>
<a name="l00741"></a>00741 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a2ecff327bbb449b07bb2a1d28756fc30">FE&lt;2,XYZ&gt;::init_face_shape_functions</a>(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp;, <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*);
<a name="l00742"></a>00742 
<a name="l00743"></a>00743 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;3,LAGRANGE&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00744"></a>00744 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#adb74f797c07e54b20b437fa105d21929">FE&lt;3,LAGRANGE&gt;::edge_reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00745"></a>00745 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;3,HIERARCHIC&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00746"></a>00746 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#adb74f797c07e54b20b437fa105d21929">FE&lt;3,HIERARCHIC&gt;::edge_reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00747"></a>00747 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;3,CLOUGH&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00748"></a>00748 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#adb74f797c07e54b20b437fa105d21929">FE&lt;3,CLOUGH&gt;::edge_reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00749"></a>00749 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;3,HERMITE&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00750"></a>00750 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#adb74f797c07e54b20b437fa105d21929">FE&lt;3,HERMITE&gt;::edge_reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00751"></a>00751 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;3,MONOMIAL&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00752"></a>00752 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#adb74f797c07e54b20b437fa105d21929">FE&lt;3,MONOMIAL&gt;::edge_reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00753"></a>00753 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;3,SCALAR&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00754"></a>00754 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#adb74f797c07e54b20b437fa105d21929">FE&lt;3,SCALAR&gt;::edge_reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00755"></a>00755 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00756"></a>00756 <span class="preprocessor"></span><span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;3,BERNSTEIN&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00757"></a>00757 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#adb74f797c07e54b20b437fa105d21929">FE&lt;3,BERNSTEIN&gt;::edge_reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00758"></a>00758 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;3,SZABAB&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00759"></a>00759 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#adb74f797c07e54b20b437fa105d21929">FE&lt;3,SZABAB&gt;::edge_reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00760"></a>00760 <span class="preprocessor">#endif</span>
<a name="l00761"></a>00761 <span class="preprocessor"></span><span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a6db14cf636db033ec5be32399464abcf">FE&lt;3,XYZ&gt;::reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00762"></a>00762 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#adb74f797c07e54b20b437fa105d21929">FE&lt;3,XYZ&gt;::edge_reinit</a>(<a class="code" href="classElem.php">Elem</a> <span class="keyword">const</span>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00763"></a>00763 
<a name="l00764"></a>00764 <span class="comment">// Intel 9.1 complained it needed this in devel mode.</span>
<a name="l00765"></a>00765 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classFE.php#a2ecff327bbb449b07bb2a1d28756fc30">FE&lt;3,XYZ&gt;::init_face_shape_functions</a>(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp;, <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*);
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
