<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_a0136eca6b184c0d854bbc4a8414e31c.php">fe</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>fe_compute_data.C</h1>  </div>
</div>
<div class="contents">
<a href="fe__compute__data_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_compute_data.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;fe_compute_data.h&quot;</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;equation_systems.h&quot;</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 
<a name="l00025"></a><a class="code" href="classFEComputeData.php#a9c726696fdc2aef030efdcdc2f74fd79">00025</a> <span class="keywordtype">void</span> <a class="code" href="classFEComputeData.php#a9c726696fdc2aef030efdcdc2f74fd79">FEComputeData::clear</a> () 
<a name="l00026"></a>00026 { 
<a name="l00027"></a>00027   this-&gt;<a class="code" href="classFEComputeData.php#ae9bf9a37c12e74af8a28cebb10e5610b">shape</a>.clear();
<a name="l00028"></a>00028 <span class="preprocessor">#if defined(LIBMESH_ENABLE_INFINITE_ELEMENTS) &amp;&amp; !defined(LIBMESH_USE_COMPLEX_NUMBERS)</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>  this-&gt;<a class="code" href="classFEComputeData.php#ac0210c897e0014b4e773c20f0c29bd35">phase</a> = 0.;
<a name="l00030"></a>00030   this-&gt;<a class="code" href="classFEComputeData.php#ab13505cb1aaaa59f084e87fd8026045d">speed</a> = 0.;
<a name="l00031"></a>00031 <span class="preprocessor">#endif</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>
<a name="l00033"></a>00033 <span class="preprocessor">#if defined (LIBMESH_ENABLE_INFINITE_ELEMENTS) &amp;&amp; defined(LIBMESH_USE_COMPLEX_NUMBERS)</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span>  this-&gt;<a class="code" href="classFEComputeData.php#ab13505cb1aaaa59f084e87fd8026045d">speed</a> = 0.;
<a name="l00035"></a>00035   this-&gt;<a class="code" href="classFEComputeData.php#aee90bcba8783f2a506e899fdf675b7d8">frequency</a> = 0.;
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="preprocessor">#endif</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span>}
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a><a class="code" href="classFEComputeData.php#a2766da5c11ee60472b6f39dc177b2229">00042</a> <span class="keywordtype">void</span> <a class="code" href="classFEComputeData.php#a2766da5c11ee60472b6f39dc177b2229">FEComputeData::init</a> () 
<a name="l00043"></a>00043 { 
<a name="l00044"></a>00044   <span class="keywordflow">if</span> (!(this-&gt;<a class="code" href="classFEComputeData.php#ae9bf9a37c12e74af8a28cebb10e5610b">shape</a>.empty()))
<a name="l00045"></a>00045     std::fill (this-&gt;<a class="code" href="classFEComputeData.php#ae9bf9a37c12e74af8a28cebb10e5610b">shape</a>.begin(),   this-&gt;<a class="code" href="classFEComputeData.php#ae9bf9a37c12e74af8a28cebb10e5610b">shape</a>.end(),   0.);
<a name="l00046"></a>00046   
<a name="l00047"></a>00047 <span class="preprocessor">#if defined(LIBMESH_ENABLE_INFINITE_ELEMENTS) &amp;&amp; !defined(LIBMESH_USE_COMPLEX_NUMBERS)</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span>  this-&gt;<a class="code" href="classFEComputeData.php#ac0210c897e0014b4e773c20f0c29bd35">phase</a> = 0.;
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   <span class="keywordflow">if</span> (<a class="code" href="classFEComputeData.php#ac2351a92cdb8dacc8cfaad2e4a17f42d">equation_systems</a>.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a20587dd7120a79624ebc7095aea0390c">have_parameter</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;speed&quot;</span>))
<a name="l00051"></a>00051     this-&gt;<a class="code" href="classFEComputeData.php#ab13505cb1aaaa59f084e87fd8026045d">speed</a> = this-&gt;<a class="code" href="classFEComputeData.php#ac2351a92cdb8dacc8cfaad2e4a17f42d">equation_systems</a>.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#ac4c5e3f411568e6defcdd2ace5829d96">get</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;speed&quot;</span>);
<a name="l00052"></a>00052 <span class="preprocessor">#endif</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span>
<a name="l00054"></a>00054 <span class="preprocessor">#if defined (LIBMESH_ENABLE_INFINITE_ELEMENTS) &amp;&amp; defined(LIBMESH_USE_COMPLEX_NUMBERS)</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (<a class="code" href="classFEComputeData.php#ac2351a92cdb8dacc8cfaad2e4a17f42d">equation_systems</a>.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a20587dd7120a79624ebc7095aea0390c">have_parameter</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;speed&quot;</span>))
<a name="l00056"></a>00056     this-&gt;<a class="code" href="classFEComputeData.php#ab13505cb1aaaa59f084e87fd8026045d">speed</a> = this-&gt;<a class="code" href="classFEComputeData.php#ac2351a92cdb8dacc8cfaad2e4a17f42d">equation_systems</a>.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#ac4c5e3f411568e6defcdd2ace5829d96">get</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;speed&quot;</span>);
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <span class="keywordflow">if</span> (<a class="code" href="classFEComputeData.php#ac2351a92cdb8dacc8cfaad2e4a17f42d">equation_systems</a>.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a20587dd7120a79624ebc7095aea0390c">have_parameter</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;current frequency&quot;</span>))  
<a name="l00059"></a>00059     this-&gt;<a class="code" href="classFEComputeData.php#aee90bcba8783f2a506e899fdf675b7d8">frequency</a> = this-&gt;<a class="code" href="classFEComputeData.php#ac2351a92cdb8dacc8cfaad2e4a17f42d">equation_systems</a>.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#ac4c5e3f411568e6defcdd2ace5829d96">get</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;current frequency&quot;</span>);
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 <span class="preprocessor">#endif</span>
<a name="l00062"></a>00062 <span class="preprocessor"></span>}
<a name="l00063"></a>00063 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
