<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f00dea3e7b839559ab8b1786e03603be.php">fe</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>fe_compute_data.h</h1>  </div>
</div>
<div class="contents">
<a href="fe__compute__data_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_compute_data.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __fe_compute_data_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __fe_compute_data_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// C++ includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh.h&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Forward declarations</span>
<a name="l00032"></a>00032 <span class="keyword">class </span><a class="code" href="classEquationSystems.php">EquationSystems</a>;
<a name="l00033"></a>00033 <span class="keyword">class </span><a class="code" href="classPoint.php">Point</a>;
<a name="l00034"></a>00034 
<a name="l00046"></a><a class="code" href="classFEComputeData.php">00046</a> <span class="keyword">class </span><a class="code" href="classFEComputeData.php">FEComputeData</a>
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048 <span class="keyword">public</span>:
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 <span class="comment">//------------------------------------------------------</span>
<a name="l00052"></a>00052 <span class="comment">// Conventional FEComputeData</span>
<a name="l00057"></a><a class="code" href="classFEComputeData.php#a8aca52ced083efa116ef8fa74d3fb7ea">00057</a> <span class="comment"></span>  <a class="code" href="classFEComputeData.php#a8aca52ced083efa116ef8fa74d3fb7ea">FEComputeData</a> (<span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00058"></a>00058                  <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; pin) :
<a name="l00059"></a>00059     <a class="code" href="classFEComputeData.php#ac2351a92cdb8dacc8cfaad2e4a17f42d">equation_systems</a>(es),
<a name="l00060"></a>00060     <a class="code" href="classFEComputeData.php#a7bf9026e9cb744cc23354c50d5e9658d">p</a>(pin)
<a name="l00061"></a>00061   { 
<a name="l00062"></a>00062     this-&gt;<a class="code" href="classFEComputeData.php#a9c726696fdc2aef030efdcdc2f74fd79">clear</a>(); 
<a name="l00063"></a>00063   }
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 
<a name="l00066"></a>00066   <span class="comment">//----------------------------------------------------</span>
<a name="l00067"></a>00067   <span class="comment">// Input data</span>
<a name="l00072"></a><a class="code" href="classFEComputeData.php#ac2351a92cdb8dacc8cfaad2e4a17f42d">00072</a> <span class="comment"></span>  <span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; <a class="code" href="classFEComputeData.php#ac2351a92cdb8dacc8cfaad2e4a17f42d">equation_systems</a>;
<a name="l00076"></a><a class="code" href="classFEComputeData.php#a7bf9026e9cb744cc23354c50d5e9658d">00076</a>   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; <a class="code" href="classFEComputeData.php#a7bf9026e9cb744cc23354c50d5e9658d">p</a>;
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   <span class="comment">//----------------------------------------------------</span>
<a name="l00081"></a>00081   <span class="comment">// Output data</span>
<a name="l00085"></a><a class="code" href="classFEComputeData.php#ae9bf9a37c12e74af8a28cebb10e5610b">00085</a> <span class="comment"></span>  std::vector&lt;Number&gt; <a class="code" href="classFEComputeData.php#ae9bf9a37c12e74af8a28cebb10e5610b">shape</a>;
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 <span class="preprocessor">#if defined(LIBMESH_ENABLE_INFINITE_ELEMENTS) &amp;&amp; !defined(LIBMESH_USE_COMPLEX_NUMBERS)</span>
<a name="l00089"></a>00089 <span class="preprocessor"></span>
<a name="l00092"></a><a class="code" href="classFEComputeData.php#ac0210c897e0014b4e773c20f0c29bd35">00092</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFEComputeData.php#ac0210c897e0014b4e773c20f0c29bd35">phase</a>;
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 <span class="preprocessor">#endif</span>
<a name="l00095"></a>00095 <span class="preprocessor"></span>
<a name="l00096"></a>00096 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00097"></a>00097 <span class="preprocessor"></span>
<a name="l00100"></a><a class="code" href="classFEComputeData.php#ab13505cb1aaaa59f084e87fd8026045d">00100</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFEComputeData.php#ab13505cb1aaaa59f084e87fd8026045d">speed</a>;
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 <span class="preprocessor">#endif</span>
<a name="l00103"></a>00103 <span class="preprocessor"></span>
<a name="l00104"></a>00104 <span class="preprocessor">#if defined LIBMESH_ENABLE_INFINITE_ELEMENTS &amp;&amp; defined(LIBMESH_USE_COMPLEX_NUMBERS)</span>
<a name="l00105"></a>00105 <span class="preprocessor"></span>
<a name="l00109"></a><a class="code" href="classFEComputeData.php#aee90bcba8783f2a506e899fdf675b7d8">00109</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFEComputeData.php#aee90bcba8783f2a506e899fdf675b7d8">frequency</a>;
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 <span class="preprocessor">#endif</span>
<a name="l00112"></a>00112 <span class="preprocessor"></span>
<a name="l00116"></a>00116   <span class="keywordtype">void</span> <a class="code" href="classFEComputeData.php#a9c726696fdc2aef030efdcdc2f74fd79">clear</a> () ;
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00123"></a>00123   <span class="keywordtype">void</span> <a class="code" href="classFEComputeData.php#a2766da5c11ee60472b6f39dc177b2229">init</a> () ;
<a name="l00124"></a>00124 };
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 <span class="preprocessor">#endif // #ifndef __fe_compute_data_h__</span>
<a name="l00128"></a>00128 <span class="preprocessor"></span>
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
