<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_a0136eca6b184c0d854bbc4a8414e31c.php">fe</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>fe_hierarchic_shape_2D.C</h1>  </div>
</div>
<div class="contents">
<a href="fe__hierarchic__shape__2D_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_hierarchic_shape_2D.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;fe.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;number_lookups.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;utility.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">template</span> &lt;&gt;
<a name="l00031"></a><a class="code" href="classFE.php#a0899c3373351a6ba5aba7e1f08e2255e">00031</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">FE&lt;2,HIERARCHIC&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00032"></a>00032                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,
<a name="l00033"></a>00033                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00034"></a>00034                              <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp;)
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036   std::cerr &lt;&lt; <span class="stringliteral">&quot;Hierarchic polynomials require the element type\n&quot;</span>
<a name="l00037"></a>00037             &lt;&lt; <span class="stringliteral">&quot;because edge orientation is needed.&quot;</span>
<a name="l00038"></a>00038             &lt;&lt; std::endl;
<a name="l00039"></a>00039   
<a name="l00040"></a>00040   libmesh_error();
<a name="l00041"></a>00041   <span class="keywordflow">return</span> 0.;
<a name="l00042"></a>00042 }
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="keyword">template</span> &lt;&gt;
<a name="l00047"></a><a class="code" href="classFE.php#aae1e47bad4e8e9b628d21086888ea08d">00047</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">FE&lt;2,HIERARCHIC&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00048"></a>00048                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00049"></a>00049                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00050"></a>00050                              <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p)
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052   libmesh_assert (elem != NULL);
<a name="l00053"></a>00053 
<a name="l00054"></a>00054   <span class="comment">// Declare that we are using our own special power function</span>
<a name="l00055"></a>00055   <span class="comment">// from the Utility namespace.  This saves typing later.</span>
<a name="l00056"></a>00056   <span class="keyword">using</span> <a class="code" href="namespaceUtility.php#aa31a2ff44b735ae86eea0446796a3b42">Utility::pow</a>;
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> totalorder = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order+elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>());
<a name="l00059"></a>00059   libmesh_assert(totalorder &gt; 0);
<a name="l00060"></a>00060   
<a name="l00061"></a>00061   <span class="keywordflow">switch</span> (elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>())
<a name="l00062"></a>00062     {      
<a name="l00063"></a>00063     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00064"></a>00064     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00065"></a>00065       {
<a name="l00066"></a>00066         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> zeta1 = p(0);
<a name="l00067"></a>00067         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> zeta2 = p(1);
<a name="l00068"></a>00068         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> zeta0 = 1. - zeta1 - zeta2;
<a name="l00069"></a>00069               
<a name="l00070"></a>00070         libmesh_assert (i&lt;(totalorder+1u)*(totalorder+2u)/2);
<a name="l00071"></a>00071         libmesh_assert (elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a> || totalorder &lt; 2);
<a name="l00072"></a>00072 
<a name="l00073"></a>00073         <span class="comment">// Vertex DoFs</span>
<a name="l00074"></a>00074         <span class="keywordflow">if</span> (i == 0)
<a name="l00075"></a>00075           <span class="keywordflow">return</span> zeta0;
<a name="l00076"></a>00076         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i == 1)
<a name="l00077"></a>00077           <span class="keywordflow">return</span> zeta1;
<a name="l00078"></a>00078         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i == 2)
<a name="l00079"></a>00079           <span class="keywordflow">return</span> zeta2;
<a name="l00080"></a>00080         <span class="comment">// Edge DoFs</span>
<a name="l00081"></a>00081         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; totalorder + 2u)
<a name="l00082"></a>00082           {
<a name="l00083"></a>00083             <span class="comment">// Avoid returning NaN on vertices!</span>
<a name="l00084"></a>00084             <span class="keywordflow">if</span> (zeta0 + zeta1 == 0.)
<a name="l00085"></a>00085               <span class="keywordflow">return</span> 0.;
<a name="l00086"></a>00086 
<a name="l00087"></a>00087             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basisorder = i - 1;
<a name="l00088"></a>00088             <span class="comment">// Get factors to account for edge-flipping</span>
<a name="l00089"></a>00089             <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> f0 = 1;
<a name="l00090"></a>00090             <span class="keywordflow">if</span> (basisorder%2 &amp;&amp; (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0) &gt; elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1)))
<a name="l00091"></a>00091               f0 = -1.;
<a name="l00092"></a>00092               
<a name="l00093"></a>00093             <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> edgeval = (zeta1 - zeta0) / (zeta1 + zeta0);
<a name="l00094"></a>00094             <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> crossfunc = zeta0 + zeta1;
<a name="l00095"></a>00095             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=1; n != basisorder; ++n)
<a name="l00096"></a>00096               crossfunc *= (zeta0 + zeta1);
<a name="l00097"></a>00097 
<a name="l00098"></a>00098             <span class="keywordflow">return</span> f0 * crossfunc *
<a name="l00099"></a>00099                    <a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">FE&lt;1,HIERARCHIC&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder,
<a name="l00100"></a>00100                                            basisorder, edgeval);
<a name="l00101"></a>00101           }
<a name="l00102"></a>00102         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 2u*totalorder + 1)
<a name="l00103"></a>00103           {
<a name="l00104"></a>00104             <span class="comment">// Avoid returning NaN on vertices!</span>
<a name="l00105"></a>00105             <span class="keywordflow">if</span> (zeta1 + zeta2 == 0.)
<a name="l00106"></a>00106               <span class="keywordflow">return</span> 0.;
<a name="l00107"></a>00107 
<a name="l00108"></a>00108             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basisorder = i - totalorder;
<a name="l00109"></a>00109             <span class="comment">// Get factors to account for edge-flipping</span>
<a name="l00110"></a>00110             <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> f1 = 1;
<a name="l00111"></a>00111             <span class="keywordflow">if</span> (basisorder%2 &amp;&amp; (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1) &gt; elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2)))
<a name="l00112"></a>00112               f1 = -1.;
<a name="l00113"></a>00113               
<a name="l00114"></a>00114             <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> edgeval = (zeta2 - zeta1) / (zeta2 + zeta1);
<a name="l00115"></a>00115             <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> crossfunc = zeta2 + zeta1;
<a name="l00116"></a>00116             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=1; n != basisorder; ++n)
<a name="l00117"></a>00117               crossfunc *= (zeta2 + zeta1);
<a name="l00118"></a>00118 
<a name="l00119"></a>00119             <span class="keywordflow">return</span> f1 * crossfunc *
<a name="l00120"></a>00120                    <a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">FE&lt;1,HIERARCHIC&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder,
<a name="l00121"></a>00121                                            basisorder, edgeval);
<a name="l00122"></a>00122           }
<a name="l00123"></a>00123         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 3u*totalorder)
<a name="l00124"></a>00124           {
<a name="l00125"></a>00125             <span class="comment">// Avoid returning NaN on vertices!</span>
<a name="l00126"></a>00126             <span class="keywordflow">if</span> (zeta0 + zeta2 == 0.)
<a name="l00127"></a>00127               <span class="keywordflow">return</span> 0.;
<a name="l00128"></a>00128 
<a name="l00129"></a>00129             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basisorder = i - (2u*totalorder) + 1;
<a name="l00130"></a>00130             <span class="comment">// Get factors to account for edge-flipping</span>
<a name="l00131"></a>00131             <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> f2 = 1;
<a name="l00132"></a>00132             <span class="keywordflow">if</span> (basisorder%2 &amp;&amp; (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2) &gt; elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0)))
<a name="l00133"></a>00133               f2 = -1.;
<a name="l00134"></a>00134 
<a name="l00135"></a>00135             <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> edgeval = (zeta0 - zeta2) / (zeta0 + zeta2);
<a name="l00136"></a>00136             <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> crossfunc = zeta0 + zeta2;
<a name="l00137"></a>00137             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=1; n != basisorder; ++n)
<a name="l00138"></a>00138               crossfunc *= (zeta0 + zeta2);
<a name="l00139"></a>00139 
<a name="l00140"></a>00140             <span class="keywordflow">return</span> f2 * crossfunc *
<a name="l00141"></a>00141                    <a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">FE&lt;1,HIERARCHIC&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder,
<a name="l00142"></a>00142                                            basisorder, edgeval);
<a name="l00143"></a>00143           }
<a name="l00144"></a>00144         <span class="comment">// Interior DoFs</span>
<a name="l00145"></a>00145         <span class="keywordflow">else</span>
<a name="l00146"></a>00146           {
<a name="l00147"></a>00147             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basisnum = i - (3u*totalorder);
<a name="l00148"></a>00148             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> exp0 = <a class="code" href="number__lookups_8C.php#a762466a1d342831aee99a130c9145b77">triangular_number_column</a>[basisnum] + 1;
<a name="l00149"></a>00149             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> exp1 = <a class="code" href="number__lookups_8C.php#ad66b5918856e4d66a56778d8f259a1b4">triangular_number_row</a>[basisnum] + 1 -
<a name="l00150"></a>00150                                 <a class="code" href="number__lookups_8C.php#a762466a1d342831aee99a130c9145b77">triangular_number_column</a>[basisnum];
<a name="l00151"></a>00151 
<a name="l00152"></a>00152             <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> returnval = 1;
<a name="l00153"></a>00153             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = 0; n != exp0; ++n)
<a name="l00154"></a>00154               returnval *= zeta0;
<a name="l00155"></a>00155             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = 0; n != exp1; ++n)
<a name="l00156"></a>00156               returnval *= zeta1;
<a name="l00157"></a>00157             returnval *= zeta2;
<a name="l00158"></a>00158             <span class="keywordflow">return</span> returnval;
<a name="l00159"></a>00159           }
<a name="l00160"></a>00160       }
<a name="l00161"></a>00161 
<a name="l00162"></a>00162     <span class="comment">// Hierarchic shape functions on the quadrilateral.</span>
<a name="l00163"></a>00163     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l00164"></a>00164       libmesh_assert (totalorder &lt; 2);
<a name="l00165"></a>00165     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00166"></a>00166     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00167"></a>00167       {
<a name="l00168"></a>00168         <span class="comment">// Compute quad shape functions as a tensor-product</span>
<a name="l00169"></a>00169         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xi  = p(0);
<a name="l00170"></a>00170         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> eta = p(1);
<a name="l00171"></a>00171       
<a name="l00172"></a>00172         libmesh_assert (i &lt; (totalorder+1u)*(totalorder+1u));
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 <span class="comment">// Example i, i0, i1 values for totalorder = 5:</span>
<a name="l00175"></a>00175 <span class="comment">//                                    0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35</span>
<a name="l00176"></a>00176 <span class="comment">//  static const unsigned int i0[] = {0, 1, 1, 0, 2, 3, 4, 5, 1, 1, 1, 1, 2, 3, 4, 5, 0, 0, 0, 0, 2, 3, 3, 2, 4, 4, 4, 3, 2, 5, 5, 5, 5, 4, 3, 2};</span>
<a name="l00177"></a>00177 <span class="comment">//  static const unsigned int i1[] = {0, 0, 1, 1, 0, 0, 0, 0, 2, 3, 4, 5, 1, 1, 1, 1, 2, 3, 4, 5, 2, 2, 3, 3, 2, 3, 4, 4, 4, 2, 3, 4, 5, 5, 5, 5};</span>
<a name="l00178"></a>00178               
<a name="l00179"></a>00179         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i0, i1;
<a name="l00180"></a>00180 
<a name="l00181"></a>00181         <span class="comment">// Vertex DoFs</span>
<a name="l00182"></a>00182         <span class="keywordflow">if</span> (i == 0)
<a name="l00183"></a>00183           { i0 = 0; i1 = 0; }
<a name="l00184"></a>00184         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i == 1)
<a name="l00185"></a>00185           { i0 = 1; i1 = 0; }
<a name="l00186"></a>00186         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i == 2)
<a name="l00187"></a>00187           { i0 = 1; i1 = 1; }
<a name="l00188"></a>00188         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i == 3)
<a name="l00189"></a>00189           { i0 = 0; i1 = 1; }
<a name="l00190"></a>00190         <span class="comment">// Edge DoFs</span>
<a name="l00191"></a>00191         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; totalorder + 3u)
<a name="l00192"></a>00192           { i0 = i - 2; i1 = 0; }
<a name="l00193"></a>00193         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 2u*totalorder + 2)
<a name="l00194"></a>00194           { i0 = 1; i1 = i - totalorder - 1; }
<a name="l00195"></a>00195         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 3u*totalorder + 1)
<a name="l00196"></a>00196           { i0 = i - 2u*totalorder; i1 = 1; }
<a name="l00197"></a>00197         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 4u*totalorder)
<a name="l00198"></a>00198           { i0 = 0; i1 = i - 3u*totalorder + 1; }
<a name="l00199"></a>00199         <span class="comment">// Interior DoFs</span>
<a name="l00200"></a>00200         <span class="keywordflow">else</span>
<a name="l00201"></a>00201           {
<a name="l00202"></a>00202             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basisnum = i - 4*totalorder;
<a name="l00203"></a>00203             i0 = <a class="code" href="number__lookups_8C.php#a8f3c09eca07801e0ff9eb08f48af8e74">square_number_column</a>[basisnum] + 2;
<a name="l00204"></a>00204             i1 = <a class="code" href="number__lookups_8C.php#a607440daec332e28892bdc860dce25b6">square_number_row</a>[basisnum] + 2;
<a name="l00205"></a>00205           }
<a name="l00206"></a>00206 
<a name="l00207"></a>00207         <span class="comment">// Flip odd degree of freedom values if necessary</span>
<a name="l00208"></a>00208         <span class="comment">// to keep continuity on sides</span>
<a name="l00209"></a>00209         <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> f = 1.;
<a name="l00210"></a>00210 
<a name="l00211"></a>00211         <span class="keywordflow">if</span> ((i0%2) &amp;&amp; (i0 &gt; 2) &amp;&amp; (i1 == 0))
<a name="l00212"></a>00212           f = (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0) &gt; elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1))?-1.:1.;
<a name="l00213"></a>00213         <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0%2) &amp;&amp; (i0&gt;2) &amp;&amp; (i1 == 1))
<a name="l00214"></a>00214           f = (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3) &gt; elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2))?-1.:1.;
<a name="l00215"></a>00215         <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0 == 0) &amp;&amp; (i1%2) &amp;&amp; (i1&gt;2))
<a name="l00216"></a>00216           f = (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0) &gt; elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3))?-1.:1.;
<a name="l00217"></a>00217         <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0 == 1) &amp;&amp; (i1%2) &amp;&amp; (i1&gt;2))
<a name="l00218"></a>00218           f = (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1) &gt; elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2))?-1.:1.;
<a name="l00219"></a>00219               
<a name="l00220"></a>00220         <span class="keywordflow">return</span> f*(<a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">FE&lt;1,HIERARCHIC&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0, xi)*
<a name="l00221"></a>00221                   <a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">FE&lt;1,HIERARCHIC&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1, eta));       
<a name="l00222"></a>00222       }
<a name="l00223"></a>00223 
<a name="l00224"></a>00224     <span class="keywordflow">default</span>:
<a name="l00225"></a>00225       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported element type!&quot;</span> &lt;&lt; std::endl;
<a name="l00226"></a>00226       libmesh_error();
<a name="l00227"></a>00227     }
<a name="l00228"></a>00228 
<a name="l00229"></a>00229   <span class="keywordflow">return</span> 0.;
<a name="l00230"></a>00230 }
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 <span class="keyword">template</span> &lt;&gt;
<a name="l00235"></a><a class="code" href="classFE.php#acbb85f88d381ceba1cc0044141620cc5">00235</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;2,HIERARCHIC&gt;::shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00236"></a>00236                                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,                     
<a name="l00237"></a>00237                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00238"></a>00238                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00239"></a>00239                                    <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp;)
<a name="l00240"></a>00240 {
<a name="l00241"></a>00241   std::cerr &lt;&lt; <span class="stringliteral">&quot;Hierarchic polynomials require the element type\n&quot;</span>
<a name="l00242"></a>00242             &lt;&lt; <span class="stringliteral">&quot;because edge orientation is needed.&quot;</span>
<a name="l00243"></a>00243             &lt;&lt; std::endl;
<a name="l00244"></a>00244 
<a name="l00245"></a>00245   libmesh_error();
<a name="l00246"></a>00246   <span class="keywordflow">return</span> 0.;
<a name="l00247"></a>00247 }
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 
<a name="l00250"></a>00250 
<a name="l00251"></a>00251 <span class="keyword">template</span> &lt;&gt;
<a name="l00252"></a><a class="code" href="classFE.php#aa147128c6bfd41a00886fd035b157469">00252</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;2,HIERARCHIC&gt;::shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00253"></a>00253                                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00254"></a>00254                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00255"></a>00255                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00256"></a>00256                                    <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p)
<a name="l00257"></a>00257 {
<a name="l00258"></a>00258   libmesh_assert (elem != NULL);
<a name="l00259"></a>00259 
<a name="l00260"></a>00260   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type = elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>();
<a name="l00261"></a>00261 
<a name="l00262"></a>00262   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> totalorder = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order+elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>());
<a name="l00263"></a>00263 
<a name="l00264"></a>00264   libmesh_assert (totalorder &gt; 0);
<a name="l00265"></a>00265   
<a name="l00266"></a>00266   <span class="keywordflow">switch</span> (type)
<a name="l00267"></a>00267     {
<a name="l00268"></a>00268       <span class="comment">// 1st &amp; 2nd-order Hierarchics.</span>
<a name="l00269"></a>00269     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00270"></a>00270     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00271"></a>00271       {
<a name="l00272"></a>00272         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> eps = 1.e-6;
<a name="l00273"></a>00273               
<a name="l00274"></a>00274         libmesh_assert (j &lt; 2);
<a name="l00275"></a>00275               
<a name="l00276"></a>00276         <span class="keywordflow">switch</span> (j)
<a name="l00277"></a>00277           {
<a name="l00278"></a>00278             <span class="comment">//  d()/dxi</span>
<a name="l00279"></a>00279           <span class="keywordflow">case</span> 0:
<a name="l00280"></a>00280             {
<a name="l00281"></a>00281               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> pp(p(0)+eps, p(1));
<a name="l00282"></a>00282               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> pm(p(0)-eps, p(1));
<a name="l00283"></a>00283 
<a name="l00284"></a>00284               <span class="keywordflow">return</span> (<a class="code" href="classFE.php">FE&lt;2,HIERARCHIC&gt;::shape</a>(elem, order, i, pp) -
<a name="l00285"></a>00285                       <a class="code" href="classFE.php">FE&lt;2,HIERARCHIC&gt;::shape</a>(elem, order, i, pm))/2./eps;
<a name="l00286"></a>00286             }
<a name="l00287"></a>00287 
<a name="l00288"></a>00288              <span class="comment">// d()/deta</span>
<a name="l00289"></a>00289           <span class="keywordflow">case</span> 1:
<a name="l00290"></a>00290             {
<a name="l00291"></a>00291               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> pp(p(0), p(1)+eps);
<a name="l00292"></a>00292               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> pm(p(0), p(1)-eps);
<a name="l00293"></a>00293 
<a name="l00294"></a>00294               <span class="keywordflow">return</span> (<a class="code" href="classFE.php">FE&lt;2,HIERARCHIC&gt;::shape</a>(elem, order, i, pp) -
<a name="l00295"></a>00295                       <a class="code" href="classFE.php">FE&lt;2,HIERARCHIC&gt;::shape</a>(elem, order, i, pm))/2./eps;
<a name="l00296"></a>00296             }
<a name="l00297"></a>00297                   
<a name="l00298"></a>00298 
<a name="l00299"></a>00299           <span class="keywordflow">default</span>:
<a name="l00300"></a>00300             libmesh_error();
<a name="l00301"></a>00301           }
<a name="l00302"></a>00302       }
<a name="l00303"></a>00303 
<a name="l00304"></a>00304     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l00305"></a>00305       libmesh_assert (totalorder &lt; 2);
<a name="l00306"></a>00306     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00307"></a>00307     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00308"></a>00308       {
<a name="l00309"></a>00309         <span class="comment">// Compute quad shape functions as a tensor-product</span>
<a name="l00310"></a>00310         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xi  = p(0);
<a name="l00311"></a>00311         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> eta = p(1);
<a name="l00312"></a>00312 
<a name="l00313"></a>00313         libmesh_assert (i &lt; (totalorder+1u)*(totalorder+1u));
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 <span class="comment">// Example i, i0, i1 values for totalorder = 5:</span>
<a name="l00316"></a>00316 <span class="comment">//                                    0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35</span>
<a name="l00317"></a>00317 <span class="comment">//  static const unsigned int i0[] = {0, 1, 1, 0, 2, 3, 4, 5, 1, 1, 1, 1, 2, 3, 4, 5, 0, 0, 0, 0, 2, 3, 4, 5, 2, 3, 4, 5, 2, 3, 4, 5, 2, 3, 4, 5};</span>
<a name="l00318"></a>00318 <span class="comment">//  static const unsigned int i1[] = {0, 0, 1, 1, 0, 0, 0, 0, 2, 3, 4, 5, 1, 1, 1, 1, 2, 3, 4, 5, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5};</span>
<a name="l00319"></a>00319               
<a name="l00320"></a>00320         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i0, i1;
<a name="l00321"></a>00321 
<a name="l00322"></a>00322         <span class="comment">// Vertex DoFs</span>
<a name="l00323"></a>00323         <span class="keywordflow">if</span> (i == 0)
<a name="l00324"></a>00324           { i0 = 0; i1 = 0; }
<a name="l00325"></a>00325         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i == 1)
<a name="l00326"></a>00326           { i0 = 1; i1 = 0; }
<a name="l00327"></a>00327         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i == 2)
<a name="l00328"></a>00328           { i0 = 1; i1 = 1; }
<a name="l00329"></a>00329         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i == 3)
<a name="l00330"></a>00330           { i0 = 0; i1 = 1; }
<a name="l00331"></a>00331         <span class="comment">// Edge DoFs</span>
<a name="l00332"></a>00332         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; totalorder + 3u)
<a name="l00333"></a>00333           { i0 = i - 2; i1 = 0; }
<a name="l00334"></a>00334         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 2u*totalorder + 2)
<a name="l00335"></a>00335           { i0 = 1; i1 = i - totalorder - 1; }
<a name="l00336"></a>00336         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 3u*totalorder + 1u)
<a name="l00337"></a>00337           { i0 = i - 2u*totalorder; i1 = 1; }
<a name="l00338"></a>00338         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 4u*totalorder)
<a name="l00339"></a>00339           { i0 = 0; i1 = i - 3u*totalorder + 1; }
<a name="l00340"></a>00340         <span class="comment">// Interior DoFs</span>
<a name="l00341"></a>00341         <span class="keywordflow">else</span>
<a name="l00342"></a>00342           {
<a name="l00343"></a>00343             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basisnum = i - 4*totalorder;
<a name="l00344"></a>00344             i0 = <a class="code" href="number__lookups_8C.php#a8f3c09eca07801e0ff9eb08f48af8e74">square_number_column</a>[basisnum] + 2;
<a name="l00345"></a>00345             i1 = <a class="code" href="number__lookups_8C.php#a607440daec332e28892bdc860dce25b6">square_number_row</a>[basisnum] + 2;
<a name="l00346"></a>00346           }
<a name="l00347"></a>00347 
<a name="l00348"></a>00348         <span class="comment">// Flip odd degree of freedom values if necessary</span>
<a name="l00349"></a>00349         <span class="comment">// to keep continuity on sides</span>
<a name="l00350"></a>00350         <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> f = 1.;
<a name="l00351"></a>00351 
<a name="l00352"></a>00352         <span class="keywordflow">if</span> ((i0%2) &amp;&amp; (i0 &gt; 2) &amp;&amp; (i1 == 0))
<a name="l00353"></a>00353           f = (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0) &gt; elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1))?-1.:1.;
<a name="l00354"></a>00354         <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0%2) &amp;&amp; (i0&gt;2) &amp;&amp; (i1 == 1))
<a name="l00355"></a>00355           f = (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3) &gt; elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2))?-1.:1.;
<a name="l00356"></a>00356         <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0 == 0) &amp;&amp; (i1%2) &amp;&amp; (i1&gt;2))
<a name="l00357"></a>00357           f = (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0) &gt; elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3))?-1.:1.;
<a name="l00358"></a>00358         <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0 == 1) &amp;&amp; (i1%2) &amp;&amp; (i1&gt;2))
<a name="l00359"></a>00359           f = (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1) &gt; elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2))?-1.:1.;
<a name="l00360"></a>00360               
<a name="l00361"></a>00361         <span class="keywordflow">switch</span> (j)
<a name="l00362"></a>00362           {
<a name="l00363"></a>00363             <span class="comment">// d()/dxi</span>
<a name="l00364"></a>00364           <span class="keywordflow">case</span> 0:                                 
<a name="l00365"></a>00365             <span class="keywordflow">return</span> f*(<a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;1,HIERARCHIC&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0, 0, xi)*
<a name="l00366"></a>00366                       <a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">FE&lt;1,HIERARCHIC&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1,    eta));
<a name="l00367"></a>00367               
<a name="l00368"></a>00368             <span class="comment">// d()/deta</span>
<a name="l00369"></a>00369           <span class="keywordflow">case</span> 1:                                 
<a name="l00370"></a>00370             <span class="keywordflow">return</span> f*(<a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">FE&lt;1,HIERARCHIC&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0,    xi)*
<a name="l00371"></a>00371                       <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;1,HIERARCHIC&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1, 0, eta));
<a name="l00372"></a>00372 
<a name="l00373"></a>00373           <span class="keywordflow">default</span>:
<a name="l00374"></a>00374             libmesh_error();
<a name="l00375"></a>00375           }
<a name="l00376"></a>00376 
<a name="l00377"></a>00377       }
<a name="l00378"></a>00378       
<a name="l00379"></a>00379     <span class="keywordflow">default</span>:
<a name="l00380"></a>00380       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported element type!&quot;</span> &lt;&lt; std::endl;
<a name="l00381"></a>00381       libmesh_error();
<a name="l00382"></a>00382     }
<a name="l00383"></a>00383 
<a name="l00384"></a>00384   <span class="keywordflow">return</span> 0.;
<a name="l00385"></a>00385 }
<a name="l00386"></a>00386 
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 
<a name="l00389"></a>00389 <span class="keyword">template</span> &lt;&gt;
<a name="l00390"></a><a class="code" href="classFE.php#ae1942b06f4aef3d7b1137c9e283c7db2">00390</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;2,HIERARCHIC&gt;::shape_second_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00391"></a>00391                                           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,                      
<a name="l00392"></a>00392                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00393"></a>00393                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00394"></a>00394                                           <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp;)
<a name="l00395"></a>00395 {
<a name="l00396"></a>00396   std::cerr &lt;&lt; <span class="stringliteral">&quot;Hierarchic polynomials require the element type\n&quot;</span>
<a name="l00397"></a>00397             &lt;&lt; <span class="stringliteral">&quot;because edge orientation is needed.&quot;</span>
<a name="l00398"></a>00398             &lt;&lt; std::endl;
<a name="l00399"></a>00399 
<a name="l00400"></a>00400   libmesh_error();
<a name="l00401"></a>00401   <span class="keywordflow">return</span> 0.;
<a name="l00402"></a>00402 }
<a name="l00403"></a>00403 
<a name="l00404"></a>00404 
<a name="l00405"></a>00405 
<a name="l00406"></a>00406 <span class="keyword">template</span> &lt;&gt;
<a name="l00407"></a><a class="code" href="classFE.php#ae8a10edd8d396c67bd261f4adb1f2244">00407</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;2,HIERARCHIC&gt;::shape_second_deriv</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00408"></a>00408                                           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00409"></a>00409                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00410"></a>00410                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00411"></a>00411                                           <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p)
<a name="l00412"></a>00412 {
<a name="l00413"></a>00413   libmesh_assert (elem != NULL);
<a name="l00414"></a>00414 
<a name="l00415"></a>00415   <span class="comment">// I have been lazy here and am using finite differences</span>
<a name="l00416"></a>00416   <span class="comment">// to compute the derivatives!</span>
<a name="l00417"></a>00417   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> eps = 1.e-6;
<a name="l00418"></a>00418   <a class="code" href="classPoint.php">Point</a> pp, pm;
<a name="l00419"></a>00419   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> prevj = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00420"></a>00420               
<a name="l00421"></a>00421   <span class="keywordflow">switch</span> (j)
<a name="l00422"></a>00422   {
<a name="l00423"></a>00423     <span class="comment">//  d^2()/dxi^2</span>
<a name="l00424"></a>00424     <span class="keywordflow">case</span> 0:
<a name="l00425"></a>00425       {
<a name="l00426"></a>00426         pp = <a class="code" href="classPoint.php">Point</a>(p(0)+eps, p(1));
<a name="l00427"></a>00427         pm = <a class="code" href="classPoint.php">Point</a>(p(0)-eps, p(1));
<a name="l00428"></a>00428         prevj = 0;
<a name="l00429"></a>00429         <span class="keywordflow">break</span>;
<a name="l00430"></a>00430       }
<a name="l00431"></a>00431   
<a name="l00432"></a>00432     <span class="comment">// d^2()/dxideta</span>
<a name="l00433"></a>00433     <span class="keywordflow">case</span> 1:
<a name="l00434"></a>00434       {
<a name="l00435"></a>00435         pp = <a class="code" href="classPoint.php">Point</a>(p(0), p(1)+eps);
<a name="l00436"></a>00436         pm = <a class="code" href="classPoint.php">Point</a>(p(0), p(1)-eps);
<a name="l00437"></a>00437         prevj = 0;
<a name="l00438"></a>00438         <span class="keywordflow">break</span>;
<a name="l00439"></a>00439       }
<a name="l00440"></a>00440 
<a name="l00441"></a>00441     <span class="comment">// d^2()/deta^2</span>
<a name="l00442"></a>00442     <span class="keywordflow">case</span> 2:
<a name="l00443"></a>00443       {
<a name="l00444"></a>00444         pp = <a class="code" href="classPoint.php">Point</a>(p(0), p(1)+eps);
<a name="l00445"></a>00445         pm = <a class="code" href="classPoint.php">Point</a>(p(0), p(1)-eps);
<a name="l00446"></a>00446         prevj = 1;
<a name="l00447"></a>00447         <span class="keywordflow">break</span>;
<a name="l00448"></a>00448       }
<a name="l00449"></a>00449     <span class="keywordflow">default</span>:
<a name="l00450"></a>00450       libmesh_error();
<a name="l00451"></a>00451   }
<a name="l00452"></a>00452   <span class="keywordflow">return</span> (<a class="code" href="classFE.php">FE&lt;2,HIERARCHIC&gt;::shape_deriv</a>(elem, order, i, prevj, pp) -
<a name="l00453"></a>00453           <a class="code" href="classFE.php">FE&lt;2,HIERARCHIC&gt;::shape_deriv</a>(elem, order, i, prevj, pm)
<a name="l00454"></a>00454           )/2./eps;
<a name="l00455"></a>00455 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
