<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_a0136eca6b184c0d854bbc4a8414e31c.php">fe</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>fe_hierarchic_shape_3D.C</h1>  </div>
</div>
<div class="contents">
<a href="fe__hierarchic__shape__3D_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_hierarchic_shape_3D.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;fe.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;number_lookups.h&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// anonymous namespace for local helper functions</span>
<a name="l00029"></a>00029 <span class="keyword">namespace</span>
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031 
<a name="l00032"></a>00032   <a class="code" href="classPoint.php">Point</a> get_min_point(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *elem,
<a name="l00033"></a>00033                       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> a,
<a name="l00034"></a>00034                       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> b,
<a name="l00035"></a>00035                       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00036"></a>00036                       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d)
<a name="l00037"></a>00037   {
<a name="l00038"></a>00038     <span class="keywordflow">return</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(a),elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(b)),
<a name="l00039"></a>00039                     <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(c),elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(d)));
<a name="l00040"></a>00040   }
<a name="l00041"></a>00041   
<a name="l00042"></a>00042   <span class="keywordtype">void</span> cube_indices(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *elem,
<a name="l00043"></a>00043                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> totalorder,
<a name="l00044"></a>00044                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00045"></a>00045                     <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> &amp;xi, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> &amp;eta, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> &amp;zeta,
<a name="l00046"></a>00046                     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;i0,
<a name="l00047"></a>00047                     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;i1,
<a name="l00048"></a>00048                     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;i2)
<a name="l00049"></a>00049   {
<a name="l00050"></a>00050     <span class="comment">// The only way to make any sense of this</span>
<a name="l00051"></a>00051     <span class="comment">// is to look at the mgflo/mg2/mgf documentation</span>
<a name="l00052"></a>00052     <span class="comment">// and make the cut-out cube!</span>
<a name="l00053"></a>00053     <span class="comment">// Example i0 and i1 values for totalorder = 3:</span>
<a name="l00054"></a>00054     <span class="comment">// FIXME - these examples are incorrect now that we&#39;ve got truly</span>
<a name="l00055"></a>00055     <span class="comment">// hierarchic basis functions</span>
<a name="l00056"></a>00056     <span class="comment">//     Nodes                         0  1  2  3  4  5  6  7  8  8  9  9 10 10 11 11 12 12 13 13 14 14 15 15 16 16 17 17 18 18 19 19 20 20 20 20 21 21 21 21 22 22 22 22 23 23 23 23 24 24 24 24 25 25 25 25 26 26 26 26 26 26 26 26 </span>
<a name="l00057"></a>00057     <span class="comment">//     DOFS                          0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 18 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 60 62 63</span>
<a name="l00058"></a>00058     <span class="comment">// static const unsigned int i0[] = {0, 1, 1, 0, 0, 1, 1, 0, 2, 3, 1, 1, 2, 3, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 2, 3, 1, 1, 2, 3, 0, 0, 2, 3, 2, 3, 2, 3, 2, 3, 1, 1, 1, 1, 2, 3, 2, 3, 0, 0, 0, 0, 2, 3, 2, 3, 2, 3, 2, 3, 2, 3, 2, 3};</span>
<a name="l00059"></a>00059     <span class="comment">// static const unsigned int i1[] = {0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 2, 3, 1, 1, 2, 3, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 2, 3, 1, 1, 2, 3, 2, 2, 3, 3, 0, 0, 0, 0, 2, 3, 2, 3, 1, 1, 1, 1, 2, 3, 2, 3, 2, 2, 3, 3, 2, 2, 3, 3, 2, 2, 3, 3};</span>
<a name="l00060"></a>00060     <span class="comment">// static const unsigned int i2[] = {0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 2, 3, 2, 3, 2, 3, 2, 3, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 2, 2, 3, 3, 2, 2, 3, 3, 2, 2, 3, 3, 2, 2, 3, 3, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3};</span>
<a name="l00061"></a>00061 
<a name="l00062"></a>00062     <span class="comment">// the number of DoFs per edge appears everywhere:</span>
<a name="l00063"></a>00063     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e = totalorder - 1u;
<a name="l00064"></a>00064 
<a name="l00065"></a>00065     libmesh_assert (i&lt;(totalorder+1u)*(totalorder+1u)*(totalorder+1u));
<a name="l00066"></a>00066 
<a name="l00067"></a>00067     <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xi_saved = xi, eta_saved = eta, zeta_saved = zeta;
<a name="l00068"></a>00068 
<a name="l00069"></a>00069     <span class="comment">// Vertices:</span>
<a name="l00070"></a>00070     <span class="keywordflow">if</span> (i == 0)
<a name="l00071"></a>00071       {
<a name="l00072"></a>00072         i0 = 0;
<a name="l00073"></a>00073         i1 = 0;
<a name="l00074"></a>00074         i2 = 0;
<a name="l00075"></a>00075       }
<a name="l00076"></a>00076     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i == 1)
<a name="l00077"></a>00077       {
<a name="l00078"></a>00078         i0 = 1;
<a name="l00079"></a>00079         i1 = 0;
<a name="l00080"></a>00080         i2 = 0;
<a name="l00081"></a>00081       }
<a name="l00082"></a>00082     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i == 2)
<a name="l00083"></a>00083       {
<a name="l00084"></a>00084         i0 = 1;
<a name="l00085"></a>00085         i1 = 1;
<a name="l00086"></a>00086         i2 = 0;
<a name="l00087"></a>00087       }
<a name="l00088"></a>00088     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i == 3)
<a name="l00089"></a>00089       {
<a name="l00090"></a>00090         i0 = 0;
<a name="l00091"></a>00091         i1 = 1;
<a name="l00092"></a>00092         i2 = 0;
<a name="l00093"></a>00093       }
<a name="l00094"></a>00094     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i == 4)
<a name="l00095"></a>00095       {
<a name="l00096"></a>00096         i0 = 0;
<a name="l00097"></a>00097         i1 = 0;
<a name="l00098"></a>00098         i2 = 1;
<a name="l00099"></a>00099       }
<a name="l00100"></a>00100     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i == 5)
<a name="l00101"></a>00101       {
<a name="l00102"></a>00102         i0 = 1;
<a name="l00103"></a>00103         i1 = 0;
<a name="l00104"></a>00104         i2 = 1;
<a name="l00105"></a>00105       }
<a name="l00106"></a>00106     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i == 6)
<a name="l00107"></a>00107       {
<a name="l00108"></a>00108         i0 = 1;
<a name="l00109"></a>00109         i1 = 1;
<a name="l00110"></a>00110         i2 = 1;
<a name="l00111"></a>00111       }
<a name="l00112"></a>00112     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i == 7)
<a name="l00113"></a>00113       {
<a name="l00114"></a>00114         i0 = 0;
<a name="l00115"></a>00115         i1 = 1;
<a name="l00116"></a>00116         i2 = 1;
<a name="l00117"></a>00117       }
<a name="l00118"></a>00118     <span class="comment">// Edge 0</span>
<a name="l00119"></a>00119     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + e)
<a name="l00120"></a>00120       {
<a name="l00121"></a>00121         i0 = i - 6;
<a name="l00122"></a>00122         i1 = 0;
<a name="l00123"></a>00123         i2 = 0;
<a name="l00124"></a>00124         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0) &gt; elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1))
<a name="l00125"></a>00125           xi = -xi_saved;
<a name="l00126"></a>00126       }
<a name="l00127"></a>00127     <span class="comment">// Edge 1</span>
<a name="l00128"></a>00128     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 2*e)
<a name="l00129"></a>00129       {
<a name="l00130"></a>00130         i0 = 1;
<a name="l00131"></a>00131         i1 = i - e - 6;
<a name="l00132"></a>00132         i2 = 0;
<a name="l00133"></a>00133         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1) &gt; elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2))
<a name="l00134"></a>00134           eta = -eta_saved;
<a name="l00135"></a>00135       }
<a name="l00136"></a>00136     <span class="comment">// Edge 2</span>
<a name="l00137"></a>00137     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 3*e)
<a name="l00138"></a>00138       {
<a name="l00139"></a>00139         i0 = i - 2*e - 6;
<a name="l00140"></a>00140         i1 = 1;
<a name="l00141"></a>00141         i2 = 0;
<a name="l00142"></a>00142         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3) &gt; elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2))
<a name="l00143"></a>00143           xi = -xi_saved;
<a name="l00144"></a>00144       }
<a name="l00145"></a>00145     <span class="comment">// Edge 3</span>
<a name="l00146"></a>00146     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 4*e)
<a name="l00147"></a>00147       {
<a name="l00148"></a>00148         i0 = 0;
<a name="l00149"></a>00149         i1 = i - 3*e - 6;
<a name="l00150"></a>00150         i2 = 0;
<a name="l00151"></a>00151         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0) &gt; elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3))
<a name="l00152"></a>00152           eta = -eta_saved;
<a name="l00153"></a>00153       }
<a name="l00154"></a>00154     <span class="comment">// Edge 4</span>
<a name="l00155"></a>00155     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 5*e)
<a name="l00156"></a>00156       {
<a name="l00157"></a>00157         i0 = 0;
<a name="l00158"></a>00158         i1 = 0;
<a name="l00159"></a>00159         i2 = i - 4*e - 6;
<a name="l00160"></a>00160         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0) &gt; elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(4))
<a name="l00161"></a>00161           zeta = -zeta_saved;
<a name="l00162"></a>00162       }                
<a name="l00163"></a>00163     <span class="comment">// Edge 5</span>
<a name="l00164"></a>00164     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 6*e)
<a name="l00165"></a>00165       {
<a name="l00166"></a>00166         i0 = 1;
<a name="l00167"></a>00167         i1 = 0;
<a name="l00168"></a>00168         i2 = i - 5*e - 6;
<a name="l00169"></a>00169         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1) &gt; elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(5))
<a name="l00170"></a>00170           zeta = -zeta_saved;
<a name="l00171"></a>00171       }                
<a name="l00172"></a>00172     <span class="comment">// Edge 6</span>
<a name="l00173"></a>00173     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 7*e)
<a name="l00174"></a>00174       {
<a name="l00175"></a>00175         i0 = 1;
<a name="l00176"></a>00176         i1 = 1;
<a name="l00177"></a>00177         i2 = i - 6*e - 6;
<a name="l00178"></a>00178         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2) &gt; elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(6))
<a name="l00179"></a>00179           zeta = -zeta_saved;
<a name="l00180"></a>00180       }
<a name="l00181"></a>00181     <span class="comment">// Edge 7</span>
<a name="l00182"></a>00182     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 8*e)
<a name="l00183"></a>00183       {
<a name="l00184"></a>00184         i0 = 0;
<a name="l00185"></a>00185         i1 = 1;
<a name="l00186"></a>00186         i2 = i - 7*e - 6;
<a name="l00187"></a>00187         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3) &gt; elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(7))
<a name="l00188"></a>00188           zeta = -zeta_saved;
<a name="l00189"></a>00189       }                
<a name="l00190"></a>00190     <span class="comment">// Edge 8</span>
<a name="l00191"></a>00191     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 9*e)
<a name="l00192"></a>00192       {
<a name="l00193"></a>00193         i0 = i - 8*e - 6;
<a name="l00194"></a>00194         i1 = 0;
<a name="l00195"></a>00195         i2 = 1;
<a name="l00196"></a>00196         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(4) &gt; elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(5))
<a name="l00197"></a>00197           xi = -xi_saved;
<a name="l00198"></a>00198       }
<a name="l00199"></a>00199     <span class="comment">// Edge 9</span>
<a name="l00200"></a>00200     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 10*e)
<a name="l00201"></a>00201       {
<a name="l00202"></a>00202         i0 = 1;
<a name="l00203"></a>00203         i1 = i - 9*e - 6;
<a name="l00204"></a>00204         i2 = 1;
<a name="l00205"></a>00205         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(5) &gt; elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(6))
<a name="l00206"></a>00206           eta = -eta_saved;
<a name="l00207"></a>00207       }                
<a name="l00208"></a>00208     <span class="comment">// Edge 10</span>
<a name="l00209"></a>00209     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 11*e)
<a name="l00210"></a>00210       {
<a name="l00211"></a>00211         i0 = i - 10*e - 6;
<a name="l00212"></a>00212         i1 = 1;
<a name="l00213"></a>00213         i2 = 1;
<a name="l00214"></a>00214         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(7) &gt; elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(6))
<a name="l00215"></a>00215           xi = -xi_saved;
<a name="l00216"></a>00216       }
<a name="l00217"></a>00217     <span class="comment">// Edge 11</span>
<a name="l00218"></a>00218     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 12*e)
<a name="l00219"></a>00219       {
<a name="l00220"></a>00220         i0 = 0;
<a name="l00221"></a>00221         i1 = i - 11*e - 6;
<a name="l00222"></a>00222         i2 = 1;
<a name="l00223"></a>00223         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(4) &gt; elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(7))
<a name="l00224"></a>00224           eta = -eta_saved;
<a name="l00225"></a>00225       }
<a name="l00226"></a>00226     <span class="comment">// Face 0</span>
<a name="l00227"></a>00227     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 12*e + e*e)
<a name="l00228"></a>00228       {
<a name="l00229"></a>00229         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basisnum = i - 8 - 12*e;
<a name="l00230"></a>00230         i0 = <a class="code" href="number__lookups_8C.php#a607440daec332e28892bdc860dce25b6">square_number_row</a>[basisnum] + 2;
<a name="l00231"></a>00231         i1 = <a class="code" href="number__lookups_8C.php#a8f3c09eca07801e0ff9eb08f48af8e74">square_number_column</a>[basisnum] + 2;
<a name="l00232"></a>00232         i2 = 0;
<a name="l00233"></a>00233         <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> min_point = get_min_point(elem, 1, 2, 0, 3);
<a name="l00234"></a>00234 
<a name="l00235"></a>00235         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0) == min_point)
<a name="l00236"></a>00236           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1), elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3)))
<a name="l00237"></a>00237             {
<a name="l00238"></a>00238               <span class="comment">// Case 1</span>
<a name="l00239"></a>00239               xi  = xi_saved;
<a name="l00240"></a>00240               eta = eta_saved;
<a name="l00241"></a>00241             }
<a name="l00242"></a>00242           <span class="keywordflow">else</span>
<a name="l00243"></a>00243             {
<a name="l00244"></a>00244               <span class="comment">// Case 2</span>
<a name="l00245"></a>00245               xi  = eta_saved;
<a name="l00246"></a>00246               eta = xi_saved;
<a name="l00247"></a>00247             }
<a name="l00248"></a>00248 
<a name="l00249"></a>00249         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3) == min_point)
<a name="l00250"></a>00250           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0), elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2)))
<a name="l00251"></a>00251             {
<a name="l00252"></a>00252               <span class="comment">// Case 3</span>
<a name="l00253"></a>00253               xi  = -eta_saved;
<a name="l00254"></a>00254               eta = xi_saved;
<a name="l00255"></a>00255             }
<a name="l00256"></a>00256           <span class="keywordflow">else</span>
<a name="l00257"></a>00257             {
<a name="l00258"></a>00258               <span class="comment">// Case 4</span>
<a name="l00259"></a>00259               xi  = xi_saved;
<a name="l00260"></a>00260               eta = -eta_saved;
<a name="l00261"></a>00261             }
<a name="l00262"></a>00262 
<a name="l00263"></a>00263         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2) == min_point)
<a name="l00264"></a>00264           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3), elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1)))
<a name="l00265"></a>00265             {
<a name="l00266"></a>00266               <span class="comment">// Case 5</span>
<a name="l00267"></a>00267               xi  = -xi_saved;
<a name="l00268"></a>00268               eta = -eta_saved;
<a name="l00269"></a>00269             }
<a name="l00270"></a>00270           <span class="keywordflow">else</span>
<a name="l00271"></a>00271             {
<a name="l00272"></a>00272               <span class="comment">// Case 6</span>
<a name="l00273"></a>00273               xi  = -eta_saved;
<a name="l00274"></a>00274               eta = -xi_saved;
<a name="l00275"></a>00275             }
<a name="l00276"></a>00276 
<a name="l00277"></a>00277         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1) == min_point)
<a name="l00278"></a>00278           {
<a name="l00279"></a>00279             <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2), elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0)))
<a name="l00280"></a>00280               {
<a name="l00281"></a>00281                 <span class="comment">// Case 7</span>
<a name="l00282"></a>00282                 xi  = eta_saved;
<a name="l00283"></a>00283                 eta = -xi_saved;
<a name="l00284"></a>00284               }
<a name="l00285"></a>00285             <span class="keywordflow">else</span>
<a name="l00286"></a>00286               {
<a name="l00287"></a>00287                 <span class="comment">// Case 8</span>
<a name="l00288"></a>00288                 xi  = -xi_saved;
<a name="l00289"></a>00289                 eta = eta_saved;
<a name="l00290"></a>00290               }
<a name="l00291"></a>00291           }
<a name="l00292"></a>00292       }
<a name="l00293"></a>00293     <span class="comment">// Face 1</span>
<a name="l00294"></a>00294     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 12*e + 2*e*e)
<a name="l00295"></a>00295       {
<a name="l00296"></a>00296         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basisnum = i - 8 - 12*e - e*e;
<a name="l00297"></a>00297         i0 = <a class="code" href="number__lookups_8C.php#a607440daec332e28892bdc860dce25b6">square_number_row</a>[basisnum] + 2;
<a name="l00298"></a>00298         i1 = 0;
<a name="l00299"></a>00299         i2 = <a class="code" href="number__lookups_8C.php#a8f3c09eca07801e0ff9eb08f48af8e74">square_number_column</a>[basisnum] + 2;
<a name="l00300"></a>00300         <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> min_point = get_min_point(elem, 0, 1, 5, 4);
<a name="l00301"></a>00301 
<a name="l00302"></a>00302         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0) == min_point)
<a name="l00303"></a>00303           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1), elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(4)))
<a name="l00304"></a>00304             {
<a name="l00305"></a>00305               <span class="comment">// Case 1</span>
<a name="l00306"></a>00306               xi   = xi_saved;
<a name="l00307"></a>00307               zeta = zeta_saved;
<a name="l00308"></a>00308             }
<a name="l00309"></a>00309           <span class="keywordflow">else</span>
<a name="l00310"></a>00310             {
<a name="l00311"></a>00311               <span class="comment">// Case 2</span>
<a name="l00312"></a>00312               xi   = zeta_saved;
<a name="l00313"></a>00313               zeta = xi_saved;
<a name="l00314"></a>00314             }
<a name="l00315"></a>00315 
<a name="l00316"></a>00316         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1) == min_point)
<a name="l00317"></a>00317           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(5) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(5), elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0)))
<a name="l00318"></a>00318             {
<a name="l00319"></a>00319               <span class="comment">// Case 3</span>
<a name="l00320"></a>00320               xi   = zeta_saved;
<a name="l00321"></a>00321               zeta = -xi_saved;
<a name="l00322"></a>00322             }
<a name="l00323"></a>00323           <span class="keywordflow">else</span>
<a name="l00324"></a>00324             {
<a name="l00325"></a>00325               <span class="comment">// Case 4</span>
<a name="l00326"></a>00326               xi   = -xi_saved;
<a name="l00327"></a>00327               zeta = zeta_saved;
<a name="l00328"></a>00328             }
<a name="l00329"></a>00329 
<a name="l00330"></a>00330         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(5) == min_point)
<a name="l00331"></a>00331           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(4) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(4), elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1)))
<a name="l00332"></a>00332             {
<a name="l00333"></a>00333               <span class="comment">// Case 5</span>
<a name="l00334"></a>00334               xi   = -xi_saved;
<a name="l00335"></a>00335               zeta = -zeta_saved;
<a name="l00336"></a>00336             }
<a name="l00337"></a>00337           <span class="keywordflow">else</span>
<a name="l00338"></a>00338             {
<a name="l00339"></a>00339               <span class="comment">// Case 6</span>
<a name="l00340"></a>00340               xi   = -zeta_saved;
<a name="l00341"></a>00341               zeta = -xi_saved;
<a name="l00342"></a>00342             }
<a name="l00343"></a>00343 
<a name="l00344"></a>00344         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(4) == min_point)
<a name="l00345"></a>00345           {
<a name="l00346"></a>00346             <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0), elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(5)))
<a name="l00347"></a>00347               {
<a name="l00348"></a>00348                 <span class="comment">// Case 7</span>
<a name="l00349"></a>00349                 xi   = -xi_saved;
<a name="l00350"></a>00350                 zeta = zeta_saved;
<a name="l00351"></a>00351               }
<a name="l00352"></a>00352             <span class="keywordflow">else</span>
<a name="l00353"></a>00353               {
<a name="l00354"></a>00354                 <span class="comment">// Case 8</span>
<a name="l00355"></a>00355                 xi   = xi_saved;
<a name="l00356"></a>00356                 zeta = -zeta_saved;
<a name="l00357"></a>00357               }
<a name="l00358"></a>00358           }
<a name="l00359"></a>00359       }
<a name="l00360"></a>00360     <span class="comment">// Face 2</span>
<a name="l00361"></a>00361     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 12*e + 3*e*e)
<a name="l00362"></a>00362       {
<a name="l00363"></a>00363         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basisnum = i - 8 - 12*e - 2*e*e;
<a name="l00364"></a>00364         i0 = 1;
<a name="l00365"></a>00365         i1 = <a class="code" href="number__lookups_8C.php#a607440daec332e28892bdc860dce25b6">square_number_row</a>[basisnum] + 2;
<a name="l00366"></a>00366         i2 = <a class="code" href="number__lookups_8C.php#a8f3c09eca07801e0ff9eb08f48af8e74">square_number_column</a>[basisnum] + 2;
<a name="l00367"></a>00367         <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> min_point = get_min_point(elem, 1, 2, 6, 5);
<a name="l00368"></a>00368 
<a name="l00369"></a>00369         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1) == min_point)
<a name="l00370"></a>00370           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2), elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(5)))
<a name="l00371"></a>00371             {
<a name="l00372"></a>00372               <span class="comment">// Case 1</span>
<a name="l00373"></a>00373               eta  = eta_saved;
<a name="l00374"></a>00374               zeta = zeta_saved;
<a name="l00375"></a>00375             }
<a name="l00376"></a>00376           <span class="keywordflow">else</span>
<a name="l00377"></a>00377             {
<a name="l00378"></a>00378               <span class="comment">// Case 2</span>
<a name="l00379"></a>00379               eta  = zeta_saved;
<a name="l00380"></a>00380               zeta = eta_saved;
<a name="l00381"></a>00381             }
<a name="l00382"></a>00382 
<a name="l00383"></a>00383         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2) == min_point)
<a name="l00384"></a>00384           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(6) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(6), elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1)))
<a name="l00385"></a>00385             {
<a name="l00386"></a>00386               <span class="comment">// Case 3</span>
<a name="l00387"></a>00387               eta  = zeta_saved;
<a name="l00388"></a>00388               zeta = -eta_saved;
<a name="l00389"></a>00389             }
<a name="l00390"></a>00390           <span class="keywordflow">else</span>
<a name="l00391"></a>00391             {
<a name="l00392"></a>00392               <span class="comment">// Case 4</span>
<a name="l00393"></a>00393               eta  = -eta_saved;
<a name="l00394"></a>00394               zeta = zeta_saved;
<a name="l00395"></a>00395             }
<a name="l00396"></a>00396 
<a name="l00397"></a>00397         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(6) == min_point)
<a name="l00398"></a>00398           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(5) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(5), elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2)))
<a name="l00399"></a>00399             {
<a name="l00400"></a>00400               <span class="comment">// Case 5</span>
<a name="l00401"></a>00401               eta  = -eta_saved;
<a name="l00402"></a>00402               zeta = -zeta_saved;
<a name="l00403"></a>00403             }
<a name="l00404"></a>00404           <span class="keywordflow">else</span>
<a name="l00405"></a>00405             {
<a name="l00406"></a>00406               <span class="comment">// Case 6</span>
<a name="l00407"></a>00407               eta  = -zeta_saved;
<a name="l00408"></a>00408               zeta = -eta_saved;
<a name="l00409"></a>00409             }
<a name="l00410"></a>00410 
<a name="l00411"></a>00411         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(5) == min_point)
<a name="l00412"></a>00412           {
<a name="l00413"></a>00413             <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(1), elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(6)))
<a name="l00414"></a>00414               {
<a name="l00415"></a>00415                 <span class="comment">// Case 7</span>
<a name="l00416"></a>00416                 eta  = -zeta_saved;
<a name="l00417"></a>00417                 zeta = eta_saved;
<a name="l00418"></a>00418               }
<a name="l00419"></a>00419             <span class="keywordflow">else</span>
<a name="l00420"></a>00420               {
<a name="l00421"></a>00421                 <span class="comment">// Case 8</span>
<a name="l00422"></a>00422                 eta   = eta_saved;
<a name="l00423"></a>00423                 zeta = -zeta_saved;
<a name="l00424"></a>00424               }
<a name="l00425"></a>00425           }
<a name="l00426"></a>00426       }
<a name="l00427"></a>00427     <span class="comment">// Face 3</span>
<a name="l00428"></a>00428     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 12*e + 4*e*e)
<a name="l00429"></a>00429       {
<a name="l00430"></a>00430         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basisnum = i - 8 - 12*e - 3*e*e;
<a name="l00431"></a>00431         i0 = <a class="code" href="number__lookups_8C.php#a607440daec332e28892bdc860dce25b6">square_number_row</a>[basisnum] + 2;
<a name="l00432"></a>00432         i1 = 1;
<a name="l00433"></a>00433         i2 = <a class="code" href="number__lookups_8C.php#a8f3c09eca07801e0ff9eb08f48af8e74">square_number_column</a>[basisnum] + 2;
<a name="l00434"></a>00434         <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> min_point = get_min_point(elem, 2, 3, 7, 6);
<a name="l00435"></a>00435 
<a name="l00436"></a>00436         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3) == min_point)
<a name="l00437"></a>00437           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2), elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(7)))
<a name="l00438"></a>00438             {
<a name="l00439"></a>00439               <span class="comment">// Case 1</span>
<a name="l00440"></a>00440               xi   = xi_saved;
<a name="l00441"></a>00441               zeta = zeta_saved;
<a name="l00442"></a>00442             }
<a name="l00443"></a>00443           <span class="keywordflow">else</span>
<a name="l00444"></a>00444             {
<a name="l00445"></a>00445               <span class="comment">// Case 2</span>
<a name="l00446"></a>00446               xi   = zeta_saved;
<a name="l00447"></a>00447               zeta = xi_saved;
<a name="l00448"></a>00448             }
<a name="l00449"></a>00449 
<a name="l00450"></a>00450         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(7) == min_point)
<a name="l00451"></a>00451           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3), elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(6)))
<a name="l00452"></a>00452             {
<a name="l00453"></a>00453               <span class="comment">// Case 3</span>
<a name="l00454"></a>00454               xi   = -zeta_saved;
<a name="l00455"></a>00455               zeta = xi_saved;
<a name="l00456"></a>00456             }
<a name="l00457"></a>00457           <span class="keywordflow">else</span>
<a name="l00458"></a>00458             {
<a name="l00459"></a>00459               <span class="comment">// Case 4</span>
<a name="l00460"></a>00460               xi   = xi_saved;
<a name="l00461"></a>00461               zeta = -zeta_saved;
<a name="l00462"></a>00462             }
<a name="l00463"></a>00463 
<a name="l00464"></a>00464         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(6) == min_point)
<a name="l00465"></a>00465           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(7) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(7), elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2)))
<a name="l00466"></a>00466             {
<a name="l00467"></a>00467               <span class="comment">// Case 5</span>
<a name="l00468"></a>00468               xi   = -xi_saved;
<a name="l00469"></a>00469               zeta = -zeta_saved;
<a name="l00470"></a>00470             }
<a name="l00471"></a>00471           <span class="keywordflow">else</span>
<a name="l00472"></a>00472             {
<a name="l00473"></a>00473               <span class="comment">// Case 6</span>
<a name="l00474"></a>00474               xi   = -zeta_saved;
<a name="l00475"></a>00475               zeta = -xi_saved;
<a name="l00476"></a>00476             }
<a name="l00477"></a>00477 
<a name="l00478"></a>00478         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(2) == min_point)
<a name="l00479"></a>00479           {
<a name="l00480"></a>00480             <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(6) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3), elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(6)))
<a name="l00481"></a>00481               {
<a name="l00482"></a>00482                 <span class="comment">// Case 7</span>
<a name="l00483"></a>00483                 xi   = zeta_saved;
<a name="l00484"></a>00484                 zeta = -xi_saved;
<a name="l00485"></a>00485               }
<a name="l00486"></a>00486             <span class="keywordflow">else</span>
<a name="l00487"></a>00487               {
<a name="l00488"></a>00488                 <span class="comment">// Case 8</span>
<a name="l00489"></a>00489                 xi   = -xi_saved;
<a name="l00490"></a>00490               zeta = zeta_saved;
<a name="l00491"></a>00491               }
<a name="l00492"></a>00492           }
<a name="l00493"></a>00493       }
<a name="l00494"></a>00494     <span class="comment">// Face 4</span>
<a name="l00495"></a>00495     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 12*e + 5*e*e)
<a name="l00496"></a>00496       {
<a name="l00497"></a>00497         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basisnum = i - 8 - 12*e - 4*e*e;
<a name="l00498"></a>00498         i0 = 0;
<a name="l00499"></a>00499         i1 = <a class="code" href="number__lookups_8C.php#a607440daec332e28892bdc860dce25b6">square_number_row</a>[basisnum] + 2;
<a name="l00500"></a>00500         i2 = <a class="code" href="number__lookups_8C.php#a8f3c09eca07801e0ff9eb08f48af8e74">square_number_column</a>[basisnum] + 2;
<a name="l00501"></a>00501         <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> min_point = get_min_point(elem, 3, 0, 4, 7);
<a name="l00502"></a>00502 
<a name="l00503"></a>00503         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0) == min_point)
<a name="l00504"></a>00504           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3), elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(4)))
<a name="l00505"></a>00505             {
<a name="l00506"></a>00506               <span class="comment">// Case 1</span>
<a name="l00507"></a>00507               eta  = eta_saved;
<a name="l00508"></a>00508               zeta = zeta_saved;
<a name="l00509"></a>00509             }
<a name="l00510"></a>00510           <span class="keywordflow">else</span>
<a name="l00511"></a>00511             {
<a name="l00512"></a>00512               <span class="comment">// Case 2</span>
<a name="l00513"></a>00513               eta  = zeta_saved;
<a name="l00514"></a>00514               zeta = eta_saved;
<a name="l00515"></a>00515             }
<a name="l00516"></a>00516 
<a name="l00517"></a>00517         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(4) == min_point)
<a name="l00518"></a>00518           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0), elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(7)))
<a name="l00519"></a>00519             {
<a name="l00520"></a>00520               <span class="comment">// Case 3</span>
<a name="l00521"></a>00521               eta  = -zeta_saved;
<a name="l00522"></a>00522               zeta = eta_saved;
<a name="l00523"></a>00523             }
<a name="l00524"></a>00524           <span class="keywordflow">else</span>
<a name="l00525"></a>00525             {
<a name="l00526"></a>00526               <span class="comment">// Case 4</span>
<a name="l00527"></a>00527               eta  = eta_saved;
<a name="l00528"></a>00528               zeta = -zeta_saved;
<a name="l00529"></a>00529             }
<a name="l00530"></a>00530 
<a name="l00531"></a>00531         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(7) == min_point)
<a name="l00532"></a>00532           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(4) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(4), elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3)))
<a name="l00533"></a>00533             {
<a name="l00534"></a>00534               <span class="comment">// Case 5</span>
<a name="l00535"></a>00535               eta  = -eta_saved;
<a name="l00536"></a>00536               zeta = -zeta_saved;
<a name="l00537"></a>00537             }
<a name="l00538"></a>00538           <span class="keywordflow">else</span>
<a name="l00539"></a>00539             {
<a name="l00540"></a>00540               <span class="comment">// Case 6</span>
<a name="l00541"></a>00541               eta  = -zeta_saved;
<a name="l00542"></a>00542               zeta = -eta_saved;
<a name="l00543"></a>00543             }
<a name="l00544"></a>00544 
<a name="l00545"></a>00545         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(3) == min_point)
<a name="l00546"></a>00546           {
<a name="l00547"></a>00547             <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(7) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(7), elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0)))
<a name="l00548"></a>00548               {
<a name="l00549"></a>00549                 <span class="comment">// Case 7</span>
<a name="l00550"></a>00550                 eta   = zeta_saved;
<a name="l00551"></a>00551                 zeta = -eta_saved;
<a name="l00552"></a>00552               }
<a name="l00553"></a>00553             <span class="keywordflow">else</span>
<a name="l00554"></a>00554               {
<a name="l00555"></a>00555                 <span class="comment">// Case 8</span>
<a name="l00556"></a>00556                 eta  = -eta_saved;
<a name="l00557"></a>00557                 zeta = zeta_saved;
<a name="l00558"></a>00558               }
<a name="l00559"></a>00559           }
<a name="l00560"></a>00560       }
<a name="l00561"></a>00561     <span class="comment">// Face 5</span>
<a name="l00562"></a>00562     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 12*e + 6*e*e)
<a name="l00563"></a>00563       {
<a name="l00564"></a>00564         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basisnum = i - 8 - 12*e - 5*e*e;
<a name="l00565"></a>00565         i0 = <a class="code" href="number__lookups_8C.php#a607440daec332e28892bdc860dce25b6">square_number_row</a>[basisnum] + 2;
<a name="l00566"></a>00566         i1 = <a class="code" href="number__lookups_8C.php#a8f3c09eca07801e0ff9eb08f48af8e74">square_number_column</a>[basisnum] + 2;
<a name="l00567"></a>00567         i2 = 1;
<a name="l00568"></a>00568         <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> min_point = get_min_point(elem, 4, 5, 6, 7);
<a name="l00569"></a>00569 
<a name="l00570"></a>00570         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(4) == min_point)
<a name="l00571"></a>00571           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(5) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(5), elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(7)))
<a name="l00572"></a>00572             {
<a name="l00573"></a>00573               <span class="comment">// Case 1</span>
<a name="l00574"></a>00574               xi  = xi_saved;
<a name="l00575"></a>00575               eta = eta_saved;
<a name="l00576"></a>00576             }
<a name="l00577"></a>00577           <span class="keywordflow">else</span>
<a name="l00578"></a>00578             {
<a name="l00579"></a>00579               <span class="comment">// Case 2</span>
<a name="l00580"></a>00580               xi  = eta_saved;
<a name="l00581"></a>00581               eta = xi_saved;
<a name="l00582"></a>00582             }
<a name="l00583"></a>00583 
<a name="l00584"></a>00584         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(5) == min_point)
<a name="l00585"></a>00585           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(6) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(6), elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(4)))
<a name="l00586"></a>00586             {
<a name="l00587"></a>00587               <span class="comment">// Case 3</span>
<a name="l00588"></a>00588               xi  = eta_saved;
<a name="l00589"></a>00589               eta = -xi_saved;
<a name="l00590"></a>00590             }
<a name="l00591"></a>00591           <span class="keywordflow">else</span>
<a name="l00592"></a>00592             {
<a name="l00593"></a>00593               <span class="comment">// Case 4</span>
<a name="l00594"></a>00594               xi  = -xi_saved;
<a name="l00595"></a>00595               eta = eta_saved;
<a name="l00596"></a>00596             }
<a name="l00597"></a>00597 
<a name="l00598"></a>00598         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(6) == min_point)
<a name="l00599"></a>00599           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(7) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(7), elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(5)))
<a name="l00600"></a>00600             {
<a name="l00601"></a>00601               <span class="comment">// Case 5</span>
<a name="l00602"></a>00602               xi  = -xi_saved;
<a name="l00603"></a>00603               eta = -eta_saved;
<a name="l00604"></a>00604             }
<a name="l00605"></a>00605           <span class="keywordflow">else</span>
<a name="l00606"></a>00606             {
<a name="l00607"></a>00607               <span class="comment">// Case 6</span>
<a name="l00608"></a>00608               xi  = -eta_saved;
<a name="l00609"></a>00609               eta = -xi_saved;
<a name="l00610"></a>00610             }
<a name="l00611"></a>00611 
<a name="l00612"></a>00612         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(7) == min_point)
<a name="l00613"></a>00613           {
<a name="l00614"></a>00614             <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(4) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(4), elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(6)))
<a name="l00615"></a>00615               {
<a name="l00616"></a>00616                 <span class="comment">// Case 7</span>
<a name="l00617"></a>00617                 xi  = -eta_saved;
<a name="l00618"></a>00618                 eta = xi_saved;
<a name="l00619"></a>00619               }
<a name="l00620"></a>00620             <span class="keywordflow">else</span>
<a name="l00621"></a>00621               {
<a name="l00622"></a>00622                 <span class="comment">// Case 8</span>
<a name="l00623"></a>00623                 xi  = xi_saved;
<a name="l00624"></a>00624                 eta = eta_saved;
<a name="l00625"></a>00625               }
<a name="l00626"></a>00626           }
<a name="l00627"></a>00627       }
<a name="l00628"></a>00628 
<a name="l00629"></a>00629     <span class="comment">// Internal DoFs</span>
<a name="l00630"></a>00630     <span class="keywordflow">else</span> 
<a name="l00631"></a>00631       {
<a name="l00632"></a>00632         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basisnum = i - 8 - 12*e - 6*e*e;
<a name="l00633"></a>00633         i0 = <a class="code" href="number__lookups_8C.php#a08eed34cf5726558293af7814c3f3e46">cube_number_column</a>[basisnum] + 2;
<a name="l00634"></a>00634         i1 = <a class="code" href="number__lookups_8C.php#ade3895f6acabbbe08a14664cd9dcc647">cube_number_row</a>[basisnum] + 2;
<a name="l00635"></a>00635         i2 = <a class="code" href="number__lookups_8C.php#a4bb4665a9c67a1466fdae770392d3fef">cube_number_page</a>[basisnum] + 2;
<a name="l00636"></a>00636       }
<a name="l00637"></a>00637   }
<a name="l00638"></a>00638 } <span class="comment">// end anonymous namespace</span>
<a name="l00639"></a>00639 
<a name="l00640"></a>00640 
<a name="l00641"></a>00641 
<a name="l00642"></a>00642 
<a name="l00643"></a>00643 <span class="keyword">template</span> &lt;&gt;
<a name="l00644"></a><a class="code" href="classFE.php#a1015770a28797b9294fb16d26f2ee342">00644</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">FE&lt;3,HIERARCHIC&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00645"></a>00645                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,
<a name="l00646"></a>00646                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00647"></a>00647                              <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp;)
<a name="l00648"></a>00648 {
<a name="l00649"></a>00649   std::cerr &lt;&lt; <span class="stringliteral">&quot;Hierarchic polynomials require the element type\n&quot;</span>
<a name="l00650"></a>00650             &lt;&lt; <span class="stringliteral">&quot;because edge and face orientation is needed.&quot;</span>
<a name="l00651"></a>00651             &lt;&lt; std::endl;
<a name="l00652"></a>00652   
<a name="l00653"></a>00653   libmesh_error();
<a name="l00654"></a>00654   <span class="keywordflow">return</span> 0.;
<a name="l00655"></a>00655 }
<a name="l00656"></a>00656 
<a name="l00657"></a>00657 
<a name="l00658"></a>00658 
<a name="l00659"></a>00659 <span class="keyword">template</span> &lt;&gt;
<a name="l00660"></a><a class="code" href="classFE.php#a4d9da2d67543851cc05037db98452c44">00660</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">FE&lt;3,HIERARCHIC&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00661"></a>00661                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00662"></a>00662                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00663"></a>00663                              <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p)
<a name="l00664"></a>00664 {
<a name="l00665"></a>00665 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00666"></a>00666 <span class="preprocessor"></span>  
<a name="l00667"></a>00667   libmesh_assert (elem != NULL);
<a name="l00668"></a>00668   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type = elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>();
<a name="l00669"></a>00669 
<a name="l00670"></a>00670   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> totalorder = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order+elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>());
<a name="l00671"></a>00671   
<a name="l00672"></a>00672   <span class="keywordflow">switch</span> (type)
<a name="l00673"></a>00673     {
<a name="l00674"></a>00674     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00675"></a>00675     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00676"></a>00676       libmesh_assert(totalorder &lt; 2);
<a name="l00677"></a>00677     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00678"></a>00678       {
<a name="l00679"></a>00679         libmesh_assert (i&lt;(totalorder+1u)*(totalorder+1u)*(totalorder+1u));
<a name="l00680"></a>00680         
<a name="l00681"></a>00681         <span class="comment">// Compute hex shape functions as a tensor-product</span>
<a name="l00682"></a>00682         <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xi   = p(0);
<a name="l00683"></a>00683         <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> eta  = p(1);
<a name="l00684"></a>00684         <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> zeta = p(2);
<a name="l00685"></a>00685         
<a name="l00686"></a>00686         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i0, i1, i2;
<a name="l00687"></a>00687         
<a name="l00688"></a>00688         cube_indices(elem, totalorder, i, xi, eta, zeta, i0, i1, i2);
<a name="l00689"></a>00689 
<a name="l00690"></a>00690         <span class="keywordflow">return</span> (<a class="code" href="classFE.php">FE&lt;1,HIERARCHIC&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0, xi)*
<a name="l00691"></a>00691                 <a class="code" href="classFE.php">FE&lt;1,HIERARCHIC&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1, eta)*
<a name="l00692"></a>00692                 <a class="code" href="classFE.php">FE&lt;1,HIERARCHIC&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2, zeta));
<a name="l00693"></a>00693       }
<a name="l00694"></a>00694 
<a name="l00695"></a>00695     <span class="keywordflow">default</span>:
<a name="l00696"></a>00696       libmesh_error();
<a name="l00697"></a>00697     }
<a name="l00698"></a>00698   
<a name="l00699"></a>00699 <span class="preprocessor">#endif</span>
<a name="l00700"></a>00700 <span class="preprocessor"></span>      
<a name="l00701"></a>00701   libmesh_error();
<a name="l00702"></a>00702   <span class="keywordflow">return</span> 0.;
<a name="l00703"></a>00703 }
<a name="l00704"></a>00704 
<a name="l00705"></a>00705 
<a name="l00706"></a>00706 
<a name="l00707"></a>00707 
<a name="l00708"></a>00708 <span class="keyword">template</span> &lt;&gt;
<a name="l00709"></a><a class="code" href="classFE.php#a4d00f5d7a2eada1700a66ee31ae333dd">00709</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;3,HIERARCHIC&gt;::shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00710"></a>00710                                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,
<a name="l00711"></a>00711                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00712"></a>00712                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00713"></a>00713                                    <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; )
<a name="l00714"></a>00714 {
<a name="l00715"></a>00715   std::cerr &lt;&lt; <span class="stringliteral">&quot;Hierarchic polynomials require the element type\n&quot;</span>
<a name="l00716"></a>00716             &lt;&lt; <span class="stringliteral">&quot;because edge and face orientation is needed.&quot;</span>
<a name="l00717"></a>00717             &lt;&lt; std::endl;
<a name="l00718"></a>00718   libmesh_error();
<a name="l00719"></a>00719   
<a name="l00720"></a>00720   <span class="keywordflow">return</span> 0.;
<a name="l00721"></a>00721 }
<a name="l00722"></a>00722 
<a name="l00723"></a>00723 
<a name="l00724"></a>00724 
<a name="l00725"></a>00725 <span class="keyword">template</span> &lt;&gt;
<a name="l00726"></a><a class="code" href="classFE.php#aaf997c5ad2f7292f28a7e5c03dc46c9f">00726</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFE.php#ac7a8713e0c8ff72ab420731e9f692185">FE&lt;3,HIERARCHIC&gt;::shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00727"></a>00727                                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00728"></a>00728                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00729"></a>00729                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00730"></a>00730                                    <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p)
<a name="l00731"></a>00731 {
<a name="l00732"></a>00732 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00733"></a>00733 <span class="preprocessor"></span>  libmesh_assert (elem != NULL);
<a name="l00734"></a>00734 
<a name="l00735"></a>00735   libmesh_assert (j &lt; 3);
<a name="l00736"></a>00736   
<a name="l00737"></a>00737   <span class="comment">// cheat by using finite difference approximations:</span>
<a name="l00738"></a>00738   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> eps = 1.e-6;
<a name="l00739"></a>00739   <a class="code" href="classPoint.php">Point</a> pp, pm;
<a name="l00740"></a>00740         
<a name="l00741"></a>00741   <span class="keywordflow">switch</span> (j)
<a name="l00742"></a>00742   {
<a name="l00743"></a>00743     <span class="comment">// d()/dxi</span>
<a name="l00744"></a>00744   <span class="keywordflow">case</span> 0:
<a name="l00745"></a>00745     {
<a name="l00746"></a>00746       pp = <a class="code" href="classPoint.php">Point</a>(p(0)+eps, p(1), p(2));
<a name="l00747"></a>00747       pm = <a class="code" href="classPoint.php">Point</a>(p(0)-eps, p(1), p(2));
<a name="l00748"></a>00748       <span class="keywordflow">break</span>;
<a name="l00749"></a>00749     }
<a name="l00750"></a>00750 
<a name="l00751"></a>00751     <span class="comment">// d()/deta</span>
<a name="l00752"></a>00752   <span class="keywordflow">case</span> 1:
<a name="l00753"></a>00753     {
<a name="l00754"></a>00754       pp = <a class="code" href="classPoint.php">Point</a>(p(0), p(1)+eps, p(2));
<a name="l00755"></a>00755       pm = <a class="code" href="classPoint.php">Point</a>(p(0), p(1)-eps, p(2));
<a name="l00756"></a>00756       <span class="keywordflow">break</span>;
<a name="l00757"></a>00757     }
<a name="l00758"></a>00758 
<a name="l00759"></a>00759     <span class="comment">// d()/dzeta</span>
<a name="l00760"></a>00760   <span class="keywordflow">case</span> 2:
<a name="l00761"></a>00761     {
<a name="l00762"></a>00762       pp = <a class="code" href="classPoint.php">Point</a>(p(0), p(1), p(2)+eps);
<a name="l00763"></a>00763       pm = <a class="code" href="classPoint.php">Point</a>(p(0), p(1), p(2)-eps);
<a name="l00764"></a>00764       <span class="keywordflow">break</span>;
<a name="l00765"></a>00765     }
<a name="l00766"></a>00766 
<a name="l00767"></a>00767   <span class="keywordflow">default</span>:
<a name="l00768"></a>00768     libmesh_error();
<a name="l00769"></a>00769   }
<a name="l00770"></a>00770 
<a name="l00771"></a>00771   <span class="keywordflow">return</span> (<a class="code" href="classFE.php">FE&lt;3,HIERARCHIC&gt;::shape</a>(elem, order, i, pp) -
<a name="l00772"></a>00772           <a class="code" href="classFE.php">FE&lt;3,HIERARCHIC&gt;::shape</a>(elem, order, i, pm))/2./eps;
<a name="l00773"></a>00773 <span class="preprocessor">#endif</span>
<a name="l00774"></a>00774 <span class="preprocessor"></span>  
<a name="l00775"></a>00775   libmesh_error();
<a name="l00776"></a>00776   <span class="keywordflow">return</span> 0.;
<a name="l00777"></a>00777 }
<a name="l00778"></a>00778 
<a name="l00779"></a>00779 
<a name="l00780"></a>00780 
<a name="l00781"></a>00781 <span class="keyword">template</span> &lt;&gt;
<a name="l00782"></a><a class="code" href="classFE.php#a3ad666a03adf16c6e263d4f6aef25902">00782</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;3,HIERARCHIC&gt;::shape_second_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00783"></a>00783                                           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,
<a name="l00784"></a>00784                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00785"></a>00785                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00786"></a>00786                                           <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; )
<a name="l00787"></a>00787 {
<a name="l00788"></a>00788   std::cerr &lt;&lt; <span class="stringliteral">&quot;Hierarchic polynomials require the element type\n&quot;</span>
<a name="l00789"></a>00789             &lt;&lt; <span class="stringliteral">&quot;because edge and face orientation is needed.&quot;</span>
<a name="l00790"></a>00790             &lt;&lt; std::endl;
<a name="l00791"></a>00791   libmesh_error();
<a name="l00792"></a>00792   
<a name="l00793"></a>00793   <span class="keywordflow">return</span> 0.;
<a name="l00794"></a>00794 }
<a name="l00795"></a>00795 
<a name="l00796"></a>00796 
<a name="l00797"></a>00797 
<a name="l00798"></a>00798 <span class="keyword">template</span> &lt;&gt;
<a name="l00799"></a><a class="code" href="classFE.php#a475a452fd9acc7ac55512b70cb693b7e">00799</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFE.php#ae74fbd763c3f60aa3fba589aa14bf38b">FE&lt;3,HIERARCHIC&gt;::shape_second_deriv</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00800"></a>00800                                           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00801"></a>00801                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00802"></a>00802                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00803"></a>00803                                           <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p)
<a name="l00804"></a>00804 {
<a name="l00805"></a>00805   libmesh_assert (elem != NULL);
<a name="l00806"></a>00806 
<a name="l00807"></a>00807   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> eps = 1.e-6;
<a name="l00808"></a>00808   <a class="code" href="classPoint.php">Point</a> pp, pm;
<a name="l00809"></a>00809   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> prevj = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00810"></a>00810 
<a name="l00811"></a>00811   <span class="keywordflow">switch</span> (j)
<a name="l00812"></a>00812   {
<a name="l00813"></a>00813     <span class="comment">//  d^2()/dxi^2</span>
<a name="l00814"></a>00814     <span class="keywordflow">case</span> 0:
<a name="l00815"></a>00815       {
<a name="l00816"></a>00816         pp = <a class="code" href="classPoint.php">Point</a>(p(0)+eps, p(1), p(2));
<a name="l00817"></a>00817         pm = <a class="code" href="classPoint.php">Point</a>(p(0)-eps, p(1), p(2));
<a name="l00818"></a>00818         prevj = 0;
<a name="l00819"></a>00819         <span class="keywordflow">break</span>;
<a name="l00820"></a>00820       }
<a name="l00821"></a>00821 
<a name="l00822"></a>00822     <span class="comment">//  d^2()/dxideta</span>
<a name="l00823"></a>00823     <span class="keywordflow">case</span> 1:
<a name="l00824"></a>00824       {
<a name="l00825"></a>00825         pp = <a class="code" href="classPoint.php">Point</a>(p(0), p(1)+eps, p(2));
<a name="l00826"></a>00826         pm = <a class="code" href="classPoint.php">Point</a>(p(0), p(1)-eps, p(2));
<a name="l00827"></a>00827         prevj = 0;
<a name="l00828"></a>00828         <span class="keywordflow">break</span>;
<a name="l00829"></a>00829       }
<a name="l00830"></a>00830 
<a name="l00831"></a>00831     <span class="comment">//  d^2()/deta^2</span>
<a name="l00832"></a>00832     <span class="keywordflow">case</span> 2:
<a name="l00833"></a>00833       {
<a name="l00834"></a>00834         pp = <a class="code" href="classPoint.php">Point</a>(p(0), p(1)+eps, p(2));
<a name="l00835"></a>00835         pm = <a class="code" href="classPoint.php">Point</a>(p(0), p(1)-eps, p(2));
<a name="l00836"></a>00836         prevj = 1;
<a name="l00837"></a>00837         <span class="keywordflow">break</span>;
<a name="l00838"></a>00838       }
<a name="l00839"></a>00839 
<a name="l00840"></a>00840     <span class="comment">//  d^2()/dxidzeta</span>
<a name="l00841"></a>00841     <span class="keywordflow">case</span> 3:
<a name="l00842"></a>00842       {
<a name="l00843"></a>00843         pp = <a class="code" href="classPoint.php">Point</a>(p(0), p(1), p(2)+eps);
<a name="l00844"></a>00844         pm = <a class="code" href="classPoint.php">Point</a>(p(0), p(1), p(2)-eps);
<a name="l00845"></a>00845         prevj = 0;
<a name="l00846"></a>00846         <span class="keywordflow">break</span>;
<a name="l00847"></a>00847       }
<a name="l00848"></a>00848 
<a name="l00849"></a>00849     <span class="comment">//  d^2()/detadzeta</span>
<a name="l00850"></a>00850     <span class="keywordflow">case</span> 4:
<a name="l00851"></a>00851       {
<a name="l00852"></a>00852         pp = <a class="code" href="classPoint.php">Point</a>(p(0), p(1), p(2)+eps);
<a name="l00853"></a>00853         pm = <a class="code" href="classPoint.php">Point</a>(p(0), p(1), p(2)-eps);
<a name="l00854"></a>00854         prevj = 1;
<a name="l00855"></a>00855         <span class="keywordflow">break</span>;
<a name="l00856"></a>00856       }
<a name="l00857"></a>00857 
<a name="l00858"></a>00858     <span class="comment">//  d^2()/dzeta^2</span>
<a name="l00859"></a>00859     <span class="keywordflow">case</span> 5:
<a name="l00860"></a>00860       {
<a name="l00861"></a>00861         pp = <a class="code" href="classPoint.php">Point</a>(p(0), p(1), p(2)+eps);
<a name="l00862"></a>00862         pm = <a class="code" href="classPoint.php">Point</a>(p(0), p(1), p(2)-eps);
<a name="l00863"></a>00863         prevj = 2;
<a name="l00864"></a>00864         <span class="keywordflow">break</span>;
<a name="l00865"></a>00865       }
<a name="l00866"></a>00866     <span class="keywordflow">default</span>:
<a name="l00867"></a>00867       libmesh_error();
<a name="l00868"></a>00868   }
<a name="l00869"></a>00869   <span class="keywordflow">return</span> (<a class="code" href="classFE.php">FE&lt;3,HIERARCHIC&gt;::shape_deriv</a>(elem, order, i, prevj, pp) -
<a name="l00870"></a>00870           <a class="code" href="classFE.php">FE&lt;3,HIERARCHIC&gt;::shape_deriv</a>(elem, order, i, prevj, pm))
<a name="l00871"></a>00871           / 2. / eps;
<a name="l00872"></a>00872 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
