<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f00dea3e7b839559ab8b1786e03603be.php">fe</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>fe_interface.h</h1>  </div>
</div>
<div class="contents">
<a href="fe__interface_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_interface.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __fe_interface_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __fe_interface_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;enum_elem_type.h&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// forward declarations</span>
<a name="l00035"></a>00035 <span class="keyword">class </span><a class="code" href="classBoundaryInfo.php">BoundaryInfo</a>;
<a name="l00036"></a>00036 <span class="keyword">class </span><a class="code" href="classDofConstraints.php">DofConstraints</a>;
<a name="l00037"></a>00037 <span class="keyword">class </span><a class="code" href="classDofMap.php">DofMap</a>;
<a name="l00038"></a>00038 <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00039"></a>00039 <span class="keyword">class </span><a class="code" href="classFEType.php">FEType</a>;
<a name="l00040"></a>00040 <span class="keyword">class </span><a class="code" href="classFEComputeData.php">FEComputeData</a>;
<a name="l00041"></a>00041 <span class="keyword">class </span><a class="code" href="classPeriodicBoundaries.php">PeriodicBoundaries</a>;
<a name="l00042"></a>00042 <span class="keyword">class </span><a class="code" href="classPoint.php">Point</a>;
<a name="l00043"></a>00043 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00044"></a>00044 
<a name="l00054"></a>00054 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00055"></a>00055 <span class="comment">// FEInterface class definition</span>
<a name="l00056"></a>00056 
<a name="l00057"></a><a class="code" href="classFEInterface.php">00057</a> <span class="keyword">class </span><a class="code" href="classFEInterface.php">FEInterface</a>
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059 <span class="keyword">private</span>:
<a name="l00060"></a>00060 
<a name="l00064"></a>00064   <a class="code" href="classFEInterface.php#a0620c253d47b7c31bf29948d0374833b">FEInterface</a>();
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 <span class="keyword">public</span>:
<a name="l00067"></a>00067   
<a name="l00071"></a><a class="code" href="classFEInterface.php#a414932f3ca085cc36e085d219de51675">00071</a>   <span class="keyword">virtual</span> <a class="code" href="classFEInterface.php#a414932f3ca085cc36e085d219de51675">~FEInterface</a>() {<span class="keywordflow">return</span>;}
<a name="l00072"></a>00072 
<a name="l00080"></a>00080   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">n_shape_functions</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00081"></a>00081                                         <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00082"></a>00082                                         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t);
<a name="l00083"></a>00083 
<a name="l00091"></a>00091   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">n_dofs</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00092"></a>00092                              <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00093"></a>00093                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t);
<a name="l00094"></a>00094 
<a name="l00102"></a>00102   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">n_dofs_at_node</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00103"></a>00103                                      <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00104"></a>00104                                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00105"></a>00105                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l00106"></a>00106 
<a name="l00114"></a>00114   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">n_dofs_per_elem</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00115"></a>00115                                       <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00116"></a>00116                                       <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t);
<a name="l00117"></a>00117 
<a name="l00125"></a>00125   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">dofs_on_side</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00126"></a>00126                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00127"></a>00127                            <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00128"></a>00128                            <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00129"></a>00129                            std::vector&lt;unsigned int&gt;&amp; di);
<a name="l00130"></a>00130 
<a name="l00138"></a>00138   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">dofs_on_edge</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00139"></a>00139                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00140"></a>00140                            <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00141"></a>00141                            <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e,
<a name="l00142"></a>00142                            std::vector&lt;unsigned int&gt;&amp; di);
<a name="l00143"></a>00143   
<a name="l00155"></a>00155   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">nodal_soln</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00156"></a>00156                          <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00157"></a>00157                          <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00158"></a>00158                          <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; elem_soln,
<a name="l00159"></a>00159                          std::vector&lt;Number&gt;&amp; <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">nodal_soln</a>);
<a name="l00160"></a>00160 
<a name="l00170"></a>00170   <span class="keyword">static</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">inverse_map</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00171"></a>00171                             <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00172"></a>00172                             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00173"></a>00173                             <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00174"></a>00174                             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tolerance = TOLERANCE,
<a name="l00175"></a>00175                             <span class="keyword">const</span> <span class="keywordtype">bool</span> secure = <span class="keyword">true</span>);
<a name="l00176"></a>00176 
<a name="l00188"></a>00188   <span class="keyword">static</span> <span class="keywordtype">void</span>  <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">inverse_map</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00189"></a>00189                             <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00190"></a>00190                             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00191"></a>00191                             <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; physical_points,
<a name="l00192"></a>00192                             std::vector&lt;Point&gt;&amp;       reference_points,
<a name="l00193"></a>00193                             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tolerance = TOLERANCE,
<a name="l00194"></a>00194                             <span class="keyword">const</span> <span class="keywordtype">bool</span> secure = <span class="keyword">true</span>);
<a name="l00195"></a>00195 
<a name="l00203"></a>00203   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classFEInterface.php#a74fa7b62c80d4740411a97560988211a">on_reference_element</a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00204"></a>00204                                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00205"></a>00205                                    <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> eps=1.e-6);
<a name="l00214"></a>00214   <span class="keyword">static</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">shape</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00215"></a>00215                     <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00216"></a>00216                     <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00217"></a>00217                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00218"></a>00218                     <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p);
<a name="l00219"></a>00219 
<a name="l00228"></a>00228   <span class="keyword">static</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">shape</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00229"></a>00229                     <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00230"></a>00230                     <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00231"></a>00231                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00232"></a>00232                     <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p);
<a name="l00233"></a>00233 
<a name="l00243"></a>00243   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classFEInterface.php#a6ae681af86208c304eb7d45b8a712e3c">compute_data</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00244"></a>00244                            <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00245"></a>00245                            <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00246"></a>00246                            <a class="code" href="classFEComputeData.php">FEComputeData</a>&amp; data);
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00249"></a>00249 <span class="preprocessor"></span>
<a name="l00254"></a>00254   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classFEInterface.php#a5c4a1f291fedb8641a3c58220f94b5b3">compute_constraints</a> (<a class="code" href="classDofConstraints.php">DofConstraints</a> &amp;constraints,
<a name="l00255"></a>00255                                    <a class="code" href="classDofMap.php">DofMap</a> &amp;dof_map,
<a name="l00256"></a>00256                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> variable_number,
<a name="l00257"></a>00257                                    <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem);
<a name="l00258"></a>00258 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00259"></a>00259 <span class="preprocessor"></span>
<a name="l00260"></a>00260 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00261"></a>00261 <span class="preprocessor"></span>
<a name="l00266"></a>00266   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classFEInterface.php#a5d15bd861ecf0a755eabf1e4695d5c3b">compute_periodic_constraints</a> (<a class="code" href="classDofConstraints.php">DofConstraints</a> &amp;constraints,
<a name="l00267"></a>00267                                             <a class="code" href="classDofMap.php">DofMap</a> &amp;dof_map,
<a name="l00268"></a>00268                                             <a class="code" href="classPeriodicBoundaries.php">PeriodicBoundaries</a> &amp;boundaries,
<a name="l00269"></a>00269                                             <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00270"></a>00270                                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> variable_number,
<a name="l00271"></a>00271                                             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem);
<a name="l00272"></a>00272 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00273"></a>00273 <span class="preprocessor"></span>
<a name="l00278"></a>00278   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFEInterface.php#aa5e5dfcfc5a000f3fe044153aa068bba">max_order</a> (<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00279"></a>00279                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>&amp; el_t);
<a name="l00280"></a>00280 
<a name="l00285"></a>00285   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classFEInterface.php#a3d821150f7d5a6315292b5c2117ef417">extra_hanging_dofs</a> (<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t);
<a name="l00286"></a>00286 
<a name="l00287"></a>00287 <span class="keyword">private</span>:
<a name="l00288"></a>00288 
<a name="l00289"></a>00289 
<a name="l00296"></a>00296   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classFEInterface.php#a490850a95469eaf9a14d56c93bc99679">is_InfFE_elem</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> et);
<a name="l00297"></a>00297 
<a name="l00298"></a>00298 
<a name="l00299"></a>00299 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00300"></a>00300 <span class="preprocessor"></span>
<a name="l00301"></a>00301   <span class="comment">// ------------------------------------------------------------</span>
<a name="l00302"></a>00302   <span class="comment">/*</span>
<a name="l00303"></a>00303 <span class="comment">   * All these private members do the same as their public</span>
<a name="l00304"></a>00304 <span class="comment">   * counterparts, but for infinite elements. This dis-entangles</span>
<a name="l00305"></a>00305 <span class="comment">   * the calls to \p FE and \p InfFE.</span>
<a name="l00306"></a>00306 <span class="comment">   */</span>
<a name="l00307"></a>00307 
<a name="l00308"></a>00308   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFEInterface.php#a5cc4efdc035c4e9f625bc58737458426">ifem_n_shape_functions</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00309"></a>00309                                              <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00310"></a>00310                                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t);
<a name="l00311"></a>00311 
<a name="l00312"></a>00312   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFEInterface.php#a166e8bf05290d5d849a8c1c03a25b649">ifem_n_dofs</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00313"></a>00313                                   <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00314"></a>00314                                   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t);
<a name="l00315"></a>00315 
<a name="l00316"></a>00316   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFEInterface.php#a54eeef852b5494748e19b264541b0146">ifem_n_dofs_at_node</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00317"></a>00317                                           <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00318"></a>00318                                           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00319"></a>00319                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l00320"></a>00320 
<a name="l00321"></a>00321   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFEInterface.php#abafd644a74d292ae1ad395312f2553eb">ifem_n_dofs_per_elem</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00322"></a>00322                                            <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00323"></a>00323                                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t);
<a name="l00324"></a>00324   
<a name="l00325"></a>00325   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classFEInterface.php#a66e3fbb5ddd660f7f1c0c62ed31446f0">ifem_nodal_soln</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00326"></a>00326                               <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00327"></a>00327                               <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00328"></a>00328                               <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; elem_soln,
<a name="l00329"></a>00329                               std::vector&lt;Number&gt;&amp; <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">nodal_soln</a>);
<a name="l00330"></a>00330 
<a name="l00331"></a>00331   <span class="keyword">static</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classFEInterface.php#a15e50e6ceb8ebc9b602bf80ad4f57858">ifem_inverse_map</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00332"></a>00332                                  <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00333"></a>00333                                  <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00334"></a>00334                                  <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00335"></a>00335                                  <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tolerance = TOLERANCE,
<a name="l00336"></a>00336                                  <span class="keyword">const</span> <span class="keywordtype">bool</span> secure = <span class="keyword">true</span>);
<a name="l00337"></a>00337   
<a name="l00338"></a>00338   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classFEInterface.php#a15e50e6ceb8ebc9b602bf80ad4f57858">ifem_inverse_map</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00339"></a>00339                                 <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00340"></a>00340                                 <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00341"></a>00341                                 <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; physical_points,
<a name="l00342"></a>00342                                 std::vector&lt;Point&gt;&amp;       reference_points,
<a name="l00343"></a>00343                                 <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tolerance = TOLERANCE,
<a name="l00344"></a>00344                                 <span class="keyword">const</span> <span class="keywordtype">bool</span> secure = <span class="keyword">true</span>);
<a name="l00345"></a>00345     
<a name="l00346"></a>00346 
<a name="l00347"></a>00347   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classFEInterface.php#a2f7c00ab9c0d9dce1eea280ebee0b478">ifem_on_reference_element</a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00348"></a>00348                                         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00349"></a>00349                                         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> eps);
<a name="l00350"></a>00350 
<a name="l00351"></a>00351   <span class="keyword">static</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFEInterface.php#a5720b471c00c2d4b19081072864311af">ifem_shape</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00352"></a>00352                          <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00353"></a>00353                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00354"></a>00354                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00355"></a>00355                          <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p);
<a name="l00356"></a>00356 
<a name="l00357"></a>00357   <span class="keyword">static</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFEInterface.php#a5720b471c00c2d4b19081072864311af">ifem_shape</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00358"></a>00358                          <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00359"></a>00359                          <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00360"></a>00360                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00361"></a>00361                          <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p);
<a name="l00362"></a>00362 
<a name="l00363"></a>00363   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classFEInterface.php#a93dc7080b53c474a76ae585749808f63">ifem_compute_data</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00364"></a>00364                                 <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00365"></a>00365                                 <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00366"></a>00366                                 <a class="code" href="classFEComputeData.php">FEComputeData</a>&amp; data);
<a name="l00367"></a>00367 
<a name="l00368"></a>00368 <span class="preprocessor">#endif</span>
<a name="l00369"></a>00369 <span class="preprocessor"></span>
<a name="l00370"></a>00370 
<a name="l00371"></a>00371 };
<a name="l00372"></a>00372 
<a name="l00373"></a>00373 
<a name="l00374"></a>00374 
<a name="l00375"></a>00375 
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00378"></a>00378 <span class="comment">// FEInterface class inline members</span>
<a name="l00379"></a>00379 <span class="preprocessor">#ifndef LIBMESH_ENABLE_INFINITE_ELEMENTS </span>
<a name="l00380"></a>00380 <span class="preprocessor"></span>
<a name="l00381"></a><a class="code" href="classFEInterface.php#a490850a95469eaf9a14d56c93bc99679">00381</a> <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classFEInterface.php#a490850a95469eaf9a14d56c93bc99679">FEInterface::is_InfFE_elem</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>)
<a name="l00382"></a>00382 {
<a name="l00383"></a>00383   <span class="keywordflow">return</span> <span class="keyword">false</span>; 
<a name="l00384"></a>00384 }
<a name="l00385"></a>00385 
<a name="l00386"></a>00386 <span class="preprocessor">#else</span>
<a name="l00387"></a>00387 <span class="preprocessor"></span>
<a name="l00388"></a>00388 <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classFEInterface.php#a490850a95469eaf9a14d56c93bc99679">FEInterface::is_InfFE_elem</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> et)
<a name="l00389"></a>00389 {
<a name="l00390"></a>00390 
<a name="l00391"></a>00391   <span class="keywordflow">switch</span> (et)
<a name="l00392"></a>00392     {
<a name="l00393"></a>00393     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a278476b80069e0630827235779c82c47">INFEDGE2</a>:
<a name="l00394"></a>00394     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a23d0ae825ee3f493b6504b71f28e2aef">INFQUAD4</a>:
<a name="l00395"></a>00395     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a669ef57bb0d4c72fd22fa0f4febe6ac1">INFQUAD6</a>:
<a name="l00396"></a>00396     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a54cedbd05931dd2cb7dcabf0109bddcb">INFHEX8</a>:
<a name="l00397"></a>00397     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a583e72df1b20e339d9f8fcea6a94c1d4">INFHEX16</a>:
<a name="l00398"></a>00398     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4e68f53177cc7d1366225dfc8f7bbbed">INFHEX18</a>:
<a name="l00399"></a>00399     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac6743a9a04524105e37159e924c4a33b">INFPRISM6</a>:
<a name="l00400"></a>00400     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a89630f5af6a58aaa9ae731d924139c61">INFPRISM12</a>:
<a name="l00401"></a>00401       {
<a name="l00402"></a>00402         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00403"></a>00403       }
<a name="l00404"></a>00404       
<a name="l00405"></a>00405     <span class="keywordflow">default</span>:
<a name="l00406"></a>00406       { 
<a name="l00407"></a>00407         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00408"></a>00408       }
<a name="l00409"></a>00409     }
<a name="l00410"></a>00410 }
<a name="l00411"></a>00411 
<a name="l00412"></a>00412 <span class="preprocessor">#endif //ifndef LIBMESH_ENABLE_INFINITE_ELEMENTS </span>
<a name="l00413"></a>00413 <span class="preprocessor"></span>
<a name="l00414"></a>00414 
<a name="l00415"></a>00415 
<a name="l00416"></a>00416 
<a name="l00417"></a>00417 
<a name="l00418"></a>00418 
<a name="l00419"></a>00419 <span class="preprocessor">#endif // ifndef __fe_interface_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
