<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_60be1125a39495b698d2d56e8e5b50b1.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>fem_context.C</h1>  </div>
</div>
<div class="contents">
<a href="fem__context_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fem_context.C 3502 2009-10-20 18:06:50Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;dof_map.h&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;fe_base.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;fe_interface.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;equation_systems.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;fem_context.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;fem_system.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;mesh.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;quadrature.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;sparse_matrix.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;time_solver.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;unsteady_solver.h&quot;</span> <span class="comment">// For euler_residual</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a><a class="code" href="classFEMContext.php#a173598a8cc070ceffefd4c575dbc0ea3">00041</a> <a class="code" href="classFEMContext.php#a173598a8cc070ceffefd4c575dbc0ea3">FEMContext::FEMContext</a> (<span class="keyword">const</span> <a class="code" href="classFEMSystem.php">FEMSystem</a> &amp;sys)
<a name="l00042"></a>00042   : <a class="code" href="classDiffContext.php">DiffContext</a>(sys),
<a name="l00043"></a>00043     element_qrule(NULL), side_qrule(NULL),
<a name="l00044"></a>00044     _mesh_sys(libMesh::<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a>),
<a name="l00045"></a>00045     _mesh_x_var(libMesh::<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a>),
<a name="l00046"></a>00046     _mesh_y_var(libMesh::<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a>),
<a name="l00047"></a>00047     _mesh_z_var(libMesh::<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a>),
<a name="l00048"></a>00048     elem(NULL), side(0), dim(sys.get_mesh().mesh_dimension())
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050   <span class="comment">// We need to know which of our variables has the hardest</span>
<a name="l00051"></a>00051   <span class="comment">// shape functions to numerically integrate.</span>
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_vars = sys.<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>();
<a name="l00054"></a>00054 
<a name="l00055"></a>00055   libmesh_assert (n_vars);
<a name="l00056"></a>00056   <a class="code" href="classFEType.php">FEType</a> hardest_fe_type = sys.<a class="code" href="classSystem.php#aa917dd59a348a46e9adab63d9767460f">variable_type</a>(0);
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_vars; ++i)
<a name="l00059"></a>00059     {
<a name="l00060"></a>00060       <a class="code" href="classFEType.php">FEType</a> fe_type = sys.<a class="code" href="classSystem.php#aa917dd59a348a46e9adab63d9767460f">variable_type</a>(i);
<a name="l00061"></a>00061 
<a name="l00062"></a>00062       <span class="comment">// FIXME - we don&#39;t yet handle mixed finite elements from</span>
<a name="l00063"></a>00063       <span class="comment">// different families which require different quadrature rules</span>
<a name="l00064"></a>00064       <span class="comment">// libmesh_assert (fe_type.family == hardest_fe_type.family);</span>
<a name="l00065"></a>00065 
<a name="l00066"></a>00066       <span class="keywordflow">if</span> (fe_type.<a class="code" href="classFEType.php#a72c29a6dbf3f2a84728111122cec4742">order</a> &gt; hardest_fe_type.<a class="code" href="classFEType.php#a72c29a6dbf3f2a84728111122cec4742">order</a>)
<a name="l00067"></a>00067         hardest_fe_type = fe_type;
<a name="l00068"></a>00068     }
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="comment">// Create an adequate quadrature rule</span>
<a name="l00071"></a>00071   <a class="code" href="classFEMContext.php#a3be41281e28b8021e92e41b3028556db">element_qrule</a> = hardest_fe_type.<a class="code" href="classFEType.php#a33013296ee9643faec0262714ad9163c">default_quadrature_rule</a>
<a name="l00072"></a>00072     (<a class="code" href="classFEMContext.php#af2f40bcea6e5c825fa61cfb8d10615a1">dim</a>, sys.<a class="code" href="classFEMSystem.php#a8b2fd912dd7f212979f048561dcf5814">extra_quadrature_order</a>).<a class="code" href="classAutoPtr.php#af9d9cdff0aa3e2df96b18b197be2c9ac" title="Bypassing the smart pointer.">release</a>();
<a name="l00073"></a>00073   <a class="code" href="classFEMContext.php#aafe642ee3623ff45a3b9ed54e2af52e4">side_qrule</a> = hardest_fe_type.<a class="code" href="classFEType.php#a33013296ee9643faec0262714ad9163c">default_quadrature_rule</a>
<a name="l00074"></a>00074     (<a class="code" href="classFEMContext.php#af2f40bcea6e5c825fa61cfb8d10615a1">dim</a>-1, sys.<a class="code" href="classFEMSystem.php#a8b2fd912dd7f212979f048561dcf5814">extra_quadrature_order</a>).<a class="code" href="classAutoPtr.php#af9d9cdff0aa3e2df96b18b197be2c9ac" title="Bypassing the smart pointer.">release</a>();
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <span class="comment">// Next, create finite element objects</span>
<a name="l00077"></a>00077   <a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>.resize(n_vars);
<a name="l00078"></a>00078   <a class="code" href="classFEMContext.php#a1c4541019276284edbccac006a0be3fe">side_fe_var</a>.resize(n_vars);
<a name="l00079"></a>00079   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_vars; ++i)
<a name="l00080"></a>00080     {
<a name="l00081"></a>00081       <a class="code" href="classFEType.php">FEType</a> fe_type = sys.<a class="code" href="classSystem.php#aa917dd59a348a46e9adab63d9767460f">variable_type</a>(i);
<a name="l00082"></a>00082       <span class="keywordflow">if</span> (<a class="code" href="classFEMContext.php#a6ad7d8e1a449cec71169e375da34ea84">element_fe</a>[fe_type] == NULL)
<a name="l00083"></a>00083         {
<a name="l00084"></a>00084           <a class="code" href="classFEMContext.php#a6ad7d8e1a449cec71169e375da34ea84">element_fe</a>[fe_type] = <a class="code" href="classFEBase.php#a3e86219b79ce4f881e9c48f4fd7b860e">FEBase::build</a>(<a class="code" href="classFEMContext.php#af2f40bcea6e5c825fa61cfb8d10615a1">dim</a>, fe_type).<a class="code" href="classAutoPtr.php#af9d9cdff0aa3e2df96b18b197be2c9ac" title="Bypassing the smart pointer.">release</a>();
<a name="l00085"></a>00085           <a class="code" href="classFEMContext.php#a6ad7d8e1a449cec71169e375da34ea84">element_fe</a>[fe_type]-&gt;attach_quadrature_rule(<a class="code" href="classFEMContext.php#a3be41281e28b8021e92e41b3028556db">element_qrule</a>);
<a name="l00086"></a>00086           <a class="code" href="classFEMContext.php#a1f8e72ea50a3a2c2f20e40c4897b85da">side_fe</a>[fe_type] = <a class="code" href="classFEBase.php#a3e86219b79ce4f881e9c48f4fd7b860e">FEBase::build</a>(<a class="code" href="classFEMContext.php#af2f40bcea6e5c825fa61cfb8d10615a1">dim</a>, fe_type).<a class="code" href="classAutoPtr.php#af9d9cdff0aa3e2df96b18b197be2c9ac" title="Bypassing the smart pointer.">release</a>();
<a name="l00087"></a>00087           <a class="code" href="classFEMContext.php#a1f8e72ea50a3a2c2f20e40c4897b85da">side_fe</a>[fe_type]-&gt;attach_quadrature_rule(<a class="code" href="classFEMContext.php#aafe642ee3623ff45a3b9ed54e2af52e4">side_qrule</a>);
<a name="l00088"></a>00088         }
<a name="l00089"></a>00089       <a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[i] = <a class="code" href="classFEMContext.php#a6ad7d8e1a449cec71169e375da34ea84">element_fe</a>[fe_type];
<a name="l00090"></a>00090       <a class="code" href="classFEMContext.php#a1c4541019276284edbccac006a0be3fe">side_fe_var</a>[i] = <a class="code" href="classFEMContext.php#a1f8e72ea50a3a2c2f20e40c4897b85da">side_fe</a>[fe_type];
<a name="l00091"></a>00091     }
<a name="l00092"></a>00092 }
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a><a class="code" href="classFEMContext.php#a9ed2c4e9f4f3e24b35a8d89cc26060f7">00095</a> <a class="code" href="classFEMContext.php#a9ed2c4e9f4f3e24b35a8d89cc26060f7">FEMContext::~FEMContext</a>()
<a name="l00096"></a>00096 {
<a name="l00097"></a>00097   <span class="comment">// We don&#39;t want to store AutoPtrs in STL containers, but we don&#39;t</span>
<a name="l00098"></a>00098   <span class="comment">// want to leak memory either</span>
<a name="l00099"></a>00099   <span class="keywordflow">for</span> (std::map&lt;FEType, FEBase *&gt;::iterator i = <a class="code" href="classFEMContext.php#a6ad7d8e1a449cec71169e375da34ea84">element_fe</a>.begin();
<a name="l00100"></a>00100        i != <a class="code" href="classFEMContext.php#a6ad7d8e1a449cec71169e375da34ea84">element_fe</a>.end(); ++i)
<a name="l00101"></a>00101     <span class="keyword">delete</span> i-&gt;second;
<a name="l00102"></a>00102   <a class="code" href="classFEMContext.php#a6ad7d8e1a449cec71169e375da34ea84">element_fe</a>.clear();
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="keywordflow">for</span> (std::map&lt;FEType, FEBase *&gt;::iterator i = <a class="code" href="classFEMContext.php#a1f8e72ea50a3a2c2f20e40c4897b85da">side_fe</a>.begin();
<a name="l00105"></a>00105        i != <a class="code" href="classFEMContext.php#a1f8e72ea50a3a2c2f20e40c4897b85da">side_fe</a>.end(); ++i)
<a name="l00106"></a>00106     <span class="keyword">delete</span> i-&gt;second;
<a name="l00107"></a>00107   <a class="code" href="classFEMContext.php#a1f8e72ea50a3a2c2f20e40c4897b85da">side_fe</a>.clear();
<a name="l00108"></a>00108 
<a name="l00109"></a>00109   <span class="keyword">delete</span> <a class="code" href="classFEMContext.php#a3be41281e28b8021e92e41b3028556db">element_qrule</a>;
<a name="l00110"></a>00110   <a class="code" href="classFEMContext.php#a3be41281e28b8021e92e41b3028556db">element_qrule</a> = NULL;
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   <span class="keyword">delete</span> <a class="code" href="classFEMContext.php#aafe642ee3623ff45a3b9ed54e2af52e4">side_qrule</a>;
<a name="l00113"></a>00113   <a class="code" href="classFEMContext.php#aafe642ee3623ff45a3b9ed54e2af52e4">side_qrule</a> = NULL;
<a name="l00114"></a>00114 }
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a><a class="code" href="classFEMContext.php#a5b2baa1edbf8d7aba30f7beb36c45daf">00118</a> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classFEMContext.php#a5b2baa1edbf8d7aba30f7beb36c45daf">FEMContext::interior_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00119"></a>00119 {
<a name="l00120"></a>00120   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00121"></a>00121   libmesh_assert (<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>.size() &gt; var);
<a name="l00122"></a>00122   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[var].size();
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <span class="comment">// Get current local coefficients</span>
<a name="l00125"></a>00125   libmesh_assert (<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>.size() &gt; var);
<a name="l00126"></a>00126   libmesh_assert (<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[var] != NULL);
<a name="l00127"></a>00127   <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[var];
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00130"></a>00130   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt; &amp;phi =
<a name="l00131"></a>00131     <a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[var]-&gt;get_phi();
<a name="l00132"></a>00132 
<a name="l00133"></a>00133   <span class="comment">// Accumulate solution value</span>
<a name="l00134"></a>00134   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> u = 0.;
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00137"></a>00137     u += phi[l][qp] * coef(l);
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   <span class="keywordflow">return</span> u;
<a name="l00140"></a>00140 }
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a><a class="code" href="classFEMContext.php#a67f09e3ce6d11d805e1106874fa99504">00144</a> <a class="code" href="classVectorValue.php">Gradient</a> <a class="code" href="classFEMContext.php#a67f09e3ce6d11d805e1106874fa99504">FEMContext::interior_gradient</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00145"></a>00145 {
<a name="l00146"></a>00146   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00147"></a>00147   libmesh_assert (<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>.size() &gt; var);
<a name="l00148"></a>00148   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[var].size();
<a name="l00149"></a>00149 
<a name="l00150"></a>00150   <span class="comment">// Get current local coefficients</span>
<a name="l00151"></a>00151   libmesh_assert (<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>.size() &gt; var);
<a name="l00152"></a>00152   libmesh_assert (<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[var] != NULL);
<a name="l00153"></a>00153   <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[var];
<a name="l00154"></a>00154 
<a name="l00155"></a>00155   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00156"></a>00156   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt; &amp;dphi =
<a name="l00157"></a>00157     <a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[var]-&gt;get_dphi();
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   <span class="comment">// Accumulate solution derivatives</span>
<a name="l00160"></a>00160   <a class="code" href="classVectorValue.php">Gradient</a> du;
<a name="l00161"></a>00161 
<a name="l00162"></a>00162   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00163"></a>00163     du.<a class="code" href="classTypeVector.php#ac9000695cb19991b893cb79a07249e9c">add_scaled</a>(dphi[l][qp], coef(l));
<a name="l00164"></a>00164 
<a name="l00165"></a>00165   <span class="keywordflow">return</span> du;
<a name="l00166"></a>00166 }
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00171"></a><a class="code" href="classFEMContext.php#aea30ca152a64ba57f790039ea6f7e2af">00171</a> <span class="preprocessor"></span><a class="code" href="classTensorValue.php">Tensor</a> <a class="code" href="classFEMContext.php#aea30ca152a64ba57f790039ea6f7e2af">FEMContext::interior_hessian</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00172"></a>00172 {
<a name="l00173"></a>00173   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00174"></a>00174   libmesh_assert (<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>.size() &gt; var);
<a name="l00175"></a>00175   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[var].size();
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   <span class="comment">// Get current local coefficients</span>
<a name="l00178"></a>00178   libmesh_assert (<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>.size() &gt; var);
<a name="l00179"></a>00179   libmesh_assert (<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[var] != NULL);
<a name="l00180"></a>00180   <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[var];
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00183"></a>00183   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealTensor&gt; &gt; &amp;d2phi =
<a name="l00184"></a>00184     <a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[var]-&gt;get_d2phi();
<a name="l00185"></a>00185 
<a name="l00186"></a>00186   <span class="comment">// Accumulate solution second derivatives</span>
<a name="l00187"></a>00187   <a class="code" href="classTensorValue.php">Tensor</a> d2u;
<a name="l00188"></a>00188 
<a name="l00189"></a>00189   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00190"></a>00190     d2u.<a class="code" href="classTypeTensor.php#ae24569251bc6ea38090165d349fdfc6c">add_scaled</a>(d2phi[l][qp], coef(l));
<a name="l00191"></a>00191 
<a name="l00192"></a>00192   <span class="keywordflow">return</span> d2u;
<a name="l00193"></a>00193 }
<a name="l00194"></a>00194 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00195"></a>00195 <span class="preprocessor"></span>
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a><a class="code" href="classFEMContext.php#ad4c1670626ff3f40218477b16d391bf7">00198</a> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classFEMContext.php#ad4c1670626ff3f40218477b16d391bf7">FEMContext::side_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00199"></a>00199 {
<a name="l00200"></a>00200   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00201"></a>00201   libmesh_assert (<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>.size() &gt; var);
<a name="l00202"></a>00202   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[var].size();
<a name="l00203"></a>00203 
<a name="l00204"></a>00204   <span class="comment">// Get current local coefficients</span>
<a name="l00205"></a>00205   libmesh_assert (<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>.size() &gt; var);
<a name="l00206"></a>00206   libmesh_assert (<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[var] != NULL);
<a name="l00207"></a>00207   <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[var];
<a name="l00208"></a>00208 
<a name="l00209"></a>00209   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00210"></a>00210   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt; &amp;phi =
<a name="l00211"></a>00211     <a class="code" href="classFEMContext.php#a1c4541019276284edbccac006a0be3fe">side_fe_var</a>[var]-&gt;get_phi();
<a name="l00212"></a>00212 
<a name="l00213"></a>00213   <span class="comment">// Accumulate solution value</span>
<a name="l00214"></a>00214   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> u = 0.;
<a name="l00215"></a>00215 
<a name="l00216"></a>00216   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00217"></a>00217     u += phi[l][qp] * coef(l);
<a name="l00218"></a>00218 
<a name="l00219"></a>00219   <span class="keywordflow">return</span> u;
<a name="l00220"></a>00220 }
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 
<a name="l00224"></a><a class="code" href="classFEMContext.php#a8b5404fbd7787f74f2af8f5024ca38ca">00224</a> <a class="code" href="classVectorValue.php">Gradient</a> <a class="code" href="classFEMContext.php#a8b5404fbd7787f74f2af8f5024ca38ca">FEMContext::side_gradient</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00225"></a>00225 {
<a name="l00226"></a>00226   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00227"></a>00227   libmesh_assert (<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>.size() &gt; var);
<a name="l00228"></a>00228   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[var].size();
<a name="l00229"></a>00229 
<a name="l00230"></a>00230   <span class="comment">// Get current local coefficients</span>
<a name="l00231"></a>00231   libmesh_assert (<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>.size() &gt; var);
<a name="l00232"></a>00232   libmesh_assert (<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[var] != NULL);
<a name="l00233"></a>00233   <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[var];
<a name="l00234"></a>00234 
<a name="l00235"></a>00235   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00236"></a>00236   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt; &amp;dphi =
<a name="l00237"></a>00237     <a class="code" href="classFEMContext.php#a1c4541019276284edbccac006a0be3fe">side_fe_var</a>[var]-&gt;get_dphi();
<a name="l00238"></a>00238 
<a name="l00239"></a>00239   <span class="comment">// Accumulate solution derivatives</span>
<a name="l00240"></a>00240   <a class="code" href="classVectorValue.php">Gradient</a> du;
<a name="l00241"></a>00241 
<a name="l00242"></a>00242   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00243"></a>00243     du.<a class="code" href="classTypeVector.php#ac9000695cb19991b893cb79a07249e9c">add_scaled</a>(dphi[l][qp], coef(l));
<a name="l00244"></a>00244 
<a name="l00245"></a>00245   <span class="keywordflow">return</span> du;
<a name="l00246"></a>00246 }
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 
<a name="l00250"></a>00250 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00251"></a><a class="code" href="classFEMContext.php#aa9ab7a6f30341955cbf71171113c2e6d">00251</a> <span class="preprocessor"></span><a class="code" href="classTensorValue.php">Tensor</a> <a class="code" href="classFEMContext.php#aa9ab7a6f30341955cbf71171113c2e6d">FEMContext::side_hessian</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00252"></a>00252 {
<a name="l00253"></a>00253   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00254"></a>00254   libmesh_assert (<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>.size() &gt; var);
<a name="l00255"></a>00255   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[var].size();
<a name="l00256"></a>00256 
<a name="l00257"></a>00257   <span class="comment">// Get current local coefficients</span>
<a name="l00258"></a>00258   libmesh_assert (<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>.size() &gt; var);
<a name="l00259"></a>00259   libmesh_assert (<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[var] != NULL);
<a name="l00260"></a>00260   <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[var];
<a name="l00261"></a>00261 
<a name="l00262"></a>00262   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00263"></a>00263   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealTensor&gt; &gt; &amp;d2phi =
<a name="l00264"></a>00264     <a class="code" href="classFEMContext.php#a1c4541019276284edbccac006a0be3fe">side_fe_var</a>[var]-&gt;get_d2phi();
<a name="l00265"></a>00265 
<a name="l00266"></a>00266   <span class="comment">// Accumulate solution second derivatives</span>
<a name="l00267"></a>00267   <a class="code" href="classTensorValue.php">Tensor</a> d2u;
<a name="l00268"></a>00268 
<a name="l00269"></a>00269   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00270"></a>00270     d2u.<a class="code" href="classTypeTensor.php#ae24569251bc6ea38090165d349fdfc6c">add_scaled</a>(d2phi[l][qp], coef(l));
<a name="l00271"></a>00271 
<a name="l00272"></a>00272   <span class="keywordflow">return</span> d2u;
<a name="l00273"></a>00273 }
<a name="l00274"></a>00274 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00275"></a>00275 <span class="preprocessor"></span>
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 
<a name="l00278"></a><a class="code" href="classFEMContext.php#a16c05d1a8484c7a7b0488e86ef46d146">00278</a> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classFEMContext.php#a16c05d1a8484c7a7b0488e86ef46d146">FEMContext::point_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <a class="code" href="classPoint.php">Point</a> &amp;p)
<a name="l00279"></a>00279 {
<a name="l00280"></a>00280   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00281"></a>00281   libmesh_assert (<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>.size() &gt; var);
<a name="l00282"></a>00282   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[var].size();
<a name="l00283"></a>00283 
<a name="l00284"></a>00284   
<a name="l00285"></a>00285   <span class="comment">// Get current local coefficients</span>
<a name="l00286"></a>00286   libmesh_assert (<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>.size() &gt; var);
<a name="l00287"></a>00287   libmesh_assert (<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[var] != NULL);
<a name="l00288"></a>00288   <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[var];
<a name="l00289"></a>00289 
<a name="l00290"></a>00290   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> u = 0.;
<a name="l00291"></a>00291 
<a name="l00292"></a>00292   <a class="code" href="classFEType.php">FEType</a> fe_type = <a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[var]-&gt;get_fe_type();
<a name="l00293"></a>00293   <a class="code" href="classPoint.php">Point</a> p_master = <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FEInterface::inverse_map</a>(<a class="code" href="classFEMContext.php#af2f40bcea6e5c825fa61cfb8d10615a1">dim</a>, fe_type, <a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>, p);
<a name="l00294"></a>00294 
<a name="l00295"></a>00295   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00296"></a>00296     u += <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FEInterface::shape</a>(<a class="code" href="classFEMContext.php#af2f40bcea6e5c825fa61cfb8d10615a1">dim</a>, fe_type, <a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>, l, p_master)
<a name="l00297"></a>00297          * coef(l);
<a name="l00298"></a>00298 
<a name="l00299"></a>00299   <span class="keywordflow">return</span> u;
<a name="l00300"></a>00300 }
<a name="l00301"></a>00301 
<a name="l00302"></a>00302 
<a name="l00303"></a>00303 
<a name="l00304"></a><a class="code" href="classFEMContext.php#ad11a4604390af0dbda24685ac4e853a9">00304</a> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classFEMContext.php#ad11a4604390af0dbda24685ac4e853a9">FEMContext::fixed_interior_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00305"></a>00305 {
<a name="l00306"></a>00306   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00307"></a>00307   libmesh_assert (<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>.size() &gt; var);
<a name="l00308"></a>00308   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[var].size();
<a name="l00309"></a>00309 
<a name="l00310"></a>00310   <span class="comment">// Get current local coefficients</span>
<a name="l00311"></a>00311   libmesh_assert (<a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>.size() &gt; var);
<a name="l00312"></a>00312   libmesh_assert (<a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>[var] != NULL);
<a name="l00313"></a>00313   <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>[var];
<a name="l00314"></a>00314 
<a name="l00315"></a>00315   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00316"></a>00316   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt; &amp;phi =
<a name="l00317"></a>00317     <a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[var]-&gt;get_phi();
<a name="l00318"></a>00318 
<a name="l00319"></a>00319   <span class="comment">// Accumulate solution value</span>
<a name="l00320"></a>00320   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> u = 0.;
<a name="l00321"></a>00321 
<a name="l00322"></a>00322   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00323"></a>00323     u += phi[l][qp] * coef(l);
<a name="l00324"></a>00324 
<a name="l00325"></a>00325   <span class="keywordflow">return</span> u;
<a name="l00326"></a>00326 }
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 
<a name="l00330"></a><a class="code" href="classFEMContext.php#a1817eeb1af549acd19e4e463e4c181bb">00330</a> <a class="code" href="classVectorValue.php">Gradient</a> <a class="code" href="classFEMContext.php#a1817eeb1af549acd19e4e463e4c181bb">FEMContext::fixed_interior_gradient</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00331"></a>00331 {
<a name="l00332"></a>00332   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00333"></a>00333   libmesh_assert (<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>.size() &gt; var);
<a name="l00334"></a>00334   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[var].size();
<a name="l00335"></a>00335 
<a name="l00336"></a>00336   <span class="comment">// Get current local coefficients</span>
<a name="l00337"></a>00337   libmesh_assert (<a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>.size() &gt; var);
<a name="l00338"></a>00338   libmesh_assert (<a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>[var] != NULL);
<a name="l00339"></a>00339   <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>[var];
<a name="l00340"></a>00340 
<a name="l00341"></a>00341   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00342"></a>00342   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt; &amp;dphi =
<a name="l00343"></a>00343     <a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[var]-&gt;get_dphi();
<a name="l00344"></a>00344 
<a name="l00345"></a>00345   <span class="comment">// Accumulate solution derivatives</span>
<a name="l00346"></a>00346   <a class="code" href="classVectorValue.php">Gradient</a> du;
<a name="l00347"></a>00347 
<a name="l00348"></a>00348   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00349"></a>00349     du.<a class="code" href="classTypeVector.php#ac9000695cb19991b893cb79a07249e9c">add_scaled</a>(dphi[l][qp], coef(l));
<a name="l00350"></a>00350 
<a name="l00351"></a>00351   <span class="keywordflow">return</span> du;
<a name="l00352"></a>00352 }
<a name="l00353"></a>00353 
<a name="l00354"></a>00354 
<a name="l00355"></a>00355 
<a name="l00356"></a>00356 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00357"></a><a class="code" href="classFEMContext.php#ac9ef6b38766724c1209506439f1867af">00357</a> <span class="preprocessor"></span><a class="code" href="classTensorValue.php">Tensor</a> <a class="code" href="classFEMContext.php#ac9ef6b38766724c1209506439f1867af">FEMContext::fixed_interior_hessian</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00358"></a>00358 {
<a name="l00359"></a>00359   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00360"></a>00360   libmesh_assert (<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>.size() &gt; var);
<a name="l00361"></a>00361   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[var].size();
<a name="l00362"></a>00362 
<a name="l00363"></a>00363   <span class="comment">// Get current local coefficients</span>
<a name="l00364"></a>00364   libmesh_assert (<a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>.size() &gt; var);
<a name="l00365"></a>00365   libmesh_assert (<a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>[var] != NULL);
<a name="l00366"></a>00366   <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>[var];
<a name="l00367"></a>00367 
<a name="l00368"></a>00368   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00369"></a>00369   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealTensor&gt; &gt; &amp;d2phi =
<a name="l00370"></a>00370     <a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[var]-&gt;get_d2phi();
<a name="l00371"></a>00371 
<a name="l00372"></a>00372   <span class="comment">// Accumulate solution second derivatives</span>
<a name="l00373"></a>00373   <a class="code" href="classTensorValue.php">Tensor</a> d2u;
<a name="l00374"></a>00374 
<a name="l00375"></a>00375   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00376"></a>00376     d2u.<a class="code" href="classTypeTensor.php#ae24569251bc6ea38090165d349fdfc6c">add_scaled</a>(d2phi[l][qp], coef(l));
<a name="l00377"></a>00377 
<a name="l00378"></a>00378   <span class="keywordflow">return</span> d2u;
<a name="l00379"></a>00379 }
<a name="l00380"></a>00380 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00381"></a>00381 <span class="preprocessor"></span>
<a name="l00382"></a>00382 
<a name="l00383"></a>00383 
<a name="l00384"></a><a class="code" href="classFEMContext.php#a91ed3a921fc132ba446e80823c93ff9c">00384</a> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classFEMContext.php#a91ed3a921fc132ba446e80823c93ff9c">FEMContext::fixed_side_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00385"></a>00385 {
<a name="l00386"></a>00386   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00387"></a>00387   libmesh_assert (<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>.size() &gt; var);
<a name="l00388"></a>00388   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[var].size();
<a name="l00389"></a>00389 
<a name="l00390"></a>00390   <span class="comment">// Get current local coefficients</span>
<a name="l00391"></a>00391   libmesh_assert (<a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>.size() &gt; var);
<a name="l00392"></a>00392   libmesh_assert (<a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>[var] != NULL);
<a name="l00393"></a>00393   <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>[var];
<a name="l00394"></a>00394 
<a name="l00395"></a>00395   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00396"></a>00396   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt; &amp;phi =
<a name="l00397"></a>00397     <a class="code" href="classFEMContext.php#a1c4541019276284edbccac006a0be3fe">side_fe_var</a>[var]-&gt;get_phi();
<a name="l00398"></a>00398 
<a name="l00399"></a>00399   <span class="comment">// Accumulate solution value</span>
<a name="l00400"></a>00400   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> u = 0.;
<a name="l00401"></a>00401 
<a name="l00402"></a>00402   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00403"></a>00403     u += phi[l][qp] * coef(l);
<a name="l00404"></a>00404 
<a name="l00405"></a>00405   <span class="keywordflow">return</span> u;
<a name="l00406"></a>00406 }
<a name="l00407"></a>00407 
<a name="l00408"></a>00408 
<a name="l00409"></a>00409 
<a name="l00410"></a><a class="code" href="classFEMContext.php#a61054551cebb6f9893d88644aeefd15d">00410</a> <a class="code" href="classVectorValue.php">Gradient</a> <a class="code" href="classFEMContext.php#a61054551cebb6f9893d88644aeefd15d">FEMContext::fixed_side_gradient</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00411"></a>00411 {
<a name="l00412"></a>00412   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00413"></a>00413   libmesh_assert (<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>.size() &gt; var);
<a name="l00414"></a>00414   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[var].size();
<a name="l00415"></a>00415 
<a name="l00416"></a>00416   <span class="comment">// Get current local coefficients</span>
<a name="l00417"></a>00417   libmesh_assert (<a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>.size() &gt; var);
<a name="l00418"></a>00418   libmesh_assert (<a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>[var] != NULL);
<a name="l00419"></a>00419   <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>[var];
<a name="l00420"></a>00420 
<a name="l00421"></a>00421   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00422"></a>00422   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt; &amp;dphi =
<a name="l00423"></a>00423     <a class="code" href="classFEMContext.php#a1c4541019276284edbccac006a0be3fe">side_fe_var</a>[var]-&gt;get_dphi();
<a name="l00424"></a>00424 
<a name="l00425"></a>00425   <span class="comment">// Accumulate solution derivatives</span>
<a name="l00426"></a>00426   <a class="code" href="classVectorValue.php">Gradient</a> du;
<a name="l00427"></a>00427 
<a name="l00428"></a>00428   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00429"></a>00429     du.<a class="code" href="classTypeVector.php#ac9000695cb19991b893cb79a07249e9c">add_scaled</a>(dphi[l][qp], coef(l));
<a name="l00430"></a>00430 
<a name="l00431"></a>00431   <span class="keywordflow">return</span> du;
<a name="l00432"></a>00432 }
<a name="l00433"></a>00433 
<a name="l00434"></a>00434 
<a name="l00435"></a>00435 
<a name="l00436"></a>00436 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00437"></a><a class="code" href="classFEMContext.php#ae5805eb22d75190b0ff0133ba6dbf712">00437</a> <span class="preprocessor"></span><a class="code" href="classTensorValue.php">Tensor</a> <a class="code" href="classFEMContext.php#ae5805eb22d75190b0ff0133ba6dbf712">FEMContext::fixed_side_hessian</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00438"></a>00438 {
<a name="l00439"></a>00439   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00440"></a>00440   libmesh_assert (<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>.size() &gt; var);
<a name="l00441"></a>00441   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[var].size();
<a name="l00442"></a>00442 
<a name="l00443"></a>00443   <span class="comment">// Get current local coefficients</span>
<a name="l00444"></a>00444   libmesh_assert (<a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>.size() &gt; var);
<a name="l00445"></a>00445   libmesh_assert (<a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>[var] != NULL);
<a name="l00446"></a>00446   <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>[var];
<a name="l00447"></a>00447 
<a name="l00448"></a>00448   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00449"></a>00449   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealTensor&gt; &gt; &amp;d2phi =
<a name="l00450"></a>00450     <a class="code" href="classFEMContext.php#a1c4541019276284edbccac006a0be3fe">side_fe_var</a>[var]-&gt;get_d2phi();
<a name="l00451"></a>00451 
<a name="l00452"></a>00452   <span class="comment">// Accumulate solution second derivatives</span>
<a name="l00453"></a>00453   <a class="code" href="classTensorValue.php">Tensor</a> d2u;
<a name="l00454"></a>00454 
<a name="l00455"></a>00455   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00456"></a>00456     d2u.<a class="code" href="classTypeTensor.php#ae24569251bc6ea38090165d349fdfc6c">add_scaled</a>(d2phi[l][qp], coef(l));
<a name="l00457"></a>00457 
<a name="l00458"></a>00458   <span class="keywordflow">return</span> d2u;
<a name="l00459"></a>00459 }
<a name="l00460"></a>00460 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00461"></a>00461 <span class="preprocessor"></span>
<a name="l00462"></a>00462 
<a name="l00463"></a>00463 
<a name="l00464"></a><a class="code" href="classFEMContext.php#a12f43decc17002bc6462173c6c3cbc1f">00464</a> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classFEMContext.php#a12f43decc17002bc6462173c6c3cbc1f">FEMContext::fixed_point_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <a class="code" href="classPoint.php">Point</a> &amp;p)
<a name="l00465"></a>00465 {
<a name="l00466"></a>00466   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00467"></a>00467   libmesh_assert (<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>.size() &gt; var);
<a name="l00468"></a>00468   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[var].size();
<a name="l00469"></a>00469 
<a name="l00470"></a>00470   
<a name="l00471"></a>00471   <span class="comment">// Get current local coefficients</span>
<a name="l00472"></a>00472   libmesh_assert (<a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>.size() &gt; var);
<a name="l00473"></a>00473   libmesh_assert (<a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>[var] != NULL);
<a name="l00474"></a>00474   <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>[var];
<a name="l00475"></a>00475 
<a name="l00476"></a>00476   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> u = 0.;
<a name="l00477"></a>00477 
<a name="l00478"></a>00478   <a class="code" href="classFEType.php">FEType</a> fe_type = <a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[var]-&gt;get_fe_type();
<a name="l00479"></a>00479   <a class="code" href="classPoint.php">Point</a> p_master = <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FEInterface::inverse_map</a>(<a class="code" href="classFEMContext.php#af2f40bcea6e5c825fa61cfb8d10615a1">dim</a>, fe_type, <a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>, p);
<a name="l00480"></a>00480 
<a name="l00481"></a>00481   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00482"></a>00482     u += <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FEInterface::shape</a>(<a class="code" href="classFEMContext.php#af2f40bcea6e5c825fa61cfb8d10615a1">dim</a>, fe_type, <a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>, l, p_master)
<a name="l00483"></a>00483          * coef(l);
<a name="l00484"></a>00484 
<a name="l00485"></a>00485   <span class="keywordflow">return</span> u;
<a name="l00486"></a>00486 }
<a name="l00487"></a>00487 
<a name="l00488"></a>00488 
<a name="l00489"></a>00489 
<a name="l00490"></a><a class="code" href="classFEMContext.php#a3edb7c340909fe9e67792e2d785096de">00490</a> <span class="keywordtype">void</span> <a class="code" href="classFEMContext.php#a3edb7c340909fe9e67792e2d785096de">FEMContext::elem_reinit</a>(<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> theta)
<a name="l00491"></a>00491 {
<a name="l00492"></a>00492   <span class="comment">// Handle a moving element if necessary</span>
<a name="l00493"></a>00493   <span class="keywordflow">if</span> (<a class="code" href="classFEMContext.php#a9ee7d0de4dc6ec45807a311dae74c4a6">_mesh_sys</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00494"></a>00494     {
<a name="l00495"></a>00495       <span class="comment">// FIXME - not threadsafe yet!</span>
<a name="l00496"></a>00496       <a class="code" href="classFEMContext.php#aadb724ebd124e1db2e9ef3604b380cca">elem_position_set</a>(theta);
<a name="l00497"></a>00497       <a class="code" href="classFEMContext.php#a8a834570338463f64b5e4e1582385ad9">elem_fe_reinit</a>();
<a name="l00498"></a>00498     }
<a name="l00499"></a>00499 }
<a name="l00500"></a>00500 
<a name="l00501"></a>00501 
<a name="l00502"></a><a class="code" href="classFEMContext.php#afeb811b018e2ab05fa960eaf3f0add16">00502</a> <span class="keywordtype">void</span> <a class="code" href="classFEMContext.php#afeb811b018e2ab05fa960eaf3f0add16">FEMContext::elem_side_reinit</a>(<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> theta)
<a name="l00503"></a>00503 {
<a name="l00504"></a>00504   <span class="comment">// Handle a moving element if necessary</span>
<a name="l00505"></a>00505   <span class="keywordflow">if</span> (<a class="code" href="classFEMContext.php#a9ee7d0de4dc6ec45807a311dae74c4a6">_mesh_sys</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00506"></a>00506     {
<a name="l00507"></a>00507       <span class="comment">// FIXME - not threadsafe yet!</span>
<a name="l00508"></a>00508       <a class="code" href="classFEMContext.php#aadb724ebd124e1db2e9ef3604b380cca">elem_position_set</a>(theta);
<a name="l00509"></a>00509       <a class="code" href="classFEMContext.php#aac3e77bdc0c55a43943333ade0b6cde1">elem_side_fe_reinit</a>();
<a name="l00510"></a>00510     }
<a name="l00511"></a>00511 }
<a name="l00512"></a>00512 
<a name="l00513"></a>00513 
<a name="l00514"></a><a class="code" href="classFEMContext.php#a8a834570338463f64b5e4e1582385ad9">00514</a> <span class="keywordtype">void</span> <a class="code" href="classFEMContext.php#a8a834570338463f64b5e4e1582385ad9">FEMContext::elem_fe_reinit</a> ()
<a name="l00515"></a>00515 {
<a name="l00516"></a>00516   <span class="comment">// Initialize all the interior FE objects on elem.</span>
<a name="l00517"></a>00517   <span class="comment">// Logging of FE::reinit is done in the FE functions</span>
<a name="l00518"></a>00518   std::map&lt;FEType, FEBase *&gt;::iterator fe_end = <a class="code" href="classFEMContext.php#a6ad7d8e1a449cec71169e375da34ea84">element_fe</a>.end();
<a name="l00519"></a>00519   <span class="keywordflow">for</span> (std::map&lt;FEType, FEBase *&gt;::iterator i = <a class="code" href="classFEMContext.php#a6ad7d8e1a449cec71169e375da34ea84">element_fe</a>.begin();
<a name="l00520"></a>00520        i != fe_end; ++i)
<a name="l00521"></a>00521     {
<a name="l00522"></a>00522       i-&gt;second-&gt;reinit(<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>);
<a name="l00523"></a>00523     }
<a name="l00524"></a>00524 }
<a name="l00525"></a>00525 
<a name="l00526"></a>00526 
<a name="l00527"></a><a class="code" href="classFEMContext.php#aac3e77bdc0c55a43943333ade0b6cde1">00527</a> <span class="keywordtype">void</span> <a class="code" href="classFEMContext.php#aac3e77bdc0c55a43943333ade0b6cde1">FEMContext::elem_side_fe_reinit</a> ()
<a name="l00528"></a>00528 {
<a name="l00529"></a>00529   <span class="comment">// Initialize all the interior FE objects on elem/side.</span>
<a name="l00530"></a>00530   <span class="comment">// Logging of FE::reinit is done in the FE functions</span>
<a name="l00531"></a>00531   std::map&lt;FEType, FEBase *&gt;::iterator fe_end = <a class="code" href="classFEMContext.php#a1f8e72ea50a3a2c2f20e40c4897b85da">side_fe</a>.end();
<a name="l00532"></a>00532   <span class="keywordflow">for</span> (std::map&lt;FEType, FEBase *&gt;::iterator i = <a class="code" href="classFEMContext.php#a1f8e72ea50a3a2c2f20e40c4897b85da">side_fe</a>.begin();
<a name="l00533"></a>00533        i != fe_end; ++i)
<a name="l00534"></a>00534     {
<a name="l00535"></a>00535       i-&gt;second-&gt;reinit(<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>, <a class="code" href="classFEMContext.php#a2a9c65a61dcb0947b65df2f862482e96">side</a>);
<a name="l00536"></a>00536     }
<a name="l00537"></a>00537 }
<a name="l00538"></a>00538 
<a name="l00539"></a>00539 
<a name="l00540"></a>00540 
<a name="l00541"></a><a class="code" href="classFEMContext.php#a6de9902c88fa9e48c57973a906f54a99">00541</a> <span class="keywordtype">void</span> <a class="code" href="classFEMContext.php#a6de9902c88fa9e48c57973a906f54a99">FEMContext::elem_position_get</a>()
<a name="l00542"></a>00542 {
<a name="l00543"></a>00543   <span class="comment">// This is too expensive to call unless we&#39;ve been asked to move the mesh</span>
<a name="l00544"></a>00544   libmesh_assert (<a class="code" href="classFEMContext.php#a9ee7d0de4dc6ec45807a311dae74c4a6">_mesh_sys</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>);
<a name="l00545"></a>00545 
<a name="l00546"></a>00546   <span class="comment">// This will probably break with threading when two contexts are</span>
<a name="l00547"></a>00547   <span class="comment">// operating on elements which share a node</span>
<a name="l00548"></a>00548   libmesh_experimental();
<a name="l00549"></a>00549 
<a name="l00550"></a>00550   <span class="comment">// If the coordinate data is in our own system, it&#39;s already</span>
<a name="l00551"></a>00551   <span class="comment">// been set up for us</span>
<a name="l00552"></a>00552 <span class="comment">//  if (_mesh_sys == this-&gt;number())</span>
<a name="l00553"></a>00553 <span class="comment">//    {</span>
<a name="l00554"></a>00554       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a> = <a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>();
<a name="l00555"></a>00555       <span class="comment">// For simplicity we demand that mesh coordinates be stored</span>
<a name="l00556"></a>00556       <span class="comment">// in a format that allows a direct copy</span>
<a name="l00557"></a>00557       libmesh_assert(<a class="code" href="classFEMContext.php#a9d271b748847e080513b50b744081c8f">_mesh_x_var</a> == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a> ||
<a name="l00558"></a>00558                      (<a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[<a class="code" href="classFEMContext.php#a9d271b748847e080513b50b744081c8f">_mesh_x_var</a>]-&gt;get_fe_type().family
<a name="l00559"></a>00559                       == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a> &amp;&amp;
<a name="l00560"></a>00560                       <a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[<a class="code" href="classFEMContext.php#a9d271b748847e080513b50b744081c8f">_mesh_x_var</a>]-&gt;get_fe_type().order
<a name="l00561"></a>00561                       == <a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classElem.php#a6cef8ca882c2fc1081fd27132851627a">default_order</a>()));
<a name="l00562"></a>00562       libmesh_assert(<a class="code" href="classFEMContext.php#a924ead3b0cc9a8e1e8c41b81a738afbf">_mesh_y_var</a> == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a> ||
<a name="l00563"></a>00563                      (<a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[<a class="code" href="classFEMContext.php#a924ead3b0cc9a8e1e8c41b81a738afbf">_mesh_y_var</a>]-&gt;get_fe_type().family
<a name="l00564"></a>00564                       == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a> &amp;&amp;
<a name="l00565"></a>00565                       <a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[<a class="code" href="classFEMContext.php#a924ead3b0cc9a8e1e8c41b81a738afbf">_mesh_y_var</a>]-&gt;get_fe_type().order
<a name="l00566"></a>00566                       == <a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classElem.php#a6cef8ca882c2fc1081fd27132851627a">default_order</a>()));
<a name="l00567"></a>00567       libmesh_assert(<a class="code" href="classFEMContext.php#a2f12db1dee6115a2093399c263ce7674">_mesh_z_var</a> == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a> ||
<a name="l00568"></a>00568                      (<a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[<a class="code" href="classFEMContext.php#a2f12db1dee6115a2093399c263ce7674">_mesh_z_var</a>]-&gt;get_fe_type().family
<a name="l00569"></a>00569                       == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a> &amp;&amp;
<a name="l00570"></a>00570                       <a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[<a class="code" href="classFEMContext.php#a2f12db1dee6115a2093399c263ce7674">_mesh_z_var</a>]-&gt;get_fe_type().order
<a name="l00571"></a>00571                       == <a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classElem.php#a6cef8ca882c2fc1081fd27132851627a">default_order</a>()));
<a name="l00572"></a>00572 
<a name="l00573"></a>00573       <span class="comment">// Get degree of freedom coefficients from point coordinates</span>
<a name="l00574"></a>00574       <span class="keywordflow">if</span> (<a class="code" href="classFEMContext.php#a9d271b748847e080513b50b744081c8f">_mesh_x_var</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00575"></a>00575         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>; ++i)
<a name="l00576"></a>00576           (*<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[<a class="code" href="classFEMContext.php#a9d271b748847e080513b50b744081c8f">_mesh_x_var</a>])(i) = <a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(i)(0);
<a name="l00577"></a>00577 
<a name="l00578"></a>00578       <span class="keywordflow">if</span> (<a class="code" href="classFEMContext.php#a924ead3b0cc9a8e1e8c41b81a738afbf">_mesh_y_var</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00579"></a>00579         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>; ++i)
<a name="l00580"></a>00580           (*<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[<a class="code" href="classFEMContext.php#a924ead3b0cc9a8e1e8c41b81a738afbf">_mesh_y_var</a>])(i) = <a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(i)(1);
<a name="l00581"></a>00581 
<a name="l00582"></a>00582       <span class="keywordflow">if</span> (<a class="code" href="classFEMContext.php#a2f12db1dee6115a2093399c263ce7674">_mesh_z_var</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00583"></a>00583         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>; ++i)
<a name="l00584"></a>00584           (*<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[<a class="code" href="classFEMContext.php#a2f12db1dee6115a2093399c263ce7674">_mesh_z_var</a>])(i) = <a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(i)(2);
<a name="l00585"></a>00585 <span class="comment">//    }</span>
<a name="l00586"></a>00586   <span class="comment">// FIXME - If the coordinate data is not in our own system, someone</span>
<a name="l00587"></a>00587   <span class="comment">// had better get around to implementing that... - RHS</span>
<a name="l00588"></a>00588 <span class="comment">//  else</span>
<a name="l00589"></a>00589 <span class="comment">//    {</span>
<a name="l00590"></a>00590 <span class="comment">//      libmesh_not_implemented();</span>
<a name="l00591"></a>00591 <span class="comment">//    }</span>
<a name="l00592"></a>00592 }
<a name="l00593"></a>00593 
<a name="l00594"></a>00594 
<a name="l00595"></a>00595 
<a name="l00596"></a><a class="code" href="classFEMContext.php#aadb724ebd124e1db2e9ef3604b380cca">00596</a> <span class="keywordtype">void</span> <a class="code" href="classFEMContext.php#aadb724ebd124e1db2e9ef3604b380cca">FEMContext::elem_position_set</a>(<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>)
<a name="l00597"></a>00597 {
<a name="l00598"></a>00598   <span class="comment">// This is too expensive to call unless we&#39;ve been asked to move the mesh</span>
<a name="l00599"></a>00599   libmesh_assert (<a class="code" href="classFEMContext.php#a9ee7d0de4dc6ec45807a311dae74c4a6">_mesh_sys</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>);
<a name="l00600"></a>00600 
<a name="l00601"></a>00601   <span class="comment">// This will probably break with threading when two contexts are</span>
<a name="l00602"></a>00602   <span class="comment">// operating on elements which share a node</span>
<a name="l00603"></a>00603   libmesh_experimental();
<a name="l00604"></a>00604 
<a name="l00605"></a>00605   <span class="comment">// If the coordinate data is in our own system, it&#39;s already</span>
<a name="l00606"></a>00606   <span class="comment">// been set up for us, and we can ignore our input parameter theta</span>
<a name="l00607"></a>00607 <span class="comment">//  if (_mesh_sys == this-&gt;number())</span>
<a name="l00608"></a>00608 <span class="comment">//    {</span>
<a name="l00609"></a>00609       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a> = <a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>();
<a name="l00610"></a>00610       <span class="comment">// For simplicity we demand that mesh coordinates be stored</span>
<a name="l00611"></a>00611       <span class="comment">// in a format that allows a direct copy</span>
<a name="l00612"></a>00612       libmesh_assert(<a class="code" href="classFEMContext.php#a9d271b748847e080513b50b744081c8f">_mesh_x_var</a> == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a> ||
<a name="l00613"></a>00613                      (<a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[<a class="code" href="classFEMContext.php#a9d271b748847e080513b50b744081c8f">_mesh_x_var</a>]-&gt;get_fe_type().family
<a name="l00614"></a>00614                       == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a> &amp;&amp;
<a name="l00615"></a>00615                       <a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[<a class="code" href="classFEMContext.php#a9d271b748847e080513b50b744081c8f">_mesh_x_var</a>]-&gt;size() == n_nodes));
<a name="l00616"></a>00616       libmesh_assert(<a class="code" href="classFEMContext.php#a924ead3b0cc9a8e1e8c41b81a738afbf">_mesh_y_var</a> == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a> ||
<a name="l00617"></a>00617                      (<a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[<a class="code" href="classFEMContext.php#a924ead3b0cc9a8e1e8c41b81a738afbf">_mesh_y_var</a>]-&gt;get_fe_type().family
<a name="l00618"></a>00618                       == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a> &amp;&amp;
<a name="l00619"></a>00619                       <a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[<a class="code" href="classFEMContext.php#a924ead3b0cc9a8e1e8c41b81a738afbf">_mesh_y_var</a>]-&gt;size() == n_nodes));
<a name="l00620"></a>00620       libmesh_assert(<a class="code" href="classFEMContext.php#a2f12db1dee6115a2093399c263ce7674">_mesh_z_var</a> == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a> ||
<a name="l00621"></a>00621                      (<a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[<a class="code" href="classFEMContext.php#a2f12db1dee6115a2093399c263ce7674">_mesh_z_var</a>]-&gt;get_fe_type().family
<a name="l00622"></a>00622                       == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a> &amp;&amp;
<a name="l00623"></a>00623                       <a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[<a class="code" href="classFEMContext.php#a2f12db1dee6115a2093399c263ce7674">_mesh_z_var</a>]-&gt;size() == n_nodes));
<a name="l00624"></a>00624 
<a name="l00625"></a>00625       <span class="comment">// Set the new point coordinates</span>
<a name="l00626"></a>00626       <span class="keywordflow">if</span> (<a class="code" href="classFEMContext.php#a9d271b748847e080513b50b744081c8f">_mesh_x_var</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00627"></a>00627         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>; ++i)
<a name="l00628"></a>00628           <a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(i)(0) =
<a name="l00629"></a>00629             <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>((*<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[<a class="code" href="classFEMContext.php#a9d271b748847e080513b50b744081c8f">_mesh_x_var</a>])(i));
<a name="l00630"></a>00630 
<a name="l00631"></a>00631       <span class="keywordflow">if</span> (<a class="code" href="classFEMContext.php#a924ead3b0cc9a8e1e8c41b81a738afbf">_mesh_y_var</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00632"></a>00632         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>; ++i)
<a name="l00633"></a>00633           <a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(i)(1) =
<a name="l00634"></a>00634             <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>((*<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[<a class="code" href="classFEMContext.php#a924ead3b0cc9a8e1e8c41b81a738afbf">_mesh_y_var</a>])(i));
<a name="l00635"></a>00635 
<a name="l00636"></a>00636       <span class="keywordflow">if</span> (<a class="code" href="classFEMContext.php#a2f12db1dee6115a2093399c263ce7674">_mesh_z_var</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00637"></a>00637         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>; ++i)
<a name="l00638"></a>00638           <a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(i)(2) =
<a name="l00639"></a>00639             <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>((*<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[<a class="code" href="classFEMContext.php#a2f12db1dee6115a2093399c263ce7674">_mesh_z_var</a>])(i));
<a name="l00640"></a>00640 <span class="comment">//    }</span>
<a name="l00641"></a>00641   <span class="comment">// FIXME - If the coordinate data is not in our own system, someone</span>
<a name="l00642"></a>00642   <span class="comment">// had better get around to implementing that... - RHS</span>
<a name="l00643"></a>00643 <span class="comment">//  else</span>
<a name="l00644"></a>00644 <span class="comment">//    {</span>
<a name="l00645"></a>00645 <span class="comment">//      libmesh_not_implemented();</span>
<a name="l00646"></a>00646 <span class="comment">//    }</span>
<a name="l00647"></a>00647 }
<a name="l00648"></a>00648 
<a name="l00649"></a>00649 
<a name="l00650"></a>00650 
<a name="l00651"></a>00651 
<a name="l00652"></a>00652 
<a name="l00653"></a><a class="code" href="classFEMContext.php#abab1b68a634f80e0b991431a793f3edb">00653</a> <span class="keywordtype">void</span> <a class="code" href="classFEMContext.php#abab1b68a634f80e0b991431a793f3edb">FEMContext::reinit</a>(<span class="keyword">const</span> <a class="code" href="classFEMSystem.php">FEMSystem</a> &amp;sys, <a class="code" href="classElem.php">Elem</a> *e)
<a name="l00654"></a>00654 {
<a name="l00655"></a>00655   <a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a> = e;
<a name="l00656"></a>00656   <span class="comment">// Initialize the per-element data for elem.</span>
<a name="l00657"></a>00657   sys.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#afc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>, <a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>);
<a name="l00658"></a>00658   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>.size();
<a name="l00659"></a>00659 
<a name="l00660"></a>00660   <a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>.<a class="code" href="classDenseVector.php#a3a9af103dc052f1dfdef1626692cd8cd">resize</a>(n_dofs);
<a name="l00661"></a>00661   <span class="keywordflow">if</span> (sys.<a class="code" href="classDifferentiableSystem.php#a3e9645837798cc7d10d127b9ce54b0e1">use_fixed_solution</a>)
<a name="l00662"></a>00662     <a class="code" href="classDiffContext.php#a1ab7c2721bfd00d5483f7625fb49e421">elem_fixed_solution</a>.<a class="code" href="classDenseVector.php#a3a9af103dc052f1dfdef1626692cd8cd">resize</a>(n_dofs);
<a name="l00663"></a>00663 
<a name="l00664"></a>00664   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_dofs; ++i)
<a name="l00665"></a>00665     <a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>(i) = sys.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>[i]);
<a name="l00666"></a>00666 
<a name="l00667"></a>00667   <span class="comment">// These resize calls also zero out the residual and jacobian</span>
<a name="l00668"></a>00668   <a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>.<a class="code" href="classDenseVector.php#a3a9af103dc052f1dfdef1626692cd8cd">resize</a>(n_dofs);
<a name="l00669"></a>00669   <a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>.<a class="code" href="classDenseMatrix.php#a8c19724598a1ac1e3c758aaad73beb1b">resize</a>(n_dofs, n_dofs);
<a name="l00670"></a>00670 
<a name="l00671"></a>00671   <span class="comment">// Initialize the per-variable data for elem.</span>
<a name="l00672"></a>00672   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sub_dofs = 0;
<a name="l00673"></a>00673   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != sys.<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>(); ++i)
<a name="l00674"></a>00674     {
<a name="l00675"></a>00675       sys.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#afc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>, <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[i], i);
<a name="l00676"></a>00676 
<a name="l00677"></a>00677       <a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[i]-&gt;reposition
<a name="l00678"></a>00678         (sub_dofs, <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[i].size());
<a name="l00679"></a>00679 
<a name="l00680"></a>00680       <span class="keywordflow">if</span> (sys.<a class="code" href="classDifferentiableSystem.php#a3e9645837798cc7d10d127b9ce54b0e1">use_fixed_solution</a>)
<a name="l00681"></a>00681         <a class="code" href="classDiffContext.php#a641e0131028fdb1d799abb10c13361f6">elem_fixed_subsolutions</a>[i]-&gt;reposition
<a name="l00682"></a>00682           (sub_dofs, <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[i].size());
<a name="l00683"></a>00683 
<a name="l00684"></a>00684       <a class="code" href="classDiffContext.php#a92489ca01a154b956107acd5eab14e1c">elem_subresiduals</a>[i]-&gt;reposition
<a name="l00685"></a>00685         (sub_dofs, <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[i].size());
<a name="l00686"></a>00686 
<a name="l00687"></a>00687       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j != i; ++j)
<a name="l00688"></a>00688         {
<a name="l00689"></a>00689           <a class="code" href="classDiffContext.php#a314b50e71d312179bb30b1800d7677ee">elem_subjacobians</a>[i][j]-&gt;reposition
<a name="l00690"></a>00690             (sub_dofs, <a class="code" href="classDiffContext.php#a92489ca01a154b956107acd5eab14e1c">elem_subresiduals</a>[j]-&gt;i_off(),
<a name="l00691"></a>00691              <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[i].size(),
<a name="l00692"></a>00692              <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[j].size());
<a name="l00693"></a>00693           <a class="code" href="classDiffContext.php#a314b50e71d312179bb30b1800d7677ee">elem_subjacobians</a>[j][i]-&gt;reposition
<a name="l00694"></a>00694             (<a class="code" href="classDiffContext.php#a92489ca01a154b956107acd5eab14e1c">elem_subresiduals</a>[j]-&gt;i_off(), sub_dofs,
<a name="l00695"></a>00695              <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[j].size(),
<a name="l00696"></a>00696              <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[i].size());
<a name="l00697"></a>00697         }
<a name="l00698"></a>00698       <a class="code" href="classDiffContext.php#a314b50e71d312179bb30b1800d7677ee">elem_subjacobians</a>[i][i]-&gt;reposition
<a name="l00699"></a>00699         (sub_dofs, sub_dofs,
<a name="l00700"></a>00700          <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[i].size(),
<a name="l00701"></a>00701          <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[i].size());
<a name="l00702"></a>00702       sub_dofs += <a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[i].size();
<a name="l00703"></a>00703     }
<a name="l00704"></a>00704   libmesh_assert(sub_dofs == n_dofs);
<a name="l00705"></a>00705 
<a name="l00706"></a>00706   <span class="comment">// Moving the mesh may be necessary</span>
<a name="l00707"></a>00707   <span class="keywordflow">if</span> (<a class="code" href="classFEMContext.php#a9ee7d0de4dc6ec45807a311dae74c4a6">_mesh_sys</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00708"></a>00708     <a class="code" href="classFEMContext.php#aadb724ebd124e1db2e9ef3604b380cca">elem_position_set</a>(1.);
<a name="l00709"></a>00709   <span class="comment">// Reinitializing the FE objects is definitely necessary</span>
<a name="l00710"></a>00710   this-&gt;<a class="code" href="classFEMContext.php#a8a834570338463f64b5e4e1582385ad9">elem_fe_reinit</a>();
<a name="l00711"></a>00711 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
