<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>fem_context.h</h1>  </div>
</div>
<div class="contents">
<a href="fem__context_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 <span class="comment">// $Id: fem_context.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00005"></a>00005 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00006"></a>00006   
<a name="l00007"></a>00007 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00008"></a>00008 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00009"></a>00009 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00010"></a>00010 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00011"></a>00011   
<a name="l00012"></a>00012 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00013"></a>00013 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00014"></a>00014 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00015"></a>00015 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00016"></a>00016   
<a name="l00017"></a>00017 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00018"></a>00018 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00019"></a>00019 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifndef __fem_context_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#define __fem_context_h__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="diff__context_8h.php">diff_context.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span><span class="preprocessor">#include &quot;tensor_value.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#endif</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span>
<a name="l00036"></a>00036 <span class="comment">// Forward Declarations</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">class </span><a class="code" href="classFEBase.php">FEBase</a>;
<a name="l00039"></a>00039 <span class="keyword">class </span><a class="code" href="classFEMSystem.php">FEMSystem</a>;
<a name="l00040"></a>00040 <span class="keyword">class </span><a class="code" href="classQBase.php">QBase</a>;
<a name="l00041"></a>00041 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classNumericVector.php">NumericVector</a>;
<a name="l00042"></a>00042 
<a name="l00055"></a>00055 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00056"></a>00056 <span class="comment">// FEMContext class definition</span>
<a name="l00057"></a>00057 
<a name="l00058"></a><a class="code" href="classFEMContext.php">00058</a> <span class="keyword">class </span><a class="code" href="classFEMContext.php">FEMContext</a> : <span class="keyword">public</span> <a class="code" href="classDiffContext.php">DiffContext</a>
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060 <span class="keyword">public</span>:
<a name="l00061"></a>00061 
<a name="l00065"></a>00065   <a class="code" href="classFEMContext.php#a173598a8cc070ceffefd4c575dbc0ea3">FEMContext</a> (<span class="keyword">const</span> <a class="code" href="classFEMSystem.php">FEMSystem</a> &amp;sys);
<a name="l00066"></a>00066 
<a name="l00070"></a>00070   <span class="keyword">virtual</span> <a class="code" href="classFEMContext.php#a9ed2c4e9f4f3e24b35a8d89cc26060f7">~FEMContext</a> ();
<a name="l00071"></a>00071 
<a name="l00076"></a>00076   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classFEMContext.php#a5b2baa1edbf8d7aba30f7beb36c45daf">interior_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00077"></a>00077 
<a name="l00082"></a>00082   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classFEMContext.php#ad4c1670626ff3f40218477b16d391bf7">side_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00083"></a>00083 
<a name="l00088"></a>00088   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classFEMContext.php#a16c05d1a8484c7a7b0488e86ef46d146">point_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <a class="code" href="classPoint.php">Point</a> &amp;p);
<a name="l00089"></a>00089 
<a name="l00094"></a>00094   <a class="code" href="classVectorValue.php">Gradient</a> <a class="code" href="classFEMContext.php#a67f09e3ce6d11d805e1106874fa99504">interior_gradient</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00095"></a>00095 
<a name="l00100"></a>00100   <a class="code" href="classVectorValue.php">Gradient</a> <a class="code" href="classFEMContext.php#a8b5404fbd7787f74f2af8f5024ca38ca">side_gradient</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00103"></a>00103 <span class="preprocessor"></span>
<a name="l00107"></a>00107   <a class="code" href="classTensorValue.php">Tensor</a> <a class="code" href="classFEMContext.php#aea30ca152a64ba57f790039ea6f7e2af">interior_hessian</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00108"></a>00108 
<a name="l00113"></a>00113   <a class="code" href="classTensorValue.php">Tensor</a> <a class="code" href="classFEMContext.php#aa9ab7a6f30341955cbf71171113c2e6d">side_hessian</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 <span class="preprocessor">#endif // LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00116"></a>00116 <span class="preprocessor"></span>
<a name="l00121"></a>00121   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classFEMContext.php#ad11a4604390af0dbda24685ac4e853a9">fixed_interior_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00122"></a>00122 
<a name="l00127"></a>00127   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classFEMContext.php#a91ed3a921fc132ba446e80823c93ff9c">fixed_side_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00128"></a>00128 
<a name="l00133"></a>00133   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classFEMContext.php#a12f43decc17002bc6462173c6c3cbc1f">fixed_point_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <a class="code" href="classPoint.php">Point</a> &amp;p);
<a name="l00134"></a>00134 
<a name="l00139"></a>00139   <a class="code" href="classVectorValue.php">Gradient</a> <a class="code" href="classFEMContext.php#a1817eeb1af549acd19e4e463e4c181bb">fixed_interior_gradient</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00140"></a>00140 
<a name="l00145"></a>00145   <a class="code" href="classVectorValue.php">Gradient</a> <a class="code" href="classFEMContext.php#a61054551cebb6f9893d88644aeefd15d">fixed_side_gradient</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00148"></a>00148 <span class="preprocessor"></span>
<a name="l00152"></a>00152   <a class="code" href="classTensorValue.php">Tensor</a> <a class="code" href="classFEMContext.php#ac9ef6b38766724c1209506439f1867af">fixed_interior_hessian</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00153"></a>00153 
<a name="l00158"></a>00158   <a class="code" href="classTensorValue.php">Tensor</a> <a class="code" href="classFEMContext.php#ae5805eb22d75190b0ff0133ba6dbf712">fixed_side_hessian</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 <span class="preprocessor">#endif // LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00161"></a>00161 <span class="preprocessor"></span>
<a name="l00166"></a>00166   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEMContext.php#abab1b68a634f80e0b991431a793f3edb">reinit</a>(<span class="keyword">const</span> <a class="code" href="classFEMSystem.php">FEMSystem</a>&amp;, <a class="code" href="classElem.php">Elem</a>*);
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 <span class="comment">// should be protected:</span>
<a name="l00174"></a>00174 <span class="comment"></span>  <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEMContext.php#a3edb7c340909fe9e67792e2d785096de">elem_reinit</a>(<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> theta);
<a name="l00175"></a>00175 
<a name="l00181"></a>00181   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEMContext.php#afeb811b018e2ab05fa960eaf3f0add16">elem_side_reinit</a>(<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> theta);
<a name="l00182"></a>00182 
<a name="l00186"></a>00186   <span class="keywordtype">void</span> <a class="code" href="classFEMContext.php#a8a834570338463f64b5e4e1582385ad9">elem_fe_reinit</a>();
<a name="l00187"></a>00187 
<a name="l00191"></a>00191   <span class="keywordtype">void</span> <a class="code" href="classFEMContext.php#aac3e77bdc0c55a43943333ade0b6cde1">elem_side_fe_reinit</a>();
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 <span class="comment">// should be protected?:</span>
<a name="l00197"></a><a class="code" href="classFEMContext.php#a6ad7d8e1a449cec71169e375da34ea84">00197</a> <span class="comment"></span>  std::map&lt;FEType, FEBase *&gt; <a class="code" href="classFEMContext.php#a6ad7d8e1a449cec71169e375da34ea84">element_fe</a>;
<a name="l00198"></a><a class="code" href="classFEMContext.php#a1f8e72ea50a3a2c2f20e40c4897b85da">00198</a>   std::map&lt;FEType, FEBase *&gt; <a class="code" href="classFEMContext.php#a1f8e72ea50a3a2c2f20e40c4897b85da">side_fe</a>;
<a name="l00199"></a>00199 
<a name="l00204"></a><a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">00204</a>   std::vector&lt;FEBase *&gt; <a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>;
<a name="l00205"></a><a class="code" href="classFEMContext.php#a1c4541019276284edbccac006a0be3fe">00205</a>   std::vector&lt;FEBase *&gt; <a class="code" href="classFEMContext.php#a1c4541019276284edbccac006a0be3fe">side_fe_var</a>;
<a name="l00206"></a>00206 
<a name="l00212"></a><a class="code" href="classFEMContext.php#a3be41281e28b8021e92e41b3028556db">00212</a>   <a class="code" href="classQBase.php">QBase</a> *<a class="code" href="classFEMContext.php#a3be41281e28b8021e92e41b3028556db">element_qrule</a>;
<a name="l00213"></a><a class="code" href="classFEMContext.php#aafe642ee3623ff45a3b9ed54e2af52e4">00213</a>   <a class="code" href="classQBase.php">QBase</a> *<a class="code" href="classFEMContext.php#aafe642ee3623ff45a3b9ed54e2af52e4">side_qrule</a>;
<a name="l00214"></a>00214 
<a name="l00220"></a>00220   <span class="keywordtype">void</span> <a class="code" href="classFEMContext.php#aadb724ebd124e1db2e9ef3604b380cca">elem_position_set</a>(<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> theta);
<a name="l00221"></a>00221 
<a name="l00226"></a>00226   <span class="keywordtype">void</span> <a class="code" href="classFEMContext.php#a6de9902c88fa9e48c57973a906f54a99">elem_position_get</a>();
<a name="l00227"></a>00227 
<a name="l00231"></a><a class="code" href="classFEMContext.php#a2f12db1dee6115a2093399c263ce7674">00231</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFEMContext.php#a9ee7d0de4dc6ec45807a311dae74c4a6">_mesh_sys</a>, <a class="code" href="classFEMContext.php#a9d271b748847e080513b50b744081c8f">_mesh_x_var</a>, <a class="code" href="classFEMContext.php#a924ead3b0cc9a8e1e8c41b81a738afbf">_mesh_y_var</a>, <a class="code" href="classFEMContext.php#a2f12db1dee6115a2093399c263ce7674">_mesh_z_var</a>;
<a name="l00232"></a>00232 
<a name="l00236"></a><a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">00236</a>   <a class="code" href="classElem.php">Elem</a> *<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>;
<a name="l00237"></a>00237 
<a name="l00241"></a><a class="code" href="classFEMContext.php#a2a9c65a61dcb0947b65df2f862482e96">00241</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="classFEMContext.php#a2a9c65a61dcb0947b65df2f862482e96">side</a>;
<a name="l00242"></a>00242 
<a name="l00246"></a><a class="code" href="classFEMContext.php#af2f40bcea6e5c825fa61cfb8d10615a1">00246</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="classFEMContext.php#af2f40bcea6e5c825fa61cfb8d10615a1">dim</a>;
<a name="l00247"></a>00247 };
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 
<a name="l00250"></a>00250 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
