<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_60be1125a39495b698d2d56e8e5b50b1.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>fem_system.C</h1>  </div>
</div>
<div class="contents">
<a href="fem__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fem_system.C 3444 2009-07-30 20:08:37Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;dof_map.h&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;fe_base.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;fe_interface.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;equation_systems.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;fem_system.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;mesh.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;parallel.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;quadrature.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;sparse_matrix.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;time_solver.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;unsteady_solver.h&quot;</span> <span class="comment">// For euler_residual</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a><a class="code" href="classFEMSystem.php#ad741a33a05f37d3216bb91e9dc0a79ee">00041</a> <a class="code" href="classFEMSystem.php#ad741a33a05f37d3216bb91e9dc0a79ee">FEMSystem::FEMSystem</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00042"></a>00042                       <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00043"></a>00043                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number)
<a name="l00044"></a>00044   : <a class="code" href="classImplicitSystem.php">Parent</a>(es, name, number),
<a name="l00045"></a>00045     fe_reinit_during_postprocess(true),
<a name="l00046"></a>00046     extra_quadrature_order(0),
<a name="l00047"></a>00047     numerical_jacobian_h(1.e-6),
<a name="l00048"></a>00048     verify_analytic_jacobians(0.0),
<a name="l00049"></a>00049     _mesh_sys(libMesh::<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a>),
<a name="l00050"></a>00050     _mesh_x_var(libMesh::<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a>),
<a name="l00051"></a>00051     _mesh_y_var(libMesh::<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a>),
<a name="l00052"></a>00052     _mesh_z_var(libMesh::<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a>)
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054 }
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00057"></a><a class="code" href="classFEMSystem.php#a21e50d15c9a34c31e65f1288409158b4">00057</a> <a class="code" href="classFEMSystem.php#a21e50d15c9a34c31e65f1288409158b4">FEMSystem::~FEMSystem</a> ()
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059   this-&gt;<a class="code" href="classFEMSystem.php#a6dbe64d3215fc46fa079223759a7011f">clear</a>();
<a name="l00060"></a>00060 }
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a><a class="code" href="classFEMSystem.php#a6dbe64d3215fc46fa079223759a7011f">00064</a> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#a6dbe64d3215fc46fa079223759a7011f">FEMSystem::clear</a>()
<a name="l00065"></a>00065 {
<a name="l00066"></a>00066   <a class="code" href="classDifferentiableSystem.php#a9072ddeb46f6a483595e93621a38d391">Parent::clear</a>();
<a name="l00067"></a>00067 }
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00071"></a><a class="code" href="classFEMSystem.php#a4cef19d8d8779a2596fa5c2266f9e8d0">00071</a> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#a4cef19d8d8779a2596fa5c2266f9e8d0">FEMSystem::init_data</a> ()
<a name="l00072"></a>00072 {
<a name="l00073"></a>00073   <span class="comment">// First initialize LinearImplicitSystem data</span>
<a name="l00074"></a>00074   <a class="code" href="classDifferentiableSystem.php#a4fe36b066e7b028d6403a858ec75fa1d">Parent::init_data</a>();
<a name="l00075"></a>00075 }
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00078"></a><a class="code" href="classFEMSystem.php#a7143f0d4ef97184f88d58af2613b0fd4">00078</a> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#a7143f0d4ef97184f88d58af2613b0fd4">FEMSystem::assembly</a> (<span class="keywordtype">bool</span> get_residual, <span class="keywordtype">bool</span> get_jacobian)
<a name="l00079"></a>00079 {
<a name="l00080"></a>00080   libmesh_assert(get_residual || get_jacobian);
<a name="l00081"></a>00081   std::string log_name;
<a name="l00082"></a>00082   <span class="keywordflow">if</span> (get_residual &amp;&amp; get_jacobian)
<a name="l00083"></a>00083     log_name = <span class="stringliteral">&quot;assembly()&quot;</span>;
<a name="l00084"></a>00084   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (get_residual)
<a name="l00085"></a>00085     log_name = <span class="stringliteral">&quot;assembly(get_residual)&quot;</span>;
<a name="l00086"></a>00086   <span class="keywordflow">else</span>
<a name="l00087"></a>00087     log_name = <span class="stringliteral">&quot;assembly(get_jacobian)&quot;</span>;
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   START_LOG(log_name, <span class="stringliteral">&quot;FEMSystem&quot;</span>);
<a name="l00090"></a>00090 
<a name="l00091"></a>00091   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh = this-&gt;<a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">get_mesh</a>();
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 <span class="comment">//  this-&gt;get_vector(&quot;_nonlinear_solution&quot;).localize</span>
<a name="l00094"></a>00094 <span class="comment">//    (*current_local_nonlinear_solution,</span>
<a name="l00095"></a>00095 <span class="comment">//     dof_map.get_send_list());</span>
<a name="l00096"></a>00096   this-&gt;<a class="code" href="classSystem.php#add4b09ec4fb0679b8623c01218cafa5b">update</a>();
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   <span class="keywordflow">if</span> (<a class="code" href="classDifferentiableSystem.php#a43462955105f77ba4d0e9f676658d975">print_solution_norms</a>)
<a name="l00099"></a>00099     {
<a name="l00100"></a>00100 <span class="comment">//      this-&gt;get_vector(&quot;_nonlinear_solution&quot;).close();</span>
<a name="l00101"></a>00101       this-&gt;<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;close();
<a name="l00102"></a>00102       std::cout &lt;&lt; <span class="stringliteral">&quot;|U| = &quot;</span>
<a name="l00103"></a>00103 <span class="comment">//                &lt;&lt; this-&gt;get_vector(&quot;_nonlinear_solution&quot;).l1_norm()</span>
<a name="l00104"></a>00104                 &lt;&lt; this-&gt;<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;l1_norm()
<a name="l00105"></a>00105                 &lt;&lt; std::endl;
<a name="l00106"></a>00106     }
<a name="l00107"></a>00107   <span class="keywordflow">if</span> (<a class="code" href="classDifferentiableSystem.php#aaa5c109a92a60968afd1fad729342563">print_solutions</a>)
<a name="l00108"></a>00108     {
<a name="l00109"></a>00109       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_precision = std::cout.precision();
<a name="l00110"></a>00110       std::cout.precision(16);
<a name="l00111"></a>00111 <span class="comment">//      std::cout &lt;&lt; &quot;U = [&quot; &lt;&lt; this-&gt;get_vector(&quot;_nonlinear_solution&quot;)</span>
<a name="l00112"></a>00112       std::cout &lt;&lt; <span class="stringliteral">&quot;U = [&quot;</span> &lt;&lt; *(this-&gt;<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>)
<a name="l00113"></a>00113                 &lt;&lt; <span class="stringliteral">&quot;];&quot;</span> &lt;&lt; std::endl;
<a name="l00114"></a>00114       std::cout.precision(old_precision);
<a name="l00115"></a>00115     }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117   <span class="comment">// Is this definitely necessary? [RHS]</span>
<a name="l00118"></a>00118   <span class="keywordflow">if</span> (get_jacobian)
<a name="l00119"></a>00119     <a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>-&gt;<a class="code" href="classSparseMatrix.php#ac9c04c5748478399f1eff3f337a7e647">zero</a>();
<a name="l00120"></a>00120   <span class="keywordflow">if</span> (get_residual)
<a name="l00121"></a>00121     <a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>-&gt;<a class="code" href="classNumericVector.php#a21ca80e20b0f88490c8f0d5298d47bef">zero</a>();
<a name="l00122"></a>00122 
<a name="l00123"></a>00123   <span class="comment">// Stupid C++ lets you set *Real* verify_analytic_jacobians = true!</span>
<a name="l00124"></a>00124   <span class="keywordflow">if</span> (<a class="code" href="classFEMSystem.php#aab6fffc5e23ecd0d815d75104512a3c1">verify_analytic_jacobians</a> &gt; 0.5)
<a name="l00125"></a>00125     {
<a name="l00126"></a>00126       std::cerr &lt;&lt; <span class="stringliteral">&quot;WARNING!  verify_analytic_jacobians was set &quot;</span>
<a name="l00127"></a>00127                 &lt;&lt; <span class="stringliteral">&quot;to absurdly large value of &quot;</span>
<a name="l00128"></a>00128                 &lt;&lt; <a class="code" href="classFEMSystem.php#aab6fffc5e23ecd0d815d75104512a3c1">verify_analytic_jacobians</a> &lt;&lt; std::endl;
<a name="l00129"></a>00129       std::cerr &lt;&lt; <span class="stringliteral">&quot;Resetting to 1e-6!&quot;</span> &lt;&lt; std::endl;
<a name="l00130"></a>00130       <a class="code" href="classFEMSystem.php#aab6fffc5e23ecd0d815d75104512a3c1">verify_analytic_jacobians</a> = 1e-6;
<a name="l00131"></a>00131     }
<a name="l00132"></a>00132 
<a name="l00133"></a>00133   <span class="comment">// In time-dependent problems, the nonlinear function we&#39;re trying</span>
<a name="l00134"></a>00134   <span class="comment">// to solve at each timestep may depend on the particular solver</span>
<a name="l00135"></a>00135   <span class="comment">// we&#39;re using</span>
<a name="l00136"></a>00136   libmesh_assert (<a class="code" href="classDifferentiableSystem.php#a0dab4aeae88234a06d041519b219fbc4">time_solver</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL);
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DiffContext&gt;</a> con = this-&gt;<a class="code" href="classFEMSystem.php#a6519e2a695abb5355f71d0398d025979">build_context</a>();
<a name="l00139"></a>00139   <a class="code" href="classFEMContext.php">FEMContext</a> &amp;_femcontext = libmesh_cast_ref&lt;FEMContext&amp;&gt;(*con);
<a name="l00140"></a>00140 
<a name="l00141"></a>00141   <span class="comment">// Build the residual and jacobian contributions on every active</span>
<a name="l00142"></a>00142   <span class="comment">// mesh element on this processor</span>
<a name="l00143"></a>00143   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el =
<a name="l00144"></a>00144     mesh.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00145"></a>00145   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el =
<a name="l00146"></a>00146     mesh.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>();
<a name="l00147"></a>00147 
<a name="l00148"></a>00148   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00149"></a>00149     {
<a name="l00150"></a>00150       _femcontext.<a class="code" href="classFEMContext.php#abab1b68a634f80e0b991431a793f3edb">reinit</a>(*<span class="keyword">this</span>, *el);
<a name="l00151"></a>00151 
<a name="l00152"></a>00152       <span class="keywordtype">bool</span> jacobian_computed =
<a name="l00153"></a>00153         <a class="code" href="classDifferentiableSystem.php#a0dab4aeae88234a06d041519b219fbc4">time_solver</a>-&gt;element_residual(get_jacobian, _femcontext);
<a name="l00154"></a>00154 
<a name="l00155"></a>00155       <span class="comment">// Compute a numeric jacobian if we have to</span>
<a name="l00156"></a>00156       <span class="keywordflow">if</span> (get_jacobian &amp;&amp; !jacobian_computed)
<a name="l00157"></a>00157         {
<a name="l00158"></a>00158           <span class="comment">// Make sure we didn&#39;t compute a jacobian and lie about it</span>
<a name="l00159"></a>00159           libmesh_assert(_femcontext.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>.<a class="code" href="classDenseMatrix.php#a6abd86dc2628f0ebffc9661e98824cb5">l1_norm</a>() == 0.0);
<a name="l00160"></a>00160           <span class="comment">// Logging of numerical jacobians is done separately</span>
<a name="l00161"></a>00161           this-&gt;<a class="code" href="classFEMSystem.php#ace72118960028430ca361b0addd03861">numerical_elem_jacobian</a>(_femcontext);
<a name="l00162"></a>00162         }
<a name="l00163"></a>00163 
<a name="l00164"></a>00164       <span class="comment">// Compute a numeric jacobian if we&#39;re asked to verify the</span>
<a name="l00165"></a>00165       <span class="comment">// analytic jacobian we got</span>
<a name="l00166"></a>00166       <span class="keywordflow">if</span> (get_jacobian &amp;&amp; jacobian_computed &amp;&amp;
<a name="l00167"></a>00167           <a class="code" href="classFEMSystem.php#aab6fffc5e23ecd0d815d75104512a3c1">verify_analytic_jacobians</a> != 0.0)
<a name="l00168"></a>00168         {
<a name="l00169"></a>00169           <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Number&gt;</a> analytic_jacobian(_femcontext.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>);
<a name="l00170"></a>00170 
<a name="l00171"></a>00171           _femcontext.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>.<a class="code" href="classDenseMatrix.php#a3d3f0e57fc2e9dc7ed292cbd2124581e">zero</a>();
<a name="l00172"></a>00172           <span class="comment">// Logging of numerical jacobians is done separately</span>
<a name="l00173"></a>00173           this-&gt;<a class="code" href="classFEMSystem.php#ace72118960028430ca361b0addd03861">numerical_elem_jacobian</a>(_femcontext);
<a name="l00174"></a>00174 
<a name="l00175"></a>00175           <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> analytic_norm = analytic_jacobian.<a class="code" href="classDenseMatrix.php#a6abd86dc2628f0ebffc9661e98824cb5">l1_norm</a>();
<a name="l00176"></a>00176           <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> numerical_norm = _femcontext.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>.<a class="code" href="classDenseMatrix.php#a6abd86dc2628f0ebffc9661e98824cb5">l1_norm</a>();
<a name="l00177"></a>00177 
<a name="l00178"></a>00178           <span class="comment">// If we can continue, we&#39;ll probably prefer the analytic jacobian</span>
<a name="l00179"></a>00179           analytic_jacobian.<a class="code" href="classDenseMatrix.php#a0df961e52a0694a9300dea1714a1a369">swap</a>(_femcontext.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>);
<a name="l00180"></a>00180 
<a name="l00181"></a>00181           <span class="comment">// The matrix &quot;analytic_jacobian&quot; will now hold the error matrix</span>
<a name="l00182"></a>00182           analytic_jacobian.<a class="code" href="classDenseMatrix.php#a926f9d5c2903ba947f73176bdcafaa42">add</a>(-1.0, _femcontext.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>);
<a name="l00183"></a>00183           <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> error_norm = analytic_jacobian.<a class="code" href="classDenseMatrix.php#a6abd86dc2628f0ebffc9661e98824cb5">l1_norm</a>();
<a name="l00184"></a>00184 
<a name="l00185"></a>00185           <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> relative_error = error_norm /
<a name="l00186"></a>00186                                 <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(analytic_norm, numerical_norm);
<a name="l00187"></a>00187 
<a name="l00188"></a>00188           <span class="keywordflow">if</span> (relative_error &gt; <a class="code" href="classFEMSystem.php#aab6fffc5e23ecd0d815d75104512a3c1">verify_analytic_jacobians</a>)
<a name="l00189"></a>00189             {
<a name="l00190"></a>00190               std::cerr &lt;&lt; <span class="stringliteral">&quot;Relative error &quot;</span> &lt;&lt; relative_error
<a name="l00191"></a>00191                         &lt;&lt; <span class="stringliteral">&quot; detected in analytic jacobian on element &quot;</span>
<a name="l00192"></a>00192                         &lt;&lt; _femcontext.<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() &lt;&lt; <span class="charliteral">&#39;!&#39;</span> &lt;&lt; std::endl;
<a name="l00193"></a>00193 
<a name="l00194"></a>00194               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_precision = std::cout.precision();
<a name="l00195"></a>00195               std::cout.precision(16);
<a name="l00196"></a>00196               std::cout &lt;&lt; <span class="stringliteral">&quot;J_analytic &quot;</span> &lt;&lt; _femcontext.<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() &lt;&lt; <span class="stringliteral">&quot; = &quot;</span>
<a name="l00197"></a>00197                         &lt;&lt; _femcontext.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a> &lt;&lt; std::endl;
<a name="l00198"></a>00198               analytic_jacobian.<a class="code" href="classDenseMatrix.php#a926f9d5c2903ba947f73176bdcafaa42">add</a>(1.0, _femcontext.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>);
<a name="l00199"></a>00199               std::cout &lt;&lt; <span class="stringliteral">&quot;J_numeric &quot;</span> &lt;&lt; _femcontext.<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() &lt;&lt; <span class="stringliteral">&quot; = &quot;</span>
<a name="l00200"></a>00200                         &lt;&lt; analytic_jacobian &lt;&lt; std::endl;
<a name="l00201"></a>00201 
<a name="l00202"></a>00202               std::cout.precision(old_precision);
<a name="l00203"></a>00203 
<a name="l00204"></a>00204               libmesh_error();
<a name="l00205"></a>00205             }
<a name="l00206"></a>00206         }
<a name="l00207"></a>00207 
<a name="l00208"></a>00208       <span class="keywordflow">for</span> (_femcontext.<a class="code" href="classFEMContext.php#a2a9c65a61dcb0947b65df2f862482e96">side</a> = 0;
<a name="l00209"></a>00209            _femcontext.<a class="code" href="classFEMContext.php#a2a9c65a61dcb0947b65df2f862482e96">side</a> != _femcontext.<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>();
<a name="l00210"></a>00210            ++_femcontext.<a class="code" href="classFEMContext.php#a2a9c65a61dcb0947b65df2f862482e96">side</a>)
<a name="l00211"></a>00211         {
<a name="l00212"></a>00212           <span class="comment">// Don&#39;t compute on non-boundary sides unless requested</span>
<a name="l00213"></a>00213           <span class="keywordflow">if</span> (!<a class="code" href="classDifferentiableSystem.php#ae412e18a407ba499d9e492facde2bb73">compute_internal_sides</a> &amp;&amp; 
<a name="l00214"></a>00214               _femcontext.<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(_femcontext.<a class="code" href="classFEMContext.php#a2a9c65a61dcb0947b65df2f862482e96">side</a>) != NULL)
<a name="l00215"></a>00215             <span class="keywordflow">continue</span>;
<a name="l00216"></a>00216 
<a name="l00217"></a>00217           <span class="comment">// Any mesh movement has already been done (and restored,</span>
<a name="l00218"></a>00218           <span class="comment">// if the TimeSolver isn&#39;t broken), but</span>
<a name="l00219"></a>00219           <span class="comment">// reinitializing the side FE objects is still necessary</span>
<a name="l00220"></a>00220           _femcontext.<a class="code" href="classFEMContext.php#aac3e77bdc0c55a43943333ade0b6cde1">elem_side_fe_reinit</a>();
<a name="l00221"></a>00221 
<a name="l00222"></a>00222           <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Number&gt;</a> old_jacobian;
<a name="l00223"></a>00223           <span class="comment">// If we&#39;re in DEBUG mode, we should always verify that the</span>
<a name="l00224"></a>00224           <span class="comment">// user&#39;s side_residual function doesn&#39;t alter our existing</span>
<a name="l00225"></a>00225           <span class="comment">// jacobian and then lie about it</span>
<a name="l00226"></a>00226 <span class="preprocessor">#ifndef DEBUG</span>
<a name="l00227"></a>00227 <span class="preprocessor"></span>          <span class="comment">// Even if we&#39;re not in DEBUG mode, when we&#39;re verifying</span>
<a name="l00228"></a>00228           <span class="comment">// analytic jacobians we&#39;ll want to verify each side&#39;s</span>
<a name="l00229"></a>00229           <span class="comment">// jacobian contribution separately</span>
<a name="l00230"></a>00230           <span class="keywordflow">if</span> (<a class="code" href="classFEMSystem.php#aab6fffc5e23ecd0d815d75104512a3c1">verify_analytic_jacobians</a> != 0.0 &amp;&amp; get_jacobian)
<a name="l00231"></a>00231 <span class="preprocessor">#endif // ifndef DEBUG</span>
<a name="l00232"></a>00232 <span class="preprocessor"></span>            {
<a name="l00233"></a>00233               old_jacobian = _femcontext.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>;
<a name="l00234"></a>00234               _femcontext.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>.<a class="code" href="classDenseMatrix.php#a3d3f0e57fc2e9dc7ed292cbd2124581e">zero</a>();
<a name="l00235"></a>00235             }
<a name="l00236"></a>00236           jacobian_computed =
<a name="l00237"></a>00237             <a class="code" href="classDifferentiableSystem.php#a0dab4aeae88234a06d041519b219fbc4">time_solver</a>-&gt;side_residual(get_jacobian, _femcontext);
<a name="l00238"></a>00238 
<a name="l00239"></a>00239           <span class="comment">// Compute a numeric jacobian if we have to</span>
<a name="l00240"></a>00240           <span class="keywordflow">if</span> (get_jacobian &amp;&amp; !jacobian_computed)
<a name="l00241"></a>00241             {
<a name="l00242"></a>00242               <span class="comment">// In DEBUG mode, we&#39;ve already set elem_jacobian == 0,</span>
<a name="l00243"></a>00243               <span class="comment">// so we can make sure side_residual didn&#39;t compute a</span>
<a name="l00244"></a>00244               <span class="comment">// jacobian and lie about it</span>
<a name="l00245"></a>00245 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00246"></a>00246 <span class="preprocessor"></span>              libmesh_assert(_femcontext.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>.<a class="code" href="classDenseMatrix.php#a6abd86dc2628f0ebffc9661e98824cb5">l1_norm</a>() == 0.0);
<a name="l00247"></a>00247 <span class="preprocessor">#endif</span>
<a name="l00248"></a>00248 <span class="preprocessor"></span>              <span class="comment">// Logging of numerical jacobians is done separately</span>
<a name="l00249"></a>00249               this-&gt;<a class="code" href="classFEMSystem.php#a0fb6805ca18d186f7dac430ce19fed81">numerical_side_jacobian</a>(_femcontext);
<a name="l00250"></a>00250 
<a name="l00251"></a>00251               <span class="comment">// If we&#39;re in DEBUG mode or if</span>
<a name="l00252"></a>00252               <span class="comment">// verify_analytic_jacobians is on, we&#39;ve moved</span>
<a name="l00253"></a>00253               <span class="comment">// elem_jacobian&#39;s accumulated values into old_jacobian.</span>
<a name="l00254"></a>00254               <span class="comment">// Now let&#39;s add them back.</span>
<a name="l00255"></a>00255 <span class="preprocessor">#ifndef DEBUG</span>
<a name="l00256"></a>00256 <span class="preprocessor"></span>              <span class="keywordflow">if</span> (<a class="code" href="classFEMSystem.php#aab6fffc5e23ecd0d815d75104512a3c1">verify_analytic_jacobians</a> != 0.0)
<a name="l00257"></a>00257 <span class="preprocessor">#endif // ifndef DEBUG</span>
<a name="l00258"></a>00258 <span class="preprocessor"></span>                _femcontext.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a> += old_jacobian;
<a name="l00259"></a>00259             }
<a name="l00260"></a>00260 
<a name="l00261"></a>00261           <span class="comment">// Compute a numeric jacobian if we&#39;re asked to verify the</span>
<a name="l00262"></a>00262           <span class="comment">// analytic jacobian we got</span>
<a name="l00263"></a>00263           <span class="keywordflow">if</span> (get_jacobian &amp;&amp; jacobian_computed &amp;&amp;
<a name="l00264"></a>00264               <a class="code" href="classFEMSystem.php#aab6fffc5e23ecd0d815d75104512a3c1">verify_analytic_jacobians</a> != 0.0)
<a name="l00265"></a>00265             {
<a name="l00266"></a>00266               <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Number&gt;</a> analytic_jacobian(_femcontext.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>);
<a name="l00267"></a>00267 
<a name="l00268"></a>00268               _femcontext.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>.<a class="code" href="classDenseMatrix.php#a3d3f0e57fc2e9dc7ed292cbd2124581e">zero</a>();
<a name="l00269"></a>00269               <span class="comment">// Logging of numerical jacobians is done separately</span>
<a name="l00270"></a>00270               this-&gt;<a class="code" href="classFEMSystem.php#a0fb6805ca18d186f7dac430ce19fed81">numerical_side_jacobian</a>(_femcontext);
<a name="l00271"></a>00271 
<a name="l00272"></a>00272               <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> analytic_norm = analytic_jacobian.<a class="code" href="classDenseMatrix.php#a6abd86dc2628f0ebffc9661e98824cb5">l1_norm</a>();
<a name="l00273"></a>00273               <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> numerical_norm = _femcontext.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>.<a class="code" href="classDenseMatrix.php#a6abd86dc2628f0ebffc9661e98824cb5">l1_norm</a>();
<a name="l00274"></a>00274 
<a name="l00275"></a>00275               <span class="comment">// If we can continue, we&#39;ll probably prefer the analytic jacobian</span>
<a name="l00276"></a>00276               analytic_jacobian.<a class="code" href="classDenseMatrix.php#a0df961e52a0694a9300dea1714a1a369">swap</a>(_femcontext.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>);
<a name="l00277"></a>00277 
<a name="l00278"></a>00278               <span class="comment">// The matrix &quot;analytic_jacobian&quot; will now hold the error matrix</span>
<a name="l00279"></a>00279               analytic_jacobian.<a class="code" href="classDenseMatrix.php#a926f9d5c2903ba947f73176bdcafaa42">add</a>(-1.0, _femcontext.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>);
<a name="l00280"></a>00280               <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> error_norm = analytic_jacobian.<a class="code" href="classDenseMatrix.php#a6abd86dc2628f0ebffc9661e98824cb5">l1_norm</a>();
<a name="l00281"></a>00281 
<a name="l00282"></a>00282               <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> relative_error = error_norm /
<a name="l00283"></a>00283                                     <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(analytic_norm, numerical_norm);
<a name="l00284"></a>00284 
<a name="l00285"></a>00285               <span class="keywordflow">if</span> (relative_error &gt; <a class="code" href="classFEMSystem.php#aab6fffc5e23ecd0d815d75104512a3c1">verify_analytic_jacobians</a>)
<a name="l00286"></a>00286                 {
<a name="l00287"></a>00287                   std::cerr &lt;&lt; <span class="stringliteral">&quot;Relative error &quot;</span> &lt;&lt; relative_error
<a name="l00288"></a>00288                             &lt;&lt; <span class="stringliteral">&quot; detected in analytic jacobian on element &quot;</span>
<a name="l00289"></a>00289                             &lt;&lt; _femcontext.<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()
<a name="l00290"></a>00290                             &lt;&lt; <span class="stringliteral">&quot;, side &quot;</span>
<a name="l00291"></a>00291                             &lt;&lt; _femcontext.<a class="code" href="classFEMContext.php#a2a9c65a61dcb0947b65df2f862482e96">side</a> &lt;&lt; <span class="charliteral">&#39;!&#39;</span> &lt;&lt; std::endl;
<a name="l00292"></a>00292 
<a name="l00293"></a>00293                   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_precision = std::cout.precision();
<a name="l00294"></a>00294                   std::cout.precision(16);
<a name="l00295"></a>00295                   std::cout &lt;&lt; <span class="stringliteral">&quot;J_analytic &quot;</span> &lt;&lt; _femcontext.<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() &lt;&lt; <span class="stringliteral">&quot; = &quot;</span>
<a name="l00296"></a>00296                             &lt;&lt; _femcontext.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a> &lt;&lt; std::endl;
<a name="l00297"></a>00297                   analytic_jacobian.<a class="code" href="classDenseMatrix.php#a926f9d5c2903ba947f73176bdcafaa42">add</a>(1.0, _femcontext.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>);
<a name="l00298"></a>00298                   std::cout &lt;&lt; <span class="stringliteral">&quot;J_numeric &quot;</span> &lt;&lt; _femcontext.<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() &lt;&lt; <span class="stringliteral">&quot; = &quot;</span>
<a name="l00299"></a>00299                             &lt;&lt; analytic_jacobian &lt;&lt; std::endl;
<a name="l00300"></a>00300                   std::cout.precision(old_precision);
<a name="l00301"></a>00301 
<a name="l00302"></a>00302                   libmesh_error();
<a name="l00303"></a>00303                 }
<a name="l00304"></a>00304               <span class="comment">// Once we&#39;ve verified a side, we&#39;ll want to add back the</span>
<a name="l00305"></a>00305               <span class="comment">// rest of the accumulated jacobian</span>
<a name="l00306"></a>00306               _femcontext.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a> += old_jacobian;
<a name="l00307"></a>00307             }
<a name="l00308"></a>00308           <span class="comment">// In DEBUG mode, we&#39;ve set elem_jacobian == 0, and we</span>
<a name="l00309"></a>00309           <span class="comment">// may still need to add the old jacobian back</span>
<a name="l00310"></a>00310 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00311"></a>00311 <span class="preprocessor"></span>          <span class="keywordflow">if</span> (get_jacobian &amp;&amp; jacobian_computed &amp;&amp;
<a name="l00312"></a>00312               <a class="code" href="classFEMSystem.php#aab6fffc5e23ecd0d815d75104512a3c1">verify_analytic_jacobians</a> == 0.0)
<a name="l00313"></a>00313             {
<a name="l00314"></a>00314               _femcontext.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a> += old_jacobian;
<a name="l00315"></a>00315             }
<a name="l00316"></a>00316 <span class="preprocessor">#endif // ifdef DEBUG</span>
<a name="l00317"></a>00317 <span class="preprocessor"></span>        }
<a name="l00318"></a>00318 
<a name="l00319"></a>00319 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00320"></a>00320 <span class="preprocessor"></span>      <span class="comment">// We turn off the asymmetric constraint application;</span>
<a name="l00321"></a>00321       <span class="comment">// enforce_constraints_exactly() should be called in the solver</span>
<a name="l00322"></a>00322       <span class="keywordflow">if</span> (get_residual &amp;&amp; get_jacobian)
<a name="l00323"></a>00323         this-&gt;<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#af32c351cce81588e65370dd14e820fb4">constrain_element_matrix_and_vector</a>
<a name="l00324"></a>00324           (_femcontext.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>, _femcontext.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>,
<a name="l00325"></a>00325            _femcontext.<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>, <span class="keyword">false</span>);
<a name="l00326"></a>00326       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (get_residual)
<a name="l00327"></a>00327         this-&gt;<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#a60d43d6b832336a9c70527024e1ffdc8">constrain_element_vector</a>
<a name="l00328"></a>00328           (_femcontext.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>, _femcontext.<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>, <span class="keyword">false</span>);
<a name="l00329"></a>00329       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (get_jacobian)
<a name="l00330"></a>00330         this-&gt;<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#ab03892878c3a760e5ffdcf16dd6a7db9">constrain_element_matrix</a>
<a name="l00331"></a>00331           (_femcontext.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>, _femcontext.<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>, <span class="keyword">false</span>);
<a name="l00332"></a>00332 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00333"></a>00333 <span class="preprocessor"></span>
<a name="l00334"></a>00334       <span class="keywordflow">if</span> (get_jacobian &amp;&amp; <a class="code" href="classDifferentiableSystem.php#a405d284eba03efd74d02b11121958af1">print_element_jacobians</a>)
<a name="l00335"></a>00335         {
<a name="l00336"></a>00336           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_precision = std::cout.precision();
<a name="l00337"></a>00337           std::cout.precision(16);
<a name="l00338"></a>00338           std::cout &lt;&lt; <span class="stringliteral">&quot;J_elem &quot;</span> &lt;&lt; _femcontext.<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() &lt;&lt; <span class="stringliteral">&quot; = &quot;</span>
<a name="l00339"></a>00339                     &lt;&lt; _femcontext.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a> &lt;&lt; std::endl;
<a name="l00340"></a>00340           std::cout.precision(old_precision);
<a name="l00341"></a>00341         }
<a name="l00342"></a>00342 
<a name="l00343"></a>00343       <span class="keywordflow">if</span> (get_jacobian)
<a name="l00344"></a>00344         this-&gt;<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>-&gt;<a class="code" href="classSparseMatrix.php#aad59105789574a7d9ad7462be13b7a90">add_matrix</a> (_femcontext.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>,
<a name="l00345"></a>00345                                   _femcontext.<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>);
<a name="l00346"></a>00346       <span class="keywordflow">if</span> (get_residual)
<a name="l00347"></a>00347         this-&gt;<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>-&gt;<a class="code" href="classNumericVector.php#ac41cf781a2cce694f5795cb36fb40a4b">add_vector</a> (_femcontext.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>,
<a name="l00348"></a>00348                                _femcontext.<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>);
<a name="l00349"></a>00349     }
<a name="l00350"></a>00350 
<a name="l00351"></a>00351 
<a name="l00352"></a>00352   <span class="keywordflow">if</span> (get_residual &amp;&amp; <a class="code" href="classDifferentiableSystem.php#aad66358e9d4cee14b2bad49234e95b85">print_residual_norms</a>)
<a name="l00353"></a>00353     {
<a name="l00354"></a>00354       this-&gt;<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>-&gt;<a class="code" href="classNumericVector.php#a4c7feb55cd686619d04e0441b41ceaa5">close</a>();
<a name="l00355"></a>00355       std::cout &lt;&lt; <span class="stringliteral">&quot;|F| = &quot;</span> &lt;&lt; this-&gt;<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>-&gt;<a class="code" href="classNumericVector.php#a32d1eccab710311df6e4e36afb6c9537">l1_norm</a>() &lt;&lt; std::endl;
<a name="l00356"></a>00356     }
<a name="l00357"></a>00357   <span class="keywordflow">if</span> (get_residual &amp;&amp; <a class="code" href="classDifferentiableSystem.php#a759d8b336a87cb9ca16b92a0129a72b0">print_residuals</a>)
<a name="l00358"></a>00358     {
<a name="l00359"></a>00359       this-&gt;<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>-&gt;<a class="code" href="classNumericVector.php#a4c7feb55cd686619d04e0441b41ceaa5">close</a>();
<a name="l00360"></a>00360       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_precision = std::cout.precision();
<a name="l00361"></a>00361       std::cout.precision(16);
<a name="l00362"></a>00362       std::cout &lt;&lt; <span class="stringliteral">&quot;F = [&quot;</span> &lt;&lt; *(this-&gt;<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>) &lt;&lt; <span class="stringliteral">&quot;];&quot;</span> &lt;&lt; std::endl;
<a name="l00363"></a>00363       std::cout.precision(old_precision);
<a name="l00364"></a>00364     }
<a name="l00365"></a>00365   <span class="keywordflow">if</span> (get_jacobian &amp;&amp; <a class="code" href="classDifferentiableSystem.php#a05ef6936334fcd8da39c5521d7728c16">print_jacobian_norms</a>)
<a name="l00366"></a>00366     {
<a name="l00367"></a>00367       this-&gt;<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>-&gt;<a class="code" href="classSparseMatrix.php#a55129db49268936e33686bc1beaaa1e9">close</a>();
<a name="l00368"></a>00368       std::cout &lt;&lt; <span class="stringliteral">&quot;|J| = &quot;</span> &lt;&lt; this-&gt;<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>-&gt;<a class="code" href="classSparseMatrix.php#a3f454639068a2d3ffe77c7ca5ef69169">l1_norm</a>() &lt;&lt; std::endl;
<a name="l00369"></a>00369     }
<a name="l00370"></a>00370   <span class="keywordflow">if</span> (get_jacobian &amp;&amp; <a class="code" href="classDifferentiableSystem.php#a34062be5513df753b1d7cc6ef2954f34">print_jacobians</a>)
<a name="l00371"></a>00371     {
<a name="l00372"></a>00372       this-&gt;<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>-&gt;<a class="code" href="classSparseMatrix.php#a55129db49268936e33686bc1beaaa1e9">close</a>();
<a name="l00373"></a>00373       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_precision = std::cout.precision();
<a name="l00374"></a>00374       std::cout.precision(16);
<a name="l00375"></a>00375       std::cout &lt;&lt; <span class="stringliteral">&quot;J = [&quot;</span> &lt;&lt; *(this-&gt;<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>) &lt;&lt; <span class="stringliteral">&quot;];&quot;</span> &lt;&lt; std::endl;
<a name="l00376"></a>00376       std::cout.precision(old_precision);
<a name="l00377"></a>00377     }
<a name="l00378"></a>00378   STOP_LOG(log_name, <span class="stringliteral">&quot;FEMSystem&quot;</span>);
<a name="l00379"></a>00379 }
<a name="l00380"></a>00380 
<a name="l00381"></a>00381 
<a name="l00382"></a>00382 
<a name="l00383"></a><a class="code" href="classFEMSystem.php#acd66d3f3517850c56e010ffa7f45f249">00383</a> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#acd66d3f3517850c56e010ffa7f45f249">FEMSystem::solve</a>()
<a name="l00384"></a>00384 {
<a name="l00385"></a>00385   <a class="code" href="classDifferentiableSystem.php#afe25c7be93c504e4505de2f5b3da7dc9">Parent::solve</a>();
<a name="l00386"></a>00386 
<a name="l00387"></a>00387   this-&gt;<a class="code" href="classFEMSystem.php#abf6f87d5af4e528271190142e1b393f9">mesh_position_set</a>();
<a name="l00388"></a>00388 }
<a name="l00389"></a>00389 
<a name="l00390"></a>00390 
<a name="l00391"></a>00391 
<a name="l00392"></a><a class="code" href="classFEMSystem.php#abf6f87d5af4e528271190142e1b393f9">00392</a> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#abf6f87d5af4e528271190142e1b393f9">FEMSystem::mesh_position_set</a>()
<a name="l00393"></a>00393 {
<a name="l00394"></a>00394   <span class="comment">// If we don&#39;t need to move the mesh, we&#39;re done</span>
<a name="l00395"></a>00395   <span class="keywordflow">if</span> (<a class="code" href="classFEMSystem.php#a264d49a3cd5e9a17adbc9548e5d87e3e">_mesh_sys</a> != this-&gt;<a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">number</a>())
<a name="l00396"></a>00396     <span class="keywordflow">return</span>;
<a name="l00397"></a>00397 
<a name="l00398"></a>00398   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh = this-&gt;<a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">get_mesh</a>();
<a name="l00399"></a>00399 
<a name="l00400"></a>00400   <span class="comment">// This code won&#39;t work on a parallelized mesh yet -</span>
<a name="l00401"></a>00401   <span class="comment">// it won&#39;t get ancestor elements right.</span>
<a name="l00402"></a>00402   libmesh_assert(mesh.<a class="code" href="classMeshBase.php#a660bb92c9fb94527d1cabfb1fdd6d056">is_serial</a>());
<a name="l00403"></a>00403   
<a name="l00404"></a>00404   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DiffContext&gt;</a> con = this-&gt;<a class="code" href="classFEMSystem.php#a6519e2a695abb5355f71d0398d025979">build_context</a>();
<a name="l00405"></a>00405   <a class="code" href="classFEMContext.php">FEMContext</a> &amp;_femcontext = libmesh_cast_ref&lt;FEMContext&amp;&gt;(*con);
<a name="l00406"></a>00406 
<a name="l00407"></a>00407   <span class="comment">// Move every mesh element we can</span>
<a name="l00408"></a>00408   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el =
<a name="l00409"></a>00409     mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00410"></a>00410   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el =
<a name="l00411"></a>00411     mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>();
<a name="l00412"></a>00412 
<a name="l00413"></a>00413   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00414"></a>00414     {
<a name="l00415"></a>00415       _femcontext.<a class="code" href="classFEMContext.php#abab1b68a634f80e0b991431a793f3edb">reinit</a>(*<span class="keyword">this</span>, *el);
<a name="l00416"></a>00416 
<a name="l00417"></a>00417       <span class="comment">// This code won&#39;t handle moving subactive elements</span>
<a name="l00418"></a>00418       libmesh_assert(!_femcontext.<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classElem.php#a2ff2cfd3b4b05b8f091ba91eb068f81c">has_children</a>());
<a name="l00419"></a>00419 
<a name="l00420"></a>00420       _femcontext.<a class="code" href="classFEMContext.php#aadb724ebd124e1db2e9ef3604b380cca">elem_position_set</a>(0.);
<a name="l00421"></a>00421     }
<a name="l00422"></a>00422 }
<a name="l00423"></a>00423 
<a name="l00424"></a>00424 
<a name="l00425"></a>00425 
<a name="l00426"></a><a class="code" href="classFEMSystem.php#a1be6a0b9f145b5df10d699c65c960c97">00426</a> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#a1be6a0b9f145b5df10d699c65c960c97">FEMSystem::postprocess</a> ()
<a name="l00427"></a>00427 {
<a name="l00428"></a>00428   START_LOG(<span class="stringliteral">&quot;postprocess()&quot;</span>, <span class="stringliteral">&quot;FEMSystem&quot;</span>);
<a name="l00429"></a>00429 
<a name="l00430"></a>00430   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh = this-&gt;<a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">get_mesh</a>();
<a name="l00431"></a>00431 
<a name="l00432"></a>00432   this-&gt;<a class="code" href="classSystem.php#add4b09ec4fb0679b8623c01218cafa5b">update</a>();
<a name="l00433"></a>00433 
<a name="l00434"></a>00434   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DiffContext&gt;</a> con = this-&gt;<a class="code" href="classFEMSystem.php#a6519e2a695abb5355f71d0398d025979">build_context</a>();
<a name="l00435"></a>00435   <a class="code" href="classFEMContext.php">FEMContext</a> &amp;_femcontext = libmesh_cast_ref&lt;FEMContext&amp;&gt;(*con);
<a name="l00436"></a>00436 
<a name="l00437"></a>00437   <span class="comment">// Loop over every active mesh element on this processor</span>
<a name="l00438"></a>00438   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el =
<a name="l00439"></a>00439     mesh.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00440"></a>00440   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el =
<a name="l00441"></a>00441     mesh.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>();
<a name="l00442"></a>00442 
<a name="l00443"></a>00443   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00444"></a>00444     {
<a name="l00445"></a>00445       _femcontext.<a class="code" href="classFEMContext.php#abab1b68a634f80e0b991431a793f3edb">reinit</a>(*<span class="keyword">this</span>, *el);
<a name="l00446"></a>00446 
<a name="l00447"></a>00447       <span class="comment">// Optionally initialize all the interior FE objects on elem.</span>
<a name="l00448"></a>00448       <span class="comment">// if (fe_reinit_during_postprocess)</span>
<a name="l00449"></a>00449       <span class="comment">// _femcontext.elem_fe_reinit();</span>
<a name="l00450"></a>00450       
<a name="l00451"></a>00451       this-&gt;<a class="code" href="classDifferentiableSystem.php#a12f0464741acd101c4492e174e3e4c42">element_postprocess</a>(_femcontext);
<a name="l00452"></a>00452 
<a name="l00453"></a>00453       <span class="keywordflow">for</span> (_femcontext.<a class="code" href="classFEMContext.php#a2a9c65a61dcb0947b65df2f862482e96">side</a> = 0;
<a name="l00454"></a>00454            _femcontext.<a class="code" href="classFEMContext.php#a2a9c65a61dcb0947b65df2f862482e96">side</a> != _femcontext.<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>();
<a name="l00455"></a>00455            ++_femcontext.<a class="code" href="classFEMContext.php#a2a9c65a61dcb0947b65df2f862482e96">side</a>)
<a name="l00456"></a>00456         {
<a name="l00457"></a>00457           <span class="comment">// Don&#39;t compute on non-boundary sides unless requested</span>
<a name="l00458"></a>00458           <span class="keywordflow">if</span> (!<a class="code" href="classDifferentiableSystem.php#a18c9cb33536527dfd2de6d528ddac53b">postprocess_sides</a> ||
<a name="l00459"></a>00459               (!<a class="code" href="classDifferentiableSystem.php#ae412e18a407ba499d9e492facde2bb73">compute_internal_sides</a> &amp;&amp;
<a name="l00460"></a>00460                _femcontext.<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(_femcontext.<a class="code" href="classFEMContext.php#a2a9c65a61dcb0947b65df2f862482e96">side</a>) != NULL))
<a name="l00461"></a>00461             <span class="keywordflow">continue</span>;
<a name="l00462"></a>00462 
<a name="l00463"></a>00463           <span class="comment">// Optionally initialize all the interior FE objects on elem/side.</span>
<a name="l00464"></a>00464           <span class="comment">// Logging of FE::reinit is done in the FE functions</span>
<a name="l00465"></a>00465           <span class="keywordflow">if</span> (<a class="code" href="classFEMSystem.php#a71d55a123010eca54580ebb77b6f4e25">fe_reinit_during_postprocess</a>)
<a name="l00466"></a>00466             {
<a name="l00467"></a>00467               std::map&lt;FEType, FEBase *&gt;::iterator fe_end =
<a name="l00468"></a>00468                 _femcontext.<a class="code" href="classFEMContext.php#a1f8e72ea50a3a2c2f20e40c4897b85da">side_fe</a>.end();
<a name="l00469"></a>00469               <span class="keywordflow">for</span> (std::map&lt;FEType, FEBase *&gt;::iterator i =
<a name="l00470"></a>00470                 _femcontext.<a class="code" href="classFEMContext.php#a1f8e72ea50a3a2c2f20e40c4897b85da">side_fe</a>.begin();
<a name="l00471"></a>00471                    i != fe_end; ++i)
<a name="l00472"></a>00472                 {
<a name="l00473"></a>00473                   i-&gt;second-&gt;reinit(_femcontext.<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>, _femcontext.<a class="code" href="classFEMContext.php#a2a9c65a61dcb0947b65df2f862482e96">side</a>);
<a name="l00474"></a>00474                 }
<a name="l00475"></a>00475             }
<a name="l00476"></a>00476 
<a name="l00477"></a>00477           this-&gt;<a class="code" href="classDifferentiableSystem.php#a5f65430b3abb73725ce9921ed980d6a5">side_postprocess</a>(_femcontext);
<a name="l00478"></a>00478         }
<a name="l00479"></a>00479     }
<a name="l00480"></a>00480 
<a name="l00481"></a>00481   STOP_LOG(<span class="stringliteral">&quot;postprocess()&quot;</span>, <span class="stringliteral">&quot;FEMSystem&quot;</span>);
<a name="l00482"></a>00482 }
<a name="l00483"></a>00483 
<a name="l00484"></a>00484 
<a name="l00485"></a>00485 
<a name="l00486"></a><a class="code" href="classFEMSystem.php#aa73fae103b7f54831f93c6a3fd3ff11b">00486</a> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#aa73fae103b7f54831f93c6a3fd3ff11b">FEMSystem::assemble_qoi</a>()
<a name="l00487"></a>00487 {
<a name="l00488"></a>00488   START_LOG(<span class="stringliteral">&quot;assemble_qoi()&quot;</span>, <span class="stringliteral">&quot;FEMSystem&quot;</span>);
<a name="l00489"></a>00489 
<a name="l00490"></a>00490   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh = this-&gt;<a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">get_mesh</a>();
<a name="l00491"></a>00491 
<a name="l00492"></a>00492   this-&gt;<a class="code" href="classSystem.php#add4b09ec4fb0679b8623c01218cafa5b">update</a>();
<a name="l00493"></a>00493 
<a name="l00494"></a>00494   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DiffContext&gt;</a> con = this-&gt;<a class="code" href="classFEMSystem.php#a6519e2a695abb5355f71d0398d025979">build_context</a>();
<a name="l00495"></a>00495   <a class="code" href="classFEMContext.php">FEMContext</a> &amp;_femcontext = libmesh_cast_ref&lt;FEMContext&amp;&gt;(*con);
<a name="l00496"></a>00496 
<a name="l00497"></a>00497   <span class="comment">// the quantity of interest is assumed to be a sum of element and</span>
<a name="l00498"></a>00498   <span class="comment">// side terms</span>
<a name="l00499"></a>00499   <a class="code" href="classSystem.php#a49aff017c2708cbddfc91abff099f9cb">qoi</a> = 0;
<a name="l00500"></a>00500 
<a name="l00501"></a>00501   <span class="comment">// Loop over every active mesh element on this processor</span>
<a name="l00502"></a>00502   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el =
<a name="l00503"></a>00503     mesh.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00504"></a>00504   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el =
<a name="l00505"></a>00505     mesh.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>();
<a name="l00506"></a>00506 
<a name="l00507"></a>00507   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00508"></a>00508     {
<a name="l00509"></a>00509       _femcontext.<a class="code" href="classFEMContext.php#abab1b68a634f80e0b991431a793f3edb">reinit</a>(*<span class="keyword">this</span>, *el);
<a name="l00510"></a>00510 
<a name="l00511"></a>00511       this-&gt;<a class="code" href="classDifferentiableSystem.php#a3e088a59d3fa7989b85d9250492e98c7">element_qoi</a>(_femcontext);
<a name="l00512"></a>00512 
<a name="l00513"></a>00513       <span class="keywordflow">for</span> (_femcontext.<a class="code" href="classFEMContext.php#a2a9c65a61dcb0947b65df2f862482e96">side</a> = 0;
<a name="l00514"></a>00514            _femcontext.<a class="code" href="classFEMContext.php#a2a9c65a61dcb0947b65df2f862482e96">side</a> != _femcontext.<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>();
<a name="l00515"></a>00515            ++_femcontext.<a class="code" href="classFEMContext.php#a2a9c65a61dcb0947b65df2f862482e96">side</a>)
<a name="l00516"></a>00516         {
<a name="l00517"></a>00517           <span class="comment">// Don&#39;t compute on non-boundary sides unless requested</span>
<a name="l00518"></a>00518           <span class="keywordflow">if</span> (!<a class="code" href="classDifferentiableSystem.php#ae1f7058cb6e13a05fb26814863a9193b">assemble_qoi_sides</a> ||
<a name="l00519"></a>00519               (!<a class="code" href="classDifferentiableSystem.php#ae412e18a407ba499d9e492facde2bb73">compute_internal_sides</a> &amp;&amp;
<a name="l00520"></a>00520                _femcontext.<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(_femcontext.<a class="code" href="classFEMContext.php#a2a9c65a61dcb0947b65df2f862482e96">side</a>) != NULL))
<a name="l00521"></a>00521             <span class="keywordflow">continue</span>;
<a name="l00522"></a>00522 
<a name="l00523"></a>00523           std::map&lt;FEType, FEBase *&gt;::iterator fe_end =
<a name="l00524"></a>00524             _femcontext.<a class="code" href="classFEMContext.php#a1f8e72ea50a3a2c2f20e40c4897b85da">side_fe</a>.end();
<a name="l00525"></a>00525           <span class="keywordflow">for</span> (std::map&lt;FEType, FEBase *&gt;::iterator i =
<a name="l00526"></a>00526             _femcontext.<a class="code" href="classFEMContext.php#a1f8e72ea50a3a2c2f20e40c4897b85da">side_fe</a>.begin();
<a name="l00527"></a>00527                i != fe_end; ++i)
<a name="l00528"></a>00528             {
<a name="l00529"></a>00529               i-&gt;second-&gt;reinit(_femcontext.<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>, _femcontext.<a class="code" href="classFEMContext.php#a2a9c65a61dcb0947b65df2f862482e96">side</a>);
<a name="l00530"></a>00530             }
<a name="l00531"></a>00531 
<a name="l00532"></a>00532           this-&gt;<a class="code" href="classDifferentiableSystem.php#acc54a0b5205d6f09e76a729f71952edd">side_qoi</a>(_femcontext);
<a name="l00533"></a>00533         }
<a name="l00534"></a>00534     }
<a name="l00535"></a>00535 
<a name="l00536"></a>00536   Parallel::sum(<a class="code" href="classSystem.php#a49aff017c2708cbddfc91abff099f9cb">qoi</a>);
<a name="l00537"></a>00537 
<a name="l00538"></a>00538   STOP_LOG(<span class="stringliteral">&quot;assemble_qoi()&quot;</span>, <span class="stringliteral">&quot;FEMSystem&quot;</span>);
<a name="l00539"></a>00539 }
<a name="l00540"></a>00540 
<a name="l00541"></a>00541 
<a name="l00542"></a>00542 
<a name="l00543"></a><a class="code" href="classFEMSystem.php#a3a5eb8fd7e03916f3d3239eb7e357532">00543</a> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#a3a5eb8fd7e03916f3d3239eb7e357532">FEMSystem::assemble_qoi_derivative</a>()
<a name="l00544"></a>00544 {
<a name="l00545"></a>00545   START_LOG(<span class="stringliteral">&quot;assemble_qoi_derivative()&quot;</span>, <span class="stringliteral">&quot;FEMSystem&quot;</span>);
<a name="l00546"></a>00546 
<a name="l00547"></a>00547   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh = this-&gt;<a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">get_mesh</a>();
<a name="l00548"></a>00548 
<a name="l00549"></a>00549   this-&gt;<a class="code" href="classSystem.php#add4b09ec4fb0679b8623c01218cafa5b">update</a>();
<a name="l00550"></a>00550 
<a name="l00551"></a>00551   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DiffContext&gt;</a> con = this-&gt;<a class="code" href="classFEMSystem.php#a6519e2a695abb5355f71d0398d025979">build_context</a>();
<a name="l00552"></a>00552   <a class="code" href="classFEMContext.php">FEMContext</a> &amp;_femcontext = libmesh_cast_ref&lt;FEMContext&amp;&gt;(*con);
<a name="l00553"></a>00553 
<a name="l00554"></a>00554   <span class="comment">// In case there&#39;s already a rhs in use</span>
<a name="l00555"></a>00555   <a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>-&gt;<a class="code" href="classNumericVector.php#a21ca80e20b0f88490c8f0d5298d47bef">zero</a>();
<a name="l00556"></a>00556 
<a name="l00557"></a>00557   <span class="comment">// Loop over every active mesh element on this processor</span>
<a name="l00558"></a>00558   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el =
<a name="l00559"></a>00559     mesh.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00560"></a>00560   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el =
<a name="l00561"></a>00561     mesh.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>();
<a name="l00562"></a>00562 
<a name="l00563"></a>00563   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00564"></a>00564     {
<a name="l00565"></a>00565       _femcontext.<a class="code" href="classFEMContext.php#abab1b68a634f80e0b991431a793f3edb">reinit</a>(*<span class="keyword">this</span>, *el);
<a name="l00566"></a>00566 
<a name="l00567"></a>00567       this-&gt;<a class="code" href="classDifferentiableSystem.php#ac0d9e6dba8bae252e04fde5b618c9ee8">element_qoi_derivative</a>(_femcontext);
<a name="l00568"></a>00568 
<a name="l00569"></a>00569       <span class="keywordflow">for</span> (_femcontext.<a class="code" href="classFEMContext.php#a2a9c65a61dcb0947b65df2f862482e96">side</a> = 0;
<a name="l00570"></a>00570            _femcontext.<a class="code" href="classFEMContext.php#a2a9c65a61dcb0947b65df2f862482e96">side</a> != _femcontext.<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>();
<a name="l00571"></a>00571            ++_femcontext.<a class="code" href="classFEMContext.php#a2a9c65a61dcb0947b65df2f862482e96">side</a>)
<a name="l00572"></a>00572         {
<a name="l00573"></a>00573           <span class="comment">// Don&#39;t compute on non-boundary sides unless requested</span>
<a name="l00574"></a>00574           <span class="keywordflow">if</span> (!<a class="code" href="classDifferentiableSystem.php#ae1f7058cb6e13a05fb26814863a9193b">assemble_qoi_sides</a> ||
<a name="l00575"></a>00575               (!<a class="code" href="classDifferentiableSystem.php#ae412e18a407ba499d9e492facde2bb73">compute_internal_sides</a> &amp;&amp;
<a name="l00576"></a>00576                _femcontext.<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(_femcontext.<a class="code" href="classFEMContext.php#a2a9c65a61dcb0947b65df2f862482e96">side</a>) != NULL))
<a name="l00577"></a>00577             <span class="keywordflow">continue</span>;
<a name="l00578"></a>00578 
<a name="l00579"></a>00579           std::map&lt;FEType, FEBase *&gt;::iterator fe_end =
<a name="l00580"></a>00580             _femcontext.<a class="code" href="classFEMContext.php#a1f8e72ea50a3a2c2f20e40c4897b85da">side_fe</a>.end();
<a name="l00581"></a>00581           <span class="keywordflow">for</span> (std::map&lt;FEType, FEBase *&gt;::iterator i =
<a name="l00582"></a>00582             _femcontext.<a class="code" href="classFEMContext.php#a1f8e72ea50a3a2c2f20e40c4897b85da">side_fe</a>.begin();
<a name="l00583"></a>00583                i != fe_end; ++i)
<a name="l00584"></a>00584             {
<a name="l00585"></a>00585               i-&gt;second-&gt;reinit(_femcontext.<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>, _femcontext.<a class="code" href="classFEMContext.php#a2a9c65a61dcb0947b65df2f862482e96">side</a>);
<a name="l00586"></a>00586             }
<a name="l00587"></a>00587 
<a name="l00588"></a>00588           this-&gt;<a class="code" href="classDifferentiableSystem.php#a91191d2563c42c9512c1dce6d431025b">side_qoi_derivative</a>(_femcontext);
<a name="l00589"></a>00589         }
<a name="l00590"></a>00590 
<a name="l00591"></a>00591       this-&gt;<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#a60d43d6b832336a9c70527024e1ffdc8">constrain_element_vector</a>
<a name="l00592"></a>00592         (_femcontext.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>, _femcontext.<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>, <span class="keyword">false</span>);
<a name="l00593"></a>00593 
<a name="l00594"></a>00594       this-&gt;<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>-&gt;<a class="code" href="classNumericVector.php#ac41cf781a2cce694f5795cb36fb40a4b">add_vector</a> (_femcontext.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>,
<a name="l00595"></a>00595                              _femcontext.<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>);
<a name="l00596"></a>00596     }
<a name="l00597"></a>00597 
<a name="l00598"></a>00598   STOP_LOG(<span class="stringliteral">&quot;assemble_qoi_derivative()&quot;</span>, <span class="stringliteral">&quot;FEMSystem&quot;</span>);
<a name="l00599"></a>00599 }
<a name="l00600"></a>00600 
<a name="l00601"></a>00601 
<a name="l00602"></a>00602 
<a name="l00603"></a><a class="code" href="classFEMSystem.php#ac647a04dec989f60d0952ae3f5734aaf">00603</a> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#ac647a04dec989f60d0952ae3f5734aaf">FEMSystem::numerical_jacobian</a> (TimeSolverResPtr res,
<a name="l00604"></a>00604                                     <a class="code" href="classFEMContext.php">FEMContext</a> &amp;context)
<a name="l00605"></a>00605 {
<a name="l00606"></a>00606   <span class="comment">// Logging is done by numerical_elem_jacobian</span>
<a name="l00607"></a>00607   <span class="comment">// or numerical_side_jacobian</span>
<a name="l00608"></a>00608 
<a name="l00609"></a>00609   <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a> original_residual(context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>);
<a name="l00610"></a>00610   <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a> backwards_residual(context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>);
<a name="l00611"></a>00611   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Number&gt;</a> <a class="code" href="classFEMSystem.php#ac647a04dec989f60d0952ae3f5734aaf">numerical_jacobian</a>(context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>);
<a name="l00612"></a>00612 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00613"></a>00613 <span class="preprocessor"></span>  <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Number&gt;</a> old_jacobian(context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>);
<a name="l00614"></a>00614 <span class="preprocessor">#endif</span>
<a name="l00615"></a>00615 <span class="preprocessor"></span>
<a name="l00616"></a>00616   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> numerical_point_h = 0.;
<a name="l00617"></a>00617   <span class="keywordflow">if</span> (<a class="code" href="classFEMSystem.php#a264d49a3cd5e9a17adbc9548e5d87e3e">_mesh_sys</a> == this-&gt;<a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">number</a>())
<a name="l00618"></a>00618     numerical_point_h = <a class="code" href="classFEMSystem.php#a0d9dc3c9c8a70e6d583b144801cd0c61">numerical_jacobian_h</a> * context.<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classElem.php#a8483eb75ec4ccc49b41596557a3a367b">hmin</a>();
<a name="l00619"></a>00619 
<a name="l00620"></a>00620   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = 0; j != context.<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>.size(); ++j)
<a name="l00621"></a>00621     {
<a name="l00622"></a>00622       <span class="comment">// Take the &quot;minus&quot; side of a central differenced first derivative</span>
<a name="l00623"></a>00623       <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> original_solution = context.<a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>(j);
<a name="l00624"></a>00624       context.<a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>(j) -= <a class="code" href="classFEMSystem.php#a0d9dc3c9c8a70e6d583b144801cd0c61">numerical_jacobian_h</a>;
<a name="l00625"></a>00625 
<a name="l00626"></a>00626       <span class="comment">// Make sure to catch any moving mesh terms</span>
<a name="l00627"></a>00627       <span class="comment">// FIXME - this could be less ugly</span>
<a name="l00628"></a>00628       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> *coord = NULL;
<a name="l00629"></a>00629       <span class="keywordflow">if</span> (<a class="code" href="classFEMSystem.php#a264d49a3cd5e9a17adbc9548e5d87e3e">_mesh_sys</a> == this-&gt;<a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">number</a>())
<a name="l00630"></a>00630         {
<a name="l00631"></a>00631           <span class="keywordflow">if</span> (<a class="code" href="classFEMSystem.php#a908e5f051c224b25710384dc90023562">_mesh_x_var</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00632"></a>00632             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k = 0;
<a name="l00633"></a>00633                  k != context.<a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[<a class="code" href="classFEMSystem.php#a908e5f051c224b25710384dc90023562">_mesh_x_var</a>].size(); ++k)
<a name="l00634"></a>00634               <span class="keywordflow">if</span> (context.<a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[<a class="code" href="classFEMSystem.php#a908e5f051c224b25710384dc90023562">_mesh_x_var</a>][k] ==
<a name="l00635"></a>00635                   context.<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>[j])
<a name="l00636"></a>00636                 coord = &amp;(context.<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(k)(0));
<a name="l00637"></a>00637           <span class="keywordflow">if</span> (<a class="code" href="classFEMSystem.php#ae8743cd2af913217990dfd57ba9c2c50">_mesh_y_var</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00638"></a>00638             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k = 0;
<a name="l00639"></a>00639                  k != context.<a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[<a class="code" href="classFEMSystem.php#ae8743cd2af913217990dfd57ba9c2c50">_mesh_y_var</a>].size(); ++k)
<a name="l00640"></a>00640               <span class="keywordflow">if</span> (context.<a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[<a class="code" href="classFEMSystem.php#ae8743cd2af913217990dfd57ba9c2c50">_mesh_y_var</a>][k] == 
<a name="l00641"></a>00641                   context.<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>[j])
<a name="l00642"></a>00642                 coord = &amp;(context.<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(k)(1));
<a name="l00643"></a>00643           <span class="keywordflow">if</span> (<a class="code" href="classFEMSystem.php#aef0ada8832396ad9f02ba5be2bb9a7d7">_mesh_z_var</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00644"></a>00644             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k = 0;
<a name="l00645"></a>00645                  k != context.<a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[<a class="code" href="classFEMSystem.php#aef0ada8832396ad9f02ba5be2bb9a7d7">_mesh_z_var</a>].size(); ++k)
<a name="l00646"></a>00646               <span class="keywordflow">if</span> (context.<a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[<a class="code" href="classFEMSystem.php#aef0ada8832396ad9f02ba5be2bb9a7d7">_mesh_z_var</a>][k] ==
<a name="l00647"></a>00647                   context.<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>[j])
<a name="l00648"></a>00648                 coord = &amp;(context.<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(k)(2));
<a name="l00649"></a>00649         }
<a name="l00650"></a>00650       <span class="keywordflow">if</span> (coord)
<a name="l00651"></a>00651         {
<a name="l00652"></a>00652           <span class="comment">// We have enough information to scale the perturbations</span>
<a name="l00653"></a>00653           <span class="comment">// here appropriately</span>
<a name="l00654"></a>00654           context.<a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>(j) = original_solution - numerical_point_h;
<a name="l00655"></a>00655           *coord = <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>(context.<a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>(j));
<a name="l00656"></a>00656         }
<a name="l00657"></a>00657 
<a name="l00658"></a>00658       context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>.<a class="code" href="classDenseVector.php#a4e0123eb5cc4054e8069155f0faf4425">zero</a>();
<a name="l00659"></a>00659       ((*time_solver).*(res))(<span class="keyword">false</span>, context);
<a name="l00660"></a>00660 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00661"></a>00661 <span class="preprocessor"></span>      libmesh_assert(old_jacobian == context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>);
<a name="l00662"></a>00662 <span class="preprocessor">#endif</span>
<a name="l00663"></a>00663 <span class="preprocessor"></span>      backwards_residual = context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>;
<a name="l00664"></a>00664 
<a name="l00665"></a>00665       <span class="comment">// Take the &quot;plus&quot; side of a central differenced first derivative</span>
<a name="l00666"></a>00666       context.<a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>(j) = original_solution + <a class="code" href="classFEMSystem.php#a0d9dc3c9c8a70e6d583b144801cd0c61">numerical_jacobian_h</a>;
<a name="l00667"></a>00667       <span class="keywordflow">if</span> (coord)
<a name="l00668"></a>00668         {
<a name="l00669"></a>00669           context.<a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>(j) = original_solution + numerical_point_h;
<a name="l00670"></a>00670           *coord = <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>(context.<a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>(j));
<a name="l00671"></a>00671         }
<a name="l00672"></a>00672       context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>.<a class="code" href="classDenseVector.php#a4e0123eb5cc4054e8069155f0faf4425">zero</a>();
<a name="l00673"></a>00673       ((*time_solver).*(res))(<span class="keyword">false</span>, context);
<a name="l00674"></a>00674 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00675"></a>00675 <span class="preprocessor"></span>      libmesh_assert(old_jacobian == context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a>);
<a name="l00676"></a>00676 <span class="preprocessor">#endif</span>
<a name="l00677"></a>00677 <span class="preprocessor"></span>
<a name="l00678"></a>00678       context.<a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>(j) = original_solution;
<a name="l00679"></a>00679       <span class="keywordflow">if</span> (coord)
<a name="l00680"></a>00680         {
<a name="l00681"></a>00681           *coord = <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>(context.<a class="code" href="classDiffContext.php#a00ea517d8b076d10da898e921522ba98">elem_solution</a>(j));
<a name="l00682"></a>00682           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != context.<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>.size(); ++i)
<a name="l00683"></a>00683             {
<a name="l00684"></a>00684               <a class="code" href="classFEMSystem.php#ac647a04dec989f60d0952ae3f5734aaf">numerical_jacobian</a>(i,j) =
<a name="l00685"></a>00685                 (context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>(i) - backwards_residual(i)) /
<a name="l00686"></a>00686                 2. / numerical_point_h;
<a name="l00687"></a>00687             }
<a name="l00688"></a>00688         }
<a name="l00689"></a>00689       <span class="keywordflow">else</span>
<a name="l00690"></a>00690         {
<a name="l00691"></a>00691           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != context.<a class="code" href="classDiffContext.php#a6448c2e63bd36a457f49c35a284bb7c3">dof_indices</a>.size(); ++i)
<a name="l00692"></a>00692             {
<a name="l00693"></a>00693               <a class="code" href="classFEMSystem.php#ac647a04dec989f60d0952ae3f5734aaf">numerical_jacobian</a>(i,j) =
<a name="l00694"></a>00694                 (context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a>(i) - backwards_residual(i)) /
<a name="l00695"></a>00695                 2. / numerical_jacobian_h;
<a name="l00696"></a>00696             }
<a name="l00697"></a>00697         }
<a name="l00698"></a>00698     }
<a name="l00699"></a>00699 
<a name="l00700"></a>00700   context.<a class="code" href="classDiffContext.php#a068da1d94ef12d65eca1abed8447dcb0">elem_residual</a> = original_residual;
<a name="l00701"></a>00701   context.<a class="code" href="classDiffContext.php#afbdc8b74b71c8ae2e3cb0e801327c787">elem_jacobian</a> = <a class="code" href="classFEMSystem.php#ac647a04dec989f60d0952ae3f5734aaf">numerical_jacobian</a>;
<a name="l00702"></a>00702 }
<a name="l00703"></a>00703 
<a name="l00704"></a>00704 
<a name="l00705"></a>00705 
<a name="l00706"></a><a class="code" href="classFEMSystem.php#ace72118960028430ca361b0addd03861">00706</a> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#ace72118960028430ca361b0addd03861">FEMSystem::numerical_elem_jacobian</a> (<a class="code" href="classFEMContext.php">FEMContext</a> &amp;context)
<a name="l00707"></a>00707 {
<a name="l00708"></a>00708   START_LOG(<span class="stringliteral">&quot;numerical_elem_jacobian()&quot;</span>, <span class="stringliteral">&quot;FEMSystem&quot;</span>);
<a name="l00709"></a>00709   this-&gt;<a class="code" href="classFEMSystem.php#ac647a04dec989f60d0952ae3f5734aaf">numerical_jacobian</a>(&amp;<a class="code" href="classTimeSolver.php#aba9a2410e2bdf6d0b1a6d3a01a501db3">TimeSolver::element_residual</a>, context);
<a name="l00710"></a>00710   STOP_LOG(<span class="stringliteral">&quot;numerical_elem_jacobian()&quot;</span>, <span class="stringliteral">&quot;FEMSystem&quot;</span>);
<a name="l00711"></a>00711 }
<a name="l00712"></a>00712 
<a name="l00713"></a>00713 
<a name="l00714"></a>00714 
<a name="l00715"></a><a class="code" href="classFEMSystem.php#a0fb6805ca18d186f7dac430ce19fed81">00715</a> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#a0fb6805ca18d186f7dac430ce19fed81">FEMSystem::numerical_side_jacobian</a> (<a class="code" href="classFEMContext.php">FEMContext</a> &amp;context)
<a name="l00716"></a>00716 {
<a name="l00717"></a>00717   START_LOG(<span class="stringliteral">&quot;numerical_side_jacobian()&quot;</span>, <span class="stringliteral">&quot;FEMSystem&quot;</span>);
<a name="l00718"></a>00718   this-&gt;<a class="code" href="classFEMSystem.php#ac647a04dec989f60d0952ae3f5734aaf">numerical_jacobian</a>(&amp;<a class="code" href="classTimeSolver.php#ab877eee4ce578637d7e8b4cff01564b2">TimeSolver::side_residual</a>, context);
<a name="l00719"></a>00719   STOP_LOG(<span class="stringliteral">&quot;numerical_side_jacobian()&quot;</span>, <span class="stringliteral">&quot;FEMSystem&quot;</span>);
<a name="l00720"></a>00720 }
<a name="l00721"></a>00721 
<a name="l00722"></a>00722 
<a name="l00723"></a>00723 
<a name="l00724"></a><a class="code" href="classFEMSystem.php#a6519e2a695abb5355f71d0398d025979">00724</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DiffContext&gt;</a> <a class="code" href="classFEMSystem.php#a6519e2a695abb5355f71d0398d025979">FEMSystem::build_context</a> ()
<a name="l00725"></a>00725 {
<a name="l00726"></a>00726   <span class="keywordflow">return</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DiffContext&gt;</a>(<span class="keyword">new</span> <a class="code" href="classFEMContext.php">FEMContext</a>(*<span class="keyword">this</span>));
<a name="l00727"></a>00727 }
<a name="l00728"></a>00728 
<a name="l00729"></a>00729 
<a name="l00730"></a>00730 
<a name="l00731"></a><a class="code" href="classFEMSystem.php#a1ed677e685064eea468e0b8637effc44">00731</a> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#a1ed677e685064eea468e0b8637effc44">FEMSystem::init_context</a>(<a class="code" href="classDiffContext.php">DiffContext</a> &amp;c)
<a name="l00732"></a>00732 {
<a name="l00733"></a>00733   <a class="code" href="classDifferentiableSystem.php#a177812e4bc63042f07a008161ab29b86">Parent::init_context</a>(c);
<a name="l00734"></a>00734 
<a name="l00735"></a>00735   <a class="code" href="classFEMContext.php">FEMContext</a> &amp;context = libmesh_cast_ref&lt;FEMContext&amp;&gt;(c);
<a name="l00736"></a>00736 
<a name="l00737"></a>00737   <span class="comment">// Make sure we&#39;re prepared to do mass integration</span>
<a name="l00738"></a>00738   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = 0; var != this-&gt;<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>(); ++var)
<a name="l00739"></a>00739     <span class="keywordflow">if</span> (<a class="code" href="classDifferentiableSystem.php#a457f7ba8b9e434c07935e23d33c41cc4">_time_evolving</a>[var])
<a name="l00740"></a>00740       {
<a name="l00741"></a>00741         context.<a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[var]-&gt;get_JxW();
<a name="l00742"></a>00742         context.<a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[var]-&gt;get_phi();
<a name="l00743"></a>00743       }
<a name="l00744"></a>00744 }
<a name="l00745"></a>00745 
<a name="l00746"></a>00746 
<a name="l00747"></a>00747 
<a name="l00748"></a><a class="code" href="classFEMSystem.php#a8b080d3b1c8851f7329d76daa78f0db6">00748</a> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#a8b080d3b1c8851f7329d76daa78f0db6">FEMSystem::time_evolving</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)
<a name="l00749"></a>00749 {
<a name="l00750"></a>00750   <span class="comment">// Call the parent function</span>
<a name="l00751"></a>00751   <a class="code" href="classDifferentiableSystem.php#a5e69fc9aa17d53f9f3ceaf0c6ddc4f78">Parent::time_evolving</a>(var);
<a name="l00752"></a>00752 }
<a name="l00753"></a>00753 
<a name="l00754"></a>00754 
<a name="l00755"></a>00755 
<a name="l00756"></a><a class="code" href="classFEMSystem.php#a3eaba6586e5f82999719fba114b02773">00756</a> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#a3eaba6586e5f82999719fba114b02773">FEMSystem::mesh_x_position</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sysnum, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)
<a name="l00757"></a>00757 {
<a name="l00758"></a>00758   <span class="keywordflow">if</span> (<a class="code" href="classFEMSystem.php#a264d49a3cd5e9a17adbc9548e5d87e3e">_mesh_sys</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a> &amp;&amp; <a class="code" href="classFEMSystem.php#a264d49a3cd5e9a17adbc9548e5d87e3e">_mesh_sys</a> != sysnum)
<a name="l00759"></a>00759     libmesh_error();
<a name="l00760"></a>00760   <span class="keywordflow">if</span> (sysnum != this-&gt;<a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">number</a>())
<a name="l00761"></a>00761     libmesh_not_implemented();
<a name="l00762"></a>00762   <a class="code" href="classFEMSystem.php#a264d49a3cd5e9a17adbc9548e5d87e3e">_mesh_sys</a> = sysnum;
<a name="l00763"></a>00763   <a class="code" href="classFEMSystem.php#a908e5f051c224b25710384dc90023562">_mesh_x_var</a> = var;
<a name="l00764"></a>00764 }
<a name="l00765"></a>00765 
<a name="l00766"></a>00766 
<a name="l00767"></a>00767 
<a name="l00768"></a><a class="code" href="classFEMSystem.php#a9192f021a04e41f6db18316a8de720dd">00768</a> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#a9192f021a04e41f6db18316a8de720dd">FEMSystem::mesh_y_position</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sysnum, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)
<a name="l00769"></a>00769 {
<a name="l00770"></a>00770   <span class="keywordflow">if</span> (<a class="code" href="classFEMSystem.php#a264d49a3cd5e9a17adbc9548e5d87e3e">_mesh_sys</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a> &amp;&amp; <a class="code" href="classFEMSystem.php#a264d49a3cd5e9a17adbc9548e5d87e3e">_mesh_sys</a> != sysnum)
<a name="l00771"></a>00771     libmesh_error();
<a name="l00772"></a>00772   <span class="keywordflow">if</span> (sysnum != this-&gt;<a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">number</a>())
<a name="l00773"></a>00773     libmesh_not_implemented();
<a name="l00774"></a>00774   <a class="code" href="classFEMSystem.php#a264d49a3cd5e9a17adbc9548e5d87e3e">_mesh_sys</a> = sysnum;
<a name="l00775"></a>00775   <a class="code" href="classFEMSystem.php#ae8743cd2af913217990dfd57ba9c2c50">_mesh_y_var</a> = var;
<a name="l00776"></a>00776 }
<a name="l00777"></a>00777 
<a name="l00778"></a>00778 
<a name="l00779"></a>00779 
<a name="l00780"></a><a class="code" href="classFEMSystem.php#aacbd9a28cfaf70b854954e1214b0d173">00780</a> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#aacbd9a28cfaf70b854954e1214b0d173">FEMSystem::mesh_z_position</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sysnum, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)
<a name="l00781"></a>00781 {
<a name="l00782"></a>00782   <span class="keywordflow">if</span> (<a class="code" href="classFEMSystem.php#a264d49a3cd5e9a17adbc9548e5d87e3e">_mesh_sys</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a> &amp;&amp; <a class="code" href="classFEMSystem.php#a264d49a3cd5e9a17adbc9548e5d87e3e">_mesh_sys</a> != sysnum)
<a name="l00783"></a>00783     libmesh_error();
<a name="l00784"></a>00784   <span class="keywordflow">if</span> (sysnum != this-&gt;<a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">number</a>())
<a name="l00785"></a>00785     libmesh_not_implemented();
<a name="l00786"></a>00786   <a class="code" href="classFEMSystem.php#a264d49a3cd5e9a17adbc9548e5d87e3e">_mesh_sys</a> = sysnum;
<a name="l00787"></a>00787   <a class="code" href="classFEMSystem.php#aef0ada8832396ad9f02ba5be2bb9a7d7">_mesh_z_var</a> = var;
<a name="l00788"></a>00788 }
<a name="l00789"></a>00789 
<a name="l00790"></a>00790 
<a name="l00791"></a>00791 
<a name="l00792"></a><a class="code" href="classFEMSystem.php#a80c30acbecc12dca6984e77bdbf880a4">00792</a> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#a80c30acbecc12dca6984e77bdbf880a4">FEMSystem::mesh_position_get</a>()
<a name="l00793"></a>00793 {
<a name="l00794"></a>00794   <span class="comment">// This function makes no sense unless we&#39;ve already picked out some</span>
<a name="l00795"></a>00795   <span class="comment">// variable(s) to reflect mesh position coordinates</span>
<a name="l00796"></a>00796   <span class="keywordflow">if</span> (<a class="code" href="classFEMSystem.php#a264d49a3cd5e9a17adbc9548e5d87e3e">_mesh_sys</a> == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00797"></a>00797     libmesh_error();
<a name="l00798"></a>00798 
<a name="l00799"></a>00799   <span class="comment">// We currently assume mesh variables are in our own system</span>
<a name="l00800"></a>00800   <span class="keywordflow">if</span> (<a class="code" href="classFEMSystem.php#a264d49a3cd5e9a17adbc9548e5d87e3e">_mesh_sys</a> != this-&gt;<a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">number</a>())
<a name="l00801"></a>00801     libmesh_not_implemented();
<a name="l00802"></a>00802 
<a name="l00803"></a>00803   <span class="comment">// Loop over every active mesh element on this processor</span>
<a name="l00804"></a>00804   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh = this-&gt;<a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">get_mesh</a>();
<a name="l00805"></a>00805 
<a name="l00806"></a>00806   <span class="keyword">const</span> <a class="code" href="classDofMap.php">DofMap</a>&amp; dof_map = this-&gt;<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>();
<a name="l00807"></a>00807 
<a name="l00808"></a>00808   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el =
<a name="l00809"></a>00809     mesh.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00810"></a>00810   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el =
<a name="l00811"></a>00811     mesh.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>();
<a name="l00812"></a>00812 
<a name="l00813"></a>00813   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DiffContext&gt;</a> con = this-&gt;<a class="code" href="classFEMSystem.php#a6519e2a695abb5355f71d0398d025979">build_context</a>();
<a name="l00814"></a>00814   <a class="code" href="classFEMContext.php">FEMContext</a> &amp;_femcontext = libmesh_cast_ref&lt;FEMContext&amp;&gt;(*con);
<a name="l00815"></a>00815   this-&gt;<a class="code" href="classFEMSystem.php#a1ed677e685064eea468e0b8637effc44">init_context</a>(_femcontext);
<a name="l00816"></a>00816 
<a name="l00817"></a>00817   <span class="comment">// Get the solution&#39;s mesh variables from every element</span>
<a name="l00818"></a>00818   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00819"></a>00819     {
<a name="l00820"></a>00820       _femcontext.<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a> = *el;
<a name="l00821"></a>00821 
<a name="l00822"></a>00822       <span class="comment">// Initialize the per-variable data for elem.</span>
<a name="l00823"></a>00823       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>(); ++i)
<a name="l00824"></a>00824         {
<a name="l00825"></a>00825           dof_map.<a class="code" href="classDofMap.php#afc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (_femcontext.<a class="code" href="classFEMContext.php#af06de57c7d8efbccb957a43ec9ea0124">elem</a>,
<a name="l00826"></a>00826                                _femcontext.<a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[i], i);
<a name="l00827"></a>00827         }
<a name="l00828"></a>00828 
<a name="l00829"></a>00829       _femcontext.<a class="code" href="classFEMContext.php#a6de9902c88fa9e48c57973a906f54a99">elem_position_get</a>();
<a name="l00830"></a>00830       <span class="keywordflow">if</span> (<a class="code" href="classFEMSystem.php#a908e5f051c224b25710384dc90023562">_mesh_x_var</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00831"></a>00831         this-&gt;<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;insert(*_femcontext.<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[<a class="code" href="classFEMSystem.php#a908e5f051c224b25710384dc90023562">_mesh_x_var</a>],
<a name="l00832"></a>00832                                _femcontext.<a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[<a class="code" href="classFEMSystem.php#a908e5f051c224b25710384dc90023562">_mesh_x_var</a>]);
<a name="l00833"></a>00833       <span class="keywordflow">if</span> (<a class="code" href="classFEMSystem.php#ae8743cd2af913217990dfd57ba9c2c50">_mesh_y_var</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00834"></a>00834         this-&gt;<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;insert(*_femcontext.<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[<a class="code" href="classFEMSystem.php#ae8743cd2af913217990dfd57ba9c2c50">_mesh_y_var</a>],
<a name="l00835"></a>00835                                _femcontext.<a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[<a class="code" href="classFEMSystem.php#ae8743cd2af913217990dfd57ba9c2c50">_mesh_y_var</a>]);
<a name="l00836"></a>00836       <span class="keywordflow">if</span> (<a class="code" href="classFEMSystem.php#aef0ada8832396ad9f02ba5be2bb9a7d7">_mesh_z_var</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00837"></a>00837         this-&gt;<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;insert(*_femcontext.<a class="code" href="classDiffContext.php#a70aae053e7130bbd982cd7be735162cd">elem_subsolutions</a>[<a class="code" href="classFEMSystem.php#aef0ada8832396ad9f02ba5be2bb9a7d7">_mesh_z_var</a>],
<a name="l00838"></a>00838                                _femcontext.<a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[<a class="code" href="classFEMSystem.php#aef0ada8832396ad9f02ba5be2bb9a7d7">_mesh_z_var</a>]);
<a name="l00839"></a>00839     }
<a name="l00840"></a>00840 
<a name="l00841"></a>00841   <span class="comment">// And make sure the current_local_solution is up to date too</span>
<a name="l00842"></a>00842   this-&gt;<a class="code" href="classSystem.php#add4b09ec4fb0679b8623c01218cafa5b">update</a>();
<a name="l00843"></a>00843 }
<a name="l00844"></a>00844 
<a name="l00845"></a>00845 
<a name="l00846"></a><a class="code" href="classFEMSystem.php#abb0481169108f844ac347fe34f61228f">00846</a> <span class="keywordtype">bool</span> <a class="code" href="classFEMSystem.php#abb0481169108f844ac347fe34f61228f">FEMSystem::eulerian_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00847"></a>00847                                    <a class="code" href="classDiffContext.php">DiffContext</a> &amp;c)
<a name="l00848"></a>00848 {
<a name="l00849"></a>00849   <span class="comment">// Only calculate a mesh movement residual if it&#39;s necessary</span>
<a name="l00850"></a>00850   <span class="keywordflow">if</span> (<a class="code" href="classFEMSystem.php#a264d49a3cd5e9a17adbc9548e5d87e3e">_mesh_sys</a> == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00851"></a>00851     <span class="keywordflow">return</span> request_jacobian;
<a name="l00852"></a>00852 
<a name="l00853"></a>00853   <a class="code" href="classFEMContext.php">FEMContext</a> &amp;context = libmesh_cast_ref&lt;FEMContext&amp;&gt;(c);
<a name="l00854"></a>00854 
<a name="l00855"></a>00855   <span class="comment">// This function only supports fully coupled mesh motion for now</span>
<a name="l00856"></a>00856   libmesh_assert(<a class="code" href="classFEMSystem.php#a264d49a3cd5e9a17adbc9548e5d87e3e">_mesh_sys</a> == this-&gt;<a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">number</a>());
<a name="l00857"></a>00857 
<a name="l00858"></a>00858   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qpoints = context.<a class="code" href="classFEMContext.php#a3be41281e28b8021e92e41b3028556db">element_qrule</a>-&gt;<a class="code" href="classQBase.php#a562b19b027dbad4ea8fdd65dddbaa649">n_points</a>();
<a name="l00859"></a>00859 
<a name="l00860"></a>00860   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_x_dofs = (<a class="code" href="classFEMSystem.php#a908e5f051c224b25710384dc90023562">_mesh_x_var</a> == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>) ?
<a name="l00861"></a>00861                                 0 : context.<a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[<a class="code" href="classFEMSystem.php#a908e5f051c224b25710384dc90023562">_mesh_x_var</a>].size();
<a name="l00862"></a>00862   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_y_dofs = (<a class="code" href="classFEMSystem.php#ae8743cd2af913217990dfd57ba9c2c50">_mesh_y_var</a> == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>) ?
<a name="l00863"></a>00863                                 0 : context.<a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[<a class="code" href="classFEMSystem.php#ae8743cd2af913217990dfd57ba9c2c50">_mesh_y_var</a>].size();
<a name="l00864"></a>00864   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_z_dofs = (<a class="code" href="classFEMSystem.php#aef0ada8832396ad9f02ba5be2bb9a7d7">_mesh_z_var</a> == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>) ?
<a name="l00865"></a>00865                                 0 : context.<a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[<a class="code" href="classFEMSystem.php#aef0ada8832396ad9f02ba5be2bb9a7d7">_mesh_z_var</a>].size();
<a name="l00866"></a>00866 
<a name="l00867"></a>00867   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> mesh_xyz_var = n_x_dofs ? <a class="code" href="classFEMSystem.php#a908e5f051c224b25710384dc90023562">_mesh_x_var</a> :
<a name="l00868"></a>00868                                    (n_y_dofs ? <a class="code" href="classFEMSystem.php#ae8743cd2af913217990dfd57ba9c2c50">_mesh_y_var</a> :
<a name="l00869"></a>00869                                    (n_z_dofs ? <a class="code" href="classFEMSystem.php#aef0ada8832396ad9f02ba5be2bb9a7d7">_mesh_z_var</a> :
<a name="l00870"></a>00870                                     <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>));
<a name="l00871"></a>00871 
<a name="l00872"></a>00872   <span class="comment">// If we&#39;re our own _mesh_sys, we&#39;d better be in charge of</span>
<a name="l00873"></a>00873   <span class="comment">// at least one coordinate, and we&#39;d better have the same</span>
<a name="l00874"></a>00874   <span class="comment">// FE type for all coordinates we are in charge of</span>
<a name="l00875"></a>00875   libmesh_assert(mesh_xyz_var != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>);
<a name="l00876"></a>00876   libmesh_assert(!n_x_dofs || context.<a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[<a class="code" href="classFEMSystem.php#a908e5f051c224b25710384dc90023562">_mesh_x_var</a>] ==
<a name="l00877"></a>00877                               context.<a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[mesh_xyz_var]);
<a name="l00878"></a>00878   libmesh_assert(!n_y_dofs || context.<a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[<a class="code" href="classFEMSystem.php#ae8743cd2af913217990dfd57ba9c2c50">_mesh_y_var</a>] ==
<a name="l00879"></a>00879                               context.<a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[mesh_xyz_var]);
<a name="l00880"></a>00880   libmesh_assert(!n_z_dofs || context.<a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[<a class="code" href="classFEMSystem.php#aef0ada8832396ad9f02ba5be2bb9a7d7">_mesh_z_var</a>] ==
<a name="l00881"></a>00881                               context.<a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[mesh_xyz_var]);
<a name="l00882"></a>00882 
<a name="l00883"></a>00883   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;     &amp;psi =
<a name="l00884"></a>00884     context.<a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[mesh_xyz_var]-&gt;get_phi();
<a name="l00885"></a>00885 
<a name="l00886"></a>00886   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = 0; var != this-&gt;<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>(); ++var)
<a name="l00887"></a>00887     {
<a name="l00888"></a>00888       <span class="comment">// Mesh motion only affects time-evolving variables</span>
<a name="l00889"></a>00889       <span class="keywordflow">if</span> (!<a class="code" href="classDifferentiableSystem.php#a457f7ba8b9e434c07935e23d33c41cc4">_time_evolving</a>[var])
<a name="l00890"></a>00890         <span class="keywordflow">continue</span>;
<a name="l00891"></a>00891 
<a name="l00892"></a>00892       <span class="comment">// The mesh coordinate variables themselves are Lagrangian,</span>
<a name="l00893"></a>00893       <span class="comment">// not Eulerian, and no convective term is desired.</span>
<a name="l00894"></a>00894       <span class="keywordflow">if</span> (<a class="code" href="classFEMSystem.php#a264d49a3cd5e9a17adbc9548e5d87e3e">_mesh_sys</a> == this-&gt;<a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">number</a>() &amp;&amp;
<a name="l00895"></a>00895           (var == <a class="code" href="classFEMSystem.php#a908e5f051c224b25710384dc90023562">_mesh_x_var</a> ||
<a name="l00896"></a>00896            var == <a class="code" href="classFEMSystem.php#ae8743cd2af913217990dfd57ba9c2c50">_mesh_y_var</a> ||
<a name="l00897"></a>00897            var == <a class="code" href="classFEMSystem.php#aef0ada8832396ad9f02ba5be2bb9a7d7">_mesh_z_var</a>))
<a name="l00898"></a>00898         <span class="keywordflow">continue</span>;
<a name="l00899"></a>00899 
<a name="l00900"></a>00900       <span class="comment">// Some of this code currently relies on the assumption that</span>
<a name="l00901"></a>00901       <span class="comment">// we can pull mesh coordinate data from our own system</span>
<a name="l00902"></a>00902       <span class="keywordflow">if</span> (<a class="code" href="classFEMSystem.php#a264d49a3cd5e9a17adbc9548e5d87e3e">_mesh_sys</a> != this-&gt;<a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">number</a>())
<a name="l00903"></a>00903         libmesh_not_implemented();
<a name="l00904"></a>00904 
<a name="l00905"></a>00905       <span class="comment">// This residual should only be called by unsteady solvers:</span>
<a name="l00906"></a>00906       <span class="comment">// if the mesh is steady, there&#39;s no mesh convection term!</span>
<a name="l00907"></a>00907       <a class="code" href="classUnsteadySolver.php">UnsteadySolver</a> *unsteady =
<a name="l00908"></a>00908         <span class="keyword">dynamic_cast&lt;</span><a class="code" href="classUnsteadySolver.php">UnsteadySolver</a> *<span class="keyword">&gt;</span>(this-&gt;<a class="code" href="classDifferentiableSystem.php#a0dab4aeae88234a06d041519b219fbc4">time_solver</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>());
<a name="l00909"></a>00909       <span class="keywordflow">if</span> (!unsteady)
<a name="l00910"></a>00910         <span class="keywordflow">return</span> request_jacobian;
<a name="l00911"></a>00911 
<a name="l00912"></a>00912       <span class="keyword">const</span> std::vector&lt;Real&gt; &amp;JxW = 
<a name="l00913"></a>00913         context.<a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[var]-&gt;get_JxW();
<a name="l00914"></a>00914 
<a name="l00915"></a>00915       <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;     &amp;phi =
<a name="l00916"></a>00916         context.<a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[var]-&gt;get_phi();
<a name="l00917"></a>00917 
<a name="l00918"></a>00918       <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt; &amp;dphi =
<a name="l00919"></a>00919         context.<a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[var]-&gt;get_dphi();
<a name="l00920"></a>00920 
<a name="l00921"></a>00921       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_u_dofs = context.<a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[var].size();
<a name="l00922"></a>00922 
<a name="l00923"></a>00923       <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;Fu = *context.<a class="code" href="classDiffContext.php#a92489ca01a154b956107acd5eab14e1c">elem_subresiduals</a>[var];
<a name="l00924"></a>00924       <a class="code" href="classDenseSubMatrix.php">DenseSubMatrix&lt;Number&gt;</a> &amp;Kuu = *context.<a class="code" href="classDiffContext.php#a314b50e71d312179bb30b1800d7677ee">elem_subjacobians</a>[var][var];
<a name="l00925"></a>00925 
<a name="l00926"></a>00926       <a class="code" href="classDenseSubMatrix.php">DenseSubMatrix&lt;Number&gt;</a> *Kux = n_x_dofs ?
<a name="l00927"></a>00927         context.<a class="code" href="classDiffContext.php#a314b50e71d312179bb30b1800d7677ee">elem_subjacobians</a>[var][<a class="code" href="classFEMSystem.php#a908e5f051c224b25710384dc90023562">_mesh_x_var</a>] : NULL;
<a name="l00928"></a>00928       <a class="code" href="classDenseSubMatrix.php">DenseSubMatrix&lt;Number&gt;</a> *Kuy = n_y_dofs ?
<a name="l00929"></a>00929         context.<a class="code" href="classDiffContext.php#a314b50e71d312179bb30b1800d7677ee">elem_subjacobians</a>[var][<a class="code" href="classFEMSystem.php#ae8743cd2af913217990dfd57ba9c2c50">_mesh_y_var</a>] : NULL;
<a name="l00930"></a>00930       <a class="code" href="classDenseSubMatrix.php">DenseSubMatrix&lt;Number&gt;</a> *Kuz = n_z_dofs ?
<a name="l00931"></a>00931         context.<a class="code" href="classDiffContext.php#a314b50e71d312179bb30b1800d7677ee">elem_subjacobians</a>[var][<a class="code" href="classFEMSystem.php#aef0ada8832396ad9f02ba5be2bb9a7d7">_mesh_z_var</a>] : NULL;
<a name="l00932"></a>00932 
<a name="l00933"></a>00933       std::vector&lt;Real&gt; delta_x(n_x_dofs, 0.);
<a name="l00934"></a>00934       std::vector&lt;Real&gt; delta_y(n_y_dofs, 0.);
<a name="l00935"></a>00935       std::vector&lt;Real&gt; delta_z(n_z_dofs, 0.);
<a name="l00936"></a>00936 
<a name="l00937"></a>00937       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != n_x_dofs; ++i)
<a name="l00938"></a>00938         {
<a name="l00939"></a>00939           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = context.<a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[<a class="code" href="classFEMSystem.php#a908e5f051c224b25710384dc90023562">_mesh_x_var</a>][i];
<a name="l00940"></a>00940           delta_x[i] = <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>(this-&gt;<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(j)) -
<a name="l00941"></a>00941                        <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>(unsteady-&gt;<a class="code" href="classUnsteadySolver.php#ad14f2816697932209a6996937dd8ff18">old_nonlinear_solution</a>(j));
<a name="l00942"></a>00942         }
<a name="l00943"></a>00943 
<a name="l00944"></a>00944       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != n_y_dofs; ++i)
<a name="l00945"></a>00945         {
<a name="l00946"></a>00946           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = context.<a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[<a class="code" href="classFEMSystem.php#ae8743cd2af913217990dfd57ba9c2c50">_mesh_y_var</a>][i];
<a name="l00947"></a>00947           delta_y[i] = <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>(this-&gt;<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(j)) -
<a name="l00948"></a>00948                        <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>(unsteady-&gt;<a class="code" href="classUnsteadySolver.php#ad14f2816697932209a6996937dd8ff18">old_nonlinear_solution</a>(j));
<a name="l00949"></a>00949         }
<a name="l00950"></a>00950 
<a name="l00951"></a>00951       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != n_z_dofs; ++i)
<a name="l00952"></a>00952         {
<a name="l00953"></a>00953           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = context.<a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[<a class="code" href="classFEMSystem.php#aef0ada8832396ad9f02ba5be2bb9a7d7">_mesh_z_var</a>][i];
<a name="l00954"></a>00954           delta_z[i] = <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>(this-&gt;<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(j)) -
<a name="l00955"></a>00955                        <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>(unsteady-&gt;<a class="code" href="classUnsteadySolver.php#ad14f2816697932209a6996937dd8ff18">old_nonlinear_solution</a>(j));
<a name="l00956"></a>00956         }
<a name="l00957"></a>00957 
<a name="l00958"></a>00958       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp = 0; qp != n_qpoints; ++qp)
<a name="l00959"></a>00959         {
<a name="l00960"></a>00960           <a class="code" href="classVectorValue.php">Gradient</a> grad_u = context.<a class="code" href="classFEMContext.php#a67f09e3ce6d11d805e1106874fa99504">interior_gradient</a>(var, qp);
<a name="l00961"></a>00961           <a class="code" href="classVectorValue.php">RealGradient</a> convection(0.);
<a name="l00962"></a>00962 
<a name="l00963"></a>00963           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != n_x_dofs; ++i)
<a name="l00964"></a>00964             convection(0) += delta_x[i] * psi[i][qp];
<a name="l00965"></a>00965           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != n_y_dofs; ++i)
<a name="l00966"></a>00966             convection(1) += delta_y[i] * psi[i][qp];
<a name="l00967"></a>00967           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != n_z_dofs; ++i)
<a name="l00968"></a>00968             convection(2) += delta_z[i] * psi[i][qp];
<a name="l00969"></a>00969 
<a name="l00970"></a>00970           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != n_u_dofs; ++i)
<a name="l00971"></a>00971             {
<a name="l00972"></a>00972               <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> JxWxPhiI = JxW[qp] * phi[i][qp];
<a name="l00973"></a>00973               Fu(i) += (convection * grad_u) * JxWxPhiI;
<a name="l00974"></a>00974               <span class="keywordflow">if</span> (request_jacobian)
<a name="l00975"></a>00975                 {
<a name="l00976"></a>00976                   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> JxWxPhiI = JxW[qp] * phi[i][qp];
<a name="l00977"></a>00977                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = 0; j != n_u_dofs; ++j)
<a name="l00978"></a>00978                     Kuu(i,j) += JxWxPhiI * (convection * dphi[j][qp]);
<a name="l00979"></a>00979 
<a name="l00980"></a>00980                   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> JxWxPhiIoverDT = JxWxPhiI/this-&gt;<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a>;
<a name="l00981"></a>00981 
<a name="l00982"></a>00982                   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> JxWxPhiIxDUDXoverDT = JxWxPhiIoverDT * grad_u(0);
<a name="l00983"></a>00983                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = 0; j != n_x_dofs; ++j)
<a name="l00984"></a>00984                     (*Kux)(i,j) += JxWxPhiIxDUDXoverDT * psi[j][qp];
<a name="l00985"></a>00985 
<a name="l00986"></a>00986                   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> JxWxPhiIxDUDYoverDT = JxWxPhiIoverDT * grad_u(1);
<a name="l00987"></a>00987                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = 0; j != n_y_dofs; ++j)
<a name="l00988"></a>00988                     (*Kuy)(i,j) += JxWxPhiIxDUDYoverDT * psi[j][qp];
<a name="l00989"></a>00989 
<a name="l00990"></a>00990                   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> JxWxPhiIxDUDZoverDT = JxWxPhiIoverDT * grad_u(2);
<a name="l00991"></a>00991                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = 0; j != n_z_dofs; ++j)
<a name="l00992"></a>00992                     (*Kuz)(i,j) += JxWxPhiIxDUDZoverDT * psi[j][qp];
<a name="l00993"></a>00993                 }
<a name="l00994"></a>00994             }
<a name="l00995"></a>00995         }
<a name="l00996"></a>00996     }
<a name="l00997"></a>00997 
<a name="l00998"></a>00998   <span class="keywordflow">return</span> request_jacobian;
<a name="l00999"></a>00999 }
<a name="l01000"></a>01000 
<a name="l01001"></a>01001       
<a name="l01002"></a>01002 
<a name="l01003"></a><a class="code" href="classFEMSystem.php#aa42f5f8d903527775028841676c84a46">01003</a> <span class="keywordtype">bool</span> <a class="code" href="classFEMSystem.php#aa42f5f8d903527775028841676c84a46">FEMSystem::mass_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l01004"></a>01004                                <a class="code" href="classDiffContext.php">DiffContext</a> &amp;c)
<a name="l01005"></a>01005 {
<a name="l01006"></a>01006   <a class="code" href="classFEMContext.php">FEMContext</a> &amp;context = libmesh_cast_ref&lt;FEMContext&amp;&gt;(c);
<a name="l01007"></a>01007 
<a name="l01008"></a>01008   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qpoints = context.<a class="code" href="classFEMContext.php#a3be41281e28b8021e92e41b3028556db">element_qrule</a>-&gt;<a class="code" href="classQBase.php#a562b19b027dbad4ea8fdd65dddbaa649">n_points</a>();
<a name="l01009"></a>01009 
<a name="l01010"></a>01010   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = 0; var != this-&gt;<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>(); ++var)
<a name="l01011"></a>01011     {
<a name="l01012"></a>01012       <span class="keywordflow">if</span> (!<a class="code" href="classDifferentiableSystem.php#a457f7ba8b9e434c07935e23d33c41cc4">_time_evolving</a>[var])
<a name="l01013"></a>01013         <span class="keywordflow">continue</span>;
<a name="l01014"></a>01014 
<a name="l01015"></a>01015       <span class="keyword">const</span> std::vector&lt;Real&gt; &amp;JxW = 
<a name="l01016"></a>01016         context.<a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[var]-&gt;get_JxW();
<a name="l01017"></a>01017 
<a name="l01018"></a>01018       <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt; &amp;phi =
<a name="l01019"></a>01019         context.<a class="code" href="classFEMContext.php#a64fe5d7126cf8ec2992251332f17e517">element_fe_var</a>[var]-&gt;get_phi();
<a name="l01020"></a>01020 
<a name="l01021"></a>01021       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#aa8f04263eed1eaf253e81041f166408b">n_dofs</a> = context.<a class="code" href="classDiffContext.php#ac30799035faefc2acd19efa7d7b90086">dof_indices_var</a>[var].size();
<a name="l01022"></a>01022 
<a name="l01023"></a>01023       <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;Fu = *context.<a class="code" href="classDiffContext.php#a92489ca01a154b956107acd5eab14e1c">elem_subresiduals</a>[var];
<a name="l01024"></a>01024       <a class="code" href="classDenseSubMatrix.php">DenseSubMatrix&lt;Number&gt;</a> &amp;Kuu = *context.<a class="code" href="classDiffContext.php#a314b50e71d312179bb30b1800d7677ee">elem_subjacobians</a>[var][var];
<a name="l01025"></a>01025 
<a name="l01026"></a>01026       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp = 0; qp != n_qpoints; ++qp)
<a name="l01027"></a>01027         {
<a name="l01028"></a>01028           <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> u = context.<a class="code" href="classFEMContext.php#a5b2baa1edbf8d7aba30f7beb36c45daf">interior_value</a>(var, qp);
<a name="l01029"></a>01029           <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> JxWxU = JxW[qp] * u;
<a name="l01030"></a>01030           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != <a class="code" href="classSystem.php#aa8f04263eed1eaf253e81041f166408b">n_dofs</a>; ++i)
<a name="l01031"></a>01031             {
<a name="l01032"></a>01032               Fu(i) += JxWxU * phi[i][qp];
<a name="l01033"></a>01033               <span class="keywordflow">if</span> (request_jacobian &amp;&amp; context.<a class="code" href="classDiffContext.php#a9cb6e53f5be4dbbbff17d3c9986ec423">elem_solution_derivative</a>)
<a name="l01034"></a>01034                 {
<a name="l01035"></a>01035                   libmesh_assert (context.<a class="code" href="classDiffContext.php#a9cb6e53f5be4dbbbff17d3c9986ec423">elem_solution_derivative</a> == 1.0);
<a name="l01036"></a>01036 
<a name="l01037"></a>01037                   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> JxWxPhiI = JxW[qp] * phi[i][qp];
<a name="l01038"></a>01038                   Kuu(i,i) += JxWxPhiI * phi[i][qp];
<a name="l01039"></a>01039                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = i+1; j &lt; <a class="code" href="classSystem.php#aa8f04263eed1eaf253e81041f166408b">n_dofs</a>; ++j)
<a name="l01040"></a>01040                     {
<a name="l01041"></a>01041                       <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> Kij = JxWxPhiI * phi[j][qp];
<a name="l01042"></a>01042                       Kuu(i,j) += Kij;
<a name="l01043"></a>01043                       Kuu(j,i) += Kij;
<a name="l01044"></a>01044                     }
<a name="l01045"></a>01045                 }
<a name="l01046"></a>01046             }
<a name="l01047"></a>01047         }
<a name="l01048"></a>01048     }
<a name="l01049"></a>01049 
<a name="l01050"></a>01050   <span class="keywordflow">return</span> request_jacobian;
<a name="l01051"></a>01051 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
