<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>fem_system.h</h1>  </div>
</div>
<div class="contents">
<a href="fem__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 <span class="comment">// $Id: fem_system.h 3412 2009-06-26 21:50:27Z roystgnr $</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00005"></a>00005 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00006"></a>00006   
<a name="l00007"></a>00007 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00008"></a>00008 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00009"></a>00009 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00010"></a>00010 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00011"></a>00011   
<a name="l00012"></a>00012 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00013"></a>00013 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00014"></a>00014 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00015"></a>00015 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00016"></a>00016   
<a name="l00017"></a>00017 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00018"></a>00018 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00019"></a>00019 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifndef __fem_system_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#define __fem_system_h__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="diff__system_8h.php">diff_system.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="fem__context_8h.php">fem_context.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Forward Declarations</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00049"></a>00049 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00050"></a>00050 <span class="comment">// FEMSystem class definition</span>
<a name="l00051"></a>00051 
<a name="l00052"></a><a class="code" href="classFEMSystem.php">00052</a> <span class="keyword">class </span><a class="code" href="classFEMSystem.php">FEMSystem</a> : <span class="keyword">public</span> <a class="code" href="classDifferentiableSystem.php">DifferentiableSystem</a>
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054 <span class="keyword">public</span>:
<a name="l00055"></a>00055 
<a name="l00060"></a>00060   <a class="code" href="classFEMSystem.php#ad741a33a05f37d3216bb91e9dc0a79ee">FEMSystem</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00061"></a>00061                  <span class="keyword">const</span> std::string&amp; <a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>,
<a name="l00062"></a>00062                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">number</a>);
<a name="l00063"></a>00063 
<a name="l00067"></a>00067   <span class="keyword">virtual</span> <a class="code" href="classFEMSystem.php#a21e50d15c9a34c31e65f1288409158b4">~FEMSystem</a> ();
<a name="l00068"></a>00068 
<a name="l00072"></a><a class="code" href="classFEMSystem.php#a93c2c2ec8ee0056c02f011823512a701">00072</a>   <span class="keyword">typedef</span> <a class="code" href="classFEMSystem.php">FEMSystem</a> <a class="code" href="classFEMSystem.php#a93c2c2ec8ee0056c02f011823512a701">sys_type</a>;
<a name="l00073"></a>00073 
<a name="l00077"></a><a class="code" href="classFEMSystem.php#af158e0a678ed4de625ff3c2dd47b07b2">00077</a>   <span class="keyword">typedef</span> <a class="code" href="classDifferentiableSystem.php">DifferentiableSystem</a> <a class="code" href="classFEMSystem.php#af158e0a678ed4de625ff3c2dd47b07b2">Parent</a>;
<a name="l00078"></a>00078   
<a name="l00083"></a>00083   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#a6dbe64d3215fc46fa079223759a7011f">clear</a> ();
<a name="l00084"></a>00084 
<a name="l00090"></a>00090   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#a7143f0d4ef97184f88d58af2613b0fd4">assembly</a> (<span class="keywordtype">bool</span> get_residual, <span class="keywordtype">bool</span> get_jacobian);
<a name="l00091"></a>00091 
<a name="l00100"></a>00100   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#acd66d3f3517850c56e010ffa7f45f249">solve</a> ();
<a name="l00101"></a>00101 
<a name="l00113"></a>00113   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#a8b080d3b1c8851f7329d76daa78f0db6">time_evolving</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var);
<a name="l00114"></a>00114 
<a name="l00129"></a>00129   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#a3eaba6586e5f82999719fba114b02773">mesh_x_position</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sysnum, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var);
<a name="l00130"></a>00130 
<a name="l00135"></a>00135   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#a9192f021a04e41f6db18316a8de720dd">mesh_y_position</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sysnum, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var);
<a name="l00136"></a>00136 
<a name="l00141"></a>00141   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#aacbd9a28cfaf70b854954e1214b0d173">mesh_z_position</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sysnum, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var);
<a name="l00142"></a>00142 
<a name="l00147"></a>00147   <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#a80c30acbecc12dca6984e77bdbf880a4">mesh_position_get</a>();
<a name="l00148"></a>00148 
<a name="l00153"></a>00153   <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#abf6f87d5af4e528271190142e1b393f9">mesh_position_set</a>();
<a name="l00154"></a>00154 
<a name="l00169"></a>00169   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classFEMSystem.php#abb0481169108f844ac347fe34f61228f">eulerian_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00170"></a>00170                                   <a class="code" href="classDiffContext.php">DiffContext</a> &amp;context);
<a name="l00171"></a>00171 
<a name="l00185"></a>00185   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classFEMSystem.php#aa42f5f8d903527775028841676c84a46">mass_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00186"></a>00186                               <a class="code" href="classDiffContext.php">DiffContext</a> &amp;context);
<a name="l00187"></a>00187 
<a name="l00196"></a>00196   <span class="keyword">virtual</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DiffContext&gt;</a> <a class="code" href="classFEMSystem.php#a6519e2a695abb5355f71d0398d025979">build_context</a>();
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   <span class="comment">/*</span>
<a name="l00199"></a>00199 <span class="comment">   * Prepares the result of a build_context() call for use.</span>
<a name="l00200"></a>00200 <span class="comment">   * </span>
<a name="l00201"></a>00201 <span class="comment">   * Most FEMSystem-based problems will need to reimplement this in order to</span>
<a name="l00202"></a>00202 <span class="comment">   * call FE::get_*() as their particular physics requires.</span>
<a name="l00203"></a>00203 <span class="comment">   */</span>
<a name="l00204"></a>00204   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#a1ed677e685064eea468e0b8637effc44">init_context</a>(<a class="code" href="classDiffContext.php">DiffContext</a> &amp;);
<a name="l00205"></a>00205  
<a name="l00210"></a>00210   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#a1be6a0b9f145b5df10d699c65c960c97">postprocess</a> ();
<a name="l00211"></a>00211 
<a name="l00219"></a>00219   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#aa73fae103b7f54831f93c6a3fd3ff11b">assemble_qoi</a> ();
<a name="l00220"></a>00220 
<a name="l00228"></a>00228   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#a3a5eb8fd7e03916f3d3239eb7e357532">assemble_qoi_derivative</a> ();
<a name="l00229"></a>00229 
<a name="l00236"></a><a class="code" href="classFEMSystem.php#a71d55a123010eca54580ebb77b6f4e25">00236</a>   <span class="keywordtype">bool</span> <a class="code" href="classFEMSystem.php#a71d55a123010eca54580ebb77b6f4e25">fe_reinit_during_postprocess</a>;
<a name="l00237"></a>00237 
<a name="l00247"></a><a class="code" href="classFEMSystem.php#a8b2fd912dd7f212979f048561dcf5814">00247</a>   <span class="keywordtype">int</span> <a class="code" href="classFEMSystem.php#a8b2fd912dd7f212979f048561dcf5814">extra_quadrature_order</a>;
<a name="l00248"></a>00248 
<a name="l00254"></a><a class="code" href="classFEMSystem.php#a0d9dc3c9c8a70e6d583b144801cd0c61">00254</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFEMSystem.php#a0d9dc3c9c8a70e6d583b144801cd0c61">numerical_jacobian_h</a>;
<a name="l00255"></a>00255 
<a name="l00269"></a><a class="code" href="classFEMSystem.php#aab6fffc5e23ecd0d815d75104512a3c1">00269</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFEMSystem.php#aab6fffc5e23ecd0d815d75104512a3c1">verify_analytic_jacobians</a>;
<a name="l00270"></a>00270 
<a name="l00271"></a>00271 <span class="keyword">protected</span>:
<a name="l00276"></a>00276   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#a4cef19d8d8779a2596fa5c2266f9e8d0">init_data</a> ();
<a name="l00277"></a>00277 
<a name="l00281"></a><a class="code" href="classFEMSystem.php#a438c7e0ad80192f5f81e522742522347">00281</a>   <span class="keyword">typedef</span> bool (<a class="code" href="classTimeSolver.php">TimeSolver</a>::*<a class="code" href="classFEMSystem.php#a438c7e0ad80192f5f81e522742522347">TimeSolverResPtr</a>)(bool, <a class="code" href="classDiffContext.php">DiffContext</a>&amp;);
<a name="l00282"></a>00282 
<a name="l00287"></a>00287   <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#ac647a04dec989f60d0952ae3f5734aaf">numerical_jacobian</a> (<a class="code" href="classFEMSystem.php#a438c7e0ad80192f5f81e522742522347">TimeSolverResPtr</a> res,
<a name="l00288"></a>00288                            <a class="code" href="classFEMContext.php">FEMContext</a> &amp;context);
<a name="l00289"></a>00289 
<a name="l00295"></a>00295   <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#ace72118960028430ca361b0addd03861">numerical_elem_jacobian</a> (<a class="code" href="classFEMContext.php">FEMContext</a> &amp;context);
<a name="l00296"></a>00296 
<a name="l00302"></a>00302   <span class="keywordtype">void</span> <a class="code" href="classFEMSystem.php#a0fb6805ca18d186f7dac430ce19fed81">numerical_side_jacobian</a> (<a class="code" href="classFEMContext.php">FEMContext</a> &amp;context);
<a name="l00303"></a>00303 
<a name="l00307"></a><a class="code" href="classFEMSystem.php#aef0ada8832396ad9f02ba5be2bb9a7d7">00307</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFEMSystem.php#a264d49a3cd5e9a17adbc9548e5d87e3e">_mesh_sys</a>, <a class="code" href="classFEMSystem.php#a908e5f051c224b25710384dc90023562">_mesh_x_var</a>, <a class="code" href="classFEMSystem.php#ae8743cd2af913217990dfd57ba9c2c50">_mesh_y_var</a>, <a class="code" href="classFEMSystem.php#aef0ada8832396ad9f02ba5be2bb9a7d7">_mesh_z_var</a>;
<a name="l00308"></a>00308 };
<a name="l00309"></a>00309 
<a name="l00310"></a>00310 
<a name="l00311"></a>00311 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
