<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c8cf73965feff5280e8b0581da1a9d14.php">error_estimation</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>fourth_error_estimators.h</h1>  </div>
</div>
<div class="contents">
<a href="fourth__error__estimators_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fourth_error_estimators.h 3428 2009-07-17 01:51:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __fourth_error_estimators_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __fourth_error_estimators_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="jump__error__estimator_8h.php">jump_error_estimator.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00045"></a><a class="code" href="classLaplacianErrorEstimator.php">00045</a> <span class="keyword">class </span><a class="code" href="classLaplacianErrorEstimator.php">LaplacianErrorEstimator</a> : <span class="keyword">public</span> <a class="code" href="classJumpErrorEstimator.php">JumpErrorEstimator</a>
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047 <span class="keyword">public</span>:
<a name="l00048"></a>00048 
<a name="l00053"></a><a class="code" href="classLaplacianErrorEstimator.php#a51aa9eb4ba0d9cf0190df33c7a92ee10">00053</a>   <a class="code" href="classLaplacianErrorEstimator.php#a51aa9eb4ba0d9cf0190df33c7a92ee10">LaplacianErrorEstimator</a>() { <a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a> = <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a>; }
<a name="l00054"></a>00054   
<a name="l00058"></a><a class="code" href="classLaplacianErrorEstimator.php#abb933662df938f1ee4badc9557cd17e3">00058</a>   <a class="code" href="classLaplacianErrorEstimator.php#abb933662df938f1ee4badc9557cd17e3">~LaplacianErrorEstimator</a>() {}
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 <span class="keyword">protected</span>:
<a name="l00061"></a>00061 
<a name="l00066"></a>00066   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classLaplacianErrorEstimator.php#a0a0421f9a1fc44aeba94d2b74a0e7547">initialize</a>(<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; system,
<a name="l00067"></a>00067                           <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00068"></a>00068                           <span class="keywordtype">bool</span> estimate_parent_error);
<a name="l00069"></a>00069 
<a name="l00074"></a>00074   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classLaplacianErrorEstimator.php#ac10abed342e87091fadcbd902bef2c0c">internal_side_integration</a>();
<a name="l00075"></a>00075 };
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 <span class="preprocessor">#endif</span>
<a name="l00079"></a>00079 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
