<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_60be1125a39495b698d2d56e8e5b50b1.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>frequency_system.C</h1>  </div>
</div>
<div class="contents">
<a href="frequency__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: frequency_system.C 3465 2009-09-17 18:01:00Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">/*</span>
<a name="l00026"></a>00026 <span class="comment"> * Require complex arithmetic</span>
<a name="l00027"></a>00027 <span class="comment"> */</span>
<a name="l00028"></a>00028 <span class="preprocessor">#if defined(LIBMESH_USE_COMPLEX_NUMBERS)</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// C++ includes</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &lt;cstdio&gt;</span>          <span class="comment">// for sprintf</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Local includes</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;frequency_system.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;equation_systems.h&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;linear_solver.h&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00044"></a>00044 <span class="comment">// FrequencySystem implementation</span>
<a name="l00045"></a><a class="code" href="classFrequencySystem.php#a3fe496f41529ee4668620621e40cec86">00045</a> <a class="code" href="classFrequencySystem.php#a3fe496f41529ee4668620621e40cec86">FrequencySystem::FrequencySystem</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00046"></a>00046                                   <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00047"></a>00047                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :
<a name="l00048"></a>00048   <a class="code" href="classLinearImplicitSystem.php">LinearImplicitSystem</a>      (es, name, number),
<a name="l00049"></a>00049   solve_system              (NULL),
<a name="l00050"></a>00050   _finished_set_frequencies (false),
<a name="l00051"></a>00051   _keep_solution_duplicates (true),
<a name="l00052"></a>00052   _finished_init            (false),
<a name="l00053"></a>00053   _finished_assemble        (false)
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055   <span class="comment">// default value for wave speed &amp; fluid density</span>
<a name="l00056"></a>00056   <span class="comment">//_equation_systems.parameters.set&lt;Real&gt;(&quot;wave speed&quot;) = 340.;</span>
<a name="l00057"></a>00057   <span class="comment">//_equation_systems.parameters.set&lt;Real&gt;(&quot;rho&quot;)        = 1.225;</span>
<a name="l00058"></a>00058 }
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a><a class="code" href="classFrequencySystem.php#a477384227e5a5a405f0460e92ac07059">00062</a> <a class="code" href="classFrequencySystem.php#a477384227e5a5a405f0460e92ac07059">FrequencySystem::~FrequencySystem</a> ()
<a name="l00063"></a>00063 {
<a name="l00064"></a>00064   this-&gt;<a class="code" href="classFrequencySystem.php#adf2638d3093d9e49020a2f788f1a9706">clear</a> ();
<a name="l00065"></a>00065   
<a name="l00066"></a>00066   <span class="comment">// the additional matrices and vectors are cleared and zero&#39;ed in System</span>
<a name="l00067"></a>00067 }
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 
<a name="l00072"></a><a class="code" href="classFrequencySystem.php#adf2638d3093d9e49020a2f788f1a9706">00072</a> <span class="keywordtype">void</span> <a class="code" href="classFrequencySystem.php#adf2638d3093d9e49020a2f788f1a9706">FrequencySystem::clear</a> ()
<a name="l00073"></a>00073 {
<a name="l00074"></a>00074   <a class="code" href="classFrequencySystem.php#adf2638d3093d9e49020a2f788f1a9706">LinearImplicitSystem::clear</a>();
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <a class="code" href="classFrequencySystem.php#acc57a5e69060359d5647517b18fe13d9">_finished_set_frequencies</a> = <span class="keyword">false</span>;
<a name="l00077"></a>00077   <a class="code" href="classFrequencySystem.php#a0f2cfab950cc9b564e7bb26bd9dd2c96">_keep_solution_duplicates</a> = <span class="keyword">true</span>;
<a name="l00078"></a>00078   <a class="code" href="classFrequencySystem.php#a4e0686d352302a487efce7f5f4d53812">_finished_init</a>            = <span class="keyword">false</span>;
<a name="l00079"></a>00079   <a class="code" href="classFrequencySystem.php#aec03801d68466271254c4f22dcf0e3f0">_finished_assemble</a>        = <span class="keyword">false</span>;
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <span class="comment">/*</span>
<a name="l00082"></a>00082 <span class="comment">   * We have to distinguish between the</span>
<a name="l00083"></a>00083 <span class="comment">   * simple straightforward &quot;clear()&quot;</span>
<a name="l00084"></a>00084 <span class="comment">   * and the clear that also touches the</span>
<a name="l00085"></a>00085 <span class="comment">   * EquationSystems parameters &quot;current frequency&quot; etc.</span>
<a name="l00086"></a>00086 <span class="comment">   * Namely, when reading from file (through equation_systems_io.C</span>
<a name="l00087"></a>00087 <span class="comment">   * methods), the param&#39;s are read in, then the systems.</span>
<a name="l00088"></a>00088 <span class="comment">   * Prior to reading a system, this system gets cleared...</span>
<a name="l00089"></a>00089 <span class="comment">   * And there, all the previously loaded frequency parameters</span>
<a name="l00090"></a>00090 <span class="comment">   * would get lost...</span>
<a name="l00091"></a>00091 <span class="comment">   */</span>
<a name="l00092"></a>00092 }
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a><a class="code" href="classFrequencySystem.php#a1c66f0f746e1427ccf51a2a417f4edfc">00096</a> <span class="keywordtype">void</span> <a class="code" href="classFrequencySystem.php#a1c66f0f746e1427ccf51a2a417f4edfc">FrequencySystem::clear_all</a> ()
<a name="l00097"></a>00097 {
<a name="l00098"></a>00098   this-&gt;<a class="code" href="classFrequencySystem.php#adf2638d3093d9e49020a2f788f1a9706">clear</a> ();
<a name="l00099"></a>00099 
<a name="l00100"></a>00100   <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es =
<a name="l00101"></a>00101     this-&gt;<a class="code" href="classSystem.php#a51da3ea6211cf1888377c9c4b1554232">get_equation_systems</a>();
<a name="l00102"></a>00102   
<a name="l00103"></a>00103   <span class="comment">// clear frequencies in the parameters section of the </span>
<a name="l00104"></a>00104   <span class="comment">// EquationSystems object</span>
<a name="l00105"></a>00105   <span class="keywordflow">if</span> (es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a20587dd7120a79624ebc7095aea0390c">have_parameter</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt; (<span class="stringliteral">&quot;n_frequencies&quot;</span>))
<a name="l00106"></a>00106     {
<a name="l00107"></a>00107       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n &lt; es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#ac4c5e3f411568e6defcdd2ace5829d96">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;n_frequencies&quot;</span>); n++)
<a name="l00108"></a>00108         es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a4e235ebee032811d76261915691c5812">remove</a>(this-&gt;form_freq_param_name(n));
<a name="l00109"></a>00109       es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a4e235ebee032811d76261915691c5812">remove</a>(<span class="stringliteral">&quot;current frequency&quot;</span>);
<a name="l00110"></a>00110     }
<a name="l00111"></a>00111 }
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a><a class="code" href="classFrequencySystem.php#a099f393c71a21b80bf1c8629a5daeaad">00116</a> <span class="keywordtype">void</span> <a class="code" href="classFrequencySystem.php#a099f393c71a21b80bf1c8629a5daeaad">FrequencySystem::init_data</a> ()
<a name="l00117"></a>00117 {
<a name="l00118"></a>00118   <span class="comment">// initialize parent data and additional solution vectors</span>
<a name="l00119"></a>00119   <a class="code" href="classFrequencySystem.php#a099f393c71a21b80bf1c8629a5daeaad">LinearImplicitSystem::init_data</a>();
<a name="l00120"></a>00120   
<a name="l00121"></a>00121   <span class="comment">// Log how long initializing the system takes</span>
<a name="l00122"></a>00122   START_LOG(<span class="stringliteral">&quot;init()&quot;</span>, <span class="stringliteral">&quot;FrequencySystem&quot;</span>);
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es =
<a name="l00125"></a>00125     this-&gt;<a class="code" href="classSystem.php#a51da3ea6211cf1888377c9c4b1554232">get_equation_systems</a>();
<a name="l00126"></a>00126 
<a name="l00127"></a>00127   <span class="comment">// make sure we have frequencies to solve for</span>
<a name="l00128"></a>00128   <span class="keywordflow">if</span> (!<a class="code" href="classFrequencySystem.php#acc57a5e69060359d5647517b18fe13d9">_finished_set_frequencies</a>)
<a name="l00129"></a>00129     {
<a name="l00130"></a>00130       <span class="comment">/*</span>
<a name="l00131"></a>00131 <span class="comment">       * when this system was read from file, check</span>
<a name="l00132"></a>00132 <span class="comment">       * if this has a &quot;n_frequencies&quot; parameter,</span>
<a name="l00133"></a>00133 <span class="comment">       * and initialize us with these.</span>
<a name="l00134"></a>00134 <span class="comment">       */</span>
<a name="l00135"></a>00135       <span class="keywordflow">if</span> (es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a20587dd7120a79624ebc7095aea0390c">have_parameter</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt; (<span class="stringliteral">&quot;n_frequencies&quot;</span>))
<a name="l00136"></a>00136         {
<a name="l00137"></a>00137           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_freq = 
<a name="l00138"></a>00138             es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#ac4c5e3f411568e6defcdd2ace5829d96">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;n_frequencies&quot;</span>);
<a name="l00139"></a>00139 
<a name="l00140"></a>00140           libmesh_assert(n_freq &gt; 0);
<a name="l00141"></a>00141 
<a name="l00142"></a>00142           <a class="code" href="classFrequencySystem.php#acc57a5e69060359d5647517b18fe13d9">_finished_set_frequencies</a> = <span class="keyword">true</span>;
<a name="l00143"></a>00143 
<a name="l00144"></a>00144           this-&gt;<a class="code" href="classFrequencySystem.php#a3cfdc4aaa52a24c7d85d6fe4f276203f">set_current_frequency</a>(0);
<a name="l00145"></a>00145         }
<a name="l00146"></a>00146       <span class="keywordflow">else</span>
<a name="l00147"></a>00147         {
<a name="l00148"></a>00148           std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Need to set frequencies before calling init(). &quot;</span> &lt;&lt; std::endl;
<a name="l00149"></a>00149           libmesh_error();
<a name="l00150"></a>00150         }
<a name="l00151"></a>00151     }
<a name="l00152"></a>00152 
<a name="l00153"></a>00153   <a class="code" href="classFrequencySystem.php#a4e0686d352302a487efce7f5f4d53812">_finished_init</a> = <span class="keyword">true</span>;
<a name="l00154"></a>00154 
<a name="l00155"></a>00155   <span class="comment">// Stop logging init()</span>
<a name="l00156"></a>00156   STOP_LOG(<span class="stringliteral">&quot;init()&quot;</span>, <span class="stringliteral">&quot;FrequencySystem&quot;</span>);
<a name="l00157"></a>00157 }
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a><a class="code" href="classFrequencySystem.php#a21b5cebd5c4bab7398ea96b3aae0b850">00161</a> <span class="keywordtype">void</span> <a class="code" href="classFrequencySystem.php#a21b5cebd5c4bab7398ea96b3aae0b850">FrequencySystem::assemble</a> ()
<a name="l00162"></a>00162 {
<a name="l00163"></a>00163   libmesh_assert (<a class="code" href="classFrequencySystem.php#a4e0686d352302a487efce7f5f4d53812">_finished_init</a>);
<a name="l00164"></a>00164 
<a name="l00165"></a>00165   <span class="keywordflow">if</span> (<a class="code" href="classFrequencySystem.php#aec03801d68466271254c4f22dcf0e3f0">_finished_assemble</a>)  
<a name="l00166"></a>00166     {
<a name="l00167"></a>00167       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Matrices already assembled.&quot;</span> &lt;&lt; std::endl;
<a name="l00168"></a>00168       libmesh_error (); 
<a name="l00169"></a>00169     }
<a name="l00170"></a>00170 
<a name="l00171"></a>00171   <span class="comment">// Log how long assemble() takes</span>
<a name="l00172"></a>00172   START_LOG(<span class="stringliteral">&quot;assemble()&quot;</span>, <span class="stringliteral">&quot;FrequencySystem&quot;</span>);
<a name="l00173"></a>00173 
<a name="l00174"></a>00174   <span class="comment">// prepare matrix with the help of the _dof_map, </span>
<a name="l00175"></a>00175   <span class="comment">// fill with sparsity pattern, initialize the</span>
<a name="l00176"></a>00176   <span class="comment">// additional matrices</span>
<a name="l00177"></a>00177   <a class="code" href="classFrequencySystem.php#a21b5cebd5c4bab7398ea96b3aae0b850">LinearImplicitSystem::assemble</a>();
<a name="l00178"></a>00178 
<a name="l00179"></a>00179   <span class="comment">//matrix.print ();</span>
<a name="l00180"></a>00180   <span class="comment">//rhs.print    ();</span>
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   <a class="code" href="classFrequencySystem.php#aec03801d68466271254c4f22dcf0e3f0">_finished_assemble</a> = <span class="keyword">true</span>;
<a name="l00183"></a>00183 
<a name="l00184"></a>00184   <span class="comment">// Log how long assemble() takes</span>
<a name="l00185"></a>00185   STOP_LOG(<span class="stringliteral">&quot;assemble()&quot;</span>, <span class="stringliteral">&quot;FrequencySystem&quot;</span>);
<a name="l00186"></a>00186 }
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 
<a name="l00190"></a><a class="code" href="classFrequencySystem.php#a735f006a0dc97f9e29bd59ab00a707af">00190</a> <span class="keywordtype">void</span> <a class="code" href="classFrequencySystem.php#a735f006a0dc97f9e29bd59ab00a707af">FrequencySystem::set_frequencies_by_steps</a> (<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> base_freq,
<a name="l00191"></a>00191                                                 <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> freq_step,
<a name="l00192"></a>00192                                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_freq,
<a name="l00193"></a>00193                                                 <span class="keyword">const</span> <span class="keywordtype">bool</span> allocate_solution_duplicates)
<a name="l00194"></a>00194 {
<a name="l00195"></a>00195   this-&gt;<a class="code" href="classFrequencySystem.php#a0f2cfab950cc9b564e7bb26bd9dd2c96">_keep_solution_duplicates</a> = allocate_solution_duplicates;
<a name="l00196"></a>00196 
<a name="l00197"></a>00197   <span class="comment">// sanity check</span>
<a name="l00198"></a>00198   <span class="keywordflow">if</span> (<a class="code" href="classFrequencySystem.php#acc57a5e69060359d5647517b18fe13d9">_finished_set_frequencies</a>)
<a name="l00199"></a>00199     {
<a name="l00200"></a>00200       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: frequencies already initialized.&quot;</span> 
<a name="l00201"></a>00201                 &lt;&lt; std::endl;
<a name="l00202"></a>00202       libmesh_error();
<a name="l00203"></a>00203     }
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es =
<a name="l00206"></a>00206     this-&gt;<a class="code" href="classSystem.php#a51da3ea6211cf1888377c9c4b1554232">get_equation_systems</a>();
<a name="l00207"></a>00207 
<a name="l00208"></a>00208   <span class="comment">// store number of frequencies as parameter</span>
<a name="l00209"></a>00209   es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;n_frequencies&quot;</span>) = n_freq;
<a name="l00210"></a>00210 
<a name="l00211"></a>00211   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;n_freq; n++)
<a name="l00212"></a>00212     {
<a name="l00213"></a>00213       <span class="comment">// remember frequencies as parameters</span>
<a name="l00214"></a>00214       es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(this-&gt;<a class="code" href="classFrequencySystem.php#ab211e0c9d38e2b249729c5c547809c47">form_freq_param_name</a>(n)) = 
<a name="l00215"></a>00215           base_freq + n * freq_step;
<a name="l00216"></a>00216 
<a name="l00217"></a>00217       <span class="comment">// build storage for solution vector, if wanted</span>
<a name="l00218"></a>00218       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classFrequencySystem.php#a0f2cfab950cc9b564e7bb26bd9dd2c96">_keep_solution_duplicates</a>)
<a name="l00219"></a>00219           this-&gt;<a class="code" href="classSystem.php#abab8a3810cc43d99fe395d449207b786">add_vector</a>(this-&gt;<a class="code" href="classFrequencySystem.php#a92da8ef91f49f1b5b9ebfb1aa471bd59">form_solu_vec_name</a>(n));
<a name="l00220"></a>00220     }  
<a name="l00221"></a>00221 
<a name="l00222"></a>00222   <a class="code" href="classFrequencySystem.php#acc57a5e69060359d5647517b18fe13d9">_finished_set_frequencies</a> = <span class="keyword">true</span>;
<a name="l00223"></a>00223 
<a name="l00224"></a>00224   <span class="comment">// set the current frequency</span>
<a name="l00225"></a>00225   this-&gt;<a class="code" href="classFrequencySystem.php#a3cfdc4aaa52a24c7d85d6fe4f276203f">set_current_frequency</a>(0);
<a name="l00226"></a>00226 }
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 
<a name="l00230"></a><a class="code" href="classFrequencySystem.php#afe5afccbde78bd2a93977fd5fcf3fa2f">00230</a> <span class="keywordtype">void</span> <a class="code" href="classFrequencySystem.php#afe5afccbde78bd2a93977fd5fcf3fa2f">FrequencySystem::set_frequencies_by_range</a> (<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> min_freq,
<a name="l00231"></a>00231                                                 <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> max_freq,
<a name="l00232"></a>00232                                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_freq,
<a name="l00233"></a>00233                                                 <span class="keyword">const</span> <span class="keywordtype">bool</span> allocate_solution_duplicates)
<a name="l00234"></a>00234 {
<a name="l00235"></a>00235   this-&gt;<a class="code" href="classFrequencySystem.php#a0f2cfab950cc9b564e7bb26bd9dd2c96">_keep_solution_duplicates</a> = allocate_solution_duplicates;
<a name="l00236"></a>00236 
<a name="l00237"></a>00237   <span class="comment">// sanity checks</span>
<a name="l00238"></a>00238   libmesh_assert(max_freq &gt; min_freq);
<a name="l00239"></a>00239   libmesh_assert(n_freq &gt; 0);
<a name="l00240"></a>00240 
<a name="l00241"></a>00241   <span class="keywordflow">if</span> (<a class="code" href="classFrequencySystem.php#acc57a5e69060359d5647517b18fe13d9">_finished_set_frequencies</a>)
<a name="l00242"></a>00242     {
<a name="l00243"></a>00243       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: frequencies already initialized. &quot;</span> &lt;&lt; std::endl;
<a name="l00244"></a>00244       libmesh_error();
<a name="l00245"></a>00245     }
<a name="l00246"></a>00246 
<a name="l00247"></a>00247   <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es =
<a name="l00248"></a>00248     this-&gt;<a class="code" href="classSystem.php#a51da3ea6211cf1888377c9c4b1554232">get_equation_systems</a>();
<a name="l00249"></a>00249 
<a name="l00250"></a>00250   <span class="comment">// store number of frequencies as parameter</span>
<a name="l00251"></a>00251   es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;n_frequencies&quot;</span>) = n_freq;
<a name="l00252"></a>00252 
<a name="l00253"></a>00253   <span class="comment">// set frequencies, build solution storage</span>
<a name="l00254"></a>00254   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;n_freq; n++)
<a name="l00255"></a>00255     {
<a name="l00256"></a>00256       <span class="comment">// remember frequencies as parameters</span>
<a name="l00257"></a>00257       es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(this-&gt;<a class="code" href="classFrequencySystem.php#ab211e0c9d38e2b249729c5c547809c47">form_freq_param_name</a>(n)) = 
<a name="l00258"></a>00258           min_freq + n*(max_freq-min_freq)/(n_freq-1);
<a name="l00259"></a>00259       
<a name="l00260"></a>00260       <span class="comment">// build storage for solution vector, if wanted</span>
<a name="l00261"></a>00261       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classFrequencySystem.php#a0f2cfab950cc9b564e7bb26bd9dd2c96">_keep_solution_duplicates</a>)
<a name="l00262"></a>00262           <a class="code" href="classSystem.php#abab8a3810cc43d99fe395d449207b786">System::add_vector</a>(this-&gt;<a class="code" href="classFrequencySystem.php#a92da8ef91f49f1b5b9ebfb1aa471bd59">form_solu_vec_name</a>(n));
<a name="l00263"></a>00263     }  
<a name="l00264"></a>00264 
<a name="l00265"></a>00265   <a class="code" href="classFrequencySystem.php#acc57a5e69060359d5647517b18fe13d9">_finished_set_frequencies</a> = <span class="keyword">true</span>;
<a name="l00266"></a>00266 
<a name="l00267"></a>00267   <span class="comment">// set the current frequency</span>
<a name="l00268"></a>00268   this-&gt;<a class="code" href="classFrequencySystem.php#a3cfdc4aaa52a24c7d85d6fe4f276203f">set_current_frequency</a>(0);
<a name="l00269"></a>00269 }
<a name="l00270"></a>00270 
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 
<a name="l00273"></a><a class="code" href="classFrequencySystem.php#a1f00416582262811fd20687caa89b59f">00273</a> <span class="keywordtype">void</span> <a class="code" href="classFrequencySystem.php#a1f00416582262811fd20687caa89b59f">FrequencySystem::set_frequencies</a> (<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; frequencies,
<a name="l00274"></a>00274                                        <span class="keyword">const</span> <span class="keywordtype">bool</span> allocate_solution_duplicates)
<a name="l00275"></a>00275 {
<a name="l00276"></a>00276   this-&gt;<a class="code" href="classFrequencySystem.php#a0f2cfab950cc9b564e7bb26bd9dd2c96">_keep_solution_duplicates</a> = allocate_solution_duplicates;
<a name="l00277"></a>00277 
<a name="l00278"></a>00278   <span class="comment">// sanity checks</span>
<a name="l00279"></a>00279   libmesh_assert(!frequencies.empty());
<a name="l00280"></a>00280 
<a name="l00281"></a>00281   <span class="keywordflow">if</span> (<a class="code" href="classFrequencySystem.php#acc57a5e69060359d5647517b18fe13d9">_finished_set_frequencies</a>)
<a name="l00282"></a>00282     {
<a name="l00283"></a>00283       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: frequencies already initialized. &quot;</span> &lt;&lt; std::endl;
<a name="l00284"></a>00284       libmesh_error();
<a name="l00285"></a>00285     }
<a name="l00286"></a>00286 
<a name="l00287"></a>00287   <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es =
<a name="l00288"></a>00288     this-&gt;<a class="code" href="classSystem.php#a51da3ea6211cf1888377c9c4b1554232">get_equation_systems</a>();
<a name="l00289"></a>00289 
<a name="l00290"></a>00290   <span class="comment">// store number of frequencies as parameter</span>
<a name="l00291"></a>00291   es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;n_frequencies&quot;</span>) = frequencies.size();
<a name="l00292"></a>00292 
<a name="l00293"></a>00293   <span class="comment">// set frequencies, build solution storage</span>
<a name="l00294"></a>00294   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;frequencies.size(); n++)
<a name="l00295"></a>00295     {
<a name="l00296"></a>00296       <span class="comment">// remember frequencies as parameters</span>
<a name="l00297"></a>00297       es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(this-&gt;<a class="code" href="classFrequencySystem.php#ab211e0c9d38e2b249729c5c547809c47">form_freq_param_name</a>(n)) = frequencies[n];
<a name="l00298"></a>00298       
<a name="l00299"></a>00299       <span class="comment">// build storage for solution vector, if wanted</span>
<a name="l00300"></a>00300       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classFrequencySystem.php#a0f2cfab950cc9b564e7bb26bd9dd2c96">_keep_solution_duplicates</a>)
<a name="l00301"></a>00301           <a class="code" href="classSystem.php#abab8a3810cc43d99fe395d449207b786">System::add_vector</a>(this-&gt;<a class="code" href="classFrequencySystem.php#a92da8ef91f49f1b5b9ebfb1aa471bd59">form_solu_vec_name</a>(n));
<a name="l00302"></a>00302     }  
<a name="l00303"></a>00303 
<a name="l00304"></a>00304   <a class="code" href="classFrequencySystem.php#acc57a5e69060359d5647517b18fe13d9">_finished_set_frequencies</a> = <span class="keyword">true</span>;
<a name="l00305"></a>00305 
<a name="l00306"></a>00306   <span class="comment">// set the current frequency</span>
<a name="l00307"></a>00307   this-&gt;<a class="code" href="classFrequencySystem.php#a3cfdc4aaa52a24c7d85d6fe4f276203f">set_current_frequency</a>(0);
<a name="l00308"></a>00308 }
<a name="l00309"></a>00309 
<a name="l00310"></a>00310 
<a name="l00311"></a>00311 
<a name="l00312"></a>00312 
<a name="l00313"></a><a class="code" href="classFrequencySystem.php#aa24a6c8f69e53b7a067de6cb211cd669">00313</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFrequencySystem.php#aa24a6c8f69e53b7a067de6cb211cd669">FrequencySystem::n_frequencies</a> ()<span class="keyword"> const</span>
<a name="l00314"></a>00314 <span class="keyword"></span>{
<a name="l00315"></a>00315   libmesh_assert(<a class="code" href="classFrequencySystem.php#acc57a5e69060359d5647517b18fe13d9">_finished_set_frequencies</a>);
<a name="l00316"></a>00316   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classSystem.php#a51da3ea6211cf1888377c9c4b1554232">get_equation_systems</a>().<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#ac4c5e3f411568e6defcdd2ace5829d96">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;n_frequencies&quot;</span>);
<a name="l00317"></a>00317 }
<a name="l00318"></a>00318 
<a name="l00319"></a>00319 
<a name="l00320"></a>00320 
<a name="l00321"></a><a class="code" href="classFrequencySystem.php#aabe75d58dfa3048671014cf10186e6dd">00321</a> <span class="keywordtype">void</span> <a class="code" href="classFrequencySystem.php#aabe75d58dfa3048671014cf10186e6dd">FrequencySystem::solve</a> ()
<a name="l00322"></a>00322 {
<a name="l00323"></a>00323   libmesh_assert (this-&gt;<a class="code" href="classFrequencySystem.php#aa24a6c8f69e53b7a067de6cb211cd669">n_frequencies</a>() &gt; 0);
<a name="l00324"></a>00324 
<a name="l00325"></a>00325   <span class="comment">// Solve for all the specified frequencies</span>
<a name="l00326"></a>00326   this-&gt;<a class="code" href="classFrequencySystem.php#aabe75d58dfa3048671014cf10186e6dd">solve</a> (0, this-&gt;<a class="code" href="classFrequencySystem.php#aa24a6c8f69e53b7a067de6cb211cd669">n_frequencies</a>()-1);
<a name="l00327"></a>00327 }
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 
<a name="l00331"></a><a class="code" href="classFrequencySystem.php#a620da4a481e043529582d173f48585e1">00331</a> <span class="keywordtype">void</span> <a class="code" href="classFrequencySystem.php#aabe75d58dfa3048671014cf10186e6dd">FrequencySystem::solve</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_start,
<a name="l00332"></a>00332                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_stop)
<a name="l00333"></a>00333 {
<a name="l00334"></a>00334   <span class="comment">// Assemble the linear system, if not already done</span>
<a name="l00335"></a>00335   <span class="keywordflow">if</span> (!<a class="code" href="classFrequencySystem.php#aec03801d68466271254c4f22dcf0e3f0">_finished_assemble</a>)
<a name="l00336"></a>00336     this-&gt;<a class="code" href="classFrequencySystem.php#a21b5cebd5c4bab7398ea96b3aae0b850">assemble</a> (); 
<a name="l00337"></a>00337 
<a name="l00338"></a>00338   <span class="comment">// the user-supplied solve method _has_ to be provided by the user</span>
<a name="l00339"></a>00339   libmesh_assert (<a class="code" href="classFrequencySystem.php#a02efd4c011829f07d96121b58ee8cd11">solve_system</a> != NULL);
<a name="l00340"></a>00340 
<a name="l00341"></a>00341   <span class="comment">// existence &amp; range checks</span>
<a name="l00342"></a>00342   libmesh_assert(this-&gt;<a class="code" href="classFrequencySystem.php#aa24a6c8f69e53b7a067de6cb211cd669">n_frequencies</a>() &gt; 0);
<a name="l00343"></a>00343   libmesh_assert(n_stop &lt; this-&gt;<a class="code" href="classFrequencySystem.php#aa24a6c8f69e53b7a067de6cb211cd669">n_frequencies</a>());
<a name="l00344"></a>00344 
<a name="l00345"></a>00345   <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es =
<a name="l00346"></a>00346     this-&gt;<a class="code" href="classSystem.php#a51da3ea6211cf1888377c9c4b1554232">get_equation_systems</a>();
<a name="l00347"></a>00347 
<a name="l00348"></a>00348   <span class="comment">// Get the user-specified linear solver tolerance,</span>
<a name="l00349"></a>00349   <span class="comment">//     the user-specified maximum # of linear solver iterations,</span>
<a name="l00350"></a>00350   <span class="comment">//     the user-specified wave speed</span>
<a name="l00351"></a>00351   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tol            =
<a name="l00352"></a>00352     es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#ac4c5e3f411568e6defcdd2ace5829d96">get</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;linear solver tolerance&quot;</span>);
<a name="l00353"></a>00353   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxits =
<a name="l00354"></a>00354     es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#ac4c5e3f411568e6defcdd2ace5829d96">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;linear solver maximum iterations&quot;</span>);
<a name="l00355"></a>00355 
<a name="l00356"></a>00356 
<a name="l00357"></a>00357 <span class="comment">//   // return values</span>
<a name="l00358"></a>00358 <span class="comment">//   std::vector&lt; std::pair&lt;unsigned int, Real&gt; &gt; vec_rval;</span>
<a name="l00359"></a>00359 
<a name="l00360"></a>00360   <span class="comment">// start solver loop</span>
<a name="l00361"></a>00361   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=n_start; n&lt;= n_stop; n++)
<a name="l00362"></a>00362     {
<a name="l00363"></a>00363       <span class="comment">// set the current frequency</span>
<a name="l00364"></a>00364       this-&gt;<a class="code" href="classFrequencySystem.php#a3cfdc4aaa52a24c7d85d6fe4f276203f">set_current_frequency</a>(n);
<a name="l00365"></a>00365 
<a name="l00366"></a>00366       <span class="comment">// Call the user-supplied pre-solve method</span>
<a name="l00367"></a>00367       START_LOG(<span class="stringliteral">&quot;user_pre_solve()&quot;</span>, <span class="stringliteral">&quot;FrequencySystem&quot;</span>);
<a name="l00368"></a>00368       
<a name="l00369"></a>00369       this-&gt;<a class="code" href="classFrequencySystem.php#a02efd4c011829f07d96121b58ee8cd11">solve_system</a> (es, this-&gt;<a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>());
<a name="l00370"></a>00370       
<a name="l00371"></a>00371       STOP_LOG(<span class="stringliteral">&quot;user_pre_solve()&quot;</span>, <span class="stringliteral">&quot;FrequencySystem&quot;</span>);
<a name="l00372"></a>00372 
<a name="l00373"></a>00373 
<a name="l00374"></a>00374       <span class="comment">// Solve the linear system for this specific frequency</span>
<a name="l00375"></a>00375       <span class="keyword">const</span> std::pair&lt;unsigned int, Real&gt; rval = 
<a name="l00376"></a>00376         <a class="code" href="classLinearImplicitSystem.php#a4f58b0fa3b6d450940b969e53ba19ac4">linear_solver</a>-&gt;solve (*<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>, *<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>, *<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>, tol, maxits);
<a name="l00377"></a>00377 
<a name="l00378"></a>00378       <a class="code" href="classLinearImplicitSystem.php#a3a97f7c1f657b5c7be86050531fdf9fc">_n_linear_iterations</a>   = rval.first;
<a name="l00379"></a>00379       <a class="code" href="classLinearImplicitSystem.php#ab345ee3343f71d8eccea0ba51791ad29">_final_linear_residual</a> = rval.second;
<a name="l00380"></a>00380 
<a name="l00381"></a>00381        <a class="code" href="classFrequencySystem.php#afc05423bf5356683b8509a84f4143f0f">vec_rval</a>.push_back(rval);      
<a name="l00382"></a>00382 
<a name="l00386"></a>00386       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classFrequencySystem.php#a0f2cfab950cc9b564e7bb26bd9dd2c96">_keep_solution_duplicates</a>)
<a name="l00387"></a>00387         this-&gt;<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(this-&gt;<a class="code" href="classFrequencySystem.php#a92da8ef91f49f1b5b9ebfb1aa471bd59">form_solu_vec_name</a>(n)) = *<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>;
<a name="l00388"></a>00388     }  
<a name="l00389"></a>00389 
<a name="l00390"></a>00390   <span class="comment">// sanity check</span>
<a name="l00391"></a>00391   <span class="comment">//libmesh_assert (vec_rval.size() == (n_stop-n_start+1));</span>
<a name="l00392"></a>00392 
<a name="l00393"></a>00393   <span class="comment">//return vec_rval; </span>
<a name="l00394"></a>00394 }
<a name="l00395"></a>00395 
<a name="l00396"></a>00396 
<a name="l00397"></a>00397 
<a name="l00398"></a><a class="code" href="classFrequencySystem.php#ae1c927a0f4ccfc3a651167fb544503b3">00398</a> <span class="keywordtype">void</span> <a class="code" href="classFrequencySystem.php#ae1c927a0f4ccfc3a651167fb544503b3">FrequencySystem::attach_solve_function</a>(<span class="keywordtype">void</span> fptr(<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00399"></a>00399                                                       <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>))
<a name="l00400"></a>00400 {
<a name="l00401"></a>00401   libmesh_assert (fptr != NULL);
<a name="l00402"></a>00402   
<a name="l00403"></a>00403   <a class="code" href="classFrequencySystem.php#a02efd4c011829f07d96121b58ee8cd11">solve_system</a> = fptr;
<a name="l00404"></a>00404 }
<a name="l00405"></a>00405 
<a name="l00406"></a>00406 
<a name="l00407"></a>00407 
<a name="l00408"></a><a class="code" href="classFrequencySystem.php#a3cfdc4aaa52a24c7d85d6fe4f276203f">00408</a> <span class="keywordtype">void</span> <a class="code" href="classFrequencySystem.php#a3cfdc4aaa52a24c7d85d6fe4f276203f">FrequencySystem::set_current_frequency</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00409"></a>00409 {
<a name="l00410"></a>00410   libmesh_assert(n &lt; <a class="code" href="classFrequencySystem.php#aa24a6c8f69e53b7a067de6cb211cd669">n_frequencies</a>());
<a name="l00411"></a>00411   
<a name="l00412"></a>00412   <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es =
<a name="l00413"></a>00413     this-&gt;<a class="code" href="classSystem.php#a51da3ea6211cf1888377c9c4b1554232">get_equation_systems</a>();
<a name="l00414"></a>00414 
<a name="l00415"></a>00415   es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;current frequency&quot;</span>) = 
<a name="l00416"></a>00416     es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#ac4c5e3f411568e6defcdd2ace5829d96">get</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(this-&gt;form_freq_param_name(n));
<a name="l00417"></a>00417 }
<a name="l00418"></a>00418 
<a name="l00419"></a>00419 
<a name="l00420"></a>00420 
<a name="l00421"></a><a class="code" href="classFrequencySystem.php#ab211e0c9d38e2b249729c5c547809c47">00421</a> std::string <a class="code" href="classFrequencySystem.php#ab211e0c9d38e2b249729c5c547809c47">FrequencySystem::form_freq_param_name</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00422"></a>00422 <span class="keyword"></span>{
<a name="l00423"></a>00423   libmesh_assert (n &lt; 9999);
<a name="l00424"></a>00424   <span class="keywordtype">char</span> buf[15];
<a name="l00425"></a>00425   sprintf(buf, <span class="stringliteral">&quot;frequency %04d&quot;</span>, n);
<a name="l00426"></a>00426   <span class="keywordflow">return</span> (buf);
<a name="l00427"></a>00427 }
<a name="l00428"></a>00428 
<a name="l00429"></a>00429 
<a name="l00430"></a>00430 
<a name="l00431"></a><a class="code" href="classFrequencySystem.php#a92da8ef91f49f1b5b9ebfb1aa471bd59">00431</a> std::string <a class="code" href="classFrequencySystem.php#a92da8ef91f49f1b5b9ebfb1aa471bd59">FrequencySystem::form_solu_vec_name</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00432"></a>00432 <span class="keyword"></span>{
<a name="l00433"></a>00433   libmesh_assert (n &lt; 9999);
<a name="l00434"></a>00434   <span class="keywordtype">char</span> buf[15];
<a name="l00435"></a>00435   sprintf(buf, <span class="stringliteral">&quot;solution %04d&quot;</span>, n);
<a name="l00436"></a>00436   <span class="keywordflow">return</span> (buf);
<a name="l00437"></a>00437 }
<a name="l00438"></a>00438 
<a name="l00439"></a>00439 
<a name="l00440"></a>00440 <span class="preprocessor">#endif // if defined(LIBMESH_USE_COMPLEX_NUMBERS)</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
