<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>frequency_system.h</h1>  </div>
</div>
<div class="contents">
<a href="frequency__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: frequency_system.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __frequency_system_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __frequency_system_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Frequency domain solutions only possible with complex arithmetic</span>
<a name="l00028"></a>00028 <span class="preprocessor">#if defined(LIBMESH_USE_COMPLEX_NUMBERS)</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="comment">// C++ includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Local Includes</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="linear__implicit__system_8h.php">linear_implicit_system.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00065"></a>00065 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00066"></a>00066 <span class="comment">// FrequencySystem class definition</span>
<a name="l00067"></a>00067 
<a name="l00068"></a><a class="code" href="classFrequencySystem.php">00068</a> <span class="keyword">class </span><a class="code" href="classFrequencySystem.php">FrequencySystem</a> : <span class="keyword">public</span> <a class="code" href="classLinearImplicitSystem.php">LinearImplicitSystem</a>
<a name="l00069"></a>00069 {
<a name="l00070"></a>00070 <span class="keyword">public</span>:
<a name="l00071"></a>00071 
<a name="l00076"></a>00076   <a class="code" href="classFrequencySystem.php#a3fe496f41529ee4668620621e40cec86">FrequencySystem</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00077"></a>00077                    <span class="keyword">const</span> std::string&amp; <a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>,
<a name="l00078"></a>00078                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">number</a>);
<a name="l00082"></a>00082   <a class="code" href="classFrequencySystem.php#a477384227e5a5a405f0460e92ac07059">~FrequencySystem</a> ();
<a name="l00083"></a>00083   
<a name="l00090"></a>00090   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFrequencySystem.php#adf2638d3093d9e49020a2f788f1a9706">clear</a> ();
<a name="l00091"></a>00091   
<a name="l00097"></a>00097   <span class="keywordtype">void</span> <a class="code" href="classFrequencySystem.php#a1c66f0f746e1427ccf51a2a417f4edfc">clear_all</a> ();
<a name="l00098"></a>00098 
<a name="l00103"></a>00103   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFrequencySystem.php#a21b5cebd5c4bab7398ea96b3aae0b850">assemble</a> ();
<a name="l00104"></a>00104 
<a name="l00108"></a>00108   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFrequencySystem.php#aabe75d58dfa3048671014cf10186e6dd">solve</a> ();
<a name="l00109"></a>00109   
<a name="l00118"></a>00118   <span class="keywordtype">void</span> <a class="code" href="classFrequencySystem.php#aabe75d58dfa3048671014cf10186e6dd">solve</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_start,
<a name="l00119"></a>00119               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_stop);
<a name="l00120"></a>00120   
<a name="l00125"></a><a class="code" href="classFrequencySystem.php#a98cbb93039261c27d43f2a27b9471edd">00125</a>   <span class="keyword">virtual</span> std::string <a class="code" href="classFrequencySystem.php#a98cbb93039261c27d43f2a27b9471edd">system_type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="stringliteral">&quot;Frequency&quot;</span>; }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128   <span class="comment">//--------------------------------------------------------</span>
<a name="l00129"></a>00129   <span class="comment">// Methods specific to the FrequencySystem</span>
<a name="l00130"></a>00130   <span class="comment">//</span>
<a name="l00131"></a>00131   
<a name="l00144"></a>00144   <span class="keywordtype">void</span> <a class="code" href="classFrequencySystem.php#a735f006a0dc97f9e29bd59ab00a707af">set_frequencies_by_steps</a> (<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> base_freq,
<a name="l00145"></a>00145                                  <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> freq_step=0.,
<a name="l00146"></a>00146                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_freq=1,
<a name="l00147"></a>00147                                  <span class="keyword">const</span> <span class="keywordtype">bool</span> allocate_solution_duplicates=<span class="keyword">true</span>);
<a name="l00148"></a>00148 
<a name="l00158"></a>00158   <span class="keywordtype">void</span> <a class="code" href="classFrequencySystem.php#afe5afccbde78bd2a93977fd5fcf3fa2f">set_frequencies_by_range</a> (<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> min_freq,
<a name="l00159"></a>00159                                  <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> max_freq,
<a name="l00160"></a>00160                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_freq,
<a name="l00161"></a>00161                                  <span class="keyword">const</span> <span class="keywordtype">bool</span> allocate_solution_duplicates=<span class="keyword">true</span>);
<a name="l00162"></a>00162 
<a name="l00170"></a>00170   <span class="keywordtype">void</span> <a class="code" href="classFrequencySystem.php#a1f00416582262811fd20687caa89b59f">set_frequencies</a> (<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; frequencies,
<a name="l00171"></a>00171                         <span class="keyword">const</span> <span class="keywordtype">bool</span> allocate_solution_duplicates=<span class="keyword">true</span>);
<a name="l00172"></a>00172 
<a name="l00176"></a>00176   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFrequencySystem.php#aa24a6c8f69e53b7a067de6cb211cd669">n_frequencies</a> () <span class="keyword">const</span>;
<a name="l00177"></a>00177   
<a name="l00184"></a>00184   <span class="keywordtype">void</span> <a class="code" href="classFrequencySystem.php#ae1c927a0f4ccfc3a651167fb544503b3">attach_solve_function</a>(<span class="keywordtype">void</span> fptr(<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00185"></a>00185                                        <span class="keyword">const</span> std::string&amp; name));
<a name="l00186"></a>00186   
<a name="l00190"></a><a class="code" href="classFrequencySystem.php#a02efd4c011829f07d96121b58ee8cd11">00190</a>   void (* <a class="code" href="classFrequencySystem.php#a02efd4c011829f07d96121b58ee8cd11">solve_system</a>) (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00191"></a>00191                          <span class="keyword">const</span> std::string&amp; <a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>);
<a name="l00192"></a>00192 
<a name="l00196"></a>00196   std::pair&lt;unsigned int, Real&gt; <a class="code" href="classFrequencySystem.php#ab88fed092daa635755241046f03fee10">get_rval</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span>;
<a name="l00197"></a>00197 
<a name="l00203"></a>00203   std::string <a class="code" href="classFrequencySystem.php#ab211e0c9d38e2b249729c5c547809c47">form_freq_param_name</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span>;
<a name="l00204"></a>00204 
<a name="l00210"></a>00210   std::string <a class="code" href="classFrequencySystem.php#a92da8ef91f49f1b5b9ebfb1aa471bd59">form_solu_vec_name</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span>;
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 <span class="keyword">protected</span>:
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 
<a name="l00222"></a>00222   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFrequencySystem.php#a099f393c71a21b80bf1c8629a5daeaad">init_data</a> ();
<a name="l00223"></a>00223   
<a name="l00228"></a>00228   <span class="keywordtype">void</span> <a class="code" href="classFrequencySystem.php#a3cfdc4aaa52a24c7d85d6fe4f276203f">set_current_frequency</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l00229"></a>00229 
<a name="l00235"></a><a class="code" href="classFrequencySystem.php#acc57a5e69060359d5647517b18fe13d9">00235</a>   <span class="keywordtype">bool</span> <a class="code" href="classFrequencySystem.php#acc57a5e69060359d5647517b18fe13d9">_finished_set_frequencies</a>;
<a name="l00236"></a>00236 
<a name="l00244"></a><a class="code" href="classFrequencySystem.php#a0f2cfab950cc9b564e7bb26bd9dd2c96">00244</a>   <span class="keywordtype">bool</span> <a class="code" href="classFrequencySystem.php#a0f2cfab950cc9b564e7bb26bd9dd2c96">_keep_solution_duplicates</a>;
<a name="l00245"></a>00245 
<a name="l00251"></a><a class="code" href="classFrequencySystem.php#a4e0686d352302a487efce7f5f4d53812">00251</a>   <span class="keywordtype">bool</span> <a class="code" href="classFrequencySystem.php#a4e0686d352302a487efce7f5f4d53812">_finished_init</a>;
<a name="l00252"></a>00252 
<a name="l00265"></a><a class="code" href="classFrequencySystem.php#aec03801d68466271254c4f22dcf0e3f0">00265</a>   <span class="keywordtype">bool</span> <a class="code" href="classFrequencySystem.php#aec03801d68466271254c4f22dcf0e3f0">_finished_assemble</a>;
<a name="l00266"></a>00266 
<a name="l00271"></a><a class="code" href="classFrequencySystem.php#afc05423bf5356683b8509a84f4143f0f">00271</a>   std::vector&lt;std::pair&lt;unsigned int, Real&gt; &gt; <a class="code" href="classFrequencySystem.php#afc05423bf5356683b8509a84f4143f0f">vec_rval</a>;
<a name="l00272"></a>00272 
<a name="l00273"></a>00273 };
<a name="l00274"></a>00274 
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00278"></a>00278 <span class="comment">// FrequencySystem inline methods</span>
<a name="l00279"></a>00279 <span class="keyword">inline</span>
<a name="l00280"></a><a class="code" href="classFrequencySystem.php#ab88fed092daa635755241046f03fee10">00280</a> std::pair&lt;unsigned int, Real&gt; <a class="code" href="classFrequencySystem.php#ab88fed092daa635755241046f03fee10">FrequencySystem::get_rval</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00281"></a>00281 <span class="keyword"></span>{
<a name="l00282"></a>00282   libmesh_assert (n &lt; <a class="code" href="classFrequencySystem.php#afc05423bf5356683b8509a84f4143f0f">vec_rval</a>.size());
<a name="l00283"></a>00283 
<a name="l00284"></a>00284   <span class="keywordflow">return</span> <a class="code" href="classFrequencySystem.php#afc05423bf5356683b8509a84f4143f0f">vec_rval</a>[n];
<a name="l00285"></a>00285 }
<a name="l00286"></a>00286 
<a name="l00287"></a>00287 
<a name="l00288"></a>00288 <span class="preprocessor">#endif // if defined(LIBMESH_USE_COMPLEX_NUMBERS)</span>
<a name="l00289"></a>00289 <span class="preprocessor"></span>
<a name="l00290"></a>00290 <span class="preprocessor">#endif // ifndef __frequency_system_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
