<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>function_base.h</h1>  </div>
</div>
<div class="contents">
<a href="function__base_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: function_base.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __function_base_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __function_base_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward Declarations</span>
<a name="l00035"></a>00035 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classDenseVector.php">DenseVector</a>;
<a name="l00036"></a>00036 <span class="keyword">class </span><a class="code" href="classFunctionBase.php">FunctionBase</a>;
<a name="l00037"></a>00037 <span class="keyword">class </span><a class="code" href="classPoint.php">Point</a>;
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00056"></a>00056 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00057"></a>00057 <span class="comment">// FunctionBase class definition</span>
<a name="l00058"></a><a class="code" href="classFunctionBase.php">00058</a> <span class="keyword">class </span><a class="code" href="classFunctionBase.php">FunctionBase</a> 
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060 <span class="keyword">protected</span>:
<a name="l00061"></a>00061 
<a name="l00065"></a>00065   <a class="code" href="classFunctionBase.php#a0c1e62c570a5e6efd2e991ca2236d1e7">FunctionBase</a> (<span class="keyword">const</span> <a class="code" href="classFunctionBase.php">FunctionBase</a>* master = NULL);
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 <span class="keyword">public</span>:
<a name="l00068"></a>00068 
<a name="l00072"></a>00072   <span class="keyword">virtual</span> <a class="code" href="classFunctionBase.php#a58707709836e981c8b846bd60b7f6cb1">~FunctionBase</a> ();
<a name="l00073"></a>00073 
<a name="l00077"></a>00077   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFunctionBase.php#ad476e03e6220a3ffb24324b4120b18d1">init</a> () = 0;
<a name="l00078"></a>00078 
<a name="l00082"></a>00082   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFunctionBase.php#ab0f12867e25bc6bf2f2a33aa97f6cee9">clear</a> () = 0;
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="comment">// ------------------------------------------------------</span>
<a name="l00086"></a>00086   <span class="comment">// misc</span>
<a name="l00093"></a>00093 <span class="comment"></span>  <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classFunctionBase.php#ade6c6bba55c1612e778e58f8b82bdda3">operator() </a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p, 
<a name="l00094"></a>00094                              <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> time = 0.) = 0;
<a name="l00095"></a>00095 
<a name="l00101"></a>00101   <span class="keywordtype">void</span> <a class="code" href="classFunctionBase.php#ade6c6bba55c1612e778e58f8b82bdda3">operator() </a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00102"></a>00102                    <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a>&amp; output);
<a name="l00103"></a>00103 
<a name="l00111"></a>00111   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classFunctionBase.php#ade6c6bba55c1612e778e58f8b82bdda3">operator() </a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00112"></a>00112                            <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> time,
<a name="l00113"></a>00113                            <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a>&amp; output) = 0;
<a name="l00114"></a>00114 
<a name="l00119"></a>00119   <span class="keywordtype">bool</span> <a class="code" href="classFunctionBase.php#a19afe60a9016248664396f20200a43cb">initialized</a> () <span class="keyword">const</span>;
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 <span class="keyword">protected</span>:
<a name="l00123"></a>00123 
<a name="l00130"></a><a class="code" href="classFunctionBase.php#a1ce94dacc6f531735410ff11045e3526">00130</a>   <span class="keyword">const</span> <a class="code" href="classFunctionBase.php">FunctionBase</a>* <a class="code" href="classFunctionBase.php#a1ce94dacc6f531735410ff11045e3526">_master</a>;
<a name="l00131"></a>00131 
<a name="l00136"></a><a class="code" href="classFunctionBase.php#ab72922e367786eca3b3497ea6710722c">00136</a>   <span class="keywordtype">bool</span> <a class="code" href="classFunctionBase.php#ab72922e367786eca3b3497ea6710722c">_initialized</a>;
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 };
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00142"></a>00142 <span class="comment">// FunctionBase inline methods</span>
<a name="l00143"></a>00143 <span class="keyword">inline</span>
<a name="l00144"></a><a class="code" href="classFunctionBase.php#a19afe60a9016248664396f20200a43cb">00144</a> <span class="keywordtype">bool</span> <a class="code" href="classFunctionBase.php#a19afe60a9016248664396f20200a43cb">FunctionBase::initialized</a>()<span class="keyword"> const</span>
<a name="l00145"></a>00145 <span class="keyword"></span>{
<a name="l00146"></a>00146   <span class="keywordflow">return</span> (this-&gt;<a class="code" href="classFunctionBase.php#ab72922e367786eca3b3497ea6710722c">_initialized</a>);
<a name="l00147"></a>00147 }
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 <span class="keyword">inline</span>
<a name="l00152"></a><a class="code" href="classFunctionBase.php#a40d20cd0bba91fe00fdb2bc21673ab50">00152</a> <span class="keywordtype">void</span> <a class="code" href="classFunctionBase.php#ade6c6bba55c1612e778e58f8b82bdda3">FunctionBase::operator() </a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00153"></a>00153                                <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a>&amp; output)
<a name="l00154"></a>00154 {
<a name="l00155"></a>00155   <span class="comment">// Call the time-dependent function with t=0.</span>
<a name="l00156"></a>00156   this-&gt;<a class="code" href="classFunctionBase.php#ade6c6bba55c1612e778e58f8b82bdda3">operator()</a>(p, 0., output);
<a name="l00157"></a>00157 }
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
