<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>gmsh_io.C</h1>  </div>
</div>
<div class="contents">
<a href="gmsh__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: gmsh_io.C 3461 2009-09-15 15:38:39Z knezed01 $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// This file was massively overhauled and extended by Martin Lthi, mluthi@tnoo.net</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;cstring&gt;</span> <span class="comment">// std::memcpy, std::strncmp</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;gmsh_io.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;boundary_info.h&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// anonymous namespace to hold local data</span>
<a name="l00036"></a>00036 <span class="keyword">namespace </span>
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038   
<a name="l00045"></a>00045   <span class="keyword">struct </span>boundaryElementInfo {
<a name="l00046"></a>00046     std::set&lt;unsigned int&gt; nodes;
<a name="l00047"></a>00047     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> id;
<a name="l00048"></a>00048   };
<a name="l00049"></a>00049 
<a name="l00053"></a>00053   <span class="keyword">struct </span>elementDefinition {
<a name="l00054"></a>00054     std::string label;
<a name="l00055"></a>00055     std::vector&lt;unsigned int&gt; nodes;
<a name="l00056"></a>00056     <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type;
<a name="l00057"></a>00057     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> exptype;
<a name="l00058"></a>00058     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim;
<a name="l00059"></a>00059     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nnodes;
<a name="l00060"></a>00060   };
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   <span class="comment">// maps from a libMesh element type to the proper</span>
<a name="l00064"></a>00064   <span class="comment">// Gmsh elementDefinition.  Placing the data structure</span>
<a name="l00065"></a>00065   <span class="comment">// here in this anonymous namespace gives us the</span>
<a name="l00066"></a>00066   <span class="comment">// benefits of a global variable without the nasty</span>
<a name="l00067"></a>00067   <span class="comment">// side-effects</span>
<a name="l00068"></a>00068   std::map&lt;ElemType, elementDefinition&gt; eletypes_exp;
<a name="l00069"></a>00069   std::map&lt;unsigned int, elementDefinition&gt; eletypes_imp;
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   <span class="comment">// ------------------------------------------------------------</span>
<a name="l00074"></a>00074   <span class="comment">// helper function to initialize the eletypes map</span>
<a name="l00075"></a>00075   <span class="keywordtype">void</span> init_eletypes ()
<a name="l00076"></a>00076   {
<a name="l00077"></a>00077     <span class="keywordflow">if</span> (eletypes_exp.empty() &amp;&amp; eletypes_imp.empty())
<a name="l00078"></a>00078       {
<a name="l00079"></a>00079         <span class="comment">// This should happen only once.  The first time this method</span>
<a name="l00080"></a>00080         <span class="comment">// is called the eletypes data struture will be empty, and</span>
<a name="l00081"></a>00081         <span class="comment">// we will fill it.  Any subsequent calls will find an initialized</span>
<a name="l00082"></a>00082         <span class="comment">// eletypes map and will do nothing.</span>
<a name="l00083"></a>00083 
<a name="l00084"></a>00084         <span class="comment">//==============================</span>
<a name="l00085"></a>00085         <span class="comment">// setup the element definitions</span>
<a name="l00086"></a>00086         elementDefinition eledef;
<a name="l00087"></a>00087 
<a name="l00088"></a>00088         <span class="comment">// use &quot;swap trick&quot; from Scott Meyer&#39;s &quot;Effective STL&quot; to initialize</span>
<a name="l00089"></a>00089         <span class="comment">// eledef.nodes vector</span>
<a name="l00090"></a>00090         
<a name="l00091"></a>00091         <span class="comment">// POINT (only Gmsh)</span>
<a name="l00092"></a>00092         {
<a name="l00093"></a>00093           eledef.exptype = 15;
<a name="l00094"></a>00094           eledef.dim     = 0;
<a name="l00095"></a>00095           eledef.nnodes  = 1;
<a name="l00096"></a>00096           eledef.nodes.clear();
<a name="l00097"></a>00097         
<a name="l00098"></a>00098           <span class="comment">// import only</span>
<a name="l00099"></a>00099           eletypes_imp[15] = eledef;
<a name="l00100"></a>00100         }
<a name="l00101"></a>00101 
<a name="l00102"></a>00102         <span class="comment">// EDGE2</span>
<a name="l00103"></a>00103         {
<a name="l00104"></a>00104           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>;
<a name="l00105"></a>00105           eledef.dim     = 1;
<a name="l00106"></a>00106           eledef.nnodes  = 2;
<a name="l00107"></a>00107           eledef.exptype = 1;
<a name="l00108"></a>00108           eledef.nodes.clear();
<a name="l00109"></a>00109         
<a name="l00110"></a>00110           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>] = eledef;
<a name="l00111"></a>00111           eletypes_imp[1]     = eledef;
<a name="l00112"></a>00112         }
<a name="l00113"></a>00113   
<a name="l00114"></a>00114         <span class="comment">// EDGE3</span>
<a name="l00115"></a>00115         {
<a name="l00116"></a>00116           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>;
<a name="l00117"></a>00117           eledef.dim     = 1;
<a name="l00118"></a>00118           eledef.nnodes  = 3;
<a name="l00119"></a>00119           eledef.exptype = 8;
<a name="l00120"></a>00120           eledef.nodes.clear();
<a name="l00121"></a>00121           
<a name="l00122"></a>00122           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>] = eledef;
<a name="l00123"></a>00123           eletypes_imp[8]     = eledef;
<a name="l00124"></a>00124         }
<a name="l00125"></a>00125       
<a name="l00126"></a>00126         <span class="comment">// TRI3</span>
<a name="l00127"></a>00127         {
<a name="l00128"></a>00128           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>;
<a name="l00129"></a>00129           eledef.dim     = 2;
<a name="l00130"></a>00130           eledef.nnodes  = 3;
<a name="l00131"></a>00131           eledef.exptype = 2;
<a name="l00132"></a>00132           eledef.nodes.clear();
<a name="l00133"></a>00133           
<a name="l00134"></a>00134           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>] = eledef;
<a name="l00135"></a>00135           eletypes_imp[2] = eledef;
<a name="l00136"></a>00136         }
<a name="l00137"></a>00137       
<a name="l00138"></a>00138         <span class="comment">// TRI6</span>
<a name="l00139"></a>00139         {
<a name="l00140"></a>00140           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>;
<a name="l00141"></a>00141           eledef.dim     = 2;
<a name="l00142"></a>00142           eledef.nnodes  = 6;
<a name="l00143"></a>00143           eledef.exptype = 9;
<a name="l00144"></a>00144           eledef.nodes.clear();
<a name="l00145"></a>00145 
<a name="l00146"></a>00146           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>] = eledef;
<a name="l00147"></a>00147           eletypes_imp[9]    = eledef;
<a name="l00148"></a>00148         }
<a name="l00149"></a>00149       
<a name="l00150"></a>00150         <span class="comment">// QUAD4</span>
<a name="l00151"></a>00151         {
<a name="l00152"></a>00152           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>;
<a name="l00153"></a>00153           eledef.dim     = 2;
<a name="l00154"></a>00154           eledef.nnodes  = 4;
<a name="l00155"></a>00155           eledef.exptype = 3;
<a name="l00156"></a>00156           eledef.nodes.clear();
<a name="l00157"></a>00157 
<a name="l00158"></a>00158           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>] = eledef;
<a name="l00159"></a>00159           eletypes_imp[3]     = eledef;
<a name="l00160"></a>00160         }
<a name="l00161"></a>00161       
<a name="l00162"></a>00162         <span class="comment">// QUAD8</span>
<a name="l00163"></a>00163         <span class="comment">// TODO: what should be done with this on writing?</span>
<a name="l00164"></a>00164         {
<a name="l00165"></a>00165           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>;
<a name="l00166"></a>00166           eledef.dim     = 2;
<a name="l00167"></a>00167           eledef.nnodes  = 8;
<a name="l00168"></a>00168           eledef.exptype = 100;
<a name="l00169"></a>00169           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nodes[] = {1,2,3,4,5,6,7,8};
<a name="l00170"></a>00170           std::vector&lt;unsigned int&gt;(nodes, nodes+eledef.nnodes).swap(eledef.nodes);
<a name="l00171"></a>00171 
<a name="l00172"></a>00172           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>] = eledef;
<a name="l00173"></a>00173           eletypes_imp[10]    = eledef;
<a name="l00174"></a>00174         }
<a name="l00175"></a>00175       
<a name="l00176"></a>00176         <span class="comment">// QUAD9</span>
<a name="l00177"></a>00177         {
<a name="l00178"></a>00178           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>;
<a name="l00179"></a>00179           eledef.dim     = 2;
<a name="l00180"></a>00180           eledef.nnodes  = 9;
<a name="l00181"></a>00181           eledef.exptype = 10;
<a name="l00182"></a>00182           eledef.nodes.clear();
<a name="l00183"></a>00183 
<a name="l00184"></a>00184           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>] = eledef;
<a name="l00185"></a>00185           eletypes_imp[10]    = eledef;
<a name="l00186"></a>00186         }
<a name="l00187"></a>00187       
<a name="l00188"></a>00188         <span class="comment">// HEX8</span>
<a name="l00189"></a>00189         {
<a name="l00190"></a>00190           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>;
<a name="l00191"></a>00191           eledef.dim     = 3;
<a name="l00192"></a>00192           eledef.nnodes  = 8;
<a name="l00193"></a>00193           eledef.exptype = 5;
<a name="l00194"></a>00194           eledef.nodes.clear();
<a name="l00195"></a>00195 
<a name="l00196"></a>00196           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>] = eledef;
<a name="l00197"></a>00197           eletypes_imp[5]    = eledef;
<a name="l00198"></a>00198         }
<a name="l00199"></a>00199       
<a name="l00200"></a>00200         <span class="comment">// HEX20</span>
<a name="l00201"></a>00201         <span class="comment">// TODO: what should be done with this on writing?</span>
<a name="l00202"></a>00202         {
<a name="l00203"></a>00203           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>;
<a name="l00204"></a>00204           eledef.dim     = 3;
<a name="l00205"></a>00205           eledef.nnodes  = 20;
<a name="l00206"></a>00206           eledef.exptype = 101;
<a name="l00207"></a>00207           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nodes[] = {1,2,3,4,5,6,7,8,9,10,11,16,17,18,19,12,13,14,15,16};
<a name="l00208"></a>00208           std::vector&lt;unsigned int&gt;(nodes, nodes+eledef.nnodes).swap(eledef.nodes);
<a name="l00209"></a>00209 
<a name="l00210"></a>00210           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>] = eledef;
<a name="l00211"></a>00211           eletypes_imp[12]    = eledef;
<a name="l00212"></a>00212         }
<a name="l00213"></a>00213       
<a name="l00214"></a>00214         <span class="comment">// HEX27</span>
<a name="l00215"></a>00215         {
<a name="l00216"></a>00216           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>;
<a name="l00217"></a>00217           eledef.dim     = 3;
<a name="l00218"></a>00218           eledef.nnodes  = 27;
<a name="l00219"></a>00219           eledef.exptype = 12;
<a name="l00220"></a>00220           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nodes[] = {0,1,2,3,4,5,6,7,8,11,12,9,13,10,14,
<a name="l00221"></a>00221                                         15,16,19,17,18,20,21,24,22,23,25,26};
<a name="l00222"></a>00222           std::vector&lt;unsigned int&gt;(nodes, nodes+eledef.nnodes).swap(eledef.nodes);
<a name="l00223"></a>00223 
<a name="l00224"></a>00224           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>] = eledef;
<a name="l00225"></a>00225           eletypes_imp[12]    = eledef;
<a name="l00226"></a>00226         }
<a name="l00227"></a>00227       
<a name="l00228"></a>00228         <span class="comment">// TET4</span>
<a name="l00229"></a>00229         {
<a name="l00230"></a>00230           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>;
<a name="l00231"></a>00231           eledef.dim     = 3;
<a name="l00232"></a>00232           eledef.nnodes  = 4;
<a name="l00233"></a>00233           eledef.exptype = 4;
<a name="l00234"></a>00234           eledef.nodes.clear();
<a name="l00235"></a>00235 
<a name="l00236"></a>00236           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>] = eledef;
<a name="l00237"></a>00237           eletypes_imp[4]    = eledef;
<a name="l00238"></a>00238         }
<a name="l00239"></a>00239       
<a name="l00240"></a>00240         <span class="comment">// TET10</span>
<a name="l00241"></a>00241         {
<a name="l00242"></a>00242           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>;
<a name="l00243"></a>00243           eledef.dim     = 3;
<a name="l00244"></a>00244           eledef.nnodes  = 10;
<a name="l00245"></a>00245           eledef.exptype = 11;
<a name="l00246"></a>00246           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nodes[] = {0,1,2,3,4,5,6,7,9,8};
<a name="l00247"></a>00247           std::vector&lt;unsigned int&gt;(nodes, nodes+eledef.nnodes).swap(eledef.nodes);
<a name="l00248"></a>00248           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>] = eledef;
<a name="l00249"></a>00249           eletypes_imp[11]    = eledef;
<a name="l00250"></a>00250         }
<a name="l00251"></a>00251       
<a name="l00252"></a>00252         <span class="comment">// PRISM6</span>
<a name="l00253"></a>00253         {
<a name="l00254"></a>00254           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>;
<a name="l00255"></a>00255           eledef.dim     = 3;
<a name="l00256"></a>00256           eledef.nnodes  = 6;
<a name="l00257"></a>00257           eledef.exptype = 6;
<a name="l00258"></a>00258           eledef.nodes.clear();
<a name="l00259"></a>00259           
<a name="l00260"></a>00260           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>] = eledef;
<a name="l00261"></a>00261           eletypes_imp[6]      = eledef;
<a name="l00262"></a>00262         }
<a name="l00263"></a>00263       
<a name="l00264"></a>00264         <span class="comment">// PRISM15</span>
<a name="l00265"></a>00265         <span class="comment">// TODO: what should be done with this on writing?</span>
<a name="l00266"></a>00266         {
<a name="l00267"></a>00267           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>;
<a name="l00268"></a>00268           eledef.dim     = 3;
<a name="l00269"></a>00269           eledef.nnodes  = 15;
<a name="l00270"></a>00270           eledef.exptype = 103;
<a name="l00271"></a>00271           eledef.nodes.clear();
<a name="l00272"></a>00272           
<a name="l00273"></a>00273           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>] = eledef;
<a name="l00274"></a>00274           eletypes_imp[13] = eledef;
<a name="l00275"></a>00275         }
<a name="l00276"></a>00276 
<a name="l00277"></a>00277         <span class="comment">// PRISM18</span>
<a name="l00278"></a>00278         {
<a name="l00279"></a>00279           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>;
<a name="l00280"></a>00280           eledef.dim     = 3;
<a name="l00281"></a>00281           eledef.nnodes  = 18;
<a name="l00282"></a>00282           eledef.exptype = 13;
<a name="l00283"></a>00283           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nodes[] = {0,1,2,3,4,5,6,8,9,7,10,11,
<a name="l00284"></a>00284                                         12,14,13,15,17,16};
<a name="l00285"></a>00285           std::vector&lt;unsigned int&gt;(nodes, nodes+eledef.nnodes).swap(eledef.nodes);
<a name="l00286"></a>00286 
<a name="l00287"></a>00287           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>] = eledef;
<a name="l00288"></a>00288           eletypes_imp[13]      = eledef;
<a name="l00289"></a>00289         }
<a name="l00290"></a>00290 
<a name="l00291"></a>00291         <span class="comment">// PYRAMID5</span>
<a name="l00292"></a>00292         {
<a name="l00293"></a>00293           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>;
<a name="l00294"></a>00294           eledef.dim     = 3;
<a name="l00295"></a>00295           eledef.nnodes  = 5;
<a name="l00296"></a>00296           eledef.exptype = 7;
<a name="l00297"></a>00297           eledef.nodes.clear();
<a name="l00298"></a>00298           
<a name="l00299"></a>00299           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>] = eledef;
<a name="l00300"></a>00300           eletypes_imp[7]        = eledef;
<a name="l00301"></a>00301         }
<a name="l00302"></a>00302 
<a name="l00303"></a>00303         <span class="comment">//==============================      </span>
<a name="l00304"></a>00304       }
<a name="l00305"></a>00305   }
<a name="l00306"></a>00306   
<a name="l00307"></a>00307 } <span class="comment">// end anonymous namespace</span>
<a name="l00308"></a>00308 
<a name="l00309"></a>00309 
<a name="l00310"></a>00310 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00311"></a>00311 <span class="comment">// GmshIO  members</span>
<a name="l00312"></a><a class="code" href="classGmshIO.php#ae650f0cd736ab71bbd2dc0459606676d">00312</a> <span class="keywordtype">void</span> <a class="code" href="classGmshIO.php#ae650f0cd736ab71bbd2dc0459606676d">GmshIO::read</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00313"></a>00313 {
<a name="l00314"></a>00314   std::ifstream in (name.c_str());
<a name="l00315"></a>00315   this-&gt;<a class="code" href="classGmshIO.php#a9a8478f7cec123a0bf824baccf94a540">read_mesh</a> (in);
<a name="l00316"></a>00316 }
<a name="l00317"></a>00317 
<a name="l00318"></a>00318 
<a name="l00319"></a><a class="code" href="classGmshIO.php#a9a8478f7cec123a0bf824baccf94a540">00319</a> <span class="keywordtype">void</span> <a class="code" href="classGmshIO.php#a9a8478f7cec123a0bf824baccf94a540">GmshIO::read_mesh</a>(std::istream&amp; in)
<a name="l00320"></a>00320 {
<a name="l00321"></a>00321   <span class="comment">// This is a serial-only process for now;</span>
<a name="l00322"></a>00322   <span class="comment">// the Mesh should be read on processor 0 and</span>
<a name="l00323"></a>00323   <span class="comment">// broadcast later</span>
<a name="l00324"></a>00324   libmesh_assert(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0);
<a name="l00325"></a>00325 
<a name="l00326"></a>00326   libmesh_assert(in.good());
<a name="l00327"></a>00327 
<a name="l00328"></a>00328   <span class="comment">// initialize the map with element types</span>
<a name="l00329"></a>00329   init_eletypes();
<a name="l00330"></a>00330 
<a name="l00331"></a>00331   <span class="comment">// clear any data in the mesh</span>
<a name="l00332"></a>00332   <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00333"></a>00333   mesh.<a class="code" href="classMeshBase.php#aefd56c4c29285d5e845f8869112b2b67">clear</a>();
<a name="l00334"></a>00334 
<a name="l00335"></a>00335   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = mesh.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>();
<a name="l00336"></a>00336 
<a name="l00337"></a>00337   <span class="comment">// some variables</span>
<a name="l00338"></a>00338   <span class="keyword">const</span> <span class="keywordtype">int</span>  bufLen = 256;
<a name="l00339"></a>00339   <span class="keywordtype">char</span>       buf[bufLen+1];
<a name="l00340"></a>00340   <span class="keywordtype">int</span>        format=0, size=0;
<a name="l00341"></a>00341   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>       version = 1.0;
<a name="l00342"></a>00342   
<a name="l00343"></a>00343   <span class="comment">// map to hold the node numbers for translation</span>
<a name="l00344"></a>00344   <span class="comment">// note the the nodes can be non-consecutive</span>
<a name="l00345"></a>00345   std::map&lt;unsigned int, unsigned int&gt; nodetrans;
<a name="l00346"></a>00346   
<a name="l00347"></a>00347   {
<a name="l00348"></a>00348     <span class="keywordflow">while</span> (!in.eof()) {
<a name="l00349"></a>00349       in &gt;&gt; buf;
<a name="l00350"></a>00350 
<a name="l00351"></a>00351       <span class="keywordflow">if</span> (!std::strncmp(buf,<span class="stringliteral">&quot;$MeshFormat&quot;</span>,11))
<a name="l00352"></a>00352         {
<a name="l00353"></a>00353           in &gt;&gt; version &gt;&gt; format &gt;&gt; size;
<a name="l00354"></a>00354           <span class="keywordflow">if</span>(version != 2.0){
<a name="l00355"></a>00355             std::cerr &lt;&lt; <span class="stringliteral">&quot;Error: Wrong msh file version &quot;</span> &lt;&lt; version &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00356"></a>00356             libmesh_error();
<a name="l00357"></a>00357           }
<a name="l00358"></a>00358           <span class="keywordflow">if</span>(format){
<a name="l00359"></a>00359             std::cerr &lt;&lt; <span class="stringliteral">&quot;Error: Unknown data format for mesh\n&quot;</span>;
<a name="l00360"></a>00360             libmesh_error();
<a name="l00361"></a>00361           }
<a name="l00362"></a>00362         }
<a name="l00363"></a>00363       
<a name="l00364"></a>00364       <span class="comment">// read the node block</span>
<a name="l00365"></a>00365       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (!std::strncmp(buf,<span class="stringliteral">&quot;$NOD&quot;</span>,4) ||
<a name="l00366"></a>00366                !std::strncmp(buf,<span class="stringliteral">&quot;$NOE&quot;</span>,4) ||
<a name="l00367"></a>00367                !std::strncmp(buf,<span class="stringliteral">&quot;$Nodes&quot;</span>,6) 
<a name="l00368"></a>00368                )
<a name="l00369"></a>00369         {
<a name="l00370"></a>00370           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> numNodes = 0;
<a name="l00371"></a>00371           in &gt;&gt; numNodes;
<a name="l00372"></a>00372           mesh.<a class="code" href="classMeshBase.php#a641a3da2df67396c48c9a9b2434b4d68">reserve_nodes</a> (numNodes);
<a name="l00373"></a>00373 
<a name="l00374"></a>00374           <span class="comment">// read in the nodal coordinates and form points.</span>
<a name="l00375"></a>00375           <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> x, y, z;
<a name="l00376"></a>00376           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> id;
<a name="l00377"></a>00377         
<a name="l00378"></a>00378           <span class="comment">// add the nodal coordinates to the mesh</span>
<a name="l00379"></a>00379           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;numNodes; ++i)      
<a name="l00380"></a>00380             {
<a name="l00381"></a>00381               in &gt;&gt; <span class="keywordtype">id</span> &gt;&gt; x &gt;&gt; y &gt;&gt; z;
<a name="l00382"></a>00382               mesh.<a class="code" href="classMeshBase.php#a01b66468d3e9d8b5db82c6f3d9131f5e">add_point</a> (<a class="code" href="classPoint.php">Point</a>(x, y, z), i);
<a name="l00383"></a>00383               nodetrans[id] = i;
<a name="l00384"></a>00384             }
<a name="l00385"></a>00385           <span class="comment">// read the $ENDNOD delimiter</span>
<a name="l00386"></a>00386           in &gt;&gt; buf;
<a name="l00387"></a>00387         }
<a name="l00388"></a>00388 
<a name="l00399"></a>00399       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (!std::strncmp(buf,<span class="stringliteral">&quot;$ELM&quot;</span>,4) ||
<a name="l00400"></a>00400                !std::strncmp(buf,<span class="stringliteral">&quot;$Elements&quot;</span>,9)
<a name="l00401"></a>00401                )
<a name="l00402"></a>00402         {
<a name="l00403"></a>00403           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> numElem = 0;
<a name="l00404"></a>00404           std::vector&lt; boundaryElementInfo &gt; boundary_elem;
<a name="l00405"></a>00405 
<a name="l00406"></a>00406           <span class="comment">// read how many elements are there, and reserve space in the mesh</span>
<a name="l00407"></a>00407           in &gt;&gt; numElem;
<a name="l00408"></a>00408           mesh.<a class="code" href="classMeshBase.php#ae034eb4ecaa04c32b89909d9eee85411">reserve_elem</a> (numElem);
<a name="l00409"></a>00409 
<a name="l00410"></a>00410           <span class="comment">// read the elements</span>
<a name="l00411"></a>00411           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_id_counter = 0;
<a name="l00412"></a>00412           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> iel=0; iel&lt;numElem; ++iel)      
<a name="l00413"></a>00413             {
<a name="l00414"></a>00414               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> id, type, physical, elementary,
<a name="l00415"></a>00415                 <span class="comment">/* partition = 1,*/</span> nnodes, ntags;
<a name="l00416"></a>00416               <span class="comment">// note - partition was assigned but never used - BSK</span>
<a name="l00417"></a>00417               <span class="keywordflow">if</span>(version &lt;= 1.0)
<a name="l00418"></a>00418                 {
<a name="l00419"></a>00419                   in &gt;&gt; <span class="keywordtype">id</span> &gt;&gt; type &gt;&gt; physical &gt;&gt; elementary &gt;&gt; nnodes;
<a name="l00420"></a>00420                 }
<a name="l00421"></a>00421               <span class="keywordflow">else</span>
<a name="l00422"></a>00422                 {
<a name="l00423"></a>00423                   in &gt;&gt; <span class="keywordtype">id</span> &gt;&gt; type &gt;&gt; ntags;
<a name="l00424"></a>00424                   elementary = physical = <span class="comment">/* partition = */</span> 1;
<a name="l00425"></a>00425                   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = 0; j &lt; ntags; j++)
<a name="l00426"></a>00426                     {
<a name="l00427"></a>00427                       <span class="keywordtype">int</span> tag;
<a name="l00428"></a>00428                       in &gt;&gt; tag;
<a name="l00429"></a>00429                       <span class="keywordflow">if</span>(j == 0)
<a name="l00430"></a>00430                         physical = tag;
<a name="l00431"></a>00431                       <span class="keywordflow">else</span> <span class="keywordflow">if</span>(j == 1)
<a name="l00432"></a>00432                         elementary = tag;
<a name="l00433"></a>00433                       <span class="comment">// else if(j == 2)</span>
<a name="l00434"></a>00434                       <span class="comment">//  partition = tag;</span>
<a name="l00435"></a>00435                       <span class="comment">// ignore any other tags for now</span>
<a name="l00436"></a>00436                     }
<a name="l00437"></a>00437                 }
<a name="l00438"></a>00438 
<a name="l00439"></a>00439               <span class="comment">// consult the import element table which element to build</span>
<a name="l00440"></a>00440               <span class="keyword">const</span> elementDefinition&amp; eletype = eletypes_imp[type];
<a name="l00441"></a>00441               nnodes = eletype.nnodes;
<a name="l00442"></a>00442 
<a name="l00443"></a>00443               <span class="comment">// only elements that match the mesh dimension are added</span>
<a name="l00444"></a>00444               <span class="comment">// if the element dimension is one less than dim, the nodes and</span>
<a name="l00445"></a>00445               <span class="comment">// sides are added to the mesh.boundary_info</span>
<a name="l00446"></a>00446               <span class="keywordflow">if</span> (eletype.dim == dim)
<a name="l00447"></a>00447                 {
<a name="l00448"></a>00448                   <span class="comment">// add the elements to the mesh</span>
<a name="l00449"></a>00449                   <a class="code" href="classElem.php">Elem</a>* elem = <a class="code" href="classElem.php#a7f46524fbd44a76f940435d6a1434a9d">Elem::build</a>(eletype.type).release();
<a name="l00450"></a>00450                   elem-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a>(elem_id_counter);
<a name="l00451"></a>00451                   mesh.<a class="code" href="classMeshBase.php#a0f6974cf3e413cfe9caa1fcb4ce8153e">add_elem</a>(elem);
<a name="l00452"></a>00452 
<a name="l00453"></a>00453                   <span class="comment">// different to iel, lower dimensional elems aren&#39;t added</span>
<a name="l00454"></a>00454                   elem_id_counter++;
<a name="l00455"></a>00455 
<a name="l00456"></a>00456                   <span class="comment">// check number of nodes. We cannot do that for version 2.0</span>
<a name="l00457"></a>00457                   <span class="keywordflow">if</span> (version &lt;= 1.0) 
<a name="l00458"></a>00458                     {
<a name="l00459"></a>00459                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>() != nnodes)
<a name="l00460"></a>00460                         {
<a name="l00461"></a>00461                           std::cerr &lt;&lt; <span class="stringliteral">&quot;Number of nodes for element &quot;</span> &lt;&lt; <span class="keywordtype">id</span>
<a name="l00462"></a>00462                                     &lt;&lt; <span class="stringliteral">&quot; of type &quot;</span> &lt;&lt; eletypes_imp[type].<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>
<a name="l00463"></a>00463                                     &lt;&lt; <span class="stringliteral">&quot; (Gmsh type &quot;</span> &lt;&lt; type  
<a name="l00464"></a>00464                                     &lt;&lt; <span class="stringliteral">&quot;) does not match Libmesh definition. &quot;</span>
<a name="l00465"></a>00465                                     &lt;&lt; <span class="stringliteral">&quot;I expected &quot;</span> &lt;&lt; elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>()
<a name="l00466"></a>00466                                     &lt;&lt; <span class="stringliteral">&quot; nodes, but got &quot;</span> &lt;&lt; nnodes &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00467"></a>00467                           libmesh_error();
<a name="l00468"></a>00468                         }
<a name="l00469"></a>00469                     }
<a name="l00470"></a>00470 
<a name="l00471"></a>00471                   <span class="comment">// add node pointers to the elements</span>
<a name="l00472"></a>00472                   <span class="keywordtype">int</span> nod = 0;
<a name="l00473"></a>00473                   <span class="comment">// if there is a node translation table, use it</span>
<a name="l00474"></a>00474                   <span class="keywordflow">if</span> (eletype.nodes.size() &gt; 0)
<a name="l00475"></a>00475                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nnodes; i++)
<a name="l00476"></a>00476                       {
<a name="l00477"></a>00477                         in &gt;&gt; nod;
<a name="l00478"></a>00478                         elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(eletype.nodes[i]) = mesh.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(nodetrans[nod]);
<a name="l00479"></a>00479                       }
<a name="l00480"></a>00480                   <span class="keywordflow">else</span>
<a name="l00481"></a>00481                     {
<a name="l00482"></a>00482                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nnodes; i++)
<a name="l00483"></a>00483                         {
<a name="l00484"></a>00484                           in &gt;&gt; nod;
<a name="l00485"></a>00485                           elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(i) = mesh.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(nodetrans[nod]);
<a name="l00486"></a>00486                         }
<a name="l00487"></a>00487                     }
<a name="l00488"></a>00488 
<a name="l00489"></a>00489                     <span class="comment">// Finally, set the subdomain ID to physical</span>
<a name="l00490"></a>00490                     elem-&gt;<a class="code" href="classElem.php#acc4746605aad9169ad38cfd0b9b97123">subdomain_id</a>() = physical;
<a name="l00491"></a>00491                 } <span class="comment">// if element.dim == dim</span>
<a name="l00492"></a>00492               <span class="comment">// if this is a boundary</span>
<a name="l00493"></a>00493               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (eletype.dim == dim-1)
<a name="l00494"></a>00494                 {
<a name="l00499"></a>00499                   boundaryElementInfo binfo;
<a name="l00500"></a>00500                   std::set&lt;unsigned int&gt;::iterator iter = binfo.nodes.begin();
<a name="l00501"></a>00501                   <span class="keywordtype">int</span> nod = 0;
<a name="l00502"></a>00502                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nnodes; i++)
<a name="l00503"></a>00503                     {
<a name="l00504"></a>00504                       in &gt;&gt; nod;
<a name="l00505"></a>00505                       mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;add_node(nodetrans[nod], physical);
<a name="l00506"></a>00506                       binfo.nodes.insert(iter, nodetrans[nod]);
<a name="l00507"></a>00507                     }
<a name="l00508"></a>00508                   binfo.id = physical;
<a name="l00509"></a>00509                   boundary_elem.push_back(binfo);
<a name="l00510"></a>00510                 }
<a name="l00515"></a>00515               <span class="keywordflow">else</span>
<a name="l00516"></a>00516                 {
<a name="l00517"></a>00517                   <span class="keywordtype">int</span> nod = 0;
<a name="l00518"></a>00518                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nnodes; i++)
<a name="l00519"></a>00519                     in &gt;&gt; nod;
<a name="l00520"></a>00520                 }
<a name="l00521"></a>00521             }<span class="comment">//element loop</span>
<a name="l00522"></a>00522           <span class="comment">// read the $ENDELM delimiter</span>
<a name="l00523"></a>00523           in &gt;&gt; buf;
<a name="l00524"></a>00524 
<a name="l00530"></a>00530           <span class="keywordflow">if</span> (boundary_elem.size() &gt; 0)
<a name="l00531"></a>00531             {
<a name="l00532"></a>00532               <span class="comment">// create a index of the boundary nodes to easily locate which</span>
<a name="l00533"></a>00533               <span class="comment">// element might have that boundary</span>
<a name="l00534"></a>00534               std::map&lt;unsigned int, std::vector&lt;unsigned int&gt; &gt; node_index;
<a name="l00535"></a>00535               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;boundary_elem.size(); i++)
<a name="l00536"></a>00536                 {
<a name="l00537"></a>00537                   boundaryElementInfo binfo = boundary_elem[i];
<a name="l00538"></a>00538                   std::set&lt;unsigned int&gt;::iterator iter = binfo.nodes.begin();
<a name="l00539"></a>00539                   <span class="keywordflow">for</span> (;iter!= binfo.nodes.end(); iter++)
<a name="l00540"></a>00540                     node_index[*iter].push_back(i);
<a name="l00541"></a>00541                 }
<a name="l00542"></a>00542               
<a name="l00543"></a>00543               <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00544"></a>00544               <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00545"></a>00545               
<a name="l00546"></a>00546               <span class="comment">// iterate over all elements and see which boundary element has</span>
<a name="l00547"></a>00547               <span class="comment">// the same set of nodes as on of the boundary elements previously read</span>
<a name="l00548"></a>00548               <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l00549"></a>00549                 {
<a name="l00550"></a>00550                   <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *it;
<a name="l00551"></a>00551                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>(); s++)
<a name="l00552"></a>00552                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s) == NULL)
<a name="l00553"></a>00553                       {
<a name="l00554"></a>00554                         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> side (elem-&gt;<a class="code" href="classElem.php#a554c146bcfb5537636bd77a157f21b85">build_side</a>(s));
<a name="l00555"></a>00555                         std::set&lt;unsigned int&gt; side_nodes;
<a name="l00556"></a>00556                         std::set&lt;unsigned int&gt;::iterator iter = side_nodes.begin();
<a name="l00557"></a>00557 
<a name="l00558"></a>00558                         <span class="comment">// make a set with all nodes from this side</span>
<a name="l00559"></a>00559                         <span class="comment">// this allows for easy comparison                        </span>
<a name="l00560"></a>00560                         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns=0; ns&lt;side-&gt;n_nodes(); ns++)
<a name="l00561"></a>00561                           side_nodes.insert(iter, side-&gt;node(ns)); 
<a name="l00562"></a>00562 
<a name="l00563"></a>00563                         <span class="comment">// See whether one of the side node occurs in the list</span>
<a name="l00564"></a>00564                         <span class="comment">// of tagged nodes. If we would loop over all side</span>
<a name="l00565"></a>00565                         <span class="comment">// nodes, we would just get multiple hits, so taking</span>
<a name="l00566"></a>00566                         <span class="comment">// node 0 is enough to do the job</span>
<a name="l00567"></a>00567                         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sn = side-&gt;node(0);
<a name="l00568"></a>00568                         <span class="keywordflow">if</span> (node_index.count(sn) &gt; 0)
<a name="l00569"></a>00569                           {
<a name="l00570"></a>00570                             <span class="comment">// Loop over all tagged (&quot;physical&quot;) &quot;sides&quot; which</span>
<a name="l00571"></a>00571                             <span class="comment">// contain the node sn (typically just 1 to</span>
<a name="l00572"></a>00572                             <span class="comment">// three). For each of these the set of nodes is</span>
<a name="l00573"></a>00573                             <span class="comment">// compared to the current element&#39;s side nodes</span>
<a name="l00574"></a>00574                             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;node_index[sn].size(); n++)
<a name="l00575"></a>00575                               {
<a name="l00576"></a>00576                                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bidx = node_index[sn][n];
<a name="l00577"></a>00577                                 <span class="keywordflow">if</span> (boundary_elem[bidx].nodes == side_nodes)
<a name="l00578"></a>00578                                   mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;add_side(elem, s, boundary_elem[bidx].<span class="keywordtype">id</span>);
<a name="l00579"></a>00579                               }
<a name="l00580"></a>00580                           }
<a name="l00581"></a>00581                       } <span class="comment">// if elem-&gt;neighbor(s) == NULL</span>
<a name="l00582"></a>00582                 } <span class="comment">// element loop</span>
<a name="l00583"></a>00583             } <span class="comment">// if boundary_elem.size() &gt; 0</span>
<a name="l00584"></a>00584         } <span class="comment">// if $ELM</span>
<a name="l00585"></a>00585 
<a name="l00586"></a>00586     } <span class="comment">// while !in.eof()</span>
<a name="l00587"></a>00587 
<a name="l00588"></a>00588   }
<a name="l00589"></a>00589 
<a name="l00590"></a>00590 }
<a name="l00591"></a>00591 
<a name="l00592"></a>00592 
<a name="l00593"></a>00593 
<a name="l00594"></a><a class="code" href="classGmshIO.php#adc25c81852d64962f3e4eac2353534c9">00594</a> <span class="keywordtype">void</span> <a class="code" href="classGmshIO.php#adc25c81852d64962f3e4eac2353534c9">GmshIO::write</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00595"></a>00595 {
<a name="l00596"></a>00596   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00597"></a>00597     {
<a name="l00598"></a>00598       <span class="comment">// Open the output file stream</span>
<a name="l00599"></a>00599       std::ofstream out (name.c_str());
<a name="l00600"></a>00600 
<a name="l00601"></a>00601       <span class="comment">// Make sure it opened correctly</span>
<a name="l00602"></a>00602       <span class="keywordflow">if</span> (!out.good())
<a name="l00603"></a>00603         libmesh_file_error(name.c_str());
<a name="l00604"></a>00604 
<a name="l00605"></a>00605       this-&gt;<a class="code" href="classGmshIO.php#a4f098ed5adbfdec6c1b6646b7e136086">write_mesh</a> (out);
<a name="l00606"></a>00606     }
<a name="l00607"></a>00607 }
<a name="l00608"></a>00608 
<a name="l00609"></a>00609 
<a name="l00610"></a><a class="code" href="classGmshIO.php#a316b217296ecdbd9fc99054c89c59cdd">00610</a> <span class="keywordtype">void</span> <a class="code" href="classGmshIO.php#a316b217296ecdbd9fc99054c89c59cdd">GmshIO::write_nodal_data</a> (<span class="keyword">const</span> std::string&amp; fname,
<a name="l00611"></a>00611                                <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; soln,
<a name="l00612"></a>00612                                <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; names)
<a name="l00613"></a>00613 {
<a name="l00614"></a>00614   <span class="comment">//this-&gt;_binary = true;</span>
<a name="l00615"></a>00615   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00616"></a>00616     this-&gt;<a class="code" href="classGmshIO.php#a916f129df2fa2b0e1b9e43ab21365ab5">write_post</a>  (fname, &amp;soln, &amp;names);
<a name="l00617"></a>00617 }
<a name="l00618"></a>00618 
<a name="l00619"></a>00619 
<a name="l00620"></a><a class="code" href="classGmshIO.php#a4f098ed5adbfdec6c1b6646b7e136086">00620</a> <span class="keywordtype">void</span> <a class="code" href="classGmshIO.php#a4f098ed5adbfdec6c1b6646b7e136086">GmshIO::write_mesh</a> (std::ostream&amp; out)
<a name="l00621"></a>00621 {
<a name="l00622"></a>00622   <span class="comment">// Be sure that the stream is valid.</span>
<a name="l00623"></a>00623   libmesh_assert (out.good());
<a name="l00624"></a>00624   
<a name="l00625"></a>00625   <span class="comment">// initialize the map with element types</span>
<a name="l00626"></a>00626   init_eletypes();
<a name="l00627"></a>00627 
<a name="l00628"></a>00628   <span class="comment">// Get a const reference to the mesh</span>
<a name="l00629"></a>00629   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00630"></a>00630   
<a name="l00631"></a>00631   <span class="comment">// Note: we are using version 2.0 of the gmsh output format.</span>
<a name="l00632"></a>00632   
<a name="l00633"></a>00633   {
<a name="l00634"></a>00634     <span class="comment">// Write the file header.</span>
<a name="l00635"></a>00635     out &lt;&lt; <span class="stringliteral">&quot;$MeshFormat\n&quot;</span>;
<a name="l00636"></a>00636     out &lt;&lt; <span class="stringliteral">&quot;2.0 0 &quot;</span> &lt;&lt; <span class="keyword">sizeof</span>(<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>) &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00637"></a>00637     out &lt;&lt; <span class="stringliteral">&quot;$EndMeshFormat\n&quot;</span>;
<a name="l00638"></a>00638   }
<a name="l00639"></a>00639 
<a name="l00640"></a>00640   {
<a name="l00641"></a>00641     <span class="comment">// write the nodes in (n x y z) format</span>
<a name="l00642"></a>00642     out &lt;&lt; <span class="stringliteral">&quot;$Nodes\n&quot;</span>;
<a name="l00643"></a>00643     out &lt;&lt; mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>() &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00644"></a>00644     
<a name="l00645"></a>00645     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>(); v++)
<a name="l00646"></a>00646       out &lt;&lt; mesh.<a class="code" href="classMeshBase.php#a298477f2d67d6a85f6c7fb5a640e2b64">node</a>(v).<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00647"></a>00647           &lt;&lt; mesh.<a class="code" href="classMeshBase.php#a298477f2d67d6a85f6c7fb5a640e2b64">node</a>(v)(0) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00648"></a>00648           &lt;&lt; mesh.<a class="code" href="classMeshBase.php#a298477f2d67d6a85f6c7fb5a640e2b64">node</a>(v)(1) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00649"></a>00649           &lt;&lt; mesh.<a class="code" href="classMeshBase.php#a298477f2d67d6a85f6c7fb5a640e2b64">node</a>(v)(2) &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00650"></a>00650     out &lt;&lt; <span class="stringliteral">&quot;$EndNodes\n&quot;</span>;
<a name="l00651"></a>00651   }
<a name="l00652"></a>00652   
<a name="l00653"></a>00653   {
<a name="l00654"></a>00654     <span class="comment">// write the connectivity</span>
<a name="l00655"></a>00655     out &lt;&lt; <span class="stringliteral">&quot;$Elements\n&quot;</span>;
<a name="l00656"></a>00656     out &lt;&lt; mesh.<a class="code" href="classMeshBase.php#a246697678d5d14a986cee2b6fbdbae6b">n_active_elem</a>() &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00657"></a>00657 
<a name="l00658"></a>00658     <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00659"></a>00659     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00660"></a>00660     
<a name="l00661"></a>00661     <span class="comment">// loop over the elements</span>
<a name="l00662"></a>00662     <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l00663"></a>00663       {
<a name="l00664"></a>00664         <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *it;
<a name="l00665"></a>00665 
<a name="l00666"></a>00666         <span class="comment">// Make sure we have a valid entry for</span>
<a name="l00667"></a>00667         <span class="comment">// the current element type.</span>
<a name="l00668"></a>00668         libmesh_assert (eletypes_exp.count(elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>()));
<a name="l00669"></a>00669 
<a name="l00670"></a>00670         <span class="comment">// consult the export element table </span>
<a name="l00671"></a>00671         <span class="keyword">const</span> elementDefinition&amp; eletype = eletypes_exp[elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>()];
<a name="l00672"></a>00672 
<a name="l00673"></a>00673         <span class="comment">// The element mapper better not require any more nodes</span>
<a name="l00674"></a>00674         <span class="comment">// than are present in the current element!</span>
<a name="l00675"></a>00675         libmesh_assert (eletype.nodes.size() &lt;= elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>());
<a name="l00676"></a>00676         
<a name="l00677"></a>00677         <span class="comment">// elements ids are 1 based in Gmsh</span>
<a name="l00678"></a>00678         out &lt;&lt; elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00679"></a>00679 
<a name="l00680"></a>00680         <span class="comment">// element type</span>
<a name="l00681"></a>00681         out &lt;&lt; eletype.exptype;
<a name="l00682"></a>00682 
<a name="l00683"></a>00683         <span class="comment">// write the number of tags and</span>
<a name="l00684"></a>00684         <span class="comment">// tag1 (physical entity), and tag2 (geometric entity)</span>
<a name="l00685"></a>00685         out &lt;&lt; <span class="stringliteral">&quot; 3 1 1 &quot;</span>;
<a name="l00686"></a>00686 
<a name="l00687"></a>00687         <span class="comment">// write the partition the element belongs to</span>
<a name="l00688"></a>00688         out &lt;&lt; elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>()+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00689"></a>00689 
<a name="l00690"></a>00690         <span class="comment">// if there is a node translation table, use it</span>
<a name="l00691"></a>00691         <span class="keywordflow">if</span> (eletype.nodes.size() &gt; 0)
<a name="l00692"></a>00692           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i &lt; elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); i++)
<a name="l00693"></a>00693             out &lt;&lt; elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(eletype.nodes[i])+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>; <span class="comment">// gmsh is 1-based </span>
<a name="l00694"></a>00694         <span class="comment">// otherwise keep the same node order</span>
<a name="l00695"></a>00695         <span class="keywordflow">else</span>
<a name="l00696"></a>00696           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i &lt; elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); i++)
<a name="l00697"></a>00697             out &lt;&lt; elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(i)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;                  <span class="comment">// gmsh is 1-based </span>
<a name="l00698"></a>00698         out &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00699"></a>00699       } <span class="comment">// element loop</span>
<a name="l00700"></a>00700     out &lt;&lt; <span class="stringliteral">&quot;$EndElements\n&quot;</span>;
<a name="l00701"></a>00701   }
<a name="l00702"></a>00702 }
<a name="l00703"></a>00703 
<a name="l00704"></a>00704 
<a name="l00705"></a><a class="code" href="classGmshIO.php#a916f129df2fa2b0e1b9e43ab21365ab5">00705</a> <span class="keywordtype">void</span> <a class="code" href="classGmshIO.php#a916f129df2fa2b0e1b9e43ab21365ab5">GmshIO::write_post</a> (<span class="keyword">const</span> std::string&amp; fname,
<a name="l00706"></a>00706                          <span class="keyword">const</span> std::vector&lt;Number&gt;* v,
<a name="l00707"></a>00707                          <span class="keyword">const</span> std::vector&lt;std::string&gt;* solution_names)
<a name="l00708"></a>00708 {
<a name="l00709"></a>00709 
<a name="l00710"></a>00710   <span class="comment">// Should only do this on processor 0!</span>
<a name="l00711"></a>00711   libmesh_assert (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0);
<a name="l00712"></a>00712   
<a name="l00713"></a>00713   <span class="comment">// Create an output stream</span>
<a name="l00714"></a>00714   std::ofstream out(fname.c_str());
<a name="l00715"></a>00715 
<a name="l00716"></a>00716   <span class="comment">// Make sure it opened correctly</span>
<a name="l00717"></a>00717   <span class="keywordflow">if</span> (!out.good())
<a name="l00718"></a>00718     libmesh_file_error(fname.c_str());
<a name="l00719"></a>00719 
<a name="l00720"></a>00720   <span class="comment">// initialize the map with element types</span>
<a name="l00721"></a>00721   init_eletypes();
<a name="l00722"></a>00722 
<a name="l00723"></a>00723   <span class="comment">// create a character buffer</span>
<a name="l00724"></a>00724   <span class="keywordtype">char</span> buf[80];
<a name="l00725"></a>00725 
<a name="l00726"></a>00726   <span class="comment">// Get a constant reference to the mesh.</span>
<a name="l00727"></a>00727   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00728"></a>00728 
<a name="l00729"></a>00729   <span class="comment">//  write the data</span>
<a name="l00730"></a>00730   <span class="keywordflow">if</span> ((solution_names != NULL) &amp;&amp; (v != NULL))
<a name="l00731"></a>00731     {      
<a name="l00732"></a>00732       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_vars = solution_names-&gt;size();
<a name="l00733"></a>00733     
<a name="l00734"></a>00734       <span class="keywordflow">if</span> (!(v-&gt;size() == mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>()*n_vars))
<a name="l00735"></a>00735         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: v-&gt;size()=&quot;</span> &lt;&lt; v-&gt;size()
<a name="l00736"></a>00736                   &lt;&lt; <span class="stringliteral">&quot;, mesh.n_nodes()=&quot;</span> &lt;&lt; mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>()
<a name="l00737"></a>00737                   &lt;&lt; <span class="stringliteral">&quot;, n_vars=&quot;</span> &lt;&lt; n_vars
<a name="l00738"></a>00738                   &lt;&lt; <span class="stringliteral">&quot;, mesh.n_nodes()*n_vars=&quot;</span> &lt;&lt; mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>()*n_vars
<a name="l00739"></a>00739                   &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00740"></a>00740       
<a name="l00741"></a>00741       libmesh_assert (v-&gt;size() == mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>()*n_vars);
<a name="l00742"></a>00742 
<a name="l00743"></a>00743       <span class="comment">// write the header</span>
<a name="l00744"></a>00744       out &lt;&lt; <span class="stringliteral">&quot;$PostFormat\n&quot;</span>;
<a name="l00745"></a>00745       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classGmshIO.php#a990e01befc0da4bc958861b04ae55d22">binary</a>())
<a name="l00746"></a>00746         out &lt;&lt; <span class="stringliteral">&quot;1.2 1 &quot;</span> &lt;&lt; <span class="keyword">sizeof</span>(<span class="keywordtype">double</span>) &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00747"></a>00747       <span class="keywordflow">else</span>
<a name="l00748"></a>00748         out &lt;&lt; <span class="stringliteral">&quot;1.2 0 &quot;</span> &lt;&lt; <span class="keyword">sizeof</span>(double) &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00749"></a>00749       out &lt;&lt; <span class="stringliteral">&quot;$EndPostFormat\n&quot;</span>;
<a name="l00750"></a>00750 
<a name="l00751"></a>00751       <span class="comment">// Loop over the elements to see how much of each type there are</span>
<a name="l00752"></a>00752       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_points=0, n_lines=0, n_triangles=0, n_quadrangles=0,
<a name="l00753"></a>00753         n_tetrahedra=0, n_hexahedra=0, n_prisms=0, n_pyramids=0;
<a name="l00754"></a>00754       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_scalar=0, n_vector=0, n_tensor=0;
<a name="l00755"></a>00755       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nb_text2d=0, nb_text2d_chars=0, nb_text3d=0, nb_text3d_chars=0;
<a name="l00756"></a>00756 
<a name="l00757"></a>00757       {
<a name="l00758"></a>00758         <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00759"></a>00759         <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00760"></a>00760 
<a name="l00761"></a>00761 
<a name="l00762"></a>00762         <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l00763"></a>00763           {
<a name="l00764"></a>00764             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> elemtype = (*it)-&gt;type();
<a name="l00765"></a>00765             
<a name="l00766"></a>00766             <span class="keywordflow">switch</span> (elemtype)
<a name="l00767"></a>00767               {
<a name="l00768"></a>00768               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00769"></a>00769               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00770"></a>00770               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l00771"></a>00771                 {
<a name="l00772"></a>00772                   n_lines += 1;
<a name="l00773"></a>00773                   <span class="keywordflow">break</span>;
<a name="l00774"></a>00774                 }
<a name="l00775"></a>00775               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00776"></a>00776               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00777"></a>00777                 {
<a name="l00778"></a>00778                   n_triangles += 1;
<a name="l00779"></a>00779                   <span class="keywordflow">break</span>;
<a name="l00780"></a>00780                 }
<a name="l00781"></a>00781               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l00782"></a>00782               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00783"></a>00783               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00784"></a>00784                 {
<a name="l00785"></a>00785                   n_quadrangles += 1;
<a name="l00786"></a>00786                   <span class="keywordflow">break</span>;
<a name="l00787"></a>00787                 }
<a name="l00788"></a>00788               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l00789"></a>00789               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l00790"></a>00790                 {
<a name="l00791"></a>00791                   n_tetrahedra += 1;
<a name="l00792"></a>00792                   <span class="keywordflow">break</span>;
<a name="l00793"></a>00793                 }
<a name="l00794"></a>00794               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00795"></a>00795               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00796"></a>00796               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00797"></a>00797                 {
<a name="l00798"></a>00798                   n_hexahedra += 1;
<a name="l00799"></a>00799                   <span class="keywordflow">break</span>;
<a name="l00800"></a>00800                 }
<a name="l00801"></a>00801               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l00802"></a>00802               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l00803"></a>00803               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l00804"></a>00804                 {
<a name="l00805"></a>00805                   n_prisms += 1;
<a name="l00806"></a>00806                   <span class="keywordflow">break</span>;
<a name="l00807"></a>00807                 }
<a name="l00808"></a>00808               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l00809"></a>00809                 {
<a name="l00810"></a>00810                   n_pyramids += 1;
<a name="l00811"></a>00811                   <span class="keywordflow">break</span>;
<a name="l00812"></a>00812                 }
<a name="l00813"></a>00813               <span class="keywordflow">default</span>:
<a name="l00814"></a>00814                 {
<a name="l00815"></a>00815                   std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Not existant element type &quot;</span>
<a name="l00816"></a>00816                             &lt;&lt; (*it)-&gt;type() &lt;&lt; std::endl;
<a name="l00817"></a>00817                   libmesh_error();
<a name="l00818"></a>00818                 }
<a name="l00819"></a>00819               }
<a name="l00820"></a>00820           }
<a name="l00821"></a>00821       }
<a name="l00822"></a>00822 
<a name="l00823"></a>00823       <span class="comment">// create a view for each variable</span>
<a name="l00824"></a>00824       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ivar=0; ivar &lt; n_vars; ivar++)
<a name="l00825"></a>00825         {
<a name="l00826"></a>00826           std::string varname = (*solution_names)[ivar];
<a name="l00827"></a>00827 
<a name="l00828"></a>00828           <span class="comment">// at the moment, we just write out scalar quantities</span>
<a name="l00829"></a>00829           <span class="comment">// later this should be made configurable through</span>
<a name="l00830"></a>00830           <span class="comment">// options to the writer class</span>
<a name="l00831"></a>00831           n_scalar = 1;
<a name="l00832"></a>00832       
<a name="l00833"></a>00833           <span class="comment">// write the variable as a view, and the number of time steps</span>
<a name="l00834"></a>00834           out &lt;&lt; <span class="stringliteral">&quot;$View\n&quot;</span> &lt;&lt; varname &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; 1 &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00835"></a>00835       
<a name="l00836"></a>00836           <span class="comment">// write how many of each geometry type are written</span>
<a name="l00837"></a>00837           out &lt;&lt; n_points * n_scalar &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00838"></a>00838               &lt;&lt; n_points * n_vector &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00839"></a>00839               &lt;&lt; n_points * n_tensor &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00840"></a>00840               &lt;&lt; n_lines * n_scalar &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00841"></a>00841               &lt;&lt; n_lines * n_vector &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00842"></a>00842               &lt;&lt; n_lines * n_tensor &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00843"></a>00843               &lt;&lt; n_triangles * n_scalar &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00844"></a>00844               &lt;&lt; n_triangles * n_vector &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00845"></a>00845               &lt;&lt; n_triangles * n_tensor &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00846"></a>00846               &lt;&lt; n_quadrangles * n_scalar &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00847"></a>00847               &lt;&lt; n_quadrangles * n_vector &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00848"></a>00848               &lt;&lt; n_quadrangles * n_tensor &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00849"></a>00849               &lt;&lt; n_tetrahedra * n_scalar &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00850"></a>00850               &lt;&lt; n_tetrahedra * n_vector &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00851"></a>00851               &lt;&lt; n_tetrahedra * n_tensor &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00852"></a>00852               &lt;&lt; n_hexahedra * n_scalar &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00853"></a>00853               &lt;&lt; n_hexahedra * n_vector &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00854"></a>00854               &lt;&lt; n_hexahedra * n_tensor &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00855"></a>00855               &lt;&lt; n_prisms * n_scalar &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00856"></a>00856               &lt;&lt; n_prisms * n_vector &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00857"></a>00857               &lt;&lt; n_prisms * n_tensor &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00858"></a>00858               &lt;&lt; n_pyramids * n_scalar &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00859"></a>00859               &lt;&lt; n_pyramids * n_vector &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00860"></a>00860               &lt;&lt; n_pyramids * n_tensor &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00861"></a>00861               &lt;&lt; nb_text2d &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00862"></a>00862               &lt;&lt; nb_text2d_chars &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00863"></a>00863               &lt;&lt; nb_text3d &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00864"></a>00864               &lt;&lt; nb_text3d_chars &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00865"></a>00865       
<a name="l00866"></a>00866           <span class="comment">// if binary, write a marker to identify the endianness of the file</span>
<a name="l00867"></a>00867           <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classGmshIO.php#a990e01befc0da4bc958861b04ae55d22">binary</a>())
<a name="l00868"></a>00868             {
<a name="l00869"></a>00869               <span class="keyword">const</span> <span class="keywordtype">int</span> one = 1;
<a name="l00870"></a>00870               std::memcpy(buf, &amp;one, <span class="keyword">sizeof</span>(<span class="keywordtype">int</span>));
<a name="l00871"></a>00871               out.write(buf, <span class="keyword">sizeof</span>(<span class="keywordtype">int</span>));
<a name="l00872"></a>00872             }
<a name="l00873"></a>00873 
<a name="l00874"></a>00874           <span class="comment">// the time steps (there is just 1 at the moment)</span>
<a name="l00875"></a>00875           <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classGmshIO.php#a990e01befc0da4bc958861b04ae55d22">binary</a>())
<a name="l00876"></a>00876             {
<a name="l00877"></a>00877               <span class="keywordtype">double</span> one = 1;
<a name="l00878"></a>00878               std::memcpy(buf, &amp;one, <span class="keyword">sizeof</span>(<span class="keywordtype">double</span>));
<a name="l00879"></a>00879               out.write(buf, <span class="keyword">sizeof</span>(<span class="keywordtype">double</span>));
<a name="l00880"></a>00880             }
<a name="l00881"></a>00881           <span class="keywordflow">else</span>
<a name="l00882"></a>00882             out &lt;&lt; <span class="stringliteral">&quot;1\n&quot;</span>;
<a name="l00883"></a>00883 
<a name="l00884"></a>00884           <span class="comment">// Loop over the elements and write out the data</span>
<a name="l00885"></a>00885           <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00886"></a>00886           <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00887"></a>00887     
<a name="l00888"></a>00888           <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l00889"></a>00889             {
<a name="l00890"></a>00890               <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *it;
<a name="l00891"></a>00891         
<a name="l00892"></a>00892               <span class="comment">// this is quite crappy, but I did not invent that file format!</span>
<a name="l00893"></a>00893               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d=0; d&lt;3; d++)  <span class="comment">// loop over the dimensions </span>
<a name="l00894"></a>00894                 {
<a name="l00895"></a>00895                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n &lt; elem-&gt;<a class="code" href="classElem.php#a6bbe1895127c069722e36ee4e2a8a6e1">n_vertices</a>(); n++)   <span class="comment">// loop over vertices</span>
<a name="l00896"></a>00896                     {
<a name="l00897"></a>00897                       <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> vertex = elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(n);
<a name="l00898"></a>00898                       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classGmshIO.php#a990e01befc0da4bc958861b04ae55d22">binary</a>())
<a name="l00899"></a>00899                         {
<a name="l00900"></a>00900                           <span class="keywordtype">double</span> tmp = vertex(d);
<a name="l00901"></a>00901                           std::memcpy(buf, &amp;tmp, <span class="keyword">sizeof</span>(<span class="keywordtype">double</span>));
<a name="l00902"></a>00902                           out.write(reinterpret_cast&lt;char *&gt;(buf), <span class="keyword">sizeof</span>(<span class="keywordtype">double</span>));
<a name="l00903"></a>00903                         }
<a name="l00904"></a>00904                       <span class="keywordflow">else</span>
<a name="l00905"></a>00905                         out &lt;&lt; vertex(d) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00906"></a>00906                     }
<a name="l00907"></a>00907                   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classGmshIO.php#a990e01befc0da4bc958861b04ae55d22">binary</a>())
<a name="l00908"></a>00908                     out &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00909"></a>00909                 }
<a name="l00910"></a>00910 
<a name="l00911"></a>00911               <span class="comment">// now finally write out the data</span>
<a name="l00912"></a>00912               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i &lt; elem-&gt;<a class="code" href="classElem.php#a6bbe1895127c069722e36ee4e2a8a6e1">n_vertices</a>(); i++)   <span class="comment">// loop over vertices</span>
<a name="l00913"></a>00913                 <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classGmshIO.php#a990e01befc0da4bc958861b04ae55d22">binary</a>())
<a name="l00914"></a>00914                   {
<a name="l00915"></a>00915 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00916"></a>00916 <span class="preprocessor"></span>                    std::cout &lt;&lt; <span class="stringliteral">&quot;WARNING: Gmsh::write_post does not fully support &quot;</span>
<a name="l00917"></a>00917                               &lt;&lt; <span class="stringliteral">&quot;complex numbers. Will only write the real part of &quot;</span>
<a name="l00918"></a>00918                               &lt;&lt; <span class="stringliteral">&quot;variable &quot;</span> &lt;&lt; varname &lt;&lt; std::endl;
<a name="l00919"></a>00919 <span class="preprocessor">#endif</span>
<a name="l00920"></a>00920 <span class="preprocessor"></span>                    <span class="keywordtype">double</span> tmp = <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>((*v)[elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(i)*n_vars + ivar]);
<a name="l00921"></a>00921                     std::memcpy(buf, &amp;tmp, <span class="keyword">sizeof</span>(<span class="keywordtype">double</span>));
<a name="l00922"></a>00922                     out.write(reinterpret_cast&lt;char *&gt;(buf), <span class="keyword">sizeof</span>(<span class="keywordtype">double</span>));
<a name="l00923"></a>00923                   }
<a name="l00924"></a>00924                 <span class="keywordflow">else</span>
<a name="l00925"></a>00925                   {
<a name="l00926"></a>00926 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00927"></a>00927 <span class="preprocessor"></span>                    std::cout &lt;&lt; <span class="stringliteral">&quot;WARNING: Gmsh::write_post does not fully support &quot;</span>
<a name="l00928"></a>00928                               &lt;&lt; <span class="stringliteral">&quot;complex numbers. Will only write the real part of &quot;</span>
<a name="l00929"></a>00929                               &lt;&lt; <span class="stringliteral">&quot;variable &quot;</span> &lt;&lt; varname &lt;&lt; std::endl;
<a name="l00930"></a>00930 <span class="preprocessor">#endif</span>
<a name="l00931"></a>00931 <span class="preprocessor"></span>                    out &lt;&lt; <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>((*v)[elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(i)*n_vars + ivar]) &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00932"></a>00932                   }
<a name="l00933"></a>00933             }
<a name="l00934"></a>00934           <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classGmshIO.php#a990e01befc0da4bc958861b04ae55d22">binary</a>())
<a name="l00935"></a>00935             out &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00936"></a>00936           out &lt;&lt; <span class="stringliteral">&quot;$EndView\n&quot;</span>;
<a name="l00937"></a>00937 
<a name="l00938"></a>00938         } <span class="comment">// end variable loop (writing the views)</span>
<a name="l00939"></a>00939     }
<a name="l00940"></a>00940 
<a name="l00941"></a>00941 }
<a name="l00942"></a>00942 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
