<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>gmsh_io.h</h1>  </div>
</div>
<div class="contents">
<a href="gmsh__io_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: gmsh_io.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __gmsh_io_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __gmsh_io_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="mesh__input_8h.php">mesh_input.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="mesh__output_8h.php">mesh_output.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Forward declarations</span>
<a name="l00031"></a>00031 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00045"></a>00045 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00046"></a>00046 <span class="comment">// GMVIO class definition</span>
<a name="l00047"></a><a class="code" href="classGmshIO.php">00047</a> <span class="keyword">class </span><a class="code" href="classGmshIO.php">GmshIO</a> : <span class="keyword">public</span> <a class="code" href="classMeshInput.php">MeshInput</a>&lt;MeshBase&gt;,
<a name="l00048"></a>00048                <span class="keyword">public</span> <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;MeshBase&gt;
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050  <span class="keyword">public</span>:
<a name="l00051"></a>00051 
<a name="l00056"></a>00056   <a class="code" href="classGmshIO.php#a0d8becce2b200ae5afaeb72d3d52b390">GmshIO</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a>);
<a name="l00057"></a>00057   
<a name="l00062"></a>00062   <a class="code" href="classGmshIO.php#a0d8becce2b200ae5afaeb72d3d52b390">GmshIO</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00063"></a>00063 
<a name="l00068"></a>00068   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classGmshIO.php#ae650f0cd736ab71bbd2dc0459606676d">read</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>);
<a name="l00069"></a>00069 
<a name="l00074"></a>00074   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classGmshIO.php#adc25c81852d64962f3e4eac2353534c9">write</a> (<span class="keyword">const</span> std::string&amp; name);
<a name="l00075"></a>00075   
<a name="l00080"></a>00080   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classGmshIO.php#a316b217296ecdbd9fc99054c89c59cdd">write_nodal_data</a> (<span class="keyword">const</span> std::string&amp;,
<a name="l00081"></a>00081                                  <span class="keyword">const</span> std::vector&lt;Number&gt;&amp;,
<a name="l00082"></a>00082                                  <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp;);
<a name="l00083"></a>00083 
<a name="l00094"></a>00094   <span class="keywordtype">bool</span> &amp; <a class="code" href="classGmshIO.php#a990e01befc0da4bc958861b04ae55d22">binary</a> ();
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 <span class="keyword">private</span>:
<a name="l00103"></a>00103   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classGmshIO.php#a9a8478f7cec123a0bf824baccf94a540">read_mesh</a> (std::istream&amp; in);
<a name="l00104"></a>00104 
<a name="l00109"></a>00109   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classGmshIO.php#a4f098ed5adbfdec6c1b6646b7e136086">write_mesh</a> (std::ostream&amp; out);
<a name="l00110"></a>00110 
<a name="l00116"></a>00116   <span class="keywordtype">void</span> <a class="code" href="classGmshIO.php#a916f129df2fa2b0e1b9e43ab21365ab5">write_post</a> (<span class="keyword">const</span> std::string&amp;,
<a name="l00117"></a>00117                    <span class="keyword">const</span> std::vector&lt;Number&gt;* = NULL,
<a name="l00118"></a>00118                    <span class="keyword">const</span> std::vector&lt;std::string&gt;* = NULL);
<a name="l00119"></a>00119 
<a name="l00123"></a><a class="code" href="classGmshIO.php#aa1101ae4c9cc3ced775c2e17edfab9fd">00123</a>   <span class="keywordtype">bool</span> <a class="code" href="classGmshIO.php#aa1101ae4c9cc3ced775c2e17edfab9fd">_binary</a>;
<a name="l00124"></a>00124  
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 };
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00132"></a>00132 <span class="comment">// GmshIO inline members</span>
<a name="l00133"></a>00133 <span class="keyword">inline</span>
<a name="l00134"></a><a class="code" href="classGmshIO.php#a0b32c1197e1885c72a451318af52b0a2">00134</a> <a class="code" href="classGmshIO.php#a0d8becce2b200ae5afaeb72d3d52b390">GmshIO::GmshIO</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh) :
<a name="l00135"></a>00135   <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt; (mesh),
<a name="l00136"></a>00136   _binary        (false)
<a name="l00137"></a>00137 {
<a name="l00138"></a>00138 }
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 <span class="keyword">inline</span>
<a name="l00142"></a><a class="code" href="classGmshIO.php#a0d8becce2b200ae5afaeb72d3d52b390">00142</a> <a class="code" href="classGmshIO.php#a0d8becce2b200ae5afaeb72d3d52b390">GmshIO::GmshIO</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh) :
<a name="l00143"></a>00143   <a class="code" href="classMeshInput.php">MeshInput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt;  (mesh),
<a name="l00144"></a>00144   <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt; (mesh),
<a name="l00145"></a>00145   _binary (false)
<a name="l00146"></a>00146 {}
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 <span class="keyword">inline</span>
<a name="l00149"></a><a class="code" href="classGmshIO.php#a990e01befc0da4bc958861b04ae55d22">00149</a> <span class="keywordtype">bool</span> &amp; <a class="code" href="classGmshIO.php#a990e01befc0da4bc958861b04ae55d22">GmshIO::binary</a> ()
<a name="l00150"></a>00150 {
<a name="l00151"></a>00151   <span class="keywordflow">return</span> <a class="code" href="classGmshIO.php#aa1101ae4c9cc3ced775c2e17edfab9fd">_binary</a>;
<a name="l00152"></a>00152 }
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 <span class="preprocessor">#endif // #define __gmsh_io_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
