<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>gmv_io.h</h1>  </div>
</div>
<div class="contents">
<a href="gmv__io_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: gmv_io.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __gmv_io_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __gmv_io_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;cstring&gt;</span>  <span class="comment">// for memcpy</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="mesh__output_8h.php">mesh_output.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="mesh__input_8h.php">mesh_input.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;elem_type.h&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Forward declarations</span>
<a name="l00036"></a>00036 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00049"></a>00049 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00050"></a>00050 <span class="comment">// GMVIO class definition</span>
<a name="l00051"></a><a class="code" href="classGMVIO.php">00051</a> <span class="keyword">class </span><a class="code" href="classGMVIO.php">GMVIO</a> : <span class="keyword">public</span> <a class="code" href="classMeshInput.php">MeshInput</a>&lt;MeshBase&gt;,
<a name="l00052"></a>00052               <span class="keyword">public</span> <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;MeshBase&gt;
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054  <span class="keyword">public</span>:
<a name="l00055"></a>00055 
<a name="l00060"></a>00060   <a class="code" href="classGMVIO.php#a96fe9550be657e03f86c3a6804ed4e1e">GMVIO</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp;);
<a name="l00061"></a>00061 
<a name="l00066"></a>00066   <a class="code" href="classGMVIO.php#a96fe9550be657e03f86c3a6804ed4e1e">GMVIO</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp;);
<a name="l00067"></a>00067   
<a name="l00071"></a>00071   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classGMVIO.php#a15c045764aae56e3b7827a6015f7d20e">write</a> (<span class="keyword">const</span> std::string&amp; );
<a name="l00072"></a>00072 
<a name="l00076"></a>00076   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classGMVIO.php#ae8334c0cb906df1a659a17f712084aa0">read</a> (<span class="keyword">const</span> std::string&amp; mesh_file);
<a name="l00077"></a>00077   
<a name="l00078"></a>00078 <span class="comment">//   /**</span>
<a name="l00079"></a>00079 <span class="comment">//    * This method implements reading a mesh from a specified file.</span>
<a name="l00080"></a>00080 <span class="comment">//    */</span>
<a name="l00081"></a>00081 <span class="comment">//   virtual void read (const std::string&amp; mesh_file)</span>
<a name="l00082"></a>00082 <span class="comment">//   { this-&gt;read_mesh_and_nodal_data(mesh_file, NULL); }</span>
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 <span class="comment">//   /**</span>
<a name="l00085"></a>00085 <span class="comment">//    * Extension of the MeshInput::read() routine which</span>
<a name="l00086"></a>00086 <span class="comment">//    * also takes an optional EquationSystems pointer and</span>
<a name="l00087"></a>00087 <span class="comment">//    * tries to read field variables from the GMV file</span>
<a name="l00088"></a>00088 <span class="comment">//    * into the EquationSystems object.</span>
<a name="l00089"></a>00089 <span class="comment">//    */</span>
<a name="l00090"></a>00090 <span class="comment">//   virtual void read_mesh_and_nodal_data (const std::string&amp; ,</span>
<a name="l00091"></a>00091 <span class="comment">//                                       EquationSystems* es=NULL);</span>
<a name="l00092"></a>00092   
<a name="l00097"></a>00097   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classGMVIO.php#afcadf7ebf7bded1774d490ea06365d83">write_nodal_data</a> (<span class="keyword">const</span> std::string&amp;,
<a name="l00098"></a>00098                                  <span class="keyword">const</span> std::vector&lt;Number&gt;&amp;,
<a name="l00099"></a>00099                                  <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp;);
<a name="l00100"></a>00100 
<a name="l00111"></a>00111   <span class="keywordtype">bool</span> &amp; <a class="code" href="classGMVIO.php#a84b95e3d5dcaa789bed735abbc4cfa37">binary</a> ();
<a name="l00112"></a>00112    
<a name="l00117"></a>00117   <span class="keywordtype">bool</span> &amp; <a class="code" href="classGMVIO.php#a2fc11345fa9e56482332b4c25db79d0d">discontinuous</a>();
<a name="l00118"></a>00118   
<a name="l00123"></a>00123   <span class="keywordtype">bool</span> &amp; <a class="code" href="classGMVIO.php#a6aa37d92f28d5c0328f5d850a8f34146">partitioning</a>();
<a name="l00124"></a>00124   
<a name="l00129"></a>00129   <span class="keywordtype">bool</span> &amp; <a class="code" href="classGMVIO.php#ad6a426c3cd0f92ebef2d511de6b36d63">subdivide_second_order</a>();
<a name="l00130"></a>00130   
<a name="l00135"></a>00135   <span class="keywordtype">bool</span> &amp; <a class="code" href="classGMVIO.php#a5f98874c0e3d59b64bf25b76ee8c50f7">p_levels</a>();
<a name="l00136"></a>00136   
<a name="l00140"></a>00140   <span class="keywordtype">void</span> <a class="code" href="classGMVIO.php#a17a9e71db590651fd7fe22ba312a5b8c">write_discontinuous_gmv</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>, 
<a name="l00141"></a>00141                                 <span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00142"></a>00142                                 <span class="keyword">const</span> <span class="keywordtype">bool</span> write_partitioning) <span class="keyword">const</span>;
<a name="l00143"></a>00143   
<a name="l00144"></a>00144 
<a name="l00151"></a>00151   <span class="keywordtype">void</span> <a class="code" href="classGMVIO.php#aad4df5b9c6a385147efb381f734e05e6">write_ascii_new_impl</a> (<span class="keyword">const</span> std::string&amp;,
<a name="l00152"></a>00152                              <span class="keyword">const</span> std::vector&lt;Number&gt;* = NULL,
<a name="l00153"></a>00153                              <span class="keyword">const</span> std::vector&lt;std::string&gt;* = NULL);
<a name="l00154"></a>00154 
<a name="l00166"></a>00166   <span class="keywordtype">void</span> <a class="code" href="classGMVIO.php#a5bba503f34793a5f5bbcc93fc6a301bd">add_cell_centered_data</a> (<span class="keyword">const</span> std::string&amp;       cell_centered_data_name,
<a name="l00167"></a>00167                                <span class="keyword">const</span> std::vector&lt;Real&gt;* cell_centered_data_vals);
<a name="l00168"></a>00168 
<a name="l00173"></a>00173   <span class="keywordtype">void</span> <a class="code" href="classGMVIO.php#a392268acc2e17ad3d8c7b590cd346fc9">copy_nodal_solution</a>(<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es);
<a name="l00174"></a>00174   
<a name="l00175"></a>00175 <span class="keyword">private</span>:
<a name="l00176"></a>00176 
<a name="l00183"></a>00183   <span class="keywordtype">void</span> <a class="code" href="classGMVIO.php#a82a9c7d7eb7d907b948aaef0185ef0f2">write_ascii_old_impl</a> (<span class="keyword">const</span> std::string&amp;,
<a name="l00184"></a>00184                              <span class="keyword">const</span> std::vector&lt;Number&gt;* = NULL,
<a name="l00185"></a>00185                              <span class="keyword">const</span> std::vector&lt;std::string&gt;* = NULL);
<a name="l00186"></a>00186 
<a name="l00192"></a>00192   <span class="keywordtype">void</span> <a class="code" href="classGMVIO.php#af68960fcc46adfa3e9625a5c97485cf7">write_binary</a> (<span class="keyword">const</span> std::string&amp;,
<a name="l00193"></a>00193                      <span class="keyword">const</span> std::vector&lt;Number&gt;* = NULL,
<a name="l00194"></a>00194                      <span class="keyword">const</span> std::vector&lt;std::string&gt;* = NULL);
<a name="l00195"></a>00195   
<a name="l00200"></a>00200   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00201"></a>00201   <span class="keywordtype">void</span> <a class="code" href="classGMVIO.php#a25764a340c49f0641f61bc09c5a49809">to_binary_stream</a>(std::ostream&amp; out,
<a name="l00202"></a>00202                         <span class="keyword">const</span> T i);
<a name="l00203"></a>00203   
<a name="l00207"></a><a class="code" href="classGMVIO.php#aa8064f2854dd75287741babae9788689">00207</a>   <span class="keywordtype">bool</span> <a class="code" href="classGMVIO.php#aa8064f2854dd75287741babae9788689">_binary</a>;
<a name="l00208"></a>00208  
<a name="l00212"></a><a class="code" href="classGMVIO.php#a9d48148872f39f849277bddb42c294ca">00212</a>   <span class="keywordtype">bool</span> <a class="code" href="classGMVIO.php#a9d48148872f39f849277bddb42c294ca">_discontinuous</a>;
<a name="l00213"></a>00213  
<a name="l00217"></a><a class="code" href="classGMVIO.php#aa899059c4b5db41d956b4526973b4d11">00217</a>   <span class="keywordtype">bool</span> <a class="code" href="classGMVIO.php#aa899059c4b5db41d956b4526973b4d11">_partitioning</a>;
<a name="l00218"></a>00218  
<a name="l00222"></a><a class="code" href="classGMVIO.php#a11fe4ec86b42843edd0cef6b891083a2">00222</a>   <span class="keywordtype">bool</span> <a class="code" href="classGMVIO.php#a11fe4ec86b42843edd0cef6b891083a2">_subdivide_second_order</a>;
<a name="l00223"></a>00223  
<a name="l00227"></a><a class="code" href="classGMVIO.php#a493f70c5ffe1622902502c4300f5e0ab">00227</a>   <span class="keywordtype">bool</span> <a class="code" href="classGMVIO.php#a493f70c5ffe1622902502c4300f5e0ab">_p_levels</a>;
<a name="l00228"></a>00228 
<a name="l00235"></a><a class="code" href="classGMVIO.php#a63e34768e73b4fd0586993b87511456f">00235</a>   std::map&lt;std::string, const std::vector&lt;Real&gt;* &gt; <a class="code" href="classGMVIO.php#a63e34768e73b4fd0586993b87511456f">_cell_centered_data</a>;
<a name="l00236"></a>00236 
<a name="l00240"></a>00240   <span class="keywordtype">void</span> <a class="code" href="classGMVIO.php#a5ad07c3daaf7d89aab0240eca6f3d383">_read_nodes</a>();
<a name="l00241"></a><a class="code" href="classGMVIO.php#aad2265a608364782a4f20a644e84c8d8">00241</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classGMVIO.php#aad2265a608364782a4f20a644e84c8d8">_next_elem_id</a>;
<a name="l00242"></a>00242   <span class="keywordtype">void</span> <a class="code" href="classGMVIO.php#a76c0bea1ec7d2678820eb8292a68a294">_read_one_cell</a>();
<a name="l00243"></a>00243   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classGMVIO.php#a704c61641391604709268cb0735880bc">_gmv_elem_to_libmesh_elem</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* elemname);
<a name="l00244"></a>00244   <span class="keywordtype">void</span> <a class="code" href="classGMVIO.php#a40dd8ce77099e2418f63ceede1495fa0">_read_materials</a>();
<a name="l00245"></a>00245   <span class="keywordtype">void</span> <a class="code" href="classGMVIO.php#a2ebc0d899ddb84dcfb0415195b098058">_read_var</a>();
<a name="l00246"></a><a class="code" href="classGMVIO.php#a8389ff29c16e7ce47fd56b8a8cc2cdbc">00246</a>   std::map&lt;std::string, std::vector&lt;Number&gt; &gt; <a class="code" href="classGMVIO.php#a8389ff29c16e7ce47fd56b8a8cc2cdbc">_nodal_data</a>;
<a name="l00247"></a>00247 };
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 
<a name="l00250"></a>00250 
<a name="l00251"></a>00251 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00252"></a>00252 <span class="comment">// GMVIO inline members</span>
<a name="l00253"></a>00253 <span class="keyword">inline</span>
<a name="l00254"></a><a class="code" href="classGMVIO.php#a96fe9550be657e03f86c3a6804ed4e1e">00254</a> <a class="code" href="classGMVIO.php#a96fe9550be657e03f86c3a6804ed4e1e">GMVIO::GMVIO</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh) :
<a name="l00255"></a>00255   <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt;    (mesh),
<a name="l00256"></a>00256   _binary                 (false),
<a name="l00257"></a>00257   _discontinuous          (false),  
<a name="l00258"></a>00258   _partitioning           (true),
<a name="l00259"></a>00259   _subdivide_second_order (true),
<a name="l00260"></a>00260   _p_levels               (true),
<a name="l00261"></a>00261   _next_elem_id           (0)
<a name="l00262"></a>00262 {
<a name="l00263"></a>00263 }
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 <span class="keyword">inline</span>
<a name="l00266"></a><a class="code" href="classGMVIO.php#ab03e9327c269840e2475266c9242ebc3">00266</a> <a class="code" href="classGMVIO.php#a96fe9550be657e03f86c3a6804ed4e1e">GMVIO::GMVIO</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh) :
<a name="l00267"></a>00267   <a class="code" href="classMeshInput.php">MeshInput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt; (mesh),
<a name="l00268"></a>00268   <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt;(mesh),
<a name="l00269"></a>00269   _binary (false),
<a name="l00270"></a>00270   _discontinuous          (false),  
<a name="l00271"></a>00271   _partitioning           (true),
<a name="l00272"></a>00272   _subdivide_second_order (true),
<a name="l00273"></a>00273   _p_levels               (true),
<a name="l00274"></a>00274   _next_elem_id           (0)
<a name="l00275"></a>00275 {
<a name="l00276"></a>00276 }
<a name="l00277"></a>00277 
<a name="l00278"></a>00278 
<a name="l00279"></a>00279 
<a name="l00280"></a>00280 <span class="keyword">inline</span>
<a name="l00281"></a><a class="code" href="classGMVIO.php#a84b95e3d5dcaa789bed735abbc4cfa37">00281</a> <span class="keywordtype">bool</span> &amp; <a class="code" href="classGMVIO.php#a84b95e3d5dcaa789bed735abbc4cfa37">GMVIO::binary</a> ()
<a name="l00282"></a>00282 {
<a name="l00283"></a>00283   <span class="keywordflow">return</span> <a class="code" href="classGMVIO.php#aa8064f2854dd75287741babae9788689">_binary</a>;
<a name="l00284"></a>00284 }
<a name="l00285"></a>00285 
<a name="l00286"></a>00286 
<a name="l00287"></a>00287 
<a name="l00288"></a>00288 <span class="keyword">inline</span>
<a name="l00289"></a><a class="code" href="classGMVIO.php#a2fc11345fa9e56482332b4c25db79d0d">00289</a> <span class="keywordtype">bool</span> &amp; <a class="code" href="classGMVIO.php#a2fc11345fa9e56482332b4c25db79d0d">GMVIO::discontinuous</a> ()
<a name="l00290"></a>00290 {
<a name="l00291"></a>00291   <span class="keywordflow">return</span> <a class="code" href="classGMVIO.php#a9d48148872f39f849277bddb42c294ca">_discontinuous</a>;
<a name="l00292"></a>00292 }
<a name="l00293"></a>00293 
<a name="l00294"></a>00294 
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 <span class="keyword">inline</span>
<a name="l00297"></a><a class="code" href="classGMVIO.php#a6aa37d92f28d5c0328f5d850a8f34146">00297</a> <span class="keywordtype">bool</span> &amp; <a class="code" href="classGMVIO.php#a6aa37d92f28d5c0328f5d850a8f34146">GMVIO::partitioning</a> ()
<a name="l00298"></a>00298 {
<a name="l00299"></a>00299   <span class="keywordflow">return</span> <a class="code" href="classGMVIO.php#aa899059c4b5db41d956b4526973b4d11">_partitioning</a>;
<a name="l00300"></a>00300 }
<a name="l00301"></a>00301 
<a name="l00302"></a>00302 
<a name="l00303"></a>00303 
<a name="l00304"></a>00304 <span class="keyword">inline</span>
<a name="l00305"></a><a class="code" href="classGMVIO.php#ad6a426c3cd0f92ebef2d511de6b36d63">00305</a> <span class="keywordtype">bool</span> &amp; <a class="code" href="classGMVIO.php#ad6a426c3cd0f92ebef2d511de6b36d63">GMVIO::subdivide_second_order</a> ()
<a name="l00306"></a>00306 {
<a name="l00307"></a>00307   <span class="keywordflow">return</span> <a class="code" href="classGMVIO.php#a11fe4ec86b42843edd0cef6b891083a2">_subdivide_second_order</a>;
<a name="l00308"></a>00308 }
<a name="l00309"></a>00309 
<a name="l00310"></a>00310 
<a name="l00311"></a>00311 
<a name="l00312"></a>00312 <span class="keyword">inline</span>
<a name="l00313"></a><a class="code" href="classGMVIO.php#a5f98874c0e3d59b64bf25b76ee8c50f7">00313</a> <span class="keywordtype">bool</span> &amp; <a class="code" href="classGMVIO.php#a5f98874c0e3d59b64bf25b76ee8c50f7">GMVIO::p_levels</a>()
<a name="l00314"></a>00314 {
<a name="l00315"></a>00315   <span class="keywordflow">return</span> <a class="code" href="classGMVIO.php#a493f70c5ffe1622902502c4300f5e0ab">_p_levels</a>;
<a name="l00316"></a>00316 }
<a name="l00317"></a>00317 
<a name="l00318"></a>00318 
<a name="l00319"></a>00319 
<a name="l00320"></a>00320 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00321"></a><a class="code" href="classGMVIO.php#a25764a340c49f0641f61bc09c5a49809">00321</a> <span class="keywordtype">void</span> <a class="code" href="classGMVIO.php#a25764a340c49f0641f61bc09c5a49809">GMVIO::to_binary_stream</a>(std::ostream&amp; out,
<a name="l00322"></a>00322                              <span class="keyword">const</span> T i)
<a name="l00323"></a>00323 {
<a name="l00324"></a>00324   <span class="keyword">static</span> <span class="keywordtype">char</span> buf[<span class="keyword">sizeof</span>(T)];
<a name="l00325"></a>00325   memcpy(buf, &amp;i, <span class="keyword">sizeof</span>(T));
<a name="l00326"></a>00326   out.write(buf, <span class="keyword">sizeof</span>(T));
<a name="l00327"></a>00327 }
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 <span class="preprocessor">#endif // #define __gmv_io_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
