<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>gnuplot_io.C</h1>  </div>
</div>
<div class="contents">
<a href="gnuplot__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: gnuplot_io.C 3416 2009-07-03 14:30:29Z knezed01 $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// C++ includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;sstream&gt;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;gnuplot_io.h&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a><a class="code" href="classGnuPlotIO.php#ad13b6619286707305d5e14613ea06be7">00030</a> <a class="code" href="classGnuPlotIO.php#ad13b6619286707305d5e14613ea06be7">GnuPlotIO::GnuPlotIO</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00031"></a>00031                      <span class="keyword">const</span> std::string&amp; title, 
<a name="l00032"></a>00032                      <span class="keywordtype">int</span> mesh_properties)
<a name="l00033"></a>00033   :
<a name="l00034"></a>00034   <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt; (mesh),
<a name="l00035"></a>00035   _title(title)
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037   <a class="code" href="classGnuPlotIO.php#af6c79bcd3e537c20924888f9f50c65a7">_grid</a>       = (mesh_properties &amp; <a class="code" href="classGnuPlotIO.php#aca69830ebbdae3713a03f6115ecca720ab346b6de6493b66ccd979bb53f52db62">GRID_ON</a>);
<a name="l00038"></a>00038   <a class="code" href="classGnuPlotIO.php#a0b4a25e7e01d093b68690546f2f2e7c4">_png_output</a> = (mesh_properties &amp; <a class="code" href="classGnuPlotIO.php#aca69830ebbdae3713a03f6115ecca720a136cbb0f13d2478098c53f05c929148f">PNG_OUTPUT</a>);
<a name="l00039"></a>00039 }
<a name="l00040"></a>00040 
<a name="l00041"></a><a class="code" href="classGnuPlotIO.php#a5f2cbbbd8a12f9f9bace2bd0952f7b11">00041</a> <span class="keywordtype">void</span> <a class="code" href="classGnuPlotIO.php#a5f2cbbbd8a12f9f9bace2bd0952f7b11">GnuPlotIO::write</a>(<span class="keyword">const</span> std::string&amp; fname)
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043 
<a name="l00044"></a>00044   <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00045"></a>00045     this-&gt;<a class="code" href="classGnuPlotIO.php#a3cb29a1dd615f6c246008037bc706811">write_solution</a>(fname);
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 }
<a name="l00048"></a>00048 
<a name="l00049"></a><a class="code" href="classGnuPlotIO.php#a96381894e9bafd93374a154dd4eb4a5a">00049</a> <span class="keywordtype">void</span> <a class="code" href="classGnuPlotIO.php#a96381894e9bafd93374a154dd4eb4a5a">GnuPlotIO::write_nodal_data</a> (<span class="keyword">const</span> std::string&amp; fname,
<a name="l00050"></a>00050                                   <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; soln,
<a name="l00051"></a>00051                                   <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; names)
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053   <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00054"></a>00054     this-&gt;<a class="code" href="classGnuPlotIO.php#a3cb29a1dd615f6c246008037bc706811">write_solution</a>(fname, &amp;soln, &amp;names);
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 }
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 
<a name="l00061"></a><a class="code" href="classGnuPlotIO.php#a3cb29a1dd615f6c246008037bc706811">00061</a> <span class="keywordtype">void</span> <a class="code" href="classGnuPlotIO.php#a3cb29a1dd615f6c246008037bc706811">GnuPlotIO::write_solution</a>(<span class="keyword">const</span> std::string&amp; fname,
<a name="l00062"></a>00062                                <span class="keyword">const</span> std::vector&lt;Number&gt;* soln,
<a name="l00063"></a>00063                                <span class="keyword">const</span> std::vector&lt;std::string&gt;* names)
<a name="l00064"></a>00064 {
<a name="l00065"></a>00065   libmesh_assert(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0);
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshOutput.php#af923657f1dcc7c26a973332295d94f13">mesh</a> = <a class="code" href="classMeshOutput.php#af923657f1dcc7c26a973332295d94f13">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   std::stringstream data_stream_name;
<a name="l00070"></a>00070   data_stream_name &lt;&lt; fname &lt;&lt; <span class="stringliteral">&quot;_data&quot;</span>;
<a name="l00071"></a>00071   <span class="keyword">const</span> std::string data_file_name = data_stream_name.str();
<a name="l00072"></a>00072   
<a name="l00073"></a>00073   <span class="comment">// This class is designed only for use with 1D meshes</span>
<a name="l00074"></a>00074   libmesh_assert (mesh.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>() == 1);
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <span class="comment">// Make sure we have a solution to plot</span>
<a name="l00077"></a>00077   libmesh_assert ((names != NULL) &amp;&amp; (soln != NULL));
<a name="l00078"></a>00078 
<a name="l00079"></a>00079   <span class="comment">// Create an output stream for script file</span>
<a name="l00080"></a>00080   std::ofstream out(fname.c_str());
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   <span class="comment">// Make sure it opened correctly</span>
<a name="l00083"></a>00083   <span class="keywordflow">if</span> (!out.good())
<a name="l00084"></a>00084     libmesh_file_error(fname.c_str());
<a name="l00085"></a>00085 
<a name="l00086"></a>00086   <span class="comment">// The number of variables in the equation system</span>
<a name="l00087"></a>00087   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_vars = names-&gt;size();
<a name="l00088"></a>00088   
<a name="l00089"></a>00089   <span class="comment">// Write header to stream</span>
<a name="l00090"></a>00090   out &lt;&lt; <span class="stringliteral">&quot;# This file was generated by gnuplot_io.C\n&quot;</span>
<a name="l00091"></a>00091       &lt;&lt; <span class="stringliteral">&quot;# Stores 1D solution data in GNUplot format\n&quot;</span>
<a name="l00092"></a>00092       &lt;&lt; <span class="stringliteral">&quot;# Execute this by loading gnuplot and typing &quot;</span>
<a name="l00093"></a>00093       &lt;&lt; <span class="stringliteral">&quot;\&quot;call &#39;&quot;</span> &lt;&lt; fname &lt;&lt; <span class="stringliteral">&quot;&#39;\&quot;\n&quot;</span>
<a name="l00094"></a>00094       &lt;&lt; <span class="stringliteral">&quot;reset\n&quot;</span>
<a name="l00095"></a>00095       &lt;&lt; <span class="stringliteral">&quot;set title \&quot;&quot;</span> &lt;&lt; <a class="code" href="classGnuPlotIO.php#a6e1faee99fc452d1a71e5fe599e87df5">_title</a> &lt;&lt; <span class="stringliteral">&quot;\&quot;\n&quot;</span>
<a name="l00096"></a>00096       &lt;&lt; <span class="stringliteral">&quot;set xlabel \&quot;x\&quot;\n&quot;</span>
<a name="l00097"></a>00097       &lt;&lt; <span class="stringliteral">&quot;set autoscale\n&quot;</span>
<a name="l00098"></a>00098       &lt;&lt; <span class="stringliteral">&quot;set xtics nomirror\n&quot;</span>;
<a name="l00099"></a>00099       
<a name="l00100"></a>00100   <span class="keywordflow">if</span>(<a class="code" href="classGnuPlotIO.php#af6c79bcd3e537c20924888f9f50c65a7">_grid</a>)
<a name="l00101"></a>00101   {
<a name="l00102"></a>00102     <span class="comment">// construct string for xtic positions at element edges</span>
<a name="l00103"></a>00103     std::string xtics;
<a name="l00104"></a>00104     std::stringstream xtics_stream;
<a name="l00105"></a>00105 
<a name="l00106"></a>00106     <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> it = mesh.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00107"></a>00107     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_it =
<a name="l00108"></a>00108       mesh.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>();
<a name="l00109"></a>00109 
<a name="l00110"></a>00110     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> count = 0;
<a name="l00111"></a>00111     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_active_elem = mesh.<a class="code" href="classMeshBase.php#a246697678d5d14a986cee2b6fbdbae6b">n_active_elem</a>();
<a name="l00112"></a>00112 
<a name="l00113"></a>00113     <span class="keywordflow">for</span>( ; it != end_it; ++it)
<a name="l00114"></a>00114     {
<a name="l00115"></a>00115       <a class="code" href="classElem.php">Elem</a>* el = *it;
<a name="l00116"></a>00116       
<a name="l00117"></a>00117       <span class="comment">// if el is the left edge of the mesh, print its left node position</span>
<a name="l00118"></a>00118       <span class="keywordflow">if</span>(el-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(0) == NULL)
<a name="l00119"></a>00119       {
<a name="l00120"></a>00120         xtics_stream &lt;&lt; <span class="stringliteral">&quot;\&quot;\&quot; &quot;</span> &lt;&lt; (*(el-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(0)))(0) &lt;&lt; <span class="stringliteral">&quot;, \\\n&quot;</span>;
<a name="l00121"></a>00121       }
<a name="l00122"></a>00122       xtics_stream &lt;&lt; <span class="stringliteral">&quot;\&quot;\&quot; &quot;</span> &lt;&lt; (*(el-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(1)))(0);
<a name="l00123"></a>00123 
<a name="l00124"></a>00124       <span class="keywordflow">if</span>(count+1 != n_active_elem)
<a name="l00125"></a>00125       {
<a name="l00126"></a>00126          xtics_stream &lt;&lt; <span class="stringliteral">&quot;, \\\n&quot;</span>;
<a name="l00127"></a>00127       }
<a name="l00128"></a>00128       count++;
<a name="l00129"></a>00129     }
<a name="l00130"></a>00130     xtics = xtics_stream.str();
<a name="l00131"></a>00131     
<a name="l00132"></a>00132   
<a name="l00133"></a>00133     out &lt;&lt; <span class="stringliteral">&quot;set x2tics (&quot;</span> &lt;&lt; xtics &lt;&lt; <span class="stringliteral">&quot;)\nset grid noxtics noytics x2tics\n&quot;</span>;
<a name="l00134"></a>00134   }
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   <span class="keywordflow">if</span>(<a class="code" href="classGnuPlotIO.php#a0b4a25e7e01d093b68690546f2f2e7c4">_png_output</a>)
<a name="l00137"></a>00137   {
<a name="l00138"></a>00138     out &lt;&lt; <span class="stringliteral">&quot;set terminal png\n&quot;</span>;
<a name="l00139"></a>00139     out &lt;&lt; <span class="stringliteral">&quot;set output \&quot;&quot;</span> &lt;&lt; fname &lt;&lt; <span class="stringliteral">&quot;.png\&quot;\n&quot;</span>;
<a name="l00140"></a>00140   }
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   out &lt;&lt; <span class="stringliteral">&quot;plot &quot;</span>
<a name="l00143"></a>00143       &lt;&lt; <a class="code" href="classGnuPlotIO.php#a3e603e689d0886873a1c59b643816205">axes_limits</a>
<a name="l00144"></a>00144       &lt;&lt; <span class="stringliteral">&quot; \&quot;&quot;</span> &lt;&lt; data_file_name &lt;&lt; <span class="stringliteral">&quot;\&quot; using 1:2 title \&quot;&quot;</span> &lt;&lt; (*names)[0]
<a name="l00145"></a>00145       &lt;&lt; <span class="stringliteral">&quot;\&quot; with lines&quot;</span>;
<a name="l00146"></a>00146   <span class="keywordflow">if</span>(n_vars &gt; 1)
<a name="l00147"></a>00147   {
<a name="l00148"></a>00148     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i&lt;n_vars; i++)
<a name="l00149"></a>00149     {
<a name="l00150"></a>00150       out &lt;&lt; <span class="stringliteral">&quot;, \\\n\&quot;&quot;</span> &lt;&lt; data_file_name &lt;&lt; <span class="stringliteral">&quot;\&quot; using 1:&quot;</span> &lt;&lt; i+2 
<a name="l00151"></a>00151           &lt;&lt; <span class="stringliteral">&quot; title \&quot;&quot;</span> &lt;&lt; (*names)[i] &lt;&lt; <span class="stringliteral">&quot;\&quot; with lines&quot;</span>;
<a name="l00152"></a>00152     }
<a name="l00153"></a>00153   }
<a name="l00154"></a>00154 
<a name="l00155"></a>00155   out.close();
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a>00158   <span class="comment">// Create an output stream for data file</span>
<a name="l00159"></a>00159   std::ofstream data(data_file_name.c_str());
<a name="l00160"></a>00160 
<a name="l00161"></a>00161   <span class="keywordflow">if</span> (!data.good())
<a name="l00162"></a>00162     {
<a name="l00163"></a>00163       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: opening output data file &quot;</span> &lt;&lt; std::endl;
<a name="l00164"></a>00164       libmesh_error();
<a name="l00165"></a>00165     }
<a name="l00166"></a>00166 
<a name="l00167"></a>00167   <span class="comment">// get ordered nodal data using a map</span>
<a name="l00168"></a>00168   <span class="keyword">typedef</span> std::pair&lt;Real, std::vector&lt;Number&gt; &gt; key_value_pair;
<a name="l00169"></a>00169   <span class="keyword">typedef</span> std::map&lt;Real, std::vector&lt;Number&gt; &gt; map_type;
<a name="l00170"></a>00170   <span class="keyword">typedef</span> map_type::iterator map_iterator;
<a name="l00171"></a>00171 
<a name="l00172"></a>00172   map_type node_map;
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 
<a name="l00175"></a>00175   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00176"></a>00176   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00177"></a>00177 
<a name="l00178"></a>00178   <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l00179"></a>00179   {
<a name="l00180"></a>00180     <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *it;
<a name="l00181"></a>00181 
<a name="l00182"></a>00182     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); i++)
<a name="l00183"></a>00183     {
<a name="l00184"></a>00184       std::vector&lt;Number&gt; values;
<a name="l00185"></a>00185 
<a name="l00186"></a>00186       <span class="comment">// Get the global id of the node</span>
<a name="l00187"></a>00187       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_id = elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(i);
<a name="l00188"></a>00188 
<a name="l00189"></a>00189       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;n_vars; c++)
<a name="l00190"></a>00190       {
<a name="l00191"></a>00191         values.push_back( (*soln)[global_id*n_vars + c] );
<a name="l00192"></a>00192       }
<a name="l00193"></a>00193 
<a name="l00194"></a>00194       node_map[ mesh.<a class="code" href="classMeshBase.php#a06af1f178519c606d0bdca7857f95ba6">point</a>(global_id)(0) ] = values;
<a name="l00195"></a>00195     }
<a name="l00196"></a>00196   }
<a name="l00197"></a>00197 
<a name="l00198"></a>00198     
<a name="l00199"></a>00199   map_iterator map_it = node_map.begin();
<a name="l00200"></a>00200   <span class="keyword">const</span> map_iterator end_map_it = node_map.end();
<a name="l00201"></a>00201 
<a name="l00202"></a>00202   <span class="keywordflow">for</span>( ; map_it != end_map_it; ++map_it)
<a name="l00203"></a>00203   {
<a name="l00204"></a>00204     key_value_pair kvp = *map_it;
<a name="l00205"></a>00205     std::vector&lt;Number&gt; values = kvp.second;
<a name="l00206"></a>00206 
<a name="l00207"></a>00207     data &lt;&lt; kvp.first &lt;&lt; <span class="stringliteral">&quot;\t&quot;</span>;
<a name="l00208"></a>00208 
<a name="l00209"></a>00209     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;values.size(); i++)
<a name="l00210"></a>00210     {
<a name="l00211"></a>00211       data &lt;&lt; values[i] &lt;&lt; <span class="stringliteral">&quot;\t&quot;</span>;
<a name="l00212"></a>00212     }
<a name="l00213"></a>00213 
<a name="l00214"></a>00214     data &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00215"></a>00215   }
<a name="l00216"></a>00216 
<a name="l00217"></a>00217   data.close();
<a name="l00218"></a>00218 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
