<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_f10759d5ac6297fe611079c3c15b8f2c.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>hp_coarsentest.C</h1>  </div>
</div>
<div class="contents">
<a href="hp__coarsentest_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: hp_coarsentest.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// C++ includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &lt;limits&gt;</span> <span class="comment">// for std::numeric_limits::max</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;math.h&gt;</span>    <span class="comment">// for sqrt</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local Includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;hp_coarsentest.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;dense_matrix.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;dense_vector.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;dof_map.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;fe_base.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;fe_interface.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;error_vector.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;mesh.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;quadrature.h&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;system.h&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;tensor_value.h&quot;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span>
<a name="l00042"></a>00042 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00043"></a>00043 <span class="comment">// HPCoarsenTest implementations</span>
<a name="l00044"></a>00044 
<a name="l00045"></a><a class="code" href="classHPCoarsenTest.php#ad47acc536e27d3c2c6acf4511e60d1c4">00045</a> <span class="keywordtype">void</span> <a class="code" href="classHPCoarsenTest.php#ad47acc536e27d3c2c6acf4511e60d1c4">HPCoarsenTest::add_projection</a>(<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a> &amp;system,
<a name="l00046"></a>00046                                 <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *elem,
<a name="l00047"></a>00047                                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049   <span class="comment">// If we have children, we need to add their projections instead</span>
<a name="l00050"></a>00050   <span class="keywordflow">if</span> (!elem-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l00051"></a>00051     {
<a name="l00052"></a>00052       libmesh_assert(!elem-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>());
<a name="l00053"></a>00053       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c = 0; c != elem-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); ++c)
<a name="l00054"></a>00054         this-&gt;<a class="code" href="classHPCoarsenTest.php#ad47acc536e27d3c2c6acf4511e60d1c4">add_projection</a>(system, elem-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c), var);
<a name="l00055"></a>00055       <span class="keywordflow">return</span>;
<a name="l00056"></a>00056     }
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <span class="comment">// The DofMap for this system</span>
<a name="l00059"></a>00059   <span class="keyword">const</span> <a class="code" href="classDofMap.php">DofMap</a>&amp; dof_map = system.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>();
<a name="l00060"></a>00060 
<a name="l00061"></a>00061   <span class="comment">// The type of finite element to use for this variable</span>
<a name="l00062"></a>00062   <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_type = dof_map.<a class="code" href="classDofMap.php#ae3c63266417020f38af6e5cc40efca76">variable_type</a> (var);
<a name="l00063"></a>00063 
<a name="l00064"></a>00064   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14">FEContinuity</a> cont = <a class="code" href="classHPCoarsenTest.php#a02771777ce64a43513557e2696a47b81">fe</a>-&gt;get_continuity();
<a name="l00065"></a>00065 
<a name="l00066"></a>00066   <a class="code" href="classHPCoarsenTest.php#a02771777ce64a43513557e2696a47b81">fe</a>-&gt;reinit(elem);
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   dof_map.<a class="code" href="classDofMap.php#afc5ee41412dcab63d5507efbf5d8482d">dof_indices</a>(elem, <a class="code" href="classHPCoarsenTest.php#a4879f91e0430730fe8739cb64f37ae10">dof_indices</a>, var);
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FEInterface::inverse_map</a> (system.<a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">get_mesh</a>().<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>(),
<a name="l00071"></a>00071     fe_type, <a class="code" href="classHPCoarsenTest.php#a26767183e3cffaf2a5163609ca49bfa2">coarse</a>, *<a class="code" href="classHPCoarsenTest.php#af420f95127d80b01a5377eb6ee99a8f0">xyz_values</a>, <a class="code" href="classHPCoarsenTest.php#a3e94470a1f95887e3a23e38e8da03e6e">coarse_qpoints</a>);
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   <a class="code" href="classHPCoarsenTest.php#ae4732a527986dea441ab2dd4c7484f11">fe_coarse</a>-&gt;reinit(coarse, &amp;<a class="code" href="classHPCoarsenTest.php#a3e94470a1f95887e3a23e38e8da03e6e">coarse_qpoints</a>);
<a name="l00074"></a>00074 
<a name="l00075"></a>00075   <span class="keywordflow">if</span> (<a class="code" href="classHPCoarsenTest.php#a407febc4f03f4e24c745ea37c0291cf2">Uc</a>.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>() == 0)
<a name="l00076"></a>00076     {
<a name="l00077"></a>00077       <a class="code" href="classHPCoarsenTest.php#ac6806220b069655e05a6ba34bf9a636f">Ke</a>.<a class="code" href="classDenseMatrix.php#a8c19724598a1ac1e3c758aaad73beb1b">resize</a>(<a class="code" href="classHPCoarsenTest.php#a177f066327658181af79e09d4bf84481">phi_coarse</a>-&gt;size(), <a class="code" href="classHPCoarsenTest.php#a177f066327658181af79e09d4bf84481">phi_coarse</a>-&gt;size());
<a name="l00078"></a>00078       <a class="code" href="classHPCoarsenTest.php#ac6806220b069655e05a6ba34bf9a636f">Ke</a>.<a class="code" href="classDenseMatrix.php#a3d3f0e57fc2e9dc7ed292cbd2124581e">zero</a>();
<a name="l00079"></a>00079       <a class="code" href="classHPCoarsenTest.php#ac619342911166d12715917f07872b210">Fe</a>.<a class="code" href="classDenseVector.php#a3a9af103dc052f1dfdef1626692cd8cd">resize</a>(<a class="code" href="classHPCoarsenTest.php#a177f066327658181af79e09d4bf84481">phi_coarse</a>-&gt;size());
<a name="l00080"></a>00080       <a class="code" href="classHPCoarsenTest.php#ac619342911166d12715917f07872b210">Fe</a>.<a class="code" href="classDenseVector.php#a4e0123eb5cc4054e8069155f0faf4425">zero</a>();
<a name="l00081"></a>00081       <a class="code" href="classHPCoarsenTest.php#a407febc4f03f4e24c745ea37c0291cf2">Uc</a>.<a class="code" href="classDenseVector.php#a3a9af103dc052f1dfdef1626692cd8cd">resize</a>(<a class="code" href="classHPCoarsenTest.php#a177f066327658181af79e09d4bf84481">phi_coarse</a>-&gt;size());
<a name="l00082"></a>00082       <a class="code" href="classHPCoarsenTest.php#a407febc4f03f4e24c745ea37c0291cf2">Uc</a>.<a class="code" href="classDenseVector.php#a4e0123eb5cc4054e8069155f0faf4425">zero</a>();
<a name="l00083"></a>00083     }
<a name="l00084"></a>00084   libmesh_assert(<a class="code" href="classHPCoarsenTest.php#a407febc4f03f4e24c745ea37c0291cf2">Uc</a>.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>() == <a class="code" href="classHPCoarsenTest.php#a177f066327658181af79e09d4bf84481">phi_coarse</a>-&gt;size());
<a name="l00085"></a>00085 
<a name="l00086"></a>00086   <span class="comment">// Loop over the quadrature points</span>
<a name="l00087"></a>00087   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;<a class="code" href="classHPCoarsenTest.php#ade5173316fcd1b1211fb3c4d91ceffc2">qrule</a>-&gt;n_points(); qp++)
<a name="l00088"></a>00088     {
<a name="l00089"></a>00089       <span class="comment">// The solution value at the quadrature point</span>
<a name="l00090"></a>00090       <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> val = <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>;
<a name="l00091"></a>00091       <a class="code" href="classVectorValue.php">Gradient</a> grad;
<a name="l00092"></a>00092       <a class="code" href="classTensorValue.php">Tensor</a> hess;
<a name="l00093"></a>00093 
<a name="l00094"></a>00094       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classHPCoarsenTest.php#a4879f91e0430730fe8739cb64f37ae10">dof_indices</a>.size(); i++)
<a name="l00095"></a>00095         {
<a name="l00096"></a>00096           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dof_num = <a class="code" href="classHPCoarsenTest.php#a4879f91e0430730fe8739cb64f37ae10">dof_indices</a>[i];
<a name="l00097"></a>00097           val += (*phi)[i][qp] *
<a name="l00098"></a>00098             system.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(dof_num);
<a name="l00099"></a>00099           <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00100"></a>00100             grad.<a class="code" href="classTypeVector.php#ac9000695cb19991b893cb79a07249e9c">add_scaled</a>((*<a class="code" href="classHPCoarsenTest.php#a1256d4e183100ed13530dcc33d57461d">dphi</a>)[i][qp],system.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(dof_num));
<a name="l00101"></a>00101            <span class="comment">// grad += (*dphi)[i][qp] *</span>
<a name="l00102"></a>00102             <span class="comment">//  system.current_solution(dof_num);</span>
<a name="l00103"></a>00103           <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00104"></a>00104             hess.<a class="code" href="classTypeTensor.php#ae24569251bc6ea38090165d349fdfc6c">add_scaled</a>((*<a class="code" href="classHPCoarsenTest.php#a6dd5a9e046b14b458455c55a2807944d">d2phi</a>)[i][qp], system.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(dof_num));
<a name="l00105"></a>00105             <span class="comment">// hess += (*d2phi)[i][qp] *</span>
<a name="l00106"></a>00106             <span class="comment">//  system.current_solution(dof_num);</span>
<a name="l00107"></a>00107         }
<a name="l00108"></a>00108 
<a name="l00109"></a>00109       <span class="comment">// The projection matrix and vector</span>
<a name="l00110"></a>00110       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classHPCoarsenTest.php#ac619342911166d12715917f07872b210">Fe</a>.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>(); ++i)
<a name="l00111"></a>00111         {
<a name="l00112"></a>00112           <a class="code" href="classHPCoarsenTest.php#ac619342911166d12715917f07872b210">Fe</a>(i) += (*JxW)[qp] * 
<a name="l00113"></a>00113             (*phi_coarse)[i][qp]*val;
<a name="l00114"></a>00114           <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00115"></a>00115             <a class="code" href="classHPCoarsenTest.php#ac619342911166d12715917f07872b210">Fe</a>(i) += (*JxW)[qp] *
<a name="l00116"></a>00116               (grad*(*dphi_coarse)[i][qp]);
<a name="l00117"></a>00117           <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00118"></a>00118             <a class="code" href="classHPCoarsenTest.php#ac619342911166d12715917f07872b210">Fe</a>(i) += (*JxW)[qp] *
<a name="l00119"></a>00119               hess.<a class="code" href="classTypeTensor.php#a1c322fe55bdd9e7eab8d9ead033f5e19">contract</a>((*<a class="code" href="classHPCoarsenTest.php#afeff2f8fa18b6a138b645e95e2460ffb">d2phi_coarse</a>)[i][qp]);
<a name="l00120"></a>00120             <span class="comment">// Fe(i) += (*JxW)[qp] *</span>
<a name="l00121"></a>00121             <span class="comment">//  (*d2phi_coarse)[i][qp].contract(hess);</span>
<a name="l00122"></a>00122 
<a name="l00123"></a>00123           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j != <a class="code" href="classHPCoarsenTest.php#ac619342911166d12715917f07872b210">Fe</a>.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>(); ++j)
<a name="l00124"></a>00124             {
<a name="l00125"></a>00125               <a class="code" href="classHPCoarsenTest.php#ac6806220b069655e05a6ba34bf9a636f">Ke</a>(i,j) += (*JxW)[qp] *
<a name="l00126"></a>00126                 (*phi_coarse)[i][qp]*(*phi_coarse)[j][qp];
<a name="l00127"></a>00127               <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00128"></a>00128                 <a class="code" href="classHPCoarsenTest.php#ac6806220b069655e05a6ba34bf9a636f">Ke</a>(i,j) += (*JxW)[qp] *
<a name="l00129"></a>00129                   (*dphi_coarse)[i][qp]*(*dphi_coarse)[j][qp];
<a name="l00130"></a>00130               <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00131"></a>00131                 <a class="code" href="classHPCoarsenTest.php#ac6806220b069655e05a6ba34bf9a636f">Ke</a>(i,j) += (*JxW)[qp] *
<a name="l00132"></a>00132                   ((*d2phi_coarse)[i][qp].contract((*<a class="code" href="classHPCoarsenTest.php#afeff2f8fa18b6a138b645e95e2460ffb">d2phi_coarse</a>)[j][qp]));
<a name="l00133"></a>00133             }
<a name="l00134"></a>00134         }
<a name="l00135"></a>00135     }
<a name="l00136"></a>00136 }
<a name="l00137"></a>00137 
<a name="l00138"></a><a class="code" href="classHPCoarsenTest.php#ac875819213df42aa447eeac0de8f5f2c">00138</a> <span class="keywordtype">void</span> <a class="code" href="classHPCoarsenTest.php#ac875819213df42aa447eeac0de8f5f2c">HPCoarsenTest::select_refinement</a> (<a class="code" href="classSystem.php">System</a> &amp;system)
<a name="l00139"></a>00139 {
<a name="l00140"></a>00140   START_LOG(<span class="stringliteral">&quot;select_refinement()&quot;</span>, <span class="stringliteral">&quot;HPCoarsenTest&quot;</span>);
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   <span class="comment">// The current mesh</span>
<a name="l00143"></a>00143   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh = system.<a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">get_mesh</a>();
<a name="l00144"></a>00144 
<a name="l00145"></a>00145   <span class="comment">// The dimensionality of the mesh</span>
<a name="l00146"></a>00146   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = mesh.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>();
<a name="l00147"></a>00147   
<a name="l00148"></a>00148   <span class="comment">// The number of variables in the system</span>
<a name="l00149"></a>00149   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_vars = system.<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>();
<a name="l00150"></a>00150   
<a name="l00151"></a>00151   <span class="comment">// The DofMap for this system</span>
<a name="l00152"></a>00152   <span class="keyword">const</span> <a class="code" href="classDofMap.php">DofMap</a>&amp; dof_map = system.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>();
<a name="l00153"></a>00153 
<a name="l00154"></a>00154   <span class="comment">// The system number (for doing bad hackery)</span>
<a name="l00155"></a>00155   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num = system.<a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">number</a>();
<a name="l00156"></a>00156 
<a name="l00157"></a>00157   <span class="comment">// Check for a valid component_scale</span>
<a name="l00158"></a>00158   <span class="keywordflow">if</span> (!<a class="code" href="classHPSelector.php#a373961932ab7c443072bdd155402fc09">component_scale</a>.empty())
<a name="l00159"></a>00159     {
<a name="l00160"></a>00160       <span class="keywordflow">if</span> (<a class="code" href="classHPSelector.php#a373961932ab7c443072bdd155402fc09">component_scale</a>.size() != n_vars)
<a name="l00161"></a>00161         {
<a name="l00162"></a>00162           std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: component_scale is the wrong size:&quot;</span>
<a name="l00163"></a>00163                     &lt;&lt; std::endl
<a name="l00164"></a>00164                     &lt;&lt; <span class="stringliteral">&quot; component_scale.size()=&quot;</span> &lt;&lt; <a class="code" href="classHPSelector.php#a373961932ab7c443072bdd155402fc09">component_scale</a>.size()
<a name="l00165"></a>00165                     &lt;&lt; std::endl
<a name="l00166"></a>00166                     &lt;&lt; <span class="stringliteral">&quot; n_vars=&quot;</span> &lt;&lt; n_vars
<a name="l00167"></a>00167                     &lt;&lt; std::endl;
<a name="l00168"></a>00168           libmesh_error();
<a name="l00169"></a>00169         }
<a name="l00170"></a>00170     }
<a name="l00171"></a>00171   <span class="keywordflow">else</span>
<a name="l00172"></a>00172     {
<a name="l00173"></a>00173       <span class="comment">// No specified scaling.  Scale all variables by one.</span>
<a name="l00174"></a>00174       <a class="code" href="classHPSelector.php#a373961932ab7c443072bdd155402fc09">component_scale</a>.resize (n_vars, 1.0);
<a name="l00175"></a>00175     }
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   <span class="comment">// Resize the error_per_cell vectors to handle</span>
<a name="l00178"></a>00178   <span class="comment">// the number of elements, initialize them to 0.</span>
<a name="l00179"></a>00179   std::vector&lt;ErrorVectorReal&gt; h_error_per_cell(mesh.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>(), 0.);
<a name="l00180"></a>00180   std::vector&lt;ErrorVectorReal&gt; p_error_per_cell(mesh.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>(), 0.);
<a name="l00181"></a>00181   
<a name="l00182"></a>00182   <span class="comment">// Loop over all the variables in the system</span>
<a name="l00183"></a>00183   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;n_vars; var++)
<a name="l00184"></a>00184     {
<a name="l00185"></a>00185       <span class="comment">// Possibly skip this variable</span>
<a name="l00186"></a>00186       <span class="keywordflow">if</span> (!<a class="code" href="classHPSelector.php#a373961932ab7c443072bdd155402fc09">component_scale</a>.empty())
<a name="l00187"></a>00187         <span class="keywordflow">if</span> (<a class="code" href="classHPSelector.php#a373961932ab7c443072bdd155402fc09">component_scale</a>[var] == 0.0) <span class="keywordflow">continue</span>;
<a name="l00188"></a>00188       
<a name="l00189"></a>00189       <span class="comment">// The type of finite element to use for this variable</span>
<a name="l00190"></a>00190       <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_type = dof_map.<a class="code" href="classDofMap.php#ae3c63266417020f38af6e5cc40efca76">variable_type</a> (var);
<a name="l00191"></a>00191 
<a name="l00192"></a>00192       <a class="code" href="classFEType.php">FEType</a> low_p_fe_type = fe_type;
<a name="l00193"></a>00193       <a class="code" href="classFEType.php">FEType</a> high_p_fe_type = fe_type;
<a name="l00194"></a>00194 
<a name="l00195"></a>00195       <span class="comment">// Finite element objects for a fine (and probably a coarse)</span>
<a name="l00196"></a>00196       <span class="comment">// element will be needed</span>
<a name="l00197"></a>00197       <a class="code" href="classHPCoarsenTest.php#a02771777ce64a43513557e2696a47b81">fe</a> = <a class="code" href="classFEBase.php#a3e86219b79ce4f881e9c48f4fd7b860e">FEBase::build</a> (dim, fe_type);
<a name="l00198"></a>00198       <a class="code" href="classHPCoarsenTest.php#ae4732a527986dea441ab2dd4c7484f11">fe_coarse</a> = <a class="code" href="classFEBase.php#a3e86219b79ce4f881e9c48f4fd7b860e">FEBase::build</a> (dim, fe_type);
<a name="l00199"></a>00199 
<a name="l00200"></a>00200       <span class="comment">// Any cached coarse element results have expired</span>
<a name="l00201"></a>00201       <a class="code" href="classHPCoarsenTest.php#a26767183e3cffaf2a5163609ca49bfa2">coarse</a> = NULL;
<a name="l00202"></a>00202       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cached_coarse_p_level = 0;
<a name="l00203"></a>00203 
<a name="l00204"></a>00204       <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14">FEContinuity</a> cont = <a class="code" href="classHPCoarsenTest.php#a02771777ce64a43513557e2696a47b81">fe</a>-&gt;get_continuity();
<a name="l00205"></a>00205       libmesh_assert (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a06624ba73875d1537d4422952c08a782">DISCONTINUOUS</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || 
<a name="l00206"></a>00206               cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>);
<a name="l00207"></a>00207 
<a name="l00208"></a>00208       <span class="comment">// Build an appropriate quadrature rule</span>
<a name="l00209"></a>00209       <a class="code" href="classHPCoarsenTest.php#ade5173316fcd1b1211fb3c4d91ceffc2">qrule</a> = fe_type.<a class="code" href="classFEType.php#a33013296ee9643faec0262714ad9163c">default_quadrature_rule</a>(dim);
<a name="l00210"></a>00210 
<a name="l00211"></a>00211       <span class="comment">// Tell the refined finite element about the quadrature</span>
<a name="l00212"></a>00212       <span class="comment">// rule.  The coarse finite element need not know about it</span>
<a name="l00213"></a>00213       <a class="code" href="classHPCoarsenTest.php#a02771777ce64a43513557e2696a47b81">fe</a>-&gt;attach_quadrature_rule (<a class="code" href="classHPCoarsenTest.php#ade5173316fcd1b1211fb3c4d91ceffc2">qrule</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>());
<a name="l00214"></a>00214 
<a name="l00215"></a>00215       <span class="comment">// We will always do the integration</span>
<a name="l00216"></a>00216       <span class="comment">// on the fine elements.  Get their Jacobian values, etc..</span>
<a name="l00217"></a>00217       <a class="code" href="classHPCoarsenTest.php#a004140a7e706fb9a9e00aa9ef9493858">JxW</a> = &amp;(<a class="code" href="classHPCoarsenTest.php#a02771777ce64a43513557e2696a47b81">fe</a>-&gt;get_JxW());
<a name="l00218"></a>00218       <a class="code" href="classHPCoarsenTest.php#af420f95127d80b01a5377eb6ee99a8f0">xyz_values</a> = &amp;(<a class="code" href="classHPCoarsenTest.php#a02771777ce64a43513557e2696a47b81">fe</a>-&gt;get_xyz());
<a name="l00219"></a>00219 
<a name="l00220"></a>00220       <span class="comment">// The shape functions</span>
<a name="l00221"></a>00221       <a class="code" href="classHPCoarsenTest.php#adf0ff4e18d15821d102955e00f45a579">phi</a> = &amp;(<a class="code" href="classHPCoarsenTest.php#a02771777ce64a43513557e2696a47b81">fe</a>-&gt;get_phi());
<a name="l00222"></a>00222       <a class="code" href="classHPCoarsenTest.php#a177f066327658181af79e09d4bf84481">phi_coarse</a> = &amp;(<a class="code" href="classHPCoarsenTest.php#ae4732a527986dea441ab2dd4c7484f11">fe_coarse</a>-&gt;get_phi());
<a name="l00223"></a>00223 
<a name="l00224"></a>00224       <span class="comment">// The shape function derivatives</span>
<a name="l00225"></a>00225       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00226"></a>00226         {
<a name="l00227"></a>00227           <a class="code" href="classHPCoarsenTest.php#a1256d4e183100ed13530dcc33d57461d">dphi</a> = &amp;(<a class="code" href="classHPCoarsenTest.php#a02771777ce64a43513557e2696a47b81">fe</a>-&gt;get_dphi());
<a name="l00228"></a>00228           <a class="code" href="classHPCoarsenTest.php#abb7c2fb156e75bc7f89355a49bb32bdb">dphi_coarse</a> = &amp;(<a class="code" href="classHPCoarsenTest.php#ae4732a527986dea441ab2dd4c7484f11">fe_coarse</a>-&gt;get_dphi());
<a name="l00229"></a>00229         }
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00232"></a>00232 <span class="preprocessor"></span>      <span class="comment">// The shape function second derivatives</span>
<a name="l00233"></a>00233       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00234"></a>00234         {
<a name="l00235"></a>00235           <a class="code" href="classHPCoarsenTest.php#a6dd5a9e046b14b458455c55a2807944d">d2phi</a> = &amp;(<a class="code" href="classHPCoarsenTest.php#a02771777ce64a43513557e2696a47b81">fe</a>-&gt;get_d2phi());
<a name="l00236"></a>00236           <a class="code" href="classHPCoarsenTest.php#afeff2f8fa18b6a138b645e95e2460ffb">d2phi_coarse</a> = &amp;(<a class="code" href="classHPCoarsenTest.php#ae4732a527986dea441ab2dd4c7484f11">fe_coarse</a>-&gt;get_d2phi());
<a name="l00237"></a>00237         }
<a name="l00238"></a>00238 <span class="preprocessor">#endif // defined (LIBMESH_ENABLE_SECOND_DERIVATIVES)</span>
<a name="l00239"></a>00239 <span class="preprocessor"></span>
<a name="l00240"></a>00240       <span class="comment">// Iterate over all the active elements in the mesh</span>
<a name="l00241"></a>00241       <span class="comment">// that live on this processor.</span>
<a name="l00242"></a>00242 
<a name="l00243"></a>00243       <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       elem_it  =
<a name="l00244"></a>00244                       mesh.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00245"></a>00245       <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> elem_end =
<a name="l00246"></a>00246                       mesh.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>(); 
<a name="l00247"></a>00247 
<a name="l00248"></a>00248       <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00249"></a>00249         {
<a name="l00250"></a>00250           <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *elem_it;
<a name="l00251"></a>00251 
<a name="l00252"></a>00252           <span class="comment">// We&#39;re only checking elements that are already flagged for h</span>
<a name="l00253"></a>00253           <span class="comment">// refinement</span>
<a name="l00254"></a>00254           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() != <a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>)
<a name="l00255"></a>00255             <span class="keywordflow">continue</span>;
<a name="l00256"></a>00256 
<a name="l00257"></a>00257           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e_id = elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l00258"></a>00258 
<a name="l00259"></a>00259           <span class="comment">// Find the projection onto the parent element,</span>
<a name="l00260"></a>00260           <span class="comment">// if necessary</span>
<a name="l00261"></a>00261           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>() &amp;&amp;
<a name="l00262"></a>00262               (<a class="code" href="classHPCoarsenTest.php#a26767183e3cffaf2a5163609ca49bfa2">coarse</a> != elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>() ||
<a name="l00263"></a>00263                cached_coarse_p_level != elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>()))
<a name="l00264"></a>00264             {
<a name="l00265"></a>00265               <a class="code" href="classHPCoarsenTest.php#a407febc4f03f4e24c745ea37c0291cf2">Uc</a>.<a class="code" href="classDenseVector.php#a3a9af103dc052f1dfdef1626692cd8cd">resize</a>(0);
<a name="l00266"></a>00266 
<a name="l00267"></a>00267               <a class="code" href="classHPCoarsenTest.php#a26767183e3cffaf2a5163609ca49bfa2">coarse</a> = elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>();
<a name="l00268"></a>00268               cached_coarse_p_level = elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>();
<a name="l00269"></a>00269 
<a name="l00270"></a>00270               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_parent_level = <a class="code" href="classHPCoarsenTest.php#a26767183e3cffaf2a5163609ca49bfa2">coarse</a>-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>();
<a name="l00271"></a>00271               (<span class="keyword">const_cast&lt;</span><a class="code" href="classElem.php">Elem</a> *<span class="keyword">&gt;</span>(<a class="code" href="classHPCoarsenTest.php#a26767183e3cffaf2a5163609ca49bfa2">coarse</a>))-&gt;hack_p_level(elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>());
<a name="l00272"></a>00272               
<a name="l00273"></a>00273               this-&gt;<a class="code" href="classHPCoarsenTest.php#ad47acc536e27d3c2c6acf4511e60d1c4">add_projection</a>(system, <a class="code" href="classHPCoarsenTest.php#a26767183e3cffaf2a5163609ca49bfa2">coarse</a>, var);
<a name="l00274"></a>00274 
<a name="l00275"></a>00275               (<span class="keyword">const_cast&lt;</span><a class="code" href="classElem.php">Elem</a> *<span class="keyword">&gt;</span>(<a class="code" href="classHPCoarsenTest.php#a26767183e3cffaf2a5163609ca49bfa2">coarse</a>))-&gt;hack_p_level(old_parent_level);
<a name="l00276"></a>00276 
<a name="l00277"></a>00277               <span class="comment">// Solve the h-coarsening projection problem</span>
<a name="l00278"></a>00278               <a class="code" href="classHPCoarsenTest.php#ac6806220b069655e05a6ba34bf9a636f">Ke</a>.<a class="code" href="classDenseMatrix.php#a7303f17ad11891bc43f2533688347f15">cholesky_solve</a>(<a class="code" href="classHPCoarsenTest.php#ac619342911166d12715917f07872b210">Fe</a>, <a class="code" href="classHPCoarsenTest.php#a407febc4f03f4e24c745ea37c0291cf2">Uc</a>);
<a name="l00279"></a>00279             }
<a name="l00280"></a>00280 
<a name="l00281"></a>00281           <a class="code" href="classHPCoarsenTest.php#a02771777ce64a43513557e2696a47b81">fe</a>-&gt;reinit(elem);
<a name="l00282"></a>00282           
<a name="l00283"></a>00283           <span class="comment">// Get the DOF indices for the fine element</span>
<a name="l00284"></a>00284           dof_map.<a class="code" href="classDofMap.php#afc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (elem, <a class="code" href="classHPCoarsenTest.php#a4879f91e0430730fe8739cb64f37ae10">dof_indices</a>, var);
<a name="l00285"></a>00285 
<a name="l00286"></a>00286           <span class="comment">// The number of quadrature points</span>
<a name="l00287"></a>00287           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = <a class="code" href="classHPCoarsenTest.php#ade5173316fcd1b1211fb3c4d91ceffc2">qrule</a>-&gt;n_points();
<a name="l00288"></a>00288 
<a name="l00289"></a>00289           <span class="comment">// The number of DOFS on the fine element</span>
<a name="l00290"></a>00290           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classHPCoarsenTest.php#a4879f91e0430730fe8739cb64f37ae10">dof_indices</a>.size();
<a name="l00291"></a>00291 
<a name="l00292"></a>00292           <span class="comment">// The number of nodes on the fine element</span>
<a name="l00293"></a>00293           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a> = elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>();
<a name="l00294"></a>00294 
<a name="l00295"></a>00295           <span class="comment">// The average element value (used as an ugly hack</span>
<a name="l00296"></a>00296           <span class="comment">// when we have nothing p-coarsened to compare to)</span>
<a name="l00297"></a>00297           <span class="comment">// Real average_val = 0.;</span>
<a name="l00298"></a>00298           <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> average_val = 0.;
<a name="l00299"></a>00299 
<a name="l00300"></a>00300           <span class="comment">// Calculate this variable&#39;s contribution to the p</span>
<a name="l00301"></a>00301           <span class="comment">// refinement error</span>
<a name="l00302"></a>00302 
<a name="l00303"></a>00303           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>() == 0)
<a name="l00304"></a>00304             {
<a name="l00305"></a>00305               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_vertices = 0;
<a name="l00306"></a>00306               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = 0; n != <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>; ++n)
<a name="l00307"></a>00307                 <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#afb4be0284f273d7d53cd0e994e6f1d7e">is_vertex</a>(n))
<a name="l00308"></a>00308                   {
<a name="l00309"></a>00309                     n_vertices++;
<a name="l00310"></a>00310                     <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a> * <span class="keyword">const</span> node = elem-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(n);
<a name="l00311"></a>00311                     average_val += system.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>
<a name="l00312"></a>00312                       (node-&gt;<a class="code" href="classDofObject.php#a7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(sys_num,var,0));
<a name="l00313"></a>00313                   }
<a name="l00314"></a>00314               average_val /= n_vertices;
<a name="l00315"></a>00315             }
<a name="l00316"></a>00316           <span class="keywordflow">else</span>
<a name="l00317"></a>00317             {
<a name="l00318"></a>00318               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_elem_level = elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>();
<a name="l00319"></a>00319               (<span class="keyword">const_cast&lt;</span><a class="code" href="classElem.php">Elem</a> *<span class="keyword">&gt;</span>(elem))-&gt;hack_p_level(old_elem_level - 1);
<a name="l00320"></a>00320               
<a name="l00321"></a>00321               <a class="code" href="classHPCoarsenTest.php#ae4732a527986dea441ab2dd4c7484f11">fe_coarse</a>-&gt;reinit(elem, &amp;(<a class="code" href="classHPCoarsenTest.php#ade5173316fcd1b1211fb3c4d91ceffc2">qrule</a>-&gt;get_points()));
<a name="l00322"></a>00322 
<a name="l00323"></a>00323               (<span class="keyword">const_cast&lt;</span><a class="code" href="classElem.php">Elem</a> *<span class="keyword">&gt;</span>(elem))-&gt;hack_p_level(old_elem_level);
<a name="l00324"></a>00324 
<a name="l00325"></a>00325               <a class="code" href="classHPCoarsenTest.php#ac6806220b069655e05a6ba34bf9a636f">Ke</a>.<a class="code" href="classDenseMatrix.php#a8c19724598a1ac1e3c758aaad73beb1b">resize</a>(<a class="code" href="classHPCoarsenTest.php#a177f066327658181af79e09d4bf84481">phi_coarse</a>-&gt;size(), <a class="code" href="classHPCoarsenTest.php#a177f066327658181af79e09d4bf84481">phi_coarse</a>-&gt;size());
<a name="l00326"></a>00326               <a class="code" href="classHPCoarsenTest.php#ac6806220b069655e05a6ba34bf9a636f">Ke</a>.<a class="code" href="classDenseMatrix.php#a3d3f0e57fc2e9dc7ed292cbd2124581e">zero</a>();
<a name="l00327"></a>00327               <a class="code" href="classHPCoarsenTest.php#ac619342911166d12715917f07872b210">Fe</a>.<a class="code" href="classDenseVector.php#a3a9af103dc052f1dfdef1626692cd8cd">resize</a>(<a class="code" href="classHPCoarsenTest.php#a177f066327658181af79e09d4bf84481">phi_coarse</a>-&gt;size());
<a name="l00328"></a>00328               <a class="code" href="classHPCoarsenTest.php#ac619342911166d12715917f07872b210">Fe</a>.<a class="code" href="classDenseVector.php#a4e0123eb5cc4054e8069155f0faf4425">zero</a>();
<a name="l00329"></a>00329 
<a name="l00330"></a>00330               <span class="comment">// Loop over the quadrature points</span>
<a name="l00331"></a>00331               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;<a class="code" href="classHPCoarsenTest.php#ade5173316fcd1b1211fb3c4d91ceffc2">qrule</a>-&gt;n_points(); qp++)
<a name="l00332"></a>00332                 {
<a name="l00333"></a>00333                   <span class="comment">// The solution value at the quadrature point</span>
<a name="l00334"></a>00334                   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> val = <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>;
<a name="l00335"></a>00335                   <a class="code" href="classVectorValue.php">Gradient</a> grad;
<a name="l00336"></a>00336                   <a class="code" href="classTensorValue.php">Tensor</a> hess;
<a name="l00337"></a>00337 
<a name="l00338"></a>00338                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classHPCoarsenTest.php#a4879f91e0430730fe8739cb64f37ae10">dof_indices</a>.size(); i++)
<a name="l00339"></a>00339                     {
<a name="l00340"></a>00340                       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dof_num = <a class="code" href="classHPCoarsenTest.php#a4879f91e0430730fe8739cb64f37ae10">dof_indices</a>[i];
<a name="l00341"></a>00341                       val += (*phi)[i][qp] *
<a name="l00342"></a>00342                         system.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(dof_num);
<a name="l00343"></a>00343                       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00344"></a>00344                         grad.<a class="code" href="classTypeVector.php#ac9000695cb19991b893cb79a07249e9c">add_scaled</a>((*<a class="code" href="classHPCoarsenTest.php#a1256d4e183100ed13530dcc33d57461d">dphi</a>)[i][qp], system.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(dof_num));
<a name="l00345"></a>00345                         <span class="comment">// grad += (*dphi)[i][qp] *</span>
<a name="l00346"></a>00346                         <span class="comment">//  system.current_solution(dof_num);</span>
<a name="l00347"></a>00347                       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00348"></a>00348                         hess.<a class="code" href="classTypeTensor.php#ae24569251bc6ea38090165d349fdfc6c">add_scaled</a>((*<a class="code" href="classHPCoarsenTest.php#a6dd5a9e046b14b458455c55a2807944d">d2phi</a>)[i][qp], system.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(dof_num));
<a name="l00349"></a>00349                         <span class="comment">// hess += (*d2phi)[i][qp] *</span>
<a name="l00350"></a>00350                         <span class="comment">//  system.current_solution(dof_num);</span>
<a name="l00351"></a>00351                     }
<a name="l00352"></a>00352 
<a name="l00353"></a>00353                   <span class="comment">// The projection matrix and vector</span>
<a name="l00354"></a>00354                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classHPCoarsenTest.php#ac619342911166d12715917f07872b210">Fe</a>.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>(); ++i)
<a name="l00355"></a>00355                     {
<a name="l00356"></a>00356                       <a class="code" href="classHPCoarsenTest.php#ac619342911166d12715917f07872b210">Fe</a>(i) += (*JxW)[qp] *
<a name="l00357"></a>00357                         (*phi_coarse)[i][qp]*val;
<a name="l00358"></a>00358                       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00359"></a>00359                         <a class="code" href="classHPCoarsenTest.php#ac619342911166d12715917f07872b210">Fe</a>(i) += (*JxW)[qp] *
<a name="l00360"></a>00360                           grad * (*dphi_coarse)[i][qp];
<a name="l00361"></a>00361                       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00362"></a>00362                         <a class="code" href="classHPCoarsenTest.php#ac619342911166d12715917f07872b210">Fe</a>(i) += (*JxW)[qp] *
<a name="l00363"></a>00363                           hess.<a class="code" href="classTypeTensor.php#a1c322fe55bdd9e7eab8d9ead033f5e19">contract</a>((*<a class="code" href="classHPCoarsenTest.php#afeff2f8fa18b6a138b645e95e2460ffb">d2phi_coarse</a>)[i][qp]);
<a name="l00364"></a>00364 
<a name="l00365"></a>00365                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j != <a class="code" href="classHPCoarsenTest.php#ac619342911166d12715917f07872b210">Fe</a>.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>(); ++j)
<a name="l00366"></a>00366                         {
<a name="l00367"></a>00367                           <a class="code" href="classHPCoarsenTest.php#ac6806220b069655e05a6ba34bf9a636f">Ke</a>(i,j) += (*JxW)[qp] *
<a name="l00368"></a>00368                             (*phi_coarse)[i][qp]*(*phi_coarse)[j][qp];
<a name="l00369"></a>00369                           <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00370"></a>00370                             <a class="code" href="classHPCoarsenTest.php#ac6806220b069655e05a6ba34bf9a636f">Ke</a>(i,j) += (*JxW)[qp] *
<a name="l00371"></a>00371                               (*dphi_coarse)[i][qp]*(*dphi_coarse)[j][qp];
<a name="l00372"></a>00372                           <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00373"></a>00373                             <a class="code" href="classHPCoarsenTest.php#ac6806220b069655e05a6ba34bf9a636f">Ke</a>(i,j) += (*JxW)[qp] *
<a name="l00374"></a>00374                               ((*d2phi_coarse)[i][qp].contract((*<a class="code" href="classHPCoarsenTest.php#afeff2f8fa18b6a138b645e95e2460ffb">d2phi_coarse</a>)[j][qp]));
<a name="l00375"></a>00375                         }
<a name="l00376"></a>00376                     }
<a name="l00377"></a>00377                 }
<a name="l00378"></a>00378 
<a name="l00379"></a>00379               <span class="comment">// Solve the p-coarsening projection problem</span>
<a name="l00380"></a>00380               <a class="code" href="classHPCoarsenTest.php#ac6806220b069655e05a6ba34bf9a636f">Ke</a>.<a class="code" href="classDenseMatrix.php#a7303f17ad11891bc43f2533688347f15">cholesky_solve</a>(<a class="code" href="classHPCoarsenTest.php#ac619342911166d12715917f07872b210">Fe</a>, <a class="code" href="classHPCoarsenTest.php#a83ddbb436c00d8985689944f6eb639bb">Up</a>);
<a name="l00381"></a>00381             }
<a name="l00382"></a>00382 
<a name="l00383"></a>00383           <span class="comment">// loop over the integration points on the fine element</span>
<a name="l00384"></a>00384           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;n_qp; qp++)
<a name="l00385"></a>00385             {
<a name="l00386"></a>00386               <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> value_error = 0.;
<a name="l00387"></a>00387               <a class="code" href="classVectorValue.php">Gradient</a> grad_error;
<a name="l00388"></a>00388               <a class="code" href="classTensorValue.php">Tensor</a> hessian_error;
<a name="l00389"></a>00389               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs; i++)
<a name="l00390"></a>00390                 {
<a name="l00391"></a>00391                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dof_num = <a class="code" href="classHPCoarsenTest.php#a4879f91e0430730fe8739cb64f37ae10">dof_indices</a>[i];
<a name="l00392"></a>00392                   value_error += (*phi)[i][qp] *
<a name="l00393"></a>00393                     system.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(dof_num);
<a name="l00394"></a>00394                   <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00395"></a>00395                     grad_error.<a class="code" href="classTypeVector.php#ac9000695cb19991b893cb79a07249e9c">add_scaled</a>((*<a class="code" href="classHPCoarsenTest.php#a1256d4e183100ed13530dcc33d57461d">dphi</a>)[i][qp], system.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(dof_num));
<a name="l00396"></a>00396                     <span class="comment">// grad_error += (*dphi)[i][qp] *</span>
<a name="l00397"></a>00397                     <span class="comment">//  system.current_solution(dof_num);</span>
<a name="l00398"></a>00398                   <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00399"></a>00399                     hessian_error.<a class="code" href="classTypeTensor.php#ae24569251bc6ea38090165d349fdfc6c">add_scaled</a>((*<a class="code" href="classHPCoarsenTest.php#a6dd5a9e046b14b458455c55a2807944d">d2phi</a>)[i][qp], system.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(dof_num));
<a name="l00400"></a>00400                   <span class="comment">// hessian_error += (*d2phi)[i][qp] *</span>
<a name="l00401"></a>00401                   <span class="comment">//    system.current_solution(dof_num);</span>
<a name="l00402"></a>00402                 }
<a name="l00403"></a>00403               <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>() == 0)
<a name="l00404"></a>00404                 {
<a name="l00405"></a>00405                   value_error -= average_val;
<a name="l00406"></a>00406                 }
<a name="l00407"></a>00407               <span class="keywordflow">else</span>
<a name="l00408"></a>00408                 {
<a name="l00409"></a>00409                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classHPCoarsenTest.php#a83ddbb436c00d8985689944f6eb639bb">Up</a>.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>(); i++)
<a name="l00410"></a>00410                     {
<a name="l00411"></a>00411                       value_error -= (*phi_coarse)[i][qp] * <a class="code" href="classHPCoarsenTest.php#a83ddbb436c00d8985689944f6eb639bb">Up</a>(i);
<a name="l00412"></a>00412                       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00413"></a>00413                         grad_error.<a class="code" href="classTypeVector.php#a94b16f15ba75d265bf83e9a50d9fd63b">subtract_scaled</a>((*<a class="code" href="classHPCoarsenTest.php#abb7c2fb156e75bc7f89355a49bb32bdb">dphi_coarse</a>)[i][qp], <a class="code" href="classHPCoarsenTest.php#a83ddbb436c00d8985689944f6eb639bb">Up</a>(i));
<a name="l00414"></a>00414                         <span class="comment">// grad_error -= (*dphi_coarse)[i][qp] * Up(i);</span>
<a name="l00415"></a>00415                       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00416"></a>00416                         hessian_error.<a class="code" href="classTypeTensor.php#a704df2f185a1d7f8db1650680e462eea">subtract_scaled</a>((*<a class="code" href="classHPCoarsenTest.php#afeff2f8fa18b6a138b645e95e2460ffb">d2phi_coarse</a>)[i][qp], <a class="code" href="classHPCoarsenTest.php#a83ddbb436c00d8985689944f6eb639bb">Up</a>(i));
<a name="l00417"></a>00417                         <span class="comment">// hessian_error -= (*d2phi_coarse)[i][qp] * Up(i);</span>
<a name="l00418"></a>00418                     }
<a name="l00419"></a>00419                 }
<a name="l00420"></a>00420 
<a name="l00421"></a>00421               p_error_per_cell[e_id] += <a class="code" href="classHPSelector.php#a373961932ab7c443072bdd155402fc09">component_scale</a>[var] * 
<a name="l00422"></a>00422                 (*JxW)[qp] * <a class="code" href="libmesh__common_8h.php#af9cdd07341b53cc644199f6aec5e1420">libmesh_norm</a>(value_error);
<a name="l00423"></a>00423               <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00424"></a>00424                 p_error_per_cell[e_id] += <a class="code" href="classHPSelector.php#a373961932ab7c443072bdd155402fc09">component_scale</a>[var] *
<a name="l00425"></a>00425                   (*JxW)[qp] * grad_error.<a class="code" href="classTypeVector.php#a099aac580a3a6fce9276cf5443d0c0e9">size_sq</a>();
<a name="l00426"></a>00426               <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00427"></a>00427                 p_error_per_cell[e_id] += <a class="code" href="classHPSelector.php#a373961932ab7c443072bdd155402fc09">component_scale</a>[var] *
<a name="l00428"></a>00428                   (*JxW)[qp] * hessian_error.<a class="code" href="classTypeTensor.php#a7be64b1de5e558f2de032bde1f881220">size_sq</a>();
<a name="l00429"></a>00429             }
<a name="l00430"></a>00430 
<a name="l00431"></a>00431           <span class="comment">// Calculate this variable&#39;s contribution to the h</span>
<a name="l00432"></a>00432           <span class="comment">// refinement error</span>
<a name="l00433"></a>00433 
<a name="l00434"></a>00434           <span class="keywordflow">if</span> (!elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>())
<a name="l00435"></a>00435             {
<a name="l00436"></a>00436               <span class="comment">// For now, we&#39;ll always start with an h refinement</span>
<a name="l00437"></a>00437               h_error_per_cell[e_id] =
<a name="l00438"></a>00438                 <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;ErrorVectorReal&gt;::max</a>() / 2;
<a name="l00439"></a>00439             }
<a name="l00440"></a>00440           <span class="keywordflow">else</span>
<a name="l00441"></a>00441             {
<a name="l00442"></a>00442               <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FEInterface::inverse_map</a> (dim, fe_type, <a class="code" href="classHPCoarsenTest.php#a26767183e3cffaf2a5163609ca49bfa2">coarse</a>,
<a name="l00443"></a>00443                 *<a class="code" href="classHPCoarsenTest.php#af420f95127d80b01a5377eb6ee99a8f0">xyz_values</a>, <a class="code" href="classHPCoarsenTest.php#a3e94470a1f95887e3a23e38e8da03e6e">coarse_qpoints</a>);
<a name="l00444"></a>00444 
<a name="l00445"></a>00445               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_parent_level = <a class="code" href="classHPCoarsenTest.php#a26767183e3cffaf2a5163609ca49bfa2">coarse</a>-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>();
<a name="l00446"></a>00446               (<span class="keyword">const_cast&lt;</span><a class="code" href="classElem.php">Elem</a> *<span class="keyword">&gt;</span>(<a class="code" href="classHPCoarsenTest.php#a26767183e3cffaf2a5163609ca49bfa2">coarse</a>))-&gt;hack_p_level(elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>());
<a name="l00447"></a>00447 
<a name="l00448"></a>00448               <a class="code" href="classHPCoarsenTest.php#ae4732a527986dea441ab2dd4c7484f11">fe_coarse</a>-&gt;reinit(<a class="code" href="classHPCoarsenTest.php#a26767183e3cffaf2a5163609ca49bfa2">coarse</a>, &amp;<a class="code" href="classHPCoarsenTest.php#a3e94470a1f95887e3a23e38e8da03e6e">coarse_qpoints</a>);
<a name="l00449"></a>00449 
<a name="l00450"></a>00450               (<span class="keyword">const_cast&lt;</span><a class="code" href="classElem.php">Elem</a> *<span class="keyword">&gt;</span>(<a class="code" href="classHPCoarsenTest.php#a26767183e3cffaf2a5163609ca49bfa2">coarse</a>))-&gt;hack_p_level(old_parent_level);
<a name="l00451"></a>00451 
<a name="l00452"></a>00452               <span class="comment">// The number of DOFS on the coarse element</span>
<a name="l00453"></a>00453               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_coarse_dofs = <a class="code" href="classHPCoarsenTest.php#a177f066327658181af79e09d4bf84481">phi_coarse</a>-&gt;size();
<a name="l00454"></a>00454 
<a name="l00455"></a>00455               <span class="comment">// Loop over the quadrature points</span>
<a name="l00456"></a>00456               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;n_qp; qp++)
<a name="l00457"></a>00457                 {
<a name="l00458"></a>00458                   <span class="comment">// The solution difference at the quadrature point</span>
<a name="l00459"></a>00459                   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> value_error = <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>;
<a name="l00460"></a>00460                   <a class="code" href="classVectorValue.php">Gradient</a> grad_error;
<a name="l00461"></a>00461                   <a class="code" href="classTensorValue.php">Tensor</a> hessian_error;
<a name="l00462"></a>00462 
<a name="l00463"></a>00463                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_dofs; ++i)
<a name="l00464"></a>00464                     {
<a name="l00465"></a>00465                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dof_num = <a class="code" href="classHPCoarsenTest.php#a4879f91e0430730fe8739cb64f37ae10">dof_indices</a>[i];
<a name="l00466"></a>00466                       value_error += (*phi)[i][qp] *
<a name="l00467"></a>00467                         system.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(dof_num);
<a name="l00468"></a>00468                       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00469"></a>00469                         grad_error.<a class="code" href="classTypeVector.php#ac9000695cb19991b893cb79a07249e9c">add_scaled</a>((*<a class="code" href="classHPCoarsenTest.php#a1256d4e183100ed13530dcc33d57461d">dphi</a>)[i][qp], system.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(dof_num));
<a name="l00470"></a>00470                         <span class="comment">// grad_error += (*dphi)[i][qp] *</span>
<a name="l00471"></a>00471                         <span class="comment">//  system.current_solution(dof_num);</span>
<a name="l00472"></a>00472                       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00473"></a>00473                         hessian_error.<a class="code" href="classTypeTensor.php#ae24569251bc6ea38090165d349fdfc6c">add_scaled</a>((*<a class="code" href="classHPCoarsenTest.php#a6dd5a9e046b14b458455c55a2807944d">d2phi</a>)[i][qp], system.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(dof_num));
<a name="l00474"></a>00474                         <span class="comment">// hessian_error += (*d2phi)[i][qp] *</span>
<a name="l00475"></a>00475                         <span class="comment">//  system.current_solution(dof_num);</span>
<a name="l00476"></a>00476                     }
<a name="l00477"></a>00477 
<a name="l00478"></a>00478                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_coarse_dofs; ++i)
<a name="l00479"></a>00479                     {
<a name="l00480"></a>00480                       value_error -= (*phi_coarse)[i][qp] * <a class="code" href="classHPCoarsenTest.php#a407febc4f03f4e24c745ea37c0291cf2">Uc</a>(i);
<a name="l00481"></a>00481                       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00482"></a>00482                         <span class="comment">// grad_error -= (*dphi_coarse)[i][qp] * Uc(i);</span>
<a name="l00483"></a>00483                         grad_error.<a class="code" href="classTypeVector.php#a94b16f15ba75d265bf83e9a50d9fd63b">subtract_scaled</a>((*<a class="code" href="classHPCoarsenTest.php#abb7c2fb156e75bc7f89355a49bb32bdb">dphi_coarse</a>)[i][qp], <a class="code" href="classHPCoarsenTest.php#a407febc4f03f4e24c745ea37c0291cf2">Uc</a>(i));
<a name="l00484"></a>00484                       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00485"></a>00485                         hessian_error.<a class="code" href="classTypeTensor.php#a704df2f185a1d7f8db1650680e462eea">subtract_scaled</a>((*<a class="code" href="classHPCoarsenTest.php#afeff2f8fa18b6a138b645e95e2460ffb">d2phi_coarse</a>)[i][qp], <a class="code" href="classHPCoarsenTest.php#a407febc4f03f4e24c745ea37c0291cf2">Uc</a>(i));
<a name="l00486"></a>00486                         <span class="comment">// hessian_error -= (*d2phi_coarse)[i][qp] * Uc(i);</span>
<a name="l00487"></a>00487                     }
<a name="l00488"></a>00488 
<a name="l00489"></a>00489                   h_error_per_cell[e_id] += <a class="code" href="classHPSelector.php#a373961932ab7c443072bdd155402fc09">component_scale</a>[var] * 
<a name="l00490"></a>00490                     (*JxW)[qp] * <a class="code" href="libmesh__common_8h.php#af9cdd07341b53cc644199f6aec5e1420">libmesh_norm</a>(value_error);
<a name="l00491"></a>00491                   <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00492"></a>00492                     h_error_per_cell[e_id] += <a class="code" href="classHPSelector.php#a373961932ab7c443072bdd155402fc09">component_scale</a>[var] * 
<a name="l00493"></a>00493                       (*JxW)[qp] * grad_error.<a class="code" href="classTypeVector.php#a099aac580a3a6fce9276cf5443d0c0e9">size_sq</a>();
<a name="l00494"></a>00494                   <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00495"></a>00495                     h_error_per_cell[e_id] += <a class="code" href="classHPSelector.php#a373961932ab7c443072bdd155402fc09">component_scale</a>[var] * 
<a name="l00496"></a>00496                       (*JxW)[qp] * hessian_error.<a class="code" href="classTypeTensor.php#a7be64b1de5e558f2de032bde1f881220">size_sq</a>();
<a name="l00497"></a>00497                 }
<a name="l00498"></a>00498 
<a name="l00499"></a>00499             }
<a name="l00500"></a>00500         }
<a name="l00501"></a>00501     }
<a name="l00502"></a>00502 
<a name="l00503"></a>00503   <span class="comment">// Now that we&#39;ve got our approximations for p_error and h_error, let&#39;s see</span>
<a name="l00504"></a>00504   <span class="comment">// if we want to switch any h refinement flags to p refinement</span>
<a name="l00505"></a>00505 
<a name="l00506"></a>00506   <span class="comment">// Iterate over all the active elements in the mesh</span>
<a name="l00507"></a>00507   <span class="comment">// that live on this processor.</span>
<a name="l00508"></a>00508 
<a name="l00509"></a>00509   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       elem_it  =
<a name="l00510"></a>00510                   mesh.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00511"></a>00511   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> elem_end =
<a name="l00512"></a>00512                   mesh.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>(); 
<a name="l00513"></a>00513 
<a name="l00514"></a>00514   <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00515"></a>00515     {
<a name="l00516"></a>00516       <a class="code" href="classElem.php">Elem</a>* elem = *elem_it;
<a name="l00517"></a>00517 
<a name="l00518"></a>00518       <span class="comment">// We&#39;re only checking elements that are already flagged for h</span>
<a name="l00519"></a>00519       <span class="comment">// refinement</span>
<a name="l00520"></a>00520       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() != <a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>)
<a name="l00521"></a>00521         <span class="keywordflow">continue</span>;
<a name="l00522"></a>00522 
<a name="l00523"></a>00523       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e_id = elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l00524"></a>00524 
<a name="l00525"></a>00525       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dofs_per_elem = 0, dofs_per_p_elem = 0;
<a name="l00526"></a>00526 
<a name="l00527"></a>00527       <span class="comment">// Loop over all the variables in the system</span>
<a name="l00528"></a>00528       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;n_vars; var++)
<a name="l00529"></a>00529         {
<a name="l00530"></a>00530           <span class="comment">// The type of finite element to use for this variable</span>
<a name="l00531"></a>00531           <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_type = dof_map.<a class="code" href="classDofMap.php#ae3c63266417020f38af6e5cc40efca76">variable_type</a> (var);
<a name="l00532"></a>00532 
<a name="l00533"></a>00533           <span class="comment">// FIXME: we&#39;re overestimating the number of DOFs added by h</span>
<a name="l00534"></a>00534           <span class="comment">// refinement</span>
<a name="l00535"></a>00535           <a class="code" href="classFEType.php">FEType</a> elem_fe_type = fe_type;
<a name="l00536"></a>00536           elem_fe_type.<a class="code" href="classFEType.php#a72c29a6dbf3f2a84728111122cec4742">order</a> =
<a name="l00537"></a>00537             <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(fe_type.<a class="code" href="classFEType.php#a72c29a6dbf3f2a84728111122cec4742">order</a> + elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>());
<a name="l00538"></a>00538           dofs_per_elem += 
<a name="l00539"></a>00539             <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FEInterface::n_dofs</a>(dim, elem_fe_type, elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>());
<a name="l00540"></a>00540 
<a name="l00541"></a>00541           elem_fe_type.<a class="code" href="classFEType.php#a72c29a6dbf3f2a84728111122cec4742">order</a> =
<a name="l00542"></a>00542             <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(fe_type.<a class="code" href="classFEType.php#a72c29a6dbf3f2a84728111122cec4742">order</a> + elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>() + 1);
<a name="l00543"></a>00543           dofs_per_p_elem += 
<a name="l00544"></a>00544             <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FEInterface::n_dofs</a>(dim, elem_fe_type, elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>());
<a name="l00545"></a>00545         }
<a name="l00546"></a>00546 
<a name="l00547"></a>00547       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_h_dofs = dofs_per_elem *
<a name="l00548"></a>00548         (elem-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>() - 1);
<a name="l00549"></a>00549 
<a name="l00550"></a>00550       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_p_dofs = dofs_per_p_elem -
<a name="l00551"></a>00551         dofs_per_elem;
<a name="l00552"></a>00552       
<a name="l00553"></a>00553 std::cerr &lt;&lt; <span class="stringliteral">&quot;Cell &quot;</span> &lt;&lt; e_id &lt;&lt; <span class="stringliteral">&quot;: h = &quot;</span> &lt;&lt; elem-&gt;<a class="code" href="classElem.php#aed45dccf181d13107eab2c2947d1afe6">hmax</a>()
<a name="l00554"></a>00554           &lt;&lt; <span class="stringliteral">&quot;, p = &quot;</span> &lt;&lt; elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>() + 1 &lt;&lt; <span class="stringliteral">&quot;,&quot;</span> &lt;&lt; std::endl 
<a name="l00555"></a>00555           &lt;&lt; <span class="stringliteral">&quot;     h_error = &quot;</span> &lt;&lt; h_error_per_cell[e_id] 
<a name="l00556"></a>00556           &lt;&lt; <span class="stringliteral">&quot;, p_error = &quot;</span> &lt;&lt; p_error_per_cell[e_id] &lt;&lt; std::endl
<a name="l00557"></a>00557           &lt;&lt; <span class="stringliteral">&quot;     new_h_dofs = &quot;</span> &lt;&lt; new_h_dofs
<a name="l00558"></a>00558           &lt;&lt; <span class="stringliteral">&quot;, new_p_dofs = &quot;</span> &lt;&lt; new_p_dofs &lt;&lt; std::endl;
<a name="l00559"></a>00559         
<a name="l00560"></a>00560       <span class="keywordflow">if</span> ((std::sqrt(p_error_per_cell[e_id]) * <a class="code" href="classHPCoarsenTest.php#af449fad3ef5e37d2749e5e21d19c6606">p_weight</a> / new_p_dofs) 
<a name="l00561"></a>00561           &gt; (std::sqrt(h_error_per_cell[e_id]) / new_h_dofs))
<a name="l00562"></a>00562 <span class="comment">/*</span>
<a name="l00563"></a>00563 <span class="comment">      if (std::sqrt(p_error_per_cell[e_id]) * p_weight</span>
<a name="l00564"></a>00564 <span class="comment">          &gt; std::sqrt(h_error_per_cell[e_id]))</span>
<a name="l00565"></a>00565 <span class="comment">*/</span>
<a name="l00566"></a>00566         {
<a name="l00567"></a>00567           elem-&gt;<a class="code" href="classElem.php#a40b62e384088baa756c3481b6631d7c4">set_p_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>);
<a name="l00568"></a>00568 <span class="comment">//          elem-&gt;set_refinement_flag(Elem::COARSEN);</span>
<a name="l00569"></a>00569           elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a3bc34bb09879a3388ad735a75317b3c3">Elem::DO_NOTHING</a>);
<a name="l00570"></a>00570         }
<a name="l00571"></a>00571     }
<a name="l00572"></a>00572 
<a name="l00573"></a>00573   STOP_LOG(<span class="stringliteral">&quot;select_refinement()&quot;</span>, <span class="stringliteral">&quot;HPCoarsenTest&quot;</span>);
<a name="l00574"></a>00574 }
<a name="l00575"></a>00575 
<a name="l00576"></a>00576 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
