<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>hp_coarsentest.h</h1>  </div>
</div>
<div class="contents">
<a href="hp__coarsentest_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: hp_coarsentest.h 3502 2009-10-20 18:06:50Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __hp_coarsentest_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __hp_coarsentest_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;auto_ptr.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="hp__selector_8h.php">hp_selector.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;fe.h&quot;</span>         <span class="comment">// MipsPro requires fe.h and quadrature.h in order to</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;quadrature.h&quot;</span> <span class="comment">//  delete AutoPtrs&lt;&gt; upon destruction</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span>
<a name="l00040"></a>00040 <span class="comment">// Forward Declarations</span>
<a name="l00041"></a>00041 <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00042"></a>00042 <span class="keyword">class </span><a class="code" href="classPoint.php">Point</a>;
<a name="l00043"></a>00043 <span class="keyword">class </span><a class="code" href="classSystem.php">System</a>;
<a name="l00044"></a>00044 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classTensorValue.php">TensorValue</a>;
<a name="l00045"></a><a class="code" href="hp__coarsentest_8h.php#a70438a9d2ae50d73d33da5b97391d6f9">00045</a> <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classVectorValue.php">VectorValue</a>;
<a name="l00046"></a>00046 <span class="keyword">typedef</span> <a class="code" href="classVectorValue.php">VectorValue&lt;Real&gt;</a> <a class="code" href="hp__coarsentest_8h.php#a70438a9d2ae50d73d33da5b97391d6f9">RealVectorValue</a>;
<a name="l00047"></a><a class="code" href="hp__coarsentest_8h.php#a499caa6b15ec36e1d2c629cc1e5964da">00047</a> <span class="keyword">typedef</span> <a class="code" href="classTensorValue.php">TensorValue&lt;Real&gt;</a> <a class="code" href="hp__coarsentest_8h.php#a499caa6b15ec36e1d2c629cc1e5964da">RealTensorValue</a>;
<a name="l00048"></a><a class="code" href="hp__coarsentest_8h.php#ac658ced7e2c274a1648a3d903bc3868b">00048</a> <span class="keyword">typedef</span> <a class="code" href="classVectorValue.php">RealVectorValue</a> <a class="code" href="hp__coarsentest_8h.php#ac658ced7e2c274a1648a3d903bc3868b">RealGradient</a>;
<a name="l00049"></a><a class="code" href="hp__coarsentest_8h.php#a3a9777da3ebb79b68fd82a40cfd0eaa8">00049</a> <span class="keyword">typedef</span> <a class="code" href="classTensorValue.php">RealTensorValue</a> <a class="code" href="hp__coarsentest_8h.php#a3a9777da3ebb79b68fd82a40cfd0eaa8">RealTensor</a>;
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00065"></a><a class="code" href="classHPCoarsenTest.php">00065</a> <span class="keyword">class </span><a class="code" href="classHPCoarsenTest.php">HPCoarsenTest</a> : <span class="keyword">public</span> <a class="code" href="classHPSelector.php">HPSelector</a>
<a name="l00066"></a>00066 {
<a name="l00067"></a>00067 <span class="keyword">public</span>:
<a name="l00068"></a>00068 
<a name="l00072"></a><a class="code" href="classHPCoarsenTest.php#a4d552cd6aaff31a15909db2067a03000">00072</a>   <a class="code" href="classHPCoarsenTest.php#a4d552cd6aaff31a15909db2067a03000">HPCoarsenTest</a>() : <a class="code" href="classHPCoarsenTest.php#af449fad3ef5e37d2749e5e21d19c6606">p_weight</a>(1.0) 
<a name="l00073"></a>00073   {
<a name="l00074"></a>00074     libmesh_experimental();
<a name="l00075"></a>00075   }
<a name="l00076"></a>00076   
<a name="l00080"></a><a class="code" href="classHPCoarsenTest.php#abd9599cb0569d3452a85107422b5a10c">00080</a>   <span class="keyword">virtual</span> <a class="code" href="classHPCoarsenTest.php#abd9599cb0569d3452a85107422b5a10c">~HPCoarsenTest</a>() {}
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00089"></a>00089   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classHPCoarsenTest.php#ac875819213df42aa447eeac0de8f5f2c">select_refinement</a> (<a class="code" href="classSystem.php">System</a>&amp; system);
<a name="l00090"></a>00090 
<a name="l00095"></a><a class="code" href="classHPCoarsenTest.php#af449fad3ef5e37d2749e5e21d19c6606">00095</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classHPCoarsenTest.php#af449fad3ef5e37d2749e5e21d19c6606">p_weight</a>;
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 <span class="keyword">protected</span>:
<a name="l00102"></a>00102   <span class="keywordtype">void</span> <a class="code" href="classHPCoarsenTest.php#ad47acc536e27d3c2c6acf4511e60d1c4">add_projection</a>(<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp;, <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var);
<a name="l00103"></a>00103 
<a name="l00107"></a><a class="code" href="classHPCoarsenTest.php#a26767183e3cffaf2a5163609ca49bfa2">00107</a>   <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *<a class="code" href="classHPCoarsenTest.php#a26767183e3cffaf2a5163609ca49bfa2">coarse</a>;
<a name="l00108"></a>00108 
<a name="l00112"></a><a class="code" href="classHPCoarsenTest.php#a4879f91e0430730fe8739cb64f37ae10">00112</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classHPCoarsenTest.php#a4879f91e0430730fe8739cb64f37ae10">dof_indices</a>;
<a name="l00113"></a>00113 
<a name="l00117"></a><a class="code" href="classHPCoarsenTest.php#ae4732a527986dea441ab2dd4c7484f11">00117</a>   <a class="code" href="classAutoPtr.php">AutoPtr&lt;FEBase&gt;</a> <a class="code" href="classHPCoarsenTest.php#a02771777ce64a43513557e2696a47b81">fe</a>, <a class="code" href="classHPCoarsenTest.php#ae4732a527986dea441ab2dd4c7484f11">fe_coarse</a>;
<a name="l00118"></a>00118 
<a name="l00122"></a><a class="code" href="classHPCoarsenTest.php#a177f066327658181af79e09d4bf84481">00122</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt; *<a class="code" href="classHPCoarsenTest.php#adf0ff4e18d15821d102955e00f45a579">phi</a>, *<a class="code" href="classHPCoarsenTest.php#a177f066327658181af79e09d4bf84481">phi_coarse</a>;
<a name="l00123"></a><a class="code" href="classHPCoarsenTest.php#abb7c2fb156e75bc7f89355a49bb32bdb">00123</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt; *<a class="code" href="classHPCoarsenTest.php#a1256d4e183100ed13530dcc33d57461d">dphi</a>, *<a class="code" href="classHPCoarsenTest.php#abb7c2fb156e75bc7f89355a49bb32bdb">dphi_coarse</a>;
<a name="l00124"></a><a class="code" href="classHPCoarsenTest.php#afeff2f8fa18b6a138b645e95e2460ffb">00124</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealTensor&gt; &gt; *<a class="code" href="classHPCoarsenTest.php#a6dd5a9e046b14b458455c55a2807944d">d2phi</a>, *<a class="code" href="classHPCoarsenTest.php#afeff2f8fa18b6a138b645e95e2460ffb">d2phi_coarse</a>;
<a name="l00125"></a>00125 
<a name="l00129"></a><a class="code" href="classHPCoarsenTest.php#a004140a7e706fb9a9e00aa9ef9493858">00129</a>   <span class="keyword">const</span> std::vector&lt;Real&gt; *<a class="code" href="classHPCoarsenTest.php#a004140a7e706fb9a9e00aa9ef9493858">JxW</a>;
<a name="l00130"></a>00130 
<a name="l00134"></a><a class="code" href="classHPCoarsenTest.php#af420f95127d80b01a5377eb6ee99a8f0">00134</a>   <span class="keyword">const</span> std::vector&lt;Point&gt; *<a class="code" href="classHPCoarsenTest.php#af420f95127d80b01a5377eb6ee99a8f0">xyz_values</a>;
<a name="l00135"></a><a class="code" href="classHPCoarsenTest.php#a3e94470a1f95887e3a23e38e8da03e6e">00135</a>   std::vector&lt;Point&gt; <a class="code" href="classHPCoarsenTest.php#a3e94470a1f95887e3a23e38e8da03e6e">coarse_qpoints</a>;
<a name="l00136"></a>00136 
<a name="l00140"></a><a class="code" href="classHPCoarsenTest.php#ade5173316fcd1b1211fb3c4d91ceffc2">00140</a>   <a class="code" href="classAutoPtr.php">AutoPtr&lt;QBase&gt;</a> <a class="code" href="classHPCoarsenTest.php#ade5173316fcd1b1211fb3c4d91ceffc2">qrule</a>;
<a name="l00141"></a>00141 
<a name="l00145"></a><a class="code" href="classHPCoarsenTest.php#ac6806220b069655e05a6ba34bf9a636f">00145</a>   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Number&gt;</a> <a class="code" href="classHPCoarsenTest.php#ac6806220b069655e05a6ba34bf9a636f">Ke</a>;
<a name="l00146"></a><a class="code" href="classHPCoarsenTest.php#ac619342911166d12715917f07872b210">00146</a>   <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classHPCoarsenTest.php#ac619342911166d12715917f07872b210">Fe</a>;
<a name="l00151"></a><a class="code" href="classHPCoarsenTest.php#a407febc4f03f4e24c745ea37c0291cf2">00151</a>   <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classHPCoarsenTest.php#a407febc4f03f4e24c745ea37c0291cf2">Uc</a>;
<a name="l00152"></a><a class="code" href="classHPCoarsenTest.php#a83ddbb436c00d8985689944f6eb639bb">00152</a>   <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classHPCoarsenTest.php#a83ddbb436c00d8985689944f6eb639bb">Up</a>;
<a name="l00153"></a>00153 };
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00156"></a>00156 <span class="preprocessor"></span>
<a name="l00157"></a>00157 <span class="preprocessor">#endif</span>
<a name="l00158"></a>00158 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
