<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_f10759d5ac6297fe611079c3c15b8f2c.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>hp_singular.C</h1>  </div>
</div>
<div class="contents">
<a href="hp__singular_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: hp_singular.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// C++ includes</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local Includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;hp_singular.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;mesh.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;system.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00032"></a>00032 <span class="comment">// HPSingularity implementations</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a><a class="code" href="classHPSingularity.php#a3e615e03cb62556035b6316b9b3e0b40">00035</a> <span class="keywordtype">void</span> <a class="code" href="classHPSingularity.php#a3e615e03cb62556035b6316b9b3e0b40">HPSingularity::select_refinement</a> (<a class="code" href="classSystem.php">System</a> &amp;system)
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037   START_LOG(<span class="stringliteral">&quot;select_refinement()&quot;</span>, <span class="stringliteral">&quot;HPSingularity&quot;</span>);
<a name="l00038"></a>00038 
<a name="l00039"></a>00039   <span class="comment">// The current mesh</span>
<a name="l00040"></a>00040   <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh = system.<a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">get_mesh</a>();
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  =
<a name="l00043"></a>00043     mesh.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00044"></a>00044   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end =
<a name="l00045"></a>00045     mesh.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>(); 
<a name="l00046"></a>00046 
<a name="l00047"></a>00047   <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00048"></a>00048     {
<a name="l00049"></a>00049       <a class="code" href="classElem.php">Elem</a>* elem = *elem_it;
<a name="l00050"></a>00050 
<a name="l00051"></a>00051       <span class="comment">// We&#39;re only checking elements that are already flagged for h</span>
<a name="l00052"></a>00052       <span class="comment">// refinement</span>
<a name="l00053"></a>00053       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() != <a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>)
<a name="l00054"></a>00054         <span class="keywordflow">continue</span>;
<a name="l00055"></a>00055 
<a name="l00056"></a>00056       elem-&gt;<a class="code" href="classElem.php#a40b62e384088baa756c3481b6631d7c4">set_p_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>);
<a name="l00057"></a>00057       elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a3bc34bb09879a3388ad735a75317b3c3">Elem::DO_NOTHING</a>);
<a name="l00058"></a>00058 
<a name="l00059"></a>00059       <span class="keywordflow">for</span> (std::list&lt;Point&gt;::iterator ppoint =
<a name="l00060"></a>00060              <a class="code" href="classHPSingularity.php#a00282c3f49533924864027fe0ebf56c5">singular_points</a>.begin();
<a name="l00061"></a>00061            ppoint != <a class="code" href="classHPSingularity.php#a00282c3f49533924864027fe0ebf56c5">singular_points</a>.end(); ++ppoint)
<a name="l00062"></a>00062         {
<a name="l00063"></a>00063           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#ace5226376cf53804d20073a0d21b0cbc">contains_point</a>(*ppoint))
<a name="l00064"></a>00064             {
<a name="l00065"></a>00065               elem-&gt;<a class="code" href="classElem.php#a40b62e384088baa756c3481b6631d7c4">set_p_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a3bc34bb09879a3388ad735a75317b3c3">Elem::DO_NOTHING</a>);
<a name="l00066"></a>00066               elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>);
<a name="l00067"></a>00067               <span class="keywordflow">break</span>;
<a name="l00068"></a>00068             }
<a name="l00069"></a>00069         }
<a name="l00070"></a>00070     }
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   STOP_LOG(<span class="stringliteral">&quot;select_refinement()&quot;</span>, <span class="stringliteral">&quot;HPSingularity&quot;</span>);
<a name="l00073"></a>00073 }
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
