<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_60be1125a39495b698d2d56e8e5b50b1.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>implicit_system.C</h1>  </div>
</div>
<div class="contents">
<a href="implicit__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: implicit_system.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;implicit_system.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;sparse_matrix.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;dof_map.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;mesh.h&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00032"></a>00032 <span class="comment">// ImplicitSystem implementation</span>
<a name="l00033"></a><a class="code" href="classImplicitSystem.php#ab30be02609452092da5d44b2fc950458">00033</a> <a class="code" href="classImplicitSystem.php#ab30be02609452092da5d44b2fc950458">ImplicitSystem::ImplicitSystem</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00034"></a>00034                                 <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00035"></a>00035                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :
<a name="l00036"></a>00036   
<a name="l00037"></a>00037   <a class="code" href="classSystem.php">Parent</a>            (es, name, number),
<a name="l00038"></a>00038   matrix            (NULL),
<a name="l00039"></a>00039   _can_add_matrices (true)
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041 }
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a><a class="code" href="classImplicitSystem.php#a813f4466bb5f24a35f81edbf0c3b3337">00045</a> <a class="code" href="classImplicitSystem.php#a813f4466bb5f24a35f81edbf0c3b3337">ImplicitSystem::~ImplicitSystem</a> ()
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047   <span class="comment">// Clear data</span>
<a name="l00048"></a>00048   this-&gt;<a class="code" href="classImplicitSystem.php#aaec0524bd164ab907129805835809f77">clear</a>();
<a name="l00049"></a>00049 }
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a><a class="code" href="classImplicitSystem.php#aaec0524bd164ab907129805835809f77">00053</a> <span class="keywordtype">void</span> <a class="code" href="classImplicitSystem.php#aaec0524bd164ab907129805835809f77">ImplicitSystem::clear</a> ()
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055   <span class="comment">// clear the parent data</span>
<a name="l00056"></a>00056   <a class="code" href="classExplicitSystem.php#a86b23fe483bba238c2f2c68b7c2a953a">Parent::clear</a>();
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <span class="comment">// clear any user-added matrices</span>
<a name="l00059"></a>00059   {
<a name="l00060"></a>00060     <span class="keywordflow">for</span> (<a class="code" href="classImplicitSystem.php#ae5b4d4fad0ff1b3dd813cdd653055715">matrices_iterator</a> pos = <a class="code" href="classImplicitSystem.php#a3b47fab354ef32701dc1d91ff39c17f0">_matrices</a>.begin();
<a name="l00061"></a>00061          pos != <a class="code" href="classImplicitSystem.php#a3b47fab354ef32701dc1d91ff39c17f0">_matrices</a>.end(); ++pos)
<a name="l00062"></a>00062       {
<a name="l00063"></a>00063         pos-&gt;second-&gt;clear ();
<a name="l00064"></a>00064         <span class="keyword">delete</span> pos-&gt;second;
<a name="l00065"></a>00065         pos-&gt;second = NULL;
<a name="l00066"></a>00066       }
<a name="l00067"></a>00067 
<a name="l00068"></a>00068     <a class="code" href="classImplicitSystem.php#a3b47fab354ef32701dc1d91ff39c17f0">_matrices</a>.clear();
<a name="l00069"></a>00069     <a class="code" href="classImplicitSystem.php#a9bafa79222951213fef7203492d94877">_can_add_matrices</a> = <span class="keyword">true</span>;
<a name="l00070"></a>00070   }
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   <span class="comment">// NULL the matrix.</span>
<a name="l00073"></a>00073   <a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a> = NULL;
<a name="l00074"></a>00074 }
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00078"></a><a class="code" href="classImplicitSystem.php#a98ef29b55b9c0f64e7a07a94276f6c57">00078</a> <span class="keywordtype">void</span> <a class="code" href="classImplicitSystem.php#a98ef29b55b9c0f64e7a07a94276f6c57">ImplicitSystem::init_data</a> ()
<a name="l00079"></a>00079 {
<a name="l00080"></a>00080   <span class="comment">// initialize parent data</span>
<a name="l00081"></a>00081   <a class="code" href="classExplicitSystem.php#a4b9e0459e6889ba4a9fe352055b01af8">Parent::init_data</a>();
<a name="l00082"></a>00082 
<a name="l00083"></a>00083   <span class="comment">// Add the system matrix.</span>
<a name="l00084"></a>00084   this-&gt;<a class="code" href="classImplicitSystem.php#accf6fbac46429c7588043fb9267e3cf4">add_system_matrix</a> ();
<a name="l00085"></a>00085   
<a name="l00086"></a>00086   <span class="comment">// Initialize the matrices for the system</span>
<a name="l00087"></a>00087   this-&gt;<a class="code" href="classImplicitSystem.php#ae0f7f60ad2fade152838de233466aabb">init_matrices</a> ();
<a name="l00088"></a>00088 }
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 
<a name="l00092"></a><a class="code" href="classImplicitSystem.php#ae0f7f60ad2fade152838de233466aabb">00092</a> <span class="keywordtype">void</span> <a class="code" href="classImplicitSystem.php#ae0f7f60ad2fade152838de233466aabb">ImplicitSystem::init_matrices</a> ()
<a name="l00093"></a>00093 {
<a name="l00094"></a>00094   libmesh_assert (<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a> != NULL);
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   <span class="comment">// Check for quick return in case the system matrix</span>
<a name="l00097"></a>00097   <span class="comment">// (and by extension all the matrices) has already</span>
<a name="l00098"></a>00098   <span class="comment">// been initialized</span>
<a name="l00099"></a>00099   <span class="keywordflow">if</span> (<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>-&gt;<a class="code" href="classSparseMatrix.php#a5859dbbdc5266472541839b5dc4b0768">initialized</a>())
<a name="l00100"></a>00100     <span class="keywordflow">return</span>;
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   <span class="comment">// Get a reference to the DofMap</span>
<a name="l00103"></a>00103   <a class="code" href="classDofMap.php">DofMap</a>&amp; dof_map = this-&gt;<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>();
<a name="l00104"></a>00104   
<a name="l00105"></a>00105   <span class="comment">// no chance to add other matrices</span>
<a name="l00106"></a>00106   <a class="code" href="classImplicitSystem.php#a9bafa79222951213fef7203492d94877">_can_add_matrices</a> = <span class="keyword">false</span>;
<a name="l00107"></a>00107   
<a name="l00108"></a>00108   <span class="comment">// Tell the matrices about the dof map, and vice versa</span>
<a name="l00109"></a>00109   <span class="keywordflow">for</span> (<a class="code" href="classImplicitSystem.php#ae5b4d4fad0ff1b3dd813cdd653055715">matrices_iterator</a> pos = <a class="code" href="classImplicitSystem.php#a3b47fab354ef32701dc1d91ff39c17f0">_matrices</a>.begin();
<a name="l00110"></a>00110        pos != <a class="code" href="classImplicitSystem.php#a3b47fab354ef32701dc1d91ff39c17f0">_matrices</a>.end(); ++pos)
<a name="l00111"></a>00111     {
<a name="l00112"></a>00112       libmesh_assert (!pos-&gt;second-&gt;initialized());
<a name="l00113"></a>00113       dof_map.<a class="code" href="classDofMap.php#abf8a314c9f21240129e140664d04ed53">attach_matrix</a> (*(pos-&gt;second));
<a name="l00114"></a>00114     }
<a name="l00115"></a>00115   
<a name="l00116"></a>00116   <span class="comment">// Compute the sparsity pattern for the current</span>
<a name="l00117"></a>00117   <span class="comment">// mesh and DOF distribution.  This also updates</span>
<a name="l00118"></a>00118   <span class="comment">// additional matrices, \p DofMap now knows them</span>
<a name="l00119"></a>00119   dof_map.<a class="code" href="classDofMap.php#ab51821ee7bdb1c6fb8f92821afea2530">compute_sparsity</a> (this-&gt;<a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">get_mesh</a>());
<a name="l00120"></a>00120   
<a name="l00121"></a>00121   <span class="comment">// Initialize matrices</span>
<a name="l00122"></a>00122   <span class="keywordflow">for</span> (<a class="code" href="classImplicitSystem.php#ae5b4d4fad0ff1b3dd813cdd653055715">matrices_iterator</a> pos = <a class="code" href="classImplicitSystem.php#a3b47fab354ef32701dc1d91ff39c17f0">_matrices</a>.begin(); 
<a name="l00123"></a>00123        pos != <a class="code" href="classImplicitSystem.php#a3b47fab354ef32701dc1d91ff39c17f0">_matrices</a>.end(); ++pos)
<a name="l00124"></a>00124     pos-&gt;second-&gt;init ();
<a name="l00125"></a>00125   
<a name="l00126"></a>00126   <span class="comment">// Set the additional matrices to 0.</span>
<a name="l00127"></a>00127   <span class="keywordflow">for</span> (<a class="code" href="classImplicitSystem.php#ae5b4d4fad0ff1b3dd813cdd653055715">matrices_iterator</a> pos = <a class="code" href="classImplicitSystem.php#a3b47fab354ef32701dc1d91ff39c17f0">_matrices</a>.begin(); 
<a name="l00128"></a>00128        pos != <a class="code" href="classImplicitSystem.php#a3b47fab354ef32701dc1d91ff39c17f0">_matrices</a>.end(); ++pos)
<a name="l00129"></a>00129     pos-&gt;second-&gt;zero ();
<a name="l00130"></a>00130 }
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a><a class="code" href="classImplicitSystem.php#a292ff27cdaef1d65974cad561ad1beed">00134</a> <span class="keywordtype">void</span> <a class="code" href="classImplicitSystem.php#a292ff27cdaef1d65974cad561ad1beed">ImplicitSystem::reinit</a> ()
<a name="l00135"></a>00135 {
<a name="l00136"></a>00136   <span class="comment">// initialize parent data</span>
<a name="l00137"></a>00137   <a class="code" href="classExplicitSystem.php#aedfc96903651e6f6e2d7cb347ec43c9f">Parent::reinit</a>();  
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   <span class="comment">// Clear the matrices</span>
<a name="l00140"></a>00140   <span class="keywordflow">for</span> (<a class="code" href="classImplicitSystem.php#ae5b4d4fad0ff1b3dd813cdd653055715">matrices_iterator</a> pos = <a class="code" href="classImplicitSystem.php#a3b47fab354ef32701dc1d91ff39c17f0">_matrices</a>.begin();
<a name="l00141"></a>00141        pos != <a class="code" href="classImplicitSystem.php#a3b47fab354ef32701dc1d91ff39c17f0">_matrices</a>.end(); ++pos)
<a name="l00142"></a>00142     pos-&gt;second-&gt;clear();
<a name="l00143"></a>00143 
<a name="l00144"></a>00144   <span class="comment">// Re-initialize the matrices</span>
<a name="l00145"></a>00145   this-&gt;<a class="code" href="classImplicitSystem.php#ae0f7f60ad2fade152838de233466aabb">init_matrices</a> ();
<a name="l00146"></a>00146 }
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00150"></a><a class="code" href="classImplicitSystem.php#a87a6ebda725c6f44293dcd4d2f69f9de">00150</a> <span class="keywordtype">void</span> <a class="code" href="classImplicitSystem.php#a87a6ebda725c6f44293dcd4d2f69f9de">ImplicitSystem::assemble</a> ()
<a name="l00151"></a>00151 {
<a name="l00152"></a>00152   libmesh_assert (<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a> != NULL);
<a name="l00153"></a>00153   libmesh_assert (<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>-&gt;<a class="code" href="classSparseMatrix.php#a5859dbbdc5266472541839b5dc4b0768">initialized</a>());
<a name="l00154"></a>00154   libmesh_assert (<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>    != NULL);
<a name="l00155"></a>00155   libmesh_assert (<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>-&gt;<a class="code" href="classNumericVector.php#a43085d102bac085751371d1a94b5dea9">initialized</a>());
<a name="l00156"></a>00156 
<a name="l00157"></a>00157   <span class="comment">// The user assembly gets to expect to accumulate on an initially</span>
<a name="l00158"></a>00158   <span class="comment">// empty system</span>
<a name="l00159"></a>00159   <a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>-&gt;<a class="code" href="classSparseMatrix.php#ac9c04c5748478399f1eff3f337a7e647">zero</a> ();
<a name="l00160"></a>00160   <a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>-&gt;<a class="code" href="classNumericVector.php#a21ca80e20b0f88490c8f0d5298d47bef">zero</a> ();
<a name="l00161"></a>00161 
<a name="l00162"></a>00162   <span class="comment">// Call the base class assemble function</span>
<a name="l00163"></a>00163   <a class="code" href="classSystem.php#abca899f8ae44d10c606fe28b5e8420dd">Parent::assemble</a> ();
<a name="l00164"></a>00164 }
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 
<a name="l00168"></a><a class="code" href="classImplicitSystem.php#acad3dc8b26c91f6c82c3e9708a1dc2e1">00168</a> <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;Number&gt;</a> &amp; <a class="code" href="classImplicitSystem.php#acad3dc8b26c91f6c82c3e9708a1dc2e1">ImplicitSystem::add_matrix</a> (<span class="keyword">const</span> std::string&amp; mat_name)
<a name="l00169"></a>00169 {
<a name="l00170"></a>00170   <span class="comment">// only add matrices before initializing...</span>
<a name="l00171"></a>00171   <span class="keywordflow">if</span> (!<a class="code" href="classImplicitSystem.php#a9bafa79222951213fef7203492d94877">_can_add_matrices</a>)
<a name="l00172"></a>00172     {
<a name="l00173"></a>00173       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Too late.  Cannot add matrices to the system after initialization&quot;</span>
<a name="l00174"></a>00174                 &lt;&lt; std::endl
<a name="l00175"></a>00175                 &lt;&lt; <span class="stringliteral">&quot; any more.  You should have done this earlier.&quot;</span>
<a name="l00176"></a>00176                 &lt;&lt; std::endl;
<a name="l00177"></a>00177       libmesh_error();
<a name="l00178"></a>00178     }
<a name="l00179"></a>00179 
<a name="l00180"></a>00180   <span class="comment">// Return the matrix if it is already there.</span>
<a name="l00181"></a>00181   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classImplicitSystem.php#aa23d50b0a898aaee758d4a98c996a4df">have_matrix</a>(mat_name))
<a name="l00182"></a>00182     <span class="keywordflow">return</span> *(<a class="code" href="classImplicitSystem.php#a3b47fab354ef32701dc1d91ff39c17f0">_matrices</a>[mat_name]);
<a name="l00183"></a>00183 
<a name="l00184"></a>00184   <span class="comment">// Otherwise build the matrix and return it.</span>
<a name="l00185"></a>00185   <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* buf = <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;Number&gt;::build</a>().release();
<a name="l00186"></a>00186   <a class="code" href="classImplicitSystem.php#a3b47fab354ef32701dc1d91ff39c17f0">_matrices</a>.insert (std::make_pair (mat_name, buf));
<a name="l00187"></a>00187 
<a name="l00188"></a>00188   <span class="keywordflow">return</span> *buf;
<a name="l00189"></a>00189 }
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 
<a name="l00193"></a><a class="code" href="classImplicitSystem.php#a719365410b024d2ddab0b1bada55753d">00193</a> <span class="keyword">const</span> <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;Number&gt;</a> &amp; <a class="code" href="classImplicitSystem.php#a719365410b024d2ddab0b1bada55753d">ImplicitSystem::get_matrix</a> (<span class="keyword">const</span> std::string&amp; mat_name)<span class="keyword"> const</span>
<a name="l00194"></a>00194 <span class="keyword"></span>{
<a name="l00195"></a>00195   <span class="comment">// Make sure the matrix exists</span>
<a name="l00196"></a>00196   <a class="code" href="classImplicitSystem.php#ad2ce7333960518e290f15ee47eb98ea6">const_matrices_iterator</a> pos = <a class="code" href="classImplicitSystem.php#a3b47fab354ef32701dc1d91ff39c17f0">_matrices</a>.find (mat_name);
<a name="l00197"></a>00197   
<a name="l00198"></a>00198   <span class="keywordflow">if</span> (pos == <a class="code" href="classImplicitSystem.php#a3b47fab354ef32701dc1d91ff39c17f0">_matrices</a>.end())
<a name="l00199"></a>00199     {
<a name="l00200"></a>00200       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: matrix &quot;</span>
<a name="l00201"></a>00201                 &lt;&lt; mat_name
<a name="l00202"></a>00202                 &lt;&lt; <span class="stringliteral">&quot; does not exist in this system!&quot;</span>
<a name="l00203"></a>00203                 &lt;&lt; std::endl;      
<a name="l00204"></a>00204       libmesh_error();
<a name="l00205"></a>00205     }
<a name="l00206"></a>00206   
<a name="l00207"></a>00207   <span class="keywordflow">return</span> *(pos-&gt;second);
<a name="l00208"></a>00208 }
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 
<a name="l00212"></a><a class="code" href="classImplicitSystem.php#ae053d2e030efcf80850633ff3784e802">00212</a> <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;Number&gt;</a> &amp; <a class="code" href="classImplicitSystem.php#a719365410b024d2ddab0b1bada55753d">ImplicitSystem::get_matrix</a> (<span class="keyword">const</span> std::string&amp; mat_name)
<a name="l00213"></a>00213 {
<a name="l00214"></a>00214   <span class="comment">// Make sure the matrix exists</span>
<a name="l00215"></a>00215   <a class="code" href="classImplicitSystem.php#ae5b4d4fad0ff1b3dd813cdd653055715">matrices_iterator</a> pos = <a class="code" href="classImplicitSystem.php#a3b47fab354ef32701dc1d91ff39c17f0">_matrices</a>.find (mat_name);
<a name="l00216"></a>00216   
<a name="l00217"></a>00217   <span class="keywordflow">if</span> (pos == <a class="code" href="classImplicitSystem.php#a3b47fab354ef32701dc1d91ff39c17f0">_matrices</a>.end())
<a name="l00218"></a>00218     {
<a name="l00219"></a>00219       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: matrix &quot;</span>
<a name="l00220"></a>00220                 &lt;&lt; mat_name
<a name="l00221"></a>00221                 &lt;&lt; <span class="stringliteral">&quot; does not exist in this system!&quot;</span>
<a name="l00222"></a>00222                 &lt;&lt; std::endl;      
<a name="l00223"></a>00223       libmesh_error();
<a name="l00224"></a>00224     }
<a name="l00225"></a>00225   
<a name="l00226"></a>00226   <span class="keywordflow">return</span> *(pos-&gt;second);
<a name="l00227"></a>00227 }
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 
<a name="l00231"></a><a class="code" href="classImplicitSystem.php#accf6fbac46429c7588043fb9267e3cf4">00231</a> <span class="keywordtype">void</span> <a class="code" href="classImplicitSystem.php#accf6fbac46429c7588043fb9267e3cf4">ImplicitSystem::add_system_matrix</a> ()
<a name="l00232"></a>00232 {
<a name="l00233"></a>00233   <span class="comment">// Possible that we cleared the _matrices but</span>
<a name="l00234"></a>00234   <span class="comment">// forgot to NULL-out the matrix?</span>
<a name="l00235"></a>00235   <span class="keywordflow">if</span> (<a class="code" href="classImplicitSystem.php#a3b47fab354ef32701dc1d91ff39c17f0">_matrices</a>.empty()) <a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a> = NULL;
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 
<a name="l00238"></a>00238   <span class="comment">// Only need to add the matrix if it isn&#39;t there</span>
<a name="l00239"></a>00239   <span class="comment">// already!</span>
<a name="l00240"></a>00240   <span class="keywordflow">if</span> (<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a> == NULL)
<a name="l00241"></a>00241     <a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a> = &amp;(this-&gt;<a class="code" href="classImplicitSystem.php#acad3dc8b26c91f6c82c3e9708a1dc2e1">add_matrix</a> (<span class="stringliteral">&quot;System Matrix&quot;</span>));
<a name="l00242"></a>00242 
<a name="l00243"></a>00243   libmesh_assert (<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a> != NULL);
<a name="l00244"></a>00244 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
