<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>implicit_system.h</h1>  </div>
</div>
<div class="contents">
<a href="implicit__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: implicit_system.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __implicit_system_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __implicit_system_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="explicit__system_8h.php">explicit_system.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Forward declarations</span>
<a name="l00031"></a>00031 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classSparseMatrix.php">SparseMatrix</a>;
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00043"></a>00043 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00044"></a>00044 <span class="comment">// ImplicitSystem class definition</span>
<a name="l00045"></a>00045 
<a name="l00046"></a><a class="code" href="classImplicitSystem.php">00046</a> <span class="keyword">class </span><a class="code" href="classImplicitSystem.php">ImplicitSystem</a> : <span class="keyword">public</span> <a class="code" href="classExplicitSystem.php">ExplicitSystem</a>
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048 <span class="keyword">public</span>:
<a name="l00049"></a>00049 
<a name="l00054"></a>00054   <a class="code" href="classImplicitSystem.php#ab30be02609452092da5d44b2fc950458">ImplicitSystem</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00055"></a>00055                   <span class="keyword">const</span> std::string&amp; <a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>,
<a name="l00056"></a>00056                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">number</a>);
<a name="l00057"></a>00057 
<a name="l00061"></a>00061   <span class="keyword">virtual</span> <a class="code" href="classImplicitSystem.php#a813f4466bb5f24a35f81edbf0c3b3337">~ImplicitSystem</a> ();
<a name="l00062"></a>00062 
<a name="l00066"></a><a class="code" href="classImplicitSystem.php#a26cd319d2c6d1490763402ac6db629bb">00066</a>   <span class="keyword">typedef</span> <a class="code" href="classImplicitSystem.php">ImplicitSystem</a> <a class="code" href="classImplicitSystem.php#a26cd319d2c6d1490763402ac6db629bb">sys_type</a>;
<a name="l00067"></a>00067 
<a name="l00071"></a><a class="code" href="classImplicitSystem.php#aa06c777ee4e6af458611ec5b58594bad">00071</a>   <a class="code" href="classExplicitSystem.php">sys_type</a> &amp; <a class="code" href="classImplicitSystem.php#aa06c777ee4e6af458611ec5b58594bad">system</a> () { <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00072"></a>00072 
<a name="l00076"></a><a class="code" href="classImplicitSystem.php#a814685633e8e0ec60426a626c50d1e7e">00076</a>   <span class="keyword">typedef</span> <a class="code" href="classExplicitSystem.php">ExplicitSystem</a> <a class="code" href="classImplicitSystem.php#a814685633e8e0ec60426a626c50d1e7e">Parent</a>;
<a name="l00077"></a>00077   
<a name="l00082"></a>00082   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classImplicitSystem.php#aaec0524bd164ab907129805835809f77">clear</a> ();
<a name="l00083"></a>00083 
<a name="l00088"></a>00088   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classImplicitSystem.php#a292ff27cdaef1d65974cad561ad1beed">reinit</a> ();
<a name="l00089"></a>00089    
<a name="l00095"></a>00095   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classImplicitSystem.php#a87a6ebda725c6f44293dcd4d2f69f9de">assemble</a> ();
<a name="l00096"></a>00096  
<a name="l00097"></a>00097 <span class="comment">//   /**</span>
<a name="l00098"></a>00098 <span class="comment">//    * Assembles &amp; solves the linear system Ax=b. </span>
<a name="l00099"></a>00099 <span class="comment">//    */</span>
<a name="l00100"></a>00100 <span class="comment">//   virtual void solve ();</span>
<a name="l00101"></a>00101  
<a name="l00106"></a><a class="code" href="classImplicitSystem.php#a1e6d2900b8dd93ce9ebf85cb44823eec">00106</a>   <span class="keyword">virtual</span> std::string <a class="code" href="classImplicitSystem.php#a1e6d2900b8dd93ce9ebf85cb44823eec">system_type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="stringliteral">&quot;Implicit&quot;</span>; }
<a name="l00107"></a>00107 
<a name="l00111"></a><a class="code" href="classImplicitSystem.php#ae5b4d4fad0ff1b3dd813cdd653055715">00111</a>   <span class="keyword">typedef</span> std::map&lt;std::string, SparseMatrix&lt;Number&gt;* &gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a>        <a class="code" href="classImplicitSystem.php#ae5b4d4fad0ff1b3dd813cdd653055715">matrices_iterator</a>;
<a name="l00112"></a><a class="code" href="classImplicitSystem.php#ad2ce7333960518e290f15ee47eb98ea6">00112</a>   <span class="keyword">typedef</span> std::map&lt;std::string, SparseMatrix&lt;Number&gt;* &gt;::const_iterator  <a class="code" href="classImplicitSystem.php#ad2ce7333960518e290f15ee47eb98ea6">const_matrices_iterator</a>;
<a name="l00113"></a>00113 
<a name="l00122"></a>00122   <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;Number&gt;</a> &amp; <a class="code" href="classImplicitSystem.php#acad3dc8b26c91f6c82c3e9708a1dc2e1">add_matrix</a> (<span class="keyword">const</span> std::string&amp; mat_name);
<a name="l00123"></a>00123 
<a name="l00128"></a>00128   <span class="keywordtype">bool</span> <a class="code" href="classImplicitSystem.php#aa23d50b0a898aaee758d4a98c996a4df">have_matrix</a> (<span class="keyword">const</span> std::string&amp; mat_name) <span class="keyword">const</span>;
<a name="l00129"></a>00129 
<a name="l00136"></a>00136   <span class="keyword">const</span> <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;Number&gt;</a> &amp; <a class="code" href="classImplicitSystem.php#a719365410b024d2ddab0b1bada55753d">get_matrix</a> (<span class="keyword">const</span> std::string&amp; mat_name) <span class="keyword">const</span>;
<a name="l00137"></a>00137 
<a name="l00144"></a>00144   <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;Number&gt;</a> &amp; <a class="code" href="classImplicitSystem.php#a719365410b024d2ddab0b1bada55753d">get_matrix</a> (<span class="keyword">const</span> std::string&amp; mat_name);
<a name="l00145"></a>00145 
<a name="l00149"></a>00149   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classImplicitSystem.php#ae599e4e98272bf512d030845c2052dfa">n_matrices</a> () <span class="keyword">const</span>;
<a name="l00150"></a>00150   
<a name="l00156"></a><a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">00156</a>   <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;Number&gt;</a> * <a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>;
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   
<a name="l00160"></a>00160 <span class="keyword">protected</span>:
<a name="l00161"></a>00161   
<a name="l00166"></a>00166   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classImplicitSystem.php#a98ef29b55b9c0f64e7a07a94276f6c57">init_data</a> ();
<a name="l00167"></a>00167   
<a name="l00171"></a>00171   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classImplicitSystem.php#ae0f7f60ad2fade152838de233466aabb">init_matrices</a> ();
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 
<a name="l00174"></a>00174   
<a name="l00175"></a>00175 <span class="keyword">private</span>:
<a name="l00176"></a>00176 
<a name="l00181"></a>00181   <span class="keywordtype">void</span> <a class="code" href="classImplicitSystem.php#accf6fbac46429c7588043fb9267e3cf4">add_system_matrix</a> ();
<a name="l00182"></a>00182 
<a name="l00186"></a><a class="code" href="classImplicitSystem.php#a3b47fab354ef32701dc1d91ff39c17f0">00186</a>   std::map&lt;std::string, SparseMatrix&lt;Number&gt;* &gt; <a class="code" href="classImplicitSystem.php#a3b47fab354ef32701dc1d91ff39c17f0">_matrices</a>;
<a name="l00187"></a>00187 
<a name="l00191"></a><a class="code" href="classImplicitSystem.php#a9bafa79222951213fef7203492d94877">00191</a>   <span class="keywordtype">bool</span> <a class="code" href="classImplicitSystem.php#a9bafa79222951213fef7203492d94877">_can_add_matrices</a>;
<a name="l00192"></a>00192 };
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00197"></a>00197 <span class="comment">// ImplicitSystem inline methods</span>
<a name="l00198"></a>00198 <span class="keyword">inline</span>
<a name="l00199"></a><a class="code" href="classImplicitSystem.php#aa23d50b0a898aaee758d4a98c996a4df">00199</a> <span class="keywordtype">bool</span> <a class="code" href="classImplicitSystem.php#aa23d50b0a898aaee758d4a98c996a4df">ImplicitSystem::have_matrix</a> (<span class="keyword">const</span> std::string&amp; mat_name)<span class="keyword"> const</span>
<a name="l00200"></a>00200 <span class="keyword"></span>{
<a name="l00201"></a>00201   <span class="keywordflow">return</span> (<a class="code" href="classImplicitSystem.php#a3b47fab354ef32701dc1d91ff39c17f0">_matrices</a>.count(mat_name));
<a name="l00202"></a>00202 }
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 <span class="keyword">inline</span>
<a name="l00206"></a><a class="code" href="classImplicitSystem.php#ae599e4e98272bf512d030845c2052dfa">00206</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classImplicitSystem.php#ae599e4e98272bf512d030845c2052dfa">ImplicitSystem::n_matrices</a> ()<span class="keyword"> const</span>
<a name="l00207"></a>00207 <span class="keyword"></span>{
<a name="l00208"></a>00208  <span class="keywordflow">return</span> <a class="code" href="classImplicitSystem.php#a3b47fab354ef32701dc1d91ff39c17f0">_matrices</a>.size(); 
<a name="l00209"></a>00209 }
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
