<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>inf_elem_builder.h</h1>  </div>
</div>
<div class="contents">
<a href="inf__elem__builder_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: inf_elem_builder.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __inf_elem_builder_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __inf_elem_builder_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="comment">// C++ includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &lt;utility&gt;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Local includes</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;point.h&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Forward Declarations</span>
<a name="l00038"></a>00038 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00039"></a>00039 <span class="keyword">class </span><a class="code" href="classNode.php">Node</a>;
<a name="l00040"></a>00040 
<a name="l00049"></a><a class="code" href="classInfElemBuilder.php">00049</a> <span class="keyword">class </span><a class="code" href="classInfElemBuilder.php">InfElemBuilder</a>
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 <span class="keyword">public</span>:
<a name="l00055"></a><a class="code" href="classInfElemBuilder.php#aa0258a773f12f1343aeb0c59999d5362">00055</a>   <a class="code" href="classInfElemBuilder.php#aa0258a773f12f1343aeb0c59999d5362">InfElemBuilder</a>(<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh) : <a class="code" href="classInfElemBuilder.php#a5008189d0f00eb5d7398ab4293cb0400">_mesh</a>(mesh) {}
<a name="l00056"></a>00056 
<a name="l00060"></a><a class="code" href="classInfElemBuilder.php#ab2bd9b2c3ec070fb0fe32eeca6828ea3">00060</a>   <span class="keyword">typedef</span> std::pair&lt;bool, double&gt; <a class="code" href="classInfElemBuilder.php#ab2bd9b2c3ec070fb0fe32eeca6828ea3">InfElemOriginValue</a>;
<a name="l00061"></a>00061 
<a name="l00071"></a>00071   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classInfElemBuilder.php#a08efff969d087ed2780c40446eee0012">build_inf_elem</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> be_verbose = <span class="keyword">false</span>);
<a name="l00072"></a>00072 
<a name="l00095"></a>00095   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classInfElemBuilder.php#a08efff969d087ed2780c40446eee0012">build_inf_elem</a> (<span class="keyword">const</span> <a class="code" href="classInfElemBuilder.php#ab2bd9b2c3ec070fb0fe32eeca6828ea3">InfElemOriginValue</a>&amp; origin_x,
<a name="l00096"></a>00096                               <span class="keyword">const</span> <a class="code" href="classInfElemBuilder.php#ab2bd9b2c3ec070fb0fe32eeca6828ea3">InfElemOriginValue</a>&amp; origin_y,
<a name="l00097"></a>00097                               <span class="keyword">const</span> <a class="code" href="classInfElemBuilder.php#ab2bd9b2c3ec070fb0fe32eeca6828ea3">InfElemOriginValue</a>&amp; origin_z,
<a name="l00098"></a>00098                               <span class="keyword">const</span> <span class="keywordtype">bool</span> x_sym = <span class="keyword">false</span>,
<a name="l00099"></a>00099                               <span class="keyword">const</span> <span class="keywordtype">bool</span> y_sym = <span class="keyword">false</span>,
<a name="l00100"></a>00100                               <span class="keyword">const</span> <span class="keywordtype">bool</span> z_sym = <span class="keyword">false</span>,
<a name="l00101"></a>00101                               <span class="keyword">const</span> <span class="keywordtype">bool</span> be_verbose = <span class="keyword">false</span>,
<a name="l00102"></a>00102                               std::vector&lt;const Node*&gt;* inner_boundary_nodes = NULL);
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 <span class="keyword">private</span>:
<a name="l00111"></a>00111   <span class="keywordtype">void</span> <a class="code" href="classInfElemBuilder.php#a08efff969d087ed2780c40446eee0012">build_inf_elem</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; origin,
<a name="l00112"></a>00112                        <span class="keyword">const</span> <span class="keywordtype">bool</span> x_sym = <span class="keyword">false</span>,
<a name="l00113"></a>00113                        <span class="keyword">const</span> <span class="keywordtype">bool</span> y_sym = <span class="keyword">false</span>,
<a name="l00114"></a>00114                        <span class="keyword">const</span> <span class="keywordtype">bool</span> z_sym = <span class="keyword">false</span>,
<a name="l00115"></a>00115                        <span class="keyword">const</span> <span class="keywordtype">bool</span> be_verbose = <span class="keyword">false</span>,
<a name="l00116"></a>00116                        std::set&lt;std::pair&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00117"></a>00117                                           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt; &gt;* inner_faces = NULL);
<a name="l00122"></a><a class="code" href="classInfElemBuilder.php#a5008189d0f00eb5d7398ab4293cb0400">00122</a>   <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classInfElemBuilder.php#a5008189d0f00eb5d7398ab4293cb0400">_mesh</a>;
<a name="l00123"></a>00123 };
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 <span class="preprocessor">#endif // LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00127"></a>00127 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
