<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f00dea3e7b839559ab8b1786e03603be.php">fe</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>inf_fe.h</h1>  </div>
</div>
<div class="contents">
<a href="inf__fe_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: inf_fe.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __inf_fe_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __inf_fe_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="fe__base_8h.php">fe_base.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// forward declarations</span>
<a name="l00035"></a>00035 <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00036"></a>00036 <span class="keyword">class </span><a class="code" href="classFEComputeData.php">FEComputeData</a>;
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00072"></a>00072 <span class="comment">//-------------------------------------------------------------</span>
<a name="l00073"></a>00073 <span class="comment">// InfFE class definition</span>
<a name="l00074"></a>00074 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00075"></a><a class="code" href="classInfFE.php">00075</a> <span class="keyword">class </span><a class="code" href="classInfFE.php">InfFE</a> : <span class="keyword">public</span> <a class="code" href="classFEBase.php">FEBase</a>
<a name="l00076"></a>00076 {
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 <span class="comment">/*</span>
<a name="l00079"></a>00079 <span class="comment"> * Protect the nested class</span>
<a name="l00080"></a>00080 <span class="comment"> */</span>
<a name="l00081"></a>00081 <span class="keyword">protected</span>:
<a name="l00082"></a>00082 
<a name="l00094"></a>00094   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00095"></a>00095   <span class="comment">// InfFE::Radial class definition</span>
<a name="l00096"></a><a class="code" href="classInfFE_1_1Radial.php">00096</a>   <span class="keyword">class </span><a class="code" href="classInfFE_1_1Radial.php">Radial</a>
<a name="l00097"></a>00097   {
<a name="l00098"></a>00098   <span class="keyword">private</span>:
<a name="l00099"></a>00099 
<a name="l00103"></a><a class="code" href="classInfFE_1_1Radial.php#a76d85a05008e057732b162b1995f19f0">00103</a>     <a class="code" href="classInfFE_1_1Radial.php#a76d85a05008e057732b162b1995f19f0">Radial</a>() {}
<a name="l00104"></a>00104 
<a name="l00105"></a>00105   <span class="keyword">public</span>:
<a name="l00106"></a>00106 
<a name="l00111"></a>00111     <span class="keyword">static</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classInfFE_1_1Radial.php#a2d5ddf0e0326f129cca14ff6efa17379">decay</a> (<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> v);
<a name="l00112"></a>00112 
<a name="l00117"></a><a class="code" href="classInfFE_1_1Radial.php#a32687511b07363d4162bcf02e752a76e">00117</a>     <span class="keyword">static</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classInfFE_1_1Radial.php#a32687511b07363d4162bcf02e752a76e">decay_deriv</a> (<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>) { <span class="keywordflow">return</span> -.5; }
<a name="l00118"></a>00118 
<a name="l00123"></a><a class="code" href="classInfFE_1_1Radial.php#a28f8be897a8c7f288d7249bce08321d5">00123</a>     <span class="keyword">static</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classInfFE_1_1Radial.php#a28f8be897a8c7f288d7249bce08321d5">D</a> (<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> v) { <span class="keywordflow">return</span> (1.-v)*(1.-v)/4.; }
<a name="l00124"></a>00124 
<a name="l00128"></a><a class="code" href="classInfFE_1_1Radial.php#af58b921b4dfb12b2be2c692a66d43a98">00128</a>     <span class="keyword">static</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classInfFE_1_1Radial.php#af58b921b4dfb12b2be2c692a66d43a98">D_deriv</a> (<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> v) { <span class="keywordflow">return</span> (v-1.)/2.; }
<a name="l00129"></a>00129 
<a name="l00134"></a><a class="code" href="classInfFE_1_1Radial.php#aeceb2b92aa173eca15ff2a94ad542a51">00134</a>     <span class="keyword">static</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classInfFE_1_1Radial.php#aeceb2b92aa173eca15ff2a94ad542a51">mapping_order</a>() { <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>; }
<a name="l00135"></a>00135 
<a name="l00148"></a><a class="code" href="classInfFE_1_1Radial.php#a1175610798b1dfb138522027f11393ac">00148</a>     <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfFE_1_1Radial.php#a1175610798b1dfb138522027f11393ac">n_dofs</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o_radial)
<a name="l00149"></a>00149         { <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(o_radial)+1; }
<a name="l00150"></a>00150 
<a name="l00160"></a>00160     <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfFE_1_1Radial.php#a4275415a791a8df2a961b1a2ab47c571">n_dofs_at_node</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o_radial,
<a name="l00161"></a>00161                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_onion);
<a name="l00162"></a>00162 
<a name="l00170"></a><a class="code" href="classInfFE_1_1Radial.php#a428bf02f4eca91e1ed601f17adfdad8a">00170</a>     <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfFE_1_1Radial.php#a428bf02f4eca91e1ed601f17adfdad8a">n_dofs_per_elem</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o_radial)
<a name="l00171"></a>00171         { <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(o_radial)+1; }
<a name="l00172"></a>00172 
<a name="l00173"></a>00173   };
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00186"></a>00186   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00187"></a>00187   <span class="comment">// InfFE::Base class definition</span>
<a name="l00188"></a><a class="code" href="classInfFE_1_1Base.php">00188</a>   <span class="keyword">class </span><a class="code" href="classInfFE_1_1Base.php">Base</a>
<a name="l00189"></a>00189   {
<a name="l00190"></a>00190   <span class="keyword">private</span>:
<a name="l00191"></a>00191 
<a name="l00195"></a><a class="code" href="classInfFE_1_1Base.php#aa0dc1f37b1094340bb8367deb6b8c0f7">00195</a>     <a class="code" href="classInfFE_1_1Base.php#aa0dc1f37b1094340bb8367deb6b8c0f7">Base</a>() {}
<a name="l00196"></a>00196 
<a name="l00197"></a>00197   <span class="keyword">public</span>:
<a name="l00198"></a>00198 
<a name="l00204"></a>00204     <span class="keyword">static</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classInfFE_1_1Base.php#a8721f4247f30474325664dfbc383542f">build_elem</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* inf_elem);
<a name="l00205"></a>00205 
<a name="l00211"></a>00211     <span class="keyword">static</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classInfFE_1_1Base.php#a17fa2d351824fe43a87077790ebc263b">get_elem_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00212"></a>00212 
<a name="l00218"></a>00218     <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfFE_1_1Base.php#a8442a19343caf29950f84a34f6ac7515">n_base_mapping_sf</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> base_elem_type,
<a name="l00219"></a>00219                                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> base_mapping_order);
<a name="l00220"></a>00220 
<a name="l00221"></a>00221   };
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 <span class="keyword">public</span>:
<a name="l00230"></a>00230 
<a name="l00231"></a>00231   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00232"></a>00232   <span class="comment">// InfFE continued</span>
<a name="l00233"></a>00233 
<a name="l00247"></a>00247   <a class="code" href="classInfFE.php#a30966325e9cd5ef7b41e45148b6919ed">InfFE</a>(<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet);
<a name="l00248"></a>00248 
<a name="l00252"></a>00252   <a class="code" href="classInfFE.php#aa15489eb8c92c0ca4d9564d911e7ccc8">~InfFE</a>();
<a name="l00253"></a>00253 
<a name="l00254"></a>00254 
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 
<a name="l00257"></a>00257 
<a name="l00258"></a>00258   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00259"></a>00259   <span class="comment">// The static public members for access from FEInterface etc</span>
<a name="l00271"></a>00271 <span class="comment"></span>  <span class="keyword">static</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classInfFE.php#a8f1335e2f60b3969aa5ba41ca6f5f14a">shape</a>(<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet,
<a name="l00272"></a>00272                     <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00273"></a>00273                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00274"></a>00274                     <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p);
<a name="l00275"></a>00275 
<a name="l00287"></a>00287   <span class="keyword">static</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classInfFE.php#a8f1335e2f60b3969aa5ba41ca6f5f14a">shape</a>(<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet,
<a name="l00288"></a>00288                     <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00289"></a>00289                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00290"></a>00290                     <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p);
<a name="l00291"></a>00291 
<a name="l00301"></a>00301   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classInfFE.php#a3d7a37b4510b580b76a67a0bbd252970">compute_data</a>(<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00302"></a>00302                            <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* inf_elem,
<a name="l00303"></a>00303                            <a class="code" href="classFEComputeData.php">FEComputeData</a>&amp; data);
<a name="l00304"></a>00304   
<a name="l00309"></a><a class="code" href="classInfFE.php#a76556361e9e04d371ff7338895e71f84">00309</a>   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfFE.php#a7c8c1c9469a7c79f12a46f7100329f20">n_shape_functions</a> (<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet,
<a name="l00310"></a>00310                                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t)
<a name="l00311"></a>00311     { <span class="keywordflow">return</span> <a class="code" href="classInfFE.php#ae036285c35003ec3ce0cd9da0c9fdc87">n_dofs</a>(fet, t); }
<a name="l00312"></a>00312 
<a name="l00318"></a>00318   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfFE.php#ae036285c35003ec3ce0cd9da0c9fdc87">n_dofs</a>(<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet,
<a name="l00319"></a>00319                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> inf_elem_type);
<a name="l00320"></a>00320 
<a name="l00325"></a>00325   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfFE.php#af8324b860253cb1d6ea110cafd5ae9d8">n_dofs_at_node</a>(<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet,
<a name="l00326"></a>00326                                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> inf_elem_type,
<a name="l00327"></a>00327                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l00328"></a>00328 
<a name="l00333"></a>00333   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfFE.php#a3d4bdb936449ab95303e96f915a5e1cc">n_dofs_per_elem</a>(<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet,
<a name="l00334"></a>00334                                       <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> inf_elem_type);
<a name="l00335"></a>00335 
<a name="l00339"></a><a class="code" href="classInfFE.php#a630f33e09204a5884ddfd38b18f65610">00339</a>   <span class="keyword">virtual</span> <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14">FEContinuity</a> <a class="code" href="classInfFE.php#a630f33e09204a5884ddfd38b18f65610">get_continuity</a>()<span class="keyword"> const</span>
<a name="l00340"></a>00340 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a>; }  <span class="comment">// FIXME - is this true??</span>
<a name="l00341"></a>00341 
<a name="l00346"></a><a class="code" href="classInfFE.php#a9200be9bbbe50edd0d4f711e92ffe0aa">00346</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfFE.php#a9200be9bbbe50edd0d4f711e92ffe0aa">is_hierarchic</a>()<span class="keyword"> const</span>
<a name="l00347"></a>00347 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }  <span class="comment">// FIXME - Inf FEs don&#39;t handle p elevation yet</span>
<a name="l00348"></a>00348 
<a name="l00356"></a>00356   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classInfFE.php#a7193cd6b4ab6d7fa013544cae644ed8f">nodal_soln</a>(<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet,
<a name="l00357"></a>00357                          <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem, 
<a name="l00358"></a>00358                          <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; elem_soln,
<a name="l00359"></a>00359                          std::vector&lt;Number&gt;&amp; <a class="code" href="classInfFE.php#a7193cd6b4ab6d7fa013544cae644ed8f">nodal_soln</a>);
<a name="l00360"></a>00360 
<a name="l00376"></a>00376   <span class="keyword">static</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classInfFE.php#ad3ae911e9714c059f519c72467cda290">inverse_map</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00377"></a>00377                             <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00378"></a>00378                             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tolerance = TOLERANCE,
<a name="l00379"></a>00379                             <span class="keyword">const</span> <span class="keywordtype">bool</span> secure = <span class="keyword">true</span>,
<a name="l00380"></a>00380                             <span class="keyword">const</span> <span class="keywordtype">bool</span> interpolated = <span class="keyword">true</span>);
<a name="l00381"></a>00381 
<a name="l00382"></a>00382 
<a name="l00389"></a>00389   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classInfFE.php#ad3ae911e9714c059f519c72467cda290">inverse_map</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00390"></a>00390                            <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; physical_points,
<a name="l00391"></a>00391                            std::vector&lt;Point&gt;&amp;       reference_points,
<a name="l00392"></a>00392                            <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tolerance = TOLERANCE,
<a name="l00393"></a>00393                            <span class="keyword">const</span> <span class="keywordtype">bool</span> secure = <span class="keyword">true</span>);
<a name="l00394"></a>00394 
<a name="l00395"></a>00395 
<a name="l00396"></a>00396   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00397"></a>00397   <span class="comment">// The work-horses of InfFE. These are often used during matrix assembly</span>
<a name="l00404"></a>00404 <span class="comment"></span>  <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classInfFE.php#aa606fecb673215f8e4164215c9dbc03b">reinit</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00405"></a>00405                        <span class="keyword">const</span> std::vector&lt;Point&gt;* <span class="keyword">const</span> pts);
<a name="l00406"></a>00406     
<a name="l00412"></a>00412   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classInfFE.php#aa606fecb673215f8e4164215c9dbc03b">reinit</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00413"></a>00413                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> side,
<a name="l00414"></a>00414                        <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tolerance = TOLERANCE);
<a name="l00415"></a>00415 
<a name="l00421"></a>00421   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classInfFE.php#ad3dbb2e882412e50ab162fd524788c0c">edge_reinit</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00422"></a>00422                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> edge,
<a name="l00423"></a>00423                             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tolerance = TOLERANCE);
<a name="l00424"></a>00424 
<a name="l00436"></a>00436   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classInfFE.php#a9c571a32ff126b78c4bf2b0d81a3657b">attach_quadrature_rule</a> (<a class="code" href="classQBase.php">QBase</a>* q);
<a name="l00437"></a>00437 
<a name="l00442"></a><a class="code" href="classInfFE.php#a7c8c1c9469a7c79f12a46f7100329f20">00442</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfFE.php#a7c8c1c9469a7c79f12a46f7100329f20">n_shape_functions</a> ()<span class="keyword"> const</span>
<a name="l00443"></a>00443 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classInfFE.php#ab26eeea0e62ce0e00ef20b8715725b8a">_n_total_approx_sf</a>; }
<a name="l00444"></a>00444   
<a name="l00450"></a><a class="code" href="classInfFE.php#ae3009980d5fd32897f78776e58a76fbe">00450</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfFE.php#ae3009980d5fd32897f78776e58a76fbe">n_quadrature_points</a> ()<span class="keyword"> const</span>
<a name="l00451"></a>00451 <span class="keyword">  </span>{ libmesh_assert (<a class="code" href="classInfFE.php#aaefb4f998627f0425f956d3dd0b64794">radial_qrule</a> != NULL); <span class="keywordflow">return</span> <a class="code" href="classInfFE.php#aa1b4b0f1280008441d4f1c0e27e1e6b1">_n_total_qp</a>; }
<a name="l00452"></a>00452 
<a name="l00453"></a>00453 
<a name="l00454"></a>00454 <span class="keyword">protected</span>:
<a name="l00455"></a>00455 
<a name="l00456"></a>00456   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00457"></a>00457   <span class="comment">// static members used by the &quot;work-horses&quot;</span>
<a name="l00458"></a>00458 
<a name="l00475"></a>00475   <span class="keyword">static</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classInfFE.php#a7e6f2cfd05c60216d10a46d589c280ef">eval</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> v,
<a name="l00476"></a>00476                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o_radial,
<a name="l00477"></a>00477                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00478"></a>00478   
<a name="l00484"></a>00484   <span class="keyword">static</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classInfFE.php#a0c59d8a76070b7d28d3e0b9d8e015a11">eval_deriv</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> v,
<a name="l00485"></a>00485                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o_radial,
<a name="l00486"></a>00486                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00487"></a>00487 
<a name="l00488"></a>00488 
<a name="l00489"></a>00489 
<a name="l00490"></a>00490   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00491"></a>00491   <span class="comment">// Non-static members used by the &quot;work-horses&quot;</span>
<a name="l00496"></a>00496 <span class="comment"></span>  <span class="keywordtype">void</span> <a class="code" href="classInfFE.php#a961651c8eb32fbc9de88b3e1905f09a6">update_base_elem</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* inf_elem);
<a name="l00497"></a>00497 
<a name="l00501"></a><a class="code" href="classInfFE.php#aaf9d8704c8bc252c62aae6f25c413fad">00501</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classInfFE.php#aaf9d8704c8bc252c62aae6f25c413fad">init_base_shape_functions</a>(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp;,
<a name="l00502"></a>00502                                          <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*)
<a name="l00503"></a>00503   { libmesh_error(); }
<a name="l00504"></a>00504 
<a name="l00510"></a>00510   <span class="keywordtype">void</span> <a class="code" href="classInfFE.php#a348abe7e168d8055e3926a551c60f8ac">init_radial_shape_functions</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* inf_elem);
<a name="l00511"></a>00511 
<a name="l00518"></a>00518   <span class="keywordtype">void</span> <a class="code" href="classInfFE.php#a3d6fda8036974cc4c1a5d35be2fd8543">init_shape_functions</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* inf_elem);
<a name="l00519"></a>00519 
<a name="l00524"></a>00524   <span class="keywordtype">void</span> <a class="code" href="classInfFE.php#a6317dd31e07d5eebce52a7faf7b9a41a">init_face_shape_functions</a> (<span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qp,
<a name="l00525"></a>00525                                   <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* side);
<a name="l00526"></a>00526 
<a name="l00535"></a>00535   <span class="keywordtype">void</span> <a class="code" href="classInfFE.php#aa0f64a35034e80bccff94c5e8aa72c97">combine_base_radial</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* inf_elem);
<a name="l00536"></a>00536 
<a name="l00548"></a>00548   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classInfFE.php#a4be08a3d95fc3d447026a479301617d4">compute_shape_functions</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*);
<a name="l00549"></a>00549 
<a name="l00550"></a>00550 
<a name="l00551"></a>00551 
<a name="l00552"></a>00552   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00553"></a>00553   <span class="comment">// Miscellaneous static members</span>
<a name="l00554"></a>00554 
<a name="l00559"></a>00559   <span class="keyword">static</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classInfFE.php#a593bf96ec6a1d9138bed74dc47ffd28b">map</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* inf_elem,
<a name="l00560"></a>00560                     <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; reference_point);
<a name="l00561"></a>00561 
<a name="l00568"></a>00568   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classInfFE.php#a05f51ff6582f7b33fafcfe1479253782">compute_node_indices</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> inf_elem_type,
<a name="l00569"></a>00569                                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> outer_node_index,
<a name="l00570"></a>00570                                     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; base_node,
<a name="l00571"></a>00571                                     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; radial_node);
<a name="l00572"></a>00572 
<a name="l00581"></a>00581   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classInfFE.php#a6e4ff9f448c4abf1342e8e784f559977">compute_node_indices_fast</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> inf_elem_type,
<a name="l00582"></a>00582                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> outer_node_index,
<a name="l00583"></a>00583                                          <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; base_node,
<a name="l00584"></a>00584                                          <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; radial_node);
<a name="l00585"></a>00585 
<a name="l00592"></a>00592   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classInfFE.php#a948ff73fff818deb24d74041648ea74a">compute_shape_indices</a> (<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fet,
<a name="l00593"></a>00593                                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> inf_elem_type,
<a name="l00594"></a>00594                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00595"></a>00595                                      <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; base_shape,
<a name="l00596"></a>00596                                      <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; radial_shape);
<a name="l00597"></a>00597 
<a name="l00598"></a>00598   <span class="comment">//--------------------------------------------------------------</span>
<a name="l00599"></a>00599   <span class="comment">// protected members, which are not to be accessed from outside</span>
<a name="l00603"></a><a class="code" href="classInfFE.php#adb79c3c846b4208b994c0d607d591578">00603</a> <span class="comment"></span>  std::vector&lt;Real&gt;  <a class="code" href="classInfFE.php#adb79c3c846b4208b994c0d607d591578">dist</a>;
<a name="l00604"></a>00604 
<a name="l00611"></a><a class="code" href="classInfFE.php#a216e87d269885c1e2be54159f79597da">00611</a>   std::vector&lt;Real&gt;  <a class="code" href="classInfFE.php#a216e87d269885c1e2be54159f79597da">dweightdv</a>;
<a name="l00612"></a>00612 
<a name="l00619"></a><a class="code" href="classInfFE.php#a8931173628710ee63a1ef9f5c81f1266">00619</a>   std::vector&lt;Real&gt;  <a class="code" href="classInfFE.php#a8931173628710ee63a1ef9f5c81f1266">som</a>;
<a name="l00624"></a><a class="code" href="classInfFE.php#a70f4c35b2dc9a24be5fb4937d5535673">00624</a>   std::vector&lt;Real&gt;  <a class="code" href="classInfFE.php#a70f4c35b2dc9a24be5fb4937d5535673">dsomdv</a>;
<a name="l00625"></a>00625 
<a name="l00630"></a><a class="code" href="classInfFE.php#aba388baa10805f380715f8a7793512cf">00630</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classInfFE.php#aba388baa10805f380715f8a7793512cf">mode</a>;
<a name="l00631"></a>00631 
<a name="l00636"></a><a class="code" href="classInfFE.php#a53ab9f4c8768a0ee7aae3ac68163c40f">00636</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classInfFE.php#a53ab9f4c8768a0ee7aae3ac68163c40f">dmodedv</a>;
<a name="l00637"></a>00637   
<a name="l00641"></a><a class="code" href="classInfFE.php#a9a4733e3bc1b7f42f5cf7461fc9a42f5">00641</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classInfFE.php#a9a4733e3bc1b7f42f5cf7461fc9a42f5">radial_map</a>;
<a name="l00642"></a>00642 
<a name="l00643"></a>00643 
<a name="l00647"></a><a class="code" href="classInfFE.php#a238e00d45bc6dec1a2e68ac0576a3a51">00647</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classInfFE.php#a238e00d45bc6dec1a2e68ac0576a3a51">dradialdv_map</a>;
<a name="l00648"></a>00648 
<a name="l00654"></a><a class="code" href="classInfFE.php#ab90d828b39cb8f035c32919dd0c658b5">00654</a>   std::vector&lt;Real&gt;  <a class="code" href="classInfFE.php#ab90d828b39cb8f035c32919dd0c658b5">dphasedxi</a>;
<a name="l00655"></a>00655 
<a name="l00661"></a><a class="code" href="classInfFE.php#a5e3550c4b56c0bd907835539dddba7d8">00661</a>   std::vector&lt;Real&gt;  <a class="code" href="classInfFE.php#a5e3550c4b56c0bd907835539dddba7d8">dphasedeta</a>;
<a name="l00662"></a>00662 
<a name="l00668"></a><a class="code" href="classInfFE.php#a12ce701e779039f0513086d5c6f297b4">00668</a>   std::vector&lt;Real&gt;  <a class="code" href="classInfFE.php#a12ce701e779039f0513086d5c6f297b4">dphasedzeta</a>;
<a name="l00669"></a>00669 
<a name="l00670"></a>00670 
<a name="l00671"></a>00671 
<a name="l00672"></a>00672 
<a name="l00673"></a>00673   <span class="comment">//--------------------------------------------------------------</span>
<a name="l00674"></a>00674   <span class="comment">// numbering scheme maps</span>
<a name="l00675"></a>00675 
<a name="l00684"></a><a class="code" href="classInfFE.php#aee35b3666ba6db2c1b5fa0f9e3524e06">00684</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classInfFE.php#aee35b3666ba6db2c1b5fa0f9e3524e06">_radial_node_index</a>;
<a name="l00685"></a>00685 
<a name="l00694"></a><a class="code" href="classInfFE.php#a01a6f0eb248b18327448a8eb100decc2">00694</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classInfFE.php#a01a6f0eb248b18327448a8eb100decc2">_base_node_index</a>;
<a name="l00695"></a>00695 
<a name="l00704"></a><a class="code" href="classInfFE.php#aff2431082fe0234adc7cd19d4779a469">00704</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classInfFE.php#aff2431082fe0234adc7cd19d4779a469">_radial_shape_index</a>;
<a name="l00705"></a>00705 
<a name="l00714"></a><a class="code" href="classInfFE.php#a38ad4b28c843734cd4abec405f7da7c9">00714</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classInfFE.php#a38ad4b28c843734cd4abec405f7da7c9">_base_shape_index</a>;
<a name="l00715"></a>00715 
<a name="l00716"></a>00716 
<a name="l00717"></a>00717 
<a name="l00718"></a>00718 
<a name="l00719"></a>00719   <span class="comment">//--------------------------------------------------------------</span>
<a name="l00720"></a>00720   <span class="comment">// some more protected members</span>
<a name="l00721"></a>00721 
<a name="l00726"></a><a class="code" href="classInfFE.php#ab26eeea0e62ce0e00ef20b8715725b8a">00726</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfFE.php#ab26eeea0e62ce0e00ef20b8715725b8a">_n_total_approx_sf</a>;
<a name="l00727"></a>00727 
<a name="l00732"></a><a class="code" href="classInfFE.php#aa1b4b0f1280008441d4f1c0e27e1e6b1">00732</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classInfFE.php#aa1b4b0f1280008441d4f1c0e27e1e6b1">_n_total_qp</a>;
<a name="l00733"></a>00733 
<a name="l00738"></a><a class="code" href="classInfFE.php#a2d14886fa7f35b4ef6505150a622a2a6">00738</a>   std::vector&lt;Real&gt;  <a class="code" href="classInfFE.php#a2d14886fa7f35b4ef6505150a622a2a6">_total_qrule_weights</a>;
<a name="l00739"></a>00739 
<a name="l00744"></a><a class="code" href="classInfFE.php#ae8bbcafc0fc2cd590475b61c0af1d0e2">00744</a>   <a class="code" href="classQBase.php">QBase</a>* <a class="code" href="classInfFE.php#ae8bbcafc0fc2cd590475b61c0af1d0e2">base_qrule</a>;
<a name="l00745"></a>00745 
<a name="l00750"></a><a class="code" href="classInfFE.php#aaefb4f998627f0425f956d3dd0b64794">00750</a>   <a class="code" href="classQBase.php">QBase</a>* <a class="code" href="classInfFE.php#aaefb4f998627f0425f956d3dd0b64794">radial_qrule</a>;
<a name="l00751"></a>00751 
<a name="l00756"></a><a class="code" href="classInfFE.php#ac7385e45547f8f296d15cc056366e304">00756</a>   <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classInfFE.php#ac7385e45547f8f296d15cc056366e304">base_elem</a>;
<a name="l00757"></a>00757 
<a name="l00764"></a><a class="code" href="classInfFE.php#ac0f73767a810b531b62cbfc452c694b4">00764</a>   <a class="code" href="classFEBase.php">FEBase</a>* <a class="code" href="classInfFE.php#ac0f73767a810b531b62cbfc452c694b4">base_fe</a>;
<a name="l00765"></a>00765 
<a name="l00773"></a><a class="code" href="classInfFE.php#a1aa382ac19305eac30d89de0e99f7291">00773</a>   <a class="code" href="classFEType.php">FEType</a> <a class="code" href="classInfFE.php#a1aa382ac19305eac30d89de0e99f7291">current_fe_type</a>;
<a name="l00774"></a>00774 
<a name="l00775"></a>00775 
<a name="l00776"></a>00776 <span class="keyword">private</span>:
<a name="l00777"></a>00777 
<a name="l00781"></a>00781   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classInfFE.php#a7f0f29771b6d4eece966bf33aee9c330">shapes_need_reinit</a>() <span class="keyword">const</span>;
<a name="l00782"></a>00782 
<a name="l00790"></a><a class="code" href="classInfFE.php#a54577c4e3c87caf185efe297cf6d5b5c">00790</a>   <span class="keyword">static</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classInfFE.php#a54577c4e3c87caf185efe297cf6d5b5c">_compute_node_indices_fast_current_elem_type</a>;
<a name="l00791"></a>00791 
<a name="l00792"></a>00792 
<a name="l00793"></a>00793 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00794"></a>00794 <span class="preprocessor"></span>
<a name="l00798"></a><a class="code" href="classInfFE.php#abddf81c62e0b26260d1c1492d81e7e68">00798</a>   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classInfFE.php#abddf81c62e0b26260d1c1492d81e7e68">_warned_for_nodal_soln</a>;
<a name="l00799"></a><a class="code" href="classInfFE.php#a25c2a3f4a1a1a8ade8f0f685499058e0">00799</a>   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classInfFE.php#a25c2a3f4a1a1a8ade8f0f685499058e0">_warned_for_shape</a>;
<a name="l00800"></a>00800 
<a name="l00801"></a>00801 <span class="preprocessor">#endif</span>
<a name="l00802"></a>00802 <span class="preprocessor"></span>
<a name="l00808"></a>00808   <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> friend_Dim, FEFamily friend_T_radial, InfMapType friend_T_map&gt;
<a name="l00809"></a><a class="code" href="classInfFE.php#a30966325e9cd5ef7b41e45148b6919ed">00809</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classInfFE.php">InfFE</a>;
<a name="l00810"></a>00810 
<a name="l00811"></a>00811 };
<a name="l00812"></a>00812 
<a name="l00813"></a>00813 
<a name="l00814"></a>00814 
<a name="l00815"></a>00815 
<a name="l00816"></a>00816 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00817"></a>00817 <span class="comment">// InfFE class inline members</span>
<a name="l00818"></a>00818 
<a name="l00819"></a>00819 
<a name="l00820"></a>00820 
<a name="l00821"></a>00821 
<a name="l00822"></a>00822 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00823"></a>00823 <span class="comment">// InfFE::Radial class inline members</span>
<a name="l00824"></a>00824 
<a name="l00825"></a>00825 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00826"></a>00826 <span class="keyword">inline</span>
<a name="l00827"></a><a class="code" href="classInfFE_1_1Radial.php#a2d5ddf0e0326f129cca14ff6efa17379">00827</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classInfFE_1_1Radial.php#a2d5ddf0e0326f129cca14ff6efa17379">InfFE&lt;Dim,T_radial,T_map&gt;::Radial::decay</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> v)
<a name="l00828"></a>00828 {
<a name="l00829"></a>00829   <span class="keywordflow">switch</span> (Dim)
<a name="l00830"></a>00830   <span class="comment">//TODO:[DD] What decay do i have in 2D and 1D?</span>
<a name="l00831"></a>00831   {
<a name="l00832"></a>00832     <span class="keywordflow">case</span> 3:
<a name="l00833"></a>00833       <span class="keywordflow">return</span> (1.-v)/2.;
<a name="l00834"></a>00834 
<a name="l00835"></a>00835     <span class="keywordflow">case</span> 2:
<a name="l00836"></a>00836       <span class="keywordflow">return</span> 0.;
<a name="l00837"></a>00837 
<a name="l00838"></a>00838     <span class="keywordflow">case</span> 1:
<a name="l00839"></a>00839       <span class="keywordflow">return</span> 0.;
<a name="l00840"></a>00840 
<a name="l00841"></a>00841     <span class="keywordflow">default</span>:
<a name="l00842"></a>00842       libmesh_error();
<a name="l00843"></a>00843       <span class="keywordflow">return</span> 0.;
<a name="l00844"></a>00844   }
<a name="l00845"></a>00845 }
<a name="l00846"></a>00846 
<a name="l00847"></a>00847 
<a name="l00848"></a>00848 
<a name="l00849"></a>00849 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00850"></a>00850 <span class="comment">// InfFE::Base class inline members</span>
<a name="l00851"></a>00851 
<a name="l00852"></a>00852 
<a name="l00853"></a>00853 
<a name="l00854"></a>00854 <span class="preprocessor">#endif //ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00855"></a>00855 <span class="preprocessor"></span>
<a name="l00856"></a>00856 
<a name="l00857"></a>00857 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
