<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_a0136eca6b184c0d854bbc4a8414e31c.php">fe</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>inf_fe_map.C</h1>  </div>
</div>
<div class="contents">
<a href="inf__fe__map_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: inf_fe_map.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span><span class="preprocessor">#include &quot;inf_fe.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;fe.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;inf_fe_macro.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00034"></a>00034 <span class="comment">// InfFE static class members concerned with coordinate</span>
<a name="l00035"></a>00035 <span class="comment">// mapping</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00039"></a><a class="code" href="classInfFE.php#a593bf96ec6a1d9138bed74dc47ffd28b">00039</a> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classInfFE.php#a593bf96ec6a1d9138bed74dc47ffd28b">InfFE&lt;Dim,T_radial,T_map&gt;::map</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* inf_elem,
<a name="l00040"></a>00040                                       <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; reference_point)
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042   libmesh_assert (inf_elem != NULL);
<a name="l00043"></a>00043   libmesh_assert (Dim != 0);
<a name="l00044"></a>00044 
<a name="l00045"></a>00045   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a>      <a class="code" href="classInfFE.php#ac7385e45547f8f296d15cc056366e304">base_elem</a> (<a class="code" href="classInfFE_1_1Base.php#a8721f4247f30474325664dfbc383542f">Base::build_elem</a> (inf_elem));
<a name="l00046"></a>00046 
<a name="l00047"></a>00047   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>        radial_mapping_order (<a class="code" href="classInfFE_1_1Radial.php#aeceb2b92aa173eca15ff2a94ad542a51">Radial::mapping_order</a>());    
<a name="l00048"></a>00048   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>         v                    (reference_point(Dim-1)); 
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   <span class="comment">// map in the base face</span>
<a name="l00051"></a>00051   <a class="code" href="classPoint.php">Point</a> base_point;
<a name="l00052"></a>00052   <span class="keywordflow">switch</span> (Dim)
<a name="l00053"></a>00053     {  
<a name="l00054"></a>00054     <span class="keywordflow">case</span> 1:
<a name="l00055"></a>00055       base_point = inf_elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0);
<a name="l00056"></a>00056       <span class="keywordflow">break</span>;
<a name="l00057"></a>00057     <span class="keywordflow">case</span> 2:
<a name="l00058"></a>00058       base_point = <a class="code" href="classFE.php#ad693264af6f1ff8f2d736f73cadc8f3d">FE&lt;1,LAGRANGE&gt;::map</a> (base_elem.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>(), reference_point);
<a name="l00059"></a>00059       <span class="keywordflow">break</span>;
<a name="l00060"></a>00060     <span class="keywordflow">case</span> 3:
<a name="l00061"></a>00061       base_point = <a class="code" href="classFE.php#ad693264af6f1ff8f2d736f73cadc8f3d">FE&lt;2,LAGRANGE&gt;::map</a> (base_elem.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>(), reference_point);
<a name="l00062"></a>00062       <span class="keywordflow">break</span>;
<a name="l00063"></a>00063 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00064"></a>00064 <span class="preprocessor"></span>    <span class="keywordflow">default</span>:
<a name="l00065"></a>00065         libmesh_error();
<a name="l00066"></a>00066 <span class="preprocessor">#endif</span>
<a name="l00067"></a>00067 <span class="preprocessor"></span>    }
<a name="l00068"></a>00068       
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="comment">// map in the outer node face not necessary. Simply</span>
<a name="l00071"></a>00071   <span class="comment">// compute the outer_point = base_point + (base_point-origin)</span>
<a name="l00072"></a>00072   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> outer_point (base_point * 2. - inf_elem-&gt;<a class="code" href="classElem.php#adcaedd09dd644bec38f2460c1e770f16">origin</a>());
<a name="l00073"></a>00073   
<a name="l00074"></a>00074   <a class="code" href="classPoint.php">Point</a> p;
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <span class="comment">// there are only two mapping shapes in radial direction</span>
<a name="l00077"></a>00077   p.<a class="code" href="classTypeVector.php#ac9000695cb19991b893cb79a07249e9c">add_scaled</a> (base_point,  <a class="code" href="classInfFE.php">InfFE&lt;Dim,INFINITE_MAP,T_map&gt;::eval</a> (v, radial_mapping_order, 0));
<a name="l00078"></a>00078   p.add_scaled (outer_point, <a class="code" href="classInfFE.php">InfFE&lt;Dim,INFINITE_MAP,T_map&gt;::eval</a> (v, radial_mapping_order, 1));
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   <span class="keywordflow">return</span> p;
<a name="l00081"></a>00081 }
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00088"></a><a class="code" href="classInfFE.php#ad3ae911e9714c059f519c72467cda290">00088</a> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classInfFE.php#ad3ae911e9714c059f519c72467cda290">InfFE&lt;Dim,T_radial,T_map&gt;::inverse_map</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* inf_elem,
<a name="l00089"></a>00089                                               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; physical_point,
<a name="l00090"></a>00090                                               <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tolerance,
<a name="l00091"></a>00091                                               <span class="keyword">const</span> <span class="keywordtype">bool</span> secure,
<a name="l00092"></a>00092                                               <span class="keyword">const</span> <span class="keywordtype">bool</span> interpolated)
<a name="l00093"></a>00093 {
<a name="l00094"></a>00094   libmesh_assert (inf_elem != NULL);
<a name="l00095"></a>00095   libmesh_assert (tolerance &gt;= 0.);
<a name="l00096"></a>00096 
<a name="l00097"></a>00097   
<a name="l00098"></a>00098   <span class="comment">// Start logging the map inversion.</span>
<a name="l00099"></a>00099   START_LOG(<span class="stringliteral">&quot;inverse_map()&quot;</span>, <span class="stringliteral">&quot;InfFE&quot;</span>);
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   
<a name="l00102"></a>00102   <span class="comment">// 1.)</span>
<a name="l00103"></a>00103   <span class="comment">// build a base element to do the map inversion in the base face</span>
<a name="l00104"></a>00104   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classInfFE.php#ac7385e45547f8f296d15cc056366e304">base_elem</a> (<a class="code" href="classInfFE_1_1Base.php#a8721f4247f30474325664dfbc383542f">Base::build_elem</a> (inf_elem));
<a name="l00105"></a>00105 
<a name="l00106"></a>00106   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>    base_mapping_order     (base_elem-&gt;default_order());
<a name="l00107"></a>00107   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> base_mapping_elem_type (base_elem-&gt;type());
<a name="l00108"></a>00108   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_base_mapping_sf = <a class="code" href="classInfFE_1_1Base.php#a8442a19343caf29950f84a34f6ac7515">Base::n_base_mapping_sf</a> (base_mapping_elem_type,
<a name="l00109"></a>00109                                                                   base_mapping_order);
<a name="l00110"></a>00110 
<a name="l00111"></a>00111   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> inf_elem_type = inf_elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>();
<a name="l00112"></a>00112   <span class="keywordflow">if</span> (inf_elem_type != <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a54cedbd05931dd2cb7dcabf0109bddcb">INFHEX8</a> &amp;&amp;
<a name="l00113"></a>00113       inf_elem_type != <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac6743a9a04524105e37159e924c4a33b">INFPRISM6</a>)
<a name="l00114"></a>00114     {
<a name="l00115"></a>00115       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: InfFE::inverse_map is currently implemented only for\n&quot;</span>
<a name="l00116"></a>00116                 &lt;&lt; <span class="stringliteral">&quot; infinite elments of type InfHex8 and InfPrism6.&quot;</span> &lt;&lt; std::endl;
<a name="l00117"></a>00117       libmesh_error();
<a name="l00118"></a>00118     }
<a name="l00119"></a>00119 
<a name="l00120"></a>00120   
<a name="l00121"></a>00121   <span class="comment">// 2.)</span>
<a name="l00122"></a>00122   <span class="comment">// just like in FE&lt;Dim-1,LAGRANGE&gt;::inverse_map(): compute</span>
<a name="l00123"></a>00123   <span class="comment">// the local coordinates, but only in the base element.</span>
<a name="l00124"></a>00124   <span class="comment">// The radial part can then be computed directly later on.</span>
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   
<a name="l00127"></a>00127   <span class="comment">// How much did the point on the reference</span>
<a name="l00128"></a>00128   <span class="comment">// element change by in this Newton step?</span>
<a name="l00129"></a>00129   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> inverse_map_error = 0.;
<a name="l00130"></a>00130   
<a name="l00131"></a>00131   
<a name="l00132"></a>00132   <span class="comment">// The point on the reference element.  This is</span>
<a name="l00133"></a>00133   <span class="comment">// the &quot;initial guess&quot; for Newton&#39;s method.  The</span>
<a name="l00134"></a>00134   <span class="comment">// centroid seems like a good idea, but computing</span>
<a name="l00135"></a>00135   <span class="comment">// it is a little more intensive than, say taking</span>
<a name="l00136"></a>00136   <span class="comment">// the zero point.  </span>
<a name="l00137"></a>00137   <span class="comment">//</span>
<a name="l00138"></a>00138   <span class="comment">// Convergence should be insensitive of this choice</span>
<a name="l00139"></a>00139   <span class="comment">// for &quot;good&quot; elements.</span>
<a name="l00140"></a>00140   <a class="code" href="classPoint.php">Point</a> p; <span class="comment">// the zero point.  No computation required</span>
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143   
<a name="l00144"></a>00144   <span class="comment">// Now find the intersection of a plane represented by the base</span>
<a name="l00145"></a>00145   <span class="comment">// element nodes and the line given by the origin of the infinite</span>
<a name="l00146"></a>00146   <span class="comment">// element and the physical point.</span>
<a name="l00147"></a>00147   <a class="code" href="classPoint.php">Point</a> intersection;
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   <span class="comment">// the origin of the infinite lement</span>
<a name="l00150"></a>00150   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> o = inf_elem-&gt;<a class="code" href="classElem.php#adcaedd09dd644bec38f2460c1e770f16">origin</a>(); 
<a name="l00151"></a>00151 
<a name="l00152"></a>00152   <span class="keywordflow">switch</span> (Dim)
<a name="l00153"></a>00153     {
<a name="l00154"></a>00154 
<a name="l00155"></a>00155       <span class="comment">// unnecessary for 1D</span>
<a name="l00156"></a>00156     <span class="keywordflow">case</span> 1:
<a name="l00157"></a>00157       {
<a name="l00158"></a>00158         <span class="keywordflow">break</span>;
<a name="l00159"></a>00159       }
<a name="l00160"></a>00160 
<a name="l00161"></a>00161     <span class="keywordflow">case</span> 2:
<a name="l00162"></a>00162       {
<a name="l00163"></a>00163         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: InfFE::inverse_map is not yet implemented&quot;</span>
<a name="l00164"></a>00164                   &lt;&lt; <span class="stringliteral">&quot; in 2d&quot;</span> &lt;&lt; std::endl;
<a name="l00165"></a>00165         libmesh_error();
<a name="l00166"></a>00166         <span class="keywordflow">break</span>;
<a name="l00167"></a>00167       }
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00170"></a>00170     <span class="keywordflow">case</span> 3:
<a name="l00171"></a>00171       {
<a name="l00172"></a>00172         <span class="comment">// references to the nodal points of the base element</span>
<a name="l00173"></a>00173         <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p0 = base_elem-&gt;point(0);
<a name="l00174"></a>00174         <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p1 = base_elem-&gt;point(1);
<a name="l00175"></a>00175         <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p2 = base_elem-&gt;point(2);
<a name="l00176"></a>00176         
<a name="l00177"></a>00177         <span class="comment">// a reference to the physical point</span>
<a name="l00178"></a>00178         <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; fp = physical_point;
<a name="l00179"></a>00179         
<a name="l00180"></a>00180         <span class="comment">// The intersection of the plane and the line is given by</span>
<a name="l00181"></a>00181         <span class="comment">// can be computed solving a linear 3x3 system</span>
<a name="l00182"></a>00182         <span class="comment">// a*({p1}-{p0})+b*({p2}-{p0})-c*({fp}-{o})={fp}-{p0}.          </span>
<a name="l00183"></a>00183         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> c_factor = -(p1(0)*fp(1)*p0(2)-p1(0)*fp(2)*p0(1)
<a name="l00184"></a>00184                                 +fp(0)*p1(2)*p0(1)-p0(0)*fp(1)*p1(2)
<a name="l00185"></a>00185                                 +p0(0)*fp(2)*p1(1)+p2(0)*fp(2)*p0(1)
<a name="l00186"></a>00186                                 -p2(0)*fp(1)*p0(2)-fp(0)*p2(2)*p0(1)
<a name="l00187"></a>00187                                 +fp(0)*p0(2)*p2(1)+p0(0)*fp(1)*p2(2)
<a name="l00188"></a>00188                                 -p0(0)*fp(2)*p2(1)-fp(0)*p0(2)*p1(1)
<a name="l00189"></a>00189                                 +p0(2)*p2(0)*p1(1)-p0(1)*p2(0)*p1(2)
<a name="l00190"></a>00190                                 -fp(0)*p1(2)*p2(1)+p2(1)*p0(0)*p1(2)
<a name="l00191"></a>00191                                 -p2(0)*fp(2)*p1(1)-p1(0)*fp(1)*p2(2)
<a name="l00192"></a>00192                                 +p2(2)*p1(0)*p0(1)+p1(0)*fp(2)*p2(1)
<a name="l00193"></a>00193                                 -p0(2)*p1(0)*p2(1)-p2(2)*p0(0)*p1(1)
<a name="l00194"></a>00194                                 +fp(0)*p2(2)*p1(1)+p2(0)*fp(1)*p1(2))/
<a name="l00195"></a>00195                                 (fp(0)*p1(2)*p0(1)-p1(0)*fp(2)*p0(1)
<a name="l00196"></a>00196                                  +p1(0)*fp(1)*p0(2)-p1(0)*o(1)*p0(2)
<a name="l00197"></a>00197                                  +o(0)*p2(2)*p0(1)-p0(0)*fp(2)*p2(1)
<a name="l00198"></a>00198                                  +p1(0)*o(1)*p2(2)+fp(0)*p0(2)*p2(1)
<a name="l00199"></a>00199                                  -fp(0)*p1(2)*p2(1)-p0(0)*o(1)*p2(2)
<a name="l00200"></a>00200                                  +p0(0)*fp(1)*p2(2)-o(0)*p0(2)*p2(1)
<a name="l00201"></a>00201                                  +o(0)*p1(2)*p2(1)-p2(0)*fp(2)*p1(1)
<a name="l00202"></a>00202                                  +fp(0)*p2(2)*p1(1)-p2(0)*fp(1)*p0(2)
<a name="l00203"></a>00203                                  -o(2)*p0(0)*p1(1)-fp(0)*p0(2)*p1(1)
<a name="l00204"></a>00204                                  +p0(0)*o(1)*p1(2)+p0(0)*fp(2)*p1(1)
<a name="l00205"></a>00205                                  -p0(0)*fp(1)*p1(2)-o(0)*p1(2)*p0(1)
<a name="l00206"></a>00206                                  -p2(0)*o(1)*p1(2)-o(2)*p2(0)*p0(1)
<a name="l00207"></a>00207                                  -o(2)*p1(0)*p2(1)+o(2)*p0(0)*p2(1)
<a name="l00208"></a>00208                                  -fp(0)*p2(2)*p0(1)+o(2)*p2(0)*p1(1)
<a name="l00209"></a>00209                                  +p2(0)*o(1)*p0(2)+p2(0)*fp(1)*p1(2)
<a name="l00210"></a>00210                                  +p2(0)*fp(2)*p0(1)-p1(0)*fp(1)*p2(2)
<a name="l00211"></a>00211                                  +p1(0)*fp(2)*p2(1)-o(0)*p2(2)*p1(1)
<a name="l00212"></a>00212                                  +o(2)*p1(0)*p0(1)+o(0)*p0(2)*p1(1));
<a name="l00213"></a>00213         
<a name="l00214"></a>00214 
<a name="l00215"></a>00215         <span class="comment">// Compute the intersection with</span>
<a name="l00216"></a>00216         <span class="comment">// {intersection} = {fp} + c*({fp}-{o}).</span>
<a name="l00217"></a>00217         intersection.<a class="code" href="classTypeVector.php#ac9000695cb19991b893cb79a07249e9c">add_scaled</a>(fp,1.+c_factor);
<a name="l00218"></a>00218         intersection.<a class="code" href="classTypeVector.php#ac9000695cb19991b893cb79a07249e9c">add_scaled</a>(o,-c_factor);
<a name="l00219"></a>00219 
<a name="l00220"></a>00220         <span class="keywordflow">break</span>;
<a name="l00221"></a>00221       }
<a name="l00222"></a>00222     }
<a name="l00223"></a>00223 
<a name="l00227"></a>00227   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt = 0;
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 
<a name="l00233"></a>00233   <span class="keywordflow">do</span>
<a name="l00234"></a>00234     {
<a name="l00235"></a>00235       
<a name="l00236"></a>00236       <span class="comment">// Increment in current iterate \p p, will be computed.</span>
<a name="l00237"></a>00237       <span class="comment">// Automatically initialized to all zero.  Note that</span>
<a name="l00238"></a>00238       <span class="comment">// in 3D, actually only the first two entries are</span>
<a name="l00239"></a>00239       <span class="comment">// filled by the inverse map, and in 2D only the first. </span>
<a name="l00240"></a>00240       <a class="code" href="classPoint.php">Point</a> dp;
<a name="l00241"></a>00241 
<a name="l00242"></a>00242       <span class="comment">// The form of the map and how we invert it depends</span>
<a name="l00243"></a>00243       <span class="comment">// on the dimension that we are in.      </span>
<a name="l00244"></a>00244       <span class="keywordflow">switch</span> (Dim)
<a name="l00245"></a>00245         {
<a name="l00246"></a>00246 
<a name="l00247"></a>00247           <span class="comment">//------------------------------------------------------------------</span>
<a name="l00248"></a>00248           <span class="comment">// 1D infinite element - no map inversion necessary</span>
<a name="l00249"></a>00249         <span class="keywordflow">case</span> 1:
<a name="l00250"></a>00250           {
<a name="l00251"></a>00251             <span class="keywordflow">break</span>;
<a name="l00252"></a>00252           }
<a name="l00253"></a>00253 
<a name="l00254"></a>00254 
<a name="l00255"></a>00255           <span class="comment">//------------------------------------------------------------------</span>
<a name="l00256"></a>00256           <span class="comment">// 2D infinite element - 1D map inversion</span>
<a name="l00257"></a>00257           <span class="comment">//</span>
<a name="l00258"></a>00258           <span class="comment">// In this iteration scheme only search for the local coordinate</span>
<a name="l00259"></a>00259           <span class="comment">// in xi direction.  Once xi is determined, the radial coordinate eta is</span>
<a name="l00260"></a>00260           <span class="comment">// uniquely determined, and there is no need to iterate in that direction.</span>
<a name="l00261"></a>00261         <span class="keywordflow">case</span> 2:
<a name="l00262"></a>00262           {
<a name="l00263"></a>00263             
<a name="l00264"></a>00264             <span class="comment">// Where our current iterate \p p maps to.</span>
<a name="l00265"></a>00265             <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> physical_guess = <a class="code" href="classFE.php#ad693264af6f1ff8f2d736f73cadc8f3d">FE&lt;1,LAGRANGE&gt;::map</a> (base_elem.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>(), p);
<a name="l00266"></a>00266 
<a name="l00267"></a>00267             
<a name="l00268"></a>00268             <span class="comment">// How far our current iterate is from the actual point.</span>
<a name="l00269"></a>00269             <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> delta = physical_point - physical_guess;
<a name="l00270"></a>00270 
<a name="l00271"></a>00271 
<a name="l00272"></a>00272             <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> dxi = <a class="code" href="classFE.php#a8c834bbbbdca5a30a49fb9ffa5a3dd95">FE&lt;1,LAGRANGE&gt;::map_xi</a> (base_elem.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>(), p);
<a name="l00273"></a>00273             
<a name="l00274"></a>00274             
<a name="l00275"></a>00275             <span class="comment">// For details on Newton&#39;s method see fe_map.C          </span>
<a name="l00276"></a>00276             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> G = dxi*dxi;
<a name="l00277"></a>00277             
<a name="l00278"></a>00278             <span class="keywordflow">if</span> (secure)
<a name="l00279"></a>00279               libmesh_assert (G &gt; 0.);
<a name="l00280"></a>00280             
<a name="l00281"></a>00281             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> Ginv = 1./G;
<a name="l00282"></a>00282             
<a name="l00283"></a>00283             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>  dxidelta = dxi*delta;
<a name="l00284"></a>00284             
<a name="l00285"></a>00285             <span class="comment">// compute only the first coordinate</span>
<a name="l00286"></a>00286             dp(0) = Ginv*dxidelta;
<a name="l00287"></a>00287 
<a name="l00288"></a>00288             <span class="keywordflow">break</span>;
<a name="l00289"></a>00289           }
<a name="l00290"></a>00290 
<a name="l00291"></a>00291 
<a name="l00292"></a>00292           
<a name="l00293"></a>00293           <span class="comment">//------------------------------------------------------------------</span>
<a name="l00294"></a>00294           <span class="comment">// 3D infinite element - 2D map inversion</span>
<a name="l00295"></a>00295           <span class="comment">//</span>
<a name="l00296"></a>00296           <span class="comment">// In this iteration scheme only search for the local coordinates</span>
<a name="l00297"></a>00297           <span class="comment">// in xi and eta direction.  Once xi, eta are determined, the radial</span>
<a name="l00298"></a>00298           <span class="comment">// coordinate zeta may directly computed. </span>
<a name="l00299"></a>00299         <span class="keywordflow">case</span> 3:
<a name="l00300"></a>00300           {
<a name="l00301"></a>00301 
<a name="l00302"></a>00302             
<a name="l00303"></a>00303             <span class="comment">// Where our current iterate \p p maps to.</span>
<a name="l00304"></a>00304             <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> physical_guess = <a class="code" href="classFE.php#ad693264af6f1ff8f2d736f73cadc8f3d">FE&lt;2,LAGRANGE&gt;::map</a> (base_elem.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>(), p);
<a name="l00305"></a>00305             
<a name="l00306"></a>00306             <span class="comment">// How far our current iterate is from the actual point.</span>
<a name="l00307"></a>00307             <span class="comment">// const Point delta = physical_point - physical_guess;</span>
<a name="l00308"></a>00308             <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> delta = intersection - physical_guess;
<a name="l00309"></a>00309 
<a name="l00310"></a>00310             <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> dxi  = <a class="code" href="classFE.php#a8c834bbbbdca5a30a49fb9ffa5a3dd95">FE&lt;2,LAGRANGE&gt;::map_xi</a>  (base_elem.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>(), p);
<a name="l00311"></a>00311             <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> deta = <a class="code" href="classFE.php#a18463361f35a76dc092bd5ead743e0bb">FE&lt;2,LAGRANGE&gt;::map_eta</a> (base_elem.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>(), p);
<a name="l00312"></a>00312             
<a name="l00313"></a>00313             
<a name="l00314"></a>00314             <span class="comment">// For details on Newton&#39;s method see fe_map.C          </span>
<a name="l00315"></a>00315             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>
<a name="l00316"></a>00316               G11 = dxi*dxi,  G12 = dxi*deta,
<a name="l00317"></a>00317               G21 = dxi*deta, G22 = deta*deta;
<a name="l00318"></a>00318             
<a name="l00319"></a>00319             
<a name="l00320"></a>00320             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> det = (G11*G22 - G12*G21);
<a name="l00321"></a>00321             
<a name="l00322"></a>00322             <span class="keywordflow">if</span> (secure)
<a name="l00323"></a>00323               {
<a name="l00324"></a>00324                 libmesh_assert (det &gt; 0.);
<a name="l00325"></a>00325                 libmesh_assert (std::abs(det) &gt; 1.e-10);
<a name="l00326"></a>00326               }
<a name="l00327"></a>00327 
<a name="l00328"></a>00328             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> inv_det = 1./det;
<a name="l00329"></a>00329             
<a name="l00330"></a>00330             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>
<a name="l00331"></a>00331               Ginv11 =  G22*inv_det,
<a name="l00332"></a>00332               Ginv12 = -G12*inv_det,
<a name="l00333"></a>00333               
<a name="l00334"></a>00334               Ginv21 = -G21*inv_det,
<a name="l00335"></a>00335               Ginv22 =  G11*inv_det;
<a name="l00336"></a>00336             
<a name="l00337"></a>00337             
<a name="l00338"></a>00338             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>  dxidelta  = dxi*delta;
<a name="l00339"></a>00339             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>  detadelta = deta*delta;
<a name="l00340"></a>00340             
<a name="l00341"></a>00341             <span class="comment">// compute only the first two coordinates.</span>
<a name="l00342"></a>00342             dp(0) = (Ginv11*dxidelta + Ginv12*detadelta);
<a name="l00343"></a>00343             dp(1) = (Ginv21*dxidelta + Ginv22*detadelta);
<a name="l00344"></a>00344 
<a name="l00345"></a>00345             <span class="keywordflow">break</span>;
<a name="l00346"></a>00346           }
<a name="l00347"></a>00347 
<a name="l00348"></a>00348 
<a name="l00349"></a>00349           
<a name="l00350"></a>00350           <span class="comment">// Some other dimension?</span>
<a name="l00351"></a>00351         <span class="keywordflow">default</span>:
<a name="l00352"></a>00352           libmesh_error();
<a name="l00353"></a>00353         } <span class="comment">// end switch(Dim), dp now computed</span>
<a name="l00354"></a>00354 
<a name="l00355"></a>00355 
<a name="l00356"></a>00356       
<a name="l00357"></a>00357       <span class="comment">// determine the error in computing the local coordinates</span>
<a name="l00358"></a>00358       <span class="comment">// in the base: ||P_n+1 - P_n||</span>
<a name="l00359"></a>00359       inverse_map_error = dp.<a class="code" href="classTypeVector.php#a34f47a12e12990aad2910a934bdaac7d">size</a>();
<a name="l00360"></a>00360 
<a name="l00361"></a>00361       
<a name="l00362"></a>00362       <span class="comment">// P_n+1 = P_n + dp</span>
<a name="l00363"></a>00363       p.<a class="code" href="classTypeVector.php#a5a491e5c665118253b6e2f65141c8922">add</a> (dp);
<a name="l00364"></a>00364 
<a name="l00365"></a>00365       
<a name="l00366"></a>00366       <span class="comment">// Increment the iteration count.</span>
<a name="l00367"></a>00367       cnt++;
<a name="l00368"></a>00368 
<a name="l00369"></a>00369       
<a name="l00370"></a>00370       <span class="comment">// Watch for divergence of Newton&#39;s</span>
<a name="l00371"></a>00371       <span class="comment">// method.</span>
<a name="l00372"></a>00372       <span class="keywordflow">if</span> (cnt &gt; 10)
<a name="l00373"></a>00373         {
<a name="l00374"></a>00374           <span class="keywordflow">if</span> (secure || !secure)
<a name="l00375"></a>00375             {
<a name="l00376"></a>00376               libmesh_here();
<a name="l00377"></a>00377               {
<a name="l00378"></a>00378                 std::cerr &lt;&lt; <span class="stringliteral">&quot;WARNING: Newton scheme has not converged in &quot;</span>
<a name="l00379"></a>00379                           &lt;&lt; cnt &lt;&lt; <span class="stringliteral">&quot; iterations:\n&quot;</span> 
<a name="l00380"></a>00380                           &lt;&lt; <span class="stringliteral">&quot;   physical_point=&quot;</span>
<a name="l00381"></a>00381                           &lt;&lt; physical_point
<a name="l00382"></a>00382                           &lt;&lt; <span class="stringliteral">&quot;   dp=&quot;</span>
<a name="l00383"></a>00383                           &lt;&lt; dp
<a name="l00384"></a>00384                           &lt;&lt; <span class="stringliteral">&quot;   p=&quot;</span>
<a name="l00385"></a>00385                           &lt;&lt; p
<a name="l00386"></a>00386                           &lt;&lt; <span class="stringliteral">&quot;   error=&quot;</span> &lt;&lt; inverse_map_error
<a name="l00387"></a>00387                           &lt;&lt; std::endl;
<a name="l00388"></a>00388               }
<a name="l00389"></a>00389             }
<a name="l00390"></a>00390 
<a name="l00391"></a>00391           <span class="keywordflow">if</span> (cnt &gt; 20)
<a name="l00392"></a>00392             {
<a name="l00393"></a>00393               std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Newton scheme FAILED to converge in &quot;</span>
<a name="l00394"></a>00394                         &lt;&lt; cnt &lt;&lt; <span class="stringliteral">&quot; iterations!&quot;</span> &lt;&lt; std::endl;
<a name="l00395"></a>00395               libmesh_error();
<a name="l00396"></a>00396             }
<a name="l00397"></a>00397 
<a name="l00398"></a>00398           <span class="comment">// else</span>
<a name="l00399"></a>00399           <span class="comment">//  {</span>
<a name="l00400"></a>00400           <span class="comment">//    break;</span>
<a name="l00401"></a>00401           <span class="comment">//  }</span>
<a name="l00402"></a>00402         }
<a name="l00403"></a>00403     }
<a name="l00404"></a>00404   <span class="keywordflow">while</span> (inverse_map_error &gt; tolerance);
<a name="l00405"></a>00405 
<a name="l00406"></a>00406 
<a name="l00407"></a>00407   
<a name="l00408"></a>00408   <span class="comment">// 4.</span>
<a name="l00409"></a>00409   <span class="comment">//</span>
<a name="l00410"></a>00410   <span class="comment">// Now that we have the local coordinates in the base,</span>
<a name="l00411"></a>00411   <span class="comment">// compute the interpolated radial distance a(s,t) \p a_interpolated</span>
<a name="l00412"></a>00412   <span class="keywordflow">if</span> (interpolated)
<a name="l00413"></a>00413     <span class="keywordflow">switch</span> (Dim)
<a name="l00414"></a>00414       {
<a name="l00415"></a>00415       <span class="keywordflow">case</span> 1:
<a name="l00416"></a>00416         {
<a name="l00417"></a>00417           <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> a_interpolated = <a class="code" href="classPoint.php">Point</a>( inf_elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0) 
<a name="l00418"></a>00418                                        - inf_elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(n_base_mapping_sf) ).size();
<a name="l00419"></a>00419           
<a name="l00420"></a>00420           p(0) = 1. - 2*a_interpolated/physical_point(0);
<a name="l00421"></a>00421           
<a name="l00422"></a>00422 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00423"></a>00423 <span class="preprocessor"></span>          <span class="comment">// the radial distance should always be &gt;= -1.</span>
<a name="l00424"></a>00424           
<a name="l00425"></a>00425           <span class="keywordflow">if</span> (p(0)+1 &lt; tolerance)
<a name="l00426"></a>00426             {
<a name="l00427"></a>00427               libmesh_here();
<a name="l00428"></a>00428               std::cerr &lt;&lt; <span class="stringliteral">&quot;WARNING: radial distance p(0) is &quot;</span>
<a name="l00429"></a>00429                         &lt;&lt; p(0)
<a name="l00430"></a>00430                         &lt;&lt; std::endl;
<a name="l00431"></a>00431             }
<a name="l00432"></a>00432 <span class="preprocessor">#endif</span>
<a name="l00433"></a>00433 <span class="preprocessor"></span>          
<a name="l00434"></a>00434           <span class="keywordflow">break</span>;
<a name="l00435"></a>00435         }
<a name="l00436"></a>00436         
<a name="l00437"></a>00437         
<a name="l00438"></a>00438       <span class="keywordflow">case</span> 2:
<a name="l00439"></a>00439         {
<a name="l00440"></a>00440           <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> a_interpolated = 0.;
<a name="l00441"></a>00441           
<a name="l00442"></a>00442           <span class="comment">// the distance between the origin and the physical point</span>
<a name="l00443"></a>00443           <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> fp_o_dist = <a class="code" href="classPoint.php">Point</a>(o-physical_point).<a class="code" href="classTypeVector.php#a34f47a12e12990aad2910a934bdaac7d">size</a>(); 
<a name="l00444"></a>00444           
<a name="l00445"></a>00445           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_base_mapping_sf; i++)
<a name="l00446"></a>00446             {
<a name="l00447"></a>00447               <span class="comment">// the radial distance of the i-th base mapping point</span>
<a name="l00448"></a>00448               <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> dist_i = <a class="code" href="classPoint.php">Point</a>( inf_elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(i) 
<a name="l00449"></a>00449                                          - inf_elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(i+n_base_mapping_sf) ).size();
<a name="l00450"></a>00450               <span class="comment">// weight with the corresponding shape function</span>
<a name="l00451"></a>00451               a_interpolated += dist_i * <a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">FE&lt;1,LAGRANGE&gt;::shape</a>(base_mapping_elem_type,
<a name="l00452"></a>00452                                                                base_mapping_order,
<a name="l00453"></a>00453                                                                i,
<a name="l00454"></a>00454                                                                p);
<a name="l00455"></a>00455             }
<a name="l00456"></a>00456           
<a name="l00457"></a>00457           p(1) = 1. - 2*a_interpolated/fp_o_dist;
<a name="l00458"></a>00458           
<a name="l00459"></a>00459 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00460"></a>00460 <span class="preprocessor"></span>          <span class="comment">// the radial distance should always be &gt;= -1.</span>
<a name="l00461"></a>00461           
<a name="l00462"></a>00462           <span class="comment">// if (p(1)+1 &lt; tolerance)</span>
<a name="l00463"></a>00463           <span class="comment">//  {</span>
<a name="l00464"></a>00464           <span class="comment">//    libmesh_here();</span>
<a name="l00465"></a>00465           <span class="comment">//    std::cerr &lt;&lt; &quot;WARNING: radial distance p(1) is &quot;</span>
<a name="l00466"></a>00466           <span class="comment">//          &lt;&lt; p(1)</span>
<a name="l00467"></a>00467           <span class="comment">//          &lt;&lt; std::endl;</span>
<a name="l00468"></a>00468           <span class="comment">//  }</span>
<a name="l00469"></a>00469 <span class="preprocessor">#endif</span>
<a name="l00470"></a>00470 <span class="preprocessor"></span>          
<a name="l00471"></a>00471           <span class="keywordflow">break</span>;
<a name="l00472"></a>00472         }
<a name="l00473"></a>00473         
<a name="l00474"></a>00474         
<a name="l00475"></a>00475       <span class="keywordflow">case</span> 3:
<a name="l00476"></a>00476         {
<a name="l00477"></a>00477           <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> a_interpolated = 0.;
<a name="l00478"></a>00478           
<a name="l00479"></a>00479           
<a name="l00480"></a>00480           <span class="comment">// the distance between the origin and the physical point</span>
<a name="l00481"></a>00481           <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> fp_o_dist = <a class="code" href="classPoint.php">Point</a>(o-physical_point).<a class="code" href="classTypeVector.php#a34f47a12e12990aad2910a934bdaac7d">size</a>(); 
<a name="l00482"></a>00482           
<a name="l00483"></a>00483           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_base_mapping_sf; i++)
<a name="l00484"></a>00484             {
<a name="l00485"></a>00485               <span class="comment">// the radial distance of the i-th base mapping point</span>
<a name="l00486"></a>00486               <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> dist_i = <a class="code" href="classPoint.php">Point</a>( inf_elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(i) 
<a name="l00487"></a>00487                                          - inf_elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(i+n_base_mapping_sf) ).size();
<a name="l00488"></a>00488               
<a name="l00489"></a>00489               <span class="comment">// weight with the corresponding shape function</span>
<a name="l00490"></a>00490               a_interpolated += dist_i * <a class="code" href="classFE.php#ab2ed637c8ff95e7e3f508138d29bd8d5">FE&lt;2,LAGRANGE&gt;::shape</a>(base_mapping_elem_type,
<a name="l00491"></a>00491                                                                base_mapping_order,
<a name="l00492"></a>00492                                                                i,
<a name="l00493"></a>00493                                                                p);
<a name="l00494"></a>00494               
<a name="l00495"></a>00495             }
<a name="l00496"></a>00496           
<a name="l00497"></a>00497           p(2) = 1. - 2*a_interpolated/fp_o_dist;
<a name="l00498"></a>00498           
<a name="l00499"></a>00499 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00500"></a>00500 <span class="preprocessor"></span>          
<a name="l00501"></a>00501           
<a name="l00502"></a>00502           <span class="comment">// the radial distance should always be &gt;= -1.</span>
<a name="l00503"></a>00503           
<a name="l00504"></a>00504           <span class="comment">// if (p(2)+1 &lt; tolerance)</span>
<a name="l00505"></a>00505           <span class="comment">//  {</span>
<a name="l00506"></a>00506           <span class="comment">// libmesh_here();</span>
<a name="l00507"></a>00507           <span class="comment">// std::cerr &lt;&lt; &quot;WARNING: radial distance p(2) is &quot;</span>
<a name="l00508"></a>00508           <span class="comment">//          &lt;&lt; p(2)</span>
<a name="l00509"></a>00509           <span class="comment">//          &lt;&lt; std::endl;</span>
<a name="l00510"></a>00510           <span class="comment">//  }</span>
<a name="l00511"></a>00511 <span class="preprocessor">#endif</span>
<a name="l00512"></a>00512 <span class="preprocessor"></span>          
<a name="l00513"></a>00513           <span class="keywordflow">break</span>;
<a name="l00514"></a>00514         }
<a name="l00515"></a>00515         
<a name="l00516"></a>00516       <span class="keywordflow">default</span>:
<a name="l00517"></a>00517         libmesh_error();
<a name="l00518"></a>00518       } <span class="comment">// end switch(Dim), p fully computed, including radial part</span>
<a name="l00519"></a>00519 
<a name="l00520"></a>00520   <span class="comment">// if we do not want the interpolated distance, then</span>
<a name="l00521"></a>00521   <span class="comment">// use newton iteration to get the actual distance</span>
<a name="l00522"></a>00522   <span class="keywordflow">else</span>
<a name="l00523"></a>00523     {
<a name="l00524"></a>00524       <span class="comment">// distance from the physical point to the ifem origin</span>
<a name="l00525"></a>00525       <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> fp_o_dist = <a class="code" href="classPoint.php">Point</a>(o-physical_point).<a class="code" href="classTypeVector.php#a34f47a12e12990aad2910a934bdaac7d">size</a>(); 
<a name="l00526"></a>00526 
<a name="l00527"></a>00527       <span class="comment">// the distance from the intersection on the</span>
<a name="l00528"></a>00528       <span class="comment">// base to the origin</span>
<a name="l00529"></a>00529       <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> a_dist = intersection.<a class="code" href="classTypeVector.php#a34f47a12e12990aad2910a934bdaac7d">size</a>();
<a name="l00530"></a>00530       
<a name="l00531"></a>00531       <span class="comment">// element coordinate in radial direction</span>
<a name="l00532"></a>00532       <span class="comment">// here our first guess is 0.</span>
<a name="l00533"></a>00533       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> v = 0.;
<a name="l00534"></a>00534       
<a name="l00535"></a>00535       <span class="comment">// the order of the radial mapping</span>
<a name="l00536"></a>00536       <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> radial_mapping_order (<a class="code" href="classInfFE_1_1Radial.php#aeceb2b92aa173eca15ff2a94ad542a51">Radial::mapping_order</a>());    
<a name="l00537"></a>00537       
<a name="l00538"></a>00538       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt = 0;
<a name="l00539"></a>00539       inverse_map_error = 0.;
<a name="l00540"></a>00540       
<a name="l00541"></a>00541       <span class="comment">// Newton iteration in 1-D</span>
<a name="l00542"></a>00542       <span class="keywordflow">do</span>
<a name="l00543"></a>00543         {
<a name="l00544"></a>00544           <span class="comment">// the mapping in radial direction</span>
<a name="l00545"></a>00545           <span class="comment">// note that we only have two mapping functions in</span>
<a name="l00546"></a>00546           <span class="comment">// radial direction</span>
<a name="l00547"></a>00547           <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> r = a_dist * <a class="code" href="classInfFE.php#a7e6f2cfd05c60216d10a46d589c280ef">InfFE&lt;Dim,INFINITE_MAP,T_map&gt;::eval</a> (v, radial_mapping_order, 0)
<a name="l00548"></a>00548             + 2. * a_dist * <a class="code" href="classInfFE.php#a7e6f2cfd05c60216d10a46d589c280ef">InfFE&lt;Dim,INFINITE_MAP,T_map&gt;::eval</a> (v, radial_mapping_order, 1);
<a name="l00549"></a>00549           
<a name="l00550"></a>00550           <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> dr = a_dist * <a class="code" href="classInfFE.php#a0c59d8a76070b7d28d3e0b9d8e015a11">InfFE&lt;Dim,INFINITE_MAP,T_map&gt;::eval_deriv</a> (v, radial_mapping_order, 0)
<a name="l00551"></a>00551             + 2. * a_dist * <a class="code" href="classInfFE.php#a0c59d8a76070b7d28d3e0b9d8e015a11">InfFE&lt;Dim,INFINITE_MAP,T_map&gt;::eval_deriv</a> (v, radial_mapping_order, 1);
<a name="l00552"></a>00552           
<a name="l00553"></a>00553           <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> G = dr*dr;
<a name="l00554"></a>00554           <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> Ginv = 1./G;
<a name="l00555"></a>00555           
<a name="l00556"></a>00556           <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> delta = fp_o_dist - r;
<a name="l00557"></a>00557           <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> drdelta = dr*delta;
<a name="l00558"></a>00558           
<a name="l00559"></a>00559           <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> dp = Ginv*drdelta;
<a name="l00560"></a>00560           
<a name="l00561"></a>00561           <span class="comment">// update the radial coordinate</span>
<a name="l00562"></a>00562           v += dp;
<a name="l00563"></a>00563           
<a name="l00564"></a>00564           <span class="comment">// note that v should be smaller than 1,</span>
<a name="l00565"></a>00565           <span class="comment">// since radial mapping function tends to infinity</span>
<a name="l00566"></a>00566           <span class="keywordflow">if</span> (v &gt;= 1.)
<a name="l00567"></a>00567             v = .9999;
<a name="l00568"></a>00568           
<a name="l00569"></a>00569           inverse_map_error = std::fabs(dp);
<a name="l00570"></a>00570           
<a name="l00571"></a>00571           <span class="comment">// increment iteration count</span>
<a name="l00572"></a>00572           cnt ++;
<a name="l00573"></a>00573           <span class="keywordflow">if</span> (cnt &gt; 20)
<a name="l00574"></a>00574             {
<a name="l00575"></a>00575               
<a name="l00576"></a>00576               std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: 1D Newton scheme FAILED to converge&quot;</span>
<a name="l00577"></a>00577                         &lt;&lt; std::endl;
<a name="l00578"></a>00578               
<a name="l00579"></a>00579               libmesh_error();
<a name="l00580"></a>00580             }
<a name="l00581"></a>00581           
<a name="l00582"></a>00582           
<a name="l00583"></a>00583         }
<a name="l00584"></a>00584       <span class="keywordflow">while</span> (inverse_map_error &gt; tolerance);
<a name="l00585"></a>00585 
<a name="l00586"></a>00586       <span class="keywordflow">switch</span> (Dim)
<a name="l00587"></a>00587         {
<a name="l00588"></a>00588         <span class="keywordflow">case</span> 1:
<a name="l00589"></a>00589           {
<a name="l00590"></a>00590             p(0) = v;
<a name="l00591"></a>00591             <span class="keywordflow">break</span>;
<a name="l00592"></a>00592           }
<a name="l00593"></a>00593         <span class="keywordflow">case</span> 2:
<a name="l00594"></a>00594           {
<a name="l00595"></a>00595             p(1) = v;
<a name="l00596"></a>00596             <span class="keywordflow">break</span>;
<a name="l00597"></a>00597           }
<a name="l00598"></a>00598         <span class="keywordflow">case</span> 3:
<a name="l00599"></a>00599           {
<a name="l00600"></a>00600             p(2) = v;
<a name="l00601"></a>00601             <span class="keywordflow">break</span>;
<a name="l00602"></a>00602           }
<a name="l00603"></a>00603         <span class="keywordflow">default</span>:
<a name="l00604"></a>00604           libmesh_error();
<a name="l00605"></a>00605         }
<a name="l00606"></a>00606     }
<a name="l00607"></a>00607   
<a name="l00608"></a>00608   <span class="comment">// If we are in debug mode do a sanity check.  Make sure</span>
<a name="l00609"></a>00609   <span class="comment">// the point \p p on the reference element actually does</span>
<a name="l00610"></a>00610   <span class="comment">// map to the point \p physical_point within a tolerance. </span>
<a name="l00611"></a>00611 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00612"></a>00612 <span class="preprocessor"></span>  <span class="comment">/*    </span>
<a name="l00613"></a>00613 <span class="comment">        const Point check = InfFE&lt;Dim,T_radial,T_map&gt;::map (inf_elem, p);</span>
<a name="l00614"></a>00614 <span class="comment">        const Point diff  = physical_point - check;</span>
<a name="l00615"></a>00615 <span class="comment">  </span>
<a name="l00616"></a>00616 <span class="comment">        if (diff.size() &gt; tolerance)</span>
<a name="l00617"></a>00617 <span class="comment">        {</span>
<a name="l00618"></a>00618 <span class="comment">        libmesh_here();</span>
<a name="l00619"></a>00619 <span class="comment">        std::cerr &lt;&lt; &quot;WARNING:  diff is &quot;</span>
<a name="l00620"></a>00620 <span class="comment">        &lt;&lt; diff.size()</span>
<a name="l00621"></a>00621 <span class="comment">        &lt;&lt; std::endl;</span>
<a name="l00622"></a>00622 <span class="comment">        }</span>
<a name="l00623"></a>00623 <span class="comment">  */</span>
<a name="l00624"></a>00624 <span class="preprocessor">#endif</span>
<a name="l00625"></a>00625 <span class="preprocessor"></span>
<a name="l00626"></a>00626 
<a name="l00627"></a>00627 
<a name="l00628"></a>00628   
<a name="l00629"></a>00629   <span class="comment">// Stop logging the map inversion.</span>
<a name="l00630"></a>00630   STOP_LOG(<span class="stringliteral">&quot;inverse_map()&quot;</span>, <span class="stringliteral">&quot;InfFE&quot;</span>);
<a name="l00631"></a>00631   
<a name="l00632"></a>00632   <span class="keywordflow">return</span> p;
<a name="l00633"></a>00633 }
<a name="l00634"></a>00634 
<a name="l00635"></a>00635 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00636"></a><a class="code" href="classInfFE.php#a6b8b0a92bbdee3117054a7138dcd153e">00636</a> <span class="keywordtype">void</span> <a class="code" href="classInfFE.php#ad3ae911e9714c059f519c72467cda290">InfFE&lt;Dim,T_radial,T_map&gt;::inverse_map</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00637"></a>00637                                              <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; physical_points,
<a name="l00638"></a>00638                                              std::vector&lt;Point&gt;&amp;       reference_points,
<a name="l00639"></a>00639                                              <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tolerance,
<a name="l00640"></a>00640                                              <span class="keyword">const</span> <span class="keywordtype">bool</span> secure)
<a name="l00641"></a>00641 {
<a name="l00642"></a>00642   <span class="comment">// The number of points to find the</span>
<a name="l00643"></a>00643   <span class="comment">// inverse map of</span>
<a name="l00644"></a>00644   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_points = physical_points.<a class="code" href="classTypeVector.php#a34f47a12e12990aad2910a934bdaac7d">size</a>();
<a name="l00645"></a>00645 
<a name="l00646"></a>00646   <span class="comment">// Resize the vector to hold the points</span>
<a name="l00647"></a>00647   <span class="comment">// on the reference element</span>
<a name="l00648"></a>00648   reference_points.resize(n_points);
<a name="l00649"></a>00649 
<a name="l00650"></a>00650   <span class="comment">// Find the coordinates on the reference</span>
<a name="l00651"></a>00651   <span class="comment">// element of each point in physical space</span>
<a name="l00652"></a>00652   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_points; p++)
<a name="l00653"></a>00653     reference_points[p] =
<a name="l00654"></a>00654       <a class="code" href="classInfFE.php">InfFE&lt;Dim,T_radial,T_map&gt;::inverse_map</a> (elem, physical_points[p], tolerance, secure, <span class="keyword">false</span>);
<a name="l00655"></a>00655 }
<a name="l00656"></a>00656 
<a name="l00657"></a>00657 
<a name="l00658"></a>00658 
<a name="l00659"></a>00659 
<a name="l00660"></a>00660 <span class="comment">//--------------------------------------------------------------</span>
<a name="l00661"></a>00661 <span class="comment">// Explicit instantiations using the macro from inf_fe_macro.h</span>
<a name="l00662"></a>00662 <span class="comment">//INSTANTIATE_INF_FE(1,CARTESIAN);</span>
<a name="l00663"></a>00663 
<a name="l00664"></a>00664 <span class="comment">//INSTANTIATE_INF_FE(2,CARTESIAN);</span>
<a name="l00665"></a>00665 
<a name="l00666"></a>00666 <span class="comment">//INSTANTIATE_INF_FE(3,CARTESIAN);</span>
<a name="l00667"></a>00667 
<a name="l00668"></a>00668 <a class="code" href="inf__fe__base__radial_8C.php#acc280d85be9e67f2256f3165252e55f2">INSTANTIATE_INF_FE_MBRF</a>(1,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<a class="code" href="classPoint.php">Point</a>,<a class="code" href="classInfFE.php#ad3ae911e9714c059f519c72467cda290">inverse_map</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*,<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp;,<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>,<span class="keyword">const</span> <span class="keywordtype">bool</span>,<span class="keyword">const</span> <span class="keywordtype">bool</span>));
<a name="l00669"></a>00669 <a class="code" href="inf__fe__base__radial_8C.php#acc280d85be9e67f2256f3165252e55f2">INSTANTIATE_INF_FE_MBRF</a>(2,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<a class="code" href="classPoint.php">Point</a>,<a class="code" href="classInfFE.php#ad3ae911e9714c059f519c72467cda290">inverse_map</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*,<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp;,<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>,<span class="keyword">const</span> <span class="keywordtype">bool</span>,<span class="keyword">const</span> <span class="keywordtype">bool</span>));
<a name="l00670"></a>00670 <a class="code" href="inf__fe__base__radial_8C.php#acc280d85be9e67f2256f3165252e55f2">INSTANTIATE_INF_FE_MBRF</a>(3,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<a class="code" href="classPoint.php">Point</a>,<a class="code" href="classInfFE.php#ad3ae911e9714c059f519c72467cda290">inverse_map</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*,<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp;,<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>,<span class="keyword">const</span> <span class="keywordtype">bool</span>,<span class="keyword">const</span> <span class="keywordtype">bool</span>));
<a name="l00671"></a>00671 
<a name="l00672"></a>00672 <a class="code" href="inf__fe__base__radial_8C.php#acc280d85be9e67f2256f3165252e55f2">INSTANTIATE_INF_FE_MBRF</a>(1,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">void</span>,<a class="code" href="classInfFE.php#ad3ae911e9714c059f519c72467cda290">inverse_map</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*,<span class="keyword">const</span> std::vector&lt;Point&gt;&amp;,std::vector&lt;Point&gt;&amp;,<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>, <span class="keyword">const</span> <span class="keywordtype">bool</span>));
<a name="l00673"></a>00673 <a class="code" href="inf__fe__base__radial_8C.php#acc280d85be9e67f2256f3165252e55f2">INSTANTIATE_INF_FE_MBRF</a>(2,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">void</span>,<a class="code" href="classInfFE.php#ad3ae911e9714c059f519c72467cda290">inverse_map</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*,<span class="keyword">const</span> std::vector&lt;Point&gt;&amp;,std::vector&lt;Point&gt;&amp;,<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>, <span class="keyword">const</span> <span class="keywordtype">bool</span>));
<a name="l00674"></a>00674 <a class="code" href="inf__fe__base__radial_8C.php#acc280d85be9e67f2256f3165252e55f2">INSTANTIATE_INF_FE_MBRF</a>(3,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">void</span>,<a class="code" href="classInfFE.php#ad3ae911e9714c059f519c72467cda290">inverse_map</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*,<span class="keyword">const</span> std::vector&lt;Point&gt;&amp;,std::vector&lt;Point&gt;&amp;,<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>, <span class="keyword">const</span> <span class="keywordtype">bool</span>));
<a name="l00675"></a>00675 
<a name="l00676"></a>00676 
<a name="l00677"></a>00677 
<a name="l00678"></a>00678 <span class="preprocessor">#endif //ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00679"></a>00679 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
