<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_a0136eca6b184c0d854bbc4a8414e31c.php">fe</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>inf_fe_map_eval.C</h1>  </div>
</div>
<div class="contents">
<a href="inf__fe__map__eval_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: inf_fe_map_eval.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// Local includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#include &quot;inf_fe.h&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00029"></a>00029 <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classInfFE.php#a7e6f2cfd05c60216d10a46d589c280ef">InfFE&lt;Dim,T_radial,T_map&gt;::eval</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> v,
<a name="l00030"></a>00030                                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>, <span class="comment">/* not used */</span>
<a name="l00031"></a>00031                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033   libmesh_assert (-1.-1.e-5 &lt;= v &amp;&amp; v &lt; 1.);
<a name="l00034"></a>00034 
<a name="l00035"></a>00035   <span class="keywordflow">switch</span> (i)
<a name="l00036"></a>00036     {
<a name="l00037"></a>00037     <span class="keywordflow">case</span> 0:
<a name="l00038"></a>00038       <span class="keywordflow">return</span> -2.*v/(1.-v);
<a name="l00039"></a>00039     <span class="keywordflow">case</span> 1:
<a name="l00040"></a>00040       <span class="keywordflow">return</span> (1.+v)/(1.-v);
<a name="l00041"></a>00041 
<a name="l00042"></a>00042     <span class="keywordflow">default</span>:
<a name="l00043"></a>00043       std::cerr &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00044"></a>00044       libmesh_error();
<a name="l00045"></a>00045 
<a name="l00046"></a>00046     }
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   <span class="comment">// we never end up here.</span>
<a name="l00049"></a>00049   libmesh_error();
<a name="l00050"></a>00050   <span class="keywordflow">return</span> 0.;
<a name="l00051"></a>00051 }
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00056"></a>00056 <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classInfFE.php#a0c59d8a76070b7d28d3e0b9d8e015a11">InfFE&lt;Dim,T_radial,T_map&gt;::eval_deriv</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> v,
<a name="l00057"></a>00057                                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>, <span class="comment">/* not used */</span>
<a name="l00058"></a>00058                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060   libmesh_assert (-1.-1.e-5 &lt;= v &amp;&amp; v &lt; 1.);
<a name="l00061"></a>00061 
<a name="l00062"></a>00062   <span class="keywordflow">switch</span> (i)
<a name="l00063"></a>00063     {
<a name="l00064"></a>00064     <span class="keywordflow">case</span> 0:
<a name="l00065"></a>00065       <span class="keywordflow">return</span> -2./((1.-v)*(1.-v));
<a name="l00066"></a>00066     <span class="keywordflow">case</span> 1:
<a name="l00067"></a>00067       <span class="keywordflow">return</span> 2./((1.-v)*(1.-v));
<a name="l00068"></a>00068 
<a name="l00069"></a>00069     <span class="keywordflow">default</span>:
<a name="l00070"></a>00070       std::cerr &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00071"></a>00071       libmesh_error();
<a name="l00072"></a>00072 
<a name="l00073"></a>00073     }
<a name="l00074"></a>00074 
<a name="l00075"></a>00075   <span class="comment">// we never end up here.</span>
<a name="l00076"></a>00076   libmesh_error();
<a name="l00077"></a>00077   <span class="keywordflow">return</span> 0.;
<a name="l00078"></a>00078 }
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 <span class="comment">//--------------------------------------------------------------</span>
<a name="l00083"></a>00083 <span class="comment">// Explicit instantiations</span>
<a name="l00084"></a>00084 <span class="comment">// template class InfFE&lt;1,INFINITE_MAP,CARTESIAN&gt;;</span>
<a name="l00085"></a>00085 <span class="comment">// template class InfFE&lt;2,INFINITE_MAP,CARTESIAN&gt;;</span>
<a name="l00086"></a>00086 <span class="comment">// template class InfFE&lt;3,INFINITE_MAP,CARTESIAN&gt;;</span>
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 <span class="comment">// template class InfFE&lt;1,INFINITE_MAP,SPHERICAL&gt;;</span>
<a name="l00089"></a>00089 <span class="comment">// template class InfFE&lt;2,INFINITE_MAP,SPHERICAL&gt;;</span>
<a name="l00090"></a>00090 <span class="comment">// template class InfFE&lt;3,INFINITE_MAP,SPHERICAL&gt;;</span>
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 <span class="comment">// template class InfFE&lt;1,INFINITE_MAP,ELLIPSOIDAL&gt;;</span>
<a name="l00093"></a>00093 <span class="comment">// template class InfFE&lt;2,INFINITE_MAP,ELLIPSOIDAL&gt;;</span>
<a name="l00094"></a>00094 <span class="comment">// template class InfFE&lt;3,INFINITE_MAP,ELLIPSOIDAL&gt;;</span>
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 <span class="keyword">template</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classInfFE.php#a7e6f2cfd05c60216d10a46d589c280ef">InfFE&lt;1,INFINITE_MAP,CARTESIAN&gt;::eval</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00097"></a>00097 <span class="keyword">template</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classInfFE.php#a0c59d8a76070b7d28d3e0b9d8e015a11">InfFE&lt;1,INFINITE_MAP,CARTESIAN&gt;::eval_deriv</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00098"></a>00098 <span class="keyword">template</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classInfFE.php#a7e6f2cfd05c60216d10a46d589c280ef">InfFE&lt;2,INFINITE_MAP,CARTESIAN&gt;::eval</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00099"></a>00099 <span class="keyword">template</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classInfFE.php#a0c59d8a76070b7d28d3e0b9d8e015a11">InfFE&lt;2,INFINITE_MAP,CARTESIAN&gt;::eval_deriv</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00100"></a>00100 <span class="keyword">template</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classInfFE.php#a7e6f2cfd05c60216d10a46d589c280ef">InfFE&lt;3,INFINITE_MAP,CARTESIAN&gt;::eval</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00101"></a>00101 <span class="keyword">template</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classInfFE.php#a0c59d8a76070b7d28d3e0b9d8e015a11">InfFE&lt;3,INFINITE_MAP,CARTESIAN&gt;::eval_deriv</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 <span class="preprocessor">#endif //ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00104"></a>00104 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
