<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c8cf73965feff5280e8b0581da1a9d14.php">error_estimation</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>jump_error_estimator.h</h1>  </div>
</div>
<div class="contents">
<a href="jump__error__estimator_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: jump_error_estimator.h 3397 2009-06-08 22:09:06Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __jump_error_estimator_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __jump_error_estimator_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;auto_ptr.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;dense_vector.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="error__estimator_8h.php">error_estimator.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;fe_base.h&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Forward Declarations</span>
<a name="l00036"></a>00036 <span class="keyword">class </span><a class="code" href="classPoint.php">Point</a>;
<a name="l00037"></a>00037 <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00049"></a><a class="code" href="classJumpErrorEstimator.php">00049</a> <span class="keyword">class </span><a class="code" href="classJumpErrorEstimator.php">JumpErrorEstimator</a> : <span class="keyword">public</span> <a class="code" href="classErrorEstimator.php">ErrorEstimator</a>
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 <span class="keyword">public</span>:
<a name="l00052"></a>00052 
<a name="l00056"></a><a class="code" href="classJumpErrorEstimator.php#a8cb511801d76e73c5514d3fc2c9e8583">00056</a>   <a class="code" href="classJumpErrorEstimator.php#a8cb511801d76e73c5514d3fc2c9e8583">JumpErrorEstimator</a>()
<a name="l00057"></a>00057     : <a class="code" href="classJumpErrorEstimator.php#a9555b0be960b95361340baa3b32300ed">scale_by_n_flux_faces</a>(false),
<a name="l00058"></a>00058       <a class="code" href="classJumpErrorEstimator.php#a7f5f4bcc5fb6615e1e1c13124f8b62ef">integrate_boundary_sides</a>(false),
<a name="l00059"></a>00059       <a class="code" href="classJumpErrorEstimator.php#af7b7b6bcf4b6a66f672d8d6aa1425f8b">fe_fine</a>(NULL), <a class="code" href="classJumpErrorEstimator.php#aa8d90652c7db1938c0365a1a20d15d44">fe_coarse</a>(NULL) {}
<a name="l00060"></a>00060   
<a name="l00064"></a><a class="code" href="classJumpErrorEstimator.php#a4443ed623ed47c3f8ef5d458c0abbea3">00064</a>   <span class="keyword">virtual</span> <a class="code" href="classJumpErrorEstimator.php#a4443ed623ed47c3f8ef5d458c0abbea3">~JumpErrorEstimator</a>() {}
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00073"></a>00073   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classJumpErrorEstimator.php#ad3e546c8f4df715b82faea55b5fc7a59">estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; system,
<a name="l00074"></a>00074                                <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00075"></a>00075                                <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector = NULL,
<a name="l00076"></a>00076                                <span class="keywordtype">bool</span> estimate_parent_error = <span class="keyword">false</span>);
<a name="l00077"></a>00077 
<a name="l00086"></a><a class="code" href="classJumpErrorEstimator.php#a9555b0be960b95361340baa3b32300ed">00086</a>   <span class="keywordtype">bool</span> <a class="code" href="classJumpErrorEstimator.php#a9555b0be960b95361340baa3b32300ed">scale_by_n_flux_faces</a>;
<a name="l00087"></a>00087   
<a name="l00088"></a>00088 <span class="keyword">protected</span>:
<a name="l00093"></a>00093   <span class="keywordtype">void</span> <a class="code" href="classJumpErrorEstimator.php#aa3adc33c558c78b7aefe1b453c665c2a">reinit_sides</a>();
<a name="l00094"></a>00094 
<a name="l00098"></a>00098   <span class="keywordtype">float</span> <a class="code" href="classJumpErrorEstimator.php#ad4c103bf6937c53838b1471b6ee7f8eb">coarse_n_flux_faces_increment</a>();
<a name="l00099"></a>00099 
<a name="l00104"></a>00104   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classJumpErrorEstimator.php#a5df5a3b20a16727880940aec54c36551">initialize</a>(<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; system,
<a name="l00105"></a>00105                           <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00106"></a>00106                           <span class="keywordtype">bool</span> estimate_parent_error);
<a name="l00107"></a>00107 
<a name="l00112"></a>00112   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classJumpErrorEstimator.php#a59d3a8f2b351d04909630d7f60aa2a5c">internal_side_integration</a>() = 0;
<a name="l00113"></a>00113 
<a name="l00119"></a><a class="code" href="classJumpErrorEstimator.php#aa9c23c1ab1db68a2308b4a2b38d8de66">00119</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classJumpErrorEstimator.php#aa9c23c1ab1db68a2308b4a2b38d8de66">boundary_side_integration</a>() { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00120"></a>00120 
<a name="l00125"></a><a class="code" href="classJumpErrorEstimator.php#a7f5f4bcc5fb6615e1e1c13124f8b62ef">00125</a>   <span class="keywordtype">bool</span> <a class="code" href="classJumpErrorEstimator.php#a7f5f4bcc5fb6615e1e1c13124f8b62ef">integrate_boundary_sides</a>;
<a name="l00126"></a>00126 
<a name="l00130"></a><a class="code" href="classJumpErrorEstimator.php#a813dc049b5e8cd0b5e96b130d0e2b094">00130</a>   <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *<a class="code" href="classJumpErrorEstimator.php#a813dc049b5e8cd0b5e96b130d0e2b094">fine_elem</a>, *<a class="code" href="classJumpErrorEstimator.php#a02179d9a677d5e442e04f90632fbe644">coarse_elem</a>;
<a name="l00131"></a>00131 
<a name="l00135"></a><a class="code" href="classJumpErrorEstimator.php#ad275c8889735e2a7b77a47eeff699fd1">00135</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classJumpErrorEstimator.php#ad275c8889735e2a7b77a47eeff699fd1">fine_error</a>, <a class="code" href="classJumpErrorEstimator.php#a0f4b375625aa3fa51effb30615df849f">coarse_error</a>;
<a name="l00136"></a>00136 
<a name="l00140"></a><a class="code" href="classJumpErrorEstimator.php#aab10cd52c22b771a88a3bbbaa3e32791">00140</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classJumpErrorEstimator.php#aab10cd52c22b771a88a3bbbaa3e32791">fine_side</a>;
<a name="l00141"></a>00141 
<a name="l00145"></a><a class="code" href="classJumpErrorEstimator.php#aa8bca408aaa3bc1a0abc8a28bd77e20a">00145</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classJumpErrorEstimator.php#aa8bca408aaa3bc1a0abc8a28bd77e20a">var</a>;
<a name="l00146"></a>00146 
<a name="l00150"></a><a class="code" href="classJumpErrorEstimator.php#a57c383839934050b1cce133f7cd5aa9f">00150</a>   <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classJumpErrorEstimator.php#a57c383839934050b1cce133f7cd5aa9f">Ufine</a>, <a class="code" href="classJumpErrorEstimator.php#a27db10ac7041e9c97d190c66b97a7f5e">Ucoarse</a>;
<a name="l00151"></a>00151 
<a name="l00155"></a><a class="code" href="classJumpErrorEstimator.php#af7b7b6bcf4b6a66f672d8d6aa1425f8b">00155</a>   <a class="code" href="classAutoPtr.php">AutoPtr&lt;FEBase&gt;</a> <a class="code" href="classJumpErrorEstimator.php#af7b7b6bcf4b6a66f672d8d6aa1425f8b">fe_fine</a>, <a class="code" href="classJumpErrorEstimator.php#aa8d90652c7db1938c0365a1a20d15d44">fe_coarse</a>;
<a name="l00156"></a>00156 };
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 <span class="preprocessor">#endif</span>
<a name="l00160"></a>00160 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
