<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_570b8306c88722caf9b7ae131e1a07b6.php">error_estimation</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>kelly_error_estimator.C</h1>  </div>
</div>
<div class="contents">
<a href="kelly__error__estimator_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: kelly_error_estimator.C 3428 2009-07-17 01:51:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::fill</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;cmath&gt;</span>    <span class="comment">// for sqrt</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local Includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;kelly_error_estimator.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;error_vector.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;fe.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;fe_interface.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;quadrature_gauss.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;system.h&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;dense_vector.h&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="keywordtype">void</span>
<a name="l00042"></a><a class="code" href="classKellyErrorEstimator.php#aba57894327ae45e6089a09fcebef5ea2">00042</a> <a class="code" href="classKellyErrorEstimator.php#aba57894327ae45e6089a09fcebef5ea2">KellyErrorEstimator::initialize</a>(<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; system,
<a name="l00043"></a>00043                                 <a class="code" href="classErrorVector.php">ErrorVector</a>&amp;,
<a name="l00044"></a>00044                                 <span class="keywordtype">bool</span>)
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046   <span class="comment">// Hang onto the system - we may need it for variable names later.</span>
<a name="l00047"></a>00047   <a class="code" href="classKellyErrorEstimator.php#a18d975f446b5b65fca97f17fa7b058f6">my_system</a> = &amp;system;
<a name="l00048"></a>00048 
<a name="l00049"></a>00049   <span class="comment">// We&#39;ll need gradients and normal vectors for flux jump computation</span>
<a name="l00050"></a>00050   <a class="code" href="classJumpErrorEstimator.php#af7b7b6bcf4b6a66f672d8d6aa1425f8b">fe_fine</a>-&gt;get_dphi();
<a name="l00051"></a>00051   <a class="code" href="classJumpErrorEstimator.php#af7b7b6bcf4b6a66f672d8d6aa1425f8b">fe_fine</a>-&gt;get_normals();
<a name="l00052"></a>00052   <a class="code" href="classJumpErrorEstimator.php#aa8d90652c7db1938c0365a1a20d15d44">fe_coarse</a>-&gt;get_dphi();
<a name="l00053"></a>00053 }
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 <span class="keywordtype">void</span>
<a name="l00058"></a><a class="code" href="classKellyErrorEstimator.php#ab6b00c70512946bd07f0a2c82fdd42d6">00058</a> <a class="code" href="classKellyErrorEstimator.php#ab6b00c70512946bd07f0a2c82fdd42d6">KellyErrorEstimator::internal_side_integration</a> ()
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> error = 1.e-30;
<a name="l00061"></a>00061   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = <a class="code" href="classJumpErrorEstimator.php#af7b7b6bcf4b6a66f672d8d6aa1425f8b">fe_fine</a>-&gt;n_quadrature_points();
<a name="l00062"></a>00062   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_fine_dofs = <a class="code" href="classJumpErrorEstimator.php#a57c383839934050b1cce133f7cd5aa9f">Ufine</a>.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>();
<a name="l00063"></a>00063   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_coarse_dofs = <a class="code" href="classJumpErrorEstimator.php#a27db10ac7041e9c97d190c66b97a7f5e">Ucoarse</a>.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>();
<a name="l00064"></a>00064 
<a name="l00065"></a>00065   std::vector&lt;std::vector&lt;RealGradient&gt; &gt; dphi_coarse = <a class="code" href="classJumpErrorEstimator.php#aa8d90652c7db1938c0365a1a20d15d44">fe_coarse</a>-&gt;get_dphi();
<a name="l00066"></a>00066   std::vector&lt;std::vector&lt;RealGradient&gt; &gt; dphi_fine = <a class="code" href="classJumpErrorEstimator.php#af7b7b6bcf4b6a66f672d8d6aa1425f8b">fe_fine</a>-&gt;get_dphi();
<a name="l00067"></a>00067   std::vector&lt;Point&gt; face_normals = <a class="code" href="classJumpErrorEstimator.php#af7b7b6bcf4b6a66f672d8d6aa1425f8b">fe_fine</a>-&gt;get_normals();
<a name="l00068"></a>00068   std::vector&lt;Real&gt; JxW_face = <a class="code" href="classJumpErrorEstimator.php#af7b7b6bcf4b6a66f672d8d6aa1425f8b">fe_fine</a>-&gt;get_JxW();
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp != n_qp; ++qp)
<a name="l00071"></a>00071     {
<a name="l00072"></a>00072       <span class="comment">// Calculate solution gradients on fine and coarse elements</span>
<a name="l00073"></a>00073       <span class="comment">// at this quadrature point</span>
<a name="l00074"></a>00074       <a class="code" href="classVectorValue.php">Gradient</a> grad_fine, grad_coarse;
<a name="l00075"></a>00075       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_coarse_dofs; ++i)
<a name="l00076"></a>00076         grad_coarse.<a class="code" href="classTypeVector.php#ac9000695cb19991b893cb79a07249e9c">add_scaled</a> (dphi_coarse[i][qp], <a class="code" href="classJumpErrorEstimator.php#a27db10ac7041e9c97d190c66b97a7f5e">Ucoarse</a>(i));
<a name="l00077"></a>00077 
<a name="l00078"></a>00078       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_fine_dofs; ++i)
<a name="l00079"></a>00079         grad_fine.<a class="code" href="classTypeVector.php#ac9000695cb19991b893cb79a07249e9c">add_scaled</a> (dphi_fine[i][qp], <a class="code" href="classJumpErrorEstimator.php#a57c383839934050b1cce133f7cd5aa9f">Ufine</a>(i));
<a name="l00080"></a>00080                                 
<a name="l00081"></a>00081       <span class="comment">// Find the jump in the normal derivative </span>
<a name="l00082"></a>00082       <span class="comment">// at this quadrature point</span>
<a name="l00083"></a>00083       <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> jump = (grad_fine - grad_coarse)*face_normals[qp];
<a name="l00084"></a>00084       <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> jump2 = <a class="code" href="libmesh__common_8h.php#af9cdd07341b53cc644199f6aec5e1420">libmesh_norm</a>(jump);
<a name="l00085"></a>00085 
<a name="l00086"></a>00086       <span class="comment">// Accumulate the jump integral</span>
<a name="l00087"></a>00087       error += JxW_face[qp] * jump2;
<a name="l00088"></a>00088     }
<a name="l00089"></a>00089 
<a name="l00090"></a>00090   <span class="comment">// Add the h-weighted jump integral to each error term</span>
<a name="l00091"></a>00091   <a class="code" href="classJumpErrorEstimator.php#ad275c8889735e2a7b77a47eeff699fd1">fine_error</a> =
<a name="l00092"></a>00092     error * <a class="code" href="classJumpErrorEstimator.php#a813dc049b5e8cd0b5e96b130d0e2b094">fine_elem</a>-&gt;<a class="code" href="classElem.php#aed45dccf181d13107eab2c2947d1afe6">hmax</a>() * <a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#ae8b33ea25655f66a4acc368c79723fed">weight</a>(<a class="code" href="classJumpErrorEstimator.php#aa8bca408aaa3bc1a0abc8a28bd77e20a">var</a>);
<a name="l00093"></a>00093   <a class="code" href="classJumpErrorEstimator.php#a0f4b375625aa3fa51effb30615df849f">coarse_error</a> =
<a name="l00094"></a>00094     error * <a class="code" href="classJumpErrorEstimator.php#a02179d9a677d5e442e04f90632fbe644">coarse_elem</a>-&gt;<a class="code" href="classElem.php#aed45dccf181d13107eab2c2947d1afe6">hmax</a>() * <a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#ae8b33ea25655f66a4acc368c79723fed">weight</a>(<a class="code" href="classJumpErrorEstimator.php#aa8bca408aaa3bc1a0abc8a28bd77e20a">var</a>);
<a name="l00095"></a>00095 }
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 <span class="keywordtype">bool</span>
<a name="l00099"></a><a class="code" href="classKellyErrorEstimator.php#a5d1746d81d7a359f2fb7f73f7b735542">00099</a> <a class="code" href="classKellyErrorEstimator.php#a5d1746d81d7a359f2fb7f73f7b735542">KellyErrorEstimator::boundary_side_integration</a> ()
<a name="l00100"></a>00100 {
<a name="l00101"></a>00101   <span class="keyword">const</span> std::string &amp;var_name = <a class="code" href="classKellyErrorEstimator.php#a18d975f446b5b65fca97f17fa7b058f6">my_system</a>-&gt;<a class="code" href="classSystem.php#af3a38b172dd6322eff9f30b3f63d3b63">variable_name</a>(<a class="code" href="classJumpErrorEstimator.php#aa8bca408aaa3bc1a0abc8a28bd77e20a">var</a>);
<a name="l00102"></a>00102 
<a name="l00103"></a>00103   std::vector&lt;std::vector&lt;RealGradient&gt; &gt; dphi_fine = <a class="code" href="classJumpErrorEstimator.php#af7b7b6bcf4b6a66f672d8d6aa1425f8b">fe_fine</a>-&gt;get_dphi();
<a name="l00104"></a>00104   std::vector&lt;Point&gt; face_normals = <a class="code" href="classJumpErrorEstimator.php#af7b7b6bcf4b6a66f672d8d6aa1425f8b">fe_fine</a>-&gt;get_normals();
<a name="l00105"></a>00105   std::vector&lt;Real&gt; JxW_face = <a class="code" href="classJumpErrorEstimator.php#af7b7b6bcf4b6a66f672d8d6aa1425f8b">fe_fine</a>-&gt;get_JxW();
<a name="l00106"></a>00106   std::vector&lt;Point&gt; qface_point = <a class="code" href="classJumpErrorEstimator.php#af7b7b6bcf4b6a66f672d8d6aa1425f8b">fe_fine</a>-&gt;get_xyz();
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   <span class="comment">// The reinitialization also recomputes the locations of</span>
<a name="l00109"></a>00109   <span class="comment">// the quadrature points on the side.  By checking if the</span>
<a name="l00110"></a>00110   <span class="comment">// first quadrature point on the side is on a flux boundary</span>
<a name="l00111"></a>00111   <span class="comment">// for a particular variable, we will determine if the whole</span>
<a name="l00112"></a>00112   <span class="comment">// element is on a flux boundary (assuming quadrature points</span>
<a name="l00113"></a>00113   <span class="comment">// are strictly contained in the side).</span>
<a name="l00114"></a>00114   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classKellyErrorEstimator.php#aeba45b0d593f5bc168fb97ff51317dd5">_bc_function</a>(*<a class="code" href="classKellyErrorEstimator.php#a18d975f446b5b65fca97f17fa7b058f6">my_system</a>, qface_point[0], var_name).first)
<a name="l00115"></a>00115     {
<a name="l00116"></a>00116       <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> h = <a class="code" href="classJumpErrorEstimator.php#a813dc049b5e8cd0b5e96b130d0e2b094">fine_elem</a>-&gt;<a class="code" href="classElem.php#aed45dccf181d13107eab2c2947d1afe6">hmax</a>();
<a name="l00117"></a>00117                     
<a name="l00118"></a>00118       <span class="comment">// The number of quadrature points</span>
<a name="l00119"></a>00119       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = <a class="code" href="classJumpErrorEstimator.php#af7b7b6bcf4b6a66f672d8d6aa1425f8b">fe_fine</a>-&gt;n_quadrature_points();
<a name="l00120"></a>00120 
<a name="l00121"></a>00121       <span class="comment">// The error contribution from this face</span>
<a name="l00122"></a>00122       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> error = 1.e-30;
<a name="l00123"></a>00123                     
<a name="l00124"></a>00124       <span class="comment">// loop over the integration points on the face.</span>
<a name="l00125"></a>00125       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;n_qp; qp++)
<a name="l00126"></a>00126         {
<a name="l00127"></a>00127           <span class="comment">// Value of the imposed flux BC at this quadrature point.</span>
<a name="l00128"></a>00128           <span class="keyword">const</span> std::pair&lt;bool,Real&gt; flux_bc =
<a name="l00129"></a>00129             this-&gt;<a class="code" href="classKellyErrorEstimator.php#aeba45b0d593f5bc168fb97ff51317dd5">_bc_function</a>(*<a class="code" href="classKellyErrorEstimator.php#a18d975f446b5b65fca97f17fa7b058f6">my_system</a>, qface_point[qp], var_name);
<a name="l00130"></a>00130 
<a name="l00131"></a>00131           <span class="comment">// Be sure the BC function still thinks we&#39;re on the </span>
<a name="l00132"></a>00132           <span class="comment">// flux boundary.</span>
<a name="l00133"></a>00133           libmesh_assert (flux_bc.first == <span class="keyword">true</span>);
<a name="l00134"></a>00134 
<a name="l00135"></a>00135           <span class="comment">// The solution gradient from each element</span>
<a name="l00136"></a>00136           <a class="code" href="classVectorValue.php">Gradient</a> grad_fine;
<a name="l00137"></a>00137 
<a name="l00138"></a>00138           <span class="comment">// Compute the solution gradient on element e</span>
<a name="l00139"></a>00139           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classJumpErrorEstimator.php#a57c383839934050b1cce133f7cd5aa9f">Ufine</a>.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>(); i++)
<a name="l00140"></a>00140             grad_fine.<a class="code" href="classTypeVector.php#ac9000695cb19991b893cb79a07249e9c">add_scaled</a> (dphi_fine[i][qp], <a class="code" href="classJumpErrorEstimator.php#a57c383839934050b1cce133f7cd5aa9f">Ufine</a>(i));
<a name="l00141"></a>00141 
<a name="l00142"></a>00142           <span class="comment">// The difference between the desired BC and the approximate solution. </span>
<a name="l00143"></a>00143           <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> jump = flux_bc.second - grad_fine*face_normals[qp];
<a name="l00144"></a>00144 
<a name="l00145"></a>00145           <span class="comment">// The flux jump squared.  If using complex numbers,</span>
<a name="l00146"></a>00146           <span class="comment">// libmesh_norm(z) returns |z|^2, where |z| is the modulus of z.</span>
<a name="l00147"></a>00147           <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> jump2 = <a class="code" href="libmesh__common_8h.php#af9cdd07341b53cc644199f6aec5e1420">libmesh_norm</a>(jump);
<a name="l00148"></a>00148 
<a name="l00149"></a>00149           <span class="comment">// Integrate the error on the face.  The error is</span>
<a name="l00150"></a>00150           <span class="comment">// scaled by an additional power of h, where h is</span>
<a name="l00151"></a>00151           <span class="comment">// the maximum side length for the element.  This</span>
<a name="l00152"></a>00152           <span class="comment">// arises in the definition of the indicator.</span>
<a name="l00153"></a>00153           error += JxW_face[qp]*jump2;                  
<a name="l00154"></a>00154                         
<a name="l00155"></a>00155         } <span class="comment">// End quadrature point loop</span>
<a name="l00156"></a>00156 
<a name="l00157"></a>00157       <a class="code" href="classJumpErrorEstimator.php#ad275c8889735e2a7b77a47eeff699fd1">fine_error</a> = error*h*<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#ae8b33ea25655f66a4acc368c79723fed">weight</a>(<a class="code" href="classJumpErrorEstimator.php#aa8bca408aaa3bc1a0abc8a28bd77e20a">var</a>);
<a name="l00158"></a>00158 
<a name="l00159"></a>00159       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00160"></a>00160     } <span class="comment">// end if side on flux boundary</span>
<a name="l00161"></a>00161   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00162"></a>00162 }
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 <span class="keywordtype">void</span>
<a name="l00167"></a><a class="code" href="classKellyErrorEstimator.php#a9e3f9538c61956a39414a4923e1b63e4">00167</a> <a class="code" href="classKellyErrorEstimator.php#a9e3f9538c61956a39414a4923e1b63e4">KellyErrorEstimator::attach_flux_bc_function</a> (std::pair&lt;bool,Real&gt; fptr(<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; system,
<a name="l00168"></a>00168                                                                         <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00169"></a>00169                                                                         <span class="keyword">const</span> std::string&amp; var_name))
<a name="l00170"></a>00170 {
<a name="l00171"></a>00171   <a class="code" href="classKellyErrorEstimator.php#aeba45b0d593f5bc168fb97ff51317dd5">_bc_function</a> = fptr;
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 <span class="comment">// We may be turning boundary side integration on or off</span>
<a name="l00174"></a>00174   <span class="keywordflow">if</span> (fptr)
<a name="l00175"></a>00175     <a class="code" href="classJumpErrorEstimator.php#a7f5f4bcc5fb6615e1e1c13124f8b62ef">integrate_boundary_sides</a> = <span class="keyword">true</span>;
<a name="l00176"></a>00176   <span class="keywordflow">else</span>
<a name="l00177"></a>00177     <a class="code" href="classJumpErrorEstimator.php#a7f5f4bcc5fb6615e1e1c13124f8b62ef">integrate_boundary_sides</a> = <span class="keyword">false</span>;
<a name="l00178"></a>00178 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
