<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c8cf73965feff5280e8b0581da1a9d14.php">error_estimation</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>kelly_error_estimator.h</h1>  </div>
</div>
<div class="contents">
<a href="kelly__error__estimator_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: kelly_error_estimator.h 3428 2009-07-17 01:51:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __kelly_error_estimator_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __kelly_error_estimator_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="jump__error__estimator_8h.php">jump_error_estimator.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Forward Declarations</span>
<a name="l00033"></a>00033 <span class="keyword">class </span><a class="code" href="classPoint.php">Point</a>;
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00058"></a><a class="code" href="classKellyErrorEstimator.php">00058</a> <span class="keyword">class </span><a class="code" href="classKellyErrorEstimator.php">KellyErrorEstimator</a> : <span class="keyword">public</span> <a class="code" href="classJumpErrorEstimator.php">JumpErrorEstimator</a>
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060 <span class="keyword">public</span>:
<a name="l00061"></a>00061 
<a name="l00067"></a><a class="code" href="classKellyErrorEstimator.php#ae9a76e7eaaab2c991a3c8d36fe881b79">00067</a>   <a class="code" href="classKellyErrorEstimator.php#ae9a76e7eaaab2c991a3c8d36fe881b79">KellyErrorEstimator</a>() : <a class="code" href="classKellyErrorEstimator.php#aeba45b0d593f5bc168fb97ff51317dd5">_bc_function</a>(NULL) 
<a name="l00068"></a>00068   { <a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a> = <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a>; }
<a name="l00069"></a>00069   
<a name="l00073"></a><a class="code" href="classKellyErrorEstimator.php#ac502a57d3886c00defba72d40721c251">00073</a>   <a class="code" href="classKellyErrorEstimator.php#ac502a57d3886c00defba72d40721c251">~KellyErrorEstimator</a>() {}
<a name="l00074"></a>00074 
<a name="l00079"></a>00079   <span class="keywordtype">void</span> <a class="code" href="classKellyErrorEstimator.php#a9e3f9538c61956a39414a4923e1b63e4">attach_flux_bc_function</a> (std::pair&lt;bool,Real&gt; fptr(<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; system,
<a name="l00080"></a>00080                                                           <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00081"></a>00081                                                           <span class="keyword">const</span> std::string&amp; var_name));
<a name="l00082"></a>00082   
<a name="l00083"></a>00083 <span class="keyword">protected</span>:
<a name="l00084"></a>00084 
<a name="l00089"></a>00089   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classKellyErrorEstimator.php#aba57894327ae45e6089a09fcebef5ea2">initialize</a>(<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; system,
<a name="l00090"></a>00090                           <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00091"></a>00091                           <span class="keywordtype">bool</span> estimate_parent_error);
<a name="l00092"></a>00092 
<a name="l00097"></a>00097   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classKellyErrorEstimator.php#ab6b00c70512946bd07f0a2c82fdd42d6">internal_side_integration</a>();
<a name="l00098"></a>00098 
<a name="l00104"></a>00104   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classKellyErrorEstimator.php#a5d1746d81d7a359f2fb7f73f7b735542">boundary_side_integration</a>();
<a name="l00105"></a>00105 
<a name="l00109"></a><a class="code" href="classKellyErrorEstimator.php#a18d975f446b5b65fca97f17fa7b058f6">00109</a>   <span class="keyword">const</span> <a class="code" href="classSystem.php">System</a> *<a class="code" href="classKellyErrorEstimator.php#a18d975f446b5b65fca97f17fa7b058f6">my_system</a>;
<a name="l00110"></a>00110 
<a name="l00114"></a><a class="code" href="classKellyErrorEstimator.php#aeba45b0d593f5bc168fb97ff51317dd5">00114</a>   std::pair&lt;bool,Real&gt; (* _bc_function) (<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; system,
<a name="l00115"></a>00115                                          <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00116"></a>00116                                          <span class="keyword">const</span> std::string&amp; var_name);
<a name="l00117"></a>00117 };
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 <span class="preprocessor">#endif</span>
<a name="l00121"></a>00121 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
