<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>laspack_linear_solver.h</h1>  </div>
</div>
<div class="contents">
<a href="laspack__linear__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: laspack_linear_solver.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __laspack_linear_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __laspack_linear_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#if defined(LIBMESH_HAVE_LASPACK)</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="comment">//#if defined(LIBMESH_HAVE_LASPACK) &amp;&amp; !defined(LIBMESH_USE_COMPLEX_NUMBERS)</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// C++ includes</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Local includes</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="linear__solver_8h.php">linear_solver.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="laspack__vector_8h.php">laspack_vector.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="laspack__matrix_8h.php">laspack_matrix.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="preprocessor">#include &lt;itersolv.h&gt;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &lt;rtc.h&gt;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &lt;errhandl.h&gt;</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00052"></a>00052 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00053"></a><a class="code" href="classLaspackLinearSolver.php">00053</a> <span class="keyword">class </span><a class="code" href="classLaspackLinearSolver.php">LaspackLinearSolver</a> : <span class="keyword">public</span> <a class="code" href="classLinearSolver.php">LinearSolver</a>&lt;T&gt;
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055  <span class="keyword">public</span>:
<a name="l00059"></a>00059   <a class="code" href="classLaspackLinearSolver.php#a600ea2ff13c2f6df4b59b2931d0a920a">LaspackLinearSolver</a> ();
<a name="l00060"></a>00060     
<a name="l00064"></a>00064   <a class="code" href="classLaspackLinearSolver.php#ac7791c3f7422cf43629c3a3e0ac122d4">~LaspackLinearSolver</a> ();
<a name="l00065"></a>00065   
<a name="l00069"></a>00069   <span class="keywordtype">void</span> <a class="code" href="classLaspackLinearSolver.php#a0daf5686c596ad9a606626253a8d3e09">clear</a> ();
<a name="l00070"></a>00070 
<a name="l00074"></a>00074   <span class="keywordtype">void</span> <a class="code" href="classLaspackLinearSolver.php#aded6e33071558ff387d6550a79f64dcb">init</a> ();
<a name="l00075"></a>00075   
<a name="l00076"></a>00076 
<a name="l00080"></a>00080   std::pair&lt;unsigned int, Real&gt; 
<a name="l00081"></a>00081     <a class="code" href="classLaspackLinearSolver.php#af9920781cfa3429870d8d3128e926813">solve</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>  &amp;matrix,
<a name="l00082"></a>00082            <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;solution,
<a name="l00083"></a>00083            <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;rhs,
<a name="l00084"></a>00084            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00085"></a>00085            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00089"></a>00089   std::pair&lt;unsigned int, Real&gt; 
<a name="l00090"></a>00090     <a class="code" href="classLaspackLinearSolver.php#af9920781cfa3429870d8d3128e926813">solve</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>  &amp;matrix,
<a name="l00091"></a>00091            <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>  &amp;pc,
<a name="l00092"></a>00092            <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;solution,
<a name="l00093"></a>00093            <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;rhs,
<a name="l00094"></a>00094            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00095"></a>00095            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00096"></a>00096    
<a name="l00100"></a>00100   std::pair&lt;unsigned int, Real&gt;
<a name="l00101"></a>00101     <a class="code" href="classLaspackLinearSolver.php#af9920781cfa3429870d8d3128e926813">solve</a> (<span class="keyword">const</span> <a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix,
<a name="l00102"></a>00102            <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; solution_in,
<a name="l00103"></a>00103            <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; rhs_in,
<a name="l00104"></a>00104            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00105"></a>00105            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00106"></a>00106   
<a name="l00112"></a>00112   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt;
<a name="l00113"></a>00113     <a class="code" href="classLaspackLinearSolver.php#af9920781cfa3429870d8d3128e926813">solve</a> (<span class="keyword">const</span> <a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix,
<a name="l00114"></a>00114            <span class="keyword">const</span> <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; precond_matrix,
<a name="l00115"></a>00115            <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; solution_in,
<a name="l00116"></a>00116            <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; rhs_in,
<a name="l00117"></a>00117            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00118"></a>00118            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00119"></a>00119   
<a name="l00124"></a>00124   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classLaspackLinearSolver.php#acfdc2c458749567bd5e58ee7474a18d0">print_converged_reason</a>();
<a name="l00125"></a>00125   
<a name="l00126"></a>00126  <span class="keyword">private</span>:
<a name="l00127"></a>00127   
<a name="l00132"></a>00132   <span class="keywordtype">void</span> <a class="code" href="classLaspackLinearSolver.php#a70593ae9ac442de575ac39774af672ba">set_laspack_preconditioner_type</a> ();
<a name="l00133"></a>00133 
<a name="l00137"></a><a class="code" href="classLaspackLinearSolver.php#a050ea394ae318bc76389e4ef9cd5d9ba">00137</a>   PrecondProcType <a class="code" href="classLaspackLinearSolver.php#a050ea394ae318bc76389e4ef9cd5d9ba">_precond_type</a>;
<a name="l00138"></a>00138 };
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 <span class="comment">/*----------------------- functions ----------------------------------*/</span>
<a name="l00142"></a>00142 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00143"></a>00143 <span class="keyword">inline</span>
<a name="l00144"></a><a class="code" href="classLaspackLinearSolver.php#a600ea2ff13c2f6df4b59b2931d0a920a">00144</a> <a class="code" href="classLaspackLinearSolver.php#a600ea2ff13c2f6df4b59b2931d0a920a">LaspackLinearSolver&lt;T&gt;::LaspackLinearSolver</a> () :
<a name="l00145"></a>00145   _precond_type (ILUPrecond)
<a name="l00146"></a>00146 {
<a name="l00147"></a>00147 }
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00152"></a>00152 <span class="keyword">inline</span>
<a name="l00153"></a><a class="code" href="classLaspackLinearSolver.php#ac7791c3f7422cf43629c3a3e0ac122d4">00153</a> <a class="code" href="classLaspackLinearSolver.php#ac7791c3f7422cf43629c3a3e0ac122d4">LaspackLinearSolver&lt;T&gt;::~LaspackLinearSolver</a> ()
<a name="l00154"></a>00154 {
<a name="l00155"></a>00155   this-&gt;clear ();
<a name="l00156"></a>00156 }
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00161"></a>00161 <span class="keyword">inline</span>
<a name="l00162"></a>00162 std::pair&lt;unsigned int, Real&gt;
<a name="l00163"></a><a class="code" href="classLaspackLinearSolver.php#a7c1fe267367eeb3ce93d61f5970f7dc5">00163</a> <a class="code" href="classLaspackLinearSolver.php#af9920781cfa3429870d8d3128e926813">LaspackLinearSolver&lt;T&gt;::solve</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;,
<a name="l00164"></a>00164                                <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;,
<a name="l00165"></a>00165                                <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;,
<a name="l00166"></a>00166                                <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;,
<a name="l00167"></a>00167                                <span class="keyword">const</span> <span class="keywordtype">double</span>,
<a name="l00168"></a>00168                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)
<a name="l00169"></a>00169 {
<a name="l00170"></a>00170   std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: LASPACK does not support a user-supplied preconditioner!&quot;</span>
<a name="l00171"></a>00171             &lt;&lt; std::endl;
<a name="l00172"></a>00172   libmesh_error();
<a name="l00173"></a>00173 
<a name="l00174"></a>00174   std::pair&lt;unsigned int, Real&gt; p;
<a name="l00175"></a>00175   <span class="keywordflow">return</span> p;
<a name="l00176"></a>00176 }
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_LASPACK</span>
<a name="l00179"></a>00179 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifndef __laspack_linear_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
