<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_f10759d5ac6297fe611079c3c15b8f2c.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>laspack_matrix.C</h1>  </div>
</div>
<div class="contents">
<a href="laspack__matrix_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: laspack_matrix.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#ifdef LIBMESH_HAVE_LASPACK</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;laspack_matrix.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;dof_map.h&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00034"></a>00034 <span class="comment">// LaspackMatrix members</span>
<a name="l00035"></a>00035 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00036"></a><a class="code" href="classLaspackMatrix.php#a7c1d8a2305a51929e3a3abf9c6d2cccc">00036</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackMatrix.php#a7c1d8a2305a51929e3a3abf9c6d2cccc">LaspackMatrix&lt;T&gt;::update_sparsity_pattern</a> (<span class="keyword">const</span> <a class="code" href="classSparsityPattern_1_1Graph.php">SparsityPattern::Graph</a> &amp;sparsity_pattern)
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038   <span class="comment">// clear data, start over</span>
<a name="l00039"></a>00039   this-&gt;clear ();    
<a name="l00040"></a>00040 
<a name="l00041"></a>00041   <span class="comment">// big trouble if this fails!</span>
<a name="l00042"></a>00042   libmesh_assert (this-&gt;_dof_map != NULL);
<a name="l00043"></a>00043   
<a name="l00044"></a>00044   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_rows = sparsity_pattern.size();
<a name="l00045"></a>00045 
<a name="l00046"></a>00046   <span class="comment">// Initialize the _row_start data structure,</span>
<a name="l00047"></a>00047   <span class="comment">// allocate storage for the _csr array</span>
<a name="l00048"></a>00048   {
<a name="l00049"></a>00049     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> size = 0;
<a name="l00050"></a>00050  
<a name="l00051"></a>00051     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> row=0; row&lt;n_rows; row++)
<a name="l00052"></a>00052       size += sparsity_pattern[row].size();
<a name="l00053"></a>00053     
<a name="l00054"></a>00054     _csr.resize       (size);
<a name="l00055"></a>00055     _row_start.reserve(n_rows + 1);
<a name="l00056"></a>00056   }
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 
<a name="l00059"></a>00059   <span class="comment">// Initize the _csr data structure.</span>
<a name="l00060"></a>00060   {
<a name="l00061"></a>00061     std::vector&lt;unsigned int&gt;::iterator pos = _csr.begin();
<a name="l00062"></a>00062     
<a name="l00063"></a>00063     _row_start.push_back (pos);
<a name="l00064"></a>00064     
<a name="l00065"></a>00065     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> row=0; row&lt;n_rows; row++)
<a name="l00066"></a>00066       {
<a name="l00067"></a>00067         <span class="comment">// insert the row indices</span>
<a name="l00068"></a>00068         <span class="keywordflow">for</span> (SparsityPattern::Row::const_iterator col = sparsity_pattern[row].begin();
<a name="l00069"></a>00069              col != sparsity_pattern[row].end(); ++col)
<a name="l00070"></a>00070           {
<a name="l00071"></a>00071             libmesh_assert (pos != _csr.end());
<a name="l00072"></a>00072             *pos = *col;
<a name="l00073"></a>00073             ++pos;
<a name="l00074"></a>00074           }
<a name="l00075"></a>00075         
<a name="l00076"></a>00076         _row_start.push_back (pos);
<a name="l00077"></a>00077       }
<a name="l00078"></a>00078   }
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <span class="comment">// Initialize the matrix</span>
<a name="l00082"></a>00082   libmesh_assert (!this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00083"></a>00083   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> ();
<a name="l00084"></a>00084   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00085"></a>00085   <span class="comment">//std::cout &lt;&lt; &quot;n_rows=&quot; &lt;&lt; n_rows &lt;&lt; std::endl;</span>
<a name="l00086"></a>00086   <span class="comment">//std::cout &lt;&lt; &quot;m()=&quot; &lt;&lt; m() &lt;&lt; std::endl;</span>
<a name="l00087"></a>00087   libmesh_assert (n_rows == this-&gt;m());
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   <span class="comment">// Tell the matrix about its structure.  Initialize it</span>
<a name="l00090"></a>00090   <span class="comment">// to zero.</span>
<a name="l00091"></a>00091   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_rows; i++)
<a name="l00092"></a>00092     {
<a name="l00093"></a>00093       <span class="keyword">const</span> std::vector&lt;unsigned int&gt;::const_iterator
<a name="l00094"></a>00094         rs = _row_start[i];
<a name="l00095"></a>00095       
<a name="l00096"></a>00096       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length = _row_start[i+1] - rs;
<a name="l00097"></a>00097       
<a name="l00098"></a>00098       Q_SetLen (&amp;_QMat, i+1, length);
<a name="l00099"></a>00099 
<a name="l00100"></a>00100       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l&lt;length; l++)
<a name="l00101"></a>00101         {
<a name="l00102"></a>00102           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = *(rs+l);
<a name="l00103"></a>00103 
<a name="l00104"></a>00104           <span class="comment">// sanity check</span>
<a name="l00105"></a>00105           <span class="comment">//std::cout &lt;&lt; &quot;m()=&quot; &lt;&lt; m() &lt;&lt; std::endl;</span>
<a name="l00106"></a>00106           <span class="comment">//std::cout &lt;&lt; &quot;(i,j,l) = (&quot; &lt;&lt; i</span>
<a name="l00107"></a>00107           <span class="comment">//        &lt;&lt; &quot;,&quot; &lt;&lt; j</span>
<a name="l00108"></a>00108           <span class="comment">//        &lt;&lt; &quot;,&quot; &lt;&lt; l</span>
<a name="l00109"></a>00109           <span class="comment">//        &lt;&lt; &quot;)&quot; &lt;&lt; std::endl;</span>
<a name="l00110"></a>00110           <span class="comment">//std::cout &lt;&lt; &quot;pos(i,j)=&quot; &lt;&lt; pos(i,j)</span>
<a name="l00111"></a>00111           <span class="comment">//          &lt;&lt; std::endl;       </span>
<a name="l00112"></a>00112           libmesh_assert (this-&gt;pos(i,j) == l);
<a name="l00113"></a>00113           Q_SetEntry (&amp;_QMat, i+1, l, j+1, 0.);
<a name="l00114"></a>00114         }
<a name="l00115"></a>00115     }
<a name="l00116"></a>00116   
<a name="l00117"></a>00117   <span class="comment">// That&#39;s it!</span>
<a name="l00118"></a>00118   <span class="comment">//libmesh_here();</span>
<a name="l00119"></a>00119 }
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00124"></a><a class="code" href="classLaspackMatrix.php#a7f12753d279f28713672784fcdb101b9">00124</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackMatrix.php#a5f0bde35dcdc185c5d4de4e97f20f4b1">LaspackMatrix&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m,
<a name="l00125"></a>00125                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00126"></a>00126                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_l,
<a name="l00127"></a>00127                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_l,
<a name="l00128"></a>00128                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nnz,
<a name="l00129"></a>00129                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)
<a name="l00130"></a>00130 {
<a name="l00131"></a>00131   <span class="comment">// noz ignored...  only used for multiple processors!</span>
<a name="l00132"></a>00132   libmesh_assert (m == m_l);
<a name="l00133"></a>00133   libmesh_assert (n == n_l);
<a name="l00134"></a>00134   libmesh_assert (m == n);
<a name="l00135"></a>00135   libmesh_assert (nnz &gt; 0);
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Only the init() member that uses the&quot;</span> &lt;&lt; std::endl
<a name="l00139"></a>00139             &lt;&lt; <span class="stringliteral">&quot;DofMap is implemented for Laspack matrices!&quot;</span> &lt;&lt; std::endl;
<a name="l00140"></a>00140   libmesh_error();
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00143"></a>00143 }
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00148"></a><a class="code" href="classLaspackMatrix.php#a5f0bde35dcdc185c5d4de4e97f20f4b1">00148</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackMatrix.php#a5f0bde35dcdc185c5d4de4e97f20f4b1">LaspackMatrix&lt;T&gt;::init</a> ()
<a name="l00149"></a>00149 {
<a name="l00150"></a>00150   <span class="comment">// Ignore calls on initialized objects</span>
<a name="l00151"></a>00151   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00152"></a>00152     <span class="keywordflow">return</span>;
<a name="l00153"></a>00153   
<a name="l00154"></a>00154   <span class="comment">// We need the DofMap for this!</span>
<a name="l00155"></a>00155   libmesh_assert (this-&gt;_dof_map != NULL);
<a name="l00156"></a>00156 
<a name="l00157"></a>00157   <span class="comment">// Clear intialized matrices</span>
<a name="l00158"></a>00158   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00159"></a>00159     this-&gt;clear();
<a name="l00160"></a>00160 
<a name="l00161"></a>00161   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m   = this-&gt;_dof_map-&gt;n_dofs();
<a name="l00162"></a>00162 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00163"></a>00163 <span class="preprocessor"></span>  <span class="comment">// The following variables are only used for assertions,</span>
<a name="l00164"></a>00164   <span class="comment">// so avoid declaring them when asserts are inactive.</span>
<a name="l00165"></a>00165   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n   = m;
<a name="l00166"></a>00166   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_l = this-&gt;_dof_map-&gt;n_dofs_on_processor(0); 
<a name="l00167"></a>00167   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_l = n_l;
<a name="l00168"></a>00168 <span class="preprocessor">#endif</span>
<a name="l00169"></a>00169 <span class="preprocessor"></span>  
<a name="l00170"></a>00170   <span class="comment">// Laspack Matrices only work for uniprocessor cases</span>
<a name="l00171"></a>00171   libmesh_assert (m   == n);
<a name="l00172"></a>00172   libmesh_assert (m_l == m);
<a name="l00173"></a>00173   libmesh_assert (n_l == n);
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00176"></a>00176 <span class="preprocessor"></span>  <span class="comment">// The following variables are only used for assertions,</span>
<a name="l00177"></a>00177   <span class="comment">// so avoid declaring them when asserts are inactive.</span>
<a name="l00178"></a>00178   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; n_nz = this-&gt;_dof_map-&gt;get_n_nz();
<a name="l00179"></a>00179   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; n_oz = this-&gt;_dof_map-&gt;get_n_oz();
<a name="l00180"></a>00180 <span class="preprocessor">#endif</span>
<a name="l00181"></a>00181 <span class="preprocessor"></span>  
<a name="l00182"></a>00182   <span class="comment">// Make sure the sparsity pattern isn&#39;t empty</span>
<a name="l00183"></a>00183   libmesh_assert (n_nz.size() == n_l);
<a name="l00184"></a>00184   libmesh_assert (n_oz.size() == n_l);
<a name="l00185"></a>00185   
<a name="l00186"></a>00186   <span class="keywordflow">if</span> (m==0)
<a name="l00187"></a>00187     <span class="keywordflow">return</span>;
<a name="l00188"></a>00188 
<a name="l00189"></a>00189   Q_Constr(&amp;_QMat, const_cast&lt;char*&gt;(<span class="stringliteral">&quot;Mat&quot;</span>), m, _LPFalse, Rowws, Normal, _LPTrue);
<a name="l00190"></a>00190 
<a name="l00191"></a>00191   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00192"></a>00192   
<a name="l00193"></a>00193   libmesh_assert (m == this-&gt;m());
<a name="l00194"></a>00194 }
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00199"></a><a class="code" href="classLaspackMatrix.php#ac65410643d4ee11a16c7a63eaee0707e">00199</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackMatrix.php#ac65410643d4ee11a16c7a63eaee0707e">LaspackMatrix&lt;T&gt;::get_diagonal</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; <span class="comment">/*dest*/</span>)<span class="keyword"> const</span>
<a name="l00200"></a>00200 <span class="keyword"></span>{
<a name="l00201"></a>00201   libmesh_not_implemented();
<a name="l00202"></a>00202 }
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00207"></a><a class="code" href="classLaspackMatrix.php#a829715b5cc7efefebfabfd26dc567e94">00207</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackMatrix.php#a829715b5cc7efefebfabfd26dc567e94">LaspackMatrix&lt;T&gt;::get_transpose</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; <span class="comment">/*dest*/</span>)<span class="keyword"> const</span>
<a name="l00208"></a>00208 <span class="keyword"></span>{
<a name="l00209"></a>00209   libmesh_not_implemented();
<a name="l00210"></a>00210 }
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 
<a name="l00214"></a>00214 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00215"></a>00215 <span class="comment">// Explicit instantiations</span>
<a name="l00216"></a>00216 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classLaspackMatrix.php">LaspackMatrix&lt;Number&gt;</a>;
<a name="l00217"></a>00217  
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_LASPACK</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
