<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>laspack_matrix.h</h1>  </div>
</div>
<div class="contents">
<a href="laspack__matrix_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: laspack_matrix.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __laspack_matrix_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __laspack_matrix_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#ifdef LIBMESH_HAVE_LASPACK </span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="comment">// C++ includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Local includes</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="preprocessor">#include &lt;qmatrix.h&gt;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">// Forward declarations</span>
<a name="l00042"></a>00042 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classLaspackVector.php">LaspackVector</a>;
<a name="l00043"></a>00043 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classLaspackLinearSolver.php">LaspackLinearSolver</a>;
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00062"></a>00062 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00063"></a><a class="code" href="classLaspackMatrix.php">00063</a> <span class="keyword">class </span><a class="code" href="classLaspackMatrix.php">LaspackMatrix</a> : <span class="keyword">public</span> <a class="code" href="classSparseMatrix.php">SparseMatrix</a>&lt;T&gt;
<a name="l00064"></a>00064 {
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 <span class="keyword">public</span>:
<a name="l00082"></a>00082   <a class="code" href="classLaspackMatrix.php#a27829c60890b7c7528917b9a81b2e659">LaspackMatrix</a> ();
<a name="l00083"></a>00083 
<a name="l00089"></a>00089   <a class="code" href="classLaspackMatrix.php#a09817590357ae41bbd366d280f5c6566">~LaspackMatrix</a> ();
<a name="l00090"></a>00090 
<a name="l00094"></a><a class="code" href="classLaspackMatrix.php#af5cc6915b04c048e0c821c3b2a89434a">00094</a>   <span class="keywordtype">bool</span> <a class="code" href="classLaspackMatrix.php#af5cc6915b04c048e0c821c3b2a89434a">need_full_sparsity_pattern</a>()<span class="keyword"> const </span>
<a name="l00095"></a>00095 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00096"></a>00096 
<a name="l00102"></a>00102   <span class="keywordtype">void</span> <a class="code" href="classLaspackMatrix.php#a7c1d8a2305a51929e3a3abf9c6d2cccc">update_sparsity_pattern</a> (<span class="keyword">const</span> <a class="code" href="classSparsityPattern_1_1Graph.php">SparsityPattern::Graph</a> &amp;);
<a name="l00103"></a>00103   
<a name="l00112"></a>00112   <span class="keywordtype">void</span> <a class="code" href="classLaspackMatrix.php#a5f0bde35dcdc185c5d4de4e97f20f4b1">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classLaspackMatrix.php#aa9a2b85722584c21cd6fbd15fafea0d7">m</a>,
<a name="l00113"></a>00113              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classLaspackMatrix.php#ab2f6dba3da5a896e0d7440898e62cf13">n</a>,
<a name="l00114"></a>00114              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_l,
<a name="l00115"></a>00115              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_l,
<a name="l00116"></a>00116              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nnz=30,
<a name="l00117"></a>00117              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> noz=10);
<a name="l00118"></a>00118 
<a name="l00122"></a>00122   <span class="keywordtype">void</span> <a class="code" href="classLaspackMatrix.php#a5f0bde35dcdc185c5d4de4e97f20f4b1">init</a> ();
<a name="l00123"></a>00123   
<a name="l00130"></a>00130   <span class="keywordtype">void</span> <a class="code" href="classLaspackMatrix.php#a28d6391628cb4d679198f6e241c3c2de">clear</a> ();
<a name="l00131"></a>00131 
<a name="l00135"></a>00135   <span class="keywordtype">void</span> <a class="code" href="classLaspackMatrix.php#a461b21e045200432a18089dc9b06701f">zero</a> ();
<a name="l00136"></a>00136   
<a name="l00142"></a><a class="code" href="classLaspackMatrix.php#a09410d0e5029c6677c1b12caf1aa72b3">00142</a>   <span class="keywordtype">void</span> <a class="code" href="classLaspackMatrix.php#a09410d0e5029c6677c1b12caf1aa72b3">close</a> ()<span class="keyword"> const </span>{ <span class="keyword">const_cast&lt;</span><a class="code" href="classLaspackMatrix.php">LaspackMatrix&lt;T&gt;</a>*<span class="keyword">&gt;</span>(<span class="keyword">this</span>)-&gt;<a class="code" href="classLaspackMatrix.php#a49ccd471ae2511ad130c24eb0c1f63a2">_closed</a> = <span class="keyword">true</span>; }
<a name="l00143"></a>00143   
<a name="l00148"></a>00148   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classLaspackMatrix.php#aa9a2b85722584c21cd6fbd15fafea0d7">m</a> () <span class="keyword">const</span>;
<a name="l00149"></a>00149 
<a name="l00154"></a>00154   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classLaspackMatrix.php#ab2f6dba3da5a896e0d7440898e62cf13">n</a> () <span class="keyword">const</span>;
<a name="l00155"></a>00155 
<a name="l00160"></a>00160   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classLaspackMatrix.php#a7d44b17482904bd7d17a62d56ee83a2f">row_start</a> () <span class="keyword">const</span>;
<a name="l00161"></a>00161 
<a name="l00166"></a>00166   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classLaspackMatrix.php#a4c63b7594e66322e66b32fdaa755bbf1">row_stop</a> () <span class="keyword">const</span>;
<a name="l00167"></a>00167 
<a name="l00174"></a>00174   <span class="keywordtype">void</span> <span class="keyword">set</span> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00175"></a>00175             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00176"></a>00176             <span class="keyword">const</span> T value);
<a name="l00177"></a>00177     
<a name="l00186"></a>00186   <span class="keywordtype">void</span> <a class="code" href="classLaspackMatrix.php#a6beb7fdb62426f5d1dd11d4f615ece88">add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00187"></a>00187             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00188"></a>00188             <span class="keyword">const</span> T value);
<a name="l00189"></a>00189 
<a name="l00197"></a>00197   <span class="keywordtype">void</span> <a class="code" href="classLaspackMatrix.php#aec32315e311c191d5930748f6915e912">add_matrix</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;dm,
<a name="l00198"></a>00198                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;rows,
<a name="l00199"></a>00199                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;cols);
<a name="l00200"></a>00200   
<a name="l00205"></a>00205   <span class="keywordtype">void</span> <a class="code" href="classLaspackMatrix.php#aec32315e311c191d5930748f6915e912">add_matrix</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;dm,
<a name="l00206"></a>00206                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;dof_indices);
<a name="l00207"></a>00207       
<a name="l00215"></a>00215   <span class="keywordtype">void</span> <a class="code" href="classLaspackMatrix.php#a6beb7fdb62426f5d1dd11d4f615ece88">add</a> (<span class="keyword">const</span> T a, <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;X);
<a name="l00216"></a>00216       
<a name="l00235"></a>00235   T <a class="code" href="classLaspackMatrix.php#ac167b9c36d884f5c18912effb5351472">operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00236"></a>00236                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span>;
<a name="l00237"></a>00237 
<a name="l00248"></a><a class="code" href="classLaspackMatrix.php#ae1f7b0b6b49d735faef15f371098aefd">00248</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classLaspackMatrix.php#ae1f7b0b6b49d735faef15f371098aefd">l1_norm</a> ()<span class="keyword"> const </span>{ libmesh_error(); <span class="keywordflow">return</span> 0.; }
<a name="l00249"></a>00249 
<a name="l00261"></a><a class="code" href="classLaspackMatrix.php#a23fa0887002d46e7da2add1df90ce457">00261</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classLaspackMatrix.php#a23fa0887002d46e7da2add1df90ce457">linfty_norm</a> ()<span class="keyword"> const </span>{ libmesh_error(); <span class="keywordflow">return</span> 0.; }
<a name="l00262"></a>00262 
<a name="l00267"></a><a class="code" href="classLaspackMatrix.php#a92434917a9945d91e96ccd3bad2a312b">00267</a>   <span class="keywordtype">bool</span> <a class="code" href="classLaspackMatrix.php#a92434917a9945d91e96ccd3bad2a312b">closed</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classLaspackMatrix.php#a49ccd471ae2511ad130c24eb0c1f63a2">_closed</a>; }
<a name="l00268"></a>00268   
<a name="l00273"></a><a class="code" href="classLaspackMatrix.php#aed2867472bddb2955f404f78a189ee6e">00273</a>   <span class="keywordtype">void</span> <a class="code" href="classLaspackMatrix.php#aed2867472bddb2955f404f78a189ee6e">print_personal</a>(std::ostream&amp; os=std::cout)<span class="keyword"> const </span>{ this-&gt;<a class="code" href="classSparseMatrix.php#a3ec4b8d0b6b8055a184c4876bce090fb">print</a>(os); }
<a name="l00274"></a>00274 
<a name="l00278"></a>00278   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classLaspackMatrix.php#ac65410643d4ee11a16c7a63eaee0707e">get_diagonal</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00279"></a>00279 
<a name="l00284"></a>00284   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classLaspackMatrix.php#a829715b5cc7efefebfabfd26dc567e94">get_transpose</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00285"></a>00285 
<a name="l00286"></a>00286 <span class="keyword">private</span>:
<a name="l00287"></a>00287 
<a name="l00292"></a>00292   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classLaspackMatrix.php#ac2b9c3466ee15f08248071b8b4098b83">pos</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00293"></a>00293                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span>;
<a name="l00294"></a>00294   
<a name="l00298"></a><a class="code" href="classLaspackMatrix.php#a155e99dfee0e5047c62cf07c10236839">00298</a>   QMatrix <a class="code" href="classLaspackMatrix.php#a155e99dfee0e5047c62cf07c10236839">_QMat</a>;
<a name="l00299"></a>00299 
<a name="l00303"></a><a class="code" href="classLaspackMatrix.php#ad6c876ee0c3b4fbf1b42896eb1bd937a">00303</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classLaspackMatrix.php#ad6c876ee0c3b4fbf1b42896eb1bd937a">_csr</a>;
<a name="l00304"></a>00304 
<a name="l00309"></a><a class="code" href="classLaspackMatrix.php#af8e28597028ebe513ddb6612a32fbfeb">00309</a>   std::vector&lt;std::vector&lt;unsigned int&gt;::const_iterator&gt; <a class="code" href="classLaspackMatrix.php#af8e28597028ebe513ddb6612a32fbfeb">_row_start</a>;
<a name="l00310"></a>00310 
<a name="l00314"></a><a class="code" href="classLaspackMatrix.php#a49ccd471ae2511ad130c24eb0c1f63a2">00314</a>   <span class="keywordtype">bool</span> <a class="code" href="classLaspackMatrix.php#a49ccd471ae2511ad130c24eb0c1f63a2">_closed</a>;
<a name="l00315"></a>00315 
<a name="l00319"></a><a class="code" href="classLaspackMatrix.php#a349576c19432153b5f5a0c544a29dbaf">00319</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classLaspackVector.php">LaspackVector</a>&lt;T&gt;;
<a name="l00320"></a><a class="code" href="classLaspackMatrix.php#a0be0354b510b1eba31ee700b6a44408b">00320</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classLaspackLinearSolver.php">LaspackLinearSolver</a>&lt;T&gt;;
<a name="l00321"></a>00321 };
<a name="l00322"></a>00322 
<a name="l00323"></a>00323 
<a name="l00324"></a>00324 
<a name="l00325"></a>00325 <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00326"></a>00326 <span class="comment">// LaspackMatrix class inline members</span>
<a name="l00327"></a>00327 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00328"></a>00328 <span class="keyword">inline</span>
<a name="l00329"></a><a class="code" href="classLaspackMatrix.php#a27829c60890b7c7528917b9a81b2e659">00329</a> <a class="code" href="classLaspackMatrix.php#a27829c60890b7c7528917b9a81b2e659">LaspackMatrix&lt;T&gt;::LaspackMatrix</a> () :
<a name="l00330"></a>00330   _closed (false)
<a name="l00331"></a>00331 {
<a name="l00332"></a>00332 }
<a name="l00333"></a>00333 
<a name="l00334"></a>00334 
<a name="l00335"></a>00335 
<a name="l00336"></a>00336 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00337"></a>00337 <span class="keyword">inline</span>
<a name="l00338"></a><a class="code" href="classLaspackMatrix.php#a09817590357ae41bbd366d280f5c6566">00338</a> <a class="code" href="classLaspackMatrix.php#a09817590357ae41bbd366d280f5c6566">LaspackMatrix&lt;T&gt;::~LaspackMatrix</a> ()
<a name="l00339"></a>00339 {
<a name="l00340"></a>00340   this-&gt;<a class="code" href="classLaspackLinearSolver.php#a0daf5686c596ad9a606626253a8d3e09">clear</a> ();
<a name="l00341"></a>00341 }
<a name="l00342"></a>00342 
<a name="l00343"></a>00343 
<a name="l00344"></a>00344 
<a name="l00345"></a>00345 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00346"></a>00346 <span class="keyword">inline</span>
<a name="l00347"></a><a class="code" href="classLaspackMatrix.php#a28d6391628cb4d679198f6e241c3c2de">00347</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackMatrix.php#a28d6391628cb4d679198f6e241c3c2de">LaspackMatrix&lt;T&gt;::clear</a> ()
<a name="l00348"></a>00348 {
<a name="l00349"></a>00349   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00350"></a>00350     {
<a name="l00351"></a>00351       Q_Destr(&amp;_QMat);
<a name="l00352"></a>00352     }
<a name="l00353"></a>00353   
<a name="l00354"></a>00354   _csr.clear();
<a name="l00355"></a>00355   _row_start.clear();
<a name="l00356"></a>00356   _closed = <span class="keyword">false</span>;
<a name="l00357"></a>00357   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00358"></a>00358 }
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 
<a name="l00361"></a>00361 
<a name="l00362"></a>00362 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00363"></a>00363 <span class="keyword">inline</span>
<a name="l00364"></a><a class="code" href="classLaspackMatrix.php#a461b21e045200432a18089dc9b06701f">00364</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackMatrix.php#a461b21e045200432a18089dc9b06701f">LaspackMatrix&lt;T&gt;::zero</a> ()
<a name="l00365"></a>00365 {
<a name="l00366"></a>00366   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_rows = this-&gt;m();
<a name="l00367"></a>00367 
<a name="l00368"></a>00368   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> row=0; row&lt;n_rows; row++)
<a name="l00369"></a>00369     {
<a name="l00370"></a>00370       <span class="keyword">const</span> std::vector&lt;unsigned int&gt;::const_iterator
<a name="l00371"></a>00371         r_start = _row_start[row];
<a name="l00372"></a>00372       
<a name="l00373"></a>00373       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len = (_row_start[row+1] - _row_start[row]);
<a name="l00374"></a>00374         
<a name="l00375"></a>00375       <span class="comment">// Make sure we agree on the row length</span>
<a name="l00376"></a>00376       libmesh_assert (len == Q_GetLen(&amp;_QMat, row+1));
<a name="l00377"></a>00377       
<a name="l00378"></a>00378       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l&lt;len; l++)
<a name="l00379"></a>00379         {
<a name="l00380"></a>00380           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = *(r_start + l);
<a name="l00381"></a>00381 
<a name="l00382"></a>00382           <span class="comment">// Make sure the data structures are working</span>
<a name="l00383"></a>00383           libmesh_assert ((j+1) == Q_GetPos (&amp;_QMat, row+1, l));
<a name="l00384"></a>00384           
<a name="l00385"></a>00385           Q_SetEntry (&amp;_QMat, row+1, l, j+1, 0.);
<a name="l00386"></a>00386         }
<a name="l00387"></a>00387     }    
<a name="l00388"></a>00388 }
<a name="l00389"></a>00389 
<a name="l00390"></a>00390 
<a name="l00391"></a>00391 
<a name="l00392"></a>00392 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00393"></a>00393 <span class="keyword">inline</span>
<a name="l00394"></a><a class="code" href="classLaspackMatrix.php#aa9a2b85722584c21cd6fbd15fafea0d7">00394</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classLaspackMatrix.php#aa9a2b85722584c21cd6fbd15fafea0d7">LaspackMatrix&lt;T&gt;::m</a> ()<span class="keyword"> const</span>
<a name="l00395"></a>00395 <span class="keyword"></span>{
<a name="l00396"></a>00396   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00397"></a>00397 
<a name="l00398"></a>00398   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(Q_GetDim(const_cast&lt;QMatrix*&gt;(&amp;_QMat)));
<a name="l00399"></a>00399 }
<a name="l00400"></a>00400 
<a name="l00401"></a>00401 
<a name="l00402"></a>00402 
<a name="l00403"></a>00403 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00404"></a>00404 <span class="keyword">inline</span>
<a name="l00405"></a><a class="code" href="classLaspackMatrix.php#ab2f6dba3da5a896e0d7440898e62cf13">00405</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classLaspackMatrix.php#ab2f6dba3da5a896e0d7440898e62cf13">LaspackMatrix&lt;T&gt;::n</a> ()<span class="keyword"> const</span>
<a name="l00406"></a>00406 <span class="keyword"></span>{
<a name="l00407"></a>00407   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00408"></a>00408   
<a name="l00409"></a>00409   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(Q_GetDim(const_cast&lt;QMatrix*&gt;(&amp;_QMat)));
<a name="l00410"></a>00410 }
<a name="l00411"></a>00411 
<a name="l00412"></a>00412 
<a name="l00413"></a>00413 
<a name="l00414"></a>00414 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00415"></a>00415 <span class="keyword">inline</span>
<a name="l00416"></a><a class="code" href="classLaspackMatrix.php#a7d44b17482904bd7d17a62d56ee83a2f">00416</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classLaspackMatrix.php#a7d44b17482904bd7d17a62d56ee83a2f">LaspackMatrix&lt;T&gt;::row_start</a> ()<span class="keyword"> const</span>
<a name="l00417"></a>00417 <span class="keyword"></span>{
<a name="l00418"></a>00418   <span class="keywordflow">return</span> 0;
<a name="l00419"></a>00419 }
<a name="l00420"></a>00420 
<a name="l00421"></a>00421 
<a name="l00422"></a>00422 
<a name="l00423"></a>00423 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00424"></a>00424 <span class="keyword">inline</span>
<a name="l00425"></a><a class="code" href="classLaspackMatrix.php#a4c63b7594e66322e66b32fdaa755bbf1">00425</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classLaspackMatrix.php#a4c63b7594e66322e66b32fdaa755bbf1">LaspackMatrix&lt;T&gt;::row_stop</a> ()<span class="keyword"> const</span>
<a name="l00426"></a>00426 <span class="keyword"></span>{
<a name="l00427"></a>00427   <span class="keywordflow">return</span> this-&gt;m();
<a name="l00428"></a>00428 }
<a name="l00429"></a>00429 
<a name="l00430"></a>00430 
<a name="l00431"></a>00431 
<a name="l00432"></a>00432 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00433"></a>00433 <span class="keyword">inline</span>
<a name="l00434"></a><a class="code" href="classLaspackMatrix.php#a01a4aaa4d310b2b6eb5b2e0f29e219ca">00434</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackMatrix.php#a01a4aaa4d310b2b6eb5b2e0f29e219ca">LaspackMatrix&lt;T&gt;::set</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00435"></a>00435                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00436"></a>00436                             <span class="keyword">const</span> T value)
<a name="l00437"></a>00437 {
<a name="l00438"></a>00438   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00439"></a>00439   libmesh_assert (i &lt; this-&gt;m());
<a name="l00440"></a>00440   libmesh_assert (j &lt; this-&gt;n());
<a name="l00441"></a>00441   
<a name="l00442"></a>00442   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> position = this-&gt;pos(i,j);
<a name="l00443"></a>00443 
<a name="l00444"></a>00444   <span class="comment">// Sanity check</span>
<a name="l00445"></a>00445   libmesh_assert (*(_row_start[i]+position) == j);
<a name="l00446"></a>00446   libmesh_assert ((j+1) == Q_GetPos (&amp;_QMat, i+1, position));
<a name="l00447"></a>00447 
<a name="l00448"></a>00448   Q_SetEntry (&amp;_QMat, i+1, position, j+1, value);
<a name="l00449"></a>00449 }
<a name="l00450"></a>00450 
<a name="l00451"></a>00451 
<a name="l00452"></a>00452 
<a name="l00453"></a>00453 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00454"></a>00454 <span class="keyword">inline</span>
<a name="l00455"></a><a class="code" href="classLaspackMatrix.php#a6beb7fdb62426f5d1dd11d4f615ece88">00455</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackMatrix.php#a6beb7fdb62426f5d1dd11d4f615ece88">LaspackMatrix&lt;T&gt;::add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00456"></a>00456                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00457"></a>00457                             <span class="keyword">const</span> T value)
<a name="l00458"></a>00458 {
<a name="l00459"></a>00459   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00460"></a>00460   libmesh_assert (i &lt; this-&gt;m());
<a name="l00461"></a>00461   libmesh_assert (j &lt; this-&gt;n());
<a name="l00462"></a>00462   
<a name="l00463"></a>00463   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> position = this-&gt;pos(i,j);
<a name="l00464"></a>00464 
<a name="l00465"></a>00465   <span class="comment">// Sanity check</span>
<a name="l00466"></a>00466   libmesh_assert (*(_row_start[i]+position) == j);
<a name="l00467"></a>00467 
<a name="l00468"></a>00468   Q_AddVal (&amp;_QMat, i+1, position, value);
<a name="l00469"></a>00469 }
<a name="l00470"></a>00470 
<a name="l00471"></a>00471 
<a name="l00472"></a>00472 
<a name="l00473"></a>00473 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00474"></a>00474 <span class="keyword">inline</span>
<a name="l00475"></a><a class="code" href="classLaspackMatrix.php#ab51c568b7eff3471c60e345d2c43102a">00475</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackMatrix.php#aec32315e311c191d5930748f6915e912">LaspackMatrix&lt;T&gt;::add_matrix</a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dm,
<a name="l00476"></a>00476                                   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00477"></a>00477 {
<a name="l00478"></a>00478   this-&gt;add_matrix (dm, dof_indices, dof_indices);
<a name="l00479"></a>00479 }
<a name="l00480"></a>00480 
<a name="l00481"></a>00481 
<a name="l00482"></a>00482 
<a name="l00483"></a>00483 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00484"></a>00484 <span class="keyword">inline</span>
<a name="l00485"></a><a class="code" href="classLaspackMatrix.php#aec32315e311c191d5930748f6915e912">00485</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackMatrix.php#aec32315e311c191d5930748f6915e912">LaspackMatrix&lt;T&gt;::add_matrix</a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dm,
<a name="l00486"></a>00486                                   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; rows,
<a name="l00487"></a>00487                                   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; cols)
<a name="l00488"></a>00488                     
<a name="l00489"></a>00489 {
<a name="l00490"></a>00490   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00491"></a>00491   libmesh_assert (dm.<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>() == rows.size());
<a name="l00492"></a>00492   libmesh_assert (dm.<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>() == cols.size());
<a name="l00493"></a>00493 
<a name="l00494"></a>00494   
<a name="l00495"></a>00495   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;rows.size(); i++)
<a name="l00496"></a>00496     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;cols.size(); j++)
<a name="l00497"></a>00497       this-&gt;add(rows[i],cols[j],dm(i,j));
<a name="l00498"></a>00498 }
<a name="l00499"></a>00499 
<a name="l00500"></a>00500 
<a name="l00501"></a>00501 
<a name="l00502"></a>00502 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00503"></a><a class="code" href="classLaspackMatrix.php#afbdd52f7fad6ddc1ef1338dd1e0b5e0b">00503</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackMatrix.php#a6beb7fdb62426f5d1dd11d4f615ece88">LaspackMatrix&lt;T&gt;::add</a> (<span class="keyword">const</span> T a_in, <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;X_in)
<a name="l00504"></a>00504 {
<a name="l00505"></a>00505   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00506"></a>00506   libmesh_assert (this-&gt;m() == X_in.<a class="code" href="classSparseMatrix.php#af2f0d62994782f324c59bd4203b9d1d2">m</a>());
<a name="l00507"></a>00507   libmesh_assert (this-&gt;n() == X_in.<a class="code" href="classSparseMatrix.php#af540f97c67ca77cf3a6dc7a4f1551c19">n</a>());
<a name="l00508"></a>00508 
<a name="l00509"></a>00509   <a class="code" href="classLaspackMatrix.php">LaspackMatrix&lt;T&gt;</a>* X = <span class="keyword">dynamic_cast&lt;</span><a class="code" href="classLaspackMatrix.php">LaspackMatrix&lt;T&gt;</a>*<span class="keyword">&gt;</span> (&amp;X_in);
<a name="l00510"></a>00510   _LPNumber         a = <span class="keyword">static_cast&lt;</span>_LPNumber<span class="keyword">&gt;</span>          (a_in);
<a name="l00511"></a>00511   
<a name="l00512"></a>00512   libmesh_assert(X != NULL);
<a name="l00513"></a>00513   
<a name="l00514"></a>00514   <span class="comment">// loops taken from LaspackMatrix&lt;T&gt;::zero ()</span>
<a name="l00515"></a>00515 
<a name="l00516"></a>00516   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_rows = this-&gt;m();
<a name="l00517"></a>00517 
<a name="l00518"></a>00518   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> row=0; row&lt;n_rows; row++)
<a name="l00519"></a>00519     {
<a name="l00520"></a>00520       <span class="keyword">const</span> std::vector&lt;unsigned int&gt;::const_iterator
<a name="l00521"></a>00521         r_start = _row_start[row];
<a name="l00522"></a>00522       
<a name="l00523"></a>00523       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len = (_row_start[row+1] - _row_start[row]);
<a name="l00524"></a>00524 
<a name="l00525"></a>00525       <span class="comment">// Make sure we agree on the row length</span>
<a name="l00526"></a>00526       libmesh_assert (len == Q_GetLen(&amp;_QMat, row+1));
<a name="l00527"></a>00527       <span class="comment">// compare matrix sparsity structures</span>
<a name="l00528"></a>00528       libmesh_assert (len == Q_GetLen(&amp;(X-&gt;_QMat), row+1));
<a name="l00529"></a>00529         
<a name="l00530"></a>00530       
<a name="l00531"></a>00531       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l&lt;len; l++)
<a name="l00532"></a>00532         {
<a name="l00533"></a>00533           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = *(r_start + l);
<a name="l00534"></a>00534 
<a name="l00535"></a>00535           <span class="comment">// Make sure the data structures are working</span>
<a name="l00536"></a>00536           libmesh_assert ((j+1) == Q_GetPos (&amp;_QMat, row+1, l));
<a name="l00537"></a>00537 
<a name="l00538"></a>00538           <span class="keyword">const</span> _LPNumber value = a * Q_GetEl(const_cast&lt;QMatrix*&gt;(&amp;(X-&gt;_QMat)), row+1, j+1);
<a name="l00539"></a>00539           Q_AddVal   (&amp;_QMat, row+1, l, value);
<a name="l00540"></a>00540         }
<a name="l00541"></a>00541     }    
<a name="l00542"></a>00542 }
<a name="l00543"></a>00543 
<a name="l00544"></a>00544 
<a name="l00545"></a>00545 
<a name="l00546"></a>00546 
<a name="l00547"></a>00547 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00548"></a>00548 <span class="keyword">inline</span>
<a name="l00549"></a><a class="code" href="classLaspackMatrix.php#ac167b9c36d884f5c18912effb5351472">00549</a> T <a class="code" href="classLaspackMatrix.php#ac167b9c36d884f5c18912effb5351472">LaspackMatrix&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00550"></a>00550                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const</span>
<a name="l00551"></a>00551 <span class="keyword"></span>{
<a name="l00552"></a>00552   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00553"></a>00553   libmesh_assert (i &lt; this-&gt;m());
<a name="l00554"></a>00554   libmesh_assert (j &lt; this-&gt;n());
<a name="l00555"></a>00555   
<a name="l00556"></a>00556   <span class="keywordflow">return</span> Q_GetEl (const_cast&lt;QMatrix*&gt;(&amp;_QMat), i+1, j+1);
<a name="l00557"></a>00557 }
<a name="l00558"></a>00558 
<a name="l00559"></a>00559 
<a name="l00560"></a>00560 
<a name="l00561"></a>00561 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00562"></a>00562 <span class="keyword">inline</span>
<a name="l00563"></a><a class="code" href="classLaspackMatrix.php#ac2b9c3466ee15f08248071b8b4098b83">00563</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classLaspackMatrix.php#ac2b9c3466ee15f08248071b8b4098b83">LaspackMatrix&lt;T&gt;::pos</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00564"></a>00564                                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const</span>
<a name="l00565"></a>00565 <span class="keyword"></span>{
<a name="l00566"></a>00566   <span class="comment">//std::cout &lt;&lt; &quot;m()=&quot; &lt;&lt; m() &lt;&lt; std::endl;</span>
<a name="l00567"></a>00567   libmesh_assert (i &lt; this-&gt;m());
<a name="l00568"></a>00568   libmesh_assert (j &lt; this-&gt;n());
<a name="l00569"></a>00569   libmesh_assert (i+1 &lt; _row_start.size());
<a name="l00570"></a>00570   libmesh_assert (_row_start.back() == _csr.end());
<a name="l00571"></a>00571 
<a name="l00572"></a>00572   <span class="comment">// note this requires the _csr to be </span>
<a name="l00573"></a>00573   std::pair&lt;std::vector&lt;unsigned int&gt;::const_iterator,
<a name="l00574"></a>00574             std::vector&lt;unsigned int&gt;::const_iterator&gt; p =
<a name="l00575"></a>00575     std::equal_range (_row_start[i],
<a name="l00576"></a>00576                       _row_start[i+1],
<a name="l00577"></a>00577                       j);
<a name="l00578"></a>00578 
<a name="l00579"></a>00579   <span class="comment">// Make sure the row contains the element j</span>
<a name="l00580"></a>00580   libmesh_assert (p.first != p.second);
<a name="l00581"></a>00581 
<a name="l00582"></a>00582   <span class="comment">// Make sure the values match</span>
<a name="l00583"></a>00583   libmesh_assert (*p.first == j);
<a name="l00584"></a>00584 
<a name="l00585"></a>00585   <span class="comment">// Return the position in the compressed row</span>
<a name="l00586"></a>00586   <span class="keywordflow">return</span> std::distance (_row_start[i], p.first);
<a name="l00587"></a>00587 }
<a name="l00588"></a>00588 
<a name="l00589"></a>00589 
<a name="l00590"></a>00590 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_LASPACK</span>
<a name="l00591"></a>00591 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __laspack_matrix_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
