<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_f10759d5ac6297fe611079c3c15b8f2c.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>laspack_vector.C</h1>  </div>
</div>
<div class="contents">
<a href="laspack__vector_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: laspack_vector.C 3466 2009-09-17 18:01:17Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::min</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;limits&gt;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local Includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;dense_subvector.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;dense_vector.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;laspack_vector.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;laspack_matrix.h&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#ifdef LIBMESH_HAVE_LASPACK</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span>
<a name="l00035"></a>00035 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00036"></a><a class="code" href="classLaspackVector.php#a4658e39680248bc4d6bbf454dcd78aa3">00036</a> T <a class="code" href="classLaspackVector.php#a4658e39680248bc4d6bbf454dcd78aa3">LaspackVector&lt;T&gt;::sum</a> ()<span class="keyword"> const</span>
<a name="l00037"></a>00037 <span class="keyword"></span>{
<a name="l00038"></a>00038   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00039"></a>00039 
<a name="l00040"></a>00040   T _sum = 0;
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = this-&gt;size();
<a name="l00043"></a>00043   
<a name="l00044"></a>00044   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=n; ++i)
<a name="l00045"></a>00045     _sum += (*<span class="keyword">this</span>)(i);
<a name="l00046"></a>00046 
<a name="l00047"></a>00047   <span class="keywordflow">return</span> _sum;
<a name="l00048"></a>00048 }
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00053"></a><a class="code" href="classLaspackVector.php#a50889100fe8e6159962c4d1ce336e8df">00053</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classLaspackVector.php#a50889100fe8e6159962c4d1ce336e8df">LaspackVector&lt;T&gt;::l1_norm</a> ()<span class="keyword"> const</span>
<a name="l00054"></a>00054 <span class="keyword"></span>{
<a name="l00055"></a>00055   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00056"></a>00056   
<a name="l00057"></a>00057   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a><span class="keyword">&gt;</span>(l1Norm_V(const_cast&lt;QVector*&gt;(&amp;_vec)));
<a name="l00058"></a>00058 }
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00063"></a><a class="code" href="classLaspackVector.php#af56611f68f067d46f9f62e65b3606d8a">00063</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classLaspackVector.php#af56611f68f067d46f9f62e65b3606d8a">LaspackVector&lt;T&gt;::l2_norm</a> ()<span class="keyword"> const</span>
<a name="l00064"></a>00064 <span class="keyword"></span>{
<a name="l00065"></a>00065   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00066"></a>00066   
<a name="l00067"></a>00067   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a><span class="keyword">&gt;</span>(l2Norm_V(const_cast&lt;QVector*&gt;(&amp;_vec)));
<a name="l00068"></a>00068 }
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 
<a name="l00072"></a>00072 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00073"></a><a class="code" href="classLaspackVector.php#a49c73ee4a6b4210631ae0f60fc934116">00073</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classLaspackVector.php#a49c73ee4a6b4210631ae0f60fc934116">LaspackVector&lt;T&gt;::linfty_norm</a> ()<span class="keyword"> const</span>
<a name="l00074"></a>00074 <span class="keyword"></span>{
<a name="l00075"></a>00075   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00076"></a>00076   
<a name="l00077"></a>00077   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a><span class="keyword">&gt;</span>(MaxNorm_V(const_cast&lt;QVector*&gt;(&amp;_vec)));
<a name="l00078"></a>00078 }
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00083"></a><a class="code" href="classLaspackVector.php#a47dad528d58f1fcaa503ee25b691148f">00083</a> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; <a class="code" href="classLaspackVector.php#a47dad528d58f1fcaa503ee25b691148f">LaspackVector&lt;T&gt;::operator += </a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v)
<a name="l00084"></a>00084 {
<a name="l00085"></a>00085   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00086"></a>00086   
<a name="l00087"></a>00087   this-&gt;add(1., v);
<a name="l00088"></a>00088   
<a name="l00089"></a>00089   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00090"></a>00090 }
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00096"></a><a class="code" href="classLaspackVector.php#ad85b90aedb454d40e65fcdb8cbdcb717">00096</a> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; <a class="code" href="classLaspackVector.php#ad85b90aedb454d40e65fcdb8cbdcb717">LaspackVector&lt;T&gt;::operator -= </a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v)
<a name="l00097"></a>00097 {
<a name="l00098"></a>00098   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00099"></a>00099   
<a name="l00100"></a>00100   this-&gt;add(-1., v);
<a name="l00101"></a>00101   
<a name="l00102"></a>00102   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00103"></a>00103 }
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00108"></a><a class="code" href="classLaspackVector.php#a92358e84cd03676ad4e3acd090010466">00108</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#a94d61c428f9c5890c8086f896c5575c2">LaspackVector&lt;T&gt;::add</a> (<span class="keyword">const</span> T v)
<a name="l00109"></a>00109 {
<a name="l00110"></a>00110   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = this-&gt;size();
<a name="l00111"></a>00111   
<a name="l00112"></a>00112   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; i++)
<a name="l00113"></a>00113     this-&gt;add (i, v);
<a name="l00114"></a>00114 }
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00120"></a><a class="code" href="classLaspackVector.php#ac56ea869210be385a940cff416dd3283">00120</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#a94d61c428f9c5890c8086f896c5575c2">LaspackVector&lt;T&gt;::add</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v)
<a name="l00121"></a>00121 {
<a name="l00122"></a>00122   this-&gt;add (1., v);
<a name="l00123"></a>00123 }
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00128"></a><a class="code" href="classLaspackVector.php#a4a15a2a67e2d76e0a52159420993ba47">00128</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#a94d61c428f9c5890c8086f896c5575c2">LaspackVector&lt;T&gt;::add</a> (<span class="keyword">const</span> T a, <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_in)
<a name="l00129"></a>00129 {
<a name="l00130"></a>00130   <span class="comment">// Make sure the vector passed in is really a LaspackVector</span>
<a name="l00131"></a>00131   <span class="keyword">const</span> <a class="code" href="classLaspackVector.php">LaspackVector</a>* v = libmesh_cast_ptr&lt;const LaspackVector*&gt;(&amp;v_in);
<a name="l00132"></a>00132 
<a name="l00133"></a>00133   libmesh_assert (v != NULL);
<a name="l00134"></a>00134   libmesh_assert (this-&gt;size() == v-&gt;<a class="code" href="classLaspackVector.php#a9acfef7d3f7d5f82014016605bfd42b3">size</a>());
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v-&gt;<a class="code" href="classLaspackVector.php#a9acfef7d3f7d5f82014016605bfd42b3">size</a>(); i++)
<a name="l00137"></a>00137     this-&gt;add (i, a*(*v)(i));
<a name="l00138"></a>00138 }
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00143"></a><a class="code" href="classLaspackVector.php#aeb761622629dd3c53a4a15105d57be54">00143</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#aeb761622629dd3c53a4a15105d57be54">LaspackVector&lt;T&gt;::add_vector</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00144"></a>00144                                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00145"></a>00145 {
<a name="l00146"></a>00146   libmesh_assert (!v.empty());
<a name="l00147"></a>00147   libmesh_assert (v.size() == dof_indices.size());
<a name="l00148"></a>00148   
<a name="l00149"></a>00149   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l00150"></a>00150     this-&gt;add (dof_indices[i], v[i]);
<a name="l00151"></a>00151 }
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00156"></a><a class="code" href="classLaspackVector.php#a955e397d8b76307532db568debc28ad2">00156</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#aeb761622629dd3c53a4a15105d57be54">LaspackVector&lt;T&gt;::add_vector</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00157"></a>00157                                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00158"></a>00158 {
<a name="l00159"></a>00159   libmesh_assert (V.<a class="code" href="classNumericVector.php#ae21bc89e89e895ac26b851a31926e194">size</a>() == dof_indices.size());
<a name="l00160"></a>00160 
<a name="l00161"></a>00161   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classNumericVector.php#ae21bc89e89e895ac26b851a31926e194">size</a>(); i++)
<a name="l00162"></a>00162     this-&gt;add (dof_indices[i], V(i));
<a name="l00163"></a>00163 }
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00168"></a><a class="code" href="classLaspackVector.php#a5b808079e341558fa5c924b332ff9bf1">00168</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#aeb761622629dd3c53a4a15105d57be54">LaspackVector&lt;T&gt;::add_vector</a> (<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00169"></a>00169                                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00170"></a>00170 {
<a name="l00171"></a>00171   libmesh_assert (V.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>() == dof_indices.size());
<a name="l00172"></a>00172 
<a name="l00173"></a>00173   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>(); i++)
<a name="l00174"></a>00174     this-&gt;add (dof_indices[i], V(i));
<a name="l00175"></a>00175 }
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00180"></a><a class="code" href="classLaspackVector.php#abb5b44a8924369c1fda30a5fe571f9d6">00180</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#abb5b44a8924369c1fda30a5fe571f9d6">LaspackVector&lt;T&gt;::insert</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00181"></a>00181                                <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00182"></a>00182 {
<a name="l00183"></a>00183   libmesh_assert (!v.empty());
<a name="l00184"></a>00184   libmesh_assert (v.size() == dof_indices.size());
<a name="l00185"></a>00185   
<a name="l00186"></a>00186   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l00187"></a>00187     this-&gt;<span class="keyword">set</span> (dof_indices[i], v[i]);
<a name="l00188"></a>00188 }
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00193"></a><a class="code" href="classLaspackVector.php#ab09f92792e32d7767871499f44595d90">00193</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#abb5b44a8924369c1fda30a5fe571f9d6">LaspackVector&lt;T&gt;::insert</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00194"></a>00194                                <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00195"></a>00195 {
<a name="l00196"></a>00196   libmesh_assert (V.<a class="code" href="classNumericVector.php#ae21bc89e89e895ac26b851a31926e194">size</a>() == dof_indices.size());
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classNumericVector.php#ae21bc89e89e895ac26b851a31926e194">size</a>(); i++)
<a name="l00199"></a>00199    this-&gt;<span class="keyword">set</span> (dof_indices[i], V(i));
<a name="l00200"></a>00200 }
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00205"></a><a class="code" href="classLaspackVector.php#aa05cb3a4a0b13b85a22f7d48193f5dad">00205</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#abb5b44a8924369c1fda30a5fe571f9d6">LaspackVector&lt;T&gt;::insert</a> (<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00206"></a>00206                                <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00207"></a>00207 {
<a name="l00208"></a>00208   libmesh_assert (V.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>() == dof_indices.size());
<a name="l00209"></a>00209 
<a name="l00210"></a>00210   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classDenseVector.php#a1787e281ed3310eb776e77142562b68d">size</a>(); i++)
<a name="l00211"></a>00211     this-&gt;<span class="keyword">set</span> (dof_indices[i], V(i));
<a name="l00212"></a>00212 }
<a name="l00213"></a>00213 
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 
<a name="l00216"></a>00216 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00217"></a><a class="code" href="classLaspackVector.php#aac31db99f6d7f05f765d29740cf832bb">00217</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#abb5b44a8924369c1fda30a5fe571f9d6">LaspackVector&lt;T&gt;::insert</a> (<span class="keyword">const</span> <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;T&gt;</a>&amp; V,
<a name="l00218"></a>00218                                <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00219"></a>00219 {
<a name="l00220"></a>00220   libmesh_assert (V.<a class="code" href="classDenseVectorBase.php#af27a452cf8a2a5ec845e040c85761572">size</a>() == dof_indices.size());
<a name="l00221"></a>00221 
<a name="l00222"></a>00222   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classDenseVectorBase.php#af27a452cf8a2a5ec845e040c85761572">size</a>(); i++)
<a name="l00223"></a>00223     this-&gt;<span class="keyword">set</span> (dof_indices[i], V(i));
<a name="l00224"></a>00224 }
<a name="l00225"></a>00225 
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00229"></a><a class="code" href="classLaspackVector.php#afdb6958e74522135b178444877db4017">00229</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#aeb761622629dd3c53a4a15105d57be54">LaspackVector&lt;T&gt;::add_vector</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;vec_in,
<a name="l00230"></a>00230                                    <span class="keyword">const</span> <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;mat_in)
<a name="l00231"></a>00231 {
<a name="l00232"></a>00232   <span class="comment">// Make sure the data passed in are really in Laspack types</span>
<a name="l00233"></a>00233   <span class="keyword">const</span> <a class="code" href="classLaspackVector.php">LaspackVector&lt;T&gt;</a>* vec = libmesh_cast_ptr&lt;const LaspackVector&lt;T&gt;*&gt;(&amp;vec_in);
<a name="l00234"></a>00234   <span class="keyword">const</span> <a class="code" href="classLaspackMatrix.php">LaspackMatrix&lt;T&gt;</a>* mat = libmesh_cast_ptr&lt;const LaspackMatrix&lt;T&gt;*&gt;(&amp;mat_in);
<a name="l00235"></a>00235 
<a name="l00236"></a>00236   libmesh_assert (vec != NULL);
<a name="l00237"></a>00237   libmesh_assert (mat != NULL);
<a name="l00238"></a>00238   
<a name="l00239"></a>00239   <span class="comment">// += mat*vec</span>
<a name="l00240"></a>00240   AddAsgn_VV (&amp;_vec, Mul_QV(const_cast&lt;QMatrix*&gt;(&amp;mat-&gt;_QMat),
<a name="l00241"></a>00241                             const_cast&lt;QVector*&gt;(&amp;vec-&gt;<a class="code" href="classLaspackVector.php#aa76ff61c00c3dccf194399ecaf64d5da">_vec</a>)));
<a name="l00242"></a>00242 }
<a name="l00243"></a>00243 
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00247"></a><a class="code" href="classLaspackVector.php#a7ae785377ae5f24c68a66c63d41c345f">00247</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#a7ae785377ae5f24c68a66c63d41c345f">LaspackVector&lt;T&gt;::scale</a> (<span class="keyword">const</span> T factor)
<a name="l00248"></a>00248 {
<a name="l00249"></a>00249   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00250"></a>00250   
<a name="l00251"></a>00251   Mul_SV (factor, &amp;_vec);
<a name="l00252"></a>00252 }
<a name="l00253"></a>00253 
<a name="l00254"></a>00254 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00255"></a><a class="code" href="classLaspackVector.php#a99cc057ed69a0d25348703a734db15c1">00255</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#a99cc057ed69a0d25348703a734db15c1">LaspackVector&lt;T&gt;::abs</a>()
<a name="l00256"></a>00256 {
<a name="l00257"></a>00257   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00258"></a>00258 
<a name="l00259"></a>00259   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = this-&gt;size();
<a name="l00260"></a>00260   
<a name="l00261"></a>00261   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=n; ++i)
<a name="l00262"></a>00262     this-&gt;<span class="keyword">set</span>(i,std::abs((*<span class="keyword">this</span>)(i)));
<a name="l00263"></a>00263 }
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00266"></a><a class="code" href="classLaspackVector.php#a66935edb5c54e3744e56289dcc02209b">00266</a> T <a class="code" href="classLaspackVector.php#a66935edb5c54e3744e56289dcc02209b">LaspackVector&lt;T&gt;::dot</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; V)<span class="keyword"> const</span>
<a name="l00267"></a>00267 <span class="keyword"></span>{
<a name="l00268"></a>00268   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00269"></a>00269 
<a name="l00270"></a>00270   <span class="comment">// Make sure the NumericVector passed in is really a LaspackVector</span>
<a name="l00271"></a>00271   <span class="keyword">const</span> <a class="code" href="classLaspackVector.php">LaspackVector&lt;T&gt;</a>* v = libmesh_cast_ptr&lt;const LaspackVector&lt;T&gt;*&gt;(&amp;V);
<a name="l00272"></a>00272   libmesh_assert (v != NULL);
<a name="l00273"></a>00273   
<a name="l00274"></a>00274   <span class="keywordflow">return</span> Mul_VV (const_cast&lt;QVector*&gt;(&amp;(this-&gt;_vec)),
<a name="l00275"></a>00275                  const_cast&lt;QVector*&gt;(&amp;(v-&gt;<a class="code" href="classLaspackVector.php#aa76ff61c00c3dccf194399ecaf64d5da">_vec</a>)));
<a name="l00276"></a>00276 }
<a name="l00277"></a>00277 
<a name="l00278"></a>00278 
<a name="l00279"></a>00279 
<a name="l00280"></a>00280 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00281"></a>00281 <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; 
<a name="l00282"></a><a class="code" href="classLaspackVector.php#a299fbb7727cd022164164f00f0510916">00282</a> <a class="code" href="classLaspackVector.php#a299fbb7727cd022164164f00f0510916">LaspackVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> T s)
<a name="l00283"></a>00283 {
<a name="l00284"></a>00284   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00285"></a>00285 
<a name="l00286"></a>00286   V_SetAllCmp (&amp;_vec, s);
<a name="l00287"></a>00287   
<a name="l00288"></a>00288   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00289"></a>00289 }
<a name="l00290"></a>00290 
<a name="l00291"></a>00291 
<a name="l00292"></a>00292 
<a name="l00293"></a>00293 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00294"></a>00294 <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;
<a name="l00295"></a><a class="code" href="classLaspackVector.php#ac7501d453a5a60ee418169c7a4281c44">00295</a> <a class="code" href="classLaspackVector.php#a299fbb7727cd022164164f00f0510916">LaspackVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_in)
<a name="l00296"></a>00296 {
<a name="l00297"></a>00297   <span class="comment">// Make sure the NumericVector passed in is really a LaspackVector</span>
<a name="l00298"></a>00298   <span class="keyword">const</span> <a class="code" href="classLaspackVector.php">LaspackVector&lt;T&gt;</a>* v =
<a name="l00299"></a>00299     libmesh_cast_ptr&lt;const LaspackVector&lt;T&gt;*&gt;(&amp;v_in);
<a name="l00300"></a>00300 
<a name="l00301"></a>00301   libmesh_assert (v != NULL);
<a name="l00302"></a>00302   
<a name="l00303"></a>00303   *<span class="keyword">this</span> = *v;
<a name="l00304"></a>00304 
<a name="l00305"></a>00305   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00306"></a>00306 }
<a name="l00307"></a>00307 
<a name="l00308"></a>00308 
<a name="l00309"></a>00309 
<a name="l00310"></a>00310 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00311"></a>00311 <a class="code" href="classLaspackVector.php">LaspackVector&lt;T&gt;</a>&amp;
<a name="l00312"></a><a class="code" href="classLaspackVector.php#a2d83979878405e6a0730a808ce73f408">00312</a> <a class="code" href="classLaspackVector.php#a299fbb7727cd022164164f00f0510916">LaspackVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> <a class="code" href="classLaspackVector.php">LaspackVector&lt;T&gt;</a>&amp; v)
<a name="l00313"></a>00313 {
<a name="l00314"></a>00314   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00315"></a>00315   libmesh_assert (this-&gt;size() == v.<a class="code" href="classLaspackVector.php#a9acfef7d3f7d5f82014016605bfd42b3">size</a>());
<a name="l00316"></a>00316 
<a name="l00317"></a>00317   this-&gt;_is_closed = v.<a class="code" href="classNumericVector.php#a5fb110426b9570de8690d317424a310b">_is_closed</a>;
<a name="l00318"></a>00318 
<a name="l00319"></a>00319   <span class="keywordflow">if</span> (v.<a class="code" href="classLaspackVector.php#a9acfef7d3f7d5f82014016605bfd42b3">size</a>() != 0)    
<a name="l00320"></a>00320     Asgn_VV (const_cast&lt;QVector*&gt;(&amp;_vec),
<a name="l00321"></a>00321              <span class="keyword">const_cast&lt;</span>QVector*<span class="keyword">&gt;</span>(&amp;v.<a class="code" href="classLaspackVector.php#aa76ff61c00c3dccf194399ecaf64d5da">_vec</a>)
<a name="l00322"></a>00322              );
<a name="l00323"></a>00323   
<a name="l00324"></a>00324   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00325"></a>00325 }
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00330"></a>00330 <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;
<a name="l00331"></a><a class="code" href="classLaspackVector.php#a7338ec738bf4d68072000c9bac602319">00331</a> <a class="code" href="classLaspackVector.php#a299fbb7727cd022164164f00f0510916">LaspackVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v)
<a name="l00332"></a>00332 {
<a name="l00337"></a>00337   <span class="keywordflow">if</span> (this-&gt;size() == v.size())      
<a name="l00338"></a>00338     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l00339"></a>00339       this-&gt;<span class="keyword">set</span> (i, v[i]);
<a name="l00340"></a>00340   
<a name="l00341"></a>00341   <span class="keywordflow">else</span>
<a name="l00342"></a>00342     libmesh_error();
<a name="l00343"></a>00343 
<a name="l00344"></a>00344   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00345"></a>00345 }
<a name="l00346"></a>00346 
<a name="l00347"></a>00347 
<a name="l00348"></a>00348 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00349"></a><a class="code" href="classLaspackVector.php#a37ca6d4623a1a20de7b687eb0263fd90">00349</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#af3f85c8a6b5934520ea51546cb7b618a">LaspackVector&lt;T&gt;::localize</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local_in)<span class="keyword"> const</span>
<a name="l00350"></a>00350 <span class="keyword"></span>{
<a name="l00351"></a>00351   <span class="comment">// Make sure the NumericVector passed in is really a LaspackVector</span>
<a name="l00352"></a>00352   <a class="code" href="classLaspackVector.php">LaspackVector&lt;T&gt;</a>* v_local =
<a name="l00353"></a>00353     libmesh_cast_ptr&lt;LaspackVector&lt;T&gt;*&gt;(&amp;v_local_in);
<a name="l00354"></a>00354 
<a name="l00355"></a>00355   libmesh_assert (v_local != NULL);
<a name="l00356"></a>00356 
<a name="l00357"></a>00357   *v_local = *<span class="keyword">this</span>;
<a name="l00358"></a>00358 }
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 
<a name="l00361"></a>00361 
<a name="l00362"></a>00362 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00363"></a><a class="code" href="classLaspackVector.php#a21cd7a493b223094d6c106afe22768c6">00363</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#af3f85c8a6b5934520ea51546cb7b618a">LaspackVector&lt;T&gt;::localize</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local_in,
<a name="l00364"></a>00364                                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list)<span class="keyword"> const</span>
<a name="l00365"></a>00365 <span class="keyword"></span>{
<a name="l00366"></a>00366   <span class="comment">// Make sure the NumericVector passed in is really a LaspackVector</span>
<a name="l00367"></a>00367   <a class="code" href="classLaspackVector.php">LaspackVector&lt;T&gt;</a>* v_local =
<a name="l00368"></a>00368     libmesh_cast_ptr&lt;LaspackVector&lt;T&gt;*&gt;(&amp;v_local_in);
<a name="l00369"></a>00369 
<a name="l00370"></a>00370   libmesh_assert (v_local != NULL);
<a name="l00371"></a>00371   libmesh_assert (send_list.size() &lt;= v_local-&gt;<a class="code" href="classLaspackVector.php#a9acfef7d3f7d5f82014016605bfd42b3">size</a>());
<a name="l00372"></a>00372 
<a name="l00373"></a>00373   *v_local = *<span class="keyword">this</span>;
<a name="l00374"></a>00374 }
<a name="l00375"></a>00375 
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00379"></a><a class="code" href="classLaspackVector.php#a0baf5efe1ea515b37f910c608d8344c5">00379</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#af3f85c8a6b5934520ea51546cb7b618a">LaspackVector&lt;T&gt;::localize</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_idx,
<a name="l00380"></a>00380                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> last_local_idx,
<a name="l00381"></a>00381                                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list)
<a name="l00382"></a>00382 {
<a name="l00383"></a>00383   libmesh_assert (first_local_idx  == 0);
<a name="l00384"></a>00384   libmesh_assert (last_local_idx+1 == this-&gt;size());
<a name="l00385"></a>00385   
<a name="l00386"></a>00386   libmesh_assert (send_list.size() &lt;= this-&gt;size());
<a name="l00387"></a>00387 }
<a name="l00388"></a>00388 
<a name="l00389"></a>00389 
<a name="l00390"></a>00390 
<a name="l00391"></a>00391 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00392"></a><a class="code" href="classLaspackVector.php#af3f85c8a6b5934520ea51546cb7b618a">00392</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#af3f85c8a6b5934520ea51546cb7b618a">LaspackVector&lt;T&gt;::localize</a> (std::vector&lt;T&gt;&amp; v_local)<span class="keyword"> const</span>
<a name="l00393"></a>00393 <span class="keyword"></span>
<a name="l00394"></a>00394 <span class="keyword"></span>{
<a name="l00395"></a>00395   v_local.resize(this-&gt;size());
<a name="l00396"></a>00396 
<a name="l00397"></a>00397   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v_local.size(); i++)
<a name="l00398"></a>00398     v_local[i] = (*<span class="keyword">this</span>)(i);  
<a name="l00399"></a>00399 }
<a name="l00400"></a>00400 
<a name="l00401"></a>00401 
<a name="l00402"></a>00402 
<a name="l00403"></a>00403 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00404"></a><a class="code" href="classLaspackVector.php#a4e0813e4889061e53ed6ae900626bf97">00404</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#a4e0813e4889061e53ed6ae900626bf97">LaspackVector&lt;T&gt;::localize_to_one</a> (std::vector&lt;T&gt;&amp; v_local,
<a name="l00405"></a>00405                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid)<span class="keyword"> const</span>
<a name="l00406"></a>00406 <span class="keyword"></span>{
<a name="l00407"></a>00407   libmesh_assert (pid == 0);
<a name="l00408"></a>00408 
<a name="l00409"></a>00409   this-&gt;localize (v_local);
<a name="l00410"></a>00410 }
<a name="l00411"></a>00411 
<a name="l00412"></a>00412 
<a name="l00413"></a>00413 
<a name="l00414"></a>00414 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00415"></a><a class="code" href="classLaspackVector.php#ab7d82a1212eff97ef7347c7a46be0334">00415</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#ab7d82a1212eff97ef7347c7a46be0334">LaspackVector&lt;T&gt;::pointwise_mult</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; <span class="comment">/*vec1*/</span>,
<a name="l00416"></a>00416                                        <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; <span class="comment">/*vec2*/</span>)
<a name="l00417"></a>00417 {
<a name="l00418"></a>00418   libmesh_not_implemented();
<a name="l00419"></a>00419 }
<a name="l00420"></a>00420 
<a name="l00421"></a>00421 
<a name="l00422"></a>00422 
<a name="l00423"></a>00423 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00424"></a><a class="code" href="classLaspackVector.php#a8ff2cd6c8ea6962a1001520a802756e3">00424</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classLaspackVector.php#a8ff2cd6c8ea6962a1001520a802756e3">LaspackVector&lt;T&gt;::max</a>()<span class="keyword"> const</span>
<a name="l00425"></a>00425 <span class="keyword"></span>{
<a name="l00426"></a>00426   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00427"></a>00427   <span class="keywordflow">if</span> (!this-&gt;size())
<a name="l00428"></a>00428     <span class="keywordflow">return</span> -<a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;Real&gt;::max</a>();
<a name="l00429"></a>00429 
<a name="l00430"></a>00430   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a> = <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>((*<span class="keyword">this</span>)(0));
<a name="l00431"></a>00431 
<a name="l00432"></a>00432   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = this-&gt;size();
<a name="l00433"></a>00433   
<a name="l00434"></a>00434   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i&lt;n; i++)
<a name="l00435"></a>00435     max = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a> (max, <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>((*<span class="keyword">this</span>)(i)));
<a name="l00436"></a>00436 
<a name="l00437"></a>00437   <span class="keywordflow">return</span> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>;
<a name="l00438"></a>00438 }
<a name="l00439"></a>00439 
<a name="l00440"></a>00440 
<a name="l00441"></a>00441 
<a name="l00442"></a>00442 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00443"></a><a class="code" href="classLaspackVector.php#a7b682d71088a7e81c5c65327d9d39e56">00443</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classLaspackVector.php#a7b682d71088a7e81c5c65327d9d39e56">LaspackVector&lt;T&gt;::min</a> ()<span class="keyword"> const</span>
<a name="l00444"></a>00444 <span class="keyword"></span>{
<a name="l00445"></a>00445   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00446"></a>00446   <span class="keywordflow">if</span> (!this-&gt;size())
<a name="l00447"></a>00447     <span class="keywordflow">return</span> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;Real&gt;::max</a>();
<a name="l00448"></a>00448 
<a name="l00449"></a>00449   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a> = <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>((*<span class="keyword">this</span>)(0));
<a name="l00450"></a>00450 
<a name="l00451"></a>00451   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = this-&gt;size();
<a name="l00452"></a>00452   
<a name="l00453"></a>00453   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i&lt;n; i++)
<a name="l00454"></a>00454     min = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a> (min, <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>((*<span class="keyword">this</span>)(i)));
<a name="l00455"></a>00455 
<a name="l00456"></a>00456   <span class="keywordflow">return</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>;
<a name="l00457"></a>00457 }
<a name="l00458"></a>00458 
<a name="l00459"></a>00459 
<a name="l00460"></a>00460 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00461"></a>00461 <span class="comment">// Explicit instantiations</span>
<a name="l00462"></a>00462 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classLaspackVector.php">LaspackVector&lt;Number&gt;</a>;
<a name="l00463"></a>00463  
<a name="l00464"></a>00464 
<a name="l00465"></a>00465 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_LASPACK</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
