<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>laspack_vector.h</h1>  </div>
</div>
<div class="contents">
<a href="laspack__vector_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: laspack_vector.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifndef __laspack_vector_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#define __laspack_vector_h__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#ifdef LIBMESH_HAVE_LASPACK</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// C++ includes</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &lt;cstdio&gt;</span> <span class="comment">// for std::sprintf</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// Local includes</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="preprocessor">#include &lt;qvector.h&gt;</span>
<a name="l00045"></a>00045 <span class="preprocessor">#include &lt;operats.h&gt;</span>
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 <span class="comment">// Forward declarations</span>
<a name="l00049"></a>00049 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classLaspackLinearSolver.php">LaspackLinearSolver</a>;
<a name="l00050"></a>00050 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classSparseMatrix.php">SparseMatrix</a>;
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00060"></a>00060 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00061"></a><a class="code" href="classLaspackVector.php">00061</a> <span class="keyword">class </span><a class="code" href="classLaspackVector.php">LaspackVector</a> : <span class="keyword">public</span> <a class="code" href="classNumericVector.php">NumericVector</a>&lt;T&gt;
<a name="l00062"></a>00062 {
<a name="l00063"></a>00063  <span class="keyword">public</span>:
<a name="l00064"></a>00064 
<a name="l00068"></a>00068   <span class="keyword">explicit</span>
<a name="l00069"></a>00069   <a class="code" href="classLaspackVector.php#ace2c5b33793be0932575d079d2babc93">LaspackVector</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00070"></a>00070   
<a name="l00074"></a>00074   <span class="keyword">explicit</span>
<a name="l00075"></a>00075   <a class="code" href="classLaspackVector.php#ace2c5b33793be0932575d079d2babc93">LaspackVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00076"></a>00076                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00077"></a>00077     
<a name="l00082"></a>00082   <a class="code" href="classLaspackVector.php#ace2c5b33793be0932575d079d2babc93">LaspackVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00083"></a>00083                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00084"></a>00084                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00085"></a>00085   
<a name="l00091"></a>00091   <a class="code" href="classLaspackVector.php#ace2c5b33793be0932575d079d2babc93">LaspackVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00092"></a>00092                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00093"></a>00093                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ghost,
<a name="l00094"></a>00094                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00095"></a>00095     
<a name="l00100"></a>00100   <a class="code" href="classLaspackVector.php#af931b1b50b76eb1a0f74202a22410d61">~LaspackVector</a> ();
<a name="l00101"></a>00101 
<a name="l00105"></a>00105   <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#ad96e22aa017ab21646815f16edd8d7a9">close</a> (); 
<a name="l00106"></a>00106 
<a name="l00110"></a>00110   <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#a107340c317ee3d11488e6f2017c119ef">clear</a> ();
<a name="l00111"></a>00111   
<a name="l00116"></a>00116   <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#aec4911b8dc8d4c773eff4646aa727896">zero</a> ();    
<a name="l00117"></a>00117 
<a name="l00121"></a>00121   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classLaspackVector.php#ae613025c75a6e468c95873a69a0594de">clone</a> () <span class="keyword">const</span>;
<a name="l00122"></a>00122   
<a name="l00136"></a>00136   <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#a570063b71e840b15da36283480d16023">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00137"></a>00137              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00138"></a>00138              <span class="keyword">const</span> <span class="keywordtype">bool</span>         fast=<span class="keyword">false</span>,
<a name="l00139"></a>00139              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a>=<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00140"></a>00140     
<a name="l00144"></a>00144   <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#a570063b71e840b15da36283480d16023">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00145"></a>00145              <span class="keyword">const</span> <span class="keywordtype">bool</span>         fast=<span class="keyword">false</span>,
<a name="l00146"></a>00146              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a>=<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00147"></a>00147     
<a name="l00152"></a>00152   <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#a570063b71e840b15da36283480d16023">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*N*/</span>,
<a name="l00153"></a>00153              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*n_local*/</span>,
<a name="l00154"></a>00154              <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <span class="comment">/*ghost*/</span>,
<a name="l00155"></a>00155              <span class="keyword">const</span> <span class="keywordtype">bool</span> <span class="comment">/*fast*/</span> = <span class="keyword">false</span>,
<a name="l00156"></a>00156              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00157"></a>00157 
<a name="l00162"></a>00162   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#a570063b71e840b15da36283480d16023">init</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; other,
<a name="l00163"></a>00163                      <span class="keyword">const</span> <span class="keywordtype">bool</span> fast = <span class="keyword">false</span>);
<a name="l00164"></a>00164     
<a name="l00168"></a>00168   <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classLaspackVector.php#a299fbb7727cd022164164f00f0510916">operator= </a>(<span class="keyword">const</span> T s);
<a name="l00169"></a>00169     
<a name="l00173"></a>00173   <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classLaspackVector.php#a299fbb7727cd022164164f00f0510916">operator= </a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00174"></a>00174   
<a name="l00178"></a>00178   <a class="code" href="classLaspackVector.php">LaspackVector&lt;T&gt;</a> &amp; <a class="code" href="classLaspackVector.php#a299fbb7727cd022164164f00f0510916">operator= </a>(<span class="keyword">const</span> <a class="code" href="classLaspackVector.php">LaspackVector&lt;T&gt;</a> &amp;V);
<a name="l00179"></a>00179 
<a name="l00183"></a>00183   <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classLaspackVector.php#a299fbb7727cd022164164f00f0510916">operator= </a>(<span class="keyword">const</span> std::vector&lt;T&gt; &amp;v);
<a name="l00184"></a>00184 
<a name="l00190"></a>00190   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classLaspackVector.php#a7b682d71088a7e81c5c65327d9d39e56">min</a> () <span class="keyword">const</span>;
<a name="l00191"></a>00191   
<a name="l00197"></a>00197   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classLaspackVector.php#a8ff2cd6c8ea6962a1001520a802756e3">max</a> () <span class="keyword">const</span>;
<a name="l00198"></a>00198   
<a name="l00202"></a>00202   T <a class="code" href="classLaspackVector.php#a4658e39680248bc4d6bbf454dcd78aa3">sum</a> () <span class="keyword">const</span>; 
<a name="l00203"></a>00203 
<a name="l00208"></a>00208   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classLaspackVector.php#a50889100fe8e6159962c4d1ce336e8df">l1_norm</a> () <span class="keyword">const</span>;
<a name="l00209"></a>00209 
<a name="l00215"></a>00215   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classLaspackVector.php#af56611f68f067d46f9f62e65b3606d8a">l2_norm</a> () <span class="keyword">const</span>;
<a name="l00216"></a>00216 
<a name="l00222"></a>00222   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classLaspackVector.php#a49c73ee4a6b4210631ae0f60fc934116">linfty_norm</a> () <span class="keyword">const</span>;
<a name="l00223"></a>00223 
<a name="l00231"></a>00231   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classLaspackVector.php#a9acfef7d3f7d5f82014016605bfd42b3">size</a> () <span class="keyword">const</span>;
<a name="l00232"></a>00232 
<a name="l00237"></a>00237   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classLaspackVector.php#a76814258fbdaf7f1a92ae513b086e9b7">local_size</a>() <span class="keyword">const</span>;
<a name="l00238"></a>00238 
<a name="l00243"></a>00243   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classLaspackVector.php#a8de4a6c30b3e9bd37c1ee49dae6df47d">first_local_index</a>() <span class="keyword">const</span>;
<a name="l00244"></a>00244 
<a name="l00249"></a>00249   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classLaspackVector.php#acbe44b89d6d21384ed5ba847784885eb">last_local_index</a>() <span class="keyword">const</span>;
<a name="l00250"></a>00250     
<a name="l00254"></a>00254   T <a class="code" href="classLaspackVector.php#afe77da9f86ab05a53476e623a8815542">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00255"></a>00255     
<a name="l00260"></a>00260   <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classLaspackVector.php#a47dad528d58f1fcaa503ee25b691148f">operator += </a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00261"></a>00261 
<a name="l00266"></a>00266   <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classLaspackVector.php#ad85b90aedb454d40e65fcdb8cbdcb717">operator -= </a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00267"></a>00267     
<a name="l00271"></a>00271   <span class="keywordtype">void</span> <span class="keyword">set</span> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value);
<a name="l00272"></a>00272     
<a name="l00276"></a>00276   <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#a94d61c428f9c5890c8086f896c5575c2">add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value);
<a name="l00277"></a>00277     
<a name="l00283"></a>00283   <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#a94d61c428f9c5890c8086f896c5575c2">add</a> (<span class="keyword">const</span> T s);
<a name="l00284"></a>00284     
<a name="l00290"></a>00290   <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#a94d61c428f9c5890c8086f896c5575c2">add</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; V);
<a name="l00291"></a>00291 
<a name="l00297"></a>00297   <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#a94d61c428f9c5890c8086f896c5575c2">add</a> (<span class="keyword">const</span> T a, <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v);
<a name="l00298"></a>00298   
<a name="l00304"></a>00304   <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#aeb761622629dd3c53a4a15105d57be54">add_vector</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00305"></a>00305                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00306"></a>00306 
<a name="l00313"></a>00313   <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#aeb761622629dd3c53a4a15105d57be54">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00314"></a>00314                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00315"></a>00315  
<a name="l00320"></a>00320   <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#aeb761622629dd3c53a4a15105d57be54">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;,
<a name="l00321"></a>00321                    <span class="keyword">const</span> <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;);
<a name="l00322"></a>00322       
<a name="l00329"></a>00329   <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#aeb761622629dd3c53a4a15105d57be54">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00330"></a>00330                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00331"></a>00331   
<a name="l00336"></a>00336   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#abb5b44a8924369c1fda30a5fe571f9d6">insert</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00337"></a>00337                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00338"></a>00338 
<a name="l00345"></a>00345   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#abb5b44a8924369c1fda30a5fe571f9d6">insert</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00346"></a>00346                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00347"></a>00347       
<a name="l00353"></a>00353   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#abb5b44a8924369c1fda30a5fe571f9d6">insert</a> (<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00354"></a>00354                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00355"></a>00355   
<a name="l00361"></a>00361   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#abb5b44a8924369c1fda30a5fe571f9d6">insert</a> (<span class="keyword">const</span> <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;T&gt;</a>&amp; V,
<a name="l00362"></a>00362                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00363"></a>00363   
<a name="l00368"></a>00368   <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#a7ae785377ae5f24c68a66c63d41c345f">scale</a> (<span class="keyword">const</span> T factor);
<a name="l00369"></a>00369 
<a name="l00374"></a>00374   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#a99cc057ed69a0d25348703a734db15c1">abs</a>();
<a name="l00375"></a>00375 
<a name="l00379"></a>00379   <span class="keyword">virtual</span> T <a class="code" href="classLaspackVector.php#a66935edb5c54e3744e56289dcc02209b">dot</a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; V) <span class="keyword">const</span>;
<a name="l00380"></a>00380 
<a name="l00385"></a>00385   <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#af3f85c8a6b5934520ea51546cb7b618a">localize</a> (std::vector&lt;T&gt;&amp; v_local) <span class="keyword">const</span>;
<a name="l00386"></a>00386 
<a name="l00391"></a>00391   <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#af3f85c8a6b5934520ea51546cb7b618a">localize</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local) <span class="keyword">const</span>;
<a name="l00392"></a>00392 
<a name="l00398"></a>00398   <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#af3f85c8a6b5934520ea51546cb7b618a">localize</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local,
<a name="l00399"></a>00399                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list) <span class="keyword">const</span>;
<a name="l00400"></a>00400     
<a name="l00405"></a>00405   <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#af3f85c8a6b5934520ea51546cb7b618a">localize</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_idx,
<a name="l00406"></a>00406                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> last_local_idx,
<a name="l00407"></a>00407                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list);
<a name="l00408"></a>00408 
<a name="l00409"></a>00409   
<a name="l00416"></a>00416   <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#a4e0813e4889061e53ed6ae900626bf97">localize_to_one</a> (std::vector&lt;T&gt;&amp; v_local,
<a name="l00417"></a>00417                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id=0) <span class="keyword">const</span>;
<a name="l00418"></a>00418     
<a name="l00423"></a>00423   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#ab7d82a1212eff97ef7347c7a46be0334">pointwise_mult</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec1,
<a name="l00424"></a>00424                                <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec2);
<a name="l00425"></a>00425 
<a name="l00429"></a>00429   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#aaf90235417c324ee6537e876013c3c08">swap</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;v);
<a name="l00430"></a>00430 
<a name="l00431"></a>00431  <span class="keyword">private</span>:
<a name="l00432"></a>00432 
<a name="l00437"></a><a class="code" href="classLaspackVector.php#aa76ff61c00c3dccf194399ecaf64d5da">00437</a>   QVector <a class="code" href="classLaspackVector.php#aa76ff61c00c3dccf194399ecaf64d5da">_vec</a>;
<a name="l00438"></a>00438 
<a name="l00442"></a><a class="code" href="classLaspackVector.php#a0be0354b510b1eba31ee700b6a44408b">00442</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classLaspackLinearSolver.php">LaspackLinearSolver</a>&lt;T&gt;;
<a name="l00443"></a>00443 };
<a name="l00444"></a>00444 
<a name="l00445"></a>00445 
<a name="l00446"></a>00446 
<a name="l00447"></a>00447 <span class="comment">//----------------------- ----------------------------------</span>
<a name="l00448"></a>00448 <span class="comment">// LaspackVector inline methods</span>
<a name="l00449"></a>00449 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00450"></a>00450 <span class="keyword">inline</span>
<a name="l00451"></a><a class="code" href="classLaspackVector.php#ace2c5b33793be0932575d079d2babc93">00451</a> <a class="code" href="classLaspackVector.php#ace2c5b33793be0932575d079d2babc93">LaspackVector&lt;T&gt;::LaspackVector</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00452"></a>00452 {
<a name="l00453"></a>00453   this-&gt;_type = type;
<a name="l00454"></a>00454 }
<a name="l00455"></a>00455 
<a name="l00456"></a>00456 
<a name="l00457"></a>00457 
<a name="l00458"></a>00458 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00459"></a>00459 <span class="keyword">inline</span>
<a name="l00460"></a><a class="code" href="classLaspackVector.php#a12e37925c958b471ddf2deeb36e3b9cd">00460</a> <a class="code" href="classLaspackVector.php#ace2c5b33793be0932575d079d2babc93">LaspackVector&lt;T&gt;::LaspackVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00461"></a>00461                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00462"></a>00462 {
<a name="l00463"></a>00463   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(n, n, <span class="keyword">false</span>, type);
<a name="l00464"></a>00464 }
<a name="l00465"></a>00465 
<a name="l00466"></a>00466 
<a name="l00467"></a>00467 
<a name="l00468"></a>00468 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00469"></a>00469 <span class="keyword">inline</span>
<a name="l00470"></a><a class="code" href="classLaspackVector.php#ad7b3219f21fb2e0fd8ff121e9edaa99d">00470</a> <a class="code" href="classLaspackVector.php#ace2c5b33793be0932575d079d2babc93">LaspackVector&lt;T&gt;::LaspackVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00471"></a>00471                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00472"></a>00472                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00473"></a>00473 {
<a name="l00474"></a>00474   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(n, n_local, <span class="keyword">false</span>, type);
<a name="l00475"></a>00475 }
<a name="l00476"></a>00476 
<a name="l00477"></a>00477 
<a name="l00478"></a>00478 
<a name="l00479"></a>00479 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00480"></a>00480 <span class="keyword">inline</span>
<a name="l00481"></a><a class="code" href="classLaspackVector.php#a69be6f6ba47f06f0a6e133a4aef0cdd5">00481</a> <a class="code" href="classLaspackVector.php#ace2c5b33793be0932575d079d2babc93">LaspackVector&lt;T&gt;::LaspackVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00482"></a>00482                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00483"></a>00483                                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ghost,
<a name="l00484"></a>00484                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00485"></a>00485 {
<a name="l00486"></a>00486   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(N, n_local, ghost, <span class="keyword">false</span>, type);
<a name="l00487"></a>00487 }
<a name="l00488"></a>00488 
<a name="l00489"></a>00489 
<a name="l00490"></a>00490 
<a name="l00491"></a>00491 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00492"></a>00492 <span class="keyword">inline</span>
<a name="l00493"></a><a class="code" href="classLaspackVector.php#af931b1b50b76eb1a0f74202a22410d61">00493</a> <a class="code" href="classLaspackVector.php#af931b1b50b76eb1a0f74202a22410d61">LaspackVector&lt;T&gt;::~LaspackVector</a> ()
<a name="l00494"></a>00494 {
<a name="l00495"></a>00495   this-&gt;<a class="code" href="classLaspackLinearSolver.php#a0daf5686c596ad9a606626253a8d3e09">clear</a> ();
<a name="l00496"></a>00496 }
<a name="l00497"></a>00497 
<a name="l00498"></a>00498 
<a name="l00499"></a>00499 
<a name="l00500"></a>00500 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00501"></a>00501 <span class="keyword">inline</span>
<a name="l00502"></a><a class="code" href="classLaspackVector.php#a570063b71e840b15da36283480d16023">00502</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#a570063b71e840b15da36283480d16023">LaspackVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00503"></a>00503                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00504"></a>00504                              <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00505"></a>00505                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a>)
<a name="l00506"></a>00506 {
<a name="l00507"></a>00507   <span class="comment">// Laspack vectors only for serial cases,</span>
<a name="l00508"></a>00508   <span class="comment">// but can provide a &quot;parallel&quot; vector on one processor.</span>
<a name="l00509"></a>00509   libmesh_assert (n == n_local);
<a name="l00510"></a>00510 
<a name="l00511"></a>00511   this-&gt;_type = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>;
<a name="l00512"></a>00512 
<a name="l00513"></a>00513   <span class="comment">// Clear initialized vectors</span>
<a name="l00514"></a>00514   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00515"></a>00515     this-&gt;<a class="code" href="classLaspackLinearSolver.php#a0daf5686c596ad9a606626253a8d3e09">clear</a>();
<a name="l00516"></a>00516 
<a name="l00517"></a>00517   <span class="comment">// create a sequential vector</span>
<a name="l00518"></a>00518 
<a name="l00519"></a>00519   <span class="keyword">static</span> <span class="keywordtype">int</span> cnt = 0;
<a name="l00520"></a>00520   <span class="keywordtype">char</span> foo[80];
<a name="l00521"></a>00521   std::sprintf(foo,  <span class="stringliteral">&quot;Vec-%d&quot;</span>, cnt++); 
<a name="l00522"></a>00522 
<a name="l00523"></a>00523   V_Constr(&amp;_vec, const_cast&lt;char*&gt;(foo), n, Normal, _LPTrue);
<a name="l00524"></a>00524     
<a name="l00525"></a>00525   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00526"></a>00526   
<a name="l00527"></a>00527   <span class="comment">// Optionally zero out all components</span>
<a name="l00528"></a>00528   <span class="keywordflow">if</span> (fast == <span class="keyword">false</span>)
<a name="l00529"></a>00529     this-&gt;<a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a> ();
<a name="l00530"></a>00530   
<a name="l00531"></a>00531   <span class="keywordflow">return</span>;
<a name="l00532"></a>00532 }
<a name="l00533"></a>00533 
<a name="l00534"></a>00534 
<a name="l00535"></a>00535 
<a name="l00536"></a>00536 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00537"></a>00537 <span class="keyword">inline</span>
<a name="l00538"></a><a class="code" href="classLaspackVector.php#a5c7dd6354c8e0f43463ffcc737ac1165">00538</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#a570063b71e840b15da36283480d16023">LaspackVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00539"></a>00539                              <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00540"></a>00540                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00541"></a>00541 {
<a name="l00542"></a>00542   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(n,n,fast,type);
<a name="l00543"></a>00543 }
<a name="l00544"></a>00544 
<a name="l00545"></a>00545 
<a name="l00546"></a>00546 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00547"></a>00547 <span class="keyword">inline</span>
<a name="l00548"></a><a class="code" href="classLaspackVector.php#a88b3bf16c5d967edad7cd0558738ee91">00548</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#a570063b71e840b15da36283480d16023">LaspackVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00549"></a>00549                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00550"></a>00550                              <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ghost,
<a name="l00551"></a>00551                              <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00552"></a>00552                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00553"></a>00553 {
<a name="l00554"></a>00554   libmesh_assert(ghost.empty());
<a name="l00555"></a>00555   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(n,n_local,fast,type);
<a name="l00556"></a>00556 }
<a name="l00557"></a>00557 
<a name="l00558"></a>00558 
<a name="l00559"></a>00559 
<a name="l00560"></a>00560 <span class="comment">/* Default implementation for solver packages for which ghosted</span>
<a name="l00561"></a>00561 <span class="comment">   vectors are not yet implemented.  */</span>
<a name="l00562"></a>00562 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00563"></a><a class="code" href="classLaspackVector.php#ad2db0529761b01df8eed1eacfca2a8e9">00563</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#a570063b71e840b15da36283480d16023">LaspackVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; other,
<a name="l00564"></a>00564                              <span class="keyword">const</span> <span class="keywordtype">bool</span> fast)
<a name="l00565"></a>00565 {
<a name="l00566"></a>00566   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(other.<a class="code" href="classNumericVector.php#ae21bc89e89e895ac26b851a31926e194">size</a>(),other.<a class="code" href="classNumericVector.php#a400307e324862d460ff6b3b83a72e867">local_size</a>(),fast,other.<a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a>());
<a name="l00567"></a>00567 }
<a name="l00568"></a>00568 
<a name="l00569"></a>00569 
<a name="l00570"></a>00570 
<a name="l00571"></a>00571 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00572"></a>00572 <span class="keyword">inline</span>
<a name="l00573"></a><a class="code" href="classLaspackVector.php#ad96e22aa017ab21646815f16edd8d7a9">00573</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#ad96e22aa017ab21646815f16edd8d7a9">LaspackVector&lt;T&gt;::close</a> ()
<a name="l00574"></a>00574 {
<a name="l00575"></a>00575   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00576"></a>00576   
<a name="l00577"></a>00577   this-&gt;_is_closed = <span class="keyword">true</span>;
<a name="l00578"></a>00578 }
<a name="l00579"></a>00579 
<a name="l00580"></a>00580 
<a name="l00581"></a>00581 
<a name="l00582"></a>00582 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00583"></a>00583 <span class="keyword">inline</span>
<a name="l00584"></a><a class="code" href="classLaspackVector.php#a107340c317ee3d11488e6f2017c119ef">00584</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#a107340c317ee3d11488e6f2017c119ef">LaspackVector&lt;T&gt;::clear</a> ()
<a name="l00585"></a>00585 {
<a name="l00586"></a>00586   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00587"></a>00587     {
<a name="l00588"></a>00588       V_Destr (&amp;_vec);
<a name="l00589"></a>00589     }
<a name="l00590"></a>00590 
<a name="l00591"></a>00591   this-&gt;_is_closed = this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00592"></a>00592 }
<a name="l00593"></a>00593 
<a name="l00594"></a>00594 
<a name="l00595"></a>00595 
<a name="l00596"></a>00596 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">inline</span>
<a name="l00597"></a><a class="code" href="classLaspackVector.php#aec4911b8dc8d4c773eff4646aa727896">00597</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#aec4911b8dc8d4c773eff4646aa727896">LaspackVector&lt;T&gt;::zero</a> ()
<a name="l00598"></a>00598 {
<a name="l00599"></a>00599   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00600"></a>00600 
<a name="l00601"></a>00601   V_SetAllCmp (&amp;_vec, 0.);
<a name="l00602"></a>00602 }
<a name="l00603"></a>00603 
<a name="l00604"></a>00604 
<a name="l00605"></a>00605 
<a name="l00606"></a>00606 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00607"></a>00607 <span class="keyword">inline</span>
<a name="l00608"></a><a class="code" href="classLaspackVector.php#ae613025c75a6e468c95873a69a0594de">00608</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classLaspackVector.php#ae613025c75a6e468c95873a69a0594de">LaspackVector&lt;T&gt;::clone</a> ()<span class="keyword"> const</span>
<a name="l00609"></a>00609 <span class="keyword"></span>{
<a name="l00610"></a>00610   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; cloned_vector (<span class="keyword">new</span> <a class="code" href="classLaspackVector.php">LaspackVector&lt;T&gt;</a>);
<a name="l00611"></a>00611 
<a name="l00612"></a>00612   cloned_vector-&gt;init(*<span class="keyword">this</span>, <span class="keyword">true</span>);
<a name="l00613"></a>00613 
<a name="l00614"></a>00614   *cloned_vector = *<span class="keyword">this</span>;
<a name="l00615"></a>00615 
<a name="l00616"></a>00616   <span class="keywordflow">return</span> cloned_vector;
<a name="l00617"></a>00617 }
<a name="l00618"></a>00618 
<a name="l00619"></a>00619 
<a name="l00620"></a>00620 
<a name="l00621"></a>00621 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00622"></a>00622 <span class="keyword">inline</span>
<a name="l00623"></a><a class="code" href="classLaspackVector.php#a9acfef7d3f7d5f82014016605bfd42b3">00623</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classLaspackVector.php#a9acfef7d3f7d5f82014016605bfd42b3">LaspackVector&lt;T&gt;::size</a> ()<span class="keyword"> const</span>
<a name="l00624"></a>00624 <span class="keyword"></span>{
<a name="l00625"></a>00625   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00626"></a>00626 
<a name="l00627"></a>00627   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(V_GetDim(const_cast&lt;QVector*&gt;(&amp;_vec)));
<a name="l00628"></a>00628 }
<a name="l00629"></a>00629 
<a name="l00630"></a>00630 
<a name="l00631"></a>00631 
<a name="l00632"></a>00632 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00633"></a>00633 <span class="keyword">inline</span>
<a name="l00634"></a><a class="code" href="classLaspackVector.php#a76814258fbdaf7f1a92ae513b086e9b7">00634</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classLaspackVector.php#a76814258fbdaf7f1a92ae513b086e9b7">LaspackVector&lt;T&gt;::local_size</a> ()<span class="keyword"> const</span>
<a name="l00635"></a>00635 <span class="keyword"></span>{
<a name="l00636"></a>00636   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00637"></a>00637   
<a name="l00638"></a>00638   <span class="keywordflow">return</span> this-&gt;size();
<a name="l00639"></a>00639 }
<a name="l00640"></a>00640 
<a name="l00641"></a>00641 
<a name="l00642"></a>00642 
<a name="l00643"></a>00643 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00644"></a>00644 <span class="keyword">inline</span>
<a name="l00645"></a><a class="code" href="classLaspackVector.php#a8de4a6c30b3e9bd37c1ee49dae6df47d">00645</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classLaspackVector.php#a8de4a6c30b3e9bd37c1ee49dae6df47d">LaspackVector&lt;T&gt;::first_local_index</a> ()<span class="keyword"> const</span>
<a name="l00646"></a>00646 <span class="keyword"></span>{
<a name="l00647"></a>00647   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00648"></a>00648   
<a name="l00649"></a>00649   <span class="keywordflow">return</span> 0;
<a name="l00650"></a>00650 }
<a name="l00651"></a>00651 
<a name="l00652"></a>00652 
<a name="l00653"></a>00653 
<a name="l00654"></a>00654 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00655"></a>00655 <span class="keyword">inline</span>
<a name="l00656"></a><a class="code" href="classLaspackVector.php#acbe44b89d6d21384ed5ba847784885eb">00656</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classLaspackVector.php#acbe44b89d6d21384ed5ba847784885eb">LaspackVector&lt;T&gt;::last_local_index</a> ()<span class="keyword"> const</span>
<a name="l00657"></a>00657 <span class="keyword"></span>{
<a name="l00658"></a>00658   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00659"></a>00659   
<a name="l00660"></a>00660   <span class="keywordflow">return</span> this-&gt;size();
<a name="l00661"></a>00661 }
<a name="l00662"></a>00662 
<a name="l00663"></a>00663 
<a name="l00664"></a>00664 
<a name="l00665"></a>00665 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00666"></a>00666 <span class="keyword">inline</span>
<a name="l00667"></a><a class="code" href="classLaspackVector.php#ad655f8b215cc89d5860c1e85825902b1">00667</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#ad655f8b215cc89d5860c1e85825902b1">LaspackVector&lt;T&gt;::set</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value)
<a name="l00668"></a>00668 {
<a name="l00669"></a>00669   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00670"></a>00670   libmesh_assert (i &lt; this-&gt;size());
<a name="l00671"></a>00671   
<a name="l00672"></a>00672   V_SetCmp (&amp;_vec, i+1, value);
<a name="l00673"></a>00673 }
<a name="l00674"></a>00674 
<a name="l00675"></a>00675 
<a name="l00676"></a>00676 
<a name="l00677"></a>00677 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00678"></a>00678 <span class="keyword">inline</span>
<a name="l00679"></a><a class="code" href="classLaspackVector.php#a94d61c428f9c5890c8086f896c5575c2">00679</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#a94d61c428f9c5890c8086f896c5575c2">LaspackVector&lt;T&gt;::add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value)
<a name="l00680"></a>00680 {
<a name="l00681"></a>00681   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00682"></a>00682   libmesh_assert (i &lt; this-&gt;size());
<a name="l00683"></a>00683   
<a name="l00684"></a>00684   V_AddCmp (&amp;_vec, i+1, value);
<a name="l00685"></a>00685 }
<a name="l00686"></a>00686 
<a name="l00687"></a>00687 
<a name="l00688"></a>00688 
<a name="l00689"></a>00689 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00690"></a>00690 <span class="keyword">inline</span>
<a name="l00691"></a><a class="code" href="classLaspackVector.php#afe77da9f86ab05a53476e623a8815542">00691</a> T <a class="code" href="classLaspackVector.php#afe77da9f86ab05a53476e623a8815542">LaspackVector&lt;T&gt;::operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00692"></a>00692 <span class="keyword"></span>{
<a name="l00693"></a>00693   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00694"></a>00694   libmesh_assert ( ((i &gt;= this-&gt;first_local_index()) &amp;&amp;
<a name="l00695"></a>00695             (i &lt;  this-&gt;last_local_index())) );
<a name="l00696"></a>00696 
<a name="l00697"></a>00697   
<a name="l00698"></a>00698   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span>T<span class="keyword">&gt;</span>(V_GetCmp(const_cast&lt;QVector*&gt;(&amp;_vec), i+1));
<a name="l00699"></a>00699 }
<a name="l00700"></a>00700 
<a name="l00701"></a>00701 
<a name="l00702"></a>00702 
<a name="l00703"></a>00703 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00704"></a>00704 <span class="keyword">inline</span>
<a name="l00705"></a><a class="code" href="classLaspackVector.php#aaf90235417c324ee6537e876013c3c08">00705</a> <span class="keywordtype">void</span> <a class="code" href="classLaspackVector.php#aaf90235417c324ee6537e876013c3c08">LaspackVector&lt;T&gt;::swap</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;other)
<a name="l00706"></a>00706 {
<a name="l00707"></a>00707   <a class="code" href="classLaspackVector.php">LaspackVector&lt;T&gt;</a>&amp; v = libmesh_cast_ref&lt;LaspackVector&lt;T&gt;&amp;&gt;(other);
<a name="l00708"></a>00708 
<a name="l00709"></a>00709   <span class="comment">// This is all grossly dependent on Laspack version...</span>
<a name="l00710"></a>00710 
<a name="l00711"></a>00711   std::swap(_vec.Name, v.<a class="code" href="classLaspackVector.php#aa76ff61c00c3dccf194399ecaf64d5da">_vec</a>.Name);
<a name="l00712"></a>00712   std::swap(_vec.Dim, v.<a class="code" href="classLaspackVector.php#aa76ff61c00c3dccf194399ecaf64d5da">_vec</a>.Dim);
<a name="l00713"></a>00713   std::swap(_vec.Instance, v.<a class="code" href="classLaspackVector.php#aa76ff61c00c3dccf194399ecaf64d5da">_vec</a>.Instance);
<a name="l00714"></a>00714   std::swap(_vec.LockLevel, v.<a class="code" href="classLaspackVector.php#aa76ff61c00c3dccf194399ecaf64d5da">_vec</a>.LockLevel);
<a name="l00715"></a>00715   std::swap(_vec.Multipl, v.<a class="code" href="classLaspackVector.php#aa76ff61c00c3dccf194399ecaf64d5da">_vec</a>.Multipl);
<a name="l00716"></a>00716   std::swap(_vec.OwnData, v.<a class="code" href="classLaspackVector.php#aa76ff61c00c3dccf194399ecaf64d5da">_vec</a>.OwnData);
<a name="l00717"></a>00717 
<a name="l00718"></a>00718   <span class="comment">// This should still be O(1), since _vec.Cmp is just a pointer to</span>
<a name="l00719"></a>00719   <span class="comment">// data on the heap</span>
<a name="l00720"></a>00720 
<a name="l00721"></a>00721   std::swap(_vec.Cmp, v.<a class="code" href="classLaspackVector.php#aa76ff61c00c3dccf194399ecaf64d5da">_vec</a>.Cmp);
<a name="l00722"></a>00722 }
<a name="l00723"></a>00723 
<a name="l00724"></a>00724 
<a name="l00725"></a>00725 
<a name="l00726"></a>00726 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_LASPACK</span>
<a name="l00727"></a>00727 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __laspack_vector_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
