<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>legacy_xdr_io.C</h1>  </div>
</div>
<div class="contents">
<a href="legacy__xdr__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: legacy_xdr_io.C 3502 2009-10-20 18:06:50Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;iostream&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;iomanip&gt;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;legacy_xdr_io.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;mesh_data.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;mesh_tools.h&quot;</span> <span class="comment">// MeshTools::n_levels(mesh)</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;parallel.h&quot;</span>   <span class="comment">// - which makes write parallel-only</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;cell_hex27.h&quot;</span> <span class="comment">// Needed for MGF-style Hex27 meshes</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;boundary_info.h&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;xdr_mgf.h&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;xdr_mesh.h&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;xdr_mhead.h&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;xdr_soln.h&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &quot;xdr_shead.h&quot;</span>
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span><span class="preprocessor">#include &quot;utility.h&quot;</span>
<a name="l00046"></a>00046 <span class="preprocessor">#endif</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span>
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00055"></a>00055 <span class="comment">// LegacyXdrIO members</span>
<a name="l00056"></a><a class="code" href="classLegacyXdrIO.php#a043f44decaacbdde9faed65875a38715">00056</a> <a class="code" href="classLegacyXdrIO.php#a043f44decaacbdde9faed65875a38715">LegacyXdrIO::LegacyXdrIO</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh, <span class="keyword">const</span> <span class="keywordtype">bool</span> binary) :
<a name="l00057"></a>00057   <a class="code" href="classMeshInput.php">MeshInput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt; (mesh),
<a name="l00058"></a>00058   <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt;(mesh),
<a name="l00059"></a>00059   _binary (binary)
<a name="l00060"></a>00060 {
<a name="l00061"></a>00061 }
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 
<a name="l00066"></a><a class="code" href="classLegacyXdrIO.php#a13db1205c974a649e396a10f1abdd48a">00066</a> <a class="code" href="classLegacyXdrIO.php#a043f44decaacbdde9faed65875a38715">LegacyXdrIO::LegacyXdrIO</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh, <span class="keyword">const</span> <span class="keywordtype">bool</span> binary) :
<a name="l00067"></a>00067   <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt;(mesh),
<a name="l00068"></a>00068   _binary (binary)
<a name="l00069"></a>00069 {
<a name="l00070"></a>00070 }
<a name="l00071"></a>00071 
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 
<a name="l00075"></a><a class="code" href="classLegacyXdrIO.php#a4d1b3629253a77a11f161a80c1751210">00075</a> <a class="code" href="classLegacyXdrIO.php#a4d1b3629253a77a11f161a80c1751210">LegacyXdrIO::~LegacyXdrIO</a> ()
<a name="l00076"></a>00076 {
<a name="l00077"></a>00077 }
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a><a class="code" href="classLegacyXdrIO.php#ad4900c83e2a153a89012e9b27dda1d22">00082</a> <span class="keywordtype">bool</span> &amp; <a class="code" href="classLegacyXdrIO.php#ad4900c83e2a153a89012e9b27dda1d22">LegacyXdrIO::binary</a> ()
<a name="l00083"></a>00083 {
<a name="l00084"></a>00084   <span class="keywordflow">return</span> <a class="code" href="classLegacyXdrIO.php#a96cf29161be5981211481dbf22977cbb">_binary</a>;
<a name="l00085"></a>00085 }
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 
<a name="l00090"></a><a class="code" href="classLegacyXdrIO.php#a481771950fce10c0f2516b22e8f9d7f3">00090</a> <span class="keywordtype">bool</span> <a class="code" href="classLegacyXdrIO.php#ad4900c83e2a153a89012e9b27dda1d22">LegacyXdrIO::binary</a> ()<span class="keyword"> const</span>
<a name="l00091"></a>00091 <span class="keyword"></span>{
<a name="l00092"></a>00092   <span class="keywordflow">return</span> <a class="code" href="classLegacyXdrIO.php#a96cf29161be5981211481dbf22977cbb">_binary</a>;
<a name="l00093"></a>00093 }
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a><a class="code" href="classLegacyXdrIO.php#aafa2ae95dcc72c51d3aad725db09cb73">00097</a> <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#aafa2ae95dcc72c51d3aad725db09cb73">LegacyXdrIO::read</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00098"></a>00098 {
<a name="l00099"></a>00099   <span class="comment">// This is a serial-only process for now;</span>
<a name="l00100"></a>00100   <span class="comment">// the Mesh should be read on processor 0 and</span>
<a name="l00101"></a>00101   <span class="comment">// broadcast later</span>
<a name="l00102"></a>00102   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l00103"></a>00103     <span class="keywordflow">return</span>;
<a name="l00104"></a>00104   
<a name="l00105"></a>00105   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classLegacyXdrIO.php#ad4900c83e2a153a89012e9b27dda1d22">binary</a>())
<a name="l00106"></a>00106     this-&gt;<a class="code" href="classLegacyXdrIO.php#a45ed48aaa6877ef96569c8916a328803">read_binary</a> (name);
<a name="l00107"></a>00107   <span class="keywordflow">else</span>
<a name="l00108"></a>00108     this-&gt;<a class="code" href="classLegacyXdrIO.php#a423f2d95e163542f48cdc8db4dca4aff">read_ascii</a>  (name);
<a name="l00109"></a>00109 }
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 
<a name="l00113"></a><a class="code" href="classLegacyXdrIO.php#ac4fde91354bab98a9a551c029ce51e0d">00113</a> <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#ac4fde91354bab98a9a551c029ce51e0d">LegacyXdrIO::read_mgf</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00114"></a>00114 {
<a name="l00115"></a>00115   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classLegacyXdrIO.php#ad4900c83e2a153a89012e9b27dda1d22">binary</a>())
<a name="l00116"></a>00116     this-&gt;<a class="code" href="classLegacyXdrIO.php#a45ed48aaa6877ef96569c8916a328803">read_binary</a> (name, <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a96a3fe5321ff4768538d2481be42354d">LegacyXdrIO::MGF</a>);
<a name="l00117"></a>00117   <span class="keywordflow">else</span>
<a name="l00118"></a>00118     this-&gt;<a class="code" href="classLegacyXdrIO.php#a423f2d95e163542f48cdc8db4dca4aff">read_ascii</a>  (name, <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a96a3fe5321ff4768538d2481be42354d">LegacyXdrIO::MGF</a>);
<a name="l00119"></a>00119 }
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a><a class="code" href="classLegacyXdrIO.php#a49f322f1ff1b7d8a1051b474d23d0cbf">00123</a> <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#a49f322f1ff1b7d8a1051b474d23d0cbf">LegacyXdrIO::write</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00124"></a>00124 {
<a name="l00125"></a>00125     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classLegacyXdrIO.php#ad4900c83e2a153a89012e9b27dda1d22">binary</a>())
<a name="l00126"></a>00126       this-&gt;<a class="code" href="classLegacyXdrIO.php#aaf353eb0f0fcddf5da48a382f6610eed">write_binary</a> (name);
<a name="l00127"></a>00127     <span class="keywordflow">else</span>
<a name="l00128"></a>00128       this-&gt;<a class="code" href="classLegacyXdrIO.php#a872c22bba97f17d7db31580645e88617">write_ascii</a>  (name);
<a name="l00129"></a>00129 }
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00133"></a><a class="code" href="classLegacyXdrIO.php#ab5369cabc6b2cc585e679efb89fad931">00133</a> <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#ab5369cabc6b2cc585e679efb89fad931">LegacyXdrIO::write_mgf</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00134"></a>00134 {
<a name="l00135"></a>00135   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classLegacyXdrIO.php#ad4900c83e2a153a89012e9b27dda1d22">binary</a>())
<a name="l00136"></a>00136     this-&gt;<a class="code" href="classLegacyXdrIO.php#aaf353eb0f0fcddf5da48a382f6610eed">write_binary</a> (name, <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a96a3fe5321ff4768538d2481be42354d">LegacyXdrIO::MGF</a>);
<a name="l00137"></a>00137   <span class="keywordflow">else</span>
<a name="l00138"></a>00138     this-&gt;<a class="code" href="classLegacyXdrIO.php#a872c22bba97f17d7db31580645e88617">write_ascii</a>  (name, <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a96a3fe5321ff4768538d2481be42354d">LegacyXdrIO::MGF</a>);
<a name="l00139"></a>00139 }
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a><a class="code" href="classLegacyXdrIO.php#ab3eb0210e8a678c833025db13d1c1a96">00143</a> <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#ab3eb0210e8a678c833025db13d1c1a96">LegacyXdrIO::read_mgf_soln</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00144"></a>00144                                  std::vector&lt;Number&gt;&amp; soln,
<a name="l00145"></a>00145                                  std::vector&lt;std::string&gt;&amp; var_names)<span class="keyword"> const</span>
<a name="l00146"></a>00146 <span class="keyword"></span>{
<a name="l00147"></a>00147   libmesh_deprecated();
<a name="l00148"></a>00148   
<a name="l00149"></a>00149 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00150"></a>00150 <span class="preprocessor"></span>  
<a name="l00151"></a>00151   <span class="comment">// buffer for writing separately</span>
<a name="l00152"></a>00152   std::vector&lt;Real&gt; real_soln;
<a name="l00153"></a>00153   std::vector&lt;Real&gt; imag_soln;
<a name="l00154"></a>00154   
<a name="l00155"></a>00155   <a class="code" href="namespaceUtility.php#ab91b2ad61e7d474fd28ca7e29e394a61">Utility::prepare_complex_data</a> (soln, real_soln, imag_soln);
<a name="l00156"></a>00156 
<a name="l00157"></a>00157   this-&gt;<a class="code" href="classLegacyXdrIO.php#af8d29b7846f20381429c9a21acdceb0d">read_soln</a> (<a class="code" href="namespaceUtility.php#a45028c8d57f427908f52bc792734bd9e">Utility::complex_filename</a>(name, 0), 
<a name="l00158"></a>00158                    real_soln, 
<a name="l00159"></a>00159                    var_names);
<a name="l00160"></a>00160   
<a name="l00161"></a>00161   this-&gt;<a class="code" href="classLegacyXdrIO.php#af8d29b7846f20381429c9a21acdceb0d">read_soln</a> (<a class="code" href="namespaceUtility.php#a45028c8d57f427908f52bc792734bd9e">Utility::complex_filename</a>(name, 1), 
<a name="l00162"></a>00162                    imag_soln, 
<a name="l00163"></a>00163                    var_names);
<a name="l00164"></a>00164   
<a name="l00165"></a>00165 <span class="preprocessor">#else</span>
<a name="l00166"></a>00166 <span class="preprocessor"></span>  
<a name="l00167"></a>00167   this-&gt;<a class="code" href="classLegacyXdrIO.php#af8d29b7846f20381429c9a21acdceb0d">read_soln</a> (name, soln, var_names);
<a name="l00168"></a>00168       
<a name="l00169"></a>00169 <span class="preprocessor">#endif</span>
<a name="l00170"></a>00170 <span class="preprocessor"></span>}
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 
<a name="l00174"></a><a class="code" href="classLegacyXdrIO.php#a0cf218a0c650c782f061d07941b48518">00174</a> <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#a0cf218a0c650c782f061d07941b48518">LegacyXdrIO::write_mgf_soln</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00175"></a>00175                                   std::vector&lt;Number&gt;&amp; soln,
<a name="l00176"></a>00176                                   std::vector&lt;std::string&gt;&amp; var_names)<span class="keyword"> const</span>
<a name="l00177"></a>00177 <span class="keyword"></span>{
<a name="l00178"></a>00178   libmesh_deprecated();
<a name="l00179"></a>00179   
<a name="l00180"></a>00180 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00181"></a>00181 <span class="preprocessor"></span>  
<a name="l00182"></a>00182   <span class="comment">// buffer for writing separately</span>
<a name="l00183"></a>00183   std::vector&lt;Real&gt; real_soln;
<a name="l00184"></a>00184   std::vector&lt;Real&gt; imag_soln;
<a name="l00185"></a>00185   
<a name="l00186"></a>00186   <a class="code" href="namespaceUtility.php#ab91b2ad61e7d474fd28ca7e29e394a61">Utility::prepare_complex_data</a> (soln, real_soln, imag_soln);
<a name="l00187"></a>00187   
<a name="l00188"></a>00188   this-&gt;<a class="code" href="classLegacyXdrIO.php#ad26b8b18265f7ee9f50e214e157ee560">write_soln</a> (<a class="code" href="namespaceUtility.php#a45028c8d57f427908f52bc792734bd9e">Utility::complex_filename</a>(name, 0), 
<a name="l00189"></a>00189                     real_soln, 
<a name="l00190"></a>00190                     var_names);
<a name="l00191"></a>00191   
<a name="l00192"></a>00192   this-&gt;<a class="code" href="classLegacyXdrIO.php#ad26b8b18265f7ee9f50e214e157ee560">write_soln</a> (<a class="code" href="namespaceUtility.php#a45028c8d57f427908f52bc792734bd9e">Utility::complex_filename</a>(name, 1), 
<a name="l00193"></a>00193                     imag_soln, 
<a name="l00194"></a>00194                     var_names);
<a name="l00195"></a>00195   
<a name="l00196"></a>00196 <span class="preprocessor">#else</span>
<a name="l00197"></a>00197 <span class="preprocessor"></span>  
<a name="l00198"></a>00198   this-&gt;<a class="code" href="classLegacyXdrIO.php#ad26b8b18265f7ee9f50e214e157ee560">write_soln</a> (name, soln, var_names);
<a name="l00199"></a>00199       
<a name="l00200"></a>00200 <span class="preprocessor">#endif</span>
<a name="l00201"></a>00201 <span class="preprocessor"></span>}
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 
<a name="l00205"></a><a class="code" href="classLegacyXdrIO.php#a423f2d95e163542f48cdc8db4dca4aff">00205</a> <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#a423f2d95e163542f48cdc8db4dca4aff">LegacyXdrIO::read_ascii</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>, <span class="keyword">const</span> <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74">LegacyXdrIO::FileFormat</a> originator)
<a name="l00206"></a>00206 {
<a name="l00207"></a>00207   <span class="comment">// get a writeable reference to the underlying mesh</span>
<a name="l00208"></a>00208   <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00209"></a>00209   
<a name="l00210"></a>00210   <span class="comment">// clear any existing mesh data</span>
<a name="l00211"></a>00211   mesh.<a class="code" href="classMeshBase.php#aefd56c4c29285d5e845f8869112b2b67">clear</a>();
<a name="l00212"></a>00212     
<a name="l00213"></a>00213   <span class="comment">// read the mesh</span>
<a name="l00214"></a>00214   this-&gt;<a class="code" href="classLegacyXdrIO.php#a0c89c01f05c74d6d887450ebcac8fb1a">read_mesh</a> (name, originator);
<a name="l00215"></a>00215 }
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 
<a name="l00219"></a><a class="code" href="classLegacyXdrIO.php#a45ed48aaa6877ef96569c8916a328803">00219</a> <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#a45ed48aaa6877ef96569c8916a328803">LegacyXdrIO::read_binary</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>, <span class="keyword">const</span> <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74">LegacyXdrIO::FileFormat</a> originator)
<a name="l00220"></a>00220 {
<a name="l00221"></a>00221 <span class="preprocessor">#ifndef LIBMESH_HAVE_XDR</span>
<a name="l00222"></a>00222 <span class="preprocessor"></span>
<a name="l00223"></a>00223   std::cerr &lt;&lt; <span class="stringliteral">&quot;WARNING: Compiled without XDR binary support.\n&quot;</span>
<a name="l00224"></a>00224             &lt;&lt; <span class="stringliteral">&quot;Will try ASCII instead&quot;</span> &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l00225"></a>00225 
<a name="l00226"></a>00226   this-&gt;<a class="code" href="classLegacyXdrIO.php#a423f2d95e163542f48cdc8db4dca4aff">read_ascii</a> (name);
<a name="l00227"></a>00227   
<a name="l00228"></a>00228 <span class="preprocessor">#else</span>
<a name="l00229"></a>00229 <span class="preprocessor"></span>  
<a name="l00230"></a>00230   <span class="comment">// get a writeable reference to the underlying mesh</span>
<a name="l00231"></a>00231   <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00232"></a>00232   
<a name="l00233"></a>00233   <span class="comment">// clear any existing mesh data</span>
<a name="l00234"></a>00234   mesh.<a class="code" href="classMeshBase.php#aefd56c4c29285d5e845f8869112b2b67">clear</a>();
<a name="l00235"></a>00235 
<a name="l00236"></a>00236   <span class="comment">// read the mesh</span>
<a name="l00237"></a>00237   this-&gt;<a class="code" href="classLegacyXdrIO.php#a0c89c01f05c74d6d887450ebcac8fb1a">read_mesh</a> (name, originator);
<a name="l00238"></a>00238   
<a name="l00239"></a>00239 <span class="preprocessor">#endif</span>
<a name="l00240"></a>00240 <span class="preprocessor"></span>}
<a name="l00241"></a>00241 
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 
<a name="l00244"></a><a class="code" href="classLegacyXdrIO.php#a872c22bba97f17d7db31580645e88617">00244</a> <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#a872c22bba97f17d7db31580645e88617">LegacyXdrIO::write_ascii</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>, <span class="keyword">const</span> <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74">LegacyXdrIO::FileFormat</a> originator)
<a name="l00245"></a>00245 {
<a name="l00246"></a>00246   this-&gt;<a class="code" href="classLegacyXdrIO.php#a92c47baf2df593f9aa21b33f8d5f7913">write_mesh</a> (name, originator);
<a name="l00247"></a>00247 }
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 
<a name="l00250"></a>00250 
<a name="l00251"></a><a class="code" href="classLegacyXdrIO.php#aaf353eb0f0fcddf5da48a382f6610eed">00251</a> <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#aaf353eb0f0fcddf5da48a382f6610eed">LegacyXdrIO::write_binary</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>, <span class="keyword">const</span> <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74">LegacyXdrIO::FileFormat</a> originator)
<a name="l00252"></a>00252 {
<a name="l00253"></a>00253 <span class="preprocessor">#ifndef LIBMESH_HAVE_XDR</span>
<a name="l00254"></a>00254 <span class="preprocessor"></span>
<a name="l00255"></a>00255   std::cerr &lt;&lt; <span class="stringliteral">&quot;WARNING: Compiled without XDR binary support.\n&quot;</span>
<a name="l00256"></a>00256             &lt;&lt; <span class="stringliteral">&quot;Will try ASCII instead&quot;</span> &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l00257"></a>00257 
<a name="l00258"></a>00258   this-&gt;<a class="code" href="classLegacyXdrIO.php#a872c22bba97f17d7db31580645e88617">write_ascii</a> (name);
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 <span class="preprocessor">#else</span>
<a name="l00261"></a>00261 <span class="preprocessor"></span>  
<a name="l00262"></a>00262   this-&gt;<a class="code" href="classLegacyXdrIO.php#a92c47baf2df593f9aa21b33f8d5f7913">write_mesh</a> (name, originator);  
<a name="l00263"></a>00263   
<a name="l00264"></a>00264 <span class="preprocessor">#endif</span>
<a name="l00265"></a>00265 <span class="preprocessor"></span>}
<a name="l00266"></a>00266 
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 
<a name="l00269"></a><a class="code" href="classLegacyXdrIO.php#a0c89c01f05c74d6d887450ebcac8fb1a">00269</a> <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#a0c89c01f05c74d6d887450ebcac8fb1a">LegacyXdrIO::read_mesh</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00270"></a>00270                              <span class="keyword">const</span> <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74">LegacyXdrIO::FileFormat</a> originator,
<a name="l00271"></a>00271                              <a class="code" href="classMeshData.php">MeshData</a>* mesh_data)
<a name="l00272"></a>00272 {
<a name="l00273"></a>00273   <span class="comment">// This is a serial-only process for now;</span>
<a name="l00274"></a>00274   <span class="comment">// the Mesh should be read on processor 0 and</span>
<a name="l00275"></a>00275   <span class="comment">// broadcast later</span>
<a name="l00276"></a>00276   libmesh_assert(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0);
<a name="l00277"></a>00277 
<a name="l00278"></a>00278   <span class="comment">// get a writeable reference to the mesh</span>
<a name="l00279"></a>00279   <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00280"></a>00280 
<a name="l00281"></a>00281   <span class="comment">// clear any data in the mesh</span>
<a name="l00282"></a>00282   mesh.<a class="code" href="classMeshBase.php#aefd56c4c29285d5e845f8869112b2b67">clear</a>();
<a name="l00283"></a>00283   
<a name="l00284"></a>00284   <span class="comment">// Create an XdrMESH object.</span>
<a name="l00285"></a>00285   <a class="code" href="classXdrMESH.php">XdrMESH</a> m;
<a name="l00286"></a>00286 
<a name="l00287"></a>00287   <span class="comment">// Create a pointer</span>
<a name="l00288"></a>00288   <span class="comment">// to an XdrMESH file</span>
<a name="l00289"></a>00289   <span class="comment">// header.</span>
<a name="l00290"></a>00290   <a class="code" href="classXdrMHEAD.php">XdrMHEAD</a> mh;
<a name="l00291"></a>00291 
<a name="l00292"></a>00292   <span class="comment">// Open the XDR file for reading.</span>
<a name="l00293"></a>00293   <span class="comment">// Note 1: Provide an additional argument</span>
<a name="l00294"></a>00294   <span class="comment">// to specify the dimension.</span>
<a name="l00295"></a>00295   <span class="comment">//</span>
<a name="l00296"></a>00296   <span class="comment">// Note 2: Has to do the right thing for</span>
<a name="l00297"></a>00297   <span class="comment">// both binary and ASCII files.</span>
<a name="l00298"></a>00298   m.<a class="code" href="classXdrMGF.php#a429208021d453abbe95b4d019b92552b">set_orig_flag</a>(originator);
<a name="l00299"></a>00299   m.<a class="code" href="classXdrMESH.php#a1514a001c5b72800ef965c8a9a6e34ab">init</a>((this-&gt;<a class="code" href="classLegacyXdrIO.php#ad4900c83e2a153a89012e9b27dda1d22">binary</a>() ? <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a2e25ec755026e9cc0d07a2773e908d1a">XdrMGF::DECODE</a> : <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759adec8f583f9a4a6a6d97dfb07f2f8ccd0">XdrMGF::R_ASCII</a>), name.c_str(), 0); <span class="comment">// mesh files are always number 0 ...</span>
<a name="l00300"></a>00300 
<a name="l00301"></a>00301   <span class="comment">// From here on, things depend</span>
<a name="l00302"></a>00302   <span class="comment">// on whether we are reading or</span>
<a name="l00303"></a>00303   <span class="comment">// writing!  First, we define</span>
<a name="l00304"></a>00304   <span class="comment">// header variables that may</span>
<a name="l00305"></a>00305   <span class="comment">// be read OR written.</span>
<a name="l00306"></a>00306   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>              n_blocks = 0;
<a name="l00307"></a>00307   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>              <a class="code" href="namespaceMeshTools.php#a467cd3c96ff9a03c0918d4df6ef16301">n_levels</a> = 0;
<a name="l00308"></a>00308   
<a name="l00309"></a>00309   <span class="keywordflow">if</span> (m.<a class="code" href="classXdrMGF.php#a38c46d070b70b3cdcf00c42ffff9b0c8">get_orig_flag</a>() == <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a866ae5a0308e85514de1abd617c8eb78">LegacyXdrIO::LIBM</a>)
<a name="l00310"></a>00310     n_levels = m.<a class="code" href="classXdrMGF.php#aa53260d28bcccb931637d572d0f063ea">get_num_levels</a>();
<a name="l00311"></a>00311   
<a name="l00312"></a>00312   
<a name="l00313"></a>00313   std::vector&lt;ElemType&gt;     etypes;
<a name="l00314"></a>00314   std::vector&lt;unsigned int&gt; neeb;
<a name="l00315"></a>00315         
<a name="l00316"></a>00316   <span class="comment">// Get the information from</span>
<a name="l00317"></a>00317   <span class="comment">// the header, and place it</span>
<a name="l00318"></a>00318   <span class="comment">// in the header pointer.</span>
<a name="l00319"></a>00319   m.<a class="code" href="classXdrMESH.php#a56ffaabfcfe3ca998154f3a2f5585f52">header</a>(&amp;mh);
<a name="l00320"></a>00320         
<a name="l00321"></a>00321   <span class="comment">// Read information from the</span>
<a name="l00322"></a>00322   <span class="comment">// file header.  This depends on</span>
<a name="l00323"></a>00323   <span class="comment">// whether its a libMesh or MGF mesh.</span>
<a name="l00324"></a>00324   <span class="keyword">const</span> <span class="keywordtype">int</span> numElem     = mh.<a class="code" href="classXdrMHEAD.php#ac422b8ab01815a399ab0e868036f298a">getNumEl</a>();
<a name="l00325"></a>00325   <span class="keyword">const</span> <span class="keywordtype">int</span> numNodes    = mh.<a class="code" href="classXdrHEAD.php#a2aa8f41b3f519596a0b5755aceb5956a">getNumNodes</a>();
<a name="l00326"></a>00326   <span class="keyword">const</span> <span class="keywordtype">int</span> totalWeight = mh.<a class="code" href="classXdrMHEAD.php#a7e5a99aee69c2d5356ce187f515784f8">getSumWghts</a>();
<a name="l00327"></a>00327   <span class="keyword">const</span> <span class="keywordtype">int</span> numBCs      = mh.<a class="code" href="classXdrHEAD.php#a6fb33c2762528f301d785e0bd5d0ea45">getNumBCs</a>();
<a name="l00328"></a>00328   
<a name="l00329"></a>00329   <span class="comment">// If a libMesh-type mesh, read the augmented mesh information</span>
<a name="l00330"></a>00330   <span class="keywordflow">if</span> ((m.<a class="code" href="classXdrMGF.php#a38c46d070b70b3cdcf00c42ffff9b0c8">get_orig_flag</a>() == <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74acbf9879c924b6167238ec2dfbfbc861a">LegacyXdrIO::DEAL</a>) || (m.<a class="code" href="classXdrMGF.php#a38c46d070b70b3cdcf00c42ffff9b0c8">get_orig_flag</a>() == <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a866ae5a0308e85514de1abd617c8eb78">LegacyXdrIO::LIBM</a>))
<a name="l00331"></a>00331     {
<a name="l00332"></a>00332       <span class="comment">// Read augmented header</span>
<a name="l00333"></a>00333       n_blocks = mh.<a class="code" href="classXdrMHEAD.php#a264ddaee09b21822fd0a850582b57253">get_n_blocks</a>();
<a name="l00334"></a>00334       
<a name="l00335"></a>00335       etypes.resize(n_blocks);
<a name="l00336"></a>00336       mh.<a class="code" href="classXdrMHEAD.php#a9115e7ed79e8dbb4185accd55880cff2">get_block_elt_types</a>(etypes);
<a name="l00337"></a>00337       
<a name="l00338"></a>00338       mh.<a class="code" href="classXdrMHEAD.php#a40332e90eb2b724e846620c2222e3055">get_num_elem_each_block</a>(neeb); 
<a name="l00339"></a>00339     }
<a name="l00340"></a>00340 
<a name="l00341"></a>00341   
<a name="l00342"></a>00342   
<a name="l00343"></a>00343   <span class="comment">// Read the connectivity  </span>
<a name="l00344"></a>00344   std::vector&lt;int&gt; conn;
<a name="l00345"></a>00345   
<a name="l00346"></a>00346   <span class="comment">// Now that we know the</span>
<a name="l00347"></a>00347   <span class="comment">// number of nodes and elements,</span>
<a name="l00348"></a>00348   <span class="comment">// we can resize the</span>
<a name="l00349"></a>00349   <span class="comment">// appropriate vectors if we are</span>
<a name="l00350"></a>00350   <span class="comment">// reading information in.</span>
<a name="l00351"></a>00351   mesh.<a class="code" href="classMeshBase.php#a641a3da2df67396c48c9a9b2434b4d68">reserve_nodes</a> (numNodes);
<a name="l00352"></a>00352   mesh.<a class="code" href="classMeshBase.php#ae034eb4ecaa04c32b89909d9eee85411">reserve_elem</a>  (numElem);
<a name="l00353"></a>00353   
<a name="l00354"></a>00354   <span class="comment">// Each element stores two extra</span>
<a name="l00355"></a>00355   <span class="comment">// locations: one which tells</span>
<a name="l00356"></a>00356   <span class="comment">// what type of element it is,</span>
<a name="l00357"></a>00357   <span class="comment">// and one which tells how many</span>
<a name="l00358"></a>00358   <span class="comment">// nodes it has. Therefore,</span>
<a name="l00359"></a>00359   <span class="comment">// the total number of nodes</span>
<a name="l00360"></a>00360   <span class="comment">// (totalWeight) must be augmented</span>
<a name="l00361"></a>00361   <span class="comment">// by 2 times the number of elements</span>
<a name="l00362"></a>00362   <span class="comment">// in order to read in the entire</span>
<a name="l00363"></a>00363   <span class="comment">// connectivity array.</span>
<a name="l00364"></a>00364   
<a name="l00365"></a>00365   <span class="comment">// Note: This section now depends on</span>
<a name="l00366"></a>00366   <span class="comment">// whether we are reading an old-style libMesh, </span>
<a name="l00367"></a>00367   <span class="comment">// MGF, or a new-style libMesh mesh.  </span>
<a name="l00368"></a>00368   <span class="keywordflow">if</span> (m.<a class="code" href="classXdrMGF.php#a38c46d070b70b3cdcf00c42ffff9b0c8">get_orig_flag</a>() == <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74acbf9879c924b6167238ec2dfbfbc861a">LegacyXdrIO::DEAL</a>) 
<a name="l00369"></a>00369     {
<a name="l00370"></a>00370       conn.resize(totalWeight);
<a name="l00371"></a>00371       m.<a class="code" href="classXdrMESH.php#ab8f1feb7cbc6c5da7c65f26fdc943bc4">Icon</a>(&amp;conn[0], 1, totalWeight);
<a name="l00372"></a>00372     }
<a name="l00373"></a>00373   
<a name="l00374"></a>00374   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (m.<a class="code" href="classXdrMGF.php#a38c46d070b70b3cdcf00c42ffff9b0c8">get_orig_flag</a>() == <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a96a3fe5321ff4768538d2481be42354d">LegacyXdrIO::MGF</a>) 
<a name="l00375"></a>00375     {
<a name="l00376"></a>00376       conn.resize(totalWeight+(2*numElem));
<a name="l00377"></a>00377       m.<a class="code" href="classXdrMESH.php#ab8f1feb7cbc6c5da7c65f26fdc943bc4">Icon</a>(&amp;conn[0], 1, totalWeight+(2*numElem));
<a name="l00378"></a>00378     }
<a name="l00379"></a>00379 
<a name="l00380"></a>00380   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (m.<a class="code" href="classXdrMGF.php#a38c46d070b70b3cdcf00c42ffff9b0c8">get_orig_flag</a>() == <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a866ae5a0308e85514de1abd617c8eb78">LegacyXdrIO::LIBM</a>)
<a name="l00381"></a>00381     {
<a name="l00382"></a>00382       conn.resize(totalWeight);
<a name="l00383"></a>00383       m.<a class="code" href="classXdrMESH.php#ab8f1feb7cbc6c5da7c65f26fdc943bc4">Icon</a>(&amp;conn[0], 1, totalWeight);
<a name="l00384"></a>00384     }
<a name="l00385"></a>00385   
<a name="l00386"></a>00386   <span class="keywordflow">else</span>
<a name="l00387"></a>00387     {
<a name="l00388"></a>00388       <span class="comment">// I don&#39;t know what type of mesh it is.</span>
<a name="l00389"></a>00389       libmesh_error();
<a name="l00390"></a>00390     }
<a name="l00391"></a>00391 
<a name="l00392"></a>00392   <span class="comment">// read in the nodal coordinates and form points.</span>
<a name="l00393"></a>00393   {
<a name="l00394"></a>00394     std::vector&lt;Real&gt; coords(numNodes*mesh.<a class="code" href="classMeshBase.php#acaf87bde8c96b91d8f355dc9ebb72f5f">spatial_dimension</a>()); <span class="comment">// Always use three coords per node</span>
<a name="l00395"></a>00395     m.<a class="code" href="classXdrMESH.php#aaaa5effbb77c02ccf782be5f5f28584f">coord</a>(&amp;coords[0], mesh.<a class="code" href="classMeshBase.php#acaf87bde8c96b91d8f355dc9ebb72f5f">spatial_dimension</a>(), numNodes);
<a name="l00396"></a>00396 
<a name="l00397"></a>00397 
<a name="l00398"></a>00398   
<a name="l00399"></a>00399     <span class="comment">// Form Nodes out of</span>
<a name="l00400"></a>00400     <span class="comment">// the coordinates.  If the    </span>
<a name="l00401"></a>00401     <span class="comment">// MeshData object is active,</span>
<a name="l00402"></a>00402     <span class="comment">// add the nodes and ids also          </span>
<a name="l00403"></a>00403     <span class="comment">// to its map.</span>
<a name="l00404"></a>00404     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> innd=0; innd&lt;numNodes; ++innd)      
<a name="l00405"></a>00405       {
<a name="l00406"></a>00406         <a class="code" href="classNode.php">Node</a>* node = mesh.<a class="code" href="classMeshBase.php#a01b66468d3e9d8b5db82c6f3d9131f5e">add_point</a> (<a class="code" href="classPoint.php">Point</a>(coords[0+innd*3],  
<a name="l00407"></a>00407                                            coords[1+innd*3],
<a name="l00408"></a>00408                                            coords[2+innd*3]), innd);
<a name="l00409"></a>00409                                        
<a name="l00410"></a>00410         <span class="keywordflow">if</span> (mesh_data != NULL)
<a name="l00411"></a>00411           <span class="keywordflow">if</span> (mesh_data-&gt;<a class="code" href="classMeshData.php#a4d99efe5fb30d203afdd520d213c6233">active</a>())
<a name="l00412"></a>00412             {
<a name="l00413"></a>00413               <span class="comment">// add the id to the MeshData, so that</span>
<a name="l00414"></a>00414               <span class="comment">// it knows the foreign id, even when </span>
<a name="l00415"></a>00415               <span class="comment">// the underlying mesh got re-numbered,</span>
<a name="l00416"></a>00416               <span class="comment">// refined, elements/nodes added...   </span>
<a name="l00417"></a>00417               mesh_data-&gt;<a class="code" href="classMeshData.php#af408db231805974db975dbdf3c1756f5">add_foreign_node_id</a>(node, innd);
<a name="l00418"></a>00418             }
<a name="l00419"></a>00419       }  
<a name="l00420"></a>00420   }
<a name="l00421"></a>00421 
<a name="l00422"></a>00422   
<a name="l00423"></a>00423   
<a name="l00424"></a>00424   <span class="comment">// Build the elements.</span>
<a name="l00425"></a>00425   <span class="comment">// Note: If the originator was MGF, we don&#39;t</span>
<a name="l00426"></a>00426   <span class="comment">// have to do much checking ...</span>
<a name="l00427"></a>00427   <span class="comment">// all the elements are Hex27.</span>
<a name="l00428"></a>00428   <span class="comment">// If the originator was</span>
<a name="l00429"></a>00429   <span class="comment">// this code, we have to loop over</span>
<a name="l00430"></a>00430   <span class="comment">// et and neeb to read in all the</span>
<a name="l00431"></a>00431   <span class="comment">// elements correctly.</span>
<a name="l00432"></a>00432   <span class="comment">//</span>
<a name="l00433"></a>00433   <span class="comment">// (This used to be before the coords block, but it</span>
<a name="l00434"></a>00434   <span class="comment">// had to change now that elements store pointers to</span>
<a name="l00435"></a>00435   <span class="comment">// nodes.  The nodes must exist before we assign them to</span>
<a name="l00436"></a>00436   <span class="comment">// the elements. BSK, 1/13/2003)</span>
<a name="l00437"></a>00437   <span class="keywordflow">if</span> ((m.<a class="code" href="classXdrMGF.php#a38c46d070b70b3cdcf00c42ffff9b0c8">get_orig_flag</a>() == <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74acbf9879c924b6167238ec2dfbfbc861a">LegacyXdrIO::DEAL</a>) || (m.<a class="code" href="classXdrMGF.php#a38c46d070b70b3cdcf00c42ffff9b0c8">get_orig_flag</a>() == <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a866ae5a0308e85514de1abd617c8eb78">LegacyXdrIO::LIBM</a>)) 
<a name="l00438"></a>00438     {
<a name="l00439"></a>00439       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> lastConnIndex = 0;
<a name="l00440"></a>00440       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> lastFaceIndex = 0;
<a name="l00441"></a>00441 
<a name="l00442"></a>00442       <span class="comment">// This map keeps track of elements we&#39;ve previously</span>
<a name="l00443"></a>00443       <span class="comment">// constructed, to avoid O(n) lookup times for parent pointers</span>
<a name="l00444"></a>00444       <span class="comment">// and to enable elements to be added in ascending ID order</span>
<a name="l00445"></a>00445       std::map&lt;unsigned int, Elem*&gt; parents;
<a name="l00446"></a>00446 
<a name="l00447"></a>00447       <span class="comment">// Keep track of Element ids in MGF-style meshes;</span>
<a name="l00448"></a>00448       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _next_elem_id = 0;
<a name="l00449"></a>00449 
<a name="l00450"></a>00450       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level=0; level&lt;=<a class="code" href="namespaceMeshTools.php#a467cd3c96ff9a03c0918d4df6ef16301">n_levels</a>; level++)
<a name="l00451"></a>00451       {
<a name="l00452"></a>00452         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>=0; <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>&lt;n_blocks; <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>++)  
<a name="l00453"></a>00453         {
<a name="l00454"></a>00454           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=lastFaceIndex; e&lt;lastFaceIndex+neeb[level*n_blocks+<a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>]; e++)  
<a name="l00455"></a>00455           {
<a name="l00456"></a>00456             <span class="comment">// Build a temporary element of the right type, so we know how</span>
<a name="l00457"></a>00457             <span class="comment">// connectivity entries will be on the line for this element.</span>
<a name="l00458"></a>00458             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> temp_elem = <a class="code" href="classLinearSolver.php#acc014293981a8cc6988c2c9641681bf2">Elem::build</a>(etypes[<a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>]);
<a name="l00459"></a>00459 
<a name="l00460"></a>00460             <span class="comment">// A pointer to the element which will eventually be added to the mesh.</span>
<a name="l00461"></a>00461             <a class="code" href="classElem.php">Elem</a>* elem;
<a name="l00462"></a>00462 
<a name="l00463"></a>00463             <span class="comment">// New-style libMesh mesh</span>
<a name="l00464"></a>00464             <span class="keywordflow">if</span> (m.<a class="code" href="classXdrMGF.php#a38c46d070b70b3cdcf00c42ffff9b0c8">get_orig_flag</a>() == <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a866ae5a0308e85514de1abd617c8eb78">LegacyXdrIO::LIBM</a>)
<a name="l00465"></a>00465             {
<a name="l00466"></a>00466               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> self_ID   = conn[lastConnIndex + temp_elem-&gt;n_nodes()];
<a name="l00467"></a>00467 
<a name="l00468"></a>00468 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00469"></a>00469 <span class="preprocessor"></span>              <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parent_ID = conn[lastConnIndex + temp_elem-&gt;n_nodes()+1];
<a name="l00470"></a>00470 
<a name="l00471"></a>00471               <span class="keywordflow">if</span> (level &gt; 0)
<a name="l00472"></a>00472               {
<a name="l00473"></a>00473                 <span class="comment">// Do a linear search for the parent</span>
<a name="l00474"></a>00474                 <a class="code" href="classElem.php">Elem</a>* my_parent;
<a name="l00475"></a>00475 
<a name="l00476"></a>00476                 <span class="comment">// Search for parent in the parents map (log(n))</span>
<a name="l00477"></a>00477                 START_LOG(<span class="stringliteral">&quot;log(n) search for parent&quot;</span>, <span class="stringliteral">&quot;LegacyXdrIO::read_mesh&quot;</span>);
<a name="l00478"></a>00478                 std::map&lt;unsigned int, Elem*&gt;::iterator it = parents.find(parent_ID);
<a name="l00479"></a>00479                 STOP_LOG(<span class="stringliteral">&quot;log(n) search for parent&quot;</span>, <span class="stringliteral">&quot;LegacyXdrIO::read_mesh&quot;</span>);
<a name="l00480"></a>00480                 
<a name="l00481"></a>00481                 <span class="comment">// If the parent was not previously added, we cannot continue.</span>
<a name="l00482"></a>00482                 <span class="keywordflow">if</span> (it == parents.end())
<a name="l00483"></a>00483                 {
<a name="l00484"></a>00484                   std::cerr &lt;&lt; <span class="stringliteral">&quot;Parent element with ID &quot;</span> &lt;&lt; parent_ID 
<a name="l00485"></a>00485                             &lt;&lt; <span class="stringliteral">&quot; not found.&quot;</span> &lt;&lt; std::endl; 
<a name="l00486"></a>00486                   libmesh_error();
<a name="l00487"></a>00487                 }
<a name="l00488"></a>00488 
<a name="l00489"></a>00489                 <span class="comment">// Set the my_parent pointer</span>
<a name="l00490"></a>00490                 my_parent = (*it).second;
<a name="l00491"></a>00491 
<a name="l00492"></a>00492                 <span class="comment">// my_parent is now INACTIVE, since he has children</span>
<a name="l00493"></a>00493                 my_parent-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829aa5b67adf7b456724c4a0a07034a0adbf">Elem::INACTIVE</a>);
<a name="l00494"></a>00494                
<a name="l00495"></a>00495                 <span class="comment">// Now that we know the parent, build the child</span>
<a name="l00496"></a>00496                 elem = <a class="code" href="classLinearSolver.php#acc014293981a8cc6988c2c9641681bf2">Elem::build</a>(etypes[idx],my_parent).release();
<a name="l00497"></a>00497 
<a name="l00498"></a>00498                 <span class="comment">// The new child is marked as JUST_REFINED</span>
<a name="l00499"></a>00499                 elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a28fd8e260b7464210efa6f4f24d54310">Elem::JUST_REFINED</a>); 
<a name="l00500"></a>00500                 
<a name="l00501"></a>00501                 <span class="comment">// Tell the parent about his new child</span>
<a name="l00502"></a>00502                 my_parent-&gt;<a class="code" href="classElem.php#a791ed16f88c661c7ed22e10e0cf8d8ff">add_child</a>(elem);
<a name="l00503"></a>00503 
<a name="l00504"></a>00504                 <span class="comment">// sanity check</span>
<a name="l00505"></a>00505                 libmesh_assert (my_parent-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>() == elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>());
<a name="l00506"></a>00506               }
<a name="l00507"></a>00507 
<a name="l00508"></a>00508               <span class="comment">// Add level-0 elements to the mesh </span>
<a name="l00509"></a>00509               <span class="keywordflow">else</span>
<a name="l00510"></a>00510 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00511"></a>00511 <span class="preprocessor"></span>              {
<a name="l00512"></a>00512                 elem = <a class="code" href="classLinearSolver.php#acc014293981a8cc6988c2c9641681bf2">Elem::build</a>(etypes[idx]).release();
<a name="l00513"></a>00513               }
<a name="l00514"></a>00514 
<a name="l00515"></a>00515               <span class="comment">// Assign the newly-added element&#39;s ID so that future </span>
<a name="l00516"></a>00516               <span class="comment">// children which may be added can find it correctly.</span>
<a name="l00517"></a>00517               elem-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a>() = self_ID;
<a name="l00518"></a>00518                 
<a name="l00519"></a>00519               <span class="comment">// Add this element to the map, it may be a parent for a future element</span>
<a name="l00520"></a>00520               START_LOG(<span class="stringliteral">&quot;insert elem into map&quot;</span>, <span class="stringliteral">&quot;LegacyXdrIO::read_mesh&quot;</span>);
<a name="l00521"></a>00521               parents[self_ID] = elem;
<a name="l00522"></a>00522               STOP_LOG(<span class="stringliteral">&quot;insert elem into map&quot;</span>, <span class="stringliteral">&quot;LegacyXdrIO::read_mesh&quot;</span>);
<a name="l00523"></a>00523             }
<a name="l00524"></a>00524 
<a name="l00525"></a>00525             <span class="comment">// MGF-style meshes</span>
<a name="l00526"></a>00526             <span class="keywordflow">else</span>
<a name="l00527"></a>00527             {
<a name="l00528"></a>00528               elem = <a class="code" href="classLinearSolver.php#acc014293981a8cc6988c2c9641681bf2">Elem::build</a>(etypes[idx]).release();
<a name="l00529"></a>00529               elem-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a>(_next_elem_id++);
<a name="l00530"></a>00530               mesh.<a class="code" href="classMeshBase.php#a0f6974cf3e413cfe9caa1fcb4ce8153e">add_elem</a>(elem);
<a name="l00531"></a>00531             }
<a name="l00532"></a>00532             
<a name="l00533"></a>00533             <span class="comment">// Add elements with the same id as in libMesh.  </span>
<a name="l00534"></a>00534             <span class="comment">// Provided the data files that MeshData reads    </span>
<a name="l00535"></a>00535             <span class="comment">// were only written with MeshData, then this      </span>
<a name="l00536"></a>00536             <span class="comment">// should work properly.  This is an inline</span>
<a name="l00537"></a>00537             <span class="comment">// function, so that for disabled MeshData, this</span>
<a name="l00538"></a>00538             <span class="comment">// should not induce too much cost</span>
<a name="l00539"></a>00539             <span class="keywordflow">if</span> (mesh_data != NULL)
<a name="l00540"></a>00540               mesh_data-&gt;<a class="code" href="classMeshData.php#acf27873beae104e2109db6c93de7efa9">add_foreign_elem_id</a> (elem, e);
<a name="l00541"></a>00541 
<a name="l00542"></a>00542             <span class="comment">// Set the node pointers of the newly-created element</span>
<a name="l00543"></a>00543             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> innd=0; innd &lt; elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); innd++)
<a name="l00544"></a>00544             {
<a name="l00545"></a>00545               elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(innd) = mesh.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(conn[innd+lastConnIndex]);
<a name="l00546"></a>00546             }
<a name="l00547"></a>00547 
<a name="l00548"></a>00548             lastConnIndex += (m.<a class="code" href="classXdrMGF.php#a38c46d070b70b3cdcf00c42ffff9b0c8">get_orig_flag</a>() == <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a866ae5a0308e85514de1abd617c8eb78">LegacyXdrIO::LIBM</a>) ? (elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>()+2) : elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>();
<a name="l00549"></a>00549           }
<a name="l00550"></a>00550           lastFaceIndex += neeb[<a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>];
<a name="l00551"></a>00551         }
<a name="l00552"></a>00552         
<a name="l00553"></a>00553       }
<a name="l00554"></a>00554 
<a name="l00555"></a>00555       <span class="keywordflow">if</span> (m.<a class="code" href="classXdrMGF.php#a38c46d070b70b3cdcf00c42ffff9b0c8">get_orig_flag</a>() == <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a866ae5a0308e85514de1abd617c8eb78">LegacyXdrIO::LIBM</a>)
<a name="l00556"></a>00556         {
<a name="l00557"></a>00557           <span class="comment">// Iterate in ascending elem ID order</span>
<a name="l00558"></a>00558           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _next_elem_id = 0;
<a name="l00559"></a>00559           <span class="keywordflow">for</span> (std::map&lt;unsigned int, Elem *&gt;::iterator i =
<a name="l00560"></a>00560                parents.begin();
<a name="l00561"></a>00561                i != parents.end(); ++i)
<a name="l00562"></a>00562             {
<a name="l00563"></a>00563               <a class="code" href="classElem.php">Elem</a> *elem = i-&gt;second;
<a name="l00564"></a>00564               <span class="keywordflow">if</span> (elem)
<a name="l00565"></a>00565                 {
<a name="l00566"></a>00566                   elem-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a>(_next_elem_id++);
<a name="l00567"></a>00567                   mesh.<a class="code" href="classMeshBase.php#a0f6974cf3e413cfe9caa1fcb4ce8153e">add_elem</a>(elem);
<a name="l00568"></a>00568                 }
<a name="l00569"></a>00569               <span class="keywordflow">else</span>
<a name="l00570"></a>00570                 <span class="comment">// We can probably handle this, but we don&#39;t expect it</span>
<a name="l00571"></a>00571                 libmesh_error();
<a name="l00572"></a>00572             }
<a name="l00573"></a>00573         }
<a name="l00574"></a>00574     }
<a name="l00575"></a>00575  
<a name="l00576"></a>00576   <span class="comment">// MGF-style (1) Hex27 mesh</span>
<a name="l00577"></a>00577   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (m.<a class="code" href="classXdrMGF.php#a38c46d070b70b3cdcf00c42ffff9b0c8">get_orig_flag</a>() == <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a96a3fe5321ff4768538d2481be42354d">LegacyXdrIO::MGF</a>) 
<a name="l00578"></a>00578     {
<a name="l00579"></a>00579       
<a name="l00580"></a>00580 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00581"></a>00581 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (mesh_data != NULL)
<a name="l00582"></a>00582         <span class="keywordflow">if</span> (mesh_data-&gt;<a class="code" href="classMeshData.php#a4d99efe5fb30d203afdd520d213c6233">active</a>())
<a name="l00583"></a>00583           {
<a name="l00584"></a>00584             std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: MeshData not implemented for MGF-style mesh.&quot;</span>
<a name="l00585"></a>00585                       &lt;&lt; std::endl;
<a name="l00586"></a>00586             libmesh_error();
<a name="l00587"></a>00587           }
<a name="l00588"></a>00588 <span class="preprocessor">#endif</span>
<a name="l00589"></a>00589 <span class="preprocessor"></span>      
<a name="l00590"></a>00590       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> ielm=0; ielm &lt; numElem; ++ielm)
<a name="l00591"></a>00591         {
<a name="l00592"></a>00592           <a class="code" href="classElem.php">Elem</a>* elem = <span class="keyword">new</span> <a class="code" href="classHex27.php">Hex27</a>;
<a name="l00593"></a>00593           elem-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a>(ielm);
<a name="l00594"></a>00594           mesh.<a class="code" href="classMeshBase.php#a0f6974cf3e413cfe9caa1fcb4ce8153e">add_elem</a>(elem);
<a name="l00595"></a>00595           
<a name="l00596"></a>00596           <span class="keywordflow">for</span> (<span class="keywordtype">int</span> innd=0; innd &lt; 27; ++innd)
<a name="l00597"></a>00597             elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(innd) = mesh.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(conn[innd+2+(27+2)*ielm]);     
<a name="l00598"></a>00598         }
<a name="l00599"></a>00599     }
<a name="l00600"></a>00600 
<a name="l00601"></a>00601   
<a name="l00602"></a>00602   <span class="comment">// tell the MeshData object that we are finished </span>
<a name="l00603"></a>00603   <span class="comment">// reading data</span>
<a name="l00604"></a>00604   <span class="keywordflow">if</span> (mesh_data != NULL)
<a name="l00605"></a>00605     mesh_data-&gt;<a class="code" href="classMeshData.php#a3cec8b434c51b58caec642d978c64ab4">close_foreign_id_maps</a> ();
<a name="l00606"></a>00606   
<a name="l00607"></a>00607   <span class="comment">// Free memory used in</span>
<a name="l00608"></a>00608   <span class="comment">// the connectivity</span>
<a name="l00609"></a>00609   <span class="comment">// vector.</span>
<a name="l00610"></a>00610   conn.clear();
<a name="l00611"></a>00611 
<a name="l00612"></a>00612 
<a name="l00613"></a>00613   <span class="comment">// If we are reading,</span>
<a name="l00614"></a>00614   <span class="comment">// read in the BCs</span>
<a name="l00615"></a>00615   <span class="comment">// from the mesh file,</span>
<a name="l00616"></a>00616   <span class="comment">// otherwise write the</span>
<a name="l00617"></a>00617   <span class="comment">// boundary conditions</span>
<a name="l00618"></a>00618   <span class="comment">// if the BoundaryInfo</span>
<a name="l00619"></a>00619   <span class="comment">// object exists.</span>
<a name="l00620"></a>00620   <span class="keywordflow">if</span> (numBCs &gt; 0)
<a name="l00621"></a>00621     {
<a name="l00622"></a>00622       std::vector&lt;int&gt; bcs(numBCs*3);
<a name="l00623"></a>00623 
<a name="l00624"></a>00624       <span class="comment">// Read the BCs from the XDR file</span>
<a name="l00625"></a>00625       m.<a class="code" href="classXdrMESH.php#a18a7b078c23683afbbcca8356eb71b9c">BC</a>(&amp;bcs[0], numBCs);
<a name="l00626"></a>00626   
<a name="l00627"></a>00627       <span class="comment">// Add to the boundary_info</span>
<a name="l00628"></a>00628       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> ibc=0; ibc &lt; numBCs; ibc++)
<a name="l00629"></a>00629         mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;add_side(bcs[0+ibc*3], bcs[1+ibc*3], bcs[2+ibc*3]);
<a name="l00630"></a>00630     }
<a name="l00631"></a>00631 }
<a name="l00632"></a>00632 
<a name="l00633"></a>00633 
<a name="l00634"></a>00634 
<a name="l00635"></a><a class="code" href="classLegacyXdrIO.php#a92c47baf2df593f9aa21b33f8d5f7913">00635</a> <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#a92c47baf2df593f9aa21b33f8d5f7913">LegacyXdrIO::write_mesh</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00636"></a>00636                               <span class="keyword">const</span> <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74">LegacyXdrIO::FileFormat</a> originator)
<a name="l00637"></a>00637 {
<a name="l00638"></a>00638   <span class="comment">// get a read-only reference to the mesh</span>
<a name="l00639"></a>00639   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00640"></a>00640 
<a name="l00641"></a>00641   <span class="comment">// n_levels is a parallel-only method</span>
<a name="l00642"></a>00642   parallel_only();
<a name="l00643"></a>00643   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>          <a class="code" href="namespaceMeshTools.php#a467cd3c96ff9a03c0918d4df6ef16301">n_levels</a> = <a class="code" href="namespaceMeshTools.php#a467cd3c96ff9a03c0918d4df6ef16301">MeshTools::n_levels</a>(mesh);
<a name="l00644"></a>00644 
<a name="l00645"></a>00645   <span class="comment">// The Legacy Xdr IO code only works if we have a serialized mesh</span>
<a name="l00646"></a>00646   libmesh_assert (mesh.<a class="code" href="classMeshBase.php#a660bb92c9fb94527d1cabfb1fdd6d056">is_serial</a>());
<a name="l00647"></a>00647 
<a name="l00648"></a>00648   <span class="comment">// In which case only processor 0 needs to do any writing</span>
<a name="l00649"></a>00649   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l00650"></a>00650     <span class="keywordflow">return</span>;
<a name="l00651"></a>00651   
<a name="l00652"></a>00652   <span class="comment">// Create an XdrMESH object.</span>
<a name="l00653"></a>00653   <a class="code" href="classXdrMESH.php">XdrMESH</a> m;
<a name="l00654"></a>00654 
<a name="l00655"></a>00655   <span class="comment">// Create a pointer</span>
<a name="l00656"></a>00656   <span class="comment">// to an XdrMESH file</span>
<a name="l00657"></a>00657   <span class="comment">// header.</span>
<a name="l00658"></a>00658   <a class="code" href="classXdrMHEAD.php">XdrMHEAD</a> mh;
<a name="l00659"></a>00659 
<a name="l00660"></a>00660   <span class="comment">// Open the XDR file for writing.</span>
<a name="l00661"></a>00661   <span class="comment">// Note 1: Provide an additional argument</span>
<a name="l00662"></a>00662   <span class="comment">// to specify the dimension.</span>
<a name="l00663"></a>00663   <span class="comment">//</span>
<a name="l00664"></a>00664   <span class="comment">// Note 2: Has to do the right thing for</span>
<a name="l00665"></a>00665   <span class="comment">// both binary and ASCII files.</span>
<a name="l00666"></a>00666   m.<a class="code" href="classXdrMGF.php#a429208021d453abbe95b4d019b92552b">set_orig_flag</a>(originator);
<a name="l00667"></a>00667 
<a name="l00668"></a>00668   <span class="comment">// From here on, things depend</span>
<a name="l00669"></a>00669   <span class="comment">// on whether we are reading or</span>
<a name="l00670"></a>00670   <span class="comment">// writing!  First, we define</span>
<a name="l00671"></a>00671   <span class="comment">// header variables that may</span>
<a name="l00672"></a>00672   <span class="comment">// be read OR written.</span>
<a name="l00673"></a>00673   std::vector&lt;unsigned int&gt; neeb;
<a name="l00674"></a>00674   std::vector&lt;ElemType&gt; etypes;
<a name="l00675"></a>00675   
<a name="l00676"></a>00676 
<a name="l00677"></a>00677   <span class="keywordtype">int</span> n_non_subactive = 0;
<a name="l00678"></a>00678   <span class="keywordtype">int</span> non_subactive_weight = 0;
<a name="l00679"></a>00679 
<a name="l00680"></a>00680   <span class="comment">// This map will associate </span>
<a name="l00681"></a>00681   <span class="comment">// the distance from the beginning of the set</span>
<a name="l00682"></a>00682   <span class="comment">// to each node ID with the node ID itself.</span>
<a name="l00683"></a>00683   std::map&lt;unsigned int, unsigned int&gt; node_map;
<a name="l00684"></a>00684 
<a name="l00685"></a>00685   {
<a name="l00686"></a>00686     <span class="comment">// For each non-subactive element:</span>
<a name="l00687"></a>00687     <span class="comment">// 1.) Increment the number of non subactive elements</span>
<a name="l00688"></a>00688     <span class="comment">// 2.) Accumulate the total weight</span>
<a name="l00689"></a>00689     <span class="comment">// 3.) Add the node ids to a set of non subactive node ids </span>
<a name="l00690"></a>00690     std::set&lt;unsigned int&gt; not_subactive_node_ids;
<a name="l00691"></a>00691     <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el = mesh.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00692"></a>00692     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = mesh.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00693"></a>00693     <span class="keywordflow">for</span>( ; el != end_el; ++el)
<a name="l00694"></a>00694     {
<a name="l00695"></a>00695       <a class="code" href="classElem.php">Elem</a>* elem = (*el);
<a name="l00696"></a>00696       <span class="keywordflow">if</span>(!elem-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>())
<a name="l00697"></a>00697       {
<a name="l00698"></a>00698         n_non_subactive++;
<a name="l00699"></a>00699         non_subactive_weight += elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>();
<a name="l00700"></a>00700 
<a name="l00701"></a>00701         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); ++n)
<a name="l00702"></a>00702           not_subactive_node_ids.insert(elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n));
<a name="l00703"></a>00703       }
<a name="l00704"></a>00704     }
<a name="l00705"></a>00705 
<a name="l00706"></a>00706     <span class="comment">// Now that the set is built, most of the hard work is done.  We build</span>
<a name="l00707"></a>00707     <span class="comment">// the map next and let the set go out of scope.</span>
<a name="l00708"></a>00708     std::set&lt;unsigned int&gt;::iterator it = not_subactive_node_ids.begin();
<a name="l00709"></a>00709     <span class="keyword">const</span> std::set&lt;unsigned int&gt;::iterator end = not_subactive_node_ids.end();
<a name="l00710"></a>00710     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l00711"></a>00711     <span class="keywordflow">for</span> (; it!=end; ++it)
<a name="l00712"></a>00712       node_map[*it] = cnt++;
<a name="l00713"></a>00713   }
<a name="l00714"></a>00714 
<a name="l00715"></a>00715 
<a name="l00716"></a>00716   <span class="keyword">const</span> <span class="keywordtype">int</span>                   numElem  = n_non_subactive;       
<a name="l00717"></a>00717   <span class="keyword">const</span> <span class="keywordtype">int</span>                   numBCs   = mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;n_boundary_conds();
<a name="l00718"></a>00718   
<a name="l00719"></a>00719   <span class="comment">// Fill the etypes vector with all of the element types found in the mesh</span>
<a name="l00720"></a>00720   <a class="code" href="namespaceMeshTools.php#a907bdeb4ae9c2d6a780e85bde894e731">MeshTools::elem_types</a>(mesh, etypes);
<a name="l00721"></a>00721   
<a name="l00722"></a>00722   <span class="comment">// store number of elements in each block at each refinement level</span>
<a name="l00723"></a>00723   neeb.resize((n_levels+1)*etypes.size()); 
<a name="l00724"></a>00724 
<a name="l00725"></a>00725   <span class="comment">// Store a variable for the number of element types                   </span>
<a name="l00726"></a>00726   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_el_types = etypes.size();
<a name="l00727"></a>00727         
<a name="l00728"></a>00728   m.<a class="code" href="classXdrMGF.php#a8e5c5d512de516fda12b311dfb648dc1">set_num_levels</a>(n_levels);
<a name="l00729"></a>00729 
<a name="l00730"></a>00730   <span class="comment">// The last argument is zero because mesh files are always number 0 ...</span>
<a name="l00731"></a>00731   m.<a class="code" href="classXdrMESH.php#a1514a001c5b72800ef965c8a9a6e34ab">init</a>((this-&gt;<a class="code" href="classLegacyXdrIO.php#ad4900c83e2a153a89012e9b27dda1d22">binary</a>() ? <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759aca15a85ac1052a9c12cd00c6a7c3bba6">XdrMGF::ENCODE</a> : <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a4abf31037aca9aabba9b65e45ebc4744">XdrMGF::W_ASCII</a>), name.c_str(), 0); 
<a name="l00732"></a>00732 
<a name="l00733"></a>00733   <span class="comment">// Loop over all levels and all element types to set the entries of neeb</span>
<a name="l00734"></a>00734   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level=0; level&lt;=<a class="code" href="namespaceMeshTools.php#a467cd3c96ff9a03c0918d4df6ef16301">n_levels</a>; level++)
<a name="l00735"></a>00735     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> el_type=0; el_type&lt;n_el_types; el_type++)
<a name="l00736"></a>00736       neeb[level*n_el_types + el_type] = 
<a name="l00737"></a>00737         <a class="code" href="namespaceMeshTools.php#a115b9be300720c24bb023ab767245937">MeshTools::n_non_subactive_elem_of_type_at_level</a>(mesh, etypes[el_type], level);
<a name="l00738"></a>00738         <span class="comment">// gotta change this function name!!!</span>
<a name="l00739"></a>00739 
<a name="l00740"></a>00740 
<a name="l00741"></a>00741   <span class="comment">// Now we check to see if we&#39;re doing</span>
<a name="l00742"></a>00742   <span class="comment">// MGF-style headers or libMesh-style</span>
<a name="l00743"></a>00743   <span class="comment">// &quot;augmented&quot; headers.  An</span>
<a name="l00744"></a>00744   <span class="comment">// augmented header contains </span>
<a name="l00745"></a>00745   <span class="comment">// information about mesh blocks,</span>
<a name="l00746"></a>00746   <span class="comment">// allowing us to optimize storage</span>
<a name="l00747"></a>00747   <span class="comment">// and minimize IO requirements</span>
<a name="l00748"></a>00748   <span class="comment">// for these meshes.</span>
<a name="l00749"></a>00749   <span class="keywordflow">if</span> ((m.<a class="code" href="classXdrMGF.php#a38c46d070b70b3cdcf00c42ffff9b0c8">get_orig_flag</a>() == <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74acbf9879c924b6167238ec2dfbfbc861a">LegacyXdrIO::DEAL</a>) || (m.<a class="code" href="classXdrMGF.php#a38c46d070b70b3cdcf00c42ffff9b0c8">get_orig_flag</a>() == <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a866ae5a0308e85514de1abd617c8eb78">LegacyXdrIO::LIBM</a>))
<a name="l00750"></a>00750     {
<a name="l00751"></a>00751       mh.<a class="code" href="classXdrMHEAD.php#a8c70bef23afbc4a2c9f07b938663caed">set_n_blocks</a>(etypes.size());
<a name="l00752"></a>00752       mh.<a class="code" href="classXdrMHEAD.php#af779d69308db4f5768bf0194e2a6b8cf">set_block_elt_types</a>(etypes);
<a name="l00753"></a>00753       mh.<a class="code" href="classXdrMHEAD.php#a8a6f5fb8a429cb7ae1eb79f2a246c451">set_num_elem_each_block</a>(neeb);
<a name="l00754"></a>00754     }
<a name="l00755"></a>00755   <span class="keywordflow">else</span>
<a name="l00756"></a>00756     libmesh_assert(etypes.size() == 1);
<a name="l00757"></a>00757   
<a name="l00758"></a>00758   mh.<a class="code" href="classXdrMHEAD.php#accda625bf371709a39dcd31a794b042c">setNumEl</a>(numElem);
<a name="l00759"></a>00759   mh.<a class="code" href="classXdrHEAD.php#a8433d0be6562374a41a361bb58e147d0">setNumNodes</a>(node_map.size());
<a name="l00760"></a>00760   mh.<a class="code" href="classXdrHEAD.php#aa4234fc2655312231e1596822b756bda">setStrSize</a>(65536);
<a name="l00761"></a>00761  
<a name="l00762"></a>00762   <span class="comment">// set a local variable for the total weight of the mesh</span>
<a name="l00763"></a>00763   <span class="keywordtype">int</span> totalWeight =0;
<a name="l00764"></a>00764 
<a name="l00765"></a>00765   <span class="keywordflow">if</span> (m.<a class="code" href="classXdrMGF.php#a38c46d070b70b3cdcf00c42ffff9b0c8">get_orig_flag</a>() == <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74acbf9879c924b6167238ec2dfbfbc861a">LegacyXdrIO::DEAL</a>)  <span class="comment">// old-style LibMesh</span>
<a name="l00766"></a>00766     totalWeight=<a class="code" href="namespaceMeshTools.php#a12088fda1f68ba58f5868a24a4ed884a">MeshTools::total_weight</a>(mesh);
<a name="l00767"></a>00767 
<a name="l00768"></a>00768   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (m.<a class="code" href="classXdrMGF.php#a38c46d070b70b3cdcf00c42ffff9b0c8">get_orig_flag</a>() == <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a96a3fe5321ff4768538d2481be42354d">LegacyXdrIO::MGF</a>) <span class="comment">// MGF-style</span>
<a name="l00769"></a>00769     totalWeight = <a class="code" href="namespaceMeshTools.php#a12088fda1f68ba58f5868a24a4ed884a">MeshTools::total_weight</a>(mesh)+2*numElem;
<a name="l00770"></a>00770 
<a name="l00771"></a>00771   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (m.<a class="code" href="classXdrMGF.php#a38c46d070b70b3cdcf00c42ffff9b0c8">get_orig_flag</a>() == <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a866ae5a0308e85514de1abd617c8eb78">LegacyXdrIO::LIBM</a>) <span class="comment">// new-style LibMesh</span>
<a name="l00772"></a>00772     totalWeight = non_subactive_weight+2*numElem;
<a name="l00773"></a>00773 
<a name="l00774"></a>00774   <span class="keywordflow">else</span>
<a name="l00775"></a>00775     libmesh_error();
<a name="l00776"></a>00776     
<a name="l00777"></a>00777   <span class="comment">// Set the total weight in the header</span>
<a name="l00778"></a>00778   mh.<a class="code" href="classXdrMHEAD.php#a53526919868204444357e7b3cad3d7f8">setSumWghts</a>(totalWeight);
<a name="l00779"></a>00779         
<a name="l00780"></a>00780   mh.<a class="code" href="classXdrHEAD.php#a2cdfac4576a940c9536e21e4a78b204c">setNumBCs</a>(numBCs);
<a name="l00781"></a>00781   mh.<a class="code" href="classXdrHEAD.php#aeb16debcad0ecb4eb73111d3b9094acf">setId</a>(<span class="stringliteral">&quot;Id String&quot;</span>);       <span class="comment">// You can put whatever you want, it will be ignored </span>
<a name="l00782"></a>00782   mh.<a class="code" href="classXdrHEAD.php#afb33d2828af0a74f460e0042cf5dc685">setTitle</a>(<span class="stringliteral">&quot;Title String&quot;</span>); <span class="comment">// You can put whatever you want, it will be ignored </span>
<a name="l00783"></a>00783   
<a name="l00784"></a>00784   <span class="comment">// Put the information</span>
<a name="l00785"></a>00785   <span class="comment">// in the XDR file.</span>
<a name="l00786"></a>00786   m.<a class="code" href="classXdrMESH.php#a56ffaabfcfe3ca998154f3a2f5585f52">header</a>(&amp;mh); 
<a name="l00787"></a>00787   
<a name="l00788"></a>00788   
<a name="l00789"></a>00789   <span class="comment">// Write the connectivity  </span>
<a name="l00790"></a>00790   {
<a name="l00791"></a>00791     std::vector&lt;int&gt; conn;
<a name="l00792"></a>00792     <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74">LegacyXdrIO::FileFormat</a> orig_type = m.<a class="code" href="classXdrMGF.php#a38c46d070b70b3cdcf00c42ffff9b0c8">get_orig_flag</a>();
<a name="l00793"></a>00793    
<a name="l00794"></a>00794     <span class="comment">// Resize the connectivity vector to hold all the connectivity for the mesh</span>
<a name="l00795"></a>00795     conn.resize(totalWeight);
<a name="l00796"></a>00796     
<a name="l00797"></a>00797     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> lastConnIndex = 0;
<a name="l00798"></a>00798     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn = 0;
<a name="l00799"></a>00799    
<a name="l00800"></a>00800     <span class="comment">// Loop over levels and types again, write connectivity information to conn.</span>
<a name="l00801"></a>00801     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level=0; level&lt;=<a class="code" href="namespaceMeshTools.php#a467cd3c96ff9a03c0918d4df6ef16301">n_levels</a>; level++)
<a name="l00802"></a>00802       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>=0; <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>&lt;etypes.size(); <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>++)
<a name="l00803"></a>00803       {
<a name="l00804"></a>00804         nn = lastConnIndex = 0;
<a name="l00805"></a>00805 
<a name="l00806"></a>00806         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;mesh.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>(); e++)
<a name="l00807"></a>00807           <span class="keywordflow">if</span> ((mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(e)-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>()  == etypes[<a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>]) &amp;&amp; 
<a name="l00808"></a>00808               (mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(e)-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() == level)       &amp;&amp;
<a name="l00809"></a>00809               !mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(e)-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>())
<a name="l00810"></a>00810           {
<a name="l00811"></a>00811             <span class="keywordtype">int</span> nstart=0;
<a name="l00812"></a>00812             
<a name="l00813"></a>00813             <span class="keywordflow">if</span> (orig_type == <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74acbf9879c924b6167238ec2dfbfbc861a">LegacyXdrIO::DEAL</a>)
<a name="l00814"></a>00814               nn = mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(e)-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>();
<a name="l00815"></a>00815 
<a name="l00816"></a>00816             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (orig_type == <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a96a3fe5321ff4768538d2481be42354d">LegacyXdrIO::MGF</a>)
<a name="l00817"></a>00817             {
<a name="l00818"></a>00818               nstart=2; <span class="comment">// ignore the 27 and 0 entries</span>
<a name="l00819"></a>00819               nn = mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(e)-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>()+2;
<a name="l00820"></a>00820               conn[lastConnIndex + 0] = 27;
<a name="l00821"></a>00821               conn[lastConnIndex + 1] = 0;
<a name="l00822"></a>00822             }
<a name="l00823"></a>00823 
<a name="l00824"></a>00824             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (orig_type == <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a866ae5a0308e85514de1abd617c8eb78">LegacyXdrIO::LIBM</a>) <span class="comment">// LIBMESH format</span>
<a name="l00825"></a>00825               nn = mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(e)-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>() + 2;
<a name="l00826"></a>00826 
<a name="l00827"></a>00827             <span class="keywordflow">else</span>
<a name="l00828"></a>00828               libmesh_error();
<a name="l00829"></a>00829 
<a name="l00830"></a>00830             <span class="comment">// Loop over the connectivity entries for this element and write to conn.</span>
<a name="l00831"></a>00831             START_LOG(<span class="stringliteral">&quot;set connectivity&quot;</span>, <span class="stringliteral">&quot;LegacyXdrIO::write_mesh&quot;</span>);
<a name="l00832"></a>00832             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> loopmax = (orig_type==<a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a866ae5a0308e85514de1abd617c8eb78">LegacyXdrIO::LIBM</a>) ? nn-2 : nn;
<a name="l00833"></a>00833             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=nstart; n&lt;loopmax; n++)
<a name="l00834"></a>00834             {
<a name="l00835"></a>00835               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> connectivity_value=0;
<a name="l00836"></a>00836 
<a name="l00837"></a>00837               <span class="comment">// old-style Libmesh and MGF meshes</span>
<a name="l00838"></a>00838               <span class="keywordflow">if</span> (orig_type != <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a866ae5a0308e85514de1abd617c8eb78">LegacyXdrIO::LIBM</a>)
<a name="l00839"></a>00839                 connectivity_value = mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(e)-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n-nstart);
<a name="l00840"></a>00840 
<a name="l00841"></a>00841               <span class="comment">// new-style libMesh meshes: compress the connectivity entries to account for</span>
<a name="l00842"></a>00842               <span class="comment">// subactive nodes that will not be in the mesh we write out.</span>
<a name="l00843"></a>00843               <span class="keywordflow">else</span>
<a name="l00844"></a>00844               {
<a name="l00845"></a>00845                 std::map&lt;unsigned int, unsigned int&gt;::iterator pos = 
<a name="l00846"></a>00846                   node_map.find(mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(e)-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n-nstart));
<a name="l00847"></a>00847 
<a name="l00848"></a>00848                 libmesh_assert (pos != node_map.end());
<a name="l00849"></a>00849 
<a name="l00850"></a>00850                 connectivity_value = (*pos).second;
<a name="l00851"></a>00851               }
<a name="l00852"></a>00852               conn[lastConnIndex + n] = connectivity_value;
<a name="l00853"></a>00853             }
<a name="l00854"></a>00854             STOP_LOG(<span class="stringliteral">&quot;set connectivity&quot;</span>, <span class="stringliteral">&quot;LegacyXdrIO::write_mesh&quot;</span>);
<a name="l00855"></a>00855 
<a name="l00856"></a>00856             <span class="comment">// In the case of an adaptive mesh, set last 2 entries to this ID and parent ID</span>
<a name="l00857"></a>00857             <span class="keywordflow">if</span> (orig_type == <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a866ae5a0308e85514de1abd617c8eb78">LegacyXdrIO::LIBM</a>)
<a name="l00858"></a>00858             {
<a name="l00859"></a>00859               <span class="keywordtype">int</span> self_ID = mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(e)-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l00860"></a>00860               <span class="keywordtype">int</span> parent_ID = -1;
<a name="l00861"></a>00861               <span class="keywordflow">if</span>(level != 0)
<a name="l00862"></a>00862                 parent_ID = mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(e)-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>()-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l00863"></a>00863 
<a name="l00864"></a>00864               <span class="comment">// Self ID is the second-to-last entry, Parent ID is the last</span>
<a name="l00865"></a>00865               <span class="comment">// entry on each connectivity line</span>
<a name="l00866"></a>00866               conn[lastConnIndex+nn-2] = self_ID;
<a name="l00867"></a>00867               conn[lastConnIndex+nn-1] = parent_ID;
<a name="l00868"></a>00868             }
<a name="l00869"></a>00869 
<a name="l00870"></a>00870             lastConnIndex += nn;
<a name="l00871"></a>00871           }
<a name="l00872"></a>00872 
<a name="l00873"></a>00873         <span class="comment">// Send conn to the XDR file.  If there are no elements of this level and type,</span>
<a name="l00874"></a>00874         <span class="comment">// then nn will be zero, and we there is no connectivity to write. </span>
<a name="l00875"></a>00875         <span class="keywordflow">if</span> (nn != 0)
<a name="l00876"></a>00876           m.<a class="code" href="classXdrMESH.php#ab8f1feb7cbc6c5da7c65f26fdc943bc4">Icon</a>(&amp;conn[0], nn, lastConnIndex/nn);
<a name="l00877"></a>00877       }
<a name="l00878"></a>00878   }
<a name="l00879"></a>00879     
<a name="l00880"></a>00880   <span class="comment">// create the vector of coords and send</span>
<a name="l00881"></a>00881   <span class="comment">// it to the XDR file.</span>
<a name="l00882"></a>00882   {
<a name="l00883"></a>00883     std::vector&lt;Real&gt; coords;
<a name="l00884"></a>00884     
<a name="l00885"></a>00885     coords.resize(mesh.<a class="code" href="classMeshBase.php#acaf87bde8c96b91d8f355dc9ebb72f5f">spatial_dimension</a>()*node_map.size());
<a name="l00886"></a>00886     <span class="keywordtype">int</span> lastIndex=0;
<a name="l00887"></a>00887 
<a name="l00888"></a>00888     std::map&lt;unsigned int,unsigned int&gt;::iterator it = node_map.begin();
<a name="l00889"></a>00889     <span class="keyword">const</span> std::map&lt;unsigned int,unsigned int&gt;::iterator end = node_map.end();
<a name="l00890"></a>00890     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00891"></a>00891       {
<a name="l00892"></a>00892         <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p = mesh.<a class="code" href="classMeshBase.php#a298477f2d67d6a85f6c7fb5a640e2b64">node</a>((*it).first);
<a name="l00893"></a>00893 
<a name="l00894"></a>00894         coords[lastIndex+0] = p(0);
<a name="l00895"></a>00895         coords[lastIndex+1] = p(1);
<a name="l00896"></a>00896         coords[lastIndex+2] = p(2);
<a name="l00897"></a>00897         lastIndex += 3;
<a name="l00898"></a>00898       }
<a name="l00899"></a>00899    
<a name="l00900"></a>00900     <span class="comment">// Put the nodes in the XDR file</span>
<a name="l00901"></a>00901     m.<a class="code" href="classXdrMESH.php#aaaa5effbb77c02ccf782be5f5f28584f">coord</a>(&amp;coords[0], mesh.<a class="code" href="classMeshBase.php#acaf87bde8c96b91d8f355dc9ebb72f5f">spatial_dimension</a>(), node_map.size()); 
<a name="l00902"></a>00902   }
<a name="l00903"></a>00903 
<a name="l00904"></a>00904   
<a name="l00905"></a>00905   <span class="comment">// write the</span>
<a name="l00906"></a>00906   <span class="comment">// boundary conditions</span>
<a name="l00907"></a>00907   <span class="comment">// if the BoundaryInfo</span>
<a name="l00908"></a>00908   <span class="comment">// object exists.</span>
<a name="l00909"></a>00909   <span class="keywordflow">if</span> (numBCs &gt; 0)
<a name="l00910"></a>00910     {
<a name="l00911"></a>00911       std::vector&lt;int&gt; bcs(numBCs*3);
<a name="l00912"></a>00912     
<a name="l00913"></a>00913       <span class="comment">//std::cout &lt;&lt; &quot;numBCs=&quot; &lt;&lt; numBCs &lt;&lt; std::endl;</span>
<a name="l00914"></a>00914     
<a name="l00915"></a>00915       <span class="comment">//std::cout &lt;&lt; &quot;Preparing to write boundary conditions.&quot; &lt;&lt; std::endl;</span>
<a name="l00916"></a>00916       std::vector&lt;unsigned int&gt; elem_list;
<a name="l00917"></a>00917       std::vector&lt;unsigned short int&gt; side_list;
<a name="l00918"></a>00918       std::vector&lt;short int&gt; elem_id_list;
<a name="l00919"></a>00919       
<a name="l00920"></a>00920       mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;build_side_list (elem_list, side_list, elem_id_list);
<a name="l00921"></a>00921     
<a name="l00922"></a>00922       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> ibc=0;  ibc&lt;numBCs; ibc++)
<a name="l00923"></a>00923         {
<a name="l00924"></a>00924           bcs[0+ibc*3] = elem_list[ibc];
<a name="l00925"></a>00925           bcs[1+ibc*3] = side_list[ibc];
<a name="l00926"></a>00926           bcs[2+ibc*3] = elem_id_list[ibc];
<a name="l00927"></a>00927         }
<a name="l00928"></a>00928     
<a name="l00929"></a>00929       <span class="comment">// Put the BCs in the XDR file</span>
<a name="l00930"></a>00930       m.<a class="code" href="classXdrMESH.php#a18a7b078c23683afbbcca8356eb71b9c">BC</a>(&amp;bcs[0], numBCs);
<a name="l00931"></a>00931     }
<a name="l00932"></a>00932 }
<a name="l00933"></a>00933 
<a name="l00934"></a>00934 
<a name="l00935"></a>00935 
<a name="l00936"></a><a class="code" href="classLegacyXdrIO.php#af8d29b7846f20381429c9a21acdceb0d">00936</a> <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#af8d29b7846f20381429c9a21acdceb0d">LegacyXdrIO::read_soln</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00937"></a>00937                              std::vector&lt;Real&gt;&amp; soln,
<a name="l00938"></a>00938                              std::vector&lt;std::string&gt;&amp; var_names)<span class="keyword"> const</span>
<a name="l00939"></a>00939 <span class="keyword"></span>{
<a name="l00940"></a>00940   <span class="comment">// Create an XdrSOLN object.</span>
<a name="l00941"></a>00941   <a class="code" href="classXdrSOLN.php">XdrSOLN</a> s;
<a name="l00942"></a>00942   
<a name="l00943"></a>00943   <span class="comment">// Create an XdrSHEAD object.</span>
<a name="l00944"></a>00944   <a class="code" href="classXdrSHEAD.php">XdrSHEAD</a> sh;
<a name="l00945"></a>00945   
<a name="l00946"></a>00946   <span class="comment">// Open the XDR file for</span>
<a name="l00947"></a>00947   <span class="comment">// reading or writing.</span>
<a name="l00948"></a>00948   <span class="comment">// Note 1: Provide an additional argument</span>
<a name="l00949"></a>00949   <span class="comment">// to specify the dimension.</span>
<a name="l00950"></a>00950   <span class="comment">//</span>
<a name="l00951"></a>00951   <span class="comment">// Note 2: Has to do the right thing for</span>
<a name="l00952"></a>00952   <span class="comment">// both binary and ASCII files.</span>
<a name="l00953"></a>00953   s.<a class="code" href="classXdrSOLN.php#a22d23b35b69a02078a0c219cba391aaa">init</a>((this-&gt;<a class="code" href="classLegacyXdrIO.php#ad4900c83e2a153a89012e9b27dda1d22">binary</a>() ? <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a2e25ec755026e9cc0d07a2773e908d1a">XdrMGF::DECODE</a> : <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759adec8f583f9a4a6a6d97dfb07f2f8ccd0">XdrMGF::R_ASCII</a>), name.c_str(), 0); <span class="comment">// mesh files are always number 0 ...</span>
<a name="l00954"></a>00954   
<a name="l00955"></a>00955   <span class="comment">// From here on, things depend</span>
<a name="l00956"></a>00956   <span class="comment">// on whether we are reading or</span>
<a name="l00957"></a>00957   <span class="comment">// writing!  First, we define</span>
<a name="l00958"></a>00958   <span class="comment">// header variables that may</span>
<a name="l00959"></a>00959   <span class="comment">// be read OR written.</span>
<a name="l00960"></a>00960   <span class="keywordtype">int</span>         numVar      = 0;       
<a name="l00961"></a>00961   <span class="keywordtype">int</span>         numNodes    = 0;
<a name="l00962"></a>00962   <span class="keyword">const</span> <span class="keywordtype">char</span>* varNames;
<a name="l00963"></a>00963         
<a name="l00964"></a>00964   <span class="comment">// Get the information from</span>
<a name="l00965"></a>00965   <span class="comment">// the header, and place it</span>
<a name="l00966"></a>00966   <span class="comment">// in the header pointer.</span>
<a name="l00967"></a>00967   s.<a class="code" href="classXdrSOLN.php#ad4068e5bfc6924804b2feaf3d090ba8b">header</a>(&amp;sh);
<a name="l00968"></a>00968         
<a name="l00969"></a>00969   <span class="comment">// Read information from the</span>
<a name="l00970"></a>00970   <span class="comment">// file header.  This depends on</span>
<a name="l00971"></a>00971   <span class="comment">// whether its a libMesh or MGF mesh.</span>
<a name="l00972"></a>00972   numVar   = sh.<a class="code" href="classXdrSHEAD.php#a536542364ba24a8dcdcfaa298f6097de">getWrtVar</a>();
<a name="l00973"></a>00973   numNodes = sh.<a class="code" href="classXdrHEAD.php#a2aa8f41b3f519596a0b5755aceb5956a">getNumNodes</a>();
<a name="l00974"></a>00974   varNames = sh.<a class="code" href="classXdrSHEAD.php#afc2ffddf806584f67384472a70b73520">getVarTitle</a>();
<a name="l00975"></a>00975         
<a name="l00976"></a>00976   <span class="comment">// Get the variable names</span>
<a name="l00977"></a>00977   {       
<a name="l00978"></a>00978     var_names.resize(numVar);
<a name="l00979"></a>00979     
<a name="l00980"></a>00980     <span class="keyword">const</span> <span class="keywordtype">char</span>* p = varNames;
<a name="l00981"></a>00981     
<a name="l00982"></a>00982     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;numVar; i++)
<a name="l00983"></a>00983       {
<a name="l00984"></a>00984         var_names[i] = p;
<a name="l00985"></a>00985         p += std::strlen(p) + 1;
<a name="l00986"></a>00986       }
<a name="l00987"></a>00987   }
<a name="l00988"></a>00988   
<a name="l00989"></a>00989   <span class="comment">// Read the soln vector</span>
<a name="l00990"></a>00990   soln.resize(numVar*numNodes);
<a name="l00991"></a>00991     
<a name="l00992"></a>00992   s.<a class="code" href="classXdrSOLN.php#ada56474bbd9746990ba43953ebf5429c">values</a>(&amp;soln[0], numNodes); 
<a name="l00993"></a>00993 }  
<a name="l00994"></a>00994 
<a name="l00995"></a>00995 
<a name="l00996"></a>00996 
<a name="l00997"></a><a class="code" href="classLegacyXdrIO.php#ad26b8b18265f7ee9f50e214e157ee560">00997</a> <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#ad26b8b18265f7ee9f50e214e157ee560">LegacyXdrIO::write_soln</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00998"></a>00998                               std::vector&lt;Real&gt;&amp; soln,
<a name="l00999"></a>00999                               std::vector&lt;std::string&gt;&amp; var_names)<span class="keyword"> const</span>
<a name="l01000"></a>01000 <span class="keyword"></span>{
<a name="l01001"></a>01001   <span class="comment">// get a read-only reference to the mesh</span>
<a name="l01002"></a>01002   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l01003"></a>01003   
<a name="l01004"></a>01004   <span class="comment">// Create an XdrSOLN object.</span>
<a name="l01005"></a>01005   <a class="code" href="classXdrSOLN.php">XdrSOLN</a> s;
<a name="l01006"></a>01006   
<a name="l01007"></a>01007   <span class="comment">// Create an XdrSHEAD object.</span>
<a name="l01008"></a>01008   <a class="code" href="classXdrSHEAD.php">XdrSHEAD</a> sh;
<a name="l01009"></a>01009   
<a name="l01010"></a>01010   <span class="comment">// Open the XDR file for</span>
<a name="l01011"></a>01011   <span class="comment">// reading or writing.</span>
<a name="l01012"></a>01012   <span class="comment">// Note 1: Provide an additional argument</span>
<a name="l01013"></a>01013   <span class="comment">// to specify the dimension.</span>
<a name="l01014"></a>01014   <span class="comment">//</span>
<a name="l01015"></a>01015   <span class="comment">// Note 2: Has to do the right thing for</span>
<a name="l01016"></a>01016   <span class="comment">// both binary and ASCII files.</span>
<a name="l01017"></a>01017   s.<a class="code" href="classXdrSOLN.php#a22d23b35b69a02078a0c219cba391aaa">init</a>((this-&gt;<a class="code" href="classLegacyXdrIO.php#ad4900c83e2a153a89012e9b27dda1d22">binary</a>() ? <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759aca15a85ac1052a9c12cd00c6a7c3bba6">XdrMGF::ENCODE</a> : <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a4abf31037aca9aabba9b65e45ebc4744">XdrMGF::W_ASCII</a>), name.c_str(), 0); <span class="comment">// mesh files are always number 0 ...</span>
<a name="l01018"></a>01018 
<a name="l01019"></a>01019   <span class="comment">// Build the header</span>
<a name="l01020"></a>01020   sh.<a class="code" href="classXdrSHEAD.php#ac1ee8b1325807cc78e859a100726c791">setWrtVar</a>(var_names.size());
<a name="l01021"></a>01021   sh.<a class="code" href="classXdrSHEAD.php#a8d8e7fa7f902b9ce3239ac545db2655a">setNumVar</a>(var_names.size());
<a name="l01022"></a>01022   sh.<a class="code" href="classXdrHEAD.php#a8433d0be6562374a41a361bb58e147d0">setNumNodes</a>(mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l01023"></a>01023   sh.<a class="code" href="classXdrHEAD.php#a2cdfac4576a940c9536e21e4a78b204c">setNumBCs</a>(mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;n_boundary_conds());
<a name="l01024"></a>01024   sh.<a class="code" href="classXdrSHEAD.php#afd9d6b86bb08867369586260b12bb830">setMeshCnt</a>(0);
<a name="l01025"></a>01025   sh.<a class="code" href="classXdrSHEAD.php#a30cd063356f04537535525986deea7f7">setKstep</a>(0);
<a name="l01026"></a>01026   sh.<a class="code" href="classXdrSHEAD.php#a70b93680f77b283bdd0f4c46b8268bdd">setTime</a>(0.);
<a name="l01027"></a>01027   sh.<a class="code" href="classXdrHEAD.php#aa4234fc2655312231e1596822b756bda">setStrSize</a>(65536);
<a name="l01028"></a>01028   sh.<a class="code" href="classXdrHEAD.php#aeb16debcad0ecb4eb73111d3b9094acf">setId</a>(<span class="stringliteral">&quot;Id String&quot;</span>);                       <span class="comment">// Ignored</span>
<a name="l01029"></a>01029   sh.<a class="code" href="classXdrHEAD.php#afb33d2828af0a74f460e0042cf5dc685">setTitle</a>(<span class="stringliteral">&quot;Title String&quot;</span>);          <span class="comment">// Ignored</span>
<a name="l01030"></a>01030   sh.<a class="code" href="classXdrSHEAD.php#ae68f13ec8401cf506f2bab34dab1fbda">setUserTitle</a>(<span class="stringliteral">&quot;User Title String&quot;</span>); <span class="comment">// Ignored</span>
<a name="l01031"></a>01031   
<a name="l01032"></a>01032   <span class="comment">// create the variable array</span>
<a name="l01033"></a>01033   {
<a name="l01034"></a>01034     std::string var_title;
<a name="l01035"></a>01035     
<a name="l01036"></a>01036     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;var_names.size(); var++)
<a name="l01037"></a>01037       {
<a name="l01038"></a>01038         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;var_names[var].size(); c++)
<a name="l01039"></a>01039           var_title += var_names[var][c];
<a name="l01040"></a>01040         
<a name="l01041"></a>01041         var_title += <span class="charliteral">&#39;\0&#39;</span>;
<a name="l01042"></a>01042       }
<a name="l01043"></a>01043     
<a name="l01044"></a>01044     sh.<a class="code" href="classXdrSHEAD.php#afca190cd39a17940e90d11016501361f">setVarTitle</a>(var_title.c_str(), var_title.size());
<a name="l01045"></a>01045   }
<a name="l01046"></a>01046   
<a name="l01047"></a>01047   <span class="comment">// Put the informationin the XDR file.</span>
<a name="l01048"></a>01048   s.<a class="code" href="classXdrSOLN.php#ad4068e5bfc6924804b2feaf3d090ba8b">header</a>(&amp;sh); <span class="comment">// Needs to work for both types of file</span>
<a name="l01049"></a>01049   
<a name="l01050"></a>01050   <span class="comment">// Write the solution vector</span>
<a name="l01051"></a>01051   libmesh_assert (soln.size() == var_names.size()*mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l01052"></a>01052   
<a name="l01053"></a>01053   s.<a class="code" href="classXdrSOLN.php#ada56474bbd9746990ba43953ebf5429c">values</a>(&amp;soln[0], mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l01054"></a>01054 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
