<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>legacy_xdr_io.h</h1>  </div>
</div>
<div class="contents">
<a href="legacy__xdr__io_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: legacy_xdr_io.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __legacy_xdr_io_io_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __legacy_xdr_io_io_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ inludes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="mesh__input_8h.php">mesh_input.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="mesh__output_8h.php">mesh_output.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Forward declarations</span>
<a name="l00033"></a>00033 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00034"></a>00034 <span class="keyword">class </span><a class="code" href="classMeshData.php">MeshData</a>;
<a name="l00035"></a>00035 
<a name="l00041"></a>00041 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00042"></a>00042 <span class="comment">// LegacyXdrIO class definition</span>
<a name="l00043"></a><a class="code" href="classLegacyXdrIO.php">00043</a> <span class="keyword">class </span><a class="code" href="classLegacyXdrIO.php">LegacyXdrIO</a> : <span class="keyword">public</span> <a class="code" href="classMeshInput.php">MeshInput</a>&lt;MeshBase&gt;,
<a name="l00044"></a>00044                     <span class="keyword">public</span> <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;MeshBase&gt;
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046 
<a name="l00047"></a>00047  <span class="keyword">public</span>:
<a name="l00055"></a><a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a96a3fe5321ff4768538d2481be42354d">00055</a>    <span class="keyword">enum</span> <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74">FileFormat</a> {<a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74acbf9879c924b6167238ec2dfbfbc861a">DEAL</a>=0, <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a96a3fe5321ff4768538d2481be42354d">MGF</a>=1, <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a866ae5a0308e85514de1abd617c8eb78">LIBM</a>=2};
<a name="l00056"></a>00056 
<a name="l00064"></a>00064   <a class="code" href="classLegacyXdrIO.php#a043f44decaacbdde9faed65875a38715">LegacyXdrIO</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp;,       <span class="keyword">const</span> <span class="keywordtype">bool</span>=<span class="keyword">false</span>);
<a name="l00065"></a>00065 
<a name="l00073"></a>00073   <a class="code" href="classLegacyXdrIO.php#a043f44decaacbdde9faed65875a38715">LegacyXdrIO</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp;, <span class="keyword">const</span> <span class="keywordtype">bool</span>=<span class="keyword">false</span>);
<a name="l00074"></a>00074   
<a name="l00078"></a>00078   <span class="keyword">virtual</span> <a class="code" href="classLegacyXdrIO.php#a4d1b3629253a77a11f161a80c1751210">~LegacyXdrIO</a> ();
<a name="l00079"></a>00079   
<a name="l00083"></a>00083   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#aafa2ae95dcc72c51d3aad725db09cb73">read</a> (<span class="keyword">const</span> std::string&amp;);
<a name="l00084"></a>00084   
<a name="l00089"></a>00089   <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#ac4fde91354bab98a9a551c029ce51e0d">read_mgf</a> (<span class="keyword">const</span> std::string&amp;);
<a name="l00090"></a>00090   
<a name="l00094"></a>00094   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#a49f322f1ff1b7d8a1051b474d23d0cbf">write</a> (<span class="keyword">const</span> std::string&amp;);
<a name="l00095"></a>00095   
<a name="l00100"></a>00100   <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#ab5369cabc6b2cc585e679efb89fad931">write_mgf</a> (<span class="keyword">const</span> std::string&amp;);
<a name="l00101"></a>00101     
<a name="l00112"></a>00112   <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#ab3eb0210e8a678c833025db13d1c1a96">read_mgf_soln</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00113"></a>00113                       std::vector&lt;Number&gt;&amp; soln,
<a name="l00114"></a>00114                       std::vector&lt;std::string&gt;&amp; var_names) <span class="keyword">const</span>;
<a name="l00115"></a>00115     
<a name="l00125"></a>00125   <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#a0cf218a0c650c782f061d07941b48518">write_mgf_soln</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00126"></a>00126                        std::vector&lt;Number&gt;&amp; soln,
<a name="l00127"></a>00127                        std::vector&lt;std::string&gt;&amp; var_names) <span class="keyword">const</span>;  
<a name="l00128"></a>00128 
<a name="l00132"></a>00132   <span class="keywordtype">bool</span> &amp; <a class="code" href="classLegacyXdrIO.php#ad4900c83e2a153a89012e9b27dda1d22">binary</a>();
<a name="l00133"></a>00133 
<a name="l00137"></a>00137   <span class="keywordtype">bool</span> <a class="code" href="classLegacyXdrIO.php#ad4900c83e2a153a89012e9b27dda1d22">binary</a>() <span class="keyword">const</span>;
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   
<a name="l00140"></a>00140  <span class="keyword">private</span>:
<a name="l00141"></a>00141 
<a name="l00148"></a>00148   <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#a423f2d95e163542f48cdc8db4dca4aff">read_ascii</a> (<span class="keyword">const</span> std::string&amp;, <span class="keyword">const</span> <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74">LegacyXdrIO::FileFormat</a> = <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a866ae5a0308e85514de1abd617c8eb78">LegacyXdrIO::LIBM</a>);
<a name="l00149"></a>00149 
<a name="l00156"></a>00156   <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#a45ed48aaa6877ef96569c8916a328803">read_binary</a> (<span class="keyword">const</span> std::string&amp;, <span class="keyword">const</span> <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74">LegacyXdrIO::FileFormat</a> = <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a866ae5a0308e85514de1abd617c8eb78">LegacyXdrIO::LIBM</a>);
<a name="l00157"></a>00157 
<a name="l00158"></a>00158   
<a name="l00159"></a>00159   
<a name="l00169"></a>00169   <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#a872c22bba97f17d7db31580645e88617">write_ascii</a> (<span class="keyword">const</span> std::string&amp;, <span class="keyword">const</span> <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74">LegacyXdrIO::FileFormat</a> = <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a866ae5a0308e85514de1abd617c8eb78">LegacyXdrIO::LIBM</a>);
<a name="l00170"></a>00170 
<a name="l00177"></a>00177   <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#aaf353eb0f0fcddf5da48a382f6610eed">write_binary</a> (<span class="keyword">const</span> std::string&amp;, <span class="keyword">const</span> <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74">LegacyXdrIO::FileFormat</a> = <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a866ae5a0308e85514de1abd617c8eb78">LegacyXdrIO::LIBM</a>);
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 
<a name="l00183"></a>00183   <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#a0c89c01f05c74d6d887450ebcac8fb1a">read_mesh</a> (<span class="keyword">const</span> std::string&amp;,
<a name="l00184"></a>00184                   <span class="keyword">const</span> <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74">LegacyXdrIO::FileFormat</a> = <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a866ae5a0308e85514de1abd617c8eb78">LegacyXdrIO::LIBM</a>,
<a name="l00185"></a>00185                   <a class="code" href="classMeshData.php">MeshData</a>* = NULL);
<a name="l00186"></a>00186 
<a name="l00190"></a>00190   <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#a92c47baf2df593f9aa21b33f8d5f7913">write_mesh</a> (<span class="keyword">const</span> std::string&amp;,
<a name="l00191"></a>00191                    <span class="keyword">const</span> <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74">LegacyXdrIO::FileFormat</a> = <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74a866ae5a0308e85514de1abd617c8eb78">LegacyXdrIO::LIBM</a>);
<a name="l00192"></a>00192 
<a name="l00196"></a>00196   <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#af8d29b7846f20381429c9a21acdceb0d">read_soln</a>  (<span class="keyword">const</span> std::string&amp;,
<a name="l00197"></a>00197                    std::vector&lt;Real&gt;&amp;,
<a name="l00198"></a>00198                    std::vector&lt;std::string&gt;&amp;) <span class="keyword">const</span>;
<a name="l00199"></a>00199   
<a name="l00203"></a>00203   <span class="keywordtype">void</span> <a class="code" href="classLegacyXdrIO.php#ad26b8b18265f7ee9f50e214e157ee560">write_soln</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00204"></a>00204                    std::vector&lt;Real&gt;&amp; soln,
<a name="l00205"></a>00205                    std::vector&lt;std::string&gt;&amp;) <span class="keyword">const</span>;
<a name="l00206"></a>00206 
<a name="l00207"></a>00207   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00208"></a>00208   <span class="comment">// local data</span>
<a name="l00209"></a>00209 
<a name="l00213"></a><a class="code" href="classLegacyXdrIO.php#a96cf29161be5981211481dbf22977cbb">00213</a>   <span class="keywordtype">bool</span> <a class="code" href="classLegacyXdrIO.php#a96cf29161be5981211481dbf22977cbb">_binary</a>;
<a name="l00214"></a>00214 };
<a name="l00215"></a>00215 
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 
<a name="l00220"></a>00220 
<a name="l00221"></a>00221 <span class="preprocessor">#endif // #define __legacy_xdr_io.h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
