<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_a444518d96d2df902338d2a7eb3a040c.php">base</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>libmesh.h</h1>  </div>
</div>
<div class="contents">
<a href="libmesh_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: libmesh.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __libmesh_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __libmesh_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__base_8h.php">libmesh_base.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;perf_log.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;enum_solver_package.h&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// Forward declaration, required when included</span>
<a name="l00037"></a>00037 <span class="comment">// in perf_log.{C,h} because the preceeding</span>
<a name="l00038"></a>00038 <span class="comment">// #include &quot;perf_log.h&quot; is ineffective.</span>
<a name="l00039"></a>00039 <span class="comment">// Multiple inclusion avoidance problem...</span>
<a name="l00040"></a>00040 <span class="comment">// __perf_log_h__ already #define&#39;d, but the</span>
<a name="l00041"></a>00041 <span class="comment">// class has not been declared yet!.</span>
<a name="l00042"></a>00042 <span class="keyword">class </span><a class="code" href="classPerfLog.php">PerfLog</a>;
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00057"></a><a class="code" href="classLibMeshInit.php">00057</a> <span class="keyword">class </span><a class="code" href="classLibMeshInit.php">LibMeshInit</a>
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059 <span class="keyword">public</span>:
<a name="l00060"></a>00060 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00061"></a>00061 <span class="preprocessor"></span>
<a name="l00068"></a>00068   <a class="code" href="classLibMeshInit.php#add6b58803b50693f2a7456e53299b567">LibMeshInit</a>(<span class="keywordtype">int</span> &amp; argc, <span class="keywordtype">char</span>** &amp; <a class="code" href="namespacelibMesh.php#a417881714cb540579a186977f22143a2">argv</a>,
<a name="l00069"></a>00069               MPI_Comm COMM_WORLD_IN=MPI_COMM_WORLD);
<a name="l00070"></a>00070 <span class="preprocessor">#else</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span>  <a class="code" href="classLibMeshInit.php#add6b58803b50693f2a7456e53299b567">LibMeshInit</a>(<span class="keywordtype">int</span> &amp; argc, <span class="keywordtype">char</span>** &amp; argv);
<a name="l00072"></a>00072 <span class="preprocessor">#endif</span>
<a name="l00073"></a>00073 <span class="preprocessor"></span>        
<a name="l00074"></a>00074   <a class="code" href="classLibMeshInit.php#a6359955a36bb80820be9aeab2378df08">~LibMeshInit</a>();
<a name="l00075"></a>00075 };
<a name="l00076"></a>00076 
<a name="l00085"></a>00085 <span class="keyword">namespace </span>libMesh {
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 <span class="preprocessor">#ifndef LIBMESH_HAVE_MPI</span>
<a name="l00088"></a>00088 <span class="preprocessor"></span>  
<a name="l00097"></a>00097   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> (<span class="keywordtype">int</span> &amp; argc, <span class="keywordtype">char</span>** &amp; <a class="code" href="namespacelibMesh.php#a417881714cb540579a186977f22143a2">argv</a>);
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 <span class="preprocessor">#else</span>
<a name="l00100"></a>00100 <span class="preprocessor"></span>  
<a name="l00110"></a>00110   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> (<span class="keywordtype">int</span> &amp; argc, <span class="keywordtype">char</span>** &amp; <a class="code" href="namespacelibMesh.php#a417881714cb540579a186977f22143a2">argv</a>,
<a name="l00111"></a>00111              MPI_Comm COMM_WORLD_IN=MPI_COMM_WORLD);
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 <span class="preprocessor">#endif</span>
<a name="l00114"></a>00114 <span class="preprocessor"></span>
<a name="l00121"></a>00121   <span class="keywordtype">bool</span> <a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a> ();
<a name="l00122"></a>00122   
<a name="l00135"></a>00135   <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh.php#a6e41d4c43a417f7b9e20302af9736247">close</a> ();
<a name="l00136"></a>00136 
<a name="l00143"></a>00143   <span class="keywordtype">bool</span> <a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a> ();
<a name="l00144"></a>00144   
<a name="l00149"></a>00149   <span class="keyword">extern</span> <a class="code" href="classPerfLog.php">PerfLog</a> <a class="code" href="namespacelibMesh.php#a596320f881a18177dbac88a97bab807e">perflog</a>;
<a name="l00150"></a>00150 
<a name="l00155"></a>00155   <span class="keywordtype">bool</span> <a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">on_command_line</a> (<span class="keyword">const</span> std::string&amp; arg);  
<a name="l00156"></a>00156 
<a name="l00161"></a>00161   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00162"></a>00162   T <a class="code" href="namespacelibMesh.php#a7cbd0ce3d26eb45284882fed440b2a09">command_line_value</a> (<span class="keyword">const</span> std::string &amp;, T);  
<a name="l00163"></a>00163 
<a name="l00167"></a>00167 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00168"></a>00168 <span class="preprocessor"></span>  <span class="keyword">extern</span> <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="namespacelibMesh.php#aa2cea1b0dff98dcda202f98174e7135d">imaginary</a>;
<a name="l00169"></a>00169 <span class="preprocessor">#endif</span>
<a name="l00170"></a>00170 <span class="preprocessor"></span>
<a name="l00179"></a>00179   <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> <a class="code" href="namespacelibMesh.php#a496c62248223cd940c7715932dd0dc2d">default_solver_package</a> ();
<a name="l00180"></a>00180 
<a name="l00184"></a>00184   <span class="keyword">extern</span> <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">pi</a>;
<a name="l00185"></a>00185 
<a name="l00189"></a>00189   <span class="keyword">extern</span> <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a>;
<a name="l00190"></a>00190 
<a name="l00195"></a>00195   <span class="keyword">extern</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a>;
<a name="l00196"></a>00196   
<a name="l00204"></a><a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php">00204</a>   <span class="keyword">namespace </span>libMeshPrivateData {
<a name="l00205"></a>00205     
<a name="l00209"></a>00209     <span class="keyword">extern</span> <span class="keywordtype">bool</span> <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a>;
<a name="l00210"></a>00210     
<a name="l00214"></a>00214     <span class="keyword">extern</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#a5595417b69d598a65c439048450f6d02">_solver_package</a>;
<a name="l00215"></a>00215   }
<a name="l00216"></a>00216 }
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 
<a name="l00220"></a>00220 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00221"></a>00221 <span class="comment">// libMesh inline member functions</span>
<a name="l00222"></a>00222 <span class="keyword">inline</span>
<a name="l00223"></a><a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">00223</a> <span class="keywordtype">bool</span> <a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">libMesh::initialized</a>()
<a name="l00224"></a>00224 {
<a name="l00225"></a>00225   <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">libMeshPrivateData::_is_initialized</a>;
<a name="l00226"></a>00226 }
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 <span class="keyword">inline</span>
<a name="l00231"></a><a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">00231</a> <span class="keywordtype">bool</span> <a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">libMesh::closed</a>()
<a name="l00232"></a>00232 {
<a name="l00233"></a>00233   <span class="keywordflow">return</span> !<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">libMesh::initialized</a>();
<a name="l00234"></a>00234 }
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 
<a name="l00238"></a>00238 <span class="preprocessor">#endif // #define __libmesh_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
