<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_a444518d96d2df902338d2a7eb3a040c.php">base</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>libmesh_common.h</h1>  </div>
</div>
<div class="contents">
<a href="libmesh__common_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: libmesh_common.h 3502 2009-10-20 18:06:50Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __libmesh_common_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __libmesh_common_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// The library configuration options</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Include the MPI definition</span>
<a name="l00030"></a>00030 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor"># include &lt;mpi.h&gt;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#endif</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span>
<a name="l00034"></a>00034 <span class="comment">// C/C++ includes everyone should know about</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &lt;iostream&gt;</span> <span class="comment">// needed for std::cout, std::cerr</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &lt;fstream&gt;</span> <span class="comment">// needed for argument to print_trace()</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &lt;unistd.h&gt;</span>  <span class="comment">// needed for getpid()</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &lt;complex&gt;</span>
<a name="l00039"></a>00039 <span class="comment">// #include &lt;cassert&gt;  // Use libmesh_assert() now</span>
<a name="l00040"></a>00040 <span class="preprocessor">#ifdef LIBMESH_HAVE_STDLIB_H</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span><span class="preprocessor"># include &lt;cstdlib&gt;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#endif</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span><span class="preprocessor">#include &lt;typeinfo&gt;</span> <span class="comment">// std::bad_cast</span>
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="comment">// _basic_ library functionality</span>
<a name="l00046"></a>00046 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__base_8h.php">libmesh_base.h</a>&quot;</span>
<a name="l00047"></a>00047 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__exceptions_8h.php">libmesh_exceptions.h</a>&quot;</span>
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="preprocessor">#ifdef LIBMESH_ENABLE_TRACEFILES</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span><span class="preprocessor">#  include &quot;<a class="code" href="print__trace_8h.php">print_trace.h</a>&quot;</span>
<a name="l00051"></a>00051 <span class="preprocessor">#endif</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span>
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 <span class="comment">// Undefine any existing macros</span>
<a name="l00058"></a>00058 <span class="preprocessor">#ifdef Real</span>
<a name="l00059"></a>00059 <span class="preprocessor"></span><span class="preprocessor">#  undef Real</span>
<a name="l00060"></a>00060 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00061"></a>00061 <span class="preprocessor"></span>
<a name="l00062"></a>00062 <span class="comment">//#ifdef REAL</span>
<a name="l00063"></a>00063 <span class="comment">//#  undef REAL</span>
<a name="l00064"></a>00064 <span class="comment">//#endif</span>
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 <span class="preprocessor">#ifdef Complex</span>
<a name="l00067"></a>00067 <span class="preprocessor"></span><span class="preprocessor">#  undef Complex</span>
<a name="l00068"></a>00068 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00069"></a>00069 <span class="preprocessor"></span>
<a name="l00070"></a>00070 <span class="preprocessor">#ifdef COMPLEX</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span><span class="preprocessor">#  undef COMPLEX</span>
<a name="l00072"></a>00072 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00073"></a>00073 <span class="preprocessor"></span>
<a name="l00074"></a>00074 <span class="preprocessor">#ifdef MPI_REAL</span>
<a name="l00075"></a>00075 <span class="preprocessor"></span><span class="preprocessor">#  undef MPI_REAL</span>
<a name="l00076"></a>00076 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00077"></a>00077 <span class="preprocessor"></span>
<a name="l00078"></a>00078 <span class="comment">// Check to see if TOLERANCE has been defined by another</span>
<a name="l00079"></a>00079 <span class="comment">// package, if so we might want to change the name...</span>
<a name="l00080"></a>00080 <span class="preprocessor">#ifdef TOLERANCE</span>
<a name="l00081"></a>00081 <span class="preprocessor"></span>   DIE A HORRIBLE DEATH HERE...
<a name="l00082"></a>00082 #  undef TOLERANCE
<a name="l00083"></a>00083 <span class="preprocessor">#endif</span>
<a name="l00084"></a>00084 <span class="preprocessor"></span>
<a name="l00085"></a>00085 
<a name="l00086"></a>00086    
<a name="l00087"></a>00087 <span class="comment">// Define the type to use for real numbers</span>
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 <span class="preprocessor">#define DOUBLE_PRECISION</span>
<a name="l00090"></a>00090 <span class="preprocessor"></span>
<a name="l00091"></a>00091 <span class="comment">// Define a corresponding tolerance.  This is what should be</span>
<a name="l00092"></a>00092 <span class="comment">// considered &quot;good enough&quot; when doing floating point comparisons.</span>
<a name="l00093"></a>00093 <span class="comment">// For example, v == 0 is changed to std::abs(v) &lt; TOLERANCE.</span>
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 <span class="preprocessor">#ifndef SINGLE_PRECISION</span>
<a name="l00096"></a>00096 <span class="preprocessor"></span><span class="preprocessor">  #ifdef TRIPLE_PRECISION</span>
<a name="l00097"></a><a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">00097</a> <span class="preprocessor"></span>    <span class="keyword">typedef</span> <span class="keywordtype">long</span> <span class="keywordtype">double</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>;
<a name="l00098"></a>00098 <span class="preprocessor">  # define TOLERANCE 1.e-8</span>
<a name="l00099"></a>00099 <span class="preprocessor"></span><span class="preprocessor">  # define MPI_REAL MPI_LONG_DOUBLE</span>
<a name="l00100"></a>00100 <span class="preprocessor"></span><span class="preprocessor">  #else</span>
<a name="l00101"></a>00101 <span class="preprocessor"></span>    <span class="keyword">typedef</span> <span class="keywordtype">double</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>;
<a name="l00102"></a>00102 <span class="preprocessor">  # define TOLERANCE 1.e-6</span>
<a name="l00103"></a>00103 <span class="preprocessor"></span><span class="preprocessor">  # define MPI_REAL MPI_DOUBLE</span>
<a name="l00104"></a>00104 <span class="preprocessor"></span><span class="preprocessor">  #endif</span>
<a name="l00105"></a>00105 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00106"></a>00106 <span class="preprocessor"></span>  <span class="keyword">typedef</span> <span class="keywordtype">float</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>;
<a name="l00107"></a>00107 <span class="preprocessor">  # define TOLERANCE 1.e-3</span>
<a name="l00108"></a>00108 <span class="preprocessor"></span><span class="preprocessor">  # define MPI_REAL MPI_FLOAT</span>
<a name="l00109"></a>00109 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00110"></a>00110 <span class="preprocessor"></span>
<a name="l00111"></a>00111 <span class="comment">// For some reason the real std::max, std::min</span>
<a name="l00112"></a>00112 <span class="comment">// don&#39;t handle mixed compatible types</span>
<a name="l00113"></a><a class="code" href="namespacestd.php">00113</a> <span class="keyword">namespace </span>std {
<a name="l00114"></a><a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">00114</a>   <span class="keyword">inline</span> <span class="keywordtype">long</span> <span class="keywordtype">double</span> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(<span class="keywordtype">long</span> <span class="keywordtype">double</span> a, <span class="keywordtype">double</span> b)
<a name="l00115"></a>00115   { <span class="keywordflow">return</span> (a&gt;b?a:b); }
<a name="l00116"></a><a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">00116</a>   <span class="keyword">inline</span> <span class="keywordtype">long</span> <span class="keywordtype">double</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(<span class="keywordtype">long</span> <span class="keywordtype">double</span> a, <span class="keywordtype">double</span> b)
<a name="l00117"></a>00117   { <span class="keywordflow">return</span> (a&lt;b?a:b); }
<a name="l00118"></a>00118 
<a name="l00119"></a><a class="code" href="namespacestd.php#a33d9bf3e5ca74fc83b90511e690984b8">00119</a>   <span class="keyword">inline</span> <span class="keywordtype">long</span> <span class="keywordtype">double</span> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(<span class="keywordtype">double</span> a, <span class="keywordtype">long</span> <span class="keywordtype">double</span> b)
<a name="l00120"></a>00120   { <span class="keywordflow">return</span> (a&gt;b?a:b); }
<a name="l00121"></a><a class="code" href="namespacestd.php#ae3946667b8ebc6ec27bd5e0efa1d9737">00121</a>   <span class="keyword">inline</span> <span class="keywordtype">long</span> <span class="keywordtype">double</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(<span class="keywordtype">double</span> a, <span class="keywordtype">long</span> <span class="keywordtype">double</span> b)
<a name="l00122"></a>00122   { <span class="keywordflow">return</span> (a&lt;b?a:b); }
<a name="l00123"></a>00123 
<a name="l00124"></a><a class="code" href="namespacestd.php#ac84527deb5aca9e85f8329d851955e79">00124</a>   <span class="keyword">inline</span> <span class="keywordtype">double</span> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(<span class="keywordtype">double</span> a, <span class="keywordtype">float</span> b)
<a name="l00125"></a>00125   { <span class="keywordflow">return</span> (a&gt;b?a:b); }
<a name="l00126"></a><a class="code" href="namespacestd.php#a6607fe77c40dd42e1ebf2d57bf13b959">00126</a>   <span class="keyword">inline</span> <span class="keywordtype">double</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(<span class="keywordtype">double</span> a, <span class="keywordtype">float</span> b)
<a name="l00127"></a>00127   { <span class="keywordflow">return</span> (a&lt;b?a:b); }
<a name="l00128"></a>00128 
<a name="l00129"></a><a class="code" href="namespacestd.php#ac7d047890b66decdabc8b0dbd592601f">00129</a>   <span class="keyword">inline</span> <span class="keywordtype">double</span> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(<span class="keywordtype">float</span> a, <span class="keywordtype">double</span> b)
<a name="l00130"></a>00130   { <span class="keywordflow">return</span> (a&gt;b?a:b); }
<a name="l00131"></a><a class="code" href="namespacestd.php#a0ae76aafe42e114852df0231e865e058">00131</a>   <span class="keyword">inline</span> <span class="keywordtype">double</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(<span class="keywordtype">float</span> a, <span class="keywordtype">double</span> b)
<a name="l00132"></a>00132   { <span class="keywordflow">return</span> (a&lt;b?a:b); }
<a name="l00133"></a>00133 
<a name="l00134"></a><a class="code" href="namespacestd.php#a79b5de6915f33bf1a3bfc7fbaed59522">00134</a>   <span class="keyword">inline</span> <span class="keywordtype">long</span> <span class="keywordtype">double</span> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(<span class="keywordtype">long</span> <span class="keywordtype">double</span> a, <span class="keywordtype">float</span> b)
<a name="l00135"></a>00135   { <span class="keywordflow">return</span> (a&gt;b?a:b); }
<a name="l00136"></a><a class="code" href="namespacestd.php#a004c7feab71987219d4a4c0674626533">00136</a>   <span class="keyword">inline</span> <span class="keywordtype">long</span> <span class="keywordtype">double</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(<span class="keywordtype">long</span> <span class="keywordtype">double</span> a, <span class="keywordtype">float</span> b)
<a name="l00137"></a>00137   { <span class="keywordflow">return</span> (a&lt;b?a:b); }
<a name="l00138"></a>00138 
<a name="l00139"></a><a class="code" href="namespacestd.php#a534434eadd7a712522181b7901b1d797">00139</a>   <span class="keyword">inline</span> <span class="keywordtype">long</span> <span class="keywordtype">double</span> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(<span class="keywordtype">float</span> a, <span class="keywordtype">long</span> <span class="keywordtype">double</span> b)
<a name="l00140"></a>00140   { <span class="keywordflow">return</span> (a&gt;b?a:b); }
<a name="l00141"></a><a class="code" href="namespacestd.php#a3957c2be1f5ac7339eb933c8cbcf41e0">00141</a>   <span class="keyword">inline</span> <span class="keywordtype">long</span> <span class="keywordtype">double</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(<span class="keywordtype">float</span> a, <span class="keywordtype">long</span> <span class="keywordtype">double</span> b)
<a name="l00142"></a>00142   { <span class="keywordflow">return</span> (a&lt;b?a:b); }
<a name="l00143"></a>00143 }
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 <span class="comment">// Define the type to use for complex numbers</span>
<a name="l00146"></a>00146 <span class="comment">// Always use std::complex&lt;double&gt;, as required by Petsc</span>
<a name="l00147"></a><a class="code" href="libmesh__common_8h.php#a400479783e355a94cc961fb30b81b31f">00147</a> <span class="keyword">typedef</span> std::complex&lt;double&gt; <a class="code" href="libmesh__common_8h.php#a400479783e355a94cc961fb30b81b31f">Complex</a>;
<a name="l00148"></a><a class="code" href="libmesh__common_8h.php#aeb7a51d53eae6b506572efff8dc8204d">00148</a> <span class="keyword">typedef</span> std::complex&lt;double&gt; <a class="code" href="libmesh__common_8h.php#aeb7a51d53eae6b506572efff8dc8204d">COMPLEX</a>;
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 <span class="comment">// Helper functions for complex/real numbers</span>
<a name="l00152"></a>00152 <span class="comment">// to clean up #ifdef LIBMESH_USE_COMPLEX_NUMBERS elsewhere</span>
<a name="l00153"></a><a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">00153</a> <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt; <span class="keyword">inline</span> T <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>(T a) { <span class="keywordflow">return</span> a; }
<a name="l00154"></a><a class="code" href="libmesh__common_8h.php#af9cdd07341b53cc644199f6aec5e1420">00154</a> <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt; <span class="keyword">inline</span> T <a class="code" href="libmesh__common_8h.php#af9cdd07341b53cc644199f6aec5e1420">libmesh_norm</a>(T a) { <span class="keywordflow">return</span> a*a; }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00157"></a><a class="code" href="libmesh__common_8h.php#ae009c013b0ebb8e21c93fd4c4d3ed357">00157</a> <span class="keyword">inline</span> T <a class="code" href="libmesh__common_8h.php#a8c11facf4521382675d9dbb93a349a78">libmesh_real</a>(std::complex&lt;T&gt; a) { <span class="keywordflow">return</span> std::real(a); }
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00160"></a><a class="code" href="libmesh__common_8h.php#a06ebe95ed0f01f24191c82e546859f9d">00160</a> <span class="keyword">inline</span> T <a class="code" href="libmesh__common_8h.php#af9cdd07341b53cc644199f6aec5e1420">libmesh_norm</a>(std::complex&lt;T&gt; a) { <span class="keywordflow">return</span> std::norm(a); }
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 <span class="comment">// Define the value type for unknowns in simulations.</span>
<a name="l00164"></a>00164 <span class="comment">// This is either Real or Complex, depending on how</span>
<a name="l00165"></a>00165 <span class="comment">// the library was configures</span>
<a name="l00166"></a>00166 <span class="preprocessor">#if   defined (LIBMESH_USE_REAL_NUMBERS)</span>
<a name="l00167"></a><a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">00167</a> <span class="preprocessor"></span>  <span class="keyword">typedef</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>;
<a name="l00168"></a>00168 <span class="preprocessor">#elif defined (LIBMESH_USE_COMPLEX_NUMBERS)</span>
<a name="l00169"></a>00169 <span class="preprocessor"></span>  <span class="keyword">typedef</span> <a class="code" href="libmesh__common_8h.php#a400479783e355a94cc961fb30b81b31f">Complex</a> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>;
<a name="l00170"></a>00170 <span class="preprocessor">#else</span>
<a name="l00171"></a>00171 <span class="preprocessor"></span>  DIE A HORRIBLE DEATH HERE...
<a name="l00172"></a>00172 #endif
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 <span class="comment">// Define the value type for error estimates.</span>
<a name="l00176"></a>00176 <span class="comment">// Since AMR/C decisions don&#39;t have to be precise,</span>
<a name="l00177"></a>00177 <span class="comment">// we default to float for memory efficiency.</span>
<a name="l00178"></a><a class="code" href="libmesh__common_8h.php#a4fde6363fef26bb083463d8f7b40ab22">00178</a> <span class="keyword">typedef</span> <span class="keywordtype">float</span> <a class="code" href="libmesh__common_8h.php#a4fde6363fef26bb083463d8f7b40ab22">ErrorVectorReal</a>;
<a name="l00179"></a>00179 <span class="preprocessor">#define MPI_ERRORVECTORREAL MPI_FLOAT</span>
<a name="l00180"></a>00180 <span class="preprocessor"></span>
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00183"></a>00183 <span class="preprocessor"></span><span class="keyword">namespace </span>libMesh
<a name="l00184"></a>00184 {
<a name="l00188"></a>00188   <span class="keyword">extern</span> MPI_Comm <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">COMM_WORLD</a>;
<a name="l00189"></a>00189 }
<a name="l00190"></a>00190 <span class="preprocessor">#endif</span>
<a name="l00191"></a>00191 <span class="preprocessor"></span>
<a name="l00192"></a>00192 <span class="comment">// These are useful macros that behave like functions in the code.</span>
<a name="l00193"></a>00193 <span class="comment">// If you want to make sure you are accessing a section of code just</span>
<a name="l00194"></a>00194 <span class="comment">// stick a libmesh_here(); in it, for example</span>
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 <span class="preprocessor">#define libmesh_here()     do { std::cerr &lt;&lt; &quot;[&quot; &lt;&lt; libMesh::processor_id() &lt;&lt; &quot;] &quot; &lt;&lt; __FILE__ &lt;&lt; &quot;, line &quot; &lt;&lt; __LINE__ &lt;&lt; &quot;, compiled &quot; &lt;&lt; __DATE__ &lt;&lt; &quot; at &quot; &lt;&lt; __TIME__ &lt;&lt; std::endl; } while (0)</span>
<a name="l00197"></a>00197 <span class="preprocessor"></span>
<a name="l00198"></a>00198 <span class="comment">// the libmesh_stop() macro will stop the code until a SIGCONT signal</span>
<a name="l00199"></a>00199 <span class="comment">// is recieved.  This is useful, for example, when determining the</span>
<a name="l00200"></a>00200 <span class="comment">// memory used by a given operation.  A libmesh_stop() could be</span>
<a name="l00201"></a>00201 <span class="comment">// instered before and after a questionable operation and the delta</span>
<a name="l00202"></a>00202 <span class="comment">// memory can be obtained from a ps or top.  This macro only works for</span>
<a name="l00203"></a>00203 <span class="comment">// serial cases.</span>
<a name="l00204"></a>00204 <span class="preprocessor">#ifdef LIBMESH_HAVE_CSIGNAL</span>
<a name="l00205"></a>00205 <span class="preprocessor"></span><span class="preprocessor">#  include &lt;csignal&gt;</span>
<a name="l00206"></a>00206 <span class="preprocessor">#  define libmesh_stop()     do { if (libMesh::n_processors() == 1) { libmesh_here(); std::cout &lt;&lt; &quot;Stopping process &quot; &lt;&lt; getpid() &lt;&lt; &quot;...&quot; &lt;&lt; std::endl; std::raise(SIGSTOP); std::cout &lt;&lt; &quot;Continuing process &quot; &lt;&lt; getpid() &lt;&lt; &quot;...&quot; &lt;&lt; std::endl; } } while(0)</span>
<a name="l00207"></a>00207 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00208"></a>00208 <span class="preprocessor"></span><span class="preprocessor">#  define libmesh_stop()     do { if (libMesh::n_processors() == 1) { libmesh_here(); std::cerr &lt;&lt; &quot;WARNING:  libmesh_stop() does not work without the &lt;csignal&gt; header file!&quot; &lt;&lt; std::endl; } } while(0)</span>
<a name="l00209"></a>00209 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00210"></a>00210 <span class="preprocessor"></span>
<a name="l00211"></a>00211 <span class="comment">// The libmesh_assert() macro acts like C&#39;s assert(), but throws a </span>
<a name="l00212"></a>00212 <span class="comment">// libmesh_error() (including stack trace, etc) instead of just exiting</span>
<a name="l00213"></a>00213 <span class="preprocessor">#ifdef NDEBUG</span>
<a name="l00214"></a>00214 <span class="preprocessor"></span><span class="preprocessor">#define libmesh_assert(asserted) </span>
<a name="l00215"></a>00215 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00216"></a>00216 <span class="preprocessor"></span><span class="preprocessor">#define libmesh_assert(asserted)  do { if (!(asserted)) { std::cerr &lt;&lt; &quot;Assertion `&quot; #asserted &quot;&#39; failed.&quot; &lt;&lt; std::endl; libmesh_error(); } } while(0)</span>
<a name="l00217"></a>00217 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00218"></a>00218 <span class="preprocessor"></span>
<a name="l00219"></a>00219 <span class="comment">// The libmesh_write_traceout() macro writes stack trace files, if</span>
<a name="l00220"></a>00220 <span class="comment">// that feature has been configured.</span>
<a name="l00221"></a>00221 <span class="preprocessor">#ifdef LIBMESH_ENABLE_TRACEFILES</span>
<a name="l00222"></a>00222 <span class="preprocessor"></span><span class="preprocessor">  #define libmesh_write_traceout()   do { std::stringstream outname; outname &lt;&lt; &quot;traceout_&quot; &lt;&lt; libMesh::processor_id() &lt;&lt; &#39;_&#39; &lt;&lt; getpid() &lt;&lt; &quot;.txt&quot;; std::ofstream traceout(outname.str().c_str()); print_trace(traceout); } while(0)</span>
<a name="l00223"></a>00223 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00224"></a>00224 <span class="preprocessor"></span><span class="preprocessor">  #define libmesh_write_traceout()   do { } while (0)</span>
<a name="l00225"></a>00225 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00226"></a>00226 <span class="preprocessor"></span>
<a name="l00227"></a>00227 <span class="comment">// The libmesh_error() macro prints a message and throws a LogicError</span>
<a name="l00228"></a>00228 <span class="comment">// exception</span>
<a name="l00229"></a>00229 <span class="comment">//</span>
<a name="l00230"></a>00230 <span class="comment">// The libmesh_not_implemented() macro prints a message and throws a</span>
<a name="l00231"></a>00231 <span class="comment">// NotImplemented exception</span>
<a name="l00232"></a>00232 <span class="comment">//</span>
<a name="l00233"></a>00233 <span class="comment">// The libmesh_file_error(const std::string&amp; filename) macro prints a message</span>
<a name="l00234"></a>00234 <span class="comment">// and throws a FileError exception</span>
<a name="l00235"></a>00235 <span class="comment">//</span>
<a name="l00236"></a>00236 <span class="comment">// The libmesh_convergence_failure() macro prints a message</span>
<a name="l00237"></a>00237 <span class="comment">// and throws a ConvergenceFailure exception</span>
<a name="l00238"></a>00238 <span class="preprocessor">#define libmesh_error()    do { libmesh_write_traceout(); libmesh_here(); LIBMESH_THROW(libMesh::LogicError()); } while(0)</span>
<a name="l00239"></a>00239 <span class="preprocessor"></span><span class="preprocessor">#define libmesh_not_implemented()    do { libmesh_write_traceout(); libmesh_here(); LIBMESH_THROW(libMesh::NotImplemented()); } while(0)</span>
<a name="l00240"></a>00240 <span class="preprocessor"></span><span class="preprocessor">#define libmesh_file_error(filename)    do { libmesh_write_traceout(); libmesh_here(); LIBMESH_THROW(libMesh::FileError(filename)); } while(0)</span>
<a name="l00241"></a>00241 <span class="preprocessor"></span><span class="preprocessor">#define libmesh_convergence_failure()    do { libmesh_here(); LIBMESH_THROW(libMesh::ConvergenceFailure()); } while(0)</span>
<a name="l00242"></a>00242 <span class="preprocessor"></span>
<a name="l00243"></a>00243 <span class="comment">// The libmesh_cast functions do a dynamic cast and assert the result,</span>
<a name="l00244"></a>00244 <span class="comment">// if we&#39;re in debug or development modes, but just do a faster static</span>
<a name="l00245"></a>00245 <span class="comment">// cast if we&#39;re in optimized mode.  Use these casts when you&#39;re</span>
<a name="l00246"></a>00246 <span class="comment">// certain that a cast will succeed in correct code but you want to be</span>
<a name="l00247"></a>00247 <span class="comment">// able to double-check.</span>
<a name="l00248"></a>00248 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Tnew, <span class="keyword">typename</span> Told&gt;
<a name="l00249"></a><a class="code" href="libmesh__common_8h.php#ade2dc28b2103e9ca1ae145be9c6fdd47">00249</a> <span class="keyword">inline</span> Tnew <a class="code" href="libmesh__common_8h.php#ade2dc28b2103e9ca1ae145be9c6fdd47">libmesh_cast_ref</a>(Told&amp; oldvar)
<a name="l00250"></a>00250 {
<a name="l00251"></a>00251 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00252"></a>00252 <span class="preprocessor"></span>  <span class="keywordflow">try</span>
<a name="l00253"></a>00253     {
<a name="l00254"></a>00254       Tnew newvar = <span class="keyword">dynamic_cast&lt;</span>Tnew<span class="keyword">&gt;</span>(oldvar);
<a name="l00255"></a>00255       <span class="keywordflow">return</span> newvar;
<a name="l00256"></a>00256     }
<a name="l00257"></a>00257   <span class="keywordflow">catch</span> (std::bad_cast)
<a name="l00258"></a>00258     {
<a name="l00259"></a>00259       libmesh_assert (<span class="keyword">false</span>);
<a name="l00260"></a>00260     }
<a name="l00261"></a>00261 <span class="preprocessor">#else</span>
<a name="l00262"></a>00262 <span class="preprocessor"></span>  <span class="keywordflow">return</span>(static_cast&lt;Tnew&gt;(oldvar));
<a name="l00263"></a>00263 <span class="preprocessor">#endif</span>
<a name="l00264"></a>00264 <span class="preprocessor"></span>}
<a name="l00265"></a>00265 
<a name="l00266"></a>00266 <span class="comment">// We use two different function names to avoid an odd overloading</span>
<a name="l00267"></a>00267 <span class="comment">// ambiguity bug with icc 10.1.008</span>
<a name="l00268"></a>00268 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Tnew, <span class="keyword">typename</span> Told&gt;
<a name="l00269"></a><a class="code" href="libmesh__common_8h.php#a045144b7d3aa8da09d921a3e8d5f2889">00269</a> <span class="keyword">inline</span> Tnew <a class="code" href="libmesh__common_8h.php#a045144b7d3aa8da09d921a3e8d5f2889">libmesh_cast_ptr</a> (Told* oldvar)
<a name="l00270"></a>00270 {
<a name="l00271"></a>00271 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00272"></a>00272 <span class="preprocessor"></span>  Tnew newvar = <span class="keyword">dynamic_cast&lt;</span>Tnew<span class="keyword">&gt;</span>(oldvar);
<a name="l00273"></a>00273   libmesh_assert (newvar);
<a name="l00274"></a>00274   <span class="keywordflow">return</span> newvar;
<a name="l00275"></a>00275 <span class="preprocessor">#else</span>
<a name="l00276"></a>00276 <span class="preprocessor"></span>  <span class="keywordflow">return</span>(static_cast&lt;Tnew&gt;(oldvar));
<a name="l00277"></a>00277 <span class="preprocessor">#endif</span>
<a name="l00278"></a>00278 <span class="preprocessor"></span>}
<a name="l00279"></a>00279 
<a name="l00280"></a>00280 
<a name="l00281"></a>00281 <span class="comment">// The libmesh_experimental macro warns that you are using</span>
<a name="l00282"></a>00282 <span class="comment">// bleeding-edge code</span>
<a name="l00283"></a>00283 <span class="preprocessor">#undef libmesh_experimental</span>
<a name="l00284"></a>00284 <span class="preprocessor"></span><span class="preprocessor">#define libmesh_experimental() do { std::cout &lt;&lt; &quot;*** Warning, This code is untested, experimental, or likely to see future API changes: &quot; &lt;&lt; __FILE__ &lt;&lt; &quot;, line &quot; &lt;&lt; __LINE__ &lt;&lt; &quot;, compiled &quot; &lt;&lt; __DATE__ &lt;&lt; &quot; at &quot; &lt;&lt; __TIME__ &lt;&lt; &quot; ***&quot; &lt;&lt; std::endl; } while (0)</span>
<a name="l00285"></a>00285 <span class="preprocessor"></span>
<a name="l00286"></a>00286 
<a name="l00287"></a>00287 <span class="comment">// The libmesh_deprecated macro warns that you are using obsoleted code</span>
<a name="l00288"></a>00288 <span class="preprocessor">#undef libmesh_deprecated</span>
<a name="l00289"></a>00289 <span class="preprocessor"></span><span class="preprocessor">#define libmesh_deprecated() do { std::cout &lt;&lt; &quot;*** Warning, This code is deprecated, and likely to be removed in future library versions! &quot; &lt;&lt; __FILE__ &lt;&lt; &quot;, line &quot; &lt;&lt; __LINE__ &lt;&lt; &quot;, compiled &quot; &lt;&lt; __DATE__ &lt;&lt; &quot; at &quot; &lt;&lt; __TIME__ &lt;&lt; &quot; ***&quot; &lt;&lt; std::endl; } while(0)</span>
<a name="l00290"></a>00290 <span class="preprocessor"></span>
<a name="l00291"></a>00291 
<a name="l00292"></a>00292 
<a name="l00293"></a>00293 
<a name="l00294"></a>00294 <span class="comment">// 3D spatial dimension unless otherwise specified</span>
<a name="l00295"></a>00295 <span class="preprocessor">#ifndef LIBMESH_DIM</span>
<a name="l00296"></a>00296 <span class="preprocessor"></span><span class="preprocessor">#  define LIBMESH_DIM 3</span>
<a name="l00297"></a>00297 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00298"></a>00298 <span class="preprocessor"></span>
<a name="l00299"></a>00299 
<a name="l00300"></a>00300 
<a name="l00301"></a>00301 
<a name="l00302"></a>00302 
<a name="l00303"></a>00303 
<a name="l00304"></a>00304 <span class="preprocessor">#endif // #define __libmesh_common_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
