<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>linear.h</h1>  </div>
</div>
<div class="contents">
<a href="linear_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: linear.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __linear_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __linear_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="solver_8h.php">solver.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00040"></a>00040 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00041"></a>00041 <span class="comment">// Linear class definition</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T = Solver&gt;
<a name="l00044"></a><a class="code" href="classLinear.php">00044</a> <span class="keyword">class </span><a class="code" href="classLinear.php">Linear</a> : <span class="keyword">public</span> T
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046 <span class="keyword">public</span>:
<a name="l00047"></a>00047   
<a name="l00051"></a>00051   <a class="code" href="classLinear.php#aefb5b4c6a718720c9d9a8aa8da7b7746">Linear</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es);
<a name="l00052"></a>00052 
<a name="l00056"></a>00056   <a class="code" href="classLinear.php#aefb5b4c6a718720c9d9a8aa8da7b7746">Linear</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00057"></a>00057           <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00058"></a>00058           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number);
<a name="l00059"></a>00059   
<a name="l00063"></a>00063   <a class="code" href="classLinear.php#af3eaf99eb274cd405812ced374108e3d">~Linear</a> ();
<a name="l00064"></a>00064 };
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00069"></a>00069 <span class="comment">// Linear inline members</span>
<a name="l00070"></a>00070 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00071"></a>00071 <span class="keyword">inline</span>
<a name="l00072"></a><a class="code" href="classLinear.php#aefb5b4c6a718720c9d9a8aa8da7b7746">00072</a> <a class="code" href="classLinear.php#aefb5b4c6a718720c9d9a8aa8da7b7746">Linear&lt;T&gt;::Linear</a>(<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es) : 
<a name="l00073"></a>00073   T (es)
<a name="l00074"></a>00074 {
<a name="l00075"></a>00075 }
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00080"></a>00080 <span class="keyword">inline</span>
<a name="l00081"></a><a class="code" href="classLinear.php#a1efee945a86150b7cf8ecd7ca47a04dc">00081</a> <a class="code" href="classLinear.php#aefb5b4c6a718720c9d9a8aa8da7b7746">Linear&lt;T&gt;::Linear</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00082"></a>00082                    <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00083"></a>00083                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :
<a name="l00084"></a>00084   T (es, name, number)
<a name="l00085"></a>00085 {
<a name="l00086"></a>00086 }
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00091"></a>00091 <span class="keyword">inline</span>
<a name="l00092"></a><a class="code" href="classLinear.php#af3eaf99eb274cd405812ced374108e3d">00092</a> <a class="code" href="classLinear.php#af3eaf99eb274cd405812ced374108e3d">Linear&lt;T&gt;::~Linear</a> ()
<a name="l00093"></a>00093 {
<a name="l00094"></a>00094 }
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 <span class="preprocessor">#endif // #define __linear_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
