<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>linear_implicit_system.h</h1>  </div>
</div>
<div class="contents">
<a href="linear__implicit__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: linear_implicit_system.h 3414 2009-06-30 23:15:45Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __linear_implicit_system_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __linear_implicit_system_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="implicit__system_8h.php">implicit_system.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Forward Declarations</span>
<a name="l00032"></a>00032 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classLinearSolver.php">LinearSolver</a>;
<a name="l00033"></a>00033 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classShellMatrix.php">ShellMatrix</a>;
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00044"></a>00044 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00045"></a>00045 <span class="comment">// LinearImplicitSystem class definition</span>
<a name="l00046"></a>00046 
<a name="l00047"></a><a class="code" href="classLinearImplicitSystem.php">00047</a> <span class="keyword">class </span><a class="code" href="classLinearImplicitSystem.php">LinearImplicitSystem</a> : <span class="keyword">public</span> <a class="code" href="classImplicitSystem.php">ImplicitSystem</a>
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049 <span class="keyword">public</span>:
<a name="l00050"></a>00050 
<a name="l00055"></a>00055   <a class="code" href="classLinearImplicitSystem.php#a8fe3c6f351f63ec6691a3c695bdd5616">LinearImplicitSystem</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00056"></a>00056                         <span class="keyword">const</span> std::string&amp; <a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>,
<a name="l00057"></a>00057                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">number</a>);
<a name="l00058"></a>00058 
<a name="l00062"></a>00062   <span class="keyword">virtual</span> <a class="code" href="classLinearImplicitSystem.php#abce220675082a85b02f1a85700cfbe10">~LinearImplicitSystem</a> ();
<a name="l00063"></a>00063 
<a name="l00067"></a><a class="code" href="classLinearImplicitSystem.php#abdf5721a4bdf55109b692fcd72265b75">00067</a>   <span class="keyword">typedef</span> <a class="code" href="classLinearImplicitSystem.php">LinearImplicitSystem</a> <a class="code" href="classLinearImplicitSystem.php#abdf5721a4bdf55109b692fcd72265b75">sys_type</a>;
<a name="l00068"></a>00068 
<a name="l00072"></a><a class="code" href="classLinearImplicitSystem.php#a42cd6da6503911b0ddbbb058ab258ddb">00072</a>   <span class="keyword">typedef</span> <a class="code" href="classImplicitSystem.php">ImplicitSystem</a> <a class="code" href="classLinearImplicitSystem.php#a42cd6da6503911b0ddbbb058ab258ddb">Parent</a>;
<a name="l00073"></a>00073   
<a name="l00077"></a><a class="code" href="classLinearImplicitSystem.php#ad2aa8ecf76f28180048ff3d7f2576aad">00077</a>   <a class="code" href="classExplicitSystem.php">sys_type</a> &amp; <a class="code" href="classLinearImplicitSystem.php#ad2aa8ecf76f28180048ff3d7f2576aad">system</a> () { <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00078"></a>00078   
<a name="l00083"></a>00083   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classLinearImplicitSystem.php#adb86d7f2795eea9056c778a9986e287e">clear</a> ();
<a name="l00084"></a>00084 
<a name="l00089"></a>00089   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classLinearImplicitSystem.php#a3b8d18deda76c54b6ddaf1725b5d5f75">reinit</a> ();
<a name="l00090"></a>00090    
<a name="l00091"></a>00091 <span class="comment">//   /**</span>
<a name="l00092"></a>00092 <span class="comment">//    * Prepares \p matrix and \p _dof_map for matrix assembly.</span>
<a name="l00093"></a>00093 <span class="comment">//    * Does not actually assemble anything.  For matrix assembly,</span>
<a name="l00094"></a>00094 <span class="comment">//    * use the \p assemble() in derived classes.</span>
<a name="l00095"></a>00095 <span class="comment">//    * @e Should be overloaded in derived classes.</span>
<a name="l00096"></a>00096 <span class="comment">//    */</span>
<a name="l00097"></a>00097 <span class="comment">//   virtual void assemble () { ImplicitSystem::assemble(); }</span>
<a name="l00098"></a>00098  
<a name="l00102"></a>00102   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classLinearImplicitSystem.php#a0975f1c4622285a0f3e19a20312eb7f7">solve</a> ();
<a name="l00103"></a>00103  
<a name="l00107"></a>00107   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classLinearImplicitSystem.php#aa9b4c5c7ef9aa3a310383437ec905197">adjoint_solve</a> ();
<a name="l00108"></a>00108  
<a name="l00119"></a>00119   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classLinearImplicitSystem.php#a6f5462a027826b98fa2e489d37be2f38">qoi_parameter_sensitivity</a> (std::vector&lt;Number *&gt;&amp; parameters,
<a name="l00120"></a>00120                                           std::vector&lt;Number&gt;&amp; sensitivities);
<a name="l00121"></a>00121  
<a name="l00126"></a><a class="code" href="classLinearImplicitSystem.php#a452f697dd85d69979be9b34e5773d8f9">00126</a>   <span class="keyword">virtual</span> std::string <a class="code" href="classLinearImplicitSystem.php#a452f697dd85d69979be9b34e5773d8f9">system_type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="stringliteral">&quot;LinearImplicit&quot;</span>; }
<a name="l00127"></a>00127 
<a name="l00134"></a><a class="code" href="classLinearImplicitSystem.php#a4f58b0fa3b6d450940b969e53ba19ac4">00134</a>   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;LinearSolver&lt;Number&gt;</a> &gt; <a class="code" href="classLinearImplicitSystem.php#a4f58b0fa3b6d450940b969e53ba19ac4">linear_solver</a>;
<a name="l00135"></a>00135   
<a name="l00140"></a><a class="code" href="classLinearImplicitSystem.php#a9229f35e1f7a076b71469e093f35a85a">00140</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classLinearImplicitSystem.php#a9229f35e1f7a076b71469e093f35a85a">n_linear_iterations</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classLinearImplicitSystem.php#a3a97f7c1f657b5c7be86050531fdf9fc">_n_linear_iterations</a>; }
<a name="l00141"></a>00141 
<a name="l00145"></a><a class="code" href="classLinearImplicitSystem.php#a327e960d51baaf1136c0907a9b08f832">00145</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classLinearImplicitSystem.php#a327e960d51baaf1136c0907a9b08f832">final_linear_residual</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classLinearImplicitSystem.php#ab345ee3343f71d8eccea0ba51791ad29">_final_linear_residual</a>; }
<a name="l00146"></a>00146   
<a name="l00156"></a>00156   <span class="keywordtype">void</span> <a class="code" href="classLinearImplicitSystem.php#aa041574412c5ad68bf5d961ba7cda458">attach_shell_matrix</a> (<a class="code" href="classShellMatrix.php">ShellMatrix&lt;Number&gt;</a>* shell_matrix);
<a name="l00157"></a>00157   
<a name="l00161"></a><a class="code" href="classLinearImplicitSystem.php#aa1580b8de5ea301e7abf2fc72efd1cfc">00161</a>   <span class="keywordtype">void</span> <a class="code" href="classLinearImplicitSystem.php#aa1580b8de5ea301e7abf2fc72efd1cfc">detach_shell_matrix</a> (<span class="keywordtype">void</span>) { <a class="code" href="classLinearImplicitSystem.php#aa041574412c5ad68bf5d961ba7cda458">attach_shell_matrix</a>(NULL); }
<a name="l00162"></a>00162 
<a name="l00167"></a><a class="code" href="classLinearImplicitSystem.php#ab6806c4963c2074f4a1ab4043236e5c1">00167</a>   <a class="code" href="classShellMatrix.php">ShellMatrix&lt;Number&gt;</a>* <a class="code" href="classLinearImplicitSystem.php#ab6806c4963c2074f4a1ab4043236e5c1">get_shell_matrix</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> <a class="code" href="classLinearImplicitSystem.php#a6760ff0032bcf83c45a43e8afacf01da">_shell_matrix</a>; }
<a name="l00168"></a>00168   
<a name="l00169"></a>00169 <span class="keyword">protected</span>:
<a name="l00170"></a>00170   
<a name="l00175"></a><a class="code" href="classLinearImplicitSystem.php#a3a97f7c1f657b5c7be86050531fdf9fc">00175</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classLinearImplicitSystem.php#a3a97f7c1f657b5c7be86050531fdf9fc">_n_linear_iterations</a>;
<a name="l00176"></a>00176 
<a name="l00180"></a><a class="code" href="classLinearImplicitSystem.php#ab345ee3343f71d8eccea0ba51791ad29">00180</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classLinearImplicitSystem.php#ab345ee3343f71d8eccea0ba51791ad29">_final_linear_residual</a>;
<a name="l00181"></a>00181 
<a name="l00185"></a><a class="code" href="classLinearImplicitSystem.php#a6760ff0032bcf83c45a43e8afacf01da">00185</a>   <a class="code" href="classShellMatrix.php">ShellMatrix&lt;Number&gt;</a>* <a class="code" href="classLinearImplicitSystem.php#a6760ff0032bcf83c45a43e8afacf01da">_shell_matrix</a>;
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 };
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00192"></a>00192 <span class="comment">// LinearImplicitSystem inline methods</span>
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
