<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_7059df55b9d3d0975f6468fedce13a55.php">partitioning</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>linear_partitioner.C</h1>  </div>
</div>
<div class="contents">
<a href="linear__partitioner_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: linear_partitioner.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;linear_partitioner.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00032"></a>00032 <span class="comment">// LinearPartitioner implementation</span>
<a name="l00033"></a><a class="code" href="classLinearPartitioner.php#a7a5fe1513f674404510d40fc66390637">00033</a> <span class="keywordtype">void</span> <a class="code" href="classLinearPartitioner.php#a7a5fe1513f674404510d40fc66390637">LinearPartitioner::_do_partition</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00034"></a>00034                                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036   libmesh_assert (n &gt; 0);
<a name="l00037"></a>00037 
<a name="l00038"></a>00038   <span class="comment">// Check for an easy return</span>
<a name="l00039"></a>00039   <span class="keywordflow">if</span> (n == 1)
<a name="l00040"></a>00040     {
<a name="l00041"></a>00041       this-&gt;<a class="code" href="classPartitioner.php#a1108dd58c055d536d489dc06cc0823ec">single_partition</a> (mesh);
<a name="l00042"></a>00042       <span class="keywordflow">return</span>;
<a name="l00043"></a>00043     }
<a name="l00044"></a>00044   
<a name="l00045"></a>00045   <span class="comment">// Create a simple linear partitioning</span>
<a name="l00046"></a>00046   {
<a name="l00047"></a>00047     START_LOG (<span class="stringliteral">&quot;partition()&quot;</span>, <span class="stringliteral">&quot;LinearPartitioner&quot;</span>);
<a name="l00048"></a>00048     
<a name="l00049"></a>00049     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_active_elem = mesh.<a class="code" href="classMeshBase.php#a246697678d5d14a986cee2b6fbdbae6b">n_active_elem</a>();
<a name="l00050"></a>00050     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> blksize       = n_active_elem/n;
<a name="l00051"></a>00051     
<a name="l00052"></a>00052     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e = 0;
<a name="l00053"></a>00053 
<a name="l00054"></a>00054     <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00055"></a>00055     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00056"></a>00056 
<a name="l00057"></a>00057     <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00058"></a>00058       {
<a name="l00059"></a>00059         <span class="keywordflow">if</span> ((e/blksize) &lt; n)
<a name="l00060"></a>00060           {
<a name="l00061"></a>00061             <a class="code" href="classElem.php">Elem</a> *elem = *elem_it;
<a name="l00062"></a>00062             elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() = e/blksize;
<a name="l00063"></a>00063           }
<a name="l00064"></a>00064         <span class="keywordflow">else</span>
<a name="l00065"></a>00065           {
<a name="l00066"></a>00066             <a class="code" href="classElem.php">Elem</a> *elem = *elem_it;
<a name="l00067"></a>00067             elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() = 0;
<a name="l00068"></a>00068             elem = elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>();
<a name="l00069"></a>00069           }
<a name="l00070"></a>00070         
<a name="l00071"></a>00071         e++;
<a name="l00072"></a>00072       }
<a name="l00073"></a>00073     
<a name="l00074"></a>00074     STOP_LOG (<span class="stringliteral">&quot;partition()&quot;</span>, <span class="stringliteral">&quot;LinearPartitioner&quot;</span>);
<a name="l00075"></a>00075   }
<a name="l00076"></a>00076 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
