<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>linear_solver.h</h1>  </div>
</div>
<div class="contents">
<a href="linear__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: linear_solver.h 3441 2009-07-26 21:04:25Z knezed01 $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __linear_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __linear_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;enum_solver_package.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;enum_solver_type.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;enum_preconditioner_type.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;reference_counted_object.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;libmesh.h&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// forward declarations</span>
<a name="l00037"></a>00037 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr</a>;
<a name="l00038"></a>00038 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classSparseMatrix.php">SparseMatrix</a>;
<a name="l00039"></a>00039 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classNumericVector.php">NumericVector</a>;
<a name="l00040"></a>00040 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classShellMatrix.php">ShellMatrix</a>;
<a name="l00041"></a>00041 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classPreconditioner.php">Preconditioner</a>;
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00052"></a>00052 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00053"></a><a class="code" href="classLinearSolver.php">00053</a> <span class="keyword">class </span><a class="code" href="classLinearSolver.php">LinearSolver</a> : <span class="keyword">public</span> <a class="code" href="classReferenceCountedObject.php">ReferenceCountedObject</a>&lt;LinearSolver&lt;T&gt; &gt;
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055 <span class="keyword">public</span>:
<a name="l00056"></a>00056   
<a name="l00060"></a>00060   <a class="code" href="classLinearSolver.php#ad18e356b34680929264cf05df508625f">LinearSolver</a> ();
<a name="l00061"></a>00061     
<a name="l00065"></a>00065   <span class="keyword">virtual</span> <a class="code" href="classLinearSolver.php#a9d57671ddf72a43de93d66bcbecffc31">~LinearSolver</a> ();
<a name="l00066"></a>00066   
<a name="l00071"></a>00071   <span class="keyword">static</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;LinearSolver&lt;T&gt;</a> &gt; <a class="code" href="classLinearSolver.php#acc014293981a8cc6988c2c9641681bf2">build</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> solver_package =
<a name="l00072"></a>00072                                                   <a class="code" href="namespacelibMesh.php#a496c62248223cd940c7715932dd0dc2d">libMesh::default_solver_package</a>());
<a name="l00073"></a>00073   
<a name="l00078"></a><a class="code" href="classLinearSolver.php#a9e3e0572e33ac1b52fea540a39f8146e">00078</a>   <span class="keywordtype">bool</span> <a class="code" href="classLinearSolver.php#a9e3e0572e33ac1b52fea540a39f8146e">initialized</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classLinearSolver.php#a2846cd5a2b1056bbac7578f97444262e">_is_initialized</a>; }
<a name="l00079"></a>00079   
<a name="l00083"></a><a class="code" href="classLinearSolver.php#a1f2eb4c2a2d6cc0dac8a39529ea4f558">00083</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classLinearSolver.php#a1f2eb4c2a2d6cc0dac8a39529ea4f558">clear</a> () {}
<a name="l00084"></a>00084 
<a name="l00088"></a>00088   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classLinearSolver.php#a07f54d905e7198fd207c6917d9a74997">init</a> () = 0;
<a name="l00089"></a>00089 
<a name="l00093"></a><a class="code" href="classLinearSolver.php#a237add7cc62f77f1ccaab26f2f09e21b">00093</a>   <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19">SolverType</a> <a class="code" href="classLinearSolver.php#a237add7cc62f77f1ccaab26f2f09e21b">solver_type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classLinearSolver.php#adb580ae95d07d68a579200b938d82c8a">_solver_type</a>; }
<a name="l00094"></a>00094 
<a name="l00098"></a><a class="code" href="classLinearSolver.php#ad5710b9e5060d83bae2e17e8645e0e11">00098</a>   <span class="keywordtype">void</span> <a class="code" href="classLinearSolver.php#ad5710b9e5060d83bae2e17e8645e0e11">set_solver_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19">SolverType</a> st)
<a name="l00099"></a>00099   { <a class="code" href="classLinearSolver.php#adb580ae95d07d68a579200b938d82c8a">_solver_type</a> = st; }
<a name="l00100"></a>00100 
<a name="l00104"></a>00104   <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4">PreconditionerType</a> <a class="code" href="classLinearSolver.php#afbc74a99d37350c8a889e03f60f18831">preconditioner_type</a> () <span class="keyword">const</span>;
<a name="l00105"></a>00105 
<a name="l00109"></a>00109   <span class="keywordtype">void</span> <a class="code" href="classLinearSolver.php#a6cf83514e8fa4fbc85f445de493eec7b">set_preconditioner_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4">PreconditionerType</a> pct);
<a name="l00110"></a>00110 
<a name="l00114"></a>00114   <span class="keywordtype">void</span> <a class="code" href="classLinearSolver.php#a0d2f112e3c9b0c0c7a33bfe0a986aebc">attach_preconditioner</a>(<a class="code" href="classPreconditioner.php">Preconditioner&lt;T&gt;</a> * preconditioner);
<a name="l00115"></a>00115 
<a name="l00122"></a>00122   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt; <a class="code" href="classLinearSolver.php#ad0651469d9eda33718e59464e9a2dcea">solve</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;,  <span class="comment">// System Matrix</span>
<a name="l00123"></a>00123                                                <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;, <span class="comment">// Solution vector</span>
<a name="l00124"></a>00124                                                <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;, <span class="comment">// RHS vector</span>
<a name="l00125"></a>00125                                                <span class="keyword">const</span> <span class="keywordtype">double</span>,      <span class="comment">// Stopping tolerance</span>
<a name="l00126"></a>00126                                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>) = 0; <span class="comment">// N. Iterations</span>
<a name="l00127"></a>00127   
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00136"></a>00136   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt; <a class="code" href="classLinearSolver.php#ad0651469d9eda33718e59464e9a2dcea">solve</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;,  <span class="comment">// System Matrix</span>
<a name="l00137"></a>00137                                                <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;,  <span class="comment">// Preconditioning Matrix</span>
<a name="l00138"></a>00138                                                <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;, <span class="comment">// Solution vector</span>
<a name="l00139"></a>00139                                                <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;, <span class="comment">// RHS vector</span>
<a name="l00140"></a>00140                                                <span class="keyword">const</span> <span class="keywordtype">double</span>,      <span class="comment">// Stopping tolerance</span>
<a name="l00141"></a>00141                                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>) = 0; <span class="comment">// N. Iterations</span>
<a name="l00142"></a>00142   
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 
<a name="l00148"></a>00148   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt; <a class="code" href="classLinearSolver.php#ad0651469d9eda33718e59464e9a2dcea">solve</a> (<span class="keyword">const</span> <a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix,
<a name="l00149"></a>00149                                                <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;, <span class="comment">// Solution vector</span>
<a name="l00150"></a>00150                                                <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;, <span class="comment">// RHS vector</span>
<a name="l00151"></a>00151                                                <span class="keyword">const</span> <span class="keywordtype">double</span>,      <span class="comment">// Stopping tolerance</span>
<a name="l00152"></a>00152                                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>) = 0; <span class="comment">// N. Iterations</span>
<a name="l00153"></a>00153   
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 
<a name="l00161"></a>00161   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt; <a class="code" href="classLinearSolver.php#ad0651469d9eda33718e59464e9a2dcea">solve</a> (<span class="keyword">const</span> <a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix,
<a name="l00162"></a>00162                                                <span class="keyword">const</span> <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; precond_matrix,
<a name="l00163"></a>00163                                                <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;, <span class="comment">// Solution vector</span>
<a name="l00164"></a>00164                                                <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;, <span class="comment">// RHS vector</span>
<a name="l00165"></a>00165                                                <span class="keyword">const</span> <span class="keywordtype">double</span>,      <span class="comment">// Stopping tolerance</span>
<a name="l00166"></a>00166                                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>) = 0; <span class="comment">// N. Iterations</span>
<a name="l00167"></a>00167   
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00174"></a>00174   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classLinearSolver.php#a7eba8bec7a878f170dfe5bef664d4934">print_converged_reason</a>() = 0;
<a name="l00175"></a>00175   
<a name="l00182"></a><a class="code" href="classLinearSolver.php#a229a1227d50b977aaefbc4faaec7a33e">00182</a>   <span class="keywordtype">bool</span> <a class="code" href="classLinearSolver.php#a229a1227d50b977aaefbc4faaec7a33e">same_preconditioner</a>;
<a name="l00183"></a>00183   
<a name="l00184"></a>00184 <span class="keyword">protected</span>:
<a name="l00185"></a>00185 
<a name="l00186"></a>00186   
<a name="l00190"></a><a class="code" href="classLinearSolver.php#adb580ae95d07d68a579200b938d82c8a">00190</a>   <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19">SolverType</a> <a class="code" href="classLinearSolver.php#adb580ae95d07d68a579200b938d82c8a">_solver_type</a>;
<a name="l00191"></a>00191 
<a name="l00195"></a><a class="code" href="classLinearSolver.php#a0c4b83443d79e960790f6c877ce5ea23">00195</a>   <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4">PreconditionerType</a> <a class="code" href="classLinearSolver.php#a0c4b83443d79e960790f6c877ce5ea23">_preconditioner_type</a>;
<a name="l00196"></a>00196   
<a name="l00200"></a><a class="code" href="classLinearSolver.php#a2846cd5a2b1056bbac7578f97444262e">00200</a>   <span class="keywordtype">bool</span> <a class="code" href="classLinearSolver.php#a2846cd5a2b1056bbac7578f97444262e">_is_initialized</a>;
<a name="l00201"></a>00201 
<a name="l00205"></a><a class="code" href="classLinearSolver.php#a4b5390e878d9ed85106d0360c7a67c31">00205</a>   <a class="code" href="classPreconditioner.php">Preconditioner&lt;T&gt;</a> * <a class="code" href="classLinearSolver.php#a4b5390e878d9ed85106d0360c7a67c31">_preconditioner</a>;
<a name="l00206"></a>00206 };
<a name="l00207"></a>00207 
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 <span class="comment">/*----------------------- inline functions ----------------------------------*/</span>
<a name="l00212"></a>00212 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00213"></a>00213 <span class="keyword">inline</span>
<a name="l00214"></a><a class="code" href="classLinearSolver.php#ad18e356b34680929264cf05df508625f">00214</a> <a class="code" href="classLinearSolver.php#ad18e356b34680929264cf05df508625f">LinearSolver&lt;T&gt;::LinearSolver</a> () :
<a name="l00215"></a>00215 
<a name="l00216"></a>00216   same_preconditioner  (false),
<a name="l00217"></a>00217   _solver_type         (<a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a28c6a4ecccca1d0e6956e5e94fa82d97">GMRES</a>),
<a name="l00218"></a>00218   _preconditioner_type (<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4af54549e0e69fbdd4ddd199ee316527f3">ILU_PRECOND</a>),
<a name="l00219"></a>00219   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a>      (false),
<a name="l00220"></a>00220   _preconditioner      (NULL)
<a name="l00221"></a>00221 {
<a name="l00222"></a>00222 }
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 
<a name="l00226"></a>00226 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00227"></a>00227 <span class="keyword">inline</span>
<a name="l00228"></a><a class="code" href="classLinearSolver.php#a9d57671ddf72a43de93d66bcbecffc31">00228</a> <a class="code" href="classLinearSolver.php#a9d57671ddf72a43de93d66bcbecffc31">LinearSolver&lt;T&gt;::~LinearSolver</a> ()
<a name="l00229"></a>00229 {
<a name="l00230"></a>00230   this-&gt;clear ();
<a name="l00231"></a>00231 }
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 <span class="preprocessor">#endif // #ifdef __solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
