<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_4f64d75cac7489d141591c33108e86ff.php">utils</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>location_maps.h</h1>  </div>
</div>
<div class="contents">
<a href="location__maps_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 <span class="comment">// $Id: location_maps.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00005"></a>00005 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00006"></a>00006   
<a name="l00007"></a>00007 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00008"></a>00008 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00009"></a>00009 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00010"></a>00010 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00011"></a>00011   
<a name="l00012"></a>00012 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00013"></a>00013 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00014"></a>00014 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00015"></a>00015 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00016"></a>00016   
<a name="l00017"></a>00017 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00018"></a>00018 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00019"></a>00019 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifndef __location_maps_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#define __location_maps_h__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00029"></a>00029 <span class="preprocessor">#if   defined(LIBMESH_HAVE_UNORDERED_MAP)</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor"># include &lt;unordered_map&gt;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#elif defined(LIBMESH_HAVE_TR1_UNORDERED_MAP)</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span><span class="preprocessor"># include &lt;tr1/unordered_map&gt;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#elif defined(LIBMESH_HAVE_HASH_MAP)</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span><span class="preprocessor"># include &lt;hash_map&gt;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#elif defined(LIBMESH_HAVE_EXT_HASH_MAP)</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span><span class="preprocessor"># include &lt;ext/hash_map&gt;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#else</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span><span class="preprocessor"># include &lt;map&gt;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#endif</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span><span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00043"></a>00043 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00044"></a>00044 <span class="preprocessor">#include &quot;point.h&quot;</span>
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="comment">// Forward Declarations -----------------------------</span>
<a name="l00047"></a>00047 <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00048"></a>00048 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00049"></a>00049 <span class="keyword">class </span><a class="code" href="classNode.php">Node</a>;
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00058"></a>00058 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00059"></a><a class="code" href="classLocationMap.php">00059</a> <span class="keyword">class </span><a class="code" href="classLocationMap.php">LocationMap</a>
<a name="l00060"></a>00060 {
<a name="l00061"></a>00061 <span class="preprocessor">#if   defined(LIBMESH_HAVE_UNORDERED_MAP)</span>
<a name="l00062"></a><a class="code" href="classLocationMap.php#af0af8c2e6db6d9b5b35d16811674a28e">00062</a> <span class="preprocessor"></span>  <span class="keyword">typedef</span> std::unordered_multimap&lt;unsigned int, T*&gt; <a class="code" href="classLocationMap.php#af0af8c2e6db6d9b5b35d16811674a28e">map_type</a>;
<a name="l00063"></a>00063 <span class="preprocessor">#elif defined(LIBMESH_HAVE_TR1_UNORDERED_MAP)</span>
<a name="l00064"></a><a class="code" href="classLocationMap.php#a2ce30def03925af398af5a0f046a447e">00064</a> <span class="preprocessor"></span>  <span class="keyword">typedef</span> std::tr1::unordered_multimap&lt;unsigned int, T*&gt; <a class="code" href="classLocationMap.php#a2ce30def03925af398af5a0f046a447e">map_type</a>;
<a name="l00065"></a>00065 <span class="preprocessor">#elif defined(LIBMESH_HAVE_HASH_MAP)</span>
<a name="l00066"></a><a class="code" href="classLocationMap.php#a7241ccbfcb40bb82fa5cae80a56edd6e">00066</a> <span class="preprocessor"></span>  <span class="keyword">typedef</span> std::hash_multimap&lt;unsigned int, T*&gt; <a class="code" href="classLocationMap.php#a7241ccbfcb40bb82fa5cae80a56edd6e">map_type</a>;
<a name="l00067"></a>00067 <span class="preprocessor">#elif defined(LIBMESH_HAVE_EXT_HASH_MAP)</span>
<a name="l00068"></a>00068 <span class="preprocessor"></span><span class="preprocessor"># if   (__GNUC__ == 3) &amp;&amp; (__GNUC_MINOR__ == 0) // gcc 3.0</span>
<a name="l00069"></a><a class="code" href="classLocationMap.php#a7241ccbfcb40bb82fa5cae80a56edd6e">00069</a> <span class="preprocessor"></span>  <span class="keyword">typedef</span> std::hash_multimap&lt;unsigned int, T*&gt; <a class="code" href="classLocationMap.php#a7241ccbfcb40bb82fa5cae80a56edd6e">map_type</a>;
<a name="l00070"></a>00070 <span class="preprocessor"># elif (__GNUC__ &gt;= 3)                          // gcc 3.1 &amp; newer</span>
<a name="l00071"></a><a class="code" href="classLocationMap.php#a33534ae112ca72588a075e4e5e80fa91">00071</a> <span class="preprocessor"></span>  <span class="keyword">typedef</span> __gnu_cxx::hash_multimap&lt;unsigned int, T*&gt; <a class="code" href="classLocationMap.php#a33534ae112ca72588a075e4e5e80fa91">map_type</a>;
<a name="l00072"></a>00072 <span class="preprocessor"># else</span>
<a name="l00073"></a>00073 <span class="preprocessor"></span><span class="comment">// XLC and who knows what other compilers get here.</span>
<a name="l00074"></a>00074 <span class="comment">// Try the most standard thing we can:</span>
<a name="l00075"></a><a class="code" href="classLocationMap.php#afbcebf782c43d733b896f506d23710c4">00075</a>   <span class="keyword">typedef</span> std::multimap&lt;unsigned int, T*&gt; <a class="code" href="classLocationMap.php#afbcebf782c43d733b896f506d23710c4">map_type</a>;
<a name="l00076"></a>00076 <span class="preprocessor"># endif</span>
<a name="l00077"></a>00077 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00078"></a><a class="code" href="classLocationMap.php#afbcebf782c43d733b896f506d23710c4">00078</a> <span class="preprocessor"></span>  <span class="keyword">typedef</span> std::multimap&lt;unsigned int, T*&gt; <a class="code" href="classLocationMap.php#afbcebf782c43d733b896f506d23710c4">map_type</a>;
<a name="l00079"></a>00079 <span class="preprocessor">#endif</span>
<a name="l00080"></a>00080 <span class="preprocessor"></span><span class="keyword">public</span>: 
<a name="l00081"></a>00081   <span class="keywordtype">void</span> <a class="code" href="classLocationMap.php#a11ceffd5adae2b79e2cc0f8ab0b1f73f">init</a>(<a class="code" href="classMeshBase.php">MeshBase</a>&amp;);
<a name="l00082"></a>00082 
<a name="l00083"></a><a class="code" href="classLocationMap.php#aca32ff9cab95a48aaf3d5e4250e51cb4">00083</a>   <span class="keywordtype">void</span> <a class="code" href="classLocationMap.php#aca32ff9cab95a48aaf3d5e4250e51cb4">clear</a>() { <a class="code" href="classLocationMap.php#ae772d4ad7cca5759b86c09b607cd1204">_map</a>.clear(); }
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="keywordtype">void</span> <a class="code" href="classLocationMap.php#aa31e9800e314e1437fdcc82088df5f3f">insert</a>(T&amp;);
<a name="l00086"></a>00086 
<a name="l00087"></a><a class="code" href="classLocationMap.php#a4517c7633d5d724f8666fefc8220b408">00087</a>   <span class="keywordtype">bool</span> <a class="code" href="classLocationMap.php#a4517c7633d5d724f8666fefc8220b408">empty</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classLocationMap.php#ae772d4ad7cca5759b86c09b607cd1204">_map</a>.empty(); }
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   T* <a class="code" href="classLocationMap.php#a5af3c498d43b5eec4c40e1fd8aff23cb">find</a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp;,
<a name="l00090"></a>00090           <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tol = TOLERANCE);
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   <a class="code" href="classPoint.php">Point</a> <a class="code" href="classLocationMap.php#ab5b10986fbdf353d3aea1caeb3fae417">point_of</a>(<span class="keyword">const</span> T&amp;) <span class="keyword">const</span>;
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 <span class="keyword">protected</span>:
<a name="l00095"></a>00095   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classLocationMap.php#acb23fc4ab13f859ae28ef33839700f77">key</a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp;);
<a name="l00096"></a>00096 
<a name="l00097"></a>00097   <span class="keywordtype">void</span> <a class="code" href="classLocationMap.php#a889d0d84b592c3f1fe8209001662f9ba">fill</a>(<a class="code" href="classMeshBase.php">MeshBase</a>&amp;);
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 <span class="keyword">private</span>: 
<a name="l00100"></a><a class="code" href="classLocationMap.php#ae772d4ad7cca5759b86c09b607cd1204">00100</a>   <a class="code" href="classLocationMap.php#af0af8c2e6db6d9b5b35d16811674a28e">map_type</a>          <a class="code" href="classLocationMap.php#ae772d4ad7cca5759b86c09b607cd1204">_map</a>;
<a name="l00101"></a><a class="code" href="classLocationMap.php#a1eb8fba19c04e18ef6f152197ea64ae8">00101</a>   std::vector&lt;Real&gt; <a class="code" href="classLocationMap.php#a1eb8fba19c04e18ef6f152197ea64ae8">_lower_bound</a>;
<a name="l00102"></a><a class="code" href="classLocationMap.php#a7210a6e7de3233254c0e3492fb6a32ce">00102</a>   std::vector&lt;Real&gt; <a class="code" href="classLocationMap.php#a7210a6e7de3233254c0e3492fb6a32ce">_upper_bound</a>;
<a name="l00103"></a>00103 };
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 <span class="preprocessor">#endif // #define __location_maps_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
