<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_4f64d75cac7489d141591c33108e86ff.php">utils</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mapvector.h</h1>  </div>
</div>
<div class="contents">
<a href="mapvector_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mapvector.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __mapvector_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __mapvector_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00027"></a>00027 
<a name="l00038"></a>00038 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Val&gt;
<a name="l00039"></a><a class="code" href="classmapvector.php">00039</a> <span class="keyword">class </span><a class="code" href="classmapvector.php">mapvector</a> : <span class="keyword">public</span> std::<a class="code" href="classstd_1_1map.php">map</a>&lt;unsigned int, Val&gt;
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041 <span class="keyword">public</span>:
<a name="l00042"></a><a class="code" href="classmapvector.php#a8cbd84a35b43a5036c3c21d4722036a4">00042</a>   <span class="keyword">typedef</span> std::map&lt;unsigned int, Val&gt; <a class="code" href="classmapvector.php#a8cbd84a35b43a5036c3c21d4722036a4">maptype</a>;
<a name="l00043"></a>00043 
<a name="l00044"></a><a class="code" href="classmapvector.php#a34511f3fd698ed0b38b18c498fd8d9ad">00044</a>   Val&amp; <a class="code" href="classmapvector.php#a34511f3fd698ed0b38b18c498fd8d9ad">operator[] </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;k)
<a name="l00045"></a>00045   {
<a name="l00046"></a>00046     <span class="keywordflow">return</span> <a class="code" href="classmapvector.php#a34511f3fd698ed0b38b18c498fd8d9ad">maptype::operator[]</a>(k);
<a name="l00047"></a>00047   }
<a name="l00048"></a><a class="code" href="classmapvector.php#ad6ba17efba30a038664c6a8a390b6ba5">00048</a>   Val <a class="code" href="classmapvector.php#a34511f3fd698ed0b38b18c498fd8d9ad">operator[] </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;k)<span class="keyword"> const </span>
<a name="l00049"></a>00049 <span class="keyword">  </span>{
<a name="l00050"></a>00050     <span class="keyword">typename</span> maptype::const_iterator it = this-&gt;find(k);
<a name="l00051"></a>00051       <span class="keywordflow">return</span> it == this-&gt;<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>().<a class="code" href="classmapvector_1_1veclike__iterator.php#afbdf23f8e2cd12aa859b0e0590a5bb1f">it</a>? Val() : it-&gt;second;
<a name="l00052"></a>00052   }
<a name="l00053"></a>00053 
<a name="l00054"></a><a class="code" href="classmapvector_1_1veclike__iterator.php">00054</a>   <span class="keyword">class </span><a class="code" href="classmapvector_1_1veclike__iterator.php">veclike_iterator</a>
<a name="l00055"></a>00055   {
<a name="l00056"></a>00056   <span class="keyword">public</span>:
<a name="l00057"></a><a class="code" href="classmapvector_1_1veclike__iterator.php#a7a45917c99e72f44b32cfb5f10c9f967">00057</a>     <a class="code" href="classmapvector_1_1veclike__iterator.php#a7a45917c99e72f44b32cfb5f10c9f967">veclike_iterator</a>(<span class="keyword">const</span> <span class="keyword">typename</span> maptype::iterator &amp;i)
<a name="l00058"></a>00058       : <a class="code" href="classmapvector_1_1veclike__iterator.php#afbdf23f8e2cd12aa859b0e0590a5bb1f">it</a>(i) {}
<a name="l00059"></a>00059 
<a name="l00060"></a><a class="code" href="classmapvector_1_1veclike__iterator.php#a5a833bc03cc20dcb23aa345fba6885cb">00060</a>     <a class="code" href="classmapvector_1_1veclike__iterator.php#a7a45917c99e72f44b32cfb5f10c9f967">veclike_iterator</a>(<span class="keyword">const</span> <a class="code" href="classmapvector_1_1veclike__iterator.php">veclike_iterator</a> &amp;i)
<a name="l00061"></a>00061       : <a class="code" href="classmapvector_1_1veclike__iterator.php#afbdf23f8e2cd12aa859b0e0590a5bb1f">it</a>(i.<a class="code" href="classmapvector_1_1veclike__iterator.php#afbdf23f8e2cd12aa859b0e0590a5bb1f">it</a>) {}
<a name="l00062"></a>00062 
<a name="l00063"></a><a class="code" href="classmapvector_1_1veclike__iterator.php#a84150508ab4ac43e40945b8119089354">00063</a>     Val&amp; <a class="code" href="classmapvector_1_1veclike__iterator.php#a84150508ab4ac43e40945b8119089354">operator*</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classmapvector_1_1veclike__iterator.php#afbdf23f8e2cd12aa859b0e0590a5bb1f">it</a>-&gt;second; }
<a name="l00064"></a>00064 
<a name="l00065"></a><a class="code" href="classmapvector_1_1veclike__iterator.php#a98ea7a2e0b37bf51e2c21463b669f698">00065</a>     <a class="code" href="classmapvector_1_1veclike__iterator.php">veclike_iterator</a>&amp; <a class="code" href="classmapvector_1_1veclike__iterator.php#a98ea7a2e0b37bf51e2c21463b669f698">operator++</a>() { ++<a class="code" href="classmapvector_1_1veclike__iterator.php#afbdf23f8e2cd12aa859b0e0590a5bb1f">it</a>; <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00066"></a>00066 
<a name="l00067"></a><a class="code" href="classmapvector_1_1veclike__iterator.php#a085731b9226e6fe37b070be921af1d74">00067</a>     <a class="code" href="classmapvector_1_1veclike__iterator.php">veclike_iterator</a> <a class="code" href="classmapvector_1_1veclike__iterator.php#a085731b9226e6fe37b070be921af1d74">operator++</a>(<span class="keywordtype">int</span>) {
<a name="l00068"></a>00068       <a class="code" href="classmapvector_1_1veclike__iterator.php">veclike_iterator</a> i = *<span class="keyword">this</span>;
<a name="l00069"></a>00069       ++(*this);
<a name="l00070"></a>00070       <span class="keywordflow">return</span> i;
<a name="l00071"></a>00071     }
<a name="l00072"></a>00072 
<a name="l00073"></a><a class="code" href="classmapvector_1_1veclike__iterator.php#a6ad10ebb7f5a451c9c3c91f9f8f2b364">00073</a>     <span class="keywordtype">bool</span> <a class="code" href="classmapvector_1_1veclike__iterator.php#a6ad10ebb7f5a451c9c3c91f9f8f2b364">operator==</a>(<span class="keyword">const</span> <a class="code" href="classmapvector_1_1veclike__iterator.php">veclike_iterator</a> &amp;other)<span class="keyword"> const </span>{
<a name="l00074"></a>00074       <span class="keywordflow">return</span> <a class="code" href="classmapvector_1_1veclike__iterator.php#afbdf23f8e2cd12aa859b0e0590a5bb1f">it</a> == other.<a class="code" href="classmapvector_1_1veclike__iterator.php#afbdf23f8e2cd12aa859b0e0590a5bb1f">it</a>;
<a name="l00075"></a>00075     }
<a name="l00076"></a>00076 
<a name="l00077"></a><a class="code" href="classmapvector_1_1veclike__iterator.php#aae08e7bea9eb45a6bad042fc55eb6671">00077</a>     <span class="keywordtype">bool</span> <a class="code" href="classmapvector_1_1veclike__iterator.php#aae08e7bea9eb45a6bad042fc55eb6671">operator!=</a>(<span class="keyword">const</span> <a class="code" href="classmapvector_1_1veclike__iterator.php">veclike_iterator</a> &amp;other)<span class="keyword"> const </span>{
<a name="l00078"></a>00078       <span class="keywordflow">return</span> <a class="code" href="classmapvector_1_1veclike__iterator.php#afbdf23f8e2cd12aa859b0e0590a5bb1f">it</a> != other.<a class="code" href="classmapvector_1_1veclike__iterator.php#afbdf23f8e2cd12aa859b0e0590a5bb1f">it</a>;
<a name="l00079"></a>00079     }
<a name="l00080"></a>00080 
<a name="l00081"></a><a class="code" href="classmapvector_1_1veclike__iterator.php#afbdf23f8e2cd12aa859b0e0590a5bb1f">00081</a>     <span class="keyword">typename</span> maptype::iterator <a class="code" href="classmapvector_1_1veclike__iterator.php#afbdf23f8e2cd12aa859b0e0590a5bb1f">it</a>;
<a name="l00082"></a>00082   };
<a name="l00083"></a>00083 
<a name="l00084"></a><a class="code" href="classmapvector_1_1const__veclike__iterator.php">00084</a>   <span class="keyword">class </span><a class="code" href="classmapvector_1_1const__veclike__iterator.php">const_veclike_iterator</a>
<a name="l00085"></a>00085   {
<a name="l00086"></a>00086   <span class="keyword">public</span>:
<a name="l00087"></a><a class="code" href="classmapvector_1_1const__veclike__iterator.php#ab3607e3dc75d748e84533e108b326ead">00087</a>     <a class="code" href="classmapvector_1_1const__veclike__iterator.php#ab3607e3dc75d748e84533e108b326ead">const_veclike_iterator</a>(<span class="keyword">const</span> <span class="keyword">typename</span> maptype::const_iterator &amp;i)
<a name="l00088"></a>00088       : <a class="code" href="classmapvector_1_1const__veclike__iterator.php#a85575199811f9ef61a3c402ffcf0fc34">it</a>(i) {}
<a name="l00089"></a>00089 
<a name="l00090"></a><a class="code" href="classmapvector_1_1const__veclike__iterator.php#a9664b464dda59fd4df1c1cfcd05543b0">00090</a>     <a class="code" href="classmapvector_1_1const__veclike__iterator.php#ab3607e3dc75d748e84533e108b326ead">const_veclike_iterator</a>(<span class="keyword">const</span> <a class="code" href="classmapvector_1_1const__veclike__iterator.php">const_veclike_iterator</a> &amp;i)
<a name="l00091"></a>00091       : <a class="code" href="classmapvector_1_1const__veclike__iterator.php#a85575199811f9ef61a3c402ffcf0fc34">it</a>(i.<a class="code" href="classmapvector_1_1const__veclike__iterator.php#a85575199811f9ef61a3c402ffcf0fc34">it</a>) {}
<a name="l00092"></a>00092 
<a name="l00093"></a><a class="code" href="classmapvector_1_1const__veclike__iterator.php#a288e61fff4b976e392710e3b21a6aeff">00093</a>     <a class="code" href="classmapvector_1_1const__veclike__iterator.php#ab3607e3dc75d748e84533e108b326ead">const_veclike_iterator</a>(<span class="keyword">const</span> <a class="code" href="classmapvector_1_1veclike__iterator.php">veclike_iterator</a> &amp;i)
<a name="l00094"></a>00094       : <a class="code" href="classmapvector_1_1const__veclike__iterator.php#a85575199811f9ef61a3c402ffcf0fc34">it</a>(i.<a class="code" href="classmapvector_1_1const__veclike__iterator.php#a85575199811f9ef61a3c402ffcf0fc34">it</a>) {}
<a name="l00095"></a>00095 
<a name="l00096"></a><a class="code" href="classmapvector_1_1const__veclike__iterator.php#a3394376d2067797a2bfeb5ec58fc90af">00096</a>     <span class="keyword">const</span> Val&amp; <a class="code" href="classmapvector_1_1const__veclike__iterator.php#a3394376d2067797a2bfeb5ec58fc90af">operator*</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classmapvector_1_1const__veclike__iterator.php#a85575199811f9ef61a3c402ffcf0fc34">it</a>-&gt;second; }
<a name="l00097"></a>00097 
<a name="l00098"></a><a class="code" href="classmapvector_1_1const__veclike__iterator.php#acf1b14a339775310641c0d9a3b6888e6">00098</a>     <a class="code" href="classmapvector_1_1const__veclike__iterator.php">const_veclike_iterator</a>&amp; <a class="code" href="classmapvector_1_1const__veclike__iterator.php#acf1b14a339775310641c0d9a3b6888e6">operator++</a>() { ++<a class="code" href="classmapvector_1_1const__veclike__iterator.php#a85575199811f9ef61a3c402ffcf0fc34">it</a>; <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00099"></a>00099 
<a name="l00100"></a><a class="code" href="classmapvector_1_1const__veclike__iterator.php#a0e39d08472670fa85bb7edba84bfd518">00100</a>     <a class="code" href="classmapvector_1_1const__veclike__iterator.php">const_veclike_iterator</a> <a class="code" href="classmapvector_1_1const__veclike__iterator.php#a0e39d08472670fa85bb7edba84bfd518">operator++</a>(<span class="keywordtype">int</span>) {
<a name="l00101"></a>00101       <a class="code" href="classmapvector_1_1veclike__iterator.php">veclike_iterator</a> i = *<span class="keyword">this</span>;
<a name="l00102"></a>00102       ++(*this);
<a name="l00103"></a>00103       <span class="keywordflow">return</span> i;
<a name="l00104"></a>00104     }
<a name="l00105"></a>00105 
<a name="l00106"></a><a class="code" href="classmapvector_1_1const__veclike__iterator.php#ad7e30114117ec00b56213cef63b3891f">00106</a>     <span class="keywordtype">bool</span> <a class="code" href="classmapvector_1_1const__veclike__iterator.php#ad7e30114117ec00b56213cef63b3891f">operator==</a>(<span class="keyword">const</span> <a class="code" href="classmapvector_1_1const__veclike__iterator.php">const_veclike_iterator</a> &amp;other)<span class="keyword"> const </span>{
<a name="l00107"></a>00107       <span class="keywordflow">return</span> <a class="code" href="classmapvector_1_1const__veclike__iterator.php#a85575199811f9ef61a3c402ffcf0fc34">it</a> == other.<a class="code" href="classmapvector_1_1const__veclike__iterator.php#a85575199811f9ef61a3c402ffcf0fc34">it</a>;
<a name="l00108"></a>00108     }
<a name="l00109"></a>00109 
<a name="l00110"></a><a class="code" href="classmapvector_1_1const__veclike__iterator.php#a598c2a6de166f76f6ccfc0b845158bb8">00110</a>     <span class="keywordtype">bool</span> <a class="code" href="classmapvector_1_1const__veclike__iterator.php#a598c2a6de166f76f6ccfc0b845158bb8">operator!=</a>(<span class="keyword">const</span> <a class="code" href="classmapvector_1_1const__veclike__iterator.php">const_veclike_iterator</a> &amp;other)<span class="keyword"> const </span>{
<a name="l00111"></a>00111       <span class="keywordflow">return</span> <a class="code" href="classmapvector_1_1const__veclike__iterator.php#a85575199811f9ef61a3c402ffcf0fc34">it</a> != other.<a class="code" href="classmapvector_1_1const__veclike__iterator.php#a85575199811f9ef61a3c402ffcf0fc34">it</a>;
<a name="l00112"></a>00112     }
<a name="l00113"></a>00113 
<a name="l00114"></a><a class="code" href="classmapvector_1_1const__veclike__iterator.php#a85575199811f9ef61a3c402ffcf0fc34">00114</a>     <span class="keyword">typename</span> maptype::const_iterator <a class="code" href="classmapvector_1_1const__veclike__iterator.php#a85575199811f9ef61a3c402ffcf0fc34">it</a>;
<a name="l00115"></a>00115   };
<a name="l00116"></a>00116 
<a name="l00117"></a><a class="code" href="classmapvector.php#aee38e1c8f77d4eeff04b74d19500429f">00117</a>   <span class="keywordtype">void</span> <a class="code" href="classmapvector.php#aee38e1c8f77d4eeff04b74d19500429f">erase</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) {
<a name="l00118"></a>00118       <a class="code" href="classmapvector.php#aee38e1c8f77d4eeff04b74d19500429f">maptype::erase</a>(i);
<a name="l00119"></a>00119   }
<a name="l00120"></a>00120 
<a name="l00121"></a><a class="code" href="classmapvector.php#a8d9cb9f5b89e9827537679d43c249b4f">00121</a>   <span class="keywordtype">void</span> <a class="code" href="classmapvector.php#a8d9cb9f5b89e9827537679d43c249b4f">erase</a>(<span class="keyword">const</span> veclike_iterator &amp;pos) {
<a name="l00122"></a>00122       <a class="code" href="classmapvector.php#aee38e1c8f77d4eeff04b74d19500429f">maptype::erase</a>(pos.it);
<a name="l00123"></a>00123   }
<a name="l00124"></a>00124 
<a name="l00125"></a><a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">00125</a>   veclike_iterator <a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>() {
<a name="l00126"></a>00126     <span class="keywordflow">return</span> veclike_iterator(maptype::begin());
<a name="l00127"></a>00127   }
<a name="l00128"></a>00128 
<a name="l00129"></a><a class="code" href="classmapvector.php#a307328dc56fd058ecee7cdba9b3b5bc0">00129</a>   const_veclike_iterator <a class="code" href="classmapvector.php#a307328dc56fd058ecee7cdba9b3b5bc0">begin</a>()<span class="keyword"> const </span>{
<a name="l00130"></a>00130     <span class="keywordflow">return</span> const_veclike_iterator(maptype::begin());
<a name="l00131"></a>00131   }
<a name="l00132"></a>00132 
<a name="l00133"></a><a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">00133</a>   veclike_iterator <a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>() {
<a name="l00134"></a>00134     <span class="keywordflow">return</span> veclike_iterator(maptype::end());
<a name="l00135"></a>00135   }
<a name="l00136"></a>00136 
<a name="l00137"></a><a class="code" href="classmapvector.php#a48b96c415af9d049899a203a9f43911b">00137</a>   const_veclike_iterator <a class="code" href="classmapvector.php#a48b96c415af9d049899a203a9f43911b">end</a>()<span class="keyword"> const </span>{
<a name="l00138"></a>00138     <span class="keywordflow">return</span> const_veclike_iterator(maptype::end());
<a name="l00139"></a>00139   }
<a name="l00140"></a>00140 };
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 <span class="preprocessor">#endif // __mapvector_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
