<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>matlab_io.C</h1>  </div>
</div>
<div class="contents">
<a href="matlab__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: matlab_io.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;matlab_io.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;face_tri3.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00030"></a>00030 <span class="comment">// MatlabIO class members</span>
<a name="l00031"></a>00031 
<a name="l00032"></a><a class="code" href="classMatlabIO.php#a3a6ccb2025cb0c6e64c6813acdada143">00032</a> <span class="keywordtype">void</span> <a class="code" href="classMatlabIO.php#a3a6ccb2025cb0c6e64c6813acdada143">MatlabIO::read</a>(<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034   std::ifstream in (name.c_str());
<a name="l00035"></a>00035 
<a name="l00036"></a>00036   this-&gt;<a class="code" href="classMatlabIO.php#a207f96c9be8ef76f489b8b84e491e823">read_stream</a>(in);
<a name="l00037"></a>00037 }
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a><a class="code" href="classMatlabIO.php#a207f96c9be8ef76f489b8b84e491e823">00040</a> <span class="keywordtype">void</span> <a class="code" href="classMatlabIO.php#a207f96c9be8ef76f489b8b84e491e823">MatlabIO::read_stream</a>(std::istream&amp; in)
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042   <span class="comment">// This is a serial-only process for now;</span>
<a name="l00043"></a>00043   <span class="comment">// the Mesh should be read on processor 0 and</span>
<a name="l00044"></a>00044   <span class="comment">// broadcast later</span>
<a name="l00045"></a>00045   libmesh_assert(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0);
<a name="l00046"></a>00046 
<a name="l00047"></a>00047   <span class="comment">// Get a reference to the mesh</span>
<a name="l00048"></a>00048   <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   <span class="comment">// Clear any existing mesh data</span>
<a name="l00051"></a>00051   mesh.<a class="code" href="classMeshBase.php#aefd56c4c29285d5e845f8869112b2b67">clear</a>();
<a name="l00052"></a>00052   
<a name="l00053"></a>00053   <span class="comment">// PDE toolkit only works in 2D</span>
<a name="l00054"></a>00054   libmesh_assert(mesh.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>() == 2);
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   <span class="comment">// Check the input buffer</span>
<a name="l00057"></a>00057   libmesh_assert (in.good());
<a name="l00058"></a>00058 
<a name="l00059"></a>00059   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nNodes=0, nElem=0;
<a name="l00060"></a>00060 
<a name="l00061"></a>00061   in &gt;&gt; nNodes   <span class="comment">// Read the number of nodes</span>
<a name="l00062"></a>00062      &gt;&gt; nElem;   <span class="comment">// Read the number of elements</span>
<a name="l00063"></a>00063 
<a name="l00064"></a>00064   <span class="comment">// Sort of check that it worked</span>
<a name="l00065"></a>00065   libmesh_assert(nNodes &gt; 0);
<a name="l00066"></a>00066   libmesh_assert(nElem &gt; 0);
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   <span class="comment">// Read the nodal coordinates</span>
<a name="l00069"></a>00069   {
<a name="l00070"></a>00070     <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> x=0., y=0., z=0.;
<a name="l00071"></a>00071 
<a name="l00072"></a>00072     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nNodes; i++)
<a name="l00073"></a>00073       {
<a name="l00074"></a>00074         in &gt;&gt; x   <span class="comment">// x-coordinate value</span>
<a name="l00075"></a>00075            &gt;&gt; y;  <span class="comment">// y-coordinate value</span>
<a name="l00076"></a>00076 
<a name="l00077"></a>00077         mesh.<a class="code" href="classMeshBase.php#a01b66468d3e9d8b5db82c6f3d9131f5e">add_point</a> ( <a class="code" href="classPoint.php">Point</a>(x,y,z), i);
<a name="l00078"></a>00078       }
<a name="l00079"></a>00079   }
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <span class="comment">// Read the elements (elements)</span>
<a name="l00082"></a>00082   {
<a name="l00083"></a>00083     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node=0, dummy=0;
<a name="l00084"></a>00084     
<a name="l00085"></a>00085     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nElem; i++)
<a name="l00086"></a>00086       {
<a name="l00087"></a>00087         <a class="code" href="classElem.php">Elem</a>* elem = <span class="keyword">new</span> <a class="code" href="classTri3.php">Tri3</a>; <span class="comment">// Always build a triangle</span>
<a name="l00088"></a>00088         elem-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a>(i);
<a name="l00089"></a>00089         mesh.<a class="code" href="classMeshBase.php#a0f6974cf3e413cfe9caa1fcb4ce8153e">add_elem</a> (elem);
<a name="l00090"></a>00090         
<a name="l00091"></a>00091         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;3; n++)  <span class="comment">// Always read three 3 nodes</span>
<a name="l00092"></a>00092           {
<a name="l00093"></a>00093             in &gt;&gt; node;
<a name="l00094"></a>00094             elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(n) = mesh.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(node-1);  <span class="comment">// Assign the node number</span>
<a name="l00095"></a>00095           }
<a name="l00096"></a>00096         
<a name="l00097"></a>00097         <span class="comment">// There is an additional subdomain number here,</span>
<a name="l00098"></a>00098         <span class="comment">// so we read it and get rid of it!</span>
<a name="l00099"></a>00099         in &gt;&gt; dummy;
<a name="l00100"></a>00100       }
<a name="l00101"></a>00101   }
<a name="l00102"></a>00102   
<a name="l00103"></a>00103 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
