<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>medit_io.C</h1>  </div>
</div>
<div class="contents">
<a href="medit__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: medit_io.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;iomanip&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;medit_io.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00034"></a>00034 <span class="comment">// MEDITIO  members</span>
<a name="l00035"></a><a class="code" href="classMEDITIO.php#a06408f59e30e825892d65ba668801aa1">00035</a> <span class="keywordtype">void</span> <a class="code" href="classMEDITIO.php#a06408f59e30e825892d65ba668801aa1">MEDITIO::write</a> (<span class="keyword">const</span> std::string&amp; fname)
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00038"></a>00038     <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classMEDITIO.php#ae7ca93732e9a0d25579f041235cd712d">binary</a>())
<a name="l00039"></a>00039       this-&gt;<a class="code" href="classMEDITIO.php#a8c6f10f6449aba83fbe8d2ce0f51ceae">write_ascii</a>  (fname);
<a name="l00040"></a>00040 }
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a><a class="code" href="classMEDITIO.php#af08dd6969502b328d92d8fcd5a025659">00044</a> <span class="keywordtype">void</span> <a class="code" href="classMEDITIO.php#af08dd6969502b328d92d8fcd5a025659">MEDITIO::write_nodal_data</a> (<span class="keyword">const</span> std::string&amp; fname,
<a name="l00045"></a>00045                               <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; soln,
<a name="l00046"></a>00046                               <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; names)
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00049"></a>00049     <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classMEDITIO.php#ae7ca93732e9a0d25579f041235cd712d">binary</a>())
<a name="l00050"></a>00050       this-&gt;<a class="code" href="classMEDITIO.php#a8c6f10f6449aba83fbe8d2ce0f51ceae">write_ascii</a>  (fname, &amp;soln, &amp;names);
<a name="l00051"></a>00051 }
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="classMEDITIO.php#a8c6f10f6449aba83fbe8d2ce0f51ceae">00055</a> <span class="keywordtype">void</span> <a class="code" href="classMEDITIO.php#a8c6f10f6449aba83fbe8d2ce0f51ceae">MEDITIO::write_ascii</a> (<span class="keyword">const</span> std::string&amp; fname,
<a name="l00056"></a>00056                            <span class="keyword">const</span> std::vector&lt;Number&gt;* vec,
<a name="l00057"></a>00057                            <span class="keyword">const</span> std::vector&lt;std::string&gt;* solution_names)
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059   <span class="comment">// Current lacks in implementation:</span>
<a name="l00060"></a>00060   <span class="comment">//  (i)   only 3D meshes.</span>
<a name="l00061"></a>00061   <span class="comment">//  (ii)  only QUAD4, TRI3, TET4 elements, others are omitted !</span>
<a name="l00062"></a>00062   <span class="comment">//  (iii) no distinction between materials.</span>
<a name="l00063"></a>00063   <span class="comment">//  (iv)  no vector output, just first scalar as output</span>
<a name="l00064"></a>00064 
<a name="l00065"></a>00065   <span class="comment">// libmesh_assert three dimensions (should be extended later)</span>
<a name="l00066"></a>00066   libmesh_assert (<a class="code" href="classMeshOutput.php">MeshOutput&lt;MeshBase&gt;::mesh</a>().mesh_dimension() == 3);
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   <span class="comment">// Open the output file stream</span>
<a name="l00069"></a>00069   std::ofstream out (fname.c_str());
<a name="l00070"></a>00070   
<a name="l00071"></a>00071   <span class="comment">// Make sure it opened correctly</span>
<a name="l00072"></a>00072   <span class="keywordflow">if</span> (!out.good())
<a name="l00073"></a>00073     libmesh_file_error(fname.c_str());
<a name="l00074"></a>00074 
<a name="l00075"></a>00075   <span class="comment">// Get a reference to the mesh</span>
<a name="l00076"></a>00076   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshOutput.php#af923657f1dcc7c26a973332295d94f13">mesh</a> = <a class="code" href="classMeshOutput.php#af923657f1dcc7c26a973332295d94f13">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00077"></a>00077   
<a name="l00078"></a>00078   <span class="comment">// Begin interfacing with the MEdit data file</span>
<a name="l00079"></a>00079   {
<a name="l00080"></a>00080     <span class="comment">// header:</span>
<a name="l00081"></a>00081     out &lt;&lt; <span class="stringliteral">&quot;MeshVersionFormatted  1\n&quot;</span>;
<a name="l00082"></a>00082     out &lt;&lt; <span class="stringliteral">&quot;Dimension  3\n&quot;</span>;
<a name="l00083"></a>00083     out &lt;&lt; <span class="stringliteral">&quot;# Mesh generated by libmesh\n\n&quot;</span>;
<a name="l00084"></a>00084 
<a name="l00085"></a>00085     <span class="comment">// write the nodes:</span>
<a name="l00086"></a>00086     out &lt;&lt; <span class="stringliteral">&quot;# Set of mesh vertices\n&quot;</span>;
<a name="l00087"></a>00087     out &lt;&lt; <span class="stringliteral">&quot;Vertices\n&quot;</span>;
<a name="l00088"></a>00088     out &lt;&lt; mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>() &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00089"></a>00089 
<a name="l00090"></a>00090     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>(); v++)
<a name="l00091"></a>00091       out &lt;&lt; mesh.<a class="code" href="classMeshBase.php#a06af1f178519c606d0bdca7857f95ba6">point</a>(v)(0) &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; mesh.<a class="code" href="classMeshBase.php#a06af1f178519c606d0bdca7857f95ba6">point</a>(v)(1) &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; mesh.<a class="code" href="classMeshBase.php#a06af1f178519c606d0bdca7857f95ba6">point</a>(v)(2) &lt;&lt; <span class="stringliteral">&quot; 0\n&quot;</span>;
<a name="l00092"></a>00092   }
<a name="l00093"></a>00093 
<a name="l00094"></a>00094   {
<a name="l00095"></a>00095     <span class="comment">// write the connectivity:</span>
<a name="l00096"></a>00096     out &lt;&lt; <span class="stringliteral">&quot;\n# Set of Polys\n\n&quot;</span>;
<a name="l00097"></a>00097     
<a name="l00098"></a>00098     <span class="comment">// count occurrences of output elements:</span>
<a name="l00099"></a>00099     <span class="keywordtype">int</span> n_tri3  = 0;
<a name="l00100"></a>00100     <span class="keywordtype">int</span> n_quad4 = 0;
<a name="l00101"></a>00101     <span class="keywordtype">int</span> n_tet4  = 0;
<a name="l00102"></a>00102 
<a name="l00103"></a>00103     {
<a name="l00104"></a>00104 <span class="comment">//       const_active_elem_iterator       it (mesh.elements_begin());</span>
<a name="l00105"></a>00105 <span class="comment">//       const const_active_elem_iterator end(mesh.elements_end());</span>
<a name="l00106"></a>00106 
<a name="l00107"></a>00107       <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00108"></a>00108       <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00109"></a>00109       
<a name="l00110"></a>00110       <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l00111"></a>00111         {
<a name="l00112"></a>00112           <span class="keywordflow">if</span> ((*it)-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>)  n_tri3++;
<a name="l00113"></a>00113           <span class="keywordflow">if</span> ((*it)-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>) n_quad4++;
<a name="l00114"></a>00114           <span class="keywordflow">if</span> ((*it)-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>) n_quad4+=4; <span class="comment">// (QUAD9 is written as 4 QUAD4.)</span>
<a name="l00115"></a>00115           <span class="keywordflow">if</span> ((*it)-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>)  n_tet4++;
<a name="l00116"></a>00116         } <span class="comment">// for</span>
<a name="l00117"></a>00117     }
<a name="l00118"></a>00118     
<a name="l00119"></a>00119     <span class="comment">// First: write out TRI3 elements:</span>
<a name="l00120"></a>00120     out &lt;&lt; <span class="stringliteral">&quot;Triangles\n&quot;</span>;
<a name="l00121"></a>00121     out &lt;&lt; n_tri3 &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00122"></a>00122 
<a name="l00123"></a>00123     {
<a name="l00124"></a>00124 <span class="comment">//       const_active_elem_iterator       it (mesh.elements_begin());</span>
<a name="l00125"></a>00125 <span class="comment">//       const const_active_elem_iterator end(mesh.elements_end());</span>
<a name="l00126"></a>00126 
<a name="l00127"></a>00127       <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00128"></a>00128       <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00129"></a>00129     
<a name="l00130"></a>00130       <span class="keywordflow">for</span> ( ; it != end; ++it) 
<a name="l00131"></a>00131         <span class="keywordflow">if</span> ((*it)-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>)
<a name="l00132"></a>00132           out &lt;&lt; (*it)-&gt;node(0)+1  &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; (*it)-&gt;node(1)+1  &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; (*it)-&gt;node(2)+1  &lt;&lt; <span class="stringliteral">&quot; 0\n&quot;</span>;
<a name="l00133"></a>00133     }
<a name="l00134"></a>00134     
<a name="l00135"></a>00135     <span class="comment">// Second: write out QUAD4 elements:</span>
<a name="l00136"></a>00136     out &lt;&lt; <span class="stringliteral">&quot;Quadrilaterals\n&quot;</span>;
<a name="l00137"></a>00137     out &lt;&lt; n_quad4 &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00138"></a>00138 
<a name="l00139"></a>00139     {
<a name="l00140"></a>00140 <span class="comment">//       const_active_elem_iterator       it (mesh.elements_begin());</span>
<a name="l00141"></a>00141 <span class="comment">//       const const_active_elem_iterator end(mesh.elements_end());</span>
<a name="l00142"></a>00142 
<a name="l00143"></a>00143       <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00144"></a>00144       <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00145"></a>00145 
<a name="l00146"></a>00146       <span class="keywordflow">for</span> ( ; it != end; ++it) 
<a name="l00147"></a>00147         <span class="keywordflow">if</span> ((*it)-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>)
<a name="l00148"></a>00148           {
<a name="l00149"></a>00149             out &lt;&lt; (*it)-&gt;node(0)+1  &lt;&lt; <span class="stringliteral">&quot; &quot;</span> 
<a name="l00150"></a>00150                 &lt;&lt; (*it)-&gt;node(1)+1  &lt;&lt; <span class="stringliteral">&quot; &quot;</span> 
<a name="l00151"></a>00151                 &lt;&lt; (*it)-&gt;node(2)+1  &lt;&lt; <span class="stringliteral">&quot; &quot;</span> 
<a name="l00152"></a>00152                 &lt;&lt; (*it)-&gt;node(3)+1  &lt;&lt;<span class="stringliteral">&quot; 0\n&quot;</span>;
<a name="l00153"></a>00153           } <span class="comment">// if</span>
<a name="l00154"></a>00154         <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((*it)-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>)
<a name="l00155"></a>00155           {
<a name="l00156"></a>00156             out &lt;&lt; (*it)-&gt;node(0)+1  &lt;&lt; <span class="stringliteral">&quot; &quot;</span> 
<a name="l00157"></a>00157                 &lt;&lt; (*it)-&gt;node(4)+1  &lt;&lt; <span class="stringliteral">&quot; &quot;</span> 
<a name="l00158"></a>00158                 &lt;&lt; (*it)-&gt;node(8)+1  &lt;&lt; <span class="stringliteral">&quot; &quot;</span> 
<a name="l00159"></a>00159                 &lt;&lt; (*it)-&gt;node(7)+1  &lt;&lt;<span class="stringliteral">&quot; 0\n&quot;</span>;
<a name="l00160"></a>00160             out &lt;&lt; (*it)-&gt;node(7)+1  &lt;&lt; <span class="stringliteral">&quot; &quot;</span> 
<a name="l00161"></a>00161                 &lt;&lt; (*it)-&gt;node(8)+1  &lt;&lt; <span class="stringliteral">&quot; &quot;</span> 
<a name="l00162"></a>00162                 &lt;&lt; (*it)-&gt;node(6)+1  &lt;&lt; <span class="stringliteral">&quot; &quot;</span> 
<a name="l00163"></a>00163                 &lt;&lt; (*it)-&gt;node(3)+1  &lt;&lt;<span class="stringliteral">&quot; 0\n&quot;</span>;
<a name="l00164"></a>00164             out &lt;&lt; (*it)-&gt;node(4)+1  &lt;&lt; <span class="stringliteral">&quot; &quot;</span> 
<a name="l00165"></a>00165                 &lt;&lt; (*it)-&gt;node(1)+1  &lt;&lt; <span class="stringliteral">&quot; &quot;</span> 
<a name="l00166"></a>00166                 &lt;&lt; (*it)-&gt;node(5)+1  &lt;&lt; <span class="stringliteral">&quot; &quot;</span> 
<a name="l00167"></a>00167                 &lt;&lt; (*it)-&gt;node(8)+1  &lt;&lt;<span class="stringliteral">&quot; 0\n&quot;</span>;
<a name="l00168"></a>00168             out &lt;&lt; (*it)-&gt;node(8)+1  &lt;&lt; <span class="stringliteral">&quot; &quot;</span> 
<a name="l00169"></a>00169                 &lt;&lt; (*it)-&gt;node(5)+1  &lt;&lt; <span class="stringliteral">&quot; &quot;</span> 
<a name="l00170"></a>00170                 &lt;&lt; (*it)-&gt;node(2)+1  &lt;&lt; <span class="stringliteral">&quot; &quot;</span> 
<a name="l00171"></a>00171                 &lt;&lt; (*it)-&gt;node(6)+1  &lt;&lt;<span class="stringliteral">&quot; 0\n&quot;</span>;
<a name="l00172"></a>00172           } <span class="comment">// if</span>
<a name="l00173"></a>00173     }
<a name="l00174"></a>00174 
<a name="l00175"></a>00175     
<a name="l00176"></a>00176     <span class="comment">// Third: write out TET4 elements:</span>
<a name="l00177"></a>00177     out &lt;&lt; <span class="stringliteral">&quot;Tetrahedra\n&quot;</span>;
<a name="l00178"></a>00178     out &lt;&lt; n_tet4 &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00179"></a>00179 
<a name="l00180"></a>00180     {
<a name="l00181"></a>00181 <span class="comment">//       const_active_elem_iterator       it (mesh.elements_begin());</span>
<a name="l00182"></a>00182 <span class="comment">//       const const_active_elem_iterator end(mesh.elements_end());</span>
<a name="l00183"></a>00183 
<a name="l00184"></a>00184       <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00185"></a>00185       <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00186"></a>00186       
<a name="l00187"></a>00187       <span class="keywordflow">for</span> ( ; it != end; ++it) 
<a name="l00188"></a>00188         <span class="keywordflow">if</span> ((*it)-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>)
<a name="l00189"></a>00189           {
<a name="l00190"></a>00190             out &lt;&lt; (*it)-&gt;node(0)+1  &lt;&lt; <span class="stringliteral">&quot; &quot;</span> 
<a name="l00191"></a>00191                 &lt;&lt; (*it)-&gt;node(1)+1  &lt;&lt; <span class="stringliteral">&quot; &quot;</span> 
<a name="l00192"></a>00192                 &lt;&lt; (*it)-&gt;node(2)+1  &lt;&lt; <span class="stringliteral">&quot; &quot;</span> 
<a name="l00193"></a>00193                 &lt;&lt; (*it)-&gt;node(3)+1  &lt;&lt;<span class="stringliteral">&quot; 0\n&quot;</span>;
<a name="l00194"></a>00194           } <span class="comment">// if</span>
<a name="l00195"></a>00195     }
<a name="l00196"></a>00196     
<a name="l00197"></a>00197   }  
<a name="l00198"></a>00198   <span class="comment">// end of the out file</span>
<a name="l00199"></a>00199   out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span> &lt;&lt; <span class="stringliteral">&quot;# end of file\n&quot;</span>;
<a name="l00200"></a>00200 
<a name="l00201"></a>00201   <span class="comment">// optionally write the data</span>
<a name="l00202"></a>00202   <span class="keywordflow">if</span> ((solution_names != NULL) &amp;&amp;
<a name="l00203"></a>00203       (vec != NULL))
<a name="l00204"></a>00204     {
<a name="l00205"></a>00205       <span class="comment">// Open the &quot;.bb&quot; file stream</span>
<a name="l00206"></a>00206       <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a> = fname.find_last_of(<span class="stringliteral">&quot;.&quot;</span>);
<a name="l00207"></a>00207       std::string bbname = fname.substr(0,idx) + <span class="stringliteral">&quot;.bb&quot;</span>;
<a name="l00208"></a>00208       
<a name="l00209"></a>00209       std::ofstream bbout (bbname.c_str());
<a name="l00210"></a>00210 
<a name="l00211"></a>00211       <span class="comment">// Make sure it opened correctly</span>
<a name="l00212"></a>00212       <span class="keywordflow">if</span> (!out.good())
<a name="l00213"></a>00213         libmesh_file_error(bbname.c_str());
<a name="l00214"></a>00214 
<a name="l00215"></a>00215       <span class="comment">// Header: 3: 3D mesh, 1: scalar output, 2: node-indexed </span>
<a name="l00216"></a>00216       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_vars = solution_names-&gt;size();
<a name="l00217"></a>00217       bbout &lt;&lt; <span class="stringliteral">&quot;3 1 &quot;</span> &lt;&lt; mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>() &lt;&lt; <span class="stringliteral">&quot; 2\n&quot;</span>;
<a name="l00218"></a>00218       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>(); n++)
<a name="l00219"></a>00219         bbout &lt;&lt; std::setprecision(10) &lt;&lt; (*vec)[n*n_vars + <a class="code" href="classMEDITIO.php#a431fc4cd81d32e128f3dbf2e2a6b8f93">scalar_idx</a>] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00220"></a>00220       bbout &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00221"></a>00221     } <span class="comment">// endif</span>
<a name="l00222"></a>00222 }
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 
<a name="l00226"></a>00226 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
