<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>medit_io.h</h1>  </div>
</div>
<div class="contents">
<a href="medit__io_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: medit_io.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __medit_io_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __medit_io_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="mesh__output_8h.php">mesh_output.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Forward declarations:</span>
<a name="l00030"></a>00030 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00045"></a>00045 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00046"></a>00046 <span class="comment">// medit_io class definition</span>
<a name="l00047"></a><a class="code" href="classMEDITIO.php">00047</a> <span class="keyword">class </span><a class="code" href="classMEDITIO.php">MEDITIO</a> : <span class="keyword">public</span> <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;MeshBase&gt;
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049  <span class="keyword">public</span>:
<a name="l00050"></a>00050 
<a name="l00055"></a>00055   <a class="code" href="classMEDITIO.php#ae1ab4a34648c25bb87e882dcbf0ebc42">MEDITIO</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp;);
<a name="l00056"></a>00056 
<a name="l00062"></a>00062   <a class="code" href="classMEDITIO.php#ae1ab4a34648c25bb87e882dcbf0ebc42">MEDITIO</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp;, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c);
<a name="l00063"></a>00063   
<a name="l00067"></a>00067   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classMEDITIO.php#a06408f59e30e825892d65ba668801aa1">write</a> (<span class="keyword">const</span> std::string&amp; );
<a name="l00068"></a>00068 
<a name="l00073"></a>00073   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classMEDITIO.php#af08dd6969502b328d92d8fcd5a025659">write_nodal_data</a> (<span class="keyword">const</span> std::string&amp;,
<a name="l00074"></a>00074                                  <span class="keyword">const</span> std::vector&lt;Number&gt;&amp;,
<a name="l00075"></a>00075                                  <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp;);
<a name="l00076"></a>00076 
<a name="l00080"></a>00080   <span class="keywordtype">bool</span> &amp; <a class="code" href="classMEDITIO.php#ae7ca93732e9a0d25579f041235cd712d">binary</a> ();
<a name="l00081"></a>00081    
<a name="l00082"></a>00082 <span class="keyword">private</span>:
<a name="l00083"></a>00083 
<a name="l00089"></a>00089   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classMEDITIO.php#a8c6f10f6449aba83fbe8d2ce0f51ceae">write_ascii</a> (<span class="keyword">const</span> std::string&amp;,
<a name="l00090"></a>00090                             <span class="keyword">const</span> std::vector&lt;Number&gt;* = NULL,
<a name="l00091"></a>00091                             <span class="keyword">const</span> std::vector&lt;std::string&gt;* = NULL);
<a name="l00092"></a>00092 
<a name="l00096"></a><a class="code" href="classMEDITIO.php#a244fd1283c7a9bdedafc648db2cf6e89">00096</a>   <span class="keywordtype">bool</span> <a class="code" href="classMEDITIO.php#a244fd1283c7a9bdedafc648db2cf6e89">_binary</a>;
<a name="l00097"></a>00097 
<a name="l00098"></a><a class="code" href="classMEDITIO.php#a431fc4cd81d32e128f3dbf2e2a6b8f93">00098</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMEDITIO.php#a431fc4cd81d32e128f3dbf2e2a6b8f93">scalar_idx</a>;  
<a name="l00099"></a>00099 };
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00104"></a>00104 <span class="comment">// medit_io inline members</span>
<a name="l00105"></a>00105 <span class="keyword">inline</span>
<a name="l00106"></a><a class="code" href="classMEDITIO.php#ae1ab4a34648c25bb87e882dcbf0ebc42">00106</a> <a class="code" href="classMEDITIO.php#ae1ab4a34648c25bb87e882dcbf0ebc42">MEDITIO::MEDITIO</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh) :
<a name="l00107"></a>00107   <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt; (mesh),
<a name="l00108"></a>00108   _binary (false)
<a name="l00109"></a>00109 {
<a name="l00110"></a>00110 }
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 <span class="keyword">inline</span>
<a name="l00113"></a><a class="code" href="classMEDITIO.php#a1bbc63a4fabf410974906f98466a4807">00113</a> <a class="code" href="classMEDITIO.php#ae1ab4a34648c25bb87e882dcbf0ebc42">MEDITIO::MEDITIO</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c) :
<a name="l00114"></a>00114   <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt; (mesh),
<a name="l00115"></a>00115   _binary    (false),
<a name="l00116"></a>00116   scalar_idx (c)
<a name="l00117"></a>00117 {
<a name="l00118"></a>00118 }
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 <span class="keyword">inline</span>
<a name="l00122"></a><a class="code" href="classMEDITIO.php#ae7ca93732e9a0d25579f041235cd712d">00122</a> <span class="keywordtype">bool</span> &amp; <a class="code" href="classMEDITIO.php#ae7ca93732e9a0d25579f041235cd712d">MEDITIO::binary</a> ()
<a name="l00123"></a>00123 {
<a name="l00124"></a>00124   <span class="keywordflow">return</span> <a class="code" href="classMEDITIO.php#a244fd1283c7a9bdedafc648db2cf6e89">_binary</a>;
<a name="l00125"></a>00125 }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 <span class="preprocessor">#endif // #define __medit_io_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
