<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh.h</h1>  </div>
</div>
<div class="contents">
<a href="mesh_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __mesh_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PARMESH</span>
<a name="l00027"></a>00027 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="parallel__mesh_8h.php">parallel_mesh.h</a>&quot;</span>
<a name="l00028"></a><a class="code" href="mesh_8h.php#a6292c327fef1c4b8de003f61f80ad7a6">00028</a>   <span class="keyword">typedef</span> <a class="code" href="classParallelMesh.php">ParallelMesh</a> <a class="code" href="mesh_8h.php#a6292c327fef1c4b8de003f61f80ad7a6">DefaultMesh</a>;
<a name="l00029"></a>00029 <span class="preprocessor">#else</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="serial__mesh_8h.php">serial_mesh.h</a>&quot;</span>
<a name="l00031"></a>00031   <span class="keyword">typedef</span> <a class="code" href="classSerialMesh.php">SerialMesh</a> <a class="code" href="mesh_8h.php#a6292c327fef1c4b8de003f61f80ad7a6">DefaultMesh</a>;
<a name="l00032"></a>00032 <span class="preprocessor">#endif</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span>
<a name="l00034"></a>00034 <span class="comment">// Forward declarations don&#39;t like typedefs...</span>
<a name="l00035"></a>00035 <span class="comment">// typedef SerialMesh Mesh;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00043"></a>00043 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00044"></a>00044 <span class="comment">// Mesh class definition</span>
<a name="l00045"></a><a class="code" href="classMesh.php">00045</a> <span class="keyword">class </span><a class="code" href="classMesh.php">Mesh</a> : <span class="keyword">public</span> <a class="code" href="classParallelMesh.php">DefaultMesh</a>
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047  <span class="keyword">public</span>:
<a name="l00048"></a>00048 
<a name="l00054"></a><a class="code" href="classMesh.php#af51809889a740d1265f15b54ec7a6b71">00054</a>   <a class="code" href="classMesh.php#af51809889a740d1265f15b54ec7a6b71">Mesh</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d) : <a class="code" href="classParallelMesh.php">DefaultMesh</a>(d) {}
<a name="l00055"></a>00055 
<a name="l00060"></a><a class="code" href="classMesh.php#af213adf75c2fd523d88de2f702813656">00060</a>   <a class="code" href="classMesh.php#af213adf75c2fd523d88de2f702813656">Mesh</a> (<span class="keyword">const</span> <a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; other_mesh) : <a class="code" href="classParallelMesh.php">DefaultMesh</a>(other_mesh) {}
<a name="l00061"></a>00061 
<a name="l00065"></a><a class="code" href="classMesh.php#a5efe4da1a4c0971cfb037bd70304c303">00065</a>   <a class="code" href="classMesh.php#a5efe4da1a4c0971cfb037bd70304c303">~Mesh</a>() {}
<a name="l00066"></a>00066 };
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 
<a name="l00072"></a>00072 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
