<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_base.C</h1>  </div>
</div>
<div class="contents">
<a href="mesh__base_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_base.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// library configuration</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::min</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;map&gt;</span>       <span class="comment">// for std::multimap</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;sstream&gt;</span>   <span class="comment">// for std::ostringstream</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Local includes</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;boundary_info.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;mesh_tools.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;partitioner.h&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;point_locator_base.h&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00042"></a>00042 <span class="comment">// MeshBase class member functions</span>
<a name="l00043"></a><a class="code" href="classMeshBase.php#abe5029b2d9fa397986956cb544e9d8ce">00043</a> <a class="code" href="classMeshBase.php#abe5029b2d9fa397986956cb544e9d8ce">MeshBase::MeshBase</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d) :
<a name="l00044"></a>00044   boundary_info  (new <a class="code" href="classBoundaryInfo.php">BoundaryInfo</a>(*this)),
<a name="l00045"></a>00045   _n_sbd         (1),
<a name="l00046"></a>00046   _n_parts       (1),
<a name="l00047"></a>00047   _dim           (d),
<a name="l00048"></a>00048   _is_prepared   (false),
<a name="l00049"></a>00049   _point_locator (NULL),
<a name="l00050"></a>00050   _partitioner   (NULL)
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052   libmesh_assert (LIBMESH_DIM &lt;= 3);
<a name="l00053"></a>00053   libmesh_assert (LIBMESH_DIM &gt;= <a class="code" href="classMeshBase.php#a9a02b0f83c0debf7395aa48edb030c39">_dim</a>);
<a name="l00054"></a>00054   libmesh_assert (<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">libMesh::initialized</a>());
<a name="l00055"></a>00055 }
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 
<a name="l00059"></a><a class="code" href="classMeshBase.php#a4ac54c0f8deec2f62eb8f18a3ea26829">00059</a> <a class="code" href="classMeshBase.php#abe5029b2d9fa397986956cb544e9d8ce">MeshBase::MeshBase</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; other_mesh) :
<a name="l00060"></a>00060   boundary_info  (new <a class="code" href="classBoundaryInfo.php">BoundaryInfo</a>(*this)), <span class="comment">// no copy constructor defined for BoundaryInfo?</span>
<a name="l00061"></a>00061   _n_sbd         (other_mesh._n_sbd),
<a name="l00062"></a>00062   _n_parts       (other_mesh._n_parts),
<a name="l00063"></a>00063   _dim           (other_mesh._dim),
<a name="l00064"></a>00064   _is_prepared   (other_mesh._is_prepared),
<a name="l00065"></a>00065   _point_locator (NULL),
<a name="l00066"></a>00066   _partitioner   (other_mesh._partitioner-&gt;clone())
<a name="l00067"></a>00067 {
<a name="l00068"></a>00068 }
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 
<a name="l00072"></a><a class="code" href="classMeshBase.php#a2256df1ac0fc2c22ee7626921a095298">00072</a> <a class="code" href="classMeshBase.php#a2256df1ac0fc2c22ee7626921a095298">MeshBase::~MeshBase</a>()
<a name="l00073"></a>00073 {
<a name="l00074"></a>00074   this-&gt;<a class="code" href="classMeshBase.php#aefd56c4c29285d5e845f8869112b2b67">clear</a>();
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   libmesh_assert (!<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">libMesh::closed</a>());
<a name="l00077"></a>00077 }
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 
<a name="l00081"></a><a class="code" href="classMeshBase.php#a7c79bc3b9a75a580ed1ef91195eb77e5">00081</a> <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#a7c79bc3b9a75a580ed1ef91195eb77e5">MeshBase::prepare_for_use</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> skip_renumber_nodes_and_elements)
<a name="l00082"></a>00082 {  
<a name="l00083"></a>00083   <span class="comment">// Renumber the nodes and elements so that they in contiguous</span>
<a name="l00084"></a>00084   <span class="comment">// blocks.  By default, skip_renumber_nodes_and_elements is false,</span>
<a name="l00085"></a>00085   <span class="comment">// however we may skip this step by passing</span>
<a name="l00086"></a>00086   <span class="comment">// skip_renumber_nodes_and_elements==true to this function.</span>
<a name="l00087"></a>00087   <span class="comment">//</span>
<a name="l00088"></a>00088   <span class="comment">// Instances where you if prepare_for_use() should not renumber the nodes</span>
<a name="l00089"></a>00089   <span class="comment">// and elements include reading in e.g. an xda/r or gmv file. In</span>
<a name="l00090"></a>00090   <span class="comment">// this case, the ordering of the nodes may depend on an accompanying</span>
<a name="l00091"></a>00091   <span class="comment">// solution, and the node ordering cannot be changed.</span>
<a name="l00092"></a>00092   <span class="keywordflow">if</span>(!skip_renumber_nodes_and_elements)
<a name="l00093"></a>00093     this-&gt;<a class="code" href="classMeshBase.php#a9cffd189f76fa2393fa5c5426f408aed">renumber_nodes_and_elements</a>();
<a name="l00094"></a>00094   
<a name="l00095"></a>00095   <span class="comment">// Let all the elements find their neighbors</span>
<a name="l00096"></a>00096   this-&gt;<a class="code" href="classMeshBase.php#a9dff97b1304d9e0e2e84be4efbcb889d">find_neighbors</a>();
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   <span class="comment">// Partition the mesh.</span>
<a name="l00099"></a>00099   this-&gt;<a class="code" href="classMeshBase.php#a3a58f368f3e4f1a5d3d0c96533596132">partition</a>();
<a name="l00100"></a>00100   
<a name="l00101"></a>00101   <span class="comment">// If we&#39;re using ParallelMesh, we&#39;ll want it parallelized.</span>
<a name="l00102"></a>00102   this-&gt;<a class="code" href="classMeshBase.php#a882442bc00428fb36c010cec0668c0e8">delete_remote_elements</a>();
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="keywordflow">if</span>(!skip_renumber_nodes_and_elements)
<a name="l00105"></a>00105     this-&gt;<a class="code" href="classMeshBase.php#a9cffd189f76fa2393fa5c5426f408aed">renumber_nodes_and_elements</a>();
<a name="l00106"></a>00106 
<a name="l00107"></a>00107   <span class="comment">// Reset our PointLocator.  This needs to happen any time the elements</span>
<a name="l00108"></a>00108   <span class="comment">// in the underlying elements in the mesh have changed, so we do it here.</span>
<a name="l00109"></a>00109   this-&gt;<a class="code" href="classMeshBase.php#a5ac0350d976e303267b8195417367689">clear_point_locator</a>();
<a name="l00110"></a>00110 
<a name="l00111"></a>00111   <span class="comment">// The mesh is now prepared for use.</span>
<a name="l00112"></a>00112   <a class="code" href="classMeshBase.php#a1322dbb0d67f763b24ea50fc872cb4f2">_is_prepared</a> = <span class="keyword">true</span>;
<a name="l00113"></a>00113 }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a><a class="code" href="classMeshBase.php#aefd56c4c29285d5e845f8869112b2b67">00117</a> <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#aefd56c4c29285d5e845f8869112b2b67">MeshBase::clear</a> ()
<a name="l00118"></a>00118 {
<a name="l00119"></a>00119   
<a name="l00120"></a>00120   <span class="comment">// Reset the number of subdomains</span>
<a name="l00121"></a>00121   <a class="code" href="classMeshBase.php#af28478381f2803a30aaf1d925df4c673">_n_sbd</a>  = 1;
<a name="l00122"></a>00122 
<a name="l00123"></a>00123   <span class="comment">// Reset the number of partitions</span>
<a name="l00124"></a>00124   <a class="code" href="classMeshBase.php#ad6717b5155fa3c20c3fa5a419ea307bd">_n_parts</a> = 1;
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   <span class="comment">// Reset the _is_prepared flag</span>
<a name="l00127"></a>00127   <a class="code" href="classMeshBase.php#a1322dbb0d67f763b24ea50fc872cb4f2">_is_prepared</a> = <span class="keyword">false</span>;
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   <span class="comment">// Clear boundary information</span>
<a name="l00130"></a>00130   this-&gt;<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;clear();
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   <span class="comment">// Clear our point locator.</span>
<a name="l00133"></a>00133   this-&gt;<a class="code" href="classMeshBase.php#a5ac0350d976e303267b8195417367689">clear_point_locator</a>();
<a name="l00134"></a>00134 }
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 
<a name="l00138"></a><a class="code" href="classMeshBase.php#a2f0fd2e27def02abdc2d47036dd0b1fe">00138</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#a2f0fd2e27def02abdc2d47036dd0b1fe">MeshBase::n_nodes_on_proc</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)<span class="keyword"> const</span>
<a name="l00139"></a>00139 <span class="keyword"></span>{
<a name="l00140"></a>00140   <span class="comment">// We&#39;re either counting a processor&#39;s nodes or unpartitioned</span>
<a name="l00141"></a>00141   <span class="comment">// nodes</span>
<a name="l00142"></a>00142   libmesh_assert (proc_id &lt; <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() ||
<a name="l00143"></a>00143           proc_id == <a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>);
<a name="l00144"></a>00144   
<a name="l00145"></a>00145   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(std::distance (this-&gt;<a class="code" href="classMeshBase.php#a2fcbe0fe5068603530d34543033c9e5b">pid_nodes_begin</a>(proc_id),
<a name="l00146"></a>00146                                                   this-&gt;<a class="code" href="classMeshBase.php#abff909aecd7e32786f49646fee5ae4a1">pid_nodes_end</a>  (proc_id)));
<a name="l00147"></a>00147 }
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a><a class="code" href="classMeshBase.php#a428bc8ddcb365c7aaf6c683dce9a3b42">00151</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#a428bc8ddcb365c7aaf6c683dce9a3b42">MeshBase::n_elem_on_proc</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)<span class="keyword"> const</span>
<a name="l00152"></a>00152 <span class="keyword"></span>{
<a name="l00153"></a>00153   <span class="comment">// We&#39;re either counting a processor&#39;s elements or unpartitioned</span>
<a name="l00154"></a>00154   <span class="comment">// elements</span>
<a name="l00155"></a>00155   libmesh_assert (proc_id &lt; <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() ||
<a name="l00156"></a>00156           proc_id == <a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>);
<a name="l00157"></a>00157   
<a name="l00158"></a>00158   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(std::distance (this-&gt;<a class="code" href="classMeshBase.php#aa8cbd1381e63c4c468292c1275497724">pid_elements_begin</a>(proc_id),
<a name="l00159"></a>00159                                                   this-&gt;<a class="code" href="classMeshBase.php#a2fa21ec41ad9c25eb2617fca513bca5d">pid_elements_end</a>  (proc_id)));
<a name="l00160"></a>00160 }
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 
<a name="l00164"></a><a class="code" href="classMeshBase.php#a59d87ef01e69230c32bd10b777516880">00164</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#a59d87ef01e69230c32bd10b777516880">MeshBase::n_active_elem_on_proc</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)<span class="keyword"> const</span>
<a name="l00165"></a>00165 <span class="keyword"></span>{
<a name="l00166"></a>00166   libmesh_assert (proc_id &lt; <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00167"></a>00167   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(std::distance (this-&gt;<a class="code" href="classMeshBase.php#ac0e09837e3ba3077c14015ea4b73ec08">active_pid_elements_begin</a>(proc_id),
<a name="l00168"></a>00168                                                   this-&gt;<a class="code" href="classMeshBase.php#a44926338045dcfee9dae93975aeafe9a">active_pid_elements_end</a>  (proc_id)));
<a name="l00169"></a>00169 }
<a name="l00170"></a>00170   
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 
<a name="l00173"></a><a class="code" href="classMeshBase.php#af580ac45d8712ce84c6f896844f318b2">00173</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#af580ac45d8712ce84c6f896844f318b2">MeshBase::n_sub_elem</a> ()<span class="keyword"> const</span>
<a name="l00174"></a>00174 <span class="keyword"></span>{
<a name="l00175"></a>00175   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ne=0;
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>       el  = this-&gt;<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00178"></a>00178   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> end = this-&gt;<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>(); 
<a name="l00179"></a>00179 
<a name="l00180"></a>00180   <span class="keywordflow">for</span> (; el!=end; ++el)
<a name="l00181"></a>00181     ne += (*el)-&gt;n_sub_elem(); 
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   <span class="keywordflow">return</span> ne;
<a name="l00184"></a>00184 }
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 
<a name="l00188"></a><a class="code" href="classMeshBase.php#a488a2249eb1ab6349807a401cb9db44e">00188</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#a488a2249eb1ab6349807a401cb9db44e">MeshBase::n_active_sub_elem</a> ()<span class="keyword"> const</span>
<a name="l00189"></a>00189 <span class="keyword"></span>{
<a name="l00190"></a>00190   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ne=0;
<a name="l00191"></a>00191 
<a name="l00192"></a>00192   <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>       el  = this-&gt;<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00193"></a>00193   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> end = this-&gt;<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00194"></a>00194 
<a name="l00195"></a>00195   <span class="keywordflow">for</span> (; el!=end; ++el)
<a name="l00196"></a>00196     ne += (*el)-&gt;n_sub_elem(); 
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   <span class="keywordflow">return</span> ne;
<a name="l00199"></a>00199 }
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 
<a name="l00203"></a><a class="code" href="classMeshBase.php#a5f1dfa1f466f8c6620eaa90697c9d0d2">00203</a> std::string <a class="code" href="classMeshBase.php#a5f1dfa1f466f8c6620eaa90697c9d0d2">MeshBase::get_info</a>()<span class="keyword"> const</span>
<a name="l00204"></a>00204 <span class="keyword"></span>{
<a name="l00205"></a>00205   std::ostringstream out;
<a name="l00206"></a>00206 
<a name="l00207"></a>00207   out &lt;&lt; <span class="stringliteral">&quot; Mesh Information:&quot;</span>                                  &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00208"></a>00208       &lt;&lt; <span class="stringliteral">&quot;  mesh_dimension()=&quot;</span>    &lt;&lt; this-&gt;<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>()    &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00209"></a>00209       &lt;&lt; <span class="stringliteral">&quot;  spatial_dimension()=&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classMeshBase.php#acaf87bde8c96b91d8f355dc9ebb72f5f">spatial_dimension</a>() &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00210"></a>00210       &lt;&lt; <span class="stringliteral">&quot;  n_nodes()=&quot;</span>           &lt;&lt; this-&gt;<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>()           &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00211"></a>00211       &lt;&lt; <span class="stringliteral">&quot;    n_local_nodes()=&quot;</span>   &lt;&lt; this-&gt;<a class="code" href="classMeshBase.php#a56053e95ae70a2f5c67725d5f4e6ea04">n_local_nodes</a>()     &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00212"></a>00212       &lt;&lt; <span class="stringliteral">&quot;  n_elem()=&quot;</span>            &lt;&lt; this-&gt;<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>()            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00213"></a>00213       &lt;&lt; <span class="stringliteral">&quot;    n_local_elem()=&quot;</span>    &lt;&lt; this-&gt;<a class="code" href="classMeshBase.php#ab2d0abdfdf6c884bace77cf94af08874">n_local_elem</a>()      &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00214"></a>00214 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00215"></a>00215 <span class="preprocessor"></span>      &lt;&lt; <span class="stringliteral">&quot;    n_active_elem()=&quot;</span>   &lt;&lt; this-&gt;<a class="code" href="classMeshBase.php#a246697678d5d14a986cee2b6fbdbae6b">n_active_elem</a>()     &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00216"></a>00216 <span class="preprocessor">#endif</span>
<a name="l00217"></a>00217 <span class="preprocessor"></span>      &lt;&lt; <span class="stringliteral">&quot;  n_subdomains()=&quot;</span>      &lt;&lt; this-&gt;<a class="code" href="classMeshBase.php#a1f288668ce5a732f9946f08c73166d73">n_subdomains</a>()      &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00218"></a>00218       &lt;&lt; <span class="stringliteral">&quot;  n_processors()=&quot;</span>      &lt;&lt; this-&gt;<a class="code" href="classMeshBase.php#a2399e70af69cf24f3add6c5a860edaa7">n_processors</a>()      &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00219"></a>00219       &lt;&lt; <span class="stringliteral">&quot;  processor_id()=&quot;</span>      &lt;&lt; this-&gt;<a class="code" href="classMeshBase.php#aba369b64ee6185d86a6b60089ba5af60">processor_id</a>()      &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00220"></a>00220 
<a name="l00221"></a>00221   <span class="keywordflow">return</span> out.str();
<a name="l00222"></a>00222 }
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00225"></a><a class="code" href="classMeshBase.php#ae858bdde120c974398e2e3513bbb5f6e">00225</a> <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#ae858bdde120c974398e2e3513bbb5f6e">MeshBase::print_info</a>(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00226"></a>00226 <span class="keyword"></span>{
<a name="l00227"></a>00227   os &lt;&lt; this-&gt;<a class="code" href="classMeshBase.php#a5f1dfa1f466f8c6620eaa90697c9d0d2">get_info</a>()
<a name="l00228"></a>00228      &lt;&lt; std::endl;
<a name="l00229"></a>00229 }
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 
<a name="l00232"></a><a class="code" href="mesh__base_8C.php#a40e1132eec66b29d79926db67fc584bc">00232</a> std::ostream&amp; <a class="code" href="fe__base_8C.php#af707d8f04488db8220405623626a146a">operator &lt;&lt; </a>(std::ostream&amp; os, <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; m)
<a name="l00233"></a>00233 {
<a name="l00234"></a>00234   m.<a class="code" href="classMeshBase.php#ae858bdde120c974398e2e3513bbb5f6e">print_info</a>(os);
<a name="l00235"></a>00235   <span class="keywordflow">return</span> os;
<a name="l00236"></a>00236 }
<a name="l00237"></a>00237 
<a name="l00238"></a>00238 
<a name="l00239"></a>00239 
<a name="l00240"></a>00240 
<a name="l00241"></a><a class="code" href="classMeshBase.php#a3a58f368f3e4f1a5d3d0c96533596132">00241</a> <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#a3a58f368f3e4f1a5d3d0c96533596132">MeshBase::partition</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_parts)
<a name="l00242"></a>00242 {
<a name="l00243"></a>00243   <span class="keywordflow">if</span> (<a class="code" href="classMeshBase.php#a4e91618481bb34ffff7e85ab2ee9b78f">partitioner</a>().<span class="keyword">get</span>()) <span class="comment">// &quot;NULL&quot; means don&#39;t partition</span>
<a name="l00244"></a>00244     <a class="code" href="classMeshBase.php#a4e91618481bb34ffff7e85ab2ee9b78f">partitioner</a>()-&gt;partition (*<span class="keyword">this</span>, n_parts);
<a name="l00245"></a>00245 }
<a name="l00246"></a>00246 
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 
<a name="l00249"></a><a class="code" href="classMeshBase.php#a9bba495febbd880e80fc0b3726194bcb">00249</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#a9bba495febbd880e80fc0b3726194bcb">MeshBase::recalculate_n_partitions</a>()
<a name="l00250"></a>00250 {
<a name="l00251"></a>00251   <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>       el  = this-&gt;<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00252"></a>00252   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> end = this-&gt;<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00253"></a>00253 
<a name="l00254"></a>00254   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_proc_id=0;
<a name="l00255"></a>00255   
<a name="l00256"></a>00256   <span class="keywordflow">for</span> (; el!=end; ++el)
<a name="l00257"></a>00257     max_proc_id = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(max_proc_id, static_cast&lt;unsigned int&gt;((*el)-&gt;processor_id()));
<a name="l00258"></a>00258 
<a name="l00259"></a>00259   <span class="comment">// The number of partitions is one more than the max processor ID.</span>
<a name="l00260"></a>00260   <a class="code" href="classMeshBase.php#ad6717b5155fa3c20c3fa5a419ea307bd">_n_parts</a> = max_proc_id+1;
<a name="l00261"></a>00261 
<a name="l00262"></a>00262   <span class="keywordflow">return</span> <a class="code" href="classMeshBase.php#ad6717b5155fa3c20c3fa5a419ea307bd">_n_parts</a>;
<a name="l00263"></a>00263 }
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 
<a name="l00266"></a>00266 
<a name="l00267"></a><a class="code" href="classMeshBase.php#aaf790ef555dbc2e8d1acec39bca69565">00267</a> <span class="keyword">const</span> <a class="code" href="classPointLocatorBase.php">PointLocatorBase</a> &amp; <a class="code" href="classMeshBase.php#aaf790ef555dbc2e8d1acec39bca69565">MeshBase::point_locator</a> ()<span class="keyword"> const</span>
<a name="l00268"></a>00268 <span class="keyword"></span>{
<a name="l00269"></a>00269   <span class="keywordflow">if</span> (<a class="code" href="classMeshBase.php#af17cc1c5b23972cca5d4b0104745ab7b">_point_locator</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() == NULL)
<a name="l00270"></a>00270     <a class="code" href="classMeshBase.php#af17cc1c5b23972cca5d4b0104745ab7b">_point_locator</a>.<a class="code" href="classAutoPtr.php#afba95dd5fca7f83ababa4eaf6a57c511" title="Forcibly deletes the managed object.">reset</a> (<a class="code" href="classPointLocatorBase.php#a01b4bbbfdbdd15cb1747511677e975da">PointLocatorBase::build</a>(<a class="code" href="namespaceMeshEnums.php#a9f0dd4dc83b7c35010fc10eaad442670a1d10cc4a6034c660fed720fb3e69b90b">TREE</a>, *<span class="keyword">this</span>).<a class="code" href="classAutoPtr.php#af9d9cdff0aa3e2df96b18b197be2c9ac" title="Bypassing the smart pointer.">release</a>());
<a name="l00271"></a>00271 
<a name="l00272"></a>00272   <span class="keywordflow">return</span> *<a class="code" href="classMeshBase.php#af17cc1c5b23972cca5d4b0104745ab7b">_point_locator</a>;
<a name="l00273"></a>00273 }
<a name="l00274"></a>00274 
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 
<a name="l00277"></a><a class="code" href="classMeshBase.php#a5ac0350d976e303267b8195417367689">00277</a> <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#a5ac0350d976e303267b8195417367689">MeshBase::clear_point_locator</a> ()
<a name="l00278"></a>00278 {
<a name="l00279"></a>00279   <a class="code" href="classMeshBase.php#af17cc1c5b23972cca5d4b0104745ab7b">_point_locator</a>.<a class="code" href="classAutoPtr.php#afba95dd5fca7f83ababa4eaf6a57c511" title="Forcibly deletes the managed object.">reset</a>(NULL);
<a name="l00280"></a>00280 }
<a name="l00281"></a>00281 
<a name="l00282"></a>00282 
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
