<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_base.h</h1>  </div>
</div>
<div class="contents">
<a href="mesh__base_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_base.h 3454 2009-09-03 16:59:40Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __mesh_base_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_base_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// forward declarations</span>
<a name="l00031"></a>00031 <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00032"></a>00032 <span class="keyword">class </span><a class="code" href="classNode.php">Node</a>;
<a name="l00033"></a>00033 <span class="keyword">class </span><a class="code" href="classPoint.php">Point</a>;
<a name="l00034"></a>00034 <span class="keyword">class </span><a class="code" href="classBoundaryInfo.php">BoundaryInfo</a>;
<a name="l00035"></a>00035 <span class="keyword">class </span><a class="code" href="classPointLocatorBase.php">PointLocatorBase</a>;
<a name="l00036"></a>00036 <span class="keyword">class </span><a class="code" href="classMeshData.php">MeshData</a>;
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;auto_ptr.h&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;dof_object.h&quot;</span> <span class="comment">// for invalid_processor_id</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;enum_elem_type.h&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00043"></a>00043 <span class="preprocessor">#include &quot;multi_predicates.h&quot;</span>
<a name="l00044"></a>00044 <span class="preprocessor">#include &quot;partitioner.h&quot;</span>
<a name="l00045"></a>00045 <span class="preprocessor">#include &quot;variant_filter_iterator.h&quot;</span>
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00067"></a>00067 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00068"></a>00068 <span class="comment">// MeshBase class definition</span>
<a name="l00069"></a><a class="code" href="classMeshBase.php">00069</a> <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>
<a name="l00070"></a>00070 {
<a name="l00071"></a>00071 <span class="keyword">public</span>:
<a name="l00072"></a>00072 
<a name="l00076"></a>00076   <a class="code" href="classMeshBase.php#abe5029b2d9fa397986956cb544e9d8ce">MeshBase</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d);
<a name="l00077"></a>00077   
<a name="l00081"></a>00081   <a class="code" href="classMeshBase.php#abe5029b2d9fa397986956cb544e9d8ce">MeshBase</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; other_mesh);
<a name="l00082"></a>00082 
<a name="l00086"></a>00086   <span class="keyword">virtual</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;MeshBase&gt;</a> <a class="code" href="classMeshBase.php#a6e55b07adb72ceedc61283004b1263d9">clone</a>() <span class="keyword">const</span> = 0;
<a name="l00087"></a>00087 
<a name="l00091"></a>00091   <span class="keyword">virtual</span> <a class="code" href="classMeshBase.php#a2256df1ac0fc2c22ee7626921a095298">~MeshBase</a> ();
<a name="l00092"></a>00092 
<a name="l00098"></a><a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">00098</a>   <a class="code" href="classAutoPtr.php">AutoPtr&lt;BoundaryInfo&gt;</a> <a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>;
<a name="l00099"></a>00099 
<a name="l00103"></a><a class="code" href="classMeshBase.php#a4e91618481bb34ffff7e85ab2ee9b78f">00103</a>   <span class="keyword">virtual</span> <a class="code" href="classAutoPtr.php">AutoPtr&lt;Partitioner&gt;</a> &amp;<a class="code" href="classMeshBase.php#a4e91618481bb34ffff7e85ab2ee9b78f">partitioner</a>() { <span class="keywordflow">return</span> <a class="code" href="classMeshBase.php#a313380606806d2771ba4f2e78f7400d9">_partitioner</a>; }
<a name="l00104"></a>00104   
<a name="l00108"></a>00108   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#aefd56c4c29285d5e845f8869112b2b67">clear</a> ();
<a name="l00109"></a>00109   
<a name="l00114"></a><a class="code" href="classMeshBase.php#a960bff880e04431f031b46e797af38cc">00114</a>   <span class="keywordtype">bool</span> <a class="code" href="classMeshBase.php#a960bff880e04431f031b46e797af38cc">is_prepared</a> ()<span class="keyword"> const</span>
<a name="l00115"></a>00115 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classMeshBase.php#a1322dbb0d67f763b24ea50fc872cb4f2">_is_prepared</a>; }
<a name="l00116"></a>00116   
<a name="l00121"></a><a class="code" href="classMeshBase.php#a660bb92c9fb94527d1cabfb1fdd6d056">00121</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classMeshBase.php#a660bb92c9fb94527d1cabfb1fdd6d056">is_serial</a> ()<span class="keyword"> const </span>
<a name="l00122"></a>00122 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00123"></a>00123   
<a name="l00128"></a><a class="code" href="classMeshBase.php#aa465e5e27d0ac948ecee50d0a03f2c82">00128</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#aa465e5e27d0ac948ecee50d0a03f2c82">allgather</a> () {}
<a name="l00129"></a>00129   
<a name="l00135"></a><a class="code" href="classMeshBase.php#a882442bc00428fb36c010cec0668c0e8">00135</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#a882442bc00428fb36c010cec0668c0e8">delete_remote_elements</a> () {}
<a name="l00136"></a>00136   
<a name="l00140"></a><a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">00140</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a> ()<span class="keyword"> const</span>
<a name="l00141"></a>00141 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(<a class="code" href="classMeshBase.php#a9a02b0f83c0debf7395aa48edb030c39">_dim</a>); }
<a name="l00142"></a>00142   
<a name="l00147"></a><a class="code" href="classMeshBase.php#a115ad25a44a20e30f6702ec71dec90a9">00147</a>   <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#a115ad25a44a20e30f6702ec71dec90a9">set_mesh_dimension</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d)
<a name="l00148"></a>00148   { libmesh_assert(!this-&gt;<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>()); <a class="code" href="classMeshBase.php#a9a02b0f83c0debf7395aa48edb030c39">_dim</a> = d; }
<a name="l00149"></a>00149   
<a name="l00154"></a><a class="code" href="classMeshBase.php#acaf87bde8c96b91d8f355dc9ebb72f5f">00154</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#acaf87bde8c96b91d8f355dc9ebb72f5f">spatial_dimension</a> ()<span class="keyword"> const</span>
<a name="l00155"></a>00155 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(LIBMESH_DIM); }
<a name="l00156"></a>00156   
<a name="l00162"></a>00162   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a> () <span class="keyword">const</span> = 0; 
<a name="l00163"></a>00163 
<a name="l00167"></a>00167   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#a2f0fd2e27def02abdc2d47036dd0b1fe">n_nodes_on_proc</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc) <span class="keyword">const</span>;
<a name="l00168"></a>00168 
<a name="l00172"></a><a class="code" href="classMeshBase.php#a56053e95ae70a2f5c67725d5f4e6ea04">00172</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#a56053e95ae70a2f5c67725d5f4e6ea04">n_local_nodes</a> ()<span class="keyword"> const</span>
<a name="l00173"></a>00173 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classMeshBase.php#a2f0fd2e27def02abdc2d47036dd0b1fe">n_nodes_on_proc</a> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()); }
<a name="l00174"></a>00174 
<a name="l00178"></a><a class="code" href="classMeshBase.php#a8070c32e5adb4cc7664c76ca7d5260f6">00178</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#a8070c32e5adb4cc7664c76ca7d5260f6">n_unpartitioned_nodes</a> ()<span class="keyword"> const</span>
<a name="l00179"></a>00179 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classMeshBase.php#a2f0fd2e27def02abdc2d47036dd0b1fe">n_nodes_on_proc</a> (<a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>); }
<a name="l00180"></a>00180 
<a name="l00185"></a>00185   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#a5a56e1b57f60d011b67f1f43ff8a5891">max_node_id</a> () <span class="keyword">const</span> = 0;
<a name="l00186"></a>00186 
<a name="l00194"></a>00194   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#a641a3da2df67396c48c9a9b2434b4d68">reserve_nodes</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn) = 0; 
<a name="l00195"></a>00195   
<a name="l00199"></a>00199   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a> () <span class="keyword">const</span> = 0; 
<a name="l00200"></a>00200 
<a name="l00205"></a>00205   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#a05c0414e5c91b36e9698fc4f60cff642">max_elem_id</a> () <span class="keyword">const</span> = 0;
<a name="l00206"></a>00206 
<a name="l00214"></a>00214   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#ae034eb4ecaa04c32b89909d9eee85411">reserve_elem</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ne) = 0; 
<a name="l00215"></a>00215 
<a name="l00220"></a>00220   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#aed43d56cc6447129ded7ef46e4c8bb3e">update_parallel_id_counts</a> () = 0;
<a name="l00221"></a>00221 
<a name="l00226"></a>00226   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#a246697678d5d14a986cee2b6fbdbae6b">n_active_elem</a> () <span class="keyword">const</span> = 0;
<a name="l00227"></a>00227 
<a name="l00231"></a>00231   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#a428bc8ddcb365c7aaf6c683dce9a3b42">n_elem_on_proc</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc) <span class="keyword">const</span>;
<a name="l00232"></a>00232 
<a name="l00236"></a><a class="code" href="classMeshBase.php#ab2d0abdfdf6c884bace77cf94af08874">00236</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#ab2d0abdfdf6c884bace77cf94af08874">n_local_elem</a> ()<span class="keyword"> const</span>
<a name="l00237"></a>00237 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classMeshBase.php#a428bc8ddcb365c7aaf6c683dce9a3b42">n_elem_on_proc</a> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()); }
<a name="l00238"></a>00238 
<a name="l00242"></a><a class="code" href="classMeshBase.php#a10ec192ec64504fdc31812a9cb5139ac">00242</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#a10ec192ec64504fdc31812a9cb5139ac">n_unpartitioned_elem</a> ()<span class="keyword"> const</span>
<a name="l00243"></a>00243 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classMeshBase.php#a428bc8ddcb365c7aaf6c683dce9a3b42">n_elem_on_proc</a> (<a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>); }
<a name="l00244"></a>00244 
<a name="l00248"></a>00248   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#a59d87ef01e69230c32bd10b777516880">n_active_elem_on_proc</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc) <span class="keyword">const</span>;
<a name="l00249"></a>00249 
<a name="l00253"></a><a class="code" href="classMeshBase.php#ac7a39d026a101d4312b9d39599fa1a45">00253</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#ac7a39d026a101d4312b9d39599fa1a45">n_active_local_elem</a> ()<span class="keyword"> const</span>
<a name="l00254"></a>00254 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classMeshBase.php#a59d87ef01e69230c32bd10b777516880">n_active_elem_on_proc</a> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()); }
<a name="l00255"></a>00255   
<a name="l00263"></a>00263   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#af580ac45d8712ce84c6f896844f318b2">n_sub_elem</a> () <span class="keyword">const</span>;
<a name="l00264"></a>00264 
<a name="l00268"></a>00268   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#a488a2249eb1ab6349807a401cb9db44e">n_active_sub_elem</a> () <span class="keyword">const</span>;
<a name="l00269"></a>00269   
<a name="l00274"></a>00274   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; <a class="code" href="classMeshBase.php#a06af1f178519c606d0bdca7857f95ba6">point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> = 0;
<a name="l00275"></a>00275 
<a name="l00280"></a>00280   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>&amp; <a class="code" href="classMeshBase.php#a298477f2d67d6a85f6c7fb5a640e2b64">node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> = 0;
<a name="l00281"></a>00281   
<a name="l00285"></a>00285   <span class="keyword">virtual</span> <a class="code" href="classNode.php">Node</a>&amp; <a class="code" href="classMeshBase.php#a298477f2d67d6a85f6c7fb5a640e2b64">node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) = 0;
<a name="l00286"></a>00286   
<a name="l00290"></a>00290   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> = 0;
<a name="l00291"></a>00291 
<a name="l00295"></a>00295   <span class="keyword">virtual</span> <a class="code" href="classNode.php">Node</a>* &amp; <a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) = 0;
<a name="l00296"></a>00296 
<a name="l00300"></a>00300   <span class="keyword">virtual</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> = 0;
<a name="l00301"></a>00301 
<a name="l00312"></a>00312   <span class="keyword">virtual</span> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classMeshBase.php#a01b66468d3e9d8b5db82c6f3d9131f5e">add_point</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00313"></a>00313                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span> = <a class="code" href="classDofObject.php#a35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>,
<a name="l00314"></a>00314                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id =
<a name="l00315"></a>00315                              <a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>) = 0;
<a name="l00316"></a>00316 
<a name="l00320"></a>00320   <span class="keyword">virtual</span> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classMeshBase.php#ae688bc12b4c0ebcc17d602b75a1bd532">add_node</a> (<a class="code" href="classNode.php">Node</a>* n) = 0;
<a name="l00321"></a>00321 
<a name="l00325"></a>00325   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#acb4609a30e5787c182b12c3d560c11a1">delete_node</a> (<a class="code" href="classNode.php">Node</a>* n) = 0;
<a name="l00326"></a>00326   
<a name="l00332"></a>00332   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#a608fdcb50de42af663437ae88d7a4056">renumber_node</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_id, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_id) = 0;
<a name="l00333"></a>00333                       
<a name="l00340"></a>00340   <span class="keyword">virtual</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classMeshBase.php#a0f6974cf3e413cfe9caa1fcb4ce8153e">add_elem</a> (<a class="code" href="classElem.php">Elem</a>* e) = 0;
<a name="l00341"></a>00341 
<a name="l00346"></a>00346   <span class="keyword">virtual</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classMeshBase.php#a7d3b027b5018b4834544b26fdc958288">insert_elem</a> (<a class="code" href="classElem.php">Elem</a>* e) = 0;
<a name="l00347"></a>00347 
<a name="l00354"></a>00354   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#abafee5e4c20eb6866d66e78c35589857">delete_elem</a> (<a class="code" href="classElem.php">Elem</a>* e) = 0;
<a name="l00355"></a>00355 
<a name="l00361"></a>00361   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#ac0e399ab1929b022cae1e8d1a1b7abbd">renumber_elem</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_id, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_id) = 0;
<a name="l00362"></a>00362 
<a name="l00375"></a>00375   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#a9dff97b1304d9e0e2e84be4efbcb889d">find_neighbors</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> reset_remote_elements = <span class="keyword">false</span>,
<a name="l00376"></a>00376                                <span class="keyword">const</span> <span class="keywordtype">bool</span> reset_current_list    = <span class="keyword">true</span>) = 0;
<a name="l00377"></a>00377   
<a name="l00383"></a>00383   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#a9cffd189f76fa2393fa5c5426f408aed">renumber_nodes_and_elements</a> () = 0;    
<a name="l00384"></a>00384 
<a name="l00385"></a>00385 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00386"></a>00386 <span class="preprocessor"></span>
<a name="l00391"></a>00391   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classMeshBase.php#a02856a9f06eb0d5837ef4917e3ce6da8">contract</a> () = 0;
<a name="l00392"></a>00392 <span class="preprocessor">#endif</span>
<a name="l00393"></a>00393 <span class="preprocessor"></span>
<a name="l00406"></a>00406   <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#a7c79bc3b9a75a580ed1ef91195eb77e5">prepare_for_use</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> skip_renumber_nodes_and_elements=<span class="keyword">false</span>);
<a name="l00407"></a>00407   
<a name="l00411"></a>00411   <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#a3a58f368f3e4f1a5d3d0c96533596132">partition</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_parts=<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00412"></a>00412   
<a name="l00420"></a><a class="code" href="classMeshBase.php#a1f288668ce5a732f9946f08c73166d73">00420</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#a1f288668ce5a732f9946f08c73166d73">n_subdomains</a> ()<span class="keyword"> const</span>
<a name="l00421"></a>00421 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classMeshBase.php#af28478381f2803a30aaf1d925df4c673">_n_sbd</a>; }
<a name="l00422"></a>00422 
<a name="l00429"></a><a class="code" href="classMeshBase.php#ac0228a08dd00ee27d137a89fa831ab0f">00429</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#ac0228a08dd00ee27d137a89fa831ab0f">n_partitions</a> ()<span class="keyword"> const</span>
<a name="l00430"></a>00430 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classMeshBase.php#ad6717b5155fa3c20c3fa5a419ea307bd">_n_parts</a>; }
<a name="l00431"></a>00431   
<a name="l00436"></a><a class="code" href="classMeshBase.php#a2399e70af69cf24f3add6c5a860edaa7">00436</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#a2399e70af69cf24f3add6c5a860edaa7">n_processors</a> ()<span class="keyword"> const</span>
<a name="l00437"></a>00437 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classMeshBase.php#a2399e70af69cf24f3add6c5a860edaa7">libMesh::n_processors</a>(); }
<a name="l00438"></a>00438 
<a name="l00442"></a><a class="code" href="classMeshBase.php#aba369b64ee6185d86a6b60089ba5af60">00442</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#aba369b64ee6185d86a6b60089ba5af60">processor_id</a> ()<span class="keyword"> const</span>
<a name="l00443"></a>00443 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classMeshBase.php#aba369b64ee6185d86a6b60089ba5af60">libMesh::processor_id</a>(); }
<a name="l00444"></a>00444 
<a name="l00449"></a>00449   std::string <a class="code" href="classMeshBase.php#a5f1dfa1f466f8c6620eaa90697c9d0d2">get_info</a> () <span class="keyword">const</span>;
<a name="l00450"></a>00450 
<a name="l00454"></a>00454   <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#ae858bdde120c974398e2e3513bbb5f6e">print_info</a> (std::ostream&amp; os=std::cout) <span class="keyword">const</span>;
<a name="l00455"></a>00455 
<a name="l00461"></a>00461   <span class="keyword">friend</span> std::ostream&amp; <a class="code" href="classMeshBase.php#a40e1132eec66b29d79926db67fc584bc">operator &lt;&lt; </a>(std::ostream&amp; os, <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; m);
<a name="l00462"></a>00462 
<a name="l00467"></a>00467   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#a854c19511b2cb3f8d141e24d61d395f4">read</a>  (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>, <a class="code" href="classMeshData.php">MeshData</a>* mesh_data=NULL,
<a name="l00468"></a>00468                       <span class="keywordtype">bool</span> skip_renumber_nodes_and_elements=<span class="keyword">false</span>) = 0;
<a name="l00469"></a>00469   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#a4315075231556216f6178b00235e44f3">write</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>, <a class="code" href="classMeshData.php">MeshData</a>* mesh_data=NULL) = 0;
<a name="l00470"></a>00470 
<a name="l00477"></a>00477   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#ad04ef199717c490f548c6daa81fcce6f">all_first_order</a> () = 0;
<a name="l00478"></a>00478 
<a name="l00490"></a>00490   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#aa2e4a0c17a24d13c89f73ffa7a38b95c">all_second_order</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> full_ordered=<span class="keyword">true</span>) = 0;
<a name="l00491"></a>00491 
<a name="l00496"></a><a class="code" href="classMeshBase.php#a22f06c73e7c2ac3f27b888fa19a64e26">00496</a>   <span class="keyword">typedef</span> <a class="code" href="structPredicates_1_1multi__predicate.php">Predicates::multi_predicate</a> <a class="code" href="classMeshBase.php#a22f06c73e7c2ac3f27b888fa19a64e26">Predicate</a>;
<a name="l00497"></a>00497 
<a name="l00504"></a>00504   <span class="keyword">struct </span><a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>;
<a name="l00505"></a>00505   <span class="keyword">struct </span><a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>;
<a name="l00506"></a>00506 
<a name="l00513"></a>00513   <span class="keyword">struct </span><a class="code" href="structMeshBase_1_1node__iterator.php">node_iterator</a>;
<a name="l00514"></a>00514   <span class="keyword">struct </span><a class="code" href="structMeshBase_1_1const__node__iterator.php">const_node_iterator</a>;
<a name="l00515"></a>00515 
<a name="l00525"></a>00525   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#a9bba495febbd880e80fc0b3726194bcb">recalculate_n_partitions</a>();
<a name="l00526"></a>00526 
<a name="l00531"></a>00531   <span class="keyword">const</span> <a class="code" href="classPointLocatorBase.php">PointLocatorBase</a> &amp; <a class="code" href="classMeshBase.php#aaf790ef555dbc2e8d1acec39bca69565">point_locator</a> () <span class="keyword">const</span>;
<a name="l00532"></a>00532 
<a name="l00536"></a>00536   <span class="keywordtype">void</span> <a class="code" href="classMeshBase.php#a5ac0350d976e303267b8195417367689">clear_point_locator</a> ();
<a name="l00537"></a>00537 
<a name="l00538"></a>00538 
<a name="l00539"></a>00539 
<a name="l00540"></a>00540 <span class="keyword">public</span>:
<a name="l00541"></a>00541 
<a name="l00542"></a>00542 
<a name="l00543"></a>00543   
<a name="l00548"></a>00548   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>                   () = 0;
<a name="l00549"></a>00549   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>                     () = 0;
<a name="l00550"></a>00550   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>            () = 0;
<a name="l00551"></a>00551   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>              () = 0;
<a name="l00552"></a>00552   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a06d9df2c0e21405bdf71afe8959bb3e6">ancestor_elements_begin</a>          () = 0;
<a name="l00553"></a>00553   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a1473b2275c9fcc6d2f46a537a550e98e">ancestor_elements_end</a>            () = 0;
<a name="l00554"></a>00554   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#af0f9a7d415ef21fdf97bcc9a78acfce1">subactive_elements_begin</a>         () = 0;
<a name="l00555"></a>00555   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a479aaa8e0e7b8a4250ad525bb8ae0bec">subactive_elements_end</a>           () = 0;
<a name="l00556"></a>00556   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#ad9834ede21c9475f12058d83a543a5f4">not_active_elements_begin</a>        () = 0;
<a name="l00557"></a>00557   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a94d764ef131e0db1538fc6ff09d1c8cd">not_active_elements_end</a>          () = 0;
<a name="l00558"></a>00558   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a1c5f7ba591002df6845ab0167fb6210d">not_ancestor_elements_begin</a>      () = 0;
<a name="l00559"></a>00559   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a73b7162ae5cfaa88b3e4630f60309c53">not_ancestor_elements_end</a>        () = 0;
<a name="l00560"></a>00560   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a7e8034e9c8897fcfafb041a1d9a1b45b">not_subactive_elements_begin</a>     () = 0;
<a name="l00561"></a>00561   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#aaa336b3c8b348ca14dbd36216b3b6816">not_subactive_elements_end</a>       () = 0;
<a name="l00562"></a>00562   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a85cb016589044fbc17fd9d3ce138f1b6">local_elements_begin</a>             () = 0;
<a name="l00563"></a>00563   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a8184d52812b82a9a38b66a0c89f04b17">local_elements_end</a>               () = 0;
<a name="l00564"></a>00564   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a3275e5f9584829168869970eb054a3b9">not_local_elements_begin</a>         () = 0;
<a name="l00565"></a>00565   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#af962c00ff77e139367263d886290fc2a">not_local_elements_end</a>           () = 0;
<a name="l00566"></a>00566   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>      () = 0;
<a name="l00567"></a>00567   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>        () = 0;
<a name="l00568"></a>00568   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a129cb04a7239a903c0b46160100ca23f">active_not_local_elements_begin</a>  () = 0;
<a name="l00569"></a>00569   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#aa25829f8e5eef9692925ffea58c7db1c">active_not_local_elements_end</a>    () = 0;
<a name="l00570"></a>00570   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a534079bde46c7d86cb976db76c697804">level_elements_begin</a>             (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level  ) = 0;
<a name="l00571"></a>00571   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a724dcfe5c7d4ad16f3ee09e22d6f1372">level_elements_end</a>               (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level  ) = 0;
<a name="l00572"></a>00572   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a456e965917ff1a3a273d885c287e30a7">not_level_elements_begin</a>         (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level  ) = 0;
<a name="l00573"></a>00573   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a9f0707833ff5453a2dc089cdee9e4b90">not_level_elements_end</a>           (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level  ) = 0;
<a name="l00574"></a>00574   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a7df701cd3172c65bf147d0fafe002a39">local_level_elements_begin</a>       (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level  ) = 0;
<a name="l00575"></a>00575   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a80fe21ac40ace65369a25040f91ab1b4">local_level_elements_end</a>         (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level  ) = 0;
<a name="l00576"></a>00576   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a1fb56e06bd6b6be3134674bc7d6ea17b">local_not_level_elements_begin</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level  ) = 0;
<a name="l00577"></a>00577   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#aa46f3c13a1ec29c39f5eefb936cd8ecd">local_not_level_elements_end</a>     (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level  ) = 0;
<a name="l00578"></a>00578   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#aa8cbd1381e63c4c468292c1275497724">pid_elements_begin</a>               (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) = 0;
<a name="l00579"></a>00579   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a2fa21ec41ad9c25eb2617fca513bca5d">pid_elements_end</a>                 (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) = 0;
<a name="l00580"></a>00580   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a3943f62e4a9bc0290d1c2a01251cf257">type_elements_begin</a>              (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type       ) = 0;
<a name="l00581"></a>00581   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a5c675c2c62ad6b627778687cc3443bcf">type_elements_end</a>                (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type       ) = 0;
<a name="l00582"></a>00582   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#aa49bba401e1509f93912bf56ca5532b0">active_type_elements_begin</a>       (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type       ) = 0;
<a name="l00583"></a>00583   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a6d51a49cc54a4734c02f39c5a4511191">active_type_elements_end</a>         (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type       ) = 0;
<a name="l00584"></a>00584   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#ac0e09837e3ba3077c14015ea4b73ec08">active_pid_elements_begin</a>        (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) = 0;
<a name="l00585"></a>00585   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a44926338045dcfee9dae93975aeafe9a">active_pid_elements_end</a>          (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) = 0;
<a name="l00586"></a>00586   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#af00e2afee8c81f0058853ca412abfd03">unpartitioned_elements_begin</a>     () = 0;
<a name="l00587"></a>00587   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a0fa23d043576937cd8ab9430a6608409">unpartitioned_elements_end</a>       () = 0;
<a name="l00588"></a>00588   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a0695440645d13a6fd736004d0aa338d6">active_local_subdomain_elements_begin</a>         (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id) = 0;
<a name="l00589"></a>00589   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> <a class="code" href="classMeshBase.php#a3e164de65a543b3d215b7b824839bb78">active_local_subdomain_elements_end</a>           (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id) = 0;
<a name="l00590"></a>00590   
<a name="l00591"></a>00591 
<a name="l00592"></a>00592   
<a name="l00593"></a>00593   
<a name="l00597"></a>00597   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>                   () <span class="keyword">const</span> = 0;
<a name="l00598"></a>00598   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>                     () <span class="keyword">const</span> = 0;
<a name="l00599"></a>00599   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>            () <span class="keyword">const</span> = 0;
<a name="l00600"></a>00600   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>              () <span class="keyword">const</span> = 0;
<a name="l00601"></a>00601   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a06d9df2c0e21405bdf71afe8959bb3e6">ancestor_elements_begin</a>          () <span class="keyword">const</span> = 0;
<a name="l00602"></a>00602   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a1473b2275c9fcc6d2f46a537a550e98e">ancestor_elements_end</a>            () <span class="keyword">const</span> = 0;
<a name="l00603"></a>00603   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#af0f9a7d415ef21fdf97bcc9a78acfce1">subactive_elements_begin</a>         () <span class="keyword">const</span> = 0;
<a name="l00604"></a>00604   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a479aaa8e0e7b8a4250ad525bb8ae0bec">subactive_elements_end</a>           () <span class="keyword">const</span> = 0;
<a name="l00605"></a>00605   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#ad9834ede21c9475f12058d83a543a5f4">not_active_elements_begin</a>        () <span class="keyword">const</span> = 0;
<a name="l00606"></a>00606   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a94d764ef131e0db1538fc6ff09d1c8cd">not_active_elements_end</a>          () <span class="keyword">const</span> = 0;
<a name="l00607"></a>00607   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a1c5f7ba591002df6845ab0167fb6210d">not_ancestor_elements_begin</a>      () <span class="keyword">const</span> = 0;
<a name="l00608"></a>00608   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a73b7162ae5cfaa88b3e4630f60309c53">not_ancestor_elements_end</a>        () <span class="keyword">const</span> = 0;
<a name="l00609"></a>00609   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a7e8034e9c8897fcfafb041a1d9a1b45b">not_subactive_elements_begin</a>     () <span class="keyword">const</span> = 0;
<a name="l00610"></a>00610   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#aaa336b3c8b348ca14dbd36216b3b6816">not_subactive_elements_end</a>       () <span class="keyword">const</span> = 0;
<a name="l00611"></a>00611   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a85cb016589044fbc17fd9d3ce138f1b6">local_elements_begin</a>             () <span class="keyword">const</span> = 0;
<a name="l00612"></a>00612   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a8184d52812b82a9a38b66a0c89f04b17">local_elements_end</a>               () <span class="keyword">const</span> = 0;
<a name="l00613"></a>00613   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a3275e5f9584829168869970eb054a3b9">not_local_elements_begin</a>         () <span class="keyword">const</span> = 0;
<a name="l00614"></a>00614   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#af962c00ff77e139367263d886290fc2a">not_local_elements_end</a>           () <span class="keyword">const</span> = 0;
<a name="l00615"></a>00615   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>      () <span class="keyword">const</span> = 0;
<a name="l00616"></a>00616   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>        () <span class="keyword">const</span> = 0;
<a name="l00617"></a>00617   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a129cb04a7239a903c0b46160100ca23f">active_not_local_elements_begin</a>  () <span class="keyword">const</span> = 0;
<a name="l00618"></a>00618   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#aa25829f8e5eef9692925ffea58c7db1c">active_not_local_elements_end</a>    () <span class="keyword">const</span> = 0;
<a name="l00619"></a>00619   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a534079bde46c7d86cb976db76c697804">level_elements_begin</a>             (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)   <span class="keyword">const</span> = 0;
<a name="l00620"></a>00620   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a724dcfe5c7d4ad16f3ee09e22d6f1372">level_elements_end</a>               (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)   <span class="keyword">const</span> = 0;
<a name="l00621"></a>00621   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a456e965917ff1a3a273d885c287e30a7">not_level_elements_begin</a>         (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)   <span class="keyword">const</span> = 0;
<a name="l00622"></a>00622   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a9f0707833ff5453a2dc089cdee9e4b90">not_level_elements_end</a>           (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)   <span class="keyword">const</span> = 0;
<a name="l00623"></a>00623   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a7df701cd3172c65bf147d0fafe002a39">local_level_elements_begin</a>       (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)   <span class="keyword">const</span> = 0;
<a name="l00624"></a>00624   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a80fe21ac40ace65369a25040f91ab1b4">local_level_elements_end</a>         (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)   <span class="keyword">const</span> = 0;
<a name="l00625"></a>00625   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a1fb56e06bd6b6be3134674bc7d6ea17b">local_not_level_elements_begin</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)   <span class="keyword">const</span> = 0;
<a name="l00626"></a>00626   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#aa46f3c13a1ec29c39f5eefb936cd8ecd">local_not_level_elements_end</a>     (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)   <span class="keyword">const</span> = 0;
<a name="l00627"></a>00627   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#aa8cbd1381e63c4c468292c1275497724">pid_elements_begin</a>               (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span> = 0;
<a name="l00628"></a>00628   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a2fa21ec41ad9c25eb2617fca513bca5d">pid_elements_end</a>                 (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span> = 0;
<a name="l00629"></a>00629   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a3943f62e4a9bc0290d1c2a01251cf257">type_elements_begin</a>              (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)        <span class="keyword">const</span> = 0;
<a name="l00630"></a>00630   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a5c675c2c62ad6b627778687cc3443bcf">type_elements_end</a>                (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)        <span class="keyword">const</span> = 0;
<a name="l00631"></a>00631   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#aa49bba401e1509f93912bf56ca5532b0">active_type_elements_begin</a>       (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)        <span class="keyword">const</span> = 0;
<a name="l00632"></a>00632   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a6d51a49cc54a4734c02f39c5a4511191">active_type_elements_end</a>         (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)        <span class="keyword">const</span> = 0;
<a name="l00633"></a>00633   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#ac0e09837e3ba3077c14015ea4b73ec08">active_pid_elements_begin</a>        (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span> = 0;
<a name="l00634"></a>00634   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a44926338045dcfee9dae93975aeafe9a">active_pid_elements_end</a>          (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span> = 0;
<a name="l00635"></a>00635   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#af00e2afee8c81f0058853ca412abfd03">unpartitioned_elements_begin</a>     () <span class="keyword">const</span> = 0;
<a name="l00636"></a>00636   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a0fa23d043576937cd8ab9430a6608409">unpartitioned_elements_end</a>       () <span class="keyword">const</span> = 0;
<a name="l00637"></a>00637   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a0695440645d13a6fd736004d0aa338d6">active_local_subdomain_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id) <span class="keyword">const</span> = 0;
<a name="l00638"></a>00638   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> <a class="code" href="classMeshBase.php#a3e164de65a543b3d215b7b824839bb78">active_local_subdomain_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id) <span class="keyword">const</span> = 0;
<a name="l00639"></a>00639 
<a name="l00640"></a>00640   
<a name="l00644"></a>00644   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1node__iterator.php">node_iterator</a> <a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>        () = 0;
<a name="l00645"></a>00645   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1node__iterator.php">node_iterator</a> <a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>          () = 0;
<a name="l00646"></a>00646   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1node__iterator.php">node_iterator</a> <a class="code" href="classMeshBase.php#addecf0fbdaee5d0d378ea96959e53dcf">active_nodes_begin</a> () = 0;
<a name="l00647"></a>00647   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1node__iterator.php">node_iterator</a> <a class="code" href="classMeshBase.php#aa2d723dc887214f9fd6dc302a7c74570">active_nodes_end</a>   () = 0;
<a name="l00648"></a>00648   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1node__iterator.php">node_iterator</a> <a class="code" href="classMeshBase.php#a6485de7e7d67f36dec274f512d10fc15">local_nodes_begin</a>  () = 0;
<a name="l00649"></a>00649   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1node__iterator.php">node_iterator</a> <a class="code" href="classMeshBase.php#ae23ced52382b7238f9182c8593f5cdd5">local_nodes_end</a>    () = 0;
<a name="l00650"></a>00650   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1node__iterator.php">node_iterator</a> <a class="code" href="classMeshBase.php#a2fcbe0fe5068603530d34543033c9e5b">pid_nodes_begin</a>    (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) = 0;
<a name="l00651"></a>00651   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1node__iterator.php">node_iterator</a> <a class="code" href="classMeshBase.php#abff909aecd7e32786f49646fee5ae4a1">pid_nodes_end</a>      (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) = 0;
<a name="l00652"></a>00652 
<a name="l00653"></a>00653 
<a name="l00657"></a>00657   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">const_node_iterator</a> <a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>        () <span class="keyword">const</span> = 0;
<a name="l00658"></a>00658   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">const_node_iterator</a> <a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>          () <span class="keyword">const</span> = 0;
<a name="l00659"></a>00659   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">const_node_iterator</a> <a class="code" href="classMeshBase.php#addecf0fbdaee5d0d378ea96959e53dcf">active_nodes_begin</a> () <span class="keyword">const</span> = 0;
<a name="l00660"></a>00660   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">const_node_iterator</a> <a class="code" href="classMeshBase.php#aa2d723dc887214f9fd6dc302a7c74570">active_nodes_end</a>   () <span class="keyword">const</span> = 0;
<a name="l00661"></a>00661   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">const_node_iterator</a> <a class="code" href="classMeshBase.php#a6485de7e7d67f36dec274f512d10fc15">local_nodes_begin</a>  () <span class="keyword">const</span> = 0;
<a name="l00662"></a>00662   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">const_node_iterator</a> <a class="code" href="classMeshBase.php#ae23ced52382b7238f9182c8593f5cdd5">local_nodes_end</a>    () <span class="keyword">const</span> = 0;
<a name="l00663"></a>00663   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">const_node_iterator</a> <a class="code" href="classMeshBase.php#a2fcbe0fe5068603530d34543033c9e5b">pid_nodes_begin</a>    (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span> = 0;
<a name="l00664"></a>00664   <span class="keyword">virtual</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">const_node_iterator</a> <a class="code" href="classMeshBase.php#abff909aecd7e32786f49646fee5ae4a1">pid_nodes_end</a>      (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span> = 0;
<a name="l00665"></a>00665 
<a name="l00666"></a>00666 
<a name="l00667"></a>00667   
<a name="l00671"></a><a class="code" href="classMeshBase.php#a5b09171a87347ea1d0134314b1f99c6e">00671</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; <a class="code" href="classMeshBase.php#a5b09171a87347ea1d0134314b1f99c6e">set_n_subdomains</a> ()
<a name="l00672"></a>00672   { <span class="keywordflow">return</span> <a class="code" href="classMeshBase.php#af28478381f2803a30aaf1d925df4c673">_n_sbd</a>; }
<a name="l00673"></a>00673   
<a name="l00674"></a>00674   
<a name="l00675"></a>00675 <span class="keyword">protected</span>:
<a name="l00676"></a>00676 
<a name="l00677"></a>00677 
<a name="l00678"></a>00678 
<a name="l00679"></a>00679   
<a name="l00680"></a>00680   
<a name="l00681"></a>00681 
<a name="l00685"></a><a class="code" href="classMeshBase.php#aafa827a5ddf0645ec7c5aa926f9d19e0">00685</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; <a class="code" href="classMeshBase.php#aafa827a5ddf0645ec7c5aa926f9d19e0">set_n_partitions</a> ()
<a name="l00686"></a>00686   { <span class="keywordflow">return</span> <a class="code" href="classMeshBase.php#ad6717b5155fa3c20c3fa5a419ea307bd">_n_parts</a>; }
<a name="l00687"></a>00687   
<a name="l00696"></a><a class="code" href="classMeshBase.php#af28478381f2803a30aaf1d925df4c673">00696</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#af28478381f2803a30aaf1d925df4c673">_n_sbd</a>;
<a name="l00697"></a>00697 
<a name="l00707"></a><a class="code" href="classMeshBase.php#ad6717b5155fa3c20c3fa5a419ea307bd">00707</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#ad6717b5155fa3c20c3fa5a419ea307bd">_n_parts</a>;
<a name="l00708"></a>00708   
<a name="l00712"></a><a class="code" href="classMeshBase.php#a9a02b0f83c0debf7395aa48edb030c39">00712</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshBase.php#a9a02b0f83c0debf7395aa48edb030c39">_dim</a>;
<a name="l00713"></a>00713 
<a name="l00717"></a><a class="code" href="classMeshBase.php#a1322dbb0d67f763b24ea50fc872cb4f2">00717</a>   <span class="keywordtype">bool</span> <a class="code" href="classMeshBase.php#a1322dbb0d67f763b24ea50fc872cb4f2">_is_prepared</a>;
<a name="l00718"></a>00718   
<a name="l00726"></a><a class="code" href="classMeshBase.php#af17cc1c5b23972cca5d4b0104745ab7b">00726</a>   <span class="keyword">mutable</span> <a class="code" href="classAutoPtr.php">AutoPtr&lt;PointLocatorBase&gt;</a> <a class="code" href="classMeshBase.php#af17cc1c5b23972cca5d4b0104745ab7b">_point_locator</a>;
<a name="l00727"></a>00727 
<a name="l00734"></a><a class="code" href="classMeshBase.php#a313380606806d2771ba4f2e78f7400d9">00734</a>   <a class="code" href="classAutoPtr.php">AutoPtr&lt;Partitioner&gt;</a> <a class="code" href="classMeshBase.php#a313380606806d2771ba4f2e78f7400d9">_partitioner</a>;
<a name="l00735"></a>00735   
<a name="l00740"></a><a class="code" href="classMeshBase.php#aecb7b18be543e142af79de1f0d0ed931">00740</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classPartitioner.php">Partitioner</a>;
<a name="l00741"></a>00741 
<a name="l00746"></a><a class="code" href="classMeshBase.php#a2c8dc194240e1c00896436711ef64897">00746</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classBoundaryInfo.php">BoundaryInfo</a>;
<a name="l00747"></a>00747 
<a name="l00748"></a>00748 };
<a name="l00749"></a>00749 
<a name="l00750"></a>00750 
<a name="l00751"></a>00751 
<a name="l00752"></a>00752 
<a name="l00753"></a>00753 
<a name="l00754"></a>00754 
<a name="l00755"></a>00755 
<a name="l00756"></a>00756 
<a name="l00757"></a>00757 
<a name="l00758"></a>00758 
<a name="l00759"></a>00759 
<a name="l00763"></a><a class="code" href="structMeshBase_1_1element__iterator.php">00763</a> <span class="keyword">struct</span>
<a name="l00764"></a>00764 <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> :
<a name="l00765"></a>00765 <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&lt;<a class="code" href="classMeshBase.php#a22f06c73e7c2ac3f27b888fa19a64e26">MeshBase::Predicate</a>,
<a name="l00766"></a>00766                         <a class="code" href="classElem.php">Elem</a>*&gt;
<a name="l00767"></a>00767 {
<a name="l00768"></a>00768   <span class="comment">// Templated forwarding ctor -- forwards to appropriate variant_filter_iterator ctor</span>
<a name="l00769"></a>00769   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> PredType, <span class="keyword">typename</span> IterType&gt;
<a name="l00770"></a><a class="code" href="structMeshBase_1_1element__iterator.php#ae5b35ff92304a90956c1b1bfd237979f">00770</a>   <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> (<span class="keyword">const</span> IterType&amp; d,
<a name="l00771"></a>00771                     <span class="keyword">const</span> IterType&amp; e,
<a name="l00772"></a>00772                     <span class="keyword">const</span> PredType&amp; p ) :
<a name="l00773"></a>00773     <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>::<a class="code" href="structPredicates_1_1multi__predicate.php">Predicate</a>,
<a name="l00774"></a>00774                             <a class="code" href="classElem.php">Elem</a>*&gt;(d,e,p) {}
<a name="l00775"></a>00775 };
<a name="l00776"></a>00776 
<a name="l00777"></a>00777 
<a name="l00778"></a>00778 
<a name="l00779"></a>00779 
<a name="l00784"></a><a class="code" href="structMeshBase_1_1const__element__iterator.php">00784</a> <span class="keyword">struct</span>
<a name="l00785"></a>00785 <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> :
<a name="l00786"></a>00786 <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&lt;<a class="code" href="classMeshBase.php#a22f06c73e7c2ac3f27b888fa19a64e26">MeshBase::Predicate</a>,
<a name="l00787"></a>00787                         <a class="code" href="classElem.php">Elem</a>* <span class="keyword">const</span>,
<a name="l00788"></a>00788                         Elem* <span class="keyword">const</span>&amp;,
<a name="l00789"></a>00789                         Elem* <span class="keyword">const</span>*&gt;
<a name="l00790"></a>00790 {
<a name="l00791"></a>00791   <span class="comment">// Templated forwarding ctor -- forwards to appropriate variant_filter_iterator ctor</span>
<a name="l00792"></a>00792   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> PredType, <span class="keyword">typename</span> IterType&gt;
<a name="l00793"></a><a class="code" href="structMeshBase_1_1const__element__iterator.php#ac8814e4c50f79fd8df9741976db4b71f">00793</a>   <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> (<span class="keyword">const</span> IterType&amp; d,
<a name="l00794"></a>00794                           <span class="keyword">const</span> IterType&amp; e,
<a name="l00795"></a>00795                           <span class="keyword">const</span> PredType&amp; p ) :
<a name="l00796"></a>00796     <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>::<a class="code" href="structPredicates_1_1multi__predicate.php">Predicate</a>,
<a name="l00797"></a>00797                             Elem* const,
<a name="l00798"></a>00798                             Elem* const&amp;,
<a name="l00799"></a>00799                             Elem* const*&gt;(d,e,p)  {}
<a name="l00800"></a>00800 
<a name="l00801"></a>00801 
<a name="l00802"></a>00802   <span class="comment">// The conversion-to-const ctor.  Takes a regular iterator and calls the appropriate</span>
<a name="l00803"></a>00803   <span class="comment">// variant_filter_iterator copy constructor.  Note that this one is *not* templated!</span>
<a name="l00804"></a><a class="code" href="structMeshBase_1_1const__element__iterator.php#a1e668a9081fc95dcc96e2a1ae308f029">00804</a>   <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> (<span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>&amp; rhs) :
<a name="l00805"></a>00805     <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&lt;<a class="code" href="structPredicates_1_1multi__predicate.php">Predicate</a>,
<a name="l00806"></a>00806                             Elem* const,
<a name="l00807"></a>00807                             Elem* const&amp;,
<a name="l00808"></a>00808                             Elem* const*&gt;(rhs)
<a name="l00809"></a>00809   {
<a name="l00810"></a>00810     <span class="comment">// std::cout &lt;&lt; &quot;Called element_iterator conversion-to-const ctor.&quot; &lt;&lt; std::endl;</span>
<a name="l00811"></a>00811   }
<a name="l00812"></a>00812 };
<a name="l00813"></a>00813 
<a name="l00814"></a>00814 
<a name="l00815"></a>00815 
<a name="l00816"></a>00816 
<a name="l00817"></a>00817 
<a name="l00818"></a>00818 
<a name="l00819"></a>00819 
<a name="l00823"></a><a class="code" href="structMeshBase_1_1node__iterator.php">00823</a> <span class="keyword">struct</span>
<a name="l00824"></a>00824 <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> :
<a name="l00825"></a>00825 <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&lt;<a class="code" href="classMeshBase.php#a22f06c73e7c2ac3f27b888fa19a64e26">MeshBase::Predicate</a>,
<a name="l00826"></a>00826                         <a class="code" href="classNode.php">Node</a>*&gt;
<a name="l00827"></a>00827 {
<a name="l00828"></a>00828   <span class="comment">// Templated forwarding ctor -- forwards to appropriate variant_filter_iterator ctor</span>
<a name="l00829"></a>00829   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> PredType, <span class="keyword">typename</span> IterType&gt;
<a name="l00830"></a><a class="code" href="structMeshBase_1_1node__iterator.php#a3157ad896922260058ec68e8df8382a1">00830</a>   <a class="code" href="structMeshBase_1_1node__iterator.php">node_iterator</a> (<span class="keyword">const</span> IterType&amp; d,
<a name="l00831"></a>00831                  <span class="keyword">const</span> IterType&amp; e,
<a name="l00832"></a>00832                  <span class="keyword">const</span> PredType&amp; p ) :
<a name="l00833"></a>00833     <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>::<a class="code" href="structPredicates_1_1multi__predicate.php">Predicate</a>,
<a name="l00834"></a>00834                             <a class="code" href="classNode.php">Node</a>*&gt;(d,e,p) {}
<a name="l00835"></a>00835 };
<a name="l00836"></a>00836 
<a name="l00837"></a>00837 
<a name="l00838"></a>00838 
<a name="l00839"></a>00839 
<a name="l00844"></a><a class="code" href="structMeshBase_1_1const__node__iterator.php">00844</a> <span class="keyword">struct</span>
<a name="l00845"></a>00845 <a class="code" href="structMeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> :
<a name="l00846"></a>00846 <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&lt;<a class="code" href="classMeshBase.php#a22f06c73e7c2ac3f27b888fa19a64e26">MeshBase::Predicate</a>,
<a name="l00847"></a>00847                         <a class="code" href="classNode.php">Node</a>* <span class="keyword">const</span>,
<a name="l00848"></a>00848                         Node* <span class="keyword">const</span> &amp;,
<a name="l00849"></a>00849                         Node* <span class="keyword">const</span> *&gt;
<a name="l00850"></a>00850 {
<a name="l00851"></a>00851   <span class="comment">// Templated forwarding ctor -- forwards to appropriate variant_filter_iterator ctor</span>
<a name="l00852"></a>00852   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> PredType, <span class="keyword">typename</span> IterType&gt;
<a name="l00853"></a><a class="code" href="structMeshBase_1_1const__node__iterator.php#ad225924d8158e48336eb5fb09ecbe019">00853</a>   <a class="code" href="structMeshBase_1_1const__node__iterator.php">const_node_iterator</a> (<span class="keyword">const</span> IterType&amp; d,
<a name="l00854"></a>00854                        <span class="keyword">const</span> IterType&amp; e,
<a name="l00855"></a>00855                        <span class="keyword">const</span> PredType&amp; p ) :
<a name="l00856"></a>00856     <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>::<a class="code" href="structPredicates_1_1multi__predicate.php">Predicate</a>,
<a name="l00857"></a>00857                             Node* const,
<a name="l00858"></a>00858                             Node* const &amp;,
<a name="l00859"></a>00859                             Node* const *&gt;(d,e,p)  {}
<a name="l00860"></a>00860 
<a name="l00861"></a>00861 
<a name="l00862"></a>00862   <span class="comment">// The conversion-to-const ctor.  Takes a regular iterator and calls the appropriate</span>
<a name="l00863"></a>00863   <span class="comment">// variant_filter_iterator copy constructor.  Note that this one is *not* templated!</span>
<a name="l00864"></a><a class="code" href="structMeshBase_1_1const__node__iterator.php#af9a34b4dc20bd1617ef395212d6617fe">00864</a>   <a class="code" href="structMeshBase_1_1const__node__iterator.php">const_node_iterator</a> (<span class="keyword">const</span> <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>&amp; rhs) :
<a name="l00865"></a>00865     <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&lt;<a class="code" href="structPredicates_1_1multi__predicate.php">Predicate</a>,
<a name="l00866"></a>00866                             Node* const,
<a name="l00867"></a>00867                             Node* const &amp;,
<a name="l00868"></a>00868                             Node* const *&gt;(rhs)
<a name="l00869"></a>00869   {
<a name="l00870"></a>00870     <span class="comment">// std::cout &lt;&lt; &quot;Called node_iterator conversion-to-const ctor.&quot; &lt;&lt; std::endl;</span>
<a name="l00871"></a>00871   }
<a name="l00872"></a>00872 };
<a name="l00873"></a>00873 
<a name="l00874"></a>00874 
<a name="l00875"></a>00875 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
