<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_communication.h</h1>  </div>
</div>
<div class="contents">
<a href="mesh__communication_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_communication.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __mesh_communication_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_communication_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="mesh__tools_8h.php">mesh_tools.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Forward declarations</span>
<a name="l00034"></a>00034 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00035"></a>00035 <span class="keyword">class </span><a class="code" href="classParallelMesh.php">ParallelMesh</a>;
<a name="l00036"></a>00036 <span class="keyword">class </span><a class="code" href="classBoundaryInfo.php">BoundaryInfo</a>;
<a name="l00037"></a>00037 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classLocationMap.php">LocationMap</a>;
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00050"></a>00050 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00051"></a>00051 <span class="comment">// MeshCommunication class definition</span>
<a name="l00052"></a><a class="code" href="classMeshCommunication.php">00052</a> <span class="keyword">class </span><a class="code" href="classMeshCommunication.php">MeshCommunication</a>
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054 <span class="keyword">public</span>:
<a name="l00055"></a>00055 
<a name="l00059"></a><a class="code" href="classMeshCommunication.php#a638aad20919eaed93144a4735a75004a">00059</a>   <a class="code" href="classMeshCommunication.php#a638aad20919eaed93144a4735a75004a">MeshCommunication</a> () {}
<a name="l00060"></a>00060 
<a name="l00064"></a><a class="code" href="classMeshCommunication.php#adce0da24854f89b018fc7aec49509478">00064</a>   <a class="code" href="classMeshCommunication.php#adce0da24854f89b018fc7aec49509478">~MeshCommunication</a> () {}
<a name="l00065"></a>00065 
<a name="l00069"></a>00069   <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#a086c678faf2b37cc2033be2342ef3c74">clear</a> ();
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 <span class="comment">//   /**</span>
<a name="l00072"></a>00072 <span class="comment">//    * Finds all the processors that may contain</span>
<a name="l00073"></a>00073 <span class="comment">//    * elements that neighbor my elements.  This list</span>
<a name="l00074"></a>00074 <span class="comment">//    * is guaranteed to include all processors that border</span>
<a name="l00075"></a>00075 <span class="comment">//    * any of my elements, but may include additional ones as</span>
<a name="l00076"></a>00076 <span class="comment">//    * well.  This method computes bounding boxes for the</span>
<a name="l00077"></a>00077 <span class="comment">//    * elements on each processor and checks for overlaps.</span>
<a name="l00078"></a>00078 <span class="comment">//    */</span>
<a name="l00079"></a>00079 <span class="comment">//   void find_neighboring_processors(const MeshBase &amp;);</span>
<a name="l00080"></a>00080 
<a name="l00087"></a>00087   <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#af47e26c3e42077ed8389a4faf1b52570">broadcast</a> (<a class="code" href="classMeshBase.php">MeshBase</a> &amp;) <span class="keyword">const</span>;
<a name="l00088"></a>00088 
<a name="l00100"></a>00100   <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#a81c4ded86040b982ff4c811823c7c187">redistribute</a> (<a class="code" href="classParallelMesh.php">ParallelMesh</a> &amp;) <span class="keyword">const</span>;
<a name="l00101"></a>00101 
<a name="l00105"></a>00105   <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#ae4d56ded77652b52bec621f5093091ce">gather_neighboring_elements</a> (<a class="code" href="classParallelMesh.php">ParallelMesh</a> &amp;) <span class="keyword">const</span>;
<a name="l00106"></a>00106   
<a name="l00115"></a>00115   <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#a21c1490e797f0bce2a29880c078eb8f5">allgather</a> (<a class="code" href="classParallelMesh.php">ParallelMesh</a> &amp;) <span class="keyword">const</span>;
<a name="l00116"></a>00116 
<a name="l00127"></a>00127   <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#aeb16d7915a3e73e7d12f3e928aa22431">delete_remote_elements</a> (<a class="code" href="classParallelMesh.php">ParallelMesh</a> &amp;) <span class="keyword">const</span>;
<a name="l00128"></a>00128 
<a name="l00139"></a>00139   <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#aa1ac865b823fff87470b2f2fcc68a00b">assign_global_indices</a> (<a class="code" href="classMeshBase.php">MeshBase</a> &amp;) <span class="keyword">const</span>;
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00146"></a>00146   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> ForwardIterator&gt;
<a name="l00147"></a>00147   <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#ad39ffc569ad59944067e273a77a06abd">find_global_indices</a> (<span class="keyword">const</span> <a class="code" href="classMeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a> &amp;,
<a name="l00148"></a>00148                             <span class="keyword">const</span> ForwardIterator &amp;,
<a name="l00149"></a>00149                             <span class="keyword">const</span> ForwardIterator &amp;,
<a name="l00150"></a>00150                             std::vector&lt;unsigned int&gt; &amp;) <span class="keyword">const</span>;
<a name="l00151"></a>00151 
<a name="l00155"></a>00155   <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#a7b765d81a42d5e663f884ed709dd4040">make_elems_parallel_consistent</a> (<a class="code" href="classMeshBase.php">MeshBase</a> &amp;);
<a name="l00156"></a>00156 
<a name="l00162"></a>00162   <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#abce9300c55a7f17ace07ec52ea575c96">make_node_ids_parallel_consistent</a> (<a class="code" href="classMeshBase.php">MeshBase</a> &amp;,
<a name="l00163"></a>00163                                           <a class="code" href="classLocationMap.php">LocationMap&lt;Node&gt;</a> &amp;);
<a name="l00164"></a>00164 
<a name="l00170"></a>00170   <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#a663092448c5bc3a969eadbd6a002ce43">make_node_proc_ids_parallel_consistent</a> (<a class="code" href="classMeshBase.php">MeshBase</a> &amp;,
<a name="l00171"></a>00171                                                <a class="code" href="classLocationMap.php">LocationMap&lt;Node&gt;</a> &amp;);
<a name="l00172"></a>00172 
<a name="l00179"></a>00179   <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#ad2ae60d0388971e32c1060bf5304186e">make_nodes_parallel_consistent</a> (<a class="code" href="classMeshBase.php">MeshBase</a> &amp;,
<a name="l00180"></a>00180                                        <a class="code" href="classLocationMap.php">LocationMap&lt;Node&gt;</a> &amp;);
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 <span class="keyword">private</span>:
<a name="l00183"></a>00183 
<a name="l00184"></a>00184   <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#ad78fc27e8a89028e43d364173b62f974">broadcast_mesh</a> (<a class="code" href="classMeshBase.php">MeshBase</a> &amp;) <span class="keyword">const</span>;
<a name="l00185"></a>00185   <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#a4a9d78ca5e1cf68f295abe5b60c744ee">broadcast_bcs</a>  (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;, <a class="code" href="classBoundaryInfo.php">BoundaryInfo</a> &amp;) <span class="keyword">const</span>;
<a name="l00186"></a>00186 
<a name="l00187"></a>00187   <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#acd6f8a7ba179432312ff14e57ba7132c">allgather_mesh</a> (<a class="code" href="classParallelMesh.php">ParallelMesh</a> &amp;) <span class="keyword">const</span>;
<a name="l00188"></a>00188   <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#a1c1d7509c36d90cf7cf042b979e71d24">allgather_bcs</a>  (<span class="keyword">const</span> <a class="code" href="classParallelMesh.php">ParallelMesh</a> &amp;, <a class="code" href="classBoundaryInfo.php">BoundaryInfo</a> &amp;) <span class="keyword">const</span>;
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 <span class="comment">//   /**</span>
<a name="l00191"></a>00191 <span class="comment">//    * Packs the element \p elem at the end of vector \p conn.</span>
<a name="l00192"></a>00192 <span class="comment">//    * This includes all the information needed to rebuild the element</span>
<a name="l00193"></a>00193 <span class="comment">//    * on a remote processor, including refinement state.</span>
<a name="l00194"></a>00194 <span class="comment">//    */</span>
<a name="l00195"></a>00195 <span class="comment">//   void pack_element (std::vector&lt;int&gt; &amp;conn, const Elem* elem) const;</span>
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 <span class="comment">//   /**</span>
<a name="l00198"></a>00198 <span class="comment">//    * The processors who neighbor the current</span>
<a name="l00199"></a>00199 <span class="comment">//    * processor</span>
<a name="l00200"></a>00200 <span class="comment">//    */</span>
<a name="l00201"></a>00201 <span class="comment">//   std::vector&lt;unsigned short int&gt; _neighboring_processors;</span>
<a name="l00202"></a>00202 };
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 <span class="comment">//--------------------------------------------------------------</span>
<a name="l00207"></a>00207 <span class="comment">// MeshCommunication inline members</span>
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 <span class="preprocessor">#endif // end #ifndef __mesh_communication_h__ </span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
