<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_communication_global_indices.C</h1>  </div>
</div>
<div class="contents">
<a href="mesh__communication__global__indices_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_communication_global_indices.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;mesh_tools.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;mesh_communication.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;parallel.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;parallel_sort.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;elem_range.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;node_range.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#ifdef LIBMESH_HAVE_LIBHILBERT</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span><span class="preprocessor">#  include &quot;hilbert.h&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#endif</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span> 
<a name="l00040"></a>00040 <span class="preprocessor">#ifdef LIBMESH_HAVE_LIBHILBERT </span>
<a name="l00041"></a>00041 <span class="preprocessor"></span><span class="keyword">namespace </span>{ <span class="comment">// anonymous namespace for helper functions</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043   <span class="comment">// Utility function to map (x,y,z) in [bbox.min, bbox.max]^3 into</span>
<a name="l00044"></a>00044   <span class="comment">// [0,max_inttype]^3 for computing Hilbert keys</span>
<a name="l00045"></a>00045   <span class="keywordtype">void</span> get_hilbert_coords (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> &amp;p,
<a name="l00046"></a>00046                            <span class="keyword">const</span> <a class="code" href="classMeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a> &amp;bbox,
<a name="l00047"></a>00047                            CFixBitVec icoords[3])
<a name="l00048"></a>00048   {
<a name="l00049"></a>00049     <span class="keyword">static</span> <span class="keyword">const</span> Hilbert::inttype max_inttype = <span class="keyword">static_cast&lt;</span>Hilbert::inttype<span class="keyword">&gt;</span>(-1);
<a name="l00050"></a>00050 
<a name="l00051"></a>00051     <span class="keyword">const</span> <span class="keywordtype">double</span> <span class="comment">// put (x,y,z) in [0,1]^3 (don&#39;t divide by 0)</span>
<a name="l00052"></a>00052       x = ((bbox.first(0) == bbox.second(0)) ? 0. :
<a name="l00053"></a>00053            (p(0)-bbox.first(0))/(bbox.second(0)-bbox.first(0))),
<a name="l00054"></a>00054           
<a name="l00055"></a>00055       y = ((bbox.first(1) == bbox.second(1)) ? 0. :
<a name="l00056"></a>00056            (p(1)-bbox.first(1))/(bbox.second(1)-bbox.first(1))),
<a name="l00057"></a>00057           
<a name="l00058"></a>00058       z = ((bbox.first(2) == bbox.second(2)) ? 0. :
<a name="l00059"></a>00059            (p(2)-bbox.first(2))/(bbox.second(2)-bbox.first(2)));
<a name="l00060"></a>00060         
<a name="l00061"></a>00061     <span class="comment">// (iccords) in [0,max_inttype]^3</span>
<a name="l00062"></a>00062     icoords[0] = <span class="keyword">static_cast&lt;</span>Hilbert::inttype<span class="keyword">&gt;</span>(x*max_inttype);
<a name="l00063"></a>00063     icoords[1] = <span class="keyword">static_cast&lt;</span>Hilbert::inttype<span class="keyword">&gt;</span>(y*max_inttype);
<a name="l00064"></a>00064     icoords[2] = <span class="keyword">static_cast&lt;</span>Hilbert::inttype<span class="keyword">&gt;</span>(z*max_inttype);
<a name="l00065"></a>00065   }
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   
<a name="l00069"></a>00069   <span class="comment">// Compute the hilbert index</span>
<a name="l00070"></a>00070   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00071"></a>00071   Hilbert::HilbertIndices
<a name="l00072"></a>00072   get_hilbert_index (<span class="keyword">const</span> T *p,
<a name="l00073"></a>00073                      <span class="keyword">const</span> <a class="code" href="classMeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a> &amp;bbox)
<a name="l00074"></a>00074   {
<a name="l00075"></a>00075     <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sizeof_inttype = <span class="keyword">sizeof</span>(Hilbert::inttype);
<a name="l00076"></a>00076 
<a name="l00077"></a>00077     Hilbert::HilbertIndices index;
<a name="l00078"></a>00078     CFixBitVec icoords[3];
<a name="l00079"></a>00079     Hilbert::BitVecType bv;
<a name="l00080"></a>00080     get_hilbert_coords (*p, bbox, icoords);
<a name="l00081"></a>00081     Hilbert::coordsToIndex (icoords, 8*sizeof_inttype, 3, bv);
<a name="l00082"></a>00082     index = bv;
<a name="l00083"></a>00083 
<a name="l00084"></a>00084     <span class="keywordflow">return</span> index;
<a name="l00085"></a>00085   }
<a name="l00086"></a>00086 
<a name="l00087"></a>00087   <span class="keyword">template</span> &lt;&gt;
<a name="l00088"></a>00088   Hilbert::HilbertIndices
<a name="l00089"></a>00089   get_hilbert_index (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *e,
<a name="l00090"></a>00090                      <span class="keyword">const</span> <a class="code" href="classMeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a> &amp;bbox)
<a name="l00091"></a>00091   {
<a name="l00092"></a>00092     <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sizeof_inttype = <span class="keyword">sizeof</span>(Hilbert::inttype);
<a name="l00093"></a>00093 
<a name="l00094"></a>00094     Hilbert::HilbertIndices index;
<a name="l00095"></a>00095     CFixBitVec icoords[3];
<a name="l00096"></a>00096     Hilbert::BitVecType bv;
<a name="l00097"></a>00097     get_hilbert_coords (e-&gt;<a class="code" href="classElem.php#a46ce080150f08ce9d367b69f16dd0452">centroid</a>(), bbox, icoords);
<a name="l00098"></a>00098     Hilbert::coordsToIndex (icoords, 8*sizeof_inttype, 3, bv);
<a name="l00099"></a>00099     index = bv;
<a name="l00100"></a>00100 
<a name="l00101"></a>00101     <span class="keywordflow">return</span> index;
<a name="l00102"></a>00102   }
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00105"></a>00105   
<a name="l00106"></a>00106   <span class="comment">// Compute the hilbert index</span>
<a name="l00107"></a>00107   Hilbert::HilbertIndices
<a name="l00108"></a>00108   get_hilbert_index (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> &amp;p,
<a name="l00109"></a>00109                      <span class="keyword">const</span> <a class="code" href="classMeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a> &amp;bbox)
<a name="l00110"></a>00110   {
<a name="l00111"></a>00111     <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sizeof_inttype = <span class="keyword">sizeof</span>(Hilbert::inttype);
<a name="l00112"></a>00112 
<a name="l00113"></a>00113     Hilbert::HilbertIndices index;
<a name="l00114"></a>00114     CFixBitVec icoords[3];
<a name="l00115"></a>00115     Hilbert::BitVecType bv;
<a name="l00116"></a>00116     get_hilbert_coords (p, bbox, icoords);
<a name="l00117"></a>00117     Hilbert::coordsToIndex (icoords, 8*sizeof_inttype, 3, bv);
<a name="l00118"></a>00118     index = bv;
<a name="l00119"></a>00119 
<a name="l00120"></a>00120     <span class="keywordflow">return</span> index;
<a name="l00121"></a>00121   }
<a name="l00122"></a>00122 
<a name="l00123"></a>00123   <span class="comment">// Helper class for threaded Hilbert key computation</span>
<a name="l00124"></a>00124   <span class="keyword">class </span>ComputeHilbertKeys 
<a name="l00125"></a>00125   {
<a name="l00126"></a>00126   <span class="keyword">public</span>:
<a name="l00127"></a>00127     ComputeHilbertKeys (<span class="keyword">const</span> <a class="code" href="classMeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a> &amp;bbox,
<a name="l00128"></a>00128                         std::vector&lt;Hilbert::HilbertIndices&gt; &amp;keys) :
<a name="l00129"></a>00129       _bbox(bbox),
<a name="l00130"></a>00130       _keys(keys)
<a name="l00131"></a>00131     {}
<a name="l00132"></a>00132                                                         
<a name="l00133"></a>00133     <span class="comment">// computes the hilbert index for a node</span>
<a name="l00134"></a>00134     <span class="keywordtype">void</span> operator() (<span class="keyword">const</span> <a class="code" href="classStoredRange.php">ConstNodeRange</a> &amp;range)<span class="keyword"> const</span>
<a name="l00135"></a>00135 <span class="keyword">    </span>{
<a name="l00136"></a>00136       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pos = range.<a class="code" href="classStoredRange.php#aba72e48cb72507cc7958557d61c2acfa">first_idx</a>();
<a name="l00137"></a>00137       <span class="keywordflow">for</span> (<a class="code" href="classStoredRange.php#ab2657352e8f9c79ab6fa4085c0bdd0d8">ConstNodeRange::const_iterator</a> it = range.<a class="code" href="classStoredRange.php#a5f753b5b424dff3ab8030ce64d7a9f0a">begin</a>(); it!=range.<a class="code" href="classStoredRange.php#abc8b19e0ebe76d4cda84e870e652fcf6">end</a>(); ++it)
<a name="l00138"></a>00138         {
<a name="l00139"></a>00139           <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node = (*it);
<a name="l00140"></a>00140           libmesh_assert (node != NULL);
<a name="l00141"></a>00141           libmesh_assert (pos &lt; _keys.size());
<a name="l00142"></a>00142           _keys[pos++] = get_hilbert_index (*node, _bbox);
<a name="l00143"></a>00143         }       
<a name="l00144"></a>00144     }
<a name="l00145"></a>00145 
<a name="l00146"></a>00146     <span class="comment">// computes the hilbert index for an element</span>
<a name="l00147"></a>00147     <span class="keywordtype">void</span> operator() (<span class="keyword">const</span> <a class="code" href="classStoredRange.php">ConstElemRange</a> &amp;range)<span class="keyword"> const</span>
<a name="l00148"></a>00148 <span class="keyword">    </span>{ 
<a name="l00149"></a>00149       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pos = range.<a class="code" href="classStoredRange.php#aba72e48cb72507cc7958557d61c2acfa">first_idx</a>();
<a name="l00150"></a>00150       <span class="keywordflow">for</span> (<a class="code" href="classStoredRange.php#ab2657352e8f9c79ab6fa4085c0bdd0d8">ConstElemRange::const_iterator</a> it = range.<a class="code" href="classStoredRange.php#a5f753b5b424dff3ab8030ce64d7a9f0a">begin</a>(); it!=range.<a class="code" href="classStoredRange.php#abc8b19e0ebe76d4cda84e870e652fcf6">end</a>(); ++it)
<a name="l00151"></a>00151         {
<a name="l00152"></a>00152           <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = (*it);
<a name="l00153"></a>00153           libmesh_assert (elem != NULL);
<a name="l00154"></a>00154           libmesh_assert (pos &lt; _keys.size());
<a name="l00155"></a>00155           _keys[pos++] = get_hilbert_index (elem-&gt;<a class="code" href="classElem.php#a46ce080150f08ce9d367b69f16dd0452">centroid</a>(), _bbox);
<a name="l00156"></a>00156         }       
<a name="l00157"></a>00157     }
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   <span class="keyword">private</span>:                                      
<a name="l00160"></a>00160     <span class="keyword">const</span> <a class="code" href="classMeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a> &amp;_bbox;
<a name="l00161"></a>00161     std::vector&lt;Hilbert::HilbertIndices&gt; &amp;_keys;
<a name="l00162"></a>00162   };
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 }
<a name="l00165"></a>00165 <span class="preprocessor">#endif</span>
<a name="l00166"></a>00166 <span class="preprocessor"></span>
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00170"></a>00170 <span class="comment">// MeshCommunication class members</span>
<a name="l00171"></a>00171 <span class="preprocessor">#if defined(LIBMESH_HAVE_LIBHILBERT) &amp;&amp; defined(LIBMESH_HAVE_MPI)</span>
<a name="l00172"></a><a class="code" href="classMeshCommunication.php#aa1ac865b823fff87470b2f2fcc68a00b">00172</a> <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#aa1ac865b823fff87470b2f2fcc68a00b">MeshCommunication::assign_global_indices</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh)<span class="keyword"> const</span>
<a name="l00173"></a>00173 <span class="keyword"></span>{
<a name="l00174"></a>00174   START_LOG (<span class="stringliteral">&quot;assign_global_indices()&quot;</span>, <span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l00175"></a>00175 
<a name="l00176"></a>00176   <span class="comment">// This method determines partition-agnostic global indices</span>
<a name="l00177"></a>00177   <span class="comment">// for nodes and elements.</span>
<a name="l00178"></a>00178 
<a name="l00179"></a>00179   <span class="comment">// Algorithm:</span>
<a name="l00180"></a>00180   <span class="comment">// (1) compute the Hilbert key for each local node/element</span>
<a name="l00181"></a>00181   <span class="comment">// (2) perform a parallel sort of the Hilbert key</span>
<a name="l00182"></a>00182   <span class="comment">// (3) get the min/max value on each processor</span>
<a name="l00183"></a>00183   <span class="comment">// (4) determine the position in the global ranking for</span>
<a name="l00184"></a>00184   <span class="comment">//     each local object</span>
<a name="l00185"></a>00185 
<a name="l00186"></a>00186   <span class="comment">// Global bounding box</span>
<a name="l00187"></a>00187   <a class="code" href="classMeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a> bbox =
<a name="l00188"></a>00188     <a class="code" href="namespaceMeshTools.php#ad533681876e9809cfe5e2114886b1c03">MeshTools::bounding_box</a> (mesh);
<a name="l00189"></a>00189 
<a name="l00190"></a>00190   <span class="comment">// Set up a derived MPI datatype to handle communication of HilbertIndices</span>
<a name="l00191"></a>00191   MPI_Datatype hilbert_type;
<a name="l00192"></a>00192   MPI_Type_contiguous (3, MPI_UNSIGNED, &amp;hilbert_type);
<a name="l00193"></a>00193   MPI_Type_commit     (&amp;hilbert_type);
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 
<a name="l00196"></a>00196   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00197"></a>00197   <span class="comment">// (1) compute Hilbert keys</span>
<a name="l00198"></a>00198   std::vector&lt;Hilbert::HilbertIndices&gt;
<a name="l00199"></a>00199     node_keys, elem_keys;
<a name="l00200"></a>00200   
<a name="l00201"></a>00201   {
<a name="l00202"></a>00202     <span class="comment">// Nodes first</span>
<a name="l00203"></a>00203     {
<a name="l00204"></a>00204       <a class="code" href="classStoredRange.php">ConstNodeRange</a> nr (mesh.<a class="code" href="classMeshBase.php#a6485de7e7d67f36dec274f512d10fc15">local_nodes_begin</a>(),
<a name="l00205"></a>00205                          mesh.<a class="code" href="classMeshBase.php#ae23ced52382b7238f9182c8593f5cdd5">local_nodes_end</a>());
<a name="l00206"></a>00206       node_keys.resize (nr.size()); 
<a name="l00207"></a>00207       <a class="code" href="namespaceThreads.php#a9eb02a1b3f006c37843c907a3b5c0581">Threads::parallel_for</a> (nr, ComputeHilbertKeys (bbox, node_keys));
<a name="l00208"></a>00208     }
<a name="l00209"></a>00209     
<a name="l00210"></a>00210     <span class="comment">// Elements next</span>
<a name="l00211"></a>00211     {
<a name="l00212"></a>00212       <a class="code" href="classStoredRange.php">ConstElemRange</a> er (mesh.<a class="code" href="classMeshBase.php#a85cb016589044fbc17fd9d3ce138f1b6">local_elements_begin</a>(),
<a name="l00213"></a>00213                          mesh.<a class="code" href="classMeshBase.php#a8184d52812b82a9a38b66a0c89f04b17">local_elements_end</a>());
<a name="l00214"></a>00214       elem_keys.resize (er.size());
<a name="l00215"></a>00215       <a class="code" href="namespaceThreads.php#a9eb02a1b3f006c37843c907a3b5c0581">Threads::parallel_for</a> (er, ComputeHilbertKeys (bbox, elem_keys));
<a name="l00216"></a>00216     }    
<a name="l00217"></a>00217   } <span class="comment">// done computing Hilbert keys</span>
<a name="l00218"></a>00218 
<a name="l00219"></a>00219   
<a name="l00220"></a>00220  
<a name="l00221"></a>00221   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00222"></a>00222   <span class="comment">// (2) parallel sort the Hilbert keys</span>
<a name="l00223"></a>00223   <a class="code" href="classParallel_1_1Sort.php">Parallel::Sort&lt;Hilbert::HilbertIndices&gt;</a> node_sorter (node_keys);
<a name="l00224"></a>00224   node_sorter.<a class="code" href="classParallel_1_1Sort.php#a8235a11b7719d98b4c519eb08c79645b">sort</a>(); <span class="comment">/* done with node_keys */</span> <span class="comment">//node_keys.clear();</span>
<a name="l00225"></a>00225     
<a name="l00226"></a>00226   <span class="keyword">const</span> std::vector&lt;Hilbert::HilbertIndices&gt; &amp;my_node_bin = 
<a name="l00227"></a>00227     node_sorter.<a class="code" href="classParallel_1_1Sort.php#a1a0f9a671643c99647e04e01a69befe0">bin</a>();
<a name="l00228"></a>00228 
<a name="l00229"></a>00229   <a class="code" href="classParallel_1_1Sort.php">Parallel::Sort&lt;Hilbert::HilbertIndices&gt;</a> elem_sorter (elem_keys);
<a name="l00230"></a>00230   elem_sorter.<a class="code" href="classParallel_1_1Sort.php#a8235a11b7719d98b4c519eb08c79645b">sort</a>(); <span class="comment">/* done with elem_keys */</span> <span class="comment">//elem_keys.clear();</span>
<a name="l00231"></a>00231     
<a name="l00232"></a>00232   <span class="keyword">const</span> std::vector&lt;Hilbert::HilbertIndices&gt; &amp;my_elem_bin = 
<a name="l00233"></a>00233     elem_sorter.<a class="code" href="classParallel_1_1Sort.php#a1a0f9a671643c99647e04e01a69befe0">bin</a>();
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 
<a name="l00237"></a>00237   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00238"></a>00238   <span class="comment">// (3) get the max value on each processor</span>
<a name="l00239"></a>00239   std::vector&lt;Hilbert::HilbertIndices&gt;    
<a name="l00240"></a>00240     node_upper_bounds(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()),
<a name="l00241"></a>00241     elem_upper_bounds(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00242"></a>00242 
<a name="l00243"></a>00243   { <span class="comment">// limit scope of temporaries</span>
<a name="l00244"></a>00244     std::vector&lt;Hilbert::HilbertIndices&gt; recvbuf(2*<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00245"></a>00245     std::vector&lt;unsigned short int&gt; <span class="comment">/* do not use a vector of bools here since it is not always so! */</span>
<a name="l00246"></a>00246       empty_nodes (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()),
<a name="l00247"></a>00247       empty_elem  (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00248"></a>00248     Hilbert::HilbertIndices my_max[2];
<a name="l00249"></a>00249     
<a name="l00250"></a>00250     <a class="code" href="classMeshCommunication.php#a21c1490e797f0bce2a29880c078eb8f5">Parallel::allgather</a> (static_cast&lt;unsigned short int&gt;(my_node_bin.empty()), empty_nodes);
<a name="l00251"></a>00251     <a class="code" href="classMeshCommunication.php#a21c1490e797f0bce2a29880c078eb8f5">Parallel::allgather</a> (static_cast&lt;unsigned short int&gt;(my_elem_bin.empty()),  empty_elem);
<a name="l00252"></a>00252                
<a name="l00253"></a>00253     <span class="keywordflow">if</span> (!my_node_bin.empty()) my_max[0] = my_node_bin.back();
<a name="l00254"></a>00254     <span class="keywordflow">if</span> (!my_elem_bin.empty()) my_max[1] = my_elem_bin.back();
<a name="l00255"></a>00255 
<a name="l00256"></a>00256     MPI_Allgather (my_max,      2, hilbert_type,
<a name="l00257"></a>00257                    &amp;recvbuf[0], 2, hilbert_type,
<a name="l00258"></a>00258                    <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l00259"></a>00259 
<a name="l00260"></a>00260     <span class="comment">// Be cereful here.  The *_upper_bounds will be used to find the processor</span>
<a name="l00261"></a>00261     <span class="comment">// a given object belongs to.  So, if a processor contains no objects (possible!)</span>
<a name="l00262"></a>00262     <span class="comment">// then copy the bound from the lower processor id.</span>
<a name="l00263"></a>00263     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); p++)
<a name="l00264"></a>00264       {
<a name="l00265"></a>00265         node_upper_bounds[p] = recvbuf[2*p+0];
<a name="l00266"></a>00266         elem_upper_bounds[p] = recvbuf[2*p+1];
<a name="l00267"></a>00267 
<a name="l00268"></a>00268         <span class="keywordflow">if</span> (p &gt; 0) <span class="comment">// default hilbert index value is the OK upper bound for processor 0.</span>
<a name="l00269"></a>00269           {
<a name="l00270"></a>00270             <span class="keywordflow">if</span> (empty_nodes[p]) node_upper_bounds[p] = node_upper_bounds[p-1];
<a name="l00271"></a>00271             <span class="keywordflow">if</span> (empty_elem[p])  elem_upper_bounds[p] = elem_upper_bounds[p-1];
<a name="l00272"></a>00272           }
<a name="l00273"></a>00273       }
<a name="l00274"></a>00274   }
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 
<a name="l00278"></a>00278   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00279"></a>00279   <span class="comment">// (4) determine the position in the global ranking for</span>
<a name="l00280"></a>00280   <span class="comment">//     each local object</span>
<a name="l00281"></a>00281   {
<a name="l00282"></a>00282     <span class="comment">//----------------------------------------------</span>
<a name="l00283"></a>00283     <span class="comment">// Nodes first -- all nodes, not just local ones</span>
<a name="l00284"></a>00284     {
<a name="l00285"></a>00285       <span class="comment">// Request sets to send to each processor</span>
<a name="l00286"></a>00286       std::vector&lt;std::vector&lt;Hilbert::HilbertIndices&gt; &gt; 
<a name="l00287"></a>00287         requested_ids (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00288"></a>00288       <span class="comment">// Results to gather from each processor</span>
<a name="l00289"></a>00289       std::vector&lt;std::vector&lt;unsigned int&gt; &gt;
<a name="l00290"></a>00290         filled_request (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00291"></a>00291 
<a name="l00292"></a>00292       <a class="code" href="structMeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a>       it  = mesh.<a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
<a name="l00293"></a>00293       <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
<a name="l00294"></a>00294 
<a name="l00295"></a>00295       <span class="comment">// build up list of requests</span>
<a name="l00296"></a>00296       <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00297"></a>00297         {
<a name="l00298"></a>00298           <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node = (*it);
<a name="l00299"></a>00299           libmesh_assert (node != NULL);
<a name="l00300"></a>00300           <span class="keyword">const</span> Hilbert::HilbertIndices hi = 
<a name="l00301"></a>00301             get_hilbert_index (*node, bbox);
<a name="l00302"></a>00302           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid = 
<a name="l00303"></a>00303             std::distance (node_upper_bounds.begin(), 
<a name="l00304"></a>00304                            std::lower_bound(node_upper_bounds.begin(), 
<a name="l00305"></a>00305                                             node_upper_bounds.end(),
<a name="l00306"></a>00306                                             hi));
<a name="l00307"></a>00307 
<a name="l00308"></a>00308           libmesh_assert (pid &lt; <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00309"></a>00309 
<a name="l00310"></a>00310           requested_ids[pid].push_back(hi);
<a name="l00311"></a>00311         }
<a name="l00312"></a>00312 
<a name="l00313"></a>00313       <span class="comment">// The number of objects in my_node_bin on each processor</span>
<a name="l00314"></a>00314       std::vector&lt;unsigned int&gt; node_bin_sizes(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00315"></a>00315       <a class="code" href="classMeshCommunication.php#a21c1490e797f0bce2a29880c078eb8f5">Parallel::allgather</a> (static_cast&lt;unsigned int&gt;(my_node_bin.size()), node_bin_sizes);
<a name="l00316"></a>00316 
<a name="l00317"></a>00317       <span class="comment">// The offset of my first global index</span>
<a name="l00318"></a>00318       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_offset = 0;
<a name="l00319"></a>00319       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>(); pid++)
<a name="l00320"></a>00320         my_offset += node_bin_sizes[pid];
<a name="l00321"></a>00321 
<a name="l00322"></a>00322       <span class="comment">// start with pid=0, so that we will trade with ourself</span>
<a name="l00323"></a>00323       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00324"></a>00324         {
<a name="l00325"></a>00325           <span class="comment">// Trade my requests with processor procup and procdown</span>
<a name="l00326"></a>00326           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procup = (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() + pid) %
<a name="l00327"></a>00327                                        libMesh::n_processors();
<a name="l00328"></a>00328           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procdown = (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() +
<a name="l00329"></a>00329                                          <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() - pid) %
<a name="l00330"></a>00330                                          libMesh::n_processors();
<a name="l00331"></a>00331 
<a name="l00332"></a>00332           std::vector&lt;Hilbert::HilbertIndices&gt; request_to_fill;
<a name="l00333"></a>00333           Parallel::send_receive(procup, requested_ids[procup],
<a name="l00334"></a>00334                                  procdown, request_to_fill,
<a name="l00335"></a>00335                                  hilbert_type);   
<a name="l00336"></a>00336 
<a name="l00337"></a>00337           <span class="comment">// Fill the requests</span>
<a name="l00338"></a>00338           std::vector&lt;unsigned int&gt; global_ids;  global_ids.reserve(request_to_fill.size());
<a name="l00339"></a>00339           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>=0; <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>&lt;request_to_fill.size(); <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>++)
<a name="l00340"></a>00340             {
<a name="l00341"></a>00341               <span class="keyword">const</span> Hilbert::HilbertIndices &amp;hi = request_to_fill[<a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>];
<a name="l00342"></a>00342               libmesh_assert (hi &lt;= node_upper_bounds[libMesh::processor_id()]);
<a name="l00343"></a>00343               
<a name="l00344"></a>00344               <span class="comment">// find the requested index in my node bin</span>
<a name="l00345"></a>00345               std::vector&lt;Hilbert::HilbertIndices&gt;::const_iterator pos =
<a name="l00346"></a>00346                  std::lower_bound (my_node_bin.begin(), my_node_bin.end(), hi);
<a name="l00347"></a>00347               libmesh_assert (pos != my_node_bin.end());
<a name="l00348"></a>00348               libmesh_assert (*pos == hi);
<a name="l00349"></a>00349               
<a name="l00350"></a>00350               <span class="comment">// Finally, assign the global index based off the position of the index</span>
<a name="l00351"></a>00351               <span class="comment">// in my array, properly offset.</span>
<a name="l00352"></a>00352               global_ids.push_back (std::distance(my_node_bin.begin(), pos) + my_offset);
<a name="l00353"></a>00353             }
<a name="l00354"></a>00354 
<a name="l00355"></a>00355           <span class="comment">// and trade back</span>
<a name="l00356"></a>00356           Parallel::send_receive (procdown, global_ids,
<a name="l00357"></a>00357                                   procup,   filled_request[procup]);
<a name="l00358"></a>00358         }
<a name="l00359"></a>00359 
<a name="l00360"></a>00360       <span class="comment">// We now have all the filled requests, so we can loop through our</span>
<a name="l00361"></a>00361       <span class="comment">// nodes once and assign the global index to each one.</span>
<a name="l00362"></a>00362       {
<a name="l00363"></a>00363         std::vector&lt;std::vector&lt;unsigned int&gt;::const_iterator&gt;
<a name="l00364"></a>00364           next_obj_on_proc; next_obj_on_proc.reserve(libMesh::n_processors());
<a name="l00365"></a>00365         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00366"></a>00366           next_obj_on_proc.push_back(filled_request[pid].begin());
<a name="l00367"></a>00367 
<a name="l00368"></a>00368         <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>       it  = mesh.<a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
<a name="l00369"></a>00369         <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
<a name="l00370"></a>00370 
<a name="l00371"></a>00371         <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00372"></a>00372           {
<a name="l00373"></a>00373             <a class="code" href="classNode.php">Node</a>* node = (*it);
<a name="l00374"></a>00374             libmesh_assert (node != NULL);
<a name="l00375"></a>00375             <span class="keyword">const</span> Hilbert::HilbertIndices hi = 
<a name="l00376"></a>00376               get_hilbert_index (*node, bbox);
<a name="l00377"></a>00377             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid = 
<a name="l00378"></a>00378               std::distance (node_upper_bounds.begin(), 
<a name="l00379"></a>00379                              std::lower_bound(node_upper_bounds.begin(), 
<a name="l00380"></a>00380                                               node_upper_bounds.end(),
<a name="l00381"></a>00381                                               hi));
<a name="l00382"></a>00382 
<a name="l00383"></a>00383             libmesh_assert (pid &lt; libMesh::n_processors());
<a name="l00384"></a>00384             libmesh_assert (next_obj_on_proc[pid] != filled_request[pid].end());
<a name="l00385"></a>00385 
<a name="l00386"></a>00386             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_index = *next_obj_on_proc[pid];
<a name="l00387"></a>00387             libmesh_assert (global_index &lt; mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l00388"></a>00388             node-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a>() = global_index;
<a name="l00389"></a>00389             
<a name="l00390"></a>00390             ++next_obj_on_proc[pid];
<a name="l00391"></a>00391           }
<a name="l00392"></a>00392       }
<a name="l00393"></a>00393     }
<a name="l00394"></a>00394 
<a name="l00395"></a>00395     <span class="comment">//---------------------------------------------------</span>
<a name="l00396"></a>00396     <span class="comment">// elements next -- all elements, not just local ones</span>
<a name="l00397"></a>00397     {
<a name="l00398"></a>00398       <span class="comment">// Request sets to send to each processor</span>
<a name="l00399"></a>00399       std::vector&lt;std::vector&lt;Hilbert::HilbertIndices&gt; &gt; 
<a name="l00400"></a>00400         requested_ids (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00401"></a>00401       <span class="comment">// Results to gather from each processor</span>
<a name="l00402"></a>00402       std::vector&lt;std::vector&lt;unsigned int&gt; &gt;
<a name="l00403"></a>00403         filled_request (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00404"></a>00404       
<a name="l00405"></a>00405       <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00406"></a>00406       <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00407"></a>00407 
<a name="l00408"></a>00408       <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00409"></a>00409         {
<a name="l00410"></a>00410           <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = (*it);
<a name="l00411"></a>00411           libmesh_assert (elem != NULL);
<a name="l00412"></a>00412           <span class="keyword">const</span> Hilbert::HilbertIndices hi = 
<a name="l00413"></a>00413             get_hilbert_index (elem-&gt;<a class="code" href="classElem.php#a46ce080150f08ce9d367b69f16dd0452">centroid</a>(), bbox);
<a name="l00414"></a>00414           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid = 
<a name="l00415"></a>00415             std::distance (elem_upper_bounds.begin(), 
<a name="l00416"></a>00416                            std::lower_bound(elem_upper_bounds.begin(), 
<a name="l00417"></a>00417                                             elem_upper_bounds.end(),
<a name="l00418"></a>00418                                             hi));
<a name="l00419"></a>00419 
<a name="l00420"></a>00420           libmesh_assert (pid &lt; <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00421"></a>00421 
<a name="l00422"></a>00422           requested_ids[pid].push_back(hi);
<a name="l00423"></a>00423         }
<a name="l00424"></a>00424 
<a name="l00425"></a>00425       <span class="comment">// The number of objects in my_elem_bin on each processor</span>
<a name="l00426"></a>00426       std::vector&lt;unsigned int&gt; elem_bin_sizes(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00427"></a>00427       <a class="code" href="classMeshCommunication.php#a21c1490e797f0bce2a29880c078eb8f5">Parallel::allgather</a> (static_cast&lt;unsigned int&gt;(my_elem_bin.size()), elem_bin_sizes);
<a name="l00428"></a>00428 
<a name="l00429"></a>00429       <span class="comment">// The offset of my first global index</span>
<a name="l00430"></a>00430       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_offset = 0;
<a name="l00431"></a>00431       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>(); pid++)
<a name="l00432"></a>00432         my_offset += elem_bin_sizes[pid];
<a name="l00433"></a>00433 
<a name="l00434"></a>00434       <span class="comment">// start with pid=0, so that we will trade with ourself</span>
<a name="l00435"></a>00435       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00436"></a>00436         {
<a name="l00437"></a>00437           <span class="comment">// Trade my requests with processor procup and procdown</span>
<a name="l00438"></a>00438           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procup = (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() + pid) %
<a name="l00439"></a>00439                                        libMesh::n_processors();
<a name="l00440"></a>00440           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procdown = (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() +
<a name="l00441"></a>00441                                          <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() - pid) %
<a name="l00442"></a>00442                                          libMesh::n_processors();
<a name="l00443"></a>00443 
<a name="l00444"></a>00444           std::vector&lt;Hilbert::HilbertIndices&gt; request_to_fill;
<a name="l00445"></a>00445           Parallel::send_receive(procup, requested_ids[procup],
<a name="l00446"></a>00446                                  procdown, request_to_fill,
<a name="l00447"></a>00447                                  hilbert_type);   
<a name="l00448"></a>00448 
<a name="l00449"></a>00449           <span class="comment">// Fill the requests</span>
<a name="l00450"></a>00450           std::vector&lt;unsigned int&gt; global_ids;  global_ids.reserve(request_to_fill.size());
<a name="l00451"></a>00451           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>=0; <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>&lt;request_to_fill.size(); <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>++)
<a name="l00452"></a>00452             {
<a name="l00453"></a>00453               <span class="keyword">const</span> Hilbert::HilbertIndices &amp;hi = request_to_fill[<a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>];
<a name="l00454"></a>00454               libmesh_assert (hi &lt;= elem_upper_bounds[libMesh::processor_id()]);
<a name="l00455"></a>00455               
<a name="l00456"></a>00456               <span class="comment">// find the requested index in my elem bin</span>
<a name="l00457"></a>00457               std::vector&lt;Hilbert::HilbertIndices&gt;::const_iterator pos =
<a name="l00458"></a>00458                 std::lower_bound (my_elem_bin.begin(), my_elem_bin.end(), hi);
<a name="l00459"></a>00459               libmesh_assert (pos != my_elem_bin.end());
<a name="l00460"></a>00460               libmesh_assert (*pos == hi);
<a name="l00461"></a>00461               
<a name="l00462"></a>00462               <span class="comment">// Finally, assign the global index based off the position of the index</span>
<a name="l00463"></a>00463               <span class="comment">// in my array, properly offset.</span>
<a name="l00464"></a>00464               global_ids.push_back (std::distance(my_elem_bin.begin(), pos) + my_offset);
<a name="l00465"></a>00465             }
<a name="l00466"></a>00466 
<a name="l00467"></a>00467           <span class="comment">// and trade back</span>
<a name="l00468"></a>00468           Parallel::send_receive (procdown, global_ids,
<a name="l00469"></a>00469                                   procup,   filled_request[procup]);
<a name="l00470"></a>00470         }
<a name="l00471"></a>00471 
<a name="l00472"></a>00472       <span class="comment">// We now have all the filled requests, so we can loop through our</span>
<a name="l00473"></a>00473       <span class="comment">// elements once and assign the global index to each one.</span>
<a name="l00474"></a>00474       {
<a name="l00475"></a>00475         std::vector&lt;std::vector&lt;unsigned int&gt;::const_iterator&gt;
<a name="l00476"></a>00476           next_obj_on_proc; next_obj_on_proc.reserve(libMesh::n_processors());
<a name="l00477"></a>00477         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00478"></a>00478           next_obj_on_proc.push_back(filled_request[pid].begin());
<a name="l00479"></a>00479 
<a name="l00480"></a>00480         <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       it  = mesh.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00481"></a>00481         <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00482"></a>00482 
<a name="l00483"></a>00483         <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00484"></a>00484           {
<a name="l00485"></a>00485             <a class="code" href="classElem.php">Elem</a>* elem = (*it);
<a name="l00486"></a>00486             libmesh_assert (elem != NULL);
<a name="l00487"></a>00487             <span class="keyword">const</span> Hilbert::HilbertIndices hi = 
<a name="l00488"></a>00488               get_hilbert_index (elem-&gt;<a class="code" href="classElem.php#a46ce080150f08ce9d367b69f16dd0452">centroid</a>(), bbox);
<a name="l00489"></a>00489             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid = 
<a name="l00490"></a>00490               std::distance (elem_upper_bounds.begin(), 
<a name="l00491"></a>00491                              std::lower_bound(elem_upper_bounds.begin(), 
<a name="l00492"></a>00492                                               elem_upper_bounds.end(),
<a name="l00493"></a>00493                                               hi));
<a name="l00494"></a>00494 
<a name="l00495"></a>00495             libmesh_assert (pid &lt; libMesh::n_processors());
<a name="l00496"></a>00496             libmesh_assert (next_obj_on_proc[pid] != filled_request[pid].end());
<a name="l00497"></a>00497 
<a name="l00498"></a>00498             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_index = *next_obj_on_proc[pid];
<a name="l00499"></a>00499             libmesh_assert (global_index &lt; mesh.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>());
<a name="l00500"></a>00500             elem-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a>() = global_index;
<a name="l00501"></a>00501             
<a name="l00502"></a>00502             ++next_obj_on_proc[pid];
<a name="l00503"></a>00503           }
<a name="l00504"></a>00504       }
<a name="l00505"></a>00505     }        
<a name="l00506"></a>00506   }
<a name="l00507"></a>00507 
<a name="l00508"></a>00508 
<a name="l00509"></a>00509   <span class="comment">// Clean up</span>
<a name="l00510"></a>00510   MPI_Type_free (&amp;hilbert_type);
<a name="l00511"></a>00511 
<a name="l00512"></a>00512   STOP_LOG (<span class="stringliteral">&quot;assign_global_indices()&quot;</span>, <span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l00513"></a>00513 }
<a name="l00514"></a>00514 <span class="preprocessor">#else // LIBMESH_HAVE_LIBHILBERT, LIBMESH_HAVE_MPI</span>
<a name="l00515"></a>00515 <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#aa1ac865b823fff87470b2f2fcc68a00b">MeshCommunication::assign_global_indices</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp;)<span class="keyword"> const</span>
<a name="l00516"></a>00516 <span class="keyword"></span>{
<a name="l00517"></a>00517 }
<a name="l00518"></a>00518 <span class="preprocessor">#endif // LIBMESH_HAVE_LIBHILBERT, LIBMESH_HAVE_MPI</span>
<a name="l00519"></a>00519 <span class="preprocessor"></span>
<a name="l00520"></a>00520 
<a name="l00521"></a>00521 
<a name="l00522"></a>00522 <span class="preprocessor">#if defined(LIBMESH_HAVE_LIBHILBERT) &amp;&amp; defined(LIBMESH_HAVE_MPI)</span>
<a name="l00523"></a>00523 <span class="preprocessor"></span><span class="keyword">template</span> &lt;<span class="keyword">typename</span> ForwardIterator&gt;
<a name="l00524"></a><a class="code" href="classMeshCommunication.php#ad39ffc569ad59944067e273a77a06abd">00524</a> <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#ad39ffc569ad59944067e273a77a06abd">MeshCommunication::find_global_indices</a> (<span class="keyword">const</span> <a class="code" href="classMeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a> &amp;bbox,
<a name="l00525"></a>00525                                              <span class="keyword">const</span> ForwardIterator &amp;begin,
<a name="l00526"></a>00526                                              <span class="keyword">const</span> ForwardIterator &amp;end,
<a name="l00527"></a>00527                                              std::vector&lt;unsigned int&gt; &amp;index_map)<span class="keyword"> const</span>
<a name="l00528"></a>00528 <span class="keyword"></span>{
<a name="l00529"></a>00529   START_LOG (<span class="stringliteral">&quot;find_global_indices()&quot;</span>, <span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l00530"></a>00530 
<a name="l00531"></a>00531   <span class="comment">// This method determines partition-agnostic global indices</span>
<a name="l00532"></a>00532   <span class="comment">// for nodes and elements.</span>
<a name="l00533"></a>00533 
<a name="l00534"></a>00534   <span class="comment">// Algorithm:</span>
<a name="l00535"></a>00535   <span class="comment">// (1) compute the Hilbert key for each local node/element</span>
<a name="l00536"></a>00536   <span class="comment">// (2) perform a parallel sort of the Hilbert key</span>
<a name="l00537"></a>00537   <span class="comment">// (3) get the min/max value on each processor</span>
<a name="l00538"></a>00538   <span class="comment">// (4) determine the position in the global ranking for</span>
<a name="l00539"></a>00539   <span class="comment">//     each local object</span>
<a name="l00540"></a>00540   index_map.clear();
<a name="l00541"></a>00541   index_map.reserve(std::distance (begin, end));
<a name="l00542"></a>00542 
<a name="l00543"></a>00543   <span class="comment">// Set up a derived MPI datatype to handle communication of HilbertIndices</span>
<a name="l00544"></a>00544   MPI_Datatype hilbert_type;
<a name="l00545"></a>00545   MPI_Type_contiguous (3, MPI_UNSIGNED, &amp;hilbert_type);
<a name="l00546"></a>00546   MPI_Type_commit     (&amp;hilbert_type);
<a name="l00547"></a>00547 
<a name="l00548"></a>00548 
<a name="l00549"></a>00549   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00550"></a>00550   <span class="comment">// (1) compute Hilbert keys</span>
<a name="l00551"></a>00551   <span class="comment">// These aren&#39;t trivial to compute, and we will need them again.</span>
<a name="l00552"></a>00552   <span class="comment">// But the binsort will sort the input vector, trashing the order</span>
<a name="l00553"></a>00553   <span class="comment">// that we&#39;d like to rely on.  So, two vectors...</span>
<a name="l00554"></a>00554   std::vector&lt;Hilbert::HilbertIndices&gt; 
<a name="l00555"></a>00555     sorted_hilbert_keys,
<a name="l00556"></a>00556     hilbert_keys;
<a name="l00557"></a>00557   sorted_hilbert_keys.reserve(index_map.capacity());
<a name="l00558"></a>00558   hilbert_keys.reserve(index_map.capacity());
<a name="l00559"></a>00559   {
<a name="l00560"></a>00560     START_LOG(<span class="stringliteral">&quot;compute_hilbert_indices()&quot;</span>, <span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l00561"></a>00561     <span class="keywordflow">for</span> (ForwardIterator it=begin; it!=end; ++it)
<a name="l00562"></a>00562       {
<a name="l00563"></a>00563         <span class="keyword">const</span> Hilbert::HilbertIndices hi(get_hilbert_index (*it, bbox));
<a name="l00564"></a>00564         hilbert_keys.push_back(hi);
<a name="l00565"></a>00565         
<a name="l00566"></a>00566         <span class="keywordflow">if</span> ((*it)-&gt;processor_id() == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00567"></a>00567           sorted_hilbert_keys.push_back(hi);
<a name="l00568"></a>00568 
<a name="l00569"></a>00569         <span class="comment">// someone needs to take care of unpartitioned objects!</span>
<a name="l00570"></a>00570         <span class="keywordflow">if</span> ((<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0) &amp;&amp;
<a name="l00571"></a>00571             ((*it)-&gt;processor_id() == <a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>))
<a name="l00572"></a>00572           sorted_hilbert_keys.push_back(hi);
<a name="l00573"></a>00573       }    
<a name="l00574"></a>00574     STOP_LOG(<span class="stringliteral">&quot;compute_hilbert_indices()&quot;</span>, <span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l00575"></a>00575   }
<a name="l00576"></a>00576   
<a name="l00577"></a>00577   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00578"></a>00578   <span class="comment">// (2) parallel sort the Hilbert keys</span>
<a name="l00579"></a>00579   START_LOG (<span class="stringliteral">&quot;parallel_sort()&quot;</span>, <span class="stringliteral">&quot;MeshCommunication&quot;</span>);  
<a name="l00580"></a>00580   <a class="code" href="classParallel_1_1Sort.php">Parallel::Sort&lt;Hilbert::HilbertIndices&gt;</a> sorter (sorted_hilbert_keys);
<a name="l00581"></a>00581   sorter.<a class="code" href="classParallel_1_1Sort.php#a8235a11b7719d98b4c519eb08c79645b">sort</a>(); 
<a name="l00582"></a>00582   STOP_LOG (<span class="stringliteral">&quot;parallel_sort()&quot;</span>, <span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l00583"></a>00583   <span class="keyword">const</span> std::vector&lt;Hilbert::HilbertIndices&gt; &amp;my_bin = sorter.<a class="code" href="classParallel_1_1Sort.php#a1a0f9a671643c99647e04e01a69befe0">bin</a>();
<a name="l00584"></a>00584 
<a name="l00585"></a>00585   <span class="comment">// The number of objects in my_bin on each processor</span>
<a name="l00586"></a>00586   std::vector&lt;unsigned int&gt; bin_sizes(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00587"></a>00587   <a class="code" href="classMeshCommunication.php#a21c1490e797f0bce2a29880c078eb8f5">Parallel::allgather</a> (static_cast&lt;unsigned int&gt;(my_bin.size()), bin_sizes);
<a name="l00588"></a>00588     
<a name="l00589"></a>00589   <span class="comment">// The offset of my first global index</span>
<a name="l00590"></a>00590   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_offset = 0;
<a name="l00591"></a>00591   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>(); pid++)
<a name="l00592"></a>00592     my_offset += bin_sizes[pid];
<a name="l00593"></a>00593   
<a name="l00594"></a>00594   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00595"></a>00595   <span class="comment">// (3) get the max value on each processor</span>
<a name="l00596"></a>00596   std::vector&lt;Hilbert::HilbertIndices&gt;    
<a name="l00597"></a>00597     upper_bounds(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00598"></a>00598     
<a name="l00599"></a>00599   <span class="comment">// limit scope of temporaries</span>
<a name="l00600"></a>00600   {
<a name="l00601"></a>00601     Hilbert::HilbertIndices my_max;
<a name="l00602"></a>00602     
<a name="l00603"></a>00603     <span class="keywordflow">if</span> (!my_bin.empty()) my_max = my_bin.back();
<a name="l00604"></a>00604     
<a name="l00605"></a>00605     MPI_Allgather (&amp;my_max,          1, hilbert_type,
<a name="l00606"></a>00606                    &amp;upper_bounds[0], 1, hilbert_type,
<a name="l00607"></a>00607                    <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l00608"></a>00608 
<a name="l00609"></a>00609     <span class="comment">// Be cereful here.  The *_upper_bounds will be used to find the processor</span>
<a name="l00610"></a>00610     <span class="comment">// a given object belongs to.  So, if a processor contains no objects (possible!)</span>
<a name="l00611"></a>00611     <span class="comment">// then copy the bound from the lower processor id.</span>
<a name="l00612"></a>00612     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); p++)
<a name="l00613"></a>00613       <span class="keywordflow">if</span> (!bin_sizes[p]) upper_bounds[p] = upper_bounds[p-1];
<a name="l00614"></a>00614   }
<a name="l00615"></a>00615 
<a name="l00616"></a>00616 
<a name="l00617"></a>00617   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00618"></a>00618   <span class="comment">// (4) determine the position in the global ranking for</span>
<a name="l00619"></a>00619   <span class="comment">//     each local object</span>
<a name="l00620"></a>00620   {
<a name="l00621"></a>00621     <span class="comment">//----------------------------------------------</span>
<a name="l00622"></a>00622     <span class="comment">// all objects, not just local ones</span>
<a name="l00623"></a>00623     
<a name="l00624"></a>00624     <span class="comment">// Request sets to send to each processor</span>
<a name="l00625"></a>00625     std::vector&lt;std::vector&lt;Hilbert::HilbertIndices&gt; &gt; 
<a name="l00626"></a>00626       requested_ids (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00627"></a>00627     <span class="comment">// Results to gather from each processor</span>
<a name="l00628"></a>00628     std::vector&lt;std::vector&lt;unsigned int&gt; &gt;
<a name="l00629"></a>00629       filled_request (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00630"></a>00630 
<a name="l00631"></a>00631     <span class="comment">// build up list of requests</span>
<a name="l00632"></a>00632     std::vector&lt;Hilbert::HilbertIndices&gt;::const_iterator hi = 
<a name="l00633"></a>00633       hilbert_keys.begin();
<a name="l00634"></a>00634 
<a name="l00635"></a>00635     <span class="keywordflow">for</span> (ForwardIterator it = begin; it != end; ++it)
<a name="l00636"></a>00636       {
<a name="l00637"></a>00637         libmesh_assert (hi != hilbert_keys.end());
<a name="l00638"></a>00638         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid = 
<a name="l00639"></a>00639           std::distance (upper_bounds.begin(), 
<a name="l00640"></a>00640                          std::lower_bound(upper_bounds.begin(), 
<a name="l00641"></a>00641                                           upper_bounds.end(),
<a name="l00642"></a>00642                                           *hi));
<a name="l00643"></a>00643 
<a name="l00644"></a>00644         libmesh_assert (pid &lt; <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00645"></a>00645 
<a name="l00646"></a>00646         requested_ids[pid].push_back(*hi);
<a name="l00647"></a>00647 
<a name="l00648"></a>00648         hi++;
<a name="l00649"></a>00649         <span class="comment">// go ahead and put pid in index_map, that way we </span>
<a name="l00650"></a>00650         <span class="comment">// don&#39;t have to repeat the std::lower_bound()</span>
<a name="l00651"></a>00651         index_map.push_back(pid);
<a name="l00652"></a>00652       }
<a name="l00653"></a>00653 
<a name="l00654"></a>00654     <span class="comment">// start with pid=0, so that we will trade with ourself</span>
<a name="l00655"></a>00655     std::vector&lt;Hilbert::HilbertIndices&gt; request_to_fill;
<a name="l00656"></a>00656     std::vector&lt;unsigned int&gt; global_ids;
<a name="l00657"></a>00657     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00658"></a>00658       {
<a name="l00659"></a>00659         <span class="comment">// Trade my requests with processor procup and procdown</span>
<a name="l00660"></a>00660         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procup = (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() + pid) %
<a name="l00661"></a>00661                                      libMesh::n_processors();
<a name="l00662"></a>00662         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procdown = (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() +
<a name="l00663"></a>00663                                        <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() - pid) %
<a name="l00664"></a>00664                                        libMesh::n_processors();
<a name="l00665"></a>00665 
<a name="l00666"></a>00666         Parallel::send_receive(procup, requested_ids[procup],
<a name="l00667"></a>00667                                procdown, request_to_fill,
<a name="l00668"></a>00668                                hilbert_type);     
<a name="l00669"></a>00669 
<a name="l00670"></a>00670         <span class="comment">// Fill the requests</span>
<a name="l00671"></a>00671         global_ids.clear();  global_ids.reserve(request_to_fill.size());
<a name="l00672"></a>00672         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>=0; <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>&lt;request_to_fill.size(); <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>++)
<a name="l00673"></a>00673           {
<a name="l00674"></a>00674             <span class="keyword">const</span> Hilbert::HilbertIndices &amp;hi = request_to_fill[<a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>];
<a name="l00675"></a>00675             libmesh_assert (hi &lt;= upper_bounds[libMesh::processor_id()]);
<a name="l00676"></a>00676             
<a name="l00677"></a>00677             <span class="comment">// find the requested index in my node bin</span>
<a name="l00678"></a>00678             std::vector&lt;Hilbert::HilbertIndices&gt;::const_iterator pos =
<a name="l00679"></a>00679               std::lower_bound (my_bin.begin(), my_bin.end(), hi);
<a name="l00680"></a>00680             libmesh_assert (pos != my_bin.end());
<a name="l00681"></a>00681             libmesh_assert (*pos == hi);
<a name="l00682"></a>00682             
<a name="l00683"></a>00683             <span class="comment">// Finally, assign the global index based off the position of the index</span>
<a name="l00684"></a>00684             <span class="comment">// in my array, properly offset.</span>
<a name="l00685"></a>00685             global_ids.push_back (std::distance(my_bin.begin(), pos) + my_offset);
<a name="l00686"></a>00686           }
<a name="l00687"></a>00687         
<a name="l00688"></a>00688         <span class="comment">// and trade back</span>
<a name="l00689"></a>00689         Parallel::send_receive (procdown, global_ids,
<a name="l00690"></a>00690                                 procup,   filled_request[procup]);
<a name="l00691"></a>00691       }
<a name="l00692"></a>00692 
<a name="l00693"></a>00693     <span class="comment">// We now have all the filled requests, so we can loop through our</span>
<a name="l00694"></a>00694     <span class="comment">// nodes once and assign the global index to each one.</span>
<a name="l00695"></a>00695     {
<a name="l00696"></a>00696       std::vector&lt;std::vector&lt;unsigned int&gt;::const_iterator&gt;
<a name="l00697"></a>00697         next_obj_on_proc; next_obj_on_proc.reserve(libMesh::n_processors());
<a name="l00698"></a>00698       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00699"></a>00699         next_obj_on_proc.push_back(filled_request[pid].begin());
<a name="l00700"></a>00700       
<a name="l00701"></a>00701       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l00702"></a>00702       <span class="keywordflow">for</span> (ForwardIterator it = begin; it != end; ++it, cnt++)
<a name="l00703"></a>00703         {
<a name="l00704"></a>00704           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid = index_map[cnt];
<a name="l00705"></a>00705           
<a name="l00706"></a>00706           libmesh_assert (pid &lt; libMesh::n_processors());
<a name="l00707"></a>00707           libmesh_assert (next_obj_on_proc[pid] != filled_request[pid].end());
<a name="l00708"></a>00708           
<a name="l00709"></a>00709           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_index = *next_obj_on_proc[pid];
<a name="l00710"></a>00710           index_map[cnt] = global_index;
<a name="l00711"></a>00711 
<a name="l00712"></a>00712           ++next_obj_on_proc[pid];
<a name="l00713"></a>00713         }
<a name="l00714"></a>00714     }
<a name="l00715"></a>00715   }
<a name="l00716"></a>00716 
<a name="l00717"></a>00717 
<a name="l00718"></a>00718   <span class="comment">// Clean up</span>
<a name="l00719"></a>00719   MPI_Type_free (&amp;hilbert_type);
<a name="l00720"></a>00720 
<a name="l00721"></a>00721   STOP_LOG (<span class="stringliteral">&quot;find_global_indices()&quot;</span>, <span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l00722"></a>00722 }
<a name="l00723"></a>00723 <span class="preprocessor">#else // LIBMESH_HAVE_LIBHILBERT, LIBMESH_HAVE_MPI</span>
<a name="l00724"></a>00724 <span class="preprocessor"></span><span class="keyword">template</span> &lt;<span class="keyword">typename</span> ForwardIterator&gt;
<a name="l00725"></a>00725 <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#ad39ffc569ad59944067e273a77a06abd">MeshCommunication::find_global_indices</a> (<span class="keyword">const</span> <a class="code" href="classMeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a> &amp;,
<a name="l00726"></a>00726                                              <span class="keyword">const</span> ForwardIterator &amp;,
<a name="l00727"></a>00727                                              <span class="keyword">const</span> ForwardIterator &amp;,
<a name="l00728"></a>00728                                              std::vector&lt;unsigned int&gt; &amp;)<span class="keyword"> const</span>
<a name="l00729"></a>00729 <span class="keyword"></span>{
<a name="l00730"></a>00730 }
<a name="l00731"></a>00731 <span class="preprocessor">#endif // LIBMESH_HAVE_LIBHILBERT, LIBMESH_HAVE_MPI</span>
<a name="l00732"></a>00732 <span class="preprocessor"></span>
<a name="l00733"></a>00733 
<a name="l00734"></a>00734 
<a name="l00735"></a>00735 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00736"></a>00736 <span class="keyword">template</span> <span class="keywordtype">void</span> MeshCommunication::find_global_indices&lt;MeshBase::const_node_iterator&gt; (<span class="keyword">const</span> <a class="code" href="classMeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a> &amp;,
<a name="l00737"></a>00737                                                                                      <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> &amp;,
<a name="l00738"></a>00738                                                                                      <span class="keyword">const</span> MeshBase::const_node_iterator &amp;,
<a name="l00739"></a>00739                                                                                      std::vector&lt;unsigned int&gt; &amp;) <span class="keyword">const</span>;
<a name="l00740"></a>00740 
<a name="l00741"></a>00741 <span class="keyword">template</span> <span class="keywordtype">void</span> MeshCommunication::find_global_indices&lt;MeshBase::const_element_iterator&gt; (<span class="keyword">const</span> MeshTools::BoundingBox &amp;,
<a name="l00742"></a>00742                                                                                         <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> &amp;,
<a name="l00743"></a>00743                                                                                         <span class="keyword">const</span> MeshBase::const_element_iterator &amp;,
<a name="l00744"></a>00744                                                                                         std::vector&lt;unsigned int&gt; &amp;) <span class="keyword">const</span>;
<a name="l00745"></a>00745 <span class="keyword">template</span> <span class="keywordtype">void</span> MeshCommunication::find_global_indices&lt;MeshBase::node_iterator&gt; (<span class="keyword">const</span> MeshTools::BoundingBox &amp;,
<a name="l00746"></a>00746                                                                                      <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> &amp;,
<a name="l00747"></a>00747                                                                                      <span class="keyword">const</span> MeshBase::node_iterator &amp;,
<a name="l00748"></a>00748                                                                                      std::vector&lt;unsigned int&gt; &amp;) <span class="keyword">const</span>;
<a name="l00749"></a>00749 
<a name="l00750"></a>00750 <span class="keyword">template</span> <span class="keywordtype">void</span> MeshCommunication::find_global_indices&lt;MeshBase::element_iterator&gt; (<span class="keyword">const</span> MeshTools::BoundingBox &amp;,
<a name="l00751"></a>00751                                                                                         <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> &amp;,
<a name="l00752"></a>00752                                                                                         <span class="keyword">const</span> MeshBase::element_iterator &amp;,
<a name="l00753"></a>00753                                                                                         std::vector&lt;unsigned int&gt; &amp;) <span class="keyword">const</span>;
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
