<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_data.h</h1>  </div>
</div>
<div class="contents">
<a href="mesh__data_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_data.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __mesh_data_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_data_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;libmesh.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;enum_xdr_mode.h&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward Declarations</span>
<a name="l00035"></a>00035 <span class="keyword">class </span><a class="code" href="classNode.php">Node</a>;
<a name="l00036"></a>00036 <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00037"></a>00037 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00038"></a>00038 <span class="keyword">class </span><a class="code" href="classMeshDataUnvHeader.php">MeshDataUnvHeader</a>;
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00054"></a>00054 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00055"></a>00055 <span class="comment">// MeshData class definition</span>
<a name="l00056"></a><a class="code" href="classMeshData.php">00056</a> <span class="keyword">class </span><a class="code" href="classMeshData.php">MeshData</a> 
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058 <span class="keyword">public</span>:
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 
<a name="l00061"></a>00061   <span class="comment">//----------------------------------------------------------</span>
<a name="l00062"></a>00062   <span class="comment">// convenient typedefs</span>
<a name="l00071"></a><a class="code" href="classMeshData.php#a6e0f60c1f2c5dcbe789de9d043d27d2a">00071</a> <span class="comment"></span>  <span class="keyword">typedef</span> std::map&lt;const Node*, std::vector&lt;Number&gt; &gt;::const_iterator <a class="code" href="classMeshData.php#a6e0f60c1f2c5dcbe789de9d043d27d2a">const_node_data_iterator</a>;
<a name="l00072"></a>00072 
<a name="l00081"></a><a class="code" href="classMeshData.php#a2b161d1fc88ec85b422184285fbd0c1e">00081</a>   <span class="keyword">typedef</span> std::map&lt;const Elem*, std::vector&lt;Number&gt; &gt;::const_iterator <a class="code" href="classMeshData.php#a2b161d1fc88ec85b422184285fbd0c1e">const_elem_data_iterator</a>;
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00084"></a>00084   <span class="comment">//----------------------------------------------------------</span>
<a name="l00089"></a>00089 <span class="comment"></span>  <a class="code" href="classMeshData.php#a86fa0ca148adfa6a4909688b790cf9f5">MeshData</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; m);
<a name="l00090"></a>00090 
<a name="l00094"></a>00094   <a class="code" href="classMeshData.php#a6f206f96b3c7ce1d33611fed471729cf">~MeshData</a> ();
<a name="l00095"></a>00095 
<a name="l00105"></a>00105   <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#a2cda94661ee53a20c0e2d0248aa90665">activate</a> (<span class="keyword">const</span> std::string&amp; descriptor=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00106"></a>00106 
<a name="l00119"></a>00119   <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#a39e9c138f115d45a44e7718f7efc79fc">enable_compatibility_mode</a> (<span class="keyword">const</span> std::string&amp; descriptor=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00120"></a>00120 
<a name="l00126"></a>00126   <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#a441899feec76257ac227a6786fe9aea9">clear</a> ();
<a name="l00127"></a>00127 
<a name="l00136"></a>00136   <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#a9b3a609890680c4651eedf17d0b3d10f">slim</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> node_id_map = <span class="keyword">true</span>,
<a name="l00137"></a>00137              <span class="keyword">const</span> <span class="keywordtype">bool</span> elem_id_map = <span class="keyword">true</span>);
<a name="l00138"></a>00138 
<a name="l00153"></a>00153   <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#abdcd1d076b7b9b892598a32455c480f8">translate</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; out_mesh,
<a name="l00154"></a>00154                   std::vector&lt;Number&gt;&amp; data_values,
<a name="l00155"></a>00155                   std::vector&lt;std::string&gt;&amp; data_names) <span class="keyword">const</span>;
<a name="l00156"></a>00156 
<a name="l00163"></a>00163   <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#a773e714608c5710eb9e60c2b631dabea">read</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>);
<a name="l00164"></a>00164 
<a name="l00169"></a>00169   <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#a897b5e6eb818824856c1376bdc8d272d">write</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>);
<a name="l00170"></a>00170 
<a name="l00175"></a>00175   std::string <a class="code" href="classMeshData.php#af23cd14f5776cfa8b064c4ac0adf06b5">get_info</a> () <span class="keyword">const</span>;
<a name="l00176"></a>00176 
<a name="l00180"></a>00180   <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#ad5ff9492ec76a3ff3af620df1b6a60c0">print_info</a> (std::ostream&amp; os=std::cout) <span class="keyword">const</span>;
<a name="l00181"></a>00181 
<a name="l00185"></a>00185   <span class="keyword">friend</span> std::ostream&amp; <a class="code" href="classMeshData.php#a0e15bc21697bf830de2d316545795c93">operator &lt;&lt; </a>(std::ostream&amp; os, <span class="keyword">const</span> <a class="code" href="classMeshData.php">MeshData</a>&amp; m);
<a name="l00186"></a>00186   
<a name="l00187"></a>00187   
<a name="l00188"></a>00188   <span class="comment">//----------------------------------------------------------</span>
<a name="l00189"></a>00189   <span class="comment">// Node-associated data</span>
<a name="l00195"></a>00195 <span class="comment"></span>  <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classMeshData.php#a7be1ba17dbb8a3d1da387cab6a357431">operator() </a>(<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node, 
<a name="l00196"></a>00196                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0) <span class="keyword">const</span>;
<a name="l00197"></a>00197 
<a name="l00202"></a>00202   <span class="keywordtype">bool</span> <a class="code" href="classMeshData.php#a88fea2994fc1ac1295745fdb8bd685f5">has_data</a> (<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node) <span class="keyword">const</span>;
<a name="l00203"></a>00203 
<a name="l00210"></a>00210   <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; <a class="code" href="classMeshData.php#ab34864d2e1f83059bd781b0dd5f71fe0">get_data</a> (<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node) <span class="keyword">const</span>;
<a name="l00211"></a>00211 
<a name="l00216"></a>00216   <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#aa64f54d59daaf037ba5fe43393fa6bdf">set_data</a> (<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node, <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; val);
<a name="l00217"></a>00217 
<a name="l00225"></a>00225   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshData.php#ae472897b59f5f1d364d0bb34916951cb">n_val_per_node</a> () <span class="keyword">const</span>;
<a name="l00226"></a>00226 
<a name="l00231"></a>00231   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshData.php#a5b30c234c36f3dee4a588e015287b8b2">n_node_data</a> () <span class="keyword">const</span>;
<a name="l00232"></a>00232 
<a name="l00238"></a>00238   <a class="code" href="classMeshData.php#a6e0f60c1f2c5dcbe789de9d043d27d2a">const_node_data_iterator</a> <a class="code" href="classMeshData.php#ac5069e4367ae32f436cae3427ff74991">node_data_begin</a> () <span class="keyword">const</span>;
<a name="l00239"></a>00239 
<a name="l00244"></a>00244   <a class="code" href="classMeshData.php#a6e0f60c1f2c5dcbe789de9d043d27d2a">const_node_data_iterator</a> <a class="code" href="classMeshData.php#afe1300d29765163e82f44fd7eae418be">node_data_end</a> () <span class="keyword">const</span>;
<a name="l00245"></a>00245 
<a name="l00261"></a>00261   <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#add73751b3cd26d03428819433a26944e">insert_node_data</a> (std::map&lt;<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>*,
<a name="l00262"></a>00262                                   std::vector&lt;Number&gt; &gt;&amp; nd,
<a name="l00263"></a>00263                          <span class="keyword">const</span> <span class="keywordtype">bool</span> close_elem_data = <span class="keyword">true</span>);
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 
<a name="l00266"></a>00266   <span class="comment">//----------------------------------------------------------</span>
<a name="l00267"></a>00267   <span class="comment">// Element-associated data</span>
<a name="l00273"></a>00273 <span class="comment"></span>  <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classMeshData.php#a7be1ba17dbb8a3d1da387cab6a357431">operator() </a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem, 
<a name="l00274"></a>00274                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0) <span class="keyword">const</span>;
<a name="l00275"></a>00275 
<a name="l00280"></a>00280   <span class="keywordtype">bool</span> <a class="code" href="classMeshData.php#a88fea2994fc1ac1295745fdb8bd685f5">has_data</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem) <span class="keyword">const</span>;
<a name="l00281"></a>00281 
<a name="l00288"></a>00288   <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; <a class="code" href="classMeshData.php#ab34864d2e1f83059bd781b0dd5f71fe0">get_data</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem) <span class="keyword">const</span>;
<a name="l00289"></a>00289 
<a name="l00294"></a>00294   <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#aa64f54d59daaf037ba5fe43393fa6bdf">set_data</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem, <span class="keyword">const</span> std::vector&lt;Number&gt; &amp;val);
<a name="l00295"></a>00295 
<a name="l00303"></a>00303   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshData.php#afba7927583ec3ef220b4d921547e5f2c">n_val_per_elem</a> () <span class="keyword">const</span>;
<a name="l00304"></a>00304 
<a name="l00309"></a>00309   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshData.php#a696d093903ece066d1db71a0d933320b">n_elem_data</a> () <span class="keyword">const</span>;
<a name="l00310"></a>00310 
<a name="l00316"></a>00316   <a class="code" href="classMeshData.php#a2b161d1fc88ec85b422184285fbd0c1e">const_elem_data_iterator</a> <a class="code" href="classMeshData.php#add5e573ac3857a9bf8f3d1b517fad302">elem_data_begin</a> () <span class="keyword">const</span>;
<a name="l00317"></a>00317 
<a name="l00322"></a>00322   <a class="code" href="classMeshData.php#a2b161d1fc88ec85b422184285fbd0c1e">const_elem_data_iterator</a> <a class="code" href="classMeshData.php#a030e720d46f453933268af0e462119f8">elem_data_end</a> () <span class="keyword">const</span>;
<a name="l00323"></a>00323 
<a name="l00340"></a>00340   <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#a8e1e867ec3cb65690e6fc295cbbfe195">insert_elem_data</a> (std::map&lt;<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*,
<a name="l00341"></a>00341                                   std::vector&lt;Number&gt; &gt;&amp; ed,
<a name="l00342"></a>00342                          <span class="keyword">const</span> <span class="keywordtype">bool</span> close_node_data = <span class="keyword">true</span>);
<a name="l00343"></a>00343 
<a name="l00344"></a>00344 
<a name="l00345"></a>00345   <span class="comment">//----------------------------------------------------------</span>
<a name="l00350"></a>00350 <span class="comment"></span>  <span class="keywordtype">bool</span> <a class="code" href="classMeshData.php#a4d99efe5fb30d203afdd520d213c6233">active</a> () <span class="keyword">const</span>;
<a name="l00355"></a>00355   <span class="keywordtype">bool</span> <a class="code" href="classMeshData.php#af448a633cf06236e8ebcb5cf73d3d2eb">compatibility_mode</a> () <span class="keyword">const</span>;
<a name="l00356"></a>00356 
<a name="l00362"></a>00362   <span class="keywordtype">bool</span> <a class="code" href="classMeshData.php#a5d9abd12d8c9c4105c251770a95089f8">elem_initialized</a> () <span class="keyword">const</span>;
<a name="l00363"></a>00363 
<a name="l00368"></a>00368   <span class="keywordtype">bool</span> <a class="code" href="classMeshData.php#a2d11b9490e1aa16eff2424306f7da832">node_initialized</a> () <span class="keyword">const</span>;
<a name="l00369"></a>00369 
<a name="l00370"></a>00370 
<a name="l00371"></a>00371   <span class="comment">//----------------------------------------------------------</span>
<a name="l00372"></a>00372   <span class="comment">// Methods for accessing the node and element maps.</span>
<a name="l00373"></a>00373   <span class="comment">// Heavily used by the \p read() and \p write() methods.</span>
<a name="l00377"></a>00377 <span class="comment"></span>  <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classMeshData.php#a6cb6c156374dc82815b2f654eab9fdf7">foreign_id_to_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> fid) <span class="keyword">const</span>;
<a name="l00378"></a>00378 
<a name="l00382"></a>00382   <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classMeshData.php#ad2522dd96c172f01c2dad1728988a538">foreign_id_to_elem</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> fid) <span class="keyword">const</span>;
<a name="l00383"></a>00383 
<a name="l00387"></a>00387   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshData.php#a64280d5ec57b031bcba08f216af20973">node_to_foreign_id</a> (<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* n) <span class="keyword">const</span>;
<a name="l00388"></a>00388 
<a name="l00392"></a>00392   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshData.php#a42f4bc27f920ebacc677fe43613d81b5">elem_to_foreign_id</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* n) <span class="keyword">const</span>;
<a name="l00393"></a>00393 
<a name="l00394"></a>00394   <span class="comment">//----------------------------------------------------------</span>
<a name="l00395"></a>00395   <span class="comment">// Methods for the header information in universal formated</span>
<a name="l00396"></a>00396   <span class="comment">// datasets.</span>
<a name="l00397"></a>00397 
<a name="l00401"></a>00401   <span class="keyword">const</span> <a class="code" href="classMeshDataUnvHeader.php">MeshDataUnvHeader</a> &amp; <a class="code" href="classMeshData.php#a326094d0acd3979b1848efc8e7638fcc">get_unv_header</a>() <span class="keyword">const</span>;
<a name="l00402"></a>00402 
<a name="l00407"></a>00407   <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#a755e652166d7d01b530c49a575630a90">set_unv_header</a>(<a class="code" href="classMeshDataUnvHeader.php">MeshDataUnvHeader</a>* unv_header);
<a name="l00408"></a>00408 
<a name="l00409"></a>00409 
<a name="l00416"></a>00416   <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#aad19633f57c520c4f448045ebb8808df">assign</a> (<span class="keyword">const</span> <a class="code" href="classMeshData.php">MeshData</a>&amp; omd);
<a name="l00417"></a>00417 
<a name="l00418"></a>00418 
<a name="l00419"></a>00419   <span class="comment">//----------------------------------------------------------</span>
<a name="l00420"></a>00420   <span class="comment">// Methods used by mesh importes to communicate node/element</span>
<a name="l00421"></a>00421   <span class="comment">// labels to this \p MeshData</span>
<a name="l00422"></a>00422   
<a name="l00430"></a>00430   <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#af408db231805974db975dbdf3c1756f5">add_foreign_node_id</a> (<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node, 
<a name="l00431"></a>00431                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> foreign_node_id);
<a name="l00432"></a>00432 
<a name="l00440"></a>00440   <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#acf27873beae104e2109db6c93de7efa9">add_foreign_elem_id</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem, 
<a name="l00441"></a>00441                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> foreign_elem_id);
<a name="l00442"></a>00442 
<a name="l00447"></a>00447   <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#a3cec8b434c51b58caec642d978c64ab4">close_foreign_id_maps</a> ();
<a name="l00448"></a>00448 
<a name="l00449"></a>00449 
<a name="l00450"></a>00450 <span class="keyword">protected</span>:
<a name="l00451"></a>00451 
<a name="l00452"></a>00452 
<a name="l00453"></a>00453   <span class="comment">//----------------------------------------------------------</span>
<a name="l00454"></a>00454   <span class="comment">// read/write Methods</span>
<a name="l00458"></a>00458 <span class="comment"></span>  <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#a8fa0a3e635dc67032e955ead3e1ef062">read_tetgen</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>);
<a name="l00459"></a>00459 
<a name="l00465"></a>00465   <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#a7d7ab5ce4ca10e2ac03cf02f3b12fab0">read_unv</a> (<span class="keyword">const</span> std::string&amp; file_name);
<a name="l00466"></a>00466 
<a name="l00473"></a>00473   <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#a1637423d1d17e4bd8308245b8d572db8">read_unv_implementation</a> (std::istream&amp; in_file);
<a name="l00474"></a>00474 
<a name="l00480"></a>00480   <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#ab89d18becb28d7f267224ce4a773d40f">write_unv</a> (<span class="keyword">const</span> std::string&amp; file_name);
<a name="l00481"></a>00481 
<a name="l00488"></a>00488   <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#a7626efe4d193f2f3806e393ed6578d47">write_unv_implementation</a> (std::ostream&amp; out_file);
<a name="l00489"></a>00489 
<a name="l00490"></a>00490 
<a name="l00498"></a>00498   <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#ad337af3416fd475a76d5fa17decba921">read_xdr</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00499"></a>00499                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">XdrMODE</a> mode = <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>);
<a name="l00500"></a>00500 
<a name="l00507"></a>00507   <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#aef8a4c695e7032e235f26657b1485256">write_xdr</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00508"></a>00508                   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">XdrMODE</a> mode = <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>);
<a name="l00509"></a>00509 
<a name="l00510"></a>00510 
<a name="l00514"></a><a class="code" href="classMeshData.php#aef8b56d1df25b587d4b8aee4136b3870">00514</a>   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshData.php#aef8b56d1df25b587d4b8aee4136b3870">_mesh</a>;
<a name="l00515"></a>00515 
<a name="l00520"></a><a class="code" href="classMeshData.php#aca70c20078e79351af9da2701f51f99d">00520</a>   std::string <a class="code" href="classMeshData.php#aca70c20078e79351af9da2701f51f99d">_data_descriptor</a>;
<a name="l00521"></a>00521 
<a name="l00522"></a>00522 
<a name="l00523"></a>00523   <span class="comment">//--------------------------------------------------</span>
<a name="l00524"></a>00524   <span class="comment">// node associated data &amp; maps</span>
<a name="l00529"></a>00529 <span class="comment"></span>  std::map&lt;<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>*,
<a name="l00530"></a><a class="code" href="classMeshData.php#a0773ff071287f33580af5832a70f8d0f">00530</a>            std::vector&lt;Number&gt; &gt; <a class="code" href="classMeshData.php#a0773ff071287f33580af5832a70f8d0f">_node_data</a>;
<a name="l00531"></a>00531 
<a name="l00536"></a>00536   std::map&lt;<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>*,
<a name="l00537"></a><a class="code" href="classMeshData.php#aa09457c9ac377c2f7f7f971867de69b3">00537</a>            <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt; <a class="code" href="classMeshData.php#aa09457c9ac377c2f7f7f971867de69b3">_node_id</a>;
<a name="l00538"></a>00538 
<a name="l00543"></a>00543   std::map&lt;<span class="keywordtype">unsigned</span> int,
<a name="l00544"></a><a class="code" href="classMeshData.php#a83aa59e4e6a4a4600b24020c7d81638f">00544</a>            <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>*&gt; <a class="code" href="classMeshData.php#a83aa59e4e6a4a4600b24020c7d81638f">_id_node</a>;
<a name="l00545"></a>00545 
<a name="l00546"></a>00546 
<a name="l00547"></a>00547 
<a name="l00548"></a>00548   <span class="comment">//--------------------------------------------------</span>
<a name="l00549"></a>00549   <span class="comment">// element associated data &amp; maps</span>
<a name="l00553"></a>00553 <span class="comment"></span>  std::map&lt;<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*,
<a name="l00554"></a><a class="code" href="classMeshData.php#a7d1d25eef77c023adc84c6010925036d">00554</a>            std::vector&lt;Number&gt; &gt; <a class="code" href="classMeshData.php#a7d1d25eef77c023adc84c6010925036d">_elem_data</a>;
<a name="l00555"></a>00555 
<a name="l00560"></a>00560   std::map&lt;<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*,
<a name="l00561"></a><a class="code" href="classMeshData.php#a722ac99e46bfe483b72a239d24dba6af">00561</a>            <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt; <a class="code" href="classMeshData.php#a722ac99e46bfe483b72a239d24dba6af">_elem_id</a>;
<a name="l00566"></a>00566   std::map&lt;<span class="keywordtype">unsigned</span> int,
<a name="l00567"></a><a class="code" href="classMeshData.php#aa4316f6310b136df7b65471964d3e4aa">00567</a>            <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*&gt; <a class="code" href="classMeshData.php#aa4316f6310b136df7b65471964d3e4aa">_id_elem</a>;
<a name="l00568"></a>00568 
<a name="l00569"></a>00569 
<a name="l00570"></a>00570 
<a name="l00571"></a>00571   <span class="comment">//--------------------------------------------------------</span>
<a name="l00580"></a><a class="code" href="classMeshData.php#a071ea01303d43241271f23704718897e">00580</a> <span class="comment"></span>  <span class="keywordtype">bool</span> <a class="code" href="classMeshData.php#a071ea01303d43241271f23704718897e">_node_id_map_closed</a>;
<a name="l00581"></a>00581 
<a name="l00586"></a><a class="code" href="classMeshData.php#a5718ca825e3b14e2e8947a3bac15d117">00586</a>   <span class="keywordtype">bool</span> <a class="code" href="classMeshData.php#a5718ca825e3b14e2e8947a3bac15d117">_node_data_closed</a>;
<a name="l00587"></a>00587 
<a name="l00588"></a>00588 
<a name="l00589"></a>00589   <span class="comment">//--------------------------------------------------------</span>
<a name="l00598"></a><a class="code" href="classMeshData.php#a52728bfcb6ea3691546bfa90770bb632">00598</a> <span class="comment"></span>  <span class="keywordtype">bool</span> <a class="code" href="classMeshData.php#a52728bfcb6ea3691546bfa90770bb632">_elem_id_map_closed</a>;
<a name="l00599"></a>00599 
<a name="l00604"></a><a class="code" href="classMeshData.php#aff2e62e6f1deb12255382c34dfca51d3">00604</a>   <span class="keywordtype">bool</span> <a class="code" href="classMeshData.php#aff2e62e6f1deb12255382c34dfca51d3">_elem_data_closed</a>;
<a name="l00605"></a>00605 
<a name="l00606"></a>00606 
<a name="l00607"></a>00607   <span class="comment">//--------------------------------------------------------</span>
<a name="l00612"></a><a class="code" href="classMeshData.php#ac67bdab9e104987a755c123ddbc899a3">00612</a> <span class="comment"></span>  <span class="keywordtype">bool</span> <a class="code" href="classMeshData.php#ac67bdab9e104987a755c123ddbc899a3">_active</a>;
<a name="l00613"></a>00613 
<a name="l00619"></a><a class="code" href="classMeshData.php#ab3fcaff9ed092e581d667fd04dacbd39">00619</a>   <span class="keywordtype">bool</span> <a class="code" href="classMeshData.php#ab3fcaff9ed092e581d667fd04dacbd39">_compatibility_mode</a>;
<a name="l00620"></a>00620 
<a name="l00624"></a><a class="code" href="classMeshData.php#a1d269aa4356e77d4c74b7dc143b14045">00624</a>   <a class="code" href="classMeshDataUnvHeader.php">MeshDataUnvHeader</a>* <a class="code" href="classMeshData.php#a1d269aa4356e77d4c74b7dc143b14045">_unv_header</a>;
<a name="l00625"></a>00625   
<a name="l00629"></a><a class="code" href="classMeshData.php#a6fc440741aa85819ff6935439e835106">00629</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classMeshDataUnvHeader.php">MeshDataUnvHeader</a>;
<a name="l00630"></a>00630   
<a name="l00631"></a>00631 };
<a name="l00632"></a>00632 
<a name="l00633"></a>00633 
<a name="l00634"></a>00634 
<a name="l00635"></a>00635 <span class="comment">//-----------------------------------------------------------</span>
<a name="l00636"></a>00636 <span class="comment">// MeshDataUnvHeader class definition</span>
<a name="l00637"></a>00637 
<a name="l00681"></a><a class="code" href="classMeshDataUnvHeader.php">00681</a> <span class="keyword">class </span><a class="code" href="classMeshDataUnvHeader.php">MeshDataUnvHeader</a>
<a name="l00682"></a>00682 {
<a name="l00683"></a>00683 <span class="keyword">public</span>:
<a name="l00684"></a>00684 
<a name="l00689"></a>00689   <a class="code" href="classMeshDataUnvHeader.php#ae6080dd453e0a70326b72e6a1ca4083a">MeshDataUnvHeader</a> ();
<a name="l00690"></a>00690 
<a name="l00694"></a>00694   <a class="code" href="classMeshDataUnvHeader.php#a8fcf984cf95ec20ec82f18cd208d046e">~MeshDataUnvHeader</a> ();
<a name="l00695"></a>00695 
<a name="l00710"></a>00710   <span class="keywordtype">void</span> <a class="code" href="classMeshDataUnvHeader.php#a0dd7c74a222b3496b6a34247d124a1b1">which_dataset</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ds_label);
<a name="l00711"></a>00711 
<a name="l00716"></a>00716   <span class="keywordtype">void</span> <a class="code" href="classMeshDataUnvHeader.php#a785e8278b4c7076d37e663069a7c715e">operator = </a>(<span class="keyword">const</span> <a class="code" href="classMeshDataUnvHeader.php">MeshDataUnvHeader</a>&amp; omduh);
<a name="l00717"></a>00717 
<a name="l00722"></a>00722   <span class="keywordtype">bool</span> <a class="code" href="classMeshDataUnvHeader.php#aba0e7cdb6fb35cf420dbfc40ff76e8bd">operator == </a>(<span class="keyword">const</span> <a class="code" href="classMeshDataUnvHeader.php">MeshDataUnvHeader</a>&amp; omduh) <span class="keyword">const</span>;
<a name="l00723"></a>00723 
<a name="l00727"></a><a class="code" href="classMeshDataUnvHeader.php#a9432bcb223662f6f1b50c5ed01b05c14">00727</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshDataUnvHeader.php#a9432bcb223662f6f1b50c5ed01b05c14">dataset_label</a>;
<a name="l00728"></a>00728 
<a name="l00732"></a><a class="code" href="classMeshDataUnvHeader.php#a37a86ee3e94d3e7a08667bfada510841">00732</a>   std::string <a class="code" href="classMeshDataUnvHeader.php#a37a86ee3e94d3e7a08667bfada510841">dataset_name</a>;
<a name="l00733"></a>00733 
<a name="l00738"></a><a class="code" href="classMeshDataUnvHeader.php#a93a7085fec9bdafb843bfb56a7bd0a50">00738</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshDataUnvHeader.php#a93a7085fec9bdafb843bfb56a7bd0a50">dataset_location</a>;
<a name="l00739"></a>00739 
<a name="l00743"></a><a class="code" href="classMeshDataUnvHeader.php#aefecee738a3f03db3d73ebe9f28f7f1c">00743</a>   std::vector&lt;std::string&gt; <a class="code" href="classMeshDataUnvHeader.php#aefecee738a3f03db3d73ebe9f28f7f1c">id_lines_1_to_5</a>;
<a name="l00744"></a>00744 
<a name="l00754"></a><a class="code" href="classMeshDataUnvHeader.php#ae424259011b6063d66933b4316201cdb">00754</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshDataUnvHeader.php#a3d3e4f97d1fbcba3be7115c59392b9ff">model_type</a>,
<a name="l00755"></a>00755                <a class="code" href="classMeshDataUnvHeader.php#a63f46e0b3f6ce390fd8d0b802d5d4354">analysis_type</a>,
<a name="l00756"></a>00756                <a class="code" href="classMeshDataUnvHeader.php#a2d824a184d8c87338dd1df69b0319f56">data_characteristic</a>,
<a name="l00757"></a>00757                <a class="code" href="classMeshDataUnvHeader.php#ae424259011b6063d66933b4316201cdb">result_type</a>;
<a name="l00758"></a>00758 
<a name="l00764"></a><a class="code" href="classMeshDataUnvHeader.php#ae8194a3ba8d6615dabebedd252332b4c">00764</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshDataUnvHeader.php#ae8194a3ba8d6615dabebedd252332b4c">data_type</a>;
<a name="l00765"></a>00765 
<a name="l00770"></a><a class="code" href="classMeshDataUnvHeader.php#a345c5391a7100d467f347942498f172b">00770</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshDataUnvHeader.php#a345c5391a7100d467f347942498f172b">nvaldc</a>;
<a name="l00771"></a>00771 
<a name="l00776"></a><a class="code" href="classMeshDataUnvHeader.php#a21c07f5b394962c15d12b94f243cfbaa">00776</a>   std::vector&lt;int&gt; <a class="code" href="classMeshDataUnvHeader.php#abe34ba27cef23f0fcb00e3d41cb38c86">record_10</a>,
<a name="l00777"></a>00777                    <a class="code" href="classMeshDataUnvHeader.php#a21c07f5b394962c15d12b94f243cfbaa">record_11</a>;
<a name="l00778"></a>00778 
<a name="l00783"></a><a class="code" href="classMeshDataUnvHeader.php#aa72672e176d3594183b3a490044dad2e">00783</a>   std::vector&lt;Real&gt; <a class="code" href="classMeshDataUnvHeader.php#a41b36862d87363c11aa05ec3eac1e57d">record_12</a>,
<a name="l00784"></a>00784                     <a class="code" href="classMeshDataUnvHeader.php#aa72672e176d3594183b3a490044dad2e">record_13</a>;
<a name="l00785"></a>00785 
<a name="l00786"></a>00786 
<a name="l00787"></a>00787 <span class="keyword">protected</span>:
<a name="l00788"></a>00788 
<a name="l00797"></a>00797   <span class="keywordtype">bool</span> <a class="code" href="classMeshDataUnvHeader.php#ae87923195e561e714fe2069b031be06a">read</a> (std::istream&amp; in_file);
<a name="l00798"></a>00798 
<a name="l00802"></a>00802   <span class="keywordtype">void</span> <a class="code" href="classMeshDataUnvHeader.php#aa9785b38766a9099661c4281db2d7fe7">write</a> (std::ostream&amp; out_file);
<a name="l00803"></a>00803 
<a name="l00804"></a>00804 
<a name="l00805"></a>00805 <span class="keyword">private</span>:
<a name="l00806"></a>00806 
<a name="l00811"></a><a class="code" href="classMeshDataUnvHeader.php#a1ce4684c8c1037ff8d1da8cbac058a70">00811</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshDataUnvHeader.php#a1ce4684c8c1037ff8d1da8cbac058a70">_desired_dataset_label</a>;
<a name="l00812"></a>00812 
<a name="l00819"></a>00819   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classMeshDataUnvHeader.php#aaa25878234cc9797f88a24529903f28b">need_D_to_e</a> (std::string&amp; number);
<a name="l00820"></a>00820 
<a name="l00824"></a><a class="code" href="classMeshDataUnvHeader.php#adb370c823252769d6a7f254661e1ff6a">00824</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classMeshData.php">MeshData</a>;
<a name="l00825"></a>00825 
<a name="l00826"></a>00826 };
<a name="l00827"></a>00827 
<a name="l00828"></a>00828 
<a name="l00829"></a>00829 
<a name="l00830"></a>00830 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00831"></a>00831 <span class="comment">// MeshData inline methods</span>
<a name="l00832"></a>00832 
<a name="l00833"></a>00833 <span class="comment">//-------------------------------------------------------------</span>
<a name="l00834"></a>00834 <span class="comment">// element data inline methods</span>
<a name="l00835"></a>00835 <span class="keyword">inline</span>
<a name="l00836"></a><a class="code" href="classMeshData.php#a7be1ba17dbb8a3d1da387cab6a357431">00836</a> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classMeshData.php#a7be1ba17dbb8a3d1da387cab6a357431">MeshData::operator() </a>(<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node, 
<a name="l00837"></a>00837                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00838"></a>00838 <span class="keyword"></span>{
<a name="l00839"></a>00839   libmesh_assert (<a class="code" href="classMeshData.php#ac67bdab9e104987a755c123ddbc899a3">_active</a> || <a class="code" href="classMeshData.php#ab3fcaff9ed092e581d667fd04dacbd39">_compatibility_mode</a>);
<a name="l00840"></a>00840   libmesh_assert (<a class="code" href="classMeshData.php#a5718ca825e3b14e2e8947a3bac15d117">_node_data_closed</a>);
<a name="l00841"></a>00841 
<a name="l00842"></a>00842   std::map&lt;<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>*, 
<a name="l00843"></a>00843            std::vector&lt;Number&gt; &gt;::const_iterator pos = <a class="code" href="classMeshData.php#a0773ff071287f33580af5832a70f8d0f">_node_data</a>.find(node);
<a name="l00844"></a>00844 
<a name="l00845"></a>00845   <span class="keywordflow">if</span> (pos == <a class="code" href="classMeshData.php#a0773ff071287f33580af5832a70f8d0f">_node_data</a>.end())
<a name="l00846"></a>00846       <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>;
<a name="l00847"></a>00847 
<a name="l00848"></a>00848   <span class="comment">// we only get here when pos != _node_data.end()</span>
<a name="l00849"></a>00849   libmesh_assert (i &lt; pos-&gt;second.size());
<a name="l00850"></a>00850   <span class="keywordflow">return</span> pos-&gt;second[i];
<a name="l00851"></a>00851 }
<a name="l00852"></a>00852 
<a name="l00853"></a>00853 
<a name="l00854"></a>00854 
<a name="l00855"></a>00855 <span class="keyword">inline</span>
<a name="l00856"></a><a class="code" href="classMeshData.php#a88fea2994fc1ac1295745fdb8bd685f5">00856</a> <span class="keywordtype">bool</span> <a class="code" href="classMeshData.php#a88fea2994fc1ac1295745fdb8bd685f5">MeshData::has_data</a> (<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node)<span class="keyword"> const</span>
<a name="l00857"></a>00857 <span class="keyword"></span>{
<a name="l00858"></a>00858   libmesh_assert (<a class="code" href="classMeshData.php#ac67bdab9e104987a755c123ddbc899a3">_active</a> || <a class="code" href="classMeshData.php#ab3fcaff9ed092e581d667fd04dacbd39">_compatibility_mode</a>);
<a name="l00859"></a>00859   libmesh_assert (<a class="code" href="classMeshData.php#a5718ca825e3b14e2e8947a3bac15d117">_node_data_closed</a>);
<a name="l00860"></a>00860 
<a name="l00861"></a>00861   std::map&lt;<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>*, 
<a name="l00862"></a>00862            std::vector&lt;Number&gt; &gt;::const_iterator pos = <a class="code" href="classMeshData.php#a0773ff071287f33580af5832a70f8d0f">_node_data</a>.find(node);
<a name="l00863"></a>00863 
<a name="l00864"></a>00864   <span class="keywordflow">return</span> (pos != <a class="code" href="classMeshData.php#a0773ff071287f33580af5832a70f8d0f">_node_data</a>.end());
<a name="l00865"></a>00865 }
<a name="l00866"></a>00866 
<a name="l00867"></a>00867 
<a name="l00868"></a>00868 
<a name="l00869"></a>00869 <span class="keyword">inline</span>
<a name="l00870"></a><a class="code" href="classMeshData.php#ab34864d2e1f83059bd781b0dd5f71fe0">00870</a> <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; <a class="code" href="classMeshData.php#ab34864d2e1f83059bd781b0dd5f71fe0">MeshData::get_data</a> (<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node)<span class="keyword"> const</span>
<a name="l00871"></a>00871 <span class="keyword"></span>{
<a name="l00872"></a>00872   libmesh_assert (<a class="code" href="classMeshData.php#ac67bdab9e104987a755c123ddbc899a3">_active</a> || <a class="code" href="classMeshData.php#ab3fcaff9ed092e581d667fd04dacbd39">_compatibility_mode</a>);
<a name="l00873"></a>00873   libmesh_assert (<a class="code" href="classMeshData.php#a5718ca825e3b14e2e8947a3bac15d117">_node_data_closed</a>);
<a name="l00874"></a>00874 
<a name="l00875"></a>00875   std::map&lt;<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>*, 
<a name="l00876"></a>00876            std::vector&lt;Number&gt; &gt;::const_iterator pos = <a class="code" href="classMeshData.php#a0773ff071287f33580af5832a70f8d0f">_node_data</a>.find(node);
<a name="l00877"></a>00877 
<a name="l00878"></a>00878 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00879"></a>00879 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (pos == <a class="code" href="classMeshData.php#a0773ff071287f33580af5832a70f8d0f">_node_data</a>.end())
<a name="l00880"></a>00880     {
<a name="l00881"></a>00881       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: No data for this node.  Use has_data() first!&quot;</span> &lt;&lt; std::endl;
<a name="l00882"></a>00882       libmesh_error();
<a name="l00883"></a>00883     }
<a name="l00884"></a>00884 <span class="preprocessor">#endif</span>
<a name="l00885"></a>00885 <span class="preprocessor"></span>
<a name="l00886"></a>00886   <span class="keywordflow">return</span> pos-&gt;second;
<a name="l00887"></a>00887 }
<a name="l00888"></a>00888 
<a name="l00889"></a>00889 
<a name="l00890"></a>00890 
<a name="l00891"></a>00891 <span class="keyword">inline</span>
<a name="l00892"></a><a class="code" href="classMeshData.php#aa64f54d59daaf037ba5fe43393fa6bdf">00892</a> <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#aa64f54d59daaf037ba5fe43393fa6bdf">MeshData::set_data</a> (<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node,
<a name="l00893"></a>00893                          <span class="keyword">const</span> std::vector&lt;Number&gt; &amp;val)
<a name="l00894"></a>00894 {
<a name="l00895"></a>00895   this-&gt;<a class="code" href="classMeshData.php#a0773ff071287f33580af5832a70f8d0f">_node_data</a>[node] = val;
<a name="l00896"></a>00896 }
<a name="l00897"></a>00897 
<a name="l00898"></a>00898 
<a name="l00899"></a>00899 
<a name="l00900"></a>00900 <span class="keyword">inline</span>
<a name="l00901"></a><a class="code" href="classMeshData.php#ac5069e4367ae32f436cae3427ff74991">00901</a> <a class="code" href="classMeshData.php#a6e0f60c1f2c5dcbe789de9d043d27d2a">MeshData::const_node_data_iterator</a> <a class="code" href="classMeshData.php#ac5069e4367ae32f436cae3427ff74991">MeshData::node_data_begin</a> ()<span class="keyword"> const</span>
<a name="l00902"></a>00902 <span class="keyword"></span>{
<a name="l00903"></a>00903   <span class="keywordflow">return</span> <a class="code" href="classMeshData.php#a0773ff071287f33580af5832a70f8d0f">_node_data</a>.begin();
<a name="l00904"></a>00904 }
<a name="l00905"></a>00905 
<a name="l00906"></a>00906 
<a name="l00907"></a>00907 
<a name="l00908"></a>00908 <span class="keyword">inline</span>
<a name="l00909"></a><a class="code" href="classMeshData.php#afe1300d29765163e82f44fd7eae418be">00909</a> <a class="code" href="classMeshData.php#a6e0f60c1f2c5dcbe789de9d043d27d2a">MeshData::const_node_data_iterator</a> <a class="code" href="classMeshData.php#afe1300d29765163e82f44fd7eae418be">MeshData::node_data_end</a> ()<span class="keyword"> const</span>
<a name="l00910"></a>00910 <span class="keyword"></span>{
<a name="l00911"></a>00911   <span class="keywordflow">return</span> <a class="code" href="classMeshData.php#a0773ff071287f33580af5832a70f8d0f">_node_data</a>.end();
<a name="l00912"></a>00912 }
<a name="l00913"></a>00913 
<a name="l00914"></a>00914 
<a name="l00915"></a>00915 
<a name="l00916"></a>00916 <span class="comment">//-------------------------------------------------------------</span>
<a name="l00917"></a>00917 <span class="comment">// element data inline methods</span>
<a name="l00918"></a>00918 <span class="keyword">inline</span>
<a name="l00919"></a><a class="code" href="classMeshData.php#aaca886338edd9095615a9092d3421669">00919</a> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classMeshData.php#a7be1ba17dbb8a3d1da387cab6a357431">MeshData::operator() </a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem, 
<a name="l00920"></a>00920                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00921"></a>00921 <span class="keyword"></span>{
<a name="l00922"></a>00922   libmesh_assert (<a class="code" href="classMeshData.php#ac67bdab9e104987a755c123ddbc899a3">_active</a> || <a class="code" href="classMeshData.php#ab3fcaff9ed092e581d667fd04dacbd39">_compatibility_mode</a>);
<a name="l00923"></a>00923   libmesh_assert (<a class="code" href="classMeshData.php#aff2e62e6f1deb12255382c34dfca51d3">_elem_data_closed</a>);
<a name="l00924"></a>00924 
<a name="l00925"></a>00925   std::map&lt;<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*, 
<a name="l00926"></a>00926            std::vector&lt;Number&gt; &gt;::const_iterator pos = <a class="code" href="classMeshData.php#a7d1d25eef77c023adc84c6010925036d">_elem_data</a>.find(elem);
<a name="l00927"></a>00927 
<a name="l00928"></a>00928   <span class="keywordflow">if</span> (pos == <a class="code" href="classMeshData.php#a7d1d25eef77c023adc84c6010925036d">_elem_data</a>.end())
<a name="l00929"></a>00929     <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>;
<a name="l00930"></a>00930   
<a name="l00931"></a>00931   <span class="comment">// we only get here when pos != _elem_data.end()  </span>
<a name="l00932"></a>00932   libmesh_assert (i &lt; pos-&gt;second.size());
<a name="l00933"></a>00933   <span class="keywordflow">return</span> pos-&gt;second[i];
<a name="l00934"></a>00934 }
<a name="l00935"></a>00935 
<a name="l00936"></a>00936 
<a name="l00937"></a>00937 
<a name="l00938"></a>00938 <span class="keyword">inline</span>
<a name="l00939"></a><a class="code" href="classMeshData.php#addbfcd2bb7f2a575b9fe2fd2788743e0">00939</a> <span class="keywordtype">bool</span> <a class="code" href="classMeshData.php#a88fea2994fc1ac1295745fdb8bd685f5">MeshData::has_data</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem)<span class="keyword"> const</span>
<a name="l00940"></a>00940 <span class="keyword"></span>{
<a name="l00941"></a>00941   libmesh_assert (<a class="code" href="classMeshData.php#ac67bdab9e104987a755c123ddbc899a3">_active</a> || <a class="code" href="classMeshData.php#ab3fcaff9ed092e581d667fd04dacbd39">_compatibility_mode</a>);
<a name="l00942"></a>00942   libmesh_assert (<a class="code" href="classMeshData.php#aff2e62e6f1deb12255382c34dfca51d3">_elem_data_closed</a>);
<a name="l00943"></a>00943 
<a name="l00944"></a>00944   std::map&lt;<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*, 
<a name="l00945"></a>00945            std::vector&lt;Number&gt; &gt;::const_iterator pos = <a class="code" href="classMeshData.php#a7d1d25eef77c023adc84c6010925036d">_elem_data</a>.find(elem);
<a name="l00946"></a>00946 
<a name="l00947"></a>00947   <span class="keywordflow">return</span> (pos != <a class="code" href="classMeshData.php#a7d1d25eef77c023adc84c6010925036d">_elem_data</a>.end());
<a name="l00948"></a>00948 }
<a name="l00949"></a>00949 
<a name="l00950"></a>00950 
<a name="l00951"></a>00951 
<a name="l00952"></a>00952 <span class="keyword">inline</span>
<a name="l00953"></a><a class="code" href="classMeshData.php#a4078ed0a39bc47424c93a383f6ce9bce">00953</a> <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; <a class="code" href="classMeshData.php#ab34864d2e1f83059bd781b0dd5f71fe0">MeshData::get_data</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem)<span class="keyword"> const</span>
<a name="l00954"></a>00954 <span class="keyword"></span>{
<a name="l00955"></a>00955   libmesh_assert (<a class="code" href="classMeshData.php#ac67bdab9e104987a755c123ddbc899a3">_active</a> || <a class="code" href="classMeshData.php#ab3fcaff9ed092e581d667fd04dacbd39">_compatibility_mode</a>);
<a name="l00956"></a>00956   libmesh_assert (<a class="code" href="classMeshData.php#aff2e62e6f1deb12255382c34dfca51d3">_elem_data_closed</a>);
<a name="l00957"></a>00957 
<a name="l00958"></a>00958   std::map&lt;<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*, 
<a name="l00959"></a>00959            std::vector&lt;Number&gt; &gt;::const_iterator pos = <a class="code" href="classMeshData.php#a7d1d25eef77c023adc84c6010925036d">_elem_data</a>.find(elem);
<a name="l00960"></a>00960 
<a name="l00961"></a>00961 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00962"></a>00962 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (pos == <a class="code" href="classMeshData.php#a7d1d25eef77c023adc84c6010925036d">_elem_data</a>.end())
<a name="l00963"></a>00963     {
<a name="l00964"></a>00964       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: No data for this element.  Use has_data() first!&quot;</span> &lt;&lt; std::endl;
<a name="l00965"></a>00965       libmesh_error();
<a name="l00966"></a>00966     }
<a name="l00967"></a>00967 <span class="preprocessor">#endif</span>
<a name="l00968"></a>00968 <span class="preprocessor"></span>
<a name="l00969"></a>00969   <span class="keywordflow">return</span> pos-&gt;second;
<a name="l00970"></a>00970 }
<a name="l00971"></a>00971 
<a name="l00972"></a>00972 
<a name="l00973"></a>00973 
<a name="l00974"></a>00974 <span class="keyword">inline</span>
<a name="l00975"></a><a class="code" href="classMeshData.php#a79d87c22b3c6b5dd941222f4243d3d00">00975</a> <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#aa64f54d59daaf037ba5fe43393fa6bdf">MeshData::set_data</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00976"></a>00976                          <span class="keyword">const</span> std::vector&lt;Number&gt; &amp;val)
<a name="l00977"></a>00977 {
<a name="l00978"></a>00978   this-&gt;<a class="code" href="classMeshData.php#a7d1d25eef77c023adc84c6010925036d">_elem_data</a>[elem] = val;
<a name="l00979"></a>00979 }
<a name="l00980"></a>00980 
<a name="l00981"></a>00981 
<a name="l00982"></a>00982 
<a name="l00983"></a>00983 <span class="keyword">inline</span>
<a name="l00984"></a><a class="code" href="classMeshData.php#add5e573ac3857a9bf8f3d1b517fad302">00984</a> <a class="code" href="classMeshData.php#a2b161d1fc88ec85b422184285fbd0c1e">MeshData::const_elem_data_iterator</a> <a class="code" href="classMeshData.php#add5e573ac3857a9bf8f3d1b517fad302">MeshData::elem_data_begin</a> ()<span class="keyword"> const</span>
<a name="l00985"></a>00985 <span class="keyword"></span>{
<a name="l00986"></a>00986   <span class="keywordflow">return</span> <a class="code" href="classMeshData.php#a7d1d25eef77c023adc84c6010925036d">_elem_data</a>.begin();
<a name="l00987"></a>00987 }
<a name="l00988"></a>00988 
<a name="l00989"></a>00989 
<a name="l00990"></a>00990 
<a name="l00991"></a>00991 <span class="keyword">inline</span>
<a name="l00992"></a><a class="code" href="classMeshData.php#a030e720d46f453933268af0e462119f8">00992</a> <a class="code" href="classMeshData.php#a2b161d1fc88ec85b422184285fbd0c1e">MeshData::const_elem_data_iterator</a> <a class="code" href="classMeshData.php#a030e720d46f453933268af0e462119f8">MeshData::elem_data_end</a> ()<span class="keyword"> const</span>
<a name="l00993"></a>00993 <span class="keyword"></span>{
<a name="l00994"></a>00994   <span class="keywordflow">return</span> <a class="code" href="classMeshData.php#a7d1d25eef77c023adc84c6010925036d">_elem_data</a>.end();
<a name="l00995"></a>00995 }
<a name="l00996"></a>00996 
<a name="l00997"></a>00997 
<a name="l00998"></a>00998 
<a name="l00999"></a>00999 <span class="comment">//-------------------------------------------------------------</span>
<a name="l01000"></a>01000 <span class="comment">// other inline methods</span>
<a name="l01001"></a>01001 <span class="keyword">inline</span>
<a name="l01002"></a><a class="code" href="classMeshData.php#a4d99efe5fb30d203afdd520d213c6233">01002</a> <span class="keywordtype">bool</span> <a class="code" href="classMeshData.php#a4d99efe5fb30d203afdd520d213c6233">MeshData::active</a>()<span class="keyword"> const</span>
<a name="l01003"></a>01003 <span class="keyword"></span>{
<a name="l01004"></a>01004   <span class="keywordflow">return</span> <a class="code" href="classMeshData.php#ac67bdab9e104987a755c123ddbc899a3">_active</a>;
<a name="l01005"></a>01005 }
<a name="l01006"></a>01006 
<a name="l01007"></a>01007 
<a name="l01008"></a>01008 
<a name="l01009"></a>01009 <span class="keyword">inline</span>
<a name="l01010"></a><a class="code" href="classMeshData.php#af448a633cf06236e8ebcb5cf73d3d2eb">01010</a> <span class="keywordtype">bool</span> <a class="code" href="classMeshData.php#af448a633cf06236e8ebcb5cf73d3d2eb">MeshData::compatibility_mode</a>()<span class="keyword"> const</span>
<a name="l01011"></a>01011 <span class="keyword"></span>{
<a name="l01012"></a>01012   <span class="keywordflow">return</span> <a class="code" href="classMeshData.php#ab3fcaff9ed092e581d667fd04dacbd39">_compatibility_mode</a>;
<a name="l01013"></a>01013 }
<a name="l01014"></a>01014 
<a name="l01015"></a>01015 
<a name="l01016"></a>01016 
<a name="l01017"></a>01017 <span class="keyword">inline</span>
<a name="l01018"></a><a class="code" href="classMeshData.php#a5d9abd12d8c9c4105c251770a95089f8">01018</a> <span class="keywordtype">bool</span> <a class="code" href="classMeshData.php#a5d9abd12d8c9c4105c251770a95089f8">MeshData::elem_initialized</a>()<span class="keyword"> const</span>
<a name="l01019"></a>01019 <span class="keyword"></span>{
<a name="l01020"></a>01020   <span class="keywordflow">return</span> (<a class="code" href="classMeshData.php#ac67bdab9e104987a755c123ddbc899a3">_active</a> &amp;&amp; <a class="code" href="classMeshData.php#aff2e62e6f1deb12255382c34dfca51d3">_elem_data_closed</a>);
<a name="l01021"></a>01021 }
<a name="l01022"></a>01022 
<a name="l01023"></a>01023 
<a name="l01024"></a>01024 
<a name="l01025"></a>01025 <span class="keyword">inline</span>
<a name="l01026"></a><a class="code" href="classMeshData.php#a2d11b9490e1aa16eff2424306f7da832">01026</a> <span class="keywordtype">bool</span> <a class="code" href="classMeshData.php#a2d11b9490e1aa16eff2424306f7da832">MeshData::node_initialized</a>()<span class="keyword"> const</span>
<a name="l01027"></a>01027 <span class="keyword"></span>{
<a name="l01028"></a>01028   <span class="keywordflow">return</span> (<a class="code" href="classMeshData.php#ac67bdab9e104987a755c123ddbc899a3">_active</a> &amp;&amp; <a class="code" href="classMeshData.php#a5718ca825e3b14e2e8947a3bac15d117">_node_data_closed</a>);
<a name="l01029"></a>01029 }
<a name="l01030"></a>01030 
<a name="l01031"></a>01031 
<a name="l01032"></a>01032 
<a name="l01033"></a>01033 <span class="keyword">inline</span>  
<a name="l01034"></a><a class="code" href="classMeshData.php#af408db231805974db975dbdf3c1756f5">01034</a> <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#af408db231805974db975dbdf3c1756f5">MeshData::add_foreign_node_id</a> (<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node, 
<a name="l01035"></a>01035                                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> foreign_node_id)
<a name="l01036"></a>01036 {
<a name="l01037"></a>01037   <span class="keywordflow">if</span> (<a class="code" href="classMeshData.php#ac67bdab9e104987a755c123ddbc899a3">_active</a>)
<a name="l01038"></a>01038     {
<a name="l01039"></a>01039       libmesh_assert (!<a class="code" href="classMeshData.php#a071ea01303d43241271f23704718897e">_node_id_map_closed</a>);
<a name="l01040"></a>01040       libmesh_assert (node                             != NULL);
<a name="l01041"></a>01041       libmesh_assert (<a class="code" href="classMeshData.php#aa09457c9ac377c2f7f7f971867de69b3">_node_id</a>.find(node)              == <a class="code" href="classMeshData.php#aa09457c9ac377c2f7f7f971867de69b3">_node_id</a>.end());
<a name="l01042"></a>01042       libmesh_assert (<a class="code" href="classMeshData.php#a83aa59e4e6a4a4600b24020c7d81638f">_id_node</a>.find(foreign_node_id)   == <a class="code" href="classMeshData.php#a83aa59e4e6a4a4600b24020c7d81638f">_id_node</a>.end());
<a name="l01043"></a>01043 
<a name="l01044"></a>01044       <span class="comment">/*</span>
<a name="l01045"></a>01045 <span class="comment">       * _always_ insert in _id_node and _node_id.  If we would </span>
<a name="l01046"></a>01046 <span class="comment">       * use the mesh.node(unsigned int) method or the node.id()</span>
<a name="l01047"></a>01047 <span class="comment">       * to get Node* and unsigned int, respectively, we would not</span>
<a name="l01048"></a>01048 <span class="comment">       * be safe any more when the mesh gets refined or re-numbered</span>
<a name="l01049"></a>01049 <span class="comment">       * within libMesh. And we could get in big trouble that would</span>
<a name="l01050"></a>01050 <span class="comment">       * be hard to find when importing data _after_ having refined...</span>
<a name="l01051"></a>01051 <span class="comment">       */</span>
<a name="l01052"></a>01052       <a class="code" href="classMeshData.php#aa09457c9ac377c2f7f7f971867de69b3">_node_id</a>.insert(std::make_pair(node, foreign_node_id));
<a name="l01053"></a>01053       <a class="code" href="classMeshData.php#a83aa59e4e6a4a4600b24020c7d81638f">_id_node</a>.insert(std::make_pair(foreign_node_id, node));
<a name="l01054"></a>01054     }
<a name="l01055"></a>01055 }
<a name="l01056"></a>01056 
<a name="l01057"></a>01057 
<a name="l01058"></a>01058 
<a name="l01059"></a>01059 <span class="keyword">inline</span>  
<a name="l01060"></a><a class="code" href="classMeshData.php#acf27873beae104e2109db6c93de7efa9">01060</a> <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#acf27873beae104e2109db6c93de7efa9">MeshData::add_foreign_elem_id</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem, 
<a name="l01061"></a>01061                                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> foreign_elem_id)
<a name="l01062"></a>01062 {
<a name="l01063"></a>01063   <span class="keywordflow">if</span> (<a class="code" href="classMeshData.php#ac67bdab9e104987a755c123ddbc899a3">_active</a>)
<a name="l01064"></a>01064     {
<a name="l01065"></a>01065       libmesh_assert (!<a class="code" href="classMeshData.php#a52728bfcb6ea3691546bfa90770bb632">_elem_id_map_closed</a>);
<a name="l01066"></a>01066       libmesh_assert (elem                             != NULL);
<a name="l01067"></a>01067       libmesh_assert (<a class="code" href="classMeshData.php#a722ac99e46bfe483b72a239d24dba6af">_elem_id</a>.find(elem)              == <a class="code" href="classMeshData.php#a722ac99e46bfe483b72a239d24dba6af">_elem_id</a>.end());
<a name="l01068"></a>01068       libmesh_assert (<a class="code" href="classMeshData.php#aa4316f6310b136df7b65471964d3e4aa">_id_elem</a>.find(foreign_elem_id)   == <a class="code" href="classMeshData.php#aa4316f6310b136df7b65471964d3e4aa">_id_elem</a>.end());
<a name="l01069"></a>01069 
<a name="l01070"></a>01070       <a class="code" href="classMeshData.php#a722ac99e46bfe483b72a239d24dba6af">_elem_id</a>.insert(std::make_pair(elem, foreign_elem_id));
<a name="l01071"></a>01071       <a class="code" href="classMeshData.php#aa4316f6310b136df7b65471964d3e4aa">_id_elem</a>.insert(std::make_pair(foreign_elem_id, elem));
<a name="l01072"></a>01072     }
<a name="l01073"></a>01073 }
<a name="l01074"></a>01074 
<a name="l01075"></a>01075 
<a name="l01076"></a>01076 <span class="keyword">inline</span>
<a name="l01077"></a><a class="code" href="classMeshData.php#a326094d0acd3979b1848efc8e7638fcc">01077</a> <span class="keyword">const</span> <a class="code" href="classMeshDataUnvHeader.php">MeshDataUnvHeader</a> &amp; <a class="code" href="classMeshData.php#a326094d0acd3979b1848efc8e7638fcc">MeshData::get_unv_header</a> ()<span class="keyword"> const</span>
<a name="l01078"></a>01078 <span class="keyword"></span>{
<a name="l01079"></a>01079   libmesh_assert (this-&gt;<a class="code" href="classMeshData.php#a1d269aa4356e77d4c74b7dc143b14045">_unv_header</a> != NULL);
<a name="l01080"></a>01080   <span class="keywordflow">return</span> *this-&gt;<a class="code" href="classMeshData.php#a1d269aa4356e77d4c74b7dc143b14045">_unv_header</a>;
<a name="l01081"></a>01081 }
<a name="l01082"></a>01082 
<a name="l01083"></a>01083 
<a name="l01084"></a>01084 <span class="keyword">inline</span>
<a name="l01085"></a><a class="code" href="classMeshData.php#a755e652166d7d01b530c49a575630a90">01085</a> <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#a755e652166d7d01b530c49a575630a90">MeshData::set_unv_header</a> (<a class="code" href="classMeshDataUnvHeader.php">MeshDataUnvHeader</a>* unv_header)
<a name="l01086"></a>01086 {
<a name="l01087"></a>01087   libmesh_assert (unv_header != NULL);
<a name="l01088"></a>01088   this-&gt;<a class="code" href="classMeshData.php#a1d269aa4356e77d4c74b7dc143b14045">_unv_header</a> = unv_header;
<a name="l01089"></a>01089 }
<a name="l01090"></a>01090 
<a name="l01091"></a>01091 
<a name="l01092"></a>01092 <span class="comment">//-----------------------------------------------------------</span>
<a name="l01093"></a>01093 <span class="comment">// MeshDataUnvHeader inline methods</span>
<a name="l01094"></a>01094 
<a name="l01095"></a>01095 
<a name="l01096"></a>01096 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
