<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_data_tetgen_support.C</h1>  </div>
</div>
<div class="contents">
<a href="mesh__data__tetgen__support_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_data_tetgen_support.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;mesh_data.h&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">//---------------------------------------------------------------------</span>
<a name="l00032"></a>00032 <span class="comment">// MeshDate TetGen support function</span>
<a name="l00033"></a><a class="code" href="classMeshData.php#a8fa0a3e635dc67032e955ead3e1ef062">00033</a> <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#a8fa0a3e635dc67032e955ead3e1ef062">MeshData::read_tetgen</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035   std::string name_node, name_ele, dummy;
<a name="l00036"></a>00036   std::string desc = <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>;
<a name="l00037"></a>00037   
<a name="l00038"></a>00038   
<a name="l00039"></a>00039   <span class="comment">// Check name for *.node or *.ele extension.</span>
<a name="l00040"></a>00040   <span class="comment">// Set std::istream for node_stream and ele_stream.</span>
<a name="l00041"></a>00041   <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.node&quot;</span>) &lt; name.size()) 
<a name="l00042"></a>00042     {
<a name="l00043"></a>00043       name_node = <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>;
<a name="l00044"></a>00044       dummy     = <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>;
<a name="l00045"></a>00045       <span class="keywordtype">int</span> position = dummy.rfind(<span class="stringliteral">&quot;.node&quot;</span>);
<a name="l00046"></a>00046       name_ele     = dummy.replace(position, 5, <span class="stringliteral">&quot;.ele&quot;</span>);
<a name="l00047"></a>00047       desc.erase(position);
<a name="l00048"></a>00048     }
<a name="l00049"></a>00049   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.ele&quot;</span>) &lt; name.size()) 
<a name="l00050"></a>00050     {
<a name="l00051"></a>00051       name_ele = <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>;
<a name="l00052"></a>00052       dummy    = <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>;
<a name="l00053"></a>00053       <span class="keywordtype">int</span> position = dummy.rfind(<span class="stringliteral">&quot;.ele&quot;</span>);
<a name="l00054"></a>00054       name_node    = dummy.replace(position, 4, <span class="stringliteral">&quot;.node&quot;</span>);
<a name="l00055"></a>00055       desc.erase(position);
<a name="l00056"></a>00056     }
<a name="l00057"></a>00057   <span class="keywordflow">else</span>
<a name="l00058"></a>00058     {
<a name="l00059"></a>00059       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Unrecognized file name: &quot;</span>
<a name="l00060"></a>00060                 &lt;&lt; name &lt;&lt; std::endl;
<a name="l00061"></a>00061       libmesh_error();
<a name="l00062"></a>00062     }
<a name="l00063"></a>00063   
<a name="l00064"></a>00064   <span class="comment">// Set the streams from which to read in.</span>
<a name="l00065"></a>00065   std::ifstream node_stream (name_node.c_str());
<a name="l00066"></a>00066   std::ifstream ele_stream  (name_ele.c_str());
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   <span class="keywordflow">if</span> ( !node_stream.good() || !ele_stream.good() )
<a name="l00069"></a>00069     {
<a name="l00070"></a>00070       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: One or both Input file(s) not good.&quot;</span> &lt;&lt; std::endl
<a name="l00071"></a>00071                 &lt;&lt; <span class="stringliteral">&quot;Error checking files &quot;</span>
<a name="l00072"></a>00072                 &lt;&lt; name_node &lt;&lt; <span class="stringliteral">&quot; and &quot;</span>
<a name="l00073"></a>00073                 &lt;&lt; name_ele  &lt;&lt; std::endl;
<a name="l00074"></a>00074       libmesh_error();
<a name="l00075"></a>00075     }
<a name="l00076"></a>00076 
<a name="l00077"></a>00077   
<a name="l00078"></a>00078   <span class="comment">// Set the descriptive name.</span>
<a name="l00079"></a>00079   <span class="comment">// TetGen won&#39;t give a name, so we use the filename.</span>
<a name="l00080"></a>00080   this-&gt;<a class="code" href="classMeshData.php#aca70c20078e79351af9da2701f51f99d">_data_descriptor</a> = desc;
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   
<a name="l00083"></a>00083   <span class="comment">//--------------------------------------------------</span>
<a name="l00084"></a>00084   <span class="comment">// Read in the data associated with the nodes.</span>
<a name="l00085"></a>00085   {
<a name="l00086"></a>00086     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_node=0, f_n_id=0, nAttri=0, BoundMark=0;
<a name="l00087"></a>00087     <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> dummy=0.0;
<a name="l00088"></a>00088     std::vector&lt;Number&gt; AttriValue;
<a name="l00089"></a>00089 
<a name="l00090"></a>00090     <span class="comment">// Read the parameters from the node_stream.</span>
<a name="l00091"></a>00091     node_stream &gt;&gt; n_node     <span class="comment">// Read the number of nodes</span>
<a name="l00092"></a>00092                 &gt;&gt; dummy      <span class="comment">// Read the dimension</span>
<a name="l00093"></a>00093                 &gt;&gt; nAttri     <span class="comment">// Read the number of attributes</span>
<a name="l00094"></a>00094                 &gt;&gt; BoundMark; <span class="comment">// (0 or 1) boundary markers are in the stream or not.</span>
<a name="l00095"></a>00095 
<a name="l00096"></a>00096     <span class="comment">// Resize the values vector.</span>
<a name="l00097"></a>00097     AttriValue.resize(nAttri);
<a name="l00098"></a>00098 
<a name="l00099"></a>00099     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_node; i++)
<a name="l00100"></a>00100       {
<a name="l00101"></a>00101         node_stream &gt;&gt; f_n_id;
<a name="l00102"></a>00102 
<a name="l00103"></a>00103         
<a name="l00104"></a>00104         <span class="comment">// Read the nodal coordinates for this node into dummy,</span>
<a name="l00105"></a>00105         <span class="comment">// since we don&#39;t need them.</span>
<a name="l00106"></a>00106         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;3; j++)
<a name="l00107"></a>00107           node_stream &gt;&gt; dummy;
<a name="l00108"></a>00108 
<a name="l00109"></a>00109         <span class="comment">// Read the attributes from the stream.</span>
<a name="l00110"></a>00110         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;nAttri; j++)
<a name="l00111"></a>00111           node_stream &gt;&gt; AttriValue[j];
<a name="l00112"></a>00112 
<a name="l00113"></a>00113         <span class="comment">// Read boundary marker if BoundaryMarker=1.</span>
<a name="l00114"></a>00114         <span class="keywordflow">if</span> (BoundMark == 1)
<a name="l00115"></a>00115           node_stream &gt;&gt; dummy;
<a name="l00116"></a>00116 
<a name="l00117"></a>00117         <span class="comment">// For the foreign node id locate the Node*.</span>
<a name="l00118"></a>00118         <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node = <a class="code" href="classMeshData.php#a6cb6c156374dc82815b2f654eab9fdf7">foreign_id_to_node</a>(f_n_id);
<a name="l00119"></a>00119                                 
<a name="l00120"></a>00120         <span class="comment">// Insert this node and the values in our _node_data.</span>
<a name="l00121"></a>00121         <a class="code" href="classMeshData.php#a0773ff071287f33580af5832a70f8d0f">_node_data</a>.insert (std::make_pair(node, AttriValue));
<a name="l00122"></a>00122       }
<a name="l00123"></a>00123   }
<a name="l00124"></a>00124 
<a name="l00125"></a>00125   
<a name="l00126"></a>00126   <span class="comment">//--------------------------------------------------</span>
<a name="l00127"></a>00127   <span class="comment">// Read in the data associated with the elements.</span>
<a name="l00128"></a>00128   {
<a name="l00129"></a>00129     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a337ed123c95f0ba57b665456c413db4b">n_elem</a>, f_e_id, <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>, nAttri=0;
<a name="l00130"></a>00130     <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> dummy=0.0;
<a name="l00131"></a>00131     std::vector&lt;Number&gt; AttriValue;
<a name="l00132"></a>00132 
<a name="l00133"></a>00133     <span class="comment">// Read the parameters from the ele_stream.</span>
<a name="l00134"></a>00134     ele_stream &gt;&gt; n_elem   <span class="comment">// Read the number of tetrahedrons</span>
<a name="l00135"></a>00135                &gt;&gt; n_nodes  <span class="comment">// Read the points per tetrahedron</span>
<a name="l00136"></a>00136                &gt;&gt; nAttri;  <span class="comment">// Read the number of attributes</span>
<a name="l00137"></a>00137 
<a name="l00138"></a>00138     <span class="comment">// Resize the values vector.</span>
<a name="l00139"></a>00139     AttriValue.resize(nAttri);
<a name="l00140"></a>00140 
<a name="l00141"></a>00141     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="namespaceMeshTools.php#a337ed123c95f0ba57b665456c413db4b">n_elem</a>; i++)
<a name="l00142"></a>00142       {
<a name="l00143"></a>00143         ele_stream &gt;&gt; f_e_id;
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 
<a name="l00146"></a>00146         <span class="comment">// For the number of nodes for this element read them into dummy,</span>
<a name="l00147"></a>00147         <span class="comment">// since we don&#39;t need them.</span>
<a name="l00148"></a>00148         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>; n++)
<a name="l00149"></a>00149           {
<a name="l00150"></a>00150             ele_stream &gt;&gt; dummy;
<a name="l00151"></a>00151           }
<a name="l00152"></a>00152 
<a name="l00153"></a>00153         <span class="comment">// Read the attributes from the stream.</span>
<a name="l00154"></a>00154         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;nAttri; j++)
<a name="l00155"></a>00155           {
<a name="l00156"></a>00156             ele_stream &gt;&gt; AttriValue[j];
<a name="l00157"></a>00157           }
<a name="l00158"></a>00158 
<a name="l00159"></a>00159         <span class="comment">// For the foreign elem id locate the Elem*.</span>
<a name="l00160"></a>00160         <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = <a class="code" href="classMeshData.php#ad2522dd96c172f01c2dad1728988a538">foreign_id_to_elem</a>(f_e_id);
<a name="l00161"></a>00161                                 
<a name="l00162"></a>00162         <span class="comment">// Insert this elem and the values in our _elem_data.</span>
<a name="l00163"></a>00163         <a class="code" href="classMeshData.php#a7d1d25eef77c023adc84c6010925036d">_elem_data</a>.insert (std::make_pair(elem, AttriValue));
<a name="l00164"></a>00164       }
<a name="l00165"></a>00165   }
<a name="l00166"></a>00166   
<a name="l00167"></a>00167   <span class="comment">//--------------------------------------------------</span>
<a name="l00168"></a>00168   <span class="comment">// Finished reading.  Now ready for use.</span>
<a name="l00169"></a>00169   this-&gt;<a class="code" href="classMeshData.php#a5718ca825e3b14e2e8947a3bac15d117">_node_data_closed</a> = <span class="keyword">true</span>;
<a name="l00170"></a>00170   this-&gt;<a class="code" href="classMeshData.php#aff2e62e6f1deb12255382c34dfca51d3">_elem_data_closed</a> = <span class="keyword">true</span>;
<a name="l00171"></a>00171 
<a name="l00172"></a>00172   node_stream.close();
<a name="l00173"></a>00173   ele_stream.close();
<a name="l00174"></a>00174 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
