<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_data_unv_support.C</h1>  </div>
</div>
<div class="contents">
<a href="mesh__data__unv__support_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_data_unv_support.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;cstdio&gt;</span> <span class="comment">// for std::sprintf</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;mesh_data.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;auto_ptr.h&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="preprocessor">#ifdef  LIBMESH_HAVE_GZSTREAM</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span><span class="preprocessor"># include &quot;gzstream.h&quot;</span> <span class="comment">// For reading/writing compressed streams</span>
<a name="l00033"></a>00033 <span class="preprocessor">#endif</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">//------------------------------------------------------</span>
<a name="l00037"></a>00037 <span class="comment">// MeshData UNV support functions</span>
<a name="l00038"></a><a class="code" href="classMeshData.php#a7d7ab5ce4ca10e2ac03cf02f3b12fab0">00038</a> <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#a7d7ab5ce4ca10e2ac03cf02f3b12fab0">MeshData::read_unv</a> (<span class="keyword">const</span> std::string&amp; file_name)
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040   <span class="comment">/*</span>
<a name="l00041"></a>00041 <span class="comment">   * we should better be active or in compatibility mode</span>
<a name="l00042"></a>00042 <span class="comment">   */</span>
<a name="l00043"></a>00043   libmesh_assert (this-&gt;<a class="code" href="classMeshData.php#ac67bdab9e104987a755c123ddbc899a3">_active</a> || this-&gt;<a class="code" href="classMeshData.php#ab3fcaff9ed092e581d667fd04dacbd39">_compatibility_mode</a>);
<a name="l00044"></a>00044 
<a name="l00045"></a>00045   <span class="comment">/*</span>
<a name="l00046"></a>00046 <span class="comment">   * When reading data, make sure the id maps are ok</span>
<a name="l00047"></a>00047 <span class="comment">   */</span>
<a name="l00048"></a>00048   libmesh_assert (this-&gt;<a class="code" href="classMeshData.php#a071ea01303d43241271f23704718897e">_node_id_map_closed</a>);
<a name="l00049"></a>00049   libmesh_assert (this-&gt;<a class="code" href="classMeshData.php#a52728bfcb6ea3691546bfa90770bb632">_elem_id_map_closed</a>);
<a name="l00050"></a>00050 
<a name="l00051"></a>00051   <span class="comment">/*</span>
<a name="l00052"></a>00052 <span class="comment">   * clear the data, but keep the id maps</span>
<a name="l00053"></a>00053 <span class="comment">   */</span>
<a name="l00054"></a>00054   this-&gt;<a class="code" href="classMeshData.php#a441899feec76257ac227a6786fe9aea9">clear</a>();
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   <span class="comment">/*</span>
<a name="l00057"></a>00057 <span class="comment">   * We can read either &quot;.unv&quot;, or &quot;.unv.gz&quot;</span>
<a name="l00058"></a>00058 <span class="comment">   * files, provided zlib.h is there</span>
<a name="l00059"></a>00059 <span class="comment">   */</span>
<a name="l00060"></a>00060   <span class="keywordflow">if</span> (file_name.rfind(<span class="stringliteral">&quot;.gz&quot;</span>) &lt; file_name.size())
<a name="l00061"></a>00061     {
<a name="l00062"></a>00062 <span class="preprocessor">#ifdef LIBMESH_HAVE_GZSTREAM</span>
<a name="l00063"></a>00063 <span class="preprocessor"></span>      igzstream in_stream(file_name.c_str());
<a name="l00064"></a>00064       this-&gt;<a class="code" href="classMeshData.php#a1637423d1d17e4bd8308245b8d572db8">read_unv_implementation</a> (in_stream);
<a name="l00065"></a>00065 <span class="preprocessor">#else</span>
<a name="l00066"></a>00066 <span class="preprocessor"></span>      std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR:  You must have the zlib.h header &quot;</span>
<a name="l00067"></a>00067                 &lt;&lt; <span class="stringliteral">&quot;files and libraries to read and write &quot;</span>
<a name="l00068"></a>00068                 &lt;&lt; <span class="stringliteral">&quot;compressed streams.&quot;</span>
<a name="l00069"></a>00069                 &lt;&lt; std::endl;
<a name="l00070"></a>00070       libmesh_error();
<a name="l00071"></a>00071 <span class="preprocessor">#endif</span>
<a name="l00072"></a>00072 <span class="preprocessor"></span>      <span class="keywordflow">return</span>;
<a name="l00073"></a>00073     }
<a name="l00074"></a>00074   
<a name="l00075"></a>00075   <span class="keywordflow">else</span>
<a name="l00076"></a>00076     {
<a name="l00077"></a>00077       std::ifstream in_stream(file_name.c_str());
<a name="l00078"></a>00078       this-&gt;<a class="code" href="classMeshData.php#a1637423d1d17e4bd8308245b8d572db8">read_unv_implementation</a> (in_stream);
<a name="l00079"></a>00079       <span class="keywordflow">return</span>;
<a name="l00080"></a>00080     }
<a name="l00081"></a>00081 }
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
<a name="l00088"></a><a class="code" href="classMeshData.php#a1637423d1d17e4bd8308245b8d572db8">00088</a> <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#a1637423d1d17e4bd8308245b8d572db8">MeshData::read_unv_implementation</a> (std::istream&amp; in_file)
<a name="l00089"></a>00089 {
<a name="l00090"></a>00090   <span class="comment">/*</span>
<a name="l00091"></a>00091 <span class="comment">   * This is the actual implementation of</span>
<a name="l00092"></a>00092 <span class="comment">   * reading in UNV format.  This enables</span>
<a name="l00093"></a>00093 <span class="comment">   * to read either through the conventional</span>
<a name="l00094"></a>00094 <span class="comment">   * C++ stream, or through a stream that</span>
<a name="l00095"></a>00095 <span class="comment">   * allows to read .gz&#39;ed files.</span>
<a name="l00096"></a>00096 <span class="comment">   */</span>
<a name="l00097"></a>00097   <span class="keywordflow">if</span> ( !in_file.good() )
<a name="l00098"></a>00098     {
<a name="l00099"></a>00099       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Input file not good.&quot;</span> 
<a name="l00100"></a>00100                 &lt;&lt; std::endl;
<a name="l00101"></a>00101       libmesh_error();
<a name="l00102"></a>00102     }
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="keyword">const</span> std::string _label_dataset_mesh_data = <span class="stringliteral">&quot;2414&quot;</span>;
<a name="l00105"></a>00105 
<a name="l00106"></a>00106   <span class="comment">/*</span>
<a name="l00107"></a>00107 <span class="comment">   * locate the beginning of data set</span>
<a name="l00108"></a>00108 <span class="comment">   * and read it.</span>
<a name="l00109"></a>00109 <span class="comment">   */</span>
<a name="l00110"></a>00110   {
<a name="l00111"></a>00111     std::string olds, news;
<a name="l00112"></a>00112 
<a name="l00113"></a>00113     <span class="keywordflow">while</span> (<span class="keyword">true</span>)
<a name="l00114"></a>00114     {
<a name="l00115"></a>00115       in_file &gt;&gt; olds &gt;&gt; news;
<a name="l00116"></a>00116 
<a name="l00117"></a>00117       <span class="comment">/*</span>
<a name="l00118"></a>00118 <span class="comment">       * Yes, really dirty:</span>
<a name="l00119"></a>00119 <span class="comment">       *</span>
<a name="l00120"></a>00120 <span class="comment">       * When we found a dataset, and the user does</span>
<a name="l00121"></a>00121 <span class="comment">       * not want this dataset, we jump back here</span>
<a name="l00122"></a>00122 <span class="comment">       */</span>
<a name="l00123"></a>00123     go_and_find_the_next_dataset:
<a name="l00124"></a>00124 
<a name="l00125"></a>00125       <span class="comment">/*</span>
<a name="l00126"></a>00126 <span class="comment">       * a &quot;-1&quot; followed by a number means the beginning of a dataset</span>
<a name="l00127"></a>00127 <span class="comment">       * stop combing at the end of the file</span>
<a name="l00128"></a>00128 <span class="comment">       */</span>
<a name="l00129"></a>00129       <span class="keywordflow">while</span>( ((olds != <span class="stringliteral">&quot;-1&quot;</span>) || (news == <span class="stringliteral">&quot;-1&quot;</span>) ) &amp;&amp; !in_file.eof() )
<a name="l00130"></a>00130         {
<a name="l00131"></a>00131           olds = news;
<a name="l00132"></a>00132           in_file &gt;&gt; news;
<a name="l00133"></a>00133         }
<a name="l00134"></a>00134 
<a name="l00135"></a>00135       <span class="keywordflow">if</span>(in_file.eof())
<a name="l00136"></a>00136         <span class="keywordflow">break</span>;
<a name="l00137"></a>00137 
<a name="l00138"></a>00138       <span class="comment">/*</span>
<a name="l00139"></a>00139 <span class="comment">       * if beginning of dataset</span>
<a name="l00140"></a>00140 <span class="comment">       */</span>
<a name="l00141"></a>00141       <span class="keywordflow">if</span> (news == _label_dataset_mesh_data)
<a name="l00142"></a>00142         {
<a name="l00143"></a>00143 
<a name="l00144"></a>00144           <span class="comment">/*</span>
<a name="l00145"></a>00145 <span class="comment">           * Now read the data of interest.</span>
<a name="l00146"></a>00146 <span class="comment">           * Start with the header.  For </span>
<a name="l00147"></a>00147 <span class="comment">           * explanation of the variable</span>
<a name="l00148"></a>00148 <span class="comment">           * dataset_location, see below.</span>
<a name="l00149"></a>00149 <span class="comment">           */</span>
<a name="l00150"></a>00150           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dataset_location;
<a name="l00151"></a>00151               
<a name="l00152"></a>00152           <span class="comment">/*</span>
<a name="l00153"></a>00153 <span class="comment">           * the type of data (complex, real,</span>
<a name="l00154"></a>00154 <span class="comment">           * float, double etc, see below)</span>
<a name="l00155"></a>00155 <span class="comment">           */</span>
<a name="l00156"></a>00156           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> data_type;
<a name="l00157"></a>00157 
<a name="l00158"></a>00158           <span class="comment">/*</span>
<a name="l00159"></a>00159 <span class="comment">           * the number of floating-point values per entity</span>
<a name="l00160"></a>00160 <span class="comment">           */</span>
<a name="l00161"></a>00161           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> NVALDC;
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 
<a name="l00164"></a>00164           <span class="comment">/*</span>
<a name="l00165"></a>00165 <span class="comment">           * If there is no MeshDataUnvHeader object</span>
<a name="l00166"></a>00166 <span class="comment">           * attached</span>
<a name="l00167"></a>00167 <span class="comment">           */</span>
<a name="l00168"></a>00168           <span class="keywordflow">if</span> (<a class="code" href="classMeshData.php#a1d269aa4356e77d4c74b7dc143b14045">_unv_header</a>==NULL)
<a name="l00169"></a>00169             {
<a name="l00170"></a>00170               <span class="comment">/*</span>
<a name="l00171"></a>00171 <span class="comment">               * Ignore the first lines that stand for</span>
<a name="l00172"></a>00172 <span class="comment">               * analysis dataset label and name.</span>
<a name="l00173"></a>00173 <span class="comment">               */</span> 
<a name="l00174"></a>00174               <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;3; i++)
<a name="l00175"></a>00175                 in_file.ignore(256,<span class="charliteral">&#39;\n&#39;</span>);             
<a name="l00176"></a>00176               
<a name="l00177"></a>00177               <span class="comment">/*</span>
<a name="l00178"></a>00178 <span class="comment">               * Read the dataset location, where</span>
<a name="l00179"></a>00179 <span class="comment">               * 1: Data at nodes</span>
<a name="l00180"></a>00180 <span class="comment">               * 2: Data on elements</span>
<a name="l00181"></a>00181 <span class="comment">               * other sets are currently not supported.</span>
<a name="l00182"></a>00182 <span class="comment">               */</span>
<a name="l00183"></a>00183               in_file &gt;&gt; dataset_location;
<a name="l00184"></a>00184 
<a name="l00185"></a>00185               <span class="comment">/*</span>
<a name="l00186"></a>00186 <span class="comment">               * Ignore five ID lines.</span>
<a name="l00187"></a>00187 <span class="comment">               */</span> 
<a name="l00188"></a>00188               <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;6; i++)
<a name="l00189"></a>00189                 in_file.ignore(256,<span class="charliteral">&#39;\n&#39;</span>);
<a name="l00190"></a>00190               
<a name="l00191"></a>00191               <span class="comment">/*</span>
<a name="l00192"></a>00192 <span class="comment">               * These data are all of no interest to us...</span>
<a name="l00193"></a>00193 <span class="comment">               */</span>
<a name="l00194"></a>00194               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> model_type,          
<a name="l00195"></a>00195                   analysis_type,
<a name="l00196"></a>00196                   data_characteristic,
<a name="l00197"></a>00197                   result_type;
<a name="l00198"></a>00198 
<a name="l00199"></a>00199               <span class="comment">/*</span>
<a name="l00200"></a>00200 <span class="comment">               * Read record 9.</span>
<a name="l00201"></a>00201 <span class="comment">               */</span>
<a name="l00202"></a>00202               in_file &gt;&gt; model_type           <span class="comment">// not used here</span>
<a name="l00203"></a>00203                       &gt;&gt; analysis_type        <span class="comment">// not used here</span>
<a name="l00204"></a>00204                       &gt;&gt; data_characteristic  <span class="comment">// not used here</span>
<a name="l00205"></a>00205                       &gt;&gt; result_type          <span class="comment">// not used here</span>
<a name="l00206"></a>00206                       &gt;&gt; data_type
<a name="l00207"></a>00207                       &gt;&gt; NVALDC;
<a name="l00208"></a>00208               
<a name="l00209"></a>00209               
<a name="l00210"></a>00210               <span class="comment">/*</span>
<a name="l00211"></a>00211 <span class="comment">               * Ignore record 10 and 11</span>
<a name="l00212"></a>00212 <span class="comment">               * (Integer analysis type specific data).</span>
<a name="l00213"></a>00213 <span class="comment">               */</span> 
<a name="l00214"></a>00214               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;3; i++)
<a name="l00215"></a>00215                 in_file.ignore(256,<span class="charliteral">&#39;\n&#39;</span>);
<a name="l00216"></a>00216               
<a name="l00217"></a>00217               <span class="comment">/*</span>
<a name="l00218"></a>00218 <span class="comment">               * Ignore record 12 and record 13.  Since there</span>
<a name="l00219"></a>00219 <span class="comment">               * exist UNV files with &#39;D&#39; instead of &#39;e&#39; as </span>
<a name="l00220"></a>00220 <span class="comment">               * 10th-power char, it is safer to use a string</span>
<a name="l00221"></a>00221 <span class="comment">               * to read the dummy reals.</span>
<a name="l00222"></a>00222 <span class="comment">               */</span>
<a name="l00223"></a>00223               {
<a name="l00224"></a>00224                 std::string dummy_Real;
<a name="l00225"></a>00225                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;12; i++)
<a name="l00226"></a>00226                     in_file &gt;&gt; dummy_Real;
<a name="l00227"></a>00227               }
<a name="l00228"></a>00228 
<a name="l00229"></a>00229             }
<a name="l00230"></a>00230           <span class="keywordflow">else</span>
<a name="l00231"></a>00231             {
<a name="l00232"></a>00232 
<a name="l00233"></a>00233               <span class="comment">/*</span>
<a name="l00234"></a>00234 <span class="comment">               * the read() method returns false when</span>
<a name="l00235"></a>00235 <span class="comment">               * the user wanted a special header, and</span>
<a name="l00236"></a>00236 <span class="comment">               * when the current header is _not_ the correct</span>
<a name="l00237"></a>00237 <span class="comment">               * header</span>
<a name="l00238"></a>00238 <span class="comment">               */</span>
<a name="l00239"></a>00239               <span class="keywordflow">if</span> (<a class="code" href="classMeshData.php#a1d269aa4356e77d4c74b7dc143b14045">_unv_header</a>-&gt;<a class="code" href="classMeshDataUnvHeader.php#ae87923195e561e714fe2069b031be06a">read</a>(in_file))
<a name="l00240"></a>00240                 {
<a name="l00241"></a>00241                   dataset_location = <a class="code" href="classMeshData.php#a1d269aa4356e77d4c74b7dc143b14045">_unv_header</a>-&gt;<a class="code" href="classMeshDataUnvHeader.php#a93a7085fec9bdafb843bfb56a7bd0a50">dataset_location</a>;
<a name="l00242"></a>00242                   NVALDC = <a class="code" href="classMeshData.php#a1d269aa4356e77d4c74b7dc143b14045">_unv_header</a>-&gt;<a class="code" href="classMeshDataUnvHeader.php#a345c5391a7100d467f347942498f172b">nvaldc</a>;
<a name="l00243"></a>00243                   data_type = <a class="code" href="classMeshData.php#a1d269aa4356e77d4c74b7dc143b14045">_unv_header</a>-&gt;<a class="code" href="classMeshDataUnvHeader.php#ae8194a3ba8d6615dabebedd252332b4c">data_type</a>;
<a name="l00244"></a>00244                 }
<a name="l00245"></a>00245               <span class="keywordflow">else</span>
<a name="l00246"></a>00246                 {
<a name="l00247"></a>00247                   <span class="comment">/*</span>
<a name="l00248"></a>00248 <span class="comment">                   * This is not the correct header.  Go</span>
<a name="l00249"></a>00249 <span class="comment">                   * and find the next.  For this to</span>
<a name="l00250"></a>00250 <span class="comment">                   * work correctly, shift to the </span>
<a name="l00251"></a>00251 <span class="comment">                   * next line, so that the &quot;-1&quot;</span>
<a name="l00252"></a>00252 <span class="comment">                   * disappears from olds </span>
<a name="l00253"></a>00253 <span class="comment">                   */</span>
<a name="l00254"></a>00254                   olds = news;
<a name="l00255"></a>00255                   in_file &gt;&gt; news;
<a name="l00256"></a>00256 
<a name="l00257"></a>00257                   <span class="comment">/*</span>
<a name="l00258"></a>00258 <span class="comment">                   * No good style, i know...</span>
<a name="l00259"></a>00259 <span class="comment">                   */</span>
<a name="l00260"></a>00260                   <span class="keywordflow">goto</span> go_and_find_the_next_dataset;
<a name="l00261"></a>00261                 }
<a name="l00262"></a>00262 
<a name="l00263"></a>00263             }
<a name="l00264"></a>00264 
<a name="l00265"></a>00265           <span class="comment">/*</span>
<a name="l00266"></a>00266 <span class="comment">           * Check the location of the dataset.</span>
<a name="l00267"></a>00267 <span class="comment">           */</span>
<a name="l00268"></a>00268           <span class="keywordflow">if</span> (dataset_location != 1)
<a name="l00269"></a>00269             {
<a name="l00270"></a>00270               std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Currently only Data at nodes is supported.&quot;</span> 
<a name="l00271"></a>00271                         &lt;&lt; std::endl;
<a name="l00272"></a>00272               libmesh_error();
<a name="l00273"></a>00273             }
<a name="l00274"></a>00274 
<a name="l00275"></a>00275 
<a name="l00276"></a>00276           <span class="comment">/*</span>
<a name="l00277"></a>00277 <span class="comment">           * Now get the foreign node id number and the respective nodal data.</span>
<a name="l00278"></a>00278 <span class="comment">           */</span>
<a name="l00279"></a>00279           <span class="keywordtype">int</span> f_n_id;
<a name="l00280"></a>00280           std::vector&lt;Number&gt; values;
<a name="l00281"></a>00281 
<a name="l00282"></a>00282           <span class="keywordflow">while</span>(<span class="keyword">true</span>)
<a name="l00283"></a>00283             {
<a name="l00284"></a>00284               in_file &gt;&gt; f_n_id;
<a name="l00285"></a>00285           
<a name="l00286"></a>00286               <span class="comment">/*</span>
<a name="l00287"></a>00287 <span class="comment">               * if node_nr = -1 then we have reached the end of the dataset.</span>
<a name="l00288"></a>00288 <span class="comment">               */</span>
<a name="l00289"></a>00289               <span class="keywordflow">if</span> (f_n_id==-1)
<a name="l00290"></a>00290                   <span class="keywordflow">break</span>;
<a name="l00291"></a>00291 
<a name="l00292"></a>00292               <span class="comment">/*</span>
<a name="l00293"></a>00293 <span class="comment">               * Resize the values vector (usually data in three</span>
<a name="l00294"></a>00294 <span class="comment">               * principle directions, i.e. NVALDC = 3).</span>
<a name="l00295"></a>00295 <span class="comment">               */</span>
<a name="l00296"></a>00296               values.resize(NVALDC);
<a name="l00297"></a>00297           
<a name="l00298"></a>00298               <span class="comment">/*</span>
<a name="l00299"></a>00299 <span class="comment">               * Read the meshdata for the respective node.</span>
<a name="l00300"></a>00300 <span class="comment">               */</span>              
<a name="l00301"></a>00301               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> data_cnt=0; data_cnt&lt;NVALDC; data_cnt++)
<a name="l00302"></a>00302                 {
<a name="l00303"></a>00303                   <span class="comment">/*</span>
<a name="l00304"></a>00304 <span class="comment">                   * Check what data type we are reading.</span>
<a name="l00305"></a>00305 <span class="comment">                   * 2,4: Real</span>
<a name="l00306"></a>00306 <span class="comment">                   * 5,6: Complex</span>
<a name="l00307"></a>00307 <span class="comment">                   * other data types are not supported yet.</span>
<a name="l00308"></a>00308 <span class="comment">                   * As again, these floats may also be written</span>
<a name="l00309"></a>00309 <span class="comment">                   * using a &#39;D&#39; instead of an &#39;e&#39;.</span>
<a name="l00310"></a>00310 <span class="comment">                   */</span>
<a name="l00311"></a>00311                   <span class="keywordflow">if</span> (data_type == 2 || data_type == 4)
<a name="l00312"></a>00312                     {
<a name="l00313"></a>00313                       std::string buf;
<a name="l00314"></a>00314                       in_file &gt;&gt; buf;
<a name="l00315"></a>00315                       <a class="code" href="classMeshDataUnvHeader.php#aaa25878234cc9797f88a24529903f28b">MeshDataUnvHeader::need_D_to_e</a>(buf);
<a name="l00316"></a>00316 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00317"></a>00317 <span class="preprocessor"></span>                      values[data_cnt] = <a class="code" href="libmesh__common_8h.php#a400479783e355a94cc961fb30b81b31f">Complex</a>(std::atof(buf.c_str()), 0.);
<a name="l00318"></a>00318 <span class="preprocessor">#else</span>
<a name="l00319"></a>00319 <span class="preprocessor"></span>                      values[data_cnt] = std::atof(buf.c_str());
<a name="l00320"></a>00320 <span class="preprocessor">#endif</span>
<a name="l00321"></a>00321 <span class="preprocessor"></span>                    }
<a name="l00322"></a>00322 
<a name="l00323"></a>00323                   <span class="keywordflow">else</span> <span class="keywordflow">if</span>(data_type == 5 || data_type == 6)
<a name="l00324"></a>00324 
<a name="l00325"></a>00325                     {
<a name="l00326"></a>00326 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00327"></a>00327 <span class="preprocessor"></span>                      <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> re_val, im_val;
<a name="l00328"></a>00328 
<a name="l00329"></a>00329                       std::string buf;
<a name="l00330"></a>00330                       in_file &gt;&gt; buf;
<a name="l00331"></a>00331 
<a name="l00332"></a>00332                       <span class="keywordflow">if</span> (<a class="code" href="classMeshDataUnvHeader.php#aaa25878234cc9797f88a24529903f28b">MeshDataUnvHeader::need_D_to_e</a>(buf))
<a name="l00333"></a>00333                         {
<a name="l00334"></a>00334                           re_val = std::atof(buf.c_str());
<a name="l00335"></a>00335                           in_file &gt;&gt; buf;
<a name="l00336"></a>00336                           <a class="code" href="classMeshDataUnvHeader.php#aaa25878234cc9797f88a24529903f28b">MeshDataUnvHeader::need_D_to_e</a>(buf);
<a name="l00337"></a>00337                           im_val = std::atof(buf.c_str()); 
<a name="l00338"></a>00338                         }
<a name="l00339"></a>00339                       <span class="keywordflow">else</span>
<a name="l00340"></a>00340                         {
<a name="l00341"></a>00341                           re_val = std::atof(buf.c_str());
<a name="l00342"></a>00342                           in_file &gt;&gt; im_val;
<a name="l00343"></a>00343                         }
<a name="l00344"></a>00344 
<a name="l00345"></a>00345                       values[data_cnt] = <a class="code" href="libmesh__common_8h.php#a400479783e355a94cc961fb30b81b31f">Complex</a>(re_val,im_val);
<a name="l00346"></a>00346 <span class="preprocessor">#else</span>
<a name="l00347"></a>00347 <span class="preprocessor"></span>
<a name="l00348"></a>00348                       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Complex data only supported&quot;</span> &lt;&lt; std::endl
<a name="l00349"></a>00349                                 &lt;&lt; <span class="stringliteral">&quot;when libMesh is configured with --enable-complex!&quot;</span>
<a name="l00350"></a>00350                                 &lt;&lt; std::endl;
<a name="l00351"></a>00351                       libmesh_error();
<a name="l00352"></a>00352 <span class="preprocessor">#endif</span>
<a name="l00353"></a>00353 <span class="preprocessor"></span>                    }
<a name="l00354"></a>00354 
<a name="l00355"></a>00355                   <span class="keywordflow">else</span>
<a name="l00356"></a>00356                     {
<a name="l00357"></a>00357                       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Data type not supported.&quot;</span> 
<a name="l00358"></a>00358                                 &lt;&lt; std::endl;
<a name="l00359"></a>00359                       libmesh_error();
<a name="l00360"></a>00360                     }
<a name="l00361"></a>00361 
<a name="l00362"></a>00362                 } <span class="comment">// end loop data_cnt</span>
<a name="l00363"></a>00363 
<a name="l00364"></a>00364               <span class="comment">/*</span>
<a name="l00365"></a>00365 <span class="comment">               * Add the values vector to the MeshData data structure.</span>
<a name="l00366"></a>00366 <span class="comment">               */</span>
<a name="l00367"></a>00367               <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node = <a class="code" href="classMeshData.php#a6cb6c156374dc82815b2f654eab9fdf7">foreign_id_to_node</a>(f_n_id);
<a name="l00368"></a>00368               <a class="code" href="classMeshData.php#a0773ff071287f33580af5832a70f8d0f">_node_data</a>.insert (std::make_pair(node, values));
<a name="l00369"></a>00369 
<a name="l00370"></a>00370             } <span class="comment">// while(true)</span>
<a name="l00371"></a>00371         }
<a name="l00372"></a>00372 
<a name="l00373"></a>00373 
<a name="l00374"></a>00374       <span class="keywordflow">else</span>
<a name="l00375"></a>00375         {
<a name="l00376"></a>00376           <span class="comment">/*</span>
<a name="l00377"></a>00377 <span class="comment">           * all other datasets are ignored</span>
<a name="l00378"></a>00378 <span class="comment">           */</span>
<a name="l00379"></a>00379         }
<a name="l00380"></a>00380 
<a name="l00381"></a>00381     }
<a name="l00382"></a>00382   }
<a name="l00383"></a>00383 
<a name="l00384"></a>00384 
<a name="l00385"></a>00385   <span class="comment">/*</span>
<a name="l00386"></a>00386 <span class="comment">   * finished reading.  Ready for use, provided</span>
<a name="l00387"></a>00387 <span class="comment">   * there was any data contained in the file.</span>
<a name="l00388"></a>00388 <span class="comment">   */</span>
<a name="l00389"></a>00389   libmesh_assert ((this-&gt;<a class="code" href="classMeshData.php#a0773ff071287f33580af5832a70f8d0f">_node_data</a>.size() != 0) || (this-&gt;<a class="code" href="classMeshData.php#a7d1d25eef77c023adc84c6010925036d">_elem_data</a>.size() != 0));
<a name="l00390"></a>00390 
<a name="l00391"></a>00391   this-&gt;<a class="code" href="classMeshData.php#a5718ca825e3b14e2e8947a3bac15d117">_node_data_closed</a> = <span class="keyword">true</span>;
<a name="l00392"></a>00392   this-&gt;<a class="code" href="classMeshData.php#aff2e62e6f1deb12255382c34dfca51d3">_elem_data_closed</a> = <span class="keyword">true</span>;
<a name="l00393"></a>00393 }
<a name="l00394"></a>00394 
<a name="l00395"></a>00395 
<a name="l00396"></a>00396 
<a name="l00397"></a>00397 
<a name="l00398"></a>00398 
<a name="l00399"></a>00399 
<a name="l00400"></a><a class="code" href="classMeshData.php#ab89d18becb28d7f267224ce4a773d40f">00400</a> <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#ab89d18becb28d7f267224ce4a773d40f">MeshData::write_unv</a> (<span class="keyword">const</span> std::string&amp; file_name)
<a name="l00401"></a>00401 {
<a name="l00402"></a>00402   <span class="comment">/*</span>
<a name="l00403"></a>00403 <span class="comment">   * we should better be active or in compatibility mode</span>
<a name="l00404"></a>00404 <span class="comment">   */</span>
<a name="l00405"></a>00405   libmesh_assert (this-&gt;<a class="code" href="classMeshData.php#ac67bdab9e104987a755c123ddbc899a3">_active</a> || this-&gt;<a class="code" href="classMeshData.php#ab3fcaff9ed092e581d667fd04dacbd39">_compatibility_mode</a>);
<a name="l00406"></a>00406 
<a name="l00407"></a>00407   <span class="comment">/*</span>
<a name="l00408"></a>00408 <span class="comment">   * make sure the id maps are ready</span>
<a name="l00409"></a>00409 <span class="comment">   * and that we have data to write</span>
<a name="l00410"></a>00410 <span class="comment">   */</span>
<a name="l00411"></a>00411   libmesh_assert (this-&gt;<a class="code" href="classMeshData.php#a071ea01303d43241271f23704718897e">_node_id_map_closed</a>);
<a name="l00412"></a>00412   libmesh_assert (this-&gt;<a class="code" href="classMeshData.php#a52728bfcb6ea3691546bfa90770bb632">_elem_id_map_closed</a>);
<a name="l00413"></a>00413 
<a name="l00414"></a>00414   libmesh_assert (this-&gt;<a class="code" href="classMeshData.php#a5718ca825e3b14e2e8947a3bac15d117">_node_data_closed</a>);
<a name="l00415"></a>00415   libmesh_assert (this-&gt;<a class="code" href="classMeshData.php#aff2e62e6f1deb12255382c34dfca51d3">_elem_data_closed</a>);
<a name="l00416"></a>00416 
<a name="l00417"></a>00417   <span class="keywordflow">if</span> (file_name.rfind(<span class="stringliteral">&quot;.gz&quot;</span>) &lt; file_name.size())
<a name="l00418"></a>00418     {
<a name="l00419"></a>00419 <span class="preprocessor">#ifdef LIBMESH_HAVE_GZSTREAM</span>
<a name="l00420"></a>00420 <span class="preprocessor"></span>      ogzstream out_stream(file_name.c_str());
<a name="l00421"></a>00421       this-&gt;<a class="code" href="classMeshData.php#a7626efe4d193f2f3806e393ed6578d47">write_unv_implementation</a> (out_stream);
<a name="l00422"></a>00422 <span class="preprocessor">#else</span>
<a name="l00423"></a>00423 <span class="preprocessor"></span>      std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR:  You must have the zlib.h header &quot;</span>
<a name="l00424"></a>00424                 &lt;&lt; <span class="stringliteral">&quot;files and libraries to read and write &quot;</span>
<a name="l00425"></a>00425                 &lt;&lt; <span class="stringliteral">&quot;compressed streams.&quot;</span>
<a name="l00426"></a>00426                 &lt;&lt; std::endl;
<a name="l00427"></a>00427       libmesh_error();
<a name="l00428"></a>00428 <span class="preprocessor">#endif</span>
<a name="l00429"></a>00429 <span class="preprocessor"></span>      <span class="keywordflow">return</span>;
<a name="l00430"></a>00430       
<a name="l00431"></a>00431     }
<a name="l00432"></a>00432   
<a name="l00433"></a>00433   <span class="keywordflow">else</span>
<a name="l00434"></a>00434     {
<a name="l00435"></a>00435       std::ofstream out_stream(file_name.c_str());
<a name="l00436"></a>00436       this-&gt;<a class="code" href="classMeshData.php#a7626efe4d193f2f3806e393ed6578d47">write_unv_implementation</a> (out_stream);
<a name="l00437"></a>00437       <span class="keywordflow">return</span>;
<a name="l00438"></a>00438     }
<a name="l00439"></a>00439 }
<a name="l00440"></a>00440 
<a name="l00441"></a>00441 
<a name="l00442"></a>00442 
<a name="l00443"></a>00443 
<a name="l00444"></a>00444 
<a name="l00445"></a>00445 
<a name="l00446"></a><a class="code" href="classMeshData.php#a7626efe4d193f2f3806e393ed6578d47">00446</a> <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#a7626efe4d193f2f3806e393ed6578d47">MeshData::write_unv_implementation</a> (std::ostream&amp; out_file)
<a name="l00447"></a>00447 {
<a name="l00448"></a>00448   <span class="comment">/*</span>
<a name="l00449"></a>00449 <span class="comment">   * This is the actual implementation of writing</span>
<a name="l00450"></a>00450 <span class="comment">   * unv files, either as .unv or as .unv.gz file</span>
<a name="l00451"></a>00451 <span class="comment">   */</span>
<a name="l00452"></a>00452   <span class="keywordflow">if</span> ( !out_file.good() )
<a name="l00453"></a>00453     {
<a name="l00454"></a>00454       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Output file not good.&quot;</span> 
<a name="l00455"></a>00455                 &lt;&lt; std::endl;
<a name="l00456"></a>00456       libmesh_error();
<a name="l00457"></a>00457     }
<a name="l00458"></a>00458 
<a name="l00459"></a>00459 
<a name="l00460"></a>00460   <span class="comment">/*</span>
<a name="l00461"></a>00461 <span class="comment">   * the beginning marker of the dataset block for</span>
<a name="l00462"></a>00462 <span class="comment">   * nodal/element-associated data (not to be confused</span>
<a name="l00463"></a>00463 <span class="comment">   * with _desired_dataset_label!)</span>
<a name="l00464"></a>00464 <span class="comment">   */</span>
<a name="l00465"></a>00465   <span class="keyword">const</span> std::string  _label_dataset_mesh_data    = <span class="stringliteral">&quot;2414&quot;</span>;
<a name="l00466"></a>00466 
<a name="l00467"></a>00467   <span class="comment">/*</span>
<a name="l00468"></a>00468 <span class="comment">   * Currently this function handles only nodal data.</span>
<a name="l00469"></a>00469 <span class="comment">   */</span>
<a name="l00470"></a>00470   libmesh_assert (!<a class="code" href="classMeshData.php#a0773ff071287f33580af5832a70f8d0f">_node_data</a>.empty());
<a name="l00471"></a>00471 
<a name="l00472"></a>00472   <span class="keywordflow">if</span> (!<a class="code" href="classMeshData.php#a7d1d25eef77c023adc84c6010925036d">_elem_data</a>.empty())
<a name="l00473"></a>00473       std::cerr &lt;&lt; <span class="stringliteral">&quot;WARNING: MeshData currently only supports nodal data for Universal files.&quot;</span>
<a name="l00474"></a>00474                 &lt;&lt; std::endl
<a name="l00475"></a>00475                 &lt;&lt; <span class="stringliteral">&quot;         Will proceed writing only nodal data, ignoring element data.&quot;</span>
<a name="l00476"></a>00476                 &lt;&lt; std::endl;
<a name="l00477"></a>00477 
<a name="l00478"></a>00478 
<a name="l00479"></a>00479   <span class="comment">/*</span>
<a name="l00480"></a>00480 <span class="comment">   * Write the beginning of the dataset.</span>
<a name="l00481"></a>00481 <span class="comment">   */</span>
<a name="l00482"></a>00482   out_file &lt;&lt; <span class="stringliteral">&quot;    -1\n&quot;</span>
<a name="l00483"></a>00483            &lt;&lt; <span class="stringliteral">&quot;  &quot;</span> 
<a name="l00484"></a>00484            &lt;&lt; _label_dataset_mesh_data
<a name="l00485"></a>00485            &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00486"></a>00486 
<a name="l00487"></a>00487   <span class="comment">/*</span>
<a name="l00488"></a>00488 <span class="comment">   * Write the header</span>
<a name="l00489"></a>00489 <span class="comment">   */</span>
<a name="l00490"></a>00490   <span class="keywordflow">if</span> (<a class="code" href="classMeshData.php#a1d269aa4356e77d4c74b7dc143b14045">_unv_header</a>==NULL)
<a name="l00491"></a>00491     {
<a name="l00492"></a>00492       <span class="comment">/*</span>
<a name="l00493"></a>00493 <span class="comment">       * create a header that holds at</span>
<a name="l00494"></a>00494 <span class="comment">       * least sufficient data to specify</span>
<a name="l00495"></a>00495 <span class="comment">       * what this data set currently holds.</span>
<a name="l00496"></a>00496 <span class="comment">       * </span>
<a name="l00497"></a>00497 <span class="comment">       * The empty constructor automatically</span>
<a name="l00498"></a>00498 <span class="comment">       * takes care of \p dataset_location</span>
<a name="l00499"></a>00499 <span class="comment">       * and \p data_type.</span>
<a name="l00500"></a>00500 <span class="comment">       */</span>
<a name="l00501"></a>00501       <a class="code" href="classMeshDataUnvHeader.php">MeshDataUnvHeader</a> my_header;
<a name="l00502"></a>00502       
<a name="l00503"></a>00503       <span class="comment">/*</span>
<a name="l00504"></a>00504 <span class="comment">       * It remains to set the correct nvaldc...</span>
<a name="l00505"></a>00505 <span class="comment">       */</span>
<a name="l00506"></a>00506       my_header.<a class="code" href="classMeshDataUnvHeader.php#a345c5391a7100d467f347942498f172b">nvaldc</a> = this-&gt;<a class="code" href="classMeshData.php#ae472897b59f5f1d364d0bb34916951cb">n_val_per_node</a>();
<a name="l00507"></a>00507       
<a name="l00508"></a>00508       <span class="comment">/*</span>
<a name="l00509"></a>00509 <span class="comment">       * and the correct data type.  By default</span>
<a name="l00510"></a>00510 <span class="comment">       * only distinguish complex or real data.</span>
<a name="l00511"></a>00511 <span class="comment">       */</span>
<a name="l00512"></a>00512 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00513"></a>00513 <span class="preprocessor"></span>      my_header.<a class="code" href="classMeshDataUnvHeader.php#ae8194a3ba8d6615dabebedd252332b4c">data_type</a> = 5;
<a name="l00514"></a>00514 <span class="preprocessor">#else</span>
<a name="l00515"></a>00515 <span class="preprocessor"></span>      my_header.<a class="code" href="classMeshDataUnvHeader.php#ae8194a3ba8d6615dabebedd252332b4c">data_type</a> = 2;
<a name="l00516"></a>00516 <span class="preprocessor">#endif</span>
<a name="l00517"></a>00517 <span class="preprocessor"></span>
<a name="l00518"></a>00518       <span class="comment">/*</span>
<a name="l00519"></a>00519 <span class="comment">       * write this default header, then let</span>
<a name="l00520"></a>00520 <span class="comment">       * the AutoPtr go out of scope.  This </span>
<a name="l00521"></a>00521 <span class="comment">       * will take care of memory management.</span>
<a name="l00522"></a>00522 <span class="comment">       */</span>
<a name="l00523"></a>00523       my_header.<a class="code" href="classMeshDataUnvHeader.php#aa9785b38766a9099661c4281db2d7fe7">write</a> (out_file);
<a name="l00524"></a>00524     }
<a name="l00525"></a>00525 
<a name="l00526"></a>00526   <span class="keywordflow">else</span>
<a name="l00527"></a>00527     {
<a name="l00528"></a>00528       <span class="comment">/*</span>
<a name="l00529"></a>00529 <span class="comment">       * make sure our nvaldc coincide.</span>
<a name="l00530"></a>00530 <span class="comment">       */</span>
<a name="l00531"></a>00531       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classMeshData.php#ae472897b59f5f1d364d0bb34916951cb">n_val_per_node</a>() != <a class="code" href="classMeshData.php#a1d269aa4356e77d4c74b7dc143b14045">_unv_header</a>-&gt;<a class="code" href="classMeshDataUnvHeader.php#a345c5391a7100d467f347942498f172b">nvaldc</a>)
<a name="l00532"></a>00532         {
<a name="l00533"></a>00533           std::cerr &lt;&lt; <span class="stringliteral">&quot;WARNING: nvaldc=&quot;</span> &lt;&lt; <a class="code" href="classMeshData.php#a1d269aa4356e77d4c74b7dc143b14045">_unv_header</a>-&gt;<a class="code" href="classMeshDataUnvHeader.php#a345c5391a7100d467f347942498f172b">nvaldc</a> 
<a name="l00534"></a>00534                     &lt;&lt; <span class="stringliteral">&quot; of attached MeshDataUnvHeader object not valid!&quot;</span> &lt;&lt; std::endl
<a name="l00535"></a>00535                     &lt;&lt; <span class="stringliteral">&quot;         re-set nvaldc to &quot;</span> &lt;&lt; this-&gt;<a class="code" href="classMeshData.php#ae472897b59f5f1d364d0bb34916951cb">n_val_per_node</a>() &lt;&lt; std::endl;
<a name="l00536"></a>00536           <a class="code" href="classMeshData.php#a1d269aa4356e77d4c74b7dc143b14045">_unv_header</a>-&gt;<a class="code" href="classMeshDataUnvHeader.php#a345c5391a7100d467f347942498f172b">nvaldc</a> = this-&gt;<a class="code" href="classMeshData.php#ae472897b59f5f1d364d0bb34916951cb">n_val_per_node</a>();
<a name="l00537"></a>00537         }
<a name="l00538"></a>00538 
<a name="l00539"></a>00539 
<a name="l00540"></a>00540       <span class="comment">/*</span>
<a name="l00541"></a>00541 <span class="comment">       * only issue a warning when data_type does</span>
<a name="l00542"></a>00542 <span class="comment">       * not coincide.  Perhaps user provided some</span>
<a name="l00543"></a>00543 <span class="comment">       * other header in order to convert complex</span>
<a name="l00544"></a>00544 <span class="comment">       * to real...</span>
<a name="l00545"></a>00545 <span class="comment">       */</span>
<a name="l00546"></a>00546 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00547"></a>00547 <span class="preprocessor"></span>      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_data_type = 5;
<a name="l00548"></a>00548 <span class="preprocessor">#else</span>
<a name="l00549"></a>00549 <span class="preprocessor"></span>      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_data_type = 2;
<a name="l00550"></a>00550 <span class="preprocessor">#endif</span>
<a name="l00551"></a>00551 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (my_data_type != <a class="code" href="classMeshData.php#a1d269aa4356e77d4c74b7dc143b14045">_unv_header</a>-&gt;<a class="code" href="classMeshDataUnvHeader.php#ae8194a3ba8d6615dabebedd252332b4c">data_type</a>)
<a name="l00552"></a>00552         {
<a name="l00553"></a>00553           std::cerr &lt;&lt; <span class="stringliteral">&quot;WARNING: data_type=&quot;</span> &lt;&lt; <a class="code" href="classMeshData.php#a1d269aa4356e77d4c74b7dc143b14045">_unv_header</a>-&gt;<a class="code" href="classMeshDataUnvHeader.php#ae8194a3ba8d6615dabebedd252332b4c">data_type</a> 
<a name="l00554"></a>00554                     &lt;&lt; <span class="stringliteral">&quot; of attached MeshDataUnvHeader differs from&quot;</span> &lt;&lt; std::endl
<a name="l00555"></a>00555                     &lt;&lt; <span class="stringliteral">&quot;         default value=&quot;</span> &lt;&lt; my_data_type
<a name="l00556"></a>00556                     &lt;&lt; <span class="stringliteral">&quot; Perhaps the user wanted this,&quot;</span> &lt;&lt; std::endl
<a name="l00557"></a>00557                     &lt;&lt; <span class="stringliteral">&quot;         so I use the value from the MeshDataUnvHeader.&quot;</span>
<a name="l00558"></a>00558                     &lt;&lt; std::endl;
<a name="l00559"></a>00559         }
<a name="l00560"></a>00560       <a class="code" href="classMeshData.php#a1d269aa4356e77d4c74b7dc143b14045">_unv_header</a>-&gt;<a class="code" href="classMeshDataUnvHeader.php#aa9785b38766a9099661c4281db2d7fe7">write</a> (out_file);
<a name="l00561"></a>00561     }
<a name="l00562"></a>00562 
<a name="l00563"></a>00563   
<a name="l00564"></a>00564   <span class="comment">/*</span>
<a name="l00565"></a>00565 <span class="comment">   * Write the foreign node number and the respective data.</span>
<a name="l00566"></a>00566 <span class="comment">   */</span>
<a name="l00567"></a>00567   std::map&lt;<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>*, 
<a name="l00568"></a>00568     std::vector&lt;Number&gt; &gt;::const_iterator nit = <a class="code" href="classMeshData.php#a0773ff071287f33580af5832a70f8d0f">_node_data</a>.begin();
<a name="l00569"></a>00569 
<a name="l00570"></a>00570   <span class="keywordtype">char</span> buf[27];
<a name="l00571"></a>00571   <span class="keywordflow">for</span> (; nit != <a class="code" href="classMeshData.php#a0773ff071287f33580af5832a70f8d0f">_node_data</a>.end(); ++nit)
<a name="l00572"></a>00572     {
<a name="l00573"></a>00573       <span class="keyword">const</span> Node* node = (*nit).first;
<a name="l00574"></a>00574 
<a name="l00575"></a>00575       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> f_n_id = <a class="code" href="classMeshData.php#a64280d5ec57b031bcba08f216af20973">node_to_foreign_id</a> (node);
<a name="l00576"></a>00576       std::sprintf(buf, <span class="stringliteral">&quot;%10i\n&quot;</span>, f_n_id);
<a name="l00577"></a>00577       out_file &lt;&lt; buf;
<a name="l00578"></a>00578 
<a name="l00579"></a>00579       <span class="comment">/* since we are iterating over our own map, this libmesh_assert</span>
<a name="l00580"></a>00580 <span class="comment">       * should never break...</span>
<a name="l00581"></a>00581 <span class="comment">       */</span>
<a name="l00582"></a>00582       libmesh_assert (this-&gt;<a class="code" href="classMeshData.php#a88fea2994fc1ac1295745fdb8bd685f5">has_data</a>(node));
<a name="l00583"></a>00583 
<a name="l00584"></a>00584       <span class="comment">// const reference to the nodal values</span>
<a name="l00585"></a>00585       <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; values = this-&gt;<a class="code" href="classMeshData.php#ab34864d2e1f83059bd781b0dd5f71fe0">get_data</a>(node);
<a name="l00586"></a>00586 
<a name="l00587"></a>00587       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v_cnt=0; v_cnt&lt;values.size(); v_cnt++)
<a name="l00588"></a>00588         {
<a name="l00589"></a>00589 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00590"></a>00590 <span class="preprocessor"></span>          std::sprintf(buf, <span class="stringliteral">&quot;%13.5E%13.5E&quot;</span>, values[v_cnt].real(),
<a name="l00591"></a>00591                                             values[v_cnt].imag());
<a name="l00592"></a>00592           out_file &lt;&lt; buf;
<a name="l00593"></a>00593 <span class="preprocessor">#else</span>
<a name="l00594"></a>00594 <span class="preprocessor"></span>          std::sprintf(buf, <span class="stringliteral">&quot;%13.5E&quot;</span>,
<a name="l00595"></a>00595                        static_cast&lt;double&gt;(values[v_cnt]));
<a name="l00596"></a>00596           out_file &lt;&lt; buf;
<a name="l00597"></a>00597 <span class="preprocessor">#endif</span>
<a name="l00598"></a>00598 <span class="preprocessor"></span>        }
<a name="l00599"></a>00599 
<a name="l00600"></a>00600       out_file &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00601"></a>00601 
<a name="l00602"></a>00602 
<a name="l00603"></a>00603     }
<a name="l00604"></a>00604 
<a name="l00605"></a>00605   <span class="comment">/*</span>
<a name="l00606"></a>00606 <span class="comment">   * Write end of the dataset.</span>
<a name="l00607"></a>00607 <span class="comment">   */</span>
<a name="l00608"></a>00608   out_file &lt;&lt; <span class="stringliteral">&quot;    -1\n&quot;</span>;
<a name="l00609"></a>00609 }
<a name="l00610"></a>00610 
<a name="l00611"></a>00611 
<a name="l00612"></a>00612 
<a name="l00613"></a>00613 
<a name="l00614"></a>00614 
<a name="l00615"></a>00615 <span class="comment">//------------------------------------------------------</span>
<a name="l00616"></a>00616 <span class="comment">// MeshDataUnvHeader functions</span>
<a name="l00617"></a><a class="code" href="classMeshDataUnvHeader.php#ae6080dd453e0a70326b72e6a1ca4083a">00617</a> <a class="code" href="classMeshDataUnvHeader.php#ae6080dd453e0a70326b72e6a1ca4083a">MeshDataUnvHeader::MeshDataUnvHeader</a>() :
<a name="l00618"></a>00618   dataset_label          (0),
<a name="l00619"></a>00619   dataset_name           (<span class="stringliteral">&quot;libMesh mesh data&quot;</span>),
<a name="l00620"></a>00620   dataset_location       (1),  <span class="comment">// default to nodal data</span>
<a name="l00621"></a>00621   model_type             (0),          
<a name="l00622"></a>00622   analysis_type          (0),
<a name="l00623"></a>00623   data_characteristic    (0),
<a name="l00624"></a>00624   result_type            (0),
<a name="l00625"></a>00625 #ifdef LIBMESH_USE_COMPLEX_NUMBERS
<a name="l00626"></a>00626   data_type              (5),  <span class="comment">// default to single precision complex</span>
<a name="l00627"></a>00627 #else
<a name="l00628"></a>00628   data_type              (2),  <span class="comment">// default to single precision real</span>
<a name="l00629"></a>00629 #endif
<a name="l00630"></a>00630   nvaldc                 (3),  <span class="comment">// default to 3 (principle directions)</span>
<a name="l00631"></a>00631   _desired_dataset_label (libMesh::<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a>)
<a name="l00632"></a>00632 {
<a name="l00633"></a>00633   <a class="code" href="classMeshDataUnvHeader.php#aefecee738a3f03db3d73ebe9f28f7f1c">id_lines_1_to_5</a>.resize(5);
<a name="l00634"></a>00634   std::fill (<a class="code" href="classMeshDataUnvHeader.php#aefecee738a3f03db3d73ebe9f28f7f1c">id_lines_1_to_5</a>.begin(), <a class="code" href="classMeshDataUnvHeader.php#aefecee738a3f03db3d73ebe9f28f7f1c">id_lines_1_to_5</a>.end(), std::string(<span class="stringliteral">&quot;libMesh default&quot;</span>));
<a name="l00635"></a>00635   <span class="comment">/*</span>
<a name="l00636"></a>00636 <span class="comment">   * resize analysis specific data.</span>
<a name="l00637"></a>00637 <span class="comment">   */</span>
<a name="l00638"></a>00638   <a class="code" href="classMeshDataUnvHeader.php#abe34ba27cef23f0fcb00e3d41cb38c86">record_10</a>.resize(8);
<a name="l00639"></a>00639   <a class="code" href="classMeshDataUnvHeader.php#a21c07f5b394962c15d12b94f243cfbaa">record_11</a>.resize(2);
<a name="l00640"></a>00640   <a class="code" href="classMeshDataUnvHeader.php#a41b36862d87363c11aa05ec3eac1e57d">record_12</a>.resize(6);
<a name="l00641"></a>00641   <a class="code" href="classMeshDataUnvHeader.php#aa72672e176d3594183b3a490044dad2e">record_13</a>.resize(6);
<a name="l00642"></a>00642 }
<a name="l00643"></a>00643 
<a name="l00644"></a>00644 
<a name="l00645"></a>00645 
<a name="l00646"></a>00646 
<a name="l00647"></a>00647 
<a name="l00648"></a><a class="code" href="classMeshDataUnvHeader.php#a8fcf984cf95ec20ec82f18cd208d046e">00648</a> <a class="code" href="classMeshDataUnvHeader.php#a8fcf984cf95ec20ec82f18cd208d046e">MeshDataUnvHeader::~MeshDataUnvHeader</a>()
<a name="l00649"></a>00649 {
<a name="l00650"></a>00650   <span class="comment">// empty</span>
<a name="l00651"></a>00651 }
<a name="l00652"></a>00652 
<a name="l00653"></a>00653 
<a name="l00654"></a>00654 
<a name="l00655"></a>00655 
<a name="l00656"></a><a class="code" href="classMeshDataUnvHeader.php#ae87923195e561e714fe2069b031be06a">00656</a> <span class="keywordtype">bool</span> <a class="code" href="classMeshDataUnvHeader.php#ae87923195e561e714fe2069b031be06a">MeshDataUnvHeader::read</a> (std::istream&amp; in_file)
<a name="l00657"></a>00657 {
<a name="l00658"></a>00658   in_file &gt;&gt; this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a9432bcb223662f6f1b50c5ed01b05c14">dataset_label</a>;
<a name="l00659"></a>00659 
<a name="l00660"></a>00660   <span class="comment">/*</span>
<a name="l00661"></a>00661 <span class="comment">   * currently, we compare only the </span>
<a name="l00662"></a>00662 <span class="comment">   * dataset_label with the _desired_dataset_label,</span>
<a name="l00663"></a>00663 <span class="comment">   * but it may be easy to also compare the </span>
<a name="l00664"></a>00664 <span class="comment">   * dataset_name.</span>
<a name="l00665"></a>00665 <span class="comment">   *</span>
<a name="l00666"></a>00666 <span class="comment">   * When the user provided a dataset label, and</span>
<a name="l00667"></a>00667 <span class="comment">   * the current label does _not_ match, then just</span>
<a name="l00668"></a>00668 <span class="comment">   * return false.</span>
<a name="l00669"></a>00669 <span class="comment">   *</span>
<a name="l00670"></a>00670 <span class="comment">   * Otherwise: when the current label matches,</span>
<a name="l00671"></a>00671 <span class="comment">   * or when there is no desired dataset label,</span>
<a name="l00672"></a>00672 <span class="comment">   * simply proceed.</span>
<a name="l00673"></a>00673 <span class="comment">   */</span>
<a name="l00674"></a>00674   <span class="keywordflow">if</span> ((this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a1ce4684c8c1037ff8d1da8cbac058a70">_desired_dataset_label</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>) &amp;&amp;
<a name="l00675"></a>00675       (this-&gt;dataset_label != this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a1ce4684c8c1037ff8d1da8cbac058a70">_desired_dataset_label</a>))
<a name="l00676"></a>00676       <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00677"></a>00677 
<a name="l00678"></a>00678 
<a name="l00679"></a>00679   in_file.ignore(256,<span class="charliteral">&#39;\n&#39;</span>);
<a name="l00680"></a>00680   std::getline(in_file, <a class="code" href="classMeshDataUnvHeader.php#a37a86ee3e94d3e7a08667bfada510841">dataset_name</a>, <span class="charliteral">&#39;\n&#39;</span>);
<a name="l00681"></a>00681 
<a name="l00682"></a>00682   in_file &gt;&gt; this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a93a7085fec9bdafb843bfb56a7bd0a50">dataset_location</a>;
<a name="l00683"></a>00683   in_file.ignore(256,<span class="charliteral">&#39;\n&#39;</span>);
<a name="l00684"></a>00684 
<a name="l00685"></a>00685 
<a name="l00686"></a>00686   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;5; n++)
<a name="l00687"></a>00687       std::getline(in_file, this-&gt;<a class="code" href="classMeshDataUnvHeader.php#aefecee738a3f03db3d73ebe9f28f7f1c">id_lines_1_to_5</a>[n], <span class="charliteral">&#39;\n&#39;</span>);
<a name="l00688"></a>00688 
<a name="l00689"></a>00689 
<a name="l00690"></a>00690   in_file &gt;&gt; this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a3d3e4f97d1fbcba3be7115c59392b9ff">model_type</a>     
<a name="l00691"></a>00691           &gt;&gt; this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a63f46e0b3f6ce390fd8d0b802d5d4354">analysis_type</a>
<a name="l00692"></a>00692           &gt;&gt; this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a2d824a184d8c87338dd1df69b0319f56">data_characteristic</a>
<a name="l00693"></a>00693           &gt;&gt; this-&gt;<a class="code" href="classMeshDataUnvHeader.php#ae424259011b6063d66933b4316201cdb">result_type</a>
<a name="l00694"></a>00694           &gt;&gt; this-&gt;<a class="code" href="classMeshDataUnvHeader.php#ae8194a3ba8d6615dabebedd252332b4c">data_type</a>
<a name="l00695"></a>00695           &gt;&gt; this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a345c5391a7100d467f347942498f172b">nvaldc</a>;
<a name="l00696"></a>00696     
<a name="l00697"></a>00697   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;8; i++)
<a name="l00698"></a>00698     in_file &gt;&gt; this-&gt;<a class="code" href="classMeshDataUnvHeader.php#abe34ba27cef23f0fcb00e3d41cb38c86">record_10</a>[i];
<a name="l00699"></a>00699 
<a name="l00700"></a>00700   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;2; i++)
<a name="l00701"></a>00701     in_file &gt;&gt; this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a21c07f5b394962c15d12b94f243cfbaa">record_11</a>[i];
<a name="l00702"></a>00702 
<a name="l00703"></a>00703 
<a name="l00704"></a>00704   <span class="comment">/*</span>
<a name="l00705"></a>00705 <span class="comment">   * There are UNV-files where floats are </span>
<a name="l00706"></a>00706 <span class="comment">   * written with &#39;D&#39; as the 10th-power </span>
<a name="l00707"></a>00707 <span class="comment">   * character. Replace this &#39;D&#39; by &#39;e&#39;,</span>
<a name="l00708"></a>00708 <span class="comment">   * so that std::atof() can work fine.</span>
<a name="l00709"></a>00709 <span class="comment">   */</span>
<a name="l00710"></a>00710   std::string buf;
<a name="l00711"></a>00711   in_file &gt;&gt; buf;
<a name="l00712"></a>00712 
<a name="l00713"></a>00713   <span class="keywordflow">if</span> (<a class="code" href="classMeshDataUnvHeader.php#aaa25878234cc9797f88a24529903f28b">need_D_to_e</a>(buf))
<a name="l00714"></a>00714     {
<a name="l00715"></a>00715       <span class="comment">// have to convert _all_ &#39;D&#39; to &#39;e&#39;</span>
<a name="l00716"></a>00716       this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a41b36862d87363c11aa05ec3eac1e57d">record_12</a>[0] = std::atof(buf.c_str());
<a name="l00717"></a>00717 
<a name="l00718"></a>00718       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i&lt;6; i++)
<a name="l00719"></a>00719         {
<a name="l00720"></a>00720           in_file &gt;&gt; buf;
<a name="l00721"></a>00721           <a class="code" href="classMeshDataUnvHeader.php#aaa25878234cc9797f88a24529903f28b">need_D_to_e</a>(buf);
<a name="l00722"></a>00722           this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a41b36862d87363c11aa05ec3eac1e57d">record_12</a>[i] = std::atof(buf.c_str());
<a name="l00723"></a>00723         }
<a name="l00724"></a>00724 
<a name="l00725"></a>00725       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;6; i++)
<a name="l00726"></a>00726         {
<a name="l00727"></a>00727           in_file &gt;&gt; buf;
<a name="l00728"></a>00728           <a class="code" href="classMeshDataUnvHeader.php#aaa25878234cc9797f88a24529903f28b">need_D_to_e</a>(buf);
<a name="l00729"></a>00729           this-&gt;<a class="code" href="classMeshDataUnvHeader.php#aa72672e176d3594183b3a490044dad2e">record_13</a>[i] = std::atof(buf.c_str());
<a name="l00730"></a>00730         }
<a name="l00731"></a>00731     }
<a name="l00732"></a>00732   <span class="keywordflow">else</span>
<a name="l00733"></a>00733     {
<a name="l00734"></a>00734       <span class="comment">// no &#39;D&#39;, the stream will recognize the floats</span>
<a name="l00735"></a>00735       this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a41b36862d87363c11aa05ec3eac1e57d">record_12</a>[0] = std::atof(buf.c_str());
<a name="l00736"></a>00736 
<a name="l00737"></a>00737       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i&lt;6; i++)
<a name="l00738"></a>00738           in_file &gt;&gt; this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a41b36862d87363c11aa05ec3eac1e57d">record_12</a>[i];
<a name="l00739"></a>00739 
<a name="l00740"></a>00740       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;6; i++)
<a name="l00741"></a>00741           in_file &gt;&gt; this-&gt;<a class="code" href="classMeshDataUnvHeader.php#aa72672e176d3594183b3a490044dad2e">record_13</a>[i];
<a name="l00742"></a>00742     }
<a name="l00743"></a>00743 
<a name="l00744"></a>00744   <span class="comment">/*</span>
<a name="l00745"></a>00745 <span class="comment">   * no matter whether the user provided a desired</span>
<a name="l00746"></a>00746 <span class="comment">   * dataset label or not: return true, b/c the</span>
<a name="l00747"></a>00747 <span class="comment">   * non-match was already caught before.</span>
<a name="l00748"></a>00748 <span class="comment">   */</span>
<a name="l00749"></a>00749   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00750"></a>00750 }
<a name="l00751"></a>00751 
<a name="l00752"></a>00752 
<a name="l00753"></a>00753 
<a name="l00754"></a>00754 
<a name="l00755"></a><a class="code" href="classMeshDataUnvHeader.php#aa9785b38766a9099661c4281db2d7fe7">00755</a> <span class="keywordtype">void</span> <a class="code" href="classMeshDataUnvHeader.php#aa9785b38766a9099661c4281db2d7fe7">MeshDataUnvHeader::write</a> (std::ostream&amp; out_file)
<a name="l00756"></a>00756 {
<a name="l00757"></a>00757   
<a name="l00758"></a>00758   
<a name="l00759"></a>00759   <span class="keywordtype">char</span> buf[82];
<a name="l00760"></a>00760 
<a name="l00761"></a>00761   std::sprintf(buf, <span class="stringliteral">&quot;%6i\n&quot;</span>,this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a9432bcb223662f6f1b50c5ed01b05c14">dataset_label</a>);
<a name="l00762"></a>00762   
<a name="l00763"></a>00763   out_file &lt;&lt; buf;
<a name="l00764"></a>00764  
<a name="l00765"></a>00765   out_file &lt;&lt; this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a37a86ee3e94d3e7a08667bfada510841">dataset_name</a> &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00766"></a>00766 
<a name="l00767"></a>00767   std::sprintf(buf, <span class="stringliteral">&quot;%6i\n&quot;</span>,this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a93a7085fec9bdafb843bfb56a7bd0a50">dataset_location</a>);
<a name="l00768"></a>00768   
<a name="l00769"></a>00769   out_file &lt;&lt; buf;
<a name="l00770"></a>00770 
<a name="l00771"></a>00771   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;5; n++)
<a name="l00772"></a>00772     out_file &lt;&lt; this-&gt;<a class="code" href="classMeshDataUnvHeader.php#aefecee738a3f03db3d73ebe9f28f7f1c">id_lines_1_to_5</a>[n] &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00773"></a>00773 
<a name="l00774"></a>00774   std::sprintf(buf, <span class="stringliteral">&quot;%10i%10i%10i%10i%10i%10i\n&quot;</span>,
<a name="l00775"></a>00775                <a class="code" href="classMeshDataUnvHeader.php#a3d3e4f97d1fbcba3be7115c59392b9ff">model_type</a>,  <a class="code" href="classMeshDataUnvHeader.php#a63f46e0b3f6ce390fd8d0b802d5d4354">analysis_type</a>, <a class="code" href="classMeshDataUnvHeader.php#a2d824a184d8c87338dd1df69b0319f56">data_characteristic</a>,
<a name="l00776"></a>00776                <a class="code" href="classMeshDataUnvHeader.php#ae424259011b6063d66933b4316201cdb">result_type</a>, <a class="code" href="classMeshDataUnvHeader.php#ae8194a3ba8d6615dabebedd252332b4c">data_type</a>,     <a class="code" href="classMeshDataUnvHeader.php#a345c5391a7100d467f347942498f172b">nvaldc</a>);
<a name="l00777"></a>00777   
<a name="l00778"></a>00778   out_file &lt;&lt; buf;
<a name="l00779"></a>00779 
<a name="l00780"></a>00780   std::sprintf(buf, <span class="stringliteral">&quot;%10i%10i%10i%10i%10i%10i%10i%10i\n&quot;</span>,
<a name="l00781"></a>00781                <a class="code" href="classMeshDataUnvHeader.php#abe34ba27cef23f0fcb00e3d41cb38c86">record_10</a>[0], <a class="code" href="classMeshDataUnvHeader.php#abe34ba27cef23f0fcb00e3d41cb38c86">record_10</a>[1], <a class="code" href="classMeshDataUnvHeader.php#abe34ba27cef23f0fcb00e3d41cb38c86">record_10</a>[2], <a class="code" href="classMeshDataUnvHeader.php#abe34ba27cef23f0fcb00e3d41cb38c86">record_10</a>[3],
<a name="l00782"></a>00782                <a class="code" href="classMeshDataUnvHeader.php#abe34ba27cef23f0fcb00e3d41cb38c86">record_10</a>[4], <a class="code" href="classMeshDataUnvHeader.php#abe34ba27cef23f0fcb00e3d41cb38c86">record_10</a>[5], <a class="code" href="classMeshDataUnvHeader.php#abe34ba27cef23f0fcb00e3d41cb38c86">record_10</a>[6], <a class="code" href="classMeshDataUnvHeader.php#abe34ba27cef23f0fcb00e3d41cb38c86">record_10</a>[7]);
<a name="l00783"></a>00783   
<a name="l00784"></a>00784   out_file &lt;&lt; buf;
<a name="l00785"></a>00785 
<a name="l00786"></a>00786   std::sprintf(buf, <span class="stringliteral">&quot;%10i%10i\n&quot;</span>, <a class="code" href="classMeshDataUnvHeader.php#a21c07f5b394962c15d12b94f243cfbaa">record_11</a>[0], <a class="code" href="classMeshDataUnvHeader.php#a21c07f5b394962c15d12b94f243cfbaa">record_11</a>[1]);
<a name="l00787"></a>00787   out_file &lt;&lt; buf;
<a name="l00788"></a>00788 
<a name="l00789"></a>00789   std::sprintf(buf, <span class="stringliteral">&quot;%13.5E%13.5E%13.5E%13.5E%13.5E%13.5E\n&quot;</span>,
<a name="l00790"></a>00790                static_cast&lt;double&gt;(<a class="code" href="classMeshDataUnvHeader.php#a41b36862d87363c11aa05ec3eac1e57d">record_12</a>[0]),
<a name="l00791"></a>00791                static_cast&lt;double&gt;(<a class="code" href="classMeshDataUnvHeader.php#a41b36862d87363c11aa05ec3eac1e57d">record_12</a>[1]),
<a name="l00792"></a>00792                static_cast&lt;double&gt;(<a class="code" href="classMeshDataUnvHeader.php#a41b36862d87363c11aa05ec3eac1e57d">record_12</a>[2]),
<a name="l00793"></a>00793                static_cast&lt;double&gt;(<a class="code" href="classMeshDataUnvHeader.php#a41b36862d87363c11aa05ec3eac1e57d">record_12</a>[3]),
<a name="l00794"></a>00794                static_cast&lt;double&gt;(<a class="code" href="classMeshDataUnvHeader.php#a41b36862d87363c11aa05ec3eac1e57d">record_12</a>[4]),
<a name="l00795"></a>00795                static_cast&lt;double&gt;(<a class="code" href="classMeshDataUnvHeader.php#a41b36862d87363c11aa05ec3eac1e57d">record_12</a>[5]));
<a name="l00796"></a>00796   
<a name="l00797"></a>00797   out_file &lt;&lt; buf;
<a name="l00798"></a>00798 
<a name="l00799"></a>00799   std::sprintf(buf, <span class="stringliteral">&quot;%13.5E%13.5E%13.5E%13.5E%13.5E%13.5E\n&quot;</span>,
<a name="l00800"></a>00800                static_cast&lt;double&gt;(<a class="code" href="classMeshDataUnvHeader.php#aa72672e176d3594183b3a490044dad2e">record_13</a>[0]),
<a name="l00801"></a>00801                static_cast&lt;double&gt;(<a class="code" href="classMeshDataUnvHeader.php#aa72672e176d3594183b3a490044dad2e">record_13</a>[1]),
<a name="l00802"></a>00802                static_cast&lt;double&gt;(<a class="code" href="classMeshDataUnvHeader.php#aa72672e176d3594183b3a490044dad2e">record_13</a>[2]),
<a name="l00803"></a>00803                static_cast&lt;double&gt;(<a class="code" href="classMeshDataUnvHeader.php#aa72672e176d3594183b3a490044dad2e">record_13</a>[3]),
<a name="l00804"></a>00804                static_cast&lt;double&gt;(<a class="code" href="classMeshDataUnvHeader.php#aa72672e176d3594183b3a490044dad2e">record_13</a>[4]),
<a name="l00805"></a>00805                static_cast&lt;double&gt;(<a class="code" href="classMeshDataUnvHeader.php#aa72672e176d3594183b3a490044dad2e">record_13</a>[5]));
<a name="l00806"></a>00806   
<a name="l00807"></a>00807   out_file &lt;&lt; buf;
<a name="l00808"></a>00808 }
<a name="l00809"></a>00809 
<a name="l00810"></a>00810 
<a name="l00811"></a>00811 
<a name="l00812"></a>00812 
<a name="l00813"></a>00813 
<a name="l00814"></a><a class="code" href="classMeshDataUnvHeader.php#aaa25878234cc9797f88a24529903f28b">00814</a> <span class="keywordtype">bool</span> <a class="code" href="classMeshDataUnvHeader.php#aaa25878234cc9797f88a24529903f28b">MeshDataUnvHeader::need_D_to_e</a> (std::string&amp; number)
<a name="l00815"></a>00815 {
<a name="l00816"></a>00816   <span class="comment">// find &quot;D&quot; in string, start looking at 6th element, to improve speed.</span>
<a name="l00817"></a>00817   <span class="comment">// We dont expect a &quot;D&quot; earlier</span>
<a name="l00818"></a>00818 
<a name="l00819"></a>00819 <span class="comment">// #ifdef __HP_aCC</span>
<a name="l00820"></a>00820 <span class="comment">//   // Use an &quot;int&quot; instead of unsigned int,</span>
<a name="l00821"></a>00821 <span class="comment">//   // otherwise HP aCC may crash!</span>
<a name="l00822"></a>00822 <span class="comment">//   const int position = number.find(&quot;D&quot;,6);</span>
<a name="l00823"></a>00823 <span class="comment">// #else</span>
<a name="l00824"></a>00824 <span class="comment">//   const unsigned int position = number.find(&quot;D&quot;,6);</span>
<a name="l00825"></a>00825 <span class="comment">// #endif</span>
<a name="l00826"></a>00826   std::string::size_type position = number.find(<span class="stringliteral">&quot;D&quot;</span>,6);
<a name="l00827"></a>00827     
<a name="l00828"></a>00828   <span class="keywordflow">if</span>(position!=std::string::npos)     <span class="comment">// npos means no position</span>
<a name="l00829"></a>00829     {
<a name="l00830"></a>00830       <span class="comment">// replace &quot;D&quot; in string</span>
<a name="l00831"></a>00831       number.replace(position,1,<span class="stringliteral">&quot;e&quot;</span>); 
<a name="l00832"></a>00832       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00833"></a>00833     }
<a name="l00834"></a>00834   <span class="keywordflow">else</span>
<a name="l00835"></a>00835       <span class="comment">// we assume that if this one number is written correctly, all numbers are</span>
<a name="l00836"></a>00836       <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00837"></a>00837 }
<a name="l00838"></a>00838 
<a name="l00839"></a>00839 
<a name="l00840"></a>00840 
<a name="l00841"></a><a class="code" href="classMeshDataUnvHeader.php#a0dd7c74a222b3496b6a34247d124a1b1">00841</a> <span class="keywordtype">void</span> <a class="code" href="classMeshDataUnvHeader.php#a0dd7c74a222b3496b6a34247d124a1b1">MeshDataUnvHeader::which_dataset</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ds_label)
<a name="l00842"></a>00842 {
<a name="l00843"></a>00843   this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a1ce4684c8c1037ff8d1da8cbac058a70">_desired_dataset_label</a> = ds_label;
<a name="l00844"></a>00844 }
<a name="l00845"></a>00845 
<a name="l00846"></a>00846 
<a name="l00847"></a>00847 
<a name="l00848"></a><a class="code" href="classMeshDataUnvHeader.php#a785e8278b4c7076d37e663069a7c715e">00848</a> <span class="keywordtype">void</span> <a class="code" href="classMeshDataUnvHeader.php#a785e8278b4c7076d37e663069a7c715e">MeshDataUnvHeader::operator = </a>(<span class="keyword">const</span> <a class="code" href="classMeshDataUnvHeader.php">MeshDataUnvHeader</a>&amp; omduh)
<a name="l00849"></a>00849 {
<a name="l00850"></a>00850   this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a9432bcb223662f6f1b50c5ed01b05c14">dataset_label</a>          = omduh.<a class="code" href="classMeshDataUnvHeader.php#a9432bcb223662f6f1b50c5ed01b05c14">dataset_label</a>;
<a name="l00851"></a>00851   this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a37a86ee3e94d3e7a08667bfada510841">dataset_name</a>           = omduh.<a class="code" href="classMeshDataUnvHeader.php#a37a86ee3e94d3e7a08667bfada510841">dataset_name</a>;
<a name="l00852"></a>00852   this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a93a7085fec9bdafb843bfb56a7bd0a50">dataset_location</a>       = omduh.<a class="code" href="classMeshDataUnvHeader.php#a93a7085fec9bdafb843bfb56a7bd0a50">dataset_location</a>;
<a name="l00853"></a>00853   this-&gt;<a class="code" href="classMeshDataUnvHeader.php#aefecee738a3f03db3d73ebe9f28f7f1c">id_lines_1_to_5</a>        = omduh.<a class="code" href="classMeshDataUnvHeader.php#aefecee738a3f03db3d73ebe9f28f7f1c">id_lines_1_to_5</a>;
<a name="l00854"></a>00854 
<a name="l00855"></a>00855   this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a3d3e4f97d1fbcba3be7115c59392b9ff">model_type</a>             = omduh.<a class="code" href="classMeshDataUnvHeader.php#a3d3e4f97d1fbcba3be7115c59392b9ff">model_type</a>;
<a name="l00856"></a>00856   this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a63f46e0b3f6ce390fd8d0b802d5d4354">analysis_type</a>          = omduh.<a class="code" href="classMeshDataUnvHeader.php#a63f46e0b3f6ce390fd8d0b802d5d4354">analysis_type</a>;
<a name="l00857"></a>00857   this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a2d824a184d8c87338dd1df69b0319f56">data_characteristic</a>    = omduh.<a class="code" href="classMeshDataUnvHeader.php#a2d824a184d8c87338dd1df69b0319f56">data_characteristic</a>;
<a name="l00858"></a>00858   this-&gt;<a class="code" href="classMeshDataUnvHeader.php#ae424259011b6063d66933b4316201cdb">result_type</a>            = omduh.<a class="code" href="classMeshDataUnvHeader.php#ae424259011b6063d66933b4316201cdb">result_type</a>;
<a name="l00859"></a>00859 
<a name="l00860"></a>00860 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00861"></a>00861 <span class="preprocessor"></span>  <span class="comment">/*</span>
<a name="l00862"></a>00862 <span class="comment">   * in complex mode allow only</span>
<a name="l00863"></a>00863 <span class="comment">   * values 5 or 6 (complex) for data_type</span>
<a name="l00864"></a>00864 <span class="comment">   */</span>
<a name="l00865"></a>00865   <span class="keywordflow">if</span> ((omduh.<a class="code" href="classMeshDataUnvHeader.php#ae8194a3ba8d6615dabebedd252332b4c">data_type</a> == 5) ||
<a name="l00866"></a>00866       (omduh.<a class="code" href="classMeshDataUnvHeader.php#ae8194a3ba8d6615dabebedd252332b4c">data_type</a> == 6))
<a name="l00867"></a>00867       this-&gt;<a class="code" href="classMeshDataUnvHeader.php#ae8194a3ba8d6615dabebedd252332b4c">data_type</a>          = omduh.<a class="code" href="classMeshDataUnvHeader.php#ae8194a3ba8d6615dabebedd252332b4c">data_type</a>;
<a name="l00868"></a>00868   <span class="keywordflow">else</span>
<a name="l00869"></a>00869     {
<a name="l00870"></a>00870 <span class="preprocessor">#  ifdef DEBUG</span>
<a name="l00871"></a>00871 <span class="preprocessor"></span>      std::cerr &lt;&lt; <span class="stringliteral">&quot;WARNING: MeshDataUnvHeader::operator=(): Other object has data_type for&quot;</span> &lt;&lt; std::endl
<a name="l00872"></a>00872                 &lt;&lt; <span class="stringliteral">&quot;         real values.  Will use default data_type=5 during assignment.&quot;</span> &lt;&lt; std::endl
<a name="l00873"></a>00873                 &lt;&lt; std::endl;
<a name="l00874"></a>00874 <span class="preprocessor">#  endif</span>
<a name="l00875"></a>00875 <span class="preprocessor"></span>      this-&gt;<a class="code" href="classMeshDataUnvHeader.php#ae8194a3ba8d6615dabebedd252332b4c">data_type</a>          = 5;
<a name="l00876"></a>00876     }
<a name="l00877"></a>00877 
<a name="l00878"></a>00878 <span class="preprocessor">#else</span>
<a name="l00879"></a>00879 <span class="preprocessor"></span>
<a name="l00880"></a>00880   <span class="comment">/*</span>
<a name="l00881"></a>00881 <span class="comment">   * in real mode allow only</span>
<a name="l00882"></a>00882 <span class="comment">   * values 2 or 4 (real) for data_type</span>
<a name="l00883"></a>00883 <span class="comment">   */</span>
<a name="l00884"></a>00884   <span class="keywordflow">if</span> ((omduh.<a class="code" href="classMeshDataUnvHeader.php#ae8194a3ba8d6615dabebedd252332b4c">data_type</a> == 2) ||
<a name="l00885"></a>00885       (omduh.<a class="code" href="classMeshDataUnvHeader.php#ae8194a3ba8d6615dabebedd252332b4c">data_type</a> == 4))
<a name="l00886"></a>00886       this-&gt;<a class="code" href="classMeshDataUnvHeader.php#ae8194a3ba8d6615dabebedd252332b4c">data_type</a>          = omduh.<a class="code" href="classMeshDataUnvHeader.php#ae8194a3ba8d6615dabebedd252332b4c">data_type</a>;
<a name="l00887"></a>00887   <span class="keywordflow">else</span>
<a name="l00888"></a>00888     {
<a name="l00889"></a>00889 <span class="preprocessor">#  ifdef DEBUG</span>
<a name="l00890"></a>00890 <span class="preprocessor"></span>      std::cerr &lt;&lt; <span class="stringliteral">&quot;WARNING: Other MeshDataUnvHeader has data_type for complex values.&quot;</span> &lt;&lt; std::endl
<a name="l00891"></a>00891                 &lt;&lt; <span class="stringliteral">&quot;         Data import will likely _not_ work and result in infinite loop,&quot;</span> &lt;&lt; std::endl
<a name="l00892"></a>00892                 &lt;&lt; <span class="stringliteral">&quot;         provided the user forgot to re-size nvaldc to 2*nvaldc_old!&quot;</span> &lt;&lt; std::endl
<a name="l00893"></a>00893                 &lt;&lt; std::endl;
<a name="l00894"></a>00894 <span class="preprocessor">#  endif</span>
<a name="l00895"></a>00895 <span class="preprocessor"></span>      this-&gt;<a class="code" href="classMeshDataUnvHeader.php#ae8194a3ba8d6615dabebedd252332b4c">data_type</a>          = 2;
<a name="l00896"></a>00896     }
<a name="l00897"></a>00897 
<a name="l00898"></a>00898 <span class="preprocessor">#endif</span>
<a name="l00899"></a>00899 <span class="preprocessor"></span>
<a name="l00900"></a>00900   this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a345c5391a7100d467f347942498f172b">nvaldc</a>                 = omduh.<a class="code" href="classMeshDataUnvHeader.php#a345c5391a7100d467f347942498f172b">nvaldc</a>;
<a name="l00901"></a>00901 
<a name="l00902"></a>00902   this-&gt;<a class="code" href="classMeshDataUnvHeader.php#abe34ba27cef23f0fcb00e3d41cb38c86">record_10</a>              = omduh.<a class="code" href="classMeshDataUnvHeader.php#abe34ba27cef23f0fcb00e3d41cb38c86">record_10</a>;
<a name="l00903"></a>00903   this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a21c07f5b394962c15d12b94f243cfbaa">record_11</a>              = omduh.<a class="code" href="classMeshDataUnvHeader.php#a21c07f5b394962c15d12b94f243cfbaa">record_11</a>;
<a name="l00904"></a>00904   this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a41b36862d87363c11aa05ec3eac1e57d">record_12</a>              = omduh.<a class="code" href="classMeshDataUnvHeader.php#a41b36862d87363c11aa05ec3eac1e57d">record_12</a>;
<a name="l00905"></a>00905   this-&gt;<a class="code" href="classMeshDataUnvHeader.php#aa72672e176d3594183b3a490044dad2e">record_13</a>              = omduh.<a class="code" href="classMeshDataUnvHeader.php#aa72672e176d3594183b3a490044dad2e">record_13</a>;
<a name="l00906"></a>00906 
<a name="l00907"></a>00907   this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a1ce4684c8c1037ff8d1da8cbac058a70">_desired_dataset_label</a> = omduh.<a class="code" href="classMeshDataUnvHeader.php#a1ce4684c8c1037ff8d1da8cbac058a70">_desired_dataset_label</a>;
<a name="l00908"></a>00908 }
<a name="l00909"></a>00909 
<a name="l00910"></a>00910 
<a name="l00911"></a>00911 
<a name="l00912"></a>00912 
<a name="l00913"></a><a class="code" href="classMeshDataUnvHeader.php#aba0e7cdb6fb35cf420dbfc40ff76e8bd">00913</a> <span class="keywordtype">bool</span> <a class="code" href="classMeshDataUnvHeader.php#aba0e7cdb6fb35cf420dbfc40ff76e8bd">MeshDataUnvHeader::operator == </a>(<span class="keyword">const</span> <a class="code" href="classMeshDataUnvHeader.php">MeshDataUnvHeader</a>&amp; omduh)<span class="keyword"> const</span>
<a name="l00914"></a>00914 <span class="keyword"></span>{
<a name="l00915"></a>00915   <span class="keywordflow">return</span> (this-&gt;<a class="code" href="classMeshDataUnvHeader.php#a9432bcb223662f6f1b50c5ed01b05c14">dataset_label</a>          == omduh.<a class="code" href="classMeshDataUnvHeader.php#a9432bcb223662f6f1b50c5ed01b05c14">dataset_label</a>       &amp;&amp;
<a name="l00916"></a>00916           this-&gt;dataset_name           == omduh.<a class="code" href="classMeshDataUnvHeader.php#a37a86ee3e94d3e7a08667bfada510841">dataset_name</a>        &amp;&amp;
<a name="l00917"></a>00917           this-&gt;dataset_location       == omduh.<a class="code" href="classMeshDataUnvHeader.php#a93a7085fec9bdafb843bfb56a7bd0a50">dataset_location</a>    &amp;&amp;
<a name="l00918"></a>00918           this-&gt;id_lines_1_to_5        == omduh.<a class="code" href="classMeshDataUnvHeader.php#aefecee738a3f03db3d73ebe9f28f7f1c">id_lines_1_to_5</a>     &amp;&amp;
<a name="l00919"></a>00919 
<a name="l00920"></a>00920           this-&gt;model_type             == omduh.<a class="code" href="classMeshDataUnvHeader.php#a3d3e4f97d1fbcba3be7115c59392b9ff">model_type</a>          &amp;&amp;
<a name="l00921"></a>00921           this-&gt;analysis_type          == omduh.<a class="code" href="classMeshDataUnvHeader.php#a63f46e0b3f6ce390fd8d0b802d5d4354">analysis_type</a>       &amp;&amp;
<a name="l00922"></a>00922           this-&gt;data_characteristic    == omduh.<a class="code" href="classMeshDataUnvHeader.php#a2d824a184d8c87338dd1df69b0319f56">data_characteristic</a> &amp;&amp;
<a name="l00923"></a>00923           this-&gt;result_type            == omduh.<a class="code" href="classMeshDataUnvHeader.php#ae424259011b6063d66933b4316201cdb">result_type</a>         &amp;&amp;
<a name="l00924"></a>00924 
<a name="l00925"></a>00925           this-&gt;data_type              == omduh.<a class="code" href="classMeshDataUnvHeader.php#ae8194a3ba8d6615dabebedd252332b4c">data_type</a>           &amp;&amp;
<a name="l00926"></a>00926           this-&gt;nvaldc                 == omduh.<a class="code" href="classMeshDataUnvHeader.php#a345c5391a7100d467f347942498f172b">nvaldc</a>              &amp;&amp;
<a name="l00927"></a>00927 
<a name="l00928"></a>00928           this-&gt;record_10              == omduh.<a class="code" href="classMeshDataUnvHeader.php#abe34ba27cef23f0fcb00e3d41cb38c86">record_10</a>           &amp;&amp;
<a name="l00929"></a>00929           this-&gt;record_11              == omduh.<a class="code" href="classMeshDataUnvHeader.php#a21c07f5b394962c15d12b94f243cfbaa">record_11</a>           &amp;&amp;
<a name="l00930"></a>00930           this-&gt;record_12              == omduh.<a class="code" href="classMeshDataUnvHeader.php#a41b36862d87363c11aa05ec3eac1e57d">record_12</a>           &amp;&amp;
<a name="l00931"></a>00931           this-&gt;record_13              == omduh.<a class="code" href="classMeshDataUnvHeader.php#aa72672e176d3594183b3a490044dad2e">record_13</a>           &amp;&amp;
<a name="l00932"></a>00932 
<a name="l00933"></a>00933           this-&gt;_desired_dataset_label == omduh.<a class="code" href="classMeshDataUnvHeader.php#a1ce4684c8c1037ff8d1da8cbac058a70">_desired_dataset_label</a>);
<a name="l00934"></a>00934 }
<a name="l00935"></a>00935 
<a name="l00936"></a>00936 
<a name="l00937"></a>00937 
<a name="l00938"></a>00938 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
