<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_data_xdr_support.C</h1>  </div>
</div>
<div class="contents">
<a href="mesh__data__xdr__support_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_data_xdr_support.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;mesh_data.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;xdr_cxx.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">//------------------------------------------------------</span>
<a name="l00033"></a>00033 <span class="comment">// MeshData functions</span>
<a name="l00034"></a><a class="code" href="classMeshData.php#ad337af3416fd475a76d5fa17decba921">00034</a> <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#ad337af3416fd475a76d5fa17decba921">MeshData::read_xdr</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00035"></a>00035                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">XdrMODE</a> mode)
<a name="l00036"></a>00036 {
<a name="l00076"></a>00076   <span class="comment">// we should better be active or in compatibility mode</span>
<a name="l00077"></a>00077   libmesh_assert (<a class="code" href="classMeshData.php#ac67bdab9e104987a755c123ddbc899a3">_active</a> || <a class="code" href="classMeshData.php#ab3fcaff9ed092e581d667fd04dacbd39">_compatibility_mode</a>);
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   <span class="comment">// make sure the id maps are ready</span>
<a name="l00081"></a>00081   libmesh_assert (<a class="code" href="classMeshData.php#a071ea01303d43241271f23704718897e">_node_id_map_closed</a>);
<a name="l00082"></a>00082   libmesh_assert (<a class="code" href="classMeshData.php#a52728bfcb6ea3691546bfa90770bb632">_elem_id_map_closed</a>);
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00088"></a>00088   this-&gt;<a class="code" href="classMeshData.php#a441899feec76257ac227a6786fe9aea9">clear</a>();
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 
<a name="l00091"></a>00091   <a class="code" href="classXdr.php">Xdr</a> io(name, mode);
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 
<a name="l00094"></a>00094   <span class="comment">/*</span>
<a name="l00095"></a>00095 <span class="comment">   * all processors read the data in the same format,</span>
<a name="l00096"></a>00096 <span class="comment">   * but only the processor that owns the element stores</span>
<a name="l00097"></a>00097 <span class="comment">   * element-associated data.  For nodes, i haven&#39;t come</span>
<a name="l00098"></a>00098 <span class="comment">   * up with such asmart idea, yet... :-P</span>
<a name="l00099"></a>00099 <span class="comment">   */</span>
<a name="l00100"></a>00100   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id = <a class="code" href="classMeshData.php#aef8b56d1df25b587d4b8aee4136b3870">_mesh</a>.<a class="code" href="classMeshBase.php#aba369b64ee6185d86a6b60089ba5af60">processor_id</a>();
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00109"></a>00109   {
<a name="l00110"></a>00110     std::string desc = <span class="stringliteral">&quot;&quot;</span>;
<a name="l00111"></a>00111     io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (desc);
<a name="l00112"></a>00112     this-&gt;<a class="code" href="classMeshData.php#aca70c20078e79351af9da2701f51f99d">_data_descriptor</a> = desc;
<a name="l00113"></a>00113   }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00122"></a>00122   {
<a name="l00123"></a>00123     std::string vtype=<span class="stringliteral">&quot;&quot;</span>;
<a name="l00124"></a>00124     io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (vtype);
<a name="l00125"></a>00125 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00126"></a>00126 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (vtype != <span class="stringliteral">&quot;COMPLEX&quot;</span>)
<a name="l00127"></a>00127       {
<a name="l00128"></a>00128         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: File does not contain complex-valued data!&quot;</span>
<a name="l00129"></a>00129                   &lt;&lt; std::endl;
<a name="l00130"></a>00130         libmesh_error();
<a name="l00131"></a>00131       }
<a name="l00132"></a>00132 <span class="preprocessor">#elif LIBMESH_USE_REAL_NUMBERS</span>
<a name="l00133"></a>00133 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (vtype != <span class="stringliteral">&quot;REAL&quot;</span>)
<a name="l00134"></a>00134       {
<a name="l00135"></a>00135         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: File does not contain real-valued data!&quot;</span>
<a name="l00136"></a>00136                   &lt;&lt; std::endl;
<a name="l00137"></a>00137         libmesh_error();
<a name="l00138"></a>00138       }
<a name="l00139"></a>00139 <span class="preprocessor">#else</span>
<a name="l00140"></a>00140 <span class="preprocessor"></span>    <span class="comment">/*</span>
<a name="l00141"></a>00141 <span class="comment">     * What number type is this?</span>
<a name="l00142"></a>00142 <span class="comment">     */</span>
<a name="l00143"></a>00143     libmesh_error();
<a name="l00144"></a>00144 <span class="preprocessor">#endif</span>
<a name="l00145"></a>00145 <span class="preprocessor"></span>  }
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00154"></a>00154   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_node = 0;
<a name="l00155"></a>00155   io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (n_node);
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00163"></a>00163   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a337ed123c95f0ba57b665456c413db4b">n_elem</a> = 0;
<a name="l00164"></a>00164   io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (n_elem);
<a name="l00165"></a>00165 
<a name="l00166"></a>00166   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> previous_values_size = 0;
<a name="l00167"></a>00167 
<a name="l00168"></a>00168   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_cnt=0; n_cnt &lt; n_node; n_cnt++)
<a name="l00169"></a>00169     {
<a name="l00176"></a>00176       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> f_id = 0;
<a name="l00177"></a>00177       io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (f_id);
<a name="l00178"></a>00178 
<a name="l00179"></a>00179       <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node = <a class="code" href="classMeshData.php#a6cb6c156374dc82815b2f654eab9fdf7">foreign_id_to_node</a>(f_id);
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00188"></a>00188       {
<a name="l00189"></a>00189         std::vector&lt;Number&gt; values;
<a name="l00190"></a>00190         io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (values);
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00194"></a>00194 <span class="preprocessor"></span>        <span class="comment">/*</span>
<a name="l00195"></a>00195 <span class="comment">         * make sure the size of the values vectors</span>
<a name="l00196"></a>00196 <span class="comment">         * are identical for all nodes</span>
<a name="l00197"></a>00197 <span class="comment">         */</span>
<a name="l00198"></a>00198         <span class="keywordflow">if</span> (n_cnt == 0)
<a name="l00199"></a>00199             previous_values_size = values.size();
<a name="l00200"></a>00200         <span class="keywordflow">else</span>
<a name="l00201"></a>00201           {
<a name="l00202"></a>00202             <span class="keywordflow">if</span> (previous_values_size != values.size())
<a name="l00203"></a>00203               {
<a name="l00204"></a>00204                 std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Size mismatch for n_cnt = &quot;</span> &lt;&lt; n_cnt &lt;&lt; std::endl;
<a name="l00205"></a>00205                 libmesh_error();
<a name="l00206"></a>00206               }
<a name="l00207"></a>00207           }
<a name="l00208"></a>00208 <span class="preprocessor">#endif</span>
<a name="l00209"></a>00209 <span class="preprocessor"></span>
<a name="l00210"></a>00210 
<a name="l00214"></a>00214         <a class="code" href="classMeshData.php#a0773ff071287f33580af5832a70f8d0f">_node_data</a>.insert (std::make_pair(node, values));
<a name="l00215"></a>00215       }
<a name="l00216"></a>00216     }
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 
<a name="l00220"></a>00220   previous_values_size = 0;
<a name="l00221"></a>00221 
<a name="l00222"></a>00222   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_cnt=0; n_cnt &lt; <a class="code" href="namespaceMeshTools.php#a337ed123c95f0ba57b665456c413db4b">n_elem</a>; n_cnt++)
<a name="l00223"></a>00223     {
<a name="l00229"></a>00229       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> f_id = 0;
<a name="l00230"></a>00230       io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (f_id);
<a name="l00231"></a>00231 
<a name="l00232"></a>00232       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = <a class="code" href="classMeshData.php#ad2522dd96c172f01c2dad1728988a538">foreign_id_to_elem</a>(f_id);
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 
<a name="l00241"></a>00241       {
<a name="l00242"></a>00242         std::vector&lt;Number&gt; values;
<a name="l00243"></a>00243         io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (values);
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00247"></a>00247 <span class="preprocessor"></span>        <span class="comment">/*</span>
<a name="l00248"></a>00248 <span class="comment">         * make sure the size of the values vectors</span>
<a name="l00249"></a>00249 <span class="comment">         * are identical for all elements</span>
<a name="l00250"></a>00250 <span class="comment">         */</span>
<a name="l00251"></a>00251         <span class="keywordflow">if</span> (n_cnt == 0)
<a name="l00252"></a>00252             previous_values_size = values.size();
<a name="l00253"></a>00253         <span class="keywordflow">else</span>
<a name="l00254"></a>00254           {
<a name="l00255"></a>00255             <span class="keywordflow">if</span> (previous_values_size != values.size())
<a name="l00256"></a>00256               {
<a name="l00257"></a>00257                 std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Size mismatch for n_cnt = &quot;</span> &lt;&lt; n_cnt &lt;&lt; std::endl;
<a name="l00258"></a>00258                 libmesh_error();
<a name="l00259"></a>00259               }
<a name="l00260"></a>00260           }
<a name="l00261"></a>00261 <span class="preprocessor">#endif</span>
<a name="l00262"></a>00262 <span class="preprocessor"></span>
<a name="l00263"></a>00263 
<a name="l00268"></a>00268         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() == proc_id)
<a name="l00269"></a>00269           <a class="code" href="classMeshData.php#a7d1d25eef77c023adc84c6010925036d">_elem_data</a>.insert (std::make_pair(elem, values));
<a name="l00270"></a>00270       }
<a name="l00271"></a>00271     }
<a name="l00272"></a>00272 
<a name="l00273"></a>00273 
<a name="l00274"></a>00274   <span class="comment">/*</span>
<a name="l00275"></a>00275 <span class="comment">   * finished reading.  Now ready for use, provided</span>
<a name="l00276"></a>00276 <span class="comment">   * there was any data contained in the file.</span>
<a name="l00277"></a>00277 <span class="comment">   */</span>
<a name="l00278"></a>00278   libmesh_assert ((this-&gt;<a class="code" href="classMeshData.php#a0773ff071287f33580af5832a70f8d0f">_node_data</a>.size() != 0) || (this-&gt;<a class="code" href="classMeshData.php#a7d1d25eef77c023adc84c6010925036d">_elem_data</a>.size() != 0));
<a name="l00279"></a>00279 
<a name="l00280"></a>00280   this-&gt;<a class="code" href="classMeshData.php#a5718ca825e3b14e2e8947a3bac15d117">_node_data_closed</a> = <span class="keyword">true</span>;
<a name="l00281"></a>00281   this-&gt;<a class="code" href="classMeshData.php#aff2e62e6f1deb12255382c34dfca51d3">_elem_data_closed</a> = <span class="keyword">true</span>;
<a name="l00282"></a>00282 }
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 
<a name="l00285"></a>00285 
<a name="l00286"></a>00286 
<a name="l00287"></a>00287 
<a name="l00288"></a>00288 
<a name="l00289"></a><a class="code" href="classMeshData.php#aef8a4c695e7032e235f26657b1485256">00289</a> <span class="keywordtype">void</span> <a class="code" href="classMeshData.php#aef8a4c695e7032e235f26657b1485256">MeshData::write_xdr</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00290"></a>00290                           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">XdrMODE</a> mode)
<a name="l00291"></a>00291 {
<a name="l00330"></a>00330   <span class="comment">/*</span>
<a name="l00331"></a>00331 <span class="comment">   * make sure the id maps are ready</span>
<a name="l00332"></a>00332 <span class="comment">   * and that we have data to write</span>
<a name="l00333"></a>00333 <span class="comment">   */</span>
<a name="l00334"></a>00334   libmesh_assert (<a class="code" href="classMeshData.php#a071ea01303d43241271f23704718897e">_node_id_map_closed</a>);
<a name="l00335"></a>00335   libmesh_assert (<a class="code" href="classMeshData.php#a52728bfcb6ea3691546bfa90770bb632">_elem_id_map_closed</a>);
<a name="l00336"></a>00336 
<a name="l00337"></a>00337   libmesh_assert (<a class="code" href="classMeshData.php#a5718ca825e3b14e2e8947a3bac15d117">_node_data_closed</a>);
<a name="l00338"></a>00338   libmesh_assert (<a class="code" href="classMeshData.php#aff2e62e6f1deb12255382c34dfca51d3">_elem_data_closed</a>);
<a name="l00339"></a>00339   
<a name="l00340"></a>00340 
<a name="l00341"></a>00341   <a class="code" href="classXdr.php">Xdr</a> io(name, mode);
<a name="l00342"></a>00342 
<a name="l00343"></a>00343 
<a name="l00344"></a>00344   <span class="comment">// all processors write the data in the same format</span>
<a name="l00345"></a>00345   <span class="comment">//const unsigned int proc_id = _mesh.processor_id();</span>
<a name="l00346"></a>00346 
<a name="l00352"></a>00352   {
<a name="l00353"></a>00353     std::string desc = this-&gt;<a class="code" href="classMeshData.php#aca70c20078e79351af9da2701f51f99d">_data_descriptor</a>;
<a name="l00354"></a>00354     io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (desc, <span class="stringliteral">&quot;# Data description&quot;</span>);
<a name="l00355"></a>00355   }
<a name="l00356"></a>00356 
<a name="l00357"></a>00357 
<a name="l00358"></a>00358 
<a name="l00364"></a>00364   {
<a name="l00365"></a>00365 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00366"></a>00366 <span class="preprocessor"></span>    std::string desc = <span class="stringliteral">&quot;COMPLEX&quot;</span>;
<a name="l00367"></a>00367 <span class="preprocessor">#elif LIBMESH_USE_REAL_NUMBERS</span>
<a name="l00368"></a>00368 <span class="preprocessor"></span>    std::string desc = <span class="stringliteral">&quot;REAL&quot;</span>;
<a name="l00369"></a>00369 <span class="preprocessor">#else</span>
<a name="l00370"></a>00370 <span class="preprocessor"></span>better_you_choke_this...
<a name="l00371"></a>00371 #endif
<a name="l00372"></a>00372     io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (desc, <span class="stringliteral">&quot;# type of values&quot;</span>);
<a name="l00373"></a>00373   }
<a name="l00374"></a>00374 
<a name="l00375"></a>00375 
<a name="l00376"></a>00376 
<a name="l00382"></a>00382   {
<a name="l00383"></a>00383     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_node = this-&gt;<a class="code" href="classMeshData.php#a0773ff071287f33580af5832a70f8d0f">_node_data</a>.size();
<a name="l00384"></a>00384     io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (n_node, <span class="stringliteral">&quot;# No. of nodes for which data is stored&quot;</span>);
<a name="l00385"></a>00385   }
<a name="l00386"></a>00386 
<a name="l00387"></a>00387 
<a name="l00393"></a>00393   {
<a name="l00394"></a>00394     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a337ed123c95f0ba57b665456c413db4b">n_elem</a> = this-&gt;<a class="code" href="classMeshData.php#a7d1d25eef77c023adc84c6010925036d">_elem_data</a>.size();
<a name="l00395"></a>00395     io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (n_elem, <span class="stringliteral">&quot;# No. of elements for which data is stored&quot;</span>);
<a name="l00396"></a>00396   }
<a name="l00397"></a>00397 
<a name="l00398"></a>00398 
<a name="l00399"></a>00399 
<a name="l00400"></a>00400 
<a name="l00401"></a>00401   std::map&lt;<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>*, 
<a name="l00402"></a>00402            std::vector&lt;Number&gt; &gt;::const_iterator nit = <a class="code" href="classMeshData.php#a0773ff071287f33580af5832a70f8d0f">_node_data</a>.begin ();
<a name="l00403"></a>00403 
<a name="l00404"></a>00404   <span class="keywordflow">for</span> (; nit != <a class="code" href="classMeshData.php#a0773ff071287f33580af5832a70f8d0f">_node_data</a>.end(); ++nit)
<a name="l00405"></a>00405     {
<a name="l00406"></a>00406       <span class="keyword">const</span> Node* node = (*nit).first;
<a name="l00407"></a>00407 
<a name="l00413"></a>00413       {
<a name="l00414"></a>00414         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> f_id = <a class="code" href="classMeshData.php#a64280d5ec57b031bcba08f216af20973">node_to_foreign_id</a> (node);
<a name="l00415"></a>00415         io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (f_id, <span class="stringliteral">&quot;# Foreign node id&quot;</span>);
<a name="l00416"></a>00416       }
<a name="l00417"></a>00417 
<a name="l00418"></a>00418 
<a name="l00424"></a>00424       {
<a name="l00425"></a>00425         <span class="comment">/* </span>
<a name="l00426"></a>00426 <span class="comment">         * since we are iterating over our @e own </span>
<a name="l00427"></a>00427 <span class="comment">         * map, this libmesh_assert should never break...</span>
<a name="l00428"></a>00428 <span class="comment">         */</span>
<a name="l00429"></a>00429         libmesh_assert (this-&gt;<a class="code" href="classMeshData.php#a88fea2994fc1ac1295745fdb8bd685f5">has_data</a>(node));
<a name="l00430"></a>00430 
<a name="l00431"></a>00431         <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; values = this-&gt;<a class="code" href="classMeshData.php#ab34864d2e1f83059bd781b0dd5f71fe0">get_data</a>(node);
<a name="l00432"></a>00432         
<a name="l00433"></a>00433         <span class="comment">/*</span>
<a name="l00434"></a>00434 <span class="comment">         * copy the data to a local buf, since</span>
<a name="l00435"></a>00435 <span class="comment">         * the Xdr class needs write access, even</span>
<a name="l00436"></a>00436 <span class="comment">         * when only reading data</span>
<a name="l00437"></a>00437 <span class="comment">         */</span>
<a name="l00438"></a>00438         std::vector&lt;Number&gt; buf = values;
<a name="l00439"></a>00439         io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (buf, <span class="stringliteral">&quot;# Values&quot;</span>);
<a name="l00440"></a>00440       }
<a name="l00441"></a>00441     }
<a name="l00442"></a>00442 
<a name="l00443"></a>00443 
<a name="l00444"></a>00444 
<a name="l00445"></a>00445 
<a name="l00446"></a>00446 
<a name="l00447"></a>00447 
<a name="l00448"></a>00448 
<a name="l00449"></a>00449   std::map&lt;<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>*, 
<a name="l00450"></a>00450            std::vector&lt;Number&gt; &gt;::const_iterator eit = <a class="code" href="classMeshData.php#a7d1d25eef77c023adc84c6010925036d">_elem_data</a>.begin ();
<a name="l00451"></a>00451 
<a name="l00452"></a>00452   <span class="keywordflow">for</span> (; eit != <a class="code" href="classMeshData.php#a7d1d25eef77c023adc84c6010925036d">_elem_data</a>.end(); ++eit)
<a name="l00453"></a>00453     {
<a name="l00454"></a>00454       <span class="keyword">const</span> Elem* elem = (*eit).first;
<a name="l00455"></a>00455 
<a name="l00461"></a>00461       {
<a name="l00462"></a>00462         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> f_id = <a class="code" href="classMeshData.php#a42f4bc27f920ebacc677fe43613d81b5">elem_to_foreign_id</a> (elem);
<a name="l00463"></a>00463         io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (f_id, <span class="stringliteral">&quot;# Foreign element id&quot;</span>);
<a name="l00464"></a>00464       }
<a name="l00465"></a>00465 
<a name="l00466"></a>00466 
<a name="l00472"></a>00472       {
<a name="l00473"></a>00473         <span class="comment">/* </span>
<a name="l00474"></a>00474 <span class="comment">         * since we are iterating over our @e own </span>
<a name="l00475"></a>00475 <span class="comment">         * map, this libmesh_assert should never break...</span>
<a name="l00476"></a>00476 <span class="comment">         */</span>
<a name="l00477"></a>00477         libmesh_assert (this-&gt;<a class="code" href="classMeshData.php#a88fea2994fc1ac1295745fdb8bd685f5">has_data</a>(elem));
<a name="l00478"></a>00478 
<a name="l00479"></a>00479         <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; values = this-&gt;<a class="code" href="classMeshData.php#ab34864d2e1f83059bd781b0dd5f71fe0">get_data</a>(elem);
<a name="l00480"></a>00480         
<a name="l00481"></a>00481         <span class="comment">/*</span>
<a name="l00482"></a>00482 <span class="comment">         * copy the data to a local buf, since</span>
<a name="l00483"></a>00483 <span class="comment">         * the Xdr class needs write access, even</span>
<a name="l00484"></a>00484 <span class="comment">         * when only reading data</span>
<a name="l00485"></a>00485 <span class="comment">         */</span>
<a name="l00486"></a>00486         std::vector&lt;Number&gt; buf = values;
<a name="l00487"></a>00487         io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (buf, <span class="stringliteral">&quot;# Values&quot;</span>);
<a name="l00488"></a>00488       }
<a name="l00489"></a>00489     }
<a name="l00490"></a>00490 }
<a name="l00491"></a>00491 
<a name="l00492"></a>00492 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
