<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_f10759d5ac6297fe611079c3c15b8f2c.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_function.C</h1>  </div>
</div>
<div class="contents">
<a href="mesh__function_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_function.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local Includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;mesh_function.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;dense_vector.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;equation_systems.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;dof_map.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;point_locator_tree.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;fe_base.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;fe_interface.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;fe_compute_data.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;mesh.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;point.h&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00040"></a>00040 <span class="comment">// MeshFunction methods</span>
<a name="l00041"></a><a class="code" href="classMeshFunction.php#af2f3632fb4b694e9c6f3f8a5f3d5ef2c">00041</a> <a class="code" href="classMeshFunction.php#af2f3632fb4b694e9c6f3f8a5f3d5ef2c">MeshFunction::MeshFunction</a> (<span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; eqn_systems,
<a name="l00042"></a>00042                             <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp; vec,
<a name="l00043"></a>00043                             <span class="keyword">const</span> <a class="code" href="classDofMap.php">DofMap</a>&amp; dof_map,
<a name="l00044"></a>00044                             <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; vars,
<a name="l00045"></a>00045                             <span class="keyword">const</span> <a class="code" href="classFunctionBase.php">FunctionBase</a>* master) :
<a name="l00046"></a>00046   <a class="code" href="classFunctionBase.php">FunctionBase</a>   (master),
<a name="l00047"></a>00047   _eqn_systems   (eqn_systems),
<a name="l00048"></a>00048   _vector        (vec),
<a name="l00049"></a>00049   _dof_map       (dof_map),
<a name="l00050"></a>00050   _system_vars   (vars),
<a name="l00051"></a>00051   _point_locator (NULL),
<a name="l00052"></a>00052   _out_of_mesh_mode(false),
<a name="l00053"></a>00053   _out_of_mesh_value()
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055 }
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 
<a name="l00059"></a><a class="code" href="classMeshFunction.php#ad80df68ce63ecb244cd7cb311d3b3bb3">00059</a> <a class="code" href="classMeshFunction.php#af2f3632fb4b694e9c6f3f8a5f3d5ef2c">MeshFunction::MeshFunction</a> (<span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; eqn_systems,
<a name="l00060"></a>00060                             <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp; vec,
<a name="l00061"></a>00061                             <span class="keyword">const</span> <a class="code" href="classDofMap.php">DofMap</a>&amp; dof_map,
<a name="l00062"></a>00062                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00063"></a>00063                             <span class="keyword">const</span> <a class="code" href="classFunctionBase.php">FunctionBase</a>* master) :
<a name="l00064"></a>00064   <a class="code" href="classFunctionBase.php">FunctionBase</a>   (master),
<a name="l00065"></a>00065   _eqn_systems   (eqn_systems),
<a name="l00066"></a>00066   _vector        (vec),
<a name="l00067"></a>00067   _dof_map       (dof_map),
<a name="l00068"></a>00068   _system_vars   (1,var),
<a name="l00069"></a>00069   _point_locator (NULL),
<a name="l00070"></a>00070   _out_of_mesh_mode(false),
<a name="l00071"></a>00071   _out_of_mesh_value()
<a name="l00072"></a>00072 {
<a name="l00073"></a>00073 <span class="comment">//   std::vector&lt;unsigned int&gt; buf (1);</span>
<a name="l00074"></a>00074 <span class="comment">//   buf[0] = var;</span>
<a name="l00075"></a>00075 <span class="comment">//   _system_vars (buf);</span>
<a name="l00076"></a>00076 }
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00084"></a><a class="code" href="classMeshFunction.php#a3dee6569eff1d838c70c9138252a9f13">00084</a> <a class="code" href="classMeshFunction.php#a3dee6569eff1d838c70c9138252a9f13">MeshFunction::~MeshFunction</a> ()
<a name="l00085"></a>00085 {
<a name="l00086"></a>00086   <span class="comment">// only delete the point locator when we are the master</span>
<a name="l00087"></a>00087   <span class="keywordflow">if</span> ((this-&gt;<a class="code" href="classMeshFunction.php#aa1ab9bf5bb1f3d92bf74cfd2d4ff5161">_point_locator</a> != NULL) &amp;&amp; (this-&gt;<a class="code" href="classFunctionBase.php#a1ce94dacc6f531735410ff11045e3526">_master</a> == NULL))
<a name="l00088"></a>00088     <span class="keyword">delete</span> this-&gt;<a class="code" href="classMeshFunction.php#aa1ab9bf5bb1f3d92bf74cfd2d4ff5161">_point_locator</a>;
<a name="l00089"></a>00089 }
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 
<a name="l00094"></a><a class="code" href="classMeshFunction.php#a9998dec20d1b4569379a072a2f134f78">00094</a> <span class="keywordtype">void</span> <a class="code" href="classMeshFunction.php#aaa9c42781e2b1ba8cede26f40f9d26be">MeshFunction::init</a> (<span class="keyword">const</span> <a class="code" href="namespaceTrees.php#a8fb02eb8a700b646d106718a2d0ca3ef">Trees::BuildType</a> point_locator_build_type)
<a name="l00095"></a>00095 {
<a name="l00096"></a>00096   <span class="comment">// are indices of the desired variable(s) provided?</span>
<a name="l00097"></a>00097   libmesh_assert (this-&gt;<a class="code" href="classMeshFunction.php#ae4f4abe1ac74f504008cf103a4daf924">_system_vars</a>.size() &gt; 0);
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   <span class="comment">// Don&#39;t do twice...</span>
<a name="l00100"></a>00100   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classFunctionBase.php#ab72922e367786eca3b3497ea6710722c">_initialized</a>)
<a name="l00101"></a>00101     {
<a name="l00102"></a>00102       libmesh_assert(this-&gt;<a class="code" href="classMeshFunction.php#aa1ab9bf5bb1f3d92bf74cfd2d4ff5161">_point_locator</a> != NULL);
<a name="l00103"></a>00103       <span class="keywordflow">return</span>;
<a name="l00104"></a>00104     }
<a name="l00105"></a>00105 
<a name="l00106"></a>00106   <span class="comment">/*</span>
<a name="l00107"></a>00107 <span class="comment">   * set up the PointLocator: either someone else</span>
<a name="l00108"></a>00108 <span class="comment">   * is the master (go and get the address of his</span>
<a name="l00109"></a>00109 <span class="comment">   * point locator) or this object is the master </span>
<a name="l00110"></a>00110 <span class="comment">   * (build the point locator  on our own).</span>
<a name="l00111"></a>00111 <span class="comment">   */</span>
<a name="l00112"></a>00112   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classFunctionBase.php#a1ce94dacc6f531735410ff11045e3526">_master</a> != NULL)
<a name="l00113"></a>00113     {
<a name="l00114"></a>00114       <span class="comment">// we aren&#39;t the master</span>
<a name="l00115"></a>00115       <span class="keyword">const</span> <a class="code" href="classMeshFunction.php">MeshFunction</a>* master =
<a name="l00116"></a>00116         libmesh_cast_ptr&lt;const MeshFunction*&gt;(this-&gt;<a class="code" href="classFunctionBase.php#a1ce94dacc6f531735410ff11045e3526">_master</a>);
<a name="l00117"></a>00117       
<a name="l00118"></a>00118       <span class="keywordflow">if</span> (master-&gt;<a class="code" href="classMeshFunction.php#aa1ab9bf5bb1f3d92bf74cfd2d4ff5161">_point_locator</a> == NULL)
<a name="l00119"></a>00119         {
<a name="l00120"></a>00120           std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: When the master-servant concept is used,&quot;</span>
<a name="l00121"></a>00121                     &lt;&lt; std::endl
<a name="l00122"></a>00122                     &lt;&lt; <span class="stringliteral">&quot; the master has to be initialized first!&quot;</span>
<a name="l00123"></a>00123                     &lt;&lt; std::endl;
<a name="l00124"></a>00124           libmesh_error();
<a name="l00125"></a>00125         }
<a name="l00126"></a>00126       <span class="keywordflow">else</span>
<a name="l00127"></a>00127         {
<a name="l00128"></a>00128           this-&gt;<a class="code" href="classMeshFunction.php#aa1ab9bf5bb1f3d92bf74cfd2d4ff5161">_point_locator</a> = master-&gt;<a class="code" href="classMeshFunction.php#aa1ab9bf5bb1f3d92bf74cfd2d4ff5161">_point_locator</a>;
<a name="l00129"></a>00129         }
<a name="l00130"></a>00130     }
<a name="l00131"></a>00131   <span class="keywordflow">else</span>
<a name="l00132"></a>00132     {
<a name="l00133"></a>00133       <span class="comment">// we are the master: build the point locator</span>
<a name="l00134"></a>00134 
<a name="l00135"></a>00135       <span class="comment">// constant reference to the other mesh</span>
<a name="l00136"></a>00136       <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh = this-&gt;<a class="code" href="classMeshFunction.php#a76cb0a16b37199f910e7728d67a784ad">_eqn_systems</a>.<a class="code" href="classEquationSystems.php#ad8d458ae6a34c460e72b3279373d4a70">get_mesh</a>();
<a name="l00137"></a>00137 
<a name="l00138"></a>00138       <span class="comment">// build the point locator.  Only \p TREE version available</span>
<a name="l00139"></a>00139       <span class="comment">//AutoPtr&lt;PointLocatorBase&gt; ap (PointLocatorBase::build (TREE, mesh));</span>
<a name="l00140"></a>00140       <span class="comment">//this-&gt;_point_locator = ap.release();</span>
<a name="l00141"></a>00141       this-&gt;<a class="code" href="classMeshFunction.php#aa1ab9bf5bb1f3d92bf74cfd2d4ff5161">_point_locator</a> = <span class="keyword">new</span> <a class="code" href="classPointLocatorTree.php">PointLocatorTree</a> (mesh, point_locator_build_type);
<a name="l00142"></a>00142       
<a name="l00143"></a>00143 
<a name="l00144"></a>00144       <span class="comment">// Point locator no longer needs to be initialized.</span>
<a name="l00145"></a>00145       <span class="comment">//      this-&gt;_point_locator-&gt;init();</span>
<a name="l00146"></a>00146     }
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   <span class="comment">// ready for use</span>
<a name="l00150"></a>00150   this-&gt;<a class="code" href="classFunctionBase.php#ab72922e367786eca3b3497ea6710722c">_initialized</a> = <span class="keyword">true</span>;
<a name="l00151"></a>00151 }
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 <span class="keywordtype">void</span>
<a name="l00155"></a><a class="code" href="classMeshFunction.php#a02d0d24f40963fcfaacd3b4585a5ac4a">00155</a> <a class="code" href="classMeshFunction.php#a02d0d24f40963fcfaacd3b4585a5ac4a">MeshFunction::clear</a> ()
<a name="l00156"></a>00156 {
<a name="l00157"></a>00157   <span class="comment">// only delete the point locator when we are the master</span>
<a name="l00158"></a>00158   <span class="keywordflow">if</span> ((this-&gt;<a class="code" href="classMeshFunction.php#aa1ab9bf5bb1f3d92bf74cfd2d4ff5161">_point_locator</a> != NULL) &amp;&amp; (this-&gt;<a class="code" href="classFunctionBase.php#a1ce94dacc6f531735410ff11045e3526">_master</a> == NULL))
<a name="l00159"></a>00159     {
<a name="l00160"></a>00160       <span class="keyword">delete</span> this-&gt;<a class="code" href="classMeshFunction.php#aa1ab9bf5bb1f3d92bf74cfd2d4ff5161">_point_locator</a>;
<a name="l00161"></a>00161       this-&gt;<a class="code" href="classMeshFunction.php#aa1ab9bf5bb1f3d92bf74cfd2d4ff5161">_point_locator</a> = NULL;
<a name="l00162"></a>00162     }
<a name="l00163"></a>00163   this-&gt;<a class="code" href="classFunctionBase.php#ab72922e367786eca3b3497ea6710722c">_initialized</a> = <span class="keyword">false</span>;
<a name="l00164"></a>00164 }
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00170"></a><a class="code" href="classMeshFunction.php#a30afa61bb066df1a677df9c1c2d9a3e3">00170</a> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classMeshFunction.php#a30afa61bb066df1a677df9c1c2d9a3e3">MeshFunction::operator() </a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p, 
<a name="l00171"></a>00171                                  <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> time)
<a name="l00172"></a>00172 {
<a name="l00173"></a>00173   libmesh_assert (this-&gt;<a class="code" href="classFunctionBase.php#a19afe60a9016248664396f20200a43cb">initialized</a>());
<a name="l00174"></a>00174   <span class="comment">// At the moment the function we call ignores the time</span>
<a name="l00175"></a>00175   libmesh_assert (time == 0.);
<a name="l00176"></a>00176   
<a name="l00177"></a>00177   <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a> buf (1);
<a name="l00178"></a>00178   this-&gt;<a class="code" href="classMeshFunction.php#a30afa61bb066df1a677df9c1c2d9a3e3">operator() </a>(p, time, buf);
<a name="l00179"></a>00179   <span class="keywordflow">return</span> buf(0);
<a name="l00180"></a>00180 }
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 
<a name="l00184"></a><a class="code" href="classMeshFunction.php#a37bc6d22da064994a924034ddc1d5b2f">00184</a> <a class="code" href="classVectorValue.php">Gradient</a> <a class="code" href="classMeshFunction.php#a37bc6d22da064994a924034ddc1d5b2f">MeshFunction::gradient</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p, 
<a name="l00185"></a>00185                                  <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> time)
<a name="l00186"></a>00186 {
<a name="l00187"></a>00187   libmesh_assert (this-&gt;<a class="code" href="classFunctionBase.php#a19afe60a9016248664396f20200a43cb">initialized</a>());
<a name="l00188"></a>00188   <span class="comment">// At the moment the function we call ignores the time</span>
<a name="l00189"></a>00189   libmesh_assert (time == 0.);
<a name="l00190"></a>00190   
<a name="l00191"></a>00191   std::vector&lt;Gradient&gt; buf (1);
<a name="l00192"></a>00192   this-&gt;<a class="code" href="classMeshFunction.php#a37bc6d22da064994a924034ddc1d5b2f">gradient</a>(p, time, buf);
<a name="l00193"></a>00193   <span class="keywordflow">return</span> buf[0];
<a name="l00194"></a>00194 }
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00199"></a><a class="code" href="classMeshFunction.php#a020bc9e4fcb430939b3dd92be8fe78c9">00199</a> <span class="preprocessor"></span><a class="code" href="classTensorValue.php">Tensor</a> <a class="code" href="classMeshFunction.php#a020bc9e4fcb430939b3dd92be8fe78c9">MeshFunction::hessian</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p, 
<a name="l00200"></a>00200                               <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> time)
<a name="l00201"></a>00201 {
<a name="l00202"></a>00202   libmesh_assert (this-&gt;<a class="code" href="classFunctionBase.php#a19afe60a9016248664396f20200a43cb">initialized</a>());
<a name="l00203"></a>00203   <span class="comment">// At the moment the function we call ignores the time</span>
<a name="l00204"></a>00204   libmesh_assert (time == 0.);
<a name="l00205"></a>00205   
<a name="l00206"></a>00206   std::vector&lt;Tensor&gt; buf (1);
<a name="l00207"></a>00207   this-&gt;<a class="code" href="classMeshFunction.php#a020bc9e4fcb430939b3dd92be8fe78c9">hessian</a>(p, time, buf);
<a name="l00208"></a>00208   <span class="keywordflow">return</span> buf[0];
<a name="l00209"></a>00209 }
<a name="l00210"></a>00210 <span class="preprocessor">#endif</span>
<a name="l00211"></a>00211 <span class="preprocessor"></span>
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 
<a name="l00214"></a><a class="code" href="classMeshFunction.php#aeda3fe37c698291260e4021d31301c13">00214</a> <span class="keywordtype">void</span> <a class="code" href="classMeshFunction.php#a30afa61bb066df1a677df9c1c2d9a3e3">MeshFunction::operator() </a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00215"></a>00215                                <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>,
<a name="l00216"></a>00216                                <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a>&amp; output)
<a name="l00217"></a>00217 {
<a name="l00218"></a>00218   libmesh_assert (this-&gt;<a class="code" href="classFunctionBase.php#a19afe60a9016248664396f20200a43cb">initialized</a>());
<a name="l00219"></a>00219 
<a name="l00220"></a>00220   <span class="comment">/* Ensure that in the case of a master mesh function, the</span>
<a name="l00221"></a>00221 <span class="comment">     out-of-mesh mode is enabled either for both or for none.  This is</span>
<a name="l00222"></a>00222 <span class="comment">     important because the out-of-mesh mode is also communicated to</span>
<a name="l00223"></a>00223 <span class="comment">     the point locator.  Since this is time consuming, enable it only</span>
<a name="l00224"></a>00224 <span class="comment">     in debug mode.  */</span>
<a name="l00225"></a>00225 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00226"></a>00226 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classFunctionBase.php#a1ce94dacc6f531735410ff11045e3526">_master</a> != NULL)
<a name="l00227"></a>00227     {
<a name="l00228"></a>00228       <span class="keyword">const</span> <a class="code" href="classMeshFunction.php">MeshFunction</a>* master =
<a name="l00229"></a>00229         libmesh_cast_ptr&lt;const MeshFunction*&gt;(this-&gt;<a class="code" href="classFunctionBase.php#a1ce94dacc6f531735410ff11045e3526">_master</a>);
<a name="l00230"></a>00230       <span class="keywordflow">if</span>(<a class="code" href="classMeshFunction.php#a6772da79111c5f3a8b5c3de1fd66a47b">_out_of_mesh_mode</a>!=master-&gt;<a class="code" href="classMeshFunction.php#a6772da79111c5f3a8b5c3de1fd66a47b">_out_of_mesh_mode</a>)
<a name="l00231"></a>00231         {
<a name="l00232"></a>00232           std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: If you use out-of-mesh-mode in connection with master mesh functions, you must enable out-of-mesh mode for both the master and the slave mesh function.&quot;</span> &lt;&lt; std::endl;
<a name="l00233"></a>00233           libmesh_error();
<a name="l00234"></a>00234         }
<a name="l00235"></a>00235     }
<a name="l00236"></a>00236 <span class="preprocessor">#endif</span>
<a name="l00237"></a>00237 <span class="preprocessor"></span>  
<a name="l00238"></a>00238   <span class="comment">// locate the point in the other mesh</span>
<a name="l00239"></a>00239   <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* element = this-&gt;<a class="code" href="classMeshFunction.php#aa1ab9bf5bb1f3d92bf74cfd2d4ff5161">_point_locator</a>-&gt;operator()(p);
<a name="l00240"></a>00240 
<a name="l00241"></a>00241   <span class="keywordflow">if</span>(element==NULL)
<a name="l00242"></a>00242     {
<a name="l00243"></a>00243       output = <a class="code" href="classMeshFunction.php#a87975159e2b86966c930446c472e2f42">_out_of_mesh_value</a>;      
<a name="l00244"></a>00244     }
<a name="l00245"></a>00245   <span class="keywordflow">else</span>
<a name="l00246"></a>00246     {
<a name="l00247"></a>00247       <span class="comment">// resize the output vector to the number of output values</span>
<a name="l00248"></a>00248       <span class="comment">// that the user told us</span>
<a name="l00249"></a>00249       output.<a class="code" href="classDenseVector.php#a3a9af103dc052f1dfdef1626692cd8cd">resize</a> (this-&gt;<a class="code" href="classMeshFunction.php#ae4f4abe1ac74f504008cf103a4daf924">_system_vars</a>.size());
<a name="l00250"></a>00250       
<a name="l00251"></a>00251       
<a name="l00252"></a>00252       {
<a name="l00253"></a>00253         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = this-&gt;<a class="code" href="classMeshFunction.php#a76cb0a16b37199f910e7728d67a784ad">_eqn_systems</a>.<a class="code" href="classEquationSystems.php#ad8d458ae6a34c460e72b3279373d4a70">get_mesh</a>().<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>();
<a name="l00254"></a>00254         
<a name="l00255"></a>00255         
<a name="l00256"></a>00256         <span class="comment">/*</span>
<a name="l00257"></a>00257 <span class="comment">         * Get local coordinates to feed these into compute_data().  </span>
<a name="l00258"></a>00258 <span class="comment">         * Note that the fe_type can safely be used from the 0-variable,</span>
<a name="l00259"></a>00259 <span class="comment">         * since the inverse mapping is the same for all FEFamilies</span>
<a name="l00260"></a>00260 <span class="comment">         */</span>
<a name="l00261"></a>00261         <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> mapped_point (<a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FEInterface::inverse_map</a> (dim, 
<a name="l00262"></a>00262                                                             this-&gt;<a class="code" href="classMeshFunction.php#a0553b98b9f8bed5d222cc9d5ec96fab2">_dof_map</a>.<a class="code" href="classDofMap.php#ae3c63266417020f38af6e5cc40efca76">variable_type</a>(0),
<a name="l00263"></a>00263                                                             element, 
<a name="l00264"></a>00264                                                             p));
<a name="l00265"></a>00265         
<a name="l00266"></a>00266         
<a name="l00267"></a>00267         <span class="comment">// loop over all vars</span>
<a name="l00268"></a>00268         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=0; index &lt; this-&gt;<a class="code" href="classMeshFunction.php#ae4f4abe1ac74f504008cf103a4daf924">_system_vars</a>.size(); index++)
<a name="l00269"></a>00269           {
<a name="l00270"></a>00270             <span class="comment">/*</span>
<a name="l00271"></a>00271 <span class="comment">             * the data for this variable</span>
<a name="l00272"></a>00272 <span class="comment">             */</span>
<a name="l00273"></a>00273             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = <a class="code" href="classMeshFunction.php#ae4f4abe1ac74f504008cf103a4daf924">_system_vars</a>[index];
<a name="l00274"></a>00274             <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_type = this-&gt;<a class="code" href="classMeshFunction.php#a0553b98b9f8bed5d222cc9d5ec96fab2">_dof_map</a>.<a class="code" href="classDofMap.php#ae3c63266417020f38af6e5cc40efca76">variable_type</a>(var);
<a name="l00275"></a>00275             
<a name="l00280"></a>00280             {
<a name="l00281"></a>00281               <a class="code" href="classFEComputeData.php">FEComputeData</a> data (this-&gt;<a class="code" href="classMeshFunction.php#a76cb0a16b37199f910e7728d67a784ad">_eqn_systems</a>, mapped_point);
<a name="l00282"></a>00282               
<a name="l00283"></a>00283               <a class="code" href="classFEInterface.php#a6ae681af86208c304eb7d45b8a712e3c">FEInterface::compute_data</a> (dim, fe_type, element, data);
<a name="l00284"></a>00284               
<a name="l00285"></a>00285               <span class="comment">// where the solution values for the var-th variable are stored</span>
<a name="l00286"></a>00286               std::vector&lt;unsigned int&gt; dof_indices;
<a name="l00287"></a>00287               this-&gt;<a class="code" href="classMeshFunction.php#a0553b98b9f8bed5d222cc9d5ec96fab2">_dof_map</a>.<a class="code" href="classDofMap.php#afc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (element, dof_indices, var);
<a name="l00288"></a>00288               
<a name="l00289"></a>00289               <span class="comment">// interpolate the solution</span>
<a name="l00290"></a>00290               {
<a name="l00291"></a>00291                 <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> value = 0.;
<a name="l00292"></a>00292                 
<a name="l00293"></a>00293                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;dof_indices.size(); i++)
<a name="l00294"></a>00294                   value += this-&gt;<a class="code" href="classMeshFunction.php#a175447a4bbbc9d931b1aafdc0036591a">_vector</a>(dof_indices[i]) * data.<a class="code" href="classFEComputeData.php#ae9bf9a37c12e74af8a28cebb10e5610b">shape</a>[i];
<a name="l00295"></a>00295                 
<a name="l00296"></a>00296                 output(index) = value;
<a name="l00297"></a>00297               }
<a name="l00298"></a>00298               
<a name="l00299"></a>00299             }
<a name="l00300"></a>00300             
<a name="l00301"></a>00301             <span class="comment">// next variable</span>
<a name="l00302"></a>00302           }
<a name="l00303"></a>00303       }
<a name="l00304"></a>00304     }
<a name="l00305"></a>00305       
<a name="l00306"></a>00306   <span class="comment">// all done</span>
<a name="l00307"></a>00307   <span class="keywordflow">return</span>;
<a name="l00308"></a>00308 }
<a name="l00309"></a>00309 
<a name="l00310"></a>00310 
<a name="l00311"></a>00311 
<a name="l00312"></a><a class="code" href="classMeshFunction.php#ae00bd32d2f4c279f5a600d2aac0ffe66">00312</a> <span class="keywordtype">void</span> <a class="code" href="classMeshFunction.php#a37bc6d22da064994a924034ddc1d5b2f">MeshFunction::gradient</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00313"></a>00313                              <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>,
<a name="l00314"></a>00314                              std::vector&lt;Gradient&gt;&amp; output)
<a name="l00315"></a>00315 {
<a name="l00316"></a>00316   libmesh_assert (this-&gt;<a class="code" href="classFunctionBase.php#a19afe60a9016248664396f20200a43cb">initialized</a>());
<a name="l00317"></a>00317 
<a name="l00318"></a>00318   <span class="comment">/* Ensure that in the case of a master mesh function, the</span>
<a name="l00319"></a>00319 <span class="comment">     out-of-mesh mode is enabled either for both or for none.  This is</span>
<a name="l00320"></a>00320 <span class="comment">     important because the out-of-mesh mode is also communicated to</span>
<a name="l00321"></a>00321 <span class="comment">     the point locator.  Since this is time consuming, enable it only</span>
<a name="l00322"></a>00322 <span class="comment">     in debug mode.  */</span>
<a name="l00323"></a>00323 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00324"></a>00324 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classFunctionBase.php#a1ce94dacc6f531735410ff11045e3526">_master</a> != NULL)
<a name="l00325"></a>00325     {
<a name="l00326"></a>00326       <span class="keyword">const</span> <a class="code" href="classMeshFunction.php">MeshFunction</a>* master =
<a name="l00327"></a>00327         libmesh_cast_ptr&lt;const MeshFunction*&gt;(this-&gt;<a class="code" href="classFunctionBase.php#a1ce94dacc6f531735410ff11045e3526">_master</a>);
<a name="l00328"></a>00328       <span class="keywordflow">if</span>(<a class="code" href="classMeshFunction.php#a6772da79111c5f3a8b5c3de1fd66a47b">_out_of_mesh_mode</a>!=master-&gt;<a class="code" href="classMeshFunction.php#a6772da79111c5f3a8b5c3de1fd66a47b">_out_of_mesh_mode</a>)
<a name="l00329"></a>00329         {
<a name="l00330"></a>00330           std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: If you use out-of-mesh-mode in connection with master mesh functions, you must enable out-of-mesh mode for both the master and the slave mesh function.&quot;</span> &lt;&lt; std::endl;
<a name="l00331"></a>00331           libmesh_error();
<a name="l00332"></a>00332         }
<a name="l00333"></a>00333     }
<a name="l00334"></a>00334 <span class="preprocessor">#endif</span>
<a name="l00335"></a>00335 <span class="preprocessor"></span>  
<a name="l00336"></a>00336   <span class="comment">// locate the point in the other mesh</span>
<a name="l00337"></a>00337   <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* element = this-&gt;<a class="code" href="classMeshFunction.php#aa1ab9bf5bb1f3d92bf74cfd2d4ff5161">_point_locator</a>-&gt;operator()(p);
<a name="l00338"></a>00338 
<a name="l00339"></a>00339   <span class="keywordflow">if</span>(element==NULL)
<a name="l00340"></a>00340     {
<a name="l00341"></a>00341       output.resize(0);
<a name="l00342"></a>00342     }
<a name="l00343"></a>00343   <span class="keywordflow">else</span>
<a name="l00344"></a>00344     {
<a name="l00345"></a>00345       <span class="comment">// resize the output vector to the number of output values</span>
<a name="l00346"></a>00346       <span class="comment">// that the user told us</span>
<a name="l00347"></a>00347       output.resize (this-&gt;<a class="code" href="classMeshFunction.php#ae4f4abe1ac74f504008cf103a4daf924">_system_vars</a>.size());
<a name="l00348"></a>00348       
<a name="l00349"></a>00349       
<a name="l00350"></a>00350       {
<a name="l00351"></a>00351         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = this-&gt;<a class="code" href="classMeshFunction.php#a76cb0a16b37199f910e7728d67a784ad">_eqn_systems</a>.<a class="code" href="classEquationSystems.php#ad8d458ae6a34c460e72b3279373d4a70">get_mesh</a>().<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>();
<a name="l00352"></a>00352         
<a name="l00353"></a>00353         
<a name="l00354"></a>00354         <span class="comment">/*</span>
<a name="l00355"></a>00355 <span class="comment">         * Get local coordinates to feed these into compute_data().  </span>
<a name="l00356"></a>00356 <span class="comment">         * Note that the fe_type can safely be used from the 0-variable,</span>
<a name="l00357"></a>00357 <span class="comment">         * since the inverse mapping is the same for all FEFamilies</span>
<a name="l00358"></a>00358 <span class="comment">         */</span>
<a name="l00359"></a>00359         <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> mapped_point (<a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FEInterface::inverse_map</a> (dim, 
<a name="l00360"></a>00360                                                             this-&gt;<a class="code" href="classMeshFunction.php#a0553b98b9f8bed5d222cc9d5ec96fab2">_dof_map</a>.<a class="code" href="classDofMap.php#ae3c63266417020f38af6e5cc40efca76">variable_type</a>(0),
<a name="l00361"></a>00361                                                             element, 
<a name="l00362"></a>00362                                                             p));
<a name="l00363"></a>00363         
<a name="l00364"></a>00364         std::vector&lt;Point&gt; point_list (1, mapped_point);
<a name="l00365"></a>00365         
<a name="l00366"></a>00366         <span class="comment">// loop over all vars</span>
<a name="l00367"></a>00367         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=0; index &lt; this-&gt;<a class="code" href="classMeshFunction.php#ae4f4abe1ac74f504008cf103a4daf924">_system_vars</a>.size(); index++)
<a name="l00368"></a>00368           {
<a name="l00369"></a>00369             <span class="comment">/*</span>
<a name="l00370"></a>00370 <span class="comment">             * the data for this variable</span>
<a name="l00371"></a>00371 <span class="comment">             */</span>
<a name="l00372"></a>00372             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = <a class="code" href="classMeshFunction.php#ae4f4abe1ac74f504008cf103a4daf924">_system_vars</a>[index];
<a name="l00373"></a>00373             <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_type = this-&gt;<a class="code" href="classMeshFunction.php#a0553b98b9f8bed5d222cc9d5ec96fab2">_dof_map</a>.<a class="code" href="classDofMap.php#ae3c63266417020f38af6e5cc40efca76">variable_type</a>(var);
<a name="l00374"></a>00374 
<a name="l00375"></a>00375             <a class="code" href="classAutoPtr.php">AutoPtr&lt;FEBase&gt;</a> point_fe (<a class="code" href="classFEBase.php#a3e86219b79ce4f881e9c48f4fd7b860e">FEBase::build</a>(dim, fe_type));
<a name="l00376"></a>00376             <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt;&amp; dphi = point_fe-&gt;get_dphi();
<a name="l00377"></a>00377             point_fe-&gt;reinit(element, &amp;point_list);
<a name="l00378"></a>00378             
<a name="l00379"></a>00379             <span class="comment">// where the solution values for the var-th variable are stored</span>
<a name="l00380"></a>00380             std::vector&lt;unsigned int&gt; dof_indices;
<a name="l00381"></a>00381             this-&gt;<a class="code" href="classMeshFunction.php#a0553b98b9f8bed5d222cc9d5ec96fab2">_dof_map</a>.<a class="code" href="classDofMap.php#afc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (element, dof_indices, var);
<a name="l00382"></a>00382               
<a name="l00383"></a>00383             <span class="comment">// interpolate the solution</span>
<a name="l00384"></a>00384             <a class="code" href="classVectorValue.php">Gradient</a> grad(0.);
<a name="l00385"></a>00385                 
<a name="l00386"></a>00386             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;dof_indices.size(); i++)
<a name="l00387"></a>00387               grad.<a class="code" href="classTypeVector.php#ac9000695cb19991b893cb79a07249e9c">add_scaled</a>(dphi[i][0], this-&gt;_vector(dof_indices[i]));
<a name="l00388"></a>00388                 
<a name="l00389"></a>00389             output[index] = grad;
<a name="l00390"></a>00390           }
<a name="l00391"></a>00391       }
<a name="l00392"></a>00392     }
<a name="l00393"></a>00393       
<a name="l00394"></a>00394   <span class="comment">// all done</span>
<a name="l00395"></a>00395   <span class="keywordflow">return</span>;
<a name="l00396"></a>00396 }
<a name="l00397"></a>00397 
<a name="l00398"></a>00398 
<a name="l00399"></a>00399 
<a name="l00400"></a>00400 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00401"></a><a class="code" href="classMeshFunction.php#ae9b174313d566a009dc61f8c6c0837a7">00401</a> <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="classMeshFunction.php#a020bc9e4fcb430939b3dd92be8fe78c9">MeshFunction::hessian</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00402"></a>00402                             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>,
<a name="l00403"></a>00403                             std::vector&lt;Tensor&gt;&amp; output)
<a name="l00404"></a>00404 {
<a name="l00405"></a>00405   libmesh_assert (this-&gt;<a class="code" href="classFunctionBase.php#a19afe60a9016248664396f20200a43cb">initialized</a>());
<a name="l00406"></a>00406 
<a name="l00407"></a>00407   <span class="comment">/* Ensure that in the case of a master mesh function, the</span>
<a name="l00408"></a>00408 <span class="comment">     out-of-mesh mode is enabled either for both or for none.  This is</span>
<a name="l00409"></a>00409 <span class="comment">     important because the out-of-mesh mode is also communicated to</span>
<a name="l00410"></a>00410 <span class="comment">     the point locator.  Since this is time consuming, enable it only</span>
<a name="l00411"></a>00411 <span class="comment">     in debug mode.  */</span>
<a name="l00412"></a>00412 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00413"></a>00413 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classFunctionBase.php#a1ce94dacc6f531735410ff11045e3526">_master</a> != NULL)
<a name="l00414"></a>00414     {
<a name="l00415"></a>00415       <span class="keyword">const</span> <a class="code" href="classMeshFunction.php">MeshFunction</a>* master =
<a name="l00416"></a>00416         libmesh_cast_ptr&lt;const MeshFunction*&gt;(this-&gt;<a class="code" href="classFunctionBase.php#a1ce94dacc6f531735410ff11045e3526">_master</a>);
<a name="l00417"></a>00417       <span class="keywordflow">if</span>(<a class="code" href="classMeshFunction.php#a6772da79111c5f3a8b5c3de1fd66a47b">_out_of_mesh_mode</a>!=master-&gt;<a class="code" href="classMeshFunction.php#a6772da79111c5f3a8b5c3de1fd66a47b">_out_of_mesh_mode</a>)
<a name="l00418"></a>00418         {
<a name="l00419"></a>00419           std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: If you use out-of-mesh-mode in connection with master mesh functions, you must enable out-of-mesh mode for both the master and the slave mesh function.&quot;</span> &lt;&lt; std::endl;
<a name="l00420"></a>00420           libmesh_error();
<a name="l00421"></a>00421         }
<a name="l00422"></a>00422     }
<a name="l00423"></a>00423 <span class="preprocessor">#endif</span>
<a name="l00424"></a>00424 <span class="preprocessor"></span>  
<a name="l00425"></a>00425   <span class="comment">// locate the point in the other mesh</span>
<a name="l00426"></a>00426   <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* element = this-&gt;<a class="code" href="classMeshFunction.php#aa1ab9bf5bb1f3d92bf74cfd2d4ff5161">_point_locator</a>-&gt;operator()(p);
<a name="l00427"></a>00427 
<a name="l00428"></a>00428   <span class="keywordflow">if</span>(element==NULL)
<a name="l00429"></a>00429     {
<a name="l00430"></a>00430       output.resize(0);
<a name="l00431"></a>00431     }
<a name="l00432"></a>00432   <span class="keywordflow">else</span>
<a name="l00433"></a>00433     {
<a name="l00434"></a>00434       <span class="comment">// resize the output vector to the number of output values</span>
<a name="l00435"></a>00435       <span class="comment">// that the user told us</span>
<a name="l00436"></a>00436       output.resize (this-&gt;<a class="code" href="classMeshFunction.php#ae4f4abe1ac74f504008cf103a4daf924">_system_vars</a>.size());
<a name="l00437"></a>00437       
<a name="l00438"></a>00438       
<a name="l00439"></a>00439       {
<a name="l00440"></a>00440         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = this-&gt;<a class="code" href="classMeshFunction.php#a76cb0a16b37199f910e7728d67a784ad">_eqn_systems</a>.<a class="code" href="classEquationSystems.php#ad8d458ae6a34c460e72b3279373d4a70">get_mesh</a>().<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>();
<a name="l00441"></a>00441         
<a name="l00442"></a>00442         
<a name="l00443"></a>00443         <span class="comment">/*</span>
<a name="l00444"></a>00444 <span class="comment">         * Get local coordinates to feed these into compute_data().  </span>
<a name="l00445"></a>00445 <span class="comment">         * Note that the fe_type can safely be used from the 0-variable,</span>
<a name="l00446"></a>00446 <span class="comment">         * since the inverse mapping is the same for all FEFamilies</span>
<a name="l00447"></a>00447 <span class="comment">         */</span>
<a name="l00448"></a>00448         <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> mapped_point (<a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FEInterface::inverse_map</a> (dim, 
<a name="l00449"></a>00449                                                             this-&gt;<a class="code" href="classMeshFunction.php#a0553b98b9f8bed5d222cc9d5ec96fab2">_dof_map</a>.<a class="code" href="classDofMap.php#ae3c63266417020f38af6e5cc40efca76">variable_type</a>(0),
<a name="l00450"></a>00450                                                             element, 
<a name="l00451"></a>00451                                                             p));
<a name="l00452"></a>00452         
<a name="l00453"></a>00453         std::vector&lt;Point&gt; point_list (1, mapped_point);
<a name="l00454"></a>00454         
<a name="l00455"></a>00455         <span class="comment">// loop over all vars</span>
<a name="l00456"></a>00456         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=0; index &lt; this-&gt;<a class="code" href="classMeshFunction.php#ae4f4abe1ac74f504008cf103a4daf924">_system_vars</a>.size(); index++)
<a name="l00457"></a>00457           {
<a name="l00458"></a>00458             <span class="comment">/*</span>
<a name="l00459"></a>00459 <span class="comment">             * the data for this variable</span>
<a name="l00460"></a>00460 <span class="comment">             */</span>
<a name="l00461"></a>00461             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = <a class="code" href="classMeshFunction.php#ae4f4abe1ac74f504008cf103a4daf924">_system_vars</a>[index];
<a name="l00462"></a>00462             <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_type = this-&gt;<a class="code" href="classMeshFunction.php#a0553b98b9f8bed5d222cc9d5ec96fab2">_dof_map</a>.<a class="code" href="classDofMap.php#ae3c63266417020f38af6e5cc40efca76">variable_type</a>(var);
<a name="l00463"></a>00463 
<a name="l00464"></a>00464             <a class="code" href="classAutoPtr.php">AutoPtr&lt;FEBase&gt;</a> point_fe (<a class="code" href="classFEBase.php#a3e86219b79ce4f881e9c48f4fd7b860e">FEBase::build</a>(dim, fe_type));
<a name="l00465"></a>00465             <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealTensor&gt; &gt;&amp; d2phi =
<a name="l00466"></a>00466                             point_fe-&gt;get_d2phi();
<a name="l00467"></a>00467             point_fe-&gt;reinit(element, &amp;point_list);
<a name="l00468"></a>00468             
<a name="l00469"></a>00469             <span class="comment">// where the solution values for the var-th variable are stored</span>
<a name="l00470"></a>00470             std::vector&lt;unsigned int&gt; dof_indices;
<a name="l00471"></a>00471             this-&gt;<a class="code" href="classMeshFunction.php#a0553b98b9f8bed5d222cc9d5ec96fab2">_dof_map</a>.<a class="code" href="classDofMap.php#afc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (element, dof_indices, var);
<a name="l00472"></a>00472               
<a name="l00473"></a>00473             <span class="comment">// interpolate the solution</span>
<a name="l00474"></a>00474             <a class="code" href="classTensorValue.php">Tensor</a> hess;
<a name="l00475"></a>00475                 
<a name="l00476"></a>00476             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;dof_indices.size(); i++)
<a name="l00477"></a>00477               hess.<a class="code" href="classTypeTensor.php#ae24569251bc6ea38090165d349fdfc6c">add_scaled</a>(d2phi[i][0], this-&gt;_vector(dof_indices[i]));
<a name="l00478"></a>00478                 
<a name="l00479"></a>00479             output[index] = hess;
<a name="l00480"></a>00480           }
<a name="l00481"></a>00481       }
<a name="l00482"></a>00482     }
<a name="l00483"></a>00483       
<a name="l00484"></a>00484   <span class="comment">// all done</span>
<a name="l00485"></a>00485   <span class="keywordflow">return</span>;
<a name="l00486"></a>00486 }
<a name="l00487"></a>00487 <span class="preprocessor">#endif</span>
<a name="l00488"></a>00488 <span class="preprocessor"></span>
<a name="l00489"></a>00489 
<a name="l00490"></a>00490 
<a name="l00491"></a><a class="code" href="classMeshFunction.php#a4e824e5fb6d742ee5a89641ef158df8d">00491</a> <span class="keyword">const</span> <a class="code" href="classPointLocatorBase.php">PointLocatorBase</a>&amp; <a class="code" href="classMeshFunction.php#a4e824e5fb6d742ee5a89641ef158df8d">MeshFunction::get_point_locator</a> (<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00492"></a>00492 <span class="keyword"></span>{
<a name="l00493"></a>00493   libmesh_assert (this-&gt;<a class="code" href="classFunctionBase.php#a19afe60a9016248664396f20200a43cb">initialized</a>());
<a name="l00494"></a>00494   <span class="keywordflow">return</span> *<a class="code" href="classMeshFunction.php#aa1ab9bf5bb1f3d92bf74cfd2d4ff5161">_point_locator</a>;
<a name="l00495"></a>00495 }
<a name="l00496"></a>00496 
<a name="l00497"></a><a class="code" href="classMeshFunction.php#a470f2222523faf8a065426820819cc40">00497</a> <span class="keywordtype">void</span> <a class="code" href="classMeshFunction.php#a470f2222523faf8a065426820819cc40">MeshFunction::enable_out_of_mesh_mode</a>(<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a>&amp; value)
<a name="l00498"></a>00498 {
<a name="l00499"></a>00499   libmesh_assert (this-&gt;<a class="code" href="classFunctionBase.php#a19afe60a9016248664396f20200a43cb">initialized</a>());
<a name="l00500"></a>00500   <a class="code" href="classMeshFunction.php#aa1ab9bf5bb1f3d92bf74cfd2d4ff5161">_point_locator</a>-&gt;<a class="code" href="classPointLocatorBase.php#aec919dca35fe706fee3bb10c2aa1f52b">enable_out_of_mesh_mode</a>();
<a name="l00501"></a>00501   <a class="code" href="classMeshFunction.php#a6772da79111c5f3a8b5c3de1fd66a47b">_out_of_mesh_mode</a> = <span class="keyword">true</span>;
<a name="l00502"></a>00502   <a class="code" href="classMeshFunction.php#a87975159e2b86966c930446c472e2f42">_out_of_mesh_value</a> = value;
<a name="l00503"></a>00503 }
<a name="l00504"></a>00504 
<a name="l00505"></a><a class="code" href="classMeshFunction.php#ae49ad4ceaa55cf9e5d63400ed8f4cca4">00505</a> <span class="keywordtype">void</span> <a class="code" href="classMeshFunction.php#a470f2222523faf8a065426820819cc40">MeshFunction::enable_out_of_mesh_mode</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>&amp; value)
<a name="l00506"></a>00506 {
<a name="l00507"></a>00507   <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a> v(1);
<a name="l00508"></a>00508   v(0) = value;
<a name="l00509"></a>00509   this-&gt;<a class="code" href="classMeshFunction.php#a470f2222523faf8a065426820819cc40">enable_out_of_mesh_mode</a>(v);
<a name="l00510"></a>00510 }
<a name="l00511"></a>00511 
<a name="l00512"></a><a class="code" href="classMeshFunction.php#aecb6bd92dfd4c6c49006f711b47a67e5">00512</a> <span class="keywordtype">void</span> <a class="code" href="classMeshFunction.php#aecb6bd92dfd4c6c49006f711b47a67e5">MeshFunction::disable_out_of_mesh_mode</a>(<span class="keywordtype">void</span>)
<a name="l00513"></a>00513 {
<a name="l00514"></a>00514   libmesh_assert (this-&gt;<a class="code" href="classFunctionBase.php#a19afe60a9016248664396f20200a43cb">initialized</a>());
<a name="l00515"></a>00515   <a class="code" href="classMeshFunction.php#aa1ab9bf5bb1f3d92bf74cfd2d4ff5161">_point_locator</a>-&gt;<a class="code" href="classPointLocatorBase.php#af85fad7094f10dbb9d6095738c960474">disable_out_of_mesh_mode</a>();
<a name="l00516"></a>00516   <a class="code" href="classMeshFunction.php#a6772da79111c5f3a8b5c3de1fd66a47b">_out_of_mesh_mode</a> = <span class="keyword">false</span>;
<a name="l00517"></a>00517 }
<a name="l00518"></a>00518 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
