<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_function.h</h1>  </div>
</div>
<div class="contents">
<a href="mesh__function_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_function.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __mesh_function_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_function_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;function_base.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;dense_vector.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;vector_value.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;tensor_value.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;tree_base.h&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Forward Declarations</span>
<a name="l00038"></a>00038 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classDenseVector.php">DenseVector</a>;
<a name="l00039"></a>00039 <span class="keyword">class </span><a class="code" href="classEquationSystems.php">EquationSystems</a>;
<a name="l00040"></a>00040 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classNumericVector.php">NumericVector</a>;
<a name="l00041"></a>00041 <span class="keyword">class </span><a class="code" href="classDofMap.php">DofMap</a>;
<a name="l00042"></a>00042 <span class="keyword">class </span><a class="code" href="classPointLocatorBase.php">PointLocatorBase</a>;
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00053"></a>00053 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00054"></a>00054 <span class="comment">// MeshFunction class definition</span>
<a name="l00055"></a><a class="code" href="classMeshFunction.php">00055</a> <span class="keyword">class </span><a class="code" href="classMeshFunction.php">MeshFunction</a> : <span class="keyword">public</span> <a class="code" href="classFunctionBase.php">FunctionBase</a>
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057 <span class="keyword">public</span>:
<a name="l00058"></a>00058 
<a name="l00067"></a>00067   <a class="code" href="classMeshFunction.php#af2f3632fb4b694e9c6f3f8a5f3d5ef2c">MeshFunction</a> (<span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; eqn_systems,
<a name="l00068"></a>00068                 <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp; vec,
<a name="l00069"></a>00069                 <span class="keyword">const</span> <a class="code" href="classDofMap.php">DofMap</a>&amp; dof_map,
<a name="l00070"></a>00070                 <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; vars,
<a name="l00071"></a>00071                 <span class="keyword">const</span> <a class="code" href="classFunctionBase.php">FunctionBase</a>* master=NULL);
<a name="l00072"></a>00072 
<a name="l00081"></a>00081   <a class="code" href="classMeshFunction.php#af2f3632fb4b694e9c6f3f8a5f3d5ef2c">MeshFunction</a> (<span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; eqn_systems,
<a name="l00082"></a>00082                 <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp; vec,
<a name="l00083"></a>00083                 <span class="keyword">const</span> <a class="code" href="classDofMap.php">DofMap</a>&amp; dof_map,
<a name="l00084"></a>00084                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00085"></a>00085                 <span class="keyword">const</span> <a class="code" href="classFunctionBase.php">FunctionBase</a>* master=NULL);
<a name="l00086"></a>00086 
<a name="l00090"></a>00090   <a class="code" href="classMeshFunction.php#a3dee6569eff1d838c70c9138252a9f13">~MeshFunction</a> ();
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 
<a name="l00098"></a><a class="code" href="classMeshFunction.php#aaa9c42781e2b1ba8cede26f40f9d26be">00098</a>   <span class="keywordtype">void</span> <a class="code" href="classMeshFunction.php#aaa9c42781e2b1ba8cede26f40f9d26be">init</a> () { this-&gt;<a class="code" href="classMeshFunction.php#aaa9c42781e2b1ba8cede26f40f9d26be">init</a>(<a class="code" href="namespaceTrees.php#a8fb02eb8a700b646d106718a2d0ca3efa6ec2eeb88ab0a36caf9a31d79c3da8cb">Trees::NODES</a>); };
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00105"></a>00105   <span class="keywordtype">void</span> <a class="code" href="classMeshFunction.php#aaa9c42781e2b1ba8cede26f40f9d26be">init</a> (<span class="keyword">const</span> <a class="code" href="namespaceTrees.php#a8fb02eb8a700b646d106718a2d0ca3ef">Trees::BuildType</a> point_locator_build_type);
<a name="l00106"></a>00106 
<a name="l00110"></a>00110   <span class="keywordtype">void</span> <a class="code" href="classMeshFunction.php#a02d0d24f40963fcfaacd3b4585a5ac4a">clear</a> ();
<a name="l00111"></a>00111 
<a name="l00116"></a>00116   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classMeshFunction.php#a30afa61bb066df1a677df9c1c2d9a3e3">operator() </a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p, 
<a name="l00117"></a>00117                      <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> time=0.);
<a name="l00118"></a>00118 
<a name="l00123"></a>00123   <a class="code" href="classVectorValue.php">Gradient</a> <a class="code" href="classMeshFunction.php#a37bc6d22da064994a924034ddc1d5b2f">gradient</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p, 
<a name="l00124"></a>00124                      <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> time=0.);
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00127"></a>00127 <span class="preprocessor"></span>
<a name="l00131"></a>00131   <a class="code" href="classTensorValue.php">Tensor</a> <a class="code" href="classMeshFunction.php#a020bc9e4fcb430939b3dd92be8fe78c9">hessian</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p, 
<a name="l00132"></a>00132                   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> time=0.);
<a name="l00133"></a>00133 <span class="preprocessor">#endif</span>
<a name="l00134"></a>00134 <span class="preprocessor"></span>
<a name="l00139"></a>00139   <span class="keywordtype">void</span> <a class="code" href="classMeshFunction.php#a30afa61bb066df1a677df9c1c2d9a3e3">operator() </a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00140"></a>00140                    <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> time,
<a name="l00141"></a>00141                    <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a>&amp; output);
<a name="l00142"></a>00142 
<a name="l00147"></a>00147   <span class="keywordtype">void</span> <a class="code" href="classMeshFunction.php#a37bc6d22da064994a924034ddc1d5b2f">gradient</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00148"></a>00148                  <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> time,
<a name="l00149"></a>00149                  std::vector&lt;Gradient&gt;&amp; output);
<a name="l00150"></a>00150 
<a name="l00155"></a>00155   <span class="keywordtype">void</span> <a class="code" href="classMeshFunction.php#a020bc9e4fcb430939b3dd92be8fe78c9">hessian</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00156"></a>00156                 <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> time,
<a name="l00157"></a>00157                 std::vector&lt;Tensor&gt;&amp; output);
<a name="l00158"></a>00158 
<a name="l00164"></a>00164   <span class="keyword">const</span> <a class="code" href="classPointLocatorBase.php">PointLocatorBase</a>&amp; <a class="code" href="classMeshFunction.php#a4e824e5fb6d742ee5a89641ef158df8d">get_point_locator</a> (<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00165"></a>00165 
<a name="l00176"></a>00176   <span class="keywordtype">void</span> <a class="code" href="classMeshFunction.php#a470f2222523faf8a065426820819cc40">enable_out_of_mesh_mode</a>(<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a>&amp; value);
<a name="l00177"></a>00177 
<a name="l00188"></a>00188   <span class="keywordtype">void</span> <a class="code" href="classMeshFunction.php#a470f2222523faf8a065426820819cc40">enable_out_of_mesh_mode</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>&amp; value);
<a name="l00189"></a>00189 
<a name="l00193"></a>00193   <span class="keywordtype">void</span> <a class="code" href="classMeshFunction.php#aecb6bd92dfd4c6c49006f711b47a67e5">disable_out_of_mesh_mode</a>(<span class="keywordtype">void</span>);
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 <span class="keyword">protected</span>:
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00202"></a><a class="code" href="classMeshFunction.php#a76cb0a16b37199f910e7728d67a784ad">00202</a>   <span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; <a class="code" href="classMeshFunction.php#a76cb0a16b37199f910e7728d67a784ad">_eqn_systems</a>;
<a name="l00203"></a>00203 
<a name="l00208"></a><a class="code" href="classMeshFunction.php#a175447a4bbbc9d931b1aafdc0036591a">00208</a>   <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp; <a class="code" href="classMeshFunction.php#a175447a4bbbc9d931b1aafdc0036591a">_vector</a>;
<a name="l00209"></a>00209 
<a name="l00213"></a><a class="code" href="classMeshFunction.php#a0553b98b9f8bed5d222cc9d5ec96fab2">00213</a>   <span class="keyword">const</span> <a class="code" href="classDofMap.php">DofMap</a>&amp; <a class="code" href="classMeshFunction.php#a0553b98b9f8bed5d222cc9d5ec96fab2">_dof_map</a>;
<a name="l00214"></a>00214 
<a name="l00219"></a><a class="code" href="classMeshFunction.php#ae4f4abe1ac74f504008cf103a4daf924">00219</a>   <span class="keyword">const</span> std::vector&lt;unsigned int&gt; <a class="code" href="classMeshFunction.php#ae4f4abe1ac74f504008cf103a4daf924">_system_vars</a>;
<a name="l00220"></a>00220 
<a name="l00225"></a><a class="code" href="classMeshFunction.php#aa1ab9bf5bb1f3d92bf74cfd2d4ff5161">00225</a>   <a class="code" href="classPointLocatorBase.php">PointLocatorBase</a>* <a class="code" href="classMeshFunction.php#aa1ab9bf5bb1f3d92bf74cfd2d4ff5161">_point_locator</a>;
<a name="l00226"></a>00226 
<a name="l00231"></a><a class="code" href="classMeshFunction.php#a6772da79111c5f3a8b5c3de1fd66a47b">00231</a>   <span class="keywordtype">bool</span> <a class="code" href="classMeshFunction.php#a6772da79111c5f3a8b5c3de1fd66a47b">_out_of_mesh_mode</a>;
<a name="l00232"></a>00232 
<a name="l00237"></a><a class="code" href="classMeshFunction.php#a87975159e2b86966c930446c472e2f42">00237</a>   <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classMeshFunction.php#a87975159e2b86966c930446c472e2f42">_out_of_mesh_value</a>;
<a name="l00238"></a>00238 };
<a name="l00239"></a>00239 
<a name="l00240"></a>00240 
<a name="l00241"></a>00241 
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00244"></a>00244 <span class="comment">// MeshFunction inline methods</span>
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 <span class="preprocessor">#endif</span>
<a name="l00249"></a>00249 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
