<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_generation.h</h1>  </div>
</div>
<div class="contents">
<a href="mesh__generation_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_generation.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __mesh_generation_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_generation_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00031"></a>00031 <span class="comment">// #include &quot;libmesh_common.h&quot; // needed for Real</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;enum_elem_type.h&quot;</span> <span class="comment">// needed for ElemType enum</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;libmesh.h&quot;</span>        <span class="comment">// needed for libMesh::invalid_uint</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;point.h&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// forward declarations</span>
<a name="l00037"></a>00037 <span class="keyword">class </span><a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>;
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00042"></a>00042 <span class="comment">// MeshTools::Generation namespace</span>
<a name="l00043"></a><a class="code" href="namespaceMeshTools.php">00043</a> <span class="keyword">namespace </span>MeshTools
<a name="l00044"></a>00044 {
<a name="l00052"></a><a class="code" href="namespaceMeshTools_1_1Generation.php">00052</a>   <span class="keyword">namespace </span>Generation
<a name="l00053"></a>00053   {
<a name="l00060"></a>00060     <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools_1_1Generation.php#ad5d0b120fd95d4f7a3ee99738c2e8092">build_cube</a> (<a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; mesh,
<a name="l00061"></a>00061                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nx=0,
<a name="l00062"></a>00062                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ny=0,
<a name="l00063"></a>00063                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nz=0,
<a name="l00064"></a>00064                      <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xmin=0., <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xmax=1.,
<a name="l00065"></a>00065                      <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> ymin=0., <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> ymax=1.,
<a name="l00066"></a>00066                      <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> zmin=0., <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> zmax=1.,
<a name="l00067"></a>00067                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>,
<a name="l00068"></a>00068                      <span class="keyword">const</span> <span class="keywordtype">bool</span> gauss_lobatto_grid=<span class="keyword">false</span>);
<a name="l00069"></a>00069 
<a name="l00073"></a>00073     <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools_1_1Generation.php#abd76b51d5930afa44238f16af2d2ab53">build_line</a> (<a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; mesh,
<a name="l00074"></a>00074                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nx,
<a name="l00075"></a>00075                      <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xmin=0., <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xmax=1.,
<a name="l00076"></a>00076                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>,
<a name="l00077"></a>00077                      <span class="keyword">const</span> <span class="keywordtype">bool</span> gauss_lobatto_grid=<span class="keyword">false</span>);
<a name="l00078"></a>00078 
<a name="l00082"></a>00082     <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools_1_1Generation.php#adae70d90ceb3f11aa92b4786ff4a4790">build_square</a> (<a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; mesh,
<a name="l00083"></a>00083                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nx,
<a name="l00084"></a>00084                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ny,
<a name="l00085"></a>00085                        <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xmin=0., <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xmax=1.,
<a name="l00086"></a>00086                        <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> ymin=0., <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> ymax=1.,
<a name="l00087"></a>00087                        <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>,
<a name="l00088"></a>00088                        <span class="keyword">const</span> <span class="keywordtype">bool</span> gauss_lobatto_grid=<span class="keyword">false</span>);
<a name="l00089"></a>00089 
<a name="l00093"></a>00093     <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools_1_1Generation.php#a19d1d75793f5d27f3bd57acf5895ebef">build_sphere</a> (<a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; mesh,
<a name="l00094"></a>00094                        <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> rad=1,
<a name="l00095"></a>00095                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nr=2,
<a name="l00096"></a>00096                        <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>);
<a name="l00097"></a>00097 
<a name="l00098"></a>00098     
<a name="l00099"></a><a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php">00099</a>     <span class="keyword">namespace </span>Private
<a name="l00100"></a>00100     {
<a name="l00108"></a>00108       <span class="keyword">inline</span>
<a name="l00109"></a><a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">00109</a>       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type,
<a name="l00110"></a>00110                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nx,
<a name="l00111"></a>00111                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00112"></a>00112                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)
<a name="l00113"></a>00113       {
<a name="l00114"></a>00114         <span class="keywordflow">switch</span>(type)
<a name="l00115"></a>00115           {
<a name="l00116"></a>00116           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>:
<a name="l00117"></a>00117           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l00118"></a>00118           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00119"></a>00119             {
<a name="l00120"></a>00120               <span class="keywordflow">return</span> i + j*(nx+1);
<a name="l00121"></a>00121               <span class="keywordflow">break</span>;
<a name="l00122"></a>00122             }
<a name="l00123"></a>00123 
<a name="l00124"></a>00124           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00125"></a>00125           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00126"></a>00126           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00127"></a>00127             {
<a name="l00128"></a>00128               <span class="keywordflow">return</span> i + j*(2*nx+1);
<a name="l00129"></a>00129               <span class="keywordflow">break</span>;
<a name="l00130"></a>00130             }
<a name="l00131"></a>00131           
<a name="l00132"></a>00132           <span class="keywordflow">default</span>:
<a name="l00133"></a>00133             {
<a name="l00134"></a>00134               std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Unrecognized 2D element type.&quot;</span> &lt;&lt; std::endl;
<a name="l00135"></a>00135               libmesh_error();
<a name="l00136"></a>00136             }
<a name="l00137"></a>00137           }
<a name="l00138"></a>00138 
<a name="l00139"></a>00139         <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00140"></a>00140       }
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143     
<a name="l00144"></a>00144       <span class="comment">// Same as the function above, but for 3D elements</span>
<a name="l00145"></a>00145       <span class="keyword">inline</span>
<a name="l00146"></a><a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#a6421b911ec6c2d7eaf5a8efe3d770b7b">00146</a>       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type,
<a name="l00147"></a>00147                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nx,
<a name="l00148"></a>00148                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ny,
<a name="l00149"></a>00149                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00150"></a>00150                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00151"></a>00151                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)
<a name="l00152"></a>00152       {
<a name="l00153"></a>00153         <span class="keywordflow">switch</span>(type)
<a name="l00154"></a>00154           {
<a name="l00155"></a>00155           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>:
<a name="l00156"></a>00156           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00157"></a>00157           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l00158"></a>00158             {
<a name="l00159"></a>00159               <span class="keywordflow">return</span> i + (nx+1)*(j + k*(ny+1));
<a name="l00160"></a>00160               <span class="keywordflow">break</span>;
<a name="l00161"></a>00161             }
<a name="l00162"></a>00162 
<a name="l00163"></a>00163           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00164"></a>00164           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00165"></a>00165           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:  <span class="comment">// TET4&#39;s are created from an initial HEX27 discretization</span>
<a name="l00166"></a>00166           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>: <span class="comment">// TET10&#39;s are created from an initial HEX27 discretization</span>
<a name="l00167"></a>00167           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>: <span class="comment">// PYRAMID5&#39;s are created from an initial HEX27 discretization</span>
<a name="l00168"></a>00168           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l00169"></a>00169           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l00170"></a>00170             {
<a name="l00171"></a>00171               <span class="keywordflow">return</span> i + (2*nx+1)*(j + k*(2*ny+1));
<a name="l00172"></a>00172               <span class="keywordflow">break</span>;
<a name="l00173"></a>00173             }
<a name="l00174"></a>00174           
<a name="l00175"></a>00175           <span class="keywordflow">default</span>:
<a name="l00176"></a>00176             {
<a name="l00177"></a>00177               std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Unrecognized element type.&quot;</span> &lt;&lt; std::endl;
<a name="l00178"></a>00178               libmesh_error();
<a name="l00179"></a>00179             }
<a name="l00180"></a>00180           }
<a name="l00181"></a>00181       
<a name="l00182"></a>00182         <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00183"></a>00183       }
<a name="l00184"></a>00184     } <span class="comment">// end namespace Meshtools::Generation::Private</span>
<a name="l00185"></a>00185   } <span class="comment">// end namespace Meshtools::Generation</span>
<a name="l00186"></a>00186 } <span class="comment">// end namespace MeshTools</span>
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 <span class="preprocessor">#endif // #define __mesh_generation_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
