<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_input.h</h1>  </div>
</div>
<div class="contents">
<a href="mesh__input_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_input.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __mesh_input_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_input_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ inludes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;istream&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00046"></a>00046 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00047"></a>00047 <span class="comment">// MeshInput class definition</span>
<a name="l00048"></a>00048 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00049"></a><a class="code" href="classMeshInput.php">00049</a> <span class="keyword">class </span><a class="code" href="classMeshInput.php">MeshInput</a>
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051  <span class="keyword">protected</span>:
<a name="l00052"></a>00052 
<a name="l00057"></a>00057   <a class="code" href="classMeshInput.php#af5edcd27dba53e72d19b2eb78431070e">MeshInput</a> (<span class="keywordtype">bool</span> is_parallel_format = <span class="keyword">false</span>);
<a name="l00058"></a>00058   
<a name="l00063"></a>00063   <a class="code" href="classMeshInput.php#af5edcd27dba53e72d19b2eb78431070e">MeshInput</a> (MT&amp;, <span class="keyword">const</span> <span class="keywordtype">bool</span> is_parallel_format = <span class="keyword">false</span>);
<a name="l00064"></a>00064   
<a name="l00065"></a>00065  <span class="keyword">public</span>:
<a name="l00066"></a>00066 
<a name="l00070"></a>00070   <span class="keyword">virtual</span> <a class="code" href="classMeshInput.php#aabbad5f721d657d0e28a63ea50ca84a6">~MeshInput</a> ();
<a name="l00071"></a>00071   
<a name="l00075"></a>00075   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classMeshInput.php#a9d70b68a1cf29ba6a123c9270aac0c07">read</a> (<span class="keyword">const</span> std::string&amp;) = 0;
<a name="l00076"></a>00076 
<a name="l00077"></a>00077   
<a name="l00078"></a>00078  <span class="keyword">protected</span>:
<a name="l00079"></a>00079   
<a name="l00083"></a>00083   MT&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> ();
<a name="l00084"></a>00084   
<a name="l00089"></a>00089   <span class="keywordtype">void</span> <a class="code" href="classMeshInput.php#a1261f0e7a0d6284c4a1e321d13c3c3ec">skip_comment_lines</a> (std::istream&amp; in,
<a name="l00090"></a>00090                            <span class="keyword">const</span> <span class="keywordtype">char</span> comment_start);
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   
<a name="l00093"></a>00093  <span class="keyword">private</span>:
<a name="l00094"></a>00094   
<a name="l00095"></a>00095 
<a name="l00100"></a><a class="code" href="classMeshInput.php#a5207bc16e219cc08064aeb82752b6ccd">00100</a>   MT* <a class="code" href="classMeshInput.php#a5207bc16e219cc08064aeb82752b6ccd">_obj</a>;
<a name="l00101"></a>00101 
<a name="l00107"></a><a class="code" href="classMeshInput.php#a93d0af9d7aa75ebe512427c2ea349396">00107</a>   <span class="keyword">const</span> <span class="keywordtype">bool</span> <a class="code" href="classMeshInput.php#a93d0af9d7aa75ebe512427c2ea349396">_is_parallel_format</a>;
<a name="l00108"></a>00108 };
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00113"></a>00113 <span class="comment">// MeshInput inline members</span>
<a name="l00114"></a>00114 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00115"></a>00115 <span class="keyword">inline</span>
<a name="l00116"></a><a class="code" href="classMeshInput.php#af5edcd27dba53e72d19b2eb78431070e">00116</a> <a class="code" href="classMeshInput.php#af5edcd27dba53e72d19b2eb78431070e">MeshInput&lt;MT&gt;::MeshInput</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> is_parallel_format) :
<a name="l00117"></a>00117   _obj (NULL),
<a name="l00118"></a>00118   _is_parallel_format(is_parallel_format)
<a name="l00119"></a>00119 {
<a name="l00120"></a>00120 }
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00125"></a>00125 <span class="keyword">inline</span>
<a name="l00126"></a><a class="code" href="classMeshInput.php#a1a1b3c8aa9fec035ec13bd5e165651ae">00126</a> <a class="code" href="classMeshInput.php#af5edcd27dba53e72d19b2eb78431070e">MeshInput&lt;MT&gt;::MeshInput</a> (MT&amp; obj, <span class="keyword">const</span> <span class="keywordtype">bool</span> is_parallel_format) :
<a name="l00127"></a>00127   _obj (&amp;obj),
<a name="l00128"></a>00128   _is_parallel_format(is_parallel_format)
<a name="l00129"></a>00129 {
<a name="l00130"></a>00130   <span class="keywordflow">if</span> (!<a class="code" href="classMeshInput.php#a93d0af9d7aa75ebe512427c2ea349396">_is_parallel_format</a> &amp;&amp; !this-&gt;<a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a>().is_serial())
<a name="l00131"></a>00131     {
<a name="l00132"></a>00132       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00133"></a>00133         {
<a name="l00134"></a>00134           std::cerr &lt;&lt; <span class="stringliteral">&quot;Warning:  This I/O operation may only be supported for meshes which have been serialized!&quot;</span>
<a name="l00135"></a>00135                     &lt;&lt; std::endl;
<a name="l00136"></a>00136           libmesh_here();
<a name="l00137"></a>00137         }
<a name="l00138"></a>00138 <span class="comment">//      libmesh_error();</span>
<a name="l00139"></a>00139     }
<a name="l00140"></a>00140 }
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00145"></a>00145 <span class="keyword">inline</span>
<a name="l00146"></a><a class="code" href="classMeshInput.php#aabbad5f721d657d0e28a63ea50ca84a6">00146</a> <a class="code" href="classMeshInput.php#aabbad5f721d657d0e28a63ea50ca84a6">MeshInput&lt;MT&gt;::~MeshInput</a> ()
<a name="l00147"></a>00147 {
<a name="l00148"></a>00148 }
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00153"></a>00153 <span class="keyword">inline</span>
<a name="l00154"></a><a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">00154</a> MT&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshInput&lt;MT&gt;::mesh</a> ()
<a name="l00155"></a>00155 {
<a name="l00156"></a>00156   <span class="keywordflow">if</span> (_obj == NULL) libmesh_error();
<a name="l00157"></a>00157   <span class="keywordflow">return</span> *_obj;
<a name="l00158"></a>00158 }
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00163"></a><a class="code" href="classMeshInput.php#a1261f0e7a0d6284c4a1e321d13c3c3ec">00163</a> <span class="keywordtype">void</span> <a class="code" href="classMeshInput.php#a1261f0e7a0d6284c4a1e321d13c3c3ec">MeshInput&lt;MT&gt;::skip_comment_lines</a> (std::istream &amp;in,
<a name="l00164"></a>00164                                         <span class="keyword">const</span> <span class="keywordtype">char</span> comment_start)
<a name="l00165"></a>00165 {    
<a name="l00166"></a>00166   <span class="keywordtype">char</span> c, line[256];
<a name="l00167"></a>00167   
<a name="l00168"></a>00168   <span class="keywordflow">while</span> (in.get(c), c==comment_start) 
<a name="l00169"></a>00169     in.getline (line, 255);
<a name="l00170"></a>00170   
<a name="l00171"></a>00171   <span class="comment">// put back first character of</span>
<a name="l00172"></a>00172   <span class="comment">// first non-comment line</span>
<a name="l00173"></a>00173   in.putback (c);
<a name="l00174"></a>00174 }
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 <span class="preprocessor">#endif // #define __mesh_io_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
