<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_modification.h</h1>  </div>
</div>
<div class="contents">
<a href="mesh__modification_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_modification.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __mesh_modification_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_modification_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// forward declarations</span>
<a name="l00033"></a>00033 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00038"></a>00038 <span class="comment">// MeshTools::Modification namespace</span>
<a name="l00039"></a>00039 <span class="keyword">namespace </span>MeshTools
<a name="l00040"></a>00040 {
<a name="l00048"></a><a class="code" href="namespaceMeshTools_1_1Modification.php">00048</a>   <span class="keyword">namespace </span>Modification
<a name="l00049"></a>00049   {
<a name="l00057"></a>00057     <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools_1_1Modification.php#a08813703c0accf704831f803ed2d2c80">distort</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00058"></a>00058                   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> factor, <span class="keyword">const</span> <span class="keywordtype">bool</span> perturb_boundary=<span class="keyword">false</span>);
<a name="l00059"></a>00059     
<a name="l00065"></a>00065     <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools_1_1Modification.php#a9ea6796cd28c007c361acca73cbefcef">translate</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00066"></a>00066                     <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xt=0., <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> yt=0., <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> zt=0.); 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 <span class="comment">//     /**</span>
<a name="l00069"></a>00069 <span class="comment">//      * Rotates the mesh in the xy plane. The rotation is</span>
<a name="l00070"></a>00070 <span class="comment">//      * counter-clock-wise (mathematical definition).</span>
<a name="l00071"></a>00071 <span class="comment">//      * The angle is in degrees (360 make a full circle)</span>
<a name="l00072"></a>00072 <span class="comment">//      */</span>
<a name="l00073"></a>00073 <span class="comment">//     void rotate2D (MeshBase&amp; mesh,</span>
<a name="l00074"></a>00074 <span class="comment">//                    const Real alpha=0.); </span>
<a name="l00075"></a>00075 
<a name="l00082"></a>00082     <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools_1_1Modification.php#a3cce8711fb1d20118641f75c404c4ebf">rotate</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00083"></a>00083                  <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> phi, <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> theta=0., <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> psi=0.); 
<a name="l00084"></a>00084 
<a name="l00091"></a>00091     <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools_1_1Modification.php#ae71416e394dfbc45fe3d8b37b9b0c7ba">scale</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00092"></a>00092                 <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xs, <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> ys=0., <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> zs=0.);
<a name="l00093"></a>00093 
<a name="l00101"></a>00101     <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools_1_1Modification.php#a162f154fd343459f521755b3adec98ac">all_tri</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00102"></a>00102 
<a name="l00115"></a>00115     <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools_1_1Modification.php#a2d492d9bf61999cc7bc4e7d4b7afacd3">smooth</a>(<a class="code" href="classMeshBase.php">MeshBase</a>&amp;, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>);
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00118"></a>00118 <span class="preprocessor"></span>
<a name="l00127"></a>00127     <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools_1_1Modification.php#a0371191246ac4bfd786665fd705217d9">flatten</a>(<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00128"></a>00128 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00129"></a>00129 <span class="preprocessor"></span>    
<a name="l00134"></a>00134     <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools_1_1Modification.php#a5e587b0a8696f847d52fe1a9fb681427">change_boundary_id</a> (<a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00135"></a>00135                              <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> old_id,
<a name="l00136"></a>00136                              <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> new_id);
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   } <span class="comment">// end namespace Meshtools::Modification</span>
<a name="l00139"></a>00139 } <span class="comment">// end namespace MeshTools</span>
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 <span class="preprocessor">#endif // #define __mesh_modification_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
