<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_output.C</h1>  </div>
</div>
<div class="contents">
<a href="mesh__output_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_output.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// Local includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;mesh_output.h&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;equation_systems.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;unstructured_mesh.h&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00027"></a>00027 <span class="keywordtype">void</span> <a class="code" href="classMeshOutput.php#a2c80e4d3992e76e4e479adcacf32abd5">MeshOutput&lt;MT&gt;::</a>
<a name="l00028"></a><a class="code" href="classMeshOutput.php#a2c80e4d3992e76e4e479adcacf32abd5">00028</a> <a class="code" href="classMeshOutput.php#a2c80e4d3992e76e4e479adcacf32abd5">_build_variable_names_and_solution_vector</a> (<span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00029"></a>00029                                            std::vector&lt;Number&gt;&amp; soln,
<a name="l00030"></a>00030                                            std::vector&lt;std::string&gt;&amp; names)
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032   <span class="comment">// We need a serial mesh for MeshOutput for now</span>
<a name="l00033"></a>00033   <span class="keyword">const_cast&lt;</span><a class="code" href="classEquationSystems.php">EquationSystems</a>&amp;<span class="keyword">&gt;</span>(es).allgather();
<a name="l00034"></a>00034 
<a name="l00035"></a>00035   es.<a class="code" href="classEquationSystems.php#a90e9f4c77f1abf585f741c303e5edc29">build_variable_names</a>  (names);
<a name="l00036"></a>00036   es.<a class="code" href="classEquationSystems.php#aa7e2afc9d649b35d6bf1a2e8185b4169">build_solution_vector</a> (soln);
<a name="l00037"></a>00037 }
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">// Instantiate for our Mesh types.  If this becomes too cumbersome later,</span>
<a name="l00042"></a>00042 <span class="comment">// move any functions in this file to the header file instead.</span>
<a name="l00043"></a>00043 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classMeshOutput.php">MeshOutput&lt;MeshBase&gt;</a>;
<a name="l00044"></a>00044 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classMeshOutput.php">MeshOutput&lt;UnstructuredMesh&gt;</a>;
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
