<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_output.h</h1>  </div>
</div>
<div class="contents">
<a href="mesh__output_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_output.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __mesh_output_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_output_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ inludes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward declares</span>
<a name="l00035"></a>00035 <span class="keyword">class </span><a class="code" href="classEquationSystems.php">EquationSystems</a>;
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00048"></a>00048 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00049"></a>00049 <span class="comment">// MeshOutput class definition</span>
<a name="l00050"></a>00050 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00051"></a><a class="code" href="classMeshOutput.php">00051</a> <span class="keyword">class </span><a class="code" href="classMeshOutput.php">MeshOutput</a>
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053  <span class="keyword">protected</span>:
<a name="l00054"></a>00054 
<a name="l00059"></a>00059   <a class="code" href="classMeshOutput.php#a3878a3a0b42bb74ee9db15756d1e3cab">MeshOutput</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> is_parallel_format = <span class="keyword">false</span>);
<a name="l00060"></a>00060   
<a name="l00065"></a>00065   <a class="code" href="classMeshOutput.php#a3878a3a0b42bb74ee9db15756d1e3cab">MeshOutput</a> (<span class="keyword">const</span> MT&amp;, <span class="keyword">const</span> <span class="keywordtype">bool</span> is_parallel_format = <span class="keyword">false</span>);
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   
<a name="l00068"></a>00068  <span class="keyword">public</span>:
<a name="l00069"></a>00069 
<a name="l00073"></a>00073   <span class="keyword">virtual</span> <a class="code" href="classMeshOutput.php#aaaa6e4e868272ca6b9ef813e715079f9">~MeshOutput</a> ();
<a name="l00074"></a>00074   
<a name="l00078"></a>00078   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classMeshOutput.php#acffc6928a8a14b6b51fe1d3649d6d3f8">write</a> (<span class="keyword">const</span> std::string&amp;) = 0;
<a name="l00079"></a>00079 
<a name="l00084"></a>00084   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classMeshOutput.php#a5e0df1f5cd00cc7ae3cbe73e6a68fe0e">write_equation_systems</a> (<span class="keyword">const</span> std::string&amp;,
<a name="l00085"></a>00085                                        <span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp;);
<a name="l00086"></a>00086 
<a name="l00091"></a><a class="code" href="classMeshOutput.php#a8365780c326915d5da092628a3e85038">00091</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classMeshOutput.php#a8365780c326915d5da092628a3e85038">write_nodal_data</a> (<span class="keyword">const</span> std::string&amp;,
<a name="l00092"></a>00092                                  <span class="keyword">const</span> std::vector&lt;Number&gt;&amp;,
<a name="l00093"></a>00093                                  <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp;)
<a name="l00094"></a>00094   { libmesh_error(); }
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   
<a name="l00097"></a>00097  <span class="keyword">protected</span>:
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00103"></a>00103   <span class="keyword">const</span> MT&amp; <a class="code" href="classMeshOutput.php#af923657f1dcc7c26a973332295d94f13">mesh</a>() <span class="keyword">const</span>;
<a name="l00104"></a>00104 
<a name="l00105"></a>00105   
<a name="l00106"></a>00106  <span class="keyword">private</span>:
<a name="l00107"></a>00107   
<a name="l00108"></a>00108 
<a name="l00113"></a><a class="code" href="classMeshOutput.php#ae44781a4b9ec7016434357b1769d5094">00113</a>   <span class="keyword">const</span> MT* <span class="keyword">const</span> <a class="code" href="classMeshOutput.php#ae44781a4b9ec7016434357b1769d5094">_obj</a>;
<a name="l00114"></a>00114 
<a name="l00120"></a><a class="code" href="classMeshOutput.php#a2bb9240948c8c33dd34e3aff78b8bd5b">00120</a>   <span class="keyword">const</span> <span class="keywordtype">bool</span> <a class="code" href="classMeshOutput.php#a2bb9240948c8c33dd34e3aff78b8bd5b">_is_parallel_format</a>;
<a name="l00121"></a>00121 
<a name="l00126"></a>00126   <span class="keywordtype">void</span> <a class="code" href="classMeshOutput.php#a2c80e4d3992e76e4e479adcacf32abd5">_build_variable_names_and_solution_vector</a>(<span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00127"></a>00127                                                  std::vector&lt;Number&gt;&amp; soln,
<a name="l00128"></a>00128                                                  std::vector&lt;std::string&gt;&amp; names);
<a name="l00129"></a>00129 };
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00134"></a>00134 <span class="comment">// MeshOutput inline members</span>
<a name="l00135"></a>00135 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00136"></a>00136 <span class="keyword">inline</span>
<a name="l00137"></a><a class="code" href="classMeshOutput.php#a3878a3a0b42bb74ee9db15756d1e3cab">00137</a> <a class="code" href="classMeshOutput.php#a3878a3a0b42bb74ee9db15756d1e3cab">MeshOutput&lt;MT&gt;::MeshOutput</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> is_parallel_format) :
<a name="l00138"></a>00138   _obj(NULL),
<a name="l00139"></a>00139   _is_parallel_format(is_parallel_format)
<a name="l00140"></a>00140 {}
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00145"></a>00145 <span class="keyword">inline</span>
<a name="l00146"></a><a class="code" href="classMeshOutput.php#a34b5d3ea73db7876df3dde5e4699c4d3">00146</a> <a class="code" href="classMeshOutput.php#a3878a3a0b42bb74ee9db15756d1e3cab">MeshOutput&lt;MT&gt;::MeshOutput</a> (<span class="keyword">const</span> MT&amp; obj, <span class="keyword">const</span> <span class="keywordtype">bool</span> is_parallel_format) :
<a name="l00147"></a>00147   _obj (&amp;obj),
<a name="l00148"></a>00148   _is_parallel_format(is_parallel_format)
<a name="l00149"></a>00149 {
<a name="l00150"></a>00150   <span class="keywordflow">if</span> (!<a class="code" href="classMeshOutput.php#a2bb9240948c8c33dd34e3aff78b8bd5b">_is_parallel_format</a> &amp;&amp; !this-&gt;<a class="code" href="classMeshOutput.php#af923657f1dcc7c26a973332295d94f13">mesh</a>().is_serial())
<a name="l00151"></a>00151     {
<a name="l00152"></a>00152       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00153"></a>00153         {
<a name="l00154"></a>00154           std::cerr &lt;&lt; <span class="stringliteral">&quot;WARNING:  This I/O operation may only be supported for meshes which have been serialized!&quot;</span>
<a name="l00155"></a>00155                     &lt;&lt; std::endl;
<a name="l00156"></a>00156           libmesh_here();
<a name="l00157"></a>00157         }
<a name="l00158"></a>00158 <span class="comment">//      libmesh_error();</span>
<a name="l00159"></a>00159     }
<a name="l00160"></a>00160 }
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00165"></a>00165 <span class="keyword">inline</span>
<a name="l00166"></a><a class="code" href="classMeshOutput.php#aaaa6e4e868272ca6b9ef813e715079f9">00166</a> <a class="code" href="classMeshOutput.php#aaaa6e4e868272ca6b9ef813e715079f9">MeshOutput&lt;MT&gt;::~MeshOutput</a> ()
<a name="l00167"></a>00167 {
<a name="l00168"></a>00168 }
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00173"></a>00173 <span class="keyword">inline</span>
<a name="l00174"></a><a class="code" href="classMeshOutput.php#a5e0df1f5cd00cc7ae3cbe73e6a68fe0e">00174</a> <span class="keywordtype">void</span> <a class="code" href="classMeshOutput.php#a5e0df1f5cd00cc7ae3cbe73e6a68fe0e">MeshOutput&lt;MT&gt;::write_equation_systems</a> (<span class="keyword">const</span> std::string&amp; fname,
<a name="l00175"></a>00175                                              <span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es)
<a name="l00176"></a>00176 {
<a name="l00177"></a>00177   <span class="comment">// Build the nodal solution values &amp; get the variable</span>
<a name="l00178"></a>00178   <span class="comment">// names from the EquationSystems object</span>
<a name="l00179"></a>00179   std::vector&lt;Number&gt;      soln;
<a name="l00180"></a>00180   std::vector&lt;std::string&gt; names;
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   this-&gt;_build_variable_names_and_solution_vector(es, soln, names);
<a name="l00183"></a>00183   <span class="comment">//es.build_variable_names  (names);</span>
<a name="l00184"></a>00184   <span class="comment">//es.build_solution_vector (soln);</span>
<a name="l00185"></a>00185 
<a name="l00186"></a>00186   this-&gt;write_nodal_data (fname, soln, names);  
<a name="l00187"></a>00187 }
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00192"></a>00192 <span class="keyword">inline</span>
<a name="l00193"></a><a class="code" href="classMeshOutput.php#af923657f1dcc7c26a973332295d94f13">00193</a> <span class="keyword">const</span> MT&amp; <a class="code" href="classMeshOutput.php#af923657f1dcc7c26a973332295d94f13">MeshOutput&lt;MT&gt;::mesh</a> ()<span class="keyword"> const</span>
<a name="l00194"></a>00194 <span class="keyword"></span>{
<a name="l00195"></a>00195   libmesh_assert (_obj != NULL);
<a name="l00196"></a>00196   <span class="keywordflow">return</span> *_obj;
<a name="l00197"></a>00197 }
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 <span class="preprocessor">#endif // #define __mesh_io_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
