<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_refinement.h</h1>  </div>
</div>
<div class="contents">
<a href="mesh__refinement_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_refinement.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __mesh_refinement_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_refinement_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;libmesh.h&quot;</span> <span class="comment">// libMesh::invalid_uint</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;location_maps.h&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">// Forward Declarations -----------------------------</span>
<a name="l00040"></a>00040 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00041"></a>00041 <span class="keyword">class </span><a class="code" href="classPoint.php">Point</a>;
<a name="l00042"></a>00042 <span class="keyword">class </span><a class="code" href="classNode.php">Node</a>;
<a name="l00043"></a>00043 <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00044"></a>00044 <span class="keyword">class </span><a class="code" href="classErrorVector.php">ErrorVector</a>;
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00056"></a>00056 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00057"></a>00057 <span class="comment">// MeshRefinement class definition</span>
<a name="l00058"></a><a class="code" href="classMeshRefinement.php">00058</a> <span class="keyword">class </span><a class="code" href="classMeshRefinement.php">MeshRefinement</a>
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060 <span class="keyword">public</span>:
<a name="l00061"></a>00061 
<a name="l00065"></a>00065   <a class="code" href="classMeshRefinement.php#a7d394c81f2d11d13f5a9f674f1dca24c">MeshRefinement</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 <span class="keyword">private</span>:
<a name="l00068"></a>00068   <span class="comment">// Both the copy ctor and the assignment operator are </span>
<a name="l00069"></a>00069   <span class="comment">// declared private but not implemented.  This is the </span>
<a name="l00070"></a>00070   <span class="comment">// standard practice to prevent them from being used.</span>
<a name="l00071"></a>00071   <a class="code" href="classMeshRefinement.php#a7d394c81f2d11d13f5a9f674f1dca24c">MeshRefinement</a> (<span class="keyword">const</span> <a class="code" href="classMeshRefinement.php">MeshRefinement</a>&amp;);
<a name="l00072"></a>00072   <a class="code" href="classMeshRefinement.php">MeshRefinement</a>&amp; <a class="code" href="classMeshRefinement.php#a7943fbdc8c036db617c52eee836394a3">operator=</a>(<span class="keyword">const</span> <a class="code" href="classMeshRefinement.php">MeshRefinement</a>&amp;);
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 <span class="keyword">public</span>:
<a name="l00075"></a>00075 
<a name="l00079"></a>00079   <a class="code" href="classMeshRefinement.php#a21700694e32153fdac783406d91309d2">~MeshRefinement</a> ();
<a name="l00080"></a>00080 
<a name="l00084"></a>00084   <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#aaefd0f57b9d612831bbaf75cfcc1962c">clear</a> ();  
<a name="l00085"></a>00085 
<a name="l00097"></a>00097   <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#ae6ecd83fa4d99cb8ca0523343e920dba">flag_elements_by_error_fraction</a> (<span class="keyword">const</span> <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00098"></a>00098                                         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classMeshRefinement.php#a7d8764f7ce747af3b7699c44da248130">refine_fraction</a>  = 0.3,
<a name="l00099"></a>00099                                         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classMeshRefinement.php#a6cdd156d3549052f52cc5f66c6460395">coarsen_fraction</a> = 0.0,
<a name="l00100"></a>00100                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#aa7528fd4ca1533ce837c7aedc6a9a108">max_level</a> = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>);
<a name="l00101"></a>00101 
<a name="l00116"></a>00116   <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#acdae03bfd1baf8fe3be7cb42bf21bcbd">flag_elements_by_error_tolerance</a> (<span class="keyword">const</span> <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell);
<a name="l00117"></a>00117 
<a name="l00131"></a>00131   <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#aeb3cae01d544b3611116483b9f0ff815">flag_elements_by_nelem_target</a> (<span class="keyword">const</span> <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell);
<a name="l00132"></a>00132 
<a name="l00146"></a>00146   <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#ae36504bf3929c94a5dabb2b4e12ddcef">flag_elements_by_elem_fraction</a> (<span class="keyword">const</span> <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00147"></a>00147                                        <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classMeshRefinement.php#a7d8764f7ce747af3b7699c44da248130">refine_fraction</a>  = 0.3,
<a name="l00148"></a>00148                                        <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classMeshRefinement.php#a6cdd156d3549052f52cc5f66c6460395">coarsen_fraction</a> = 0.0,
<a name="l00149"></a>00149                                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#aa7528fd4ca1533ce837c7aedc6a9a108">max_level</a> = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>);
<a name="l00150"></a>00150 
<a name="l00164"></a>00164   <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#a2349085f6bbd241a5819366e85c4408a">flag_elements_by_mean_stddev</a> (<span class="keyword">const</span> <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00165"></a>00165                                      <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classMeshRefinement.php#a7d8764f7ce747af3b7699c44da248130">refine_fraction</a>  = 1.0,
<a name="l00166"></a>00166                                      <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classMeshRefinement.php#a6cdd156d3549052f52cc5f66c6460395">coarsen_fraction</a> = 0.0,
<a name="l00167"></a>00167                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#aa7528fd4ca1533ce837c7aedc6a9a108">max_level</a> = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>);
<a name="l00168"></a>00168 
<a name="l00173"></a>00173   <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#a122cf26f86f73d225fbaff4a6a2ed54b">switch_h_to_p_refinement</a>();
<a name="l00174"></a>00174 
<a name="l00179"></a>00179   <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#a4ed4a0cb7da0e8918458e09ba8d0a818">add_p_to_h_refinement</a>();
<a name="l00180"></a>00180 
<a name="l00192"></a>00192   <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#a0c992129fc3ed9b157eb98f2b75db7d9">refine_and_coarsen_elements</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> maintain_level_one=<span class="keyword">true</span>);
<a name="l00193"></a>00193 
<a name="l00205"></a>00205   <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#a34f81cc5a33c88fffe936b191e48cb24">coarsen_elements</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> maintain_level_one=<span class="keyword">true</span>);
<a name="l00206"></a>00206 
<a name="l00217"></a>00217   <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#ae8312ffdcfe06d7e83c4fde95480c299">refine_elements</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> maintain_level_one=<span class="keyword">true</span>);
<a name="l00218"></a>00218   
<a name="l00222"></a>00222   <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#a9fdd024cd000c1ac0bf52f9c777098c6">uniformly_refine</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=1);
<a name="l00223"></a>00223   
<a name="l00227"></a>00227   <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#ab1c27c47f0c680e97e3ef33c09312278">uniformly_coarsen</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=1);
<a name="l00228"></a>00228   
<a name="l00232"></a>00232   <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#a9a37541cb84e7ca981c7c4c6a3bc8f0b">uniformly_p_refine</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=1);
<a name="l00233"></a>00233   
<a name="l00237"></a>00237   <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#a03c0e4cc5b36b95c8044950c50b6745e">uniformly_p_coarsen</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=1);
<a name="l00238"></a>00238 
<a name="l00245"></a>00245   <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#ac11ceeab37e4935d02192813c539358d">test_level_one</a> (<span class="keywordtype">bool</span> libmesh_assert_yes = <span class="keyword">false</span>);
<a name="l00246"></a>00246   
<a name="l00254"></a>00254   <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#aa1fdda385ef81a73833abeac506d48bc">test_unflagged</a> (<span class="keywordtype">bool</span> libmesh_assert_yes = <span class="keyword">false</span>);
<a name="l00255"></a>00255   
<a name="l00263"></a>00263   <a class="code" href="classNode.php">Node</a>* <a class="code" href="classMeshRefinement.php#a1ba6d819dde6739791062d14a25e49aa">add_point</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00264"></a>00264                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">processor_id</a>,
<a name="l00265"></a>00265                    <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tol);
<a name="l00266"></a>00266 
<a name="l00270"></a>00270   <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classMeshRefinement.php#a2227d3f4c2e3cde51213d2845c0ce508">add_elem</a> (<a class="code" href="classElem.php">Elem</a>* elem);
<a name="l00271"></a>00271 
<a name="l00276"></a><a class="code" href="classMeshRefinement.php#a1adcccfefc3c4b1e98a2c966b89968db">00276</a>   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshRefinement.php#a1adcccfefc3c4b1e98a2c966b89968db">get_mesh</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>; }
<a name="l00277"></a>00277 
<a name="l00282"></a><a class="code" href="classMeshRefinement.php#a34c9275b5bab2b731814fbf6ff814969">00282</a>   <a class="code" href="classMeshBase.php">MeshBase</a>&amp;       <a class="code" href="classMeshRefinement.php#a34c9275b5bab2b731814fbf6ff814969">get_mesh</a> ()       { <span class="keywordflow">return</span> <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>; }
<a name="l00283"></a>00283 
<a name="l00291"></a>00291   <span class="keywordtype">bool</span>&amp; <a class="code" href="classMeshRefinement.php#a2629eb5e9570daa6227d6c33a7080183">coarsen_by_parents</a>();
<a name="l00292"></a>00292 
<a name="l00300"></a>00300   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&amp; <a class="code" href="classMeshRefinement.php#a7d8764f7ce747af3b7699c44da248130">refine_fraction</a>();
<a name="l00301"></a>00301 
<a name="l00309"></a>00309   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&amp; <a class="code" href="classMeshRefinement.php#a6cdd156d3549052f52cc5f66c6460395">coarsen_fraction</a>();
<a name="l00310"></a>00310 
<a name="l00317"></a>00317   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; <a class="code" href="classMeshRefinement.php#a2aa5825479021d92305c4af8c3d67a08">max_h_level</a>();
<a name="l00318"></a>00318 
<a name="l00327"></a>00327   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&amp; <a class="code" href="classMeshRefinement.php#a78a24fa995b0a09793ee8be77b7843be">coarsen_threshold</a>();
<a name="l00328"></a>00328 
<a name="l00336"></a>00336   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; <a class="code" href="classMeshRefinement.php#a03c879eb331829328247d2f19210bbac">nelem_target</a>();
<a name="l00337"></a>00337 
<a name="l00347"></a>00347   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&amp; <a class="code" href="classMeshRefinement.php#a9a094ad8a57648c536fa9e9ef4b58c10">absolute_global_tolerance</a>();
<a name="l00348"></a>00348 
<a name="l00359"></a>00359   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>&amp; <a class="code" href="classMeshRefinement.php#a16a41a634500d59084544c3d146aaaf4">face_level_mismatch_limit</a>();
<a name="l00360"></a>00360 
<a name="l00370"></a>00370   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>&amp; <a class="code" href="classMeshRefinement.php#a552e438f7c90bd73d1d9a6093314e809">edge_level_mismatch_limit</a>();
<a name="l00371"></a>00371 
<a name="l00381"></a>00381   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>&amp; <a class="code" href="classMeshRefinement.php#a646cdd8485355b0a247526939e16205d">node_level_mismatch_limit</a>();
<a name="l00382"></a>00382 
<a name="l00383"></a>00383 <span class="keyword">private</span>:
<a name="l00384"></a>00384 
<a name="l00399"></a>00399   <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#ae33151743e5987e4d216eac6a1142376">_coarsen_elements</a> ();
<a name="l00400"></a>00400   
<a name="l00409"></a>00409   <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#a2edc635e999cae1d61575a7dd54ca782">_refine_elements</a> ();
<a name="l00410"></a>00410 
<a name="l00411"></a>00411 
<a name="l00412"></a>00412 
<a name="l00413"></a>00413   <span class="comment">//------------------------------------------------------</span>
<a name="l00414"></a>00414   <span class="comment">// &quot;Smoothing&quot; algorthms for refined meshes</span>
<a name="l00415"></a>00415   
<a name="l00480"></a>00480   <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#a679686967e6929094bb35a045836c409">limit_level_mismatch_at_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_mismatch);
<a name="l00481"></a>00481 
<a name="l00482"></a>00482   <span class="comment">/*</span>
<a name="l00483"></a>00483 <span class="comment">   * This algorithm restricts the maximum level mismatch</span>
<a name="l00484"></a>00484 <span class="comment">   * at any edge in the mesh.  See the ASCII art in the comment of</span>
<a name="l00485"></a>00485 <span class="comment">   * limit_level_mismatch_at_node, and pretend they&#39;re hexes.</span>
<a name="l00486"></a>00486 <span class="comment">   */</span>
<a name="l00487"></a>00487   <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#ab10822f9e5af57f3816bdb766d315fd3">limit_level_mismatch_at_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_mismatch);
<a name="l00488"></a>00488 
<a name="l00541"></a>00541   <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#a0c58ffb7438dae0abb7a01b00a806400">eliminate_unrefined_patches</a> ();
<a name="l00542"></a>00542 
<a name="l00543"></a>00543 
<a name="l00544"></a>00544   <span class="comment">//---------------------------------------------</span>
<a name="l00545"></a>00545   <span class="comment">// Utility algorithms</span>
<a name="l00546"></a>00546 
<a name="l00552"></a>00552   <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#a0ccabd41707c7e688b674b3bc4f3d070">create_parent_error_vector</a> (<span class="keyword">const</span> <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00553"></a>00553                                    <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_parent,
<a name="l00554"></a>00554                                    <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> &amp;parent_error_min,
<a name="l00555"></a>00555                                    <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> &amp;parent_error_max);
<a name="l00556"></a>00556 
<a name="l00560"></a>00560   <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#a09537b2ea4265d398d94c1f1e547a2fe">update_nodes_map</a> ();
<a name="l00561"></a>00561 
<a name="l00566"></a>00566   <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#a78e121fabb0ee86091a7c39190440ca1">clean_refinement_flags</a> ();
<a name="l00567"></a>00567   
<a name="l00572"></a>00572   <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#a960de39287ae7d4821527767af11ea09">make_coarsening_compatible</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span>);
<a name="l00573"></a>00573 
<a name="l00578"></a>00578   <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#a95d2a98b52ef5a7360e4cba48b182c05">make_refinement_compatible</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span>);
<a name="l00579"></a>00579   
<a name="l00584"></a>00584   <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#a964d0b5fff0a75536267bc6ad8df166b">make_flags_parallel_consistent</a> ();
<a name="l00585"></a>00585   
<a name="l00590"></a><a class="code" href="classMeshRefinement.php#a830cefaa2e0f102fc921dc5cae2b5733">00590</a>   <a class="code" href="classLocationMap.php">LocationMap&lt;Node&gt;</a> <a class="code" href="classMeshRefinement.php#a830cefaa2e0f102fc921dc5cae2b5733">_new_nodes_map</a>;
<a name="l00591"></a>00591 
<a name="l00595"></a><a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">00595</a>   <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>;
<a name="l00596"></a>00596 
<a name="l00602"></a><a class="code" href="classMeshRefinement.php#acc86f42287bf425be9c995249e919954">00602</a>   <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#acc86f42287bf425be9c995249e919954">_use_member_parameters</a>;
<a name="l00603"></a>00603 
<a name="l00608"></a><a class="code" href="classMeshRefinement.php#a9aa08ca5c7d35aefbaf2a3520a4e03ba">00608</a>   <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#a9aa08ca5c7d35aefbaf2a3520a4e03ba">_coarsen_by_parents</a>;
<a name="l00609"></a>00609 
<a name="l00610"></a><a class="code" href="classMeshRefinement.php#a4575eddb3967dab44119aa774fc72a7e">00610</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classMeshRefinement.php#a4575eddb3967dab44119aa774fc72a7e">_refine_fraction</a>;
<a name="l00611"></a>00611 
<a name="l00612"></a><a class="code" href="classMeshRefinement.php#afc8f8e7f1fc8710c8c8746ead90589dc">00612</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classMeshRefinement.php#afc8f8e7f1fc8710c8c8746ead90589dc">_coarsen_fraction</a>;
<a name="l00613"></a>00613 
<a name="l00614"></a><a class="code" href="classMeshRefinement.php#ad519253a5183e1cb16f424fbd85c2372">00614</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshRefinement.php#ad519253a5183e1cb16f424fbd85c2372">_max_h_level</a>;
<a name="l00615"></a>00615 
<a name="l00616"></a><a class="code" href="classMeshRefinement.php#aab34acc013af03cf5a1bc96a7e6424c8">00616</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classMeshRefinement.php#aab34acc013af03cf5a1bc96a7e6424c8">_coarsen_threshold</a>;
<a name="l00617"></a>00617 
<a name="l00618"></a><a class="code" href="classMeshRefinement.php#a69043d3abcb7dca9b1a3c7aeb6177a45">00618</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMeshRefinement.php#a69043d3abcb7dca9b1a3c7aeb6177a45">_nelem_target</a>;
<a name="l00619"></a>00619 
<a name="l00620"></a><a class="code" href="classMeshRefinement.php#aaccb6fd2619e2bee7217bde633673d32">00620</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classMeshRefinement.php#aaccb6fd2619e2bee7217bde633673d32">_absolute_global_tolerance</a>;
<a name="l00621"></a>00621 
<a name="l00622"></a><a class="code" href="classMeshRefinement.php#a46b608a8db8dbb59f693a137e19ea458">00622</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="classMeshRefinement.php#a6f1ce9fd520404fd1076968ef4c95dad">_face_level_mismatch_limit</a>, <a class="code" href="classMeshRefinement.php#af529cf6d70ea8e067d667f07269862a7">_edge_level_mismatch_limit</a>,
<a name="l00623"></a>00623                 <a class="code" href="classMeshRefinement.php#a46b608a8db8dbb59f693a137e19ea458">_node_level_mismatch_limit</a>;
<a name="l00624"></a>00624 };
<a name="l00625"></a>00625 
<a name="l00626"></a>00626 
<a name="l00627"></a>00627 
<a name="l00628"></a>00628 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00629"></a>00629 <span class="comment">// MeshRefinement class inline members</span>
<a name="l00630"></a>00630 
<a name="l00631"></a><a class="code" href="classMeshRefinement.php#a2629eb5e9570daa6227d6c33a7080183">00631</a> <span class="keyword">inline</span> <span class="keywordtype">bool</span>&amp; <a class="code" href="classMeshRefinement.php#a2629eb5e9570daa6227d6c33a7080183">MeshRefinement::coarsen_by_parents</a>()
<a name="l00632"></a>00632 {
<a name="l00633"></a>00633   <a class="code" href="classMeshRefinement.php#acc86f42287bf425be9c995249e919954">_use_member_parameters</a> = <span class="keyword">true</span>;
<a name="l00634"></a>00634   <span class="keywordflow">return</span> <a class="code" href="classMeshRefinement.php#a9aa08ca5c7d35aefbaf2a3520a4e03ba">_coarsen_by_parents</a>;
<a name="l00635"></a>00635 }
<a name="l00636"></a>00636 
<a name="l00637"></a><a class="code" href="classMeshRefinement.php#a7d8764f7ce747af3b7699c44da248130">00637</a> <span class="keyword">inline</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&amp; <a class="code" href="classMeshRefinement.php#a7d8764f7ce747af3b7699c44da248130">MeshRefinement::refine_fraction</a>()
<a name="l00638"></a>00638 {
<a name="l00639"></a>00639   <a class="code" href="classMeshRefinement.php#acc86f42287bf425be9c995249e919954">_use_member_parameters</a> = <span class="keyword">true</span>;
<a name="l00640"></a>00640   <span class="keywordflow">return</span> <a class="code" href="classMeshRefinement.php#a4575eddb3967dab44119aa774fc72a7e">_refine_fraction</a>;
<a name="l00641"></a>00641 }
<a name="l00642"></a>00642 
<a name="l00643"></a><a class="code" href="classMeshRefinement.php#a6cdd156d3549052f52cc5f66c6460395">00643</a> <span class="keyword">inline</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&amp; <a class="code" href="classMeshRefinement.php#a6cdd156d3549052f52cc5f66c6460395">MeshRefinement::coarsen_fraction</a>()
<a name="l00644"></a>00644 {
<a name="l00645"></a>00645   <a class="code" href="classMeshRefinement.php#acc86f42287bf425be9c995249e919954">_use_member_parameters</a> = <span class="keyword">true</span>;
<a name="l00646"></a>00646   <span class="keywordflow">return</span> <a class="code" href="classMeshRefinement.php#afc8f8e7f1fc8710c8c8746ead90589dc">_coarsen_fraction</a>;
<a name="l00647"></a>00647 }
<a name="l00648"></a>00648 
<a name="l00649"></a><a class="code" href="classMeshRefinement.php#a2aa5825479021d92305c4af8c3d67a08">00649</a> <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; <a class="code" href="classMeshRefinement.php#a2aa5825479021d92305c4af8c3d67a08">MeshRefinement::max_h_level</a>()
<a name="l00650"></a>00650 {
<a name="l00651"></a>00651   <a class="code" href="classMeshRefinement.php#acc86f42287bf425be9c995249e919954">_use_member_parameters</a> = <span class="keyword">true</span>;
<a name="l00652"></a>00652   <span class="keywordflow">return</span> <a class="code" href="classMeshRefinement.php#ad519253a5183e1cb16f424fbd85c2372">_max_h_level</a>;
<a name="l00653"></a>00653 }
<a name="l00654"></a>00654 
<a name="l00655"></a><a class="code" href="classMeshRefinement.php#a78a24fa995b0a09793ee8be77b7843be">00655</a> <span class="keyword">inline</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&amp; <a class="code" href="classMeshRefinement.php#a78a24fa995b0a09793ee8be77b7843be">MeshRefinement::coarsen_threshold</a>()
<a name="l00656"></a>00656 {
<a name="l00657"></a>00657   <a class="code" href="classMeshRefinement.php#acc86f42287bf425be9c995249e919954">_use_member_parameters</a> = <span class="keyword">true</span>;
<a name="l00658"></a>00658   <span class="keywordflow">return</span> <a class="code" href="classMeshRefinement.php#aab34acc013af03cf5a1bc96a7e6424c8">_coarsen_threshold</a>;
<a name="l00659"></a>00659 }
<a name="l00660"></a>00660 
<a name="l00661"></a><a class="code" href="classMeshRefinement.php#a03c879eb331829328247d2f19210bbac">00661</a> <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; <a class="code" href="classMeshRefinement.php#a03c879eb331829328247d2f19210bbac">MeshRefinement::nelem_target</a>()
<a name="l00662"></a>00662 {
<a name="l00663"></a>00663   <a class="code" href="classMeshRefinement.php#acc86f42287bf425be9c995249e919954">_use_member_parameters</a> = <span class="keyword">true</span>;
<a name="l00664"></a>00664   <span class="keywordflow">return</span> <a class="code" href="classMeshRefinement.php#a69043d3abcb7dca9b1a3c7aeb6177a45">_nelem_target</a>;
<a name="l00665"></a>00665 }
<a name="l00666"></a>00666 
<a name="l00667"></a><a class="code" href="classMeshRefinement.php#a9a094ad8a57648c536fa9e9ef4b58c10">00667</a> <span class="keyword">inline</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&amp; <a class="code" href="classMeshRefinement.php#a9a094ad8a57648c536fa9e9ef4b58c10">MeshRefinement::absolute_global_tolerance</a>()
<a name="l00668"></a>00668 {
<a name="l00669"></a>00669   <a class="code" href="classMeshRefinement.php#acc86f42287bf425be9c995249e919954">_use_member_parameters</a> = <span class="keyword">true</span>;
<a name="l00670"></a>00670   <span class="keywordflow">return</span> <a class="code" href="classMeshRefinement.php#aaccb6fd2619e2bee7217bde633673d32">_absolute_global_tolerance</a>;
<a name="l00671"></a>00671 }
<a name="l00672"></a>00672 
<a name="l00673"></a><a class="code" href="classMeshRefinement.php#a16a41a634500d59084544c3d146aaaf4">00673</a> <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>&amp; <a class="code" href="classMeshRefinement.php#a16a41a634500d59084544c3d146aaaf4">MeshRefinement::face_level_mismatch_limit</a>()
<a name="l00674"></a>00674 {
<a name="l00675"></a>00675   <span class="keywordflow">return</span> <a class="code" href="classMeshRefinement.php#a6f1ce9fd520404fd1076968ef4c95dad">_face_level_mismatch_limit</a>;
<a name="l00676"></a>00676 }
<a name="l00677"></a>00677 
<a name="l00678"></a><a class="code" href="classMeshRefinement.php#a552e438f7c90bd73d1d9a6093314e809">00678</a> <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>&amp; <a class="code" href="classMeshRefinement.php#a552e438f7c90bd73d1d9a6093314e809">MeshRefinement::edge_level_mismatch_limit</a>()
<a name="l00679"></a>00679 {
<a name="l00680"></a>00680   <span class="keywordflow">return</span> <a class="code" href="classMeshRefinement.php#af529cf6d70ea8e067d667f07269862a7">_edge_level_mismatch_limit</a>;
<a name="l00681"></a>00681 }
<a name="l00682"></a>00682 
<a name="l00683"></a><a class="code" href="classMeshRefinement.php#a646cdd8485355b0a247526939e16205d">00683</a> <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>&amp; <a class="code" href="classMeshRefinement.php#a646cdd8485355b0a247526939e16205d">MeshRefinement::node_level_mismatch_limit</a>()
<a name="l00684"></a>00684 {
<a name="l00685"></a>00685   <span class="keywordflow">return</span> <a class="code" href="classMeshRefinement.php#a46b608a8db8dbb59f693a137e19ea458">_node_level_mismatch_limit</a>;
<a name="l00686"></a>00686 }
<a name="l00687"></a>00687 
<a name="l00688"></a>00688 <span class="preprocessor">#endif // end #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00689"></a>00689 <span class="preprocessor"></span><span class="preprocessor">#endif // end #ifndef __mesh_refinement_h__ </span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
