<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_refinement_flagging.C</h1>  </div>
</div>
<div class="contents">
<a href="mesh__refinement__flagging_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 <span class="comment">// $Id: mesh_refinement_flagging.C 3502 2009-10-20 18:06:50Z roystgnr $</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00005"></a>00005 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00006"></a>00006   
<a name="l00007"></a>00007 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00008"></a>00008 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00009"></a>00009 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00010"></a>00010 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00011"></a>00011   
<a name="l00012"></a>00012 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00013"></a>00013 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00014"></a>00014 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00015"></a>00015 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00016"></a>00016   
<a name="l00017"></a>00017 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00018"></a>00018 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00019"></a>00019 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// only compile these functions if the user requests AMR support</span>
<a name="l00027"></a>00027 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="comment">// C++ includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::sort</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Local includes</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;error_vector.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;mesh_refinement.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;parallel.h&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00042"></a>00042 <span class="comment">// Mesh refinement methods</span>
<a name="l00043"></a><a class="code" href="classMeshRefinement.php#ae6ecd83fa4d99cb8ca0523343e920dba">00043</a> <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#ae6ecd83fa4d99cb8ca0523343e920dba">MeshRefinement::flag_elements_by_error_fraction</a> (<span class="keyword">const</span> <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00044"></a>00044                                                       <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> refine_frac,
<a name="l00045"></a>00045                                                       <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> coarsen_frac,
<a name="l00046"></a>00046                                                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_l)
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048   <span class="comment">// The function arguments are currently just there for</span>
<a name="l00049"></a>00049   <span class="comment">// backwards_compatibility</span>
<a name="l00050"></a>00050   <span class="keywordflow">if</span> (!<a class="code" href="classMeshRefinement.php#acc86f42287bf425be9c995249e919954">_use_member_parameters</a>)
<a name="l00051"></a>00051   {
<a name="l00052"></a>00052     <span class="comment">// If the user used non-default parameters, lets warn</span>
<a name="l00053"></a>00053     <span class="comment">// that they&#39;re deprecated</span>
<a name="l00054"></a>00054     <span class="keywordflow">if</span> (refine_frac != 0.3 ||
<a name="l00055"></a>00055         coarsen_frac != 0.0 ||
<a name="l00056"></a>00056         max_l != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00057"></a>00057       libmesh_deprecated();
<a name="l00058"></a>00058 
<a name="l00059"></a>00059     <a class="code" href="classMeshRefinement.php#a4575eddb3967dab44119aa774fc72a7e">_refine_fraction</a> = refine_frac;
<a name="l00060"></a>00060     <a class="code" href="classMeshRefinement.php#afc8f8e7f1fc8710c8c8746ead90589dc">_coarsen_fraction</a> = coarsen_frac;
<a name="l00061"></a>00061     <a class="code" href="classMeshRefinement.php#ad519253a5183e1cb16f424fbd85c2372">_max_h_level</a> = max_l;
<a name="l00062"></a>00062   }
<a name="l00063"></a>00063 
<a name="l00064"></a>00064   <span class="comment">// Check for valid fractions..</span>
<a name="l00065"></a>00065   <span class="comment">// The fraction values must be in [0,1]</span>
<a name="l00066"></a>00066   libmesh_assert (<a class="code" href="classMeshRefinement.php#a4575eddb3967dab44119aa774fc72a7e">_refine_fraction</a>  &gt;= 0. &amp;&amp; <a class="code" href="classMeshRefinement.php#a4575eddb3967dab44119aa774fc72a7e">_refine_fraction</a>  &lt;= 1.);
<a name="l00067"></a>00067   libmesh_assert (<a class="code" href="classMeshRefinement.php#afc8f8e7f1fc8710c8c8746ead90589dc">_coarsen_fraction</a> &gt;= 0. &amp;&amp; <a class="code" href="classMeshRefinement.php#afc8f8e7f1fc8710c8c8746ead90589dc">_coarsen_fraction</a> &lt;= 1.);
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   <span class="comment">// Clean up the refinement flags.  These could be left</span>
<a name="l00070"></a>00070   <span class="comment">// over from previous refinement steps.</span>
<a name="l00071"></a>00071   this-&gt;<a class="code" href="classMeshRefinement.php#a78e121fabb0ee86091a7c39190440ca1">clean_refinement_flags</a>();
<a name="l00072"></a>00072   
<a name="l00073"></a>00073   <span class="comment">// We&#39;re getting the minimum and maximum error values</span>
<a name="l00074"></a>00074   <span class="comment">// for the ACTIVE elements</span>
<a name="l00075"></a>00075   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> error_min = 1.e30;
<a name="l00076"></a>00076   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> error_max = 0.;
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   <span class="comment">// And, if necessary, for their parents</span>
<a name="l00079"></a>00079   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> parent_error_min = 1.e30;
<a name="l00080"></a>00080   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> parent_error_max = 0.;
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   <span class="comment">// Prepare another error vector if we need to sum parent errors</span>
<a name="l00083"></a>00083   <a class="code" href="classErrorVector.php">ErrorVector</a> error_per_parent;
<a name="l00084"></a>00084   <span class="keywordflow">if</span> (<a class="code" href="classMeshRefinement.php#a9aa08ca5c7d35aefbaf2a3520a4e03ba">_coarsen_by_parents</a>) 
<a name="l00085"></a>00085   {
<a name="l00086"></a>00086     <a class="code" href="classMeshRefinement.php#a0ccabd41707c7e688b674b3bc4f3d070">create_parent_error_vector</a>(error_per_cell,
<a name="l00087"></a>00087                                error_per_parent,
<a name="l00088"></a>00088                                parent_error_min,
<a name="l00089"></a>00089                                parent_error_max);
<a name="l00090"></a>00090   }
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   <span class="comment">// We need to loop over all active elements to find the minimum </span>
<a name="l00093"></a>00093   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el_it  =
<a name="l00094"></a>00094     <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00095"></a>00095   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> el_end =
<a name="l00096"></a>00096     <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>(); 
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   <span class="keywordflow">for</span> (; el_it != el_end; ++el_it)
<a name="l00099"></a>00099   {
<a name="l00100"></a>00100     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>  = (*el_it)-&gt;id();
<a name="l00101"></a>00101     libmesh_assert (<span class="keywordtype">id</span> &lt; error_per_cell.size());
<a name="l00102"></a>00102 
<a name="l00103"></a>00103     error_max = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a> (error_max, error_per_cell[<span class="keywordtype">id</span>]);
<a name="l00104"></a>00104     error_min = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a> (error_min, error_per_cell[<span class="keywordtype">id</span>]);
<a name="l00105"></a>00105   }
<a name="l00106"></a>00106   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(error_max);
<a name="l00107"></a>00107   <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(error_min);
<a name="l00108"></a>00108   
<a name="l00109"></a>00109   <span class="comment">// Compute the cutoff values for coarsening and refinement</span>
<a name="l00110"></a>00110   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> error_delta = (error_max - error_min);
<a name="l00111"></a>00111   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> parent_error_delta = parent_error_max - parent_error_min;
<a name="l00112"></a>00112 
<a name="l00113"></a>00113   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> refine_cutoff  = (1.- <a class="code" href="classMeshRefinement.php#a4575eddb3967dab44119aa774fc72a7e">_refine_fraction</a>)*error_max;
<a name="l00114"></a>00114   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> coarsen_cutoff = <a class="code" href="classMeshRefinement.php#afc8f8e7f1fc8710c8c8746ead90589dc">_coarsen_fraction</a>*error_delta + error_min;
<a name="l00115"></a>00115   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> parent_cutoff = <a class="code" href="classMeshRefinement.php#afc8f8e7f1fc8710c8c8746ead90589dc">_coarsen_fraction</a>*parent_error_delta + error_min;
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 <span class="comment">//   // Print information about the error</span>
<a name="l00118"></a>00118 <span class="comment">//   std::cout &lt;&lt; &quot; Error Information:&quot;                     &lt;&lt; std::endl</span>
<a name="l00119"></a>00119 <span class="comment">//          &lt;&lt; &quot; ------------------&quot;                     &lt;&lt; std::endl</span>
<a name="l00120"></a>00120 <span class="comment">//          &lt;&lt; &quot;   min:              &quot; &lt;&lt; error_min      &lt;&lt; std::endl</span>
<a name="l00121"></a>00121 <span class="comment">//          &lt;&lt; &quot;   max:              &quot; &lt;&lt; error_max      &lt;&lt; std::endl</span>
<a name="l00122"></a>00122 <span class="comment">//          &lt;&lt; &quot;   delta:            &quot; &lt;&lt; error_delta    &lt;&lt; std::endl</span>
<a name="l00123"></a>00123 <span class="comment">//          &lt;&lt; &quot;     refine_cutoff:  &quot; &lt;&lt; refine_cutoff  &lt;&lt; std::endl</span>
<a name="l00124"></a>00124 <span class="comment">//          &lt;&lt; &quot;     coarsen_cutoff: &quot; &lt;&lt; coarsen_cutoff &lt;&lt; std::endl;</span>
<a name="l00125"></a>00125   
<a name="l00126"></a>00126   
<a name="l00127"></a>00127 
<a name="l00128"></a>00128   <span class="comment">// Loop over the elements and flag them for coarsening or</span>
<a name="l00129"></a>00129   <span class="comment">// refinement based on the element error</span>
<a name="l00130"></a>00130 
<a name="l00131"></a>00131   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       e_it  =
<a name="l00132"></a>00132     <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00133"></a>00133   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> e_end =
<a name="l00134"></a>00134     <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00135"></a>00135   <span class="keywordflow">for</span> (; e_it != e_end; ++e_it)
<a name="l00136"></a>00136   {
<a name="l00137"></a>00137     <a class="code" href="classElem.php">Elem</a>* elem             = *e_it;
<a name="l00138"></a>00138     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>  = elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l00139"></a>00139 
<a name="l00140"></a>00140     libmesh_assert (<span class="keywordtype">id</span> &lt; error_per_cell.size());
<a name="l00141"></a>00141       
<a name="l00142"></a>00142     <span class="keyword">const</span> <span class="keywordtype">float</span> elem_error = error_per_cell[id];
<a name="l00143"></a>00143 
<a name="l00144"></a>00144     <span class="keywordflow">if</span> (<a class="code" href="classMeshRefinement.php#a9aa08ca5c7d35aefbaf2a3520a4e03ba">_coarsen_by_parents</a>)
<a name="l00145"></a>00145     {
<a name="l00146"></a>00146       <a class="code" href="classElem.php">Elem</a>* parent           = elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>();
<a name="l00147"></a>00147       <span class="keywordflow">if</span> (parent)
<a name="l00148"></a>00148       {
<a name="l00149"></a>00149         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parentid  = parent-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l00150"></a>00150         <span class="keywordflow">if</span> (error_per_parent[parentid] &gt;= 0. &amp;&amp;
<a name="l00151"></a>00151             error_per_parent[parentid] &lt;= parent_cutoff)
<a name="l00152"></a>00152           elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>);
<a name="l00153"></a>00153       }
<a name="l00154"></a>00154     }
<a name="l00155"></a>00155     <span class="comment">// Flag the element for coarsening if its error</span>
<a name="l00156"></a>00156     <span class="comment">// is &lt;= coarsen_fraction*delta + error_min</span>
<a name="l00157"></a>00157     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem_error &lt;= coarsen_cutoff)
<a name="l00158"></a>00158     {
<a name="l00159"></a>00159       elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>);
<a name="l00160"></a>00160     }
<a name="l00161"></a>00161       
<a name="l00162"></a>00162     <span class="comment">// Flag the element for refinement if its error</span>
<a name="l00163"></a>00163     <span class="comment">// is &gt;= refinement_cutoff.</span>
<a name="l00164"></a>00164     <span class="keywordflow">if</span> (elem_error &gt;= refine_cutoff)
<a name="l00165"></a>00165       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() &lt; <a class="code" href="classMeshRefinement.php#ad519253a5183e1cb16f424fbd85c2372">_max_h_level</a>)
<a name="l00166"></a>00166         elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>);
<a name="l00167"></a>00167   }
<a name="l00168"></a>00168 }
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 
<a name="l00172"></a><a class="code" href="classMeshRefinement.php#acdae03bfd1baf8fe3be7cb42bf21bcbd">00172</a> <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#acdae03bfd1baf8fe3be7cb42bf21bcbd">MeshRefinement::flag_elements_by_error_tolerance</a> (<span class="keyword">const</span> <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell_in)
<a name="l00173"></a>00173 {
<a name="l00174"></a>00174   <span class="comment">// Check for valid fractions..</span>
<a name="l00175"></a>00175   <span class="comment">// The fraction values must be in [0,1]</span>
<a name="l00176"></a>00176   libmesh_assert (<a class="code" href="classMeshRefinement.php#aab34acc013af03cf5a1bc96a7e6424c8">_coarsen_threshold</a>  &gt;= 0. &amp;&amp; <a class="code" href="classMeshRefinement.php#a4575eddb3967dab44119aa774fc72a7e">_refine_fraction</a>  &lt;= 1.);
<a name="l00177"></a>00177   libmesh_assert (<a class="code" href="classMeshRefinement.php#a4575eddb3967dab44119aa774fc72a7e">_refine_fraction</a>  &gt;= 0. &amp;&amp; <a class="code" href="classMeshRefinement.php#a4575eddb3967dab44119aa774fc72a7e">_refine_fraction</a>  &lt;= 1.);
<a name="l00178"></a>00178   libmesh_assert (<a class="code" href="classMeshRefinement.php#afc8f8e7f1fc8710c8c8746ead90589dc">_coarsen_fraction</a> &gt;= 0. &amp;&amp; <a class="code" href="classMeshRefinement.php#afc8f8e7f1fc8710c8c8746ead90589dc">_coarsen_fraction</a> &lt;= 1.);
<a name="l00179"></a>00179 
<a name="l00180"></a>00180   <span class="comment">// How much error per cell will we tolerate?</span>
<a name="l00181"></a>00181   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> local_refinement_tolerance =
<a name="l00182"></a>00182     <a class="code" href="classMeshRefinement.php#aaccb6fd2619e2bee7217bde633673d32">_absolute_global_tolerance</a> / std::sqrt(static_cast&lt;Real&gt;(<a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a246697678d5d14a986cee2b6fbdbae6b">n_active_elem</a>()));
<a name="l00183"></a>00183   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> local_coarsening_tolerance =
<a name="l00184"></a>00184     local_refinement_tolerance * <a class="code" href="classMeshRefinement.php#aab34acc013af03cf5a1bc96a7e6424c8">_coarsen_threshold</a>;
<a name="l00185"></a>00185 
<a name="l00186"></a>00186   <span class="comment">// Prepare another error vector if we need to sum parent errors</span>
<a name="l00187"></a>00187   <a class="code" href="classErrorVector.php">ErrorVector</a> error_per_parent;
<a name="l00188"></a>00188   <span class="keywordflow">if</span> (<a class="code" href="classMeshRefinement.php#a9aa08ca5c7d35aefbaf2a3520a4e03ba">_coarsen_by_parents</a>) 
<a name="l00189"></a>00189   {
<a name="l00190"></a>00190     <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> parent_error_min, parent_error_max;
<a name="l00191"></a>00191 
<a name="l00192"></a>00192     <a class="code" href="classMeshRefinement.php#a0ccabd41707c7e688b674b3bc4f3d070">create_parent_error_vector</a>(error_per_cell_in,
<a name="l00193"></a>00193                                error_per_parent,
<a name="l00194"></a>00194                                parent_error_min,
<a name="l00195"></a>00195                                parent_error_max);
<a name="l00196"></a>00196   }
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00199"></a>00199   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00200"></a>00200 
<a name="l00201"></a>00201   <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00202"></a>00202   {
<a name="l00203"></a>00203     <a class="code" href="classElem.php">Elem</a>* elem = *elem_it;
<a name="l00204"></a>00204     <a class="code" href="classElem.php">Elem</a>* parent = elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>();
<a name="l00205"></a>00205     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_number = elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l00206"></a>00206     <span class="keyword">const</span> <span class="keywordtype">float</span>        elem_error  = error_per_cell_in[elem_number];
<a name="l00207"></a>00207 
<a name="l00208"></a>00208     <span class="keywordflow">if</span> (elem_error &gt; local_refinement_tolerance &amp;&amp;
<a name="l00209"></a>00209         elem-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() &lt; <a class="code" href="classMeshRefinement.php#ad519253a5183e1cb16f424fbd85c2372">_max_h_level</a>)
<a name="l00210"></a>00210       elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>);
<a name="l00211"></a>00211 
<a name="l00212"></a>00212     <span class="keywordflow">if</span> (!<a class="code" href="classMeshRefinement.php#a9aa08ca5c7d35aefbaf2a3520a4e03ba">_coarsen_by_parents</a> &amp;&amp; elem_error &lt;
<a name="l00213"></a>00213         local_coarsening_tolerance)
<a name="l00214"></a>00214       elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>);
<a name="l00215"></a>00215 
<a name="l00216"></a>00216     <span class="keywordflow">if</span> (<a class="code" href="classMeshRefinement.php#a9aa08ca5c7d35aefbaf2a3520a4e03ba">_coarsen_by_parents</a> &amp;&amp; parent)
<a name="l00217"></a>00217     {
<a name="l00218"></a>00218       <span class="keywordtype">float</span> parent_error = error_per_parent[parent-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()];
<a name="l00219"></a>00219       <span class="keywordflow">if</span> (parent_error &gt;= 0.)
<a name="l00220"></a>00220       {
<a name="l00221"></a>00221         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> parent_coarsening_tolerance =
<a name="l00222"></a>00222           std::sqrt(parent-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>() *
<a name="l00223"></a>00223                     local_coarsening_tolerance *
<a name="l00224"></a>00224                     local_coarsening_tolerance);
<a name="l00225"></a>00225         <span class="keywordflow">if</span> (parent_error &lt; parent_coarsening_tolerance)
<a name="l00226"></a>00226           elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>);
<a name="l00227"></a>00227       }
<a name="l00228"></a>00228     }
<a name="l00229"></a>00229   }
<a name="l00230"></a>00230 }
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 
<a name="l00234"></a><a class="code" href="classMeshRefinement.php#aeb3cae01d544b3611116483b9f0ff815">00234</a> <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#aeb3cae01d544b3611116483b9f0ff815">MeshRefinement::flag_elements_by_nelem_target</a> (<span class="keyword">const</span> <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell)
<a name="l00235"></a>00235 {
<a name="l00236"></a>00236   <span class="comment">// Check for valid fractions..</span>
<a name="l00237"></a>00237   <span class="comment">// The fraction values must be in [0,1]</span>
<a name="l00238"></a>00238   libmesh_assert (<a class="code" href="classMeshRefinement.php#a4575eddb3967dab44119aa774fc72a7e">_refine_fraction</a>  &gt;= 0. &amp;&amp; <a class="code" href="classMeshRefinement.php#a4575eddb3967dab44119aa774fc72a7e">_refine_fraction</a>  &lt;= 1.);
<a name="l00239"></a>00239   libmesh_assert (<a class="code" href="classMeshRefinement.php#afc8f8e7f1fc8710c8c8746ead90589dc">_coarsen_fraction</a> &gt;= 0. &amp;&amp; <a class="code" href="classMeshRefinement.php#afc8f8e7f1fc8710c8c8746ead90589dc">_coarsen_fraction</a> &lt;= 1.);
<a name="l00240"></a>00240 
<a name="l00241"></a>00241   <span class="comment">// This function is currently only coded to work when coarsening by</span>
<a name="l00242"></a>00242   <span class="comment">// parents - it&#39;s too hard to guess how many coarsenings will be</span>
<a name="l00243"></a>00243   <span class="comment">// performed otherwise.</span>
<a name="l00244"></a>00244   libmesh_assert (<a class="code" href="classMeshRefinement.php#a9aa08ca5c7d35aefbaf2a3520a4e03ba">_coarsen_by_parents</a>);
<a name="l00245"></a>00245   
<a name="l00246"></a>00246   <span class="comment">// The number of active elements in the mesh - hopefully less than</span>
<a name="l00247"></a>00247   <span class="comment">// 2 billion on 32 bit machines</span>
<a name="l00248"></a>00248   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_active_elem  = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a246697678d5d14a986cee2b6fbdbae6b">n_active_elem</a>();
<a name="l00249"></a>00249 
<a name="l00250"></a>00250   <span class="comment">// The maximum number of active elements to flag for coarsening</span>
<a name="l00251"></a>00251   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_elem_coarsen =
<a name="l00252"></a>00252     <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(<a class="code" href="classMeshRefinement.php#afc8f8e7f1fc8710c8c8746ead90589dc">_coarsen_fraction</a> * n_active_elem) + 1;
<a name="l00253"></a>00253 
<a name="l00254"></a>00254   <span class="comment">// The maximum number of elements to flag for refinement</span>
<a name="l00255"></a>00255   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_elem_refine  =
<a name="l00256"></a>00256     <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(<a class="code" href="classMeshRefinement.php#a4575eddb3967dab44119aa774fc72a7e">_refine_fraction</a>  * n_active_elem) + 1;
<a name="l00257"></a>00257 
<a name="l00258"></a>00258   <span class="comment">// Clean up the refinement flags.  These could be left</span>
<a name="l00259"></a>00259   <span class="comment">// over from previous refinement steps.</span>
<a name="l00260"></a>00260   this-&gt;<a class="code" href="classMeshRefinement.php#a78e121fabb0ee86091a7c39190440ca1">clean_refinement_flags</a>();
<a name="l00261"></a>00261 
<a name="l00262"></a>00262   <span class="comment">// The target number of elements to add or remove</span>
<a name="l00263"></a>00263   <span class="keyword">const</span> <span class="keywordtype">int</span> n_elem_new = <a class="code" href="classMeshRefinement.php#a69043d3abcb7dca9b1a3c7aeb6177a45">_nelem_target</a> - n_active_elem;
<a name="l00264"></a>00264 
<a name="l00265"></a>00265   <span class="comment">// Create an vector with active element errors and ids,</span>
<a name="l00266"></a>00266   <span class="comment">// sorted by highest errors first</span>
<a name="l00267"></a>00267   std::vector&lt;std::pair&lt;float, unsigned int&gt; &gt; sorted_error;
<a name="l00268"></a>00268 
<a name="l00269"></a>00269   sorted_error.reserve (n_active_elem);
<a name="l00270"></a>00270 
<a name="l00271"></a>00271   <span class="comment">// FIXME - this won&#39;t work on a non-serialized mesh yet</span>
<a name="l00272"></a>00272   <span class="keywordflow">if</span> (!<a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a660bb92c9fb94527d1cabfb1fdd6d056">is_serial</a>())
<a name="l00273"></a>00273     {
<a name="l00274"></a>00274       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00275"></a>00275         std::cerr &lt;&lt; <span class="stringliteral">&quot;flag_elements_by_nelem_target does not yet &quot;</span>
<a name="l00276"></a>00276                   &lt;&lt; <span class="stringliteral">&quot;work on a parallel mesh.&quot;</span> &lt;&lt; std::endl;
<a name="l00277"></a>00277       libmesh_error();
<a name="l00278"></a>00278     }
<a name="l00279"></a>00279 
<a name="l00280"></a>00280   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00281"></a>00281   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00282"></a>00282 
<a name="l00283"></a>00283   <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00284"></a>00284     {
<a name="l00285"></a>00285       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> eid = (*elem_it)-&gt;id();
<a name="l00286"></a>00286       libmesh_assert(eid &lt; error_per_cell.size());
<a name="l00287"></a>00287       sorted_error.push_back
<a name="l00288"></a>00288         (std::make_pair(error_per_cell[eid], eid));
<a name="l00289"></a>00289     }
<a name="l00290"></a>00290 
<a name="l00291"></a>00291   <span class="comment">// Default sort works since pairs are sorted lexicographically</span>
<a name="l00292"></a>00292   std::sort (sorted_error.begin(), sorted_error.end());
<a name="l00293"></a>00293   std::reverse (sorted_error.begin(), sorted_error.end());
<a name="l00294"></a>00294 
<a name="l00295"></a>00295   <span class="comment">// Create a sorted error vector with coarsenable parent elements</span>
<a name="l00296"></a>00296   <span class="comment">// only, sorted by lowest errors first</span>
<a name="l00297"></a>00297   <a class="code" href="classErrorVector.php">ErrorVector</a> error_per_parent;
<a name="l00298"></a>00298   std::vector&lt;std::pair&lt;float, unsigned int&gt; &gt; sorted_parent_error;
<a name="l00299"></a>00299   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> parent_error_min, parent_error_max;
<a name="l00300"></a>00300 
<a name="l00301"></a>00301   <a class="code" href="classMeshRefinement.php#a0ccabd41707c7e688b674b3bc4f3d070">create_parent_error_vector</a>(error_per_cell,
<a name="l00302"></a>00302                              error_per_parent,
<a name="l00303"></a>00303                              parent_error_min,
<a name="l00304"></a>00304                              parent_error_max);
<a name="l00305"></a>00305 
<a name="l00306"></a>00306   <span class="comment">// create_parent_error_vector sets values for non-parents and</span>
<a name="l00307"></a>00307   <span class="comment">// non-coarsenable parents to -1.  Get rid of them.</span>
<a name="l00308"></a>00308   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != error_per_parent.size(); ++i)
<a name="l00309"></a>00309     <span class="keywordflow">if</span> (error_per_parent[i] != -1)
<a name="l00310"></a>00310       sorted_parent_error.push_back(std::make_pair(error_per_parent[i], i));
<a name="l00311"></a>00311 
<a name="l00312"></a>00312   std::sort (sorted_parent_error.begin(), sorted_parent_error.end());
<a name="l00313"></a>00313 
<a name="l00314"></a>00314   <span class="comment">// Keep track of how many elements we plan to coarsen &amp; refine</span>
<a name="l00315"></a>00315   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> coarsen_count = 0;
<a name="l00316"></a>00316   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> refine_count = 0;
<a name="l00317"></a>00317 
<a name="l00318"></a>00318   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>();
<a name="l00319"></a>00319   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> twotodim = 1;
<a name="l00320"></a>00320   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=dim; ++i)
<a name="l00321"></a>00321     twotodim *= 2;
<a name="l00322"></a>00322 
<a name="l00323"></a>00323   <span class="comment">// First, let&#39;s try to get our element count to target_nelem</span>
<a name="l00324"></a>00324   <span class="keywordflow">if</span> (n_elem_new &gt;= 0)
<a name="l00325"></a>00325   {
<a name="l00326"></a>00326     <span class="comment">// Every element refinement creates at least </span>
<a name="l00327"></a>00327     <span class="comment">// 2^dim-1 new elements</span>
<a name="l00328"></a>00328     refine_count =
<a name="l00329"></a>00329       <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(static_cast&lt;unsigned int&gt;(n_elem_new / (twotodim-1)),
<a name="l00330"></a>00330                max_elem_refine);
<a name="l00331"></a>00331   }
<a name="l00332"></a>00332   <span class="keywordflow">else</span>
<a name="l00333"></a>00333   {
<a name="l00334"></a>00334     <span class="comment">// Every successful element coarsening is likely to destroy</span>
<a name="l00335"></a>00335     <span class="comment">// 2^dim-1 net elements.</span>
<a name="l00336"></a>00336     coarsen_count =
<a name="l00337"></a>00337       <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(static_cast&lt;unsigned int&gt;(-n_elem_new / (twotodim-1)),
<a name="l00338"></a>00338                max_elem_coarsen);
<a name="l00339"></a>00339   }
<a name="l00340"></a>00340 
<a name="l00341"></a>00341   <span class="comment">// Next, let&#39;s see if we can trade any refinement for coarsening</span>
<a name="l00342"></a>00342   <span class="keywordflow">while</span> (coarsen_count &lt; max_elem_coarsen &amp;&amp;
<a name="l00343"></a>00343          refine_count &lt; max_elem_refine &amp;&amp;
<a name="l00344"></a>00344          coarsen_count &lt; sorted_parent_error.size() &amp;&amp;
<a name="l00345"></a>00345          refine_count &lt; sorted_error.size() &amp;&amp;
<a name="l00346"></a>00346          sorted_error[refine_count].first &gt; 
<a name="l00347"></a>00347          sorted_parent_error[coarsen_count].first * <a class="code" href="classMeshRefinement.php#aab34acc013af03cf5a1bc96a7e6424c8">_coarsen_threshold</a>)
<a name="l00348"></a>00348   {
<a name="l00349"></a>00349     coarsen_count++;
<a name="l00350"></a>00350     refine_count++;
<a name="l00351"></a>00351   }
<a name="l00352"></a>00352 
<a name="l00353"></a>00353   <span class="keywordflow">if</span> (refine_count &gt; max_elem_refine)
<a name="l00354"></a>00354     refine_count = max_elem_refine;
<a name="l00355"></a>00355   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> successful_refine_count = 0;
<a name="l00356"></a>00356   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != sorted_error.size(); ++i)
<a name="l00357"></a>00357     {
<a name="l00358"></a>00358       <span class="keywordflow">if</span> (successful_refine_count &gt;= refine_count)
<a name="l00359"></a>00359         <span class="keywordflow">break</span>;
<a name="l00360"></a>00360 
<a name="l00361"></a>00361       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> eid = sorted_error[i].second;
<a name="l00362"></a>00362       <a class="code" href="classElem.php">Elem</a> *elem = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(eid);
<a name="l00363"></a>00363       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() &lt; <a class="code" href="classMeshRefinement.php#ad519253a5183e1cb16f424fbd85c2372">_max_h_level</a>)
<a name="l00364"></a>00364         {
<a name="l00365"></a>00365           elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>);
<a name="l00366"></a>00366           successful_refine_count++;
<a name="l00367"></a>00367         }
<a name="l00368"></a>00368     }
<a name="l00369"></a>00369 
<a name="l00370"></a>00370   <span class="comment">// If we couldn&#39;t refine enough elements, don&#39;t coarsen too many</span>
<a name="l00371"></a>00371   <span class="comment">// either</span>
<a name="l00372"></a>00372   <span class="keywordflow">if</span> (coarsen_count &lt; (refine_count - successful_refine_count))
<a name="l00373"></a>00373     coarsen_count = 0;
<a name="l00374"></a>00374   <span class="keywordflow">else</span>
<a name="l00375"></a>00375     coarsen_count -= (refine_count - successful_refine_count);
<a name="l00376"></a>00376 
<a name="l00377"></a>00377   <span class="keywordflow">if</span> (coarsen_count &gt; max_elem_coarsen)
<a name="l00378"></a>00378     coarsen_count = max_elem_coarsen;
<a name="l00379"></a>00379   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> successful_coarsen_count = 0;
<a name="l00380"></a>00380   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != sorted_parent_error.size(); ++i)
<a name="l00381"></a>00381     {
<a name="l00382"></a>00382       <span class="keywordflow">if</span> (successful_coarsen_count &gt;= coarsen_count * twotodim)
<a name="l00383"></a>00383         <span class="keywordflow">break</span>;
<a name="l00384"></a>00384 
<a name="l00385"></a>00385       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parent_id = sorted_parent_error[i].second;
<a name="l00386"></a>00386       <a class="code" href="classElem.php">Elem</a> *parent = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(parent_id);
<a name="l00387"></a>00387       libmesh_assert(parent-&gt;<a class="code" href="classElem.php#a2ff2cfd3b4b05b8f091ba91eb068f81c">has_children</a>());
<a name="l00388"></a>00388       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c != parent-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); ++c)
<a name="l00389"></a>00389         {
<a name="l00390"></a>00390           <a class="code" href="classElem.php">Elem</a> *elem = parent-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c);
<a name="l00391"></a>00391           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l00392"></a>00392             {
<a name="l00393"></a>00393               elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>);
<a name="l00394"></a>00394               successful_coarsen_count++;
<a name="l00395"></a>00395             }
<a name="l00396"></a>00396         }
<a name="l00397"></a>00397     }
<a name="l00398"></a>00398 
<a name="l00399"></a>00399   <span class="comment">// Return true if we&#39;ve done all the AMR/C we can</span>
<a name="l00400"></a>00400   <span class="keywordflow">if</span> (!successful_coarsen_count &amp;&amp; 
<a name="l00401"></a>00401       !successful_refine_count)
<a name="l00402"></a>00402     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00403"></a>00403   <span class="comment">// And false if there may still be more to do.</span>
<a name="l00404"></a>00404   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00405"></a>00405 }
<a name="l00406"></a>00406 
<a name="l00407"></a>00407 
<a name="l00408"></a>00408 
<a name="l00409"></a><a class="code" href="classMeshRefinement.php#ae36504bf3929c94a5dabb2b4e12ddcef">00409</a> <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#ae36504bf3929c94a5dabb2b4e12ddcef">MeshRefinement::flag_elements_by_elem_fraction</a> (<span class="keyword">const</span> <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00410"></a>00410                                                      <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> refine_frac,
<a name="l00411"></a>00411                                                      <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> coarsen_frac,
<a name="l00412"></a>00412                                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_l)
<a name="l00413"></a>00413 {
<a name="l00414"></a>00414   <span class="comment">// FIXME - this won&#39;t work on a non-serialized mesh yet</span>
<a name="l00415"></a>00415   <span class="keywordflow">if</span> (!<a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a660bb92c9fb94527d1cabfb1fdd6d056">is_serial</a>())
<a name="l00416"></a>00416     {
<a name="l00417"></a>00417       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00418"></a>00418         std::cerr &lt;&lt; <span class="stringliteral">&quot;flag_elements_by_elem_fraction does not yet &quot;</span>
<a name="l00419"></a>00419                   &lt;&lt; <span class="stringliteral">&quot;work on a parallel mesh.&quot;</span> &lt;&lt; std::endl;
<a name="l00420"></a>00420       libmesh_error();
<a name="l00421"></a>00421     }
<a name="l00422"></a>00422 
<a name="l00423"></a>00423   <span class="comment">// The function arguments are currently just there for</span>
<a name="l00424"></a>00424   <span class="comment">// backwards_compatibility</span>
<a name="l00425"></a>00425   <span class="keywordflow">if</span> (!<a class="code" href="classMeshRefinement.php#acc86f42287bf425be9c995249e919954">_use_member_parameters</a>)
<a name="l00426"></a>00426   {
<a name="l00427"></a>00427     <span class="comment">// If the user used non-default parameters, lets warn</span>
<a name="l00428"></a>00428     <span class="comment">// that they&#39;re deprecated</span>
<a name="l00429"></a>00429     <span class="keywordflow">if</span> (refine_frac != 0.3 ||
<a name="l00430"></a>00430         coarsen_frac != 0.0 ||
<a name="l00431"></a>00431         max_l != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00432"></a>00432       libmesh_deprecated();
<a name="l00433"></a>00433 
<a name="l00434"></a>00434     <a class="code" href="classMeshRefinement.php#a4575eddb3967dab44119aa774fc72a7e">_refine_fraction</a> = refine_frac;
<a name="l00435"></a>00435     <a class="code" href="classMeshRefinement.php#afc8f8e7f1fc8710c8c8746ead90589dc">_coarsen_fraction</a> = coarsen_frac;
<a name="l00436"></a>00436     <a class="code" href="classMeshRefinement.php#ad519253a5183e1cb16f424fbd85c2372">_max_h_level</a> = max_l;
<a name="l00437"></a>00437   }
<a name="l00438"></a>00438 
<a name="l00439"></a>00439   <span class="comment">// Check for valid fractions..</span>
<a name="l00440"></a>00440   <span class="comment">// The fraction values must be in [0,1]</span>
<a name="l00441"></a>00441   libmesh_assert (<a class="code" href="classMeshRefinement.php#a4575eddb3967dab44119aa774fc72a7e">_refine_fraction</a>  &gt;= 0. &amp;&amp; <a class="code" href="classMeshRefinement.php#a4575eddb3967dab44119aa774fc72a7e">_refine_fraction</a>  &lt;= 1.);
<a name="l00442"></a>00442   libmesh_assert (<a class="code" href="classMeshRefinement.php#afc8f8e7f1fc8710c8c8746ead90589dc">_coarsen_fraction</a> &gt;= 0. &amp;&amp; <a class="code" href="classMeshRefinement.php#afc8f8e7f1fc8710c8c8746ead90589dc">_coarsen_fraction</a> &lt;= 1.);
<a name="l00443"></a>00443 
<a name="l00444"></a>00444   <span class="comment">// The number of active elements in the mesh</span>
<a name="l00445"></a>00445   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_active_elem  = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>();
<a name="l00446"></a>00446 
<a name="l00447"></a>00447   <span class="comment">// The number of elements to flag for coarsening</span>
<a name="l00448"></a>00448   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_elem_coarsen =
<a name="l00449"></a>00449     <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(<a class="code" href="classMeshRefinement.php#afc8f8e7f1fc8710c8c8746ead90589dc">_coarsen_fraction</a> * n_active_elem);
<a name="l00450"></a>00450 
<a name="l00451"></a>00451   <span class="comment">// The number of elements to flag for refinement</span>
<a name="l00452"></a>00452   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_elem_refine =
<a name="l00453"></a>00453     <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(<a class="code" href="classMeshRefinement.php#a4575eddb3967dab44119aa774fc72a7e">_refine_fraction</a>  * n_active_elem);
<a name="l00454"></a>00454 
<a name="l00455"></a>00455 
<a name="l00456"></a>00456   
<a name="l00457"></a>00457   <span class="comment">// Clean up the refinement flags.  These could be left</span>
<a name="l00458"></a>00458   <span class="comment">// over from previous refinement steps.</span>
<a name="l00459"></a>00459   this-&gt;<a class="code" href="classMeshRefinement.php#a78e121fabb0ee86091a7c39190440ca1">clean_refinement_flags</a>();
<a name="l00460"></a>00460 
<a name="l00461"></a>00461 
<a name="l00462"></a>00462   <span class="comment">// This vector stores the error and element number for all the</span>
<a name="l00463"></a>00463   <span class="comment">// active elements.  It will be sorted and the top &amp; bottom</span>
<a name="l00464"></a>00464   <span class="comment">// elements will then be flagged for coarsening &amp; refinement</span>
<a name="l00465"></a>00465   std::vector&lt;float&gt; sorted_error;
<a name="l00466"></a>00466 
<a name="l00467"></a>00467   sorted_error.reserve (n_active_elem);
<a name="l00468"></a>00468 
<a name="l00469"></a>00469   <span class="comment">// Loop over the active elements and create the entry</span>
<a name="l00470"></a>00470   <span class="comment">// in the sorted_error vector</span>
<a name="l00471"></a>00471   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00472"></a>00472   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00473"></a>00473 
<a name="l00474"></a>00474   <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00475"></a>00475     sorted_error.push_back (error_per_cell[(*elem_it)-&gt;id()]);
<a name="l00476"></a>00476 
<a name="l00477"></a>00477   <span class="comment">// Now sort the sorted_error vector</span>
<a name="l00478"></a>00478   std::sort (sorted_error.begin(), sorted_error.end());
<a name="l00479"></a>00479   
<a name="l00480"></a>00480   <span class="comment">// If we&#39;re coarsening by parents:</span>
<a name="l00481"></a>00481   <span class="comment">// Create a sorted error vector with coarsenable parent elements</span>
<a name="l00482"></a>00482   <span class="comment">// only, sorted by lowest errors first</span>
<a name="l00483"></a>00483   <a class="code" href="classErrorVector.php">ErrorVector</a> error_per_parent, sorted_parent_error;
<a name="l00484"></a>00484   <span class="keywordflow">if</span> (<a class="code" href="classMeshRefinement.php#a9aa08ca5c7d35aefbaf2a3520a4e03ba">_coarsen_by_parents</a>)
<a name="l00485"></a>00485   {
<a name="l00486"></a>00486     <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> parent_error_min, parent_error_max;
<a name="l00487"></a>00487 
<a name="l00488"></a>00488     <a class="code" href="classMeshRefinement.php#a0ccabd41707c7e688b674b3bc4f3d070">create_parent_error_vector</a>(error_per_cell,
<a name="l00489"></a>00489                                error_per_parent,
<a name="l00490"></a>00490                                parent_error_min,
<a name="l00491"></a>00491                                parent_error_max);
<a name="l00492"></a>00492 
<a name="l00493"></a>00493     sorted_parent_error = error_per_parent;
<a name="l00494"></a>00494     std::sort (sorted_parent_error.begin(), sorted_parent_error.end());
<a name="l00495"></a>00495 
<a name="l00496"></a>00496     <span class="comment">// All the other error values will be 0., so get rid of them.</span>
<a name="l00497"></a>00497     sorted_parent_error.erase (std::remove(sorted_parent_error.begin(),
<a name="l00498"></a>00498                                            sorted_parent_error.end(), 0.),
<a name="l00499"></a>00499                                sorted_parent_error.end());
<a name="l00500"></a>00500   }
<a name="l00501"></a>00501   
<a name="l00502"></a>00502 
<a name="l00503"></a>00503   <span class="keywordtype">float</span> top_error= 0., bottom_error = 0.;
<a name="l00504"></a>00504 
<a name="l00505"></a>00505   <span class="comment">// Get the maximum error value corresponding to the</span>
<a name="l00506"></a>00506   <span class="comment">// bottom n_elem_coarsen elements</span>
<a name="l00507"></a>00507   <span class="keywordflow">if</span> (<a class="code" href="classMeshRefinement.php#a9aa08ca5c7d35aefbaf2a3520a4e03ba">_coarsen_by_parents</a> &amp;&amp; n_elem_coarsen)
<a name="l00508"></a>00508     {
<a name="l00509"></a>00509       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>();
<a name="l00510"></a>00510       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> twotodim = 1;
<a name="l00511"></a>00511       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=dim; ++i)
<a name="l00512"></a>00512         twotodim *= 2;
<a name="l00513"></a>00513 
<a name="l00514"></a>00514       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_parent_coarsen = n_elem_coarsen / (twotodim - 1);
<a name="l00515"></a>00515 
<a name="l00516"></a>00516       <span class="keywordflow">if</span> (n_parent_coarsen)
<a name="l00517"></a>00517         bottom_error = sorted_parent_error[n_parent_coarsen - 1];
<a name="l00518"></a>00518     }
<a name="l00519"></a>00519   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (n_elem_coarsen)
<a name="l00520"></a>00520     {
<a name="l00521"></a>00521       bottom_error = sorted_error[n_elem_coarsen - 1];
<a name="l00522"></a>00522     }
<a name="l00523"></a>00523 
<a name="l00524"></a>00524   <span class="keywordflow">if</span> (n_elem_refine)
<a name="l00525"></a>00525     top_error = sorted_error[sorted_error.size() - n_elem_refine + 1];
<a name="l00526"></a>00526 
<a name="l00527"></a>00527   <span class="comment">// Finally, let&#39;s do the element flagging</span>
<a name="l00528"></a>00528   elem_it  = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00529"></a>00529   <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00530"></a>00530     {
<a name="l00531"></a>00531       <a class="code" href="classElem.php">Elem</a>* elem = *elem_it;
<a name="l00532"></a>00532       <a class="code" href="classElem.php">Elem</a>* parent = elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>();
<a name="l00533"></a>00533 
<a name="l00534"></a>00534       <span class="keywordflow">if</span> (<a class="code" href="classMeshRefinement.php#a9aa08ca5c7d35aefbaf2a3520a4e03ba">_coarsen_by_parents</a> &amp;&amp; parent &amp;&amp; n_elem_coarsen &amp;&amp;
<a name="l00535"></a>00535           error_per_parent[parent-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] &lt;= bottom_error)
<a name="l00536"></a>00536         elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>);
<a name="l00537"></a>00537 
<a name="l00538"></a>00538       <span class="keywordflow">if</span> (!<a class="code" href="classMeshRefinement.php#a9aa08ca5c7d35aefbaf2a3520a4e03ba">_coarsen_by_parents</a> &amp;&amp; n_elem_coarsen &amp;&amp;
<a name="l00539"></a>00539           error_per_cell[elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] &lt;= bottom_error)
<a name="l00540"></a>00540         elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>);
<a name="l00541"></a>00541 
<a name="l00542"></a>00542       <span class="keywordflow">if</span> (n_elem_refine &amp;&amp;
<a name="l00543"></a>00543           elem-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() &lt; <a class="code" href="classMeshRefinement.php#ad519253a5183e1cb16f424fbd85c2372">_max_h_level</a> &amp;&amp;
<a name="l00544"></a>00544           error_per_cell[elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] &gt;= top_error)
<a name="l00545"></a>00545         elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>);
<a name="l00546"></a>00546     }
<a name="l00547"></a>00547 }
<a name="l00548"></a>00548 
<a name="l00549"></a>00549 
<a name="l00550"></a>00550 
<a name="l00551"></a><a class="code" href="classMeshRefinement.php#a2349085f6bbd241a5819366e85c4408a">00551</a> <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#a2349085f6bbd241a5819366e85c4408a">MeshRefinement::flag_elements_by_mean_stddev</a> (<span class="keyword">const</span> <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00552"></a>00552                                                    <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> refine_frac,
<a name="l00553"></a>00553                                                    <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> coarsen_frac,
<a name="l00554"></a>00554                                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_l)
<a name="l00555"></a>00555 {
<a name="l00556"></a>00556   <span class="comment">// FIXME - this won&#39;t work on a non-serialized mesh yet</span>
<a name="l00557"></a>00557   <span class="keywordflow">if</span> (!<a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a660bb92c9fb94527d1cabfb1fdd6d056">is_serial</a>())
<a name="l00558"></a>00558     {
<a name="l00559"></a>00559       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00560"></a>00560         std::cerr &lt;&lt; <span class="stringliteral">&quot;flag_elements_by_mean_stddev does not yet &quot;</span>
<a name="l00561"></a>00561                   &lt;&lt; <span class="stringliteral">&quot;work on a parallel mesh.&quot;</span> &lt;&lt; std::endl;
<a name="l00562"></a>00562       libmesh_error();
<a name="l00563"></a>00563     }
<a name="l00564"></a>00564 
<a name="l00565"></a>00565   <span class="comment">// The function arguments are currently just there for</span>
<a name="l00566"></a>00566   <span class="comment">// backwards_compatibility</span>
<a name="l00567"></a>00567   <span class="keywordflow">if</span> (!<a class="code" href="classMeshRefinement.php#acc86f42287bf425be9c995249e919954">_use_member_parameters</a>)
<a name="l00568"></a>00568     {
<a name="l00569"></a>00569       <span class="comment">// If the user used non-default parameters, lets warn</span>
<a name="l00570"></a>00570       <span class="comment">// that they&#39;re deprecated</span>
<a name="l00571"></a>00571       <span class="keywordflow">if</span> (refine_frac != 0.3 ||
<a name="l00572"></a>00572           coarsen_frac != 0.0 ||
<a name="l00573"></a>00573           max_l != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00574"></a>00574         libmesh_deprecated();
<a name="l00575"></a>00575 
<a name="l00576"></a>00576       <a class="code" href="classMeshRefinement.php#a4575eddb3967dab44119aa774fc72a7e">_refine_fraction</a> = refine_frac;
<a name="l00577"></a>00577       <a class="code" href="classMeshRefinement.php#afc8f8e7f1fc8710c8c8746ead90589dc">_coarsen_fraction</a> = coarsen_frac;
<a name="l00578"></a>00578       <a class="code" href="classMeshRefinement.php#ad519253a5183e1cb16f424fbd85c2372">_max_h_level</a> = max_l;
<a name="l00579"></a>00579     }
<a name="l00580"></a>00580 
<a name="l00581"></a>00581   <span class="comment">// Get the mean value from the error vector</span>
<a name="l00582"></a>00582   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> mean = error_per_cell.<a class="code" href="classErrorVector.php#a959bacdc9d596c5212137c9221ff6f14">mean</a>();
<a name="l00583"></a>00583   
<a name="l00584"></a>00584   <span class="comment">// Get the standard deviation.  This equals the</span>
<a name="l00585"></a>00585   <span class="comment">// square-root of the variance</span>
<a name="l00586"></a>00586   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> stddev = std::sqrt (error_per_cell.<a class="code" href="classErrorVector.php#a0b1a9d39bb54ac0cd9b8659e4360f54a">variance</a>());
<a name="l00587"></a>00587   
<a name="l00588"></a>00588   <span class="comment">// Check for valid fractions</span>
<a name="l00589"></a>00589   libmesh_assert (<a class="code" href="classMeshRefinement.php#a4575eddb3967dab44119aa774fc72a7e">_refine_fraction</a>  &gt;= 0. &amp;&amp; <a class="code" href="classMeshRefinement.php#a4575eddb3967dab44119aa774fc72a7e">_refine_fraction</a>  &lt;= 1.);
<a name="l00590"></a>00590   libmesh_assert (<a class="code" href="classMeshRefinement.php#afc8f8e7f1fc8710c8c8746ead90589dc">_coarsen_fraction</a> &gt;= 0. &amp;&amp; <a class="code" href="classMeshRefinement.php#afc8f8e7f1fc8710c8c8746ead90589dc">_coarsen_fraction</a> &lt;= 1.);
<a name="l00591"></a>00591 
<a name="l00592"></a>00592   <span class="comment">// The refine and coarsen cutoff</span>
<a name="l00593"></a>00593   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> refine_cutoff  =  mean + <a class="code" href="classMeshRefinement.php#a4575eddb3967dab44119aa774fc72a7e">_refine_fraction</a>  * stddev;
<a name="l00594"></a>00594   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> coarsen_cutoff =  <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(mean - <a class="code" href="classMeshRefinement.php#afc8f8e7f1fc8710c8c8746ead90589dc">_coarsen_fraction</a> * stddev, 0.);
<a name="l00595"></a>00595       
<a name="l00596"></a>00596   <span class="comment">// Loop over the elements and flag them for coarsening or</span>
<a name="l00597"></a>00597   <span class="comment">// refinement based on the element error</span>
<a name="l00598"></a>00598   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00599"></a>00599   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00600"></a>00600 
<a name="l00601"></a>00601   <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00602"></a>00602     {
<a name="l00603"></a>00603       <a class="code" href="classElem.php">Elem</a>* elem             = *elem_it;
<a name="l00604"></a>00604       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>  = elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l00605"></a>00605 
<a name="l00606"></a>00606       libmesh_assert (<span class="keywordtype">id</span> &lt; error_per_cell.size());
<a name="l00607"></a>00607       
<a name="l00608"></a>00608       <span class="keyword">const</span> <span class="keywordtype">float</span> elem_error = error_per_cell[id];
<a name="l00609"></a>00609 
<a name="l00610"></a>00610       <span class="comment">// Possibly flag the element for coarsening ...</span>
<a name="l00611"></a>00611       <span class="keywordflow">if</span> (elem_error &lt;= coarsen_cutoff)
<a name="l00612"></a>00612         elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>);
<a name="l00613"></a>00613       
<a name="l00614"></a>00614       <span class="comment">// ... or refinement</span>
<a name="l00615"></a>00615       <span class="keywordflow">if</span> ((elem_error &gt;= refine_cutoff) &amp;&amp; (elem-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() &lt; <a class="code" href="classMeshRefinement.php#ad519253a5183e1cb16f424fbd85c2372">_max_h_level</a>))
<a name="l00616"></a>00616         elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>);
<a name="l00617"></a>00617     }
<a name="l00618"></a>00618 }
<a name="l00619"></a>00619 
<a name="l00620"></a>00620 
<a name="l00621"></a>00621 
<a name="l00622"></a><a class="code" href="classMeshRefinement.php#a122cf26f86f73d225fbaff4a6a2ed54b">00622</a> <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#a122cf26f86f73d225fbaff4a6a2ed54b">MeshRefinement::switch_h_to_p_refinement</a> ()
<a name="l00623"></a>00623 {
<a name="l00624"></a>00624   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00625"></a>00625   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>(); 
<a name="l00626"></a>00626 
<a name="l00627"></a>00627   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00628"></a>00628     {
<a name="l00629"></a>00629       <span class="keywordflow">if</span> ((*elem_it)-&gt;active())
<a name="l00630"></a>00630         {
<a name="l00631"></a>00631           (*elem_it)-&gt;set_p_refinement_flag((*elem_it)-&gt;refinement_flag());
<a name="l00632"></a>00632           (*elem_it)-&gt;set_refinement_flag(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a3bc34bb09879a3388ad735a75317b3c3">Elem::DO_NOTHING</a>);
<a name="l00633"></a>00633         } 
<a name="l00634"></a>00634       <span class="keywordflow">else</span>
<a name="l00635"></a>00635         {
<a name="l00636"></a>00636           (*elem_it)-&gt;set_p_refinement_flag((*elem_it)-&gt;refinement_flag());
<a name="l00637"></a>00637           (*elem_it)-&gt;set_refinement_flag(<a class="code" href="classElem.php#a946039859488cca879512de516fef829aa5b67adf7b456724c4a0a07034a0adbf">Elem::INACTIVE</a>);
<a name="l00638"></a>00638         } 
<a name="l00639"></a>00639     }
<a name="l00640"></a>00640 }
<a name="l00641"></a>00641 
<a name="l00642"></a>00642 
<a name="l00643"></a>00643 
<a name="l00644"></a><a class="code" href="classMeshRefinement.php#a4ed4a0cb7da0e8918458e09ba8d0a818">00644</a> <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#a4ed4a0cb7da0e8918458e09ba8d0a818">MeshRefinement::add_p_to_h_refinement</a> ()
<a name="l00645"></a>00645 {
<a name="l00646"></a>00646   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00647"></a>00647   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>(); 
<a name="l00648"></a>00648 
<a name="l00649"></a>00649   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00650"></a>00650     (*elem_it)-&gt;set_p_refinement_flag((*elem_it)-&gt;refinement_flag());
<a name="l00651"></a>00651 }
<a name="l00652"></a>00652 
<a name="l00653"></a>00653 
<a name="l00654"></a>00654 
<a name="l00655"></a><a class="code" href="classMeshRefinement.php#a78e121fabb0ee86091a7c39190440ca1">00655</a> <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#a78e121fabb0ee86091a7c39190440ca1">MeshRefinement::clean_refinement_flags</a> ()
<a name="l00656"></a>00656 {
<a name="l00657"></a>00657   <span class="comment">// Possibly clean up the refinement flags from</span>
<a name="l00658"></a>00658   <span class="comment">// a previous step</span>
<a name="l00659"></a>00659 <span class="comment">//   elem_iterator       elem_it (_mesh.elements_begin());</span>
<a name="l00660"></a>00660 <span class="comment">//   const elem_iterator elem_end(_mesh.elements_end());</span>
<a name="l00661"></a>00661 
<a name="l00662"></a>00662   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00663"></a>00663   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>(); 
<a name="l00664"></a>00664 
<a name="l00665"></a>00665   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00666"></a>00666     {
<a name="l00667"></a>00667       <span class="keywordflow">if</span> ((*elem_it)-&gt;active())
<a name="l00668"></a>00668         {
<a name="l00669"></a>00669           (*elem_it)-&gt;set_refinement_flag(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a3bc34bb09879a3388ad735a75317b3c3">Elem::DO_NOTHING</a>);
<a name="l00670"></a>00670           (*elem_it)-&gt;set_p_refinement_flag(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a3bc34bb09879a3388ad735a75317b3c3">Elem::DO_NOTHING</a>);
<a name="l00671"></a>00671         } 
<a name="l00672"></a>00672       <span class="keywordflow">else</span>
<a name="l00673"></a>00673         {
<a name="l00674"></a>00674           (*elem_it)-&gt;set_refinement_flag(<a class="code" href="classElem.php#a946039859488cca879512de516fef829aa5b67adf7b456724c4a0a07034a0adbf">Elem::INACTIVE</a>);
<a name="l00675"></a>00675           (*elem_it)-&gt;set_p_refinement_flag(<a class="code" href="classElem.php#a946039859488cca879512de516fef829aa5b67adf7b456724c4a0a07034a0adbf">Elem::INACTIVE</a>);
<a name="l00676"></a>00676         } 
<a name="l00677"></a>00677     }
<a name="l00678"></a>00678 }
<a name="l00679"></a>00679 
<a name="l00680"></a>00680 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
