<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_smoother.h</h1>  </div>
</div>
<div class="contents">
<a href="mesh__smoother_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_smoother.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __mesh_smoother_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_smoother_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// forward declarations</span>
<a name="l00032"></a>00032 <span class="keyword">class </span><a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>;
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00046"></a>00046 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00047"></a>00047 <span class="comment">// MeshSmoother class definition</span>
<a name="l00048"></a><a class="code" href="classMeshSmoother.php">00048</a> <span class="keyword">class </span><a class="code" href="classMeshSmoother.php">MeshSmoother</a>
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050 <span class="keyword">public</span>:
<a name="l00055"></a><a class="code" href="classMeshSmoother.php#a7e21469c23699a6f526581a080e5d7ba">00055</a>   <a class="code" href="classMeshSmoother.php#a7e21469c23699a6f526581a080e5d7ba">MeshSmoother</a>(<a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; mesh) : <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>(mesh) {}
<a name="l00056"></a>00056 
<a name="l00060"></a><a class="code" href="classMeshSmoother.php#a92b804d949e4845da42309b6372567fa">00060</a>   <span class="keyword">virtual</span> <a class="code" href="classMeshSmoother.php#a92b804d949e4845da42309b6372567fa">~MeshSmoother</a>() {}
<a name="l00061"></a>00061 
<a name="l00066"></a>00066   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classMeshSmoother.php#a2f860e9c2cfbe3e14f363f223ed5baab">smooth</a>() = 0;
<a name="l00067"></a>00067   
<a name="l00068"></a>00068 <span class="keyword">protected</span>:
<a name="l00069"></a>00069 
<a name="l00070"></a><a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">00070</a>   <a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>;
<a name="l00071"></a>00071   
<a name="l00072"></a>00072 };
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
