<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_smoother_laplace.C</h1>  </div>
</div>
<div class="contents">
<a href="mesh__smoother__laplace_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_smoother_laplace.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::copy, std::sort</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;mesh_smoother_laplace.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;mesh_tools.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;unstructured_mesh.h&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Member functions for the Laplace smoother</span>
<a name="l00033"></a><a class="code" href="classLaplaceMeshSmoother.php#aa9eb8b9ba1fbaefab44b3e950e4d4e20">00033</a> <span class="keywordtype">void</span> <a class="code" href="classLaplaceMeshSmoother.php#a836c8d87c7e6ae66de9462a7a587eaaf">LaplaceMeshSmoother::smooth</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_iterations)
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035   <span class="keywordflow">if</span> (!<a class="code" href="classLaplaceMeshSmoother.php#aad041b842be1c1813c57744ec8b467dc">_initialized</a>)
<a name="l00036"></a>00036     this-&gt;<a class="code" href="classLaplaceMeshSmoother.php#ab70683d8eaa560136b8423a734afeb68">init</a>();
<a name="l00037"></a>00037   
<a name="l00038"></a>00038   <span class="comment">// Don&#39;t smooth the nodes on the boundary...</span>
<a name="l00039"></a>00039   <span class="comment">// this would change the mesh geometry which</span>
<a name="l00040"></a>00040   <span class="comment">// is probably not something we want!</span>
<a name="l00041"></a>00041   std::vector&lt;bool&gt; on_boundary;
<a name="l00042"></a>00042   <a class="code" href="namespaceMeshTools.php#ab24d347f09559cc4fa6ea2c1a238b2d4">MeshTools::find_boundary_nodes</a>(<a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>, on_boundary);
<a name="l00043"></a>00043 
<a name="l00044"></a>00044   <span class="comment">// We can only update the nodes after all new positions were</span>
<a name="l00045"></a>00045   <span class="comment">// determined. We store the new positions here</span>
<a name="l00046"></a>00046   std::vector&lt;Point&gt; new_positions;
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;n_iterations; n++)
<a name="l00049"></a>00049     {
<a name="l00050"></a>00050       new_positions.resize(<a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l00051"></a>00051       
<a name="l00052"></a>00052       <span class="keywordflow">for</span> (<a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> it  = <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
<a name="l00053"></a>00053            it != <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
<a name="l00054"></a>00054            ++it) 
<a name="l00055"></a>00055         {
<a name="l00056"></a>00056           <a class="code" href="classNode.php">Node</a>* node = *it;
<a name="l00057"></a>00057           <span class="comment">// leave the boundary intact</span>
<a name="l00058"></a>00058           <span class="comment">// Only relocate the nodes which are vertices of an element</span>
<a name="l00059"></a>00059           <span class="comment">// All other entries of _graph (the secondary nodes) are empty</span>
<a name="l00060"></a>00060           <span class="keywordflow">if</span> (!on_boundary[node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] &amp;&amp; (<a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()].size() &gt; 0) )
<a name="l00061"></a>00061             {
<a name="l00062"></a>00062               <a class="code" href="classPoint.php">Point</a> avg_position(0.,0.,0.);
<a name="l00063"></a>00063               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()].size(); ++j)
<a name="l00064"></a>00064                 avg_position.<a class="code" href="classTypeVector.php#a5a491e5c665118253b6e2f65141c8922">add</a>(<a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a298477f2d67d6a85f6c7fb5a640e2b64">node</a>(<a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()][j]));
<a name="l00065"></a>00065               new_positions[node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] = avg_position /
<a name="l00066"></a>00066                 <span class="keyword">static_cast&lt;</span><a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a><span class="keyword">&gt;</span>(<a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()].size());
<a name="l00067"></a>00067             }
<a name="l00068"></a>00068         }
<a name="l00069"></a>00069       
<a name="l00070"></a>00070       <span class="comment">// now update the node positions</span>
<a name="l00071"></a>00071       <span class="keywordflow">for</span> (<a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> it  = <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
<a name="l00072"></a>00072            it != <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
<a name="l00073"></a>00073            ++it)
<a name="l00074"></a>00074         {
<a name="l00075"></a>00075           <a class="code" href="classNode.php">Node</a>* node = *it;
<a name="l00076"></a>00076           
<a name="l00077"></a>00077           <span class="keywordflow">if</span> (!on_boundary[node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] &amp;&amp; (<a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()].size() &gt; 0) )
<a name="l00078"></a>00078             {
<a name="l00079"></a>00079               <span class="comment">// Should call Point::op=</span>
<a name="l00080"></a>00080               <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a298477f2d67d6a85f6c7fb5a640e2b64">node</a>(node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()) = new_positions[node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()];
<a name="l00081"></a>00081             }
<a name="l00082"></a>00082         }
<a name="l00083"></a>00083     }
<a name="l00084"></a>00084   
<a name="l00085"></a>00085   <span class="comment">// finally adjust the second order nodes (those located between vertices)</span>
<a name="l00086"></a>00086   <span class="comment">// these nodes will be located between their adjacent nodes</span>
<a name="l00087"></a>00087   <span class="comment">// do this element-wise</span>
<a name="l00088"></a>00088   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el  = <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00089"></a>00089   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00090"></a>00090         
<a name="l00091"></a>00091   <span class="keywordflow">for</span> (; el != end; ++el)
<a name="l00092"></a>00092     {
<a name="l00093"></a>00093       <span class="comment">// Constant handle for the element</span>
<a name="l00094"></a>00094       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *el;
<a name="l00095"></a>00095 
<a name="l00096"></a>00096       <span class="comment">// get the second order nodes (son)</span>
<a name="l00097"></a>00097       <span class="comment">// their element indices start at n_vertices and go to n_nodes</span>
<a name="l00098"></a>00098       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> son_begin = elem-&gt;<a class="code" href="classElem.php#a6bbe1895127c069722e36ee4e2a8a6e1">n_vertices</a>();
<a name="l00099"></a>00099       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> son_end   = elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>();
<a name="l00100"></a>00100       
<a name="l00101"></a>00101       <span class="comment">// loop over all second order nodes (son)</span>
<a name="l00102"></a>00102       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> son=son_begin; son&lt;son_end; son++)
<a name="l00103"></a>00103         {
<a name="l00104"></a>00104           <span class="comment">// Don&#39;t smooth second-order nodes which are on the boundary</span>
<a name="l00105"></a>00105           <span class="keywordflow">if</span> (!on_boundary[elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(son)])
<a name="l00106"></a>00106             {
<a name="l00107"></a>00107               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_adjacent_vertices =
<a name="l00108"></a>00108                 elem-&gt;<a class="code" href="classElem.php#a9f073eee0a8cd4d87e72f0834b4b1815">n_second_order_adjacent_vertices</a>(son);
<a name="l00109"></a>00109 
<a name="l00110"></a>00110               <span class="comment">// calculate the new position which is the average of the</span>
<a name="l00111"></a>00111               <span class="comment">// position of the adjacent vertices</span>
<a name="l00112"></a>00112               <a class="code" href="classPoint.php">Point</a> avg_position(0,0,0);
<a name="l00113"></a>00113               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;n_adjacent_vertices; v++)
<a name="l00114"></a>00114                 avg_position +=
<a name="l00115"></a>00115                   <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a06af1f178519c606d0bdca7857f95ba6">point</a>( elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>( elem-&gt;<a class="code" href="classElem.php#a51e4bd9931fa1378113784f76ac13d6a">second_order_adjacent_vertex</a>(son,v) ) );
<a name="l00116"></a>00116 
<a name="l00117"></a>00117               <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a298477f2d67d6a85f6c7fb5a640e2b64">node</a>(elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(son)) = avg_position / n_adjacent_vertices;
<a name="l00118"></a>00118             }
<a name="l00119"></a>00119         }
<a name="l00120"></a>00120     }
<a name="l00121"></a>00121 }
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 
<a name="l00124"></a><a class="code" href="classLaplaceMeshSmoother.php#ab70683d8eaa560136b8423a734afeb68">00124</a> <span class="keywordtype">void</span> <a class="code" href="classLaplaceMeshSmoother.php#ab70683d8eaa560136b8423a734afeb68">LaplaceMeshSmoother::init</a>()
<a name="l00125"></a>00125 {
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128   <span class="keywordflow">switch</span> (<a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>())
<a name="l00129"></a>00129     {
<a name="l00130"></a>00130       
<a name="l00131"></a>00131       <span class="comment">// TODO:[BSK] Fix this to work for refined meshes...  I think</span>
<a name="l00132"></a>00132       <span class="comment">// the implementation was done quickly for Damien, who did not have</span>
<a name="l00133"></a>00133       <span class="comment">// refined grids.  Fix it here and in the original Mesh member.</span>
<a name="l00134"></a>00134       
<a name="l00135"></a>00135     <span class="keywordflow">case</span> 2: <span class="comment">// Stolen directly from build_L_graph in mesh_base.C</span>
<a name="l00136"></a>00136       {
<a name="l00137"></a>00137         <span class="comment">// Initialize space in the graph.  It is n_nodes</span>
<a name="l00138"></a>00138         <span class="comment">// long and each node is assumed to be connected to</span>
<a name="l00139"></a>00139         <span class="comment">// approximately 4 neighbors.</span>
<a name="l00140"></a>00140         <a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>.resize(<a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l00141"></a>00141 <span class="comment">//      for (unsigned int i=0; i&lt;_mesh.n_nodes(); ++i)</span>
<a name="l00142"></a>00142 <span class="comment">//        _graph[i].reserve(4);</span>
<a name="l00143"></a>00143         
<a name="l00144"></a>00144         <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el  = <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00145"></a>00145         <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00146"></a>00146         
<a name="l00147"></a>00147         <span class="keywordflow">for</span> (; el != end; ++el)
<a name="l00148"></a>00148           {
<a name="l00149"></a>00149             <span class="comment">// Constant handle for the element</span>
<a name="l00150"></a>00150             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *el;
<a name="l00151"></a>00151             
<a name="l00152"></a>00152             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); s++)
<a name="l00153"></a>00153               {
<a name="l00154"></a>00154                 <span class="comment">// Only operate on sides which are on the</span>
<a name="l00155"></a>00155                 <span class="comment">// boundary or for which the current element&#39;s</span>
<a name="l00156"></a>00156                 <span class="comment">// id is greater than its neighbor&#39;s.</span>
<a name="l00157"></a>00157                 <span class="comment">// Sides get only built once.</span>
<a name="l00158"></a>00158                 <span class="keywordflow">if</span> ((elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s) == NULL) ||
<a name="l00159"></a>00159                     (elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() &gt; elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s)-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()))
<a name="l00160"></a>00160                   {
<a name="l00161"></a>00161                     <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> side(elem-&gt;<a class="code" href="classElem.php#a554c146bcfb5537636bd77a157f21b85">build_side</a>(s));
<a name="l00162"></a>00162                     <a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[side-&gt;node(0)].push_back(side-&gt;node(1));
<a name="l00163"></a>00163                     <a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[side-&gt;node(1)].push_back(side-&gt;node(0));
<a name="l00164"></a>00164                 }
<a name="l00165"></a>00165               }
<a name="l00166"></a>00166           }
<a name="l00167"></a>00167         <a class="code" href="classLaplaceMeshSmoother.php#aad041b842be1c1813c57744ec8b467dc">_initialized</a> = <span class="keyword">true</span>;
<a name="l00168"></a>00168         <span class="keywordflow">break</span>;
<a name="l00169"></a>00169       }
<a name="l00170"></a>00170 
<a name="l00171"></a>00171     <span class="keywordflow">case</span> 3: <span class="comment">// Stolen blatantly from build_L_graph in mesh_base.C</span>
<a name="l00172"></a>00172       {
<a name="l00173"></a>00173         <span class="comment">// Initialize space in the graph.  In 3D, I&#39;ve assumed</span>
<a name="l00174"></a>00174         <span class="comment">// that each node was connected to approximately 3 neighbors.</span>
<a name="l00175"></a>00175         <a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>.resize(<a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l00176"></a>00176 <span class="comment">//      for (unsigned int i=0; i&lt;_mesh.n_nodes(); ++i)</span>
<a name="l00177"></a>00177 <span class="comment">//        _graph[i].reserve(8);</span>
<a name="l00178"></a>00178         
<a name="l00179"></a>00179         <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el  = <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00180"></a>00180         <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182         <span class="keywordflow">for</span> (; el != end; ++el)
<a name="l00183"></a>00183           {
<a name="l00184"></a>00184             <span class="comment">// Shortcut notation for simplicity</span>
<a name="l00185"></a>00185             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *el;
<a name="l00186"></a>00186             
<a name="l00187"></a>00187             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> f=0; f&lt;elem-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); f++) <span class="comment">// Loop over faces</span>
<a name="l00188"></a>00188               <span class="keywordflow">if</span> ((elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(f) == NULL) ||
<a name="l00189"></a>00189                   (elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() &gt; elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(f)-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()))
<a name="l00190"></a>00190                 {
<a name="l00191"></a>00191                   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(elem-&gt;<a class="code" href="classElem.php#a554c146bcfb5537636bd77a157f21b85">build_side</a>(f));
<a name="l00192"></a>00192                 
<a name="l00193"></a>00193                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;face-&gt;n_neighbors(); s++) <span class="comment">// Loop over face&#39;s edges</span>
<a name="l00194"></a>00194                     {
<a name="l00195"></a>00195                       <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> side(face-&gt;build_side(s));
<a name="l00196"></a>00196                     
<a name="l00197"></a>00197                       <span class="comment">// At this point, we just insert the node numbers</span>
<a name="l00198"></a>00198                       <span class="comment">// again.  At the end we&#39;ll call sort and unique</span>
<a name="l00199"></a>00199                       <span class="comment">// to make sure there are no duplicates</span>
<a name="l00200"></a>00200                       <a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[side-&gt;node(0)].push_back(side-&gt;node(1));
<a name="l00201"></a>00201                       <a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[side-&gt;node(1)].push_back(side-&gt;node(0));
<a name="l00202"></a>00202                     }
<a name="l00203"></a>00203                 }
<a name="l00204"></a>00204           }
<a name="l00205"></a>00205 
<a name="l00206"></a>00206         <span class="comment">// Now call sort and unique to remove duplicate entries.</span>
<a name="l00207"></a>00207         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>(); ++i)
<a name="l00208"></a>00208           {
<a name="l00209"></a>00209             std::sort  (<a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[i].begin(), <a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[i].end());
<a name="l00210"></a>00210             <a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[i].erase(std::unique(<a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[i].begin(), <a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[i].end()), <a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[i].end());
<a name="l00211"></a>00211           }
<a name="l00212"></a>00212         
<a name="l00213"></a>00213         <a class="code" href="classLaplaceMeshSmoother.php#aad041b842be1c1813c57744ec8b467dc">_initialized</a> = <span class="keyword">true</span>;
<a name="l00214"></a>00214         <span class="keywordflow">break</span>;
<a name="l00215"></a>00215       }
<a name="l00216"></a>00216 
<a name="l00217"></a>00217     <span class="keywordflow">default</span>:
<a name="l00218"></a>00218       {
<a name="l00219"></a>00219         std::cerr &lt;&lt; <span class="stringliteral">&quot;At this time it is not possible &quot;</span>
<a name="l00220"></a>00220                   &lt;&lt; <span class="stringliteral">&quot;to smooth a dimension &quot;</span>
<a name="l00221"></a>00221                   &lt;&lt; <a class="code" href="classMeshSmoother.php#a7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>()
<a name="l00222"></a>00222                   &lt;&lt; <span class="stringliteral">&quot;mesh.  Aborting...&quot;</span>
<a name="l00223"></a>00223                   &lt;&lt; std::endl;
<a name="l00224"></a>00224         libmesh_error();
<a name="l00225"></a>00225       }
<a name="l00226"></a>00226       
<a name="l00227"></a>00227     }
<a name="l00228"></a>00228 }
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 
<a name="l00233"></a><a class="code" href="classLaplaceMeshSmoother.php#a8195e341cfaf73c63b07afaa1b7c903a">00233</a> <span class="keywordtype">void</span> <a class="code" href="classLaplaceMeshSmoother.php#a8195e341cfaf73c63b07afaa1b7c903a">LaplaceMeshSmoother::print_graph</a>()<span class="keyword"> const</span>
<a name="l00234"></a>00234 <span class="keyword"></span>{
<a name="l00235"></a>00235   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>.size(); ++i)
<a name="l00236"></a>00236     {
<a name="l00237"></a>00237       std::cout &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;: &quot;</span>;
<a name="l00238"></a>00238       std::copy(<a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[i].begin(),
<a name="l00239"></a>00239                 <a class="code" href="classLaplaceMeshSmoother.php#a9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[i].end(),
<a name="l00240"></a>00240                 std::ostream_iterator&lt;unsigned int&gt;(std::cout, <span class="stringliteral">&quot; &quot;</span>));
<a name="l00241"></a>00241       std::cout &lt;&lt; std::endl;
<a name="l00242"></a>00242     }
<a name="l00243"></a>00243 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
