<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_smoother_vsmoother.h</h1>  </div>
</div>
<div class="contents">
<a href="mesh__smoother__vsmoother_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_smoother_vsmoother.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __mesh_smoother_vsmoother_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_smoother_vsmoother_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#ifdef LIBMESH_ENABLE_VSMOOTHER</span>
<a name="l00027"></a>00027 <span class="preprocessor"></span>
<a name="l00028"></a>00028 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &lt;stdio.h&gt;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &lt;stdlib.h&gt;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &lt;math.h&gt;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &lt;time.h&gt;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">//jj</span>
<a name="l00037"></a><a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">00037</a> <span class="keyword">typedef</span> <span class="keywordtype">double</span>     * <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a>;
<a name="l00038"></a><a class="code" href="mesh__smoother__vsmoother_8h.php#a51d3d3f63d1d3c78b0f7a395d5dca5c6">00038</a> <span class="keyword">typedef</span> <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a>   * <a class="code" href="mesh__smoother__vsmoother_8h.php#a51d3d3f63d1d3c78b0f7a395d5dca5c6">LPLPDOUBLE</a>;
<a name="l00039"></a><a class="code" href="mesh__smoother__vsmoother_8h.php#ad0c91302eded5c4d6562e5c20cb2b074">00039</a> <span class="keyword">typedef</span> <a class="code" href="mesh__smoother__vsmoother_8h.php#a51d3d3f63d1d3c78b0f7a395d5dca5c6">LPLPDOUBLE</a>   * <a class="code" href="mesh__smoother__vsmoother_8h.php#ad0c91302eded5c4d6562e5c20cb2b074">LPLPLPDOUBLE</a>;
<a name="l00040"></a><a class="code" href="mesh__smoother__vsmoother_8h.php#ab064840df4ab5a8cf90ddb963f94de34">00040</a> <span class="keyword">typedef</span> <span class="keywordtype">void</span>     * <a class="code" href="mesh__smoother__vsmoother_8h.php#ab064840df4ab5a8cf90ddb963f94de34">LPVOID</a>;
<a name="l00041"></a><a class="code" href="mesh__smoother__vsmoother_8h.php#abe3453d5a2a73bcd3c2eee82ed6f433b">00041</a> <span class="keyword">typedef</span> <a class="code" href="mesh__smoother__vsmoother_8h.php#ab064840df4ab5a8cf90ddb963f94de34">LPVOID</a>   * <a class="code" href="mesh__smoother__vsmoother_8h.php#abe3453d5a2a73bcd3c2eee82ed6f433b">LPLPVOID</a>;
<a name="l00042"></a><a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">00042</a> <span class="keyword">typedef</span> <span class="keywordtype">int</span>  * <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a>;
<a name="l00043"></a><a class="code" href="mesh__smoother__vsmoother_8h.php#afd3dfc3ea89eac683f1db3acfc6695be">00043</a> <span class="keyword">typedef</span> <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a>  * <a class="code" href="mesh__smoother__vsmoother_8h.php#afd3dfc3ea89eac683f1db3acfc6695be">LPLPINT</a>;
<a name="l00044"></a><a class="code" href="mesh__smoother__vsmoother_8h.php#a91ad9478d81a7aaf2593e8d9c3d06a14">00044</a> <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="mesh__smoother__vsmoother_8h.php#a91ad9478d81a7aaf2593e8d9c3d06a14">uint</a>;
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00047"></a>00047 <span class="preprocessor">#include &quot;<a class="code" href="mesh__smoother_8h.php">mesh_smoother.h</a>&quot;</span>
<a name="l00048"></a>00048 <span class="preprocessor">#include &quot;<a class="code" href="unstructured__mesh_8h.php">unstructured_mesh.h</a>&quot;</span>
<a name="l00049"></a>00049 
<a name="l00072"></a>00072 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00073"></a>00073 <span class="comment">// VariationalMeshSmoother class definition</span>
<a name="l00074"></a><a class="code" href="classVariationalMeshSmoother.php">00074</a> <span class="keyword">class </span><a class="code" href="classVariationalMeshSmoother.php">VariationalMeshSmoother</a> : <span class="keyword">public</span> <a class="code" href="classMeshSmoother.php">MeshSmoother</a>
<a name="l00075"></a>00075 {
<a name="l00076"></a>00076 <span class="keyword">public</span>:
<a name="l00077"></a>00077 
<a name="l00081"></a><a class="code" href="classVariationalMeshSmoother.php#a40a23fec22d54675be7695bd30368a6d">00081</a>   <a class="code" href="classVariationalMeshSmoother.php#a40a23fec22d54675be7695bd30368a6d">VariationalMeshSmoother</a>(<a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; mesh, <span class="keyword">const</span> <span class="keywordtype">double</span>&amp; theta=0.5, <span class="keyword">const</span> <a class="code" href="mesh__smoother__vsmoother_8h.php#a91ad9478d81a7aaf2593e8d9c3d06a14">uint</a>&amp; miniter=2,
<a name="l00082"></a>00082                           <span class="keyword">const</span> <a class="code" href="mesh__smoother__vsmoother_8h.php#a91ad9478d81a7aaf2593e8d9c3d06a14">uint</a>&amp; maxiter=5, <span class="keyword">const</span> <a class="code" href="mesh__smoother__vsmoother_8h.php#a91ad9478d81a7aaf2593e8d9c3d06a14">uint</a>&amp; miniterBC=5)
<a name="l00083"></a>00083     :<a class="code" href="classMeshSmoother.php">MeshSmoother</a>(mesh),
<a name="l00084"></a>00084      <a class="code" href="classVariationalMeshSmoother.php#aa2555f98a449be76538a78d5c8accb29">_percent_to_move</a>(1),
<a name="l00085"></a>00085      <a class="code" href="classVariationalMeshSmoother.php#ab7a657df048d1e808e0b1ea4bdd83bcf">_adapt_data</a>(NULL),
<a name="l00086"></a>00086      <a class="code" href="classVariationalMeshSmoother.php#a7ded6ffb14dcbe92d5d66c038be8cf1b">_dim</a>(mesh.mesh_dimension()),
<a name="l00087"></a>00087      <a class="code" href="classVariationalMeshSmoother.php#a169f9daf376c96de210dd42160f36718">_miniter</a>(miniter),
<a name="l00088"></a>00088      <a class="code" href="classVariationalMeshSmoother.php#a83fb44270d1866d9ddc243ff74c581af">_maxiter</a>(maxiter),
<a name="l00089"></a>00089      <a class="code" href="classVariationalMeshSmoother.php#a04473201370957005e5e2d6e6b65f453">_miniterBC</a>(miniterBC),
<a name="l00090"></a>00090      
<a name="l00091"></a>00091      <a class="code" href="classVariationalMeshSmoother.php#aa656c997748231b33e77b4671c866213">_metric</a>(<a class="code" href="classVariationalMeshSmoother.php#a2f22e241290a880729170f9a0c5ac675a4244136b6f508eefc6058a70a19d4ff4">uniform</a>),
<a name="l00092"></a>00092      <a class="code" href="classVariationalMeshSmoother.php#aba4e7c886fbd7d85e612417dc3c738cf">_adaptive_func</a>(<a class="code" href="classVariationalMeshSmoother.php#acb4553cd5806fbed05a7d1cda8b20676ae697a2ae4f93e3a956c611636b27e8d7">none</a>),
<a name="l00093"></a>00093      <a class="code" href="classVariationalMeshSmoother.php#ace1c9194b09618259f3a3f6dfedc060e">_theta</a>(theta),
<a name="l00094"></a>00094      <a class="code" href="classVariationalMeshSmoother.php#af876de2d32e6f756b8912a2cc5fdd2a0">_generate_data</a>(false),
<a name="l00095"></a>00095 
<a name="l00096"></a>00096      <a class="code" href="classVariationalMeshSmoother.php#a539a84077ff6d65584072085497f4c93">_area_of_interest</a>(NULL)
<a name="l00097"></a>00097   {}
<a name="l00098"></a>00098 
<a name="l00102"></a><a class="code" href="classVariationalMeshSmoother.php#a5f8192d72c4aca66eb079a2df3d6691e">00102</a>   <a class="code" href="classVariationalMeshSmoother.php#a40a23fec22d54675be7695bd30368a6d">VariationalMeshSmoother</a>(<a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; mesh, std::vector&lt;float&gt;* adapt_data, <span class="keyword">const</span> <span class="keywordtype">double</span>&amp; theta=0.5,
<a name="l00103"></a>00103                           <span class="keyword">const</span> <a class="code" href="mesh__smoother__vsmoother_8h.php#a91ad9478d81a7aaf2593e8d9c3d06a14">uint</a>&amp; miniter=2, <span class="keyword">const</span> <a class="code" href="mesh__smoother__vsmoother_8h.php#a91ad9478d81a7aaf2593e8d9c3d06a14">uint</a>&amp; maxiter=5, <span class="keyword">const</span> <a class="code" href="mesh__smoother__vsmoother_8h.php#a91ad9478d81a7aaf2593e8d9c3d06a14">uint</a>&amp; miniterBC=5,
<a name="l00104"></a>00104                           <span class="keyword">const</span> <span class="keywordtype">double</span>&amp; percent_to_move=1)
<a name="l00105"></a>00105     :<a class="code" href="classMeshSmoother.php">MeshSmoother</a>(mesh),
<a name="l00106"></a>00106      <a class="code" href="classVariationalMeshSmoother.php#aa2555f98a449be76538a78d5c8accb29">_percent_to_move</a>(percent_to_move),
<a name="l00107"></a>00107      <a class="code" href="classVariationalMeshSmoother.php#ab7a657df048d1e808e0b1ea4bdd83bcf">_adapt_data</a>(adapt_data),
<a name="l00108"></a>00108      <a class="code" href="classVariationalMeshSmoother.php#a7ded6ffb14dcbe92d5d66c038be8cf1b">_dim</a>(mesh.mesh_dimension()),
<a name="l00109"></a>00109      <a class="code" href="classVariationalMeshSmoother.php#a169f9daf376c96de210dd42160f36718">_miniter</a>(miniter),
<a name="l00110"></a>00110      <a class="code" href="classVariationalMeshSmoother.php#a83fb44270d1866d9ddc243ff74c581af">_maxiter</a>(maxiter),
<a name="l00111"></a>00111      <a class="code" href="classVariationalMeshSmoother.php#a04473201370957005e5e2d6e6b65f453">_miniterBC</a>(miniterBC),
<a name="l00112"></a>00112      
<a name="l00113"></a>00113      <a class="code" href="classVariationalMeshSmoother.php#aa656c997748231b33e77b4671c866213">_metric</a>(<a class="code" href="classVariationalMeshSmoother.php#a2f22e241290a880729170f9a0c5ac675a4244136b6f508eefc6058a70a19d4ff4">uniform</a>),
<a name="l00114"></a>00114      <a class="code" href="classVariationalMeshSmoother.php#aba4e7c886fbd7d85e612417dc3c738cf">_adaptive_func</a>(<a class="code" href="classVariationalMeshSmoother.php#acb4553cd5806fbed05a7d1cda8b20676aaf77d2a7ad871a6e573213127d04453a">cell</a>),
<a name="l00115"></a>00115      <a class="code" href="classVariationalMeshSmoother.php#ace1c9194b09618259f3a3f6dfedc060e">_theta</a>(theta),
<a name="l00116"></a>00116      <a class="code" href="classVariationalMeshSmoother.php#af876de2d32e6f756b8912a2cc5fdd2a0">_generate_data</a>(false),
<a name="l00117"></a>00117 
<a name="l00118"></a>00118      <a class="code" href="classVariationalMeshSmoother.php#a539a84077ff6d65584072085497f4c93">_area_of_interest</a>(NULL)
<a name="l00119"></a>00119   {}
<a name="l00120"></a>00120   
<a name="l00125"></a><a class="code" href="classVariationalMeshSmoother.php#a94e3ba7fbcbaf248689f1f819b78a023">00125</a>   <a class="code" href="classVariationalMeshSmoother.php#a40a23fec22d54675be7695bd30368a6d">VariationalMeshSmoother</a>(<a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; mesh, <span class="keyword">const</span> <a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>* area_of_interest, std::vector&lt;float&gt;* adapt_data,
<a name="l00126"></a>00126                           <span class="keyword">const</span> <span class="keywordtype">double</span>&amp; theta=0.5, <span class="keyword">const</span> <a class="code" href="mesh__smoother__vsmoother_8h.php#a91ad9478d81a7aaf2593e8d9c3d06a14">uint</a>&amp; miniter=2, <span class="keyword">const</span> <a class="code" href="mesh__smoother__vsmoother_8h.php#a91ad9478d81a7aaf2593e8d9c3d06a14">uint</a>&amp; maxiter=5,
<a name="l00127"></a>00127                           <span class="keyword">const</span> <a class="code" href="mesh__smoother__vsmoother_8h.php#a91ad9478d81a7aaf2593e8d9c3d06a14">uint</a>&amp; miniterBC=5, <span class="keyword">const</span> <span class="keywordtype">double</span>&amp; percent_to_move=1)
<a name="l00128"></a>00128     :<a class="code" href="classMeshSmoother.php">MeshSmoother</a>(mesh),
<a name="l00129"></a>00129      <a class="code" href="classVariationalMeshSmoother.php#aa2555f98a449be76538a78d5c8accb29">_percent_to_move</a>(percent_to_move),
<a name="l00130"></a>00130      <a class="code" href="classVariationalMeshSmoother.php#ab7a657df048d1e808e0b1ea4bdd83bcf">_adapt_data</a>(adapt_data),
<a name="l00131"></a>00131      <a class="code" href="classVariationalMeshSmoother.php#a7ded6ffb14dcbe92d5d66c038be8cf1b">_dim</a>(mesh.mesh_dimension()),
<a name="l00132"></a>00132      <a class="code" href="classVariationalMeshSmoother.php#a169f9daf376c96de210dd42160f36718">_miniter</a>(miniter),
<a name="l00133"></a>00133      <a class="code" href="classVariationalMeshSmoother.php#a83fb44270d1866d9ddc243ff74c581af">_maxiter</a>(maxiter),
<a name="l00134"></a>00134      <a class="code" href="classVariationalMeshSmoother.php#a04473201370957005e5e2d6e6b65f453">_miniterBC</a>(miniterBC),
<a name="l00135"></a>00135 
<a name="l00136"></a>00136      <a class="code" href="classVariationalMeshSmoother.php#aa656c997748231b33e77b4671c866213">_metric</a>(<a class="code" href="classVariationalMeshSmoother.php#a2f22e241290a880729170f9a0c5ac675a4244136b6f508eefc6058a70a19d4ff4">uniform</a>),
<a name="l00137"></a>00137      <a class="code" href="classVariationalMeshSmoother.php#aba4e7c886fbd7d85e612417dc3c738cf">_adaptive_func</a>(<a class="code" href="classVariationalMeshSmoother.php#acb4553cd5806fbed05a7d1cda8b20676aaf77d2a7ad871a6e573213127d04453a">cell</a>),
<a name="l00138"></a>00138      <a class="code" href="classVariationalMeshSmoother.php#ace1c9194b09618259f3a3f6dfedc060e">_theta</a>(theta),
<a name="l00139"></a>00139      <a class="code" href="classVariationalMeshSmoother.php#af876de2d32e6f756b8912a2cc5fdd2a0">_generate_data</a>(false),
<a name="l00140"></a>00140 
<a name="l00141"></a>00141      <a class="code" href="classVariationalMeshSmoother.php#a539a84077ff6d65584072085497f4c93">_area_of_interest</a>(area_of_interest)
<a name="l00142"></a>00142   {}
<a name="l00143"></a>00143 
<a name="l00144"></a><a class="code" href="classVariationalMeshSmoother.php#a2f22e241290a880729170f9a0c5ac675">00144</a>   <span class="keyword">enum</span> <a class="code" href="classVariationalMeshSmoother.php#a2f22e241290a880729170f9a0c5ac675">metric_type</a>
<a name="l00145"></a>00145   {
<a name="l00146"></a><a class="code" href="classVariationalMeshSmoother.php#a2f22e241290a880729170f9a0c5ac675a4244136b6f508eefc6058a70a19d4ff4">00146</a>     <a class="code" href="classVariationalMeshSmoother.php#a2f22e241290a880729170f9a0c5ac675a4244136b6f508eefc6058a70a19d4ff4">uniform</a>=1,
<a name="l00147"></a><a class="code" href="classVariationalMeshSmoother.php#a2f22e241290a880729170f9a0c5ac675a79c23fd54d8224b35eab7abd27c22708">00147</a>     <a class="code" href="classVariationalMeshSmoother.php#a2f22e241290a880729170f9a0c5ac675a79c23fd54d8224b35eab7abd27c22708">volumetric</a>=2,
<a name="l00148"></a><a class="code" href="classVariationalMeshSmoother.php#a2f22e241290a880729170f9a0c5ac675ac94fe1f57a1734f813ca3d2aee388e6a">00148</a>     <a class="code" href="classVariationalMeshSmoother.php#a2f22e241290a880729170f9a0c5ac675ac94fe1f57a1734f813ca3d2aee388e6a">directional</a>=3
<a name="l00149"></a>00149   };
<a name="l00150"></a>00150 
<a name="l00151"></a><a class="code" href="classVariationalMeshSmoother.php#acb4553cd5806fbed05a7d1cda8b20676">00151</a>   <span class="keyword">enum</span> <a class="code" href="classVariationalMeshSmoother.php#acb4553cd5806fbed05a7d1cda8b20676">adapt_type</a>
<a name="l00152"></a>00152   {
<a name="l00153"></a><a class="code" href="classVariationalMeshSmoother.php#acb4553cd5806fbed05a7d1cda8b20676aaf77d2a7ad871a6e573213127d04453a">00153</a>     <a class="code" href="classVariationalMeshSmoother.php#acb4553cd5806fbed05a7d1cda8b20676aaf77d2a7ad871a6e573213127d04453a">cell</a>=-1,
<a name="l00154"></a><a class="code" href="classVariationalMeshSmoother.php#acb4553cd5806fbed05a7d1cda8b20676ae697a2ae4f93e3a956c611636b27e8d7">00154</a>     <a class="code" href="classVariationalMeshSmoother.php#acb4553cd5806fbed05a7d1cda8b20676ae697a2ae4f93e3a956c611636b27e8d7">none</a>=0,
<a name="l00155"></a><a class="code" href="classVariationalMeshSmoother.php#acb4553cd5806fbed05a7d1cda8b20676adb674cd1d6a5817b27f4a2eb8fa44f88">00155</a>     <a class="code" href="classVariationalMeshSmoother.php#acb4553cd5806fbed05a7d1cda8b20676adb674cd1d6a5817b27f4a2eb8fa44f88">node</a>=1
<a name="l00156"></a>00156   };
<a name="l00157"></a>00157 
<a name="l00161"></a><a class="code" href="classVariationalMeshSmoother.php#af4ad7d3e829a5f8a3476f467d376219f">00161</a>   <span class="keyword">virtual</span> <a class="code" href="classVariationalMeshSmoother.php#af4ad7d3e829a5f8a3476f467d376219f">~VariationalMeshSmoother</a>() {}
<a name="l00162"></a>00162 
<a name="l00169"></a><a class="code" href="classVariationalMeshSmoother.php#aa1c33896624b8728b8e813ba6d128850">00169</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classVariationalMeshSmoother.php#aa1c33896624b8728b8e813ba6d128850">smooth</a>() { <a class="code" href="classVariationalMeshSmoother.php#afbc17ff699a9045a5f0e92057004ecd8">_distance</a> = this-&gt;<a class="code" href="classVariationalMeshSmoother.php#aa1c33896624b8728b8e813ba6d128850">smooth</a>(1); }
<a name="l00170"></a>00170 
<a name="l00176"></a>00176   <span class="keywordtype">double</span> <a class="code" href="classVariationalMeshSmoother.php#aa1c33896624b8728b8e813ba6d128850">smooth</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_iterations);
<a name="l00177"></a>00177 
<a name="l00183"></a><a class="code" href="classVariationalMeshSmoother.php#a9b63782bef5b71ecd43cd3e0da88468f">00183</a>   <span class="keywordtype">double</span> <a class="code" href="classVariationalMeshSmoother.php#a9b63782bef5b71ecd43cd3e0da88468f" title="Member function distanceMoved">distanceMoved</a>()<span class="keyword"> const </span>{<span class="keywordflow">return</span> <a class="code" href="classVariationalMeshSmoother.php#afbc17ff699a9045a5f0e92057004ecd8">_distance</a>;}
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 <span class="keyword">private</span>:
<a name="l00186"></a>00186 
<a name="l00190"></a><a class="code" href="classVariationalMeshSmoother.php#afbc17ff699a9045a5f0e92057004ecd8">00190</a>   <span class="keywordtype">double</span> <a class="code" href="classVariationalMeshSmoother.php#afbc17ff699a9045a5f0e92057004ecd8">_distance</a>;
<a name="l00191"></a>00191   
<a name="l00195"></a><a class="code" href="classVariationalMeshSmoother.php#aa2555f98a449be76538a78d5c8accb29">00195</a>   <span class="keyword">const</span> <span class="keywordtype">double</span> <a class="code" href="classVariationalMeshSmoother.php#aa2555f98a449be76538a78d5c8accb29">_percent_to_move</a>;
<a name="l00196"></a>00196   
<a name="l00200"></a><a class="code" href="classVariationalMeshSmoother.php#a166e923b6a4c06f30ef27e1c98efc3ec">00200</a>   <span class="keywordtype">double</span> <a class="code" href="classVariationalMeshSmoother.php#a166e923b6a4c06f30ef27e1c98efc3ec">_dist_norm</a>;
<a name="l00201"></a>00201   
<a name="l00205"></a><a class="code" href="classVariationalMeshSmoother.php#ad94f4b11d00f3574e059a6e168ce8b6d">00205</a>   std::map&lt;unsigned int, std::vector&lt;unsigned int&gt; &gt; <a class="code" href="classVariationalMeshSmoother.php#ad94f4b11d00f3574e059a6e168ce8b6d">_hanging_nodes</a>;
<a name="l00206"></a>00206   
<a name="l00210"></a><a class="code" href="classVariationalMeshSmoother.php#ab7a657df048d1e808e0b1ea4bdd83bcf">00210</a>   std::vector&lt;float&gt; * <a class="code" href="classVariationalMeshSmoother.php#ab7a657df048d1e808e0b1ea4bdd83bcf">_adapt_data</a>;
<a name="l00211"></a>00211 
<a name="l00215"></a><a class="code" href="classVariationalMeshSmoother.php#a04473201370957005e5e2d6e6b65f453">00215</a>   <span class="keyword">const</span> <a class="code" href="mesh__smoother__vsmoother_8h.php#a91ad9478d81a7aaf2593e8d9c3d06a14">uint</a>&amp; <a class="code" href="classVariationalMeshSmoother.php#a7ded6ffb14dcbe92d5d66c038be8cf1b">_dim</a>,<a class="code" href="classVariationalMeshSmoother.php#a169f9daf376c96de210dd42160f36718">_miniter</a>,<a class="code" href="classVariationalMeshSmoother.php#a83fb44270d1866d9ddc243ff74c581af">_maxiter</a>,<a class="code" href="classVariationalMeshSmoother.php#a04473201370957005e5e2d6e6b65f453">_miniterBC</a>;
<a name="l00216"></a><a class="code" href="classVariationalMeshSmoother.php#aa656c997748231b33e77b4671c866213">00216</a>   <span class="keyword">const</span> <a class="code" href="classVariationalMeshSmoother.php#a2f22e241290a880729170f9a0c5ac675">metric_type</a>&amp; <a class="code" href="classVariationalMeshSmoother.php#aa656c997748231b33e77b4671c866213">_metric</a>;
<a name="l00217"></a><a class="code" href="classVariationalMeshSmoother.php#aba4e7c886fbd7d85e612417dc3c738cf">00217</a>   <span class="keyword">const</span> <a class="code" href="classVariationalMeshSmoother.php#acb4553cd5806fbed05a7d1cda8b20676">adapt_type</a>&amp; <a class="code" href="classVariationalMeshSmoother.php#aba4e7c886fbd7d85e612417dc3c738cf">_adaptive_func</a>;
<a name="l00218"></a><a class="code" href="classVariationalMeshSmoother.php#ace1c9194b09618259f3a3f6dfedc060e">00218</a>   <span class="keyword">const</span> <span class="keywordtype">double</span>&amp; <a class="code" href="classVariationalMeshSmoother.php#ace1c9194b09618259f3a3f6dfedc060e">_theta</a>;
<a name="l00219"></a><a class="code" href="classVariationalMeshSmoother.php#af876de2d32e6f756b8912a2cc5fdd2a0">00219</a>   <span class="keyword">const</span> <span class="keywordtype">bool</span>&amp; <a class="code" href="classVariationalMeshSmoother.php#af876de2d32e6f756b8912a2cc5fdd2a0">_generate_data</a>;
<a name="l00220"></a>00220 
<a name="l00224"></a><a class="code" href="classVariationalMeshSmoother.php#a539a84077ff6d65584072085497f4c93">00224</a>   <span class="keyword">const</span> <a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a> * <a class="code" href="classVariationalMeshSmoother.php#a539a84077ff6d65584072085497f4c93">_area_of_interest</a>;
<a name="l00225"></a>00225   
<a name="l00226"></a>00226   <span class="keywordtype">void</span> <a class="code" href="classVariationalMeshSmoother.php#ac524a60baf19332899f2a69143e8f484">adjust_adapt_data</a>();
<a name="l00227"></a>00227   <span class="keywordtype">float</span> <a class="code" href="classVariationalMeshSmoother.php#a8f5c48b17c4ea4f6621b3f09ff5ad1b1">adapt_minimum</a>() <span class="keyword">const</span>;
<a name="l00228"></a>00228   
<a name="l00233"></a>00233   <span class="comment">/*-- allocate memory --*/</span>
<a name="l00234"></a><a class="code" href="classVariationalMeshSmoother.php#a560a90707496f7578d69953d8a0001e5">00234</a>   <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a> <a class="code" href="classVariationalMeshSmoother.php#a560a90707496f7578d69953d8a0001e5">alloc_d_n1</a>(<span class="keywordtype">int</span> m1)              { <span class="keywordflow">return</span>((<a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a>)malloc(m1*<span class="keyword">sizeof</span>(<span class="keywordtype">double</span>))); }
<a name="l00235"></a><a class="code" href="classVariationalMeshSmoother.php#af1fdfdff1cd7ce3930dd8ae12261350b">00235</a>   <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> <a class="code" href="classVariationalMeshSmoother.php#af1fdfdff1cd7ce3930dd8ae12261350b">alloc_i_n1</a>(<span class="keywordtype">int</span> m1)                 { <span class="keywordflow">return</span>((<a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a>)malloc(m1*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>))); }
<a name="l00236"></a><a class="code" href="classVariationalMeshSmoother.php#a2b2c5c74f517c3b8af2a758f33974434">00236</a>   <a class="code" href="mesh__smoother__vsmoother_8h.php#afd3dfc3ea89eac683f1db3acfc6695be">LPLPINT</a> <a class="code" href="classVariationalMeshSmoother.php#a2b2c5c74f517c3b8af2a758f33974434">alloc_i_n1_n2</a>(<span class="keywordtype">int</span> m1, <span class="keywordtype">int</span>)    { <span class="keywordflow">return</span>((<a class="code" href="mesh__smoother__vsmoother_8h.php#afd3dfc3ea89eac683f1db3acfc6695be">LPLPINT</a>)malloc(m1*<span class="keyword">sizeof</span>(<a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a>))); }
<a name="l00237"></a><a class="code" href="classVariationalMeshSmoother.php#a30df1b79983f49fc89068700eee9dc24">00237</a>   <a class="code" href="mesh__smoother__vsmoother_8h.php#a51d3d3f63d1d3c78b0f7a395d5dca5c6">LPLPDOUBLE</a> <a class="code" href="classVariationalMeshSmoother.php#a30df1b79983f49fc89068700eee9dc24">alloc_d_n1_n2</a>(<span class="keywordtype">int</span> m1, <span class="keywordtype">int</span>) { <span class="keywordflow">return</span>((<a class="code" href="mesh__smoother__vsmoother_8h.php#a51d3d3f63d1d3c78b0f7a395d5dca5c6">LPLPDOUBLE</a>)malloc(m1*<span class="keyword">sizeof</span>(<a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a>))); }
<a name="l00238"></a><a class="code" href="classVariationalMeshSmoother.php#aed494b6d7484b4c2ee1c5817f68d73cc">00238</a>   <a class="code" href="mesh__smoother__vsmoother_8h.php#ad0c91302eded5c4d6562e5c20cb2b074">LPLPLPDOUBLE</a> <a class="code" href="classVariationalMeshSmoother.php#aed494b6d7484b4c2ee1c5817f68d73cc">alloc_d_n1_n2_n3</a>(<span class="keywordtype">int</span> m1, <span class="keywordtype">int</span>, <span class="keywordtype">int</span>) { <span class="keywordflow">return</span>((<a class="code" href="mesh__smoother__vsmoother_8h.php#ad0c91302eded5c4d6562e5c20cb2b074">LPLPLPDOUBLE</a>)malloc(m1*<span class="keyword">sizeof</span>(<a class="code" href="mesh__smoother__vsmoother_8h.php#a51d3d3f63d1d3c78b0f7a395d5dca5c6">LPLPDOUBLE</a>))); }
<a name="l00239"></a>00239 
<a name="l00240"></a>00240   <span class="keywordtype">int</span> <a class="code" href="classVariationalMeshSmoother.php#a474afd4ab23fc7c7754d0f9eda2281e1">writegr</a>(<span class="keywordtype">int</span> n, <span class="keywordtype">int</span> N, <a class="code" href="mesh__smoother__vsmoother_8h.php#a51d3d3f63d1d3c78b0f7a395d5dca5c6">LPLPDOUBLE</a> R, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> mask, <span class="keywordtype">int</span> ncells, <a class="code" href="mesh__smoother__vsmoother_8h.php#afd3dfc3ea89eac683f1db3acfc6695be">LPLPINT</a> cells,
<a name="l00241"></a>00241               <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> mcells, <span class="keywordtype">int</span> nedges, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> edges, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> hnodes, <span class="keyword">const</span> <span class="keywordtype">char</span> grid[],
<a name="l00242"></a>00242               <span class="keywordtype">int</span> me, <span class="keyword">const</span> <span class="keywordtype">char</span> grid_old[], FILE *sout);
<a name="l00243"></a>00243 
<a name="l00244"></a>00244   <span class="keywordtype">int</span> <a class="code" href="classVariationalMeshSmoother.php#a08895896bd81cb86b2fa592370573174">readgr</a>(<span class="keywordtype">int</span> n, <span class="keywordtype">int</span> N, <a class="code" href="mesh__smoother__vsmoother_8h.php#a51d3d3f63d1d3c78b0f7a395d5dca5c6">LPLPDOUBLE</a> R, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> mask, <span class="keywordtype">int</span> ncells,
<a name="l00245"></a>00245              <a class="code" href="mesh__smoother__vsmoother_8h.php#afd3dfc3ea89eac683f1db3acfc6695be">LPLPINT</a> cells, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> mcells, <span class="keywordtype">int</span> nedges, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> edges, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> hnodes, FILE *sout);
<a name="l00246"></a>00246 
<a name="l00247"></a>00247   <span class="keywordtype">int</span> <a class="code" href="classVariationalMeshSmoother.php#aef21a059d9e6e4f0e99d70a90754beee">readmetr</a>(<span class="keywordtype">char</span> *<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>, <a class="code" href="mesh__smoother__vsmoother_8h.php#ad0c91302eded5c4d6562e5c20cb2b074">LPLPLPDOUBLE</a> H, <span class="keywordtype">int</span> ncells, <span class="keywordtype">int</span> n, FILE *sout);
<a name="l00248"></a>00248 
<a name="l00249"></a>00249   <span class="keywordtype">int</span> <a class="code" href="classVariationalMeshSmoother.php#a8f418c37380d09bc129a46b47a529a01">read_adp</a>(<a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a> afun, <span class="keywordtype">char</span> *adap, FILE *sout);
<a name="l00250"></a>00250 
<a name="l00251"></a>00251   <span class="keywordtype">double</span> <a class="code" href="classVariationalMeshSmoother.php#a13e2fcfd8008b781a4daef82c00f8182">jac3</a>(<span class="keywordtype">double</span> x1,<span class="keywordtype">double</span> y1,<span class="keywordtype">double</span> z1,<span class="keywordtype">double</span> x2,<span class="keywordtype">double</span> y2,
<a name="l00252"></a>00252               <span class="keywordtype">double</span> z2,<span class="keywordtype">double</span> x3,<span class="keywordtype">double</span> y3,<span class="keywordtype">double</span> z3);
<a name="l00253"></a>00253 
<a name="l00254"></a>00254   <span class="keywordtype">double</span> <a class="code" href="classVariationalMeshSmoother.php#a5e4eb9c8e8296b062328936828373914">jac2</a>(<span class="keywordtype">double</span> x1,<span class="keywordtype">double</span> y1,<span class="keywordtype">double</span> x2,<span class="keywordtype">double</span> y2);
<a name="l00255"></a>00255 
<a name="l00256"></a>00256   <span class="keywordtype">int</span> <a class="code" href="classVariationalMeshSmoother.php#ad750656bb434947d31a42be50493b8a9">basisA</a>(<span class="keywordtype">int</span> n, <a class="code" href="mesh__smoother__vsmoother_8h.php#a51d3d3f63d1d3c78b0f7a395d5dca5c6">LPLPDOUBLE</a> Q, <span class="keywordtype">int</span> nvert, <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a> K, <a class="code" href="mesh__smoother__vsmoother_8h.php#a51d3d3f63d1d3c78b0f7a395d5dca5c6">LPLPDOUBLE</a> H, <span class="keywordtype">int</span> me);
<a name="l00257"></a>00257 
<a name="l00258"></a>00258   <span class="keywordtype">void</span> <a class="code" href="classVariationalMeshSmoother.php#ada0c0c5bdec2df3da356abee33c06b1c">adp_renew</a>(<span class="keywordtype">int</span> n, <span class="keywordtype">int</span> N, <a class="code" href="mesh__smoother__vsmoother_8h.php#a51d3d3f63d1d3c78b0f7a395d5dca5c6">LPLPDOUBLE</a> R, <span class="keywordtype">int</span> ncells, <a class="code" href="mesh__smoother__vsmoother_8h.php#afd3dfc3ea89eac683f1db3acfc6695be">LPLPINT</a> cells,
<a name="l00259"></a>00259                  <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a> afun, <span class="keywordtype">int</span> adp, FILE *sout);
<a name="l00260"></a>00260 
<a name="l00261"></a>00261   <span class="keywordtype">void</span> <a class="code" href="classVariationalMeshSmoother.php#a687f1dc3b5baecd15e2bf9b57be9b3e4">full_smooth</a>(<span class="keywordtype">int</span> n, <span class="keywordtype">int</span> N, <a class="code" href="mesh__smoother__vsmoother_8h.php#a51d3d3f63d1d3c78b0f7a395d5dca5c6">LPLPDOUBLE</a> R, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> mask, <span class="keywordtype">int</span> ncells, <a class="code" href="mesh__smoother__vsmoother_8h.php#afd3dfc3ea89eac683f1db3acfc6695be">LPLPINT</a> cells, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> mcells, 
<a name="l00262"></a>00262                    <span class="keywordtype">int</span> nedges, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> edges, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> hnodes, <span class="keywordtype">double</span> w, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> iter, <span class="keywordtype">int</span> me, 
<a name="l00263"></a>00263                    <a class="code" href="mesh__smoother__vsmoother_8h.php#ad0c91302eded5c4d6562e5c20cb2b074">LPLPLPDOUBLE</a> H, <span class="keywordtype">int</span> adp, <span class="keywordtype">char</span> *adap, <span class="keywordtype">int</span> gr, FILE *sout);
<a name="l00264"></a>00264 
<a name="l00265"></a>00265   <span class="keywordtype">double</span> <a class="code" href="classVariationalMeshSmoother.php#a25594fde8801975b54b0541eb19baadc">maxE</a>(<span class="keywordtype">int</span> n, <span class="keywordtype">int</span> N, <a class="code" href="mesh__smoother__vsmoother_8h.php#a51d3d3f63d1d3c78b0f7a395d5dca5c6">LPLPDOUBLE</a> R, <span class="keywordtype">int</span> ncells, <a class="code" href="mesh__smoother__vsmoother_8h.php#afd3dfc3ea89eac683f1db3acfc6695be">LPLPINT</a> cells, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> mcells, 
<a name="l00266"></a>00266               <span class="keywordtype">int</span> me, <a class="code" href="mesh__smoother__vsmoother_8h.php#ad0c91302eded5c4d6562e5c20cb2b074">LPLPLPDOUBLE</a> H, <span class="keywordtype">double</span> v, <span class="keywordtype">double</span> epsilon, <span class="keywordtype">double</span> w, <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a> Gamma, 
<a name="l00267"></a>00267               <span class="keywordtype">double</span> *qmin, FILE *sout);
<a name="l00268"></a>00268 
<a name="l00269"></a>00269   <span class="keywordtype">double</span> <a class="code" href="classVariationalMeshSmoother.php#ae6486023bf369fe0bf34777c4c14f835">minq</a>(<span class="keywordtype">int</span> n, <span class="keywordtype">int</span> N, <a class="code" href="mesh__smoother__vsmoother_8h.php#a51d3d3f63d1d3c78b0f7a395d5dca5c6">LPLPDOUBLE</a> R, <span class="keywordtype">int</span> ncells, <a class="code" href="mesh__smoother__vsmoother_8h.php#afd3dfc3ea89eac683f1db3acfc6695be">LPLPINT</a> cells, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> mcells, 
<a name="l00270"></a>00270               <span class="keywordtype">int</span> me, <a class="code" href="mesh__smoother__vsmoother_8h.php#ad0c91302eded5c4d6562e5c20cb2b074">LPLPLPDOUBLE</a> H, <span class="keywordtype">double</span> *vol, <span class="keywordtype">double</span> *Vmin, FILE *sout);
<a name="l00271"></a>00271 
<a name="l00272"></a>00272   <span class="keywordtype">double</span> <a class="code" href="classVariationalMeshSmoother.php#a2895d86be312035020a7a921a20029cf">minJ</a>(<span class="keywordtype">int</span> n, <span class="keywordtype">int</span> N, <a class="code" href="mesh__smoother__vsmoother_8h.php#a51d3d3f63d1d3c78b0f7a395d5dca5c6">LPLPDOUBLE</a> R, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> mask, <span class="keywordtype">int</span> ncells, <a class="code" href="mesh__smoother__vsmoother_8h.php#afd3dfc3ea89eac683f1db3acfc6695be">LPLPINT</a> cells, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> mcells,
<a name="l00273"></a>00273               <span class="keywordtype">double</span> epsilon, <span class="keywordtype">double</span> w, <span class="keywordtype">int</span> me, <a class="code" href="mesh__smoother__vsmoother_8h.php#ad0c91302eded5c4d6562e5c20cb2b074">LPLPLPDOUBLE</a> H, <span class="keywordtype">double</span> vol, <span class="keywordtype">int</span> nedges, 
<a name="l00274"></a>00274               <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> edges, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> hnodes, <span class="keywordtype">int</span> msglev, <span class="keywordtype">double</span> *Vmin, <span class="keywordtype">double</span> *emax, <span class="keywordtype">double</span> *qmin, 
<a name="l00275"></a>00275               <span class="keywordtype">int</span> adp, <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a> afun, FILE *sout);
<a name="l00276"></a>00276 
<a name="l00277"></a>00277   <span class="keywordtype">double</span> <a class="code" href="classVariationalMeshSmoother.php#ad9b2d6398d4c6095af0398095864dd05">minJ_BC</a>(<span class="keywordtype">int</span> N, <a class="code" href="mesh__smoother__vsmoother_8h.php#a51d3d3f63d1d3c78b0f7a395d5dca5c6">LPLPDOUBLE</a> R, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> mask, <span class="keywordtype">int</span> ncells, <a class="code" href="mesh__smoother__vsmoother_8h.php#afd3dfc3ea89eac683f1db3acfc6695be">LPLPINT</a> cells, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> mcells,
<a name="l00278"></a>00278                 <span class="keywordtype">double</span> epsilon, <span class="keywordtype">double</span> w, <span class="keywordtype">int</span> me, <a class="code" href="mesh__smoother__vsmoother_8h.php#ad0c91302eded5c4d6562e5c20cb2b074">LPLPLPDOUBLE</a> H, <span class="keywordtype">double</span> vol, <span class="keywordtype">int</span> msglev, 
<a name="l00279"></a>00279                 <span class="keywordtype">double</span> *Vmin, <span class="keywordtype">double</span> *emax, <span class="keywordtype">double</span> *qmin, <span class="keywordtype">int</span> adp, <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a> afun, <span class="keywordtype">int</span> NCN, FILE *sout);
<a name="l00280"></a>00280 
<a name="l00281"></a>00281   <span class="keywordtype">double</span> <a class="code" href="classVariationalMeshSmoother.php#a106b341ce812444fb2f2c153a79b697c">localP</a>(<span class="keywordtype">int</span> n, <a class="code" href="mesh__smoother__vsmoother_8h.php#ad0c91302eded5c4d6562e5c20cb2b074">LPLPLPDOUBLE</a> W, <a class="code" href="mesh__smoother__vsmoother_8h.php#a51d3d3f63d1d3c78b0f7a395d5dca5c6">LPLPDOUBLE</a> F, <a class="code" href="mesh__smoother__vsmoother_8h.php#a51d3d3f63d1d3c78b0f7a395d5dca5c6">LPLPDOUBLE</a> R, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> <a class="code" href="classVariationalMeshSmoother.php#acb4553cd5806fbed05a7d1cda8b20676aaf77d2a7ad871a6e573213127d04453a">cell</a>, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> mask, <span class="keywordtype">double</span> epsilon, 
<a name="l00282"></a>00282                 <span class="keywordtype">double</span> w, <span class="keywordtype">int</span> nvert, <a class="code" href="mesh__smoother__vsmoother_8h.php#a51d3d3f63d1d3c78b0f7a395d5dca5c6">LPLPDOUBLE</a> H, <span class="keywordtype">int</span> me, <span class="keywordtype">double</span> vol, <span class="keywordtype">int</span> f, <span class="keywordtype">double</span> *Vmin, 
<a name="l00283"></a>00283                 <span class="keywordtype">double</span> *qmin, <span class="keywordtype">int</span> adp, <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a> afun, <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a> Gloc, FILE *sout);
<a name="l00284"></a>00284 
<a name="l00285"></a>00285   <span class="keywordtype">double</span> <a class="code" href="classVariationalMeshSmoother.php#a6f34400b79de24181db75c7dff8c2fa4">avertex</a>(<span class="keywordtype">int</span> n, <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a> afun, <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a> G, <a class="code" href="mesh__smoother__vsmoother_8h.php#a51d3d3f63d1d3c78b0f7a395d5dca5c6">LPLPDOUBLE</a> R, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> <a class="code" href="classVariationalMeshSmoother.php#acb4553cd5806fbed05a7d1cda8b20676aaf77d2a7ad871a6e573213127d04453a">cell</a>, <span class="keywordtype">int</span> nvert, <span class="keywordtype">int</span> adp, FILE *sout);
<a name="l00286"></a>00286 
<a name="l00287"></a>00287   <span class="keywordtype">double</span> <a class="code" href="classVariationalMeshSmoother.php#a4fd483a93f25e767f351e223346554e3">vertex</a>(<span class="keywordtype">int</span> n, <a class="code" href="mesh__smoother__vsmoother_8h.php#ad0c91302eded5c4d6562e5c20cb2b074">LPLPLPDOUBLE</a> W, <a class="code" href="mesh__smoother__vsmoother_8h.php#a51d3d3f63d1d3c78b0f7a395d5dca5c6">LPLPDOUBLE</a> F, <a class="code" href="mesh__smoother__vsmoother_8h.php#a51d3d3f63d1d3c78b0f7a395d5dca5c6">LPLPDOUBLE</a> R, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> <a class="code" href="classVariationalMeshSmoother.php#acb4553cd5806fbed05a7d1cda8b20676aaf77d2a7ad871a6e573213127d04453a">cell</a>, 
<a name="l00288"></a>00288                 <span class="keywordtype">double</span> epsilon, <span class="keywordtype">double</span> w, <span class="keywordtype">int</span> nvert, <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a> K, 
<a name="l00289"></a>00289                 <a class="code" href="mesh__smoother__vsmoother_8h.php#a51d3d3f63d1d3c78b0f7a395d5dca5c6">LPLPDOUBLE</a> H, <span class="keywordtype">int</span> me, <span class="keywordtype">double</span> vol, <span class="keywordtype">int</span> f, <span class="keywordtype">double</span> *Vmin, <span class="keywordtype">int</span> adp, 
<a name="l00290"></a>00290                 <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a> G, <span class="keywordtype">double</span> sigma, FILE *sout);
<a name="l00291"></a>00291 
<a name="l00292"></a>00292   <span class="keywordtype">void</span> <a class="code" href="classVariationalMeshSmoother.php#aef3712e9ac024eb68e62d24842cbad6e">metr_data_gen</a>(<span class="keywordtype">char</span> grid[], <span class="keywordtype">char</span> metr[], <span class="keywordtype">int</span> n, <span class="keywordtype">int</span> me, FILE *sout);
<a name="l00293"></a>00293 
<a name="l00294"></a>00294   <span class="keywordtype">int</span> <a class="code" href="classVariationalMeshSmoother.php#add048ff70be8132f8fcbf807c1d340a1">solver</a>(<span class="keywordtype">int</span> n, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> ia, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> ja, <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a> a, <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a> x, <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a> b, <span class="keywordtype">double</span> eps,
<a name="l00295"></a>00295              <span class="keywordtype">int</span> maxite, <span class="keywordtype">int</span> msglev, FILE *sout);
<a name="l00296"></a>00296 
<a name="l00297"></a>00297   <span class="keywordtype">int</span> <a class="code" href="classVariationalMeshSmoother.php#aeee449dc021b64164ead2f8c490b966b">pcg_ic0</a>(<span class="keywordtype">int</span> n, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> ia, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> ja, <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a> a, <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a> u, <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a> x, <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a> b, <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a> r, 
<a name="l00298"></a>00298               <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a> p, <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a> z, <span class="keywordtype">double</span> eps, <span class="keywordtype">int</span> maxite, <span class="keywordtype">int</span> msglev, FILE *sout);
<a name="l00299"></a>00299 
<a name="l00300"></a>00300   <span class="keywordtype">int</span> <a class="code" href="classVariationalMeshSmoother.php#af0d5c24de5d24b3368575c063723374f">pcg_par_check</a>(<span class="keywordtype">int</span> n, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> ia, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> ja, <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a> a, <span class="keywordtype">double</span> eps, <span class="keywordtype">int</span> maxite, <span class="keywordtype">int</span> msglev, FILE *sout);
<a name="l00301"></a>00301 
<a name="l00302"></a>00302   <span class="keywordtype">void</span> <a class="code" href="classVariationalMeshSmoother.php#a8283787c35e1398daa1aea1401802746">gener</a>(<span class="keywordtype">char</span> grid[], <span class="keywordtype">int</span> n, FILE *sout);
<a name="l00303"></a>00303   
<a name="l00304"></a>00304   <span class="keywordtype">void</span> <a class="code" href="classVariationalMeshSmoother.php#a214a03b8b5cd34ebe111e2ab39371e41">local_sweep</a>(<span class="keywordtype">int</span> n, <span class="keywordtype">int</span> N, <a class="code" href="mesh__smoother__vsmoother_8h.php#a51d3d3f63d1d3c78b0f7a395d5dca5c6">LPLPDOUBLE</a> R, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> mask, <span class="keywordtype">int</span> ncells, <a class="code" href="mesh__smoother__vsmoother_8h.php#afd3dfc3ea89eac683f1db3acfc6695be">LPLPINT</a> cells, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> mcells, 
<a name="l00305"></a>00305                   <span class="keywordtype">int</span> nedges, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> edges, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> hnodes, <span class="keywordtype">double</span> w, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> iter, <span class="keywordtype">int</span> me, 
<a name="l00306"></a>00306                       <a class="code" href="mesh__smoother__vsmoother_8h.php#ad0c91302eded5c4d6562e5c20cb2b074">LPLPLPDOUBLE</a> H, <span class="keywordtype">int</span> adp, <span class="keywordtype">int</span> OPT, FILE *sout);
<a name="l00307"></a>00307   
<a name="l00308"></a>00308   <span class="keywordtype">double</span> <a class="code" href="classVariationalMeshSmoother.php#af7eede7306c8734d45f820dcdcd6404e">minJ_l</a>(<span class="keywordtype">int</span> n, <span class="keywordtype">int</span> N, <a class="code" href="mesh__smoother__vsmoother_8h.php#a51d3d3f63d1d3c78b0f7a395d5dca5c6">LPLPDOUBLE</a> R, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> mask, <span class="keywordtype">int</span> ncells, <a class="code" href="mesh__smoother__vsmoother_8h.php#afd3dfc3ea89eac683f1db3acfc6695be">LPLPINT</a> cells, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> mcells,
<a name="l00309"></a>00309               <span class="keywordtype">double</span> epsilon, <span class="keywordtype">double</span> w, <span class="keywordtype">int</span> me, <a class="code" href="mesh__smoother__vsmoother_8h.php#ad0c91302eded5c4d6562e5c20cb2b074">LPLPLPDOUBLE</a> H, <span class="keywordtype">double</span> vol, <span class="keywordtype">int</span> nedges, 
<a name="l00310"></a>00310               <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> edges, <a class="code" href="mesh__smoother__vsmoother_8h.php#a98a4cce06ba63315f3bac9ab056eb0a9">LPINT</a> hnodes, <span class="keywordtype">int</span> msglev, <span class="keywordtype">double</span> *Vmin, <span class="keywordtype">double</span> *emax, <span class="keywordtype">double</span> *qmin, 
<a name="l00311"></a>00311               <span class="keywordtype">int</span> adp, <a class="code" href="mesh__smoother__vsmoother_8h.php#a37a78163d34eb9eb180935ab275feb04">LPDOUBLE</a> afun, FILE *sout);
<a name="l00312"></a>00312 };
<a name="l00313"></a>00313 
<a name="l00314"></a>00314 <span class="preprocessor">#endif // LIBMESH_ENABLE_VSMOOTHER</span>
<a name="l00315"></a>00315 <span class="preprocessor"></span>
<a name="l00316"></a>00316 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
