<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_tetgen_support.C</h1>  </div>
</div>
<div class="contents">
<a href="mesh__tetgen__support_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_tetgen_support.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002  
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010 
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015 
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00021"></a>00021 <span class="preprocessor">#ifdef LIBMESH_HAVE_TETGEN</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// C++ includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;sstream&gt;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;cell_tet4.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;face_tri3.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;unstructured_mesh.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;mesh_tetgen_support.h&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">//----------------------------------------------------------------------</span>
<a name="l00036"></a>00036 <span class="comment">// TetGenMeshInterface functions</span>
<a name="l00037"></a><a class="code" href="classTetGenWrapper.php#a4b3f94500ce85d5df223d3e6985e6e1a">00037</a> <a class="code" href="classTetGenWrapper.php#a4b3f94500ce85d5df223d3e6985e6e1a">TetGenWrapper::TetGenWrapper</a>()
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039   <a class="code" href="classTetGenWrapper.php#a90005b9ea112519f380edd23d73fa682">tetgen_output</a> = <span class="keyword">new</span> tetgenio;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041   this-&gt;<a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.mesh_dim                = 3;
<a name="l00042"></a>00042   this-&gt;<a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.numberofpointattributes = 0;
<a name="l00043"></a>00043   this-&gt;<a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.firstnumber             = 0;
<a name="l00044"></a>00044 }
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00048"></a><a class="code" href="classTetGenWrapper.php#adec2626ab48159450185395002516d82">00048</a> <a class="code" href="classTetGenWrapper.php#adec2626ab48159450185395002516d82">TetGenWrapper::~TetGenWrapper</a>()
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050   <span class="keyword">delete</span> <a class="code" href="classTetGenWrapper.php#a90005b9ea112519f380edd23d73fa682">tetgen_output</a>;
<a name="l00051"></a>00051 }
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="classTetGenWrapper.php#a02fdaa4cfb77bd0c35213687a16ee966">00055</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a02fdaa4cfb77bd0c35213687a16ee966">TetGenWrapper::set_node</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a> x, <span class="keyword">const</span> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a> y, <span class="keyword">const</span> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a> z)
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057   <span class="keywordtype">int</span> index = i*3;
<a name="l00058"></a>00058   <a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.pointlist[index++] = x;
<a name="l00059"></a>00059   <a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.pointlist[index++] = y;
<a name="l00060"></a>00060   <a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.pointlist[index++] = z;
<a name="l00061"></a>00061 }
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a><a class="code" href="classTetGenWrapper.php#a2e0545781e16d96ccfabe8182f04d624">00065</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a2e0545781e16d96ccfabe8182f04d624">TetGenWrapper::set_hole</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a> x, <span class="keyword">const</span> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a> y, <span class="keyword">const</span> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a> z)
<a name="l00066"></a>00066 {
<a name="l00067"></a>00067   <span class="keywordtype">int</span> index = i*3;
<a name="l00068"></a>00068   <a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.holelist[index++] = x;
<a name="l00069"></a>00069   <a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.holelist[index++] = y;
<a name="l00070"></a>00070   <a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.holelist[index++] = z;
<a name="l00071"></a>00071 }
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 
<a name="l00075"></a><a class="code" href="classTetGenWrapper.php#a5becf7bd070afeed09f5abd21c483abe">00075</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a5becf7bd070afeed09f5abd21c483abe">TetGenWrapper::set_numberofpoints</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i)
<a name="l00076"></a>00076 {
<a name="l00077"></a>00077   <a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.numberofpoints = i;
<a name="l00078"></a>00078 }
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a><a class="code" href="classTetGenWrapper.php#aaf7f1bff58bc2873f188dd308c5cd5bc">00082</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#aaf7f1bff58bc2873f188dd308c5cd5bc">TetGenWrapper::get_output_node</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a>&amp; x, <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a>&amp; y, <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a>&amp; z)
<a name="l00083"></a>00083 {
<a name="l00084"></a>00084   x = <a class="code" href="classTetGenWrapper.php#a90005b9ea112519f380edd23d73fa682">tetgen_output</a>-&gt;pointlist[3*i];
<a name="l00085"></a>00085   y = <a class="code" href="classTetGenWrapper.php#a90005b9ea112519f380edd23d73fa682">tetgen_output</a>-&gt;pointlist[3*i+1];
<a name="l00086"></a>00086   z = <a class="code" href="classTetGenWrapper.php#a90005b9ea112519f380edd23d73fa682">tetgen_output</a>-&gt;pointlist[3*i+2];
<a name="l00087"></a>00087 }
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 
<a name="l00091"></a><a class="code" href="classTetGenWrapper.php#a4a4a35c65439175ac29d650bff564e64">00091</a> <span class="keywordtype">int</span> <a class="code" href="classTetGenWrapper.php#a4a4a35c65439175ac29d650bff564e64">TetGenWrapper::get_numberoftetrahedra</a>()
<a name="l00092"></a>00092 {
<a name="l00093"></a>00093   <span class="keywordflow">return</span> <a class="code" href="classTetGenWrapper.php#a90005b9ea112519f380edd23d73fa682">tetgen_output</a>-&gt;numberoftetrahedra;
<a name="l00094"></a>00094 }
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a><a class="code" href="classTetGenWrapper.php#a0c9fe93997a9402ac88db9f5eecd1c2d">00098</a> <span class="keywordtype">int</span> <a class="code" href="classTetGenWrapper.php#a0c9fe93997a9402ac88db9f5eecd1c2d">TetGenWrapper::get_numberoftrifaces</a>()
<a name="l00099"></a>00099 {
<a name="l00100"></a>00100   <span class="keywordflow">return</span> <a class="code" href="classTetGenWrapper.php#a90005b9ea112519f380edd23d73fa682">tetgen_output</a>-&gt;numberoftrifaces;
<a name="l00101"></a>00101 }
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00105"></a><a class="code" href="classTetGenWrapper.php#a082ce057359b37ec61f9331722a6871f">00105</a> <span class="keywordtype">int</span> <a class="code" href="classTetGenWrapper.php#a082ce057359b37ec61f9331722a6871f">TetGenWrapper::get_numberofpoints</a>()
<a name="l00106"></a>00106 {
<a name="l00107"></a>00107   <span class="keywordflow">return</span> <a class="code" href="classTetGenWrapper.php#a90005b9ea112519f380edd23d73fa682">tetgen_output</a>-&gt;numberofpoints;
<a name="l00108"></a>00108 }
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 
<a name="l00112"></a><a class="code" href="classTetGenWrapper.php#a03c69a555eab2abb205f141e5138294f">00112</a> <span class="keywordtype">int</span> <a class="code" href="classTetGenWrapper.php#a03c69a555eab2abb205f141e5138294f">TetGenWrapper::get_element_node</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> j)
<a name="l00113"></a>00113 {
<a name="l00114"></a>00114   <span class="keywordflow">return</span> <a class="code" href="classTetGenWrapper.php#a90005b9ea112519f380edd23d73fa682">tetgen_output</a>-&gt;tetrahedronlist[i*4+j];
<a name="l00115"></a>00115 }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a><a class="code" href="classTetGenWrapper.php#a7e1fed37c404491a77524dcf7f315223">00119</a> <span class="keywordtype">int</span> <a class="code" href="classTetGenWrapper.php#a7e1fed37c404491a77524dcf7f315223">TetGenWrapper::get_triface_node</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> j)
<a name="l00120"></a>00120 {
<a name="l00121"></a>00121   <span class="keywordflow">return</span> <a class="code" href="classTetGenWrapper.php#a90005b9ea112519f380edd23d73fa682">tetgen_output</a>-&gt;trifacelist[i*3+j];
<a name="l00122"></a>00122 }
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a><a class="code" href="classTetGenWrapper.php#a54f87eb822ba7b34fd5a6bee5180c941">00126</a> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a> <a class="code" href="classTetGenWrapper.php#a54f87eb822ba7b34fd5a6bee5180c941">TetGenWrapper::get_element_attribute</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i)
<a name="l00127"></a>00127 {
<a name="l00128"></a>00128   libmesh_assert(<a class="code" href="classTetGenWrapper.php#a90005b9ea112519f380edd23d73fa682">tetgen_output</a>-&gt;numberoftetrahedronattributes&gt;0);
<a name="l00129"></a>00129   <span class="keywordflow">return</span> <a class="code" href="classTetGenWrapper.php#a90005b9ea112519f380edd23d73fa682">tetgen_output</a>-&gt;tetrahedronattributelist[<a class="code" href="classTetGenWrapper.php#a90005b9ea112519f380edd23d73fa682">tetgen_output</a>-&gt;numberoftetrahedronattributes*i];
<a name="l00130"></a>00130 }
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a><a class="code" href="classTetGenWrapper.php#a464e83468a1ccafcde42232c0e44b6fc">00134</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a464e83468a1ccafcde42232c0e44b6fc">TetGenWrapper::set_pointlist</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> numofpoints)
<a name="l00135"></a>00135 {
<a name="l00136"></a>00136   this-&gt;<a class="code" href="classTetGenWrapper.php#a5becf7bd070afeed09f5abd21c483abe">set_numberofpoints</a>(numofpoints);
<a name="l00137"></a>00137   this-&gt;<a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.pointlist = <span class="keyword">new</span> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a>[<a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.numberofpoints * 3];
<a name="l00138"></a>00138 }
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00142"></a><a class="code" href="classTetGenWrapper.php#accee0a8d7fd6972101fcd524f3c48bfe">00142</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#accee0a8d7fd6972101fcd524f3c48bfe">TetGenWrapper::set_switches</a>(<span class="keyword">const</span> std::string&amp; s)
<a name="l00143"></a>00143 {
<a name="l00144"></a>00144   <span class="comment">// Copy the string to a temporary buffer for passing to the C API</span>
<a name="l00145"></a>00145   <span class="keywordtype">char</span> buffer[256];
<a name="l00146"></a>00146   libmesh_assert (s.size() &lt; <span class="keyword">sizeof</span>(buffer)-1);
<a name="l00147"></a>00147   buffer[ s.copy( buffer , <span class="keyword">sizeof</span>( buffer ) - 1 ) ] = <span class="charliteral">&#39;\0&#39;</span> ;
<a name="l00148"></a>00148   
<a name="l00149"></a>00149   <span class="keywordflow">if</span> (!<a class="code" href="classTetGenWrapper.php#a774298ef64ec5b014a89b8840b508450">tetgen_be</a>.parse_commandline(buffer)) 
<a name="l00150"></a>00150     std::cout &lt;&lt; <span class="stringliteral">&quot;TetGen replies: Wrong switches!&quot;</span> &lt;&lt; std::endl;
<a name="l00151"></a>00151 }
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a><a class="code" href="classTetGenWrapper.php#aec79130c06161fff8170b4041b9d66c0">00155</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#aec79130c06161fff8170b4041b9d66c0">TetGenWrapper::run_tetgen</a>()
<a name="l00156"></a>00156 {
<a name="l00157"></a>00157   <span class="comment">// Call tetrahedralize from the TetGen library.</span>
<a name="l00158"></a>00158   tetrahedralize(&amp;<a class="code" href="classTetGenWrapper.php#a774298ef64ec5b014a89b8840b508450">tetgen_be</a>, &amp;<a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>, <a class="code" href="classTetGenWrapper.php#a90005b9ea112519f380edd23d73fa682">tetgen_output</a>);
<a name="l00159"></a>00159 }
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 
<a name="l00163"></a><a class="code" href="classTetGenWrapper.php#a820b942bda20be02eb8a481d7b3069ab">00163</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a820b942bda20be02eb8a481d7b3069ab">TetGenWrapper::set_numberoffacets</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i)
<a name="l00164"></a>00164 { 
<a name="l00165"></a>00165   this-&gt;<a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.numberoffacets = i;
<a name="l00166"></a>00166 }
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00170"></a><a class="code" href="classTetGenWrapper.php#a7a55ca5a95be8c510588228a047b95c6">00170</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a7a55ca5a95be8c510588228a047b95c6">TetGenWrapper::set_numberofholes</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i)
<a name="l00171"></a>00171 { 
<a name="l00172"></a>00172   this-&gt;<a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.numberofholes = i;
<a name="l00173"></a>00173 }
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00177"></a><a class="code" href="classTetGenWrapper.php#a05434f887fde5814f21132adbd764c9e">00177</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a05434f887fde5814f21132adbd764c9e">TetGenWrapper::set_numberofregions</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i)
<a name="l00178"></a>00178 {
<a name="l00179"></a>00179   this-&gt;<a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.numberofregions = i;
<a name="l00180"></a>00180 }
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 
<a name="l00184"></a><a class="code" href="classTetGenWrapper.php#a2a5fdc7689d694dcea389daf5252d090">00184</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a2a5fdc7689d694dcea389daf5252d090">TetGenWrapper::set_facetlist</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> numoffacets, <span class="keyword">const</span> <span class="keywordtype">int</span> numofholes)
<a name="l00185"></a>00185 {
<a name="l00186"></a>00186   <a class="code" href="classTetGenWrapper.php#a820b942bda20be02eb8a481d7b3069ab">set_numberoffacets</a>(numoffacets);
<a name="l00187"></a>00187   <a class="code" href="classTetGenWrapper.php#a7a55ca5a95be8c510588228a047b95c6">set_numberofholes</a>(numofholes);
<a name="l00188"></a>00188   this-&gt;<a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.facetlist = <span class="keyword">new</span> tetgenio::facet[this-&gt;<a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.numberoffacets];
<a name="l00189"></a>00189   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;numoffacets; i++)
<a name="l00190"></a>00190     this-&gt;<a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.init(&amp;(this-&gt;tetgen_data.facetlist[i]));
<a name="l00191"></a>00191   this-&gt;<a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.holelist = <span class="keyword">new</span> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a>[this-&gt;<a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.numberofholes * 3];
<a name="l00192"></a>00192 }
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 
<a name="l00196"></a><a class="code" href="classTetGenWrapper.php#a0879b9edf704af76092202f1302c442d">00196</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a0879b9edf704af76092202f1302c442d">TetGenWrapper::set_regionlist</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> numofregions)
<a name="l00197"></a>00197 {
<a name="l00198"></a>00198   <a class="code" href="classTetGenWrapper.php#a05434f887fde5814f21132adbd764c9e">set_numberofregions</a>(numofregions);
<a name="l00199"></a>00199   this-&gt;<a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.regionlist = <span class="keyword">new</span> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a>[this-&gt;<a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.numberofregions * 5];
<a name="l00200"></a>00200 }
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a><a class="code" href="classTetGenWrapper.php#a32b9c10c0f9bf3562326959518c3a880">00204</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a32b9c10c0f9bf3562326959518c3a880">TetGenWrapper::set_facet_numberofpolygons</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> num)
<a name="l00205"></a>00205 {
<a name="l00206"></a>00206   this-&gt;<a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.facetlist[i].numberofpolygons = num;
<a name="l00207"></a>00207 }
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 
<a name="l00211"></a><a class="code" href="classTetGenWrapper.php#aff0706bec70fa7eb558f0769b8410cae">00211</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#aff0706bec70fa7eb558f0769b8410cae">TetGenWrapper::set_facet_numberofholes</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> num)
<a name="l00212"></a>00212 {
<a name="l00213"></a>00213   this-&gt;<a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.facetlist[i].numberofholes = num;
<a name="l00214"></a>00214 }
<a name="l00215"></a>00215 
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 
<a name="l00219"></a><a class="code" href="classTetGenWrapper.php#ab93ff8de300d23807b9b746776aeae3b">00219</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#ab93ff8de300d23807b9b746776aeae3b">TetGenWrapper::set_facet_polygonlist</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> numofpolygons)
<a name="l00220"></a>00220 {
<a name="l00221"></a>00221   <a class="code" href="classTetGenWrapper.php#a32b9c10c0f9bf3562326959518c3a880">set_facet_numberofpolygons</a>(i, numofpolygons);
<a name="l00222"></a>00222   <a class="code" href="classTetGenWrapper.php#aff0706bec70fa7eb558f0769b8410cae">set_facet_numberofholes</a>(i, 0);
<a name="l00223"></a>00223   this-&gt;<a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.facetlist[i].polygonlist = <span class="keyword">new</span> tetgenio::polygon[numofpolygons];
<a name="l00224"></a>00224   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0; j&lt;this-&gt;<a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.facetlist[i].numberofpolygons; j++)
<a name="l00225"></a>00225     this-&gt;<a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.init(&amp;(this-&gt;tetgen_data.facetlist[i].polygonlist[j]));
<a name="l00226"></a>00226 }
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 
<a name="l00230"></a><a class="code" href="classTetGenWrapper.php#a7ea0378b2101e5348aad343bcc37bb77">00230</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a7ea0378b2101e5348aad343bcc37bb77">TetGenWrapper::set_polygon_numberofvertices</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> j, <span class="keyword">const</span> <span class="keywordtype">int</span> num)
<a name="l00231"></a>00231 {
<a name="l00232"></a>00232   this-&gt;<a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.facetlist[i].polygonlist[j].numberofvertices = num;
<a name="l00233"></a>00233 }
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 
<a name="l00237"></a><a class="code" href="classTetGenWrapper.php#a5a1c4f88c0ed7d1542967d95261c7a6a">00237</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a5a1c4f88c0ed7d1542967d95261c7a6a">TetGenWrapper::set_polygon_vertexlist</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> j, <span class="keyword">const</span> <span class="keywordtype">int</span> numofvertices)
<a name="l00238"></a>00238 {
<a name="l00239"></a>00239   <a class="code" href="classTetGenWrapper.php#a7ea0378b2101e5348aad343bcc37bb77">set_polygon_numberofvertices</a>(i, j, numofvertices);
<a name="l00240"></a>00240   this-&gt;<a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.facetlist[i].polygonlist[j].vertexlist = <span class="keyword">new</span> <span class="keywordtype">int</span>[numofvertices];
<a name="l00241"></a>00241 }
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 
<a name="l00246"></a><a class="code" href="classTetGenWrapper.php#a76ebaaa12882426617193ae5ca475a02">00246</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a76ebaaa12882426617193ae5ca475a02">TetGenWrapper::set_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> j, <span class="keyword">const</span> <span class="keywordtype">int</span> k, <span class="keyword">const</span> <span class="keywordtype">int</span> nodeindex)
<a name="l00247"></a>00247 {
<a name="l00248"></a>00248   this-&gt;<a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.facetlist[i].polygonlist[j].vertexlist[k] = nodeindex;
<a name="l00249"></a>00249 }
<a name="l00250"></a>00250 
<a name="l00251"></a>00251 
<a name="l00252"></a>00252 
<a name="l00253"></a><a class="code" href="classTetGenWrapper.php#a4f2a5703008a1e4938b4e1a14dfe8312">00253</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a4f2a5703008a1e4938b4e1a14dfe8312">TetGenWrapper::set_region</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a> x, <span class="keyword">const</span> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a> y, <span class="keyword">const</span> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a> z,
<a name="l00254"></a>00254                                <span class="keyword">const</span> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a> attribute, <span class="keyword">const</span> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a> vol_constraint)
<a name="l00255"></a>00255 {
<a name="l00256"></a>00256   <span class="keywordtype">int</span> index = i*5;
<a name="l00257"></a>00257   <a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.regionlist[index++] = x;
<a name="l00258"></a>00258   <a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.regionlist[index++] = y;
<a name="l00259"></a>00259   <a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.regionlist[index++] = z;
<a name="l00260"></a>00260   <a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.regionlist[index++] = attribute;
<a name="l00261"></a>00261   <a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>.regionlist[index++] = vol_constraint;
<a name="l00262"></a>00262 }
<a name="l00263"></a>00263 
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 <span class="comment">// class type TetGen_access is cast to TetGenWrapper.</span>
<a name="l00266"></a><a class="code" href="mesh__tetgen__support_8C.php#acc0956f9ddb55031764bf526abf79604">00266</a> <span class="keyword">typedef</span> <a class="code" href="classTetGenWrapper.php">TetGenWrapper</a> <a class="code" href="mesh__tetgen__support_8C.php#acc0956f9ddb55031764bf526abf79604">TetGen_access</a>;
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 
<a name="l00269"></a>00269 
<a name="l00270"></a>00270 
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 
<a name="l00273"></a>00273 <span class="comment">//----------------------------------------------------------------------</span>
<a name="l00274"></a>00274 <span class="comment">// TetGenMeshInterface class members</span>
<a name="l00275"></a><a class="code" href="classTetGenMeshInterface.php#adad356a34e76444a477393798f6460c2">00275</a> <a class="code" href="classTetGenMeshInterface.php#adad356a34e76444a477393798f6460c2">TetGenMeshInterface::TetGenMeshInterface</a> (<a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; mesh) :
<a name="l00276"></a>00276   _mesh         (mesh)
<a name="l00277"></a>00277 {
<a name="l00278"></a>00278 }
<a name="l00279"></a>00279 
<a name="l00280"></a>00280 
<a name="l00281"></a>00281 
<a name="l00282"></a><a class="code" href="classTetGenMeshInterface.php#ab8febaa5fd52233db6c130106e94c254">00282</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenMeshInterface.php#ab8febaa5fd52233db6c130106e94c254">TetGenMeshInterface::triangulate_pointset</a> ()   
<a name="l00283"></a>00283 {
<a name="l00284"></a>00284   <span class="comment">// class tetgen_wrapper allows library access on a basic level:</span>
<a name="l00285"></a>00285   <a class="code" href="classTetGenWrapper.php">TetGen_access</a> tetgen_wrapper; 
<a name="l00286"></a>00286 
<a name="l00287"></a>00287   <span class="comment">// fill input structure with point set data:</span>
<a name="l00288"></a>00288   tetgen_wrapper.<a class="code" href="classTetGenWrapper.php#a464e83468a1ccafcde42232c0e44b6fc">set_pointlist</a>( this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>() );
<a name="l00289"></a>00289 
<a name="l00290"></a>00290   {
<a name="l00291"></a>00291     <span class="keywordtype">int</span> index = 0;
<a name="l00292"></a>00292     <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> it  = this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
<a name="l00293"></a>00293     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> end = this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
<a name="l00294"></a>00294     <span class="keywordflow">for</span> ( ; it != end; ++it) 
<a name="l00295"></a>00295       tetgen_wrapper.<a class="code" href="classTetGenWrapper.php#a02fdaa4cfb77bd0c35213687a16ee966">set_node</a>(index++, (**it)(0), (**it)(1), (**it)(2));
<a name="l00296"></a>00296   }
<a name="l00297"></a>00297   
<a name="l00298"></a>00298   <span class="comment">// run TetGen triangulation method:</span>
<a name="l00299"></a>00299   tetgen_wrapper.<a class="code" href="classTetGenWrapper.php#accee0a8d7fd6972101fcd524f3c48bfe">set_switches</a>(<span class="stringliteral">&quot;Q&quot;</span>); <span class="comment">// TetGen switches: triangulation, Quiet mode</span>
<a name="l00300"></a>00300   tetgen_wrapper.<a class="code" href="classTetGenWrapper.php#aec79130c06161fff8170b4041b9d66c0">run_tetgen</a>();
<a name="l00301"></a>00301 
<a name="l00302"></a>00302   <span class="comment">// save elements to mesh structure, nodes will not be changed:</span>
<a name="l00303"></a>00303   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num_elements   = tetgen_wrapper.<a class="code" href="classTetGenWrapper.php#a4a4a35c65439175ac29d650bff564e64">get_numberoftetrahedra</a>();
<a name="l00304"></a>00304 
<a name="l00305"></a>00305   <span class="comment">// Vector that temporarily holds the node labels defining element.</span>
<a name="l00306"></a>00306   <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> node_labels[4];      
<a name="l00307"></a>00307 
<a name="l00308"></a>00308   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;num_elements; ++i)
<a name="l00309"></a>00309     {
<a name="l00310"></a>00310       <a class="code" href="classElem.php">Elem</a>* elem = <span class="keyword">new</span> <a class="code" href="classTet4.php">Tet4</a>;
<a name="l00311"></a>00311 
<a name="l00312"></a>00312       <span class="comment">// Get the nodes associated with this element</span>
<a name="l00313"></a>00313       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); ++j)
<a name="l00314"></a>00314         node_labels[j] = tetgen_wrapper.<a class="code" href="classTetGenWrapper.php#a03c69a555eab2abb205f141e5138294f">get_element_node</a>(i,j);
<a name="l00315"></a>00315 
<a name="l00316"></a>00316       <span class="comment">// Associate the nodes with this element</span>
<a name="l00317"></a>00317       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); ++j)
<a name="l00318"></a>00318         elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(j) = this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>( node_labels[j] );
<a name="l00319"></a>00319 
<a name="l00320"></a>00320       <span class="comment">// Finally, add this element to the mesh.</span>
<a name="l00321"></a>00321       this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#a0f6974cf3e413cfe9caa1fcb4ce8153e">add_elem</a>(elem);
<a name="l00322"></a>00322     }
<a name="l00323"></a>00323 } 
<a name="l00324"></a>00324 
<a name="l00325"></a>00325 
<a name="l00326"></a>00326 
<a name="l00327"></a><a class="code" href="classTetGenMeshInterface.php#a39c38b6c11a824222b76de8dbf4c76fd">00327</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenMeshInterface.php#a39c38b6c11a824222b76de8dbf4c76fd">TetGenMeshInterface::pointset_convexhull</a> ()   
<a name="l00328"></a>00328 {
<a name="l00329"></a>00329   <span class="comment">// class tetgen_wrapper allows library access on a basic level:</span>
<a name="l00330"></a>00330   <a class="code" href="classTetGenWrapper.php">TetGen_access</a> tetgen_wrapper; 
<a name="l00331"></a>00331 
<a name="l00332"></a>00332   <span class="comment">// fill input structure with point set data:</span>
<a name="l00333"></a>00333   tetgen_wrapper.<a class="code" href="classTetGenWrapper.php#a464e83468a1ccafcde42232c0e44b6fc">set_pointlist</a>(this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l00334"></a>00334   <span class="keywordtype">int</span> index = 0;
<a name="l00335"></a>00335 
<a name="l00336"></a>00336   <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> it        = this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
<a name="l00337"></a>00337   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> end = this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
<a name="l00338"></a>00338   <span class="keywordflow">for</span> ( ; it != end; ++it) 
<a name="l00339"></a>00339     tetgen_wrapper.<a class="code" href="classTetGenWrapper.php#a02fdaa4cfb77bd0c35213687a16ee966">set_node</a>(index++, (**it)(0), (**it)(1), (**it)(2));
<a name="l00340"></a>00340 
<a name="l00341"></a>00341   
<a name="l00342"></a>00342   <span class="comment">// run TetGen triangulation method:</span>
<a name="l00343"></a>00343   tetgen_wrapper.<a class="code" href="classTetGenWrapper.php#accee0a8d7fd6972101fcd524f3c48bfe">set_switches</a>(<span class="stringliteral">&quot;Q&quot;</span>); <span class="comment">// TetGen switches: triangulation, Convex hull, Quiet mode</span>
<a name="l00344"></a>00344   tetgen_wrapper.<a class="code" href="classTetGenWrapper.php#aec79130c06161fff8170b4041b9d66c0">run_tetgen</a>();
<a name="l00345"></a>00345   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num_elements   = tetgen_wrapper.<a class="code" href="classTetGenWrapper.php#a0c9fe93997a9402ac88db9f5eecd1c2d">get_numberoftrifaces</a>();
<a name="l00346"></a>00346 
<a name="l00347"></a>00347   <span class="comment">// Delete *all* old elements</span>
<a name="l00348"></a>00348   {
<a name="l00349"></a>00349     <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       it  = this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00350"></a>00350     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00351"></a>00351     <span class="keywordflow">for</span> ( ; it != end; ++it) 
<a name="l00352"></a>00352       this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#abafee5e4c20eb6866d66e78c35589857">delete_elem</a> (*it);
<a name="l00353"></a>00353   }
<a name="l00354"></a>00354   
<a name="l00355"></a>00355 
<a name="l00356"></a>00356   <span class="comment">// Add the 2D elements which comprise the convex hull back to the mesh.</span>
<a name="l00357"></a>00357   <span class="comment">// Vector that temporarily holds the node labels defining element.</span>
<a name="l00358"></a>00358   <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> node_labels[3];
<a name="l00359"></a>00359   
<a name="l00360"></a>00360   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;num_elements; ++i)
<a name="l00361"></a>00361     {
<a name="l00362"></a>00362       <a class="code" href="classElem.php">Elem</a>* elem = <span class="keyword">new</span> <a class="code" href="classTri3.php">Tri3</a>;
<a name="l00363"></a>00363 
<a name="l00364"></a>00364       <span class="comment">// Get node labels associated with this element</span>
<a name="l00365"></a>00365       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); ++j)
<a name="l00366"></a>00366         node_labels[j] = tetgen_wrapper.<a class="code" href="classTetGenWrapper.php#a7e1fed37c404491a77524dcf7f315223">get_triface_node</a>(i,j);
<a name="l00367"></a>00367 
<a name="l00368"></a>00368       <span class="comment">// Associate nodes with this element</span>
<a name="l00369"></a>00369       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); j++)
<a name="l00370"></a>00370         elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(j) = this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>( node_labels[j] );
<a name="l00371"></a>00371 
<a name="l00372"></a>00372       <span class="comment">// Finally, add this element to the mesh.</span>
<a name="l00373"></a>00373       this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#a0f6974cf3e413cfe9caa1fcb4ce8153e">add_elem</a>(elem);
<a name="l00374"></a>00374     }
<a name="l00375"></a>00375 } 
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 
<a name="l00379"></a><a class="code" href="classTetGenMeshInterface.php#a65eb0e78354164b4da9f76767abcadfa">00379</a> <span class="keywordtype">int</span> <a class="code" href="classTetGenMeshInterface.php#a65eb0e78354164b4da9f76767abcadfa">TetGenMeshInterface::get_node_index</a> (<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* inode)
<a name="l00380"></a>00380 {
<a name="l00381"></a>00381   <span class="comment">// This is NO elegant solution! (A linear search of the nodes.)</span>
<a name="l00382"></a>00382   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_id;
<a name="l00383"></a>00383   node_id = inode-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l00384"></a>00384 
<a name="l00385"></a>00385   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>(); ++i)
<a name="l00386"></a>00386     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#a298477f2d67d6a85f6c7fb5a640e2b64">node</a>(i).<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() == node_id)
<a name="l00387"></a>00387       <span class="keywordflow">return</span> i;
<a name="l00388"></a>00388 
<a name="l00389"></a>00389   std::cerr &lt;&lt; <span class="stringliteral">&quot;Error! Node not found in the mesh!&quot;</span> &lt;&lt; std::endl;
<a name="l00390"></a>00390   libmesh_error();
<a name="l00391"></a>00391   
<a name="l00392"></a>00392   <span class="keywordflow">return</span> 0;
<a name="l00393"></a>00393 }
<a name="l00394"></a>00394 
<a name="l00395"></a>00395 
<a name="l00396"></a>00396 
<a name="l00397"></a><a class="code" href="classTetGenMeshInterface.php#a89c4f7132fa5db03d8752f74282d1f00">00397</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenMeshInterface.php#a89c4f7132fa5db03d8752f74282d1f00">TetGenMeshInterface::triangulate_conformingDelaunayMesh</a> (<span class="keyword">const</span> <span class="keywordtype">double</span> quality_constraint,
<a name="l00398"></a>00398                                                               <span class="keyword">const</span> <span class="keywordtype">double</span> volume_constraint)   
<a name="l00399"></a>00399 {
<a name="l00400"></a>00400   <span class="comment">// &gt;&gt;&gt; libmesh_assert usage of TRI3 hull elements (no other elements! =&gt; mesh.all_tri() )</span>
<a name="l00401"></a>00401 
<a name="l00402"></a>00402   <span class="comment">// thorough check of hull integrity:</span>
<a name="l00403"></a>00403   <span class="comment">// loop over hull with breadth-first search:</span>
<a name="l00404"></a>00404   std::set&lt; Elem *&gt;    visited;
<a name="l00405"></a>00405   std::vector&lt; Elem *&gt; current;
<a name="l00406"></a>00406 
<a name="l00407"></a>00407   <span class="comment">// Initialize the current vector with element 0</span>
<a name="l00408"></a>00408   current.push_back(this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(0));
<a name="l00409"></a>00409 
<a name="l00410"></a>00410   <span class="keywordflow">while</span> (!current.empty())
<a name="l00411"></a>00411     {
<a name="l00412"></a>00412       <a class="code" href="classElem.php">Elem</a>* elem = current.back();
<a name="l00413"></a>00413 
<a name="l00414"></a>00414       libmesh_assert (elem != NULL);
<a name="l00415"></a>00415   
<a name="l00416"></a>00416       <span class="comment">// Attempt to insert this element into the visited set.</span>
<a name="l00417"></a>00417       visited.insert(elem);
<a name="l00418"></a>00418 
<a name="l00419"></a>00419       <span class="comment">// Remove the last element from the vector.</span>
<a name="l00420"></a>00420       current.pop_back();
<a name="l00421"></a>00421 
<a name="l00422"></a>00422       <span class="comment">// Loop over the element&#39;s neighbors</span>
<a name="l00423"></a>00423       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;elem-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); ++i)
<a name="l00424"></a>00424         {
<a name="l00425"></a>00425           <span class="comment">// Attempt to find this element&#39;s neighbor in the visited set.</span>
<a name="l00426"></a>00426           <span class="comment">// If not found, insert this neighbor into the current vector.</span>
<a name="l00427"></a>00427           <span class="keywordflow">if</span> (visited.find(elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(i)) == visited.end())
<a name="l00428"></a>00428             current.push_back(elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(i));
<a name="l00429"></a>00429         } 
<a name="l00430"></a>00430     }
<a name="l00431"></a>00431   
<a name="l00432"></a>00432   <span class="keywordflow">if</span> (visited.size() != this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>())
<a name="l00433"></a>00433     {
<a name="l00434"></a>00434       std::cerr &lt;&lt; <span class="stringliteral">&quot;triangulate: hull not connected: element(s) not reached by others.\n&quot;</span>;
<a name="l00435"></a>00435       libmesh_error();
<a name="l00436"></a>00436     } 
<a name="l00437"></a>00437 
<a name="l00438"></a>00438   <span class="comment">// start triangulation method with empty holes list:</span>
<a name="l00439"></a>00439   std::vector&lt; Node *&gt; noholes;
<a name="l00440"></a>00440   <a class="code" href="classTetGenMeshInterface.php#a723a1028ca384f3b4accf542aee94e7c">triangulate_conformingDelaunayMesh_carvehole</a>(noholes, quality_constraint, volume_constraint);
<a name="l00441"></a>00441 }
<a name="l00442"></a>00442 
<a name="l00443"></a>00443 
<a name="l00444"></a>00444 
<a name="l00445"></a><a class="code" href="classTetGenMeshInterface.php#a723a1028ca384f3b4accf542aee94e7c">00445</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenMeshInterface.php#a723a1028ca384f3b4accf542aee94e7c">TetGenMeshInterface::triangulate_conformingDelaunayMesh_carvehole</a>  (<span class="keyword">const</span> std::vector&lt; Node *&gt;&amp; holes,
<a name="l00446"></a>00446                                                                          <span class="keyword">const</span> <span class="keywordtype">double</span> quality_constraint,
<a name="l00447"></a>00447                                                                          <span class="keyword">const</span> <span class="keywordtype">double</span> volume_constraint)
<a name="l00448"></a>00448 {
<a name="l00449"></a>00449   <span class="comment">// Check mesh for validity: Must be composed of all TRI3 elements,</span>
<a name="l00450"></a>00450   <span class="comment">// also it must be convex so each element must have non-NULL neighbors.</span>
<a name="l00451"></a>00451   {
<a name="l00452"></a>00452     <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> it        = this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00453"></a>00453     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00454"></a>00454 
<a name="l00455"></a>00455     <span class="keywordflow">for</span> (; it != end ; ++it)
<a name="l00456"></a>00456       {
<a name="l00457"></a>00457         <a class="code" href="classElem.php">Elem</a>* elem = *it;
<a name="l00458"></a>00458 
<a name="l00459"></a>00459         <span class="comment">// Check for proper element type</span>
<a name="l00460"></a>00460         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>() != <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>)
<a name="l00461"></a>00461           {
<a name="l00462"></a>00462             std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Some of the elements in the original mesh were not TRI3!&quot;</span> &lt;&lt; std::endl;
<a name="l00463"></a>00463             libmesh_error();
<a name="l00464"></a>00464           }
<a name="l00465"></a>00465 
<a name="l00466"></a>00466         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;elem-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); ++i)
<a name="l00467"></a>00467           {
<a name="l00468"></a>00468             <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(i) == NULL)
<a name="l00469"></a>00469               {
<a name="l00470"></a>00470                 std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Non-convex hull, cannot be tetrahedralized.&quot;</span> &lt;&lt; std::endl;
<a name="l00471"></a>00471                 libmesh_error();
<a name="l00472"></a>00472               }
<a name="l00473"></a>00473           }
<a name="l00474"></a>00474       }
<a name="l00475"></a>00475   }
<a name="l00476"></a>00476   
<a name="l00477"></a>00477   <span class="comment">// &gt;&gt;&gt; fill input structure with point set data:</span>
<a name="l00478"></a>00478   <span class="comment">// class tetgen_wrapper allows library access on a basic level:</span>
<a name="l00479"></a>00479   <a class="code" href="classTetGenWrapper.php">TetGen_access</a> tetgen_wrapper; 
<a name="l00480"></a>00480 
<a name="l00481"></a>00481   tetgen_wrapper.<a class="code" href="classTetGenWrapper.php#a464e83468a1ccafcde42232c0e44b6fc">set_pointlist</a>(this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l00482"></a>00482   {
<a name="l00483"></a>00483     <span class="keywordtype">int</span> index = 0;
<a name="l00484"></a>00484     <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> it        = this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
<a name="l00485"></a>00485     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> end = this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
<a name="l00486"></a>00486     <span class="keywordflow">for</span> ( ; it != end; ++it) 
<a name="l00487"></a>00487       tetgen_wrapper.<a class="code" href="classTetGenWrapper.php#a02fdaa4cfb77bd0c35213687a16ee966">set_node</a>(index++, (**it)(0), (**it)(1), (**it)(2));
<a name="l00488"></a>00488   }
<a name="l00489"></a>00489 
<a name="l00490"></a>00490   <span class="comment">// &gt;&gt;&gt; fill input structure &quot;tetgenio&quot; with facet data:</span>
<a name="l00491"></a>00491   <span class="keywordtype">int</span> facet_num = this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>();
<a name="l00492"></a>00492 
<a name="l00493"></a>00493   <span class="comment">// allocate memory in &quot;tetgenio&quot; structure:</span>
<a name="l00494"></a>00494   tetgen_wrapper.<a class="code" href="classTetGenWrapper.php#a2a5fdc7689d694dcea389daf5252d090">set_facetlist</a>(facet_num, holes.size());
<a name="l00495"></a>00495 
<a name="l00496"></a>00496 
<a name="l00497"></a>00497   {
<a name="l00498"></a>00498     <span class="keywordtype">int</span> insertnum = 0;
<a name="l00499"></a>00499     <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> it        = this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00500"></a>00500     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00501"></a>00501     <span class="keywordflow">for</span> (; it != end ; ++it)
<a name="l00502"></a>00502       {
<a name="l00503"></a>00503         tetgen_wrapper.<a class="code" href="classTetGenWrapper.php#ab93ff8de300d23807b9b746776aeae3b">set_facet_polygonlist</a>(insertnum, 1);
<a name="l00504"></a>00504         tetgen_wrapper.<a class="code" href="classTetGenWrapper.php#a5a1c4f88c0ed7d1542967d95261c7a6a">set_polygon_vertexlist</a>(insertnum, 0, 3);
<a name="l00505"></a>00505 
<a name="l00506"></a>00506         <a class="code" href="classElem.php">Elem</a>* elem = *it;
<a name="l00507"></a>00507 
<a name="l00508"></a>00508         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); ++j)
<a name="l00509"></a>00509           tetgen_wrapper.<a class="code" href="classTetGenWrapper.php#a76ebaaa12882426617193ae5ca475a02">set_vertex</a>(insertnum, <span class="comment">// facet number</span>
<a name="l00510"></a>00510                                     0,         <span class="comment">// polygon (always 0)</span>
<a name="l00511"></a>00511                                     j,         <span class="comment">// vertex in tetgen input</span>
<a name="l00512"></a>00512                                     this-&gt;get_node_index(elem-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(j)));
<a name="l00513"></a>00513         insertnum++;
<a name="l00514"></a>00514       }
<a name="l00515"></a>00515   }
<a name="l00516"></a>00516 
<a name="l00517"></a>00517 
<a name="l00518"></a>00518 
<a name="l00519"></a>00519   <span class="comment">// fill hole list (if there are holes):</span>
<a name="l00520"></a>00520   <span class="keywordflow">if</span> (holes.size() &gt; 0)
<a name="l00521"></a>00521     {
<a name="l00522"></a>00522       std::vector&lt; Node *&gt;::const_iterator ihole;
<a name="l00523"></a>00523       <span class="keywordtype">int</span> hole_index = 0;
<a name="l00524"></a>00524       <span class="keywordflow">for</span> (ihole=holes.begin(); ihole!=holes.end(); ++ihole)
<a name="l00525"></a>00525         tetgen_wrapper.<a class="code" href="classTetGenWrapper.php#a2e0545781e16d96ccfabe8182f04d624">set_hole</a>(hole_index++, (**ihole)(0), (**ihole)(1), (**ihole)(2));
<a name="l00526"></a>00526     }
<a name="l00527"></a>00527 
<a name="l00528"></a>00528   
<a name="l00529"></a>00529   <span class="comment">// &gt;&gt;&gt; run TetGen triangulation method:</span>
<a name="l00530"></a>00530   <span class="comment">// assemble switches:</span>
<a name="l00531"></a>00531   std::ostringstream oss; <span class="comment">// string holding switches</span>
<a name="l00532"></a>00532   oss &lt;&lt; <span class="stringliteral">&quot;pQ&quot;</span>;
<a name="l00533"></a>00533 
<a name="l00534"></a>00534   <span class="keywordflow">if</span> (quality_constraint != 0)
<a name="l00535"></a>00535     oss &lt;&lt; <span class="stringliteral">&quot;q&quot;</span> &lt;&lt; std::fixed &lt;&lt; quality_constraint;
<a name="l00536"></a>00536   
<a name="l00537"></a>00537   <span class="keywordflow">if</span> (volume_constraint != 0)
<a name="l00538"></a>00538     oss &lt;&lt; <span class="stringliteral">&quot;a&quot;</span> &lt;&lt; std::fixed &lt;&lt; volume_constraint;
<a name="l00539"></a>00539   
<a name="l00540"></a>00540   std::string params = oss.str();
<a name="l00541"></a>00541 
<a name="l00542"></a>00542   tetgen_wrapper.<a class="code" href="classTetGenWrapper.php#accee0a8d7fd6972101fcd524f3c48bfe">set_switches</a>(params); <span class="comment">// TetGen switches: Piecewise linear complex, Quiet mode</span>
<a name="l00543"></a>00543   tetgen_wrapper.<a class="code" href="classTetGenWrapper.php#aec79130c06161fff8170b4041b9d66c0">run_tetgen</a>();
<a name="l00544"></a>00544 
<a name="l00545"></a>00545   <span class="comment">// =&gt; nodes:</span>
<a name="l00546"></a>00546   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_nodesnum = this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>();
<a name="l00547"></a>00547   <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a> x=0., y=0., z=0.;
<a name="l00548"></a>00548   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num_nodes = tetgen_wrapper.<a class="code" href="classTetGenWrapper.php#a082ce057359b37ec61f9331722a6871f">get_numberofpoints</a>();
<a name="l00549"></a>00549 
<a name="l00550"></a>00550   <span class="comment">// Add additional nodes to the nodes vector.</span>
<a name="l00551"></a>00551   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=old_nodesnum; i&lt;=num_nodes; i++)
<a name="l00552"></a>00552     {
<a name="l00553"></a>00553       tetgen_wrapper.<a class="code" href="classTetGenWrapper.php#aaf7f1bff58bc2873f188dd308c5cd5bc">get_output_node</a>(i, x,y,z);
<a name="l00554"></a>00554       this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#a01b66468d3e9d8b5db82c6f3d9131f5e">add_point</a> ( <a class="code" href="classPoint.php">Point</a>(x,y,z) );
<a name="l00555"></a>00555     }
<a name="l00556"></a>00556   
<a name="l00557"></a>00557   <span class="comment">// =&gt; tetrahedra:</span>
<a name="l00558"></a>00558   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num_elements   = tetgen_wrapper.<a class="code" href="classTetGenWrapper.php#a4a4a35c65439175ac29d650bff564e64">get_numberoftetrahedra</a>();
<a name="l00559"></a>00559 
<a name="l00560"></a>00560   <span class="comment">// Vector that temporarily holds the node labels defining element.</span>
<a name="l00561"></a>00561   <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> node_labels[4];      
<a name="l00562"></a>00562 
<a name="l00563"></a>00563   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;num_elements; i++)
<a name="l00564"></a>00564     {
<a name="l00565"></a>00565       <span class="comment">//_elements[firstnumber+i] = new Tet4;     // TetGen only supports Tet4 elements.</span>
<a name="l00566"></a>00566       <a class="code" href="classElem.php">Elem</a>* elem = <span class="keyword">new</span> <a class="code" href="classTet4.php">Tet4</a>;
<a name="l00567"></a>00567 
<a name="l00568"></a>00568       <span class="comment">// Fill up the the node_labels vector</span>
<a name="l00569"></a>00569       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); j++) 
<a name="l00570"></a>00570         node_labels[j] = tetgen_wrapper.<a class="code" href="classTetGenWrapper.php#a03c69a555eab2abb205f141e5138294f">get_element_node</a>(i,j);
<a name="l00571"></a>00571       
<a name="l00572"></a>00572       <span class="comment">// Associate nodes with this element</span>
<a name="l00573"></a>00573       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); j++) 
<a name="l00574"></a>00574         elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(j) = this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>( node_labels[j] );
<a name="l00575"></a>00575 
<a name="l00576"></a>00576       <span class="comment">// Finally, add this element to the mesh</span>
<a name="l00577"></a>00577       this-&gt;<a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>.<a class="code" href="classMeshBase.php#a0f6974cf3e413cfe9caa1fcb4ce8153e">add_elem</a>(elem);
<a name="l00578"></a>00578     }
<a name="l00579"></a>00579 }
<a name="l00580"></a>00580 
<a name="l00581"></a>00581 
<a name="l00582"></a>00582 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_TETGEN</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
