<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_tetgen_support.h</h1>  </div>
</div>
<div class="contents">
<a href="mesh__tetgen__support_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_tetgen_support.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002  
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __mesh_tetgen_support_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_tetgen_support_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#ifdef LIBMESH_HAVE_TETGEN</span>
<a name="l00026"></a>00026 <span class="preprocessor"></span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// C++ includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Local includes</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// TetGen include file</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;tetgen.h&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">// Forward Declarations</span>
<a name="l00040"></a>00040 <span class="keyword">class </span><a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>;
<a name="l00041"></a>00041 <span class="keyword">class </span><a class="code" href="classNode.php">Node</a>;
<a name="l00042"></a>00042 
<a name="l00047"></a><a class="code" href="classTetGenWrapper.php">00047</a> <span class="keyword">class </span><a class="code" href="classTetGenWrapper.php">TetGenWrapper</a>
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049  <span class="keyword">public</span>:
<a name="l00050"></a>00050 
<a name="l00054"></a>00054   <a class="code" href="classTetGenWrapper.php#a4b3f94500ce85d5df223d3e6985e6e1a">TetGenWrapper</a> ();
<a name="l00055"></a>00055 
<a name="l00059"></a>00059   <a class="code" href="classTetGenWrapper.php#adec2626ab48159450185395002516d82">~TetGenWrapper</a> ();
<a name="l00060"></a>00060   
<a name="l00064"></a>00064   <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#accee0a8d7fd6972101fcd524f3c48bfe">set_switches</a>(<span class="keyword">const</span> std::string&amp; s);
<a name="l00065"></a>00065 
<a name="l00069"></a>00069   <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#aec79130c06161fff8170b4041b9d66c0">run_tetgen</a>();
<a name="l00070"></a>00070 
<a name="l00074"></a>00074   <span class="keywordtype">int</span>  <a class="code" href="classTetGenWrapper.php#a4a4a35c65439175ac29d650bff564e64">get_numberoftetrahedra</a>();
<a name="l00075"></a>00075 
<a name="l00079"></a>00079   <span class="keywordtype">int</span>  <a class="code" href="classTetGenWrapper.php#a0c9fe93997a9402ac88db9f5eecd1c2d">get_numberoftrifaces</a>();
<a name="l00080"></a>00080 
<a name="l00084"></a>00084   <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a5becf7bd070afeed09f5abd21c483abe">set_numberofpoints</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i);
<a name="l00085"></a>00085 
<a name="l00089"></a>00089   <span class="keywordtype">int</span>  <a class="code" href="classTetGenWrapper.php#a082ce057359b37ec61f9331722a6871f">get_numberofpoints</a>();
<a name="l00090"></a>00090 
<a name="l00094"></a>00094   <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a820b942bda20be02eb8a481d7b3069ab">set_numberoffacets</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i);
<a name="l00095"></a>00095 
<a name="l00099"></a>00099   <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a7a55ca5a95be8c510588228a047b95c6">set_numberofholes</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i);
<a name="l00100"></a>00100 
<a name="l00104"></a>00104   <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a05434f887fde5814f21132adbd764c9e">set_numberofregions</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i);
<a name="l00105"></a>00105 
<a name="l00109"></a>00109   <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a464e83468a1ccafcde42232c0e44b6fc">set_pointlist</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> numofpoints);
<a name="l00110"></a>00110 
<a name="l00114"></a>00114   <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a2a5fdc7689d694dcea389daf5252d090">set_facetlist</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> numoffacets, <span class="keyword">const</span> <span class="keywordtype">int</span> numofholes);
<a name="l00115"></a>00115 
<a name="l00119"></a>00119   <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a0879b9edf704af76092202f1302c442d">set_regionlist</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> numofregions);
<a name="l00120"></a>00120 
<a name="l00124"></a>00124   <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a02fdaa4cfb77bd0c35213687a16ee966">set_node</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a> x, <span class="keyword">const</span> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a> y, <span class="keyword">const</span> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a> z);
<a name="l00125"></a>00125 
<a name="l00129"></a>00129   <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#aaf7f1bff58bc2873f188dd308c5cd5bc">get_output_node</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a>&amp; x, <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a>&amp; y, <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a>&amp; z);
<a name="l00130"></a>00130 
<a name="l00134"></a>00134   <span class="keywordtype">int</span>  <a class="code" href="classTetGenWrapper.php#a03c69a555eab2abb205f141e5138294f">get_element_node</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> j);
<a name="l00135"></a>00135 
<a name="l00139"></a>00139   <span class="keywordtype">int</span>  <a class="code" href="classTetGenWrapper.php#a7e1fed37c404491a77524dcf7f315223">get_triface_node</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> j);
<a name="l00140"></a>00140 
<a name="l00144"></a>00144   <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a> <a class="code" href="classTetGenWrapper.php#a54f87eb822ba7b34fd5a6bee5180c941">get_element_attribute</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i);
<a name="l00145"></a>00145        
<a name="l00149"></a>00149   <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a2e0545781e16d96ccfabe8182f04d624">set_hole</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a> x, <span class="keyword">const</span> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a> y, <span class="keyword">const</span> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a> z);
<a name="l00150"></a>00150 
<a name="l00154"></a>00154   <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a32b9c10c0f9bf3562326959518c3a880">set_facet_numberofpolygons</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> num);
<a name="l00155"></a>00155 
<a name="l00159"></a>00159   <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#aff0706bec70fa7eb558f0769b8410cae">set_facet_numberofholes</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> num);
<a name="l00160"></a>00160 
<a name="l00165"></a>00165   <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#ab93ff8de300d23807b9b746776aeae3b">set_facet_polygonlist</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> numofpolygons);
<a name="l00166"></a>00166 
<a name="l00170"></a>00170   <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a7ea0378b2101e5348aad343bcc37bb77">set_polygon_numberofvertices</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> j, <span class="keyword">const</span> <span class="keywordtype">int</span> num);
<a name="l00171"></a>00171 
<a name="l00176"></a>00176   <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a5a1c4f88c0ed7d1542967d95261c7a6a">set_polygon_vertexlist</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> j, <span class="keyword">const</span> <span class="keywordtype">int</span> numofvertices);
<a name="l00177"></a>00177 
<a name="l00182"></a>00182   <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a76ebaaa12882426617193ae5ca475a02">set_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> j, <span class="keyword">const</span> <span class="keywordtype">int</span> k, <span class="keyword">const</span> <span class="keywordtype">int</span> nodeindex);
<a name="l00183"></a>00183 
<a name="l00190"></a>00190   <span class="keywordtype">void</span> <a class="code" href="classTetGenWrapper.php#a4f2a5703008a1e4938b4e1a14dfe8312">set_region</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a> x, <span class="keyword">const</span> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a> y, <span class="keyword">const</span> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a> z,
<a name="l00191"></a>00191                   <span class="keyword">const</span> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a> attribute, <span class="keyword">const</span> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a> vol_constraint);
<a name="l00192"></a>00192 
<a name="l00196"></a><a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">00196</a>   tetgenio   <a class="code" href="classTetGenWrapper.php#a5c81bec76efa564cdd4b467d573cb7eb">tetgen_data</a>;
<a name="l00197"></a>00197   
<a name="l00201"></a><a class="code" href="classTetGenWrapper.php#a90005b9ea112519f380edd23d73fa682">00201</a>   tetgenio*  <a class="code" href="classTetGenWrapper.php#a90005b9ea112519f380edd23d73fa682">tetgen_output</a>;
<a name="l00202"></a>00202 
<a name="l00206"></a><a class="code" href="classTetGenWrapper.php#a86d1169d19008f8705c27717d6b979cc">00206</a>   tetgenmesh      <a class="code" href="classTetGenWrapper.php#a86d1169d19008f8705c27717d6b979cc">tetgen_mesh</a>;
<a name="l00207"></a>00207   
<a name="l00211"></a><a class="code" href="classTetGenWrapper.php#a774298ef64ec5b014a89b8840b508450">00211</a>   tetgenbehavior  <a class="code" href="classTetGenWrapper.php#a774298ef64ec5b014a89b8840b508450">tetgen_be</a>; 
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 };
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 
<a name="l00216"></a>00216 
<a name="l00223"></a><a class="code" href="classTetGenMeshInterface.php">00223</a> <span class="keyword">class </span><a class="code" href="classTetGenMeshInterface.php">TetGenMeshInterface</a>
<a name="l00224"></a>00224 {
<a name="l00225"></a>00225 <span class="keyword">public</span>:
<a name="l00226"></a>00226 
<a name="l00230"></a>00230   <a class="code" href="classTetGenMeshInterface.php#adad356a34e76444a477393798f6460c2">TetGenMeshInterface</a> (<a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; mesh);
<a name="l00231"></a>00231 
<a name="l00235"></a><a class="code" href="classTetGenMeshInterface.php#a5690e46c7a3cb83b274adc81e56dcd7f">00235</a>   <a class="code" href="classTetGenMeshInterface.php#a5690e46c7a3cb83b274adc81e56dcd7f">~TetGenMeshInterface</a>() {};
<a name="l00236"></a>00236 
<a name="l00241"></a>00241   <span class="keywordtype">void</span> <a class="code" href="classTetGenMeshInterface.php#ab8febaa5fd52233db6c130106e94c254">triangulate_pointset</a> ();
<a name="l00242"></a>00242 
<a name="l00247"></a>00247   <span class="keywordtype">void</span> <a class="code" href="classTetGenMeshInterface.php#a39c38b6c11a824222b76de8dbf4c76fd">pointset_convexhull</a> ();
<a name="l00248"></a>00248 
<a name="l00254"></a>00254   <span class="keywordtype">void</span> <a class="code" href="classTetGenMeshInterface.php#a89c4f7132fa5db03d8752f74282d1f00">triangulate_conformingDelaunayMesh</a> (<span class="keyword">const</span> <span class="keywordtype">double</span> quality_constraint,
<a name="l00255"></a>00255                                            <span class="keyword">const</span> <span class="keywordtype">double</span> volume_constraint);
<a name="l00256"></a>00256 
<a name="l00262"></a>00262   <span class="keywordtype">void</span> <a class="code" href="classTetGenMeshInterface.php#a723a1028ca384f3b4accf542aee94e7c">triangulate_conformingDelaunayMesh_carvehole</a> (<span class="keyword">const</span> std::vector&lt; Node *&gt;&amp; holes,
<a name="l00263"></a>00263                                                      <span class="keyword">const</span> <span class="keywordtype">double</span> quality_constraint,
<a name="l00264"></a>00264                                                      <span class="keyword">const</span> <span class="keywordtype">double</span> volume_constraint);
<a name="l00265"></a>00265 
<a name="l00269"></a>00269   <span class="keywordtype">int</span> <a class="code" href="classTetGenMeshInterface.php#a65eb0e78354164b4da9f76767abcadfa">get_node_index</a> (<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* inode);
<a name="l00270"></a>00270 
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 <span class="keyword">protected</span>:
<a name="l00273"></a>00273 
<a name="l00277"></a><a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">00277</a>   <a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; <a class="code" href="classTetGenMeshInterface.php#a1966c842d18caccc99e9f94cdc59da77">_mesh</a>;
<a name="l00278"></a>00278 
<a name="l00279"></a>00279 };
<a name="l00280"></a>00280 
<a name="l00281"></a>00281 <span class="preprocessor">#endif // LIBMESH_HAVE_TETGEN</span>
<a name="l00282"></a>00282 <span class="preprocessor"></span>
<a name="l00283"></a>00283 <span class="preprocessor">#endif </span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
