<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_tools.C</h1>  </div>
</div>
<div class="contents">
<a href="mesh__tools_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_tools.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;limits&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;boundary_info.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;elem_range.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;location_maps.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;mesh_communication.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;mesh_tools.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;node_range.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;parallel.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;parallel_mesh.h&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;serial_mesh.h&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;sphere.h&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;threads.h&quot;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span><span class="preprocessor">#  include &quot;remote_elem.h&quot;</span>
<a name="l00043"></a>00043 <span class="preprocessor">#endif</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span>
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00048"></a>00048 <span class="comment">// anonymous namespace for helper classes</span>
<a name="l00049"></a>00049 <span class="keyword">namespace </span>{
<a name="l00057"></a>00057   <span class="keyword">class </span>SumElemWeight
<a name="l00058"></a>00058   {
<a name="l00059"></a>00059   <span class="keyword">public</span>:
<a name="l00060"></a>00060     SumElemWeight () : 
<a name="l00061"></a>00061       _weight(0) 
<a name="l00062"></a>00062     {}
<a name="l00063"></a>00063 
<a name="l00064"></a>00064     SumElemWeight (SumElemWeight &amp;, <a class="code" href="classThreads_1_1split.php">Threads::split</a>) : 
<a name="l00065"></a>00065       _weight(0)
<a name="l00066"></a>00066     {}
<a name="l00067"></a>00067     
<a name="l00068"></a>00068     <span class="keywordtype">void</span> operator()(<span class="keyword">const</span> <a class="code" href="classStoredRange.php">ConstElemRange</a> &amp;range)
<a name="l00069"></a>00069     { 
<a name="l00070"></a>00070       <span class="keywordflow">for</span> (<a class="code" href="classStoredRange.php#ab2657352e8f9c79ab6fa4085c0bdd0d8">ConstElemRange::const_iterator</a> it = range.<a class="code" href="classStoredRange.php#a5f753b5b424dff3ab8030ce64d7a9f0a">begin</a>(); it !=range.<a class="code" href="classStoredRange.php#abc8b19e0ebe76d4cda84e870e652fcf6">end</a>(); ++it)
<a name="l00071"></a>00071         _weight += (*it)-&gt;n_nodes();
<a name="l00072"></a>00072     }
<a name="l00073"></a>00073 
<a name="l00074"></a>00074     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a7c3064eb37925fb5bdda7660e872cf69">weight</a>()<span class="keyword"> const </span>
<a name="l00075"></a>00075 <span class="keyword">    </span>{ <span class="keywordflow">return</span> _weight; }
<a name="l00076"></a>00076     
<a name="l00077"></a>00077     <span class="keywordtype">void</span> join (<span class="keyword">const</span> SumElemWeight &amp;other)
<a name="l00078"></a>00078     { _weight += other.weight(); }
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   <span class="keyword">private</span>:
<a name="l00081"></a>00081     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _weight;
<a name="l00082"></a>00082   };
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00091"></a>00091   <span class="keyword">class </span>FindBBox
<a name="l00092"></a>00092   {
<a name="l00093"></a>00093   <span class="keyword">public</span>:
<a name="l00094"></a>00094     FindBBox () :
<a name="l00095"></a>00095       _vmin(3,  std::numeric_limits&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;::<a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>()),
<a name="l00096"></a>00096       _vmax(3, -std::numeric_limits&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;::<a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>())
<a name="l00097"></a>00097     {}
<a name="l00098"></a>00098 
<a name="l00099"></a>00099     FindBBox (FindBBox &amp;other, <a class="code" href="classThreads_1_1split.php">Threads::split</a>) :
<a name="l00100"></a>00100       _vmin(other._vmin),
<a name="l00101"></a>00101       _vmax(other._vmax)
<a name="l00102"></a>00102     {}
<a name="l00103"></a>00103 
<a name="l00104"></a>00104     std::vector&lt;Real&gt; &amp; <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>() { <span class="keywordflow">return</span> _vmin; }
<a name="l00105"></a>00105     std::vector&lt;Real&gt; &amp; <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>() { <span class="keywordflow">return</span> _vmax; }
<a name="l00106"></a>00106     
<a name="l00107"></a>00107     <span class="keywordtype">void</span> operator()(<span class="keyword">const</span> <a class="code" href="classStoredRange.php">ConstNodeRange</a> &amp;range)
<a name="l00108"></a>00108     {
<a name="l00109"></a>00109       <span class="keywordflow">for</span> (<a class="code" href="classStoredRange.php#ab2657352e8f9c79ab6fa4085c0bdd0d8">ConstNodeRange::const_iterator</a> it = range.<a class="code" href="classStoredRange.php#a5f753b5b424dff3ab8030ce64d7a9f0a">begin</a>(); it != range.<a class="code" href="classStoredRange.php#abc8b19e0ebe76d4cda84e870e652fcf6">end</a>(); ++it)
<a name="l00110"></a>00110         {
<a name="l00111"></a>00111           <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a> *node = *it;
<a name="l00112"></a>00112           libmesh_assert (node != NULL);
<a name="l00113"></a>00113           
<a name="l00114"></a>00114           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;3; i++)
<a name="l00115"></a>00115             {
<a name="l00116"></a>00116               _vmin[i] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(_vmin[i], (*node)(i));
<a name="l00117"></a>00117               _vmax[i] = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(_vmax[i], (*node)(i));
<a name="l00118"></a>00118             }      
<a name="l00119"></a>00119         }
<a name="l00120"></a>00120     }
<a name="l00121"></a>00121 
<a name="l00122"></a>00122     <span class="keywordtype">void</span> operator()(<span class="keyword">const</span> <a class="code" href="classStoredRange.php">ConstElemRange</a> &amp;range)
<a name="l00123"></a>00123     {
<a name="l00124"></a>00124       <span class="keywordflow">for</span> (<a class="code" href="classStoredRange.php#ab2657352e8f9c79ab6fa4085c0bdd0d8">ConstElemRange::const_iterator</a> it = range.<a class="code" href="classStoredRange.php#a5f753b5b424dff3ab8030ce64d7a9f0a">begin</a>(); it != range.<a class="code" href="classStoredRange.php#abc8b19e0ebe76d4cda84e870e652fcf6">end</a>(); ++it)
<a name="l00125"></a>00125         {
<a name="l00126"></a>00126           <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *elem = *it;
<a name="l00127"></a>00127           libmesh_assert (elem != NULL);
<a name="l00128"></a>00128 
<a name="l00129"></a>00129           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); n++)
<a name="l00130"></a>00130             {
<a name="l00131"></a>00131               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> &amp;point = elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(n);
<a name="l00132"></a>00132 
<a name="l00133"></a>00133               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;3; i++)
<a name="l00134"></a>00134                 {
<a name="l00135"></a>00135                   _vmin[i] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(_vmin[i], point(i));
<a name="l00136"></a>00136                   _vmax[i] = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(_vmax[i], point(i));
<a name="l00137"></a>00137                 }     
<a name="l00138"></a>00138             } 
<a name="l00139"></a>00139         }
<a name="l00140"></a>00140     }
<a name="l00141"></a>00141 
<a name="l00142"></a>00142     <span class="keywordtype">void</span> join (<span class="keyword">const</span> FindBBox &amp;other)
<a name="l00143"></a>00143     {
<a name="l00144"></a>00144       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;3; i++)
<a name="l00145"></a>00145         {
<a name="l00146"></a>00146           _vmin[i] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(_vmin[i], other._vmin[i]);
<a name="l00147"></a>00147           _vmax[i] = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(_vmax[i], other._vmax[i]);
<a name="l00148"></a>00148         }      
<a name="l00149"></a>00149     }
<a name="l00150"></a>00150 
<a name="l00151"></a>00151     <a class="code" href="classMeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a> bbox ()<span class="keyword"> const</span>
<a name="l00152"></a>00152 <span class="keyword">    </span>{
<a name="l00153"></a>00153       <a class="code" href="classPoint.php">Point</a> pmin(_vmin[0], _vmin[1], _vmin[2]);
<a name="l00154"></a>00154       <a class="code" href="classPoint.php">Point</a> pmax(_vmax[0], _vmax[1], _vmax[2]);
<a name="l00155"></a>00155 
<a name="l00156"></a>00156       <span class="keyword">const</span> <a class="code" href="classMeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a> ret_val(pmin, pmax);
<a name="l00157"></a>00157 
<a name="l00158"></a>00158       <span class="keywordflow">return</span> ret_val;        
<a name="l00159"></a>00159     }
<a name="l00160"></a>00160     
<a name="l00161"></a>00161   <span class="keyword">private</span>:
<a name="l00162"></a>00162     std::vector&lt;Real&gt; _vmin;
<a name="l00163"></a>00163     std::vector&lt;Real&gt; _vmax;
<a name="l00164"></a>00164   };
<a name="l00165"></a>00165 }
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00170"></a>00170 <span class="comment">// MeshTools functions</span>
<a name="l00171"></a><a class="code" href="namespaceMeshTools.php#a12088fda1f68ba58f5868a24a4ed884a">00171</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a12088fda1f68ba58f5868a24a4ed884a">MeshTools::total_weight</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh)
<a name="l00172"></a>00172 {
<a name="l00173"></a>00173   <span class="keywordflow">if</span> (!mesh.<a class="code" href="classMeshBase.php#a660bb92c9fb94527d1cabfb1fdd6d056">is_serial</a>())
<a name="l00174"></a>00174     {
<a name="l00175"></a>00175       parallel_only();
<a name="l00176"></a>00176       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a7c3064eb37925fb5bdda7660e872cf69">weight</a> = <a class="code" href="namespaceMeshTools.php#a7c3064eb37925fb5bdda7660e872cf69">MeshTools::weight</a> (mesh, <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>());
<a name="l00177"></a>00177       Parallel::sum(weight);
<a name="l00178"></a>00178       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> unpartitioned_weight =
<a name="l00179"></a>00179         <a class="code" href="namespaceMeshTools.php#a7c3064eb37925fb5bdda7660e872cf69">MeshTools::weight</a> (mesh, <a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>);
<a name="l00180"></a>00180       <span class="keywordflow">return</span> weight + unpartitioned_weight;
<a name="l00181"></a>00181     }
<a name="l00182"></a>00182   
<a name="l00183"></a>00183   SumElemWeight sew;
<a name="l00184"></a>00184   
<a name="l00185"></a>00185   <a class="code" href="namespaceThreads.php#a5957a49c5a5b3a757b655cb6f8a2d933">Threads::parallel_reduce</a> (<a class="code" href="classStoredRange.php">ConstElemRange</a> (mesh.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>(),
<a name="l00186"></a>00186                                             mesh.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>()),
<a name="l00187"></a>00187                             sew);
<a name="l00188"></a>00188   <span class="keywordflow">return</span> sew.weight();
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 }
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 
<a name="l00194"></a><a class="code" href="namespaceMeshTools.php#a7c3064eb37925fb5bdda7660e872cf69">00194</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a7c3064eb37925fb5bdda7660e872cf69">MeshTools::weight</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid)
<a name="l00195"></a>00195 {
<a name="l00196"></a>00196   SumElemWeight sew;
<a name="l00197"></a>00197   
<a name="l00198"></a>00198   <a class="code" href="namespaceThreads.php#a5957a49c5a5b3a757b655cb6f8a2d933">Threads::parallel_reduce</a> (<a class="code" href="classStoredRange.php">ConstElemRange</a> (mesh.<a class="code" href="classMeshBase.php#aa8cbd1381e63c4c468292c1275497724">pid_elements_begin</a>(pid),
<a name="l00199"></a>00199                                             mesh.<a class="code" href="classMeshBase.php#a2fa21ec41ad9c25eb2617fca513bca5d">pid_elements_end</a>(pid)),
<a name="l00200"></a>00200                             sew);
<a name="l00201"></a>00201   <span class="keywordflow">return</span> sew.weight();
<a name="l00202"></a>00202 }
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 
<a name="l00206"></a><a class="code" href="namespaceMeshTools.php#a632cfcd7fcbda25f0450b52f3d75942f">00206</a> <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a632cfcd7fcbda25f0450b52f3d75942f">MeshTools::build_nodes_to_elem_map</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00207"></a>00207                                          std::vector&lt;std::vector&lt;unsigned int&gt; &gt;&amp; nodes_to_elem_map)
<a name="l00208"></a>00208 {
<a name="l00209"></a>00209   nodes_to_elem_map.resize (mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l00210"></a>00210 
<a name="l00211"></a>00211   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el  = mesh.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00212"></a>00212   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00213"></a>00213 
<a name="l00214"></a>00214   <span class="keywordflow">for</span> (; el != end; ++el)
<a name="l00215"></a>00215     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;(*el)-&gt;n_nodes(); n++)
<a name="l00216"></a>00216       {
<a name="l00217"></a>00217         libmesh_assert ((*el)-&gt;node(n) &lt; nodes_to_elem_map.size());
<a name="l00218"></a>00218         libmesh_assert ((*el)-&gt;id()    &lt; mesh.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>());
<a name="l00219"></a>00219         
<a name="l00220"></a>00220         nodes_to_elem_map[(*el)-&gt;node(n)].push_back((*el)-&gt;id());
<a name="l00221"></a>00221       }
<a name="l00222"></a>00222 }
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 
<a name="l00226"></a><a class="code" href="namespaceMeshTools.php#acc1724d9e06c08d92d4e805f944e633b">00226</a> <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a632cfcd7fcbda25f0450b52f3d75942f">MeshTools::build_nodes_to_elem_map</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00227"></a>00227                                          std::vector&lt;std::vector&lt;const Elem*&gt; &gt;&amp; nodes_to_elem_map)
<a name="l00228"></a>00228 {
<a name="l00229"></a>00229   nodes_to_elem_map.resize (mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l00230"></a>00230 
<a name="l00231"></a>00231   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el  = mesh.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00232"></a>00232   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00233"></a>00233 
<a name="l00234"></a>00234   <span class="keywordflow">for</span> (; el != end; ++el)
<a name="l00235"></a>00235     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;(*el)-&gt;n_nodes(); n++)
<a name="l00236"></a>00236       {
<a name="l00237"></a>00237         libmesh_assert ((*el)-&gt;node(n) &lt; nodes_to_elem_map.size());
<a name="l00238"></a>00238         
<a name="l00239"></a>00239         nodes_to_elem_map[(*el)-&gt;node(n)].push_back(*el);
<a name="l00240"></a>00240       }
<a name="l00241"></a>00241 }
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 
<a name="l00244"></a>00244 
<a name="l00245"></a><a class="code" href="namespaceMeshTools.php#ab24d347f09559cc4fa6ea2c1a238b2d4">00245</a> <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#ab24d347f09559cc4fa6ea2c1a238b2d4">MeshTools::find_boundary_nodes</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00246"></a>00246                                      std::vector&lt;bool&gt;&amp; on_boundary)
<a name="l00247"></a>00247 {
<a name="l00248"></a>00248   <span class="comment">// Resize the vector which holds boundary nodes and fill with false.</span>
<a name="l00249"></a>00249   on_boundary.resize(mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l00250"></a>00250   std::fill(on_boundary.begin(),
<a name="l00251"></a>00251             on_boundary.end(),
<a name="l00252"></a>00252             <span class="keyword">false</span>);
<a name="l00253"></a>00253 
<a name="l00254"></a>00254   <span class="comment">// Loop over elements, find those on boundary, and</span>
<a name="l00255"></a>00255   <span class="comment">// mark them as true in on_boundary.</span>
<a name="l00256"></a>00256   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el  = mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00257"></a>00257   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00258"></a>00258 
<a name="l00259"></a>00259   <span class="keywordflow">for</span> (; el != end; ++el)
<a name="l00260"></a>00260     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;(*el)-&gt;n_neighbors(); s++)
<a name="l00261"></a>00261       <span class="keywordflow">if</span> ((*el)-&gt;neighbor(s) == NULL) <span class="comment">// on the boundary</span>
<a name="l00262"></a>00262         {
<a name="l00263"></a>00263           <span class="keyword">const</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> side((*el)-&gt;build_side(s));
<a name="l00264"></a>00264           
<a name="l00265"></a>00265           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;side-&gt;n_nodes(); n++)
<a name="l00266"></a>00266             on_boundary[side-&gt;node(n)] = <span class="keyword">true</span>;
<a name="l00267"></a>00267         }
<a name="l00268"></a>00268 }
<a name="l00269"></a>00269 
<a name="l00270"></a>00270 
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 <a class="code" href="classMeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a>
<a name="l00273"></a><a class="code" href="namespaceMeshTools.php#ad533681876e9809cfe5e2114886b1c03">00273</a> <a class="code" href="namespaceMeshTools.php#ad533681876e9809cfe5e2114886b1c03">MeshTools::bounding_box</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh)
<a name="l00274"></a>00274 {
<a name="l00275"></a>00275   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00276"></a>00276   parallel_only();
<a name="l00277"></a>00277 
<a name="l00278"></a>00278   FindBBox find_bbox;
<a name="l00279"></a>00279   
<a name="l00280"></a>00280   <a class="code" href="namespaceThreads.php#a5957a49c5a5b3a757b655cb6f8a2d933">Threads::parallel_reduce</a> (<a class="code" href="classStoredRange.php">ConstNodeRange</a> (mesh.<a class="code" href="classMeshBase.php#a6485de7e7d67f36dec274f512d10fc15">local_nodes_begin</a>(),
<a name="l00281"></a>00281                                             mesh.<a class="code" href="classMeshBase.php#ae23ced52382b7238f9182c8593f5cdd5">local_nodes_end</a>()),
<a name="l00282"></a>00282                             find_bbox);
<a name="l00283"></a>00283 
<a name="l00284"></a>00284   <span class="comment">// and the unpartitioned nodes</span>
<a name="l00285"></a>00285   <a class="code" href="namespaceThreads.php#a5957a49c5a5b3a757b655cb6f8a2d933">Threads::parallel_reduce</a> (<a class="code" href="classStoredRange.php">ConstNodeRange</a> (mesh.<a class="code" href="classMeshBase.php#a2fcbe0fe5068603530d34543033c9e5b">pid_nodes_begin</a>(<a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>),
<a name="l00286"></a>00286                                             mesh.<a class="code" href="classMeshBase.php#abff909aecd7e32786f49646fee5ae4a1">pid_nodes_end</a>(<a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>)),
<a name="l00287"></a>00287                             find_bbox);
<a name="l00288"></a>00288 
<a name="l00289"></a>00289   <span class="comment">// Compare the bounding boxes across processors</span>
<a name="l00290"></a>00290   <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(find_bbox.min());
<a name="l00291"></a>00291   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(find_bbox.max());
<a name="l00292"></a>00292 
<a name="l00293"></a>00293   <span class="keywordflow">return</span> find_bbox.bbox();
<a name="l00294"></a>00294 }
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 
<a name="l00297"></a>00297 
<a name="l00298"></a>00298 <a class="code" href="classSphere.php">Sphere</a>
<a name="l00299"></a><a class="code" href="namespaceMeshTools.php#a535977af7ac146991ee577adc585b810">00299</a> <a class="code" href="namespaceMeshTools.php#a535977af7ac146991ee577adc585b810">MeshTools::bounding_sphere</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh)
<a name="l00300"></a>00300 {
<a name="l00301"></a>00301   <a class="code" href="classMeshTools_1_1BoundingBox.php">BoundingBox</a> bbox = <a class="code" href="namespaceMeshTools.php#ad533681876e9809cfe5e2114886b1c03">bounding_box</a>(mesh);
<a name="l00302"></a>00302 
<a name="l00303"></a>00303   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>  diag = (bbox.second - bbox.first).size();
<a name="l00304"></a>00304   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> cent = (bbox.second + bbox.first)/2.;
<a name="l00305"></a>00305 
<a name="l00306"></a>00306   <span class="keywordflow">return</span> <a class="code" href="classSphere.php">Sphere</a> (cent, .5*diag);
<a name="l00307"></a>00307 }
<a name="l00308"></a>00308 
<a name="l00309"></a>00309 
<a name="l00310"></a>00310 
<a name="l00311"></a>00311 <a class="code" href="classMeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a>
<a name="l00312"></a><a class="code" href="namespaceMeshTools.php#a2bdd431bdb400efd4a5ddafc9a63532f">00312</a> <a class="code" href="namespaceMeshTools.php#a2bdd431bdb400efd4a5ddafc9a63532f">MeshTools::processor_bounding_box</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00313"></a>00313                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid)
<a name="l00314"></a>00314 {
<a name="l00315"></a>00315   libmesh_assert (pid &lt; <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00316"></a>00316 
<a name="l00317"></a>00317   FindBBox find_bbox;
<a name="l00318"></a>00318   
<a name="l00319"></a>00319   <a class="code" href="namespaceThreads.php#a5957a49c5a5b3a757b655cb6f8a2d933">Threads::parallel_reduce</a> (<a class="code" href="classStoredRange.php">ConstElemRange</a> (mesh.<a class="code" href="classMeshBase.php#aa8cbd1381e63c4c468292c1275497724">pid_elements_begin</a>(pid),
<a name="l00320"></a>00320                                             mesh.<a class="code" href="classMeshBase.php#a2fa21ec41ad9c25eb2617fca513bca5d">pid_elements_end</a>(pid)),
<a name="l00321"></a>00321                             find_bbox);
<a name="l00322"></a>00322   
<a name="l00323"></a>00323   <span class="keywordflow">return</span> find_bbox.bbox();
<a name="l00324"></a>00324 }
<a name="l00325"></a>00325 
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 <a class="code" href="classSphere.php">Sphere</a>
<a name="l00329"></a><a class="code" href="namespaceMeshTools.php#a53e25707943fd10db85e74bd2ab7480e">00329</a> <a class="code" href="namespaceMeshTools.php#a53e25707943fd10db85e74bd2ab7480e">MeshTools::processor_bounding_sphere</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00330"></a>00330                                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid)
<a name="l00331"></a>00331 {
<a name="l00332"></a>00332   <a class="code" href="classMeshTools_1_1BoundingBox.php">BoundingBox</a> bbox = <a class="code" href="namespaceMeshTools.php#a2bdd431bdb400efd4a5ddafc9a63532f">processor_bounding_box</a>(mesh,pid);
<a name="l00333"></a>00333 
<a name="l00334"></a>00334   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>  diag = (bbox.second - bbox.first).size();
<a name="l00335"></a>00335   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> cent = (bbox.second + bbox.first)/2.;
<a name="l00336"></a>00336 
<a name="l00337"></a>00337   <span class="keywordflow">return</span> <a class="code" href="classSphere.php">Sphere</a> (cent, .5*diag);
<a name="l00338"></a>00338 }
<a name="l00339"></a>00339 
<a name="l00340"></a>00340 
<a name="l00341"></a>00341 
<a name="l00342"></a>00342 <a class="code" href="classMeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a>
<a name="l00343"></a><a class="code" href="namespaceMeshTools.php#a5c09fb16b47c708e7e712d950812d39a">00343</a> <a class="code" href="namespaceMeshTools.php#a5c09fb16b47c708e7e712d950812d39a">MeshTools::subdomain_bounding_box</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00344"></a>00344                                    <span class="keyword">const</span> <a class="code" href="classTestClass.php">subdomain_id_type</a> sid)
<a name="l00345"></a>00345 {
<a name="l00346"></a>00346   libmesh_assert (mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>() != 0);
<a name="l00347"></a>00347 
<a name="l00348"></a>00348   <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>( 1.e30,  1.e30,  1.e30);
<a name="l00349"></a>00349   <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(-1.e30, -1.e30, -1.e30);
<a name="l00350"></a>00350 
<a name="l00351"></a>00351   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;mesh.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>(); e++)
<a name="l00352"></a>00352     <span class="keywordflow">if</span> (mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(e)-&gt;<a class="code" href="classElem.php#acc4746605aad9169ad38cfd0b9b97123">subdomain_id</a>() == sid)
<a name="l00353"></a>00353       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(e)-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); n++)
<a name="l00354"></a>00354         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;mesh.<a class="code" href="classMeshBase.php#acaf87bde8c96b91d8f355dc9ebb72f5f">spatial_dimension</a>(); i++)
<a name="l00355"></a>00355           {
<a name="l00356"></a>00356             <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(i) = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(i), mesh.<a class="code" href="classMeshBase.php#a06af1f178519c606d0bdca7857f95ba6">point</a>(mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(e)-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n))(i));
<a name="l00357"></a>00357             <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(i) = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(<a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(i), mesh.<a class="code" href="classMeshBase.php#a06af1f178519c606d0bdca7857f95ba6">point</a>(mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(e)-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n))(i));
<a name="l00358"></a>00358           }      
<a name="l00359"></a>00359   
<a name="l00360"></a>00360   <span class="keywordflow">return</span> <a class="code" href="classMeshTools_1_1BoundingBox.php">BoundingBox</a> (min, max);
<a name="l00361"></a>00361 }
<a name="l00362"></a>00362 
<a name="l00363"></a>00363 
<a name="l00364"></a>00364 
<a name="l00365"></a>00365 <a class="code" href="classSphere.php">Sphere</a>
<a name="l00366"></a><a class="code" href="namespaceMeshTools.php#a941ef83f5e28b5c11e59987041cb266e">00366</a> <a class="code" href="namespaceMeshTools.php#a941ef83f5e28b5c11e59987041cb266e">MeshTools::subdomain_bounding_sphere</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00367"></a>00367                                       <span class="keyword">const</span> <a class="code" href="classTestClass.php">subdomain_id_type</a> sid)
<a name="l00368"></a>00368 {
<a name="l00369"></a>00369   <a class="code" href="classMeshTools_1_1BoundingBox.php">BoundingBox</a> bbox = <a class="code" href="namespaceMeshTools.php#a5c09fb16b47c708e7e712d950812d39a">subdomain_bounding_box</a>(mesh,sid);
<a name="l00370"></a>00370 
<a name="l00371"></a>00371   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>  diag = (bbox.second - bbox.first).size();
<a name="l00372"></a>00372   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> cent = (bbox.second + bbox.first)/2.;
<a name="l00373"></a>00373 
<a name="l00374"></a>00374   <span class="keywordflow">return</span> <a class="code" href="classSphere.php">Sphere</a> (cent, .5*diag);
<a name="l00375"></a>00375 }
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 
<a name="l00379"></a><a class="code" href="namespaceMeshTools.php#a907bdeb4ae9c2d6a780e85bde894e731">00379</a> <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a907bdeb4ae9c2d6a780e85bde894e731">MeshTools::elem_types</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00380"></a>00380                             std::vector&lt;ElemType&gt;&amp; et)
<a name="l00381"></a>00381 {
<a name="l00382"></a>00382   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el  = mesh.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00383"></a>00383   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>(); 
<a name="l00384"></a>00384 
<a name="l00385"></a>00385   <span class="comment">// Automatically get the first type</span>
<a name="l00386"></a>00386   et.push_back((*el)-&gt;type());  ++el;
<a name="l00387"></a>00387 
<a name="l00388"></a>00388   <span class="comment">// Loop over the rest of the elements.</span>
<a name="l00389"></a>00389   <span class="comment">// If the current element type isn&#39;t in the</span>
<a name="l00390"></a>00390   <span class="comment">// vector, insert it.</span>
<a name="l00391"></a>00391   <span class="keywordflow">for</span> (; el != end; ++el)
<a name="l00392"></a>00392     <span class="keywordflow">if</span> (!std::count(et.begin(), et.end(), (*el)-&gt;type()))
<a name="l00393"></a>00393       et.push_back((*el)-&gt;type());
<a name="l00394"></a>00394 }
<a name="l00395"></a>00395 
<a name="l00396"></a>00396 
<a name="l00397"></a>00397 
<a name="l00398"></a><a class="code" href="namespaceMeshTools.php#ad3ca1fc8a6437d31b6c7b28d687e7fee">00398</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#ad3ca1fc8a6437d31b6c7b28d687e7fee">MeshTools::n_elem_of_type</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00399"></a>00399                                         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)
<a name="l00400"></a>00400 {
<a name="l00401"></a>00401   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(std::distance(mesh.<a class="code" href="classMeshBase.php#a3943f62e4a9bc0290d1c2a01251cf257">type_elements_begin</a>(type),
<a name="l00402"></a>00402                                                  mesh.<a class="code" href="classMeshBase.php#a5c675c2c62ad6b627778687cc3443bcf">type_elements_end</a>  (type)));
<a name="l00403"></a>00403 }
<a name="l00404"></a>00404 
<a name="l00405"></a>00405 
<a name="l00406"></a>00406 
<a name="l00407"></a><a class="code" href="namespaceMeshTools.php#a3449fb3ff9f5d7770b02bec93b778bef">00407</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a3449fb3ff9f5d7770b02bec93b778bef">MeshTools::n_active_elem_of_type</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00408"></a>00408                                                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)
<a name="l00409"></a>00409 {
<a name="l00410"></a>00410   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(std::distance(mesh.<a class="code" href="classMeshBase.php#aa49bba401e1509f93912bf56ca5532b0">active_type_elements_begin</a>(type),
<a name="l00411"></a>00411                                                  mesh.<a class="code" href="classMeshBase.php#a6d51a49cc54a4734c02f39c5a4511191">active_type_elements_end</a>  (type)));
<a name="l00412"></a>00412 }
<a name="l00413"></a>00413 
<a name="l00414"></a><a class="code" href="namespaceMeshTools.php#a115b9be300720c24bb023ab767245937">00414</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a115b9be300720c24bb023ab767245937">MeshTools::n_non_subactive_elem_of_type_at_level</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00415"></a>00415                                                 <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type,
<a name="l00416"></a>00416                                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)
<a name="l00417"></a>00417 {
<a name="l00418"></a>00418   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt = 0;
<a name="l00419"></a>00419   <span class="comment">// iterate over the elements of the specified type</span>
<a name="l00420"></a>00420   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el = mesh.<a class="code" href="classMeshBase.php#a3943f62e4a9bc0290d1c2a01251cf257">type_elements_begin</a>(type);
<a name="l00421"></a>00421   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a5c675c2c62ad6b627778687cc3443bcf">type_elements_end</a>(type);
<a name="l00422"></a>00422 
<a name="l00423"></a>00423   <span class="keywordflow">for</span>(; el!=end; ++el)
<a name="l00424"></a>00424     <span class="keywordflow">if</span>( ((*el)-&gt;level() == level) &amp;&amp; !(*el)-&gt;subactive())
<a name="l00425"></a>00425       cnt++;
<a name="l00426"></a>00426 
<a name="l00427"></a>00427   <span class="keywordflow">return</span> cnt;
<a name="l00428"></a>00428 }
<a name="l00429"></a>00429 
<a name="l00430"></a>00430 
<a name="l00431"></a><a class="code" href="namespaceMeshTools.php#ad90de59c6df96299aa4873e92e69bd94">00431</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#ad90de59c6df96299aa4873e92e69bd94">MeshTools::n_active_local_levels</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh)
<a name="l00432"></a>00432 {
<a name="l00433"></a>00433   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#aa7528fd4ca1533ce837c7aedc6a9a108">max_level</a> = 0;
<a name="l00434"></a>00434 
<a name="l00435"></a>00435   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el = mesh.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00436"></a>00436   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = mesh.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>();
<a name="l00437"></a>00437 
<a name="l00438"></a>00438   <span class="keywordflow">for</span>( ; el != end_el; ++el)
<a name="l00439"></a>00439     max_level = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>((*el)-&gt;level(), <a class="code" href="namespaceMeshTools.php#aa7528fd4ca1533ce837c7aedc6a9a108">max_level</a>);
<a name="l00440"></a>00440 
<a name="l00441"></a>00441   <span class="keywordflow">return</span> max_level + 1;
<a name="l00442"></a>00442 }
<a name="l00443"></a>00443 
<a name="l00444"></a>00444 
<a name="l00445"></a>00445 
<a name="l00446"></a><a class="code" href="namespaceMeshTools.php#ac7347516a0e8d16e18b72870f87bfac9">00446</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#ac7347516a0e8d16e18b72870f87bfac9">MeshTools::n_active_levels</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh)
<a name="l00447"></a>00447 {
<a name="l00448"></a>00448   parallel_only();
<a name="l00449"></a>00449 
<a name="l00450"></a>00450   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nl = <a class="code" href="namespaceMeshTools.php#ad90de59c6df96299aa4873e92e69bd94">MeshTools::n_active_local_levels</a>(mesh);
<a name="l00451"></a>00451 
<a name="l00452"></a>00452   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el =
<a name="l00453"></a>00453     mesh.<a class="code" href="classMeshBase.php#af00e2afee8c81f0058853ca412abfd03">unpartitioned_elements_begin</a>();
<a name="l00454"></a>00454   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el =
<a name="l00455"></a>00455     mesh.<a class="code" href="classMeshBase.php#a0fa23d043576937cd8ab9430a6608409">unpartitioned_elements_end</a>();
<a name="l00456"></a>00456 
<a name="l00457"></a>00457   <span class="keywordflow">for</span>( ; el != end_el; ++el)
<a name="l00458"></a>00458     <span class="keywordflow">if</span> ((*el)-&gt;active())
<a name="l00459"></a>00459       nl = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>((*el)-&gt;level() + 1, nl);
<a name="l00460"></a>00460 
<a name="l00461"></a>00461   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(nl);
<a name="l00462"></a>00462   <span class="keywordflow">return</span> nl;
<a name="l00463"></a>00463 }
<a name="l00464"></a>00464 
<a name="l00465"></a>00465 
<a name="l00466"></a>00466 
<a name="l00467"></a><a class="code" href="namespaceMeshTools.php#a2d3e473958b98cab21275e75b75ed19b">00467</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a2d3e473958b98cab21275e75b75ed19b">MeshTools::n_local_levels</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh)
<a name="l00468"></a>00468 {
<a name="l00469"></a>00469   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#aa7528fd4ca1533ce837c7aedc6a9a108">max_level</a> = 0;
<a name="l00470"></a>00470 
<a name="l00471"></a>00471   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el = mesh.<a class="code" href="classMeshBase.php#a85cb016589044fbc17fd9d3ce138f1b6">local_elements_begin</a>();
<a name="l00472"></a>00472   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = mesh.<a class="code" href="classMeshBase.php#a8184d52812b82a9a38b66a0c89f04b17">local_elements_end</a>();
<a name="l00473"></a>00473 
<a name="l00474"></a>00474   <span class="keywordflow">for</span>( ; el != end_el; ++el)
<a name="l00475"></a>00475     max_level = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>((*el)-&gt;level(), <a class="code" href="namespaceMeshTools.php#aa7528fd4ca1533ce837c7aedc6a9a108">max_level</a>);
<a name="l00476"></a>00476 
<a name="l00477"></a>00477   <span class="keywordflow">return</span> max_level + 1;
<a name="l00478"></a>00478 }
<a name="l00479"></a>00479    
<a name="l00480"></a>00480 
<a name="l00481"></a>00481 
<a name="l00482"></a><a class="code" href="namespaceMeshTools.php#a467cd3c96ff9a03c0918d4df6ef16301">00482</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a467cd3c96ff9a03c0918d4df6ef16301">MeshTools::n_levels</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh)
<a name="l00483"></a>00483 {
<a name="l00484"></a>00484   parallel_only();
<a name="l00485"></a>00485 
<a name="l00486"></a>00486   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nl = <a class="code" href="namespaceMeshTools.php#a2d3e473958b98cab21275e75b75ed19b">MeshTools::n_local_levels</a>(mesh);
<a name="l00487"></a>00487 
<a name="l00488"></a>00488   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el =
<a name="l00489"></a>00489     mesh.<a class="code" href="classMeshBase.php#af00e2afee8c81f0058853ca412abfd03">unpartitioned_elements_begin</a>();
<a name="l00490"></a>00490   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el =
<a name="l00491"></a>00491     mesh.<a class="code" href="classMeshBase.php#a0fa23d043576937cd8ab9430a6608409">unpartitioned_elements_end</a>();
<a name="l00492"></a>00492 
<a name="l00493"></a>00493   <span class="keywordflow">for</span>( ; el != end_el; ++el)
<a name="l00494"></a>00494     nl = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>((*el)-&gt;level() + 1, nl);
<a name="l00495"></a>00495 
<a name="l00496"></a>00496   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(nl);
<a name="l00497"></a>00497   <span class="keywordflow">return</span> nl;
<a name="l00498"></a>00498 }
<a name="l00499"></a>00499 
<a name="l00500"></a>00500 
<a name="l00501"></a>00501 
<a name="l00502"></a><a class="code" href="namespaceMeshTools.php#adc92798ee497c203c0ba45f017bdd7ff">00502</a> <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#adc92798ee497c203c0ba45f017bdd7ff">MeshTools::get_not_subactive_node_ids</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00503"></a>00503     std::set&lt;unsigned int&gt;&amp; not_subactive_node_ids)
<a name="l00504"></a>00504 {
<a name="l00505"></a>00505   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el           = mesh.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00506"></a>00506   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = mesh.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00507"></a>00507   <span class="keywordflow">for</span>( ; el != end_el; ++el)
<a name="l00508"></a>00508   {
<a name="l00509"></a>00509     <a class="code" href="classElem.php">Elem</a>* elem = (*el);
<a name="l00510"></a>00510     <span class="keywordflow">if</span>(!elem-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>())
<a name="l00511"></a>00511       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); ++n)
<a name="l00512"></a>00512         not_subactive_node_ids.insert(elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n));
<a name="l00513"></a>00513   }
<a name="l00514"></a>00514 }
<a name="l00515"></a>00515 
<a name="l00516"></a>00516 
<a name="l00517"></a>00517 
<a name="l00518"></a><a class="code" href="namespaceMeshTools.php#a337ed123c95f0ba57b665456c413db4b">00518</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a337ed123c95f0ba57b665456c413db4b">MeshTools::n_elem</a> (<span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> &amp;begin,
<a name="l00519"></a>00519                                 <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> &amp;end)
<a name="l00520"></a>00520 {
<a name="l00521"></a>00521   <span class="keywordflow">return</span> std::distance(begin, end);
<a name="l00522"></a>00522 }
<a name="l00523"></a>00523 
<a name="l00524"></a>00524 
<a name="l00525"></a>00525 
<a name="l00526"></a><a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">00526</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">MeshTools::n_nodes</a> (<span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> &amp;begin,
<a name="l00527"></a>00527                                  <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> &amp;end)
<a name="l00528"></a>00528 {
<a name="l00529"></a>00529   <span class="keywordflow">return</span> std::distance(begin, end);
<a name="l00530"></a>00530 }
<a name="l00531"></a>00531    
<a name="l00532"></a>00532 
<a name="l00533"></a>00533 
<a name="l00534"></a><a class="code" href="namespaceMeshTools.php#a7c26061d17e6cbc7122fe92b8d349772">00534</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a7c26061d17e6cbc7122fe92b8d349772">MeshTools::n_p_levels</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh)
<a name="l00535"></a>00535 {
<a name="l00536"></a>00536   parallel_only();
<a name="l00537"></a>00537   
<a name="l00538"></a>00538   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_p_level = 0;
<a name="l00539"></a>00539 
<a name="l00540"></a>00540   <span class="comment">// first my local elements</span>
<a name="l00541"></a>00541   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>
<a name="l00542"></a>00542     el     = mesh.<a class="code" href="classMeshBase.php#a85cb016589044fbc17fd9d3ce138f1b6">local_elements_begin</a>(),
<a name="l00543"></a>00543     end_el = mesh.<a class="code" href="classMeshBase.php#a8184d52812b82a9a38b66a0c89f04b17">local_elements_end</a>();
<a name="l00544"></a>00544 
<a name="l00545"></a>00545   <span class="keywordflow">for</span>( ; el != end_el; ++el)
<a name="l00546"></a>00546     max_p_level = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>((*el)-&gt;p_level(), max_p_level);
<a name="l00547"></a>00547 
<a name="l00548"></a>00548   <span class="comment">// then any unpartitioned objects</span>
<a name="l00549"></a>00549   el     = mesh.<a class="code" href="classMeshBase.php#af00e2afee8c81f0058853ca412abfd03">unpartitioned_elements_begin</a>();
<a name="l00550"></a>00550   end_el = mesh.<a class="code" href="classMeshBase.php#a0fa23d043576937cd8ab9430a6608409">unpartitioned_elements_end</a>();
<a name="l00551"></a>00551 
<a name="l00552"></a>00552   <span class="keywordflow">for</span>( ; el != end_el; ++el)
<a name="l00553"></a>00553     max_p_level = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>((*el)-&gt;p_level(), max_p_level);
<a name="l00554"></a>00554 
<a name="l00555"></a>00555   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(max_p_level);
<a name="l00556"></a>00556   <span class="keywordflow">return</span> max_p_level + 1;
<a name="l00557"></a>00557 }
<a name="l00558"></a>00558 
<a name="l00559"></a>00559 
<a name="l00560"></a>00560 
<a name="l00561"></a><a class="code" href="namespaceMeshTools.php#a78d702e60195186a26f1ae644696c735">00561</a> <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a78d702e60195186a26f1ae644696c735">MeshTools::find_nodal_neighbors</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp;, <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>&amp; n, 
<a name="l00562"></a>00562                                      std::vector&lt;std::vector&lt;const Elem*&gt; &gt;&amp; nodes_to_elem_map, 
<a name="l00563"></a>00563                                      std::vector&lt;const Node*&gt;&amp; neighbors)
<a name="l00564"></a>00564 {
<a name="l00565"></a>00565   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_id = n.<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l00566"></a>00566   
<a name="l00567"></a>00567   <span class="comment">//Iterators to iterate through the elements that include this node</span>
<a name="l00568"></a>00568   std::vector&lt;const Elem*&gt;::const_iterator el     = nodes_to_elem_map[global_id].begin();
<a name="l00569"></a>00569   std::vector&lt;const Elem*&gt;::const_iterator end_el = nodes_to_elem_map[global_id].end();
<a name="l00570"></a>00570   
<a name="l00571"></a>00571   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_ed=0; <span class="comment">// Number of edges on the element</span>
<a name="l00572"></a>00572   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ed=0;   <span class="comment">// Current edge</span>
<a name="l00573"></a>00573   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l_n=0;  <span class="comment">// Local node number</span>
<a name="l00574"></a>00574   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> o_n=0;  <span class="comment">// Other node on this edge</span>
<a name="l00575"></a>00575   
<a name="l00576"></a>00576   <span class="comment">//Assume we find a edge... then prove ourselves wrong...</span>
<a name="l00577"></a>00577   <span class="keywordtype">bool</span> found_edge=<span class="keyword">true</span>;
<a name="l00578"></a>00578   
<a name="l00579"></a>00579   <a class="code" href="classNode.php">Node</a> * node_to_save = NULL;
<a name="l00580"></a>00580   
<a name="l00581"></a>00581   <span class="comment">//Look through the elements that contain this node</span>
<a name="l00582"></a>00582   <span class="comment">//find the local node id... then find the side that</span>
<a name="l00583"></a>00583   <span class="comment">//node lives on in the element</span>
<a name="l00584"></a>00584   <span class="comment">//next, look for the _other_ node on that side</span>
<a name="l00585"></a>00585   <span class="comment">//That other node is a &quot;nodal_neighbor&quot;... save it</span>
<a name="l00586"></a>00586   <span class="keywordflow">for</span>(;el != end_el;el++)
<a name="l00587"></a>00587   {
<a name="l00588"></a>00588     <span class="comment">//We only care about active elements...</span>
<a name="l00589"></a>00589     <span class="keywordflow">if</span>((*el)-&gt;active())
<a name="l00590"></a>00590     {
<a name="l00591"></a>00591       n_ed=(*el)-&gt;n_edges();
<a name="l00592"></a>00592       
<a name="l00593"></a>00593       <span class="comment">//Find the local node id</span>
<a name="l00594"></a>00594       <span class="keywordflow">while</span>(global_id != (*el)-&gt;node(l_n++)) { }
<a name="l00595"></a>00595       l_n--; <span class="comment">//Hmmm... take the last one back off</span>
<a name="l00596"></a>00596       
<a name="l00597"></a>00597       <span class="keywordflow">while</span>(ed&lt;n_ed)
<a name="l00598"></a>00598       {
<a name="l00599"></a>00599         
<a name="l00600"></a>00600         <span class="comment">//Find the edge the node is on</span>
<a name="l00601"></a>00601         <span class="keywordflow">while</span>(found_edge &amp;&amp; !(*el)-&gt;is_node_on_edge(l_n,ed++))
<a name="l00602"></a>00602         {
<a name="l00603"></a>00603           <span class="comment">//This only happens if all the edges have already been found</span>
<a name="l00604"></a>00604           <span class="keywordflow">if</span>(ed&gt;=n_ed)
<a name="l00605"></a>00605             found_edge=<span class="keyword">false</span>;
<a name="l00606"></a>00606         }
<a name="l00607"></a>00607         
<a name="l00608"></a>00608         <span class="comment">//Did we find one?</span>
<a name="l00609"></a>00609         <span class="keywordflow">if</span>(found_edge)
<a name="l00610"></a>00610         {
<a name="l00611"></a>00611           ed--; <span class="comment">//Take the last one back off again</span>
<a name="l00612"></a>00612           
<a name="l00613"></a>00613           <span class="comment">//Now find the other node on that edge</span>
<a name="l00614"></a>00614           <span class="keywordflow">while</span>(!(*el)-&gt;is_node_on_edge(o_n++,ed) || global_id==(*el)-&gt;node(o_n-1)) { }
<a name="l00615"></a>00615           o_n--;
<a name="l00616"></a>00616           
<a name="l00617"></a>00617           <span class="comment">//We&#39;ve found one!  Save it..</span>
<a name="l00618"></a>00618           node_to_save=(*el)-&gt;get_node(o_n);
<a name="l00619"></a>00619           
<a name="l00620"></a>00620           <span class="comment">//Search to see if we&#39;ve already found this one</span>
<a name="l00621"></a>00621           std::vector&lt;const Node*&gt;::const_iterator result = std::find(neighbors.begin(),neighbors.end(),node_to_save);
<a name="l00622"></a>00622           
<a name="l00623"></a>00623           <span class="comment">//If we didn&#39;t find it and add it to the vector</span>
<a name="l00624"></a>00624           <span class="keywordflow">if</span>(result == neighbors.end())
<a name="l00625"></a>00625             neighbors.push_back(node_to_save);
<a name="l00626"></a>00626         }
<a name="l00627"></a>00627         
<a name="l00628"></a>00628         <span class="comment">//Reset to look for another</span>
<a name="l00629"></a>00629         o_n=0;
<a name="l00630"></a>00630         
<a name="l00631"></a>00631         <span class="comment">//Keep looking for edges, node may be on more than one edge</span>
<a name="l00632"></a>00632         ed++;
<a name="l00633"></a>00633       }
<a name="l00634"></a>00634       
<a name="l00635"></a>00635       <span class="comment">//Reset to get ready for the next element</span>
<a name="l00636"></a>00636       l_n=ed=0;
<a name="l00637"></a>00637       found_edge=<span class="keyword">true</span>;
<a name="l00638"></a>00638     }
<a name="l00639"></a>00639   }
<a name="l00640"></a>00640 }
<a name="l00641"></a>00641 
<a name="l00642"></a><a class="code" href="namespaceMeshTools.php#a0deba4a0a21e80c0abb5c1e279244db9">00642</a> <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a0deba4a0a21e80c0abb5c1e279244db9">MeshTools::find_hanging_nodes_and_parents</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh, std::map&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, std::vector&lt;unsigned int&gt; &gt;&amp; hanging_nodes)
<a name="l00643"></a>00643 {
<a name="l00644"></a>00644   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> it  = mesh.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00645"></a>00645   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>();
<a name="l00646"></a>00646   
<a name="l00647"></a>00647   <span class="comment">//Loop through all the elements</span>
<a name="l00648"></a>00648   <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00649"></a>00649   {
<a name="l00650"></a>00650     <span class="comment">//Save it off for easier access</span>
<a name="l00651"></a>00651     <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = (*it);
<a name="l00652"></a>00652     
<a name="l00653"></a>00653     <span class="comment">//Right now this only works for quad4&#39;s</span>
<a name="l00654"></a>00654     <span class="comment">//libmesh_assert(elem-&gt;type() == libMeshEnums::QUAD4);</span>
<a name="l00655"></a>00655     <span class="keywordflow">if</span>(elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">libMeshEnums::QUAD4</a>)
<a name="l00656"></a>00656     {
<a name="l00657"></a>00657       <span class="comment">//Loop over the sides looking for sides that have hanging nodes</span>
<a name="l00658"></a>00658       <span class="comment">//This code is inspired by compute_proj_constraints()</span>
<a name="l00659"></a>00659       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>(); s++)
<a name="l00660"></a>00660       {
<a name="l00661"></a>00661         <span class="comment">//If not a boundary node</span>
<a name="l00662"></a>00662         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s) != NULL)
<a name="l00663"></a>00663         {
<a name="l00664"></a>00664           <span class="comment">// Get pointers to the element&#39;s neighbor.</span>
<a name="l00665"></a>00665           <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* neigh = elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s);
<a name="l00666"></a>00666           
<a name="l00667"></a>00667           <span class="comment">//Is there a coarser element next to this one?</span>
<a name="l00668"></a>00668           <span class="keywordflow">if</span> (neigh-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() &lt; elem-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>()) 
<a name="l00669"></a>00669           {
<a name="l00670"></a>00670             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *ancestor = elem;
<a name="l00671"></a>00671             <span class="keywordflow">while</span> (neigh-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() &lt; ancestor-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>())
<a name="l00672"></a>00672               ancestor = ancestor-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>();
<a name="l00673"></a>00673             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s_neigh = neigh-&gt;<a class="code" href="classElem.php#acab8fea073846b18b149ed2b88d43aff">which_neighbor_am_i</a>(ancestor);
<a name="l00674"></a>00674             libmesh_assert (s_neigh &lt; neigh-&gt;n_neighbors());
<a name="l00675"></a>00675             
<a name="l00676"></a>00676             <span class="comment">//Couple of helper uints...</span>
<a name="l00677"></a>00677             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node1=0;
<a name="l00678"></a>00678             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node2=0;
<a name="l00679"></a>00679             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> hanging_node=0;
<a name="l00680"></a>00680                 
<a name="l00681"></a>00681             <span class="keywordtype">bool</span> found_in_neighbor = <span class="keyword">false</span>;
<a name="l00682"></a>00682                 
<a name="l00683"></a>00683             <span class="comment">//Find the two vertices that make up this side</span>
<a name="l00684"></a>00684             <span class="keywordflow">while</span>(!elem-&gt;<a class="code" href="classElem.php#a85c5162cacd439d80d2262dec568c87a">is_node_on_side</a>(node1++,s)) { }
<a name="l00685"></a>00685             node1--;
<a name="l00686"></a>00686                 
<a name="l00687"></a>00687                 <span class="comment">//Start looking for the second one with the next node</span>
<a name="l00688"></a>00688             node2=node1+1;
<a name="l00689"></a>00689             
<a name="l00690"></a>00690             <span class="comment">//Find the other one</span>
<a name="l00691"></a>00691             <span class="keywordflow">while</span>(!elem-&gt;<a class="code" href="classElem.php#a85c5162cacd439d80d2262dec568c87a">is_node_on_side</a>(node2++,s)) { }
<a name="l00692"></a>00692             node2--;
<a name="l00693"></a>00693   
<a name="l00694"></a>00694                 <span class="comment">//Pull out their global ids:</span>
<a name="l00695"></a>00695             node1 = elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(node1);
<a name="l00696"></a>00696             node2 = elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(node2);
<a name="l00697"></a>00697             
<a name="l00698"></a>00698             <span class="comment">//Now find which node is present in the neighbor</span>
<a name="l00699"></a>00699             <span class="comment">//FIXME This assumes a level one rule!</span>
<a name="l00700"></a>00700             <span class="comment">//The _other_ one is the hanging node</span>
<a name="l00701"></a>00701             
<a name="l00702"></a>00702             <span class="comment">//First look for the first one</span>
<a name="l00703"></a>00703             <span class="comment">//FIXME could be streamlined a bit</span>
<a name="l00704"></a>00704             <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0;n&lt;neigh-&gt;<a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>();n++)
<a name="l00705"></a>00705             {
<a name="l00706"></a>00706               <span class="keywordflow">if</span>(neigh-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n) == node1)
<a name="l00707"></a>00707                 found_in_neighbor=<span class="keyword">true</span>;
<a name="l00708"></a>00708             }
<a name="l00709"></a>00709                 
<a name="l00710"></a>00710                 
<a name="l00711"></a>00711             <span class="keywordflow">if</span>(!found_in_neighbor)
<a name="l00712"></a>00712               hanging_node=node1;
<a name="l00713"></a>00713             <span class="keywordflow">else</span> <span class="comment">//If it wasn&#39;t node1 then it must be node2!</span>
<a name="l00714"></a>00714               hanging_node=node2;
<a name="l00715"></a>00715             
<a name="l00716"></a>00716             <span class="comment">//Reset these for reuse</span>
<a name="l00717"></a>00717             node1=0;
<a name="l00718"></a>00718             node2=0;
<a name="l00719"></a>00719             
<a name="l00720"></a>00720             <span class="comment">//Find the first node that makes up the side in the neighbor (these should be the parent nodes)</span>
<a name="l00721"></a>00721             <span class="keywordflow">while</span>(!neigh-&gt;<a class="code" href="classElem.php#a85c5162cacd439d80d2262dec568c87a">is_node_on_side</a>(node1++,s_neigh)) { }
<a name="l00722"></a>00722             node1--;
<a name="l00723"></a>00723                 
<a name="l00724"></a>00724             node2=node1+1;
<a name="l00725"></a>00725             
<a name="l00726"></a>00726             <span class="comment">//Find the second node...</span>
<a name="l00727"></a>00727             <span class="keywordflow">while</span>(!neigh-&gt;<a class="code" href="classElem.php#a85c5162cacd439d80d2262dec568c87a">is_node_on_side</a>(node2++,s_neigh)) { }
<a name="l00728"></a>00728             node2--;
<a name="l00729"></a>00729             
<a name="l00730"></a>00730             <span class="comment">//Save them if we haven&#39;t already found the parents for this one</span>
<a name="l00731"></a>00731             <span class="keywordflow">if</span>(hanging_nodes[hanging_node].size()&lt;2)
<a name="l00732"></a>00732             {
<a name="l00733"></a>00733               hanging_nodes[hanging_node].push_back(neigh-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(node1));
<a name="l00734"></a>00734               hanging_nodes[hanging_node].push_back(neigh-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(node2));
<a name="l00735"></a>00735             }
<a name="l00736"></a>00736           }
<a name="l00737"></a>00737         }
<a name="l00738"></a>00738       }
<a name="l00739"></a>00739     }
<a name="l00740"></a>00740   }
<a name="l00741"></a>00741 }
<a name="l00742"></a>00742 
<a name="l00743"></a>00743 
<a name="l00744"></a>00744 
<a name="l00745"></a>00745 <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a0ce5caf2cff3d386fe0906e09c052c91">MeshTools::correct_node_proc_ids</a>
<a name="l00746"></a><a class="code" href="namespaceMeshTools.php#a0ce5caf2cff3d386fe0906e09c052c91">00746</a>   (<a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00747"></a>00747    <a class="code" href="classLocationMap.php">LocationMap&lt;Node&gt;</a> &amp;loc_map)
<a name="l00748"></a>00748 {
<a name="l00749"></a>00749   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00750"></a>00750   parallel_only();
<a name="l00751"></a>00751 
<a name="l00752"></a>00752   <span class="comment">// We&#39;ll need the new_nodes_map to answer other processors&#39;</span>
<a name="l00753"></a>00753   <span class="comment">// requests.  It should never be empty unless we don&#39;t have any</span>
<a name="l00754"></a>00754   <span class="comment">// nodes.</span>
<a name="l00755"></a>00755   libmesh_assert(mesh.<a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>() == mesh.<a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>() ||
<a name="l00756"></a>00756                  !loc_map.<a class="code" href="classLocationMap.php#a4517c7633d5d724f8666fefc8220b408">empty</a>());
<a name="l00757"></a>00757 
<a name="l00758"></a>00758   <span class="comment">// Fix all nodes&#39; processor ids.  Coarsening may have left us with</span>
<a name="l00759"></a>00759   <span class="comment">// nodes which are no longer touched by any elements of the same</span>
<a name="l00760"></a>00760   <span class="comment">// processor id, and for DofMap to work we need to fix that.</span>
<a name="l00761"></a>00761 
<a name="l00762"></a>00762   <span class="comment">// In the first pass, invalidate processor ids for nodes on active</span>
<a name="l00763"></a>00763   <span class="comment">// elements.  We avoid touching subactive-only nodes.</span>
<a name="l00764"></a>00764   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       e_it  = mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00765"></a>00765   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> e_end = mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>();
<a name="l00766"></a>00766   <span class="keywordflow">for</span> (; e_it != e_end; ++e_it)
<a name="l00767"></a>00767     {
<a name="l00768"></a>00768       <a class="code" href="classElem.php">Elem</a> *elem = *e_it;
<a name="l00769"></a>00769       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n != elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); ++n)
<a name="l00770"></a>00770         {
<a name="l00771"></a>00771           <a class="code" href="classNode.php">Node</a> *node = elem-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(n);
<a name="l00772"></a>00772           node-&gt;<a class="code" href="classDofObject.php#aca6ecb4f00416a9682d3912ecce7c867">invalidate_processor_id</a>();
<a name="l00773"></a>00773         }
<a name="l00774"></a>00774     }
<a name="l00775"></a>00775 
<a name="l00776"></a>00776   <span class="comment">// In the second pass, find the lowest processor ids on active</span>
<a name="l00777"></a>00777   <span class="comment">// elements touching each node, and set the node processor id.</span>
<a name="l00778"></a>00778   <span class="keywordflow">for</span> (e_it = mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>(); e_it != e_end; ++e_it)
<a name="l00779"></a>00779     {
<a name="l00780"></a>00780       <a class="code" href="classElem.php">Elem</a> *elem = *e_it;
<a name="l00781"></a>00781       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id = elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>();
<a name="l00782"></a>00782       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n != elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); ++n)
<a name="l00783"></a>00783         {
<a name="l00784"></a>00784           <a class="code" href="classNode.php">Node</a> *node = elem-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(n);
<a name="l00785"></a>00785           <span class="keywordflow">if</span> (node-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() == <a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a> ||
<a name="l00786"></a>00786               node-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() &gt; proc_id)
<a name="l00787"></a>00787             node-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() = proc_id;
<a name="l00788"></a>00788         }
<a name="l00789"></a>00789     }
<a name="l00790"></a>00790 
<a name="l00791"></a>00791   <span class="comment">// Those two passes will correct every node that touches a local</span>
<a name="l00792"></a>00792   <span class="comment">// element, but we can&#39;t be sure about nodes touching remote</span>
<a name="l00793"></a>00793   <span class="comment">// elements.  Fix those now.</span>
<a name="l00794"></a>00794   <a class="code" href="classMeshCommunication.php">MeshCommunication</a>().<a class="code" href="classMeshCommunication.php#a663092448c5bc3a969eadbd6a002ce43">make_node_proc_ids_parallel_consistent</a>
<a name="l00795"></a>00795     (mesh, loc_map);
<a name="l00796"></a>00796 }
<a name="l00797"></a>00797 
<a name="l00798"></a>00798 
<a name="l00799"></a>00799 
<a name="l00800"></a>00800 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00801"></a><a class="code" href="namespaceMeshTools.php#a36e87521b260afd4f9e6663bdaaec414">00801</a> <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a36e87521b260afd4f9e6663bdaaec414">MeshTools::libmesh_assert_valid_node_pointers</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh)
<a name="l00802"></a>00802 {
<a name="l00803"></a>00803   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el_end =
<a name="l00804"></a>00804     mesh.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00805"></a>00805   <span class="keywordflow">for</span> (<a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el = 
<a name="l00806"></a>00806        mesh.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>(); el != el_end; ++el)
<a name="l00807"></a>00807     {
<a name="l00808"></a>00808       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *el;
<a name="l00809"></a>00809       libmesh_assert (elem);
<a name="l00810"></a>00810       <span class="keywordflow">while</span> (elem)
<a name="l00811"></a>00811         {
<a name="l00812"></a>00812           elem-&gt;<a class="code" href="classElem.php#a527c92ecb5322b14ef5649c3970cab87">libmesh_assert_valid_node_pointers</a>();
<a name="l00813"></a>00813           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n != elem-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); ++n)
<a name="l00814"></a>00814             <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(n) &amp;&amp;
<a name="l00815"></a>00815                 elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(n) != <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>)
<a name="l00816"></a>00816               elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(n)-&gt;<a class="code" href="classElem.php#a527c92ecb5322b14ef5649c3970cab87">libmesh_assert_valid_node_pointers</a>();
<a name="l00817"></a>00817             
<a name="l00818"></a>00818           libmesh_assert (elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>() != <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>);
<a name="l00819"></a>00819           elem = elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>();
<a name="l00820"></a>00820         }
<a name="l00821"></a>00821     }
<a name="l00822"></a>00822 }
<a name="l00823"></a>00823 
<a name="l00824"></a>00824 
<a name="l00825"></a><a class="code" href="namespaceMeshTools.php#a2304fff4874f07eec82a4fa173ac31fe">00825</a> <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a2304fff4874f07eec82a4fa173ac31fe">MeshTools::libmesh_assert_valid_remote_elems</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh)
<a name="l00826"></a>00826 {
<a name="l00827"></a>00827   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el_end =
<a name="l00828"></a>00828     mesh.<a class="code" href="classMeshBase.php#a8184d52812b82a9a38b66a0c89f04b17">local_elements_end</a>();
<a name="l00829"></a>00829   <span class="keywordflow">for</span> (<a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el = 
<a name="l00830"></a>00830        mesh.<a class="code" href="classMeshBase.php#a85cb016589044fbc17fd9d3ce138f1b6">local_elements_begin</a>(); el != el_end; ++el)
<a name="l00831"></a>00831     {
<a name="l00832"></a>00832       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *el;
<a name="l00833"></a>00833       libmesh_assert (elem);
<a name="l00834"></a>00834       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n != elem-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); ++n)
<a name="l00835"></a>00835         libmesh_assert (elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(n) != <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>);
<a name="l00836"></a>00836 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00837"></a>00837 <span class="preprocessor"></span>      <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* parent = elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>();
<a name="l00838"></a>00838       <span class="keywordflow">if</span> (parent)
<a name="l00839"></a>00839         {
<a name="l00840"></a>00840           libmesh_assert (parent != <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>);
<a name="l00841"></a>00841           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c != elem-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); ++c)
<a name="l00842"></a>00842             libmesh_assert (parent-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c) != <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>);
<a name="l00843"></a>00843         }
<a name="l00844"></a>00844 <span class="preprocessor">#endif</span>
<a name="l00845"></a>00845 <span class="preprocessor"></span>    }
<a name="l00846"></a>00846 }
<a name="l00847"></a>00847 
<a name="l00848"></a>00848 
<a name="l00849"></a><a class="code" href="namespaceMeshTools.php#a752dbbf1fd1febbe7cd636800e846df8">00849</a> <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a752dbbf1fd1febbe7cd636800e846df8">MeshTools::libmesh_assert_no_links_to_elem</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00850"></a>00850                                                 <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *bad_elem)
<a name="l00851"></a>00851 {
<a name="l00852"></a>00852   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el_end =
<a name="l00853"></a>00853     mesh.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00854"></a>00854   <span class="keywordflow">for</span> (<a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el = 
<a name="l00855"></a>00855        mesh.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>(); el != el_end; ++el)
<a name="l00856"></a>00856     {
<a name="l00857"></a>00857       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *el;
<a name="l00858"></a>00858       libmesh_assert (elem);
<a name="l00859"></a>00859       libmesh_assert (elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>() != bad_elem);
<a name="l00860"></a>00860       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n != elem-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); ++n)
<a name="l00861"></a>00861         libmesh_assert(elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(n) != bad_elem);
<a name="l00862"></a>00862 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00863"></a>00863 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a2ff2cfd3b4b05b8f091ba91eb068f81c">has_children</a>())
<a name="l00864"></a>00864         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c != elem-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); ++c)
<a name="l00865"></a>00865           libmesh_assert(elem-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c) != bad_elem);
<a name="l00866"></a>00866 <span class="preprocessor">#endif</span>
<a name="l00867"></a>00867 <span class="preprocessor"></span>    }
<a name="l00868"></a>00868 }
<a name="l00869"></a>00869 
<a name="l00870"></a>00870 
<a name="l00871"></a>00871 
<a name="l00872"></a><a class="code" href="namespaceMeshTools.php#a2fd26b4502cbdc994e60136839a6d101">00872</a> <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a2fd26b4502cbdc994e60136839a6d101">MeshTools::libmesh_assert_valid_elem_ids</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh)
<a name="l00873"></a>00873 {
<a name="l00874"></a>00874   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> lastprocid = 0;
<a name="l00875"></a>00875   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> lastelemid = 0;
<a name="l00876"></a>00876 
<a name="l00877"></a>00877   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el_end =
<a name="l00878"></a>00878     mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>();
<a name="l00879"></a>00879   <span class="keywordflow">for</span> (<a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el = 
<a name="l00880"></a>00880        mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>(); el != el_end; ++el)
<a name="l00881"></a>00881     {
<a name="l00882"></a>00882       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *el;
<a name="l00883"></a>00883       libmesh_assert (elem);
<a name="l00884"></a>00884       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elemprocid = elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>();
<a name="l00885"></a>00885       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elemid = elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l00886"></a>00886 
<a name="l00887"></a>00887       libmesh_assert(elemid &gt;= lastelemid);
<a name="l00888"></a>00888       libmesh_assert(elemprocid &gt;= lastprocid);
<a name="l00889"></a>00889 
<a name="l00890"></a>00890       lastelemid = elemid;
<a name="l00891"></a>00891       lastprocid = elemprocid;
<a name="l00892"></a>00892     }
<a name="l00893"></a>00893 }
<a name="l00894"></a>00894 
<a name="l00895"></a>00895 
<a name="l00896"></a>00896 
<a name="l00897"></a><a class="code" href="namespaceMeshTools.php#a8459293294733e3d034d2fec20501759">00897</a> <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a8459293294733e3d034d2fec20501759">MeshTools::libmesh_assert_valid_node_procids</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh)
<a name="l00898"></a>00898 {
<a name="l00899"></a>00899   parallel_only();
<a name="l00900"></a>00900   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l00901"></a>00901     <span class="keywordflow">return</span>;
<a name="l00902"></a>00902 
<a name="l00903"></a>00903   libmesh_assert(Parallel::verify(mesh.<a class="code" href="classMeshBase.php#a5a56e1b57f60d011b67f1f43ff8a5891">max_node_id</a>()));
<a name="l00904"></a>00904   std::vector&lt;bool&gt; node_touched_by_me(mesh.<a class="code" href="classMeshBase.php#a5a56e1b57f60d011b67f1f43ff8a5891">max_node_id</a>(), <span class="keyword">false</span>);
<a name="l00905"></a>00905 
<a name="l00906"></a>00906   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el_end =
<a name="l00907"></a>00907     mesh.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>();
<a name="l00908"></a>00908   <span class="keywordflow">for</span> (<a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el = 
<a name="l00909"></a>00909        mesh.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>(); el != el_end; ++el)
<a name="l00910"></a>00910     {
<a name="l00911"></a>00911       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *el;
<a name="l00912"></a>00912       libmesh_assert (elem);
<a name="l00913"></a>00913 
<a name="l00914"></a>00914       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); ++i)
<a name="l00915"></a>00915         {
<a name="l00916"></a>00916           <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a> *node = elem-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(i);
<a name="l00917"></a>00917           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nodeid = node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l00918"></a>00918           node_touched_by_me[nodeid] = <span class="keyword">true</span>;
<a name="l00919"></a>00919         }
<a name="l00920"></a>00920     }
<a name="l00921"></a>00921   std::vector&lt;bool&gt; node_touched_by_anyone(node_touched_by_me);
<a name="l00922"></a>00922   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(node_touched_by_anyone);
<a name="l00923"></a>00923 
<a name="l00924"></a>00924   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> nd_end = mesh.<a class="code" href="classMeshBase.php#ae23ced52382b7238f9182c8593f5cdd5">local_nodes_end</a>();
<a name="l00925"></a>00925   <span class="keywordflow">for</span> (<a class="code" href="structMeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> nd = mesh.<a class="code" href="classMeshBase.php#a6485de7e7d67f36dec274f512d10fc15">local_nodes_begin</a>();
<a name="l00926"></a>00926        nd != nd_end; ++nd)
<a name="l00927"></a>00927     {
<a name="l00928"></a>00928       <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a> *node = *nd;
<a name="l00929"></a>00929       libmesh_assert(node);
<a name="l00930"></a>00930 
<a name="l00931"></a>00931       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nodeid = node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l00932"></a>00932       libmesh_assert(!node_touched_by_anyone[nodeid] ||
<a name="l00933"></a>00933                      node_touched_by_me[nodeid]);
<a name="l00934"></a>00934     }
<a name="l00935"></a>00935 }
<a name="l00936"></a>00936 
<a name="l00937"></a>00937 
<a name="l00938"></a>00938 
<a name="l00939"></a>00939 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00940"></a><a class="code" href="namespaceMeshTools.php#a0e286b930c592345c483fa98c325ff84">00940</a> <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a0e286b930c592345c483fa98c325ff84">MeshTools::libmesh_assert_valid_refinement_flags</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh)
<a name="l00941"></a>00941 {
<a name="l00942"></a>00942   parallel_only();
<a name="l00943"></a>00943   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l00944"></a>00944     <span class="keywordflow">return</span>;
<a name="l00945"></a>00945 
<a name="l00946"></a>00946   std::vector&lt;unsigned char&gt; my_elem_h_state(mesh.<a class="code" href="classMeshBase.php#a05c0414e5c91b36e9698fc4f60cff642">max_elem_id</a>(), 255);
<a name="l00947"></a>00947   std::vector&lt;unsigned char&gt; my_elem_p_state(mesh.<a class="code" href="classMeshBase.php#a05c0414e5c91b36e9698fc4f60cff642">max_elem_id</a>(), 255);
<a name="l00948"></a>00948 
<a name="l00949"></a>00949   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el_end =
<a name="l00950"></a>00950     mesh.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00951"></a>00951   <span class="keywordflow">for</span> (<a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el = 
<a name="l00952"></a>00952        mesh.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>(); el != el_end; ++el)
<a name="l00953"></a>00953     {
<a name="l00954"></a>00954       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *el;
<a name="l00955"></a>00955       libmesh_assert (elem);
<a name="l00956"></a>00956       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elemid = elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l00957"></a>00957 
<a name="l00958"></a>00958       my_elem_h_state[elemid] =
<a name="l00959"></a>00959         <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">char</span><span class="keyword">&gt;</span>(elem-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>());
<a name="l00960"></a>00960 
<a name="l00961"></a>00961       my_elem_p_state[elemid] =
<a name="l00962"></a>00962         <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">char</span><span class="keyword">&gt;</span>(elem-&gt;<a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>());
<a name="l00963"></a>00963     }
<a name="l00964"></a>00964   std::vector&lt;unsigned char&gt; min_elem_h_state(my_elem_h_state);
<a name="l00965"></a>00965   <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(min_elem_h_state);
<a name="l00966"></a>00966 
<a name="l00967"></a>00967   std::vector&lt;unsigned char&gt; min_elem_p_state(my_elem_p_state);
<a name="l00968"></a>00968   <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(min_elem_p_state);
<a name="l00969"></a>00969 
<a name="l00970"></a>00970   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!= mesh.<a class="code" href="classMeshBase.php#a05c0414e5c91b36e9698fc4f60cff642">max_elem_id</a>(); ++i)
<a name="l00971"></a>00971     {
<a name="l00972"></a>00972       libmesh_assert(my_elem_h_state[i] == 255 ||
<a name="l00973"></a>00973                      my_elem_h_state[i] == min_elem_h_state[i]);
<a name="l00974"></a>00974       libmesh_assert(my_elem_p_state[i] == 255 ||
<a name="l00975"></a>00975                      my_elem_p_state[i] == min_elem_p_state[i]);
<a name="l00976"></a>00976     }
<a name="l00977"></a>00977 }
<a name="l00978"></a>00978 <span class="preprocessor">#else</span>
<a name="l00979"></a>00979 <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a0e286b930c592345c483fa98c325ff84">MeshTools::libmesh_assert_valid_refinement_flags</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;)
<a name="l00980"></a>00980 {
<a name="l00981"></a>00981 }
<a name="l00982"></a>00982 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR</span>
<a name="l00983"></a>00983 <span class="preprocessor"></span>
<a name="l00984"></a>00984 
<a name="l00985"></a>00985 
<a name="l00986"></a><a class="code" href="namespaceMeshTools.php#a55d1315fac6f245f3873626808d8a377">00986</a> <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a55d1315fac6f245f3873626808d8a377">MeshTools::libmesh_assert_valid_neighbors</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh)
<a name="l00987"></a>00987 {
<a name="l00988"></a>00988   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el_end = mesh.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00989"></a>00989   <span class="keywordflow">for</span> (<a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el = mesh.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00990"></a>00990        el != el_end; ++el)
<a name="l00991"></a>00991     {
<a name="l00992"></a>00992       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *el;
<a name="l00993"></a>00993       libmesh_assert (elem);
<a name="l00994"></a>00994       elem-&gt;<a class="code" href="classElem.php#a8130d32feced4528a2a08cfb3d8270af">libmesh_assert_valid_neighbors</a>();
<a name="l00995"></a>00995     }
<a name="l00996"></a>00996 }
<a name="l00997"></a>00997 <span class="preprocessor">#endif</span>
<a name="l00998"></a>00998 <span class="preprocessor"></span>
<a name="l00999"></a>00999 
<a name="l01000"></a>01000 
<a name="l01001"></a><a class="code" href="namespaceMeshTools_1_1Private.php#a96ed88f210c1a01056f4598751269cd2">01001</a> <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools_1_1Private.php#a96ed88f210c1a01056f4598751269cd2">MeshTools::Private::globally_renumber_nodes_and_elements</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh)
<a name="l01002"></a>01002 {
<a name="l01003"></a>01003   <a class="code" href="classMeshCommunication.php">MeshCommunication</a>().<a class="code" href="classMeshCommunication.php#aa1ac865b823fff87470b2f2fcc68a00b">assign_global_indices</a>(mesh);
<a name="l01004"></a>01004 }
<a name="l01005"></a>01005 
<a name="l01006"></a>01006 
<a name="l01007"></a>01007 
<a name="l01008"></a><a class="code" href="namespaceMeshTools_1_1Private.php#af435c29becf70b3ce4a05360be28dbc5">01008</a> <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools_1_1Private.php#af435c29becf70b3ce4a05360be28dbc5">MeshTools::Private::fix_broken_node_and_element_numbering</a> (<a class="code" href="classSerialMesh.php">SerialMesh</a> &amp;mesh)
<a name="l01009"></a>01009 {
<a name="l01010"></a>01010    <span class="comment">// Nodes first</span>
<a name="l01011"></a>01011   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;mesh.<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>.size(); n++)
<a name="l01012"></a>01012     <span class="keywordflow">if</span> (mesh.<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[n] != NULL)
<a name="l01013"></a>01013       mesh.<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[n]-&gt;set_id() = n;
<a name="l01014"></a>01014 
<a name="l01015"></a>01015   <span class="comment">// Elements next</span>
<a name="l01016"></a>01016   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;mesh.<a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>.size(); e++)
<a name="l01017"></a>01017     <span class="keywordflow">if</span> (mesh.<a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>[e] != NULL)
<a name="l01018"></a>01018       mesh.<a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>[e]-&gt;set_id() = e; 
<a name="l01019"></a>01019 }
<a name="l01020"></a>01020 
<a name="l01021"></a>01021 
<a name="l01022"></a>01022 
<a name="l01023"></a><a class="code" href="namespaceMeshTools_1_1Private.php#a71fd69f647d0fefaadee5ba6e9b5f06a">01023</a> <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools_1_1Private.php#af435c29becf70b3ce4a05360be28dbc5">MeshTools::Private::fix_broken_node_and_element_numbering</a> (<a class="code" href="classParallelMesh.php">ParallelMesh</a> &amp;mesh)
<a name="l01024"></a>01024 {
<a name="l01025"></a>01025   <span class="comment">// We need access to iterators for the underlying containers,</span>
<a name="l01026"></a>01026   <span class="comment">// not the mapvector&lt;&gt; reimplementations.</span>
<a name="l01027"></a>01027   <a class="code" href="classmapvector.php">mapvector&lt;Node*&gt;::maptype</a> &amp;nodes = mesh.<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>;
<a name="l01028"></a>01028   <a class="code" href="classmapvector.php">mapvector&lt;Elem*&gt;::maptype</a> &amp;elem  = mesh.<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>;
<a name="l01029"></a>01029   
<a name="l01030"></a>01030   <span class="comment">// Nodes first</span>
<a name="l01031"></a>01031   {
<a name="l01032"></a>01032     <a class="code" href="classmapvector.php">mapvector&lt;Node*&gt;::maptype::iterator</a>
<a name="l01033"></a>01033       it  = nodes.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(),
<a name="l01034"></a>01034       end = nodes.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>();
<a name="l01035"></a>01035 
<a name="l01036"></a>01036     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l01037"></a>01037       <span class="keywordflow">if</span> (it-&gt;second != NULL)
<a name="l01038"></a>01038         it-&gt;second-&gt;set_id() = it-&gt;first;
<a name="l01039"></a>01039   }
<a name="l01040"></a>01040 
<a name="l01041"></a>01041   <span class="comment">// Elements next</span>
<a name="l01042"></a>01042   {
<a name="l01043"></a>01043     <a class="code" href="classmapvector.php">mapvector&lt;Elem*&gt;::maptype::iterator</a>
<a name="l01044"></a>01044       it  = elem.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(),
<a name="l01045"></a>01045       end = elem.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>();
<a name="l01046"></a>01046 
<a name="l01047"></a>01047     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l01048"></a>01048       <span class="keywordflow">if</span> (it-&gt;second != NULL)
<a name="l01049"></a>01049         it-&gt;second-&gt;set_id() = it-&gt;first;
<a name="l01050"></a>01050   }
<a name="l01051"></a>01051 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
