<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_tools.h</h1>  </div>
</div>
<div class="contents">
<a href="mesh__tools_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_tools.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __mesh_tools_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_tools_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;libmesh.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;enum_elem_type.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;id_types.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;point.h&quot;</span> <span class="comment">// some compilers want the full definition - I think so they can do </span>
<a name="l00037"></a>00037                    <span class="comment">// return-value-optimization for BoundingBox&#39;es - BSK</span>
<a name="l00038"></a>00038 <span class="comment">// forward declarations</span>
<a name="l00039"></a>00039 <span class="keyword">class </span><a class="code" href="classSerialMesh.php">SerialMesh</a>;
<a name="l00040"></a>00040 <span class="keyword">class </span><a class="code" href="classParallelMesh.php">ParallelMesh</a>;
<a name="l00041"></a>00041 <span class="keyword">class </span><a class="code" href="classSphere.php">Sphere</a>;
<a name="l00042"></a>00042 <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00043"></a>00043 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classLocationMap.php">LocationMap</a>;
<a name="l00044"></a>00044 
<a name="l00057"></a>00057 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00058"></a>00058 <span class="comment">// MeshTools namespace</span>
<a name="l00059"></a>00059 <span class="keyword">namespace </span>MeshTools
<a name="l00060"></a>00060 {
<a name="l00065"></a><a class="code" href="classMeshTools_1_1BoundingBox.php">00065</a>   <span class="keyword">class </span><a class="code" href="classMeshTools_1_1BoundingBox.php">BoundingBox</a> : <span class="keyword">public</span> std::pair&lt;Point, Point&gt;
<a name="l00066"></a>00066   {
<a name="l00067"></a>00067   <span class="keyword">public</span>:
<a name="l00068"></a>00068     
<a name="l00069"></a><a class="code" href="classMeshTools_1_1BoundingBox.php#a03ec118efd5271457b47ee1590dfcf19">00069</a>     <a class="code" href="classMeshTools_1_1BoundingBox.php#a03ec118efd5271457b47ee1590dfcf19">BoundingBox</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> &amp;<a class="code" href="classMeshTools_1_1BoundingBox.php#a93514b4261fa152a5481740871c92843">min</a>, <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> &amp;<a class="code" href="classMeshTools_1_1BoundingBox.php#a53580abe3b662293c7cf9e38a0bc6a8d">max</a>) :
<a name="l00070"></a>00070       std::pair&lt;<a class="code" href="classPoint.php">Point</a>, <a class="code" href="classPoint.php">Point</a>&gt;(min, max)
<a name="l00071"></a>00071     {}
<a name="l00072"></a>00072 
<a name="l00073"></a><a class="code" href="classMeshTools_1_1BoundingBox.php#acebd569654cd95ba4847379d7ecd111e">00073</a>     <a class="code" href="classMeshTools_1_1BoundingBox.php#a03ec118efd5271457b47ee1590dfcf19">BoundingBox</a> (<span class="keyword">const</span> std::pair&lt;Point, Point&gt; &amp;bbox) :
<a name="l00074"></a>00074       std::pair&lt;<a class="code" href="classPoint.php">Point</a>, <a class="code" href="classPoint.php">Point</a>&gt; (bbox)
<a name="l00075"></a>00075     {}
<a name="l00076"></a>00076 
<a name="l00077"></a><a class="code" href="classMeshTools_1_1BoundingBox.php#a93514b4261fa152a5481740871c92843">00077</a>     <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> &amp; <a class="code" href="classMeshTools_1_1BoundingBox.php#a93514b4261fa152a5481740871c92843">min</a>()<span class="keyword"> const</span>
<a name="l00078"></a>00078 <span class="keyword">    </span>{ <span class="keywordflow">return</span> this-&gt;first; }
<a name="l00079"></a>00079 
<a name="l00080"></a><a class="code" href="classMeshTools_1_1BoundingBox.php#a9b12fafd4f44fa06f608bcf291dd3632">00080</a>     <a class="code" href="classPoint.php">Point</a> &amp; <a class="code" href="classMeshTools_1_1BoundingBox.php#a93514b4261fa152a5481740871c92843">min</a>()
<a name="l00081"></a>00081     { <span class="keywordflow">return</span> this-&gt;first; }
<a name="l00082"></a>00082 
<a name="l00083"></a><a class="code" href="classMeshTools_1_1BoundingBox.php#a53580abe3b662293c7cf9e38a0bc6a8d">00083</a>     <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> &amp; <a class="code" href="classMeshTools_1_1BoundingBox.php#a53580abe3b662293c7cf9e38a0bc6a8d">max</a>()<span class="keyword"> const</span>
<a name="l00084"></a>00084 <span class="keyword">    </span>{ <span class="keywordflow">return</span> this-&gt;second; }
<a name="l00085"></a>00085 
<a name="l00086"></a><a class="code" href="classMeshTools_1_1BoundingBox.php#a549725b6d63926b0004ff2106d5bec9c">00086</a>     <a class="code" href="classPoint.php">Point</a> &amp; <a class="code" href="classMeshTools_1_1BoundingBox.php#a53580abe3b662293c7cf9e38a0bc6a8d">max</a>()
<a name="l00087"></a>00087     { <span class="keywordflow">return</span> this-&gt;second; }
<a name="l00088"></a>00088 
<a name="l00089"></a><a class="code" href="classMeshTools_1_1BoundingBox.php#a9df97dd4ac75b8f67212d5385aad2f12">00089</a>     <a class="code" href="classMeshTools_1_1BoundingBox.php">BoundingBox</a> &amp; <a class="code" href="classMeshTools_1_1BoundingBox.php#a9df97dd4ac75b8f67212d5385aad2f12">expand</a>()
<a name="l00090"></a>00090     { <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00091"></a>00091 
<a name="l00092"></a><a class="code" href="classMeshTools_1_1BoundingBox.php#aa5831c9c0e19d1f3e92e81f3b5f843a0">00092</a>     <span class="keywordtype">bool</span> <a class="code" href="classMeshTools_1_1BoundingBox.php#aa5831c9c0e19d1f3e92e81f3b5f843a0">intersect</a> (<span class="keyword">const</span> <a class="code" href="classMeshTools_1_1BoundingBox.php">BoundingBox</a> &amp;)<span class="keyword"> const</span>
<a name="l00093"></a>00093 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   <span class="keyword">private</span>:
<a name="l00096"></a>00096   };
<a name="l00097"></a>00097   
<a name="l00104"></a>00104   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a12088fda1f68ba58f5868a24a4ed884a">total_weight</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00105"></a>00105   
<a name="l00112"></a>00112   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a7c3064eb37925fb5bdda7660e872cf69">weight</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>());
<a name="l00113"></a>00113   
<a name="l00120"></a>00120   <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a632cfcd7fcbda25f0450b52f3d75942f">build_nodes_to_elem_map</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00121"></a>00121                                 std::vector&lt;std::vector&lt;unsigned int&gt; &gt; &amp;nodes_to_elem_map);
<a name="l00122"></a>00122   
<a name="l00126"></a>00126   <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a632cfcd7fcbda25f0450b52f3d75942f">build_nodes_to_elem_map</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00127"></a>00127                                 std::vector&lt;std::vector&lt;const Elem*&gt; &gt;&amp; nodes_to_elem_map);
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 <span class="comment">//   /**</span>
<a name="l00131"></a>00131 <span class="comment">//    * Calling this function on a 2D mesh will convert all the elements</span>
<a name="l00132"></a>00132 <span class="comment">//    * to triangles.  \p QUAD4s will be converted to \p TRI3s, \p QUAD8s</span>
<a name="l00133"></a>00133 <span class="comment">//    * and \p QUAD9s will be converted to \p TRI6s. </span>
<a name="l00134"></a>00134 <span class="comment">//    */</span>
<a name="l00135"></a>00135 <span class="comment">//   void all_tri (MeshBase &amp;mesh);</span>
<a name="l00136"></a>00136 
<a name="l00141"></a>00141   <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#ab24d347f09559cc4fa6ea2c1a238b2d4">find_boundary_nodes</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00142"></a>00142                             std::vector&lt;bool&gt; &amp;on_boundary);
<a name="l00143"></a>00143 
<a name="l00149"></a>00149   BoundingBox
<a name="l00150"></a>00150   <a class="code" href="namespaceMeshTools.php#ad533681876e9809cfe5e2114886b1c03">bounding_box</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00151"></a>00151 
<a name="l00155"></a>00155   <a class="code" href="classSphere.php">Sphere</a>
<a name="l00156"></a>00156   <a class="code" href="namespaceMeshTools.php#a535977af7ac146991ee577adc585b810">bounding_sphere</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00157"></a>00157   
<a name="l00162"></a>00162   BoundingBox
<a name="l00163"></a>00163   <a class="code" href="namespaceMeshTools.php#a2bdd431bdb400efd4a5ddafc9a63532f">processor_bounding_box</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00164"></a>00164                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid);
<a name="l00165"></a>00165 
<a name="l00169"></a>00169   <a class="code" href="classSphere.php">Sphere</a> 
<a name="l00170"></a>00170   <a class="code" href="namespaceMeshTools.php#a53e25707943fd10db85e74bd2ab7480e">processor_bounding_sphere</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00171"></a>00171                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid);
<a name="l00172"></a>00172 
<a name="l00177"></a>00177   BoundingBox
<a name="l00178"></a>00178   <a class="code" href="namespaceMeshTools.php#a5c09fb16b47c708e7e712d950812d39a">subdomain_bounding_box</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00179"></a>00179                           <span class="keyword">const</span> <a class="code" href="classTestClass.php">subdomain_id_type</a> sid);
<a name="l00180"></a>00180 
<a name="l00184"></a>00184   <a class="code" href="classSphere.php">Sphere</a> 
<a name="l00185"></a>00185   <a class="code" href="namespaceMeshTools.php#a941ef83f5e28b5c11e59987041cb266e">subdomain_bounding_sphere</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00186"></a>00186                              <span class="keyword">const</span> <a class="code" href="classTestClass.php">subdomain_id_type</a> sid);
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 
<a name="l00193"></a>00193   <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a907bdeb4ae9c2d6a780e85bde894e731">elem_types</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00194"></a>00194                    std::vector&lt;ElemType&gt; &amp;et);
<a name="l00195"></a>00195   
<a name="l00200"></a>00200   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#ad3ca1fc8a6437d31b6c7b28d687e7fee">n_elem_of_type</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00201"></a>00201                                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00202"></a>00202 
<a name="l00207"></a>00207   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a3449fb3ff9f5d7770b02bec93b778bef">n_active_elem_of_type</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00208"></a>00208                                       <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00209"></a>00209 
<a name="l00218"></a>00218   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a115b9be300720c24bb023ab767245937">n_non_subactive_elem_of_type_at_level</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00219"></a>00219                                                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type,
<a name="l00220"></a>00220                                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00221"></a>00221 
<a name="l00227"></a>00227   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a467cd3c96ff9a03c0918d4df6ef16301">n_levels</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00228"></a>00228 
<a name="l00234"></a>00234   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a2d3e473958b98cab21275e75b75ed19b">n_local_levels</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00235"></a>00235  
<a name="l00241"></a>00241   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#ac7347516a0e8d16e18b72870f87bfac9">n_active_levels</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00242"></a>00242 
<a name="l00248"></a>00248   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#ad90de59c6df96299aa4873e92e69bd94">n_active_local_levels</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00249"></a>00249 
<a name="l00255"></a>00255   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a7c26061d17e6cbc7122fe92b8d349772">n_p_levels</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00256"></a>00256  
<a name="l00263"></a>00263   <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#adc92798ee497c203c0ba45f017bdd7ff">get_not_subactive_node_ids</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh, 
<a name="l00264"></a>00264                                   std::set&lt;unsigned int&gt; &amp;not_subactive_node_ids);
<a name="l00265"></a>00265 
<a name="l00270"></a>00270    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a337ed123c95f0ba57b665456c413db4b">n_elem</a> (<span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> &amp;begin,
<a name="l00271"></a>00271                         <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> &amp;end);
<a name="l00272"></a>00272 
<a name="l00273"></a>00273 
<a name="l00278"></a>00278    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a> (<span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> &amp;begin,
<a name="l00279"></a>00279                          <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> &amp;end);
<a name="l00280"></a>00280 
<a name="l00281"></a>00281 
<a name="l00285"></a>00285   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#aa7528fd4ca1533ce837c7aedc6a9a108">max_level</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00286"></a>00286     
<a name="l00287"></a>00287   
<a name="l00292"></a>00292    <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a78d702e60195186a26f1ae644696c735">find_nodal_neighbors</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh, <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a> &amp;n, 
<a name="l00293"></a>00293                              std::vector&lt;std::vector&lt;const Elem*&gt; &gt; &amp;nodes_to_elem_map, 
<a name="l00294"></a>00294                              std::vector&lt;const Node*&gt; &amp;neighbors);
<a name="l00295"></a>00295    
<a name="l00302"></a>00302    <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a0deba4a0a21e80c0abb5c1e279244db9">find_hanging_nodes_and_parents</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh, std::map&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, std::vector&lt;unsigned int&gt; &gt; &amp;hanging_nodes);
<a name="l00303"></a>00303 
<a name="l00314"></a>00314   <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a0ce5caf2cff3d386fe0906e09c052c91">correct_node_proc_ids</a>(<a class="code" href="classMeshBase.php">MeshBase</a> &amp;, <a class="code" href="classLocationMap.php">LocationMap&lt;Node&gt;</a> &amp;);
<a name="l00315"></a>00315 
<a name="l00316"></a>00316 
<a name="l00317"></a>00317 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00318"></a>00318 <span class="preprocessor"></span>
<a name="l00322"></a>00322   <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a752dbbf1fd1febbe7cd636800e846df8">libmesh_assert_no_links_to_elem</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00323"></a>00323                                        <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *bad_elem);
<a name="l00324"></a>00324 
<a name="l00329"></a>00329   <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a36e87521b260afd4f9e6663bdaaec414">libmesh_assert_valid_node_pointers</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00330"></a>00330 
<a name="l00335"></a>00335   <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a2304fff4874f07eec82a4fa173ac31fe">libmesh_assert_valid_remote_elems</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00336"></a>00336 
<a name="l00341"></a>00341   <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a2fd26b4502cbdc994e60136839a6d101">libmesh_assert_valid_elem_ids</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00342"></a>00342 
<a name="l00347"></a>00347   <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a8459293294733e3d034d2fec20501759">libmesh_assert_valid_node_procids</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00348"></a>00348 
<a name="l00353"></a>00353   <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a0e286b930c592345c483fa98c325ff84">libmesh_assert_valid_refinement_flags</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00354"></a>00354 
<a name="l00359"></a>00359   <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools.php#a55d1315fac6f245f3873626808d8a377">libmesh_assert_valid_neighbors</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00360"></a>00360 <span class="preprocessor">#endif</span>
<a name="l00361"></a>00361 <span class="preprocessor"></span>
<a name="l00362"></a>00362   <span class="comment">// There is no reason for users to call functions in the MeshTools::Private namespace.</span>
<a name="l00363"></a><a class="code" href="namespaceMeshTools_1_1Private.php">00363</a>   <span class="keyword">namespace </span>Private {
<a name="l00375"></a>00375     <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools_1_1Private.php#a96ed88f210c1a01056f4598751269cd2">globally_renumber_nodes_and_elements</a> (<a class="code" href="classMeshBase.php">MeshBase</a> &amp;);
<a name="l00376"></a>00376 
<a name="l00377"></a>00377   
<a name="l00384"></a>00384     <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools_1_1Private.php#af435c29becf70b3ce4a05360be28dbc5">fix_broken_node_and_element_numbering</a> (<a class="code" href="classSerialMesh.php">SerialMesh</a> &amp;);
<a name="l00385"></a>00385     
<a name="l00386"></a>00386 
<a name="l00393"></a>00393     <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools_1_1Private.php#af435c29becf70b3ce4a05360be28dbc5">fix_broken_node_and_element_numbering</a> (<a class="code" href="classParallelMesh.php">ParallelMesh</a> &amp;);
<a name="l00394"></a>00394   } <span class="comment">// end namespace Private</span>
<a name="l00395"></a>00395   
<a name="l00396"></a>00396 } <span class="comment">// end namespace MeshTools</span>
<a name="l00397"></a>00397 
<a name="l00398"></a>00398 
<a name="l00399"></a>00399 <span class="preprocessor">#endif // #define __mesh_tools_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
