<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_triangle_support.C</h1>  </div>
</div>
<div class="contents">
<a href="mesh__triangle__support_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_triangle_support.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010 
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015 
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;mesh_triangle_support.h&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;unstructured_mesh.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;face_tri3.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;face_tri6.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;mesh_generation.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;mesh_smoother_laplace.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;boundary_info.h&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="preprocessor">#ifdef LIBMESH_HAVE_TRIANGLE</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>
<a name="l00033"></a>00033 <span class="comment">// Triangulates a 2D rectangular region with or without holes</span>
<a name="l00034"></a><a class="code" href="namespaceMeshTools_1_1Generation.php#addc1168079a94fd08dd1b0efd93b2c77">00034</a> <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools_1_1Generation.php#addc1168079a94fd08dd1b0efd93b2c77">MeshTools::Generation::build_delaunay_square</a>(<a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; mesh,
<a name="l00035"></a>00035                                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nx, <span class="comment">// num. of elements in x-dir</span>
<a name="l00036"></a>00036                                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ny, <span class="comment">// num. of elements in y-dir</span>
<a name="l00037"></a>00037                                                   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xmin, <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xmax,
<a name="l00038"></a>00038                                                   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> ymin, <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> ymax,
<a name="l00039"></a>00039                                                   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type,
<a name="l00040"></a>00040                                                   <span class="keyword">const</span> std::vector&lt;TriangleInterface::Hole*&gt;* holes)
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042   <span class="comment">// Check for reasonable size</span>
<a name="l00043"></a>00043   libmesh_assert (nx &gt;= 1); <span class="comment">// need at least 1 element in x-direction</span>
<a name="l00044"></a>00044   libmesh_assert (ny &gt;= 1); <span class="comment">// need at least 1 element in y-direction</span>
<a name="l00045"></a>00045   libmesh_assert (xmin &lt; xmax);
<a name="l00046"></a>00046   libmesh_assert (ymin &lt; ymax);
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   <span class="comment">// Clear out any data which may have been in the Mesh</span>
<a name="l00049"></a>00049   mesh.<a class="code" href="classMeshBase.php#aefd56c4c29285d5e845f8869112b2b67">clear</a>();
<a name="l00050"></a>00050 
<a name="l00051"></a>00051   <span class="comment">// Make sure the new Mesh will be 2D</span>
<a name="l00052"></a>00052   mesh.<a class="code" href="classMeshBase.php#a115ad25a44a20e30f6702ec71dec90a9">set_mesh_dimension</a>(2);
<a name="l00053"></a>00053   
<a name="l00054"></a>00054   <span class="comment">// The x and y spacing between boundary points</span>
<a name="l00055"></a>00055   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> delta_x = (xmax-xmin) / static_cast&lt;Real&gt;(nx);
<a name="l00056"></a>00056   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> delta_y = (ymax-ymin) / static_cast&lt;Real&gt;(ny);  
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <span class="comment">// Bottom</span>
<a name="l00059"></a>00059   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;=nx; ++p)
<a name="l00060"></a>00060     mesh.<a class="code" href="classMeshBase.php#a01b66468d3e9d8b5db82c6f3d9131f5e">add_point</a>(<a class="code" href="classPoint.php">Point</a>(xmin + p*delta_x, ymin));
<a name="l00061"></a>00061   
<a name="l00062"></a>00062   <span class="comment">// Right side</span>
<a name="l00063"></a>00063   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p&lt;ny; ++p)
<a name="l00064"></a>00064     mesh.<a class="code" href="classMeshBase.php#a01b66468d3e9d8b5db82c6f3d9131f5e">add_point</a>(<a class="code" href="classPoint.php">Point</a>(xmax, ymin + p*delta_y)); 
<a name="l00065"></a>00065 
<a name="l00066"></a>00066   <span class="comment">// Top</span>
<a name="l00067"></a>00067   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;=nx; ++p)
<a name="l00068"></a>00068     mesh.<a class="code" href="classMeshBase.php#a01b66468d3e9d8b5db82c6f3d9131f5e">add_point</a>(<a class="code" href="classPoint.php">Point</a>(xmax - p*delta_x, ymax));
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="comment">// Left side</span>
<a name="l00071"></a>00071   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p&lt;ny; ++p)
<a name="l00072"></a>00072     mesh.<a class="code" href="classMeshBase.php#a01b66468d3e9d8b5db82c6f3d9131f5e">add_point</a>(<a class="code" href="classPoint.php">Point</a>(xmin,  ymax - p*delta_y)); 
<a name="l00073"></a>00073                    
<a name="l00074"></a>00074   <span class="comment">// Be sure we added as many points as we thought we did</span>
<a name="l00075"></a>00075   libmesh_assert (mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>() == 2*(nx+ny));
<a name="l00076"></a>00076 
<a name="l00077"></a>00077   <span class="comment">// Construct the Triangle Interface object</span>
<a name="l00078"></a>00078   <a class="code" href="classTriangleInterface.php">TriangleInterface</a> t(mesh);
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   <span class="comment">// Set custom variables for the triangulation</span>
<a name="l00081"></a>00081   t.<a class="code" href="classTriangleInterface.php#abe4717fb10f05e0a759d7c62f40afaa4">desired_area</a>()       = 0.5 * (xmax-xmin)*(ymax-ymin) / <span class="keyword">static_cast&lt;</span><a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a><span class="keyword">&gt;</span>(nx*ny);
<a name="l00082"></a>00082   t.<a class="code" href="classTriangleInterface.php#ab122b87ff7684f70d80e946c5b02f854">triangulation_type</a>() = <a class="code" href="classTriangleInterface.php#ae488289d934519b457d75eb54f89cfc5a490443ff49dc346853d7282865d71c37">TriangleInterface::PSLG</a>;
<a name="l00083"></a>00083   t.<a class="code" href="classTriangleInterface.php#a57a42a4f5ed08c7a230a4716079779d3">elem_type</a>()          = type;
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="keywordflow">if</span> (holes != NULL)
<a name="l00086"></a>00086     t.<a class="code" href="classTriangleInterface.php#a32e725f4141b3c7a4f81af0490fd491e">attach_hole_list</a>(holes);
<a name="l00087"></a>00087 
<a name="l00088"></a>00088   <span class="comment">// Triangulate!</span>
<a name="l00089"></a>00089   t.<a class="code" href="classTriangleInterface.php#a932beb79abc660bfdef248437730e4e1">triangulate</a>();
<a name="l00090"></a>00090 
<a name="l00091"></a>00091   <span class="comment">// The mesh is now generated, but we still need to mark the boundaries</span>
<a name="l00092"></a>00092   <span class="comment">// to be consistent with the other build_square routines.  Note that only</span>
<a name="l00093"></a>00093   <span class="comment">// the external boundaries of the square are given boundary ids, the holes</span>
<a name="l00094"></a>00094   <span class="comment">// are not numbered.</span>
<a name="l00095"></a>00095   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el     = mesh.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00096"></a>00096   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end_el = mesh.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00097"></a>00097   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00098"></a>00098     {
<a name="l00099"></a>00099       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *el;
<a name="l00100"></a>00100       
<a name="l00101"></a>00101       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>(); s++)
<a name="l00102"></a>00102         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s) == NULL)
<a name="l00103"></a>00103           {
<a name="l00104"></a>00104             <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> side (elem-&gt;<a class="code" href="classElem.php#a554c146bcfb5537636bd77a157f21b85">build_side</a>(s));
<a name="l00105"></a>00105 
<a name="l00106"></a>00106             <span class="comment">// Check the location of the side&#39;s midpoint.  Since</span>
<a name="l00107"></a>00107             <span class="comment">// the square has straight sides, the midpoint is not</span>
<a name="l00108"></a>00108             <span class="comment">// on the corner and thus it is uniquely on one of the</span>
<a name="l00109"></a>00109             <span class="comment">// sides.</span>
<a name="l00110"></a>00110             <a class="code" href="classPoint.php">Point</a> side_midpoint= 0.5*( (*side-&gt;get_node(0)) + (*side-&gt;get_node(1)) );
<a name="l00111"></a>00111 
<a name="l00112"></a>00112             <span class="comment">// The boundary ids are set following the same convention as Quad4 sides</span>
<a name="l00113"></a>00113             <span class="comment">// bottom = 0</span>
<a name="l00114"></a>00114             <span class="comment">// right  = 1</span>
<a name="l00115"></a>00115             <span class="comment">// top = 2</span>
<a name="l00116"></a>00116             <span class="comment">// left = 3</span>
<a name="l00117"></a>00117             <span class="comment">// hole = 4</span>
<a name="l00118"></a>00118             <span class="keywordtype">short</span> <span class="keywordtype">int</span> bc_id=4;
<a name="l00119"></a>00119 
<a name="l00120"></a>00120             <span class="comment">// bottom</span>
<a name="l00121"></a>00121             <span class="keywordflow">if</span>      (std::fabs(side_midpoint(1) - ymin) &lt; TOLERANCE)
<a name="l00122"></a>00122               bc_id=0;
<a name="l00123"></a>00123 
<a name="l00124"></a>00124             <span class="comment">// right</span>
<a name="l00125"></a>00125             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (std::fabs(side_midpoint(0) - xmax) &lt; TOLERANCE)
<a name="l00126"></a>00126               bc_id=1;
<a name="l00127"></a>00127 
<a name="l00128"></a>00128             <span class="comment">// top</span>
<a name="l00129"></a>00129             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (std::fabs(side_midpoint(1) - ymax) &lt; TOLERANCE)
<a name="l00130"></a>00130               bc_id=2;
<a name="l00131"></a>00131 
<a name="l00132"></a>00132             <span class="comment">// left</span>
<a name="l00133"></a>00133             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (std::fabs(side_midpoint(0) - xmin) &lt; TOLERANCE)
<a name="l00134"></a>00134               bc_id=3;
<a name="l00135"></a>00135 
<a name="l00136"></a>00136             <span class="comment">// If the point is not on any of the external boundaries, it</span>
<a name="l00137"></a>00137             <span class="comment">// is on one of the holes....</span>
<a name="l00138"></a>00138             
<a name="l00139"></a>00139             <span class="comment">// Finally, add this element&#39;s information to the boundary info object.</span>
<a name="l00140"></a>00140             mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;add_side(elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>(), s, bc_id);
<a name="l00141"></a>00141           }
<a name="l00142"></a>00142     }
<a name="l00143"></a>00143   
<a name="l00144"></a>00144 }
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 <span class="comment">// Init helper routine defined in the Triangle namespace</span>
<a name="l00152"></a>00152 <span class="keywordtype">void</span> <a class="code" href="namespaceTriangle.php#aef666211ad88f9081563e665b9d17ba3">Triangle::init</a>(Triangle::triangulateio&amp; t)
<a name="l00153"></a>00153 {
<a name="l00154"></a>00154   t.pointlist                    = <span class="keyword">static_cast&lt;</span><a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a>*<span class="keyword">&gt;</span>(NULL);
<a name="l00155"></a>00155   t.pointattributelist           = <span class="keyword">static_cast&lt;</span><a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a>*<span class="keyword">&gt;</span>(NULL);
<a name="l00156"></a>00156   t.pointmarkerlist              = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span>* <span class="keyword">&gt;</span>(NULL);
<a name="l00157"></a>00157   t.numberofpoints               = 0 ;
<a name="l00158"></a>00158   t.numberofpointattributes      = 0 ;                                   
<a name="l00159"></a>00159 
<a name="l00160"></a>00160   t.trianglelist                 = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span>* <span class="keyword">&gt;</span>(NULL);
<a name="l00161"></a>00161   t.triangleattributelist        = <span class="keyword">static_cast&lt;</span><a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a>*<span class="keyword">&gt;</span>(NULL);
<a name="l00162"></a>00162   t.trianglearealist             = <span class="keyword">static_cast&lt;</span><a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a>*<span class="keyword">&gt;</span>(NULL);
<a name="l00163"></a>00163   t.neighborlist                 = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span>* <span class="keyword">&gt;</span>(NULL);
<a name="l00164"></a>00164   t.numberoftriangles            = 0;
<a name="l00165"></a>00165   t.numberofcorners              = 0;
<a name="l00166"></a>00166   t.numberoftriangleattributes   = 0;
<a name="l00167"></a>00167   
<a name="l00168"></a>00168   t.segmentlist                  = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span>* <span class="keyword">&gt;</span>(NULL);
<a name="l00169"></a>00169   t.segmentmarkerlist            = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span>* <span class="keyword">&gt;</span>(NULL);
<a name="l00170"></a>00170   t.numberofsegments             = 0;
<a name="l00171"></a>00171 
<a name="l00172"></a>00172   t.holelist                     = <span class="keyword">static_cast&lt;</span><a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a>*<span class="keyword">&gt;</span>(NULL);
<a name="l00173"></a>00173   t.numberofholes                = 0;
<a name="l00174"></a>00174 
<a name="l00175"></a>00175   t.regionlist                   = <span class="keyword">static_cast&lt;</span><a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a>*<span class="keyword">&gt;</span>(NULL);
<a name="l00176"></a>00176   t.numberofregions              = 0;
<a name="l00177"></a>00177   
<a name="l00178"></a>00178   t.edgelist                     = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span>* <span class="keyword">&gt;</span>(NULL);
<a name="l00179"></a>00179   t.edgemarkerlist               = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span>* <span class="keyword">&gt;</span>(NULL);
<a name="l00180"></a>00180   t.normlist                     = <span class="keyword">static_cast&lt;</span><a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a>*<span class="keyword">&gt;</span>(NULL);
<a name="l00181"></a>00181   t.numberofedges                = 0;
<a name="l00182"></a>00182 }
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 <span class="comment">// Destroy helper routine defined in the Triangle namespace</span>
<a name="l00190"></a>00190 <span class="keywordtype">void</span> <a class="code" href="namespaceTriangle.php#a2576a06733e4a9a9dccf19cec535aa7d">Triangle::destroy</a>(Triangle::triangulateio&amp; t, <a class="code" href="namespaceTriangle.php#a4c150407cd74e6c2bf9fb34106af33b2">Triangle::IO_Type</a> io_type)
<a name="l00191"></a>00191 {
<a name="l00192"></a>00192   std::free (t.pointlist                    );
<a name="l00193"></a>00193   std::free (t.pointattributelist           );
<a name="l00194"></a>00194   std::free (t.pointmarkerlist              );
<a name="l00195"></a>00195   std::free (t.trianglelist                 );
<a name="l00196"></a>00196   std::free (t.triangleattributelist        );
<a name="l00197"></a>00197   std::free (t.trianglearealist             );
<a name="l00198"></a>00198   std::free (t.neighborlist                 );
<a name="l00199"></a>00199   std::free (t.segmentlist                  );
<a name="l00200"></a>00200   std::free (t.segmentmarkerlist            );
<a name="l00201"></a>00201 
<a name="l00202"></a>00202   <span class="comment">// Only attempt to free these when t was used as an input struct!</span>
<a name="l00203"></a>00203   <span class="keywordflow">if</span> (io_type==<a class="code" href="namespaceTriangle.php#a4c150407cd74e6c2bf9fb34106af33b2af37d50f6c19d3f355c10481ca2a75de4">INPUT</a>)
<a name="l00204"></a>00204     {
<a name="l00205"></a>00205       std::free (t.holelist                     );
<a name="l00206"></a>00206       std::free (t.regionlist                   );
<a name="l00207"></a>00207     }
<a name="l00208"></a>00208   
<a name="l00209"></a>00209   std::free (t.edgelist                     );
<a name="l00210"></a>00210   std::free (t.edgemarkerlist               );
<a name="l00211"></a>00211   std::free (t.normlist                     );
<a name="l00212"></a>00212 
<a name="l00213"></a>00213   <span class="comment">// Reset</span>
<a name="l00214"></a>00214   <span class="comment">// Triangle::init(t);</span>
<a name="l00215"></a>00215 }
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 
<a name="l00220"></a>00220 
<a name="l00221"></a>00221 
<a name="l00222"></a><a class="code" href="namespaceTriangle.php#a0c5d82513cbe81970c3663404219a057">00222</a> <span class="keywordtype">void</span> <a class="code" href="namespaceTriangle.php#a0c5d82513cbe81970c3663404219a057">Triangle::copy_tri_to_mesh</a>(<span class="keyword">const</span> triangulateio&amp; triangle_data_input,
<a name="l00223"></a>00223                                 <a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; mesh_output,
<a name="l00224"></a>00224                                 <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)
<a name="l00225"></a>00225 {
<a name="l00226"></a>00226   <span class="comment">// Transfer the information into the LibMesh mesh.</span>
<a name="l00227"></a>00227   mesh_output.<a class="code" href="classMeshBase.php#aefd56c4c29285d5e845f8869112b2b67">clear</a>();
<a name="l00228"></a>00228   
<a name="l00229"></a>00229   <span class="comment">// Make sure the new Mesh will be 2D</span>
<a name="l00230"></a>00230   mesh_output.<a class="code" href="classMeshBase.php#a115ad25a44a20e30f6702ec71dec90a9">set_mesh_dimension</a>(2);
<a name="l00231"></a>00231   
<a name="l00232"></a>00232   <span class="comment">// Node information</span>
<a name="l00233"></a>00233   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0, c=0; c&lt;triangle_data_input.numberofpoints; i+=2, ++c)
<a name="l00234"></a>00234     {
<a name="l00235"></a>00235       mesh_output.<a class="code" href="classMeshBase.php#a01b66468d3e9d8b5db82c6f3d9131f5e">add_point</a>( <a class="code" href="classPoint.php">Point</a>(triangle_data_input.pointlist[i],
<a name="l00236"></a>00236                                    triangle_data_input.pointlist[i+1]) );
<a name="l00237"></a>00237     }
<a name="l00238"></a>00238 
<a name="l00239"></a>00239   <span class="comment">// Element information</span>
<a name="l00240"></a>00240   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;triangle_data_input.numberoftriangles; ++i)
<a name="l00241"></a>00241     {
<a name="l00242"></a>00242       <span class="keywordflow">switch</span> (type)
<a name="l00243"></a>00243         {
<a name="l00244"></a>00244         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00245"></a>00245           {
<a name="l00246"></a>00246             <a class="code" href="classElem.php">Elem</a>* elem = mesh_output.<a class="code" href="classMeshBase.php#a0f6974cf3e413cfe9caa1fcb4ce8153e">add_elem</a> (<span class="keyword">new</span> <a class="code" href="classTri3.php">Tri3</a>);
<a name="l00247"></a>00247 
<a name="l00248"></a>00248             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;3; ++n)
<a name="l00249"></a>00249               elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(n) = mesh_output.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(triangle_data_input.trianglelist[i*3 + n]);
<a name="l00250"></a>00250 
<a name="l00251"></a>00251             <span class="keywordflow">break</span>;
<a name="l00252"></a>00252           }
<a name="l00253"></a>00253 
<a name="l00254"></a>00254         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00255"></a>00255           {
<a name="l00256"></a>00256             <a class="code" href="classElem.php">Elem</a>* elem = mesh_output.<a class="code" href="classMeshBase.php#a0f6974cf3e413cfe9caa1fcb4ce8153e">add_elem</a> (<span class="keyword">new</span> <a class="code" href="classTri6.php">Tri6</a>);
<a name="l00257"></a>00257 
<a name="l00258"></a>00258             <span class="comment">// Triangle number TRI6 nodes in a different way to libMesh</span>
<a name="l00259"></a>00259             elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(0) = mesh_output.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(triangle_data_input.trianglelist[i*6 + 0]);
<a name="l00260"></a>00260             elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(1) = mesh_output.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(triangle_data_input.trianglelist[i*6 + 1]);
<a name="l00261"></a>00261             elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(2) = mesh_output.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(triangle_data_input.trianglelist[i*6 + 2]);
<a name="l00262"></a>00262             elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(3) = mesh_output.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(triangle_data_input.trianglelist[i*6 + 5]);
<a name="l00263"></a>00263             elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(4) = mesh_output.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(triangle_data_input.trianglelist[i*6 + 3]);
<a name="l00264"></a>00264             elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(5) = mesh_output.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(triangle_data_input.trianglelist[i*6 + 4]);
<a name="l00265"></a>00265 
<a name="l00266"></a>00266             <span class="keywordflow">break</span>;
<a name="l00267"></a>00267           }
<a name="l00268"></a>00268 
<a name="l00269"></a>00269         <span class="keywordflow">default</span>:
<a name="l00270"></a>00270           {
<a name="l00271"></a>00271             std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Unrecognized triangular element type.&quot;</span> &lt;&lt; std::endl;
<a name="l00272"></a>00272             libmesh_error();
<a name="l00273"></a>00273           }
<a name="l00274"></a>00274         }
<a name="l00275"></a>00275     }
<a name="l00276"></a>00276 
<a name="l00277"></a>00277   <span class="comment">// Prepare mesh for usage.</span>
<a name="l00278"></a>00278   mesh_output.<a class="code" href="classMeshBase.php#a7c79bc3b9a75a580ed1ef91195eb77e5">prepare_for_use</a>();
<a name="l00279"></a>00279 }
<a name="l00280"></a>00280 
<a name="l00281"></a>00281 
<a name="l00282"></a>00282 
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 
<a name="l00285"></a>00285 
<a name="l00286"></a>00286 <span class="comment">// Function definitions for the TriangleInterface class</span>
<a name="l00287"></a><a class="code" href="classTriangleInterface.php#a932beb79abc660bfdef248437730e4e1">00287</a> <span class="keywordtype">void</span> <a class="code" href="classTriangleInterface.php#a932beb79abc660bfdef248437730e4e1">TriangleInterface::triangulate</a>()
<a name="l00288"></a>00288 {
<a name="l00289"></a>00289   <span class="comment">// Will the triangulation have holes?</span>
<a name="l00290"></a>00290   <span class="keyword">const</span> <span class="keywordtype">bool</span> have_holes = ((<a class="code" href="classTriangleInterface.php#acb0e6a8a4e3a79ba62b1cbebfb586fde">_holes</a> != NULL) &amp;&amp; (!<a class="code" href="classTriangleInterface.php#acb0e6a8a4e3a79ba62b1cbebfb586fde">_holes</a>-&gt;empty()));
<a name="l00291"></a>00291   
<a name="l00292"></a>00292   <span class="comment">// If the initial PSLG is really simple, e.g. an L-shaped domain or</span>
<a name="l00293"></a>00293   <span class="comment">// a square/rectangle, the resulting triangulation may be very</span>
<a name="l00294"></a>00294   <span class="comment">// &quot;structured&quot; looking.  Sometimes this is a problem if your</span>
<a name="l00295"></a>00295   <span class="comment">// intention is to work with an &quot;unstructured&quot; looking grid.  We can</span>
<a name="l00296"></a>00296   <span class="comment">// attempt to work around this limitation by inserting midpoints</span>
<a name="l00297"></a>00297   <span class="comment">// into the original PSLG.  Inserting additional points into a</span>
<a name="l00298"></a>00298   <span class="comment">// set of points meant to be a convex hull usually makes less sense.</span>
<a name="l00299"></a>00299 
<a name="l00300"></a>00300   <span class="comment">// May or may not need to insert new points ...</span>
<a name="l00301"></a>00301   <span class="keywordflow">if</span> ((<a class="code" href="classTriangleInterface.php#aa68d8950ccfc30b79dbdc916561153d9">_triangulation_type</a>==<a class="code" href="classTriangleInterface.php#ae488289d934519b457d75eb54f89cfc5a490443ff49dc346853d7282865d71c37">PSLG</a>) &amp;&amp; (<a class="code" href="classTriangleInterface.php#abdabe2f1e942e831b85d0505de722079">_insert_extra_points</a>))
<a name="l00302"></a>00302     {
<a name="l00303"></a>00303       <span class="comment">// Make a copy of the original points from the Mesh</span>
<a name="l00304"></a>00304       std::vector&lt;Point&gt; original_points (<a class="code" href="classTriangleInterface.php#ad615b9a86af9ccb152cbcde775e6cec5">_mesh</a>.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l00305"></a>00305       
<a name="l00306"></a>00306       <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>       node_it  = <a class="code" href="classTriangleInterface.php#ad615b9a86af9ccb152cbcde775e6cec5">_mesh</a>.<a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
<a name="l00307"></a>00307       <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> node_end = <a class="code" href="classTriangleInterface.php#ad615b9a86af9ccb152cbcde775e6cec5">_mesh</a>.<a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
<a name="l00308"></a>00308       
<a name="l00309"></a>00309       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ctr=0; node_it != node_end; ++node_it)
<a name="l00310"></a>00310         original_points[ctr++] = **node_it;
<a name="l00311"></a>00311       
<a name="l00312"></a>00312       <span class="comment">// Clear out the mesh</span>
<a name="l00313"></a>00313       <a class="code" href="classTriangleInterface.php#ad615b9a86af9ccb152cbcde775e6cec5">_mesh</a>.<a class="code" href="classMeshBase.php#aefd56c4c29285d5e845f8869112b2b67">clear</a>();
<a name="l00314"></a>00314       
<a name="l00315"></a>00315       <span class="comment">// Make sure the new Mesh will be 2D</span>
<a name="l00316"></a>00316       <a class="code" href="classTriangleInterface.php#ad615b9a86af9ccb152cbcde775e6cec5">_mesh</a>.<a class="code" href="classMeshBase.php#a115ad25a44a20e30f6702ec71dec90a9">set_mesh_dimension</a>(2);
<a name="l00317"></a>00317   
<a name="l00318"></a>00318       <span class="comment">// Insert a new point on each PSLG at some random location</span>
<a name="l00319"></a>00319       <span class="comment">// np=index into new points vector</span>
<a name="l00320"></a>00320       <span class="comment">// n =index into original points vector</span>
<a name="l00321"></a>00321       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> np=0, n=0; np&lt;2*original_points.size(); ++np)
<a name="l00322"></a>00322         {
<a name="l00323"></a>00323           <span class="comment">// the even entries are the original points</span>
<a name="l00324"></a>00324           <span class="keywordflow">if</span> (np%2==0)
<a name="l00325"></a>00325             <a class="code" href="classTriangleInterface.php#ad615b9a86af9ccb152cbcde775e6cec5">_mesh</a>.<a class="code" href="classMeshBase.php#a01b66468d3e9d8b5db82c6f3d9131f5e">add_point</a>(original_points[n++]);
<a name="l00326"></a>00326 
<a name="l00327"></a>00327           <span class="keywordflow">else</span> <span class="comment">// the odd entries are the midpoints of the original PSLG segments</span>
<a name="l00328"></a>00328             <a class="code" href="classTriangleInterface.php#ad615b9a86af9ccb152cbcde775e6cec5">_mesh</a>.<a class="code" href="classMeshBase.php#a01b66468d3e9d8b5db82c6f3d9131f5e">add_point</a> (0.5*(original_points[n] + original_points[n-1]));
<a name="l00329"></a>00329         }
<a name="l00330"></a>00330     }
<a name="l00331"></a>00331   
<a name="l00332"></a>00332   <span class="comment">// Regardless of whether we added additional points, the set of points to</span>
<a name="l00333"></a>00333   <span class="comment">// triangulate is now sitting in the mesh.</span>
<a name="l00334"></a>00334 
<a name="l00335"></a>00335   <span class="comment">// If the holes vector is non-NULL (and non-empty) we need to determine</span>
<a name="l00336"></a>00336   <span class="comment">// the number of additional points which the holes will add to the</span>
<a name="l00337"></a>00337   <span class="comment">// triangulation.</span>
<a name="l00338"></a>00338   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_hole_points = 0;
<a name="l00339"></a>00339 
<a name="l00340"></a>00340   <span class="keywordflow">if</span> (have_holes)
<a name="l00341"></a>00341     {
<a name="l00342"></a>00342       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classTriangleInterface.php#acb0e6a8a4e3a79ba62b1cbebfb586fde">_holes</a>-&gt;size(); ++i)
<a name="l00343"></a>00343         n_hole_points += (*<a class="code" href="classTriangleInterface.php#acb0e6a8a4e3a79ba62b1cbebfb586fde">_holes</a>)[i]-&gt;n_points();
<a name="l00344"></a>00344     }
<a name="l00345"></a>00345   
<a name="l00346"></a>00346   <span class="comment">// Triangle data structure for the mesh</span>
<a name="l00347"></a>00347   Triangle::triangulateio initial;
<a name="l00348"></a>00348   Triangle::triangulateio <span class="keyword">final</span>;
<a name="l00349"></a>00349 
<a name="l00350"></a>00350   <span class="comment">// Pseudo-Constructor for the triangle io structs</span>
<a name="l00351"></a>00351   <a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">Triangle::init</a>(initial);
<a name="l00352"></a>00352   <a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">Triangle::init</a>(<span class="keyword">final</span>);
<a name="l00353"></a>00353     
<a name="l00354"></a>00354   initial.numberofpoints = <a class="code" href="classTriangleInterface.php#ad615b9a86af9ccb152cbcde775e6cec5">_mesh</a>.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>() + n_hole_points;
<a name="l00355"></a>00355   initial.pointlist      = <span class="keyword">static_cast&lt;</span><a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a>*<span class="keyword">&gt;</span>(std::malloc(initial.numberofpoints * 2 * <span class="keyword">sizeof</span>(<a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a>)));
<a name="l00356"></a>00356 
<a name="l00357"></a>00357   <span class="keywordflow">if</span> (<a class="code" href="classTriangleInterface.php#aa68d8950ccfc30b79dbdc916561153d9">_triangulation_type</a>==<a class="code" href="classTriangleInterface.php#ae488289d934519b457d75eb54f89cfc5a490443ff49dc346853d7282865d71c37">PSLG</a>)
<a name="l00358"></a>00358     {
<a name="l00359"></a>00359       <span class="comment">// Implicit segment ordering: One segment per point, including hole points</span>
<a name="l00360"></a>00360       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classTriangleInterface.php#ab609a8300aab0d19b37f2a683c15f97d">segments</a>.empty())
<a name="l00361"></a>00361         initial.numberofsegments = initial.numberofpoints; 
<a name="l00362"></a>00362 
<a name="l00363"></a>00363       <span class="comment">// User-defined segment ordering: One segment per entry in the segments vector</span>
<a name="l00364"></a>00364       <span class="keywordflow">else</span>
<a name="l00365"></a>00365         initial.numberofsegments = this-&gt;segments.size();
<a name="l00366"></a>00366     }
<a name="l00367"></a>00367   
<a name="l00368"></a>00368   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classTriangleInterface.php#aa68d8950ccfc30b79dbdc916561153d9">_triangulation_type</a>==<a class="code" href="classTriangleInterface.php#ae488289d934519b457d75eb54f89cfc5a46df267b678bf416f0206f94da13f107">GENERATE_CONVEX_HULL</a>)
<a name="l00369"></a>00369     initial.numberofsegments = n_hole_points; <span class="comment">// One segment for each hole point</span>
<a name="l00370"></a>00370 
<a name="l00371"></a>00371   <span class="comment">// Debugging</span>
<a name="l00372"></a>00372   <span class="comment">// std::cout &lt;&lt; &quot;Number of segments set to: &quot; &lt;&lt; initial.numberofsegments &lt;&lt; std::endl;</span>
<a name="l00373"></a>00373   
<a name="l00374"></a>00374   <span class="comment">// Allocate space for the segments (2 int per segment)</span>
<a name="l00375"></a>00375   <span class="keywordflow">if</span> (initial.numberofsegments &gt; 0)
<a name="l00376"></a>00376     {
<a name="l00377"></a>00377       initial.segmentlist = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span> (std::malloc(initial.numberofsegments * 2 * <span class="keyword">sizeof</span>(<span class="keywordtype">int</span>)));
<a name="l00378"></a>00378     }  
<a name="l00379"></a>00379 
<a name="l00380"></a>00380 
<a name="l00381"></a>00381   <span class="comment">// Copy all the holes&#39; points and segments into the triangle struct.</span>
<a name="l00382"></a>00382 
<a name="l00383"></a>00383   <span class="comment">// The hole_offset is a constant offset into the points vector which points</span>
<a name="l00384"></a>00384   <span class="comment">// past the end of the last hole point added.</span>
<a name="l00385"></a>00385   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> hole_offset=0;
<a name="l00386"></a>00386   
<a name="l00387"></a>00387   <span class="keywordflow">if</span> (have_holes)
<a name="l00388"></a>00388     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classTriangleInterface.php#acb0e6a8a4e3a79ba62b1cbebfb586fde">_holes</a>-&gt;size(); ++i)
<a name="l00389"></a>00389       {
<a name="l00390"></a>00390         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ctr=0, h=0; h&lt;(*_holes)[i]-&gt;n_points(); ctr+=2, ++h)
<a name="l00391"></a>00391           {
<a name="l00392"></a>00392             <a class="code" href="classPoint.php">Point</a> p = (*_holes)[i]-&gt;point(h);
<a name="l00393"></a>00393 
<a name="l00394"></a>00394             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index0 = 2*hole_offset+ctr;
<a name="l00395"></a>00395             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index1 = 2*hole_offset+ctr+1;
<a name="l00396"></a>00396 
<a name="l00397"></a>00397             <span class="comment">// Save the x,y locations in the triangle struct.</span>
<a name="l00398"></a>00398             initial.pointlist[index0] = p(0);
<a name="l00399"></a>00399             initial.pointlist[index1] = p(1);
<a name="l00400"></a>00400 
<a name="l00401"></a>00401             <span class="comment">// Set the points which define the segments</span>
<a name="l00402"></a>00402             initial.segmentlist[index0] = hole_offset+h;
<a name="l00403"></a>00403             initial.segmentlist[index1] = (h==(*_holes)[i]-&gt;n_points()-1) ? hole_offset : hole_offset+h+1; <span class="comment">// wrap around</span>
<a name="l00404"></a>00404           }
<a name="l00405"></a>00405         
<a name="l00406"></a>00406         <span class="comment">// Update the hole_offset for the next hole</span>
<a name="l00407"></a>00407         hole_offset += (*_holes)[i]-&gt;n_points();
<a name="l00408"></a>00408       }
<a name="l00409"></a>00409 
<a name="l00410"></a>00410   
<a name="l00411"></a>00411   <span class="comment">// Copy all the non-hole points and segments into the triangle struct.</span>
<a name="l00412"></a>00412   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ctr=0, n=0; n&lt;<a class="code" href="classTriangleInterface.php#ad615b9a86af9ccb152cbcde775e6cec5">_mesh</a>.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>(); ctr+=2, ++n)
<a name="l00413"></a>00413     {
<a name="l00414"></a>00414       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index0 = 2*hole_offset+ctr;
<a name="l00415"></a>00415       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index1 = 2*hole_offset+ctr+1;
<a name="l00416"></a>00416       
<a name="l00417"></a>00417       initial.pointlist[index0] = <a class="code" href="classTriangleInterface.php#ad615b9a86af9ccb152cbcde775e6cec5">_mesh</a>.<a class="code" href="classMeshBase.php#a06af1f178519c606d0bdca7857f95ba6">point</a>(n)(0);
<a name="l00418"></a>00418       initial.pointlist[index1] = <a class="code" href="classTriangleInterface.php#ad615b9a86af9ccb152cbcde775e6cec5">_mesh</a>.<a class="code" href="classMeshBase.php#a06af1f178519c606d0bdca7857f95ba6">point</a>(n)(1);
<a name="l00419"></a>00419 
<a name="l00420"></a>00420       <span class="comment">// If the user requested a PSLG, the non-hole points are also segments</span>
<a name="l00421"></a>00421       <span class="keywordflow">if</span> (<a class="code" href="classTriangleInterface.php#aa68d8950ccfc30b79dbdc916561153d9">_triangulation_type</a>==<a class="code" href="classTriangleInterface.php#ae488289d934519b457d75eb54f89cfc5a490443ff49dc346853d7282865d71c37">PSLG</a>)
<a name="l00422"></a>00422         {
<a name="l00423"></a>00423           <span class="comment">// Use implicit ordering to define segments</span>
<a name="l00424"></a>00424           <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classTriangleInterface.php#ab609a8300aab0d19b37f2a683c15f97d">segments</a>.empty())
<a name="l00425"></a>00425             {
<a name="l00426"></a>00426               initial.segmentlist[index0] = hole_offset+n;
<a name="l00427"></a>00427               initial.segmentlist[index1] = (n==<a class="code" href="classTriangleInterface.php#ad615b9a86af9ccb152cbcde775e6cec5">_mesh</a>.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>()-1) ? hole_offset : hole_offset+n+1; <span class="comment">// wrap around</span>
<a name="l00428"></a>00428             }
<a name="l00429"></a>00429         }
<a name="l00430"></a>00430     }
<a name="l00431"></a>00431 
<a name="l00432"></a>00432   
<a name="l00433"></a>00433   <span class="comment">// If the user provided it, use his ordering to define the segments</span>
<a name="l00434"></a>00434   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ctr=0, s=0; s&lt;this-&gt;<a class="code" href="classTriangleInterface.php#ab609a8300aab0d19b37f2a683c15f97d">segments</a>.size(); ctr+=2, ++s)
<a name="l00435"></a>00435     {
<a name="l00436"></a>00436       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index0 = 2*hole_offset+ctr;
<a name="l00437"></a>00437       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index1 = 2*hole_offset+ctr+1;
<a name="l00438"></a>00438       
<a name="l00439"></a>00439       initial.segmentlist[index0] = hole_offset + this-&gt;<a class="code" href="classTriangleInterface.php#ab609a8300aab0d19b37f2a683c15f97d">segments</a>[s].first;
<a name="l00440"></a>00440       initial.segmentlist[index1] = hole_offset + this-&gt;<a class="code" href="classTriangleInterface.php#ab609a8300aab0d19b37f2a683c15f97d">segments</a>[s].second;
<a name="l00441"></a>00441     }
<a name="l00442"></a>00442 
<a name="l00443"></a>00443 
<a name="l00444"></a>00444 
<a name="l00445"></a>00445   <span class="comment">// Tell the input struct about the holes</span>
<a name="l00446"></a>00446   <span class="keywordflow">if</span> (have_holes)
<a name="l00447"></a>00447     {
<a name="l00448"></a>00448       initial.numberofholes = <a class="code" href="classTriangleInterface.php#acb0e6a8a4e3a79ba62b1cbebfb586fde">_holes</a>-&gt;size();
<a name="l00449"></a>00449       initial.holelist      = <span class="keyword">static_cast&lt;</span><a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a>*<span class="keyword">&gt;</span>(std::malloc(initial.numberofholes * 2 * <span class="keyword">sizeof</span>(<a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a>)));
<a name="l00450"></a>00450       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0, ctr=0; i&lt;<a class="code" href="classTriangleInterface.php#acb0e6a8a4e3a79ba62b1cbebfb586fde">_holes</a>-&gt;size(); ++i, ctr+=2)
<a name="l00451"></a>00451         {
<a name="l00452"></a>00452           <a class="code" href="classPoint.php">Point</a> inside_point = (*_holes)[i]-&gt;inside();
<a name="l00453"></a>00453           initial.holelist[ctr]   = inside_point(0);
<a name="l00454"></a>00454           initial.holelist[ctr+1] = inside_point(1);
<a name="l00455"></a>00455         }
<a name="l00456"></a>00456     }
<a name="l00457"></a>00457   
<a name="l00458"></a>00458   <span class="comment">// Set the triangulation flags.</span>
<a name="l00459"></a>00459   <span class="comment">// c ~ enclose convex hull with segments</span>
<a name="l00460"></a>00460   <span class="comment">// z ~ use zero indexing</span>
<a name="l00461"></a>00461   <span class="comment">// B ~ Suppresses boundary markers in the output</span>
<a name="l00462"></a>00462   <span class="comment">// Q ~ run in &quot;quiet&quot; mode</span>
<a name="l00463"></a>00463   <span class="comment">// p ~ Triangulates a Planar Straight Line Graph</span>
<a name="l00464"></a>00464   <span class="comment">//     If the `p&#39; switch is used, `segmentlist&#39; must point to a list of     </span>
<a name="l00465"></a>00465   <span class="comment">//     segments, `numberofsegments&#39; must be properly set, and               </span>
<a name="l00466"></a>00466   <span class="comment">//     `segmentmarkerlist&#39; must either be set to NULL (in which case all    </span>
<a name="l00467"></a>00467   <span class="comment">//     markers default to zero), or must point to a list of markers.</span>
<a name="l00468"></a>00468   <span class="comment">// D ~ Conforming Delaunay: use this switch if you want all triangles</span>
<a name="l00469"></a>00469   <span class="comment">//     in the mesh to be Delaunay, and not just constrained Delaunay</span>
<a name="l00470"></a>00470   <span class="comment">// q ~  Quality mesh generation with no angles smaller than 20 degrees.</span>
<a name="l00471"></a>00471   <span class="comment">//      An alternate minimum angle may be specified after the q</span>
<a name="l00472"></a>00472   <span class="comment">// a ~ Imposes a maximum triangle area constraint.</span>
<a name="l00473"></a>00473   <span class="comment">// -P  Suppresses the output .poly file. Saves disk space, but you lose the ability to maintain</span>
<a name="l00474"></a>00474   <span class="comment">//     constraining segments on later refinements of the mesh.</span>
<a name="l00475"></a>00475   <span class="comment">// Create the flag strings, depends on element type</span>
<a name="l00476"></a>00476 std::ostringstream flags;
<a name="l00477"></a>00477 
<a name="l00478"></a>00478 <span class="comment">// Default flags always used</span>
<a name="l00479"></a>00479 flags &lt;&lt; <span class="stringliteral">&quot;zBPQq&quot;</span>;
<a name="l00480"></a>00480 
<a name="l00481"></a>00481   <span class="comment">// Flags which are specific to the type of triangulation</span>
<a name="l00482"></a>00482   <span class="keywordflow">switch</span> (<a class="code" href="classTriangleInterface.php#aa68d8950ccfc30b79dbdc916561153d9">_triangulation_type</a>)
<a name="l00483"></a>00483     {
<a name="l00484"></a>00484     <span class="keywordflow">case</span> <a class="code" href="classTriangleInterface.php#ae488289d934519b457d75eb54f89cfc5a46df267b678bf416f0206f94da13f107">GENERATE_CONVEX_HULL</a>:
<a name="l00485"></a>00485       {
<a name="l00486"></a>00486         flags &lt;&lt; <span class="stringliteral">&quot;c&quot;</span>;
<a name="l00487"></a>00487         <span class="keywordflow">break</span>;
<a name="l00488"></a>00488       }
<a name="l00489"></a>00489 
<a name="l00490"></a>00490     <span class="keywordflow">case</span> <a class="code" href="classTriangleInterface.php#ae488289d934519b457d75eb54f89cfc5a490443ff49dc346853d7282865d71c37">PSLG</a>:
<a name="l00491"></a>00491       {
<a name="l00492"></a>00492         flags &lt;&lt; <span class="stringliteral">&quot;p&quot;</span>;
<a name="l00493"></a>00493         <span class="keywordflow">break</span>;
<a name="l00494"></a>00494       }
<a name="l00495"></a>00495       
<a name="l00496"></a>00496     <span class="keywordflow">case</span> <a class="code" href="classTriangleInterface.php#ae488289d934519b457d75eb54f89cfc5aa6507c81822101607cf7b28626a3ae61">INVALID_TRIANGULATION_TYPE</a>:
<a name="l00497"></a>00497       {
<a name="l00498"></a>00498         libmesh_error();
<a name="l00499"></a>00499         <span class="keywordflow">break</span>;
<a name="l00500"></a>00500       }
<a name="l00501"></a>00501       
<a name="l00502"></a>00502     <span class="keywordflow">default</span>:
<a name="l00503"></a>00503       {
<a name="l00504"></a>00504         libmesh_error();
<a name="l00505"></a>00505       }
<a name="l00506"></a>00506     }
<a name="l00507"></a>00507 
<a name="l00508"></a>00508 
<a name="l00509"></a>00509   <span class="comment">// Flags specific to the type of element</span>
<a name="l00510"></a>00510   <span class="keywordflow">switch</span> (<a class="code" href="classTriangleInterface.php#a439160f942ffdb190e7da02536e3260a">_elem_type</a>)
<a name="l00511"></a>00511     {
<a name="l00512"></a>00512     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00513"></a>00513       {
<a name="l00514"></a>00514         <span class="comment">// do nothing.</span>
<a name="l00515"></a>00515         <span class="keywordflow">break</span>;
<a name="l00516"></a>00516       }
<a name="l00517"></a>00517 
<a name="l00518"></a>00518     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00519"></a>00519       {
<a name="l00520"></a>00520         flags &lt;&lt; <span class="stringliteral">&quot;o2&quot;</span>;
<a name="l00521"></a>00521         <span class="keywordflow">break</span>;
<a name="l00522"></a>00522       }
<a name="l00523"></a>00523       
<a name="l00524"></a>00524     <span class="keywordflow">default</span>:
<a name="l00525"></a>00525       {
<a name="l00526"></a>00526         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Unrecognized triangular element type.&quot;</span> &lt;&lt; std::endl;
<a name="l00527"></a>00527         libmesh_error();
<a name="l00528"></a>00528       }
<a name="l00529"></a>00529     }
<a name="l00530"></a>00530 
<a name="l00531"></a>00531 
<a name="l00532"></a>00532   <span class="comment">// If we do have holes and the user asked to GENERATE_CONVEX_HULL,</span>
<a name="l00533"></a>00533   <span class="comment">// need to add the p flag so the triangulation respects those segments.</span>
<a name="l00534"></a>00534   <span class="keywordflow">if</span> ((<a class="code" href="classTriangleInterface.php#aa68d8950ccfc30b79dbdc916561153d9">_triangulation_type</a>==<a class="code" href="classTriangleInterface.php#ae488289d934519b457d75eb54f89cfc5a46df267b678bf416f0206f94da13f107">GENERATE_CONVEX_HULL</a>) &amp;&amp; (have_holes))
<a name="l00535"></a>00535     flags &lt;&lt; <span class="stringliteral">&quot;p&quot;</span>;
<a name="l00536"></a>00536   
<a name="l00537"></a>00537   <span class="comment">// Finally, add the area constraint</span>
<a name="l00538"></a>00538   flags &lt;&lt; <span class="stringliteral">&quot;a&quot;</span> &lt;&lt; std::fixed &lt;&lt; <a class="code" href="classTriangleInterface.php#a908fc00da56848ae6035ebaec00b35ba">_desired_area</a>;
<a name="l00539"></a>00539 
<a name="l00540"></a>00540   <span class="comment">// Refine the initial output to conform to the area constraint</span>
<a name="l00541"></a>00541   <a class="code" href="classTriangleInterface.php#a932beb79abc660bfdef248437730e4e1">Triangle::triangulate</a>(const_cast&lt;char*&gt;(flags.str().c_str()),
<a name="l00542"></a>00542                         &amp;initial,
<a name="l00543"></a>00543                         &amp;<span class="keyword">final</span>,
<a name="l00544"></a>00544                         NULL); <span class="comment">// voronoi ouput -- not used</span>
<a name="l00545"></a>00545   
<a name="l00546"></a>00546   
<a name="l00547"></a>00547   <span class="comment">// Send the information computed by Triangle to the Mesh.</span>
<a name="l00548"></a>00548   <a class="code" href="namespaceTriangle.php#a0c5d82513cbe81970c3663404219a057">Triangle::copy_tri_to_mesh</a>(<span class="keyword">final</span>,
<a name="l00549"></a>00549                              <a class="code" href="classTriangleInterface.php#ad615b9a86af9ccb152cbcde775e6cec5">_mesh</a>,
<a name="l00550"></a>00550                              <a class="code" href="classTriangleInterface.php#a439160f942ffdb190e7da02536e3260a">_elem_type</a>);
<a name="l00551"></a>00551       
<a name="l00552"></a>00552   <span class="comment">// To the naked eye, a few smoothing iterations usually looks better,</span>
<a name="l00553"></a>00553   <span class="comment">// so we do this by default unless the user says not to.</span>
<a name="l00554"></a>00554   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classTriangleInterface.php#a7400d57511f62528e92f8667587b31d5">_smooth_after_generating</a>)
<a name="l00555"></a>00555     <a class="code" href="classLaplaceMeshSmoother.php">LaplaceMeshSmoother</a>(<a class="code" href="classTriangleInterface.php#ad615b9a86af9ccb152cbcde775e6cec5">_mesh</a>).<a class="code" href="classLaplaceMeshSmoother.php#a836c8d87c7e6ae66de9462a7a587eaaf">smooth</a>(2);
<a name="l00556"></a>00556 
<a name="l00557"></a>00557     
<a name="l00558"></a>00558   <span class="comment">// Clean up.    </span>
<a name="l00559"></a>00559   <a class="code" href="namespaceTriangle.php#a2576a06733e4a9a9dccf19cec535aa7d">Triangle::destroy</a>(initial,      <a class="code" href="namespaceTriangle.php#a4c150407cd74e6c2bf9fb34106af33b2af37d50f6c19d3f355c10481ca2a75de4">Triangle::INPUT</a>);
<a name="l00560"></a>00560   <a class="code" href="namespaceTriangle.php#a2576a06733e4a9a9dccf19cec535aa7d">Triangle::destroy</a>(<span class="keyword">final</span>,        <a class="code" href="namespaceTriangle.php#a4c150407cd74e6c2bf9fb34106af33b2a58bb5f72fe5c04eea09bbcb1b5d59022">Triangle::OUTPUT</a>);
<a name="l00561"></a>00561   
<a name="l00562"></a>00562 }
<a name="l00563"></a>00563 
<a name="l00564"></a>00564 
<a name="l00565"></a>00565 
<a name="l00566"></a>00566 
<a name="l00567"></a>00567 
<a name="l00568"></a>00568 
<a name="l00569"></a>00569 
<a name="l00570"></a>00570 <span class="preprocessor">#endif // LIBMESH_HAVE_TRIANGLE</span>
<a name="l00571"></a>00571 <span class="preprocessor"></span>
<a name="l00572"></a>00572 
<a name="l00573"></a>00573 
<a name="l00574"></a>00574 
<a name="l00575"></a>00575 
<a name="l00576"></a>00576 
<a name="l00577"></a>00577 
<a name="l00578"></a>00578 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
