<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_triangle_support.h</h1>  </div>
</div>
<div class="contents">
<a href="mesh__triangle__support_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_triangle_support.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002  
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __mesh_triangle_support_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_triangle_support_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// C++ includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;elem_type.h&quot;</span> <span class="comment">// For ElemType declaration below</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;point.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;libmesh.h&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Forward Declarations</span>
<a name="l00034"></a><a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">00034</a> <span class="keyword">class </span><a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>;
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="preprocessor">#ifdef LIBMESH_HAVE_TRIANGLE</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span>
<a name="l00038"></a>00038 <span class="comment">// Note: libmesh_common.h defines REAL, which is required by triangle.</span>
<a name="l00039"></a>00039 <span class="comment">// Therefore, we need to include it first.</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="keyword">typedef</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="mesh__triangle__support_8h.php#a5396381931c679ef58da229901df36d7">REAL</a>;
<a name="l00043"></a>00043 
<a name="l00049"></a><a class="code" href="namespaceTriangle.php">00049</a> <span class="keyword">namespace </span>Triangle {
<a name="l00050"></a>00050 <span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {
<a name="l00051"></a>00051 <span class="preprocessor">#include &quot;triangle.h&quot;</span>
<a name="l00052"></a>00052 }
<a name="l00053"></a>00053 
<a name="l00054"></a><a class="code" href="namespaceTriangle.php#a4c150407cd74e6c2bf9fb34106af33b2">00054</a>   <span class="keyword">enum</span> <a class="code" href="namespaceTriangle.php#a4c150407cd74e6c2bf9fb34106af33b2">IO_Type</a> {
<a name="l00055"></a><a class="code" href="namespaceTriangle.php#a4c150407cd74e6c2bf9fb34106af33b2af37d50f6c19d3f355c10481ca2a75de4">00055</a>     <a class="code" href="namespaceTriangle.php#a4c150407cd74e6c2bf9fb34106af33b2af37d50f6c19d3f355c10481ca2a75de4">INPUT</a>  = 0,
<a name="l00056"></a><a class="code" href="namespaceTriangle.php#a4c150407cd74e6c2bf9fb34106af33b2a58bb5f72fe5c04eea09bbcb1b5d59022">00056</a>     <a class="code" href="namespaceTriangle.php#a4c150407cd74e6c2bf9fb34106af33b2a58bb5f72fe5c04eea09bbcb1b5d59022">OUTPUT</a> = 1,
<a name="l00057"></a><a class="code" href="namespaceTriangle.php#a4c150407cd74e6c2bf9fb34106af33b2a16711d3f22d0007a9b8f51041fd3dce2">00057</a>     <a class="code" href="namespaceTriangle.php#a4c150407cd74e6c2bf9fb34106af33b2a16711d3f22d0007a9b8f51041fd3dce2">BOTH</a>   = 2};
<a name="l00058"></a>00058   
<a name="l00065"></a>00065   <span class="keywordtype">void</span> <a class="code" href="namespaceTriangle.php#aef666211ad88f9081563e665b9d17ba3">init</a>(triangulateio&amp; t);
<a name="l00066"></a>00066     
<a name="l00078"></a>00078   <span class="keywordtype">void</span> <a class="code" href="namespaceTriangle.php#a2576a06733e4a9a9dccf19cec535aa7d">destroy</a>(triangulateio&amp; t, <a class="code" href="namespaceTriangle.php#a4c150407cd74e6c2bf9fb34106af33b2">IO_Type</a>);
<a name="l00079"></a>00079 
<a name="l00086"></a>00086   <span class="keywordtype">void</span> <a class="code" href="namespaceTriangle.php#a0c5d82513cbe81970c3663404219a057">copy_tri_to_mesh</a>(<span class="keyword">const</span> triangulateio&amp; triangle_data_input,
<a name="l00087"></a>00087                         <a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; mesh_output,
<a name="l00088"></a>00088                         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00089"></a>00089     
<a name="l00090"></a>00090   
<a name="l00091"></a>00091 }
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 
<a name="l00108"></a><a class="code" href="classTriangleInterface.php">00108</a> <span class="keyword">class </span><a class="code" href="classTriangleInterface.php">TriangleInterface</a>
<a name="l00109"></a>00109 {
<a name="l00110"></a>00110 <span class="keyword">public</span>:
<a name="l00117"></a><a class="code" href="classTriangleInterface.php#a7a65f36c681e2f536c370c1e7e5bc8d8">00117</a>   <a class="code" href="classTriangleInterface.php#a7a65f36c681e2f536c370c1e7e5bc8d8">TriangleInterface</a>(<a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; mesh)
<a name="l00118"></a>00118     : <a class="code" href="classTriangleInterface.php#ad615b9a86af9ccb152cbcde775e6cec5">_mesh</a>(mesh),
<a name="l00119"></a>00119       <a class="code" href="classTriangleInterface.php#acb0e6a8a4e3a79ba62b1cbebfb586fde">_holes</a>(NULL),
<a name="l00120"></a>00120       <a class="code" href="classTriangleInterface.php#a439160f942ffdb190e7da02536e3260a">_elem_type</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>),
<a name="l00121"></a>00121       <a class="code" href="classTriangleInterface.php#a908fc00da56848ae6035ebaec00b35ba">_desired_area</a>(0.1),
<a name="l00122"></a>00122       <a class="code" href="classTriangleInterface.php#aa68d8950ccfc30b79dbdc916561153d9">_triangulation_type</a>(<a class="code" href="classTriangleInterface.php#ae488289d934519b457d75eb54f89cfc5a46df267b678bf416f0206f94da13f107">GENERATE_CONVEX_HULL</a>),
<a name="l00123"></a>00123       <a class="code" href="classTriangleInterface.php#abdabe2f1e942e831b85d0505de722079">_insert_extra_points</a>(false),
<a name="l00124"></a>00124       <a class="code" href="classTriangleInterface.php#a7400d57511f62528e92f8667587b31d5">_smooth_after_generating</a>(true)
<a name="l00125"></a>00125   {}
<a name="l00126"></a>00126 
<a name="l00130"></a><a class="code" href="classTriangleInterface.php#ac36620829928a8f125f17db133f744fd">00130</a>   <a class="code" href="classTriangleInterface.php#ac36620829928a8f125f17db133f744fd">~TriangleInterface</a>() {}
<a name="l00131"></a>00131       
<a name="l00136"></a><a class="code" href="classTriangleInterface.php#ae488289d934519b457d75eb54f89cfc5">00136</a>   <span class="keyword">enum</span> <a class="code" href="classTriangleInterface.php#ae488289d934519b457d75eb54f89cfc5">TriangulationType</a>
<a name="l00137"></a>00137     {
<a name="l00138"></a><a class="code" href="classTriangleInterface.php#ae488289d934519b457d75eb54f89cfc5a46df267b678bf416f0206f94da13f107">00138</a>       <a class="code" href="classTriangleInterface.php#ae488289d934519b457d75eb54f89cfc5a46df267b678bf416f0206f94da13f107">GENERATE_CONVEX_HULL</a> = 0,
<a name="l00146"></a><a class="code" href="classTriangleInterface.php#ae488289d934519b457d75eb54f89cfc5a490443ff49dc346853d7282865d71c37">00146</a>       <a class="code" href="classTriangleInterface.php#ae488289d934519b457d75eb54f89cfc5a490443ff49dc346853d7282865d71c37">PSLG</a> = 1,
<a name="l00158"></a><a class="code" href="classTriangleInterface.php#ae488289d934519b457d75eb54f89cfc5aa6507c81822101607cf7b28626a3ae61">00158</a>       <a class="code" href="classTriangleInterface.php#ae488289d934519b457d75eb54f89cfc5aa6507c81822101607cf7b28626a3ae61">INVALID_TRIANGULATION_TYPE</a>
<a name="l00162"></a>00162     };
<a name="l00163"></a>00163 
<a name="l00169"></a>00169   <span class="keyword">class </span>Hole;
<a name="l00170"></a>00170   <span class="keyword">class </span>PolygonHole;
<a name="l00171"></a>00171   <span class="keyword">class </span>ArbitraryHole;
<a name="l00172"></a>00172       
<a name="l00177"></a>00177   <span class="keywordtype">void</span> <a class="code" href="classTriangleInterface.php#a932beb79abc660bfdef248437730e4e1">triangulate</a>();
<a name="l00178"></a>00178 
<a name="l00182"></a><a class="code" href="classTriangleInterface.php#a57a42a4f5ed08c7a230a4716079779d3">00182</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>&amp; <a class="code" href="classTriangleInterface.php#a57a42a4f5ed08c7a230a4716079779d3">elem_type</a>() {<span class="keywordflow">return</span> <a class="code" href="classTriangleInterface.php#a439160f942ffdb190e7da02536e3260a">_elem_type</a>;}
<a name="l00183"></a>00183 
<a name="l00187"></a><a class="code" href="classTriangleInterface.php#abe4717fb10f05e0a759d7c62f40afaa4">00187</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&amp; <a class="code" href="classTriangleInterface.php#abe4717fb10f05e0a759d7c62f40afaa4">desired_area</a>() {<span class="keywordflow">return</span> <a class="code" href="classTriangleInterface.php#a908fc00da56848ae6035ebaec00b35ba">_desired_area</a>;}
<a name="l00188"></a>00188 
<a name="l00192"></a><a class="code" href="classTriangleInterface.php#ab122b87ff7684f70d80e946c5b02f854">00192</a>   <a class="code" href="classTriangleInterface.php#ae488289d934519b457d75eb54f89cfc5">TriangulationType</a>&amp; <a class="code" href="classTriangleInterface.php#ab122b87ff7684f70d80e946c5b02f854">triangulation_type</a>() {<span class="keywordflow">return</span> <a class="code" href="classTriangleInterface.php#aa68d8950ccfc30b79dbdc916561153d9">_triangulation_type</a>;}
<a name="l00193"></a>00193 
<a name="l00197"></a><a class="code" href="classTriangleInterface.php#a000a86b6a9b74c16a3699a4782295c36">00197</a>   <span class="keywordtype">bool</span>&amp; <a class="code" href="classTriangleInterface.php#a000a86b6a9b74c16a3699a4782295c36">insert_extra_points</a>() {<span class="keywordflow">return</span> <a class="code" href="classTriangleInterface.php#abdabe2f1e942e831b85d0505de722079">_insert_extra_points</a>;}
<a name="l00198"></a>00198 
<a name="l00203"></a><a class="code" href="classTriangleInterface.php#a73adc1d7969ea306a0af9c785bc32ced">00203</a>   <span class="keywordtype">bool</span>&amp; <a class="code" href="classTriangleInterface.php#a73adc1d7969ea306a0af9c785bc32ced">smooth_after_generating</a>() {<span class="keywordflow">return</span> <a class="code" href="classTriangleInterface.php#a7400d57511f62528e92f8667587b31d5">_smooth_after_generating</a>;}
<a name="l00204"></a>00204   
<a name="l00209"></a><a class="code" href="classTriangleInterface.php#a32e725f4141b3c7a4f81af0490fd491e">00209</a>   <span class="keywordtype">void</span> <a class="code" href="classTriangleInterface.php#a32e725f4141b3c7a4f81af0490fd491e">attach_hole_list</a>(<span class="keyword">const</span> std::vector&lt;Hole*&gt;* holes) {<a class="code" href="classTriangleInterface.php#acb0e6a8a4e3a79ba62b1cbebfb586fde">_holes</a> = holes;}
<a name="l00210"></a>00210 
<a name="l00222"></a><a class="code" href="classTriangleInterface.php#ab609a8300aab0d19b37f2a683c15f97d">00222</a>   std::vector&lt;std::pair&lt;unsigned int, unsigned int&gt; &gt; <a class="code" href="classTriangleInterface.php#ab609a8300aab0d19b37f2a683c15f97d">segments</a>;
<a name="l00223"></a>00223   
<a name="l00224"></a>00224 <span class="keyword">private</span>:
<a name="l00228"></a><a class="code" href="classTriangleInterface.php#ad615b9a86af9ccb152cbcde775e6cec5">00228</a>   <a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; <a class="code" href="classTriangleInterface.php#ad615b9a86af9ccb152cbcde775e6cec5">_mesh</a>;
<a name="l00229"></a>00229 
<a name="l00234"></a><a class="code" href="classTriangleInterface.php#acb0e6a8a4e3a79ba62b1cbebfb586fde">00234</a>   <span class="keyword">const</span> std::vector&lt;Hole*&gt;* <a class="code" href="classTriangleInterface.php#acb0e6a8a4e3a79ba62b1cbebfb586fde">_holes</a>;
<a name="l00235"></a>00235 
<a name="l00240"></a><a class="code" href="classTriangleInterface.php#a439160f942ffdb190e7da02536e3260a">00240</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classTriangleInterface.php#a439160f942ffdb190e7da02536e3260a">_elem_type</a>;
<a name="l00241"></a>00241 
<a name="l00245"></a><a class="code" href="classTriangleInterface.php#a908fc00da56848ae6035ebaec00b35ba">00245</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classTriangleInterface.php#a908fc00da56848ae6035ebaec00b35ba">_desired_area</a>;
<a name="l00246"></a>00246 
<a name="l00252"></a><a class="code" href="classTriangleInterface.php#aa68d8950ccfc30b79dbdc916561153d9">00252</a>   <a class="code" href="classTriangleInterface.php#ae488289d934519b457d75eb54f89cfc5">TriangulationType</a> <a class="code" href="classTriangleInterface.php#aa68d8950ccfc30b79dbdc916561153d9">_triangulation_type</a>;
<a name="l00253"></a>00253 
<a name="l00259"></a><a class="code" href="classTriangleInterface.php#abdabe2f1e942e831b85d0505de722079">00259</a>   <span class="keywordtype">bool</span> <a class="code" href="classTriangleInterface.php#abdabe2f1e942e831b85d0505de722079">_insert_extra_points</a>;
<a name="l00260"></a>00260 
<a name="l00265"></a><a class="code" href="classTriangleInterface.php#a7400d57511f62528e92f8667587b31d5">00265</a>   <span class="keywordtype">bool</span> <a class="code" href="classTriangleInterface.php#a7400d57511f62528e92f8667587b31d5">_smooth_after_generating</a>;
<a name="l00266"></a>00266 };
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 
<a name="l00269"></a>00269 
<a name="l00270"></a>00270 
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 
<a name="l00273"></a>00273 
<a name="l00280"></a><a class="code" href="classTriangleInterface_1_1Hole.php">00280</a> <span class="keyword">class </span><a class="code" href="classTriangleInterface_1_1Hole.php">TriangleInterface::Hole</a>
<a name="l00281"></a>00281 {
<a name="l00282"></a>00282 <span class="keyword">public</span>:
<a name="l00286"></a><a class="code" href="classTriangleInterface_1_1Hole.php#a2fe973365709526e444408af9e8f0d2d">00286</a>   <a class="code" href="classTriangleInterface_1_1Hole.php#a2fe973365709526e444408af9e8f0d2d">Hole</a>() {}
<a name="l00287"></a>00287 
<a name="l00291"></a><a class="code" href="classTriangleInterface_1_1Hole.php#aa62e137f13a45d8a6cc31d9a4f73236e">00291</a>   <span class="keyword">virtual</span> <a class="code" href="classTriangleInterface_1_1Hole.php#aa62e137f13a45d8a6cc31d9a4f73236e">~Hole</a>() {}
<a name="l00292"></a>00292 
<a name="l00296"></a>00296   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTriangleInterface_1_1Hole.php#a81c5799c41935d8c294afeb016d82360">n_points</a>() <span class="keyword">const</span> = 0;
<a name="l00297"></a>00297 
<a name="l00301"></a>00301   <span class="keyword">virtual</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classTriangleInterface_1_1Hole.php#a044586e5f70e66e6199daeddf3460888">point</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span> = 0;
<a name="l00302"></a>00302 
<a name="l00306"></a>00306   <span class="keyword">virtual</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classTriangleInterface_1_1Hole.php#a6a08f1e36ffc8856448c4013bdeaa1fb">inside</a>() <span class="keyword">const</span> = 0;
<a name="l00307"></a>00307 };
<a name="l00308"></a>00308 
<a name="l00309"></a>00309 
<a name="l00310"></a>00310 
<a name="l00311"></a>00311 
<a name="l00312"></a>00312 
<a name="l00313"></a>00313     
<a name="l00318"></a><a class="code" href="classTriangleInterface_1_1PolygonHole.php">00318</a> <span class="keyword">class </span><a class="code" href="classTriangleInterface_1_1PolygonHole.php">TriangleInterface::PolygonHole</a> : <span class="keyword">public</span> <a class="code" href="classTriangleInterface.php">TriangleInterface</a>::<a class="code" href="classTriangleInterface_1_1Hole.php">Hole</a>
<a name="l00319"></a>00319 {
<a name="l00320"></a>00320 <span class="keyword">public</span>:
<a name="l00326"></a><a class="code" href="classTriangleInterface_1_1PolygonHole.php#a7ce2b9b22a78674aa27e67cd559403e2">00326</a>   <a class="code" href="classTriangleInterface_1_1PolygonHole.php#a7ce2b9b22a78674aa27e67cd559403e2">PolygonHole</a>(<a class="code" href="classPoint.php">Point</a> center, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> radius, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTriangleInterface_1_1PolygonHole.php#acfee142161f4770dfe56d60efb570cbe">n_points</a>) :
<a name="l00327"></a>00327     <a class="code" href="classTriangleInterface_1_1PolygonHole.php#a83f8c8a8ae2deccb90e644d737ee4078">_center</a>(center),
<a name="l00328"></a>00328     <a class="code" href="classTriangleInterface_1_1PolygonHole.php#a1c9b08608fc608eb316b6c5cf002d4ab">_radius</a>(radius),
<a name="l00329"></a>00329     <a class="code" href="classTriangleInterface_1_1PolygonHole.php#aa9841d625e545bc5e0005452a0618867">_n_points</a>(n_points) {}
<a name="l00330"></a>00330 
<a name="l00334"></a>00334   <span class="comment">// PolygonHole() {}</span>
<a name="l00335"></a>00335 
<a name="l00336"></a><a class="code" href="classTriangleInterface_1_1PolygonHole.php#acfee142161f4770dfe56d60efb570cbe">00336</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTriangleInterface_1_1PolygonHole.php#acfee142161f4770dfe56d60efb570cbe">n_points</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classTriangleInterface_1_1PolygonHole.php#aa9841d625e545bc5e0005452a0618867">_n_points</a>; }
<a name="l00337"></a>00337 
<a name="l00338"></a><a class="code" href="classTriangleInterface_1_1PolygonHole.php#af8a07961959fcb64f5c20c806d0449be">00338</a>   <span class="keyword">virtual</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classTriangleInterface_1_1PolygonHole.php#af8a07961959fcb64f5c20c806d0449be">point</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00339"></a>00339 <span class="keyword">  </span>{
<a name="l00340"></a>00340     <span class="comment">// The nth point lies at the angle theta = 2 * pi * n / _n_points</span>
<a name="l00341"></a>00341     <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> theta = <span class="keyword">static_cast&lt;</span><a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a><span class="keyword">&gt;</span>(n) * 2.0 * <a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">libMesh::pi</a> / static_cast&lt;Real&gt;(<a class="code" href="classTriangleInterface_1_1PolygonHole.php#aa9841d625e545bc5e0005452a0618867">_n_points</a>);
<a name="l00342"></a>00342         
<a name="l00343"></a>00343     <span class="keywordflow">return</span> <a class="code" href="classPoint.php">Point</a>(<a class="code" href="classTriangleInterface_1_1PolygonHole.php#a83f8c8a8ae2deccb90e644d737ee4078">_center</a>(0) + <a class="code" href="classTriangleInterface_1_1PolygonHole.php#a1c9b08608fc608eb316b6c5cf002d4ab">_radius</a>*std::cos(theta), <span class="comment">// x=r*cos(theta)</span>
<a name="l00344"></a>00344                  <a class="code" href="classTriangleInterface_1_1PolygonHole.php#a83f8c8a8ae2deccb90e644d737ee4078">_center</a>(1) + <a class="code" href="classTriangleInterface_1_1PolygonHole.php#a1c9b08608fc608eb316b6c5cf002d4ab">_radius</a>*std::sin(theta), <span class="comment">// y=r*sin(theta)</span>
<a name="l00345"></a>00345                  0.);
<a name="l00346"></a>00346   }
<a name="l00347"></a>00347 
<a name="l00351"></a><a class="code" href="classTriangleInterface_1_1PolygonHole.php#a950dab07377fe7011779da09d704bcdb">00351</a>   <span class="keyword">virtual</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classTriangleInterface_1_1PolygonHole.php#a950dab07377fe7011779da09d704bcdb">inside</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classTriangleInterface_1_1PolygonHole.php#a83f8c8a8ae2deccb90e644d737ee4078">_center</a>;  }
<a name="l00352"></a>00352       
<a name="l00353"></a>00353 <span class="keyword">private</span>:
<a name="l00357"></a><a class="code" href="classTriangleInterface_1_1PolygonHole.php#a83f8c8a8ae2deccb90e644d737ee4078">00357</a>   <a class="code" href="classPoint.php">Point</a> <a class="code" href="classTriangleInterface_1_1PolygonHole.php#a83f8c8a8ae2deccb90e644d737ee4078">_center</a>;
<a name="l00358"></a>00358 
<a name="l00362"></a><a class="code" href="classTriangleInterface_1_1PolygonHole.php#a1c9b08608fc608eb316b6c5cf002d4ab">00362</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classTriangleInterface_1_1PolygonHole.php#a1c9b08608fc608eb316b6c5cf002d4ab">_radius</a>;
<a name="l00363"></a>00363 
<a name="l00369"></a><a class="code" href="classTriangleInterface_1_1PolygonHole.php#aa9841d625e545bc5e0005452a0618867">00369</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTriangleInterface_1_1PolygonHole.php#aa9841d625e545bc5e0005452a0618867">_n_points</a>;
<a name="l00370"></a>00370 };
<a name="l00371"></a>00371 
<a name="l00372"></a>00372 
<a name="l00373"></a>00373 
<a name="l00374"></a>00374 
<a name="l00375"></a>00375 
<a name="l00376"></a>00376     
<a name="l00377"></a>00377 
<a name="l00385"></a><a class="code" href="classTriangleInterface_1_1ArbitraryHole.php">00385</a> <span class="keyword">class </span><a class="code" href="classTriangleInterface_1_1ArbitraryHole.php">TriangleInterface::ArbitraryHole</a> : <span class="keyword">public</span> <a class="code" href="classTriangleInterface.php">TriangleInterface</a>::<a class="code" href="classTriangleInterface_1_1Hole.php">Hole</a>
<a name="l00386"></a>00386 {
<a name="l00387"></a>00387 <span class="keyword">public</span>:
<a name="l00388"></a><a class="code" href="classTriangleInterface_1_1ArbitraryHole.php#ad42afdee8c880cb37ffdd18c6d658125">00388</a>   <a class="code" href="classTriangleInterface_1_1ArbitraryHole.php#ad42afdee8c880cb37ffdd18c6d658125">ArbitraryHole</a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> center,
<a name="l00389"></a>00389                 <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; points)
<a name="l00390"></a>00390     :   <a class="code" href="classTriangleInterface_1_1ArbitraryHole.php#a15f6226cabe6fa9d390b811255ac6a83">_center</a>(center),
<a name="l00391"></a>00391         <a class="code" href="classTriangleInterface_1_1ArbitraryHole.php#a557d436897e97fe922cf1571b7c42f0f">_points</a>(points)
<a name="l00392"></a>00392   {}
<a name="l00393"></a>00393 
<a name="l00401"></a><a class="code" href="classTriangleInterface_1_1ArbitraryHole.php#a5593993996407d73228a7fcdf5df1b1d">00401</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTriangleInterface_1_1ArbitraryHole.php#a5593993996407d73228a7fcdf5df1b1d">n_points</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classTriangleInterface_1_1ArbitraryHole.php#a557d436897e97fe922cf1571b7c42f0f">_points</a>.size(); }
<a name="l00402"></a>00402 
<a name="l00406"></a><a class="code" href="classTriangleInterface_1_1ArbitraryHole.php#a8be161f6ef4ada4937b169da21c8877b">00406</a>   <span class="keyword">virtual</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classTriangleInterface_1_1ArbitraryHole.php#a8be161f6ef4ada4937b169da21c8877b">point</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00407"></a>00407 <span class="keyword">  </span>{
<a name="l00408"></a>00408     libmesh_assert (n &lt; <a class="code" href="classTriangleInterface_1_1ArbitraryHole.php#a557d436897e97fe922cf1571b7c42f0f">_points</a>.size());
<a name="l00409"></a>00409     <span class="keywordflow">return</span> <a class="code" href="classTriangleInterface_1_1ArbitraryHole.php#a557d436897e97fe922cf1571b7c42f0f">_points</a>[n];
<a name="l00410"></a>00410   }
<a name="l00411"></a>00411 
<a name="l00415"></a><a class="code" href="classTriangleInterface_1_1ArbitraryHole.php#a6d0c765299bb1860d90659c914946656">00415</a>   <span class="keyword">virtual</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classTriangleInterface_1_1ArbitraryHole.php#a6d0c765299bb1860d90659c914946656">inside</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classTriangleInterface_1_1ArbitraryHole.php#a15f6226cabe6fa9d390b811255ac6a83">_center</a>;  }
<a name="l00416"></a>00416 
<a name="l00417"></a>00417 <span class="keyword">private</span>:
<a name="l00421"></a><a class="code" href="classTriangleInterface_1_1ArbitraryHole.php#a15f6226cabe6fa9d390b811255ac6a83">00421</a>   <a class="code" href="classPoint.php">Point</a> <a class="code" href="classTriangleInterface_1_1ArbitraryHole.php#a15f6226cabe6fa9d390b811255ac6a83">_center</a>;
<a name="l00422"></a>00422 
<a name="l00427"></a><a class="code" href="classTriangleInterface_1_1ArbitraryHole.php#a557d436897e97fe922cf1571b7c42f0f">00427</a>   <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; <a class="code" href="classTriangleInterface_1_1ArbitraryHole.php#a557d436897e97fe922cf1571b7c42f0f">_points</a>;
<a name="l00428"></a>00428 };
<a name="l00429"></a>00429 
<a name="l00430"></a>00430 
<a name="l00431"></a>00431 
<a name="l00432"></a>00432 
<a name="l00433"></a>00433 
<a name="l00437"></a>00437 <span class="keyword">namespace </span>MeshTools
<a name="l00438"></a>00438 {
<a name="l00439"></a>00439   <span class="keyword">namespace </span>Generation
<a name="l00440"></a>00440   {
<a name="l00441"></a>00441 
<a name="l00447"></a>00447     <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools_1_1Generation.php#addc1168079a94fd08dd1b0efd93b2c77">build_delaunay_square</a>(<a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; mesh,
<a name="l00448"></a>00448                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nx, <span class="comment">// num. of elements in x-dir</span>
<a name="l00449"></a>00449                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ny, <span class="comment">// num. of elements in y-dir</span>
<a name="l00450"></a>00450                                <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xmin, <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xmax,
<a name="l00451"></a>00451                                <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> ymin, <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> ymax,
<a name="l00452"></a>00452                                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type,
<a name="l00453"></a>00453                                <span class="keyword">const</span> std::vector&lt;TriangleInterface::Hole*&gt;* holes=NULL);
<a name="l00454"></a>00454   }
<a name="l00455"></a>00455 }
<a name="l00456"></a>00456 
<a name="l00457"></a>00457 
<a name="l00458"></a>00458 
<a name="l00459"></a>00459 
<a name="l00460"></a>00460 <span class="preprocessor">#endif // LIBMESH_HAVE_TRIANGLE</span>
<a name="l00461"></a>00461 <span class="preprocessor"></span>
<a name="l00462"></a>00462 <span class="preprocessor">#endif // ifndef __mesh_triangle_support_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
