<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_7059df55b9d3d0975f6468fedce13a55.php">partitioning</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>metis_partitioner.C</h1>  </div>
</div>
<div class="contents">
<a href="metis__partitioner_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: metis_partitioner.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;metis_partitioner.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;mesh_communication.h&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#ifdef LIBMESH_HAVE_METIS</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span><span class="comment">// MIPSPro 7.4.2 gets confused about these nested namespaces</span>
<a name="l00035"></a>00035 <span class="preprocessor"># ifdef __sgi</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span><span class="preprocessor">#  include &lt;cstdarg&gt;</span>
<a name="l00037"></a>00037 <span class="preprocessor"># endif</span>
<a name="l00038"></a><a class="code" href="namespaceMetis.php">00038</a> <span class="preprocessor"></span>  <span class="keyword">namespace </span>Metis {
<a name="l00039"></a>00039     <span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {
<a name="l00040"></a>00040 <span class="preprocessor">#     include &quot;metis.h&quot;</span>
<a name="l00041"></a>00041     }
<a name="l00042"></a>00042   }
<a name="l00043"></a>00043 <span class="preprocessor">#else</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span><span class="preprocessor">#  include &quot;sfc_partitioner.h&quot;</span>
<a name="l00045"></a>00045 <span class="preprocessor">#endif</span>
<a name="l00046"></a>00046 <span class="preprocessor"></span>
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00050"></a>00050 <span class="comment">// MetisPartitioner implementation</span>
<a name="l00051"></a><a class="code" href="classMetisPartitioner.php#ac3177b9f9973c31e0e656e0317b4e34d">00051</a> <span class="keywordtype">void</span> <a class="code" href="classMetisPartitioner.php#ac3177b9f9973c31e0e656e0317b4e34d">MetisPartitioner::_do_partition</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00052"></a>00052                                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_pieces)
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054   libmesh_assert (n_pieces &gt; 0);
<a name="l00055"></a>00055   libmesh_assert (mesh.<a class="code" href="classMeshBase.php#a660bb92c9fb94527d1cabfb1fdd6d056">is_serial</a>());
<a name="l00056"></a>00056 
<a name="l00057"></a>00057   <span class="comment">// Check for an easy return</span>
<a name="l00058"></a>00058   <span class="keywordflow">if</span> (n_pieces == 1)
<a name="l00059"></a>00059     {
<a name="l00060"></a>00060       this-&gt;<a class="code" href="classPartitioner.php#a1108dd58c055d536d489dc06cc0823ec">single_partition</a> (mesh);
<a name="l00061"></a>00061       <span class="keywordflow">return</span>;
<a name="l00062"></a>00062     }
<a name="l00063"></a>00063   
<a name="l00064"></a>00064 <span class="comment">// What to do if the Metis library IS NOT present</span>
<a name="l00065"></a>00065 <span class="preprocessor">#ifndef LIBMESH_HAVE_METIS</span>
<a name="l00066"></a>00066 <span class="preprocessor"></span>
<a name="l00067"></a>00067   libmesh_here();
<a name="l00068"></a>00068   std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: The library has been built without&quot;</span>    &lt;&lt; std::endl
<a name="l00069"></a>00069             &lt;&lt; <span class="stringliteral">&quot;Metis support.  Using a space-filling curve&quot;</span>  &lt;&lt; std::endl
<a name="l00070"></a>00070             &lt;&lt; <span class="stringliteral">&quot;partitioner instead!&quot;</span>                         &lt;&lt; std::endl;
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   <a class="code" href="classSFCPartitioner.php">SFCPartitioner</a> sfcp;
<a name="l00073"></a>00073 
<a name="l00074"></a>00074   sfcp.<a class="code" href="classPartitioner.php#a6c8f1c4dac2b50c4ed0e30088e0c4063">partition</a> (mesh, n_pieces);
<a name="l00075"></a>00075   
<a name="l00076"></a>00076 <span class="comment">// What to do if the Metis library IS present</span>
<a name="l00077"></a>00077 <span class="preprocessor">#else</span>
<a name="l00078"></a>00078 <span class="preprocessor"></span>  
<a name="l00079"></a>00079   START_LOG(<span class="stringliteral">&quot;partition()&quot;</span>, <span class="stringliteral">&quot;MetisPartitioner&quot;</span>);
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_active_elem = mesh.<a class="code" href="classMeshBase.php#a246697678d5d14a986cee2b6fbdbae6b">n_active_elem</a>();
<a name="l00082"></a>00082   
<a name="l00083"></a>00083   <span class="comment">// build the graph  </span>
<a name="l00084"></a>00084   std::vector&lt;int&gt; options(5);
<a name="l00085"></a>00085   std::vector&lt;int&gt; vwgt(n_active_elem);
<a name="l00086"></a>00086   std::vector&lt;int&gt; part(n_active_elem);
<a name="l00087"></a>00087   
<a name="l00088"></a>00088   <span class="keywordtype">int</span>
<a name="l00089"></a>00089     n = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n_active_elem),  <span class="comment">// number of &quot;nodes&quot; (elements)</span>
<a name="l00090"></a>00090                                           <span class="comment">//   in the graph</span>
<a name="l00091"></a>00091     wgtflag = 2,                          <span class="comment">// weights on vertices only,</span>
<a name="l00092"></a>00092                                           <span class="comment">//   none on edges</span>
<a name="l00093"></a>00093     numflag = 0,                          <span class="comment">// C-style 0-based numbering</span>
<a name="l00094"></a>00094     nparts  = static_cast&lt;int&gt;(n_pieces), <span class="comment">// number of subdomains to create</span>
<a name="l00095"></a>00095     edgecut = 0;                          <span class="comment">// the numbers of edges cut by the</span>
<a name="l00096"></a>00096                                           <span class="comment">//   resulting partition</span>
<a name="l00097"></a>00097   
<a name="l00098"></a>00098   <span class="comment">// Set the options</span>
<a name="l00099"></a>00099   options[0] = 0; <span class="comment">// use default options</span>
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   <span class="comment">// Metis will only consider the active elements.</span>
<a name="l00102"></a>00102   <span class="comment">// We need to map the active element ids into a</span>
<a name="l00103"></a>00103   <span class="comment">// contiguous range.  Further, we want the unique range indexing to be</span>
<a name="l00104"></a>00104   <span class="comment">// independednt of the element ordering, otherwise a circular dependency</span>
<a name="l00105"></a>00105   <span class="comment">// can result in which the partitioning depends on the ordering which </span>
<a name="l00106"></a>00106   <span class="comment">// depends on the partitioning...</span>
<a name="l00107"></a>00107   std::map&lt;const Elem*, unsigned int&gt; global_index_map;
<a name="l00108"></a>00108   {
<a name="l00109"></a>00109     std::vector&lt;unsigned int&gt; global_index;
<a name="l00110"></a>00110     
<a name="l00111"></a>00111     <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       it  = mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00112"></a>00112     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00113"></a>00113     
<a name="l00114"></a>00114     <a class="code" href="classMeshCommunication.php">MeshCommunication</a>().<a class="code" href="classMeshCommunication.php#ad39ffc569ad59944067e273a77a06abd">find_global_indices</a> (<a class="code" href="namespaceMeshTools.php#ad533681876e9809cfe5e2114886b1c03">MeshTools::bounding_box</a>(mesh),
<a name="l00115"></a>00115                                              it, end, global_index);
<a name="l00116"></a>00116     
<a name="l00117"></a>00117     libmesh_assert (global_index.size() == n_active_elem);    
<a name="l00118"></a>00118     
<a name="l00119"></a>00119     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0; it != end; ++it)
<a name="l00120"></a>00120       {
<a name="l00121"></a>00121         <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *elem = *it;
<a name="l00122"></a>00122         libmesh_assert (!global_index_map.count(elem));
<a name="l00123"></a>00123         
<a name="l00124"></a>00124         global_index_map[elem]  = global_index[cnt++];
<a name="l00125"></a>00125       }
<a name="l00126"></a>00126     libmesh_assert (global_index_map.size() == n_active_elem);    
<a name="l00127"></a>00127   }
<a name="l00128"></a>00128   
<a name="l00129"></a>00129   
<a name="l00130"></a>00130   <span class="comment">// build the graph in CSR format.  Note that</span>
<a name="l00131"></a>00131   <span class="comment">// the edges in the graph will correspond to</span>
<a name="l00132"></a>00132   <span class="comment">// face neighbors</span>
<a name="l00133"></a>00133   std::vector&lt;int&gt; xadj, adjncy;
<a name="l00134"></a>00134   {
<a name="l00135"></a>00135     std::vector&lt;const Elem*&gt; neighbors_offspring;    
<a name="l00136"></a>00136     
<a name="l00137"></a>00137     <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00138"></a>00138     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00139"></a>00139     
<a name="l00140"></a>00140     <span class="comment">// This will be exact when there is no refinement and all the</span>
<a name="l00141"></a>00141     <span class="comment">// elements are of the same type.</span>
<a name="l00142"></a>00142     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> graph_size=0;
<a name="l00143"></a>00143     std::vector&lt;std::vector&lt;unsigned int&gt; &gt; graph(n_active_elem);
<a name="l00144"></a>00144     
<a name="l00145"></a>00145     <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00146"></a>00146       {
<a name="l00147"></a>00147         <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *elem_it;
<a name="l00148"></a>00148         
<a name="l00149"></a>00149         libmesh_assert (global_index_map.count(elem));
<a name="l00150"></a>00150         
<a name="l00151"></a>00151         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_global_index = 
<a name="l00152"></a>00152           global_index_map[elem];
<a name="l00153"></a>00153         
<a name="l00154"></a>00154         libmesh_assert (elem_global_index &lt; vwgt.size());
<a name="l00155"></a>00155         libmesh_assert (elem_global_index &lt; graph.size());
<a name="l00156"></a>00156 
<a name="l00157"></a>00157         <span class="comment">// maybe there is a better weight?</span>
<a name="l00158"></a>00158         <span class="comment">// The weight is used to define what a balanced graph is</span>
<a name="l00159"></a>00159         vwgt[elem_global_index] = elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); 
<a name="l00160"></a>00160 
<a name="l00161"></a>00161         <span class="comment">// Loop over the element&#39;s neighbors.  An element</span>
<a name="l00162"></a>00162         <span class="comment">// adjacency corresponds to a face neighbor</span>
<a name="l00163"></a>00163         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ms=0; ms&lt;elem-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); ms++)
<a name="l00164"></a>00164           {
<a name="l00165"></a>00165             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* neighbor = elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(ms);
<a name="l00166"></a>00166             
<a name="l00167"></a>00167             <span class="keywordflow">if</span> (neighbor != NULL)
<a name="l00168"></a>00168               {  
<a name="l00169"></a>00169                 <span class="comment">// If the neighbor is active treat it</span>
<a name="l00170"></a>00170                 <span class="comment">// as a connection</span>
<a name="l00171"></a>00171                 <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l00172"></a>00172                   {
<a name="l00173"></a>00173                     libmesh_assert (global_index_map.count(neighbor));
<a name="l00174"></a>00174                     
<a name="l00175"></a>00175                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> neighbor_global_index = 
<a name="l00176"></a>00176                       global_index_map[neighbor];
<a name="l00177"></a>00177                     
<a name="l00178"></a>00178                     graph[elem_global_index].push_back(neighbor_global_index);
<a name="l00179"></a>00179                     graph_size++;
<a name="l00180"></a>00180                   }
<a name="l00181"></a>00181   
<a name="l00182"></a>00182 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00183"></a>00183 <span class="preprocessor"></span>                
<a name="l00184"></a>00184                 <span class="comment">// Otherwise we need to find all of the</span>
<a name="l00185"></a>00185                 <span class="comment">// neighbor&#39;s children that are connected to</span>
<a name="l00186"></a>00186                 <span class="comment">// us and add them</span>
<a name="l00187"></a>00187                 <span class="keywordflow">else</span>
<a name="l00188"></a>00188                   {
<a name="l00189"></a>00189                     <span class="comment">// The side of the neighbor to which</span>
<a name="l00190"></a>00190                     <span class="comment">// we are connected</span>
<a name="l00191"></a>00191                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns =
<a name="l00192"></a>00192                       neighbor-&gt;<a class="code" href="classElem.php#acab8fea073846b18b149ed2b88d43aff">which_neighbor_am_i</a> (elem);
<a name="l00193"></a>00193                     libmesh_assert (ns &lt; neighbor-&gt;n_neighbors());
<a name="l00194"></a>00194                     
<a name="l00195"></a>00195                     <span class="comment">// Get all the active children (&amp; grandchildren, etc...)</span>
<a name="l00196"></a>00196                     <span class="comment">// of the neighbor.</span>
<a name="l00197"></a>00197                     neighbor-&gt;<a class="code" href="classElem.php#a51ae47d8c3c024b8dc1098b9392a1161">active_family_tree</a> (neighbors_offspring);
<a name="l00198"></a>00198                     
<a name="l00199"></a>00199                     <span class="comment">// Get all the neighbor&#39;s children that</span>
<a name="l00200"></a>00200                     <span class="comment">// live on that side and are thus connected</span>
<a name="l00201"></a>00201                     <span class="comment">// to us</span>
<a name="l00202"></a>00202                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc=0; nc&lt;neighbors_offspring.size(); nc++)
<a name="l00203"></a>00203                       {
<a name="l00204"></a>00204                         <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* child =
<a name="l00205"></a>00205                           neighbors_offspring[nc];
<a name="l00206"></a>00206                         
<a name="l00207"></a>00207                         <span class="comment">// This does not assume a level-1 mesh.</span>
<a name="l00208"></a>00208                         <span class="comment">// Note that since children have sides numbered</span>
<a name="l00209"></a>00209                         <span class="comment">// coincident with the parent then this is a sufficient test.</span>
<a name="l00210"></a>00210                         <span class="keywordflow">if</span> (child-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(ns) == elem)
<a name="l00211"></a>00211                           {
<a name="l00212"></a>00212                             libmesh_assert (child-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>());
<a name="l00213"></a>00213                             libmesh_assert (global_index_map.count(child));
<a name="l00214"></a>00214 
<a name="l00215"></a>00215                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> child_global_index =
<a name="l00216"></a>00216                               global_index_map[child];
<a name="l00217"></a>00217                             
<a name="l00218"></a>00218                             graph[elem_global_index].push_back(child_global_index);
<a name="l00219"></a>00219                             graph_size++;
<a name="l00220"></a>00220                           }
<a name="l00221"></a>00221                       }
<a name="l00222"></a>00222                   }
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 <span class="preprocessor">#endif </span><span class="comment">/* ifdef LIBMESH_ENABLE_AMR */</span>
<a name="l00225"></a>00225 
<a name="l00226"></a>00226               }
<a name="l00227"></a>00227           }
<a name="l00228"></a>00228       }
<a name="l00229"></a>00229     
<a name="l00230"></a>00230     <span class="comment">// Convert the graph into the format Metis wants</span>
<a name="l00231"></a>00231     xadj.reserve(n_active_elem+1);
<a name="l00232"></a>00232     adjncy.reserve(graph_size);
<a name="l00233"></a>00233     
<a name="l00234"></a>00234     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> r=0; r&lt;graph.size(); r++)
<a name="l00235"></a>00235       {
<a name="l00236"></a>00236         xadj.push_back(adjncy.size());
<a name="l00237"></a>00237         std::vector&lt;unsigned int&gt; graph_row; <span class="comment">// build this emtpy</span>
<a name="l00238"></a>00238         graph_row.swap(graph[r]); <span class="comment">// this will deallocate at the end of scope</span>
<a name="l00239"></a>00239         adjncy.insert(adjncy.end(),
<a name="l00240"></a>00240                       graph_row.begin(),
<a name="l00241"></a>00241                       graph_row.end());
<a name="l00242"></a>00242       }
<a name="l00243"></a>00243 
<a name="l00244"></a>00244     <span class="comment">// The end of the adjacency array for the last elem</span>
<a name="l00245"></a>00245     xadj.push_back(adjncy.size());
<a name="l00246"></a>00246     
<a name="l00247"></a>00247     libmesh_assert (adjncy.size() == graph_size);
<a name="l00248"></a>00248     libmesh_assert (xadj.size() == n_active_elem+1);    
<a name="l00249"></a>00249   } <span class="comment">// done building the graph</span>
<a name="l00250"></a>00250   
<a name="l00251"></a>00251   
<a name="l00252"></a>00252   <span class="keywordflow">if</span> (adjncy.empty())
<a name="l00253"></a>00253     adjncy.push_back(0);
<a name="l00254"></a>00254   
<a name="l00255"></a>00255   <span class="comment">// Select which type of partitioning to create</span>
<a name="l00256"></a>00256   
<a name="l00257"></a>00257   <span class="comment">// Use recursive if the number of partitions is less than or equal to 8</span>
<a name="l00258"></a>00258   <span class="keywordflow">if</span> (n_pieces &lt;= 8)
<a name="l00259"></a>00259     Metis::METIS_PartGraphRecursive(&amp;n, &amp;xadj[0], &amp;adjncy[0], &amp;vwgt[0], NULL,
<a name="l00260"></a>00260                                     &amp;wgtflag, &amp;numflag, &amp;nparts, &amp;options[0],
<a name="l00261"></a>00261                                     &amp;edgecut, &amp;part[0]);
<a name="l00262"></a>00262   
<a name="l00263"></a>00263   <span class="comment">// Otherwise  use kway</span>
<a name="l00264"></a>00264   <span class="keywordflow">else</span>
<a name="l00265"></a>00265     Metis::METIS_PartGraphKway(&amp;n, &amp;xadj[0], &amp;adjncy[0], &amp;vwgt[0], NULL,
<a name="l00266"></a>00266                                &amp;wgtflag, &amp;numflag, &amp;nparts, &amp;options[0],
<a name="l00267"></a>00267                                &amp;edgecut, &amp;part[0]);
<a name="l00268"></a>00268   
<a name="l00269"></a>00269   
<a name="l00270"></a>00270   <span class="comment">// Assign the returned processor ids.  The part array contains</span>
<a name="l00271"></a>00271   <span class="comment">// the processor id for each active element, but in terms of</span>
<a name="l00272"></a>00272   <span class="comment">// the contiguous indexing we defined above</span>
<a name="l00273"></a>00273   {
<a name="l00274"></a>00274     <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       it  = mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00275"></a>00275     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00276"></a>00276     
<a name="l00277"></a>00277     <span class="keywordflow">for</span> (; it!=end; ++it)
<a name="l00278"></a>00278       {
<a name="l00279"></a>00279         <a class="code" href="classElem.php">Elem</a>* elem = *it;
<a name="l00280"></a>00280         
<a name="l00281"></a>00281         libmesh_assert (global_index_map.count(elem));
<a name="l00282"></a>00282         
<a name="l00283"></a>00283         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_global_index = 
<a name="l00284"></a>00284           global_index_map[elem];
<a name="l00285"></a>00285         
<a name="l00286"></a>00286         libmesh_assert (elem_global_index &lt; part.size());
<a name="l00287"></a>00287         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_procid =  <span class="keyword">static_cast&lt;</span><span class="keywordtype">short</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(part[elem_global_index]);
<a name="l00288"></a>00288     
<a name="l00289"></a>00289         elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() = elem_procid;
<a name="l00290"></a>00290       }
<a name="l00291"></a>00291   }
<a name="l00292"></a>00292 
<a name="l00293"></a>00293   STOP_LOG(<span class="stringliteral">&quot;partition()&quot;</span>, <span class="stringliteral">&quot;MetisPartitioner&quot;</span>);
<a name="l00294"></a>00294 <span class="preprocessor">#endif</span>
<a name="l00295"></a>00295 <span class="preprocessor"></span>}
<a name="l00296"></a>00296   
<a name="l00297"></a>00297 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
