<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_a444518d96d2df902338d2a7eb3a040c.php">base</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>multi_predicates.h</h1>  </div>
</div>
<div class="contents">
<a href="multi__predicates_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: multi_predicates.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __multi_predicates_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __multi_predicates_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__base_8h.php">libmesh_base.h</a>&quot;</span> <span class="comment">// for libMesh::processor_id()</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="single__predicates_8h.php">single_predicates.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00034"></a><a class="code" href="namespacePredicates.php">00034</a> <span class="keyword">namespace </span>Predicates
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036   
<a name="l00037"></a>00037   <span class="comment">// Empty place-holder base class for multi_predicates</span>
<a name="l00038"></a><a class="code" href="structPredicates_1_1multi__predicate.php">00038</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1multi__predicate.php">multi_predicate</a> {};
<a name="l00039"></a>00039   
<a name="l00040"></a>00040 
<a name="l00041"></a>00041   <span class="comment">// This class represents a generic combination of more than one predicate.</span>
<a name="l00042"></a>00042   <span class="comment">// It is meant to be derived from to actually be used.</span>
<a name="l00043"></a>00043   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00044"></a><a class="code" href="structPredicates_1_1abstract__multi__predicate.php">00044</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a> : <a class="code" href="structPredicates_1_1multi__predicate.php">multi_predicate</a>
<a name="l00045"></a>00045   {
<a name="l00046"></a>00046     <span class="comment">// virtual destructor.</span>
<a name="l00047"></a><a class="code" href="structPredicates_1_1abstract__multi__predicate.php#ac5dcb5e3836b8a512ce0c2779d6473bf">00047</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1abstract__multi__predicate.php#ac5dcb5e3836b8a512ce0c2779d6473bf">~abstract_multi_predicate</a>()
<a name="l00048"></a>00048     {
<a name="l00049"></a>00049       <span class="comment">// Clean-up vector</span>
<a name="l00050"></a>00050       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.size(); ++i)
<a name="l00051"></a>00051         <span class="keyword">delete</span> <a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>[i];
<a name="l00052"></a>00052     }
<a name="l00053"></a>00053 
<a name="l00054"></a>00054     <span class="comment">// operator= (perform deep copy of entries in _predicates vector</span>
<a name="l00055"></a><a class="code" href="structPredicates_1_1abstract__multi__predicate.php#a355a400ea631d92148762dcfcd54bb92">00055</a>     <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&amp; <a class="code" href="structPredicates_1_1abstract__multi__predicate.php#a355a400ea631d92148762dcfcd54bb92">operator=</a>(<span class="keyword">const</span> <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&amp; rhs)
<a name="l00056"></a>00056     {
<a name="l00057"></a>00057       <span class="comment">// First clear out the predicates vector</span>
<a name="l00058"></a>00058       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.size(); ++i)
<a name="l00059"></a>00059         <span class="keyword">delete</span> <a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>[i];
<a name="l00060"></a>00060 
<a name="l00061"></a>00061       <span class="comment">// Now copy over the information from the rhs.</span>
<a name="l00062"></a>00062       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aceb0aa0e596cb17c5f16ca8b108d22d1">deep_copy</a>(rhs);
<a name="l00063"></a>00063       
<a name="l00064"></a>00064       <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00065"></a>00065     }
<a name="l00066"></a>00066     
<a name="l00067"></a>00067     <span class="comment">// operator() checks all the predicates in the vector.</span>
<a name="l00068"></a><a class="code" href="structPredicates_1_1abstract__multi__predicate.php#a741192cdedfa11b349ec85ae901f32d9">00068</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structPredicates_1_1abstract__multi__predicate.php#a741192cdedfa11b349ec85ae901f32d9">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const</span>
<a name="l00069"></a>00069 <span class="keyword">    </span>{
<a name="l00070"></a>00070       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.size(); ++i)
<a name="l00071"></a>00071         {
<a name="l00072"></a>00072           <span class="keyword">const</span> <a class="code" href="structPredicates_1_1predicate.php">predicate&lt;T&gt;</a>* pred = <a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>[i];
<a name="l00073"></a>00073 
<a name="l00074"></a>00074           libmesh_assert (pred != NULL);
<a name="l00075"></a>00075           
<a name="l00076"></a>00076           <span class="keywordflow">if</span> ( ! (*pred)(it) )
<a name="l00077"></a>00077             <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00078"></a>00078         }
<a name="l00079"></a>00079       
<a name="l00080"></a>00080       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00081"></a>00081     }
<a name="l00082"></a>00082     
<a name="l00083"></a>00083   <span class="keyword">protected</span>:
<a name="l00084"></a>00084     <span class="comment">// Do not instantiate the base class.</span>
<a name="l00085"></a><a class="code" href="structPredicates_1_1abstract__multi__predicate.php#a890310d076fb1718fc671febc1d864e3">00085</a>     <a class="code" href="structPredicates_1_1abstract__multi__predicate.php#a890310d076fb1718fc671febc1d864e3">abstract_multi_predicate</a>() {}
<a name="l00086"></a>00086 
<a name="l00087"></a>00087     <span class="comment">// Copy constructor.</span>
<a name="l00088"></a><a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aaf4a7219dd579e31b031f3544a3e9778">00088</a>     <a class="code" href="structPredicates_1_1abstract__multi__predicate.php#a890310d076fb1718fc671febc1d864e3">abstract_multi_predicate</a>(<span class="keyword">const</span> <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&amp; rhs)
<a name="l00089"></a>00089     {
<a name="l00090"></a>00090       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aceb0aa0e596cb17c5f16ca8b108d22d1">deep_copy</a>(rhs);
<a name="l00091"></a>00091     }
<a name="l00092"></a>00092 
<a name="l00093"></a>00093     <span class="comment">// The deep_copy function is used by both the op= and</span>
<a name="l00094"></a>00094     <span class="comment">// copy constructors.  This function uses the default (empty)</span>
<a name="l00095"></a>00095     <span class="comment">// copy constructor for the predicate class.</span>
<a name="l00096"></a><a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aceb0aa0e596cb17c5f16ca8b108d22d1">00096</a>     <span class="keywordtype">void</span> <a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aceb0aa0e596cb17c5f16ca8b108d22d1">deep_copy</a>(<span class="keyword">const</span> <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&amp; rhs)
<a name="l00097"></a>00097     {
<a name="l00098"></a>00098       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;rhs.<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.size(); ++i)
<a name="l00099"></a>00099         <a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(rhs.<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>[i]-&gt;clone());
<a name="l00100"></a>00100     }
<a name="l00101"></a>00101     
<a name="l00102"></a>00102     <span class="comment">// Predicates to be evaluated.</span>
<a name="l00103"></a><a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">00103</a>     std::vector&lt;predicate&lt;T&gt;*&gt; <a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>;
<a name="l00104"></a>00104   };
<a name="l00105"></a>00105   
<a name="l00106"></a>00106   
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   <span class="comment">// Instantiation of the IsNull abstract_multi_predicate.</span>
<a name="l00109"></a>00109   <span class="comment">// This would be used to iterate over NULL entries in a container.</span>
<a name="l00110"></a>00110   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00111"></a><a class="code" href="structPredicates_1_1IsNull.php">00111</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1IsNull.php">IsNull</a> : <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;
<a name="l00112"></a>00112   {
<a name="l00113"></a>00113     <span class="comment">// Constructor, pushes back a single predicate</span>
<a name="l00114"></a><a class="code" href="structPredicates_1_1IsNull.php#a2947b6b19ef1b37d016611035405222f">00114</a>     <a class="code" href="structPredicates_1_1IsNull.php#a2947b6b19ef1b37d016611035405222f">IsNull</a>()
<a name="l00115"></a>00115     {
<a name="l00116"></a>00116       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1is__null.php">is_null&lt;T&gt;</a>);
<a name="l00117"></a>00117     }
<a name="l00118"></a>00118   };
<a name="l00119"></a>00119   
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   
<a name="l00125"></a>00125   <span class="comment">// Instantiation for the NotNull abstract_multi_predicate</span>
<a name="l00126"></a>00126   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00127"></a><a class="code" href="structPredicates_1_1NotNull.php">00127</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1NotNull.php">NotNull</a> : <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;
<a name="l00128"></a>00128   {
<a name="l00129"></a>00129     <span class="comment">// Constructor, pushes back a single predicate</span>
<a name="l00130"></a><a class="code" href="structPredicates_1_1NotNull.php#a7550fdcc5641f5efcc94a42eb2db325b">00130</a>     <a class="code" href="structPredicates_1_1NotNull.php#a7550fdcc5641f5efcc94a42eb2db325b">NotNull</a>()
<a name="l00131"></a>00131     {
<a name="l00132"></a>00132       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__null.php">not_null&lt;T&gt;</a>);
<a name="l00133"></a>00133     }
<a name="l00134"></a>00134   };
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 
<a name="l00140"></a>00140   <span class="comment">// Instantiation for the Active abstract_multi_predicate</span>
<a name="l00141"></a>00141   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00142"></a><a class="code" href="structPredicates_1_1Active.php">00142</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1Active.php">Active</a> : <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;
<a name="l00143"></a>00143   {
<a name="l00144"></a>00144     <span class="comment">// Constructor, pushes back two single predicates</span>
<a name="l00145"></a><a class="code" href="structPredicates_1_1Active.php#a452025663fab09f33cf0053537447bae">00145</a>     <a class="code" href="structPredicates_1_1Active.php#a452025663fab09f33cf0053537447bae">Active</a>()
<a name="l00146"></a>00146     {
<a name="l00147"></a>00147       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__null.php">not_null&lt;T&gt;</a>);
<a name="l00148"></a>00148       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1active.php">active&lt;T&gt;</a>);
<a name="l00149"></a>00149     }
<a name="l00150"></a>00150   };
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154   <span class="comment">// Instantiation for the NotActive abstract_multi_predicate</span>
<a name="l00155"></a>00155   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00156"></a><a class="code" href="structPredicates_1_1NotActive.php">00156</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1NotActive.php">NotActive</a> : <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;
<a name="l00157"></a>00157   {
<a name="l00158"></a>00158     <span class="comment">// Constructor, pushes back two single predicates</span>
<a name="l00159"></a><a class="code" href="structPredicates_1_1NotActive.php#a63530602f921f6d424a324a7a5fc3b60">00159</a>     <a class="code" href="structPredicates_1_1NotActive.php#a63530602f921f6d424a324a7a5fc3b60">NotActive</a>()
<a name="l00160"></a>00160     {
<a name="l00161"></a>00161       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__null.php">not_null&lt;T&gt;</a>);
<a name="l00162"></a>00162       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__active.php">not_active&lt;T&gt;</a>);
<a name="l00163"></a>00163     }
<a name="l00164"></a>00164   };
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00167"></a>00167   
<a name="l00168"></a>00168 
<a name="l00169"></a>00169   <span class="comment">// Instantiation for the Ancestor abstract_multi_predicate</span>
<a name="l00170"></a>00170   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00171"></a><a class="code" href="structPredicates_1_1Ancestor.php">00171</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1Ancestor.php">Ancestor</a> : <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;
<a name="l00172"></a>00172   {
<a name="l00173"></a>00173     <span class="comment">// Constructor, pushes back two single predicates</span>
<a name="l00174"></a><a class="code" href="structPredicates_1_1Ancestor.php#a4718d59c74e7c27b3dd76cbfb43703ad">00174</a>     <a class="code" href="structPredicates_1_1Ancestor.php#a4718d59c74e7c27b3dd76cbfb43703ad">Ancestor</a>()
<a name="l00175"></a>00175     {
<a name="l00176"></a>00176       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__null.php">not_null&lt;T&gt;</a>);
<a name="l00177"></a>00177       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1ancestor.php">ancestor&lt;T&gt;</a>);
<a name="l00178"></a>00178     }
<a name="l00179"></a>00179   };
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   
<a name="l00183"></a>00183 
<a name="l00184"></a>00184   <span class="comment">// Instantiation for the NotAncestor abstract_multi_predicate</span>
<a name="l00185"></a>00185   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00186"></a><a class="code" href="structPredicates_1_1NotAncestor.php">00186</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1NotAncestor.php">NotAncestor</a> : <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;
<a name="l00187"></a>00187   {
<a name="l00188"></a>00188     <span class="comment">// Constructor, pushes back two single predicates</span>
<a name="l00189"></a><a class="code" href="structPredicates_1_1NotAncestor.php#a77545b210cb8f3735eb1f42933c1b0d1">00189</a>     <a class="code" href="structPredicates_1_1NotAncestor.php#a77545b210cb8f3735eb1f42933c1b0d1">NotAncestor</a>()
<a name="l00190"></a>00190     {
<a name="l00191"></a>00191       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__null.php">not_null&lt;T&gt;</a>);
<a name="l00192"></a>00192       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__ancestor.php">not_ancestor&lt;T&gt;</a>);
<a name="l00193"></a>00193     }
<a name="l00194"></a>00194   };
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   
<a name="l00199"></a>00199   <span class="comment">// Instantiation for the SubActive abstract_multi_predicate</span>
<a name="l00200"></a>00200   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00201"></a><a class="code" href="structPredicates_1_1SubActive.php">00201</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1SubActive.php">SubActive</a> : <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;
<a name="l00202"></a>00202   {
<a name="l00203"></a>00203     <span class="comment">// Constructor, pushes back two single predicates</span>
<a name="l00204"></a><a class="code" href="structPredicates_1_1SubActive.php#ad28aefabdb0a8075d2fc763457da7deb">00204</a>     <a class="code" href="structPredicates_1_1SubActive.php#ad28aefabdb0a8075d2fc763457da7deb">SubActive</a>()
<a name="l00205"></a>00205     {
<a name="l00206"></a>00206       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__null.php">not_null&lt;T&gt;</a>);
<a name="l00207"></a>00207       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1subactive.php">subactive&lt;T&gt;</a>);
<a name="l00208"></a>00208     }
<a name="l00209"></a>00209   };
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 
<a name="l00212"></a>00212   
<a name="l00213"></a>00213 
<a name="l00214"></a>00214   <span class="comment">// Instantiation for the NotSubActive abstract_multi_predicate</span>
<a name="l00215"></a>00215   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00216"></a><a class="code" href="structPredicates_1_1NotSubActive.php">00216</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1NotSubActive.php">NotSubActive</a> : <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;
<a name="l00217"></a>00217   {
<a name="l00218"></a>00218     <span class="comment">// Constructor, pushes back two single predicates</span>
<a name="l00219"></a><a class="code" href="structPredicates_1_1NotSubActive.php#a8c42958242a09869ac087478d3f35311">00219</a>     <a class="code" href="structPredicates_1_1NotSubActive.php#a8c42958242a09869ac087478d3f35311">NotSubActive</a>()
<a name="l00220"></a>00220     {
<a name="l00221"></a>00221       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__null.php">not_null&lt;T&gt;</a>);
<a name="l00222"></a>00222       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__subactive.php">not_subactive&lt;T&gt;</a>);
<a name="l00223"></a>00223     }
<a name="l00224"></a>00224   };
<a name="l00225"></a>00225 
<a name="l00226"></a>00226   
<a name="l00227"></a>00227   
<a name="l00228"></a>00228   <span class="comment">// Instantiation for the Local abstract_multi_predicate</span>
<a name="l00229"></a>00229   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00230"></a><a class="code" href="structPredicates_1_1Local.php">00230</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1Local.php">Local</a> : <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;
<a name="l00231"></a>00231   {
<a name="l00232"></a>00232     <span class="comment">// Constructor, pushes back two single predicates</span>
<a name="l00233"></a><a class="code" href="structPredicates_1_1Local.php#aece0d067b7ab66346bf777bc71c1b7c7">00233</a>     <a class="code" href="structPredicates_1_1Local.php#aece0d067b7ab66346bf777bc71c1b7c7">Local</a>()
<a name="l00234"></a>00234     {
<a name="l00235"></a>00235       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__null.php">not_null&lt;T&gt;</a>);
<a name="l00236"></a>00236       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1pid.php">pid&lt;T&gt;</a>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()));
<a name="l00237"></a>00237     }
<a name="l00238"></a>00238 
<a name="l00239"></a>00239   };
<a name="l00240"></a>00240 
<a name="l00241"></a>00241 
<a name="l00242"></a>00242   <span class="comment">// Instantiation for the NotLocal abstract_multi_predicate</span>
<a name="l00243"></a>00243   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00244"></a><a class="code" href="structPredicates_1_1NotLocal.php">00244</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1NotLocal.php">NotLocal</a> : <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;
<a name="l00245"></a>00245   {
<a name="l00246"></a>00246     <span class="comment">// Constructor, pushes back two single predicates</span>
<a name="l00247"></a><a class="code" href="structPredicates_1_1NotLocal.php#ac8b3faaa38e9b47d98ae394c8764c2f4">00247</a>     <a class="code" href="structPredicates_1_1NotLocal.php#ac8b3faaa38e9b47d98ae394c8764c2f4">NotLocal</a>()
<a name="l00248"></a>00248     {
<a name="l00249"></a>00249       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__null.php">not_null&lt;T&gt;</a>);
<a name="l00250"></a>00250       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__pid.php">not_pid&lt;T&gt;</a>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()));
<a name="l00251"></a>00251     }
<a name="l00252"></a>00252 
<a name="l00253"></a>00253   };
<a name="l00254"></a>00254 
<a name="l00255"></a>00255 
<a name="l00256"></a>00256   <span class="comment">// Instantiation for the ActiveNotLocal abstract_multi_predicate</span>
<a name="l00257"></a>00257   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00258"></a><a class="code" href="structPredicates_1_1ActiveNotLocal.php">00258</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1ActiveNotLocal.php">ActiveNotLocal</a> : <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;
<a name="l00259"></a>00259   {
<a name="l00260"></a>00260     <span class="comment">// Constructor, pushes back two single predicates</span>
<a name="l00261"></a><a class="code" href="structPredicates_1_1ActiveNotLocal.php#a344cd8fe8900309a5626e6e3ef02b505">00261</a>     <a class="code" href="structPredicates_1_1ActiveNotLocal.php#a344cd8fe8900309a5626e6e3ef02b505">ActiveNotLocal</a>()
<a name="l00262"></a>00262     {
<a name="l00263"></a>00263       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__null.php">not_null&lt;T&gt;</a>);
<a name="l00264"></a>00264       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1active.php">active&lt;T&gt;</a>);
<a name="l00265"></a>00265       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__pid.php">not_pid&lt;T&gt;</a>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()));
<a name="l00266"></a>00266     }
<a name="l00267"></a>00267 
<a name="l00268"></a>00268   };
<a name="l00269"></a>00269   
<a name="l00270"></a>00270 
<a name="l00271"></a>00271   <span class="comment">// Instantiation for the Type abstract_multi_predicate</span>
<a name="l00272"></a>00272   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00273"></a><a class="code" href="structPredicates_1_1Type.php">00273</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1Type.php">Type</a> : <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;
<a name="l00274"></a>00274   {
<a name="l00275"></a><a class="code" href="structPredicates_1_1Type.php#a8bbdc30c87ba5e4cf3b39410982b77d5">00275</a>     <a class="code" href="structPredicates_1_1Type.php#a8bbdc30c87ba5e4cf3b39410982b77d5">Type</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)
<a name="l00276"></a>00276     {
<a name="l00277"></a>00277       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__null.php">not_null&lt;T&gt;</a>);
<a name="l00278"></a>00278       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1elem__type.php">elem_type&lt;T&gt;</a>(type));
<a name="l00279"></a>00279     }
<a name="l00280"></a>00280   };
<a name="l00281"></a>00281 
<a name="l00282"></a>00282   
<a name="l00283"></a>00283   
<a name="l00284"></a>00284   <span class="comment">// Instantiation for the ActiveType abstract_multi_predicate</span>
<a name="l00285"></a>00285   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00286"></a><a class="code" href="structPredicates_1_1ActiveType.php">00286</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1ActiveType.php">ActiveType</a> : <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;
<a name="l00287"></a>00287   {
<a name="l00288"></a><a class="code" href="structPredicates_1_1ActiveType.php#a4b28ffa05c3471a4182f9762b8feebb3">00288</a>     <a class="code" href="structPredicates_1_1ActiveType.php#a4b28ffa05c3471a4182f9762b8feebb3">ActiveType</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)
<a name="l00289"></a>00289     {
<a name="l00290"></a>00290       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__null.php">not_null&lt;T&gt;</a>);
<a name="l00291"></a>00291       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1active.php">active&lt;T&gt;</a>);
<a name="l00292"></a>00292       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1elem__type.php">elem_type&lt;T&gt;</a>(type));
<a name="l00293"></a>00293     }
<a name="l00294"></a>00294   };
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 
<a name="l00297"></a>00297 
<a name="l00298"></a>00298   <span class="comment">// Instantiation for the ActivePID abstract_multi_predicate</span>
<a name="l00299"></a>00299   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00300"></a><a class="code" href="structPredicates_1_1ActivePID.php">00300</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1ActivePID.php">ActivePID</a> : <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;
<a name="l00301"></a>00301   {
<a name="l00302"></a><a class="code" href="structPredicates_1_1ActivePID.php#a085d0348e9a083660e1033b62d47178e">00302</a>     <a class="code" href="structPredicates_1_1ActivePID.php#a085d0348e9a083660e1033b62d47178e">ActivePID</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)
<a name="l00303"></a>00303     {
<a name="l00304"></a>00304       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__null.php">not_null&lt;T&gt;</a>);
<a name="l00305"></a>00305       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1active.php">active&lt;T&gt;</a>);
<a name="l00306"></a>00306       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1pid.php">pid&lt;T&gt;</a>(proc_id));
<a name="l00307"></a>00307     }
<a name="l00308"></a>00308   };
<a name="l00309"></a>00309 
<a name="l00310"></a>00310 
<a name="l00311"></a>00311 
<a name="l00312"></a>00312 
<a name="l00313"></a>00313   
<a name="l00314"></a>00314   <span class="comment">// Instantiation for the ActiveLocal abstract_multi_predicate</span>
<a name="l00315"></a>00315   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00316"></a><a class="code" href="structPredicates_1_1ActiveLocal.php">00316</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1ActiveLocal.php">ActiveLocal</a> : <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;
<a name="l00317"></a>00317   {
<a name="l00318"></a><a class="code" href="structPredicates_1_1ActiveLocal.php#ad0bcecd025be2175f18c1d39c43bb5d2">00318</a>     <a class="code" href="structPredicates_1_1ActiveLocal.php#ad0bcecd025be2175f18c1d39c43bb5d2">ActiveLocal</a>()
<a name="l00319"></a>00319     {
<a name="l00320"></a>00320       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__null.php">not_null&lt;T&gt;</a>);
<a name="l00321"></a>00321       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1active.php">active&lt;T&gt;</a>);
<a name="l00322"></a>00322       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1pid.php">pid&lt;T&gt;</a>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()));
<a name="l00323"></a>00323     }
<a name="l00324"></a>00324   };
<a name="l00325"></a>00325 
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 
<a name="l00330"></a>00330   <span class="comment">// Instantiation for the PID abstract_multi_predicate</span>
<a name="l00331"></a>00331   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00332"></a><a class="code" href="structPredicates_1_1PID.php">00332</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1PID.php">PID</a> : <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;
<a name="l00333"></a>00333   {
<a name="l00334"></a><a class="code" href="structPredicates_1_1PID.php#aae6d8bbd4a75dd3e8cc2a559675a1c89">00334</a>     <a class="code" href="structPredicates_1_1PID.php#aae6d8bbd4a75dd3e8cc2a559675a1c89">PID</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)
<a name="l00335"></a>00335     {
<a name="l00336"></a>00336       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__null.php">not_null&lt;T&gt;</a>);
<a name="l00337"></a>00337       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1pid.php">pid&lt;T&gt;</a>(proc_id));
<a name="l00338"></a>00338     }
<a name="l00339"></a>00339   };
<a name="l00340"></a>00340 
<a name="l00341"></a>00341 
<a name="l00342"></a>00342   
<a name="l00343"></a>00343   <span class="comment">// Instantiation for the NotPID abstract_multi_predicate</span>
<a name="l00344"></a>00344   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00345"></a><a class="code" href="structPredicates_1_1NotPID.php">00345</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1NotPID.php">NotPID</a> : <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;
<a name="l00346"></a>00346   {
<a name="l00347"></a><a class="code" href="structPredicates_1_1NotPID.php#a37c1b59657555e583e95cd304f982c94">00347</a>     <a class="code" href="structPredicates_1_1NotPID.php#a37c1b59657555e583e95cd304f982c94">NotPID</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)
<a name="l00348"></a>00348     {
<a name="l00349"></a>00349       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__null.php">not_null&lt;T&gt;</a>);
<a name="l00350"></a>00350       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__pid.php">not_pid&lt;T&gt;</a>(proc_id));
<a name="l00351"></a>00351     }
<a name="l00352"></a>00352   };
<a name="l00353"></a>00353 
<a name="l00354"></a>00354 
<a name="l00355"></a>00355 
<a name="l00356"></a>00356 
<a name="l00357"></a>00357   <span class="comment">// Instantiation for the Level abstract_multi_predicate</span>
<a name="l00358"></a>00358   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00359"></a><a class="code" href="structPredicates_1_1Level.php">00359</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1Level.php">Level</a> : <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;
<a name="l00360"></a>00360   {
<a name="l00361"></a><a class="code" href="structPredicates_1_1Level.php#a0af96c85ab0574352a735de3c36e5318">00361</a>     <a class="code" href="structPredicates_1_1Level.php#a0af96c85ab0574352a735de3c36e5318">Level</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l)
<a name="l00362"></a>00362     {
<a name="l00363"></a>00363       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__null.php">not_null&lt;T&gt;</a>);
<a name="l00364"></a>00364       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1level.php">level&lt;T&gt;</a>(l));
<a name="l00365"></a>00365     }
<a name="l00366"></a>00366   };
<a name="l00367"></a>00367 
<a name="l00368"></a>00368 
<a name="l00369"></a>00369 
<a name="l00370"></a>00370 
<a name="l00371"></a>00371   <span class="comment">// Instantiation for the NotLevel abstract_multi_predicate</span>
<a name="l00372"></a>00372   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00373"></a><a class="code" href="structPredicates_1_1NotLevel.php">00373</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1NotLevel.php">NotLevel</a> : <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;
<a name="l00374"></a>00374   {
<a name="l00375"></a><a class="code" href="structPredicates_1_1NotLevel.php#a22c057bf13d29d06a4424aca7dbb4c11">00375</a>     <a class="code" href="structPredicates_1_1NotLevel.php#a22c057bf13d29d06a4424aca7dbb4c11">NotLevel</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l)
<a name="l00376"></a>00376     {
<a name="l00377"></a>00377       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__null.php">not_null&lt;T&gt;</a>);
<a name="l00378"></a>00378       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__level.php">not_level&lt;T&gt;</a>(l));
<a name="l00379"></a>00379     }
<a name="l00380"></a>00380   };
<a name="l00381"></a>00381 
<a name="l00382"></a>00382 
<a name="l00383"></a>00383 
<a name="l00384"></a>00384 
<a name="l00385"></a>00385   <span class="comment">// Instantiation for the LocalLevel abstract_multi_predicate</span>
<a name="l00386"></a>00386   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00387"></a><a class="code" href="structPredicates_1_1LocalLevel.php">00387</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1LocalLevel.php">LocalLevel</a> : <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;
<a name="l00388"></a>00388   {
<a name="l00389"></a><a class="code" href="structPredicates_1_1LocalLevel.php#a0fe3fadfc004fcd72e938cd971c687cb">00389</a>     <a class="code" href="structPredicates_1_1LocalLevel.php#a0fe3fadfc004fcd72e938cd971c687cb">LocalLevel</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l)
<a name="l00390"></a>00390     {
<a name="l00391"></a>00391       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__null.php">not_null&lt;T&gt;</a>);
<a name="l00392"></a>00392       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1pid.php">pid&lt;T&gt;</a>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()));
<a name="l00393"></a>00393       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1level.php">level&lt;T&gt;</a>(l));
<a name="l00394"></a>00394     }
<a name="l00395"></a>00395   };
<a name="l00396"></a>00396 
<a name="l00397"></a>00397 
<a name="l00398"></a>00398 
<a name="l00399"></a>00399 
<a name="l00400"></a>00400   <span class="comment">// Instantiation for the LocalNotLevel abstract_multi_predicate</span>
<a name="l00401"></a>00401   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00402"></a><a class="code" href="structPredicates_1_1LocalNotLevel.php">00402</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1LocalNotLevel.php">LocalNotLevel</a> : <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;
<a name="l00403"></a>00403   {
<a name="l00404"></a><a class="code" href="structPredicates_1_1LocalNotLevel.php#a2e6191092c0f0b741285ab809199e5c8">00404</a>     <a class="code" href="structPredicates_1_1LocalNotLevel.php#a2e6191092c0f0b741285ab809199e5c8">LocalNotLevel</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l)
<a name="l00405"></a>00405     {
<a name="l00406"></a>00406       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__null.php">not_null&lt;T&gt;</a>);
<a name="l00407"></a>00407       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1pid.php">pid&lt;T&gt;</a>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()));
<a name="l00408"></a>00408       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__level.php">not_level&lt;T&gt;</a>(l));
<a name="l00409"></a>00409     }
<a name="l00410"></a>00410   };
<a name="l00411"></a>00411 
<a name="l00412"></a>00412 
<a name="l00413"></a>00413 
<a name="l00414"></a>00414   <span class="comment">// Instantiation for the ActiveOnBoundary abstract_multi_predicate</span>
<a name="l00415"></a>00415   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00416"></a><a class="code" href="structPredicates_1_1ActiveOnBoundary.php">00416</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1ActiveOnBoundary.php">ActiveOnBoundary</a> : <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;
<a name="l00417"></a>00417   {
<a name="l00418"></a><a class="code" href="structPredicates_1_1ActiveOnBoundary.php#a6c56d15074012a00d5a22c7d602289d3">00418</a>     <a class="code" href="structPredicates_1_1ActiveOnBoundary.php#a6c56d15074012a00d5a22c7d602289d3">ActiveOnBoundary</a>()
<a name="l00419"></a>00419     {
<a name="l00420"></a>00420       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__null.php">not_null&lt;T&gt;</a>);
<a name="l00421"></a>00421       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1active.php">active&lt;T&gt;</a>);
<a name="l00422"></a>00422       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1null__neighbor.php">null_neighbor&lt;T&gt;</a>);
<a name="l00423"></a>00423     }
<a name="l00424"></a>00424   };
<a name="l00425"></a>00425 
<a name="l00426"></a>00426 
<a name="l00427"></a>00427   
<a name="l00428"></a>00428   <span class="comment">// Instantiation for the BoundarySide abstract_multi_predicate</span>
<a name="l00429"></a>00429   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00430"></a><a class="code" href="structPredicates_1_1BoundarySide.php">00430</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1BoundarySide.php">BoundarySide</a> : <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;
<a name="l00431"></a>00431   {
<a name="l00432"></a><a class="code" href="structPredicates_1_1BoundarySide.php#a467e707ea75329ff7ac91c7d53d60cbf">00432</a>     <a class="code" href="structPredicates_1_1BoundarySide.php#a467e707ea75329ff7ac91c7d53d60cbf">BoundarySide</a>()
<a name="l00433"></a>00433     {
<a name="l00434"></a>00434       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1boundary__side.php">boundary_side&lt;T&gt;</a>);
<a name="l00435"></a>00435     }
<a name="l00436"></a>00436   };
<a name="l00437"></a>00437 
<a name="l00438"></a>00438   
<a name="l00439"></a>00439 
<a name="l00440"></a>00440   <span class="comment">// Instantiation for the ActiveLocalSubdomain abstract_multi_predicate</span>
<a name="l00441"></a>00441   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00442"></a><a class="code" href="structPredicates_1_1ActiveLocalSubdomain.php">00442</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1ActiveLocalSubdomain.php">ActiveLocalSubdomain</a> : <a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;
<a name="l00443"></a>00443   {
<a name="l00444"></a><a class="code" href="structPredicates_1_1ActiveLocalSubdomain.php#a4633560a5c7b1de7468ae67735db30ef">00444</a>     <a class="code" href="structPredicates_1_1ActiveLocalSubdomain.php#a4633560a5c7b1de7468ae67735db30ef">ActiveLocalSubdomain</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id)
<a name="l00445"></a>00445     {
<a name="l00446"></a>00446       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__null.php">not_null&lt;T&gt;</a>);
<a name="l00447"></a>00447       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1active.php">active&lt;T&gt;</a>);
<a name="l00448"></a>00448       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1pid.php">pid&lt;T&gt;</a>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()));
<a name="l00449"></a>00449       this-&gt;<a class="code" href="structPredicates_1_1abstract__multi__predicate.php#aacca06861577824dfc487f773b44234c">_predicates</a>.push_back(<span class="keyword">new</span> <a class="code" href="structPredicates_1_1subdomain.php">subdomain&lt;T&gt;</a>(subdomain_id));
<a name="l00450"></a>00450     }
<a name="l00451"></a>00451   };
<a name="l00452"></a>00452   
<a name="l00453"></a>00453 }
<a name="l00454"></a>00454 
<a name="l00455"></a>00455 
<a name="l00456"></a>00456 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
