<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="namespaces.php"><span>Namespace&#160;List</span></a></li>
      <li><a href="namespacemembers.php"><span>Namespace&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceMeshTools.php">MeshTools</a>      </li>
      <li class="navelem"><a class="el" href="namespaceMeshTools_1_1Private.php">Private</a>      </li>
</div>
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<h1>MeshTools::Private Namespace Reference</h1>  </div>
</div>
<div class="contents">
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="func-members"></a>
Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceMeshTools_1_1Private.php#a96ed88f210c1a01056f4598751269cd2">globally_renumber_nodes_and_elements</a> (<a class="el" href="classMeshBase.php">MeshBase</a> &amp;)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceMeshTools_1_1Private.php#af435c29becf70b3ce4a05360be28dbc5">fix_broken_node_and_element_numbering</a> (<a class="el" href="classSerialMesh.php">SerialMesh</a> &amp;)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceMeshTools_1_1Private.php#a71fd69f647d0fefaadee5ba6e9b5f06a">fix_broken_node_and_element_numbering</a> (<a class="el" href="classParallelMesh.php">ParallelMesh</a> &amp;)</td></tr>
</table>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="af435c29becf70b3ce4a05360be28dbc5"></a><!-- doxytag: member="MeshTools::Private::fix_broken_node_and_element_numbering" ref="af435c29becf70b3ce4a05360be28dbc5" args="(SerialMesh &amp;)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void MeshTools::Private::fix_broken_node_and_element_numbering </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classSerialMesh.php">SerialMesh</a> &amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>There is no reason for a user to ever call this function.</p>
<p>This function restores a previously broken element/node numbering such that <code>mesh.node(n)-&gt;id()</code> == n. </p>

<p>Definition at line <a class="el" href="mesh__tools_8C_source.php#l01008">1008</a> of file <a class="el" href="mesh__tools_8C_source.php">mesh_tools.C</a>.</p>

<p>References <a class="el" href="serial__mesh_8h_source.php#l00313">SerialMesh::_elements</a>, and <a class="el" href="serial__mesh_8h_source.php#l00308">SerialMesh::_nodes</a>.</p>

<p>Referenced by <a class="el" href="equation__systems__io_8C_source.php#l00123">EquationSystems::_read_impl()</a>, and <a class="el" href="equation__systems__io_8C_source.php#l00343">EquationSystems::write()</a>.</p>
<div class="fragment"><pre class="fragment">{
   <span class="comment">// Nodes first</span>
  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;mesh.<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>.size(); n++)
    <span class="keywordflow">if</span> (mesh.<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[n] != NULL)
      mesh.<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[n]-&gt;set_id() = n;

  <span class="comment">// Elements next</span>
  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;mesh.<a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>.size(); e++)
    <span class="keywordflow">if</span> (mesh.<a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>[e] != NULL)
      mesh.<a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>[e]-&gt;set_id() = e; 
}
</pre></div>
</div>
</div>
<a class="anchor" id="a71fd69f647d0fefaadee5ba6e9b5f06a"></a><!-- doxytag: member="MeshTools::Private::fix_broken_node_and_element_numbering" ref="a71fd69f647d0fefaadee5ba6e9b5f06a" args="(ParallelMesh &amp;)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void MeshTools::Private::fix_broken_node_and_element_numbering </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classParallelMesh.php">ParallelMesh</a> &amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>There is no reason for a user to ever call this function.</p>
<p>This function restores a previously broken element/node numbering such that <code>mesh.node(n)-&gt;id()</code> == n. </p>

<p>Definition at line <a class="el" href="mesh__tools_8C_source.php#l01023">1023</a> of file <a class="el" href="mesh__tools_8C_source.php">mesh_tools.C</a>.</p>

<p>References <a class="el" href="parallel__mesh_8h_source.php#l00375">ParallelMesh::_elements</a>, <a class="el" href="parallel__mesh_8h_source.php#l00370">ParallelMesh::_nodes</a>, <a class="el" href="mapvector_8h_source.php#l00125">mapvector&lt; Val &gt;::begin()</a>, and <a class="el" href="mapvector_8h_source.php#l00133">mapvector&lt; Val &gt;::end()</a>.</p>
<div class="fragment"><pre class="fragment">{
  <span class="comment">// We need access to iterators for the underlying containers,</span>
  <span class="comment">// not the mapvector&lt;&gt; reimplementations.</span>
  <a class="code" href="classmapvector.php">mapvector&lt;Node*&gt;::maptype</a> &amp;nodes = mesh.<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>;
  <a class="code" href="classmapvector.php">mapvector&lt;Elem*&gt;::maptype</a> &amp;elem  = mesh.<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>;
  
  <span class="comment">// Nodes first</span>
  {
    <a class="code" href="classmapvector.php">mapvector&lt;Node*&gt;::maptype::iterator</a>
      it  = nodes.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(),
      end = nodes.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>();

    <span class="keywordflow">for</span> (; it != end; ++it)
      <span class="keywordflow">if</span> (it-&gt;second != NULL)
        it-&gt;second-&gt;set_id() = it-&gt;first;
  }

  <span class="comment">// Elements next</span>
  {
    <a class="code" href="classmapvector.php">mapvector&lt;Elem*&gt;::maptype::iterator</a>
      it  = elem.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(),
      end = elem.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>();

    <span class="keywordflow">for</span> (; it != end; ++it)
      <span class="keywordflow">if</span> (it-&gt;second != NULL)
        it-&gt;second-&gt;set_id() = it-&gt;first;
  }
}
</pre></div>
</div>
</div>
<a class="anchor" id="a96ed88f210c1a01056f4598751269cd2"></a><!-- doxytag: member="MeshTools::Private::globally_renumber_nodes_and_elements" ref="a96ed88f210c1a01056f4598751269cd2" args="(MeshBase &amp;)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void MeshTools::Private::globally_renumber_nodes_and_elements </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classMeshBase.php">MeshBase</a> &amp;&#160;</td>
          <td class="paramname"><em>mesh</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>There is no reason for a user to ever call this function.</p>
<p>This function determines partition-agnostic global indices for all nodes and elements in the mesh. Note that after this function is called the mesh will likely be in an inconsistent state, i.e. <code>mesh.nodes(i)-&gt;id()</code> != i in the nodes container. Direct node/element access via the <code>mesh.node(n)</code> or <code>mesh.elem(e)</code> functions will likely fail. The original numbering can (and should) be restored with a subsequent call to <code>fix_node_and_element_numbering()</code>. </p>

<p>Definition at line <a class="el" href="mesh__tools_8C_source.php#l01001">1001</a> of file <a class="el" href="mesh__tools_8C_source.php">mesh_tools.C</a>.</p>

<p>References <a class="el" href="mesh__communication__global__indices_8C_source.php#l00172">MeshCommunication::assign_global_indices()</a>.</p>

<p>Referenced by <a class="el" href="equation__systems__io_8C_source.php#l00123">EquationSystems::_read_impl()</a>, and <a class="el" href="equation__systems__io_8C_source.php#l00343">EquationSystems::write()</a>.</p>
<div class="fragment"><pre class="fragment">{
  <a class="code" href="classMeshCommunication.php">MeshCommunication</a>().<a class="code" href="classMeshCommunication.php#aa1ac865b823fff87470b2f2fcc68a00b">assign_global_indices</a>(mesh);
}
</pre></div>
</div>
</div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
