<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="namespaces.php"><span>Namespace&#160;List</span></a></li>
      <li><a href="namespacemembers.php"><span>Namespace&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceParallel.php">Parallel</a>      </li>
      <li class="navelem"><a class="el" href="namespaceParallel_1_1Utils.php">Utils</a>      </li>
</div>
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<h1>Parallel::Utils Namespace Reference</h1>  </div>
</div>
<div class="contents">
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="func-members"></a>
Functions</h2></td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;typename KeyType &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespaceParallel_1_1Utils.php#a10a62091b54c73f7b5ea268e8dd7b178">is_sorted</a> (const std::vector&lt; KeyType &gt; &amp;v)</td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;typename KeyType &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">double&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespaceParallel_1_1Utils.php#a7cb0d6aee3faa60b9d20c0db2d7fbb8b">to_double</a> (const KeyType &amp;k)</td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;typename KeyType &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">KeyType&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespaceParallel_1_1Utils.php#af4a329731aabb6ca58e83e812163d6e4">to_key_type</a> (const double f)</td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;&gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">double&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespaceParallel_1_1Utils.php#ad9cdff5c825be76118631c141b6fa758">to_double</a> (const Hilbert::HilbertIndices &amp;bvt)</td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;&gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">Hilbert::HilbertIndices&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespaceParallel_1_1Utils.php#a7a8f06337d63ab303f01e8033d0795e4">to_key_type</a> (const double f)</td></tr>
</table>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="a10a62091b54c73f7b5ea268e8dd7b178"></a><!-- doxytag: member="Parallel::Utils::is_sorted" ref="a10a62091b54c73f7b5ea268e8dd7b178" args="(const std::vector&lt; KeyType &gt; &amp;v)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename KeyType &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool Parallel::Utils::is_sorted </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; KeyType &gt; &amp;&#160;</td>
          <td class="paramname"><em>v</em></td><td>)</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p><a class="el" href="namespaceUtility.php">Utility</a> function that returns true if the vector v is sorted, false otherwise. O(N), the length of the vector. This is implemented solely because the std::is_sorted appears to be an STL extension. </p>

<p>Definition at line <a class="el" href="parallel__conversion__utils_8h_source.php#l00047">47</a> of file <a class="el" href="parallel__conversion__utils_8h_source.php">parallel_conversion_utils.h</a>.</p>

<p>Referenced by <a class="el" href="parallel__bin__sorter_8C_source.php#l00041">Parallel::BinSorter&lt; KeyType &gt;::BinSorter()</a>, and <a class="el" href="parallel__histogram_8C_source.php#l00038">Parallel::Histogram&lt; KeyType &gt;::Histogram()</a>.</p>
<div class="fragment"><pre class="fragment">      {
        <span class="keywordflow">if</span> (v.empty())
          <span class="keywordflow">return</span> <span class="keyword">true</span>;

        <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i&lt;v.size(); i++)
          <span class="keywordflow">if</span> (v[i] &lt; v[i-1])
            <span class="keywordflow">return</span> <span class="keyword">false</span>;

        <span class="keywordflow">return</span> <span class="keyword">true</span>;    
      }
</pre></div>
</div>
</div>
<a class="anchor" id="a7cb0d6aee3faa60b9d20c0db2d7fbb8b"></a><!-- doxytag: member="Parallel::Utils::to_double" ref="a7cb0d6aee3faa60b9d20c0db2d7fbb8b" args="(const KeyType &amp;k)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename KeyType &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">double Parallel::Utils::to_double </td>
          <td>(</td>
          <td class="paramtype">const KeyType &amp;&#160;</td>
          <td class="paramname"><em>k</em></td><td>)</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>A utility function which converts whatever <code>KeyType</code> is to a <code>double</code> for the histogram bounds </p>

<p>Definition at line <a class="el" href="parallel__conversion__utils_8h_source.php#l00065">65</a> of file <a class="el" href="parallel__conversion__utils_8h_source.php">parallel_conversion_utils.h</a>.</p>

<p>Referenced by <a class="el" href="parallel__bin__sorter_8C_source.php#l00056">Parallel::BinSorter&lt; KeyType &gt;::binsort()</a>, and <a class="el" href="parallel__histogram_8C_source.php#l00047">Parallel::Histogram&lt; KeyType &gt;::make_histogram()</a>.</p>
<div class="fragment"><pre class="fragment">      {
        <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">double</span><span class="keyword">&gt;</span>(k);
      }
</pre></div>
</div>
</div>
<a class="anchor" id="ad9cdff5c825be76118631c141b6fa758"></a><!-- doxytag: member="Parallel::Utils::to_double" ref="ad9cdff5c825be76118631c141b6fa758" args="(const Hilbert::HilbertIndices &amp;bvt)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">double Parallel::Utils::to_double </td>
          <td>(</td>
          <td class="paramtype">const Hilbert::HilbertIndices &amp;&#160;</td>
          <td class="paramname"><em>bvt</em></td><td>)</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="parallel__conversion__utils_8h_source.php#l00087">87</a> of file <a class="el" href="parallel__conversion__utils_8h_source.php">parallel_conversion_utils.h</a>.</p>
<div class="fragment"><pre class="fragment">      {
        <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">double</span><span class="keyword">&gt;</span>(bvt.rack2);
      }
</pre></div>
</div>
</div>
<a class="anchor" id="af4a329731aabb6ca58e83e812163d6e4"></a><!-- doxytag: member="Parallel::Utils::to_key_type" ref="af4a329731aabb6ca58e83e812163d6e4" args="(const double f)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename KeyType &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">KeyType Parallel::Utils::to_key_type </td>
          <td>(</td>
          <td class="paramtype">const double&#160;</td>
          <td class="paramname"><em>f</em></td><td>)</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>A utility to convert a <code>double</code> to some sort of <code>KeyType</code>, for interpreting how histogram bounds relate to <code>KeyType</code> positions. </p>

<p>Definition at line <a class="el" href="parallel__conversion__utils_8h_source.php#l00078">78</a> of file <a class="el" href="parallel__conversion__utils_8h_source.php">parallel_conversion_utils.h</a>.</p>
<div class="fragment"><pre class="fragment">      {
        <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span>KeyType<span class="keyword">&gt;</span>(f);
      }
</pre></div>
</div>
</div>
<a class="anchor" id="a7a8f06337d63ab303f01e8033d0795e4"></a><!-- doxytag: member="Parallel::Utils::to_key_type" ref="a7a8f06337d63ab303f01e8033d0795e4" args="(const double f)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">Hilbert::HilbertIndices Parallel::Utils::to_key_type </td>
          <td>(</td>
          <td class="paramtype">const double&#160;</td>
          <td class="paramname"><em>f</em></td><td>)</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="parallel__conversion__utils_8h_source.php#l00095">95</a> of file <a class="el" href="parallel__conversion__utils_8h_source.php">parallel_conversion_utils.h</a>.</p>
<div class="fragment"><pre class="fragment">      {
        Hilbert::HilbertIndices bvt;

        bvt.rack0 = 0;
        bvt.rack1 = 0;
        bvt.rack2 = <span class="keyword">static_cast&lt;</span>Hilbert::inttype<span class="keyword">&gt;</span>(f);

        <span class="keywordflow">return</span> bvt;
      }
</pre></div>
</div>
</div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
