<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="namespaces.php"><span>Namespace&#160;List</span></a></li>
      <li><a href="namespacemembers.php"><span>Namespace&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a> &#124;
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle">
<h1>QuadratureRules Namespace Reference</h1>  </div>
</div>
<div class="contents">
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="func-members"></a>
Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceQuadratureRules.php#a977a91f607c81062f220472d2552964c">name</a> (const QuadratureType t)</td></tr>
<tr><td colspan="2"><h2><a name="var-members"></a>
Variables</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceQuadratureRules.php#ae0de7916cc1e4da0bd8b1c5568d25945">num_rules</a> = 5</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const QuadratureType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceQuadratureRules.php#a6cd73c12440db2f13e7c5a67896f1bd0">valid_elem_rules</a> []</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceQuadratureRules.php#a83bb3bf0f93c7de93bff9b1398a1e763">num_valid_elem_rules</a> = 3</td></tr>
</table>
<hr/><a name="_details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>A namespace for utility functions for quadrature rules. </p>
</div><hr/><h2>Function Documentation</h2>
<a class="anchor" id="a977a91f607c81062f220472d2552964c"></a><!-- doxytag: member="QuadratureRules::name" ref="a977a91f607c81062f220472d2552964c" args="(const QuadratureType t)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::string QuadratureRules::name </td>
          <td>(</td>
          <td class="paramtype">const QuadratureType&#160;</td>
          <td class="paramname"><em>t</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Returns a standard string representation for the specific quadrature rule. </p>

<p>Definition at line <a class="el" href="quadrature__rules_8C_source.php#l00030">30</a> of file <a class="el" href="quadrature__rules_8C_source.php">quadrature_rules.C</a>.</p>

<p>References <a class="el" href="enum__quadrature__type_8h_source.php#l00032">libMeshEnums::QGAUSS</a>, <a class="el" href="enum__quadrature__type_8h_source.php#l00034">libMeshEnums::QJACOBI_1_0</a>, <a class="el" href="enum__quadrature__type_8h_source.php#l00035">libMeshEnums::QJACOBI_2_0</a>, <a class="el" href="enum__quadrature__type_8h_source.php#l00037">libMeshEnums::QSIMPSON</a>, and <a class="el" href="enum__quadrature__type_8h_source.php#l00038">libMeshEnums::QTRAP</a>.</p>
<div class="fragment"><pre class="fragment">{
  std::string its_name;
  
  <span class="keywordflow">switch</span> (q)
    {
      
    <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ada11bd5a126c073e475e588e38016b3785">QGAUSS</a>:
      its_name = <span class="stringliteral">&quot;Gauss-Legendre Quadrature&quot;</span>;
      <span class="keywordflow">break</span>;

    <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716adad3a339e15685559999115b81f6d38370">QJACOBI_1_0</a>:
      its_name = <span class="stringliteral">&quot;Jacobi(1,0)-Gauss Quadrature&quot;</span>;
      <span class="keywordflow">break</span>;

    <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ada52629eed7dec8b36fbd387b3dd51d48d">QJACOBI_2_0</a>:
      its_name = <span class="stringliteral">&quot;Jacobi(2,0)-Gauss Quadrature&quot;</span>;
      <span class="keywordflow">break</span>;

    <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716adaeb07c05dac20ab7f134838e34f9db0c1">QSIMPSON</a>:
      its_name = <span class="stringliteral">&quot;Simpson Rule&quot;</span>;
      <span class="keywordflow">break</span>;

    <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ada26431abeff146407680a87ae0dd3a39a">QTRAP</a>:
      its_name = <span class="stringliteral">&quot;Trapezoidal Rule&quot;</span>;
      <span class="keywordflow">break</span>;


    <span class="keywordflow">default</span>:
      { 
        std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad qt=&quot;</span> &lt;&lt; q &lt;&lt; std::endl;
        libmesh_error();
      }
    }
  
  <span class="keywordflow">return</span> its_name;
}
</pre></div>
</div>
</div>
<hr/><h2>Variable Documentation</h2>
<a class="anchor" id="ae0de7916cc1e4da0bd8b1c5568d25945"></a><!-- doxytag: member="QuadratureRules::num_rules" ref="ae0de7916cc1e4da0bd8b1c5568d25945" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const unsigned int <a class="el" href="namespaceQuadratureRules.php#ae0de7916cc1e4da0bd8b1c5568d25945">QuadratureRules::num_rules</a> = 5</td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>The number of quadrature rules that are defined (INVALD_Q_RULE excluded). You might have to update this if you add a new one! </p>

<p>Definition at line <a class="el" href="quadrature__rules_8h_source.php#l00045">45</a> of file <a class="el" href="quadrature__rules_8h_source.php">quadrature_rules.h</a>.</p>

</div>
</div>
<a class="anchor" id="a83bb3bf0f93c7de93bff9b1398a1e763"></a><!-- doxytag: member="QuadratureRules::num_valid_elem_rules" ref="a83bb3bf0f93c7de93bff9b1398a1e763" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const unsigned int <a class="el" href="namespaceQuadratureRules.php#a83bb3bf0f93c7de93bff9b1398a1e763">QuadratureRules::num_valid_elem_rules</a> = 3</td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>The number of valid quadrature rules for numerical integration over geometric entities. </p>

<p>Definition at line <a class="el" href="quadrature__rules_8h_source.php#l00060">60</a> of file <a class="el" href="quadrature__rules_8h_source.php">quadrature_rules.h</a>.</p>

</div>
</div>
<a class="anchor" id="a6cd73c12440db2f13e7c5a67896f1bd0"></a><!-- doxytag: member="QuadratureRules::valid_elem_rules" ref="a6cd73c12440db2f13e7c5a67896f1bd0" args="[]" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const QuadratureType <a class="el" href="namespaceQuadratureRules.php#a6cd73c12440db2f13e7c5a67896f1bd0">QuadratureRules::valid_elem_rules</a>[]</td>
        </tr>
      </table>
</div>
<div class="memdoc">
<b>Initial value:</b><div class="fragment"><pre class="fragment"> {<a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ada11bd5a126c073e475e588e38016b3785">QGAUSS</a>,
                                             <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716adaeb07c05dac20ab7f134838e34f9db0c1">QSIMPSON</a>,
                                             <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ada26431abeff146407680a87ae0dd3a39a">QTRAP</a>}
</pre></div><p>The types of quadrature rules that may be used for numerical integration over geometric entities. </p>

<p>Definition at line <a class="el" href="quadrature__rules_8h_source.php#l00052">52</a> of file <a class="el" href="quadrature__rules_8h_source.php">quadrature_rules.h</a>.</p>

</div>
</div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
