<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="namespaces.php"><span>Namespace&#160;List</span></a></li>
      <li><a href="namespacemembers.php"><span>Namespace&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#typedef-members">Typedefs</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<h1>SparsityPattern Namespace Reference</h1>  </div>
</div>
<div class="contents">
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSparsityPattern_1_1Graph.php">Graph</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSparsityPattern_1_1Build.php">Build</a></td></tr>
<tr><td colspan="2"><h2><a name="typedef-members"></a>
Typedefs</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef std::vector&lt; unsigned <br class="typebreak"/>
int, <br class="typebreak"/>
<a class="el" href="classThreads_1_1scalable__allocator.php">Threads::scalable_allocator</a><br class="typebreak"/>
&lt; unsigned int &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceSparsityPattern.php#a380dc3cd41bc4aab23a1c916181104b3">Row</a></td></tr>
<tr><td colspan="2"><h2><a name="func-members"></a>
Functions</h2></td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;typename BidirectionalIterator &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">static void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespaceSparsityPattern.php#abcab8a87e8229861015b1de4bc8f60ff">sort_row</a> (const BidirectionalIterator begin, BidirectionalIterator middle, const BidirectionalIterator end)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceSparsityPattern.php#a853789831aeb290de9ca4a4a33c71ea9">_dummy_function</a> (void)</td></tr>
</table>
<hr/><a name="_details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This defines the sparsity pattern, or graph, of a sparse matrix. The format is quite simple -- the global indices of the nonzero entries in each row are packed into a vector. The global indices (i,j) of the nth nonzero entry of row i are given by j = sparsity_pattern[i][n]; </p>
</div><hr/><h2>Typedef Documentation</h2>
<a class="anchor" id="a380dc3cd41bc4aab23a1c916181104b3"></a><!-- doxytag: member="SparsityPattern::Row" ref="a380dc3cd41bc4aab23a1c916181104b3" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;unsigned int, <a class="el" href="classThreads_1_1scalable__allocator.php">Threads::scalable_allocator</a>&lt;unsigned int&gt; &gt; <a class="el" href="namespaceSparsityPattern.php#a380dc3cd41bc4aab23a1c916181104b3">SparsityPattern::Row</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="dof__map_8h_source.php#l00072">72</a> of file <a class="el" href="dof__map_8h_source.php">dof_map.h</a>.</p>

</div>
</div>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="a853789831aeb290de9ca4a4a33c71ea9"></a><!-- doxytag: member="SparsityPattern::_dummy_function" ref="a853789831aeb290de9ca4a4a33c71ea9" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void SparsityPattern::_dummy_function </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Dummy function that does nothing but can be used to prohibit compiler optimization in some situations where some compilers have optimization bugs. </p>

<p>Definition at line <a class="el" href="dof__map_8C_source.php#l01806">1806</a> of file <a class="el" href="dof__map_8C_source.php">dof_map.C</a>.</p>

<p>Referenced by <a class="el" href="dof__map_8h_source.php#l00932">sort_row()</a>.</p>
<div class="fragment"><pre class="fragment">{
}
</pre></div>
</div>
</div>
<a class="anchor" id="abcab8a87e8229861015b1de4bc8f60ff"></a><!-- doxytag: member="SparsityPattern::sort_row" ref="abcab8a87e8229861015b1de4bc8f60ff" args="(const BidirectionalIterator begin, BidirectionalIterator middle, const BidirectionalIterator end)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename BidirectionalIterator &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void SparsityPattern::sort_row </td>
          <td>(</td>
          <td class="paramtype">const BidirectionalIterator&#160;</td>
          <td class="paramname"><em>begin</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">BidirectionalIterator&#160;</td>
          <td class="paramname"><em>middle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const BidirectionalIterator&#160;</td>
          <td class="paramname"><em>end</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inline, static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Splices the two sorted ranges [begin,middle) and [middle,end) into one sorted range [begin,end). This method is much like std::inplace_merge except it assumes the intersection of the two sorted ranges is empty and that any element in each range occurs only once in that range. Additionally, this sort occurs in-place, while std::inplace_merge may use a temporary buffer. </p>

<p>Definition at line <a class="el" href="dof__map_8h_source.php#l00932">932</a> of file <a class="el" href="dof__map_8h_source.php">dof_map.h</a>.</p>

<p>References <a class="el" href="dof__map_8C_source.php#l01806">_dummy_function()</a>.</p>

<p>Referenced by <a class="el" href="dof__map_8C_source.php#l01814">SparsityPattern::Build::operator()()</a>.</p>
<div class="fragment"><pre class="fragment">{
  <span class="keywordflow">if</span> ((begin == middle) || (middle == end)) <span class="keywordflow">return</span>;

  libmesh_assert (std::distance (begin,  middle) &gt; 0);
  libmesh_assert (std::distance (middle, end)    &gt; 0);
  libmesh_assert (std::unique (begin,  middle) == middle);
  libmesh_assert (std::unique (middle, end)    == end);
  
  <span class="keywordflow">while</span> (middle != end)
    {
      BidirectionalIterator
        b = middle,
        a = b-1;

      <span class="comment">// Bubble-sort the middle value downward</span>
      <span class="keywordflow">while</span> (!(*a &lt; *b)) <span class="comment">// *a &amp; *b are less-than comparable, so use &lt;</span>
        {
          std::swap (*a, *b);

<span class="preprocessor">#if defined(__GNUC__) &amp;&amp; (__GNUC__ &lt; 4) &amp;&amp; !defined(__INTEL_COMPILER)</span>
<span class="preprocessor"></span>          <span class="comment">/* Prohibit optimization at this point since gcc 3.3.5 seems</span>
<span class="comment">             to have a bug.  */</span>
          <a class="code" href="namespaceSparsityPattern.php#a853789831aeb290de9ca4a4a33c71ea9">SparsityPattern::_dummy_function</a>();
<span class="preprocessor">#endif</span>
<span class="preprocessor"></span>
          <span class="keywordflow">if</span> (a == begin) <span class="keywordflow">break</span>;
          
          b=a;
          --a;
        }
      
      ++middle;
    }

  <span class="comment">// Assure the algorithm worked if we are in DEBUG mode</span>
<span class="preprocessor">#ifdef DEBUG</span>
<span class="preprocessor"></span>  {
    <span class="comment">// SGI STL extension!</span>
    <span class="comment">// libmesh_assert (std::is_sorted(begin,end));</span>
    
    BidirectionalIterator
      prev  = begin,
      first = begin;

    <span class="keywordflow">for</span> (++first; first != end; prev=first, ++first)
      <span class="keywordflow">if</span> (*first &lt; *prev)
        libmesh_assert(<span class="keyword">false</span>);
  }  
<span class="preprocessor">#endif</span>
<span class="preprocessor"></span>
  <span class="comment">// Make sure the two ranges did not contain any common elements</span>
  libmesh_assert (std::unique (begin, end) == end);
}
</pre></div>
</div>
</div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
