<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>nemesis_io.C</h1>  </div>
</div>
<div class="contents">
<a href="nemesis__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: nemesis_io.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;numeric&gt;</span> <span class="comment">// std::accumulate</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// LibMesh includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;exodusII_io.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;nemesis_io.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;nemesis_io_helper.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;parallel_mesh.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;parallel.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;utility.h&quot;</span> <span class="comment">// is_sorted, deallocate</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">//-----------------------------------------------</span>
<a name="l00034"></a>00034 <span class="comment">// anonymous namespace for implementation details</span>
<a name="l00035"></a>00035 <span class="keyword">namespace </span>{
<a name="l00036"></a>00036   <span class="keyword">struct </span>CompareGlobalIdxMappings
<a name="l00037"></a>00037   {
<a name="l00038"></a>00038     <span class="comment">// strict weak ordering for a.first -&gt; a.second mapping.  since we can only map to one</span>
<a name="l00039"></a>00039     <span class="comment">// value only order the first entry</span>
<a name="l00040"></a>00040     <span class="keywordtype">bool</span> operator()(<span class="keyword">const</span> std::pair&lt;unsigned int, unsigned int&gt; &amp;a,
<a name="l00041"></a>00041                     <span class="keyword">const</span> std::pair&lt;unsigned int, unsigned int&gt; &amp;b)<span class="keyword"> const </span>
<a name="l00042"></a>00042 <span class="keyword">    </span>{ <span class="keywordflow">return</span> a.first &lt; b.first; }
<a name="l00043"></a>00043     
<a name="l00044"></a>00044     <span class="comment">// strict weak ordering for a.first -&gt; a.second mapping.  lookups will</span>
<a name="l00045"></a>00045     <span class="comment">// be in terms of a single integer, which is why we need this method.</span>
<a name="l00046"></a>00046     <span class="keywordtype">bool</span> operator()(<span class="keyword">const</span> std::pair&lt;unsigned int, unsigned int&gt; &amp;a,
<a name="l00047"></a>00047                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> b)<span class="keyword"> const </span>
<a name="l00048"></a>00048 <span class="keyword">    </span>{ <span class="keywordflow">return</span> a.first &lt; b; }
<a name="l00049"></a>00049   };
<a name="l00050"></a>00050 
<a name="l00051"></a>00051   <span class="comment">// Nemesis &amp; ExodusII use int for all integer values, even the ones which </span>
<a name="l00052"></a>00052   <span class="comment">// should never be negative.  we like to use unsigned as a force of habit,</span>
<a name="l00053"></a>00053   <span class="comment">// this trivial little method saves some typing &amp; also makes sure something</span>
<a name="l00054"></a>00054   <span class="comment">// is not horribly wrong.</span>
<a name="l00055"></a>00055   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00056"></a>00056   <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> to_uint ( <span class="keyword">const</span> T &amp;t ) 
<a name="l00057"></a>00057   {
<a name="l00058"></a>00058     libmesh_assert (t == static_cast&lt;T&gt;(static_cast&lt;unsigned int&gt;(t)));
<a name="l00059"></a>00059 
<a name="l00060"></a>00060     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(t); 
<a name="l00061"></a>00061   }
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   <span class="comment">// test equality for a.first -&gt; a.second mapping.  since we can only map to one</span>
<a name="l00064"></a>00064   <span class="comment">// value only test the first entry</span>
<a name="l00065"></a>00065   <span class="keyword">inline</span> <span class="keywordtype">bool</span> global_idx_mapping_equality (<span class="keyword">const</span> std::pair&lt;unsigned int, unsigned int&gt; &amp;a,
<a name="l00066"></a>00066                                            <span class="keyword">const</span> std::pair&lt;unsigned int, unsigned int&gt; &amp;b)
<a name="l00067"></a>00067   { <span class="keywordflow">return</span> a.first == b.first; }
<a name="l00068"></a>00068 }
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 
<a name="l00072"></a>00072 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00073"></a>00073 <span class="comment">// Nemesis_IO class members</span>
<a name="l00074"></a><a class="code" href="classNemesis__IO.php#a00d9475df1b8c05f66ad45be899b7bee">00074</a> <a class="code" href="classNemesis__IO.php#a00d9475df1b8c05f66ad45be899b7bee">Nemesis_IO::Nemesis_IO</a> (<a class="code" href="classParallelMesh.php">ParallelMesh</a>&amp; mesh) :
<a name="l00075"></a>00075   <a class="code" href="classMeshInput.php">MeshInput</a>&lt;<a class="code" href="classParallelMesh.php">ParallelMesh</a>&gt; (mesh, <span class="comment">/*is_parallel_format=*/</span>true),
<a name="l00076"></a>00076   <span class="comment">//MeshOutput&lt;ParallelMesh&gt; (mesh, /*is_parallel_format=*/true)</span>
<a name="l00077"></a>00077   _verbose (false)
<a name="l00078"></a>00078 {
<a name="l00079"></a>00079 }
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a><a class="code" href="classNemesis__IO.php#a75e61b87153e284397ec31e216b4ae3f">00082</a> <a class="code" href="classNemesis__IO.php#a75e61b87153e284397ec31e216b4ae3f">Nemesis_IO::~Nemesis_IO</a> ()
<a name="l00083"></a>00083 {
<a name="l00084"></a>00084 }
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
<a name="l00088"></a><a class="code" href="classNemesis__IO.php#a42d99bed6a19e0119830cdc192d13346">00088</a> <span class="keywordtype">void</span> <a class="code" href="classNemesis__IO.php#a42d99bed6a19e0119830cdc192d13346">Nemesis_IO::verbose</a> (<span class="keywordtype">bool</span> set_verbosity)
<a name="l00089"></a>00089 {
<a name="l00090"></a>00090   <a class="code" href="classNemesis__IO.php#a69c1bbcbb75afaec414ddb5ccc19c93d">_verbose</a> = set_verbosity;
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 <span class="preprocessor">#if defined(LIBMESH_HAVE_EXODUS_API) &amp;&amp; defined(LIBMESH_HAVE_NEMESIS_API)</span>
<a name="l00093"></a>00093 <span class="preprocessor"></span>  <span class="comment">// Set the verbose flag in the helper object</span>
<a name="l00094"></a>00094   <span class="comment">// as well.</span>
<a name="l00095"></a>00095   <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a90ab6ea1557ee6785027f28eee726836">verbose</a>(<a class="code" href="classNemesis__IO.php#a69c1bbcbb75afaec414ddb5ccc19c93d">_verbose</a>);
<a name="l00096"></a>00096 <span class="preprocessor">#endif</span>
<a name="l00097"></a>00097 <span class="preprocessor"></span>}
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 <span class="preprocessor">#if defined(LIBMESH_HAVE_EXODUS_API) &amp;&amp; defined(LIBMESH_HAVE_NEMESIS_API)</span>
<a name="l00102"></a><a class="code" href="classNemesis__IO.php#ab79e507bd0f761e25f070442bcafa848">00102</a> <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="classNemesis__IO.php#ab79e507bd0f761e25f070442bcafa848">Nemesis_IO::read</a> (<span class="keyword">const</span> std::string&amp; base_filename)
<a name="l00103"></a>00103 {
<a name="l00104"></a>00104   <span class="comment">// On one processor, Nemesis and ExodusII should be equivalent, so</span>
<a name="l00105"></a>00105   <span class="comment">// let&#39;s cowardly defer to that implementation...</span>
<a name="l00106"></a>00106   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l00107"></a>00107     {                                           
<a name="l00108"></a>00108       <a class="code" href="classExodusII__IO.php">ExodusII_IO</a>(this-&gt;<a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a>()).<a class="code" href="classExodusII__IO.php#a71cded634eaffef4c0f2441ef65d5860">read</a> (base_filename);
<a name="l00109"></a>00109       <span class="keywordflow">return</span>;
<a name="l00110"></a>00110     }
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   START_LOG (<span class="stringliteral">&quot;read()&quot;</span>,<span class="stringliteral">&quot;Nemesis_IO&quot;</span>);
<a name="l00113"></a>00113 
<a name="l00114"></a>00114   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00115"></a>00115   parallel_only();
<a name="l00116"></a>00116   
<a name="l00117"></a>00117   <span class="keywordflow">if</span> (<a class="code" href="classNemesis__IO.php#a69c1bbcbb75afaec414ddb5ccc19c93d">_verbose</a>)
<a name="l00118"></a>00118     {
<a name="l00119"></a>00119       std::cout &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l00120"></a>00120       std::cout &lt;&lt; <span class="stringliteral">&quot;Reading Nemesis file on processor: &quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; std::endl;
<a name="l00121"></a>00121     }
<a name="l00122"></a>00122   
<a name="l00123"></a>00123   <span class="comment">// Construct a filename string for this processor.</span>
<a name="l00124"></a>00124   <span class="comment">//</span>
<a name="l00125"></a>00125   <span class="comment">// FIXME: This assumes you are reading in a mesh on exactly the</span>
<a name="l00126"></a>00126   <span class="comment">// same number of processors it was written out on!!</span>
<a name="l00127"></a>00127   <span class="comment">// This should be generalized at some point...</span>
<a name="l00128"></a>00128   std::ostringstream file_oss;
<a name="l00129"></a>00129 
<a name="l00130"></a>00130   file_oss &lt;&lt; base_filename  
<a name="l00131"></a>00131            &lt;&lt; <span class="charliteral">&#39;.&#39;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() 
<a name="l00132"></a>00132            &lt;&lt; <span class="charliteral">&#39;.&#39;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>();
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   std::cout &lt;&lt; <span class="stringliteral">&quot;Opening file: &quot;</span> &lt;&lt; file_oss.str() &lt;&lt; std::endl;
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   <span class="comment">// Open the Exodus file</span>
<a name="l00137"></a>00137   <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#af979d5fd7cffa411bdd0a16b3a3011ee">open</a>(file_oss.str().c_str());
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   <span class="comment">// Get a reference to the ParallelMesh.  </span>
<a name="l00140"></a>00140   <a class="code" href="classParallelMesh.php">ParallelMesh</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = this-&gt;<a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a>();
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   <span class="comment">// Local information: Read the following information from the standard Exodus header</span>
<a name="l00143"></a>00143   <span class="comment">//  title[0]</span>
<a name="l00144"></a>00144   <span class="comment">//  num_dim</span>
<a name="l00145"></a>00145   <span class="comment">//  num_nodes</span>
<a name="l00146"></a>00146   <span class="comment">//  num_elem</span>
<a name="l00147"></a>00147   <span class="comment">//  num_elem_blk</span>
<a name="l00148"></a>00148   <span class="comment">//  num_node_sets</span>
<a name="l00149"></a>00149   <span class="comment">//  num_side_sets</span>
<a name="l00150"></a>00150   <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a3e2c4651800daaa7c199c63c4e49f161">read_header</a>();
<a name="l00151"></a>00151   <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a814335b8f7e05a408917b3d422078e61">print_header</a>();
<a name="l00152"></a>00152   
<a name="l00153"></a>00153   <span class="comment">// Be sure number of dimensions is equal to the number of dimensions in the mesh supplied.</span>
<a name="l00154"></a>00154   libmesh_assert(static_cast&lt;unsigned int&gt;(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#aa514ad80ba187511d8dd81cb97a6a2aa">num_dim</a>) == mesh.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>());
<a name="l00155"></a>00155   
<a name="l00156"></a>00156   <span class="comment">// Get global information: number of nodes, elems, blocks, nodesets and sidesets</span>
<a name="l00157"></a>00157   <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#aefe8b0652990f2a3c4f9b13372a04594">get_init_global</a>();
<a name="l00158"></a>00158   
<a name="l00159"></a>00159   <span class="comment">// Get &quot;load balance&quot; information.  This includes the number of internal &amp; border</span>
<a name="l00160"></a>00160   <span class="comment">// nodes and elements as well as the number of communication maps.</span>
<a name="l00161"></a>00161   <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#ad51dccf48af546768e8d8c38b38d9199">get_loadbal_param</a>();
<a name="l00162"></a>00162   
<a name="l00163"></a>00163   <span class="comment">// Do some error checking</span>
<a name="l00164"></a>00164   <span class="keywordflow">if</span> (<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#a72be75805bfcc7ea69945d388d03613a">num_external_nodes</a>)
<a name="l00165"></a>00165     {
<a name="l00166"></a>00166       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: there should be no external nodes in an element-based partitioning!&quot;</span>
<a name="l00167"></a>00167                 &lt;&lt; std::endl;
<a name="l00168"></a>00168       libmesh_error();
<a name="l00169"></a>00169     }
<a name="l00170"></a>00170 
<a name="l00171"></a>00171   libmesh_assert (<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a5f58455a10a22df08b2733e4b5e39aef">num_nodes</a> ==
<a name="l00172"></a>00172                   (<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#ad1bb0c3c604b2bf5c6b86c8519947271">num_internal_nodes</a> + 
<a name="l00173"></a>00173                    <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#aef9540fb4039cf360b30084bb3b2f043">num_border_nodes</a>));
<a name="l00174"></a>00174   
<a name="l00175"></a>00175   libmesh_assert (<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a5f3697a4d820cb9b2b4f18dd3a035f12">num_elem</a> ==
<a name="l00176"></a>00176                   (<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#a44993cb2a368e2801eeda5d9344c79f9">num_internal_elems</a> +
<a name="l00177"></a>00177                    <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#affe3458fe4a6b73f4cee8e58145ac65d">num_border_elems</a>));
<a name="l00178"></a>00178   
<a name="l00179"></a>00179   libmesh_assert (<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a5f58455a10a22df08b2733e4b5e39aef">num_nodes</a> &lt;= <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#a93408876262dd779fc874a85e7513627">num_nodes_global</a>);
<a name="l00180"></a>00180   libmesh_assert (<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a5f3697a4d820cb9b2b4f18dd3a035f12">num_elem</a>  &lt;= <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#aa8906be9fe6255354908463a19de130d">num_elems_global</a>);
<a name="l00181"></a>00181       
<a name="l00182"></a>00182   <span class="comment">// Read nodes from the exodus file: this fills the nemhelper.x,y,z arrays.</span>
<a name="l00183"></a>00183   <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a0ae664b1cc9421fff23daeff6049b591">read_nodes</a>();
<a name="l00184"></a>00184 
<a name="l00185"></a>00185   <span class="comment">// Reads the nemhelper.node_num_map array, node_num_map[i] is the global node number for</span>
<a name="l00186"></a>00186   <span class="comment">// local node number i.</span>
<a name="l00187"></a>00187   <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a0fb998fe79e5d8f206925d29c363eb45">read_node_num_map</a>();
<a name="l00188"></a>00188   
<a name="l00189"></a>00189   <span class="comment">// The get_cmap_params() function reads in the:</span>
<a name="l00190"></a>00190   <span class="comment">//  node_cmap_ids[],</span>
<a name="l00191"></a>00191   <span class="comment">//  node_cmap_node_cnts[],</span>
<a name="l00192"></a>00192   <span class="comment">//  elem_cmap_ids[],</span>
<a name="l00193"></a>00193   <span class="comment">//  elem_cmap_elem_cnts[],</span>
<a name="l00194"></a>00194   <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#a920b522c0e9c97168a61ad4a5e6fdd1a">get_cmap_params</a>();
<a name="l00195"></a>00195   
<a name="l00196"></a>00196   <span class="comment">// Read the IDs of the interior, boundary, and external nodes.  This function</span>
<a name="l00197"></a>00197   <span class="comment">// fills the vectors:</span>
<a name="l00198"></a>00198   <span class="comment">//  node_mapi[],</span>
<a name="l00199"></a>00199   <span class="comment">//  node_mapb[],</span>
<a name="l00200"></a>00200   <span class="comment">//  node_mape[]</span>
<a name="l00201"></a>00201   <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#ae18b474d41f4e7393076f7a196f8b692">get_node_map</a>();
<a name="l00202"></a>00202   
<a name="l00203"></a>00203   <span class="comment">// Read each node communication map for this processor.  This function</span>
<a name="l00204"></a>00204   <span class="comment">// fills the vectors of vectors named:</span>
<a name="l00205"></a>00205   <span class="comment">//  node_cmap_node_ids[][]</span>
<a name="l00206"></a>00206   <span class="comment">//  node_cmap_proc_ids[][]</span>
<a name="l00207"></a>00207   <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#a2e8ebc4c5107a95e2741d2ea39235d7a">get_node_cmap</a>();
<a name="l00208"></a>00208 
<a name="l00209"></a>00209   libmesh_assert (to_uint(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#adb3de98f16985108f1e6238fd57b9293">num_node_cmaps</a>) == <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#aafaa51ee1443a4a7f040de27c2861f9f">node_cmap_node_cnts</a>.size());
<a name="l00210"></a>00210   libmesh_assert (to_uint(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#adb3de98f16985108f1e6238fd57b9293">num_node_cmaps</a>) == <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#a465e329ca0b93bfbf01a69f24fa394de">node_cmap_node_ids</a>.size());
<a name="l00211"></a>00211   libmesh_assert (to_uint(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#adb3de98f16985108f1e6238fd57b9293">num_node_cmaps</a>) == <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#ac6fff644d62c498246bcc020bc66e814">node_cmap_proc_ids</a>.size());
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00214"></a>00214 <span class="preprocessor"></span>  <span class="comment">// We expect the communication maps to be symmetric - e.g. if processor i thinks it</span>
<a name="l00215"></a>00215   <span class="comment">// communicates with processor j, then processor j should also be expecting to</span>
<a name="l00216"></a>00216   <span class="comment">// communicate with i.  We can assert that here easily enough with an alltoall,</span>
<a name="l00217"></a>00217   <span class="comment">// but let&#39;s only do it when not in optimized mode to limit unnecessary communication.</span>
<a name="l00218"></a>00218   {
<a name="l00219"></a>00219     std::vector&lt;unsigned char&gt; pid_send_partener (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l00220"></a>00220 
<a name="l00221"></a>00221     <span class="comment">// strictly speaking, we should expect to communicate with ourself...</span>
<a name="l00222"></a>00222     pid_send_partener[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()] = 1;
<a name="l00223"></a>00223     
<a name="l00224"></a>00224     <span class="comment">// mark each processor id we reference with a node cmap </span>
<a name="l00225"></a>00225     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cmap=0; cmap&lt;to_uint(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#adb3de98f16985108f1e6238fd57b9293">num_node_cmaps</a>); cmap++)
<a name="l00226"></a>00226       {
<a name="l00227"></a>00227         libmesh_assert (to_uint(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#ade7e2ae0aecfc073b48b5fe37fe35312">node_cmap_ids</a>[cmap]) &lt; <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00228"></a>00228 
<a name="l00229"></a>00229         pid_send_partener[<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#ade7e2ae0aecfc073b48b5fe37fe35312">node_cmap_ids</a>[cmap]] = 1;
<a name="l00230"></a>00230       }
<a name="l00231"></a>00231 
<a name="l00232"></a>00232     <span class="comment">// Copy the send pairing so we can catch the receive paring and</span>
<a name="l00233"></a>00233     <span class="comment">// test for equality</span>
<a name="l00234"></a>00234     <span class="keyword">const</span> std::vector&lt;unsigned char&gt; pid_recv_partener (pid_send_partener);
<a name="l00235"></a>00235     
<a name="l00236"></a>00236     Parallel::alltoall (pid_send_partener);
<a name="l00237"></a>00237 
<a name="l00238"></a>00238     libmesh_assert (pid_send_partener == pid_recv_partener);
<a name="l00239"></a>00239   }
<a name="l00240"></a>00240 <span class="preprocessor">#endif</span>
<a name="l00241"></a>00241 <span class="preprocessor"></span>  
<a name="l00242"></a>00242   <span class="comment">// We now have enough information to infer node ownership.  We start by assuming</span>
<a name="l00243"></a>00243   <span class="comment">// we own all the nodes on this processor.  We will then interrogate the </span>
<a name="l00244"></a>00244   <span class="comment">// node cmaps and see if a lower-rank processor is associated with any of</span>
<a name="l00245"></a>00245   <span class="comment">// our nodes.  If so, then that processor owns the node, not us...</span>
<a name="l00246"></a>00246   std::vector&lt;unsigned short int&gt; node_ownership (<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#ad1bb0c3c604b2bf5c6b86c8519947271">num_internal_nodes</a> +
<a name="l00247"></a>00247                                                   <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#aef9540fb4039cf360b30084bb3b2f043">num_border_nodes</a>,
<a name="l00248"></a>00248                                                   libMesh::processor_id());
<a name="l00249"></a>00249 
<a name="l00250"></a>00250   <span class="comment">// a map from processor id to cmap number, to be used later</span>
<a name="l00251"></a>00251   std::map&lt;unsigned int, unsigned int&gt; pid_to_cmap_map;
<a name="l00252"></a>00252 
<a name="l00253"></a>00253   <span class="comment">// For each node_cmap...</span>
<a name="l00254"></a>00254   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cmap=0; cmap&lt;to_uint(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#adb3de98f16985108f1e6238fd57b9293">num_node_cmaps</a>); cmap++)
<a name="l00255"></a>00255     {
<a name="l00256"></a>00256       <span class="comment">// Good time for error checking...</span>
<a name="l00257"></a>00257       libmesh_assert (to_uint(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#aafaa51ee1443a4a7f040de27c2861f9f">node_cmap_node_cnts</a>[cmap]) ==
<a name="l00258"></a>00258                       <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#a465e329ca0b93bfbf01a69f24fa394de">node_cmap_node_ids</a>[cmap].size());
<a name="l00259"></a>00259       
<a name="l00260"></a>00260       libmesh_assert (to_uint(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#aafaa51ee1443a4a7f040de27c2861f9f">node_cmap_node_cnts</a>[cmap]) ==
<a name="l00261"></a>00261                       <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#ac6fff644d62c498246bcc020bc66e814">node_cmap_proc_ids</a>[cmap].size());
<a name="l00262"></a>00262       
<a name="l00263"></a>00263       <span class="comment">// In all the samples I have seen, node_cmap_ids[cmap] is the processor</span>
<a name="l00264"></a>00264       <span class="comment">// rank of the remote processor...</span>
<a name="l00265"></a>00265       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> adjcnt_pid_idx = <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#ade7e2ae0aecfc073b48b5fe37fe35312">node_cmap_ids</a>[cmap];
<a name="l00266"></a>00266 
<a name="l00267"></a>00267       libmesh_assert (adjcnt_pid_idx &lt;  <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00268"></a>00268       libmesh_assert (adjcnt_pid_idx != libMesh::processor_id());
<a name="l00269"></a>00269       
<a name="l00270"></a>00270       <span class="comment">// We only expect one cmap per adjacent processor</span>
<a name="l00271"></a>00271       libmesh_assert (!pid_to_cmap_map.count(adjcnt_pid_idx));
<a name="l00272"></a>00272                                                 
<a name="l00273"></a>00273       pid_to_cmap_map[adjcnt_pid_idx] = cmap;
<a name="l00274"></a>00274 
<a name="l00275"></a>00275       <span class="comment">// ...and each node in that cmap...</span>
<a name="l00276"></a>00276       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>=0; <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>&lt;to_uint(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#aafaa51ee1443a4a7f040de27c2861f9f">node_cmap_node_cnts</a>[cmap]); <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>++)
<a name="l00277"></a>00277         {
<a name="l00278"></a>00278           <span class="comment">//  Are the node_cmap_ids and node_cmap_proc_ids really redundant?</span>
<a name="l00279"></a>00279           libmesh_assert (adjcnt_pid_idx == <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#ac6fff644d62c498246bcc020bc66e814">node_cmap_proc_ids</a>[cmap][<a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>]);
<a name="l00280"></a>00280           
<a name="l00281"></a>00281           <span class="comment">// we are expecting the exodus node numbering to be 1-based...</span>
<a name="l00282"></a>00282           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_node_idx = <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#a465e329ca0b93bfbf01a69f24fa394de">node_cmap_node_ids</a>[cmap][<a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>]-1;
<a name="l00283"></a>00283 
<a name="l00284"></a>00284           libmesh_assert (local_node_idx &lt; node_ownership.size());
<a name="l00285"></a>00285           
<a name="l00286"></a>00286           <span class="comment">// if the adjacent processor is lower rank than the current</span>
<a name="l00287"></a>00287           <span class="comment">// owner for this node, then it will get the node...</span>
<a name="l00288"></a>00288           node_ownership[local_node_idx] = 
<a name="l00289"></a>00289             <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(node_ownership[local_node_idx], adjcnt_pid_idx);
<a name="l00290"></a>00290         }
<a name="l00291"></a>00291     } <span class="comment">// We now should have established proper node ownership.</span>
<a name="l00292"></a>00292 
<a name="l00293"></a>00293   <span class="comment">// now that ownership is established, we can figure out how many nodes we </span>
<a name="l00294"></a>00294   <span class="comment">// will be responsible for numbering.</span>
<a name="l00295"></a>00295   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num_nodes_i_must_number = 0;
<a name="l00296"></a>00296 
<a name="l00297"></a>00297   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>=0; <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>&lt;node_ownership.size(); <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>++)
<a name="l00298"></a>00298     <span class="keywordflow">if</span> (node_ownership[<a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>] == libMesh::processor_id())
<a name="l00299"></a>00299       num_nodes_i_must_number++;
<a name="l00300"></a>00300 
<a name="l00301"></a>00301   <span class="comment">// more error checking...</span>
<a name="l00302"></a>00302   libmesh_assert (num_nodes_i_must_number &gt;= to_uint(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#ad1bb0c3c604b2bf5c6b86c8519947271">num_internal_nodes</a>));
<a name="l00303"></a>00303   libmesh_assert (num_nodes_i_must_number &lt;= to_uint(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#ad1bb0c3c604b2bf5c6b86c8519947271">num_internal_nodes</a> +
<a name="l00304"></a>00304                                                   <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#aef9540fb4039cf360b30084bb3b2f043">num_border_nodes</a>));
<a name="l00305"></a>00305   <span class="keywordflow">if</span> (<a class="code" href="classNemesis__IO.php#a69c1bbcbb75afaec414ddb5ccc19c93d">_verbose</a>)
<a name="l00306"></a>00306     std::cout &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00307"></a>00307               &lt;&lt; <span class="stringliteral">&quot;num_nodes_i_must_number=&quot;</span>
<a name="l00308"></a>00308               &lt;&lt; num_nodes_i_must_number
<a name="l00309"></a>00309               &lt;&lt; std::endl;
<a name="l00310"></a>00310   
<a name="l00311"></a>00311   <span class="comment">// The call to get_loadbal_param() gets 7 pieces of information.  We allgather</span>
<a name="l00312"></a>00312   <span class="comment">// these now across all processors to determine some global numberings. We should</span>
<a name="l00313"></a>00313   <span class="comment">// also gather the number of nodes each processor thinks it will number so that</span>
<a name="l00314"></a>00314   <span class="comment">// we can (i) determine our offset, and (ii) do some error checking.</span>
<a name="l00315"></a>00315   std::vector&lt;int&gt; all_loadbal_data ( 8 );
<a name="l00316"></a>00316   all_loadbal_data[0] = <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#ad1bb0c3c604b2bf5c6b86c8519947271">num_internal_nodes</a>;
<a name="l00317"></a>00317   all_loadbal_data[1] = <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#aef9540fb4039cf360b30084bb3b2f043">num_border_nodes</a>;
<a name="l00318"></a>00318   all_loadbal_data[2] = <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#a72be75805bfcc7ea69945d388d03613a">num_external_nodes</a>;
<a name="l00319"></a>00319   all_loadbal_data[3] = <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#a44993cb2a368e2801eeda5d9344c79f9">num_internal_elems</a>;
<a name="l00320"></a>00320   all_loadbal_data[4] = <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#affe3458fe4a6b73f4cee8e58145ac65d">num_border_elems</a>;
<a name="l00321"></a>00321   all_loadbal_data[5] = <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#adb3de98f16985108f1e6238fd57b9293">num_node_cmaps</a>;
<a name="l00322"></a>00322   all_loadbal_data[6] = <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#a1132aa96f2e47d370bcb9a383f602cb6">num_elem_cmaps</a>;
<a name="l00323"></a>00323   all_loadbal_data[7] = num_nodes_i_must_number;
<a name="l00324"></a>00324   
<a name="l00325"></a>00325   Parallel::allgather (all_loadbal_data, <span class="comment">/* identical_buffer_sizes = */</span> <span class="keyword">true</span>);
<a name="l00326"></a>00326 
<a name="l00327"></a>00327   <span class="comment">// OK, we are now in a position to request new global indices for all the nodes</span>
<a name="l00328"></a>00328   <span class="comment">// we do not own</span>
<a name="l00329"></a>00329   std::vector&lt;std::vector&lt;int&gt; &gt; 
<a name="l00330"></a>00330     needed_node_idxs (<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#adb3de98f16985108f1e6238fd57b9293">num_node_cmaps</a>); <span class="comment">// the indices we will ask for</span>
<a name="l00331"></a>00331     
<a name="l00332"></a>00332   std::vector&lt;Parallel::Request&gt; 
<a name="l00333"></a>00333     needed_nodes_requests (<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#adb3de98f16985108f1e6238fd57b9293">num_node_cmaps</a>);
<a name="l00334"></a>00334   
<a name="l00335"></a>00335   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cmap=0; cmap&lt;to_uint(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#adb3de98f16985108f1e6238fd57b9293">num_node_cmaps</a>); cmap++)
<a name="l00336"></a>00336     {
<a name="l00337"></a>00337       <span class="comment">// We know we will need no more indices than there are nodes</span>
<a name="l00338"></a>00338       <span class="comment">// in this cmap, but that number is an upper bound in general</span>
<a name="l00339"></a>00339       <span class="comment">// since the neighboring processor associated with the cmap</span>
<a name="l00340"></a>00340       <span class="comment">//  may not actually own it</span>
<a name="l00341"></a>00341       needed_node_idxs[cmap].reserve   (<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#aafaa51ee1443a4a7f040de27c2861f9f">node_cmap_node_cnts</a>[cmap]);
<a name="l00342"></a>00342             
<a name="l00343"></a>00343       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> adjcnt_pid_idx = <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#ade7e2ae0aecfc073b48b5fe37fe35312">node_cmap_ids</a>[cmap];
<a name="l00344"></a>00344 
<a name="l00345"></a>00345       <span class="comment">// ...and each node in that cmap...</span>
<a name="l00346"></a>00346       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>=0; <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>&lt;to_uint(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#aafaa51ee1443a4a7f040de27c2861f9f">node_cmap_node_cnts</a>[cmap]); <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>++)
<a name="l00347"></a>00347         {
<a name="l00348"></a>00348           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00349"></a>00349             local_node_idx  = <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#a465e329ca0b93bfbf01a69f24fa394de">node_cmap_node_ids</a>[cmap][<a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>]-1,
<a name="l00350"></a>00350             owning_pid_idx  = node_ownership[local_node_idx];
<a name="l00351"></a>00351 
<a name="l00352"></a>00352           <span class="comment">// add it to the request list for its owning processor.</span>
<a name="l00353"></a>00353           <span class="keywordflow">if</span> (owning_pid_idx == adjcnt_pid_idx)
<a name="l00354"></a>00354             {
<a name="l00355"></a>00355               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00356"></a>00356                 global_node_idx = <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a24538ef46d1309b8dc1fca2a9e937ad0">node_num_map</a>[local_node_idx]-1;
<a name="l00357"></a>00357               needed_node_idxs[cmap].push_back(global_node_idx);
<a name="l00358"></a>00358             }
<a name="l00359"></a>00359         }
<a name="l00360"></a>00360       <span class="comment">// now post the send for this cmap</span>
<a name="l00361"></a>00361       Parallel::send (adjcnt_pid_idx,              <span class="comment">// destination</span>
<a name="l00362"></a>00362                       needed_node_idxs[cmap],      <span class="comment">// send buffer</span>
<a name="l00363"></a>00363                       needed_nodes_requests[cmap], <span class="comment">// request</span>
<a name="l00364"></a>00364                          <span class="comment">/* tag = */</span> 12345);      
<a name="l00365"></a>00365     } <span class="comment">// all communication requests for getting updated global indices for border</span>
<a name="l00366"></a>00366       <span class="comment">// nodes have been initiated</span>
<a name="l00367"></a>00367 
<a name="l00368"></a>00368   <span class="comment">// Figure out how many nodes each processor thinks it will number and make sure</span>
<a name="l00369"></a>00369   <span class="comment">// that it adds up to the global number of nodes. Also, set up global node</span>
<a name="l00370"></a>00370   <span class="comment">// index offsets for each processor.</span>
<a name="l00371"></a>00371   std::vector&lt;unsigned int&gt;
<a name="l00372"></a>00372     all_num_nodes_i_must_number (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00373"></a>00373    
<a name="l00374"></a>00374   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00375"></a>00375     all_num_nodes_i_must_number[pid] = all_loadbal_data[8*pid + 7];
<a name="l00376"></a>00376   
<a name="l00377"></a>00377   <span class="comment">// The sum of all the entries in this vector should sum to the number of global nodes</span>
<a name="l00378"></a>00378   libmesh_assert (std::accumulate(all_num_nodes_i_must_number.begin(),
<a name="l00379"></a>00379                                   all_num_nodes_i_must_number.end(),
<a name="l00380"></a>00380                                   0) == <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#a93408876262dd779fc874a85e7513627">num_nodes_global</a>);
<a name="l00381"></a>00381   
<a name="l00382"></a>00382   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_next_node = 0;
<a name="l00383"></a>00383   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>(); pid++)
<a name="l00384"></a>00384     my_next_node += all_num_nodes_i_must_number[pid];
<a name="l00385"></a>00385   
<a name="l00386"></a>00386   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_node_offset = my_next_node;
<a name="l00387"></a>00387 
<a name="l00388"></a>00388   <span class="keywordflow">if</span> (<a class="code" href="classNemesis__IO.php#a69c1bbcbb75afaec414ddb5ccc19c93d">_verbose</a>)
<a name="l00389"></a>00389     std::cout &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00390"></a>00390               &lt;&lt; <span class="stringliteral">&quot;my_node_offset=&quot;</span>
<a name="l00391"></a>00391               &lt;&lt; my_node_offset
<a name="l00392"></a>00392               &lt;&lt; std::endl;
<a name="l00393"></a>00393   
<a name="l00394"></a>00394   <span class="comment">// Add internal nodes to the ParallelMesh, using the node ID offset we</span>
<a name="l00395"></a>00395   <span class="comment">// computed and the current processor&#39;s ID.</span>
<a name="l00396"></a>00396   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;to_uint(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#ad1bb0c3c604b2bf5c6b86c8519947271">num_internal_nodes</a>); ++i)
<a name="l00397"></a>00397     {
<a name="l00398"></a>00398       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00399"></a>00399         local_node_idx  = <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#aeb1fc829338103345105dadb6946fe5f">node_mapi</a>[i]-1,
<a name="l00400"></a>00400         global_node_idx = <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a24538ef46d1309b8dc1fca2a9e937ad0">node_num_map</a>[local_node_idx]-1,
<a name="l00401"></a>00401         owning_pid_idx  = node_ownership[local_node_idx];
<a name="l00402"></a>00402 
<a name="l00403"></a>00403       <span class="comment">// an internal node we do not own? huh??</span>
<a name="l00404"></a>00404       libmesh_assert (owning_pid_idx == libMesh::processor_id());
<a name="l00405"></a>00405       libmesh_assert (global_node_idx &lt; to_uint(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#a93408876262dd779fc874a85e7513627">num_nodes_global</a>));
<a name="l00406"></a>00406 
<a name="l00407"></a>00407       mesh.<a class="code" href="classParallelMesh.php#a9a458dd93052e3707da352e1ca0ea0b6">add_point</a> (<a class="code" href="classPoint.php">Point</a>(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a168332624b026270a5424916f638c0f7">x</a>[local_node_idx],
<a name="l00408"></a>00408                             <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a1c72a90256cbff143f3685f97648f958">y</a>[local_node_idx],
<a name="l00409"></a>00409                             <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a952624a5decb9b620eb59ffb41c948e4">z</a>[local_node_idx]), 
<a name="l00410"></a>00410                       my_next_node, 
<a name="l00411"></a>00411                       libMesh::processor_id());
<a name="l00412"></a>00412 
<a name="l00413"></a>00413       <span class="comment">// update the local-&gt;global index map, when we are done</span>
<a name="l00414"></a>00414       <span class="comment">// it will be 0-based.</span>
<a name="l00415"></a>00415       <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a24538ef46d1309b8dc1fca2a9e937ad0">node_num_map</a>[local_node_idx] = my_next_node++;
<a name="l00416"></a>00416     }
<a name="l00417"></a>00417 
<a name="l00418"></a>00418   <span class="comment">// Now, for the boundary nodes...  We may very well own some of them,</span>
<a name="l00419"></a>00419   <span class="comment">// but there may be others for which we have requested the new global</span>
<a name="l00420"></a>00420   <span class="comment">// id.  We expect to be asked for the ids of the ones we own, so </span>
<a name="l00421"></a>00421   <span class="comment">// we need to create a map from the old global id to the new one</span>
<a name="l00422"></a>00422   <span class="comment">// we are about to create.</span>
<a name="l00423"></a>00423   <span class="keyword">typedef</span> std::vector&lt;std::pair&lt;unsigned int, unsigned int&gt; &gt; global_idx_mapping_type;
<a name="l00424"></a>00424   global_idx_mapping_type old_global_to_new_global_map;
<a name="l00425"></a>00425   old_global_to_new_global_map.reserve (num_nodes_i_must_number <span class="comment">// total # i will have         </span>
<a name="l00426"></a>00426                                         - (my_next_node         <span class="comment">// amount i have thus far</span>
<a name="l00427"></a>00427                                            - my_node_offset));  <span class="comment">// this should be exact! </span>
<a name="l00428"></a>00428   CompareGlobalIdxMappings global_idx_mapping_comp;
<a name="l00429"></a>00429 
<a name="l00430"></a>00430   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;to_uint(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#aef9540fb4039cf360b30084bb3b2f043">num_border_nodes</a>); ++i)
<a name="l00431"></a>00431     {
<a name="l00432"></a>00432       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00433"></a>00433         local_node_idx  = <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#a857a6b1208f9747144efac37f9ad1030">node_mapb</a>[i]-1,
<a name="l00434"></a>00434         owning_pid_idx  = node_ownership[local_node_idx];       
<a name="l00435"></a>00435       
<a name="l00436"></a>00436       <span class="comment">// if we own it...</span>
<a name="l00437"></a>00437       <span class="keywordflow">if</span> (owning_pid_idx == libMesh::processor_id())
<a name="l00438"></a>00438         {
<a name="l00439"></a>00439           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00440"></a>00440             global_node_idx = <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a24538ef46d1309b8dc1fca2a9e937ad0">node_num_map</a>[local_node_idx]-1;
<a name="l00441"></a>00441 
<a name="l00442"></a>00442           <span class="comment">// we will number it, and create a mapping from its old global index to</span>
<a name="l00443"></a>00443           <span class="comment">// the new global index, for lookup purposes when neighbors come calling</span>
<a name="l00444"></a>00444           old_global_to_new_global_map.push_back(std::make_pair(global_node_idx, 
<a name="l00445"></a>00445                                                                 my_next_node));
<a name="l00446"></a>00446           mesh.<a class="code" href="classParallelMesh.php#a9a458dd93052e3707da352e1ca0ea0b6">add_point</a> (<a class="code" href="classPoint.php">Point</a>(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a168332624b026270a5424916f638c0f7">x</a>[local_node_idx],
<a name="l00447"></a>00447                                 <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a1c72a90256cbff143f3685f97648f958">y</a>[local_node_idx],
<a name="l00448"></a>00448                                 <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a952624a5decb9b620eb59ffb41c948e4">z</a>[local_node_idx]), 
<a name="l00449"></a>00449                           my_next_node, 
<a name="l00450"></a>00450                           libMesh::processor_id());
<a name="l00451"></a>00451 
<a name="l00452"></a>00452           <span class="comment">// update the local-&gt;global index map, when we are done</span>
<a name="l00453"></a>00453           <span class="comment">// it will be 0-based.</span>
<a name="l00454"></a>00454           <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a24538ef46d1309b8dc1fca2a9e937ad0">node_num_map</a>[local_node_idx] = my_next_node++;
<a name="l00455"></a>00455         }
<a name="l00456"></a>00456     }
<a name="l00457"></a>00457   <span class="comment">// That should cover numbering all the nodes which belong to us...</span>
<a name="l00458"></a>00458   libmesh_assert (num_nodes_i_must_number == (my_next_node - my_node_offset));
<a name="l00459"></a>00459 
<a name="l00460"></a>00460   <span class="comment">// Let&#39;s sort the mapping so we can efficiently answer requests</span>
<a name="l00461"></a>00461   std::sort (old_global_to_new_global_map.begin(),
<a name="l00462"></a>00462              old_global_to_new_global_map.end(),
<a name="l00463"></a>00463              global_idx_mapping_comp);
<a name="l00464"></a>00464 
<a name="l00465"></a>00465   <span class="comment">// and it had better be unique...</span>
<a name="l00466"></a>00466   libmesh_assert (std::unique (old_global_to_new_global_map.begin(),
<a name="l00467"></a>00467                                old_global_to_new_global_map.end(),
<a name="l00468"></a>00468                                global_idx_mapping_equality) ==
<a name="l00469"></a>00469                   old_global_to_new_global_map.end());
<a name="l00470"></a>00470 
<a name="l00471"></a>00471   <span class="comment">// We can now catch incoming requests and process them. for efficiency</span>
<a name="l00472"></a>00472   <span class="comment">// let&#39;s do whatever is available next</span>
<a name="l00473"></a>00473   std::map&lt;unsigned int, std::vector&lt;int&gt; &gt; requested_node_idxs; <span class="comment">// the indices asked of us   </span>
<a name="l00474"></a>00474 
<a name="l00475"></a>00475   std::vector&lt;Parallel::Request&gt; requested_nodes_requests(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#adb3de98f16985108f1e6238fd57b9293">num_node_cmaps</a>);
<a name="l00476"></a>00476   
<a name="l00477"></a>00477   <span class="comment">// We know we will receive the request from a given processor before</span>
<a name="l00478"></a>00478   <span class="comment">// we receive its reply to our request. However, we may receive</span>
<a name="l00479"></a>00479   <span class="comment">// a request and a response from one processor before getting</span>
<a name="l00480"></a>00480   <span class="comment">// a request from another processor.  So what we are doing here</span>
<a name="l00481"></a>00481   <span class="comment">// is processing whatever message comes next, while recognizing </span>
<a name="l00482"></a>00482   <span class="comment">// we will receive a request from a processor before receiving</span>
<a name="l00483"></a>00483   <span class="comment">// its reply</span>
<a name="l00484"></a>00484   std::vector&lt;bool&gt; processed_cmap (<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#adb3de98f16985108f1e6238fd57b9293">num_node_cmaps</a>, <span class="keyword">false</span>);
<a name="l00485"></a>00485 
<a name="l00486"></a>00486   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comm_step=0; comm_step&lt;2*to_uint(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#adb3de98f16985108f1e6238fd57b9293">num_node_cmaps</a>); comm_step++)
<a name="l00487"></a>00487     {
<a name="l00488"></a>00488       <span class="comment">// query the first message which is available</span>
<a name="l00489"></a>00489       <span class="keyword">const</span> Parallel::Status 
<a name="l00490"></a>00490         status (Parallel::probe (Parallel::any_source, 
<a name="l00491"></a>00491                                  <span class="comment">/* tag = */</span> 12345));
<a name="l00492"></a>00492       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00493"></a>00493         requesting_pid_idx = status.source(),
<a name="l00494"></a>00494         source_pid_idx     = status.source();
<a name="l00495"></a>00495 
<a name="l00496"></a>00496       <span class="comment">// this had better be from a processor we are expecting...</span>
<a name="l00497"></a>00497       libmesh_assert (pid_to_cmap_map.count(requesting_pid_idx));
<a name="l00498"></a>00498       
<a name="l00499"></a>00499       <span class="comment">// the local cmap which corresponds to the source processor</span>
<a name="l00500"></a>00500       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cmap = pid_to_cmap_map[source_pid_idx];
<a name="l00501"></a>00501 
<a name="l00502"></a>00502       <span class="keywordflow">if</span> (!processed_cmap[cmap])
<a name="l00503"></a>00503         {
<a name="l00504"></a>00504           processed_cmap[cmap] = <span class="keyword">true</span>;
<a name="l00505"></a>00505           
<a name="l00506"></a>00506           <span class="comment">// we should only get one request per paired processor</span>
<a name="l00507"></a>00507           libmesh_assert (!requested_node_idxs.count(requesting_pid_idx));
<a name="l00508"></a>00508       
<a name="l00509"></a>00509           <span class="comment">// get a reference to the request buffer for this processor to</span>
<a name="l00510"></a>00510           <span class="comment">// avoid repeated map lookups</span>
<a name="l00511"></a>00511           std::vector&lt;int&gt; &amp;xfer_buf (requested_node_idxs[requesting_pid_idx]);
<a name="l00512"></a>00512             
<a name="l00513"></a>00513           <span class="comment">// actually receive the message.  </span>
<a name="l00514"></a>00514           Parallel::receive (requesting_pid_idx, xfer_buf, <span class="comment">/* tag = */</span> 12345);
<a name="l00515"></a>00515           
<a name="l00516"></a>00516           <span class="comment">// Fill the request</span>
<a name="l00517"></a>00517           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;xfer_buf.size(); i++)
<a name="l00518"></a>00518             {
<a name="l00519"></a>00519               <span class="comment">// the requested old global node index, *now 0-based*</span>
<a name="l00520"></a>00520               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_global_node_idx = xfer_buf[i];
<a name="l00521"></a>00521               
<a name="l00522"></a>00522               <span class="comment">// find the new global node index for the requested node -</span>
<a name="l00523"></a>00523               <span class="comment">// note that requesting_pid_idx thinks we own this node,</span>
<a name="l00524"></a>00524               <span class="comment">// so we better!</span>
<a name="l00525"></a>00525               <span class="keyword">const</span> global_idx_mapping_type::const_iterator it =
<a name="l00526"></a>00526                 std::lower_bound (old_global_to_new_global_map.begin(),
<a name="l00527"></a>00527                                   old_global_to_new_global_map.end(),
<a name="l00528"></a>00528                                   old_global_node_idx,
<a name="l00529"></a>00529                                   global_idx_mapping_comp);
<a name="l00530"></a>00530                 
<a name="l00531"></a>00531               libmesh_assert (it != old_global_to_new_global_map.end());
<a name="l00532"></a>00532               libmesh_assert (it-&gt;first == old_global_node_idx);
<a name="l00533"></a>00533               libmesh_assert (it-&gt;second &gt;= my_node_offset);
<a name="l00534"></a>00534               libmesh_assert (it-&gt;second &lt;  my_next_node);
<a name="l00535"></a>00535               
<a name="l00536"></a>00536               <span class="comment">// overwrite the requested old global node index with the new global index</span>
<a name="l00537"></a>00537               xfer_buf[i] = it-&gt;second;
<a name="l00538"></a>00538             }
<a name="l00539"></a>00539             
<a name="l00540"></a>00540           <span class="comment">// and send the new global indices back to the processor which asked for them</span>
<a name="l00541"></a>00541           Parallel::send (requesting_pid_idx,
<a name="l00542"></a>00542                           xfer_buf,
<a name="l00543"></a>00543                           requested_nodes_requests[cmap],
<a name="l00544"></a>00544                           <span class="comment">/* tag = */</span> 12345);
<a name="l00545"></a>00545         } <span class="comment">// done processing the request</span>
<a name="l00546"></a>00546       
<a name="l00547"></a>00547       <span class="comment">// this is the second time we have heard from this processor, </span>
<a name="l00548"></a>00548       <span class="comment">// so it must be its reply to our request</span>
<a name="l00549"></a>00549       <span class="keywordflow">else</span>
<a name="l00550"></a>00550         {
<a name="l00551"></a>00551           <span class="comment">// a long time ago, we sent off our own requests.  now it is time to catch the </span>
<a name="l00552"></a>00552           <span class="comment">// replies and get the new global node numbering.  note that for any reply</span>
<a name="l00553"></a>00553           <span class="comment">// we receive, the corresponding nonblocking send from above *must* have been </span>
<a name="l00554"></a>00554           <span class="comment">// completed, since the reply is in response to that request!!</span>
<a name="l00555"></a>00555           
<a name="l00556"></a>00556           <span class="comment">// if we have received a reply, our send *must* have completed</span>
<a name="l00557"></a>00557           <span class="comment">// (note we never actually need to wait on the request)</span>
<a name="l00558"></a>00558           libmesh_assert (needed_nodes_requests[cmap].test());
<a name="l00559"></a>00559           libmesh_assert (to_uint(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#ade7e2ae0aecfc073b48b5fe37fe35312">node_cmap_ids</a>[cmap]) == source_pid_idx);
<a name="l00560"></a>00560             
<a name="l00561"></a>00561           <span class="comment">// now post the receive for this cmap</span>
<a name="l00562"></a>00562           Parallel::receive (source_pid_idx,
<a name="l00563"></a>00563                              needed_node_idxs[cmap],
<a name="l00564"></a>00564                              <span class="comment">/* tag = */</span> 12345);
<a name="l00565"></a>00565           
<a name="l00566"></a>00566           libmesh_assert (needed_node_idxs[cmap].size() &lt;= 
<a name="l00567"></a>00567                           <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#a465e329ca0b93bfbf01a69f24fa394de">node_cmap_node_ids</a>[cmap].size());
<a name="l00568"></a>00568           
<a name="l00569"></a>00569           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0,j=0; i&lt;<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#a465e329ca0b93bfbf01a69f24fa394de">node_cmap_node_ids</a>[cmap].size(); i++)
<a name="l00570"></a>00570             {
<a name="l00571"></a>00571               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00572"></a>00572                 local_node_idx  = <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#a465e329ca0b93bfbf01a69f24fa394de">node_cmap_node_ids</a>[cmap][i]-1,
<a name="l00573"></a>00573                 owning_pid_idx  = node_ownership[local_node_idx];       
<a name="l00574"></a>00574               
<a name="l00575"></a>00575               <span class="comment">// if this node is owned by source_pid_idx, its new global id </span>
<a name="l00576"></a>00576               <span class="comment">// is in the buffer we just received</span>
<a name="l00577"></a>00577               <span class="keywordflow">if</span> (owning_pid_idx == source_pid_idx)
<a name="l00578"></a>00578                 {
<a name="l00579"></a>00579                   libmesh_assert (j &lt; needed_node_idxs[cmap].size());
<a name="l00580"></a>00580                     
<a name="l00581"></a>00581                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">// now 0-based!</span>
<a name="l00582"></a>00582                     global_node_idx = needed_node_idxs[cmap][j++];
<a name="l00583"></a>00583                   
<a name="l00584"></a>00584                   mesh.<a class="code" href="classParallelMesh.php#a9a458dd93052e3707da352e1ca0ea0b6">add_point</a> (<a class="code" href="classPoint.php">Point</a>(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a168332624b026270a5424916f638c0f7">x</a>[local_node_idx],
<a name="l00585"></a>00585                                         <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a1c72a90256cbff143f3685f97648f958">y</a>[local_node_idx],
<a name="l00586"></a>00586                                         <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a952624a5decb9b620eb59ffb41c948e4">z</a>[local_node_idx]),
<a name="l00587"></a>00587                                   global_node_idx,
<a name="l00588"></a>00588                                   source_pid_idx);
<a name="l00589"></a>00589                   
<a name="l00590"></a>00590                   <span class="comment">// update the local-&gt;global index map, when we are done</span>
<a name="l00591"></a>00591                   <span class="comment">// it will be 0-based.</span>
<a name="l00592"></a>00592                   <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a24538ef46d1309b8dc1fca2a9e937ad0">node_num_map</a>[local_node_idx] = global_node_idx;
<a name="l00593"></a>00593                   
<a name="l00594"></a>00594                   <span class="comment">// we are not really going to use my_next_node again, but we can</span>
<a name="l00595"></a>00595                   <span class="comment">// keep incrimenting it to track how many nodes we have added </span>
<a name="l00596"></a>00596                   <span class="comment">// to the mesh</span>
<a name="l00597"></a>00597                   my_next_node++;
<a name="l00598"></a>00598                 }
<a name="l00599"></a>00599             }
<a name="l00600"></a>00600         }
<a name="l00601"></a>00601     } <span class="comment">// end of node index communication loop</span>
<a name="l00602"></a>00602   
<a name="l00603"></a>00603   <span class="comment">// we had better have added all the nodes we need to!</span>
<a name="l00604"></a>00604   libmesh_assert ((my_next_node - my_node_offset) == to_uint(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a5f58455a10a22df08b2733e4b5e39aef">num_nodes</a>));
<a name="l00605"></a>00605 
<a name="l00606"></a>00606   <span class="comment">// After all that, we should be done with all node-related arrays *except* the</span>
<a name="l00607"></a>00607   <span class="comment">// node_num_map, which we have transformed to use our new numbering...</span>
<a name="l00608"></a>00608   <span class="comment">// So let&#39;s clean up the arrays we are done with.</span>
<a name="l00609"></a>00609   {
<a name="l00610"></a>00610     <a class="code" href="namespaceUtility.php#a87eab2b9d265355c6c62b945c15bdf9f">Utility::deallocate</a> (<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#aeb1fc829338103345105dadb6946fe5f">node_mapi</a>);
<a name="l00611"></a>00611     <a class="code" href="namespaceUtility.php#a87eab2b9d265355c6c62b945c15bdf9f">Utility::deallocate</a> (<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#a857a6b1208f9747144efac37f9ad1030">node_mapb</a>);
<a name="l00612"></a>00612     <a class="code" href="namespaceUtility.php#a87eab2b9d265355c6c62b945c15bdf9f">Utility::deallocate</a> (<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#ac4b279158fb94ed1939cec548ae6b2e7">node_mape</a>);
<a name="l00613"></a>00613     <a class="code" href="namespaceUtility.php#a87eab2b9d265355c6c62b945c15bdf9f">Utility::deallocate</a> (<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#ade7e2ae0aecfc073b48b5fe37fe35312">node_cmap_ids</a>);
<a name="l00614"></a>00614     <a class="code" href="namespaceUtility.php#a87eab2b9d265355c6c62b945c15bdf9f">Utility::deallocate</a> (<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#aafaa51ee1443a4a7f040de27c2861f9f">node_cmap_node_cnts</a>);
<a name="l00615"></a>00615     <a class="code" href="namespaceUtility.php#a87eab2b9d265355c6c62b945c15bdf9f">Utility::deallocate</a> (<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#a465e329ca0b93bfbf01a69f24fa394de">node_cmap_node_ids</a>);
<a name="l00616"></a>00616     <a class="code" href="namespaceUtility.php#a87eab2b9d265355c6c62b945c15bdf9f">Utility::deallocate</a> (<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#ac6fff644d62c498246bcc020bc66e814">node_cmap_proc_ids</a>);
<a name="l00617"></a>00617     <a class="code" href="namespaceUtility.php#a87eab2b9d265355c6c62b945c15bdf9f">Utility::deallocate</a> (<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a168332624b026270a5424916f638c0f7">x</a>);
<a name="l00618"></a>00618     <a class="code" href="namespaceUtility.php#a87eab2b9d265355c6c62b945c15bdf9f">Utility::deallocate</a> (<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a1c72a90256cbff143f3685f97648f958">y</a>);
<a name="l00619"></a>00619     <a class="code" href="namespaceUtility.php#a87eab2b9d265355c6c62b945c15bdf9f">Utility::deallocate</a> (<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a952624a5decb9b620eb59ffb41c948e4">z</a>);
<a name="l00620"></a>00620     <a class="code" href="namespaceUtility.php#a87eab2b9d265355c6c62b945c15bdf9f">Utility::deallocate</a> (needed_node_idxs);
<a name="l00621"></a>00621     <a class="code" href="namespaceUtility.php#a87eab2b9d265355c6c62b945c15bdf9f">Utility::deallocate</a> (node_ownership);
<a name="l00622"></a>00622   }
<a name="l00623"></a>00623   
<a name="l00624"></a>00624   Parallel::wait (requested_nodes_requests);
<a name="l00625"></a>00625   requested_node_idxs.clear();
<a name="l00626"></a>00626 
<a name="l00627"></a>00627   <span class="comment">// See what the node count is up to now.</span>
<a name="l00628"></a>00628   <span class="keywordflow">if</span> (<a class="code" href="classNemesis__IO.php#a69c1bbcbb75afaec414ddb5ccc19c93d">_verbose</a>)
<a name="l00629"></a>00629     {
<a name="l00630"></a>00630       <span class="comment">// Report the number of nodes which have been added locally</span>
<a name="l00631"></a>00631       std::cout &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l00632"></a>00632       std::cout &lt;&lt; <span class="stringliteral">&quot;mesh.n_nodes()=&quot;</span> &lt;&lt; mesh.<a class="code" href="classParallelMesh.php#a0b5505cdbb6799aed76cafb62a7e0135">n_nodes</a>() &lt;&lt; std::endl;
<a name="l00633"></a>00633       
<a name="l00634"></a>00634       <span class="comment">// Reports the number of nodes that have been added in total.</span>
<a name="l00635"></a>00635       std::cout &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l00636"></a>00636       std::cout &lt;&lt; <span class="stringliteral">&quot;mesh.parallel_n_nodes()=&quot;</span> &lt;&lt; mesh.<a class="code" href="classParallelMesh.php#a3222f264bd57a7c39d1e101314689c03">parallel_n_nodes</a>() &lt;&lt; std::endl;
<a name="l00637"></a>00637     }
<a name="l00638"></a>00638   
<a name="l00639"></a>00639 
<a name="l00640"></a>00640 
<a name="l00641"></a>00641   <span class="comment">// --------------------------------------------------------------------------------</span>
<a name="l00642"></a>00642   <span class="comment">// --------------------------------------------------------------------------------</span>
<a name="l00643"></a>00643   <span class="comment">// --------------------------------------------------------------------------------</span>
<a name="l00644"></a>00644 
<a name="l00645"></a>00645       
<a name="l00646"></a>00646   <span class="comment">// We can now read in the elements...Exodus stores them in blocks in which all</span>
<a name="l00647"></a>00647   <span class="comment">// elements have the same geometric type.  This code is adapted directly from exodusII_io.C</span>
<a name="l00648"></a>00648 
<a name="l00649"></a>00649   <span class="comment">// Assertion: The sum of the border and internal elements on all processors</span>
<a name="l00650"></a>00650   <span class="comment">// should equal nemhelper.num_elems_global</span>
<a name="l00651"></a>00651 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00652"></a>00652 <span class="preprocessor"></span>  {
<a name="l00653"></a>00653     <span class="keywordtype">int</span> sum_internal_elems=0, sum_border_elems=0;
<a name="l00654"></a>00654     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=3,c=0; c&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); j+=8,++c)
<a name="l00655"></a>00655       sum_internal_elems += all_loadbal_data[j];
<a name="l00656"></a>00656     
<a name="l00657"></a>00657     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=4,c=0; c&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); j+=8,++c)
<a name="l00658"></a>00658       sum_border_elems += all_loadbal_data[j];
<a name="l00659"></a>00659     
<a name="l00660"></a>00660     <span class="keywordflow">if</span> (<a class="code" href="classNemesis__IO.php#a69c1bbcbb75afaec414ddb5ccc19c93d">_verbose</a>)
<a name="l00661"></a>00661       {
<a name="l00662"></a>00662         std::cout &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l00663"></a>00663         std::cout &lt;&lt; <span class="stringliteral">&quot;sum_internal_elems=&quot;</span> &lt;&lt; sum_internal_elems &lt;&lt; std::endl;
<a name="l00664"></a>00664         
<a name="l00665"></a>00665         std::cout &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l00666"></a>00666         std::cout &lt;&lt; <span class="stringliteral">&quot;sum_border_elems=&quot;</span> &lt;&lt; sum_border_elems &lt;&lt; std::endl;
<a name="l00667"></a>00667       }
<a name="l00668"></a>00668     
<a name="l00669"></a>00669     libmesh_assert(sum_internal_elems+sum_border_elems == <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#aa8906be9fe6255354908463a19de130d">num_elems_global</a>);
<a name="l00670"></a>00670   }
<a name="l00671"></a>00671 <span class="preprocessor">#endif</span>
<a name="l00672"></a>00672 <span class="preprocessor"></span>
<a name="l00673"></a>00673   <span class="comment">// Compute my_elem_offset, the amount by which to offset the local elem numbering</span>
<a name="l00674"></a>00674   <span class="comment">// on my processor.</span>
<a name="l00675"></a>00675   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_next_elem = 0;
<a name="l00676"></a>00676   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>(); ++pid)
<a name="l00677"></a>00677     my_next_elem += (all_loadbal_data[8*pid + 3]+  <span class="comment">// num_internal_elems, proc pid</span>
<a name="l00678"></a>00678                      all_loadbal_data[8*pid + 4]); <span class="comment">// num_border_elems, proc pid</span>
<a name="l00679"></a>00679   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_elem_offset = my_next_elem;
<a name="l00680"></a>00680 
<a name="l00681"></a>00681   <span class="keywordflow">if</span> (<a class="code" href="classNemesis__IO.php#a69c1bbcbb75afaec414ddb5ccc19c93d">_verbose</a>)
<a name="l00682"></a>00682     std::cout &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00683"></a>00683               &lt;&lt; <span class="stringliteral">&quot;my_elem_offset=&quot;</span> &lt;&lt; my_elem_offset &lt;&lt; std::endl;
<a name="l00684"></a>00684 
<a name="l00685"></a>00685 
<a name="l00686"></a>00686   <span class="comment">// Fills in the: </span>
<a name="l00687"></a>00687   <span class="comment">// global_elem_blk_ids[] and</span>
<a name="l00688"></a>00688   <span class="comment">// global_elem_blk_cnts[] arrays.</span>
<a name="l00689"></a>00689   <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#a2a56bca7a746f582fbe7cfaf5fba2f7b">get_eb_info_global</a>();
<a name="l00690"></a>00690 
<a name="l00691"></a>00691 <span class="comment">//   // Fills in the vectors</span>
<a name="l00692"></a>00692 <span class="comment">//   // elem_mapi[num_internal_elems]</span>
<a name="l00693"></a>00693 <span class="comment">//   // elem_mapb[num_border_elems  ]</span>
<a name="l00694"></a>00694 <span class="comment">//   // These tell which of the (locally-numbered) elements are internal and which are border elements.</span>
<a name="l00695"></a>00695 <span class="comment">//   // In our test example these arrays are sorted (but non-contiguous), which makes it possible to</span>
<a name="l00696"></a>00696 <span class="comment">//   // binary search for each element ID... however I don&#39;t think we need to distinguish between the</span>
<a name="l00697"></a>00697 <span class="comment">//   // two types, since either can have nodes the boundary!</span>
<a name="l00698"></a>00698 <span class="comment">//   nemhelper.get_elem_map();</span>
<a name="l00699"></a>00699       
<a name="l00700"></a>00700   <span class="comment">// Fills in the vectors of vectors:</span>
<a name="l00701"></a>00701   <span class="comment">// elem_cmap_elem_ids[][]</span>
<a name="l00702"></a>00702   <span class="comment">// elem_cmap_side_ids[][]</span>
<a name="l00703"></a>00703   <span class="comment">// elem_cmap_proc_ids[][]</span>
<a name="l00704"></a>00704   <span class="comment">// These arrays are of size num_elem_cmaps * elem_cmap_elem_cnts[i], i = 0..num_elem_cmaps</span>
<a name="l00705"></a>00705   <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classNemesis__IO__Helper.php#a047af7c395a87c22ef7bb627b15a8d43">get_elem_cmap</a>();
<a name="l00706"></a>00706       
<a name="l00707"></a>00707   <span class="comment">// Get information about the element blocks:</span>
<a name="l00708"></a>00708   <span class="comment">// (read in the array nemhelper.block_ids[])</span>
<a name="l00709"></a>00709   <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#aac7883fbd864085b82ef0305205037b5">read_block_info</a>();
<a name="l00710"></a>00710 
<a name="l00711"></a>00711   <span class="comment">// Reads the nemhelper.elem_num_map array, elem_num_map[i] is the global element number for</span>
<a name="l00712"></a>00712   <span class="comment">// local element number i.</span>
<a name="l00713"></a>00713   <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a65706a7896b35a9f4befee2bed02cc8f">read_elem_num_map</a>();
<a name="l00714"></a>00714       
<a name="l00715"></a>00715   <span class="comment">// Instantiate the ElementMaps interface.  This is what translates LibMesh&#39;s</span>
<a name="l00716"></a>00716   <span class="comment">// element numbering scheme to Exodus&#39;s.</span>
<a name="l00717"></a>00717   <a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php">ExodusII_IO_Helper::ElementMaps</a> em;
<a name="l00718"></a>00718       
<a name="l00719"></a>00719   <span class="comment">// Read in the element connectivity for each block by</span>
<a name="l00720"></a>00720   <span class="comment">// looping over all the blocks.</span>
<a name="l00721"></a>00721   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;to_uint(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#af8020c0bd24728e12beea02d7f6fb44c">num_elem_blk</a>); i++)
<a name="l00722"></a>00722     {
<a name="l00723"></a>00723       <span class="comment">// Read the information for block i:  For nemhelper.block_ids[i], reads</span>
<a name="l00724"></a>00724       <span class="comment">// elem_type</span>
<a name="l00725"></a>00725       <span class="comment">// num_elem_this_blk</span>
<a name="l00726"></a>00726       <span class="comment">// num_nodes_per_elem</span>
<a name="l00727"></a>00727       <span class="comment">// num_attr</span>
<a name="l00728"></a>00728       <span class="comment">// connect &lt;-- the nodal connectivity array for each element in the block.</span>
<a name="l00729"></a>00729       <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#af2bf9e3fea0115a5e5da62074fca5968">read_elem_in_block</a>(i);
<a name="l00730"></a>00730 
<a name="l00731"></a>00731       <span class="comment">// Note that with parallel files it is possible we have no elements in</span>
<a name="l00732"></a>00732       <span class="comment">// this block!</span>
<a name="l00733"></a>00733       <span class="keywordflow">if</span> (!<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a856f2a0dc5850f1957a2072ef1ce2e5f">num_elem_this_blk</a>) <span class="keywordflow">continue</span>;
<a name="l00734"></a>00734       
<a name="l00735"></a>00735       <span class="comment">// Set subdomain ID based on the block ID.</span>
<a name="l00736"></a>00736       <span class="keywordtype">int</span> subdomain_id = <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#afc7339f25064d90005a6b7a6aff429b0">block_ids</a>[i];
<a name="l00737"></a>00737 
<a name="l00738"></a>00738       <span class="comment">// Create a type string (this uses the null-terminated string ctor).</span>
<a name="l00739"></a>00739       <span class="keyword">const</span> std::string type_str ( &amp;(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a63b094665cd526058573859ea7ec7a9f">elem_type</a>[0]) ); 
<a name="l00740"></a>00740 
<a name="l00741"></a>00741       <span class="comment">// Set any relevant node/edge maps for this element</span>
<a name="l00742"></a>00742       <span class="keyword">const</span> <a class="code" href="classExodusII__IO__Helper_1_1Conversion.php">ExodusII_IO_Helper::Conversion</a> conv = em.<a class="code" href="classExodusII__IO__Helper_1_1ElementMaps.php#a572ac41c49e11af4a560e4a731186590">assign_conversion</a>(type_str); 
<a name="l00743"></a>00743 
<a name="l00744"></a>00744       <span class="keywordflow">if</span> (<a class="code" href="classNemesis__IO.php#a69c1bbcbb75afaec414ddb5ccc19c93d">_verbose</a>)
<a name="l00745"></a>00745         std::cout &lt;&lt; <span class="stringliteral">&quot;Reading a block of &quot;</span> &lt;&lt; type_str &lt;&lt; <span class="stringliteral">&quot; elements.&quot;</span> &lt;&lt; std::endl;
<a name="l00746"></a>00746       
<a name="l00747"></a>00747       <span class="comment">// Loop over all the elements in this block</span>
<a name="l00748"></a>00748       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;to_uint(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a856f2a0dc5850f1957a2072ef1ce2e5f">num_elem_this_blk</a>); j++)
<a name="l00749"></a>00749         {
<a name="l00750"></a>00750           <a class="code" href="classElem.php">Elem</a>* elem = <a class="code" href="classElem.php#a7f46524fbd44a76f940435d6a1434a9d">Elem::build</a> (conv.<a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#a98dc09a31fab74133984df6e76da926a">get_canonical_type</a>()).release();
<a name="l00751"></a>00751           libmesh_assert (elem);
<a name="l00752"></a>00752 
<a name="l00753"></a>00753           <span class="comment">// Assign subdomain and processor ID to the newly-created Elem.</span>
<a name="l00754"></a>00754           <span class="comment">// Assigning the processor ID beforehand ensures that the Elem is</span>
<a name="l00755"></a>00755           <span class="comment">// not added as an &quot;unpartitioned&quot; element.  Note that the element</span>
<a name="l00756"></a>00756           <span class="comment">// numbering in Exodus is also 1-based.</span>
<a name="l00757"></a>00757           elem-&gt;<a class="code" href="classElem.php#acc4746605aad9169ad38cfd0b9b97123">subdomain_id</a>() = subdomain_id;
<a name="l00758"></a>00758           elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() = <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>();
<a name="l00759"></a>00759           elem-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a>()       = my_next_elem++;
<a name="l00760"></a>00760                 
<a name="l00761"></a>00761           <span class="comment">// Add the created Elem to the Mesh, catch the Elem</span>
<a name="l00762"></a>00762           <span class="comment">// pointer that the Mesh throws back.</span>
<a name="l00763"></a>00763           elem = mesh.<a class="code" href="classParallelMesh.php#a070d9e8636ce1e4fc4fe6ab0265462b0">add_elem</a> (elem); 
<a name="l00764"></a>00764 
<a name="l00765"></a>00765           <span class="comment">// Set all the nodes for this element</span>
<a name="l00766"></a>00766           <span class="keywordflow">if</span> (<a class="code" href="classNemesis__IO.php#a69c1bbcbb75afaec414ddb5ccc19c93d">_verbose</a>)     
<a name="l00767"></a>00767             std::cout &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00768"></a>00768                       &lt;&lt; <span class="stringliteral">&quot;Setting nodes for Elem &quot;</span> &lt;&lt; elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() &lt;&lt; std::endl;
<a name="l00769"></a>00769               
<a name="l00770"></a>00770           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;to_uint(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a944f1231f4dfbdafc94ac3371ae0cf0b">num_nodes_per_elem</a>); k++)
<a name="l00771"></a>00771             {
<a name="l00772"></a>00772               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00773"></a>00773                 gi              = (j*<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a944f1231f4dfbdafc94ac3371ae0cf0b">num_nodes_per_elem</a> +       <span class="comment">// index into connectivity array</span>
<a name="l00774"></a>00774                                    conv.<a class="code" href="classExodusII__IO__Helper_1_1Conversion.php#ad5ed62938325bdd443bfb24297f605a3">get_node_map</a>(k)), 
<a name="l00775"></a>00775                 local_node_idx  = <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#aa1399def5bca722af0eed2adcbc4cd73">connect</a>[gi]-1,                <span class="comment">// local node index </span>
<a name="l00776"></a>00776                 global_node_idx = <a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a24538ef46d1309b8dc1fca2a9e937ad0">node_num_map</a>[local_node_idx]; <span class="comment">// new global node index</span>
<a name="l00777"></a>00777                   
<a name="l00778"></a>00778               <span class="comment">// Set node number</span>
<a name="l00779"></a>00779               elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(k) = mesh.<a class="code" href="classParallelMesh.php#a39d1343ddfc925e1012d021d9a11e42f">node_ptr</a>(global_node_idx);
<a name="l00780"></a>00780             }
<a name="l00781"></a>00781         } <span class="comment">// for (unsigned int j=0; j&lt;nemhelper.num_elem_this_blk; j++)     </span>
<a name="l00782"></a>00782     } <span class="comment">// end for (unsigned int i=0; i&lt;nemhelper.num_elem_blk; i++)</span>
<a name="l00783"></a>00783 
<a name="l00784"></a>00784   libmesh_assert ((my_next_elem - my_elem_offset) == to_uint(<a class="code" href="classNemesis__IO.php#a5be9e239c529decdf0066e03d1194be8">nemhelper</a>.<a class="code" href="classExodusII__IO__Helper.php#a5f3697a4d820cb9b2b4f18dd3a035f12">num_elem</a>));
<a name="l00785"></a>00785 
<a name="l00786"></a>00786   <span class="comment">// See what the elem count is up to now.</span>
<a name="l00787"></a>00787   <span class="keywordflow">if</span> (<a class="code" href="classNemesis__IO.php#a69c1bbcbb75afaec414ddb5ccc19c93d">_verbose</a>)
<a name="l00788"></a>00788     {
<a name="l00789"></a>00789       <span class="comment">// Report the number of elements which have been added locally</span>
<a name="l00790"></a>00790       std::cout &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l00791"></a>00791       std::cout &lt;&lt; <span class="stringliteral">&quot;mesh.n_elem()=&quot;</span> &lt;&lt; mesh.<a class="code" href="classParallelMesh.php#aaefea67041752d4e801f25d2a41c3552">n_elem</a>() &lt;&lt; std::endl;
<a name="l00792"></a>00792 
<a name="l00793"></a>00793       <span class="comment">// Reports the number of elements that have been added in total.</span>
<a name="l00794"></a>00794       std::cout &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l00795"></a>00795       std::cout &lt;&lt; <span class="stringliteral">&quot;mesh.parallel_n_elem()=&quot;</span> &lt;&lt; mesh.<a class="code" href="classParallelMesh.php#a0b05286761dd00f468e271e75a0ddd23">parallel_n_elem</a>() &lt;&lt; std::endl;
<a name="l00796"></a>00796     }
<a name="l00797"></a>00797 
<a name="l00798"></a>00798   STOP_LOG (<span class="stringliteral">&quot;read()&quot;</span>,<span class="stringliteral">&quot;Nemesis_IO&quot;</span>);
<a name="l00799"></a>00799 
<a name="l00800"></a>00800   <span class="comment">// For ParallelMesh, it seems that _is_serial is true by default.  A hack to</span>
<a name="l00801"></a>00801   <span class="comment">// make the Mesh think it&#39;s parallel might be to call:</span>
<a name="l00802"></a>00802   mesh.<a class="code" href="classParallelMesh.php#ab7cc8fa40837fa8c29a3bc1e9ad938c0">delete_remote_elements</a>();
<a name="l00803"></a>00803 }
<a name="l00804"></a>00804 
<a name="l00805"></a>00805 <span class="preprocessor">#else</span>
<a name="l00806"></a>00806 <span class="preprocessor"></span>
<a name="l00807"></a>00807 <span class="keywordtype">void</span> <a class="code" href="classNemesis__IO.php#ab79e507bd0f761e25f070442bcafa848">Nemesis_IO::read</a> (<span class="keyword">const</span> std::string&amp; )
<a name="l00808"></a>00808 {
<a name="l00809"></a>00809   std::cerr &lt;&lt;  <span class="stringliteral">&quot;ERROR, Nemesis API is not defined!&quot;</span> &lt;&lt; std::endl;
<a name="l00810"></a>00810   libmesh_error();
<a name="l00811"></a>00811 }
<a name="l00812"></a>00812 
<a name="l00813"></a>00813 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
