<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>nemesis_io_helper.h</h1>  </div>
</div>
<div class="contents">
<a href="nemesis__io__helper_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: nemesis_io_helper.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __nemesis_io_helper_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __nemesis_io_helper_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="preprocessor">#if defined(LIBMESH_HAVE_NEMESIS_API) &amp;&amp; defined(LIBMESH_HAVE_EXODUS_API)</span>
<a name="l00026"></a>00026 <span class="preprocessor"></span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="exodusII__io__helper_8h.php">exodusII_io_helper.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// The Nemesis API header file.  Should already be</span>
<a name="l00031"></a>00031 <span class="comment">// correctly extern C&#39;d but it doesn&#39;t hurt :)</span>
<a name="l00032"></a><a class="code" href="namespaceNemesis.php">00032</a> <span class="keyword">namespace </span>Nemesis {
<a name="l00033"></a>00033   <span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;ne_nemesisI.h&quot;</span>
<a name="l00035"></a>00035   }
<a name="l00036"></a>00036 }
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00048"></a><a class="code" href="classNemesis__IO__Helper.php">00048</a> <span class="keyword">class </span><a class="code" href="classNemesis__IO__Helper.php">Nemesis_IO_Helper</a> : <span class="keyword">public</span> <a class="code" href="classExodusII__IO__Helper.php">ExodusII_IO_Helper</a>
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050 <span class="keyword">public</span>:
<a name="l00054"></a>00054   <a class="code" href="classNemesis__IO__Helper.php#a8c6683cea3f7f4d72efd0dc8e85cc59a">Nemesis_IO_Helper</a>(<span class="keywordtype">bool</span> <a class="code" href="classExodusII__IO__Helper.php#a90ab6ea1557ee6785027f28eee726836">verbose</a>=<span class="keyword">false</span>);
<a name="l00055"></a>00055 
<a name="l00059"></a>00059   <a class="code" href="classNemesis__IO__Helper.php#a15787912e98d23cb9de2fd3bd962711d">~Nemesis_IO_Helper</a>();
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 <span class="comment">//   /**</span>
<a name="l00062"></a>00062 <span class="comment">//    * Set the flag indicationg if we should be verbose.</span>
<a name="l00063"></a>00063 <span class="comment">//    */</span>
<a name="l00064"></a>00064 <span class="comment">//   void verbose (bool set_verbosity);</span>
<a name="l00065"></a>00065   
<a name="l00066"></a>00066   <span class="comment">// Member functions.  These just allocate memory for you and call the Nemesis</span>
<a name="l00067"></a>00067   <span class="comment">// routines of the same name.  They also handle error checking for the Nemesis</span>
<a name="l00068"></a>00068   <span class="comment">// return value.  Be careful calling these at random, some depend on others</span>
<a name="l00069"></a>00069   <span class="comment">// being called first...</span>
<a name="l00070"></a>00070   <span class="keywordtype">void</span> <a class="code" href="classNemesis__IO__Helper.php#aefe8b0652990f2a3c4f9b13372a04594">get_init_global</a>();
<a name="l00071"></a>00071   <span class="keywordtype">void</span> <a class="code" href="classNemesis__IO__Helper.php#a295f4ce2bfc907660bde50782f6610d9">get_ss_param_global</a>();
<a name="l00072"></a>00072   <span class="keywordtype">void</span> <a class="code" href="classNemesis__IO__Helper.php#a67c55426511aabf7ca6a8036682ba078">get_ns_param_global</a>();
<a name="l00073"></a>00073   <span class="keywordtype">void</span> <a class="code" href="classNemesis__IO__Helper.php#a2a56bca7a746f582fbe7cfaf5fba2f7b">get_eb_info_global</a>();
<a name="l00074"></a>00074   <span class="keywordtype">void</span> <a class="code" href="classNemesis__IO__Helper.php#aee0f61aaf797ee13db3d92aa52727fcf">get_init_info</a>();
<a name="l00075"></a>00075   <span class="keywordtype">void</span> <a class="code" href="classNemesis__IO__Helper.php#ad51dccf48af546768e8d8c38b38d9199">get_loadbal_param</a>();
<a name="l00076"></a>00076   <span class="keywordtype">void</span> <a class="code" href="classNemesis__IO__Helper.php#a04db2620d1e367348363ec48af01a8eb">get_elem_map</a>();
<a name="l00077"></a>00077   <span class="keywordtype">void</span> <a class="code" href="classNemesis__IO__Helper.php#ae18b474d41f4e7393076f7a196f8b692">get_node_map</a>();
<a name="l00078"></a>00078   <span class="keywordtype">void</span> <a class="code" href="classNemesis__IO__Helper.php#a920b522c0e9c97168a61ad4a5e6fdd1a">get_cmap_params</a>();
<a name="l00079"></a>00079   <span class="keywordtype">void</span> <a class="code" href="classNemesis__IO__Helper.php#a2e8ebc4c5107a95e2741d2ea39235d7a">get_node_cmap</a>();
<a name="l00080"></a>00080   <span class="keywordtype">void</span> <a class="code" href="classNemesis__IO__Helper.php#a047af7c395a87c22ef7bb627b15a8d43">get_elem_cmap</a>();
<a name="l00081"></a>00081   
<a name="l00082"></a>00082   <span class="comment">// Member data</span>
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 <span class="comment">//   /**</span>
<a name="l00085"></a>00085 <span class="comment">//    * Instance of the Exodus IO Helper.  We call the Exodus API through</span>
<a name="l00086"></a>00086 <span class="comment">//    * this object.  Instead of creating forwarding functions for</span>
<a name="l00087"></a>00087 <span class="comment">//    * everything in the ExodusII_IO_Helper class, just call them</span>
<a name="l00088"></a>00088 <span class="comment">//    * directly through this object!</span>
<a name="l00089"></a>00089 <span class="comment">//    */</span>
<a name="l00090"></a>00090 <span class="comment">//   ExodusII_IO_Helper ex2helper;</span>
<a name="l00091"></a>00091 
<a name="l00096"></a><a class="code" href="classNemesis__IO__Helper.php#ad977587412b5a984ce98b40ac1bb64a4">00096</a>   <span class="keywordtype">int</span> <a class="code" href="classNemesis__IO__Helper.php#ad977587412b5a984ce98b40ac1bb64a4">nemesis_err_flag</a>;
<a name="l00097"></a>00097     
<a name="l00102"></a><a class="code" href="classNemesis__IO__Helper.php#a93408876262dd779fc874a85e7513627">00102</a>   <span class="keywordtype">int</span> <a class="code" href="classNemesis__IO__Helper.php#a93408876262dd779fc874a85e7513627">num_nodes_global</a>;
<a name="l00103"></a><a class="code" href="classNemesis__IO__Helper.php#aa8906be9fe6255354908463a19de130d">00103</a>   <span class="keywordtype">int</span> <a class="code" href="classNemesis__IO__Helper.php#aa8906be9fe6255354908463a19de130d">num_elems_global</a>;
<a name="l00104"></a><a class="code" href="classNemesis__IO__Helper.php#ac1f4ae2ce56bd2158053bce74335cdbf">00104</a>   <span class="keywordtype">int</span> <a class="code" href="classNemesis__IO__Helper.php#ac1f4ae2ce56bd2158053bce74335cdbf">num_elem_blks_global</a>;
<a name="l00105"></a><a class="code" href="classNemesis__IO__Helper.php#aa4213efe6dae2b6ccabdaa5e6546aa0e">00105</a>   <span class="keywordtype">int</span> <a class="code" href="classNemesis__IO__Helper.php#aa4213efe6dae2b6ccabdaa5e6546aa0e">num_node_sets_global</a>;
<a name="l00106"></a><a class="code" href="classNemesis__IO__Helper.php#a9cb07f3d6d5b3b63799de3d6f51031dc">00106</a>   <span class="keywordtype">int</span> <a class="code" href="classNemesis__IO__Helper.php#a9cb07f3d6d5b3b63799de3d6f51031dc">num_side_sets_global</a>;
<a name="l00107"></a>00107 
<a name="l00112"></a><a class="code" href="classNemesis__IO__Helper.php#a3b02ba3aeef46699d969d57390ae42f0">00112</a>   <span class="keywordtype">int</span> <a class="code" href="classNemesis__IO__Helper.php#a3b02ba3aeef46699d969d57390ae42f0">num_proc</a>;
<a name="l00113"></a>00113 
<a name="l00119"></a><a class="code" href="classNemesis__IO__Helper.php#aee736c208eff086780de06b80ff635ea">00119</a>   <span class="keywordtype">int</span> <a class="code" href="classNemesis__IO__Helper.php#aee736c208eff086780de06b80ff635ea">num_proc_in_file</a>;
<a name="l00120"></a>00120 
<a name="l00126"></a><a class="code" href="classNemesis__IO__Helper.php#af83fad94e30cb357becb2b62132714b7">00126</a>   <span class="keywordtype">char</span> <a class="code" href="classNemesis__IO__Helper.php#af83fad94e30cb357becb2b62132714b7">ftype</a>;
<a name="l00127"></a>00127   
<a name="l00135"></a><a class="code" href="classNemesis__IO__Helper.php#a35f88c2988d0ea6ba56266c687923164">00135</a>   std::vector&lt;int&gt; <a class="code" href="classNemesis__IO__Helper.php#a35f88c2988d0ea6ba56266c687923164">global_sideset_ids</a>;
<a name="l00136"></a><a class="code" href="classNemesis__IO__Helper.php#a5409901c8e6c020d365a5c1357678cdb">00136</a>   std::vector&lt;int&gt; <a class="code" href="classNemesis__IO__Helper.php#a5409901c8e6c020d365a5c1357678cdb">num_global_side_counts</a>;
<a name="l00137"></a><a class="code" href="classNemesis__IO__Helper.php#a878c2f4d558d4819d57a7035e2bad2ae">00137</a>   std::vector&lt;int&gt; <a class="code" href="classNemesis__IO__Helper.php#a878c2f4d558d4819d57a7035e2bad2ae">num_global_side_df_counts</a>;
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 
<a name="l00147"></a><a class="code" href="classNemesis__IO__Helper.php#a726c25e102cb1190c98113ec68b1d7ce">00147</a>   std::vector&lt;int&gt; <a class="code" href="classNemesis__IO__Helper.php#a726c25e102cb1190c98113ec68b1d7ce">global_nodeset_ids</a>;
<a name="l00148"></a><a class="code" href="classNemesis__IO__Helper.php#ac8426c8a10615e10cb7efd3a98d7db0c">00148</a>   std::vector&lt;int&gt; <a class="code" href="classNemesis__IO__Helper.php#ac8426c8a10615e10cb7efd3a98d7db0c">num_global_node_counts</a>;
<a name="l00149"></a><a class="code" href="classNemesis__IO__Helper.php#a64816b89997addc66905fe3c654f75d2">00149</a>   std::vector&lt;int&gt; <a class="code" href="classNemesis__IO__Helper.php#a64816b89997addc66905fe3c654f75d2">num_global_node_df_counts</a>;
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00157"></a><a class="code" href="classNemesis__IO__Helper.php#a54c86431e03960de9fbbef04d7787910">00157</a>   std::vector&lt;int&gt; <a class="code" href="classNemesis__IO__Helper.php#a54c86431e03960de9fbbef04d7787910">global_elem_blk_ids</a>;
<a name="l00158"></a><a class="code" href="classNemesis__IO__Helper.php#a7c5330a75c621e5e758c534d9091aed4">00158</a>   std::vector&lt;int&gt; <a class="code" href="classNemesis__IO__Helper.php#a7c5330a75c621e5e758c534d9091aed4">global_elem_blk_cnts</a>;
<a name="l00159"></a>00159   
<a name="l00160"></a>00160 
<a name="l00169"></a><a class="code" href="classNemesis__IO__Helper.php#ad1bb0c3c604b2bf5c6b86c8519947271">00169</a>   <span class="keywordtype">int</span> <a class="code" href="classNemesis__IO__Helper.php#ad1bb0c3c604b2bf5c6b86c8519947271">num_internal_nodes</a>;
<a name="l00170"></a>00170 
<a name="l00176"></a><a class="code" href="classNemesis__IO__Helper.php#aef9540fb4039cf360b30084bb3b2f043">00176</a>   <span class="keywordtype">int</span> <a class="code" href="classNemesis__IO__Helper.php#aef9540fb4039cf360b30084bb3b2f043">num_border_nodes</a>;
<a name="l00177"></a>00177   
<a name="l00183"></a><a class="code" href="classNemesis__IO__Helper.php#a72be75805bfcc7ea69945d388d03613a">00183</a>   <span class="keywordtype">int</span> <a class="code" href="classNemesis__IO__Helper.php#a72be75805bfcc7ea69945d388d03613a">num_external_nodes</a>;
<a name="l00184"></a>00184   
<a name="l00189"></a><a class="code" href="classNemesis__IO__Helper.php#a44993cb2a368e2801eeda5d9344c79f9">00189</a>   <span class="keywordtype">int</span> <a class="code" href="classNemesis__IO__Helper.php#a44993cb2a368e2801eeda5d9344c79f9">num_internal_elems</a>;
<a name="l00190"></a>00190 
<a name="l00196"></a><a class="code" href="classNemesis__IO__Helper.php#affe3458fe4a6b73f4cee8e58145ac65d">00196</a>   <span class="keywordtype">int</span> <a class="code" href="classNemesis__IO__Helper.php#affe3458fe4a6b73f4cee8e58145ac65d">num_border_elems</a>;
<a name="l00197"></a>00197   
<a name="l00203"></a><a class="code" href="classNemesis__IO__Helper.php#adb3de98f16985108f1e6238fd57b9293">00203</a>   <span class="keywordtype">int</span> <a class="code" href="classNemesis__IO__Helper.php#adb3de98f16985108f1e6238fd57b9293">num_node_cmaps</a>;
<a name="l00204"></a>00204   
<a name="l00210"></a><a class="code" href="classNemesis__IO__Helper.php#a1132aa96f2e47d370bcb9a383f602cb6">00210</a>   <span class="keywordtype">int</span> <a class="code" href="classNemesis__IO__Helper.php#a1132aa96f2e47d370bcb9a383f602cb6">num_elem_cmaps</a>;
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 
<a name="l00213"></a>00213   
<a name="l00219"></a><a class="code" href="classNemesis__IO__Helper.php#a060fb8aff7a667973b253673cd80745a">00219</a>   std::vector&lt;int&gt; <a class="code" href="classNemesis__IO__Helper.php#a060fb8aff7a667973b253673cd80745a">elem_mapi</a>;
<a name="l00220"></a>00220   
<a name="l00226"></a><a class="code" href="classNemesis__IO__Helper.php#a9827268fc0474fe758bcaa5b72f458fc">00226</a>   std::vector&lt;int&gt; <a class="code" href="classNemesis__IO__Helper.php#a9827268fc0474fe758bcaa5b72f458fc">elem_mapb</a>;
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 
<a name="l00229"></a>00229   
<a name="l00235"></a><a class="code" href="classNemesis__IO__Helper.php#aeb1fc829338103345105dadb6946fe5f">00235</a>   std::vector&lt;int&gt; <a class="code" href="classNemesis__IO__Helper.php#aeb1fc829338103345105dadb6946fe5f">node_mapi</a>;
<a name="l00236"></a>00236   
<a name="l00242"></a><a class="code" href="classNemesis__IO__Helper.php#a857a6b1208f9747144efac37f9ad1030">00242</a>   std::vector&lt;int&gt; <a class="code" href="classNemesis__IO__Helper.php#a857a6b1208f9747144efac37f9ad1030">node_mapb</a>;
<a name="l00243"></a>00243 
<a name="l00249"></a><a class="code" href="classNemesis__IO__Helper.php#ac4b279158fb94ed1939cec548ae6b2e7">00249</a>   std::vector&lt;int&gt; <a class="code" href="classNemesis__IO__Helper.php#ac4b279158fb94ed1939cec548ae6b2e7">node_mape</a>;
<a name="l00250"></a>00250   
<a name="l00251"></a>00251   
<a name="l00258"></a><a class="code" href="classNemesis__IO__Helper.php#ade7e2ae0aecfc073b48b5fe37fe35312">00258</a>   std::vector&lt;int&gt; <a class="code" href="classNemesis__IO__Helper.php#ade7e2ae0aecfc073b48b5fe37fe35312">node_cmap_ids</a>;
<a name="l00259"></a><a class="code" href="classNemesis__IO__Helper.php#aafaa51ee1443a4a7f040de27c2861f9f">00259</a>   std::vector&lt;int&gt; <a class="code" href="classNemesis__IO__Helper.php#aafaa51ee1443a4a7f040de27c2861f9f">node_cmap_node_cnts</a>;
<a name="l00260"></a><a class="code" href="classNemesis__IO__Helper.php#aa4e86c7d1db2c52feada7f08fab3dfdc">00260</a>   std::vector&lt;int&gt; <a class="code" href="classNemesis__IO__Helper.php#aa4e86c7d1db2c52feada7f08fab3dfdc">elem_cmap_ids</a>;
<a name="l00261"></a><a class="code" href="classNemesis__IO__Helper.php#ade81eb4d4719cde5aac3d62372471415">00261</a>   std::vector&lt;int&gt; <a class="code" href="classNemesis__IO__Helper.php#ade81eb4d4719cde5aac3d62372471415">elem_cmap_elem_cnts</a>;
<a name="l00262"></a>00262 
<a name="l00263"></a>00263 
<a name="l00272"></a><a class="code" href="classNemesis__IO__Helper.php#a465e329ca0b93bfbf01a69f24fa394de">00272</a>   std::vector&lt;std::vector&lt;int&gt; &gt; <a class="code" href="classNemesis__IO__Helper.php#a465e329ca0b93bfbf01a69f24fa394de">node_cmap_node_ids</a>;
<a name="l00273"></a><a class="code" href="classNemesis__IO__Helper.php#ac6fff644d62c498246bcc020bc66e814">00273</a>   std::vector&lt;std::vector&lt;int&gt; &gt; <a class="code" href="classNemesis__IO__Helper.php#ac6fff644d62c498246bcc020bc66e814">node_cmap_proc_ids</a>;
<a name="l00274"></a>00274 
<a name="l00275"></a>00275 
<a name="l00281"></a><a class="code" href="classNemesis__IO__Helper.php#a1d7b5c1360ae3fbd5a747e1244f4d416">00281</a>   std::vector&lt;std::vector&lt;int&gt; &gt; <a class="code" href="classNemesis__IO__Helper.php#a1d7b5c1360ae3fbd5a747e1244f4d416">elem_cmap_elem_ids</a>;
<a name="l00282"></a><a class="code" href="classNemesis__IO__Helper.php#ad2dd5861a5e8c0e518997592215b6e4d">00282</a>   std::vector&lt;std::vector&lt;int&gt; &gt; <a class="code" href="classNemesis__IO__Helper.php#ad2dd5861a5e8c0e518997592215b6e4d">elem_cmap_side_ids</a>;
<a name="l00283"></a><a class="code" href="classNemesis__IO__Helper.php#a6c0d1a13d026fc0318913fced5f3d27c">00283</a>   std::vector&lt;std::vector&lt;int&gt; &gt; <a class="code" href="classNemesis__IO__Helper.php#a6c0d1a13d026fc0318913fced5f3d27c">elem_cmap_proc_ids</a>;
<a name="l00284"></a>00284 
<a name="l00285"></a>00285 
<a name="l00286"></a>00286 <span class="keyword">private</span>:
<a name="l00287"></a>00287   <span class="comment">//  bool _verbose;</span>
<a name="l00288"></a>00288   
<a name="l00289"></a>00289 };
<a name="l00290"></a>00290 
<a name="l00291"></a>00291 <span class="preprocessor">#endif // #if defined(LIBMESH_HAVE_NEMESIS_API) &amp;&amp; defined(LIBMESH_HAVE_EXODUS_API)</span>
<a name="l00292"></a>00292 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifndef __nemesis_io_helper_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
