<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_60be1125a39495b698d2d56e8e5b50b1.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>newmark_system.C</h1>  </div>
</div>
<div class="contents">
<a href="newmark__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: newmark_system.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;newmark_system.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;equation_systems.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;sparse_matrix.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00035"></a>00035 <span class="comment">// NewmarkSystem static members</span>
<a name="l00036"></a>00036 <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNewmarkSystem.php#af19ac9c645154163925058f56ca87234">NewmarkSystem::_default_alpha</a>    = .25;
<a name="l00037"></a>00037 <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNewmarkSystem.php#a4918b727b7510aaa8896fa760a3b1892">NewmarkSystem::_default_delta</a>    = .5;
<a name="l00038"></a>00038 <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNewmarkSystem.php#a9aae6908e151a6b1921a65d4e2b83432">NewmarkSystem::_default_timestep</a> = 1.;
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00043"></a>00043 <span class="comment">// NewmarkSystem implementation</span>
<a name="l00044"></a><a class="code" href="classNewmarkSystem.php#a31fe96a0bc2e4331455106b23007013d">00044</a> <a class="code" href="classNewmarkSystem.php#a31fe96a0bc2e4331455106b23007013d">NewmarkSystem::NewmarkSystem</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00045"></a>00045                               <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00046"></a>00046                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :  
<a name="l00047"></a>00047   <a class="code" href="classLinearImplicitSystem.php">LinearImplicitSystem</a> (es, name, number),
<a name="l00048"></a>00048   _a_0                 (1./(_default_alpha*_default_timestep*_default_timestep)),
<a name="l00049"></a>00049   _a_1                 (_default_delta/(_default_alpha*_default_timestep)),
<a name="l00050"></a>00050   _a_2                 (1./(_default_alpha*_default_timestep)),
<a name="l00051"></a>00051   _a_3                 (1./(2.*_default_alpha)-1.),
<a name="l00052"></a>00052   _a_4                 (_default_delta/_default_alpha -1.),
<a name="l00053"></a>00053   _a_5                 (_default_timestep/2.*(_default_delta/_default_alpha-2.)),
<a name="l00054"></a>00054   _a_6                 (_default_timestep*(1.-_default_delta)),
<a name="l00055"></a>00055   _a_7                 (_default_delta*_default_timestep),
<a name="l00056"></a>00056   _finished_assemble   (false)
<a name="l00057"></a>00057   
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059   <span class="comment">// default values of the newmark parameters</span>
<a name="l00060"></a>00060   es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;Newmark alpha&quot;</span>) = <a class="code" href="classNewmarkSystem.php#af19ac9c645154163925058f56ca87234">_default_alpha</a>;
<a name="l00061"></a>00061   es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;Newmark delta&quot;</span>) = <a class="code" href="classNewmarkSystem.php#a4918b727b7510aaa8896fa760a3b1892">_default_delta</a>;
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   <span class="comment">// time step size.</span>
<a name="l00064"></a>00064   <span class="comment">// should be handled at a later stage through EquationSystems?</span>
<a name="l00065"></a>00065   es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;Newmark time step&quot;</span>) = <a class="code" href="classNewmarkSystem.php#a9aae6908e151a6b1921a65d4e2b83432">_default_timestep</a>;
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   <span class="comment">// add additional matrices and vectors that will be used in the</span>
<a name="l00068"></a>00068   <span class="comment">// newmark algorithm to the data structure</span>
<a name="l00069"></a>00069   <span class="comment">// functions LinearImplicitSystem::add_matrix and LinearImplicitSystem::add_vector</span>
<a name="l00070"></a>00070   <span class="comment">// are used so we do not have to bother about initialization and</span>
<a name="l00071"></a>00071   <span class="comment">// dof mapping</span>
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   <span class="comment">// system matrices</span>
<a name="l00074"></a>00074   this-&gt;<a class="code" href="classImplicitSystem.php#acad3dc8b26c91f6c82c3e9708a1dc2e1">add_matrix</a> (<span class="stringliteral">&quot;stiffness&quot;</span>);
<a name="l00075"></a>00075   this-&gt;<a class="code" href="classImplicitSystem.php#acad3dc8b26c91f6c82c3e9708a1dc2e1">add_matrix</a> (<span class="stringliteral">&quot;damping&quot;</span>);
<a name="l00076"></a>00076   this-&gt;<a class="code" href="classImplicitSystem.php#acad3dc8b26c91f6c82c3e9708a1dc2e1">add_matrix</a> (<span class="stringliteral">&quot;mass&quot;</span>);
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   <span class="comment">// load vector  </span>
<a name="l00079"></a>00079   this-&gt;<a class="code" href="classSystem.php#abab8a3810cc43d99fe395d449207b786">add_vector</a> (<span class="stringliteral">&quot;force&quot;</span>);
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <span class="comment">// the displacement and the time derivatives  </span>
<a name="l00082"></a>00082   this-&gt;<a class="code" href="classSystem.php#abab8a3810cc43d99fe395d449207b786">add_vector</a> (<span class="stringliteral">&quot;displacement&quot;</span>);
<a name="l00083"></a>00083   this-&gt;<a class="code" href="classSystem.php#abab8a3810cc43d99fe395d449207b786">add_vector</a> (<span class="stringliteral">&quot;velocity&quot;</span>);
<a name="l00084"></a>00084   this-&gt;<a class="code" href="classSystem.php#abab8a3810cc43d99fe395d449207b786">add_vector</a> (<span class="stringliteral">&quot;acceleration&quot;</span>);
<a name="l00085"></a>00085 
<a name="l00086"></a>00086   <span class="comment">// contributions to the rhs</span>
<a name="l00087"></a>00087   this-&gt;<a class="code" href="classSystem.php#abab8a3810cc43d99fe395d449207b786">add_vector</a> (<span class="stringliteral">&quot;rhs_m&quot;</span>);
<a name="l00088"></a>00088   this-&gt;<a class="code" href="classSystem.php#abab8a3810cc43d99fe395d449207b786">add_vector</a> (<span class="stringliteral">&quot;rhs_c&quot;</span>);
<a name="l00089"></a>00089   
<a name="l00090"></a>00090   <span class="comment">// results from the previous time step</span>
<a name="l00091"></a>00091   this-&gt;<a class="code" href="classSystem.php#abab8a3810cc43d99fe395d449207b786">add_vector</a> (<span class="stringliteral">&quot;old_solution&quot;</span>);
<a name="l00092"></a>00092   this-&gt;<a class="code" href="classSystem.php#abab8a3810cc43d99fe395d449207b786">add_vector</a> (<span class="stringliteral">&quot;old_acceleration&quot;</span>);
<a name="l00093"></a>00093 }
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a><a class="code" href="classNewmarkSystem.php#a4574173ccf18f8b04046dc0bb8b458f5">00097</a> <a class="code" href="classNewmarkSystem.php#a4574173ccf18f8b04046dc0bb8b458f5">NewmarkSystem::~NewmarkSystem</a> ()
<a name="l00098"></a>00098 {
<a name="l00099"></a>00099   this-&gt;<a class="code" href="classNewmarkSystem.php#a37f7e01df8cb8f362347464de1f3e4f1">clear</a>();
<a name="l00100"></a>00100 }
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a><a class="code" href="classNewmarkSystem.php#a37f7e01df8cb8f362347464de1f3e4f1">00104</a> <span class="keywordtype">void</span> <a class="code" href="classNewmarkSystem.php#a37f7e01df8cb8f362347464de1f3e4f1">NewmarkSystem::clear</a> ()
<a name="l00105"></a>00105 {
<a name="l00106"></a>00106   <span class="comment">// use parent clear this will also clear the</span>
<a name="l00107"></a>00107   <span class="comment">// matrices and vectors added in the constructor</span>
<a name="l00108"></a>00108   <a class="code" href="classNewmarkSystem.php#a37f7e01df8cb8f362347464de1f3e4f1">LinearImplicitSystem::clear</a>();
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   <span class="comment">// Get a reference to the EquationSystems</span>
<a name="l00111"></a>00111   <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es =
<a name="l00112"></a>00112     this-&gt;<a class="code" href="classSystem.php#a51da3ea6211cf1888377c9c4b1554232">get_equation_systems</a>();
<a name="l00113"></a>00113   
<a name="l00114"></a>00114   <span class="comment">// default values of the newmark parameters</span>
<a name="l00115"></a>00115   es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;Newmark alpha&quot;</span>) = <a class="code" href="classNewmarkSystem.php#af19ac9c645154163925058f56ca87234">_default_alpha</a>;
<a name="l00116"></a>00116   es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;Newmark delta&quot;</span>) = <a class="code" href="classNewmarkSystem.php#a4918b727b7510aaa8896fa760a3b1892">_default_delta</a>;
<a name="l00117"></a>00117 
<a name="l00118"></a>00118   <span class="comment">// time step size.  should be handled at a later stage through EquationSystems?</span>
<a name="l00119"></a>00119   es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;Newmark time step&quot;</span>) = <a class="code" href="classNewmarkSystem.php#a9aae6908e151a6b1921a65d4e2b83432">_default_timestep</a>;
<a name="l00120"></a>00120 
<a name="l00121"></a>00121   <span class="comment">// set bool to false</span>
<a name="l00122"></a>00122   <a class="code" href="classNewmarkSystem.php#aa1edbde5d81df27b72547a02b97ec913">_finished_assemble</a> = <span class="keyword">false</span>;
<a name="l00123"></a>00123 }
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a><a class="code" href="classNewmarkSystem.php#a256ccb6844eba4723a2d435d7ff8c148">00127</a> <span class="keywordtype">void</span> <a class="code" href="classNewmarkSystem.php#a256ccb6844eba4723a2d435d7ff8c148">NewmarkSystem::reinit</a> ()
<a name="l00128"></a>00128 {
<a name="l00129"></a>00129   libmesh_error();
<a name="l00130"></a>00130   
<a name="l00131"></a>00131   <span class="comment">// initialize parent data</span>
<a name="l00132"></a>00132   <a class="code" href="classNewmarkSystem.php#a256ccb6844eba4723a2d435d7ff8c148">LinearImplicitSystem::reinit</a>();
<a name="l00133"></a>00133 }
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a><a class="code" href="classNewmarkSystem.php#a01640ac7b66202b394830f281571bb47">00137</a> <span class="keywordtype">void</span> <a class="code" href="classNewmarkSystem.php#a01640ac7b66202b394830f281571bb47">NewmarkSystem::assemble</a> ()
<a name="l00138"></a>00138 {
<a name="l00139"></a>00139   <span class="keywordflow">if</span> (!<a class="code" href="classNewmarkSystem.php#aa1edbde5d81df27b72547a02b97ec913">_finished_assemble</a>)
<a name="l00140"></a>00140     {
<a name="l00141"></a>00141       <span class="comment">// prepare matrix with the help of the _dof_map, </span>
<a name="l00142"></a>00142       <span class="comment">// fill with sparsity pattern</span>
<a name="l00143"></a>00143       <a class="code" href="classNewmarkSystem.php#a01640ac7b66202b394830f281571bb47">LinearImplicitSystem::assemble</a>();
<a name="l00144"></a>00144 
<a name="l00145"></a>00145       <span class="comment">// compute the effective system matrix</span>
<a name="l00146"></a>00146       this-&gt;<a class="code" href="classNewmarkSystem.php#aaec8bd006e8a4755a7c391d547697914">compute_matrix</a>();
<a name="l00147"></a>00147 
<a name="l00148"></a>00148       <span class="comment">// apply initial conditions</span>
<a name="l00149"></a>00149       this-&gt;<a class="code" href="classNewmarkSystem.php#aea751d081e62fa068f965e59c9e21995">initial_conditions</a>();
<a name="l00150"></a>00150       
<a name="l00151"></a>00151       <a class="code" href="classNewmarkSystem.php#aa1edbde5d81df27b72547a02b97ec913">_finished_assemble</a> = <span class="keyword">true</span>;
<a name="l00152"></a>00152     }
<a name="l00153"></a>00153 }
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 
<a name="l00156"></a><a class="code" href="classNewmarkSystem.php#aea751d081e62fa068f965e59c9e21995">00156</a> <span class="keywordtype">void</span> <a class="code" href="classNewmarkSystem.php#aea751d081e62fa068f965e59c9e21995">NewmarkSystem::initial_conditions</a> ()
<a name="l00157"></a>00157 {
<a name="l00158"></a>00158   <span class="comment">// libmesh_assert (init_cond_fptr != NULL);</span>
<a name="l00159"></a>00159 
<a name="l00160"></a>00160   <span class="comment">// Log how long the user&#39;s matrix assembly code takes</span>
<a name="l00161"></a>00161   START_LOG(<span class="stringliteral">&quot;initial_conditions ()&quot;</span>, <span class="stringliteral">&quot;NewmarkSystem&quot;</span>);
<a name="l00162"></a>00162   
<a name="l00163"></a>00163   <span class="comment">// Set all values to 0, then</span>
<a name="l00164"></a>00164   <span class="comment">// call the user-specified function for initial conditions.</span>
<a name="l00165"></a>00165   this-&gt;<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;displacement&quot;</span>).<a class="code" href="classNumericVector.php#a21ca80e20b0f88490c8f0d5298d47bef">zero</a>();
<a name="l00166"></a>00166   this-&gt;<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;velocity&quot;</span>).<a class="code" href="classNumericVector.php#a21ca80e20b0f88490c8f0d5298d47bef">zero</a>();
<a name="l00167"></a>00167   this-&gt;<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;acceleration&quot;</span>).<a class="code" href="classNumericVector.php#a21ca80e20b0f88490c8f0d5298d47bef">zero</a>();
<a name="l00168"></a>00168   this-&gt;<a class="code" href="classSystem.php#a3f5139f478cc769a89df8d09bb7aa69a">user_initialization</a>();
<a name="l00169"></a>00169 
<a name="l00170"></a>00170   <span class="comment">// Stop logging the user code</span>
<a name="l00171"></a>00171   STOP_LOG(<span class="stringliteral">&quot;initial_conditions ()&quot;</span>, <span class="stringliteral">&quot;NewmarkSystem&quot;</span>);
<a name="l00172"></a>00172 }
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 
<a name="l00176"></a><a class="code" href="classNewmarkSystem.php#aaec8bd006e8a4755a7c391d547697914">00176</a> <span class="keywordtype">void</span> <a class="code" href="classNewmarkSystem.php#aaec8bd006e8a4755a7c391d547697914">NewmarkSystem::compute_matrix</a> ()
<a name="l00177"></a>00177 {
<a name="l00178"></a>00178   <span class="comment">// close the component matrices</span>
<a name="l00179"></a>00179   this-&gt;<a class="code" href="classImplicitSystem.php#a719365410b024d2ddab0b1bada55753d">get_matrix</a> (<span class="stringliteral">&quot;stiffness&quot;</span>).<a class="code" href="classSparseMatrix.php#a55129db49268936e33686bc1beaaa1e9">close</a>();
<a name="l00180"></a>00180   this-&gt;<a class="code" href="classImplicitSystem.php#a719365410b024d2ddab0b1bada55753d">get_matrix</a> (<span class="stringliteral">&quot;mass&quot;</span>     ).<a class="code" href="classSparseMatrix.php#a55129db49268936e33686bc1beaaa1e9">close</a>();
<a name="l00181"></a>00181   this-&gt;<a class="code" href="classImplicitSystem.php#a719365410b024d2ddab0b1bada55753d">get_matrix</a> (<span class="stringliteral">&quot;damping&quot;</span>  ).<a class="code" href="classSparseMatrix.php#a55129db49268936e33686bc1beaaa1e9">close</a>();
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   <span class="comment">// close &amp; zero the system matrix</span>
<a name="l00184"></a>00184   this-&gt;<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>-&gt;<a class="code" href="classSparseMatrix.php#a55129db49268936e33686bc1beaaa1e9">close</a> (); this-&gt;<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>-&gt;<a class="code" href="classSparseMatrix.php#ac9c04c5748478399f1eff3f337a7e647">zero</a>();
<a name="l00185"></a>00185 
<a name="l00186"></a>00186   <span class="comment">// add up the matrices</span>
<a name="l00187"></a>00187   this-&gt;<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>-&gt;<a class="code" href="classSparseMatrix.php#a23714d101ef245d4c31b8eebeffc99dd">add</a> (1.,   this-&gt;<a class="code" href="classImplicitSystem.php#a719365410b024d2ddab0b1bada55753d">get_matrix</a> (<span class="stringliteral">&quot;stiffness&quot;</span>));
<a name="l00188"></a>00188   this-&gt;<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>-&gt;<a class="code" href="classSparseMatrix.php#a23714d101ef245d4c31b8eebeffc99dd">add</a> (<a class="code" href="classNewmarkSystem.php#a622f1d7f86455f74f5289e226c24ea6d">_a_0</a>, this-&gt;<a class="code" href="classImplicitSystem.php#a719365410b024d2ddab0b1bada55753d">get_matrix</a> (<span class="stringliteral">&quot;mass&quot;</span>));
<a name="l00189"></a>00189   this-&gt;<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>-&gt;<a class="code" href="classSparseMatrix.php#a23714d101ef245d4c31b8eebeffc99dd">add</a> (<a class="code" href="classNewmarkSystem.php#a1d303e697942bf9b4b705891240cbb8e">_a_1</a>, this-&gt;<a class="code" href="classImplicitSystem.php#a719365410b024d2ddab0b1bada55753d">get_matrix</a> (<span class="stringliteral">&quot;damping&quot;</span>));
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 }
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 
<a name="l00195"></a><a class="code" href="classNewmarkSystem.php#a007944de471f1bd86a339d89dcf71751">00195</a> <span class="keywordtype">void</span> <a class="code" href="classNewmarkSystem.php#a007944de471f1bd86a339d89dcf71751">NewmarkSystem::update_rhs</a> ()
<a name="l00196"></a>00196 {
<a name="l00197"></a>00197   START_LOG(<span class="stringliteral">&quot;update_rhs ()&quot;</span>, <span class="stringliteral">&quot;NewmarkSystem&quot;</span>);
<a name="l00198"></a>00198   
<a name="l00199"></a>00199   <span class="comment">// zero the rhs-vector</span>
<a name="l00200"></a>00200   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp; <a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a> = *this-&gt;<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>;
<a name="l00201"></a>00201   rhs.<a class="code" href="classNumericVector.php#a21ca80e20b0f88490c8f0d5298d47bef">zero</a>();
<a name="l00202"></a>00202 
<a name="l00203"></a>00203   <span class="comment">// get writable references to some vectors</span>
<a name="l00204"></a>00204   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp; rhs_m = this-&gt;<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;rhs_m&quot;</span>);
<a name="l00205"></a>00205   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp; rhs_c = this-&gt;<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;rhs_c&quot;</span>);
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 
<a name="l00208"></a>00208   <span class="comment">// zero the vectors for matrix-vector product</span>
<a name="l00209"></a>00209   rhs_m.<a class="code" href="classNumericVector.php#a21ca80e20b0f88490c8f0d5298d47bef">zero</a>();
<a name="l00210"></a>00210   rhs_c.<a class="code" href="classNumericVector.php#a21ca80e20b0f88490c8f0d5298d47bef">zero</a>();
<a name="l00211"></a>00211 
<a name="l00212"></a>00212   <span class="comment">// compute auxiliary vectors rhs_m and rhs_c</span>
<a name="l00213"></a>00213   rhs_m.<a class="code" href="classNumericVector.php#a63f662febc0a45f3b821cce3bc438190">add</a>(<a class="code" href="classNewmarkSystem.php#a622f1d7f86455f74f5289e226c24ea6d">_a_0</a>, this-&gt;<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;displacement&quot;</span>));
<a name="l00214"></a>00214   rhs_m.<a class="code" href="classNumericVector.php#a63f662febc0a45f3b821cce3bc438190">add</a>(<a class="code" href="classNewmarkSystem.php#ae5ae20d28992f522dc0be9c36c514dc7">_a_2</a>, this-&gt;<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;velocity&quot;</span>));
<a name="l00215"></a>00215   rhs_m.<a class="code" href="classNumericVector.php#a63f662febc0a45f3b821cce3bc438190">add</a>(<a class="code" href="classNewmarkSystem.php#af7001c2a7e737de53713dd4f36fd56cb">_a_3</a>, this-&gt;<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;acceleration&quot;</span>));
<a name="l00216"></a>00216 
<a name="l00217"></a>00217   rhs_c.<a class="code" href="classNumericVector.php#a63f662febc0a45f3b821cce3bc438190">add</a>(<a class="code" href="classNewmarkSystem.php#a1d303e697942bf9b4b705891240cbb8e">_a_1</a>, this-&gt;<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;displacement&quot;</span>));
<a name="l00218"></a>00218   rhs_c.<a class="code" href="classNumericVector.php#a63f662febc0a45f3b821cce3bc438190">add</a>(<a class="code" href="classNewmarkSystem.php#a7c8c5164ca75e1405ea5001b610057a3">_a_4</a>, this-&gt;<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;velocity&quot;</span>));
<a name="l00219"></a>00219   rhs_c.<a class="code" href="classNumericVector.php#a63f662febc0a45f3b821cce3bc438190">add</a>(<a class="code" href="classNewmarkSystem.php#a92b44781ebcce86b0f966c1772e1ff7f">_a_5</a>, this-&gt;<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;acceleration&quot;</span>));
<a name="l00220"></a>00220 
<a name="l00221"></a>00221   <span class="comment">// compute rhs</span>
<a name="l00222"></a>00222   rhs.<a class="code" href="classNumericVector.php#a63f662febc0a45f3b821cce3bc438190">add</a>(this-&gt;<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;force&quot;</span>));
<a name="l00223"></a>00223   rhs.<a class="code" href="classNumericVector.php#ac41cf781a2cce694f5795cb36fb40a4b">add_vector</a>(rhs_m, this-&gt;<a class="code" href="classImplicitSystem.php#a719365410b024d2ddab0b1bada55753d">get_matrix</a>(<span class="stringliteral">&quot;mass&quot;</span>));
<a name="l00224"></a>00224   rhs.<a class="code" href="classNumericVector.php#ac41cf781a2cce694f5795cb36fb40a4b">add_vector</a>(rhs_c, this-&gt;<a class="code" href="classImplicitSystem.php#a719365410b024d2ddab0b1bada55753d">get_matrix</a>(<span class="stringliteral">&quot;damping&quot;</span>));
<a name="l00225"></a>00225   
<a name="l00226"></a>00226   STOP_LOG(<span class="stringliteral">&quot;update_rhs ()&quot;</span>, <span class="stringliteral">&quot;NewmarkSystem&quot;</span>);
<a name="l00227"></a>00227 }
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 
<a name="l00231"></a><a class="code" href="classNewmarkSystem.php#ae240cf67c5eeb4794cbeeeed4c2bda29">00231</a> <span class="keywordtype">void</span> <a class="code" href="classNewmarkSystem.php#ae240cf67c5eeb4794cbeeeed4c2bda29">NewmarkSystem::update_u_v_a</a> ()
<a name="l00232"></a>00232 {
<a name="l00233"></a>00233   START_LOG(<span class="stringliteral">&quot;update_u_v_a ()&quot;</span>, <span class="stringliteral">&quot;NewmarkSystem&quot;</span>);
<a name="l00234"></a>00234   
<a name="l00235"></a>00235   <span class="comment">// get some references for convenience</span>
<a name="l00236"></a>00236   <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp;  solu = *this-&gt;<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>;
<a name="l00237"></a>00237 
<a name="l00238"></a>00238   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp;  disp_vec   = this-&gt;<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;displacement&quot;</span>);
<a name="l00239"></a>00239   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp;  vel_vec    = this-&gt;<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;velocity&quot;</span>);
<a name="l00240"></a>00240   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp;  acc_vec    = this-&gt;<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;acceleration&quot;</span>);
<a name="l00241"></a>00241   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp;  old_acc    = this-&gt;<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;old_acceleration&quot;</span>);
<a name="l00242"></a>00242   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp;  old_solu   = this-&gt;<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;old_solution&quot;</span>);
<a name="l00243"></a>00243 
<a name="l00244"></a>00244   <span class="comment">// copy data</span>
<a name="l00245"></a>00245   old_solu = disp_vec;
<a name="l00246"></a>00246   disp_vec = solu;
<a name="l00247"></a>00247   old_acc  = acc_vec;
<a name="l00248"></a>00248 
<a name="l00249"></a>00249   <span class="comment">// compute the new acceleration vector</span>
<a name="l00250"></a>00250   acc_vec.<a class="code" href="classNumericVector.php#a902c95547d402fa3b9448a767fd8eeab">scale</a>(-<a class="code" href="classNewmarkSystem.php#af7001c2a7e737de53713dd4f36fd56cb">_a_3</a>);
<a name="l00251"></a>00251   acc_vec.<a class="code" href="classNumericVector.php#a63f662febc0a45f3b821cce3bc438190">add</a>(<a class="code" href="classNewmarkSystem.php#a622f1d7f86455f74f5289e226c24ea6d">_a_0</a>, disp_vec);
<a name="l00252"></a>00252   acc_vec.<a class="code" href="classNumericVector.php#a63f662febc0a45f3b821cce3bc438190">add</a>(-<a class="code" href="classNewmarkSystem.php#a622f1d7f86455f74f5289e226c24ea6d">_a_0</a>, old_solu);
<a name="l00253"></a>00253   acc_vec.<a class="code" href="classNumericVector.php#a63f662febc0a45f3b821cce3bc438190">add</a>(-<a class="code" href="classNewmarkSystem.php#ae5ae20d28992f522dc0be9c36c514dc7">_a_2</a>,vel_vec);
<a name="l00254"></a>00254 
<a name="l00255"></a>00255   <span class="comment">// compute the new velocity vector</span>
<a name="l00256"></a>00256   vel_vec.<a class="code" href="classNumericVector.php#a63f662febc0a45f3b821cce3bc438190">add</a>(<a class="code" href="classNewmarkSystem.php#ac03d948ce7cc672f66a0afcbc416ddc4">_a_6</a>,old_acc);
<a name="l00257"></a>00257   vel_vec.<a class="code" href="classNumericVector.php#a63f662febc0a45f3b821cce3bc438190">add</a>(<a class="code" href="classNewmarkSystem.php#ab535e8cc882ba4ef80b161072452b38a">_a_7</a>,acc_vec);
<a name="l00258"></a>00258   
<a name="l00259"></a>00259   STOP_LOG(<span class="stringliteral">&quot;update_u_v_a ()&quot;</span>, <span class="stringliteral">&quot;NewmarkSystem&quot;</span>);
<a name="l00260"></a>00260 }
<a name="l00261"></a>00261 
<a name="l00262"></a>00262 
<a name="l00263"></a>00263 
<a name="l00264"></a><a class="code" href="classNewmarkSystem.php#a14c65f25b3113af21e773db340253393">00264</a> <span class="keywordtype">void</span> <a class="code" href="classNewmarkSystem.php#a14c65f25b3113af21e773db340253393">NewmarkSystem::set_newmark_parameters</a> (<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> delta_T, 
<a name="l00265"></a>00265                                             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> alpha,
<a name="l00266"></a>00266                                             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> delta)
<a name="l00267"></a>00267 {
<a name="l00268"></a>00268   libmesh_assert(delta_T != 0.);
<a name="l00269"></a>00269 
<a name="l00270"></a>00270     <span class="comment">// Get a reference to the EquationSystems</span>
<a name="l00271"></a>00271   <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es =
<a name="l00272"></a>00272     this-&gt;<a class="code" href="classSystem.php#a51da3ea6211cf1888377c9c4b1554232">get_equation_systems</a>();
<a name="l00273"></a>00273 
<a name="l00274"></a>00274   <span class="comment">// the newmark parameters</span>
<a name="l00275"></a>00275   es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;Newmark alpha&quot;</span>) = alpha;
<a name="l00276"></a>00276   es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;Newmark delta&quot;</span>) = delta;
<a name="l00277"></a>00277 
<a name="l00278"></a>00278   <span class="comment">// time step size.</span>
<a name="l00279"></a>00279   <span class="comment">// should be handled at a later stage through EquationSystems?</span>
<a name="l00280"></a>00280   es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;Newmark time step&quot;</span>) = delta_T;
<a name="l00281"></a>00281 
<a name="l00282"></a>00282   <span class="comment">// the constants for time integration</span>
<a name="l00283"></a>00283   <a class="code" href="classNewmarkSystem.php#a622f1d7f86455f74f5289e226c24ea6d">_a_0</a> = 1./(alpha*delta_T*delta_T);
<a name="l00284"></a>00284   <a class="code" href="classNewmarkSystem.php#a1d303e697942bf9b4b705891240cbb8e">_a_1</a> = delta/(alpha*delta_T);
<a name="l00285"></a>00285   <a class="code" href="classNewmarkSystem.php#ae5ae20d28992f522dc0be9c36c514dc7">_a_2</a> = 1./(alpha*delta_T);
<a name="l00286"></a>00286   <a class="code" href="classNewmarkSystem.php#af7001c2a7e737de53713dd4f36fd56cb">_a_3</a> = 1./(2.*alpha)-1.;
<a name="l00287"></a>00287   <a class="code" href="classNewmarkSystem.php#a7c8c5164ca75e1405ea5001b610057a3">_a_4</a> = delta/alpha -1.;
<a name="l00288"></a>00288   <a class="code" href="classNewmarkSystem.php#a92b44781ebcce86b0f966c1772e1ff7f">_a_5</a> = delta_T/2.*(delta/alpha-2.);
<a name="l00289"></a>00289   <a class="code" href="classNewmarkSystem.php#ac03d948ce7cc672f66a0afcbc416ddc4">_a_6</a> = delta_T*(1.-delta);
<a name="l00290"></a>00290   <a class="code" href="classNewmarkSystem.php#ab535e8cc882ba4ef80b161072452b38a">_a_7</a> = delta*delta_T;
<a name="l00291"></a>00291 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
