<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_60be1125a39495b698d2d56e8e5b50b1.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>newton_solver.C</h1>  </div>
</div>
<div class="contents">
<a href="newton__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: newton_solver.C 3502 2009-10-20 18:06:50Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;cmath&quot;</span> <span class="comment">// For isnan(), when it&#39;s defined</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;diff_system.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;equation_systems.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;linear_solver.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;newton_solver.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;sparse_matrix.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;dof_map.h&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// SIGN from Numerical Recipes</span>
<a name="l00033"></a>00033 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00034"></a>00034 <span class="keyword">inline</span>
<a name="l00035"></a><a class="code" href="newton__solver_8C.php#a38aacf4cc8e02b8cb52c5174bd627086">00035</a> T <a class="code" href="newton__solver_8C.php#a38aacf4cc8e02b8cb52c5174bd627086">SIGN</a>(T a, T b)
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037   <span class="keywordflow">return</span> b &gt;= 0 ? std::abs(a) : -std::abs(a);
<a name="l00038"></a>00038 }
<a name="l00039"></a>00039 
<a name="l00040"></a><a class="code" href="classNewtonSolver.php#aa3e0ef80228414bf0d04dbb6e0382798">00040</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNewtonSolver.php#aa3e0ef80228414bf0d04dbb6e0382798">NewtonSolver::line_search</a>(<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tol,
<a name="l00041"></a>00041                                <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> last_residual,
<a name="l00042"></a>00042                                <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> &amp;current_residual,
<a name="l00043"></a>00043                                <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp;newton_iterate,
<a name="l00044"></a>00044                                <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp;linear_solution)
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046   <span class="comment">// Take a full step if we got a residual reduction or if we</span>
<a name="l00047"></a>00047   <span class="comment">// aren&#39;t substepping</span>
<a name="l00048"></a>00048   <span class="keywordflow">if</span> (current_residual &lt; last_residual ||
<a name="l00049"></a>00049       !<a class="code" href="classNewtonSolver.php#a435167ee009f7b1c80050ed527709341">require_residual_reduction</a>)
<a name="l00050"></a>00050     <span class="keywordflow">return</span> 1.;
<a name="l00051"></a>00051 
<a name="l00052"></a>00052   <span class="comment">// The residual vector</span>
<a name="l00053"></a>00053   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp;rhs = *(<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>);
<a name="l00054"></a>00054 
<a name="l00055"></a>00055   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> ax = 0.;  <span class="comment">// First abscissa, don&#39;t take negative steps</span>
<a name="l00056"></a>00056   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> cx = 1.;  <span class="comment">// Second abscissa, don&#39;t extrapolate steps</span>
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <span class="comment">// Find bx, a step length that gives lower residual than ax or cx</span>
<a name="l00059"></a>00059   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> bx = 1.;
<a name="l00060"></a>00060   <span class="keywordflow">while</span> (current_residual &gt; last_residual)
<a name="l00061"></a>00061     {
<a name="l00062"></a>00062       <span class="comment">// Reduce step size to 1/2, 1/4, etc.</span>
<a name="l00063"></a>00063       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> substepdivision;
<a name="l00064"></a>00064       <span class="keywordflow">if</span> (<a class="code" href="classNewtonSolver.php#a7950ce52c056de7ca5d653e422c9c366">brent_line_search</a>)
<a name="l00065"></a>00065         {
<a name="l00066"></a>00066           substepdivision = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(0.5, last_residual/current_residual);
<a name="l00067"></a>00067           substepdivision = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(substepdivision, tol*2.);
<a name="l00068"></a>00068         }
<a name="l00069"></a>00069       <span class="keywordflow">else</span>
<a name="l00070"></a>00070         substepdivision = 0.5;
<a name="l00071"></a>00071 
<a name="l00072"></a>00072       newton_iterate.<a class="code" href="classNumericVector.php#a63f662febc0a45f3b821cce3bc438190">add</a> (bx * (1.-substepdivision),
<a name="l00073"></a>00073                           linear_solution);
<a name="l00074"></a>00074       newton_iterate.<a class="code" href="classNumericVector.php#a4c7feb55cd686619d04e0441b41ceaa5">close</a>();
<a name="l00075"></a>00075       bx *= substepdivision;
<a name="l00076"></a>00076       <span class="keywordflow">if</span> (!<a class="code" href="classDiffSolver.php#ae6aee54a1508db27cbaa0a6045ef44e9">quiet</a>)
<a name="l00077"></a>00077         std::cout &lt;&lt; <span class="stringliteral">&quot;  Shrinking Newton step to &quot;</span>
<a name="l00078"></a>00078                   &lt;&lt; bx &lt;&lt; std::endl;
<a name="l00079"></a>00079 
<a name="l00080"></a>00080       <span class="comment">// Check residual with fractional Newton step</span>
<a name="l00081"></a>00081       <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classDifferentiableSystem.php#af2770154003897eef7c70a5318478393">assembly</a> (<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l00082"></a>00082 
<a name="l00083"></a>00083       rhs.<a class="code" href="classNumericVector.php#a4c7feb55cd686619d04e0441b41ceaa5">close</a>();
<a name="l00084"></a>00084       current_residual = rhs.<a class="code" href="classNumericVector.php#aae40073beefab5ff9d4418f97b2b4517">l2_norm</a>();
<a name="l00085"></a>00085       <span class="keywordflow">if</span> (!<a class="code" href="classDiffSolver.php#ae6aee54a1508db27cbaa0a6045ef44e9">quiet</a>)
<a name="l00086"></a>00086         std::cout &lt;&lt; <span class="stringliteral">&quot;  Current Residual: &quot;</span>
<a name="l00087"></a>00087                   &lt;&lt; current_residual &lt;&lt; std::endl;
<a name="l00088"></a>00088 
<a name="l00089"></a>00089       <span class="keywordflow">if</span> (bx/2. &lt; <a class="code" href="classNewtonSolver.php#acc5cac6e3570d6d39de8fb805c6862bb">minsteplength</a> &amp;&amp; 
<a name="l00090"></a>00090           current_residual &gt; last_residual)
<a name="l00091"></a>00091         {
<a name="l00092"></a>00092           std::cout &lt;&lt; <span class="stringliteral">&quot;Inexact Newton step FAILED at step &quot;</span>
<a name="l00093"></a>00093                     &lt;&lt; <a class="code" href="classDiffSolver.php#a79d256bff5a88d89aec8941041dc89a9">_outer_iterations</a> &lt;&lt; std::endl;
<a name="l00094"></a>00094 
<a name="l00095"></a>00095           <span class="keywordflow">if</span> (!<a class="code" href="classDiffSolver.php#a37c6a1d3285402138026b4ad79d4e5a8">continue_after_backtrack_failure</a>)
<a name="l00096"></a>00096             {
<a name="l00097"></a>00097               libmesh_convergence_failure();
<a name="l00098"></a>00098             }
<a name="l00099"></a>00099           <span class="keywordflow">else</span>
<a name="l00100"></a>00100             {
<a name="l00101"></a>00101               std::cout &lt;&lt; <span class="stringliteral">&quot;Continuing anyway ...&quot;</span> &lt;&lt; std::endl;
<a name="l00102"></a>00102               <a class="code" href="classDiffSolver.php#aec36f54268296d66ff6bf995521edb5c">_solve_result</a> = <a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eea130376f697142abacfd339d3f8d28edc">DiffSolver::DIVERGED_BACKTRACKING_FAILURE</a>;
<a name="l00103"></a>00103               <span class="keywordflow">return</span> bx;
<a name="l00104"></a>00104             }
<a name="l00105"></a>00105         }
<a name="l00106"></a>00106     } <span class="comment">// end while (current_residual &gt; last_residual)</span>
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   <span class="comment">// Now return that reduced-residual step, or  use Brent&#39;s method to</span>
<a name="l00109"></a>00109   <span class="comment">// find a more optimal step.</span>
<a name="l00110"></a>00110 
<a name="l00111"></a>00111   <span class="keywordflow">if</span> (!<a class="code" href="classNewtonSolver.php#a7950ce52c056de7ca5d653e422c9c366">brent_line_search</a>)
<a name="l00112"></a>00112     <span class="keywordflow">return</span> bx;
<a name="l00113"></a>00113 
<a name="l00114"></a>00114   <span class="comment">// Brent&#39;s method adapted from Numerical Recipes in C, ch. 10.2</span>
<a name="l00115"></a>00115   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> e = 0.;
<a name="l00116"></a>00116 
<a name="l00117"></a>00117   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> x = bx, w = bx, v = bx;
<a name="l00118"></a>00118 
<a name="l00119"></a>00119   <span class="comment">// Residuals at bx</span>
<a name="l00120"></a>00120   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> fx = current_residual,
<a name="l00121"></a>00121        fw = current_residual,
<a name="l00122"></a>00122        fv = current_residual;
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <span class="comment">// Max iterations for Brent&#39;s method loop</span>
<a name="l00125"></a>00125   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_i = 20;
<a name="l00126"></a>00126 
<a name="l00127"></a>00127   <span class="comment">// for golden ratio steps</span>
<a name="l00128"></a>00128   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> golden_ratio = 1.-(std::sqrt(5.)-1.)/2.;
<a name="l00129"></a>00129 
<a name="l00130"></a>00130   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i &lt;= max_i; i++)
<a name="l00131"></a>00131     {
<a name="l00132"></a>00132       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xm = (ax+cx)*0.5;
<a name="l00133"></a>00133       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tol1 = tol * std::abs(x) + tol*tol;
<a name="l00134"></a>00134       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tol2 = 2.0 * tol1;
<a name="l00135"></a>00135 
<a name="l00136"></a>00136       <span class="comment">// Test if we&#39;re done</span>
<a name="l00137"></a>00137       <span class="keywordflow">if</span> (std::abs(x-xm) &lt;= (tol2 - 0.5 * (cx - ax)))
<a name="l00138"></a>00138         <span class="keywordflow">return</span> x;
<a name="l00139"></a>00139 
<a name="l00140"></a>00140       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> d;
<a name="l00141"></a>00141 
<a name="l00142"></a>00142       <span class="comment">// Construct a parabolic fit</span>
<a name="l00143"></a>00143       <span class="keywordflow">if</span> (std::abs(e) &gt; tol1)
<a name="l00144"></a>00144         {
<a name="l00145"></a>00145           <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> r = (x-w)*(fx-fv);
<a name="l00146"></a>00146           <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> q = (x-v)*(fx-fw);
<a name="l00147"></a>00147           <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> p = (x-v)*q-(x-w)*r;
<a name="l00148"></a>00148           q = 2. * (q-r);
<a name="l00149"></a>00149           <span class="keywordflow">if</span> (q &gt; 0.)
<a name="l00150"></a>00150             p = -p;
<a name="l00151"></a>00151           <span class="keywordflow">else</span>
<a name="l00152"></a>00152             q = std::abs(q);
<a name="l00153"></a>00153           <span class="keywordflow">if</span> (std::abs(p) &gt;= std::abs(0.5*q*e) ||
<a name="l00154"></a>00154               p &lt;= q * (ax-x) ||
<a name="l00155"></a>00155               p &gt;= q * (cx-x))
<a name="l00156"></a>00156             {
<a name="l00157"></a>00157               <span class="comment">// Take a golden section step</span>
<a name="l00158"></a>00158               e = x &gt;= xm ? ax-x : cx-x;
<a name="l00159"></a>00159               d = golden_ratio * e;
<a name="l00160"></a>00160             }
<a name="l00161"></a>00161           <span class="keywordflow">else</span>
<a name="l00162"></a>00162             {
<a name="l00163"></a>00163               <span class="comment">// Take a parabolic fit step</span>
<a name="l00164"></a>00164               d = p/q;
<a name="l00165"></a>00165               <span class="keywordflow">if</span> (x+d-ax &lt; tol2 || cx-(x+d) &lt; tol2)
<a name="l00166"></a>00166                 d = <a class="code" href="newton__solver_8C.php#a38aacf4cc8e02b8cb52c5174bd627086">SIGN</a>(tol1, xm - x);
<a name="l00167"></a>00167             }
<a name="l00168"></a>00168         }
<a name="l00169"></a>00169       <span class="keywordflow">else</span>
<a name="l00170"></a>00170         {
<a name="l00171"></a>00171           <span class="comment">// Take a golden section step</span>
<a name="l00172"></a>00172           e = x &gt;= xm ? ax-x : cx-x;
<a name="l00173"></a>00173           d = golden_ratio * e;
<a name="l00174"></a>00174         }
<a name="l00175"></a>00175 
<a name="l00176"></a>00176       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> u = std::abs(d) &gt;= tol1 ? x+d : x + <a class="code" href="newton__solver_8C.php#a38aacf4cc8e02b8cb52c5174bd627086">SIGN</a>(tol1,d);
<a name="l00177"></a>00177 
<a name="l00178"></a>00178       <span class="comment">// Assemble the residual at the new steplength u</span>
<a name="l00179"></a>00179       newton_iterate.<a class="code" href="classNumericVector.php#a63f662febc0a45f3b821cce3bc438190">add</a> (bx - u, linear_solution);
<a name="l00180"></a>00180       newton_iterate.<a class="code" href="classNumericVector.php#a4c7feb55cd686619d04e0441b41ceaa5">close</a>();
<a name="l00181"></a>00181       bx = u;
<a name="l00182"></a>00182       <span class="keywordflow">if</span> (!<a class="code" href="classDiffSolver.php#ae6aee54a1508db27cbaa0a6045ef44e9">quiet</a>)
<a name="l00183"></a>00183         std::cout &lt;&lt; <span class="stringliteral">&quot;  Shrinking Newton step to &quot;</span>
<a name="l00184"></a>00184                   &lt;&lt; bx &lt;&lt; std::endl;
<a name="l00185"></a>00185 
<a name="l00186"></a>00186       <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classDifferentiableSystem.php#af2770154003897eef7c70a5318478393">assembly</a> (<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l00187"></a>00187 
<a name="l00188"></a>00188       rhs.<a class="code" href="classNumericVector.php#a4c7feb55cd686619d04e0441b41ceaa5">close</a>();
<a name="l00189"></a>00189       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> fu = current_residual = rhs.<a class="code" href="classNumericVector.php#aae40073beefab5ff9d4418f97b2b4517">l2_norm</a>();
<a name="l00190"></a>00190       <span class="keywordflow">if</span> (!<a class="code" href="classDiffSolver.php#ae6aee54a1508db27cbaa0a6045ef44e9">quiet</a>)
<a name="l00191"></a>00191         std::cout &lt;&lt; <span class="stringliteral">&quot;  Current Residual: &quot;</span>
<a name="l00192"></a>00192                   &lt;&lt; fu &lt;&lt; std::endl;
<a name="l00193"></a>00193 
<a name="l00194"></a>00194       <span class="keywordflow">if</span> (fu &lt;= fx)
<a name="l00195"></a>00195         {
<a name="l00196"></a>00196           <span class="keywordflow">if</span> (u &gt;= x)
<a name="l00197"></a>00197             ax = x;
<a name="l00198"></a>00198           <span class="keywordflow">else</span>
<a name="l00199"></a>00199             cx = x;
<a name="l00200"></a>00200           v = w;   w = x;   x = u;
<a name="l00201"></a>00201           fv = fw; fw = fx; fx = fu;
<a name="l00202"></a>00202         }
<a name="l00203"></a>00203       <span class="keywordflow">else</span>
<a name="l00204"></a>00204         {
<a name="l00205"></a>00205           <span class="keywordflow">if</span> (u &lt; x)
<a name="l00206"></a>00206             ax = u;
<a name="l00207"></a>00207           <span class="keywordflow">else</span>
<a name="l00208"></a>00208             cx = u;
<a name="l00209"></a>00209           <span class="keywordflow">if</span> (fu &lt;= fw || w == x)
<a name="l00210"></a>00210             {
<a name="l00211"></a>00211               v = w;   w = u;
<a name="l00212"></a>00212               fv = fw; fw = fu;
<a name="l00213"></a>00213             }
<a name="l00214"></a>00214           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (fu &lt;= fv || v == x || v == w)
<a name="l00215"></a>00215             {
<a name="l00216"></a>00216               v = u;
<a name="l00217"></a>00217               fv = fu;
<a name="l00218"></a>00218             }
<a name="l00219"></a>00219         }
<a name="l00220"></a>00220     }
<a name="l00221"></a>00221 
<a name="l00222"></a>00222   std::cout &lt;&lt; <span class="stringliteral">&quot;Warning!  Too many iterations used in Brent line search!&quot;</span>
<a name="l00223"></a>00223             &lt;&lt; std::endl;
<a name="l00224"></a>00224   <span class="keywordflow">return</span> bx;
<a name="l00225"></a>00225 }
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 
<a name="l00228"></a><a class="code" href="classNewtonSolver.php#ab7250404338aa02a7785792d692d356d">00228</a> <a class="code" href="classNewtonSolver.php#ab7250404338aa02a7785792d692d356d">NewtonSolver::NewtonSolver</a> (<a class="code" href="classDifferentiableSystem.php">sys_type</a>&amp; s)
<a name="l00229"></a>00229   : <a class="code" href="classDiffSolver.php">Parent</a>(s),
<a name="l00230"></a>00230     require_residual_reduction(true),
<a name="l00231"></a>00231     brent_line_search(true),
<a name="l00232"></a>00232     minsteplength(1e-5),
<a name="l00233"></a>00233     linear_tolerance_multiplier(1e-3),
<a name="l00234"></a>00234     linear_solver(<a class="code" href="classLinearSolver.php">LinearSolver</a>&lt;<a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>&gt;::build())
<a name="l00235"></a>00235 {
<a name="l00236"></a>00236 }
<a name="l00237"></a>00237 
<a name="l00238"></a>00238 
<a name="l00239"></a>00239 
<a name="l00240"></a><a class="code" href="classNewtonSolver.php#a7548b647b809d07297866dc562ac2096">00240</a> <a class="code" href="classNewtonSolver.php#a7548b647b809d07297866dc562ac2096">NewtonSolver::~NewtonSolver</a> ()
<a name="l00241"></a>00241 {
<a name="l00242"></a>00242 }
<a name="l00243"></a>00243 
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 
<a name="l00246"></a><a class="code" href="classNewtonSolver.php#a9e49619f19ab731e3b02c7cd1823bb83">00246</a> <span class="keywordtype">void</span> <a class="code" href="classNewtonSolver.php#a9e49619f19ab731e3b02c7cd1823bb83">NewtonSolver::reinit</a>()
<a name="l00247"></a>00247 {
<a name="l00248"></a>00248   <a class="code" href="classDiffSolver.php#af577460d7836c62c1aed2455c9085e32">Parent::reinit</a>();
<a name="l00249"></a>00249 
<a name="l00250"></a>00250   <a class="code" href="classNewtonSolver.php#aeeaa5c6f270169f6755575a0c294bcc2">linear_solver</a>-&gt;clear();
<a name="l00251"></a>00251 }
<a name="l00252"></a>00252 
<a name="l00253"></a>00253 
<a name="l00254"></a>00254 
<a name="l00255"></a><a class="code" href="classNewtonSolver.php#ae2a6378f959b2d928c1e4e540215171d">00255</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classNewtonSolver.php#ae2a6378f959b2d928c1e4e540215171d">NewtonSolver::solve</a>()
<a name="l00256"></a>00256 {
<a name="l00257"></a>00257   START_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;NewtonSolver&quot;</span>);
<a name="l00258"></a>00258 
<a name="l00259"></a>00259   <span class="comment">// Reset any prior solve result</span>
<a name="l00260"></a>00260   <a class="code" href="classDiffSolver.php#aec36f54268296d66ff6bf995521edb5c">_solve_result</a> = <a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eeae038bac4d2139f7fc5c4244a07c7a3d2">INVALID_SOLVE_RESULT</a>;
<a name="l00261"></a>00261   
<a name="l00262"></a>00262   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp;newton_iterate = *(<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>);
<a name="l00263"></a>00263 
<a name="l00264"></a>00264   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; linear_solution_ptr = newton_iterate.<a class="code" href="classNumericVector.php#a5ac7af0a31b15c7f13c6fa85a5048e45">clone</a>();
<a name="l00265"></a>00265   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp;linear_solution = *linear_solution_ptr;
<a name="l00266"></a>00266   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp;rhs = *(<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>);
<a name="l00267"></a>00267 
<a name="l00268"></a>00268   newton_iterate.<a class="code" href="classNumericVector.php#a4c7feb55cd686619d04e0441b41ceaa5">close</a>();
<a name="l00269"></a>00269   linear_solution.<a class="code" href="classNumericVector.php#a4c7feb55cd686619d04e0441b41ceaa5">close</a>();
<a name="l00270"></a>00270   rhs.<a class="code" href="classNumericVector.php#a4c7feb55cd686619d04e0441b41ceaa5">close</a>();
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00273"></a>00273 <span class="preprocessor"></span>  <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#ab8f806aded3f8351a9f0f6bbf8ae8274">enforce_constraints_exactly</a>(<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>);
<a name="l00274"></a>00274 <span class="preprocessor">#endif</span>
<a name="l00275"></a>00275 <span class="preprocessor"></span>
<a name="l00276"></a>00276   <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;Number&gt;</a> &amp;matrix = *(<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>);
<a name="l00277"></a>00277 
<a name="l00278"></a>00278   <span class="comment">// Prepare to take incomplete steps</span>
<a name="l00279"></a>00279   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> last_residual=0.;
<a name="l00280"></a>00280 
<a name="l00281"></a>00281   <span class="comment">// Set starting linear tolerance</span>
<a name="l00282"></a>00282   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> current_linear_tolerance = <a class="code" href="classDiffSolver.php#aeef97d8c12a932bfd59a7e1aa703fc92">initial_linear_tolerance</a>;
<a name="l00283"></a>00283 
<a name="l00284"></a>00284   <span class="comment">// Start counting our linear solver steps</span>
<a name="l00285"></a>00285   <a class="code" href="classDiffSolver.php#a80e331cee9e385b0a96eae02f680ef52">_inner_iterations</a> = 0;
<a name="l00286"></a>00286 
<a name="l00287"></a>00287   <span class="comment">// Now we begin the nonlinear loop</span>
<a name="l00288"></a>00288   <span class="keywordflow">for</span> (<a class="code" href="classDiffSolver.php#a79d256bff5a88d89aec8941041dc89a9">_outer_iterations</a>=0; <a class="code" href="classDiffSolver.php#a79d256bff5a88d89aec8941041dc89a9">_outer_iterations</a>&lt;<a class="code" href="classDiffSolver.php#af19d007c437a3f5a6e7be54e3c0d0bea">max_nonlinear_iterations</a>;
<a name="l00289"></a>00289        ++<a class="code" href="classDiffSolver.php#a79d256bff5a88d89aec8941041dc89a9">_outer_iterations</a>)
<a name="l00290"></a>00290     {
<a name="l00291"></a>00291       <span class="keywordflow">if</span> (!<a class="code" href="classDiffSolver.php#ae6aee54a1508db27cbaa0a6045ef44e9">quiet</a>)
<a name="l00292"></a>00292         std::cout &lt;&lt; <span class="stringliteral">&quot;Assembling the System&quot;</span> &lt;&lt; std::endl;
<a name="l00293"></a>00293 
<a name="l00294"></a>00294       <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classDifferentiableSystem.php#af2770154003897eef7c70a5318478393">assembly</a>(<span class="keyword">true</span>, <span class="keyword">true</span>);
<a name="l00295"></a>00295       rhs.<a class="code" href="classNumericVector.php#a4c7feb55cd686619d04e0441b41ceaa5">close</a>();
<a name="l00296"></a>00296       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> current_residual = rhs.<a class="code" href="classNumericVector.php#aae40073beefab5ff9d4418f97b2b4517">l2_norm</a>();
<a name="l00297"></a>00297       last_residual = current_residual;
<a name="l00298"></a>00298 
<a name="l00299"></a>00299 <span class="comment">// isnan() isn&#39;t standard C++ yet</span>
<a name="l00300"></a>00300 <span class="preprocessor">#ifdef isnan</span>
<a name="l00301"></a>00301 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (isnan(current_residual))
<a name="l00302"></a>00302         {
<a name="l00303"></a>00303           std::cout &lt;&lt; <span class="stringliteral">&quot;  Nonlinear solver DIVERGED at step &quot;</span> &lt;&lt; last_residual
<a name="l00304"></a>00304                     &lt;&lt; <span class="stringliteral">&quot; with norm Not-a-Number&quot;</span>
<a name="l00305"></a>00305                     &lt;&lt; std::endl;
<a name="l00306"></a>00306           libmesh_convergence_failure();
<a name="l00307"></a>00307           <span class="keywordflow">continue</span>;
<a name="l00308"></a>00308         }
<a name="l00309"></a>00309 <span class="preprocessor">#endif // isnan</span>
<a name="l00310"></a>00310 <span class="preprocessor"></span>
<a name="l00311"></a>00311       <a class="code" href="classDiffSolver.php#a90458811c5dc49c07ec3447553529a6d">max_residual_norm</a> = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a> (current_residual,
<a name="l00312"></a>00312                                     <a class="code" href="classDiffSolver.php#a90458811c5dc49c07ec3447553529a6d">max_residual_norm</a>);
<a name="l00313"></a>00313  
<a name="l00314"></a>00314       <span class="comment">// Compute the l2 norm of the whole solution</span>
<a name="l00315"></a>00315       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> norm_total = newton_iterate.<a class="code" href="classNumericVector.php#aae40073beefab5ff9d4418f97b2b4517">l2_norm</a>();
<a name="l00316"></a>00316 
<a name="l00317"></a>00317       <a class="code" href="classDiffSolver.php#ae59b11ad5467539e63a8427289c3d897">max_solution_norm</a> = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(<a class="code" href="classDiffSolver.php#ae59b11ad5467539e63a8427289c3d897">max_solution_norm</a>, norm_total);
<a name="l00318"></a>00318 
<a name="l00319"></a>00319       <span class="keywordflow">if</span> (!<a class="code" href="classDiffSolver.php#ae6aee54a1508db27cbaa0a6045ef44e9">quiet</a>)
<a name="l00320"></a>00320         std::cout &lt;&lt; <span class="stringliteral">&quot;Nonlinear Residual: &quot;</span>
<a name="l00321"></a>00321                   &lt;&lt; current_residual &lt;&lt; std::endl;
<a name="l00322"></a>00322 
<a name="l00323"></a>00323       <span class="comment">// Make sure our linear tolerance is low enough</span>
<a name="l00324"></a>00324       current_linear_tolerance = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a> (current_linear_tolerance,
<a name="l00325"></a>00325         current_residual * <a class="code" href="classNewtonSolver.php#ad9786803199860d2ae9e4aaf21deda3c">linear_tolerance_multiplier</a>);
<a name="l00326"></a>00326 
<a name="l00327"></a>00327       <span class="comment">// But don&#39;t let it be too small</span>
<a name="l00328"></a>00328       <span class="keywordflow">if</span> (current_linear_tolerance &lt; <a class="code" href="classDiffSolver.php#a13f56127884c9aada9af23517b804a3c">minimum_linear_tolerance</a>)
<a name="l00329"></a>00329         {
<a name="l00330"></a>00330           current_linear_tolerance = <a class="code" href="classDiffSolver.php#a13f56127884c9aada9af23517b804a3c">minimum_linear_tolerance</a>;
<a name="l00331"></a>00331         }
<a name="l00332"></a>00332 
<a name="l00333"></a>00333       <span class="comment">// At this point newton_iterate is the current guess, and</span>
<a name="l00334"></a>00334       <span class="comment">// linear_solution is now about to become the NEGATIVE of the next</span>
<a name="l00335"></a>00335       <span class="comment">// Newton step.</span>
<a name="l00336"></a>00336 
<a name="l00337"></a>00337       <span class="comment">// Our best initial guess for the linear_solution is zero!</span>
<a name="l00338"></a>00338       linear_solution.<a class="code" href="classNumericVector.php#a21ca80e20b0f88490c8f0d5298d47bef">zero</a>();
<a name="l00339"></a>00339 
<a name="l00340"></a>00340       <span class="keywordflow">if</span> (!<a class="code" href="classDiffSolver.php#ae6aee54a1508db27cbaa0a6045ef44e9">quiet</a>)
<a name="l00341"></a>00341         std::cout &lt;&lt; <span class="stringliteral">&quot;Linear solve starting, tolerance &quot;</span> 
<a name="l00342"></a>00342                   &lt;&lt; current_linear_tolerance &lt;&lt; std::endl;
<a name="l00343"></a>00343 
<a name="l00344"></a>00344       <span class="comment">// Solve the linear system.  Two cases:</span>
<a name="l00345"></a>00345       <span class="keyword">const</span> std::pair&lt;unsigned int, Real&gt; rval =
<a name="l00346"></a>00346         (<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#aa23d50b0a898aaee758d4a98c996a4df">have_matrix</a>(<span class="stringliteral">&quot;Preconditioner&quot;</span>)) ?
<a name="l00347"></a>00347       <span class="comment">// 1.) User-supplied preconditioner</span>
<a name="l00348"></a>00348         <a class="code" href="classNewtonSolver.php#aeeaa5c6f270169f6755575a0c294bcc2">linear_solver</a>-&gt;solve (matrix, <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#a719365410b024d2ddab0b1bada55753d">get_matrix</a>(<span class="stringliteral">&quot;Preconditioner&quot;</span>),
<a name="l00349"></a>00349                               linear_solution, rhs, current_linear_tolerance,
<a name="l00350"></a>00350                               <a class="code" href="classDiffSolver.php#a44125d46d2f5df9f29392cbe81069bf6">max_linear_iterations</a>) :
<a name="l00351"></a>00351       <span class="comment">// 2.) Use system matrix for the preconditioner</span>
<a name="l00352"></a>00352         <a class="code" href="classNewtonSolver.php#aeeaa5c6f270169f6755575a0c294bcc2">linear_solver</a>-&gt;solve (matrix, linear_solution, rhs,
<a name="l00353"></a>00353                               current_linear_tolerance, 
<a name="l00354"></a>00354                               <a class="code" href="classDiffSolver.php#a44125d46d2f5df9f29392cbe81069bf6">max_linear_iterations</a>);
<a name="l00355"></a>00355       <span class="comment">// We may need to localize a parallel solution</span>
<a name="l00356"></a>00356       <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classSystem.php#add4b09ec4fb0679b8623c01218cafa5b">update</a> ();
<a name="l00357"></a>00357       <span class="comment">// The linear solver may not have fit our constraints exactly</span>
<a name="l00358"></a>00358 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00359"></a>00359 <span class="preprocessor"></span>      <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#ab8f806aded3f8351a9f0f6bbf8ae8274">enforce_constraints_exactly</a>(<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>, &amp;linear_solution);
<a name="l00360"></a>00360 <span class="preprocessor">#endif</span>
<a name="l00361"></a>00361 <span class="preprocessor"></span>
<a name="l00362"></a>00362       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> linear_steps = rval.first;
<a name="l00363"></a>00363       libmesh_assert(linear_steps &lt;= <a class="code" href="classDiffSolver.php#a44125d46d2f5df9f29392cbe81069bf6">max_linear_iterations</a>);
<a name="l00364"></a>00364       <a class="code" href="classDiffSolver.php#a80e331cee9e385b0a96eae02f680ef52">_inner_iterations</a> += linear_steps;
<a name="l00365"></a>00365 
<a name="l00366"></a>00366       <span class="keyword">const</span> <span class="keywordtype">bool</span> linear_solve_finished = 
<a name="l00367"></a>00367         !(linear_steps == <a class="code" href="classDiffSolver.php#a44125d46d2f5df9f29392cbe81069bf6">max_linear_iterations</a>);
<a name="l00368"></a>00368 
<a name="l00369"></a>00369       <span class="keywordflow">if</span> (!<a class="code" href="classDiffSolver.php#ae6aee54a1508db27cbaa0a6045ef44e9">quiet</a>)
<a name="l00370"></a>00370         std::cout &lt;&lt; <span class="stringliteral">&quot;Linear solve finished, step &quot;</span> &lt;&lt; linear_steps
<a name="l00371"></a>00371                   &lt;&lt; <span class="stringliteral">&quot;, residual &quot;</span> &lt;&lt; rval.second
<a name="l00372"></a>00372                   &lt;&lt; std::endl;
<a name="l00373"></a>00373 
<a name="l00374"></a>00374       <span class="comment">// Compute the l2 norm of the nonlinear update</span>
<a name="l00375"></a>00375       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> norm_delta = linear_solution.<a class="code" href="classNumericVector.php#aae40073beefab5ff9d4418f97b2b4517">l2_norm</a>();
<a name="l00376"></a>00376 
<a name="l00377"></a>00377       <span class="keywordflow">if</span> (!<a class="code" href="classDiffSolver.php#ae6aee54a1508db27cbaa0a6045ef44e9">quiet</a>)
<a name="l00378"></a>00378         std::cout &lt;&lt; <span class="stringliteral">&quot;Trying full Newton step&quot;</span> &lt;&lt; std::endl;
<a name="l00379"></a>00379       <span class="comment">// Take a full Newton step</span>
<a name="l00380"></a>00380       newton_iterate.<a class="code" href="classNumericVector.php#a63f662febc0a45f3b821cce3bc438190">add</a> (-1., linear_solution);
<a name="l00381"></a>00381       newton_iterate.<a class="code" href="classNumericVector.php#a4c7feb55cd686619d04e0441b41ceaa5">close</a>();
<a name="l00382"></a>00382 
<a name="l00383"></a>00383       <span class="comment">// Check residual with full Newton step</span>
<a name="l00384"></a>00384       <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classDifferentiableSystem.php#af2770154003897eef7c70a5318478393">assembly</a>(<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l00385"></a>00385 
<a name="l00386"></a>00386       rhs.close();
<a name="l00387"></a>00387       current_residual = rhs.l2_norm();
<a name="l00388"></a>00388       <span class="keywordflow">if</span> (!<a class="code" href="classDiffSolver.php#ae6aee54a1508db27cbaa0a6045ef44e9">quiet</a>)
<a name="l00389"></a>00389         std::cout &lt;&lt; <span class="stringliteral">&quot;  Current Residual: &quot;</span>
<a name="l00390"></a>00390                   &lt;&lt; current_residual &lt;&lt; std::endl;
<a name="l00391"></a>00391 
<a name="l00392"></a>00392 <span class="comment">// A potential method for avoiding oversolving?</span>
<a name="l00393"></a>00393 <span class="comment">/*</span>
<a name="l00394"></a>00394 <span class="comment">      Real predicted_absolute_error =</span>
<a name="l00395"></a>00395 <span class="comment">        current_residual * norm_delta / last_residual;</span>
<a name="l00396"></a>00396 <span class="comment"></span>
<a name="l00397"></a>00397 <span class="comment">      Real predicted_relative_error =</span>
<a name="l00398"></a>00398 <span class="comment">        predicted_absolute_error / max_solution_norm;</span>
<a name="l00399"></a>00399 <span class="comment"></span>
<a name="l00400"></a>00400 <span class="comment">      std::cout &lt;&lt; &quot;Predicted absolute error = &quot; &lt;&lt;</span>
<a name="l00401"></a>00401 <span class="comment">        predicted_absolute_error &lt;&lt; std::endl;</span>
<a name="l00402"></a>00402 <span class="comment"></span>
<a name="l00403"></a>00403 <span class="comment">      std::cout &lt;&lt; &quot;Predicted relative error = &quot; &lt;&lt;</span>
<a name="l00404"></a>00404 <span class="comment">        predicted_relative_error &lt;&lt; std::endl;</span>
<a name="l00405"></a>00405 <span class="comment">*/</span>
<a name="l00406"></a>00406 
<a name="l00407"></a>00407       <span class="comment">// don&#39;t fiddle around if we&#39;ve already converged</span>
<a name="l00408"></a>00408       <span class="keywordflow">if</span> (<a class="code" href="classNewtonSolver.php#a2bb1b9c986d4a793ac07f59274ff6047">test_convergence</a>(current_residual, norm_delta,
<a name="l00409"></a>00409                            linear_solve_finished))
<a name="l00410"></a>00410         {
<a name="l00411"></a>00411           <span class="keywordflow">if</span> (!<a class="code" href="classDiffSolver.php#ae6aee54a1508db27cbaa0a6045ef44e9">quiet</a>)
<a name="l00412"></a>00412             <a class="code" href="classNewtonSolver.php#a24764dc9b196ade62223bbe2c70265e8">print_convergence</a>(<a class="code" href="classDiffSolver.php#a79d256bff5a88d89aec8941041dc89a9">_outer_iterations</a>, current_residual,
<a name="l00413"></a>00413                               norm_delta, linear_solve_finished);
<a name="l00414"></a>00414           <a class="code" href="classDiffSolver.php#a79d256bff5a88d89aec8941041dc89a9">_outer_iterations</a>++;
<a name="l00415"></a>00415           <span class="keywordflow">break</span>; <span class="comment">// out of _outer_iterations for loop</span>
<a name="l00416"></a>00416         }
<a name="l00417"></a>00417 
<a name="l00418"></a>00418       <span class="comment">// otherwise, backtrack if necessary</span>
<a name="l00419"></a>00419       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> steplength =
<a name="l00420"></a>00420         this-&gt;<a class="code" href="classNewtonSolver.php#aa3e0ef80228414bf0d04dbb6e0382798">line_search</a>(std::sqrt(TOLERANCE),
<a name="l00421"></a>00421                           last_residual, current_residual,
<a name="l00422"></a>00422                           newton_iterate, linear_solution);
<a name="l00423"></a>00423       norm_delta *= steplength;
<a name="l00424"></a>00424 
<a name="l00425"></a>00425       <span class="comment">// Check to see if backtracking failed,</span>
<a name="l00426"></a>00426       <span class="comment">// and break out of the nonlinear loop if so...</span>
<a name="l00427"></a>00427       <span class="keywordflow">if</span> (<a class="code" href="classDiffSolver.php#aec36f54268296d66ff6bf995521edb5c">_solve_result</a> == <a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eea130376f697142abacfd339d3f8d28edc">DiffSolver::DIVERGED_BACKTRACKING_FAILURE</a>)
<a name="l00428"></a>00428         {
<a name="l00429"></a>00429           <a class="code" href="classDiffSolver.php#a79d256bff5a88d89aec8941041dc89a9">_outer_iterations</a>++;
<a name="l00430"></a>00430           <span class="keywordflow">break</span>; <span class="comment">// out of _outer_iterations for loop</span>
<a name="l00431"></a>00431         }
<a name="l00432"></a>00432 
<a name="l00433"></a>00433       <span class="comment">// Compute the l2 norm of the whole solution</span>
<a name="l00434"></a>00434       norm_total = newton_iterate.<a class="code" href="classNumericVector.php#aae40073beefab5ff9d4418f97b2b4517">l2_norm</a>();
<a name="l00435"></a>00435 
<a name="l00436"></a>00436       <a class="code" href="classDiffSolver.php#ae59b11ad5467539e63a8427289c3d897">max_solution_norm</a> = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(<a class="code" href="classDiffSolver.php#ae59b11ad5467539e63a8427289c3d897">max_solution_norm</a>, norm_total);
<a name="l00437"></a>00437 
<a name="l00438"></a>00438       <span class="comment">// Print out information for the </span>
<a name="l00439"></a>00439       <span class="comment">// nonlinear iterations.</span>
<a name="l00440"></a>00440       <span class="keywordflow">if</span> (!<a class="code" href="classDiffSolver.php#ae6aee54a1508db27cbaa0a6045ef44e9">quiet</a>)
<a name="l00441"></a>00441         std::cout &lt;&lt; <span class="stringliteral">&quot;  Nonlinear step: |du|/|u| = &quot;</span>
<a name="l00442"></a>00442                   &lt;&lt; norm_delta / norm_total
<a name="l00443"></a>00443                   &lt;&lt; <span class="stringliteral">&quot;, |du| = &quot;</span> &lt;&lt; norm_delta
<a name="l00444"></a>00444                   &lt;&lt; std::endl;
<a name="l00445"></a>00445 
<a name="l00446"></a>00446       <span class="comment">// Terminate the solution iteration if the difference between</span>
<a name="l00447"></a>00447       <span class="comment">// this iteration and the last is sufficiently small.</span>
<a name="l00448"></a>00448       <span class="keywordflow">if</span> (!<a class="code" href="classDiffSolver.php#ae6aee54a1508db27cbaa0a6045ef44e9">quiet</a>)
<a name="l00449"></a>00449         <a class="code" href="classNewtonSolver.php#a24764dc9b196ade62223bbe2c70265e8">print_convergence</a>(<a class="code" href="classDiffSolver.php#a79d256bff5a88d89aec8941041dc89a9">_outer_iterations</a>, current_residual,
<a name="l00450"></a>00450                           norm_delta / steplength,
<a name="l00451"></a>00451                           linear_solve_finished);
<a name="l00452"></a>00452       <span class="keywordflow">if</span> (<a class="code" href="classNewtonSolver.php#a2bb1b9c986d4a793ac07f59274ff6047">test_convergence</a>(current_residual, norm_delta / steplength,
<a name="l00453"></a>00453                            linear_solve_finished))
<a name="l00454"></a>00454         {
<a name="l00455"></a>00455           <a class="code" href="classDiffSolver.php#a79d256bff5a88d89aec8941041dc89a9">_outer_iterations</a>++;
<a name="l00456"></a>00456           <span class="keywordflow">break</span>; <span class="comment">// out of _outer_iterations for loop</span>
<a name="l00457"></a>00457         }
<a name="l00458"></a>00458 
<a name="l00459"></a>00459       <span class="keywordflow">if</span> (<a class="code" href="classDiffSolver.php#a79d256bff5a88d89aec8941041dc89a9">_outer_iterations</a> &gt;= max_nonlinear_iterations - 1)
<a name="l00460"></a>00460         {
<a name="l00461"></a>00461           std::cout &lt;&lt; <span class="stringliteral">&quot;  Nonlinear solver FAILED TO CONVERGE by step &quot;</span>
<a name="l00462"></a>00462                     &lt;&lt; <a class="code" href="classDiffSolver.php#a79d256bff5a88d89aec8941041dc89a9">_outer_iterations</a> &lt;&lt; <span class="stringliteral">&quot; with norm &quot;</span>
<a name="l00463"></a>00463                     &lt;&lt; norm_total &lt;&lt; std::endl;
<a name="l00464"></a>00464           <span class="keywordflow">if</span> (<a class="code" href="classDiffSolver.php#a97ca05c97f03bd17340b1a361a98e80f">continue_after_max_iterations</a>)
<a name="l00465"></a>00465             {
<a name="l00466"></a>00466               <a class="code" href="classDiffSolver.php#aec36f54268296d66ff6bf995521edb5c">_solve_result</a> = <a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eeabe4e5d049d7a788b52deae9ce8865b34">DiffSolver::DIVERGED_MAX_NONLINEAR_ITERATIONS</a>;
<a name="l00467"></a>00467               std::cout &lt;&lt; <span class="stringliteral">&quot;  Continuing anyway...&quot;</span> &lt;&lt; std::endl;
<a name="l00468"></a>00468             }
<a name="l00469"></a>00469           <span class="keywordflow">else</span>
<a name="l00470"></a>00470             {
<a name="l00471"></a>00471               libmesh_convergence_failure();
<a name="l00472"></a>00472             }
<a name="l00473"></a>00473           <span class="keywordflow">continue</span>;
<a name="l00474"></a>00474         }
<a name="l00475"></a>00475     } <span class="comment">// end nonlinear loop</span>
<a name="l00476"></a>00476 
<a name="l00477"></a>00477   <span class="comment">// The linear solver may not have fit our constraints exactly</span>
<a name="l00478"></a>00478 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00479"></a>00479 <span class="preprocessor"></span>  <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#ab8f806aded3f8351a9f0f6bbf8ae8274">enforce_constraints_exactly</a>(<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>);
<a name="l00480"></a>00480 <span class="preprocessor">#endif</span>
<a name="l00481"></a>00481 <span class="preprocessor"></span>
<a name="l00482"></a>00482   <span class="comment">// We may need to localize a parallel solution</span>
<a name="l00483"></a>00483   <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classSystem.php#add4b09ec4fb0679b8623c01218cafa5b">update</a> ();
<a name="l00484"></a>00484 
<a name="l00485"></a>00485   STOP_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;NewtonSolver&quot;</span>);
<a name="l00486"></a>00486 
<a name="l00487"></a>00487   <span class="comment">// Make sure we are returning something sensible as the</span>
<a name="l00488"></a>00488   <span class="comment">// _solve_result.</span>
<a name="l00489"></a>00489   libmesh_assert (<a class="code" href="classDiffSolver.php#aec36f54268296d66ff6bf995521edb5c">_solve_result</a> != <a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eeae038bac4d2139f7fc5c4244a07c7a3d2">DiffSolver::INVALID_SOLVE_RESULT</a>);
<a name="l00490"></a>00490   
<a name="l00491"></a>00491   <span class="keywordflow">return</span> <a class="code" href="classDiffSolver.php#aec36f54268296d66ff6bf995521edb5c">_solve_result</a>;
<a name="l00492"></a>00492 }
<a name="l00493"></a>00493 
<a name="l00494"></a>00494 
<a name="l00495"></a>00495 
<a name="l00496"></a><a class="code" href="classNewtonSolver.php#a5df93dd4984fdf16a8db99a5160de197">00496</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classNewtonSolver.php#a5df93dd4984fdf16a8db99a5160de197">NewtonSolver::adjoint_solve</a>()
<a name="l00497"></a>00497 {
<a name="l00498"></a>00498   <span class="comment">// The adjoint_solve API (and all APIs using it) are about to see a</span>
<a name="l00499"></a>00499   <span class="comment">// series of non-backwards-compatible changes, primarily to add</span>
<a name="l00500"></a>00500   <span class="comment">// multiple-QoI support</span>
<a name="l00501"></a>00501   libmesh_experimental();
<a name="l00502"></a>00502 
<a name="l00503"></a>00503   START_LOG(<span class="stringliteral">&quot;adjoint_solve()&quot;</span>, <span class="stringliteral">&quot;NewtonSolver&quot;</span>);
<a name="l00504"></a>00504 
<a name="l00505"></a>00505   <span class="keywordflow">if</span> (!<a class="code" href="classDiffSolver.php#ae6aee54a1508db27cbaa0a6045ef44e9">quiet</a>)
<a name="l00506"></a>00506   std::cout &lt;&lt; <span class="stringliteral">&quot;Assembling the Adjoint System&quot;</span> &lt;&lt; std::endl;
<a name="l00507"></a>00507 
<a name="l00508"></a>00508   <span class="comment">// Adding an adjoint_solution vector, allocate an adjoint_solution if it doesn&#39;t already exist</span>
<a name="l00509"></a>00509 
<a name="l00510"></a>00510   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp; adjoint_solution = <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classSystem.php#abab8a3810cc43d99fe395d449207b786">add_vector</a>(<span class="stringliteral">&quot;adjoint_solution&quot;</span>);
<a name="l00511"></a>00511   
<a name="l00512"></a>00512   <span class="comment">// Do DiffSystem assembly</span>
<a name="l00513"></a>00513   <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classDifferentiableSystem.php#af2770154003897eef7c70a5318478393">assembly</a>(<span class="keyword">false</span>, <span class="keyword">true</span>);
<a name="l00514"></a>00514   <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>-&gt;<a class="code" href="classSparseMatrix.php#a55129db49268936e33686bc1beaaa1e9">close</a>();
<a name="l00515"></a>00515 
<a name="l00516"></a>00516   <span class="comment">// But take the adjoint</span>
<a name="l00517"></a>00517   <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>-&gt;<a class="code" href="classSparseMatrix.php#a7f1c4ddda074a4e1aa63bf7d2f780492">get_transpose</a>(*<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>);
<a name="l00518"></a>00518 
<a name="l00519"></a>00519   <span class="keywordflow">if</span> (<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#aa23d50b0a898aaee758d4a98c996a4df">have_matrix</a>(<span class="stringliteral">&quot;Preconditioner&quot;</span>))
<a name="l00520"></a>00520     {
<a name="l00521"></a>00521       <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;Number&gt;</a> &amp;pre = <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#a719365410b024d2ddab0b1bada55753d">get_matrix</a>(<span class="stringliteral">&quot;Preconditioner&quot;</span>);
<a name="l00522"></a>00522       pre.<a class="code" href="classSparseMatrix.php#a7f1c4ddda074a4e1aa63bf7d2f780492">get_transpose</a>(pre);
<a name="l00523"></a>00523     }
<a name="l00524"></a>00524 
<a name="l00525"></a>00525   <span class="comment">// And set the right hand side to the quantity of interest&#39;s</span>
<a name="l00526"></a>00526   <span class="comment">// derivative</span>
<a name="l00527"></a>00527   <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classExplicitSystem.php#a563d121d2398bdc54dbe60eda789ddaa">assemble_qoi_derivative</a>();
<a name="l00528"></a>00528 
<a name="l00529"></a>00529   <span class="keywordflow">if</span> (!<a class="code" href="classDiffSolver.php#ae6aee54a1508db27cbaa0a6045ef44e9">quiet</a>)
<a name="l00530"></a>00530     std::cout &lt;&lt; <span class="stringliteral">&quot;Linear solve of Adjoint System starting, tolerance &quot;</span> 
<a name="l00531"></a>00531               &lt;&lt; <a class="code" href="classDiffSolver.php#aa61c00b75cbbd6910882c7a415d9d22a">relative_residual_tolerance</a> &lt;&lt; <span class="stringliteral">&quot;, max iterations &quot;</span>
<a name="l00532"></a>00532               &lt;&lt; <a class="code" href="classDiffSolver.php#a44125d46d2f5df9f29392cbe81069bf6">max_linear_iterations</a> &lt;&lt; std::endl;
<a name="l00533"></a>00533 
<a name="l00534"></a>00534   <span class="comment">// Solve the linear system.  Two cases:</span>
<a name="l00535"></a>00535   <span class="keyword">const</span> std::pair&lt;unsigned int, Real&gt; rval =
<a name="l00536"></a>00536     (<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#aa23d50b0a898aaee758d4a98c996a4df">have_matrix</a>(<span class="stringliteral">&quot;Preconditioner&quot;</span>)) ?
<a name="l00537"></a>00537   <span class="comment">// 1.) User-supplied preconditioner</span>
<a name="l00538"></a>00538     <a class="code" href="classNewtonSolver.php#aeeaa5c6f270169f6755575a0c294bcc2">linear_solver</a>-&gt;solve (*<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>,
<a name="l00539"></a>00539                           <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#a719365410b024d2ddab0b1bada55753d">get_matrix</a>(<span class="stringliteral">&quot;Preconditioner&quot;</span>),
<a name="l00540"></a>00540                           adjoint_solution, *<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>,
<a name="l00541"></a>00541                           <a class="code" href="classDiffSolver.php#aa61c00b75cbbd6910882c7a415d9d22a">relative_residual_tolerance</a>,
<a name="l00542"></a>00542                           <a class="code" href="classDiffSolver.php#a44125d46d2f5df9f29392cbe81069bf6">max_linear_iterations</a>) :
<a name="l00543"></a>00543   <span class="comment">// 2.) Use system matrix for the preconditioner</span>
<a name="l00544"></a>00544     <a class="code" href="classNewtonSolver.php#aeeaa5c6f270169f6755575a0c294bcc2">linear_solver</a>-&gt;solve (*<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>,
<a name="l00545"></a>00545                           adjoint_solution, *<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>,
<a name="l00546"></a>00546                           <a class="code" href="classDiffSolver.php#aa61c00b75cbbd6910882c7a415d9d22a">relative_residual_tolerance</a>, 
<a name="l00547"></a>00547                           <a class="code" href="classDiffSolver.php#a44125d46d2f5df9f29392cbe81069bf6">max_linear_iterations</a>);
<a name="l00548"></a>00548 
<a name="l00549"></a>00549   <span class="comment">// We may need to localize a parallel solution</span>
<a name="l00550"></a>00550   <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classSystem.php#add4b09ec4fb0679b8623c01218cafa5b">update</a> ();
<a name="l00551"></a>00551 
<a name="l00552"></a>00552   <span class="comment">// The linear solver may not have fit our constraints exactly</span>
<a name="l00553"></a>00553 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00554"></a>00554 <span class="preprocessor"></span>  <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#ab8f806aded3f8351a9f0f6bbf8ae8274">enforce_constraints_exactly</a>(<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>, &amp;adjoint_solution);
<a name="l00555"></a>00555 <span class="preprocessor">#endif</span>
<a name="l00556"></a>00556 <span class="preprocessor"></span>
<a name="l00557"></a>00557   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> linear_steps = rval.first;
<a name="l00558"></a>00558   libmesh_assert(linear_steps &lt;= <a class="code" href="classDiffSolver.php#a44125d46d2f5df9f29392cbe81069bf6">max_linear_iterations</a>);
<a name="l00559"></a>00559 
<a name="l00560"></a>00560   <span class="keywordflow">if</span> (!<a class="code" href="classDiffSolver.php#ae6aee54a1508db27cbaa0a6045ef44e9">quiet</a>)
<a name="l00561"></a>00561     std::cout &lt;&lt; <span class="stringliteral">&quot;Linear solve of Adjoint System finished, step &quot;</span> &lt;&lt; linear_steps
<a name="l00562"></a>00562               &lt;&lt; <span class="stringliteral">&quot;, residual &quot;</span> &lt;&lt; rval.second
<a name="l00563"></a>00563               &lt;&lt; std::endl;
<a name="l00564"></a>00564 
<a name="l00565"></a>00565   STOP_LOG(<span class="stringliteral">&quot;adjoint_solve()&quot;</span>, <span class="stringliteral">&quot;NewtonSolver&quot;</span>);
<a name="l00566"></a>00566 
<a name="l00567"></a>00567   <span class="comment">// FIXME - We&#39;ll worry about getting the solve result right later...</span>
<a name="l00568"></a>00568   
<a name="l00569"></a>00569   <span class="keywordflow">return</span> <a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eea7a3ff540e243e45764a90666389ba012">DiffSolver::CONVERGED_RELATIVE_RESIDUAL</a>;
<a name="l00570"></a>00570 }
<a name="l00571"></a>00571 
<a name="l00572"></a>00572 
<a name="l00573"></a>00573 
<a name="l00574"></a><a class="code" href="classNewtonSolver.php#a2bb1b9c986d4a793ac07f59274ff6047">00574</a> <span class="keywordtype">bool</span> <a class="code" href="classNewtonSolver.php#a2bb1b9c986d4a793ac07f59274ff6047">NewtonSolver::test_convergence</a>(<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> current_residual,
<a name="l00575"></a>00575                                     <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> step_norm,
<a name="l00576"></a>00576                                     <span class="keywordtype">bool</span> linear_solve_finished)
<a name="l00577"></a>00577 {
<a name="l00578"></a>00578   <span class="comment">// We haven&#39;t converged unless we pass a convergence test</span>
<a name="l00579"></a>00579   <span class="keywordtype">bool</span> has_converged = <span class="keyword">false</span>;
<a name="l00580"></a>00580 
<a name="l00581"></a>00581   <span class="comment">// Is our absolute residual low enough?</span>
<a name="l00582"></a>00582   <span class="keywordflow">if</span> (current_residual &lt; <a class="code" href="classDiffSolver.php#a3cbd27e0c7686f2b8679cfda8ef10688">absolute_residual_tolerance</a>)
<a name="l00583"></a>00583     {
<a name="l00584"></a>00584       <a class="code" href="classDiffSolver.php#aec36f54268296d66ff6bf995521edb5c">_solve_result</a> |= <a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eea6cf0082a1c732ae88bb52a5d35ae52ae">CONVERGED_ABSOLUTE_RESIDUAL</a>;
<a name="l00585"></a>00585       has_converged = <span class="keyword">true</span>;
<a name="l00586"></a>00586     }
<a name="l00587"></a>00587   
<a name="l00588"></a>00588   <span class="comment">// Is our relative residual low enough?</span>
<a name="l00589"></a>00589   <span class="keywordflow">if</span> ((current_residual / <a class="code" href="classDiffSolver.php#a90458811c5dc49c07ec3447553529a6d">max_residual_norm</a>) &lt;
<a name="l00590"></a>00590       <a class="code" href="classDiffSolver.php#aa61c00b75cbbd6910882c7a415d9d22a">relative_residual_tolerance</a>)
<a name="l00591"></a>00591     {
<a name="l00592"></a>00592       <a class="code" href="classDiffSolver.php#aec36f54268296d66ff6bf995521edb5c">_solve_result</a> |= <a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eea7a3ff540e243e45764a90666389ba012">CONVERGED_RELATIVE_RESIDUAL</a>;
<a name="l00593"></a>00593       has_converged = <span class="keyword">true</span>;
<a name="l00594"></a>00594     }
<a name="l00595"></a>00595   
<a name="l00596"></a>00596   <span class="comment">// For incomplete linear solves, it&#39;s not safe to test step sizes</span>
<a name="l00597"></a>00597   <span class="keywordflow">if</span> (!linear_solve_finished)
<a name="l00598"></a>00598     {
<a name="l00599"></a>00599       <span class="keywordflow">return</span> has_converged;
<a name="l00600"></a>00600     }
<a name="l00601"></a>00601   
<a name="l00602"></a>00602   <span class="comment">// Is our absolute Newton step size small enough?</span>
<a name="l00603"></a>00603   <span class="keywordflow">if</span> (step_norm &lt; <a class="code" href="classDiffSolver.php#a84dcc061d26122fae4918c2c31bf7112">absolute_step_tolerance</a>)
<a name="l00604"></a>00604     {
<a name="l00605"></a>00605       <a class="code" href="classDiffSolver.php#aec36f54268296d66ff6bf995521edb5c">_solve_result</a> |= <a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eeac8730b88876c08be2436d12d17dcb42f">CONVERGED_ABSOLUTE_STEP</a>;
<a name="l00606"></a>00606       has_converged = <span class="keyword">true</span>;
<a name="l00607"></a>00607     }
<a name="l00608"></a>00608   
<a name="l00609"></a>00609   <span class="comment">// Is our relative Newton step size small enough?</span>
<a name="l00610"></a>00610   <span class="keywordflow">if</span> (step_norm / <a class="code" href="classDiffSolver.php#ae59b11ad5467539e63a8427289c3d897">max_solution_norm</a> &lt;
<a name="l00611"></a>00611       <a class="code" href="classDiffSolver.php#abd9adb33f150f9d5af8241e38e64d218">relative_step_tolerance</a>)
<a name="l00612"></a>00612     {
<a name="l00613"></a>00613       <a class="code" href="classDiffSolver.php#aec36f54268296d66ff6bf995521edb5c">_solve_result</a> |= <a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eea2f1371f17746515eeba38c85bc8676e1">CONVERGED_RELATIVE_STEP</a>;
<a name="l00614"></a>00614       has_converged = <span class="keyword">true</span>;
<a name="l00615"></a>00615     }
<a name="l00616"></a>00616   
<a name="l00617"></a>00617   <span class="keywordflow">return</span> has_converged;
<a name="l00618"></a>00618 }
<a name="l00619"></a>00619 
<a name="l00620"></a>00620 
<a name="l00621"></a><a class="code" href="classNewtonSolver.php#a24764dc9b196ade62223bbe2c70265e8">00621</a> <span class="keywordtype">void</span> <a class="code" href="classNewtonSolver.php#a24764dc9b196ade62223bbe2c70265e8">NewtonSolver::print_convergence</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> step_num,
<a name="l00622"></a>00622                                      <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> current_residual,
<a name="l00623"></a>00623                                      <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> step_norm,
<a name="l00624"></a>00624                                      <span class="keywordtype">bool</span> linear_solve_finished)
<a name="l00625"></a>00625 {
<a name="l00626"></a>00626   <span class="comment">// Is our absolute residual low enough?</span>
<a name="l00627"></a>00627   <span class="keywordflow">if</span> (current_residual &lt; <a class="code" href="classDiffSolver.php#a3cbd27e0c7686f2b8679cfda8ef10688">absolute_residual_tolerance</a>)
<a name="l00628"></a>00628     {
<a name="l00629"></a>00629       std::cout &lt;&lt; <span class="stringliteral">&quot;  Nonlinear solver converged, step &quot;</span> &lt;&lt; step_num
<a name="l00630"></a>00630                 &lt;&lt; <span class="stringliteral">&quot;, residual &quot;</span> &lt;&lt; current_residual
<a name="l00631"></a>00631                 &lt;&lt; std::endl;
<a name="l00632"></a>00632     }
<a name="l00633"></a>00633   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classDiffSolver.php#a3cbd27e0c7686f2b8679cfda8ef10688">absolute_residual_tolerance</a>)
<a name="l00634"></a>00634     {
<a name="l00635"></a>00635       std::cout &lt;&lt; <span class="stringliteral">&quot;  Nonlinear solver current_residual &quot;</span>
<a name="l00636"></a>00636                 &lt;&lt; current_residual &lt;&lt; <span class="stringliteral">&quot; &gt; &quot;</span>
<a name="l00637"></a>00637                 &lt;&lt; (<a class="code" href="classDiffSolver.php#a3cbd27e0c7686f2b8679cfda8ef10688">absolute_residual_tolerance</a>) &lt;&lt; std::endl;
<a name="l00638"></a>00638     }
<a name="l00639"></a>00639 
<a name="l00640"></a>00640   <span class="comment">// Is our relative residual low enough?</span>
<a name="l00641"></a>00641   <span class="keywordflow">if</span> ((current_residual / <a class="code" href="classDiffSolver.php#a90458811c5dc49c07ec3447553529a6d">max_residual_norm</a>) &lt;
<a name="l00642"></a>00642       <a class="code" href="classDiffSolver.php#aa61c00b75cbbd6910882c7a415d9d22a">relative_residual_tolerance</a>)
<a name="l00643"></a>00643     {
<a name="l00644"></a>00644       std::cout &lt;&lt; <span class="stringliteral">&quot;  Nonlinear solver converged, step &quot;</span> &lt;&lt; step_num
<a name="l00645"></a>00645                 &lt;&lt; <span class="stringliteral">&quot;, residual reduction &quot;</span>
<a name="l00646"></a>00646                 &lt;&lt; current_residual / <a class="code" href="classDiffSolver.php#a90458811c5dc49c07ec3447553529a6d">max_residual_norm</a>
<a name="l00647"></a>00647                 &lt;&lt; <span class="stringliteral">&quot; &lt; &quot;</span> &lt;&lt; <a class="code" href="classDiffSolver.php#aa61c00b75cbbd6910882c7a415d9d22a">relative_residual_tolerance</a>
<a name="l00648"></a>00648                 &lt;&lt; std::endl;
<a name="l00649"></a>00649     }
<a name="l00650"></a>00650   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classDiffSolver.php#aa61c00b75cbbd6910882c7a415d9d22a">relative_residual_tolerance</a>)
<a name="l00651"></a>00651     {
<a name="l00652"></a>00652       <span class="keywordflow">if</span> (!<a class="code" href="classDiffSolver.php#ae6aee54a1508db27cbaa0a6045ef44e9">quiet</a>)
<a name="l00653"></a>00653         std::cout &lt;&lt; <span class="stringliteral">&quot;  Nonlinear solver relative residual &quot;</span>
<a name="l00654"></a>00654                   &lt;&lt; (current_residual / <a class="code" href="classDiffSolver.php#a90458811c5dc49c07ec3447553529a6d">max_residual_norm</a>)
<a name="l00655"></a>00655                   &lt;&lt; <span class="stringliteral">&quot; &gt; &quot;</span> &lt;&lt; <a class="code" href="classDiffSolver.php#aa61c00b75cbbd6910882c7a415d9d22a">relative_residual_tolerance</a>
<a name="l00656"></a>00656                   &lt;&lt; std::endl;
<a name="l00657"></a>00657     }
<a name="l00658"></a>00658 
<a name="l00659"></a>00659   <span class="comment">// For incomplete linear solves, it&#39;s not safe to test step sizes</span>
<a name="l00660"></a>00660   <span class="keywordflow">if</span> (!linear_solve_finished)
<a name="l00661"></a>00661     <span class="keywordflow">return</span>;
<a name="l00662"></a>00662 
<a name="l00663"></a>00663   <span class="comment">// Is our absolute Newton step size small enough?</span>
<a name="l00664"></a>00664   <span class="keywordflow">if</span> (step_norm &lt; <a class="code" href="classDiffSolver.php#a84dcc061d26122fae4918c2c31bf7112">absolute_step_tolerance</a>)
<a name="l00665"></a>00665     {
<a name="l00666"></a>00666       std::cout &lt;&lt; <span class="stringliteral">&quot;  Nonlinear solver converged, step &quot;</span> &lt;&lt; step_num
<a name="l00667"></a>00667                 &lt;&lt; <span class="stringliteral">&quot;, absolute step size &quot;</span>
<a name="l00668"></a>00668                 &lt;&lt; step_norm
<a name="l00669"></a>00669                 &lt;&lt; <span class="stringliteral">&quot; &lt; &quot;</span> &lt;&lt; <a class="code" href="classDiffSolver.php#a84dcc061d26122fae4918c2c31bf7112">absolute_step_tolerance</a>
<a name="l00670"></a>00670                 &lt;&lt; std::endl;
<a name="l00671"></a>00671     }
<a name="l00672"></a>00672   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classDiffSolver.php#a84dcc061d26122fae4918c2c31bf7112">absolute_step_tolerance</a>)
<a name="l00673"></a>00673     {
<a name="l00674"></a>00674       std::cout &lt;&lt; <span class="stringliteral">&quot;  Nonlinear solver absolute step size &quot;</span>
<a name="l00675"></a>00675                 &lt;&lt; step_norm
<a name="l00676"></a>00676                 &lt;&lt; <span class="stringliteral">&quot; &gt; &quot;</span> &lt;&lt; <a class="code" href="classDiffSolver.php#a84dcc061d26122fae4918c2c31bf7112">absolute_step_tolerance</a>
<a name="l00677"></a>00677                 &lt;&lt; std::endl;
<a name="l00678"></a>00678     }
<a name="l00679"></a>00679 
<a name="l00680"></a>00680   <span class="comment">// Is our relative Newton step size small enough?</span>
<a name="l00681"></a>00681   <span class="keywordflow">if</span> (step_norm / <a class="code" href="classDiffSolver.php#ae59b11ad5467539e63a8427289c3d897">max_solution_norm</a> &lt;
<a name="l00682"></a>00682       <a class="code" href="classDiffSolver.php#abd9adb33f150f9d5af8241e38e64d218">relative_step_tolerance</a>)
<a name="l00683"></a>00683     {
<a name="l00684"></a>00684       std::cout &lt;&lt; <span class="stringliteral">&quot;  Nonlinear solver converged, step &quot;</span> &lt;&lt; step_num
<a name="l00685"></a>00685                 &lt;&lt; <span class="stringliteral">&quot;, relative step size &quot;</span>
<a name="l00686"></a>00686                 &lt;&lt; (step_norm / <a class="code" href="classDiffSolver.php#ae59b11ad5467539e63a8427289c3d897">max_solution_norm</a>)
<a name="l00687"></a>00687                 &lt;&lt; <span class="stringliteral">&quot; &lt; &quot;</span> &lt;&lt; <a class="code" href="classDiffSolver.php#abd9adb33f150f9d5af8241e38e64d218">relative_step_tolerance</a>
<a name="l00688"></a>00688                 &lt;&lt; std::endl;
<a name="l00689"></a>00689     }
<a name="l00690"></a>00690   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classDiffSolver.php#abd9adb33f150f9d5af8241e38e64d218">relative_step_tolerance</a>)
<a name="l00691"></a>00691     {
<a name="l00692"></a>00692       std::cout &lt;&lt; <span class="stringliteral">&quot;  Nonlinear solver relative step size &quot;</span>
<a name="l00693"></a>00693                 &lt;&lt; (step_norm / <a class="code" href="classDiffSolver.php#ae59b11ad5467539e63a8427289c3d897">max_solution_norm</a>)
<a name="l00694"></a>00694                 &lt;&lt; <span class="stringliteral">&quot; &gt; &quot;</span> &lt;&lt; <a class="code" href="classDiffSolver.php#abd9adb33f150f9d5af8241e38e64d218">relative_step_tolerance</a>
<a name="l00695"></a>00695                 &lt;&lt; std::endl;
<a name="l00696"></a>00696     }
<a name="l00697"></a>00697 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
