<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>newton_solver.h</h1>  </div>
</div>
<div class="contents">
<a href="newton__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: newton_solver.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __newton_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __newton_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;linear_solver.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;reference_counted_object.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="diff__solver_8h.php">diff_solver.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00045"></a>00045 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00046"></a>00046 <span class="comment">// Solver class definition</span>
<a name="l00047"></a><a class="code" href="classNewtonSolver.php">00047</a> <span class="keyword">class </span><a class="code" href="classNewtonSolver.php">NewtonSolver</a> : <span class="keyword">public</span> <a class="code" href="classDiffSolver.php">DiffSolver</a>
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049 <span class="keyword">public</span>:
<a name="l00054"></a>00054   <a class="code" href="classNewtonSolver.php#ab7250404338aa02a7785792d692d356d">NewtonSolver</a> (<a class="code" href="classDifferentiableSystem.php">sys_type</a>&amp; <a class="code" href="classDiffSolver.php#a4caf9ee24e332e6cda6c8bb3ea032b87">system</a>);
<a name="l00055"></a>00055   
<a name="l00059"></a>00059   <span class="keyword">virtual</span> <a class="code" href="classNewtonSolver.php#a7548b647b809d07297866dc562ac2096">~NewtonSolver</a> ();
<a name="l00060"></a>00060 
<a name="l00061"></a><a class="code" href="classNewtonSolver.php#a606329660600608ce78bcb4c3fa822a3">00061</a>   <span class="keyword">typedef</span> <a class="code" href="classDiffSolver.php">DiffSolver</a> <a class="code" href="classNewtonSolver.php#a606329660600608ce78bcb4c3fa822a3">Parent</a>;
<a name="l00062"></a>00062 
<a name="l00067"></a>00067   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNewtonSolver.php#a9e49619f19ab731e3b02c7cd1823bb83">reinit</a> ();
<a name="l00068"></a>00068 
<a name="l00073"></a>00073   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classNewtonSolver.php#ae2a6378f959b2d928c1e4e540215171d">solve</a> ();
<a name="l00074"></a>00074 
<a name="l00078"></a>00078   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classNewtonSolver.php#a5df93dd4984fdf16a8db99a5160de197">adjoint_solve</a> ();
<a name="l00079"></a>00079 
<a name="l00087"></a><a class="code" href="classNewtonSolver.php#a435167ee009f7b1c80050ed527709341">00087</a>   <span class="keywordtype">bool</span> <a class="code" href="classNewtonSolver.php#a435167ee009f7b1c80050ed527709341">require_residual_reduction</a>;
<a name="l00088"></a>00088 
<a name="l00100"></a><a class="code" href="classNewtonSolver.php#a7950ce52c056de7ca5d653e422c9c366">00100</a>   <span class="keywordtype">bool</span> <a class="code" href="classNewtonSolver.php#a7950ce52c056de7ca5d653e422c9c366">brent_line_search</a>;
<a name="l00101"></a>00101 
<a name="l00108"></a><a class="code" href="classNewtonSolver.php#acc5cac6e3570d6d39de8fb805c6862bb">00108</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNewtonSolver.php#acc5cac6e3570d6d39de8fb805c6862bb">minsteplength</a>;
<a name="l00109"></a>00109 
<a name="l00114"></a><a class="code" href="classNewtonSolver.php#ad9786803199860d2ae9e4aaf21deda3c">00114</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNewtonSolver.php#ad9786803199860d2ae9e4aaf21deda3c">linear_tolerance_multiplier</a>;
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 <span class="keyword">protected</span>:
<a name="l00117"></a>00117 
<a name="l00124"></a><a class="code" href="classNewtonSolver.php#aeeaa5c6f270169f6755575a0c294bcc2">00124</a>   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;LinearSolver&lt;Number&gt;</a> &gt; <a class="code" href="classNewtonSolver.php#aeeaa5c6f270169f6755575a0c294bcc2">linear_solver</a>;
<a name="l00125"></a>00125 
<a name="l00132"></a>00132   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNewtonSolver.php#aa3e0ef80228414bf0d04dbb6e0382798">line_search</a>(<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tol, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> last_residual, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&amp; current_residual,
<a name="l00133"></a>00133                    <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp;newton_iterate,
<a name="l00134"></a>00134                    <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp;linear_solution);
<a name="l00135"></a>00135 
<a name="l00140"></a>00140   <span class="keywordtype">void</span> <a class="code" href="classNewtonSolver.php#a24764dc9b196ade62223bbe2c70265e8">print_convergence</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> step_num,
<a name="l00141"></a>00141                          <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> current_residual,
<a name="l00142"></a>00142                          <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> step_norm,
<a name="l00143"></a>00143                          <span class="keywordtype">bool</span> linear_solve_finished);
<a name="l00144"></a>00144 
<a name="l00149"></a>00149   <span class="keywordtype">bool</span> <a class="code" href="classNewtonSolver.php#a2bb1b9c986d4a793ac07f59274ff6047">test_convergence</a>(<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> current_residual,
<a name="l00150"></a>00150                         <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> step_norm,
<a name="l00151"></a>00151                         <span class="keywordtype">bool</span> linear_solve_finished);
<a name="l00152"></a>00152 };
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 <span class="preprocessor">#endif // #define __newton_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
