<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1665b3ccb6c776ec6797fe204e2359e5.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>node.C</h1>  </div>
</div>
<div class="contents">
<a href="node_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: node.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;node.h&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00030"></a>00030 <span class="comment">// Node class static member initialization</span>
<a name="l00031"></a>00031 <span class="comment">//const unsigned int Node::invalid_id = libMesh::invalid_uint;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a><a class="code" href="classNode.php#ade382579e87c4393961f9ea5f4fa2abf">00034</a> <span class="keywordtype">bool</span> <a class="code" href="classNode.php#ade382579e87c4393961f9ea5f4fa2abf">Node::operator==</a>(<span class="keyword">const</span> <a class="code" href="classDofObject.php">DofObject</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00035"></a>00035 <span class="keyword"></span>{
<a name="l00036"></a>00036   <span class="comment">// Cast rhs to a Node*</span>
<a name="l00037"></a>00037   <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* rhs_node = <span class="keyword">dynamic_cast&lt;</span><span class="keyword">const </span><a class="code" href="classNode.php">Node</a>*<span class="keyword">&gt;</span>(&amp;rhs);
<a name="l00038"></a>00038 
<a name="l00039"></a>00039   <span class="comment">// If we can&#39;t cast to a Node* then rhs must be an Elem</span>
<a name="l00040"></a>00040   <span class="keywordflow">if</span>(rhs_node == NULL)
<a name="l00041"></a>00041     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00042"></a>00042 
<a name="l00043"></a>00043   <span class="comment">// Explicitly calling the operator== defined in Point</span>
<a name="l00044"></a>00044   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classNode.php#ade382579e87c4393961f9ea5f4fa2abf">Point::operator==</a>(*rhs_node);
<a name="l00045"></a>00045 }
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00050"></a><a class="code" href="structNode_1_1PackedNode.php#aa8d2df259c60b02a82fa80fa60326acf">00050</a> <span class="preprocessor"></span>MPI_Datatype <a class="code" href="structNode_1_1PackedNode.php#aa8d2df259c60b02a82fa80fa60326acf">Node::PackedNode::create_mpi_datatype</a> ()
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052   MPI_Datatype packed_node_type;
<a name="l00053"></a>00053   MPI_Datatype types[] = { MPI_UNSIGNED, MPI_REAL };
<a name="l00054"></a>00054   <span class="keywordtype">int</span> blocklengths[] = { 2, 3 };
<a name="l00055"></a>00055   MPI_Aint displs[2];
<a name="l00056"></a>00056   
<a name="l00057"></a>00057   <span class="comment">// create a Packed node and get the addresses of the elements.</span>
<a name="l00058"></a>00058   <span class="comment">// this will properly handle id/pid getting padded, for example,</span>
<a name="l00059"></a>00059   <span class="comment">// in which case id and x may not be 2*sizeof(unsigned int) apart.</span>
<a name="l00060"></a>00060   <a class="code" href="structNode_1_1PackedNode.php">Node::PackedNode</a> pn;
<a name="l00061"></a>00061   
<a name="l00062"></a>00062   MPI_Address (&amp;pn.<a class="code" href="structNode_1_1PackedNode.php#af2edf0e2a43b86b35fbf2ac15bdba9ce">id</a>, &amp;displs[0]);
<a name="l00063"></a>00063   MPI_Address (&amp;pn.<a class="code" href="structNode_1_1PackedNode.php#a749a213444088d24960189da8a5bb765">x</a>,  &amp;displs[1]);
<a name="l00064"></a>00064   displs[1] -= displs[0];
<a name="l00065"></a>00065   displs[0] = 0;
<a name="l00066"></a>00066   
<a name="l00067"></a>00067 <span class="preprocessor">#if MPI_VERSION &gt; 1</span>
<a name="l00068"></a>00068 <span class="preprocessor"></span>  MPI_Type_create_struct (2, blocklengths, displs, types, &amp;packed_node_type);
<a name="l00069"></a>00069 <span class="preprocessor">#else</span>
<a name="l00070"></a>00070 <span class="preprocessor"></span>  MPI_Type_struct (2, blocklengths, displs, types, &amp;packed_node_type);
<a name="l00071"></a>00071 <span class="preprocessor">#endif // #if MPI_VERSION &gt; 1</span>
<a name="l00072"></a>00072 <span class="preprocessor"></span>
<a name="l00073"></a>00073   <span class="keywordflow">return</span> packed_node_type;
<a name="l00074"></a>00074 }
<a name="l00075"></a>00075 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_MPI</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
