<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>node.h</h1>  </div>
</div>
<div class="contents">
<a href="node_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: node.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __node_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __node_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="point_8h.php">point.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;dof_object.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;reference_counted_object.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;auto_ptr.h&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// forward declarations</span>
<a name="l00035"></a>00035 <span class="keyword">class </span><a class="code" href="classNode.php">Node</a>;
<a name="l00036"></a>00036 <span class="keyword">class </span><a class="code" href="classMeshRefinement.php">MeshRefinement</a>;
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00051"></a><a class="code" href="classNode.php">00051</a> <span class="keyword">class </span><a class="code" href="classNode.php">Node</a> : <span class="keyword">public</span> <a class="code" href="classPoint.php">Point</a>,
<a name="l00052"></a>00052              <span class="keyword">public</span> <a class="code" href="classDofObject.php">DofObject</a>,      
<a name="l00053"></a>00053              <span class="keyword">public</span> <a class="code" href="classReferenceCountedObject.php">ReferenceCountedObject</a>&lt;Node&gt;
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055   
<a name="l00056"></a>00056 <span class="keyword">public</span>:
<a name="l00057"></a>00057   
<a name="l00062"></a>00062   <a class="code" href="classNode.php#ae7707d9bd9054993f9a04c28453cdcdb">Node</a>  (<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> x,
<a name="l00063"></a>00063          <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> y,
<a name="l00064"></a>00064          <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> z,
<a name="l00065"></a>00065          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span> = <a class="code" href="classDofObject.php#a35a5c88688334a8a3b8f0ff45105fb36">invalid_id</a>);
<a name="l00066"></a>00066 
<a name="l00070"></a>00070   <a class="code" href="classNode.php#ae7707d9bd9054993f9a04c28453cdcdb">Node</a> (<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>&amp; n);
<a name="l00071"></a>00071 
<a name="l00075"></a>00075   <span class="keyword">explicit</span> <a class="code" href="classNode.php#ae7707d9bd9054993f9a04c28453cdcdb">Node</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00076"></a>00076                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span> = <a class="code" href="classDofObject.php#a35a5c88688334a8a3b8f0ff45105fb36">invalid_id</a>);
<a name="l00077"></a>00077 
<a name="l00081"></a>00081   <span class="keyword">virtual</span> <a class="code" href="classNode.php#aa0840c3cb5c7159be6d992adecd2097c">~Node</a> ();
<a name="l00082"></a>00082 
<a name="l00086"></a>00086   <a class="code" href="classNode.php">Node</a>&amp; <a class="code" href="classNode.php#abbf7640ded33b62ca31739bc0f4f340f">operator= </a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p);
<a name="l00087"></a>00087   
<a name="l00092"></a>00092   <span class="keyword">static</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Node&gt;</a> <a class="code" href="classNode.php#aa6175b07d8a78dc554bb0f9f4727b02e">build</a> (<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>&amp; n);
<a name="l00093"></a>00093 
<a name="l00098"></a>00098   <span class="keyword">static</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Node&gt;</a> <a class="code" href="classNode.php#aa6175b07d8a78dc554bb0f9f4727b02e">build</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00099"></a>00099                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>);
<a name="l00100"></a>00100   
<a name="l00105"></a>00105   <span class="keyword">static</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Node&gt;</a> <a class="code" href="classNode.php#aa6175b07d8a78dc554bb0f9f4727b02e">build</a> (<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> x,
<a name="l00106"></a>00106                               <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> y,
<a name="l00107"></a>00107                               <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> z,
<a name="l00108"></a>00108                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>);
<a name="l00109"></a>00109 
<a name="l00116"></a>00116   <span class="keywordtype">bool</span> <a class="code" href="classNode.php#aeae09fc5539347eee78119cdf4eaef53">active</a> () <span class="keyword">const</span>;
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00124"></a>00124   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classNode.php#ade382579e87c4393961f9ea5f4fa2abf">operator==</a>(<span class="keyword">const</span> <a class="code" href="classDofObject.php">DofObject</a>&amp; rhs) <span class="keyword">const</span>;
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00128"></a>00128 <span class="preprocessor"></span>
<a name="l00136"></a><a class="code" href="structNode_1_1PackedNode.php">00136</a>   <span class="keyword">struct </span><a class="code" href="structNode_1_1PackedNode.php">PackedNode</a>
<a name="l00137"></a>00137   {
<a name="l00138"></a><a class="code" href="structNode_1_1PackedNode.php#af2edf0e2a43b86b35fbf2ac15bdba9ce">00138</a>     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="structNode_1_1PackedNode.php#af2edf0e2a43b86b35fbf2ac15bdba9ce">id</a>;
<a name="l00139"></a><a class="code" href="structNode_1_1PackedNode.php#a7c06f9c5034d61a3fa1e1d2214a7dae8">00139</a>     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="structNode_1_1PackedNode.php#a7c06f9c5034d61a3fa1e1d2214a7dae8">pid</a>;
<a name="l00140"></a><a class="code" href="structNode_1_1PackedNode.php#a749a213444088d24960189da8a5bb765">00140</a>     <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="structNode_1_1PackedNode.php#a749a213444088d24960189da8a5bb765">x</a>;
<a name="l00141"></a><a class="code" href="structNode_1_1PackedNode.php#a8b9ca5bf369f4ef7040c4fde986cb0a8">00141</a>     <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="structNode_1_1PackedNode.php#a8b9ca5bf369f4ef7040c4fde986cb0a8">y</a>;
<a name="l00142"></a><a class="code" href="structNode_1_1PackedNode.php#afb23ca1cb2f15f6d8297b6b29d825bd6">00142</a>     <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="structNode_1_1PackedNode.php#afb23ca1cb2f15f6d8297b6b29d825bd6">z</a>;
<a name="l00143"></a>00143 
<a name="l00144"></a><a class="code" href="structNode_1_1PackedNode.php#a866baf0053660f7a16bc0a644efa9c86">00144</a>     <a class="code" href="structNode_1_1PackedNode.php#a866baf0053660f7a16bc0a644efa9c86">PackedNode</a> () :
<a name="l00145"></a>00145       id(0),
<a name="l00146"></a>00146       x(0.),
<a name="l00147"></a>00147       y(0.),
<a name="l00148"></a>00148       z(0.)
<a name="l00149"></a>00149     {}
<a name="l00150"></a>00150 
<a name="l00151"></a><a class="code" href="structNode_1_1PackedNode.php#a820399684d473c861fa45198902b4929">00151</a>     <a class="code" href="structNode_1_1PackedNode.php#a866baf0053660f7a16bc0a644efa9c86">PackedNode</a> (<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a> &amp;node) :
<a name="l00152"></a>00152       id(node.id()),
<a name="l00153"></a>00153       <a class="code" href="structNode_1_1PackedNode.php#a7c06f9c5034d61a3fa1e1d2214a7dae8">pid</a>(node.<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>()),
<a name="l00154"></a>00154       x(node(0)),
<a name="l00155"></a>00155       y(node(1)),
<a name="l00156"></a>00156       z(node(2))
<a name="l00157"></a>00157     {}
<a name="l00158"></a>00158 
<a name="l00159"></a><a class="code" href="structNode_1_1PackedNode.php#a2a535a521af047577146c7b621e52de1">00159</a>     <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Node&gt;</a> <a class="code" href="structNode_1_1PackedNode.php#a2a535a521af047577146c7b621e52de1">build_node</a> ()<span class="keyword"> const</span>
<a name="l00160"></a>00160 <span class="keyword">    </span>{
<a name="l00161"></a>00161       <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Node&gt;</a> node(<span class="keyword">new</span> <a class="code" href="classNode.php#ae7707d9bd9054993f9a04c28453cdcdb">Node</a>(x,y,z,<span class="keywordtype">id</span>));
<a name="l00162"></a>00162       node-&gt;processor_id() = <a class="code" href="structNode_1_1PackedNode.php#a7c06f9c5034d61a3fa1e1d2214a7dae8">pid</a>;
<a name="l00163"></a>00163       <span class="keywordflow">return</span> node;
<a name="l00164"></a>00164     }
<a name="l00165"></a>00165 
<a name="l00166"></a><a class="code" href="structNode_1_1PackedNode.php#ae042f72add0ec1bdaa752ba1f2d2c9e5">00166</a>     <a class="code" href="classPoint.php">Point</a> <a class="code" href="structNode_1_1PackedNode.php#ae042f72add0ec1bdaa752ba1f2d2c9e5">build_point</a> ()<span class="keyword"> const</span>
<a name="l00167"></a>00167 <span class="keyword">    </span>{
<a name="l00168"></a>00168       <span class="keywordflow">return</span> <a class="code" href="classPoint.php#a0f6c9376314a8c1bc47e33e2b87483fc">Point</a>(x,y,z);
<a name="l00169"></a>00169     }
<a name="l00170"></a>00170     
<a name="l00171"></a>00171     <span class="keyword">static</span> MPI_Datatype <a class="code" href="structNode_1_1PackedNode.php#aa8d2df259c60b02a82fa80fa60326acf">create_mpi_datatype</a> ();
<a name="l00172"></a>00172     
<a name="l00173"></a>00173   };
<a name="l00174"></a>00174 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_MPI</span>
<a name="l00175"></a>00175 <span class="preprocessor"></span>  
<a name="l00176"></a>00176 <span class="keyword">private</span>:
<a name="l00177"></a>00177 
<a name="l00182"></a><a class="code" href="classNode.php#a7eb42a58c387442456965deba0fd97fd">00182</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classMeshRefinement.php">MeshRefinement</a>;
<a name="l00183"></a><a class="code" href="classNode.php#ad1b9b5ac435c80adb1c05c0f811aa841">00183</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00184"></a>00184 };
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 <span class="comment">//------------------------------------------------------</span>
<a name="l00189"></a>00189 <span class="comment">// Inline functions</span>
<a name="l00190"></a>00190 <span class="keyword">inline</span>
<a name="l00191"></a><a class="code" href="classNode.php#ae7707d9bd9054993f9a04c28453cdcdb">00191</a> <a class="code" href="classNode.php#ae7707d9bd9054993f9a04c28453cdcdb">Node::Node</a> (<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> x,
<a name="l00192"></a>00192             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> y,
<a name="l00193"></a>00193             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> z,
<a name="l00194"></a>00194             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>) :
<a name="l00195"></a>00195   <a class="code" href="classPoint.php">Point</a>(x,y,z)
<a name="l00196"></a>00196 {
<a name="l00197"></a>00197   this-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a>() = <a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>;
<a name="l00198"></a>00198 }
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 <span class="keyword">inline</span>
<a name="l00203"></a><a class="code" href="classNode.php#a277918b68827f6ffd8150f450b0c12c3">00203</a> <a class="code" href="classNode.php#ae7707d9bd9054993f9a04c28453cdcdb">Node::Node</a> (<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>&amp; n) :
<a name="l00204"></a>00204   <a class="code" href="classPoint.php">Point</a>(n),
<a name="l00205"></a>00205   <a class="code" href="classDofObject.php">DofObject</a>(n),
<a name="l00206"></a>00206   <a class="code" href="classReferenceCountedObject.php">ReferenceCountedObject</a>&lt;<a class="code" href="classNode.php">Node</a>&gt;()
<a name="l00207"></a>00207 {
<a name="l00208"></a>00208 }
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 <span class="keyword">inline</span>
<a name="l00213"></a><a class="code" href="classNode.php#a2a34bd4dfdeb98636c044432c53f8af9">00213</a> <a class="code" href="classNode.php#ae7707d9bd9054993f9a04c28453cdcdb">Node::Node</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00214"></a>00214             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>) :
<a name="l00215"></a>00215   <a class="code" href="classPoint.php">Point</a>(p)
<a name="l00216"></a>00216 {
<a name="l00217"></a>00217   <span class="comment">// optionally assign the id.  We have</span>
<a name="l00218"></a>00218   <span class="comment">// to do it like this otherwise</span>
<a name="l00219"></a>00219   <span class="comment">// Node n = Point p would erase</span>
<a name="l00220"></a>00220   <span class="comment">// the id!</span>
<a name="l00221"></a>00221   <span class="keywordflow">if</span> (<span class="keywordtype">id</span> != <a class="code" href="classDofObject.php#a35a5c88688334a8a3b8f0ff45105fb36">invalid_id</a>)
<a name="l00222"></a>00222     this-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a>() = <a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>;
<a name="l00223"></a>00223 }
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 <span class="keyword">inline</span>
<a name="l00228"></a><a class="code" href="classNode.php#aa0840c3cb5c7159be6d992adecd2097c">00228</a> <a class="code" href="classNode.php#aa0840c3cb5c7159be6d992adecd2097c">Node::~Node</a> ()
<a name="l00229"></a>00229 {
<a name="l00230"></a>00230 }
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 <span class="keyword">inline</span>
<a name="l00235"></a><a class="code" href="classNode.php#abbf7640ded33b62ca31739bc0f4f340f">00235</a> <a class="code" href="classNode.php">Node</a> &amp; <a class="code" href="classNode.php#abbf7640ded33b62ca31739bc0f4f340f">Node::operator= </a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p)
<a name="l00236"></a>00236 {
<a name="l00237"></a>00237   (*this)(0) = p(0);
<a name="l00238"></a>00238   (*this)(1) = p(1);
<a name="l00239"></a>00239   (*this)(2) = p(2);
<a name="l00240"></a>00240 
<a name="l00241"></a>00241   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00242"></a>00242 }
<a name="l00243"></a>00243 
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 <span class="keyword">inline</span>
<a name="l00247"></a><a class="code" href="classNode.php#aa6175b07d8a78dc554bb0f9f4727b02e">00247</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Node&gt;</a> <a class="code" href="classNode.php#aa6175b07d8a78dc554bb0f9f4727b02e">Node::build</a>(<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>&amp; n)
<a name="l00248"></a>00248 {
<a name="l00249"></a>00249   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Node&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classNode.php#ae7707d9bd9054993f9a04c28453cdcdb">Node</a>(n));
<a name="l00250"></a>00250   <span class="keywordflow">return</span> ap;
<a name="l00251"></a>00251 }
<a name="l00252"></a>00252 
<a name="l00253"></a>00253 
<a name="l00254"></a>00254 
<a name="l00255"></a>00255 <span class="keyword">inline</span>
<a name="l00256"></a><a class="code" href="classNode.php#a1911e9738e4ecd78ea0887a069a11894">00256</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Node&gt;</a> <a class="code" href="classNode.php#aa6175b07d8a78dc554bb0f9f4727b02e">Node::build</a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00257"></a>00257                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>)
<a name="l00258"></a>00258 {
<a name="l00259"></a>00259   
<a name="l00260"></a>00260   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Node&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classNode.php#ae7707d9bd9054993f9a04c28453cdcdb">Node</a>(p,<span class="keywordtype">id</span>));
<a name="l00261"></a>00261   <span class="keywordflow">return</span> ap;
<a name="l00262"></a>00262 }
<a name="l00263"></a>00263 
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 
<a name="l00266"></a>00266 <span class="keyword">inline</span>
<a name="l00267"></a><a class="code" href="classNode.php#a27d5aace0b7905d6ac9a87ca339e5313">00267</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Node&gt;</a> <a class="code" href="classNode.php#aa6175b07d8a78dc554bb0f9f4727b02e">Node::build</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> x,
<a name="l00268"></a>00268                           <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> y,
<a name="l00269"></a>00269                           <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> z,
<a name="l00270"></a>00270                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>)
<a name="l00271"></a>00271 {
<a name="l00272"></a>00272   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Node&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classNode.php#ae7707d9bd9054993f9a04c28453cdcdb">Node</a>(x,y,z,<span class="keywordtype">id</span>));
<a name="l00273"></a>00273   <span class="keywordflow">return</span> ap;
<a name="l00274"></a>00274 }
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 
<a name="l00278"></a>00278 <span class="keyword">inline</span>
<a name="l00279"></a><a class="code" href="classNode.php#aeae09fc5539347eee78119cdf4eaef53">00279</a> <span class="keywordtype">bool</span> <a class="code" href="classNode.php#aeae09fc5539347eee78119cdf4eaef53">Node::active</a> ()<span class="keyword"> const</span>
<a name="l00280"></a>00280 <span class="keyword"></span>{
<a name="l00281"></a>00281   <span class="keywordflow">return</span> (this-&gt;<span class="keywordtype">id</span>() != <a class="code" href="classDofObject.php#a35a5c88688334a8a3b8f0ff45105fb36">Node::invalid_id</a>);
<a name="l00282"></a>00282 }
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 
<a name="l00285"></a>00285 
<a name="l00286"></a>00286 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
