<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>node_elem.h</h1>  </div>
</div>
<div class="contents">
<a href="node__elem_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: node_elem.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __node_elem_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __node_elem_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Forward declarations</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00039"></a>00039 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00040"></a>00040 <span class="comment">// NodeElem class definition</span>
<a name="l00041"></a><a class="code" href="classNodeElem.php">00041</a> <span class="keyword">class </span><a class="code" href="classNodeElem.php">NodeElem</a> : <span class="keyword">public</span> <a class="code" href="classElem.php">Elem</a>
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043  <span class="keyword">public</span>:
<a name="l00044"></a>00044 
<a name="l00048"></a><a class="code" href="classNodeElem.php#a153b1c58d565e116b57ef9d84e1b08a0">00048</a>   <a class="code" href="classNodeElem.php#a153b1c58d565e116b57ef9d84e1b08a0">NodeElem</a> (<a class="code" href="classElem.php">Elem</a>* p=NULL) :
<a name="l00049"></a>00049     <a class="code" href="classElem.php">Elem</a>(<a class="code" href="classNodeElem.php">NodeElem</a>::<a class="code" href="classNodeElem.php#a0da4e0833acb405e217412d9d565bd7b">n_nodes</a>(), <a class="code" href="classNodeElem.php">NodeElem</a>::<a class="code" href="classNodeElem.php#ac1f21442323ee265603aaffe1420ebfb">n_sides</a>(), p) {}
<a name="l00050"></a>00050 
<a name="l00055"></a><a class="code" href="classNodeElem.php#a5eb5b357fa10909359ec49cf6bc83a1c">00055</a>   <a class="code" href="classNodeElem.php#a153b1c58d565e116b57ef9d84e1b08a0">NodeElem</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00056"></a>00056          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00057"></a>00057          <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00058"></a>00058     <a class="code" href="classElem.php">Elem</a>(nn, ns, p) { libmesh_assert(nn == 1); libmesh_assert (ns == 0); }
<a name="l00059"></a>00059 
<a name="l00064"></a><a class="code" href="classNodeElem.php#a2396c74b8f65ff39b86895163df99e95">00064</a>   <a class="code" href="classNodeElem.php#a153b1c58d565e116b57ef9d84e1b08a0">NodeElem</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00065"></a>00065         <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00066"></a>00066     <a class="code" href="classElem.php">Elem</a>(nn, <a class="code" href="classNodeElem.php">NodeElem</a>::<a class="code" href="classNodeElem.php#ac1f21442323ee265603aaffe1420ebfb">n_sides</a>(), p) {}
<a name="l00067"></a>00067    
<a name="l00071"></a><a class="code" href="classNodeElem.php#a7291457de56228af3975cef180ca4e05">00071</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classNodeElem.php#a7291457de56228af3975cef180ca4e05">dim</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; }
<a name="l00072"></a>00072   
<a name="l00076"></a><a class="code" href="classNodeElem.php#a0da4e0833acb405e217412d9d565bd7b">00076</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classNodeElem.php#a0da4e0833acb405e217412d9d565bd7b">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00077"></a>00077 
<a name="l00081"></a><a class="code" href="classNodeElem.php#ac1f21442323ee265603aaffe1420ebfb">00081</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classNodeElem.php#ac1f21442323ee265603aaffe1420ebfb">n_sides</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; }
<a name="l00082"></a>00082 
<a name="l00086"></a><a class="code" href="classNodeElem.php#addb67e6b874df8cd80081adee3ad0518">00086</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classNodeElem.php#addb67e6b874df8cd80081adee3ad0518">n_vertices</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00087"></a>00087   
<a name="l00091"></a><a class="code" href="classNodeElem.php#a6749592bbedb2368d710d0057b4b2403">00091</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classNodeElem.php#a6749592bbedb2368d710d0057b4b2403">n_edges</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; }
<a name="l00092"></a>00092   
<a name="l00096"></a><a class="code" href="classNodeElem.php#a15862b0b1fa0a4d2dac1ac5eaef476dd">00096</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classNodeElem.php#a15862b0b1fa0a4d2dac1ac5eaef476dd">n_faces</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; }
<a name="l00097"></a>00097   
<a name="l00101"></a><a class="code" href="classNodeElem.php#a0618e09e0b107b6e918907d4fd620fee">00101</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classNodeElem.php#a0618e09e0b107b6e918907d4fd620fee">n_children</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00102"></a>00102 
<a name="l00107"></a><a class="code" href="classNodeElem.php#a41edecca46b4505a53858a76c2e4dacd">00107</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classNodeElem.php#a41edecca46b4505a53858a76c2e4dacd">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00108"></a>00108 <span class="keyword">  </span>{ <span class="keywordflow">return</span> 0; }
<a name="l00109"></a>00109   
<a name="l00113"></a><a class="code" href="classNodeElem.php#adeefc12f4268b8511d1738a63509ad82">00113</a>   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> <a class="code" href="classNodeElem.php#adeefc12f4268b8511d1738a63509ad82">side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00114"></a>00114 <span class="keyword">  </span>{ libmesh_error(); <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> ap(NULL); <span class="keywordflow">return</span> ap; }
<a name="l00115"></a>00115 
<a name="l00119"></a><a class="code" href="classNodeElem.php#a5e3103c741c2f8b6c0b4eb9cf62ceb67">00119</a>   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classNodeElem.php#a5e3103c741c2f8b6c0b4eb9cf62ceb67">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <span class="keywordtype">bool</span>)<span class="keyword"> const</span>
<a name="l00120"></a>00120 <span class="keyword">  </span>{ libmesh_error(); <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(NULL); <span class="keywordflow">return</span> ap; }
<a name="l00121"></a>00121 
<a name="l00125"></a><a class="code" href="classNodeElem.php#ad29e18cd0373b4e65c9bb585a3c3371d">00125</a>   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classNodeElem.php#ad29e18cd0373b4e65c9bb585a3c3371d">build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00126"></a>00126 <span class="keyword">  </span>{ libmesh_error(); <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(NULL); <span class="keywordflow">return</span> ap; }
<a name="l00127"></a>00127 
<a name="l00131"></a><a class="code" href="classNodeElem.php#afb583b3f874bd685d458c86e9482d301">00131</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classNodeElem.php#afb583b3f874bd685d458c86e9482d301">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00132"></a>00132   
<a name="l00136"></a><a class="code" href="classNodeElem.php#ab04f70540dfb13b623841cf4fe17bfb1">00136</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classNodeElem.php#ab04f70540dfb13b623841cf4fe17bfb1">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00137"></a>00137 
<a name="l00141"></a><a class="code" href="classNodeElem.php#a06718ef5787c03729d36a4cfb4dfdc43">00141</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classNodeElem.php#a06718ef5787c03729d36a4cfb4dfdc43">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00142"></a>00142 
<a name="l00143"></a><a class="code" href="classNodeElem.php#a965630bb9a176d54b95aa324fa9b136c">00143</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classNodeElem.php#a965630bb9a176d54b95aa324fa9b136c">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00144"></a>00144   
<a name="l00145"></a><a class="code" href="classNodeElem.php#aa1c65b7a338bae52a55353d7c4caf577">00145</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classNodeElem.php#aa1c65b7a338bae52a55353d7c4caf577">is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00146"></a>00146                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00147"></a>00147 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00148"></a>00148   
<a name="l00149"></a><a class="code" href="classNodeElem.php#a575044efc5eea148e23725e0b4ecb7cd">00149</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classNodeElem.php#a575044efc5eea148e23725e0b4ecb7cd">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00150"></a>00150                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00151"></a>00151 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00152"></a>00152   
<a name="l00153"></a><a class="code" href="classNodeElem.php#a34a63fced04f2b03733c71b4acec37c8">00153</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classNodeElem.php#a34a63fced04f2b03733c71b4acec37c8">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00154"></a>00154                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const </span>
<a name="l00155"></a>00155 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00156"></a>00156   
<a name="l00157"></a>00157   <span class="comment">/*</span>
<a name="l00158"></a>00158 <span class="comment">   * @returns true iff the element map is definitely affine within</span>
<a name="l00159"></a>00159 <span class="comment">   * numerical tolerances</span>
<a name="l00160"></a>00160 <span class="comment">   */</span>
<a name="l00161"></a><a class="code" href="classNodeElem.php#a2dae02f02478601af247efaa8fb193cf">00161</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classNodeElem.php#a2dae02f02478601af247efaa8fb193cf">has_affine_map</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00162"></a>00162 
<a name="l00166"></a><a class="code" href="classNodeElem.php#aa9c072c132513d538d7c7fde7bd63816">00166</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classNodeElem.php#aa9c072c132513d538d7c7fde7bd63816">type</a>()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>; }
<a name="l00167"></a>00167   
<a name="l00171"></a><a class="code" href="classNodeElem.php#a063f911411f5cda139b5113f48d41605">00171</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classNodeElem.php#a063f911411f5cda139b5113f48d41605">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>; }
<a name="l00172"></a>00172 
<a name="l00173"></a>00173   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNodeElem.php#a1ec3e6d67039b3424e99737678136536">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00174"></a>00174                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00175"></a>00175                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00179"></a>00179 <span class="preprocessor"></span>
<a name="l00183"></a><a class="code" href="classNodeElem.php#a22cc21b2b1e9871f29d61b2cd8aeef6c">00183</a>   <span class="keywordtype">bool</span> <a class="code" href="classNodeElem.php#a22cc21b2b1e9871f29d61b2cd8aeef6c">infinite</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 <span class="preprocessor">#endif</span>
<a name="l00186"></a>00186 <span class="preprocessor"></span>
<a name="l00187"></a>00187   
<a name="l00188"></a>00188 <span class="keyword">protected</span>:
<a name="l00189"></a>00189 
<a name="l00190"></a>00190   
<a name="l00191"></a>00191 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00192"></a>00192 <span class="preprocessor"></span>
<a name="l00196"></a><a class="code" href="classNodeElem.php#a84ae6274acd1f153b8a2540e01b1e275">00196</a>   <span class="keywordtype">float</span> <a class="code" href="classNodeElem.php#a84ae6274acd1f153b8a2540e01b1e275">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00197"></a>00197                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00198"></a>00198                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00199"></a>00199 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classNodeElem.php#aa0e3d4da6c6b9566ac3b8294263d5bd8">_embedding_matrix</a>[i][j][k]; }
<a name="l00200"></a>00200   
<a name="l00205"></a><a class="code" href="classNodeElem.php#aa0e3d4da6c6b9566ac3b8294263d5bd8">00205</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classNodeElem.php#aa0e3d4da6c6b9566ac3b8294263d5bd8">_embedding_matrix</a>[1][1][1];
<a name="l00206"></a>00206   
<a name="l00210"></a><a class="code" href="classNodeElem.php#ada705cf5717cc9c83f0a5ab0ee4afc82">00210</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classNodeElem.php#ada705cf5717cc9c83f0a5ab0ee4afc82">side_children_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, 
<a name="l00211"></a>00211                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00212"></a>00212 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> 0; }
<a name="l00213"></a>00213 
<a name="l00214"></a>00214 <span class="preprocessor">#endif</span>
<a name="l00215"></a>00215 <span class="preprocessor"></span>  
<a name="l00216"></a>00216 };
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 
<a name="l00220"></a>00220 
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00223"></a>00223 <span class="comment">// NodeElem class member functions</span>
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
