<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>nonlinear.h</h1>  </div>
</div>
<div class="contents">
<a href="nonlinear_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: nonlinear.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __nonlinear_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __nonlinear_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="linear_8h.php">linear.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00040"></a>00040 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00041"></a>00041 <span class="comment">// Nonlinear class definition</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T = Linear&lt;&gt; &gt;
<a name="l00044"></a><a class="code" href="classNonlinear.php">00044</a> <span class="keyword">class </span><a class="code" href="classNonlinear.php">Nonlinear</a> : <span class="keyword">public</span> T
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046 <span class="keyword">public</span>:
<a name="l00047"></a>00047   
<a name="l00051"></a>00051   <a class="code" href="classNonlinear.php#a57147b4d5eab9bc9522bc2c93289ebfe">Nonlinear</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es);
<a name="l00052"></a>00052 
<a name="l00056"></a>00056   <a class="code" href="classNonlinear.php#a57147b4d5eab9bc9522bc2c93289ebfe">Nonlinear</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00057"></a>00057              <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00058"></a>00058              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number);
<a name="l00059"></a>00059 
<a name="l00063"></a>00063   <a class="code" href="classNonlinear.php#adf3dc4fe98bdb7db5064ef30c28e5425">~Nonlinear</a> ();
<a name="l00064"></a>00064 
<a name="l00069"></a>00069   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNonlinear.php#a5ad2d015ff3340702dd41615f7da2f48">solve</a> ();
<a name="l00070"></a>00070 
<a name="l00074"></a><a class="code" href="classNonlinear.php#ac1eca877e4ce6672a25248a21104a8f6">00074</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classNonlinear.php#ac1eca877e4ce6672a25248a21104a8f6">max_nonlinear_steps</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classNonlinear.php#acc27b38c823692508046d2c8fe321480">_max_nl_steps</a>; }
<a name="l00075"></a>00075 
<a name="l00079"></a><a class="code" href="classNonlinear.php#a5f7de9f9183660d2d162b850ec1e87c2">00079</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp; <a class="code" href="classNonlinear.php#a5f7de9f9183660d2d162b850ec1e87c2">max_nonlinear_steps</a> () { <span class="keywordflow">return</span> <a class="code" href="classNonlinear.php#acc27b38c823692508046d2c8fe321480">_max_nl_steps</a>; }
<a name="l00080"></a>00080 
<a name="l00084"></a><a class="code" href="classNonlinear.php#a40dd8538ab05abbc310a50f0be81340e">00084</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNonlinear.php#a40dd8538ab05abbc310a50f0be81340e">nonlinear_tolerance</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classNonlinear.php#ae1f2977ba38755ab4f769bdbd89a62e4">_nl_tol</a>; }
<a name="l00085"></a>00085 
<a name="l00089"></a><a class="code" href="classNonlinear.php#a91d7b370f004e850135b1049da0403ed">00089</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> &amp; <a class="code" href="classNonlinear.php#a91d7b370f004e850135b1049da0403ed">nonlinear_tolerance</a> () { <span class="keywordflow">return</span> <a class="code" href="classNonlinear.php#ae1f2977ba38755ab4f769bdbd89a62e4">_nl_tol</a>; }
<a name="l00090"></a>00090 
<a name="l00091"></a>00091   
<a name="l00092"></a>00092 <span class="keyword">private</span>:
<a name="l00093"></a>00093 
<a name="l00097"></a><a class="code" href="classNonlinear.php#acc27b38c823692508046d2c8fe321480">00097</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classNonlinear.php#acc27b38c823692508046d2c8fe321480">_max_nl_steps</a>;
<a name="l00098"></a>00098 
<a name="l00102"></a><a class="code" href="classNonlinear.php#ae1f2977ba38755ab4f769bdbd89a62e4">00102</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNonlinear.php#ae1f2977ba38755ab4f769bdbd89a62e4">_nl_tol</a>;
<a name="l00103"></a>00103 };
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00108"></a>00108 <span class="comment">// Nonlinear inline members</span>
<a name="l00109"></a>00109 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00110"></a>00110 <span class="keyword">inline</span>
<a name="l00111"></a><a class="code" href="classNonlinear.php#a57147b4d5eab9bc9522bc2c93289ebfe">00111</a> <a class="code" href="classNonlinear.php#a57147b4d5eab9bc9522bc2c93289ebfe">Nonlinear&lt;T&gt;::Nonlinear</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es) :
<a name="l00112"></a>00112   T             (es),  <span class="comment">// Call the base class constructor</span>
<a name="l00113"></a>00113   _max_nl_steps (5),   <span class="comment">// Default solver attributes</span>
<a name="l00114"></a>00114   _nl_tol       (1.e-6)
<a name="l00115"></a>00115 {
<a name="l00116"></a>00116 }
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00121"></a>00121 <span class="keyword">inline</span>
<a name="l00122"></a><a class="code" href="classNonlinear.php#afaf6a277066a537caf68930fd884aa15">00122</a> <a class="code" href="classNonlinear.php#a57147b4d5eab9bc9522bc2c93289ebfe">Nonlinear&lt;T&gt;::Nonlinear</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00123"></a>00123                          <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00124"></a>00124                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :
<a name="l00125"></a>00125   <a class="code" href="classNonlinear.php">Nonlinear</a> (es),
<a name="l00126"></a>00126   T         (es, name, number)  <span class="comment">// Call the base class constructor</span>
<a name="l00127"></a>00127 {
<a name="l00128"></a>00128 }
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00133"></a>00133 <span class="keyword">inline</span>
<a name="l00134"></a><a class="code" href="classNonlinear.php#adf3dc4fe98bdb7db5064ef30c28e5425">00134</a> <a class="code" href="classNonlinear.php#adf3dc4fe98bdb7db5064ef30c28e5425">Nonlinear&lt;T&gt;::~Nonlinear</a> ()
<a name="l00135"></a>00135 {
<a name="l00136"></a>00136 }
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00141"></a>00141 <span class="keyword">inline</span>
<a name="l00142"></a><a class="code" href="classNonlinear.php#a5ad2d015ff3340702dd41615f7da2f48">00142</a> <span class="keywordtype">void</span> <a class="code" href="classNonlinear.php#a5ad2d015ff3340702dd41615f7da2f48">Nonlinear&lt;T&gt;::solve</a> ()
<a name="l00143"></a>00143 {
<a name="l00144"></a>00144   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l&lt;this-&gt;max_nonlinear_steps(); l++)
<a name="l00145"></a>00145     {
<a name="l00146"></a>00146       <span class="comment">// Get a copy of the solution at the current nonlinear</span>
<a name="l00147"></a>00147       <span class="comment">// iteration</span>
<a name="l00148"></a>00148       <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt;
<a name="l00149"></a>00149         last_nonlinear_soln (this-&gt;system().solution-&gt;clone());
<a name="l00150"></a>00150       
<a name="l00151"></a>00151       <span class="comment">// Call the base class solver</span>
<a name="l00152"></a>00152       T::solve ();
<a name="l00153"></a>00153 
<a name="l00154"></a>00154       <span class="comment">// Compute the difference between this solution</span>
<a name="l00155"></a>00155       <span class="comment">// and the last iterate</span>
<a name="l00156"></a>00156       last_nonlinear_soln-&gt;add (-1., *(this-&gt;system().solution));
<a name="l00157"></a>00157 
<a name="l00158"></a>00158       <span class="comment">// We must close the vector before we ask it for its norm</span>
<a name="l00159"></a>00159       last_nonlinear_soln-&gt;close();
<a name="l00160"></a>00160       
<a name="l00161"></a>00161       <span class="comment">// Compute the l2 norm of the difference</span>
<a name="l00162"></a>00162       <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> norm_delta = last_nonlinear_soln-&gt;l2_norm();
<a name="l00163"></a>00163 
<a name="l00164"></a>00164       <span class="comment">// Print out convergence information</span>
<a name="l00165"></a>00165       std::cout &lt;&lt; <span class="stringliteral">&quot;Nonlinear convergence: ||u - u_old|| = &quot;</span>
<a name="l00166"></a>00166                 &lt;&lt; norm_delta
<a name="l00167"></a>00167                 &lt;&lt; std::endl;
<a name="l00168"></a>00168 
<a name="l00169"></a>00169       <span class="comment">// Terminate the solution iteration if the difference between</span>
<a name="l00170"></a>00170       <span class="comment">// this iteration and the last is sufficiently small.</span>
<a name="l00171"></a>00171       <span class="keywordflow">if</span> (norm_delta &lt; this-&gt;nonlinear_tolerance())
<a name="l00172"></a>00172         {
<a name="l00173"></a>00173           std::cout &lt;&lt; <span class="stringliteral">&quot; Nonlinear solver converged at step &quot;</span>
<a name="l00174"></a>00174                     &lt;&lt; l
<a name="l00175"></a>00175                     &lt;&lt; std::endl;
<a name="l00176"></a>00176           <span class="keywordflow">break</span>;
<a name="l00177"></a>00177         }
<a name="l00178"></a>00178     }
<a name="l00179"></a>00179 }
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 <span class="preprocessor">#endif // #define __nonlinear_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
