<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_60be1125a39495b698d2d56e8e5b50b1.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>nonlinear_implicit_system.C</h1>  </div>
</div>
<div class="contents">
<a href="nonlinear__implicit__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: nonlinear_implicit_system.C 3502 2009-10-20 18:06:50Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;nonlinear_implicit_system.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;equation_systems.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;linear_solver.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;nonlinear_solver.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;sparse_matrix.h&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00034"></a>00034 <span class="comment">// NonlinearImplicitSystem implementation</span>
<a name="l00035"></a><a class="code" href="classNonlinearImplicitSystem.php#a5a484ef34b3cefcbd797963c60eac41f">00035</a> <a class="code" href="classNonlinearImplicitSystem.php#a5a484ef34b3cefcbd797963c60eac41f">NonlinearImplicitSystem::NonlinearImplicitSystem</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00036"></a>00036                                                   <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00037"></a>00037                                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :
<a name="l00038"></a>00038   
<a name="l00039"></a>00039   <a class="code" href="classSystem.php">Parent</a>                    (es, name, number),
<a name="l00040"></a>00040   nonlinear_solver          (<a class="code" href="classNonlinearSolver.php">NonlinearSolver</a>&lt;<a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>&gt;::build(*this)),
<a name="l00041"></a>00041   _n_nonlinear_iterations   (0),
<a name="l00042"></a>00042   _final_nonlinear_residual (1.e20)
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044   <span class="comment">// Set default parameters</span>
<a name="l00045"></a>00045   <span class="comment">// These were chosen to match the Petsc defaults</span>
<a name="l00046"></a>00046   es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;        (<span class="stringliteral">&quot;linear solver tolerance&quot;</span>) = 1e-5;
<a name="l00047"></a>00047   es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;        (<span class="stringliteral">&quot;linear solver minimum tolerance&quot;</span>) = 1e-5;
<a name="l00048"></a>00048   es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;linear solver maximum iterations&quot;</span>) = 10000;
<a name="l00049"></a>00049   
<a name="l00050"></a>00050   es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;nonlinear solver maximum iterations&quot;</span>) = 50;
<a name="l00051"></a>00051   es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;nonlinear solver maximum function evaluations&quot;</span>) = 10000;
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;nonlinear solver absolute residual tolerance&quot;</span>) = 1e-50;
<a name="l00054"></a>00054   es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;nonlinear solver relative residual tolerance&quot;</span>) = 1e-8;
<a name="l00055"></a>00055   es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;nonlinear solver absolute step tolerance&quot;</span>) = 1e-8;
<a name="l00056"></a>00056   es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">set</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;nonlinear solver relative step tolerance&quot;</span>) = 1e-8;
<a name="l00057"></a>00057 }
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 
<a name="l00061"></a><a class="code" href="classNonlinearImplicitSystem.php#aeded7e71ed420ae21876f032a295946a">00061</a> <a class="code" href="classNonlinearImplicitSystem.php#aeded7e71ed420ae21876f032a295946a">NonlinearImplicitSystem::~NonlinearImplicitSystem</a> ()
<a name="l00062"></a>00062 {
<a name="l00063"></a>00063   <span class="comment">// Clear data</span>
<a name="l00064"></a>00064   this-&gt;<a class="code" href="classNonlinearImplicitSystem.php#a0d44ef3c554b9051a06d5ed41a6479ac">clear</a>();
<a name="l00065"></a>00065 }
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00069"></a><a class="code" href="classNonlinearImplicitSystem.php#a0d44ef3c554b9051a06d5ed41a6479ac">00069</a> <span class="keywordtype">void</span> <a class="code" href="classNonlinearImplicitSystem.php#a0d44ef3c554b9051a06d5ed41a6479ac">NonlinearImplicitSystem::clear</a> ()
<a name="l00070"></a>00070 {
<a name="l00071"></a>00071   <span class="comment">// clear the nonlinear solver</span>
<a name="l00072"></a>00072   <a class="code" href="classNonlinearImplicitSystem.php#af53b1f85297d1b95e5ff6656a1be18f2">nonlinear_solver</a>-&gt;clear();
<a name="l00073"></a>00073   
<a name="l00074"></a>00074   <span class="comment">// clear the parent data</span>
<a name="l00075"></a>00075   <a class="code" href="classImplicitSystem.php#aaec0524bd164ab907129805835809f77">Parent::clear</a>();
<a name="l00076"></a>00076 }
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00080"></a><a class="code" href="classNonlinearImplicitSystem.php#a6e90e888c2a3786316d968a4d70f0a06">00080</a> <span class="keywordtype">void</span> <a class="code" href="classNonlinearImplicitSystem.php#a6e90e888c2a3786316d968a4d70f0a06">NonlinearImplicitSystem::reinit</a> ()
<a name="l00081"></a>00081 {
<a name="l00082"></a>00082   <span class="comment">// re-initialize the nonlinear solver interface</span>
<a name="l00083"></a>00083   <a class="code" href="classNonlinearImplicitSystem.php#af53b1f85297d1b95e5ff6656a1be18f2">nonlinear_solver</a>-&gt;clear();
<a name="l00084"></a>00084   
<a name="l00085"></a>00085   <span class="comment">// initialize parent data</span>
<a name="l00086"></a>00086   <a class="code" href="classImplicitSystem.php#a292ff27cdaef1d65974cad561ad1beed">Parent::reinit</a>();  
<a name="l00087"></a>00087 }
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 
<a name="l00091"></a><a class="code" href="classNonlinearImplicitSystem.php#a8ba78f3b6b910692f59eba070839086b">00091</a> <span class="keywordtype">void</span> <a class="code" href="classNonlinearImplicitSystem.php#a8ba78f3b6b910692f59eba070839086b">NonlinearImplicitSystem::set_solver_parameters</a> ()
<a name="l00092"></a>00092 {
<a name="l00093"></a>00093   <span class="comment">// Get a reference to the EquationSystems</span>
<a name="l00094"></a>00094   <span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es =
<a name="l00095"></a>00095     this-&gt;<a class="code" href="classSystem.php#a51da3ea6211cf1888377c9c4b1554232">get_equation_systems</a>();  
<a name="l00096"></a>00096   
<a name="l00097"></a>00097   <span class="comment">// Get the user-specifiied nonlinear solver tolerances</span>
<a name="l00098"></a>00098   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxits =
<a name="l00099"></a>00099     es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#ac4c5e3f411568e6defcdd2ace5829d96">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;nonlinear solver maximum iterations&quot;</span>);
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxfuncs =
<a name="l00102"></a>00102     es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#ac4c5e3f411568e6defcdd2ace5829d96">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;nonlinear solver maximum function evaluations&quot;</span>);
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> abs_resid_tol =
<a name="l00105"></a>00105     es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#ac4c5e3f411568e6defcdd2ace5829d96">get</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;nonlinear solver absolute residual tolerance&quot;</span>);
<a name="l00106"></a>00106 
<a name="l00107"></a>00107   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> rel_resid_tol =
<a name="l00108"></a>00108     es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#ac4c5e3f411568e6defcdd2ace5829d96">get</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;nonlinear solver relative residual tolerance&quot;</span>);
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> abs_step_tol =
<a name="l00111"></a>00111     es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#ac4c5e3f411568e6defcdd2ace5829d96">get</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;nonlinear solver absolute step tolerance&quot;</span>);
<a name="l00112"></a>00112 
<a name="l00113"></a>00113   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> rel_step_tol =
<a name="l00114"></a>00114     es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#ac4c5e3f411568e6defcdd2ace5829d96">get</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;nonlinear solver relative step tolerance&quot;</span>);
<a name="l00115"></a>00115 
<a name="l00116"></a>00116   <span class="comment">// Get the user-specified linear solver toleranaces</span>
<a name="l00117"></a>00117   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxlinearits =
<a name="l00118"></a>00118     es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#ac4c5e3f411568e6defcdd2ace5829d96">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;linear solver maximum iterations&quot;</span>);
<a name="l00119"></a>00119 
<a name="l00120"></a>00120   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> linear_tol =
<a name="l00121"></a>00121     es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#ac4c5e3f411568e6defcdd2ace5829d96">get</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;linear solver tolerance&quot;</span>);
<a name="l00122"></a>00122 
<a name="l00123"></a>00123   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> linear_min_tol =
<a name="l00124"></a>00124     es.<a class="code" href="classEquationSystems.php#a529c7657c05d543663da77032122bba0">parameters</a>.<a class="code" href="classParameters.php#ac4c5e3f411568e6defcdd2ace5829d96">get</a>&lt;<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&gt;(<span class="stringliteral">&quot;linear solver minimum tolerance&quot;</span>);
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   <span class="comment">// Set all the parameters on the NonlinearSolver</span>
<a name="l00127"></a>00127   <a class="code" href="classNonlinearImplicitSystem.php#af53b1f85297d1b95e5ff6656a1be18f2">nonlinear_solver</a>-&gt;max_nonlinear_iterations = maxits;
<a name="l00128"></a>00128   <a class="code" href="classNonlinearImplicitSystem.php#af53b1f85297d1b95e5ff6656a1be18f2">nonlinear_solver</a>-&gt;max_function_evaluations = maxfuncs;
<a name="l00129"></a>00129   <a class="code" href="classNonlinearImplicitSystem.php#af53b1f85297d1b95e5ff6656a1be18f2">nonlinear_solver</a>-&gt;absolute_residual_tolerance = abs_resid_tol;
<a name="l00130"></a>00130   <a class="code" href="classNonlinearImplicitSystem.php#af53b1f85297d1b95e5ff6656a1be18f2">nonlinear_solver</a>-&gt;relative_residual_tolerance = rel_resid_tol;
<a name="l00131"></a>00131   <a class="code" href="classNonlinearImplicitSystem.php#af53b1f85297d1b95e5ff6656a1be18f2">nonlinear_solver</a>-&gt;absolute_step_tolerance = abs_step_tol;
<a name="l00132"></a>00132   <a class="code" href="classNonlinearImplicitSystem.php#af53b1f85297d1b95e5ff6656a1be18f2">nonlinear_solver</a>-&gt;relative_step_tolerance = rel_step_tol;
<a name="l00133"></a>00133   <a class="code" href="classNonlinearImplicitSystem.php#af53b1f85297d1b95e5ff6656a1be18f2">nonlinear_solver</a>-&gt;max_linear_iterations = maxlinearits;
<a name="l00134"></a>00134   <a class="code" href="classNonlinearImplicitSystem.php#af53b1f85297d1b95e5ff6656a1be18f2">nonlinear_solver</a>-&gt;initial_linear_tolerance = linear_tol;
<a name="l00135"></a>00135   <a class="code" href="classNonlinearImplicitSystem.php#af53b1f85297d1b95e5ff6656a1be18f2">nonlinear_solver</a>-&gt;minimum_linear_tolerance = linear_min_tol;
<a name="l00136"></a>00136 }
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 
<a name="l00140"></a><a class="code" href="classNonlinearImplicitSystem.php#a398f285dc218b94c8cadeb9e36b9dbc1">00140</a> <span class="keywordtype">void</span> <a class="code" href="classNonlinearImplicitSystem.php#a398f285dc218b94c8cadeb9e36b9dbc1">NonlinearImplicitSystem::solve</a> ()
<a name="l00141"></a>00141 {
<a name="l00142"></a>00142   <span class="comment">// Log how long the nonlinear solve takes.</span>
<a name="l00143"></a>00143   START_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l00144"></a>00144   
<a name="l00145"></a>00145   this-&gt;<a class="code" href="classNonlinearImplicitSystem.php#a8ba78f3b6b910692f59eba070839086b">set_solver_parameters</a>();
<a name="l00146"></a>00146 
<a name="l00147"></a>00147   <span class="comment">// Solve the nonlinear system.</span>
<a name="l00148"></a>00148   <span class="keyword">const</span> std::pair&lt;unsigned int, Real&gt; rval =
<a name="l00149"></a>00149     <a class="code" href="classNonlinearImplicitSystem.php#af53b1f85297d1b95e5ff6656a1be18f2">nonlinear_solver</a>-&gt;solve (*<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>, *<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>, *<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>, 
<a name="l00150"></a>00150                              <a class="code" href="classNonlinearImplicitSystem.php#af53b1f85297d1b95e5ff6656a1be18f2">nonlinear_solver</a>-&gt;relative_residual_tolerance,
<a name="l00151"></a>00151                              <a class="code" href="classNonlinearImplicitSystem.php#af53b1f85297d1b95e5ff6656a1be18f2">nonlinear_solver</a>-&gt;max_linear_iterations);
<a name="l00152"></a>00152 
<a name="l00153"></a>00153   <span class="comment">// Store the number of nonlinear iterations required to</span>
<a name="l00154"></a>00154   <span class="comment">// solve and the final residual.</span>
<a name="l00155"></a>00155   <a class="code" href="classNonlinearImplicitSystem.php#a3133ddf822751dc7c1f235533fd547be">_n_nonlinear_iterations</a>   = rval.first;
<a name="l00156"></a>00156   <a class="code" href="classNonlinearImplicitSystem.php#a36cd39f9d94dbabec2a1b77018d062d1">_final_nonlinear_residual</a> = rval.second;
<a name="l00157"></a>00157     
<a name="l00158"></a>00158   <span class="comment">// Stop logging the nonlinear solve</span>
<a name="l00159"></a>00159   STOP_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l00160"></a>00160 
<a name="l00161"></a>00161   <span class="comment">// Update the system after the solve</span>
<a name="l00162"></a>00162   this-&gt;<a class="code" href="classSystem.php#add4b09ec4fb0679b8623c01218cafa5b">update</a>();  
<a name="l00163"></a>00163 }
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00167"></a><a class="code" href="classNonlinearImplicitSystem.php#a35febf47fca6afa4cbb1803187edb8a0">00167</a> <span class="keywordtype">void</span> <a class="code" href="classNonlinearImplicitSystem.php#a35febf47fca6afa4cbb1803187edb8a0">NonlinearImplicitSystem::adjoint_solve</a> ()
<a name="l00168"></a>00168 {
<a name="l00169"></a>00169   <span class="comment">// The adjoint_solve API (and all APIs using it) are about to see a</span>
<a name="l00170"></a>00170   <span class="comment">// series of non-backwards-compatible changes, primarily to add</span>
<a name="l00171"></a>00171   <span class="comment">// multiple-QoI support</span>
<a name="l00172"></a>00172   libmesh_experimental();
<a name="l00173"></a>00173 
<a name="l00174"></a>00174   <span class="comment">// Log how long the nonlinear solve takes.</span>
<a name="l00175"></a>00175   START_LOG(<span class="stringliteral">&quot;adjoint_solve()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   <span class="comment">// Adding an adjoint_solution vector, allocate an adjoint_solution if it doesn&#39;t already exist</span>
<a name="l00178"></a>00178   
<a name="l00179"></a>00179   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp; adjoint_solution = <a class="code" href="classSystem.php#abab8a3810cc43d99fe395d449207b786">System::add_vector</a>(<span class="stringliteral">&quot;adjoint_solution&quot;</span>);
<a name="l00180"></a>00180   
<a name="l00181"></a>00181   <span class="comment">// The nonlinear system should now already be solved.</span>
<a name="l00182"></a>00182   <span class="comment">// Now assemble it&#39;s adjoint.</span>
<a name="l00183"></a>00183 
<a name="l00184"></a>00184   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classSystem.php#ac1684646af433b1cdeb4c97ca1f31216">assemble_before_solve</a>)
<a name="l00185"></a>00185     {
<a name="l00186"></a>00186       <span class="comment">// Build the Jacobian</span>
<a name="l00187"></a>00187       <span class="keywordflow">if</span> (<a class="code" href="classNonlinearImplicitSystem.php#af53b1f85297d1b95e5ff6656a1be18f2">nonlinear_solver</a>-&gt;jacobian != NULL)
<a name="l00188"></a>00188         <a class="code" href="classNonlinearImplicitSystem.php#af53b1f85297d1b95e5ff6656a1be18f2">nonlinear_solver</a>-&gt;jacobian (*<a class="code" href="classSystem.php#a47b00cd00684aebe3c095aba010626e5">current_local_solution</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>(), *<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>);
<a name="l00189"></a>00189       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classNonlinearImplicitSystem.php#af53b1f85297d1b95e5ff6656a1be18f2">nonlinear_solver</a>-&gt;matvec != NULL)
<a name="l00190"></a>00190         <a class="code" href="classNonlinearImplicitSystem.php#af53b1f85297d1b95e5ff6656a1be18f2">nonlinear_solver</a>-&gt;matvec   (*<a class="code" href="classSystem.php#a47b00cd00684aebe3c095aba010626e5">current_local_solution</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>(), NULL, <a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>);
<a name="l00191"></a>00191       <span class="keywordflow">else</span> libmesh_error();
<a name="l00192"></a>00192 
<a name="l00193"></a>00193       <span class="comment">// Take the discretization adjoint</span>
<a name="l00194"></a>00194       <a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>-&gt;<a class="code" href="classSparseMatrix.php#a7f1c4ddda074a4e1aa63bf7d2f780492">get_transpose</a>(*<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>);
<a name="l00195"></a>00195 
<a name="l00196"></a>00196       <span class="comment">// Reset and build the RHS from the QOI derivative</span>
<a name="l00197"></a>00197       <a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>-&gt;<a class="code" href="classNumericVector.php#a21ca80e20b0f88490c8f0d5298d47bef">zero</a>();
<a name="l00198"></a>00198       this-&gt;<a class="code" href="classExplicitSystem.php#a563d121d2398bdc54dbe60eda789ddaa">assemble_qoi_derivative</a>();
<a name="l00199"></a>00199     }
<a name="l00200"></a>00200 
<a name="l00201"></a>00201   <span class="comment">// The adjoint problem is linear, so we only use the nonlinear</span>
<a name="l00202"></a>00202   <span class="comment">// solver to get tolerances and the current jacobian from it.</span>
<a name="l00203"></a>00203 
<a name="l00204"></a>00204   this-&gt;<a class="code" href="classNonlinearImplicitSystem.php#a8ba78f3b6b910692f59eba070839086b">set_solver_parameters</a>();
<a name="l00205"></a>00205 
<a name="l00206"></a>00206   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;LinearSolver&lt;Number&gt;</a> &gt; linear_solver = <a class="code" href="classLinearSolver.php">LinearSolver&lt;Number&gt;::build</a>();
<a name="l00207"></a>00207 
<a name="l00208"></a>00208   <span class="keyword">const</span> std::pair&lt;unsigned int, Real&gt; rval =
<a name="l00209"></a>00209     linear_solver-&gt;solve (*<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>, adjoint_solution, *<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>,
<a name="l00210"></a>00210                            <a class="code" href="classNonlinearImplicitSystem.php#af53b1f85297d1b95e5ff6656a1be18f2">nonlinear_solver</a>-&gt;relative_residual_tolerance,
<a name="l00211"></a>00211                            <a class="code" href="classNonlinearImplicitSystem.php#af53b1f85297d1b95e5ff6656a1be18f2">nonlinear_solver</a>-&gt;max_linear_iterations);
<a name="l00212"></a>00212 
<a name="l00213"></a>00213   <span class="comment">// Store the number of nonlinear iterations required to</span>
<a name="l00214"></a>00214   <span class="comment">// solve and the final residual.</span>
<a name="l00215"></a>00215   <a class="code" href="classNonlinearImplicitSystem.php#a3133ddf822751dc7c1f235533fd547be">_n_nonlinear_iterations</a>   = rval.first;
<a name="l00216"></a>00216   <a class="code" href="classNonlinearImplicitSystem.php#a36cd39f9d94dbabec2a1b77018d062d1">_final_nonlinear_residual</a> = rval.second;
<a name="l00217"></a>00217     
<a name="l00218"></a>00218   <span class="comment">// Stop logging the nonlinear solve</span>
<a name="l00219"></a>00219   STOP_LOG(<span class="stringliteral">&quot;adjoint_solve()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l00220"></a>00220 
<a name="l00221"></a>00221   <span class="comment">// Update the system after the solve</span>
<a name="l00222"></a>00222   this-&gt;<a class="code" href="classSystem.php#add4b09ec4fb0679b8623c01218cafa5b">update</a>();  
<a name="l00223"></a>00223 }
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 <span class="keywordtype">void</span> <a class="code" href="classNonlinearImplicitSystem.php#a9f96b6b45f31e6a9d50406fb09b35a9c">NonlinearImplicitSystem::qoi_parameter_sensitivity</a>
<a name="l00228"></a><a class="code" href="classNonlinearImplicitSystem.php#a9f96b6b45f31e6a9d50406fb09b35a9c">00228</a>   (std::vector&lt;Number *&gt;&amp; parameters,
<a name="l00229"></a>00229    std::vector&lt;Number&gt;&amp;   sensitivities)
<a name="l00230"></a>00230 {
<a name="l00231"></a>00231   <span class="comment">// Get ready to fill in senstivities:</span>
<a name="l00232"></a>00232   sensitivities.clear();
<a name="l00233"></a>00233   sensitivities.resize(parameters.size(), 0);
<a name="l00234"></a>00234 
<a name="l00235"></a>00235   <span class="comment">// An introduction to the problem:</span>
<a name="l00236"></a>00236   <span class="comment">//</span>
<a name="l00237"></a>00237   <span class="comment">// Residual R(u(p),p) = 0</span>
<a name="l00238"></a>00238   <span class="comment">// partial R / partial u = J = system matrix</span>
<a name="l00239"></a>00239   <span class="comment">//</span>
<a name="l00240"></a>00240   <span class="comment">// This implies that:</span>
<a name="l00241"></a>00241   <span class="comment">// d/dp(R) = 0</span>
<a name="l00242"></a>00242   <span class="comment">// (partial R / partial p) + </span>
<a name="l00243"></a>00243   <span class="comment">// (partial R / partial u) * (partial u / partial p) = 0</span>
<a name="l00244"></a>00244 
<a name="l00245"></a>00245   <span class="comment">// We first do an adjoint solve:</span>
<a name="l00246"></a>00246   <span class="comment">// J^T * z = (partial q / partial u)</span>
<a name="l00247"></a>00247 
<a name="l00248"></a>00248   this-&gt;adjoint_solve();
<a name="l00249"></a>00249 
<a name="l00250"></a>00250   <span class="comment">// We use the identities:</span>
<a name="l00251"></a>00251   <span class="comment">// dq/dp = (partial q / partial p) + (partial q / partial u) *</span>
<a name="l00252"></a>00252   <span class="comment">//         (partial u / partial p)</span>
<a name="l00253"></a>00253   <span class="comment">// dq/dp = (partial q / partial p) + (J^T * z) *</span>
<a name="l00254"></a>00254   <span class="comment">//         (partial u / partial p)</span>
<a name="l00255"></a>00255   <span class="comment">// dq/dp = (partial q / partial p) + z * J *</span>
<a name="l00256"></a>00256   <span class="comment">//         (partial u / partial p)</span>
<a name="l00257"></a>00257  
<a name="l00258"></a>00258   <span class="comment">// Leading to our final formula:</span>
<a name="l00259"></a>00259   <span class="comment">// dq/dp = (partial q / partial p) - z * (partial R / partial p)</span>
<a name="l00260"></a>00260 
<a name="l00261"></a>00261   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != parameters.size(); ++i)
<a name="l00262"></a>00262     {
<a name="l00263"></a>00263       <span class="comment">// We currently get partial derivatives via central differencing</span>
<a name="l00264"></a>00264       <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> delta_p = 1e-6;
<a name="l00265"></a>00265 
<a name="l00266"></a>00266       <span class="comment">// (partial q / partial p) ~= (q(p+dp)-q(p-dp))/(2*dp)</span>
<a name="l00267"></a>00267       <span class="comment">// (partial R / partial p) ~= (rhs(p+dp) - rhs(p-dp))/(2*dp)</span>
<a name="l00268"></a>00268 
<a name="l00269"></a>00269       <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> old_parameter = *parameters[i];
<a name="l00270"></a>00270       <span class="comment">// Number old_qoi = this-&gt;qoi;</span>
<a name="l00271"></a>00271 
<a name="l00272"></a>00272       *parameters[i] = old_parameter - delta_p;
<a name="l00273"></a>00273       this-&gt;assemble_qoi();
<a name="l00274"></a>00274       <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> qoi_minus = this-&gt;qoi;
<a name="l00275"></a>00275 
<a name="l00276"></a>00276       this-&gt;assemble();
<a name="l00277"></a>00277       this-&gt;rhs-&gt;close();
<a name="l00278"></a>00278       this-&gt;matrix-&gt;close();
<a name="l00279"></a>00279       <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; partialR_partialp = this-&gt;rhs-&gt;clone();
<a name="l00280"></a>00280       *partialR_partialp *= -1;
<a name="l00281"></a>00281 
<a name="l00282"></a>00282       *parameters[i] = old_parameter + delta_p;
<a name="l00283"></a>00283       this-&gt;assemble_qoi();
<a name="l00284"></a>00284       <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> qoi_plus = this-&gt;qoi;
<a name="l00285"></a>00285       <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> partialq_partialp = (qoi_plus - qoi_minus) / (2.*delta_p);
<a name="l00286"></a>00286 
<a name="l00287"></a>00287       this-&gt;assemble();
<a name="l00288"></a>00288       this-&gt;rhs-&gt;close();
<a name="l00289"></a>00289       this-&gt;matrix-&gt;close();
<a name="l00290"></a>00290       *partialR_partialp += *this-&gt;rhs;
<a name="l00291"></a>00291       *partialR_partialp /= (2.*delta_p);
<a name="l00292"></a>00292 
<a name="l00293"></a>00293       <span class="comment">// Don&#39;t leave the parameter changed</span>
<a name="l00294"></a>00294       *parameters[i] = old_parameter;
<a name="l00295"></a>00295 
<a name="l00296"></a>00296       sensitivities[i] = partialq_partialp -
<a name="l00297"></a>00297                          partialR_partialp-&gt;dot(this-&gt;get_adjoint_solution());
<a name="l00298"></a>00298     }
<a name="l00299"></a>00299 
<a name="l00300"></a>00300   <span class="comment">// All parameters have been reset.</span>
<a name="l00301"></a>00301   <span class="comment">// Don&#39;t leave the qoi or system changed - principle of least</span>
<a name="l00302"></a>00302   <span class="comment">// surprise.</span>
<a name="l00303"></a>00303   this-&gt;assemble();
<a name="l00304"></a>00304   this-&gt;assemble_qoi();
<a name="l00305"></a>00305   this-&gt;rhs-&gt;close();
<a name="l00306"></a>00306   this-&gt;matrix-&gt;close();
<a name="l00307"></a>00307 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
