<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>nonlinear_implicit_system.h</h1>  </div>
</div>
<div class="contents">
<a href="nonlinear__implicit__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: nonlinear_implicit_system.h 3414 2009-06-30 23:15:45Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __nonlinear_implicit_system_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __nonlinear_implicit_system_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="implicit__system_8h.php">implicit_system.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Forward declarations</span>
<a name="l00032"></a>00032 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classNonlinearSolver.php">NonlinearSolver</a>;
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00043"></a>00043 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00044"></a>00044 <span class="comment">// NonlinearImplicitSystem class definition</span>
<a name="l00045"></a>00045 
<a name="l00046"></a><a class="code" href="classNonlinearImplicitSystem.php">00046</a> <span class="keyword">class </span><a class="code" href="classNonlinearImplicitSystem.php">NonlinearImplicitSystem</a> : <span class="keyword">public</span> <a class="code" href="classImplicitSystem.php">ImplicitSystem</a>
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048 <span class="keyword">public</span>:
<a name="l00049"></a>00049 
<a name="l00054"></a>00054   <a class="code" href="classNonlinearImplicitSystem.php#a5a484ef34b3cefcbd797963c60eac41f">NonlinearImplicitSystem</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00055"></a>00055                            <span class="keyword">const</span> std::string&amp; <a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>,
<a name="l00056"></a>00056                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">number</a>);
<a name="l00057"></a>00057 
<a name="l00061"></a>00061   <span class="keyword">virtual</span> <a class="code" href="classNonlinearImplicitSystem.php#aeded7e71ed420ae21876f032a295946a">~NonlinearImplicitSystem</a> ();
<a name="l00062"></a>00062 
<a name="l00066"></a><a class="code" href="classNonlinearImplicitSystem.php#a7bd47717f890c2359578deb3899e46c9">00066</a>   <span class="keyword">typedef</span> <a class="code" href="classNonlinearImplicitSystem.php">NonlinearImplicitSystem</a> <a class="code" href="classNonlinearImplicitSystem.php#a7bd47717f890c2359578deb3899e46c9">sys_type</a>;
<a name="l00067"></a>00067 
<a name="l00071"></a><a class="code" href="classNonlinearImplicitSystem.php#a4c9e2064096c42f39b05dfcab9b02c6f">00071</a>   <span class="keyword">typedef</span> <a class="code" href="classImplicitSystem.php">ImplicitSystem</a> <a class="code" href="classNonlinearImplicitSystem.php#a4c9e2064096c42f39b05dfcab9b02c6f">Parent</a>;
<a name="l00072"></a>00072   
<a name="l00076"></a><a class="code" href="classNonlinearImplicitSystem.php#abaff7e6445a95e1a4a9673d3c8a55d84">00076</a>   <a class="code" href="classExplicitSystem.php">sys_type</a> &amp; <a class="code" href="classNonlinearImplicitSystem.php#abaff7e6445a95e1a4a9673d3c8a55d84">system</a> () { <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00077"></a>00077   
<a name="l00082"></a>00082   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNonlinearImplicitSystem.php#a0d44ef3c554b9051a06d5ed41a6479ac">clear</a> ();
<a name="l00083"></a>00083 
<a name="l00088"></a>00088   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNonlinearImplicitSystem.php#a6e90e888c2a3786316d968a4d70f0a06">reinit</a> ();
<a name="l00089"></a>00089    
<a name="l00090"></a>00090 <span class="comment">//   /**</span>
<a name="l00091"></a>00091 <span class="comment">//    * Prepares \p matrix and \p _dof_map for matrix assembly.</span>
<a name="l00092"></a>00092 <span class="comment">//    * Does not actually assemble anything.  For matrix assembly,</span>
<a name="l00093"></a>00093 <span class="comment">//    * use the \p assemble() in derived classes.</span>
<a name="l00094"></a>00094 <span class="comment">//    * @e Should be overloaded in derived classes.</span>
<a name="l00095"></a>00095 <span class="comment">//    */</span>
<a name="l00096"></a>00096 <span class="comment">//   virtual void assemble () { ImplicitSystem::assemble(); }</span>
<a name="l00097"></a>00097  
<a name="l00101"></a>00101   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNonlinearImplicitSystem.php#a398f285dc218b94c8cadeb9e36b9dbc1">solve</a> ();
<a name="l00102"></a>00102  
<a name="l00106"></a>00106   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNonlinearImplicitSystem.php#a35febf47fca6afa4cbb1803187edb8a0">adjoint_solve</a> ();
<a name="l00107"></a>00107  
<a name="l00118"></a>00118   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNonlinearImplicitSystem.php#a9f96b6b45f31e6a9d50406fb09b35a9c">qoi_parameter_sensitivity</a> (std::vector&lt;Number *&gt;&amp; parameters,
<a name="l00119"></a>00119                                           std::vector&lt;Number&gt;&amp; sensitivities);
<a name="l00120"></a>00120  
<a name="l00125"></a><a class="code" href="classNonlinearImplicitSystem.php#ad40fcf52b55d8e1d9391860a64e73ed9">00125</a>   <span class="keyword">virtual</span> std::string <a class="code" href="classNonlinearImplicitSystem.php#ad40fcf52b55d8e1d9391860a64e73ed9">system_type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="stringliteral">&quot;NonlinearImplicit&quot;</span>; }
<a name="l00126"></a>00126 
<a name="l00133"></a><a class="code" href="classNonlinearImplicitSystem.php#af53b1f85297d1b95e5ff6656a1be18f2">00133</a>   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NonlinearSolver&lt;Number&gt;</a> &gt; <a class="code" href="classNonlinearImplicitSystem.php#af53b1f85297d1b95e5ff6656a1be18f2">nonlinear_solver</a>;
<a name="l00134"></a>00134   
<a name="l00139"></a><a class="code" href="classNonlinearImplicitSystem.php#aa25c4932c94756a1689c48d049f2f0d1">00139</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classNonlinearImplicitSystem.php#aa25c4932c94756a1689c48d049f2f0d1">n_nonlinear_iterations</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classNonlinearImplicitSystem.php#a3133ddf822751dc7c1f235533fd547be">_n_nonlinear_iterations</a>; }
<a name="l00140"></a>00140 
<a name="l00144"></a><a class="code" href="classNonlinearImplicitSystem.php#a582774bb8eafe12dfca62afad85a6a64">00144</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNonlinearImplicitSystem.php#a582774bb8eafe12dfca62afad85a6a64">final_nonlinear_residual</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classNonlinearImplicitSystem.php#a36cd39f9d94dbabec2a1b77018d062d1">_final_nonlinear_residual</a>; }
<a name="l00145"></a>00145   
<a name="l00146"></a>00146 <span class="keyword">protected</span>:
<a name="l00147"></a>00147 
<a name="l00151"></a>00151   <span class="keywordtype">void</span> <a class="code" href="classNonlinearImplicitSystem.php#a8ba78f3b6b910692f59eba070839086b">set_solver_parameters</a>();
<a name="l00152"></a>00152   
<a name="l00157"></a><a class="code" href="classNonlinearImplicitSystem.php#a3133ddf822751dc7c1f235533fd547be">00157</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classNonlinearImplicitSystem.php#a3133ddf822751dc7c1f235533fd547be">_n_nonlinear_iterations</a>;
<a name="l00158"></a>00158 
<a name="l00162"></a><a class="code" href="classNonlinearImplicitSystem.php#a36cd39f9d94dbabec2a1b77018d062d1">00162</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNonlinearImplicitSystem.php#a36cd39f9d94dbabec2a1b77018d062d1">_final_nonlinear_residual</a>;
<a name="l00163"></a>00163 };
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00168"></a>00168 <span class="comment">// NonlinearImplicitSystem inline methods</span>
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
