<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>nonlinear_solver.h</h1>  </div>
</div>
<div class="contents">
<a href="nonlinear__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: nonlinear_solver.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __nonlinear_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __nonlinear_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;enum_solver_package.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;reference_counted_object.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;libmesh.h&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// forward declarations</span>
<a name="l00035"></a>00035 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr</a>;
<a name="l00036"></a>00036 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classSparseMatrix.php">SparseMatrix</a>;
<a name="l00037"></a>00037 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classNumericVector.php">NumericVector</a>;
<a name="l00038"></a>00038 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classPreconditioner.php">Preconditioner</a>;
<a name="l00039"></a>00039 <span class="keyword">class </span><a class="code" href="classNonlinearImplicitSystem.php">NonlinearImplicitSystem</a>;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00053"></a>00053 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00054"></a><a class="code" href="classNonlinearSolver.php">00054</a> <span class="keyword">class </span><a class="code" href="classNonlinearSolver.php">NonlinearSolver</a> : <span class="keyword">public</span> <a class="code" href="classReferenceCountedObject.php">ReferenceCountedObject</a>&lt;NonlinearSolver&lt;T&gt; &gt;
<a name="l00055"></a>00055 {
<a name="l00056"></a>00056 <span class="keyword">public</span>:
<a name="l00060"></a><a class="code" href="classNonlinearSolver.php#ac0eaf0f8ec528f1e6ce5842c2ffc6932">00060</a>   <span class="keyword">typedef</span> <a class="code" href="classNonlinearImplicitSystem.php">NonlinearImplicitSystem</a> <a class="code" href="classNonlinearSolver.php#ac0eaf0f8ec528f1e6ce5842c2ffc6932">sys_type</a>;
<a name="l00061"></a>00061 
<a name="l00065"></a>00065   <a class="code" href="classNonlinearSolver.php#a990badd9d38fd71b680ac39509c4d2d8">NonlinearSolver</a> (<a class="code" href="classNonlinearImplicitSystem.php">sys_type</a>&amp; s);
<a name="l00066"></a>00066     
<a name="l00070"></a>00070   <span class="keyword">virtual</span> <a class="code" href="classNonlinearSolver.php#a64bf6c15664f1c5c1c25200fdc8ae263">~NonlinearSolver</a> ();
<a name="l00071"></a>00071   
<a name="l00076"></a>00076   <span class="keyword">static</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NonlinearSolver&lt;T&gt;</a> &gt; <a class="code" href="classNonlinearSolver.php#aa38316ffc5670712f304cfa1f9c57239">build</a>(<a class="code" href="classNonlinearImplicitSystem.php">sys_type</a>&amp; s, <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> solver_package =
<a name="l00077"></a>00077                                             <a class="code" href="namespacelibMesh.php#a496c62248223cd940c7715932dd0dc2d">libMesh::default_solver_package</a>());
<a name="l00078"></a>00078   
<a name="l00083"></a><a class="code" href="classNonlinearSolver.php#a2153d2deb58b464e8d73b4a8e871b151">00083</a>   <span class="keywordtype">bool</span> <a class="code" href="classNonlinearSolver.php#a2153d2deb58b464e8d73b4a8e871b151">initialized</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classNonlinearSolver.php#ab91df0629f0ebe03af1fc4ef3dd89fcf">_is_initialized</a>; }
<a name="l00084"></a>00084   
<a name="l00088"></a><a class="code" href="classNonlinearSolver.php#a58f00e34447f224d03d7d9dad9d1a0a7">00088</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNonlinearSolver.php#a58f00e34447f224d03d7d9dad9d1a0a7">clear</a> () {}
<a name="l00089"></a>00089 
<a name="l00093"></a>00093   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNonlinearSolver.php#a3161b395f6119be6e3de419e8ba5a2d7">init</a> () = 0;
<a name="l00094"></a>00094 
<a name="l00098"></a>00098   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt; <a class="code" href="classNonlinearSolver.php#aa85c826d3a11634ecd77410e469cdcea">solve</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;,  <span class="comment">// System Jacobian Matrix</span>
<a name="l00099"></a>00099                                                <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;, <span class="comment">// Solution vector</span>
<a name="l00100"></a>00100                                                <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;, <span class="comment">// Residual vector</span>
<a name="l00101"></a>00101                                                <span class="keyword">const</span> <span class="keywordtype">double</span>,      <span class="comment">// Stopping tolerance</span>
<a name="l00102"></a>00102                                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>) = 0; <span class="comment">// N. Iterations</span>
<a name="l00103"></a>00103 
<a name="l00108"></a><a class="code" href="classNonlinearSolver.php#ab9792803ce6e3bc389eb080571c2a2ed">00108</a>   void (* <a class="code" href="classNonlinearSolver.php#ab9792803ce6e3bc389eb080571c2a2ed">residual</a>) (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp; X,
<a name="l00109"></a>00109                      <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp; R);
<a name="l00110"></a>00110 
<a name="l00115"></a><a class="code" href="classNonlinearSolver.php#a9f75710fe155e7e8feb1845568594d47">00115</a>   void (* <a class="code" href="classNonlinearSolver.php#a9f75710fe155e7e8feb1845568594d47">jacobian</a>) (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp; X,
<a name="l00116"></a>00116                      <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;Number&gt;</a>&amp; J);
<a name="l00117"></a>00117 
<a name="l00124"></a><a class="code" href="classNonlinearSolver.php#a591234d80323741618c37973e1fc686b">00124</a>   void (* <a class="code" href="classNonlinearSolver.php#a591234d80323741618c37973e1fc686b">matvec</a>) (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp; X,
<a name="l00125"></a>00125                    <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* R,
<a name="l00126"></a>00126                    <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;Number&gt;</a>*  J);
<a name="l00127"></a>00127 
<a name="l00131"></a><a class="code" href="classNonlinearSolver.php#acb0c621b2fe80e2c4b7e2b8114b349cb">00131</a>   <span class="keyword">const</span> <a class="code" href="classNonlinearImplicitSystem.php">sys_type</a> &amp; <a class="code" href="classNonlinearSolver.php#acb0c621b2fe80e2c4b7e2b8114b349cb">system</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classNonlinearSolver.php#a18c0a7db5e6974c94590830ee23db7b4">_system</a>; }
<a name="l00132"></a>00132 
<a name="l00136"></a><a class="code" href="classNonlinearSolver.php#a761da036aaa70ca820e99377a76437bd">00136</a>   <a class="code" href="classNonlinearImplicitSystem.php">sys_type</a> &amp; <a class="code" href="classNonlinearSolver.php#a761da036aaa70ca820e99377a76437bd">system</a> () { <span class="keywordflow">return</span> <a class="code" href="classNonlinearSolver.php#a18c0a7db5e6974c94590830ee23db7b4">_system</a>; }
<a name="l00137"></a>00137 
<a name="l00141"></a>00141   <span class="keywordtype">void</span> <a class="code" href="classNonlinearSolver.php#a173944a3be8013718f72e84630141b58">attach_preconditioner</a>(<a class="code" href="classPreconditioner.php">Preconditioner&lt;T&gt;</a> * preconditioner);
<a name="l00142"></a>00142 
<a name="l00146"></a><a class="code" href="classNonlinearSolver.php#a9296b5984ffb88e9b0096d4aa66a58cd">00146</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classNonlinearSolver.php#a9296b5984ffb88e9b0096d4aa66a58cd">max_nonlinear_iterations</a>;
<a name="l00147"></a>00147 
<a name="l00151"></a><a class="code" href="classNonlinearSolver.php#a0f3063f9a22927a14f04bddd5f800930">00151</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classNonlinearSolver.php#a0f3063f9a22927a14f04bddd5f800930">max_function_evaluations</a>;
<a name="l00152"></a>00152   
<a name="l00163"></a><a class="code" href="classNonlinearSolver.php#afb74273caf49d61e12e9967c2343ec27">00163</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNonlinearSolver.php#afb74273caf49d61e12e9967c2343ec27">absolute_residual_tolerance</a>;
<a name="l00164"></a><a class="code" href="classNonlinearSolver.php#a5efd4ea41450586a28da30ab7fff3297">00164</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNonlinearSolver.php#a5efd4ea41450586a28da30ab7fff3297">relative_residual_tolerance</a>;
<a name="l00165"></a>00165 
<a name="l00177"></a><a class="code" href="classNonlinearSolver.php#a9564586b23664b1da5d44871994a5bbc">00177</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNonlinearSolver.php#a9564586b23664b1da5d44871994a5bbc">absolute_step_tolerance</a>;
<a name="l00178"></a><a class="code" href="classNonlinearSolver.php#a8492e8e078534438a213e7b49fc67edd">00178</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNonlinearSolver.php#a8492e8e078534438a213e7b49fc67edd">relative_step_tolerance</a>;
<a name="l00179"></a>00179 
<a name="l00184"></a><a class="code" href="classNonlinearSolver.php#ab868d5b8e7c62c1ae668cc2ed1870523">00184</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classNonlinearSolver.php#ab868d5b8e7c62c1ae668cc2ed1870523">max_linear_iterations</a>;
<a name="l00185"></a>00185 
<a name="l00190"></a><a class="code" href="classNonlinearSolver.php#a98c0236c885dbab1081a4cdb946f9760">00190</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNonlinearSolver.php#a98c0236c885dbab1081a4cdb946f9760">initial_linear_tolerance</a>;
<a name="l00191"></a>00191 
<a name="l00195"></a><a class="code" href="classNonlinearSolver.php#a29ff00482d043714351bd8de6aecff90">00195</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNonlinearSolver.php#a29ff00482d043714351bd8de6aecff90">minimum_linear_tolerance</a>;
<a name="l00196"></a>00196 
<a name="l00201"></a><a class="code" href="classNonlinearSolver.php#a8880e2631459482cf145ba7dacdd0b87">00201</a>   <span class="keywordtype">bool</span> <a class="code" href="classNonlinearSolver.php#a8880e2631459482cf145ba7dacdd0b87">converged</a>;
<a name="l00202"></a>00202   
<a name="l00203"></a>00203 <span class="keyword">protected</span>:
<a name="l00207"></a><a class="code" href="classNonlinearSolver.php#a18c0a7db5e6974c94590830ee23db7b4">00207</a>   <a class="code" href="classNonlinearImplicitSystem.php">sys_type</a>&amp; <a class="code" href="classNonlinearSolver.php#a18c0a7db5e6974c94590830ee23db7b4">_system</a>;
<a name="l00208"></a>00208   
<a name="l00212"></a><a class="code" href="classNonlinearSolver.php#ab91df0629f0ebe03af1fc4ef3dd89fcf">00212</a>   <span class="keywordtype">bool</span> <a class="code" href="classNonlinearSolver.php#ab91df0629f0ebe03af1fc4ef3dd89fcf">_is_initialized</a>;
<a name="l00213"></a>00213 
<a name="l00217"></a><a class="code" href="classNonlinearSolver.php#a59c9ee5ab780fe8c365f8f757ffffd89">00217</a>   <a class="code" href="classPreconditioner.php">Preconditioner&lt;T&gt;</a> * <a class="code" href="classNonlinearSolver.php#a59c9ee5ab780fe8c365f8f757ffffd89">_preconditioner</a>;
<a name="l00218"></a>00218 };
<a name="l00219"></a>00219 
<a name="l00220"></a>00220 
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 <span class="comment">/*----------------------- inline functions ----------------------------------*/</span>
<a name="l00224"></a>00224 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00225"></a>00225 <span class="keyword">inline</span>
<a name="l00226"></a><a class="code" href="classNonlinearSolver.php#a990badd9d38fd71b680ac39509c4d2d8">00226</a> <a class="code" href="classNonlinearSolver.php#a990badd9d38fd71b680ac39509c4d2d8">NonlinearSolver&lt;T&gt;::NonlinearSolver</a> (<a class="code" href="classNonlinearImplicitSystem.php">sys_type</a>&amp; s) :
<a name="l00227"></a>00227   residual        (NULL),
<a name="l00228"></a>00228   jacobian        (NULL),
<a name="l00229"></a>00229   matvec          (NULL),
<a name="l00230"></a>00230   max_nonlinear_iterations(0),
<a name="l00231"></a>00231   max_function_evaluations(0),
<a name="l00232"></a>00232   absolute_residual_tolerance(0),
<a name="l00233"></a>00233   relative_residual_tolerance(0),
<a name="l00234"></a>00234   absolute_step_tolerance(0),
<a name="l00235"></a>00235   relative_step_tolerance(0),
<a name="l00236"></a>00236   max_linear_iterations(0),
<a name="l00237"></a>00237   initial_linear_tolerance(0),
<a name="l00238"></a>00238   minimum_linear_tolerance(0),
<a name="l00239"></a>00239   _system(s),
<a name="l00240"></a>00240   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> (false),
<a name="l00241"></a>00241   _preconditioner (NULL)
<a name="l00242"></a>00242 {
<a name="l00243"></a>00243 }
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 
<a name="l00247"></a>00247 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00248"></a>00248 <span class="keyword">inline</span>
<a name="l00249"></a><a class="code" href="classNonlinearSolver.php#a64bf6c15664f1c5c1c25200fdc8ae263">00249</a> <a class="code" href="classNonlinearSolver.php#a64bf6c15664f1c5c1c25200fdc8ae263">NonlinearSolver&lt;T&gt;::~NonlinearSolver</a> ()
<a name="l00250"></a>00250 {
<a name="l00251"></a>00251   this-&gt;clear ();
<a name="l00252"></a>00252 }
<a name="l00253"></a>00253 
<a name="l00254"></a>00254 
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 <span class="preprocessor">#endif // #ifdef __solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
