<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_f10759d5ac6297fe611079c3c15b8f2c.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>numeric_vector.C</h1>  </div>
</div>
<div class="contents">
<a href="numeric__vector_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: numeric_vector.C 3466 2009-09-17 18:01:17Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;cmath&gt;</span> <span class="comment">// for std::abs</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local Includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;distributed_vector.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;laspack_vector.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;petsc_vector.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;trilinos_epetra_vector.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;shell_matrix.h&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00036"></a>00036 <span class="comment">// NumericVector methods</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// Full specialization for Real datatypes</span>
<a name="l00039"></a>00039 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00040"></a>00040 <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt;
<a name="l00041"></a><a class="code" href="classNumericVector.php#a5c1d43e1a85ffb0487d1e0ae43918bd4">00041</a> <a class="code" href="classNumericVector.php#a5c1d43e1a85ffb0487d1e0ae43918bd4">NumericVector&lt;T&gt;::build</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> solver_package)
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043   <span class="comment">// Build the appropriate vector</span>
<a name="l00044"></a>00044   <span class="keywordflow">switch</span> (solver_package)
<a name="l00045"></a>00045     {
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 <span class="preprocessor">#ifdef LIBMESH_HAVE_LASPACK</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span>    <span class="keywordflow">case</span> <a class="code" href="libmesh_8C.php#ad6ecbeeb31977480c0eaa28e42e4437b">LASPACK_SOLVERS</a>:
<a name="l00050"></a>00050       {
<a name="l00051"></a>00051         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; ap(<span class="keyword">new</span> <a class="code" href="classLaspackVector.php">LaspackVector&lt;T&gt;</a>);
<a name="l00052"></a>00052         <span class="keywordflow">return</span> ap;
<a name="l00053"></a>00053       }
<a name="l00054"></a>00054 <span class="preprocessor">#endif</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span>
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00058"></a>00058 <span class="preprocessor"></span>    <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8a4bb6e669bd80e3d232092e60df464572">PETSC_SOLVERS</a>:
<a name="l00059"></a>00059       {
<a name="l00060"></a>00060         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; ap(<span class="keyword">new</span> <a class="code" href="classPetscVector.php">PetscVector&lt;T&gt;</a>);
<a name="l00061"></a>00061         <span class="keywordflow">return</span> ap;
<a name="l00062"></a>00062       }
<a name="l00063"></a>00063 <span class="preprocessor">#endif</span>
<a name="l00064"></a>00064 <span class="preprocessor"></span>
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 <span class="preprocessor">#ifdef LIBMESH_HAVE_TRILINOS</span>
<a name="l00067"></a>00067 <span class="preprocessor"></span>    <span class="keywordflow">case</span> <a class="code" href="libmesh_8C.php#aeb3d2e133be6abf302776ec5d939c457">TRILINOS_SOLVERS</a>:
<a name="l00068"></a>00068       {
<a name="l00069"></a>00069         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; ap(<span class="keyword">new</span> <a class="code" href="classEpetraVector.php">EpetraVector&lt;T&gt;</a>);
<a name="l00070"></a>00070         <span class="keywordflow">return</span> ap;
<a name="l00071"></a>00071       }
<a name="l00072"></a>00072 <span class="preprocessor">#endif</span>
<a name="l00073"></a>00073 <span class="preprocessor"></span>
<a name="l00074"></a>00074 
<a name="l00075"></a>00075     <span class="keywordflow">default</span>:
<a name="l00076"></a>00076       <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; ap(<span class="keyword">new</span> <a class="code" href="classDistributedVector.php">DistributedVector&lt;T&gt;</a>);
<a name="l00077"></a>00077       <span class="keywordflow">return</span> ap;
<a name="l00078"></a>00078     }
<a name="l00079"></a>00079     
<a name="l00080"></a>00080   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; ap(NULL);
<a name="l00081"></a>00081   <span class="keywordflow">return</span> ap;    
<a name="l00082"></a>00082 }
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 <span class="comment">// Full specialization for float datatypes (DistributedVector wants this)</span>
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 <span class="keyword">template</span> &lt;&gt;
<a name="l00089"></a><a class="code" href="classNumericVector.php#af0706e2c034683e7e73379fdd77a9e8a">00089</a> <span class="keywordtype">int</span> <a class="code" href="classNumericVector.php#ac23757a31a5afe5a7a9eb2f5ffe203ba">NumericVector&lt;float&gt;::compare</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;float&gt;</a> &amp;other_vector,
<a name="l00090"></a>00090                                    <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> threshold)<span class="keyword"> const</span>
<a name="l00091"></a>00091 <span class="keyword"></span>{
<a name="l00092"></a>00092   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00093"></a>00093   libmesh_assert (other_vector.<a class="code" href="classNumericVector.php#a43085d102bac085751371d1a94b5dea9">initialized</a>());
<a name="l00094"></a>00094   libmesh_assert (this-&gt;first_local_index() == other_vector.<a class="code" href="classNumericVector.php#adbe9067eff8c949bfdd591b4bee6b87d">first_local_index</a>());
<a name="l00095"></a>00095   libmesh_assert (this-&gt;last_local_index()  == other_vector.<a class="code" href="classNumericVector.php#ae3230edd5439110231dfe3d4f01dfe52">last_local_index</a>());
<a name="l00096"></a>00096 
<a name="l00097"></a>00097   <span class="keywordtype">int</span> rvalue     = -1;
<a name="l00098"></a>00098   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = first_local_index();
<a name="l00099"></a>00099 
<a name="l00100"></a>00100   <span class="keywordflow">do</span>
<a name="l00101"></a>00101     {
<a name="l00102"></a>00102       <span class="keywordflow">if</span> ( std::abs( (*<span class="keyword">this</span>)(i) - other_vector(i) ) &gt; threshold )
<a name="l00103"></a>00103         rvalue = i;
<a name="l00104"></a>00104       <span class="keywordflow">else</span>
<a name="l00105"></a>00105         i++;
<a name="l00106"></a>00106     }
<a name="l00107"></a>00107   <span class="keywordflow">while</span> (rvalue==-1 &amp;&amp; i&lt;last_local_index());
<a name="l00108"></a>00108 
<a name="l00109"></a>00109   <span class="keywordflow">return</span> rvalue;
<a name="l00110"></a>00110 }
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 <span class="comment">// Full specialization for double datatypes</span>
<a name="l00113"></a>00113 <span class="keyword">template</span> &lt;&gt;
<a name="l00114"></a><a class="code" href="classNumericVector.php#a6382f9f25ba93ce56d8a21e8caa3d556">00114</a> <span class="keywordtype">int</span> <a class="code" href="classNumericVector.php#ac23757a31a5afe5a7a9eb2f5ffe203ba">NumericVector&lt;double&gt;::compare</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;double&gt;</a> &amp;other_vector,
<a name="l00115"></a>00115                                     <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> threshold)<span class="keyword"> const</span>
<a name="l00116"></a>00116 <span class="keyword"></span>{
<a name="l00117"></a>00117   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00118"></a>00118   libmesh_assert (other_vector.<a class="code" href="classNumericVector.php#a43085d102bac085751371d1a94b5dea9">initialized</a>());
<a name="l00119"></a>00119   libmesh_assert (this-&gt;first_local_index() == other_vector.<a class="code" href="classNumericVector.php#adbe9067eff8c949bfdd591b4bee6b87d">first_local_index</a>());
<a name="l00120"></a>00120   libmesh_assert (this-&gt;last_local_index()  == other_vector.<a class="code" href="classNumericVector.php#ae3230edd5439110231dfe3d4f01dfe52">last_local_index</a>());
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   <span class="keywordtype">int</span> rvalue     = -1;
<a name="l00123"></a>00123   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = first_local_index();
<a name="l00124"></a>00124 
<a name="l00125"></a>00125   <span class="keywordflow">do</span>
<a name="l00126"></a>00126     {
<a name="l00127"></a>00127       <span class="keywordflow">if</span> ( std::abs( (*<span class="keyword">this</span>)(i) - other_vector(i) ) &gt; threshold )
<a name="l00128"></a>00128         rvalue = i;
<a name="l00129"></a>00129       <span class="keywordflow">else</span>
<a name="l00130"></a>00130         i++;
<a name="l00131"></a>00131     }
<a name="l00132"></a>00132   <span class="keywordflow">while</span> (rvalue==-1 &amp;&amp; i&lt;last_local_index());
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   <span class="keywordflow">return</span> rvalue;
<a name="l00135"></a>00135 }
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 <span class="preprocessor">#ifdef TRIPLE_PRECISION</span>
<a name="l00138"></a>00138 <span class="preprocessor"></span><span class="comment">// Full specialization for long double datatypes</span>
<a name="l00139"></a>00139 <span class="keyword">template</span> &lt;&gt;
<a name="l00140"></a><a class="code" href="classNumericVector.php#a2feb665858f5d53264ca9a4f2e45b0b8">00140</a> <span class="keywordtype">int</span> <a class="code" href="classNumericVector.php#ac23757a31a5afe5a7a9eb2f5ffe203ba">NumericVector&lt;long double&gt;::compare</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;long double&gt;</a> &amp;other_vector,
<a name="l00141"></a>00141                                          <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> threshold)<span class="keyword"> const</span>
<a name="l00142"></a>00142 <span class="keyword"></span>{
<a name="l00143"></a>00143   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00144"></a>00144   libmesh_assert (other_vector.<a class="code" href="classNumericVector.php#a43085d102bac085751371d1a94b5dea9">initialized</a>());
<a name="l00145"></a>00145   libmesh_assert (this-&gt;first_local_index() == other_vector.<a class="code" href="classNumericVector.php#adbe9067eff8c949bfdd591b4bee6b87d">first_local_index</a>());
<a name="l00146"></a>00146   libmesh_assert (this-&gt;last_local_index()  == other_vector.<a class="code" href="classNumericVector.php#ae3230edd5439110231dfe3d4f01dfe52">last_local_index</a>());
<a name="l00147"></a>00147 
<a name="l00148"></a>00148   <span class="keywordtype">int</span> rvalue     = -1;
<a name="l00149"></a>00149   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = first_local_index();
<a name="l00150"></a>00150 
<a name="l00151"></a>00151   <span class="keywordflow">do</span>
<a name="l00152"></a>00152     {
<a name="l00153"></a>00153       <span class="keywordflow">if</span> ( std::abs( (*<span class="keyword">this</span>)(i) - other_vector(i) ) &gt; threshold )
<a name="l00154"></a>00154         rvalue = i;
<a name="l00155"></a>00155       <span class="keywordflow">else</span>
<a name="l00156"></a>00156         i++;
<a name="l00157"></a>00157     }
<a name="l00158"></a>00158   <span class="keywordflow">while</span> (rvalue==-1 &amp;&amp; i&lt;last_local_index());
<a name="l00159"></a>00159 
<a name="l00160"></a>00160   <span class="keywordflow">return</span> rvalue;
<a name="l00161"></a>00161 }
<a name="l00162"></a>00162 <span class="preprocessor">#endif</span>
<a name="l00163"></a>00163 <span class="preprocessor"></span>
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 <span class="comment">// Full specialization for Complex datatypes</span>
<a name="l00166"></a>00166 <span class="keyword">template</span> &lt;&gt;
<a name="l00167"></a><a class="code" href="classNumericVector.php#a1431af6ba6a50cf9779d638435ecc5e2">00167</a> <span class="keywordtype">int</span> <a class="code" href="classNumericVector.php#ac23757a31a5afe5a7a9eb2f5ffe203ba">NumericVector&lt;Complex&gt;::compare</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Complex&gt;</a> &amp;other_vector,
<a name="l00168"></a>00168                                      <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> threshold)<span class="keyword"> const</span>
<a name="l00169"></a>00169 <span class="keyword"></span>{
<a name="l00170"></a>00170   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00171"></a>00171   libmesh_assert (other_vector.<a class="code" href="classNumericVector.php#a43085d102bac085751371d1a94b5dea9">initialized</a>());
<a name="l00172"></a>00172   libmesh_assert (this-&gt;first_local_index() == other_vector.<a class="code" href="classNumericVector.php#adbe9067eff8c949bfdd591b4bee6b87d">first_local_index</a>());
<a name="l00173"></a>00173   libmesh_assert (this-&gt;last_local_index()  == other_vector.<a class="code" href="classNumericVector.php#ae3230edd5439110231dfe3d4f01dfe52">last_local_index</a>());
<a name="l00174"></a>00174 
<a name="l00175"></a>00175   <span class="keywordtype">int</span> rvalue     = -1;
<a name="l00176"></a>00176   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = first_local_index();
<a name="l00177"></a>00177 
<a name="l00178"></a>00178   <span class="keywordflow">do</span>
<a name="l00179"></a>00179     {
<a name="l00180"></a>00180       <span class="keywordflow">if</span> (( std::abs( (*<span class="keyword">this</span>)(i).real() - other_vector(i).real() ) &gt; threshold ) ||
<a name="l00181"></a>00181           ( std::abs( (*<span class="keyword">this</span>)(i).imag() - other_vector(i).imag() ) &gt; threshold ))
<a name="l00182"></a>00182         rvalue = i;
<a name="l00183"></a>00183       <span class="keywordflow">else</span>
<a name="l00184"></a>00184         i++;
<a name="l00185"></a>00185     }
<a name="l00186"></a>00186   <span class="keywordflow">while</span> (rvalue==-1 &amp;&amp; i&lt;this-&gt;last_local_index());
<a name="l00187"></a>00187 
<a name="l00188"></a>00188   <span class="keywordflow">return</span> rvalue;
<a name="l00189"></a>00189 }
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00193"></a><a class="code" href="classNumericVector.php#aa7dd3afd81017c57f980dea9092ffa74">00193</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNumericVector.php#aa7dd3afd81017c57f980dea9092ffa74">NumericVector&lt;T&gt;::subset_l1_norm</a> (<span class="keyword">const</span> std::set&lt;unsigned int&gt; &amp; indices)
<a name="l00194"></a>00194 {
<a name="l00195"></a>00195   <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; v = *<span class="keyword">this</span>;
<a name="l00196"></a>00196   
<a name="l00197"></a>00197   std::set&lt;unsigned int&gt;::iterator it = indices.begin();
<a name="l00198"></a>00198   <span class="keyword">const</span> std::set&lt;unsigned int&gt;::iterator it_end = indices.end();
<a name="l00199"></a>00199 
<a name="l00200"></a>00200   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> norm = 0;
<a name="l00201"></a>00201   
<a name="l00202"></a>00202   <span class="keywordflow">for</span>(; it!=it_end; ++it)
<a name="l00203"></a>00203     norm += std::abs(v(*it));
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   Parallel::sum(norm);
<a name="l00206"></a>00206 
<a name="l00207"></a>00207   <span class="keywordflow">return</span> norm;
<a name="l00208"></a>00208 }
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00211"></a><a class="code" href="classNumericVector.php#a223c7b1890765ea0a5b6f0d3801d8ba8">00211</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNumericVector.php#a223c7b1890765ea0a5b6f0d3801d8ba8">NumericVector&lt;T&gt;::subset_l2_norm</a> (<span class="keyword">const</span> std::set&lt;unsigned int&gt; &amp; indices)
<a name="l00212"></a>00212 {
<a name="l00213"></a>00213   <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; v = *<span class="keyword">this</span>;
<a name="l00214"></a>00214 
<a name="l00215"></a>00215   std::set&lt;unsigned int&gt;::iterator it = indices.begin();
<a name="l00216"></a>00216   <span class="keyword">const</span> std::set&lt;unsigned int&gt;::iterator it_end = indices.end();
<a name="l00217"></a>00217 
<a name="l00218"></a>00218   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> norm = 0;
<a name="l00219"></a>00219   
<a name="l00220"></a>00220   <span class="keywordflow">for</span>(; it!=it_end; ++it)
<a name="l00221"></a>00221     norm += <a class="code" href="libmesh__common_8h.php#af9cdd07341b53cc644199f6aec5e1420">libmesh_norm</a>(v(*it));
<a name="l00222"></a>00222 
<a name="l00223"></a>00223   Parallel::sum(norm);
<a name="l00224"></a>00224 
<a name="l00225"></a>00225   <span class="keywordflow">return</span> std::sqrt(norm);
<a name="l00226"></a>00226 }
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00229"></a><a class="code" href="classNumericVector.php#a78d0fb683c0fcb05dff10b47617b0c06">00229</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNumericVector.php#a78d0fb683c0fcb05dff10b47617b0c06">NumericVector&lt;T&gt;::subset_linfty_norm</a> (<span class="keyword">const</span> std::set&lt;unsigned int&gt; &amp; indices)
<a name="l00230"></a>00230 {
<a name="l00231"></a>00231   <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; v = *<span class="keyword">this</span>;
<a name="l00232"></a>00232 
<a name="l00233"></a>00233   std::set&lt;unsigned int&gt;::iterator it = indices.begin();
<a name="l00234"></a>00234   <span class="keyword">const</span> std::set&lt;unsigned int&gt;::iterator it_end = indices.end();
<a name="l00235"></a>00235 
<a name="l00236"></a>00236   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> norm = 0;
<a name="l00237"></a>00237   
<a name="l00238"></a>00238   <span class="keywordflow">for</span>(; it!=it_end; ++it)
<a name="l00239"></a>00239     {
<a name="l00240"></a>00240       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> value = std::abs(v(*it));
<a name="l00241"></a>00241       <span class="keywordflow">if</span>(value &gt; norm)
<a name="l00242"></a>00242         norm = value;
<a name="l00243"></a>00243     }
<a name="l00244"></a>00244 
<a name="l00245"></a>00245   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(norm);
<a name="l00246"></a>00246 
<a name="l00247"></a>00247   <span class="keywordflow">return</span> norm;
<a name="l00248"></a>00248 }
<a name="l00249"></a>00249 
<a name="l00250"></a>00250 
<a name="l00251"></a>00251 
<a name="l00252"></a>00252 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00253"></a><a class="code" href="classNumericVector.php#a995855a8ca6239adc26fe4e665dd30e6">00253</a> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#ac41cf781a2cce694f5795cb36fb40a4b">NumericVector&lt;T&gt;::add_vector</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v,
<a name="l00254"></a>00254                                    <span class="keyword">const</span> <a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; a)
<a name="l00255"></a>00255 {
<a name="l00256"></a>00256   a.<a class="code" href="classShellMatrix.php#a66ae1b9b063ffa4b589e0759bbba826d">vector_mult_add</a>(*<span class="keyword">this</span>,v);
<a name="l00257"></a>00257 }
<a name="l00258"></a>00258 
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 
<a name="l00261"></a>00261 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00262"></a>00262 <span class="comment">// Explicit instantiations</span>
<a name="l00263"></a>00263 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>;
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
