<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>numeric_vector.h</h1>  </div>
</div>
<div class="contents">
<a href="numeric__vector_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: numeric_vector.h 3456 2009-09-04 18:32:19Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __numeric_vector_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __numeric_vector_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;auto_ptr.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;enum_parallel_type.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;enum_solver_package.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;reference_counted_object.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;libmesh.h&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">// forward declarations</span>
<a name="l00040"></a>00040 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classNumericVector.php">NumericVector</a>;
<a name="l00041"></a>00041 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classDenseVector.php">DenseVector</a>;
<a name="l00042"></a>00042 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classDenseSubVector.php">DenseSubVector</a>;
<a name="l00043"></a>00043 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classSparseMatrix.php">SparseMatrix</a>;
<a name="l00044"></a>00044 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classShellMatrix.php">ShellMatrix</a>;
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00054"></a>00054 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00055"></a><a class="code" href="classNumericVector.php">00055</a> <span class="keyword">class </span><a class="code" href="classNumericVector.php">NumericVector</a> : <span class="keyword">public</span> <a class="code" href="classReferenceCountedObject.php">ReferenceCountedObject</a>&lt;NumericVector&lt;T&gt; &gt;
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057 <span class="keyword">public</span>:
<a name="l00058"></a>00058 
<a name="l00062"></a>00062   <span class="keyword">explicit</span>
<a name="l00063"></a>00063   <a class="code" href="classNumericVector.php#a484e9bff23067d8d9a7936d8767df6ab">NumericVector</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00064"></a>00064     
<a name="l00068"></a>00068   <span class="keyword">explicit</span>
<a name="l00069"></a>00069   <a class="code" href="classNumericVector.php#a484e9bff23067d8d9a7936d8767df6ab">NumericVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00070"></a>00070                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00071"></a>00071     
<a name="l00076"></a>00076   <a class="code" href="classNumericVector.php#a484e9bff23067d8d9a7936d8767df6ab">NumericVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> n,
<a name="l00077"></a>00077                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00078"></a>00078                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00079"></a>00079 
<a name="l00085"></a>00085   <a class="code" href="classNumericVector.php#a484e9bff23067d8d9a7936d8767df6ab">NumericVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00086"></a>00086                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00087"></a>00087                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ghost,
<a name="l00088"></a>00088                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00089"></a>00089     
<a name="l00090"></a>00090 <span class="keyword">public</span>:
<a name="l00091"></a>00091 
<a name="l00096"></a>00096   <span class="keyword">virtual</span> <a class="code" href="classNumericVector.php#a664fb397cac540c73656f573855efbe1">~NumericVector</a> ();
<a name="l00097"></a>00097 
<a name="l00102"></a>00102   <span class="keyword">static</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt;
<a name="l00103"></a>00103   <a class="code" href="classNumericVector.php#a5c1d43e1a85ffb0487d1e0ae43918bd4">build</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> solver_package = <a class="code" href="namespacelibMesh.php#a496c62248223cd940c7715932dd0dc2d">libMesh::default_solver_package</a>());
<a name="l00104"></a>00104   
<a name="l00109"></a><a class="code" href="classNumericVector.php#a43085d102bac085751371d1a94b5dea9">00109</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classNumericVector.php#a43085d102bac085751371d1a94b5dea9">initialized</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classNumericVector.php#ac4a667077b6ec42b9a35a9aed43fc92e">_is_initialized</a>; }
<a name="l00110"></a>00110 
<a name="l00114"></a><a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">00114</a>   <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classNumericVector.php#a26410625410635a53bf754077ff88173">_type</a>; }
<a name="l00115"></a>00115 
<a name="l00119"></a><a class="code" href="classNumericVector.php#aae52e60424fdda96d4c259d2673980cb">00119</a>   <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> &amp; <a class="code" href="classNumericVector.php#aae52e60424fdda96d4c259d2673980cb">type</a>() { <span class="keywordflow">return</span> <a class="code" href="classNumericVector.php#a26410625410635a53bf754077ff88173">_type</a>; }
<a name="l00120"></a>00120 
<a name="l00125"></a><a class="code" href="classNumericVector.php#a8a960770fd4eb3db8bc29c4c2397ddbf">00125</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classNumericVector.php#a8a960770fd4eb3db8bc29c4c2397ddbf">closed</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classNumericVector.php#a5fb110426b9570de8690d317424a310b">_is_closed</a>; }
<a name="l00126"></a>00126   
<a name="l00130"></a>00130   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#a4c7feb55cd686619d04e0441b41ceaa5">close</a> () = 0; 
<a name="l00131"></a>00131 
<a name="l00135"></a>00135   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#a00f9162aaeaaf8658d3fc95408a778b6">clear</a> ();
<a name="l00136"></a>00136 
<a name="l00141"></a>00141   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#a21ca80e20b0f88490c8f0d5298d47bef">zero</a> () = 0;    
<a name="l00142"></a>00142 
<a name="l00147"></a>00147   <span class="keyword">virtual</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classNumericVector.php#a5ac7af0a31b15c7f13c6fa85a5048e45">clone</a> () <span class="keyword">const</span> = 0;
<a name="l00148"></a>00148   
<a name="l00162"></a>00162   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#abbb0c0eb886ba1c6bb835d6275475c6e">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00163"></a>00163                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00164"></a>00164                      <span class="keyword">const</span> <span class="keywordtype">bool</span> = <span class="keyword">false</span>,
<a name="l00165"></a>00165                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>) = 0;
<a name="l00166"></a>00166   
<a name="l00170"></a>00170   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#abbb0c0eb886ba1c6bb835d6275475c6e">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00171"></a>00171                      <span class="keyword">const</span> <span class="keywordtype">bool</span> = <span class="keyword">false</span>,
<a name="l00172"></a>00172                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>) = 0;
<a name="l00173"></a>00173     
<a name="l00178"></a>00178   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#abbb0c0eb886ba1c6bb835d6275475c6e">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*N*/</span>,
<a name="l00179"></a>00179                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*n_local*/</span>,
<a name="l00180"></a>00180                      <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <span class="comment">/*ghost*/</span>,
<a name="l00181"></a>00181                      <span class="keyword">const</span> <span class="keywordtype">bool</span> <span class="comment">/*fast*/</span> = <span class="keyword">false</span>,
<a name="l00182"></a>00182                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>) = 0;
<a name="l00183"></a>00183 
<a name="l00188"></a>00188   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#abbb0c0eb886ba1c6bb835d6275475c6e">init</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; other,
<a name="l00189"></a>00189                      <span class="keyword">const</span> <span class="keywordtype">bool</span> fast = <span class="keyword">false</span>) = 0;
<a name="l00190"></a>00190     
<a name="l00194"></a>00194   <span class="keyword">virtual</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classNumericVector.php#ae8afb0d23e17e5740240575ad641c5e0">operator= </a>(<span class="keyword">const</span> T s) = 0;
<a name="l00195"></a>00195   
<a name="l00199"></a>00199   <span class="keyword">virtual</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classNumericVector.php#ae8afb0d23e17e5740240575ad641c5e0">operator= </a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;V) = 0;
<a name="l00200"></a>00200 
<a name="l00204"></a>00204   <span class="keyword">virtual</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classNumericVector.php#ae8afb0d23e17e5740240575ad641c5e0">operator= </a>(<span class="keyword">const</span> std::vector&lt;T&gt; &amp;v) = 0;
<a name="l00205"></a>00205 
<a name="l00211"></a>00211   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNumericVector.php#af75d2cb36e1c5019dc0a01198bd9c32b">min</a> () <span class="keyword">const</span> = 0;
<a name="l00212"></a>00212   
<a name="l00218"></a>00218   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNumericVector.php#a2de590658672f9fae6ed0c0201f362d6">max</a> () <span class="keyword">const</span> = 0;
<a name="l00219"></a>00219  
<a name="l00223"></a>00223   <span class="keyword">virtual</span> T <a class="code" href="classNumericVector.php#a6e7d8a519ade3f53216947fc76f15792">sum</a>() <span class="keyword">const</span> = 0;
<a name="l00224"></a>00224 
<a name="l00229"></a>00229   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNumericVector.php#a32d1eccab710311df6e4e36afb6c9537">l1_norm</a> () <span class="keyword">const</span> = 0;
<a name="l00230"></a>00230 
<a name="l00236"></a>00236   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNumericVector.php#aae40073beefab5ff9d4418f97b2b4517">l2_norm</a> () <span class="keyword">const</span> = 0;
<a name="l00237"></a>00237 
<a name="l00243"></a>00243   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNumericVector.php#a38f90cc59a6732636ee71c0b83f2f65c">linfty_norm</a> () <span class="keyword">const</span> = 0;
<a name="l00244"></a>00244 
<a name="l00253"></a>00253   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNumericVector.php#aa7dd3afd81017c57f980dea9092ffa74">subset_l1_norm</a> (<span class="keyword">const</span> std::set&lt;unsigned int&gt; &amp; indices);
<a name="l00254"></a>00254 
<a name="l00264"></a>00264   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNumericVector.php#a223c7b1890765ea0a5b6f0d3801d8ba8">subset_l2_norm</a> (<span class="keyword">const</span> std::set&lt;unsigned int&gt; &amp; indices);
<a name="l00265"></a>00265 
<a name="l00274"></a>00274   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classNumericVector.php#a78d0fb683c0fcb05dff10b47617b0c06">subset_linfty_norm</a> (<span class="keyword">const</span> std::set&lt;unsigned int&gt; &amp; indices);
<a name="l00275"></a>00275 
<a name="l00283"></a>00283   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classNumericVector.php#ae21bc89e89e895ac26b851a31926e194">size</a> () <span class="keyword">const</span> = 0;
<a name="l00284"></a>00284 
<a name="l00290"></a>00290   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classNumericVector.php#a400307e324862d460ff6b3b83a72e867">local_size</a>() <span class="keyword">const</span> = 0;
<a name="l00291"></a>00291 
<a name="l00297"></a>00297   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classNumericVector.php#adbe9067eff8c949bfdd591b4bee6b87d">first_local_index</a>() <span class="keyword">const</span> = 0;
<a name="l00298"></a>00298 
<a name="l00304"></a>00304   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classNumericVector.php#ae3230edd5439110231dfe3d4f01dfe52">last_local_index</a>() <span class="keyword">const</span> = 0;
<a name="l00305"></a>00305     
<a name="l00309"></a>00309   <span class="keyword">virtual</span> T <a class="code" href="classNumericVector.php#a523c1119c440183d5e79974e8be2e121">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> = 0;
<a name="l00310"></a>00310     
<a name="l00314"></a><a class="code" href="classNumericVector.php#a8aecaa39185f4ed3a3d6e7dd9ec7a80e">00314</a>   <span class="keyword">virtual</span> T <a class="code" href="classNumericVector.php#a8aecaa39185f4ed3a3d6e7dd9ec7a80e">el</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (*<span class="keyword">this</span>)(i); }
<a name="l00315"></a>00315 
<a name="l00322"></a>00322   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <span class="keyword">get</span>(<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; index, std::vector&lt;T&gt;&amp; values) <span class="keyword">const</span>;
<a name="l00323"></a>00323 
<a name="l00328"></a>00328   <span class="keyword">virtual</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classNumericVector.php#ab858310f2aa60e5811fc2e8157ca136c">operator += </a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;V) = 0;
<a name="l00329"></a>00329 
<a name="l00334"></a>00334   <span class="keyword">virtual</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classNumericVector.php#a33d8eefbbea4e3d54e838e6d6092229f">operator -= </a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;V) = 0;
<a name="l00335"></a>00335     
<a name="l00340"></a><a class="code" href="classNumericVector.php#ac796d219778bc0e8c5f22db674582b4d">00340</a>   <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classNumericVector.php#ac796d219778bc0e8c5f22db674582b4d">operator *= </a>(<span class="keyword">const</span> T a) { this-&gt;<a class="code" href="classNumericVector.php#a902c95547d402fa3b9448a767fd8eeab">scale</a>(a); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00341"></a>00341 
<a name="l00346"></a><a class="code" href="classNumericVector.php#a67fc2e83995274eed4fde8dd82e242ea">00346</a>   <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classNumericVector.php#a67fc2e83995274eed4fde8dd82e242ea">operator /= </a>(<span class="keyword">const</span> T a) { this-&gt;<a class="code" href="classNumericVector.php#a902c95547d402fa3b9448a767fd8eeab">scale</a>(1./a); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00347"></a>00347 
<a name="l00351"></a>00351   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <span class="keyword">set</span> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value) = 0;
<a name="l00352"></a>00352     
<a name="l00356"></a>00356   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#a63f662febc0a45f3b821cce3bc438190">add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value) = 0;
<a name="l00357"></a>00357     
<a name="l00363"></a>00363   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#a63f662febc0a45f3b821cce3bc438190">add</a> (<span class="keyword">const</span> T s) = 0;
<a name="l00364"></a>00364     
<a name="l00370"></a>00370   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#a63f662febc0a45f3b821cce3bc438190">add</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; V) = 0;
<a name="l00371"></a>00371 
<a name="l00377"></a>00377   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#a63f662febc0a45f3b821cce3bc438190">add</a> (<span class="keyword">const</span> T a, <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v) = 0;
<a name="l00378"></a>00378 
<a name="l00384"></a>00384   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#ac41cf781a2cce694f5795cb36fb40a4b">add_vector</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00385"></a>00385                            <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices) = 0;
<a name="l00386"></a>00386 
<a name="l00393"></a>00393   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#ac41cf781a2cce694f5795cb36fb40a4b">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00394"></a>00394                            <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices) = 0;
<a name="l00395"></a>00395 
<a name="l00400"></a>00400   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#ac41cf781a2cce694f5795cb36fb40a4b">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;,
<a name="l00401"></a>00401                            <span class="keyword">const</span> <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;) = 0;
<a name="l00402"></a>00402       
<a name="l00407"></a>00407   <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#ac41cf781a2cce694f5795cb36fb40a4b">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v,
<a name="l00408"></a>00408                    <span class="keyword">const</span> <a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; a);
<a name="l00409"></a>00409       
<a name="l00416"></a>00416   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#ac41cf781a2cce694f5795cb36fb40a4b">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00417"></a>00417                            <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices) = 0;
<a name="l00418"></a>00418 
<a name="l00423"></a>00423   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#a987f06abdeae62d77a043dbd94ffb370">insert</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00424"></a>00424                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices) = 0;
<a name="l00425"></a>00425 
<a name="l00432"></a>00432   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#a987f06abdeae62d77a043dbd94ffb370">insert</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00433"></a>00433                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices) = 0;
<a name="l00434"></a>00434       
<a name="l00441"></a>00441   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#a987f06abdeae62d77a043dbd94ffb370">insert</a> (<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00442"></a>00442                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices) = 0;
<a name="l00443"></a>00443 
<a name="l00449"></a>00449   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#a987f06abdeae62d77a043dbd94ffb370">insert</a> (<span class="keyword">const</span> <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;T&gt;</a>&amp; V,
<a name="l00450"></a>00450                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices) = 0;
<a name="l00451"></a>00451     
<a name="l00456"></a>00456   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#a902c95547d402fa3b9448a767fd8eeab">scale</a> (<span class="keyword">const</span> T factor) = 0;
<a name="l00457"></a>00457 
<a name="l00462"></a>00462   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#a1ed18621d6c8d1897513cc8fade59b55">abs</a>() = 0;
<a name="l00463"></a>00463 
<a name="l00467"></a>00467   <span class="keyword">virtual</span> T <a class="code" href="classNumericVector.php#a31ab3c7766664f2d6ce99075c4572ff3">dot</a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;) <span class="keyword">const</span> = 0;
<a name="l00468"></a>00468   
<a name="l00473"></a>00473   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#ab5d2d505bd3b8c09e6be4207379d901e">localize</a> (std::vector&lt;T&gt;&amp; v_local) <span class="keyword">const</span> = 0;
<a name="l00474"></a>00474 
<a name="l00479"></a>00479   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#ab5d2d505bd3b8c09e6be4207379d901e">localize</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local) <span class="keyword">const</span> = 0;
<a name="l00480"></a>00480 
<a name="l00486"></a>00486   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#ab5d2d505bd3b8c09e6be4207379d901e">localize</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local,
<a name="l00487"></a>00487                          <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list) <span class="keyword">const</span> = 0;
<a name="l00488"></a>00488   
<a name="l00493"></a>00493   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#ab5d2d505bd3b8c09e6be4207379d901e">localize</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_idx,
<a name="l00494"></a>00494                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> last_local_idx,
<a name="l00495"></a>00495                          <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list) = 0;
<a name="l00496"></a>00496 
<a name="l00503"></a>00503   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#aee6ec5e7e301cf044ad0e47c92808bb3">localize_to_one</a> (std::vector&lt;T&gt;&amp; v_local,
<a name="l00504"></a>00504                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id=0) <span class="keyword">const</span> = 0;
<a name="l00505"></a>00505     
<a name="l00514"></a>00514   <span class="keyword">virtual</span> <span class="keywordtype">int</span> <a class="code" href="classNumericVector.php#ac23757a31a5afe5a7a9eb2f5ffe203ba">compare</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;other_vector,
<a name="l00515"></a>00515                        <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> threshold = TOLERANCE) <span class="keyword">const</span>;
<a name="l00516"></a>00516 
<a name="l00521"></a>00521   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#a86efd5ff67320b79e5e6cd9d93a4d5ca">pointwise_mult</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec1,
<a name="l00522"></a>00522                                <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec2) = 0;
<a name="l00523"></a>00523 
<a name="l00527"></a>00527   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#acfb8a6c4ec8447a49f68a59c1406ba00">print</a>(std::ostream&amp; os=std::cout) <span class="keyword">const</span>;
<a name="l00528"></a>00528 
<a name="l00532"></a>00532   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#acc9cf91eb078b1d8715448251603ad6d">print_global</a>(std::ostream&amp; os=std::cout) <span class="keyword">const</span>;
<a name="l00533"></a>00533 
<a name="l00537"></a><a class="code" href="classNumericVector.php#a79351f9d343287d91dd2e782dfbd508d">00537</a>   <span class="keyword">friend</span> std::ostream&amp; operator &lt;&lt; (std::ostream&amp; os, const NumericVector&lt;T&gt;&amp; v)
<a name="l00538"></a>00538   {
<a name="l00539"></a>00539     v.print_global(os);
<a name="l00540"></a>00540     <span class="keywordflow">return</span> os;
<a name="l00541"></a>00541   }
<a name="l00542"></a>00542   
<a name="l00549"></a><a class="code" href="classNumericVector.php#a2172d307f0b20c183d4bd2fb2705529b">00549</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#a2172d307f0b20c183d4bd2fb2705529b">print_matlab</a>(<span class="keyword">const</span> std::string <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>=<span class="stringliteral">&quot;NULL&quot;</span>)<span class="keyword"> const</span>
<a name="l00550"></a>00550 <span class="keyword">  </span>{
<a name="l00551"></a>00551     std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Not Implemented in base class yet!&quot;</span> &lt;&lt; std::endl;
<a name="l00552"></a>00552     std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR writing MATLAB file &quot;</span> &lt;&lt; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a> &lt;&lt; std::endl;
<a name="l00553"></a>00553     libmesh_error();
<a name="l00554"></a>00554   }
<a name="l00555"></a>00555 
<a name="l00562"></a><a class="code" href="classNumericVector.php#a2277dbc2d145715ab716fd7b722ff88c">00562</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#a2277dbc2d145715ab716fd7b722ff88c">create_subvector</a>(<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; ,
<a name="l00563"></a>00563                                 <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; )<span class="keyword"> const</span>
<a name="l00564"></a>00564 <span class="keyword">  </span>{
<a name="l00565"></a>00565     std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Not Implemented in base class yet!&quot;</span> &lt;&lt; std::endl;
<a name="l00566"></a>00566     libmesh_error();
<a name="l00567"></a>00567   }
<a name="l00568"></a>00568     
<a name="l00574"></a>00574   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#a51e2011eeca6faa30e349c1950352eb8">swap</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;v);
<a name="l00575"></a>00575 
<a name="l00576"></a>00576 <span class="keyword">protected</span>:
<a name="l00577"></a>00577   
<a name="l00582"></a><a class="code" href="classNumericVector.php#a5fb110426b9570de8690d317424a310b">00582</a>   <span class="keywordtype">bool</span> <a class="code" href="classNumericVector.php#a5fb110426b9570de8690d317424a310b">_is_closed</a>;
<a name="l00583"></a>00583   
<a name="l00588"></a><a class="code" href="classNumericVector.php#ac4a667077b6ec42b9a35a9aed43fc92e">00588</a>   <span class="keywordtype">bool</span> <a class="code" href="classNumericVector.php#ac4a667077b6ec42b9a35a9aed43fc92e">_is_initialized</a>;
<a name="l00589"></a>00589 
<a name="l00593"></a><a class="code" href="classNumericVector.php#a26410625410635a53bf754077ff88173">00593</a>   <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classNumericVector.php#a26410625410635a53bf754077ff88173">_type</a>;
<a name="l00594"></a>00594 };
<a name="l00595"></a>00595 
<a name="l00596"></a>00596 
<a name="l00597"></a>00597 <span class="comment">/*----------------------- Inline functions ----------------------------------*/</span>
<a name="l00598"></a>00598 
<a name="l00599"></a>00599 
<a name="l00600"></a>00600 
<a name="l00601"></a>00601 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00602"></a>00602 <span class="keyword">inline</span>
<a name="l00603"></a><a class="code" href="classNumericVector.php#a484e9bff23067d8d9a7936d8767df6ab">00603</a> <a class="code" href="classNumericVector.php#a484e9bff23067d8d9a7936d8767df6ab">NumericVector&lt;T&gt;::NumericVector</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type) :
<a name="l00604"></a>00604   _is_closed(false),
<a name="l00605"></a>00605   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a>(false),
<a name="l00606"></a>00606   _type(type)
<a name="l00607"></a>00607 {
<a name="l00608"></a>00608 }
<a name="l00609"></a>00609 
<a name="l00610"></a>00610 
<a name="l00611"></a>00611 
<a name="l00612"></a>00612 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00613"></a>00613 <span class="keyword">inline</span>
<a name="l00614"></a><a class="code" href="classNumericVector.php#aae66c99b835658ccab38bc761da35d84">00614</a> <a class="code" href="classNumericVector.php#a484e9bff23067d8d9a7936d8767df6ab">NumericVector&lt;T&gt;::NumericVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*n*/</span>,
<a name="l00615"></a>00615                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type) :
<a name="l00616"></a>00616   _is_closed(false),
<a name="l00617"></a>00617   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a>(false),
<a name="l00618"></a>00618   _type(type)
<a name="l00619"></a>00619 {
<a name="l00620"></a>00620   libmesh_error(); <span class="comment">// Abstract base class!</span>
<a name="l00621"></a>00621   <span class="comment">// init(n, n, false, type);</span>
<a name="l00622"></a>00622 }
<a name="l00623"></a>00623 
<a name="l00624"></a>00624 
<a name="l00625"></a>00625 
<a name="l00626"></a>00626 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00627"></a>00627 <span class="keyword">inline</span>
<a name="l00628"></a><a class="code" href="classNumericVector.php#ad969c62e8d88a9eba1fdc899b47f4248">00628</a> <a class="code" href="classNumericVector.php#a484e9bff23067d8d9a7936d8767df6ab">NumericVector&lt;T&gt;::NumericVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*n*/</span>,
<a name="l00629"></a>00629                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*n_local*/</span>,
<a name="l00630"></a>00630                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type) :
<a name="l00631"></a>00631   _is_closed(false),
<a name="l00632"></a>00632   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a>(false),
<a name="l00633"></a>00633   _type(type)
<a name="l00634"></a>00634 {
<a name="l00635"></a>00635   libmesh_error(); <span class="comment">// Abstract base class!</span>
<a name="l00636"></a>00636   <span class="comment">// init(n, n_local, false, type);</span>
<a name="l00637"></a>00637 }
<a name="l00638"></a>00638 
<a name="l00639"></a>00639 
<a name="l00640"></a>00640 
<a name="l00641"></a>00641 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00642"></a>00642 <span class="keyword">inline</span>
<a name="l00643"></a><a class="code" href="classNumericVector.php#aa20a6ca58581955aa20e50d6bc9ad243">00643</a> <a class="code" href="classNumericVector.php#a484e9bff23067d8d9a7936d8767df6ab">NumericVector&lt;T&gt;::NumericVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*n*/</span>,
<a name="l00644"></a>00644                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*n_local*/</span>,
<a name="l00645"></a>00645                                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <span class="comment">/*ghost*/</span>,
<a name="l00646"></a>00646                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type) :
<a name="l00647"></a>00647   _is_closed(false),
<a name="l00648"></a>00648   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a>(false),
<a name="l00649"></a>00649   _type(type)
<a name="l00650"></a>00650 {
<a name="l00651"></a>00651   libmesh_error(); <span class="comment">// Abstract base class!</span>
<a name="l00652"></a>00652   <span class="comment">// init(n, n_local, ghost, false, type);</span>
<a name="l00653"></a>00653 }
<a name="l00654"></a>00654 
<a name="l00655"></a>00655 
<a name="l00656"></a>00656 
<a name="l00657"></a>00657 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00658"></a>00658 <span class="keyword">inline</span>
<a name="l00659"></a><a class="code" href="classNumericVector.php#a664fb397cac540c73656f573855efbe1">00659</a> <a class="code" href="classNumericVector.php#a664fb397cac540c73656f573855efbe1">NumericVector&lt;T&gt;::~NumericVector</a> ()
<a name="l00660"></a>00660 {
<a name="l00661"></a>00661   clear ();
<a name="l00662"></a>00662 }
<a name="l00663"></a>00663 
<a name="l00664"></a>00664 
<a name="l00665"></a>00665 
<a name="l00666"></a>00666 <span class="comment">// These should be pure virtual, not bugs waiting to happen - RHS</span>
<a name="l00667"></a>00667 <span class="comment">/*</span>
<a name="l00668"></a>00668 <span class="comment">template &lt;typename T&gt;</span>
<a name="l00669"></a>00669 <span class="comment">inline</span>
<a name="l00670"></a>00670 <span class="comment">NumericVector&lt;T&gt; &amp; NumericVector&lt;T&gt;::operator= (const T) </span>
<a name="l00671"></a>00671 <span class="comment">{</span>
<a name="l00672"></a>00672 <span class="comment">  //  libmesh_error();</span>
<a name="l00673"></a>00673 <span class="comment"></span>
<a name="l00674"></a>00674 <span class="comment">  return *this;</span>
<a name="l00675"></a>00675 <span class="comment">}</span>
<a name="l00676"></a>00676 <span class="comment"></span>
<a name="l00677"></a>00677 <span class="comment"></span>
<a name="l00678"></a>00678 <span class="comment"></span>
<a name="l00679"></a>00679 <span class="comment">template &lt;typename T&gt;</span>
<a name="l00680"></a>00680 <span class="comment">inline</span>
<a name="l00681"></a>00681 <span class="comment">NumericVector&lt;T&gt; &amp; NumericVector&lt;T&gt;::operator= (const NumericVector&lt;T&gt;&amp;) </span>
<a name="l00682"></a>00682 <span class="comment">{</span>
<a name="l00683"></a>00683 <span class="comment">  //  libmesh_error();</span>
<a name="l00684"></a>00684 <span class="comment"></span>
<a name="l00685"></a>00685 <span class="comment">  return *this;</span>
<a name="l00686"></a>00686 <span class="comment">}</span>
<a name="l00687"></a>00687 <span class="comment"></span>
<a name="l00688"></a>00688 <span class="comment"></span>
<a name="l00689"></a>00689 <span class="comment"></span>
<a name="l00690"></a>00690 <span class="comment">template &lt;typename T&gt;</span>
<a name="l00691"></a>00691 <span class="comment">inline</span>
<a name="l00692"></a>00692 <span class="comment">NumericVector&lt;T&gt; &amp; NumericVector&lt;T&gt;::operator= (const std::vector&lt;T&gt;&amp;) </span>
<a name="l00693"></a>00693 <span class="comment">{</span>
<a name="l00694"></a>00694 <span class="comment">  //  libmesh_error();</span>
<a name="l00695"></a>00695 <span class="comment"></span>
<a name="l00696"></a>00696 <span class="comment">  return *this;</span>
<a name="l00697"></a>00697 <span class="comment">}</span>
<a name="l00698"></a>00698 <span class="comment">*/</span>
<a name="l00699"></a>00699 
<a name="l00700"></a>00700 
<a name="l00701"></a>00701 
<a name="l00702"></a>00702 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00703"></a>00703 <span class="keyword">inline</span>
<a name="l00704"></a><a class="code" href="classNumericVector.php#a00f9162aaeaaf8658d3fc95408a778b6">00704</a> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#a00f9162aaeaaf8658d3fc95408a778b6">NumericVector&lt;T&gt;::clear</a> ()
<a name="l00705"></a>00705 {
<a name="l00706"></a>00706   _is_closed      = <span class="keyword">false</span>;
<a name="l00707"></a>00707   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00708"></a>00708 }
<a name="l00709"></a>00709   
<a name="l00710"></a>00710   
<a name="l00711"></a>00711   
<a name="l00712"></a>00712 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00713"></a>00713 <span class="keyword">inline</span>
<a name="l00714"></a><a class="code" href="classNumericVector.php#a4d76021b1be23b502169e3dfc57ea83f">00714</a> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#a4d76021b1be23b502169e3dfc57ea83f">NumericVector&lt;T&gt;::get</a>(<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; index, std::vector&lt;T&gt;&amp; values)<span class="keyword"> const</span>
<a name="l00715"></a>00715 <span class="keyword"></span>{
<a name="l00716"></a>00716   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num = index.size();
<a name="l00717"></a>00717   values.resize(num);
<a name="l00718"></a>00718   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;num; i++)
<a name="l00719"></a>00719     {
<a name="l00720"></a>00720       values[i] = (*this)(index[i]);
<a name="l00721"></a>00721     }
<a name="l00722"></a>00722 }
<a name="l00723"></a>00723 
<a name="l00724"></a>00724 
<a name="l00725"></a>00725 
<a name="l00726"></a>00726 <span class="comment">// Full specialization of the print() member for complex</span>
<a name="l00727"></a>00727 <span class="comment">// variables.  This must precede the non-specialized</span>
<a name="l00728"></a>00728 <span class="comment">// version, at least according to icc v7.1</span>
<a name="l00729"></a>00729 <span class="keyword">template</span> &lt;&gt;
<a name="l00730"></a>00730 <span class="keyword">inline</span>
<a name="l00731"></a><a class="code" href="classNumericVector.php#aa9a703131a9e6f40403b8a46cebdf628">00731</a> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#acfb8a6c4ec8447a49f68a59c1406ba00">NumericVector&lt;Complex&gt;::print</a>(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00732"></a>00732 <span class="keyword"></span>{
<a name="l00733"></a>00733   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00734"></a>00734   os &lt;&lt; <span class="stringliteral">&quot;Size\tglobal =  &quot;</span> &lt;&lt; this-&gt;size()
<a name="l00735"></a>00735      &lt;&lt; <span class="stringliteral">&quot;\t\tlocal =  &quot;</span> &lt;&lt; this-&gt;local_size() &lt;&lt; std::endl;
<a name="l00736"></a>00736   
<a name="l00737"></a>00737   <span class="comment">// std::complex&lt;&gt;::operator&lt;&lt;() is defined, but use this form</span>
<a name="l00738"></a>00738   os &lt;&lt; <span class="stringliteral">&quot;#\tReal part\t\tImaginary part&quot;</span> &lt;&lt; std::endl;
<a name="l00739"></a>00739   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=this-&gt;first_local_index(); i&lt;this-&gt;last_local_index(); i++)
<a name="l00740"></a>00740     os &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;\t&quot;</span> 
<a name="l00741"></a>00741        &lt;&lt; (*<span class="keyword">this</span>)(i).real() &lt;&lt; <span class="stringliteral">&quot;\t\t&quot;</span> 
<a name="l00742"></a>00742        &lt;&lt; (*this)(i).imag() &lt;&lt; std::endl;
<a name="l00743"></a>00743 }
<a name="l00744"></a>00744 
<a name="l00745"></a>00745 
<a name="l00746"></a>00746 
<a name="l00747"></a>00747 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00748"></a>00748 <span class="keyword">inline</span>
<a name="l00749"></a><a class="code" href="classNumericVector.php#acfb8a6c4ec8447a49f68a59c1406ba00">00749</a> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#acfb8a6c4ec8447a49f68a59c1406ba00">NumericVector&lt;T&gt;::print</a>(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00750"></a>00750 <span class="keyword"></span>{
<a name="l00751"></a>00751   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00752"></a>00752   os &lt;&lt; <span class="stringliteral">&quot;Size\tglobal =  &quot;</span> &lt;&lt; this-&gt;size()
<a name="l00753"></a>00753      &lt;&lt; <span class="stringliteral">&quot;\t\tlocal =  &quot;</span> &lt;&lt; this-&gt;local_size() &lt;&lt; std::endl;
<a name="l00754"></a>00754 
<a name="l00755"></a>00755   os &lt;&lt; <span class="stringliteral">&quot;#\tValue&quot;</span> &lt;&lt; std::endl;
<a name="l00756"></a>00756   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=this-&gt;first_local_index(); i&lt;this-&gt;last_local_index(); i++)
<a name="l00757"></a>00757     os &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;\t&quot;</span> &lt;&lt; (*<span class="keyword">this</span>)(i) &lt;&lt; std::endl;
<a name="l00758"></a>00758 }
<a name="l00759"></a>00759 
<a name="l00760"></a>00760 
<a name="l00761"></a>00761 
<a name="l00762"></a>00762 <span class="keyword">template</span> &lt;&gt;
<a name="l00763"></a>00763 <span class="keyword">inline</span>
<a name="l00764"></a><a class="code" href="classNumericVector.php#a4b3c5e857236309cf018f2ea7cbeae1c">00764</a> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#acc9cf91eb078b1d8715448251603ad6d">NumericVector&lt;Complex&gt;::print_global</a>(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00765"></a>00765 <span class="keyword"></span>{
<a name="l00766"></a>00766   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00767"></a>00767 
<a name="l00768"></a>00768   std::vector&lt;Complex&gt; v(this-&gt;size());
<a name="l00769"></a>00769   this-&gt;localize(v);
<a name="l00770"></a>00770 
<a name="l00771"></a>00771   <span class="comment">// Right now we only want one copy of the output</span>
<a name="l00772"></a>00772   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00773"></a>00773     <span class="keywordflow">return</span>;
<a name="l00774"></a>00774   
<a name="l00775"></a>00775   os &lt;&lt; <span class="stringliteral">&quot;Size\tglobal =  &quot;</span> &lt;&lt; this-&gt;size() &lt;&lt; std::endl;
<a name="l00776"></a>00776   os &lt;&lt; <span class="stringliteral">&quot;#\tReal part\t\tImaginary part&quot;</span> &lt;&lt; std::endl;
<a name="l00777"></a>00777   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=v.size(); i++)
<a name="l00778"></a>00778     os &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;\t&quot;</span> 
<a name="l00779"></a>00779        &lt;&lt; v[i].real() &lt;&lt; <span class="stringliteral">&quot;\t\t&quot;</span> 
<a name="l00780"></a>00780        &lt;&lt; v[i].imag() &lt;&lt; std::endl;
<a name="l00781"></a>00781 }
<a name="l00782"></a>00782 
<a name="l00783"></a>00783 
<a name="l00784"></a>00784 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00785"></a>00785 <span class="keyword">inline</span>
<a name="l00786"></a><a class="code" href="classNumericVector.php#acc9cf91eb078b1d8715448251603ad6d">00786</a> <span class="keywordtype">void</span> <a class="code" href="classNumericVector.php#acc9cf91eb078b1d8715448251603ad6d">NumericVector&lt;T&gt;::print_global</a>(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00787"></a>00787 <span class="keyword"></span>{
<a name="l00788"></a>00788   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00789"></a>00789 
<a name="l00790"></a>00790   std::vector&lt;T&gt; v(this-&gt;size());
<a name="l00791"></a>00791   this-&gt;localize(v);
<a name="l00792"></a>00792 
<a name="l00793"></a>00793   <span class="comment">// Right now we only want one copy of the output</span>
<a name="l00794"></a>00794   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00795"></a>00795     <span class="keywordflow">return</span>;
<a name="l00796"></a>00796 
<a name="l00797"></a>00797   os &lt;&lt; <span class="stringliteral">&quot;Size\tglobal =  &quot;</span> &lt;&lt; this-&gt;size() &lt;&lt; std::endl;
<a name="l00798"></a>00798   os &lt;&lt; <span class="stringliteral">&quot;#\tValue&quot;</span> &lt;&lt; std::endl;
<a name="l00799"></a>00799   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=v.size(); i++)
<a name="l00800"></a>00800     os &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;\t&quot;</span> &lt;&lt; v[i] &lt;&lt; std::endl;
<a name="l00801"></a>00801 }
<a name="l00802"></a>00802 
<a name="l00803"></a>00803 
<a name="l00804"></a>00804 
<a name="l00805"></a>00805 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00806"></a>00806 <span class="keyword">inline</span>
<a name="l00807"></a><a class="code" href="classNumericVector.php#a51e2011eeca6faa30e349c1950352eb8">00807</a> <span class="keywordtype">void</span>  <a class="code" href="classNumericVector.php#a51e2011eeca6faa30e349c1950352eb8">NumericVector&lt;T&gt;::swap</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;v)
<a name="l00808"></a>00808 {
<a name="l00809"></a>00809   std::swap(_is_closed, v.<a class="code" href="classNumericVector.php#a5fb110426b9570de8690d317424a310b">_is_closed</a>);
<a name="l00810"></a>00810   std::swap(<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a>, v.<a class="code" href="classNumericVector.php#ac4a667077b6ec42b9a35a9aed43fc92e">_is_initialized</a>);
<a name="l00811"></a>00811   std::swap(_type, v.<a class="code" href="classNumericVector.php#a26410625410635a53bf754077ff88173">_type</a>);
<a name="l00812"></a>00812 }
<a name="l00813"></a>00813 
<a name="l00814"></a>00814 
<a name="l00815"></a>00815 
<a name="l00816"></a>00816 <span class="preprocessor">#endif  // #ifdef __numeric_vector_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
