<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_4f64d75cac7489d141591c33108e86ff.php">utils</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>o_string_stream.h</h1>  </div>
</div>
<div class="contents">
<a href="o__string__stream_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: o_string_stream.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __o_string_stream_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __o_string_stream_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Mesh configuration options</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="preprocessor">#ifdef LIBMESH_HAVE_SSTREAM</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span>
<a name="l00034"></a>00034 <span class="comment">// C++ includes</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &lt;sstream&gt;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Local Includes</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">// Forward Declarations</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="comment">/*</span>
<a name="l00046"></a>00046 <span class="comment"> * Some compilers, at least HP \p aCC do not even</span>
<a name="l00047"></a>00047 <span class="comment"> * accept empty classes derived from \p std::ostringstream.</span>
<a name="l00048"></a>00048 <span class="comment"> * Therefore, resort to preprocessor definitions. </span>
<a name="l00049"></a>00049 <span class="comment"> */</span>
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 <span class="preprocessor">#ifndef LIBMESH_BROKEN_IOSTREAM</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span> <span class="comment">/*</span>
<a name="l00053"></a>00053 <span class="comment">  * ---------------------------------------------------------------------------------</span>
<a name="l00054"></a>00054 <span class="comment">  * Everything for a clean iostream</span>
<a name="l00055"></a>00055 <span class="comment">  */</span>
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 <span class="preprocessor"># include &lt;iomanip&gt;</span>
<a name="l00058"></a>00058 
<a name="l00059"></a>00059  <span class="comment">/*</span>
<a name="l00060"></a>00060 <span class="comment">  * Outputs \p std::string \p d with width </span>
<a name="l00061"></a>00061 <span class="comment">  * \p v left-formatted to stream \p o.</span>
<a name="l00062"></a>00062 <span class="comment">  */</span>
<a name="l00063"></a>00063 <span class="preprocessor"># define OSSStringleft(o,v,d)       (o).width(v);  (o) &lt;&lt; std::left &lt;&lt; (d)</span>
<a name="l00064"></a>00064 <span class="preprocessor"></span>
<a name="l00065"></a>00065  <span class="comment">/*</span>
<a name="l00066"></a>00066 <span class="comment">  * Outputs \p std::string \p d with width </span>
<a name="l00067"></a>00067 <span class="comment">  * \p v right-formatted to stream \p o.</span>
<a name="l00068"></a>00068 <span class="comment">  */</span>
<a name="l00069"></a>00069 <span class="preprocessor"># define OSSStringright(o,v,d)      (o).width(v);  (o) &lt;&lt; std::right &lt;&lt; (d)</span>
<a name="l00070"></a>00070 <span class="preprocessor"></span>
<a name="l00071"></a>00071  <span class="comment">/*</span>
<a name="l00072"></a>00072 <span class="comment">  * Outputs \p Real \p d with width \p v and</span>
<a name="l00073"></a>00073 <span class="comment">  * precision \p p to stream \p o (padded with</span>
<a name="l00074"></a>00074 <span class="comment">  * whitespaces).</span>
<a name="l00075"></a>00075 <span class="comment">  */</span>
<a name="l00076"></a>00076 <span class="preprocessor"># define OSSRealleft(o,v,p,d)       (o).width(v);  (o).precision(p); (o).fill(&#39; &#39;); (o) &lt;&lt; (d)</span>
<a name="l00077"></a>00077 <span class="preprocessor"></span>
<a name="l00078"></a>00078  <span class="comment">/*</span>
<a name="l00079"></a>00079 <span class="comment">  * Outputs \p Real \p d with width \p v and</span>
<a name="l00080"></a>00080 <span class="comment">  * precision \p p to stream \p o (padded with </span>
<a name="l00081"></a>00081 <span class="comment">  * zeros).</span>
<a name="l00082"></a>00082 <span class="comment">  */</span>
<a name="l00083"></a>00083 <span class="preprocessor"># define OSSRealzeroleft(o,v,p,d)   (o).width(v); (o).precision(p); (o).fill(&#39;0&#39;); (o) &lt;&lt; std::showpoint &lt;&lt; std::left &lt;&lt; (d)</span>
<a name="l00084"></a>00084 <span class="preprocessor"></span>
<a name="l00085"></a>00085  <span class="comment">/*</span>
<a name="l00086"></a>00086 <span class="comment">  * Outputs \p Real \p d with width \p v and</span>
<a name="l00087"></a>00087 <span class="comment">  * precision \p p to stream \p o (padded with</span>
<a name="l00088"></a>00088 <span class="comment">  * whitespaces).</span>
<a name="l00089"></a>00089 <span class="comment">  */</span>
<a name="l00090"></a>00090 <span class="preprocessor"># define OSSRealright(o,v,p,d)       (o).width(v);  (o).precision(p); (o).fill(&#39; &#39;); (o) &lt;&lt; std::right &lt;&lt; (d)</span>
<a name="l00091"></a>00091 <span class="preprocessor"></span>
<a name="l00092"></a>00092  <span class="comment">/*</span>
<a name="l00093"></a>00093 <span class="comment">  * Outputs \p Real \p d with width \p v and</span>
<a name="l00094"></a>00094 <span class="comment">  * precision \p p to stream \p o (padded with</span>
<a name="l00095"></a>00095 <span class="comment">  * zeros).</span>
<a name="l00096"></a>00096 <span class="comment">  */</span>
<a name="l00097"></a>00097 <span class="preprocessor"># define OSSRealzeroright(o,v,p,d)   (o).width(v);  (o).precision(p); (o).fill(&#39;0&#39;); (o) &lt;&lt; std::right &lt;&lt; (d) </span>
<a name="l00098"></a>00098 <span class="preprocessor"></span>
<a name="l00099"></a>00099  <span class="comment">/*</span>
<a name="l00100"></a>00100 <span class="comment">  * Outputs \p Real \p d with width \p v</span>
<a name="l00101"></a>00101 <span class="comment">  * in scientific format to stream \p o.</span>
<a name="l00102"></a>00102 <span class="comment">  */</span>
<a name="l00103"></a>00103 <span class="preprocessor"># define OSSRealscientific(o,v,d)   (o) &lt;&lt; std::setw(v) &lt;&lt; std::scientific &lt;&lt; (d)</span>
<a name="l00104"></a>00104 <span class="preprocessor"></span>
<a name="l00105"></a>00105  <span class="comment">/*</span>
<a name="l00106"></a>00106 <span class="comment">  * Outputs \p int \p d with width </span>
<a name="l00107"></a>00107 <span class="comment">  * \p v to stream \p o.</span>
<a name="l00108"></a>00108 <span class="comment">  */</span>
<a name="l00109"></a>00109 <span class="preprocessor"># define OSSInt(o,v,d)              (o).width(v);  (o) &lt;&lt; (d)</span>
<a name="l00110"></a>00110 <span class="preprocessor"></span>
<a name="l00111"></a>00111  <span class="comment">/*</span>
<a name="l00112"></a>00112 <span class="comment">  * class alias</span>
<a name="l00113"></a>00113 <span class="comment">  */</span>
<a name="l00114"></a>00114 <span class="comment">//# define OStringStream           std::ostringstream</span>
<a name="l00115"></a><a class="code" href="o__string__stream_8h.php#a404e79e210a38d985b3bfdab1e496280">00115</a> <span class="keyword">typedef</span> std::ostringstream <a class="code" href="o__string__stream_8h.php#a404e79e210a38d985b3bfdab1e496280">OStringStream</a>;
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 <span class="preprocessor">#else</span>
<a name="l00121"></a>00121 <span class="preprocessor"></span> <span class="comment">/*</span>
<a name="l00122"></a>00122 <span class="comment">  * ---------------------------------------------------------------------------------</span>
<a name="l00123"></a>00123 <span class="comment">  * Everything for broken iostream</span>
<a name="l00124"></a>00124 <span class="comment">  */</span>
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 <span class="preprocessor"># include &lt;cstdio&gt;</span>
<a name="l00127"></a>00127 
<a name="l00128"></a>00128  <span class="comment">/*</span>
<a name="l00129"></a>00129 <span class="comment">  * Outputs \p std::string \p d with width </span>
<a name="l00130"></a>00130 <span class="comment">  * \p v left-formatted to stream \p o.</span>
<a name="l00131"></a>00131 <span class="comment">  */</span>
<a name="l00132"></a>00132 <span class="preprocessor"># define OSSStringleft(o,v,d)       (o).left( (v), (d) )</span>
<a name="l00133"></a>00133 <span class="preprocessor"></span>
<a name="l00134"></a>00134  <span class="comment">/*</span>
<a name="l00135"></a>00135 <span class="comment">  * Outputs \p std::string \p d with width </span>
<a name="l00136"></a>00136 <span class="comment">  * \p v right-formatted to stream \p o.</span>
<a name="l00137"></a>00137 <span class="comment">  */</span>
<a name="l00138"></a>00138 <span class="preprocessor"># define OSSStringright(o,v,d)      (o).right( (v), (d) )</span>
<a name="l00139"></a>00139 <span class="preprocessor"></span>
<a name="l00140"></a>00140  <span class="comment">/*</span>
<a name="l00141"></a>00141 <span class="comment">  * Outputs \p Real \p d with width \p v and</span>
<a name="l00142"></a>00142 <span class="comment">  * precision \p p to stream \p o (padded with</span>
<a name="l00143"></a>00143 <span class="comment">  * whitespaces).</span>
<a name="l00144"></a>00144 <span class="comment">  */</span>
<a name="l00145"></a>00145 <span class="preprocessor"># define OSSRealleft(o,v,p,d)       (o).left( (v), (p), (d) , &#39; &#39;)</span>
<a name="l00146"></a>00146 <span class="preprocessor"></span>
<a name="l00147"></a>00147  <span class="comment">/*</span>
<a name="l00148"></a>00148 <span class="comment">  * Outputs \p Real \p d with width \p v and</span>
<a name="l00149"></a>00149 <span class="comment">  * precision \p p to stream \p o (padded with</span>
<a name="l00150"></a>00150 <span class="comment">  * zeros).</span>
<a name="l00151"></a>00151 <span class="comment">  */</span>
<a name="l00152"></a>00152 <span class="preprocessor"># define OSSRealzeroleft(o,v,p,d)       (o).left( (v), (p), (d) , &#39;0&#39;)</span>
<a name="l00153"></a>00153 <span class="preprocessor"></span>
<a name="l00154"></a>00154  <span class="comment">/*</span>
<a name="l00155"></a>00155 <span class="comment">  * Outputs \p Real \p d with width \p v and</span>
<a name="l00156"></a>00156 <span class="comment">  * precision \p p to stream \p o (padded with</span>
<a name="l00157"></a>00157 <span class="comment">  * whitespaces).</span>
<a name="l00158"></a>00158 <span class="comment">  */</span>
<a name="l00159"></a>00159 <span class="preprocessor"># define OSSRealright(o,v,p,d)      (o).right( (v), (p), (d) ,&#39; &#39;) </span>
<a name="l00160"></a>00160 <span class="preprocessor"></span>
<a name="l00161"></a>00161  <span class="comment">/*</span>
<a name="l00162"></a>00162 <span class="comment">  * Outputs \p Real \p d with width \p v and</span>
<a name="l00163"></a>00163 <span class="comment">  * precision \p p to stream \p o (padded with</span>
<a name="l00164"></a>00164 <span class="comment">  * zeros).</span>
<a name="l00165"></a>00165 <span class="comment">  */</span>
<a name="l00166"></a>00166 <span class="preprocessor"># define OSSRealzeroright(o,v,p,d)      (o).right( (v), (p), (d) ,&#39;0&#39;) </span>
<a name="l00167"></a>00167 <span class="preprocessor"></span>
<a name="l00168"></a>00168  <span class="comment">/*</span>
<a name="l00169"></a>00169 <span class="comment">  * Outputs \p Real \p d with width \p v</span>
<a name="l00170"></a>00170 <span class="comment">  * in scientific format to stream \p o.</span>
<a name="l00171"></a>00171 <span class="comment">  */</span>
<a name="l00172"></a>00172 <span class="preprocessor"># define OSSRealscientific(o,v,d)   (o).scientific( (v), (d) )</span>
<a name="l00173"></a>00173 <span class="preprocessor"></span>
<a name="l00174"></a>00174  <span class="comment">/*</span>
<a name="l00175"></a>00175 <span class="comment">  * Outputs \p int \p d with width </span>
<a name="l00176"></a>00176 <span class="comment">  * \p v to stream \p o.</span>
<a name="l00177"></a>00177 <span class="comment">  */</span>
<a name="l00178"></a>00178 <span class="preprocessor"># define OSSInt(o,v,d)              (o).left( (v), (d) )</span>
<a name="l00179"></a>00179 <span class="preprocessor"></span>
<a name="l00180"></a>00180 <span class="comment">//  /*</span>
<a name="l00181"></a>00181 <span class="comment">//   * class alias</span>
<a name="l00182"></a>00182 <span class="comment">//   */</span>
<a name="l00183"></a>00183 <span class="comment">// # define OSSOStringStream           OStringStream</span>
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 
<a name="l00193"></a>00193  <span class="comment">// ------------------------------------------------------------</span>
<a name="l00194"></a>00194  <span class="comment">// OStringStream class definition</span>
<a name="l00195"></a><a class="code" href="classOStringStream.php">00195</a>  <span class="keyword">class </span><a class="code" href="classOStringStream.php">OStringStream</a> : <span class="keyword">public</span> std::ostringstream
<a name="l00196"></a>00196  {
<a name="l00197"></a>00197  <span class="keyword">public</span>:
<a name="l00198"></a>00198 
<a name="l00202"></a><a class="code" href="classOStringStream.php#ab77da1ad9a3bda9fbcab8282e62a9d0f">00202</a>   <a class="code" href="classOStringStream.php#ab77da1ad9a3bda9fbcab8282e62a9d0f">OStringStream</a> () : std::ostringstream() {};
<a name="l00203"></a>00203 
<a name="l00207"></a><a class="code" href="classOStringStream.php#a40db9b7c343af211da107b3066e51ab1">00207</a>   <a class="code" href="classOStringStream.php#a40db9b7c343af211da107b3066e51ab1">~OStringStream</a> () {};
<a name="l00208"></a>00208 
<a name="l00212"></a>00212   <span class="keyword">typedef</span> std::string::size_type <a class="code" href="classOStringStream.php#a594b3ca7f2040836be32a6d16d4616e2">sizetype</a>;
<a name="l00213"></a>00213 
<a name="l00219"></a>00219   <span class="keywordtype">void</span> <a class="code" href="classOStringStream.php#aa907b4c1b66b27428a17520509634488">left</a> (<span class="keyword">const</span> <a class="code" href="classOStringStream.php#a594b3ca7f2040836be32a6d16d4616e2">sizetype</a> w,
<a name="l00220"></a>00220              <span class="keyword">const</span> std::string&amp; s);
<a name="l00221"></a>00221 
<a name="l00227"></a>00227   <span class="keywordtype">void</span> <a class="code" href="classOStringStream.php#aa907b4c1b66b27428a17520509634488">left</a> (<span class="keyword">const</span> <a class="code" href="classOStringStream.php#a594b3ca7f2040836be32a6d16d4616e2">sizetype</a> w,
<a name="l00228"></a>00228              <span class="keyword">const</span> <a class="code" href="classOStringStream.php#a594b3ca7f2040836be32a6d16d4616e2">sizetype</a> prec,
<a name="l00229"></a>00229              <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> r,
<a name="l00230"></a>00230              <span class="keyword">const</span> <span class="keywordtype">char</span> c = <span class="charliteral">&#39; &#39;</span>);
<a name="l00231"></a>00231 
<a name="l00238"></a>00238   <span class="keywordtype">void</span> <a class="code" href="classOStringStream.php#aa907b4c1b66b27428a17520509634488">left</a> (<span class="keyword">const</span> <a class="code" href="classOStringStream.php#a594b3ca7f2040836be32a6d16d4616e2">sizetype</a> w,
<a name="l00239"></a>00239              <span class="keyword">const</span> <span class="keywordtype">int</span> n);
<a name="l00240"></a>00240 
<a name="l00246"></a>00246   <span class="keywordtype">void</span> <a class="code" href="classOStringStream.php#a67f1bf19952cc449208bd2340ab4cf8f">right</a> (<span class="keyword">const</span> <a class="code" href="classOStringStream.php#a594b3ca7f2040836be32a6d16d4616e2">sizetype</a> w,
<a name="l00247"></a>00247               <span class="keyword">const</span> std::string&amp; s);
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 
<a name="l00256"></a>00256   <span class="keywordtype">void</span> <a class="code" href="classOStringStream.php#a67f1bf19952cc449208bd2340ab4cf8f">right</a> (<span class="keyword">const</span> <a class="code" href="classOStringStream.php#a594b3ca7f2040836be32a6d16d4616e2">sizetype</a> w,
<a name="l00257"></a>00257               <span class="keyword">const</span> <a class="code" href="classOStringStream.php#a594b3ca7f2040836be32a6d16d4616e2">sizetype</a> prec,
<a name="l00258"></a>00258               <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> r,
<a name="l00259"></a>00259               <span class="keyword">const</span> <span class="keywordtype">char</span> c = <span class="charliteral">&#39; &#39;</span>);
<a name="l00260"></a>00260 
<a name="l00266"></a>00266   <span class="keywordtype">void</span> <a class="code" href="classOStringStream.php#a59a58ae3976d9dd3ce957cd3df8bbf9e">scientific</a> (<span class="keyword">const</span> <a class="code" href="classOStringStream.php#a594b3ca7f2040836be32a6d16d4616e2">sizetype</a> w,
<a name="l00267"></a>00267                    <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> r);
<a name="l00268"></a>00268 
<a name="l00269"></a>00269  <span class="keyword">protected</span>:
<a name="l00274"></a>00274   <span class="keywordtype">void</span> <a class="code" href="classOStringStream.php#a3a859890623889264001276d7c3e5100">print_ws</a> (<span class="keyword">const</span> <a class="code" href="classOStringStream.php#a594b3ca7f2040836be32a6d16d4616e2">sizetype</a> n,
<a name="l00275"></a>00275                  <span class="keyword">const</span> <span class="keywordtype">char</span> c = <span class="charliteral">&#39; &#39;</span>);
<a name="l00276"></a>00276 
<a name="l00277"></a>00277  };
<a name="l00278"></a>00278 
<a name="l00279"></a>00279 
<a name="l00280"></a>00280 
<a name="l00281"></a>00281  <span class="comment">// ------------------------------------------------------------</span>
<a name="l00282"></a>00282  <span class="comment">// OStringStream inline methods</span>
<a name="l00283"></a>00283  <span class="keyword">inline</span>
<a name="l00284"></a><a class="code" href="classOStringStream.php#aa907b4c1b66b27428a17520509634488">00284</a>  <span class="keywordtype">void</span> <a class="code" href="classOStringStream.php#aa907b4c1b66b27428a17520509634488">OStringStream::left</a> (<span class="keyword">const</span> <a class="code" href="classOStringStream.php#a594b3ca7f2040836be32a6d16d4616e2">sizetype</a> w,
<a name="l00285"></a>00285                            <span class="keyword">const</span> std::string&amp; s)
<a name="l00286"></a>00286  {
<a name="l00287"></a>00287    *<span class="keyword">this</span> &lt;&lt; s;
<a name="l00288"></a>00288    <span class="comment">// pad with whitespaces afterwards</span>
<a name="l00289"></a>00289    <a class="code" href="classOStringStream.php#a3a859890623889264001276d7c3e5100">print_ws</a> ((w-s.size()));
<a name="l00290"></a>00290  }
<a name="l00291"></a>00291 
<a name="l00292"></a>00292 
<a name="l00293"></a>00293  <span class="keyword">inline</span>
<a name="l00294"></a><a class="code" href="classOStringStream.php#a4e1a3240da8d06ef16fd9143e7d862f6">00294</a>  <span class="keywordtype">void</span> <a class="code" href="classOStringStream.php#aa907b4c1b66b27428a17520509634488">OStringStream::left</a> (<span class="keyword">const</span> <a class="code" href="classOStringStream.php#a594b3ca7f2040836be32a6d16d4616e2">sizetype</a> w,
<a name="l00295"></a>00295                            <span class="keyword">const</span> <a class="code" href="classOStringStream.php#a594b3ca7f2040836be32a6d16d4616e2">sizetype</a> prec,
<a name="l00296"></a>00296                            <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> r,
<a name="l00297"></a>00297                            <span class="keyword">const</span> <span class="keywordtype">char</span> c)
<a name="l00298"></a>00298  {
<a name="l00299"></a>00299    libmesh_assert (w &lt; 30);
<a name="l00300"></a>00300    <span class="keywordtype">char</span> buf[30];  
<a name="l00301"></a>00301    <span class="keywordtype">char</span> format[8];
<a name="l00302"></a>00302    <span class="comment">// form the format for r</span>
<a name="l00303"></a>00303    <span class="comment">// ALTERNATIVE: sprintf (format, &quot;%%%d.%df&quot;, int((w-prec)/2), prec);</span>
<a name="l00304"></a>00304    sprintf (format, <span class="stringliteral">&quot;%%.%df&quot;</span>, prec);
<a name="l00305"></a>00305    <span class="comment">// form string as desired</span>
<a name="l00306"></a>00306    sprintf (buf, format, r);
<a name="l00307"></a>00307    *<span class="keyword">this</span> &lt;&lt; buf;
<a name="l00308"></a>00308    <span class="comment">// pad with whitespaces afterwards</span>
<a name="l00309"></a>00309    <a class="code" href="classOStringStream.php#a3a859890623889264001276d7c3e5100">print_ws</a> (w-std::string(buf).size(), c);
<a name="l00310"></a>00310    <span class="comment">// ALTERNATIVE: print_ws (w-int((w-prec)/2));</span>
<a name="l00311"></a>00311  }
<a name="l00312"></a>00312 
<a name="l00313"></a>00313 
<a name="l00314"></a>00314  <span class="keyword">inline</span>
<a name="l00315"></a><a class="code" href="classOStringStream.php#a80bb5253a9d3ca197e4032502d394615">00315</a>  <span class="keywordtype">void</span> <a class="code" href="classOStringStream.php#aa907b4c1b66b27428a17520509634488">OStringStream::left</a> (<span class="keyword">const</span> <a class="code" href="classOStringStream.php#a594b3ca7f2040836be32a6d16d4616e2">sizetype</a> w,
<a name="l00316"></a>00316                            <span class="keyword">const</span> <span class="keywordtype">int</span> n)
<a name="l00317"></a>00317  {
<a name="l00318"></a>00318    libmesh_assert (w &lt; 30);
<a name="l00319"></a>00319    <span class="keywordtype">char</span> buf[30];  
<a name="l00320"></a>00320    <span class="comment">// form string as desired</span>
<a name="l00321"></a>00321    sprintf (buf, <span class="stringliteral">&quot;%d&quot;</span>, n);
<a name="l00322"></a>00322    *<span class="keyword">this</span> &lt;&lt; buf;
<a name="l00323"></a>00323    <span class="comment">// pad with whitespaces afterwards</span>
<a name="l00324"></a>00324    <a class="code" href="classOStringStream.php#a3a859890623889264001276d7c3e5100">print_ws</a> (w-std::string(buf).size());
<a name="l00325"></a>00325  }
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 
<a name="l00328"></a>00328  <span class="keyword">inline</span>
<a name="l00329"></a><a class="code" href="classOStringStream.php#a67f1bf19952cc449208bd2340ab4cf8f">00329</a>  <span class="keywordtype">void</span> <a class="code" href="classOStringStream.php#a67f1bf19952cc449208bd2340ab4cf8f">OStringStream::right</a> (<span class="keyword">const</span> <a class="code" href="classOStringStream.php#a594b3ca7f2040836be32a6d16d4616e2">sizetype</a> w,
<a name="l00330"></a>00330                             <span class="keyword">const</span> std::string&amp; s)
<a name="l00331"></a>00331  {
<a name="l00332"></a>00332    <span class="comment">// first pad with whitespaces</span>
<a name="l00333"></a>00333    <a class="code" href="classOStringStream.php#a3a859890623889264001276d7c3e5100">print_ws</a> ((w-s.size()));
<a name="l00334"></a>00334    *<span class="keyword">this</span> &lt;&lt; s;
<a name="l00335"></a>00335  }
<a name="l00336"></a>00336 
<a name="l00337"></a>00337 
<a name="l00338"></a>00338  <span class="keyword">inline</span>
<a name="l00339"></a><a class="code" href="classOStringStream.php#a244ee7a18fa622badd6c153ed81eb193">00339</a>  <span class="keywordtype">void</span> <a class="code" href="classOStringStream.php#a67f1bf19952cc449208bd2340ab4cf8f">OStringStream::right</a> (<span class="keyword">const</span> <a class="code" href="classOStringStream.php#a594b3ca7f2040836be32a6d16d4616e2">sizetype</a> w,
<a name="l00340"></a>00340                             <span class="keyword">const</span> <a class="code" href="classOStringStream.php#a594b3ca7f2040836be32a6d16d4616e2">sizetype</a> prec,
<a name="l00341"></a>00341                             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> r,
<a name="l00342"></a>00342                             <span class="keyword">const</span> <span class="keywordtype">char</span> c)
<a name="l00343"></a>00343  {
<a name="l00344"></a>00344    libmesh_assert (w &lt; 30);
<a name="l00345"></a>00345    <span class="keywordtype">char</span> buf[30];  
<a name="l00346"></a>00346    <span class="keywordtype">char</span> format[8];
<a name="l00347"></a>00347    <span class="comment">// form the format for r</span>
<a name="l00348"></a>00348    sprintf (format, <span class="stringliteral">&quot;%%.%df&quot;</span>, prec);
<a name="l00349"></a>00349    <span class="comment">// form string as desired</span>
<a name="l00350"></a>00350    sprintf (buf, format, r);
<a name="l00351"></a>00351    <span class="comment">// first pad with the user-defined char</span>
<a name="l00352"></a>00352    <a class="code" href="classOStringStream.php#a3a859890623889264001276d7c3e5100">print_ws</a> (w-std::string(buf).size(), c);
<a name="l00353"></a>00353    <span class="comment">// then print the float</span>
<a name="l00354"></a>00354    *<span class="keyword">this</span> &lt;&lt; buf;
<a name="l00355"></a>00355  }
<a name="l00356"></a>00356 
<a name="l00357"></a>00357 
<a name="l00358"></a>00358  <span class="keyword">inline</span>
<a name="l00359"></a><a class="code" href="classOStringStream.php#a59a58ae3976d9dd3ce957cd3df8bbf9e">00359</a>  <span class="keywordtype">void</span> <a class="code" href="classOStringStream.php#a59a58ae3976d9dd3ce957cd3df8bbf9e">OStringStream::scientific</a> (<span class="keyword">const</span> <a class="code" href="classOStringStream.php#a594b3ca7f2040836be32a6d16d4616e2">sizetype</a> w,
<a name="l00360"></a>00360                                  <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> r)
<a name="l00361"></a>00361  {
<a name="l00362"></a>00362    libmesh_assert (w &lt; 30);
<a name="l00363"></a>00363    <span class="keywordtype">char</span> buf[30];  
<a name="l00364"></a>00364    <span class="keywordtype">char</span> format[8];
<a name="l00365"></a>00365    <span class="comment">// form the format for r</span>
<a name="l00366"></a>00366    sprintf (format, <span class="stringliteral">&quot;%%%de&quot;</span>, w);
<a name="l00367"></a>00367    <span class="comment">// form string as desired</span>
<a name="l00368"></a>00368    sprintf (buf, format, r);
<a name="l00369"></a>00369    *<span class="keyword">this</span> &lt;&lt; buf;
<a name="l00370"></a>00370  }
<a name="l00371"></a>00371 
<a name="l00372"></a>00372 
<a name="l00373"></a>00373  <span class="keyword">inline</span>
<a name="l00374"></a><a class="code" href="classOStringStream.php#a3a859890623889264001276d7c3e5100">00374</a>  <span class="keywordtype">void</span> <a class="code" href="classOStringStream.php#a3a859890623889264001276d7c3e5100">OStringStream::print_ws</a> (<span class="keyword">const</span> <a class="code" href="classOStringStream.php#a594b3ca7f2040836be32a6d16d4616e2">sizetype</a> n,
<a name="l00375"></a>00375                                <span class="keyword">const</span> <span class="keywordtype">char</span> c)
<a name="l00376"></a>00376  {
<a name="l00377"></a>00377    <span class="keywordflow">for</span> (<a class="code" href="classOStringStream.php#a594b3ca7f2040836be32a6d16d4616e2">sizetype</a> i = 0; i &lt; n; i++)
<a name="l00378"></a>00378      *<span class="keyword">this</span> &lt;&lt; c;
<a name="l00379"></a>00379  }
<a name="l00380"></a>00380 
<a name="l00381"></a>00381 
<a name="l00382"></a>00382 <span class="preprocessor">#endif // ifndef ... else ... LIBMESH_BROKEN_IOSTREAM</span>
<a name="l00383"></a>00383 <span class="preprocessor"></span>
<a name="l00384"></a>00384 
<a name="l00385"></a>00385 
<a name="l00386"></a>00386 
<a name="l00387"></a>00387 <span class="preprocessor">#endif // ifdef LIBMESH_HAVE_SSTREAM</span>
<a name="l00388"></a>00388 <span class="preprocessor"></span>
<a name="l00389"></a>00389 <span class="preprocessor">#endif // ifndef __o_string_stream_h__</span>
<a name="l00390"></a>00390 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
