<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_52158fd467848760bd2e88c2cd6b831c.php">parallel</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>parallel_bin_sorter.C</h1>  </div>
</div>
<div class="contents">
<a href="parallel__bin__sorter_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: parallel_bin_sorter.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;iterator&gt;</span>   <span class="comment">// std::distance(), std::advance()</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;algorithm&gt;</span>  <span class="comment">// std::swap</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;iostream&gt;</span>   <span class="comment">// std::cout</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;parallel_bin_sorter.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;parallel_histogram.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#ifdef LIBMESH_HAVE_LIBHILBERT</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#  include &quot;hilbert.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#endif</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span><span class="preprocessor">#include &quot;parallel.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;parallel_conversion_utils.h&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a><a class="code" href="namespaceParallel.php">00038</a> <span class="keyword">namespace </span>Parallel {
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00041"></a><a class="code" href="classParallel_1_1BinSorter.php#a8dac8bb0db68fae64fc31dbbe45bf7eb">00041</a> <a class="code" href="classParallel_1_1BinSorter.php#a8dac8bb0db68fae64fc31dbbe45bf7eb">BinSorter&lt;KeyType&gt;::BinSorter</a> (<span class="keyword">const</span> std::vector&lt;KeyType&gt;&amp; d) :
<a name="l00042"></a>00042   data(d)
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044   <span class="comment">// Assume (&amp; libmesh_assert) we are working with a sorted range</span>
<a name="l00045"></a>00045 
<a name="l00046"></a>00046   <span class="comment">// Ah...  is_sorted is an STL extension!</span>
<a name="l00047"></a>00047   <span class="comment">//libmesh_assert (std::is_sorted (data.begin(), data.end()));</span>
<a name="l00048"></a>00048 
<a name="l00049"></a>00049   <span class="comment">// Home-grown is_sorted</span>
<a name="l00050"></a>00050   libmesh_assert (<a class="code" href="namespaceParallel_1_1Utils.php#a10a62091b54c73f7b5ea268e8dd7b178">Parallel::Utils::is_sorted</a> (<a class="code" href="classParallel_1_1BinSorter.php#a30031517d08bab4f74544004c4e8a5c0">data</a>));
<a name="l00051"></a>00051 }
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00056"></a><a class="code" href="classParallel_1_1BinSorter.php#a8e26ac21896524e4b00f1601a4fd8ec2">00056</a> <span class="keywordtype">void</span> <a class="code" href="classParallel_1_1BinSorter.php#a8e26ac21896524e4b00f1601a4fd8ec2">BinSorter&lt;KeyType&gt;::binsort</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nbins,
<a name="l00057"></a>00057                                   KeyType <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>,
<a name="l00058"></a>00058                                   KeyType <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>)
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060   libmesh_assert (min &lt; max);
<a name="l00061"></a>00061   
<a name="l00062"></a>00062   <span class="comment">// Build a histogram in parallel from our data.</span>
<a name="l00063"></a>00063   <span class="comment">// Use this to create quasi-uniform bins.</span>
<a name="l00064"></a>00064   <a class="code" href="classParallel_1_1Histogram.php">Parallel::Histogram&lt;KeyType&gt;</a> phist (data);
<a name="l00065"></a>00065   phist.<a class="code" href="classParallel_1_1Histogram.php#a600a34da3f9171131d978335f54ea0c4">make_histogram</a> (nbins*50, max, min);
<a name="l00066"></a>00066   phist.<a class="code" href="classParallel_1_1Histogram.php#a30de720d25ebb57229bb94784e240bd5">build_histogram</a> ();
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; histogram =
<a name="l00069"></a>00069     phist.<a class="code" href="classParallel_1_1Histogram.php#a139d20f807accfa9f60b8a1d391f361a">get_histogram</a>();
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   <span class="comment">// Now we will locate the bin boundaries so</span>
<a name="l00073"></a>00073   <span class="comment">// that each bin is roughly equal size</span>
<a name="l00074"></a>00074   {
<a name="l00075"></a>00075     <span class="comment">// Find the total size of the data set</span>
<a name="l00076"></a>00076     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_data_size = data.size();
<a name="l00077"></a>00077     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_data_size = local_data_size;
<a name="l00078"></a>00078 
<a name="l00079"></a>00079     Parallel::sum(global_data_size);
<a name="l00080"></a>00080     
<a name="l00081"></a>00081     std::vector&lt;unsigned int&gt; target_bin_size (nbins, global_data_size / nbins);
<a name="l00082"></a>00082     
<a name="l00083"></a>00083     <span class="comment">// Equally distribute the remainder</span>
<a name="l00084"></a>00084     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;(global_data_size % nbins); i++)
<a name="l00085"></a>00085       ++target_bin_size[i];
<a name="l00086"></a>00086     
<a name="l00087"></a>00087     <span class="comment">// Set the iterators corresponding to the bin boundaries</span>
<a name="l00088"></a>00088     {
<a name="l00089"></a>00089       std::vector&lt;double&gt; bin_bounds (nbins+1);
<a name="l00090"></a>00090       bin_iters.resize  (nbins+1, data.begin());
<a name="l00091"></a>00091       
<a name="l00092"></a>00092       <span class="comment">// Set the minimum bin boundary iterator</span>
<a name="l00093"></a>00093       bin_iters[0]  = data.begin();
<a name="l00094"></a>00094       bin_bounds[0] = <a class="code" href="namespaceParallel_1_1Utils.php#a7cb0d6aee3faa60b9d20c0db2d7fbb8b">Parallel::Utils::to_double</a>(min);
<a name="l00095"></a>00095       
<a name="l00096"></a>00096       <span class="comment">// The current location in the histogram</span>
<a name="l00097"></a>00097       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_histogram_bin = 0;
<a name="l00098"></a>00098 
<a name="l00099"></a>00099       <span class="comment">// How much above (+) or below (-) we are from the</span>
<a name="l00100"></a>00100       <span class="comment">// target size for the last bin.</span>
<a name="l00101"></a>00101       <span class="comment">// Note that when delta is (-) we will</span>
<a name="l00102"></a>00102       <span class="comment">// accept a slightly larger size for the next bin,</span>
<a name="l00103"></a>00103       <span class="comment">// the goal being to keep the whole mess average</span>
<a name="l00104"></a>00104       <span class="keywordtype">int</span> delta = 0;
<a name="l00105"></a>00105       
<a name="l00106"></a>00106       <span class="comment">// Set the internal bin boundary iterators</span>
<a name="l00107"></a>00107       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> b=0; b&lt;nbins; ++b)
<a name="l00108"></a>00108         {
<a name="l00109"></a>00109           <span class="comment">// The size of bin b.  We want this to</span>
<a name="l00110"></a>00110           <span class="comment">// be ~= target_bin_size[b]</span>
<a name="l00111"></a>00111           <span class="keywordtype">int</span> current_bin_size = 0;
<a name="l00112"></a>00112           
<a name="l00113"></a>00113           <span class="comment">// Step through the histogram until we have the</span>
<a name="l00114"></a>00114           <span class="comment">// desired bin size     </span>
<a name="l00115"></a>00115           <span class="keywordflow">while</span> ((current_bin_size + histogram[current_histogram_bin] + delta) &lt;= target_bin_size[b])
<a name="l00116"></a>00116             {
<a name="l00117"></a>00117               <span class="comment">// Don&#39;t index out of the histogram!</span>
<a name="l00118"></a>00118               <span class="keywordflow">if</span> ((current_histogram_bin+1) == phist.<a class="code" href="classParallel_1_1Histogram.php#ac0af45c16e98656a905d206218d36ddb">n_bins</a>())
<a name="l00119"></a>00119                 <span class="keywordflow">break</span>;
<a name="l00120"></a>00120               
<a name="l00121"></a>00121               current_bin_size += histogram[current_histogram_bin++];
<a name="l00122"></a>00122             }
<a name="l00123"></a>00123           
<a name="l00124"></a>00124           delta += current_bin_size - target_bin_size[b];
<a name="l00125"></a>00125           
<a name="l00126"></a>00126           <span class="comment">// Set the upper bound of the bin</span>
<a name="l00127"></a>00127           bin_bounds[b+1] = phist.<a class="code" href="classParallel_1_1Histogram.php#a7fd9a5608983b57677ccdd7e0ae3523e">upper_bound</a> (current_histogram_bin);    
<a name="l00128"></a>00128           bin_iters[b+1]  = std::lower_bound(bin_iters[b], data.end(), 
<a name="l00129"></a>00129                                              Parallel::Utils::to_key_type&lt;KeyType&gt;(bin_bounds[b+1]));
<a name="l00130"></a>00130         }
<a name="l00131"></a>00131 
<a name="l00132"></a>00132       <span class="comment">// Just be sure the last boundaries point to the right place</span>
<a name="l00133"></a>00133       bin_iters[nbins]  = data.end();
<a name="l00134"></a>00134       bin_bounds[nbins] = <a class="code" href="namespaceParallel_1_1Utils.php#a7cb0d6aee3faa60b9d20c0db2d7fbb8b">Parallel::Utils::to_double</a>(max);
<a name="l00135"></a>00135     }
<a name="l00136"></a>00136   }
<a name="l00137"></a>00137 }
<a name="l00138"></a>00138   
<a name="l00139"></a>00139 }
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 <span class="comment">// Explicitly instantiate for int, double</span>
<a name="l00143"></a>00143 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classParallel_1_1BinSorter.php">Parallel::BinSorter&lt;int&gt;</a>;
<a name="l00144"></a>00144 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classParallel_1_1BinSorter.php">Parallel::BinSorter&lt;double&gt;</a>;
<a name="l00145"></a>00145 <span class="preprocessor">#ifdef LIBMESH_HAVE_LIBHILBERT</span>
<a name="l00146"></a>00146 <span class="preprocessor"></span><span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classParallel_1_1BinSorter.php">Parallel::BinSorter&lt;Hilbert::HilbertIndices&gt;</a>;
<a name="l00147"></a>00147 <span class="preprocessor">#endif</span>
<a name="l00148"></a>00148 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
