<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_68b326994b1686b0c255607250545e3c.php">parallel</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>parallel_bin_sorter.h</h1>  </div>
</div>
<div class="contents">
<a href="parallel__bin__sorter_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: parallel_bin_sorter.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __parallel_bin_sorter_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __parallel_bin_sorter_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// This class contains all the functionality for bin sorting</span>
<a name="l00025"></a>00025 <span class="comment">// Templated on the type of keys you will be sorting and the</span>
<a name="l00026"></a>00026 <span class="comment">// type of iterator you will be using.</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;iterator&gt;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>Parallel {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00038"></a><a class="code" href="classParallel_1_1BinSorter.php">00038</a> <span class="keyword">class </span><a class="code" href="classParallel_1_1BinSorter.php">BinSorter</a>
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040   <span class="comment">// The type of iterator we will be using is inferred from KeyType</span>
<a name="l00041"></a><a class="code" href="classParallel_1_1BinSorter.php#a28ec5c126980361efb132f6fcdc17c4c">00041</a>   <span class="keyword">typedef</span> <span class="keyword">typename</span> std::vector&lt;KeyType&gt;::const_iterator <a class="code" href="classParallel_1_1BinSorter.php#a28ec5c126980361efb132f6fcdc17c4c">IterType</a>;
<a name="l00042"></a>00042   
<a name="l00043"></a>00043 <span class="keyword">public</span>:
<a name="l00044"></a>00044 
<a name="l00045"></a>00045   <span class="comment">// Constructor</span>
<a name="l00046"></a>00046   <a class="code" href="classParallel_1_1BinSorter.php#a8dac8bb0db68fae64fc31dbbe45bf7eb">BinSorter</a> (<span class="keyword">const</span> std::vector&lt;KeyType&gt;&amp; d);
<a name="l00047"></a>00047   
<a name="l00048"></a>00048   <span class="comment">// The actual function which sorts the data into</span>
<a name="l00049"></a>00049   <span class="comment">// nbins.  Currently based on the global min and</span>
<a name="l00050"></a>00050   <span class="comment">// max which you must provide e.g. by using MPI.</span>
<a name="l00051"></a>00051   <span class="keywordtype">void</span> <a class="code" href="classParallel_1_1BinSorter.php#a8e26ac21896524e4b00f1601a4fd8ec2">binsort</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nbins,
<a name="l00052"></a>00052                 KeyType <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>,
<a name="l00053"></a>00053                 KeyType <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>);
<a name="l00054"></a>00054   
<a name="l00055"></a>00055   <span class="comment">// Returns the size of bin b as an unsigned int.</span>
<a name="l00056"></a>00056   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallel_1_1BinSorter.php#ade300e13f5bacec1c736b62c17e5143f">sizeof_bin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bin) <span class="keyword">const</span>;
<a name="l00057"></a>00057   
<a name="l00058"></a>00058     
<a name="l00059"></a>00059 <span class="keyword">private</span>:
<a name="l00060"></a>00060   
<a name="l00061"></a><a class="code" href="classParallel_1_1BinSorter.php#a30031517d08bab4f74544004c4e8a5c0">00061</a>   <span class="keyword">const</span> std::vector&lt;KeyType&gt;&amp; <a class="code" href="classParallel_1_1BinSorter.php#a30031517d08bab4f74544004c4e8a5c0">data</a>;
<a name="l00062"></a><a class="code" href="classParallel_1_1BinSorter.php#af29aa496bd046771354d5e51e2d0d38e">00062</a>   std::vector&lt;IterType&gt;       <a class="code" href="classParallel_1_1BinSorter.php#af29aa496bd046771354d5e51e2d0d38e">bin_iters</a>;   <span class="comment">// Iterators to the bin boundaries</span>
<a name="l00063"></a>00063                                            <span class="comment">//  in data</span>
<a name="l00064"></a>00064 };
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 <span class="comment">//--------------------------------------------------------------------------</span>
<a name="l00069"></a>00069 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00070"></a>00070 <span class="keyword">inline</span>
<a name="l00071"></a><a class="code" href="classParallel_1_1BinSorter.php#ade300e13f5bacec1c736b62c17e5143f">00071</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallel_1_1BinSorter.php#ade300e13f5bacec1c736b62c17e5143f">BinSorter&lt;KeyType&gt;::sizeof_bin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bin)<span class="keyword"> const</span>
<a name="l00072"></a>00072 <span class="keyword"></span>{
<a name="l00073"></a>00073   libmesh_assert ((bin+1) &lt; bin_iters.size());
<a name="l00074"></a>00074 
<a name="l00075"></a>00075   <span class="comment">// The size of the bin is defined by the distance between</span>
<a name="l00076"></a>00076   <span class="comment">// its bounding iterators</span>
<a name="l00077"></a>00077   <span class="keywordflow">return</span> std::distance (bin_iters[bin], bin_iters[bin+1]);
<a name="l00078"></a>00078 }
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 }
<a name="l00081"></a>00081 <span class="preprocessor">#endif</span>
<a name="l00082"></a>00082 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
