<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_68b326994b1686b0c255607250545e3c.php">parallel</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>parallel_ghost_sync.h</h1>  </div>
</div>
<div class="contents">
<a href="parallel__ghost__sync_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 <span class="comment">// $Id: parallel_ghost_sync.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00005"></a>00005 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00006"></a>00006   
<a name="l00007"></a>00007 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00008"></a>00008 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00009"></a>00009 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00010"></a>00010 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00011"></a>00011   
<a name="l00012"></a>00012 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00013"></a>00013 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00014"></a>00014 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00015"></a>00015 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00016"></a>00016   
<a name="l00017"></a>00017 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00018"></a>00018 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00019"></a>00019 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifndef __parallel_ghost_sync_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#define __parallel_ghost_sync_h__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span><span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;auto_ptr.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;location_maps.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">//--------------------------------------------------------------------------</span>
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Parallel {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039   <span class="comment">//------------------------------------------------------------------------</span>
<a name="l00056"></a>00056 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Iterator,
<a name="l00057"></a>00057             <span class="keyword">typename</span> DofObjType,
<a name="l00058"></a>00058             <span class="keyword">typename</span> SyncFunctor&gt;
<a name="l00059"></a>00059   <span class="keywordtype">void</span> <a class="code" href="namespaceParallel.php#a67ce8f53bd6f7bda0eb3cb0fb3964251">sync_dofobject_data_by_xyz</a>(<span class="keyword">const</span> Iterator&amp;          range_begin,
<a name="l00060"></a>00060                                   <span class="keyword">const</span> Iterator&amp;          range_end,
<a name="l00061"></a>00061                                   <a class="code" href="classLocationMap.php">LocationMap&lt;DofObjType&gt;</a>* location_map,
<a name="l00062"></a>00062                                   SyncFunctor&amp;             sync);
<a name="l00063"></a>00063 
<a name="l00064"></a>00064   <span class="comment">//------------------------------------------------------------------------</span>
<a name="l00077"></a>00077 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Iterator,
<a name="l00078"></a>00078             <span class="keyword">typename</span> SyncFunctor&gt;
<a name="l00079"></a>00079   <span class="keywordtype">void</span> <a class="code" href="namespaceParallel.php#ab9f27623ac0ba8ee92c34c881386afe5">sync_dofobject_data_by_id</a>(<span class="keyword">const</span> Iterator&amp; range_begin,
<a name="l00080"></a>00080                                  <span class="keyword">const</span> Iterator&amp; range_end,
<a name="l00081"></a>00081                                  SyncFunctor&amp;    sync);
<a name="l00082"></a>00082 
<a name="l00083"></a>00083   <span class="comment">//------------------------------------------------------------------------</span>
<a name="l00097"></a>00097 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Iterator,
<a name="l00098"></a>00098             <span class="keyword">typename</span> SyncFunctor&gt;
<a name="l00099"></a>00099   <span class="keywordtype">void</span> <a class="code" href="namespaceParallel.php#a6ccf8177a39475406f26a72369dfc56d">sync_element_data_by_parent_id</a>(<a class="code" href="classMeshBase.php">MeshBase</a>&amp;       mesh,
<a name="l00100"></a>00100                                       <span class="keyword">const</span> Iterator&amp; range_begin,
<a name="l00101"></a>00101                                       <span class="keyword">const</span> Iterator&amp; range_end,
<a name="l00102"></a>00102                                       SyncFunctor&amp;    sync);
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="comment">//------------------------------------------------------------------------</span>
<a name="l00105"></a>00105   <span class="comment">// Parallel members</span>
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Iterator,
<a name="l00108"></a>00108           <span class="keyword">typename</span> DofObjType,
<a name="l00109"></a>00109           <span class="keyword">typename</span> SyncFunctor&gt;
<a name="l00110"></a><a class="code" href="namespaceParallel.php#ad76a5c24069fdb94b096f62f564d81b5">00110</a> <span class="keywordtype">void</span> <a class="code" href="namespaceParallel.php#a67ce8f53bd6f7bda0eb3cb0fb3964251">sync_dofobject_data_by_xyz</a>(<span class="keyword">const</span> Iterator&amp;          range_begin,
<a name="l00111"></a>00111                                 <span class="keyword">const</span> Iterator&amp;          range_end,
<a name="l00112"></a>00112                                 <a class="code" href="classLocationMap.php">LocationMap&lt;DofObjType&gt;</a>&amp; location_map,
<a name="l00113"></a>00113                                 SyncFunctor&amp;             sync)
<a name="l00114"></a>00114 {
<a name="l00115"></a>00115   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00116"></a>00116   parallel_only();
<a name="l00117"></a>00117 
<a name="l00118"></a>00118   <span class="comment">// We need a valid location_map</span>
<a name="l00119"></a>00119 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00120"></a>00120 <span class="preprocessor"></span>  <span class="keywordtype">bool</span> need_map_update = (range_begin != range_end &amp;&amp; location_map.<a class="code" href="classLocationMap.php#a4517c7633d5d724f8666fefc8220b408">empty</a>());
<a name="l00121"></a>00121   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(need_map_update);
<a name="l00122"></a>00122   libmesh_assert(!need_map_update);
<a name="l00123"></a>00123 <span class="preprocessor">#endif</span>
<a name="l00124"></a>00124 <span class="preprocessor"></span>
<a name="l00125"></a>00125   <span class="comment">// Count the objectss to ask each processor about</span>
<a name="l00126"></a>00126   std::vector&lt;unsigned int&gt;
<a name="l00127"></a>00127     ghost_objects_from_proc(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   <span class="keywordflow">for</span> (Iterator it = range_begin; it != range_end; ++it)
<a name="l00130"></a>00130     {
<a name="l00131"></a>00131       DofObjType *obj = *it;
<a name="l00132"></a>00132       libmesh_assert (obj);
<a name="l00133"></a>00133       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> obj_procid = obj-&gt;processor_id();
<a name="l00134"></a>00134       libmesh_assert (obj_procid != <a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>);
<a name="l00135"></a>00135 
<a name="l00136"></a>00136       ghost_objects_from_proc[obj_procid]++;
<a name="l00137"></a>00137     }
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   <span class="comment">// Request sets to send to each processor</span>
<a name="l00140"></a>00140   std::vector&lt;std::vector&lt;Real&gt; &gt;
<a name="l00141"></a>00141     requested_objs_x(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()),
<a name="l00142"></a>00142     requested_objs_y(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()),
<a name="l00143"></a>00143     requested_objs_z(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00144"></a>00144   <span class="comment">// Corresponding ids to keep track of</span>
<a name="l00145"></a>00145   std::vector&lt;std::vector&lt;unsigned int&gt; &gt;
<a name="l00146"></a>00146     requested_objs_id(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00147"></a>00147 
<a name="l00148"></a>00148   <span class="comment">// We know how many objects live on each processor, so reserve()</span>
<a name="l00149"></a>00149   <span class="comment">// space for each.</span>
<a name="l00150"></a>00150   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00151"></a>00151     <span class="keywordflow">if</span> (p != <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00152"></a>00152       {
<a name="l00153"></a>00153         requested_objs_x[p].reserve(ghost_objects_from_proc[p]);
<a name="l00154"></a>00154         requested_objs_y[p].reserve(ghost_objects_from_proc[p]);
<a name="l00155"></a>00155         requested_objs_z[p].reserve(ghost_objects_from_proc[p]);
<a name="l00156"></a>00156         requested_objs_id[p].reserve(ghost_objects_from_proc[p]);
<a name="l00157"></a>00157       }
<a name="l00158"></a>00158   <span class="keywordflow">for</span> (Iterator it = range_begin; it != range_end; ++it)
<a name="l00159"></a>00159     {
<a name="l00160"></a>00160       DofObjType *obj = *it;
<a name="l00161"></a>00161       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> obj_procid = obj-&gt;processor_id();
<a name="l00162"></a>00162       <span class="keywordflow">if</span> (obj_procid == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00163"></a>00163         <span class="keywordflow">continue</span>;
<a name="l00164"></a>00164 
<a name="l00165"></a>00165       <a class="code" href="classPoint.php">Point</a> p = location_map.<a class="code" href="classLocationMap.php#ab5b10986fbdf353d3aea1caeb3fae417">point_of</a>(*obj);
<a name="l00166"></a>00166       requested_objs_x[obj_procid].push_back(p(0));
<a name="l00167"></a>00167       requested_objs_y[obj_procid].push_back(p(1));
<a name="l00168"></a>00168       requested_objs_z[obj_procid].push_back(p(2));
<a name="l00169"></a>00169       requested_objs_id[obj_procid].push_back(obj-&gt;id());
<a name="l00170"></a>00170     }
<a name="l00171"></a>00171 
<a name="l00172"></a>00172   <span class="comment">// Trade requests with other processors</span>
<a name="l00173"></a>00173   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00174"></a>00174     {
<a name="l00175"></a>00175       <span class="comment">// Trade my requests with processor procup and procdown</span>
<a name="l00176"></a>00176       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procup = (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() + p) %
<a name="l00177"></a>00177                              <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00178"></a>00178       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procdown = (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() +
<a name="l00179"></a>00179                                <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() - p) %
<a name="l00180"></a>00180                                <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00181"></a>00181       std::vector&lt;Real&gt; request_to_fill_x,
<a name="l00182"></a>00182                         request_to_fill_y,
<a name="l00183"></a>00183                         request_to_fill_z;
<a name="l00184"></a>00184       Parallel::send_receive(procup, requested_objs_x[procup],
<a name="l00185"></a>00185                              procdown, request_to_fill_x);
<a name="l00186"></a>00186       Parallel::send_receive(procup, requested_objs_y[procup],
<a name="l00187"></a>00187                              procdown, request_to_fill_y);
<a name="l00188"></a>00188       Parallel::send_receive(procup, requested_objs_z[procup],
<a name="l00189"></a>00189                              procdown, request_to_fill_z);
<a name="l00190"></a>00190 
<a name="l00191"></a>00191       <span class="comment">// Find the local id of each requested object</span>
<a name="l00192"></a>00192       std::vector&lt;unsigned int&gt; request_to_fill_id(request_to_fill_x.size());
<a name="l00193"></a>00193       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != request_to_fill_x.size(); ++i)
<a name="l00194"></a>00194         {
<a name="l00195"></a>00195           <a class="code" href="classPoint.php">Point</a> p(request_to_fill_x[i],
<a name="l00196"></a>00196                   request_to_fill_y[i],
<a name="l00197"></a>00197                   request_to_fill_z[i]);
<a name="l00198"></a>00198 
<a name="l00199"></a>00199           <span class="comment">// Look for this object in the multimap</span>
<a name="l00200"></a>00200           DofObjType *obj = location_map.<a class="code" href="classLocationMap.php#a5af3c498d43b5eec4c40e1fd8aff23cb">find</a>(p);
<a name="l00201"></a>00201 
<a name="l00202"></a>00202           <span class="comment">// We&#39;d better find every object we&#39;re asked for</span>
<a name="l00203"></a>00203           libmesh_assert (obj);
<a name="l00204"></a>00204 
<a name="l00205"></a>00205           <span class="comment">// Return the object&#39;s correct processor id,</span>
<a name="l00206"></a>00206           <span class="comment">// and our (correct if it&#39;s local) id for it.</span>
<a name="l00207"></a>00207           request_to_fill_id[i] = obj-&gt;id();
<a name="l00208"></a>00208         }
<a name="l00209"></a>00209 
<a name="l00210"></a>00210       <span class="comment">// Gather whatever data the user wants</span>
<a name="l00211"></a>00211       std::vector&lt;typename SyncFunctor::datum&gt; data;
<a name="l00212"></a>00212       sync.gather_data(request_to_fill_id, data);
<a name="l00213"></a>00213 
<a name="l00214"></a>00214       <span class="comment">// Trade back the results</span>
<a name="l00215"></a>00215       std::vector&lt;typename SyncFunctor::datum&gt; received_data;
<a name="l00216"></a>00216       Parallel::send_receive(procdown, data,
<a name="l00217"></a>00217                              procup, received_data);
<a name="l00218"></a>00218       libmesh_assert(requested_objs_x[procup].size() ==
<a name="l00219"></a>00219                      received_data.size());
<a name="l00220"></a>00220 
<a name="l00221"></a>00221       <span class="comment">// Let the user process the results</span>
<a name="l00222"></a>00222       sync.act_on_data(requested_objs_id[procup], received_data);
<a name="l00223"></a>00223     }
<a name="l00224"></a>00224 }
<a name="l00225"></a>00225 
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Iterator,
<a name="l00229"></a>00229           <span class="keyword">typename</span> SyncFunctor&gt;
<a name="l00230"></a><a class="code" href="namespaceParallel.php#ab9f27623ac0ba8ee92c34c881386afe5">00230</a> <span class="keywordtype">void</span> <a class="code" href="namespaceParallel.php#ab9f27623ac0ba8ee92c34c881386afe5">sync_dofobject_data_by_id</a>(<span class="keyword">const</span> Iterator&amp; range_begin,
<a name="l00231"></a>00231                                <span class="keyword">const</span> Iterator&amp; range_end,
<a name="l00232"></a>00232                                SyncFunctor&amp;    sync)
<a name="l00233"></a>00233 {
<a name="l00234"></a>00234   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00235"></a>00235   parallel_only();
<a name="l00236"></a>00236 
<a name="l00237"></a>00237   <span class="comment">// Count the objects to ask each processor about</span>
<a name="l00238"></a>00238   std::vector&lt;unsigned int&gt;
<a name="l00239"></a>00239     ghost_objects_from_proc(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l00240"></a>00240 
<a name="l00241"></a>00241   <span class="keywordflow">for</span> (Iterator it = range_begin; it != range_end; ++it)
<a name="l00242"></a>00242     {
<a name="l00243"></a>00243       <a class="code" href="classDofObject.php">DofObject</a> *obj = *it;
<a name="l00244"></a>00244       libmesh_assert (obj);
<a name="l00245"></a>00245       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> obj_procid = obj-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>();
<a name="l00246"></a>00246       libmesh_assert (obj_procid != <a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>);
<a name="l00247"></a>00247 
<a name="l00248"></a>00248       ghost_objects_from_proc[obj_procid]++;
<a name="l00249"></a>00249     }
<a name="l00250"></a>00250 
<a name="l00251"></a>00251   <span class="comment">// Request sets to send to each processor</span>
<a name="l00252"></a>00252   std::vector&lt;std::vector&lt;unsigned int&gt; &gt;
<a name="l00253"></a>00253     requested_objs_id(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00254"></a>00254 
<a name="l00255"></a>00255   <span class="comment">// We know how many objects live on each processor, so reserve()</span>
<a name="l00256"></a>00256   <span class="comment">// space for each.</span>
<a name="l00257"></a>00257   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00258"></a>00258     <span class="keywordflow">if</span> (p != <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00259"></a>00259       {
<a name="l00260"></a>00260         requested_objs_id[p].reserve(ghost_objects_from_proc[p]);
<a name="l00261"></a>00261       }
<a name="l00262"></a>00262   <span class="keywordflow">for</span> (Iterator it = range_begin; it != range_end; ++it)
<a name="l00263"></a>00263     {
<a name="l00264"></a>00264       <a class="code" href="classDofObject.php">DofObject</a> *obj = *it;
<a name="l00265"></a>00265       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> obj_procid = obj-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>();
<a name="l00266"></a>00266       <span class="keywordflow">if</span> (obj_procid == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00267"></a>00267         <span class="keywordflow">continue</span>;
<a name="l00268"></a>00268 
<a name="l00269"></a>00269       requested_objs_id[obj_procid].push_back(obj-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>());
<a name="l00270"></a>00270     }
<a name="l00271"></a>00271 
<a name="l00272"></a>00272   <span class="comment">// Trade requests with other processors</span>
<a name="l00273"></a>00273   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00274"></a>00274     {
<a name="l00275"></a>00275       <span class="comment">// Trade my requests with processor procup and procdown</span>
<a name="l00276"></a>00276       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procup = (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() + p) %
<a name="l00277"></a>00277                              <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00278"></a>00278       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procdown = (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() +
<a name="l00279"></a>00279                                <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() - p) %
<a name="l00280"></a>00280                                <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00281"></a>00281       std::vector&lt;unsigned int&gt; request_to_fill_id;
<a name="l00282"></a>00282       Parallel::send_receive(procup, requested_objs_id[procup],
<a name="l00283"></a>00283                              procdown, request_to_fill_id);
<a name="l00284"></a>00284 
<a name="l00285"></a>00285       <span class="comment">// Gather whatever data the user wants</span>
<a name="l00286"></a>00286       std::vector&lt;typename SyncFunctor::datum&gt; data;
<a name="l00287"></a>00287       sync.gather_data(request_to_fill_id, data);
<a name="l00288"></a>00288 
<a name="l00289"></a>00289       <span class="comment">// Trade back the results</span>
<a name="l00290"></a>00290       std::vector&lt;typename SyncFunctor::datum&gt; received_data;
<a name="l00291"></a>00291       Parallel::send_receive(procdown, data,
<a name="l00292"></a>00292                              procup, received_data);
<a name="l00293"></a>00293       libmesh_assert(requested_objs_id[procup].size() ==
<a name="l00294"></a>00294                      received_data.size());
<a name="l00295"></a>00295 
<a name="l00296"></a>00296       <span class="comment">// Let the user process the results</span>
<a name="l00297"></a>00297       sync.act_on_data(requested_objs_id[procup], received_data);
<a name="l00298"></a>00298     }
<a name="l00299"></a>00299 }
<a name="l00300"></a>00300 
<a name="l00301"></a>00301 
<a name="l00302"></a>00302 
<a name="l00303"></a>00303   <span class="comment">// If there&#39;s no refined elements, there&#39;s nothing to sync</span>
<a name="l00304"></a>00304 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00305"></a>00305 <span class="preprocessor"></span><span class="keyword">template</span> &lt;<span class="keyword">typename</span> Iterator,
<a name="l00306"></a>00306           <span class="keyword">typename</span> SyncFunctor&gt;
<a name="l00307"></a><a class="code" href="namespaceParallel.php#a6ccf8177a39475406f26a72369dfc56d">00307</a> <span class="keywordtype">void</span> <a class="code" href="namespaceParallel.php#a6ccf8177a39475406f26a72369dfc56d">sync_element_data_by_parent_id</a>(<a class="code" href="classMeshBase.php">MeshBase</a>&amp;       mesh,
<a name="l00308"></a>00308                                     <span class="keyword">const</span> Iterator&amp; range_begin,
<a name="l00309"></a>00309                                     <span class="keyword">const</span> Iterator&amp; range_end,
<a name="l00310"></a>00310                                     SyncFunctor&amp;    sync)
<a name="l00311"></a>00311 {
<a name="l00312"></a>00312   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00313"></a>00313   parallel_only();
<a name="l00314"></a>00314 
<a name="l00315"></a>00315   <span class="comment">// Count the objects to ask each processor about</span>
<a name="l00316"></a>00316   std::vector&lt;unsigned int&gt;
<a name="l00317"></a>00317     ghost_objects_from_proc(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l00318"></a>00318 
<a name="l00319"></a>00319   <span class="keywordflow">for</span> (Iterator it = range_begin; it != range_end; ++it)
<a name="l00320"></a>00320     {
<a name="l00321"></a>00321       <a class="code" href="classDofObject.php">DofObject</a> *obj = *it;
<a name="l00322"></a>00322       libmesh_assert (obj);
<a name="l00323"></a>00323       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> obj_procid = obj-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>();
<a name="l00324"></a>00324       libmesh_assert (obj_procid != <a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>);
<a name="l00325"></a>00325 
<a name="l00326"></a>00326       ghost_objects_from_proc[obj_procid]++;
<a name="l00327"></a>00327     }
<a name="l00328"></a>00328 
<a name="l00329"></a>00329   <span class="comment">// Request sets to send to each processor</span>
<a name="l00330"></a>00330   std::vector&lt;std::vector&lt;unsigned int&gt; &gt;
<a name="l00331"></a>00331     requested_objs_id(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()),
<a name="l00332"></a>00332     requested_objs_parent_id(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()),
<a name="l00333"></a>00333     requested_objs_child_num(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00334"></a>00334 
<a name="l00335"></a>00335   <span class="comment">// We know how many objects live on each processor, so reserve()</span>
<a name="l00336"></a>00336   <span class="comment">// space for each.</span>
<a name="l00337"></a>00337   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00338"></a>00338     <span class="keywordflow">if</span> (p != <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00339"></a>00339       {
<a name="l00340"></a>00340         requested_objs_id[p].reserve(ghost_objects_from_proc[p]);
<a name="l00341"></a>00341         requested_objs_parent_id[p].reserve(ghost_objects_from_proc[p]);
<a name="l00342"></a>00342         requested_objs_child_num[p].reserve(ghost_objects_from_proc[p]);
<a name="l00343"></a>00343       }
<a name="l00344"></a>00344 
<a name="l00345"></a>00345   <span class="keywordflow">for</span> (Iterator it = range_begin; it != range_end; ++it)
<a name="l00346"></a>00346     {
<a name="l00347"></a>00347       <a class="code" href="classElem.php">Elem</a> *elem = *it;
<a name="l00348"></a>00348       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> obj_procid = elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>();
<a name="l00349"></a>00349       <span class="keywordflow">if</span> (obj_procid == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00350"></a>00350         <span class="keywordflow">continue</span>;
<a name="l00351"></a>00351       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *parent = elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>();
<a name="l00352"></a>00352       <span class="keywordflow">if</span> (!parent || !elem-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l00353"></a>00353         <span class="keywordflow">continue</span>;
<a name="l00354"></a>00354 
<a name="l00355"></a>00355       requested_objs_id[obj_procid].push_back(elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>());
<a name="l00356"></a>00356       requested_objs_parent_id[obj_procid].push_back(parent-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>());
<a name="l00357"></a>00357       requested_objs_child_num[obj_procid].push_back
<a name="l00358"></a>00358         (parent-&gt;<a class="code" href="classElem.php#a72cd45e535e8bebac68a57a362a60fef">which_child_am_i</a>(elem));
<a name="l00359"></a>00359     }
<a name="l00360"></a>00360 
<a name="l00361"></a>00361   <span class="comment">// Trade requests with other processors</span>
<a name="l00362"></a>00362   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00363"></a>00363     {
<a name="l00364"></a>00364       <span class="comment">// Trade my requests with processor procup and procdown</span>
<a name="l00365"></a>00365       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procup = (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() + p) %
<a name="l00366"></a>00366                              <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00367"></a>00367       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procdown = (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() +
<a name="l00368"></a>00368                                <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() - p) %
<a name="l00369"></a>00369                                <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00370"></a>00370       std::vector&lt;unsigned int&gt; request_to_fill_parent_id,
<a name="l00371"></a>00371                                 request_to_fill_child_num;
<a name="l00372"></a>00372       Parallel::send_receive(procup, requested_objs_parent_id[procup],
<a name="l00373"></a>00373                              procdown, request_to_fill_parent_id);
<a name="l00374"></a>00374       Parallel::send_receive(procup, requested_objs_child_num[procup],
<a name="l00375"></a>00375                              procdown, request_to_fill_child_num);
<a name="l00376"></a>00376 
<a name="l00377"></a>00377       <span class="comment">// Find the id of each requested element</span>
<a name="l00378"></a>00378       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> request_size = request_to_fill_parent_id.size();
<a name="l00379"></a>00379       std::vector&lt;unsigned int&gt; request_to_fill_id(request_size);
<a name="l00380"></a>00380       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != request_size; ++i)
<a name="l00381"></a>00381         {
<a name="l00382"></a>00382           <a class="code" href="classElem.php">Elem</a> *parent = mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(request_to_fill_parent_id[i]);
<a name="l00383"></a>00383           libmesh_assert(parent);
<a name="l00384"></a>00384           libmesh_assert(parent-&gt;<a class="code" href="classElem.php#a2ff2cfd3b4b05b8f091ba91eb068f81c">has_children</a>());
<a name="l00385"></a>00385           <a class="code" href="classElem.php">Elem</a> *child = parent-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(request_to_fill_child_num[i]);
<a name="l00386"></a>00386           libmesh_assert(child);
<a name="l00387"></a>00387           libmesh_assert(child-&gt;active());
<a name="l00388"></a>00388           request_to_fill_id[i] = child-&gt;id();
<a name="l00389"></a>00389         }
<a name="l00390"></a>00390 
<a name="l00391"></a>00391       <span class="comment">// Gather whatever data the user wants</span>
<a name="l00392"></a>00392       std::vector&lt;typename SyncFunctor::datum&gt; data;
<a name="l00393"></a>00393       sync.gather_data(request_to_fill_id, data);
<a name="l00394"></a>00394 
<a name="l00395"></a>00395       <span class="comment">// Trade back the results</span>
<a name="l00396"></a>00396       std::vector&lt;typename SyncFunctor::datum&gt; received_data;
<a name="l00397"></a>00397       Parallel::send_receive(procdown, data,
<a name="l00398"></a>00398                              procup, received_data);
<a name="l00399"></a>00399       libmesh_assert(requested_objs_id[procup].size() ==
<a name="l00400"></a>00400                      received_data.size());
<a name="l00401"></a>00401 
<a name="l00402"></a>00402       <span class="comment">// Let the user process the results</span>
<a name="l00403"></a>00403       sync.act_on_data(requested_objs_id[procup], received_data);
<a name="l00404"></a>00404     }
<a name="l00405"></a>00405 }
<a name="l00406"></a>00406 <span class="preprocessor">#else</span>
<a name="l00407"></a>00407 <span class="preprocessor"></span><span class="keyword">template</span> &lt;<span class="keyword">typename</span> Iterator,
<a name="l00408"></a>00408           <span class="keyword">typename</span> SyncFunctor&gt;
<a name="l00409"></a>00409 <span class="keywordtype">void</span> <a class="code" href="namespaceParallel.php#a6ccf8177a39475406f26a72369dfc56d">sync_element_data_by_parent_id</a>(<a class="code" href="classMeshBase.php">MeshBase</a>&amp;,
<a name="l00410"></a>00410                                     <span class="keyword">const</span> Iterator&amp;,
<a name="l00411"></a>00411                                     <span class="keyword">const</span> Iterator&amp;,
<a name="l00412"></a>00412                                     SyncFunctor&amp;)
<a name="l00413"></a>00413 {
<a name="l00414"></a>00414 }
<a name="l00415"></a>00415 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR</span>
<a name="l00416"></a>00416 <span class="preprocessor"></span>
<a name="l00417"></a>00417 
<a name="l00418"></a>00418 
<a name="l00419"></a>00419 
<a name="l00420"></a>00420 }
<a name="l00421"></a>00421 
<a name="l00422"></a>00422 <span class="preprocessor">#endif // #define __parallel_ghost_sync_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
