<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_68b326994b1686b0c255607250545e3c.php">parallel</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>parallel_histogram.h</h1>  </div>
</div>
<div class="contents">
<a href="parallel__histogram_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: parallel_histogram.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __parallel_histogram_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __parallel_histogram_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// This class contains all the functionality for bin sorting</span>
<a name="l00025"></a>00025 <span class="comment">// Templated on the type of keys you will be sorting and the</span>
<a name="l00026"></a>00026 <span class="comment">// type of iterator you will be using.</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;iterator&gt;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span> <span class="comment">// for libmesh_assert()</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Parallel {
<a name="l00035"></a>00035 
<a name="l00040"></a>00040 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00041"></a><a class="code" href="classParallel_1_1Histogram.php">00041</a> <span class="keyword">class </span><a class="code" href="classParallel_1_1Histogram.php">Histogram</a>
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043   <span class="comment">// The type of iterator we will be using is inferred from KeyType</span>
<a name="l00044"></a><a class="code" href="classParallel_1_1Histogram.php#aa212520a81dae929a5d9b1b2838482ea">00044</a>   <span class="keyword">typedef</span> <span class="keyword">typename</span> std::vector&lt;KeyType&gt;::const_iterator <a class="code" href="classParallel_1_1Histogram.php#aa212520a81dae929a5d9b1b2838482ea">IterType</a>;
<a name="l00045"></a>00045   
<a name="l00046"></a>00046 <span class="keyword">public</span>:
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   <span class="comment">// Constructor</span>
<a name="l00049"></a>00049   <a class="code" href="classParallel_1_1Histogram.php#a75f71f94e22641a801568eaaaefbb221">Histogram</a> (<span class="keyword">const</span> std::vector&lt;KeyType&gt;&amp; d);
<a name="l00050"></a>00050   
<a name="l00051"></a>00051   <span class="comment">// The actual function which sorts the data into</span>
<a name="l00052"></a>00052   <span class="comment">// nbins.  Currently based on the global min and</span>
<a name="l00053"></a>00053   <span class="comment">// max which you must provide e.g. by using MPI.</span>
<a name="l00054"></a>00054   <span class="keywordtype">void</span> <a class="code" href="classParallel_1_1Histogram.php#a600a34da3f9171131d978335f54ea0c4">make_histogram</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nbins,
<a name="l00055"></a>00055                        KeyType <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>,
<a name="l00056"></a>00056                        KeyType <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>);
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <span class="comment">// Build the histogram across all processors and store the</span>
<a name="l00059"></a>00059   <span class="comment">// result in the input vector \p hist</span>
<a name="l00060"></a>00060   <span class="keywordtype">void</span> <a class="code" href="classParallel_1_1Histogram.php#a30de720d25ebb57229bb94784e240bd5">build_histogram</a> ();
<a name="l00061"></a>00061 
<a name="l00062"></a>00062   <span class="comment">// Return the raw histogram data to the user</span>
<a name="l00063"></a>00063   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <a class="code" href="classParallel_1_1Histogram.php#a139d20f807accfa9f60b8a1d391f361a">get_histogram</a>() <span class="keyword">const</span>;
<a name="l00064"></a>00064   
<a name="l00065"></a>00065   <span class="comment">// The number of bins in the histogram</span>
<a name="l00066"></a>00066   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallel_1_1Histogram.php#ac0af45c16e98656a905d206218d36ddb">n_bins</a> () <span class="keyword">const</span>;
<a name="l00067"></a>00067   
<a name="l00068"></a>00068   <span class="comment">// Returns the size of local bin b as an unsigned int.</span>
<a name="l00069"></a>00069   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallel_1_1Histogram.php#a620f40cee3341b723691e7d31b7dd854">local_bin_size</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bin) <span class="keyword">const</span>;  
<a name="l00070"></a>00070   
<a name="l00071"></a>00071   <span class="comment">// Returns the size of global bin b as an unsigned int.</span>
<a name="l00072"></a>00072   <span class="comment">// Requires that the user first call \p build_histogram()</span>
<a name="l00073"></a>00073   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallel_1_1Histogram.php#abf7fbdd43676b6b882f2daf38d8cee5a">global_bin_size</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bin) <span class="keyword">const</span>;  
<a name="l00074"></a>00074 
<a name="l00075"></a>00075   <span class="comment">// Returns the lower boundary of bin \p bin</span>
<a name="l00076"></a>00076   <span class="keywordtype">double</span> <a class="code" href="classParallel_1_1Histogram.php#a9c73fbf8b3532bb73149430879557769">lower_bound</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bin) <span class="keyword">const</span>;
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   <span class="comment">// Returns the upper boundary of bin \p bin</span>
<a name="l00079"></a>00079   <span class="keywordtype">double</span> <a class="code" href="classParallel_1_1Histogram.php#a7fd9a5608983b57677ccdd7e0ae3523e">upper_bound</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bin) <span class="keyword">const</span>;
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   
<a name="l00082"></a>00082 <span class="keyword">private</span>:
<a name="l00083"></a>00083 
<a name="l00084"></a>00084   
<a name="l00085"></a><a class="code" href="classParallel_1_1Histogram.php#a7429074e1a0794e217c94c53a1dc5f20">00085</a>   <span class="keyword">const</span> std::vector&lt;KeyType&gt;&amp; <a class="code" href="classParallel_1_1Histogram.php#a7429074e1a0794e217c94c53a1dc5f20">data</a>;
<a name="l00086"></a><a class="code" href="classParallel_1_1Histogram.php#ae7aebb6344a6250a4ff20da04e3a17ce">00086</a>   std::vector&lt;unsigned int&gt;   <a class="code" href="classParallel_1_1Histogram.php#ae7aebb6344a6250a4ff20da04e3a17ce">hist</a>;        <span class="comment">// The actual histogram</span>
<a name="l00087"></a><a class="code" href="classParallel_1_1Histogram.php#a8c7e0d1820753a22c860eb015a6f73ca">00087</a>   std::vector&lt;double&gt;         <a class="code" href="classParallel_1_1Histogram.php#a8c7e0d1820753a22c860eb015a6f73ca">bin_bounds</a>;  <span class="comment">// The boundary values of each bin</span>
<a name="l00088"></a><a class="code" href="classParallel_1_1Histogram.php#adf2b3da6871fd484b11b364adf487f44">00088</a>   std::vector&lt;IterType&gt;       <a class="code" href="classParallel_1_1Histogram.php#adf2b3da6871fd484b11b364adf487f44">bin_iters</a>;   <span class="comment">// Iterators to the bin boundaries</span>
<a name="l00089"></a>00089                                            <span class="comment">//  in data</span>
<a name="l00090"></a>00090 };
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 <span class="comment">//--------------------------------------------------------------------------</span>
<a name="l00096"></a>00096 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00097"></a>00097 <span class="keyword">inline</span>
<a name="l00098"></a><a class="code" href="classParallel_1_1Histogram.php#a139d20f807accfa9f60b8a1d391f361a">00098</a> <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <a class="code" href="classParallel_1_1Histogram.php#a139d20f807accfa9f60b8a1d391f361a">Histogram&lt;KeyType&gt;::get_histogram</a> ()<span class="keyword"> const</span>
<a name="l00099"></a>00099 <span class="keyword"></span>{
<a name="l00100"></a>00100   <span class="keywordflow">return</span> hist;
<a name="l00101"></a>00101 }
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00106"></a>00106 <span class="keyword">inline</span>
<a name="l00107"></a><a class="code" href="classParallel_1_1Histogram.php#ac0af45c16e98656a905d206218d36ddb">00107</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallel_1_1Histogram.php#ac0af45c16e98656a905d206218d36ddb">Histogram&lt;KeyType&gt;::n_bins</a> ()<span class="keyword"> const</span>
<a name="l00108"></a>00108 <span class="keyword"></span>{
<a name="l00109"></a>00109   <span class="keywordflow">if</span> (bin_iters.empty())
<a name="l00110"></a>00110     <span class="keywordflow">return</span> 0;
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   <span class="keywordflow">return</span> (bin_iters.size()-1);
<a name="l00113"></a>00113 }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00118"></a>00118 <span class="keyword">inline</span>
<a name="l00119"></a><a class="code" href="classParallel_1_1Histogram.php#a620f40cee3341b723691e7d31b7dd854">00119</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallel_1_1Histogram.php#a620f40cee3341b723691e7d31b7dd854">Histogram&lt;KeyType&gt;::local_bin_size</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bin)<span class="keyword"> const</span>
<a name="l00120"></a>00120 <span class="keyword"></span>{
<a name="l00121"></a>00121   libmesh_assert ((bin+1) &lt; bin_iters.size());
<a name="l00122"></a>00122 
<a name="l00123"></a>00123   <span class="comment">// The number of entries in the bin (locally)</span>
<a name="l00124"></a>00124   <span class="keywordflow">return</span> std::distance (bin_iters[bin], bin_iters[bin+1]);
<a name="l00125"></a>00125 }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00130"></a>00130 <span class="keyword">inline</span>
<a name="l00131"></a><a class="code" href="classParallel_1_1Histogram.php#abf7fbdd43676b6b882f2daf38d8cee5a">00131</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallel_1_1Histogram.php#abf7fbdd43676b6b882f2daf38d8cee5a">Histogram&lt;KeyType&gt;::global_bin_size</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bin)<span class="keyword"> const</span>
<a name="l00132"></a>00132 <span class="keyword"></span>{
<a name="l00133"></a>00133   libmesh_assert (bin &lt; hist.size());
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   <span class="comment">// The number of entries in the bin (globally)</span>
<a name="l00136"></a>00136   <span class="keywordflow">return</span> hist[bin];
<a name="l00137"></a>00137 }
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00142"></a>00142 <span class="keyword">inline</span>
<a name="l00143"></a><a class="code" href="classParallel_1_1Histogram.php#a9c73fbf8b3532bb73149430879557769">00143</a> <span class="keywordtype">double</span> <a class="code" href="classParallel_1_1Histogram.php#a9c73fbf8b3532bb73149430879557769">Histogram&lt;KeyType&gt;::lower_bound</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bin)<span class="keyword"> const</span>
<a name="l00144"></a>00144 <span class="keyword"></span>{
<a name="l00145"></a>00145   libmesh_assert ((bin+1) &lt; bin_bounds.size());
<a name="l00146"></a>00146 
<a name="l00147"></a>00147   <span class="keywordflow">return</span> bin_bounds[bin];
<a name="l00148"></a>00148 }
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00153"></a>00153 <span class="keyword">inline</span>
<a name="l00154"></a><a class="code" href="classParallel_1_1Histogram.php#a7fd9a5608983b57677ccdd7e0ae3523e">00154</a> <span class="keywordtype">double</span> <a class="code" href="classParallel_1_1Histogram.php#a7fd9a5608983b57677ccdd7e0ae3523e">Histogram&lt;KeyType&gt;::upper_bound</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bin)<span class="keyword"> const</span>
<a name="l00155"></a>00155 <span class="keyword"></span>{
<a name="l00156"></a>00156   libmesh_assert ((bin+1) &lt; bin_bounds.size());
<a name="l00157"></a>00157 
<a name="l00158"></a>00158   <span class="keywordflow">return</span> bin_bounds[bin+1];
<a name="l00159"></a>00159 }
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 }
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 <span class="preprocessor">#endif</span>
<a name="l00164"></a>00164 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
