<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>parallel_mesh.C</h1>  </div>
</div>
<div class="contents">
<a href="parallel__mesh_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: parallel_mesh.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;boundary_info.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;mesh_communication.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;parallel_mesh.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;parallel.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;parmetis_partitioner.h&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00032"></a>00032 <span class="comment">// ParallelMesh class member functions</span>
<a name="l00033"></a><a class="code" href="classParallelMesh.php#a875c73804bc4be3eaa45fdb70177398a">00033</a> <a class="code" href="classParallelMesh.php#a875c73804bc4be3eaa45fdb70177398a">ParallelMesh::ParallelMesh</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d) :
<a name="l00034"></a>00034   <a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a> (d), _is_serial(true),
<a name="l00035"></a>00035   _n_nodes(0), _n_elem(0), _max_node_id(0), _max_elem_id(0),
<a name="l00036"></a>00036   _next_free_local_node_id(libMesh::<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">processor_id</a>()),
<a name="l00037"></a>00037   _next_free_local_elem_id(libMesh::<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">processor_id</a>()),
<a name="l00038"></a>00038   _next_free_unpartitioned_node_id(libMesh::<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">n_processors</a>()),
<a name="l00039"></a>00039   _next_free_unpartitioned_elem_id(libMesh::<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">n_processors</a>())
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041   <a class="code" href="classMeshBase.php#a313380606806d2771ba4f2e78f7400d9">_partitioner</a> = <a class="code" href="classAutoPtr.php">AutoPtr&lt;Partitioner&gt;</a>(<span class="keyword">new</span> <a class="code" href="classParmetisPartitioner.php">ParmetisPartitioner</a>());
<a name="l00042"></a>00042 }
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a><a class="code" href="classParallelMesh.php#a0a2fbb5b83b5470b50577bed0b437fd3">00045</a> <a class="code" href="classParallelMesh.php#a0a2fbb5b83b5470b50577bed0b437fd3">ParallelMesh::~ParallelMesh</a> ()
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047   this-&gt;<a class="code" href="classParallelMesh.php#ad0429ae4ae81a253098ff659bae00de4">clear</a>();  <span class="comment">// Free nodes and elements</span>
<a name="l00048"></a>00048 }
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 <span class="comment">// This might be specialized later, but right now it&#39;s just here to</span>
<a name="l00052"></a>00052 <span class="comment">// make sure the compiler doesn&#39;t give us a default (non-deep) copy</span>
<a name="l00053"></a>00053 <span class="comment">// constructor instead.</span>
<a name="l00054"></a><a class="code" href="classParallelMesh.php#a637c0c9c3b1e7d02e22c78ff67c26e75">00054</a> <a class="code" href="classParallelMesh.php#a875c73804bc4be3eaa45fdb70177398a">ParallelMesh::ParallelMesh</a> (<span class="keyword">const</span> <a class="code" href="classParallelMesh.php">ParallelMesh</a> &amp;other_mesh) :
<a name="l00055"></a>00055   <a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a> (other_mesh)
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057   this-&gt;<a class="code" href="classUnstructuredMesh.php#afecc40762dc88b1ef471a9d4a3938f4c">copy_nodes_and_elements</a>(other_mesh);
<a name="l00058"></a>00058   <a class="code" href="classParallelMesh.php#a40377d3c8e3bc9b45e5c08f55a33ef1a">_n_nodes</a> = other_mesh.<a class="code" href="classParallelMesh.php#a0b5505cdbb6799aed76cafb62a7e0135">n_nodes</a>();
<a name="l00059"></a>00059   <a class="code" href="classParallelMesh.php#a0bdfa08b935887abbc25dd72c8047fca">_n_elem</a>  = other_mesh.<a class="code" href="classParallelMesh.php#aaefea67041752d4e801f25d2a41c3552">n_elem</a>();
<a name="l00060"></a>00060   <a class="code" href="classParallelMesh.php#a55e7b1c0d855184e7db312cc2ddc0a8c">_max_node_id</a> = other_mesh.<a class="code" href="classParallelMesh.php#ac30d8f34e21ae07a6d9be2a5850c058c">max_node_id</a>();
<a name="l00061"></a>00061   <a class="code" href="classParallelMesh.php#a149c9eae01b607b2f9959683ccbdcf01">_max_elem_id</a> = other_mesh.<a class="code" href="classParallelMesh.php#a01b6a417b62c640cff4a50ffe13645a5">max_elem_id</a>();
<a name="l00062"></a>00062 }
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 
<a name="l00066"></a><a class="code" href="classParallelMesh.php#ab485de61b3714ff545724fea2dac82fa">00066</a> <a class="code" href="classParallelMesh.php#a875c73804bc4be3eaa45fdb70177398a">ParallelMesh::ParallelMesh</a> (<span class="keyword">const</span> <a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a> &amp;other_mesh) :
<a name="l00067"></a>00067   <a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a> (other_mesh)
<a name="l00068"></a>00068 {
<a name="l00069"></a>00069   this-&gt;<a class="code" href="classUnstructuredMesh.php#afecc40762dc88b1ef471a9d4a3938f4c">copy_nodes_and_elements</a>(other_mesh);
<a name="l00070"></a>00070   <a class="code" href="classParallelMesh.php#a40377d3c8e3bc9b45e5c08f55a33ef1a">_n_nodes</a> = other_mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>();
<a name="l00071"></a>00071   <a class="code" href="classParallelMesh.php#a0bdfa08b935887abbc25dd72c8047fca">_n_elem</a>  = other_mesh.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>();
<a name="l00072"></a>00072   <a class="code" href="classParallelMesh.php#a55e7b1c0d855184e7db312cc2ddc0a8c">_max_node_id</a> = other_mesh.<a class="code" href="classMeshBase.php#a5a56e1b57f60d011b67f1f43ff8a5891">max_node_id</a>();
<a name="l00073"></a>00073   <a class="code" href="classParallelMesh.php#a149c9eae01b607b2f9959683ccbdcf01">_max_elem_id</a> = other_mesh.<a class="code" href="classMeshBase.php#a05c0414e5c91b36e9698fc4f60cff642">max_elem_id</a>();
<a name="l00074"></a>00074 }
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 <span class="comment">// We use cached values for these so they can be called</span>
<a name="l00078"></a>00078 <span class="comment">// from one processor without bothering the rest, but</span>
<a name="l00079"></a>00079 <span class="comment">// we may need to update those caches before doing a full</span>
<a name="l00080"></a>00080 <span class="comment">// renumbering</span>
<a name="l00081"></a><a class="code" href="classParallelMesh.php#ae23de933ff7c8656e1262024a1aa2e92">00081</a> <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#ae23de933ff7c8656e1262024a1aa2e92">ParallelMesh::update_parallel_id_counts</a>()
<a name="l00082"></a>00082 {
<a name="l00083"></a>00083   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00084"></a>00084   parallel_only();
<a name="l00085"></a>00085 
<a name="l00086"></a>00086   <a class="code" href="classParallelMesh.php#a0bdfa08b935887abbc25dd72c8047fca">_n_elem</a> = this-&gt;<a class="code" href="classMeshBase.php#ab2d0abdfdf6c884bace77cf94af08874">n_local_elem</a>();
<a name="l00087"></a>00087   Parallel::sum(<a class="code" href="classParallelMesh.php#a0bdfa08b935887abbc25dd72c8047fca">_n_elem</a>);
<a name="l00088"></a>00088   <a class="code" href="classParallelMesh.php#a0bdfa08b935887abbc25dd72c8047fca">_n_elem</a> += this-&gt;<a class="code" href="classMeshBase.php#a10ec192ec64504fdc31812a9cb5139ac">n_unpartitioned_elem</a>();
<a name="l00089"></a>00089 
<a name="l00090"></a>00090   <a class="code" href="classParallelMesh.php#a149c9eae01b607b2f9959683ccbdcf01">_max_elem_id</a> = <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.empty() ?
<a name="l00091"></a>00091     0 : <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.rbegin()-&gt;first + 1;
<a name="l00092"></a>00092   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(<a class="code" href="classParallelMesh.php#a149c9eae01b607b2f9959683ccbdcf01">_max_elem_id</a>);
<a name="l00093"></a>00093 
<a name="l00094"></a>00094   <a class="code" href="classParallelMesh.php#a40377d3c8e3bc9b45e5c08f55a33ef1a">_n_nodes</a> = this-&gt;<a class="code" href="classMeshBase.php#a56053e95ae70a2f5c67725d5f4e6ea04">n_local_nodes</a>();
<a name="l00095"></a>00095   Parallel::sum(<a class="code" href="classParallelMesh.php#a40377d3c8e3bc9b45e5c08f55a33ef1a">_n_nodes</a>);
<a name="l00096"></a>00096   <a class="code" href="classParallelMesh.php#a40377d3c8e3bc9b45e5c08f55a33ef1a">_n_nodes</a> += this-&gt;<a class="code" href="classMeshBase.php#a8070c32e5adb4cc7664c76ca7d5260f6">n_unpartitioned_nodes</a>();
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   <a class="code" href="classParallelMesh.php#a55e7b1c0d855184e7db312cc2ddc0a8c">_max_node_id</a> = <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.empty() ?
<a name="l00099"></a>00099     0 : <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.rbegin()-&gt;first + 1;
<a name="l00100"></a>00100   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(<a class="code" href="classParallelMesh.php#a55e7b1c0d855184e7db312cc2ddc0a8c">_max_node_id</a>);
<a name="l00101"></a>00101 }
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 <span class="comment">// Or in debug mode we may want to test the uncached values without</span>
<a name="l00105"></a>00105 <span class="comment">// changing the cache</span>
<a name="l00106"></a><a class="code" href="classParallelMesh.php#a0b05286761dd00f468e271e75a0ddd23">00106</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallelMesh.php#a0b05286761dd00f468e271e75a0ddd23">ParallelMesh::parallel_n_elem</a>()<span class="keyword"> const</span>
<a name="l00107"></a>00107 <span class="keyword"></span>{
<a name="l00108"></a>00108   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00109"></a>00109   parallel_only();
<a name="l00110"></a>00110 
<a name="l00111"></a>00111   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local = this-&gt;<a class="code" href="classMeshBase.php#ab2d0abdfdf6c884bace77cf94af08874">n_local_elem</a>();
<a name="l00112"></a>00112   Parallel::sum(n_local);
<a name="l00113"></a>00113   n_local += this-&gt;<a class="code" href="classMeshBase.php#a10ec192ec64504fdc31812a9cb5139ac">n_unpartitioned_elem</a>();
<a name="l00114"></a>00114   <span class="keywordflow">return</span> n_local;
<a name="l00115"></a>00115 }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a><a class="code" href="classParallelMesh.php#a0e38945a413c69a17ae308b48890bbf5">00119</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallelMesh.php#a0e38945a413c69a17ae308b48890bbf5">ParallelMesh::parallel_max_elem_id</a>()<span class="keyword"> const</span>
<a name="l00120"></a>00120 <span class="keyword"></span>{
<a name="l00121"></a>00121   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00122"></a>00122   parallel_only();
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_local = <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.empty() ?
<a name="l00125"></a>00125     0 : <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.rbegin()-&gt;first + 1;
<a name="l00126"></a>00126   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(max_local);
<a name="l00127"></a>00127   <span class="keywordflow">return</span> max_local;
<a name="l00128"></a>00128 }
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 
<a name="l00132"></a><a class="code" href="classParallelMesh.php#a3222f264bd57a7c39d1e101314689c03">00132</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallelMesh.php#a3222f264bd57a7c39d1e101314689c03">ParallelMesh::parallel_n_nodes</a>()<span class="keyword"> const</span>
<a name="l00133"></a>00133 <span class="keyword"></span>{
<a name="l00134"></a>00134   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00135"></a>00135   parallel_only();
<a name="l00136"></a>00136 
<a name="l00137"></a>00137   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local = this-&gt;<a class="code" href="classMeshBase.php#a56053e95ae70a2f5c67725d5f4e6ea04">n_local_nodes</a>();
<a name="l00138"></a>00138   Parallel::sum(n_local);
<a name="l00139"></a>00139   n_local += this-&gt;<a class="code" href="classMeshBase.php#a8070c32e5adb4cc7664c76ca7d5260f6">n_unpartitioned_nodes</a>();
<a name="l00140"></a>00140   <span class="keywordflow">return</span> n_local;
<a name="l00141"></a>00141 }
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 
<a name="l00145"></a><a class="code" href="classParallelMesh.php#a0ba543c1ad92224e85f123ee942f1612">00145</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallelMesh.php#a0ba543c1ad92224e85f123ee942f1612">ParallelMesh::parallel_max_node_id</a>()<span class="keyword"> const</span>
<a name="l00146"></a>00146 <span class="keyword"></span>{
<a name="l00147"></a>00147   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00148"></a>00148   parallel_only();
<a name="l00149"></a>00149 
<a name="l00150"></a>00150   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_local = <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.empty() ?
<a name="l00151"></a>00151     0 : <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.rbegin()-&gt;first + 1;
<a name="l00152"></a>00152   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(max_local);
<a name="l00153"></a>00153   <span class="keywordflow">return</span> max_local;
<a name="l00154"></a>00154 }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a><a class="code" href="classParallelMesh.php#a1dc3e9b9efb18dde357eaae4df18feaf">00158</a> <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; <a class="code" href="classParallelMesh.php#a1dc3e9b9efb18dde357eaae4df18feaf">ParallelMesh::point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00159"></a>00159 <span class="keyword"></span>{
<a name="l00160"></a>00160   libmesh_assert (<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>[i] != NULL);
<a name="l00161"></a>00161   libmesh_assert (<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>[i]-&gt;<span class="keywordtype">id</span>() == i);  
<a name="l00162"></a>00162 
<a name="l00163"></a>00163   <span class="keywordflow">return</span> (*<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>[i]);
<a name="l00164"></a>00164 }
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00170"></a><a class="code" href="classParallelMesh.php#a0d1e373cd978cf40b1a072eacf119a7e">00170</a> <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>&amp; <a class="code" href="classParallelMesh.php#a0d1e373cd978cf40b1a072eacf119a7e">ParallelMesh::node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00171"></a>00171 <span class="keyword"></span>{
<a name="l00172"></a>00172   libmesh_assert (<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>[i] != NULL);
<a name="l00173"></a>00173   libmesh_assert (<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>[i]-&gt;<span class="keywordtype">id</span>() == i);  
<a name="l00174"></a>00174   
<a name="l00175"></a>00175   <span class="keywordflow">return</span> (*<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>[i]);
<a name="l00176"></a>00176 }
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a><a class="code" href="classParallelMesh.php#ae6aded5041595d9ff07915acabcb7f4c">00182</a> <a class="code" href="classNode.php">Node</a>&amp; <a class="code" href="classParallelMesh.php#a0d1e373cd978cf40b1a072eacf119a7e">ParallelMesh::node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00183"></a>00183 {
<a name="l00184"></a>00184   libmesh_assert (<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>[i] != NULL);
<a name="l00185"></a>00185   libmesh_assert (<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>[i]-&gt;<span class="keywordtype">id</span>() == i);  
<a name="l00186"></a>00186 
<a name="l00187"></a>00187   <span class="keywordflow">return</span> (*<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>[i]);
<a name="l00188"></a>00188 }
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 
<a name="l00192"></a><a class="code" href="classParallelMesh.php#a39d1343ddfc925e1012d021d9a11e42f">00192</a> <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classParallelMesh.php#a39d1343ddfc925e1012d021d9a11e42f">ParallelMesh::node_ptr</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00193"></a>00193 <span class="keyword"></span>{
<a name="l00194"></a>00194 <span class="comment">//  libmesh_assert (_nodes[i] != NULL);</span>
<a name="l00195"></a>00195   libmesh_assert (<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>[i] == NULL || <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>[i]-&gt;<span class="keywordtype">id</span>() == i);  
<a name="l00196"></a>00196   
<a name="l00197"></a>00197   <span class="keywordflow">return</span> <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>[i];
<a name="l00198"></a>00198 }
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 
<a name="l00203"></a><a class="code" href="classParallelMesh.php#a6035c5437a30537bd3deef2e777df297">00203</a> <a class="code" href="classNode.php">Node</a>* &amp; <a class="code" href="classParallelMesh.php#a39d1343ddfc925e1012d021d9a11e42f">ParallelMesh::node_ptr</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00204"></a>00204 {
<a name="l00205"></a>00205 <span class="comment">//  libmesh_assert (_nodes[i] != NULL);</span>
<a name="l00206"></a>00206   libmesh_assert (<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>[i] == NULL || <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>[i]-&gt;<span class="keywordtype">id</span>() == i);
<a name="l00207"></a>00207 
<a name="l00208"></a>00208   <span class="keywordflow">return</span> <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>[i];
<a name="l00209"></a>00209 }
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 
<a name="l00214"></a><a class="code" href="classParallelMesh.php#ae5df0d138114adafeae3bc6b3270cff8">00214</a> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classParallelMesh.php#ae5df0d138114adafeae3bc6b3270cff8">ParallelMesh::elem</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00215"></a>00215 <span class="keyword"></span>{
<a name="l00216"></a>00216 <span class="comment">//  libmesh_assert (_elements[i] != NULL);</span>
<a name="l00217"></a>00217   libmesh_assert (<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>[i] == NULL || <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>[i]-&gt;<span class="keywordtype">id</span>() == i);
<a name="l00218"></a>00218   
<a name="l00219"></a>00219   <span class="keywordflow">return</span> <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>[i];
<a name="l00220"></a>00220 }
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00225"></a><a class="code" href="classParallelMesh.php#a070d9e8636ce1e4fc4fe6ab0265462b0">00225</a> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classParallelMesh.php#a070d9e8636ce1e4fc4fe6ab0265462b0">ParallelMesh::add_elem</a> (<a class="code" href="classElem.php">Elem</a> *e)
<a name="l00226"></a>00226 {
<a name="l00227"></a>00227   <span class="comment">// Don&#39;t try to add NULLs!</span>
<a name="l00228"></a>00228   libmesh_assert(e);
<a name="l00229"></a>00229 
<a name="l00230"></a>00230   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_procid = e-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>();
<a name="l00231"></a>00231 
<a name="l00232"></a>00232   <span class="keywordflow">if</span> (!e-&gt;<a class="code" href="classDofObject.php#a941814a36472764092ae352543f3ecd7">valid_id</a>())
<a name="l00233"></a>00233     {
<a name="l00234"></a>00234       <span class="comment">// Use the unpartitioned ids for unpartitioned elems,</span>
<a name="l00235"></a>00235       <span class="comment">// in serial, and temporarily for ghost elems</span>
<a name="l00236"></a>00236       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> *next_id = &amp;<a class="code" href="classParallelMesh.php#a0e7b564b3093c49e6b56c2ce874ae112">_next_free_unpartitioned_elem_id</a>;
<a name="l00237"></a>00237       <span class="keywordflow">if</span> (elem_procid == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &amp;&amp;
<a name="l00238"></a>00238           !this-&gt;<a class="code" href="classParallelMesh.php#ac72c8fd7a3d1df94503f7028601c14df">is_serial</a>())
<a name="l00239"></a>00239         next_id = &amp;<a class="code" href="classParallelMesh.php#abcf351f2a4a6562b58cba564bd00c73d">_next_free_local_elem_id</a>;
<a name="l00240"></a>00240       e-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a> (*next_id);
<a name="l00241"></a>00241       *next_id += <a class="code" href="classMeshBase.php#a2399e70af69cf24f3add6c5a860edaa7">libMesh::n_processors</a>() + 1;
<a name="l00242"></a>00242     }
<a name="l00243"></a>00243   <span class="keywordflow">else</span>
<a name="l00244"></a>00244     {
<a name="l00245"></a>00245       <span class="keywordflow">if</span> (_next_free_unpartitioned_elem_id &lt;= e-&gt;<span class="keywordtype">id</span>())
<a name="l00246"></a>00246         <a class="code" href="classParallelMesh.php#a0e7b564b3093c49e6b56c2ce874ae112">_next_free_unpartitioned_elem_id</a> += <a class="code" href="classMeshBase.php#a2399e70af69cf24f3add6c5a860edaa7">libMesh::n_processors</a>() + 1;
<a name="l00247"></a>00247       <span class="keywordflow">if</span> (_next_free_local_elem_id &lt;= e-&gt;<span class="keywordtype">id</span>())
<a name="l00248"></a>00248         <a class="code" href="classParallelMesh.php#abcf351f2a4a6562b58cba564bd00c73d">_next_free_local_elem_id</a> += <a class="code" href="classMeshBase.php#a2399e70af69cf24f3add6c5a860edaa7">libMesh::n_processors</a>() + 1;
<a name="l00249"></a>00249     }
<a name="l00250"></a>00250 
<a name="l00251"></a>00251   <span class="comment">// Don&#39;t try to overwrite existing elems</span>
<a name="l00252"></a>00252   libmesh_assert (!<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>[e-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()]);
<a name="l00253"></a>00253 
<a name="l00254"></a>00254   <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>[e-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] = e;
<a name="l00255"></a>00255 
<a name="l00256"></a>00256   <span class="comment">// Make the cached elem data more accurate</span>
<a name="l00257"></a>00257   <a class="code" href="classParallelMesh.php#a0bdfa08b935887abbc25dd72c8047fca">_n_elem</a>++;
<a name="l00258"></a>00258   <a class="code" href="classParallelMesh.php#a149c9eae01b607b2f9959683ccbdcf01">_max_elem_id</a> = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(<a class="code" href="classParallelMesh.php#a149c9eae01b607b2f9959683ccbdcf01">_max_elem_id</a>, e-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()+1);
<a name="l00259"></a>00259   
<a name="l00260"></a>00260 <span class="comment">// Unpartitioned elems should be added on every processor</span>
<a name="l00261"></a>00261 <span class="comment">// And shouldn&#39;t be added in the same batch as ghost elems</span>
<a name="l00262"></a>00262 <span class="comment">// But we might be just adding on processor 0 to</span>
<a name="l00263"></a>00263 <span class="comment">// broadcast later</span>
<a name="l00264"></a>00264 <span class="preprocessor">#if 0</span>
<a name="l00265"></a>00265 <span class="preprocessor"></span><span class="preprocessor">#ifdef DEBUG</span>
<a name="l00266"></a>00266 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (elem_procid == <a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>)
<a name="l00267"></a>00267     {
<a name="l00268"></a>00268       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_id = e-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l00269"></a>00269       <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(elem_id);
<a name="l00270"></a>00270       libmesh_assert(elem_id == e-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>());
<a name="l00271"></a>00271     }
<a name="l00272"></a>00272 <span class="preprocessor">#endif</span>
<a name="l00273"></a>00273 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00274"></a>00274 <span class="preprocessor"></span>
<a name="l00275"></a>00275   <span class="keywordflow">return</span> e;
<a name="l00276"></a>00276 }
<a name="l00277"></a>00277 
<a name="l00278"></a>00278 
<a name="l00279"></a>00279 
<a name="l00280"></a><a class="code" href="classParallelMesh.php#aadf11922b8147ddc3680d9a7da5d4447">00280</a> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classParallelMesh.php#aadf11922b8147ddc3680d9a7da5d4447">ParallelMesh::insert_elem</a> (<a class="code" href="classElem.php">Elem</a>* e)
<a name="l00281"></a>00281 {
<a name="l00282"></a>00282   <span class="keywordflow">if</span> (<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>[e-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()])
<a name="l00283"></a>00283     this-&gt;<a class="code" href="classParallelMesh.php#a7f67f79d1533bcace8c133804ab977b2">delete_elem</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>[e-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()]);
<a name="l00284"></a>00284 
<a name="l00285"></a>00285   <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>[e-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] = e;
<a name="l00286"></a>00286 
<a name="l00287"></a>00287   <span class="keywordflow">return</span> e;
<a name="l00288"></a>00288 }
<a name="l00289"></a>00289 
<a name="l00290"></a>00290 
<a name="l00291"></a>00291 
<a name="l00292"></a><a class="code" href="classParallelMesh.php#a7f67f79d1533bcace8c133804ab977b2">00292</a> <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#a7f67f79d1533bcace8c133804ab977b2">ParallelMesh::delete_elem</a>(<a class="code" href="classElem.php">Elem</a>* e)
<a name="l00293"></a>00293 {
<a name="l00294"></a>00294   libmesh_assert (e);
<a name="l00295"></a>00295 
<a name="l00296"></a>00296   <span class="comment">// Delete the element from the BoundaryInfo object</span>
<a name="l00297"></a>00297   this-&gt;<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;remove(e);
<a name="l00298"></a>00298 
<a name="l00299"></a>00299   <span class="comment">// But not yet from the container; we might invalidate</span>
<a name="l00300"></a>00300   <span class="comment">// an iterator that way!</span>
<a name="l00301"></a>00301 
<a name="l00302"></a>00302   <span class="comment">//_elements.erase(e-&gt;id());</span>
<a name="l00303"></a>00303 
<a name="l00304"></a>00304   <span class="comment">// Instead, we set it to NULL for now</span>
<a name="l00305"></a>00305 
<a name="l00306"></a>00306   <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>[e-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] = NULL;
<a name="l00307"></a>00307   
<a name="l00308"></a>00308   <span class="comment">// delete the element</span>
<a name="l00309"></a>00309   <span class="keyword">delete</span> e;
<a name="l00310"></a>00310 }
<a name="l00311"></a>00311 
<a name="l00312"></a>00312 
<a name="l00313"></a>00313 
<a name="l00314"></a><a class="code" href="classParallelMesh.php#a4af7c5ed955150e759d7d311c7179905">00314</a> <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#a4af7c5ed955150e759d7d311c7179905">ParallelMesh::renumber_elem</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_id,
<a name="l00315"></a>00315                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_id)
<a name="l00316"></a>00316 {
<a name="l00317"></a>00317   <a class="code" href="classElem.php">Elem</a> *<a class="code" href="classParallelMesh.php#ae5df0d138114adafeae3bc6b3270cff8">elem</a> = <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>[old_id];
<a name="l00318"></a>00318   libmesh_assert (elem);
<a name="l00319"></a>00319   libmesh_assert (elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() == old_id);
<a name="l00320"></a>00320 
<a name="l00321"></a>00321   elem-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a>(new_id);
<a name="l00322"></a>00322   libmesh_assert (!<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>[new_id]);
<a name="l00323"></a>00323   <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>[new_id] = <a class="code" href="classParallelMesh.php#ae5df0d138114adafeae3bc6b3270cff8">elem</a>;
<a name="l00324"></a>00324   <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#aee38e1c8f77d4eeff04b74d19500429f">erase</a>(old_id);
<a name="l00325"></a>00325 }
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 
<a name="l00329"></a><a class="code" href="classParallelMesh.php#a9a458dd93052e3707da352e1ca0ea0b6">00329</a> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classParallelMesh.php#a9a458dd93052e3707da352e1ca0ea0b6">ParallelMesh::add_point</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00330"></a>00330                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>,
<a name="l00331"></a>00331                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)
<a name="l00332"></a>00332 {  
<a name="l00333"></a>00333   <span class="keywordflow">if</span> (<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.count(<span class="keywordtype">id</span>))
<a name="l00334"></a>00334     {
<a name="l00335"></a>00335       <a class="code" href="classNode.php">Node</a> *n = <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>[id];
<a name="l00336"></a>00336       libmesh_assert (n);
<a name="l00337"></a>00337       libmesh_assert (n-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() == id);
<a name="l00338"></a>00338       
<a name="l00339"></a>00339       *n = p;
<a name="l00340"></a>00340       n-&gt;processor_id() = proc_id;
<a name="l00341"></a>00341 
<a name="l00342"></a>00342       <span class="keywordflow">return</span> n;
<a name="l00343"></a>00343     }
<a name="l00344"></a>00344 
<a name="l00345"></a>00345   <a class="code" href="classNode.php">Node</a>* n = <a class="code" href="classNode.php#aa6175b07d8a78dc554bb0f9f4727b02e">Node::build</a>(p, <span class="keywordtype">id</span>).release();
<a name="l00346"></a>00346   n-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() = proc_id;
<a name="l00347"></a>00347 
<a name="l00348"></a>00348   <span class="keywordflow">return</span> <a class="code" href="classParallelMesh.php#afe5b25cec4f3944296a9030a7e0f45d1">ParallelMesh::add_node</a>(n);
<a name="l00349"></a>00349 }
<a name="l00350"></a>00350 
<a name="l00351"></a>00351 
<a name="l00352"></a>00352 
<a name="l00353"></a><a class="code" href="classParallelMesh.php#afe5b25cec4f3944296a9030a7e0f45d1">00353</a> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classParallelMesh.php#afe5b25cec4f3944296a9030a7e0f45d1">ParallelMesh::add_node</a> (<a class="code" href="classNode.php">Node</a> *n)
<a name="l00354"></a>00354 {
<a name="l00355"></a>00355   <span class="comment">// Don&#39;t try to add NULLs!</span>
<a name="l00356"></a>00356   libmesh_assert(n);
<a name="l00357"></a>00357 
<a name="l00358"></a>00358   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_procid = n-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>();
<a name="l00359"></a>00359 
<a name="l00360"></a>00360   <span class="keywordflow">if</span> (!n-&gt;<a class="code" href="classDofObject.php#a941814a36472764092ae352543f3ecd7">valid_id</a>())
<a name="l00361"></a>00361     {
<a name="l00362"></a>00362       <span class="comment">// Use the unpartitioned ids for unpartitioned nodes,</span>
<a name="l00363"></a>00363       <span class="comment">// in serial, and temporarily for ghost nodes</span>
<a name="l00364"></a>00364       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> *next_id = &amp;<a class="code" href="classParallelMesh.php#ad7beb6c794979321b7bb1a1010b842d4">_next_free_unpartitioned_node_id</a>;
<a name="l00365"></a>00365       <span class="keywordflow">if</span> (node_procid == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &amp;&amp;
<a name="l00366"></a>00366           !this-&gt;<a class="code" href="classParallelMesh.php#ac72c8fd7a3d1df94503f7028601c14df">is_serial</a>())
<a name="l00367"></a>00367         next_id = &amp;<a class="code" href="classParallelMesh.php#acca1c020ab2000bb301b2d16e7a5b2bd">_next_free_local_node_id</a>;
<a name="l00368"></a>00368       n-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a> (*next_id);
<a name="l00369"></a>00369       *next_id += <a class="code" href="classMeshBase.php#a2399e70af69cf24f3add6c5a860edaa7">libMesh::n_processors</a>() + 1;
<a name="l00370"></a>00370     }
<a name="l00371"></a>00371   <span class="keywordflow">else</span>
<a name="l00372"></a>00372     {
<a name="l00373"></a>00373       <span class="keywordflow">if</span> (_next_free_unpartitioned_node_id &lt;= n-&gt;<span class="keywordtype">id</span>())
<a name="l00374"></a>00374         <a class="code" href="classParallelMesh.php#ad7beb6c794979321b7bb1a1010b842d4">_next_free_unpartitioned_node_id</a> += <a class="code" href="classMeshBase.php#a2399e70af69cf24f3add6c5a860edaa7">libMesh::n_processors</a>() + 1;
<a name="l00375"></a>00375       <span class="keywordflow">if</span> (_next_free_local_node_id &lt;= n-&gt;<span class="keywordtype">id</span>())
<a name="l00376"></a>00376         <a class="code" href="classParallelMesh.php#acca1c020ab2000bb301b2d16e7a5b2bd">_next_free_local_node_id</a> += <a class="code" href="classMeshBase.php#a2399e70af69cf24f3add6c5a860edaa7">libMesh::n_processors</a>() + 1;
<a name="l00377"></a>00377     }
<a name="l00378"></a>00378 
<a name="l00379"></a>00379   <span class="comment">// Don&#39;t try to overwrite existing nodes</span>
<a name="l00380"></a>00380   libmesh_assert (!<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>[n-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()]);
<a name="l00381"></a>00381 
<a name="l00382"></a>00382   <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>[n-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] = n;
<a name="l00383"></a>00383   
<a name="l00384"></a>00384   <span class="comment">// Make the cached elem data more accurate</span>
<a name="l00385"></a>00385   <a class="code" href="classParallelMesh.php#a40377d3c8e3bc9b45e5c08f55a33ef1a">_n_nodes</a>++;
<a name="l00386"></a>00386   <a class="code" href="classParallelMesh.php#a55e7b1c0d855184e7db312cc2ddc0a8c">_max_node_id</a> = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(<a class="code" href="classParallelMesh.php#a55e7b1c0d855184e7db312cc2ddc0a8c">_max_node_id</a>, n-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()+1);
<a name="l00387"></a>00387   
<a name="l00388"></a>00388 <span class="comment">// Unpartitioned nodes should be added on every processor</span>
<a name="l00389"></a>00389 <span class="comment">// And shouldn&#39;t be added in the same batch as ghost nodes</span>
<a name="l00390"></a>00390 <span class="comment">// But we might be just adding on processor 0 to</span>
<a name="l00391"></a>00391 <span class="comment">// broadcast later</span>
<a name="l00392"></a>00392 <span class="preprocessor">#if 0</span>
<a name="l00393"></a>00393 <span class="preprocessor"></span><span class="preprocessor">#ifdef DEBUG</span>
<a name="l00394"></a>00394 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (node_procid == <a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>)
<a name="l00395"></a>00395     {
<a name="l00396"></a>00396       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_id = n-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l00397"></a>00397       <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(node_id);
<a name="l00398"></a>00398       libmesh_assert(node_id == n-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>());
<a name="l00399"></a>00399     }
<a name="l00400"></a>00400 <span class="preprocessor">#endif</span>
<a name="l00401"></a>00401 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00402"></a>00402 <span class="preprocessor"></span>
<a name="l00403"></a>00403   <span class="keywordflow">return</span> n;
<a name="l00404"></a>00404 }
<a name="l00405"></a>00405 
<a name="l00406"></a>00406 
<a name="l00407"></a>00407 
<a name="l00408"></a><a class="code" href="classParallelMesh.php#ae5a2ef7ac888ae42fe08bb9716664795">00408</a> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classParallelMesh.php#ae5a2ef7ac888ae42fe08bb9716664795">ParallelMesh::insert_node</a> (<a class="code" href="classNode.php">Node</a>* n)
<a name="l00409"></a>00409 {
<a name="l00410"></a>00410   <span class="comment">// If we already have this node we cannot</span>
<a name="l00411"></a>00411   <span class="comment">// simply delete it, because we may have elements</span>
<a name="l00412"></a>00412   <span class="comment">// which are attached to its address.</span>
<a name="l00413"></a>00413   <span class="comment">//</span>
<a name="l00414"></a>00414   <span class="comment">// Instead, call the Node = Point assignment operator</span>
<a name="l00415"></a>00415   <span class="comment">// to overwrite the spatial coordinates (but keep its</span>
<a name="l00416"></a>00416   <span class="comment">// address), delete the provided node, and return the</span>
<a name="l00417"></a>00417   <span class="comment">// address of the one we already had.</span>
<a name="l00418"></a>00418   <span class="keywordflow">if</span> (<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.count(n-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()))
<a name="l00419"></a>00419     {
<a name="l00420"></a>00420       <a class="code" href="classNode.php">Node</a> *my_n = <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>[n-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()];
<a name="l00421"></a>00421 
<a name="l00422"></a>00422       *my_n = <span class="keyword">static_cast&lt;</span><a class="code" href="classPoint.php">Point</a><span class="keyword">&gt;</span>(*n);
<a name="l00423"></a>00423       <span class="keyword">delete</span> n;
<a name="l00424"></a>00424       n = my_n;
<a name="l00425"></a>00425     }
<a name="l00426"></a>00426   <span class="keywordflow">else</span>
<a name="l00427"></a>00427     <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>[n-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] = n;
<a name="l00428"></a>00428 
<a name="l00429"></a>00429   <span class="keywordflow">return</span> n;
<a name="l00430"></a>00430 }
<a name="l00431"></a>00431 
<a name="l00432"></a>00432 
<a name="l00433"></a>00433 
<a name="l00434"></a><a class="code" href="classParallelMesh.php#adf7540eaf668eda49a4bd3d72c28d2c7">00434</a> <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#adf7540eaf668eda49a4bd3d72c28d2c7">ParallelMesh::delete_node</a>(<a class="code" href="classNode.php">Node</a>* n)
<a name="l00435"></a>00435 {
<a name="l00436"></a>00436   libmesh_assert (n != NULL);
<a name="l00437"></a>00437   libmesh_assert (<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>[n-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] != NULL);
<a name="l00438"></a>00438 
<a name="l00439"></a>00439   <span class="comment">// Delete the node from the BoundaryInfo object</span>
<a name="l00440"></a>00440   this-&gt;<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;remove(n);
<a name="l00441"></a>00441 
<a name="l00442"></a>00442   <span class="comment">// And from the container</span>
<a name="l00443"></a>00443   <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#aee38e1c8f77d4eeff04b74d19500429f">erase</a>(n-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>());
<a name="l00444"></a>00444   
<a name="l00445"></a>00445   <span class="comment">// delete the node</span>
<a name="l00446"></a>00446   <span class="keyword">delete</span> n;
<a name="l00447"></a>00447 }
<a name="l00448"></a>00448 
<a name="l00449"></a>00449 
<a name="l00450"></a>00450 
<a name="l00451"></a><a class="code" href="classParallelMesh.php#a72988a5f21d74f5195c734155d0dcfa1">00451</a> <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#a72988a5f21d74f5195c734155d0dcfa1">ParallelMesh::renumber_node</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_id,
<a name="l00452"></a>00452                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_id)
<a name="l00453"></a>00453 {
<a name="l00454"></a>00454   <a class="code" href="classNode.php">Node</a> *<a class="code" href="classParallelMesh.php#a0d1e373cd978cf40b1a072eacf119a7e">node</a> = <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>[old_id];
<a name="l00455"></a>00455   libmesh_assert (node);
<a name="l00456"></a>00456   libmesh_assert (node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() == old_id);
<a name="l00457"></a>00457 
<a name="l00458"></a>00458   node-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a>(new_id);
<a name="l00459"></a>00459   libmesh_assert (!<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>[new_id]);
<a name="l00460"></a>00460   <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>[new_id] = <a class="code" href="classParallelMesh.php#a0d1e373cd978cf40b1a072eacf119a7e">node</a>;
<a name="l00461"></a>00461   <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#aee38e1c8f77d4eeff04b74d19500429f">erase</a>(old_id);
<a name="l00462"></a>00462 }
<a name="l00463"></a>00463 
<a name="l00464"></a>00464 
<a name="l00465"></a>00465 
<a name="l00466"></a><a class="code" href="classParallelMesh.php#ad0429ae4ae81a253098ff659bae00de4">00466</a> <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#ad0429ae4ae81a253098ff659bae00de4">ParallelMesh::clear</a> ()
<a name="l00467"></a>00467 {
<a name="l00468"></a>00468   <span class="comment">// Call parent clear function</span>
<a name="l00469"></a>00469   <a class="code" href="classParallelMesh.php#ad0429ae4ae81a253098ff659bae00de4">MeshBase::clear</a>();
<a name="l00470"></a>00470 
<a name="l00471"></a>00471   
<a name="l00472"></a>00472   <span class="comment">// Clear our elements and nodes</span>
<a name="l00473"></a>00473   {
<a name="l00474"></a>00474     <a class="code" href="classParallelMesh.php#a755d720d8a69b18ca13180a6efa5722b">elem_iterator_imp</a>        it = <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>();
<a name="l00475"></a>00475     <span class="keyword">const</span> <a class="code" href="classParallelMesh.php#a755d720d8a69b18ca13180a6efa5722b">elem_iterator_imp</a> end = <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>();
<a name="l00476"></a>00476 
<a name="l00477"></a>00477     <span class="comment">// There is no need to remove the elements from</span>
<a name="l00478"></a>00478     <span class="comment">// the BoundaryInfo data structure since we</span>
<a name="l00479"></a>00479     <span class="comment">// already cleared it.</span>
<a name="l00480"></a>00480     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00481"></a>00481       <span class="keyword">delete</span> *it;
<a name="l00482"></a>00482 
<a name="l00483"></a>00483     <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.clear();
<a name="l00484"></a>00484   }
<a name="l00485"></a>00485 
<a name="l00486"></a>00486   <span class="comment">// clear the nodes data structure</span>
<a name="l00487"></a>00487   {
<a name="l00488"></a>00488     <a class="code" href="classParallelMesh.php#ace78878c29e013e5ce3b0fe544d7196f">node_iterator_imp</a> it  = <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>();
<a name="l00489"></a>00489     <a class="code" href="classParallelMesh.php#ace78878c29e013e5ce3b0fe544d7196f">node_iterator_imp</a> end = <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>();
<a name="l00490"></a>00490 
<a name="l00491"></a>00491     <span class="comment">// There is no need to remove the nodes from</span>
<a name="l00492"></a>00492     <span class="comment">// the BoundaryInfo data structure since we</span>
<a name="l00493"></a>00493     <span class="comment">// already cleared it.</span>
<a name="l00494"></a>00494     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00495"></a>00495       <span class="keyword">delete</span> *it;
<a name="l00496"></a>00496     
<a name="l00497"></a>00497     <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.clear();
<a name="l00498"></a>00498   }
<a name="l00499"></a>00499 
<a name="l00500"></a>00500   <span class="comment">// We&#39;re no longer distributed if we were before</span>
<a name="l00501"></a>00501   <a class="code" href="classParallelMesh.php#a9c13b059a6cf3c9d4ad8da7fbb644f08">_is_serial</a> = <span class="keyword">true</span>;
<a name="l00502"></a>00502 
<a name="l00503"></a>00503   <span class="comment">// Correct our caches</span>
<a name="l00504"></a>00504   <a class="code" href="classParallelMesh.php#a40377d3c8e3bc9b45e5c08f55a33ef1a">_n_nodes</a> = 0;
<a name="l00505"></a>00505   <a class="code" href="classParallelMesh.php#a0bdfa08b935887abbc25dd72c8047fca">_n_elem</a> = 0;
<a name="l00506"></a>00506   <a class="code" href="classParallelMesh.php#a55e7b1c0d855184e7db312cc2ddc0a8c">_max_node_id</a> = 0;
<a name="l00507"></a>00507   <a class="code" href="classParallelMesh.php#a149c9eae01b607b2f9959683ccbdcf01">_max_elem_id</a> = 0;
<a name="l00508"></a>00508   <a class="code" href="classParallelMesh.php#acca1c020ab2000bb301b2d16e7a5b2bd">_next_free_local_node_id</a> = <a class="code" href="classMeshBase.php#aba369b64ee6185d86a6b60089ba5af60">libMesh::processor_id</a>();
<a name="l00509"></a>00509   <a class="code" href="classParallelMesh.php#abcf351f2a4a6562b58cba564bd00c73d">_next_free_local_elem_id</a> = <a class="code" href="classMeshBase.php#aba369b64ee6185d86a6b60089ba5af60">libMesh::processor_id</a>();
<a name="l00510"></a>00510   <a class="code" href="classParallelMesh.php#ad7beb6c794979321b7bb1a1010b842d4">_next_free_unpartitioned_node_id</a> = <a class="code" href="classMeshBase.php#a2399e70af69cf24f3add6c5a860edaa7">libMesh::n_processors</a>();
<a name="l00511"></a>00511   <a class="code" href="classParallelMesh.php#a0e7b564b3093c49e6b56c2ce874ae112">_next_free_unpartitioned_elem_id</a> = <a class="code" href="classMeshBase.php#a2399e70af69cf24f3add6c5a860edaa7">libMesh::n_processors</a>();
<a name="l00512"></a>00512 }
<a name="l00513"></a>00513 
<a name="l00514"></a>00514 
<a name="l00515"></a>00515 
<a name="l00516"></a>00516 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00517"></a>00517 <span class="preprocessor"></span><span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00518"></a>00518 <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#a64a1e4b395d28827764998859aa9c083">ParallelMesh::libmesh_assert_valid_parallel_object_ids</a> 
<a name="l00519"></a><a class="code" href="classParallelMesh.php#a64a1e4b395d28827764998859aa9c083">00519</a>   (<span class="keyword">const</span> <a class="code" href="classmapvector.php">mapvector&lt;T*&gt;</a> &amp;objects) <span class="keyword">const</span>
<a name="l00520"></a>00520 {
<a name="l00521"></a>00521   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00522"></a>00522   parallel_only();
<a name="l00523"></a>00523 
<a name="l00524"></a>00524   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pmax_elem_id = this-&gt;parallel_max_elem_id();
<a name="l00525"></a>00525 
<a name="l00526"></a>00526   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != pmax_elem_id; ++i)
<a name="l00527"></a>00527     {
<a name="l00528"></a>00528       T* obj = objects[i]; <span class="comment">// Returns NULL if there&#39;s no map entry</span>
<a name="l00529"></a>00529 
<a name="l00530"></a>00530       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dofid = obj &amp;&amp; obj-&gt;valid_id() ?
<a name="l00531"></a>00531         obj-&gt;id() : <a class="code" href="classDofObject.php#a35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>;
<a name="l00532"></a>00532       <span class="comment">// Local lookups by id should return the requested object</span>
<a name="l00533"></a>00533       libmesh_assert(!obj || obj-&gt;id() == i);
<a name="l00534"></a>00534 
<a name="l00535"></a>00535       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> min_dofid = dofid;
<a name="l00536"></a>00536       <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(min_dofid);
<a name="l00537"></a>00537       <span class="comment">// All processors with an object should agree on id</span>
<a name="l00538"></a>00538       libmesh_assert (!obj || dofid == min_dofid);
<a name="l00539"></a>00539 
<a name="l00540"></a>00540       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procid = obj &amp;&amp; obj-&gt;valid_processor_id() ?
<a name="l00541"></a>00541         obj-&gt;processor_id() : <a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>;
<a name="l00542"></a>00542 
<a name="l00543"></a>00543       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> min_procid = procid;
<a name="l00544"></a>00544       <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(min_procid);
<a name="l00545"></a>00545       <span class="comment">// All processors with an object should agree on processor id</span>
<a name="l00546"></a>00546       libmesh_assert (!obj || procid == min_procid);
<a name="l00547"></a>00547       <span class="comment">// I should own any object another processor thinks I do</span>
<a name="l00548"></a>00548       libmesh_assert (min_procid != <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() || obj);
<a name="l00549"></a>00549     }
<a name="l00550"></a>00550 }
<a name="l00551"></a>00551 
<a name="l00552"></a>00552 
<a name="l00553"></a>00553 
<a name="l00554"></a><a class="code" href="classParallelMesh.php#aa17a6d0f8e2d57519d42f7be307d6ee3">00554</a> <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#aa17a6d0f8e2d57519d42f7be307d6ee3">ParallelMesh::libmesh_assert_valid_parallel_ids</a> ()<span class="keyword"> const</span>
<a name="l00555"></a>00555 <span class="keyword"></span>{
<a name="l00556"></a>00556   this-&gt;<a class="code" href="classParallelMesh.php#a64a1e4b395d28827764998859aa9c083">libmesh_assert_valid_parallel_object_ids</a> (this-&gt;<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>);
<a name="l00557"></a>00557   this-&gt;<a class="code" href="classParallelMesh.php#a64a1e4b395d28827764998859aa9c083">libmesh_assert_valid_parallel_object_ids</a> (this-&gt;<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>);
<a name="l00558"></a>00558 }
<a name="l00559"></a>00559 
<a name="l00560"></a>00560 
<a name="l00561"></a>00561 
<a name="l00562"></a><a class="code" href="classParallelMesh.php#ab6e23e11a72b34b34626bc1bb885c44e">00562</a> <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#ab6e23e11a72b34b34626bc1bb885c44e">ParallelMesh::libmesh_assert_valid_parallel_flags</a> ()<span class="keyword"> const</span>
<a name="l00563"></a>00563 <span class="keyword"></span>{
<a name="l00564"></a>00564 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00565"></a>00565 <span class="preprocessor"></span>  <span class="comment">// This function must be run on all processors at once</span>
<a name="l00566"></a>00566   parallel_only();
<a name="l00567"></a>00567 
<a name="l00568"></a>00568   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pmax_elem_id = this-&gt;<a class="code" href="classParallelMesh.php#a0e38945a413c69a17ae308b48890bbf5">parallel_max_elem_id</a>();
<a name="l00569"></a>00569 
<a name="l00570"></a>00570   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != pmax_elem_id; ++i)
<a name="l00571"></a>00571     {
<a name="l00572"></a>00572       <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classParallelMesh.php#ae5df0d138114adafeae3bc6b3270cff8">elem</a> = <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>[i]; <span class="comment">// Returns NULL if there&#39;s no map entry</span>
<a name="l00573"></a>00573 
<a name="l00574"></a>00574       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> refinement_flag   = elem ?
<a name="l00575"></a>00575         <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span> (elem-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>()) : <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00576"></a>00576       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p_refinement_flag = elem ?
<a name="l00577"></a>00577         <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span> (elem-&gt;<a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>()) : <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00578"></a>00578 
<a name="l00579"></a>00579       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> min_rflag = refinement_flag;
<a name="l00580"></a>00580       <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(min_rflag);
<a name="l00581"></a>00581       <span class="comment">// All processors with this element should agree on flag</span>
<a name="l00582"></a>00582       libmesh_assert (!elem || min_rflag == refinement_flag);
<a name="l00583"></a>00583 
<a name="l00584"></a>00584       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> min_pflag = p_refinement_flag;
<a name="l00585"></a>00585       <span class="comment">// All processors with this element should agree on flag</span>
<a name="l00586"></a>00586       libmesh_assert (!elem || min_pflag == p_refinement_flag);
<a name="l00587"></a>00587     }
<a name="l00588"></a>00588 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR</span>
<a name="l00589"></a>00589 <span class="preprocessor"></span>}
<a name="l00590"></a>00590 <span class="preprocessor">#endif // DEBUG</span>
<a name="l00591"></a>00591 <span class="preprocessor"></span>
<a name="l00592"></a>00592 
<a name="l00593"></a>00593 
<a name="l00594"></a>00594 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00595"></a><a class="code" href="classParallelMesh.php#aeff924bd33e8926235470d13c34a6e2e">00595</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallelMesh.php#aeff924bd33e8926235470d13c34a6e2e">ParallelMesh::renumber_dof_objects</a> (<a class="code" href="classmapvector.php">mapvector&lt;T*&gt;</a> &amp;objects)
<a name="l00596"></a>00596 {
<a name="l00597"></a>00597   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00598"></a>00598   parallel_only();
<a name="l00599"></a>00599 
<a name="l00600"></a>00600   <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classmapvector_1_1veclike__iterator.php">mapvector&lt;T*&gt;::veclike_iterator</a> object_iterator;
<a name="l00601"></a>00601 
<a name="l00602"></a>00602   <span class="comment">// In parallel we may not know what objects other processors have.</span>
<a name="l00603"></a>00603   <span class="comment">// Start by figuring out how many</span>
<a name="l00604"></a>00604   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> unpartitioned_objects = 0;
<a name="l00605"></a>00605 
<a name="l00606"></a>00606   std::vector&lt;unsigned int&gt;
<a name="l00607"></a>00607     ghost_objects_from_proc(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l00608"></a>00608 
<a name="l00609"></a>00609   object_iterator it  = objects.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>();
<a name="l00610"></a>00610   object_iterator end = objects.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>();
<a name="l00611"></a>00611 
<a name="l00612"></a>00612   <span class="keywordflow">for</span> (; it != end;)
<a name="l00613"></a>00613     {
<a name="l00614"></a>00614       T *obj = *it;
<a name="l00615"></a>00615 
<a name="l00616"></a>00616       <span class="comment">// Remove any NULL container entries while we&#39;re here,</span>
<a name="l00617"></a>00617       <span class="comment">// being careful not to invalidate our iterator</span>
<a name="l00618"></a>00618       <span class="keywordflow">if</span> (!*it)
<a name="l00619"></a>00619         objects.<a class="code" href="classmapvector.php#aee38e1c8f77d4eeff04b74d19500429f">erase</a>(it++);
<a name="l00620"></a>00620       <span class="keywordflow">else</span>
<a name="l00621"></a>00621         {
<a name="l00622"></a>00622           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> obj_procid = obj-&gt;processor_id();
<a name="l00623"></a>00623           <span class="keywordflow">if</span> (obj_procid == <a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>)
<a name="l00624"></a>00624             unpartitioned_objects++;
<a name="l00625"></a>00625           <span class="keywordflow">else</span>
<a name="l00626"></a>00626             ghost_objects_from_proc[obj_procid]++;
<a name="l00627"></a>00627           ++it;
<a name="l00628"></a>00628         }
<a name="l00629"></a>00629     }
<a name="l00630"></a>00630 
<a name="l00631"></a>00631   std::vector&lt;unsigned int&gt; objects_on_proc(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l00632"></a>00632   <a class="code" href="classParallelMesh.php#afabbcd5f3423e2985f288723951d595f">Parallel::allgather</a>(ghost_objects_from_proc[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()],
<a name="l00633"></a>00633                       objects_on_proc);
<a name="l00634"></a>00634 
<a name="l00635"></a>00635 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00636"></a>00636 <span class="preprocessor"></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_unpartitioned_objects = unpartitioned_objects;
<a name="l00637"></a>00637   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(global_unpartitioned_objects);
<a name="l00638"></a>00638   libmesh_assert(global_unpartitioned_objects == unpartitioned_objects);
<a name="l00639"></a>00639   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p != <a class="code" href="classMeshBase.php#a2399e70af69cf24f3add6c5a860edaa7">libMesh::n_processors</a>(); ++p)
<a name="l00640"></a>00640     libmesh_assert(ghost_objects_from_proc[p] &lt;= objects_on_proc[p]);
<a name="l00641"></a>00641 <span class="preprocessor">#endif</span>
<a name="l00642"></a>00642 <span class="preprocessor"></span>
<a name="l00643"></a>00643   <span class="comment">// We&#39;ll renumber objects in blocks by processor id</span>
<a name="l00644"></a>00644   std::vector&lt;unsigned int&gt; first_object_on_proc(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00645"></a>00645   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i != <a class="code" href="classMeshBase.php#a2399e70af69cf24f3add6c5a860edaa7">libMesh::n_processors</a>(); ++i)
<a name="l00646"></a>00646     first_object_on_proc[i] = first_object_on_proc[i-1] +
<a name="l00647"></a>00647                               objects_on_proc[i-1];
<a name="l00648"></a>00648   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> next_id = first_object_on_proc[<a class="code" href="classMeshBase.php#aba369b64ee6185d86a6b60089ba5af60">libMesh::processor_id</a>()];
<a name="l00649"></a>00649   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_free_id =
<a name="l00650"></a>00650     first_object_on_proc[<a class="code" href="classMeshBase.php#a2399e70af69cf24f3add6c5a860edaa7">libMesh::n_processors</a>()-1] +
<a name="l00651"></a>00651     objects_on_proc[<a class="code" href="classMeshBase.php#a2399e70af69cf24f3add6c5a860edaa7">libMesh::n_processors</a>()-1] + 
<a name="l00652"></a>00652     unpartitioned_objects;
<a name="l00653"></a>00653 
<a name="l00654"></a>00654   <span class="comment">// First set new local object ids and build request sets </span>
<a name="l00655"></a>00655   <span class="comment">// for non-local object ids</span>
<a name="l00656"></a>00656   
<a name="l00657"></a>00657   <span class="comment">// Request sets to send to each processor</span>
<a name="l00658"></a>00658   std::vector&lt;std::vector&lt;unsigned int&gt; &gt;
<a name="l00659"></a>00659     requested_ids(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00660"></a>00660 
<a name="l00661"></a>00661   <span class="comment">// We know how many objects live on each processor, so reseve() space for</span>
<a name="l00662"></a>00662   <span class="comment">// each.</span>
<a name="l00663"></a>00663   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p != <a class="code" href="classMeshBase.php#a2399e70af69cf24f3add6c5a860edaa7">libMesh::n_processors</a>(); ++p)
<a name="l00664"></a>00664     <span class="keywordflow">if</span> (p != <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00665"></a>00665       requested_ids[p].reserve(ghost_objects_from_proc[p]);
<a name="l00666"></a>00666 
<a name="l00667"></a>00667   end = objects.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>();
<a name="l00668"></a>00668   <span class="keywordflow">for</span> (it = objects.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(); it != end; ++it)
<a name="l00669"></a>00669     {
<a name="l00670"></a>00670       T *obj = *it;
<a name="l00671"></a>00671       <span class="keywordflow">if</span> (obj-&gt;processor_id() == <a class="code" href="classMeshBase.php#aba369b64ee6185d86a6b60089ba5af60">libMesh::processor_id</a>())
<a name="l00672"></a>00672         obj-&gt;set_id(next_id++);
<a name="l00673"></a>00673       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (obj-&gt;processor_id() != <a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>)
<a name="l00674"></a>00674         requested_ids[obj-&gt;processor_id()].push_back(obj-&gt;id());
<a name="l00675"></a>00675     }
<a name="l00676"></a>00676 
<a name="l00677"></a>00677   <span class="comment">// Next set ghost object ids from other processors</span>
<a name="l00678"></a>00678   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l00679"></a>00679     {
<a name="l00680"></a>00680       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p != <a class="code" href="classMeshBase.php#a2399e70af69cf24f3add6c5a860edaa7">libMesh::n_processors</a>(); ++p)
<a name="l00681"></a>00681         {
<a name="l00682"></a>00682           <span class="comment">// Trade my requests with processor procup and procdown</span>
<a name="l00683"></a>00683           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procup = (<a class="code" href="classMeshBase.php#aba369b64ee6185d86a6b60089ba5af60">libMesh::processor_id</a>() + p) %
<a name="l00684"></a>00684                                  <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00685"></a>00685           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procdown = (<a class="code" href="classMeshBase.php#a2399e70af69cf24f3add6c5a860edaa7">libMesh::n_processors</a>() +
<a name="l00686"></a>00686                                    <a class="code" href="classMeshBase.php#aba369b64ee6185d86a6b60089ba5af60">libMesh::processor_id</a>() - p) %
<a name="l00687"></a>00687                                    <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00688"></a>00688           std::vector&lt;unsigned int&gt; request_to_fill;
<a name="l00689"></a>00689           Parallel::send_receive(procup, requested_ids[procup],
<a name="l00690"></a>00690                                  procdown, request_to_fill);
<a name="l00691"></a>00691 
<a name="l00692"></a>00692           <span class="comment">// Fill those requests</span>
<a name="l00693"></a>00693           std::vector&lt;unsigned int&gt; new_ids(request_to_fill.size());
<a name="l00694"></a>00694           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != request_to_fill.size(); ++i)
<a name="l00695"></a>00695             {
<a name="l00696"></a>00696               T *obj = objects[request_to_fill[i]];
<a name="l00697"></a>00697               libmesh_assert(obj);
<a name="l00698"></a>00698               libmesh_assert(obj-&gt;processor_id() == <a class="code" href="classMeshBase.php#aba369b64ee6185d86a6b60089ba5af60">libMesh::processor_id</a>());
<a name="l00699"></a>00699               new_ids[i] = obj-&gt;id();
<a name="l00700"></a>00700               libmesh_assert(new_ids[i] &gt;=
<a name="l00701"></a>00701                      first_object_on_proc[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()]);
<a name="l00702"></a>00702               libmesh_assert(new_ids[i] &lt;
<a name="l00703"></a>00703                      first_object_on_proc[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()] +
<a name="l00704"></a>00704                      objects_on_proc[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()]);
<a name="l00705"></a>00705             }
<a name="l00706"></a>00706 
<a name="l00707"></a>00707           <span class="comment">// Trade back the results</span>
<a name="l00708"></a>00708           std::vector&lt;unsigned int&gt; filled_request;
<a name="l00709"></a>00709           Parallel::send_receive(procdown, new_ids,
<a name="l00710"></a>00710                                  procup, filled_request);
<a name="l00711"></a>00711 
<a name="l00712"></a>00712           <span class="comment">// And copy the id changes we&#39;ve now been informed of</span>
<a name="l00713"></a>00713           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != filled_request.size(); ++i)
<a name="l00714"></a>00714             {
<a name="l00715"></a>00715               T *obj = objects[requested_ids[procup][i]];
<a name="l00716"></a>00716               libmesh_assert (obj);
<a name="l00717"></a>00717               libmesh_assert (obj-&gt;processor_id() == procup);
<a name="l00718"></a>00718               libmesh_assert(filled_request[i] &gt;=
<a name="l00719"></a>00719                      first_object_on_proc[procup]);
<a name="l00720"></a>00720               libmesh_assert(filled_request[i] &lt;
<a name="l00721"></a>00721                      first_object_on_proc[procup] +
<a name="l00722"></a>00722                      objects_on_proc[procup]);
<a name="l00723"></a>00723               obj-&gt;set_id(filled_request[i]);
<a name="l00724"></a>00724             }
<a name="l00725"></a>00725         }
<a name="l00726"></a>00726     }
<a name="l00727"></a>00727 
<a name="l00728"></a>00728   <span class="comment">// Next set unpartitioned object ids</span>
<a name="l00729"></a>00729   next_id = 0;
<a name="l00730"></a>00730   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classMeshBase.php#a2399e70af69cf24f3add6c5a860edaa7">libMesh::n_processors</a>(); ++i)
<a name="l00731"></a>00731     next_id += objects_on_proc[i];
<a name="l00732"></a>00732   <span class="keywordflow">for</span> (it = objects.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(); it != end; ++it)
<a name="l00733"></a>00733     {
<a name="l00734"></a>00734       T *obj = *it;
<a name="l00735"></a>00735       <span class="keywordflow">if</span> (obj-&gt;processor_id() == <a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>)
<a name="l00736"></a>00736         obj-&gt;set_id(next_id++);
<a name="l00737"></a>00737     }
<a name="l00738"></a>00738 
<a name="l00739"></a>00739   <span class="comment">// Finally shuffle around objects so that container indices</span>
<a name="l00740"></a>00740   <span class="comment">// match ids</span>
<a name="l00741"></a>00741   end = objects.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>();
<a name="l00742"></a>00742   <span class="keywordflow">for</span> (it = objects.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(); it != end;)
<a name="l00743"></a>00743     {
<a name="l00744"></a>00744       T *obj = *it;
<a name="l00745"></a>00745       <span class="keywordflow">if</span> (obj) <span class="comment">// don&#39;t try shuffling already-NULL entries</span>
<a name="l00746"></a>00746         {
<a name="l00747"></a>00747           T *next = objects[obj-&gt;id()];
<a name="l00748"></a>00748           <span class="comment">// If we have to move this object</span>
<a name="l00749"></a>00749           <span class="keywordflow">if</span> (next != obj)
<a name="l00750"></a>00750             {
<a name="l00751"></a>00751               <span class="comment">// NULL out its original position for now</span>
<a name="l00752"></a>00752               <span class="comment">// (our shuffling may put another object there shortly)</span>
<a name="l00753"></a>00753               *it = NULL;
<a name="l00754"></a>00754 
<a name="l00755"></a>00755               <span class="comment">// There may already be another object with this id that</span>
<a name="l00756"></a>00756               <span class="comment">// needs to be moved itself</span>
<a name="l00757"></a>00757               <span class="keywordflow">while</span> (next)
<a name="l00758"></a>00758                 {
<a name="l00759"></a>00759                   <span class="comment">// We shouldn&#39;t be trying to give two objects the</span>
<a name="l00760"></a>00760                   <span class="comment">// same id</span>
<a name="l00761"></a>00761                   libmesh_assert (next-&gt;id() != obj-&gt;id());
<a name="l00762"></a>00762                   objects[obj-&gt;id()] = obj;
<a name="l00763"></a>00763                   obj = next;
<a name="l00764"></a>00764                   next = objects[obj-&gt;id()];
<a name="l00765"></a>00765                 }
<a name="l00766"></a>00766               objects[obj-&gt;id()] = obj;
<a name="l00767"></a>00767             }
<a name="l00768"></a>00768         }
<a name="l00769"></a>00769       <span class="comment">// Remove any container entries that were left as NULL,</span>
<a name="l00770"></a>00770       <span class="comment">// being careful not to invalidate our iterator</span>
<a name="l00771"></a>00771       <span class="keywordflow">if</span> (!*it)
<a name="l00772"></a>00772         objects.<a class="code" href="classmapvector.php#aee38e1c8f77d4eeff04b74d19500429f">erase</a>(it++);
<a name="l00773"></a>00773       <span class="keywordflow">else</span>
<a name="l00774"></a>00774         ++it;
<a name="l00775"></a>00775     }
<a name="l00776"></a>00776 
<a name="l00777"></a>00777   <span class="keywordflow">return</span> first_free_id;
<a name="l00778"></a>00778 }
<a name="l00779"></a>00779 
<a name="l00780"></a>00780 
<a name="l00781"></a><a class="code" href="classParallelMesh.php#afdb75157107defbfd06ceb5fe11fde7e">00781</a> <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#afdb75157107defbfd06ceb5fe11fde7e">ParallelMesh::renumber_nodes_and_elements</a> ()
<a name="l00782"></a>00782 {
<a name="l00783"></a>00783   START_LOG(<span class="stringliteral">&quot;renumber_nodes_and_elements()&quot;</span>, <span class="stringliteral">&quot;ParallelMesh&quot;</span>);
<a name="l00784"></a>00784 
<a name="l00785"></a>00785 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00786"></a>00786 <span class="preprocessor"></span><span class="comment">// Make sure our ids and flags are consistent</span>
<a name="l00787"></a>00787   this-&gt;<a class="code" href="classParallelMesh.php#aa17a6d0f8e2d57519d42f7be307d6ee3">libmesh_assert_valid_parallel_ids</a>();
<a name="l00788"></a>00788   this-&gt;<a class="code" href="classParallelMesh.php#ab6e23e11a72b34b34626bc1bb885c44e">libmesh_assert_valid_parallel_flags</a>();
<a name="l00789"></a>00789 <span class="preprocessor">#endif</span>
<a name="l00790"></a>00790 <span class="preprocessor"></span>
<a name="l00791"></a>00791   std::set&lt;unsigned int&gt; used_nodes;
<a name="l00792"></a>00792 
<a name="l00793"></a>00793   <span class="comment">// flag the nodes we need</span>
<a name="l00794"></a>00794   {      
<a name="l00795"></a>00795     <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>  it = <a class="code" href="classParallelMesh.php#a5f982d8b28eb452959996453fde4439f">elements_begin</a>();
<a name="l00796"></a>00796     <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> end = <a class="code" href="classParallelMesh.php#a227c5c6ed9dd600b00d4c76f450eeae3">elements_end</a>();
<a name="l00797"></a>00797 
<a name="l00798"></a>00798     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00799"></a>00799       {
<a name="l00800"></a>00800         <a class="code" href="classElem.php">Elem</a> *<a class="code" href="classParallelMesh.php#ae5df0d138114adafeae3bc6b3270cff8">elem</a> = *it;
<a name="l00801"></a>00801 
<a name="l00802"></a>00802         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n != elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); ++n)
<a name="l00803"></a>00803           used_nodes.insert(elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n));
<a name="l00804"></a>00804       }
<a name="l00805"></a>00805   }
<a name="l00806"></a>00806 
<a name="l00807"></a>00807   <span class="comment">// Nodes not connected to any local elements are deleted</span>
<a name="l00808"></a>00808   {
<a name="l00809"></a>00809     <a class="code" href="classParallelMesh.php#ace78878c29e013e5ce3b0fe544d7196f">node_iterator_imp</a>  it = <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>();
<a name="l00810"></a>00810     <a class="code" href="classParallelMesh.php#ace78878c29e013e5ce3b0fe544d7196f">node_iterator_imp</a> end = <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>();
<a name="l00811"></a>00811 
<a name="l00812"></a>00812     <span class="keywordflow">for</span> (; it != end;)
<a name="l00813"></a>00813       {
<a name="l00814"></a>00814         <a class="code" href="classNode.php">Node</a> *<a class="code" href="classParallelMesh.php#a0d1e373cd978cf40b1a072eacf119a7e">node</a> = *it;
<a name="l00815"></a>00815         <span class="keywordflow">if</span> (!used_nodes.count(node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()))
<a name="l00816"></a>00816           {
<a name="l00817"></a>00817             <span class="comment">// remove any boundary information associated with</span>
<a name="l00818"></a>00818             <span class="comment">// this node</span>
<a name="l00819"></a>00819             this-&gt;<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;remove (node);
<a name="l00820"></a>00820 
<a name="l00821"></a>00821             <span class="comment">// delete the node</span>
<a name="l00822"></a>00822             <span class="keyword">delete</span> <a class="code" href="classParallelMesh.php#a0d1e373cd978cf40b1a072eacf119a7e">node</a>;
<a name="l00823"></a>00823 
<a name="l00824"></a>00824             <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#aee38e1c8f77d4eeff04b74d19500429f">erase</a>(it++);
<a name="l00825"></a>00825           }
<a name="l00826"></a>00826         <span class="keywordflow">else</span>
<a name="l00827"></a>00827           ++it;
<a name="l00828"></a>00828       }
<a name="l00829"></a>00829   }
<a name="l00830"></a>00830 
<a name="l00831"></a>00831   <span class="comment">// Finally renumber all the elements</span>
<a name="l00832"></a>00832   <a class="code" href="classParallelMesh.php#a0bdfa08b935887abbc25dd72c8047fca">_n_elem</a> = this-&gt;<a class="code" href="classParallelMesh.php#aeff924bd33e8926235470d13c34a6e2e">renumber_dof_objects</a> (this-&gt;<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>);
<a name="l00833"></a>00833   <a class="code" href="classParallelMesh.php#a149c9eae01b607b2f9959683ccbdcf01">_max_elem_id</a> = <a class="code" href="classParallelMesh.php#a0bdfa08b935887abbc25dd72c8047fca">_n_elem</a>;
<a name="l00834"></a>00834   <a class="code" href="classParallelMesh.php#abcf351f2a4a6562b58cba564bd00c73d">_next_free_local_elem_id</a> = <a class="code" href="classParallelMesh.php#a0bdfa08b935887abbc25dd72c8047fca">_n_elem</a>;
<a name="l00835"></a>00835 
<a name="l00836"></a>00836   <span class="comment">// and all the remaining nodes</span>
<a name="l00837"></a>00837   <a class="code" href="classParallelMesh.php#a40377d3c8e3bc9b45e5c08f55a33ef1a">_n_nodes</a> = this-&gt;<a class="code" href="classParallelMesh.php#aeff924bd33e8926235470d13c34a6e2e">renumber_dof_objects</a> (this-&gt;<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>);
<a name="l00838"></a>00838   <a class="code" href="classParallelMesh.php#a55e7b1c0d855184e7db312cc2ddc0a8c">_max_node_id</a> = <a class="code" href="classParallelMesh.php#a40377d3c8e3bc9b45e5c08f55a33ef1a">_n_nodes</a>;
<a name="l00839"></a>00839   <a class="code" href="classParallelMesh.php#acca1c020ab2000bb301b2d16e7a5b2bd">_next_free_local_node_id</a> = <a class="code" href="classParallelMesh.php#a40377d3c8e3bc9b45e5c08f55a33ef1a">_n_nodes</a>;
<a name="l00840"></a>00840 
<a name="l00841"></a>00841   <span class="comment">// And figure out what IDs we should use when adding new nodes and</span>
<a name="l00842"></a>00842   <span class="comment">// new elements</span>
<a name="l00843"></a>00843   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cycle = <a class="code" href="classMeshBase.php#a2399e70af69cf24f3add6c5a860edaa7">libMesh::n_processors</a>()+1;
<a name="l00844"></a>00844   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> offset = <a class="code" href="classParallelMesh.php#abcf351f2a4a6562b58cba564bd00c73d">_next_free_local_elem_id</a> % cycle;
<a name="l00845"></a>00845   <span class="keywordflow">if</span> (offset)
<a name="l00846"></a>00846     <a class="code" href="classParallelMesh.php#abcf351f2a4a6562b58cba564bd00c73d">_next_free_local_elem_id</a> += cycle - offset;
<a name="l00847"></a>00847   <a class="code" href="classParallelMesh.php#a0e7b564b3093c49e6b56c2ce874ae112">_next_free_unpartitioned_elem_id</a> = <a class="code" href="classParallelMesh.php#abcf351f2a4a6562b58cba564bd00c73d">_next_free_local_elem_id</a> +
<a name="l00848"></a>00848                                      <a class="code" href="classMeshBase.php#a2399e70af69cf24f3add6c5a860edaa7">libMesh::n_processors</a>();
<a name="l00849"></a>00849   <a class="code" href="classParallelMesh.php#abcf351f2a4a6562b58cba564bd00c73d">_next_free_local_elem_id</a> += <a class="code" href="classMeshBase.php#aba369b64ee6185d86a6b60089ba5af60">libMesh::processor_id</a>();
<a name="l00850"></a>00850 
<a name="l00851"></a>00851   offset = <a class="code" href="classParallelMesh.php#acca1c020ab2000bb301b2d16e7a5b2bd">_next_free_local_node_id</a> % cycle;
<a name="l00852"></a>00852   <span class="keywordflow">if</span> (offset)
<a name="l00853"></a>00853     <a class="code" href="classParallelMesh.php#acca1c020ab2000bb301b2d16e7a5b2bd">_next_free_local_node_id</a> += cycle - offset;
<a name="l00854"></a>00854   <a class="code" href="classParallelMesh.php#ad7beb6c794979321b7bb1a1010b842d4">_next_free_unpartitioned_node_id</a> = <a class="code" href="classParallelMesh.php#acca1c020ab2000bb301b2d16e7a5b2bd">_next_free_local_node_id</a> +
<a name="l00855"></a>00855                                      <a class="code" href="classMeshBase.php#a2399e70af69cf24f3add6c5a860edaa7">libMesh::n_processors</a>();
<a name="l00856"></a>00856   <a class="code" href="classParallelMesh.php#acca1c020ab2000bb301b2d16e7a5b2bd">_next_free_local_node_id</a> += <a class="code" href="classMeshBase.php#aba369b64ee6185d86a6b60089ba5af60">libMesh::processor_id</a>();
<a name="l00857"></a>00857 
<a name="l00858"></a>00858 <span class="comment">// Make sure our caches are up to date and our</span>
<a name="l00859"></a>00859 <span class="comment">// DofObjects are well packed</span>
<a name="l00860"></a>00860 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00861"></a>00861 <span class="preprocessor"></span>  libmesh_assert(this-&gt;<a class="code" href="classParallelMesh.php#a0b5505cdbb6799aed76cafb62a7e0135">n_nodes</a>() == this-&gt;<a class="code" href="classParallelMesh.php#a3222f264bd57a7c39d1e101314689c03">parallel_n_nodes</a>());
<a name="l00862"></a>00862   libmesh_assert(this-&gt;<a class="code" href="classParallelMesh.php#aaefea67041752d4e801f25d2a41c3552">n_elem</a>() == this-&gt;<a class="code" href="classParallelMesh.php#a0b05286761dd00f468e271e75a0ddd23">parallel_n_elem</a>());
<a name="l00863"></a>00863   libmesh_assert(this-&gt;<a class="code" href="classParallelMesh.php#ac30d8f34e21ae07a6d9be2a5850c058c">max_node_id</a>() == this-&gt;<a class="code" href="classParallelMesh.php#a0ba543c1ad92224e85f123ee942f1612">parallel_max_node_id</a>());
<a name="l00864"></a>00864   libmesh_assert(this-&gt;<a class="code" href="classParallelMesh.php#a01b6a417b62c640cff4a50ffe13645a5">max_elem_id</a>() == this-&gt;<a class="code" href="classParallelMesh.php#a0e38945a413c69a17ae308b48890bbf5">parallel_max_elem_id</a>());
<a name="l00865"></a>00865   libmesh_assert(this-&gt;<a class="code" href="classParallelMesh.php#a0b5505cdbb6799aed76cafb62a7e0135">n_nodes</a>() == this-&gt;<a class="code" href="classParallelMesh.php#ac30d8f34e21ae07a6d9be2a5850c058c">max_node_id</a>());
<a name="l00866"></a>00866   libmesh_assert(this-&gt;<a class="code" href="classParallelMesh.php#aaefea67041752d4e801f25d2a41c3552">n_elem</a>() == this-&gt;<a class="code" href="classParallelMesh.php#a01b6a417b62c640cff4a50ffe13645a5">max_elem_id</a>());
<a name="l00867"></a>00867 
<a name="l00868"></a>00868 <span class="comment">// Make sure our ids and flags are consistent</span>
<a name="l00869"></a>00869   this-&gt;<a class="code" href="classParallelMesh.php#aa17a6d0f8e2d57519d42f7be307d6ee3">libmesh_assert_valid_parallel_ids</a>();
<a name="l00870"></a>00870   this-&gt;<a class="code" href="classParallelMesh.php#ab6e23e11a72b34b34626bc1bb885c44e">libmesh_assert_valid_parallel_flags</a>();
<a name="l00871"></a>00871 
<a name="l00872"></a>00872 <span class="comment">// And make sure we&#39;ve made our numbering monotonic</span>
<a name="l00873"></a>00873   <a class="code" href="namespaceMeshTools.php#a2fd26b4502cbdc994e60136839a6d101">MeshTools::libmesh_assert_valid_elem_ids</a>(*<span class="keyword">this</span>);
<a name="l00874"></a>00874 <span class="preprocessor">#endif</span>
<a name="l00875"></a>00875 <span class="preprocessor"></span>
<a name="l00876"></a>00876   STOP_LOG(<span class="stringliteral">&quot;renumber_nodes_and_elements()&quot;</span>, <span class="stringliteral">&quot;ParallelMesh&quot;</span>);
<a name="l00877"></a>00877 }
<a name="l00878"></a>00878 
<a name="l00879"></a>00879 
<a name="l00880"></a>00880 
<a name="l00881"></a><a class="code" href="classParallelMesh.php#ab49533012e213781c55217337de6bfd4">00881</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallelMesh.php#ab49533012e213781c55217337de6bfd4">ParallelMesh::n_active_elem</a> ()<span class="keyword"> const</span>
<a name="l00882"></a>00882 <span class="keyword"></span>{
<a name="l00883"></a>00883   parallel_only();
<a name="l00884"></a>00884 
<a name="l00885"></a>00885   <span class="comment">// Get local active elements first</span>
<a name="l00886"></a>00886   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> active_elements =
<a name="l00887"></a>00887     <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(std::distance (this-&gt;<a class="code" href="classParallelMesh.php#a6256f0b7f343da9232eb280a94f95999">active_local_elements_begin</a>(),
<a name="l00888"></a>00888                                              this-&gt;<a class="code" href="classParallelMesh.php#a7505f8ccf94a640390308892417a5f49">active_local_elements_end</a>()));
<a name="l00889"></a>00889   Parallel::sum(active_elements);
<a name="l00890"></a>00890 
<a name="l00891"></a>00891   <span class="comment">// Then add unpartitioned active elements, which should exist on</span>
<a name="l00892"></a>00892   <span class="comment">// every processor</span>
<a name="l00893"></a>00893   active_elements +=
<a name="l00894"></a>00894     <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(std::distance
<a name="l00895"></a>00895       (this-&gt;<a class="code" href="classParallelMesh.php#afaa6356f7fc192f9146c38194f4747ba">active_pid_elements_begin</a>(<a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>),
<a name="l00896"></a>00896        this-&gt;<a class="code" href="classParallelMesh.php#ac83631fe55f1b418f31db3c4cab3e6c3">active_pid_elements_end</a>(<a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>)));
<a name="l00897"></a>00897   <span class="keywordflow">return</span> active_elements;
<a name="l00898"></a>00898 }
<a name="l00899"></a>00899 
<a name="l00900"></a>00900 
<a name="l00901"></a>00901 
<a name="l00902"></a><a class="code" href="classParallelMesh.php#ab7cc8fa40837fa8c29a3bc1e9ad938c0">00902</a> <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#ab7cc8fa40837fa8c29a3bc1e9ad938c0">ParallelMesh::delete_remote_elements</a>()
<a name="l00903"></a>00903 {
<a name="l00904"></a>00904 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00905"></a>00905 <span class="preprocessor"></span><span class="comment">// Make sure our neighbor links are all fine</span>
<a name="l00906"></a>00906   <a class="code" href="namespaceMeshTools.php#a55d1315fac6f245f3873626808d8a377">MeshTools::libmesh_assert_valid_neighbors</a>(*<span class="keyword">this</span>);
<a name="l00907"></a>00907 <span class="preprocessor">#endif</span>
<a name="l00908"></a>00908 <span class="preprocessor"></span>
<a name="l00909"></a>00909   <a class="code" href="classParallelMesh.php#a9c13b059a6cf3c9d4ad8da7fbb644f08">_is_serial</a> = <span class="keyword">false</span>;
<a name="l00910"></a>00910   <a class="code" href="classMeshCommunication.php">MeshCommunication</a>().<a class="code" href="classMeshCommunication.php#aeb16d7915a3e73e7d12f3e928aa22431">delete_remote_elements</a>(*<span class="keyword">this</span>);
<a name="l00911"></a>00911 
<a name="l00912"></a>00912 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00913"></a>00913 <span class="preprocessor"></span><span class="comment">// Make sure our caches are up to date and our</span>
<a name="l00914"></a>00914 <span class="comment">// DofObjects are well packed</span>
<a name="l00915"></a>00915   libmesh_assert(this-&gt;<a class="code" href="classParallelMesh.php#a0b5505cdbb6799aed76cafb62a7e0135">n_nodes</a>() == this-&gt;<a class="code" href="classParallelMesh.php#a3222f264bd57a7c39d1e101314689c03">parallel_n_nodes</a>());
<a name="l00916"></a>00916   libmesh_assert(this-&gt;<a class="code" href="classParallelMesh.php#aaefea67041752d4e801f25d2a41c3552">n_elem</a>() == this-&gt;<a class="code" href="classParallelMesh.php#a0b05286761dd00f468e271e75a0ddd23">parallel_n_elem</a>());
<a name="l00917"></a>00917   libmesh_assert(this-&gt;<a class="code" href="classParallelMesh.php#ac30d8f34e21ae07a6d9be2a5850c058c">max_node_id</a>() == this-&gt;<a class="code" href="classParallelMesh.php#a0ba543c1ad92224e85f123ee942f1612">parallel_max_node_id</a>());
<a name="l00918"></a>00918   libmesh_assert(this-&gt;<a class="code" href="classParallelMesh.php#a01b6a417b62c640cff4a50ffe13645a5">max_elem_id</a>() == this-&gt;<a class="code" href="classParallelMesh.php#a0e38945a413c69a17ae308b48890bbf5">parallel_max_elem_id</a>());
<a name="l00919"></a>00919   libmesh_assert(this-&gt;<a class="code" href="classParallelMesh.php#a0b5505cdbb6799aed76cafb62a7e0135">n_nodes</a>() == this-&gt;<a class="code" href="classParallelMesh.php#ac30d8f34e21ae07a6d9be2a5850c058c">max_node_id</a>());
<a name="l00920"></a>00920   libmesh_assert(this-&gt;<a class="code" href="classParallelMesh.php#aaefea67041752d4e801f25d2a41c3552">n_elem</a>() == this-&gt;<a class="code" href="classParallelMesh.php#a01b6a417b62c640cff4a50ffe13645a5">max_elem_id</a>());
<a name="l00921"></a>00921 
<a name="l00922"></a>00922 <span class="comment">// Make sure our neighbor links are all fine</span>
<a name="l00923"></a>00923   <a class="code" href="namespaceMeshTools.php#a55d1315fac6f245f3873626808d8a377">MeshTools::libmesh_assert_valid_neighbors</a>(*<span class="keyword">this</span>);
<a name="l00924"></a>00924 
<a name="l00925"></a>00925 <span class="comment">// Make sure our ids and flags are consistent</span>
<a name="l00926"></a>00926   this-&gt;<a class="code" href="classParallelMesh.php#aa17a6d0f8e2d57519d42f7be307d6ee3">libmesh_assert_valid_parallel_ids</a>();
<a name="l00927"></a>00927   this-&gt;<a class="code" href="classParallelMesh.php#ab6e23e11a72b34b34626bc1bb885c44e">libmesh_assert_valid_parallel_flags</a>();
<a name="l00928"></a>00928 
<a name="l00929"></a>00929 <span class="comment">// And make sure our numbering is still monotonic</span>
<a name="l00930"></a>00930   <a class="code" href="namespaceMeshTools.php#a2fd26b4502cbdc994e60136839a6d101">MeshTools::libmesh_assert_valid_elem_ids</a>(*<span class="keyword">this</span>);
<a name="l00931"></a>00931 <span class="preprocessor">#endif</span>
<a name="l00932"></a>00932 <span class="preprocessor"></span>}
<a name="l00933"></a>00933 
<a name="l00934"></a>00934 
<a name="l00935"></a>00935 
<a name="l00936"></a><a class="code" href="classParallelMesh.php#afabbcd5f3423e2985f288723951d595f">00936</a> <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#afabbcd5f3423e2985f288723951d595f">ParallelMesh::allgather</a>()
<a name="l00937"></a>00937 {
<a name="l00938"></a>00938   <span class="keywordflow">if</span> (<a class="code" href="classParallelMesh.php#a9c13b059a6cf3c9d4ad8da7fbb644f08">_is_serial</a>)
<a name="l00939"></a>00939     <span class="keywordflow">return</span>;
<a name="l00940"></a>00940   <a class="code" href="classParallelMesh.php#a9c13b059a6cf3c9d4ad8da7fbb644f08">_is_serial</a> = <span class="keyword">true</span>;
<a name="l00941"></a>00941   <a class="code" href="classMeshCommunication.php">MeshCommunication</a>().<a class="code" href="classMeshCommunication.php#a21c1490e797f0bce2a29880c078eb8f5">allgather</a>(*<span class="keyword">this</span>);
<a name="l00942"></a>00942 
<a name="l00943"></a>00943 <span class="comment">// Make sure our caches are up to date and our</span>
<a name="l00944"></a>00944 <span class="comment">// DofObjects are well packed</span>
<a name="l00945"></a>00945 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00946"></a>00946 <span class="preprocessor"></span>  libmesh_assert(this-&gt;<a class="code" href="classParallelMesh.php#a0b5505cdbb6799aed76cafb62a7e0135">n_nodes</a>() == this-&gt;<a class="code" href="classParallelMesh.php#a3222f264bd57a7c39d1e101314689c03">parallel_n_nodes</a>());
<a name="l00947"></a>00947   libmesh_assert(this-&gt;<a class="code" href="classParallelMesh.php#aaefea67041752d4e801f25d2a41c3552">n_elem</a>() == this-&gt;<a class="code" href="classParallelMesh.php#a0b05286761dd00f468e271e75a0ddd23">parallel_n_elem</a>());
<a name="l00948"></a>00948   libmesh_assert(this-&gt;<a class="code" href="classParallelMesh.php#ac30d8f34e21ae07a6d9be2a5850c058c">max_node_id</a>() == this-&gt;<a class="code" href="classParallelMesh.php#a0ba543c1ad92224e85f123ee942f1612">parallel_max_node_id</a>());
<a name="l00949"></a>00949   libmesh_assert(this-&gt;<a class="code" href="classParallelMesh.php#a01b6a417b62c640cff4a50ffe13645a5">max_elem_id</a>() == this-&gt;<a class="code" href="classParallelMesh.php#a0e38945a413c69a17ae308b48890bbf5">parallel_max_elem_id</a>());
<a name="l00950"></a>00950   libmesh_assert(this-&gt;<a class="code" href="classParallelMesh.php#a0b5505cdbb6799aed76cafb62a7e0135">n_nodes</a>() == this-&gt;<a class="code" href="classParallelMesh.php#ac30d8f34e21ae07a6d9be2a5850c058c">max_node_id</a>());
<a name="l00951"></a>00951   libmesh_assert(this-&gt;<a class="code" href="classParallelMesh.php#aaefea67041752d4e801f25d2a41c3552">n_elem</a>() == this-&gt;<a class="code" href="classParallelMesh.php#a01b6a417b62c640cff4a50ffe13645a5">max_elem_id</a>());
<a name="l00952"></a>00952 
<a name="l00953"></a>00953 <span class="comment">// Make sure our neighbor links are all fine</span>
<a name="l00954"></a>00954   <a class="code" href="namespaceMeshTools.php#a55d1315fac6f245f3873626808d8a377">MeshTools::libmesh_assert_valid_neighbors</a>(*<span class="keyword">this</span>);
<a name="l00955"></a>00955 
<a name="l00956"></a>00956 <span class="comment">// Make sure our ids and flags are consistent</span>
<a name="l00957"></a>00957   this-&gt;<a class="code" href="classParallelMesh.php#aa17a6d0f8e2d57519d42f7be307d6ee3">libmesh_assert_valid_parallel_ids</a>();
<a name="l00958"></a>00958   this-&gt;<a class="code" href="classParallelMesh.php#ab6e23e11a72b34b34626bc1bb885c44e">libmesh_assert_valid_parallel_flags</a>();
<a name="l00959"></a>00959 <span class="preprocessor">#endif</span>
<a name="l00960"></a>00960 <span class="preprocessor"></span>}
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
