<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>parallel_mesh.h</h1>  </div>
</div>
<div class="contents">
<a href="parallel__mesh_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: parallel_mesh.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __parallel_mesh_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __parallel_mesh_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;mapvector.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;node.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="unstructured__mesh_8h.php">unstructured_mesh.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Prototype this function so we can delcare it a friend.</span>
<a name="l00036"></a>00036 <span class="keyword">class </span><a class="code" href="classParallelMesh.php">ParallelMesh</a>;
<a name="l00037"></a>00037 <span class="keyword">namespace </span>MeshTools {
<a name="l00038"></a>00038   <span class="keyword">namespace </span>Private {
<a name="l00039"></a>00039     <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools_1_1Private.php#af435c29becf70b3ce4a05360be28dbc5">fix_broken_node_and_element_numbering</a> (<a class="code" href="classParallelMesh.php">ParallelMesh</a> &amp;);
<a name="l00040"></a>00040   }
<a name="l00041"></a>00041 }
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00052"></a>00052 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00053"></a>00053 <span class="comment">// UnstructuredMesh class definition</span>
<a name="l00054"></a><a class="code" href="classParallelMesh.php">00054</a> <span class="keyword">class </span><a class="code" href="classParallelMesh.php">ParallelMesh</a> : <span class="keyword">public</span> <a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>
<a name="l00055"></a>00055 {
<a name="l00056"></a>00056  <span class="keyword">public</span>:
<a name="l00057"></a>00057 
<a name="l00063"></a>00063   <a class="code" href="classParallelMesh.php#a875c73804bc4be3eaa45fdb70177398a">ParallelMesh</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d);
<a name="l00064"></a>00064 
<a name="l00069"></a>00069   <a class="code" href="classParallelMesh.php#a875c73804bc4be3eaa45fdb70177398a">ParallelMesh</a> (<span class="keyword">const</span> <a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; other_mesh);
<a name="l00070"></a>00070 
<a name="l00075"></a>00075   <a class="code" href="classParallelMesh.php#a875c73804bc4be3eaa45fdb70177398a">ParallelMesh</a> (<span class="keyword">const</span> <a class="code" href="classParallelMesh.php">ParallelMesh</a>&amp; other_mesh);
<a name="l00076"></a>00076 
<a name="l00080"></a><a class="code" href="classParallelMesh.php#afd13e17d0f327976c1c27a2ef047054b">00080</a>   <span class="keyword">virtual</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;MeshBase&gt;</a> <a class="code" href="classParallelMesh.php#afd13e17d0f327976c1c27a2ef047054b">clone</a> ()<span class="keyword"> const</span>
<a name="l00081"></a>00081 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;MeshBase&gt;</a>(<span class="keyword">new</span> <a class="code" href="classParallelMesh.php#a875c73804bc4be3eaa45fdb70177398a">ParallelMesh</a>(*<span class="keyword">this</span>)); }
<a name="l00082"></a>00082 
<a name="l00086"></a>00086   <span class="keyword">virtual</span> <a class="code" href="classParallelMesh.php#a0a2fbb5b83b5470b50577bed0b437fd3">~ParallelMesh</a>();
<a name="l00087"></a>00087 
<a name="l00091"></a>00091   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#ad0429ae4ae81a253098ff659bae00de4">clear</a>();
<a name="l00092"></a>00092 
<a name="l00097"></a><a class="code" href="classParallelMesh.php#ac72c8fd7a3d1df94503f7028601c14df">00097</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classParallelMesh.php#ac72c8fd7a3d1df94503f7028601c14df">is_serial</a> ()<span class="keyword"> const</span>
<a name="l00098"></a>00098 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classParallelMesh.php#a9c13b059a6cf3c9d4ad8da7fbb644f08">_is_serial</a>; }
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00101"></a>00101 <span class="preprocessor"></span>
<a name="l00106"></a>00106   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00107"></a>00107   <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#a64a1e4b395d28827764998859aa9c083">libmesh_assert_valid_parallel_object_ids</a>(<span class="keyword">const</span> <a class="code" href="classmapvector.php">mapvector&lt;T*&gt;</a>&amp;) <span class="keyword">const</span>;
<a name="l00108"></a>00108 
<a name="l00114"></a>00114   <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#aa17a6d0f8e2d57519d42f7be307d6ee3">libmesh_assert_valid_parallel_ids</a>() <span class="keyword">const</span>;
<a name="l00115"></a>00115 
<a name="l00121"></a>00121   <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#ab6e23e11a72b34b34626bc1bb885c44e">libmesh_assert_valid_parallel_flags</a>() <span class="keyword">const</span>;
<a name="l00122"></a>00122 <span class="preprocessor">#endif</span>
<a name="l00123"></a>00123 <span class="preprocessor"></span>
<a name="l00129"></a>00129   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00130"></a>00130   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallelMesh.php#aeff924bd33e8926235470d13c34a6e2e">renumber_dof_objects</a> (<a class="code" href="classmapvector.php">mapvector&lt;T*&gt;</a>&amp;);
<a name="l00131"></a>00131 
<a name="l00135"></a>00135   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#afdb75157107defbfd06ceb5fe11fde7e">renumber_nodes_and_elements</a> ();
<a name="l00136"></a>00136 
<a name="l00141"></a>00141   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#afabbcd5f3423e2985f288723951d595f">allgather</a>();
<a name="l00142"></a>00142 
<a name="l00148"></a>00148   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#ab7cc8fa40837fa8c29a3bc1e9ad938c0">delete_remote_elements</a>();
<a name="l00149"></a>00149 
<a name="l00150"></a>00150   <span class="comment">// Cached methods that can be called in serial</span>
<a name="l00151"></a><a class="code" href="classParallelMesh.php#a0b5505cdbb6799aed76cafb62a7e0135">00151</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallelMesh.php#a0b5505cdbb6799aed76cafb62a7e0135">n_nodes</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classParallelMesh.php#a40377d3c8e3bc9b45e5c08f55a33ef1a">_n_nodes</a>; }
<a name="l00152"></a><a class="code" href="classParallelMesh.php#ac30d8f34e21ae07a6d9be2a5850c058c">00152</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallelMesh.php#ac30d8f34e21ae07a6d9be2a5850c058c">max_node_id</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classParallelMesh.php#a55e7b1c0d855184e7db312cc2ddc0a8c">_max_node_id</a>; }
<a name="l00153"></a><a class="code" href="classParallelMesh.php#a6dd52893b2c31897caa37a6b2821a143">00153</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#a6dd52893b2c31897caa37a6b2821a143">reserve_nodes</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>) { }
<a name="l00154"></a><a class="code" href="classParallelMesh.php#aaefea67041752d4e801f25d2a41c3552">00154</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallelMesh.php#aaefea67041752d4e801f25d2a41c3552">n_elem</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classParallelMesh.php#a0bdfa08b935887abbc25dd72c8047fca">_n_elem</a>; }
<a name="l00155"></a>00155   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallelMesh.php#ab49533012e213781c55217337de6bfd4">n_active_elem</a> () <span class="keyword">const</span>;
<a name="l00156"></a><a class="code" href="classParallelMesh.php#a01b6a417b62c640cff4a50ffe13645a5">00156</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallelMesh.php#a01b6a417b62c640cff4a50ffe13645a5">max_elem_id</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classParallelMesh.php#a149c9eae01b607b2f9959683ccbdcf01">_max_elem_id</a>; }
<a name="l00157"></a><a class="code" href="classParallelMesh.php#a0d9fd0a3a2677eae8f4e09be00a14679">00157</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#a0d9fd0a3a2677eae8f4e09be00a14679">reserve_elem</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>) { }
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   <span class="comment">// Parallel only method to update the caches</span>
<a name="l00160"></a>00160   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#ae23de933ff7c8656e1262024a1aa2e92">update_parallel_id_counts</a> ();
<a name="l00161"></a>00161 
<a name="l00162"></a>00162   <span class="comment">// And more parallel only methods to test non-cached values</span>
<a name="l00163"></a>00163   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallelMesh.php#a3222f264bd57a7c39d1e101314689c03">parallel_n_nodes</a> () <span class="keyword">const</span>;
<a name="l00164"></a>00164   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallelMesh.php#a0ba543c1ad92224e85f123ee942f1612">parallel_max_node_id</a> () <span class="keyword">const</span>;
<a name="l00165"></a>00165   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallelMesh.php#a0b05286761dd00f468e271e75a0ddd23">parallel_n_elem</a> () <span class="keyword">const</span>;
<a name="l00166"></a>00166   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallelMesh.php#a0e38945a413c69a17ae308b48890bbf5">parallel_max_elem_id</a> () <span class="keyword">const</span>;
<a name="l00167"></a>00167 
<a name="l00171"></a>00171   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; <a class="code" href="classParallelMesh.php#a1dc3e9b9efb18dde357eaae4df18feaf">point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> ;
<a name="l00172"></a>00172   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>&amp;  <a class="code" href="classParallelMesh.php#a0d1e373cd978cf40b1a072eacf119a7e">node</a>  (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> ;
<a name="l00173"></a>00173   <span class="keyword">virtual</span> <a class="code" href="classNode.php">Node</a>&amp; <a class="code" href="classParallelMesh.php#a0d1e373cd978cf40b1a072eacf119a7e">node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) ;
<a name="l00174"></a>00174   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classParallelMesh.php#a39d1343ddfc925e1012d021d9a11e42f">node_ptr</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> ;
<a name="l00175"></a>00175   <span class="keyword">virtual</span> <a class="code" href="classNode.php">Node</a>* &amp; <a class="code" href="classParallelMesh.php#a39d1343ddfc925e1012d021d9a11e42f">node_ptr</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) ;
<a name="l00176"></a>00176   <span class="keyword">virtual</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classParallelMesh.php#ae5df0d138114adafeae3bc6b3270cff8">elem</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> ;
<a name="l00177"></a>00177 
<a name="l00181"></a>00181   <span class="keyword">virtual</span> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classParallelMesh.php#a9a458dd93052e3707da352e1ca0ea0b6">add_point</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00182"></a>00182                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span> =
<a name="l00183"></a>00183                              <a class="code" href="classDofObject.php#a35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>,
<a name="l00184"></a>00184                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id =
<a name="l00185"></a>00185                              <a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>);
<a name="l00186"></a>00186   <span class="keyword">virtual</span> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classParallelMesh.php#afe5b25cec4f3944296a9030a7e0f45d1">add_node</a> (<a class="code" href="classNode.php">Node</a>* n) ;
<a name="l00187"></a>00187   <span class="keyword">virtual</span> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classParallelMesh.php#ae5a2ef7ac888ae42fe08bb9716664795">insert_node</a> (<a class="code" href="classNode.php">Node</a>* n);
<a name="l00188"></a>00188   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#adf7540eaf668eda49a4bd3d72c28d2c7">delete_node</a> (<a class="code" href="classNode.php">Node</a>* n) ;
<a name="l00189"></a>00189   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#a72988a5f21d74f5195c734155d0dcfa1">renumber_node</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_id, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_id);
<a name="l00190"></a>00190   <span class="keyword">virtual</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classParallelMesh.php#a070d9e8636ce1e4fc4fe6ab0265462b0">add_elem</a> (<a class="code" href="classElem.php">Elem</a>* e) ;
<a name="l00191"></a>00191   <span class="keyword">virtual</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classParallelMesh.php#aadf11922b8147ddc3680d9a7da5d4447">insert_elem</a> (<a class="code" href="classElem.php">Elem</a>* e) ;
<a name="l00192"></a>00192   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#a7f67f79d1533bcace8c133804ab977b2">delete_elem</a> (<a class="code" href="classElem.php">Elem</a>* e) ;
<a name="l00193"></a>00193   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classParallelMesh.php#a4af7c5ed955150e759d7d311c7179905">renumber_elem</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_id, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_id);
<a name="l00194"></a>00194 
<a name="l00195"></a>00195   <span class="keyword">friend</span> <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools_1_1Private.php#af435c29becf70b3ce4a05360be28dbc5">MeshTools::Private::fix_broken_node_and_element_numbering</a> (<a class="code" href="classParallelMesh.php">ParallelMesh</a> &amp;);
<a name="l00196"></a>00196   
<a name="l00197"></a>00197 <span class="keyword">public</span>:
<a name="l00201"></a>00201   element_iterator <a class="code" href="classParallelMesh.php#a5f982d8b28eb452959996453fde4439f">elements_begin</a> ();
<a name="l00202"></a>00202   element_iterator <a class="code" href="classParallelMesh.php#a227c5c6ed9dd600b00d4c76f450eeae3">elements_end</a>   ();
<a name="l00203"></a>00203 
<a name="l00204"></a>00204   element_iterator <a class="code" href="classParallelMesh.php#ad93ab290b531351ba6b27edb53963106">active_elements_begin</a> ();
<a name="l00205"></a>00205   element_iterator <a class="code" href="classParallelMesh.php#aae426097554ed05956198a6ef04b5189">active_elements_end</a>   ();
<a name="l00206"></a>00206 
<a name="l00207"></a>00207   element_iterator <a class="code" href="classParallelMesh.php#a7ece42cd353d9c87e4dbdec965de88b5">ancestor_elements_begin</a> ();
<a name="l00208"></a>00208   element_iterator <a class="code" href="classParallelMesh.php#a40b5e29244947c98e99f344c7a2c6b43">ancestor_elements_end</a>   ();
<a name="l00209"></a>00209 
<a name="l00210"></a>00210   element_iterator <a class="code" href="classParallelMesh.php#ae8fc74e9e779cef9f4b4429bab777ab7">subactive_elements_begin</a> ();
<a name="l00211"></a>00211   element_iterator <a class="code" href="classParallelMesh.php#a66a538d6334a006b2b17126b4cbc2527">subactive_elements_end</a>   ();
<a name="l00212"></a>00212 
<a name="l00213"></a>00213   element_iterator <a class="code" href="classParallelMesh.php#a8bb796e6be387a4f12282acd147b6c52">not_active_elements_begin</a> ();
<a name="l00214"></a>00214   element_iterator <a class="code" href="classParallelMesh.php#a6459eed633c2e15655a9a097bd513618">not_active_elements_end</a>   ();
<a name="l00215"></a>00215 
<a name="l00216"></a>00216   element_iterator <a class="code" href="classParallelMesh.php#ab749438ebc0c950500d84bbb7543d974">not_ancestor_elements_begin</a> ();
<a name="l00217"></a>00217   element_iterator <a class="code" href="classParallelMesh.php#a8bacb1a9e4768073add40da965c514f7">not_ancestor_elements_end</a>   ();
<a name="l00218"></a>00218 
<a name="l00219"></a>00219   element_iterator <a class="code" href="classParallelMesh.php#a37bff79e0dd8a3bc3fe545b38f38e064">not_subactive_elements_begin</a> ();
<a name="l00220"></a>00220   element_iterator <a class="code" href="classParallelMesh.php#a8c69925fbc4de782202c987ee367a741">not_subactive_elements_end</a>   ();
<a name="l00221"></a>00221 
<a name="l00222"></a>00222   element_iterator <a class="code" href="classParallelMesh.php#adffe63cef73e8fd317f08aa1722d8e71">local_elements_begin</a> ();
<a name="l00223"></a>00223   element_iterator <a class="code" href="classParallelMesh.php#a70c12ce1edd2d0c5af2367da3d0da5e3">local_elements_end</a>   ();
<a name="l00224"></a>00224 
<a name="l00225"></a>00225   element_iterator <a class="code" href="classParallelMesh.php#ad0e42cc14d2d5f0cd26d2bb2a6b1b888">not_local_elements_begin</a> ();
<a name="l00226"></a>00226   element_iterator <a class="code" href="classParallelMesh.php#aa84e174e2190219edc0e15c12db6bf8d">not_local_elements_end</a>   ();
<a name="l00227"></a>00227 
<a name="l00228"></a>00228   element_iterator <a class="code" href="classParallelMesh.php#a6256f0b7f343da9232eb280a94f95999">active_local_elements_begin</a> ();
<a name="l00229"></a>00229   element_iterator <a class="code" href="classParallelMesh.php#a7505f8ccf94a640390308892417a5f49">active_local_elements_end</a>   ();
<a name="l00230"></a>00230 
<a name="l00231"></a>00231   element_iterator <a class="code" href="classParallelMesh.php#a375c34b64ee77c69677a4c1089a99523">active_not_local_elements_begin</a> ();
<a name="l00232"></a>00232   element_iterator <a class="code" href="classParallelMesh.php#a36a649c8ff9100fec84023d4e05f71ac">active_not_local_elements_end</a>   ();
<a name="l00233"></a>00233 
<a name="l00234"></a>00234   element_iterator <a class="code" href="classParallelMesh.php#ad61c7ac197af37ec6eee1fafc72c625a">level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00235"></a>00235   element_iterator <a class="code" href="classParallelMesh.php#a41457c8b4b80171696f8fc4ff4f444b9">level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00236"></a>00236 
<a name="l00237"></a>00237   element_iterator <a class="code" href="classParallelMesh.php#aa4e1dd747d2c71afc9ce54c99fc18eb3">not_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00238"></a>00238   element_iterator <a class="code" href="classParallelMesh.php#ae955bb231a8928cea2dd6bc1353f5193">not_level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00239"></a>00239 
<a name="l00240"></a>00240   element_iterator <a class="code" href="classParallelMesh.php#abcc01be1661a0e82a4e4d5dfb1a79ef4">local_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00241"></a>00241   element_iterator <a class="code" href="classParallelMesh.php#a0b6fc28939ea321936ea2edabb65f1c1">local_level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00242"></a>00242 
<a name="l00243"></a>00243   element_iterator <a class="code" href="classParallelMesh.php#adbe1c8be02fbe183eb1f3ab26baa503b">local_not_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00244"></a>00244   element_iterator <a class="code" href="classParallelMesh.php#a92cca5e4b0e005ff6528d2e766d70125">local_not_level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00245"></a>00245 
<a name="l00246"></a>00246   element_iterator <a class="code" href="classParallelMesh.php#a400f4952a80055c7546a6cc9e87378bb">pid_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id);
<a name="l00247"></a>00247   element_iterator <a class="code" href="classParallelMesh.php#a29ce765858d4135034f6becd8ee5a44d">pid_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id);
<a name="l00248"></a>00248 
<a name="l00249"></a>00249   element_iterator <a class="code" href="classParallelMesh.php#a78ff7a6829916ff229bb8c5e80799e74">type_elements_begin</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00250"></a>00250   element_iterator <a class="code" href="classParallelMesh.php#adada4938d90271ed8e1b1d2ce16b5c9c">type_elements_end</a>   (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00251"></a>00251 
<a name="l00252"></a>00252   element_iterator <a class="code" href="classParallelMesh.php#a6bdf72630cb5bf3fd5ee9d25c49c344d">active_type_elements_begin</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00253"></a>00253   element_iterator <a class="code" href="classParallelMesh.php#ace8c755e61adf67a16d643bd72ecad17">active_type_elements_end</a>   (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00254"></a>00254 
<a name="l00255"></a>00255   element_iterator <a class="code" href="classParallelMesh.php#afaa6356f7fc192f9146c38194f4747ba">active_pid_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id);
<a name="l00256"></a>00256   element_iterator <a class="code" href="classParallelMesh.php#ac83631fe55f1b418f31db3c4cab3e6c3">active_pid_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id);
<a name="l00257"></a>00257 
<a name="l00258"></a>00258   element_iterator <a class="code" href="classParallelMesh.php#a36cda99fc5687ca38b5b0cf2e113fcff">unpartitioned_elements_begin</a> ();
<a name="l00259"></a>00259   element_iterator <a class="code" href="classParallelMesh.php#a147d2a4bda46d2dbeabd972f908525bb">unpartitioned_elements_end</a> ();
<a name="l00260"></a>00260 
<a name="l00261"></a>00261   element_iterator <a class="code" href="classParallelMesh.php#a3d11ea6fbb0b593b9a2a026b90b8120f">active_local_subdomain_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id);
<a name="l00262"></a>00262   element_iterator <a class="code" href="classParallelMesh.php#a9ca7e83cc9bfb677b8b4877630d91b86">active_local_subdomain_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id);
<a name="l00263"></a>00263 
<a name="l00264"></a>00264 
<a name="l00268"></a>00268   const_element_iterator <a class="code" href="classParallelMesh.php#a5f982d8b28eb452959996453fde4439f">elements_begin</a>() <span class="keyword">const</span>;
<a name="l00269"></a>00269   const_element_iterator <a class="code" href="classParallelMesh.php#a227c5c6ed9dd600b00d4c76f450eeae3">elements_end</a>()   <span class="keyword">const</span>;
<a name="l00270"></a>00270   
<a name="l00271"></a>00271   const_element_iterator <a class="code" href="classParallelMesh.php#ad93ab290b531351ba6b27edb53963106">active_elements_begin</a>() <span class="keyword">const</span>;
<a name="l00272"></a>00272   const_element_iterator <a class="code" href="classParallelMesh.php#aae426097554ed05956198a6ef04b5189">active_elements_end</a>()   <span class="keyword">const</span>;
<a name="l00273"></a>00273   
<a name="l00274"></a>00274   const_element_iterator <a class="code" href="classParallelMesh.php#a7ece42cd353d9c87e4dbdec965de88b5">ancestor_elements_begin</a>() <span class="keyword">const</span>;
<a name="l00275"></a>00275   const_element_iterator <a class="code" href="classParallelMesh.php#a40b5e29244947c98e99f344c7a2c6b43">ancestor_elements_end</a>()   <span class="keyword">const</span>;
<a name="l00276"></a>00276   
<a name="l00277"></a>00277   const_element_iterator <a class="code" href="classParallelMesh.php#ae8fc74e9e779cef9f4b4429bab777ab7">subactive_elements_begin</a>() <span class="keyword">const</span>;
<a name="l00278"></a>00278   const_element_iterator <a class="code" href="classParallelMesh.php#a66a538d6334a006b2b17126b4cbc2527">subactive_elements_end</a>()   <span class="keyword">const</span>;
<a name="l00279"></a>00279   
<a name="l00280"></a>00280   const_element_iterator <a class="code" href="classParallelMesh.php#a8bb796e6be387a4f12282acd147b6c52">not_active_elements_begin</a>() <span class="keyword">const</span>;
<a name="l00281"></a>00281   const_element_iterator <a class="code" href="classParallelMesh.php#a6459eed633c2e15655a9a097bd513618">not_active_elements_end</a>()   <span class="keyword">const</span>;
<a name="l00282"></a>00282 
<a name="l00283"></a>00283   const_element_iterator <a class="code" href="classParallelMesh.php#ab749438ebc0c950500d84bbb7543d974">not_ancestor_elements_begin</a>() <span class="keyword">const</span>;
<a name="l00284"></a>00284   const_element_iterator <a class="code" href="classParallelMesh.php#a8bacb1a9e4768073add40da965c514f7">not_ancestor_elements_end</a>()   <span class="keyword">const</span>;
<a name="l00285"></a>00285 
<a name="l00286"></a>00286   const_element_iterator <a class="code" href="classParallelMesh.php#a37bff79e0dd8a3bc3fe545b38f38e064">not_subactive_elements_begin</a>() <span class="keyword">const</span>;
<a name="l00287"></a>00287   const_element_iterator <a class="code" href="classParallelMesh.php#a8c69925fbc4de782202c987ee367a741">not_subactive_elements_end</a>()   <span class="keyword">const</span>;
<a name="l00288"></a>00288 
<a name="l00289"></a>00289   const_element_iterator <a class="code" href="classParallelMesh.php#adffe63cef73e8fd317f08aa1722d8e71">local_elements_begin</a> () <span class="keyword">const</span>;
<a name="l00290"></a>00290   const_element_iterator <a class="code" href="classParallelMesh.php#a70c12ce1edd2d0c5af2367da3d0da5e3">local_elements_end</a>   () <span class="keyword">const</span>;
<a name="l00291"></a>00291 
<a name="l00292"></a>00292   const_element_iterator <a class="code" href="classParallelMesh.php#ad0e42cc14d2d5f0cd26d2bb2a6b1b888">not_local_elements_begin</a> () <span class="keyword">const</span>;
<a name="l00293"></a>00293   const_element_iterator <a class="code" href="classParallelMesh.php#aa84e174e2190219edc0e15c12db6bf8d">not_local_elements_end</a>   () <span class="keyword">const</span>;
<a name="l00294"></a>00294 
<a name="l00295"></a>00295   const_element_iterator <a class="code" href="classParallelMesh.php#a6256f0b7f343da9232eb280a94f95999">active_local_elements_begin</a> () <span class="keyword">const</span>;
<a name="l00296"></a>00296   const_element_iterator <a class="code" href="classParallelMesh.php#a7505f8ccf94a640390308892417a5f49">active_local_elements_end</a>   () <span class="keyword">const</span>;
<a name="l00297"></a>00297 
<a name="l00298"></a>00298   const_element_iterator <a class="code" href="classParallelMesh.php#a375c34b64ee77c69677a4c1089a99523">active_not_local_elements_begin</a> () <span class="keyword">const</span>;
<a name="l00299"></a>00299   const_element_iterator <a class="code" href="classParallelMesh.php#a36a649c8ff9100fec84023d4e05f71ac">active_not_local_elements_end</a>   () <span class="keyword">const</span>;
<a name="l00300"></a>00300 
<a name="l00301"></a>00301   const_element_iterator <a class="code" href="classParallelMesh.php#ad61c7ac197af37ec6eee1fafc72c625a">level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00302"></a>00302   const_element_iterator <a class="code" href="classParallelMesh.php#a41457c8b4b80171696f8fc4ff4f444b9">level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00303"></a>00303 
<a name="l00304"></a>00304   const_element_iterator <a class="code" href="classParallelMesh.php#aa4e1dd747d2c71afc9ce54c99fc18eb3">not_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00305"></a>00305   const_element_iterator <a class="code" href="classParallelMesh.php#ae955bb231a8928cea2dd6bc1353f5193">not_level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00306"></a>00306 
<a name="l00307"></a>00307   const_element_iterator <a class="code" href="classParallelMesh.php#abcc01be1661a0e82a4e4d5dfb1a79ef4">local_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00308"></a>00308   const_element_iterator <a class="code" href="classParallelMesh.php#a0b6fc28939ea321936ea2edabb65f1c1">local_level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00309"></a>00309 
<a name="l00310"></a>00310   const_element_iterator <a class="code" href="classParallelMesh.php#adbe1c8be02fbe183eb1f3ab26baa503b">local_not_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00311"></a>00311   const_element_iterator <a class="code" href="classParallelMesh.php#a92cca5e4b0e005ff6528d2e766d70125">local_not_level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00312"></a>00312 
<a name="l00313"></a>00313   const_element_iterator <a class="code" href="classParallelMesh.php#a400f4952a80055c7546a6cc9e87378bb">pid_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span>;
<a name="l00314"></a>00314   const_element_iterator <a class="code" href="classParallelMesh.php#a29ce765858d4135034f6becd8ee5a44d">pid_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span>;
<a name="l00315"></a>00315 
<a name="l00316"></a>00316   const_element_iterator <a class="code" href="classParallelMesh.php#a78ff7a6829916ff229bb8c5e80799e74">type_elements_begin</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type) <span class="keyword">const</span>;
<a name="l00317"></a>00317   const_element_iterator <a class="code" href="classParallelMesh.php#adada4938d90271ed8e1b1d2ce16b5c9c">type_elements_end</a>   (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type) <span class="keyword">const</span>;
<a name="l00318"></a>00318 
<a name="l00319"></a>00319   const_element_iterator <a class="code" href="classParallelMesh.php#a6bdf72630cb5bf3fd5ee9d25c49c344d">active_type_elements_begin</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type) <span class="keyword">const</span>;
<a name="l00320"></a>00320   const_element_iterator <a class="code" href="classParallelMesh.php#ace8c755e61adf67a16d643bd72ecad17">active_type_elements_end</a>   (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type) <span class="keyword">const</span>;
<a name="l00321"></a>00321 
<a name="l00322"></a>00322   const_element_iterator <a class="code" href="classParallelMesh.php#afaa6356f7fc192f9146c38194f4747ba">active_pid_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span>;
<a name="l00323"></a>00323   const_element_iterator <a class="code" href="classParallelMesh.php#ac83631fe55f1b418f31db3c4cab3e6c3">active_pid_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span>;
<a name="l00324"></a>00324 
<a name="l00325"></a>00325   const_element_iterator <a class="code" href="classParallelMesh.php#a36cda99fc5687ca38b5b0cf2e113fcff">unpartitioned_elements_begin</a> () <span class="keyword">const</span>;
<a name="l00326"></a>00326   const_element_iterator <a class="code" href="classParallelMesh.php#a147d2a4bda46d2dbeabd972f908525bb">unpartitioned_elements_end</a> () <span class="keyword">const</span>;
<a name="l00327"></a>00327   
<a name="l00328"></a>00328   const_element_iterator <a class="code" href="classParallelMesh.php#a3d11ea6fbb0b593b9a2a026b90b8120f">active_local_subdomain_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id) <span class="keyword">const</span>;
<a name="l00329"></a>00329   const_element_iterator <a class="code" href="classParallelMesh.php#a9ca7e83cc9bfb677b8b4877630d91b86">active_local_subdomain_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id) <span class="keyword">const</span>;
<a name="l00330"></a>00330   
<a name="l00331"></a>00331   
<a name="l00332"></a>00332   
<a name="l00333"></a>00333   
<a name="l00334"></a>00334   
<a name="l00338"></a>00338   node_iterator <a class="code" href="classParallelMesh.php#a41dc2bb2c80771f68752593a5a27ebdd">nodes_begin</a>();
<a name="l00339"></a>00339   node_iterator <a class="code" href="classParallelMesh.php#ac4ccc2b31dfaf51efd64dc1d0baead0c">nodes_end</a>();
<a name="l00340"></a>00340   
<a name="l00341"></a>00341   node_iterator <a class="code" href="classParallelMesh.php#ab4fd25d514ab88336f8715c0c2dbe8d0">active_nodes_begin</a>();
<a name="l00342"></a>00342   node_iterator <a class="code" href="classParallelMesh.php#a7c030873eb732981d3fd4c8733f19685">active_nodes_end</a>();
<a name="l00343"></a>00343 
<a name="l00344"></a>00344   node_iterator <a class="code" href="classParallelMesh.php#a6d946e045e452f81014f878a6c0e3dc0">local_nodes_begin</a>  ();
<a name="l00345"></a>00345   node_iterator <a class="code" href="classParallelMesh.php#aea43c4aa5e1717506724d63551de946c">local_nodes_end</a>    ();
<a name="l00346"></a>00346   
<a name="l00347"></a>00347   node_iterator <a class="code" href="classParallelMesh.php#a848705e1601967c53ad123d7fd55f30e">pid_nodes_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id);
<a name="l00348"></a>00348   node_iterator <a class="code" href="classParallelMesh.php#a5df791650531a9743dfad56befbf8041">pid_nodes_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id);
<a name="l00349"></a>00349 
<a name="l00353"></a>00353   const_node_iterator <a class="code" href="classParallelMesh.php#a41dc2bb2c80771f68752593a5a27ebdd">nodes_begin</a>() <span class="keyword">const</span>;
<a name="l00354"></a>00354   const_node_iterator <a class="code" href="classParallelMesh.php#ac4ccc2b31dfaf51efd64dc1d0baead0c">nodes_end</a>()   <span class="keyword">const</span>;
<a name="l00355"></a>00355 
<a name="l00356"></a>00356   const_node_iterator <a class="code" href="classParallelMesh.php#ab4fd25d514ab88336f8715c0c2dbe8d0">active_nodes_begin</a>() <span class="keyword">const</span>;
<a name="l00357"></a>00357   const_node_iterator <a class="code" href="classParallelMesh.php#a7c030873eb732981d3fd4c8733f19685">active_nodes_end</a>()   <span class="keyword">const</span>;
<a name="l00358"></a>00358 
<a name="l00359"></a>00359   const_node_iterator <a class="code" href="classParallelMesh.php#a6d946e045e452f81014f878a6c0e3dc0">local_nodes_begin</a>  () <span class="keyword">const</span>;
<a name="l00360"></a>00360   const_node_iterator <a class="code" href="classParallelMesh.php#aea43c4aa5e1717506724d63551de946c">local_nodes_end</a>    () <span class="keyword">const</span>;
<a name="l00361"></a>00361 
<a name="l00362"></a>00362   const_node_iterator <a class="code" href="classParallelMesh.php#a848705e1601967c53ad123d7fd55f30e">pid_nodes_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span>;
<a name="l00363"></a>00363   const_node_iterator <a class="code" href="classParallelMesh.php#a5df791650531a9743dfad56befbf8041">pid_nodes_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span>;
<a name="l00364"></a>00364  
<a name="l00365"></a>00365 <span class="keyword">protected</span>:
<a name="l00366"></a>00366 
<a name="l00370"></a><a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">00370</a>   <a class="code" href="classmapvector.php">mapvector&lt;Node*&gt;</a> <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>;
<a name="l00371"></a>00371   
<a name="l00375"></a><a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">00375</a>   <a class="code" href="classmapvector.php">mapvector&lt;Elem*&gt;</a> <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>;
<a name="l00376"></a>00376 
<a name="l00380"></a><a class="code" href="classParallelMesh.php#a9c13b059a6cf3c9d4ad8da7fbb644f08">00380</a>   <span class="keywordtype">bool</span> <a class="code" href="classParallelMesh.php#a9c13b059a6cf3c9d4ad8da7fbb644f08">_is_serial</a>;
<a name="l00381"></a>00381 
<a name="l00385"></a><a class="code" href="classParallelMesh.php#a40377d3c8e3bc9b45e5c08f55a33ef1a">00385</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallelMesh.php#a40377d3c8e3bc9b45e5c08f55a33ef1a">_n_nodes</a>, <a class="code" href="classParallelMesh.php#a0bdfa08b935887abbc25dd72c8047fca">_n_elem</a>, <a class="code" href="classParallelMesh.php#a55e7b1c0d855184e7db312cc2ddc0a8c">_max_node_id</a>, <a class="code" href="classParallelMesh.php#a149c9eae01b607b2f9959683ccbdcf01">_max_elem_id</a>;
<a name="l00386"></a>00386 
<a name="l00391"></a><a class="code" href="classParallelMesh.php#acca1c020ab2000bb301b2d16e7a5b2bd">00391</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallelMesh.php#acca1c020ab2000bb301b2d16e7a5b2bd">_next_free_local_node_id</a>,
<a name="l00392"></a>00392                <a class="code" href="classParallelMesh.php#abcf351f2a4a6562b58cba564bd00c73d">_next_free_local_elem_id</a>;
<a name="l00393"></a><a class="code" href="classParallelMesh.php#ad7beb6c794979321b7bb1a1010b842d4">00393</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallelMesh.php#ad7beb6c794979321b7bb1a1010b842d4">_next_free_unpartitioned_node_id</a>,
<a name="l00394"></a>00394                <a class="code" href="classParallelMesh.php#a0e7b564b3093c49e6b56c2ce874ae112">_next_free_unpartitioned_elem_id</a>;
<a name="l00395"></a>00395 
<a name="l00396"></a>00396 <span class="keyword">private</span>:
<a name="l00397"></a>00397   
<a name="l00402"></a><a class="code" href="classParallelMesh.php#a755d720d8a69b18ca13180a6efa5722b">00402</a>   <span class="keyword">typedef</span> <a class="code" href="classmapvector.php">mapvector&lt;Elem*&gt;::veclike_iterator</a>             <a class="code" href="classParallelMesh.php#a755d720d8a69b18ca13180a6efa5722b">elem_iterator_imp</a>;
<a name="l00403"></a><a class="code" href="classParallelMesh.php#a010ea903820bea8f21f812a75083c14d">00403</a>   <span class="keyword">typedef</span> <a class="code" href="classmapvector.php">mapvector&lt;Elem*&gt;::const_veclike_iterator</a> <a class="code" href="classParallelMesh.php#a010ea903820bea8f21f812a75083c14d">const_elem_iterator_imp</a>;
<a name="l00404"></a>00404 
<a name="l00409"></a><a class="code" href="classParallelMesh.php#ace78878c29e013e5ce3b0fe544d7196f">00409</a>   <span class="keyword">typedef</span> <a class="code" href="classmapvector.php">mapvector&lt;Node*&gt;::veclike_iterator</a>             <a class="code" href="classParallelMesh.php#ace78878c29e013e5ce3b0fe544d7196f">node_iterator_imp</a>;
<a name="l00410"></a><a class="code" href="classParallelMesh.php#a06317f1cdd759c346797742a8dbf7493">00410</a>   <span class="keyword">typedef</span> <a class="code" href="classmapvector.php">mapvector&lt;Node*&gt;::const_veclike_iterator</a> <a class="code" href="classParallelMesh.php#a06317f1cdd759c346797742a8dbf7493">const_node_iterator_imp</a>;
<a name="l00411"></a>00411 };
<a name="l00412"></a>00412 
<a name="l00413"></a>00413 
<a name="l00414"></a>00414 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
