<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>parallel_mesh_iterators.C</h1>  </div>
</div>
<div class="contents">
<a href="parallel__mesh__iterators_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: parallel_mesh_iterators.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libParallelMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="comment">// #include &quot;mesh_base.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;parallel_mesh.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// This file contains the implementation of all the different iterator</span>
<a name="l00030"></a>00030 <span class="comment">// functions for the mesh class.  They were put here to save space in the</span>
<a name="l00031"></a>00031 <span class="comment">// header files.</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// default begin() accessor</span>
<a name="l00035"></a>00035 ParallelMesh::element_iterator
<a name="l00036"></a><a class="code" href="classParallelMesh.php#a5f982d8b28eb452959996453fde4439f">00036</a> <a class="code" href="classParallelMesh.php#a5f982d8b28eb452959996453fde4439f">ParallelMesh::elements_begin</a> ()
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038   <a class="code" href="structPredicates_1_1NotNull.php">Predicates::NotNull&lt;elem_iterator_imp&gt;</a> p;
<a name="l00039"></a>00039   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00040"></a>00040 }
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="comment">// active elements begin() accessor</span>
<a name="l00045"></a>00045 ParallelMesh::element_iterator
<a name="l00046"></a><a class="code" href="classParallelMesh.php#ad93ab290b531351ba6b27edb53963106">00046</a> <a class="code" href="classParallelMesh.php#ad93ab290b531351ba6b27edb53963106">ParallelMesh::active_elements_begin</a> ()
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048   <a class="code" href="structPredicates_1_1Active.php">Predicates::Active&lt;elem_iterator_imp&gt;</a> p;
<a name="l00049"></a>00049   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00050"></a>00050 }
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 <span class="comment">// not active elements begin() accessor</span>
<a name="l00055"></a>00055 ParallelMesh::element_iterator
<a name="l00056"></a><a class="code" href="classParallelMesh.php#a8bb796e6be387a4f12282acd147b6c52">00056</a> <a class="code" href="classParallelMesh.php#a8bb796e6be387a4f12282acd147b6c52">ParallelMesh::not_active_elements_begin</a> ()
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058   <a class="code" href="structPredicates_1_1NotActive.php">Predicates::NotActive&lt;elem_iterator_imp&gt;</a> p;
<a name="l00059"></a>00059   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00060"></a>00060 }
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 <span class="comment">// ancestor elements begin() accessor</span>
<a name="l00065"></a>00065 ParallelMesh::element_iterator
<a name="l00066"></a><a class="code" href="classParallelMesh.php#a7ece42cd353d9c87e4dbdec965de88b5">00066</a> <a class="code" href="classParallelMesh.php#a7ece42cd353d9c87e4dbdec965de88b5">ParallelMesh::ancestor_elements_begin</a> ()
<a name="l00067"></a>00067 {
<a name="l00068"></a>00068   <a class="code" href="structPredicates_1_1Ancestor.php">Predicates::Ancestor&lt;elem_iterator_imp&gt;</a> p;
<a name="l00069"></a>00069   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00070"></a>00070 }
<a name="l00071"></a>00071 
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 <span class="comment">// not ancestor elements begin() accessor</span>
<a name="l00075"></a>00075 ParallelMesh::element_iterator
<a name="l00076"></a><a class="code" href="classParallelMesh.php#ab749438ebc0c950500d84bbb7543d974">00076</a> <a class="code" href="classParallelMesh.php#ab749438ebc0c950500d84bbb7543d974">ParallelMesh::not_ancestor_elements_begin</a> ()
<a name="l00077"></a>00077 {
<a name="l00078"></a>00078   <a class="code" href="structPredicates_1_1Ancestor.php">Predicates::Ancestor&lt;elem_iterator_imp&gt;</a> p;
<a name="l00079"></a>00079   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00080"></a>00080 }
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 <span class="comment">// subactive elements begin() accessor</span>
<a name="l00085"></a>00085 ParallelMesh::element_iterator
<a name="l00086"></a><a class="code" href="classParallelMesh.php#ae8fc74e9e779cef9f4b4429bab777ab7">00086</a> <a class="code" href="classParallelMesh.php#ae8fc74e9e779cef9f4b4429bab777ab7">ParallelMesh::subactive_elements_begin</a> ()
<a name="l00087"></a>00087 {
<a name="l00088"></a>00088   <a class="code" href="structPredicates_1_1SubActive.php">Predicates::SubActive&lt;elem_iterator_imp&gt;</a> p;
<a name="l00089"></a>00089   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00090"></a>00090 }
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 <span class="comment">// not subactive elements begin() accessor</span>
<a name="l00095"></a>00095 ParallelMesh::element_iterator
<a name="l00096"></a><a class="code" href="classParallelMesh.php#a37bff79e0dd8a3bc3fe545b38f38e064">00096</a> <a class="code" href="classParallelMesh.php#a37bff79e0dd8a3bc3fe545b38f38e064">ParallelMesh::not_subactive_elements_begin</a> ()
<a name="l00097"></a>00097 {
<a name="l00098"></a>00098   <a class="code" href="structPredicates_1_1NotSubActive.php">Predicates::NotSubActive&lt;elem_iterator_imp&gt;</a> p;
<a name="l00099"></a>00099   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00100"></a>00100 }
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 <span class="comment">// local elements begin() accessor</span>
<a name="l00105"></a>00105 ParallelMesh::element_iterator
<a name="l00106"></a><a class="code" href="classParallelMesh.php#adffe63cef73e8fd317f08aa1722d8e71">00106</a> <a class="code" href="classParallelMesh.php#adffe63cef73e8fd317f08aa1722d8e71">ParallelMesh::local_elements_begin</a> ()
<a name="l00107"></a>00107 {
<a name="l00108"></a>00108   <a class="code" href="structPredicates_1_1Local.php">Predicates::Local&lt;elem_iterator_imp&gt;</a> p;
<a name="l00109"></a>00109   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00110"></a>00110 }
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 <span class="comment">// not_local elements begin() accessor</span>
<a name="l00115"></a>00115 ParallelMesh::element_iterator
<a name="l00116"></a><a class="code" href="classParallelMesh.php#ad0e42cc14d2d5f0cd26d2bb2a6b1b888">00116</a> <a class="code" href="classParallelMesh.php#ad0e42cc14d2d5f0cd26d2bb2a6b1b888">ParallelMesh::not_local_elements_begin</a> ()
<a name="l00117"></a>00117 {
<a name="l00118"></a>00118   <a class="code" href="structPredicates_1_1NotLocal.php">Predicates::NotLocal&lt;elem_iterator_imp&gt;</a> p;
<a name="l00119"></a>00119   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00120"></a>00120 }
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 <span class="comment">// active local elements begin() accessor</span>
<a name="l00125"></a>00125 ParallelMesh::element_iterator
<a name="l00126"></a><a class="code" href="classParallelMesh.php#a6256f0b7f343da9232eb280a94f95999">00126</a> <a class="code" href="classParallelMesh.php#a6256f0b7f343da9232eb280a94f95999">ParallelMesh::active_local_elements_begin</a> ()
<a name="l00127"></a>00127 {
<a name="l00128"></a>00128   <a class="code" href="structPredicates_1_1ActiveLocal.php">Predicates::ActiveLocal&lt;elem_iterator_imp&gt;</a> p;
<a name="l00129"></a>00129   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00130"></a>00130 }
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 <span class="comment">// active_not_local elements begin() accessor</span>
<a name="l00135"></a>00135 ParallelMesh::element_iterator
<a name="l00136"></a><a class="code" href="classParallelMesh.php#a375c34b64ee77c69677a4c1089a99523">00136</a> <a class="code" href="classParallelMesh.php#a375c34b64ee77c69677a4c1089a99523">ParallelMesh::active_not_local_elements_begin</a> ()
<a name="l00137"></a>00137 {
<a name="l00138"></a>00138   <a class="code" href="structPredicates_1_1ActiveNotLocal.php">Predicates::ActiveNotLocal&lt;elem_iterator_imp&gt;</a> p;
<a name="l00139"></a>00139   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00140"></a>00140 }
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 <span class="comment">// level elements begin() accessor</span>
<a name="l00145"></a>00145 ParallelMesh::element_iterator
<a name="l00146"></a><a class="code" href="classParallelMesh.php#ad61c7ac197af37ec6eee1fafc72c625a">00146</a> <a class="code" href="classParallelMesh.php#ad61c7ac197af37ec6eee1fafc72c625a">ParallelMesh::level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)
<a name="l00147"></a>00147 {
<a name="l00148"></a>00148   <a class="code" href="structPredicates_1_1Level.php">Predicates::Level&lt;elem_iterator_imp&gt;</a> p(level);
<a name="l00149"></a>00149   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00150"></a>00150 }
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 <span class="comment">// not level elements begin() accessor</span>
<a name="l00155"></a>00155 ParallelMesh::element_iterator
<a name="l00156"></a><a class="code" href="classParallelMesh.php#aa4e1dd747d2c71afc9ce54c99fc18eb3">00156</a> <a class="code" href="classParallelMesh.php#aa4e1dd747d2c71afc9ce54c99fc18eb3">ParallelMesh::not_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)
<a name="l00157"></a>00157 {
<a name="l00158"></a>00158   <a class="code" href="structPredicates_1_1NotLevel.php">Predicates::NotLevel&lt;elem_iterator_imp&gt;</a> p(level);
<a name="l00159"></a>00159   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00160"></a>00160 }
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 <span class="comment">// local level elements begin() accessor</span>
<a name="l00165"></a>00165 ParallelMesh::element_iterator
<a name="l00166"></a><a class="code" href="classParallelMesh.php#abcc01be1661a0e82a4e4d5dfb1a79ef4">00166</a> <a class="code" href="classParallelMesh.php#abcc01be1661a0e82a4e4d5dfb1a79ef4">ParallelMesh::local_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)
<a name="l00167"></a>00167 {
<a name="l00168"></a>00168   <a class="code" href="structPredicates_1_1LocalLevel.php">Predicates::LocalLevel&lt;elem_iterator_imp&gt;</a> p(level);
<a name="l00169"></a>00169   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00170"></a>00170 }
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 <span class="comment">// local not level elements begin() accessor</span>
<a name="l00175"></a>00175 ParallelMesh::element_iterator
<a name="l00176"></a><a class="code" href="classParallelMesh.php#adbe1c8be02fbe183eb1f3ab26baa503b">00176</a> <a class="code" href="classParallelMesh.php#adbe1c8be02fbe183eb1f3ab26baa503b">ParallelMesh::local_not_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)
<a name="l00177"></a>00177 {
<a name="l00178"></a>00178   <a class="code" href="structPredicates_1_1LocalNotLevel.php">Predicates::LocalNotLevel&lt;elem_iterator_imp&gt;</a> p(level);
<a name="l00179"></a>00179   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00180"></a>00180 }
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 <span class="comment">// pid elements begin() accessor</span>
<a name="l00185"></a>00185 ParallelMesh::element_iterator
<a name="l00186"></a><a class="code" href="classParallelMesh.php#a400f4952a80055c7546a6cc9e87378bb">00186</a> <a class="code" href="classParallelMesh.php#a400f4952a80055c7546a6cc9e87378bb">ParallelMesh::pid_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)
<a name="l00187"></a>00187 {
<a name="l00188"></a>00188   <a class="code" href="structPredicates_1_1PID.php">Predicates::PID&lt;elem_iterator_imp&gt;</a> p(proc_id);
<a name="l00189"></a>00189   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00190"></a>00190 }
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 <span class="comment">// type elements begin() accessor</span>
<a name="l00195"></a>00195 ParallelMesh::element_iterator
<a name="l00196"></a><a class="code" href="classParallelMesh.php#a78ff7a6829916ff229bb8c5e80799e74">00196</a> <a class="code" href="classParallelMesh.php#a78ff7a6829916ff229bb8c5e80799e74">ParallelMesh::type_elements_begin</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)
<a name="l00197"></a>00197 {
<a name="l00198"></a>00198   <a class="code" href="structPredicates_1_1Type.php">Predicates::Type&lt;elem_iterator_imp&gt;</a> p(type);
<a name="l00199"></a>00199   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00200"></a>00200 }
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 <span class="comment">// active type elements begin() accessor</span>
<a name="l00205"></a>00205 ParallelMesh::element_iterator
<a name="l00206"></a><a class="code" href="classParallelMesh.php#a6bdf72630cb5bf3fd5ee9d25c49c344d">00206</a> <a class="code" href="classParallelMesh.php#a6bdf72630cb5bf3fd5ee9d25c49c344d">ParallelMesh::active_type_elements_begin</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)
<a name="l00207"></a>00207 {
<a name="l00208"></a>00208   <a class="code" href="structPredicates_1_1ActiveType.php">Predicates::ActiveType&lt;elem_iterator_imp&gt;</a> p(type);
<a name="l00209"></a>00209   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00210"></a>00210 }
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 
<a name="l00214"></a>00214 <span class="comment">// active pid elements begin() accessor</span>
<a name="l00215"></a>00215 ParallelMesh::element_iterator
<a name="l00216"></a><a class="code" href="classParallelMesh.php#afaa6356f7fc192f9146c38194f4747ba">00216</a> <a class="code" href="classParallelMesh.php#afaa6356f7fc192f9146c38194f4747ba">ParallelMesh::active_pid_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)
<a name="l00217"></a>00217 {
<a name="l00218"></a>00218   <a class="code" href="structPredicates_1_1ActivePID.php">Predicates::ActivePID&lt;elem_iterator_imp&gt;</a> p(proc_id);
<a name="l00219"></a>00219   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00220"></a>00220 }
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 <span class="comment">// unpartitioned elements begin() accessor</span>
<a name="l00225"></a>00225 ParallelMesh::element_iterator
<a name="l00226"></a><a class="code" href="classParallelMesh.php#a36cda99fc5687ca38b5b0cf2e113fcff">00226</a> <a class="code" href="classParallelMesh.php#a36cda99fc5687ca38b5b0cf2e113fcff">ParallelMesh::unpartitioned_elements_begin</a> ()
<a name="l00227"></a>00227 {
<a name="l00228"></a>00228   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classParallelMesh.php#a400f4952a80055c7546a6cc9e87378bb">pid_elements_begin</a>(<a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>);
<a name="l00229"></a>00229 }
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 <span class="comment">// subdomain elements begin() accessor</span>
<a name="l00234"></a>00234 ParallelMesh::element_iterator
<a name="l00235"></a><a class="code" href="classParallelMesh.php#a3d11ea6fbb0b593b9a2a026b90b8120f">00235</a> <a class="code" href="classParallelMesh.php#a3d11ea6fbb0b593b9a2a026b90b8120f">ParallelMesh::active_local_subdomain_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id)
<a name="l00236"></a>00236 {
<a name="l00237"></a>00237   <a class="code" href="structPredicates_1_1ActiveLocalSubdomain.php">Predicates::ActiveLocalSubdomain&lt;elem_iterator_imp&gt;</a> p(subdomain_id);
<a name="l00238"></a>00238   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00239"></a>00239 }
<a name="l00240"></a>00240 
<a name="l00241"></a>00241 
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 <span class="comment">// default const begin() accessor</span>
<a name="l00250"></a>00250 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00251"></a><a class="code" href="classParallelMesh.php#a8e216d0060db2b6ad0478a7dab6f5e71">00251</a> <a class="code" href="classParallelMesh.php#a5f982d8b28eb452959996453fde4439f">ParallelMesh::elements_begin</a> ()<span class="keyword"> const</span>
<a name="l00252"></a>00252 <span class="keyword"></span>{
<a name="l00253"></a>00253   <a class="code" href="structPredicates_1_1NotNull.php">Predicates::NotNull&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00254"></a>00254   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00255"></a>00255 }
<a name="l00256"></a>00256 
<a name="l00257"></a>00257 
<a name="l00258"></a>00258 
<a name="l00259"></a>00259 <span class="comment">// const active begin() accessor</span>
<a name="l00260"></a>00260 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00261"></a><a class="code" href="classParallelMesh.php#acfb8b706d9321ed7cf48834e350b9b03">00261</a> <a class="code" href="classParallelMesh.php#ad93ab290b531351ba6b27edb53963106">ParallelMesh::active_elements_begin</a> ()<span class="keyword"> const</span>
<a name="l00262"></a>00262 <span class="keyword"></span>{
<a name="l00263"></a>00263   <a class="code" href="structPredicates_1_1Active.php">Predicates::Active&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00264"></a>00264   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00265"></a>00265 }
<a name="l00266"></a>00266 
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 <span class="comment">// const not active begin() accessor</span>
<a name="l00269"></a>00269 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00270"></a><a class="code" href="classParallelMesh.php#a6c7915474632a153e888e6022de2b4a4">00270</a> <a class="code" href="classParallelMesh.php#a8bb796e6be387a4f12282acd147b6c52">ParallelMesh::not_active_elements_begin</a> ()<span class="keyword"> const</span>
<a name="l00271"></a>00271 <span class="keyword"></span>{
<a name="l00272"></a>00272   <a class="code" href="structPredicates_1_1NotActive.php">Predicates::NotActive&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00273"></a>00273   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00274"></a>00274 }
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 
<a name="l00278"></a>00278 <span class="comment">// const ancestor begin() accessor</span>
<a name="l00279"></a>00279 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00280"></a><a class="code" href="classParallelMesh.php#a04fbe554fc260f54b541949ad5f7c9df">00280</a> <a class="code" href="classParallelMesh.php#a7ece42cd353d9c87e4dbdec965de88b5">ParallelMesh::ancestor_elements_begin</a> ()<span class="keyword"> const</span>
<a name="l00281"></a>00281 <span class="keyword"></span>{
<a name="l00282"></a>00282   <a class="code" href="structPredicates_1_1Ancestor.php">Predicates::Ancestor&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00283"></a>00283   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00284"></a>00284 }
<a name="l00285"></a>00285 
<a name="l00286"></a>00286 
<a name="l00287"></a>00287 
<a name="l00288"></a>00288 <span class="comment">// const not ancestor begin() accessor</span>
<a name="l00289"></a>00289 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00290"></a><a class="code" href="classParallelMesh.php#a0b5da0244040b67f22534b2c14905192">00290</a> <a class="code" href="classParallelMesh.php#ab749438ebc0c950500d84bbb7543d974">ParallelMesh::not_ancestor_elements_begin</a> ()<span class="keyword"> const</span>
<a name="l00291"></a>00291 <span class="keyword"></span>{
<a name="l00292"></a>00292   <a class="code" href="structPredicates_1_1Ancestor.php">Predicates::Ancestor&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00293"></a>00293   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00294"></a>00294 }
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 
<a name="l00297"></a>00297 
<a name="l00298"></a>00298 <span class="comment">// const subactive begin() accessor</span>
<a name="l00299"></a>00299 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00300"></a><a class="code" href="classParallelMesh.php#a7835757c843c5c114473e41151ad1f53">00300</a> <a class="code" href="classParallelMesh.php#ae8fc74e9e779cef9f4b4429bab777ab7">ParallelMesh::subactive_elements_begin</a> ()<span class="keyword"> const</span>
<a name="l00301"></a>00301 <span class="keyword"></span>{
<a name="l00302"></a>00302   <a class="code" href="structPredicates_1_1SubActive.php">Predicates::SubActive&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00303"></a>00303   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00304"></a>00304 }
<a name="l00305"></a>00305 
<a name="l00306"></a>00306 
<a name="l00307"></a>00307 
<a name="l00308"></a>00308 <span class="comment">// const not subactive begin() accessor</span>
<a name="l00309"></a>00309 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00310"></a><a class="code" href="classParallelMesh.php#a0a07c7a57972377fb2981053bf2ddab2">00310</a> <a class="code" href="classParallelMesh.php#a37bff79e0dd8a3bc3fe545b38f38e064">ParallelMesh::not_subactive_elements_begin</a> ()<span class="keyword"> const</span>
<a name="l00311"></a>00311 <span class="keyword"></span>{
<a name="l00312"></a>00312   <a class="code" href="structPredicates_1_1NotSubActive.php">Predicates::NotSubActive&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00313"></a>00313   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00314"></a>00314 }
<a name="l00315"></a>00315 
<a name="l00316"></a>00316 
<a name="l00317"></a>00317 
<a name="l00318"></a>00318 <span class="comment">// const local begin() accessor</span>
<a name="l00319"></a>00319 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00320"></a><a class="code" href="classParallelMesh.php#a49a99ec5f55fcea41350a2051487d841">00320</a> <a class="code" href="classParallelMesh.php#adffe63cef73e8fd317f08aa1722d8e71">ParallelMesh::local_elements_begin</a> ()<span class="keyword"> const</span>
<a name="l00321"></a>00321 <span class="keyword"></span>{
<a name="l00322"></a>00322   <a class="code" href="structPredicates_1_1Local.php">Predicates::Local&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00323"></a>00323   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00324"></a>00324 }
<a name="l00325"></a>00325 
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 <span class="comment">// const not_local begin() accessor</span>
<a name="l00329"></a>00329 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00330"></a><a class="code" href="classParallelMesh.php#a6baba0e1c3899bd9ee57f4eaf6bac7de">00330</a> <a class="code" href="classParallelMesh.php#ad0e42cc14d2d5f0cd26d2bb2a6b1b888">ParallelMesh::not_local_elements_begin</a> ()<span class="keyword"> const</span>
<a name="l00331"></a>00331 <span class="keyword"></span>{
<a name="l00332"></a>00332   <a class="code" href="structPredicates_1_1NotLocal.php">Predicates::NotLocal&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00333"></a>00333   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00334"></a>00334 }
<a name="l00335"></a>00335 
<a name="l00336"></a>00336 
<a name="l00337"></a>00337 
<a name="l00338"></a>00338 <span class="comment">// const active local begin() accessor</span>
<a name="l00339"></a>00339 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00340"></a><a class="code" href="classParallelMesh.php#a926cb2b6ca11bc8f5ab2efa4ccdef996">00340</a> <a class="code" href="classParallelMesh.php#a6256f0b7f343da9232eb280a94f95999">ParallelMesh::active_local_elements_begin</a> ()<span class="keyword"> const</span>
<a name="l00341"></a>00341 <span class="keyword"></span>{
<a name="l00342"></a>00342   <a class="code" href="structPredicates_1_1ActiveLocal.php">Predicates::ActiveLocal&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00343"></a>00343   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00344"></a>00344 }
<a name="l00345"></a>00345 
<a name="l00346"></a>00346 
<a name="l00347"></a>00347 
<a name="l00348"></a>00348 <span class="comment">// const active not_local begin() accessor</span>
<a name="l00349"></a>00349 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00350"></a><a class="code" href="classParallelMesh.php#a5d95033acc7999600060a61c8e44ac88">00350</a> <a class="code" href="classParallelMesh.php#a375c34b64ee77c69677a4c1089a99523">ParallelMesh::active_not_local_elements_begin</a> ()<span class="keyword"> const</span>
<a name="l00351"></a>00351 <span class="keyword"></span>{
<a name="l00352"></a>00352   <a class="code" href="structPredicates_1_1ActiveNotLocal.php">Predicates::ActiveNotLocal&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00353"></a>00353   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00354"></a>00354 }
<a name="l00355"></a>00355 
<a name="l00356"></a>00356 
<a name="l00357"></a>00357 
<a name="l00358"></a>00358 <span class="comment">// const level begin() accessor</span>
<a name="l00359"></a>00359 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00360"></a><a class="code" href="classParallelMesh.php#a3764ad22e5a3c499ac4c26debbd24953">00360</a> <a class="code" href="classParallelMesh.php#ad61c7ac197af37ec6eee1fafc72c625a">ParallelMesh::level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)<span class="keyword"> const</span>
<a name="l00361"></a>00361 <span class="keyword"></span>{
<a name="l00362"></a>00362   <a class="code" href="structPredicates_1_1Level.php">Predicates::Level&lt;const_elem_iterator_imp&gt;</a> p(level);
<a name="l00363"></a>00363   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00364"></a>00364 }
<a name="l00365"></a>00365 
<a name="l00366"></a>00366 
<a name="l00367"></a>00367 
<a name="l00368"></a>00368 <span class="comment">// const not level begin() accessor</span>
<a name="l00369"></a>00369 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00370"></a><a class="code" href="classParallelMesh.php#aa006077bf248793d41261f86e7c3e5d4">00370</a> <a class="code" href="classParallelMesh.php#aa4e1dd747d2c71afc9ce54c99fc18eb3">ParallelMesh::not_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)<span class="keyword"> const</span>
<a name="l00371"></a>00371 <span class="keyword"></span>{
<a name="l00372"></a>00372   <a class="code" href="structPredicates_1_1NotLevel.php">Predicates::NotLevel&lt;const_elem_iterator_imp&gt;</a> p(level);
<a name="l00373"></a>00373   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00374"></a>00374 }
<a name="l00375"></a>00375 
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 <span class="comment">// const local level begin() accessor</span>
<a name="l00379"></a>00379 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00380"></a><a class="code" href="classParallelMesh.php#ada932e690de63b86f6a7354cbb68b164">00380</a> <a class="code" href="classParallelMesh.php#abcc01be1661a0e82a4e4d5dfb1a79ef4">ParallelMesh::local_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)<span class="keyword"> const</span>
<a name="l00381"></a>00381 <span class="keyword"></span>{
<a name="l00382"></a>00382   <a class="code" href="structPredicates_1_1LocalLevel.php">Predicates::LocalLevel&lt;const_elem_iterator_imp&gt;</a> p(level);
<a name="l00383"></a>00383   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00384"></a>00384 }
<a name="l00385"></a>00385 
<a name="l00386"></a>00386 
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 <span class="comment">// const local not level begin() accessor</span>
<a name="l00389"></a>00389 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00390"></a><a class="code" href="classParallelMesh.php#a4afd5168919a9fdd672739aedffcc9ee">00390</a> <a class="code" href="classParallelMesh.php#adbe1c8be02fbe183eb1f3ab26baa503b">ParallelMesh::local_not_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)<span class="keyword"> const</span>
<a name="l00391"></a>00391 <span class="keyword"></span>{
<a name="l00392"></a>00392   <a class="code" href="structPredicates_1_1LocalNotLevel.php">Predicates::LocalNotLevel&lt;const_elem_iterator_imp&gt;</a> p(level);
<a name="l00393"></a>00393   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00394"></a>00394 }
<a name="l00395"></a>00395 
<a name="l00396"></a>00396 
<a name="l00397"></a>00397 
<a name="l00398"></a>00398 <span class="comment">// const pid begin() accessor</span>
<a name="l00399"></a>00399 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00400"></a><a class="code" href="classParallelMesh.php#a948c13dd92eae910bdf09eff84990000">00400</a> <a class="code" href="classParallelMesh.php#a400f4952a80055c7546a6cc9e87378bb">ParallelMesh::pid_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)<span class="keyword"> const</span>
<a name="l00401"></a>00401 <span class="keyword"></span>{
<a name="l00402"></a>00402   <a class="code" href="structPredicates_1_1PID.php">Predicates::PID&lt;const_elem_iterator_imp&gt;</a> p(proc_id);
<a name="l00403"></a>00403   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00404"></a>00404 }
<a name="l00405"></a>00405 
<a name="l00406"></a>00406 
<a name="l00407"></a>00407 
<a name="l00408"></a>00408 <span class="comment">// const type begin() accessor</span>
<a name="l00409"></a>00409 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00410"></a><a class="code" href="classParallelMesh.php#a0104f3253020d1e53ac8d9abd58eaab7">00410</a> <a class="code" href="classParallelMesh.php#a78ff7a6829916ff229bb8c5e80799e74">ParallelMesh::type_elements_begin</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)<span class="keyword"> const</span>
<a name="l00411"></a>00411 <span class="keyword"></span>{
<a name="l00412"></a>00412   <a class="code" href="structPredicates_1_1Type.php">Predicates::Type&lt;const_elem_iterator_imp&gt;</a> p(type);
<a name="l00413"></a>00413   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00414"></a>00414 }
<a name="l00415"></a>00415 
<a name="l00416"></a>00416 
<a name="l00417"></a>00417 
<a name="l00418"></a>00418 <span class="comment">// const active type begin() accessor</span>
<a name="l00419"></a>00419 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00420"></a><a class="code" href="classParallelMesh.php#a1e09d0134790eb7d6401dabc0bc811e3">00420</a> <a class="code" href="classParallelMesh.php#a6bdf72630cb5bf3fd5ee9d25c49c344d">ParallelMesh::active_type_elements_begin</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)<span class="keyword"> const</span>
<a name="l00421"></a>00421 <span class="keyword"></span>{
<a name="l00422"></a>00422   <a class="code" href="structPredicates_1_1ActiveType.php">Predicates::ActiveType&lt;const_elem_iterator_imp&gt;</a> p(type);
<a name="l00423"></a>00423   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00424"></a>00424 }
<a name="l00425"></a>00425 
<a name="l00426"></a>00426 
<a name="l00427"></a>00427 
<a name="l00428"></a>00428 <span class="comment">// const active pid elements begin() accessor</span>
<a name="l00429"></a>00429 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00430"></a><a class="code" href="classParallelMesh.php#aa97cec5760d5fee9b1b7f5d568b3a822">00430</a> <a class="code" href="classParallelMesh.php#afaa6356f7fc192f9146c38194f4747ba">ParallelMesh::active_pid_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)<span class="keyword"> const</span>
<a name="l00431"></a>00431 <span class="keyword"></span>{
<a name="l00432"></a>00432   <a class="code" href="structPredicates_1_1ActivePID.php">Predicates::ActivePID&lt;const_elem_iterator_imp&gt;</a> p(proc_id);
<a name="l00433"></a>00433   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00434"></a>00434 }
<a name="l00435"></a>00435 
<a name="l00436"></a>00436 
<a name="l00437"></a>00437 
<a name="l00438"></a>00438 <span class="comment">// unpartitioned elements begin() accessor</span>
<a name="l00439"></a>00439 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00440"></a><a class="code" href="classParallelMesh.php#ab40226ceffaa1dfd27a0642b4e81168b">00440</a> <a class="code" href="classParallelMesh.php#a36cda99fc5687ca38b5b0cf2e113fcff">ParallelMesh::unpartitioned_elements_begin</a> ()<span class="keyword"> const</span>
<a name="l00441"></a>00441 <span class="keyword"></span>{
<a name="l00442"></a>00442   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classParallelMesh.php#a400f4952a80055c7546a6cc9e87378bb">pid_elements_begin</a>(<a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>);
<a name="l00443"></a>00443 }
<a name="l00444"></a>00444 
<a name="l00445"></a>00445 
<a name="l00446"></a>00446 
<a name="l00447"></a>00447 <span class="comment">// subdomain elements begin() accessor</span>
<a name="l00448"></a>00448 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00449"></a><a class="code" href="classParallelMesh.php#a442477001624b9c86b4469fb59ef95fe">00449</a> <a class="code" href="classParallelMesh.php#a3d11ea6fbb0b593b9a2a026b90b8120f">ParallelMesh::active_local_subdomain_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id)<span class="keyword"> const</span>
<a name="l00450"></a>00450 <span class="keyword"></span>{
<a name="l00451"></a>00451   <a class="code" href="structPredicates_1_1ActiveLocalSubdomain.php">Predicates::ActiveLocalSubdomain&lt;const_elem_iterator_imp&gt;</a> p(subdomain_id);
<a name="l00452"></a>00452   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00453"></a>00453 }
<a name="l00454"></a>00454 
<a name="l00455"></a>00455 
<a name="l00456"></a>00456 
<a name="l00457"></a>00457 
<a name="l00458"></a>00458 
<a name="l00459"></a>00459 
<a name="l00460"></a>00460 
<a name="l00461"></a>00461 <span class="comment">// default end() accessor</span>
<a name="l00462"></a>00462 ParallelMesh::element_iterator
<a name="l00463"></a><a class="code" href="classParallelMesh.php#a227c5c6ed9dd600b00d4c76f450eeae3">00463</a> <a class="code" href="classParallelMesh.php#a227c5c6ed9dd600b00d4c76f450eeae3">ParallelMesh::elements_end</a> ()
<a name="l00464"></a>00464 {
<a name="l00465"></a>00465   <a class="code" href="structPredicates_1_1NotNull.php">Predicates::NotNull&lt;elem_iterator_imp&gt;</a> p;
<a name="l00466"></a>00466   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00467"></a>00467 }
<a name="l00468"></a>00468 
<a name="l00469"></a>00469 
<a name="l00470"></a>00470 
<a name="l00471"></a>00471 <span class="comment">// active end() accessor</span>
<a name="l00472"></a>00472 ParallelMesh::element_iterator
<a name="l00473"></a><a class="code" href="classParallelMesh.php#aae426097554ed05956198a6ef04b5189">00473</a> <a class="code" href="classParallelMesh.php#aae426097554ed05956198a6ef04b5189">ParallelMesh::active_elements_end</a> ()
<a name="l00474"></a>00474 {
<a name="l00475"></a>00475   <a class="code" href="structPredicates_1_1Active.php">Predicates::Active&lt;elem_iterator_imp&gt;</a> p;
<a name="l00476"></a>00476   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00477"></a>00477 }
<a name="l00478"></a>00478 
<a name="l00479"></a>00479 
<a name="l00480"></a>00480 
<a name="l00481"></a>00481 <span class="comment">// active end() accessor</span>
<a name="l00482"></a>00482 ParallelMesh::element_iterator
<a name="l00483"></a><a class="code" href="classParallelMesh.php#a6459eed633c2e15655a9a097bd513618">00483</a> <a class="code" href="classParallelMesh.php#a6459eed633c2e15655a9a097bd513618">ParallelMesh::not_active_elements_end</a> ()
<a name="l00484"></a>00484 {
<a name="l00485"></a>00485   <a class="code" href="structPredicates_1_1NotActive.php">Predicates::NotActive&lt;elem_iterator_imp&gt;</a> p;
<a name="l00486"></a>00486   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00487"></a>00487 }
<a name="l00488"></a>00488 
<a name="l00489"></a>00489 
<a name="l00490"></a>00490 
<a name="l00491"></a>00491 <span class="comment">// ancestor end() accessor</span>
<a name="l00492"></a>00492 ParallelMesh::element_iterator
<a name="l00493"></a><a class="code" href="classParallelMesh.php#a40b5e29244947c98e99f344c7a2c6b43">00493</a> <a class="code" href="classParallelMesh.php#a40b5e29244947c98e99f344c7a2c6b43">ParallelMesh::ancestor_elements_end</a> ()
<a name="l00494"></a>00494 {
<a name="l00495"></a>00495   <a class="code" href="structPredicates_1_1Ancestor.php">Predicates::Ancestor&lt;elem_iterator_imp&gt;</a> p;
<a name="l00496"></a>00496   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00497"></a>00497 }
<a name="l00498"></a>00498 
<a name="l00499"></a>00499 
<a name="l00500"></a>00500 
<a name="l00501"></a>00501 <span class="comment">// ancestor end() accessor</span>
<a name="l00502"></a>00502 ParallelMesh::element_iterator
<a name="l00503"></a><a class="code" href="classParallelMesh.php#a8bacb1a9e4768073add40da965c514f7">00503</a> <a class="code" href="classParallelMesh.php#a8bacb1a9e4768073add40da965c514f7">ParallelMesh::not_ancestor_elements_end</a> ()
<a name="l00504"></a>00504 {
<a name="l00505"></a>00505   <a class="code" href="structPredicates_1_1Ancestor.php">Predicates::Ancestor&lt;elem_iterator_imp&gt;</a> p;
<a name="l00506"></a>00506   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00507"></a>00507 }
<a name="l00508"></a>00508 
<a name="l00509"></a>00509 
<a name="l00510"></a>00510 
<a name="l00511"></a>00511 <span class="comment">// subactive end() accessor</span>
<a name="l00512"></a>00512 ParallelMesh::element_iterator
<a name="l00513"></a><a class="code" href="classParallelMesh.php#a66a538d6334a006b2b17126b4cbc2527">00513</a> <a class="code" href="classParallelMesh.php#a66a538d6334a006b2b17126b4cbc2527">ParallelMesh::subactive_elements_end</a> ()
<a name="l00514"></a>00514 {
<a name="l00515"></a>00515   <a class="code" href="structPredicates_1_1SubActive.php">Predicates::SubActive&lt;elem_iterator_imp&gt;</a> p;
<a name="l00516"></a>00516   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00517"></a>00517 }
<a name="l00518"></a>00518 
<a name="l00519"></a>00519 
<a name="l00520"></a>00520 
<a name="l00521"></a>00521 <span class="comment">// subactive end() accessor</span>
<a name="l00522"></a>00522 ParallelMesh::element_iterator
<a name="l00523"></a><a class="code" href="classParallelMesh.php#a8c69925fbc4de782202c987ee367a741">00523</a> <a class="code" href="classParallelMesh.php#a8c69925fbc4de782202c987ee367a741">ParallelMesh::not_subactive_elements_end</a> ()
<a name="l00524"></a>00524 {
<a name="l00525"></a>00525   <a class="code" href="structPredicates_1_1NotSubActive.php">Predicates::NotSubActive&lt;elem_iterator_imp&gt;</a> p;
<a name="l00526"></a>00526   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00527"></a>00527 }
<a name="l00528"></a>00528 
<a name="l00529"></a>00529 
<a name="l00530"></a>00530 
<a name="l00531"></a>00531 <span class="comment">// local end() accessor</span>
<a name="l00532"></a>00532 ParallelMesh::element_iterator
<a name="l00533"></a><a class="code" href="classParallelMesh.php#a70c12ce1edd2d0c5af2367da3d0da5e3">00533</a> <a class="code" href="classParallelMesh.php#a70c12ce1edd2d0c5af2367da3d0da5e3">ParallelMesh::local_elements_end</a> ()
<a name="l00534"></a>00534 {
<a name="l00535"></a>00535   <a class="code" href="structPredicates_1_1Local.php">Predicates::Local&lt;elem_iterator_imp&gt;</a> p;
<a name="l00536"></a>00536   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00537"></a>00537 }
<a name="l00538"></a>00538 
<a name="l00539"></a>00539 
<a name="l00540"></a>00540 
<a name="l00541"></a>00541 <span class="comment">// not_local end() accessor</span>
<a name="l00542"></a>00542 ParallelMesh::element_iterator
<a name="l00543"></a><a class="code" href="classParallelMesh.php#aa84e174e2190219edc0e15c12db6bf8d">00543</a> <a class="code" href="classParallelMesh.php#aa84e174e2190219edc0e15c12db6bf8d">ParallelMesh::not_local_elements_end</a> ()
<a name="l00544"></a>00544 {
<a name="l00545"></a>00545   <a class="code" href="structPredicates_1_1NotLocal.php">Predicates::NotLocal&lt;elem_iterator_imp&gt;</a> p;
<a name="l00546"></a>00546   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00547"></a>00547 }
<a name="l00548"></a>00548 
<a name="l00549"></a>00549 
<a name="l00550"></a>00550 
<a name="l00551"></a>00551 <span class="comment">// active local end() accessor</span>
<a name="l00552"></a>00552 ParallelMesh::element_iterator
<a name="l00553"></a><a class="code" href="classParallelMesh.php#a7505f8ccf94a640390308892417a5f49">00553</a> <a class="code" href="classParallelMesh.php#a7505f8ccf94a640390308892417a5f49">ParallelMesh::active_local_elements_end</a> ()
<a name="l00554"></a>00554 {
<a name="l00555"></a>00555   <a class="code" href="structPredicates_1_1ActiveLocal.php">Predicates::ActiveLocal&lt;elem_iterator_imp&gt;</a> p;
<a name="l00556"></a>00556   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00557"></a>00557 }
<a name="l00558"></a>00558 
<a name="l00559"></a>00559 
<a name="l00560"></a>00560 
<a name="l00561"></a>00561 <span class="comment">// not_local end() accessor</span>
<a name="l00562"></a>00562 ParallelMesh::element_iterator
<a name="l00563"></a><a class="code" href="classParallelMesh.php#a36a649c8ff9100fec84023d4e05f71ac">00563</a> <a class="code" href="classParallelMesh.php#a36a649c8ff9100fec84023d4e05f71ac">ParallelMesh::active_not_local_elements_end</a> ()
<a name="l00564"></a>00564 {
<a name="l00565"></a>00565   <a class="code" href="structPredicates_1_1ActiveNotLocal.php">Predicates::ActiveNotLocal&lt;elem_iterator_imp&gt;</a> p;
<a name="l00566"></a>00566   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00567"></a>00567 }
<a name="l00568"></a>00568 
<a name="l00569"></a>00569 
<a name="l00570"></a>00570 
<a name="l00571"></a>00571 <span class="comment">// level end() accessor</span>
<a name="l00572"></a>00572 ParallelMesh::element_iterator
<a name="l00573"></a><a class="code" href="classParallelMesh.php#a41457c8b4b80171696f8fc4ff4f444b9">00573</a> <a class="code" href="classParallelMesh.php#a41457c8b4b80171696f8fc4ff4f444b9">ParallelMesh::level_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)
<a name="l00574"></a>00574 {
<a name="l00575"></a>00575   <a class="code" href="structPredicates_1_1Level.php">Predicates::Level&lt;elem_iterator_imp&gt;</a> p(level);
<a name="l00576"></a>00576   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00577"></a>00577 }
<a name="l00578"></a>00578 
<a name="l00579"></a>00579 
<a name="l00580"></a>00580 
<a name="l00581"></a>00581 <span class="comment">// not level end() accessor</span>
<a name="l00582"></a>00582 ParallelMesh::element_iterator
<a name="l00583"></a><a class="code" href="classParallelMesh.php#ae955bb231a8928cea2dd6bc1353f5193">00583</a> <a class="code" href="classParallelMesh.php#ae955bb231a8928cea2dd6bc1353f5193">ParallelMesh::not_level_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)
<a name="l00584"></a>00584 {
<a name="l00585"></a>00585   <a class="code" href="structPredicates_1_1NotLevel.php">Predicates::NotLevel&lt;elem_iterator_imp&gt;</a> p(level);
<a name="l00586"></a>00586   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00587"></a>00587 }
<a name="l00588"></a>00588 
<a name="l00589"></a>00589 
<a name="l00590"></a>00590 
<a name="l00591"></a>00591 <span class="comment">// local level end() accessor</span>
<a name="l00592"></a>00592 ParallelMesh::element_iterator
<a name="l00593"></a><a class="code" href="classParallelMesh.php#a0b6fc28939ea321936ea2edabb65f1c1">00593</a> <a class="code" href="classParallelMesh.php#a0b6fc28939ea321936ea2edabb65f1c1">ParallelMesh::local_level_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)
<a name="l00594"></a>00594 {
<a name="l00595"></a>00595   <a class="code" href="structPredicates_1_1LocalLevel.php">Predicates::LocalLevel&lt;elem_iterator_imp&gt;</a> p(level);
<a name="l00596"></a>00596   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00597"></a>00597 }
<a name="l00598"></a>00598 
<a name="l00599"></a>00599 
<a name="l00600"></a>00600 
<a name="l00601"></a>00601 <span class="comment">// local not level end() accessor</span>
<a name="l00602"></a>00602 ParallelMesh::element_iterator
<a name="l00603"></a><a class="code" href="classParallelMesh.php#a92cca5e4b0e005ff6528d2e766d70125">00603</a> <a class="code" href="classParallelMesh.php#a92cca5e4b0e005ff6528d2e766d70125">ParallelMesh::local_not_level_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)
<a name="l00604"></a>00604 {
<a name="l00605"></a>00605   <a class="code" href="structPredicates_1_1LocalNotLevel.php">Predicates::LocalNotLevel&lt;elem_iterator_imp&gt;</a> p(level);
<a name="l00606"></a>00606   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00607"></a>00607 }
<a name="l00608"></a>00608 
<a name="l00609"></a>00609 
<a name="l00610"></a>00610 
<a name="l00611"></a>00611 <span class="comment">// pid end() accessor</span>
<a name="l00612"></a>00612 ParallelMesh::element_iterator
<a name="l00613"></a><a class="code" href="classParallelMesh.php#a29ce765858d4135034f6becd8ee5a44d">00613</a> <a class="code" href="classParallelMesh.php#a29ce765858d4135034f6becd8ee5a44d">ParallelMesh::pid_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)
<a name="l00614"></a>00614 {
<a name="l00615"></a>00615   <a class="code" href="structPredicates_1_1PID.php">Predicates::PID&lt;elem_iterator_imp&gt;</a> p(proc_id);
<a name="l00616"></a>00616   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00617"></a>00617 }
<a name="l00618"></a>00618 
<a name="l00619"></a>00619 
<a name="l00620"></a>00620 
<a name="l00621"></a>00621 <span class="comment">// type end() accessor</span>
<a name="l00622"></a>00622 ParallelMesh::element_iterator
<a name="l00623"></a><a class="code" href="classParallelMesh.php#adada4938d90271ed8e1b1d2ce16b5c9c">00623</a> <a class="code" href="classParallelMesh.php#adada4938d90271ed8e1b1d2ce16b5c9c">ParallelMesh::type_elements_end</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)
<a name="l00624"></a>00624 {
<a name="l00625"></a>00625   <a class="code" href="structPredicates_1_1Type.php">Predicates::Type&lt;elem_iterator_imp&gt;</a> p(type);
<a name="l00626"></a>00626   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00627"></a>00627 }
<a name="l00628"></a>00628 
<a name="l00629"></a>00629 
<a name="l00630"></a>00630 
<a name="l00631"></a>00631 <span class="comment">// active type end() accessor</span>
<a name="l00632"></a>00632 ParallelMesh::element_iterator
<a name="l00633"></a><a class="code" href="classParallelMesh.php#ace8c755e61adf67a16d643bd72ecad17">00633</a> <a class="code" href="classParallelMesh.php#ace8c755e61adf67a16d643bd72ecad17">ParallelMesh::active_type_elements_end</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)
<a name="l00634"></a>00634 {
<a name="l00635"></a>00635   <a class="code" href="structPredicates_1_1ActiveType.php">Predicates::ActiveType&lt;elem_iterator_imp&gt;</a> p(type);
<a name="l00636"></a>00636   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00637"></a>00637 }
<a name="l00638"></a>00638 
<a name="l00639"></a>00639 
<a name="l00640"></a>00640 
<a name="l00641"></a>00641 <span class="comment">// active PID end() accessor</span>
<a name="l00642"></a>00642 ParallelMesh::element_iterator
<a name="l00643"></a><a class="code" href="classParallelMesh.php#ac83631fe55f1b418f31db3c4cab3e6c3">00643</a> <a class="code" href="classParallelMesh.php#ac83631fe55f1b418f31db3c4cab3e6c3">ParallelMesh::active_pid_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)
<a name="l00644"></a>00644 {
<a name="l00645"></a>00645   <a class="code" href="structPredicates_1_1ActivePID.php">Predicates::ActivePID&lt;elem_iterator_imp&gt;</a> p(proc_id);
<a name="l00646"></a>00646   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00647"></a>00647 }
<a name="l00648"></a>00648 
<a name="l00649"></a>00649 
<a name="l00650"></a>00650 
<a name="l00651"></a>00651 <span class="comment">// unpartitioned elements end() accessor</span>
<a name="l00652"></a>00652 ParallelMesh::element_iterator
<a name="l00653"></a><a class="code" href="classParallelMesh.php#a147d2a4bda46d2dbeabd972f908525bb">00653</a> <a class="code" href="classParallelMesh.php#a147d2a4bda46d2dbeabd972f908525bb">ParallelMesh::unpartitioned_elements_end</a> ()
<a name="l00654"></a>00654 {
<a name="l00655"></a>00655   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classParallelMesh.php#a29ce765858d4135034f6becd8ee5a44d">pid_elements_end</a>(<a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>);
<a name="l00656"></a>00656 }
<a name="l00657"></a>00657 
<a name="l00658"></a>00658 
<a name="l00659"></a>00659 
<a name="l00660"></a>00660 <span class="comment">// subdomain elements end() accessor</span>
<a name="l00661"></a>00661 ParallelMesh::element_iterator
<a name="l00662"></a><a class="code" href="classParallelMesh.php#a9ca7e83cc9bfb677b8b4877630d91b86">00662</a> <a class="code" href="classParallelMesh.php#a9ca7e83cc9bfb677b8b4877630d91b86">ParallelMesh::active_local_subdomain_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id)
<a name="l00663"></a>00663 {
<a name="l00664"></a>00664   <a class="code" href="structPredicates_1_1ActiveLocalSubdomain.php">Predicates::ActiveLocalSubdomain&lt;elem_iterator_imp&gt;</a> p(subdomain_id);
<a name="l00665"></a>00665   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00666"></a>00666 }
<a name="l00667"></a>00667 
<a name="l00668"></a>00668 
<a name="l00669"></a>00669 
<a name="l00670"></a>00670 
<a name="l00671"></a>00671 
<a name="l00672"></a>00672 
<a name="l00673"></a>00673 
<a name="l00674"></a>00674 
<a name="l00675"></a>00675 
<a name="l00676"></a>00676 <span class="comment">// default const end() accessor</span>
<a name="l00677"></a>00677 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00678"></a><a class="code" href="classParallelMesh.php#a92715ea26d79b2aea62943be73020835">00678</a> <a class="code" href="classParallelMesh.php#a227c5c6ed9dd600b00d4c76f450eeae3">ParallelMesh::elements_end</a> ()<span class="keyword"> const</span>
<a name="l00679"></a>00679 <span class="keyword"></span>{
<a name="l00680"></a>00680   <a class="code" href="structPredicates_1_1NotNull.php">Predicates::NotNull&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00681"></a>00681   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00682"></a>00682 }
<a name="l00683"></a>00683 
<a name="l00684"></a>00684 
<a name="l00685"></a>00685 
<a name="l00686"></a>00686 <span class="comment">// active const end() accessor</span>
<a name="l00687"></a>00687 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00688"></a><a class="code" href="classParallelMesh.php#a2a3ea5dd47485588581e34d27ad50fe3">00688</a> <a class="code" href="classParallelMesh.php#aae426097554ed05956198a6ef04b5189">ParallelMesh::active_elements_end</a> ()<span class="keyword"> const</span>
<a name="l00689"></a>00689 <span class="keyword"></span>{
<a name="l00690"></a>00690   <a class="code" href="structPredicates_1_1Active.php">Predicates::Active&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00691"></a>00691   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00692"></a>00692 }
<a name="l00693"></a>00693 
<a name="l00694"></a>00694 
<a name="l00695"></a>00695 
<a name="l00696"></a>00696 <span class="comment">// not active const end() accessor</span>
<a name="l00697"></a>00697 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00698"></a><a class="code" href="classParallelMesh.php#af83dfacbdeb18d2bb1c7877aa6b24a73">00698</a> <a class="code" href="classParallelMesh.php#a6459eed633c2e15655a9a097bd513618">ParallelMesh::not_active_elements_end</a> ()<span class="keyword"> const</span>
<a name="l00699"></a>00699 <span class="keyword"></span>{
<a name="l00700"></a>00700   <a class="code" href="structPredicates_1_1NotActive.php">Predicates::NotActive&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00701"></a>00701   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00702"></a>00702 }
<a name="l00703"></a>00703 
<a name="l00704"></a>00704 
<a name="l00705"></a>00705 
<a name="l00706"></a>00706 <span class="comment">// ancestor const end() accessor</span>
<a name="l00707"></a>00707 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00708"></a><a class="code" href="classParallelMesh.php#abf58020d1eb141b1bf1b64b852452a21">00708</a> <a class="code" href="classParallelMesh.php#a40b5e29244947c98e99f344c7a2c6b43">ParallelMesh::ancestor_elements_end</a> ()<span class="keyword"> const</span>
<a name="l00709"></a>00709 <span class="keyword"></span>{
<a name="l00710"></a>00710   <a class="code" href="structPredicates_1_1Ancestor.php">Predicates::Ancestor&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00711"></a>00711   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00712"></a>00712 }
<a name="l00713"></a>00713 
<a name="l00714"></a>00714 
<a name="l00715"></a>00715 
<a name="l00716"></a>00716 <span class="comment">// not ancestor const end() accessor</span>
<a name="l00717"></a>00717 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00718"></a><a class="code" href="classParallelMesh.php#a861c12a5f8fade8aa8d76648d7b6f78a">00718</a> <a class="code" href="classParallelMesh.php#a8bacb1a9e4768073add40da965c514f7">ParallelMesh::not_ancestor_elements_end</a> ()<span class="keyword"> const</span>
<a name="l00719"></a>00719 <span class="keyword"></span>{
<a name="l00720"></a>00720   <a class="code" href="structPredicates_1_1Ancestor.php">Predicates::Ancestor&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00721"></a>00721   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00722"></a>00722 }
<a name="l00723"></a>00723 
<a name="l00724"></a>00724 
<a name="l00725"></a>00725 
<a name="l00726"></a>00726 <span class="comment">// subactive const end() accessor</span>
<a name="l00727"></a>00727 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00728"></a><a class="code" href="classParallelMesh.php#aabbeaa267f7ff20658a731a48a86c6dd">00728</a> <a class="code" href="classParallelMesh.php#a66a538d6334a006b2b17126b4cbc2527">ParallelMesh::subactive_elements_end</a> ()<span class="keyword"> const</span>
<a name="l00729"></a>00729 <span class="keyword"></span>{
<a name="l00730"></a>00730   <a class="code" href="structPredicates_1_1SubActive.php">Predicates::SubActive&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00731"></a>00731   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00732"></a>00732 }
<a name="l00733"></a>00733 
<a name="l00734"></a>00734 
<a name="l00735"></a>00735 
<a name="l00736"></a>00736 <span class="comment">// not subactive const end() accessor</span>
<a name="l00737"></a>00737 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00738"></a><a class="code" href="classParallelMesh.php#a5547481c5eb136e5455b9db2967e1ed9">00738</a> <a class="code" href="classParallelMesh.php#a8c69925fbc4de782202c987ee367a741">ParallelMesh::not_subactive_elements_end</a> ()<span class="keyword"> const</span>
<a name="l00739"></a>00739 <span class="keyword"></span>{
<a name="l00740"></a>00740   <a class="code" href="structPredicates_1_1NotSubActive.php">Predicates::NotSubActive&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00741"></a>00741   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00742"></a>00742 }
<a name="l00743"></a>00743 
<a name="l00744"></a>00744 
<a name="l00745"></a>00745 
<a name="l00746"></a>00746 <span class="comment">// local const end() accessor</span>
<a name="l00747"></a>00747 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00748"></a><a class="code" href="classParallelMesh.php#a71a9144802617c6d87ffe5b1a9ffa76e">00748</a> <a class="code" href="classParallelMesh.php#a70c12ce1edd2d0c5af2367da3d0da5e3">ParallelMesh::local_elements_end</a> ()<span class="keyword"> const</span>
<a name="l00749"></a>00749 <span class="keyword"></span>{
<a name="l00750"></a>00750   <a class="code" href="structPredicates_1_1Local.php">Predicates::Local&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00751"></a>00751   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00752"></a>00752 }
<a name="l00753"></a>00753 
<a name="l00754"></a>00754 
<a name="l00755"></a>00755 
<a name="l00756"></a>00756 <span class="comment">// not_local const end() accessor</span>
<a name="l00757"></a>00757 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00758"></a><a class="code" href="classParallelMesh.php#a7ab5e29f65ee7aa6e509dd82cae0db43">00758</a> <a class="code" href="classParallelMesh.php#aa84e174e2190219edc0e15c12db6bf8d">ParallelMesh::not_local_elements_end</a> ()<span class="keyword"> const</span>
<a name="l00759"></a>00759 <span class="keyword"></span>{
<a name="l00760"></a>00760   <a class="code" href="structPredicates_1_1NotLocal.php">Predicates::NotLocal&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00761"></a>00761   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00762"></a>00762 }
<a name="l00763"></a>00763 
<a name="l00764"></a>00764 
<a name="l00765"></a>00765 
<a name="l00766"></a>00766 <span class="comment">// local active const end() accessor</span>
<a name="l00767"></a>00767 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00768"></a><a class="code" href="classParallelMesh.php#a01bca849bf9ffe991f6104f4c4ee4c1f">00768</a> <a class="code" href="classParallelMesh.php#a7505f8ccf94a640390308892417a5f49">ParallelMesh::active_local_elements_end</a> ()<span class="keyword"> const</span>
<a name="l00769"></a>00769 <span class="keyword"></span>{
<a name="l00770"></a>00770   <a class="code" href="structPredicates_1_1ActiveLocal.php">Predicates::ActiveLocal&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00771"></a>00771   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00772"></a>00772 }
<a name="l00773"></a>00773 
<a name="l00774"></a>00774 
<a name="l00775"></a>00775 
<a name="l00776"></a>00776 <span class="comment">// const local active const end() accessor</span>
<a name="l00777"></a>00777 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00778"></a><a class="code" href="classParallelMesh.php#ad28fc4e8d454d24e7d360e12464e3b3d">00778</a> <a class="code" href="classParallelMesh.php#a36a649c8ff9100fec84023d4e05f71ac">ParallelMesh::active_not_local_elements_end</a> ()<span class="keyword"> const</span>
<a name="l00779"></a>00779 <span class="keyword"></span>{
<a name="l00780"></a>00780   <a class="code" href="structPredicates_1_1ActiveNotLocal.php">Predicates::ActiveNotLocal&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00781"></a>00781   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00782"></a>00782 }
<a name="l00783"></a>00783 
<a name="l00784"></a>00784 
<a name="l00785"></a>00785 
<a name="l00786"></a>00786 <span class="comment">// level const end() accessor</span>
<a name="l00787"></a>00787 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00788"></a><a class="code" href="classParallelMesh.php#a7b18a70c4f2fcff87c60359fe4f777d5">00788</a> <a class="code" href="classParallelMesh.php#a41457c8b4b80171696f8fc4ff4f444b9">ParallelMesh::level_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)<span class="keyword"> const</span>
<a name="l00789"></a>00789 <span class="keyword"></span>{
<a name="l00790"></a>00790   <a class="code" href="structPredicates_1_1Level.php">Predicates::Level&lt;const_elem_iterator_imp&gt;</a> p(level);
<a name="l00791"></a>00791   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00792"></a>00792 }
<a name="l00793"></a>00793 
<a name="l00794"></a>00794 
<a name="l00795"></a>00795 
<a name="l00796"></a>00796 <span class="comment">// not level const end() accessor</span>
<a name="l00797"></a>00797 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00798"></a><a class="code" href="classParallelMesh.php#a83e997b9f57243ea79d04d637daa6be6">00798</a> <a class="code" href="classParallelMesh.php#ae955bb231a8928cea2dd6bc1353f5193">ParallelMesh::not_level_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)<span class="keyword"> const</span>
<a name="l00799"></a>00799 <span class="keyword"></span>{
<a name="l00800"></a>00800   <a class="code" href="structPredicates_1_1NotLevel.php">Predicates::NotLevel&lt;const_elem_iterator_imp&gt;</a> p(level);
<a name="l00801"></a>00801   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00802"></a>00802 }
<a name="l00803"></a>00803 
<a name="l00804"></a>00804 
<a name="l00805"></a>00805 
<a name="l00806"></a>00806 <span class="comment">// local level const end() accessor</span>
<a name="l00807"></a>00807 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00808"></a><a class="code" href="classParallelMesh.php#adbcbcca26602a83ffeb596d280114410">00808</a> <a class="code" href="classParallelMesh.php#a0b6fc28939ea321936ea2edabb65f1c1">ParallelMesh::local_level_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)<span class="keyword"> const</span>
<a name="l00809"></a>00809 <span class="keyword"></span>{
<a name="l00810"></a>00810   <a class="code" href="structPredicates_1_1LocalLevel.php">Predicates::LocalLevel&lt;const_elem_iterator_imp&gt;</a> p(level);
<a name="l00811"></a>00811   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00812"></a>00812 }
<a name="l00813"></a>00813 
<a name="l00814"></a>00814 
<a name="l00815"></a>00815 
<a name="l00816"></a>00816 <span class="comment">// local not level const end() accessor</span>
<a name="l00817"></a>00817 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00818"></a><a class="code" href="classParallelMesh.php#acd134ef365490aae467c98954dd98029">00818</a> <a class="code" href="classParallelMesh.php#a92cca5e4b0e005ff6528d2e766d70125">ParallelMesh::local_not_level_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)<span class="keyword"> const</span>
<a name="l00819"></a>00819 <span class="keyword"></span>{
<a name="l00820"></a>00820   <a class="code" href="structPredicates_1_1LocalNotLevel.php">Predicates::LocalNotLevel&lt;const_elem_iterator_imp&gt;</a> p(level);
<a name="l00821"></a>00821   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00822"></a>00822 }
<a name="l00823"></a>00823 
<a name="l00824"></a>00824 
<a name="l00825"></a>00825 <span class="comment">// pid const end() accessor</span>
<a name="l00826"></a>00826 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00827"></a><a class="code" href="classParallelMesh.php#a6d5a65e9a3d38f5c1c03cb39ff903b2a">00827</a> <a class="code" href="classParallelMesh.php#a29ce765858d4135034f6becd8ee5a44d">ParallelMesh::pid_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)<span class="keyword"> const</span>
<a name="l00828"></a>00828 <span class="keyword"></span>{
<a name="l00829"></a>00829   <a class="code" href="structPredicates_1_1PID.php">Predicates::PID&lt;const_elem_iterator_imp&gt;</a> p(proc_id);
<a name="l00830"></a>00830   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00831"></a>00831 }
<a name="l00832"></a>00832 
<a name="l00833"></a>00833 
<a name="l00834"></a>00834 
<a name="l00835"></a>00835 <span class="comment">// type const end() accessor</span>
<a name="l00836"></a>00836 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00837"></a><a class="code" href="classParallelMesh.php#aa8d3abaaceab5f305485232ad4a9a75c">00837</a> <a class="code" href="classParallelMesh.php#adada4938d90271ed8e1b1d2ce16b5c9c">ParallelMesh::type_elements_end</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)<span class="keyword"> const</span>
<a name="l00838"></a>00838 <span class="keyword"></span>{
<a name="l00839"></a>00839   <a class="code" href="structPredicates_1_1Type.php">Predicates::Type&lt;const_elem_iterator_imp&gt;</a> p(type);
<a name="l00840"></a>00840   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00841"></a>00841 }
<a name="l00842"></a>00842 
<a name="l00843"></a>00843 
<a name="l00844"></a>00844 
<a name="l00845"></a>00845 <span class="comment">// active type const end() accessor</span>
<a name="l00846"></a>00846 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00847"></a><a class="code" href="classParallelMesh.php#a222929f4b3f5ea862776261917e0c92c">00847</a> <a class="code" href="classParallelMesh.php#ace8c755e61adf67a16d643bd72ecad17">ParallelMesh::active_type_elements_end</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)<span class="keyword"> const</span>
<a name="l00848"></a>00848 <span class="keyword"></span>{
<a name="l00849"></a>00849   <a class="code" href="structPredicates_1_1ActiveType.php">Predicates::ActiveType&lt;const_elem_iterator_imp&gt;</a> p(type);
<a name="l00850"></a>00850   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00851"></a>00851 }
<a name="l00852"></a>00852 
<a name="l00853"></a>00853 
<a name="l00854"></a>00854 
<a name="l00855"></a>00855 <span class="comment">// active PID end() accessor</span>
<a name="l00856"></a>00856 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00857"></a><a class="code" href="classParallelMesh.php#af92725736ba645360b3780ae4bdf4320">00857</a> <a class="code" href="classParallelMesh.php#ac83631fe55f1b418f31db3c4cab3e6c3">ParallelMesh::active_pid_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)<span class="keyword"> const</span>
<a name="l00858"></a>00858 <span class="keyword"></span>{
<a name="l00859"></a>00859   <a class="code" href="structPredicates_1_1ActivePID.php">Predicates::ActivePID&lt;const_elem_iterator_imp&gt;</a> p(proc_id);
<a name="l00860"></a>00860   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00861"></a>00861 }
<a name="l00862"></a>00862 
<a name="l00863"></a>00863 
<a name="l00864"></a>00864 
<a name="l00865"></a>00865 <span class="comment">// unpartitioned elements end() accessor</span>
<a name="l00866"></a>00866 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00867"></a><a class="code" href="classParallelMesh.php#a484bcf2fda21e64cea89ed29604a6d79">00867</a> <a class="code" href="classParallelMesh.php#a147d2a4bda46d2dbeabd972f908525bb">ParallelMesh::unpartitioned_elements_end</a> ()<span class="keyword"> const</span>
<a name="l00868"></a>00868 <span class="keyword"></span>{
<a name="l00869"></a>00869   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classParallelMesh.php#a29ce765858d4135034f6becd8ee5a44d">pid_elements_end</a>(<a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>);
<a name="l00870"></a>00870 }
<a name="l00871"></a>00871 
<a name="l00872"></a>00872 
<a name="l00873"></a>00873 
<a name="l00874"></a>00874 <span class="comment">// subdomain elements end() accessor</span>
<a name="l00875"></a>00875 <a class="code" href="structMeshBase_1_1const__element__iterator.php">ParallelMesh::const_element_iterator</a>
<a name="l00876"></a><a class="code" href="classParallelMesh.php#a99adcc6902825bfdd2834e8389237117">00876</a> <a class="code" href="classParallelMesh.php#a9ca7e83cc9bfb677b8b4877630d91b86">ParallelMesh::active_local_subdomain_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id)<span class="keyword"> const</span>
<a name="l00877"></a>00877 <span class="keyword"></span>{
<a name="l00878"></a>00878   <a class="code" href="structPredicates_1_1ActiveLocalSubdomain.php">Predicates::ActiveLocalSubdomain&lt;const_elem_iterator_imp&gt;</a> p(subdomain_id);
<a name="l00879"></a>00879   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a589de5efc3000cfc1c94857c37244fa6">_elements</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00880"></a>00880 }
<a name="l00881"></a>00881 
<a name="l00882"></a>00882 
<a name="l00883"></a>00883 
<a name="l00884"></a>00884 
<a name="l00885"></a>00885 
<a name="l00886"></a>00886 
<a name="l00887"></a>00887 
<a name="l00888"></a>00888 <span class="comment">// default nodes begin() accessor</span>
<a name="l00889"></a>00889 ParallelMesh::node_iterator
<a name="l00890"></a><a class="code" href="classParallelMesh.php#a41dc2bb2c80771f68752593a5a27ebdd">00890</a> <a class="code" href="classParallelMesh.php#a41dc2bb2c80771f68752593a5a27ebdd">ParallelMesh::nodes_begin</a> ()
<a name="l00891"></a>00891 {
<a name="l00892"></a>00892   <a class="code" href="structPredicates_1_1NotNull.php">Predicates::NotNull&lt;node_iterator_imp&gt;</a> p;
<a name="l00893"></a>00893   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1node__iterator.php">node_iterator</a>(<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00894"></a>00894 }
<a name="l00895"></a>00895 
<a name="l00896"></a>00896 
<a name="l00897"></a>00897 
<a name="l00898"></a>00898 <span class="comment">// active nodes begin() accessor</span>
<a name="l00899"></a>00899 ParallelMesh::node_iterator
<a name="l00900"></a><a class="code" href="classParallelMesh.php#ab4fd25d514ab88336f8715c0c2dbe8d0">00900</a> <a class="code" href="classParallelMesh.php#ab4fd25d514ab88336f8715c0c2dbe8d0">ParallelMesh::active_nodes_begin</a> ()
<a name="l00901"></a>00901 {
<a name="l00902"></a>00902   <a class="code" href="structPredicates_1_1Active.php">Predicates::Active&lt;node_iterator_imp&gt;</a> p;
<a name="l00903"></a>00903   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1node__iterator.php">node_iterator</a>(<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00904"></a>00904 }
<a name="l00905"></a>00905 
<a name="l00906"></a>00906 
<a name="l00907"></a>00907 
<a name="l00908"></a>00908 <span class="comment">// local nodes begin() accessor</span>
<a name="l00909"></a>00909 ParallelMesh::node_iterator
<a name="l00910"></a><a class="code" href="classParallelMesh.php#a6d946e045e452f81014f878a6c0e3dc0">00910</a> <a class="code" href="classParallelMesh.php#a6d946e045e452f81014f878a6c0e3dc0">ParallelMesh::local_nodes_begin</a> ()
<a name="l00911"></a>00911 {
<a name="l00912"></a>00912   <a class="code" href="structPredicates_1_1Local.php">Predicates::Local&lt;node_iterator_imp&gt;</a> p;
<a name="l00913"></a>00913   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1node__iterator.php">node_iterator</a>(<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00914"></a>00914 }
<a name="l00915"></a>00915 
<a name="l00916"></a>00916 
<a name="l00917"></a>00917 
<a name="l00918"></a>00918 <span class="comment">// pid nodes begin() accessor</span>
<a name="l00919"></a>00919 ParallelMesh::node_iterator
<a name="l00920"></a><a class="code" href="classParallelMesh.php#a848705e1601967c53ad123d7fd55f30e">00920</a> <a class="code" href="classParallelMesh.php#a848705e1601967c53ad123d7fd55f30e">ParallelMesh::pid_nodes_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)
<a name="l00921"></a>00921 {
<a name="l00922"></a>00922   <a class="code" href="structPredicates_1_1PID.php">Predicates::PID&lt;node_iterator_imp&gt;</a> p(proc_id);
<a name="l00923"></a>00923   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1node__iterator.php">node_iterator</a>(<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00924"></a>00924 }
<a name="l00925"></a>00925 
<a name="l00926"></a>00926 
<a name="l00927"></a>00927 
<a name="l00928"></a>00928 <span class="comment">// default const nodes begin() accessor</span>
<a name="l00929"></a>00929 <a class="code" href="structMeshBase_1_1const__node__iterator.php">ParallelMesh::const_node_iterator</a>
<a name="l00930"></a><a class="code" href="classParallelMesh.php#a331f26ab1e7d677c3a2ed8447a1fb63b">00930</a> <a class="code" href="classParallelMesh.php#a41dc2bb2c80771f68752593a5a27ebdd">ParallelMesh::nodes_begin</a> ()<span class="keyword"> const</span>
<a name="l00931"></a>00931 <span class="keyword"></span>{
<a name="l00932"></a>00932   <a class="code" href="structPredicates_1_1NotNull.php">Predicates::NotNull&lt;const_node_iterator_imp&gt;</a> p;
<a name="l00933"></a>00933   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">const_node_iterator</a>(<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00934"></a>00934 }
<a name="l00935"></a>00935 
<a name="l00936"></a>00936 
<a name="l00937"></a>00937 
<a name="l00938"></a>00938 <span class="comment">// active const nodes begin() accessor</span>
<a name="l00939"></a>00939 <a class="code" href="structMeshBase_1_1const__node__iterator.php">ParallelMesh::const_node_iterator</a>
<a name="l00940"></a><a class="code" href="classParallelMesh.php#a54858a6e7200b253c129e77bb2b48321">00940</a> <a class="code" href="classParallelMesh.php#ab4fd25d514ab88336f8715c0c2dbe8d0">ParallelMesh::active_nodes_begin</a> ()<span class="keyword"> const</span>
<a name="l00941"></a>00941 <span class="keyword"></span>{
<a name="l00942"></a>00942   <a class="code" href="structPredicates_1_1Active.php">Predicates::Active&lt;const_node_iterator_imp&gt;</a> p;
<a name="l00943"></a>00943   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">const_node_iterator</a>(<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00944"></a>00944 }
<a name="l00945"></a>00945 
<a name="l00946"></a>00946 
<a name="l00947"></a>00947 
<a name="l00948"></a>00948 <span class="comment">// local const nodes begin() accessor</span>
<a name="l00949"></a>00949 <a class="code" href="structMeshBase_1_1const__node__iterator.php">ParallelMesh::const_node_iterator</a>
<a name="l00950"></a><a class="code" href="classParallelMesh.php#ac42b36a775a258bde411e288051ea8f8">00950</a> <a class="code" href="classParallelMesh.php#a6d946e045e452f81014f878a6c0e3dc0">ParallelMesh::local_nodes_begin</a> ()<span class="keyword"> const</span>
<a name="l00951"></a>00951 <span class="keyword"></span>{
<a name="l00952"></a>00952   <a class="code" href="structPredicates_1_1Local.php">Predicates::Local&lt;const_node_iterator_imp&gt;</a> p;
<a name="l00953"></a>00953   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">const_node_iterator</a>(<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00954"></a>00954 }
<a name="l00955"></a>00955 
<a name="l00956"></a>00956 
<a name="l00957"></a>00957 
<a name="l00958"></a>00958 <span class="comment">// pid const nodes begin() accessor</span>
<a name="l00959"></a>00959 <a class="code" href="structMeshBase_1_1const__node__iterator.php">ParallelMesh::const_node_iterator</a>
<a name="l00960"></a><a class="code" href="classParallelMesh.php#a3171124c377017cb698affd098910436">00960</a> <a class="code" href="classParallelMesh.php#a848705e1601967c53ad123d7fd55f30e">ParallelMesh::pid_nodes_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)<span class="keyword"> const</span>
<a name="l00961"></a>00961 <span class="keyword"></span>{
<a name="l00962"></a>00962   <a class="code" href="structPredicates_1_1PID.php">Predicates::PID&lt;const_node_iterator_imp&gt;</a> p(proc_id);
<a name="l00963"></a>00963   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">const_node_iterator</a>(<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(), <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00964"></a>00964 }
<a name="l00965"></a>00965 
<a name="l00966"></a>00966 
<a name="l00967"></a>00967 
<a name="l00968"></a>00968 <span class="comment">// default nodes end() accessor</span>
<a name="l00969"></a>00969 ParallelMesh::node_iterator
<a name="l00970"></a><a class="code" href="classParallelMesh.php#ac4ccc2b31dfaf51efd64dc1d0baead0c">00970</a> <a class="code" href="classParallelMesh.php#ac4ccc2b31dfaf51efd64dc1d0baead0c">ParallelMesh::nodes_end</a> ()
<a name="l00971"></a>00971 {
<a name="l00972"></a>00972   <a class="code" href="structPredicates_1_1NotNull.php">Predicates::NotNull&lt;node_iterator_imp&gt;</a> p;
<a name="l00973"></a>00973   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1node__iterator.php">node_iterator</a>(<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00974"></a>00974 }
<a name="l00975"></a>00975 
<a name="l00976"></a>00976 
<a name="l00977"></a>00977 
<a name="l00978"></a>00978 <span class="comment">// active nodes end() accessor</span>
<a name="l00979"></a>00979 ParallelMesh::node_iterator
<a name="l00980"></a><a class="code" href="classParallelMesh.php#a7c030873eb732981d3fd4c8733f19685">00980</a> <a class="code" href="classParallelMesh.php#a7c030873eb732981d3fd4c8733f19685">ParallelMesh::active_nodes_end</a> ()
<a name="l00981"></a>00981 {
<a name="l00982"></a>00982   <a class="code" href="structPredicates_1_1Active.php">Predicates::Active&lt;node_iterator_imp&gt;</a> p;
<a name="l00983"></a>00983   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1node__iterator.php">node_iterator</a>(<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00984"></a>00984 }
<a name="l00985"></a>00985 
<a name="l00986"></a>00986 
<a name="l00987"></a>00987 
<a name="l00988"></a>00988 <span class="comment">// local nodes end() accessor</span>
<a name="l00989"></a>00989 ParallelMesh::node_iterator
<a name="l00990"></a><a class="code" href="classParallelMesh.php#aea43c4aa5e1717506724d63551de946c">00990</a> <a class="code" href="classParallelMesh.php#aea43c4aa5e1717506724d63551de946c">ParallelMesh::local_nodes_end</a> ()
<a name="l00991"></a>00991 {
<a name="l00992"></a>00992   <a class="code" href="structPredicates_1_1Local.php">Predicates::Local&lt;node_iterator_imp&gt;</a> p;
<a name="l00993"></a>00993   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1node__iterator.php">node_iterator</a>(<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l00994"></a>00994 }
<a name="l00995"></a>00995 
<a name="l00996"></a>00996 
<a name="l00997"></a>00997 
<a name="l00998"></a>00998 <span class="comment">// pid nodes end() accessor</span>
<a name="l00999"></a>00999 ParallelMesh::node_iterator
<a name="l01000"></a><a class="code" href="classParallelMesh.php#a5df791650531a9743dfad56befbf8041">01000</a> <a class="code" href="classParallelMesh.php#a5df791650531a9743dfad56befbf8041">ParallelMesh::pid_nodes_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)
<a name="l01001"></a>01001 {
<a name="l01002"></a>01002   <a class="code" href="structPredicates_1_1PID.php">Predicates::PID&lt;node_iterator_imp&gt;</a> p(proc_id);
<a name="l01003"></a>01003   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1node__iterator.php">node_iterator</a>(<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l01004"></a>01004 }
<a name="l01005"></a>01005 
<a name="l01006"></a>01006 
<a name="l01007"></a>01007 
<a name="l01008"></a>01008 <span class="comment">// default const nodes end() accessor</span>
<a name="l01009"></a>01009 <a class="code" href="structMeshBase_1_1const__node__iterator.php">ParallelMesh::const_node_iterator</a>
<a name="l01010"></a><a class="code" href="classParallelMesh.php#abb77654e6f046466292ec76ae4c2d3e9">01010</a> <a class="code" href="classParallelMesh.php#ac4ccc2b31dfaf51efd64dc1d0baead0c">ParallelMesh::nodes_end</a> ()<span class="keyword"> const</span>
<a name="l01011"></a>01011 <span class="keyword"></span>{
<a name="l01012"></a>01012   <a class="code" href="structPredicates_1_1NotNull.php">Predicates::NotNull&lt;const_node_iterator_imp&gt;</a> p;
<a name="l01013"></a>01013   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">const_node_iterator</a>(<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l01014"></a>01014 }
<a name="l01015"></a>01015 
<a name="l01016"></a>01016 
<a name="l01017"></a>01017 
<a name="l01018"></a>01018 <span class="comment">// const active nodes end() accessor</span>
<a name="l01019"></a>01019 <a class="code" href="structMeshBase_1_1const__node__iterator.php">ParallelMesh::const_node_iterator</a>
<a name="l01020"></a><a class="code" href="classParallelMesh.php#ac9e5e6a783a8382b6b77769a2b1522b5">01020</a> <a class="code" href="classParallelMesh.php#a7c030873eb732981d3fd4c8733f19685">ParallelMesh::active_nodes_end</a> ()<span class="keyword"> const</span>
<a name="l01021"></a>01021 <span class="keyword"></span>{
<a name="l01022"></a>01022   <a class="code" href="structPredicates_1_1Active.php">Predicates::Active&lt;const_node_iterator_imp&gt;</a> p;
<a name="l01023"></a>01023   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">const_node_iterator</a>(<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l01024"></a>01024 }
<a name="l01025"></a>01025 
<a name="l01026"></a>01026 
<a name="l01027"></a>01027 
<a name="l01028"></a>01028 <span class="comment">// local const nodes end() accessor</span>
<a name="l01029"></a>01029 <a class="code" href="structMeshBase_1_1const__node__iterator.php">ParallelMesh::const_node_iterator</a>
<a name="l01030"></a><a class="code" href="classParallelMesh.php#ac7fb87dc6f523dda207a3660a0120dfc">01030</a> <a class="code" href="classParallelMesh.php#aea43c4aa5e1717506724d63551de946c">ParallelMesh::local_nodes_end</a> ()<span class="keyword"> const</span>
<a name="l01031"></a>01031 <span class="keyword"></span>{
<a name="l01032"></a>01032   <a class="code" href="structPredicates_1_1Local.php">Predicates::Local&lt;const_node_iterator_imp&gt;</a> p;
<a name="l01033"></a>01033   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">const_node_iterator</a>(<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l01034"></a>01034 }
<a name="l01035"></a>01035 
<a name="l01036"></a>01036 
<a name="l01037"></a>01037 
<a name="l01038"></a>01038 <span class="comment">// pid const nodes end() accessor</span>
<a name="l01039"></a>01039 <a class="code" href="structMeshBase_1_1const__node__iterator.php">ParallelMesh::const_node_iterator</a>
<a name="l01040"></a><a class="code" href="classParallelMesh.php#a0f5813ab07dbe303eb458c82dd3abb75">01040</a> <a class="code" href="classParallelMesh.php#a5df791650531a9743dfad56befbf8041">ParallelMesh::pid_nodes_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)<span class="keyword"> const</span>
<a name="l01041"></a>01041 <span class="keyword"></span>{
<a name="l01042"></a>01042   <a class="code" href="structPredicates_1_1PID.php">Predicates::PID&lt;const_node_iterator_imp&gt;</a> p(proc_id);
<a name="l01043"></a>01043   <span class="keywordflow">return</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">const_node_iterator</a>(<a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), <a class="code" href="classParallelMesh.php#a24ee2ef5c854badf46bb366dad014436">_nodes</a>.<a class="code" href="classmapvector.php#a15afca216def803488c97deed4f9fad3">end</a>(), p);
<a name="l01044"></a>01044 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
