<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_68b326994b1686b0c255607250545e3c.php">parallel</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>parallel_sort.h</h1>  </div>
</div>
<div class="contents">
<a href="parallel__sort_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: parallel_sort.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __parallel_sort_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __parallel_sort_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// System Includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>Parallel
<a name="l00033"></a>00033 {
<a name="l00045"></a>00045 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00046"></a><a class="code" href="classParallel_1_1Sort.php">00046</a> <span class="keyword">class </span><a class="code" href="classParallel_1_1Sort.php">Sort</a>
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048 <span class="keyword">public</span>:
<a name="l00057"></a>00057   <a class="code" href="classParallel_1_1Sort.php#a699ab5fbc79ea76e59d544d420445162">Sort</a> (std::vector&lt;KeyType&gt;&amp; d,
<a name="l00058"></a>00058         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_procs = <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(),
<a name="l00059"></a>00059         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id = <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>());
<a name="l00060"></a>00060                 
<a name="l00061"></a>00061 
<a name="l00068"></a>00068   <span class="keywordtype">void</span> <a class="code" href="classParallel_1_1Sort.php#a8235a11b7719d98b4c519eb08c79645b">sort</a>();
<a name="l00069"></a>00069   
<a name="l00075"></a>00075   <span class="keyword">const</span> std::vector&lt;KeyType&gt;&amp; <a class="code" href="classParallel_1_1Sort.php#a1a0f9a671643c99647e04e01a69befe0">bin</a>();
<a name="l00076"></a>00076   
<a name="l00077"></a>00077 <span class="keyword">private</span>:
<a name="l00078"></a>00078 
<a name="l00082"></a><a class="code" href="classParallel_1_1Sort.php#a2e336fda3f5c1bc3aed24b2eb443334b">00082</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallel_1_1Sort.php#a2e336fda3f5c1bc3aed24b2eb443334b">_n_procs</a>;
<a name="l00083"></a>00083 
<a name="l00087"></a><a class="code" href="classParallel_1_1Sort.php#a19237eae56b639ec1240f87c783128e6">00087</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParallel_1_1Sort.php#a19237eae56b639ec1240f87c783128e6">_proc_id</a>;
<a name="l00088"></a>00088 
<a name="l00092"></a><a class="code" href="classParallel_1_1Sort.php#a3f2050e89a4433d55b00256ccaaffa6f">00092</a>   <span class="keywordtype">bool</span> <a class="code" href="classParallel_1_1Sort.php#a3f2050e89a4433d55b00256ccaaffa6f">_bin_is_sorted</a>;
<a name="l00093"></a>00093   
<a name="l00099"></a><a class="code" href="classParallel_1_1Sort.php#a0c40cace4f915f858222dcba2c1ca06d">00099</a>   std::vector&lt;KeyType&gt;&amp; <a class="code" href="classParallel_1_1Sort.php#a0c40cace4f915f858222dcba2c1ca06d">_data</a>;
<a name="l00100"></a>00100 
<a name="l00106"></a><a class="code" href="classParallel_1_1Sort.php#aefecc197661e9b4a01064cdfbbca5074">00106</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classParallel_1_1Sort.php#aefecc197661e9b4a01064cdfbbca5074">_local_bin_sizes</a>;
<a name="l00107"></a>00107   
<a name="l00114"></a><a class="code" href="classParallel_1_1Sort.php#ad3e20857bc548f910c00f081729b7f73">00114</a>   std::vector&lt;KeyType&gt; <a class="code" href="classParallel_1_1Sort.php#ad3e20857bc548f910c00f081729b7f73">_my_bin</a>;
<a name="l00115"></a>00115 
<a name="l00121"></a>00121   <span class="keywordtype">void</span> <a class="code" href="classParallel_1_1Sort.php#a617a9aae5f42352db65b81dd0c761a14">binsort</a> ();
<a name="l00122"></a>00122 
<a name="l00129"></a>00129   <span class="keywordtype">void</span> <a class="code" href="classParallel_1_1Sort.php#af157db39a4f48984c4f874243b7d9b3c">communicate_bins</a>();
<a name="l00130"></a>00130 
<a name="l00136"></a>00136   <span class="keywordtype">void</span> <a class="code" href="classParallel_1_1Sort.php#aa148cec5fe28cce1f52c9bf05cbdce9e">sort_local_bin</a>();
<a name="l00137"></a>00137   
<a name="l00138"></a>00138 };
<a name="l00139"></a>00139 }
<a name="l00140"></a>00140 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
