<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_4f64d75cac7489d141591c33108e86ff.php">utils</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>parameters.h</h1>  </div>
</div>
<div class="contents">
<a href="parameters_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: parameters.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __parameters_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __parameters_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;typeinfo&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;reference_counted_object.h&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00047"></a>00047 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00048"></a>00048 <span class="comment">// Parameters class definition</span>
<a name="l00049"></a><a class="code" href="classParameters.php">00049</a> <span class="keyword">class </span><a class="code" href="classParameters.php">Parameters</a> 
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 <span class="keyword">public</span>:
<a name="l00052"></a>00052 
<a name="l00056"></a><a class="code" href="classParameters.php#af4d94ee360ac0157d9065f78797fe9a1">00056</a>   <a class="code" href="classParameters.php#af4d94ee360ac0157d9065f78797fe9a1">Parameters</a> () {};
<a name="l00057"></a>00057 
<a name="l00061"></a>00061   <a class="code" href="classParameters.php#af4d94ee360ac0157d9065f78797fe9a1">Parameters</a> (<span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp;);
<a name="l00062"></a>00062 
<a name="l00066"></a>00066   <a class="code" href="classParameters.php#a640a1a349975a8cb023696f25e563a5c">~Parameters</a> ();
<a name="l00067"></a>00067 
<a name="l00071"></a>00071   <a class="code" href="classParameters.php">Parameters</a>&amp; <a class="code" href="classParameters.php#ae0e7fb7e74a71438edfdd8c605080395">operator= </a>(<span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp;);
<a name="l00072"></a>00072   
<a name="l00077"></a>00077   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00078"></a>00078   <span class="keywordtype">bool</span> <a class="code" href="classParameters.php#a20587dd7120a79624ebc7095aea0390c">have_parameter</a> (<span class="keyword">const</span> std::string&amp;) <span class="keyword">const</span>;
<a name="l00079"></a>00079 
<a name="l00084"></a>00084   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00085"></a>00085   <span class="keyword">const</span> T&amp; <span class="keyword">get</span> (<span class="keyword">const</span> std::string&amp;) <span class="keyword">const</span>;
<a name="l00086"></a>00086 
<a name="l00093"></a>00093   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00094"></a>00094   T&amp; <span class="keyword">set</span> (<span class="keyword">const</span> std::string&amp;);
<a name="l00095"></a>00095 
<a name="l00099"></a>00099   <span class="keywordtype">void</span> <span class="keyword">remove</span> (<span class="keyword">const</span> std::string&amp;);
<a name="l00100"></a>00100 
<a name="l00104"></a><a class="code" href="classParameters.php#a792118f15e3df73d3735e137d0f354ee">00104</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParameters.php#a792118f15e3df73d3735e137d0f354ee">n_parameters</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">_values</a>.size(); }
<a name="l00105"></a>00105 
<a name="l00109"></a>00109   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00110"></a>00110   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParameters.php#a792118f15e3df73d3735e137d0f354ee">n_parameters</a> () <span class="keyword">const</span>;
<a name="l00111"></a>00111   
<a name="l00115"></a>00115   <span class="keywordtype">void</span> <a class="code" href="classParameters.php#a9d44875d9fa9f8569d56673e8344279d">clear</a> ();
<a name="l00116"></a>00116 
<a name="l00120"></a>00120   <span class="keywordtype">void</span> <a class="code" href="classParameters.php#a068b7dcca9d186c6d28701f30e70fb48">print</a> (std::ostream&amp; os=std::cout) <span class="keyword">const</span>;
<a name="l00121"></a>00121   
<a name="l00122"></a>00122 <span class="keyword">private</span>:
<a name="l00123"></a>00123 
<a name="l00127"></a><a class="code" href="classParameters_1_1Value.php">00127</a>   <span class="keyword">class </span><a class="code" href="classParameters_1_1Value.php">Value</a> : <span class="keyword">public</span> <a class="code" href="classReferenceCountedObject.php">ReferenceCountedObject</a>&lt;Value&gt;
<a name="l00128"></a>00128   {
<a name="l00129"></a>00129   <span class="keyword">public</span>:
<a name="l00130"></a>00130 
<a name="l00134"></a><a class="code" href="classParameters_1_1Value.php#ac51be9ed0406d2b5647bcea28af49d08">00134</a>     <span class="keyword">virtual</span> <a class="code" href="classParameters_1_1Value.php#ac51be9ed0406d2b5647bcea28af49d08">~Value</a>() {};
<a name="l00135"></a>00135 
<a name="l00140"></a>00140     <span class="keyword">virtual</span> std::string <a class="code" href="classParameters_1_1Value.php#a4e06ad62ac02f758b810b224b8cc1ffe">type</a> () <span class="keyword">const</span> = 0;
<a name="l00141"></a>00141 
<a name="l00146"></a>00146     <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classParameters_1_1Value.php#afd53c742fee60fb3e58755c3f555e868">print</a>(std::ostream&amp;) <span class="keyword">const</span> = 0;
<a name="l00147"></a>00147 
<a name="l00152"></a>00152     <span class="keyword">virtual</span> <a class="code" href="classParameters_1_1Value.php">Value</a>* <a class="code" href="classParameters_1_1Value.php#abcd0b762625ff28c2aad3c9ed09741b5">clone</a> () <span class="keyword">const</span> = 0;
<a name="l00153"></a>00153   };
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 <span class="keyword">public</span>:
<a name="l00156"></a>00156 
<a name="l00161"></a>00161   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00162"></a><a class="code" href="classParameters_1_1Parameter.php">00162</a>   <span class="keyword">class </span><a class="code" href="classParameters_1_1Parameter.php">Parameter</a> : <span class="keyword">public</span> <a class="code" href="classParameters_1_1Value.php">Value</a>
<a name="l00163"></a>00163   {
<a name="l00164"></a>00164   <span class="keyword">public</span>:
<a name="l00165"></a>00165 
<a name="l00169"></a><a class="code" href="classParameters_1_1Parameter.php#a9408478db249ae2a8bd92d894be39b32">00169</a>     <span class="keyword">const</span> T&amp; <span class="keyword">get</span> () <span class="keyword">const</span> { <span class="keywordflow">return</span> <a class="code" href="classParameters_1_1Parameter.php#a1723a186580a0a039d68587dc4f04ca2">_value</a>; }
<a name="l00170"></a>00170     
<a name="l00174"></a><a class="code" href="classParameters_1_1Parameter.php#a3fe26b7a22592efc09733b9c4b5d016d">00174</a>     T&amp; <span class="keyword">set</span> () { <span class="keywordflow">return</span> <a class="code" href="classParameters_1_1Parameter.php#a1723a186580a0a039d68587dc4f04ca2">_value</a>; }
<a name="l00175"></a>00175 
<a name="l00179"></a>00179     <span class="keyword">virtual</span> std::string <a class="code" href="classParameters_1_1Parameter.php#aa0a761fded4037f06f20faa35a412325">type</a> () <span class="keyword">const</span>;
<a name="l00180"></a>00180 
<a name="l00184"></a>00184     <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classParameters_1_1Parameter.php#ae2679349967d9c7e4ce52bd0a68b72a0">print</a>(std::ostream&amp;) <span class="keyword">const</span>;
<a name="l00185"></a>00185 
<a name="l00189"></a>00189     <span class="keyword">virtual</span> <a class="code" href="classParameters_1_1Value.php">Value</a>* <a class="code" href="classParameters_1_1Parameter.php#a27567af3d257d3d64d751ed6b6b4d480">clone</a> () <span class="keyword">const</span>; 
<a name="l00190"></a>00190     
<a name="l00191"></a>00191   <span class="keyword">private</span>:
<a name="l00192"></a>00192 
<a name="l00196"></a><a class="code" href="classParameters_1_1Parameter.php#a1723a186580a0a039d68587dc4f04ca2">00196</a>     T <a class="code" href="classParameters_1_1Parameter.php#a1723a186580a0a039d68587dc4f04ca2">_value</a>;
<a name="l00197"></a>00197   };
<a name="l00198"></a>00198 
<a name="l00202"></a><a class="code" href="classParameters.php#a2d552339af565bf653c5cafca5b4e156">00202</a>   <span class="keyword">typedef</span> std::map&lt;std::string, Value*&gt;::iterator <a class="code" href="classParameters.php#a2d552339af565bf653c5cafca5b4e156">iterator</a>;
<a name="l00203"></a>00203 
<a name="l00207"></a><a class="code" href="classParameters.php#a9981db459a2169b2ac312d10e9ec0f64">00207</a>   <span class="keyword">typedef</span> std::map&lt;std::string, Value*&gt;::const_iterator <a class="code" href="classParameters.php#a9981db459a2169b2ac312d10e9ec0f64">const_iterator</a>;
<a name="l00208"></a>00208 
<a name="l00212"></a>00212   <a class="code" href="classParameters.php#a2d552339af565bf653c5cafca5b4e156">iterator</a> <a class="code" href="classParameters.php#a4b8c6b7062523872a9286ce70fa59252">begin</a>();
<a name="l00213"></a>00213 
<a name="l00217"></a>00217   <a class="code" href="classParameters.php#a9981db459a2169b2ac312d10e9ec0f64">const_iterator</a> <a class="code" href="classParameters.php#a4b8c6b7062523872a9286ce70fa59252">begin</a>() <span class="keyword">const</span>;
<a name="l00218"></a>00218 
<a name="l00222"></a>00222   <a class="code" href="classParameters.php#a2d552339af565bf653c5cafca5b4e156">iterator</a> <a class="code" href="classParameters.php#a249b5c11a1da0cc4691dbe9feff9c280">end</a>();
<a name="l00223"></a>00223 
<a name="l00227"></a>00227   <a class="code" href="classParameters.php#a9981db459a2169b2ac312d10e9ec0f64">const_iterator</a> <a class="code" href="classParameters.php#a249b5c11a1da0cc4691dbe9feff9c280">end</a>() <span class="keyword">const</span>;
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 <span class="keyword">private</span>:
<a name="l00230"></a>00230 
<a name="l00234"></a><a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">00234</a>   std::map&lt;std::string, Value*&gt; <a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">_values</a>;
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 };
<a name="l00237"></a>00237 
<a name="l00238"></a>00238 
<a name="l00239"></a>00239 
<a name="l00240"></a>00240 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00241"></a>00241 <span class="comment">// Parameters::Parameter&lt;&gt; class inline methods</span>
<a name="l00242"></a>00242 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00243"></a>00243 <span class="keyword">inline</span>
<a name="l00244"></a><a class="code" href="classParameters_1_1Parameter.php#aa0a761fded4037f06f20faa35a412325">00244</a> std::string <a class="code" href="classParameters_1_1Parameter.php#aa0a761fded4037f06f20faa35a412325">Parameters::Parameter&lt;T&gt;::type</a> ()<span class="keyword"> const</span>
<a name="l00245"></a>00245 <span class="keyword"></span>{
<a name="l00246"></a>00246   <span class="keywordflow">return</span> <span class="keyword">typeid</span>(T).<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>();
<a name="l00247"></a>00247 }
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 
<a name="l00250"></a>00250 
<a name="l00251"></a>00251 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00252"></a>00252 <span class="keyword">inline</span>
<a name="l00253"></a><a class="code" href="classParameters_1_1Parameter.php#ae2679349967d9c7e4ce52bd0a68b72a0">00253</a> <span class="keywordtype">void</span> <a class="code" href="classParameters_1_1Parameter.php#ae2679349967d9c7e4ce52bd0a68b72a0">Parameters::Parameter&lt;T&gt;::print</a> (std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00254"></a>00254 <span class="keyword"></span>{
<a name="l00255"></a>00255   os &lt;&lt; _value;
<a name="l00256"></a>00256 }
<a name="l00257"></a>00257 
<a name="l00258"></a>00258 
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00261"></a>00261 <span class="keyword">inline</span>
<a name="l00262"></a><a class="code" href="classParameters_1_1Parameter.php#a27567af3d257d3d64d751ed6b6b4d480">00262</a> <a class="code" href="classParameters_1_1Value.php">Parameters::Value</a>* <a class="code" href="classParameters_1_1Parameter.php#a27567af3d257d3d64d751ed6b6b4d480">Parameters::Parameter&lt;T&gt;::clone</a> ()<span class="keyword"> const</span>
<a name="l00263"></a>00263 <span class="keyword"></span>{
<a name="l00264"></a>00264   <span class="comment">// No good for Solaris C++! - BSK</span>
<a name="l00265"></a>00265 <span class="comment">//  Parameters::Parameter&lt;T&gt;</span>
<a name="l00266"></a>00266 <span class="comment">//    *copy = new Parameters::Parameter&lt;T&gt;;</span>
<a name="l00267"></a>00267   <a class="code" href="classParameters_1_1Parameter.php">Parameter&lt;T&gt;</a>
<a name="l00268"></a>00268     *copy = <span class="keyword">new</span> <a class="code" href="classParameters_1_1Parameter.php">Parameter&lt;T&gt;</a>;
<a name="l00269"></a>00269 
<a name="l00270"></a>00270   libmesh_assert (copy != NULL);
<a name="l00271"></a>00271   
<a name="l00272"></a>00272   copy-&gt;<a class="code" href="classParameters_1_1Parameter.php#a1723a186580a0a039d68587dc4f04ca2">_value</a> = _value;
<a name="l00273"></a>00273 
<a name="l00274"></a>00274   <span class="keywordflow">return</span> copy;
<a name="l00275"></a>00275 }
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 
<a name="l00278"></a>00278 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00279"></a>00279 <span class="comment">// Parameters class inline methods</span>
<a name="l00280"></a>00280 <span class="keyword">inline</span>
<a name="l00281"></a><a class="code" href="classParameters.php#a9d44875d9fa9f8569d56673e8344279d">00281</a> <span class="keywordtype">void</span> <a class="code" href="classParameters.php#a9d44875d9fa9f8569d56673e8344279d">Parameters::clear</a> () <span class="comment">// since this is inline we must define it</span>
<a name="l00282"></a>00282 {                         <span class="comment">// before its first use (for some compilers)</span>
<a name="l00283"></a>00283   <span class="keywordflow">while</span> (!<a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">_values</a>.empty())
<a name="l00284"></a>00284     {
<a name="l00285"></a>00285       <a class="code" href="classParameters.php#a2d552339af565bf653c5cafca5b4e156">Parameters::iterator</a> it = <a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">_values</a>.begin();
<a name="l00286"></a>00286       
<a name="l00287"></a>00287       <span class="keyword">delete</span> it-&gt;second;      
<a name="l00288"></a>00288       it-&gt;second = NULL;
<a name="l00289"></a>00289       
<a name="l00290"></a>00290       <a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">_values</a>.erase(it);
<a name="l00291"></a>00291     }
<a name="l00292"></a>00292 }
<a name="l00293"></a>00293 
<a name="l00294"></a>00294 
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 <span class="keyword">inline</span>
<a name="l00297"></a><a class="code" href="classParameters.php#ae0e7fb7e74a71438edfdd8c605080395">00297</a> <a class="code" href="classParameters.php">Parameters</a>&amp; <a class="code" href="classParameters.php#ae0e7fb7e74a71438edfdd8c605080395">Parameters::operator= </a>(<span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; rhs)
<a name="l00298"></a>00298 {
<a name="l00299"></a>00299   this-&gt;<a class="code" href="classParameters.php#a9d44875d9fa9f8569d56673e8344279d">clear</a>();
<a name="l00300"></a>00300   
<a name="l00301"></a>00301   <span class="keywordflow">for</span> (<a class="code" href="classParameters.php#a9981db459a2169b2ac312d10e9ec0f64">Parameters::const_iterator</a> it = rhs.<a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">_values</a>.begin();
<a name="l00302"></a>00302        it != rhs.<a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">_values</a>.end(); ++it)
<a name="l00303"></a>00303     <a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">_values</a>[it-&gt;first] = it-&gt;second-&gt;clone();
<a name="l00304"></a>00304   
<a name="l00305"></a>00305   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00306"></a>00306 }
<a name="l00307"></a>00307 
<a name="l00308"></a>00308 
<a name="l00309"></a>00309 
<a name="l00310"></a>00310 <span class="keyword">inline</span>
<a name="l00311"></a><a class="code" href="classParameters.php#ac9f0de01233484fa2866ec1b698145bb">00311</a> <a class="code" href="classParameters.php#af4d94ee360ac0157d9065f78797fe9a1">Parameters::Parameters</a> (<span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; p)
<a name="l00312"></a>00312 {
<a name="l00313"></a>00313   *<span class="keyword">this</span> = p;
<a name="l00314"></a>00314 }
<a name="l00315"></a>00315 
<a name="l00316"></a>00316 
<a name="l00317"></a>00317 
<a name="l00318"></a>00318 <span class="keyword">inline</span>
<a name="l00319"></a><a class="code" href="classParameters.php#a640a1a349975a8cb023696f25e563a5c">00319</a> <a class="code" href="classParameters.php#a640a1a349975a8cb023696f25e563a5c">Parameters::~Parameters</a> ()
<a name="l00320"></a>00320 {
<a name="l00321"></a>00321   this-&gt;<a class="code" href="classParameters.php#a9d44875d9fa9f8569d56673e8344279d">clear</a> ();
<a name="l00322"></a>00322 }
<a name="l00323"></a>00323 
<a name="l00324"></a>00324 
<a name="l00325"></a>00325 
<a name="l00326"></a>00326 <span class="keyword">inline</span>
<a name="l00327"></a><a class="code" href="classParameters.php#a068b7dcca9d186c6d28701f30e70fb48">00327</a> <span class="keywordtype">void</span> <a class="code" href="classParameters.php#a068b7dcca9d186c6d28701f30e70fb48">Parameters::print</a> (std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00328"></a>00328 <span class="keyword"></span>{
<a name="l00329"></a>00329   <a class="code" href="classParameters.php#a9981db459a2169b2ac312d10e9ec0f64">Parameters::const_iterator</a> it = <a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">_values</a>.begin();
<a name="l00330"></a>00330 
<a name="l00331"></a>00331   os &lt;&lt; <span class="stringliteral">&quot;Name\t Type\t Value\n&quot;</span>
<a name="l00332"></a>00332      &lt;&lt; <span class="stringliteral">&quot;---------------------\n&quot;</span>;
<a name="l00333"></a>00333   <span class="keywordflow">while</span> (it != <a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">_values</a>.end())
<a name="l00334"></a>00334     {
<a name="l00335"></a>00335       os &lt;&lt; <span class="stringliteral">&quot; &quot;</span>   &lt;&lt; it-&gt;first
<a name="l00336"></a>00336          &lt;&lt; <span class="stringliteral">&quot;\t &quot;</span> &lt;&lt; it-&gt;second-&gt;type()
<a name="l00337"></a>00337          &lt;&lt; <span class="stringliteral">&quot;\t &quot;</span>;   it-&gt;second-&gt;print(os);      
<a name="l00338"></a>00338       os &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00339"></a>00339 
<a name="l00340"></a>00340       ++it;
<a name="l00341"></a>00341     }
<a name="l00342"></a>00342 }
<a name="l00343"></a>00343 
<a name="l00344"></a>00344 
<a name="l00345"></a>00345 
<a name="l00346"></a>00346 <span class="comment">// Declare this now that Paramers::print() is defined.</span>
<a name="l00347"></a>00347 <span class="comment">// By declaring this early we can use it in subsequent</span>
<a name="l00348"></a>00348 <span class="comment">// methods.  Required for gcc-4.0.2 -- 11/30/2005, BSK</span>
<a name="l00349"></a>00349 <span class="keyword">inline</span>
<a name="l00350"></a><a class="code" href="parameters_8h.php#a033cb11c5497d303a16d707072b6ab3d">00350</a> std::ostream&amp; <a class="code" href="fe__base_8C.php#af707d8f04488db8220405623626a146a">operator &lt;&lt; </a>(std::ostream&amp; os, <span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; p)
<a name="l00351"></a>00351 {
<a name="l00352"></a>00352   p.<a class="code" href="classParameters.php#a068b7dcca9d186c6d28701f30e70fb48">print</a>(os);
<a name="l00353"></a>00353   <span class="keywordflow">return</span> os;
<a name="l00354"></a>00354 }
<a name="l00355"></a>00355 
<a name="l00356"></a>00356 
<a name="l00357"></a>00357 
<a name="l00358"></a>00358 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00359"></a>00359 <span class="keyword">inline</span>
<a name="l00360"></a><a class="code" href="classParameters.php#a20587dd7120a79624ebc7095aea0390c">00360</a> <span class="keywordtype">bool</span> <a class="code" href="classParameters.php#a20587dd7120a79624ebc7095aea0390c">Parameters::have_parameter</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)<span class="keyword"> const</span>
<a name="l00361"></a>00361 <span class="keyword"></span>{
<a name="l00362"></a>00362   <a class="code" href="classParameters.php#a9981db459a2169b2ac312d10e9ec0f64">Parameters::const_iterator</a> it = <a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">_values</a>.find(name);
<a name="l00363"></a>00363 
<a name="l00364"></a>00364   <span class="keywordflow">if</span> (it != <a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">_values</a>.end())
<a name="l00365"></a>00365     <span class="keywordflow">if</span> (<span class="keyword">dynamic_cast&lt;</span><span class="keyword">const </span><a class="code" href="classParameters_1_1Parameter.php">Parameter&lt;T&gt;</a>*<span class="keyword">&gt;</span>(it-&gt;second) != NULL)
<a name="l00366"></a>00366       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00367"></a>00367 
<a name="l00368"></a>00368   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00369"></a>00369 }
<a name="l00370"></a>00370 
<a name="l00371"></a>00371 
<a name="l00372"></a>00372 
<a name="l00373"></a>00373 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00374"></a>00374 <span class="keyword">inline</span>
<a name="l00375"></a><a class="code" href="classParameters.php#ac4c5e3f411568e6defcdd2ace5829d96">00375</a> <span class="keyword">const</span> T&amp; <a class="code" href="classParameters.php#ac4c5e3f411568e6defcdd2ace5829d96">Parameters::get</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)<span class="keyword"> const</span>
<a name="l00376"></a>00376 <span class="keyword"></span>{
<a name="l00377"></a>00377   <span class="keywordflow">if</span> (!this-&gt;have_parameter&lt;T&gt;(name))
<a name="l00378"></a>00378     {
<a name="l00379"></a>00379       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: no &quot;</span>
<a name="l00380"></a>00380                 &lt;&lt; <span class="keyword">typeid</span>(T).<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>()
<a name="l00381"></a>00381                 &lt;&lt; <span class="stringliteral">&quot; parameter named \&quot;&quot;</span>
<a name="l00382"></a>00382                 &lt;&lt; name &lt;&lt; <span class="stringliteral">&quot;\&quot;:&quot;</span> &lt;&lt; std::endl
<a name="l00383"></a>00383                 &lt;&lt; *<span class="keyword">this</span>;
<a name="l00384"></a>00384       
<a name="l00385"></a>00385       libmesh_error();
<a name="l00386"></a>00386     }
<a name="l00387"></a>00387 
<a name="l00388"></a>00388   <a class="code" href="classParameters.php#a9981db459a2169b2ac312d10e9ec0f64">Parameters::const_iterator</a> it = <a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">_values</a>.find(name);
<a name="l00389"></a>00389 
<a name="l00390"></a>00390   libmesh_assert (it != <a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">_values</a>.end());
<a name="l00391"></a>00391   libmesh_assert (it-&gt;second != NULL);
<a name="l00392"></a>00392   libmesh_assert (<span class="keyword">dynamic_cast&lt;</span><span class="keyword">const </span><a class="code" href="classParameters_1_1Parameter.php">Parameter&lt;T&gt;</a>*<span class="keyword">&gt;</span>(it-&gt;second) != NULL);
<a name="l00393"></a>00393   
<a name="l00394"></a>00394   <span class="keywordflow">return</span> <span class="keyword">dynamic_cast&lt;</span><a class="code" href="classParameters_1_1Parameter.php">Parameter&lt;T&gt;</a>*<span class="keyword">&gt;</span>(it-&gt;second)-&gt;<span class="keyword">get</span>();
<a name="l00395"></a>00395 }
<a name="l00396"></a>00396 
<a name="l00397"></a>00397 
<a name="l00398"></a>00398 
<a name="l00399"></a>00399 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00400"></a>00400 <span class="keyword">inline</span>
<a name="l00401"></a><a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">00401</a> T&amp; <a class="code" href="classParameters.php#a69f0c3899c1f97bb0bc961eec32ae095">Parameters::set</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00402"></a>00402 {
<a name="l00403"></a>00403   <a class="code" href="classParameters_1_1Parameter.php">Parameter&lt;T&gt;</a>* param = NULL;
<a name="l00404"></a>00404   
<a name="l00405"></a>00405   <span class="keywordflow">if</span> (!this-&gt;have_parameter&lt;T&gt;(name))
<a name="l00406"></a>00406     <a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">_values</a>[<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>] = <span class="keyword">new</span> <a class="code" href="classParameters_1_1Parameter.php">Parameter&lt;T&gt;</a>;
<a name="l00407"></a>00407 
<a name="l00408"></a>00408   param = <span class="keyword">dynamic_cast&lt;</span><a class="code" href="classParameters_1_1Parameter.php">Parameter&lt;T&gt;</a>*<span class="keyword">&gt;</span>(<a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">_values</a>[<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>]);
<a name="l00409"></a>00409 
<a name="l00410"></a>00410   libmesh_assert (param != NULL);
<a name="l00411"></a>00411   
<a name="l00412"></a>00412   <span class="keywordflow">return</span> param-&gt;<a class="code" href="classParameters_1_1Parameter.php#a3fe26b7a22592efc09733b9c4b5d016d">set</a>();
<a name="l00413"></a>00413 }
<a name="l00414"></a>00414 
<a name="l00415"></a>00415 
<a name="l00416"></a>00416 
<a name="l00417"></a>00417 <span class="keyword">inline</span>
<a name="l00418"></a><a class="code" href="classParameters.php#a4e235ebee032811d76261915691c5812">00418</a> <span class="keywordtype">void</span> <a class="code" href="classParameters.php#a4e235ebee032811d76261915691c5812">Parameters::remove</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00419"></a>00419 {
<a name="l00420"></a>00420   <a class="code" href="classParameters.php#a2d552339af565bf653c5cafca5b4e156">Parameters::iterator</a> it = <a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">_values</a>.find(name);
<a name="l00421"></a>00421 
<a name="l00422"></a>00422   <span class="keywordflow">if</span> (it != <a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">_values</a>.end())
<a name="l00423"></a>00423     {
<a name="l00424"></a>00424       <span class="keyword">delete</span> it-&gt;second;
<a name="l00425"></a>00425       it-&gt;second = NULL;
<a name="l00426"></a>00426 
<a name="l00427"></a>00427       <a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">_values</a>.erase(it);
<a name="l00428"></a>00428     }
<a name="l00429"></a>00429 }
<a name="l00430"></a>00430 
<a name="l00431"></a>00431 
<a name="l00432"></a>00432 
<a name="l00433"></a>00433 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00434"></a>00434 <span class="keyword">inline</span>
<a name="l00435"></a>00435 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classParameters.php#a792118f15e3df73d3735e137d0f354ee">Parameters::n_parameters</a> ()<span class="keyword"> const</span>
<a name="l00436"></a>00436 <span class="keyword"></span>{
<a name="l00437"></a>00437   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt = 0;  
<a name="l00438"></a>00438   
<a name="l00439"></a>00439   <a class="code" href="classParameters.php#a9981db459a2169b2ac312d10e9ec0f64">Parameters::const_iterator</a>       it  = <a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">_values</a>.begin();
<a name="l00440"></a>00440   <span class="keyword">const</span> <a class="code" href="classParameters.php#a9981db459a2169b2ac312d10e9ec0f64">Parameters::const_iterator</a> <a class="code" href="classParameters.php#a249b5c11a1da0cc4691dbe9feff9c280">end</a> = <a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">_values</a>.end();
<a name="l00441"></a>00441   
<a name="l00442"></a>00442   <span class="keywordflow">for</span> (; it != <a class="code" href="classParameters.php#a249b5c11a1da0cc4691dbe9feff9c280">end</a>; ++it)
<a name="l00443"></a>00443     <span class="keywordflow">if</span> (<span class="keyword">dynamic_cast&lt;</span>Parameter&lt;T&gt;*<span class="keyword">&gt;</span>(it-&gt;second) != NULL)
<a name="l00444"></a>00444       cnt++;
<a name="l00445"></a>00445 
<a name="l00446"></a>00446   <span class="keywordflow">return</span> cnt;    
<a name="l00447"></a>00447 }
<a name="l00448"></a>00448 
<a name="l00449"></a>00449 <span class="keyword">inline</span>
<a name="l00450"></a><a class="code" href="classParameters.php#a4b8c6b7062523872a9286ce70fa59252">00450</a> <a class="code" href="classParameters.php#a2d552339af565bf653c5cafca5b4e156">Parameters::iterator</a> <a class="code" href="classParameters.php#a4b8c6b7062523872a9286ce70fa59252">Parameters::begin</a>()
<a name="l00451"></a>00451 {
<a name="l00452"></a>00452   <span class="keywordflow">return</span> <a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">_values</a>.begin();
<a name="l00453"></a>00453 }
<a name="l00454"></a>00454 
<a name="l00455"></a>00455 <span class="keyword">inline</span>
<a name="l00456"></a><a class="code" href="classParameters.php#a698dfea1496ace310fb674bfbfc5ee0e">00456</a> <a class="code" href="classParameters.php#a9981db459a2169b2ac312d10e9ec0f64">Parameters::const_iterator</a> <a class="code" href="classParameters.php#a4b8c6b7062523872a9286ce70fa59252">Parameters::begin</a>()<span class="keyword"> const</span>
<a name="l00457"></a>00457 <span class="keyword"></span>{
<a name="l00458"></a>00458   <span class="keywordflow">return</span> <a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">_values</a>.begin();
<a name="l00459"></a>00459 }
<a name="l00460"></a>00460 
<a name="l00461"></a>00461 <span class="keyword">inline</span>
<a name="l00462"></a><a class="code" href="classParameters.php#a249b5c11a1da0cc4691dbe9feff9c280">00462</a> <a class="code" href="classParameters.php#a2d552339af565bf653c5cafca5b4e156">Parameters::iterator</a> <a class="code" href="classParameters.php#a249b5c11a1da0cc4691dbe9feff9c280">Parameters::end</a>()
<a name="l00463"></a>00463 {
<a name="l00464"></a>00464   <span class="keywordflow">return</span> <a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">_values</a>.end();
<a name="l00465"></a>00465 }
<a name="l00466"></a>00466 
<a name="l00467"></a>00467 <span class="keyword">inline</span>
<a name="l00468"></a><a class="code" href="classParameters.php#a45665cdb75a8067e4e535e5149fde33a">00468</a> <a class="code" href="classParameters.php#a9981db459a2169b2ac312d10e9ec0f64">Parameters::const_iterator</a> <a class="code" href="classParameters.php#a249b5c11a1da0cc4691dbe9feff9c280">Parameters::end</a>()<span class="keyword"> const</span>
<a name="l00469"></a>00469 <span class="keyword"></span>{
<a name="l00470"></a>00470   <span class="keywordflow">return</span> <a class="code" href="classParameters.php#aaf92a25b01b678fb9f5c7a6f8fa4a6c2">_values</a>.end();
<a name="l00471"></a>00471 }
<a name="l00472"></a>00472 
<a name="l00473"></a>00473 <span class="preprocessor">#endif // #define __parameters_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
