<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_7059df55b9d3d0975f6468fedce13a55.php">partitioning</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>parmetis_partitioner.C</h1>  </div>
</div>
<div class="contents">
<a href="parmetis__partitioner_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: parmetis_partitioner.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;parallel.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;mesh_tools.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;mesh_communication.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;parmetis_partitioner.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;metis_partitioner.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="preprocessor">#ifdef LIBMESH_HAVE_PARMETIS</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span>
<a name="l00037"></a>00037 <span class="comment">// Include the MPI header files, which must be accessible for</span>
<a name="l00038"></a>00038 <span class="comment">// ParMETIS to work properly.</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;mpi.h&quot;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">// Include the ParMETIS header files</span>
<a name="l00042"></a><a class="code" href="namespaceParmetis.php">00042</a> <span class="keyword">namespace </span>Parmetis {
<a name="l00043"></a>00043   <span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {
<a name="l00044"></a>00044 <span class="preprocessor">#     include &quot;parmetis.h&quot;</span>
<a name="l00045"></a>00045   }
<a name="l00046"></a>00046 }
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_PARMETIS ... else ...</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span>
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00053"></a>00053 <span class="comment">// ParmetisPartitioner implementation</span>
<a name="l00054"></a><a class="code" href="classParmetisPartitioner.php#a7656f039e6db1a47788211c3527d64e1">00054</a> <span class="keywordtype">void</span> <a class="code" href="classParmetisPartitioner.php#a7656f039e6db1a47788211c3527d64e1">ParmetisPartitioner::_do_partition</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00055"></a>00055                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sbdmns)
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057   this-&gt;<a class="code" href="classParmetisPartitioner.php#a435005ebb65587f6991e641eed03c1fb">_do_repartition</a> (mesh, n_sbdmns);
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 <span class="comment">//   libmesh_assert (n_sbdmns &gt; 0);</span>
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 <span class="comment">//   // Check for an easy return</span>
<a name="l00062"></a>00062 <span class="comment">//   if (n_sbdmns == 1)</span>
<a name="l00063"></a>00063 <span class="comment">//     {</span>
<a name="l00064"></a>00064 <span class="comment">//       this-&gt;single_partition (mesh);</span>
<a name="l00065"></a>00065 <span class="comment">//       return;</span>
<a name="l00066"></a>00066 <span class="comment">//     }</span>
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 <span class="comment">//   // This function must be run on all processors at once</span>
<a name="l00069"></a>00069 <span class="comment">//   parallel_only();</span>
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 <span class="comment">// // What to do if the Parmetis library IS NOT present</span>
<a name="l00072"></a>00072 <span class="comment">// #ifndef LIBMESH_HAVE_PARMETIS</span>
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 <span class="comment">//   libmesh_here();</span>
<a name="l00075"></a>00075 <span class="comment">//   std::cerr &lt;&lt; &quot;ERROR: The library has been built without&quot;  &lt;&lt; std::endl</span>
<a name="l00076"></a>00076 <span class="comment">//          &lt;&lt; &quot;Parmetis support.  Using a Metis&quot;           &lt;&lt; std::endl</span>
<a name="l00077"></a>00077 <span class="comment">//          &lt;&lt; &quot;partitioner instead!&quot;                       &lt;&lt; std::endl;</span>
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 <span class="comment">//   MetisPartitioner mp;</span>
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 <span class="comment">//   mp.partition (mesh, n_sbdmns);</span>
<a name="l00082"></a>00082   
<a name="l00083"></a>00083 <span class="comment">// // What to do if the Parmetis library IS present</span>
<a name="l00084"></a>00084 <span class="comment">// #else</span>
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 <span class="comment">//   START_LOG(&quot;partition()&quot;, &quot;ParmetisPartitioner&quot;);</span>
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 <span class="comment">//   // Initialize the data structures required by ParMETIS</span>
<a name="l00089"></a>00089 <span class="comment">//   this-&gt;initialize (mesh, n_sbdmns);</span>
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 <span class="comment">//   // build the graph corresponding to the mesh</span>
<a name="l00092"></a>00092 <span class="comment">//   this-&gt;build_graph (mesh);</span>
<a name="l00093"></a>00093   
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 <span class="comment">//   // Partition the graph</span>
<a name="l00096"></a>00096 <span class="comment">//   MPI_Comm mpi_comm = libMesh::COMM_WORLD;</span>
<a name="l00097"></a>00097   
<a name="l00098"></a>00098 <span class="comment">//   // Call the ParMETIS k-way partitioning algorithm.</span>
<a name="l00099"></a>00099 <span class="comment">//   Parmetis::ParMETIS_V3_PartKway(&amp;_vtxdist[0], &amp;_xadj[0], &amp;_adjncy[0], &amp;_vwgt[0], NULL,</span>
<a name="l00100"></a>00100 <span class="comment">//                               &amp;_wgtflag, &amp;_numflag, &amp;_ncon, &amp;_nparts, &amp;_tpwgts[0],</span>
<a name="l00101"></a>00101 <span class="comment">//                               &amp;_ubvec[0], &amp;_options[0], &amp;_edgecut,</span>
<a name="l00102"></a>00102 <span class="comment">//                               &amp;_part[0],</span>
<a name="l00103"></a>00103 <span class="comment">//                               &amp;mpi_comm);</span>
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 <span class="comment">//   // Assign the returned processor ids</span>
<a name="l00106"></a>00106 <span class="comment">//   this-&gt;assign_partitioning (mesh);</span>
<a name="l00107"></a>00107   
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 <span class="comment">//   STOP_LOG (&quot;partition()&quot;, &quot;ParmetisPartitioner&quot;);</span>
<a name="l00110"></a>00110   
<a name="l00111"></a>00111 <span class="comment">// #endif // #ifndef LIBMESH_HAVE_PARMETIS ... else ...</span>
<a name="l00112"></a>00112   
<a name="l00113"></a>00113 }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a><a class="code" href="classParmetisPartitioner.php#a435005ebb65587f6991e641eed03c1fb">00117</a> <span class="keywordtype">void</span> <a class="code" href="classParmetisPartitioner.php#a435005ebb65587f6991e641eed03c1fb">ParmetisPartitioner::_do_repartition</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00118"></a>00118                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sbdmns)
<a name="l00119"></a>00119 {
<a name="l00120"></a>00120   libmesh_assert (n_sbdmns &gt; 0);
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   <span class="comment">// Check for an easy return</span>
<a name="l00123"></a>00123   <span class="keywordflow">if</span> (n_sbdmns == 1)
<a name="l00124"></a>00124     {
<a name="l00125"></a>00125       this-&gt;<a class="code" href="classPartitioner.php#a1108dd58c055d536d489dc06cc0823ec">single_partition</a>(mesh);
<a name="l00126"></a>00126       <span class="keywordflow">return</span>;
<a name="l00127"></a>00127     }
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00130"></a>00130   parallel_only();
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 <span class="comment">// What to do if the Parmetis library IS NOT present</span>
<a name="l00133"></a>00133 <span class="preprocessor">#ifndef LIBMESH_HAVE_PARMETIS</span>
<a name="l00134"></a>00134 <span class="preprocessor"></span>
<a name="l00135"></a>00135   libmesh_here();
<a name="l00136"></a>00136   std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: The library has been built without&quot;</span>  &lt;&lt; std::endl
<a name="l00137"></a>00137             &lt;&lt; <span class="stringliteral">&quot;Parmetis support.  Using a Metis&quot;</span>           &lt;&lt; std::endl
<a name="l00138"></a>00138             &lt;&lt; <span class="stringliteral">&quot;partitioner instead!&quot;</span>                       &lt;&lt; std::endl;
<a name="l00139"></a>00139 
<a name="l00140"></a>00140   <a class="code" href="classMetisPartitioner.php">MetisPartitioner</a> mp;
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   mp.<a class="code" href="classPartitioner.php#a6c8f1c4dac2b50c4ed0e30088e0c4063">partition</a> (mesh, n_sbdmns);
<a name="l00143"></a>00143   
<a name="l00144"></a>00144 <span class="comment">// What to do if the Parmetis library IS present</span>
<a name="l00145"></a>00145 <span class="preprocessor">#else</span>
<a name="l00146"></a>00146 <span class="preprocessor"></span>
<a name="l00147"></a>00147   <span class="comment">// Revert to METIS on one processor.</span>
<a name="l00148"></a>00148   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l00149"></a>00149     {
<a name="l00150"></a>00150       <a class="code" href="classMetisPartitioner.php">MetisPartitioner</a> mp;
<a name="l00151"></a>00151       mp.<a class="code" href="classPartitioner.php#a6c8f1c4dac2b50c4ed0e30088e0c4063">partition</a> (mesh, n_sbdmns);
<a name="l00152"></a>00152       <span class="keywordflow">return</span>;   
<a name="l00153"></a>00153     }
<a name="l00154"></a>00154   
<a name="l00155"></a>00155   START_LOG(<span class="stringliteral">&quot;repartition()&quot;</span>, <span class="stringliteral">&quot;ParmetisPartitioner&quot;</span>);
<a name="l00156"></a>00156 
<a name="l00157"></a>00157   <span class="comment">// Initialize the data structures required by ParMETIS</span>
<a name="l00158"></a>00158   this-&gt;<a class="code" href="classParmetisPartitioner.php#adb43bb39778d93f97e486eefcef69823">initialize</a> (mesh, n_sbdmns);
<a name="l00159"></a>00159 
<a name="l00160"></a>00160   <span class="comment">// Make sure all processors have some active local elements.</span>
<a name="l00161"></a>00161   {
<a name="l00162"></a>00162     <span class="keywordtype">bool</span> all_have_active_elements = <span class="keyword">true</span>;
<a name="l00163"></a>00163     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="classParmetisPartitioner.php#a713644a1e3be63ed4bb1fccdb8141d01">_n_active_elem_on_proc</a>.size(); pid++)
<a name="l00164"></a>00164       <span class="keywordflow">if</span> (!<a class="code" href="classParmetisPartitioner.php#a713644a1e3be63ed4bb1fccdb8141d01">_n_active_elem_on_proc</a>[pid]) all_have_active_elements = <span class="keyword">false</span>;
<a name="l00165"></a>00165 
<a name="l00166"></a>00166     <span class="comment">// Parmetis will not work unless each processor has some</span>
<a name="l00167"></a>00167     <span class="comment">// elements. Specifically, it will abort when passed a NULL</span>
<a name="l00168"></a>00168     <span class="comment">// partition array on *any* of the processors.</span>
<a name="l00169"></a>00169     <span class="keywordflow">if</span> (!all_have_active_elements)
<a name="l00170"></a>00170       {
<a name="l00171"></a>00171         <span class="keywordflow">if</span> (!mesh.<a class="code" href="classMeshBase.php#a660bb92c9fb94527d1cabfb1fdd6d056">is_serial</a>())
<a name="l00172"></a>00172           libmesh_error();
<a name="l00173"></a>00173 
<a name="l00174"></a>00174         <span class="comment">// Cowardly revert to METIS, although this requires a serial mesh</span>
<a name="l00175"></a>00175         STOP_LOG (<span class="stringliteral">&quot;repartition()&quot;</span>, <span class="stringliteral">&quot;ParmetisPartitioner&quot;</span>);
<a name="l00176"></a>00176   
<a name="l00177"></a>00177         <a class="code" href="classMetisPartitioner.php">MetisPartitioner</a> mp;
<a name="l00178"></a>00178         mp.<a class="code" href="classPartitioner.php#a6c8f1c4dac2b50c4ed0e30088e0c4063">partition</a> (mesh, n_sbdmns);
<a name="l00179"></a>00179         <span class="keywordflow">return</span>; 
<a name="l00180"></a>00180       }
<a name="l00181"></a>00181   }
<a name="l00182"></a>00182   
<a name="l00183"></a>00183   <span class="comment">// build the graph corresponding to the mesh</span>
<a name="l00184"></a>00184   this-&gt;<a class="code" href="classParmetisPartitioner.php#ab3d3b5b5ad48e388179775a018a2d0c9">build_graph</a> (mesh);
<a name="l00185"></a>00185   
<a name="l00186"></a>00186 
<a name="l00187"></a>00187   <span class="comment">// Partition the graph</span>
<a name="l00188"></a>00188   std::vector&lt;int&gt; vsize(<a class="code" href="classParmetisPartitioner.php#a9c6f90f03338cca19eac448d901cfef3">_vwgt</a>.size(), 1);
<a name="l00189"></a>00189   <span class="keywordtype">float</span> itr = 1000000.0;
<a name="l00190"></a>00190   MPI_Comm mpi_comm = <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>;
<a name="l00191"></a>00191 
<a name="l00192"></a>00192   <span class="comment">// Call the ParMETIS adaptive repartitioning method.  This respects the</span>
<a name="l00193"></a>00193   <span class="comment">// original partitioning when computing the new partitioning so as to</span>
<a name="l00194"></a>00194   <span class="comment">// minimize the required data redistribution.</span>
<a name="l00195"></a>00195   Parmetis::ParMETIS_V3_AdaptiveRepart(<a class="code" href="classParmetisPartitioner.php#a375ef9491cbd889f7038a266ce3500b4">_vtxdist</a>.empty() ? NULL : &amp;<a class="code" href="classParmetisPartitioner.php#a375ef9491cbd889f7038a266ce3500b4">_vtxdist</a>[0],
<a name="l00196"></a>00196                                        <a class="code" href="classParmetisPartitioner.php#a5d6d2aa77f878805c4f40b36c0be61e0">_xadj</a>.empty()    ? NULL : &amp;<a class="code" href="classParmetisPartitioner.php#a5d6d2aa77f878805c4f40b36c0be61e0">_xadj</a>[0],
<a name="l00197"></a>00197                                        <a class="code" href="classParmetisPartitioner.php#a0e0de501be9649f0efe4cff232b66967">_adjncy</a>.empty()  ? NULL : &amp;<a class="code" href="classParmetisPartitioner.php#a0e0de501be9649f0efe4cff232b66967">_adjncy</a>[0],
<a name="l00198"></a>00198                                        <a class="code" href="classParmetisPartitioner.php#a9c6f90f03338cca19eac448d901cfef3">_vwgt</a>.empty()    ? NULL : &amp;<a class="code" href="classParmetisPartitioner.php#a9c6f90f03338cca19eac448d901cfef3">_vwgt</a>[0],
<a name="l00199"></a>00199                                        vsize.empty()    ? NULL : &amp;vsize[0],
<a name="l00200"></a>00200                                        NULL,
<a name="l00201"></a>00201                                        &amp;<a class="code" href="classParmetisPartitioner.php#a8cbbaea8a17a1efa2a5b48743702b599">_wgtflag</a>,
<a name="l00202"></a>00202                                        &amp;<a class="code" href="classParmetisPartitioner.php#ad7a902f3d2dfaa83dd9caa96bbea9c2e">_numflag</a>,
<a name="l00203"></a>00203                                        &amp;<a class="code" href="classParmetisPartitioner.php#aadb14a86605bc19cce337ebc3a6ff2c5">_ncon</a>,
<a name="l00204"></a>00204                                        &amp;<a class="code" href="classParmetisPartitioner.php#aee744f616d841bf6c09741190695ef8f">_nparts</a>,
<a name="l00205"></a>00205                                        <a class="code" href="classParmetisPartitioner.php#afb3c44e78e2eab08d9cba3b3fb8e7659">_tpwgts</a>.empty()  ? NULL : &amp;<a class="code" href="classParmetisPartitioner.php#afb3c44e78e2eab08d9cba3b3fb8e7659">_tpwgts</a>[0],
<a name="l00206"></a>00206                                        <a class="code" href="classParmetisPartitioner.php#ad3c4df598dbabed2b16abf754cc0dae1">_ubvec</a>.empty()   ? NULL : &amp;<a class="code" href="classParmetisPartitioner.php#ad3c4df598dbabed2b16abf754cc0dae1">_ubvec</a>[0],
<a name="l00207"></a>00207                                        &amp;itr,
<a name="l00208"></a>00208                                        &amp;<a class="code" href="classParmetisPartitioner.php#a683c6bdccc33cfd7bcf5154803ca8e53">_options</a>[0],
<a name="l00209"></a>00209                                        &amp;<a class="code" href="classParmetisPartitioner.php#a825106e4a8706676a7236e8175638e45">_edgecut</a>,
<a name="l00210"></a>00210                                        <a class="code" href="classParmetisPartitioner.php#ab8a7824475eb678363f1a64c0c3ae605">_part</a>.empty()    ? NULL : &amp;<a class="code" href="classParmetisPartitioner.php#ab8a7824475eb678363f1a64c0c3ae605">_part</a>[0],
<a name="l00211"></a>00211                                        &amp;mpi_comm);
<a name="l00212"></a>00212 
<a name="l00213"></a>00213   <span class="comment">// Assign the returned processor ids</span>
<a name="l00214"></a>00214   this-&gt;<a class="code" href="classParmetisPartitioner.php#a178e642f66510fe3ea6d49a865846120">assign_partitioning</a> (mesh);
<a name="l00215"></a>00215   
<a name="l00216"></a>00216 
<a name="l00217"></a>00217   STOP_LOG (<span class="stringliteral">&quot;repartition()&quot;</span>, <span class="stringliteral">&quot;ParmetisPartitioner&quot;</span>);
<a name="l00218"></a>00218   
<a name="l00219"></a>00219 <span class="preprocessor">#endif // #ifndef LIBMESH_HAVE_PARMETIS ... else ...</span>
<a name="l00220"></a>00220 <span class="preprocessor"></span>  
<a name="l00221"></a>00221 }
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 <span class="comment">// Only need to compile these methods if ParMETIS is present</span>
<a name="l00226"></a>00226 <span class="preprocessor">#ifdef LIBMESH_HAVE_PARMETIS</span>
<a name="l00227"></a>00227 <span class="preprocessor"></span>
<a name="l00228"></a><a class="code" href="classParmetisPartitioner.php#adb43bb39778d93f97e486eefcef69823">00228</a> <span class="keywordtype">void</span> <a class="code" href="classParmetisPartitioner.php#adb43bb39778d93f97e486eefcef69823">ParmetisPartitioner::initialize</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00229"></a>00229                                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sbdmns)
<a name="l00230"></a>00230 {
<a name="l00231"></a>00231   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_active_local_elem = mesh.<a class="code" href="classMeshBase.php#ac7a39d026a101d4312b9d39599fa1a45">n_active_local_elem</a>();
<a name="l00232"></a>00232 
<a name="l00233"></a>00233   <span class="comment">// Set parameters.</span>
<a name="l00234"></a>00234   <a class="code" href="classParmetisPartitioner.php#a8cbbaea8a17a1efa2a5b48743702b599">_wgtflag</a> = 2;                          <span class="comment">// weights on vertices only</span>
<a name="l00235"></a>00235   <a class="code" href="classParmetisPartitioner.php#aadb14a86605bc19cce337ebc3a6ff2c5">_ncon</a>    = 1;                          <span class="comment">// one weight per vertex</span>
<a name="l00236"></a>00236   <a class="code" href="classParmetisPartitioner.php#ad7a902f3d2dfaa83dd9caa96bbea9c2e">_numflag</a> = 0;                          <span class="comment">// C-style 0-based numbering</span>
<a name="l00237"></a>00237   <a class="code" href="classParmetisPartitioner.php#aee744f616d841bf6c09741190695ef8f">_nparts</a>  = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n_sbdmns); <span class="comment">// number of subdomains to create</span>
<a name="l00238"></a>00238   <a class="code" href="classParmetisPartitioner.php#a825106e4a8706676a7236e8175638e45">_edgecut</a> = 0;                          <span class="comment">// the numbers of edges cut by the</span>
<a name="l00239"></a>00239                                          <span class="comment">//   partition</span>
<a name="l00240"></a>00240 
<a name="l00241"></a>00241   <span class="comment">// Initialize data structures for ParMETIS</span>
<a name="l00242"></a>00242   <a class="code" href="classParmetisPartitioner.php#a375ef9491cbd889f7038a266ce3500b4">_vtxdist</a>.resize (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()+1); std::fill (<a class="code" href="classParmetisPartitioner.php#a375ef9491cbd889f7038a266ce3500b4">_vtxdist</a>.begin(), <a class="code" href="classParmetisPartitioner.php#a375ef9491cbd889f7038a266ce3500b4">_vtxdist</a>.end(), 0);
<a name="l00243"></a>00243   <a class="code" href="classParmetisPartitioner.php#afb3c44e78e2eab08d9cba3b3fb8e7659">_tpwgts</a>.resize  (<a class="code" href="classParmetisPartitioner.php#aee744f616d841bf6c09741190695ef8f">_nparts</a>);                   std::fill (<a class="code" href="classParmetisPartitioner.php#afb3c44e78e2eab08d9cba3b3fb8e7659">_tpwgts</a>.begin(),  <a class="code" href="classParmetisPartitioner.php#afb3c44e78e2eab08d9cba3b3fb8e7659">_tpwgts</a>.end(),  1./<a class="code" href="classParmetisPartitioner.php#aee744f616d841bf6c09741190695ef8f">_nparts</a>);
<a name="l00244"></a>00244   <a class="code" href="classParmetisPartitioner.php#ad3c4df598dbabed2b16abf754cc0dae1">_ubvec</a>.resize   (<a class="code" href="classParmetisPartitioner.php#aadb14a86605bc19cce337ebc3a6ff2c5">_ncon</a>);                     std::fill (<a class="code" href="classParmetisPartitioner.php#ad3c4df598dbabed2b16abf754cc0dae1">_ubvec</a>.begin(),   <a class="code" href="classParmetisPartitioner.php#ad3c4df598dbabed2b16abf754cc0dae1">_ubvec</a>.end(),   1.);
<a name="l00245"></a>00245   <a class="code" href="classParmetisPartitioner.php#ab8a7824475eb678363f1a64c0c3ae605">_part</a>.resize    (n_active_local_elem);       std::fill (<a class="code" href="classParmetisPartitioner.php#ab8a7824475eb678363f1a64c0c3ae605">_part</a>.begin(),    <a class="code" href="classParmetisPartitioner.php#ab8a7824475eb678363f1a64c0c3ae605">_part</a>.end(), 0);
<a name="l00246"></a>00246   <a class="code" href="classParmetisPartitioner.php#a683c6bdccc33cfd7bcf5154803ca8e53">_options</a>.resize (5);
<a name="l00247"></a>00247   <a class="code" href="classParmetisPartitioner.php#a9c6f90f03338cca19eac448d901cfef3">_vwgt</a>.resize    (n_active_local_elem);
<a name="l00248"></a>00248   
<a name="l00249"></a>00249   <span class="comment">// Set the options</span>
<a name="l00250"></a>00250   <a class="code" href="classParmetisPartitioner.php#a683c6bdccc33cfd7bcf5154803ca8e53">_options</a>[0] = 1;  <span class="comment">// don&#39;t use default options</span>
<a name="l00251"></a>00251   <a class="code" href="classParmetisPartitioner.php#a683c6bdccc33cfd7bcf5154803ca8e53">_options</a>[1] = 0;  <span class="comment">// default (level of timing)</span>
<a name="l00252"></a>00252   <a class="code" href="classParmetisPartitioner.php#a683c6bdccc33cfd7bcf5154803ca8e53">_options</a>[2] = 15; <span class="comment">// random seed (default)</span>
<a name="l00253"></a>00253   <a class="code" href="classParmetisPartitioner.php#a683c6bdccc33cfd7bcf5154803ca8e53">_options</a>[3] = 2;  <span class="comment">// processor distribution and subdomain distribution are decoupled</span>
<a name="l00254"></a>00254   
<a name="l00255"></a>00255   <span class="comment">// Find the number of active elements on each processor.  We cannot use</span>
<a name="l00256"></a>00256   <span class="comment">// mesh.n_active_elem_on_proc(pid) since that only returns the number of</span>
<a name="l00257"></a>00257   <span class="comment">// elements assigned to pid which are currently stored on the calling </span>
<a name="l00258"></a>00258   <span class="comment">// processor. This will not in general be correct for parallel meshes</span>
<a name="l00259"></a>00259   <span class="comment">// when (pid!=libMesh::processor_id()).</span>
<a name="l00260"></a>00260   <a class="code" href="classParmetisPartitioner.php#a713644a1e3be63ed4bb1fccdb8141d01">_n_active_elem_on_proc</a>.resize(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00261"></a>00261   Parallel::allgather(n_active_local_elem, <a class="code" href="classParmetisPartitioner.php#a713644a1e3be63ed4bb1fccdb8141d01">_n_active_elem_on_proc</a>);
<a name="l00262"></a>00262 
<a name="l00263"></a>00263   <span class="comment">// count the total number of active elements in the mesh.  Note we cannot</span>
<a name="l00264"></a>00264   <span class="comment">// use mesh.n_active_elem() in general since this only returns the number</span>
<a name="l00265"></a>00265   <span class="comment">// of active elements which are stored on the calling processor.</span>
<a name="l00266"></a>00266   <span class="comment">// We should not use n_active_elem for any allocation because that will</span>
<a name="l00267"></a>00267   <span class="comment">// be inheritly unscalable, but it can be useful for libmesh_assertions.</span>
<a name="l00268"></a>00268   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_active_elem=0;
<a name="l00269"></a>00269 
<a name="l00270"></a>00270   <span class="comment">// Set up the vtxdist array.  This will be the same on each processor.</span>
<a name="l00271"></a>00271   <span class="comment">// ***** Consult the Parmetis documentation. *****</span>
<a name="l00272"></a>00272   libmesh_assert (<a class="code" href="classParmetisPartitioner.php#a375ef9491cbd889f7038a266ce3500b4">_vtxdist</a>.size() == <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()+1);
<a name="l00273"></a>00273   libmesh_assert (<a class="code" href="classParmetisPartitioner.php#a375ef9491cbd889f7038a266ce3500b4">_vtxdist</a>[0] == 0);
<a name="l00274"></a>00274   
<a name="l00275"></a>00275   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00276"></a>00276     {
<a name="l00277"></a>00277       <a class="code" href="classParmetisPartitioner.php#a375ef9491cbd889f7038a266ce3500b4">_vtxdist</a>[pid+1] = <a class="code" href="classParmetisPartitioner.php#a375ef9491cbd889f7038a266ce3500b4">_vtxdist</a>[pid] + <a class="code" href="classParmetisPartitioner.php#a713644a1e3be63ed4bb1fccdb8141d01">_n_active_elem_on_proc</a>[pid];
<a name="l00278"></a>00278       n_active_elem += _n_active_elem_on_proc[pid];
<a name="l00279"></a>00279     }
<a name="l00280"></a>00280   libmesh_assert (<a class="code" href="classParmetisPartitioner.php#a375ef9491cbd889f7038a266ce3500b4">_vtxdist</a>.back() == <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n_active_elem));
<a name="l00281"></a>00281 
<a name="l00282"></a>00282   <span class="comment">// ParMetis expects the elements to be numbered in contiguous blocks</span>
<a name="l00283"></a>00283   <span class="comment">// by processor, i.e. [0, ne0), [ne0, ne0+ne1), ...</span>
<a name="l00284"></a>00284   <span class="comment">// Since we only partition active elements we should have no expectation</span>
<a name="l00285"></a>00285   <span class="comment">// that we currently have such a distribution.  So we need to create it.</span>
<a name="l00286"></a>00286   <span class="comment">// Also, at the same time we are going to map all the active elements into a globally</span>
<a name="l00287"></a>00287   <span class="comment">// unique range [0,n_active_elem) which is *independent* of the current partitioning.</span>
<a name="l00288"></a>00288   <span class="comment">// This can be fed to ParMetis as the initial partitioning of the subdomains (decoupled</span>
<a name="l00289"></a>00289   <span class="comment">// from the partitioning of the objects themselves).  This allows us to get the same</span>
<a name="l00290"></a>00290   <span class="comment">// resultant partitioning independed of the input partitioning.</span>
<a name="l00291"></a>00291   <a class="code" href="classMeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a> bbox =
<a name="l00292"></a>00292     <a class="code" href="namespaceMeshTools.php#ad533681876e9809cfe5e2114886b1c03">MeshTools::bounding_box</a>(mesh);
<a name="l00293"></a>00293 
<a name="l00294"></a>00294   <a class="code" href="classParmetisPartitioner.php#a7ab120fdf3c3c57ba3a70701b4cd8145">_global_index_by_pid_map</a>.clear();
<a name="l00295"></a>00295 
<a name="l00296"></a>00296   <span class="comment">// Maps active element ids into a contiguous range independent of partitioning.</span>
<a name="l00297"></a>00297   <span class="comment">// (only needs local scope)</span>
<a name="l00298"></a>00298   std::map&lt;unsigned int, unsigned int&gt; global_index_map;
<a name="l00299"></a>00299 
<a name="l00300"></a>00300   {
<a name="l00301"></a>00301     std::vector&lt;unsigned int&gt; global_index;
<a name="l00302"></a>00302 
<a name="l00303"></a>00303     <span class="comment">// create the mapping which is contiguous by processor </span>
<a name="l00304"></a>00304     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0, pid_offset=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00305"></a>00305       {
<a name="l00306"></a>00306         <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classMeshBase.php#ac0e09837e3ba3077c14015ea4b73ec08">active_pid_elements_begin</a>(pid);
<a name="l00307"></a>00307         <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a44926338045dcfee9dae93975aeafe9a">active_pid_elements_end</a>(pid); 
<a name="l00308"></a>00308         
<a name="l00309"></a>00309         <span class="comment">// note that we may not have all (or any!) the active elements which belong on this processor,</span>
<a name="l00310"></a>00310         <span class="comment">// but by calling this on all processors a unique range in [0,_n_active_elem_on_proc[pid])</span>
<a name="l00311"></a>00311         <span class="comment">// is constructed.  Only the indices for the elements we pass in are returned in the array.</span>
<a name="l00312"></a>00312         <a class="code" href="classMeshCommunication.php">MeshCommunication</a>().<a class="code" href="classMeshCommunication.php#ad39ffc569ad59944067e273a77a06abd">find_global_indices</a> (bbox, it, end, 
<a name="l00313"></a>00313                                                  global_index);
<a name="l00314"></a>00314         
<a name="l00315"></a>00315         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0; it != end; ++it)
<a name="l00316"></a>00316           {
<a name="l00317"></a>00317             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *elem = *it;
<a name="l00318"></a>00318             libmesh_assert (!<a class="code" href="classParmetisPartitioner.php#a7ab120fdf3c3c57ba3a70701b4cd8145">_global_index_by_pid_map</a>.count(elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()));
<a name="l00319"></a>00319             libmesh_assert (cnt &lt; global_index.size());
<a name="l00320"></a>00320             libmesh_assert (global_index[cnt] &lt; <a class="code" href="classParmetisPartitioner.php#a713644a1e3be63ed4bb1fccdb8141d01">_n_active_elem_on_proc</a>[pid]);
<a name="l00321"></a>00321 
<a name="l00322"></a>00322             <a class="code" href="classParmetisPartitioner.php#a7ab120fdf3c3c57ba3a70701b4cd8145">_global_index_by_pid_map</a>[elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()]  = global_index[cnt++] + pid_offset;
<a name="l00323"></a>00323           }
<a name="l00324"></a>00324 
<a name="l00325"></a>00325         pid_offset += <a class="code" href="classParmetisPartitioner.php#a713644a1e3be63ed4bb1fccdb8141d01">_n_active_elem_on_proc</a>[pid];
<a name="l00326"></a>00326       }
<a name="l00327"></a>00327 
<a name="l00328"></a>00328     <span class="comment">// create the unique mapping for all active elements independent of partitioning</span>
<a name="l00329"></a>00329     {
<a name="l00330"></a>00330       <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00331"></a>00331       <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00332"></a>00332         
<a name="l00333"></a>00333       <span class="comment">// Calling this on all processors a unique range in [0,n_active_elem) is constructed.  </span>
<a name="l00334"></a>00334       <span class="comment">// Only the indices for the elements we pass in are returned in the array.</span>
<a name="l00335"></a>00335       <a class="code" href="classMeshCommunication.php">MeshCommunication</a>().<a class="code" href="classMeshCommunication.php#ad39ffc569ad59944067e273a77a06abd">find_global_indices</a> (bbox, it, end, 
<a name="l00336"></a>00336                                                global_index);
<a name="l00337"></a>00337       
<a name="l00338"></a>00338       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0; it != end; ++it)
<a name="l00339"></a>00339         {
<a name="l00340"></a>00340           <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *elem = *it;
<a name="l00341"></a>00341           libmesh_assert (!global_index_map.count(elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()));
<a name="l00342"></a>00342           libmesh_assert (cnt &lt; global_index.size());
<a name="l00343"></a>00343           libmesh_assert (global_index[cnt] &lt; n_active_elem);
<a name="l00344"></a>00344 
<a name="l00345"></a>00345           global_index_map[elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()]  = global_index[cnt++];
<a name="l00346"></a>00346         }
<a name="l00347"></a>00347       }
<a name="l00348"></a>00348     <span class="comment">// really, shouldn&#39;t be close!</span>
<a name="l00349"></a>00349     libmesh_assert (global_index_map.size() &lt;= n_active_elem);
<a name="l00350"></a>00350     libmesh_assert (<a class="code" href="classParmetisPartitioner.php#a7ab120fdf3c3c57ba3a70701b4cd8145">_global_index_by_pid_map</a>.size() &lt;= n_active_elem);
<a name="l00351"></a>00351 
<a name="l00352"></a>00352     <span class="comment">// At this point the two maps should be the same size.  If they are not</span>
<a name="l00353"></a>00353     <span class="comment">// then the number of active elements is not the same as the sum over all </span>
<a name="l00354"></a>00354     <span class="comment">// processors of the number of active elements per processor, which means</span>
<a name="l00355"></a>00355     <span class="comment">// there must be some unpartitioned objects out there.</span>
<a name="l00356"></a>00356     <span class="keywordflow">if</span> (global_index_map.size() != <a class="code" href="classParmetisPartitioner.php#a7ab120fdf3c3c57ba3a70701b4cd8145">_global_index_by_pid_map</a>.size())
<a name="l00357"></a>00357       {
<a name="l00358"></a>00358         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR:  ParmetisPartitioner cannot handle unpartitioned objects!&quot;</span>
<a name="l00359"></a>00359                   &lt;&lt; std::endl;
<a name="l00360"></a>00360         libmesh_error();
<a name="l00361"></a>00361       }    
<a name="l00362"></a>00362   }
<a name="l00363"></a>00363 
<a name="l00364"></a>00364   <span class="comment">// Finally, we need to initialize the vertex (partition) weights and the initial subdomain</span>
<a name="l00365"></a>00365   <span class="comment">// mapping.  The subdomain mapping will be independent of the processor mapping, and is </span>
<a name="l00366"></a>00366   <span class="comment">// defined by a simple mapping of the global indices we just found.</span>
<a name="l00367"></a>00367   {
<a name="l00368"></a>00368     std::vector&lt;unsigned int&gt; subdomain_bounds(libMesh::n_processors());
<a name="l00369"></a>00369 
<a name="l00370"></a>00370     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_elem = <a class="code" href="classParmetisPartitioner.php#a375ef9491cbd889f7038a266ce3500b4">_vtxdist</a>[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()];
<a name="l00371"></a>00371 
<a name="l00372"></a>00372     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00373"></a>00373       {
<a name="l00374"></a>00374         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tgt_subdomain_size = 0;
<a name="l00375"></a>00375         
<a name="l00376"></a>00376         <span class="comment">// watch out for the case that n_subdomains &lt; n_processors</span>
<a name="l00377"></a>00377         <span class="keywordflow">if</span> (pid &lt; static_cast&lt;unsigned int&gt;(<a class="code" href="classParmetisPartitioner.php#aee744f616d841bf6c09741190695ef8f">_nparts</a>))
<a name="l00378"></a>00378           {     
<a name="l00379"></a>00379             tgt_subdomain_size =
<a name="l00380"></a>00380               n_active_elem/<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(libMesh::n_processors(),
<a name="l00381"></a>00381                                      static_cast&lt;unsigned int&gt;(<a class="code" href="classParmetisPartitioner.php#aee744f616d841bf6c09741190695ef8f">_nparts</a>));
<a name="l00382"></a>00382             
<a name="l00383"></a>00383             <span class="keywordflow">if</span> (pid &lt; n_active_elem%<a class="code" href="classParmetisPartitioner.php#aee744f616d841bf6c09741190695ef8f">_nparts</a>)
<a name="l00384"></a>00384               tgt_subdomain_size++;
<a name="l00385"></a>00385           }
<a name="l00386"></a>00386         <span class="keywordflow">if</span> (pid == 0)
<a name="l00387"></a>00387           subdomain_bounds[0] = tgt_subdomain_size;
<a name="l00388"></a>00388         <span class="keywordflow">else</span>
<a name="l00389"></a>00389           subdomain_bounds[pid] = subdomain_bounds[pid-1] + tgt_subdomain_size;
<a name="l00390"></a>00390       }
<a name="l00391"></a>00391 
<a name="l00392"></a>00392     libmesh_assert (subdomain_bounds.back() == n_active_elem);
<a name="l00393"></a>00393 
<a name="l00394"></a>00394     <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       elem_it  = mesh.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00395"></a>00395     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> elem_end = mesh.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>();
<a name="l00396"></a>00396     
<a name="l00397"></a>00397     <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00398"></a>00398       {
<a name="l00399"></a>00399         <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *elem = *elem_it;
<a name="l00400"></a>00400         
<a name="l00401"></a>00401         libmesh_assert (<a class="code" href="classParmetisPartitioner.php#a7ab120fdf3c3c57ba3a70701b4cd8145">_global_index_by_pid_map</a>.count(elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()));
<a name="l00402"></a>00402         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_index_by_pid = 
<a name="l00403"></a>00403           <a class="code" href="classParmetisPartitioner.php#a7ab120fdf3c3c57ba3a70701b4cd8145">_global_index_by_pid_map</a>[elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()]; 
<a name="l00404"></a>00404         libmesh_assert (global_index_by_pid &lt; n_active_elem);
<a name="l00405"></a>00405         
<a name="l00406"></a>00406         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_index =
<a name="l00407"></a>00407           global_index_by_pid - first_local_elem;
<a name="l00408"></a>00408         
<a name="l00409"></a>00409         libmesh_assert (local_index &lt; n_active_local_elem);
<a name="l00410"></a>00410         libmesh_assert (local_index &lt; <a class="code" href="classParmetisPartitioner.php#a9c6f90f03338cca19eac448d901cfef3">_vwgt</a>.size());
<a name="l00411"></a>00411         
<a name="l00412"></a>00412         <span class="comment">// TODO:[BSK] maybe there is a better weight?</span>
<a name="l00413"></a>00413         <a class="code" href="classParmetisPartitioner.php#a9c6f90f03338cca19eac448d901cfef3">_vwgt</a>[local_index] = elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>();
<a name="l00414"></a>00414         
<a name="l00415"></a>00415         <span class="comment">// find the subdomain this element belongs in</span>
<a name="l00416"></a>00416         libmesh_assert (global_index_map.count(elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()));
<a name="l00417"></a>00417         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_index =
<a name="l00418"></a>00418           global_index_map[elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()];
<a name="l00419"></a>00419         
<a name="l00420"></a>00420         libmesh_assert (global_index &lt; subdomain_bounds.back());
<a name="l00421"></a>00421         
<a name="l00422"></a>00422         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id =
<a name="l00423"></a>00423           std::distance(subdomain_bounds.begin(),
<a name="l00424"></a>00424                         std::lower_bound(subdomain_bounds.begin(),
<a name="l00425"></a>00425                                          subdomain_bounds.end(),
<a name="l00426"></a>00426                                          global_index));
<a name="l00427"></a>00427         libmesh_assert (subdomain_id &lt; static_cast&lt;unsigned int&gt;(<a class="code" href="classParmetisPartitioner.php#aee744f616d841bf6c09741190695ef8f">_nparts</a>));
<a name="l00428"></a>00428         libmesh_assert (local_index &lt; <a class="code" href="classParmetisPartitioner.php#ab8a7824475eb678363f1a64c0c3ae605">_part</a>.size());
<a name="l00429"></a>00429           
<a name="l00430"></a>00430         <a class="code" href="classParmetisPartitioner.php#ab8a7824475eb678363f1a64c0c3ae605">_part</a>[local_index] = subdomain_id;
<a name="l00431"></a>00431       }    
<a name="l00432"></a>00432   }
<a name="l00433"></a>00433 }
<a name="l00434"></a>00434 
<a name="l00435"></a>00435 
<a name="l00436"></a>00436 
<a name="l00437"></a><a class="code" href="classParmetisPartitioner.php#ab3d3b5b5ad48e388179775a018a2d0c9">00437</a> <span class="keywordtype">void</span> <a class="code" href="classParmetisPartitioner.php#ab3d3b5b5ad48e388179775a018a2d0c9">ParmetisPartitioner::build_graph</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh)
<a name="l00438"></a>00438 {
<a name="l00439"></a>00439   <span class="comment">// build the graph in distributed CSR format.  Note that</span>
<a name="l00440"></a>00440   <span class="comment">// the edges in the graph will correspond to</span>
<a name="l00441"></a>00441   <span class="comment">// face neighbors</span>
<a name="l00442"></a>00442   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_active_local_elem  = mesh.<a class="code" href="classMeshBase.php#ac7a39d026a101d4312b9d39599fa1a45">n_active_local_elem</a>();
<a name="l00443"></a>00443     
<a name="l00444"></a>00444   std::vector&lt;const Elem*&gt; neighbors_offspring;
<a name="l00445"></a>00445   
<a name="l00446"></a>00446   std::vector&lt;std::vector&lt;unsigned int&gt; &gt; graph(n_active_local_elem);
<a name="l00447"></a>00447   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> graph_size=0;
<a name="l00448"></a>00448 
<a name="l00449"></a>00449   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_elem = <a class="code" href="classParmetisPartitioner.php#a375ef9491cbd889f7038a266ce3500b4">_vtxdist</a>[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()];
<a name="l00450"></a>00450   
<a name="l00451"></a>00451   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       elem_it  = mesh.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00452"></a>00452   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> elem_end = mesh.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>(); 
<a name="l00453"></a>00453   
<a name="l00454"></a>00454   <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00455"></a>00455     {
<a name="l00456"></a>00456       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *elem_it;
<a name="l00457"></a>00457         
<a name="l00458"></a>00458       libmesh_assert (<a class="code" href="classParmetisPartitioner.php#a7ab120fdf3c3c57ba3a70701b4cd8145">_global_index_by_pid_map</a>.count(elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()));
<a name="l00459"></a>00459       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_index_by_pid = 
<a name="l00460"></a>00460         <a class="code" href="classParmetisPartitioner.php#a7ab120fdf3c3c57ba3a70701b4cd8145">_global_index_by_pid_map</a>[elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()];   
<a name="l00461"></a>00461         
<a name="l00462"></a>00462       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_index =
<a name="l00463"></a>00463         global_index_by_pid - first_local_elem;
<a name="l00464"></a>00464       libmesh_assert (local_index &lt; n_active_local_elem);
<a name="l00465"></a>00465 
<a name="l00466"></a>00466       std::vector&lt;unsigned int&gt; &amp;graph_row = graph[local_index];
<a name="l00467"></a>00467 
<a name="l00468"></a>00468       <span class="comment">// Loop over the element&#39;s neighbors.  An element</span>
<a name="l00469"></a>00469       <span class="comment">// adjacency corresponds to a face neighbor</span>
<a name="l00470"></a>00470       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ms=0; ms&lt;elem-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); ms++)
<a name="l00471"></a>00471         {
<a name="l00472"></a>00472           <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* neighbor = elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(ms);
<a name="l00473"></a>00473           
<a name="l00474"></a>00474           <span class="keywordflow">if</span> (neighbor != NULL)
<a name="l00475"></a>00475             {  
<a name="l00476"></a>00476               <span class="comment">// If the neighbor is active treat it</span>
<a name="l00477"></a>00477               <span class="comment">// as a connection</span>
<a name="l00478"></a>00478               <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l00479"></a>00479                 {
<a name="l00480"></a>00480                   libmesh_assert(<a class="code" href="classParmetisPartitioner.php#a7ab120fdf3c3c57ba3a70701b4cd8145">_global_index_by_pid_map</a>.count(neighbor-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()));
<a name="l00481"></a>00481                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> neighbor_global_index_by_pid =
<a name="l00482"></a>00482                     <a class="code" href="classParmetisPartitioner.php#a7ab120fdf3c3c57ba3a70701b4cd8145">_global_index_by_pid_map</a>[neighbor-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()];
<a name="l00483"></a>00483                   
<a name="l00484"></a>00484                   graph_row.push_back(neighbor_global_index_by_pid);
<a name="l00485"></a>00485                   graph_size++;
<a name="l00486"></a>00486                 }
<a name="l00487"></a>00487   
<a name="l00488"></a>00488 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00489"></a>00489 <span class="preprocessor"></span>              
<a name="l00490"></a>00490               <span class="comment">// Otherwise we need to find all of the</span>
<a name="l00491"></a>00491               <span class="comment">// neighbor&#39;s children that are connected to</span>
<a name="l00492"></a>00492               <span class="comment">// us and add them</span>
<a name="l00493"></a>00493               <span class="keywordflow">else</span>
<a name="l00494"></a>00494                 {
<a name="l00495"></a>00495                   <span class="comment">// The side of the neighbor to which</span>
<a name="l00496"></a>00496                   <span class="comment">// we are connected</span>
<a name="l00497"></a>00497                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns =
<a name="l00498"></a>00498                     neighbor-&gt;<a class="code" href="classElem.php#acab8fea073846b18b149ed2b88d43aff">which_neighbor_am_i</a> (elem);
<a name="l00499"></a>00499                   libmesh_assert (ns &lt; neighbor-&gt;n_neighbors());
<a name="l00500"></a>00500                   
<a name="l00501"></a>00501                   <span class="comment">// Get all the active children (&amp; grandchildren, etc...)</span>
<a name="l00502"></a>00502                   <span class="comment">// of the neighbor.</span>
<a name="l00503"></a>00503                   neighbor-&gt;<a class="code" href="classElem.php#a51ae47d8c3c024b8dc1098b9392a1161">active_family_tree</a> (neighbors_offspring);
<a name="l00504"></a>00504                   
<a name="l00505"></a>00505                   <span class="comment">// Get all the neighbor&#39;s children that</span>
<a name="l00506"></a>00506                   <span class="comment">// live on that side and are thus connected</span>
<a name="l00507"></a>00507                   <span class="comment">// to us</span>
<a name="l00508"></a>00508                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc=0; nc&lt;neighbors_offspring.size(); nc++)
<a name="l00509"></a>00509                     {
<a name="l00510"></a>00510                       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* child =
<a name="l00511"></a>00511                         neighbors_offspring[nc];
<a name="l00512"></a>00512                       
<a name="l00513"></a>00513                       <span class="comment">// This does not assume a level-1 mesh.</span>
<a name="l00514"></a>00514                       <span class="comment">// Note that since children have sides numbered</span>
<a name="l00515"></a>00515                       <span class="comment">// coincident with the parent then this is a sufficient test.</span>
<a name="l00516"></a>00516                       <span class="keywordflow">if</span> (child-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(ns) == elem)
<a name="l00517"></a>00517                         {
<a name="l00518"></a>00518                           libmesh_assert (child-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>());
<a name="l00519"></a>00519                           libmesh_assert (<a class="code" href="classParmetisPartitioner.php#a7ab120fdf3c3c57ba3a70701b4cd8145">_global_index_by_pid_map</a>.count(child-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()));
<a name="l00520"></a>00520                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> child_global_index_by_pid =
<a name="l00521"></a>00521                             <a class="code" href="classParmetisPartitioner.php#a7ab120fdf3c3c57ba3a70701b4cd8145">_global_index_by_pid_map</a>[child-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()];
<a name="l00522"></a>00522 
<a name="l00523"></a>00523                           graph_row.push_back(child_global_index_by_pid);
<a name="l00524"></a>00524                           graph_size++;
<a name="l00525"></a>00525                         }
<a name="l00526"></a>00526                     }
<a name="l00527"></a>00527                 }
<a name="l00528"></a>00528 
<a name="l00529"></a>00529 <span class="preprocessor">#endif </span><span class="comment">/* ifdef LIBMESH_ENABLE_AMR */</span>
<a name="l00530"></a>00530 
<a name="l00531"></a>00531 
<a name="l00532"></a>00532             }
<a name="l00533"></a>00533         }
<a name="l00534"></a>00534     }
<a name="l00535"></a>00535 
<a name="l00536"></a>00536   <span class="comment">// Reserve space in the adjacency array</span>
<a name="l00537"></a>00537   <a class="code" href="classParmetisPartitioner.php#a5d6d2aa77f878805c4f40b36c0be61e0">_xadj</a>.clear();
<a name="l00538"></a>00538   <a class="code" href="classParmetisPartitioner.php#a5d6d2aa77f878805c4f40b36c0be61e0">_xadj</a>.reserve (n_active_local_elem + 1);
<a name="l00539"></a>00539   <a class="code" href="classParmetisPartitioner.php#a0e0de501be9649f0efe4cff232b66967">_adjncy</a>.clear();
<a name="l00540"></a>00540   <a class="code" href="classParmetisPartitioner.php#a0e0de501be9649f0efe4cff232b66967">_adjncy</a>.reserve (graph_size);
<a name="l00541"></a>00541 
<a name="l00542"></a>00542   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> r=0; r&lt;graph.size(); r++)
<a name="l00543"></a>00543     {
<a name="l00544"></a>00544       <a class="code" href="classParmetisPartitioner.php#a5d6d2aa77f878805c4f40b36c0be61e0">_xadj</a>.push_back(<a class="code" href="classParmetisPartitioner.php#a0e0de501be9649f0efe4cff232b66967">_adjncy</a>.size());
<a name="l00545"></a>00545       std::vector&lt;unsigned int&gt; graph_row; <span class="comment">// build this emtpy</span>
<a name="l00546"></a>00546       graph_row.swap(graph[r]); <span class="comment">// this will deallocate at the end of scope</span>
<a name="l00547"></a>00547       <a class="code" href="classParmetisPartitioner.php#a0e0de501be9649f0efe4cff232b66967">_adjncy</a>.insert(<a class="code" href="classParmetisPartitioner.php#a0e0de501be9649f0efe4cff232b66967">_adjncy</a>.end(),
<a name="l00548"></a>00548                      graph_row.begin(),
<a name="l00549"></a>00549                      graph_row.end());
<a name="l00550"></a>00550     }
<a name="l00551"></a>00551   
<a name="l00552"></a>00552   <span class="comment">// The end of the adjacency array for the last elem</span>
<a name="l00553"></a>00553   <a class="code" href="classParmetisPartitioner.php#a5d6d2aa77f878805c4f40b36c0be61e0">_xadj</a>.push_back(<a class="code" href="classParmetisPartitioner.php#a0e0de501be9649f0efe4cff232b66967">_adjncy</a>.size());
<a name="l00554"></a>00554   
<a name="l00555"></a>00555   libmesh_assert (<a class="code" href="classParmetisPartitioner.php#a5d6d2aa77f878805c4f40b36c0be61e0">_xadj</a>.size() == n_active_local_elem+1);
<a name="l00556"></a>00556   libmesh_assert (<a class="code" href="classParmetisPartitioner.php#a0e0de501be9649f0efe4cff232b66967">_adjncy</a>.size() == graph_size);
<a name="l00557"></a>00557 }
<a name="l00558"></a>00558 
<a name="l00559"></a>00559 
<a name="l00560"></a>00560 
<a name="l00561"></a><a class="code" href="classParmetisPartitioner.php#a178e642f66510fe3ea6d49a865846120">00561</a> <span class="keywordtype">void</span> <a class="code" href="classParmetisPartitioner.php#a178e642f66510fe3ea6d49a865846120">ParmetisPartitioner::assign_partitioning</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh)
<a name="l00562"></a>00562 {
<a name="l00563"></a>00563   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00564"></a>00564     first_local_elem = <a class="code" href="classParmetisPartitioner.php#a375ef9491cbd889f7038a266ce3500b4">_vtxdist</a>[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()];
<a name="l00565"></a>00565     
<a name="l00566"></a>00566   std::vector&lt;std::vector&lt;unsigned int&gt; &gt; 
<a name="l00567"></a>00567     requested_ids(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()),
<a name="l00568"></a>00568     requests_to_fill(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00569"></a>00569   
<a name="l00570"></a>00570   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_it  = mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00571"></a>00571   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>();
<a name="l00572"></a>00572     
<a name="l00573"></a>00573   <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00574"></a>00574     {   
<a name="l00575"></a>00575       <a class="code" href="classElem.php">Elem</a> *elem = *elem_it;
<a name="l00576"></a>00576 
<a name="l00577"></a>00577       <span class="comment">// we need to get the index from the owning processor</span>
<a name="l00578"></a>00578       <span class="comment">// (note we cannot assign it now -- we are iterating</span>
<a name="l00579"></a>00579       <span class="comment">// over elements again and this will be bad!)</span>
<a name="l00580"></a>00580       libmesh_assert (elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() &lt; requested_ids.size());
<a name="l00581"></a>00581       requested_ids[elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>()].push_back(elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>());
<a name="l00582"></a>00582     }
<a name="l00583"></a>00583   
<a name="l00584"></a>00584   <span class="comment">// Trade with all processors (including self) to get their indices</span>
<a name="l00585"></a>00585   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00586"></a>00586     {
<a name="l00587"></a>00587       <span class="comment">// Trade my requests with processor procup and procdown</span>
<a name="l00588"></a>00588       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procup = (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() + pid) %
<a name="l00589"></a>00589                                    libMesh::n_processors();
<a name="l00590"></a>00590       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procdown = (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() +
<a name="l00591"></a>00591                                      <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() - pid) %
<a name="l00592"></a>00592                                      libMesh::n_processors();
<a name="l00593"></a>00593 
<a name="l00594"></a>00594       Parallel::send_receive (procup,   requested_ids[procup],
<a name="l00595"></a>00595                               procdown, requests_to_fill[procdown]); 
<a name="l00596"></a>00596 
<a name="l00597"></a>00597       <span class="comment">// we can overwrite these requested ids in-place.</span>
<a name="l00598"></a>00598       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;requests_to_fill[procdown].size(); i++)
<a name="l00599"></a>00599         {
<a name="l00600"></a>00600           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> requested_elem_index = 
<a name="l00601"></a>00601             requests_to_fill[procdown][i];
<a name="l00602"></a>00602 
<a name="l00603"></a>00603           libmesh_assert(<a class="code" href="classParmetisPartitioner.php#a7ab120fdf3c3c57ba3a70701b4cd8145">_global_index_by_pid_map</a>.count(requested_elem_index));
<a name="l00604"></a>00604 
<a name="l00605"></a>00605           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_index_by_pid = 
<a name="l00606"></a>00606             <a class="code" href="classParmetisPartitioner.php#a7ab120fdf3c3c57ba3a70701b4cd8145">_global_index_by_pid_map</a>[requested_elem_index];
<a name="l00607"></a>00607 
<a name="l00608"></a>00608           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_index =
<a name="l00609"></a>00609             global_index_by_pid - first_local_elem;
<a name="l00610"></a>00610             
<a name="l00611"></a>00611           libmesh_assert (local_index &lt; <a class="code" href="classParmetisPartitioner.php#ab8a7824475eb678363f1a64c0c3ae605">_part</a>.size());
<a name="l00612"></a>00612           libmesh_assert (local_index &lt; mesh.<a class="code" href="classMeshBase.php#ac7a39d026a101d4312b9d39599fa1a45">n_active_local_elem</a>());
<a name="l00613"></a>00613           
<a name="l00614"></a>00614           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_procid =
<a name="l00615"></a>00615             <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(<a class="code" href="classParmetisPartitioner.php#ab8a7824475eb678363f1a64c0c3ae605">_part</a>[local_index]);
<a name="l00616"></a>00616 
<a name="l00617"></a>00617           libmesh_assert (elem_procid &lt; static_cast&lt;unsigned int&gt;(<a class="code" href="classParmetisPartitioner.php#aee744f616d841bf6c09741190695ef8f">_nparts</a>));
<a name="l00618"></a>00618 
<a name="l00619"></a>00619           requests_to_fill[procdown][i] = elem_procid;
<a name="l00620"></a>00620         }
<a name="l00621"></a>00621 
<a name="l00622"></a>00622       <span class="comment">// Trade back</span>
<a name="l00623"></a>00623       Parallel::send_receive (procdown, requests_to_fill[procdown],
<a name="l00624"></a>00624                               procup,   requested_ids[procup]);
<a name="l00625"></a>00625     }
<a name="l00626"></a>00626 
<a name="l00627"></a>00627    <span class="comment">// and finally assign the partitioning.</span>
<a name="l00628"></a>00628    <span class="comment">// note we are iterating in exactly the same order</span>
<a name="l00629"></a>00629    <span class="comment">// used to build up the request, so we can expect the</span>
<a name="l00630"></a>00630    <span class="comment">// required entries to be in the proper sequence.</span>
<a name="l00631"></a>00631    elem_it  = mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00632"></a>00632    elem_end = mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>();      
<a name="l00633"></a>00633    
<a name="l00634"></a>00634    <span class="keywordflow">for</span> (std::vector&lt;unsigned int&gt; counters(libMesh::n_processors(), 0);  
<a name="l00635"></a>00635         elem_it != elem_end; ++elem_it)
<a name="l00636"></a>00636      {  
<a name="l00637"></a>00637        <a class="code" href="classElem.php">Elem</a> *elem = *elem_it;
<a name="l00638"></a>00638        
<a name="l00639"></a>00639        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_pid = elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>();
<a name="l00640"></a>00640        
<a name="l00641"></a>00641        libmesh_assert (counters[current_pid] &lt; requested_ids[current_pid].size());
<a name="l00642"></a>00642        
<a name="l00643"></a>00643        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_procid = 
<a name="l00644"></a>00644          requested_ids[current_pid][counters[current_pid]++];
<a name="l00645"></a>00645        
<a name="l00646"></a>00646        libmesh_assert (elem_procid &lt; static_cast&lt;unsigned int&gt;(<a class="code" href="classParmetisPartitioner.php#aee744f616d841bf6c09741190695ef8f">_nparts</a>));
<a name="l00647"></a>00647        elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() = elem_procid;
<a name="l00648"></a>00648      }
<a name="l00649"></a>00649 }
<a name="l00650"></a>00650 
<a name="l00651"></a>00651 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_PARMETIS</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
