<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c614ad117abf49b5c733d084008febbb.php">partitioning</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>parmetis_partitioner.h</h1>  </div>
</div>
<div class="contents">
<a href="parmetis__partitioner_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: parmetis_partitioner.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __parmetis_partitioner_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __parmetis_partitioner_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="partitioner_8h.php">partitioner.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00040"></a>00040 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00041"></a>00041 <span class="comment">// ParmetisPartitioner class definition</span>
<a name="l00042"></a><a class="code" href="classParmetisPartitioner.php">00042</a> <span class="keyword">class </span><a class="code" href="classParmetisPartitioner.php">ParmetisPartitioner</a> : <span class="keyword">public</span> <a class="code" href="classPartitioner.php">Partitioner</a>
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044  <span class="keyword">public</span>:
<a name="l00045"></a>00045 
<a name="l00049"></a><a class="code" href="classParmetisPartitioner.php#a73c5d8cfb07a88d53acbe48bc4fdc132">00049</a>   <a class="code" href="classParmetisPartitioner.php#a73c5d8cfb07a88d53acbe48bc4fdc132">ParmetisPartitioner</a> () {}
<a name="l00050"></a>00050 
<a name="l00055"></a><a class="code" href="classParmetisPartitioner.php#ae938cac21da0024c4b7fe96d9baa8d54">00055</a>   <span class="keyword">virtual</span> <a class="code" href="classAutoPtr.php">AutoPtr&lt;Partitioner&gt;</a> <a class="code" href="classParmetisPartitioner.php#ae938cac21da0024c4b7fe96d9baa8d54">clone</a> ()<span class="keyword"> const </span>{
<a name="l00056"></a>00056     <a class="code" href="classAutoPtr.php">AutoPtr&lt;Partitioner&gt;</a> cloned_partitioner
<a name="l00057"></a>00057       (<span class="keyword">new</span> <a class="code" href="classParmetisPartitioner.php#a73c5d8cfb07a88d53acbe48bc4fdc132">ParmetisPartitioner</a>());
<a name="l00058"></a>00058     <span class="keywordflow">return</span> cloned_partitioner;
<a name="l00059"></a>00059   }
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 <span class="keyword">protected</span>:
<a name="l00063"></a>00063 
<a name="l00070"></a>00070   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classParmetisPartitioner.php#a435005ebb65587f6991e641eed03c1fb">_do_repartition</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00071"></a>00071                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l00072"></a>00072 
<a name="l00076"></a>00076   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classParmetisPartitioner.php#a7656f039e6db1a47788211c3527d64e1">_do_partition</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00077"></a>00077                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 <span class="keyword">private</span>:
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 <span class="comment">// These methods &amp; data only need to be available if the</span>
<a name="l00082"></a>00082 <span class="comment">// ParMETIS library is available.</span>
<a name="l00083"></a>00083 <span class="preprocessor">#ifdef LIBMESH_HAVE_PARMETIS</span>
<a name="l00084"></a>00084 <span class="preprocessor"></span>
<a name="l00088"></a>00088   <span class="keywordtype">void</span> <a class="code" href="classParmetisPartitioner.php#adb43bb39778d93f97e486eefcef69823">initialize</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sbdmns);
<a name="l00089"></a>00089   
<a name="l00093"></a>00093   <span class="keywordtype">void</span> <a class="code" href="classParmetisPartitioner.php#ab3d3b5b5ad48e388179775a018a2d0c9">build_graph</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00094"></a>00094 
<a name="l00098"></a>00098   <span class="keywordtype">void</span> <a class="code" href="classParmetisPartitioner.php#a178e642f66510fe3ea6d49a865846120">assign_partitioning</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00099"></a>00099 
<a name="l00105"></a><a class="code" href="classParmetisPartitioner.php#a713644a1e3be63ed4bb1fccdb8141d01">00105</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classParmetisPartitioner.php#a713644a1e3be63ed4bb1fccdb8141d01">_n_active_elem_on_proc</a>;
<a name="l00106"></a>00106   
<a name="l00110"></a><a class="code" href="classParmetisPartitioner.php#a7ab120fdf3c3c57ba3a70701b4cd8145">00110</a>   std::map&lt;unsigned int, unsigned int&gt; <a class="code" href="classParmetisPartitioner.php#a7ab120fdf3c3c57ba3a70701b4cd8145">_global_index_by_pid_map</a>;
<a name="l00111"></a>00111   
<a name="l00116"></a><a class="code" href="classParmetisPartitioner.php#a375ef9491cbd889f7038a266ce3500b4">00116</a>   std::vector&lt;int&gt;    <a class="code" href="classParmetisPartitioner.php#a375ef9491cbd889f7038a266ce3500b4">_vtxdist</a>;
<a name="l00117"></a><a class="code" href="classParmetisPartitioner.php#a5d6d2aa77f878805c4f40b36c0be61e0">00117</a>   std::vector&lt;int&gt;    <a class="code" href="classParmetisPartitioner.php#a5d6d2aa77f878805c4f40b36c0be61e0">_xadj</a>;
<a name="l00118"></a><a class="code" href="classParmetisPartitioner.php#a0e0de501be9649f0efe4cff232b66967">00118</a>   std::vector&lt;int&gt;    <a class="code" href="classParmetisPartitioner.php#a0e0de501be9649f0efe4cff232b66967">_adjncy</a>;
<a name="l00119"></a><a class="code" href="classParmetisPartitioner.php#ab8a7824475eb678363f1a64c0c3ae605">00119</a>   std::vector&lt;int&gt;    <a class="code" href="classParmetisPartitioner.php#ab8a7824475eb678363f1a64c0c3ae605">_part</a>;
<a name="l00120"></a><a class="code" href="classParmetisPartitioner.php#afb3c44e78e2eab08d9cba3b3fb8e7659">00120</a>   std::vector&lt;float&gt;  <a class="code" href="classParmetisPartitioner.php#afb3c44e78e2eab08d9cba3b3fb8e7659">_tpwgts</a>;
<a name="l00121"></a><a class="code" href="classParmetisPartitioner.php#ad3c4df598dbabed2b16abf754cc0dae1">00121</a>   std::vector&lt;float&gt;  <a class="code" href="classParmetisPartitioner.php#ad3c4df598dbabed2b16abf754cc0dae1">_ubvec</a>;
<a name="l00122"></a><a class="code" href="classParmetisPartitioner.php#a683c6bdccc33cfd7bcf5154803ca8e53">00122</a>   std::vector&lt;int&gt;    <a class="code" href="classParmetisPartitioner.php#a683c6bdccc33cfd7bcf5154803ca8e53">_options</a>;
<a name="l00123"></a><a class="code" href="classParmetisPartitioner.php#a9c6f90f03338cca19eac448d901cfef3">00123</a>   std::vector&lt;int&gt;    <a class="code" href="classParmetisPartitioner.php#a9c6f90f03338cca19eac448d901cfef3">_vwgt</a>;
<a name="l00124"></a>00124 
<a name="l00125"></a><a class="code" href="classParmetisPartitioner.php#a8cbbaea8a17a1efa2a5b48743702b599">00125</a>   <span class="keywordtype">int</span> <a class="code" href="classParmetisPartitioner.php#a8cbbaea8a17a1efa2a5b48743702b599">_wgtflag</a>;
<a name="l00126"></a><a class="code" href="classParmetisPartitioner.php#aadb14a86605bc19cce337ebc3a6ff2c5">00126</a>   <span class="keywordtype">int</span> <a class="code" href="classParmetisPartitioner.php#aadb14a86605bc19cce337ebc3a6ff2c5">_ncon</a>;
<a name="l00127"></a><a class="code" href="classParmetisPartitioner.php#ad7a902f3d2dfaa83dd9caa96bbea9c2e">00127</a>   <span class="keywordtype">int</span> <a class="code" href="classParmetisPartitioner.php#ad7a902f3d2dfaa83dd9caa96bbea9c2e">_numflag</a>;
<a name="l00128"></a><a class="code" href="classParmetisPartitioner.php#aee744f616d841bf6c09741190695ef8f">00128</a>   <span class="keywordtype">int</span> <a class="code" href="classParmetisPartitioner.php#aee744f616d841bf6c09741190695ef8f">_nparts</a>;
<a name="l00129"></a><a class="code" href="classParmetisPartitioner.php#a825106e4a8706676a7236e8175638e45">00129</a>   <span class="keywordtype">int</span> <a class="code" href="classParmetisPartitioner.php#a825106e4a8706676a7236e8175638e45">_edgecut</a>;
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 <span class="preprocessor">#endif</span>
<a name="l00132"></a>00132 <span class="preprocessor"></span>};
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 <span class="preprocessor">#endif // #define __parmetis_partitioner_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
