<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c614ad117abf49b5c733d084008febbb.php">partitioning</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>partitioner.h</h1>  </div>
</div>
<div class="contents">
<a href="partitioner_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: partitioner.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __partitioner_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __partitioner_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;auto_ptr.h&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Forward Declarations</span>
<a name="l00032"></a>00032 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00043"></a>00043 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00044"></a>00044 <span class="comment">// Partitioner class definition</span>
<a name="l00045"></a><a class="code" href="classPartitioner.php">00045</a> <span class="keyword">class </span><a class="code" href="classPartitioner.php">Partitioner</a>
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047  <span class="keyword">public</span>:
<a name="l00048"></a>00048 
<a name="l00052"></a><a class="code" href="classPartitioner.php#ab3788db43d9594c28b201255991e85c2">00052</a>   <a class="code" href="classPartitioner.php#ab3788db43d9594c28b201255991e85c2">Partitioner</a> () {}
<a name="l00053"></a>00053   
<a name="l00057"></a><a class="code" href="classPartitioner.php#a8adefe825a9988129017f650bac676d4">00057</a>   <span class="keyword">virtual</span> <a class="code" href="classPartitioner.php#a8adefe825a9988129017f650bac676d4">~Partitioner</a>() {}
<a name="l00058"></a>00058 
<a name="l00065"></a>00065   <span class="keyword">virtual</span> <a class="code" href="classAutoPtr.php">AutoPtr&lt;Partitioner&gt;</a> <a class="code" href="classPartitioner.php#a36a3fe6fd17cda3a61d9f4c8000e5306">clone</a> () <span class="keyword">const</span> = 0;
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00078"></a>00078   <span class="keywordtype">void</span> <a class="code" href="classPartitioner.php#a6c8f1c4dac2b50c4ed0e30088e0c4063">partition</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00079"></a>00079                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00080"></a>00080 
<a name="l00087"></a>00087   <span class="keywordtype">void</span> <a class="code" href="classPartitioner.php#a329cc64c5ef27067f7480fb9932c6332">repartition</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00088"></a>00088                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00089"></a>00089 
<a name="l00093"></a>00093   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classPartitioner.php#ae2acaba47c3b5314fddc15abf3ceb05a">partition_unpartitioned_elements</a> (<a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh, 
<a name="l00094"></a>00094                                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00095"></a>00095 
<a name="l00101"></a>00101   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classPartitioner.php#a03a69ca8eef475a2d23ca2f4887ab70d">set_parent_processor_ids</a>(<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00102"></a>00102 
<a name="l00108"></a>00108   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classPartitioner.php#adc818fcff7a1cdc8c2eff63c72ac7a42">set_node_processor_ids</a>(<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00109"></a>00109   
<a name="l00110"></a>00110 <span class="keyword">protected</span>:
<a name="l00111"></a>00111 
<a name="l00118"></a>00118   <span class="keywordtype">void</span> <a class="code" href="classPartitioner.php#a1108dd58c055d536d489dc06cc0823ec">single_partition</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00119"></a>00119 
<a name="l00125"></a>00125   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPartitioner.php#a9aaa83a69c99c21233e66f09900b63b8">_do_partition</a>(<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00126"></a>00126                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) = 0;
<a name="l00127"></a>00127 
<a name="l00133"></a><a class="code" href="classPartitioner.php#a6206b079e66de9f84dc7bddd1a251503">00133</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPartitioner.php#a6206b079e66de9f84dc7bddd1a251503">_do_repartition</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00134"></a>00134                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) { this-&gt;<a class="code" href="classPartitioner.php#a9aaa83a69c99c21233e66f09900b63b8">_do_partition</a> (mesh, n); }
<a name="l00135"></a>00135 
<a name="l00140"></a><a class="code" href="classPartitioner.php#a8f04a45f7cd717a59a715efe910b8603">00140</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPartitioner.php#a8f04a45f7cd717a59a715efe910b8603">communication_blocksize</a>;
<a name="l00141"></a>00141 };
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
