<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>patch.h</h1>  </div>
</div>
<div class="contents">
<a href="patch_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 <span class="comment">// $Id: patch.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00005"></a>00005 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00006"></a>00006   
<a name="l00007"></a>00007 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00008"></a>00008 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00009"></a>00009 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00010"></a>00010 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00011"></a>00011   
<a name="l00012"></a>00012 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00013"></a>00013 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00014"></a>00014 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00015"></a>00015 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00016"></a>00016   
<a name="l00017"></a>00017 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00018"></a>00018 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00019"></a>00019 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifndef __patch_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#define __patch_h__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Forward Declarations</span>
<a name="l00032"></a>00032 <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00043"></a><a class="code" href="classPatch.php">00043</a> <span class="keyword">class </span><a class="code" href="classPatch.php">Patch</a> : <span class="keyword">public</span> std::set&lt;const Elem *&gt;
<a name="l00044"></a>00044 {
<a name="l00045"></a>00045 <span class="keyword">public</span>:
<a name="l00046"></a>00046 
<a name="l00050"></a><a class="code" href="classPatch.php#a65fdd4bb128b8f50c1b9dcc008f20360">00050</a>   <a class="code" href="classPatch.php#a65fdd4bb128b8f50c1b9dcc008f20360">Patch</a>() {}
<a name="l00051"></a>00051   
<a name="l00055"></a><a class="code" href="classPatch.php#aa048c71e9e5a671e111d1ecee25df183">00055</a>   <a class="code" href="classPatch.php#aa048c71e9e5a671e111d1ecee25df183">~Patch</a>() {}
<a name="l00056"></a>00056 
<a name="l00061"></a>00061   <span class="keywordtype">void</span> <a class="code" href="classPatch.php#a38238748ccd74cde71c47e7edcbfb18a">add_face_neighbors</a>();
<a name="l00062"></a>00062 
<a name="l00067"></a>00067   <span class="keywordtype">void</span> <a class="code" href="classPatch.php#a131103f21fe3d743f74efb423f83df9b">add_local_face_neighbors</a>();
<a name="l00068"></a>00068 
<a name="l00073"></a>00073   <span class="keywordtype">void</span> <a class="code" href="classPatch.php#a1e67f107aa62706f9b35dc6f2fc9bc24">add_point_neighbors</a>();
<a name="l00074"></a>00074 
<a name="l00079"></a>00079   <span class="keywordtype">void</span> <a class="code" href="classPatch.php#a8a2f3d8163cfe64d8b5979b0cbd90aec">add_local_point_neighbors</a>();
<a name="l00080"></a>00080 
<a name="l00084"></a><a class="code" href="classPatch.php#a94f979b3d9cf0075c0b17b89cc05c474">00084</a>   <span class="keyword">typedef</span> void (<a class="code" href="classPatch.php">Patch</a>::*<a class="code" href="classPatch.php#a94f979b3d9cf0075c0b17b89cc05c474">PMF</a>)();
<a name="l00085"></a>00085 
<a name="l00093"></a>00093   <span class="keywordtype">void</span> <a class="code" href="classPatch.php#a034ff7f955be2a4fd9135d92bbb0b002">build_around_element</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00094"></a>00094                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> target_patch_size = 10,
<a name="l00095"></a>00095                             <a class="code" href="classPatch.php#a94f979b3d9cf0075c0b17b89cc05c474">PMF</a> patchtype = &amp;<a class="code" href="classPatch.php#a131103f21fe3d743f74efb423f83df9b">Patch::add_local_face_neighbors</a>);
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 <span class="keyword">protected</span>:
<a name="l00098"></a>00098 
<a name="l00103"></a>00103   <span class="keywordtype">void</span> <a class="code" href="classPatch.php#ac92a3d2cfa69e45dcd71c01074e55c4d">find_face_neighbors</a>(std::set&lt;const Elem *&gt; &amp;neighbor_set);
<a name="l00104"></a>00104 
<a name="l00109"></a>00109   <span class="keywordtype">void</span> <a class="code" href="classPatch.php#a355674b34dfc6bd6c1203dbe8ec299ef">find_point_neighbors</a>(std::set&lt;const Elem *&gt; &amp;neighbor_set);
<a name="l00110"></a>00110 };
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 <span class="preprocessor">#endif // #define __patch_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
