<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_570b8306c88722caf9b7ae131e1a07b6.php">error_estimation</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>patch_recovery_error_estimator.C</h1>  </div>
</div>
<div class="contents">
<a href="patch__recovery__error__estimator_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: patch_recovery_error_estimator.C 3437 2009-07-18 21:02:18Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::fill</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;cmath&gt;</span>     <span class="comment">// for std::sqrt std::pow std::abs</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local Includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;patch_recovery_error_estimator.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;dof_map.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;fe.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;dense_matrix.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;dense_vector.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;error_vector.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;quadrature_gauss.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;patch.h&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;quadrature_grid.h&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;system.h&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;mesh.h&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &quot;tensor_value.h&quot;</span>
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00046"></a>00046 <span class="comment">// PatchRecoveryErrorEstimator implementations</span>
<a name="l00047"></a><a class="code" href="classPatchRecoveryErrorEstimator.php#a32f27e8ffd66cf390a65624286fb254c">00047</a> std::vector&lt;Real&gt; <a class="code" href="classPatchRecoveryErrorEstimator.php#a32f27e8ffd66cf390a65624286fb254c">PatchRecoveryErrorEstimator::specpoly</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00048"></a>00048                                                         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00049"></a>00049                                                         <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> p,
<a name="l00050"></a>00050                                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> matsize)
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052   std::vector&lt;Real&gt; psi;
<a name="l00053"></a>00053   psi.reserve(matsize);
<a name="l00054"></a>00054   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> x = p(0), y=0., z=0.;
<a name="l00055"></a>00055   <span class="keywordflow">if</span> (dim &gt; 1)
<a name="l00056"></a>00056     y = p(1);
<a name="l00057"></a>00057   <span class="keywordflow">if</span> (dim &gt; 2)
<a name="l00058"></a>00058     z = p(2);
<a name="l00059"></a>00059     
<a name="l00060"></a>00060   <span class="comment">// builds psi vector of form 1 x y z x^2 xy xz y^2 yz z^2 etc..</span>
<a name="l00061"></a>00061   <span class="comment">// I haven&#39;t added 1D support here</span>
<a name="l00062"></a>00062   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> poly_deg=0; poly_deg &lt;= static_cast&lt;unsigned int&gt;(order) ; poly_deg++)
<a name="l00063"></a>00063     { <span class="comment">// loop over all polynomials of total degreee = poly_deg</span>
<a name="l00064"></a>00064 
<a name="l00065"></a>00065       <span class="keywordflow">switch</span> (dim)
<a name="l00066"></a>00066         {
<a name="l00067"></a>00067           <span class="comment">// 3D spectral polynomial basis functions</span>
<a name="l00068"></a>00068         <span class="keywordflow">case</span> 3:
<a name="l00069"></a>00069           {     
<a name="l00070"></a>00070             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> xexp=poly_deg; xexp &gt;= 0; xexp--) <span class="comment">// use an int for xexp since we -- it</span>
<a name="l00071"></a>00071               <span class="keywordflow">for</span> (<span class="keywordtype">int</span> yexp=poly_deg-xexp; yexp &gt;= 0; yexp--)
<a name="l00072"></a>00072                 {
<a name="l00073"></a>00073                   <span class="keywordtype">int</span> zexp = poly_deg - xexp - yexp;
<a name="l00074"></a>00074                   psi.push_back(<a class="code" href="namespaceUtility.php#aa31a2ff44b735ae86eea0446796a3b42">std::pow</a>(x,static_cast&lt;Real&gt;(xexp))*
<a name="l00075"></a>00075                                 <a class="code" href="namespaceUtility.php#aa31a2ff44b735ae86eea0446796a3b42">std::pow</a>(y,static_cast&lt;Real&gt;(yexp))*
<a name="l00076"></a>00076                                 <a class="code" href="namespaceUtility.php#aa31a2ff44b735ae86eea0446796a3b42">std::pow</a>(z,static_cast&lt;Real&gt;(zexp)));
<a name="l00077"></a>00077                 }
<a name="l00078"></a>00078             <span class="keywordflow">break</span>;
<a name="l00079"></a>00079           }
<a name="l00080"></a>00080 
<a name="l00081"></a>00081           <span class="comment">// 2D spectral polynomial basis functions</span>
<a name="l00082"></a>00082         <span class="keywordflow">case</span> 2:
<a name="l00083"></a>00083           {
<a name="l00084"></a>00084             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> xexp=poly_deg; xexp &gt;= 0; xexp--) <span class="comment">// use an int for xexp since we -- it</span>
<a name="l00085"></a>00085               {
<a name="l00086"></a>00086                 <span class="keywordtype">int</span> yexp = poly_deg - xexp;
<a name="l00087"></a>00087                 psi.push_back(<a class="code" href="namespaceUtility.php#aa31a2ff44b735ae86eea0446796a3b42">std::pow</a>(x,static_cast&lt;Real&gt;(xexp))*
<a name="l00088"></a>00088                               <a class="code" href="namespaceUtility.php#aa31a2ff44b735ae86eea0446796a3b42">std::pow</a>(y,static_cast&lt;Real&gt;(yexp)));
<a name="l00089"></a>00089               }
<a name="l00090"></a>00090             <span class="keywordflow">break</span>;
<a name="l00091"></a>00091           }
<a name="l00092"></a>00092 
<a name="l00093"></a>00093           <span class="comment">// 1D spectral polynomial basis functions</span>
<a name="l00094"></a>00094         <span class="keywordflow">case</span> 1:
<a name="l00095"></a>00095           {
<a name="l00096"></a>00096             <span class="keywordtype">int</span> xexp = poly_deg;
<a name="l00097"></a>00097             psi.push_back(<a class="code" href="namespaceUtility.php#aa31a2ff44b735ae86eea0446796a3b42">std::pow</a>(x,static_cast&lt;Real&gt;(xexp)));
<a name="l00098"></a>00098             <span class="keywordflow">break</span>;
<a name="l00099"></a>00099           }
<a name="l00100"></a>00100           
<a name="l00101"></a>00101         <span class="keywordflow">default</span>:
<a name="l00102"></a>00102           libmesh_error();
<a name="l00103"></a>00103         }
<a name="l00104"></a>00104     }
<a name="l00105"></a>00105 
<a name="l00106"></a>00106   <span class="keywordflow">return</span> psi;
<a name="l00107"></a>00107 }
<a name="l00108"></a>00108     
<a name="l00109"></a>00109   
<a name="l00110"></a>00110 
<a name="l00111"></a><a class="code" href="classPatchRecoveryErrorEstimator.php#a4d7ba78c48aa6660890eecedd8fc5c0b">00111</a> <span class="keywordtype">void</span> <a class="code" href="classPatchRecoveryErrorEstimator.php#a4d7ba78c48aa6660890eecedd8fc5c0b">PatchRecoveryErrorEstimator::estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; system,
<a name="l00112"></a>00112                                                   <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00113"></a>00113                                                   <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector,
<a name="l00114"></a>00114                                                   <span class="keywordtype">bool</span>)
<a name="l00115"></a>00115 {
<a name="l00116"></a>00116   START_LOG(<span class="stringliteral">&quot;estimate_error()&quot;</span>, <span class="stringliteral">&quot;PatchRecoveryErrorEstimator&quot;</span>);
<a name="l00117"></a>00117 
<a name="l00118"></a>00118   <span class="comment">// The current mesh</span>
<a name="l00119"></a>00119   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh = system.<a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">get_mesh</a>();
<a name="l00120"></a>00120   
<a name="l00121"></a>00121   <span class="comment">// Resize the error_per_cell vector to be</span>
<a name="l00122"></a>00122   <span class="comment">// the number of elements, initialize it to 0.</span>
<a name="l00123"></a>00123   error_per_cell.resize (mesh.<a class="code" href="classMeshBase.php#a05c0414e5c91b36e9698fc4f60cff642">max_elem_id</a>());
<a name="l00124"></a>00124   std::fill (error_per_cell.begin(), error_per_cell.end(), 0.);
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   <span class="comment">// Prepare current_local_solution to localize a non-standard</span>
<a name="l00127"></a>00127   <span class="comment">// solution vector if necessary</span>
<a name="l00128"></a>00128   <span class="keywordflow">if</span> (solution_vector &amp;&amp; solution_vector != system.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>())
<a name="l00129"></a>00129     {
<a name="l00130"></a>00130       <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* newsol =
<a name="l00131"></a>00131         <span class="keyword">const_cast&lt;</span><a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>*<span class="keyword">&gt;</span>(solution_vector);
<a name="l00132"></a>00132       <a class="code" href="classSystem.php">System</a> &amp;sys = <span class="keyword">const_cast&lt;</span><a class="code" href="classSystem.php">System</a>&amp;<span class="keyword">&gt;</span>(system);
<a name="l00133"></a>00133       newsol-&gt;<a class="code" href="classNumericVector.php#a51e2011eeca6faa30e349c1950352eb8">swap</a>(*sys.solution);
<a name="l00134"></a>00134       sys.update();
<a name="l00135"></a>00135     }
<a name="l00136"></a>00136   
<a name="l00137"></a>00137   <span class="comment">//------------------------------------------------------------</span>
<a name="l00138"></a>00138   <span class="comment">// Iterate over all the active elements in the mesh</span>
<a name="l00139"></a>00139   <span class="comment">// that live on this processor.</span>
<a name="l00140"></a>00140   <a class="code" href="namespaceThreads.php#a9eb02a1b3f006c37843c907a3b5c0581">Threads::parallel_for</a> (<a class="code" href="elem__range_8h.php#ab9d765fb756f937643f885587e18beda">ConstElemRange</a>(mesh.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>(),
<a name="l00141"></a>00141                                         mesh.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>(),
<a name="l00142"></a>00142                                         200),
<a name="l00143"></a>00143                          <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php">EstimateError</a>(system,
<a name="l00144"></a>00144                                        *<span class="keyword">this</span>,
<a name="l00145"></a>00145                                        error_per_cell)
<a name="l00146"></a>00146                          );
<a name="l00147"></a>00147 
<a name="l00148"></a>00148   <span class="comment">// Each processor has now computed the error contribuions</span>
<a name="l00149"></a>00149   <span class="comment">// for its local elements, and error_per_cell contains 0 for all the</span>
<a name="l00150"></a>00150   <span class="comment">// non-local elements.  Summing the vector will provide the L_oo value</span>
<a name="l00151"></a>00151   <span class="comment">// for each element, local or remote</span>
<a name="l00152"></a>00152   this-&gt;<a class="code" href="classErrorEstimator.php#a6b108b6e9e10fd97df826209c15c8618">reduce_error</a>(error_per_cell);
<a name="l00153"></a>00153   
<a name="l00154"></a>00154   <span class="comment">// If we used a non-standard solution before, now is the time to fix</span>
<a name="l00155"></a>00155   <span class="comment">// the current_local_solution</span>
<a name="l00156"></a>00156   <span class="keywordflow">if</span> (solution_vector &amp;&amp; solution_vector != system.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>())
<a name="l00157"></a>00157     {
<a name="l00158"></a>00158       <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* newsol =
<a name="l00159"></a>00159         <span class="keyword">const_cast&lt;</span><a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>*<span class="keyword">&gt;</span>(solution_vector);
<a name="l00160"></a>00160       <a class="code" href="classSystem.php">System</a> &amp;sys = <span class="keyword">const_cast&lt;</span><a class="code" href="classSystem.php">System</a>&amp;<span class="keyword">&gt;</span>(system);
<a name="l00161"></a>00161       newsol-&gt;<a class="code" href="classNumericVector.php#a51e2011eeca6faa30e349c1950352eb8">swap</a>(*sys.solution);
<a name="l00162"></a>00162       sys.update();
<a name="l00163"></a>00163     }
<a name="l00164"></a>00164 
<a name="l00165"></a>00165   STOP_LOG(<span class="stringliteral">&quot;estimate_error()&quot;</span>, <span class="stringliteral">&quot;PatchRecoveryErrorEstimator&quot;</span>);
<a name="l00166"></a>00166 }
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00170"></a><a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a90a64e0df05dcd28232f2ec0bcc46156">00170</a> <span class="keywordtype">void</span> <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a90a64e0df05dcd28232f2ec0bcc46156">PatchRecoveryErrorEstimator::EstimateError::operator()</a>(<span class="keyword">const</span> <a class="code" href="classStoredRange.php">ConstElemRange</a> &amp;range)<span class="keyword"> const</span>
<a name="l00171"></a>00171 <span class="keyword"></span>{
<a name="l00172"></a>00172   <span class="comment">// The current mesh</span>
<a name="l00173"></a>00173   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh = <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#ae32f0e41f8abe5c81d3c1a469a74c970">system</a>.<a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">get_mesh</a>();
<a name="l00174"></a>00174 
<a name="l00175"></a>00175   <span class="comment">// The dimensionality of the mesh</span>
<a name="l00176"></a>00176   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = mesh.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>();
<a name="l00177"></a>00177   
<a name="l00178"></a>00178   <span class="comment">// The number of variables in the system</span>
<a name="l00179"></a>00179   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_vars = <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#ae32f0e41f8abe5c81d3c1a469a74c970">system</a>.<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>();
<a name="l00180"></a>00180   
<a name="l00181"></a>00181   <span class="comment">// The DofMap for this system</span>
<a name="l00182"></a>00182   <span class="keyword">const</span> <a class="code" href="classDofMap.php">DofMap</a>&amp; dof_map = <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#ae32f0e41f8abe5c81d3c1a469a74c970">system</a>.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>();
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 
<a name="l00185"></a>00185   <span class="comment">//------------------------------------------------------------</span>
<a name="l00186"></a>00186   <span class="comment">// Iterate over all the elements in the range.</span>
<a name="l00187"></a>00187   <span class="keywordflow">for</span> (<a class="code" href="classStoredRange.php#ab2657352e8f9c79ab6fa4085c0bdd0d8">ConstElemRange::const_iterator</a> elem_it=range.<a class="code" href="classStoredRange.php#a5f753b5b424dff3ab8030ce64d7a9f0a">begin</a>(); elem_it!=range.<a class="code" href="classStoredRange.php#abc8b19e0ebe76d4cda84e870e652fcf6">end</a>(); ++elem_it)
<a name="l00188"></a>00188     {
<a name="l00189"></a>00189       <span class="comment">// elem is necessarily an active element on the local processor</span>
<a name="l00190"></a>00190       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *elem_it;
<a name="l00191"></a>00191 
<a name="l00192"></a>00192       <span class="comment">// We&#39;ll need an index into the error vector</span>
<a name="l00193"></a>00193       <span class="keyword">const</span> <span class="keywordtype">int</span> e_id=elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l00194"></a>00194 
<a name="l00195"></a>00195       <span class="comment">// Build a patch containing the current element</span>
<a name="l00196"></a>00196       <span class="comment">// and its neighbors on the local processor</span>
<a name="l00197"></a>00197       <a class="code" href="classPatch.php">Patch</a> patch;
<a name="l00198"></a>00198 
<a name="l00199"></a>00199       <span class="comment">// Use user specified patch size and growth strategy</span>
<a name="l00200"></a>00200       patch.<a class="code" href="classPatch.php#a034ff7f955be2a4fd9135d92bbb0b002">build_around_element</a> (elem, <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classPatchRecoveryErrorEstimator.php#ab2cc0e031b3982b6a7d50864fca42553">target_patch_size</a>,
<a name="l00201"></a>00201                                   <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classPatchRecoveryErrorEstimator.php#a4670a8e094be2d71463384adae82523e">patch_growth_strategy</a>);
<a name="l00202"></a>00202 
<a name="l00203"></a>00203       <span class="comment">//------------------------------------------------------------</span>
<a name="l00204"></a>00204       <span class="comment">// Process each variable in the system using the current patch</span>
<a name="l00205"></a>00205       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;n_vars; var++)
<a name="l00206"></a>00206         {
<a name="l00207"></a>00207 <span class="preprocessor">#ifndef DEBUG</span>
<a name="l00208"></a>00208 <span class="preprocessor"></span><span class="preprocessor">  #ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00209"></a>00209 <span class="preprocessor"></span>          libmesh_assert (<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a> ||
<a name="l00210"></a>00210                           <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a> ||
<a name="l00211"></a>00211                           <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a4b61e006ed8d92ee72c5b9f15b812357">W1_INF_SEMINORM</a> ||
<a name="l00212"></a>00212                           <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad02dfe2efa80354e38555ad2e5a206d6">W2_INF_SEMINORM</a>);
<a name="l00213"></a>00213 <span class="preprocessor">  #else</span>
<a name="l00214"></a>00214 <span class="preprocessor"></span>          libmesh_assert (<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a> ||
<a name="l00215"></a>00215                           <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a4b61e006ed8d92ee72c5b9f15b812357">W1_INF_SEMINORM</a>);
<a name="l00216"></a>00216 <span class="preprocessor">  #endif</span>
<a name="l00217"></a>00217 <span class="preprocessor"></span>          <span class="keywordflow">if</span> (var &gt; 0)
<a name="l00218"></a>00218             <span class="comment">// We can&#39;t mix L_inf and L_2 norms</span>
<a name="l00219"></a>00219             libmesh_assert (((<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a> ||
<a name="l00220"></a>00220                               <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a>) &amp;&amp;
<a name="l00221"></a>00221                              (<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var-1) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a> ||
<a name="l00222"></a>00222                               <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var-1) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a>)) ||
<a name="l00223"></a>00223                             ((<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a4b61e006ed8d92ee72c5b9f15b812357">W1_INF_SEMINORM</a> ||
<a name="l00224"></a>00224                               <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad02dfe2efa80354e38555ad2e5a206d6">W2_INF_SEMINORM</a>) &amp;&amp;
<a name="l00225"></a>00225                              (<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var-1) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a4b61e006ed8d92ee72c5b9f15b812357">W1_INF_SEMINORM</a> ||
<a name="l00226"></a>00226                               <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var-1) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad02dfe2efa80354e38555ad2e5a206d6">W2_INF_SEMINORM</a>)));
<a name="l00227"></a>00227 <span class="preprocessor">#endif</span>
<a name="l00228"></a>00228 <span class="preprocessor"></span>
<a name="l00229"></a>00229           <span class="comment">// Possibly skip this variable</span>
<a name="l00230"></a>00230           <span class="keywordflow">if</span> (<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#ae8b33ea25655f66a4acc368c79723fed">weight</a>(var) == 0.0) <span class="keywordflow">continue</span>;
<a name="l00231"></a>00231           
<a name="l00232"></a>00232           <span class="comment">// The type of finite element to use for this variable</span>
<a name="l00233"></a>00233           <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_type = dof_map.<a class="code" href="classDofMap.php#ae3c63266417020f38af6e5cc40efca76">variable_type</a> (var);
<a name="l00234"></a>00234 
<a name="l00235"></a>00235           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> element_order  = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>
<a name="l00236"></a>00236             (fe_type.<a class="code" href="classFEType.php#a72c29a6dbf3f2a84728111122cec4742">order</a> + elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>());
<a name="l00237"></a>00237       
<a name="l00238"></a>00238           <span class="comment">// Finite element object for use in this patch</span>
<a name="l00239"></a>00239           <a class="code" href="classAutoPtr.php">AutoPtr&lt;FEBase&gt;</a> fe (<a class="code" href="classFEBase.php#a3e86219b79ce4f881e9c48f4fd7b860e">FEBase::build</a> (dim, fe_type));
<a name="l00240"></a>00240           
<a name="l00241"></a>00241           <span class="comment">// Build an appropriate Gaussian quadrature rule</span>
<a name="l00242"></a>00242           <a class="code" href="classAutoPtr.php">AutoPtr&lt;QBase&gt;</a> qrule (fe_type.<a class="code" href="classFEType.php#a33013296ee9643faec0262714ad9163c">default_quadrature_rule</a>(dim));
<a name="l00243"></a>00243 
<a name="l00244"></a>00244           <span class="comment">// Tell the finite element about the quadrature rule.</span>
<a name="l00245"></a>00245           fe-&gt;attach_quadrature_rule (qrule.get());
<a name="l00246"></a>00246       
<a name="l00247"></a>00247           <span class="comment">// Get Jacobian values, etc..</span>
<a name="l00248"></a>00248           <span class="keyword">const</span> std::vector&lt;Real&gt;&amp;                       JxW     = fe-&gt;get_JxW();
<a name="l00249"></a>00249           <span class="keyword">const</span> std::vector&lt;Point&gt;&amp;                      q_point = fe-&gt;get_xyz();
<a name="l00250"></a>00250 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00251"></a>00251 <span class="preprocessor"></span>          <span class="comment">// We only use phi below to assert that the dof_indices</span>
<a name="l00252"></a>00252           <span class="comment">// vector has the correct size.  So we avoid declaring it</span>
<a name="l00253"></a>00253           <span class="comment">// here unless asserts are active.</span>
<a name="l00254"></a>00254           <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp;         phi     = fe-&gt;get_phi();
<a name="l00255"></a>00255 <span class="preprocessor">#endif</span>
<a name="l00256"></a>00256 <span class="preprocessor"></span>          <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt; *dphi = NULL;
<a name="l00257"></a>00257           <span class="keywordflow">if</span> (<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a> ||
<a name="l00258"></a>00258               <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a4b61e006ed8d92ee72c5b9f15b812357">W1_INF_SEMINORM</a>)
<a name="l00259"></a>00259             dphi = &amp;(fe-&gt;get_dphi());
<a name="l00260"></a>00260 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00261"></a>00261 <span class="preprocessor"></span>          <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealTensor&gt; &gt;  *d2phi = NULL;
<a name="l00262"></a>00262           <span class="keywordflow">if</span> (<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a> ||
<a name="l00263"></a>00263               <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a4b61e006ed8d92ee72c5b9f15b812357">W1_INF_SEMINORM</a>)
<a name="l00264"></a>00264             d2phi = &amp;(fe-&gt;get_d2phi());
<a name="l00265"></a>00265 <span class="preprocessor">#endif</span>
<a name="l00266"></a>00266 <span class="preprocessor"></span>      
<a name="l00267"></a>00267           <span class="comment">// global DOF indices</span>
<a name="l00268"></a>00268           std::vector&lt;unsigned int&gt; dof_indices;
<a name="l00269"></a>00269 
<a name="l00270"></a>00270           <span class="comment">// Compute the approprite size for the patch projection matrices</span>
<a name="l00271"></a>00271           <span class="comment">// and vectors; </span>
<a name="l00272"></a>00272           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> matsize = element_order + 1;
<a name="l00273"></a>00273           <span class="keywordflow">if</span> (dim &gt; 1)
<a name="l00274"></a>00274             {
<a name="l00275"></a>00275               matsize *= (element_order + 2);
<a name="l00276"></a>00276               matsize /= 2;
<a name="l00277"></a>00277             }
<a name="l00278"></a>00278           <span class="keywordflow">if</span> (dim &gt; 2)
<a name="l00279"></a>00279             {
<a name="l00280"></a>00280               matsize *= (element_order + 3);
<a name="l00281"></a>00281               matsize /= 3;
<a name="l00282"></a>00282             }
<a name="l00283"></a>00283                   
<a name="l00284"></a>00284           <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Number&gt;</a> Kp(matsize,matsize);
<a name="l00285"></a>00285           <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a>
<a name="l00286"></a>00286             Fx(matsize), Pu_x_h(matsize), <span class="comment">// Also xx</span>
<a name="l00287"></a>00287             Fy(matsize), Pu_y_h(matsize), <span class="comment">// Also yy</span>
<a name="l00288"></a>00288             Fz(matsize), Pu_z_h(matsize); <span class="comment">// Also zz</span>
<a name="l00289"></a>00289           <a class="code" href="classDenseVector.php">DenseVector&lt;Number&gt;</a> Fxy, Pu_xy_h, Fxz, Pu_xz_h, Fyz, Pu_yz_h;
<a name="l00290"></a>00290           <span class="keywordflow">if</span> (<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a> ||
<a name="l00291"></a>00291               <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad02dfe2efa80354e38555ad2e5a206d6">W2_INF_SEMINORM</a>)
<a name="l00292"></a>00292             {
<a name="l00293"></a>00293               Fxy.<a class="code" href="classDenseVector.php#a3a9af103dc052f1dfdef1626692cd8cd">resize</a>(matsize); Pu_xy_h.<a class="code" href="classDenseVector.php#a3a9af103dc052f1dfdef1626692cd8cd">resize</a>(matsize);
<a name="l00294"></a>00294               Fxz.<a class="code" href="classDenseVector.php#a3a9af103dc052f1dfdef1626692cd8cd">resize</a>(matsize); Pu_xz_h.<a class="code" href="classDenseVector.php#a3a9af103dc052f1dfdef1626692cd8cd">resize</a>(matsize);
<a name="l00295"></a>00295               Fyz.<a class="code" href="classDenseVector.php#a3a9af103dc052f1dfdef1626692cd8cd">resize</a>(matsize); Pu_yz_h.<a class="code" href="classDenseVector.php#a3a9af103dc052f1dfdef1626692cd8cd">resize</a>(matsize);
<a name="l00296"></a>00296             }
<a name="l00297"></a>00297 
<a name="l00298"></a>00298           <span class="comment">//------------------------------------------------------</span>
<a name="l00299"></a>00299           <span class="comment">// Loop over each element in the patch and compute their</span>
<a name="l00300"></a>00300           <span class="comment">// contribution to the patch gradient projection.</span>
<a name="l00301"></a>00301           Patch::const_iterator        patch_it  = patch.begin();
<a name="l00302"></a>00302           <span class="keyword">const</span> Patch::const_iterator  patch_end = patch.end();
<a name="l00303"></a>00303 
<a name="l00304"></a>00304           <span class="keywordflow">for</span> (; patch_it != patch_end; ++patch_it)
<a name="l00305"></a>00305             {
<a name="l00306"></a>00306               <span class="comment">// The pth element in the patch</span>
<a name="l00307"></a>00307               <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* e_p = *patch_it;
<a name="l00308"></a>00308 
<a name="l00309"></a>00309               <span class="comment">// Reinitialize the finite element data for this element</span>
<a name="l00310"></a>00310               fe-&gt;reinit (e_p);
<a name="l00311"></a>00311 
<a name="l00312"></a>00312               <span class="comment">// Get the global DOF indices for the current variable</span>
<a name="l00313"></a>00313               <span class="comment">// in the current element</span>
<a name="l00314"></a>00314               dof_map.<a class="code" href="classDofMap.php#afc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (e_p, dof_indices, var);
<a name="l00315"></a>00315               libmesh_assert (dof_indices.size() == phi.size());
<a name="l00316"></a>00316 
<a name="l00317"></a>00317               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = dof_indices.size();
<a name="l00318"></a>00318               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp   = qrule-&gt;n_points();
<a name="l00319"></a>00319 
<a name="l00320"></a>00320               <span class="comment">// Compute the projection components from this cell.</span>
<a name="l00321"></a>00321               <span class="comment">// \int_{Omega_e} \psi_i \psi_j = \int_{Omega_e} du_h/dx_k \psi_i</span>
<a name="l00322"></a>00322               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;n_qp; qp++)
<a name="l00323"></a>00323                 {
<a name="l00324"></a>00324                   <span class="comment">// Construct the shape function values for the patch projection</span>
<a name="l00325"></a>00325                   std::vector&lt;Real&gt; psi(<a class="code" href="classPatchRecoveryErrorEstimator.php#a32f27e8ffd66cf390a65624286fb254c">specpoly</a>(dim, element_order, q_point[qp], matsize));
<a name="l00326"></a>00326                   
<a name="l00327"></a>00327                   <span class="comment">// Patch matrix contribution</span>
<a name="l00328"></a>00328                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;Kp.<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>(); i++)
<a name="l00329"></a>00329                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;Kp.<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>(); j++)
<a name="l00330"></a>00330                       Kp(i,j) += JxW[qp]*psi[i]*psi[j];
<a name="l00331"></a>00331 
<a name="l00332"></a>00332                   <span class="keywordflow">if</span> (<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a> ||
<a name="l00333"></a>00333                       <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a4b61e006ed8d92ee72c5b9f15b812357">W1_INF_SEMINORM</a>)
<a name="l00334"></a>00334                     {
<a name="l00335"></a>00335                       <span class="comment">// Compute the gradient on the current patch element</span>
<a name="l00336"></a>00336                       <span class="comment">// at the quadrature point</span>
<a name="l00337"></a>00337                       <a class="code" href="classVectorValue.php">Gradient</a> grad_u_h;
<a name="l00338"></a>00338 
<a name="l00339"></a>00339                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs; i++)
<a name="l00340"></a>00340                         grad_u_h.<a class="code" href="classTypeVector.php#ac9000695cb19991b893cb79a07249e9c">add_scaled</a> ((*dphi)[i][qp],
<a name="l00341"></a>00341                                              <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#ae32f0e41f8abe5c81d3c1a469a74c970">system</a>.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(dof_indices[i]));
<a name="l00342"></a>00342                   
<a name="l00343"></a>00343                       <span class="comment">// Patch RHS contributions</span>
<a name="l00344"></a>00344                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;psi.size(); i++)
<a name="l00345"></a>00345                         {
<a name="l00346"></a>00346                           Fx(i) += JxW[qp]*grad_u_h(0)*psi[i];
<a name="l00347"></a>00347                           Fy(i) += JxW[qp]*grad_u_h(1)*psi[i];
<a name="l00348"></a>00348                           Fz(i) += JxW[qp]*grad_u_h(2)*psi[i];
<a name="l00349"></a>00349                         }
<a name="l00350"></a>00350                     }
<a name="l00351"></a>00351                   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a> ||
<a name="l00352"></a>00352                            <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad02dfe2efa80354e38555ad2e5a206d6">W2_INF_SEMINORM</a>)
<a name="l00353"></a>00353                     {
<a name="l00354"></a>00354 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00355"></a>00355 <span class="preprocessor"></span>                      <span class="comment">// Compute the hessian on the current patch element</span>
<a name="l00356"></a>00356                       <span class="comment">// at the quadrature point</span>
<a name="l00357"></a>00357                       <a class="code" href="classTensorValue.php">Tensor</a> hess_u_h;
<a name="l00358"></a>00358 
<a name="l00359"></a>00359                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs; i++)
<a name="l00360"></a>00360                         hess_u_h.<a class="code" href="classTypeTensor.php#ae24569251bc6ea38090165d349fdfc6c">add_scaled</a> ((*d2phi)[i][qp],
<a name="l00361"></a>00361                                              <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#ae32f0e41f8abe5c81d3c1a469a74c970">system</a>.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(dof_indices[i]));
<a name="l00362"></a>00362 
<a name="l00363"></a>00363                       <span class="comment">// Patch RHS contributions</span>
<a name="l00364"></a>00364                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;psi.size(); i++)
<a name="l00365"></a>00365                         {
<a name="l00366"></a>00366                           Fx(i)  += JxW[qp]*hess_u_h(0,0)*psi[i];
<a name="l00367"></a>00367                           Fy(i)  += JxW[qp]*hess_u_h(1,1)*psi[i];
<a name="l00368"></a>00368                           Fz(i)  += JxW[qp]*hess_u_h(2,2)*psi[i];
<a name="l00369"></a>00369                           Fxy(i) += JxW[qp]*hess_u_h(0,1)*psi[i];
<a name="l00370"></a>00370                           Fxz(i) += JxW[qp]*hess_u_h(0,2)*psi[i];
<a name="l00371"></a>00371                           Fyz(i) += JxW[qp]*hess_u_h(1,2)*psi[i];
<a name="l00372"></a>00372                         }
<a name="l00373"></a>00373 <span class="preprocessor">#else</span>
<a name="l00374"></a>00374 <span class="preprocessor"></span>                      std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR:  --enable-second-derivatives is required\n&quot;</span>
<a name="l00375"></a>00375                                 &lt;&lt; <span class="stringliteral">&quot;        for _sobolev_order == 2!\n&quot;</span>;
<a name="l00376"></a>00376                       libmesh_error();
<a name="l00377"></a>00377 <span class="preprocessor">#endif</span>
<a name="l00378"></a>00378 <span class="preprocessor"></span>                    }
<a name="l00379"></a>00379                   <span class="keywordflow">else</span>
<a name="l00380"></a>00380                     libmesh_error();
<a name="l00381"></a>00381                 } <span class="comment">// end quadrature loop</span>
<a name="l00382"></a>00382             } <span class="comment">// end patch loop</span>
<a name="l00383"></a>00383           
<a name="l00384"></a>00384 
<a name="l00385"></a>00385           
<a name="l00386"></a>00386           <span class="comment">//--------------------------------------------------</span>
<a name="l00387"></a>00387           <span class="comment">// Now we have fully assembled the projection system</span>
<a name="l00388"></a>00388           <span class="comment">// for this patch.  Project the gradient components.</span>
<a name="l00389"></a>00389           <span class="comment">// MAY NEED TO USE PARTIAL PIVOTING!</span>
<a name="l00390"></a>00390           Kp.<a class="code" href="classDenseMatrix.php#a477240f22a12d4bcf761b490414f4491">lu_solve</a> (Fx, Pu_x_h);
<a name="l00391"></a>00391           Kp.<a class="code" href="classDenseMatrix.php#a477240f22a12d4bcf761b490414f4491">lu_solve</a> (Fy, Pu_y_h);
<a name="l00392"></a>00392           Kp.<a class="code" href="classDenseMatrix.php#a477240f22a12d4bcf761b490414f4491">lu_solve</a> (Fz, Pu_z_h);
<a name="l00393"></a>00393           <span class="keywordflow">if</span> (<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a> ||
<a name="l00394"></a>00394               <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad02dfe2efa80354e38555ad2e5a206d6">W2_INF_SEMINORM</a>)
<a name="l00395"></a>00395             {
<a name="l00396"></a>00396               Kp.<a class="code" href="classDenseMatrix.php#a477240f22a12d4bcf761b490414f4491">lu_solve</a>(Fxy, Pu_xy_h);
<a name="l00397"></a>00397               Kp.<a class="code" href="classDenseMatrix.php#a477240f22a12d4bcf761b490414f4491">lu_solve</a>(Fxz, Pu_xz_h);
<a name="l00398"></a>00398               Kp.<a class="code" href="classDenseMatrix.php#a477240f22a12d4bcf761b490414f4491">lu_solve</a>(Fyz, Pu_yz_h);
<a name="l00399"></a>00399             }
<a name="l00400"></a>00400           
<a name="l00401"></a>00401           <span class="comment">//--------------------------------------------------</span>
<a name="l00402"></a>00402           <span class="comment">// Finally, estimate the error in the current variable</span>
<a name="l00403"></a>00403           <span class="comment">// for the current element by computing ||P grad_u_h - grad_u_h||</span>
<a name="l00404"></a>00404           <span class="comment">// or ||P hess_u_h - hess_u_h|| according to the requested</span>
<a name="l00405"></a>00405           <span class="comment">// seminorm</span>
<a name="l00406"></a>00406 
<a name="l00407"></a>00407           dof_map.<a class="code" href="classDofMap.php#afc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (elem, dof_indices, var);
<a name="l00408"></a>00408           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = dof_indices.size();
<a name="l00409"></a>00409           
<a name="l00410"></a>00410           <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> element_error = 0;
<a name="l00411"></a>00411 
<a name="l00412"></a>00412           <span class="comment">// we approximate the max norm by sampling over a set of points</span>
<a name="l00413"></a>00413           <span class="comment">// in future we may add specialized routines for specific cases</span>
<a name="l00414"></a>00414           <span class="comment">// or use some optimization package</span>
<a name="l00415"></a>00415           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> qorder = element_order;
<a name="l00416"></a>00416 
<a name="l00417"></a>00417           <span class="comment">// build a &quot;fake&quot; quadrature rule for the element</span>
<a name="l00418"></a>00418           <span class="comment">//</span>
<a name="l00419"></a>00419           <span class="comment">// For linear elements, grad is a constant, so we need</span>
<a name="l00420"></a>00420           <span class="comment">// to compute grad u_h once on the element.  Also as G_H</span>
<a name="l00421"></a>00421           <span class="comment">// u_h - gradu_h is linear on an element, it assumes its</span>
<a name="l00422"></a>00422           <span class="comment">// maximum at a vertex of the element</span>
<a name="l00423"></a>00423 
<a name="l00424"></a>00424           <a class="code" href="classQGrid.php">QGrid</a> samprule (dim, qorder);
<a name="l00425"></a>00425 
<a name="l00426"></a>00426           <span class="keywordflow">if</span> (<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a4b61e006ed8d92ee72c5b9f15b812357">W1_INF_SEMINORM</a> ||
<a name="l00427"></a>00427               <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad02dfe2efa80354e38555ad2e5a206d6">W2_INF_SEMINORM</a>)
<a name="l00428"></a>00428             fe-&gt;attach_quadrature_rule (&amp;samprule);
<a name="l00429"></a>00429 
<a name="l00430"></a>00430           <span class="comment">// reinitialize element for integration or sampling</span>
<a name="l00431"></a>00431           fe-&gt;reinit(elem);
<a name="l00432"></a>00432               
<a name="l00433"></a>00433           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sp = JxW.size();
<a name="l00434"></a>00434           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sp=0; sp&lt; n_sp; sp++)
<a name="l00435"></a>00435             {
<a name="l00436"></a>00436               std::vector&lt;Number&gt; temperr(6,0.0); <span class="comment">// x,y,z or xx,yy,zz,xy,xz,yz</span>
<a name="l00437"></a>00437           
<a name="l00438"></a>00438               <span class="keywordflow">if</span> (<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a> ||
<a name="l00439"></a>00439                   <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a4b61e006ed8d92ee72c5b9f15b812357">W1_INF_SEMINORM</a>)
<a name="l00440"></a>00440                 {
<a name="l00441"></a>00441                   <span class="comment">// Compute the gradient at the current sample point</span>
<a name="l00442"></a>00442                   <a class="code" href="classVectorValue.php">Gradient</a> grad_u_h;
<a name="l00443"></a>00443           
<a name="l00444"></a>00444                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs; i++)
<a name="l00445"></a>00445                     grad_u_h.<a class="code" href="classTypeVector.php#ac9000695cb19991b893cb79a07249e9c">add_scaled</a> ((*dphi)[i][sp],
<a name="l00446"></a>00446                                          <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#ae32f0e41f8abe5c81d3c1a469a74c970">system</a>.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(dof_indices[i]));
<a name="l00447"></a>00447                   <span class="comment">// Compute the phi values at the current sample point</span>
<a name="l00448"></a>00448                   std::vector&lt;Real&gt; psi(<a class="code" href="classPatchRecoveryErrorEstimator.php#a32f27e8ffd66cf390a65624286fb254c">specpoly</a>(dim, element_order, q_point[sp], matsize));
<a name="l00449"></a>00449                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;matsize; i++)
<a name="l00450"></a>00450                     {
<a name="l00451"></a>00451                       temperr[0] += psi[i]*Pu_x_h(i);
<a name="l00452"></a>00452                       temperr[1] += psi[i]*Pu_y_h(i);
<a name="l00453"></a>00453                       temperr[2] += psi[i]*Pu_z_h(i);
<a name="l00454"></a>00454                     }
<a name="l00455"></a>00455                   temperr[0] -= grad_u_h(0);
<a name="l00456"></a>00456                   temperr[1] -= grad_u_h(1);
<a name="l00457"></a>00457                   temperr[2] -= grad_u_h(2);
<a name="l00458"></a>00458                 }
<a name="l00459"></a>00459               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a> ||
<a name="l00460"></a>00460                        <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad02dfe2efa80354e38555ad2e5a206d6">W2_INF_SEMINORM</a>)
<a name="l00461"></a>00461                 {
<a name="l00462"></a>00462 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00463"></a>00463 <span class="preprocessor"></span>                  <span class="comment">// Compute the Hessian at the current sample point</span>
<a name="l00464"></a>00464                   <a class="code" href="classTensorValue.php">Tensor</a> hess_u_h;
<a name="l00465"></a>00465           
<a name="l00466"></a>00466                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs; i++)
<a name="l00467"></a>00467                     hess_u_h.<a class="code" href="classTypeTensor.php#ae24569251bc6ea38090165d349fdfc6c">add_scaled</a> ((*d2phi)[i][sp],
<a name="l00468"></a>00468                                          <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#ae32f0e41f8abe5c81d3c1a469a74c970">system</a>.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(dof_indices[i]));
<a name="l00469"></a>00469                   <span class="comment">// Compute the phi values at the current sample point</span>
<a name="l00470"></a>00470                   std::vector&lt;Real&gt; psi(<a class="code" href="classPatchRecoveryErrorEstimator.php#a32f27e8ffd66cf390a65624286fb254c">specpoly</a>(dim, element_order, q_point[sp], matsize));
<a name="l00471"></a>00471                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;matsize; i++)
<a name="l00472"></a>00472                     {
<a name="l00473"></a>00473                       temperr[0] += psi[i]*Pu_x_h(i);
<a name="l00474"></a>00474                       temperr[1] += psi[i]*Pu_y_h(i);
<a name="l00475"></a>00475                       temperr[2] += psi[i]*Pu_z_h(i);
<a name="l00476"></a>00476                       temperr[3] += psi[i]*Pu_xy_h(i);
<a name="l00477"></a>00477                       temperr[4] += psi[i]*Pu_xz_h(i);
<a name="l00478"></a>00478                       temperr[5] += psi[i]*Pu_yz_h(i);
<a name="l00479"></a>00479                     }
<a name="l00480"></a>00480                   temperr[0] -= hess_u_h(0,0);
<a name="l00481"></a>00481                   temperr[1] -= hess_u_h(1,1);
<a name="l00482"></a>00482                   temperr[2] -= hess_u_h(2,2);
<a name="l00483"></a>00483                   temperr[3] -= hess_u_h(0,1);
<a name="l00484"></a>00484                   temperr[4] -= hess_u_h(0,2);
<a name="l00485"></a>00485                   temperr[5] -= hess_u_h(1,2);
<a name="l00486"></a>00486 <span class="preprocessor">#else</span>
<a name="l00487"></a>00487 <span class="preprocessor"></span>                      std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR:  --enable-second-derivatives is required\n&quot;</span>
<a name="l00488"></a>00488                                 &lt;&lt; <span class="stringliteral">&quot;        for _sobolev_order == 2!\n&quot;</span>;
<a name="l00489"></a>00489                       libmesh_error();
<a name="l00490"></a>00490 <span class="preprocessor">#endif</span>
<a name="l00491"></a>00491 <span class="preprocessor"></span>                }
<a name="l00492"></a>00492               <span class="keywordflow">if</span> (<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a4b61e006ed8d92ee72c5b9f15b812357">W1_INF_SEMINORM</a>)
<a name="l00493"></a>00493                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != 3; ++i)
<a name="l00494"></a>00494                   element_error = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(element_error, std::abs(temperr[i]));
<a name="l00495"></a>00495               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad02dfe2efa80354e38555ad2e5a206d6">W2_INF_SEMINORM</a>)
<a name="l00496"></a>00496                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != 6; ++i)
<a name="l00497"></a>00497                   element_error = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(element_error, std::abs(temperr[i]));
<a name="l00498"></a>00498               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a>)
<a name="l00499"></a>00499                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != 3; ++i)
<a name="l00500"></a>00500                   element_error += JxW[sp]*<a class="code" href="libmesh__common_8h.php#af9cdd07341b53cc644199f6aec5e1420">libmesh_norm</a>(temperr[i]);
<a name="l00501"></a>00501               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a>)
<a name="l00502"></a>00502                 {
<a name="l00503"></a>00503                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != 3; ++i)
<a name="l00504"></a>00504                     element_error += JxW[sp]*<a class="code" href="libmesh__common_8h.php#af9cdd07341b53cc644199f6aec5e1420">libmesh_norm</a>(temperr[i]);
<a name="l00505"></a>00505                 <span class="comment">// Off diagonal terms enter into the Hessian norm twice</span>
<a name="l00506"></a>00506                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=3; i != 6; ++i)
<a name="l00507"></a>00507                     element_error += JxW[sp]*2*<a class="code" href="libmesh__common_8h.php#af9cdd07341b53cc644199f6aec5e1420">libmesh_norm</a>(temperr[i]);
<a name="l00508"></a>00508                 }
<a name="l00509"></a>00509 
<a name="l00510"></a>00510             } <span class="comment">// end sample_point_loop</span>
<a name="l00511"></a>00511 
<a name="l00512"></a>00512           <span class="comment">// The patch error estimator works element-by-element --</span>
<a name="l00513"></a>00513           <span class="comment">// there is no need to get a mutex on error_per_cell!</span>
<a name="l00514"></a>00514           <span class="keywordflow">if</span> (<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a4b61e006ed8d92ee72c5b9f15b812357">W1_INF_SEMINORM</a> ||
<a name="l00515"></a>00515               <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad02dfe2efa80354e38555ad2e5a206d6">W2_INF_SEMINORM</a>)
<a name="l00516"></a>00516             <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a2198bdc32f83254c5ac74aca51c1ff91">error_per_cell</a>[e_id] += <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#ae8b33ea25655f66a4acc368c79723fed">weight</a>(var) * element_error;       
<a name="l00517"></a>00517           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a> ||
<a name="l00518"></a>00518                    <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a>)
<a name="l00519"></a>00519             <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a2198bdc32f83254c5ac74aca51c1ff91">error_per_cell</a>[e_id] += <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a5a1f8483b61f9a931014352ca678f684">weight_sq</a>(var) * element_error;    
<a name="l00520"></a>00520           <span class="keywordflow">else</span>
<a name="l00521"></a>00521             libmesh_error();
<a name="l00522"></a>00522         } <span class="comment">// end variable loop  </span>
<a name="l00523"></a>00523 
<a name="l00524"></a>00524       <span class="keywordflow">if</span> (<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(0) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a> ||
<a name="l00525"></a>00525           <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>.<a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(0) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a>)
<a name="l00526"></a>00526         <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a2198bdc32f83254c5ac74aca51c1ff91">error_per_cell</a>[e_id] = std::sqrt(<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a2198bdc32f83254c5ac74aca51c1ff91">error_per_cell</a>[e_id]);
<a name="l00527"></a>00527 
<a name="l00528"></a>00528     } <span class="comment">// end element loop</span>
<a name="l00529"></a>00529 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
