<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c8cf73965feff5280e8b0581da1a9d14.php">error_estimation</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>patch_recovery_error_estimator.h</h1>  </div>
</div>
<div class="contents">
<a href="patch__recovery__error__estimator_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: patch_recovery_error_estimator.h 3428 2009-07-17 01:51:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __patch_recovery_error_estimator_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __patch_recovery_error_estimator_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="error__estimator_8h.php">error_estimator.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;enum_order.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;patch.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;point.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;elem_range.h&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Forward Declarations</span>
<a name="l00036"></a>00036 <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00045"></a><a class="code" href="classPatchRecoveryErrorEstimator.php">00045</a> <span class="keyword">class </span><a class="code" href="classPatchRecoveryErrorEstimator.php">PatchRecoveryErrorEstimator</a> : <span class="keyword">public</span> <a class="code" href="classErrorEstimator.php">ErrorEstimator</a>
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047 <span class="keyword">public</span>:
<a name="l00048"></a>00048 
<a name="l00054"></a><a class="code" href="classPatchRecoveryErrorEstimator.php#afa574e3d4ce9cb7a798f2dec32d60d2f">00054</a>   <a class="code" href="classPatchRecoveryErrorEstimator.php#afa574e3d4ce9cb7a798f2dec32d60d2f">PatchRecoveryErrorEstimator</a>() :
<a name="l00055"></a>00055     <a class="code" href="classPatchRecoveryErrorEstimator.php#ab2cc0e031b3982b6a7d50864fca42553">target_patch_size</a>(20),
<a name="l00056"></a>00056     <a class="code" href="classPatchRecoveryErrorEstimator.php#a4670a8e094be2d71463384adae82523e">patch_growth_strategy</a>(&amp;<a class="code" href="classPatch.php">Patch</a>::add_local_face_neighbors) 
<a name="l00057"></a>00057   { <a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a> = <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a>; }
<a name="l00058"></a>00058   
<a name="l00062"></a><a class="code" href="classPatchRecoveryErrorEstimator.php#a0ff6fb2ea0064038020dab57f43c12f2">00062</a>   <a class="code" href="classPatchRecoveryErrorEstimator.php#a0ff6fb2ea0064038020dab57f43c12f2">~PatchRecoveryErrorEstimator</a>() {}
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00071"></a>00071   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPatchRecoveryErrorEstimator.php#a4d7ba78c48aa6660890eecedd8fc5c0b">estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; system,
<a name="l00072"></a>00072                                <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00073"></a>00073                                <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector = NULL,
<a name="l00074"></a>00074                                <span class="keywordtype">bool</span> estimate_parent_error = <span class="keyword">false</span>);
<a name="l00075"></a>00075 
<a name="l00080"></a><a class="code" href="classPatchRecoveryErrorEstimator.php#ab2cc0e031b3982b6a7d50864fca42553">00080</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPatchRecoveryErrorEstimator.php#ab2cc0e031b3982b6a7d50864fca42553">target_patch_size</a>;
<a name="l00081"></a>00081 
<a name="l00088"></a><a class="code" href="classPatchRecoveryErrorEstimator.php#a4670a8e094be2d71463384adae82523e">00088</a>   <a class="code" href="classPatch.php#a94f979b3d9cf0075c0b17b89cc05c474">Patch::PMF</a> <a class="code" href="classPatchRecoveryErrorEstimator.php#a4670a8e094be2d71463384adae82523e">patch_growth_strategy</a>;
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 <span class="keyword">private</span>:
<a name="l00091"></a>00091 
<a name="l00096"></a>00096   <span class="keyword">static</span> std::vector&lt;Real&gt; <a class="code" href="classPatchRecoveryErrorEstimator.php#a32f27e8ffd66cf390a65624286fb254c">specpoly</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00097"></a>00097                                     <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00098"></a>00098                                     <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> p,
<a name="l00099"></a>00099                                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> matsize);
<a name="l00100"></a>00100 
<a name="l00105"></a><a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php">00105</a>   <span class="keyword">class </span><a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php">EstimateError</a>
<a name="l00106"></a>00106   {
<a name="l00107"></a>00107   <span class="keyword">public</span>:
<a name="l00108"></a><a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a769ecb76e19f477136825ba117d91807">00108</a>     <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a769ecb76e19f477136825ba117d91807">EstimateError</a> (<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; sys,
<a name="l00109"></a>00109                    <span class="keyword">const</span> <a class="code" href="classPatchRecoveryErrorEstimator.php">PatchRecoveryErrorEstimator</a> &amp;ee,
<a name="l00110"></a>00110                    <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; epc) :
<a name="l00111"></a>00111       <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#ae32f0e41f8abe5c81d3c1a469a74c970">system</a>(sys),
<a name="l00112"></a>00112       <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>(ee),
<a name="l00113"></a>00113       <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a2198bdc32f83254c5ac74aca51c1ff91">error_per_cell</a>(epc)
<a name="l00114"></a>00114     {}
<a name="l00115"></a>00115 
<a name="l00116"></a>00116     <span class="keywordtype">void</span> <a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a90a64e0df05dcd28232f2ec0bcc46156">operator()</a>(<span class="keyword">const</span> <a class="code" href="classStoredRange.php">ConstElemRange</a> &amp;range) <span class="keyword">const</span>;
<a name="l00117"></a>00117     
<a name="l00118"></a>00118   <span class="keyword">private</span>:
<a name="l00119"></a>00119 
<a name="l00120"></a><a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#ae32f0e41f8abe5c81d3c1a469a74c970">00120</a>     <span class="keyword">const</span> <a class="code" href="classSystem.php">System</a> &amp;<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#ae32f0e41f8abe5c81d3c1a469a74c970">system</a>;
<a name="l00121"></a><a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">00121</a>     <span class="keyword">const</span> <a class="code" href="classPatchRecoveryErrorEstimator.php">PatchRecoveryErrorEstimator</a> &amp;<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a211206345a4ae9376f1f7f60d2f4c380">error_estimator</a>;
<a name="l00122"></a><a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a2198bdc32f83254c5ac74aca51c1ff91">00122</a>     <a class="code" href="classErrorVector.php">ErrorVector</a> &amp;<a class="code" href="classPatchRecoveryErrorEstimator_1_1EstimateError.php#a2198bdc32f83254c5ac74aca51c1ff91">error_per_cell</a>;    
<a name="l00123"></a>00123   };
<a name="l00124"></a>00124 
<a name="l00125"></a><a class="code" href="classPatchRecoveryErrorEstimator.php#aa8c9786c7c61b4a781fbce7dc6767a56">00125</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classPatchRecoveryErrorEstimator.php#aa8c9786c7c61b4a781fbce7dc6767a56">EsitmateError</a>;
<a name="l00126"></a>00126 };
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 <span class="preprocessor">#endif // #define __patch_recovery_error_estimator_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
