<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_4f64d75cac7489d141591c33108e86ff.php">utils</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>perf_log.h</h1>  </div>
</div>
<div class="contents">
<a href="perf__log_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: perf_log.h 3403 2009-06-16 18:01:45Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __perflog_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __perflog_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="o__string__stream_8h.php">o_string_stream.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// C++ includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &lt;stack&gt;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &lt;sys/time.h&gt;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="preprocessor">#ifdef LIBMESH_HAVE_LOCALE</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span><span class="preprocessor">#include &lt;locale&gt;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#endif</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span>
<a name="l00040"></a>00040 <span class="comment">// Forward Declarations</span>
<a name="l00041"></a>00041 <span class="comment">// class OStringStream;</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00049"></a>00049 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00050"></a>00050 <span class="comment">// PerfData class definition</span>
<a name="l00051"></a><a class="code" href="classPerfData.php">00051</a> <span class="keyword">class </span><a class="code" href="classPerfData.php">PerfData</a>
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053  <span class="keyword">public</span>:
<a name="l00054"></a>00054 
<a name="l00058"></a><a class="code" href="classPerfData.php#a4074383c71452e25e788cb1ef7638006">00058</a>   <a class="code" href="classPerfData.php#a4074383c71452e25e788cb1ef7638006">PerfData</a> () :
<a name="l00059"></a>00059     <a class="code" href="classPerfData.php#a62b084835472576f517dcbdcba003650">tot_time</a>(0.),
<a name="l00060"></a>00060     <a class="code" href="classPerfData.php#a21638248b97b5a6c60ab9229ac103cc6">tot_time_incl_sub</a>(0.),
<a name="l00061"></a>00061     <a class="code" href="classPerfData.php#a8bba34efb86fda1fce8ca4c7cb043f03">count</a>(0),
<a name="l00062"></a>00062     <a class="code" href="classPerfData.php#a44d56915fac1754821f63a8a5c506cb4">open</a>(false),
<a name="l00063"></a>00063     <a class="code" href="classPerfData.php#a3c3a767eae0ed11e38b765d852e8fc68">called_recursively</a>(0)
<a name="l00064"></a>00064     {}
<a name="l00065"></a>00065 
<a name="l00066"></a>00066   
<a name="l00070"></a><a class="code" href="classPerfData.php#a62b084835472576f517dcbdcba003650">00070</a>   <span class="keywordtype">double</span> <a class="code" href="classPerfData.php#a62b084835472576f517dcbdcba003650">tot_time</a>;
<a name="l00071"></a>00071 
<a name="l00075"></a><a class="code" href="classPerfData.php#a21638248b97b5a6c60ab9229ac103cc6">00075</a>   <span class="keywordtype">double</span> <a class="code" href="classPerfData.php#a21638248b97b5a6c60ab9229ac103cc6">tot_time_incl_sub</a>;
<a name="l00076"></a>00076 
<a name="l00081"></a><a class="code" href="classPerfData.php#a42acbfcf30298f7f19737d9ca7ac641b">00081</a>   <span class="keyword">struct </span>timeval <a class="code" href="classPerfData.php#a42acbfcf30298f7f19737d9ca7ac641b">tstart</a>;
<a name="l00082"></a>00082 
<a name="l00087"></a><a class="code" href="classPerfData.php#a5287f8b75f9a4f91d50a295fa205e356">00087</a>   <span class="keyword">struct </span>timeval <a class="code" href="classPerfData.php#a5287f8b75f9a4f91d50a295fa205e356">tstart_incl_sub</a>;
<a name="l00088"></a>00088 
<a name="l00093"></a><a class="code" href="classPerfData.php#a8bba34efb86fda1fce8ca4c7cb043f03">00093</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPerfData.php#a8bba34efb86fda1fce8ca4c7cb043f03">count</a>;
<a name="l00094"></a>00094 
<a name="l00100"></a><a class="code" href="classPerfData.php#a44d56915fac1754821f63a8a5c506cb4">00100</a>   <span class="keywordtype">bool</span> <a class="code" href="classPerfData.php#a44d56915fac1754821f63a8a5c506cb4">open</a>;
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   <span class="keywordtype">void</span>   <a class="code" href="classPerfData.php#a8eb1f95885700a69ba209bde12be81ed">start</a> ();
<a name="l00103"></a>00103   <span class="keywordtype">void</span>   <a class="code" href="classPerfData.php#a4b10fb39c9d5b6f771978e311e490e09">restart</a> ();
<a name="l00104"></a>00104   <span class="keywordtype">double</span> <a class="code" href="classPerfData.php#a775154920461f30ade0b923526608555">pause</a> ();
<a name="l00105"></a>00105   <span class="keywordtype">double</span> <a class="code" href="classPerfData.php#a5d02f9bd8e0cd5c864586cc1280ab133">stopit</a> ();
<a name="l00106"></a>00106     
<a name="l00107"></a><a class="code" href="classPerfData.php#a3c3a767eae0ed11e38b765d852e8fc68">00107</a>   <span class="keywordtype">int</span> <a class="code" href="classPerfData.php#a3c3a767eae0ed11e38b765d852e8fc68">called_recursively</a>;
<a name="l00108"></a>00108 
<a name="l00109"></a>00109  <span class="keyword">protected</span>:
<a name="l00110"></a>00110   <span class="keywordtype">double</span> <a class="code" href="classPerfData.php#a95b49dda38c3d7cc1d3e9624823f9ece">stop_or_pause</a>(<span class="keyword">const</span> <span class="keywordtype">bool</span> do_stop);
<a name="l00111"></a>00111 };
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00125"></a>00125 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00126"></a>00126 <span class="comment">// PerfLog class definition</span>
<a name="l00127"></a><a class="code" href="classPerfLog.php">00127</a> <span class="keyword">class </span><a class="code" href="classPerfLog.php">PerfLog</a>
<a name="l00128"></a>00128 {
<a name="l00129"></a>00129 
<a name="l00130"></a>00130  <span class="keyword">public</span>:
<a name="l00131"></a>00131 
<a name="l00139"></a>00139   <a class="code" href="classPerfLog.php#a482e1cc72a3e2396dfb6e2ba28904534">PerfLog</a>(<span class="keyword">const</span> std::string&amp; <a class="code" href="classPerfLog.php#a922935190940abc452236df465d53888">label_name</a>=<span class="stringliteral">&quot;&quot;</span>,
<a name="l00140"></a>00140           <span class="keyword">const</span> <span class="keywordtype">bool</span> <a class="code" href="classPerfLog.php#ad1c74796ff385f98d655a94cf0d9de9d">log_events</a>=<span class="keyword">true</span>);
<a name="l00141"></a>00141 
<a name="l00145"></a>00145   <a class="code" href="classPerfLog.php#aa7678503719df703eabb441b35e88642">~PerfLog</a>();
<a name="l00146"></a>00146   
<a name="l00154"></a>00154   <span class="keywordtype">void</span> <a class="code" href="classPerfLog.php#a3ec0f74c3b2a495d450c35db152c1eda">clear</a>();
<a name="l00155"></a>00155 
<a name="l00159"></a><a class="code" href="classPerfLog.php#a838a1bbf3549a41d07fd60c2c8e32de4">00159</a>   <span class="keywordtype">void</span> <a class="code" href="classPerfLog.php#a838a1bbf3549a41d07fd60c2c8e32de4">disable_logging</a>() { <a class="code" href="classPerfLog.php#ad1c74796ff385f98d655a94cf0d9de9d">log_events</a> = <span class="keyword">false</span>; }
<a name="l00160"></a>00160 
<a name="l00164"></a><a class="code" href="classPerfLog.php#aeef4a343213cc476c5750029085f0d4a">00164</a>   <span class="keywordtype">void</span> <a class="code" href="classPerfLog.php#aeef4a343213cc476c5750029085f0d4a">enable_logging</a>() { <a class="code" href="classPerfLog.php#ad1c74796ff385f98d655a94cf0d9de9d">log_events</a> = <span class="keyword">true</span>; }
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00170"></a>00170   <span class="keywordtype">void</span> <a class="code" href="classPerfLog.php#afe763605a6d4618f8bb15d601cca9058">push</a> (<span class="keyword">const</span> std::string &amp;label,
<a name="l00171"></a>00171              <span class="keyword">const</span> std::string &amp;header=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00172"></a>00172   
<a name="l00176"></a>00176   <span class="keywordtype">void</span> <a class="code" href="classPerfLog.php#a245da0a3b062c48d7bff86cd9b5ebd62">pop</a> (<span class="keyword">const</span> std::string &amp;label,
<a name="l00177"></a>00177             <span class="keyword">const</span> std::string &amp;header=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00178"></a>00178   
<a name="l00182"></a>00182   <span class="keywordtype">void</span> <a class="code" href="classPerfLog.php#a5dda932c13a030e40cee55e5d9dba311">start_event</a>(<span class="keyword">const</span> std::string &amp;label,
<a name="l00183"></a>00183                    <span class="keyword">const</span> std::string &amp;header=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00184"></a>00184 
<a name="l00188"></a>00188   <span class="keywordtype">void</span> <a class="code" href="classPerfLog.php#a64527e61cad880b801c14d1f139b2e0a">stop_event</a>(<span class="keyword">const</span> std::string &amp;label,
<a name="l00189"></a>00189                   <span class="keyword">const</span> std::string &amp;header=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00190"></a>00190 
<a name="l00194"></a>00194   <span class="keywordtype">void</span> <a class="code" href="classPerfLog.php#aa711f6ee0e37bcd449856c6fae8770a7">pause_event</a>(<span class="keyword">const</span> std::string &amp;label,
<a name="l00195"></a>00195                    <span class="keyword">const</span> std::string &amp;header=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00196"></a>00196 
<a name="l00200"></a>00200   <span class="keywordtype">void</span> <a class="code" href="classPerfLog.php#af6714888c9cef3f122d93319a421aa1a">restart_event</a>(<span class="keyword">const</span> std::string &amp;label,
<a name="l00201"></a>00201                      <span class="keyword">const</span> std::string &amp;header=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00202"></a>00202   
<a name="l00208"></a>00208   std::string <a class="code" href="classPerfLog.php#a6c33ecd6933b5b6f280e2a0e5e980968">get_log</a>() <span class="keyword">const</span>;
<a name="l00209"></a>00209   
<a name="l00213"></a>00213   std::string <a class="code" href="classPerfLog.php#a840c76b95c10d67ebe890c7ea81764a3">get_info_header</a>() <span class="keyword">const</span>;
<a name="l00214"></a>00214 
<a name="l00218"></a>00218   std::string <a class="code" href="classPerfLog.php#acca23d96b3c288a9b6a3e50412b8bfe4">get_perf_info</a>() <span class="keyword">const</span>;
<a name="l00219"></a>00219   
<a name="l00223"></a>00223   <span class="keywordtype">void</span> <a class="code" href="classPerfLog.php#ab54112f4f8c4f5d01cf1fa278ffe1599">print_log</a>() <span class="keyword">const</span>;
<a name="l00224"></a>00224 
<a name="l00228"></a>00228   <span class="keywordtype">double</span> <a class="code" href="classPerfLog.php#a8482c6f6cf5bf7fc36661ee7b28b7540">get_elapsed_time</a>() <span class="keyword">const</span>;
<a name="l00229"></a>00229  
<a name="l00230"></a>00230    
<a name="l00231"></a>00231  <span class="keyword">private</span>:
<a name="l00232"></a>00232 
<a name="l00233"></a>00233   
<a name="l00237"></a><a class="code" href="classPerfLog.php#a922935190940abc452236df465d53888">00237</a>   <span class="keyword">const</span> std::string <a class="code" href="classPerfLog.php#a922935190940abc452236df465d53888">label_name</a>;
<a name="l00238"></a>00238 
<a name="l00242"></a><a class="code" href="classPerfLog.php#ad1c74796ff385f98d655a94cf0d9de9d">00242</a>   <span class="keywordtype">bool</span> <a class="code" href="classPerfLog.php#ad1c74796ff385f98d655a94cf0d9de9d">log_events</a>;
<a name="l00243"></a>00243 
<a name="l00247"></a><a class="code" href="classPerfLog.php#a981a63417022107b279d92ebe1d04e1b">00247</a>   <span class="keywordtype">double</span> <a class="code" href="classPerfLog.php#a981a63417022107b279d92ebe1d04e1b">total_time</a>;
<a name="l00248"></a>00248   
<a name="l00252"></a><a class="code" href="classPerfLog.php#a030dce47e547b8206a1d2824305acf0f">00252</a>   <span class="keyword">struct </span>timeval <a class="code" href="classPerfLog.php#a030dce47e547b8206a1d2824305acf0f">tstart</a>;
<a name="l00253"></a>00253   
<a name="l00257"></a>00257   std::map&lt;std::pair&lt;std::string,
<a name="l00258"></a>00258                      std::string&gt;,
<a name="l00259"></a><a class="code" href="classPerfLog.php#aeb8bb270fc25d7ddfd6da45986d03bbc">00259</a>            <a class="code" href="classPerfData.php">PerfData</a>&gt; <a class="code" href="classPerfLog.php#aeb8bb270fc25d7ddfd6da45986d03bbc">log</a>;
<a name="l00260"></a>00260 
<a name="l00264"></a><a class="code" href="classPerfLog.php#a1d5656bfd4313c1fe79ac48a7f3bbda0">00264</a>   std::stack&lt;PerfData*&gt; <a class="code" href="classPerfLog.php#a1d5656bfd4313c1fe79ac48a7f3bbda0">log_stack</a>;
<a name="l00265"></a>00265   
<a name="l00271"></a><a class="code" href="classPerfLog.php#ac99902253fb74436828f998ed4602a9c">00271</a>   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classPerfLog.php#ac99902253fb74436828f998ed4602a9c">called</a>;
<a name="l00272"></a>00272   
<a name="l00277"></a>00277   <span class="keywordtype">void</span> <a class="code" href="classPerfLog.php#a5041965ccf3ee9d20bc4ace652ef9083">_character_line</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00278"></a>00278                        <span class="keyword">const</span> <span class="keywordtype">char</span> c,
<a name="l00279"></a>00279                        <a class="code" href="classOStringStream.php">OStringStream</a>&amp; out) <span class="keyword">const</span>;
<a name="l00280"></a>00280 };
<a name="l00281"></a>00281 
<a name="l00282"></a>00282 
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00285"></a>00285 <span class="comment">// PerfData class member funcions</span>
<a name="l00286"></a>00286 <span class="keyword">inline</span>
<a name="l00287"></a><a class="code" href="classPerfData.php#a8eb1f95885700a69ba209bde12be81ed">00287</a> <span class="keywordtype">void</span> <a class="code" href="classPerfData.php#a8eb1f95885700a69ba209bde12be81ed">PerfData::start</a> ()
<a name="l00288"></a>00288 {
<a name="l00289"></a>00289   this-&gt;<a class="code" href="classPerfData.php#a8bba34efb86fda1fce8ca4c7cb043f03">count</a>++;
<a name="l00290"></a>00290   this-&gt;<a class="code" href="classPerfData.php#a3c3a767eae0ed11e38b765d852e8fc68">called_recursively</a>++;
<a name="l00291"></a>00291   gettimeofday (&amp;(this-&gt;<a class="code" href="classPerfData.php#a42acbfcf30298f7f19737d9ca7ac641b">tstart</a>), NULL);
<a name="l00292"></a>00292   this-&gt;<a class="code" href="classPerfData.php#a5287f8b75f9a4f91d50a295fa205e356">tstart_incl_sub</a> = this-&gt;<a class="code" href="classPerfData.php#a42acbfcf30298f7f19737d9ca7ac641b">tstart</a>;
<a name="l00293"></a>00293 }
<a name="l00294"></a>00294 
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 
<a name="l00297"></a>00297 <span class="keyword">inline</span>
<a name="l00298"></a><a class="code" href="classPerfData.php#a4b10fb39c9d5b6f771978e311e490e09">00298</a> <span class="keywordtype">void</span> <a class="code" href="classPerfData.php#a4b10fb39c9d5b6f771978e311e490e09">PerfData::restart</a> ()
<a name="l00299"></a>00299 {
<a name="l00300"></a>00300   gettimeofday (&amp;(this-&gt;<a class="code" href="classPerfData.php#a42acbfcf30298f7f19737d9ca7ac641b">tstart</a>), NULL);
<a name="l00301"></a>00301 }
<a name="l00302"></a>00302 
<a name="l00303"></a>00303 
<a name="l00304"></a>00304 
<a name="l00305"></a>00305 <span class="keyword">inline</span>
<a name="l00306"></a><a class="code" href="classPerfData.php#a775154920461f30ade0b923526608555">00306</a> <span class="keywordtype">double</span> <a class="code" href="classPerfData.php#a775154920461f30ade0b923526608555">PerfData::pause</a> ()
<a name="l00307"></a>00307 {
<a name="l00308"></a>00308   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classPerfData.php#a95b49dda38c3d7cc1d3e9624823f9ece">stop_or_pause</a>(<span class="keyword">false</span>);
<a name="l00309"></a>00309 }
<a name="l00310"></a>00310 
<a name="l00311"></a>00311 
<a name="l00312"></a>00312 <span class="keyword">inline</span>
<a name="l00313"></a><a class="code" href="classPerfData.php#a95b49dda38c3d7cc1d3e9624823f9ece">00313</a> <span class="keywordtype">double</span> <a class="code" href="classPerfData.php#a95b49dda38c3d7cc1d3e9624823f9ece">PerfData::stop_or_pause</a>(<span class="keyword">const</span> <span class="keywordtype">bool</span> do_stop)
<a name="l00314"></a>00314 {
<a name="l00315"></a>00315   <span class="comment">// save the start times, reuse the structure we have rather than create</span>
<a name="l00316"></a>00316   <span class="comment">// a new one.</span>
<a name="l00317"></a>00317   <span class="keyword">const</span> time_t
<a name="l00318"></a>00318     tstart_tv_sec  = this-&gt;<a class="code" href="classPerfData.php#a42acbfcf30298f7f19737d9ca7ac641b">tstart</a>.tv_sec,
<a name="l00319"></a>00319     tstart_tv_usec = this-&gt;<a class="code" href="classPerfData.php#a42acbfcf30298f7f19737d9ca7ac641b">tstart</a>.tv_usec;
<a name="l00320"></a>00320   
<a name="l00321"></a>00321   gettimeofday (&amp;(this-&gt;<a class="code" href="classPerfData.php#a42acbfcf30298f7f19737d9ca7ac641b">tstart</a>), NULL);
<a name="l00322"></a>00322   
<a name="l00323"></a>00323   <span class="keyword">const</span> <span class="keywordtype">double</span> elapsed_time = (<span class="keyword">static_cast&lt;</span><span class="keywordtype">double</span><span class="keyword">&gt;</span>(this-&gt;<a class="code" href="classPerfData.php#a42acbfcf30298f7f19737d9ca7ac641b">tstart</a>.tv_sec  - tstart_tv_sec) +
<a name="l00324"></a>00324                                static_cast&lt;double&gt;(this-&gt;<a class="code" href="classPerfData.php#a42acbfcf30298f7f19737d9ca7ac641b">tstart</a>.tv_usec - tstart_tv_usec)*1.e-6);      
<a name="l00325"></a>00325   
<a name="l00326"></a>00326   this-&gt;<a class="code" href="classPerfData.php#a62b084835472576f517dcbdcba003650">tot_time</a> += elapsed_time;
<a name="l00327"></a>00327 
<a name="l00328"></a>00328   <span class="keywordflow">if</span>(do_stop)
<a name="l00329"></a>00329     {
<a name="l00330"></a>00330       <span class="keyword">const</span> <span class="keywordtype">double</span> elapsed_time_incl_sub = (<span class="keyword">static_cast&lt;</span><span class="keywordtype">double</span><span class="keyword">&gt;</span>(this-&gt;<a class="code" href="classPerfData.php#a42acbfcf30298f7f19737d9ca7ac641b">tstart</a>.tv_sec  - this-&gt;<a class="code" href="classPerfData.php#a5287f8b75f9a4f91d50a295fa205e356">tstart_incl_sub</a>.tv_sec) +
<a name="l00331"></a>00331                                             static_cast&lt;double&gt;(this-&gt;<a class="code" href="classPerfData.php#a42acbfcf30298f7f19737d9ca7ac641b">tstart</a>.tv_usec - this-&gt;tstart_incl_sub.tv_usec)*1.e-6);      
<a name="l00332"></a>00332 
<a name="l00333"></a>00333       this-&gt;<a class="code" href="classPerfData.php#a21638248b97b5a6c60ab9229ac103cc6">tot_time_incl_sub</a> += elapsed_time_incl_sub;
<a name="l00334"></a>00334     }
<a name="l00335"></a>00335 
<a name="l00336"></a>00336   <span class="keywordflow">return</span> elapsed_time;
<a name="l00337"></a>00337 }
<a name="l00338"></a>00338 
<a name="l00339"></a>00339 
<a name="l00340"></a>00340 
<a name="l00341"></a>00341 <span class="keyword">inline</span>
<a name="l00342"></a><a class="code" href="classPerfData.php#a5d02f9bd8e0cd5c864586cc1280ab133">00342</a> <span class="keywordtype">double</span> <a class="code" href="classPerfData.php#a5d02f9bd8e0cd5c864586cc1280ab133">PerfData::stopit</a> ()
<a name="l00343"></a>00343 {
<a name="l00344"></a>00344   <span class="comment">// stopit is just similar to pause except that it decrements the </span>
<a name="l00345"></a>00345   <span class="comment">// recursive call counter</span>
<a name="l00346"></a>00346   
<a name="l00347"></a>00347   this-&gt;<a class="code" href="classPerfData.php#a3c3a767eae0ed11e38b765d852e8fc68">called_recursively</a>--;
<a name="l00348"></a>00348   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classPerfData.php#a95b49dda38c3d7cc1d3e9624823f9ece">stop_or_pause</a>(<span class="keyword">true</span>);
<a name="l00349"></a>00349 }
<a name="l00350"></a>00350 
<a name="l00351"></a>00351 
<a name="l00352"></a>00352 
<a name="l00353"></a>00353 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00354"></a>00354 <span class="comment">// PerfLog class inline member funcions</span>
<a name="l00355"></a>00355 <span class="keyword">inline</span>
<a name="l00356"></a><a class="code" href="classPerfLog.php#afe763605a6d4618f8bb15d601cca9058">00356</a> <span class="keywordtype">void</span> <a class="code" href="classPerfLog.php#afe763605a6d4618f8bb15d601cca9058">PerfLog::push</a> (<span class="keyword">const</span> std::string &amp;label,
<a name="l00357"></a>00357                     <span class="keyword">const</span> std::string &amp;header)
<a name="l00358"></a>00358 {
<a name="l00359"></a>00359   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPerfLog.php#ad1c74796ff385f98d655a94cf0d9de9d">log_events</a>)
<a name="l00360"></a>00360     {
<a name="l00361"></a>00361       <span class="comment">// Get a reference to the event data to avoid</span>
<a name="l00362"></a>00362       <span class="comment">// repeated map lookups</span>
<a name="l00363"></a>00363       <a class="code" href="classPerfData.php">PerfData</a> *perf_data = &amp;(<a class="code" href="classPerfLog.php#aeb8bb270fc25d7ddfd6da45986d03bbc">log</a>[std::make_pair(header,label)]);
<a name="l00364"></a>00364 
<a name="l00365"></a>00365       <span class="keywordflow">if</span> (!<a class="code" href="classPerfLog.php#a1d5656bfd4313c1fe79ac48a7f3bbda0">log_stack</a>.empty())
<a name="l00366"></a>00366         <a class="code" href="classPerfLog.php#a981a63417022107b279d92ebe1d04e1b">total_time</a> += 
<a name="l00367"></a>00367           <a class="code" href="classPerfLog.php#a1d5656bfd4313c1fe79ac48a7f3bbda0">log_stack</a>.top()-&gt;pause();
<a name="l00368"></a>00368       
<a name="l00369"></a>00369       perf_data-&gt;<a class="code" href="classPerfData.php#a8eb1f95885700a69ba209bde12be81ed">start</a>();
<a name="l00370"></a>00370       <a class="code" href="classPerfLog.php#a1d5656bfd4313c1fe79ac48a7f3bbda0">log_stack</a>.push(perf_data);
<a name="l00371"></a>00371     }
<a name="l00372"></a>00372 }
<a name="l00373"></a>00373 
<a name="l00374"></a>00374 
<a name="l00375"></a>00375 
<a name="l00376"></a>00376 <span class="keyword">inline</span>
<a name="l00377"></a><a class="code" href="classPerfLog.php#a245da0a3b062c48d7bff86cd9b5ebd62">00377</a> <span class="keywordtype">void</span> <a class="code" href="classPerfLog.php#a245da0a3b062c48d7bff86cd9b5ebd62">PerfLog::pop</a> (<span class="keyword">const</span> std::string &amp;label,
<a name="l00378"></a>00378                    <span class="keyword">const</span> std::string &amp;header)
<a name="l00379"></a>00379 {
<a name="l00380"></a>00380   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPerfLog.php#ad1c74796ff385f98d655a94cf0d9de9d">log_events</a>)
<a name="l00381"></a>00381     {
<a name="l00382"></a>00382       libmesh_assert (!<a class="code" href="classPerfLog.php#a1d5656bfd4313c1fe79ac48a7f3bbda0">log_stack</a>.empty());
<a name="l00383"></a>00383 
<a name="l00384"></a>00384 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00385"></a>00385 <span class="preprocessor"></span>      <a class="code" href="classPerfData.php">PerfData</a> *perf_data = &amp;(<a class="code" href="classPerfLog.php#aeb8bb270fc25d7ddfd6da45986d03bbc">log</a>[std::make_pair(header,label)]);
<a name="l00386"></a>00386       libmesh_assert (perf_data == <a class="code" href="classPerfLog.php#a1d5656bfd4313c1fe79ac48a7f3bbda0">log_stack</a>.top());
<a name="l00387"></a>00387 <span class="preprocessor">#endif</span>
<a name="l00388"></a>00388 <span class="preprocessor"></span>
<a name="l00389"></a>00389       <a class="code" href="classPerfLog.php#a981a63417022107b279d92ebe1d04e1b">total_time</a> += <a class="code" href="classPerfLog.php#a1d5656bfd4313c1fe79ac48a7f3bbda0">log_stack</a>.top()-&gt;stopit();
<a name="l00390"></a>00390 
<a name="l00391"></a>00391       <a class="code" href="classPerfLog.php#a1d5656bfd4313c1fe79ac48a7f3bbda0">log_stack</a>.pop();
<a name="l00392"></a>00392 
<a name="l00393"></a>00393       <span class="keywordflow">if</span> (!<a class="code" href="classPerfLog.php#a1d5656bfd4313c1fe79ac48a7f3bbda0">log_stack</a>.empty())
<a name="l00394"></a>00394         <a class="code" href="classPerfLog.php#a1d5656bfd4313c1fe79ac48a7f3bbda0">log_stack</a>.top()-&gt;restart();
<a name="l00395"></a>00395     }
<a name="l00396"></a>00396 }
<a name="l00397"></a>00397 
<a name="l00398"></a>00398 
<a name="l00399"></a>00399 
<a name="l00400"></a>00400 <span class="keyword">inline</span>
<a name="l00401"></a><a class="code" href="classPerfLog.php#a8482c6f6cf5bf7fc36661ee7b28b7540">00401</a> <span class="keywordtype">double</span> <a class="code" href="classPerfLog.php#a8482c6f6cf5bf7fc36661ee7b28b7540">PerfLog::get_elapsed_time</a> ()<span class="keyword"> const</span>
<a name="l00402"></a>00402 <span class="keyword"></span>{
<a name="l00403"></a>00403   <span class="keyword">struct </span>timeval tnow;
<a name="l00404"></a>00404   
<a name="l00405"></a>00405   gettimeofday (&amp;tnow, NULL);
<a name="l00406"></a>00406           
<a name="l00407"></a>00407   <span class="keyword">const</span> <span class="keywordtype">double</span> elapsed_time = (<span class="keyword">static_cast&lt;</span><span class="keywordtype">double</span><span class="keyword">&gt;</span>(tnow.tv_sec  - <a class="code" href="classPerfLog.php#a030dce47e547b8206a1d2824305acf0f">tstart</a>.tv_sec) +
<a name="l00408"></a>00408                                static_cast&lt;double&gt;(tnow.tv_usec - <a class="code" href="classPerfLog.php#a030dce47e547b8206a1d2824305acf0f">tstart</a>.tv_usec)*1.e-6);
<a name="l00409"></a>00409   <span class="keywordflow">return</span> elapsed_time;
<a name="l00410"></a>00410 }
<a name="l00411"></a>00411 
<a name="l00412"></a>00412 
<a name="l00413"></a>00413 
<a name="l00414"></a>00414 <span class="comment">// Typedefs we might need</span>
<a name="l00415"></a>00415 <span class="preprocessor">#ifdef LIBMESH_HAVE_LOCALE</span>
<a name="l00416"></a><a class="code" href="perf__log_8h.php#a203d45cc47c1b2ec2697f0955d820dab">00416</a> <span class="preprocessor"></span><span class="keyword">typedef</span> std::ostreambuf_iterator&lt;char, std::char_traits&lt;char&gt; &gt; <a class="code" href="perf__log_8h.php#a203d45cc47c1b2ec2697f0955d820dab">TimeIter</a>;
<a name="l00417"></a><a class="code" href="perf__log_8h.php#a7e5de10bb0913a59c2efc144503420a5">00417</a> <span class="keyword">typedef</span> std::time_put&lt;char, TimeIter&gt; <a class="code" href="perf__log_8h.php#a7e5de10bb0913a59c2efc144503420a5">TimePut</a>;
<a name="l00418"></a>00418 <span class="preprocessor">#endif</span>
<a name="l00419"></a>00419 <span class="preprocessor"></span>
<a name="l00420"></a>00420 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
