<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_4f64d75cac7489d141591c33108e86ff.php">utils</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>perfmon.h</h1>  </div>
</div>
<div class="contents">
<a href="perfmon_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: perfmon.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __perfmon_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __perfmon_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;sys/time.h&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Local includes</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#ifdef HAVE_PAPI_H</span>
<a name="l00035"></a><a class="code" href="namespacePapi.php">00035</a> <span class="preprocessor"></span><span class="keyword">namespace </span>Papi {
<a name="l00036"></a>00036 <span class="preprocessor">#  include &lt;papi.h&gt;</span>
<a name="l00037"></a>00037 }
<a name="l00038"></a>00038 <span class="preprocessor">#endif</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a><a class="code" href="classPerfMon.php">00042</a> <span class="keyword">class </span><a class="code" href="classPerfMon.php">PerfMon</a>
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044  <span class="keyword">public</span>:
<a name="l00045"></a>00045   <a class="code" href="classPerfMon.php#aa0126ef62931739a8d47a2f90f570c45">PerfMon</a>  (std::string <span class="keywordtype">id</span>,
<a name="l00046"></a>00046             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=1,
<a name="l00047"></a>00047             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0);
<a name="l00048"></a>00048             
<a name="l00049"></a>00049   <a class="code" href="classPerfMon.php#a52277c1612441b56ec9eb5841fd1d009">~PerfMon</a> ();
<a name="l00050"></a>00050   <span class="keywordtype">void</span> <a class="code" href="classPerfMon.php#ada7a1fb9b1a0b3f90f36029d2b08b20c">reset</a> ();
<a name="l00051"></a>00051   <span class="keywordtype">double</span> <a class="code" href="classPerfMon.php#a07637030a1d6bcc2a9d426cef3d40ce9">print</a> (std::string msg=<span class="stringliteral">&quot;NULL&quot;</span>);
<a name="l00052"></a>00052   
<a name="l00053"></a>00053  <span class="keyword">private</span>:
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="classPerfMon.php#ab5e14826d75e9e556519e36650e2d0a0">00055</a>   <span class="keyword">const</span> std::string <a class="code" href="classPerfMon.php#ab5e14826d75e9e556519e36650e2d0a0">id_string</a>;
<a name="l00056"></a>00056   
<a name="l00057"></a><a class="code" href="classPerfMon.php#a61a78a9e9e15b88e34f5cab9ba2e6a29">00057</a>   <span class="keyword">struct </span>timeval <a class="code" href="classPerfMon.php#a61a78a9e9e15b88e34f5cab9ba2e6a29">the_time_start</a>;
<a name="l00058"></a><a class="code" href="classPerfMon.php#a382b4598e42cd4181ec93a25dc832539">00058</a>   <span class="keyword">struct </span>timeval <a class="code" href="classPerfMon.php#a382b4598e42cd4181ec93a25dc832539">the_time_stop</a>;
<a name="l00059"></a>00059 
<a name="l00060"></a><a class="code" href="classPerfMon.php#a81462248d940ec19a368399ef0e08f5b">00060</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPerfMon.php#a81462248d940ec19a368399ef0e08f5b">verbose</a>;
<a name="l00061"></a><a class="code" href="classPerfMon.php#a65778286e98d723b9c2d4abaa89ae228">00061</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPerfMon.php#a65778286e98d723b9c2d4abaa89ae228">proc_id</a>;
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 <span class="preprocessor">#ifdef HAVE_PAPI_H</span>
<a name="l00064"></a><a class="code" href="classPerfMon.php#a188236f1df2502a1b7b43a0e09784703">00064</a> <span class="preprocessor"></span>  <span class="keywordtype">float</span> <a class="code" href="classPerfMon.php#a188236f1df2502a1b7b43a0e09784703">rtime</a>, <a class="code" href="classPerfMon.php#a1d940990520264ef2071a62d9a692e1b">ptime</a>, <a class="code" href="classPerfMon.php#a2cc9e6ec48cd05db0835b4ebbbd40228">mflops</a>;
<a name="l00065"></a><a class="code" href="classPerfMon.php#a82f8e78a9d0a39a2cc3a3a05b4c3f6a8">00065</a>   <span class="keywordtype">long</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> <a class="code" href="classPerfMon.php#a82f8e78a9d0a39a2cc3a3a05b4c3f6a8">flpins</a>;
<a name="l00066"></a>00066 <span class="preprocessor">#endif</span>
<a name="l00067"></a>00067 <span class="preprocessor"></span>};
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 <span class="keyword">inline</span>
<a name="l00072"></a>00072 <span class="keywordtype">void</span>
<a name="l00073"></a><a class="code" href="classPerfMon.php#ada7a1fb9b1a0b3f90f36029d2b08b20c">00073</a> <a class="code" href="classPerfMon.php#ada7a1fb9b1a0b3f90f36029d2b08b20c">PerfMon::reset</a> ()
<a name="l00074"></a>00074 {
<a name="l00075"></a>00075   gettimeofday (&amp;<a class="code" href="classPerfMon.php#a61a78a9e9e15b88e34f5cab9ba2e6a29">the_time_start</a>, NULL);
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 <span class="preprocessor">#ifdef HAVE_PAPI_H</span>
<a name="l00078"></a>00078 <span class="preprocessor"></span>  Papi::PAPI_flops (&amp;<a class="code" href="classPerfMon.php#a188236f1df2502a1b7b43a0e09784703">rtime</a>, &amp;<a class="code" href="classPerfMon.php#a1d940990520264ef2071a62d9a692e1b">ptime</a>, &amp;<a class="code" href="classPerfMon.php#a82f8e78a9d0a39a2cc3a3a05b4c3f6a8">flpins</a>, &amp;<a class="code" href="classPerfMon.php#a2cc9e6ec48cd05db0835b4ebbbd40228">mflops</a>);
<a name="l00079"></a>00079 <span class="preprocessor">#endif  </span>
<a name="l00080"></a>00080 <span class="preprocessor"></span>}
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 <span class="keyword">inline</span>
<a name="l00085"></a>00085 <span class="keywordtype">double</span>
<a name="l00086"></a><a class="code" href="classPerfMon.php#a07637030a1d6bcc2a9d426cef3d40ce9">00086</a> <a class="code" href="classPerfMon.php#a07637030a1d6bcc2a9d426cef3d40ce9">PerfMon::print</a> (std::string msg)
<a name="l00087"></a>00087 {  
<a name="l00088"></a>00088   gettimeofday (&amp;<a class="code" href="classPerfMon.php#a382b4598e42cd4181ec93a25dc832539">the_time_stop</a>, NULL);
<a name="l00089"></a>00089   
<a name="l00090"></a>00090 <span class="preprocessor">#ifdef HAVE_PAPI_H</span>
<a name="l00091"></a>00091 <span class="preprocessor"></span>  Papi::PAPI_flops (&amp;<a class="code" href="classPerfMon.php#a188236f1df2502a1b7b43a0e09784703">rtime</a>, &amp;<a class="code" href="classPerfMon.php#a1d940990520264ef2071a62d9a692e1b">ptime</a>, &amp;<a class="code" href="classPerfMon.php#a82f8e78a9d0a39a2cc3a3a05b4c3f6a8">flpins</a>, &amp;<a class="code" href="classPerfMon.php#a2cc9e6ec48cd05db0835b4ebbbd40228">mflops</a>);
<a name="l00092"></a>00092 <span class="preprocessor">#endif</span>
<a name="l00093"></a>00093 <span class="preprocessor"></span>
<a name="l00094"></a>00094   <span class="keyword">const</span> <span class="keywordtype">double</span> elapsed_time = ((double) (<a class="code" href="classPerfMon.php#a382b4598e42cd4181ec93a25dc832539">the_time_stop</a>.tv_sec - <a class="code" href="classPerfMon.php#a61a78a9e9e15b88e34f5cab9ba2e6a29">the_time_start</a>.tv_sec)) +
<a name="l00095"></a>00095                               ((<span class="keywordtype">double</span>) (<a class="code" href="classPerfMon.php#a382b4598e42cd4181ec93a25dc832539">the_time_stop</a>.tv_usec - <a class="code" href="classPerfMon.php#a61a78a9e9e15b88e34f5cab9ba2e6a29">the_time_start</a>.tv_usec))/1000000.;
<a name="l00096"></a>00096 
<a name="l00097"></a>00097   <span class="keywordflow">if</span> (<a class="code" href="classPerfMon.php#a81462248d940ec19a368399ef0e08f5b">verbose</a>)
<a name="l00098"></a>00098     {
<a name="l00099"></a>00099       
<a name="l00100"></a>00100       <span class="keywordflow">if</span> (<a class="code" href="classPerfMon.php#a65778286e98d723b9c2d4abaa89ae228">proc_id</a> == 0)
<a name="l00101"></a>00101         {
<a name="l00102"></a>00102           <span class="keywordflow">if</span> (msg == <span class="stringliteral">&quot;NULL&quot;</span>)
<a name="l00103"></a>00103             std::cout &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; <a class="code" href="classPerfMon.php#ab5e14826d75e9e556519e36650e2d0a0">id_string</a>
<a name="l00104"></a>00104                       &lt;&lt; <span class="stringliteral">&quot;: elapsed time: &quot;</span>
<a name="l00105"></a>00105                       &lt;&lt; elapsed_time &lt;&lt; <span class="stringliteral">&quot; (sec)&quot;</span>
<a name="l00106"></a>00106                       &lt;&lt; std::endl;
<a name="l00107"></a>00107           <span class="keywordflow">else</span>
<a name="l00108"></a>00108             std::cout &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; msg
<a name="l00109"></a>00109                       &lt;&lt; <span class="stringliteral">&quot;: elapsed time: &quot;</span>
<a name="l00110"></a>00110                       &lt;&lt; elapsed_time &lt;&lt; <span class="stringliteral">&quot; (sec)&quot;</span>
<a name="l00111"></a>00111                       &lt;&lt; std::endl;
<a name="l00112"></a>00112           
<a name="l00113"></a>00113 <span class="preprocessor">#ifdef HAVE_PAPI_H</span>
<a name="l00114"></a>00114 <span class="preprocessor"></span>          <span class="keywordflow">if</span> (msg == <span class="stringliteral">&quot;NULL&quot;</span>)
<a name="l00115"></a>00115             std::cout &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; <a class="code" href="classPerfMon.php#ab5e14826d75e9e556519e36650e2d0a0">id_string</a>
<a name="l00116"></a>00116                       &lt;&lt; <span class="stringliteral">&quot;: mflops: &quot;</span>
<a name="l00117"></a>00117                       &lt;&lt; <a class="code" href="classPerfMon.php#a2cc9e6ec48cd05db0835b4ebbbd40228">mflops</a>
<a name="l00118"></a>00118                       &lt;&lt; std::endl;
<a name="l00119"></a>00119           <span class="keywordflow">else</span>
<a name="l00120"></a>00120             std::cout &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; msg
<a name="l00121"></a>00121                       &lt;&lt; <span class="stringliteral">&quot;: mflops: &quot;</span>
<a name="l00122"></a>00122                       &lt;&lt; <a class="code" href="classPerfMon.php#a2cc9e6ec48cd05db0835b4ebbbd40228">mflops</a>
<a name="l00123"></a>00123                       &lt;&lt; std::endl;
<a name="l00124"></a>00124       
<a name="l00125"></a>00125 <span class="preprocessor">#endif</span>
<a name="l00126"></a>00126 <span class="preprocessor"></span>
<a name="l00127"></a>00127         }
<a name="l00128"></a>00128     }
<a name="l00129"></a>00129   
<a name="l00130"></a>00130   <span class="keywordflow">return</span> elapsed_time;
<a name="l00131"></a>00131 }
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 <span class="keyword">inline</span>
<a name="l00135"></a><a class="code" href="classPerfMon.php#aa0126ef62931739a8d47a2f90f570c45">00135</a> <a class="code" href="classPerfMon.php#aa0126ef62931739a8d47a2f90f570c45">PerfMon::PerfMon</a> (std::string <span class="keywordtype">id</span>,
<a name="l00136"></a>00136                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v,
<a name="l00137"></a>00137                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid) :
<a name="l00138"></a>00138   id_string(id),
<a name="l00139"></a>00139   verbose(v),
<a name="l00140"></a>00140   proc_id(pid)
<a name="l00141"></a>00141 {
<a name="l00142"></a>00142   <a class="code" href="classPerfMon.php#ada7a1fb9b1a0b3f90f36029d2b08b20c">reset</a> ();
<a name="l00143"></a>00143 }
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 <span class="keyword">inline</span>
<a name="l00148"></a><a class="code" href="classPerfMon.php#a52277c1612441b56ec9eb5841fd1d009">00148</a> <a class="code" href="classPerfMon.php#a52277c1612441b56ec9eb5841fd1d009">PerfMon::~PerfMon</a> ()
<a name="l00149"></a>00149 {
<a name="l00150"></a>00150   <a class="code" href="classPerfMon.php#a07637030a1d6bcc2a9d426cef3d40ce9">print</a> ();
<a name="l00151"></a>00151 }
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
