<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_60be1125a39495b698d2d56e8e5b50b1.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>petsc_diff_solver.C</h1>  </div>
</div>
<div class="contents">
<a href="petsc__diff__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: petsc_diff_solver.C 3505 2009-10-21 19:04:07Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;diff_system.h&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;dof_map.h&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;linear_solver.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;petsc_diff_solver.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;petsc_matrix.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;petsc_vector.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00032"></a>00032 <span class="comment">// Functions with C linkage to pass to PETSc.  PETSc will call these</span>
<a name="l00033"></a>00033 <span class="comment">// methods as needed.</span>
<a name="l00034"></a>00034 <span class="comment">//</span>
<a name="l00035"></a>00035 <span class="comment">// Since they must have C linkage they have no knowledge of a namespace.</span>
<a name="l00036"></a>00036 <span class="comment">// Give them an obscure name to avoid namespace pollution.</span>
<a name="l00037"></a>00037 <span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span>
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039   <span class="comment">// Older versions of PETSc do not have the different int typedefs.</span>
<a name="l00040"></a>00040   <span class="comment">// On 64-bit machines, PetscInt may actually be a long long int.</span>
<a name="l00041"></a>00041   <span class="comment">// This change occurred in Petsc-2.2.1.</span>
<a name="l00042"></a>00042 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,1)</span>
<a name="l00043"></a><a class="code" href="petsc__diff__solver_8C.php#aefae79199a0dda59581d16f802913456">00043</a> <span class="preprocessor"></span>  <span class="keyword">typedef</span> <span class="keywordtype">int</span> <a class="code" href="petsc__linear__solver_8C.php#aefae79199a0dda59581d16f802913456">PetscErrorCode</a>;
<a name="l00044"></a><a class="code" href="petsc__diff__solver_8C.php#a515706180f960b30595b607f2d734d14">00044</a>   <span class="keyword">typedef</span> <span class="keywordtype">int</span> <a class="code" href="petsc__linear__solver_8C.php#a515706180f960b30595b607f2d734d14">PetscInt</a>;
<a name="l00045"></a>00045 <span class="preprocessor">#endif</span>
<a name="l00046"></a>00046 <span class="preprocessor"></span>
<a name="l00047"></a>00047 <span class="comment">// Function to hand to PETSc&#39;s SNES,</span>
<a name="l00048"></a>00048 <span class="comment">// which monitors convergence at X</span>
<a name="l00049"></a>00049 PetscErrorCode
<a name="l00050"></a><a class="code" href="petsc__diff__solver_8C.php#ad231197b0b8e9d27ef453831a34d5d8f">00050</a> <a class="code" href="petsc__diff__solver_8C.php#ad231197b0b8e9d27ef453831a34d5d8f">__libmesh_petsc_diff_solver_monitor</a> (SNES, PetscInt its,
<a name="l00051"></a>00051                                      PetscReal fnorm, <span class="keywordtype">void</span> *)
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053   std::cout &lt;&lt; <span class="stringliteral">&quot;  PetscDiffSolver step &quot;</span> &lt;&lt; its
<a name="l00054"></a>00054             &lt;&lt; <span class="stringliteral">&quot;, |residual|_2 = &quot;</span> &lt;&lt; fnorm &lt;&lt; std::endl;
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   <span class="keywordflow">return</span> 0;
<a name="l00057"></a>00057 }
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 <span class="comment">// Functions to hand to PETSc&#39;s SNES,</span>
<a name="l00060"></a>00060 <span class="comment">// which compute the residual or jacobian at X</span>
<a name="l00061"></a>00061 PetscErrorCode
<a name="l00062"></a><a class="code" href="petsc__diff__solver_8C.php#a6a66616f39fff0e22f601401162c9526">00062</a> <a class="code" href="petsc__diff__solver_8C.php#a6a66616f39fff0e22f601401162c9526">__libmesh_petsc_diff_solver_residual</a> (SNES, Vec x, Vec r, <span class="keywordtype">void</span> *ctx)
<a name="l00063"></a>00063 {
<a name="l00064"></a>00064   libmesh_assert (x   != NULL);
<a name="l00065"></a>00065   libmesh_assert (r   != NULL);
<a name="l00066"></a>00066   libmesh_assert (ctx != NULL);
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   <a class="code" href="classPetscDiffSolver.php">PetscDiffSolver</a>&amp; solver =
<a name="l00069"></a>00069     *(<span class="keyword">static_cast&lt;</span><a class="code" href="classPetscDiffSolver.php">PetscDiffSolver</a>*<span class="keyword">&gt;</span> (ctx));
<a name="l00070"></a>00070   <a class="code" href="classDifferentiableSystem.php">DifferentiableSystem</a> &amp;sys = solver.<a class="code" href="classDiffSolver.php#a4caf9ee24e332e6cda6c8bb3ea032b87">system</a>();
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   <a class="code" href="classPetscVector.php">PetscVector&lt;Number&gt;</a>&amp; X_system =
<a name="l00073"></a>00073     *libmesh_cast_ptr&lt;PetscVector&lt;Number&gt;*&gt;(sys.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>());
<a name="l00074"></a>00074   <a class="code" href="classPetscVector.php">PetscVector&lt;Number&gt;</a>&amp; R_system =
<a name="l00075"></a>00075     *libmesh_cast_ptr&lt;PetscVector&lt;Number&gt;*&gt;(sys.<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>);
<a name="l00076"></a>00076   <a class="code" href="classPetscVector.php">PetscVector&lt;Number&gt;</a> X_input(x), R_input(r);
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   <span class="comment">// DiffSystem assembles from the solution and into the rhs, so swap</span>
<a name="l00079"></a>00079   <span class="comment">// those with our input vectors before assembling.  They&#39;ll probably</span>
<a name="l00080"></a>00080   <span class="comment">// already be references to the same vectors, but PETSc might do</span>
<a name="l00081"></a>00081   <span class="comment">// something tricky.</span>
<a name="l00082"></a>00082   X_input.swap(X_system);
<a name="l00083"></a>00083   R_input.swap(R_system);
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="comment">// We may need to correct a non-conforming solution</span>
<a name="l00086"></a>00086   sys.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#ab8f806aded3f8351a9f0f6bbf8ae8274">enforce_constraints_exactly</a>(sys);
<a name="l00087"></a>00087 
<a name="l00088"></a>00088   <span class="comment">// We may need to localize a parallel solution</span>
<a name="l00089"></a>00089   sys.<a class="code" href="classSystem.php#add4b09ec4fb0679b8623c01218cafa5b">update</a>();
<a name="l00090"></a>00090 
<a name="l00091"></a>00091   <span class="comment">// Do DiffSystem assembly</span>
<a name="l00092"></a>00092   sys.<a class="code" href="classDifferentiableSystem.php#af2770154003897eef7c70a5318478393">assembly</a>(<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l00093"></a>00093   R_system.close();
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   <span class="comment">// Swap back</span>
<a name="l00096"></a>00096   X_input.swap(X_system);
<a name="l00097"></a>00097   R_input.swap(R_system);
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   <span class="comment">// No errors, we hope</span>
<a name="l00100"></a>00100   <span class="keywordflow">return</span> 0;
<a name="l00101"></a>00101 }
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 PetscErrorCode
<a name="l00105"></a><a class="code" href="petsc__diff__solver_8C.php#a71ea94f62359c7bd59bad291a9cc7df2">00105</a> <a class="code" href="petsc__diff__solver_8C.php#a71ea94f62359c7bd59bad291a9cc7df2">__libmesh_petsc_diff_solver_jacobian</a> (SNES, Vec x, Mat *j, Mat *pc,
<a name="l00106"></a>00106                                       MatStructure *msflag, <span class="keywordtype">void</span> *ctx)
<a name="l00107"></a>00107 {
<a name="l00108"></a>00108   libmesh_assert (x   != NULL);
<a name="l00109"></a>00109   libmesh_assert (j   != NULL);
<a name="l00110"></a>00110 <span class="comment">//  libmesh_assert (pc  == j);  // We don&#39;t use separate preconditioners yet</span>
<a name="l00111"></a>00111   libmesh_assert (ctx != NULL);
<a name="l00112"></a>00112 
<a name="l00113"></a>00113   <a class="code" href="classPetscDiffSolver.php">PetscDiffSolver</a>&amp; solver =
<a name="l00114"></a>00114     *(<span class="keyword">static_cast&lt;</span><a class="code" href="classPetscDiffSolver.php">PetscDiffSolver</a>*<span class="keyword">&gt;</span> (ctx));
<a name="l00115"></a>00115   <a class="code" href="classDifferentiableSystem.php">DifferentiableSystem</a> &amp;sys = solver.<a class="code" href="classDiffSolver.php#a4caf9ee24e332e6cda6c8bb3ea032b87">system</a>();
<a name="l00116"></a>00116 
<a name="l00117"></a>00117   <a class="code" href="classPetscVector.php">PetscVector&lt;Number&gt;</a>&amp; X_system =
<a name="l00118"></a>00118     *libmesh_cast_ptr&lt;PetscVector&lt;Number&gt;*&gt;(sys.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>());
<a name="l00119"></a>00119   <a class="code" href="classPetscVector.php">PetscVector&lt;Number&gt;</a> X_input(x);
<a name="l00120"></a>00120 
<a name="l00121"></a>00121   <a class="code" href="classPetscMatrix.php">PetscMatrix&lt;Number&gt;</a> J_input(*pc);
<a name="l00122"></a>00122   <a class="code" href="classPetscMatrix.php">PetscMatrix&lt;Number&gt;</a>&amp; J_system =
<a name="l00123"></a>00123     *libmesh_cast_ptr&lt;PetscMatrix&lt;Number&gt;*&gt;(sys.<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>);
<a name="l00124"></a>00124 
<a name="l00125"></a>00125   <span class="comment">// DiffSystem assembles from the solution and into the jacobian, so</span>
<a name="l00126"></a>00126   <span class="comment">// swap those with our input vectors before assembling.  They&#39;ll</span>
<a name="l00127"></a>00127   <span class="comment">// probably already be references to the same vectors, but PETSc</span>
<a name="l00128"></a>00128   <span class="comment">// might do something tricky.</span>
<a name="l00129"></a>00129   X_input.<a class="code" href="classPetscMatrix.php#aaf70f96b16c6604e67edc21e24dbb87b">swap</a>(X_system);
<a name="l00130"></a>00130   J_input.<a class="code" href="classPetscMatrix.php#aaf70f96b16c6604e67edc21e24dbb87b">swap</a>(J_system);
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   <span class="comment">// We may need to correct a non-conforming solution</span>
<a name="l00133"></a>00133   sys.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#ab8f806aded3f8351a9f0f6bbf8ae8274">enforce_constraints_exactly</a>(sys);
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   <span class="comment">// We may need to localize a parallel solution</span>
<a name="l00136"></a>00136   sys.<a class="code" href="classSystem.php#add4b09ec4fb0679b8623c01218cafa5b">update</a>();
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <span class="comment">// Do DiffSystem assembly</span>
<a name="l00139"></a>00139   sys.<a class="code" href="classDifferentiableSystem.php#af2770154003897eef7c70a5318478393">assembly</a>(<span class="keyword">false</span>, <span class="keyword">true</span>);
<a name="l00140"></a>00140   J_system.<a class="code" href="classPetscMatrix.php#a431196369d051b83ea1e3d595ec2dc0d">close</a>();
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   <span class="comment">// Swap back</span>
<a name="l00143"></a>00143   X_input.swap(X_system);
<a name="l00144"></a>00144   J_input.<a class="code" href="classPetscMatrix.php#aaf70f96b16c6604e67edc21e24dbb87b">swap</a>(J_system);
<a name="l00145"></a>00145 
<a name="l00146"></a>00146   *msflag = SAME_NONZERO_PATTERN;
<a name="l00147"></a>00147 
<a name="l00148"></a>00148   <span class="comment">// No errors, we hope</span>
<a name="l00149"></a>00149   <span class="keywordflow">return</span> 0;
<a name="l00150"></a>00150 }
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 } <span class="comment">// extern &quot;C&quot;</span>
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a><a class="code" href="classPetscDiffSolver.php#a175d8f80d3c3f2aa93431c9bc5b63312">00155</a> <a class="code" href="classPetscDiffSolver.php#a175d8f80d3c3f2aa93431c9bc5b63312">PetscDiffSolver::PetscDiffSolver</a> (<a class="code" href="classDifferentiableSystem.php">sys_type</a>&amp; s)
<a name="l00156"></a>00156   : <a class="code" href="classDiffSolver.php">Parent</a>(s)
<a name="l00157"></a>00157 {
<a name="l00158"></a>00158 }
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a><a class="code" href="classPetscDiffSolver.php#ae969d80c10f8e50bc81856224f5337f0">00161</a> <span class="keywordtype">void</span> <a class="code" href="classPetscDiffSolver.php#ae969d80c10f8e50bc81856224f5337f0">PetscDiffSolver::init</a> ()
<a name="l00162"></a>00162 {
<a name="l00163"></a>00163   START_LOG(<span class="stringliteral">&quot;init()&quot;</span>, <span class="stringliteral">&quot;PetscDiffSolver&quot;</span>);
<a name="l00164"></a>00164 
<a name="l00165"></a>00165   <a class="code" href="classDiffSolver.php#ae5b8b414c326206370ffffeda5184815">Parent::init</a>();
<a name="l00166"></a>00166 
<a name="l00167"></a>00167   <span class="keywordtype">int</span> ierr=0;
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,1,2)</span>
<a name="l00170"></a>00170 <span class="preprocessor"></span>  <span class="comment">// At least until Petsc 2.1.1, the SNESCreate had a different</span>
<a name="l00171"></a>00171   <span class="comment">// calling syntax.  The second argument was of type SNESProblemType,</span>
<a name="l00172"></a>00172   <span class="comment">// and could have a value of either SNES_NONLINEAR_EQUATIONS or</span>
<a name="l00173"></a>00173   <span class="comment">// SNES_UNCONSTRAINED_MINIMIZATION.</span>
<a name="l00174"></a>00174   ierr = SNESCreate(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>, SNES_NONLINEAR_EQUATIONS, &amp;<a class="code" href="classPetscDiffSolver.php#a9b7462cdd86f11393111ac1112e3fd77">_snes</a>);
<a name="l00175"></a>00175   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00176"></a>00176 <span class="preprocessor">#else</span>
<a name="l00177"></a>00177 <span class="preprocessor"></span>  ierr = SNESCreate(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,&amp;<a class="code" href="classPetscDiffSolver.php#a9b7462cdd86f11393111ac1112e3fd77">_snes</a>);
<a name="l00178"></a>00178   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00179"></a>00179 <span class="preprocessor">#endif</span>
<a name="l00180"></a>00180 <span class="preprocessor"></span>
<a name="l00181"></a>00181 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,3)</span>
<a name="l00182"></a>00182 <span class="preprocessor"></span>  ierr = SNESSetMonitor (<a class="code" href="classPetscDiffSolver.php#a9b7462cdd86f11393111ac1112e3fd77">_snes</a>, <a class="code" href="petsc__diff__solver_8C.php#ad231197b0b8e9d27ef453831a34d5d8f">__libmesh_petsc_diff_solver_monitor</a>,
<a name="l00183"></a>00183                          <span class="keyword">this</span>, PETSC_NULL);
<a name="l00184"></a>00184 <span class="preprocessor">#else</span>
<a name="l00185"></a>00185 <span class="preprocessor"></span>  <span class="comment">// API name change in PETSc 2.3.3</span>
<a name="l00186"></a>00186   ierr = SNESMonitorSet (<a class="code" href="classPetscDiffSolver.php#a9b7462cdd86f11393111ac1112e3fd77">_snes</a>, <a class="code" href="petsc__diff__solver_8C.php#ad231197b0b8e9d27ef453831a34d5d8f">__libmesh_petsc_diff_solver_monitor</a>,
<a name="l00187"></a>00187                          <span class="keyword">this</span>, PETSC_NULL);
<a name="l00188"></a>00188 <span class="preprocessor">#endif</span>
<a name="l00189"></a>00189 <span class="preprocessor"></span>  CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00190"></a>00190 
<a name="l00191"></a>00191   ierr = SNESSetFromOptions(<a class="code" href="classPetscDiffSolver.php#a9b7462cdd86f11393111ac1112e3fd77">_snes</a>);
<a name="l00192"></a>00192   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00193"></a>00193 
<a name="l00194"></a>00194   STOP_LOG(<span class="stringliteral">&quot;init()&quot;</span>, <span class="stringliteral">&quot;PetscDiffSolver&quot;</span>);
<a name="l00195"></a>00195 }
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 
<a name="l00199"></a><a class="code" href="classPetscDiffSolver.php#a1d1aa101888ade3f1159cf60b0f13415">00199</a> <a class="code" href="classPetscDiffSolver.php#a1d1aa101888ade3f1159cf60b0f13415">PetscDiffSolver::~PetscDiffSolver</a> ()
<a name="l00200"></a>00200 {
<a name="l00201"></a>00201 }
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 
<a name="l00205"></a><a class="code" href="classPetscDiffSolver.php#acba4d9ef2bf084222f046307b2ccd502">00205</a> <span class="keywordtype">void</span> <a class="code" href="classPetscDiffSolver.php#acba4d9ef2bf084222f046307b2ccd502">PetscDiffSolver::clear</a>()
<a name="l00206"></a>00206 {
<a name="l00207"></a>00207   START_LOG(<span class="stringliteral">&quot;clear()&quot;</span>, <span class="stringliteral">&quot;PetscDiffSolver&quot;</span>);
<a name="l00208"></a>00208 
<a name="l00209"></a>00209   <span class="keywordtype">int</span> ierr=0;
<a name="l00210"></a>00210 
<a name="l00211"></a>00211   ierr = SNESDestroy(<a class="code" href="classPetscDiffSolver.php#a9b7462cdd86f11393111ac1112e3fd77">_snes</a>);
<a name="l00212"></a>00212   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00213"></a>00213 
<a name="l00214"></a>00214   STOP_LOG(<span class="stringliteral">&quot;clear()&quot;</span>, <span class="stringliteral">&quot;PetscDiffSolver&quot;</span>);
<a name="l00215"></a>00215 }
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 
<a name="l00219"></a><a class="code" href="classPetscDiffSolver.php#aaa0948133945299347da5a52df0f4f2d">00219</a> <span class="keywordtype">void</span> <a class="code" href="classPetscDiffSolver.php#aaa0948133945299347da5a52df0f4f2d">PetscDiffSolver::reinit</a>()
<a name="l00220"></a>00220 {
<a name="l00221"></a>00221   <a class="code" href="classDiffSolver.php#af577460d7836c62c1aed2455c9085e32">Parent::reinit</a>();
<a name="l00222"></a>00222 }
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 
<a name="l00226"></a><a class="code" href="classPetscDiffSolver.php#a9794d490c7c1accad00a876df088deb3">00226</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscDiffSolver.php#a9794d490c7c1accad00a876df088deb3">PetscDiffSolver::solve</a>()
<a name="l00227"></a>00227 {
<a name="l00228"></a>00228   this-&gt;<a class="code" href="classPetscDiffSolver.php#ae969d80c10f8e50bc81856224f5337f0">init</a>();
<a name="l00229"></a>00229 
<a name="l00230"></a>00230   START_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;PetscDiffSolver&quot;</span>);
<a name="l00231"></a>00231 
<a name="l00232"></a>00232   <a class="code" href="classPetscVector.php">PetscVector&lt;Number&gt;</a> &amp;x =
<a name="l00233"></a>00233     *(libmesh_cast_ptr&lt;PetscVector&lt;Number&gt;*&gt;(<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>()));
<a name="l00234"></a>00234   <a class="code" href="classPetscMatrix.php">PetscMatrix&lt;Number&gt;</a> &amp;jac =
<a name="l00235"></a>00235     *(libmesh_cast_ptr&lt;PetscMatrix&lt;Number&gt;*&gt;(<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>));
<a name="l00236"></a>00236   <a class="code" href="classPetscVector.php">PetscVector&lt;Number&gt;</a> &amp;r =
<a name="l00237"></a>00237     *(libmesh_cast_ptr&lt;PetscVector&lt;Number&gt;*&gt;(<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>));
<a name="l00238"></a>00238 
<a name="l00239"></a>00239   x.<a class="code" href="classPetscVector.php#aba0946fa812f249899f4ab12c0cf330c">close</a>();
<a name="l00240"></a>00240   r.<a class="code" href="classPetscVector.php#aba0946fa812f249899f4ab12c0cf330c">close</a>();
<a name="l00241"></a>00241   jac.<a class="code" href="classPetscMatrix.php#a431196369d051b83ea1e3d595ec2dc0d">close</a>();
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00244"></a>00244 <span class="preprocessor"></span>  <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#ab8f806aded3f8351a9f0f6bbf8ae8274">enforce_constraints_exactly</a>(<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>);
<a name="l00245"></a>00245 <span class="preprocessor">#endif</span>
<a name="l00246"></a>00246 <span class="preprocessor"></span>
<a name="l00247"></a>00247   <span class="keywordtype">int</span> ierr = 0;
<a name="l00248"></a>00248 
<a name="l00249"></a>00249   ierr = SNESSetFunction (<a class="code" href="classPetscDiffSolver.php#a9b7462cdd86f11393111ac1112e3fd77">_snes</a>, r.<a class="code" href="classPetscVector.php#ada77db22640adec265059dd445404f6d">vec</a>(),
<a name="l00250"></a>00250                           <a class="code" href="petsc__diff__solver_8C.php#a6a66616f39fff0e22f601401162c9526">__libmesh_petsc_diff_solver_residual</a>, <span class="keyword">this</span>);
<a name="l00251"></a>00251     CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00252"></a>00252 
<a name="l00253"></a>00253   ierr = SNESSetJacobian (<a class="code" href="classPetscDiffSolver.php#a9b7462cdd86f11393111ac1112e3fd77">_snes</a>, jac.<a class="code" href="classPetscMatrix.php#a612eda163983cf42adb5a2151045f28b">mat</a>(), jac.<a class="code" href="classPetscMatrix.php#a612eda163983cf42adb5a2151045f28b">mat</a>(),
<a name="l00254"></a>00254                           <a class="code" href="petsc__diff__solver_8C.php#a71ea94f62359c7bd59bad291a9cc7df2">__libmesh_petsc_diff_solver_jacobian</a>, <span class="keyword">this</span>);
<a name="l00255"></a>00255     CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00256"></a>00256 
<a name="l00257"></a>00257 <span class="preprocessor"># if PETSC_VERSION_LESS_THAN(2,2,0)</span>
<a name="l00258"></a>00258 <span class="preprocessor"></span>
<a name="l00259"></a>00259   ierr = SNESSolve (<a class="code" href="classPetscDiffSolver.php#a9b7462cdd86f11393111ac1112e3fd77">_snes</a>, x.<a class="code" href="classPetscVector.php#ada77db22640adec265059dd445404f6d">vec</a>(), &amp;<a class="code" href="classDiffSolver.php#a79d256bff5a88d89aec8941041dc89a9">_outer_iterations</a>);
<a name="l00260"></a>00260          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00261"></a>00261 
<a name="l00262"></a>00262 <span class="comment">// 2.2.x style</span>
<a name="l00263"></a>00263 <span class="preprocessor">#elif PETSC_VERSION_LESS_THAN(2,3,0)</span>
<a name="l00264"></a>00264 <span class="preprocessor"></span>
<a name="l00265"></a>00265   ierr = SNESSolve (<a class="code" href="classPetscDiffSolver.php#a9b7462cdd86f11393111ac1112e3fd77">_snes</a>, x.<a class="code" href="classPetscVector.php#ada77db22640adec265059dd445404f6d">vec</a>());
<a name="l00266"></a>00266          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 <span class="comment">// 2.3.x &amp; newer style</span>
<a name="l00269"></a>00269 <span class="preprocessor">#else</span>
<a name="l00270"></a>00270 <span class="preprocessor"></span>
<a name="l00271"></a>00271   ierr = SNESSolve (<a class="code" href="classPetscDiffSolver.php#a9b7462cdd86f11393111ac1112e3fd77">_snes</a>, PETSC_NULL, x.<a class="code" href="classPetscVector.php#ada77db22640adec265059dd445404f6d">vec</a>());
<a name="l00272"></a>00272          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00273"></a>00273 
<a name="l00274"></a>00274 <span class="preprocessor">#endif</span>
<a name="l00275"></a>00275 <span class="preprocessor"></span>
<a name="l00276"></a>00276   STOP_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;PetscDiffSolver&quot;</span>);
<a name="l00277"></a>00277 
<a name="l00278"></a>00278   this-&gt;<a class="code" href="classPetscDiffSolver.php#acba4d9ef2bf084222f046307b2ccd502">clear</a>();
<a name="l00279"></a>00279 
<a name="l00280"></a>00280   <span class="comment">// FIXME - We&#39;ll worry about getting the solve result right later...</span>
<a name="l00281"></a>00281   
<a name="l00282"></a>00282   <span class="keywordflow">return</span> <a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eea7a3ff540e243e45764a90666389ba012">DiffSolver::CONVERGED_RELATIVE_RESIDUAL</a>;
<a name="l00283"></a>00283 }
<a name="l00284"></a>00284 
<a name="l00285"></a>00285 
<a name="l00286"></a>00286 
<a name="l00287"></a><a class="code" href="classPetscDiffSolver.php#a425e5c3f57fc020040cfbe07759d7762">00287</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscDiffSolver.php#a425e5c3f57fc020040cfbe07759d7762">PetscDiffSolver::adjoint_solve</a>()
<a name="l00288"></a>00288 {
<a name="l00289"></a>00289   <span class="comment">// The adjoint_solve API (and all APIs using it) are about to see a</span>
<a name="l00290"></a>00290   <span class="comment">// series of non-backwards-compatible changes, primarily to add</span>
<a name="l00291"></a>00291   <span class="comment">// multiple-QoI support</span>
<a name="l00292"></a>00292   libmesh_experimental();
<a name="l00293"></a>00293 
<a name="l00294"></a>00294   START_LOG(<span class="stringliteral">&quot;adjoint_solve()&quot;</span>, <span class="stringliteral">&quot;PetscDiffSolver&quot;</span>);
<a name="l00295"></a>00295 
<a name="l00296"></a>00296   <span class="comment">// Do DiffSystem assembly</span>
<a name="l00297"></a>00297   <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classDifferentiableSystem.php#af2770154003897eef7c70a5318478393">assembly</a>(<span class="keyword">false</span>, <span class="keyword">true</span>);
<a name="l00298"></a>00298   <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>-&gt;<a class="code" href="classSparseMatrix.php#a55129db49268936e33686bc1beaaa1e9">close</a>();
<a name="l00299"></a>00299 
<a name="l00300"></a>00300   <span class="comment">// But take the adjoint</span>
<a name="l00301"></a>00301   <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>-&gt;<a class="code" href="classSparseMatrix.php#a7f1c4ddda074a4e1aa63bf7d2f780492">get_transpose</a>(*<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>);
<a name="l00302"></a>00302 
<a name="l00303"></a>00303   <span class="keywordflow">if</span> (<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#aa23d50b0a898aaee758d4a98c996a4df">have_matrix</a>(<span class="stringliteral">&quot;Preconditioner&quot;</span>))
<a name="l00304"></a>00304     {
<a name="l00305"></a>00305       <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;Number&gt;</a> &amp;pre = <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#a719365410b024d2ddab0b1bada55753d">get_matrix</a>(<span class="stringliteral">&quot;Preconditioner&quot;</span>);
<a name="l00306"></a>00306       pre.<a class="code" href="classSparseMatrix.php#a7f1c4ddda074a4e1aa63bf7d2f780492">get_transpose</a>(pre);
<a name="l00307"></a>00307     }
<a name="l00308"></a>00308 
<a name="l00309"></a>00309   <span class="comment">// And set the right hand side to the quantity of interest</span>
<a name="l00310"></a>00310   <span class="comment">// derivative</span>
<a name="l00311"></a>00311   <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classExplicitSystem.php#a563d121d2398bdc54dbe60eda789ddaa">assemble_qoi_derivative</a>();
<a name="l00312"></a>00312 
<a name="l00313"></a>00313   <span class="comment">// Then build something to solve the _linear_ system</span>
<a name="l00314"></a>00314   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;LinearSolver&lt;Number&gt;</a> &gt; linear_solver = <a class="code" href="classDiffSolver.php#a4329eed9150ced6af7f969015fc14dfb">LinearSolver&lt;Number&gt;::build</a>();
<a name="l00315"></a>00315 
<a name="l00316"></a>00316   <span class="comment">// Solve the linear system.  Two cases:</span>
<a name="l00317"></a>00317   <span class="keyword">const</span> std::pair&lt;unsigned int, Real&gt; rval =
<a name="l00318"></a>00318     (<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#aa23d50b0a898aaee758d4a98c996a4df">have_matrix</a>(<span class="stringliteral">&quot;Preconditioner&quot;</span>)) ?
<a name="l00319"></a>00319   <span class="comment">// 1.) User-supplied preconditioner</span>
<a name="l00320"></a>00320     linear_solver-&gt;solve (*<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>,
<a name="l00321"></a>00321                           <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#a719365410b024d2ddab0b1bada55753d">get_matrix</a>(<span class="stringliteral">&quot;Preconditioner&quot;</span>),
<a name="l00322"></a>00322                           *<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>, *<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>,
<a name="l00323"></a>00323                           <a class="code" href="classDiffSolver.php#aa61c00b75cbbd6910882c7a415d9d22a">relative_residual_tolerance</a>,
<a name="l00324"></a>00324                           <a class="code" href="classDiffSolver.php#a44125d46d2f5df9f29392cbe81069bf6">max_linear_iterations</a>) :
<a name="l00325"></a>00325   <span class="comment">// 2.) Use system matrix for the preconditioner</span>
<a name="l00326"></a>00326     linear_solver-&gt;solve (*<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#a9bd7b51f027338353a5329b63b75b1a0">matrix</a>,
<a name="l00327"></a>00327                           *<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>, *<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classExplicitSystem.php#ab4c08a2268bb5d270a821fc0ce56920a">rhs</a>,
<a name="l00328"></a>00328                           <a class="code" href="classDiffSolver.php#aa61c00b75cbbd6910882c7a415d9d22a">relative_residual_tolerance</a>, 
<a name="l00329"></a>00329                           <a class="code" href="classDiffSolver.php#a44125d46d2f5df9f29392cbe81069bf6">max_linear_iterations</a>);
<a name="l00330"></a>00330 
<a name="l00331"></a>00331   <span class="comment">// We may need to localize a parallel solution</span>
<a name="l00332"></a>00332   <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classSystem.php#add4b09ec4fb0679b8623c01218cafa5b">update</a> ();
<a name="l00333"></a>00333 
<a name="l00334"></a>00334   <span class="comment">// The linear solver may not have fit our constraints exactly</span>
<a name="l00335"></a>00335 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00336"></a>00336 <span class="preprocessor"></span>  <a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#ab8f806aded3f8351a9f0f6bbf8ae8274">enforce_constraints_exactly</a>(<a class="code" href="classDiffSolver.php#a85dc8547a41ba6b109433147355a48aa">_system</a>);
<a name="l00337"></a>00337 <span class="preprocessor">#endif</span>
<a name="l00338"></a>00338 <span class="preprocessor"></span>
<a name="l00339"></a>00339   STOP_LOG(<span class="stringliteral">&quot;adjoint_solve()&quot;</span>, <span class="stringliteral">&quot;PetscDiffSolver&quot;</span>);
<a name="l00340"></a>00340 
<a name="l00341"></a>00341   <span class="comment">// FIXME - We&#39;ll worry about getting the solve result right later...</span>
<a name="l00342"></a>00342   
<a name="l00343"></a>00343   <span class="keywordflow">return</span> <a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eea7a3ff540e243e45764a90666389ba012">DiffSolver::CONVERGED_RELATIVE_RESIDUAL</a>;
<a name="l00344"></a>00344 }
<a name="l00345"></a>00345 
<a name="l00346"></a>00346 <span class="preprocessor">#endif // LIBMESH_HAVE_PETSC</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
