<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>petsc_diff_solver.h</h1>  </div>
</div>
<div class="contents">
<a href="petsc__diff__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: petsc_diff_solver.h 3505 2009-10-21 19:04:07Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __petsc_diff_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __petsc_diff_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="diff__solver_8h.php">diff_solver.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;petsc_macro.h&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 EXTERN_C_FOR_PETSC_BEGIN
<a name="l00036"></a>00036 <span class="preprocessor"># include &lt;petscsnes.h&gt;</span>
<a name="l00037"></a>00037 EXTERN_C_FOR_PETSC_END
<a name="l00038"></a>00038 
<a name="l00050"></a>00050 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00051"></a>00051 <span class="comment">// Solver class definition</span>
<a name="l00052"></a><a class="code" href="classPetscDiffSolver.php">00052</a> <span class="keyword">class </span><a class="code" href="classPetscDiffSolver.php">PetscDiffSolver</a> : <span class="keyword">public</span> <a class="code" href="classDiffSolver.php">DiffSolver</a>
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054 <span class="keyword">public</span>:
<a name="l00059"></a>00059   <a class="code" href="classPetscDiffSolver.php#a175d8f80d3c3f2aa93431c9bc5b63312">PetscDiffSolver</a> (<a class="code" href="classDifferentiableSystem.php">sys_type</a>&amp; <a class="code" href="classDiffSolver.php#a4caf9ee24e332e6cda6c8bb3ea032b87">system</a>);
<a name="l00060"></a>00060   
<a name="l00064"></a>00064   <span class="keyword">virtual</span> <a class="code" href="classPetscDiffSolver.php#a1d1aa101888ade3f1159cf60b0f13415">~PetscDiffSolver</a> ();
<a name="l00065"></a>00065 
<a name="l00066"></a><a class="code" href="classPetscDiffSolver.php#a87df98e440622fd01ddfb042bd31d7cc">00066</a>   <span class="keyword">typedef</span> <a class="code" href="classDiffSolver.php">DiffSolver</a> <a class="code" href="classPetscDiffSolver.php#a87df98e440622fd01ddfb042bd31d7cc">Parent</a>;
<a name="l00067"></a>00067 
<a name="l00072"></a>00072   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPetscDiffSolver.php#aaa0948133945299347da5a52df0f4f2d">reinit</a> ();
<a name="l00073"></a>00073 
<a name="l00078"></a>00078   <span class="keywordtype">void</span> <a class="code" href="classPetscDiffSolver.php#ae969d80c10f8e50bc81856224f5337f0">init</a> ();
<a name="l00079"></a>00079 
<a name="l00084"></a>00084   <span class="keywordtype">void</span> <a class="code" href="classPetscDiffSolver.php#acba4d9ef2bf084222f046307b2ccd502">clear</a> ();
<a name="l00085"></a>00085 
<a name="l00091"></a>00091   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscDiffSolver.php#a9794d490c7c1accad00a876df088deb3">solve</a> ();
<a name="l00092"></a>00092 
<a name="l00098"></a>00098   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscDiffSolver.php#a425e5c3f57fc020040cfbe07759d7762">adjoint_solve</a> ();
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 <span class="keyword">protected</span>:
<a name="l00101"></a>00101 
<a name="l00105"></a><a class="code" href="classPetscDiffSolver.php#a9b7462cdd86f11393111ac1112e3fd77">00105</a>   SNES <a class="code" href="classPetscDiffSolver.php#a9b7462cdd86f11393111ac1112e3fd77">_snes</a>;
<a name="l00106"></a>00106 };
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00109"></a>00109 <span class="preprocessor"></span>
<a name="l00110"></a>00110 <span class="preprocessor">#endif // #define __petsc_diff_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
