<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_f10759d5ac6297fe611079c3c15b8f2c.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>petsc_linear_solver.C</h1>  </div>
</div>
<div class="contents">
<a href="petsc__linear__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: petsc_linear_solver.C 3458 2009-09-04 20:39:35Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;petsc_linear_solver.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;shell_matrix.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;petsc_preconditioner.h&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span>
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,1)</span>
<a name="l00036"></a><a class="code" href="petsc__linear__solver_8C.php#aefae79199a0dda59581d16f802913456">00036</a> <span class="preprocessor"></span>  <span class="keyword">typedef</span> <span class="keywordtype">int</span> <a class="code" href="petsc__linear__solver_8C.php#aefae79199a0dda59581d16f802913456">PetscErrorCode</a>;
<a name="l00037"></a><a class="code" href="petsc__linear__solver_8C.php#a515706180f960b30595b607f2d734d14">00037</a>   <span class="keyword">typedef</span> <span class="keywordtype">int</span> <a class="code" href="petsc__linear__solver_8C.php#a515706180f960b30595b607f2d734d14">PetscInt</a>;
<a name="l00038"></a>00038 <span class="preprocessor">#endif</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(3,0,1) &amp;&amp; PETSC_VERSION_RELEASE</span>
<a name="l00042"></a><a class="code" href="petsc__linear__solver_8h.php#a4737870c4c15c93547318e44dea2e463">00042</a> <span class="preprocessor"></span>  PetscErrorCode <a class="code" href="petsc__linear__solver_8C.php#a4737870c4c15c93547318e44dea2e463">__libmesh_petsc_preconditioner_setup</a> (<span class="keywordtype">void</span> * ctx)
<a name="l00043"></a>00043   {
<a name="l00044"></a>00044     <a class="code" href="classPreconditioner.php">Preconditioner&lt;Number&gt;</a> * preconditioner = <span class="keyword">static_cast&lt;</span><a class="code" href="classPreconditioner.php">Preconditioner&lt;Number&gt;</a>*<span class="keyword">&gt;</span>(ctx);
<a name="l00045"></a>00045     preconditioner-&gt;<a class="code" href="classPreconditioner.php#a4548979055a8a62a8cfb7c5723dc326a">init</a>();
<a name="l00046"></a>00046 
<a name="l00047"></a>00047     <span class="keywordflow">return</span> 0;
<a name="l00048"></a>00048   }
<a name="l00049"></a>00049   
<a name="l00050"></a>00050 
<a name="l00051"></a><a class="code" href="petsc__linear__solver_8h.php#a13ac63a1ac4545e7ac3bac10a8bd8677">00051</a>   PetscErrorCode <a class="code" href="petsc__linear__solver_8C.php#a13ac63a1ac4545e7ac3bac10a8bd8677">__libmesh_petsc_preconditioner_apply</a>(<span class="keywordtype">void</span> *ctx, Vec x, Vec y)
<a name="l00052"></a>00052   {
<a name="l00053"></a>00053     <a class="code" href="classPreconditioner.php">Preconditioner&lt;Number&gt;</a> * preconditioner = <span class="keyword">static_cast&lt;</span><a class="code" href="classPreconditioner.php">Preconditioner&lt;Number&gt;</a>*<span class="keyword">&gt;</span>(ctx);
<a name="l00054"></a>00054 
<a name="l00055"></a>00055     <a class="code" href="classPetscVector.php">PetscVector&lt;Number&gt;</a> x_vec(x);
<a name="l00056"></a>00056     <a class="code" href="classPetscVector.php">PetscVector&lt;Number&gt;</a> y_vec(y);
<a name="l00057"></a>00057 
<a name="l00058"></a>00058     preconditioner-&gt;<a class="code" href="classPreconditioner.php#a030423ba30e3badcc2ab85aa7e4ceb82">apply</a>(x_vec,y_vec);
<a name="l00059"></a>00059 
<a name="l00060"></a>00060     <span class="keywordflow">return</span> 0;
<a name="l00061"></a>00061   }
<a name="l00062"></a>00062 <span class="preprocessor">#else</span>
<a name="l00063"></a><a class="code" href="petsc__linear__solver_8h.php#a7f9050298a8ebb30a5e1998947b8653e">00063</a> <span class="preprocessor"></span>  PetscErrorCode <a class="code" href="petsc__linear__solver_8C.php#a4737870c4c15c93547318e44dea2e463">__libmesh_petsc_preconditioner_setup</a> (PC pc)
<a name="l00064"></a>00064   {
<a name="l00065"></a>00065     <span class="keywordtype">void</span> *ctx;
<a name="l00066"></a>00066     PetscErrorCode ierr = PCShellGetContext(pc,&amp;ctx);CHKERRQ(ierr);
<a name="l00067"></a>00067     <a class="code" href="classPreconditioner.php">Preconditioner&lt;Number&gt;</a> * preconditioner = <span class="keyword">static_cast&lt;</span><a class="code" href="classPreconditioner.php">Preconditioner&lt;Number&gt;</a>*<span class="keyword">&gt;</span>(ctx);
<a name="l00068"></a>00068     preconditioner-&gt;<a class="code" href="classPreconditioner.php#a4548979055a8a62a8cfb7c5723dc326a">init</a>();
<a name="l00069"></a>00069 
<a name="l00070"></a>00070     <span class="keywordflow">return</span> 0;
<a name="l00071"></a>00071   }
<a name="l00072"></a>00072 
<a name="l00073"></a><a class="code" href="petsc__linear__solver_8h.php#add1205beb649851a35301fb431bdb655">00073</a>   PetscErrorCode <a class="code" href="petsc__linear__solver_8C.php#a13ac63a1ac4545e7ac3bac10a8bd8677">__libmesh_petsc_preconditioner_apply</a>(PC pc, Vec x, Vec y)
<a name="l00074"></a>00074   {
<a name="l00075"></a>00075     <span class="keywordtype">void</span> *ctx;
<a name="l00076"></a>00076     PetscErrorCode ierr = PCShellGetContext(pc,&amp;ctx);CHKERRQ(ierr);
<a name="l00077"></a>00077     <a class="code" href="classPreconditioner.php">Preconditioner&lt;Number&gt;</a> * preconditioner = <span class="keyword">static_cast&lt;</span><a class="code" href="classPreconditioner.php">Preconditioner&lt;Number&gt;</a>*<span class="keyword">&gt;</span>(ctx);
<a name="l00078"></a>00078 
<a name="l00079"></a>00079     <a class="code" href="classPetscVector.php">PetscVector&lt;Number&gt;</a> x_vec(x);
<a name="l00080"></a>00080     <a class="code" href="classPetscVector.php">PetscVector&lt;Number&gt;</a> y_vec(y);
<a name="l00081"></a>00081 
<a name="l00082"></a>00082     preconditioner-&gt;<a class="code" href="classPreconditioner.php#a030423ba30e3badcc2ab85aa7e4ceb82">apply</a>(x_vec,y_vec);
<a name="l00083"></a>00083 
<a name="l00084"></a>00084     <span class="keywordflow">return</span> 0;
<a name="l00085"></a>00085   }
<a name="l00086"></a>00086 <span class="preprocessor">#endif</span>
<a name="l00087"></a>00087 <span class="preprocessor"></span>} <span class="comment">// end extern &quot;C&quot;</span>
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 <span class="comment">/*----------------------- functions ----------------------------------*/</span>
<a name="l00090"></a>00090 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00091"></a><a class="code" href="classPetscLinearSolver.php#a9df90716996e557a9e97d8d882876d98">00091</a> <span class="keywordtype">void</span> <a class="code" href="classPetscLinearSolver.php#a9df90716996e557a9e97d8d882876d98">PetscLinearSolver&lt;T&gt;::clear</a> ()
<a name="l00092"></a>00092 {
<a name="l00093"></a>00093   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00094"></a>00094     {
<a name="l00095"></a>00095       this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00096"></a>00096 
<a name="l00097"></a>00097       <span class="keywordtype">int</span> ierr=0;
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,0)</span>
<a name="l00100"></a>00100 <span class="preprocessor"></span>
<a name="l00101"></a>00101   <span class="comment">// 2.1.x &amp; earlier style      </span>
<a name="l00102"></a>00102   ierr = SLESDestroy(_sles);
<a name="l00103"></a>00103          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 <span class="preprocessor">#else</span>
<a name="l00106"></a>00106 <span class="preprocessor"></span>
<a name="l00107"></a>00107   <span class="comment">// 2.2.0 &amp; newer style</span>
<a name="l00108"></a>00108   ierr = KSPDestroy(_ksp);
<a name="l00109"></a>00109          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 <span class="preprocessor">#endif</span>
<a name="l00112"></a>00112 <span class="preprocessor"></span>
<a name="l00113"></a>00113              
<a name="l00114"></a>00114       <span class="comment">// Mimic PETSc default solver and preconditioner</span>
<a name="l00115"></a>00115       this-&gt;_solver_type           = <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a28c6a4ecccca1d0e6956e5e94fa82d97">GMRES</a>;
<a name="l00116"></a>00116 
<a name="l00117"></a>00117       <span class="keywordflow">if</span>(!this-&gt;_preconditioner)
<a name="l00118"></a>00118       {
<a name="l00119"></a>00119         <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l00120"></a>00120           this-&gt;_preconditioner_type = <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4af54549e0e69fbdd4ddd199ee316527f3">ILU_PRECOND</a>;
<a name="l00121"></a>00121         <span class="keywordflow">else</span>
<a name="l00122"></a>00122           this-&gt;_preconditioner_type = <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a8f036d61e96c69b14d585f04235613d2">BLOCK_JACOBI_PRECOND</a>;
<a name="l00123"></a>00123       }
<a name="l00124"></a>00124     }
<a name="l00125"></a>00125 }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00130"></a><a class="code" href="classPetscLinearSolver.php#aa2812b487efec89def8b23269b8afdfe">00130</a> <span class="keywordtype">void</span> <a class="code" href="classPetscLinearSolver.php#aa2812b487efec89def8b23269b8afdfe">PetscLinearSolver&lt;T&gt;::init</a> ()
<a name="l00131"></a>00131 {
<a name="l00132"></a>00132   <span class="comment">// Initialize the data structures if not done so already.</span>
<a name="l00133"></a>00133   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00134"></a>00134     {
<a name="l00135"></a>00135       this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00136"></a>00136       
<a name="l00137"></a>00137       <span class="keywordtype">int</span> ierr=0;
<a name="l00138"></a>00138   
<a name="l00139"></a>00139 <span class="comment">// 2.1.x &amp; earlier style      </span>
<a name="l00140"></a>00140 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,0)</span>
<a name="l00141"></a>00141 <span class="preprocessor"></span>      
<a name="l00142"></a>00142       <span class="comment">// Create the linear solver context</span>
<a name="l00143"></a>00143       ierr = SLESCreate (<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>, &amp;_sles);
<a name="l00144"></a>00144              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00145"></a>00145       
<a name="l00146"></a>00146       <span class="comment">// Create the Krylov subspace &amp; preconditioner contexts</span>
<a name="l00147"></a>00147       ierr = SLESGetKSP       (_sles, &amp;_ksp);
<a name="l00148"></a>00148              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00149"></a>00149       ierr = SLESGetPC        (_sles, &amp;_pc);
<a name="l00150"></a>00150              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00151"></a>00151       
<a name="l00152"></a>00152       <span class="comment">// Have the Krylov subspace method use our good initial guess rather than 0</span>
<a name="l00153"></a>00153       ierr = KSPSetInitialGuessNonzero (_ksp, PETSC_TRUE);
<a name="l00154"></a>00154              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00155"></a>00155       
<a name="l00156"></a>00156       <span class="comment">// Set user-specified  solver and preconditioner types</span>
<a name="l00157"></a>00157       this-&gt;set_petsc_solver_type();
<a name="l00158"></a>00158       
<a name="l00159"></a>00159       <span class="comment">// Set the options from user-input</span>
<a name="l00160"></a>00160       <span class="comment">// Set runtime options, e.g.,</span>
<a name="l00161"></a>00161       <span class="comment">//      -ksp_type &lt;type&gt; -pc_type &lt;type&gt; -ksp_monitor -ksp_rtol &lt;rtol&gt;</span>
<a name="l00162"></a>00162       <span class="comment">//  These options will override those specified above as long as</span>
<a name="l00163"></a>00163       <span class="comment">//  SLESSetFromOptions() is called _after_ any other customization</span>
<a name="l00164"></a>00164       <span class="comment">//  routines.</span>
<a name="l00165"></a>00165       
<a name="l00166"></a>00166       ierr = SLESSetFromOptions (_sles);
<a name="l00167"></a>00167              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 <span class="comment">// 2.2.0 &amp; newer style</span>
<a name="l00170"></a>00170 <span class="preprocessor">#else</span>
<a name="l00171"></a>00171 <span class="preprocessor"></span>      
<a name="l00172"></a>00172       <span class="comment">// Create the linear solver context</span>
<a name="l00173"></a>00173       ierr = KSPCreate (<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>, &amp;_ksp);
<a name="l00174"></a>00174              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00175"></a>00175       
<a name="l00176"></a>00176       <span class="comment">// Create the preconditioner context</span>
<a name="l00177"></a>00177       ierr = KSPGetPC        (_ksp, &amp;_pc);
<a name="l00178"></a>00178              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00179"></a>00179 
<a name="l00180"></a>00180       <span class="comment">// Have the Krylov subspace method use our good initial guess rather than 0</span>
<a name="l00181"></a>00181       ierr = KSPSetInitialGuessNonzero (_ksp, PETSC_TRUE);
<a name="l00182"></a>00182              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00183"></a>00183       
<a name="l00184"></a>00184       <span class="comment">// Set user-specified  solver and preconditioner types</span>
<a name="l00185"></a>00185       this-&gt;set_petsc_solver_type();
<a name="l00186"></a>00186 
<a name="l00187"></a>00187       <span class="comment">// Set the options from user-input</span>
<a name="l00188"></a>00188       <span class="comment">// Set runtime options, e.g.,</span>
<a name="l00189"></a>00189       <span class="comment">//      -ksp_type &lt;type&gt; -pc_type &lt;type&gt; -ksp_monitor -ksp_rtol &lt;rtol&gt;</span>
<a name="l00190"></a>00190       <span class="comment">//  These options will override those specified above as long as</span>
<a name="l00191"></a>00191       <span class="comment">//  KSPSetFromOptions() is called _after_ any other customization</span>
<a name="l00192"></a>00192       <span class="comment">//  routines.</span>
<a name="l00193"></a>00193       
<a name="l00194"></a>00194       ierr = KSPSetFromOptions (_ksp);
<a name="l00195"></a>00195       CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00196"></a>00196 
<a name="l00197"></a>00197       <span class="comment">// Not sure if this is necessary, or if it is already handled by KSPSetFromOptions?</span>
<a name="l00198"></a>00198       <span class="comment">// NOT NECESSARY!!!!</span>
<a name="l00199"></a>00199       <span class="comment">//ierr = PCSetFromOptions (_pc);</span>
<a name="l00200"></a>00200       <span class="comment">//CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00201"></a>00201 
<a name="l00202"></a>00202                
<a name="l00203"></a>00203 <span class="preprocessor">#endif</span>
<a name="l00204"></a>00204 <span class="preprocessor"></span>             
<a name="l00205"></a>00205       <span class="comment">// Notify PETSc of location to store residual history.</span>
<a name="l00206"></a>00206       <span class="comment">// This needs to be called before any solves, since</span>
<a name="l00207"></a>00207       <span class="comment">// it sets the residual history length to zero.  The default</span>
<a name="l00208"></a>00208       <span class="comment">// behavior is for PETSc to allocate (internally) an array</span>
<a name="l00209"></a>00209       <span class="comment">// of size 1000 to hold the residual norm history.</span>
<a name="l00210"></a>00210       ierr = KSPSetResidualHistory(_ksp,
<a name="l00211"></a>00211                                    PETSC_NULL,   <span class="comment">// pointer to the array which holds the history</span>
<a name="l00212"></a>00212                                    PETSC_DECIDE, <span class="comment">// size of the array holding the history</span>
<a name="l00213"></a>00213                                    PETSC_TRUE);  <span class="comment">// Whether or not to reset the history for each solve. </span>
<a name="l00214"></a>00214       CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00215"></a>00215 
<a name="l00216"></a>00216       <a class="code" href="classPetscPreconditioner.php#a19eb1fca114780091f7d205ff9067b5c">PetscPreconditioner&lt;T&gt;::set_petsc_preconditioner_type</a>(this-&gt;_preconditioner_type,_pc);
<a name="l00217"></a>00217 
<a name="l00218"></a>00218       <span class="comment">//If there is a preconditioner object we need to set the internal setup and apply routines</span>
<a name="l00219"></a>00219       <span class="keywordflow">if</span>(this-&gt;_preconditioner)
<a name="l00220"></a>00220       {
<a name="l00221"></a>00221         PCShellSetContext(_pc,(<span class="keywordtype">void</span>*)this-&gt;_preconditioner);
<a name="l00222"></a>00222         PCShellSetSetUp(_pc,<a class="code" href="petsc__linear__solver_8C.php#a4737870c4c15c93547318e44dea2e463">__libmesh_petsc_preconditioner_setup</a>);
<a name="l00223"></a>00223         PCShellSetApply(_pc,<a class="code" href="petsc__linear__solver_8C.php#a13ac63a1ac4545e7ac3bac10a8bd8677">__libmesh_petsc_preconditioner_apply</a>);
<a name="l00224"></a>00224       }
<a name="l00225"></a>00225     }
<a name="l00226"></a>00226 }
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00230"></a><a class="code" href="classPetscLinearSolver.php#a55c0d055a2a688b1e6bb01f239799411">00230</a> <span class="keywordtype">void</span> <a class="code" href="classPetscLinearSolver.php#aa2812b487efec89def8b23269b8afdfe">PetscLinearSolver&lt;T&gt;::init</a> ( <a class="code" href="classPetscMatrix.php">PetscMatrix&lt;T&gt;</a>* matrix )
<a name="l00231"></a>00231 {
<a name="l00232"></a>00232   <span class="comment">// Initialize the data structures if not done so already.</span>
<a name="l00233"></a>00233   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00234"></a>00234     {
<a name="l00235"></a>00235       this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00236"></a>00236       
<a name="l00237"></a>00237       <span class="keywordtype">int</span> ierr=0;
<a name="l00238"></a>00238 
<a name="l00239"></a>00239 <span class="comment">// 2.1.x &amp; earlier style      </span>
<a name="l00240"></a>00240 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,0)</span>
<a name="l00241"></a>00241 <span class="preprocessor"></span>      
<a name="l00242"></a>00242       <span class="comment">// Create the linear solver context</span>
<a name="l00243"></a>00243       ierr = SLESCreate (<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>, &amp;_sles);
<a name="l00244"></a>00244              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00245"></a>00245       
<a name="l00246"></a>00246       <span class="comment">// Create the Krylov subspace &amp; preconditioner contexts</span>
<a name="l00247"></a>00247       ierr = SLESGetKSP       (_sles, &amp;_ksp);
<a name="l00248"></a>00248              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00249"></a>00249       ierr = SLESGetPC        (_sles, &amp;_pc);
<a name="l00250"></a>00250              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00251"></a>00251       
<a name="l00252"></a>00252       <span class="comment">// Have the Krylov subspace method use our good initial guess rather than 0</span>
<a name="l00253"></a>00253       ierr = KSPSetInitialGuessNonzero (_ksp, PETSC_TRUE);
<a name="l00254"></a>00254              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00255"></a>00255       
<a name="l00256"></a>00256       <span class="comment">// Set user-specified  solver and preconditioner types</span>
<a name="l00257"></a>00257       this-&gt;set_petsc_solver_type();
<a name="l00258"></a>00258       
<a name="l00259"></a>00259       <span class="comment">// Set the options from user-input</span>
<a name="l00260"></a>00260       <span class="comment">// Set runtime options, e.g.,</span>
<a name="l00261"></a>00261       <span class="comment">//      -ksp_type &lt;type&gt; -pc_type &lt;type&gt; -ksp_monitor -ksp_rtol &lt;rtol&gt;</span>
<a name="l00262"></a>00262       <span class="comment">//  These options will override those specified above as long as</span>
<a name="l00263"></a>00263       <span class="comment">//  SLESSetFromOptions() is called _after_ any other customization</span>
<a name="l00264"></a>00264       <span class="comment">//  routines.</span>
<a name="l00265"></a>00265       
<a name="l00266"></a>00266       ierr = SLESSetFromOptions (_sles);
<a name="l00267"></a>00267              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00268"></a>00268 
<a name="l00269"></a>00269 <span class="comment">// 2.2.0 &amp; newer style</span>
<a name="l00270"></a>00270 <span class="preprocessor">#else</span>
<a name="l00271"></a>00271 <span class="preprocessor"></span>      
<a name="l00272"></a>00272       <span class="comment">// Create the linear solver context</span>
<a name="l00273"></a>00273       ierr = KSPCreate (<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>, &amp;_ksp);
<a name="l00274"></a>00274              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00275"></a>00275       
<a name="l00276"></a>00276     
<a name="l00277"></a>00277       <span class="comment">//ierr = PCCreate (libMesh::COMM_WORLD, &amp;_pc);</span>
<a name="l00278"></a>00278       <span class="comment">//     CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00279"></a>00279       
<a name="l00280"></a>00280       <span class="comment">// Create the preconditioner context</span>
<a name="l00281"></a>00281       ierr = KSPGetPC        (_ksp, &amp;_pc);
<a name="l00282"></a>00282              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00283"></a>00283       
<a name="l00284"></a>00284       <span class="comment">// Set operators. The input matrix works as the preconditioning matrix</span>
<a name="l00285"></a>00285       ierr = KSPSetOperators(_ksp, matrix-&gt;<a class="code" href="classPetscMatrix.php#a612eda163983cf42adb5a2151045f28b">mat</a>(), matrix-&gt;<a class="code" href="classPetscMatrix.php#a612eda163983cf42adb5a2151045f28b">mat</a>(),SAME_NONZERO_PATTERN);
<a name="l00286"></a>00286              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);       
<a name="l00287"></a>00287 
<a name="l00288"></a>00288       <span class="comment">// Have the Krylov subspace method use our good initial guess rather than 0</span>
<a name="l00289"></a>00289       ierr = KSPSetInitialGuessNonzero (_ksp, PETSC_TRUE);
<a name="l00290"></a>00290              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00291"></a>00291       
<a name="l00292"></a>00292       <span class="comment">// Set user-specified  solver and preconditioner types</span>
<a name="l00293"></a>00293       this-&gt;set_petsc_solver_type();
<a name="l00294"></a>00294 
<a name="l00295"></a>00295       <span class="comment">// Set the options from user-input</span>
<a name="l00296"></a>00296       <span class="comment">// Set runtime options, e.g.,</span>
<a name="l00297"></a>00297       <span class="comment">//      -ksp_type &lt;type&gt; -pc_type &lt;type&gt; -ksp_monitor -ksp_rtol &lt;rtol&gt;</span>
<a name="l00298"></a>00298       <span class="comment">//  These options will override those specified above as long as</span>
<a name="l00299"></a>00299       <span class="comment">//  KSPSetFromOptions() is called _after_ any other customization</span>
<a name="l00300"></a>00300       <span class="comment">//  routines.</span>
<a name="l00301"></a>00301       
<a name="l00302"></a>00302       ierr = KSPSetFromOptions (_ksp);
<a name="l00303"></a>00303       CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00304"></a>00304 
<a name="l00305"></a>00305       <span class="comment">// Not sure if this is necessary, or if it is already handled by KSPSetFromOptions?</span>
<a name="l00306"></a>00306       <span class="comment">// NOT NECESSARY!!!!</span>
<a name="l00307"></a>00307       <span class="comment">//ierr = PCSetFromOptions (_pc);</span>
<a name="l00308"></a>00308       <span class="comment">//CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00309"></a>00309 
<a name="l00310"></a>00310                
<a name="l00311"></a>00311 <span class="preprocessor">#endif</span>
<a name="l00312"></a>00312 <span class="preprocessor"></span>             
<a name="l00313"></a>00313       <span class="comment">// Notify PETSc of location to store residual history.</span>
<a name="l00314"></a>00314       <span class="comment">// This needs to be called before any solves, since</span>
<a name="l00315"></a>00315       <span class="comment">// it sets the residual history length to zero.  The default</span>
<a name="l00316"></a>00316       <span class="comment">// behavior is for PETSc to allocate (internally) an array</span>
<a name="l00317"></a>00317       <span class="comment">// of size 1000 to hold the residual norm history.</span>
<a name="l00318"></a>00318       ierr = KSPSetResidualHistory(_ksp,
<a name="l00319"></a>00319                                    PETSC_NULL,   <span class="comment">// pointer to the array which holds the history</span>
<a name="l00320"></a>00320                                    PETSC_DECIDE, <span class="comment">// size of the array holding the history</span>
<a name="l00321"></a>00321                                    PETSC_TRUE);  <span class="comment">// Whether or not to reset the history for each solve. </span>
<a name="l00322"></a>00322       CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00323"></a>00323 
<a name="l00324"></a>00324       <a class="code" href="classPetscPreconditioner.php#a19eb1fca114780091f7d205ff9067b5c">PetscPreconditioner&lt;T&gt;::set_petsc_preconditioner_type</a>(this-&gt;_preconditioner_type,_pc);      
<a name="l00325"></a>00325       <span class="keywordflow">if</span>(this-&gt;_preconditioner)
<a name="l00326"></a>00326       {
<a name="l00327"></a>00327         this-&gt;_preconditioner-&gt;set_matrix(*matrix);
<a name="l00328"></a>00328         PCShellSetContext(_pc,(<span class="keywordtype">void</span>*)this-&gt;_preconditioner);
<a name="l00329"></a>00329         PCShellSetSetUp(_pc,<a class="code" href="petsc__linear__solver_8C.php#a4737870c4c15c93547318e44dea2e463">__libmesh_petsc_preconditioner_setup</a>);
<a name="l00330"></a>00330         PCShellSetApply(_pc,<a class="code" href="petsc__linear__solver_8C.php#a13ac63a1ac4545e7ac3bac10a8bd8677">__libmesh_petsc_preconditioner_apply</a>);
<a name="l00331"></a>00331       }
<a name="l00332"></a>00332     }
<a name="l00333"></a>00333 }
<a name="l00334"></a>00334 
<a name="l00335"></a>00335 
<a name="l00336"></a>00336 
<a name="l00337"></a>00337 
<a name="l00338"></a>00338 
<a name="l00339"></a>00339 
<a name="l00340"></a>00340 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00341"></a>00341 std::pair&lt;unsigned int, Real&gt; 
<a name="l00342"></a><a class="code" href="classPetscLinearSolver.php#a731e51c51d4625c8252d3a75f360df2f">00342</a> <a class="code" href="classPetscLinearSolver.php#a84b2c641cf61d768f9c7a07e501b59c9">PetscLinearSolver&lt;T&gt;::solve</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;  matrix_in,
<a name="l00343"></a>00343                              <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;  precond_in,
<a name="l00344"></a>00344                              <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; solution_in,
<a name="l00345"></a>00345                              <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; rhs_in,
<a name="l00346"></a>00346                              <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00347"></a>00347                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its)
<a name="l00348"></a>00348 {
<a name="l00349"></a>00349   START_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;PetscLinearSolver&quot;</span>);
<a name="l00350"></a>00350   
<a name="l00351"></a>00351   <span class="comment">// Make sure the data passed in are really of Petsc types</span>
<a name="l00352"></a>00352   <a class="code" href="classPetscMatrix.php">PetscMatrix&lt;T&gt;</a>* matrix   = libmesh_cast_ptr&lt;PetscMatrix&lt;T&gt;*&gt;(&amp;matrix_in);
<a name="l00353"></a>00353   <a class="code" href="classPetscMatrix.php">PetscMatrix&lt;T&gt;</a>* precond  = libmesh_cast_ptr&lt;PetscMatrix&lt;T&gt;*&gt;(&amp;precond_in);
<a name="l00354"></a>00354   <a class="code" href="classPetscVector.php">PetscVector&lt;T&gt;</a>* solution = libmesh_cast_ptr&lt;PetscVector&lt;T&gt;*&gt;(&amp;solution_in);
<a name="l00355"></a>00355   <a class="code" href="classPetscVector.php">PetscVector&lt;T&gt;</a>* rhs      = libmesh_cast_ptr&lt;PetscVector&lt;T&gt;*&gt;(&amp;rhs_in);
<a name="l00356"></a>00356 
<a name="l00357"></a>00357   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> (matrix);
<a name="l00358"></a>00358 
<a name="l00359"></a>00359   <span class="keywordtype">int</span> ierr=0;
<a name="l00360"></a>00360   <span class="keywordtype">int</span> its=0, max_its = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(m_its);
<a name="l00361"></a>00361   PetscReal final_resid=0.;
<a name="l00362"></a>00362 
<a name="l00363"></a>00363   <span class="comment">// Close the matrices and vectors in case this wasn&#39;t already done.</span>
<a name="l00364"></a>00364   matrix-&gt;<a class="code" href="classPetscMatrix.php#a431196369d051b83ea1e3d595ec2dc0d">close</a> ();
<a name="l00365"></a>00365   precond-&gt;close ();
<a name="l00366"></a>00366   solution-&gt;close ();
<a name="l00367"></a>00367   rhs-&gt;close ();
<a name="l00368"></a>00368 
<a name="l00369"></a>00369 <span class="comment">//   // If matrix != precond, then this means we have specified a</span>
<a name="l00370"></a>00370 <span class="comment">//   // special preconditioner, so reset preconditioner type to PCMAT.</span>
<a name="l00371"></a>00371 <span class="comment">//   if (matrix != precond)</span>
<a name="l00372"></a>00372 <span class="comment">//     {</span>
<a name="l00373"></a>00373 <span class="comment">//       this-&gt;_preconditioner_type = USER_PRECOND;</span>
<a name="l00374"></a>00374 <span class="comment">//       this-&gt;set_petsc_preconditioner_type ();</span>
<a name="l00375"></a>00375 <span class="comment">//     }</span>
<a name="l00376"></a>00376 
<a name="l00377"></a>00377   <span class="keywordflow">if</span>(this-&gt;_preconditioner)
<a name="l00378"></a>00378     this-&gt;_preconditioner-&gt;set_matrix(matrix_in);
<a name="l00379"></a>00379 
<a name="l00380"></a>00380   
<a name="l00381"></a>00381 <span class="comment">// 2.1.x &amp; earlier style      </span>
<a name="l00382"></a>00382 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,0)</span>
<a name="l00383"></a>00383 <span class="preprocessor"></span>      
<a name="l00384"></a>00384   <span class="comment">// Set operators. The input matrix works as the preconditioning matrix</span>
<a name="l00385"></a>00385   ierr = SLESSetOperators(_sles, matrix-&gt;<a class="code" href="classPetscMatrix.php#a612eda163983cf42adb5a2151045f28b">mat</a>(), precond-&gt;mat(),
<a name="l00386"></a>00386                           SAME_NONZERO_PATTERN);
<a name="l00387"></a>00387          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00388"></a>00388 
<a name="l00389"></a>00389   <span class="comment">// Set the tolerances for the iterative solver.  Use the user-supplied</span>
<a name="l00390"></a>00390   <span class="comment">// tolerance for the relative residual &amp; leave the others at default values.</span>
<a name="l00391"></a>00391   ierr = KSPSetTolerances (_ksp, tol, PETSC_DEFAULT,
<a name="l00392"></a>00392                            PETSC_DEFAULT, max_its);
<a name="l00393"></a>00393          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00394"></a>00394 
<a name="l00395"></a>00395 
<a name="l00396"></a>00396   <span class="comment">// Solve the linear system</span>
<a name="l00397"></a>00397   ierr = SLESSolve (_sles, rhs-&gt;vec(), solution-&gt;vec(), &amp;its);
<a name="l00398"></a>00398          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00399"></a>00399 
<a name="l00400"></a>00400 
<a name="l00401"></a>00401   <span class="comment">// Get the norm of the final residual to return to the user.</span>
<a name="l00402"></a>00402   ierr = KSPGetResidualNorm (_ksp, &amp;final_resid);
<a name="l00403"></a>00403          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00404"></a>00404 
<a name="l00405"></a>00405 <span class="comment">// 2.2.0</span>
<a name="l00406"></a>00406 <span class="preprocessor">#elif PETSC_VERSION_LESS_THAN(2,2,1)</span>
<a name="l00407"></a>00407 <span class="preprocessor"></span>      
<a name="l00408"></a>00408   <span class="comment">// Set operators. The input matrix works as the preconditioning matrix</span>
<a name="l00409"></a>00409   <span class="comment">//ierr = KSPSetOperators(_ksp, matrix-&gt;mat(), precond-&gt;mat(),</span>
<a name="l00410"></a>00410          <span class="comment">//                      SAME_NONZERO_PATTERN);</span>
<a name="l00411"></a>00411          <span class="comment">//       CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00412"></a>00412 
<a name="l00413"></a>00413 
<a name="l00414"></a>00414   <span class="comment">// Set the tolerances for the iterative solver.  Use the user-supplied</span>
<a name="l00415"></a>00415   <span class="comment">// tolerance for the relative residual &amp; leave the others at default values.</span>
<a name="l00416"></a>00416   <span class="comment">// Convergence is detected at iteration k if</span>
<a name="l00417"></a>00417   <span class="comment">// ||r_k||_2 &lt; max(rtol*||b||_2 , abstol)</span>
<a name="l00418"></a>00418   <span class="comment">// where r_k is the residual vector and b is the right-hand side.  Note that</span>
<a name="l00419"></a>00419   <span class="comment">// it is the *maximum* of the two values, the larger of which will almost</span>
<a name="l00420"></a>00420   <span class="comment">// always be rtol*||b||_2. </span>
<a name="l00421"></a>00421   ierr = KSPSetTolerances (_ksp,
<a name="l00422"></a>00422                            tol,           <span class="comment">// rtol   = relative decrease in residual  (1.e-5)</span>
<a name="l00423"></a>00423                            PETSC_DEFAULT, <span class="comment">// abstol = absolute convergence tolerance (1.e-50)</span>
<a name="l00424"></a>00424                            PETSC_DEFAULT, <span class="comment">// dtol   = divergence tolerance           (1.e+5)</span>
<a name="l00425"></a>00425                            max_its);
<a name="l00426"></a>00426          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00427"></a>00427 
<a name="l00428"></a>00428 
<a name="l00429"></a>00429   <span class="comment">// Set the solution vector to use</span>
<a name="l00430"></a>00430   ierr = KSPSetSolution (_ksp, solution-&gt;vec());
<a name="l00431"></a>00431          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00432"></a>00432          
<a name="l00433"></a>00433   <span class="comment">// Set the RHS vector to use</span>
<a name="l00434"></a>00434   ierr = KSPSetRhs (_ksp, rhs-&gt;vec());
<a name="l00435"></a>00435          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00436"></a>00436    
<a name="l00437"></a>00437   <span class="comment">// Solve the linear system</span>
<a name="l00438"></a>00438   ierr = KSPSolve (_ksp);
<a name="l00439"></a>00439          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00440"></a>00440          
<a name="l00441"></a>00441   <span class="comment">// Get the number of iterations required for convergence</span>
<a name="l00442"></a>00442   ierr = KSPGetIterationNumber (_ksp, &amp;its);
<a name="l00443"></a>00443          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00444"></a>00444          
<a name="l00445"></a>00445   <span class="comment">// Get the norm of the final residual to return to the user.</span>
<a name="l00446"></a>00446   ierr = KSPGetResidualNorm (_ksp, &amp;final_resid);
<a name="l00447"></a>00447          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00448"></a>00448          
<a name="l00449"></a>00449 <span class="comment">// 2.2.1 &amp; newer style</span>
<a name="l00450"></a>00450 <span class="preprocessor">#else</span>
<a name="l00451"></a>00451 <span class="preprocessor"></span>      
<a name="l00452"></a>00452   <span class="comment">// Set operators. The input matrix works as the preconditioning matrix</span>
<a name="l00453"></a>00453   <span class="keywordflow">if</span>(!this-&gt;same_preconditioner)
<a name="l00454"></a>00454   {
<a name="l00455"></a>00455     ierr = KSPSetOperators(_ksp, matrix-&gt;<a class="code" href="classPetscMatrix.php#a612eda163983cf42adb5a2151045f28b">mat</a>(), precond-&gt;mat(),
<a name="l00456"></a>00456                            SAME_NONZERO_PATTERN);
<a name="l00457"></a>00457            CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00458"></a>00458   }
<a name="l00459"></a>00459   <span class="keywordflow">else</span>
<a name="l00460"></a>00460   {
<a name="l00461"></a>00461     ierr = KSPSetOperators(_ksp, matrix-&gt;<a class="code" href="classPetscMatrix.php#a612eda163983cf42adb5a2151045f28b">mat</a>(), precond-&gt;mat(),
<a name="l00462"></a>00462                SAME_PRECONDITIONER);
<a name="l00463"></a>00463            CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00464"></a>00464   }
<a name="l00465"></a>00465 
<a name="l00466"></a>00466   <span class="comment">// Set the tolerances for the iterative solver.  Use the user-supplied</span>
<a name="l00467"></a>00467   <span class="comment">// tolerance for the relative residual &amp; leave the others at default values.</span>
<a name="l00468"></a>00468   ierr = KSPSetTolerances (_ksp, tol, PETSC_DEFAULT,
<a name="l00469"></a>00469                            PETSC_DEFAULT, max_its);
<a name="l00470"></a>00470          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00471"></a>00471 
<a name="l00472"></a>00472   <span class="comment">// Solve the linear system</span>
<a name="l00473"></a>00473   ierr = KSPSolve (_ksp, rhs-&gt;vec(), solution-&gt;vec());
<a name="l00474"></a>00474          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00475"></a>00475          
<a name="l00476"></a>00476   <span class="comment">// Get the number of iterations required for convergence</span>
<a name="l00477"></a>00477   ierr = KSPGetIterationNumber (_ksp, &amp;its);
<a name="l00478"></a>00478          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00479"></a>00479          
<a name="l00480"></a>00480   <span class="comment">// Get the norm of the final residual to return to the user.</span>
<a name="l00481"></a>00481   ierr = KSPGetResidualNorm (_ksp, &amp;final_resid);
<a name="l00482"></a>00482          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00483"></a>00483          
<a name="l00484"></a>00484 <span class="preprocessor">#endif</span>
<a name="l00485"></a>00485 <span class="preprocessor"></span>
<a name="l00486"></a>00486   STOP_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;PetscLinearSolver&quot;</span>);
<a name="l00487"></a>00487   <span class="comment">// return the # of its. and the final residual norm.</span>
<a name="l00488"></a>00488   <span class="keywordflow">return</span> std::make_pair(its, final_resid);
<a name="l00489"></a>00489 }
<a name="l00490"></a>00490 
<a name="l00491"></a>00491 
<a name="l00492"></a>00492 
<a name="l00493"></a>00493 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00494"></a>00494 std::pair&lt;unsigned int, Real&gt; 
<a name="l00495"></a><a class="code" href="classPetscLinearSolver.php#a34c508fbb656818e119cd1c589f7d971">00495</a> <a class="code" href="classPetscLinearSolver.php#a84b2c641cf61d768f9c7a07e501b59c9">PetscLinearSolver&lt;T&gt;::solve</a> (<span class="keyword">const</span> <a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix,
<a name="l00496"></a>00496                              <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; solution_in,
<a name="l00497"></a>00497                              <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; rhs_in,
<a name="l00498"></a>00498                              <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00499"></a>00499                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its)
<a name="l00500"></a>00500 {
<a name="l00501"></a>00501 
<a name="l00502"></a>00502 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,1)</span>
<a name="l00503"></a>00503 <span class="preprocessor"></span>  <span class="comment">// FIXME[JWP]: There will be a bunch of unused variable warnings</span>
<a name="l00504"></a>00504   <span class="comment">// for older PETScs here.</span>
<a name="l00505"></a>00505   std::cout &lt;&lt; <span class="stringliteral">&quot;This method has been developed with PETSc 2.3.1.  &quot;</span>
<a name="l00506"></a>00506             &lt;&lt; <span class="stringliteral">&quot;No one has made it backwards compatible with older &quot;</span>
<a name="l00507"></a>00507             &lt;&lt; <span class="stringliteral">&quot;versions of PETSc so far; however, it might work &quot;</span>
<a name="l00508"></a>00508             &lt;&lt; <span class="stringliteral">&quot;without any change with some older version.&quot;</span> &lt;&lt; std::endl;
<a name="l00509"></a>00509   libmesh_error();
<a name="l00510"></a>00510   <span class="keywordflow">return</span> std::make_pair(0,0.0);
<a name="l00511"></a>00511 
<a name="l00512"></a>00512 <span class="preprocessor">#else</span>
<a name="l00513"></a>00513 <span class="preprocessor"></span>
<a name="l00514"></a>00514   START_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;PetscLinearSolver&quot;</span>);
<a name="l00515"></a>00515 
<a name="l00516"></a>00516   <span class="comment">// Make sure the data passed in are really of Petsc types</span>
<a name="l00517"></a>00517   <a class="code" href="classPetscVector.php">PetscVector&lt;T&gt;</a>* solution = libmesh_cast_ptr&lt;PetscVector&lt;T&gt;*&gt;(&amp;solution_in);
<a name="l00518"></a>00518   <a class="code" href="classPetscVector.php">PetscVector&lt;T&gt;</a>* rhs      = libmesh_cast_ptr&lt;PetscVector&lt;T&gt;*&gt;(&amp;rhs_in);
<a name="l00519"></a>00519 
<a name="l00520"></a>00520   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> ();
<a name="l00521"></a>00521 
<a name="l00522"></a>00522   <span class="keywordtype">int</span> ierr=0;
<a name="l00523"></a>00523   <span class="keywordtype">int</span> its=0, max_its = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(m_its);
<a name="l00524"></a>00524   PetscReal final_resid=0.;
<a name="l00525"></a>00525 
<a name="l00526"></a>00526   <span class="comment">// Close the matrices and vectors in case this wasn&#39;t already done.</span>
<a name="l00527"></a>00527   solution-&gt;<a class="code" href="classPetscVector.php#aba0946fa812f249899f4ab12c0cf330c">close</a> ();
<a name="l00528"></a>00528   rhs-&gt;close ();
<a name="l00529"></a>00529 
<a name="l00530"></a>00530   <span class="comment">// Prepare the matrix.</span>
<a name="l00531"></a>00531   Mat mat;
<a name="l00532"></a>00532   ierr = MatCreateShell(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,
<a name="l00533"></a>00533                         rhs_in.<a class="code" href="classNumericVector.php#a400307e324862d460ff6b3b83a72e867">local_size</a>(),
<a name="l00534"></a>00534                         solution_in.<a class="code" href="classNumericVector.php#a400307e324862d460ff6b3b83a72e867">local_size</a>(),
<a name="l00535"></a>00535                         rhs_in.<a class="code" href="classNumericVector.php#ae21bc89e89e895ac26b851a31926e194">size</a>(),
<a name="l00536"></a>00536                         solution_in.<a class="code" href="classNumericVector.php#ae21bc89e89e895ac26b851a31926e194">size</a>(),
<a name="l00537"></a>00537                         <span class="keyword">const_cast&lt;</span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(<span class="keyword">static_cast&lt;</span><span class="keyword">const </span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(&amp;shell_matrix)),
<a name="l00538"></a>00538                         &amp;mat);
<a name="l00539"></a>00539   <span class="comment">/* Note that the const_cast above is only necessary because PETSc</span>
<a name="l00540"></a>00540 <span class="comment">     does not accept a const void*.  Inside the member function</span>
<a name="l00541"></a>00541 <span class="comment">     _petsc_shell_matrix() below, the pointer is casted back to a</span>
<a name="l00542"></a>00542 <span class="comment">     const ShellMatrix&lt;T&gt;*.  */</span>
<a name="l00543"></a>00543 
<a name="l00544"></a>00544   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00545"></a>00545   ierr = MatShellSetOperation(mat,MATOP_MULT,<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">void</span>(*)(<span class="keywordtype">void</span>)<span class="keyword">&gt;</span>(_petsc_shell_matrix_mult));
<a name="l00546"></a>00546   ierr = MatShellSetOperation(mat,MATOP_GET_DIAGONAL,<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">void</span>(*)(<span class="keywordtype">void</span>)<span class="keyword">&gt;</span>(_petsc_shell_matrix_get_diagonal));
<a name="l00547"></a>00547   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00548"></a>00548 
<a name="l00549"></a>00549   <span class="comment">// Set operators. The input matrix works as the preconditioning matrix</span>
<a name="l00550"></a>00550   ierr = KSPSetOperators(_ksp, mat, mat,
<a name="l00551"></a>00551                          SAME_NONZERO_PATTERN);
<a name="l00552"></a>00552   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00553"></a>00553 
<a name="l00554"></a>00554   <span class="comment">// Set the tolerances for the iterative solver.  Use the user-supplied</span>
<a name="l00555"></a>00555   <span class="comment">// tolerance for the relative residual &amp; leave the others at default values.</span>
<a name="l00556"></a>00556   ierr = KSPSetTolerances (_ksp, tol, PETSC_DEFAULT,
<a name="l00557"></a>00557                            PETSC_DEFAULT, max_its);
<a name="l00558"></a>00558   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00559"></a>00559 
<a name="l00560"></a>00560   <span class="comment">// Solve the linear system</span>
<a name="l00561"></a>00561   ierr = KSPSolve (_ksp, rhs-&gt;vec(), solution-&gt;<a class="code" href="classPetscVector.php#ada77db22640adec265059dd445404f6d">vec</a>());
<a name="l00562"></a>00562   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00563"></a>00563          
<a name="l00564"></a>00564   <span class="comment">// Get the number of iterations required for convergence</span>
<a name="l00565"></a>00565   ierr = KSPGetIterationNumber (_ksp, &amp;its);
<a name="l00566"></a>00566   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00567"></a>00567          
<a name="l00568"></a>00568   <span class="comment">// Get the norm of the final residual to return to the user.</span>
<a name="l00569"></a>00569   ierr = KSPGetResidualNorm (_ksp, &amp;final_resid);
<a name="l00570"></a>00570   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00571"></a>00571 
<a name="l00572"></a>00572   <span class="comment">// Destroy the matrix.</span>
<a name="l00573"></a>00573   ierr = MatDestroy(mat);
<a name="l00574"></a>00574   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00575"></a>00575          
<a name="l00576"></a>00576   STOP_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;PetscLinearSolver&quot;</span>);
<a name="l00577"></a>00577   <span class="comment">// return the # of its. and the final residual norm.</span>
<a name="l00578"></a>00578   <span class="keywordflow">return</span> std::make_pair(its, final_resid);
<a name="l00579"></a>00579 
<a name="l00580"></a>00580 <span class="preprocessor">#endif</span>
<a name="l00581"></a>00581 <span class="preprocessor"></span>
<a name="l00582"></a>00582 }
<a name="l00583"></a>00583 
<a name="l00584"></a>00584 
<a name="l00585"></a>00585 
<a name="l00586"></a>00586 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00587"></a>00587 std::pair&lt;unsigned int, Real&gt; 
<a name="l00588"></a><a class="code" href="classPetscLinearSolver.php#a240b790a31d3964cdc6c4026bb5e6ab6">00588</a> <a class="code" href="classPetscLinearSolver.php#a84b2c641cf61d768f9c7a07e501b59c9">PetscLinearSolver&lt;T&gt;::solve</a> (<span class="keyword">const</span> <a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix,
<a name="l00589"></a>00589                              <span class="keyword">const</span> <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; precond_matrix,
<a name="l00590"></a>00590                              <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;solution_in,
<a name="l00591"></a>00591                              <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;rhs_in,
<a name="l00592"></a>00592                              <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00593"></a>00593                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its)
<a name="l00594"></a>00594 {
<a name="l00595"></a>00595 
<a name="l00596"></a>00596 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,1)</span>
<a name="l00597"></a>00597 <span class="preprocessor"></span>  <span class="comment">// FIXME[JWP]: There will be a bunch of unused variable warnings</span>
<a name="l00598"></a>00598   <span class="comment">// for older PETScs here.</span>
<a name="l00599"></a>00599   std::cout &lt;&lt; <span class="stringliteral">&quot;This method has been developed with PETSc 2.3.1.  &quot;</span>
<a name="l00600"></a>00600             &lt;&lt; <span class="stringliteral">&quot;No one has made it backwards compatible with older &quot;</span>
<a name="l00601"></a>00601             &lt;&lt; <span class="stringliteral">&quot;versions of PETSc so far; however, it might work &quot;</span>
<a name="l00602"></a>00602             &lt;&lt; <span class="stringliteral">&quot;without any change with some older version.&quot;</span> &lt;&lt; std::endl;
<a name="l00603"></a>00603   libmesh_error();
<a name="l00604"></a>00604   <span class="keywordflow">return</span> std::make_pair(0,0.0);
<a name="l00605"></a>00605 
<a name="l00606"></a>00606 <span class="preprocessor">#else</span>
<a name="l00607"></a>00607 <span class="preprocessor"></span>
<a name="l00608"></a>00608   START_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;PetscLinearSolver&quot;</span>);
<a name="l00609"></a>00609 
<a name="l00610"></a>00610   <span class="comment">// Make sure the data passed in are really of Petsc types</span>
<a name="l00611"></a>00611   <span class="keyword">const</span> <a class="code" href="classPetscMatrix.php">PetscMatrix&lt;T&gt;</a>* precond  = libmesh_cast_ptr&lt;const PetscMatrix&lt;T&gt;*&gt;(&amp;precond_matrix);
<a name="l00612"></a>00612   <a class="code" href="classPetscVector.php">PetscVector&lt;T&gt;</a>* solution = libmesh_cast_ptr&lt;PetscVector&lt;T&gt;*&gt;(&amp;solution_in);
<a name="l00613"></a>00613   <a class="code" href="classPetscVector.php">PetscVector&lt;T&gt;</a>* rhs      = libmesh_cast_ptr&lt;PetscVector&lt;T&gt;*&gt;(&amp;rhs_in);
<a name="l00614"></a>00614 
<a name="l00615"></a>00615   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> ();
<a name="l00616"></a>00616 
<a name="l00617"></a>00617   <span class="keywordtype">int</span> ierr=0;
<a name="l00618"></a>00618   <span class="keywordtype">int</span> its=0, max_its = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(m_its);
<a name="l00619"></a>00619   PetscReal final_resid=0.;
<a name="l00620"></a>00620 
<a name="l00621"></a>00621   <span class="comment">// Close the matrices and vectors in case this wasn&#39;t already done.</span>
<a name="l00622"></a>00622   solution-&gt;close ();
<a name="l00623"></a>00623   rhs-&gt;close ();
<a name="l00624"></a>00624 
<a name="l00625"></a>00625   <span class="comment">// Prepare the matrix.</span>
<a name="l00626"></a>00626   Mat mat;
<a name="l00627"></a>00627   ierr = MatCreateShell(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,
<a name="l00628"></a>00628                         rhs_in.<a class="code" href="classNumericVector.php#a400307e324862d460ff6b3b83a72e867">local_size</a>(),
<a name="l00629"></a>00629                         solution_in.<a class="code" href="classNumericVector.php#a400307e324862d460ff6b3b83a72e867">local_size</a>(),
<a name="l00630"></a>00630                         rhs_in.<a class="code" href="classNumericVector.php#ae21bc89e89e895ac26b851a31926e194">size</a>(),
<a name="l00631"></a>00631                         solution_in.<a class="code" href="classNumericVector.php#ae21bc89e89e895ac26b851a31926e194">size</a>(),
<a name="l00632"></a>00632                         <span class="keyword">const_cast&lt;</span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(<span class="keyword">static_cast&lt;</span><span class="keyword">const </span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(&amp;shell_matrix)),
<a name="l00633"></a>00633                         &amp;mat);
<a name="l00634"></a>00634   <span class="comment">/* Note that the const_cast above is only necessary because PETSc</span>
<a name="l00635"></a>00635 <span class="comment">     does not accept a const void*.  Inside the member function</span>
<a name="l00636"></a>00636 <span class="comment">     _petsc_shell_matrix() below, the pointer is casted back to a</span>
<a name="l00637"></a>00637 <span class="comment">     const ShellMatrix&lt;T&gt;*.  */</span>
<a name="l00638"></a>00638 
<a name="l00639"></a>00639   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00640"></a>00640   ierr = MatShellSetOperation(mat,MATOP_MULT,<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">void</span>(*)(<span class="keywordtype">void</span>)<span class="keyword">&gt;</span>(_petsc_shell_matrix_mult));
<a name="l00641"></a>00641   ierr = MatShellSetOperation(mat,MATOP_GET_DIAGONAL,<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">void</span>(*)(<span class="keywordtype">void</span>)<span class="keyword">&gt;</span>(_petsc_shell_matrix_get_diagonal));
<a name="l00642"></a>00642   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00643"></a>00643 
<a name="l00644"></a>00644   <span class="comment">// Set operators. The input matrix works as the preconditioning matrix</span>
<a name="l00645"></a>00645   ierr = KSPSetOperators(_ksp, mat, <span class="keyword">const_cast&lt;</span><a class="code" href="classPetscMatrix.php">PetscMatrix&lt;T&gt;</a>*<span class="keyword">&gt;</span>(precond)-&gt;mat(),
<a name="l00646"></a>00646                          DIFFERENT_NONZERO_PATTERN);
<a name="l00647"></a>00647   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00648"></a>00648 
<a name="l00649"></a>00649   <span class="keywordflow">if</span>(this-&gt;_preconditioner)
<a name="l00650"></a>00650     this-&gt;_preconditioner-&gt;set_matrix(<span class="keyword">const_cast&lt;</span><a class="code" href="classSparseMatrix.php">SparseMatrix&lt;Number&gt;</a>&amp;<span class="keyword">&gt;</span>(precond_matrix));
<a name="l00651"></a>00651 
<a name="l00652"></a>00652   <span class="comment">// Set the tolerances for the iterative solver.  Use the user-supplied</span>
<a name="l00653"></a>00653   <span class="comment">// tolerance for the relative residual &amp; leave the others at default values.</span>
<a name="l00654"></a>00654   ierr = KSPSetTolerances (_ksp, tol, PETSC_DEFAULT,
<a name="l00655"></a>00655                            PETSC_DEFAULT, max_its);
<a name="l00656"></a>00656   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00657"></a>00657 
<a name="l00658"></a>00658   <span class="comment">// Solve the linear system</span>
<a name="l00659"></a>00659   ierr = KSPSolve (_ksp, rhs-&gt;vec(), solution-&gt;vec());
<a name="l00660"></a>00660   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00661"></a>00661          
<a name="l00662"></a>00662   <span class="comment">// Get the number of iterations required for convergence</span>
<a name="l00663"></a>00663   ierr = KSPGetIterationNumber (_ksp, &amp;its);
<a name="l00664"></a>00664   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00665"></a>00665          
<a name="l00666"></a>00666   <span class="comment">// Get the norm of the final residual to return to the user.</span>
<a name="l00667"></a>00667   ierr = KSPGetResidualNorm (_ksp, &amp;final_resid);
<a name="l00668"></a>00668   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00669"></a>00669 
<a name="l00670"></a>00670   <span class="comment">// Destroy the matrix.</span>
<a name="l00671"></a>00671   ierr = MatDestroy(mat);
<a name="l00672"></a>00672   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00673"></a>00673          
<a name="l00674"></a>00674   STOP_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;PetscLinearSolver&quot;</span>);
<a name="l00675"></a>00675   <span class="comment">// return the # of its. and the final residual norm.</span>
<a name="l00676"></a>00676   <span class="keywordflow">return</span> std::make_pair(its, final_resid);
<a name="l00677"></a>00677 
<a name="l00678"></a>00678 <span class="preprocessor">#endif</span>
<a name="l00679"></a>00679 <span class="preprocessor"></span>
<a name="l00680"></a>00680 }
<a name="l00681"></a>00681 
<a name="l00682"></a>00682 
<a name="l00683"></a>00683 
<a name="l00684"></a>00684 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00685"></a><a class="code" href="classPetscLinearSolver.php#a17fc234788a7ba293512cc71b2716348">00685</a> <span class="keywordtype">void</span> <a class="code" href="classPetscLinearSolver.php#a17fc234788a7ba293512cc71b2716348">PetscLinearSolver&lt;T&gt;::get_residual_history</a>(std::vector&lt;double&gt;&amp; hist)
<a name="l00686"></a>00686 {
<a name="l00687"></a>00687   <span class="keywordtype">int</span> ierr = 0;
<a name="l00688"></a>00688   <span class="keywordtype">int</span> its  = 0;
<a name="l00689"></a>00689 
<a name="l00690"></a>00690   <span class="comment">// Fill the residual history vector with the residual norms</span>
<a name="l00691"></a>00691   <span class="comment">// Note that GetResidualHistory() does not copy any values, it</span>
<a name="l00692"></a>00692   <span class="comment">// simply sets the pointer p.  Note that for some Krylov subspace</span>
<a name="l00693"></a>00693   <span class="comment">// methods, the number of residuals returned in the history</span>
<a name="l00694"></a>00694   <span class="comment">// vector may be different from what you are expecting.  For</span>
<a name="l00695"></a>00695   <span class="comment">// example, TFQMR returns two residual values per iteration step.</span>
<a name="l00696"></a>00696   PetscReal* p;
<a name="l00697"></a>00697   ierr = KSPGetResidualHistory(_ksp, &amp;p, &amp;its);
<a name="l00698"></a>00698   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00699"></a>00699 
<a name="l00700"></a>00700   <span class="comment">// Check for early return</span>
<a name="l00701"></a>00701   <span class="keywordflow">if</span> (its == 0) <span class="keywordflow">return</span>;
<a name="l00702"></a>00702   
<a name="l00703"></a>00703   <span class="comment">// Create space to store the result</span>
<a name="l00704"></a>00704   hist.resize(its);
<a name="l00705"></a>00705 
<a name="l00706"></a>00706   <span class="comment">// Copy history into the vector provided by the user.</span>
<a name="l00707"></a>00707   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;its; ++i)
<a name="l00708"></a>00708     {
<a name="l00709"></a>00709       hist[i] = *p;
<a name="l00710"></a>00710       p++;
<a name="l00711"></a>00711     }
<a name="l00712"></a>00712 }
<a name="l00713"></a>00713 
<a name="l00714"></a>00714 
<a name="l00715"></a>00715 
<a name="l00716"></a>00716 
<a name="l00717"></a>00717 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00718"></a><a class="code" href="classPetscLinearSolver.php#a70f0c4b77d30657eb17462689074e69b">00718</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classPetscLinearSolver.php#a70f0c4b77d30657eb17462689074e69b">PetscLinearSolver&lt;T&gt;::get_initial_residual</a>()
<a name="l00719"></a>00719 {
<a name="l00720"></a>00720   <span class="keywordtype">int</span> ierr = 0;
<a name="l00721"></a>00721   <span class="keywordtype">int</span> its  = 0;
<a name="l00722"></a>00722 
<a name="l00723"></a>00723   <span class="comment">// Fill the residual history vector with the residual norms</span>
<a name="l00724"></a>00724   <span class="comment">// Note that GetResidualHistory() does not copy any values, it</span>
<a name="l00725"></a>00725   <span class="comment">// simply sets the pointer p.  Note that for some Krylov subspace</span>
<a name="l00726"></a>00726   <span class="comment">// methods, the number of residuals returned in the history</span>
<a name="l00727"></a>00727   <span class="comment">// vector may be different from what you are expecting.  For</span>
<a name="l00728"></a>00728   <span class="comment">// example, TFQMR returns two residual values per iteration step.</span>
<a name="l00729"></a>00729   PetscReal* p;
<a name="l00730"></a>00730   ierr = KSPGetResidualHistory(_ksp, &amp;p, &amp;its);
<a name="l00731"></a>00731   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00732"></a>00732 
<a name="l00733"></a>00733   <span class="comment">// Check no residual history</span>
<a name="l00734"></a>00734   <span class="keywordflow">if</span> (its == 0)
<a name="l00735"></a>00735     {
<a name="l00736"></a>00736       std::cerr &lt;&lt; <span class="stringliteral">&quot;No iterations have been performed, returning 0.&quot;</span> &lt;&lt; std::endl;
<a name="l00737"></a>00737       <span class="keywordflow">return</span> 0.;
<a name="l00738"></a>00738     }
<a name="l00739"></a>00739 
<a name="l00740"></a>00740   <span class="comment">// Otherwise, return the value pointed to by p.</span>
<a name="l00741"></a>00741   <span class="keywordflow">return</span> *p;
<a name="l00742"></a>00742 }
<a name="l00743"></a>00743 
<a name="l00744"></a>00744 
<a name="l00745"></a>00745 
<a name="l00746"></a>00746 
<a name="l00747"></a>00747 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00748"></a><a class="code" href="classPetscLinearSolver.php#a5f707d6969fa458a0476086ec954a060">00748</a> <span class="keywordtype">void</span> <a class="code" href="classPetscLinearSolver.php#a5f707d6969fa458a0476086ec954a060">PetscLinearSolver&lt;T&gt;::set_petsc_solver_type</a>()
<a name="l00749"></a>00749 {
<a name="l00750"></a>00750   <span class="keywordtype">int</span> ierr = 0;
<a name="l00751"></a>00751   
<a name="l00752"></a>00752   <span class="keywordflow">switch</span> (this-&gt;_solver_type)
<a name="l00753"></a>00753     {
<a name="l00754"></a>00754 
<a name="l00755"></a>00755     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19af0969a6b5512fce0e1ef22d7487e23d7">CG</a>:
<a name="l00756"></a>00756       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPCG);         CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00757"></a>00757 
<a name="l00758"></a>00758     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a201f83b26b927cf91cf1cbd3c6bc0ee2">CR</a>:
<a name="l00759"></a>00759       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPCR);         CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00760"></a>00760 
<a name="l00761"></a>00761     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19afff9553e13457ad7f271af09bc52f438">CGS</a>:
<a name="l00762"></a>00762       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPCGS);        CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00763"></a>00763 
<a name="l00764"></a>00764     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a0dcffd9411a6eaa02f83ce1be41bcde2">BICG</a>:
<a name="l00765"></a>00765       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPBICG);       CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00766"></a>00766 
<a name="l00767"></a>00767     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a66f876695d8cb986b11fd03a6011da5c">TCQMR</a>:
<a name="l00768"></a>00768       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPTCQMR);      CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00769"></a>00769  
<a name="l00770"></a>00770     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a64344ae8d8320983e6f24873b0f59506">TFQMR</a>:
<a name="l00771"></a>00771       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPTFQMR);      CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00772"></a>00772 
<a name="l00773"></a>00773     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a4402b8ddf01d5b9a43a60c21b95738f6">LSQR</a>:
<a name="l00774"></a>00774       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPLSQR);       CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00775"></a>00775 
<a name="l00776"></a>00776     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19ae5a5e49337074324233c300b1daf83ec">BICGSTAB</a>:
<a name="l00777"></a>00777       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPBCGS);       CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00778"></a>00778 
<a name="l00779"></a>00779     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a1c732aa5750b891b366f966a0ad1b33a">MINRES</a>:
<a name="l00780"></a>00780       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPMINRES);     CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00781"></a>00781 
<a name="l00782"></a>00782     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a28c6a4ecccca1d0e6956e5e94fa82d97">GMRES</a>:
<a name="l00783"></a>00783       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPGMRES);      CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00784"></a>00784 
<a name="l00785"></a>00785     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19ac89e84330ee207620b12f16ed98cb31c">RICHARDSON</a>:
<a name="l00786"></a>00786       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPRICHARDSON); CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00787"></a>00787 
<a name="l00788"></a>00788     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a7c268c55b3f99132648b5c7245896764">CHEBYSHEV</a>: 
<a name="l00789"></a>00789       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPCHEBYCHEV);  CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00790"></a>00790 
<a name="l00791"></a>00791     <span class="keywordflow">default</span>:
<a name="l00792"></a>00792       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR:  Unsupported PETSC Solver: &quot;</span>
<a name="l00793"></a>00793                 &lt;&lt; this-&gt;_solver_type               &lt;&lt; std::endl
<a name="l00794"></a>00794                 &lt;&lt; <span class="stringliteral">&quot;Continuing with PETSC defaults&quot;</span> &lt;&lt; std::endl;
<a name="l00795"></a>00795     }
<a name="l00796"></a>00796 }
<a name="l00797"></a>00797 
<a name="l00798"></a>00798 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00799"></a><a class="code" href="classPetscLinearSolver.php#acf1013790d2464431f17e1a4825e62fa">00799</a> <span class="keywordtype">void</span> <a class="code" href="classPetscLinearSolver.php#acf1013790d2464431f17e1a4825e62fa">PetscLinearSolver&lt;T&gt;::print_converged_reason</a>()
<a name="l00800"></a>00800 {
<a name="l00801"></a>00801 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,1)</span>
<a name="l00802"></a>00802 <span class="preprocessor"></span>  std::cout &lt;&lt; <span class="stringliteral">&quot;This method is currently not supported &quot;</span>
<a name="l00803"></a>00803             &lt;&lt; <span class="stringliteral">&quot;(but may work!) for Petsc 2.3.0 and earlier.&quot;</span> &lt;&lt; std::endl;
<a name="l00804"></a>00804 <span class="preprocessor">#else</span>
<a name="l00805"></a>00805 <span class="preprocessor"></span>  KSPConvergedReason reason;
<a name="l00806"></a>00806   KSPGetConvergedReason(_ksp, &amp;reason);
<a name="l00807"></a>00807   
<a name="l00808"></a>00808   <span class="comment">//  KSP_CONVERGED_RTOL (residual 2-norm decreased by a factor of rtol, from 2-norm of right hand side)</span>
<a name="l00809"></a>00809   <span class="comment">//  KSP_CONVERGED_ATOL (residual 2-norm less than abstol)</span>
<a name="l00810"></a>00810   <span class="comment">//  KSP_CONVERGED_ITS (used by the preonly preconditioner that always uses ONE iteration) </span>
<a name="l00811"></a>00811   <span class="comment">//  KSP_CONVERGED_STEP_LENGTH</span>
<a name="l00812"></a>00812   <span class="comment">//  KSP_DIVERGED_ITS  (required more than its to reach convergence)</span>
<a name="l00813"></a>00813   <span class="comment">//  KSP_DIVERGED_DTOL (residual norm increased by a factor of divtol)</span>
<a name="l00814"></a>00814   <span class="comment">//  KSP_DIVERGED_NAN (residual norm became Not-a-number likely do to 0/0)</span>
<a name="l00815"></a>00815   <span class="comment">//  KSP_DIVERGED_BREAKDOWN (generic breakdown in method)</span>
<a name="l00816"></a>00816 
<a name="l00817"></a>00817   <span class="keywordflow">switch</span> (reason)
<a name="l00818"></a>00818     {
<a name="l00819"></a>00819     <span class="keywordflow">case</span> KSP_CONVERGED_RTOL:
<a name="l00820"></a>00820        {
<a name="l00821"></a>00821         std::cout &lt;&lt; <span class="stringliteral">&quot;Linear solver converged, relative tolerance reached.&quot;</span> &lt;&lt; std::endl;
<a name="l00822"></a>00822         <span class="keywordflow">break</span>;
<a name="l00823"></a>00823        }
<a name="l00824"></a>00824     <span class="keywordflow">case</span> KSP_CONVERGED_ATOL:
<a name="l00825"></a>00825        {
<a name="l00826"></a>00826          std::cout &lt;&lt; <span class="stringliteral">&quot;Linear solver converged, absolute tolerance reached.&quot;</span> &lt;&lt; std::endl;
<a name="l00827"></a>00827          <span class="keywordflow">break</span>;
<a name="l00828"></a>00828        }
<a name="l00829"></a>00829 
<a name="l00830"></a>00830       <span class="comment">// Divergence</span>
<a name="l00831"></a>00831     <span class="keywordflow">case</span> KSP_DIVERGED_ITS:
<a name="l00832"></a>00832        {
<a name="l00833"></a>00833          std::cout &lt;&lt; <span class="stringliteral">&quot;Linear solver diverged, max no. of iterations reached.&quot;</span> &lt;&lt; std::endl;
<a name="l00834"></a>00834          <span class="keywordflow">break</span>;
<a name="l00835"></a>00835        }
<a name="l00836"></a>00836     <span class="keywordflow">case</span> KSP_DIVERGED_DTOL:
<a name="l00837"></a>00837        {
<a name="l00838"></a>00838          std::cout &lt;&lt; <span class="stringliteral">&quot;Linear solver diverged, residual norm increase by dtol (default 1.e5).&quot;</span> &lt;&lt; std::endl;
<a name="l00839"></a>00839          <span class="keywordflow">break</span>;
<a name="l00840"></a>00840        }
<a name="l00841"></a>00841     <span class="keywordflow">case</span> KSP_DIVERGED_NAN:
<a name="l00842"></a>00842        {
<a name="l00843"></a>00843          std::cout &lt;&lt; <span class="stringliteral">&quot;Linear solver diverged, residual norm is NaN.&quot;</span> &lt;&lt; std::endl;
<a name="l00844"></a>00844          <span class="keywordflow">break</span>;
<a name="l00845"></a>00845        }
<a name="l00846"></a>00846     <span class="keywordflow">case</span> KSP_DIVERGED_BREAKDOWN:
<a name="l00847"></a>00847        {
<a name="l00848"></a>00848          std::cout &lt;&lt; <span class="stringliteral">&quot;Linear solver diverged, generic breakdown in the method.&quot;</span> &lt;&lt; std::endl;
<a name="l00849"></a>00849          <span class="keywordflow">break</span>;
<a name="l00850"></a>00850        }
<a name="l00851"></a>00851     <span class="keywordflow">default</span>:
<a name="l00852"></a>00852       {
<a name="l00853"></a>00853         std::cout &lt;&lt; <span class="stringliteral">&quot;Unknown/unsupported con(di)vergence reason: &quot;</span> &lt;&lt; reason &lt;&lt; std::endl;
<a name="l00854"></a>00854       }
<a name="l00855"></a>00855     }
<a name="l00856"></a>00856 <span class="preprocessor">#endif</span>
<a name="l00857"></a>00857 <span class="preprocessor"></span>}
<a name="l00858"></a>00858 
<a name="l00859"></a>00859 
<a name="l00860"></a>00860 
<a name="l00861"></a>00861 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00862"></a><a class="code" href="classPetscLinearSolver.php#a313bcde5f7d003fc4dad0f164283dba5">00862</a> <a class="code" href="petsc__linear__solver_8C.php#aefae79199a0dda59581d16f802913456">PetscErrorCode</a> <a class="code" href="classPetscLinearSolver.php#a313bcde5f7d003fc4dad0f164283dba5">PetscLinearSolver&lt;T&gt;::_petsc_shell_matrix_mult</a>(Mat mat, Vec arg, Vec dest)
<a name="l00863"></a>00863 {
<a name="l00864"></a>00864   <span class="comment">/* Get the matrix context.  */</span>
<a name="l00865"></a>00865   <span class="keywordtype">int</span> ierr=0;
<a name="l00866"></a>00866   <span class="keywordtype">void</span>* ctx;
<a name="l00867"></a>00867   ierr = MatShellGetContext(mat,&amp;ctx);
<a name="l00868"></a>00868   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00869"></a>00869 
<a name="l00870"></a>00870   <span class="comment">/* Get user shell matrix object.  */</span>
<a name="l00871"></a>00871   <span class="keyword">const</span> <a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix = *<span class="keyword">static_cast&lt;</span><span class="keyword">const </span><a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a>*<span class="keyword">&gt;</span>(ctx);
<a name="l00872"></a>00872 
<a name="l00873"></a>00873   <span class="comment">/* Make \p NumericVector instances around the vectors.  */</span>
<a name="l00874"></a>00874   <a class="code" href="classPetscVector.php">PetscVector&lt;T&gt;</a> arg_global(arg);
<a name="l00875"></a>00875   <a class="code" href="classPetscVector.php">PetscVector&lt;T&gt;</a> dest_global(dest);
<a name="l00876"></a>00876 
<a name="l00877"></a>00877   <span class="comment">/* Call the user function.  */</span>
<a name="l00878"></a>00878   shell_matrix.<a class="code" href="classShellMatrix.php#ad947169bcd199cd56f99b21e78cbb21a">vector_mult</a>(dest_global,arg_global);
<a name="l00879"></a>00879 
<a name="l00880"></a>00880   <span class="keywordflow">return</span> ierr;
<a name="l00881"></a>00881 }
<a name="l00882"></a>00882 
<a name="l00883"></a>00883 
<a name="l00884"></a>00884 
<a name="l00885"></a>00885 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00886"></a><a class="code" href="classPetscLinearSolver.php#a112674ca97b0213c2687b08e0266d4b0">00886</a> <a class="code" href="petsc__linear__solver_8C.php#aefae79199a0dda59581d16f802913456">PetscErrorCode</a> <a class="code" href="classPetscLinearSolver.php#a112674ca97b0213c2687b08e0266d4b0">PetscLinearSolver&lt;T&gt;::_petsc_shell_matrix_get_diagonal</a>(Mat mat, Vec dest)
<a name="l00887"></a>00887 {
<a name="l00888"></a>00888   <span class="comment">/* Get the matrix context.  */</span>
<a name="l00889"></a>00889   <span class="keywordtype">int</span> ierr=0;
<a name="l00890"></a>00890   <span class="keywordtype">void</span>* ctx;
<a name="l00891"></a>00891   ierr = MatShellGetContext(mat,&amp;ctx);
<a name="l00892"></a>00892   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00893"></a>00893 
<a name="l00894"></a>00894   <span class="comment">/* Get user shell matrix object.  */</span>
<a name="l00895"></a>00895   <span class="keyword">const</span> <a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix = *<span class="keyword">static_cast&lt;</span><span class="keyword">const </span><a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a>*<span class="keyword">&gt;</span>(ctx);
<a name="l00896"></a>00896 
<a name="l00897"></a>00897   <span class="comment">/* Make \p NumericVector instances around the vector.  */</span>
<a name="l00898"></a>00898   <a class="code" href="classPetscVector.php">PetscVector&lt;T&gt;</a> dest_global(dest);
<a name="l00899"></a>00899 
<a name="l00900"></a>00900   <span class="comment">/* Call the user function.  */</span>
<a name="l00901"></a>00901   shell_matrix.<a class="code" href="classShellMatrix.php#a30afa0fc718c1549044d05087a0a92db">get_diagonal</a>(dest_global);
<a name="l00902"></a>00902 
<a name="l00903"></a>00903   <span class="keywordflow">return</span> ierr;
<a name="l00904"></a>00904 }
<a name="l00905"></a>00905 
<a name="l00906"></a>00906 
<a name="l00907"></a>00907 
<a name="l00908"></a>00908 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00909"></a>00909 <span class="comment">// Explicit instantiations</span>
<a name="l00910"></a>00910 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classPetscLinearSolver.php">PetscLinearSolver&lt;Number&gt;</a>;
<a name="l00911"></a>00911  
<a name="l00912"></a>00912 
<a name="l00913"></a>00913 
<a name="l00914"></a>00914 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_PETSC</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
