<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>petsc_linear_solver.h</h1>  </div>
</div>
<div class="contents">
<a href="petsc__linear__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: petsc_linear_solver.h 3399 2009-06-12 21:44:20Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __petsc_linear_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __petsc_linear_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="comment">// C++ includes</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Local includes</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="linear__solver_8h.php">linear_solver.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="petsc__vector_8h.php">petsc_vector.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="petsc__matrix_8h.php">petsc_matrix.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="petsc__macro_8h.php">petsc_macro.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00041"></a>00041 EXTERN_C_FOR_PETSC_BEGIN
<a name="l00042"></a>00042 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,0)</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span><span class="preprocessor">#  include &lt;petscsles.h&gt;</span>
<a name="l00044"></a>00044 <span class="preprocessor">#else</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span><span class="preprocessor">#  include &lt;petscksp.h&gt;</span>
<a name="l00046"></a>00046 <span class="preprocessor">#endif</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span>EXTERN_C_FOR_PETSC_END
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00050"></a>00050 <span class="comment">// Functions with C linkage to pass to PETSc.  PETSc will call these</span>
<a name="l00051"></a>00051 <span class="comment">// methods as needed for preconditioning</span>
<a name="l00052"></a>00052 <span class="comment">// </span>
<a name="l00053"></a>00053 <span class="comment">// Since they must have C linkage they have no knowledge of a namespace.</span>
<a name="l00054"></a>00054 <span class="comment">// Give them an obscure name to avoid namespace pollution.</span>
<a name="l00055"></a>00055 <span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span>
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057   <span class="comment">// Older versions of PETSc do not have the different int typedefs.</span>
<a name="l00058"></a>00058   <span class="comment">// On 64-bit machines, PetscInt may actually be a long long int.</span>
<a name="l00059"></a>00059   <span class="comment">// This change occurred in Petsc-2.2.1.</span>
<a name="l00060"></a>00060 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,1)</span>
<a name="l00061"></a><a class="code" href="petsc__linear__solver_8h.php#a91cad2aac2280ad0d8a5796908f49a74">00061</a> <span class="preprocessor"></span>  <span class="keyword">typedef</span> <span class="keywordtype">int</span> <a class="code" href="petsc__linear__solver_8C.php#aefae79199a0dda59581d16f802913456">PetscErrorCode</a>;
<a name="l00062"></a><a class="code" href="petsc__linear__solver_8h.php#a515706180f960b30595b607f2d734d14">00062</a>   <span class="keyword">typedef</span> <span class="keywordtype">int</span> <a class="code" href="petsc__linear__solver_8C.php#a515706180f960b30595b607f2d734d14">PetscInt</a>;
<a name="l00063"></a>00063 <span class="preprocessor">#endif</span>
<a name="l00064"></a>00064 <span class="preprocessor"></span>
<a name="l00065"></a>00065 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(3,0,1) &amp;&amp; PETSC_VERSION_RELEASE</span>
<a name="l00066"></a>00066 <span class="preprocessor"></span>
<a name="l00070"></a>00070   PetscErrorCode <a class="code" href="petsc__linear__solver_8C.php#a4737870c4c15c93547318e44dea2e463">__libmesh_petsc_preconditioner_setup</a> (<span class="keywordtype">void</span> * ctx);
<a name="l00071"></a>00071 
<a name="l00076"></a>00076   PetscErrorCode <a class="code" href="petsc__linear__solver_8C.php#a13ac63a1ac4545e7ac3bac10a8bd8677">__libmesh_petsc_preconditioner_apply</a>(<span class="keywordtype">void</span> *ctx, Vec x, Vec y);
<a name="l00077"></a>00077 <span class="preprocessor">#else</span>
<a name="l00078"></a>00078 <span class="preprocessor"></span>  PetscErrorCode <a class="code" href="petsc__linear__solver_8C.php#a4737870c4c15c93547318e44dea2e463">__libmesh_petsc_preconditioner_setup</a> (PC);
<a name="l00079"></a>00079   PetscErrorCode <a class="code" href="petsc__linear__solver_8C.php#a13ac63a1ac4545e7ac3bac10a8bd8677">__libmesh_petsc_preconditioner_apply</a>(PC, Vec x, Vec y);
<a name="l00080"></a>00080 <span class="preprocessor">#endif</span>
<a name="l00081"></a>00081 <span class="preprocessor"></span>} <span class="comment">// end extern &quot;C&quot;</span>
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00092"></a>00092 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00093"></a><a class="code" href="classPetscLinearSolver.php">00093</a> <span class="keyword">class </span><a class="code" href="classPetscLinearSolver.php">PetscLinearSolver</a> : <span class="keyword">public</span> <a class="code" href="classLinearSolver.php">LinearSolver</a>&lt;T&gt;
<a name="l00094"></a>00094 {
<a name="l00095"></a>00095 <span class="keyword">public</span>:
<a name="l00099"></a>00099   <a class="code" href="classPetscLinearSolver.php#ab582953ce1113a6a993e89fc42bd3416">PetscLinearSolver</a> ();
<a name="l00100"></a>00100     
<a name="l00104"></a>00104   <a class="code" href="classPetscLinearSolver.php#ac0351605862bc4bd5809ba827488a983">~PetscLinearSolver</a> ();
<a name="l00105"></a>00105   
<a name="l00109"></a>00109   <span class="keywordtype">void</span> <a class="code" href="classPetscLinearSolver.php#a9df90716996e557a9e97d8d882876d98">clear</a> ();
<a name="l00110"></a>00110 
<a name="l00114"></a>00114   <span class="keywordtype">void</span> <a class="code" href="classPetscLinearSolver.php#aa2812b487efec89def8b23269b8afdfe">init</a> ();
<a name="l00115"></a>00115   
<a name="l00119"></a>00119   <span class="keywordtype">void</span> <a class="code" href="classPetscLinearSolver.php#aa2812b487efec89def8b23269b8afdfe">init</a> (<a class="code" href="classPetscMatrix.php">PetscMatrix&lt;T&gt;</a>* matrix);
<a name="l00124"></a>00124   std::pair&lt;unsigned int, Real&gt; 
<a name="l00125"></a><a class="code" href="classPetscLinearSolver.php#a84b2c641cf61d768f9c7a07e501b59c9">00125</a>   <a class="code" href="classPetscLinearSolver.php#a84b2c641cf61d768f9c7a07e501b59c9">solve</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>  &amp;matrix_in,
<a name="l00126"></a>00126          <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;solution_in,
<a name="l00127"></a>00127          <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;rhs_in,
<a name="l00128"></a>00128          <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00129"></a>00129          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its)
<a name="l00130"></a>00130   {
<a name="l00131"></a>00131     <span class="keywordflow">return</span> this-&gt;<a class="code" href="classPetscLinearSolver.php#a84b2c641cf61d768f9c7a07e501b59c9">solve</a>(matrix_in, matrix_in, solution_in, rhs_in, tol, m_its);
<a name="l00132"></a>00132   }
<a name="l00133"></a>00133 
<a name="l00149"></a>00149   std::pair&lt;unsigned int, Real&gt; 
<a name="l00150"></a>00150   <a class="code" href="classPetscLinearSolver.php#a84b2c641cf61d768f9c7a07e501b59c9">solve</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>  &amp;matrix,
<a name="l00151"></a>00151          <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>  &amp;preconditioner,
<a name="l00152"></a>00152          <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;solution,
<a name="l00153"></a>00153          <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;rhs,
<a name="l00154"></a>00154          <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00155"></a>00155          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00156"></a>00156 
<a name="l00160"></a>00160   std::pair&lt;unsigned int, Real&gt;
<a name="l00161"></a>00161     <a class="code" href="classPetscLinearSolver.php#a84b2c641cf61d768f9c7a07e501b59c9">solve</a> (<span class="keyword">const</span> <a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix,
<a name="l00162"></a>00162            <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; solution_in,
<a name="l00163"></a>00163            <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; rhs_in,
<a name="l00164"></a>00164            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00165"></a>00165            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00166"></a>00166   
<a name="l00172"></a>00172   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt;
<a name="l00173"></a>00173     <a class="code" href="classPetscLinearSolver.php#a84b2c641cf61d768f9c7a07e501b59c9">solve</a> (<span class="keyword">const</span> <a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix,
<a name="l00174"></a>00174            <span class="keyword">const</span> <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; precond_matrix,
<a name="l00175"></a>00175            <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; solution_in,
<a name="l00176"></a>00176            <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; rhs_in,
<a name="l00177"></a>00177            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00178"></a>00178            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00179"></a>00179   
<a name="l00185"></a><a class="code" href="classPetscLinearSolver.php#a1fc210cc9e1fb036d9269296ef5e592c">00185</a>   PC <a class="code" href="classPetscLinearSolver.php#a1fc210cc9e1fb036d9269296ef5e592c">pc</a>() { this-&gt;<a class="code" href="classPetscLinearSolver.php#aa2812b487efec89def8b23269b8afdfe">init</a>(); <span class="keywordflow">return</span> <a class="code" href="classPetscLinearSolver.php#a2c4d279918e7e7b27244e723eb6a8a3a">_pc</a>; }
<a name="l00186"></a>00186 
<a name="l00192"></a><a class="code" href="classPetscLinearSolver.php#a75e0dab9e2869a19bc384c972ed862cd">00192</a>   KSP <a class="code" href="classPetscLinearSolver.php#a75e0dab9e2869a19bc384c972ed862cd">ksp</a>() { this-&gt;<a class="code" href="classPetscLinearSolver.php#aa2812b487efec89def8b23269b8afdfe">init</a>(); <span class="keywordflow">return</span> <a class="code" href="classPetscLinearSolver.php#a96e24f13ef33a43e4a11e4180c4d06a3">_ksp</a>; }
<a name="l00193"></a>00193   
<a name="l00198"></a>00198   <span class="keywordtype">void</span> <a class="code" href="classPetscLinearSolver.php#a17fc234788a7ba293512cc71b2716348">get_residual_history</a>(std::vector&lt;double&gt;&amp; hist);
<a name="l00199"></a>00199 
<a name="l00206"></a>00206   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classPetscLinearSolver.php#a70f0c4b77d30657eb17462689074e69b">get_initial_residual</a>();
<a name="l00207"></a>00207 
<a name="l00212"></a>00212   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPetscLinearSolver.php#acf1013790d2464431f17e1a4825e62fa">print_converged_reason</a>();
<a name="l00213"></a>00213   
<a name="l00214"></a>00214 <span class="keyword">private</span>:
<a name="l00215"></a>00215 
<a name="l00220"></a>00220   <span class="keywordtype">void</span> <a class="code" href="classPetscLinearSolver.php#a5f707d6969fa458a0476086ec954a060">set_petsc_solver_type</a> ();
<a name="l00221"></a>00221 
<a name="l00225"></a>00225   <span class="keyword">static</span> <a class="code" href="petsc__linear__solver_8C.php#aefae79199a0dda59581d16f802913456">PetscErrorCode</a> <a class="code" href="classPetscLinearSolver.php#a313bcde5f7d003fc4dad0f164283dba5">_petsc_shell_matrix_mult</a>(Mat mat, Vec arg, Vec dest);
<a name="l00226"></a>00226 
<a name="l00230"></a>00230   <span class="keyword">static</span> <a class="code" href="petsc__linear__solver_8C.php#aefae79199a0dda59581d16f802913456">PetscErrorCode</a> <a class="code" href="classPetscLinearSolver.php#a112674ca97b0213c2687b08e0266d4b0">_petsc_shell_matrix_get_diagonal</a>(Mat mat, Vec dest);
<a name="l00231"></a>00231 
<a name="l00232"></a>00232   <span class="comment">// SLES removed from &gt;= PETSc 2.2.0</span>
<a name="l00233"></a>00233 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,0)</span>
<a name="l00234"></a>00234 <span class="preprocessor"></span>  
<a name="l00238"></a><a class="code" href="classPetscLinearSolver.php#a634225eec001f694fe3ceca32b34df46">00238</a>   SLES <a class="code" href="classPetscLinearSolver.php#a634225eec001f694fe3ceca32b34df46">_sles</a>;
<a name="l00239"></a>00239 
<a name="l00240"></a>00240 <span class="preprocessor">#endif</span>
<a name="l00241"></a>00241 <span class="preprocessor"></span>  
<a name="l00245"></a><a class="code" href="classPetscLinearSolver.php#a2c4d279918e7e7b27244e723eb6a8a3a">00245</a>   PC <a class="code" href="classPetscLinearSolver.php#a2c4d279918e7e7b27244e723eb6a8a3a">_pc</a>; 
<a name="l00246"></a>00246 
<a name="l00250"></a><a class="code" href="classPetscLinearSolver.php#a96e24f13ef33a43e4a11e4180c4d06a3">00250</a>   KSP <a class="code" href="classPetscLinearSolver.php#a96e24f13ef33a43e4a11e4180c4d06a3">_ksp</a>;
<a name="l00251"></a>00251 };
<a name="l00252"></a>00252 
<a name="l00253"></a>00253 
<a name="l00254"></a>00254 <span class="comment">/*----------------------- functions ----------------------------------*/</span>
<a name="l00255"></a>00255 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00256"></a>00256 <span class="keyword">inline</span>
<a name="l00257"></a><a class="code" href="classPetscLinearSolver.php#ab582953ce1113a6a993e89fc42bd3416">00257</a> <a class="code" href="classPetscLinearSolver.php#ab582953ce1113a6a993e89fc42bd3416">PetscLinearSolver&lt;T&gt;::PetscLinearSolver</a> ()
<a name="l00258"></a>00258 {
<a name="l00259"></a>00259   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l00260"></a>00260     this-&gt;_preconditioner_type = <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4af54549e0e69fbdd4ddd199ee316527f3">ILU_PRECOND</a>;
<a name="l00261"></a>00261   <span class="keywordflow">else</span>
<a name="l00262"></a>00262     this-&gt;_preconditioner_type = <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a8f036d61e96c69b14d585f04235613d2">BLOCK_JACOBI_PRECOND</a>;
<a name="l00263"></a>00263 }
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 
<a name="l00266"></a>00266 
<a name="l00267"></a>00267 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00268"></a>00268 <span class="keyword">inline</span>
<a name="l00269"></a><a class="code" href="classPetscLinearSolver.php#ac0351605862bc4bd5809ba827488a983">00269</a> <a class="code" href="classPetscLinearSolver.php#ac0351605862bc4bd5809ba827488a983">PetscLinearSolver&lt;T&gt;::~PetscLinearSolver</a> ()
<a name="l00270"></a>00270 {
<a name="l00271"></a>00271   this-&gt;clear ();
<a name="l00272"></a>00272 }
<a name="l00273"></a>00273 
<a name="l00274"></a>00274 
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00277"></a>00277 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __petsc_linear_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
