<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_f10759d5ac6297fe611079c3c15b8f2c.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>petsc_matrix.C</h1>  </div>
</div>
<div class="contents">
<a href="petsc__matrix_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: petsc_matrix.C 3476 2009-09-28 18:53:28Z knezed01 $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;petsc_matrix.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;dof_map.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;dense_matrix.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;petsc_vector.h&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00035"></a>00035 <span class="comment">// PetscMatrix members</span>
<a name="l00036"></a>00036 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00037"></a><a class="code" href="classPetscMatrix.php#af6ed0dc17cd4bcf20c3963c7124c205d">00037</a> <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#a3d7d48860e626fe1ed8b1b16f3f9532f">PetscMatrix&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m,
<a name="l00038"></a>00038                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00039"></a>00039                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_l,
<a name="l00040"></a>00040                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_l,
<a name="l00041"></a>00041                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nnz,
<a name="l00042"></a>00042                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> noz)
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044   <span class="comment">// We allow 0x0 matrices now</span>
<a name="l00045"></a>00045   <span class="comment">//if ((m==0) || (n==0))</span>
<a name="l00046"></a>00046   <span class="comment">//  return;</span>
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   <span class="comment">// Clear initialized matrices</span>
<a name="l00049"></a>00049   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00050"></a>00050     this-&gt;clear();
<a name="l00051"></a>00051 
<a name="l00052"></a>00052   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00053"></a>00053 
<a name="l00054"></a>00054   
<a name="l00055"></a>00055   <span class="keywordtype">int</span> ierr     = 0;
<a name="l00056"></a>00056   <span class="keywordtype">int</span> m_global = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(m);
<a name="l00057"></a>00057   <span class="keywordtype">int</span> n_global = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n);
<a name="l00058"></a>00058   <span class="keywordtype">int</span> m_local  = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(m_l);
<a name="l00059"></a>00059   <span class="keywordtype">int</span> n_local  = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n_l);
<a name="l00060"></a>00060   <span class="keywordtype">int</span> n_nz     = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(nnz);
<a name="l00061"></a>00061   <span class="keywordtype">int</span> n_oz     = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(noz);
<a name="l00062"></a>00062   
<a name="l00063"></a>00063   <span class="comment">// create a sequential matrix on one processor</span>
<a name="l00064"></a>00064   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l00065"></a>00065     {
<a name="l00066"></a>00066       libmesh_assert ((m_l == m) &amp;&amp; (n_l == n));
<a name="l00067"></a>00067 
<a name="l00068"></a>00068       <span class="comment">// Create matrix.  Revisit later to do preallocation and make more efficient</span>
<a name="l00069"></a>00069       ierr = MatCreateSeqAIJ (<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>, n_global, n_global,
<a name="l00070"></a>00070                               n_nz, PETSC_NULL, &amp;_mat);
<a name="l00071"></a>00071              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00072"></a>00072   
<a name="l00073"></a>00073       ierr = MatSetFromOptions (_mat);
<a name="l00074"></a>00074              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00075"></a>00075     }
<a name="l00076"></a>00076 
<a name="l00077"></a>00077   <span class="keywordflow">else</span>
<a name="l00078"></a>00078     {
<a name="l00079"></a>00079       parallel_only();
<a name="l00080"></a>00080 
<a name="l00081"></a>00081       ierr = MatCreateMPIAIJ (<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>, m_local, n_local, m_global, n_global,
<a name="l00082"></a>00082                               n_nz, PETSC_NULL, n_oz, PETSC_NULL, &amp;_mat);
<a name="l00083"></a>00083              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00084"></a>00084   
<a name="l00085"></a>00085       ierr = MatSetFromOptions (_mat);
<a name="l00086"></a>00086              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00087"></a>00087     }
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   this-&gt;<a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a> ();
<a name="l00090"></a>00090 }
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00096"></a><a class="code" href="classPetscMatrix.php#a3d7d48860e626fe1ed8b1b16f3f9532f">00096</a> <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#a3d7d48860e626fe1ed8b1b16f3f9532f">PetscMatrix&lt;T&gt;::init</a> ()
<a name="l00097"></a>00097 {
<a name="l00098"></a>00098   libmesh_assert (this-&gt;_dof_map != NULL);
<a name="l00099"></a>00099   
<a name="l00100"></a>00100   <span class="comment">// Clear initialized matrices</span>
<a name="l00101"></a>00101   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00102"></a>00102     this-&gt;clear();
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00105"></a>00105 
<a name="l00106"></a>00106   
<a name="l00107"></a>00107   <span class="keywordtype">int</span> proc_id = 0;
<a name="l00108"></a>00108 
<a name="l00109"></a>00109   MPI_Comm_rank (<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>, &amp;proc_id);
<a name="l00110"></a>00110   
<a name="l00111"></a>00111   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m   = this-&gt;_dof_map-&gt;n_dofs();
<a name="l00112"></a>00112   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n   = m;
<a name="l00113"></a>00113   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_l = this-&gt;_dof_map-&gt;n_dofs_on_processor(proc_id); 
<a name="l00114"></a>00114   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_l = n_l;
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; n_nz = this-&gt;_dof_map-&gt;get_n_nz();
<a name="l00118"></a>00118   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; n_oz = this-&gt;_dof_map-&gt;get_n_oz();
<a name="l00119"></a>00119 
<a name="l00120"></a>00120   <span class="comment">// Make sure the sparsity pattern isn&#39;t empty unless the matrix is 0x0</span>
<a name="l00121"></a>00121   libmesh_assert (n_nz.size() == n_l);
<a name="l00122"></a>00122   libmesh_assert (n_oz.size() == n_l);
<a name="l00123"></a>00123   
<a name="l00124"></a>00124   <span class="comment">// We allow 0x0 matrices now</span>
<a name="l00125"></a>00125   <span class="comment">//if (m==0)</span>
<a name="l00126"></a>00126   <span class="comment">//  return;</span>
<a name="l00127"></a>00127   
<a name="l00128"></a>00128   <span class="keywordtype">int</span> ierr     = 0;
<a name="l00129"></a>00129   <span class="keywordtype">int</span> m_global = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(m);
<a name="l00130"></a>00130   <span class="keywordtype">int</span> n_global = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n);
<a name="l00131"></a>00131   <span class="keywordtype">int</span> m_local  = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(m_l);
<a name="l00132"></a>00132   <span class="keywordtype">int</span> n_local  = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n_l);
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   <span class="comment">// create a sequential matrix on one processor</span>
<a name="l00136"></a>00136   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l00137"></a>00137     {
<a name="l00138"></a>00138       libmesh_assert ((m_l == m) &amp;&amp; (n_l == n));
<a name="l00139"></a>00139       <span class="keywordflow">if</span> (n_nz.empty())
<a name="l00140"></a>00140         ierr = MatCreateSeqAIJ (<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>, n_global, n_global,
<a name="l00141"></a>00141                                 PETSC_NULL, (<span class="keywordtype">int</span>*) PETSC_NULL, &amp;_mat);
<a name="l00142"></a>00142       <span class="keywordflow">else</span>
<a name="l00143"></a>00143         ierr = MatCreateSeqAIJ (<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>, n_global, n_global,
<a name="l00144"></a>00144                                 PETSC_NULL, (<span class="keywordtype">int</span>*) &amp;n_nz[0], &amp;_mat);
<a name="l00145"></a>00145              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00146"></a>00146   
<a name="l00147"></a>00147       ierr = MatSetFromOptions (_mat);
<a name="l00148"></a>00148              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00149"></a>00149     }
<a name="l00150"></a>00150 
<a name="l00151"></a>00151   <span class="keywordflow">else</span>
<a name="l00152"></a>00152     {
<a name="l00153"></a>00153       parallel_only();
<a name="l00154"></a>00154 
<a name="l00155"></a>00155       <span class="keywordflow">if</span> (n_nz.empty())
<a name="l00156"></a>00156         ierr = MatCreateMPIAIJ (<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,
<a name="l00157"></a>00157                                 m_local, n_local,
<a name="l00158"></a>00158                                 m_global, n_global,
<a name="l00159"></a>00159                                 PETSC_NULL, (<span class="keywordtype">int</span>*) PETSC_NULL,
<a name="l00160"></a>00160                                 PETSC_NULL, (<span class="keywordtype">int</span>*) PETSC_NULL, &amp;_mat);
<a name="l00161"></a>00161       <span class="keywordflow">else</span>
<a name="l00162"></a>00162         ierr = MatCreateMPIAIJ (<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,
<a name="l00163"></a>00163                                 m_local, n_local,
<a name="l00164"></a>00164                                 m_global, n_global,
<a name="l00165"></a>00165                                 PETSC_NULL, (<span class="keywordtype">int</span>*) &amp;n_nz[0],
<a name="l00166"></a>00166                                 PETSC_NULL, (<span class="keywordtype">int</span>*) &amp;n_oz[0], &amp;_mat);
<a name="l00167"></a>00167              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00168"></a>00168   
<a name="l00169"></a>00169       ierr = MatSetFromOptions (_mat);
<a name="l00170"></a>00170              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00171"></a>00171     }
<a name="l00172"></a>00172 
<a name="l00173"></a>00173   this-&gt;<a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a>();
<a name="l00174"></a>00174 }
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00179"></a><a class="code" href="classPetscMatrix.php#ac3d7ce98a1ea87f804cf80091bdfc86e">00179</a> <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#ac3d7ce98a1ea87f804cf80091bdfc86e">PetscMatrix&lt;T&gt;::zero</a> ()
<a name="l00180"></a>00180 {
<a name="l00181"></a>00181   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   semiparallel_only();
<a name="l00184"></a>00184   
<a name="l00185"></a>00185   <span class="keywordtype">int</span> ierr=0;
<a name="l00186"></a>00186 
<a name="l00187"></a>00187   ierr = MatZeroEntries(_mat);
<a name="l00188"></a>00188          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00189"></a>00189 }
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00192"></a><a class="code" href="classPetscMatrix.php#acc7465ea83190aad48140c8efdd34eb8">00192</a> <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#acc7465ea83190aad48140c8efdd34eb8">PetscMatrix&lt;T&gt;::zero_rows</a> (std::vector&lt;int&gt; &amp; rows, T diag_value)
<a name="l00193"></a>00193 {
<a name="l00194"></a>00194   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00195"></a>00195 
<a name="l00196"></a>00196   semiparallel_only();
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   <span class="keywordtype">int</span> ierr=0;
<a name="l00199"></a>00199 
<a name="l00200"></a>00200   <span class="keywordflow">if</span>(!rows.empty())
<a name="l00201"></a>00201     ierr = MatZeroRows(_mat, rows.size(), &amp;rows[0], diag_value);
<a name="l00202"></a>00202   <span class="keywordflow">else</span>
<a name="l00203"></a>00203     ierr = MatZeroRows(_mat, 0, PETSC_NULL, diag_value);
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00206"></a>00206 }
<a name="l00207"></a>00207 
<a name="l00208"></a>00208 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00209"></a><a class="code" href="classPetscMatrix.php#a04875fe9a435eb60573e74d1065faf3a">00209</a> <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#a04875fe9a435eb60573e74d1065faf3a">PetscMatrix&lt;T&gt;::clear</a> ()
<a name="l00210"></a>00210 {
<a name="l00211"></a>00211   <span class="keywordtype">int</span> ierr=0;
<a name="l00212"></a>00212   
<a name="l00213"></a>00213   <span class="keywordflow">if</span> ((this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>()) &amp;&amp; (this-&gt;_destroy_mat_on_exit))
<a name="l00214"></a>00214     {
<a name="l00215"></a>00215       semiparallel_only();
<a name="l00216"></a>00216   
<a name="l00217"></a>00217       ierr = MatDestroy (_mat);
<a name="l00218"></a>00218              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00219"></a>00219       
<a name="l00220"></a>00220       this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00221"></a>00221     }
<a name="l00222"></a>00222 }
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 
<a name="l00226"></a>00226 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00227"></a><a class="code" href="classPetscMatrix.php#a3d76f9d09c8b2cf3f82ef2b01190a3f2">00227</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classPetscMatrix.php#a3d76f9d09c8b2cf3f82ef2b01190a3f2">PetscMatrix&lt;T&gt;::l1_norm</a> ()<span class="keyword"> const</span>
<a name="l00228"></a>00228 <span class="keyword"></span>{
<a name="l00229"></a>00229   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00230"></a>00230   
<a name="l00231"></a>00231   semiparallel_only();
<a name="l00232"></a>00232 
<a name="l00233"></a>00233   <span class="keywordtype">int</span> ierr=0;
<a name="l00234"></a>00234   PetscReal petsc_value;
<a name="l00235"></a>00235   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> value;
<a name="l00236"></a>00236   
<a name="l00237"></a>00237   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00238"></a>00238 
<a name="l00239"></a>00239   ierr = MatNorm(_mat, NORM_1, &amp;petsc_value);
<a name="l00240"></a>00240          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00241"></a>00241 
<a name="l00242"></a>00242   value = <span class="keyword">static_cast&lt;</span><a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a><span class="keyword">&gt;</span>(petsc_value);
<a name="l00243"></a>00243 
<a name="l00244"></a>00244   <span class="keywordflow">return</span> value;
<a name="l00245"></a>00245 }
<a name="l00246"></a>00246 
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00250"></a><a class="code" href="classPetscMatrix.php#a63402472f723d1c89ffe498ae7b72d18">00250</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classPetscMatrix.php#a63402472f723d1c89ffe498ae7b72d18">PetscMatrix&lt;T&gt;::linfty_norm</a> ()<span class="keyword"> const</span>
<a name="l00251"></a>00251 <span class="keyword"></span>{
<a name="l00252"></a>00252   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00253"></a>00253   
<a name="l00254"></a>00254   semiparallel_only();
<a name="l00255"></a>00255 
<a name="l00256"></a>00256   <span class="keywordtype">int</span> ierr=0;
<a name="l00257"></a>00257   PetscReal petsc_value;
<a name="l00258"></a>00258   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> value;
<a name="l00259"></a>00259   
<a name="l00260"></a>00260   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00261"></a>00261 
<a name="l00262"></a>00262   ierr = MatNorm(_mat, NORM_INFINITY, &amp;petsc_value);
<a name="l00263"></a>00263          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00264"></a>00264 
<a name="l00265"></a>00265   value = <span class="keyword">static_cast&lt;</span><a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a><span class="keyword">&gt;</span>(petsc_value);
<a name="l00266"></a>00266 
<a name="l00267"></a>00267   <span class="keywordflow">return</span> value;
<a name="l00268"></a>00268 }
<a name="l00269"></a>00269 
<a name="l00270"></a>00270 
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00273"></a><a class="code" href="classPetscMatrix.php#a2da4c371bfd1bf997084f0493f16a0fc">00273</a> <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#a2da4c371bfd1bf997084f0493f16a0fc">PetscMatrix&lt;T&gt;::print_matlab</a> (<span class="keyword">const</span> std::string <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)<span class="keyword"> const</span>
<a name="l00274"></a>00274 <span class="keyword"></span>{
<a name="l00275"></a>00275   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00276"></a>00276 
<a name="l00277"></a>00277   semiparallel_only();
<a name="l00278"></a>00278 
<a name="l00279"></a>00279   <span class="comment">// libmesh_assert (this-&gt;closed());</span>
<a name="l00280"></a>00280   this-&gt;<a class="code" href="namespacelibMesh.php#a6e41d4c43a417f7b9e20302af9736247">close</a>();
<a name="l00281"></a>00281   
<a name="l00282"></a>00282   <span class="keywordtype">int</span> ierr=0; 
<a name="l00283"></a>00283   PetscViewer petsc_viewer;
<a name="l00284"></a>00284 
<a name="l00285"></a>00285 
<a name="l00286"></a>00286   ierr = PetscViewerCreate (<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,
<a name="l00287"></a>00287                             &amp;petsc_viewer);
<a name="l00288"></a>00288          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00289"></a>00289 
<a name="l00294"></a>00294   <span class="keywordflow">if</span> (name != <span class="stringliteral">&quot;NULL&quot;</span>)
<a name="l00295"></a>00295     {
<a name="l00296"></a>00296       ierr = PetscViewerASCIIOpen( <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,
<a name="l00297"></a>00297                                    name.c_str(),
<a name="l00298"></a>00298                                    &amp;petsc_viewer);
<a name="l00299"></a>00299              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00300"></a>00300       
<a name="l00301"></a>00301       ierr = PetscViewerSetFormat (petsc_viewer,
<a name="l00302"></a>00302                                    PETSC_VIEWER_ASCII_MATLAB);
<a name="l00303"></a>00303              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00304"></a>00304   
<a name="l00305"></a>00305       ierr = MatView (_mat, petsc_viewer);
<a name="l00306"></a>00306              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00307"></a>00307     }
<a name="l00308"></a>00308 
<a name="l00312"></a>00312   <span class="keywordflow">else</span>
<a name="l00313"></a>00313     {
<a name="l00314"></a>00314       ierr = PetscViewerSetFormat (PETSC_VIEWER_STDOUT_WORLD,
<a name="l00315"></a>00315                                    PETSC_VIEWER_ASCII_MATLAB);
<a name="l00316"></a>00316              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00317"></a>00317   
<a name="l00318"></a>00318       ierr = MatView (_mat, PETSC_VIEWER_STDOUT_WORLD);
<a name="l00319"></a>00319              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00320"></a>00320     }
<a name="l00321"></a>00321 
<a name="l00322"></a>00322 
<a name="l00326"></a>00326   ierr = PetscViewerDestroy (petsc_viewer);
<a name="l00327"></a>00327          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00328"></a>00328 }
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 
<a name="l00332"></a>00332 
<a name="l00333"></a>00333 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00334"></a><a class="code" href="classPetscMatrix.php#adb89e5ae254de3d326d02f7456b69f66">00334</a> <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#adb89e5ae254de3d326d02f7456b69f66">PetscMatrix&lt;T&gt;::add_matrix</a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dm,
<a name="l00335"></a>00335                                 <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; rows,
<a name="l00336"></a>00336                                 <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; cols)
<a name="l00337"></a>00337 {
<a name="l00338"></a>00338   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00339"></a>00339   
<a name="l00340"></a>00340   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m = dm.<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>();
<a name="l00341"></a>00341   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = dm.<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>();
<a name="l00342"></a>00342 
<a name="l00343"></a>00343   libmesh_assert (rows.size() == m);
<a name="l00344"></a>00344   libmesh_assert (cols.size() == n);
<a name="l00345"></a>00345   
<a name="l00346"></a>00346   <span class="keywordtype">int</span> ierr=0;
<a name="l00347"></a>00347 
<a name="l00348"></a>00348   <span class="comment">// These casts are required for PETSc &lt;= 2.1.5</span>
<a name="l00349"></a>00349   ierr = MatSetValues(_mat,
<a name="l00350"></a>00350                       m, (<span class="keywordtype">int</span>*) &amp;rows[0],
<a name="l00351"></a>00351                       n, (<span class="keywordtype">int</span>*) &amp;cols[0],
<a name="l00352"></a>00352                       (PetscScalar*) &amp;dm.<a class="code" href="classDenseMatrix.php#a528bde8c704176e220f23b79acdb11ec">get_values</a>()[0],
<a name="l00353"></a>00353                       ADD_VALUES);
<a name="l00354"></a>00354          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00355"></a>00355 }
<a name="l00356"></a>00356 
<a name="l00357"></a>00357 
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 
<a name="l00361"></a>00361 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00362"></a><a class="code" href="classPetscMatrix.php#a7d182aa5fbf7fbd9dd5e707b02d69b19">00362</a> <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#a7d182aa5fbf7fbd9dd5e707b02d69b19">PetscMatrix&lt;T&gt;::_get_submatrix</a>(<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; submatrix,
<a name="l00363"></a>00363                                     <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;rows,
<a name="l00364"></a>00364                                     <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;cols,
<a name="l00365"></a>00365                                     <span class="keyword">const</span> <span class="keywordtype">bool</span> reuse_submatrix)<span class="keyword"> const</span>
<a name="l00366"></a>00366 <span class="keyword"></span>{
<a name="l00367"></a>00367   <span class="comment">// Can only extract submatrices from closed matrices</span>
<a name="l00368"></a>00368   this-&gt;<a class="code" href="namespacelibMesh.php#a6e41d4c43a417f7b9e20302af9736247">close</a>();
<a name="l00369"></a>00369 
<a name="l00370"></a>00370   <span class="comment">// Make sure the SparseMatrix passed in is really a PetscMatrix</span>
<a name="l00371"></a>00371   <a class="code" href="classPetscMatrix.php">PetscMatrix&lt;T&gt;</a>* petsc_submatrix = libmesh_cast_ptr&lt;PetscMatrix&lt;T&gt;*&gt;(&amp;submatrix);
<a name="l00372"></a>00372 
<a name="l00373"></a>00373   <span class="comment">// If we&#39;re not reusing submatrix and submatrix is already initialized</span>
<a name="l00374"></a>00374   <span class="comment">// then we need to clear it, otherwise we get a memory leak.</span>
<a name="l00375"></a>00375   <span class="keywordflow">if</span>( !reuse_submatrix &amp;&amp; submatrix.<a class="code" href="classSparseMatrix.php#a5859dbbdc5266472541839b5dc4b0768">initialized</a>() )
<a name="l00376"></a>00376     submatrix.<a class="code" href="classSparseMatrix.php#a4dc6672a641212eeb422d100d3a542fc">clear</a>();
<a name="l00377"></a>00377   
<a name="l00378"></a>00378   <span class="comment">// Construct row and column index sets.</span>
<a name="l00379"></a>00379   <span class="keywordtype">int</span> ierr=0;
<a name="l00380"></a>00380   IS isrow, iscol;
<a name="l00381"></a>00381 
<a name="l00382"></a>00382   ierr = ISCreateGeneral(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,
<a name="l00383"></a>00383                          rows.size(),
<a name="l00384"></a>00384                          (<span class="keywordtype">int</span>*) &amp;rows[0],
<a name="l00385"></a>00385                          &amp;isrow); CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00386"></a>00386 
<a name="l00387"></a>00387   ierr = ISCreateGeneral(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,
<a name="l00388"></a>00388                          cols.size(),
<a name="l00389"></a>00389                          (<span class="keywordtype">int</span>*) &amp;cols[0],
<a name="l00390"></a>00390                          &amp;iscol); CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00391"></a>00391 
<a name="l00392"></a>00392   <span class="comment">// Extract submatrix</span>
<a name="l00393"></a>00393 <span class="preprocessor">#if !PETSC_VERSION_LESS_THAN(3,0,1) || !PETSC_VERSION_RELEASE</span>
<a name="l00394"></a>00394 <span class="preprocessor"></span>  ierr = MatGetSubMatrix(_mat,
<a name="l00395"></a>00395                          isrow,
<a name="l00396"></a>00396                          iscol,
<a name="l00397"></a>00397                          (reuse_submatrix ? MAT_REUSE_MATRIX : MAT_INITIAL_MATRIX),
<a name="l00398"></a>00398                          &amp;(petsc_submatrix-&gt;<a class="code" href="classPetscMatrix.php#acb8f4ad91b1f8de1504dfd15fadde192">_mat</a>));  CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00399"></a>00399 <span class="preprocessor">#else</span>
<a name="l00400"></a>00400 <span class="preprocessor"></span>  ierr = MatGetSubMatrix(_mat,
<a name="l00401"></a>00401                          isrow,
<a name="l00402"></a>00402                          iscol,
<a name="l00403"></a>00403                          PETSC_DECIDE,
<a name="l00404"></a>00404                          (reuse_submatrix ? MAT_REUSE_MATRIX : MAT_INITIAL_MATRIX),
<a name="l00405"></a>00405                          &amp;(petsc_submatrix-&gt;<a class="code" href="classPetscMatrix.php#acb8f4ad91b1f8de1504dfd15fadde192">_mat</a>));  CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00406"></a>00406 <span class="preprocessor">#endif</span>
<a name="l00407"></a>00407 <span class="preprocessor"></span>
<a name="l00408"></a>00408   <span class="comment">// Specify that the new submatrix is initialized and close it.</span>
<a name="l00409"></a>00409   petsc_submatrix-&gt;<a class="code" href="classSparseMatrix.php#a1dd24ca76da426c3c657545d37cb8187">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00410"></a>00410   petsc_submatrix-&gt;<a class="code" href="classPetscMatrix.php#a431196369d051b83ea1e3d595ec2dc0d">close</a>();
<a name="l00411"></a>00411 
<a name="l00412"></a>00412   <span class="comment">// Clean up PETSc data structures</span>
<a name="l00413"></a>00413   ierr = ISDestroy(isrow); CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00414"></a>00414   ierr = ISDestroy(iscol); CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00415"></a>00415 }
<a name="l00416"></a>00416 
<a name="l00417"></a>00417 
<a name="l00418"></a>00418 
<a name="l00419"></a>00419 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00420"></a><a class="code" href="classPetscMatrix.php#a31339d95832b7d07d391a73e32e20d2d">00420</a> <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#a31339d95832b7d07d391a73e32e20d2d">PetscMatrix&lt;T&gt;::get_diagonal</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest)<span class="keyword"> const</span>
<a name="l00421"></a>00421 <span class="keyword"></span>{
<a name="l00422"></a>00422   <span class="comment">// Make sure the NumericVector passed in is really a PetscVector</span>
<a name="l00423"></a>00423   <a class="code" href="classPetscVector.php">PetscVector&lt;T&gt;</a>&amp; petsc_dest = libmesh_cast_ref&lt;PetscVector&lt;T&gt;&amp;&gt;(dest);
<a name="l00424"></a>00424 
<a name="l00425"></a>00425   <span class="comment">// Call PETSc function.</span>
<a name="l00426"></a>00426 
<a name="l00427"></a>00427 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,1)</span>
<a name="l00428"></a>00428 <span class="preprocessor"></span>
<a name="l00429"></a>00429   std::cout &lt;&lt; <span class="stringliteral">&quot;This method has been developed with PETSc 2.3.1.  &quot;</span>
<a name="l00430"></a>00430             &lt;&lt; <span class="stringliteral">&quot;No one has made it backwards compatible with older &quot;</span>
<a name="l00431"></a>00431             &lt;&lt; <span class="stringliteral">&quot;versions of PETSc so far; however, it might work &quot;</span>
<a name="l00432"></a>00432             &lt;&lt; <span class="stringliteral">&quot;without any change with some older version.&quot;</span> &lt;&lt; std::endl;
<a name="l00433"></a>00433   libmesh_error();
<a name="l00434"></a>00434 
<a name="l00435"></a>00435 <span class="preprocessor">#else</span>
<a name="l00436"></a>00436 <span class="preprocessor"></span>
<a name="l00437"></a>00437   <span class="comment">// Needs a const_cast since PETSc does not work with const.</span>
<a name="l00438"></a>00438   <span class="keywordtype">int</span> ierr =
<a name="l00439"></a>00439     MatGetDiagonal(<span class="keyword">const_cast&lt;</span><a class="code" href="classPetscMatrix.php">PetscMatrix&lt;T&gt;</a>*<span class="keyword">&gt;</span>(<span class="keyword">this</span>)-&gt;mat(),petsc_dest.<a class="code" href="classPetscVector.php#ada77db22640adec265059dd445404f6d">vec</a>()); CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00440"></a>00440 
<a name="l00441"></a>00441 <span class="preprocessor">#endif</span>
<a name="l00442"></a>00442 <span class="preprocessor"></span>
<a name="l00443"></a>00443 }
<a name="l00444"></a>00444 
<a name="l00445"></a>00445 
<a name="l00446"></a>00446 
<a name="l00447"></a>00447 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00448"></a><a class="code" href="classPetscMatrix.php#a269e77c9474db08a0620784f4f77e077">00448</a> <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#a269e77c9474db08a0620784f4f77e077">PetscMatrix&lt;T&gt;::get_transpose</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; dest)<span class="keyword"> const</span>
<a name="l00449"></a>00449 <span class="keyword"></span>{
<a name="l00450"></a>00450   <span class="comment">// Make sure the SparseMatrix passed in is really a PetscMatrix</span>
<a name="l00451"></a>00451   <a class="code" href="classPetscMatrix.php">PetscMatrix&lt;T&gt;</a>&amp; petsc_dest = libmesh_cast_ref&lt;PetscMatrix&lt;T&gt;&amp;&gt;(dest);
<a name="l00452"></a>00452 
<a name="l00453"></a>00453   <span class="comment">// If we aren&#39;t reusing the matrix then need to clear dest,</span>
<a name="l00454"></a>00454   <span class="comment">// otherwise we get a memory leak</span>
<a name="l00455"></a>00455   <span class="keywordflow">if</span>(&amp;petsc_dest != <span class="keyword">this</span>)
<a name="l00456"></a>00456     dest.<a class="code" href="classSparseMatrix.php#a4dc6672a641212eeb422d100d3a542fc">clear</a>();
<a name="l00457"></a>00457 
<a name="l00458"></a>00458   <span class="keywordtype">int</span> ierr;
<a name="l00459"></a>00459 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(3,0,0)</span>
<a name="l00460"></a>00460 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (&amp;petsc_dest == <span class="keyword">this</span>)
<a name="l00461"></a>00461     ierr = MatTranspose(_mat,PETSC_NULL);
<a name="l00462"></a>00462   <span class="keywordflow">else</span>
<a name="l00463"></a>00463     ierr = MatTranspose(_mat,&amp;petsc_dest.<a class="code" href="classPetscMatrix.php#acb8f4ad91b1f8de1504dfd15fadde192">_mat</a>);
<a name="l00464"></a>00464   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00465"></a>00465 <span class="preprocessor">#else</span>
<a name="l00466"></a>00466 <span class="preprocessor"></span>  <span class="comment">// FIXME - we can probably use MAT_REUSE_MATRIX in more situations</span>
<a name="l00467"></a>00467   <span class="keywordflow">if</span> (&amp;petsc_dest == <span class="keyword">this</span>)
<a name="l00468"></a>00468     ierr = MatTranspose(_mat,MAT_REUSE_MATRIX,&amp;petsc_dest.<a class="code" href="classPetscMatrix.php#acb8f4ad91b1f8de1504dfd15fadde192">_mat</a>);
<a name="l00469"></a>00469   <span class="keywordflow">else</span>
<a name="l00470"></a>00470     ierr = MatTranspose(_mat,MAT_INITIAL_MATRIX,&amp;petsc_dest.<a class="code" href="classPetscMatrix.php#acb8f4ad91b1f8de1504dfd15fadde192">_mat</a>);
<a name="l00471"></a>00471   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00472"></a>00472 <span class="preprocessor">#endif</span>
<a name="l00473"></a>00473 <span class="preprocessor"></span>
<a name="l00474"></a>00474   <span class="comment">// Specify that the transposed matrix is initialized and close it.</span>
<a name="l00475"></a>00475   petsc_dest.<a class="code" href="classSparseMatrix.php#a1dd24ca76da426c3c657545d37cb8187">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00476"></a>00476   petsc_dest.<a class="code" href="classPetscMatrix.php#a431196369d051b83ea1e3d595ec2dc0d">close</a>();
<a name="l00477"></a>00477 }
<a name="l00478"></a>00478 
<a name="l00479"></a>00479 
<a name="l00480"></a>00480 
<a name="l00481"></a>00481 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00482"></a>00482 <span class="comment">// Explicit instantiations</span>
<a name="l00483"></a>00483 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classPetscMatrix.php">PetscMatrix&lt;Number&gt;</a>;
<a name="l00484"></a>00484 
<a name="l00485"></a>00485 
<a name="l00486"></a>00486 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_PETSC</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
