<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>petsc_matrix.h</h1>  </div>
</div>
<div class="contents">
<a href="petsc__matrix_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: petsc_matrix.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __petsc_matrix_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __petsc_matrix_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="comment">// C++ includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Local includes</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;parallel.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="petsc__macro_8h.php">petsc_macro.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Macro to identify and debug functions which should be called in</span>
<a name="l00038"></a>00038 <span class="comment">// parallel on parallel matrices but which may be called in serial on</span>
<a name="l00039"></a>00039 <span class="comment">// serial matrices.  This macro will only be valid inside non-static</span>
<a name="l00040"></a>00040 <span class="comment">// PetscMatrix methods</span>
<a name="l00041"></a>00041 <span class="preprocessor">#undef semiparallel_only</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span><span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span><span class="preprocessor">  #include &lt;cstring&gt;</span>
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="preprocessor">  #define semiparallel_only() do { if (this-&gt;initialized()) { const char *mytype; \</span>
<a name="l00046"></a>00046 <span class="preprocessor">    MatGetType(_mat,&amp;mytype); \</span>
<a name="l00047"></a>00047 <span class="preprocessor">    if (!strcmp(mytype, MATSEQAIJ)) \</span>
<a name="l00048"></a>00048 <span class="preprocessor">      parallel_only(); } } while (0)</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span><span class="preprocessor">  #define semiparallel_only()</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span>
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 <span class="comment">// Forward Declarations</span>
<a name="l00055"></a>00055 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classDenseMatrix.php">DenseMatrix</a>;
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00061"></a>00061 EXTERN_C_FOR_PETSC_BEGIN
<a name="l00062"></a>00062 <span class="preprocessor"># include &lt;petscmat.h&gt;</span>
<a name="l00063"></a>00063 EXTERN_C_FOR_PETSC_END
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00075"></a>00075 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00076"></a><a class="code" href="classPetscMatrix.php">00076</a> <span class="keyword">class </span><a class="code" href="classPetscMatrix.php">PetscMatrix</a> : <span class="keyword">public</span> <a class="code" href="classSparseMatrix.php">SparseMatrix</a>&lt;T&gt;
<a name="l00077"></a>00077 {
<a name="l00078"></a>00078 <span class="keyword">public</span>:
<a name="l00094"></a>00094   <a class="code" href="classPetscMatrix.php#a3bc1fcf6549d42e9c113903d51338f6d">PetscMatrix</a> ();
<a name="l00095"></a>00095 
<a name="l00103"></a>00103   <a class="code" href="classPetscMatrix.php#a3bc1fcf6549d42e9c113903d51338f6d">PetscMatrix</a> (Mat <a class="code" href="classPetscMatrix.php#a3fe2c4a39942bfc59b1ed4b04cabec6f">m</a>);
<a name="l00104"></a>00104   
<a name="l00110"></a>00110   <a class="code" href="classPetscMatrix.php#a9fd1736256a9e954019334a815472a8e">~PetscMatrix</a> ();
<a name="l00111"></a>00111 
<a name="l00120"></a>00120   <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#a3d7d48860e626fe1ed8b1b16f3f9532f">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m,
<a name="l00121"></a>00121              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscMatrix.php#ab328981e84816d300b4dace337d518e0">n</a>,
<a name="l00122"></a>00122              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_l,
<a name="l00123"></a>00123              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_l,
<a name="l00124"></a>00124              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nnz=30,
<a name="l00125"></a>00125              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> noz=10);
<a name="l00126"></a>00126 
<a name="l00130"></a>00130   <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#a3d7d48860e626fe1ed8b1b16f3f9532f">init</a> ();
<a name="l00131"></a>00131   
<a name="l00138"></a>00138   <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#a04875fe9a435eb60573e74d1065faf3a">clear</a> ();
<a name="l00139"></a>00139 
<a name="l00144"></a>00144   <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#ac3d7ce98a1ea87f804cf80091bdfc86e">zero</a> ();
<a name="l00145"></a>00145 
<a name="l00149"></a>00149   <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#acc7465ea83190aad48140c8efdd34eb8">zero_rows</a> (std::vector&lt;int&gt; &amp; rows, T diag_value = 0.0);
<a name="l00150"></a>00150   
<a name="l00156"></a>00156   <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#a431196369d051b83ea1e3d595ec2dc0d">close</a> () <span class="keyword">const</span>;
<a name="l00157"></a>00157   
<a name="l00162"></a>00162   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscMatrix.php#a3fe2c4a39942bfc59b1ed4b04cabec6f">m</a> () <span class="keyword">const</span>;
<a name="l00163"></a>00163 
<a name="l00168"></a>00168   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscMatrix.php#ab328981e84816d300b4dace337d518e0">n</a> () <span class="keyword">const</span>;
<a name="l00169"></a>00169 
<a name="l00174"></a>00174   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscMatrix.php#a32bae243b3c9d704d2778004ada745fa">row_start</a> () <span class="keyword">const</span>;
<a name="l00175"></a>00175 
<a name="l00180"></a>00180   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscMatrix.php#ac735967840a097fecd69e834ee6a53ee">row_stop</a> () <span class="keyword">const</span>;
<a name="l00181"></a>00181 
<a name="l00188"></a>00188   <span class="keywordtype">void</span> <span class="keyword">set</span> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00189"></a>00189             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00190"></a>00190             <span class="keyword">const</span> T value);
<a name="l00191"></a>00191     
<a name="l00200"></a>00200   <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#aa082bfe2655a93c335710765af95fd28">add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00201"></a>00201             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00202"></a>00202             <span class="keyword">const</span> T value);
<a name="l00203"></a>00203 
<a name="l00211"></a>00211   <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#adb89e5ae254de3d326d02f7456b69f66">add_matrix</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;dm,
<a name="l00212"></a>00212                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;rows,
<a name="l00213"></a>00213                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;cols);           
<a name="l00214"></a>00214 
<a name="l00219"></a>00219   <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#adb89e5ae254de3d326d02f7456b69f66">add_matrix</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;dm,
<a name="l00220"></a>00220                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;dof_indices);            
<a name="l00221"></a>00221       
<a name="l00233"></a>00233   <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#aa082bfe2655a93c335710765af95fd28">add</a> (<span class="keyword">const</span> T a, <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;X);
<a name="l00234"></a>00234     
<a name="l00253"></a>00253   T <a class="code" href="classPetscMatrix.php#a656e1bfbd5020582422e2b6990e0d492">operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00254"></a>00254                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span>;
<a name="l00255"></a>00255 
<a name="l00267"></a>00267   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classPetscMatrix.php#a3d76f9d09c8b2cf3f82ef2b01190a3f2">l1_norm</a> () <span class="keyword">const</span>;
<a name="l00268"></a>00268 
<a name="l00281"></a>00281   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classPetscMatrix.php#a63402472f723d1c89ffe498ae7b72d18">linfty_norm</a> () <span class="keyword">const</span>;
<a name="l00282"></a>00282 
<a name="l00287"></a>00287   <span class="keywordtype">bool</span> <a class="code" href="classPetscMatrix.php#ac0ce33b01a5e7acfe6d2b6e299f0e55d">closed</a>() <span class="keyword">const</span>;
<a name="l00288"></a>00288   
<a name="l00296"></a>00296   <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#a4116c40d9c558bb3471c5748935a81ef">print_personal</a>(std::ostream&amp; os=std::cout) <span class="keyword">const</span>;
<a name="l00297"></a>00297 
<a name="l00304"></a>00304   <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#a2da4c371bfd1bf997084f0493f16a0fc">print_matlab</a>(<span class="keyword">const</span> std::string <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>=<span class="stringliteral">&quot;NULL&quot;</span>) <span class="keyword">const</span>;
<a name="l00305"></a>00305 
<a name="l00309"></a>00309   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#a31339d95832b7d07d391a73e32e20d2d">get_diagonal</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00310"></a>00310 
<a name="l00315"></a>00315   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#a269e77c9474db08a0620784f4f77e077">get_transpose</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00316"></a>00316 
<a name="l00320"></a>00320   <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#aaf70f96b16c6604e67edc21e24dbb87b">swap</a> (<a class="code" href="classPetscMatrix.php">PetscMatrix&lt;T&gt;</a> &amp;);
<a name="l00321"></a>00321 
<a name="l00327"></a><a class="code" href="classPetscMatrix.php#a612eda163983cf42adb5a2151045f28b">00327</a>   Mat <a class="code" href="classPetscMatrix.php#a612eda163983cf42adb5a2151045f28b">mat</a> () { libmesh_assert (<a class="code" href="classPetscMatrix.php#acb8f4ad91b1f8de1504dfd15fadde192">_mat</a> != NULL); <span class="keywordflow">return</span> <a class="code" href="classPetscMatrix.php#acb8f4ad91b1f8de1504dfd15fadde192">_mat</a>; }
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 <span class="keyword">protected</span>:
<a name="l00330"></a>00330 
<a name="l00340"></a>00340   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#a7d182aa5fbf7fbd9dd5e707b02d69b19">_get_submatrix</a>(<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; submatrix,
<a name="l00341"></a>00341                               <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; rows,
<a name="l00342"></a>00342                               <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; cols,
<a name="l00343"></a>00343                               <span class="keyword">const</span> <span class="keywordtype">bool</span> reuse_submatrix) <span class="keyword">const</span>;
<a name="l00344"></a>00344 
<a name="l00345"></a>00345 <span class="keyword">private</span>:
<a name="l00346"></a>00346   
<a name="l00350"></a><a class="code" href="classPetscMatrix.php#acb8f4ad91b1f8de1504dfd15fadde192">00350</a>   Mat <a class="code" href="classPetscMatrix.php#acb8f4ad91b1f8de1504dfd15fadde192">_mat</a>;
<a name="l00351"></a>00351 
<a name="l00356"></a><a class="code" href="classPetscMatrix.php#aa97aeea45f5fccad3f468ab1bfa0e0c5">00356</a>   <span class="keywordtype">bool</span> <a class="code" href="classPetscMatrix.php#aa97aeea45f5fccad3f468ab1bfa0e0c5">_destroy_mat_on_exit</a>;
<a name="l00357"></a>00357 };
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 
<a name="l00361"></a>00361 
<a name="l00362"></a>00362 <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00363"></a>00363 <span class="comment">// PetscMatrix inline members</span>
<a name="l00364"></a>00364 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00365"></a>00365 <span class="keyword">inline</span>
<a name="l00366"></a><a class="code" href="classPetscMatrix.php#a3bc1fcf6549d42e9c113903d51338f6d">00366</a> <a class="code" href="classPetscMatrix.php#a3bc1fcf6549d42e9c113903d51338f6d">PetscMatrix&lt;T&gt;::PetscMatrix</a>()
<a name="l00367"></a>00367   : _destroy_mat_on_exit(true)
<a name="l00368"></a>00368 {}
<a name="l00369"></a>00369 
<a name="l00370"></a>00370 
<a name="l00371"></a>00371 
<a name="l00372"></a>00372 
<a name="l00373"></a>00373 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00374"></a>00374 <span class="keyword">inline</span>
<a name="l00375"></a><a class="code" href="classPetscMatrix.php#a9597ef98880370bc3783a786f5651f5b">00375</a> <a class="code" href="classPetscMatrix.php#a3bc1fcf6549d42e9c113903d51338f6d">PetscMatrix&lt;T&gt;::PetscMatrix</a>(Mat m)
<a name="l00376"></a>00376   : _destroy_mat_on_exit(false)
<a name="l00377"></a>00377 {
<a name="l00378"></a>00378   this-&gt;<a class="code" href="classPetscMatrix.php#acb8f4ad91b1f8de1504dfd15fadde192">_mat</a> = <a class="code" href="classPetscMatrix.php#a3fe2c4a39942bfc59b1ed4b04cabec6f">m</a>;
<a name="l00379"></a>00379   this-&gt;<a class="code" href="classSparseMatrix.php#a1dd24ca76da426c3c657545d37cb8187">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00380"></a>00380 }
<a name="l00381"></a>00381 
<a name="l00382"></a>00382 
<a name="l00383"></a>00383 
<a name="l00384"></a>00384 
<a name="l00385"></a>00385 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00386"></a>00386 <span class="keyword">inline</span>
<a name="l00387"></a><a class="code" href="classPetscMatrix.php#a9fd1736256a9e954019334a815472a8e">00387</a> <a class="code" href="classPetscMatrix.php#a9fd1736256a9e954019334a815472a8e">PetscMatrix&lt;T&gt;::~PetscMatrix</a>()
<a name="l00388"></a>00388 {
<a name="l00389"></a>00389   this-&gt;clear();
<a name="l00390"></a>00390 }
<a name="l00391"></a>00391 
<a name="l00392"></a>00392 
<a name="l00393"></a>00393 
<a name="l00394"></a>00394 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00395"></a>00395 <span class="keyword">inline</span>
<a name="l00396"></a><a class="code" href="classPetscMatrix.php#a431196369d051b83ea1e3d595ec2dc0d">00396</a> <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#a431196369d051b83ea1e3d595ec2dc0d">PetscMatrix&lt;T&gt;::close</a> ()<span class="keyword"> const</span>
<a name="l00397"></a>00397 <span class="keyword"></span>{
<a name="l00398"></a>00398   parallel_only();
<a name="l00399"></a>00399 
<a name="l00400"></a>00400   <span class="comment">// BSK - 1/19/2004</span>
<a name="l00401"></a>00401   <span class="comment">// strictly this check should be OK, but it seems to</span>
<a name="l00402"></a>00402   <span class="comment">// fail on matrix-free matrices.  Do they falsely</span>
<a name="l00403"></a>00403   <span class="comment">// state they are assembled?  Check with the developers...</span>
<a name="l00404"></a>00404 <span class="comment">//   if (this-&gt;closed())</span>
<a name="l00405"></a>00405 <span class="comment">//     return;</span>
<a name="l00406"></a>00406   
<a name="l00407"></a>00407   <span class="keywordtype">int</span> ierr=0;
<a name="l00408"></a>00408  
<a name="l00409"></a>00409   ierr = MatAssemblyBegin (_mat, MAT_FINAL_ASSEMBLY);
<a name="l00410"></a>00410          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00411"></a>00411   ierr = MatAssemblyEnd   (_mat, MAT_FINAL_ASSEMBLY);
<a name="l00412"></a>00412          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00413"></a>00413 }
<a name="l00414"></a>00414 
<a name="l00415"></a>00415 
<a name="l00416"></a>00416 
<a name="l00417"></a>00417 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00418"></a>00418 <span class="keyword">inline</span>
<a name="l00419"></a><a class="code" href="classPetscMatrix.php#a3fe2c4a39942bfc59b1ed4b04cabec6f">00419</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscMatrix.php#a3fe2c4a39942bfc59b1ed4b04cabec6f">PetscMatrix&lt;T&gt;::m</a> ()<span class="keyword"> const</span>
<a name="l00420"></a>00420 <span class="keyword"></span>{
<a name="l00421"></a>00421   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00422"></a>00422   
<a name="l00423"></a>00423   <span class="keywordtype">int</span> petsc_m=0, petsc_n=0, ierr=0;
<a name="l00424"></a>00424 
<a name="l00425"></a>00425   ierr = MatGetSize (_mat, &amp;petsc_m, &amp;petsc_n);
<a name="l00426"></a>00426 
<a name="l00427"></a>00427   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_m);
<a name="l00428"></a>00428 }
<a name="l00429"></a>00429 
<a name="l00430"></a>00430 
<a name="l00431"></a>00431 
<a name="l00432"></a>00432 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00433"></a>00433 <span class="keyword">inline</span>
<a name="l00434"></a><a class="code" href="classPetscMatrix.php#ab328981e84816d300b4dace337d518e0">00434</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscMatrix.php#ab328981e84816d300b4dace337d518e0">PetscMatrix&lt;T&gt;::n</a> ()<span class="keyword"> const</span>
<a name="l00435"></a>00435 <span class="keyword"></span>{
<a name="l00436"></a>00436   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00437"></a>00437   
<a name="l00438"></a>00438   <span class="keywordtype">int</span> petsc_m=0, petsc_n=0, ierr=0;
<a name="l00439"></a>00439 
<a name="l00440"></a>00440   ierr = MatGetSize (_mat, &amp;petsc_m, &amp;petsc_n);
<a name="l00441"></a>00441 
<a name="l00442"></a>00442   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_n);
<a name="l00443"></a>00443 }
<a name="l00444"></a>00444 
<a name="l00445"></a>00445 
<a name="l00446"></a>00446 
<a name="l00447"></a>00447 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00448"></a>00448 <span class="keyword">inline</span>
<a name="l00449"></a><a class="code" href="classPetscMatrix.php#a32bae243b3c9d704d2778004ada745fa">00449</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscMatrix.php#a32bae243b3c9d704d2778004ada745fa">PetscMatrix&lt;T&gt;::row_start</a> ()<span class="keyword"> const</span>
<a name="l00450"></a>00450 <span class="keyword"></span>{
<a name="l00451"></a>00451   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00452"></a>00452   
<a name="l00453"></a>00453   <span class="keywordtype">int</span> start=0, stop=0, ierr=0;
<a name="l00454"></a>00454 
<a name="l00455"></a>00455   ierr = MatGetOwnershipRange(_mat, &amp;start, &amp;stop);
<a name="l00456"></a>00456          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00457"></a>00457 
<a name="l00458"></a>00458   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(start);
<a name="l00459"></a>00459 }
<a name="l00460"></a>00460 
<a name="l00461"></a>00461 
<a name="l00462"></a>00462 
<a name="l00463"></a>00463 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00464"></a>00464 <span class="keyword">inline</span>
<a name="l00465"></a><a class="code" href="classPetscMatrix.php#ac735967840a097fecd69e834ee6a53ee">00465</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscMatrix.php#ac735967840a097fecd69e834ee6a53ee">PetscMatrix&lt;T&gt;::row_stop</a> ()<span class="keyword"> const</span>
<a name="l00466"></a>00466 <span class="keyword"></span>{
<a name="l00467"></a>00467   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00468"></a>00468   
<a name="l00469"></a>00469   <span class="keywordtype">int</span> start=0, stop=0, ierr=0;
<a name="l00470"></a>00470 
<a name="l00471"></a>00471   ierr = MatGetOwnershipRange(_mat, &amp;start, &amp;stop);
<a name="l00472"></a>00472          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00473"></a>00473 
<a name="l00474"></a>00474   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(stop);
<a name="l00475"></a>00475 }
<a name="l00476"></a>00476 
<a name="l00477"></a>00477 
<a name="l00478"></a>00478 
<a name="l00479"></a>00479 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00480"></a>00480 <span class="keyword">inline</span>
<a name="l00481"></a><a class="code" href="classPetscMatrix.php#a2e5ac1b51576cd3d9be8d7d3abb3a308">00481</a> <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#a2e5ac1b51576cd3d9be8d7d3abb3a308">PetscMatrix&lt;T&gt;::set</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00482"></a>00482                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00483"></a>00483                           <span class="keyword">const</span> T value)
<a name="l00484"></a>00484 {  
<a name="l00485"></a>00485   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00486"></a>00486   
<a name="l00487"></a>00487   <span class="keywordtype">int</span> ierr=0, i_val=i, j_val=j;
<a name="l00488"></a>00488 
<a name="l00489"></a>00489   PetscScalar petsc_value = <span class="keyword">static_cast&lt;</span>PetscScalar<span class="keyword">&gt;</span>(value);
<a name="l00490"></a>00490   ierr = MatSetValues(_mat, 1, &amp;i_val, 1, &amp;j_val,
<a name="l00491"></a>00491                       &amp;petsc_value, INSERT_VALUES);
<a name="l00492"></a>00492          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00493"></a>00493 }
<a name="l00494"></a>00494 
<a name="l00495"></a>00495 
<a name="l00496"></a>00496 
<a name="l00497"></a>00497 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00498"></a>00498 <span class="keyword">inline</span>
<a name="l00499"></a><a class="code" href="classPetscMatrix.php#aa082bfe2655a93c335710765af95fd28">00499</a> <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#aa082bfe2655a93c335710765af95fd28">PetscMatrix&lt;T&gt;::add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00500"></a>00500                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00501"></a>00501                           <span class="keyword">const</span> T value)
<a name="l00502"></a>00502 {
<a name="l00503"></a>00503   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00504"></a>00504   
<a name="l00505"></a>00505   <span class="keywordtype">int</span> ierr=0, i_val=i, j_val=j;
<a name="l00506"></a>00506 
<a name="l00507"></a>00507   PetscScalar petsc_value = <span class="keyword">static_cast&lt;</span>PetscScalar<span class="keyword">&gt;</span>(value);
<a name="l00508"></a>00508   ierr = MatSetValues(_mat, 1, &amp;i_val, 1, &amp;j_val,
<a name="l00509"></a>00509                       &amp;petsc_value, ADD_VALUES);
<a name="l00510"></a>00510          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00511"></a>00511 }
<a name="l00512"></a>00512 
<a name="l00513"></a>00513 
<a name="l00514"></a>00514 
<a name="l00515"></a>00515 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00516"></a>00516 <span class="keyword">inline</span>
<a name="l00517"></a><a class="code" href="classPetscMatrix.php#a09ebe532444012b0b493a774ded35172">00517</a> <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#adb89e5ae254de3d326d02f7456b69f66">PetscMatrix&lt;T&gt;::add_matrix</a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dm,
<a name="l00518"></a>00518                                 <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00519"></a>00519 {
<a name="l00520"></a>00520   this-&gt;add_matrix (dm, dof_indices, dof_indices);
<a name="l00521"></a>00521 }
<a name="l00522"></a>00522 
<a name="l00523"></a>00523 
<a name="l00524"></a>00524 
<a name="l00525"></a>00525 
<a name="l00526"></a>00526 
<a name="l00527"></a>00527 
<a name="l00528"></a>00528 
<a name="l00529"></a>00529 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00530"></a>00530 <span class="keyword">inline</span>
<a name="l00531"></a><a class="code" href="classPetscMatrix.php#a789285607346bb3736412d87e5d912b2">00531</a> <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#aa082bfe2655a93c335710765af95fd28">PetscMatrix&lt;T&gt;::add</a> (<span class="keyword">const</span> T a_in, <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;X_in)
<a name="l00532"></a>00532 {
<a name="l00533"></a>00533   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00534"></a>00534 
<a name="l00535"></a>00535   <span class="comment">// sanity check. but this cannot avoid </span>
<a name="l00536"></a>00536   <span class="comment">// crash due to incompatible sparsity structure...</span>
<a name="l00537"></a>00537   libmesh_assert (this-&gt;m() == X_in.<a class="code" href="classSparseMatrix.php#af2f0d62994782f324c59bd4203b9d1d2">m</a>());
<a name="l00538"></a>00538   libmesh_assert (this-&gt;n() == X_in.<a class="code" href="classSparseMatrix.php#af540f97c67ca77cf3a6dc7a4f1551c19">n</a>());
<a name="l00539"></a>00539 
<a name="l00540"></a>00540   PetscScalar     a = <span class="keyword">static_cast&lt;</span>PetscScalar<span class="keyword">&gt;</span>      (a_in);
<a name="l00541"></a>00541   <a class="code" href="classPetscMatrix.php">PetscMatrix&lt;T&gt;</a>* X = <span class="keyword">dynamic_cast&lt;</span><a class="code" href="classPetscMatrix.php">PetscMatrix&lt;T&gt;</a>*<span class="keyword">&gt;</span> (&amp;X_in);
<a name="l00542"></a>00542 
<a name="l00543"></a>00543   libmesh_assert (X != NULL);
<a name="l00544"></a>00544   
<a name="l00545"></a>00545   <span class="keywordtype">int</span> ierr=0;
<a name="l00546"></a>00546 
<a name="l00547"></a>00547   <span class="comment">// the matrix from which we copy the values has to be assembled/closed</span>
<a name="l00548"></a>00548   <span class="comment">// X-&gt;close ();</span>
<a name="l00549"></a>00549   libmesh_assert(X-&gt;<a class="code" href="classPetscMatrix.php#ac0ce33b01a5e7acfe6d2b6e299f0e55d">closed</a>());
<a name="l00550"></a>00550 
<a name="l00551"></a>00551   semiparallel_only();
<a name="l00552"></a>00552 
<a name="l00553"></a>00553 <span class="comment">// 2.2.x &amp; earlier style</span>
<a name="l00554"></a>00554 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,0)  </span>
<a name="l00555"></a>00555 <span class="preprocessor"></span>  
<a name="l00556"></a>00556   ierr = MatAXPY(&amp;a,  X-&gt;<a class="code" href="classPetscMatrix.php#acb8f4ad91b1f8de1504dfd15fadde192">_mat</a>, _mat, SAME_NONZERO_PATTERN);
<a name="l00557"></a>00557          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00558"></a>00558          
<a name="l00559"></a>00559 <span class="comment">// 2.3.x &amp; newer</span>
<a name="l00560"></a>00560 <span class="preprocessor">#else</span>
<a name="l00561"></a>00561 <span class="preprocessor"></span>  
<a name="l00562"></a>00562   ierr = MatAXPY(_mat, a, X-&gt;<a class="code" href="classPetscMatrix.php#acb8f4ad91b1f8de1504dfd15fadde192">_mat</a>, DIFFERENT_NONZERO_PATTERN);
<a name="l00563"></a>00563          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00564"></a>00564          
<a name="l00565"></a>00565 <span class="preprocessor">#endif</span>
<a name="l00566"></a>00566 <span class="preprocessor"></span>}
<a name="l00567"></a>00567 
<a name="l00568"></a>00568 
<a name="l00569"></a>00569 
<a name="l00570"></a>00570 
<a name="l00571"></a>00571 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00572"></a>00572 <span class="keyword">inline</span>
<a name="l00573"></a><a class="code" href="classPetscMatrix.php#a656e1bfbd5020582422e2b6990e0d492">00573</a> T <a class="code" href="classPetscMatrix.php#a656e1bfbd5020582422e2b6990e0d492">PetscMatrix&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00574"></a>00574                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const</span>
<a name="l00575"></a>00575 <span class="keyword"></span>{
<a name="l00576"></a>00576   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00577"></a>00577 
<a name="l00578"></a>00578 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,1)</span>
<a name="l00579"></a>00579 <span class="preprocessor"></span>
<a name="l00580"></a>00580   <span class="comment">// PETSc 2.2.0 &amp; older</span>
<a name="l00581"></a>00581   PetscScalar *petsc_row;
<a name="l00582"></a>00582   <span class="keywordtype">int</span>* petsc_cols;
<a name="l00583"></a>00583   
<a name="l00584"></a>00584 <span class="preprocessor">#else</span>
<a name="l00585"></a>00585 <span class="preprocessor"></span>  
<a name="l00586"></a>00586   <span class="comment">// PETSc 2.2.1 &amp; newer</span>
<a name="l00587"></a>00587   <span class="keyword">const</span> PetscScalar *petsc_row;
<a name="l00588"></a>00588   <span class="keyword">const</span> <a class="code" href="petsc__linear__solver_8C.php#a515706180f960b30595b607f2d734d14">PetscInt</a>    *petsc_cols;
<a name="l00589"></a>00589 
<a name="l00590"></a>00590 <span class="preprocessor">#endif</span>
<a name="l00591"></a>00591 <span class="preprocessor"></span>  
<a name="l00592"></a>00592   
<a name="l00593"></a>00593   <span class="comment">// If the entry is not in the sparse matrix, it is 0.  </span>
<a name="l00594"></a>00594   T value=0.;  
<a name="l00595"></a>00595   
<a name="l00596"></a>00596   <span class="keywordtype">int</span>
<a name="l00597"></a>00597     ierr=0,
<a name="l00598"></a>00598     ncols=0,
<a name="l00599"></a>00599     i_val=<span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(i),
<a name="l00600"></a>00600     j_val=static_cast&lt;int&gt;(j);
<a name="l00601"></a>00601   
<a name="l00602"></a>00602 
<a name="l00603"></a>00603   <span class="comment">// the matrix needs to be closed for this to work</span>
<a name="l00604"></a>00604   <span class="comment">// this-&gt;close();</span>
<a name="l00605"></a>00605   <span class="comment">// but closing it is a semiparallel operation; we want operator()</span>
<a name="l00606"></a>00606   <span class="comment">// to run on one processor.</span>
<a name="l00607"></a>00607   libmesh_assert(this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00608"></a>00608 
<a name="l00609"></a>00609   ierr = MatGetRow(_mat, i_val, &amp;ncols, &amp;petsc_cols, &amp;petsc_row);
<a name="l00610"></a>00610          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00611"></a>00611          
<a name="l00612"></a>00612   <span class="comment">// Perform a binary search to find the contiguous index in</span>
<a name="l00613"></a>00613   <span class="comment">// petsc_cols (resp. petsc_row) corresponding to global index j_val</span>
<a name="l00614"></a>00614   std::pair&lt;const int*, const int*&gt; p =
<a name="l00615"></a>00615     std::equal_range (&amp;petsc_cols[0], &amp;petsc_cols[0] + ncols, j_val);
<a name="l00616"></a>00616 
<a name="l00617"></a>00617   <span class="comment">// Found an entry for j_val</span>
<a name="l00618"></a>00618   <span class="keywordflow">if</span> (p.first != p.second)
<a name="l00619"></a>00619     {
<a name="l00620"></a>00620       <span class="comment">// The entry in the contiguous row corresponding</span>
<a name="l00621"></a>00621       <span class="comment">// to the j_val column of interest</span>
<a name="l00622"></a>00622       <span class="keyword">const</span> <span class="keywordtype">int</span> j = std::distance (const_cast&lt;int*&gt;(&amp;petsc_cols[0]),
<a name="l00623"></a>00623                                    const_cast&lt;int*&gt;(p.first));
<a name="l00624"></a>00624       
<a name="l00625"></a>00625       libmesh_assert (j &lt; ncols);
<a name="l00626"></a>00626       libmesh_assert (petsc_cols[j] == j_val);
<a name="l00627"></a>00627       
<a name="l00628"></a>00628       value = <span class="keyword">static_cast&lt;</span>T<span class="keyword">&gt;</span> (petsc_row[j]);
<a name="l00629"></a>00629     }
<a name="l00630"></a>00630       
<a name="l00631"></a>00631   ierr  = MatRestoreRow(_mat, i_val,
<a name="l00632"></a>00632                         &amp;ncols, &amp;petsc_cols, &amp;petsc_row);
<a name="l00633"></a>00633           CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00634"></a>00634           
<a name="l00635"></a>00635   <span class="keywordflow">return</span> value;
<a name="l00636"></a>00636 }
<a name="l00637"></a>00637 
<a name="l00638"></a>00638 
<a name="l00639"></a>00639 
<a name="l00640"></a>00640 
<a name="l00641"></a>00641 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00642"></a>00642 <span class="keyword">inline</span>
<a name="l00643"></a><a class="code" href="classPetscMatrix.php#ac0ce33b01a5e7acfe6d2b6e299f0e55d">00643</a> <span class="keywordtype">bool</span> <a class="code" href="classPetscMatrix.php#ac0ce33b01a5e7acfe6d2b6e299f0e55d">PetscMatrix&lt;T&gt;::closed</a>()<span class="keyword"> const</span>
<a name="l00644"></a>00644 <span class="keyword"></span>{
<a name="l00645"></a>00645   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00646"></a>00646   
<a name="l00647"></a>00647   <span class="keywordtype">int</span> ierr=0;
<a name="l00648"></a>00648   PetscTruth assembled;
<a name="l00649"></a>00649 
<a name="l00650"></a>00650   ierr = MatAssembled(_mat, &amp;assembled);
<a name="l00651"></a>00651          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00652"></a>00652 
<a name="l00653"></a>00653   <span class="keywordflow">return</span> (assembled == PETSC_TRUE);
<a name="l00654"></a>00654 }
<a name="l00655"></a>00655 
<a name="l00656"></a>00656 
<a name="l00657"></a>00657 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00658"></a>00658 <span class="keyword">inline</span>
<a name="l00659"></a><a class="code" href="classPetscMatrix.php#aaf70f96b16c6604e67edc21e24dbb87b">00659</a> <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#aaf70f96b16c6604e67edc21e24dbb87b">PetscMatrix&lt;T&gt;::swap</a>(<a class="code" href="classPetscMatrix.php">PetscMatrix&lt;T&gt;</a> &amp;m) 
<a name="l00660"></a>00660 {
<a name="l00661"></a>00661   std::swap(_mat, m.<a class="code" href="classPetscMatrix.php#acb8f4ad91b1f8de1504dfd15fadde192">_mat</a>);
<a name="l00662"></a>00662   std::swap(_destroy_mat_on_exit, m.<a class="code" href="classPetscMatrix.php#aa97aeea45f5fccad3f468ab1bfa0e0c5">_destroy_mat_on_exit</a>);
<a name="l00663"></a>00663 }
<a name="l00664"></a>00664 
<a name="l00665"></a>00665 
<a name="l00666"></a>00666 
<a name="l00667"></a>00667 
<a name="l00668"></a>00668 
<a name="l00669"></a>00669 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00670"></a>00670 <span class="keyword">inline</span>
<a name="l00671"></a><a class="code" href="classPetscMatrix.php#a4116c40d9c558bb3471c5748935a81ef">00671</a> <span class="keywordtype">void</span> <a class="code" href="classPetscMatrix.php#a4116c40d9c558bb3471c5748935a81ef">PetscMatrix&lt;T&gt;::print_personal</a>(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00672"></a>00672 <span class="keyword"></span>{
<a name="l00673"></a>00673   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00674"></a>00674 
<a name="l00675"></a>00675 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00676"></a>00676 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (os != std::cout)
<a name="l00677"></a>00677     std::cerr &lt;&lt; <span class="stringliteral">&quot;Warning! PETSc can only print to std::cout!&quot;</span> &lt;&lt; std::endl;
<a name="l00678"></a>00678 <span class="preprocessor">#endif</span>
<a name="l00679"></a>00679 <span class="preprocessor"></span>  
<a name="l00680"></a>00680   <span class="keywordtype">int</span> ierr=0;
<a name="l00681"></a>00681 
<a name="l00682"></a>00682   ierr = MatView(_mat, PETSC_VIEWER_STDOUT_SELF);
<a name="l00683"></a>00683          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00684"></a>00684 }
<a name="l00685"></a>00685 
<a name="l00686"></a>00686 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00687"></a>00687 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __petsc_matrix_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
