<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>petsc_nonlinear_solver.h</h1>  </div>
</div>
<div class="contents">
<a href="petsc__nonlinear__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: petsc_nonlinear_solver.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __petsc_nonlinear_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __petsc_nonlinear_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Petsc include files.</span>
<a name="l00032"></a>00032 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="nonlinear__solver_8h.php">nonlinear_solver.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="petsc__macro_8h.php">petsc_macro.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 EXTERN_C_FOR_PETSC_BEGIN
<a name="l00038"></a>00038 <span class="preprocessor"># include &lt;petscsnes.h&gt;</span>
<a name="l00039"></a>00039 EXTERN_C_FOR_PETSC_END
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00051"></a>00051 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00052"></a><a class="code" href="classPetscNonlinearSolver.php">00052</a> <span class="keyword">class </span><a class="code" href="classPetscNonlinearSolver.php">PetscNonlinearSolver</a> : <span class="keyword">public</span> <a class="code" href="classNonlinearSolver.php">NonlinearSolver</a>&lt;T&gt;
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054 <span class="keyword">public</span>:
<a name="l00058"></a><a class="code" href="classPetscNonlinearSolver.php#ad828e2786963ab8d1549bf33899bdd7e">00058</a>   <span class="keyword">typedef</span> <a class="code" href="classNonlinearImplicitSystem.php">NonlinearImplicitSystem</a> <a class="code" href="classPetscNonlinearSolver.php#ad828e2786963ab8d1549bf33899bdd7e">sys_type</a>;
<a name="l00059"></a>00059 
<a name="l00063"></a>00063   <a class="code" href="classPetscNonlinearSolver.php#a1c3675263bac7a4333a068deaa0913c1">PetscNonlinearSolver</a> (<a class="code" href="classNonlinearImplicitSystem.php">sys_type</a>&amp; <a class="code" href="classNonlinearSolver.php#acb0c621b2fe80e2c4b7e2b8114b349cb">system</a>);
<a name="l00064"></a>00064     
<a name="l00068"></a>00068   <a class="code" href="classPetscNonlinearSolver.php#acd3fa4d60a679efd83d651769a2c9346">~PetscNonlinearSolver</a> ();
<a name="l00069"></a>00069   
<a name="l00073"></a>00073   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPetscNonlinearSolver.php#a89c97dc01dfe2db4b135bdcfb816fb37">clear</a> ();
<a name="l00074"></a>00074 
<a name="l00078"></a>00078   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPetscNonlinearSolver.php#ada9d366279d9c2c1a274451bcba59f9e">init</a> ();
<a name="l00079"></a>00079 
<a name="l00083"></a><a class="code" href="classPetscNonlinearSolver.php#a9090390ad8b9a80ac988246242af5ee9">00083</a>   SNES <a class="code" href="classPetscNonlinearSolver.php#a9090390ad8b9a80ac988246242af5ee9">snes</a>() { this-&gt;<a class="code" href="classPetscNonlinearSolver.php#ada9d366279d9c2c1a274451bcba59f9e">init</a>(); <span class="keywordflow">return</span> <a class="code" href="classPetscNonlinearSolver.php#abfa21d135caa78ffad4419897b831854">_snes</a>; }
<a name="l00084"></a>00084   
<a name="l00089"></a>00089   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt; <a class="code" href="classPetscNonlinearSolver.php#abf488230a81c903298babee9dbefcb9e">solve</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;,    <span class="comment">// System Jacobian Matrix</span>
<a name="l00090"></a>00090                                                <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;,   <span class="comment">// Solution vector</span>
<a name="l00091"></a>00091                                                <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;,   <span class="comment">// Residual vector</span>
<a name="l00092"></a>00092                                                <span class="keyword">const</span> <span class="keywordtype">double</span>,        <span class="comment">// Stopping tolerance</span>
<a name="l00093"></a>00093                                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>); <span class="comment">// N. Iterations</span>
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   
<a name="l00097"></a>00097 <span class="keyword">private</span>:
<a name="l00098"></a>00098 
<a name="l00102"></a><a class="code" href="classPetscNonlinearSolver.php#abfa21d135caa78ffad4419897b831854">00102</a>   SNES <a class="code" href="classPetscNonlinearSolver.php#abfa21d135caa78ffad4419897b831854">_snes</a>;
<a name="l00103"></a>00103 };
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 <span class="comment">/*----------------------- functions ----------------------------------*/</span>
<a name="l00107"></a>00107 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00108"></a>00108 <span class="keyword">inline</span>
<a name="l00109"></a><a class="code" href="classPetscNonlinearSolver.php#a1c3675263bac7a4333a068deaa0913c1">00109</a> <a class="code" href="classPetscNonlinearSolver.php#a1c3675263bac7a4333a068deaa0913c1">PetscNonlinearSolver&lt;T&gt;::PetscNonlinearSolver</a> (<a class="code" href="classNonlinearImplicitSystem.php">sys_type</a>&amp; system) :
<a name="l00110"></a>00110   <a class="code" href="classNonlinearSolver.php">NonlinearSolver</a>&lt;T&gt;(system)
<a name="l00111"></a>00111 {
<a name="l00112"></a>00112 }
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00117"></a>00117 <span class="keyword">inline</span>
<a name="l00118"></a><a class="code" href="classPetscNonlinearSolver.php#acd3fa4d60a679efd83d651769a2c9346">00118</a> <a class="code" href="classPetscNonlinearSolver.php#acd3fa4d60a679efd83d651769a2c9346">PetscNonlinearSolver&lt;T&gt;::~PetscNonlinearSolver</a> ()
<a name="l00119"></a>00119 {
<a name="l00120"></a>00120   this-&gt;clear ();
<a name="l00121"></a>00121 }
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00126"></a>00126 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __petsc_nonlinear_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
