<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_f10759d5ac6297fe611079c3c15b8f2c.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>petsc_preconditioner.C</h1>  </div>
</div>
<div class="contents">
<a href="petsc__preconditioner_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: petsc_preconditioner.C 3423 2009-07-15 20:41:43Z friedmud $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// C++ includes</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local Includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;auto_ptr.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;petsc_preconditioner.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;petsc_macro.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;petsc_matrix.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;petsc_vector.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;petsc_macro.h&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00037"></a>00037 <span class="keywordtype">void</span>
<a name="l00038"></a><a class="code" href="classPetscPreconditioner.php#a8c9b8b93eac654f9c99d4218212fea2d">00038</a> <a class="code" href="classPetscPreconditioner.php#a8c9b8b93eac654f9c99d4218212fea2d">PetscPreconditioner&lt;T&gt;::apply</a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; x, <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; y)
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040   <a class="code" href="classPetscVector.php">PetscVector&lt;T&gt;</a> &amp; x_pvec = libmesh_cast_ref&lt;PetscVector&lt;T&gt;&amp;&gt;(<span class="keyword">const_cast&lt;</span><a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;<span class="keyword">&gt;</span>(x));
<a name="l00041"></a>00041   <a class="code" href="classPetscVector.php">PetscVector&lt;T&gt;</a> &amp; y_pvec = libmesh_cast_ref&lt;PetscVector&lt;T&gt;&amp;&gt;(<span class="keyword">const_cast&lt;</span><a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;<span class="keyword">&gt;</span>(y));
<a name="l00042"></a>00042 
<a name="l00043"></a>00043   Vec x_vec = x_pvec.<a class="code" href="classPetscVector.php#ada77db22640adec265059dd445404f6d">vec</a>();
<a name="l00044"></a>00044   Vec y_vec = y_pvec.<a class="code" href="classPetscVector.php#ada77db22640adec265059dd445404f6d">vec</a>();
<a name="l00045"></a>00045 
<a name="l00046"></a>00046   PCApply(_pc,x_vec,y_vec);
<a name="l00047"></a>00047 }
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00050"></a>00050 <span class="keywordtype">void</span>
<a name="l00051"></a><a class="code" href="classPetscPreconditioner.php#a5d042d2d4eeed27e0145c588a1e37fb3">00051</a> <a class="code" href="classPetscPreconditioner.php#a5d042d2d4eeed27e0145c588a1e37fb3">PetscPreconditioner&lt;T&gt;::init</a> ()
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053   <span class="keywordflow">if</span>(!this-&gt;_matrix)
<a name="l00054"></a>00054   {
<a name="l00055"></a>00055     std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: No matrix set for PetscPreconditioner, but init() called&quot;</span> &lt;&lt; std::endl;
<a name="l00056"></a>00056     libmesh_error();
<a name="l00057"></a>00057   }
<a name="l00058"></a>00058 
<a name="l00059"></a>00059   <span class="comment">//Clear the preconditioner in case it has been created in the past</span>
<a name="l00060"></a>00060   <span class="keywordflow">if</span>(!this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a>)
<a name="l00061"></a>00061   {
<a name="l00062"></a>00062     <span class="comment">//Create the preconditioning object</span>
<a name="l00063"></a>00063     PCCreate(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,&amp;_pc);
<a name="l00064"></a>00064 
<a name="l00065"></a>00065     <span class="comment">//Set the PCType</span>
<a name="l00066"></a>00066     set_petsc_preconditioner_type(this-&gt;_preconditioner_type, _pc);
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC_HYPRE</span>
<a name="l00069"></a>00069 <span class="preprocessor"></span>    <span class="keywordflow">if</span>(this-&gt;_preconditioner_type == <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4ac436c2c16e4aaaf30a5d761bc7e6c621">AMG_PRECOND</a>)
<a name="l00070"></a>00070       PCHYPRESetType(this-&gt;_pc, <span class="stringliteral">&quot;boomeramg&quot;</span>);
<a name="l00071"></a>00071 <span class="preprocessor">#endif</span>
<a name="l00072"></a>00072 <span class="preprocessor"></span>
<a name="l00073"></a>00073     <a class="code" href="classPetscMatrix.php">PetscMatrix&lt;T&gt;</a> * pmatrix = libmesh_cast_ptr&lt;PetscMatrix&lt;T&gt;*, <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &gt;(this-&gt;_matrix);
<a name="l00074"></a>00074     
<a name="l00075"></a>00075     _mat = pmatrix-&gt;<a class="code" href="classPetscMatrix.php#a612eda163983cf42adb5a2151045f28b">mat</a>();
<a name="l00076"></a>00076   }
<a name="l00077"></a>00077   
<a name="l00078"></a>00078   PCSetOperators(_pc,_mat,_mat,SAME_NONZERO_PATTERN);
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00081"></a>00081 }
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00084"></a>00084 <span class="keywordtype">void</span>
<a name="l00085"></a><a class="code" href="classPetscPreconditioner.php#a19eb1fca114780091f7d205ff9067b5c">00085</a> <a class="code" href="classPetscPreconditioner.php#a19eb1fca114780091f7d205ff9067b5c">PetscPreconditioner&lt;T&gt;::set_petsc_preconditioner_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4">PreconditionerType</a> &amp; preconditioner_type, PC &amp; pc)
<a name="l00086"></a>00086 {
<a name="l00087"></a>00087   <span class="keywordtype">int</span> ierr = 0;
<a name="l00088"></a>00088  
<a name="l00089"></a>00089   <span class="keywordflow">switch</span> (preconditioner_type)
<a name="l00090"></a>00090   {
<a name="l00091"></a>00091   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a44a26581f6d3dd94e7188bbb4af8294a">IDENTITY_PRECOND</a>:
<a name="l00092"></a>00092     ierr = PCSetType (pc, (<span class="keywordtype">char</span>*) PCNONE);      CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">break</span>;
<a name="l00093"></a>00093         
<a name="l00094"></a>00094   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a01ae0c1024d6b2ae4022dbf0e0317ea9">CHOLESKY_PRECOND</a>:
<a name="l00095"></a>00095     ierr = PCSetType (pc, (<span class="keywordtype">char</span>*) PCCHOLESKY);  CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">break</span>;
<a name="l00096"></a>00096 
<a name="l00097"></a>00097   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4ad530e0c240976b35094aee7290848d7f">ICC_PRECOND</a>:
<a name="l00098"></a>00098     ierr = PCSetType (pc, (<span class="keywordtype">char</span>*) PCICC);       CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">break</span>;
<a name="l00099"></a>00099 
<a name="l00100"></a>00100   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4af54549e0e69fbdd4ddd199ee316527f3">ILU_PRECOND</a>:
<a name="l00101"></a>00101     ierr = PCSetType (pc, (<span class="keywordtype">char</span>*) PCILU);       CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">break</span>;
<a name="l00102"></a>00102 
<a name="l00103"></a>00103   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4af6625c293f8dbecf282cac92d7a8c8fb">LU_PRECOND</a>:
<a name="l00104"></a>00104     ierr = PCSetType (pc, (<span class="keywordtype">char</span>*) PCLU);        CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">break</span>;
<a name="l00105"></a>00105       
<a name="l00106"></a>00106   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a791f4098f0a9d74f940c5e1fb1215582">ASM_PRECOND</a>:
<a name="l00107"></a>00107     ierr = PCSetType (pc, (<span class="keywordtype">char</span>*) PCASM);       CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">break</span>;
<a name="l00108"></a>00108 
<a name="l00109"></a>00109   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a9b2d6ff994aa4cfb181f5eceec23174f">JACOBI_PRECOND</a>:
<a name="l00110"></a>00110     ierr = PCSetType (pc, (<span class="keywordtype">char</span>*) PCJACOBI);    CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">break</span>;
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a8f036d61e96c69b14d585f04235613d2">BLOCK_JACOBI_PRECOND</a>:
<a name="l00113"></a>00113     ierr = PCSetType (pc, (<span class="keywordtype">char</span>*) PCBJACOBI);   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">break</span>;
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a52da319102c9f93cef67896f122614b9">SOR_PRECOND</a>:
<a name="l00116"></a>00116     ierr = PCSetType (pc, (<span class="keywordtype">char</span>*) PCSOR);       CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">break</span>;
<a name="l00117"></a>00117 
<a name="l00118"></a>00118   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a7e8d6554e69fa3376ef61e35b17d92a4">EISENSTAT_PRECOND</a>:
<a name="l00119"></a>00119     ierr = PCSetType (pc, (<span class="keywordtype">char</span>*) PCEISENSTAT); CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">break</span>;
<a name="l00120"></a>00120 
<a name="l00121"></a>00121   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4ac436c2c16e4aaaf30a5d761bc7e6c621">AMG_PRECOND</a>:
<a name="l00122"></a>00122     ierr = PCSetType (pc, (<span class="keywordtype">char</span>*) PCHYPRE);     CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">break</span>;
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 <span class="preprocessor">#if !(PETSC_VERSION_LESS_THAN(2,1,2))</span>
<a name="l00125"></a>00125 <span class="preprocessor"></span>    <span class="comment">// Only available for PETSC &gt;= 2.1.2      </span>
<a name="l00126"></a>00126   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4ae3a9e261a354c7a05a8a8d0648f210de">USER_PRECOND</a>:
<a name="l00127"></a>00127     ierr = PCSetType (pc, (<span class="keywordtype">char</span>*) PCMAT);       CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">break</span>;
<a name="l00128"></a>00128 <span class="preprocessor">#endif</span>
<a name="l00129"></a>00129 <span class="preprocessor"></span>
<a name="l00130"></a>00130   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4af09677d7fa99ef863f62c4f26266b27f">SHELL_PRECOND</a>:
<a name="l00131"></a>00131     ierr = PCSetType (pc, (<span class="keywordtype">char</span>*) PCSHELL);     CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">break</span>;
<a name="l00132"></a>00132 
<a name="l00133"></a>00133   <span class="keywordflow">default</span>:
<a name="l00134"></a>00134     std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR:  Unsupported PETSC Preconditioner: &quot;</span>
<a name="l00135"></a>00135               &lt;&lt; preconditioner_type       &lt;&lt; std::endl
<a name="l00136"></a>00136               &lt;&lt; <span class="stringliteral">&quot;Continuing with PETSC defaults&quot;</span> &lt;&lt; std::endl;
<a name="l00137"></a>00137   }
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   <span class="comment">//Let the commandline override stuff</span>
<a name="l00140"></a>00140   <span class="keywordflow">if</span>( preconditioner_type != <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4ac436c2c16e4aaaf30a5d761bc7e6c621">AMG_PRECOND</a> )
<a name="l00141"></a>00141     PCSetFromOptions(pc);
<a name="l00142"></a>00142 }
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00145"></a>00145 <span class="comment">// Explicit instantiations</span>
<a name="l00146"></a>00146 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classPetscPreconditioner.php">PetscPreconditioner&lt;Number&gt;</a>;
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_PETSC</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
