<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>petsc_preconditioner.h</h1>  </div>
</div>
<div class="contents">
<a href="petsc__preconditioner_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: petsc_preconditioner.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __petsc_preconditioner_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __petsc_preconditioner_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="comment">// C++ includes</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Local includes</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="preconditioner_8h.php">preconditioner.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;enum_solver_package.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;enum_preconditioner_type.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;reference_counted_object.h&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;libmesh.h&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">// Petsc includes</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;petscpc.h&quot;</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="comment">// forward declarations</span>
<a name="l00043"></a>00043 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr</a>;
<a name="l00044"></a>00044 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classSparseMatrix.php">SparseMatrix</a>;
<a name="l00045"></a>00045 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classNumericVector.php">NumericVector</a>;
<a name="l00046"></a>00046 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classShellMatrix.php">ShellMatrix</a>;
<a name="l00047"></a>00047 
<a name="l00055"></a>00055 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00056"></a><a class="code" href="classPetscPreconditioner.php">00056</a> <span class="keyword">class </span><a class="code" href="classPetscPreconditioner.php">PetscPreconditioner</a> : <span class="keyword">public</span> <a class="code" href="classPreconditioner.php">Preconditioner</a>&lt;T&gt;
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058 <span class="keyword">public</span>:
<a name="l00059"></a>00059   
<a name="l00063"></a>00063   <a class="code" href="classPetscPreconditioner.php#a26ee15e74a8624c2957d6d2c75a6d415">PetscPreconditioner</a> ();
<a name="l00064"></a>00064     
<a name="l00068"></a>00068   <span class="keyword">virtual</span> <a class="code" href="classPetscPreconditioner.php#acbfba4b04a0b40e4ae77a9b87a6dc99b">~PetscPreconditioner</a> ();  
<a name="l00069"></a>00069 
<a name="l00074"></a>00074   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPetscPreconditioner.php#a8c9b8b93eac654f9c99d4218212fea2d">apply</a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; x, <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; y);
<a name="l00075"></a>00075   
<a name="l00079"></a><a class="code" href="classPetscPreconditioner.php#ac90dbc5ea7205ed5f3b54b0963c62d46">00079</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPetscPreconditioner.php#ac90dbc5ea7205ed5f3b54b0963c62d46">clear</a> () {}
<a name="l00080"></a>00080 
<a name="l00084"></a>00084   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPetscPreconditioner.php#a5d042d2d4eeed27e0145c588a1e37fb3">init</a> ();
<a name="l00085"></a>00085 
<a name="l00090"></a><a class="code" href="classPetscPreconditioner.php#a530d125ff7e98d5ddb7565865f96c29d">00090</a>   PC <a class="code" href="classPetscPreconditioner.php#a530d125ff7e98d5ddb7565865f96c29d">pc</a>() { <span class="keywordflow">return</span> <a class="code" href="classPetscPreconditioner.php#a0a026e0dd23b1534df575f9d71522084">_pc</a>; }
<a name="l00091"></a>00091   
<a name="l00095"></a>00095   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classPetscPreconditioner.php#a19eb1fca114780091f7d205ff9067b5c">set_petsc_preconditioner_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4">PreconditionerType</a> &amp; preconditioner_type, PC &amp; <a class="code" href="classPetscPreconditioner.php#a530d125ff7e98d5ddb7565865f96c29d">pc</a>);
<a name="l00096"></a>00096   
<a name="l00097"></a>00097 <span class="keyword">protected</span>:
<a name="l00098"></a>00098   
<a name="l00102"></a><a class="code" href="classPetscPreconditioner.php#a0a026e0dd23b1534df575f9d71522084">00102</a>   PC <a class="code" href="classPetscPreconditioner.php#a0a026e0dd23b1534df575f9d71522084">_pc</a>;
<a name="l00103"></a>00103 
<a name="l00108"></a><a class="code" href="classPetscPreconditioner.php#ac22657fc04d557fda60351781673b0a1">00108</a>   Mat <a class="code" href="classPetscPreconditioner.php#ac22657fc04d557fda60351781673b0a1">_mat</a>;
<a name="l00109"></a>00109 };
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 <span class="comment">/*----------------------- inline functions ----------------------------------*/</span>
<a name="l00115"></a>00115 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00116"></a>00116 <span class="keyword">inline</span>
<a name="l00117"></a><a class="code" href="classPetscPreconditioner.php#a26ee15e74a8624c2957d6d2c75a6d415">00117</a> <a class="code" href="classPetscPreconditioner.php#a26ee15e74a8624c2957d6d2c75a6d415">PetscPreconditioner&lt;T&gt;::PetscPreconditioner</a> () :
<a name="l00118"></a>00118   <a class="code" href="classPreconditioner.php">Preconditioner</a>&lt;T&gt;()
<a name="l00119"></a>00119 {
<a name="l00120"></a>00120 }
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00125"></a>00125 <span class="keyword">inline</span>
<a name="l00126"></a><a class="code" href="classPetscPreconditioner.php#acbfba4b04a0b40e4ae77a9b87a6dc99b">00126</a> <a class="code" href="classPetscPreconditioner.php#acbfba4b04a0b40e4ae77a9b87a6dc99b">PetscPreconditioner&lt;T&gt;::~PetscPreconditioner</a> ()
<a name="l00127"></a>00127 {
<a name="l00128"></a>00128   this-&gt;clear ();
<a name="l00129"></a>00129 }
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00132"></a>00132 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __petsc_linear_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
