<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>petsc_vector.h</h1>  </div>
</div>
<div class="contents">
<a href="petsc__vector_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: petsc_vector.h 3459 2009-09-08 16:10:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifndef __petsc_vector_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#define __petsc_vector_h__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="comment">// C++ includes</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Local includes</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="petsc__macro_8h.php">petsc_macro.h</a>&quot;</span>
<a name="l00038"></a>00038 
<a name="l00042"></a>00042 EXTERN_C_FOR_PETSC_BEGIN
<a name="l00043"></a>00043 <span class="preprocessor"># include &lt;petscvec.h&gt;</span>
<a name="l00044"></a>00044 EXTERN_C_FOR_PETSC_END
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 <span class="comment">// forward declarations</span>
<a name="l00049"></a>00049 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classSparseMatrix.php">SparseMatrix</a>;
<a name="l00050"></a>00050 
<a name="l00058"></a>00058 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00059"></a><a class="code" href="classPetscVector.php">00059</a> <span class="keyword">class </span><a class="code" href="classPetscVector.php">PetscVector</a> : <span class="keyword">public</span> <a class="code" href="classNumericVector.php">NumericVector</a>&lt;T&gt;
<a name="l00060"></a>00060 {
<a name="l00061"></a>00061 <span class="keyword">public</span>:
<a name="l00062"></a>00062 
<a name="l00066"></a>00066   <span class="keyword">explicit</span>
<a name="l00067"></a>00067   <a class="code" href="classPetscVector.php#accd9e4b0620e70146c98acd76bf08acc">PetscVector</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00068"></a>00068   
<a name="l00072"></a>00072   <span class="keyword">explicit</span>
<a name="l00073"></a>00073   <a class="code" href="classPetscVector.php#accd9e4b0620e70146c98acd76bf08acc">PetscVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00074"></a>00074                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00075"></a>00075     
<a name="l00080"></a>00080   <a class="code" href="classPetscVector.php#accd9e4b0620e70146c98acd76bf08acc">PetscVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00081"></a>00081                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00082"></a>00082                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00083"></a>00083 
<a name="l00089"></a>00089   <a class="code" href="classPetscVector.php#accd9e4b0620e70146c98acd76bf08acc">PetscVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00090"></a>00090                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00091"></a>00091                <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ghost,
<a name="l00092"></a>00092                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00093"></a>00093   
<a name="l00101"></a>00101   <a class="code" href="classPetscVector.php#accd9e4b0620e70146c98acd76bf08acc">PetscVector</a>(Vec v);
<a name="l00102"></a>00102   
<a name="l00107"></a>00107   <a class="code" href="classPetscVector.php#a5496c6d5e3b99e3c25add943e146ca74">~PetscVector</a> ();
<a name="l00108"></a>00108 
<a name="l00112"></a>00112   <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#aba0946fa812f249899f4ab12c0cf330c">close</a> (); 
<a name="l00113"></a>00113 
<a name="l00117"></a>00117   <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#ad4de19d50b21db4ab42b53f7f0c91d5e">clear</a> ();
<a name="l00118"></a>00118   
<a name="l00123"></a>00123   <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#aa3a5327659ceca09ef72aff5e386d783">zero</a> ();    
<a name="l00124"></a>00124 
<a name="l00128"></a>00128   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classPetscVector.php#adc539452a46b6608ee69cdbc012c40dd">clone</a> () <span class="keyword">const</span>;
<a name="l00129"></a>00129   
<a name="l00143"></a>00143   <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a3fd30539f0c928870c71d19c0d6a8dcb">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00144"></a>00144              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00145"></a>00145              <span class="keyword">const</span> <span class="keywordtype">bool</span>         fast=<span class="keyword">false</span>,
<a name="l00146"></a>00146              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a>=<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00147"></a>00147     
<a name="l00151"></a>00151   <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a3fd30539f0c928870c71d19c0d6a8dcb">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00152"></a>00152              <span class="keyword">const</span> <span class="keywordtype">bool</span>         fast=<span class="keyword">false</span>,
<a name="l00153"></a>00153              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a>=<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00154"></a>00154     
<a name="l00159"></a>00159   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a3fd30539f0c928870c71d19c0d6a8dcb">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*N*/</span>,
<a name="l00160"></a>00160                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*n_local*/</span>,
<a name="l00161"></a>00161                      <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <span class="comment">/*ghost*/</span>,
<a name="l00162"></a>00162                      <span class="keyword">const</span> <span class="keywordtype">bool</span> <span class="comment">/*fast*/</span> = <span class="keyword">false</span>,
<a name="l00163"></a>00163                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00164"></a>00164 
<a name="l00169"></a>00169   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a3fd30539f0c928870c71d19c0d6a8dcb">init</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; other,
<a name="l00170"></a>00170                      <span class="keyword">const</span> <span class="keywordtype">bool</span> fast = <span class="keyword">false</span>);
<a name="l00171"></a>00171 
<a name="l00172"></a>00172   <span class="comment">//   /**</span>
<a name="l00173"></a>00173   <span class="comment">//    * Change the dimension to that of the</span>
<a name="l00174"></a>00174   <span class="comment">//    * vector \p V. The same applies as for</span>
<a name="l00175"></a>00175   <span class="comment">//    * the other \p init function.</span>
<a name="l00176"></a>00176   <span class="comment">//    *</span>
<a name="l00177"></a>00177   <span class="comment">//    * The elements of \p V are not copied, i.e.</span>
<a name="l00178"></a>00178   <span class="comment">//    * this function is the same as calling</span>
<a name="l00179"></a>00179   <span class="comment">//    * \p init(V.size(),fast).</span>
<a name="l00180"></a>00180   <span class="comment">//    */</span>
<a name="l00181"></a>00181   <span class="comment">//   void init (const NumericVector&lt;T&gt;&amp; V,</span>
<a name="l00182"></a>00182   <span class="comment">//         const bool fast=false);</span>
<a name="l00183"></a>00183 
<a name="l00187"></a>00187   <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classPetscVector.php#a57f5cf6a82f2f4074d233c5dca606c07">operator= </a>(<span class="keyword">const</span> T s);
<a name="l00188"></a>00188     
<a name="l00192"></a>00192   <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classPetscVector.php#a57f5cf6a82f2f4074d233c5dca606c07">operator= </a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00193"></a>00193 
<a name="l00197"></a>00197   <a class="code" href="classPetscVector.php">PetscVector&lt;T&gt;</a> &amp; <a class="code" href="classPetscVector.php#a57f5cf6a82f2f4074d233c5dca606c07">operator= </a>(<span class="keyword">const</span> <a class="code" href="classPetscVector.php">PetscVector&lt;T&gt;</a> &amp;V);
<a name="l00198"></a>00198 
<a name="l00202"></a>00202   <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classPetscVector.php#a57f5cf6a82f2f4074d233c5dca606c07">operator= </a>(<span class="keyword">const</span> std::vector&lt;T&gt; &amp;v);
<a name="l00203"></a>00203 
<a name="l00209"></a>00209   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classPetscVector.php#ab4ee98dedd8a24a29f1dfdb4c70f9a88">min</a> () <span class="keyword">const</span>;
<a name="l00210"></a>00210   
<a name="l00216"></a>00216   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classPetscVector.php#ad988e64253142460da77e96bf38c32bd">max</a> () <span class="keyword">const</span>;
<a name="l00217"></a>00217 
<a name="l00221"></a>00221   T <a class="code" href="classPetscVector.php#ae41815663a90c640f988bd36237a2e72">sum</a> () <span class="keyword">const</span>;
<a name="l00222"></a>00222 
<a name="l00227"></a>00227   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classPetscVector.php#a129c02c94a64d08dbbe8ea3cecca862e">l1_norm</a> () <span class="keyword">const</span>;
<a name="l00228"></a>00228 
<a name="l00234"></a>00234   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classPetscVector.php#af5333cdfb6a6cdb3d9f8e166c72b5e4d">l2_norm</a> () <span class="keyword">const</span>;
<a name="l00235"></a>00235 
<a name="l00241"></a>00241   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classPetscVector.php#aeb83c80652fb399632c691da5e7a89f1">linfty_norm</a> () <span class="keyword">const</span>;
<a name="l00242"></a>00242 
<a name="l00250"></a>00250   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscVector.php#a747bd947cd27e9f9078996317eca1435">size</a> () <span class="keyword">const</span>;
<a name="l00251"></a>00251 
<a name="l00256"></a>00256   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscVector.php#ad02e5b2ee7848b67656c8b8d0fb93d29">local_size</a>() <span class="keyword">const</span>;
<a name="l00257"></a>00257 
<a name="l00262"></a>00262   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscVector.php#a88263bbdfcbc00e7d9bc1ba6f7bf14b7">first_local_index</a>() <span class="keyword">const</span>;
<a name="l00263"></a>00263 
<a name="l00268"></a>00268   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscVector.php#a18235e29a767ceb13571292466d81633">last_local_index</a>() <span class="keyword">const</span>;
<a name="l00269"></a>00269 
<a name="l00276"></a>00276   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscVector.php#acc26b868ae94928475a985efd7a7d818">map_global_to_local_index</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00277"></a>00277     
<a name="l00281"></a>00281   T <a class="code" href="classPetscVector.php#aede4693867bc977a2021d9af57085af6">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00282"></a>00282     
<a name="l00288"></a>00288   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <span class="keyword">get</span>(<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; index, std::vector&lt;T&gt;&amp; values) <span class="keyword">const</span>;
<a name="l00289"></a>00289 
<a name="l00294"></a>00294   <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classPetscVector.php#acf627f7540308b0af1e243719d642e09">operator += </a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00295"></a>00295 
<a name="l00300"></a>00300   <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classPetscVector.php#a481893960afa07f62165d4d67a70fe0d">operator -= </a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00301"></a>00301     
<a name="l00305"></a>00305   <span class="keywordtype">void</span> <span class="keyword">set</span> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value);
<a name="l00306"></a>00306     
<a name="l00310"></a>00310   <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#ae3cf849bc001332f1713465820160a37">add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value);
<a name="l00311"></a>00311     
<a name="l00317"></a>00317   <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#ae3cf849bc001332f1713465820160a37">add</a> (<span class="keyword">const</span> T s);
<a name="l00318"></a>00318     
<a name="l00324"></a>00324   <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#ae3cf849bc001332f1713465820160a37">add</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; V);
<a name="l00325"></a>00325 
<a name="l00331"></a>00331   <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#ae3cf849bc001332f1713465820160a37">add</a> (<span class="keyword">const</span> T a, <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v);
<a name="l00332"></a>00332   
<a name="l00338"></a>00338   <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#ab7b4b238110371383e1ed231b0e19f06">add_vector</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00339"></a>00339                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00340"></a>00340 
<a name="l00347"></a>00347   <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#ab7b4b238110371383e1ed231b0e19f06">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00348"></a>00348                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00349"></a>00349 
<a name="l00350"></a>00350 
<a name="l00355"></a>00355   <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#ab7b4b238110371383e1ed231b0e19f06">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;V,
<a name="l00356"></a>00356                    <span class="keyword">const</span> <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;A);
<a name="l00357"></a>00357      
<a name="l00364"></a>00364   <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#ab7b4b238110371383e1ed231b0e19f06">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00365"></a>00365                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00366"></a>00366   
<a name="l00371"></a>00371   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a7d5a14901dce0444b2f0bb06e8c55d9a">insert</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00372"></a>00372                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00373"></a>00373 
<a name="l00380"></a>00380   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a7d5a14901dce0444b2f0bb06e8c55d9a">insert</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00381"></a>00381                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00382"></a>00382       
<a name="l00388"></a>00388   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a7d5a14901dce0444b2f0bb06e8c55d9a">insert</a> (<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00389"></a>00389                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00390"></a>00390     
<a name="l00396"></a>00396   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a7d5a14901dce0444b2f0bb06e8c55d9a">insert</a> (<span class="keyword">const</span> <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;T&gt;</a>&amp; V,
<a name="l00397"></a>00397                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00398"></a>00398     
<a name="l00399"></a>00399   
<a name="l00404"></a>00404   <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a5454fd88c6eb9f18e70695fcef802b4e">scale</a> (<span class="keyword">const</span> T factor);
<a name="l00405"></a>00405 
<a name="l00410"></a>00410   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a0a1750f3ce9e63ec4ca3bbe573caa5fe">abs</a>();
<a name="l00411"></a>00411 
<a name="l00415"></a>00415   <span class="keyword">virtual</span> T <a class="code" href="classPetscVector.php#a663ca116522987a9cf28c7880c1a51ea">dot</a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; V) <span class="keyword">const</span>;
<a name="l00416"></a>00416   
<a name="l00421"></a>00421   <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a985f76bcdd29bcefc3a33605c7d9048c">localize</a> (std::vector&lt;T&gt;&amp; v_local) <span class="keyword">const</span>;
<a name="l00422"></a>00422 
<a name="l00427"></a>00427   <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a985f76bcdd29bcefc3a33605c7d9048c">localize</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local) <span class="keyword">const</span>;
<a name="l00428"></a>00428 
<a name="l00434"></a>00434   <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a985f76bcdd29bcefc3a33605c7d9048c">localize</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local,
<a name="l00435"></a>00435                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list) <span class="keyword">const</span>;
<a name="l00436"></a>00436   
<a name="l00441"></a>00441   <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a985f76bcdd29bcefc3a33605c7d9048c">localize</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_idx,
<a name="l00442"></a>00442                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> last_local_idx,
<a name="l00443"></a>00443                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list);
<a name="l00444"></a>00444   
<a name="l00451"></a>00451   <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a8c5251964dabcb6cc9f471c91eb4c8a1">localize_to_one</a> (std::vector&lt;T&gt;&amp; v_local,
<a name="l00452"></a>00452                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id=0) <span class="keyword">const</span>;
<a name="l00453"></a>00453   
<a name="l00458"></a>00458   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a943ec3cf3239422b166cbcd0d32db5dc">pointwise_mult</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec1,
<a name="l00459"></a>00459                                <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec2);
<a name="l00460"></a>00460 
<a name="l00467"></a>00467   <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#afcdd8bfc7db3265bf1ae261ba5caa9c1">print_matlab</a>(<span class="keyword">const</span> std::string <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>=<span class="stringliteral">&quot;NULL&quot;</span>) <span class="keyword">const</span>;
<a name="l00468"></a>00468 
<a name="l00473"></a>00473   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a6cb9e54510fadf55669efe1ea72c9d57">create_subvector</a>(<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; subvector,
<a name="l00474"></a>00474                                 <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; rows) <span class="keyword">const</span>;
<a name="l00475"></a>00475 
<a name="l00479"></a>00479   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a48f45adc6d9ac25db7bc3ae2350b040c">swap</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;v);
<a name="l00480"></a>00480 
<a name="l00486"></a><a class="code" href="classPetscVector.php#ada77db22640adec265059dd445404f6d">00486</a>   Vec <a class="code" href="classPetscVector.php#ada77db22640adec265059dd445404f6d">vec</a> () { libmesh_assert (<a class="code" href="classPetscVector.php#a18bff810e6db4070a4a49c3745476782">_vec</a> != NULL); <span class="keywordflow">return</span> <a class="code" href="classPetscVector.php#a18bff810e6db4070a4a49c3745476782">_vec</a>; }
<a name="l00487"></a>00487 
<a name="l00488"></a>00488 
<a name="l00489"></a>00489   
<a name="l00490"></a>00490 <span class="keyword">private</span>:
<a name="l00491"></a>00491 
<a name="l00496"></a><a class="code" href="classPetscVector.php#a18bff810e6db4070a4a49c3745476782">00496</a>   Vec <a class="code" href="classPetscVector.php#a18bff810e6db4070a4a49c3745476782">_vec</a>;
<a name="l00497"></a>00497 
<a name="l00503"></a><a class="code" href="classPetscVector.php#a8b763656ddd5fcf184643d745b2517e3">00503</a>   <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classPetscVector.php#a8b763656ddd5fcf184643d745b2517e3">_array_is_present</a>;
<a name="l00504"></a>00504 
<a name="l00505"></a>00505 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00506"></a>00506 <span class="preprocessor"></span>
<a name="l00511"></a><a class="code" href="classPetscVector.php#a40c5439b37018f484d6d2a838d829201">00511</a>   <span class="keyword">mutable</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscVector.php#a40c5439b37018f484d6d2a838d829201">_local_size</a>;
<a name="l00512"></a>00512 <span class="preprocessor">#endif</span>
<a name="l00513"></a>00513 <span class="preprocessor"></span>
<a name="l00519"></a><a class="code" href="classPetscVector.php#abcdad33e4c1b4408a9134f403f015571">00519</a>   <span class="keyword">mutable</span> Vec <a class="code" href="classPetscVector.php#abcdad33e4c1b4408a9134f403f015571">_local_form</a>;
<a name="l00520"></a>00520 
<a name="l00525"></a><a class="code" href="classPetscVector.php#ad82dfb29d5ad961b12d7fab6eed612db">00525</a>   <span class="keyword">mutable</span> PetscScalar* <a class="code" href="classPetscVector.php#ad82dfb29d5ad961b12d7fab6eed612db">_values</a>;
<a name="l00526"></a>00526 
<a name="l00531"></a>00531   <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#ad09635a12020c8efe6c46fd1117bd9ed">_get_array</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00532"></a>00532 
<a name="l00537"></a>00537   <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a9556fc5c261ed4858490461cadd4f6d0">_restore_array</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00538"></a>00538 
<a name="l00542"></a><a class="code" href="classPetscVector.php#aceba6318e5c52ef1b727e039b5b72593">00542</a>   <span class="keyword">typedef</span> std::map&lt;unsigned int,unsigned int&gt; <a class="code" href="classPetscVector.php#aceba6318e5c52ef1b727e039b5b72593">GlobalToLocalMap</a>;
<a name="l00543"></a>00543 
<a name="l00548"></a><a class="code" href="classPetscVector.php#aef141ae0777f3ed515196c9480142997">00548</a>   <a class="code" href="classPetscVector.php#aceba6318e5c52ef1b727e039b5b72593">GlobalToLocalMap</a> <a class="code" href="classPetscVector.php#aef141ae0777f3ed515196c9480142997">_global_to_local_map</a>;
<a name="l00549"></a>00549 
<a name="l00554"></a><a class="code" href="classPetscVector.php#a2ca3c95b4cb22c77a669df2a9ddeeabe">00554</a>   <span class="keywordtype">bool</span> <a class="code" href="classPetscVector.php#a2ca3c95b4cb22c77a669df2a9ddeeabe">_destroy_vec_on_exit</a>;
<a name="l00555"></a>00555 };
<a name="l00556"></a>00556 
<a name="l00557"></a>00557 
<a name="l00558"></a>00558 <span class="comment">/*----------------------- Inline functions ----------------------------------*/</span>
<a name="l00559"></a>00559 
<a name="l00560"></a>00560 
<a name="l00561"></a>00561 
<a name="l00562"></a>00562 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00563"></a>00563 <span class="keyword">inline</span>
<a name="l00564"></a><a class="code" href="classPetscVector.php#accd9e4b0620e70146c98acd76bf08acc">00564</a> <a class="code" href="classPetscVector.php#accd9e4b0620e70146c98acd76bf08acc">PetscVector&lt;T&gt;::PetscVector</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00565"></a>00565   : _array_is_present(false),
<a name="l00566"></a>00566     _local_form(NULL),
<a name="l00567"></a>00567     _values(NULL),
<a name="l00568"></a>00568     _global_to_local_map(),
<a name="l00569"></a>00569     _destroy_vec_on_exit(true)
<a name="l00570"></a>00570 {
<a name="l00571"></a>00571   this-&gt;<a class="code" href="classNumericVector.php#a26410625410635a53bf754077ff88173">_type</a> = <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a>;
<a name="l00572"></a>00572 }
<a name="l00573"></a>00573 
<a name="l00574"></a>00574 
<a name="l00575"></a>00575 
<a name="l00576"></a>00576 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00577"></a>00577 <span class="keyword">inline</span>
<a name="l00578"></a><a class="code" href="classPetscVector.php#ae9c66f12938fc9c48f18cc4fbc6b0bac">00578</a> <a class="code" href="classPetscVector.php#accd9e4b0620e70146c98acd76bf08acc">PetscVector&lt;T&gt;::PetscVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00579"></a>00579                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00580"></a>00580   : _array_is_present(false),
<a name="l00581"></a>00581     _local_form(NULL),
<a name="l00582"></a>00582     _values(NULL),
<a name="l00583"></a>00583     _global_to_local_map(),
<a name="l00584"></a>00584     _destroy_vec_on_exit(true)
<a name="l00585"></a>00585 {
<a name="l00586"></a>00586   this-&gt;<a class="code" href="classPetscVector.php#a3fd30539f0c928870c71d19c0d6a8dcb">init</a>(n, n, <span class="keyword">false</span>, type);
<a name="l00587"></a>00587 }
<a name="l00588"></a>00588 
<a name="l00589"></a>00589 
<a name="l00590"></a>00590 
<a name="l00591"></a>00591 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00592"></a>00592 <span class="keyword">inline</span>
<a name="l00593"></a><a class="code" href="classPetscVector.php#abf328bef594a746f5a5608d17ee1b00a">00593</a> <a class="code" href="classPetscVector.php#accd9e4b0620e70146c98acd76bf08acc">PetscVector&lt;T&gt;::PetscVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00594"></a>00594                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00595"></a>00595                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00596"></a>00596   : _array_is_present(false),
<a name="l00597"></a>00597     _local_form(NULL),
<a name="l00598"></a>00598     _values(NULL),
<a name="l00599"></a>00599     _global_to_local_map(),
<a name="l00600"></a>00600     _destroy_vec_on_exit(true)
<a name="l00601"></a>00601 {
<a name="l00602"></a>00602   this-&gt;<a class="code" href="classPetscVector.php#a3fd30539f0c928870c71d19c0d6a8dcb">init</a>(n, n_local, <span class="keyword">false</span>, type);
<a name="l00603"></a>00603 }
<a name="l00604"></a>00604 
<a name="l00605"></a>00605 
<a name="l00606"></a>00606 
<a name="l00607"></a>00607 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00608"></a>00608 <span class="keyword">inline</span>
<a name="l00609"></a><a class="code" href="classPetscVector.php#ad09b77c1f757ef45985f1e665e796e2f">00609</a> <a class="code" href="classPetscVector.php#accd9e4b0620e70146c98acd76bf08acc">PetscVector&lt;T&gt;::PetscVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00610"></a>00610                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00611"></a>00611                              <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ghost,
<a name="l00612"></a>00612                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00613"></a>00613   : _array_is_present(false),
<a name="l00614"></a>00614     _local_form(NULL),
<a name="l00615"></a>00615     _values(NULL),
<a name="l00616"></a>00616     _global_to_local_map(),
<a name="l00617"></a>00617     _destroy_vec_on_exit(true)
<a name="l00618"></a>00618 {
<a name="l00619"></a>00619   this-&gt;<a class="code" href="classPetscVector.php#a3fd30539f0c928870c71d19c0d6a8dcb">init</a>(n, n_local, ghost, <span class="keyword">false</span>, type);
<a name="l00620"></a>00620 }
<a name="l00621"></a>00621 
<a name="l00622"></a>00622 
<a name="l00623"></a>00623 
<a name="l00624"></a>00624 
<a name="l00625"></a>00625 
<a name="l00626"></a>00626 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00627"></a>00627 <span class="keyword">inline</span>
<a name="l00628"></a><a class="code" href="classPetscVector.php#af5d6cc2ea6ab47dd0a039b0e8021571d">00628</a> <a class="code" href="classPetscVector.php#accd9e4b0620e70146c98acd76bf08acc">PetscVector&lt;T&gt;::PetscVector</a> (Vec v)
<a name="l00629"></a>00629   : _array_is_present(false),
<a name="l00630"></a>00630     _local_form(NULL),
<a name="l00631"></a>00631     _values(NULL),
<a name="l00632"></a>00632     _global_to_local_map(),
<a name="l00633"></a>00633     _destroy_vec_on_exit(false)
<a name="l00634"></a>00634 {
<a name="l00635"></a>00635   this-&gt;<a class="code" href="classPetscVector.php#a18bff810e6db4070a4a49c3745476782">_vec</a> = v;
<a name="l00636"></a>00636   this-&gt;<a class="code" href="classNumericVector.php#a5fb110426b9570de8690d317424a310b">_is_closed</a> = <span class="keyword">true</span>;
<a name="l00637"></a>00637   this-&gt;<a class="code" href="classNumericVector.php#ac4a667077b6ec42b9a35a9aed43fc92e">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00638"></a>00638 
<a name="l00639"></a>00639   <span class="comment">/* We need to ask PETSc about the (local to global) ghost value</span>
<a name="l00640"></a>00640 <span class="comment">     mapping and create the inverse mapping out of it.  */</span>
<a name="l00641"></a>00641   <span class="keywordtype">int</span> ierr=0, petsc_size=0, petsc_local_size=0;
<a name="l00642"></a>00642   ierr = VecGetSize(<a class="code" href="classPetscVector.php#a18bff810e6db4070a4a49c3745476782">_vec</a>, &amp;petsc_size);
<a name="l00643"></a>00643   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00644"></a>00644   ierr = VecGetLocalSize(<a class="code" href="classPetscVector.php#a18bff810e6db4070a4a49c3745476782">_vec</a>, &amp;petsc_local_size);
<a name="l00645"></a>00645   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00646"></a>00646 
<a name="l00647"></a>00647   <span class="comment">/* \p petsc_local_size is the number of non-ghost values.  If it</span>
<a name="l00648"></a>00648 <span class="comment">     equals the global size, then we are a serial vector, and there</span>
<a name="l00649"></a>00649 <span class="comment">     are no ghost values.  */</span>
<a name="l00650"></a>00650   <span class="keywordflow">if</span>(petsc_size!=petsc_local_size)
<a name="l00651"></a>00651     {
<a name="l00652"></a>00652       ISLocalToGlobalMapping mapping = <a class="code" href="classPetscVector.php#a18bff810e6db4070a4a49c3745476782">_vec</a>-&gt;mapping;
<a name="l00653"></a>00653 
<a name="l00654"></a>00654       <span class="comment">// If is a sparsely stored vector, set up our new mapping</span>
<a name="l00655"></a>00655       <span class="keywordflow">if</span> (mapping)
<a name="l00656"></a>00656         {
<a name="l00657"></a>00657           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscVector.php#ad02e5b2ee7848b67656c8b8d0fb93d29">local_size</a> = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_local_size);
<a name="l00658"></a>00658           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ghost_begin = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_local_size);
<a name="l00659"></a>00659           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ghost_end = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(mapping-&gt;n);
<a name="l00660"></a>00660           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=ghost_begin; i&lt;ghost_end; i++)
<a name="l00661"></a>00661             <a class="code" href="classPetscVector.php#aef141ae0777f3ed515196c9480142997">_global_to_local_map</a>[mapping-&gt;indices[i]] = i-local_size;
<a name="l00662"></a>00662           this-&gt;_type = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>;
<a name="l00663"></a>00663         }
<a name="l00664"></a>00664       <span class="keywordflow">else</span>
<a name="l00665"></a>00665         this-&gt;<a class="code" href="classNumericVector.php#a26410625410635a53bf754077ff88173">_type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>;
<a name="l00666"></a>00666     }
<a name="l00667"></a>00667   <span class="keywordflow">else</span>
<a name="l00668"></a>00668     this-&gt;<a class="code" href="classNumericVector.php#a26410625410635a53bf754077ff88173">_type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>;
<a name="l00669"></a>00669 
<a name="l00670"></a>00670 }
<a name="l00671"></a>00671 
<a name="l00672"></a>00672 
<a name="l00673"></a>00673 
<a name="l00674"></a>00674 
<a name="l00675"></a>00675 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00676"></a>00676 <span class="keyword">inline</span>
<a name="l00677"></a><a class="code" href="classPetscVector.php#a5496c6d5e3b99e3c25add943e146ca74">00677</a> <a class="code" href="classPetscVector.php#a5496c6d5e3b99e3c25add943e146ca74">PetscVector&lt;T&gt;::~PetscVector</a> ()
<a name="l00678"></a>00678 {
<a name="l00679"></a>00679   this-&gt;clear ();
<a name="l00680"></a>00680 }
<a name="l00681"></a>00681 
<a name="l00682"></a>00682 
<a name="l00683"></a>00683 
<a name="l00684"></a>00684 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00685"></a>00685 <span class="keyword">inline</span>
<a name="l00686"></a><a class="code" href="classPetscVector.php#a3fd30539f0c928870c71d19c0d6a8dcb">00686</a> <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a3fd30539f0c928870c71d19c0d6a8dcb">PetscVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00687"></a>00687                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00688"></a>00688                            <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00689"></a>00689                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00690"></a>00690 {
<a name="l00691"></a>00691   <span class="keywordtype">int</span> ierr=0;
<a name="l00692"></a>00692   <span class="keywordtype">int</span> petsc_n=<span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n);
<a name="l00693"></a>00693   <span class="keywordtype">int</span> petsc_n_local=<span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n_local);
<a name="l00694"></a>00694 
<a name="l00695"></a>00695 
<a name="l00696"></a>00696   <span class="comment">// Clear initialized vectors </span>
<a name="l00697"></a>00697   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00698"></a>00698     this-&gt;clear();
<a name="l00699"></a>00699 
<a name="l00700"></a>00700   <span class="keywordflow">if</span> (type == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>)
<a name="l00701"></a>00701     {
<a name="l00702"></a>00702       <span class="keywordflow">if</span> (n == n_local)
<a name="l00703"></a>00703         this-&gt;_type = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>;
<a name="l00704"></a>00704       <span class="keywordflow">else</span>
<a name="l00705"></a>00705         this-&gt;_type = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>;
<a name="l00706"></a>00706     }
<a name="l00707"></a>00707   <span class="keywordflow">else</span>
<a name="l00708"></a>00708     this-&gt;_type = type;
<a name="l00709"></a>00709 
<a name="l00710"></a>00710   libmesh_assert ((this-&gt;_type==<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a> &amp;&amp; n==n_local) ||
<a name="l00711"></a>00711                   this-&gt;_type==<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>);
<a name="l00712"></a>00712   
<a name="l00713"></a>00713   <span class="comment">// create a sequential vector if on only 1 processor </span>
<a name="l00714"></a>00714   <span class="keywordflow">if</span> (this-&gt;_type == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>)
<a name="l00715"></a>00715     {
<a name="l00716"></a>00716       ierr = VecCreateSeq (PETSC_COMM_SELF, petsc_n, &amp;_vec);
<a name="l00717"></a>00717              CHKERRABORT(PETSC_COMM_SELF,ierr);
<a name="l00718"></a>00718       
<a name="l00719"></a>00719       ierr = VecSetFromOptions (_vec);
<a name="l00720"></a>00720              CHKERRABORT(PETSC_COMM_SELF,ierr);
<a name="l00721"></a>00721     }
<a name="l00722"></a>00722   <span class="comment">// otherwise create an MPI-enabled vector</span>
<a name="l00723"></a>00723   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (this-&gt;_type == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>)
<a name="l00724"></a>00724     {
<a name="l00725"></a>00725       libmesh_assert (n_local &lt;= n);
<a name="l00726"></a>00726       
<a name="l00727"></a>00727       ierr = VecCreateMPI (<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>, petsc_n_local, petsc_n,
<a name="l00728"></a>00728                            &amp;_vec);
<a name="l00729"></a>00729              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00730"></a>00730       
<a name="l00731"></a>00731       ierr = VecSetFromOptions (_vec);
<a name="l00732"></a>00732              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00733"></a>00733     }  
<a name="l00734"></a>00734   <span class="keywordflow">else</span>
<a name="l00735"></a>00735     libmesh_error();
<a name="l00736"></a>00736   
<a name="l00737"></a>00737   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00738"></a>00738 <span class="comment">//  this-&gt;_is_closed = true;</span>
<a name="l00739"></a>00739   
<a name="l00740"></a>00740   
<a name="l00741"></a>00741   <span class="keywordflow">if</span> (fast == <span class="keyword">false</span>)
<a name="l00742"></a>00742     this-&gt;<a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a> ();
<a name="l00743"></a>00743 }
<a name="l00744"></a>00744 
<a name="l00745"></a>00745 
<a name="l00746"></a>00746 
<a name="l00747"></a>00747 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00748"></a>00748 <span class="keyword">inline</span>
<a name="l00749"></a><a class="code" href="classPetscVector.php#a2be57f122f4d44f99bf7ed4584a3e874">00749</a> <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a3fd30539f0c928870c71d19c0d6a8dcb">PetscVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00750"></a>00750                            <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00751"></a>00751                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00752"></a>00752 {
<a name="l00753"></a>00753   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(n,n,fast,type);
<a name="l00754"></a>00754 }
<a name="l00755"></a>00755 
<a name="l00756"></a>00756 
<a name="l00757"></a>00757 
<a name="l00758"></a>00758 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00759"></a>00759 <span class="keyword">inline</span>
<a name="l00760"></a><a class="code" href="classPetscVector.php#aefcc2a367a4130764b91000ed3f7f72e">00760</a> <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a3fd30539f0c928870c71d19c0d6a8dcb">PetscVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00761"></a>00761                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00762"></a>00762                            <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ghost,
<a name="l00763"></a>00763                            <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00764"></a>00764                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00765"></a>00765 {
<a name="l00766"></a>00766   <span class="keywordtype">int</span> ierr=0;
<a name="l00767"></a>00767   <span class="keywordtype">int</span> petsc_n=<span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n);
<a name="l00768"></a>00768   <span class="keywordtype">int</span> petsc_n_local=<span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n_local);
<a name="l00769"></a>00769   <span class="keywordtype">int</span> petsc_n_ghost=<span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(ghost.size());
<a name="l00770"></a>00770 
<a name="l00771"></a>00771   <span class="comment">// If the mesh is disjoint, the following assertion will fail.</span>
<a name="l00772"></a>00772   <span class="comment">// If the mesh is not disjoint, every processor will either have</span>
<a name="l00773"></a>00773   <span class="comment">// all the dofs, none of the dofs, or some non-zero dofs at the</span>
<a name="l00774"></a>00774   <span class="comment">// boundary between processors.</span>
<a name="l00775"></a>00775   libmesh_assert(n_local == 0 || n_local == n || !ghost.empty());
<a name="l00776"></a>00776 
<a name="l00777"></a>00777   <span class="keywordtype">int</span>* petsc_ghost = ghost.empty() ? PETSC_NULL :
<a name="l00778"></a>00778     <span class="keyword">const_cast&lt;</span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(<span class="keyword">reinterpret_cast&lt;</span><span class="keyword">const </span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(&amp;ghost[0]));
<a name="l00779"></a>00779 
<a name="l00780"></a>00780   <span class="comment">// Clear initialized vectors </span>
<a name="l00781"></a>00781   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00782"></a>00782     this-&gt;clear();
<a name="l00783"></a>00783 
<a name="l00784"></a>00784   libmesh_assert(type == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a> || type == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>);
<a name="l00785"></a>00785   this-&gt;_type = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>;
<a name="l00786"></a>00786 
<a name="l00787"></a>00787   <span class="comment">/* Make the global-to-local ghost cell map.  */</span>
<a name="l00788"></a>00788   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;ghost.size(); i++)
<a name="l00789"></a>00789     {
<a name="l00790"></a>00790       _global_to_local_map[ghost[i]] = i;
<a name="l00791"></a>00791     }
<a name="l00792"></a>00792 
<a name="l00793"></a>00793   <span class="comment">/* Create vector.  */</span>
<a name="l00794"></a>00794   ierr = VecCreateGhost (<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>, petsc_n_local, petsc_n,
<a name="l00795"></a>00795                          petsc_n_ghost, petsc_ghost,
<a name="l00796"></a>00796                          &amp;_vec);
<a name="l00797"></a>00797   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00798"></a>00798   
<a name="l00799"></a>00799   ierr = VecSetFromOptions (_vec);
<a name="l00800"></a>00800   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00801"></a>00801   
<a name="l00802"></a>00802   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00803"></a>00803 <span class="comment">//  this-&gt;_is_closed = true;</span>
<a name="l00804"></a>00804   
<a name="l00805"></a>00805   <span class="keywordflow">if</span> (fast == <span class="keyword">false</span>)
<a name="l00806"></a>00806     this-&gt;<a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a> ();
<a name="l00807"></a>00807 }
<a name="l00808"></a>00808 
<a name="l00809"></a>00809 
<a name="l00810"></a>00810 
<a name="l00811"></a>00811 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00812"></a>00812 <span class="keyword">inline</span>
<a name="l00813"></a><a class="code" href="classPetscVector.php#ace9bd976a6444257484a84cdaaf4a1b0">00813</a> <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a3fd30539f0c928870c71d19c0d6a8dcb">PetscVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; other,
<a name="l00814"></a>00814                            <span class="keyword">const</span> <span class="keywordtype">bool</span> fast)
<a name="l00815"></a>00815 {
<a name="l00816"></a>00816   <span class="comment">// Clear initialized vectors </span>
<a name="l00817"></a>00817   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00818"></a>00818     this-&gt;clear();
<a name="l00819"></a>00819 
<a name="l00820"></a>00820   <span class="keyword">const</span> <a class="code" href="classPetscVector.php">PetscVector&lt;T&gt;</a>&amp; v = libmesh_cast_ref&lt;const PetscVector&lt;T&gt;&amp;&gt;(other);
<a name="l00821"></a>00821 
<a name="l00822"></a>00822   <span class="comment">// Other vector should restore array.</span>
<a name="l00823"></a>00823   <span class="keywordflow">if</span>(v.<a class="code" href="classNumericVector.php#a43085d102bac085751371d1a94b5dea9">initialized</a>())
<a name="l00824"></a>00824     {
<a name="l00825"></a>00825       v.<a class="code" href="classPetscVector.php#a9556fc5c261ed4858490461cadd4f6d0">_restore_array</a>();
<a name="l00826"></a>00826     }
<a name="l00827"></a>00827 
<a name="l00828"></a>00828   this-&gt;_global_to_local_map = v.<a class="code" href="classPetscVector.php#aef141ae0777f3ed515196c9480142997">_global_to_local_map</a>;
<a name="l00829"></a>00829   this-&gt;_is_closed      = v.<a class="code" href="classNumericVector.php#a5fb110426b9570de8690d317424a310b">_is_closed</a>;
<a name="l00830"></a>00830   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = v.<a class="code" href="classNumericVector.php#ac4a667077b6ec42b9a35a9aed43fc92e">_is_initialized</a>;
<a name="l00831"></a>00831   this-&gt;_type = v.<a class="code" href="classNumericVector.php#a26410625410635a53bf754077ff88173">_type</a>;
<a name="l00832"></a>00832 
<a name="l00833"></a>00833   <span class="keywordflow">if</span> (v.<a class="code" href="classPetscVector.php#a747bd947cd27e9f9078996317eca1435">size</a>() != 0)
<a name="l00834"></a>00834     {
<a name="l00835"></a>00835       <span class="keywordtype">int</span> ierr = 0;
<a name="l00836"></a>00836 
<a name="l00837"></a>00837       ierr = VecDuplicate (v.<a class="code" href="classPetscVector.php#a18bff810e6db4070a4a49c3745476782">_vec</a>, &amp;this-&gt;_vec);
<a name="l00838"></a>00838       CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00839"></a>00839     }
<a name="l00840"></a>00840   
<a name="l00841"></a>00841   <span class="keywordflow">if</span> (fast == <span class="keyword">false</span>)
<a name="l00842"></a>00842     this-&gt;<a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a> ();
<a name="l00843"></a>00843 }
<a name="l00844"></a>00844 
<a name="l00845"></a>00845 
<a name="l00846"></a>00846 
<a name="l00847"></a>00847 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00848"></a>00848 <span class="keyword">inline</span>
<a name="l00849"></a><a class="code" href="classPetscVector.php#aba0946fa812f249899f4ab12c0cf330c">00849</a> <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#aba0946fa812f249899f4ab12c0cf330c">PetscVector&lt;T&gt;::close</a> ()
<a name="l00850"></a>00850 {
<a name="l00851"></a>00851   this-&gt;_restore_array();
<a name="l00852"></a>00852   
<a name="l00853"></a>00853   <span class="keywordtype">int</span> ierr=0;
<a name="l00854"></a>00854   
<a name="l00855"></a>00855   ierr = VecAssemblyBegin(_vec);
<a name="l00856"></a>00856   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00857"></a>00857   ierr = VecAssemblyEnd(_vec);
<a name="l00858"></a>00858   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00859"></a>00859 
<a name="l00860"></a>00860   <span class="keywordflow">if</span>(this-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l00861"></a>00861     {
<a name="l00862"></a>00862       ierr = VecGhostUpdateBegin(_vec,INSERT_VALUES,SCATTER_FORWARD);
<a name="l00863"></a>00863       CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00864"></a>00864       ierr = VecGhostUpdateEnd(_vec,INSERT_VALUES,SCATTER_FORWARD);
<a name="l00865"></a>00865       CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00866"></a>00866     }
<a name="l00867"></a>00867 
<a name="l00868"></a>00868   this-&gt;_is_closed = <span class="keyword">true</span>;
<a name="l00869"></a>00869 }
<a name="l00870"></a>00870 
<a name="l00871"></a>00871 
<a name="l00872"></a>00872 
<a name="l00873"></a>00873 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00874"></a>00874 <span class="keyword">inline</span>
<a name="l00875"></a><a class="code" href="classPetscVector.php#ad4de19d50b21db4ab42b53f7f0c91d5e">00875</a> <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#ad4de19d50b21db4ab42b53f7f0c91d5e">PetscVector&lt;T&gt;::clear</a> ()
<a name="l00876"></a>00876 {
<a name="l00877"></a>00877   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00878"></a>00878     this-&gt;_restore_array();
<a name="l00879"></a>00879 
<a name="l00880"></a>00880   <span class="keywordflow">if</span> ((this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>()) &amp;&amp; (this-&gt;_destroy_vec_on_exit))
<a name="l00881"></a>00881     {
<a name="l00882"></a>00882       <span class="keywordtype">int</span> ierr=0;
<a name="l00883"></a>00883 
<a name="l00884"></a>00884       ierr = VecDestroy(_vec);
<a name="l00885"></a>00885              CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00886"></a>00886     }
<a name="l00887"></a>00887 
<a name="l00888"></a>00888   this-&gt;_is_closed = this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00889"></a>00889 
<a name="l00890"></a>00890   _global_to_local_map.clear();
<a name="l00891"></a>00891 }
<a name="l00892"></a>00892 
<a name="l00893"></a>00893 
<a name="l00894"></a>00894 
<a name="l00895"></a>00895 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00896"></a>00896 <span class="keyword">inline</span>
<a name="l00897"></a><a class="code" href="classPetscVector.php#aa3a5327659ceca09ef72aff5e386d783">00897</a> <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#aa3a5327659ceca09ef72aff5e386d783">PetscVector&lt;T&gt;::zero</a> ()
<a name="l00898"></a>00898 {
<a name="l00899"></a>00899   this-&gt;_restore_array();
<a name="l00900"></a>00900   
<a name="l00901"></a>00901   <span class="keywordtype">int</span> ierr=0;
<a name="l00902"></a>00902 
<a name="l00903"></a>00903   PetscScalar z=0.;
<a name="l00904"></a>00904 
<a name="l00905"></a>00905   <span class="keywordflow">if</span>(this-&gt;type() != <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l00906"></a>00906     {
<a name="l00907"></a>00907 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,0)  </span>
<a name="l00908"></a>00908 <span class="preprocessor"></span>      <span class="comment">// 2.2.x &amp; earlier style</span>
<a name="l00909"></a>00909       ierr = VecSet (&amp;z, _vec);
<a name="l00910"></a>00910       CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00911"></a>00911 <span class="preprocessor">#else</span>
<a name="l00912"></a>00912 <span class="preprocessor"></span>      <span class="comment">// 2.3.x &amp; newer</span>
<a name="l00913"></a>00913       ierr = VecSet (_vec, z);
<a name="l00914"></a>00914       CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00915"></a>00915 <span class="preprocessor">#endif</span>
<a name="l00916"></a>00916 <span class="preprocessor"></span>    }
<a name="l00917"></a>00917   <span class="keywordflow">else</span>
<a name="l00918"></a>00918     {
<a name="l00919"></a>00919       <span class="comment">/* Vectors that include ghost values require a special</span>
<a name="l00920"></a>00920 <span class="comment">         handling.  */</span>
<a name="l00921"></a>00921       Vec loc_vec;
<a name="l00922"></a>00922       ierr = VecGhostGetLocalForm (_vec,&amp;loc_vec);
<a name="l00923"></a>00923       CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00924"></a>00924 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,0)  </span>
<a name="l00925"></a>00925 <span class="preprocessor"></span>      <span class="comment">// 2.2.x &amp; earlier style</span>
<a name="l00926"></a>00926       ierr = VecSet (&amp;z, loc_vec);
<a name="l00927"></a>00927       CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00928"></a>00928 <span class="preprocessor">#else</span>
<a name="l00929"></a>00929 <span class="preprocessor"></span>      <span class="comment">// 2.3.x &amp; newer</span>
<a name="l00930"></a>00930       ierr = VecSet (loc_vec, z);
<a name="l00931"></a>00931       CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00932"></a>00932 <span class="preprocessor">#endif</span>
<a name="l00933"></a>00933 <span class="preprocessor"></span>      ierr = VecGhostRestoreLocalForm (_vec,&amp;loc_vec);
<a name="l00934"></a>00934       CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00935"></a>00935     }
<a name="l00936"></a>00936 }
<a name="l00937"></a>00937 
<a name="l00938"></a>00938 
<a name="l00939"></a>00939 
<a name="l00940"></a>00940 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00941"></a>00941 <span class="keyword">inline</span>
<a name="l00942"></a><a class="code" href="classPetscVector.php#adc539452a46b6608ee69cdbc012c40dd">00942</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classPetscVector.php#adc539452a46b6608ee69cdbc012c40dd">PetscVector&lt;T&gt;::clone</a> ()<span class="keyword"> const</span>
<a name="l00943"></a>00943 <span class="keyword"></span>{
<a name="l00944"></a>00944   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; cloned_vector (<span class="keyword">new</span> <a class="code" href="classPetscVector.php">PetscVector&lt;T&gt;</a>);
<a name="l00945"></a>00945 
<a name="l00946"></a>00946   cloned_vector-&gt;init(*<span class="keyword">this</span>, <span class="keyword">true</span>);
<a name="l00947"></a>00947 
<a name="l00948"></a>00948   *cloned_vector = *<span class="keyword">this</span>;
<a name="l00949"></a>00949 
<a name="l00950"></a>00950   <span class="keywordflow">return</span> cloned_vector;
<a name="l00951"></a>00951 }
<a name="l00952"></a>00952 
<a name="l00953"></a>00953 
<a name="l00954"></a>00954 
<a name="l00955"></a>00955 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00956"></a>00956 <span class="keyword">inline</span>
<a name="l00957"></a><a class="code" href="classPetscVector.php#a747bd947cd27e9f9078996317eca1435">00957</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscVector.php#a747bd947cd27e9f9078996317eca1435">PetscVector&lt;T&gt;::size</a> ()<span class="keyword"> const</span>
<a name="l00958"></a>00958 <span class="keyword"></span>{
<a name="l00959"></a>00959   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00960"></a>00960   
<a name="l00961"></a>00961   <span class="keywordtype">int</span> ierr=0, petsc_size=0;
<a name="l00962"></a>00962   
<a name="l00963"></a>00963   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00964"></a>00964     <span class="keywordflow">return</span> 0;
<a name="l00965"></a>00965   
<a name="l00966"></a>00966   ierr = VecGetSize(_vec, &amp;petsc_size);
<a name="l00967"></a>00967          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00968"></a>00968 
<a name="l00969"></a>00969   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_size);
<a name="l00970"></a>00970 }
<a name="l00971"></a>00971 
<a name="l00972"></a>00972 
<a name="l00973"></a>00973 
<a name="l00974"></a>00974 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00975"></a>00975 <span class="keyword">inline</span>
<a name="l00976"></a><a class="code" href="classPetscVector.php#ad02e5b2ee7848b67656c8b8d0fb93d29">00976</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscVector.php#ad02e5b2ee7848b67656c8b8d0fb93d29">PetscVector&lt;T&gt;::local_size</a> ()<span class="keyword"> const</span>
<a name="l00977"></a>00977 <span class="keyword"></span>{
<a name="l00978"></a>00978   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00979"></a>00979   
<a name="l00980"></a>00980   <span class="keywordtype">int</span> ierr=0, petsc_size=0;
<a name="l00981"></a>00981   
<a name="l00982"></a>00982   ierr = VecGetLocalSize(_vec, &amp;petsc_size);
<a name="l00983"></a>00983          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00984"></a>00984   
<a name="l00985"></a>00985   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_size);
<a name="l00986"></a>00986 }
<a name="l00987"></a>00987 
<a name="l00988"></a>00988 
<a name="l00989"></a>00989 
<a name="l00990"></a>00990 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00991"></a>00991 <span class="keyword">inline</span>
<a name="l00992"></a><a class="code" href="classPetscVector.php#a88263bbdfcbc00e7d9bc1ba6f7bf14b7">00992</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscVector.php#a88263bbdfcbc00e7d9bc1ba6f7bf14b7">PetscVector&lt;T&gt;::first_local_index</a> ()<span class="keyword"> const</span>
<a name="l00993"></a>00993 <span class="keyword"></span>{
<a name="l00994"></a>00994   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00995"></a>00995   
<a name="l00996"></a>00996   <span class="keywordtype">int</span> ierr=0, petsc_first=0, petsc_last=0;
<a name="l00997"></a>00997   
<a name="l00998"></a>00998   ierr = VecGetOwnershipRange (_vec, &amp;petsc_first, &amp;petsc_last);
<a name="l00999"></a>00999          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l01000"></a>01000   
<a name="l01001"></a>01001   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_first);
<a name="l01002"></a>01002 }
<a name="l01003"></a>01003 
<a name="l01004"></a>01004 
<a name="l01005"></a>01005 
<a name="l01006"></a>01006 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01007"></a>01007 <span class="keyword">inline</span>
<a name="l01008"></a><a class="code" href="classPetscVector.php#a18235e29a767ceb13571292466d81633">01008</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscVector.php#a18235e29a767ceb13571292466d81633">PetscVector&lt;T&gt;::last_local_index</a> ()<span class="keyword"> const</span>
<a name="l01009"></a>01009 <span class="keyword"></span>{
<a name="l01010"></a>01010   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l01011"></a>01011   
<a name="l01012"></a>01012   <span class="keywordtype">int</span> ierr=0, petsc_first=0, petsc_last=0;
<a name="l01013"></a>01013   
<a name="l01014"></a>01014   ierr = VecGetOwnershipRange (_vec, &amp;petsc_first, &amp;petsc_last);
<a name="l01015"></a>01015          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l01016"></a>01016   
<a name="l01017"></a>01017   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_last);
<a name="l01018"></a>01018 }
<a name="l01019"></a>01019 
<a name="l01020"></a>01020 
<a name="l01021"></a>01021 
<a name="l01022"></a>01022 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01023"></a>01023 <span class="keyword">inline</span>
<a name="l01024"></a><a class="code" href="classPetscVector.php#acc26b868ae94928475a985efd7a7d818">01024</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscVector.php#acc26b868ae94928475a985efd7a7d818">PetscVector&lt;T&gt;::map_global_to_local_index</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l01025"></a>01025 <span class="keyword"></span>{
<a name="l01026"></a>01026   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l01027"></a>01027 
<a name="l01028"></a>01028   <span class="keywordtype">int</span> ierr=0, petsc_first=0, petsc_last=0;
<a name="l01029"></a>01029   ierr = VecGetOwnershipRange (_vec, &amp;petsc_first, &amp;petsc_last);
<a name="l01030"></a>01030   CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l01031"></a>01031   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_first);
<a name="l01032"></a>01032   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> last = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_last);
<a name="l01033"></a>01033 
<a name="l01034"></a>01034   <span class="keywordflow">if</span>((i&gt;=first) &amp;&amp; (i&lt;last))
<a name="l01035"></a>01035     {
<a name="l01036"></a>01036       <span class="keywordflow">return</span> i-first;
<a name="l01037"></a>01037     }
<a name="l01038"></a>01038 
<a name="l01039"></a>01039   GlobalToLocalMap::const_iterator it = _global_to_local_map.find(i);
<a name="l01040"></a>01040   libmesh_assert (it!=_global_to_local_map.end());
<a name="l01041"></a>01041   <span class="keywordflow">return</span> it-&gt;second+last-first;
<a name="l01042"></a>01042 }
<a name="l01043"></a>01043 
<a name="l01044"></a>01044 
<a name="l01045"></a>01045 
<a name="l01046"></a>01046 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01047"></a>01047 <span class="keyword">inline</span>
<a name="l01048"></a><a class="code" href="classPetscVector.php#aede4693867bc977a2021d9af57085af6">01048</a> T <a class="code" href="classPetscVector.php#aede4693867bc977a2021d9af57085af6">PetscVector&lt;T&gt;::operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l01049"></a>01049 <span class="keyword"></span>{
<a name="l01050"></a>01050   this-&gt;_get_array();
<a name="l01051"></a>01051 
<a name="l01052"></a>01052   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_index = this-&gt;map_global_to_local_index(i);
<a name="l01053"></a>01053 
<a name="l01054"></a>01054 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01055"></a>01055 <span class="preprocessor"></span>  <span class="keywordflow">if</span>(this-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l01056"></a>01056     {
<a name="l01057"></a>01057       libmesh_assert(local_index&lt;_local_size);
<a name="l01058"></a>01058     }
<a name="l01059"></a>01059 <span class="preprocessor">#endif</span>
<a name="l01060"></a>01060 <span class="preprocessor"></span>  
<a name="l01061"></a>01061   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span>T<span class="keyword">&gt;</span>(_values[local_index]);
<a name="l01062"></a>01062 }
<a name="l01063"></a>01063 
<a name="l01064"></a>01064 
<a name="l01065"></a>01065 
<a name="l01066"></a>01066 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01067"></a>01067 <span class="keyword">inline</span>
<a name="l01068"></a><a class="code" href="classPetscVector.php#a10d495d38819cae87c2f72c7a6deca23">01068</a> <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a10d495d38819cae87c2f72c7a6deca23">PetscVector&lt;T&gt;::get</a>(<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; index, std::vector&lt;T&gt;&amp; values)<span class="keyword"> const</span>
<a name="l01069"></a>01069 <span class="keyword"></span>{
<a name="l01070"></a>01070   this-&gt;_get_array();
<a name="l01071"></a>01071 
<a name="l01072"></a>01072   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num = index.size();
<a name="l01073"></a>01073   values.resize(num);
<a name="l01074"></a>01074 
<a name="l01075"></a>01075   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;num; i++)
<a name="l01076"></a>01076     {
<a name="l01077"></a>01077       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_index = this-&gt;map_global_to_local_index(index[i]);
<a name="l01078"></a>01078 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01079"></a>01079 <span class="preprocessor"></span>      <span class="keywordflow">if</span>(this-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l01080"></a>01080         {
<a name="l01081"></a>01081           libmesh_assert(local_index&lt;_local_size);
<a name="l01082"></a>01082         }
<a name="l01083"></a>01083 <span class="preprocessor">#endif</span>
<a name="l01084"></a>01084 <span class="preprocessor"></span>      values[i] = <span class="keyword">static_cast&lt;</span>T<span class="keyword">&gt;</span>(_values[local_index]);
<a name="l01085"></a>01085     }
<a name="l01086"></a>01086 }
<a name="l01087"></a>01087 
<a name="l01088"></a>01088 
<a name="l01089"></a>01089 
<a name="l01090"></a>01090 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01091"></a>01091 <span class="keyword">inline</span>
<a name="l01092"></a><a class="code" href="classPetscVector.php#ab4ee98dedd8a24a29f1dfdb4c70f9a88">01092</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classPetscVector.php#ab4ee98dedd8a24a29f1dfdb4c70f9a88">PetscVector&lt;T&gt;::min</a> ()<span class="keyword"> const</span>
<a name="l01093"></a>01093 <span class="keyword"></span>{
<a name="l01094"></a>01094   this-&gt;_restore_array();
<a name="l01095"></a>01095 
<a name="l01096"></a>01096   <span class="keywordtype">int</span> index=0, ierr=0;
<a name="l01097"></a>01097   PetscReal <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>=0.;
<a name="l01098"></a>01098 
<a name="l01099"></a>01099   ierr = VecMin (_vec, &amp;index, &amp;min);
<a name="l01100"></a>01100          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l01101"></a>01101 
<a name="l01102"></a>01102   <span class="comment">// this return value is correct: VecMin returns a PetscReal</span>
<a name="l01103"></a>01103   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a><span class="keyword">&gt;</span>(<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>);
<a name="l01104"></a>01104 }
<a name="l01105"></a>01105 
<a name="l01106"></a>01106 
<a name="l01107"></a>01107 
<a name="l01108"></a>01108 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01109"></a>01109 <span class="keyword">inline</span>
<a name="l01110"></a><a class="code" href="classPetscVector.php#ad988e64253142460da77e96bf38c32bd">01110</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classPetscVector.php#ad988e64253142460da77e96bf38c32bd">PetscVector&lt;T&gt;::max</a>()<span class="keyword"> const</span>
<a name="l01111"></a>01111 <span class="keyword"></span>{
<a name="l01112"></a>01112   this-&gt;_restore_array();
<a name="l01113"></a>01113 
<a name="l01114"></a>01114   <span class="keywordtype">int</span> index=0, ierr=0;
<a name="l01115"></a>01115   PetscReal <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>=0.;
<a name="l01116"></a>01116 
<a name="l01117"></a>01117   ierr = VecMax (_vec, &amp;index, &amp;max);
<a name="l01118"></a>01118          CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l01119"></a>01119 
<a name="l01120"></a>01120   <span class="comment">// this return value is correct: VecMax returns a PetscReal</span>
<a name="l01121"></a>01121   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a><span class="keyword">&gt;</span>(<a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>);
<a name="l01122"></a>01122 }
<a name="l01123"></a>01123 
<a name="l01124"></a>01124 
<a name="l01125"></a>01125 
<a name="l01126"></a>01126 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01127"></a>01127 <span class="keyword">inline</span>
<a name="l01128"></a><a class="code" href="classPetscVector.php#a48f45adc6d9ac25db7bc3ae2350b040c">01128</a> <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a48f45adc6d9ac25db7bc3ae2350b040c">PetscVector&lt;T&gt;::swap</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;other)
<a name="l01129"></a>01129 {
<a name="l01130"></a>01130   <a class="code" href="classNumericVector.php#a51e2011eeca6faa30e349c1950352eb8">NumericVector&lt;T&gt;::swap</a>(other);
<a name="l01131"></a>01131 
<a name="l01132"></a>01132   <a class="code" href="classPetscVector.php">PetscVector&lt;T&gt;</a>&amp; v = libmesh_cast_ref&lt;PetscVector&lt;T&gt;&amp;&gt;(other);
<a name="l01133"></a>01133 
<a name="l01134"></a>01134   std::swap(_vec, v.<a class="code" href="classPetscVector.php#a18bff810e6db4070a4a49c3745476782">_vec</a>);
<a name="l01135"></a>01135   std::swap(_destroy_vec_on_exit, v.<a class="code" href="classPetscVector.php#a2ca3c95b4cb22c77a669df2a9ddeeabe">_destroy_vec_on_exit</a>);
<a name="l01136"></a>01136   std::swap(_global_to_local_map, v.<a class="code" href="classPetscVector.php#aef141ae0777f3ed515196c9480142997">_global_to_local_map</a>);
<a name="l01137"></a>01137   std::swap(_array_is_present, v.<a class="code" href="classPetscVector.php#a8b763656ddd5fcf184643d745b2517e3">_array_is_present</a>);
<a name="l01138"></a>01138   std::swap(_local_form, v.<a class="code" href="classPetscVector.php#abcdad33e4c1b4408a9134f403f015571">_local_form</a>);
<a name="l01139"></a>01139   std::swap(_values, v.<a class="code" href="classPetscVector.php#ad82dfb29d5ad961b12d7fab6eed612db">_values</a>);
<a name="l01140"></a>01140 }
<a name="l01141"></a>01141 
<a name="l01142"></a>01142 
<a name="l01143"></a>01143 
<a name="l01144"></a>01144 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01145"></a>01145 <span class="keyword">inline</span>
<a name="l01146"></a><a class="code" href="classPetscVector.php#ad09635a12020c8efe6c46fd1117bd9ed">01146</a> <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#ad09635a12020c8efe6c46fd1117bd9ed">PetscVector&lt;T&gt;::_get_array</a>(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l01147"></a>01147 <span class="keyword"></span>{
<a name="l01148"></a>01148   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l01149"></a>01149   <span class="keywordflow">if</span>(!_array_is_present)
<a name="l01150"></a>01150     {
<a name="l01151"></a>01151       <span class="keywordtype">int</span> ierr=0;
<a name="l01152"></a>01152       <span class="keywordflow">if</span>(this-&gt;type() != <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l01153"></a>01153         {
<a name="l01154"></a>01154           ierr = VecGetArray(_vec, &amp;_values);
<a name="l01155"></a>01155           CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l01156"></a>01156         }
<a name="l01157"></a>01157       <span class="keywordflow">else</span>
<a name="l01158"></a>01158         {
<a name="l01159"></a>01159           ierr = VecGhostGetLocalForm (_vec,&amp;_local_form);
<a name="l01160"></a>01160           CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l01161"></a>01161           ierr = VecGetArray(_local_form, &amp;_values);
<a name="l01162"></a>01162           CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l01163"></a>01163 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01164"></a>01164 <span class="preprocessor"></span>          <span class="keywordtype">int</span> local_size = 0;
<a name="l01165"></a>01165           ierr = VecGetLocalSize(_local_form, &amp;local_size);
<a name="l01166"></a>01166           CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l01167"></a>01167           _local_size = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(local_size);
<a name="l01168"></a>01168 <span class="preprocessor">#endif</span>
<a name="l01169"></a>01169 <span class="preprocessor"></span>        }
<a name="l01170"></a>01170       _array_is_present = <span class="keyword">true</span>;
<a name="l01171"></a>01171     }
<a name="l01172"></a>01172 }
<a name="l01173"></a>01173 
<a name="l01174"></a>01174 
<a name="l01175"></a>01175 
<a name="l01176"></a>01176 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01177"></a>01177 <span class="keyword">inline</span>
<a name="l01178"></a><a class="code" href="classPetscVector.php#a9556fc5c261ed4858490461cadd4f6d0">01178</a> <span class="keywordtype">void</span> <a class="code" href="classPetscVector.php#a9556fc5c261ed4858490461cadd4f6d0">PetscVector&lt;T&gt;::_restore_array</a>(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l01179"></a>01179 <span class="keyword"></span>{
<a name="l01180"></a>01180   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l01181"></a>01181   <span class="keywordflow">if</span>(_array_is_present)
<a name="l01182"></a>01182     {
<a name="l01183"></a>01183       <span class="keywordtype">int</span> ierr=0;
<a name="l01184"></a>01184       <span class="keywordflow">if</span>(this-&gt;type() != <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l01185"></a>01185         {
<a name="l01186"></a>01186           ierr = VecRestoreArray (_vec, &amp;_values);
<a name="l01187"></a>01187           CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l01188"></a>01188           _values = NULL;
<a name="l01189"></a>01189         }
<a name="l01190"></a>01190       <span class="keywordflow">else</span>
<a name="l01191"></a>01191         {
<a name="l01192"></a>01192           ierr = VecRestoreArray (_local_form, &amp;_values);
<a name="l01193"></a>01193           CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l01194"></a>01194           _values = NULL;
<a name="l01195"></a>01195           ierr = VecGhostRestoreLocalForm (_vec,&amp;_local_form);
<a name="l01196"></a>01196           CHKERRABORT(<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l01197"></a>01197           _local_form = NULL;
<a name="l01198"></a>01198 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01199"></a>01199 <span class="preprocessor"></span>          _local_size = 0;
<a name="l01200"></a>01200 <span class="preprocessor">#endif</span>
<a name="l01201"></a>01201 <span class="preprocessor"></span>        }
<a name="l01202"></a>01202       _array_is_present = <span class="keyword">false</span>;
<a name="l01203"></a>01203     }
<a name="l01204"></a>01204 }
<a name="l01205"></a>01205 
<a name="l01206"></a>01206 
<a name="l01207"></a>01207 
<a name="l01208"></a>01208 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_PETSC</span>
<a name="l01209"></a>01209 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __petsc_vector_h__</span>
<a name="l01210"></a>01210 <span class="preprocessor"></span>
<a name="l01211"></a>01211 
<a name="l01212"></a>01212 
<a name="l01213"></a>01213 
<a name="l01214"></a>01214 
<a name="l01215"></a>01215 
<a name="l01216"></a>01216 
<a name="l01217"></a>01217 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
