<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1665b3ccb6c776ec6797fe204e2359e5.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>plane.C</h1>  </div>
</div>
<div class="contents">
<a href="plane_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: plane.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;plane.h&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00030"></a>00030 <span class="comment">// Plane class member functions</span>
<a name="l00031"></a><a class="code" href="classPlane.php#acac0d9c003e0ab10d07b146c3566a0c7">00031</a> <a class="code" href="classPlane.php#acac0d9c003e0ab10d07b146c3566a0c7">Plane::Plane</a> ()
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 }
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a><a class="code" href="classPlane.php#a80962be01d8609951acb60f04769c78c">00037</a> <a class="code" href="classPlane.php#acac0d9c003e0ab10d07b146c3566a0c7">Plane::Plane</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p, 
<a name="l00038"></a>00038               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; n)
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040   this-&gt;<a class="code" href="classPlane.php#a2afadb592af9c71e73bc23f23d3ba7be">create_from_point_normal</a> (p, n);
<a name="l00041"></a>00041 }
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a><a class="code" href="classPlane.php#a21dfd453dc60e14dc38a015457046dcd">00045</a> <a class="code" href="classPlane.php#acac0d9c003e0ab10d07b146c3566a0c7">Plane::Plane</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p0, 
<a name="l00046"></a>00046               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p1, 
<a name="l00047"></a>00047               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p2)
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049   this-&gt;<a class="code" href="classPlane.php#a4ad683293ea44ed1fe15f41a2c2a407e">create_from_three_points</a> (p0, p1, p2);
<a name="l00050"></a>00050 }
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a><a class="code" href="classPlane.php#a3de5bc91e6829d2ff774e664c4b97c9c">00054</a> <a class="code" href="classPlane.php#acac0d9c003e0ab10d07b146c3566a0c7">Plane::Plane</a> (<span class="keyword">const</span> <a class="code" href="classPlane.php">Plane</a>&amp; other_plane) :
<a name="l00055"></a>00055   <a class="code" href="classSurface.php">Surface</a>()
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057   this-&gt;<a class="code" href="classPlane.php#a2afadb592af9c71e73bc23f23d3ba7be">create_from_point_normal</a>(other_plane.<a class="code" href="classPlane.php#ae4acee1096d44ca14baeaeaa7607479c">_point</a>,
<a name="l00058"></a>00058                                  other_plane.<a class="code" href="classPlane.php#a19ec886d94af864776f74fe7553160e1">_normal</a>);
<a name="l00059"></a>00059 }
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a><a class="code" href="classPlane.php#a69abd86051c880dcb44b249ad10c4436">00063</a> <a class="code" href="classPlane.php#a69abd86051c880dcb44b249ad10c4436">Plane::~Plane</a> ()
<a name="l00064"></a>00064 {
<a name="l00065"></a>00065 }
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00069"></a><a class="code" href="classPlane.php#a2afadb592af9c71e73bc23f23d3ba7be">00069</a> <span class="keywordtype">void</span> <a class="code" href="classPlane.php#a2afadb592af9c71e73bc23f23d3ba7be">Plane::create_from_point_normal</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p, <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; n)
<a name="l00070"></a>00070 {
<a name="l00071"></a>00071   <a class="code" href="classPlane.php#a19ec886d94af864776f74fe7553160e1">_normal</a> = n.<a class="code" href="classTypeVector.php#a0415bcc1a523ea5f0224a711b14b3532">unit</a>();
<a name="l00072"></a>00072   <a class="code" href="classPlane.php#ae4acee1096d44ca14baeaeaa7607479c">_point</a>  = p;
<a name="l00073"></a>00073 }
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
<a name="l00077"></a><a class="code" href="classPlane.php#a4ad683293ea44ed1fe15f41a2c2a407e">00077</a> <span class="keywordtype">void</span> <a class="code" href="classPlane.php#a4ad683293ea44ed1fe15f41a2c2a407e">Plane::create_from_three_points</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p0,
<a name="l00078"></a>00078                                       <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p1,
<a name="l00079"></a>00079                                       <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p2)
<a name="l00080"></a>00080 {
<a name="l00081"></a>00081   <span class="comment">// Just use p0 for the point.</span>
<a name="l00082"></a>00082   <a class="code" href="classPlane.php#ae4acee1096d44ca14baeaeaa7607479c">_point</a> = p0;
<a name="l00083"></a>00083   
<a name="l00084"></a>00084   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> e0 = p1 - p0;
<a name="l00085"></a>00085   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> e1 = p2 - p0;
<a name="l00086"></a>00086   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> n  = e0.<a class="code" href="classTypeVector.php#a1347e1223f3e31f8a2c0496736e60dc5">cross</a>(e1);
<a name="l00087"></a>00087 
<a name="l00088"></a>00088   <a class="code" href="classPlane.php#a19ec886d94af864776f74fe7553160e1">_normal</a> = n.<a class="code" href="classTypeVector.php#a0415bcc1a523ea5f0224a711b14b3532">unit</a>(); 
<a name="l00089"></a>00089 }
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 
<a name="l00093"></a><a class="code" href="classPlane.php#a716620654f85f7093d8b8fb1111f683a">00093</a> <span class="keywordtype">void</span> <a class="code" href="classPlane.php#a716620654f85f7093d8b8fb1111f683a">Plane::xy_plane</a> (<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> zpos)
<a name="l00094"></a>00094 {
<a name="l00095"></a>00095   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> p (0., 0., zpos);
<a name="l00096"></a>00096   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> n (0., 0., 1.);
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   <a class="code" href="classPlane.php#ae4acee1096d44ca14baeaeaa7607479c">_point</a>  = p;
<a name="l00099"></a>00099   <a class="code" href="classPlane.php#a19ec886d94af864776f74fe7553160e1">_normal</a> = n;
<a name="l00100"></a>00100 }
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a><a class="code" href="classPlane.php#a4e54c6614e57d5e52c002a133dff54bb">00104</a> <span class="keywordtype">void</span> <a class="code" href="classPlane.php#a4e54c6614e57d5e52c002a133dff54bb">Plane::xz_plane</a> (<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> ypos)
<a name="l00105"></a>00105 {
<a name="l00106"></a>00106   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> p (0., ypos, 0.);
<a name="l00107"></a>00107   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> n (0., 1., 0.);
<a name="l00108"></a>00108 
<a name="l00109"></a>00109   <a class="code" href="classPlane.php#ae4acee1096d44ca14baeaeaa7607479c">_point</a>  = p;
<a name="l00110"></a>00110   <a class="code" href="classPlane.php#a19ec886d94af864776f74fe7553160e1">_normal</a> = n;
<a name="l00111"></a>00111 }
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a><a class="code" href="classPlane.php#a9b2df04f1dfeddd2310ffa62726aa0e5">00115</a> <span class="keywordtype">void</span> <a class="code" href="classPlane.php#a9b2df04f1dfeddd2310ffa62726aa0e5">Plane::yz_plane</a> (<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xpos)
<a name="l00116"></a>00116 {
<a name="l00117"></a>00117   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> p (xpos, 0., 0.);
<a name="l00118"></a>00118   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> n (1., 0., 0.);
<a name="l00119"></a>00119 
<a name="l00120"></a>00120   <a class="code" href="classPlane.php#ae4acee1096d44ca14baeaeaa7607479c">_point</a>  = p;
<a name="l00121"></a>00121   <a class="code" href="classPlane.php#a19ec886d94af864776f74fe7553160e1">_normal</a> = n;
<a name="l00122"></a>00122 }
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a><a class="code" href="classPlane.php#a4602c3eac515d90e7391b44f661eb0f9">00126</a> <span class="keywordtype">bool</span> <a class="code" href="classPlane.php#a4602c3eac515d90e7391b44f661eb0f9">Plane::above_surface</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p)<span class="keyword"> const </span>
<a name="l00127"></a>00127 <span class="keyword"></span>{
<a name="l00128"></a>00128   <span class="comment">// Create a vector from the surface to point p;</span>
<a name="l00129"></a>00129   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> w = p - <a class="code" href="classPlane.php#ae4acee1096d44ca14baeaeaa7607479c">_point</a>;
<a name="l00130"></a>00130 
<a name="l00131"></a>00131   <span class="comment">// The point is above the surface if the projection</span>
<a name="l00132"></a>00132   <span class="comment">// of that vector onto the normal is positive </span>
<a name="l00133"></a>00133   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> proj = w*this-&gt;<a class="code" href="classPlane.php#a8f658e63ed0dfc57a0b81727a5f9fec5">normal</a>();
<a name="l00134"></a>00134   
<a name="l00135"></a>00135   <span class="keywordflow">if</span> (proj &gt; 0.) 
<a name="l00136"></a>00136     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00139"></a>00139 }
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a><a class="code" href="classPlane.php#ab7ab4751a24bb7211cfea1796216b1c0">00143</a> <span class="keywordtype">bool</span> <a class="code" href="classPlane.php#ab7ab4751a24bb7211cfea1796216b1c0">Plane::below_surface</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p)<span class="keyword"> const </span>
<a name="l00144"></a>00144 <span class="keyword"></span>{
<a name="l00145"></a>00145   <span class="keywordflow">return</span> ( !this-&gt;<a class="code" href="classPlane.php#a4602c3eac515d90e7391b44f661eb0f9">above_surface</a> (p) );
<a name="l00146"></a>00146 }
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00150"></a><a class="code" href="classPlane.php#adb2b4ea766a9da6df0e131825c8d1cff">00150</a> <span class="keywordtype">bool</span> <a class="code" href="classPlane.php#adb2b4ea766a9da6df0e131825c8d1cff">Plane::on_surface</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p)<span class="keyword"> const </span>
<a name="l00151"></a>00151 <span class="keyword"></span>{
<a name="l00152"></a>00152   <span class="comment">// Create a vector from the surface to point p;</span>
<a name="l00153"></a>00153   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> w = p - <a class="code" href="classPlane.php#ae4acee1096d44ca14baeaeaa7607479c">_point</a>;
<a name="l00154"></a>00154 
<a name="l00155"></a>00155   <span class="comment">// If the projection of that vector onto the</span>
<a name="l00156"></a>00156   <span class="comment">// plane&#39;s normal is 0 then the point is in</span>
<a name="l00157"></a>00157   <span class="comment">// the plane.</span>
<a name="l00158"></a>00158   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> proj = w * this-&gt;<a class="code" href="classPlane.php#a8f658e63ed0dfc57a0b81727a5f9fec5">normal</a>();
<a name="l00159"></a>00159 
<a name="l00160"></a>00160   <span class="keywordflow">if</span> (std::abs(proj) &lt; 1.e-10)
<a name="l00161"></a>00161     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00162"></a>00162 
<a name="l00163"></a>00163   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00164"></a>00164 }
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 
<a name="l00168"></a><a class="code" href="classPlane.php#a501daecf11d3b630e00a9d9146fc056e">00168</a> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classPlane.php#a501daecf11d3b630e00a9d9146fc056e">Plane::closest_point</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p)<span class="keyword"> const</span>
<a name="l00169"></a>00169 <span class="keyword"></span>{
<a name="l00170"></a>00170   <span class="comment">// Create a vector from the surface to point p;</span>
<a name="l00171"></a>00171   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> w = p - <a class="code" href="classPlane.php#ae4acee1096d44ca14baeaeaa7607479c">_point</a>;
<a name="l00172"></a>00172 
<a name="l00173"></a>00173   <span class="comment">// The closest point in the plane to point p</span>
<a name="l00174"></a>00174   <span class="comment">// is in the negative normal direction</span>
<a name="l00175"></a>00175   <span class="comment">// a distance w (dot) p.</span>
<a name="l00176"></a>00176   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> cp = p - this-&gt;<a class="code" href="classPlane.php#a8f658e63ed0dfc57a0b81727a5f9fec5">normal</a>()*(w*this-&gt;<a class="code" href="classPlane.php#a8f658e63ed0dfc57a0b81727a5f9fec5">normal</a>());
<a name="l00177"></a>00177   
<a name="l00178"></a>00178   <span class="keywordflow">return</span> cp;
<a name="l00179"></a>00179 }
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 
<a name="l00183"></a><a class="code" href="classPlane.php#a7ea7aadc47cd4adec76933cf2d445553">00183</a> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classPlane.php#a7ea7aadc47cd4adec76933cf2d445553">Plane::unit_normal</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp;)<span class="keyword"> const</span>
<a name="l00184"></a>00184 <span class="keyword"></span>{
<a name="l00185"></a>00185   <span class="keywordflow">return</span> <a class="code" href="classPlane.php#a19ec886d94af864776f74fe7553160e1">_normal</a>;
<a name="l00186"></a>00186 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
