<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_c2e5aa429b9110fa734bdc9647d91e10.php">utils</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>plt_loader_read.C</h1>  </div>
</div>
<div class="contents">
<a href="plt__loader__read_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: plt_loader_read.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// Copyright (C) 2002-2007  Benjamin S. Kirk</span>
<a name="l00004"></a>00004   
<a name="l00005"></a>00005 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00007"></a>00007 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009   
<a name="l00010"></a>00010 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00014"></a>00014   
<a name="l00015"></a>00015 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00016"></a>00016 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00017"></a>00017 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00018"></a>00018 
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// C++ includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &lt;iostream&gt;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;cstring&gt;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;utility.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;plt_loader.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">//-----------------------------------------------------------------------------</span>
<a name="l00032"></a>00032 <span class="comment">// PltLoader reading members</span>
<a name="l00033"></a><a class="code" href="classPltLoader.php#a50048c4398f06a61ccc860d845b6a222">00033</a> <span class="keywordtype">void</span> <a class="code" href="classPltLoader.php#a50048c4398f06a61ccc860d845b6a222">PltLoader::read</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035   std::ifstream in (name.c_str(), std::ios::in|std::ios::binary);
<a name="l00036"></a>00036 
<a name="l00037"></a>00037   <span class="keywordflow">if</span> (!in.good())
<a name="l00038"></a>00038     {
<a name="l00039"></a>00039       std::cerr &lt;&lt; <span class="stringliteral">&quot;Error reading input file &quot;</span> &lt;&lt; name
<a name="l00040"></a>00040                 &lt;&lt; std::endl;
<a name="l00041"></a>00041 
<a name="l00042"></a>00042       libmesh_error();
<a name="l00043"></a>00043     }
<a name="l00044"></a>00044     
<a name="l00045"></a>00045 
<a name="l00046"></a>00046   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPltLoader.php#a0e20e58aef5d83224980367d81cdda26">verbose</a>())
<a name="l00047"></a>00047     std::cout &lt;&lt; std::endl
<a name="l00048"></a>00048               &lt;&lt; <span class="stringliteral">&quot;Reading input file &quot;</span> &lt;&lt; name
<a name="l00049"></a>00049               &lt;&lt; std::endl
<a name="l00050"></a>00050               &lt;&lt; <span class="stringliteral">&quot;-------------------------------------------------------------------------&quot;</span>
<a name="l00051"></a>00051               &lt;&lt; std::endl;
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   this-&gt;<a class="code" href="classPltLoader.php#a6626bb15b64708f5be7e95df057f71f1">read_header</a> (in);
<a name="l00054"></a>00054   this-&gt;<a class="code" href="classPltLoader.php#a7210840975dfd8c3f4ca839d976bc24c">read_data</a>   (in);
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPltLoader.php#a0e20e58aef5d83224980367d81cdda26">verbose</a>())
<a name="l00057"></a>00057     std::cout &lt;&lt; std::endl
<a name="l00058"></a>00058               &lt;&lt; <span class="stringliteral">&quot;-------------------------------------------------------------------------&quot;</span>
<a name="l00059"></a>00059               &lt;&lt; std::endl;
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 }
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a><a class="code" href="classPltLoader.php#a6626bb15b64708f5be7e95df057f71f1">00065</a> <span class="keywordtype">void</span> <a class="code" href="classPltLoader.php#a6626bb15b64708f5be7e95df057f71f1">PltLoader::read_header</a> (std::istream&amp; in)
<a name="l00066"></a>00066 {
<a name="l00067"></a>00067   libmesh_assert (in.good());
<a name="l00068"></a>00068   
<a name="l00069"></a>00069   <span class="comment">//----------------------------------------------------</span>
<a name="l00070"></a>00070   <span class="comment">// Read the TECPLOT header</span>
<a name="l00071"></a>00071   
<a name="l00072"></a>00072   <span class="comment">// Read the version number</span>
<a name="l00073"></a>00073   {
<a name="l00074"></a>00074     in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, 8);
<a name="l00075"></a>00075 
<a name="l00076"></a>00076     <span class="comment">// Using erase for GCC 2.95.3</span>
<a name="l00077"></a>00077     this-&gt;<a class="code" href="classPltLoader.php#a3ed3c9de4fd9cd64a926e2c980a461ef">version</a>().erase();
<a name="l00078"></a>00078 
<a name="l00079"></a>00079     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;8; i++)
<a name="l00080"></a>00080       this-&gt;<a class="code" href="classPltLoader.php#a3ed3c9de4fd9cd64a926e2c980a461ef">version</a>() += <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>[i];
<a name="l00081"></a>00081     
<a name="l00082"></a>00082     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPltLoader.php#a0e20e58aef5d83224980367d81cdda26">verbose</a>())
<a name="l00083"></a>00083       std::cout &lt;&lt; <span class="stringliteral">&quot;Tecplot Version: &quot;</span>
<a name="l00084"></a>00084                 &lt;&lt; this-&gt;<a class="code" href="classPltLoader.php#a3ed3c9de4fd9cd64a926e2c980a461ef">version</a>()
<a name="l00085"></a>00085                 &lt;&lt; std::endl;
<a name="l00086"></a>00086   }
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   <span class="comment">//----------------------------------------------------</span>
<a name="l00090"></a>00090   <span class="comment">// Read plt files written by older versions of Tecplot</span>
<a name="l00091"></a>00091   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPltLoader.php#a3ed3c9de4fd9cd64a926e2c980a461ef">version</a>().rfind(<span class="stringliteral">&quot;V7&quot;</span>) &lt; this-&gt;<a class="code" href="classPltLoader.php#a3ed3c9de4fd9cd64a926e2c980a461ef">version</a>().size())
<a name="l00092"></a>00092     {
<a name="l00093"></a>00093       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPltLoader.php#a0e20e58aef5d83224980367d81cdda26">verbose</a>())
<a name="l00094"></a>00094         std::cout &lt;&lt; <span class="stringliteral">&quot;Reading legacy .plt format (&lt;= v9) ...&quot;</span>
<a name="l00095"></a>00095                   &lt;&lt; std::endl;
<a name="l00096"></a>00096       
<a name="l00097"></a>00097       <span class="comment">// Read the value of 1 to determine byte ordering</span>
<a name="l00098"></a>00098       {
<a name="l00099"></a>00099         <span class="keywordtype">int</span> one = 0;    
<a name="l00100"></a>00100         in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00101"></a>00101         std::memcpy  (&amp;one, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00102"></a>00102         
<a name="l00103"></a>00103         <span class="keywordflow">if</span> (one != 1)
<a name="l00104"></a>00104           {
<a name="l00105"></a>00105             <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPltLoader.php#a0e20e58aef5d83224980367d81cdda26">verbose</a>())
<a name="l00106"></a>00106               std::cout &lt;&lt; <span class="stringliteral">&quot;Tecplot data is Foreign!&quot;</span>
<a name="l00107"></a>00107                         &lt;&lt; std::endl;
<a name="l00108"></a>00108             this-&gt;<a class="code" href="classPltLoader.php#abf12f02978300d3b32f3daac9b1c69ea">is_foreign</a>() = <span class="keyword">true</span>;
<a name="l00109"></a>00109 
<a name="l00110"></a>00110             <span class="comment">// Make sure one reversed is one</span>
<a name="l00111"></a>00111             <a class="code" href="classUtility_1_1ReverseBytes.php">Utility::ReverseBytes</a> rb(this-&gt;<a class="code" href="classPltLoader.php#abf12f02978300d3b32f3daac9b1c69ea">is_foreign</a>());
<a name="l00112"></a>00112             libmesh_assert (rb(one) == 1);
<a name="l00113"></a>00113           }
<a name="l00114"></a>00114       }
<a name="l00115"></a>00115 
<a name="l00116"></a>00116       <span class="comment">// A byte-reverser in case the data is foreign</span>
<a name="l00117"></a>00117       <a class="code" href="classUtility_1_1ReverseBytes.php">Utility::ReverseBytes</a> rb(this-&gt;<a class="code" href="classPltLoader.php#abf12f02978300d3b32f3daac9b1c69ea">is_foreign</a>());
<a name="l00118"></a>00118 
<a name="l00119"></a>00119       <span class="comment">// Read the title</span>
<a name="l00120"></a>00120       {
<a name="l00121"></a>00121         <span class="keywordtype">int</span> i=0;
<a name="l00122"></a>00122         
<a name="l00123"></a>00123         <span class="comment">// Using erase for GCC 2.95.3</span>
<a name="l00124"></a>00124         this-&gt;<a class="code" href="classPltLoader.php#a0e0f399e3b6a36b94f397ec67756d80a">title</a>().erase();
<a name="l00125"></a>00125         
<a name="l00126"></a>00126         <span class="keywordflow">do</span>
<a name="l00127"></a>00127           {
<a name="l00128"></a>00128             in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00129"></a>00129             std::memcpy  (&amp;i, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00130"></a>00130             rb(i);
<a name="l00131"></a>00131 
<a name="l00132"></a>00132             <span class="comment">// Don&#39;t add trailing \0</span>
<a name="l00133"></a>00133             <span class="keywordflow">if</span> (i)
<a name="l00134"></a>00134               this-&gt;<a class="code" href="classPltLoader.php#a0e0f399e3b6a36b94f397ec67756d80a">title</a>() += <span class="keyword">static_cast&lt;</span><span class="keywordtype">char</span><span class="keyword">&gt;</span>(i);
<a name="l00135"></a>00135           }
<a name="l00136"></a>00136         <span class="keywordflow">while</span> (i);
<a name="l00137"></a>00137       }
<a name="l00138"></a>00138 
<a name="l00139"></a>00139       <span class="comment">// Read the number of variables in the data set</span>
<a name="l00140"></a>00140       {
<a name="l00141"></a>00141         <span class="keywordtype">int</span> nv;
<a name="l00142"></a>00142         in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00143"></a>00143         std::memcpy  (&amp;nv, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00144"></a>00144         rb(nv);
<a name="l00145"></a>00145         
<a name="l00146"></a>00146         this-&gt;<a class="code" href="classPltLoader.php#acdfa78b38e1175cc0123a272b1a9adcb">set_n_vars</a> (nv);
<a name="l00147"></a>00147       }
<a name="l00148"></a>00148 
<a name="l00149"></a>00149       <span class="comment">// Read the variable names</span>
<a name="l00150"></a>00150       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;this-&gt;<a class="code" href="classPltLoader.php#a1120168d3423421b21c4e30c40b2f005">n_vars</a>(); v++)
<a name="l00151"></a>00151         {
<a name="l00152"></a>00152           <span class="keywordtype">int</span> i=0;
<a name="l00153"></a>00153 
<a name="l00154"></a>00154           <span class="comment">// Using erase for GCC 2.95.3</span>
<a name="l00155"></a>00155           this-&gt;<a class="code" href="classPltLoader.php#aab7ba55a9382d4d1b0d326d542cc63b0">var_name</a>(v).erase();
<a name="l00156"></a>00156       
<a name="l00157"></a>00157           <span class="keywordflow">do</span>
<a name="l00158"></a>00158             {
<a name="l00159"></a>00159               in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00160"></a>00160               std::memcpy  (&amp;i, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00161"></a>00161               rb(i);
<a name="l00162"></a>00162               
<a name="l00163"></a>00163               <span class="comment">// Don&#39;t add trailing \0</span>
<a name="l00164"></a>00164               <span class="keywordflow">if</span> (i)
<a name="l00165"></a>00165                 this-&gt;<a class="code" href="classPltLoader.php#aab7ba55a9382d4d1b0d326d542cc63b0">var_name</a>(v) += <span class="keyword">static_cast&lt;</span><span class="keywordtype">char</span><span class="keyword">&gt;</span>(i);
<a name="l00166"></a>00166             }
<a name="l00167"></a>00167           <span class="keywordflow">while</span> (i);
<a name="l00168"></a>00168         }
<a name="l00169"></a>00169 
<a name="l00170"></a>00170   
<a name="l00171"></a>00171       
<a name="l00172"></a>00172       <span class="comment">// Read zones from the header.</span>
<a name="l00173"></a>00173       <span class="comment">// Continue reading until the end-of-header</span>
<a name="l00174"></a>00174       <span class="comment">// marker (357.) is found.</span>
<a name="l00175"></a>00175       <span class="keywordtype">int</span> nz=0;
<a name="l00176"></a>00176       std::vector&lt;std::string&gt; zname;
<a name="l00177"></a>00177       std::vector&lt;int&gt;         ztype, zimax, zjmax, zkmax;
<a name="l00178"></a>00178       
<a name="l00179"></a>00179       {
<a name="l00180"></a>00180         <span class="keywordtype">float</span> f=0.;
<a name="l00181"></a>00181     
<a name="l00182"></a>00182         <span class="keywordflow">do</span>
<a name="l00183"></a>00183           {
<a name="l00184"></a>00184             <span class="comment">// find the next Zone marker        </span>
<a name="l00185"></a>00185             <span class="keywordflow">do</span>
<a name="l00186"></a>00186               {
<a name="l00187"></a>00187                 f = 0.;
<a name="l00188"></a>00188                 in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_FLOAT);
<a name="l00189"></a>00189                 std::memcpy  (&amp;f, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_FLOAT);
<a name="l00190"></a>00190                 rb(f);
<a name="l00191"></a>00191               }
<a name="l00192"></a>00192             <span class="keywordflow">while</span> ((f != 299.) &amp;&amp;
<a name="l00193"></a>00193                    (f != 357.) &amp;&amp;
<a name="l00194"></a>00194                    in.good());
<a name="l00195"></a>00195           
<a name="l00196"></a>00196           
<a name="l00197"></a>00197             <span class="comment">// Did we overrun the file?</span>
<a name="l00198"></a>00198             <span class="keywordflow">if</span> (!in.good())
<a name="l00199"></a>00199               {
<a name="l00200"></a>00200                 std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Unexpected end-of-file!&quot;</span>
<a name="l00201"></a>00201                           &lt;&lt; std::endl;
<a name="l00202"></a>00202                 libmesh_error();
<a name="l00203"></a>00203               }    
<a name="l00204"></a>00204           
<a name="l00205"></a>00205             <span class="comment">// Found a Zone marker</span>
<a name="l00206"></a>00206             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (f == 299.) 
<a name="l00207"></a>00207               {
<a name="l00208"></a>00208                 <span class="comment">// Incriment the Zone counter</span>
<a name="l00209"></a>00209                 nz++;
<a name="l00210"></a>00210           
<a name="l00211"></a>00211                 <span class="comment">// Read the zone name</span>
<a name="l00212"></a>00212                 {
<a name="l00213"></a>00213                   <span class="keywordtype">int</span> i=0;
<a name="l00214"></a>00214                   std::string <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>;
<a name="l00215"></a>00215             
<a name="l00216"></a>00216                   <span class="keywordflow">do</span>
<a name="l00217"></a>00217                     {
<a name="l00218"></a>00218                       in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00219"></a>00219                       std::memcpy  (&amp;i, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00220"></a>00220                       rb(i);
<a name="l00221"></a>00221                       
<a name="l00222"></a>00222                       <span class="comment">// Don&#39;t add trailing \0</span>
<a name="l00223"></a>00223                       <span class="keywordflow">if</span> (i)
<a name="l00224"></a>00224                         name += <span class="keyword">static_cast&lt;</span><span class="keywordtype">char</span><span class="keyword">&gt;</span>(i);
<a name="l00225"></a>00225                     }
<a name="l00226"></a>00226                   <span class="keywordflow">while</span> (i);
<a name="l00227"></a>00227             
<a name="l00228"></a>00228                   zname.push_back(name);
<a name="l00229"></a>00229                 }
<a name="l00230"></a>00230               
<a name="l00231"></a>00231                 <span class="comment">// Read the zone format</span>
<a name="l00232"></a>00232                 {
<a name="l00233"></a>00233                   <span class="keywordtype">int</span> zt;
<a name="l00234"></a>00234                   in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00235"></a>00235                   std::memcpy  (&amp;zt, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00236"></a>00236                   rb(zt);
<a name="l00237"></a>00237                   
<a name="l00238"></a>00238                   ztype.push_back(zt);
<a name="l00239"></a>00239                   <span class="comment">//std::cout &lt;&lt; &quot;zone type=&quot; &lt;&lt; ztype.back() &lt;&lt; std::endl;</span>
<a name="l00240"></a>00240                 }
<a name="l00241"></a>00241               
<a name="l00242"></a>00242                 <span class="comment">// Read the zone color</span>
<a name="l00243"></a>00243                 {
<a name="l00244"></a>00244                   <span class="keywordtype">int</span> zc=0;
<a name="l00245"></a>00245             
<a name="l00246"></a>00246                   in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00247"></a>00247                   std::memcpy  (&amp;zc, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00248"></a>00248                   rb(zc);
<a name="l00249"></a>00249                   
<a name="l00250"></a>00250                   <span class="comment">//std::cout &lt;&lt; &quot;zone color=&quot; &lt;&lt; zc &lt;&lt; std::endl;</span>
<a name="l00251"></a>00251                 }
<a name="l00252"></a>00252           
<a name="l00253"></a>00253                 <span class="comment">// Read in the block dimensions</span>
<a name="l00254"></a>00254                 {
<a name="l00255"></a>00255                   <span class="keywordtype">int</span>
<a name="l00256"></a>00256                     <a class="code" href="classPltLoader.php#a70b6ef7c80a5ceee904d8d34f1172f91">imax</a>=0,
<a name="l00257"></a>00257                     <a class="code" href="classPltLoader.php#a1e4e578cc888fcfbf1c064f0c75821b6">jmax</a>=0,
<a name="l00258"></a>00258                     <a class="code" href="classPltLoader.php#a71ab54fcbd4b5020196850ce2532d01e">kmax</a>=0;
<a name="l00259"></a>00259             
<a name="l00260"></a>00260                   in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00261"></a>00261                   std::memcpy  (&amp;imax, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00262"></a>00262                   rb(imax);
<a name="l00263"></a>00263                   
<a name="l00264"></a>00264                   in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00265"></a>00265                   std::memcpy  (&amp;<a class="code" href="classPltLoader.php#a1e4e578cc888fcfbf1c064f0c75821b6">jmax</a>, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00266"></a>00266                   rb(<a class="code" href="classPltLoader.php#a1e4e578cc888fcfbf1c064f0c75821b6">jmax</a>);
<a name="l00267"></a>00267                   
<a name="l00268"></a>00268                   in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00269"></a>00269                   std::memcpy  (&amp;<a class="code" href="classPltLoader.php#a71ab54fcbd4b5020196850ce2532d01e">kmax</a>, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00270"></a>00270                   rb(<a class="code" href="classPltLoader.php#a71ab54fcbd4b5020196850ce2532d01e">kmax</a>);
<a name="l00271"></a>00271                   
<a name="l00272"></a>00272                   zimax.push_back (imax);
<a name="l00273"></a>00273                   zjmax.push_back (<a class="code" href="classPltLoader.php#a1e4e578cc888fcfbf1c064f0c75821b6">jmax</a>);
<a name="l00274"></a>00274                   zkmax.push_back (<a class="code" href="classPltLoader.php#a71ab54fcbd4b5020196850ce2532d01e">kmax</a>);
<a name="l00275"></a>00275                 }
<a name="l00276"></a>00276               } <span class="comment">// else if (f == 299.)</span>
<a name="l00277"></a>00277           }
<a name="l00278"></a>00278         <span class="keywordflow">while</span> ((f != 357.) &amp;&amp; in.good());
<a name="l00279"></a>00279       }
<a name="l00280"></a>00280 
<a name="l00281"></a>00281       <span class="comment">// Set the header data</span>
<a name="l00282"></a>00282       this-&gt;<a class="code" href="classPltLoader.php#af1b9d2757692f0dd42ddb1d410be1b05">set_n_zones</a> (nz);
<a name="l00283"></a>00283 
<a name="l00284"></a>00284       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> z=0; z&lt;this-&gt;<a class="code" href="classPltLoader.php#a32454a413f74ab14ac846a9faadbdc8e">n_zones</a>(); z++)
<a name="l00285"></a>00285         {
<a name="l00286"></a>00286           this-&gt;<a class="code" href="classPltLoader.php#ac8de207e01aba553998101bf404f7006">zone_type</a>(z) = ztype[z];
<a name="l00287"></a>00287           this-&gt;<a class="code" href="classPltLoader.php#a88acf163c7e0e9385ac16095c2e4b921">zone_name</a>(z) = zname[z];
<a name="l00288"></a>00288           this-&gt;<a class="code" href="classPltLoader.php#a70b6ef7c80a5ceee904d8d34f1172f91">imax</a>(z)      = zimax[z];
<a name="l00289"></a>00289           this-&gt;<a class="code" href="classPltLoader.php#a1e4e578cc888fcfbf1c064f0c75821b6">jmax</a>(z)      = zjmax[z];
<a name="l00290"></a>00290           this-&gt;<a class="code" href="classPltLoader.php#a71ab54fcbd4b5020196850ce2532d01e">kmax</a>(z)      = zkmax[z];
<a name="l00291"></a>00291         }
<a name="l00292"></a>00292     }
<a name="l00293"></a>00293   
<a name="l00294"></a>00294 
<a name="l00295"></a>00295   <span class="comment">//----------------------------------------------------</span>
<a name="l00296"></a>00296   <span class="comment">// Read plt files written by newer versions of Tecplot</span>
<a name="l00297"></a>00297   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPltLoader.php#a3ed3c9de4fd9cd64a926e2c980a461ef">version</a>().rfind(<span class="stringliteral">&quot;V1&quot;</span>) &lt; this-&gt;<a class="code" href="classPltLoader.php#a3ed3c9de4fd9cd64a926e2c980a461ef">version</a>().size())
<a name="l00298"></a>00298     {
<a name="l00299"></a>00299       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPltLoader.php#a0e20e58aef5d83224980367d81cdda26">verbose</a>())
<a name="l00300"></a>00300         std::cout &lt;&lt; <span class="stringliteral">&quot;Reading new .plt format (&gt;= v10)...&quot;</span>
<a name="l00301"></a>00301                   &lt;&lt; std::endl;
<a name="l00302"></a>00302       
<a name="l00303"></a>00303       <span class="comment">// Read the value of 1 to determine byte ordering</span>
<a name="l00304"></a>00304       {
<a name="l00305"></a>00305         <span class="keywordtype">int</span> one = 0;
<a name="l00306"></a>00306         
<a name="l00307"></a>00307         in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00308"></a>00308         std::memcpy  (&amp;one, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00309"></a>00309         
<a name="l00310"></a>00310         <span class="keywordflow">if</span> (one != 1)
<a name="l00311"></a>00311           {
<a name="l00312"></a>00312             <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPltLoader.php#a0e20e58aef5d83224980367d81cdda26">verbose</a>())
<a name="l00313"></a>00313               std::cerr &lt;&lt; <span class="stringliteral">&quot;Tecplot data is Foreign!&quot;</span>
<a name="l00314"></a>00314                         &lt;&lt; std::endl;
<a name="l00315"></a>00315             this-&gt;<a class="code" href="classPltLoader.php#abf12f02978300d3b32f3daac9b1c69ea">is_foreign</a>() = <span class="keyword">true</span>;
<a name="l00316"></a>00316 
<a name="l00317"></a>00317             <span class="comment">// Make sure one reversed is one</span>
<a name="l00318"></a>00318             <a class="code" href="classUtility_1_1ReverseBytes.php">Utility::ReverseBytes</a> rb(this-&gt;<a class="code" href="classPltLoader.php#abf12f02978300d3b32f3daac9b1c69ea">is_foreign</a>());
<a name="l00319"></a>00319             libmesh_assert (rb(one) == 1);
<a name="l00320"></a>00320           }
<a name="l00321"></a>00321       }
<a name="l00322"></a>00322 
<a name="l00323"></a>00323       <span class="comment">// A byte-reverser in case the data is foreign</span>
<a name="l00324"></a>00324       <a class="code" href="classUtility_1_1ReverseBytes.php">Utility::ReverseBytes</a> rb(this-&gt;<a class="code" href="classPltLoader.php#abf12f02978300d3b32f3daac9b1c69ea">is_foreign</a>());
<a name="l00325"></a>00325 
<a name="l00326"></a>00326       <span class="comment">// Read the title</span>
<a name="l00327"></a>00327       {
<a name="l00328"></a>00328         <span class="keywordtype">int</span> i=0;
<a name="l00329"></a>00329 
<a name="l00330"></a>00330         <span class="comment">// Using erase() for GCC 2.95.3</span>
<a name="l00331"></a>00331         this-&gt;<a class="code" href="classPltLoader.php#a0e0f399e3b6a36b94f397ec67756d80a">title</a>().erase();
<a name="l00332"></a>00332         <span class="keywordflow">do</span>
<a name="l00333"></a>00333           {
<a name="l00334"></a>00334             in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00335"></a>00335             std::memcpy  (&amp;i, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00336"></a>00336             rb(i);
<a name="l00337"></a>00337             
<a name="l00338"></a>00338             <span class="comment">// Don&#39;t add trailing \0</span>
<a name="l00339"></a>00339             <span class="keywordflow">if</span> (i)
<a name="l00340"></a>00340               this-&gt;<a class="code" href="classPltLoader.php#a0e0f399e3b6a36b94f397ec67756d80a">title</a>() += <span class="keyword">static_cast&lt;</span><span class="keywordtype">char</span><span class="keyword">&gt;</span>(i);
<a name="l00341"></a>00341           }
<a name="l00342"></a>00342         <span class="keywordflow">while</span> (i);
<a name="l00343"></a>00343       }
<a name="l00344"></a>00344 
<a name="l00345"></a>00345       <span class="comment">// Read the number of variables in the data set</span>
<a name="l00346"></a>00346       {
<a name="l00347"></a>00347         <span class="keywordtype">int</span> nv;
<a name="l00348"></a>00348         in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00349"></a>00349         std::memcpy  (&amp;nv, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00350"></a>00350         rb(nv);
<a name="l00351"></a>00351         
<a name="l00352"></a>00352         this-&gt;<a class="code" href="classPltLoader.php#acdfa78b38e1175cc0123a272b1a9adcb">set_n_vars</a> (nv);
<a name="l00353"></a>00353       }
<a name="l00354"></a>00354 
<a name="l00355"></a>00355       <span class="comment">// Read the variable names</span>
<a name="l00356"></a>00356       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;this-&gt;<a class="code" href="classPltLoader.php#a1120168d3423421b21c4e30c40b2f005">n_vars</a>(); v++)
<a name="l00357"></a>00357         {
<a name="l00358"></a>00358           <span class="keywordtype">int</span> i=0;
<a name="l00359"></a>00359 
<a name="l00360"></a>00360           <span class="comment">// Using erase() for GCC 2.95.3</span>
<a name="l00361"></a>00361           this-&gt;<a class="code" href="classPltLoader.php#aab7ba55a9382d4d1b0d326d542cc63b0">var_name</a>(v).erase();
<a name="l00362"></a>00362       
<a name="l00363"></a>00363           <span class="keywordflow">do</span>
<a name="l00364"></a>00364             {
<a name="l00365"></a>00365               in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00366"></a>00366               std::memcpy  (&amp;i, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00367"></a>00367               rb(i);
<a name="l00368"></a>00368               
<a name="l00369"></a>00369               <span class="comment">// Don&#39;t add trailing \0</span>
<a name="l00370"></a>00370               <span class="keywordflow">if</span> (i)
<a name="l00371"></a>00371                 this-&gt;<a class="code" href="classPltLoader.php#aab7ba55a9382d4d1b0d326d542cc63b0">var_name</a>(v) += <span class="keyword">static_cast&lt;</span><span class="keywordtype">char</span><span class="keyword">&gt;</span>(i);
<a name="l00372"></a>00372             }
<a name="l00373"></a>00373           <span class="keywordflow">while</span> (i);
<a name="l00374"></a>00374         }
<a name="l00375"></a>00375 
<a name="l00376"></a>00376   
<a name="l00377"></a>00377       
<a name="l00378"></a>00378       <span class="comment">// Read zones from the header.</span>
<a name="l00379"></a>00379       <span class="comment">// Continue reading until the end-of-header</span>
<a name="l00380"></a>00380       <span class="comment">// marker (357.) is found.</span>
<a name="l00381"></a>00381       <span class="keywordtype">int</span> nz=0;
<a name="l00382"></a>00382       std::vector&lt;std::string&gt; zname;
<a name="l00383"></a>00383       std::vector&lt;int&gt;         zpack, ztype, zimax, zjmax, zkmax, znelem, znnodes;
<a name="l00384"></a>00384       
<a name="l00385"></a>00385       {
<a name="l00386"></a>00386         <span class="keywordtype">float</span> f=0.;
<a name="l00387"></a>00387     
<a name="l00388"></a>00388         <span class="keywordflow">do</span>
<a name="l00389"></a>00389           {
<a name="l00390"></a>00390             <span class="comment">// find the next Zone marker        </span>
<a name="l00391"></a>00391             <span class="keywordflow">do</span>
<a name="l00392"></a>00392               {
<a name="l00393"></a>00393                 f = 0.;
<a name="l00394"></a>00394                 in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_FLOAT);
<a name="l00395"></a>00395                 std::memcpy  (&amp;f, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_FLOAT);
<a name="l00396"></a>00396                 rb(f);
<a name="l00397"></a>00397               }
<a name="l00398"></a>00398             <span class="keywordflow">while</span> ((f != 299.) &amp;&amp;
<a name="l00399"></a>00399                    (f != 357.) &amp;&amp;
<a name="l00400"></a>00400                    in.good());
<a name="l00401"></a>00401           
<a name="l00402"></a>00402           
<a name="l00403"></a>00403             <span class="comment">// Did we overrun the file?</span>
<a name="l00404"></a>00404             <span class="keywordflow">if</span> (!in.good())
<a name="l00405"></a>00405               {
<a name="l00406"></a>00406                 std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Unexpected end-of-file!&quot;</span>
<a name="l00407"></a>00407                           &lt;&lt; std::endl;
<a name="l00408"></a>00408                 libmesh_error();
<a name="l00409"></a>00409               }    
<a name="l00410"></a>00410           
<a name="l00411"></a>00411             <span class="comment">// Found a Zone marker</span>
<a name="l00412"></a>00412             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (f == 299.) 
<a name="l00413"></a>00413               {
<a name="l00414"></a>00414                 <span class="comment">// Incriment the Zone counter</span>
<a name="l00415"></a>00415                 nz++;
<a name="l00416"></a>00416           
<a name="l00417"></a>00417                 <span class="comment">// Read the zone name</span>
<a name="l00418"></a>00418                 {
<a name="l00419"></a>00419                   <span class="keywordtype">int</span> i=0;
<a name="l00420"></a>00420                   std::string <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>;
<a name="l00421"></a>00421             
<a name="l00422"></a>00422                   <span class="keywordflow">do</span>
<a name="l00423"></a>00423                     {
<a name="l00424"></a>00424                       in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00425"></a>00425                       std::memcpy  (&amp;i, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00426"></a>00426                       rb(i);
<a name="l00427"></a>00427                   
<a name="l00428"></a>00428                       <span class="comment">// Don&#39;t add trailing \0</span>
<a name="l00429"></a>00429                       <span class="keywordflow">if</span> (i)
<a name="l00430"></a>00430                         name += <span class="keyword">static_cast&lt;</span><span class="keywordtype">char</span><span class="keyword">&gt;</span>(i);
<a name="l00431"></a>00431                     }
<a name="l00432"></a>00432                   <span class="keywordflow">while</span> (i);
<a name="l00433"></a>00433             
<a name="l00434"></a>00434                   zname.push_back(name);
<a name="l00435"></a>00435                 }
<a name="l00436"></a>00436               
<a name="l00437"></a>00437                 <span class="comment">// Read the zone color</span>
<a name="l00438"></a>00438                 {
<a name="l00439"></a>00439                   <span class="keywordtype">int</span> zc=0;         
<a name="l00440"></a>00440                   in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00441"></a>00441                   std::memcpy  (&amp;zc, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00442"></a>00442                   rb(zc);
<a name="l00443"></a>00443                 }
<a name="l00444"></a>00444               
<a name="l00445"></a>00445                 <span class="comment">// Read the zone format</span>
<a name="l00446"></a>00446                 {
<a name="l00447"></a>00447                   <span class="keywordtype">int</span> zt;
<a name="l00448"></a>00448                   in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00449"></a>00449                   std::memcpy  (&amp;zt, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00450"></a>00450                   rb(zt);
<a name="l00451"></a>00451                   
<a name="l00452"></a>00452                   ztype.push_back(zt);
<a name="l00453"></a>00453                 }
<a name="l00454"></a>00454 
<a name="l00455"></a>00455                 <span class="comment">// Read the data packing flag</span>
<a name="l00456"></a>00456                 {
<a name="l00457"></a>00457                   <span class="keywordtype">int</span> dp=0;
<a name="l00458"></a>00458                   in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00459"></a>00459                   std::memcpy (&amp;dp, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00460"></a>00460                   rb(dp);
<a name="l00461"></a>00461 
<a name="l00462"></a>00462                   zpack.push_back (dp);
<a name="l00463"></a>00463                 }
<a name="l00464"></a>00464 
<a name="l00465"></a>00465                 <span class="comment">// Will we specify the variable location?</span>
<a name="l00466"></a>00466                 {
<a name="l00467"></a>00467                   <span class="keywordtype">int</span> svl=0;
<a name="l00468"></a>00468                   <span class="keywordtype">int</span>  vl=0;
<a name="l00469"></a>00469                   in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00470"></a>00470                   std::memcpy  (&amp;svl, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00471"></a>00471                   rb(svl);
<a name="l00472"></a>00472                   
<a name="l00473"></a>00473                   <span class="keywordflow">if</span> (svl)
<a name="l00474"></a>00474                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;this-&gt;<a class="code" href="classPltLoader.php#a1120168d3423421b21c4e30c40b2f005">n_vars</a>(); v++)
<a name="l00475"></a>00475                       {
<a name="l00476"></a>00476                         in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00477"></a>00477                         std::memcpy  (&amp;vl, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00478"></a>00478                         rb(vl);
<a name="l00479"></a>00479                         libmesh_assert (vl == 0); <span class="comment">// Only know about node-based data</span>
<a name="l00480"></a>00480                                           <span class="comment">// right now</span>
<a name="l00481"></a>00481                       }
<a name="l00482"></a>00482                     
<a name="l00483"></a>00483                 }
<a name="l00484"></a>00484 
<a name="l00485"></a>00485                 <span class="comment">// Get the number of user-defined face-neighbors</span>
<a name="l00486"></a>00486                 {
<a name="l00487"></a>00487                   <span class="keywordtype">int</span> fn=0;
<a name="l00488"></a>00488                   in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00489"></a>00489                   std::memcpy  (&amp;fn, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00490"></a>00490                   rb(fn);
<a name="l00491"></a>00491                 }
<a name="l00492"></a>00492           
<a name="l00493"></a>00493                 <span class="comment">// Read in the block dimensions</span>
<a name="l00494"></a>00494                 {
<a name="l00495"></a>00495                   <span class="keywordflow">if</span> (ztype.back() != <a class="code" href="classPltLoader.php#a278aad9425430a197439af31ede52e0bab58da81a8f3cdbd6e350edacd840b244">ORDERED</a>)
<a name="l00496"></a>00496                     {
<a name="l00497"></a>00497                       <span class="keywordtype">int</span> np=0, ne=0;
<a name="l00498"></a>00498 
<a name="l00499"></a>00499                       in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00500"></a>00500                       std::memcpy  (&amp;np, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00501"></a>00501                       rb(np);
<a name="l00502"></a>00502 
<a name="l00503"></a>00503                       in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00504"></a>00504                       std::memcpy  (&amp;ne, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00505"></a>00505                       rb(ne);
<a name="l00506"></a>00506 
<a name="l00507"></a>00507                       zimax.push_back (np);
<a name="l00508"></a>00508                       zjmax.push_back (ne);
<a name="l00509"></a>00509                       zjmax.push_back (0);
<a name="l00510"></a>00510                     }
<a name="l00511"></a>00511                   
<a name="l00512"></a>00512                   <span class="keywordtype">int</span>
<a name="l00513"></a>00513                     <a class="code" href="classPltLoader.php#a70b6ef7c80a5ceee904d8d34f1172f91">imax</a>=0,
<a name="l00514"></a>00514                     <a class="code" href="classPltLoader.php#a1e4e578cc888fcfbf1c064f0c75821b6">jmax</a>=0,
<a name="l00515"></a>00515                     <a class="code" href="classPltLoader.php#a71ab54fcbd4b5020196850ce2532d01e">kmax</a>=0;
<a name="l00516"></a>00516                   
<a name="l00517"></a>00517                   in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00518"></a>00518                   std::memcpy  (&amp;imax, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00519"></a>00519                   rb(imax);
<a name="l00520"></a>00520                   
<a name="l00521"></a>00521                   in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00522"></a>00522                   std::memcpy  (&amp;<a class="code" href="classPltLoader.php#a1e4e578cc888fcfbf1c064f0c75821b6">jmax</a>, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00523"></a>00523                   rb(<a class="code" href="classPltLoader.php#a1e4e578cc888fcfbf1c064f0c75821b6">jmax</a>);
<a name="l00524"></a>00524                   
<a name="l00525"></a>00525                   in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00526"></a>00526                   std::memcpy  (&amp;<a class="code" href="classPltLoader.php#a71ab54fcbd4b5020196850ce2532d01e">kmax</a>, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00527"></a>00527                   rb(<a class="code" href="classPltLoader.php#a71ab54fcbd4b5020196850ce2532d01e">kmax</a>);
<a name="l00528"></a>00528 
<a name="l00529"></a>00529                   <span class="comment">// These are only useful for orderd data.  Otherwise</span>
<a name="l00530"></a>00530                   <span class="comment">// we grabbed the relevant values above.</span>
<a name="l00531"></a>00531                   <span class="keywordflow">if</span> (ztype.back() != <a class="code" href="classPltLoader.php#a278aad9425430a197439af31ede52e0bab58da81a8f3cdbd6e350edacd840b244">ORDERED</a>)
<a name="l00532"></a>00532                     {
<a name="l00533"></a>00533                       zimax.push_back (imax);
<a name="l00534"></a>00534                       zjmax.push_back (<a class="code" href="classPltLoader.php#a1e4e578cc888fcfbf1c064f0c75821b6">jmax</a>);
<a name="l00535"></a>00535                       zkmax.push_back (<a class="code" href="classPltLoader.php#a71ab54fcbd4b5020196850ce2532d01e">kmax</a>);
<a name="l00536"></a>00536                     }
<a name="l00537"></a>00537                 }
<a name="l00538"></a>00538               } <span class="comment">// else if (f == 299.)</span>
<a name="l00539"></a>00539           }
<a name="l00540"></a>00540         <span class="keywordflow">while</span> ((f != 357.) &amp;&amp; in.good());
<a name="l00541"></a>00541       }
<a name="l00542"></a>00542 
<a name="l00543"></a>00543       <span class="comment">// Set the header data</span>
<a name="l00544"></a>00544       this-&gt;<a class="code" href="classPltLoader.php#af1b9d2757692f0dd42ddb1d410be1b05">set_n_zones</a> (nz);
<a name="l00545"></a>00545 
<a name="l00546"></a>00546       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> z=0; z&lt;this-&gt;<a class="code" href="classPltLoader.php#a32454a413f74ab14ac846a9faadbdc8e">n_zones</a>(); z++)
<a name="l00547"></a>00547         {
<a name="l00548"></a>00548           this-&gt;<a class="code" href="classPltLoader.php#ac8de207e01aba553998101bf404f7006">zone_type</a>(z) = ztype[z];
<a name="l00549"></a>00549           this-&gt;<a class="code" href="classPltLoader.php#a88acf163c7e0e9385ac16095c2e4b921">zone_name</a>(z) = zname[z];
<a name="l00550"></a>00550           this-&gt;<a class="code" href="classPltLoader.php#a3b94a35340f369a3278280e95589221a">zone_pack</a>(z) = zpack[z];
<a name="l00551"></a>00551           this-&gt;<a class="code" href="classPltLoader.php#a70b6ef7c80a5ceee904d8d34f1172f91">imax</a>(z)      = zimax[z];
<a name="l00552"></a>00552           this-&gt;<a class="code" href="classPltLoader.php#a1e4e578cc888fcfbf1c064f0c75821b6">jmax</a>(z)      = zjmax[z];
<a name="l00553"></a>00553           this-&gt;<a class="code" href="classPltLoader.php#a71ab54fcbd4b5020196850ce2532d01e">kmax</a>(z)      = zkmax[z];
<a name="l00554"></a>00554         }
<a name="l00555"></a>00555     }
<a name="l00556"></a>00556 
<a name="l00557"></a>00557   
<a name="l00558"></a>00558 
<a name="l00559"></a>00559   <span class="comment">//----------------------------------------------------</span>
<a name="l00560"></a>00560   <span class="comment">// Unrecognized Tecplot Version!</span>
<a name="l00561"></a>00561   <span class="keywordflow">else</span>
<a name="l00562"></a>00562     {
<a name="l00563"></a>00563       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR:  This plot file was written by an unrecognized version of Tecplot!:&quot;</span>
<a name="l00564"></a>00564                 &lt;&lt; std::endl
<a name="l00565"></a>00565                 &lt;&lt; this-&gt;<a class="code" href="classPltLoader.php#a3ed3c9de4fd9cd64a926e2c980a461ef">version</a>()
<a name="l00566"></a>00566                 &lt;&lt; std::endl;
<a name="l00567"></a>00567       libmesh_error();
<a name="l00568"></a>00568     }
<a name="l00569"></a>00569   
<a name="l00570"></a>00570 
<a name="l00571"></a>00571 
<a name="l00572"></a>00572   
<a name="l00573"></a>00573 
<a name="l00574"></a>00574 
<a name="l00575"></a>00575 
<a name="l00576"></a>00576 
<a name="l00577"></a>00577   <span class="comment">// Print the data to the screen.</span>
<a name="l00578"></a>00578   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPltLoader.php#a0e20e58aef5d83224980367d81cdda26">verbose</a>())
<a name="l00579"></a>00579     {
<a name="l00580"></a>00580       std::cout &lt;&lt; <span class="stringliteral">&quot;Tecplot Header: &quot;</span>
<a name="l00581"></a>00581                 &lt;&lt; this-&gt;<a class="code" href="classPltLoader.php#a0e0f399e3b6a36b94f397ec67756d80a">title</a>() &lt;&lt; std::endl;
<a name="l00582"></a>00582 
<a name="l00583"></a>00583       std::cout &lt;&lt; <span class="stringliteral">&quot;Variables: &quot;</span>;      
<a name="l00584"></a>00584       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;this-&gt;<a class="code" href="classPltLoader.php#a1120168d3423421b21c4e30c40b2f005">n_vars</a>(); v++)
<a name="l00585"></a>00585         std::cout &lt;&lt; <span class="stringliteral">&quot;\&quot;&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classPltLoader.php#aab7ba55a9382d4d1b0d326d542cc63b0">var_name</a> (v) &lt;&lt; <span class="stringliteral">&quot;\&quot;&quot;</span> &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;  
<a name="l00586"></a>00586       std::cout &lt;&lt; std::endl;
<a name="l00587"></a>00587 
<a name="l00588"></a>00588       std::cout &lt;&lt; <span class="stringliteral">&quot;Variable Types: &quot;</span>;      
<a name="l00589"></a>00589       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;this-&gt;<a class="code" href="classPltLoader.php#a1120168d3423421b21c4e30c40b2f005">n_vars</a>(); v++)
<a name="l00590"></a>00590         std::cout &lt;&lt; this-&gt;<a class="code" href="classPltLoader.php#a0d2adffec94d16de190f2963aecf96ae">var_type</a> (v) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;  
<a name="l00591"></a>00591       std::cout &lt;&lt; std::endl;
<a name="l00592"></a>00592 
<a name="l00593"></a>00593       std::cout &lt;&lt; <span class="stringliteral">&quot;Zone Names: &quot;</span>;
<a name="l00594"></a>00594       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> z=0; z&lt;this-&gt;<a class="code" href="classPltLoader.php#a32454a413f74ab14ac846a9faadbdc8e">n_zones</a>(); z++)
<a name="l00595"></a>00595         std::cout &lt;&lt; <span class="stringliteral">&quot;\&quot;&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classPltLoader.php#a88acf163c7e0e9385ac16095c2e4b921">zone_name</a> (z) &lt;&lt; <span class="stringliteral">&quot;\&quot;&quot;</span> &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00596"></a>00596       std::cout &lt;&lt; std::endl;
<a name="l00597"></a>00597 
<a name="l00598"></a>00598       std::cout &lt;&lt; <span class="stringliteral">&quot;Zone Types: &quot;</span>;
<a name="l00599"></a>00599       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> z=0; z&lt;this-&gt;<a class="code" href="classPltLoader.php#a32454a413f74ab14ac846a9faadbdc8e">n_zones</a>(); z++)
<a name="l00600"></a>00600         {
<a name="l00601"></a>00601           std::cout &lt;&lt; this-&gt;<a class="code" href="classPltLoader.php#ac8de207e01aba553998101bf404f7006">zone_type</a> (z) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00602"></a>00602 
<a name="l00603"></a>00603           <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPltLoader.php#ac8de207e01aba553998101bf404f7006">zone_type</a> (z) != <a class="code" href="classPltLoader.php#a278aad9425430a197439af31ede52e0bab58da81a8f3cdbd6e350edacd840b244">ORDERED</a>)
<a name="l00604"></a>00604             std::cout &lt;&lt; <span class="stringliteral">&quot;(&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classPltLoader.php#a41730e7b7b63cf2f5920705804328af9">n_nodes</a>(z) &lt;&lt; <span class="stringliteral">&quot;,&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classPltLoader.php#a45013bafc4d20950ad0affa542f7d7a7">n_elem</a>(z) &lt;&lt; <span class="stringliteral">&quot;) &quot;</span>;
<a name="l00605"></a>00605         }
<a name="l00606"></a>00606       std::cout &lt;&lt; std::endl;
<a name="l00607"></a>00607 
<a name="l00608"></a>00608       std::cout &lt;&lt; <span class="stringliteral">&quot;Zone Dimensions: &quot;</span> &lt;&lt; std::endl;
<a name="l00609"></a>00609       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> z=0; z&lt;this-&gt;<a class="code" href="classPltLoader.php#a32454a413f74ab14ac846a9faadbdc8e">n_zones</a>(); z++)
<a name="l00610"></a>00610         std::cout &lt;&lt; <span class="stringliteral">&quot;  (&quot;</span>
<a name="l00611"></a>00611                   &lt;&lt; this-&gt;<a class="code" href="classPltLoader.php#a70b6ef7c80a5ceee904d8d34f1172f91">imax</a>(z) &lt;&lt; <span class="stringliteral">&quot;,&quot;</span> 
<a name="l00612"></a>00612                   &lt;&lt; this-&gt;<a class="code" href="classPltLoader.php#a1e4e578cc888fcfbf1c064f0c75821b6">jmax</a>(z) &lt;&lt; <span class="stringliteral">&quot;,&quot;</span> 
<a name="l00613"></a>00613                   &lt;&lt; this-&gt;<a class="code" href="classPltLoader.php#a71ab54fcbd4b5020196850ce2532d01e">kmax</a>(z) &lt;&lt; <span class="stringliteral">&quot;)&quot;</span>
<a name="l00614"></a>00614                   &lt;&lt; std::endl;  
<a name="l00615"></a>00615     }
<a name="l00616"></a>00616 }
<a name="l00617"></a>00617 
<a name="l00618"></a>00618 
<a name="l00619"></a>00619 
<a name="l00620"></a><a class="code" href="classPltLoader.php#a7210840975dfd8c3f4ca839d976bc24c">00620</a> <span class="keywordtype">void</span> <a class="code" href="classPltLoader.php#a7210840975dfd8c3f4ca839d976bc24c">PltLoader::read_data</a> (std::istream&amp; in)
<a name="l00621"></a>00621 {
<a name="l00622"></a>00622   libmesh_assert (in.good());
<a name="l00623"></a>00623 
<a name="l00624"></a>00624   <span class="comment">// A byte-reverser in case the data is foreign</span>
<a name="l00625"></a>00625   <a class="code" href="classUtility_1_1ReverseBytes.php">Utility::ReverseBytes</a> rb(this-&gt;<a class="code" href="classPltLoader.php#abf12f02978300d3b32f3daac9b1c69ea">is_foreign</a>());
<a name="l00626"></a>00626   
<a name="l00627"></a>00627   <span class="comment">//----------------------------------------------------</span>
<a name="l00628"></a>00628   <span class="comment">// Read the TECPLOT data for each zone</span>
<a name="l00629"></a>00629   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPltLoader.php#a0e20e58aef5d83224980367d81cdda26">verbose</a>())
<a name="l00630"></a>00630     {
<a name="l00631"></a>00631       std::cout &lt;&lt; <span class="stringliteral">&quot;Reading Zones&quot;</span>;
<a name="l00632"></a>00632       std::cout.flush();
<a name="l00633"></a>00633     }
<a name="l00634"></a>00634       
<a name="l00635"></a>00635   
<a name="l00636"></a>00636   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> zone=0; zone&lt;this-&gt;<a class="code" href="classPltLoader.php#a32454a413f74ab14ac846a9faadbdc8e">n_zones</a>(); zone++)
<a name="l00637"></a>00637     {
<a name="l00638"></a>00638       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPltLoader.php#a0e20e58aef5d83224980367d81cdda26">verbose</a>())
<a name="l00639"></a>00639         {
<a name="l00640"></a>00640           std::cout &lt;&lt; <span class="stringliteral">&quot;.&quot;</span>;
<a name="l00641"></a>00641           std::cout.flush();
<a name="l00642"></a>00642         }
<a name="l00643"></a>00643 
<a name="l00644"></a>00644 
<a name="l00645"></a>00645       <span class="comment">//----------------------------------------------------</span>
<a name="l00646"></a>00646       <span class="comment">// Read plt files written by older versions of Tecplot</span>
<a name="l00647"></a>00647       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPltLoader.php#a3ed3c9de4fd9cd64a926e2c980a461ef">version</a>().rfind(<span class="stringliteral">&quot;V7&quot;</span>) &lt; this-&gt;<a class="code" href="classPltLoader.php#a3ed3c9de4fd9cd64a926e2c980a461ef">version</a>().size())
<a name="l00648"></a>00648         {
<a name="l00649"></a>00649           <span class="keywordtype">float</span> f = 0.;
<a name="l00650"></a>00650           
<a name="l00651"></a>00651           <span class="comment">// Find the next Zone marker.</span>
<a name="l00652"></a>00652           <span class="keywordflow">do</span>
<a name="l00653"></a>00653             {
<a name="l00654"></a>00654               f = 0.;
<a name="l00655"></a>00655               in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_FLOAT);
<a name="l00656"></a>00656               std::memcpy  (&amp;f, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_FLOAT);
<a name="l00657"></a>00657               rb(f);
<a name="l00658"></a>00658             }
<a name="l00659"></a>00659           <span class="keywordflow">while</span> ((f != 299.) &amp;&amp; in.good());
<a name="l00660"></a>00660         
<a name="l00661"></a>00661           <span class="comment">// Did we overrun the file?</span>
<a name="l00662"></a>00662           <span class="keywordflow">if</span> (!in.good())
<a name="l00663"></a>00663             {
<a name="l00664"></a>00664               std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Unexpected end-of-file!&quot;</span>
<a name="l00665"></a>00665                         &lt;&lt; std::endl;
<a name="l00666"></a>00666               libmesh_error();
<a name="l00667"></a>00667             }
<a name="l00668"></a>00668 
<a name="l00669"></a>00669           <span class="comment">// Get the number of repeated vars.</span>
<a name="l00670"></a>00670           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_rep_vars=0;
<a name="l00671"></a>00671           std::vector&lt;int&gt; rep_vars;
<a name="l00672"></a>00672         
<a name="l00673"></a>00673           {     
<a name="l00674"></a>00674             in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00675"></a>00675             std::memcpy  (&amp;n_rep_vars, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00676"></a>00676             rb(n_rep_vars);
<a name="l00677"></a>00677 
<a name="l00678"></a>00678             rep_vars.resize (n_rep_vars);
<a name="l00679"></a>00679         
<a name="l00680"></a>00680             <span class="comment">// Get the repeated variables number.</span>
<a name="l00681"></a>00681             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;n_rep_vars; v++)
<a name="l00682"></a>00682               {
<a name="l00683"></a>00683                 std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR:  I don&#39;t understand repeated variables yet!&quot;</span>
<a name="l00684"></a>00684                           &lt;&lt; std::endl;
<a name="l00685"></a>00685                 libmesh_error();
<a name="l00686"></a>00686             
<a name="l00687"></a>00687                 in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00688"></a>00688                 std::memcpy  (&amp;rep_vars[v], <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00689"></a>00689                 rb(rep_vars[v]);
<a name="l00690"></a>00690               } 
<a name="l00691"></a>00691           }
<a name="l00692"></a>00692 
<a name="l00693"></a>00693           <span class="comment">// Get the variable data type</span>
<a name="l00694"></a>00694           <span class="comment">//std::cout &lt;&lt; &quot;var_types=&quot;;</span>
<a name="l00695"></a>00695           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;this-&gt;<a class="code" href="classPltLoader.php#a1120168d3423421b21c4e30c40b2f005">n_vars</a>(); v++)
<a name="l00696"></a>00696             {
<a name="l00697"></a>00697               in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00698"></a>00698               std::memcpy  (&amp;this-&gt;<a class="code" href="classPltLoader.php#a0d2adffec94d16de190f2963aecf96ae">var_type</a>(v), <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00699"></a>00699               rb(this-&gt;<a class="code" href="classPltLoader.php#a0d2adffec94d16de190f2963aecf96ae">var_type</a>(v));
<a name="l00700"></a>00700 
<a name="l00701"></a>00701               <span class="comment">//std::cout &lt;&lt; this-&gt;var_type(v) &lt;&lt; &quot; &quot;;</span>
<a name="l00702"></a>00702             }
<a name="l00703"></a>00703           <span class="comment">//std::cout &lt;&lt; std::endl;</span>
<a name="l00704"></a>00704 
<a name="l00705"></a>00705 
<a name="l00706"></a>00706       
<a name="l00707"></a>00707           <span class="comment">// Read the data.</span>
<a name="l00708"></a>00708           <span class="keywordflow">switch</span> (this-&gt;<a class="code" href="classPltLoader.php#ac8de207e01aba553998101bf404f7006">zone_type</a>(zone) )
<a name="l00709"></a>00709             {
<a name="l00710"></a>00710               <span class="comment">// Block-based data.  Structured meshes.</span>
<a name="l00711"></a>00711             <span class="keywordflow">case</span> <a class="code" href="classPltLoader.php#a8b3cfb75057387aa69257526cde804e9abfcdb2849537b947b7fe127327363c68">BLOCK</a>:
<a name="l00712"></a>00712               {
<a name="l00713"></a>00713                 this-&gt;<a class="code" href="classPltLoader.php#ad679861e3a2f4a1fd9a599c4cc3e006e">read_block_data</a> (in, zone);
<a name="l00714"></a>00714                 <span class="keywordflow">break</span>;
<a name="l00715"></a>00715               }
<a name="l00716"></a>00716           
<a name="l00717"></a>00717               <span class="comment">// Point-based data.  Structured meshes.</span>
<a name="l00718"></a>00718             <span class="keywordflow">case</span> <a class="code" href="classPltLoader.php#a8b3cfb75057387aa69257526cde804e9a5c152159d1718932072c1eb6b70ed1f6">POINT</a>:
<a name="l00719"></a>00719               {
<a name="l00720"></a>00720                 this-&gt;<a class="code" href="classPltLoader.php#aa1ed557b996425568f586997574481f8">read_point_data</a> (in, zone);
<a name="l00721"></a>00721                 <span class="keywordflow">break</span>;
<a name="l00722"></a>00722               }
<a name="l00723"></a>00723           
<a name="l00724"></a>00724               <span class="comment">// FE block data.  Unstructured meshes.</span>
<a name="l00725"></a>00725             <span class="keywordflow">case</span> <a class="code" href="classPltLoader.php#a8b3cfb75057387aa69257526cde804e9a07f2a6a4defc08c42fb689dfe50f1557">FEBLOCK</a>:
<a name="l00726"></a>00726               {
<a name="l00727"></a>00727                 this-&gt;<a class="code" href="classPltLoader.php#ab2ed484fcc635813a37fd92f401ea4cb">read_feblock_data</a> (in, zone);
<a name="l00728"></a>00728             
<a name="l00729"></a>00729                 <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPltLoader.php#a0e20e58aef5d83224980367d81cdda26">verbose</a>())
<a name="l00730"></a>00730               
<a name="l00731"></a>00731                   std::cout &lt;&lt; <span class="stringliteral">&quot;Zone &quot;</span> &lt;&lt; zone &lt;&lt; <span class="stringliteral">&quot;:&quot;</span> &lt;&lt; std::endl
<a name="l00732"></a>00732                             &lt;&lt; <span class="stringliteral">&quot;  nnodes   =&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classPltLoader.php#a70b6ef7c80a5ceee904d8d34f1172f91">imax</a>(zone) &lt;&lt; std::endl
<a name="l00733"></a>00733                             &lt;&lt; <span class="stringliteral">&quot;  nelem    =&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classPltLoader.php#a1e4e578cc888fcfbf1c064f0c75821b6">jmax</a>(zone) &lt;&lt; std::endl
<a name="l00734"></a>00734                             &lt;&lt; <span class="stringliteral">&quot;  elem_type=&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classPltLoader.php#a71ab54fcbd4b5020196850ce2532d01e">kmax</a>(zone) &lt;&lt; std::endl
<a name="l00735"></a>00735                             &lt;&lt; std::endl;
<a name="l00736"></a>00736                 <span class="keywordflow">break</span>;
<a name="l00737"></a>00737               }
<a name="l00738"></a>00738 
<a name="l00739"></a>00739               <span class="comment">// FE point data.  Unstructured meshes.</span>
<a name="l00740"></a>00740             <span class="keywordflow">case</span> <a class="code" href="classPltLoader.php#a8b3cfb75057387aa69257526cde804e9ad12d0731e47f020f8d85141d8d3633e2">FEPOINT</a>:
<a name="l00741"></a>00741               {
<a name="l00742"></a>00742                 this-&gt;<a class="code" href="classPltLoader.php#afd01d27bc6ef20a1bb1c15595cdc8ddf">read_fepoint_data</a> (in, zone);
<a name="l00743"></a>00743                 <span class="keywordflow">break</span>;
<a name="l00744"></a>00744               }
<a name="l00745"></a>00745           
<a name="l00746"></a>00746             <span class="keywordflow">default</span>:
<a name="l00747"></a>00747               {
<a name="l00748"></a>00748                 std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported Zone type: &quot;</span>
<a name="l00749"></a>00749                           &lt;&lt; this-&gt;<a class="code" href="classPltLoader.php#ac8de207e01aba553998101bf404f7006">zone_type</a>(zone)
<a name="l00750"></a>00750                           &lt;&lt; std::endl;
<a name="l00751"></a>00751                 libmesh_error();
<a name="l00752"></a>00752               }
<a name="l00753"></a>00753             } <span class="comment">// end switch on zone type</span>
<a name="l00754"></a>00754         }
<a name="l00755"></a>00755   
<a name="l00756"></a>00756 
<a name="l00757"></a>00757       <span class="comment">//----------------------------------------------------</span>
<a name="l00758"></a>00758       <span class="comment">// Read plt files written by newer versions of Tecplot</span>
<a name="l00759"></a>00759       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPltLoader.php#a3ed3c9de4fd9cd64a926e2c980a461ef">version</a>().rfind(<span class="stringliteral">&quot;V1&quot;</span>) &lt; this-&gt;<a class="code" href="classPltLoader.php#a3ed3c9de4fd9cd64a926e2c980a461ef">version</a>().size())
<a name="l00760"></a>00760         {
<a name="l00761"></a>00761           <span class="keywordtype">float</span> f = 0.;
<a name="l00762"></a>00762           
<a name="l00763"></a>00763           <span class="comment">// Find the next Zone marker.</span>
<a name="l00764"></a>00764           <span class="keywordflow">do</span>
<a name="l00765"></a>00765             {
<a name="l00766"></a>00766               f = 0.;
<a name="l00767"></a>00767               in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_FLOAT);
<a name="l00768"></a>00768               std::memcpy  (&amp;f, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_FLOAT);
<a name="l00769"></a>00769               rb(f);
<a name="l00770"></a>00770             }
<a name="l00771"></a>00771           <span class="keywordflow">while</span> ((f != 299.) &amp;&amp; in.good());
<a name="l00772"></a>00772         
<a name="l00773"></a>00773           <span class="comment">// Did we overrun the file?</span>
<a name="l00774"></a>00774           <span class="keywordflow">if</span> (!in.good())
<a name="l00775"></a>00775             {
<a name="l00776"></a>00776               std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Unexpected end-of-file!&quot;</span>
<a name="l00777"></a>00777                         &lt;&lt; std::endl;
<a name="l00778"></a>00778               libmesh_error();
<a name="l00779"></a>00779             }
<a name="l00780"></a>00780 
<a name="l00781"></a>00781           <span class="comment">// Get the variable data type</span>
<a name="l00782"></a>00782           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;this-&gt;<a class="code" href="classPltLoader.php#a1120168d3423421b21c4e30c40b2f005">n_vars</a>(); v++)
<a name="l00783"></a>00783             {
<a name="l00784"></a>00784               in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00785"></a>00785               std::memcpy  (&amp;this-&gt;<a class="code" href="classPltLoader.php#a0d2adffec94d16de190f2963aecf96ae">var_type</a>(v), <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00786"></a>00786               rb(this-&gt;<a class="code" href="classPltLoader.php#a0d2adffec94d16de190f2963aecf96ae">var_type</a>(v));
<a name="l00787"></a>00787 
<a name="l00788"></a>00788               <span class="comment">//std::cout &lt;&lt; this-&gt;var_type(v) &lt;&lt; &quot; &quot;;</span>
<a name="l00789"></a>00789             }
<a name="l00790"></a>00790 
<a name="l00791"></a>00791           <span class="comment">// Get the variable sharing flag</span>
<a name="l00792"></a>00792           {
<a name="l00793"></a>00793             <span class="keywordtype">int</span> vs=0;
<a name="l00794"></a>00794             <span class="keywordtype">int</span> sv=0;
<a name="l00795"></a>00795 
<a name="l00796"></a>00796             in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00797"></a>00797             std::memcpy  (&amp;vs, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00798"></a>00798             rb(vs);
<a name="l00799"></a>00799 
<a name="l00800"></a>00800             <span class="keywordflow">if</span> (vs)
<a name="l00801"></a>00801               {
<a name="l00802"></a>00802                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;this-&gt;<a class="code" href="classPltLoader.php#a1120168d3423421b21c4e30c40b2f005">n_vars</a>(); v++)
<a name="l00803"></a>00803                   {
<a name="l00804"></a>00804                     in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00805"></a>00805                     std::memcpy  (&amp;sv, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00806"></a>00806                     rb(sv);
<a name="l00807"></a>00807                     
<a name="l00808"></a>00808                     <span class="keywordflow">if</span> (sv != -1)
<a name="l00809"></a>00809                       {
<a name="l00810"></a>00810                         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR:  I don&#39;t understand variable sharing!&quot;</span>
<a name="l00811"></a>00811                                   &lt;&lt; std::endl;
<a name="l00812"></a>00812                         libmesh_error();
<a name="l00813"></a>00813                       }
<a name="l00814"></a>00814                   }
<a name="l00815"></a>00815               }
<a name="l00816"></a>00816           }
<a name="l00817"></a>00817 
<a name="l00818"></a>00818           <span class="comment">// Get zone to share connectivity with</span>
<a name="l00819"></a>00819           {
<a name="l00820"></a>00820             <span class="keywordtype">int</span> sc=0;
<a name="l00821"></a>00821             in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00822"></a>00822             std::memcpy  (&amp;sc, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_INT);
<a name="l00823"></a>00823             rb(sc);
<a name="l00824"></a>00824             
<a name="l00825"></a>00825             libmesh_assert (sc == -1);
<a name="l00826"></a>00826           }
<a name="l00827"></a>00827 
<a name="l00828"></a>00828       
<a name="l00829"></a>00829           <span class="comment">// Read the data.</span>
<a name="l00830"></a>00830           <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPltLoader.php#ac8de207e01aba553998101bf404f7006">zone_type</a>(zone) == <a class="code" href="classPltLoader.php#a278aad9425430a197439af31ede52e0bab58da81a8f3cdbd6e350edacd840b244">ORDERED</a>)
<a name="l00831"></a>00831             {
<a name="l00832"></a>00832                 <span class="comment">// Block-based data.  Structured meshes.</span>
<a name="l00833"></a>00833               <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPltLoader.php#a3b94a35340f369a3278280e95589221a">zone_pack</a>(zone) == 0)
<a name="l00834"></a>00834                 this-&gt;<a class="code" href="classPltLoader.php#ad679861e3a2f4a1fd9a599c4cc3e006e">read_block_data</a> (in, zone);
<a name="l00835"></a>00835           
<a name="l00836"></a>00836               <span class="comment">// Point-based data.  Structured meshes.</span>
<a name="l00837"></a>00837               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPltLoader.php#a3b94a35340f369a3278280e95589221a">zone_pack</a>(zone) == 1)
<a name="l00838"></a>00838                 this-&gt;<a class="code" href="classPltLoader.php#aa1ed557b996425568f586997574481f8">read_point_data</a> (in, zone);
<a name="l00839"></a>00839 
<a name="l00840"></a>00840               <span class="keywordflow">else</span>
<a name="l00841"></a>00841                 libmesh_error();
<a name="l00842"></a>00842             }
<a name="l00843"></a>00843           <span class="keywordflow">else</span>
<a name="l00844"></a>00844             {
<a name="l00845"></a>00845               <span class="comment">// Block-based data.  Unstructured meshes.</span>
<a name="l00846"></a>00846               <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPltLoader.php#a3b94a35340f369a3278280e95589221a">zone_pack</a>(zone) == 0)
<a name="l00847"></a>00847                 this-&gt;<a class="code" href="classPltLoader.php#ab2ed484fcc635813a37fd92f401ea4cb">read_feblock_data</a> (in, zone);
<a name="l00848"></a>00848 
<a name="l00849"></a>00849               <span class="comment">// Point-based data.  Unstructured meshes.</span>
<a name="l00850"></a>00850               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPltLoader.php#a3b94a35340f369a3278280e95589221a">zone_pack</a>(zone) == 1)
<a name="l00851"></a>00851                 this-&gt;<a class="code" href="classPltLoader.php#afd01d27bc6ef20a1bb1c15595cdc8ddf">read_fepoint_data</a> (in, zone);
<a name="l00852"></a>00852 
<a name="l00853"></a>00853               <span class="keywordflow">else</span>
<a name="l00854"></a>00854                 libmesh_error();
<a name="l00855"></a>00855             }
<a name="l00856"></a>00856         }
<a name="l00857"></a>00857 
<a name="l00858"></a>00858   
<a name="l00859"></a>00859 
<a name="l00860"></a>00860       <span class="comment">//----------------------------------------------------</span>
<a name="l00861"></a>00861       <span class="comment">// Unrecognized Tecplot Version!</span>
<a name="l00862"></a>00862       <span class="keywordflow">else</span>
<a name="l00863"></a>00863         {
<a name="l00864"></a>00864           std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR:  This plot file was written by an unrecognized version of Tecplot!:&quot;</span>
<a name="l00865"></a>00865                     &lt;&lt; std::endl
<a name="l00866"></a>00866                     &lt;&lt; this-&gt;<a class="code" href="classPltLoader.php#a3ed3c9de4fd9cd64a926e2c980a461ef">version</a>()
<a name="l00867"></a>00867                     &lt;&lt; std::endl;
<a name="l00868"></a>00868           libmesh_error();
<a name="l00869"></a>00869         }
<a name="l00870"></a>00870       
<a name="l00871"></a>00871     } <span class="comment">// end loop on zones</span>
<a name="l00872"></a>00872 }
<a name="l00873"></a>00873 
<a name="l00874"></a>00874 
<a name="l00875"></a>00875 
<a name="l00876"></a><a class="code" href="classPltLoader.php#ad679861e3a2f4a1fd9a599c4cc3e006e">00876</a> <span class="keywordtype">void</span> <a class="code" href="classPltLoader.php#ad679861e3a2f4a1fd9a599c4cc3e006e">PltLoader::read_block_data</a> (std::istream&amp; in, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> zone)
<a name="l00877"></a>00877 {
<a name="l00878"></a>00878   libmesh_assert (in.good());
<a name="l00879"></a>00879 
<a name="l00880"></a>00880   
<a name="l00881"></a>00881   <span class="comment">// A byte-reverser in case the data is foreign</span>
<a name="l00882"></a>00882   <a class="code" href="classUtility_1_1ReverseBytes.php">Utility::ReverseBytes</a> rb(this-&gt;<a class="code" href="classPltLoader.php#abf12f02978300d3b32f3daac9b1c69ea">is_foreign</a>());
<a name="l00883"></a>00883 
<a name="l00884"></a>00884   
<a name="l00885"></a>00885   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;this-&gt;<a class="code" href="classPltLoader.php#a1120168d3423421b21c4e30c40b2f005">n_vars</a>(); var++) 
<a name="l00886"></a>00886     {
<a name="l00887"></a>00887       
<a name="l00888"></a>00888       <span class="keywordflow">switch</span> (this-&gt;<a class="code" href="classPltLoader.php#a0d2adffec94d16de190f2963aecf96ae">var_type</a>(var))
<a name="l00889"></a>00889         {
<a name="l00890"></a>00890           
<a name="l00891"></a>00891           <span class="comment">// Read a single-precision variable</span>
<a name="l00892"></a>00892         <span class="keywordflow">case</span> <a class="code" href="classPltLoader.php#a0b9f891735de11140d807b4b48e40d7ea51e28cc34852aac84477fe6b95cf4260">FLOAT</a>:
<a name="l00893"></a>00893           {
<a name="l00894"></a>00894             std::vector&lt;float&gt; &amp; data = <a class="code" href="classPltLoader.php#a39b4d34d4af3db42fca39fcca6f0e870">_data</a>[zone][var];
<a name="l00895"></a>00895             
<a name="l00896"></a>00896             data.clear();
<a name="l00897"></a>00897             data.resize (this-&gt;<a class="code" href="classPltLoader.php#a70b6ef7c80a5ceee904d8d34f1172f91">imax</a>(zone)*
<a name="l00898"></a>00898                          this-&gt;<a class="code" href="classPltLoader.php#a1e4e578cc888fcfbf1c064f0c75821b6">jmax</a>(zone)*
<a name="l00899"></a>00899                          this-&gt;<a class="code" href="classPltLoader.php#a71ab54fcbd4b5020196850ce2532d01e">kmax</a>(zone));
<a name="l00900"></a>00900             
<a name="l00901"></a>00901             in.read ((<span class="keywordtype">char</span>*) &amp;data[0], LIBMESH_SIZEOF_FLOAT*data.size());
<a name="l00902"></a>00902 
<a name="l00903"></a>00903             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;data.size(); i++)
<a name="l00904"></a>00904               rb(data[i]);
<a name="l00905"></a>00905             
<a name="l00906"></a>00906             <span class="keywordflow">break</span>;
<a name="l00907"></a>00907           }
<a name="l00908"></a>00908           
<a name="l00909"></a>00909           <span class="comment">// Read a double-precision variable</span>
<a name="l00910"></a>00910         <span class="keywordflow">case</span> <a class="code" href="classPltLoader.php#a0b9f891735de11140d807b4b48e40d7ea787937a9565017fbbc75eb25f5fa7b89">DOUBLE</a>:
<a name="l00911"></a>00911           {
<a name="l00912"></a>00912             std::vector&lt;double&gt; ddata;
<a name="l00913"></a>00913             std::vector&lt;float&gt; &amp; data = <a class="code" href="classPltLoader.php#a39b4d34d4af3db42fca39fcca6f0e870">_data</a>[zone][var];
<a name="l00914"></a>00914             
<a name="l00915"></a>00915             data.clear();
<a name="l00916"></a>00916             data.resize (this-&gt;<a class="code" href="classPltLoader.php#a70b6ef7c80a5ceee904d8d34f1172f91">imax</a>(zone)*
<a name="l00917"></a>00917                          this-&gt;<a class="code" href="classPltLoader.php#a1e4e578cc888fcfbf1c064f0c75821b6">jmax</a>(zone)*
<a name="l00918"></a>00918                          this-&gt;<a class="code" href="classPltLoader.php#a71ab54fcbd4b5020196850ce2532d01e">kmax</a>(zone));
<a name="l00919"></a>00919             
<a name="l00920"></a>00920             ddata.resize (this-&gt;<a class="code" href="classPltLoader.php#a70b6ef7c80a5ceee904d8d34f1172f91">imax</a>(zone)*
<a name="l00921"></a>00921                           this-&gt;<a class="code" href="classPltLoader.php#a1e4e578cc888fcfbf1c064f0c75821b6">jmax</a>(zone)*
<a name="l00922"></a>00922                           this-&gt;<a class="code" href="classPltLoader.php#a71ab54fcbd4b5020196850ce2532d01e">kmax</a>(zone));
<a name="l00923"></a>00923             
<a name="l00924"></a>00924             in.read ((<span class="keywordtype">char</span>*) &amp;ddata[0], LIBMESH_SIZEOF_DOUBLE*ddata.size());
<a name="l00925"></a>00925 
<a name="l00926"></a>00926             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;data.size(); i++)
<a name="l00927"></a>00927               data[i] = rb(ddata[i]);
<a name="l00928"></a>00928             
<a name="l00929"></a>00929             <span class="keywordflow">break</span>;
<a name="l00930"></a>00930           }
<a name="l00931"></a>00931                       
<a name="l00932"></a>00932         <span class="keywordflow">default</span>:
<a name="l00933"></a>00933           {
<a name="l00934"></a>00934             std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported data type: &quot;</span>
<a name="l00935"></a>00935                       &lt;&lt; this-&gt;<a class="code" href="classPltLoader.php#a0d2adffec94d16de190f2963aecf96ae">var_type</a>(var)
<a name="l00936"></a>00936                       &lt;&lt; std::endl;
<a name="l00937"></a>00937             libmesh_error();
<a name="l00938"></a>00938           }
<a name="l00939"></a>00939         }
<a name="l00940"></a>00940     }
<a name="l00941"></a>00941 }
<a name="l00942"></a>00942 
<a name="l00943"></a>00943 
<a name="l00944"></a>00944 
<a name="l00945"></a><a class="code" href="classPltLoader.php#aa1ed557b996425568f586997574481f8">00945</a> <span class="keywordtype">void</span> <a class="code" href="classPltLoader.php#aa1ed557b996425568f586997574481f8">PltLoader::read_point_data</a> (std::istream&amp; in, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> zone)
<a name="l00946"></a>00946 {
<a name="l00947"></a>00947   libmesh_assert (in.good());
<a name="l00948"></a>00948 
<a name="l00949"></a>00949   <span class="comment">// A byte-reverser in case the data is foreign</span>
<a name="l00950"></a>00950   <a class="code" href="classUtility_1_1ReverseBytes.php">Utility::ReverseBytes</a> rb(this-&gt;<a class="code" href="classPltLoader.php#abf12f02978300d3b32f3daac9b1c69ea">is_foreign</a>());
<a name="l00951"></a>00951 
<a name="l00952"></a>00952   <span class="comment">// First allocate space</span>
<a name="l00953"></a>00953   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;this-&gt;<a class="code" href="classPltLoader.php#a1120168d3423421b21c4e30c40b2f005">n_vars</a>(); var++)
<a name="l00954"></a>00954     {
<a name="l00955"></a>00955       std::vector&lt;float&gt; &amp; data = <a class="code" href="classPltLoader.php#a39b4d34d4af3db42fca39fcca6f0e870">_data</a>[zone][var];
<a name="l00956"></a>00956       
<a name="l00957"></a>00957       data.clear();
<a name="l00958"></a>00958       data.reserve (this-&gt;<a class="code" href="classPltLoader.php#a70b6ef7c80a5ceee904d8d34f1172f91">imax</a>(zone)*
<a name="l00959"></a>00959                     this-&gt;<a class="code" href="classPltLoader.php#a1e4e578cc888fcfbf1c064f0c75821b6">jmax</a>(zone)*
<a name="l00960"></a>00960                     this-&gt;<a class="code" href="classPltLoader.php#a71ab54fcbd4b5020196850ce2532d01e">kmax</a>(zone));
<a name="l00961"></a>00961     }
<a name="l00962"></a>00962 
<a name="l00963"></a>00963   
<a name="l00964"></a>00964   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;this-&gt;<a class="code" href="classPltLoader.php#a71ab54fcbd4b5020196850ce2532d01e">kmax</a>(zone); k++)
<a name="l00965"></a>00965     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;<a class="code" href="classPltLoader.php#a1e4e578cc888fcfbf1c064f0c75821b6">jmax</a>(zone); j++)
<a name="l00966"></a>00966       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;<a class="code" href="classPltLoader.php#a70b6ef7c80a5ceee904d8d34f1172f91">imax</a>(zone); i++)
<a name="l00967"></a>00967         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;this-&gt;<a class="code" href="classPltLoader.php#a1120168d3423421b21c4e30c40b2f005">n_vars</a>(); var++)
<a name="l00968"></a>00968           <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPltLoader.php#a0d2adffec94d16de190f2963aecf96ae">var_type</a>(var) == <a class="code" href="classPltLoader.php#a0b9f891735de11140d807b4b48e40d7ea51e28cc34852aac84477fe6b95cf4260">FLOAT</a>)
<a name="l00969"></a>00969             {
<a name="l00970"></a>00970               <span class="keywordtype">float</span> f = 0.;
<a name="l00971"></a>00971               
<a name="l00972"></a>00972               libmesh_assert (in.good());
<a name="l00973"></a>00973               
<a name="l00974"></a>00974               in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_FLOAT);
<a name="l00975"></a>00975               std::memcpy  (&amp;f, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_FLOAT);
<a name="l00976"></a>00976               rb(f);
<a name="l00977"></a>00977                     
<a name="l00978"></a>00978               <a class="code" href="classPltLoader.php#a39b4d34d4af3db42fca39fcca6f0e870">_data</a>[zone][var].push_back(f);                    
<a name="l00979"></a>00979             }
<a name="l00980"></a>00980           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPltLoader.php#a0d2adffec94d16de190f2963aecf96ae">var_type</a>(var) == <a class="code" href="classPltLoader.php#a0b9f891735de11140d807b4b48e40d7ea787937a9565017fbbc75eb25f5fa7b89">DOUBLE</a>)
<a name="l00981"></a>00981             {
<a name="l00982"></a>00982               <span class="keywordtype">double</span> d = 0.;
<a name="l00983"></a>00983               
<a name="l00984"></a>00984               libmesh_assert (in.good());
<a name="l00985"></a>00985               
<a name="l00986"></a>00986               in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_DOUBLE);
<a name="l00987"></a>00987               std::memcpy  (&amp;d, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_DOUBLE);
<a name="l00988"></a>00988               rb(d);
<a name="l00989"></a>00989               
<a name="l00990"></a>00990               <a class="code" href="classPltLoader.php#a39b4d34d4af3db42fca39fcca6f0e870">_data</a>[zone][var].push_back(d);                    
<a name="l00991"></a>00991             }
<a name="l00992"></a>00992           <span class="keywordflow">else</span>
<a name="l00993"></a>00993             {
<a name="l00994"></a>00994               std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: unsupported data type: &quot;</span>
<a name="l00995"></a>00995                         &lt;&lt; this-&gt;<a class="code" href="classPltLoader.php#a0d2adffec94d16de190f2963aecf96ae">var_type</a>(var)
<a name="l00996"></a>00996                         &lt;&lt; std::endl;
<a name="l00997"></a>00997               libmesh_error();
<a name="l00998"></a>00998             }
<a name="l00999"></a>00999 }
<a name="l01000"></a>01000 
<a name="l01001"></a>01001 
<a name="l01002"></a>01002 
<a name="l01003"></a><a class="code" href="classPltLoader.php#ab2ed484fcc635813a37fd92f401ea4cb">01003</a> <span class="keywordtype">void</span> <a class="code" href="classPltLoader.php#ab2ed484fcc635813a37fd92f401ea4cb">PltLoader::read_feblock_data</a> (std::istream&amp; in, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> zone)
<a name="l01004"></a>01004 {
<a name="l01005"></a>01005   libmesh_assert (in.good());
<a name="l01006"></a>01006 
<a name="l01007"></a>01007   <span class="comment">// A byte-reverser in case the data is foreign</span>
<a name="l01008"></a>01008   <a class="code" href="classUtility_1_1ReverseBytes.php">Utility::ReverseBytes</a> rb(this-&gt;<a class="code" href="classPltLoader.php#abf12f02978300d3b32f3daac9b1c69ea">is_foreign</a>());
<a name="l01009"></a>01009 
<a name="l01010"></a>01010   <span class="comment">// Read the variable values at each node.</span>
<a name="l01011"></a>01011   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;this-&gt;<a class="code" href="classPltLoader.php#a1120168d3423421b21c4e30c40b2f005">n_vars</a>(); var++) 
<a name="l01012"></a>01012     {      
<a name="l01013"></a>01013       <span class="keywordflow">switch</span> (this-&gt;<a class="code" href="classPltLoader.php#a0d2adffec94d16de190f2963aecf96ae">var_type</a>(var))
<a name="l01014"></a>01014         {
<a name="l01015"></a>01015           
<a name="l01016"></a>01016           <span class="comment">// Read a single-precision variable</span>
<a name="l01017"></a>01017         <span class="keywordflow">case</span> <a class="code" href="classPltLoader.php#a0b9f891735de11140d807b4b48e40d7ea51e28cc34852aac84477fe6b95cf4260">FLOAT</a>:
<a name="l01018"></a>01018           {
<a name="l01019"></a>01019             std::vector&lt;float&gt; &amp; data = <a class="code" href="classPltLoader.php#a39b4d34d4af3db42fca39fcca6f0e870">_data</a>[zone][var];
<a name="l01020"></a>01020             
<a name="l01021"></a>01021             data.clear();
<a name="l01022"></a>01022             data.resize (this-&gt;<a class="code" href="classPltLoader.php#a70b6ef7c80a5ceee904d8d34f1172f91">imax</a>(zone));
<a name="l01023"></a>01023             
<a name="l01024"></a>01024             in.read ((<span class="keywordtype">char</span>*) &amp;data[0], LIBMESH_SIZEOF_FLOAT*data.size());
<a name="l01025"></a>01025 
<a name="l01026"></a>01026             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;data.size(); i++)
<a name="l01027"></a>01027               rb(data[i]);
<a name="l01028"></a>01028             
<a name="l01029"></a>01029             <span class="keywordflow">break</span>;
<a name="l01030"></a>01030           }
<a name="l01031"></a>01031           
<a name="l01032"></a>01032           <span class="comment">// Read a double-precision variable</span>
<a name="l01033"></a>01033         <span class="keywordflow">case</span> <a class="code" href="classPltLoader.php#a0b9f891735de11140d807b4b48e40d7ea787937a9565017fbbc75eb25f5fa7b89">DOUBLE</a>:
<a name="l01034"></a>01034           {
<a name="l01035"></a>01035             std::vector&lt;double&gt; ddata;
<a name="l01036"></a>01036             std::vector&lt;float&gt; &amp; data = <a class="code" href="classPltLoader.php#a39b4d34d4af3db42fca39fcca6f0e870">_data</a>[zone][var];
<a name="l01037"></a>01037             
<a name="l01038"></a>01038             data.clear();
<a name="l01039"></a>01039             data.resize (this-&gt;<a class="code" href="classPltLoader.php#a70b6ef7c80a5ceee904d8d34f1172f91">imax</a>(zone));
<a name="l01040"></a>01040             ddata.resize (this-&gt;<a class="code" href="classPltLoader.php#a70b6ef7c80a5ceee904d8d34f1172f91">imax</a>(zone));
<a name="l01041"></a>01041             
<a name="l01042"></a>01042             in.read ((<span class="keywordtype">char</span>*) &amp;ddata[0], LIBMESH_SIZEOF_DOUBLE*ddata.size());
<a name="l01043"></a>01043 
<a name="l01044"></a>01044             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;data.size(); i++)
<a name="l01045"></a>01045               data[i] = rb(ddata[i]);
<a name="l01046"></a>01046             
<a name="l01047"></a>01047             <span class="keywordflow">break</span>;
<a name="l01048"></a>01048           }
<a name="l01049"></a>01049                       
<a name="l01050"></a>01050         <span class="keywordflow">default</span>:
<a name="l01051"></a>01051           {
<a name="l01052"></a>01052             std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported data type: &quot;</span>
<a name="l01053"></a>01053                       &lt;&lt; this-&gt;<a class="code" href="classPltLoader.php#a0d2adffec94d16de190f2963aecf96ae">var_type</a>(var)
<a name="l01054"></a>01054                       &lt;&lt; std::endl;
<a name="l01055"></a>01055             libmesh_error();
<a name="l01056"></a>01056           }
<a name="l01057"></a>01057         }
<a name="l01058"></a>01058     }
<a name="l01059"></a>01059 
<a name="l01060"></a>01060   <span class="comment">// Read the connectivity</span>
<a name="l01061"></a>01061   {
<a name="l01062"></a>01062     <span class="comment">// Get the connectivity repetition flag</span>
<a name="l01063"></a>01063     <span class="keywordtype">int</span> rep=0;
<a name="l01064"></a>01064     in.read ((<span class="keywordtype">char</span>*) &amp;rep, LIBMESH_SIZEOF_INT);
<a name="l01065"></a>01065     rb(rep);
<a name="l01066"></a>01066 
<a name="l01067"></a>01067     <span class="keywordflow">if</span> (rep == 1 &amp;&amp; this-&gt;<a class="code" href="classPltLoader.php#a32454a413f74ab14ac846a9faadbdc8e">n_zones</a>() &gt; 1)
<a name="l01068"></a>01068       {
<a name="l01069"></a>01069         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR:  Repeated connectivity not supported!&quot;</span>
<a name="l01070"></a>01070                   &lt;&lt; std::endl;
<a name="l01071"></a>01071         libmesh_error();
<a name="l01072"></a>01072       }
<a name="l01073"></a>01073 
<a name="l01074"></a>01074     <span class="comment">// Read the connectivity</span>
<a name="l01075"></a>01075     <span class="keywordflow">else</span>
<a name="l01076"></a>01076       {
<a name="l01077"></a>01077         libmesh_assert (zone &lt; <a class="code" href="classPltLoader.php#afa77d70ceb6c610f960c5dcf600de3d9">_conn</a>.size());
<a name="l01078"></a>01078         libmesh_assert (this-&gt;<a class="code" href="classPltLoader.php#a71ab54fcbd4b5020196850ce2532d01e">kmax</a>(zone) &lt; 4);
<a name="l01079"></a>01079         
<a name="l01080"></a>01080         <a class="code" href="classPltLoader.php#afa77d70ceb6c610f960c5dcf600de3d9">_conn</a>[zone].resize (this-&gt;<a class="code" href="classPltLoader.php#a1e4e578cc888fcfbf1c064f0c75821b6">jmax</a>(zone)*<a class="code" href="classPltLoader.php#a045da2801491cbd4130cc84808e6e51d">NNodes</a>[this-&gt;<a class="code" href="classPltLoader.php#a71ab54fcbd4b5020196850ce2532d01e">kmax</a>(zone)]);
<a name="l01081"></a>01081         
<a name="l01082"></a>01082         in.read ((<span class="keywordtype">char</span>*) &amp;<a class="code" href="classPltLoader.php#afa77d70ceb6c610f960c5dcf600de3d9">_conn</a>[zone][0], LIBMESH_SIZEOF_INT*<a class="code" href="classPltLoader.php#afa77d70ceb6c610f960c5dcf600de3d9">_conn</a>[zone].size());
<a name="l01083"></a>01083 
<a name="l01084"></a>01084         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classPltLoader.php#afa77d70ceb6c610f960c5dcf600de3d9">_conn</a>[zone].size(); i++)
<a name="l01085"></a>01085           rb(<a class="code" href="classPltLoader.php#afa77d70ceb6c610f960c5dcf600de3d9">_conn</a>[zone][i]);
<a name="l01086"></a>01086       }
<a name="l01087"></a>01087   }  
<a name="l01088"></a>01088 }
<a name="l01089"></a>01089 
<a name="l01090"></a>01090 
<a name="l01091"></a>01091 
<a name="l01092"></a><a class="code" href="classPltLoader.php#afd01d27bc6ef20a1bb1c15595cdc8ddf">01092</a> <span class="keywordtype">void</span> <a class="code" href="classPltLoader.php#afd01d27bc6ef20a1bb1c15595cdc8ddf">PltLoader::read_fepoint_data</a> (std::istream&amp; in, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> zone)
<a name="l01093"></a>01093 {
<a name="l01094"></a>01094   libmesh_assert (in.good());
<a name="l01095"></a>01095 
<a name="l01096"></a>01096   <span class="comment">// A byte-reverser in case the data is foreign</span>
<a name="l01097"></a>01097   <a class="code" href="classUtility_1_1ReverseBytes.php">Utility::ReverseBytes</a> rb(this-&gt;<a class="code" href="classPltLoader.php#abf12f02978300d3b32f3daac9b1c69ea">is_foreign</a>());
<a name="l01098"></a>01098 
<a name="l01099"></a>01099   <span class="comment">// First allocate space</span>
<a name="l01100"></a>01100   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;this-&gt;<a class="code" href="classPltLoader.php#a1120168d3423421b21c4e30c40b2f005">n_vars</a>(); var++)
<a name="l01101"></a>01101     {
<a name="l01102"></a>01102       std::vector&lt;float&gt; &amp; data = <a class="code" href="classPltLoader.php#a39b4d34d4af3db42fca39fcca6f0e870">_data</a>[zone][var];
<a name="l01103"></a>01103       
<a name="l01104"></a>01104       data.clear();
<a name="l01105"></a>01105       data.reserve (this-&gt;<a class="code" href="classPltLoader.php#a70b6ef7c80a5ceee904d8d34f1172f91">imax</a>(zone));
<a name="l01106"></a>01106     }
<a name="l01107"></a>01107 
<a name="l01108"></a>01108   
<a name="l01109"></a>01109   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;<a class="code" href="classPltLoader.php#a70b6ef7c80a5ceee904d8d34f1172f91">imax</a>(zone); i++)
<a name="l01110"></a>01110     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;this-&gt;<a class="code" href="classPltLoader.php#a1120168d3423421b21c4e30c40b2f005">n_vars</a>(); var++)
<a name="l01111"></a>01111       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPltLoader.php#a0d2adffec94d16de190f2963aecf96ae">var_type</a>(var) == <a class="code" href="classPltLoader.php#a0b9f891735de11140d807b4b48e40d7ea51e28cc34852aac84477fe6b95cf4260">FLOAT</a>)
<a name="l01112"></a>01112         {
<a name="l01113"></a>01113           <span class="keywordtype">float</span> f = 0.;
<a name="l01114"></a>01114           
<a name="l01115"></a>01115           libmesh_assert (in.good());
<a name="l01116"></a>01116           
<a name="l01117"></a>01117           in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_FLOAT);
<a name="l01118"></a>01118           std::memcpy  (&amp;f, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_FLOAT);
<a name="l01119"></a>01119           rb(f);
<a name="l01120"></a>01120           
<a name="l01121"></a>01121           <a class="code" href="classPltLoader.php#a39b4d34d4af3db42fca39fcca6f0e870">_data</a>[zone][var].push_back(f);                        
<a name="l01122"></a>01122         }
<a name="l01123"></a>01123       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPltLoader.php#a0d2adffec94d16de190f2963aecf96ae">var_type</a>(var) == <a class="code" href="classPltLoader.php#a0b9f891735de11140d807b4b48e40d7ea787937a9565017fbbc75eb25f5fa7b89">DOUBLE</a>)
<a name="l01124"></a>01124         {
<a name="l01125"></a>01125           <span class="keywordtype">double</span> d = 0.;
<a name="l01126"></a>01126           
<a name="l01127"></a>01127           libmesh_assert (in.good());
<a name="l01128"></a>01128           
<a name="l01129"></a>01129           in.read (<a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_DOUBLE);
<a name="l01130"></a>01130           std::memcpy  (&amp;d, <a class="code" href="classPltLoader.php#a7284c94fd24df17130b429c5893a988e">buf</a>, LIBMESH_SIZEOF_DOUBLE);
<a name="l01131"></a>01131           rb(d);
<a name="l01132"></a>01132           
<a name="l01133"></a>01133           <a class="code" href="classPltLoader.php#a39b4d34d4af3db42fca39fcca6f0e870">_data</a>[zone][var].push_back(d);                        
<a name="l01134"></a>01134         }
<a name="l01135"></a>01135       <span class="keywordflow">else</span>
<a name="l01136"></a>01136         {
<a name="l01137"></a>01137           std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: unsupported data type: &quot;</span>
<a name="l01138"></a>01138                     &lt;&lt; this-&gt;<a class="code" href="classPltLoader.php#a0d2adffec94d16de190f2963aecf96ae">var_type</a>(var)
<a name="l01139"></a>01139                     &lt;&lt; std::endl;
<a name="l01140"></a>01140           libmesh_error();
<a name="l01141"></a>01141         }
<a name="l01142"></a>01142 
<a name="l01143"></a>01143   <span class="comment">// Read the connectivity</span>
<a name="l01144"></a>01144   {
<a name="l01145"></a>01145     <span class="comment">// Get the connectivity repetition flag</span>
<a name="l01146"></a>01146     <span class="keywordtype">int</span> rep=0;
<a name="l01147"></a>01147 
<a name="l01148"></a>01148     in.read ((<span class="keywordtype">char</span>*) &amp;rep, LIBMESH_SIZEOF_INT);
<a name="l01149"></a>01149     rb(rep);
<a name="l01150"></a>01150 
<a name="l01151"></a>01151     <span class="keywordflow">if</span> (rep == 1)
<a name="l01152"></a>01152       {
<a name="l01153"></a>01153         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR:  Repeated connectivity not supported!&quot;</span>
<a name="l01154"></a>01154                   &lt;&lt; std::endl;
<a name="l01155"></a>01155         libmesh_error();
<a name="l01156"></a>01156       }
<a name="l01157"></a>01157 
<a name="l01158"></a>01158     <span class="comment">// Read the connectivity</span>
<a name="l01159"></a>01159     <span class="keywordflow">else</span>
<a name="l01160"></a>01160       {
<a name="l01161"></a>01161         libmesh_assert (zone &lt; <a class="code" href="classPltLoader.php#afa77d70ceb6c610f960c5dcf600de3d9">_conn</a>.size());
<a name="l01162"></a>01162         libmesh_assert (this-&gt;<a class="code" href="classPltLoader.php#a71ab54fcbd4b5020196850ce2532d01e">kmax</a>(zone) &lt; 4);
<a name="l01163"></a>01163         
<a name="l01164"></a>01164         <a class="code" href="classPltLoader.php#afa77d70ceb6c610f960c5dcf600de3d9">_conn</a>[zone].resize (this-&gt;<a class="code" href="classPltLoader.php#a1e4e578cc888fcfbf1c064f0c75821b6">jmax</a>(zone)*<a class="code" href="classPltLoader.php#a045da2801491cbd4130cc84808e6e51d">NNodes</a>[this-&gt;<a class="code" href="classPltLoader.php#a71ab54fcbd4b5020196850ce2532d01e">kmax</a>(zone)]);
<a name="l01165"></a>01165         
<a name="l01166"></a>01166         in.read ((<span class="keywordtype">char</span>*) &amp;<a class="code" href="classPltLoader.php#afa77d70ceb6c610f960c5dcf600de3d9">_conn</a>[zone][0], LIBMESH_SIZEOF_INT*<a class="code" href="classPltLoader.php#afa77d70ceb6c610f960c5dcf600de3d9">_conn</a>[zone].size());
<a name="l01167"></a>01167 
<a name="l01168"></a>01168         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classPltLoader.php#afa77d70ceb6c610f960c5dcf600de3d9">_conn</a>[zone].size(); i++)
<a name="l01169"></a>01169           rb(<a class="code" href="classPltLoader.php#afa77d70ceb6c610f960c5dcf600de3d9">_conn</a>[zone][i]);
<a name="l01170"></a>01170       }
<a name="l01171"></a>01171   }
<a name="l01172"></a>01172 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
