<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_c2e5aa429b9110fa734bdc9647d91e10.php">utils</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>point_locator_base.C</h1>  </div>
</div>
<div class="contents">
<a href="point__locator__base_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: point_locator_base.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local Includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;point_locator_base.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;point_locator_tree.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;point_locator_list.h&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00034"></a>00034 <span class="comment">// PointLocatorBase methods</span>
<a name="l00035"></a><a class="code" href="classPointLocatorBase.php#ac107e5100257b6784dab4e39063e8fa4">00035</a> <a class="code" href="classPointLocatorBase.php#ac107e5100257b6784dab4e39063e8fa4">PointLocatorBase::PointLocatorBase</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00036"></a>00036                                     <span class="keyword">const</span> <a class="code" href="classPointLocatorBase.php">PointLocatorBase</a>* master) :
<a name="l00037"></a>00037   _master                  (master),
<a name="l00038"></a>00038   _mesh                    (mesh),
<a name="l00039"></a>00039   _initialized             (false)
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041 }
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a><a class="code" href="classPointLocatorBase.php#a938bc769e8505519fad58b100252128b">00047</a> <a class="code" href="classPointLocatorBase.php#a938bc769e8505519fad58b100252128b">PointLocatorBase::~PointLocatorBase</a> ()
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049 }
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="classPointLocatorBase.php#a01b4bbbfdbdd15cb1747511677e975da">00055</a> <a class="code" href="classAutoPtr.php">AutoPtr&lt;PointLocatorBase&gt;</a> <a class="code" href="classPointLocatorBase.php#a01b4bbbfdbdd15cb1747511677e975da">PointLocatorBase::build</a> (<span class="keyword">const</span> <a class="code" href="namespaceMeshEnums.php#a9f0dd4dc83b7c35010fc10eaad442670">PointLocatorType</a> t,
<a name="l00056"></a>00056                                                    <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00057"></a>00057                                                    <span class="keyword">const</span> <a class="code" href="classPointLocatorBase.php">PointLocatorBase</a>* master)
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059   <span class="keywordflow">switch</span> (t)
<a name="l00060"></a>00060     {
<a name="l00061"></a>00061     <span class="keywordflow">case</span> <a class="code" href="namespaceMeshEnums.php#a9f0dd4dc83b7c35010fc10eaad442670a1d10cc4a6034c660fed720fb3e69b90b">TREE</a>:
<a name="l00062"></a>00062       {
<a name="l00063"></a>00063         <a class="code" href="classAutoPtr.php">AutoPtr&lt;PointLocatorBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classPointLocatorTree.php">PointLocatorTree</a>(mesh,
<a name="l00064"></a>00064                                                           master));
<a name="l00065"></a>00065         <span class="keywordflow">return</span> ap;
<a name="l00066"></a>00066       }
<a name="l00067"></a>00067 
<a name="l00068"></a>00068     <span class="keywordflow">case</span> <a class="code" href="namespaceMeshEnums.php#a9f0dd4dc83b7c35010fc10eaad442670ad0224fd598f206514df2a6b3f6df8683">LIST</a>:
<a name="l00069"></a>00069       {
<a name="l00070"></a>00070         <a class="code" href="classAutoPtr.php">AutoPtr&lt;PointLocatorBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classPointLocatorList.php">PointLocatorList</a>(mesh,
<a name="l00071"></a>00071                                                           master));
<a name="l00072"></a>00072         <span class="keywordflow">return</span> ap;
<a name="l00073"></a>00073       }
<a name="l00074"></a>00074 
<a name="l00075"></a>00075     <span class="keywordflow">default</span>:
<a name="l00076"></a>00076       {
<a name="l00077"></a>00077         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad PointLocatorType = &quot;</span> &lt;&lt; t &lt;&lt; std::endl;
<a name="l00078"></a>00078         libmesh_error();
<a name="l00079"></a>00079       }
<a name="l00080"></a>00080     }
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   libmesh_error();
<a name="l00083"></a>00083   <a class="code" href="classAutoPtr.php">AutoPtr&lt;PointLocatorBase&gt;</a> ap(NULL);
<a name="l00084"></a>00084   <span class="keywordflow">return</span> ap;
<a name="l00085"></a>00085 }
<a name="l00086"></a>00086 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
