<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_4f64d75cac7489d141591c33108e86ff.php">utils</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>point_locator_base.h</h1>  </div>
</div>
<div class="contents">
<a href="point__locator__base_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: point_locator_base.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __point_locator_base_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __point_locator_base_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local Includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;reference_counted_object.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;auto_ptr.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;enum_point_locator_type.h&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// Forward Declarations</span>
<a name="l00039"></a>00039 <span class="keyword">class </span><a class="code" href="classPointLocatorBase.php">PointLocatorBase</a>;
<a name="l00040"></a>00040 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00041"></a>00041 <span class="keyword">class </span><a class="code" href="classPoint.php">Point</a>;
<a name="l00042"></a>00042 <span class="keyword">class </span><a class="code" href="classTreeBase.php">TreeBase</a>;
<a name="l00043"></a>00043 <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00055"></a>00055 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00056"></a>00056 <span class="comment">// PointLocatorBase class definition</span>
<a name="l00057"></a><a class="code" href="classPointLocatorBase.php">00057</a> <span class="keyword">class </span><a class="code" href="classPointLocatorBase.php">PointLocatorBase</a> : <span class="keyword">public</span> <a class="code" href="classReferenceCountedObject.php">ReferenceCountedObject</a>&lt;PointLocatorBase&gt;
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059 <span class="keyword">protected</span>:
<a name="l00060"></a>00060 
<a name="l00066"></a>00066   <a class="code" href="classPointLocatorBase.php#ac107e5100257b6784dab4e39063e8fa4">PointLocatorBase</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00067"></a>00067                     <span class="keyword">const</span> <a class="code" href="classPointLocatorBase.php">PointLocatorBase</a>* master);
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 <span class="keyword">public</span>:
<a name="l00071"></a>00071 
<a name="l00075"></a>00075   <span class="keyword">virtual</span> <a class="code" href="classPointLocatorBase.php#a938bc769e8505519fad58b100252128b">~PointLocatorBase</a> ();
<a name="l00076"></a>00076 
<a name="l00083"></a>00083   <span class="keyword">static</span> <a class="code" href="classAutoPtr.php">AutoPtr&lt;PointLocatorBase&gt;</a> <a class="code" href="classPointLocatorBase.php#a01b4bbbfdbdd15cb1747511677e975da">build</a> (<span class="keyword">const</span> <a class="code" href="namespaceMeshEnums.php#a9f0dd4dc83b7c35010fc10eaad442670">PointLocatorType</a> t,
<a name="l00084"></a>00084                                           <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00085"></a>00085                                           <span class="keyword">const</span> <a class="code" href="classPointLocatorBase.php">PointLocatorBase</a>* master = NULL);
<a name="l00086"></a>00086 
<a name="l00090"></a>00090   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPointLocatorBase.php#abded8fb6117cdceb576b45320735e3e7">clear</a>() = 0;
<a name="l00091"></a>00091 
<a name="l00096"></a>00096   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPointLocatorBase.php#ade713830da0519113dee6f13bb3d465d">init</a>() = 0;
<a name="l00097"></a>00097 
<a name="l00102"></a>00102   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classPointLocatorBase.php#a90985874509dcd0f723a2e6194b70ac4">operator() </a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p) <span class="keyword">const</span> = 0;
<a name="l00103"></a>00103 
<a name="l00108"></a>00108   <span class="keywordtype">bool</span> <a class="code" href="classPointLocatorBase.php#a05b6f9b39ed157b3e1b2d0230dd1f5c4">initialized</a> () <span class="keyword">const</span>;
<a name="l00109"></a>00109 
<a name="l00116"></a>00116   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPointLocatorBase.php#aec919dca35fe706fee3bb10c2aa1f52b">enable_out_of_mesh_mode</a> (<span class="keywordtype">void</span>) = 0;
<a name="l00117"></a>00117 
<a name="l00123"></a>00123   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPointLocatorBase.php#af85fad7094f10dbb9d6095738c960474">disable_out_of_mesh_mode</a> (<span class="keywordtype">void</span>) = 0;
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 <span class="keyword">protected</span>:
<a name="l00126"></a>00126 
<a name="l00132"></a><a class="code" href="classPointLocatorBase.php#a3560565f31424666cec69650486bd024">00132</a>   <span class="keyword">const</span> <a class="code" href="classPointLocatorBase.php">PointLocatorBase</a>* <a class="code" href="classPointLocatorBase.php#a3560565f31424666cec69650486bd024">_master</a>;
<a name="l00133"></a>00133   
<a name="l00137"></a><a class="code" href="classPointLocatorBase.php#a33c0eef7f3345539d618f9b0f85f3790">00137</a>   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classPointLocatorBase.php#a33c0eef7f3345539d618f9b0f85f3790">_mesh</a>;
<a name="l00138"></a>00138 
<a name="l00142"></a><a class="code" href="classPointLocatorBase.php#a34945133769f261c1c0b3e1f8d6d71fc">00142</a>   <span class="keywordtype">bool</span> <a class="code" href="classPointLocatorBase.php#a34945133769f261c1c0b3e1f8d6d71fc">_initialized</a>;
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 };
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00148"></a>00148 <span class="comment">// PointLocatorBase inline methods</span>
<a name="l00149"></a>00149 <span class="keyword">inline</span>
<a name="l00150"></a><a class="code" href="classPointLocatorBase.php#a05b6f9b39ed157b3e1b2d0230dd1f5c4">00150</a> <span class="keywordtype">bool</span> <a class="code" href="classPointLocatorBase.php#a05b6f9b39ed157b3e1b2d0230dd1f5c4">PointLocatorBase::initialized</a> ()<span class="keyword"> const</span>
<a name="l00151"></a>00151 <span class="keyword"></span>{
<a name="l00152"></a>00152   <span class="keywordflow">return</span> (this-&gt;<a class="code" href="classPointLocatorBase.php#a34945133769f261c1c0b3e1f8d6d71fc">_initialized</a>);
<a name="l00153"></a>00153 }
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 <span class="preprocessor">#endif</span>
<a name="l00156"></a>00156 <span class="preprocessor"></span>
<a name="l00157"></a>00157 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
