<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_4f64d75cac7489d141591c33108e86ff.php">utils</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>point_locator_list.h</h1>  </div>
</div>
<div class="contents">
<a href="point__locator__list_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: point_locator_list.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __point_locator_list_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __point_locator_list_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;utility&gt;</span> <span class="comment">// pair</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local Includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="point__locator__base_8h.php">point_locator_base.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Forward Declarations</span>
<a name="l00036"></a>00036 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00037"></a>00037 <span class="keyword">class </span><a class="code" href="classPoint.php">Point</a>;
<a name="l00038"></a>00038 <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00065"></a>00065 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00066"></a>00066 <span class="comment">// PointLocatorList class definition</span>
<a name="l00067"></a><a class="code" href="classPointLocatorList.php">00067</a> <span class="keyword">class </span><a class="code" href="classPointLocatorList.php">PointLocatorList</a> : <span class="keyword">public</span> <a class="code" href="classPointLocatorBase.php">PointLocatorBase</a>
<a name="l00068"></a>00068 {
<a name="l00069"></a>00069 <span class="keyword">public</span>:
<a name="l00070"></a>00070 
<a name="l00080"></a>00080   <a class="code" href="classPointLocatorList.php#a6f99b534e4f7ae15758cacbb10088f26">PointLocatorList</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00081"></a>00081                     <span class="keyword">const</span> <a class="code" href="classPointLocatorBase.php">PointLocatorBase</a>* master = NULL);
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 <span class="keyword">public</span>:
<a name="l00085"></a>00085 
<a name="l00089"></a>00089   <a class="code" href="classPointLocatorList.php#abd759ecb5cc600d59ed428727669bf36">~PointLocatorList</a> ();
<a name="l00090"></a>00090 
<a name="l00095"></a>00095   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPointLocatorList.php#a86d1b6989c1bd9dc4764739e94a33894">clear</a>();
<a name="l00096"></a>00096 
<a name="l00102"></a>00102   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPointLocatorList.php#af71f34871ee10039e0deea810487c2a2">init</a>();
<a name="l00103"></a>00103 
<a name="l00108"></a>00108   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classPointLocatorList.php#a79065af32c598cb2a2d510c17584a11f">operator() </a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00109"></a>00109 
<a name="l00116"></a>00116   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPointLocatorList.php#a97f9fd20e6cec89e0decfd66692d2c2a">enable_out_of_mesh_mode</a> (<span class="keywordtype">void</span>);
<a name="l00117"></a>00117 
<a name="l00123"></a>00123   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPointLocatorList.php#a6d9d06e46d253e7b0ede9ad441b3ad2f">disable_out_of_mesh_mode</a> (<span class="keywordtype">void</span>);
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 <span class="keyword">protected</span>:
<a name="l00126"></a>00126 
<a name="l00133"></a><a class="code" href="classPointLocatorList.php#a09c82ffa1a6d7a814401a484a8b68cd9">00133</a>   std::vector&lt;std::pair&lt;Point, const Elem *&gt; &gt;* <a class="code" href="classPointLocatorList.php#a09c82ffa1a6d7a814401a484a8b68cd9">_list</a>;
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 };
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00139"></a>00139 <span class="comment">// PointLocatorList inline methods</span>
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 <span class="preprocessor">#endif</span>
<a name="l00143"></a>00143 <span class="preprocessor"></span>
<a name="l00144"></a>00144 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
