<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_c2e5aa429b9110fa734bdc9647d91e10.php">utils</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>point_locator_tree.C</h1>  </div>
</div>
<div class="contents">
<a href="point__locator__tree_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: point_locator_tree.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;tree.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;point_locator_tree.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;mesh_tools.h&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00034"></a>00034 <span class="comment">// PointLocator methods</span>
<a name="l00035"></a><a class="code" href="classPointLocatorTree.php#a0069c8558a55cc11d5c31934006bf85d">00035</a> <a class="code" href="classPointLocatorTree.php#a0069c8558a55cc11d5c31934006bf85d">PointLocatorTree::PointLocatorTree</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00036"></a>00036                                     <span class="keyword">const</span> <a class="code" href="classPointLocatorBase.php">PointLocatorBase</a>* master) :
<a name="l00037"></a>00037   <a class="code" href="classPointLocatorBase.php">PointLocatorBase</a> (mesh,master),
<a name="l00038"></a>00038   _tree            (NULL),
<a name="l00039"></a>00039   _element         (NULL),
<a name="l00040"></a>00040   _out_of_mesh_mode(false)
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042   this-&gt;<a class="code" href="classPointLocatorTree.php#a47dd94ede01e541e6c9de6b760502ee0">init</a>(<a class="code" href="namespaceTrees.php#a8fb02eb8a700b646d106718a2d0ca3efa6ec2eeb88ab0a36caf9a31d79c3da8cb">Trees::NODES</a>);
<a name="l00043"></a>00043 }
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00048"></a><a class="code" href="classPointLocatorTree.php#a117d3833d729d2baf98e371ee85a4f42">00048</a> <a class="code" href="classPointLocatorTree.php#a0069c8558a55cc11d5c31934006bf85d">PointLocatorTree::PointLocatorTree</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00049"></a>00049                                     <span class="keyword">const</span> <a class="code" href="namespaceTrees.php#a8fb02eb8a700b646d106718a2d0ca3ef">Trees::BuildType</a> build_type,
<a name="l00050"></a>00050                                     <span class="keyword">const</span> <a class="code" href="classPointLocatorBase.php">PointLocatorBase</a>* master) :
<a name="l00051"></a>00051   <a class="code" href="classPointLocatorBase.php">PointLocatorBase</a> (mesh,master),
<a name="l00052"></a>00052   _tree            (NULL),
<a name="l00053"></a>00053   _element         (NULL),
<a name="l00054"></a>00054   _out_of_mesh_mode(false)
<a name="l00055"></a>00055 {
<a name="l00056"></a>00056   this-&gt;<a class="code" href="classPointLocatorTree.php#a47dd94ede01e541e6c9de6b760502ee0">init</a>(build_type);
<a name="l00057"></a>00057 }
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a><a class="code" href="classPointLocatorTree.php#a80f2ce6505074e05266d54ba5cae0307">00062</a> <a class="code" href="classPointLocatorTree.php#a80f2ce6505074e05266d54ba5cae0307">PointLocatorTree::~PointLocatorTree</a> ()
<a name="l00063"></a>00063 {
<a name="l00064"></a>00064   this-&gt;<a class="code" href="classPointLocatorTree.php#a4f70369549fdb0d8709ba55321eaff49">clear</a> ();
<a name="l00065"></a>00065 }
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 
<a name="l00070"></a><a class="code" href="classPointLocatorTree.php#a4f70369549fdb0d8709ba55321eaff49">00070</a> <span class="keywordtype">void</span> <a class="code" href="classPointLocatorTree.php#a4f70369549fdb0d8709ba55321eaff49">PointLocatorTree::clear</a> ()
<a name="l00071"></a>00071 {
<a name="l00072"></a>00072   <span class="comment">// only delete the tree when we are the master</span>
<a name="l00073"></a>00073   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPointLocatorTree.php#a74b3656c5eb5531fe876c7a22e2e1db5">_tree</a> != NULL)
<a name="l00074"></a>00074     {
<a name="l00075"></a>00075       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPointLocatorBase.php#a3560565f31424666cec69650486bd024">_master</a> == NULL)
<a name="l00076"></a>00076           <span class="comment">// we own the tree</span>
<a name="l00077"></a>00077           <span class="keyword">delete</span> this-&gt;<a class="code" href="classPointLocatorTree.php#a74b3656c5eb5531fe876c7a22e2e1db5">_tree</a>;
<a name="l00078"></a>00078       <span class="keywordflow">else</span>
<a name="l00079"></a>00079           <span class="comment">// someone else owns and therefore deletes the tree</span>
<a name="l00080"></a>00080           this-&gt;<a class="code" href="classPointLocatorTree.php#a74b3656c5eb5531fe876c7a22e2e1db5">_tree</a> = NULL;
<a name="l00081"></a>00081     }
<a name="l00082"></a>00082 }
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
<a name="l00088"></a><a class="code" href="classPointLocatorTree.php#a2e0159748203271a0aedeb411dd7d0b3">00088</a> <span class="keywordtype">void</span> <a class="code" href="classPointLocatorTree.php#a47dd94ede01e541e6c9de6b760502ee0">PointLocatorTree::init</a> (<span class="keyword">const</span> <a class="code" href="namespaceTrees.php#a8fb02eb8a700b646d106718a2d0ca3ef">Trees::BuildType</a> build_type)
<a name="l00089"></a>00089 {
<a name="l00090"></a>00090   libmesh_assert (this-&gt;<a class="code" href="classPointLocatorTree.php#a74b3656c5eb5531fe876c7a22e2e1db5">_tree</a> == NULL); 
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPointLocatorBase.php#a34945133769f261c1c0b3e1f8d6d71fc">_initialized</a>)
<a name="l00093"></a>00093     {
<a name="l00094"></a>00094       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Already initialized!  Will ignore this call...&quot;</span>
<a name="l00095"></a>00095                 &lt;&lt; std::endl;
<a name="l00096"></a>00096     }
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   <span class="keywordflow">else</span>
<a name="l00099"></a>00099 
<a name="l00100"></a>00100     {
<a name="l00101"></a>00101 
<a name="l00102"></a>00102       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPointLocatorBase.php#a3560565f31424666cec69650486bd024">_master</a> == NULL)
<a name="l00103"></a>00103         {
<a name="l00104"></a>00104           <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPointLocatorBase.php#a33c0eef7f3345539d618f9b0f85f3790">_mesh</a>.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>() == 3)
<a name="l00105"></a>00105             <a class="code" href="classPointLocatorTree.php#a74b3656c5eb5531fe876c7a22e2e1db5">_tree</a> = <span class="keyword">new</span> <a class="code" href="classTree.php">Trees::OctTree</a> (this-&gt;<a class="code" href="classPointLocatorBase.php#a33c0eef7f3345539d618f9b0f85f3790">_mesh</a>, 200, build_type);          
<a name="l00106"></a>00106           <span class="keywordflow">else</span>
<a name="l00107"></a>00107             {
<a name="l00108"></a>00108               <span class="comment">// A 1D/2D mesh in 3D space needs special consideration.</span>
<a name="l00109"></a>00109               <span class="comment">// If the mesh is planar XY, we want to build a QuadTree</span>
<a name="l00110"></a>00110               <span class="comment">// to search efficiently.  If the mesh is truly a manifold,</span>
<a name="l00111"></a>00111               <span class="comment">// then we need an octree</span>
<a name="l00112"></a>00112               <span class="keywordtype">bool</span> is_planar_xy = <span class="keyword">false</span>;
<a name="l00113"></a>00113               
<a name="l00114"></a>00114               <span class="comment">// Build the bounding box for the mesh.  If the delta-z bound is</span>
<a name="l00115"></a>00115               <span class="comment">// negligibly small then we can use a quadtree.</span>
<a name="l00116"></a>00116               {
<a name="l00117"></a>00117                 <a class="code" href="classMeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a> bbox = <a class="code" href="namespaceMeshTools.php#ad533681876e9809cfe5e2114886b1c03">MeshTools::bounding_box</a>(this-&gt;<a class="code" href="classPointLocatorBase.php#a33c0eef7f3345539d618f9b0f85f3790">_mesh</a>);
<a name="l00118"></a>00118                 
<a name="l00119"></a>00119                 <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>
<a name="l00120"></a>00120                   Dx = bbox.second(0) - bbox.first(0),
<a name="l00121"></a>00121                   Dz = bbox.second(2) - bbox.first(2);
<a name="l00122"></a>00122                 
<a name="l00123"></a>00123                 <span class="keywordflow">if</span> (std::abs(Dz/(Dx + 1.e-20)) &lt; 1e-10)
<a name="l00124"></a>00124                   is_planar_xy = <span class="keyword">true</span>;
<a name="l00125"></a>00125               }
<a name="l00126"></a>00126                             
<a name="l00127"></a>00127               <span class="keywordflow">if</span> (is_planar_xy)
<a name="l00128"></a>00128                 <a class="code" href="classPointLocatorTree.php#a74b3656c5eb5531fe876c7a22e2e1db5">_tree</a> = <span class="keyword">new</span> <a class="code" href="namespaceTrees.php#aa31e55d7a4d60fa095885778b546d623">Trees::QuadTree</a> (this-&gt;<a class="code" href="classPointLocatorBase.php#a33c0eef7f3345539d618f9b0f85f3790">_mesh</a>, 200, build_type);
<a name="l00129"></a>00129               <span class="keywordflow">else</span>
<a name="l00130"></a>00130                 <a class="code" href="classPointLocatorTree.php#a74b3656c5eb5531fe876c7a22e2e1db5">_tree</a> = <span class="keyword">new</span> <a class="code" href="namespaceTrees.php#a5d5e8a484b5dac1ba377b8d53bcf5da9">Trees::OctTree</a> (this-&gt;<a class="code" href="classPointLocatorBase.php#a33c0eef7f3345539d618f9b0f85f3790">_mesh</a>, 200, build_type);
<a name="l00131"></a>00131             }
<a name="l00132"></a>00132         }
<a name="l00133"></a>00133 
<a name="l00134"></a>00134       <span class="keywordflow">else</span>
<a name="l00135"></a>00135           
<a name="l00136"></a>00136         {
<a name="l00137"></a>00137           <span class="comment">// We are _not_ the master.  Let our Tree point to</span>
<a name="l00138"></a>00138           <span class="comment">// the master&#39;s tree.  But for this we first transform</span>
<a name="l00139"></a>00139           <span class="comment">// the master in a state for which we are friends.</span>
<a name="l00140"></a>00140           <span class="comment">// And make sure the master @e has a tree!</span>
<a name="l00141"></a>00141           <span class="keyword">const</span> <a class="code" href="classPointLocatorTree.php">PointLocatorTree</a>* my_master =
<a name="l00142"></a>00142             libmesh_cast_ptr&lt;const PointLocatorTree*&gt;(this-&gt;<a class="code" href="classPointLocatorBase.php#a3560565f31424666cec69650486bd024">_master</a>);
<a name="l00143"></a>00143 
<a name="l00144"></a>00144           <span class="keywordflow">if</span> (my_master-&gt;<a class="code" href="classPointLocatorBase.php#a05b6f9b39ed157b3e1b2d0230dd1f5c4">initialized</a>())
<a name="l00145"></a>00145             this-&gt;<a class="code" href="classPointLocatorTree.php#a74b3656c5eb5531fe876c7a22e2e1db5">_tree</a> = my_master-&gt;<a class="code" href="classPointLocatorTree.php#a74b3656c5eb5531fe876c7a22e2e1db5">_tree</a>;
<a name="l00146"></a>00146           <span class="keywordflow">else</span>
<a name="l00147"></a>00147             {
<a name="l00148"></a>00148               std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Initialize master first, then servants!&quot;</span>
<a name="l00149"></a>00149                         &lt;&lt; std::endl;
<a name="l00150"></a>00150               libmesh_error();
<a name="l00151"></a>00151             }
<a name="l00152"></a>00152         }
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a>00155       <span class="comment">// Not all PointLocators may own a tree, but all of them</span>
<a name="l00156"></a>00156       <span class="comment">// use their own element pointer.  Let the element pointer</span>
<a name="l00157"></a>00157       <span class="comment">// be unique for every interpolator.</span>
<a name="l00158"></a>00158       <span class="comment">// Suppose the interpolators are used concurrently</span>
<a name="l00159"></a>00159       <span class="comment">// at different locations in the mesh, then it makes quite</span>
<a name="l00160"></a>00160       <span class="comment">// sense to have unique start elements.</span>
<a name="l00161"></a>00161       this-&gt;<a class="code" href="classPointLocatorTree.php#a9a8c4a848a32c2c97b016e2d4a6fe252">_element</a> = NULL;
<a name="l00162"></a>00162     }
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 
<a name="l00165"></a>00165   <span class="comment">// ready for take-off</span>
<a name="l00166"></a>00166   this-&gt;_initialized = <span class="keyword">true</span>;
<a name="l00167"></a>00167 }
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 
<a name="l00173"></a><a class="code" href="classPointLocatorTree.php#ab7e7d88c7a3582ef0bc63fad1dc0f7b0">00173</a> <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classPointLocatorTree.php#ab7e7d88c7a3582ef0bc63fad1dc0f7b0">PointLocatorTree::operator() </a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p)<span class="keyword"> const</span>
<a name="l00174"></a>00174 <span class="keyword"></span>{
<a name="l00175"></a>00175   libmesh_assert (this-&gt;<a class="code" href="classPointLocatorBase.php#a34945133769f261c1c0b3e1f8d6d71fc">_initialized</a>);
<a name="l00176"></a>00176   
<a name="l00177"></a>00177   <span class="comment">// First check the element from last time before asking the tree</span>
<a name="l00178"></a>00178   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPointLocatorTree.php#a9a8c4a848a32c2c97b016e2d4a6fe252">_element</a>==NULL || !(this-&gt;<a class="code" href="classPointLocatorTree.php#a9a8c4a848a32c2c97b016e2d4a6fe252">_element</a>-&gt;<a class="code" href="classElem.php#ace5226376cf53804d20073a0d21b0cbc">contains_point</a>(p)))
<a name="l00179"></a>00179     {
<a name="l00180"></a>00180         <span class="comment">// ask the tree</span>
<a name="l00181"></a>00181         this-&gt;<a class="code" href="classPointLocatorTree.php#a9a8c4a848a32c2c97b016e2d4a6fe252">_element</a> = this-&gt;<a class="code" href="classPointLocatorTree.php#a74b3656c5eb5531fe876c7a22e2e1db5">_tree</a>-&gt;<a class="code" href="classTreeBase.php#ae4e3287db3cd08bf5a19dccab92d1371">find_element</a> (p);
<a name="l00182"></a>00182 
<a name="l00183"></a>00183         <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPointLocatorTree.php#a9a8c4a848a32c2c97b016e2d4a6fe252">_element</a> == NULL)
<a name="l00184"></a>00184           {
<a name="l00185"></a>00185             <span class="comment">/* No element seems to contain this point.  If out-of-mesh</span>
<a name="l00186"></a>00186 <span class="comment">               mode is enabled, just return NULL.  If not, however, we</span>
<a name="l00187"></a>00187 <span class="comment">               have to perform a linear search before we call \p</span>
<a name="l00188"></a>00188 <span class="comment">               libmesh_error() since in the case of curved elements, the</span>
<a name="l00189"></a>00189 <span class="comment">               bounding box computed in \p TreeNode::insert(const</span>
<a name="l00190"></a>00190 <span class="comment">               Elem*) might be slightly inaccurate.  */</span>
<a name="l00191"></a>00191             <span class="keywordflow">if</span>(!<a class="code" href="classPointLocatorTree.php#ab5287c42efc50b3fc18a9d56c3c4fec2">_out_of_mesh_mode</a>)
<a name="l00192"></a>00192               {
<a name="l00193"></a>00193                 <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       pos     = this-&gt;<a class="code" href="classPointLocatorBase.php#a33c0eef7f3345539d618f9b0f85f3790">_mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00194"></a>00194                 <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_pos = this-&gt;<a class="code" href="classPointLocatorBase.php#a33c0eef7f3345539d618f9b0f85f3790">_mesh</a>.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>();
<a name="l00195"></a>00195                 
<a name="l00196"></a>00196                 <span class="keywordflow">for</span> ( ; pos != end_pos; ++pos)
<a name="l00197"></a>00197                   <span class="keywordflow">if</span> ((*pos)-&gt;contains_point(p))
<a name="l00198"></a>00198                     <span class="keywordflow">return</span> this-&gt;<a class="code" href="classPointLocatorTree.php#a9a8c4a848a32c2c97b016e2d4a6fe252">_element</a> = (*pos);
<a name="l00199"></a>00199 
<a name="l00200"></a>00200                 <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPointLocatorTree.php#a9a8c4a848a32c2c97b016e2d4a6fe252">_element</a> == NULL)
<a name="l00201"></a>00201                   {
<a name="l00202"></a>00202                     std::cerr &lt;&lt; std::endl
<a name="l00203"></a>00203                               &lt;&lt; <span class="stringliteral">&quot; ******** Serious Problem.  Could not find an Element &quot;</span>
<a name="l00204"></a>00204                               &lt;&lt; <span class="stringliteral">&quot;in the Mesh&quot;</span> 
<a name="l00205"></a>00205                               &lt;&lt; std:: endl
<a name="l00206"></a>00206                               &lt;&lt; <span class="stringliteral">&quot; ******** that contains the Point &quot;</span>
<a name="l00207"></a>00207                               &lt;&lt; p;
<a name="l00208"></a>00208                     libmesh_error();
<a name="l00209"></a>00209                   }
<a name="l00210"></a>00210               }
<a name="l00211"></a>00211           }
<a name="l00212"></a>00212     }
<a name="l00213"></a>00213   
<a name="l00214"></a>00214   <span class="comment">// the element should be active</span>
<a name="l00215"></a>00215   libmesh_assert (this-&gt;<a class="code" href="classPointLocatorTree.php#a9a8c4a848a32c2c97b016e2d4a6fe252">_element</a>-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>());
<a name="l00216"></a>00216 
<a name="l00217"></a>00217   <span class="comment">// return the element</span>
<a name="l00218"></a>00218   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classPointLocatorTree.php#a9a8c4a848a32c2c97b016e2d4a6fe252">_element</a>;
<a name="l00219"></a>00219 }
<a name="l00220"></a>00220 
<a name="l00221"></a><a class="code" href="classPointLocatorTree.php#af4aae1aae85c3544391892683fc60c09">00221</a> <span class="keywordtype">void</span> <a class="code" href="classPointLocatorTree.php#af4aae1aae85c3544391892683fc60c09">PointLocatorTree::enable_out_of_mesh_mode</a> (<span class="keywordtype">void</span>)
<a name="l00222"></a>00222 {
<a name="l00223"></a>00223   <span class="comment">/* Out-of-mesh mode is currently only supported if all of the</span>
<a name="l00224"></a>00224 <span class="comment">     elements have affine mappings.  The reason is that for quadratic</span>
<a name="l00225"></a>00225 <span class="comment">     mappings, it is not easy to construct a relyable bounding box of</span>
<a name="l00226"></a>00226 <span class="comment">     the element, and thus, the fallback linear search in \p</span>
<a name="l00227"></a>00227 <span class="comment">     operator() is required.  Hence, out-of-mesh mode would be</span>
<a name="l00228"></a>00228 <span class="comment">     extremely slow.  */</span>
<a name="l00229"></a>00229   <span class="keywordflow">if</span>(!<a class="code" href="classPointLocatorTree.php#ab5287c42efc50b3fc18a9d56c3c4fec2">_out_of_mesh_mode</a>)
<a name="l00230"></a>00230     {
<a name="l00231"></a>00231 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00232"></a>00232 <span class="preprocessor"></span>      <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       pos     = this-&gt;<a class="code" href="classPointLocatorBase.php#a33c0eef7f3345539d618f9b0f85f3790">_mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00233"></a>00233       <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_pos = this-&gt;<a class="code" href="classPointLocatorBase.php#a33c0eef7f3345539d618f9b0f85f3790">_mesh</a>.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>();
<a name="l00234"></a>00234       <span class="keywordflow">for</span> ( ; pos != end_pos; ++pos)
<a name="l00235"></a>00235         <span class="keywordflow">if</span> (!(*pos)-&gt;has_affine_map())
<a name="l00236"></a>00236           {
<a name="l00237"></a>00237             std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Out-of-mesh mode is currently only supported if all elements have affine mappings.&quot;</span> &lt;&lt; std::endl;
<a name="l00238"></a>00238             libmesh_error();
<a name="l00239"></a>00239           }
<a name="l00240"></a>00240 <span class="preprocessor">#endif</span>
<a name="l00241"></a>00241 <span class="preprocessor"></span>      
<a name="l00242"></a>00242       <a class="code" href="classPointLocatorTree.php#ab5287c42efc50b3fc18a9d56c3c4fec2">_out_of_mesh_mode</a> = <span class="keyword">true</span>;
<a name="l00243"></a>00243     }
<a name="l00244"></a>00244 }
<a name="l00245"></a>00245 
<a name="l00246"></a><a class="code" href="classPointLocatorTree.php#ac1f87c991b2a4368df55447868f8ad30">00246</a> <span class="keywordtype">void</span> <a class="code" href="classPointLocatorTree.php#ac1f87c991b2a4368df55447868f8ad30">PointLocatorTree::disable_out_of_mesh_mode</a> (<span class="keywordtype">void</span>)
<a name="l00247"></a>00247 {
<a name="l00248"></a>00248   <a class="code" href="classPointLocatorTree.php#ab5287c42efc50b3fc18a9d56c3c4fec2">_out_of_mesh_mode</a> = <span class="keyword">false</span>;
<a name="l00249"></a>00249 }
<a name="l00250"></a>00250 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
