<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_4f64d75cac7489d141591c33108e86ff.php">utils</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>point_locator_tree.h</h1>  </div>
</div>
<div class="contents">
<a href="point__locator__tree_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: point_locator_tree.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __point_locator_tree_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __point_locator_tree_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="point__locator__base_8h.php">point_locator_base.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="tree__base_8h.php">tree_base.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward Declarations</span>
<a name="l00035"></a>00035 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00036"></a>00036 <span class="keyword">class </span><a class="code" href="classPoint.php">Point</a>;
<a name="l00037"></a>00037 <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00050"></a>00050 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00051"></a>00051 <span class="comment">// PointLocatorTree class definition</span>
<a name="l00052"></a><a class="code" href="classPointLocatorTree.php">00052</a> <span class="keyword">class </span><a class="code" href="classPointLocatorTree.php">PointLocatorTree</a> : <span class="keyword">public</span> <a class="code" href="classPointLocatorBase.php">PointLocatorBase</a>
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054 <span class="keyword">public</span>:
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00065"></a>00065   <a class="code" href="classPointLocatorTree.php#a0069c8558a55cc11d5c31934006bf85d">PointLocatorTree</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00066"></a>00066                     <span class="keyword">const</span> <a class="code" href="classPointLocatorBase.php">PointLocatorBase</a>* master = NULL);
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   
<a name="l00080"></a>00080   <a class="code" href="classPointLocatorTree.php#a0069c8558a55cc11d5c31934006bf85d">PointLocatorTree</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00081"></a>00081                     <span class="keyword">const</span> <a class="code" href="namespaceTrees.php#a8fb02eb8a700b646d106718a2d0ca3ef">Trees::BuildType</a> build_type,
<a name="l00082"></a>00082                     <span class="keyword">const</span> <a class="code" href="classPointLocatorBase.php">PointLocatorBase</a>* master = NULL);
<a name="l00083"></a>00083 
<a name="l00084"></a>00084     
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 <span class="keyword">public</span>:
<a name="l00087"></a>00087 
<a name="l00091"></a>00091   <a class="code" href="classPointLocatorTree.php#a80f2ce6505074e05266d54ba5cae0307">~PointLocatorTree</a> ();
<a name="l00092"></a>00092 
<a name="l00096"></a>00096   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPointLocatorTree.php#a4f70369549fdb0d8709ba55321eaff49">clear</a>();
<a name="l00097"></a>00097 
<a name="l00102"></a>00102   <span class="keywordtype">void</span> <a class="code" href="classPointLocatorTree.php#a47dd94ede01e541e6c9de6b760502ee0">init</a>(<span class="keyword">const</span> <a class="code" href="namespaceTrees.php#a8fb02eb8a700b646d106718a2d0ca3ef">Trees::BuildType</a> build_type);
<a name="l00103"></a>00103 
<a name="l00108"></a><a class="code" href="classPointLocatorTree.php#a47dd94ede01e541e6c9de6b760502ee0">00108</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPointLocatorTree.php#a47dd94ede01e541e6c9de6b760502ee0">init</a>() { this-&gt;<a class="code" href="classPointLocatorTree.php#a47dd94ede01e541e6c9de6b760502ee0">init</a>(<a class="code" href="namespaceTrees.php#a8fb02eb8a700b646d106718a2d0ca3efa6ec2eeb88ab0a36caf9a31d79c3da8cb">Trees::NODES</a>); };
<a name="l00109"></a>00109 
<a name="l00116"></a>00116   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classPointLocatorTree.php#ab7e7d88c7a3582ef0bc63fad1dc0f7b0">operator() </a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00117"></a>00117 
<a name="l00124"></a>00124   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPointLocatorTree.php#af4aae1aae85c3544391892683fc60c09">enable_out_of_mesh_mode</a> (<span class="keywordtype">void</span>);
<a name="l00125"></a>00125 
<a name="l00131"></a>00131   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPointLocatorTree.php#ac1f87c991b2a4368df55447868f8ad30">disable_out_of_mesh_mode</a> (<span class="keywordtype">void</span>);
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 <span class="keyword">protected</span>:
<a name="l00134"></a>00134 
<a name="l00140"></a><a class="code" href="classPointLocatorTree.php#a74b3656c5eb5531fe876c7a22e2e1db5">00140</a>   <a class="code" href="classTreeBase.php">TreeBase</a>* <a class="code" href="classPointLocatorTree.php#a74b3656c5eb5531fe876c7a22e2e1db5">_tree</a>;
<a name="l00141"></a>00141 
<a name="l00147"></a><a class="code" href="classPointLocatorTree.php#a9a8c4a848a32c2c97b016e2d4a6fe252">00147</a>   <span class="keyword">mutable</span> <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classPointLocatorTree.php#a9a8c4a848a32c2c97b016e2d4a6fe252">_element</a>;
<a name="l00148"></a>00148 
<a name="l00153"></a><a class="code" href="classPointLocatorTree.php#ab5287c42efc50b3fc18a9d56c3c4fec2">00153</a>   <span class="keywordtype">bool</span> <a class="code" href="classPointLocatorTree.php#ab5287c42efc50b3fc18a9d56c3c4fec2">_out_of_mesh_mode</a>;
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 };
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00159"></a>00159 <span class="comment">// PointLocatorTree inline methods</span>
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 <span class="preprocessor">#endif</span>
<a name="l00163"></a>00163 <span class="preprocessor"></span>
<a name="l00164"></a>00164 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
