<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>postscript_io.C</h1>  </div>
</div>
<div class="contents">
<a href="postscript__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: postscript_io.C 3502 2009-10-20 18:06:50Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// C++ includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &lt;ctime&gt;</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;postscript_io.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;mesh_tools.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Transformation map between monomial (physical space) and Bezier bases.</span>
<a name="l00030"></a>00030 <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classPostscriptIO.php#ac0ad75c6d9ede8c5ea3f7af2cf78f632">PostscriptIO::_bezier_transform</a>[3][3] =
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032   {-1./6., 1./6.,    1.}, 
<a name="l00033"></a>00033   {-1./6.,   0.5, 1./6.}, 
<a name="l00034"></a>00034   {    0.,    1.,    0.} 
<a name="l00035"></a>00035 };
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a><a class="code" href="classPostscriptIO.php#a9fe419030691e00a0ec10417359a5d65">00038</a> <a class="code" href="classPostscriptIO.php#a9fe419030691e00a0ec10417359a5d65">PostscriptIO::PostscriptIO</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh)
<a name="l00039"></a>00039   : <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt; (mesh),
<a name="l00040"></a>00040     shade_value(0.0),
<a name="l00041"></a>00041     line_width(0.5),
<a name="l00042"></a>00042     <span class="comment">//_M(3,3),</span>
<a name="l00043"></a>00043     _offset(0., 0.),
<a name="l00044"></a>00044     _scale(1.0),
<a name="l00045"></a>00045     _current_point(0., 0.)
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047   <span class="comment">// This code is still undergoing some development.</span>
<a name="l00048"></a>00048   libmesh_experimental();
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   <span class="comment">// Entries of transformation matrix from physical to Bezier coords.</span>
<a name="l00051"></a>00051   <span class="comment">// _M(0,0) = -1./6.;    _M(0,1) = 1./6.;    _M(0,2) = 1.; </span>
<a name="l00052"></a>00052   <span class="comment">// _M(1,0) = -1./6.;    _M(1,1) = 0.5  ;    _M(1,2) = 1./6.; </span>
<a name="l00053"></a>00053   <span class="comment">// _M(2,0) = 0.    ;    _M(2,1) = 1.   ;    _M(2,2) = 0.;</span>
<a name="l00054"></a>00054 
<a name="l00055"></a>00055   <span class="comment">// Make sure there is enough room to store Bezier coefficients.</span>
<a name="l00056"></a>00056   <a class="code" href="classPostscriptIO.php#a51d13a4b827a38e83eb933f2057e12b5">_bezier_coeffs</a>.resize(3);
<a name="l00057"></a>00057 }
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 
<a name="l00061"></a><a class="code" href="classPostscriptIO.php#aee0884032ed3850082048e4929903826">00061</a> <a class="code" href="classPostscriptIO.php#aee0884032ed3850082048e4929903826">PostscriptIO::~PostscriptIO</a> ()
<a name="l00062"></a>00062 {
<a name="l00063"></a>00063 }
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00067"></a><a class="code" href="classPostscriptIO.php#a57b3b2b0c7b8cf533c262faefa5ba907">00067</a> <span class="keywordtype">void</span> <a class="code" href="classPostscriptIO.php#a57b3b2b0c7b8cf533c262faefa5ba907">PostscriptIO::write</a> (<span class="keyword">const</span> std::string&amp; fname)
<a name="l00068"></a>00068 {
<a name="l00069"></a>00069   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00070"></a>00070     {
<a name="l00071"></a>00071       <span class="comment">// Get a constant reference to the mesh.</span>
<a name="l00072"></a>00072       <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshOutput.php#af923657f1dcc7c26a973332295d94f13">mesh</a> = <a class="code" href="classMeshOutput.php#af923657f1dcc7c26a973332295d94f13">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00073"></a>00073 
<a name="l00074"></a>00074       <span class="comment">// Only works in 2D</span>
<a name="l00075"></a>00075       libmesh_assert(mesh.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>() == 2);
<a name="l00076"></a>00076 
<a name="l00077"></a>00077       <span class="comment">// Create output file stream.</span>
<a name="l00078"></a>00078       <span class="comment">// _out is now a private member of the class.</span>
<a name="l00079"></a>00079       <a class="code" href="classPostscriptIO.php#a382b1b7eaafa4ddab91448c3dfd1f42f">_out</a>.open(fname.c_str());
<a name="l00080"></a>00080       
<a name="l00081"></a>00081       <span class="comment">// Make sure it opened correctly</span>
<a name="l00082"></a>00082       <span class="keywordflow">if</span> (!<a class="code" href="classPostscriptIO.php#a382b1b7eaafa4ddab91448c3dfd1f42f">_out</a>.good())
<a name="l00083"></a>00083         libmesh_file_error(fname.c_str());
<a name="l00084"></a>00084 
<a name="l00085"></a>00085       <span class="comment">// The mesh bounding box gives us info about what the</span>
<a name="l00086"></a>00086       <span class="comment">// Postscript bounding box should be.</span>
<a name="l00087"></a>00087       <a class="code" href="classMeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a> bbox = <a class="code" href="namespaceMeshTools.php#ad533681876e9809cfe5e2114886b1c03">MeshTools::bounding_box</a>(mesh);
<a name="l00088"></a>00088 
<a name="l00089"></a>00089       <span class="comment">// Add a little extra padding to the &quot;true&quot; bounding box so</span>
<a name="l00090"></a>00090       <span class="comment">// that we can still see the boundary</span>
<a name="l00091"></a>00091       <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> percent_padding = 0.01;
<a name="l00092"></a>00092       <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> dx=bbox.second(0)-bbox.first(0); libmesh_assert(dx &gt; 0.0);
<a name="l00093"></a>00093       <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> dy=bbox.second(1)-bbox.first(1); libmesh_assert(dy &gt; 0.0);
<a name="l00094"></a>00094       
<a name="l00095"></a>00095       <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> x_min = bbox.first(0)  - percent_padding*dx;
<a name="l00096"></a>00096       <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> y_min = bbox.first(1)  - percent_padding*dy;
<a name="l00097"></a>00097       <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> x_max = bbox.second(0) + percent_padding*dx;
<a name="l00098"></a>00098       <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> y_max = bbox.second(1) + percent_padding*dy;
<a name="l00099"></a>00099 
<a name="l00100"></a>00100       <span class="comment">// Width of the output as given in postscript units.</span>
<a name="l00101"></a>00101       <span class="comment">// This usually is given by the strange unit 1/72 inch. </span>
<a name="l00102"></a>00102       <span class="comment">// A width of 300 represents a size of roughly 10 cm.</span>
<a name="l00103"></a>00103       <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> width = 300;
<a name="l00104"></a>00104       <a class="code" href="classPostscriptIO.php#a18988eecafd4b10a77a743b62c0460e1">_scale</a> = width / (x_max-x_min);
<a name="l00105"></a>00105       <a class="code" href="classPostscriptIO.php#a2d201584a8ca4c76d5d7cdc4a2e4703f">_offset</a>(0) = x_min;
<a name="l00106"></a>00106       <a class="code" href="classPostscriptIO.php#a2d201584a8ca4c76d5d7cdc4a2e4703f">_offset</a>(1) = y_min;
<a name="l00107"></a>00107       
<a name="l00108"></a>00108       <span class="comment">// Header writing stuff stolen from Deal.II</span>
<a name="l00109"></a>00109       std::time_t  time1= std::time (0);
<a name="l00110"></a>00110       std::tm     *time = std::localtime(&amp;time1);
<a name="l00111"></a>00111       <a class="code" href="classPostscriptIO.php#a382b1b7eaafa4ddab91448c3dfd1f42f">_out</a> &lt;&lt; <span class="stringliteral">&quot;%!PS-Adobe-2.0 EPSF-1.2&quot;</span> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00112"></a>00112         <span class="comment">//&lt;&lt; &quot;%!PS-Adobe-1.0&quot; &lt;&lt; &#39;\n&#39; // Lars&#39; PS version</span>
<a name="l00113"></a>00113           &lt;&lt; <span class="stringliteral">&quot;%%Filename: &quot;</span> &lt;&lt; fname &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00114"></a>00114           &lt;&lt; <span class="stringliteral">&quot;%%Title: LibMesh Output&quot;</span> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00115"></a>00115           &lt;&lt; <span class="stringliteral">&quot;%%Creator: LibMesh: A C++ finite element library&quot;</span> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00116"></a>00116           &lt;&lt; <span class="stringliteral">&quot;%%Creation Date: &quot;</span>
<a name="l00117"></a>00117           &lt;&lt; time-&gt;tm_year+1900 &lt;&lt; <span class="stringliteral">&quot;/&quot;</span>
<a name="l00118"></a>00118           &lt;&lt; time-&gt;tm_mon+1 &lt;&lt; <span class="stringliteral">&quot;/&quot;</span>
<a name="l00119"></a>00119           &lt;&lt; time-&gt;tm_mday &lt;&lt; <span class="stringliteral">&quot; - &quot;</span>
<a name="l00120"></a>00120           &lt;&lt; time-&gt;tm_hour &lt;&lt; <span class="stringliteral">&quot;:&quot;</span>
<a name="l00121"></a>00121           &lt;&lt; std::setw(2) &lt;&lt; time-&gt;tm_min &lt;&lt; <span class="stringliteral">&quot;:&quot;</span>
<a name="l00122"></a>00122           &lt;&lt; std::setw(2) &lt;&lt; time-&gt;tm_sec &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00123"></a>00123           &lt;&lt; <span class="stringliteral">&quot;%%BoundingBox: &quot;</span>
<a name="l00124"></a>00124         <span class="comment">// lower left corner</span>
<a name="l00125"></a>00125           &lt;&lt; <span class="stringliteral">&quot;0 0 &quot;</span>
<a name="l00126"></a>00126         <span class="comment">// upper right corner</span>
<a name="l00127"></a>00127           &lt;&lt; <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>( rint((x_max-x_min) * <a class="code" href="classPostscriptIO.php#a18988eecafd4b10a77a743b62c0460e1">_scale</a> ))
<a name="l00128"></a>00128           &lt;&lt; <span class="charliteral">&#39; &#39;</span>
<a name="l00129"></a>00129           &lt;&lt; static_cast&lt;unsigned int&gt;( rint((y_max-y_min) * _scale ))
<a name="l00130"></a>00130           &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00131"></a>00131 
<a name="l00132"></a>00132       <span class="comment">// define some abbreviations to keep</span>
<a name="l00133"></a>00133       <span class="comment">// the output small:</span>
<a name="l00134"></a>00134       <span class="comment">// m=move turtle to</span>
<a name="l00135"></a>00135       <span class="comment">// l=define a line</span>
<a name="l00136"></a>00136       <span class="comment">// s=set rgb color</span>
<a name="l00137"></a>00137       <span class="comment">// sg=set gray value</span>
<a name="l00138"></a>00138       <span class="comment">// lx=close the line and plot the line</span>
<a name="l00139"></a>00139       <span class="comment">// lf=close the line and fill the interior</span>
<a name="l00140"></a>00140       <a class="code" href="classPostscriptIO.php#a382b1b7eaafa4ddab91448c3dfd1f42f">_out</a> &lt;&lt; <span class="stringliteral">&quot;/m {moveto} bind def&quot;</span>      &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00141"></a>00141           &lt;&lt; <span class="stringliteral">&quot;/l {lineto} bind def&quot;</span>      &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00142"></a>00142           &lt;&lt; <span class="stringliteral">&quot;/s {setrgbcolor} bind def&quot;</span> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00143"></a>00143           &lt;&lt; <span class="stringliteral">&quot;/sg {setgray} bind def&quot;</span>    &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00144"></a>00144           &lt;&lt; <span class="stringliteral">&quot;/cs {curveto stroke} bind def&quot;</span> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00145"></a>00145           &lt;&lt; <span class="stringliteral">&quot;/lx {lineto closepath stroke} bind def&quot;</span> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00146"></a>00146           &lt;&lt; <span class="stringliteral">&quot;/lf {lineto closepath fill} bind def&quot;</span>   &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00147"></a>00147 
<a name="l00148"></a>00148       <a class="code" href="classPostscriptIO.php#a382b1b7eaafa4ddab91448c3dfd1f42f">_out</a> &lt;&lt; <span class="stringliteral">&quot;%%EndProlog&quot;</span> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00149"></a>00149       <span class="comment">//          &lt;&lt; &#39;\n&#39;;</span>
<a name="l00150"></a>00150       
<a name="l00151"></a>00151       <span class="comment">// Set line width in the postscript file.  </span>
<a name="l00152"></a>00152       <a class="code" href="classPostscriptIO.php#a382b1b7eaafa4ddab91448c3dfd1f42f">_out</a> &lt;&lt; <a class="code" href="classPostscriptIO.php#a0d782246db1734c7d3c3ce96d44df355">line_width</a> &lt;&lt; <span class="stringliteral">&quot; setlinewidth&quot;</span> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00153"></a>00153 
<a name="l00154"></a>00154       <span class="comment">// Set line cap and join options</span>
<a name="l00155"></a>00155       <a class="code" href="classPostscriptIO.php#a382b1b7eaafa4ddab91448c3dfd1f42f">_out</a> &lt;&lt; <span class="stringliteral">&quot;1 setlinecap&quot;</span> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00156"></a>00156       <a class="code" href="classPostscriptIO.php#a382b1b7eaafa4ddab91448c3dfd1f42f">_out</a> &lt;&lt; <span class="stringliteral">&quot;1 setlinejoin&quot;</span> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00157"></a>00157   
<a name="l00158"></a>00158       <span class="comment">// allow only five digits for output (instead of the default</span>
<a name="l00159"></a>00159       <span class="comment">// six); this should suffice even for fine grids, but reduces</span>
<a name="l00160"></a>00160       <span class="comment">// the file size significantly</span>
<a name="l00161"></a>00161       <a class="code" href="classPostscriptIO.php#a382b1b7eaafa4ddab91448c3dfd1f42f">_out</a> &lt;&lt; std::setprecision (5);
<a name="l00162"></a>00162 
<a name="l00163"></a>00163       <span class="comment">// Loop over the active elements, draw lines for the edges.  We</span>
<a name="l00164"></a>00164       <span class="comment">// draw even quadratic elements with straight sides, i.e. a straight</span>
<a name="l00165"></a>00165       <span class="comment">// line sits between each pair of vertices.  Also we draw every edge</span>
<a name="l00166"></a>00166       <span class="comment">// for an element regardless of the fact that it may overlap with</span>
<a name="l00167"></a>00167       <span class="comment">// another.  This would probably be a useful optimization...</span>
<a name="l00168"></a>00168       <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     = mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00169"></a>00169       <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00170"></a>00170       <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00171"></a>00171         {
<a name="l00172"></a>00172           <span class="comment">//const Elem* elem = *el;</span>
<a name="l00173"></a>00173 
<a name="l00174"></a>00174           this-&gt;<a class="code" href="classPostscriptIO.php#a475e1cf3af638551905d2295ac67ef50">plot_linear_elem</a>(*el);
<a name="l00175"></a>00175           <span class="comment">//this-&gt;plot_quadratic_elem(*el); // Experimental</span>
<a name="l00176"></a>00176         }
<a name="l00177"></a>00177       
<a name="l00178"></a>00178       <span class="comment">// Issue the showpage command, and we&#39;re done.</span>
<a name="l00179"></a>00179       <a class="code" href="classPostscriptIO.php#a382b1b7eaafa4ddab91448c3dfd1f42f">_out</a> &lt;&lt; <span class="stringliteral">&quot;showpage&quot;</span> &lt;&lt; std::endl;
<a name="l00180"></a>00180       
<a name="l00181"></a>00181     } <span class="comment">// end if (libMesh::processor_id() == 0)</span>
<a name="l00182"></a>00182 }
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 
<a name="l00189"></a><a class="code" href="classPostscriptIO.php#a475e1cf3af638551905d2295ac67ef50">00189</a> <span class="keywordtype">void</span> <a class="code" href="classPostscriptIO.php#a475e1cf3af638551905d2295ac67ef50">PostscriptIO::plot_linear_elem</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem)
<a name="l00190"></a>00190 {
<a name="l00191"></a>00191   <span class="comment">// Clear the string contents.  Yes, this really is how you do that...</span>
<a name="l00192"></a>00192   <a class="code" href="classPostscriptIO.php#a3395829bba49bcb5cb4aaec6198ed01e">_cell_string</a>.str(<span class="stringliteral">&quot;&quot;</span>);
<a name="l00193"></a>00193           
<a name="l00194"></a>00194   <span class="comment">// The general strategy is:</span>
<a name="l00195"></a>00195   <span class="comment">// 1.) Use m  := {moveto} to go to vertex 0.</span>
<a name="l00196"></a>00196   <span class="comment">// 2.) Use l  := {lineto} commands to draw lines to vertex 1, 2, ... N-1.</span>
<a name="l00197"></a>00197   <span class="comment">// 3a.) Use lx := {lineto closepath stroke} command at  vertex N to draw the last line.</span>
<a name="l00198"></a>00198   <span class="comment">// 3b.)     lf := {lineto closepath fill} command to shade the cell just drawn </span>
<a name="l00199"></a>00199   <span class="comment">// All of our 2D elements&#39; vertices are numbered in counterclockwise order,</span>
<a name="l00200"></a>00200   <span class="comment">// so we can just draw them in the same order.</span>
<a name="l00201"></a>00201 
<a name="l00202"></a>00202   <span class="comment">// 1.)</span>
<a name="l00203"></a>00203   <a class="code" href="classPostscriptIO.php#a311a28b2a1ccdc02c1d7979787c193d3">_current_point</a> = (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0) - <a class="code" href="classPostscriptIO.php#a2d201584a8ca4c76d5d7cdc4a2e4703f">_offset</a>) * <a class="code" href="classPostscriptIO.php#a18988eecafd4b10a77a743b62c0460e1">_scale</a>;
<a name="l00204"></a>00204   <a class="code" href="classPostscriptIO.php#a3395829bba49bcb5cb4aaec6198ed01e">_cell_string</a> &lt;&lt; <a class="code" href="classPostscriptIO.php#a311a28b2a1ccdc02c1d7979787c193d3">_current_point</a>(0) &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; <a class="code" href="classPostscriptIO.php#a311a28b2a1ccdc02c1d7979787c193d3">_current_point</a>(1) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>; <span class="comment">// write x y </span>
<a name="l00205"></a>00205   <a class="code" href="classPostscriptIO.php#a3395829bba49bcb5cb4aaec6198ed01e">_cell_string</a> &lt;&lt; <span class="stringliteral">&quot;m &quot;</span>;
<a name="l00206"></a>00206 
<a name="l00207"></a>00207   <span class="comment">// 2.)</span>
<a name="l00208"></a>00208   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nv=elem-&gt;<a class="code" href="classElem.php#a6bbe1895127c069722e36ee4e2a8a6e1">n_vertices</a>();
<a name="l00209"></a>00209   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=1; v&lt;nv-1; ++v)
<a name="l00210"></a>00210     {
<a name="l00211"></a>00211       <a class="code" href="classPostscriptIO.php#a311a28b2a1ccdc02c1d7979787c193d3">_current_point</a> = (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(v) - <a class="code" href="classPostscriptIO.php#a2d201584a8ca4c76d5d7cdc4a2e4703f">_offset</a>) * <a class="code" href="classPostscriptIO.php#a18988eecafd4b10a77a743b62c0460e1">_scale</a>;
<a name="l00212"></a>00212       <a class="code" href="classPostscriptIO.php#a3395829bba49bcb5cb4aaec6198ed01e">_cell_string</a> &lt;&lt; <a class="code" href="classPostscriptIO.php#a311a28b2a1ccdc02c1d7979787c193d3">_current_point</a>(0) &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; <a class="code" href="classPostscriptIO.php#a311a28b2a1ccdc02c1d7979787c193d3">_current_point</a>(1) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>; <span class="comment">// write x y </span>
<a name="l00213"></a>00213       <a class="code" href="classPostscriptIO.php#a3395829bba49bcb5cb4aaec6198ed01e">_cell_string</a> &lt;&lt; <span class="stringliteral">&quot;l &quot;</span>;
<a name="l00214"></a>00214     }
<a name="l00215"></a>00215           
<a name="l00216"></a>00216   <span class="comment">// 3.)</span>
<a name="l00217"></a>00217   <a class="code" href="classPostscriptIO.php#a311a28b2a1ccdc02c1d7979787c193d3">_current_point</a> = (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(nv-1) - <a class="code" href="classPostscriptIO.php#a2d201584a8ca4c76d5d7cdc4a2e4703f">_offset</a>) * <a class="code" href="classPostscriptIO.php#a18988eecafd4b10a77a743b62c0460e1">_scale</a>;
<a name="l00218"></a>00218   <a class="code" href="classPostscriptIO.php#a3395829bba49bcb5cb4aaec6198ed01e">_cell_string</a> &lt;&lt; <a class="code" href="classPostscriptIO.php#a311a28b2a1ccdc02c1d7979787c193d3">_current_point</a>(0) &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; <a class="code" href="classPostscriptIO.php#a311a28b2a1ccdc02c1d7979787c193d3">_current_point</a>(1) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>; <span class="comment">// write x y </span>
<a name="l00219"></a>00219 
<a name="l00220"></a>00220   <span class="comment">// We draw the shaded (interior) parts first, if applicable.</span>
<a name="l00221"></a>00221   <span class="keywordflow">if</span> (<a class="code" href="classPostscriptIO.php#a9ae333cc1abafcdd69253aa614a05748">shade_value</a> &gt; 0.0)
<a name="l00222"></a>00222     <a class="code" href="classPostscriptIO.php#a382b1b7eaafa4ddab91448c3dfd1f42f">_out</a> &lt;&lt; <a class="code" href="classPostscriptIO.php#a9ae333cc1abafcdd69253aa614a05748">shade_value</a> &lt;&lt; <span class="stringliteral">&quot; sg &quot;</span> &lt;&lt; <a class="code" href="classPostscriptIO.php#a3395829bba49bcb5cb4aaec6198ed01e">_cell_string</a>.str() &lt;&lt; <span class="stringliteral">&quot;lf\n&quot;</span>;
<a name="l00223"></a>00223           
<a name="l00224"></a>00224   <span class="comment">// Draw the black lines (I guess we will always do this)</span>
<a name="l00225"></a>00225   <a class="code" href="classPostscriptIO.php#a382b1b7eaafa4ddab91448c3dfd1f42f">_out</a> &lt;&lt; <span class="stringliteral">&quot;0 sg &quot;</span> &lt;&lt; <a class="code" href="classPostscriptIO.php#a3395829bba49bcb5cb4aaec6198ed01e">_cell_string</a>.str() &lt;&lt; <span class="stringliteral">&quot;lx\n&quot;</span>;
<a name="l00226"></a>00226 }
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 
<a name="l00231"></a><a class="code" href="classPostscriptIO.php#a422c54b9848db4897385bb2ae2d60a11">00231</a> <span class="keywordtype">void</span> <a class="code" href="classPostscriptIO.php#a422c54b9848db4897385bb2ae2d60a11">PostscriptIO::plot_quadratic_elem</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem)
<a name="l00232"></a>00232 {
<a name="l00233"></a>00233   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns=0; ns&lt;elem-&gt;<a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>(); ++ns)
<a name="l00234"></a>00234     {
<a name="l00235"></a>00235       <span class="comment">// Build the quadratic side</span>
<a name="l00236"></a>00236       <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> side = elem-&gt;<a class="code" href="classElem.php#a554c146bcfb5537636bd77a157f21b85">build_side</a>(ns);
<a name="l00237"></a>00237 
<a name="l00238"></a>00238       <span class="comment">// Be sure it&#39;s quadratic (Edge2).  Eventually we could</span>
<a name="l00239"></a>00239       <span class="comment">// handle cubic elements as well...</span>
<a name="l00240"></a>00240       libmesh_assert( side-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a> );
<a name="l00241"></a>00241 
<a name="l00242"></a>00242       <a class="code" href="classPostscriptIO.php#a382b1b7eaafa4ddab91448c3dfd1f42f">_out</a> &lt;&lt; <span class="stringliteral">&quot;0 sg &quot;</span>;
<a name="l00243"></a>00243 
<a name="l00244"></a>00244       <span class="comment">// Move to the first point on this side.</span>
<a name="l00245"></a>00245       <a class="code" href="classPostscriptIO.php#a311a28b2a1ccdc02c1d7979787c193d3">_current_point</a> = (side-&gt;point(0) - <a class="code" href="classPostscriptIO.php#a2d201584a8ca4c76d5d7cdc4a2e4703f">_offset</a>) * <a class="code" href="classPostscriptIO.php#a18988eecafd4b10a77a743b62c0460e1">_scale</a>;
<a name="l00246"></a>00246       _out &lt;&lt; <a class="code" href="classPostscriptIO.php#a311a28b2a1ccdc02c1d7979787c193d3">_current_point</a>(0) &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; <a class="code" href="classPostscriptIO.php#a311a28b2a1ccdc02c1d7979787c193d3">_current_point</a>(1) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>; <span class="comment">// write x y </span>
<a name="l00247"></a>00247       _out &lt;&lt; <span class="stringliteral">&quot;m &quot;</span>;
<a name="l00248"></a>00248       
<a name="l00249"></a>00249       <span class="comment">// Compute _bezier_coeffs for this edge.  This fills up</span>
<a name="l00250"></a>00250       <span class="comment">// the _bezier_coeffs vector.</span>
<a name="l00251"></a>00251       this-&gt;<a class="code" href="classPostscriptIO.php#aaa844219d1baa62ca62342d20069bd0c">_compute_edge_bezier_coeffs</a>(side.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>());
<a name="l00252"></a>00252       
<a name="l00253"></a>00253       <span class="comment">// Print curveto path to file</span>
<a name="l00254"></a>00254       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classPostscriptIO.php#a51d13a4b827a38e83eb933f2057e12b5">_bezier_coeffs</a>.size(); ++i)
<a name="l00255"></a>00255         _out &lt;&lt; <a class="code" href="classPostscriptIO.php#a51d13a4b827a38e83eb933f2057e12b5">_bezier_coeffs</a>[i](0) &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; <a class="code" href="classPostscriptIO.php#a51d13a4b827a38e83eb933f2057e12b5">_bezier_coeffs</a>[i](1) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00256"></a>00256       _out &lt;&lt; <span class="stringliteral">&quot; cs\n&quot;</span>;
<a name="l00257"></a>00257     }
<a name="l00258"></a>00258 }
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 
<a name="l00261"></a>00261 
<a name="l00262"></a>00262 
<a name="l00263"></a><a class="code" href="classPostscriptIO.php#aaa844219d1baa62ca62342d20069bd0c">00263</a> <span class="keywordtype">void</span> <a class="code" href="classPostscriptIO.php#aaa844219d1baa62ca62342d20069bd0c">PostscriptIO::_compute_edge_bezier_coeffs</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem)
<a name="l00264"></a>00264 {
<a name="l00265"></a>00265   <span class="comment">// I only know how to do this for an Edge3!</span>
<a name="l00266"></a>00266   libmesh_assert (elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>);
<a name="l00267"></a>00267 
<a name="l00268"></a>00268   <span class="comment">// Get x-coordinates into an array, transform them,</span>
<a name="l00269"></a>00269   <span class="comment">// and repeat for y.</span>
<a name="l00270"></a>00270   <span class="keywordtype">float</span>
<a name="l00271"></a>00271     phys_coords[3] = {0., 0., 0.},
<a name="l00272"></a>00272     bez_coords[3]  = {0., 0., 0.};
<a name="l00273"></a>00273   
<a name="l00274"></a>00274   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;2; ++i)
<a name="l00275"></a>00275     {
<a name="l00276"></a>00276       <span class="comment">// Initialize vectors.  Physical coordinates are initialized</span>
<a name="l00277"></a>00277       <span class="comment">// by their postscript-scaled values. </span>
<a name="l00278"></a>00278       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;3; ++j)
<a name="l00279"></a>00279         {
<a name="l00280"></a>00280           phys_coords[j] = (elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(j)(i) - <a class="code" href="classPostscriptIO.php#a2d201584a8ca4c76d5d7cdc4a2e4703f">_offset</a>(i)) * <a class="code" href="classPostscriptIO.php#a18988eecafd4b10a77a743b62c0460e1">_scale</a>;
<a name="l00281"></a>00281           bez_coords[j] = 0.; <span class="comment">// zero out result vector</span>
<a name="l00282"></a>00282         }
<a name="l00283"></a>00283 
<a name="l00284"></a>00284       <span class="comment">// Multiply matrix times vector</span>
<a name="l00285"></a>00285       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;3; ++j)
<a name="l00286"></a>00286         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;3; ++k)
<a name="l00287"></a>00287           bez_coords[j] += <a class="code" href="classPostscriptIO.php#ac0ad75c6d9ede8c5ea3f7af2cf78f632">_bezier_transform</a>[j][k]*phys_coords[k];
<a name="l00288"></a>00288 
<a name="l00289"></a>00289       <span class="comment">// Store result in _bezier_coeffs</span>
<a name="l00290"></a>00290       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;3; ++j)
<a name="l00291"></a>00291         <a class="code" href="classPostscriptIO.php#a51d13a4b827a38e83eb933f2057e12b5">_bezier_coeffs</a>[j](i) = phys_coords[j];
<a name="l00292"></a>00292     }
<a name="l00293"></a>00293 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
