<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>postscript_io.h</h1>  </div>
</div>
<div class="contents">
<a href="postscript__io_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: postscript_io.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __postscript_io_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __postscript_io_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="mesh__output_8h.php">mesh_output.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;dense_matrix.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;point.h&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward declarations</span>
<a name="l00035"></a>00035 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00036"></a>00036 <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00037"></a>00037 
<a name="l00049"></a><a class="code" href="classPostscriptIO.php">00049</a> <span class="keyword">class </span><a class="code" href="classPostscriptIO.php">PostscriptIO</a> : <span class="keyword">public</span> <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;MeshBase&gt;
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051  <span class="keyword">public</span>:
<a name="l00055"></a>00055   <a class="code" href="classPostscriptIO.php#a9fe419030691e00a0ec10417359a5d65">PostscriptIO</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshOutput.php#af923657f1dcc7c26a973332295d94f13">mesh</a>);
<a name="l00056"></a>00056 
<a name="l00060"></a>00060   <span class="keyword">virtual</span> <a class="code" href="classPostscriptIO.php#aee0884032ed3850082048e4929903826">~PostscriptIO</a> ();
<a name="l00061"></a>00061 
<a name="l00065"></a>00065   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPostscriptIO.php#a57b3b2b0c7b8cf533c262faefa5ba907">write</a> (<span class="keyword">const</span> std::string&amp; );
<a name="l00066"></a>00066   
<a name="l00075"></a><a class="code" href="classPostscriptIO.php#a9ae333cc1abafcdd69253aa614a05748">00075</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classPostscriptIO.php#a9ae333cc1abafcdd69253aa614a05748">shade_value</a>;
<a name="l00076"></a>00076 
<a name="l00083"></a><a class="code" href="classPostscriptIO.php#a0d782246db1734c7d3c3ce96d44df355">00083</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classPostscriptIO.php#a0d782246db1734c7d3c3ce96d44df355">line_width</a>;
<a name="l00084"></a>00084   
<a name="l00088"></a>00088   <span class="keywordtype">void</span> <a class="code" href="classPostscriptIO.php#a422c54b9848db4897385bb2ae2d60a11">plot_quadratic_elem</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem);
<a name="l00089"></a>00089 
<a name="l00093"></a>00093   <span class="keywordtype">void</span> <a class="code" href="classPostscriptIO.php#a475e1cf3af638551905d2295ac67ef50">plot_linear_elem</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem);
<a name="l00094"></a>00094   
<a name="l00095"></a>00095 <span class="keyword">private</span>:
<a name="l00101"></a>00101   <span class="keywordtype">void</span> <a class="code" href="classPostscriptIO.php#aaa844219d1baa62ca62342d20069bd0c">_compute_edge_bezier_coeffs</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem);
<a name="l00102"></a>00102 
<a name="l00108"></a>00108   <span class="comment">//DenseMatrix&lt;float&gt; _M;</span>
<a name="l00109"></a><a class="code" href="classPostscriptIO.php#ac0ad75c6d9ede8c5ea3f7af2cf78f632">00109</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classPostscriptIO.php#ac0ad75c6d9ede8c5ea3f7af2cf78f632">_bezier_transform</a>[3][3];
<a name="l00110"></a>00110   
<a name="l00115"></a><a class="code" href="classPostscriptIO.php#a51d13a4b827a38e83eb933f2057e12b5">00115</a>   std::vector&lt;Point&gt; <a class="code" href="classPostscriptIO.php#a51d13a4b827a38e83eb933f2057e12b5">_bezier_coeffs</a>;
<a name="l00116"></a>00116 
<a name="l00120"></a><a class="code" href="classPostscriptIO.php#a2d201584a8ca4c76d5d7cdc4a2e4703f">00120</a>   <a class="code" href="classPoint.php">Point</a> <a class="code" href="classPostscriptIO.php#a2d201584a8ca4c76d5d7cdc4a2e4703f">_offset</a>;
<a name="l00121"></a>00121 
<a name="l00125"></a><a class="code" href="classPostscriptIO.php#a18988eecafd4b10a77a743b62c0460e1">00125</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classPostscriptIO.php#a18988eecafd4b10a77a743b62c0460e1">_scale</a>;
<a name="l00126"></a>00126 
<a name="l00130"></a><a class="code" href="classPostscriptIO.php#a311a28b2a1ccdc02c1d7979787c193d3">00130</a>   <a class="code" href="classPoint.php">Point</a> <a class="code" href="classPostscriptIO.php#a311a28b2a1ccdc02c1d7979787c193d3">_current_point</a>;
<a name="l00131"></a>00131 
<a name="l00137"></a><a class="code" href="classPostscriptIO.php#a3395829bba49bcb5cb4aaec6198ed01e">00137</a>   std::ostringstream <a class="code" href="classPostscriptIO.php#a3395829bba49bcb5cb4aaec6198ed01e">_cell_string</a>;
<a name="l00138"></a>00138 
<a name="l00142"></a><a class="code" href="classPostscriptIO.php#a382b1b7eaafa4ddab91448c3dfd1f42f">00142</a>   std::ofstream <a class="code" href="classPostscriptIO.php#a382b1b7eaafa4ddab91448c3dfd1f42f">_out</a>;
<a name="l00143"></a>00143 };
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 <span class="preprocessor">#endif // #ifndef __postscript_io_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
