<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_f10759d5ac6297fe611079c3c15b8f2c.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>preconditioner.C</h1>  </div>
</div>
<div class="contents">
<a href="preconditioner_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: preconditioner.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;auto_ptr.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;preconditioner.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;petsc_preconditioner.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00030"></a>00030 <span class="comment">// Preconditioner members</span>
<a name="l00031"></a>00031 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00032"></a>00032 <a class="code" href="classPreconditioner.php">Preconditioner&lt;T&gt;</a> *
<a name="l00033"></a><a class="code" href="classPreconditioner.php#a1f0e8e9836c99c9a293e530a0c4dc8db">00033</a> <a class="code" href="classPreconditioner.php#a1f0e8e9836c99c9a293e530a0c4dc8db">Preconditioner&lt;T&gt;::build</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> solver_package)
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035   <span class="comment">// Build the appropriate solver</span>
<a name="l00036"></a>00036   <span class="keywordflow">switch</span> (solver_package)
<a name="l00037"></a>00037     {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">/*</span>
<a name="l00040"></a>00040 <span class="comment">#ifdef LIBMESH_HAVE_LASPACK</span>
<a name="l00041"></a>00041 <span class="comment">    case LASPACK_SOLVERS:</span>
<a name="l00042"></a>00042 <span class="comment">      {</span>
<a name="l00043"></a>00043 <span class="comment">        AutoPtr&lt;Preconditioner&lt;T&gt; &gt; ap(new LaspackPreconditioner&lt;T&gt;);</span>
<a name="l00044"></a>00044 <span class="comment">        return ap;</span>
<a name="l00045"></a>00045 <span class="comment">      }</span>
<a name="l00046"></a>00046 <span class="comment">#endif</span>
<a name="l00047"></a>00047 <span class="comment">*/</span>
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span>    <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8a4bb6e669bd80e3d232092e60df464572">PETSC_SOLVERS</a>:
<a name="l00051"></a>00051       {
<a name="l00052"></a>00052         <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="classPetscPreconditioner.php">PetscPreconditioner&lt;T&gt;</a>();
<a name="l00053"></a>00053       }
<a name="l00054"></a>00054 <span class="preprocessor">#endif</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span>
<a name="l00056"></a>00056 <span class="comment">/*</span>
<a name="l00057"></a>00057 <span class="comment">#ifdef LIBMESH_HAVE_TRILINOS</span>
<a name="l00058"></a>00058 <span class="comment">    case TRILINOS_SOLVERS:</span>
<a name="l00059"></a>00059 <span class="comment">      {</span>
<a name="l00060"></a>00060 <span class="comment">        AutoPtr&lt;Preconditioner&lt;T&gt; &gt; ap(new AztecPreconditioner&lt;T&gt;);</span>
<a name="l00061"></a>00061 <span class="comment">        return ap;</span>
<a name="l00062"></a>00062 <span class="comment">      }</span>
<a name="l00063"></a>00063 <span class="comment">#endif</span>
<a name="l00064"></a>00064 <span class="comment">*/</span>
<a name="l00065"></a>00065     <span class="keywordflow">default</span>:
<a name="l00066"></a>00066       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR:  Unrecognized solver package: &quot;</span>
<a name="l00067"></a>00067                 &lt;&lt; solver_package
<a name="l00068"></a>00068                 &lt;&lt; std::endl;
<a name="l00069"></a>00069       libmesh_error();
<a name="l00070"></a>00070     }
<a name="l00071"></a>00071     
<a name="l00072"></a>00072   <span class="keywordflow">return</span> NULL;    
<a name="l00073"></a>00073 }
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00078"></a>00078 <span class="comment">// Explicit instantiations</span>
<a name="l00079"></a>00079 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classPreconditioner.php">Preconditioner&lt;Number&gt;</a>;
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
