<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>preconditioner.h</h1>  </div>
</div>
<div class="contents">
<a href="preconditioner_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: preconditioner.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __preconditioner_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __preconditioner_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;enum_solver_package.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;enum_solver_type.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;enum_preconditioner_type.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;reference_counted_object.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;libmesh.h&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// forward declarations</span>
<a name="l00037"></a>00037 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr</a>;
<a name="l00038"></a>00038 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classSparseMatrix.php">SparseMatrix</a>;
<a name="l00039"></a>00039 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classNumericVector.php">NumericVector</a>;
<a name="l00040"></a>00040 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classShellMatrix.php">ShellMatrix</a>;
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00058"></a>00058 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00059"></a><a class="code" href="classPreconditioner.php">00059</a> <span class="keyword">class </span><a class="code" href="classPreconditioner.php">Preconditioner</a> : <span class="keyword">public</span> <a class="code" href="classReferenceCountedObject.php">ReferenceCountedObject</a>&lt;Preconditioner&lt;T&gt; &gt;
<a name="l00060"></a>00060 {
<a name="l00061"></a>00061 <span class="keyword">public</span>:
<a name="l00062"></a>00062   
<a name="l00066"></a>00066   <a class="code" href="classPreconditioner.php#a6e9995a2b6a2dd86a395b901bbeafed2">Preconditioner</a> ();
<a name="l00067"></a>00067 
<a name="l00071"></a>00071   <span class="keyword">virtual</span> <a class="code" href="classPreconditioner.php#ae87ceb6df2b49167e1ab09f71a64fb48">~Preconditioner</a> ();
<a name="l00072"></a>00072   
<a name="l00077"></a>00077   <span class="keyword">static</span> <a class="code" href="classPreconditioner.php">Preconditioner&lt;T&gt;</a> * <a class="code" href="classPreconditioner.php#a1f0e8e9836c99c9a293e530a0c4dc8db">build</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> solver_package =
<a name="l00078"></a>00078                                    <a class="code" href="namespacelibMesh.php#a496c62248223cd940c7715932dd0dc2d">libMesh::default_solver_package</a>());
<a name="l00079"></a>00079   
<a name="l00084"></a><a class="code" href="classPreconditioner.php#a3523f00ffbf5b561a13a6f7763b27dbb">00084</a>   <span class="keywordtype">bool</span> <a class="code" href="classPreconditioner.php#a3523f00ffbf5b561a13a6f7763b27dbb">initialized</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classPreconditioner.php#afbd4eb8d960669408bfe4845d583c289">_is_initialized</a>; }
<a name="l00085"></a>00085 
<a name="l00090"></a>00090   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPreconditioner.php#a030423ba30e3badcc2ab85aa7e4ceb82">apply</a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; x, <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; y) = 0;
<a name="l00091"></a>00091   
<a name="l00095"></a><a class="code" href="classPreconditioner.php#a3d355decebe2edf6b9bf5cbbe418e73a">00095</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPreconditioner.php#a3d355decebe2edf6b9bf5cbbe418e73a">clear</a> () {}
<a name="l00096"></a>00096 
<a name="l00100"></a><a class="code" href="classPreconditioner.php#a4548979055a8a62a8cfb7c5723dc326a">00100</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classPreconditioner.php#a4548979055a8a62a8cfb7c5723dc326a">init</a> () {};
<a name="l00101"></a>00101 
<a name="l00105"></a>00105   <span class="keywordtype">void</span> <a class="code" href="classPreconditioner.php#aa03a92a9c4744283fcabe925eee71872">set_matrix</a>(<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;Number&gt;</a> &amp; mat);
<a name="l00106"></a>00106 
<a name="l00110"></a><a class="code" href="classPreconditioner.php#ae84b7181822dd22059f4164ff96bdc6c">00110</a>   <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4">PreconditionerType</a> <a class="code" href="classPreconditioner.php#ae84b7181822dd22059f4164ff96bdc6c">type</a> ()<span class="keyword"> const</span>
<a name="l00111"></a>00111 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classPreconditioner.php#aa6d3e15fc42f60df256f1bcc8bfe8e79">_preconditioner_type</a>; }
<a name="l00112"></a>00112 
<a name="l00116"></a>00116   <span class="keywordtype">void</span> <a class="code" href="classPreconditioner.php#aaf2f6f89e5115021e5e61b25c7a92962">set_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4">PreconditionerType</a> pct);
<a name="l00117"></a>00117   
<a name="l00118"></a>00118 <span class="keyword">protected</span>:
<a name="l00119"></a>00119 
<a name="l00124"></a><a class="code" href="classPreconditioner.php#acfa454d7ebc95bf1ad2d3cb6837ab06a">00124</a>   <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> * <a class="code" href="classPreconditioner.php#acfa454d7ebc95bf1ad2d3cb6837ab06a">_matrix</a>;
<a name="l00125"></a>00125   
<a name="l00129"></a><a class="code" href="classPreconditioner.php#aa6d3e15fc42f60df256f1bcc8bfe8e79">00129</a>   <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4">PreconditionerType</a> <a class="code" href="classPreconditioner.php#aa6d3e15fc42f60df256f1bcc8bfe8e79">_preconditioner_type</a>;
<a name="l00130"></a>00130   
<a name="l00134"></a><a class="code" href="classPreconditioner.php#afbd4eb8d960669408bfe4845d583c289">00134</a>   <span class="keywordtype">bool</span> <a class="code" href="classPreconditioner.php#afbd4eb8d960669408bfe4845d583c289">_is_initialized</a>;
<a name="l00135"></a>00135 };
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 <span class="comment">/*----------------------- inline functions ----------------------------------*/</span>
<a name="l00141"></a>00141 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00142"></a>00142 <span class="keyword">inline</span>
<a name="l00143"></a><a class="code" href="classPreconditioner.php#a6e9995a2b6a2dd86a395b901bbeafed2">00143</a> <a class="code" href="classPreconditioner.php#a6e9995a2b6a2dd86a395b901bbeafed2">Preconditioner&lt;T&gt;::Preconditioner</a> () :
<a name="l00144"></a>00144   _matrix(NULL),
<a name="l00145"></a>00145   _preconditioner_type (<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4af54549e0e69fbdd4ddd199ee316527f3">ILU_PRECOND</a>),
<a name="l00146"></a>00146   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a>      (false)
<a name="l00147"></a>00147 {
<a name="l00148"></a>00148 }
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00153"></a>00153 <span class="keyword">inline</span>
<a name="l00154"></a><a class="code" href="classPreconditioner.php#ae87ceb6df2b49167e1ab09f71a64fb48">00154</a> <a class="code" href="classPreconditioner.php#ae87ceb6df2b49167e1ab09f71a64fb48">Preconditioner&lt;T&gt;::~Preconditioner</a> ()
<a name="l00155"></a>00155 {
<a name="l00156"></a>00156   this-&gt;clear ();
<a name="l00157"></a>00157 }
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00160"></a>00160 <span class="keywordtype">void</span>
<a name="l00161"></a><a class="code" href="classPreconditioner.php#aa03a92a9c4744283fcabe925eee71872">00161</a> <a class="code" href="classPreconditioner.php#aa03a92a9c4744283fcabe925eee71872">Preconditioner&lt;T&gt;::set_matrix</a>(<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;Number&gt;</a> &amp; mat)
<a name="l00162"></a>00162 {
<a name="l00163"></a>00163   <span class="comment">//If the matrix is changing then we (probably) need to reinitialize.</span>
<a name="l00164"></a>00164   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00165"></a>00165   _matrix = &amp;mat;
<a name="l00166"></a>00166 }
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00169"></a>00169 <span class="keywordtype">void</span>
<a name="l00170"></a><a class="code" href="classPreconditioner.php#aaf2f6f89e5115021e5e61b25c7a92962">00170</a> <a class="code" href="classPreconditioner.php#aaf2f6f89e5115021e5e61b25c7a92962">Preconditioner&lt;T&gt;::set_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4">PreconditionerType</a> pct)
<a name="l00171"></a>00171 {
<a name="l00172"></a>00172   <span class="comment">//If the preconditioner type changes we (probably) need to reinitialize.</span>
<a name="l00173"></a>00173   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00174"></a>00174   _preconditioner_type = pct;
<a name="l00175"></a>00175 }
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 <span class="preprocessor">#endif // #ifdef __preconditioner_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
