<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_7bd01b27aea5d59f5c4653fb1c436874.php">quadrature</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>quadrature.C</h1>  </div>
</div>
<div class="contents">
<a href="quadrature_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: quadrature.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;quadrature.h&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a><a class="code" href="classQBase.php#a1a0f71b05c7af21a8dd5577474b25818">00026</a> <span class="keywordtype">void</span> <a class="code" href="classQBase.php#a1a0f71b05c7af21a8dd5577474b25818">QBase::init</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00027"></a>00027                  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)
<a name="l00028"></a>00028 {
<a name="l00029"></a>00029   <span class="comment">// check to see if we have already</span>
<a name="l00030"></a>00030   <span class="comment">// done the work for this quadrature rule</span>
<a name="l00031"></a>00031   <span class="keywordflow">if</span> (t == _type &amp;&amp; p == _p_level)
<a name="l00032"></a>00032     <span class="keywordflow">return</span>;
<a name="l00033"></a>00033   <span class="keywordflow">else</span>
<a name="l00034"></a>00034     {
<a name="l00035"></a>00035       _type = t;
<a name="l00036"></a>00036       _p_level = p;
<a name="l00037"></a>00037     }
<a name="l00038"></a>00038     
<a name="l00039"></a>00039   
<a name="l00040"></a>00040   
<a name="l00041"></a>00041   <span class="keywordflow">switch</span>(_dim)
<a name="l00042"></a>00042     {
<a name="l00043"></a>00043     <span class="keywordflow">case</span> 0:
<a name="l00044"></a>00044       this-&gt;<a class="code" href="classQBase.php#a4a111b2a437de3e94a23a6342cde3ed2">init_0D</a>(_type,_p_level);
<a name="l00045"></a>00045 
<a name="l00046"></a>00046       <span class="keywordflow">return</span>;
<a name="l00047"></a>00047       
<a name="l00048"></a>00048     <span class="keywordflow">case</span> 1:
<a name="l00049"></a>00049       this-&gt;<a class="code" href="classQBase.php#ae13365995bf2bc42a52bda510e368bf0">init_1D</a>(_type,_p_level);
<a name="l00050"></a>00050 
<a name="l00051"></a>00051       <span class="keywordflow">return</span>;
<a name="l00052"></a>00052       
<a name="l00053"></a>00053     <span class="keywordflow">case</span> 2:
<a name="l00054"></a>00054       this-&gt;<a class="code" href="classQBase.php#a58b2ebdf197e8103a446d6c630207721">init_2D</a>(_type,_p_level);
<a name="l00055"></a>00055 
<a name="l00056"></a>00056       <span class="keywordflow">return</span>;
<a name="l00057"></a>00057 
<a name="l00058"></a>00058     <span class="keywordflow">case</span> 3:
<a name="l00059"></a>00059       this-&gt;init_3D(_type,_p_level);
<a name="l00060"></a>00060 
<a name="l00061"></a>00061       <span class="keywordflow">return</span>;
<a name="l00062"></a>00062 
<a name="l00063"></a>00063     <span class="keywordflow">default</span>:
<a name="l00064"></a>00064       libmesh_error();
<a name="l00065"></a>00065     }
<a name="l00066"></a>00066 }
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 
<a name="l00070"></a><a class="code" href="classQBase.php#a4a111b2a437de3e94a23a6342cde3ed2">00070</a> <span class="keywordtype">void</span> <a class="code" href="classQBase.php#a4a111b2a437de3e94a23a6342cde3ed2">QBase::init_0D</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00071"></a>00071                     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)
<a name="l00072"></a>00072 {
<a name="l00073"></a>00073   <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>.resize(1);
<a name="l00074"></a>00074   <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>.resize(1);
<a name="l00075"></a>00075   <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[0] = <a class="code" href="classPoint.php">Point</a>(0.);
<a name="l00076"></a>00076   <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>[0] = 1.0;
<a name="l00077"></a>00077 }
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 
<a name="l00081"></a><a class="code" href="classQBase.php#a8934e87f23f2dc116dc4083c3df4f508">00081</a> <span class="keywordtype">void</span> <a class="code" href="classQBase.php#a8934e87f23f2dc116dc4083c3df4f508">QBase::scale</a>(std::pair&lt;Real, Real&gt; old_range,
<a name="l00082"></a>00082                   std::pair&lt;Real, Real&gt; new_range)
<a name="l00083"></a>00083 {
<a name="l00084"></a>00084   <span class="comment">// Make sure we are in 1D</span>
<a name="l00085"></a>00085   libmesh_assert(_dim == 1);
<a name="l00086"></a>00086   
<a name="l00087"></a>00087   <span class="comment">// Make sure that we have sane ranges </span>
<a name="l00088"></a>00088   libmesh_assert(new_range.second &gt; new_range.first);
<a name="l00089"></a>00089   libmesh_assert(old_range.second &gt; old_range.first);
<a name="l00090"></a>00090 
<a name="l00091"></a>00091   <span class="comment">// Make sure there are some points</span>
<a name="l00092"></a>00092   libmesh_assert(<a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>.size() &gt; 0);
<a name="l00093"></a>00093 
<a name="l00094"></a>00094   <span class="comment">// We&#39;re mapping from old_range -&gt; new_range </span>
<a name="l00095"></a>00095   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>.size(); i++)
<a name="l00096"></a>00096     {
<a name="l00097"></a>00097       <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[i](0) =
<a name="l00098"></a>00098         (<a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[i](0) - old_range.first) *
<a name="l00099"></a>00099         (new_range.second - new_range.first) /
<a name="l00100"></a>00100         (old_range.second - old_range.first) +
<a name="l00101"></a>00101         new_range.first;
<a name="l00102"></a>00102     }
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="comment">// Compute the scale factor and scale the weights</span>
<a name="l00105"></a>00105   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> scfact = (new_range.second - new_range.first) /
<a name="l00106"></a>00106                       (old_range.second - old_range.first);
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>.size(); i++)
<a name="l00109"></a>00109     <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>[i] *= scfact;
<a name="l00110"></a>00110 }
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 <span class="keywordtype">void</span> QBase::tensor_product_quad(<span class="keyword">const</span> <a class="code" href="classQBase.php">QBase</a>&amp; q1D)
<a name="l00116"></a>00116 {
<a name="l00117"></a>00117   
<a name="l00118"></a>00118   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQBase.php#a562b19b027dbad4ea8fdd65dddbaa649">n_points</a> = q1D.<a class="code" href="classQBase.php#a562b19b027dbad4ea8fdd65dddbaa649">n_points</a>();
<a name="l00119"></a>00119   
<a name="l00120"></a>00120   <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>.resize(n_points * n_points);
<a name="l00121"></a>00121   
<a name="l00122"></a>00122   <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>.resize(n_points * n_points);
<a name="l00123"></a>00123   
<a name="l00124"></a>00124   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>=0;
<a name="l00125"></a>00125   
<a name="l00126"></a>00126   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classQBase.php#a562b19b027dbad4ea8fdd65dddbaa649">n_points</a>; j++)
<a name="l00127"></a>00127     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classQBase.php#a562b19b027dbad4ea8fdd65dddbaa649">n_points</a>; i++)
<a name="l00128"></a>00128       {
<a name="l00129"></a>00129         <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[<a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>](0) = q1D.<a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>(i)(0);
<a name="l00130"></a>00130         <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[<a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>](1) = q1D.<a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>(j)(0);
<a name="l00131"></a>00131         
<a name="l00132"></a>00132         <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>[<a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>] = q1D.<a class="code" href="classQBase.php#a0dd67326f71a568ac67da91fd4d713ff">w</a>(i)*q1D.<a class="code" href="classQBase.php#a0dd67326f71a568ac67da91fd4d713ff">w</a>(j);
<a name="l00133"></a>00133         
<a name="l00134"></a>00134         qp++;
<a name="l00135"></a>00135       }
<a name="l00136"></a>00136 }
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 <span class="keywordtype">void</span> QBase::tensor_product_hex(<span class="keyword">const</span> <a class="code" href="classQBase.php">QBase</a>&amp; q1D)
<a name="l00143"></a>00143 {
<a name="l00144"></a>00144   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_points = q1D.<a class="code" href="classQBase.php#a562b19b027dbad4ea8fdd65dddbaa649">n_points</a>();
<a name="l00145"></a>00145   
<a name="l00146"></a>00146   <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>.resize(n_points * n_points * n_points);
<a name="l00147"></a>00147   
<a name="l00148"></a>00148   <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>.resize(n_points * n_points * n_points);
<a name="l00149"></a>00149   
<a name="l00150"></a>00150   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0;
<a name="l00151"></a>00151   
<a name="l00152"></a>00152   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;<a class="code" href="classQBase.php#a562b19b027dbad4ea8fdd65dddbaa649">n_points</a>; k++)
<a name="l00153"></a>00153     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classQBase.php#a562b19b027dbad4ea8fdd65dddbaa649">n_points</a>; j++)
<a name="l00154"></a>00154       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classQBase.php#a562b19b027dbad4ea8fdd65dddbaa649">n_points</a>; i++)
<a name="l00155"></a>00155         {
<a name="l00156"></a>00156           <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[<a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>](0) = q1D.<a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>(i)(0);
<a name="l00157"></a>00157           <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[<a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>](1) = q1D.<a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>(j)(0);
<a name="l00158"></a>00158           <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[<a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>](2) = q1D.<a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>(k)(0);
<a name="l00159"></a>00159           
<a name="l00160"></a>00160           <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>[<a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>] = q1D.<a class="code" href="classQBase.php#a0dd67326f71a568ac67da91fd4d713ff">w</a>(i) * q1D.<a class="code" href="classQBase.php#a0dd67326f71a568ac67da91fd4d713ff">w</a>(j) * q1D.<a class="code" href="classQBase.php#a0dd67326f71a568ac67da91fd4d713ff">w</a>(k);
<a name="l00161"></a>00161           
<a name="l00162"></a>00162           qp++;
<a name="l00163"></a>00163         }
<a name="l00164"></a>00164 }
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 <span class="keywordtype">void</span> QBase::tensor_product_prism(<span class="keyword">const</span> <a class="code" href="classQBase.php">QBase</a>&amp; q1D, <span class="keyword">const</span> <a class="code" href="classQBase.php">QBase</a>&amp; q2D)
<a name="l00170"></a>00170 {
<a name="l00171"></a>00171   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_points1D = q1D.<a class="code" href="classQBase.php#a562b19b027dbad4ea8fdd65dddbaa649">n_points</a>();
<a name="l00172"></a>00172   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_points2D = q2D.<a class="code" href="classQBase.php#a562b19b027dbad4ea8fdd65dddbaa649">n_points</a>();
<a name="l00173"></a>00173   
<a name="l00174"></a>00174   <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>.resize  (n_points1D * n_points2D);
<a name="l00175"></a>00175   <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>.resize (n_points1D * n_points2D);
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0;
<a name="l00178"></a>00178   
<a name="l00179"></a>00179   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_points1D; j++)
<a name="l00180"></a>00180     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_points2D; i++)
<a name="l00181"></a>00181       {
<a name="l00182"></a>00182         <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[<a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>](0) = q2D.<a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>(i)(0);
<a name="l00183"></a>00183         <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[<a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>](1) = q2D.<a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>(i)(1);
<a name="l00184"></a>00184         <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[<a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>](2) = q1D.<a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>(j)(0);
<a name="l00185"></a>00185 
<a name="l00186"></a>00186         <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>[<a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>] = q2D.<a class="code" href="classQBase.php#a0dd67326f71a568ac67da91fd4d713ff">w</a>(i) * q1D.<a class="code" href="classQBase.php#a0dd67326f71a568ac67da91fd4d713ff">w</a>(j);
<a name="l00187"></a>00187 
<a name="l00188"></a>00188         qp++;
<a name="l00189"></a>00189       }
<a name="l00190"></a>00190   
<a name="l00191"></a>00191 }
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 
<a name="l00196"></a><a class="code" href="quadrature_8C.php#a98886adbc1976761ab84721b2a28237e">00196</a> std::ostream&amp; <a class="code" href="fe__base_8C.php#af707d8f04488db8220405623626a146a">operator &lt;&lt; </a>(std::ostream&amp; os, <span class="keyword">const</span> <a class="code" href="classQBase.php">QBase</a>&amp; q)
<a name="l00197"></a>00197 {
<a name="l00198"></a>00198   q.<a class="code" href="classQBase.php#a2eccc789144e226e9d0d5c40e83c2b10">print_info</a>(os);
<a name="l00199"></a>00199   <span class="keywordflow">return</span> os;
<a name="l00200"></a>00200 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
