<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_eda61118c38b159444c3f5303da3dc86.php">quadrature</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>quadrature.h</h1>  </div>
</div>
<div class="contents">
<a href="quadrature_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: quadrature.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __quadrature_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __quadrature_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;utility&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;reference_counted_object.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;point.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;enum_elem_type.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;enum_order.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;enum_quadrature_type.h&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;auto_ptr.h&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00050"></a>00050 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00051"></a>00051 <span class="comment">// QBase class definition</span>
<a name="l00052"></a>00052 
<a name="l00053"></a><a class="code" href="classQBase.php">00053</a> <span class="keyword">class </span><a class="code" href="classQBase.php">QBase</a> : <span class="keyword">public</span> <a class="code" href="classReferenceCountedObject.php">ReferenceCountedObject</a>&lt;QBase&gt;
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055 <span class="keyword">protected</span>:
<a name="l00056"></a>00056 
<a name="l00061"></a>00061   <a class="code" href="classQBase.php#a13d1e4ee833c5c9056e96be25eda593f">QBase</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _dim,
<a name="l00062"></a>00062          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> _order=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa2c3571d1803f3f264b0b2c653f0a6a04">INVALID_ORDER</a>);
<a name="l00063"></a>00063   
<a name="l00064"></a>00064 <span class="keyword">public</span>:
<a name="l00065"></a>00065   
<a name="l00069"></a><a class="code" href="classQBase.php#a198c4f7df0d0bee3e61ce58ecbf6d85a">00069</a>   <span class="keyword">virtual</span> <a class="code" href="classQBase.php#a198c4f7df0d0bee3e61ce58ecbf6d85a">~QBase</a>() {}
<a name="l00070"></a>00070 
<a name="l00074"></a>00074   <span class="keyword">virtual</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ad">QuadratureType</a> <a class="code" href="classQBase.php#a86d3e0c674da2bfff694ab64b41e2a1a">type</a>() <span class="keyword">const</span> = 0;
<a name="l00075"></a>00075 
<a name="l00085"></a>00085   <span class="keyword">static</span> <a class="code" href="classAutoPtr.php">AutoPtr&lt;QBase&gt;</a> <a class="code" href="classQBase.php#a303e1f22a59f998c310aebb7e6c279b5">build</a> (<span class="keyword">const</span> std::string &amp;<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00086"></a>00086                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _dim,
<a name="l00087"></a>00087                                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> _order=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa2c3571d1803f3f264b0b2c653f0a6a04">INVALID_ORDER</a>);
<a name="l00088"></a>00088 
<a name="l00096"></a>00096   <span class="keyword">static</span> <a class="code" href="classAutoPtr.php">AutoPtr&lt;QBase&gt;</a> <a class="code" href="classQBase.php#a303e1f22a59f998c310aebb7e6c279b5">build</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ad">QuadratureType</a> _qt,
<a name="l00097"></a>00097                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _dim,
<a name="l00098"></a>00098                                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> _order=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa2c3571d1803f3f264b0b2c653f0a6a04">INVALID_ORDER</a>);
<a name="l00099"></a>00099 
<a name="l00103"></a><a class="code" href="classQBase.php#ad7d9a164950ad590c1bd9e5861809ff9">00103</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classQBase.php#ad7d9a164950ad590c1bd9e5861809ff9">get_elem_type</a>()<span class="keyword"> const</span>
<a name="l00104"></a>00104 <span class="keyword">    </span>{ <span class="keywordflow">return</span> _type; }
<a name="l00105"></a>00105 
<a name="l00109"></a><a class="code" href="classQBase.php#a9558ede8b5914d89f9483f67a7799d7b">00109</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQBase.php#a9558ede8b5914d89f9483f67a7799d7b">get_p_level</a>()<span class="keyword"> const</span>
<a name="l00110"></a>00110 <span class="keyword">    </span>{ <span class="keywordflow">return</span> _p_level; }
<a name="l00111"></a>00111 
<a name="l00115"></a><a class="code" href="classQBase.php#a562b19b027dbad4ea8fdd65dddbaa649">00115</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQBase.php#a562b19b027dbad4ea8fdd65dddbaa649">n_points</a>()<span class="keyword"> const</span>
<a name="l00116"></a>00116 <span class="keyword">    </span>{ libmesh_assert (!<a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>.empty()); <span class="keywordflow">return</span> <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>.size(); }
<a name="l00117"></a>00117 
<a name="l00121"></a><a class="code" href="classQBase.php#adb4c9caf830f15d7b880db7c28faca71">00121</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQBase.php#adb4c9caf830f15d7b880db7c28faca71">get_dim</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> _dim;  }
<a name="l00122"></a>00122 
<a name="l00127"></a><a class="code" href="classQBase.php#a23bdd4e01c2f6d74307b33c99f83c4e9">00127</a>   <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; <a class="code" href="classQBase.php#a23bdd4e01c2f6d74307b33c99f83c4e9">get_points</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>;  }
<a name="l00128"></a>00128 
<a name="l00133"></a><a class="code" href="classQBase.php#ac27c6daa8b3232c2869880c95c130ac5">00133</a>   std::vector&lt;Point&gt;&amp; <a class="code" href="classQBase.php#ac27c6daa8b3232c2869880c95c130ac5">get_points</a>() { <span class="keywordflow">return</span> <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>;  }
<a name="l00134"></a>00134 
<a name="l00138"></a><a class="code" href="classQBase.php#a6761747a317f199580691ea574fa9e99">00138</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classQBase.php#a6761747a317f199580691ea574fa9e99">get_weights</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>; }
<a name="l00139"></a>00139 
<a name="l00143"></a><a class="code" href="classQBase.php#a0a15cc31052f4baa71e20b52f3ba2b6e">00143</a>   std::vector&lt;Real&gt;&amp; <a class="code" href="classQBase.php#a0a15cc31052f4baa71e20b52f3ba2b6e">get_weights</a>() { <span class="keywordflow">return</span> <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>; }
<a name="l00144"></a>00144 
<a name="l00148"></a><a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">00148</a>   <a class="code" href="classPoint.php">Point</a> <a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00149"></a>00149 <span class="keyword">    </span>{ libmesh_assert (i &lt; <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>.size()); <span class="keywordflow">return</span> <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[i]; }
<a name="l00150"></a>00150 
<a name="l00154"></a><a class="code" href="classQBase.php#a0dd67326f71a568ac67da91fd4d713ff">00154</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classQBase.php#a0dd67326f71a568ac67da91fd4d713ff">w</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00155"></a>00155 <span class="keyword">    </span>{ libmesh_assert (i &lt; <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>.size()); <span class="keywordflow">return</span> <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>[i]; }
<a name="l00156"></a>00156   
<a name="l00161"></a>00161   <span class="keywordtype">void</span> <a class="code" href="classQBase.php#a1a0f71b05c7af21a8dd5577474b25818">init</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> _type=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>,
<a name="l00162"></a>00162              <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p_level=0);
<a name="l00163"></a>00163 
<a name="l00167"></a><a class="code" href="classQBase.php#ab4f0855636c3044d396c24d1f2934721">00167</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classQBase.php#ab4f0855636c3044d396c24d1f2934721">get_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(_order + _p_level); }
<a name="l00168"></a>00168   
<a name="l00172"></a>00172   <span class="keywordtype">void</span> <a class="code" href="classReferenceCounter.php#a96bf10fbce55bcc34c3ab0e469238ee1">print_info</a>(std::ostream&amp; os=std::cout) <span class="keyword">const</span>;
<a name="l00173"></a>00173 
<a name="l00180"></a>00180   <span class="keywordtype">void</span> <a class="code" href="classQBase.php#a8934e87f23f2dc116dc4083c3df4f508">scale</a>(std::pair&lt;Real, Real&gt; old_range,
<a name="l00181"></a>00181              std::pair&lt;Real, Real&gt; new_range);
<a name="l00182"></a>00182 
<a name="l00186"></a>00186   <span class="keyword">friend</span> std::ostream&amp; <a class="code" href="classQBase.php#a98886adbc1976761ab84721b2a28237e">operator &lt;&lt; </a>(std::ostream&amp; os, <span class="keyword">const</span> <a class="code" href="classQBase.php">QBase</a>&amp; q);
<a name="l00187"></a>00187 
<a name="l00203"></a><a class="code" href="classQBase.php#a8d178a77bd09f56326ee6135e9c43d8b">00203</a>   <span class="keywordtype">bool</span> <a class="code" href="classQBase.php#a8d178a77bd09f56326ee6135e9c43d8b">allow_rules_with_negative_weights</a>;
<a name="l00204"></a>00204   
<a name="l00205"></a>00205 <span class="keyword">protected</span>:
<a name="l00206"></a>00206 
<a name="l00207"></a>00207   
<a name="l00213"></a>00213   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classQBase.php#a4a111b2a437de3e94a23a6342cde3ed2">init_0D</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> _type=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>,
<a name="l00214"></a>00214                         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p_level=0);
<a name="l00215"></a>00215 
<a name="l00223"></a>00223   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classQBase.php#ae13365995bf2bc42a52bda510e368bf0">init_1D</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> _type=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>,
<a name="l00224"></a>00224                         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p_level=0) = 0;
<a name="l00225"></a>00225 
<a name="l00234"></a><a class="code" href="classQBase.php#a58b2ebdf197e8103a446d6c630207721">00234</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classQBase.php#a58b2ebdf197e8103a446d6c630207721">init_2D</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00235"></a>00235                         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> =0)
<a name="l00236"></a>00236 <span class="preprocessor">#ifndef DEBUG</span>
<a name="l00237"></a>00237 <span class="preprocessor"></span>  {}
<a name="l00238"></a>00238 <span class="preprocessor">#else</span>
<a name="l00239"></a>00239 <span class="preprocessor"></span>  {  
<a name="l00240"></a>00240     std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Seems as if this quadrature rule&quot;</span> &lt;&lt; std::endl
<a name="l00241"></a>00241               &lt;&lt; <span class="stringliteral">&quot; is not implemented for 2D.&quot;</span> &lt;&lt; std::endl;
<a name="l00242"></a>00242     libmesh_error();
<a name="l00243"></a>00243   }
<a name="l00244"></a>00244 <span class="preprocessor">#endif</span>
<a name="l00245"></a>00245 <span class="preprocessor"></span>
<a name="l00254"></a>00254   <span class="keyword">virtual</span> <span class="keywordtype">void</span> init_3D (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00255"></a>00255                         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> =0)
<a name="l00256"></a>00256 <span class="preprocessor">#ifndef DEBUG</span>
<a name="l00257"></a>00257 <span class="preprocessor"></span>  {}
<a name="l00258"></a>00258 <span class="preprocessor">#else</span>
<a name="l00259"></a>00259 <span class="preprocessor"></span>  {  
<a name="l00260"></a>00260     std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Seems as if this quadrature rule&quot;</span> &lt;&lt; std::endl
<a name="l00261"></a>00261               &lt;&lt; <span class="stringliteral">&quot; is not implemented for 3D.&quot;</span> &lt;&lt; std::endl;
<a name="l00262"></a>00262     libmesh_error();
<a name="l00263"></a>00263   }
<a name="l00264"></a>00264 <span class="preprocessor">#endif</span>
<a name="l00265"></a>00265 <span class="preprocessor"></span>  
<a name="l00266"></a>00266   
<a name="l00273"></a>00273   <span class="keywordtype">void</span> tensor_product_quad (<span class="keyword">const</span> <a class="code" href="classQBase.php">QBase</a>&amp; q1D);
<a name="l00274"></a>00274 
<a name="l00281"></a>00281   <span class="keywordtype">void</span> tensor_product_hex (<span class="keyword">const</span> <a class="code" href="classQBase.php">QBase</a>&amp; q1D);
<a name="l00282"></a>00282   
<a name="l00290"></a>00290   <span class="keywordtype">void</span> tensor_product_prism (<span class="keyword">const</span> <a class="code" href="classQBase.php">QBase</a>&amp; q1D, <span class="keyword">const</span> <a class="code" href="classQBase.php">QBase</a>&amp; q2D);
<a name="l00291"></a>00291 
<a name="l00292"></a>00292 
<a name="l00293"></a>00293   
<a name="l00297"></a>00297   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _dim;
<a name="l00298"></a>00298   
<a name="l00302"></a>00302   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> _order;
<a name="l00303"></a>00303 
<a name="l00308"></a>00308   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> _type;
<a name="l00309"></a>00309 
<a name="l00314"></a>00314   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _p_level;
<a name="l00315"></a>00315 
<a name="l00320"></a><a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">00320</a>   std::vector&lt;Point&gt; <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>;
<a name="l00321"></a>00321 
<a name="l00325"></a><a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">00325</a>   std::vector&lt;Real&gt; <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>;
<a name="l00326"></a>00326 };
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 
<a name="l00332"></a>00332 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00333"></a>00333 <span class="comment">// QBase class members</span>
<a name="l00334"></a>00334 
<a name="l00335"></a>00335 <span class="keyword">inline</span>
<a name="l00336"></a><a class="code" href="classQBase.php#a13d1e4ee833c5c9056e96be25eda593f">00336</a> <a class="code" href="classQBase.php#a13d1e4ee833c5c9056e96be25eda593f">QBase::QBase</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d,
<a name="l00337"></a>00337              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o) :
<a name="l00338"></a>00338   allow_rules_with_negative_weights(true),
<a name="l00339"></a>00339   _dim(d),
<a name="l00340"></a>00340   _order(o),
<a name="l00341"></a>00341   _type(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>),
<a name="l00342"></a>00342   _p_level(0)
<a name="l00343"></a>00343 {
<a name="l00344"></a>00344 }
<a name="l00345"></a>00345 
<a name="l00346"></a>00346 
<a name="l00347"></a>00347 
<a name="l00348"></a>00348 
<a name="l00349"></a>00349 <span class="keyword">inline</span>
<a name="l00350"></a><a class="code" href="classQBase.php#a2eccc789144e226e9d0d5c40e83c2b10">00350</a> <span class="keywordtype">void</span> <a class="code" href="classReferenceCounter.php#a96bf10fbce55bcc34c3ab0e469238ee1">QBase::print_info</a>(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00351"></a>00351 <span class="keyword"></span>{
<a name="l00352"></a>00352   libmesh_assert(!<a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>.empty());
<a name="l00353"></a>00353   libmesh_assert(!<a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>.empty());
<a name="l00354"></a>00354 
<a name="l00355"></a>00355   os &lt;&lt; <span class="stringliteral">&quot;N_Q_Points=&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classQBase.php#a562b19b027dbad4ea8fdd65dddbaa649">n_points</a>() &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l00356"></a>00356   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>=0; <a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>&lt;this-&gt;<a class="code" href="classQBase.php#a562b19b027dbad4ea8fdd65dddbaa649">n_points</a>(); <a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>++)
<a name="l00357"></a>00357     {
<a name="l00358"></a>00358       os &lt;&lt; <span class="stringliteral">&quot; Point &quot;</span> &lt;&lt; <a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a> &lt;&lt; <span class="stringliteral">&quot;:\n&quot;</span>
<a name="l00359"></a>00359          &lt;&lt; <span class="stringliteral">&quot;  &quot;</span>
<a name="l00360"></a>00360          &lt;&lt; <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[<a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>]
<a name="l00361"></a>00361          &lt;&lt; <span class="stringliteral">&quot; Weight:\n &quot;</span>
<a name="l00362"></a>00362          &lt;&lt; <span class="stringliteral">&quot;  w=&quot;</span> &lt;&lt; <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>[<a class="code" href="classQBase.php#ab861cdec6206a175be7e4bb1cd08dfd5">qp</a>] &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span> &lt;&lt; std::endl;
<a name="l00363"></a>00363     }
<a name="l00364"></a>00364 }
<a name="l00365"></a>00365 
<a name="l00366"></a>00366 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
