<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_7bd01b27aea5d59f5c4653fb1c436874.php">quadrature</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>quadrature_conical_2D.C</h1>  </div>
</div>
<div class="contents">
<a href="quadrature__conical__2D_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: quadrature_conical_2D.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// Local includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;quadrature_conical.h&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a><a class="code" href="classQConical.php#affca0f0608a216862bcec8633df957ed">00026</a> <span class="keywordtype">void</span> <a class="code" href="classQConical.php#affca0f0608a216862bcec8633df957ed">QConical::init_2D</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> _type,
<a name="l00027"></a>00027                        <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)
<a name="l00028"></a>00028 {
<a name="l00029"></a>00029   <span class="keywordflow">switch</span> (_type)
<a name="l00030"></a>00030     {
<a name="l00031"></a>00031     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00032"></a>00032     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00033"></a>00033       {
<a name="l00034"></a>00034         this-&gt;<a class="code" href="classQConical.php#aca80fae98897349c5f16278c311dccd3">conical_product_tri</a>(p);
<a name="l00035"></a>00035         <span class="keywordflow">return</span>;
<a name="l00036"></a>00036         
<a name="l00037"></a>00037       } <span class="comment">// end case TRI3, TRI6</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040       
<a name="l00041"></a>00041       <span class="comment">//---------------------------------------------</span>
<a name="l00042"></a>00042       <span class="comment">// Unsupported element type</span>
<a name="l00043"></a>00043     <span class="keywordflow">default</span>:
<a name="l00044"></a>00044       {
<a name="l00045"></a>00045         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported element type: &quot;</span> &lt;&lt; _type &lt;&lt; std::endl;
<a name="l00046"></a>00046         libmesh_error();
<a name="l00047"></a>00047       }
<a name="l00048"></a>00048     } <span class="comment">// end switch (_type)</span>
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   <span class="comment">// We must have returned or errored-out by this point.  If not,</span>
<a name="l00051"></a>00051   <span class="comment">// throw an error now.</span>
<a name="l00052"></a>00052   libmesh_error();
<a name="l00053"></a>00053   <span class="keywordflow">return</span>;
<a name="l00054"></a>00054 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
