<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_7bd01b27aea5d59f5c4653fb1c436874.php">quadrature</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>quadrature_gauss.C</h1>  </div>
</div>
<div class="contents">
<a href="quadrature__gauss_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: quadrature_gauss.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;quadrature_gauss.h&quot;</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// See the files:</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// quadrature_gauss_1D.C</span>
<a name="l00026"></a>00026 <span class="comment">// quadrature_gauss_2D.C</span>
<a name="l00027"></a>00027 <span class="comment">// quadrature_gauss_3D.C</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// for implementation of specific element types.</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a><a class="code" href="classQGauss.php#abfb24d0f4a8f02dd3585f84c8c91311d">00032</a> <span class="keywordtype">void</span> <a class="code" href="classQGauss.php#abfb24d0f4a8f02dd3585f84c8c91311d">QGauss::keast_rule</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> rule_data[][4],
<a name="l00033"></a>00033                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_pts)
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035   <span class="comment">// Like the Dunavant rule, the input data should have 4 columns.  These columns</span>
<a name="l00036"></a>00036   <span class="comment">// have the following format and implied permutations (w=weight).</span>
<a name="l00037"></a>00037   <span class="comment">// {a, 0, 0, w} = 1-permutation  (a,a,a)</span>
<a name="l00038"></a>00038   <span class="comment">// {a, b, 0, w} = 4-permutation  (a,b,b), (b,a,b), (b,b,a), (b,b,b)</span>
<a name="l00039"></a>00039   <span class="comment">// {a, 0, b, w} = 6-permutation  (a,a,b), (a,b,b), (b,b,a), (b,a,b), (b,a,a), (a,b,a)</span>
<a name="l00040"></a>00040   <span class="comment">// {a, b, c, w} = 12-permutation (a,a,b), (a,a,c), (b,a,a), (c,a,a), (a,b,a), (a,c,a)</span>
<a name="l00041"></a>00041   <span class="comment">//                               (a,b,c), (a,c,b), (b,a,c), (b,c,a), (c,a,b), (c,b,a)</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043   <span class="comment">// Always insert into the points &amp; weights vector relative to the offset </span>
<a name="l00044"></a>00044   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> offset=0;
<a name="l00045"></a>00045   
<a name="l00046"></a>00046   
<a name="l00047"></a>00047   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_pts; ++p)
<a name="l00048"></a>00048     {
<a name="l00049"></a>00049 
<a name="l00050"></a>00050       <span class="comment">// There must always be a non-zero entry to start the row</span>
<a name="l00051"></a>00051       libmesh_assert(rule_data[p][0] != static_cast&lt;Real&gt;(0.0));
<a name="l00052"></a>00052       
<a name="l00053"></a>00053       <span class="comment">// A zero weight may imply you did not set up the raw data correctly</span>
<a name="l00054"></a>00054       libmesh_assert(rule_data[p][3] != static_cast&lt;Real&gt;(0.0));
<a name="l00055"></a>00055 
<a name="l00056"></a>00056       <span class="comment">// What kind of point is this?</span>
<a name="l00057"></a>00057       <span class="comment">// One non-zero entry in first 3 cols   ? 1-perm (centroid) point = 1</span>
<a name="l00058"></a>00058       <span class="comment">// Two non-zero entries in first 3 cols ? 3-perm point            = 3</span>
<a name="l00059"></a>00059       <span class="comment">// Three non-zero entries               ? 6-perm point            = 6</span>
<a name="l00060"></a>00060       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pointtype=1;
<a name="l00061"></a>00061 
<a name="l00062"></a>00062       <span class="keywordflow">if</span> (rule_data[p][1] != static_cast&lt;Real&gt;(0.0))      
<a name="l00063"></a>00063         {
<a name="l00064"></a>00064           <span class="keywordflow">if</span> (rule_data[p][2] != static_cast&lt;Real&gt;(0.0))
<a name="l00065"></a>00065             pointtype = 12;
<a name="l00066"></a>00066           <span class="keywordflow">else</span>
<a name="l00067"></a>00067             pointtype = 4;
<a name="l00068"></a>00068         }
<a name="l00069"></a>00069       <span class="keywordflow">else</span>
<a name="l00070"></a>00070         {
<a name="l00071"></a>00071           <span class="comment">// The second entry is zero.  What about the third?</span>
<a name="l00072"></a>00072           <span class="keywordflow">if</span> (rule_data[p][2] != static_cast&lt;Real&gt;(0.0))
<a name="l00073"></a>00073             pointtype = 6;
<a name="l00074"></a>00074         }
<a name="l00075"></a>00075 
<a name="l00076"></a>00076       
<a name="l00077"></a>00077       <span class="keywordflow">switch</span> (pointtype)
<a name="l00078"></a>00078         {
<a name="l00079"></a>00079         <span class="keywordflow">case</span> 1:
<a name="l00080"></a>00080           {
<a name="l00081"></a>00081             <span class="comment">// Be sure we have enough space to insert this point</span>
<a name="l00082"></a>00082             libmesh_assert(offset + 0 &lt; <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>.size());
<a name="l00083"></a>00083 
<a name="l00084"></a>00084             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> a = rule_data[p][0];
<a name="l00085"></a>00085             
<a name="l00086"></a>00086             <span class="comment">// The point has only a single permutation (the centroid!)</span>
<a name="l00087"></a>00087             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset  + 0] = <a class="code" href="classPoint.php">Point</a>(a,a,a);
<a name="l00088"></a>00088 
<a name="l00089"></a>00089             <span class="comment">// The weight is always the last entry in the row.</span>
<a name="l00090"></a>00090             <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>[offset + 0] = rule_data[p][3];
<a name="l00091"></a>00091 
<a name="l00092"></a>00092             offset += pointtype;
<a name="l00093"></a>00093             <span class="keywordflow">break</span>;
<a name="l00094"></a>00094           }
<a name="l00095"></a>00095 
<a name="l00096"></a>00096         <span class="keywordflow">case</span> 4:
<a name="l00097"></a>00097           {
<a name="l00098"></a>00098             <span class="comment">// Be sure we have enough space to insert these points</span>
<a name="l00099"></a>00099             libmesh_assert(offset + 3 &lt; <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>.size());
<a name="l00100"></a>00100 
<a name="l00101"></a>00101             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> a = rule_data[p][0];
<a name="l00102"></a>00102             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> b = rule_data[p][1];
<a name="l00103"></a>00103             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classQBase.php#a0dd67326f71a568ac67da91fd4d713ff">w</a> = rule_data[p][3];
<a name="l00104"></a>00104             
<a name="l00105"></a>00105             <span class="comment">// Here it&#39;s understood the second entry is to be used twice, and</span>
<a name="l00106"></a>00106             <span class="comment">// thus there are three possible permutations.</span>
<a name="l00107"></a>00107             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 0] = <a class="code" href="classPoint.php">Point</a>(a,b,b);
<a name="l00108"></a>00108             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 1] = <a class="code" href="classPoint.php">Point</a>(b,a,b);
<a name="l00109"></a>00109             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 2] = <a class="code" href="classPoint.php">Point</a>(b,b,a);
<a name="l00110"></a>00110             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 3] = <a class="code" href="classPoint.php">Point</a>(b,b,b);
<a name="l00111"></a>00111 
<a name="l00112"></a>00112             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;pointtype; ++j)
<a name="l00113"></a>00113               <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>[offset + j] = w;
<a name="l00114"></a>00114             
<a name="l00115"></a>00115             offset += pointtype;
<a name="l00116"></a>00116             <span class="keywordflow">break</span>;
<a name="l00117"></a>00117           }
<a name="l00118"></a>00118 
<a name="l00119"></a>00119         <span class="keywordflow">case</span> 6:
<a name="l00120"></a>00120           {
<a name="l00121"></a>00121             <span class="comment">// Be sure we have enough space to insert these points</span>
<a name="l00122"></a>00122             libmesh_assert(offset + 5 &lt; <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>.size());
<a name="l00123"></a>00123 
<a name="l00124"></a>00124             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> a = rule_data[p][0];
<a name="l00125"></a>00125             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> b = rule_data[p][2];
<a name="l00126"></a>00126             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classQBase.php#a0dd67326f71a568ac67da91fd4d713ff">w</a> = rule_data[p][3];
<a name="l00127"></a>00127             
<a name="l00128"></a>00128             <span class="comment">// Three individual entries with six permutations.</span>
<a name="l00129"></a>00129             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 0] = <a class="code" href="classPoint.php">Point</a>(a,a,b);
<a name="l00130"></a>00130             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 1] = <a class="code" href="classPoint.php">Point</a>(a,b,b);
<a name="l00131"></a>00131             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 2] = <a class="code" href="classPoint.php">Point</a>(b,b,a);
<a name="l00132"></a>00132             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 3] = <a class="code" href="classPoint.php">Point</a>(b,a,b);
<a name="l00133"></a>00133             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 4] = <a class="code" href="classPoint.php">Point</a>(b,a,a);
<a name="l00134"></a>00134             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 5] = <a class="code" href="classPoint.php">Point</a>(a,b,a);
<a name="l00135"></a>00135 
<a name="l00136"></a>00136             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;pointtype; ++j)
<a name="l00137"></a>00137               <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>[offset + j] = w;
<a name="l00138"></a>00138             
<a name="l00139"></a>00139             offset += pointtype;
<a name="l00140"></a>00140             <span class="keywordflow">break</span>;
<a name="l00141"></a>00141           }
<a name="l00142"></a>00142 
<a name="l00143"></a>00143           
<a name="l00144"></a>00144         <span class="keywordflow">case</span> 12:
<a name="l00145"></a>00145           {
<a name="l00146"></a>00146             <span class="comment">// Be sure we have enough space to insert these points</span>
<a name="l00147"></a>00147             libmesh_assert(offset + 11 &lt; <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>.size());
<a name="l00148"></a>00148 
<a name="l00149"></a>00149             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> a = rule_data[p][0];
<a name="l00150"></a>00150             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> b = rule_data[p][1];
<a name="l00151"></a>00151             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> c = rule_data[p][2];
<a name="l00152"></a>00152             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classQBase.php#a0dd67326f71a568ac67da91fd4d713ff">w</a> = rule_data[p][3];
<a name="l00153"></a>00153             
<a name="l00154"></a>00154             <span class="comment">// Three individual entries with six permutations.</span>
<a name="l00155"></a>00155             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 0] = <a class="code" href="classPoint.php">Point</a>(a,a,b);  <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 6]  = <a class="code" href="classPoint.php">Point</a>(a,b,c);
<a name="l00156"></a>00156             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 1] = <a class="code" href="classPoint.php">Point</a>(a,a,c);  <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 7]  = <a class="code" href="classPoint.php">Point</a>(a,c,b);
<a name="l00157"></a>00157             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 2] = <a class="code" href="classPoint.php">Point</a>(b,a,a);  <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 8]  = <a class="code" href="classPoint.php">Point</a>(b,a,c);
<a name="l00158"></a>00158             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 3] = <a class="code" href="classPoint.php">Point</a>(c,a,a);  <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 9]  = <a class="code" href="classPoint.php">Point</a>(b,c,a);
<a name="l00159"></a>00159             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 4] = <a class="code" href="classPoint.php">Point</a>(a,b,a);  <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 10] = <a class="code" href="classPoint.php">Point</a>(c,a,b);
<a name="l00160"></a>00160             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 5] = <a class="code" href="classPoint.php">Point</a>(a,c,a);  <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 11] = <a class="code" href="classPoint.php">Point</a>(c,b,a);
<a name="l00161"></a>00161 
<a name="l00162"></a>00162             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;pointtype; ++j)
<a name="l00163"></a>00163               <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>[offset + j] = w;
<a name="l00164"></a>00164             
<a name="l00165"></a>00165             offset += pointtype;
<a name="l00166"></a>00166             <span class="keywordflow">break</span>;
<a name="l00167"></a>00167           }
<a name="l00168"></a>00168 
<a name="l00169"></a>00169         <span class="keywordflow">default</span>:
<a name="l00170"></a>00170           {
<a name="l00171"></a>00171             std::cerr &lt;&lt; <span class="stringliteral">&quot;Don&#39;t know what to do with this many permutation points!&quot;</span> &lt;&lt; std::endl;
<a name="l00172"></a>00172             libmesh_error();
<a name="l00173"></a>00173           }
<a name="l00174"></a>00174         }
<a name="l00175"></a>00175       
<a name="l00176"></a>00176     }
<a name="l00177"></a>00177   
<a name="l00178"></a>00178 }
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 <span class="comment">// A number of different rules for triangles can be described by</span>
<a name="l00182"></a>00182 <span class="comment">// permutations of the following types of points:</span>
<a name="l00183"></a>00183 <span class="comment">// I:   &quot;1&quot;-permutation, (1/3,1/3)  (single point only)</span>
<a name="l00184"></a>00184 <span class="comment">// II:   3-permutation, (a,a,1-2a) </span>
<a name="l00185"></a>00185 <span class="comment">// III:  6-permutation, (a,b,1-a-b)</span>
<a name="l00186"></a>00186 <span class="comment">// The weights for a given set of permutations are all the same.</span>
<a name="l00187"></a><a class="code" href="classQGauss.php#aee2d59ed71b5cb524bcb45a1d52c3caa">00187</a> <span class="keywordtype">void</span> <a class="code" href="classQGauss.php#aee2d59ed71b5cb524bcb45a1d52c3caa">QGauss::dunavant_rule2</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>* wts,
<a name="l00188"></a>00188                             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>* a,
<a name="l00189"></a>00189                             <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>* b,
<a name="l00190"></a>00190                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>* permutation_ids,
<a name="l00191"></a>00191                             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_wts)
<a name="l00192"></a>00192 {
<a name="l00193"></a>00193   <span class="comment">// Figure out how many total points by summing up the entries</span>
<a name="l00194"></a>00194   <span class="comment">// in the permutation_ids array, and resize the _points and _weights</span>
<a name="l00195"></a>00195   <span class="comment">// vectors appropriately.</span>
<a name="l00196"></a>00196   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> total_pts = 0;
<a name="l00197"></a>00197   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_wts; ++p)
<a name="l00198"></a>00198     total_pts += permutation_ids[p];
<a name="l00199"></a>00199 
<a name="l00200"></a>00200   <span class="comment">// Resize point and weight vectors appropriately.</span>
<a name="l00201"></a>00201   <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>.resize(total_pts);
<a name="l00202"></a>00202   <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>.resize(total_pts);
<a name="l00203"></a>00203     
<a name="l00204"></a>00204   <span class="comment">// Always insert into the points &amp; weights vector relative to the offset </span>
<a name="l00205"></a>00205   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> offset=0;
<a name="l00206"></a>00206   
<a name="l00207"></a>00207   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_wts; ++p)
<a name="l00208"></a>00208     {
<a name="l00209"></a>00209       <span class="keywordflow">switch</span> (permutation_ids[p])
<a name="l00210"></a>00210         {
<a name="l00211"></a>00211         <span class="keywordflow">case</span> 1:
<a name="l00212"></a>00212           {
<a name="l00213"></a>00213             <span class="comment">// The point has only a single permutation (the centroid!)</span>
<a name="l00214"></a>00214             <span class="comment">// So we don&#39;t even need to look in the a or b arrays.</span>
<a name="l00215"></a>00215             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a> [offset  + 0] = <a class="code" href="classPoint.php">Point</a>(1.0L/3.0L, 1.0L/3.0L);
<a name="l00216"></a>00216             <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>[offset + 0] = wts[p];
<a name="l00217"></a>00217             
<a name="l00218"></a>00218             offset += 1;
<a name="l00219"></a>00219             <span class="keywordflow">break</span>;
<a name="l00220"></a>00220           }
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 
<a name="l00223"></a>00223         <span class="keywordflow">case</span> 3:
<a name="l00224"></a>00224           {
<a name="l00225"></a>00225             <span class="comment">// For this type of rule, don&#39;t need to look in the b array.</span>
<a name="l00226"></a>00226             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 0] = <a class="code" href="classPoint.php">Point</a>(a[p],         a[p]);         <span class="comment">// (a,a)</span>
<a name="l00227"></a>00227             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 1] = <a class="code" href="classPoint.php">Point</a>(a[p],         1.L-2.L*a[p]); <span class="comment">// (a,1-2a)</span>
<a name="l00228"></a>00228             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 2] = <a class="code" href="classPoint.php">Point</a>(1.L-2.L*a[p], a[p]);         <span class="comment">// (1-2a,a)</span>
<a name="l00229"></a>00229 
<a name="l00230"></a>00230             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;3; ++j)
<a name="l00231"></a>00231               <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>[offset + j] = wts[p];
<a name="l00232"></a>00232             
<a name="l00233"></a>00233             offset += 3;
<a name="l00234"></a>00234             <span class="keywordflow">break</span>;
<a name="l00235"></a>00235           }
<a name="l00236"></a>00236 
<a name="l00237"></a>00237         <span class="keywordflow">case</span> 6:
<a name="l00238"></a>00238           {
<a name="l00239"></a>00239             <span class="comment">// This type of point uses all 3 arrays...</span>
<a name="l00240"></a>00240             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 0] = <a class="code" href="classPoint.php">Point</a>(a[p], b[p]);
<a name="l00241"></a>00241             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 1] = <a class="code" href="classPoint.php">Point</a>(b[p], a[p]);
<a name="l00242"></a>00242             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 2] = <a class="code" href="classPoint.php">Point</a>(a[p], 1.L-a[p]-b[p]);
<a name="l00243"></a>00243             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 3] = <a class="code" href="classPoint.php">Point</a>(1.L-a[p]-b[p], a[p]);
<a name="l00244"></a>00244             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 4] = <a class="code" href="classPoint.php">Point</a>(b[p], 1.L-a[p]-b[p]);
<a name="l00245"></a>00245             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 5] = <a class="code" href="classPoint.php">Point</a>(1.L-a[p]-b[p], b[p]);
<a name="l00246"></a>00246 
<a name="l00247"></a>00247             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;6; ++j)
<a name="l00248"></a>00248               <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>[offset + j] = wts[p];
<a name="l00249"></a>00249             
<a name="l00250"></a>00250             offset += 6;
<a name="l00251"></a>00251             <span class="keywordflow">break</span>;
<a name="l00252"></a>00252           }
<a name="l00253"></a>00253           
<a name="l00254"></a>00254         <span class="keywordflow">default</span>:
<a name="l00255"></a>00255           {
<a name="l00256"></a>00256             std::cerr &lt;&lt; <span class="stringliteral">&quot;Unknown permutation id: &quot;</span> &lt;&lt; permutation_ids[p] &lt;&lt; <span class="stringliteral">&quot;!&quot;</span> &lt;&lt; std::endl;
<a name="l00257"></a>00257             libmesh_error();
<a name="l00258"></a>00258           }
<a name="l00259"></a>00259         }
<a name="l00260"></a>00260     }
<a name="l00261"></a>00261   
<a name="l00262"></a>00262 }
<a name="l00263"></a>00263 
<a name="l00264"></a>00264 
<a name="l00265"></a><a class="code" href="classQGauss.php#a8341ee199d1beb0d2e76f8991b2ca717">00265</a> <span class="keywordtype">void</span> <a class="code" href="classQGauss.php#a8341ee199d1beb0d2e76f8991b2ca717">QGauss::dunavant_rule</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> rule_data[][4],
<a name="l00266"></a>00266                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_pts)
<a name="l00267"></a>00267 {
<a name="l00268"></a>00268   <span class="comment">// The input data array has 4 columns.  The first 3 are the permutation points.</span>
<a name="l00269"></a>00269   <span class="comment">// The last column is the weights for a given set of permutation points.  A zero</span>
<a name="l00270"></a>00270   <span class="comment">// in two of the first 3 columns implies the point is a 1-permutation (centroid).</span>
<a name="l00271"></a>00271   <span class="comment">// A zero in one of the first 3 columns implies the point is a 3-permutation.</span>
<a name="l00272"></a>00272   <span class="comment">// Otherwise each point is assumed to be a 6-permutation.</span>
<a name="l00273"></a>00273 
<a name="l00274"></a>00274   <span class="comment">// Always insert into the points &amp; weights vector relative to the offset </span>
<a name="l00275"></a>00275   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> offset=0;
<a name="l00276"></a>00276 
<a name="l00277"></a>00277   
<a name="l00278"></a>00278   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_pts; ++p)
<a name="l00279"></a>00279     {
<a name="l00280"></a>00280 
<a name="l00281"></a>00281       <span class="comment">// There must always be a non-zero entry to start the row</span>
<a name="l00282"></a>00282       libmesh_assert( rule_data[p][0] != static_cast&lt;Real&gt;(0.0) );
<a name="l00283"></a>00283       
<a name="l00284"></a>00284       <span class="comment">// A zero weight may imply you did not set up the raw data correctly</span>
<a name="l00285"></a>00285       libmesh_assert( rule_data[p][3] != static_cast&lt;Real&gt;(0.0) );
<a name="l00286"></a>00286 
<a name="l00287"></a>00287       <span class="comment">// What kind of point is this?</span>
<a name="l00288"></a>00288       <span class="comment">// One non-zero entry in first 3 cols   ? 1-perm (centroid) point = 1</span>
<a name="l00289"></a>00289       <span class="comment">// Two non-zero entries in first 3 cols ? 3-perm point            = 3</span>
<a name="l00290"></a>00290       <span class="comment">// Three non-zero entries               ? 6-perm point            = 6</span>
<a name="l00291"></a>00291       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pointtype=1;
<a name="l00292"></a>00292       
<a name="l00293"></a>00293       <span class="keywordflow">if</span> (rule_data[p][1] != static_cast&lt;Real&gt;(0.0))      
<a name="l00294"></a>00294         {
<a name="l00295"></a>00295           <span class="keywordflow">if</span> (rule_data[p][2] != static_cast&lt;Real&gt;(0.0))
<a name="l00296"></a>00296             pointtype = 6;
<a name="l00297"></a>00297           <span class="keywordflow">else</span>
<a name="l00298"></a>00298             pointtype = 3;
<a name="l00299"></a>00299         }
<a name="l00300"></a>00300       
<a name="l00301"></a>00301       <span class="keywordflow">switch</span> (pointtype)
<a name="l00302"></a>00302         {
<a name="l00303"></a>00303         <span class="keywordflow">case</span> 1:
<a name="l00304"></a>00304           {
<a name="l00305"></a>00305             <span class="comment">// Be sure we have enough space to insert this point</span>
<a name="l00306"></a>00306             libmesh_assert(offset + 0 &lt; <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>.size());
<a name="l00307"></a>00307             
<a name="l00308"></a>00308             <span class="comment">// The point has only a single permutation (the centroid!)</span>
<a name="l00309"></a>00309             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset  + 0] = <a class="code" href="classPoint.php">Point</a>(rule_data[p][0], rule_data[p][0]);
<a name="l00310"></a>00310 
<a name="l00311"></a>00311             <span class="comment">// The weight is always the last entry in the row.</span>
<a name="l00312"></a>00312             <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>[offset + 0] = rule_data[p][3];
<a name="l00313"></a>00313 
<a name="l00314"></a>00314             offset += 1;
<a name="l00315"></a>00315             <span class="keywordflow">break</span>;
<a name="l00316"></a>00316           }
<a name="l00317"></a>00317 
<a name="l00318"></a>00318         <span class="keywordflow">case</span> 3:
<a name="l00319"></a>00319           {
<a name="l00320"></a>00320             <span class="comment">// Be sure we have enough space to insert these points</span>
<a name="l00321"></a>00321             libmesh_assert(offset + 2 &lt; <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>.size());
<a name="l00322"></a>00322             
<a name="l00323"></a>00323             <span class="comment">// Here it&#39;s understood the second entry is to be used twice, and</span>
<a name="l00324"></a>00324             <span class="comment">// thus there are three possible permutations.</span>
<a name="l00325"></a>00325             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 0] = <a class="code" href="classPoint.php">Point</a>(rule_data[p][0], rule_data[p][1]);
<a name="l00326"></a>00326             _points[offset + 1] = <a class="code" href="classPoint.php">Point</a>(rule_data[p][1], rule_data[p][0]);
<a name="l00327"></a>00327             _points[offset + 2] = <a class="code" href="classPoint.php">Point</a>(rule_data[p][1], rule_data[p][1]);
<a name="l00328"></a>00328 
<a name="l00329"></a>00329             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;3; ++j)
<a name="l00330"></a>00330               <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>[offset + j] = rule_data[p][3];
<a name="l00331"></a>00331             
<a name="l00332"></a>00332             offset += 3;
<a name="l00333"></a>00333             <span class="keywordflow">break</span>;
<a name="l00334"></a>00334           }
<a name="l00335"></a>00335 
<a name="l00336"></a>00336         <span class="keywordflow">case</span> 6:
<a name="l00337"></a>00337           {
<a name="l00338"></a>00338             <span class="comment">// Be sure we have enough space to insert these points</span>
<a name="l00339"></a>00339             libmesh_assert(offset + 5 &lt; <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>.size());
<a name="l00340"></a>00340             
<a name="l00341"></a>00341             <span class="comment">// Three individual entries with six permutations.</span>
<a name="l00342"></a>00342             <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[offset + 0] = <a class="code" href="classPoint.php">Point</a>(rule_data[p][0], rule_data[p][1]);
<a name="l00343"></a>00343             _points[offset + 1] = <a class="code" href="classPoint.php">Point</a>(rule_data[p][0], rule_data[p][2]);
<a name="l00344"></a>00344             _points[offset + 2] = <a class="code" href="classPoint.php">Point</a>(rule_data[p][1], rule_data[p][0]);
<a name="l00345"></a>00345             _points[offset + 3] = <a class="code" href="classPoint.php">Point</a>(rule_data[p][1], rule_data[p][2]);
<a name="l00346"></a>00346             _points[offset + 4] = <a class="code" href="classPoint.php">Point</a>(rule_data[p][2], rule_data[p][0]);
<a name="l00347"></a>00347             _points[offset + 5] = <a class="code" href="classPoint.php">Point</a>(rule_data[p][2], rule_data[p][1]);
<a name="l00348"></a>00348 
<a name="l00349"></a>00349             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;6; ++j)
<a name="l00350"></a>00350               <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>[offset + j] = rule_data[p][3];
<a name="l00351"></a>00351             
<a name="l00352"></a>00352             offset += 6;
<a name="l00353"></a>00353             <span class="keywordflow">break</span>;
<a name="l00354"></a>00354           }
<a name="l00355"></a>00355 
<a name="l00356"></a>00356         <span class="keywordflow">default</span>:
<a name="l00357"></a>00357           {
<a name="l00358"></a>00358             std::cerr &lt;&lt; <span class="stringliteral">&quot;Don&#39;t know what to do with this many permutation points!&quot;</span> &lt;&lt; std::endl;
<a name="l00359"></a>00359             libmesh_error();
<a name="l00360"></a>00360           }
<a name="l00361"></a>00361         }
<a name="l00362"></a>00362     }
<a name="l00363"></a>00363 }
<a name="l00364"></a>00364 
<a name="l00365"></a>00365 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
