<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_eda61118c38b159444c3f5303da3dc86.php">quadrature</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>quadrature_grid.h</h1>  </div>
</div>
<div class="contents">
<a href="quadrature__grid_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: quadrature_grid.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __quadrature_grid_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __quadrature_grid_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="quadrature_8h.php">quadrature.h</a>&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00036"></a>00036 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00037"></a>00037 <span class="comment">// QGrid class definition</span>
<a name="l00038"></a>00038 
<a name="l00039"></a><a class="code" href="classQGrid.php">00039</a> <span class="keyword">class </span><a class="code" href="classQGrid.php">QGrid</a> : <span class="keyword">public</span> <a class="code" href="classQBase.php">QBase</a>
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041  <span class="keyword">public</span>:
<a name="l00042"></a>00042 
<a name="l00046"></a>00046   <a class="code" href="classQGrid.php#a630cadd40dac5d8b93c9c7694b6c2234">QGrid</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _dim,
<a name="l00047"></a>00047          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> _order=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa2c3571d1803f3f264b0b2c653f0a6a04">INVALID_ORDER</a>);
<a name="l00048"></a>00048 
<a name="l00052"></a>00052   <a class="code" href="classQGrid.php#a3957562e1191817184e45f645d4a9886">~QGrid</a>();
<a name="l00053"></a>00053 
<a name="l00057"></a><a class="code" href="classQGrid.php#ab3fffb9ebdfa9eb20c62ad7857bda773">00057</a>   <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ad">QuadratureType</a> <a class="code" href="classQGrid.php#ab3fffb9ebdfa9eb20c62ad7857bda773">type</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ada0205c4820461f2f6e60de9d5a3894050">QGRID</a>; }
<a name="l00058"></a>00058 
<a name="l00059"></a>00059  
<a name="l00060"></a>00060  <span class="keyword">private</span>:
<a name="l00061"></a>00061 
<a name="l00062"></a>00062   <span class="keywordtype">void</span> <a class="code" href="classQGrid.php#a620af0cd55befb9145af7c3afe537603">init_1D</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> _type=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>,
<a name="l00063"></a>00063                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p_level=0);
<a name="l00064"></a>00064   <span class="keywordtype">void</span> <a class="code" href="classQGrid.php#a21cacbddfd4122919027b716b6c493e7">init_2D</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> _type=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>,
<a name="l00065"></a>00065                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p_level=0);
<a name="l00066"></a>00066   <span class="keywordtype">void</span> <a class="code" href="classQGrid.php#aa03af9c482b4bd53675cc55c2e103e0d">init_3D</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> _type=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>,
<a name="l00067"></a>00067                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p_level=0);
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 };
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00074"></a>00074 <span class="comment">// QGauss class members</span>
<a name="l00075"></a>00075 <span class="keyword">inline</span>
<a name="l00076"></a><a class="code" href="classQGrid.php#a630cadd40dac5d8b93c9c7694b6c2234">00076</a> <a class="code" href="classQGrid.php#a630cadd40dac5d8b93c9c7694b6c2234">QGrid::QGrid</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d,
<a name="l00077"></a>00077              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o) : <a class="code" href="classQBase.php">QBase</a>(d,o)
<a name="l00078"></a>00078 {
<a name="l00079"></a>00079 }
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 <span class="keyword">inline</span>
<a name="l00085"></a><a class="code" href="classQGrid.php#a3957562e1191817184e45f645d4a9886">00085</a> <a class="code" href="classQGrid.php#a3957562e1191817184e45f645d4a9886">QGrid::~QGrid</a>()
<a name="l00086"></a>00086 {
<a name="l00087"></a>00087 }
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
