<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_7bd01b27aea5d59f5c4653fb1c436874.php">quadrature</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>quadrature_grid_3D.C</h1>  </div>
</div>
<div class="contents">
<a href="quadrature__grid__3D_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: quadrature_grid_3D.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;quadrature_grid.h&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a><a class="code" href="classQGrid.php#aa03af9c482b4bd53675cc55c2e103e0d">00026</a> <span class="keywordtype">void</span> <a class="code" href="classQGrid.php#aa03af9c482b4bd53675cc55c2e103e0d">QGrid::init_3D</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> _type,
<a name="l00027"></a>00027                     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)
<a name="l00028"></a>00028 {
<a name="l00029"></a>00029 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>  
<a name="l00031"></a>00031   <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00032"></a>00032   <span class="comment">// 3D quadrature rules</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034   <span class="comment">// We ignore p - the grid rule is just for experimentation</span>
<a name="l00035"></a>00035   <span class="keywordflow">switch</span> (_type)
<a name="l00036"></a>00036     {
<a name="l00037"></a>00037       <span class="comment">//---------------------------------------------</span>
<a name="l00038"></a>00038       <span class="comment">// Hex quadrature rules</span>
<a name="l00039"></a>00039     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00040"></a>00040     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00041"></a>00041     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00042"></a>00042       {
<a name="l00043"></a>00043         <span class="comment">// We compute the 3D quadrature rule as a tensor</span>
<a name="l00044"></a>00044         <span class="comment">// product of the 1D quadrature rule.</span>
<a name="l00045"></a>00045         <a class="code" href="classQGrid.php">QGrid</a> q1D(1,_order);
<a name="l00046"></a>00046         q1D.<a class="code" href="classQBase.php#a1a0f71b05c7af21a8dd5577474b25818">init</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>);
<a name="l00047"></a>00047 
<a name="l00048"></a>00048         tensor_product_hex( q1D );
<a name="l00049"></a>00049         
<a name="l00050"></a>00050         <span class="keywordflow">return</span>;
<a name="l00051"></a>00051       }
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054       
<a name="l00055"></a>00055       <span class="comment">//---------------------------------------------</span>
<a name="l00056"></a>00056       <span class="comment">// Tetrahedral quadrature rules</span>
<a name="l00057"></a>00057     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l00058"></a>00058     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l00059"></a>00059       {
<a name="l00060"></a>00060         <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>.resize((_order+1)*(_order+2)*(_order+3)/6);
<a name="l00061"></a>00061         <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>.resize((_order+1)*(_order+2)*(_order+3)/6);
<a name="l00062"></a>00062 
<a name="l00063"></a>00063         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pt = 0;
<a name="l00064"></a>00064         <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i != _order + 1; ++i)
<a name="l00065"></a>00065           {
<a name="l00066"></a>00066             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j = 0; j != _order + 1 - i; ++j)
<a name="l00067"></a>00067               {
<a name="l00068"></a>00068                 <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k = 0; k != _order + 1 - i - j; ++k)
<a name="l00069"></a>00069                   {
<a name="l00070"></a>00070                     <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[pt](0) = (<span class="keywordtype">double</span>)i / (double)_order;
<a name="l00071"></a>00071                     <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[pt](1) = (<span class="keywordtype">double</span>)j / (double)_order;
<a name="l00072"></a>00072                     <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[pt](2) = (<span class="keywordtype">double</span>)k / (double)_order;
<a name="l00073"></a>00073                     <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>[pt] = 1.0 / (double)(_order+1) /
<a name="l00074"></a>00074                       (double)(_order+2) / (double)(_order+3);
<a name="l00075"></a>00075                     pt++;
<a name="l00076"></a>00076                   }
<a name="l00077"></a>00077               }
<a name="l00078"></a>00078           }
<a name="l00079"></a>00079         <span class="keywordflow">return</span>;
<a name="l00080"></a>00080       }
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a>00083       <span class="comment">// Prism quadrature rules</span>
<a name="l00084"></a>00084     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l00085"></a>00085     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l00086"></a>00086     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l00087"></a>00087       {
<a name="l00088"></a>00088         <span class="comment">// We compute the 3D quadrature rule as a tensor</span>
<a name="l00089"></a>00089         <span class="comment">// product of the 1D quadrature rule and a 2D</span>
<a name="l00090"></a>00090         <span class="comment">// triangle quadrature rule</span>
<a name="l00091"></a>00091             
<a name="l00092"></a>00092         <a class="code" href="classQGrid.php">QGrid</a> q1D(1,_order);
<a name="l00093"></a>00093         <a class="code" href="classQGrid.php">QGrid</a> q2D(2,_order);
<a name="l00094"></a>00094 
<a name="l00095"></a>00095         <span class="comment">// Initialize </span>
<a name="l00096"></a>00096         q1D.<a class="code" href="classQBase.php#a1a0f71b05c7af21a8dd5577474b25818">init</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>);
<a name="l00097"></a>00097         q2D.<a class="code" href="classQBase.php#a1a0f71b05c7af21a8dd5577474b25818">init</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>);
<a name="l00098"></a>00098 
<a name="l00099"></a>00099         tensor_product_prism(q1D, q2D);
<a name="l00100"></a>00100         
<a name="l00101"></a>00101         <span class="keywordflow">return</span>;
<a name="l00102"></a>00102       }
<a name="l00103"></a>00103       
<a name="l00104"></a>00104 
<a name="l00105"></a>00105       
<a name="l00106"></a>00106       <span class="comment">//---------------------------------------------</span>
<a name="l00107"></a>00107       <span class="comment">// Pyramid</span>
<a name="l00108"></a>00108     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l00109"></a>00109       {
<a name="l00110"></a>00110         <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>.resize((_order+1)*(_order+2)*(_order+3)/6);
<a name="l00111"></a>00111         <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>.resize((_order+1)*(_order+2)*(_order+3)/6);
<a name="l00112"></a>00112 
<a name="l00113"></a>00113         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pt = 0;
<a name="l00114"></a>00114         <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k = 0; k != _order + 1; ++k)
<a name="l00115"></a>00115           {
<a name="l00116"></a>00116             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i != _order + 1 - k; ++i)
<a name="l00117"></a>00117               {
<a name="l00118"></a>00118                 <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j = 0; j != _order + 1 - k; ++j)
<a name="l00119"></a>00119                   {
<a name="l00120"></a>00120                     <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[pt](0) = 2.0 * (<span class="keywordtype">double</span>)i / (double)_order
<a name="l00121"></a>00121                       - 1.0 + (<span class="keywordtype">double</span>)k / (double)_order;
<a name="l00122"></a>00122                     <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[pt](1) = 2.0 * (<span class="keywordtype">double</span>)j / (double)_order
<a name="l00123"></a>00123                       - 1.0 + (<span class="keywordtype">double</span>)k / (double)_order;
<a name="l00124"></a>00124                     <a class="code" href="classQBase.php#a99b92460225c9795d123f892d79ba1f5">_points</a>[pt](2) = (<span class="keywordtype">double</span>)k / (double)_order;
<a name="l00125"></a>00125                     <a class="code" href="classQBase.php#a5593d917f89534aeb2b3d6d5d51cdc5a">_weights</a>[pt] = 1.0 / (double)(_order+1) /
<a name="l00126"></a>00126                       (double)(_order+2) / (double)(_order+3);
<a name="l00127"></a>00127                     pt++;
<a name="l00128"></a>00128                   }
<a name="l00129"></a>00129               }
<a name="l00130"></a>00130           }
<a name="l00131"></a>00131         <span class="keywordflow">return</span>;
<a name="l00132"></a>00132       }
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00135"></a>00135       
<a name="l00136"></a>00136       <span class="comment">//---------------------------------------------</span>
<a name="l00137"></a>00137       <span class="comment">// Unsupported type</span>
<a name="l00138"></a>00138     <span class="keywordflow">default</span>:
<a name="l00139"></a>00139       {
<a name="l00140"></a>00140         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported type: &quot;</span> &lt;&lt; _type &lt;&lt; std::endl;
<a name="l00141"></a>00141         libmesh_error();
<a name="l00142"></a>00142       }
<a name="l00143"></a>00143     }
<a name="l00144"></a>00144 
<a name="l00145"></a>00145   libmesh_error();
<a name="l00146"></a>00146 
<a name="l00147"></a>00147   <span class="keywordflow">return</span>;
<a name="l00148"></a>00148   
<a name="l00149"></a>00149 <span class="preprocessor">#endif</span>
<a name="l00150"></a>00150 <span class="preprocessor"></span>}
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
