<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_eda61118c38b159444c3f5303da3dc86.php">quadrature</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>quadrature_jacobi.h</h1>  </div>
</div>
<div class="contents">
<a href="quadrature__jacobi_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: quadrature_jacobi.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __quadrature_jacobi_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __quadrature_jacobi_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="quadrature_8h.php">quadrature.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00032"></a>00032 <span class="comment">// QJacobi class definition</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00051"></a><a class="code" href="classQJacobi.php">00051</a> <span class="keyword">class </span><a class="code" href="classQJacobi.php">QJacobi</a> : <span class="keyword">public</span> <a class="code" href="classQBase.php">QBase</a>
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053  <span class="keyword">public</span>:
<a name="l00054"></a>00054 
<a name="l00060"></a>00060   <a class="code" href="classQJacobi.php#a4c00a12666381abce20ca097d8b46d12">QJacobi</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _dim,
<a name="l00061"></a>00061            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> _order=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa2c3571d1803f3f264b0b2c653f0a6a04">INVALID_ORDER</a>,
<a name="l00062"></a>00062            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQJacobi.php#acdaf475e4ab30d561a61af1d9a5f93f9">_alpha</a>=1,
<a name="l00063"></a>00063            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQJacobi.php#a046d58726b59140732f6eb6cf495e23b">_beta</a>=0);
<a name="l00064"></a>00064 
<a name="l00068"></a><a class="code" href="classQJacobi.php#a269efce63eed3e1f8a6c8deceb289e0a">00068</a>   <a class="code" href="classQJacobi.php#a269efce63eed3e1f8a6c8deceb289e0a">~QJacobi</a>() {}
<a name="l00069"></a>00069 
<a name="l00074"></a>00074   <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ad">QuadratureType</a> <a class="code" href="classQJacobi.php#aeae34004f007d18c98168c1952543fa0">type</a>() <span class="keyword">const</span>;
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
<a name="l00077"></a>00077  <span class="keyword">private</span>:
<a name="l00078"></a><a class="code" href="classQJacobi.php#acdaf475e4ab30d561a61af1d9a5f93f9">00078</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQJacobi.php#acdaf475e4ab30d561a61af1d9a5f93f9">_alpha</a>;
<a name="l00079"></a><a class="code" href="classQJacobi.php#a046d58726b59140732f6eb6cf495e23b">00079</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classQJacobi.php#a046d58726b59140732f6eb6cf495e23b">_beta</a>;
<a name="l00080"></a>00080   
<a name="l00081"></a>00081   <span class="keywordtype">void</span> <a class="code" href="classQJacobi.php#a86f55aa530399c6fe0ecfb5d7fe96bf9">init_1D</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> _type=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>,
<a name="l00082"></a>00082                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p_level=0);
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 };
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00090"></a>00090 <span class="comment">// QJacobi class members</span>
<a name="l00091"></a>00091 <span class="keyword">inline</span>
<a name="l00092"></a><a class="code" href="classQJacobi.php#a4c00a12666381abce20ca097d8b46d12">00092</a> <a class="code" href="classQJacobi.php#a4c00a12666381abce20ca097d8b46d12">QJacobi::QJacobi</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d,
<a name="l00093"></a>00093                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00094"></a>00094                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> a,
<a name="l00095"></a>00095                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> b) : <a class="code" href="classQBase.php">QBase</a>(d,o), _alpha(a), _beta(b)
<a name="l00096"></a>00096 {
<a name="l00097"></a>00097   <span class="comment">// explicitly call the init function in 1D since the</span>
<a name="l00098"></a>00098   <span class="comment">// other tensor-product rules require this one.</span>
<a name="l00099"></a>00099   <span class="comment">// note that EDGE will not be used internally, however</span>
<a name="l00100"></a>00100   <span class="comment">// if we called the function with INVALID_ELEM it would try to</span>
<a name="l00101"></a>00101   <span class="comment">// be smart and return, thinking it had already done the work.</span>
<a name="l00102"></a>00102   <span class="keywordflow">if</span> (_dim == 1)
<a name="l00103"></a>00103     <a class="code" href="classQBase.php#a1a0f71b05c7af21a8dd5577474b25818">init</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>);
<a name="l00104"></a>00104 }
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 <span class="keyword">inline</span>
<a name="l00109"></a><a class="code" href="classQJacobi.php#aeae34004f007d18c98168c1952543fa0">00109</a> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ad">QuadratureType</a> <a class="code" href="classQJacobi.php#aeae34004f007d18c98168c1952543fa0">QJacobi::type</a>()<span class="keyword"> const</span>
<a name="l00110"></a>00110 <span class="keyword"></span>{
<a name="l00111"></a>00111   <span class="keywordflow">if</span> ((<a class="code" href="classQJacobi.php#acdaf475e4ab30d561a61af1d9a5f93f9">_alpha</a> == 1) &amp;&amp; (<a class="code" href="classQJacobi.php#a046d58726b59140732f6eb6cf495e23b">_beta</a> == 0))
<a name="l00112"></a>00112     <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716adad3a339e15685559999115b81f6d38370">QJACOBI_1_0</a>;
<a name="l00113"></a>00113 
<a name="l00114"></a>00114   <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((<a class="code" href="classQJacobi.php#acdaf475e4ab30d561a61af1d9a5f93f9">_alpha</a> == 2) &amp;&amp; (<a class="code" href="classQJacobi.php#a046d58726b59140732f6eb6cf495e23b">_beta</a> == 0))
<a name="l00115"></a>00115     <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ada52629eed7dec8b36fbd387b3dd51d48d">QJACOBI_2_0</a>;
<a name="l00116"></a>00116 
<a name="l00117"></a>00117   <span class="keywordflow">else</span>
<a name="l00118"></a>00118     { 
<a name="l00119"></a>00119       libmesh_error();
<a name="l00120"></a>00120       <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ada5b62f4e4a76d956412ab1b6e3c464fff">INVALID_Q_RULE</a>;
<a name="l00121"></a>00121     }
<a name="l00122"></a>00122 }
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
