<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_eda61118c38b159444c3f5303da3dc86.php">quadrature</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>quadrature_monomial.h</h1>  </div>
</div>
<div class="contents">
<a href="quadrature__monomial_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: quadrature_monomial.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __quadrature_monomial_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __quadrature_monomial_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="quadrature_8h.php">quadrature.h</a>&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00062"></a><a class="code" href="classQMonomial.php">00062</a> <span class="keyword">class </span><a class="code" href="classQMonomial.php">QMonomial</a> : <span class="keyword">public</span> <a class="code" href="classQBase.php">QBase</a>
<a name="l00063"></a>00063 {
<a name="l00064"></a>00064  <span class="keyword">public</span>:
<a name="l00065"></a>00065 
<a name="l00069"></a>00069   <a class="code" href="classQMonomial.php#aabe73c7460c506d772993de2d788a105">QMonomial</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _dim,
<a name="l00070"></a>00070              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> _order=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa2c3571d1803f3f264b0b2c653f0a6a04">INVALID_ORDER</a>);
<a name="l00071"></a>00071 
<a name="l00075"></a>00075   <a class="code" href="classQMonomial.php#a5752b9b0fd7d3f51de0926ad423814a3">~QMonomial</a>();
<a name="l00076"></a>00076 
<a name="l00080"></a><a class="code" href="classQMonomial.php#ac25f664567c5bc058f7276456c715e0e">00080</a>   <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ad">QuadratureType</a> <a class="code" href="classQMonomial.php#ac25f664567c5bc058f7276456c715e0e">type</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716adad253e92d04395f506aa249f2b42e1ff5">QMONOMIAL</a>; }
<a name="l00081"></a>00081 
<a name="l00082"></a>00082  
<a name="l00083"></a>00083  <span class="keyword">private</span>:
<a name="l00084"></a>00084 
<a name="l00085"></a><a class="code" href="classQMonomial.php#a82adcccd402e839537d7dbc0a606b008">00085</a>   <span class="keywordtype">void</span> <a class="code" href="classQMonomial.php#a82adcccd402e839537d7dbc0a606b008">init_1D</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00086"></a>00086                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> =0)
<a name="l00087"></a>00087   {
<a name="l00088"></a>00088     <span class="comment">// See about making this non-pure virtual in the base class?</span>
<a name="l00089"></a>00089     libmesh_error();
<a name="l00090"></a>00090   }
<a name="l00091"></a>00091 
<a name="l00095"></a>00095   <span class="keywordtype">void</span> <a class="code" href="classQMonomial.php#a64c34e51d1f61078ae240155a87243b6">init_2D</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> _type=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>,
<a name="l00096"></a>00096                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p_level=0);
<a name="l00097"></a>00097   
<a name="l00101"></a>00101   <span class="keywordtype">void</span> <a class="code" href="classQMonomial.php#ae5ee51cc4a81de9b2d940e9c2a9b56f8">init_3D</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> _type=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>,
<a name="l00102"></a>00102                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p_level=0);
<a name="l00103"></a>00103 
<a name="l00104"></a>00104      
<a name="l00105"></a>00105   
<a name="l00118"></a>00118   <span class="keywordtype">void</span> <a class="code" href="classQMonomial.php#acd398af3906498ad92d5cd38950ef6b0">wissmann_rule</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> rule_data[][3],
<a name="l00119"></a>00119                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_pts);
<a name="l00120"></a>00120 
<a name="l00141"></a>00141   <span class="keywordtype">void</span> <a class="code" href="classQMonomial.php#acb11b4b58a0f8342c9684ac7c286312a">stroud_rule</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> rule_data[][3],
<a name="l00142"></a>00142                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>* rule_symmetry,
<a name="l00143"></a>00143                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_pts);
<a name="l00144"></a>00144 
<a name="l00182"></a>00182   <span class="keywordtype">void</span> <a class="code" href="classQMonomial.php#ae9a7220699124f5d08a3e51d6f257a26">kim_rule</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> rule_data[][4],
<a name="l00183"></a>00183                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>* rule_id,
<a name="l00184"></a>00184                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_pts);
<a name="l00185"></a>00185 };
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
