<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_7fe868bab29692ef098291edf1b17671.php">base</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>reference_counter.C</h1>  </div>
</div>
<div class="contents">
<a href="reference__counter_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: reference_counter.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;iostream&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;sstream&gt;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;reference_counter.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00032"></a>00032 <span class="comment">// ReferenceCounter class static member initializations</span>
<a name="l00033"></a>00033 <span class="preprocessor">#if defined(LIBMESH_ENABLE_REFERENCE_COUNTING) &amp;&amp; defined(DEBUG)</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span>
<a name="l00035"></a>00035 <a class="code" href="classReferenceCounter.php#a305980f109c40d6ac58d6e2378c20028">ReferenceCounter::Counts</a> <a class="code" href="classReferenceCounter.php#a5d0f24455f088f414f8faadbfe186681">ReferenceCounter::_counts</a>;
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="preprocessor">#endif</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span>
<a name="l00039"></a>00039 <a class="code" href="classThreads_1_1atomic.php">Threads::atomic&lt;unsigned int&gt;</a> <a class="code" href="classReferenceCounter.php#aba9ef3e2e3b24c5cea394b185df0135f">ReferenceCounter::_n_objects</a>;
<a name="l00040"></a>00040 <a class="code" href="classThreads_1_1spin__mutex.php">Threads::spin_mutex</a>  <a class="code" href="classReferenceCounter.php#aa1acbef21cf0d60e5b96c5018f4233f1">ReferenceCounter::_mutex</a>;
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00044"></a>00044 <span class="comment">// ReferenceCounter class members</span>
<a name="l00045"></a><a class="code" href="classReferenceCounter.php#a20339453b2f8ddc2991d141fb9122b76">00045</a> std::string <a class="code" href="classReferenceCounter.php#a20339453b2f8ddc2991d141fb9122b76">ReferenceCounter::get_info</a> ()
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047 <span class="preprocessor">#if defined(LIBMESH_ENABLE_REFERENCE_COUNTING) &amp;&amp; defined(DEBUG)</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span>
<a name="l00049"></a>00049   std::ostringstream out;
<a name="l00050"></a>00050   
<a name="l00051"></a>00051   out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00052"></a>00052       &lt;&lt; <span class="stringliteral">&quot; ---------------------------------------------------------------------------- \n&quot;</span>
<a name="l00053"></a>00053       &lt;&lt; <span class="stringliteral">&quot;| Reference count information                                                |\n&quot;</span>
<a name="l00054"></a>00054       &lt;&lt; <span class="stringliteral">&quot; ---------------------------------------------------------------------------- \n&quot;</span>;
<a name="l00055"></a>00055   
<a name="l00056"></a>00056   <span class="keywordflow">for</span> (Counts::iterator it = <a class="code" href="classReferenceCounter.php#a5d0f24455f088f414f8faadbfe186681">_counts</a>.begin();
<a name="l00057"></a>00057        it != <a class="code" href="classReferenceCounter.php#a5d0f24455f088f414f8faadbfe186681">_counts</a>.end(); ++it)
<a name="l00058"></a>00058     {
<a name="l00059"></a>00059       <span class="keyword">const</span> std::string <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>(it-&gt;first);
<a name="l00060"></a>00060       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> creations    = it-&gt;second.first;
<a name="l00061"></a>00061       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> destructions = it-&gt;second.second;
<a name="l00062"></a>00062 
<a name="l00063"></a>00063       out &lt;&lt; <span class="stringliteral">&quot;| &quot;</span> &lt;&lt; name &lt;&lt; <span class="stringliteral">&quot; reference count information:\n&quot;</span>
<a name="l00064"></a>00064           &lt;&lt; <span class="stringliteral">&quot;|  Creations:    &quot;</span> &lt;&lt; creations    &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00065"></a>00065           &lt;&lt; <span class="stringliteral">&quot;|  Destructions: &quot;</span> &lt;&lt; destructions &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00066"></a>00066     }
<a name="l00067"></a>00067   
<a name="l00068"></a>00068   out &lt;&lt; <span class="stringliteral">&quot; ---------------------------------------------------------------------------- \n&quot;</span>;
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="keywordflow">return</span> out.str();
<a name="l00071"></a>00071 
<a name="l00072"></a>00072 <span class="preprocessor">#else</span>
<a name="l00073"></a>00073 <span class="preprocessor"></span>
<a name="l00074"></a>00074   <span class="keywordflow">return</span> <span class="stringliteral">&quot;&quot;</span>;
<a name="l00075"></a>00075   
<a name="l00076"></a>00076 <span class="preprocessor">#endif</span>
<a name="l00077"></a>00077 <span class="preprocessor"></span>}
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a><a class="code" href="classReferenceCounter.php#a96bf10fbce55bcc34c3ab0e469238ee1">00083</a> <span class="keywordtype">void</span> <a class="code" href="classReferenceCounter.php#a96bf10fbce55bcc34c3ab0e469238ee1">ReferenceCounter::print_info</a> ()
<a name="l00084"></a>00084 {
<a name="l00085"></a>00085 <span class="preprocessor">#if defined(LIBMESH_ENABLE_REFERENCE_COUNTING) &amp;&amp; defined(DEBUG)</span>
<a name="l00086"></a>00086 <span class="preprocessor"></span>  
<a name="l00087"></a>00087   std::cout &lt;&lt; <a class="code" href="classReferenceCounter.php#a20339453b2f8ddc2991d141fb9122b76">ReferenceCounter::get_info</a>();
<a name="l00088"></a>00088   
<a name="l00089"></a>00089 <span class="preprocessor">#endif</span>
<a name="l00090"></a>00090 <span class="preprocessor"></span>}
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
