<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_a444518d96d2df902338d2a7eb3a040c.php">base</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>reference_counter.h</h1>  </div>
</div>
<div class="contents">
<a href="reference__counter_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001  <span class="comment">// $Id: reference_counter.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __reference_counter_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __reference_counter_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;threads.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// C++ includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00042"></a>00042 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00043"></a>00043 <span class="comment">// ReferenceCounter class definition</span>
<a name="l00044"></a><a class="code" href="classReferenceCounter.php">00044</a> <span class="keyword">class </span><a class="code" href="classReferenceCounter.php">ReferenceCounter</a>
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046 <span class="keyword">protected</span>:
<a name="l00047"></a>00047 
<a name="l00053"></a>00053   <a class="code" href="classReferenceCounter.php#a6389ca70c8a41c4d2f1a4e72d42e9780">ReferenceCounter</a> ();
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 <span class="keyword">public</span>:
<a name="l00056"></a>00056   
<a name="l00060"></a>00060   <span class="keyword">virtual</span> <a class="code" href="classReferenceCounter.php#aaaed1963de9be1f8a3218ea57adffcb7">~ReferenceCounter</a> ();
<a name="l00061"></a>00061 
<a name="l00065"></a>00065   <span class="keyword">static</span> std::string <a class="code" href="classReferenceCounter.php#a20339453b2f8ddc2991d141fb9122b76">get_info</a> ();
<a name="l00066"></a>00066   
<a name="l00070"></a>00070   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classReferenceCounter.php#a96bf10fbce55bcc34c3ab0e469238ee1">print_info</a> ();
<a name="l00071"></a>00071 
<a name="l00076"></a><a class="code" href="classReferenceCounter.php#a8cb7e9757c4c1ef049bdf1e11ca65177">00076</a>   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classReferenceCounter.php#a8cb7e9757c4c1ef049bdf1e11ca65177">n_objects</a> ()
<a name="l00077"></a>00077   { <span class="keywordflow">return</span> <a class="code" href="classReferenceCounter.php#aba9ef3e2e3b24c5cea394b185df0135f">_n_objects</a>; }
<a name="l00078"></a>00078 
<a name="l00079"></a>00079   
<a name="l00080"></a>00080 <span class="keyword">protected</span>:
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   
<a name="l00088"></a>00088   <span class="keywordtype">void</span> <a class="code" href="classReferenceCounter.php#a9a9c62e0d9c6738995dc3acafe795d0e">increment_constructor_count</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>);
<a name="l00089"></a>00089   
<a name="l00095"></a>00095   <span class="keywordtype">void</span> <a class="code" href="classReferenceCounter.php#a84339666391c278727332f5935751517">increment_destructor_count</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>);
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 <span class="preprocessor">#if defined(LIBMESH_ENABLE_REFERENCE_COUNTING) &amp;&amp; defined(DEBUG)</span>
<a name="l00099"></a>00099 <span class="preprocessor"></span>  
<a name="l00104"></a>00104   <span class="keyword">typedef</span> std::map&lt;std::string, std::pair&lt;<span class="keywordtype">unsigned</span> int,
<a name="l00105"></a><a class="code" href="classReferenceCounter.php#a305980f109c40d6ac58d6e2378c20028">00105</a>                                           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt; &gt; <a class="code" href="classReferenceCounter.php#a305980f109c40d6ac58d6e2378c20028">Counts</a>;
<a name="l00106"></a>00106 
<a name="l00110"></a><a class="code" href="classReferenceCounter.php#a5d0f24455f088f414f8faadbfe186681">00110</a>   <span class="keyword">static</span> <a class="code" href="classReferenceCounter.php#a305980f109c40d6ac58d6e2378c20028">Counts</a> <a class="code" href="classReferenceCounter.php#a5d0f24455f088f414f8faadbfe186681">_counts</a>;
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 <span class="preprocessor">#endif</span>
<a name="l00113"></a>00113 <span class="preprocessor"></span>  
<a name="l00118"></a><a class="code" href="classReferenceCounter.php#aba9ef3e2e3b24c5cea394b185df0135f">00118</a>   <span class="keyword">static</span> <a class="code" href="classThreads_1_1atomic.php">Threads::atomic&lt;unsigned int&gt;</a> <a class="code" href="classReferenceCounter.php#aba9ef3e2e3b24c5cea394b185df0135f">_n_objects</a>;
<a name="l00119"></a>00119 
<a name="l00123"></a><a class="code" href="classReferenceCounter.php#aa1acbef21cf0d60e5b96c5018f4233f1">00123</a>   <span class="keyword">static</span> <a class="code" href="classThreads_1_1spin__mutex.php">Threads::spin_mutex</a> <a class="code" href="classReferenceCounter.php#aa1acbef21cf0d60e5b96c5018f4233f1">_mutex</a>;
<a name="l00124"></a>00124 };
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00129"></a>00129 <span class="comment">// ReferenceCounter class inline methods</span>
<a name="l00130"></a><a class="code" href="classReferenceCounter.php#a6389ca70c8a41c4d2f1a4e72d42e9780">00130</a> <span class="keyword">inline</span> <a class="code" href="classReferenceCounter.php#a6389ca70c8a41c4d2f1a4e72d42e9780">ReferenceCounter::ReferenceCounter</a>()
<a name="l00131"></a>00131 {
<a name="l00132"></a>00132   <a class="code" href="classReferenceCounter.php#aba9ef3e2e3b24c5cea394b185df0135f">_n_objects</a>++;
<a name="l00133"></a>00133 }
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a><a class="code" href="classReferenceCounter.php#aaaed1963de9be1f8a3218ea57adffcb7">00137</a> <span class="keyword">inline</span> <a class="code" href="classReferenceCounter.php#aaaed1963de9be1f8a3218ea57adffcb7">ReferenceCounter::~ReferenceCounter</a>()
<a name="l00138"></a>00138 {
<a name="l00139"></a>00139   <a class="code" href="classReferenceCounter.php#aba9ef3e2e3b24c5cea394b185df0135f">_n_objects</a>--;
<a name="l00140"></a>00140 }
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 <span class="preprocessor">#if defined(LIBMESH_ENABLE_REFERENCE_COUNTING) &amp;&amp; defined(DEBUG)</span>
<a name="l00148"></a>00148 <span class="preprocessor"></span><span class="keyword">inline</span>
<a name="l00149"></a><a class="code" href="classReferenceCounter.php#a9a9c62e0d9c6738995dc3acafe795d0e">00149</a> <span class="keywordtype">void</span> <a class="code" href="classReferenceCounter.php#a9a9c62e0d9c6738995dc3acafe795d0e">ReferenceCounter::increment_constructor_count</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00150"></a>00150 {
<a name="l00151"></a>00151   Threads::spin_mutex::scoped_lock lock(<a class="code" href="namespaceThreads.php#aad3bf7e190fddf12301f3393213aa5a9">Threads::spin_mtx</a>);
<a name="l00152"></a>00152   std::pair&lt;unsigned int, unsigned int&gt;&amp; p = <a class="code" href="classReferenceCounter.php#a5d0f24455f088f414f8faadbfe186681">_counts</a>[<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>];
<a name="l00153"></a>00153 
<a name="l00154"></a>00154   p.first++;
<a name="l00155"></a>00155 }
<a name="l00156"></a>00156 <span class="preprocessor">#else</span>
<a name="l00157"></a>00157 <span class="preprocessor"></span><span class="keyword">inline</span>
<a name="l00158"></a>00158 <span class="keywordtype">void</span> <a class="code" href="classReferenceCounter.php#a9a9c62e0d9c6738995dc3acafe795d0e">ReferenceCounter::increment_constructor_count</a> (<span class="keyword">const</span> std::string&amp;)
<a name="l00159"></a>00159 {
<a name="l00160"></a>00160 }
<a name="l00161"></a>00161 <span class="preprocessor">#endif</span>
<a name="l00162"></a>00162 <span class="preprocessor"></span>
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 <span class="preprocessor">#if defined(LIBMESH_ENABLE_REFERENCE_COUNTING) &amp;&amp; defined(DEBUG)</span>
<a name="l00166"></a>00166 <span class="preprocessor"></span><span class="keyword">inline</span>
<a name="l00167"></a><a class="code" href="classReferenceCounter.php#a84339666391c278727332f5935751517">00167</a> <span class="keywordtype">void</span> <a class="code" href="classReferenceCounter.php#a84339666391c278727332f5935751517">ReferenceCounter::increment_destructor_count</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00168"></a>00168 {
<a name="l00169"></a>00169   Threads::spin_mutex::scoped_lock lock(<a class="code" href="namespaceThreads.php#aad3bf7e190fddf12301f3393213aa5a9">Threads::spin_mtx</a>);
<a name="l00170"></a>00170   std::pair&lt;unsigned int, unsigned int&gt;&amp; p = <a class="code" href="classReferenceCounter.php#a5d0f24455f088f414f8faadbfe186681">_counts</a>[<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>];
<a name="l00171"></a>00171 
<a name="l00172"></a>00172   p.second++;
<a name="l00173"></a>00173 }
<a name="l00174"></a>00174 <span class="preprocessor">#else</span>
<a name="l00175"></a>00175 <span class="preprocessor"></span><span class="keyword">inline</span>
<a name="l00176"></a>00176 <span class="keywordtype">void</span> <a class="code" href="classReferenceCounter.php#a84339666391c278727332f5935751517">ReferenceCounter::increment_destructor_count</a> (<span class="keyword">const</span> std::string&amp;)
<a name="l00177"></a>00177 {
<a name="l00178"></a>00178 }
<a name="l00179"></a>00179 <span class="preprocessor">#endif</span>
<a name="l00180"></a>00180 <span class="preprocessor"></span>
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 <span class="preprocessor">#endif // end #ifndef __reference_counter_h__</span>
<a name="l00184"></a>00184 <span class="preprocessor"></span>
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
