<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>remote_elem.h</h1>  </div>
</div>
<div class="contents">
<a href="remote__elem_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: remote_elem.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __remote_elem_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __remote_elem_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Forward declarations</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00042"></a>00042 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00043"></a>00043 <span class="comment">// RemoteElem class definition</span>
<a name="l00044"></a><a class="code" href="classRemoteElem.php">00044</a> <span class="keyword">class </span><a class="code" href="classRemoteElem.php">RemoteElem</a> : <span class="keyword">public</span> <a class="code" href="classElem.php">Elem</a>
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046  <span class="keyword">public</span>:
<a name="l00047"></a>00047 
<a name="l00051"></a><a class="code" href="classRemoteElem.php#a86ff5aa78fabf3abfc9545e2647733a2">00051</a>   <a class="code" href="classRemoteElem.php#a86ff5aa78fabf3abfc9545e2647733a2">RemoteElem</a> () : <a class="code" href="classElem.php">Elem</a>() {}
<a name="l00052"></a>00052 
<a name="l00056"></a><a class="code" href="classRemoteElem.php#a0903ac2ab120bbf7e44a275ba1828359">00056</a>   <span class="keyword">virtual</span> <a class="code" href="classRemoteElem.php#a0903ac2ab120bbf7e44a275ba1828359">~RemoteElem</a>() {}
<a name="l00057"></a>00057 
<a name="l00058"></a><a class="code" href="classRemoteElem.php#a6176b6973af8f5487092c624bd08b768">00058</a>   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> &amp; <a class="code" href="classRemoteElem.php#a6176b6973af8f5487092c624bd08b768">point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00059"></a>00059 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> <a class="code" href="classRemoteElem.php#a6176b6973af8f5487092c624bd08b768">Elem::point</a>(i); }
<a name="l00060"></a>00060 
<a name="l00061"></a><a class="code" href="classRemoteElem.php#a9fcdff3769599ce1e5352f9f866b0d64">00061</a>   <span class="keyword">virtual</span> <a class="code" href="classPoint.php">Point</a> &amp; <a class="code" href="classRemoteElem.php#a6176b6973af8f5487092c624bd08b768">point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00062"></a>00062   { libmesh_error(); <span class="keywordflow">return</span> <a class="code" href="classRemoteElem.php#a6176b6973af8f5487092c624bd08b768">Elem::point</a>(i); }
<a name="l00063"></a>00063 
<a name="l00064"></a><a class="code" href="classRemoteElem.php#a07f9b86e7aec92251f861055937700b3">00064</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classRemoteElem.php#a07f9b86e7aec92251f861055937700b3">node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00065"></a>00065 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> <a class="code" href="classRemoteElem.php#a07f9b86e7aec92251f861055937700b3">Elem::node</a>(i); }
<a name="l00066"></a>00066 
<a name="l00067"></a><a class="code" href="classRemoteElem.php#add70e8febad7abe32c8a112051cd11b5">00067</a>   <span class="keyword">virtual</span> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classRemoteElem.php#add70e8febad7abe32c8a112051cd11b5">get_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00068"></a>00068 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> <a class="code" href="classRemoteElem.php#add70e8febad7abe32c8a112051cd11b5">Elem::get_node</a>(i); }
<a name="l00069"></a>00069 
<a name="l00070"></a><a class="code" href="classRemoteElem.php#a972d7417b057e2ebfdc24bdeb1ca48f9">00070</a>   <span class="keyword">virtual</span> <a class="code" href="classNode.php">Node</a>* &amp; <a class="code" href="classRemoteElem.php#a972d7417b057e2ebfdc24bdeb1ca48f9">set_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00071"></a>00071   { libmesh_error(); <span class="keywordflow">return</span> <a class="code" href="classRemoteElem.php#a972d7417b057e2ebfdc24bdeb1ca48f9">Elem::set_node</a>(i); }
<a name="l00072"></a>00072   
<a name="l00073"></a><a class="code" href="classRemoteElem.php#a6605ec7753d915b832d9ac90b0dbfbd1">00073</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classRemoteElem.php#a6605ec7753d915b832d9ac90b0dbfbd1">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00074"></a>00074 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> 0; }
<a name="l00075"></a>00075 
<a name="l00076"></a><a class="code" href="classRemoteElem.php#a5458a74ecf6fc7e52d11a41f21987b80">00076</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classRemoteElem.php#a5458a74ecf6fc7e52d11a41f21987b80">is_remote</a> ()<span class="keyword"> const</span>
<a name="l00077"></a>00077 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00078"></a>00078   
<a name="l00079"></a><a class="code" href="classRemoteElem.php#ace520631a58726eff8d933fdc2f91ccb">00079</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classRemoteElem.php#ace520631a58726eff8d933fdc2f91ccb">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00080"></a>00080                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a>,
<a name="l00081"></a>00081                             std::vector&lt;unsigned int&gt;&amp;)<span class="keyword"> const</span>
<a name="l00082"></a>00082 <span class="keyword">  </span>{ libmesh_error(); }
<a name="l00083"></a>00083 
<a name="l00084"></a><a class="code" href="classRemoteElem.php#ab899e6b9a87207c1dc4e3ae34a2049a3">00084</a>   <span class="keyword">virtual</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classRemoteElem.php#ab899e6b9a87207c1dc4e3ae34a2049a3">type</a> ()<span class="keyword"> const</span>
<a name="l00085"></a>00085 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a2815a19a1f13bcbc4852882544d17983">REMOTEELEM</a>; }
<a name="l00086"></a>00086   
<a name="l00087"></a><a class="code" href="classRemoteElem.php#a7f005bdfbb9352af8baace320c5b513b">00087</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classRemoteElem.php#a7f005bdfbb9352af8baace320c5b513b">dim</a> ()<span class="keyword"> const</span>
<a name="l00088"></a>00088 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> 0; }
<a name="l00089"></a>00089   
<a name="l00090"></a><a class="code" href="classRemoteElem.php#a484478383b1b359bf76a992443977052">00090</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classRemoteElem.php#a484478383b1b359bf76a992443977052">n_nodes</a> ()<span class="keyword"> const</span>
<a name="l00091"></a>00091 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> 0; }
<a name="l00092"></a>00092 
<a name="l00093"></a><a class="code" href="classRemoteElem.php#a60f0189e949146630a4e22a523188227">00093</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classRemoteElem.php#a60f0189e949146630a4e22a523188227">n_sides</a> ()<span class="keyword"> const </span>
<a name="l00094"></a>00094 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> 0; }
<a name="l00095"></a>00095 
<a name="l00096"></a><a class="code" href="classRemoteElem.php#aed170a14c9350e4258e9ef928f538af9">00096</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classRemoteElem.php#aed170a14c9350e4258e9ef928f538af9">n_vertices</a> ()<span class="keyword"> const</span>
<a name="l00097"></a>00097 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> 0; }
<a name="l00098"></a>00098 
<a name="l00099"></a><a class="code" href="classRemoteElem.php#a7320d6a2701fa9f87a5ca292cac95459">00099</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classRemoteElem.php#a7320d6a2701fa9f87a5ca292cac95459">n_edges</a> ()<span class="keyword"> const</span>
<a name="l00100"></a>00100 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> 0; }
<a name="l00101"></a>00101 
<a name="l00102"></a><a class="code" href="classRemoteElem.php#a323483d7da6dd95047ebf7ad540380a4">00102</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classRemoteElem.php#a323483d7da6dd95047ebf7ad540380a4">n_faces</a> ()<span class="keyword"> const</span>
<a name="l00103"></a>00103 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> 0; }
<a name="l00104"></a>00104   
<a name="l00105"></a><a class="code" href="classRemoteElem.php#a373c4b8d3846bf9a68f9b204b30da5b4">00105</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classRemoteElem.php#a373c4b8d3846bf9a68f9b204b30da5b4">n_children</a> ()<span class="keyword"> const</span>
<a name="l00106"></a>00106 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> 0; }
<a name="l00107"></a>00107 
<a name="l00108"></a><a class="code" href="classRemoteElem.php#ad8761619a1ede1e634d95bea40e29bd5">00108</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classRemoteElem.php#ad8761619a1ede1e634d95bea40e29bd5">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00109"></a>00109 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00110"></a>00110 
<a name="l00111"></a><a class="code" href="classRemoteElem.php#aff464c91d83dc55363a7a966bf1996f4">00111</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classRemoteElem.php#aff464c91d83dc55363a7a966bf1996f4">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00112"></a>00112 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00113"></a>00113 
<a name="l00114"></a><a class="code" href="classRemoteElem.php#a6f10cf2642f74f9ba2960c8c4e067971">00114</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classRemoteElem.php#a6f10cf2642f74f9ba2960c8c4e067971">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00115"></a>00115 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00116"></a>00116   
<a name="l00117"></a><a class="code" href="classRemoteElem.php#a5a0e348ae4369370b3e100fa518ede77">00117</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classRemoteElem.php#a5a0e348ae4369370b3e100fa518ede77">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00118"></a>00118                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00119"></a>00119 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00120"></a>00120   
<a name="l00121"></a><a class="code" href="classRemoteElem.php#af2a07fab96a04ae916e4f3a4aec7cbe5">00121</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classRemoteElem.php#af2a07fab96a04ae916e4f3a4aec7cbe5">is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00122"></a>00122                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00123"></a>00123 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00124"></a>00124   
<a name="l00125"></a><a class="code" href="classRemoteElem.php#a541b2abb83b43b7cb76fe6bbccdf7f6f">00125</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classRemoteElem.php#a541b2abb83b43b7cb76fe6bbccdf7f6f">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00126"></a>00126                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00127"></a>00127 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00128"></a>00128 
<a name="l00129"></a><a class="code" href="classRemoteElem.php#ad26faa5fb0c3543e66976cd52a5378a5">00129</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classRemoteElem.php#ad26faa5fb0c3543e66976cd52a5378a5">n_sub_elem</a> ()<span class="keyword"> const</span>
<a name="l00130"></a>00130 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> 0; }
<a name="l00131"></a>00131 
<a name="l00132"></a><a class="code" href="classRemoteElem.php#ae9b5fada50d538988b6c87bf10d6f9b2">00132</a>   <span class="keyword">virtual</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> <a class="code" href="classRemoteElem.php#ae9b5fada50d538988b6c87bf10d6f9b2">side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00133"></a>00133 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a>(NULL); }
<a name="l00134"></a>00134   
<a name="l00135"></a><a class="code" href="classRemoteElem.php#a1f12459bcbebaa3fa0232a782f5810e1">00135</a>   <span class="keyword">virtual</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classRemoteElem.php#a1f12459bcbebaa3fa0232a782f5810e1">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00136"></a>00136                                     <span class="keywordtype">bool</span>)<span class="keyword"> const</span>
<a name="l00137"></a>00137 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a>(NULL); }
<a name="l00138"></a>00138 
<a name="l00139"></a><a class="code" href="classRemoteElem.php#a6c4a229b625911d8020b492c826fd900">00139</a>   <span class="keyword">virtual</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classRemoteElem.php#a6c4a229b625911d8020b492c826fd900">build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00140"></a>00140 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a>(NULL); }
<a name="l00141"></a>00141 
<a name="l00142"></a><a class="code" href="classRemoteElem.php#adcef023896eaebf07114e51e13072f67">00142</a>   <span class="keyword">virtual</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classRemoteElem.php#adcef023896eaebf07114e51e13072f67">default_order</a> ()<span class="keyword"> const</span>
<a name="l00143"></a>00143 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>; }
<a name="l00144"></a>00144   
<a name="l00145"></a>00145 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00146"></a>00146 <span class="preprocessor"></span>
<a name="l00147"></a><a class="code" href="classRemoteElem.php#a0f2ce2cd590dab5eb362e090526d26a4">00147</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classRemoteElem.php#a0f2ce2cd590dab5eb362e090526d26a4">infinite</a> ()<span class="keyword"> const</span>
<a name="l00148"></a>00148 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 <span class="preprocessor">#endif</span>
<a name="l00151"></a>00151 <span class="preprocessor"></span>
<a name="l00152"></a>00152 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00153"></a>00153 <span class="preprocessor"></span>  
<a name="l00158"></a><a class="code" href="classRemoteElem.php#aaa284fc16b78fad2c524e90ead7cdcca">00158</a>   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="classRemoteElem.php#aaa284fc16b78fad2c524e90ead7cdcca">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00159"></a>00159                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00160"></a>00160                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00161"></a>00161 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> 0.; }
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 <span class="preprocessor">#endif</span>
<a name="l00164"></a>00164 <span class="preprocessor"></span>
<a name="l00165"></a>00165 };
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 <span class="comment">// Singleton RemoteElem</span>
<a name="l00168"></a>00168 <span class="keyword">extern</span> <span class="keyword">const</span> <a class="code" href="classRemoteElem.php">RemoteElem</a>* <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>;
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 <span class="preprocessor">#endif // end #ifndef __remote_elem_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
