<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>serial_mesh.C</h1>  </div>
</div>
<div class="contents">
<a href="serial__mesh_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: serial_mesh.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;boundary_info.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;metis_partitioner.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;serial_mesh.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00030"></a>00030 <span class="comment">// SerialMesh class member functions</span>
<a name="l00031"></a><a class="code" href="classSerialMesh.php#a33d71d3b55c017a15c441aa7240b6ba9">00031</a> <a class="code" href="classSerialMesh.php#a33d71d3b55c017a15c441aa7240b6ba9">SerialMesh::SerialMesh</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d) :
<a name="l00032"></a>00032   <a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a> (d)
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034   <a class="code" href="classMeshBase.php#a313380606806d2771ba4f2e78f7400d9">_partitioner</a> = <a class="code" href="classAutoPtr.php">AutoPtr&lt;Partitioner&gt;</a>(<span class="keyword">new</span> <a class="code" href="classMetisPartitioner.php">MetisPartitioner</a>());
<a name="l00035"></a>00035 }
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a><a class="code" href="classSerialMesh.php#a45c7d3c5a6a0fa19883f9dda747ff9c9">00038</a> <a class="code" href="classSerialMesh.php#a45c7d3c5a6a0fa19883f9dda747ff9c9">SerialMesh::~SerialMesh</a> ()
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040   this-&gt;<a class="code" href="classSerialMesh.php#a13aed0ff844e0ce7c7c7ee8654595c55">clear</a>();  <span class="comment">// Free nodes and elements</span>
<a name="l00041"></a>00041 }
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="comment">// This might be specialized later, but right now it&#39;s just here to</span>
<a name="l00045"></a>00045 <span class="comment">// make sure the compiler doesn&#39;t give us a default (non-deep) copy</span>
<a name="l00046"></a>00046 <span class="comment">// constructor instead.</span>
<a name="l00047"></a><a class="code" href="classSerialMesh.php#a0477b28a05d0a41df297099e254817cc">00047</a> <a class="code" href="classSerialMesh.php#a33d71d3b55c017a15c441aa7240b6ba9">SerialMesh::SerialMesh</a> (<span class="keyword">const</span> <a class="code" href="classSerialMesh.php">SerialMesh</a> &amp;other_mesh) :
<a name="l00048"></a>00048   <a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a> (other_mesh)
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050   this-&gt;<a class="code" href="classUnstructuredMesh.php#afecc40762dc88b1ef471a9d4a3938f4c">copy_nodes_and_elements</a>(other_mesh);
<a name="l00051"></a>00051 }
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a><a class="code" href="classSerialMesh.php#aadea91f4c99d40156999ec80c5327990">00054</a> <a class="code" href="classSerialMesh.php#a33d71d3b55c017a15c441aa7240b6ba9">SerialMesh::SerialMesh</a> (<span class="keyword">const</span> <a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a> &amp;other_mesh) :
<a name="l00055"></a>00055   <a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a> (other_mesh)
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057   this-&gt;<a class="code" href="classUnstructuredMesh.php#afecc40762dc88b1ef471a9d4a3938f4c">copy_nodes_and_elements</a>(other_mesh);
<a name="l00058"></a>00058 }
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 
<a name="l00061"></a><a class="code" href="classSerialMesh.php#a5da5261e0400836ed13473c860d87de2">00061</a> <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; <a class="code" href="classSerialMesh.php#a5da5261e0400836ed13473c860d87de2">SerialMesh::point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00062"></a>00062 <span class="keyword"></span>{
<a name="l00063"></a>00063   libmesh_assert (i &lt; this-&gt;<a class="code" href="classSerialMesh.php#a521879644f76ce00e0c400eb1b272412">n_nodes</a>());
<a name="l00064"></a>00064   libmesh_assert (<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[i] != NULL);
<a name="l00065"></a>00065   libmesh_assert (<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[i]-&gt;<span class="keywordtype">id</span>() == i); <span class="comment">// This will change soon</span>
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   <span class="keywordflow">return</span> (*<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[i]);
<a name="l00068"></a>00068 }
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 
<a name="l00074"></a><a class="code" href="classSerialMesh.php#a0c84db67cea0c268dd49fa2a15debaea">00074</a> <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>&amp; <a class="code" href="classSerialMesh.php#a0c84db67cea0c268dd49fa2a15debaea">SerialMesh::node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00075"></a>00075 <span class="keyword"></span>{
<a name="l00076"></a>00076   libmesh_assert (i &lt; this-&gt;<a class="code" href="classSerialMesh.php#a521879644f76ce00e0c400eb1b272412">n_nodes</a>());
<a name="l00077"></a>00077   libmesh_assert (<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[i] != NULL);
<a name="l00078"></a>00078   libmesh_assert (<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[i]-&gt;<span class="keywordtype">id</span>() == i); <span class="comment">// This will change soon</span>
<a name="l00079"></a>00079   
<a name="l00080"></a>00080   <span class="keywordflow">return</span> (*<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[i]);
<a name="l00081"></a>00081 }
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a><a class="code" href="classSerialMesh.php#a15292d8b6d2d3e3dce6f939becf96ba2">00087</a> <a class="code" href="classNode.php">Node</a>&amp; <a class="code" href="classSerialMesh.php#a0c84db67cea0c268dd49fa2a15debaea">SerialMesh::node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00088"></a>00088 {
<a name="l00089"></a>00089   <span class="keywordflow">if</span> (i &gt;= this-&gt;<a class="code" href="classSerialMesh.php#a521879644f76ce00e0c400eb1b272412">n_nodes</a>())
<a name="l00090"></a>00090     {
<a name="l00091"></a>00091       std::cout &lt;&lt; <span class="stringliteral">&quot; i=&quot;</span> &lt;&lt; i
<a name="l00092"></a>00092                 &lt;&lt; <span class="stringliteral">&quot;, n_nodes()=&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classSerialMesh.php#a521879644f76ce00e0c400eb1b272412">n_nodes</a>()
<a name="l00093"></a>00093                 &lt;&lt; std::endl;
<a name="l00094"></a>00094       libmesh_error();
<a name="l00095"></a>00095     }
<a name="l00096"></a>00096   
<a name="l00097"></a>00097   libmesh_assert (i &lt; this-&gt;<a class="code" href="classSerialMesh.php#a521879644f76ce00e0c400eb1b272412">n_nodes</a>());
<a name="l00098"></a>00098   libmesh_assert (<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[i] != NULL);
<a name="l00099"></a>00099   libmesh_assert (<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[i]-&gt;<span class="keywordtype">id</span>() == i); <span class="comment">// This will change soon</span>
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   <span class="keywordflow">return</span> (*<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[i]);
<a name="l00102"></a>00102 }
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a><a class="code" href="classSerialMesh.php#a0f6d0cca187e0c021a4972c4d27bab59">00106</a> <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classSerialMesh.php#a0f6d0cca187e0c021a4972c4d27bab59">SerialMesh::node_ptr</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00107"></a>00107 <span class="keyword"></span>{
<a name="l00108"></a>00108   libmesh_assert (i &lt; this-&gt;<a class="code" href="classSerialMesh.php#a521879644f76ce00e0c400eb1b272412">n_nodes</a>());
<a name="l00109"></a>00109   libmesh_assert (<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[i] != NULL);
<a name="l00110"></a>00110   libmesh_assert (<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[i]-&gt;<span class="keywordtype">id</span>() == i); <span class="comment">// This will change soon</span>
<a name="l00111"></a>00111   
<a name="l00112"></a>00112   <span class="keywordflow">return</span> <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[i];
<a name="l00113"></a>00113 }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a><a class="code" href="classSerialMesh.php#a9e2c5c65f0d4b8338e420afd68ec1d13">00118</a> <a class="code" href="classNode.php">Node</a>* &amp; <a class="code" href="classSerialMesh.php#a0f6d0cca187e0c021a4972c4d27bab59">SerialMesh::node_ptr</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00119"></a>00119 {
<a name="l00120"></a>00120   libmesh_assert (i &lt; this-&gt;<a class="code" href="classSerialMesh.php#a521879644f76ce00e0c400eb1b272412">n_nodes</a>());
<a name="l00121"></a>00121   libmesh_assert (<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[i] != NULL);
<a name="l00122"></a>00122   libmesh_assert (<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[i]-&gt;<span class="keywordtype">id</span>() == i); <span class="comment">// This will change soon</span>
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <span class="keywordflow">return</span> <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[i];
<a name="l00125"></a>00125 }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a><a class="code" href="classSerialMesh.php#a444744996ac4b5446a29fe0304da33b3">00130</a> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classSerialMesh.php#a444744996ac4b5446a29fe0304da33b3">SerialMesh::elem</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00131"></a>00131 <span class="keyword"></span>{
<a name="l00132"></a>00132   libmesh_assert (i &lt; this-&gt;<a class="code" href="classSerialMesh.php#ae81b518f32216083ac13e34884455547">n_elem</a>());
<a name="l00133"></a>00133   libmesh_assert (<a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>[i] != NULL);
<a name="l00134"></a>00134   libmesh_assert (<a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>[i]-&gt;<span class="keywordtype">id</span>() == i); <span class="comment">// This will change soon</span>
<a name="l00135"></a>00135   
<a name="l00136"></a>00136   <span class="keywordflow">return</span> <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>[i];
<a name="l00137"></a>00137 }
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00142"></a><a class="code" href="classSerialMesh.php#a3757e6fde38880e663ae1dc441d05cb1">00142</a> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classSerialMesh.php#a3757e6fde38880e663ae1dc441d05cb1">SerialMesh::add_elem</a> (<a class="code" href="classElem.php">Elem</a>* e)
<a name="l00143"></a>00143 {
<a name="l00144"></a>00144   libmesh_assert(e);
<a name="l00145"></a>00145 
<a name="l00146"></a>00146   <span class="comment">// We only append elements with SerialMesh</span>
<a name="l00147"></a>00147   libmesh_assert (!e-&gt;<a class="code" href="classDofObject.php#a941814a36472764092ae352543f3ecd7">valid_id</a>() ||
<a name="l00148"></a>00148           e-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() == <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>.size());
<a name="l00149"></a>00149 
<a name="l00150"></a>00150   e-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a> (<a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>.size());
<a name="l00151"></a>00151   
<a name="l00152"></a>00152   <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>.push_back(e);
<a name="l00153"></a>00153 
<a name="l00154"></a>00154   <span class="keywordflow">return</span> e;
<a name="l00155"></a>00155 }
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 
<a name="l00159"></a><a class="code" href="classSerialMesh.php#a03b82e4f03e7c6f5d569f21f665cdc7a">00159</a> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classSerialMesh.php#a03b82e4f03e7c6f5d569f21f665cdc7a">SerialMesh::insert_elem</a> (<a class="code" href="classElem.php">Elem</a>* e)
<a name="l00160"></a>00160 {
<a name="l00161"></a>00161   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> eid = e-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l00162"></a>00162   libmesh_assert(eid &lt; <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>.size());
<a name="l00163"></a>00163   <a class="code" href="classElem.php">Elem</a> *oldelem = <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>[eid];
<a name="l00164"></a>00164 
<a name="l00165"></a>00165   <span class="keywordflow">if</span> (oldelem)
<a name="l00166"></a>00166     {
<a name="l00167"></a>00167       libmesh_assert(oldelem-&gt;id() == eid);
<a name="l00168"></a>00168       this-&gt;<a class="code" href="classSerialMesh.php#a83f780390afaf40518732e4a3f91f411">delete_elem</a>(oldelem);
<a name="l00169"></a>00169     }
<a name="l00170"></a>00170 
<a name="l00171"></a>00171   <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>[e-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] = e;
<a name="l00172"></a>00172 
<a name="l00173"></a>00173   <span class="keywordflow">return</span> e;
<a name="l00174"></a>00174 }
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a><a class="code" href="classSerialMesh.php#a83f780390afaf40518732e4a3f91f411">00178</a> <span class="keywordtype">void</span> <a class="code" href="classSerialMesh.php#a83f780390afaf40518732e4a3f91f411">SerialMesh::delete_elem</a>(<a class="code" href="classElem.php">Elem</a>* e)
<a name="l00179"></a>00179 {
<a name="l00180"></a>00180   libmesh_assert (e != NULL);
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   <span class="comment">// Initialize an iterator to eventually point to the element we want to delete</span>
<a name="l00183"></a>00183   std::vector&lt;Elem*&gt;::iterator pos = <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>.end();
<a name="l00184"></a>00184   
<a name="l00185"></a>00185   <span class="comment">// In many cases, e-&gt;id() gives us a clue as to where e</span>
<a name="l00186"></a>00186   <span class="comment">// is located in the _elements vector.  Try that first</span>
<a name="l00187"></a>00187   <span class="comment">// before trying the O(n_elem) search.</span>
<a name="l00188"></a>00188   libmesh_assert (e-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() &lt; <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>.size());
<a name="l00189"></a>00189 
<a name="l00190"></a>00190   <span class="keywordflow">if</span> (<a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>[e-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] == e)
<a name="l00191"></a>00191     {
<a name="l00192"></a>00192       <span class="comment">// We found it!</span>
<a name="l00193"></a>00193       pos = <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>.begin();
<a name="l00194"></a>00194       std::advance(pos, e-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>());
<a name="l00195"></a>00195     }
<a name="l00196"></a>00196 
<a name="l00197"></a>00197   <span class="keywordflow">else</span>
<a name="l00198"></a>00198     {
<a name="l00199"></a>00199       <span class="comment">// This search is O(n_elem)</span>
<a name="l00200"></a>00200       pos = std::find (<a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>.begin(),
<a name="l00201"></a>00201                        <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>.end(),
<a name="l00202"></a>00202                        e);
<a name="l00203"></a>00203     }
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   <span class="comment">// Huh? Element not in the vector?</span>
<a name="l00206"></a>00206   libmesh_assert (pos != <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>.end());
<a name="l00207"></a>00207 
<a name="l00208"></a>00208   <span class="comment">// Remove the element from the BoundaryInfo object</span>
<a name="l00209"></a>00209   this-&gt;<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;remove(e);
<a name="l00210"></a>00210   
<a name="l00211"></a>00211   <span class="comment">// delete the element</span>
<a name="l00212"></a>00212   <span class="keyword">delete</span> e;
<a name="l00213"></a>00213   
<a name="l00214"></a>00214   <span class="comment">// explicitly NULL the pointer</span>
<a name="l00215"></a>00215   *pos = NULL;
<a name="l00216"></a>00216 }
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 
<a name="l00220"></a><a class="code" href="classSerialMesh.php#a9a0a9fc8c5c3b231a24cbd20fde52d34">00220</a> <span class="keywordtype">void</span> <a class="code" href="classSerialMesh.php#a9a0a9fc8c5c3b231a24cbd20fde52d34">SerialMesh::renumber_elem</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_id,
<a name="l00221"></a>00221                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_id)
<a name="l00222"></a>00222 {
<a name="l00223"></a>00223   <span class="comment">// This doesn&#39;t get used in serial yet</span>
<a name="l00224"></a>00224   <a class="code" href="classElem.php">Elem</a> *<a class="code" href="classSerialMesh.php#a444744996ac4b5446a29fe0304da33b3">elem</a> = <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>[old_id];
<a name="l00225"></a>00225   libmesh_assert (elem);
<a name="l00226"></a>00226 
<a name="l00227"></a>00227   elem-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a>(new_id);
<a name="l00228"></a>00228   libmesh_assert (!<a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>[new_id]);
<a name="l00229"></a>00229   <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>[new_id] = <a class="code" href="classSerialMesh.php#a444744996ac4b5446a29fe0304da33b3">elem</a>;
<a name="l00230"></a>00230   <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>[old_id] = NULL;
<a name="l00231"></a>00231 }
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 
<a name="l00235"></a><a class="code" href="classSerialMesh.php#ac79d5838f4434a25161667d4c85a1727">00235</a> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classSerialMesh.php#ac79d5838f4434a25161667d4c85a1727">SerialMesh::add_point</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00236"></a>00236                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>,
<a name="l00237"></a>00237                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)
<a name="l00238"></a>00238 {  
<a name="l00239"></a>00239 <span class="comment">//   // We only append points with SerialMesh</span>
<a name="l00240"></a>00240 <span class="comment">//   libmesh_assert(id == DofObject::invalid_id || id == _nodes.size());</span>
<a name="l00241"></a>00241 <span class="comment">//   Node *n = Node::build(p, _nodes.size()).release();</span>
<a name="l00242"></a>00242 <span class="comment">//   n-&gt;processor_id() = proc_id;</span>
<a name="l00243"></a>00243 <span class="comment">//   _nodes.push_back (n);</span>
<a name="l00244"></a>00244 
<a name="l00245"></a>00245   <a class="code" href="classNode.php">Node</a> *n = NULL;
<a name="l00246"></a>00246 
<a name="l00247"></a>00247   <span class="comment">// If the user requests a valid id, either</span>
<a name="l00248"></a>00248   <span class="comment">// provide the existing node or resize the container</span>
<a name="l00249"></a>00249   <span class="comment">// to fit the new node.</span>
<a name="l00250"></a>00250   <span class="keywordflow">if</span> (<span class="keywordtype">id</span> != <a class="code" href="classDofObject.php#a35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>)
<a name="l00251"></a>00251     <span class="keywordflow">if</span> (<span class="keywordtype">id</span> &lt; <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>.size())
<a name="l00252"></a>00252       n = <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[<span class="keywordtype">id</span>];
<a name="l00253"></a>00253     <span class="keywordflow">else</span>
<a name="l00254"></a>00254       <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>.resize(<span class="keywordtype">id</span>+1);
<a name="l00255"></a>00255   <span class="keywordflow">else</span>
<a name="l00256"></a>00256     <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>.push_back (static_cast&lt;Node*&gt;(NULL));
<a name="l00257"></a>00257   
<a name="l00258"></a>00258   <span class="comment">// if the node already exists, then assign new (x,y,z) values</span>
<a name="l00259"></a>00259   <span class="keywordflow">if</span> (n)
<a name="l00260"></a>00260     *n = p;
<a name="l00261"></a>00261   <span class="comment">// otherwise build a new node, put it in the right spot, and return </span>
<a name="l00262"></a>00262   <span class="comment">// a valid pointer.</span>
<a name="l00263"></a>00263   <span class="keywordflow">else</span>
<a name="l00264"></a>00264     {
<a name="l00265"></a>00265       n = <a class="code" href="classNode.php#aa6175b07d8a78dc554bb0f9f4727b02e">Node::build</a>(p, (<span class="keywordtype">id</span> == <a class="code" href="classDofObject.php#a35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>) ? <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>.size()-1 : id).release();
<a name="l00266"></a>00266       n-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() = proc_id;
<a name="l00267"></a>00267 
<a name="l00268"></a>00268       <span class="keywordflow">if</span> (<span class="keywordtype">id</span> == <a class="code" href="classDofObject.php#a35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>)
<a name="l00269"></a>00269         <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>.back() = n;
<a name="l00270"></a>00270       <span class="keywordflow">else</span>
<a name="l00271"></a>00271         <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[id] = n;
<a name="l00272"></a>00272     }
<a name="l00273"></a>00273 
<a name="l00274"></a>00274   <span class="comment">// better not pass back a NULL pointer.</span>
<a name="l00275"></a>00275   libmesh_assert (n);
<a name="l00276"></a>00276 
<a name="l00277"></a>00277   <span class="keywordflow">return</span> n;
<a name="l00278"></a>00278 }
<a name="l00279"></a>00279 
<a name="l00280"></a>00280 
<a name="l00281"></a>00281 
<a name="l00282"></a><a class="code" href="classSerialMesh.php#a8dce0a71382bbbf7b675e91097a2f0a7">00282</a> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classSerialMesh.php#a8dce0a71382bbbf7b675e91097a2f0a7">SerialMesh::add_node</a> (<a class="code" href="classNode.php">Node</a>* n)
<a name="l00283"></a>00283 {  
<a name="l00284"></a>00284   libmesh_assert(n);
<a name="l00285"></a>00285   <span class="comment">// We only append points with SerialMesh</span>
<a name="l00286"></a>00286   libmesh_assert(!n-&gt;<a class="code" href="classDofObject.php#a941814a36472764092ae352543f3ecd7">valid_id</a>() || n-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() == <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>.size());
<a name="l00287"></a>00287 
<a name="l00288"></a>00288   n-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a> (<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>.size());
<a name="l00289"></a>00289   
<a name="l00290"></a>00290   <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>.push_back(n);
<a name="l00291"></a>00291 
<a name="l00292"></a>00292   <span class="keywordflow">return</span> n;
<a name="l00293"></a>00293 }
<a name="l00294"></a>00294 
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 
<a name="l00297"></a><a class="code" href="classSerialMesh.php#a80974147cfdf5d5267cf2aee04b0097b">00297</a> <span class="keywordtype">void</span> <a class="code" href="classSerialMesh.php#a80974147cfdf5d5267cf2aee04b0097b">SerialMesh::delete_node</a>(<a class="code" href="classNode.php">Node</a>* n)
<a name="l00298"></a>00298 {
<a name="l00299"></a>00299   libmesh_assert (n != NULL);
<a name="l00300"></a>00300   libmesh_assert (n-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() &lt; <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>.size());
<a name="l00301"></a>00301 
<a name="l00302"></a>00302   <span class="comment">// Initialize an iterator to eventually point to the element we want</span>
<a name="l00303"></a>00303   <span class="comment">// to delete</span>
<a name="l00304"></a>00304   std::vector&lt;Node*&gt;::iterator pos;
<a name="l00305"></a>00305 
<a name="l00306"></a>00306   <span class="comment">// In many cases, e-&gt;id() gives us a clue as to where e</span>
<a name="l00307"></a>00307   <span class="comment">// is located in the _elements vector.  Try that first</span>
<a name="l00308"></a>00308   <span class="comment">// before trying the O(n_elem) search.</span>
<a name="l00309"></a>00309   <span class="keywordflow">if</span> (<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[n-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] == n)
<a name="l00310"></a>00310     {
<a name="l00311"></a>00311       pos = <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>.begin();
<a name="l00312"></a>00312       std::advance(pos, n-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>());
<a name="l00313"></a>00313     }
<a name="l00314"></a>00314   <span class="keywordflow">else</span>
<a name="l00315"></a>00315     {
<a name="l00316"></a>00316       pos = std::find (<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>.begin(),
<a name="l00317"></a>00317                        <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>.end(),
<a name="l00318"></a>00318                        n);
<a name="l00319"></a>00319     }
<a name="l00320"></a>00320   
<a name="l00321"></a>00321   <span class="comment">// Huh? Node not in the vector?</span>
<a name="l00322"></a>00322   libmesh_assert (pos != <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>.end());
<a name="l00323"></a>00323 
<a name="l00324"></a>00324   <span class="comment">// Delete the node from the BoundaryInfo object</span>
<a name="l00325"></a>00325   this-&gt;<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;remove(n);
<a name="l00326"></a>00326   
<a name="l00327"></a>00327   <span class="comment">// delete the node</span>
<a name="l00328"></a>00328   <span class="keyword">delete</span> n;
<a name="l00329"></a>00329   
<a name="l00330"></a>00330   <span class="comment">// explicitly NULL the pointer</span>
<a name="l00331"></a>00331   *pos = NULL;
<a name="l00332"></a>00332 }
<a name="l00333"></a>00333 
<a name="l00334"></a>00334 
<a name="l00335"></a>00335 
<a name="l00336"></a><a class="code" href="classSerialMesh.php#a17e8f3105fbdd349d7ec27a04d6e22f3">00336</a> <span class="keywordtype">void</span> <a class="code" href="classSerialMesh.php#a17e8f3105fbdd349d7ec27a04d6e22f3">SerialMesh::renumber_node</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_id,
<a name="l00337"></a>00337                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_id)
<a name="l00338"></a>00338 {
<a name="l00339"></a>00339   <span class="comment">// This doesn&#39;t get used in serial yet</span>
<a name="l00340"></a>00340   <a class="code" href="classNode.php">Node</a> *<a class="code" href="classSerialMesh.php#a0c84db67cea0c268dd49fa2a15debaea">node</a> = <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[old_id];
<a name="l00341"></a>00341   libmesh_assert (node);
<a name="l00342"></a>00342 
<a name="l00343"></a>00343   node-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a>(new_id);
<a name="l00344"></a>00344   libmesh_assert (!<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[new_id]);
<a name="l00345"></a>00345   <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[new_id] = <a class="code" href="classSerialMesh.php#a0c84db67cea0c268dd49fa2a15debaea">node</a>;
<a name="l00346"></a>00346   <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[old_id] = NULL;
<a name="l00347"></a>00347 }
<a name="l00348"></a>00348 
<a name="l00349"></a>00349 
<a name="l00350"></a>00350 
<a name="l00351"></a><a class="code" href="classSerialMesh.php#a13aed0ff844e0ce7c7c7ee8654595c55">00351</a> <span class="keywordtype">void</span> <a class="code" href="classSerialMesh.php#a13aed0ff844e0ce7c7c7ee8654595c55">SerialMesh::clear</a> ()
<a name="l00352"></a>00352 {
<a name="l00353"></a>00353   <span class="comment">// Call parent clear function</span>
<a name="l00354"></a>00354   <a class="code" href="classSerialMesh.php#a13aed0ff844e0ce7c7c7ee8654595c55">MeshBase::clear</a>();
<a name="l00355"></a>00355 
<a name="l00356"></a>00356   
<a name="l00357"></a>00357   <span class="comment">// Clear our elements and nodes</span>
<a name="l00358"></a>00358   {
<a name="l00359"></a>00359     std::vector&lt;Elem*&gt;::iterator       it  = <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>.begin();
<a name="l00360"></a>00360     <span class="keyword">const</span> std::vector&lt;Elem*&gt;::iterator end = <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>.end();
<a name="l00361"></a>00361 
<a name="l00362"></a>00362     <span class="comment">// There is no need to remove the elements from</span>
<a name="l00363"></a>00363     <span class="comment">// the BoundaryInfo data structure since we</span>
<a name="l00364"></a>00364     <span class="comment">// already cleared it.</span>
<a name="l00365"></a>00365     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00366"></a>00366       <span class="keyword">delete</span> *it;
<a name="l00367"></a>00367 
<a name="l00368"></a>00368     <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>.clear();
<a name="l00369"></a>00369   }
<a name="l00370"></a>00370 
<a name="l00371"></a>00371   <span class="comment">// clear the nodes data structure</span>
<a name="l00372"></a>00372   {
<a name="l00373"></a>00373     std::vector&lt;Node*&gt;::iterator       it  = <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>.begin();
<a name="l00374"></a>00374     <span class="keyword">const</span> std::vector&lt;Node*&gt;::iterator end = <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>.end();
<a name="l00375"></a>00375 
<a name="l00376"></a>00376     <span class="comment">// There is no need to remove the nodes from</span>
<a name="l00377"></a>00377     <span class="comment">// the BoundaryInfo data structure since we</span>
<a name="l00378"></a>00378     <span class="comment">// already cleared it.</span>
<a name="l00379"></a>00379     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00380"></a>00380       <span class="keyword">delete</span> *it;
<a name="l00381"></a>00381     
<a name="l00382"></a>00382     <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>.clear();
<a name="l00383"></a>00383   }
<a name="l00384"></a>00384 }
<a name="l00385"></a>00385 
<a name="l00386"></a>00386 
<a name="l00387"></a>00387 
<a name="l00388"></a><a class="code" href="classSerialMesh.php#a60db08a01ffaf1df40160beb24ead12f">00388</a> <span class="keywordtype">void</span> <a class="code" href="classSerialMesh.php#a60db08a01ffaf1df40160beb24ead12f">SerialMesh::renumber_nodes_and_elements</a> ()
<a name="l00389"></a>00389 {
<a name="l00390"></a>00390   
<a name="l00391"></a>00391   START_LOG(<span class="stringliteral">&quot;renumber_nodes_and_elem()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00392"></a>00392   
<a name="l00393"></a>00393   <span class="comment">// node and element id counters</span>
<a name="l00394"></a>00394   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> next_free_elem = 0;
<a name="l00395"></a>00395   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> next_free_node = 0;
<a name="l00396"></a>00396 
<a name="l00397"></a>00397   <span class="comment">// Loop over the elements.  Note that there may</span>
<a name="l00398"></a>00398   <span class="comment">// be NULLs in the _elements vector from the coarsening</span>
<a name="l00399"></a>00399   <span class="comment">// process.  Pack the elements in to a contiguous array</span>
<a name="l00400"></a>00400   <span class="comment">// and then trim any excess.</span>
<a name="l00401"></a>00401   {      
<a name="l00402"></a>00402     std::vector&lt;Elem*&gt;::iterator in        = <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>.begin();
<a name="l00403"></a>00403     std::vector&lt;Elem*&gt;::iterator out       = <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>.begin();
<a name="l00404"></a>00404     <span class="keyword">const</span> std::vector&lt;Elem*&gt;::iterator end = <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>.end();
<a name="l00405"></a>00405 
<a name="l00406"></a>00406     <span class="keywordflow">for</span> (; in != end; ++in)
<a name="l00407"></a>00407       <span class="keywordflow">if</span> (*in != NULL)
<a name="l00408"></a>00408         {
<a name="l00409"></a>00409           <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classSerialMesh.php#a444744996ac4b5446a29fe0304da33b3">elem</a> = *in;
<a name="l00410"></a>00410           
<a name="l00411"></a>00411           *out = *in;
<a name="l00412"></a>00412           ++out;
<a name="l00413"></a>00413           
<a name="l00414"></a>00414           <span class="comment">// Increment the element counter</span>
<a name="l00415"></a>00415           elem-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a> (next_free_elem++);
<a name="l00416"></a>00416           
<a name="l00417"></a>00417           <span class="comment">// Loop over this element&#39;s nodes.  Number them,</span>
<a name="l00418"></a>00418           <span class="comment">// if they have not been numbered already.  Also,</span>
<a name="l00419"></a>00419           <span class="comment">// position them in the _nodes vector so that they</span>
<a name="l00420"></a>00420           <span class="comment">// are packed contiguously from the beginning.</span>
<a name="l00421"></a>00421           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); n++)
<a name="l00422"></a>00422             <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n) == next_free_node)     <span class="comment">// don&#39;t need to process</span>
<a name="l00423"></a>00423               next_free_node++;                      <span class="comment">// [(src == dst) below]</span>
<a name="l00424"></a>00424 
<a name="l00425"></a>00425             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n) &gt; next_free_node) <span class="comment">// need to process</span>
<a name="l00426"></a>00426               {
<a name="l00427"></a>00427                 <span class="comment">// The source and destination indices</span>
<a name="l00428"></a>00428                 <span class="comment">// for this node</span>
<a name="l00429"></a>00429                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> src_idx = elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n);
<a name="l00430"></a>00430                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dst_idx = next_free_node++;
<a name="l00431"></a>00431 
<a name="l00432"></a>00432                 <span class="comment">// ensure we want to swap valid nodes</span>
<a name="l00433"></a>00433                 libmesh_assert (<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[src_idx] != NULL);
<a name="l00434"></a>00434                 libmesh_assert (<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[dst_idx] != NULL);
<a name="l00435"></a>00435                 
<a name="l00436"></a>00436                 <span class="comment">// Swap the source and destination nodes</span>
<a name="l00437"></a>00437                 std::swap(<a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[src_idx],
<a name="l00438"></a>00438                           <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[dst_idx] );
<a name="l00439"></a>00439 
<a name="l00440"></a>00440                 <span class="comment">// Set proper indices</span>
<a name="l00441"></a>00441                 <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[src_idx]-&gt;set_id (src_idx);
<a name="l00442"></a>00442                 <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>[dst_idx]-&gt;set_id (dst_idx);
<a name="l00443"></a>00443               }
<a name="l00444"></a>00444         }
<a name="l00445"></a>00445 
<a name="l00446"></a>00446     <span class="comment">// Erase any additional storage. These elements have been</span>
<a name="l00447"></a>00447     <span class="comment">// copied into NULL voids by the procedure above, and are</span>
<a name="l00448"></a>00448     <span class="comment">// thus repeated and unnecessary.</span>
<a name="l00449"></a>00449     <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>.erase (out, end);
<a name="l00450"></a>00450   }
<a name="l00451"></a>00451 
<a name="l00452"></a>00452   <span class="comment">// Any nodes in the vector &gt;= _nodes[next_free_node]</span>
<a name="l00453"></a>00453   <span class="comment">// are not connected to any elements and may be deleted</span>
<a name="l00454"></a>00454   <span class="comment">// if desired.</span>
<a name="l00455"></a>00455 
<a name="l00456"></a>00456   <span class="comment">// (This code block will erase the unused nodes)</span>
<a name="l00457"></a>00457   <span class="comment">// Now, delete the unused nodes</span>
<a name="l00458"></a>00458   {
<a name="l00459"></a>00459     std::vector&lt;Node*&gt;::iterator nd        = <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>.begin();
<a name="l00460"></a>00460     <span class="keyword">const</span> std::vector&lt;Node*&gt;::iterator end = <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>.end();
<a name="l00461"></a>00461 
<a name="l00462"></a>00462     std::advance (nd, next_free_node);
<a name="l00463"></a>00463     
<a name="l00464"></a>00464     <span class="keywordflow">for</span> (std::vector&lt;Node*&gt;::iterator it=nd;
<a name="l00465"></a>00465          it != end; ++it)
<a name="l00466"></a>00466       {
<a name="l00467"></a>00467         libmesh_assert (*it != NULL);
<a name="l00468"></a>00468 
<a name="l00469"></a>00469         <span class="comment">// remove any boundary information associated with</span>
<a name="l00470"></a>00470         <span class="comment">// this node</span>
<a name="l00471"></a>00471         this-&gt;<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;remove (*it);
<a name="l00472"></a>00472         
<a name="l00473"></a>00473         <span class="comment">// delete the node</span>
<a name="l00474"></a>00474         <span class="keyword">delete</span> *it;
<a name="l00475"></a>00475         *it = NULL;
<a name="l00476"></a>00476       }
<a name="l00477"></a>00477 
<a name="l00478"></a>00478     <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>.erase (nd, end);
<a name="l00479"></a>00479   }
<a name="l00480"></a>00480   
<a name="l00481"></a>00481 
<a name="l00482"></a>00482   libmesh_assert (next_free_elem == <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>.size());
<a name="l00483"></a>00483   libmesh_assert (next_free_node == <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>.size());
<a name="l00484"></a>00484   
<a name="l00485"></a>00485   STOP_LOG(<span class="stringliteral">&quot;renumber_nodes_and_elem()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00486"></a>00486 }
<a name="l00487"></a>00487 
<a name="l00488"></a>00488 
<a name="l00489"></a>00489 
<a name="l00490"></a><a class="code" href="classSerialMesh.php#a5bf321699a3f218420fdb6ee19b08eee">00490</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSerialMesh.php#a5bf321699a3f218420fdb6ee19b08eee">SerialMesh::n_active_elem</a> ()<span class="keyword"> const</span>
<a name="l00491"></a>00491 <span class="keyword"></span>{
<a name="l00492"></a>00492   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(std::distance (this-&gt;<a class="code" href="classSerialMesh.php#ab981af7e69906482a62b58c26ad400b4">active_elements_begin</a>(),
<a name="l00493"></a>00493                                                   this-&gt;<a class="code" href="classSerialMesh.php#aa1a47788c6a93e51631f9304f4127686">active_elements_end</a>()));
<a name="l00494"></a>00494 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
