<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>serial_mesh.h</h1>  </div>
</div>
<div class="contents">
<a href="serial__mesh_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: serial_mesh.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __serial_mesh_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __serial_mesh_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="unstructured__mesh_8h.php">unstructured_mesh.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Prototype this function so we can delcare it a friend.</span>
<a name="l00036"></a>00036 <span class="keyword">class </span><a class="code" href="classSerialMesh.php">SerialMesh</a>;
<a name="l00037"></a>00037 <span class="keyword">namespace </span>MeshTools {
<a name="l00038"></a>00038   <span class="keyword">namespace </span>Private {
<a name="l00039"></a>00039     <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools_1_1Private.php#af435c29becf70b3ce4a05360be28dbc5">fix_broken_node_and_element_numbering</a> (<a class="code" href="classSerialMesh.php">SerialMesh</a> &amp;);
<a name="l00040"></a>00040   }
<a name="l00041"></a>00041 }
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00051"></a>00051 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00052"></a>00052 <span class="comment">// Mesh class definition</span>
<a name="l00053"></a><a class="code" href="classSerialMesh.php">00053</a> <span class="keyword">class </span><a class="code" href="classSerialMesh.php">SerialMesh</a> : <span class="keyword">public</span> <a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055  <span class="keyword">public</span>:
<a name="l00056"></a>00056 
<a name="l00062"></a>00062   <a class="code" href="classSerialMesh.php#a33d71d3b55c017a15c441aa7240b6ba9">SerialMesh</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d);
<a name="l00063"></a>00063 
<a name="l00068"></a>00068   <a class="code" href="classSerialMesh.php#a33d71d3b55c017a15c441aa7240b6ba9">SerialMesh</a> (<span class="keyword">const</span> <a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; other_mesh);
<a name="l00069"></a>00069 
<a name="l00074"></a>00074   <a class="code" href="classSerialMesh.php#a33d71d3b55c017a15c441aa7240b6ba9">SerialMesh</a> (<span class="keyword">const</span> <a class="code" href="classSerialMesh.php">SerialMesh</a>&amp; other_mesh);
<a name="l00075"></a>00075 
<a name="l00079"></a><a class="code" href="classSerialMesh.php#a342c18bca67d851c27dccc6daad8619a">00079</a>   <span class="keyword">virtual</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;MeshBase&gt;</a> <a class="code" href="classSerialMesh.php#a342c18bca67d851c27dccc6daad8619a">clone</a> ()<span class="keyword"> const</span>
<a name="l00080"></a>00080 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;MeshBase&gt;</a>(<span class="keyword">new</span> <a class="code" href="classSerialMesh.php#a33d71d3b55c017a15c441aa7240b6ba9">SerialMesh</a>(*<span class="keyword">this</span>)); }
<a name="l00081"></a>00081 
<a name="l00085"></a>00085   <span class="keyword">virtual</span> <a class="code" href="classSerialMesh.php#a45c7d3c5a6a0fa19883f9dda747ff9c9">~SerialMesh</a>();
<a name="l00086"></a>00086 
<a name="l00090"></a>00090   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSerialMesh.php#a13aed0ff844e0ce7c7c7ee8654595c55">clear</a>();
<a name="l00091"></a>00091 
<a name="l00095"></a>00095   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSerialMesh.php#a60db08a01ffaf1df40160beb24ead12f">renumber_nodes_and_elements</a> ();
<a name="l00096"></a>00096 
<a name="l00097"></a><a class="code" href="classSerialMesh.php#a521879644f76ce00e0c400eb1b272412">00097</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSerialMesh.php#a521879644f76ce00e0c400eb1b272412">n_nodes</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>.size(); }
<a name="l00098"></a><a class="code" href="classSerialMesh.php#a0c320b9965bcd9a152193d1dec7c6598">00098</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSerialMesh.php#a0c320b9965bcd9a152193d1dec7c6598">max_node_id</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>.size(); }
<a name="l00099"></a><a class="code" href="classSerialMesh.php#a14ce2158fa84418b5ebd2d25ca541594">00099</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSerialMesh.php#a14ce2158fa84418b5ebd2d25ca541594">reserve_nodes</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn) { <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>.reserve (nn); }
<a name="l00100"></a><a class="code" href="classSerialMesh.php#ae81b518f32216083ac13e34884455547">00100</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSerialMesh.php#ae81b518f32216083ac13e34884455547">n_elem</a> ()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>.size(); }
<a name="l00101"></a>00101   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSerialMesh.php#a5bf321699a3f218420fdb6ee19b08eee">n_active_elem</a> () <span class="keyword">const</span>;
<a name="l00102"></a><a class="code" href="classSerialMesh.php#ac94abe2c37dcf0a891eaf95a42b213ab">00102</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSerialMesh.php#ac94abe2c37dcf0a891eaf95a42b213ab">max_elem_id</a> ()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>.size(); }
<a name="l00103"></a><a class="code" href="classSerialMesh.php#a6ddd72d93fcfc1ca567c75d81baff040">00103</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSerialMesh.php#a6ddd72d93fcfc1ca567c75d81baff040">reserve_elem</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ne) { <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>.reserve (ne); }
<a name="l00104"></a>00104 
<a name="l00105"></a>00105   <span class="comment">// SerialMesh has no caches to update</span>
<a name="l00106"></a><a class="code" href="classSerialMesh.php#a334da2e75839356728c7f5b80a3a590e">00106</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSerialMesh.php#a334da2e75839356728c7f5b80a3a590e">update_parallel_id_counts</a> () {}
<a name="l00107"></a>00107 
<a name="l00111"></a>00111   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; <a class="code" href="classSerialMesh.php#a5da5261e0400836ed13473c860d87de2">point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> ;
<a name="l00112"></a>00112   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>&amp;  <a class="code" href="classSerialMesh.php#a0c84db67cea0c268dd49fa2a15debaea">node</a>  (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> ;
<a name="l00113"></a>00113   <span class="keyword">virtual</span> <a class="code" href="classNode.php">Node</a>&amp; <a class="code" href="classSerialMesh.php#a0c84db67cea0c268dd49fa2a15debaea">node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) ;
<a name="l00114"></a>00114   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classSerialMesh.php#a0f6d0cca187e0c021a4972c4d27bab59">node_ptr</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> ;
<a name="l00115"></a>00115   <span class="keyword">virtual</span> <a class="code" href="classNode.php">Node</a>* &amp; <a class="code" href="classSerialMesh.php#a0f6d0cca187e0c021a4972c4d27bab59">node_ptr</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) ;
<a name="l00116"></a>00116   <span class="keyword">virtual</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classSerialMesh.php#a444744996ac4b5446a29fe0304da33b3">elem</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> ;
<a name="l00117"></a>00117 
<a name="l00121"></a>00121   <span class="keyword">virtual</span> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classSerialMesh.php#ac79d5838f4434a25161667d4c85a1727">add_point</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00122"></a>00122                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span> =
<a name="l00123"></a>00123                              <a class="code" href="classDofObject.php#a35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>,
<a name="l00124"></a>00124                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id =
<a name="l00125"></a>00125                              <a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>);
<a name="l00126"></a>00126   <span class="keyword">virtual</span> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classSerialMesh.php#a8dce0a71382bbbf7b675e91097a2f0a7">add_node</a> (<a class="code" href="classNode.php">Node</a>* n) ;
<a name="l00127"></a>00127   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSerialMesh.php#a80974147cfdf5d5267cf2aee04b0097b">delete_node</a> (<a class="code" href="classNode.php">Node</a>* n) ;
<a name="l00128"></a>00128   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSerialMesh.php#a17e8f3105fbdd349d7ec27a04d6e22f3">renumber_node</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_id, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_id);
<a name="l00129"></a>00129   <span class="keyword">virtual</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classSerialMesh.php#a3757e6fde38880e663ae1dc441d05cb1">add_elem</a> (<a class="code" href="classElem.php">Elem</a>* e) ;
<a name="l00130"></a>00130   <span class="keyword">virtual</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classSerialMesh.php#a03b82e4f03e7c6f5d569f21f665cdc7a">insert_elem</a> (<a class="code" href="classElem.php">Elem</a>* e) ;
<a name="l00131"></a>00131   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSerialMesh.php#a83f780390afaf40518732e4a3f91f411">delete_elem</a> (<a class="code" href="classElem.php">Elem</a>* e) ;
<a name="l00132"></a>00132   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSerialMesh.php#a9a0a9fc8c5c3b231a24cbd20fde52d34">renumber_elem</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_id, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_id);
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   <span class="keyword">friend</span> <span class="keywordtype">void</span> <a class="code" href="namespaceMeshTools_1_1Private.php#af435c29becf70b3ce4a05360be28dbc5">MeshTools::Private::fix_broken_node_and_element_numbering</a> (<a class="code" href="classSerialMesh.php">SerialMesh</a> &amp;);
<a name="l00135"></a>00135   
<a name="l00136"></a>00136 <span class="keyword">public</span>:
<a name="l00140"></a>00140   element_iterator <a class="code" href="classSerialMesh.php#aba5c567c53aa4d2444212089253820dc">elements_begin</a> ();
<a name="l00141"></a>00141   element_iterator <a class="code" href="classSerialMesh.php#aa489a38f160a9d4aed033fcaf59d61e0">elements_end</a>   ();
<a name="l00142"></a>00142 
<a name="l00143"></a>00143   element_iterator <a class="code" href="classSerialMesh.php#ab981af7e69906482a62b58c26ad400b4">active_elements_begin</a> ();
<a name="l00144"></a>00144   element_iterator <a class="code" href="classSerialMesh.php#aa1a47788c6a93e51631f9304f4127686">active_elements_end</a>   ();
<a name="l00145"></a>00145 
<a name="l00146"></a>00146   element_iterator <a class="code" href="classSerialMesh.php#ad38048645067d681b06a2010ebb72384">ancestor_elements_begin</a> ();
<a name="l00147"></a>00147   element_iterator <a class="code" href="classSerialMesh.php#a3e00f36cf9689ea418a0ee2742af1927">ancestor_elements_end</a>   ();
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   element_iterator <a class="code" href="classSerialMesh.php#ae3a46e02b677315b39376cd87ddf7efd">subactive_elements_begin</a> ();
<a name="l00150"></a>00150   element_iterator <a class="code" href="classSerialMesh.php#a00e461844d3140da7c7357cf1f6c9945">subactive_elements_end</a>   ();
<a name="l00151"></a>00151 
<a name="l00152"></a>00152   element_iterator <a class="code" href="classSerialMesh.php#afe773bb7c94dea599510b1bbe502079e">not_active_elements_begin</a> ();
<a name="l00153"></a>00153   element_iterator <a class="code" href="classSerialMesh.php#a920700cacf7a3f56c115e482769642d9">not_active_elements_end</a>   ();
<a name="l00154"></a>00154 
<a name="l00155"></a>00155   element_iterator <a class="code" href="classSerialMesh.php#aab45695e4ff3ad683fdd51f36ebdd114">not_ancestor_elements_begin</a> ();
<a name="l00156"></a>00156   element_iterator <a class="code" href="classSerialMesh.php#a43eedd58799650308ede5c4c90a53391">not_ancestor_elements_end</a>   ();
<a name="l00157"></a>00157 
<a name="l00158"></a>00158   element_iterator <a class="code" href="classSerialMesh.php#ae365e10df6fee124830fc6588b154d35">not_subactive_elements_begin</a> ();
<a name="l00159"></a>00159   element_iterator <a class="code" href="classSerialMesh.php#a1af10fcc9fc67792210279c9d43d3c80">not_subactive_elements_end</a>   ();
<a name="l00160"></a>00160 
<a name="l00161"></a>00161   element_iterator <a class="code" href="classSerialMesh.php#a9c94fa5f85717ab508b233ffaae48c54">local_elements_begin</a> ();
<a name="l00162"></a>00162   element_iterator <a class="code" href="classSerialMesh.php#a2516b6a7c6b51d27f9258e97e22c76f6">local_elements_end</a>   ();
<a name="l00163"></a>00163 
<a name="l00164"></a>00164   element_iterator <a class="code" href="classSerialMesh.php#a5b690aa31da8a29437d947ebda4a3c5d">not_local_elements_begin</a> ();
<a name="l00165"></a>00165   element_iterator <a class="code" href="classSerialMesh.php#a46b38ffbf5cdeb44998591e08fdeb9ae">not_local_elements_end</a>   ();
<a name="l00166"></a>00166 
<a name="l00167"></a>00167   element_iterator <a class="code" href="classSerialMesh.php#ac4da916d2c22083a3d70f8f0d573221b">active_local_elements_begin</a> ();
<a name="l00168"></a>00168   element_iterator <a class="code" href="classSerialMesh.php#a36e35a25d8459c26b0ceaaec69685f54">active_local_elements_end</a>   ();
<a name="l00169"></a>00169 
<a name="l00170"></a>00170   element_iterator <a class="code" href="classSerialMesh.php#af27b7fbacb39cd4c529b190e2d077735">active_not_local_elements_begin</a> ();
<a name="l00171"></a>00171   element_iterator <a class="code" href="classSerialMesh.php#a641737155b1cd4ee63a79915b72b3ab5">active_not_local_elements_end</a>   ();
<a name="l00172"></a>00172 
<a name="l00173"></a>00173   element_iterator <a class="code" href="classSerialMesh.php#aad303dacf855b7389a70055b47beb58c">level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00174"></a>00174   element_iterator <a class="code" href="classSerialMesh.php#afdd301aec4eafae61bd51c77cda71ce1">level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00175"></a>00175 
<a name="l00176"></a>00176   element_iterator <a class="code" href="classSerialMesh.php#a0a2e90e3e71006e00f1620bb89f05c3c">not_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00177"></a>00177   element_iterator <a class="code" href="classSerialMesh.php#a52000464597a6e1817ab2caddcd35c31">not_level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00178"></a>00178 
<a name="l00179"></a>00179   element_iterator <a class="code" href="classSerialMesh.php#ad9bf5c5b0c4f106554a4de4b10dc245a">local_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00180"></a>00180   element_iterator <a class="code" href="classSerialMesh.php#a224e25a2dbd7b3fa3f15c3a546765c15">local_level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   element_iterator <a class="code" href="classSerialMesh.php#a1579603081551a029d75593d70c53639">local_not_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00183"></a>00183   element_iterator <a class="code" href="classSerialMesh.php#aac05f2f93297b9502b15a33ef57bff44">local_not_level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00184"></a>00184 
<a name="l00185"></a>00185   element_iterator <a class="code" href="classSerialMesh.php#a0118d9629bb3cfdfcdc777f647b26d7e">pid_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id);
<a name="l00186"></a>00186   element_iterator <a class="code" href="classSerialMesh.php#a2f55abadb9f07de78d2f3a860ae943f2">pid_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id);
<a name="l00187"></a>00187 
<a name="l00188"></a>00188   element_iterator <a class="code" href="classSerialMesh.php#a5a922373ffd9af8c1c70847016da3993">type_elements_begin</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00189"></a>00189   element_iterator <a class="code" href="classSerialMesh.php#adb49d8873927b20bf5f5432120344c80">type_elements_end</a>   (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00190"></a>00190 
<a name="l00191"></a>00191   element_iterator <a class="code" href="classSerialMesh.php#ad5459b6c4628624e940985317e21226a">active_type_elements_begin</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00192"></a>00192   element_iterator <a class="code" href="classSerialMesh.php#a1296b6e8d0cc2f4351ae8a27b38ac22c">active_type_elements_end</a>   (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00193"></a>00193 
<a name="l00194"></a>00194   element_iterator <a class="code" href="classSerialMesh.php#a21575e670b3102e00bc5d554d4446474">active_pid_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id);
<a name="l00195"></a>00195   element_iterator <a class="code" href="classSerialMesh.php#a96b8aa733bb8806ec860817922d4110f">active_pid_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id);
<a name="l00196"></a>00196 
<a name="l00197"></a>00197   element_iterator <a class="code" href="classSerialMesh.php#a1671451863b6dac372e369ddbc69fa18">unpartitioned_elements_begin</a> ();
<a name="l00198"></a>00198   element_iterator <a class="code" href="classSerialMesh.php#af8ea41e9393cfd9a82c00fadcbad608e">unpartitioned_elements_end</a> ();
<a name="l00199"></a>00199   
<a name="l00200"></a>00200   element_iterator <a class="code" href="classSerialMesh.php#ad0b7c24a6fb9e35dcd7b835f9d7e43ed">active_local_subdomain_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id);
<a name="l00201"></a>00201   element_iterator <a class="code" href="classSerialMesh.php#a487ec97b8f75e7df6634e1503ac97cbb">active_local_subdomain_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id);
<a name="l00202"></a>00202   
<a name="l00206"></a>00206   const_element_iterator <a class="code" href="classSerialMesh.php#aba5c567c53aa4d2444212089253820dc">elements_begin</a>() <span class="keyword">const</span>;
<a name="l00207"></a>00207   const_element_iterator <a class="code" href="classSerialMesh.php#aa489a38f160a9d4aed033fcaf59d61e0">elements_end</a>()   <span class="keyword">const</span>;
<a name="l00208"></a>00208   
<a name="l00209"></a>00209   const_element_iterator <a class="code" href="classSerialMesh.php#ab981af7e69906482a62b58c26ad400b4">active_elements_begin</a>() <span class="keyword">const</span>;
<a name="l00210"></a>00210   const_element_iterator <a class="code" href="classSerialMesh.php#aa1a47788c6a93e51631f9304f4127686">active_elements_end</a>()   <span class="keyword">const</span>;
<a name="l00211"></a>00211   
<a name="l00212"></a>00212   const_element_iterator <a class="code" href="classSerialMesh.php#ad38048645067d681b06a2010ebb72384">ancestor_elements_begin</a>() <span class="keyword">const</span>;
<a name="l00213"></a>00213   const_element_iterator <a class="code" href="classSerialMesh.php#a3e00f36cf9689ea418a0ee2742af1927">ancestor_elements_end</a>()   <span class="keyword">const</span>;
<a name="l00214"></a>00214   
<a name="l00215"></a>00215   const_element_iterator <a class="code" href="classSerialMesh.php#ae3a46e02b677315b39376cd87ddf7efd">subactive_elements_begin</a>() <span class="keyword">const</span>;
<a name="l00216"></a>00216   const_element_iterator <a class="code" href="classSerialMesh.php#a00e461844d3140da7c7357cf1f6c9945">subactive_elements_end</a>()   <span class="keyword">const</span>;
<a name="l00217"></a>00217   
<a name="l00218"></a>00218   const_element_iterator <a class="code" href="classSerialMesh.php#afe773bb7c94dea599510b1bbe502079e">not_active_elements_begin</a>() <span class="keyword">const</span>;
<a name="l00219"></a>00219   const_element_iterator <a class="code" href="classSerialMesh.php#a920700cacf7a3f56c115e482769642d9">not_active_elements_end</a>()   <span class="keyword">const</span>;
<a name="l00220"></a>00220 
<a name="l00221"></a>00221   const_element_iterator <a class="code" href="classSerialMesh.php#aab45695e4ff3ad683fdd51f36ebdd114">not_ancestor_elements_begin</a>() <span class="keyword">const</span>;
<a name="l00222"></a>00222   const_element_iterator <a class="code" href="classSerialMesh.php#a43eedd58799650308ede5c4c90a53391">not_ancestor_elements_end</a>()   <span class="keyword">const</span>;
<a name="l00223"></a>00223 
<a name="l00224"></a>00224   const_element_iterator <a class="code" href="classSerialMesh.php#ae365e10df6fee124830fc6588b154d35">not_subactive_elements_begin</a>() <span class="keyword">const</span>;
<a name="l00225"></a>00225   const_element_iterator <a class="code" href="classSerialMesh.php#a1af10fcc9fc67792210279c9d43d3c80">not_subactive_elements_end</a>()   <span class="keyword">const</span>;
<a name="l00226"></a>00226 
<a name="l00227"></a>00227   const_element_iterator <a class="code" href="classSerialMesh.php#a9c94fa5f85717ab508b233ffaae48c54">local_elements_begin</a> () <span class="keyword">const</span>;
<a name="l00228"></a>00228   const_element_iterator <a class="code" href="classSerialMesh.php#a2516b6a7c6b51d27f9258e97e22c76f6">local_elements_end</a>   () <span class="keyword">const</span>;
<a name="l00229"></a>00229 
<a name="l00230"></a>00230   const_element_iterator <a class="code" href="classSerialMesh.php#a5b690aa31da8a29437d947ebda4a3c5d">not_local_elements_begin</a> () <span class="keyword">const</span>;
<a name="l00231"></a>00231   const_element_iterator <a class="code" href="classSerialMesh.php#a46b38ffbf5cdeb44998591e08fdeb9ae">not_local_elements_end</a>   () <span class="keyword">const</span>;
<a name="l00232"></a>00232 
<a name="l00233"></a>00233   const_element_iterator <a class="code" href="classSerialMesh.php#ac4da916d2c22083a3d70f8f0d573221b">active_local_elements_begin</a> () <span class="keyword">const</span>;
<a name="l00234"></a>00234   const_element_iterator <a class="code" href="classSerialMesh.php#a36e35a25d8459c26b0ceaaec69685f54">active_local_elements_end</a>   () <span class="keyword">const</span>;
<a name="l00235"></a>00235 
<a name="l00236"></a>00236   const_element_iterator <a class="code" href="classSerialMesh.php#af27b7fbacb39cd4c529b190e2d077735">active_not_local_elements_begin</a> () <span class="keyword">const</span>;
<a name="l00237"></a>00237   const_element_iterator <a class="code" href="classSerialMesh.php#a641737155b1cd4ee63a79915b72b3ab5">active_not_local_elements_end</a>   () <span class="keyword">const</span>;
<a name="l00238"></a>00238 
<a name="l00239"></a>00239   const_element_iterator <a class="code" href="classSerialMesh.php#aad303dacf855b7389a70055b47beb58c">level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00240"></a>00240   const_element_iterator <a class="code" href="classSerialMesh.php#afdd301aec4eafae61bd51c77cda71ce1">level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00241"></a>00241 
<a name="l00242"></a>00242   const_element_iterator <a class="code" href="classSerialMesh.php#a0a2e90e3e71006e00f1620bb89f05c3c">not_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00243"></a>00243   const_element_iterator <a class="code" href="classSerialMesh.php#a52000464597a6e1817ab2caddcd35c31">not_level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00244"></a>00244 
<a name="l00245"></a>00245   const_element_iterator <a class="code" href="classSerialMesh.php#ad9bf5c5b0c4f106554a4de4b10dc245a">local_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00246"></a>00246   const_element_iterator <a class="code" href="classSerialMesh.php#a224e25a2dbd7b3fa3f15c3a546765c15">local_level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00247"></a>00247 
<a name="l00248"></a>00248   const_element_iterator <a class="code" href="classSerialMesh.php#a1579603081551a029d75593d70c53639">local_not_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00249"></a>00249   const_element_iterator <a class="code" href="classSerialMesh.php#aac05f2f93297b9502b15a33ef57bff44">local_not_level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00250"></a>00250 
<a name="l00251"></a>00251   const_element_iterator <a class="code" href="classSerialMesh.php#a0118d9629bb3cfdfcdc777f647b26d7e">pid_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span>;
<a name="l00252"></a>00252   const_element_iterator <a class="code" href="classSerialMesh.php#a2f55abadb9f07de78d2f3a860ae943f2">pid_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span>;
<a name="l00253"></a>00253 
<a name="l00254"></a>00254   const_element_iterator <a class="code" href="classSerialMesh.php#a5a922373ffd9af8c1c70847016da3993">type_elements_begin</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type) <span class="keyword">const</span>;
<a name="l00255"></a>00255   const_element_iterator <a class="code" href="classSerialMesh.php#adb49d8873927b20bf5f5432120344c80">type_elements_end</a>   (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type) <span class="keyword">const</span>;
<a name="l00256"></a>00256 
<a name="l00257"></a>00257   const_element_iterator <a class="code" href="classSerialMesh.php#ad5459b6c4628624e940985317e21226a">active_type_elements_begin</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type) <span class="keyword">const</span>;
<a name="l00258"></a>00258   const_element_iterator <a class="code" href="classSerialMesh.php#a1296b6e8d0cc2f4351ae8a27b38ac22c">active_type_elements_end</a>   (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type) <span class="keyword">const</span>;
<a name="l00259"></a>00259 
<a name="l00260"></a>00260   const_element_iterator <a class="code" href="classSerialMesh.php#a21575e670b3102e00bc5d554d4446474">active_pid_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span>;
<a name="l00261"></a>00261   const_element_iterator <a class="code" href="classSerialMesh.php#a96b8aa733bb8806ec860817922d4110f">active_pid_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span>;
<a name="l00262"></a>00262 
<a name="l00263"></a>00263   const_element_iterator <a class="code" href="classSerialMesh.php#a1671451863b6dac372e369ddbc69fa18">unpartitioned_elements_begin</a> () <span class="keyword">const</span>;
<a name="l00264"></a>00264   const_element_iterator <a class="code" href="classSerialMesh.php#af8ea41e9393cfd9a82c00fadcbad608e">unpartitioned_elements_end</a> () <span class="keyword">const</span>;
<a name="l00265"></a>00265   
<a name="l00266"></a>00266   const_element_iterator <a class="code" href="classSerialMesh.php#ad0b7c24a6fb9e35dcd7b835f9d7e43ed">active_local_subdomain_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id) <span class="keyword">const</span>;
<a name="l00267"></a>00267   const_element_iterator <a class="code" href="classSerialMesh.php#a487ec97b8f75e7df6634e1503ac97cbb">active_local_subdomain_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id) <span class="keyword">const</span>;
<a name="l00268"></a>00268   
<a name="l00269"></a>00269   
<a name="l00270"></a>00270   
<a name="l00271"></a>00271   
<a name="l00272"></a>00272   
<a name="l00273"></a>00273   
<a name="l00277"></a>00277   node_iterator <a class="code" href="classSerialMesh.php#afbd5a0087ae235df4f5c36125bd2affd">nodes_begin</a>();
<a name="l00278"></a>00278   node_iterator <a class="code" href="classSerialMesh.php#ac77535d9e6224fe96ef8937a503c89b4">nodes_end</a>();
<a name="l00279"></a>00279   
<a name="l00280"></a>00280   node_iterator <a class="code" href="classSerialMesh.php#a56a4371e9a9740396bebf663c819ed88">active_nodes_begin</a>();
<a name="l00281"></a>00281   node_iterator <a class="code" href="classSerialMesh.php#a8b31e6f0273331c2f97c93105b153b93">active_nodes_end</a>();
<a name="l00282"></a>00282 
<a name="l00283"></a>00283   node_iterator <a class="code" href="classSerialMesh.php#ae2701396622b4bf77e54f01feb61fcd7">local_nodes_begin</a>  ();
<a name="l00284"></a>00284   node_iterator <a class="code" href="classSerialMesh.php#abf93dbf571d96e1d7bebeaf6c835b824">local_nodes_end</a>    ();
<a name="l00285"></a>00285   
<a name="l00286"></a>00286   node_iterator <a class="code" href="classSerialMesh.php#a1cd00aa7fb0339c2da37db64a7fa7642">pid_nodes_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id);
<a name="l00287"></a>00287   node_iterator <a class="code" href="classSerialMesh.php#a8102a3dc5f4c303355b5b02cc60f1165">pid_nodes_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id);
<a name="l00288"></a>00288 
<a name="l00292"></a>00292   const_node_iterator <a class="code" href="classSerialMesh.php#afbd5a0087ae235df4f5c36125bd2affd">nodes_begin</a>() <span class="keyword">const</span>;
<a name="l00293"></a>00293   const_node_iterator <a class="code" href="classSerialMesh.php#ac77535d9e6224fe96ef8937a503c89b4">nodes_end</a>()   <span class="keyword">const</span>;
<a name="l00294"></a>00294 
<a name="l00295"></a>00295   const_node_iterator <a class="code" href="classSerialMesh.php#a56a4371e9a9740396bebf663c819ed88">active_nodes_begin</a>() <span class="keyword">const</span>;
<a name="l00296"></a>00296   const_node_iterator <a class="code" href="classSerialMesh.php#a8b31e6f0273331c2f97c93105b153b93">active_nodes_end</a>()   <span class="keyword">const</span>;
<a name="l00297"></a>00297 
<a name="l00298"></a>00298   const_node_iterator <a class="code" href="classSerialMesh.php#ae2701396622b4bf77e54f01feb61fcd7">local_nodes_begin</a>  () <span class="keyword">const</span>;
<a name="l00299"></a>00299   const_node_iterator <a class="code" href="classSerialMesh.php#abf93dbf571d96e1d7bebeaf6c835b824">local_nodes_end</a>    () <span class="keyword">const</span>;
<a name="l00300"></a>00300 
<a name="l00301"></a>00301   const_node_iterator <a class="code" href="classSerialMesh.php#a1cd00aa7fb0339c2da37db64a7fa7642">pid_nodes_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span>;
<a name="l00302"></a>00302   const_node_iterator <a class="code" href="classSerialMesh.php#a8102a3dc5f4c303355b5b02cc60f1165">pid_nodes_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span>;
<a name="l00303"></a>00303   
<a name="l00304"></a>00304 <span class="keyword">protected</span>:
<a name="l00308"></a><a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">00308</a>   std::vector&lt;Node*&gt; <a class="code" href="classSerialMesh.php#ae85db50b023e5950dcafb20da2f1578b">_nodes</a>;
<a name="l00309"></a>00309   
<a name="l00313"></a><a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">00313</a>   std::vector&lt;Elem*&gt; <a class="code" href="classSerialMesh.php#aa9818efdffad6dbd52ca09c0ad99a259">_elements</a>;
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 <span class="keyword">private</span>:
<a name="l00316"></a>00316   
<a name="l00321"></a><a class="code" href="classSerialMesh.php#afa7b83d4c925a5847a71cffdb82750b3">00321</a>   <span class="keyword">typedef</span> std::vector&lt;Elem*&gt;::iterator             <a class="code" href="classSerialMesh.php#afa7b83d4c925a5847a71cffdb82750b3">elem_iterator_imp</a>;
<a name="l00322"></a><a class="code" href="classSerialMesh.php#a2e9c2df379968c10d2e0f50de5f85d63">00322</a>   <span class="keyword">typedef</span> std::vector&lt;Elem*&gt;::const_iterator <a class="code" href="classSerialMesh.php#a2e9c2df379968c10d2e0f50de5f85d63">const_elem_iterator_imp</a>;
<a name="l00323"></a>00323 
<a name="l00328"></a><a class="code" href="classSerialMesh.php#a8ad349cbb3dbfed4eae0eb3aadc2c6e6">00328</a>   <span class="keyword">typedef</span> std::vector&lt;Node*&gt;::iterator             <a class="code" href="classSerialMesh.php#a8ad349cbb3dbfed4eae0eb3aadc2c6e6">node_iterator_imp</a>;
<a name="l00329"></a><a class="code" href="classSerialMesh.php#a71ba78dc735ff5d1572d0c6c33664758">00329</a>   <span class="keyword">typedef</span> std::vector&lt;Node*&gt;::const_iterator <a class="code" href="classSerialMesh.php#a71ba78dc735ff5d1572d0c6c33664758">const_node_iterator_imp</a>;
<a name="l00330"></a>00330 };
<a name="l00331"></a>00331 
<a name="l00332"></a>00332 
<a name="l00333"></a>00333 
<a name="l00334"></a>00334 
<a name="l00335"></a>00335 
<a name="l00336"></a>00336 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
