<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>shell_matrix.h</h1>  </div>
</div>
<div class="contents">
<a href="shell__matrix_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: shell_matrix.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __shell_matrix_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __shell_matrix_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;reference_counted_object.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh.h&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// forward declarations</span>
<a name="l00032"></a>00032 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classNumericVector.php">NumericVector</a>;
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00043"></a>00043 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00044"></a><a class="code" href="classShellMatrix.php">00044</a> <span class="keyword">class </span><a class="code" href="classShellMatrix.php">ShellMatrix</a> : <span class="keyword">public</span> <a class="code" href="classReferenceCountedObject.php">ReferenceCountedObject</a>&lt;ShellMatrix&lt;T&gt; &gt;
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046 <span class="keyword">public</span>:
<a name="l00050"></a>00050   <a class="code" href="classShellMatrix.php#ab074ff88931097c86bc79cb46c7650b7">ShellMatrix</a> ();
<a name="l00051"></a>00051 
<a name="l00055"></a>00055   <span class="keyword">virtual</span> <a class="code" href="classShellMatrix.php#a6b6c99ebdda436d1f49ab84d76e0faa7">~ShellMatrix</a> ();
<a name="l00056"></a>00056 
<a name="l00061"></a>00061   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classShellMatrix.php#a3668dcbba190238a7d20f4f108f499ab">m</a> () <span class="keyword">const</span> = 0;
<a name="l00062"></a>00062 
<a name="l00067"></a>00067   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classShellMatrix.php#a27660c46051ae5cbb64a19a85a012ab9">n</a> () <span class="keyword">const</span> = 0;
<a name="l00068"></a>00068 
<a name="l00073"></a>00073   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classShellMatrix.php#ad947169bcd199cd56f99b21e78cbb21a">vector_mult</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest,
<a name="l00074"></a>00074                             <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; arg) <span class="keyword">const</span> = 0;
<a name="l00075"></a>00075 
<a name="l00079"></a>00079   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classShellMatrix.php#a66ae1b9b063ffa4b589e0759bbba826d">vector_mult_add</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest,
<a name="l00080"></a>00080                                 <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; arg) <span class="keyword">const</span> = 0;
<a name="l00081"></a>00081 
<a name="l00085"></a>00085   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classShellMatrix.php#a30afa0fc718c1549044d05087a0a92db">get_diagonal</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span> = 0;
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 };
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00092"></a>00092 <span class="comment">// ShellMatrix inline members</span>
<a name="l00093"></a>00093 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00094"></a>00094 <span class="keyword">inline</span>
<a name="l00095"></a><a class="code" href="classShellMatrix.php#ab074ff88931097c86bc79cb46c7650b7">00095</a> <a class="code" href="classShellMatrix.php#ab074ff88931097c86bc79cb46c7650b7">ShellMatrix&lt;T&gt;::ShellMatrix</a> ()
<a name="l00096"></a>00096 {}
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00101"></a>00101 <span class="keyword">inline</span>
<a name="l00102"></a><a class="code" href="classShellMatrix.php#a6b6c99ebdda436d1f49ab84d76e0faa7">00102</a> <a class="code" href="classShellMatrix.php#a6b6c99ebdda436d1f49ab84d76e0faa7">ShellMatrix&lt;T&gt;::~ShellMatrix</a> ()
<a name="l00103"></a>00103 {}
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 <span class="preprocessor">#endif // #ifndef __shell_matrix_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
