<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>side.h</h1>  </div>
</div>
<div class="contents">
<a href="side_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: side.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __side_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __side_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Forward declarations</span>
<a name="l00032"></a>00032 <span class="keyword">class </span><a class="code" href="classPoint.php">Point</a>;
<a name="l00033"></a>00033 <span class="keyword">class </span><a class="code" href="classNode.php">Node</a>;
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00050"></a>00050 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00051"></a>00051 <span class="comment">//Side class definition</span>
<a name="l00052"></a>00052 <span class="keyword">template</span> &lt;<span class="keyword">class</span> S<span class="keywordtype">id</span>eType, <span class="keyword">class</span> ParentType&gt;
<a name="l00053"></a><a class="code" href="classSide.php">00053</a> <span class="keyword">class </span><a class="code" href="classSide.php">Side</a> : <span class="keyword">public</span> SideType
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055  <span class="keyword">public</span>:
<a name="l00056"></a>00056 
<a name="l00060"></a><a class="code" href="classSide.php#a740e8f731623bb7fb7035769fc757ff4">00060</a>   <a class="code" href="classSide.php#a740e8f731623bb7fb7035769fc757ff4">Side</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* parent,
<a name="l00061"></a>00061         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> side) :
<a name="l00062"></a>00062     SideType(0,0,const_cast&lt;<a class="code" href="classElem.php">Elem</a>*&gt;(parent)), <span class="comment">// Allocate no storage for nodes or neighbors!</span>
<a name="l00063"></a>00063     <a class="code" href="classSide.php#a885fed244f107757f0ee635a077fe8fa">_side_number</a>(side)
<a name="l00064"></a>00064   {
<a name="l00065"></a>00065     libmesh_assert (parent != NULL);
<a name="l00066"></a>00066     <span class="comment">// may not be true when building infinite element sides</span>
<a name="l00067"></a>00067     <span class="comment">// libmesh_assert (_side_number &lt; this-&gt;parent()-&gt;n_sides());</span>
<a name="l00068"></a>00068     libmesh_assert ((this-&gt;dim()+1) == this-&gt;parent()-&gt;dim());
<a name="l00069"></a>00069   }
<a name="l00070"></a>00070 
<a name="l00074"></a><a class="code" href="classSide.php#a3d4c448a3fe0167b8d619981b4f7c701">00074</a>   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> &amp; <a class="code" href="classSide.php#a3d4c448a3fe0167b8d619981b4f7c701">point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00075"></a>00075 <span class="keyword">  </span>{
<a name="l00076"></a>00076     libmesh_assert (i &lt; this-&gt;<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>());    
<a name="l00077"></a>00077     <span class="keywordflow">return</span> this-&gt;parent()-&gt;point (ParentType::side_nodes_map[<a class="code" href="classSide.php#a885fed244f107757f0ee635a077fe8fa">_side_number</a>][i]);
<a name="l00078"></a>00078   }
<a name="l00079"></a>00079  
<a name="l00084"></a><a class="code" href="classSide.php#ac2da16de445ca747820b01115843c9d7">00084</a>   <span class="keyword">virtual</span> <a class="code" href="classPoint.php">Point</a> &amp; <a class="code" href="classSide.php#a3d4c448a3fe0167b8d619981b4f7c701">point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00085"></a>00085   {
<a name="l00086"></a>00086     libmesh_assert (i &lt; this-&gt;<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>());
<a name="l00087"></a>00087     <span class="keywordflow">return</span> this-&gt;parent()-&gt;point (ParentType::side_nodes_map[<a class="code" href="classSide.php#a885fed244f107757f0ee635a077fe8fa">_side_number</a>][i]);
<a name="l00088"></a>00088   }
<a name="l00089"></a>00089   
<a name="l00093"></a><a class="code" href="classSide.php#a3f73110f5072962c10415e5afbd54c21">00093</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSide.php#a3f73110f5072962c10415e5afbd54c21">node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00094"></a>00094 <span class="keyword">  </span>{
<a name="l00095"></a>00095     libmesh_assert (i &lt; this-&gt;<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>());
<a name="l00096"></a>00096     <span class="keywordflow">return</span> this-&gt;parent()-&gt;node (ParentType::side_nodes_map[<a class="code" href="classSide.php#a885fed244f107757f0ee635a077fe8fa">_side_number</a>][i]);  
<a name="l00097"></a>00097   }
<a name="l00098"></a>00098 
<a name="l00102"></a><a class="code" href="classSide.php#aa41d4e8527fed43009825bf3fe6ee723">00102</a>   <span class="keyword">virtual</span> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classSide.php#aa41d4e8527fed43009825bf3fe6ee723">get_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00103"></a>00103 <span class="keyword">  </span>{
<a name="l00104"></a>00104     libmesh_assert (i &lt; this-&gt;<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>());    
<a name="l00105"></a>00105     <span class="keywordflow">return</span> this-&gt;parent()-&gt;get_node (ParentType::side_nodes_map[<a class="code" href="classSide.php#a885fed244f107757f0ee635a077fe8fa">_side_number</a>][i]);
<a name="l00106"></a>00106   }
<a name="l00107"></a>00107 
<a name="l00111"></a><a class="code" href="classSide.php#a3ff11176fea2f4acd32da701c02df07d">00111</a>   <span class="keyword">virtual</span> <a class="code" href="classNode.php">Node</a>* &amp; <a class="code" href="classSide.php#a3ff11176fea2f4acd32da701c02df07d">set_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00112"></a>00112   {
<a name="l00113"></a>00113     libmesh_assert (i &lt; this-&gt;<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>());    
<a name="l00114"></a>00114     <span class="keywordflow">return</span> this-&gt;parent()-&gt;set_node (ParentType::side_nodes_map[<a class="code" href="classSide.php#a885fed244f107757f0ee635a077fe8fa">_side_number</a>][i]);
<a name="l00115"></a>00115   }
<a name="l00116"></a>00116 
<a name="l00120"></a><a class="code" href="classSide.php#a5abd7abcacecdac8b1d0b065162e9364">00120</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSide.php#a5abd7abcacecdac8b1d0b065162e9364">n_sides</a> ()<span class="keyword"> const </span>
<a name="l00121"></a>00121 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> 0; }
<a name="l00122"></a>00122 
<a name="l00123"></a><a class="code" href="classSide.php#a8b0dfc7ec79a08bf8b3f0ae308575751">00123</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classSide.php#a8b0dfc7ec79a08bf8b3f0ae308575751">is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00124"></a>00124                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00125"></a>00125 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00126"></a>00126   
<a name="l00127"></a>00127   
<a name="l00128"></a>00128  <span class="keyword">private</span>:
<a name="l00129"></a>00129 
<a name="l00130"></a>00130   
<a name="l00134"></a><a class="code" href="classSide.php#a885fed244f107757f0ee635a077fe8fa">00134</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSide.php#a885fed244f107757f0ee635a077fe8fa">_side_number</a>;
<a name="l00135"></a>00135 };
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00152"></a>00152 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00153"></a>00153 <span class="comment">//SideEdge class definition</span>
<a name="l00154"></a>00154 <span class="keyword">template</span> &lt;<span class="keyword">class</span> EdgeType, <span class="keyword">class</span> ParentType&gt;
<a name="l00155"></a><a class="code" href="classSideEdge.php">00155</a> <span class="keyword">class </span><a class="code" href="classSideEdge.php">SideEdge</a> : <span class="keyword">public</span> EdgeType
<a name="l00156"></a>00156 {
<a name="l00157"></a>00157  <span class="keyword">public</span>:
<a name="l00158"></a>00158 
<a name="l00162"></a><a class="code" href="classSideEdge.php#a9d9938ca43bc6c0e7598cbe0223af578">00162</a>   <a class="code" href="classSideEdge.php#a9d9938ca43bc6c0e7598cbe0223af578">SideEdge</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* parent,
<a name="l00163"></a>00163             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> edge) :
<a name="l00164"></a>00164     EdgeType(0,0,const_cast&lt;<a class="code" href="classElem.php">Elem</a>*&gt;(parent)), <span class="comment">// Allocate no storage for nodes or neighbors!</span>
<a name="l00165"></a>00165     <a class="code" href="classSideEdge.php#ae9e582cb4418b10d319822a7637cc554">_edge_number</a>(edge)
<a name="l00166"></a>00166   {
<a name="l00167"></a>00167     libmesh_assert (parent != NULL);
<a name="l00168"></a>00168     libmesh_assert (_edge_number &lt; this-&gt;parent()-&gt;n_edges());
<a name="l00169"></a>00169     libmesh_assert (this-&gt;dim() == 1);
<a name="l00170"></a>00170   }
<a name="l00171"></a>00171 
<a name="l00175"></a><a class="code" href="classSideEdge.php#a1865398f57cf543b5cab9ce404b12769">00175</a>   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> &amp; <a class="code" href="classSideEdge.php#a1865398f57cf543b5cab9ce404b12769">point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00176"></a>00176 <span class="keyword">  </span>{
<a name="l00177"></a>00177     libmesh_assert (i &lt; this-&gt;<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>());    
<a name="l00178"></a>00178     <span class="keywordflow">return</span> this-&gt;parent()-&gt;point (ParentType::edge_nodes_map[<a class="code" href="classSideEdge.php#ae9e582cb4418b10d319822a7637cc554">_edge_number</a>][i]);
<a name="l00179"></a>00179   }
<a name="l00180"></a>00180  
<a name="l00185"></a><a class="code" href="classSideEdge.php#aa6d45027d6e0d72e6e78f6e670fb4949">00185</a>   <span class="keyword">virtual</span> <a class="code" href="classPoint.php">Point</a> &amp; <a class="code" href="classSideEdge.php#a1865398f57cf543b5cab9ce404b12769">point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00186"></a>00186   {
<a name="l00187"></a>00187     libmesh_assert (i &lt; this-&gt;<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>());
<a name="l00188"></a>00188     <span class="keywordflow">return</span> this-&gt;parent()-&gt;point (ParentType::edge_nodes_map[<a class="code" href="classSideEdge.php#ae9e582cb4418b10d319822a7637cc554">_edge_number</a>][i]);
<a name="l00189"></a>00189   }
<a name="l00190"></a>00190   
<a name="l00194"></a><a class="code" href="classSideEdge.php#a295869abe65da3d2873368e55afe5e66">00194</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSideEdge.php#a295869abe65da3d2873368e55afe5e66">node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00195"></a>00195 <span class="keyword">  </span>{
<a name="l00196"></a>00196     libmesh_assert (i &lt; this-&gt;<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>());
<a name="l00197"></a>00197     <span class="keywordflow">return</span> this-&gt;parent()-&gt;node (ParentType::edge_nodes_map[<a class="code" href="classSideEdge.php#ae9e582cb4418b10d319822a7637cc554">_edge_number</a>][i]);  
<a name="l00198"></a>00198   }
<a name="l00199"></a>00199 
<a name="l00203"></a><a class="code" href="classSideEdge.php#ac9a2ac8c8c5bfec938265a9cdf6dc3cc">00203</a>   <span class="keyword">virtual</span> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classSideEdge.php#ac9a2ac8c8c5bfec938265a9cdf6dc3cc">get_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00204"></a>00204 <span class="keyword">  </span>{
<a name="l00205"></a>00205     libmesh_assert (i &lt; this-&gt;<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>());    
<a name="l00206"></a>00206     <span class="keywordflow">return</span> this-&gt;parent()-&gt;get_node (ParentType::edge_nodes_map[<a class="code" href="classSideEdge.php#ae9e582cb4418b10d319822a7637cc554">_edge_number</a>][i]);
<a name="l00207"></a>00207   }
<a name="l00208"></a>00208 
<a name="l00212"></a><a class="code" href="classSideEdge.php#a01a2776b2429f1deec40c714a30f0bf9">00212</a>   <span class="keyword">virtual</span> <a class="code" href="classNode.php">Node</a>* &amp; <a class="code" href="classSideEdge.php#a01a2776b2429f1deec40c714a30f0bf9">set_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00213"></a>00213   {
<a name="l00214"></a>00214     libmesh_assert (i &lt; this-&gt;<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>());    
<a name="l00215"></a>00215     <span class="keywordflow">return</span> this-&gt;parent()-&gt;set_node (ParentType::edge_nodes_map[<a class="code" href="classSideEdge.php#ae9e582cb4418b10d319822a7637cc554">_edge_number</a>][i]);
<a name="l00216"></a>00216   }
<a name="l00217"></a>00217 
<a name="l00222"></a><a class="code" href="classSideEdge.php#af44663fcb6ec4b45dca223a955853f7a">00222</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSideEdge.php#af44663fcb6ec4b45dca223a955853f7a">n_sides</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; }
<a name="l00223"></a>00223 
<a name="l00224"></a>00224   
<a name="l00225"></a>00225  <span class="keyword">private</span>:
<a name="l00226"></a>00226 
<a name="l00227"></a>00227   
<a name="l00231"></a><a class="code" href="classSideEdge.php#ae9e582cb4418b10d319822a7637cc554">00231</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSideEdge.php#ae9e582cb4418b10d319822a7637cc554">_edge_number</a>;
<a name="l00232"></a>00232 };
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 <span class="preprocessor">#endif // end #ifndef __side_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
