<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_a444518d96d2df902338d2a7eb3a040c.php">base</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>single_predicates.h</h1>  </div>
</div>
<div class="contents">
<a href="single__predicates_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: single_predicates.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __single_predicates_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __single_predicates_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;enum_elem_type.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="id__types_8h.php">id_types.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Predicates
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039   <span class="comment">// Forward declaration</span>
<a name="l00040"></a>00040   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>abstract_multi_predicate;
<a name="l00041"></a>00041   
<a name="l00042"></a>00042   <span class="comment">// abstract single predicate.  Derived classes must implement the clone()</span>
<a name="l00043"></a>00043   <span class="comment">// function.  Be careful using it since it allocates memory!  The clone()</span>
<a name="l00044"></a>00044   <span class="comment">// function is necessary since the predicate class has pure virtual</span>
<a name="l00045"></a>00045   <span class="comment">// functions.</span>
<a name="l00046"></a>00046   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00047"></a><a class="code" href="structPredicates_1_1predicate.php">00047</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1predicate.php">predicate</a>
<a name="l00048"></a>00048   {
<a name="l00049"></a><a class="code" href="structPredicates_1_1predicate.php#a3f698cafd5e66528e3fc725095688e3d">00049</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1predicate.php#a3f698cafd5e66528e3fc725095688e3d">~predicate</a>() {}
<a name="l00050"></a>00050     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structPredicates_1_1predicate.php#ac61b7d0112eb5c33e3e9d27c34ce8f45">operator()</a>(<span class="keyword">const</span> T&amp; it) <span class="keyword">const</span> = 0;
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   <span class="keyword">protected</span>:
<a name="l00054"></a><a class="code" href="structPredicates_1_1predicate.php#abda0f718f2b5dd6de03d6bf20356697a">00054</a>     <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="structPredicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;;
<a name="l00055"></a>00055     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1predicate.php">predicate</a>* <a class="code" href="structPredicates_1_1predicate.php#a8724fa9e613f23a2d10ab3ec3f93fd73">clone</a>() <span class="keyword">const</span> = 0;
<a name="l00056"></a>00056 
<a name="l00057"></a>00057   };
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 
<a name="l00060"></a>00060   <span class="comment">// The is_null predicate returns true if the underlying pointer is NULL.</span>
<a name="l00061"></a>00061   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00062"></a><a class="code" href="structPredicates_1_1is__null.php">00062</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1is__null.php">is_null</a> : <a class="code" href="structPredicates_1_1predicate.php">predicate</a>&lt;T&gt;
<a name="l00063"></a>00063   {
<a name="l00064"></a><a class="code" href="structPredicates_1_1is__null.php#af7f31c0f311ee1860d7200e2ad569cd9">00064</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1is__null.php#af7f31c0f311ee1860d7200e2ad569cd9">~is_null</a>() {}
<a name="l00065"></a><a class="code" href="structPredicates_1_1is__null.php#a81f6a3e8b2fbcf0c3f7988f34dfa4bb3">00065</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structPredicates_1_1is__null.php#a81f6a3e8b2fbcf0c3f7988f34dfa4bb3">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> *it == NULL; }
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   <span class="keyword">protected</span>:
<a name="l00068"></a><a class="code" href="structPredicates_1_1is__null.php#ab3d369fe9811e9b5a17dfafed831fef3">00068</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structPredicates_1_1is__null.php#ab3d369fe9811e9b5a17dfafed831fef3">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structPredicates_1_1is__null.php">is_null&lt;T&gt;</a>(*this); }
<a name="l00069"></a>00069   };
<a name="l00070"></a>00070   
<a name="l00071"></a>00071   <span class="comment">// The not_null predicate simply returns true if the pointer is not NULL.</span>
<a name="l00072"></a>00072   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00073"></a><a class="code" href="structPredicates_1_1not__null.php">00073</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1not__null.php">not_null</a> : <a class="code" href="structPredicates_1_1is__null.php">is_null</a>&lt;T&gt;
<a name="l00074"></a>00074   {
<a name="l00075"></a><a class="code" href="structPredicates_1_1not__null.php#a8d77e2815e356cd975545a5657f21677">00075</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structPredicates_1_1not__null.php#a8d77e2815e356cd975545a5657f21677">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> !<a class="code" href="structPredicates_1_1not__null.php#a8d77e2815e356cd975545a5657f21677">is_null&lt;T&gt;::operator()</a>(it); }
<a name="l00076"></a>00076 
<a name="l00077"></a>00077   <span class="keyword">protected</span>:
<a name="l00078"></a><a class="code" href="structPredicates_1_1not__null.php#a729c6b081247891372bc7862ff340124">00078</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structPredicates_1_1not__null.php#a729c6b081247891372bc7862ff340124">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__null.php">not_null&lt;T&gt;</a>(*this); }
<a name="l00079"></a>00079   };
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   <span class="comment">// The active predicate returns true if the pointer is active.</span>
<a name="l00083"></a>00083   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00084"></a><a class="code" href="structPredicates_1_1active.php">00084</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1active.php">active</a> : <a class="code" href="structPredicates_1_1predicate.php">predicate</a>&lt;T&gt;
<a name="l00085"></a>00085   {
<a name="l00086"></a><a class="code" href="structPredicates_1_1active.php#aff577ba3781bfc753117a4c3d6452701">00086</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1active.php#aff577ba3781bfc753117a4c3d6452701">~active</a>() {}
<a name="l00087"></a><a class="code" href="structPredicates_1_1active.php#a90dad596ef2443cef28778b7e8a9ab2a">00087</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structPredicates_1_1active.php#a90dad596ef2443cef28778b7e8a9ab2a">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (*it)-&gt;active(); }
<a name="l00088"></a>00088     
<a name="l00089"></a>00089   <span class="keyword">protected</span>:
<a name="l00090"></a><a class="code" href="structPredicates_1_1active.php#a2756de4291c5486df5210dde105ac54b">00090</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structPredicates_1_1active.php#a2756de4291c5486df5210dde105ac54b">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structPredicates_1_1active.php">active&lt;T&gt;</a>(*this); }
<a name="l00091"></a>00091   };
<a name="l00092"></a>00092 
<a name="l00093"></a>00093   <span class="comment">// The not active predicate returns true when the pointer is inactive</span>
<a name="l00094"></a>00094   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00095"></a><a class="code" href="structPredicates_1_1not__active.php">00095</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1not__active.php">not_active</a> : <a class="code" href="structPredicates_1_1active.php">active</a>&lt;T&gt;
<a name="l00096"></a>00096   {
<a name="l00097"></a><a class="code" href="structPredicates_1_1not__active.php#a96fec0d59cab23d221e877b75f8147d3">00097</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structPredicates_1_1not__active.php#a96fec0d59cab23d221e877b75f8147d3">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> !<a class="code" href="structPredicates_1_1not__active.php#a96fec0d59cab23d221e877b75f8147d3">active&lt;T&gt;::operator()</a>(it); }
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   <span class="keyword">protected</span>:
<a name="l00100"></a><a class="code" href="structPredicates_1_1not__active.php#a837358b9e975d0a75f7b9ad1b1ae3ca3">00100</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structPredicates_1_1not__active.php#a837358b9e975d0a75f7b9ad1b1ae3ca3">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__active.php">not_active&lt;T&gt;</a>(*this); }
<a name="l00101"></a>00101   };
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="comment">// The ancestor predicate returns true if the pointer is ancestor.</span>
<a name="l00105"></a>00105   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00106"></a><a class="code" href="structPredicates_1_1ancestor.php">00106</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1ancestor.php">ancestor</a> : <a class="code" href="structPredicates_1_1predicate.php">predicate</a>&lt;T&gt;
<a name="l00107"></a>00107   {
<a name="l00108"></a><a class="code" href="structPredicates_1_1ancestor.php#a6efccd99c945fab8cf43b34035cc2b65">00108</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1ancestor.php#a6efccd99c945fab8cf43b34035cc2b65">~ancestor</a>() {}
<a name="l00109"></a><a class="code" href="structPredicates_1_1ancestor.php#a98e3642297f2e0c11e3da93ddd14a412">00109</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structPredicates_1_1ancestor.php#a98e3642297f2e0c11e3da93ddd14a412">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (*it)-&gt;ancestor(); }
<a name="l00110"></a>00110     
<a name="l00111"></a>00111   <span class="keyword">protected</span>:
<a name="l00112"></a><a class="code" href="structPredicates_1_1ancestor.php#a3953e26f736637f613f089a53e807569">00112</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structPredicates_1_1ancestor.php#a3953e26f736637f613f089a53e807569">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structPredicates_1_1ancestor.php">ancestor&lt;T&gt;</a>(*this); }
<a name="l00113"></a>00113   };
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   <span class="comment">// The not_ancestor predicate returns true when the pointer is not ancestor</span>
<a name="l00116"></a>00116   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00117"></a><a class="code" href="structPredicates_1_1not__ancestor.php">00117</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1not__ancestor.php">not_ancestor</a> : <a class="code" href="structPredicates_1_1ancestor.php">ancestor</a>&lt;T&gt;
<a name="l00118"></a>00118   {
<a name="l00119"></a><a class="code" href="structPredicates_1_1not__ancestor.php#afa6a2fa7acdc9de2b0769e6e79d32f27">00119</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structPredicates_1_1not__ancestor.php#afa6a2fa7acdc9de2b0769e6e79d32f27">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> !<a class="code" href="structPredicates_1_1not__ancestor.php#afa6a2fa7acdc9de2b0769e6e79d32f27">ancestor&lt;T&gt;::operator()</a>(it); }
<a name="l00120"></a>00120 
<a name="l00121"></a>00121   <span class="keyword">protected</span>:
<a name="l00122"></a><a class="code" href="structPredicates_1_1not__ancestor.php#aaec4115f343e837d652270ea8ae5e9b9">00122</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structPredicates_1_1not__ancestor.php#aaec4115f343e837d652270ea8ae5e9b9">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__ancestor.php">not_ancestor&lt;T&gt;</a>(*this); }
<a name="l00123"></a>00123   };
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   <span class="comment">// The subactive predicate returns true if the pointer is subactive.</span>
<a name="l00127"></a>00127   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00128"></a><a class="code" href="structPredicates_1_1subactive.php">00128</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1subactive.php">subactive</a> : <a class="code" href="structPredicates_1_1predicate.php">predicate</a>&lt;T&gt;
<a name="l00129"></a>00129   {
<a name="l00130"></a><a class="code" href="structPredicates_1_1subactive.php#a03a0d16648a04ee67b3b93c7acfeaf11">00130</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1subactive.php#a03a0d16648a04ee67b3b93c7acfeaf11">~subactive</a>() {}
<a name="l00131"></a><a class="code" href="structPredicates_1_1subactive.php#a8cdfdbd06745def6d05110906fce7dbf">00131</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structPredicates_1_1subactive.php#a8cdfdbd06745def6d05110906fce7dbf">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (*it)-&gt;subactive(); }
<a name="l00132"></a>00132     
<a name="l00133"></a>00133   <span class="keyword">protected</span>:
<a name="l00134"></a><a class="code" href="structPredicates_1_1subactive.php#a6ced4fa6165c424fd3680f5fcdade40e">00134</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structPredicates_1_1subactive.php#a6ced4fa6165c424fd3680f5fcdade40e">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structPredicates_1_1subactive.php">subactive&lt;T&gt;</a>(*this); }
<a name="l00135"></a>00135   };
<a name="l00136"></a>00136 
<a name="l00137"></a>00137   <span class="comment">// The not_subactive predicate returns true when the pointer is not subactive</span>
<a name="l00138"></a>00138   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00139"></a><a class="code" href="structPredicates_1_1not__subactive.php">00139</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1not__subactive.php">not_subactive</a> : <a class="code" href="structPredicates_1_1subactive.php">subactive</a>&lt;T&gt;
<a name="l00140"></a>00140   {
<a name="l00141"></a><a class="code" href="structPredicates_1_1not__subactive.php#af9ada7921e3ec36956c1a39c3ba7cef8">00141</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structPredicates_1_1not__subactive.php#af9ada7921e3ec36956c1a39c3ba7cef8">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> !<a class="code" href="structPredicates_1_1not__subactive.php#af9ada7921e3ec36956c1a39c3ba7cef8">subactive&lt;T&gt;::operator()</a>(it); }
<a name="l00142"></a>00142 
<a name="l00143"></a>00143   <span class="keyword">protected</span>:
<a name="l00144"></a><a class="code" href="structPredicates_1_1not__subactive.php#ae37b3206699125d52d47c3b4ab2641a9">00144</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structPredicates_1_1not__subactive.php#ae37b3206699125d52d47c3b4ab2641a9">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__subactive.php">not_subactive&lt;T&gt;</a>(*this); }
<a name="l00145"></a>00145   };
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   <span class="comment">// The pid predicate returns true if the pointers</span>
<a name="l00150"></a>00150   <span class="comment">// processor id matches a given processor id.</span>
<a name="l00151"></a>00151   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00152"></a><a class="code" href="structPredicates_1_1pid.php">00152</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1pid.php">pid</a> : <a class="code" href="structPredicates_1_1predicate.php">predicate</a>&lt;T&gt;
<a name="l00153"></a>00153   {
<a name="l00154"></a>00154     <span class="comment">// Constructor</span>
<a name="l00155"></a><a class="code" href="structPredicates_1_1pid.php#a6945f3b91df2390953d98939066f3f4f">00155</a>     <a class="code" href="structPredicates_1_1pid.php#a6945f3b91df2390953d98939066f3f4f">pid</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p) : <a class="code" href="structPredicates_1_1pid.php#a82b7a9f26d6d1e3c4def8677c671e7d4">_pid</a>(p) {}
<a name="l00156"></a><a class="code" href="structPredicates_1_1pid.php#a22ba3d927f30167602a3f485741ecc23">00156</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1pid.php#a22ba3d927f30167602a3f485741ecc23">~pid</a>() {}
<a name="l00157"></a>00157 
<a name="l00158"></a>00158     <span class="comment">// op()</span>
<a name="l00159"></a><a class="code" href="structPredicates_1_1pid.php#a2fb3a559a548d60eabffcf3aa777c462">00159</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structPredicates_1_1pid.php#a2fb3a559a548d60eabffcf3aa777c462">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (*it)-&gt;processor_id() == <a class="code" href="structPredicates_1_1pid.php#a82b7a9f26d6d1e3c4def8677c671e7d4">_pid</a>; }
<a name="l00160"></a>00160     
<a name="l00161"></a>00161   <span class="keyword">protected</span>:
<a name="l00162"></a><a class="code" href="structPredicates_1_1pid.php#a5a5ab144eee4695646b6f4f015a526c0">00162</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structPredicates_1_1pid.php#a5a5ab144eee4695646b6f4f015a526c0">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structPredicates_1_1pid.php">pid&lt;T&gt;</a>(*this); }
<a name="l00163"></a><a class="code" href="structPredicates_1_1pid.php#a82b7a9f26d6d1e3c4def8677c671e7d4">00163</a>     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="structPredicates_1_1pid.php#a82b7a9f26d6d1e3c4def8677c671e7d4">_pid</a>;
<a name="l00164"></a>00164   };
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00167"></a>00167   
<a name="l00168"></a>00168   <span class="comment">// The not_pid predicate returns ture if the pointers</span>
<a name="l00169"></a>00169   <span class="comment">// processor id does _not_ match p.</span>
<a name="l00170"></a>00170   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00171"></a><a class="code" href="structPredicates_1_1not__pid.php">00171</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1not__pid.php">not_pid</a> : <a class="code" href="structPredicates_1_1pid.php">pid</a>&lt;T&gt;
<a name="l00172"></a>00172   {
<a name="l00173"></a><a class="code" href="structPredicates_1_1not__pid.php#ac85683f4e54fff679d268743cf5880ff">00173</a>     <a class="code" href="structPredicates_1_1not__pid.php#ac85683f4e54fff679d268743cf5880ff">not_pid</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p) : <a class="code" href="structPredicates_1_1pid.php">pid</a>&lt;T&gt;(p) {}
<a name="l00174"></a>00174 
<a name="l00175"></a><a class="code" href="structPredicates_1_1not__pid.php#aeac27708e7e88116c11e22d350fdced3">00175</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structPredicates_1_1not__pid.php#aeac27708e7e88116c11e22d350fdced3">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> !<a class="code" href="structPredicates_1_1not__pid.php#aeac27708e7e88116c11e22d350fdced3">pid&lt;T&gt;::operator()</a>(it); }
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   <span class="keyword">protected</span>:
<a name="l00178"></a><a class="code" href="structPredicates_1_1not__pid.php#a03a26c57dbedb0bdffc6147858dba103">00178</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structPredicates_1_1not__pid.php#a03a26c57dbedb0bdffc6147858dba103">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__pid.php">not_pid&lt;T&gt;</a>(*this); }
<a name="l00179"></a>00179   };
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   <span class="comment">// The elem_type predicate returns true if the pointers</span>
<a name="l00183"></a>00183   <span class="comment">// type matches the given type.  Of course, this one can only</span>
<a name="l00184"></a>00184   <span class="comment">// be instantiated for objects which return Elem*s when dereferened.</span>
<a name="l00185"></a>00185   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00186"></a><a class="code" href="structPredicates_1_1elem__type.php">00186</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1elem__type.php">elem_type</a> : <a class="code" href="structPredicates_1_1predicate.php">predicate</a>&lt;T&gt;
<a name="l00187"></a>00187   {
<a name="l00188"></a>00188     <span class="comment">// Constructor</span>
<a name="l00189"></a><a class="code" href="structPredicates_1_1elem__type.php#a9d6ef09fee6d68a8ab68a4a2c80433ee">00189</a>     <a class="code" href="structPredicates_1_1elem__type.php#a9d6ef09fee6d68a8ab68a4a2c80433ee">elem_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t) : <a class="code" href="structPredicates_1_1elem__type.php#a74d5effa822e90c00878294c4496ac75">_elem_type</a>(t) {}
<a name="l00190"></a><a class="code" href="structPredicates_1_1elem__type.php#a99f9742778f695341f826034fadc650c">00190</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1elem__type.php#a99f9742778f695341f826034fadc650c">~elem_type</a>() {}
<a name="l00191"></a>00191     
<a name="l00192"></a><a class="code" href="structPredicates_1_1elem__type.php#a90e02889b6a0611b60a633303ae51bdb">00192</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structPredicates_1_1elem__type.php#a90e02889b6a0611b60a633303ae51bdb">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (*it)-&gt;type() == <a class="code" href="structPredicates_1_1elem__type.php#a74d5effa822e90c00878294c4496ac75">_elem_type</a>; }
<a name="l00193"></a>00193 
<a name="l00194"></a>00194   <span class="keyword">protected</span>:
<a name="l00195"></a><a class="code" href="structPredicates_1_1elem__type.php#ad01e2c6c6c49b4352ed388f39a445529">00195</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structPredicates_1_1elem__type.php#ad01e2c6c6c49b4352ed388f39a445529">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structPredicates_1_1elem__type.php">elem_type&lt;T&gt;</a>(*this); }
<a name="l00196"></a><a class="code" href="structPredicates_1_1elem__type.php#a74d5effa822e90c00878294c4496ac75">00196</a>     <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="structPredicates_1_1elem__type.php#a74d5effa822e90c00878294c4496ac75">_elem_type</a>;
<a name="l00197"></a>00197   };
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 
<a name="l00202"></a>00202   
<a name="l00203"></a>00203   <span class="comment">// The level predicate returns true if the pointers level</span>
<a name="l00204"></a>00204   <span class="comment">// matches the given level.</span>
<a name="l00205"></a>00205   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00206"></a><a class="code" href="structPredicates_1_1level.php">00206</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1level.php">level</a> : <a class="code" href="structPredicates_1_1predicate.php">predicate</a>&lt;T&gt;
<a name="l00207"></a>00207   {
<a name="l00208"></a>00208     <span class="comment">// Constructor</span>
<a name="l00209"></a><a class="code" href="structPredicates_1_1level.php#a2d9ac41598671cf5ddb6af24b40f8ae1">00209</a>     <a class="code" href="structPredicates_1_1level.php#a2d9ac41598671cf5ddb6af24b40f8ae1">level</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l) : <a class="code" href="structPredicates_1_1level.php#a2742da97b1983462c00dc7d664d44fa4">_level</a>(l) {}
<a name="l00210"></a><a class="code" href="structPredicates_1_1level.php#a3ee2c18b82317abb4b91f881d88454de">00210</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1level.php#a3ee2c18b82317abb4b91f881d88454de">~level</a>() {}
<a name="l00211"></a>00211 
<a name="l00212"></a><a class="code" href="structPredicates_1_1level.php#acbe67a7f65ed6efb378b5ec849ca27d8">00212</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structPredicates_1_1level.php#acbe67a7f65ed6efb378b5ec849ca27d8">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (*it)-&gt;level() == <a class="code" href="structPredicates_1_1level.php#a2742da97b1983462c00dc7d664d44fa4">_level</a>; }
<a name="l00213"></a>00213     
<a name="l00214"></a>00214   <span class="keyword">protected</span>:
<a name="l00215"></a><a class="code" href="structPredicates_1_1level.php#a8e641aa81105b7ad28a05d4e660ef80c">00215</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structPredicates_1_1level.php#a8e641aa81105b7ad28a05d4e660ef80c">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structPredicates_1_1level.php">level&lt;T&gt;</a>(*this); }
<a name="l00216"></a><a class="code" href="structPredicates_1_1level.php#a2742da97b1983462c00dc7d664d44fa4">00216</a>     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="structPredicates_1_1level.php#a2742da97b1983462c00dc7d664d44fa4">_level</a>;
<a name="l00217"></a>00217   };
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 
<a name="l00220"></a>00220   
<a name="l00221"></a>00221   <span class="comment">// The not_level predicate returns true if the pointers level</span>
<a name="l00222"></a>00222   <span class="comment">// _does not_ match the given level.</span>
<a name="l00223"></a>00223   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00224"></a><a class="code" href="structPredicates_1_1not__level.php">00224</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1not__level.php">not_level</a> : <a class="code" href="structPredicates_1_1level.php">level</a>&lt;T&gt;
<a name="l00225"></a>00225   {
<a name="l00226"></a>00226     <span class="comment">// Constructor</span>
<a name="l00227"></a><a class="code" href="structPredicates_1_1not__level.php#a12fca3c87f245071d38ba75207e606c7">00227</a>     <a class="code" href="structPredicates_1_1not__level.php#a12fca3c87f245071d38ba75207e606c7">not_level</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l) : <a class="code" href="structPredicates_1_1level.php">level</a>&lt;T&gt;(l) {}
<a name="l00228"></a>00228   
<a name="l00229"></a><a class="code" href="structPredicates_1_1not__level.php#ae6b9452c696ef71aaaa3cd2ccd63174a">00229</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structPredicates_1_1not__level.php#ae6b9452c696ef71aaaa3cd2ccd63174a">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> !<a class="code" href="structPredicates_1_1not__level.php#ae6b9452c696ef71aaaa3cd2ccd63174a">level&lt;T&gt;::operator()</a>(it); }
<a name="l00230"></a>00230 
<a name="l00231"></a>00231   <span class="keyword">protected</span>:
<a name="l00232"></a><a class="code" href="structPredicates_1_1not__level.php#abaf3b92b26d729cf507fa62f1f00461c">00232</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structPredicates_1_1not__level.php#abaf3b92b26d729cf507fa62f1f00461c">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structPredicates_1_1not__level.php">not_level&lt;T&gt;</a>(*this); }
<a name="l00233"></a>00233   };
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 
<a name="l00236"></a>00236   
<a name="l00237"></a>00237 
<a name="l00238"></a>00238   <span class="comment">// The null_neighbor predicate returns true if the pointer has any</span>
<a name="l00239"></a>00239   <span class="comment">// NULL neigbors.</span>
<a name="l00240"></a>00240   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00241"></a><a class="code" href="structPredicates_1_1null__neighbor.php">00241</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1null__neighbor.php">null_neighbor</a> : <a class="code" href="structPredicates_1_1predicate.php">predicate</a>&lt;T&gt;
<a name="l00242"></a>00242   {
<a name="l00243"></a><a class="code" href="structPredicates_1_1null__neighbor.php#a87328c92071c0f682845cd6754bd7226">00243</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1null__neighbor.php#a87328c92071c0f682845cd6754bd7226">~null_neighbor</a>() {}
<a name="l00244"></a><a class="code" href="structPredicates_1_1null__neighbor.php#a03553765687e9d7579acbaaa23cf12d1">00244</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structPredicates_1_1null__neighbor.php#a03553765687e9d7579acbaaa23cf12d1">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const</span>
<a name="l00245"></a>00245 <span class="keyword">    </span>{
<a name="l00246"></a>00246       <span class="keywordflow">return</span> (*it)-&gt;on_boundary();
<a name="l00247"></a>00247     }
<a name="l00248"></a>00248     
<a name="l00249"></a>00249   <span class="keyword">protected</span>:
<a name="l00250"></a><a class="code" href="structPredicates_1_1null__neighbor.php#ae0ecba647b7f2afd860ab5670ebdc9de">00250</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structPredicates_1_1null__neighbor.php#ae0ecba647b7f2afd860ab5670ebdc9de">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structPredicates_1_1null__neighbor.php">null_neighbor&lt;T&gt;</a>(*this); }
<a name="l00251"></a>00251   };
<a name="l00252"></a>00252 
<a name="l00253"></a>00253 
<a name="l00254"></a>00254 
<a name="l00255"></a>00255   <span class="comment">// This predicate simply forwards the work of determining whether</span>
<a name="l00256"></a>00256   <span class="comment">// a particular side is on the boundary to the iterator itself, which</span>
<a name="l00257"></a>00257   <span class="comment">// has more information.</span>
<a name="l00258"></a>00258   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00259"></a><a class="code" href="structPredicates_1_1boundary__side.php">00259</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1boundary__side.php">boundary_side</a> : <a class="code" href="structPredicates_1_1predicate.php">predicate</a>&lt;T&gt;
<a name="l00260"></a>00260   {
<a name="l00261"></a><a class="code" href="structPredicates_1_1boundary__side.php#a531962d81cdd66b75c55faab008f7b93">00261</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1boundary__side.php#a531962d81cdd66b75c55faab008f7b93">~boundary_side</a>() {}
<a name="l00262"></a><a class="code" href="structPredicates_1_1boundary__side.php#afd8296fd019071b43fac1c9fa376c674">00262</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structPredicates_1_1boundary__side.php#afd8296fd019071b43fac1c9fa376c674">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const</span>
<a name="l00263"></a>00263 <span class="keyword">    </span>{
<a name="l00264"></a>00264       <span class="keywordflow">return</span> it.side_on_boundary();
<a name="l00265"></a>00265     }
<a name="l00266"></a>00266 
<a name="l00267"></a>00267   <span class="keyword">protected</span>:
<a name="l00268"></a><a class="code" href="structPredicates_1_1boundary__side.php#ae657bd851297c53e3555edc54f8febfc">00268</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structPredicates_1_1boundary__side.php#ae657bd851297c53e3555edc54f8febfc">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structPredicates_1_1boundary__side.php">boundary_side&lt;T&gt;</a>(*this); }
<a name="l00269"></a>00269   };
<a name="l00270"></a>00270 
<a name="l00271"></a>00271   <span class="comment">// The subdomain predicate returns true if the pointers</span>
<a name="l00272"></a>00272   <span class="comment">// subdimain id matches a given subdomain id.</span>
<a name="l00273"></a>00273   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00274"></a><a class="code" href="structPredicates_1_1subdomain.php">00274</a>   <span class="keyword">struct </span><a class="code" href="structPredicates_1_1subdomain.php">subdomain</a> : <a class="code" href="structPredicates_1_1predicate.php">predicate</a>&lt;T&gt;
<a name="l00275"></a>00275   {
<a name="l00276"></a>00276     <span class="comment">// Constructor</span>
<a name="l00277"></a><a class="code" href="structPredicates_1_1subdomain.php#a57ed4c720d9c24efc4d2dc26b2525d97">00277</a>     <a class="code" href="structPredicates_1_1subdomain.php#a57ed4c720d9c24efc4d2dc26b2525d97">subdomain</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sid) : <a class="code" href="structPredicates_1_1subdomain.php#ac591e699c7a7b086eae200b8ad115fbe">_subdomain</a>(sid) {}
<a name="l00278"></a><a class="code" href="structPredicates_1_1subdomain.php#a0702bc808193f0ab72ca6679a6075851">00278</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1subdomain.php#a0702bc808193f0ab72ca6679a6075851">~subdomain</a>() {}
<a name="l00279"></a>00279 
<a name="l00280"></a>00280     <span class="comment">// op()</span>
<a name="l00281"></a><a class="code" href="structPredicates_1_1subdomain.php#aa54dc127c4028a202e25270a56ef44cc">00281</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structPredicates_1_1subdomain.php#aa54dc127c4028a202e25270a56ef44cc">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (*it)-&gt;subdomain_id() == <a class="code" href="structPredicates_1_1subdomain.php#ac591e699c7a7b086eae200b8ad115fbe">_subdomain</a>; }
<a name="l00282"></a>00282     
<a name="l00283"></a>00283   <span class="keyword">protected</span>:
<a name="l00284"></a><a class="code" href="structPredicates_1_1subdomain.php#aa2f5634861c92ba64c372742751c2146">00284</a>     <span class="keyword">virtual</span> <a class="code" href="structPredicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structPredicates_1_1subdomain.php#aa2f5634861c92ba64c372742751c2146">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structPredicates_1_1subdomain.php">subdomain&lt;T&gt;</a>(*this); }
<a name="l00285"></a><a class="code" href="structPredicates_1_1subdomain.php#ac591e699c7a7b086eae200b8ad115fbe">00285</a>     <span class="keyword">const</span> <a class="code" href="classTestClass.php">subdomain_id_type</a> <a class="code" href="structPredicates_1_1subdomain.php#ac591e699c7a7b086eae200b8ad115fbe">_subdomain</a>;
<a name="l00286"></a>00286   };
<a name="l00287"></a>00287 
<a name="l00288"></a>00288 }
<a name="l00289"></a>00289 
<a name="l00290"></a>00290 
<a name="l00291"></a>00291 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
