<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>slepc_eigen_solver.h</h1>  </div>
</div>
<div class="contents">
<a href="slepc__eigen__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: slepc_eigen_solver.h 3416 2009-07-03 14:30:29Z knezed01 $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __slepc_eigen_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __slepc_eigen_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="eigen__solver_8h.php">eigen_solver.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="petsc__vector_8h.php">petsc_vector.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="petsc__matrix_8h.php">petsc_matrix.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00037"></a>00037 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC) &amp;&amp; defined(LIBMESH_HAVE_PETSC)</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span>
<a name="l00039"></a>00039 <span class="preprocessor">#ifndef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span>
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042 <span class="preprocessor"># include &lt;slepceps.h&gt;</span>
<a name="l00043"></a>00043 <span class="preprocessor"># include &lt;slepcversion.h&gt;</span>
<a name="l00044"></a>00044 }
<a name="l00045"></a>00045 <span class="preprocessor">#else</span>
<a name="l00046"></a>00046 <span class="preprocessor"></span><span class="preprocessor"># include &lt;slepceps.h&gt;</span>
<a name="l00047"></a>00047 <span class="preprocessor"># include &lt;slepcversion.h&gt;</span>
<a name="l00048"></a>00048 <span class="preprocessor">#endif</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span>
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 <span class="comment">// A convenient macro for comparing SLEPc versions.</span>
<a name="l00052"></a>00052 <span class="comment">// Returns 1 if the current SLEPc version is &lt; major.minor.subminor</span>
<a name="l00053"></a>00053 <span class="comment">// and zero otherwise.</span>
<a name="l00054"></a>00054 <span class="preprocessor">#define SLEPC_VERSION_LESS_THAN(major,minor,subminor)                               \</span>
<a name="l00055"></a>00055 <span class="preprocessor">  ((SLEPC_VERSION_MAJOR &lt; (major) ||                                                \</span>
<a name="l00056"></a>00056 <span class="preprocessor">    (SLEPC_VERSION_MAJOR == (major) &amp;&amp; (SLEPC_VERSION_MINOR &lt; (minor) ||            \</span>
<a name="l00057"></a>00057 <span class="preprocessor">                                  (SLEPC_VERSION_MINOR == (minor) &amp;&amp;                \</span>
<a name="l00058"></a>00058 <span class="preprocessor">                                   SLEPC_VERSION_SUBMINOR &lt; (subminor))))) ? 1 : 0)</span>
<a name="l00059"></a>00059 <span class="preprocessor"></span>
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00067"></a>00067 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00068"></a><a class="code" href="classSlepcEigenSolver.php">00068</a> <span class="keyword">class </span><a class="code" href="classSlepcEigenSolver.php">SlepcEigenSolver</a> : <span class="keyword">public</span> <a class="code" href="classEigenSolver.php">EigenSolver</a>&lt;T&gt;
<a name="l00069"></a>00069 {
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 <span class="keyword">public</span>:
<a name="l00072"></a>00072 
<a name="l00076"></a>00076   <a class="code" href="classSlepcEigenSolver.php#a75bb3a03da03080a1f56fef8a9acaa9b">SlepcEigenSolver</a>();
<a name="l00077"></a>00077     
<a name="l00078"></a>00078 
<a name="l00082"></a>00082   <a class="code" href="classSlepcEigenSolver.php#abb743cf07c7c7464d6423a7ce7b99550">~SlepcEigenSolver</a>();
<a name="l00083"></a>00083 
<a name="l00084"></a>00084   
<a name="l00088"></a>00088   <span class="keywordtype">void</span> <a class="code" href="classSlepcEigenSolver.php#ada66948bab2a240a013853730cf99924">clear</a>();
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 
<a name="l00094"></a>00094   <span class="keywordtype">void</span> <a class="code" href="classSlepcEigenSolver.php#a294a5ff9e998c09fa5a2fa65af7f8ce7">init</a>();
<a name="l00095"></a>00095 
<a name="l00096"></a>00096        
<a name="l00107"></a>00107   std::pair&lt;unsigned int, unsigned int&gt;  <a class="code" href="classSlepcEigenSolver.php#a182a3ddba170ddca0f2363383bd2b521">solve_standard</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_A,
<a name="l00108"></a>00108                                                          <span class="keywordtype">int</span> nev,
<a name="l00109"></a>00109                                                          <span class="keywordtype">int</span> ncv,
<a name="l00110"></a>00110                                                          <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00111"></a>00111                                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00112"></a>00112 
<a name="l00117"></a>00117   std::pair&lt;unsigned int, unsigned int&gt;  <a class="code" href="classSlepcEigenSolver.php#a182a3ddba170ddca0f2363383bd2b521">solve_standard</a> (<a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;shell_matrix,
<a name="l00118"></a>00118                                                          <span class="keywordtype">int</span> nev,
<a name="l00119"></a>00119                                                          <span class="keywordtype">int</span> ncv,
<a name="l00120"></a>00120                                                          <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00121"></a>00121                                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00122"></a>00122   
<a name="l00123"></a>00123 
<a name="l00136"></a>00136   std::pair&lt;unsigned int, unsigned int&gt;  <a class="code" href="classSlepcEigenSolver.php#ab9a657adf5ad54ed8e85225bc1553275">solve_generalized</a>(<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_A,
<a name="l00137"></a>00137                                                            <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_B,
<a name="l00138"></a>00138                                                            <span class="keywordtype">int</span> nev,
<a name="l00139"></a>00139                                                            <span class="keywordtype">int</span> ncv,
<a name="l00140"></a>00140                                                            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00141"></a>00141                                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00142"></a>00142 
<a name="l00147"></a>00147     std::pair&lt;unsigned int, unsigned int&gt;  <a class="code" href="classSlepcEigenSolver.php#ab9a657adf5ad54ed8e85225bc1553275">solve_generalized</a>(<a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;matrix_A,
<a name="l00148"></a>00148                                                            <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_B,
<a name="l00149"></a>00149                                                            <span class="keywordtype">int</span> nev,
<a name="l00150"></a>00150                                                            <span class="keywordtype">int</span> ncv,
<a name="l00151"></a>00151                                                            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00152"></a>00152                                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00153"></a>00153 
<a name="l00164"></a>00164     std::pair&lt;unsigned int, unsigned int&gt;  <a class="code" href="classSlepcEigenSolver.php#ab9a657adf5ad54ed8e85225bc1553275">solve_generalized</a>(<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_A,
<a name="l00165"></a>00165                                                            <a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;matrix_B,
<a name="l00166"></a>00166                                                            <span class="keywordtype">int</span> nev,
<a name="l00167"></a>00167                                                            <span class="keywordtype">int</span> ncv,
<a name="l00168"></a>00168                                                            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00169"></a>00169                                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00170"></a>00170 
<a name="l00181"></a>00181     std::pair&lt;unsigned int, unsigned int&gt;  <a class="code" href="classSlepcEigenSolver.php#ab9a657adf5ad54ed8e85225bc1553275">solve_generalized</a>(<a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;matrix_A,
<a name="l00182"></a>00182                                                            <a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;matrix_B,
<a name="l00183"></a>00183                                                            <span class="keywordtype">int</span> nev,
<a name="l00184"></a>00184                                                            <span class="keywordtype">int</span> ncv,
<a name="l00185"></a>00185                                                            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00186"></a>00186                                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00187"></a>00187 
<a name="l00188"></a>00188  
<a name="l00189"></a>00189  
<a name="l00196"></a>00196   std::pair&lt;Real, Real&gt; <a class="code" href="classSlepcEigenSolver.php#afe25c6b6bb795271ca34917a5c6794d8">get_eigenpair</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00197"></a>00197                                        <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;solution_in);
<a name="l00198"></a>00198 
<a name="l00203"></a>00203   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classSlepcEigenSolver.php#a236eef6e58f5092fb35bcae21a439dcf">get_relative_error</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00204"></a>00204 
<a name="l00208"></a>00208   <span class="keywordtype">void</span> <a class="code" href="classSlepcEigenSolver.php#ac5baa682ab5eb63dfd8734a0dddd6336">attach_deflation_space</a>(<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; deflation_vector);
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 <span class="keyword">private</span>:
<a name="l00211"></a>00211 
<a name="l00215"></a>00215   std::pair&lt;unsigned int, unsigned int&gt;  <a class="code" href="classSlepcEigenSolver.php#ae2ce977bfa02d860215441038b6a3e6e">_solve_standard_helper</a> (Mat mat,
<a name="l00216"></a>00216                                                          <span class="keywordtype">int</span> nev,
<a name="l00217"></a>00217                                                          <span class="keywordtype">int</span> ncv,
<a name="l00218"></a>00218                                                          <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00219"></a>00219                                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00220"></a>00220 
<a name="l00224"></a>00224   std::pair&lt;unsigned int, unsigned int&gt;  <a class="code" href="classSlepcEigenSolver.php#a6009a0dbee13ea7dbffba69ef26be1ea">_solve_generalized_helper</a> (Mat mat_A,
<a name="l00225"></a>00225                                                                  Mat mat_B,
<a name="l00226"></a>00226                                                                  <span class="keywordtype">int</span> nev,
<a name="l00227"></a>00227                                                                  <span class="keywordtype">int</span> ncv,
<a name="l00228"></a>00228                                                                  <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00229"></a>00229                                                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00230"></a>00230 
<a name="l00235"></a>00235   <span class="keywordtype">void</span> <a class="code" href="classSlepcEigenSolver.php#aa31985ca6678c3370a0645acb7cbafd6">set_slepc_solver_type</a> ();
<a name="l00236"></a>00236 
<a name="l00241"></a>00241   <span class="keywordtype">void</span> <a class="code" href="classSlepcEigenSolver.php#a14e834219079c4b1df00aa6ca970a179">set_slepc_problem_type</a> ();
<a name="l00242"></a>00242 
<a name="l00247"></a>00247   <span class="keywordtype">void</span> <a class="code" href="classSlepcEigenSolver.php#ae4eb2c3afdf92ed2f21e0948f7614897">set_slepc_position_of_spectrum</a>();
<a name="l00248"></a>00248 
<a name="l00254"></a>00254   <span class="keyword">static</span> <a class="code" href="petsc__linear__solver_8C.php#aefae79199a0dda59581d16f802913456">PetscErrorCode</a> <a class="code" href="classSlepcEigenSolver.php#ac2ba414670ebffafb034e6cfb126900d">_petsc_shell_matrix_mult</a>(Mat mat, Vec arg, Vec dest);
<a name="l00255"></a>00255 
<a name="l00261"></a>00261   <span class="keyword">static</span> <a class="code" href="petsc__linear__solver_8C.php#aefae79199a0dda59581d16f802913456">PetscErrorCode</a> <a class="code" href="classSlepcEigenSolver.php#a0924faa62e95ac9fb09fb8071138138f">_petsc_shell_matrix_get_diagonal</a>(Mat mat, Vec dest);
<a name="l00262"></a>00262 
<a name="l00266"></a><a class="code" href="classSlepcEigenSolver.php#ab0122a73f6797a500e472f32696d91a2">00266</a>   EPS <a class="code" href="classSlepcEigenSolver.php#ab0122a73f6797a500e472f32696d91a2">_eps</a>;
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 };
<a name="l00269"></a>00269 
<a name="l00270"></a>00270 
<a name="l00271"></a>00271 <span class="comment">/*----------------------- inline functions ----------------------------------*/</span>
<a name="l00272"></a>00272 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00273"></a>00273 <span class="keyword">inline</span>
<a name="l00274"></a><a class="code" href="classSlepcEigenSolver.php#a75bb3a03da03080a1f56fef8a9acaa9b">00274</a> <a class="code" href="classSlepcEigenSolver.php#a75bb3a03da03080a1f56fef8a9acaa9b">SlepcEigenSolver&lt;T&gt;::SlepcEigenSolver</a> ()
<a name="l00275"></a>00275 {
<a name="l00276"></a>00276   this-&gt;_eigen_solver_type  = <a class="code" href="namespacelibMeshEnums.php#a4b230c3a7c3d5488c3c46bd9d03ce802a12dfe2dfbb1204d9ac57ca8efc947146">ARNOLDI</a>;
<a name="l00277"></a>00277   this-&gt;_eigen_problem_type = <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301a2b61471cb234c46e5f054bc73c2221de">NHEP</a>;
<a name="l00278"></a>00278 }
<a name="l00279"></a>00279 
<a name="l00280"></a>00280 
<a name="l00281"></a>00281 
<a name="l00282"></a>00282 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00283"></a>00283 <span class="keyword">inline</span>
<a name="l00284"></a><a class="code" href="classSlepcEigenSolver.php#abb743cf07c7c7464d6423a7ce7b99550">00284</a> <a class="code" href="classSlepcEigenSolver.php#abb743cf07c7c7464d6423a7ce7b99550">SlepcEigenSolver&lt;T&gt;::~SlepcEigenSolver</a> ()
<a name="l00285"></a>00285 {
<a name="l00286"></a>00286   this-&gt;clear ();
<a name="l00287"></a>00287 }
<a name="l00288"></a>00288 
<a name="l00289"></a>00289 
<a name="l00290"></a>00290 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_SLEPC</span>
<a name="l00291"></a>00291 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __slepc_linear_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
