<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>solver.h</h1>  </div>
</div>
<div class="contents">
<a href="solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: solver.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;reference_counted_object.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Forward Declarations</span>
<a name="l00033"></a>00033 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00034"></a>00034 <span class="keyword">class </span><a class="code" href="classSolver.php">Solver</a>;
<a name="l00035"></a>00035 
<a name="l00044"></a>00044 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00045"></a>00045 <span class="comment">// Solver class definition</span>
<a name="l00046"></a><a class="code" href="classSolver.php">00046</a> <span class="keyword">class </span><a class="code" href="classSolver.php">Solver</a> : <span class="keyword">public</span> <a class="code" href="classReferenceCountedObject.php">ReferenceCountedObject</a>&lt;Solver&gt;
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048 <span class="keyword">protected</span>:
<a name="l00049"></a>00049   
<a name="l00055"></a>00055   <a class="code" href="classSolver.php#a0c9453ef628a46eb1bfd71b9458ffd9b">Solver</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es);
<a name="l00056"></a>00056 
<a name="l00061"></a>00061   <a class="code" href="classSolver.php#a0c9453ef628a46eb1bfd71b9458ffd9b">Solver</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00062"></a>00062           <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00063"></a>00063           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number);
<a name="l00064"></a>00064   
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 <span class="keyword">public</span>:
<a name="l00067"></a>00067   
<a name="l00071"></a>00071   <a class="code" href="classSolver.php#aba52d3c92fafceb6fe39f937f2d73db3">~Solver</a> ();
<a name="l00072"></a>00072 
<a name="l00076"></a><a class="code" href="classSolver.php#a7c8dda7a14b4b221e355ee6ab724aaf9">00076</a>   <span class="keyword">typedef</span> <a class="code" href="classEquationSystems.php">EquationSystems</a> <a class="code" href="classSolver.php#a7c8dda7a14b4b221e355ee6ab724aaf9">sys_type</a>;
<a name="l00077"></a>00077   
<a name="l00082"></a>00082   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSolver.php#a819713a2cc7f9792b61b5ecde67aa5d0">init</a> ();
<a name="l00083"></a>00083 
<a name="l00088"></a>00088   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSolver.php#a4451ebbc7f391c56c117e491d25b6281">pre_process</a> ();
<a name="l00089"></a>00089 
<a name="l00095"></a>00095   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSolver.php#ab651560a089c3beaf420deb61ea4bd87">solve</a> ();
<a name="l00096"></a>00096 
<a name="l00101"></a>00101   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSolver.php#ad5803422ba8466e6ae2923e9fa5e99d6">post_process</a> ();
<a name="l00102"></a>00102 
<a name="l00106"></a><a class="code" href="classSolver.php#a9a3b99e5e195d70b2c03ea7a0ed84d0f">00106</a>   <span class="keyword">const</span> <a class="code" href="classEquationSystems.php">sys_type</a> &amp; <a class="code" href="classSolver.php#a9a3b99e5e195d70b2c03ea7a0ed84d0f">system</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classSolver.php#a67ca5e38f2a58641943cc3bd63698df7">_system</a>; }
<a name="l00107"></a>00107 
<a name="l00111"></a><a class="code" href="classSolver.php#a5dd0496234dd4bc1c7e6b751c69f2a6b">00111</a>   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp; <a class="code" href="classSolver.php#a5dd0496234dd4bc1c7e6b751c69f2a6b">mesh</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classSolver.php#a5ed99c278cf92062fd4c8dbb50662400">_mesh</a>; }
<a name="l00112"></a>00112 
<a name="l00113"></a>00113   
<a name="l00114"></a>00114 <span class="keyword">protected</span>:
<a name="l00115"></a>00115 
<a name="l00119"></a><a class="code" href="classSolver.php#a2364ad0ac3cfd5b6bd87b6969ee4552f">00119</a>   <a class="code" href="classEquationSystems.php">sys_type</a> &amp; <a class="code" href="classSolver.php#a2364ad0ac3cfd5b6bd87b6969ee4552f">system</a> () { <span class="keywordflow">return</span> <a class="code" href="classSolver.php#a67ca5e38f2a58641943cc3bd63698df7">_system</a>; }
<a name="l00120"></a>00120   
<a name="l00124"></a><a class="code" href="classSolver.php#abb9de8df1d883cc48cd281a3cc18920f">00124</a>   <a class="code" href="classMeshBase.php">MeshBase</a> &amp; <a class="code" href="classSolver.php#abb9de8df1d883cc48cd281a3cc18920f">mesh</a> () { <span class="keywordflow">return</span> <a class="code" href="classSolver.php#a5ed99c278cf92062fd4c8dbb50662400">_mesh</a>; }
<a name="l00125"></a>00125 
<a name="l00129"></a><a class="code" href="classSolver.php#a67ca5e38f2a58641943cc3bd63698df7">00129</a>   <a class="code" href="classEquationSystems.php">sys_type</a>&amp; <a class="code" href="classSolver.php#a67ca5e38f2a58641943cc3bd63698df7">_system</a>;
<a name="l00130"></a>00130 
<a name="l00135"></a><a class="code" href="classSolver.php#a5ed99c278cf92062fd4c8dbb50662400">00135</a>   <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classSolver.php#a5ed99c278cf92062fd4c8dbb50662400">_mesh</a>;
<a name="l00136"></a>00136 };
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00141"></a>00141 <span class="comment">// Solver inline members</span>
<a name="l00142"></a>00142 <span class="keyword">inline</span>
<a name="l00143"></a><a class="code" href="classSolver.php#a0c9453ef628a46eb1bfd71b9458ffd9b">00143</a> <a class="code" href="classSolver.php#a0c9453ef628a46eb1bfd71b9458ffd9b">Solver::Solver</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es) :
<a name="l00144"></a>00144   _system (es),
<a name="l00145"></a>00145   _mesh   (es.get_mesh())
<a name="l00146"></a>00146 {
<a name="l00147"></a>00147 }
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 <span class="keyword">inline</span>
<a name="l00152"></a><a class="code" href="classSolver.php#aba52d3c92fafceb6fe39f937f2d73db3">00152</a> <a class="code" href="classSolver.php#aba52d3c92fafceb6fe39f937f2d73db3">Solver::~Solver</a> ()
<a name="l00153"></a>00153 {
<a name="l00154"></a>00154 }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 <span class="keyword">inline</span>
<a name="l00159"></a><a class="code" href="classSolver.php#a819713a2cc7f9792b61b5ecde67aa5d0">00159</a> <span class="keywordtype">void</span> <a class="code" href="classSolver.php#a819713a2cc7f9792b61b5ecde67aa5d0">Solver::init</a> ()
<a name="l00160"></a>00160 {
<a name="l00161"></a>00161   std::cout &lt;&lt; <span class="stringliteral">&quot;Initializing $Id: solver.h 3391 2009-05-26 03:50:35Z benkirk $&quot;</span>
<a name="l00162"></a>00162             &lt;&lt; std::endl;
<a name="l00163"></a>00163   
<a name="l00164"></a>00164   <span class="comment">// Initialize the system.</span>
<a name="l00165"></a>00165   this-&gt;<a class="code" href="classSolver.php#a9a3b99e5e195d70b2c03ea7a0ed84d0f">system</a>().<a class="code" href="classEquationSystems.php#a759b6d1f3fa9dff14c6618bf725f060a">init</a> ();
<a name="l00166"></a>00166 }
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 <span class="keyword">inline</span>
<a name="l00171"></a><a class="code" href="classSolver.php#a4451ebbc7f391c56c117e491d25b6281">00171</a> <span class="keywordtype">void</span> <a class="code" href="classSolver.php#a4451ebbc7f391c56c117e491d25b6281">Solver::pre_process</a> ()
<a name="l00172"></a>00172 {
<a name="l00173"></a>00173 <span class="comment">//  std::cout &lt;&lt; &quot;Pre-processing&quot;</span>
<a name="l00174"></a>00174 <span class="comment">//          &lt;&lt; std::endl;</span>
<a name="l00175"></a>00175 }
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 <span class="keyword">inline</span>
<a name="l00180"></a><a class="code" href="classSolver.php#ab651560a089c3beaf420deb61ea4bd87">00180</a> <span class="keywordtype">void</span> <a class="code" href="classSolver.php#ab651560a089c3beaf420deb61ea4bd87">Solver::solve</a> ()
<a name="l00181"></a>00181 {
<a name="l00182"></a>00182   <span class="comment">// Perform any necessary pre-processing</span>
<a name="l00183"></a>00183   <a class="code" href="classSolver.php#a4451ebbc7f391c56c117e491d25b6281">Solver::pre_process</a> ();
<a name="l00184"></a>00184   
<a name="l00185"></a>00185 <span class="comment">//  std::cout &lt;&lt; &quot;Solving $Id: solver.h 3391 2009-05-26 03:50:35Z benkirk $&quot;</span>
<a name="l00186"></a>00186 <span class="comment">//          &lt;&lt; std::endl;</span>
<a name="l00187"></a>00187 
<a name="l00188"></a>00188   <span class="comment">// Solve the system</span>
<a name="l00189"></a>00189   this-&gt;<a class="code" href="classSolver.php#a9a3b99e5e195d70b2c03ea7a0ed84d0f">system</a>().<a class="code" href="classEquationSystems.php#aef3aa48d457508bf35043667dab8bd5b">solve</a> ();
<a name="l00190"></a>00190   
<a name="l00191"></a>00191   <span class="comment">// Perform any necessary post-processing</span>
<a name="l00192"></a>00192   <a class="code" href="classSolver.php#ad5803422ba8466e6ae2923e9fa5e99d6">Solver::post_process</a> ();  
<a name="l00193"></a>00193 }
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 <span class="keyword">inline</span>
<a name="l00198"></a><a class="code" href="classSolver.php#ad5803422ba8466e6ae2923e9fa5e99d6">00198</a> <span class="keywordtype">void</span> <a class="code" href="classSolver.php#ad5803422ba8466e6ae2923e9fa5e99d6">Solver::post_process</a> ()
<a name="l00199"></a>00199 {
<a name="l00200"></a>00200 <span class="comment">//  std::cout &lt;&lt; &quot;Post-processing&quot;</span>
<a name="l00201"></a>00201 <span class="comment">//          &lt;&lt; std::endl;</span>
<a name="l00202"></a>00202 }
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 <span class="preprocessor">#endif // #define __solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
