<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_f10759d5ac6297fe611079c3c15b8f2c.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>sparse_matrix.C</h1>  </div>
</div>
<div class="contents">
<a href="sparse__matrix_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: sparse_matrix.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;dof_map.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;laspack_matrix.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;parallel.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;petsc_matrix.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;sparse_matrix.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;trilinos_epetra_matrix.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00035"></a>00035 <span class="comment">// SparseMatrix Methods</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Full specialization for Real datatypes</span>
<a name="l00038"></a>00038 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00039"></a>00039 <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;SparseMatrix&lt;T&gt;</a> &gt;
<a name="l00040"></a><a class="code" href="classSparseMatrix.php#ad9c4cbd7164325b433e49f7bfd65255d">00040</a> <a class="code" href="classSparseMatrix.php#ad9c4cbd7164325b433e49f7bfd65255d">SparseMatrix&lt;T&gt;::build</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> solver_package)
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042   <span class="comment">// Build the appropriate vector</span>
<a name="l00043"></a>00043   <span class="keywordflow">switch</span> (solver_package)
<a name="l00044"></a>00044     {
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 <span class="preprocessor">#ifdef LIBMESH_HAVE_LASPACK</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span>    <span class="keywordflow">case</span> <a class="code" href="libmesh_8C.php#ad6ecbeeb31977480c0eaa28e42e4437b">LASPACK_SOLVERS</a>:
<a name="l00049"></a>00049       {
<a name="l00050"></a>00050         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;SparseMatrix&lt;T&gt;</a> &gt; ap(<span class="keyword">new</span> <a class="code" href="classLaspackMatrix.php">LaspackMatrix&lt;T&gt;</a>);
<a name="l00051"></a>00051         <span class="keywordflow">return</span> ap;
<a name="l00052"></a>00052       }
<a name="l00053"></a>00053 <span class="preprocessor">#endif</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span>
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span>    <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8a4bb6e669bd80e3d232092e60df464572">PETSC_SOLVERS</a>:
<a name="l00058"></a>00058       {
<a name="l00059"></a>00059         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;SparseMatrix&lt;T&gt;</a> &gt; ap(<span class="keyword">new</span> <a class="code" href="classPetscMatrix.php">PetscMatrix&lt;T&gt;</a>);
<a name="l00060"></a>00060         <span class="keywordflow">return</span> ap;
<a name="l00061"></a>00061       }
<a name="l00062"></a>00062 <span class="preprocessor">#endif</span>
<a name="l00063"></a>00063 <span class="preprocessor"></span>
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 <span class="preprocessor">#ifdef LIBMESH_HAVE_TRILINOS</span>
<a name="l00066"></a>00066 <span class="preprocessor"></span>    <span class="keywordflow">case</span> <a class="code" href="libmesh_8C.php#aeb3d2e133be6abf302776ec5d939c457">TRILINOS_SOLVERS</a>:
<a name="l00067"></a>00067       {
<a name="l00068"></a>00068         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;SparseMatrix&lt;T&gt;</a> &gt; ap(<span class="keyword">new</span> <a class="code" href="classEpetraMatrix.php">EpetraMatrix&lt;T&gt;</a>);
<a name="l00069"></a>00069         <span class="keywordflow">return</span> ap;
<a name="l00070"></a>00070       }
<a name="l00071"></a>00071 <span class="preprocessor">#endif</span>
<a name="l00072"></a>00072 <span class="preprocessor"></span>
<a name="l00073"></a>00073 
<a name="l00074"></a>00074     <span class="keywordflow">default</span>:
<a name="l00075"></a>00075       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR:  Unrecognized solver package: &quot;</span>
<a name="l00076"></a>00076                 &lt;&lt; solver_package
<a name="l00077"></a>00077                 &lt;&lt; std::endl;
<a name="l00078"></a>00078       libmesh_error();
<a name="l00079"></a>00079     }
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;SparseMatrix&lt;T&gt;</a> &gt; ap(NULL);
<a name="l00082"></a>00082   <span class="keywordflow">return</span> ap;    
<a name="l00083"></a>00083 }
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00087"></a><a class="code" href="classSparseMatrix.php#ac0fc31655fcd03e3e96a4a0df212a924">00087</a> <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#ac0fc31655fcd03e3e96a4a0df212a924">SparseMatrix&lt;T&gt;::vector_mult</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest,
<a name="l00088"></a>00088                                    <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; arg)<span class="keyword"> const</span>
<a name="l00089"></a>00089 <span class="keyword"></span>{
<a name="l00090"></a>00090   dest.<a class="code" href="classNumericVector.php#a21ca80e20b0f88490c8f0d5298d47bef">zero</a>();
<a name="l00091"></a>00091   this-&gt;vector_mult_add(dest,arg);
<a name="l00092"></a>00092 }
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00097"></a><a class="code" href="classSparseMatrix.php#a3753580774da3ac5f591d2a9dab620cc">00097</a> <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#a3753580774da3ac5f591d2a9dab620cc">SparseMatrix&lt;T&gt;::vector_mult_add</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest,
<a name="l00098"></a>00098                                        <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; arg)<span class="keyword"> const</span>
<a name="l00099"></a>00099 <span class="keyword"></span>{
<a name="l00100"></a>00100   <span class="comment">/* This functionality is actually implemented in the \p</span>
<a name="l00101"></a>00101 <span class="comment">     NumericVector class.  */</span>
<a name="l00102"></a>00102   dest.<a class="code" href="classNumericVector.php#ac41cf781a2cce694f5795cb36fb40a4b">add_vector</a>(arg,*<span class="keyword">this</span>);
<a name="l00103"></a>00103 }
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00108"></a><a class="code" href="classSparseMatrix.php#af1afde30d9c81cd2f6575d8e5016a106">00108</a> <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#af1afde30d9c81cd2f6575d8e5016a106">SparseMatrix&lt;T&gt;::zero_rows</a> (std::vector&lt;int&gt; &amp;, T)
<a name="l00109"></a>00109 {
<a name="l00110"></a>00110   <span class="comment">/* This functionality isn&#39;t implemented or stubbed in every subclass yet */</span>
<a name="l00111"></a>00111   libmesh_not_implemented();
<a name="l00112"></a>00112 }
<a name="l00113"></a>00113 
<a name="l00114"></a>00114   
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00117"></a>00117 <span class="keyword">inline</span>
<a name="l00118"></a><a class="code" href="classSparseMatrix.php#a3ec4b8d0b6b8055a184c4876bce090fb">00118</a> <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#a3ec4b8d0b6b8055a184c4876bce090fb">SparseMatrix&lt;T&gt;::print</a>(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00119"></a>00119 <span class="keyword"></span>{
<a name="l00120"></a>00120   parallel_only();
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <span class="comment">// We&#39;ll print the matrix from processor 0 to make sure</span>
<a name="l00125"></a>00125   <span class="comment">// it&#39;s serialized properly</span>
<a name="l00126"></a>00126   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00127"></a>00127     {
<a name="l00128"></a>00128       libmesh_assert(this-&gt;_dof_map-&gt;first_dof() == 0);
<a name="l00129"></a>00129       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=this-&gt;_dof_map-&gt;first_dof();
<a name="l00130"></a>00130            i!=this-&gt;_dof_map-&gt;end_dof(); ++i)
<a name="l00131"></a>00131         {
<a name="l00132"></a>00132           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;n(); j++)
<a name="l00133"></a>00133             os &lt;&lt; (*<span class="keyword">this</span>)(i,j) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00134"></a>00134           os &lt;&lt; std::endl;
<a name="l00135"></a>00135         }
<a name="l00136"></a>00136 
<a name="l00137"></a>00137       std::vector&lt;unsigned int&gt; ibuf, jbuf;
<a name="l00138"></a>00138       std::vector&lt;T&gt; cbuf;
<a name="l00139"></a>00139       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> currenti = this-&gt;_dof_map-&gt;end_dof();
<a name="l00140"></a>00140       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p &lt; <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00141"></a>00141         {
<a name="l00142"></a>00142           Parallel::receive(p, ibuf);
<a name="l00143"></a>00143           Parallel::receive(p, jbuf);
<a name="l00144"></a>00144           Parallel::receive(p, cbuf);
<a name="l00145"></a>00145           libmesh_assert(ibuf.size() == jbuf.size());
<a name="l00146"></a>00146           libmesh_assert(ibuf.size() == cbuf.size());
<a name="l00147"></a>00147 
<a name="l00148"></a>00148           <span class="keywordflow">if</span> (ibuf.empty())
<a name="l00149"></a>00149             <span class="keywordflow">continue</span>;
<a name="l00150"></a>00150           libmesh_assert(ibuf.front() &gt;= currenti);
<a name="l00151"></a>00151           libmesh_assert(ibuf.back() &gt;= ibuf.front());
<a name="l00152"></a>00152 
<a name="l00153"></a>00153           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> currentb = 0;
<a name="l00154"></a>00154           <span class="keywordflow">for</span> (;currenti &lt;= ibuf.back(); ++currenti)
<a name="l00155"></a>00155             {
<a name="l00156"></a>00156               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;n(); j++)
<a name="l00157"></a>00157                 {
<a name="l00158"></a>00158                   <span class="keywordflow">if</span> (currentb &lt; ibuf.size() &amp;&amp;
<a name="l00159"></a>00159                       ibuf[currentb] == currenti &amp;&amp;
<a name="l00160"></a>00160                       jbuf[currentb] == j)
<a name="l00161"></a>00161                     {
<a name="l00162"></a>00162                       os &lt;&lt; cbuf[currentb] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00163"></a>00163                       currentb++;
<a name="l00164"></a>00164                     }
<a name="l00165"></a>00165                   <span class="keywordflow">else</span>
<a name="l00166"></a>00166                     os &lt;&lt; static_cast&lt;T&gt;(0.0) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00167"></a>00167                 }
<a name="l00168"></a>00168               os &lt;&lt; std::endl;
<a name="l00169"></a>00169             }
<a name="l00170"></a>00170         }
<a name="l00171"></a>00171       <span class="keywordflow">for</span> (; currenti != this-&gt;m(); ++currenti)
<a name="l00172"></a>00172         {
<a name="l00173"></a>00173           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;n(); j++)
<a name="l00174"></a>00174             os &lt;&lt; static_cast&lt;T&gt;(0.0) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00175"></a>00175           os &lt;&lt; std::endl;
<a name="l00176"></a>00176         }
<a name="l00177"></a>00177     }
<a name="l00178"></a>00178   <span class="keywordflow">else</span>
<a name="l00179"></a>00179     {
<a name="l00180"></a>00180       std::vector&lt;unsigned int&gt; ibuf, jbuf;
<a name="l00181"></a>00181       std::vector&lt;T&gt; cbuf;
<a name="l00182"></a>00182 
<a name="l00183"></a>00183       <span class="comment">// We&#39;ll assume each processor has access to entire</span>
<a name="l00184"></a>00184       <span class="comment">// matrix rows, so (*this)(i,j) is valid if i is a local index.</span>
<a name="l00185"></a>00185       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=this-&gt;_dof_map-&gt;first_dof();
<a name="l00186"></a>00186            i!=this-&gt;_dof_map-&gt;end_dof(); ++i)
<a name="l00187"></a>00187         {
<a name="l00188"></a>00188           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;n(); j++)
<a name="l00189"></a>00189             {
<a name="l00190"></a>00190               T c = (*this)(i,j);
<a name="l00191"></a>00191               <span class="keywordflow">if</span> (c != static_cast&lt;T&gt;(0.0))
<a name="l00192"></a>00192                 {
<a name="l00193"></a>00193                   ibuf.push_back(i);
<a name="l00194"></a>00194                   jbuf.push_back(j);
<a name="l00195"></a>00195                   cbuf.push_back(c);
<a name="l00196"></a>00196                 }
<a name="l00197"></a>00197             }
<a name="l00198"></a>00198         }
<a name="l00199"></a>00199       Parallel::send(0,ibuf);
<a name="l00200"></a>00200       Parallel::send(0,jbuf);
<a name="l00201"></a>00201       Parallel::send(0,cbuf);
<a name="l00202"></a>00202     }
<a name="l00203"></a>00203 }
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00208"></a>00208 <span class="comment">// Explicit instantiations</span>
<a name="l00209"></a>00209 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classSparseMatrix.php">SparseMatrix&lt;Number&gt;</a>;
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
