<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>sparse_matrix.h</h1>  </div>
</div>
<div class="contents">
<a href="sparse__matrix_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: sparse_matrix.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __sparse_matrix_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __sparse_matrix_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;iomanip&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;auto_ptr.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;reference_counted_object.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;libmesh.h&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// forward declarations</span>
<a name="l00037"></a>00037 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classSparseMatrix.php">SparseMatrix</a>;
<a name="l00038"></a>00038 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classDenseMatrix.php">DenseMatrix</a>;
<a name="l00039"></a>00039 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">inline</span> std::ostream&amp; operator &lt;&lt; (std::ostream&amp; os, const SparseMatrix&lt;T&gt;&amp; <a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>);
<a name="l00040"></a>00040 <span class="keyword">class </span><a class="code" href="classDofMap.php">DofMap</a>;
<a name="l00041"></a>00041 <span class="keyword">namespace </span>SparsityPattern { <span class="keyword">class </span>Graph; }
<a name="l00042"></a>00042 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classNumericVector.php">NumericVector</a>;
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00056"></a>00056 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00057"></a><a class="code" href="classSparseMatrix.php">00057</a> <span class="keyword">class </span><a class="code" href="classSparseMatrix.php">SparseMatrix</a> : <span class="keyword">public</span> <a class="code" href="classReferenceCountedObject.php">ReferenceCountedObject</a>&lt;SparseMatrix&lt;T&gt; &gt;
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059 <span class="keyword">public</span>:
<a name="l00075"></a>00075   <a class="code" href="classSparseMatrix.php#a7cc1357950b026509513c9cc88796c00">SparseMatrix</a> ();
<a name="l00076"></a>00076 
<a name="l00082"></a>00082   <span class="keyword">virtual</span> <a class="code" href="classSparseMatrix.php#a1a02a8503d026de2eabec8fa68a0ac03">~SparseMatrix</a> ();
<a name="l00083"></a>00083 
<a name="l00088"></a>00088   <span class="keyword">static</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;SparseMatrix&lt;T&gt;</a> &gt;
<a name="l00089"></a>00089   <a class="code" href="classSparseMatrix.php#ad9c4cbd7164325b433e49f7bfd65255d">build</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> solver_package = <a class="code" href="namespacelibMesh.php#a496c62248223cd940c7715932dd0dc2d">libMesh::default_solver_package</a>());
<a name="l00090"></a>00090   
<a name="l00095"></a><a class="code" href="classSparseMatrix.php#a5859dbbdc5266472541839b5dc4b0768">00095</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classSparseMatrix.php#a5859dbbdc5266472541839b5dc4b0768">initialized</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classSparseMatrix.php#a1dd24ca76da426c3c657545d37cb8187">_is_initialized</a>; }
<a name="l00096"></a>00096 
<a name="l00100"></a><a class="code" href="classSparseMatrix.php#a962f53b3692ce1e275655cd1bdc3afc4">00100</a>   <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#a962f53b3692ce1e275655cd1bdc3afc4">attach_dof_map</a> (<span class="keyword">const</span> <a class="code" href="classDofMap.php">DofMap</a>&amp; dof_map)
<a name="l00101"></a>00101   { <a class="code" href="classSparseMatrix.php#a4ba525d86c62d981b3dfc42586cadc18">_dof_map</a> = &amp;dof_map; }
<a name="l00102"></a>00102 
<a name="l00110"></a><a class="code" href="classSparseMatrix.php#a4e7c51fd92b19f8993aa68180ad2734e">00110</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classSparseMatrix.php#a4e7c51fd92b19f8993aa68180ad2734e">need_full_sparsity_pattern</a>()<span class="keyword"> const </span>
<a name="l00111"></a>00111 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }  
<a name="l00112"></a>00112 
<a name="l00118"></a><a class="code" href="classSparseMatrix.php#a4d73db20a61e2192685ded3ccda4abff">00118</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#a4d73db20a61e2192685ded3ccda4abff">update_sparsity_pattern</a> (<span class="keyword">const</span> <a class="code" href="classSparsityPattern_1_1Graph.php">SparsityPattern::Graph</a> &amp;) {}
<a name="l00119"></a>00119   
<a name="l00128"></a>00128   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#aa4c2bf22bb324b0acffa1e767dce188b">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSparseMatrix.php#af2f0d62994782f324c59bd4203b9d1d2">m</a>,
<a name="l00129"></a>00129                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSparseMatrix.php#af540f97c67ca77cf3a6dc7a4f1551c19">n</a>,
<a name="l00130"></a>00130                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_l,
<a name="l00131"></a>00131                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_l,
<a name="l00132"></a>00132                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nnz=30,
<a name="l00133"></a>00133                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> noz=10) = 0;
<a name="l00134"></a>00134 
<a name="l00138"></a>00138   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#aa4c2bf22bb324b0acffa1e767dce188b">init</a> () = 0;
<a name="l00139"></a>00139   
<a name="l00146"></a>00146   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#a4dc6672a641212eeb422d100d3a542fc">clear</a> () = 0;
<a name="l00147"></a>00147 
<a name="l00151"></a>00151   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#ac9c04c5748478399f1eff3f337a7e647">zero</a> () = 0;
<a name="l00152"></a>00152 
<a name="l00156"></a>00156   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#af1afde30d9c81cd2f6575d8e5016a106">zero_rows</a> (std::vector&lt;int&gt; &amp; rows, T diag_value = 0.0);
<a name="l00157"></a>00157   
<a name="l00163"></a>00163   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#a55129db49268936e33686bc1beaaa1e9">close</a> () <span class="keyword">const</span> = 0;
<a name="l00164"></a>00164   
<a name="l00169"></a>00169   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSparseMatrix.php#af2f0d62994782f324c59bd4203b9d1d2">m</a> () <span class="keyword">const</span> = 0;
<a name="l00170"></a>00170 
<a name="l00175"></a>00175   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSparseMatrix.php#af540f97c67ca77cf3a6dc7a4f1551c19">n</a> () <span class="keyword">const</span> = 0;
<a name="l00176"></a>00176 
<a name="l00181"></a>00181   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSparseMatrix.php#af756a147a38a3a80c1dc694f2773619c">row_start</a> () <span class="keyword">const</span> = 0;
<a name="l00182"></a>00182 
<a name="l00187"></a>00187   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSparseMatrix.php#a689808949565c286a10bce61e40efaf5">row_stop</a> () <span class="keyword">const</span> = 0;
<a name="l00188"></a>00188 
<a name="l00195"></a>00195   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <span class="keyword">set</span> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00196"></a>00196                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00197"></a>00197                     <span class="keyword">const</span> T value) = 0;
<a name="l00198"></a>00198     
<a name="l00207"></a>00207   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#a23714d101ef245d4c31b8eebeffc99dd">add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00208"></a>00208                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00209"></a>00209                     <span class="keyword">const</span> T value) = 0;
<a name="l00210"></a>00210 
<a name="l00217"></a>00217   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#aad59105789574a7d9ad7462be13b7a90">add_matrix</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;dm,
<a name="l00218"></a>00218                            <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;rows,
<a name="l00219"></a>00219                            <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;cols) = 0;
<a name="l00220"></a>00220   
<a name="l00225"></a>00225   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#aad59105789574a7d9ad7462be13b7a90">add_matrix</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;dm,
<a name="l00226"></a>00226                            <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;dof_indices) = 0;
<a name="l00227"></a>00227       
<a name="l00233"></a>00233   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#a23714d101ef245d4c31b8eebeffc99dd">add</a> (<span class="keyword">const</span> T, <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;) = 0;
<a name="l00234"></a>00234 
<a name="l00253"></a>00253   <span class="keyword">virtual</span> T <a class="code" href="classSparseMatrix.php#a2fe280f432238d4bfce73b6473ba7dc0">operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00254"></a>00254                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span> = 0;
<a name="l00255"></a>00255 
<a name="l00266"></a>00266   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classSparseMatrix.php#a3f454639068a2d3ffe77c7ca5ef69169">l1_norm</a> () <span class="keyword">const</span> = 0;
<a name="l00267"></a>00267 
<a name="l00279"></a>00279   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classSparseMatrix.php#af891a2f3a4cb6b03005d92bb1a2120aa">linfty_norm</a> () <span class="keyword">const</span> = 0;
<a name="l00280"></a>00280 
<a name="l00285"></a>00285   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classSparseMatrix.php#a9750409ffe56174bb2d959d48b6f80ac">closed</a>() <span class="keyword">const</span> = 0;
<a name="l00286"></a>00286 
<a name="l00292"></a>00292   <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#a3ec4b8d0b6b8055a184c4876bce090fb">print</a>(std::ostream&amp; os=std::cout) <span class="keyword">const</span>;
<a name="l00293"></a>00293 
<a name="l00298"></a>00298   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> U&gt;
<a name="l00299"></a>00299   <span class="keyword">friend</span> std::ostream&amp; operator &lt;&lt; (std::ostream&amp; os, const SparseMatrix&lt;U&gt;&amp; <a class="code" href="classSparseMatrix.php#af2f0d62994782f324c59bd4203b9d1d2">m</a>);
<a name="l00300"></a>00300   
<a name="l00305"></a>00305   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#a6e27d9a42badfc1a301cd615c29d53c3">print_personal</a>(std::ostream&amp; os=std::cout) <span class="keyword">const</span> = 0;
<a name="l00306"></a>00306   
<a name="l00313"></a><a class="code" href="classSparseMatrix.php#a33d00df7d35761283ec71be3ef21170f">00313</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#a33d00df7d35761283ec71be3ef21170f">print_matlab</a>(<span class="keyword">const</span> std::string <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>=<span class="stringliteral">&quot;NULL&quot;</span>)<span class="keyword"> const</span>
<a name="l00314"></a>00314 <span class="keyword">  </span>{
<a name="l00315"></a>00315     std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Not Implemented in base class yet!&quot;</span> &lt;&lt; std::endl;
<a name="l00316"></a>00316     std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR writing MATLAB file &quot;</span> &lt;&lt; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a> &lt;&lt; std::endl;
<a name="l00317"></a>00317     libmesh_error();
<a name="l00318"></a>00318   }
<a name="l00319"></a>00319 
<a name="l00325"></a><a class="code" href="classSparseMatrix.php#a02bbbe07f3b8d71cfcf1b780c31d38ca">00325</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#a02bbbe07f3b8d71cfcf1b780c31d38ca">create_submatrix</a>(<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; submatrix,
<a name="l00326"></a>00326                                 <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; rows,
<a name="l00327"></a>00327                                 <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; cols)<span class="keyword"> const</span>
<a name="l00328"></a>00328 <span class="keyword">  </span>{
<a name="l00329"></a>00329     this-&gt;<a class="code" href="classSparseMatrix.php#a0de6a193febac4e65d1d63e754242f5b">_get_submatrix</a>(submatrix,
<a name="l00330"></a>00330                          rows,
<a name="l00331"></a>00331                          cols,
<a name="l00332"></a>00332                          <span class="keyword">false</span>); <span class="comment">// false means DO NOT REUSE submatrix</span>
<a name="l00333"></a>00333   }
<a name="l00334"></a>00334 
<a name="l00341"></a><a class="code" href="classSparseMatrix.php#a1f6e6566651b637120d2faff0068a708">00341</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#a1f6e6566651b637120d2faff0068a708">reinit_submatrix</a>(<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; submatrix,
<a name="l00342"></a>00342                                 <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; rows,
<a name="l00343"></a>00343                                 <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; cols)<span class="keyword"> const</span>
<a name="l00344"></a>00344 <span class="keyword">  </span>{
<a name="l00345"></a>00345     this-&gt;<a class="code" href="classSparseMatrix.php#a0de6a193febac4e65d1d63e754242f5b">_get_submatrix</a>(submatrix,
<a name="l00346"></a>00346                          rows,
<a name="l00347"></a>00347                          cols,
<a name="l00348"></a>00348                          <span class="keyword">true</span>); <span class="comment">// true means REUSE submatrix</span>
<a name="l00349"></a>00349   }
<a name="l00350"></a>00350   
<a name="l00355"></a>00355   <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#ac0fc31655fcd03e3e96a4a0df212a924">vector_mult</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest,
<a name="l00356"></a>00356                     <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; arg) <span class="keyword">const</span>;
<a name="l00357"></a>00357 
<a name="l00361"></a>00361   <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#a3753580774da3ac5f591d2a9dab620cc">vector_mult_add</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest,
<a name="l00362"></a>00362                         <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; arg) <span class="keyword">const</span>;
<a name="l00363"></a>00363 
<a name="l00367"></a>00367   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#ae0358ae630fb06c6241ea634740685e5">get_diagonal</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span> = 0;
<a name="l00368"></a>00368 
<a name="l00373"></a>00373   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#a7f1c4ddda074a4e1aa63bf7d2f780492">get_transpose</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span> = 0;
<a name="l00374"></a>00374 
<a name="l00375"></a>00375 <span class="keyword">protected</span>:
<a name="l00376"></a>00376 
<a name="l00382"></a><a class="code" href="classSparseMatrix.php#a0de6a193febac4e65d1d63e754242f5b">00382</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#a0de6a193febac4e65d1d63e754242f5b">_get_submatrix</a>(<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; ,
<a name="l00383"></a>00383                               <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ,
<a name="l00384"></a>00384                               <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ,
<a name="l00385"></a>00385                               <span class="keyword">const</span> <span class="keywordtype">bool</span>)<span class="keyword"> const</span>
<a name="l00386"></a>00386 <span class="keyword">  </span>{
<a name="l00387"></a>00387     std::cerr &lt;&lt; <span class="stringliteral">&quot;Error! This function is not yet implemented in the base class!&quot;</span>
<a name="l00388"></a>00388               &lt;&lt; std::endl;
<a name="l00389"></a>00389     libmesh_error();
<a name="l00390"></a>00390   }
<a name="l00391"></a>00391   
<a name="l00395"></a><a class="code" href="classSparseMatrix.php#a4ba525d86c62d981b3dfc42586cadc18">00395</a>   <a class="code" href="classDofMap.php">DofMap</a> <span class="keyword">const</span> *<a class="code" href="classSparseMatrix.php#a4ba525d86c62d981b3dfc42586cadc18">_dof_map</a>;
<a name="l00396"></a>00396   
<a name="l00401"></a><a class="code" href="classSparseMatrix.php#a1dd24ca76da426c3c657545d37cb8187">00401</a>   <span class="keywordtype">bool</span> <a class="code" href="classSparseMatrix.php#a1dd24ca76da426c3c657545d37cb8187">_is_initialized</a>;
<a name="l00402"></a>00402 };
<a name="l00403"></a>00403 
<a name="l00404"></a>00404 
<a name="l00405"></a>00405 
<a name="l00406"></a>00406 <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00407"></a>00407 <span class="comment">// SparseMatrix inline members</span>
<a name="l00408"></a>00408 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00409"></a>00409 <span class="keyword">inline</span>
<a name="l00410"></a><a class="code" href="classSparseMatrix.php#a7cc1357950b026509513c9cc88796c00">00410</a> <a class="code" href="classSparseMatrix.php#a7cc1357950b026509513c9cc88796c00">SparseMatrix&lt;T&gt;::SparseMatrix</a> () :
<a name="l00411"></a>00411   _dof_map(NULL),
<a name="l00412"></a>00412   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a>(false)
<a name="l00413"></a>00413 {}
<a name="l00414"></a>00414 
<a name="l00415"></a>00415 
<a name="l00416"></a>00416 
<a name="l00417"></a>00417 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00418"></a>00418 <span class="keyword">inline</span>
<a name="l00419"></a><a class="code" href="classSparseMatrix.php#a1a02a8503d026de2eabec8fa68a0ac03">00419</a> <a class="code" href="classSparseMatrix.php#a1a02a8503d026de2eabec8fa68a0ac03">SparseMatrix&lt;T&gt;::~SparseMatrix</a> ()
<a name="l00420"></a>00420 {}
<a name="l00421"></a>00421 
<a name="l00422"></a>00422 
<a name="l00423"></a>00423 
<a name="l00424"></a>00424 
<a name="l00425"></a>00425 
<a name="l00426"></a>00426 <span class="comment">// Full specialization for Complex datatypes</span>
<a name="l00427"></a>00427 <span class="keyword">template</span> &lt;&gt;
<a name="l00428"></a>00428 <span class="keyword">inline</span>
<a name="l00429"></a><a class="code" href="classSparseMatrix.php#a524c56a17568c19ef6f7859f3d84c45f">00429</a> <span class="keywordtype">void</span> <a class="code" href="classSparseMatrix.php#a3ec4b8d0b6b8055a184c4876bce090fb">SparseMatrix&lt;Complex&gt;::print</a>(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00430"></a>00430 <span class="keyword"></span>{
<a name="l00431"></a>00431   <span class="comment">// std::complex&lt;&gt;::operator&lt;&lt;() is defined, but use this form</span>
<a name="l00432"></a>00432 
<a name="l00433"></a>00433   std::cout &lt;&lt; <span class="stringliteral">&quot;Real part:&quot;</span> &lt;&lt; std::endl;
<a name="l00434"></a>00434   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;m(); i++)
<a name="l00435"></a>00435     {
<a name="l00436"></a>00436       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;n(); j++)
<a name="l00437"></a>00437         os &lt;&lt; std::setw(8) &lt;&lt; (*this)(i,j).real() &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00438"></a>00438       os &lt;&lt; std::endl;
<a name="l00439"></a>00439     }
<a name="l00440"></a>00440 
<a name="l00441"></a>00441   os &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;Imaginary part:&quot;</span> &lt;&lt; std::endl;
<a name="l00442"></a>00442   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;m(); i++)
<a name="l00443"></a>00443     {
<a name="l00444"></a>00444       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;n(); j++)
<a name="l00445"></a>00445         os &lt;&lt; std::setw(8) &lt;&lt; (*this)(i,j).imag() &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00446"></a>00446       os &lt;&lt; std::endl;
<a name="l00447"></a>00447     }
<a name="l00448"></a>00448 }
<a name="l00449"></a>00449 
<a name="l00450"></a>00450 
<a name="l00451"></a>00451 
<a name="l00452"></a>00452 <span class="comment">// For SGI MIPSpro this implementation must occur after</span>
<a name="l00453"></a>00453 <span class="comment">// the partial specialization of the print() member.</span>
<a name="l00454"></a>00454 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00455"></a>00455 <span class="keyword">inline</span>
<a name="l00456"></a><a class="code" href="sparse__matrix_8h.php#a4fc624f72daf05e63c3c9057f26bcbcf">00456</a> std::ostream&amp; operator &lt;&lt; (std::ostream&amp; os, const SparseMatrix&lt;T&gt;&amp; m)
<a name="l00457"></a>00457 {
<a name="l00458"></a>00458   m.print(os);
<a name="l00459"></a>00459   <span class="keywordflow">return</span> os;
<a name="l00460"></a>00460 }
<a name="l00461"></a>00461 
<a name="l00462"></a>00462 
<a name="l00463"></a>00463 
<a name="l00464"></a>00464 <span class="preprocessor">#endif // #ifndef __sparse_matrix_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
