<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1665b3ccb6c776ec6797fe204e2359e5.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>sphere.C</h1>  </div>
</div>
<div class="contents">
<a href="sphere_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: sphere.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;cmath&gt;</span> <span class="comment">// for std::abs</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;tensor_value.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;sphere.h&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00033"></a>00033 <span class="comment">// Sphere class member functions</span>
<a name="l00034"></a><a class="code" href="classSphere.php#a890a63ff583cb88e7ec4e840b4ef5eb9">00034</a> <a class="code" href="classSphere.php#a890a63ff583cb88e7ec4e840b4ef5eb9">Sphere::Sphere</a> () : 
<a name="l00035"></a>00035   _rad(-1.)
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037 }
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a><a class="code" href="classSphere.php#a03a67eeae01516b17f90383bec6e0bcf">00041</a> <a class="code" href="classSphere.php#a890a63ff583cb88e7ec4e840b4ef5eb9">Sphere::Sphere</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; c, 
<a name="l00042"></a>00042                 <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>   r)
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044   libmesh_assert (r &gt; 0.);
<a name="l00045"></a>00045 
<a name="l00046"></a>00046   this-&gt;<a class="code" href="classSphere.php#aaa997d5e9418d97a59b074e98a76c239">create_from_center_radius</a> (c, r);
<a name="l00047"></a>00047 }
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a><a class="code" href="classSphere.php#a3fa97ab24767a2ec8dac950e872b1508">00051</a> <a class="code" href="classSphere.php#a890a63ff583cb88e7ec4e840b4ef5eb9">Sphere::Sphere</a> (<span class="keyword">const</span> <a class="code" href="classSphere.php">Sphere</a>&amp; other_sphere) :
<a name="l00052"></a>00052   <a class="code" href="classSurface.php">Surface</a>()
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054   this-&gt;<a class="code" href="classSphere.php#aaa997d5e9418d97a59b074e98a76c239">create_from_center_radius</a> (other_sphere.<a class="code" href="classSphere.php#a75792b8a1ffd7ec2517f89c6c3cb4822">center</a>(),
<a name="l00055"></a>00055                                    other_sphere.<a class="code" href="classSphere.php#a7aa370233ed514b6c09c65efae8f8a20">radius</a>());
<a name="l00056"></a>00056 }
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 
<a name="l00060"></a><a class="code" href="classSphere.php#a0b6b911e116f9bfaf61254274b8a101e">00060</a> <a class="code" href="classSphere.php#a890a63ff583cb88e7ec4e840b4ef5eb9">Sphere::Sphere</a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; pa,
<a name="l00061"></a>00061                <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; pb,
<a name="l00062"></a>00062                <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; pc,
<a name="l00063"></a>00063                <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; pd)
<a name="l00064"></a>00064 {
<a name="l00065"></a>00065   <a class="code" href="classPoint.php">Point</a> pad = pa - pd;
<a name="l00066"></a>00066   <a class="code" href="classPoint.php">Point</a> pbd = pb - pd;
<a name="l00067"></a>00067   <a class="code" href="classPoint.php">Point</a> pcd = pc - pd;
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   <a class="code" href="classTensorValue.php">TensorValue&lt;Real&gt;</a> T(pad,pbd,pcd);
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> D = T.<a class="code" href="classTypeTensor.php#a4e8ef88336d54773e974a50bb567c3a3">det</a>();
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   <span class="comment">// The points had better not be coplanar</span>
<a name="l00074"></a>00074   libmesh_assert (std::abs(D) &gt; 1e-12);
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> e = 0.5*(pa.<a class="code" href="classTypeVector.php#a099aac580a3a6fce9276cf5443d0c0e9">size_sq</a>() - pd.size_sq());
<a name="l00077"></a>00077   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> f = 0.5*(pb.<a class="code" href="classTypeVector.php#a099aac580a3a6fce9276cf5443d0c0e9">size_sq</a>() - pd.size_sq());
<a name="l00078"></a>00078   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> g = 0.5*(pc.<a class="code" href="classTypeVector.php#a099aac580a3a6fce9276cf5443d0c0e9">size_sq</a>() - pd.size_sq());
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   <a class="code" href="classTensorValue.php">TensorValue&lt;Real&gt;</a> T1(e,pad(1),pad(2),
<a name="l00081"></a>00081                        f,pbd(1),pbd(2),
<a name="l00082"></a>00082                        g,pcd(1),pcd(2));
<a name="l00083"></a>00083   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> sx = T1.<a class="code" href="classTypeTensor.php#a4e8ef88336d54773e974a50bb567c3a3">det</a>()/D;
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <a class="code" href="classTensorValue.php">TensorValue&lt;Real&gt;</a> T2(pad(0),e,pad(2),
<a name="l00086"></a>00086                        pbd(0),f,pbd(2),
<a name="l00087"></a>00087                        pcd(0),g,pcd(2));
<a name="l00088"></a>00088   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> sy = T2.<a class="code" href="classTypeTensor.php#a4e8ef88336d54773e974a50bb567c3a3">det</a>()/D;
<a name="l00089"></a>00089 
<a name="l00090"></a>00090   <a class="code" href="classTensorValue.php">TensorValue&lt;Real&gt;</a> T3(pad(0),pad(1),e,
<a name="l00091"></a>00091                        pbd(0),pbd(1),f,
<a name="l00092"></a>00092                        pcd(0),pcd(1),g);
<a name="l00093"></a>00093   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> sz = T3.<a class="code" href="classTypeTensor.php#a4e8ef88336d54773e974a50bb567c3a3">det</a>()/D;
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   <a class="code" href="classPoint.php">Point</a> c(sx,sy,sz);
<a name="l00096"></a>00096   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> r = (c-pa).size();
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   this-&gt;<a class="code" href="classSphere.php#aaa997d5e9418d97a59b074e98a76c239">create_from_center_radius</a>(c,r);
<a name="l00099"></a>00099 }
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 
<a name="l00103"></a><a class="code" href="classSphere.php#a569c071e50a3e11f678630ee1a17737e">00103</a> <a class="code" href="classSphere.php#a569c071e50a3e11f678630ee1a17737e">Sphere::~Sphere</a> ()
<a name="l00104"></a>00104 {
<a name="l00105"></a>00105 }
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a><a class="code" href="classSphere.php#aaa997d5e9418d97a59b074e98a76c239">00109</a> <span class="keywordtype">void</span> <a class="code" href="classSphere.php#aaa997d5e9418d97a59b074e98a76c239">Sphere::create_from_center_radius</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; c, <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> r)
<a name="l00110"></a>00110 {
<a name="l00111"></a>00111   this-&gt;<a class="code" href="classSphere.php#a75792b8a1ffd7ec2517f89c6c3cb4822">center</a>() = c;
<a name="l00112"></a>00112   this-&gt;<a class="code" href="classSphere.php#a7aa370233ed514b6c09c65efae8f8a20">radius</a>() = r;
<a name="l00113"></a>00113 
<a name="l00114"></a>00114   libmesh_assert (this-&gt;<a class="code" href="classSphere.php#a7aa370233ed514b6c09c65efae8f8a20">radius</a>() &gt; 0.);
<a name="l00115"></a>00115 }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a><a class="code" href="classSphere.php#a213b859ec99849ef3a608c69aa0cc0a0">00119</a> <span class="keywordtype">bool</span> <a class="code" href="classSphere.php#a213b859ec99849ef3a608c69aa0cc0a0">Sphere::intersects</a> (<span class="keyword">const</span> <a class="code" href="classSphere.php">Sphere</a>&amp; other_sphere)<span class="keyword"> const</span>
<a name="l00120"></a>00120 <span class="keyword"></span>{
<a name="l00121"></a>00121   libmesh_assert ( this-&gt;<a class="code" href="classSphere.php#a7aa370233ed514b6c09c65efae8f8a20">radius</a>() &gt; 0. );
<a name="l00122"></a>00122   libmesh_assert ( other_sphere.<a class="code" href="classSphere.php#a7aa370233ed514b6c09c65efae8f8a20">radius</a>() &gt; 0. );
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> distance = (this-&gt;<a class="code" href="classSphere.php#a75792b8a1ffd7ec2517f89c6c3cb4822">center</a>() - other_sphere.<a class="code" href="classSphere.php#a75792b8a1ffd7ec2517f89c6c3cb4822">center</a>()).size();
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   <span class="keywordflow">if</span> (distance &lt; (this-&gt;<a class="code" href="classSphere.php#a7aa370233ed514b6c09c65efae8f8a20">radius</a>() + other_sphere.<a class="code" href="classSphere.php#a7aa370233ed514b6c09c65efae8f8a20">radius</a>()) )
<a name="l00127"></a>00127     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00128"></a>00128   
<a name="l00129"></a>00129   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00130"></a>00130 }
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a><a class="code" href="classSphere.php#a7c55ddf6e71f18aec75c7b836d75b84f">00134</a> <span class="keywordtype">bool</span> <a class="code" href="classSphere.php#a7c55ddf6e71f18aec75c7b836d75b84f">Sphere::above_surface</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p)<span class="keyword"> const </span>
<a name="l00135"></a>00135 <span class="keyword"></span>{
<a name="l00136"></a>00136   libmesh_assert (this-&gt;<a class="code" href="classSphere.php#a7aa370233ed514b6c09c65efae8f8a20">radius</a>() &gt; 0.);
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <span class="comment">// create a vector from the center to the point.</span>
<a name="l00139"></a>00139   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> w = p - this-&gt;<a class="code" href="classSphere.php#a75792b8a1ffd7ec2517f89c6c3cb4822">center</a>();
<a name="l00140"></a>00140 
<a name="l00141"></a>00141   <span class="keywordflow">if</span> (w.<a class="code" href="classTypeVector.php#a34f47a12e12990aad2910a934bdaac7d">size</a>() &gt; this-&gt;<a class="code" href="classSphere.php#a7aa370233ed514b6c09c65efae8f8a20">radius</a>())
<a name="l00142"></a>00142     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00143"></a>00143 
<a name="l00144"></a>00144   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00145"></a>00145 }
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a><a class="code" href="classSphere.php#a97a59b2ab1a320b4739b52b388387a68">00149</a> <span class="keywordtype">bool</span> <a class="code" href="classSphere.php#a97a59b2ab1a320b4739b52b388387a68">Sphere::below_surface</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p)<span class="keyword"> const </span>
<a name="l00150"></a>00150 <span class="keyword"></span>{
<a name="l00151"></a>00151   libmesh_assert (this-&gt;<a class="code" href="classSphere.php#a7aa370233ed514b6c09c65efae8f8a20">radius</a>() &gt; 0.);
<a name="l00152"></a>00152 
<a name="l00153"></a>00153   <span class="keywordflow">return</span> ( !this-&gt;<a class="code" href="classSphere.php#a7c55ddf6e71f18aec75c7b836d75b84f">above_surface</a> (p) );
<a name="l00154"></a>00154 }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a><a class="code" href="classSphere.php#aa76dbb36091a83101c8812ec96913193">00158</a> <span class="keywordtype">bool</span> <a class="code" href="classSphere.php#aa76dbb36091a83101c8812ec96913193">Sphere::on_surface</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p)<span class="keyword"> const </span>
<a name="l00159"></a>00159 <span class="keyword"></span>{
<a name="l00160"></a>00160   libmesh_assert (this-&gt;<a class="code" href="classSphere.php#a7aa370233ed514b6c09c65efae8f8a20">radius</a>() &gt; 0.);
<a name="l00161"></a>00161 
<a name="l00162"></a>00162   <span class="comment">// Create a vector from the center to the point.</span>
<a name="l00163"></a>00163   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> w = p - this-&gt;<a class="code" href="classSphere.php#a75792b8a1ffd7ec2517f89c6c3cb4822">center</a>();
<a name="l00164"></a>00164 
<a name="l00165"></a>00165   <span class="comment">// if the size of that vector is the same as the radius() then</span>
<a name="l00166"></a>00166   <span class="comment">// the point is on the surface.</span>
<a name="l00167"></a>00167   <span class="keywordflow">if</span> (std::abs(w.<a class="code" href="classTypeVector.php#a34f47a12e12990aad2910a934bdaac7d">size</a>() - this-&gt;<a class="code" href="classSphere.php#a7aa370233ed514b6c09c65efae8f8a20">radius</a>()) &lt; 1.e-10)
<a name="l00168"></a>00168     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00169"></a>00169 
<a name="l00170"></a>00170   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00171"></a>00171 }
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 
<a name="l00175"></a><a class="code" href="classSphere.php#a2d75d8d43b1e2d5549a068c7167d97e6">00175</a> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classSphere.php#a2d75d8d43b1e2d5549a068c7167d97e6">Sphere::closest_point</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p)<span class="keyword"> const</span>
<a name="l00176"></a>00176 <span class="keyword"></span>{
<a name="l00177"></a>00177   libmesh_assert (this-&gt;<a class="code" href="classSphere.php#a7aa370233ed514b6c09c65efae8f8a20">radius</a>() &gt; 0.);
<a name="l00178"></a>00178 
<a name="l00179"></a>00179   <span class="comment">// get the normal from the surface in the direction</span>
<a name="l00180"></a>00180   <span class="comment">// of p</span>
<a name="l00181"></a>00181   <a class="code" href="classPoint.php">Point</a> normal = this-&gt;<a class="code" href="classSphere.php#a60b23e8ca4e87e8f0b1637546d4fb869">unit_normal</a> (p);
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   <span class="comment">// The closest point on the sphere is in the direction</span>
<a name="l00184"></a>00184   <span class="comment">// of the normal a distance r from the center.</span>
<a name="l00185"></a>00185   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> cp = this-&gt;<a class="code" href="classSphere.php#a75792b8a1ffd7ec2517f89c6c3cb4822">center</a>() + normal*this-&gt;<a class="code" href="classSphere.php#a7aa370233ed514b6c09c65efae8f8a20">radius</a>();
<a name="l00186"></a>00186   
<a name="l00187"></a>00187   <span class="keywordflow">return</span> cp;
<a name="l00188"></a>00188 }
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 
<a name="l00192"></a><a class="code" href="classSphere.php#a60b23e8ca4e87e8f0b1637546d4fb869">00192</a> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classSphere.php#a60b23e8ca4e87e8f0b1637546d4fb869">Sphere::unit_normal</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p)<span class="keyword"> const</span>
<a name="l00193"></a>00193 <span class="keyword"></span>{
<a name="l00194"></a>00194   libmesh_assert (this-&gt;<a class="code" href="classSphere.php#a7aa370233ed514b6c09c65efae8f8a20">radius</a>() &gt; 0.);
<a name="l00195"></a>00195 
<a name="l00196"></a>00196   libmesh_assert ( !(p == this-&gt;<a class="code" href="classSphere.php#a75792b8a1ffd7ec2517f89c6c3cb4822">center</a>()) );
<a name="l00197"></a>00197   
<a name="l00198"></a>00198   <span class="comment">// Create a vector from the center to the point</span>
<a name="l00199"></a>00199   <a class="code" href="classPoint.php">Point</a> n = p - this-&gt;<a class="code" href="classSphere.php#a75792b8a1ffd7ec2517f89c6c3cb4822">center</a>();
<a name="l00200"></a>00200 
<a name="l00201"></a>00201   <span class="keywordflow">return</span> n.<a class="code" href="classTypeVector.php#a0415bcc1a523ea5f0224a711b14b3532">unit</a>();
<a name="l00202"></a>00202 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
