<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>sphere.h</h1>  </div>
</div>
<div class="contents">
<a href="sphere_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: sphere.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __sphere_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __sphere_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;cmath&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="surface_8h.php">surface.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;libmesh.h&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00072"></a>00072 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00073"></a>00073 <span class="comment">// Sphere class definition</span>
<a name="l00074"></a><a class="code" href="classSphere.php">00074</a> <span class="keyword">class </span><a class="code" href="classSphere.php">Sphere</a> : <span class="keyword">public</span> <a class="code" href="classSurface.php">Surface</a>
<a name="l00075"></a>00075 {
<a name="l00076"></a>00076 <span class="keyword">public</span>:
<a name="l00077"></a>00077   
<a name="l00081"></a>00081   <a class="code" href="classSphere.php#a890a63ff583cb88e7ec4e840b4ef5eb9">Sphere</a> ();
<a name="l00082"></a>00082 
<a name="l00086"></a>00086   <a class="code" href="classSphere.php#a890a63ff583cb88e7ec4e840b4ef5eb9">Sphere</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; c, <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> r);
<a name="l00087"></a>00087 
<a name="l00091"></a>00091   <a class="code" href="classSphere.php#a890a63ff583cb88e7ec4e840b4ef5eb9">Sphere</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp;, <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp;, <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp;, <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp;);
<a name="l00092"></a>00092 
<a name="l00096"></a>00096   <a class="code" href="classSphere.php#a890a63ff583cb88e7ec4e840b4ef5eb9">Sphere</a> (<span class="keyword">const</span> <a class="code" href="classSphere.php">Sphere</a>&amp; other_sphere);
<a name="l00097"></a>00097 
<a name="l00101"></a>00101   <a class="code" href="classSphere.php#a569c071e50a3e11f678630ee1a17737e">~Sphere</a> ();
<a name="l00102"></a>00102 
<a name="l00106"></a>00106   <span class="keywordtype">void</span> <a class="code" href="classSphere.php#aaa997d5e9418d97a59b074e98a76c239">create_from_center_radius</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; c, <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> r);
<a name="l00107"></a>00107 
<a name="l00112"></a>00112   <span class="keywordtype">bool</span> <a class="code" href="classSphere.php#a213b859ec99849ef3a608c69aa0cc0a0">intersects</a> (<span class="keyword">const</span> <a class="code" href="classSphere.php">Sphere</a>&amp; other_sphere) <span class="keyword">const</span>;
<a name="l00113"></a>00113 
<a name="l00118"></a>00118   <span class="keywordtype">bool</span> <a class="code" href="classSphere.php#a7c55ddf6e71f18aec75c7b836d75b84f">above_surface</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00119"></a>00119 
<a name="l00124"></a>00124   <span class="keywordtype">bool</span> <a class="code" href="classSphere.php#a97a59b2ab1a320b4739b52b388387a68">below_surface</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00125"></a>00125 
<a name="l00132"></a>00132   <span class="keywordtype">bool</span> <a class="code" href="classSphere.php#aa76dbb36091a83101c8812ec96913193">on_surface</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00133"></a>00133 
<a name="l00137"></a>00137   <a class="code" href="classPoint.php">Point</a> <a class="code" href="classSphere.php#a2d75d8d43b1e2d5549a068c7167d97e6">closest_point</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00138"></a>00138 
<a name="l00143"></a>00143   <a class="code" href="classPoint.php">Point</a> <a class="code" href="classSphere.php#a60b23e8ca4e87e8f0b1637546d4fb869">unit_normal</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00144"></a>00144 
<a name="l00148"></a><a class="code" href="classSphere.php#a7aa370233ed514b6c09c65efae8f8a20">00148</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classSphere.php#a7aa370233ed514b6c09c65efae8f8a20">radius</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classSphere.php#a6ed603d5ff93bd46b07b5fa96adf31b5">_rad</a>; }
<a name="l00149"></a>00149 
<a name="l00153"></a><a class="code" href="classSphere.php#add808cee289bd78a4725bef57468b566">00153</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&amp; <a class="code" href="classSphere.php#add808cee289bd78a4725bef57468b566">radius</a>() { <span class="keywordflow">return</span> <a class="code" href="classSphere.php#a6ed603d5ff93bd46b07b5fa96adf31b5">_rad</a>; }
<a name="l00154"></a>00154 
<a name="l00158"></a><a class="code" href="classSphere.php#a75792b8a1ffd7ec2517f89c6c3cb4822">00158</a>   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; <a class="code" href="classSphere.php#a75792b8a1ffd7ec2517f89c6c3cb4822">center</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classSphere.php#a2a6b1ea77d20d4a03ed7967deb16cb95">_cent</a>; }
<a name="l00159"></a>00159 
<a name="l00163"></a><a class="code" href="classSphere.php#a0ed521f2459df0f3dd4762dfd4769ac5">00163</a>   <a class="code" href="classPoint.php">Point</a>&amp; <a class="code" href="classSphere.php#a0ed521f2459df0f3dd4762dfd4769ac5">center</a>() { <span class="keywordflow">return</span> <a class="code" href="classSphere.php#a2a6b1ea77d20d4a03ed7967deb16cb95">_cent</a>; }
<a name="l00164"></a>00164 
<a name="l00169"></a>00169   <a class="code" href="classPoint.php">Point</a> <a class="code" href="classSphere.php#abf39c91886c0d9e5e8cfc6f1f8bf3a51">surface_coords</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; cart) <span class="keyword">const</span>;
<a name="l00170"></a>00170 
<a name="l00175"></a>00175   <a class="code" href="classPoint.php">Point</a> <a class="code" href="classSphere.php#afa113ecc10c66fa8ba2e2c22626b32fe">world_coords</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; sph) <span class="keyword">const</span>;
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   
<a name="l00178"></a>00178 <span class="keyword">private</span>:
<a name="l00179"></a>00179 
<a name="l00180"></a>00180   
<a name="l00184"></a><a class="code" href="classSphere.php#a2a6b1ea77d20d4a03ed7967deb16cb95">00184</a>   <a class="code" href="classPoint.php">Point</a> <a class="code" href="classSphere.php#a2a6b1ea77d20d4a03ed7967deb16cb95">_cent</a>;
<a name="l00185"></a>00185 
<a name="l00189"></a><a class="code" href="classSphere.php#a6ed603d5ff93bd46b07b5fa96adf31b5">00189</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>  <a class="code" href="classSphere.php#a6ed603d5ff93bd46b07b5fa96adf31b5">_rad</a>;
<a name="l00190"></a>00190 };
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00195"></a>00195 <span class="comment">// Sphere inline functions</span>
<a name="l00196"></a>00196 <span class="keyword">inline</span>
<a name="l00197"></a><a class="code" href="classSphere.php#abf39c91886c0d9e5e8cfc6f1f8bf3a51">00197</a> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classSphere.php#abf39c91886c0d9e5e8cfc6f1f8bf3a51">Sphere::surface_coords</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; cart)<span class="keyword"> const</span>
<a name="l00198"></a>00198 <span class="keyword"></span>{
<a name="l00199"></a>00199   <span class="comment">// constant translation in the origin</span>
<a name="l00200"></a>00200   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> c (cart-this-&gt;<a class="code" href="classSphere.php#a75792b8a1ffd7ec2517f89c6c3cb4822">center</a>());
<a name="l00201"></a>00201 
<a name="l00202"></a>00202   <span class="comment">// phi: special care, so that it gives 0..2pi results</span>
<a name="l00203"></a>00203   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> phi = std::atan2(c(1), c(0));
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   <span class="keywordflow">return</span> <a class="code" href="classPoint.php">Point</a>(<span class="comment">/* radius */</span> c.<a class="code" href="classTypeVector.php#a34f47a12e12990aad2910a934bdaac7d">size</a>(),
<a name="l00206"></a>00206                <span class="comment">/* theta  */</span> std::atan2( std::sqrt( c(0)*c(0) + c(1)*c(1) ), c(2) ),
<a name="l00207"></a>00207                <span class="comment">/* phi    */</span> ( (phi &lt; 0)  ?  2.*<a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">libMesh::pi</a>+phi  :  phi ) );
<a name="l00208"></a>00208 }
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 <span class="keyword">inline</span>
<a name="l00213"></a><a class="code" href="classSphere.php#afa113ecc10c66fa8ba2e2c22626b32fe">00213</a> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classSphere.php#afa113ecc10c66fa8ba2e2c22626b32fe">Sphere::world_coords</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; sph)<span class="keyword"> const</span>
<a name="l00214"></a>00214 <span class="keyword"></span>{
<a name="l00215"></a>00215   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> r     = sph(0);
<a name="l00216"></a>00216   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> theta = sph(1);
<a name="l00217"></a>00217   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> phi   = sph(2);
<a name="l00218"></a>00218 
<a name="l00219"></a>00219   <span class="comment">// constant translation out of the origin</span>
<a name="l00220"></a>00220   <span class="keywordflow">return</span> <a class="code" href="classPoint.php">Point</a> (<span class="comment">/* x */</span> r*std::sin(theta)*std::cos(phi) + this-&gt;<a class="code" href="classSphere.php#a75792b8a1ffd7ec2517f89c6c3cb4822">center</a>()(0),
<a name="l00221"></a>00221                 <span class="comment">/* y */</span> r*std::sin(theta)*std::sin(phi) + this-&gt;<a class="code" href="classSphere.php#a75792b8a1ffd7ec2517f89c6c3cb4822">center</a>()(1),
<a name="l00222"></a>00222                 <span class="comment">/* z */</span> r*std::cos(theta)               + this-&gt;<a class="code" href="classSphere.php#a75792b8a1ffd7ec2517f89c6c3cb4822">center</a>()(2));
<a name="l00223"></a>00223 }
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
