<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_4f64d75cac7489d141591c33108e86ff.php">utils</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>statistics.h</h1>  </div>
</div>
<div class="contents">
<a href="statistics_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: statistics.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __statistics_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __statistics_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;cmath&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00031"></a>00031 
<a name="l00071"></a>00071 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00072"></a>00072 <span class="comment">// StatisticsVector class definition</span>
<a name="l00073"></a>00073 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00074"></a><a class="code" href="classStatisticsVector.php">00074</a> <span class="keyword">class </span><a class="code" href="classStatisticsVector.php">StatisticsVector</a> : <span class="keyword">public</span> std::<a class="code" href="classstd_1_1vector.php">vector</a>&lt;T&gt;
<a name="l00075"></a>00075 {
<a name="l00076"></a>00076  <span class="keyword">public</span>:
<a name="l00077"></a>00077 
<a name="l00081"></a><a class="code" href="classStatisticsVector.php#a6f96a64fc7a1bd65b8af92d64d828d6a">00081</a>   <a class="code" href="classStatisticsVector.php#a6f96a64fc7a1bd65b8af92d64d828d6a">StatisticsVector</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0) : std::<a class="code" href="classstd_1_1vector.php">vector</a>&lt;T&gt; (i) {}
<a name="l00082"></a>00082   
<a name="l00086"></a><a class="code" href="classStatisticsVector.php#a9db2000f523548d022b8ce35de4f4c3d">00086</a>   <a class="code" href="classStatisticsVector.php#a9db2000f523548d022b8ce35de4f4c3d">StatisticsVector</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, T val) : std::<a class="code" href="classstd_1_1vector.php">vector</a>&lt;T&gt; (i,val) {}
<a name="l00087"></a>00087 
<a name="l00091"></a><a class="code" href="classStatisticsVector.php#a1aba52c1633b7fc8685515be721f936f">00091</a>   <span class="keyword">virtual</span> <a class="code" href="classStatisticsVector.php#a1aba52c1633b7fc8685515be721f936f">~StatisticsVector</a> () {}
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 
<a name="l00097"></a>00097   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classStatisticsVector.php#ab9c211c266922e1fd0da23239a90356c">l2_norm</a>() <span class="keyword">const</span>;
<a name="l00098"></a>00098   
<a name="l00102"></a>00102   <span class="keyword">virtual</span> T <a class="code" href="classStatisticsVector.php#a9727d64089f0cc6dd5d3a30a1423d98d">minimum</a>() <span class="keyword">const</span>;
<a name="l00103"></a>00103   
<a name="l00107"></a>00107   <span class="keyword">virtual</span> T <a class="code" href="classStatisticsVector.php#afc7ea6421cd1d7d07f947ccc2eecb1cc">maximum</a>() <span class="keyword">const</span>;
<a name="l00108"></a>00108   
<a name="l00114"></a>00114   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classStatisticsVector.php#a3175eb04b6a6977a2e94d5082aaf12c0">mean</a>() <span class="keyword">const</span>;
<a name="l00115"></a>00115 
<a name="l00124"></a>00124   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classStatisticsVector.php#ab7177d66034d20472645e6af44ceef3a">median</a>();
<a name="l00125"></a>00125 
<a name="l00131"></a>00131   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classStatisticsVector.php#ab7177d66034d20472645e6af44ceef3a">median</a>() <span class="keyword">const</span>;
<a name="l00132"></a>00132 
<a name="l00141"></a><a class="code" href="classStatisticsVector.php#a00fe4de3a704f07f46ec893707549546">00141</a>   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classStatisticsVector.php#a00fe4de3a704f07f46ec893707549546">variance</a>()<span class="keyword"> const</span>
<a name="l00142"></a>00142 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classStatisticsVector.php#a00fe4de3a704f07f46ec893707549546">variance</a>(this-&gt;<a class="code" href="classStatisticsVector.php#a3175eb04b6a6977a2e94d5082aaf12c0">mean</a>()); }
<a name="l00143"></a>00143 
<a name="l00154"></a>00154   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classStatisticsVector.php#a00fe4de3a704f07f46ec893707549546">variance</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classStatisticsVector.php#a3175eb04b6a6977a2e94d5082aaf12c0">mean</a>) <span class="keyword">const</span>;
<a name="l00155"></a>00155 
<a name="l00161"></a><a class="code" href="classStatisticsVector.php#af6717ca69bba0e11d181fa758be420db">00161</a>   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classStatisticsVector.php#af6717ca69bba0e11d181fa758be420db">stddev</a>()<span class="keyword"> const</span>
<a name="l00162"></a>00162 <span class="keyword">  </span>{ <span class="keywordflow">return</span> std::sqrt(this-&gt;<a class="code" href="classStatisticsVector.php#a00fe4de3a704f07f46ec893707549546">variance</a>()); }
<a name="l00163"></a>00163   
<a name="l00170"></a><a class="code" href="classStatisticsVector.php#a7d374f172f9c9b39fe0f65609247555e">00170</a>   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classStatisticsVector.php#af6717ca69bba0e11d181fa758be420db">stddev</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classStatisticsVector.php#a3175eb04b6a6977a2e94d5082aaf12c0">mean</a>)<span class="keyword"> const</span>
<a name="l00171"></a>00171 <span class="keyword">  </span>{ <span class="keywordflow">return</span> std::sqrt(this-&gt;<a class="code" href="classStatisticsVector.php#a00fe4de3a704f07f46ec893707549546">variance</a>(mean)); }
<a name="l00172"></a>00172 
<a name="l00177"></a>00177   <span class="keywordtype">void</span> <a class="code" href="classStatisticsVector.php#a2157afb1eb020b0022fdf53db7def610">normalize</a>();
<a name="l00178"></a>00178   
<a name="l00188"></a>00188   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classStatisticsVector.php#ad79dab47e5e9134efe7e3ece809b9340">histogram</a> (std::vector&lt;unsigned int&gt;&amp; bin_members,
<a name="l00189"></a>00189                           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bins=10);
<a name="l00190"></a>00190 
<a name="l00198"></a>00198   <span class="keywordtype">void</span> <a class="code" href="classStatisticsVector.php#a4f0fa454d1e09a06a7a8bfa81d2ce3ba">plot_histogram</a>(<span class="keyword">const</span> std::string&amp; filename,
<a name="l00199"></a>00199                       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bins);
<a name="l00200"></a>00200   
<a name="l00204"></a>00204   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classStatisticsVector.php#ad79dab47e5e9134efe7e3ece809b9340">histogram</a> (std::vector&lt;unsigned int&gt;&amp; bin_members,
<a name="l00205"></a>00205                           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bins=10) <span class="keyword">const</span>;
<a name="l00206"></a>00206 
<a name="l00212"></a>00212   <span class="keyword">virtual</span> std::vector&lt;unsigned int&gt; <a class="code" href="classStatisticsVector.php#ae5752e0ceeee7fa07d005cf5d504e19b">cut_below</a>(<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> cut) <span class="keyword">const</span>;
<a name="l00213"></a>00213 
<a name="l00221"></a>00221   <span class="keyword">virtual</span> std::vector&lt;unsigned int&gt; <a class="code" href="classStatisticsVector.php#a35e1f4f6100dd2dab76fb23b09ce8a82">cut_above</a>(<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> cut) <span class="keyword">const</span>;
<a name="l00222"></a>00222   
<a name="l00223"></a>00223   
<a name="l00224"></a>00224  <span class="keyword">private</span>:
<a name="l00225"></a>00225   
<a name="l00226"></a>00226 };
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
