<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>steady_solver.h</h1>  </div>
</div>
<div class="contents">
<a href="steady__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 <span class="comment">// $Id: steady_solver.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00005"></a>00005 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00006"></a>00006   
<a name="l00007"></a>00007 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00008"></a>00008 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00009"></a>00009 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00010"></a>00010 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00011"></a>00011   
<a name="l00012"></a>00012 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00013"></a>00013 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00014"></a>00014 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00015"></a>00015 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00016"></a>00016   
<a name="l00017"></a>00017 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00018"></a>00018 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00019"></a>00019 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifndef __steady_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#define __steady_solver_h__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="time__solver_8h.php">time_solver.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Forward Declarations</span>
<a name="l00032"></a>00032 <span class="keyword">class </span><a class="code" href="classDiffContext.php">DiffContext</a>;
<a name="l00033"></a>00033 <span class="keyword">class </span><a class="code" href="classDifferentiableSystem.php">DifferentiableSystem</a>;
<a name="l00034"></a>00034 <span class="keyword">class </span><a class="code" href="classTimeSolver.php">TimeSolver</a>;
<a name="l00035"></a>00035 
<a name="l00047"></a>00047 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00048"></a>00048 <span class="comment">// Solver class definition</span>
<a name="l00049"></a><a class="code" href="classSteadySolver.php">00049</a> <span class="keyword">class </span><a class="code" href="classSteadySolver.php">SteadySolver</a> : <span class="keyword">public</span> <a class="code" href="classTimeSolver.php">TimeSolver</a>
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 <span class="keyword">public</span>:
<a name="l00055"></a><a class="code" href="classSteadySolver.php#a89bfc78101ea8131cc66ff8438f737f1">00055</a>   <span class="keyword">typedef</span> <a class="code" href="classDifferentiableSystem.php">DifferentiableSystem</a> <a class="code" href="classSteadySolver.php#a89bfc78101ea8131cc66ff8438f737f1">sys_type</a>;
<a name="l00056"></a>00056 
<a name="l00060"></a><a class="code" href="classSteadySolver.php#ab4f02c6b5d1b07f601f10798b3c2d5e1">00060</a>   <span class="keyword">typedef</span> <a class="code" href="classTimeSolver.php">TimeSolver</a> <a class="code" href="classSteadySolver.php#ab4f02c6b5d1b07f601f10798b3c2d5e1">Parent</a>;
<a name="l00061"></a>00061   
<a name="l00066"></a><a class="code" href="classSteadySolver.php#a027cbd6218fd1230d7f4091847b570e0">00066</a>   <a class="code" href="classSteadySolver.php#a027cbd6218fd1230d7f4091847b570e0">SteadySolver</a> (<a class="code" href="classDifferentiableSystem.php">sys_type</a>&amp; s) : <a class="code" href="classTimeSolver.php">Parent</a>(s) {}
<a name="l00067"></a>00067   
<a name="l00071"></a>00071   <span class="keyword">virtual</span> <a class="code" href="classSteadySolver.php#a888037e4814bd1473147d1d1ebb326fb">~SteadySolver</a> ();
<a name="l00072"></a>00072 
<a name="l00077"></a><a class="code" href="classSteadySolver.php#ab463a7018ce4ca79b0640d69b6c26d1d">00077</a>   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classSteadySolver.php#ab463a7018ce4ca79b0640d69b6c26d1d">error_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0.; }
<a name="l00078"></a>00078 
<a name="l00084"></a>00084   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classSteadySolver.php#ac0e0e93e6f59f26895c5100fd5b2ad87">element_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00085"></a>00085                                  <a class="code" href="classDiffContext.php">DiffContext</a> &amp;);
<a name="l00086"></a>00086 
<a name="l00092"></a>00092   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classSteadySolver.php#ab8a70755195ba17201eabf41b199f668">side_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00093"></a>00093                               <a class="code" href="classDiffContext.php">DiffContext</a> &amp;);
<a name="l00094"></a>00094 
<a name="l00100"></a><a class="code" href="classSteadySolver.php#ad338b1516afc16b25c0b7f9a552e9674">00100</a>   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classSteadySolver.php#ad338b1516afc16b25c0b7f9a552e9674">du</a>(<span class="keyword">const</span> <a class="code" href="classSystemNorm.php">SystemNorm</a>&amp;)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; };
<a name="l00101"></a>00101 };
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 <span class="preprocessor">#endif // #define __steady_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
