<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>stored_range.h</h1>  </div>
</div>
<div class="contents">
<a href="stored__range_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: stored_range.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __stored_range_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __stored_range_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;threads.h&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00049"></a>00049 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> iterator_type, <span class="keyword">typename</span> <span class="keywordtype">object</span>_type&gt;
<a name="l00050"></a><a class="code" href="classStoredRange.php">00050</a> <span class="keyword">class </span><a class="code" href="classStoredRange.php">StoredRange</a> 
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052 <span class="keyword">public</span>:
<a name="l00056"></a><a class="code" href="classStoredRange.php#ab2657352e8f9c79ab6fa4085c0bdd0d8">00056</a>   <span class="keyword">typedef</span> <span class="keyword">typename</span> std::vector&lt;object_type&gt;::const_iterator <a class="code" href="classStoredRange.php#ab2657352e8f9c79ab6fa4085c0bdd0d8">const_iterator</a>;
<a name="l00057"></a>00057 
<a name="l00063"></a><a class="code" href="classStoredRange.php#a4ac1e419ef576e7b86d161af2a4e68af">00063</a>   <a class="code" href="classStoredRange.php#a4ac1e419ef576e7b86d161af2a4e68af">StoredRange</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classStoredRange.php#a1e414e1ab1673d2d7024928485de4a38">grainsize</a> = 1000) :
<a name="l00064"></a>00064   <a class="code" href="classStoredRange.php#afaf472139962109a225cf08ff388057b">_grainsize</a>(<a class="code" href="classStoredRange.php#a1e414e1ab1673d2d7024928485de4a38">grainsize</a>)
<a name="l00065"></a>00065   {}
<a name="l00066"></a>00066 
<a name="l00073"></a><a class="code" href="classStoredRange.php#a38a2c3224e069a966cb2e93780bbf16b">00073</a>   <a class="code" href="classStoredRange.php#a4ac1e419ef576e7b86d161af2a4e68af">StoredRange</a> (<span class="keyword">const</span> iterator_type &amp;first,
<a name="l00074"></a>00074                <span class="keyword">const</span> iterator_type &amp;last,
<a name="l00075"></a>00075                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classStoredRange.php#a1e414e1ab1673d2d7024928485de4a38">grainsize</a> = 1000) :
<a name="l00076"></a>00076   <a class="code" href="classStoredRange.php#afaf472139962109a225cf08ff388057b">_grainsize</a>(<a class="code" href="classStoredRange.php#a1e414e1ab1673d2d7024928485de4a38">grainsize</a>)
<a name="l00077"></a>00077   {
<a name="l00078"></a>00078     this-&gt;<a class="code" href="classStoredRange.php#af4dbdb75d52bb8a40870e7d322306bc2">reset</a>(first, last);
<a name="l00079"></a>00079   }
<a name="l00080"></a>00080 
<a name="l00094"></a><a class="code" href="classStoredRange.php#a9f99f57b6b4e260c2b163bdfcfe5013a">00094</a>   <a class="code" href="classStoredRange.php#a4ac1e419ef576e7b86d161af2a4e68af">StoredRange</a> (<span class="keyword">const</span> <a class="code" href="classStoredRange.php">StoredRange&lt;iterator_type,object_type&gt;</a> &amp;er):
<a name="l00095"></a>00095     <a class="code" href="classStoredRange.php#afbab563604f713e43cefa6950ee118bf">_end</a>(er.<a class="code" href="classStoredRange.php#afbab563604f713e43cefa6950ee118bf">_end</a>), 
<a name="l00096"></a>00096     <a class="code" href="classStoredRange.php#aeadb21c69aadc035db9017bcc04c7f28">_begin</a>(er.<a class="code" href="classStoredRange.php#aeadb21c69aadc035db9017bcc04c7f28">_begin</a>),
<a name="l00097"></a>00097     <a class="code" href="classStoredRange.php#af111ef0053942334832cb778ac81e6ff">_last</a>(er.<a class="code" href="classStoredRange.php#af111ef0053942334832cb778ac81e6ff">_last</a>),
<a name="l00098"></a>00098     <a class="code" href="classStoredRange.php#a588a411fb56e5cb59d4f9a47d3dfd148">_first</a>(er.<a class="code" href="classStoredRange.php#a588a411fb56e5cb59d4f9a47d3dfd148">_first</a>),
<a name="l00099"></a>00099     <a class="code" href="classStoredRange.php#afaf472139962109a225cf08ff388057b">_grainsize</a>(er.<a class="code" href="classStoredRange.php#afaf472139962109a225cf08ff388057b">_grainsize</a>)
<a name="l00100"></a>00100   {
<a name="l00101"></a>00101     <span class="comment">// specifically, do *not* copy the vector</span>
<a name="l00102"></a>00102   }
<a name="l00103"></a>00103     
<a name="l00109"></a><a class="code" href="classStoredRange.php#a79ac4f38943836ee5f0c41ca031405d3">00109</a>   <a class="code" href="classStoredRange.php#a4ac1e419ef576e7b86d161af2a4e68af">StoredRange</a> (<a class="code" href="classStoredRange.php">StoredRange&lt;iterator_type,object_type&gt;</a> &amp;r, <a class="code" href="classThreads_1_1split.php">Threads::split</a> ) : 
<a name="l00110"></a>00110     <a class="code" href="classStoredRange.php#afbab563604f713e43cefa6950ee118bf">_end</a>(r.<a class="code" href="classStoredRange.php#afbab563604f713e43cefa6950ee118bf">_end</a>),
<a name="l00111"></a>00111     <a class="code" href="classStoredRange.php#aeadb21c69aadc035db9017bcc04c7f28">_begin</a>(r.<a class="code" href="classStoredRange.php#aeadb21c69aadc035db9017bcc04c7f28">_begin</a>),
<a name="l00112"></a>00112     <a class="code" href="classStoredRange.php#af111ef0053942334832cb778ac81e6ff">_last</a>(r.<a class="code" href="classStoredRange.php#af111ef0053942334832cb778ac81e6ff">_last</a>),
<a name="l00113"></a>00113     <a class="code" href="classStoredRange.php#a588a411fb56e5cb59d4f9a47d3dfd148">_first</a>(r.<a class="code" href="classStoredRange.php#a588a411fb56e5cb59d4f9a47d3dfd148">_first</a>),
<a name="l00114"></a>00114     <a class="code" href="classStoredRange.php#afaf472139962109a225cf08ff388057b">_grainsize</a>(r.<a class="code" href="classStoredRange.php#afaf472139962109a225cf08ff388057b">_grainsize</a>)
<a name="l00115"></a>00115   {
<a name="l00116"></a>00116     <a class="code" href="classStoredRange.php#ab2657352e8f9c79ab6fa4085c0bdd0d8">const_iterator</a>
<a name="l00117"></a>00117       beginning = r.<a class="code" href="classStoredRange.php#aeadb21c69aadc035db9017bcc04c7f28">_begin</a>,
<a name="l00118"></a>00118       ending    = r.<a class="code" href="classStoredRange.php#afbab563604f713e43cefa6950ee118bf">_end</a>,
<a name="l00119"></a>00119       middle    = beginning + std::distance(beginning, ending)/2u;
<a name="l00120"></a>00120     
<a name="l00121"></a>00121     r.<a class="code" href="classStoredRange.php#afbab563604f713e43cefa6950ee118bf">_end</a> = <a class="code" href="classStoredRange.php#aeadb21c69aadc035db9017bcc04c7f28">_begin</a> = middle;
<a name="l00122"></a>00122 
<a name="l00123"></a>00123     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00124"></a>00124       first = r.<a class="code" href="classStoredRange.php#a588a411fb56e5cb59d4f9a47d3dfd148">_first</a>,
<a name="l00125"></a>00125       last  = r.<a class="code" href="classStoredRange.php#af111ef0053942334832cb778ac81e6ff">_last</a>,
<a name="l00126"></a>00126       half  = first + (last-first)/2u;
<a name="l00127"></a>00127 
<a name="l00128"></a>00128     r.<a class="code" href="classStoredRange.php#af111ef0053942334832cb778ac81e6ff">_last</a> = <a class="code" href="classStoredRange.php#a588a411fb56e5cb59d4f9a47d3dfd148">_first</a> = half;
<a name="l00129"></a>00129   }
<a name="l00130"></a>00130     
<a name="l00136"></a>00136   <a class="code" href="classStoredRange.php">StoredRange&lt;iterator_type, object_type&gt;</a> &amp; 
<a name="l00137"></a><a class="code" href="classStoredRange.php#ab7da363a81a3cc10f34b7de11c0ffc6c">00137</a>   <a class="code" href="classStoredRange.php#af4dbdb75d52bb8a40870e7d322306bc2">reset</a> (<span class="keyword">const</span> iterator_type &amp;first,
<a name="l00138"></a>00138          <span class="keyword">const</span> iterator_type &amp;last)
<a name="l00139"></a>00139   {
<a name="l00140"></a>00140     <a class="code" href="classStoredRange.php#aca33bf35bea17620f858bba9e6da3720">_objs</a>.clear();
<a name="l00141"></a>00141 
<a name="l00142"></a>00142     <span class="keywordflow">for</span> (iterator_type it=first; it!=last; ++it)
<a name="l00143"></a>00143       <a class="code" href="classStoredRange.php#aca33bf35bea17620f858bba9e6da3720">_objs</a>.push_back(*it);
<a name="l00144"></a>00144     
<a name="l00145"></a>00145     <a class="code" href="classStoredRange.php#aeadb21c69aadc035db9017bcc04c7f28">_begin</a> = <a class="code" href="classStoredRange.php#aca33bf35bea17620f858bba9e6da3720">_objs</a>.begin();
<a name="l00146"></a>00146     <a class="code" href="classStoredRange.php#afbab563604f713e43cefa6950ee118bf">_end</a>   = <a class="code" href="classStoredRange.php#aca33bf35bea17620f858bba9e6da3720">_objs</a>.end();
<a name="l00147"></a>00147 
<a name="l00148"></a>00148     <a class="code" href="classStoredRange.php#a588a411fb56e5cb59d4f9a47d3dfd148">_first</a> = 0;
<a name="l00149"></a>00149     <a class="code" href="classStoredRange.php#af111ef0053942334832cb778ac81e6ff">_last</a>  = <a class="code" href="classStoredRange.php#aca33bf35bea17620f858bba9e6da3720">_objs</a>.size();
<a name="l00150"></a>00150     
<a name="l00151"></a>00151     <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00152"></a>00152   }
<a name="l00153"></a>00153 
<a name="l00161"></a><a class="code" href="classStoredRange.php#af4dbdb75d52bb8a40870e7d322306bc2">00161</a>   <a class="code" href="classStoredRange.php">StoredRange&lt;iterator_type, object_type&gt;</a> &amp; <a class="code" href="classStoredRange.php#af4dbdb75d52bb8a40870e7d322306bc2">reset</a> ()
<a name="l00162"></a>00162   {
<a name="l00163"></a>00163     <a class="code" href="classStoredRange.php#aeadb21c69aadc035db9017bcc04c7f28">_begin</a> = <a class="code" href="classStoredRange.php#aca33bf35bea17620f858bba9e6da3720">_objs</a>.begin();
<a name="l00164"></a>00164     <a class="code" href="classStoredRange.php#afbab563604f713e43cefa6950ee118bf">_end</a>   = <a class="code" href="classStoredRange.php#aca33bf35bea17620f858bba9e6da3720">_objs</a>.end();
<a name="l00165"></a>00165 
<a name="l00166"></a>00166     <a class="code" href="classStoredRange.php#a588a411fb56e5cb59d4f9a47d3dfd148">_first</a> = 0;
<a name="l00167"></a>00167     <a class="code" href="classStoredRange.php#af111ef0053942334832cb778ac81e6ff">_last</a>  = <a class="code" href="classStoredRange.php#aca33bf35bea17620f858bba9e6da3720">_objs</a>.size();
<a name="l00168"></a>00168 
<a name="l00169"></a>00169     <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00170"></a>00170   }
<a name="l00171"></a>00171   
<a name="l00175"></a><a class="code" href="classStoredRange.php#a5f753b5b424dff3ab8030ce64d7a9f0a">00175</a>   <a class="code" href="classStoredRange.php#ab2657352e8f9c79ab6fa4085c0bdd0d8">const_iterator</a> <a class="code" href="classStoredRange.php#a5f753b5b424dff3ab8030ce64d7a9f0a">begin</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classStoredRange.php#aeadb21c69aadc035db9017bcc04c7f28">_begin</a>; }  
<a name="l00176"></a>00176   
<a name="l00180"></a><a class="code" href="classStoredRange.php#abc8b19e0ebe76d4cda84e870e652fcf6">00180</a>   <a class="code" href="classStoredRange.php#ab2657352e8f9c79ab6fa4085c0bdd0d8">const_iterator</a> <a class="code" href="classStoredRange.php#abc8b19e0ebe76d4cda84e870e652fcf6">end</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classStoredRange.php#afbab563604f713e43cefa6950ee118bf">_end</a>; }
<a name="l00181"></a>00181 
<a name="l00185"></a><a class="code" href="classStoredRange.php#aba72e48cb72507cc7958557d61c2acfa">00185</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classStoredRange.php#aba72e48cb72507cc7958557d61c2acfa">first_idx</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classStoredRange.php#a588a411fb56e5cb59d4f9a47d3dfd148">_first</a>; }
<a name="l00186"></a>00186 
<a name="l00190"></a><a class="code" href="classStoredRange.php#a633f29d329e35a65e0c08044d1149f5b">00190</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classStoredRange.php#a633f29d329e35a65e0c08044d1149f5b">last_idx</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classStoredRange.php#af111ef0053942334832cb778ac81e6ff">_last</a>; }
<a name="l00191"></a>00191 
<a name="l00196"></a><a class="code" href="classStoredRange.php#a1e414e1ab1673d2d7024928485de4a38">00196</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classStoredRange.php#a1e414e1ab1673d2d7024928485de4a38">grainsize</a> ()<span class="keyword"> const </span>{<span class="keywordflow">return</span> <a class="code" href="classStoredRange.php#afaf472139962109a225cf08ff388057b">_grainsize</a>;}
<a name="l00197"></a>00197 
<a name="l00201"></a><a class="code" href="classStoredRange.php#ae47de29a8148afd28813551f6b96fbc7">00201</a>   <span class="keywordtype">void</span> <a class="code" href="classStoredRange.php#ae47de29a8148afd28813551f6b96fbc7">grainsize</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;gs) {<a class="code" href="classStoredRange.php#afaf472139962109a225cf08ff388057b">_grainsize</a> = gs;}
<a name="l00202"></a>00202 
<a name="l00206"></a><a class="code" href="classStoredRange.php#aa4308f7c39ae2586b8b8b7b171501e20">00206</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classStoredRange.php#aa4308f7c39ae2586b8b8b7b171501e20">size</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> std::distance(<a class="code" href="classStoredRange.php#aeadb21c69aadc035db9017bcc04c7f28">_begin</a>, <a class="code" href="classStoredRange.php#afbab563604f713e43cefa6950ee118bf">_end</a>); }
<a name="l00207"></a>00207 
<a name="l00208"></a>00208   <span class="comment">//------------------------------------------------------------------------</span>
<a name="l00209"></a>00209   <span class="comment">// Methods that implement Range concept</span>
<a name="l00210"></a>00210   <span class="comment">//------------------------------------------------------------------------</span>
<a name="l00211"></a>00211 
<a name="l00215"></a><a class="code" href="classStoredRange.php#a6ffe5670b736768c694b7295ce141696">00215</a>   <span class="keywordtype">bool</span> <a class="code" href="classStoredRange.php#a6ffe5670b736768c694b7295ce141696">empty</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (<a class="code" href="classStoredRange.php#aeadb21c69aadc035db9017bcc04c7f28">_begin</a> == <a class="code" href="classStoredRange.php#afbab563604f713e43cefa6950ee118bf">_end</a>); }
<a name="l00216"></a>00216 
<a name="l00220"></a><a class="code" href="classStoredRange.php#a5ed3453fc6d751c2d0a7f94f33ee21f0">00220</a>   <span class="keywordtype">bool</span> <a class="code" href="classStoredRange.php#a5ed3453fc6d751c2d0a7f94f33ee21f0">is_divisible</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classStoredRange.php#a1e414e1ab1673d2d7024928485de4a38">grainsize</a>() &lt; <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(std::distance(<a class="code" href="classStoredRange.php#aeadb21c69aadc035db9017bcc04c7f28">_begin</a>, <a class="code" href="classStoredRange.php#afbab563604f713e43cefa6950ee118bf">_end</a>)); }
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 <span class="keyword">private</span>:
<a name="l00223"></a>00223 
<a name="l00224"></a><a class="code" href="classStoredRange.php#afbab563604f713e43cefa6950ee118bf">00224</a>   <a class="code" href="classStoredRange.php#ab2657352e8f9c79ab6fa4085c0bdd0d8">const_iterator</a> <a class="code" href="classStoredRange.php#afbab563604f713e43cefa6950ee118bf">_end</a>;
<a name="l00225"></a><a class="code" href="classStoredRange.php#aeadb21c69aadc035db9017bcc04c7f28">00225</a>   <a class="code" href="classStoredRange.php#ab2657352e8f9c79ab6fa4085c0bdd0d8">const_iterator</a> <a class="code" href="classStoredRange.php#aeadb21c69aadc035db9017bcc04c7f28">_begin</a>;
<a name="l00226"></a><a class="code" href="classStoredRange.php#af111ef0053942334832cb778ac81e6ff">00226</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classStoredRange.php#af111ef0053942334832cb778ac81e6ff">_last</a>;
<a name="l00227"></a><a class="code" href="classStoredRange.php#a588a411fb56e5cb59d4f9a47d3dfd148">00227</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classStoredRange.php#a588a411fb56e5cb59d4f9a47d3dfd148">_first</a>;
<a name="l00228"></a><a class="code" href="classStoredRange.php#afaf472139962109a225cf08ff388057b">00228</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classStoredRange.php#afaf472139962109a225cf08ff388057b">_grainsize</a>;
<a name="l00229"></a><a class="code" href="classStoredRange.php#aca33bf35bea17620f858bba9e6da3720">00229</a>   std::vector&lt;object_type&gt; <a class="code" href="classStoredRange.php#aca33bf35bea17620f858bba9e6da3720">_objs</a>;
<a name="l00230"></a>00230 };
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 <span class="preprocessor">#endif // end #ifndef __stored_range_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
