<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_c2e5aa429b9110fa734bdc9647d91e10.php">utils</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>string_to_enum.C</h1>  </div>
</div>
<div class="contents">
<a href="string__to__enum_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: string_to_enum.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;string_to_enum.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;enum_elem_type.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;enum_order.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;enum_fe_family.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;enum_inf_map_type.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;enum_quadrature_type.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;enum_preconditioner_type.h&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00038"></a>00038 <span class="comment">// Anonymous namespace to hold local data &amp; methods</span>
<a name="l00039"></a>00039 <span class="keyword">namespace </span>{
<a name="l00040"></a>00040 
<a name="l00041"></a>00041   
<a name="l00042"></a>00042   <span class="comment">// Reverse a map</span>
<a name="l00043"></a>00043   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> MapIter, <span class="keyword">class</span> MapType&gt;
<a name="l00044"></a>00044   <span class="keyword">inline</span>
<a name="l00045"></a>00045   <span class="keywordtype">void</span> build_reverse_map (MapIter it, MapIter end, MapType&amp; reverse)
<a name="l00046"></a>00046   {
<a name="l00047"></a>00047     reverse.clear();
<a name="l00048"></a>00048     
<a name="l00049"></a>00049     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00050"></a>00050       {
<a name="l00051"></a>00051         <span class="comment">// If the forward map is not invertible, we might already have</span>
<a name="l00052"></a>00052         <span class="comment">// found a preimage of it-&gt;second.  Choose the &quot;largest&quot;</span>
<a name="l00053"></a>00053         <span class="comment">// preimage according to operator&lt;; for std::string this will</span>
<a name="l00054"></a>00054         <span class="comment">// give us the longest, hopefully most specific name</span>
<a name="l00055"></a>00055         <span class="comment">// corresponding to an enum.</span>
<a name="l00056"></a>00056         <span class="keyword">typename</span> MapType::iterator preimage = reverse.find(it-&gt;second);
<a name="l00057"></a>00057         <span class="keywordflow">if</span> (preimage == reverse.end())
<a name="l00058"></a>00058           reverse.insert (std::make_pair(it-&gt;second, it-&gt;first));
<a name="l00059"></a>00059         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (preimage-&gt;second &lt; it-&gt;first)
<a name="l00060"></a>00060           preimage-&gt;second = it-&gt;first;
<a name="l00061"></a>00061       }
<a name="l00062"></a>00062   }
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a>00065   <span class="comment">//----------------------------------------------------  </span>
<a name="l00066"></a>00066   std::map&lt;std::string, ElemType&gt; elem_type_to_enum;
<a name="l00067"></a>00067   
<a name="l00068"></a>00068   <span class="comment">// Initialize elem_type_to_enum on first call</span>
<a name="l00069"></a>00069   <span class="keywordtype">void</span> init_elem_type_to_enum ()
<a name="l00070"></a>00070   {
<a name="l00071"></a>00071     <span class="keywordflow">if</span> (elem_type_to_enum.empty())
<a name="l00072"></a>00072       {
<a name="l00073"></a>00073         elem_type_to_enum[<span class="stringliteral">&quot;EDGE&quot;</span>      ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>;
<a name="l00074"></a>00074         elem_type_to_enum[<span class="stringliteral">&quot;EDGE2&quot;</span>     ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>;
<a name="l00075"></a>00075         elem_type_to_enum[<span class="stringliteral">&quot;EDGE3&quot;</span>     ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>;
<a name="l00076"></a>00076         elem_type_to_enum[<span class="stringliteral">&quot;EDGE4&quot;</span>     ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>;
<a name="l00077"></a>00077         
<a name="l00078"></a>00078         elem_type_to_enum[<span class="stringliteral">&quot;TRI&quot;</span>       ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>;
<a name="l00079"></a>00079         elem_type_to_enum[<span class="stringliteral">&quot;TRI3&quot;</span>      ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>;
<a name="l00080"></a>00080         elem_type_to_enum[<span class="stringliteral">&quot;TRI6&quot;</span>      ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>;
<a name="l00081"></a>00081         
<a name="l00082"></a>00082         elem_type_to_enum[<span class="stringliteral">&quot;QUAD&quot;</span>      ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>;
<a name="l00083"></a>00083         elem_type_to_enum[<span class="stringliteral">&quot;QUAD4&quot;</span>     ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>;
<a name="l00084"></a>00084         elem_type_to_enum[<span class="stringliteral">&quot;QUAD8&quot;</span>     ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>;
<a name="l00085"></a>00085         elem_type_to_enum[<span class="stringliteral">&quot;QUAD9&quot;</span>     ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>;
<a name="l00086"></a>00086         
<a name="l00087"></a>00087         elem_type_to_enum[<span class="stringliteral">&quot;TET&quot;</span>       ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>;
<a name="l00088"></a>00088         elem_type_to_enum[<span class="stringliteral">&quot;TET4&quot;</span>      ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>;
<a name="l00089"></a>00089         elem_type_to_enum[<span class="stringliteral">&quot;TET10&quot;</span>     ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>;
<a name="l00090"></a>00090         
<a name="l00091"></a>00091         elem_type_to_enum[<span class="stringliteral">&quot;HEX&quot;</span>       ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>;
<a name="l00092"></a>00092         elem_type_to_enum[<span class="stringliteral">&quot;HEX8&quot;</span>      ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>;
<a name="l00093"></a>00093         elem_type_to_enum[<span class="stringliteral">&quot;HEX20&quot;</span>     ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>;
<a name="l00094"></a>00094         elem_type_to_enum[<span class="stringliteral">&quot;HEX27&quot;</span>     ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>;
<a name="l00095"></a>00095         
<a name="l00096"></a>00096         elem_type_to_enum[<span class="stringliteral">&quot;PRISM&quot;</span>     ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>;
<a name="l00097"></a>00097         elem_type_to_enum[<span class="stringliteral">&quot;PRISM6&quot;</span>    ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>;
<a name="l00098"></a>00098         elem_type_to_enum[<span class="stringliteral">&quot;PRISM15&quot;</span>   ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>;
<a name="l00099"></a>00099         elem_type_to_enum[<span class="stringliteral">&quot;PRISM18&quot;</span>   ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>;
<a name="l00100"></a>00100         
<a name="l00101"></a>00101         elem_type_to_enum[<span class="stringliteral">&quot;PYRAMID&quot;</span>   ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>;
<a name="l00102"></a>00102         elem_type_to_enum[<span class="stringliteral">&quot;PYRAMID5&quot;</span>  ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>;
<a name="l00103"></a>00103         
<a name="l00104"></a>00104         elem_type_to_enum[<span class="stringliteral">&quot;INFEDGE&quot;</span>   ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a278476b80069e0630827235779c82c47">INFEDGE2</a>;
<a name="l00105"></a>00105         elem_type_to_enum[<span class="stringliteral">&quot;INFEDGE2&quot;</span>  ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a278476b80069e0630827235779c82c47">INFEDGE2</a>;
<a name="l00106"></a>00106         
<a name="l00107"></a>00107         elem_type_to_enum[<span class="stringliteral">&quot;INFQUAD&quot;</span>   ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a23d0ae825ee3f493b6504b71f28e2aef">INFQUAD4</a>;
<a name="l00108"></a>00108         elem_type_to_enum[<span class="stringliteral">&quot;INFQUAD4&quot;</span>  ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a23d0ae825ee3f493b6504b71f28e2aef">INFQUAD4</a>;
<a name="l00109"></a>00109         elem_type_to_enum[<span class="stringliteral">&quot;INFQUAD6&quot;</span>  ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a669ef57bb0d4c72fd22fa0f4febe6ac1">INFQUAD6</a>;
<a name="l00110"></a>00110         
<a name="l00111"></a>00111         elem_type_to_enum[<span class="stringliteral">&quot;INFHEX&quot;</span>    ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a54cedbd05931dd2cb7dcabf0109bddcb">INFHEX8</a>;
<a name="l00112"></a>00112         elem_type_to_enum[<span class="stringliteral">&quot;INFHEX8&quot;</span>   ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a54cedbd05931dd2cb7dcabf0109bddcb">INFHEX8</a>;
<a name="l00113"></a>00113         elem_type_to_enum[<span class="stringliteral">&quot;INFHEX16&quot;</span>  ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a583e72df1b20e339d9f8fcea6a94c1d4">INFHEX16</a>;
<a name="l00114"></a>00114         elem_type_to_enum[<span class="stringliteral">&quot;INFHEX18&quot;</span>  ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4e68f53177cc7d1366225dfc8f7bbbed">INFHEX18</a>;
<a name="l00115"></a>00115         
<a name="l00116"></a>00116         elem_type_to_enum[<span class="stringliteral">&quot;INFPRISM&quot;</span>  ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac6743a9a04524105e37159e924c4a33b">INFPRISM6</a>;
<a name="l00117"></a>00117         elem_type_to_enum[<span class="stringliteral">&quot;INFPRISM6&quot;</span> ]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac6743a9a04524105e37159e924c4a33b">INFPRISM6</a>;
<a name="l00118"></a>00118         elem_type_to_enum[<span class="stringliteral">&quot;INFPRISM12&quot;</span>]=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a89630f5af6a58aaa9ae731d924139c61">INFPRISM12</a>;
<a name="l00119"></a>00119       }
<a name="l00120"></a>00120   }
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a>00123   
<a name="l00124"></a>00124   std::map&lt;ElemType, std::string&gt; enum_to_elem_type;
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   <span class="comment">// Initialize the enum_to_elem_type on first call</span>
<a name="l00127"></a>00127   <span class="keywordtype">void</span> init_enum_to_elem_type ()
<a name="l00128"></a>00128   {
<a name="l00129"></a>00129     <span class="comment">// Build reverse map</span>
<a name="l00130"></a>00130     <span class="keywordflow">if</span> (enum_to_elem_type.empty())
<a name="l00131"></a>00131       {
<a name="l00132"></a>00132         <span class="comment">// Initialize elem_type_to_enum on first call</span>
<a name="l00133"></a>00133         init_elem_type_to_enum();
<a name="l00134"></a>00134 
<a name="l00135"></a>00135         build_reverse_map (elem_type_to_enum.begin(),
<a name="l00136"></a>00136                            elem_type_to_enum.end(),
<a name="l00137"></a>00137                            enum_to_elem_type);
<a name="l00138"></a>00138       }
<a name="l00139"></a>00139   }
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143   
<a name="l00144"></a>00144   <span class="comment">//---------------------------------------------</span>
<a name="l00145"></a>00145   std::map&lt;std::string, Order&gt; order_to_enum;
<a name="l00146"></a>00146   
<a name="l00147"></a>00147   <span class="comment">// Initialize order_to_enum on first call</span>
<a name="l00148"></a>00148   <span class="keywordtype">void</span> init_order_to_enum ()
<a name="l00149"></a>00149   {
<a name="l00150"></a>00150     <span class="keywordflow">if</span> (order_to_enum.empty())
<a name="l00151"></a>00151       {
<a name="l00152"></a>00152         order_to_enum[<span class="stringliteral">&quot;CONSTANT&quot;</span>     ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fab999dd3da94a1ab81b0359e1fd11c6fa">CONSTANT</a>;
<a name="l00153"></a>00153         order_to_enum[<span class="stringliteral">&quot;FIRST&quot;</span>        ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>;
<a name="l00154"></a>00154         order_to_enum[<span class="stringliteral">&quot;SECOND&quot;</span>       ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>;
<a name="l00155"></a>00155         order_to_enum[<span class="stringliteral">&quot;THIRD&quot;</span>        ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>;
<a name="l00156"></a>00156         order_to_enum[<span class="stringliteral">&quot;FOURTH&quot;</span>       ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa786b5502dc91e9f53b5cbc9c284852a0">FOURTH</a>;
<a name="l00157"></a>00157         order_to_enum[<span class="stringliteral">&quot;FIFTH&quot;</span>        ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa357bed9167850d65b08770e2ab6587ac">FIFTH</a>;
<a name="l00158"></a>00158         order_to_enum[<span class="stringliteral">&quot;SIXTH&quot;</span>        ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa12e4c6641c177b3d6a15fa73eb5bfa1a">SIXTH</a>;
<a name="l00159"></a>00159         order_to_enum[<span class="stringliteral">&quot;SEVENTH&quot;</span>      ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa084350fc91ff5f1f99dc2a99e9494e1f">SEVENTH</a>;
<a name="l00160"></a>00160         order_to_enum[<span class="stringliteral">&quot;EIGHTH&quot;</span>       ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa10019183220ee3e691f593d9507eb620">EIGHTH</a>;
<a name="l00161"></a>00161         order_to_enum[<span class="stringliteral">&quot;NINTH&quot;</span>        ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa96e4b793b046031faa991f15f1a80bc6">NINTH</a>;
<a name="l00162"></a>00162         order_to_enum[<span class="stringliteral">&quot;TENTH&quot;</span>        ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa6115f555ee86d242617207bec760f208">TENTH</a>;
<a name="l00163"></a>00163                                                   
<a name="l00164"></a>00164         order_to_enum[<span class="stringliteral">&quot;ELEVENTH&quot;</span>     ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa9d8cd1c6f2feb41a556c16d8cb4744cd">ELEVENTH</a>;
<a name="l00165"></a>00165         order_to_enum[<span class="stringliteral">&quot;TWELFTH&quot;</span>      ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa72ff7b576c902d58a9fc3ad53b247a85">TWELFTH</a>;
<a name="l00166"></a>00166         order_to_enum[<span class="stringliteral">&quot;THIRTEENTH&quot;</span>   ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faeb2a82bbe2a44c6917cedc029423ce75">THIRTEENTH</a>;
<a name="l00167"></a>00167         order_to_enum[<span class="stringliteral">&quot;FOURTEENTH&quot;</span>   ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faab1534905d9792db00394cf617c71749">FOURTEENTH</a>;
<a name="l00168"></a>00168         order_to_enum[<span class="stringliteral">&quot;FIFTEENTH&quot;</span>    ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa7120ce4c6dcb4b9465b15e7531631fe6">FIFTEENTH</a>;
<a name="l00169"></a>00169         order_to_enum[<span class="stringliteral">&quot;SIXTEENTH&quot;</span>    ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fad3a83c160ba19d280cf82ab0fee65f2d">SIXTEENTH</a>;
<a name="l00170"></a>00170         order_to_enum[<span class="stringliteral">&quot;SEVENTEENTH&quot;</span>  ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fae4eeb80a784baaf763cdccf0a47a4557">SEVENTEENTH</a>;
<a name="l00171"></a>00171         order_to_enum[<span class="stringliteral">&quot;EIGHTTEENTH&quot;</span>  ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa04abe26889214024e6b01556757afebc">EIGHTTEENTH</a>;
<a name="l00172"></a>00172         order_to_enum[<span class="stringliteral">&quot;NINTEENTH&quot;</span>    ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa460d128a5ae3f0cab006386047945a63">NINTEENTH</a>;
<a name="l00173"></a>00173         order_to_enum[<span class="stringliteral">&quot;TWENTIETH&quot;</span>    ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1fd67e9ea1cf7030e0e5b9c6e82698a2">TWENTIETH</a>;
<a name="l00174"></a>00174                                                   
<a name="l00175"></a>00175         order_to_enum[<span class="stringliteral">&quot;TWENTYFIRST&quot;</span>  ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa6e1551e839c8196b348cd883be5a4bd8">TWENTYFIRST</a>;
<a name="l00176"></a>00176         order_to_enum[<span class="stringliteral">&quot;TWENTYSECOND&quot;</span> ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fac53c44bf97483f77b3b8f12689d1025f">TWENTYSECOND</a>;
<a name="l00177"></a>00177         order_to_enum[<span class="stringliteral">&quot;TWENTYTHIRD&quot;</span>  ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1dda25317008178eb86eef7e967e9ecf">TWENTYTHIRD</a>;
<a name="l00178"></a>00178         order_to_enum[<span class="stringliteral">&quot;TWENTYFOURTH&quot;</span> ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa8093001568608e51bbe10f03c871fc41">TWENTYFOURTH</a>;
<a name="l00179"></a>00179         order_to_enum[<span class="stringliteral">&quot;TWENTYFIFTH&quot;</span>  ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fad2f79bea88fd463e33a7800d828bded9">TWENTYFIFTH</a>;
<a name="l00180"></a>00180         order_to_enum[<span class="stringliteral">&quot;TWENTYSIXTH&quot;</span>  ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa5f33eeba0f7239d41b54654ce8d99aa3">TWENTYSIXTH</a>;
<a name="l00181"></a>00181         order_to_enum[<span class="stringliteral">&quot;TWENTYSEVENTH&quot;</span>]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0facb1defec8f9bfcd21f5ef0f62fcacd2f">TWENTYSEVENTH</a>;
<a name="l00182"></a>00182         order_to_enum[<span class="stringliteral">&quot;TWENTYEIGHTH&quot;</span> ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa0e295eb2dfc5e7e8c49b433ae27b1369">TWENTYEIGHTH</a>;
<a name="l00183"></a>00183         order_to_enum[<span class="stringliteral">&quot;TWENTYNINTH&quot;</span>  ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa2e33cfffe6c21901c488cc5c58d5bae9">TWENTYNINTH</a>;
<a name="l00184"></a>00184         order_to_enum[<span class="stringliteral">&quot;THIRTIETH&quot;</span>    ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fac64b552bcc7fd10e6a8723de2e2a1250">THIRTIETH</a>;
<a name="l00185"></a>00185                                                   
<a name="l00186"></a>00186         order_to_enum[<span class="stringliteral">&quot;THIRTYFIRST&quot;</span>  ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa6812a2218979fea1f20f3cdf06d855a9">THIRTYFIRST</a>;
<a name="l00187"></a>00187         order_to_enum[<span class="stringliteral">&quot;THIRTYSECOND&quot;</span> ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa88a052a9254947f209a5736a2cf49b19">THIRTYSECOND</a>;
<a name="l00188"></a>00188         order_to_enum[<span class="stringliteral">&quot;THIRTYTHIRD&quot;</span>  ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa15d72f9acb6abf33bfbd64b4afdb59b4">THIRTYTHIRD</a>;
<a name="l00189"></a>00189         order_to_enum[<span class="stringliteral">&quot;THIRTYFOURTH&quot;</span> ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa621d865989d4fc3580a8d55ddc63a03a">THIRTYFOURTH</a>;
<a name="l00190"></a>00190         order_to_enum[<span class="stringliteral">&quot;THIRTYFIFTH&quot;</span>  ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faa8088f586a6b0baa0a05d6a18361510e">THIRTYFIFTH</a>;
<a name="l00191"></a>00191         order_to_enum[<span class="stringliteral">&quot;THIRTYSIXTH&quot;</span>  ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1c81e8502e0dabbaa5ea9e87b53459bd">THIRTYSIXTH</a>;
<a name="l00192"></a>00192         order_to_enum[<span class="stringliteral">&quot;THIRTYSEVENTH&quot;</span>]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa24cbc0dd8da68e1efcf1873487f9904c">THIRTYSEVENTH</a>;
<a name="l00193"></a>00193         order_to_enum[<span class="stringliteral">&quot;THIRTYEIGHTH&quot;</span> ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fad7b5f8e152598d25c7c161f15221f5be">THIRTYEIGHTH</a>;
<a name="l00194"></a>00194         order_to_enum[<span class="stringliteral">&quot;THIRTYNINTH&quot;</span>  ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa7686c65f85c6e3ec25fb1ce492b41e2c">THIRTYNINTH</a>;
<a name="l00195"></a>00195         order_to_enum[<span class="stringliteral">&quot;FORTIETH&quot;</span>    ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa0b2b50be416b002ce458061fe2d7506a">FORTIETH</a>;
<a name="l00196"></a>00196                                                   
<a name="l00197"></a>00197         order_to_enum[<span class="stringliteral">&quot;FORTYFIRST&quot;</span>  ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faae7b8a6cf8f301aa024087e7f371a81c">FORTYFIRST</a>;
<a name="l00198"></a>00198         order_to_enum[<span class="stringliteral">&quot;FORTYSECOND&quot;</span> ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faf1ea9fc7d47660c23ff7ff4c0ffae985">FORTYSECOND</a>;
<a name="l00199"></a>00199         order_to_enum[<span class="stringliteral">&quot;FORTYTHIRD&quot;</span>  ]=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa5536e362ffba6fc36737d12d56016794">FORTYTHIRD</a>;
<a name="l00200"></a>00200       }
<a name="l00201"></a>00201   }
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   std::map&lt;Order, std::string&gt; enum_to_order;
<a name="l00206"></a>00206   
<a name="l00207"></a>00207   <span class="comment">// Initialize the enum_to_order on first call</span>
<a name="l00208"></a>00208   <span class="keywordtype">void</span> init_enum_to_order ()
<a name="l00209"></a>00209   {
<a name="l00210"></a>00210     <span class="comment">// Build reverse map</span>
<a name="l00211"></a>00211     <span class="keywordflow">if</span> (enum_to_order.empty())
<a name="l00212"></a>00212       {
<a name="l00213"></a>00213         <span class="comment">// Initialize order_to_enum on first call</span>
<a name="l00214"></a>00214         init_order_to_enum();
<a name="l00215"></a>00215 
<a name="l00216"></a>00216         build_reverse_map (order_to_enum.begin(),
<a name="l00217"></a>00217                            order_to_enum.end(),
<a name="l00218"></a>00218                            enum_to_order);
<a name="l00219"></a>00219       }
<a name="l00220"></a>00220   }
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 
<a name="l00224"></a>00224   <span class="comment">//---------------------------------------------------  </span>
<a name="l00225"></a>00225   std::map&lt;std::string, FEFamily&gt; fefamily_to_enum;
<a name="l00226"></a>00226 
<a name="l00227"></a>00227   <span class="comment">// Initialize fefamily_to_enum on first call</span>
<a name="l00228"></a>00228   <span class="keywordtype">void</span> init_fefamily_to_enum ()
<a name="l00229"></a>00229   {
<a name="l00230"></a>00230     <span class="keywordflow">if</span> (fefamily_to_enum.empty())
<a name="l00231"></a>00231       {
<a name="l00232"></a>00232         fefamily_to_enum[<span class="stringliteral">&quot;LAGRANGE&quot;</span>    ]=<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>;
<a name="l00233"></a>00233         fefamily_to_enum[<span class="stringliteral">&quot;HIERARCHIC&quot;</span>  ]=<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>;
<a name="l00234"></a>00234         fefamily_to_enum[<span class="stringliteral">&quot;MONOMIAL&quot;</span>    ]=<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>;
<a name="l00235"></a>00235         fefamily_to_enum[<span class="stringliteral">&quot;SCALAR&quot;</span>      ]=<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>;
<a name="l00236"></a>00236         fefamily_to_enum[<span class="stringliteral">&quot;XYZ&quot;</span>         ]=<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>;
<a name="l00237"></a>00237         fefamily_to_enum[<span class="stringliteral">&quot;BERNSTEIN&quot;</span>   ]=<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>;
<a name="l00238"></a>00238         fefamily_to_enum[<span class="stringliteral">&quot;SZABAB&quot;</span>      ]=<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>;
<a name="l00239"></a>00239         fefamily_to_enum[<span class="stringliteral">&quot;INFINITE_MAP&quot;</span>]=<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a71025d1f59830aa9264a533822120185">INFINITE_MAP</a>;
<a name="l00240"></a>00240         fefamily_to_enum[<span class="stringliteral">&quot;JACOBI_20_00&quot;</span>]=<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac8091b262c367b2c2c8b213ea407c444">JACOBI_20_00</a>;
<a name="l00241"></a>00241         fefamily_to_enum[<span class="stringliteral">&quot;JACOBI_30_00&quot;</span>]=<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0c05e061ee42e52270205fd2d4fb77bc">JACOBI_30_00</a>;
<a name="l00242"></a>00242         fefamily_to_enum[<span class="stringliteral">&quot;LEGENDRE&quot;</span>    ]=<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a592c7a57b998aa47edeb98321e1aa970">LEGENDRE</a>;
<a name="l00243"></a>00243         fefamily_to_enum[<span class="stringliteral">&quot;CLOUGH&quot;</span>      ]=<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>;
<a name="l00244"></a>00244         fefamily_to_enum[<span class="stringliteral">&quot;HERMITE&quot;</span>     ]=<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>;
<a name="l00245"></a>00245       }
<a name="l00246"></a>00246     
<a name="l00247"></a>00247   }
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 
<a name="l00250"></a>00250   std::map&lt;FEFamily, std::string&gt; enum_to_fefamily;
<a name="l00251"></a>00251   
<a name="l00252"></a>00252   <span class="comment">// Initialize the enum_to_fefamily on first call</span>
<a name="l00253"></a>00253   <span class="keywordtype">void</span> init_enum_to_fefamily ()
<a name="l00254"></a>00254   {
<a name="l00255"></a>00255     <span class="comment">// Build reverse map</span>
<a name="l00256"></a>00256     <span class="keywordflow">if</span> (enum_to_fefamily.empty())
<a name="l00257"></a>00257       {
<a name="l00258"></a>00258         <span class="comment">// Initialize fefamily_to_enum on first call</span>
<a name="l00259"></a>00259         init_fefamily_to_enum();
<a name="l00260"></a>00260 
<a name="l00261"></a>00261         build_reverse_map (fefamily_to_enum.begin(),
<a name="l00262"></a>00262                            fefamily_to_enum.end(),
<a name="l00263"></a>00263                            enum_to_fefamily);
<a name="l00264"></a>00264       }
<a name="l00265"></a>00265   }
<a name="l00266"></a>00266 
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 
<a name="l00269"></a>00269   <span class="comment">//---------------------------------------------------  </span>
<a name="l00270"></a>00270   std::map&lt;std::string, InfMapType&gt; inf_map_type_to_enum;
<a name="l00271"></a>00271 
<a name="l00272"></a>00272   <span class="comment">// Initialize inf_map_type_to_enum on first call</span>
<a name="l00273"></a>00273   <span class="keywordtype">void</span> init_inf_map_type_to_enum ()
<a name="l00274"></a>00274   {
<a name="l00275"></a>00275     <span class="keywordflow">if</span> (inf_map_type_to_enum.empty())
<a name="l00276"></a>00276       {
<a name="l00277"></a>00277         inf_map_type_to_enum[<span class="stringliteral">&quot;CARTESIAN&quot;</span>  ]=<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>;
<a name="l00278"></a>00278         inf_map_type_to_enum[<span class="stringliteral">&quot;SPHERICAL&quot;</span>  ]=<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a43327a8402d2f1174b5d029b35ab2848">SPHERICAL</a>;
<a name="l00279"></a>00279         inf_map_type_to_enum[<span class="stringliteral">&quot;ELLIPSOIDAL&quot;</span>]=<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a7d49a738860410cd543fb5d64202cd3b">ELLIPSOIDAL</a>;
<a name="l00280"></a>00280       }    
<a name="l00281"></a>00281   }
<a name="l00282"></a>00282 
<a name="l00283"></a>00283 
<a name="l00284"></a>00284   std::map&lt;InfMapType, std::string&gt; enum_to_inf_map_type;
<a name="l00285"></a>00285   
<a name="l00286"></a>00286   <span class="comment">// Initialize the enum_to_inf_map_type on first call</span>
<a name="l00287"></a>00287   <span class="keywordtype">void</span> init_enum_to_inf_map_type ()
<a name="l00288"></a>00288   {
<a name="l00289"></a>00289     <span class="comment">// Build reverse map</span>
<a name="l00290"></a>00290     <span class="keywordflow">if</span> (enum_to_inf_map_type.empty())
<a name="l00291"></a>00291       {
<a name="l00292"></a>00292         <span class="comment">// Initialize inf_map_type_to_enum on first call</span>
<a name="l00293"></a>00293         init_inf_map_type_to_enum();
<a name="l00294"></a>00294 
<a name="l00295"></a>00295         build_reverse_map (inf_map_type_to_enum.begin(),
<a name="l00296"></a>00296                            inf_map_type_to_enum.end(),
<a name="l00297"></a>00297                            enum_to_inf_map_type);
<a name="l00298"></a>00298       }
<a name="l00299"></a>00299   }
<a name="l00300"></a>00300 
<a name="l00301"></a>00301 
<a name="l00302"></a>00302 
<a name="l00303"></a>00303   <span class="comment">//---------------------------------------------------  </span>
<a name="l00304"></a>00304   std::map&lt;std::string, QuadratureType&gt; quadrature_type_to_enum;
<a name="l00305"></a>00305 
<a name="l00306"></a>00306   <span class="comment">// Initialize quadrature_type_to_enum on first call</span>
<a name="l00307"></a>00307   <span class="keywordtype">void</span> init_quadrature_type_to_enum ()
<a name="l00308"></a>00308   {
<a name="l00309"></a>00309     <span class="keywordflow">if</span> (quadrature_type_to_enum.empty())
<a name="l00310"></a>00310       {
<a name="l00311"></a>00311         quadrature_type_to_enum[<span class="stringliteral">&quot;QGAUSS&quot;</span>     ]=<a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ada11bd5a126c073e475e588e38016b3785">QGAUSS</a>;
<a name="l00312"></a>00312         quadrature_type_to_enum[<span class="stringliteral">&quot;QJACOBI_1_0&quot;</span>]=<a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716adad3a339e15685559999115b81f6d38370">QJACOBI_1_0</a>;
<a name="l00313"></a>00313         quadrature_type_to_enum[<span class="stringliteral">&quot;QJACOBI_2_0&quot;</span>]=<a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ada52629eed7dec8b36fbd387b3dd51d48d">QJACOBI_2_0</a>;
<a name="l00314"></a>00314         quadrature_type_to_enum[<span class="stringliteral">&quot;QSIMPSON&quot;</span>   ]=<a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716adaeb07c05dac20ab7f134838e34f9db0c1">QSIMPSON</a>;
<a name="l00315"></a>00315         quadrature_type_to_enum[<span class="stringliteral">&quot;QTRAP&quot;</span>      ]=<a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ada26431abeff146407680a87ae0dd3a39a">QTRAP</a>;
<a name="l00316"></a>00316         quadrature_type_to_enum[<span class="stringliteral">&quot;QGRID&quot;</span>      ]=<a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ada0205c4820461f2f6e60de9d5a3894050">QGRID</a>;
<a name="l00317"></a>00317         quadrature_type_to_enum[<span class="stringliteral">&quot;QCLOUGH&quot;</span>    ]=<a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ada6a44b32cfeb467cf770cd8ff2d462c77">QCLOUGH</a>;
<a name="l00318"></a>00318       }    
<a name="l00319"></a>00319   }
<a name="l00320"></a>00320 
<a name="l00321"></a>00321 
<a name="l00322"></a>00322   std::map&lt;QuadratureType, std::string&gt; enum_to_quadrature_type;
<a name="l00323"></a>00323   
<a name="l00324"></a>00324   <span class="comment">// Initialize the enum_to_quadrature_type on first call</span>
<a name="l00325"></a>00325   <span class="keywordtype">void</span> init_enum_to_quadrature_type ()
<a name="l00326"></a>00326   {
<a name="l00327"></a>00327     <span class="comment">// Build reverse map</span>
<a name="l00328"></a>00328     <span class="keywordflow">if</span> (enum_to_quadrature_type.empty())
<a name="l00329"></a>00329       {
<a name="l00330"></a>00330         <span class="comment">// Initialize inf_map_type_to_enum on first call</span>
<a name="l00331"></a>00331         init_quadrature_type_to_enum();
<a name="l00332"></a>00332 
<a name="l00333"></a>00333         build_reverse_map (quadrature_type_to_enum.begin(),
<a name="l00334"></a>00334                            quadrature_type_to_enum.end(),
<a name="l00335"></a>00335                            enum_to_quadrature_type);
<a name="l00336"></a>00336       }
<a name="l00337"></a>00337   }
<a name="l00338"></a>00338 
<a name="l00339"></a>00339 
<a name="l00340"></a>00340   <span class="comment">//---------------------------------------------------  </span>
<a name="l00341"></a>00341   std::map&lt;std::string, PreconditionerType&gt; preconditioner_type_to_enum;
<a name="l00342"></a>00342 
<a name="l00343"></a>00343   <span class="comment">// Initialize preconditioner_type_to_enum on first call</span>
<a name="l00344"></a>00344   <span class="keywordtype">void</span> init_preconditioner_type_to_enum ()
<a name="l00345"></a>00345   {
<a name="l00346"></a>00346     <span class="keywordflow">if</span> (preconditioner_type_to_enum.empty())
<a name="l00347"></a>00347       {
<a name="l00348"></a>00348         preconditioner_type_to_enum[<span class="stringliteral">&quot;IDENTITY_PRECOND&quot;</span>      ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a44a26581f6d3dd94e7188bbb4af8294a">IDENTITY_PRECOND</a>;
<a name="l00349"></a>00349         preconditioner_type_to_enum[<span class="stringliteral">&quot;JACOBI_PRECOND&quot;</span>        ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a9b2d6ff994aa4cfb181f5eceec23174f">JACOBI_PRECOND</a>;
<a name="l00350"></a>00350         preconditioner_type_to_enum[<span class="stringliteral">&quot;BLOCK_JACOBI_PRECOND&quot;</span>  ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a8f036d61e96c69b14d585f04235613d2">BLOCK_JACOBI_PRECOND</a>;
<a name="l00351"></a>00351         preconditioner_type_to_enum[<span class="stringliteral">&quot;SOR_PRECOND&quot;</span>           ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a52da319102c9f93cef67896f122614b9">SOR_PRECOND</a>;
<a name="l00352"></a>00352         preconditioner_type_to_enum[<span class="stringliteral">&quot;SSOR_PRECOND&quot;</span>          ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a9e50971811a02ac1f940c7d803cc2b4c">SSOR_PRECOND</a>;
<a name="l00353"></a>00353         preconditioner_type_to_enum[<span class="stringliteral">&quot;EISENSTAT_PRECOND&quot;</span>     ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a7e8d6554e69fa3376ef61e35b17d92a4">EISENSTAT_PRECOND</a>;
<a name="l00354"></a>00354         preconditioner_type_to_enum[<span class="stringliteral">&quot;ASM_PRECOND&quot;</span>           ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a791f4098f0a9d74f940c5e1fb1215582">ASM_PRECOND</a>;
<a name="l00355"></a>00355         preconditioner_type_to_enum[<span class="stringliteral">&quot;CHOLESKY_PRECOND&quot;</span>      ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a01ae0c1024d6b2ae4022dbf0e0317ea9">CHOLESKY_PRECOND</a>;  
<a name="l00356"></a>00356         preconditioner_type_to_enum[<span class="stringliteral">&quot;ICC_PRECOND&quot;</span>           ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4ad530e0c240976b35094aee7290848d7f">ICC_PRECOND</a>;               
<a name="l00357"></a>00357         preconditioner_type_to_enum[<span class="stringliteral">&quot;ILU_PRECOND&quot;</span>           ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4af54549e0e69fbdd4ddd199ee316527f3">ILU_PRECOND</a>;               
<a name="l00358"></a>00358         preconditioner_type_to_enum[<span class="stringliteral">&quot;LU_PRECOND&quot;</span>            ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4af6625c293f8dbecf282cac92d7a8c8fb">LU_PRECOND</a>;                
<a name="l00359"></a>00359         preconditioner_type_to_enum[<span class="stringliteral">&quot;USER_PRECOND&quot;</span>          ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4ae3a9e261a354c7a05a8a8d0648f210de">USER_PRECOND</a>;      
<a name="l00360"></a>00360         preconditioner_type_to_enum[<span class="stringliteral">&quot;SHELL_PRECOND&quot;</span>         ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4af09677d7fa99ef863f62c4f26266b27f">SHELL_PRECOND</a>;     
<a name="l00361"></a>00361         preconditioner_type_to_enum[<span class="stringliteral">&quot;AMG_PRECOND&quot;</span>           ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4ac436c2c16e4aaaf30a5d761bc7e6c621">AMG_PRECOND</a>;               
<a name="l00362"></a>00362         preconditioner_type_to_enum[<span class="stringliteral">&quot;INVALID_PRECONDITIONER&quot;</span>]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a531a6705593a3d669e898d2d102cc931">INVALID_PRECONDITIONER</a>;
<a name="l00363"></a>00363 
<a name="l00364"></a>00364         <span class="comment">//shorter</span>
<a name="l00365"></a>00365         preconditioner_type_to_enum[<span class="stringliteral">&quot;IDENTITY&quot;</span>    ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a44a26581f6d3dd94e7188bbb4af8294a">IDENTITY_PRECOND</a>;
<a name="l00366"></a>00366         preconditioner_type_to_enum[<span class="stringliteral">&quot;JACOBI&quot;</span>      ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a9b2d6ff994aa4cfb181f5eceec23174f">JACOBI_PRECOND</a>;
<a name="l00367"></a>00367         preconditioner_type_to_enum[<span class="stringliteral">&quot;BLOCK_JACOBI&quot;</span>]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a8f036d61e96c69b14d585f04235613d2">BLOCK_JACOBI_PRECOND</a>;
<a name="l00368"></a>00368         preconditioner_type_to_enum[<span class="stringliteral">&quot;SOR&quot;</span>         ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a52da319102c9f93cef67896f122614b9">SOR_PRECOND</a>;
<a name="l00369"></a>00369         preconditioner_type_to_enum[<span class="stringliteral">&quot;SSOR&quot;</span>        ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a9e50971811a02ac1f940c7d803cc2b4c">SSOR_PRECOND</a>;
<a name="l00370"></a>00370         preconditioner_type_to_enum[<span class="stringliteral">&quot;EISENSTAT&quot;</span>   ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a7e8d6554e69fa3376ef61e35b17d92a4">EISENSTAT_PRECOND</a>;
<a name="l00371"></a>00371         preconditioner_type_to_enum[<span class="stringliteral">&quot;ASM&quot;</span>         ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a791f4098f0a9d74f940c5e1fb1215582">ASM_PRECOND</a>;
<a name="l00372"></a>00372         preconditioner_type_to_enum[<span class="stringliteral">&quot;CHOLESKY&quot;</span>    ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a01ae0c1024d6b2ae4022dbf0e0317ea9">CHOLESKY_PRECOND</a>;    
<a name="l00373"></a>00373         preconditioner_type_to_enum[<span class="stringliteral">&quot;ICC&quot;</span>         ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4ad530e0c240976b35094aee7290848d7f">ICC_PRECOND</a>;                 
<a name="l00374"></a>00374         preconditioner_type_to_enum[<span class="stringliteral">&quot;ILU&quot;</span>         ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4af54549e0e69fbdd4ddd199ee316527f3">ILU_PRECOND</a>;                 
<a name="l00375"></a>00375         preconditioner_type_to_enum[<span class="stringliteral">&quot;LU&quot;</span>          ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4af6625c293f8dbecf282cac92d7a8c8fb">LU_PRECOND</a>;          
<a name="l00376"></a>00376         preconditioner_type_to_enum[<span class="stringliteral">&quot;USER&quot;</span>        ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4ae3a9e261a354c7a05a8a8d0648f210de">USER_PRECOND</a>;        
<a name="l00377"></a>00377         preconditioner_type_to_enum[<span class="stringliteral">&quot;SHELL&quot;</span>       ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4af09677d7fa99ef863f62c4f26266b27f">SHELL_PRECOND</a>;       
<a name="l00378"></a>00378         preconditioner_type_to_enum[<span class="stringliteral">&quot;AMG&quot;</span>         ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4ac436c2c16e4aaaf30a5d761bc7e6c621">AMG_PRECOND</a>;                 
<a name="l00379"></a>00379         preconditioner_type_to_enum[<span class="stringliteral">&quot;INVALID&quot;</span>     ]=<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a531a6705593a3d669e898d2d102cc931">INVALID_PRECONDITIONER</a>;
<a name="l00380"></a>00380       }    
<a name="l00381"></a>00381   }
<a name="l00382"></a>00382 
<a name="l00383"></a>00383 
<a name="l00384"></a>00384   std::map&lt;PreconditionerType, std::string&gt; enum_to_preconditioner_type;
<a name="l00385"></a>00385   
<a name="l00386"></a>00386   <span class="comment">// Initialize the enum_to_preconditioner_type on first call</span>
<a name="l00387"></a>00387   <span class="keywordtype">void</span> init_enum_to_preconditioner_type ()
<a name="l00388"></a>00388   {
<a name="l00389"></a>00389     <span class="comment">// Build reverse map</span>
<a name="l00390"></a>00390     <span class="keywordflow">if</span> (enum_to_preconditioner_type.empty())
<a name="l00391"></a>00391       {
<a name="l00392"></a>00392         <span class="comment">// Initialize inf_map_type_to_enum on first call</span>
<a name="l00393"></a>00393         init_preconditioner_type_to_enum();
<a name="l00394"></a>00394 
<a name="l00395"></a>00395         build_reverse_map (preconditioner_type_to_enum.begin(),
<a name="l00396"></a>00396                            preconditioner_type_to_enum.end(),
<a name="l00397"></a>00397                            enum_to_preconditioner_type);
<a name="l00398"></a>00398       }
<a name="l00399"></a>00399   }
<a name="l00400"></a>00400 } <span class="comment">// end anonymous namespace</span>
<a name="l00401"></a>00401 
<a name="l00402"></a>00402 
<a name="l00403"></a>00403 
<a name="l00404"></a>00404 <span class="comment">// ------------------------------------------------------</span>
<a name="l00405"></a>00405 <span class="comment">// Utility::string_to_enum&lt;&gt; &amp; Utility::enum_to_string&lt;&gt;</span>
<a name="l00406"></a>00406 <span class="comment">// full specializations</span>
<a name="l00407"></a><a class="code" href="namespaceUtility.php">00407</a> <span class="keyword">namespace </span>Utility {
<a name="l00408"></a>00408 
<a name="l00409"></a>00409   <span class="comment">//------------------------------------------------------</span>
<a name="l00410"></a>00410   <span class="comment">// ElemType specialization</span>
<a name="l00411"></a>00411   <span class="keyword">template</span> &lt;&gt;
<a name="l00412"></a><a class="code" href="namespaceUtility.php#a104670ad7a0d99e4cfc1290b07bac5d7">00412</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="namespaceUtility.php#a104670ad7a0d99e4cfc1290b07bac5d7">string_to_enum&lt;ElemType&gt;</a> (<span class="keyword">const</span> std::string&amp; s)
<a name="l00413"></a>00413   {
<a name="l00414"></a>00414     init_elem_type_to_enum();
<a name="l00415"></a>00415 
<a name="l00416"></a>00416     std::string upper(s);
<a name="l00417"></a>00417     std::transform(upper.begin(), upper.end(), upper.begin(), ::toupper);
<a name="l00418"></a>00418     
<a name="l00419"></a>00419     <span class="keywordflow">if</span> (!elem_type_to_enum.count(upper))
<a name="l00420"></a>00420       libmesh_error();
<a name="l00421"></a>00421     
<a name="l00422"></a>00422     <span class="keywordflow">return</span> elem_type_to_enum[upper];
<a name="l00423"></a>00423   }
<a name="l00424"></a>00424 
<a name="l00425"></a>00425 
<a name="l00426"></a>00426   
<a name="l00427"></a>00427   <span class="keyword">template</span> &lt;&gt;
<a name="l00428"></a><a class="code" href="namespaceUtility.php#a648673ce02c4cb497b72b994f3710815">00428</a>   std::string <a class="code" href="namespaceUtility.php#a648673ce02c4cb497b72b994f3710815">enum_to_string&lt;ElemType&gt;</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> e)
<a name="l00429"></a>00429   {
<a name="l00430"></a>00430     init_enum_to_elem_type();
<a name="l00431"></a>00431 
<a name="l00432"></a>00432     <span class="keywordflow">if</span> (!enum_to_elem_type.count(e))
<a name="l00433"></a>00433       libmesh_error();
<a name="l00434"></a>00434 
<a name="l00435"></a>00435     <span class="keywordflow">return</span> enum_to_elem_type[e];
<a name="l00436"></a>00436   }
<a name="l00437"></a>00437 
<a name="l00438"></a>00438 
<a name="l00439"></a>00439   
<a name="l00440"></a>00440   <span class="comment">//------------------------------------------------</span>
<a name="l00441"></a>00441   <span class="comment">// Order specialization</span>
<a name="l00442"></a>00442   <span class="keyword">template</span> &lt;&gt;
<a name="l00443"></a><a class="code" href="namespaceUtility.php#a9fb5c35b33aa7342bfe09444c668b404">00443</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="namespaceUtility.php#a9fb5c35b33aa7342bfe09444c668b404">string_to_enum&lt;Order&gt;</a> (<span class="keyword">const</span> std::string&amp; s)
<a name="l00444"></a>00444   {
<a name="l00445"></a>00445     init_order_to_enum();
<a name="l00446"></a>00446     
<a name="l00447"></a>00447     std::string upper(s);
<a name="l00448"></a>00448     std::transform(upper.begin(), upper.end(), upper.begin(), ::toupper);
<a name="l00449"></a>00449     
<a name="l00450"></a>00450     <span class="keywordflow">if</span> (!order_to_enum.count(upper))
<a name="l00451"></a>00451       libmesh_error();
<a name="l00452"></a>00452     
<a name="l00453"></a>00453     <span class="keywordflow">return</span> order_to_enum[upper];
<a name="l00454"></a>00454   }
<a name="l00455"></a>00455 
<a name="l00456"></a>00456 
<a name="l00457"></a>00457   
<a name="l00458"></a>00458   <span class="keyword">template</span> &lt;&gt;
<a name="l00459"></a><a class="code" href="namespaceUtility.php#a55df3fbf802e78cc56adacf2af11a817">00459</a>   std::string <a class="code" href="namespaceUtility.php#a55df3fbf802e78cc56adacf2af11a817">enum_to_string&lt;Order&gt;</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o)
<a name="l00460"></a>00460   {
<a name="l00461"></a>00461     init_enum_to_order();
<a name="l00462"></a>00462 
<a name="l00463"></a>00463     <span class="keywordflow">if</span> (!enum_to_order.count(o))
<a name="l00464"></a>00464       libmesh_error();
<a name="l00465"></a>00465 
<a name="l00466"></a>00466     <span class="keywordflow">return</span> enum_to_order[o];
<a name="l00467"></a>00467   }
<a name="l00468"></a>00468 
<a name="l00469"></a>00469 
<a name="l00470"></a>00470 
<a name="l00471"></a>00471   <span class="comment">//------------------------------------------------------</span>
<a name="l00472"></a>00472   <span class="comment">// FEFamily specialization</span>
<a name="l00473"></a>00473   <span class="keyword">template</span> &lt;&gt;
<a name="l00474"></a><a class="code" href="namespaceUtility.php#a1c31087589d56ad1201e8f72c15ef5b4">00474</a>   <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5">FEFamily</a> <a class="code" href="namespaceUtility.php#a1c31087589d56ad1201e8f72c15ef5b4">string_to_enum&lt;FEFamily&gt;</a> (<span class="keyword">const</span> std::string&amp; s)
<a name="l00475"></a>00475   {
<a name="l00476"></a>00476     init_fefamily_to_enum();
<a name="l00477"></a>00477     
<a name="l00478"></a>00478     std::string upper(s);
<a name="l00479"></a>00479     std::transform(upper.begin(), upper.end(), upper.begin(), ::toupper);
<a name="l00480"></a>00480     
<a name="l00481"></a>00481     <span class="keywordflow">if</span> (!fefamily_to_enum.count(upper))
<a name="l00482"></a>00482       libmesh_error();
<a name="l00483"></a>00483     
<a name="l00484"></a>00484     <span class="keywordflow">return</span> fefamily_to_enum[upper];
<a name="l00485"></a>00485   }
<a name="l00486"></a>00486 
<a name="l00487"></a>00487 
<a name="l00488"></a>00488   
<a name="l00489"></a>00489   <span class="keyword">template</span> &lt;&gt;
<a name="l00490"></a><a class="code" href="namespaceUtility.php#ab75b87c9fdd1f9f417fd8c68338fed2f">00490</a>   std::string <a class="code" href="namespaceUtility.php#ab75b87c9fdd1f9f417fd8c68338fed2f">enum_to_string&lt;FEFamily&gt;</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5">FEFamily</a> f)
<a name="l00491"></a>00491   {
<a name="l00492"></a>00492     init_enum_to_fefamily();
<a name="l00493"></a>00493 
<a name="l00494"></a>00494     <span class="keywordflow">if</span> (!enum_to_fefamily.count(f))
<a name="l00495"></a>00495       libmesh_error();
<a name="l00496"></a>00496 
<a name="l00497"></a>00497     <span class="keywordflow">return</span> enum_to_fefamily[f];
<a name="l00498"></a>00498   }
<a name="l00499"></a>00499 
<a name="l00500"></a>00500 
<a name="l00501"></a>00501 
<a name="l00502"></a>00502   <span class="comment">//------------------------------------------------------</span>
<a name="l00503"></a>00503   <span class="comment">// InfMapType specialization</span>
<a name="l00504"></a>00504   <span class="keyword">template</span> &lt;&gt;
<a name="l00505"></a><a class="code" href="namespaceUtility.php#a345d0e1fa8f64a24511e3573b5de5646">00505</a>   <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7">InfMapType</a> <a class="code" href="namespaceUtility.php#a345d0e1fa8f64a24511e3573b5de5646">string_to_enum&lt;InfMapType&gt;</a> (<span class="keyword">const</span> std::string&amp; s)
<a name="l00506"></a>00506   {
<a name="l00507"></a>00507     init_inf_map_type_to_enum();
<a name="l00508"></a>00508     
<a name="l00509"></a>00509     std::string upper(s);
<a name="l00510"></a>00510     std::transform(upper.begin(), upper.end(), upper.begin(), ::toupper);
<a name="l00511"></a>00511     
<a name="l00512"></a>00512     <span class="keywordflow">if</span> (!inf_map_type_to_enum.count(upper))
<a name="l00513"></a>00513       libmesh_error();
<a name="l00514"></a>00514     
<a name="l00515"></a>00515     <span class="keywordflow">return</span> inf_map_type_to_enum[upper];
<a name="l00516"></a>00516   }
<a name="l00517"></a>00517 
<a name="l00518"></a>00518 
<a name="l00519"></a>00519   
<a name="l00520"></a>00520   <span class="keyword">template</span> &lt;&gt;
<a name="l00521"></a><a class="code" href="namespaceUtility.php#a4c8123de6d43525bc7d07bf445652f96">00521</a>   std::string <a class="code" href="namespaceUtility.php#a4c8123de6d43525bc7d07bf445652f96">enum_to_string&lt;InfMapType&gt;</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7">InfMapType</a> i)
<a name="l00522"></a>00522   {
<a name="l00523"></a>00523     init_enum_to_inf_map_type();
<a name="l00524"></a>00524 
<a name="l00525"></a>00525     <span class="keywordflow">if</span> (!enum_to_inf_map_type.count(i))
<a name="l00526"></a>00526       libmesh_error();
<a name="l00527"></a>00527 
<a name="l00528"></a>00528     <span class="keywordflow">return</span> enum_to_inf_map_type[i];
<a name="l00529"></a>00529   }
<a name="l00530"></a>00530 
<a name="l00531"></a>00531 
<a name="l00532"></a>00532 
<a name="l00533"></a>00533   <span class="comment">//------------------------------------------------------</span>
<a name="l00534"></a>00534   <span class="comment">// QuadratureType specialization</span>
<a name="l00535"></a>00535   <span class="keyword">template</span> &lt;&gt;
<a name="l00536"></a><a class="code" href="namespaceUtility.php#a39bfe9a5213827ca4abdbca65f3317dd">00536</a>   <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ad">QuadratureType</a> <a class="code" href="namespaceUtility.php#a39bfe9a5213827ca4abdbca65f3317dd">string_to_enum&lt;QuadratureType&gt;</a> (<span class="keyword">const</span> std::string&amp; s)
<a name="l00537"></a>00537   {
<a name="l00538"></a>00538     init_quadrature_type_to_enum();
<a name="l00539"></a>00539     
<a name="l00540"></a>00540     std::string upper(s);
<a name="l00541"></a>00541     std::transform(upper.begin(), upper.end(), upper.begin(), ::toupper);
<a name="l00542"></a>00542     
<a name="l00543"></a>00543     <span class="keywordflow">if</span> (!quadrature_type_to_enum.count(upper))
<a name="l00544"></a>00544       libmesh_error();
<a name="l00545"></a>00545     
<a name="l00546"></a>00546     <span class="keywordflow">return</span> quadrature_type_to_enum[upper];
<a name="l00547"></a>00547   }
<a name="l00548"></a>00548 
<a name="l00549"></a>00549 
<a name="l00550"></a>00550   
<a name="l00551"></a>00551   <span class="keyword">template</span> &lt;&gt;
<a name="l00552"></a><a class="code" href="namespaceUtility.php#a746cbd8b8415370ee3ba292d3b76e7ab">00552</a>   std::string <a class="code" href="namespaceUtility.php#a746cbd8b8415370ee3ba292d3b76e7ab">enum_to_string&lt;QuadratureType&gt;</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ad">QuadratureType</a> i)
<a name="l00553"></a>00553   {
<a name="l00554"></a>00554     init_enum_to_quadrature_type();
<a name="l00555"></a>00555 
<a name="l00556"></a>00556     <span class="keywordflow">if</span> (!enum_to_quadrature_type.count(i))
<a name="l00557"></a>00557       libmesh_error();
<a name="l00558"></a>00558 
<a name="l00559"></a>00559     <span class="keywordflow">return</span> enum_to_quadrature_type[i];
<a name="l00560"></a>00560   }
<a name="l00561"></a>00561 
<a name="l00562"></a>00562 
<a name="l00563"></a>00563   <span class="comment">//------------------------------------------------------</span>
<a name="l00564"></a>00564   <span class="comment">// PreconditionerType specialization</span>
<a name="l00565"></a>00565   <span class="keyword">template</span> &lt;&gt;
<a name="l00566"></a><a class="code" href="namespaceUtility.php#aae2f89b483f133532201c4348e2a13f3">00566</a>   <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4">PreconditionerType</a> <a class="code" href="namespaceUtility.php#aae2f89b483f133532201c4348e2a13f3">string_to_enum&lt;PreconditionerType&gt;</a> (<span class="keyword">const</span> std::string&amp; s)
<a name="l00567"></a>00567   {
<a name="l00568"></a>00568     init_preconditioner_type_to_enum();
<a name="l00569"></a>00569     
<a name="l00570"></a>00570     std::string upper(s);
<a name="l00571"></a>00571     std::transform(upper.begin(), upper.end(), upper.begin(), ::toupper);
<a name="l00572"></a>00572     
<a name="l00573"></a>00573     <span class="keywordflow">if</span> (!preconditioner_type_to_enum.count(upper))
<a name="l00574"></a>00574       libmesh_error();
<a name="l00575"></a>00575     
<a name="l00576"></a>00576     <span class="keywordflow">return</span> preconditioner_type_to_enum[upper];
<a name="l00577"></a>00577   }
<a name="l00578"></a>00578 
<a name="l00579"></a>00579 
<a name="l00580"></a>00580   
<a name="l00581"></a>00581   <span class="keyword">template</span> &lt;&gt;
<a name="l00582"></a><a class="code" href="namespaceUtility.php#a1f1c54d3b13ce3ba7fb840cea76ee889">00582</a>   std::string <a class="code" href="namespaceUtility.php#a1f1c54d3b13ce3ba7fb840cea76ee889">enum_to_string&lt;PreconditionerType&gt;</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4">PreconditionerType</a> i)
<a name="l00583"></a>00583   {
<a name="l00584"></a>00584     init_enum_to_preconditioner_type();
<a name="l00585"></a>00585 
<a name="l00586"></a>00586     <span class="keywordflow">if</span> (!enum_to_preconditioner_type.count(i))
<a name="l00587"></a>00587       libmesh_error();
<a name="l00588"></a>00588 
<a name="l00589"></a>00589     <span class="keywordflow">return</span> enum_to_preconditioner_type[i];
<a name="l00590"></a>00590   }
<a name="l00591"></a>00591   
<a name="l00592"></a>00592 }
<a name="l00593"></a>00593 
<a name="l00594"></a>00594 
<a name="l00595"></a>00595 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
