<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_f10759d5ac6297fe611079c3c15b8f2c.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>sum_shell_matrix.C</h1>  </div>
</div>
<div class="contents">
<a href="sum__shell__matrix_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: sum_shell_matrix.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;sum_shell_matrix.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00027"></a><a class="code" href="classSumShellMatrix.php#a371edfb5bf3f89ad7889c21c0a2b7a68">00027</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSumShellMatrix.php#a371edfb5bf3f89ad7889c21c0a2b7a68">SumShellMatrix&lt;T&gt;::m</a> ()<span class="keyword"> const</span>
<a name="l00028"></a>00028 <span class="keyword"></span>{
<a name="l00029"></a>00029   libmesh_assert(!matrices.empty());
<a name="l00030"></a>00030   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> result = matrices[0]-&gt;m();
<a name="l00031"></a>00031   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=matrices.size(); i--&gt;1; )
<a name="l00032"></a>00032     {
<a name="l00033"></a>00033       libmesh_assert(matrices[i]-&gt;m()==result);
<a name="l00034"></a>00034     }
<a name="l00035"></a>00035   <span class="keywordflow">return</span> result;
<a name="l00036"></a>00036 }
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00041"></a><a class="code" href="classSumShellMatrix.php#a449e8624c8f6ea5a9ad76741365cf8da">00041</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSumShellMatrix.php#a449e8624c8f6ea5a9ad76741365cf8da">SumShellMatrix&lt;T&gt;::n</a> ()<span class="keyword"> const</span>
<a name="l00042"></a>00042 <span class="keyword"></span>{
<a name="l00043"></a>00043   libmesh_assert(!matrices.empty());
<a name="l00044"></a>00044   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> result = matrices[0]-&gt;n();
<a name="l00045"></a>00045   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=matrices.size(); i--&gt;1; )
<a name="l00046"></a>00046     {
<a name="l00047"></a>00047       libmesh_assert(matrices[i]-&gt;n()==result);
<a name="l00048"></a>00048     }
<a name="l00049"></a>00049   <span class="keywordflow">return</span> result;
<a name="l00050"></a>00050 }
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00055"></a><a class="code" href="classSumShellMatrix.php#a89154679ecd2d087c14c08b010df7f84">00055</a> <span class="keywordtype">void</span> <a class="code" href="classSumShellMatrix.php#a89154679ecd2d087c14c08b010df7f84">SumShellMatrix&lt;T&gt;::vector_mult</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest,
<a name="l00056"></a>00056                                      <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; arg)<span class="keyword"> const</span>
<a name="l00057"></a>00057 <span class="keyword"></span>{
<a name="l00058"></a>00058   dest.<a class="code" href="classNumericVector.php#a21ca80e20b0f88490c8f0d5298d47bef">zero</a>();
<a name="l00059"></a>00059   this-&gt;vector_mult_add(dest,arg);
<a name="l00060"></a>00060 }
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00065"></a><a class="code" href="classSumShellMatrix.php#a39fb4b6a7c4041743f06a0fa42c1dc8c">00065</a> <span class="keywordtype">void</span> <a class="code" href="classSumShellMatrix.php#a39fb4b6a7c4041743f06a0fa42c1dc8c">SumShellMatrix&lt;T&gt;::vector_mult_add</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest,
<a name="l00066"></a>00066                                          <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; arg)<span class="keyword"> const</span>
<a name="l00067"></a>00067 <span class="keyword"></span>{
<a name="l00068"></a>00068   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=matrices.size(); i--&gt;0; )
<a name="l00069"></a>00069     {
<a name="l00070"></a>00070       matrices[i]-&gt;vector_mult_add(dest,arg);
<a name="l00071"></a>00071     }
<a name="l00072"></a>00072 }
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00077"></a><a class="code" href="classSumShellMatrix.php#aee377bc7ee7198211c81a8392c0a4d70">00077</a> <span class="keywordtype">void</span> <a class="code" href="classSumShellMatrix.php#aee377bc7ee7198211c81a8392c0a4d70">SumShellMatrix&lt;T&gt;::get_diagonal</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest)<span class="keyword"> const</span>
<a name="l00078"></a>00078 <span class="keyword"></span>{
<a name="l00079"></a>00079   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; a = dest.<a class="code" href="classNumericVector.php#a5ac7af0a31b15c7f13c6fa85a5048e45">clone</a>();
<a name="l00080"></a>00080   dest.<a class="code" href="classNumericVector.php#a21ca80e20b0f88490c8f0d5298d47bef">zero</a>();
<a name="l00081"></a>00081   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=matrices.size(); i--&gt;0; )
<a name="l00082"></a>00082     {
<a name="l00083"></a>00083       matrices[i]-&gt;get_diagonal(*a);
<a name="l00084"></a>00084       dest += *a;
<a name="l00085"></a>00085     }
<a name="l00086"></a>00086 }
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00091"></a>00091 <span class="comment">// Explicit instantiations</span>
<a name="l00092"></a>00092 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classSumShellMatrix.php">SumShellMatrix&lt;Number&gt;</a>;
<a name="l00093"></a>00093 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
