<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f3dddc399b6638a7c4a0cce975976e74.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>surface.h</h1>  </div>
</div>
<div class="contents">
<a href="surface_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: surface.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __surface_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __surface_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="point_8h.php">point.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00042"></a>00042 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00043"></a>00043 <span class="comment">// Surface class definition</span>
<a name="l00044"></a><a class="code" href="classSurface.php">00044</a> <span class="keyword">class </span><a class="code" href="classSurface.php">Surface</a>
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046 <span class="keyword">public</span>:
<a name="l00047"></a>00047   
<a name="l00051"></a><a class="code" href="classSurface.php#a8fc57f2a15292135c00545c9d224ec68">00051</a>   <a class="code" href="classSurface.php#a8fc57f2a15292135c00545c9d224ec68">Surface</a> () {}
<a name="l00052"></a>00052 
<a name="l00056"></a><a class="code" href="classSurface.php#a6a06e68159b7c22878599d81b3defbdc">00056</a>   <a class="code" href="classSurface.php#a6a06e68159b7c22878599d81b3defbdc">Surface</a> (<span class="keyword">const</span> <a class="code" href="classSurface.php">Surface</a>&amp;) {}
<a name="l00057"></a>00057 
<a name="l00061"></a><a class="code" href="classSurface.php#a44ff6a911acc4ada428c3d734f342a8a">00061</a>   <span class="keyword">virtual</span> <a class="code" href="classSurface.php#a44ff6a911acc4ada428c3d734f342a8a">~Surface</a> () {}
<a name="l00062"></a>00062 
<a name="l00067"></a>00067   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classSurface.php#a37cfeede124f5d1e9ada0ce5c791706a">above_surface</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p) <span class="keyword">const</span> = 0;
<a name="l00068"></a>00068 
<a name="l00073"></a>00073   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classSurface.php#a3105b56b3069916cb60dbb5afa5f6a62">below_surface</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p) <span class="keyword">const</span> = 0;
<a name="l00074"></a>00074 
<a name="l00081"></a>00081   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classSurface.php#aaa7f101ff25a02957c7a9e53e6d57532">on_surface</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p) <span class="keyword">const</span> = 0;
<a name="l00082"></a>00082 
<a name="l00086"></a>00086   <span class="keyword">virtual</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classSurface.php#aae21735f15cf140d7c313d66226e007f">closest_point</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p) <span class="keyword">const</span> = 0;
<a name="l00087"></a>00087 
<a name="l00092"></a>00092   <span class="keyword">virtual</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classSurface.php#a8d8a8631247ff64332be872c5828be5a">unit_normal</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p) <span class="keyword">const</span> = 0;
<a name="l00093"></a>00093 
<a name="l00102"></a>00102   <span class="keyword">virtual</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classSurface.php#a00afc929b46acf6554a5be50c79a5769">surface_coords</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; <a class="code" href="classSurface.php#a1e47cede5e7f87673132d27ef72633bb">world_coords</a>) <span class="keyword">const</span>;
<a name="l00103"></a>00103 
<a name="l00111"></a>00111   <span class="keyword">virtual</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classSurface.php#a1e47cede5e7f87673132d27ef72633bb">world_coords</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; surf_coords) <span class="keyword">const</span>;
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 <span class="keyword">protected</span>:
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 };
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00118"></a>00118 <span class="comment">// Surface class member functions</span>
<a name="l00119"></a>00119 <span class="keyword">inline</span>
<a name="l00120"></a><a class="code" href="classSurface.php#a00afc929b46acf6554a5be50c79a5769">00120</a> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classSurface.php#a00afc929b46acf6554a5be50c79a5769">Surface::surface_coords</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; world_coords)<span class="keyword"> const</span>
<a name="l00121"></a>00121 <span class="keyword"></span>{
<a name="l00122"></a>00122   <a class="code" href="classPoint.php">Point</a> p (world_coords);
<a name="l00123"></a>00123   <span class="keywordflow">return</span> p;
<a name="l00124"></a>00124 }
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 <span class="keyword">inline</span>
<a name="l00129"></a><a class="code" href="classSurface.php#a1e47cede5e7f87673132d27ef72633bb">00129</a> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classSurface.php#a1e47cede5e7f87673132d27ef72633bb">Surface::world_coords</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; surf_coords)<span class="keyword"> const</span>
<a name="l00130"></a>00130 <span class="keyword"></span>{
<a name="l00131"></a>00131   <a class="code" href="classPoint.php">Point</a> p (surf_coords);
<a name="l00132"></a>00132   <span class="keywordflow">return</span> p;
<a name="l00133"></a>00133 }
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
