<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_60be1125a39495b698d2d56e8e5b50b1.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>system.C</h1>  </div>
</div>
<div class="contents">
<a href="system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: system.C 3453 2009-09-03 16:58:44Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;sstream&gt;</span>   <span class="comment">// for std::ostringstream</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;system.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;equation_systems.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;utility.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;string_to_enum.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;dof_map.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// includes for calculate_norm</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;fe_base.h&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;parallel.h&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;quadrature.h&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;tensor_value.h&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;vector_value.h&quot;</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00045"></a>00045 <span class="comment">// System implementation</span>
<a name="l00046"></a><a class="code" href="classSystem.php#af944a5bb4e6a5d3979898b77d63b542b">00046</a> <a class="code" href="classSystem.php#af944a5bb4e6a5d3979898b77d63b542b">System::System</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00047"></a>00047                 <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00048"></a>00048                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   assemble_before_solve    (true),
<a name="l00051"></a>00051   solution                 (<a class="code" href="classNumericVector.php">NumericVector</a>&lt;<a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>&gt;::build()),
<a name="l00052"></a>00052   current_local_solution   (<a class="code" href="classNumericVector.php">NumericVector</a>&lt;<a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>&gt;::build()),
<a name="l00053"></a>00053   qoi                      (0),
<a name="l00054"></a>00054   _init_system             (NULL),
<a name="l00055"></a>00055   _assemble_system         (NULL),
<a name="l00056"></a>00056   _constrain_system        (NULL),
<a name="l00057"></a>00057   _dof_map                 (new <a class="code" href="classDofMap.php">DofMap</a>(number)),
<a name="l00058"></a>00058   _equation_systems        (es),
<a name="l00059"></a>00059   _mesh                    (es.get_mesh()),
<a name="l00060"></a>00060   _sys_name                (name),
<a name="l00061"></a>00061   _sys_number              (number),
<a name="l00062"></a>00062   _active                  (true),
<a name="l00063"></a>00063   _solution_projection     (true),
<a name="l00064"></a>00064   _can_add_vectors         (true),
<a name="l00065"></a>00065   _additional_data_written (false)
<a name="l00066"></a>00066 {
<a name="l00067"></a>00067 }
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00071"></a><a class="code" href="classSystem.php#a3be70bb338e3f062f821173fd15680d0">00071</a> <a class="code" href="classSystem.php#a3be70bb338e3f062f821173fd15680d0">System::~System</a> ()
<a name="l00072"></a>00072 {
<a name="l00073"></a>00073   <span class="comment">// Null-out the function pointers.  Since this</span>
<a name="l00074"></a>00074   <span class="comment">// class is getting destructed it is pointless,</span>
<a name="l00075"></a>00075   <span class="comment">// but a good habit.</span>
<a name="l00076"></a>00076   <a class="code" href="classSystem.php#ad5fcdc621c417276b264a448a129ae69">_init_system</a> = <a class="code" href="classSystem.php#a07099cdef68f5638d6af2ed5be48801d">_assemble_system</a> = NULL;
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   <span class="comment">// Clear data</span>
<a name="l00079"></a>00079   this-&gt;<a class="code" href="classSystem.php#a66bdd137db3fc914bbfe9518b6c71017">clear</a> ();
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   libmesh_assert (!<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">libMesh::closed</a>());
<a name="l00082"></a>00082 }
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a><a class="code" href="classSystem.php#aa8f04263eed1eaf253e81041f166408b">00086</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#aa8f04263eed1eaf253e81041f166408b">System::n_dofs</a>()<span class="keyword"> const</span>
<a name="l00087"></a>00087 <span class="keyword"></span>{
<a name="l00088"></a>00088   <span class="keywordflow">return</span> <a class="code" href="classSystem.php#ad9cb48f6abe7baff3d4a501cd92ee88e">_dof_map</a>-&gt;n_dofs();
<a name="l00089"></a>00089 }
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 
<a name="l00093"></a><a class="code" href="classSystem.php#accee8e94a0b050017d77589f0a43fbc8">00093</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#accee8e94a0b050017d77589f0a43fbc8">System::n_constrained_dofs</a>()<span class="keyword"> const</span>
<a name="l00094"></a>00094 <span class="keyword"></span>{
<a name="l00095"></a>00095 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00096"></a>00096 <span class="preprocessor"></span>
<a name="l00097"></a>00097   <span class="keywordflow">return</span> <a class="code" href="classSystem.php#ad9cb48f6abe7baff3d4a501cd92ee88e">_dof_map</a>-&gt;n_constrained_dofs();
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 <span class="preprocessor">#else</span>
<a name="l00100"></a>00100 <span class="preprocessor"></span>
<a name="l00101"></a>00101   <span class="keywordflow">return</span> 0;
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 <span class="preprocessor">#endif</span>
<a name="l00104"></a>00104 <span class="preprocessor"></span>}
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 
<a name="l00108"></a><a class="code" href="classSystem.php#a401d38d088ef9140e51c455387af319d">00108</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#a401d38d088ef9140e51c455387af319d">System::n_local_dofs</a>()<span class="keyword"> const</span>
<a name="l00109"></a>00109 <span class="keyword"></span>{
<a name="l00110"></a>00110   <span class="keywordflow">return</span> <a class="code" href="classSystem.php#ad9cb48f6abe7baff3d4a501cd92ee88e">_dof_map</a>-&gt;n_dofs_on_processor (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>());
<a name="l00111"></a>00111 }
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a><a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">00115</a> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">System::current_solution</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_dof_number)<span class="keyword"> const</span>
<a name="l00116"></a>00116 <span class="keyword"></span>{
<a name="l00117"></a>00117   <span class="comment">// Check the sizes</span>
<a name="l00118"></a>00118   libmesh_assert (global_dof_number &lt; _dof_map-&gt;<a class="code" href="classSystem.php#aa8f04263eed1eaf253e81041f166408b">n_dofs</a>());
<a name="l00119"></a>00119   libmesh_assert (global_dof_number &lt; current_local_solution-&gt;size());
<a name="l00120"></a>00120    
<a name="l00121"></a>00121   <span class="keywordflow">return</span> (*<a class="code" href="classSystem.php#a47b00cd00684aebe3c095aba010626e5">current_local_solution</a>)(global_dof_number);
<a name="l00122"></a>00122 }
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a><a class="code" href="classSystem.php#a66bdd137db3fc914bbfe9518b6c71017">00126</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a66bdd137db3fc914bbfe9518b6c71017">System::clear</a> ()
<a name="l00127"></a>00127 {
<a name="l00128"></a>00128   <a class="code" href="classSystem.php#a6937f66076215b9804aecf3983b1c5e8">_variables</a>.clear();
<a name="l00129"></a>00129   
<a name="l00130"></a>00130   <a class="code" href="classSystem.php#ade03c4f7efd4b1839ff0003971d09d0a">_variable_numbers</a>.clear();
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   <a class="code" href="classSystem.php#ad9cb48f6abe7baff3d4a501cd92ee88e">_dof_map</a>-&gt;clear ();
<a name="l00133"></a>00133   
<a name="l00134"></a>00134   <a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;clear ();
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   <a class="code" href="classSystem.php#a47b00cd00684aebe3c095aba010626e5">current_local_solution</a>-&gt;clear ();
<a name="l00137"></a>00137   
<a name="l00138"></a>00138   <span class="comment">// clear any user-added vectors</span>
<a name="l00139"></a>00139   {
<a name="l00140"></a>00140     <span class="keywordflow">for</span> (<a class="code" href="classSystem.php#ac1939aeca6473017c8b6a560892e86aa">vectors_iterator</a> pos = <a class="code" href="classSystem.php#af306b03372a5ade33a7569b81af47ef1">_vectors</a>.begin(); pos != <a class="code" href="classSystem.php#af306b03372a5ade33a7569b81af47ef1">_vectors</a>.end(); ++pos)
<a name="l00141"></a>00141       {
<a name="l00142"></a>00142         pos-&gt;second-&gt;clear ();
<a name="l00143"></a>00143         <span class="keyword">delete</span> pos-&gt;second;
<a name="l00144"></a>00144         pos-&gt;second = NULL;
<a name="l00145"></a>00145       }
<a name="l00146"></a>00146     
<a name="l00147"></a>00147     <a class="code" href="classSystem.php#af306b03372a5ade33a7569b81af47ef1">_vectors</a>.clear();
<a name="l00148"></a>00148     <a class="code" href="classSystem.php#a6c7fa5761b1ddb3c5fa5689df975e179">_vector_projections</a>.clear();
<a name="l00149"></a>00149     <a class="code" href="classSystem.php#ab6e6f8f579140ed6bfe4fe95f4084852">_can_add_vectors</a> = <span class="keyword">true</span>;
<a name="l00150"></a>00150   }
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 }
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 
<a name="l00156"></a><a class="code" href="classSystem.php#ae5928a3751d52745b76feca40666c31f">00156</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#ae5928a3751d52745b76feca40666c31f">System::init</a> ()
<a name="l00157"></a>00157 { 
<a name="l00158"></a>00158   <span class="comment">// First initialize any required data</span>
<a name="l00159"></a>00159   this-&gt;<a class="code" href="classSystem.php#a1ee0d1111c06a94c271b2830dbc69421">init_data</a>();
<a name="l00160"></a>00160   
<a name="l00161"></a>00161   <span class="comment">//If no variables have been added to this system</span>
<a name="l00162"></a>00162   <span class="comment">//don&#39;t do anything</span>
<a name="l00163"></a>00163   <span class="keywordflow">if</span>(!this-&gt;<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>())
<a name="l00164"></a>00164     <span class="keywordflow">return</span>;
<a name="l00165"></a>00165  
<a name="l00166"></a>00166   <span class="comment">// Then call the user-provided intialization function</span>
<a name="l00167"></a>00167   this-&gt;<a class="code" href="classSystem.php#a3f5139f478cc769a89df8d09bb7aa69a">user_initialization</a>();
<a name="l00168"></a>00168 }
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 
<a name="l00172"></a><a class="code" href="classSystem.php#a1ee0d1111c06a94c271b2830dbc69421">00172</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a1ee0d1111c06a94c271b2830dbc69421">System::init_data</a> ()
<a name="l00173"></a>00173 {
<a name="l00174"></a>00174   <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh = this-&gt;<a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">get_mesh</a>();
<a name="l00175"></a>00175 
<a name="l00176"></a>00176   <span class="comment">// Distribute the degrees of freedom on the mesh</span>
<a name="l00177"></a>00177   <a class="code" href="classSystem.php#ad9cb48f6abe7baff3d4a501cd92ee88e">_dof_map</a>-&gt;distribute_dofs (mesh);
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00180"></a>00180 <span class="preprocessor"></span>
<a name="l00181"></a>00181   <span class="comment">// Recreate any hanging node constraints</span>
<a name="l00182"></a>00182   <a class="code" href="classSystem.php#ad9cb48f6abe7baff3d4a501cd92ee88e">_dof_map</a>-&gt;create_dof_constraints(mesh);
<a name="l00183"></a>00183 
<a name="l00184"></a>00184   <span class="comment">// Apply any user-defined constraints</span>
<a name="l00185"></a>00185   this-&gt;<a class="code" href="classSystem.php#a8dd9e548cdc41149155da0a92eefa591">user_constrain</a>();
<a name="l00186"></a>00186 
<a name="l00187"></a>00187   <span class="comment">// Expand any recursive constraints</span>
<a name="l00188"></a>00188   <a class="code" href="classSystem.php#ad9cb48f6abe7baff3d4a501cd92ee88e">_dof_map</a>-&gt;process_constraints();
<a name="l00189"></a>00189 
<a name="l00190"></a>00190   <span class="comment">// And clean up the send_list before we first use it</span>
<a name="l00191"></a>00191   <a class="code" href="classSystem.php#ad9cb48f6abe7baff3d4a501cd92ee88e">_dof_map</a>-&gt;prepare_send_list();
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 <span class="preprocessor">#endif</span>
<a name="l00194"></a>00194 <span class="preprocessor"></span>  
<a name="l00195"></a>00195   <span class="comment">// Resize the solution conformal to the current mesh</span>
<a name="l00196"></a>00196   <a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;init (this-&gt;<a class="code" href="classSystem.php#aa8f04263eed1eaf253e81041f166408b">n_dofs</a>(), this-&gt;<a class="code" href="classSystem.php#a401d38d088ef9140e51c455387af319d">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>);
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   <span class="comment">// Resize the current_local_solution for the current mesh</span>
<a name="l00199"></a>00199 <span class="preprocessor">#ifdef LIBMESH_ENABLE_GHOSTED</span>
<a name="l00200"></a>00200 <span class="preprocessor"></span>  <a class="code" href="classSystem.php#a47b00cd00684aebe3c095aba010626e5">current_local_solution</a>-&gt;init (this-&gt;<a class="code" href="classSystem.php#aa8f04263eed1eaf253e81041f166408b">n_dofs</a>(), this-&gt;<a class="code" href="classSystem.php#a401d38d088ef9140e51c455387af319d">n_local_dofs</a>(),
<a name="l00201"></a>00201                                 <a class="code" href="classSystem.php#ad9cb48f6abe7baff3d4a501cd92ee88e">_dof_map</a>-&gt;get_send_list(), <span class="keyword">false</span>,
<a name="l00202"></a>00202                                 <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>);
<a name="l00203"></a>00203 <span class="preprocessor">#else</span>
<a name="l00204"></a>00204 <span class="preprocessor"></span>  <a class="code" href="classSystem.php#a47b00cd00684aebe3c095aba010626e5">current_local_solution</a>-&gt;init (this-&gt;<a class="code" href="classSystem.php#aa8f04263eed1eaf253e81041f166408b">n_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>);
<a name="l00205"></a>00205 <span class="preprocessor">#endif</span>
<a name="l00206"></a>00206 <span class="preprocessor"></span>
<a name="l00207"></a>00207   <span class="comment">// from now on, no chance to add additional vectors</span>
<a name="l00208"></a>00208   <a class="code" href="classSystem.php#ab6e6f8f579140ed6bfe4fe95f4084852">_can_add_vectors</a> = <span class="keyword">false</span>;
<a name="l00209"></a>00209 
<a name="l00210"></a>00210   <span class="comment">// initialize &amp; zero other vectors, if necessary</span>
<a name="l00211"></a>00211   <span class="keywordflow">for</span> (<a class="code" href="classSystem.php#ac1939aeca6473017c8b6a560892e86aa">vectors_iterator</a> pos = <a class="code" href="classSystem.php#af306b03372a5ade33a7569b81af47ef1">_vectors</a>.begin(); pos != <a class="code" href="classSystem.php#af306b03372a5ade33a7569b81af47ef1">_vectors</a>.end(); ++pos)
<a name="l00212"></a>00212       pos-&gt;second-&gt;init (this-&gt;n_dofs(), this-&gt;<a class="code" href="classSystem.php#a401d38d088ef9140e51c455387af319d">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>);
<a name="l00213"></a>00213 }
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 
<a name="l00216"></a>00216 
<a name="l00217"></a><a class="code" href="classSystem.php#af92311614385b58e619b19c958acf6c9">00217</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#af92311614385b58e619b19c958acf6c9">System::restrict_vectors</a> ()
<a name="l00218"></a>00218 {
<a name="l00219"></a>00219 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00220"></a>00220 <span class="preprocessor"></span>  <span class="comment">// Restrict the _vectors on the coarsened cells</span>
<a name="l00221"></a>00221   <span class="keywordflow">for</span> (<a class="code" href="classSystem.php#ac1939aeca6473017c8b6a560892e86aa">vectors_iterator</a> pos = <a class="code" href="classSystem.php#af306b03372a5ade33a7569b81af47ef1">_vectors</a>.begin(); pos != <a class="code" href="classSystem.php#af306b03372a5ade33a7569b81af47ef1">_vectors</a>.end(); ++pos)
<a name="l00222"></a>00222     {
<a name="l00223"></a>00223       <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* v = pos-&gt;second;
<a name="l00224"></a>00224       
<a name="l00225"></a>00225       <span class="keywordflow">if</span> (<a class="code" href="classSystem.php#a6c7fa5761b1ddb3c5fa5689df975e179">_vector_projections</a>[pos-&gt;first])
<a name="l00226"></a>00226         this-&gt;<a class="code" href="classSystem.php#a7a43c17f7d8fd02835faba1d39204cef">project_vector</a> (*v);
<a name="l00227"></a>00227       <span class="keywordflow">else</span>
<a name="l00228"></a>00228         v-&gt;<a class="code" href="classNumericVector.php#abbb0c0eb886ba1c6bb835d6275475c6e">init</a> (this-&gt;<a class="code" href="classSystem.php#aa8f04263eed1eaf253e81041f166408b">n_dofs</a>(), this-&gt;<a class="code" href="classSystem.php#a401d38d088ef9140e51c455387af319d">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>);
<a name="l00229"></a>00229     }
<a name="l00230"></a>00230 
<a name="l00231"></a>00231   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list = <a class="code" href="classSystem.php#ad9cb48f6abe7baff3d4a501cd92ee88e">_dof_map</a>-&gt;get_send_list ();
<a name="l00232"></a>00232 
<a name="l00233"></a>00233   <span class="comment">// Restrict the solution on the coarsened cells</span>
<a name="l00234"></a>00234   <span class="keywordflow">if</span> (<a class="code" href="classSystem.php#a5c4dc93cbba1fc013ce6023029f30909">_solution_projection</a>)
<a name="l00235"></a>00235     this-&gt;<a class="code" href="classSystem.php#a7a43c17f7d8fd02835faba1d39204cef">project_vector</a> (*<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>);
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 <span class="preprocessor">#ifdef LIBMESH_ENABLE_GHOSTED</span>
<a name="l00238"></a>00238 <span class="preprocessor"></span>  <a class="code" href="classSystem.php#a47b00cd00684aebe3c095aba010626e5">current_local_solution</a>-&gt;init(this-&gt;<a class="code" href="classSystem.php#aa8f04263eed1eaf253e81041f166408b">n_dofs</a>(),
<a name="l00239"></a>00239                                this-&gt;<a class="code" href="classSystem.php#a401d38d088ef9140e51c455387af319d">n_local_dofs</a>(), send_list, 
<a name="l00240"></a>00240                                <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>);
<a name="l00241"></a>00241 <span class="preprocessor">#else</span>
<a name="l00242"></a>00242 <span class="preprocessor"></span>  <a class="code" href="classSystem.php#a47b00cd00684aebe3c095aba010626e5">current_local_solution</a>-&gt;init(this-&gt;<a class="code" href="classSystem.php#aa8f04263eed1eaf253e81041f166408b">n_dofs</a>());
<a name="l00243"></a>00243 <span class="preprocessor">#endif</span>
<a name="l00244"></a>00244 <span class="preprocessor"></span>
<a name="l00245"></a>00245   <span class="keywordflow">if</span> (<a class="code" href="classSystem.php#a5c4dc93cbba1fc013ce6023029f30909">_solution_projection</a>)
<a name="l00246"></a>00246     <a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;localize (*<a class="code" href="classSystem.php#a47b00cd00684aebe3c095aba010626e5">current_local_solution</a>, send_list); 
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR</span>
<a name="l00249"></a>00249 <span class="preprocessor"></span>}
<a name="l00250"></a>00250 
<a name="l00251"></a>00251 
<a name="l00252"></a>00252 
<a name="l00253"></a><a class="code" href="classSystem.php#a557fe073d299e4382e5058644ebf452e">00253</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a557fe073d299e4382e5058644ebf452e">System::prolong_vectors</a> ()
<a name="l00254"></a>00254 {
<a name="l00255"></a>00255 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00256"></a>00256 <span class="preprocessor"></span>  <span class="comment">// Currently project_vector handles both restriction and prolongation</span>
<a name="l00257"></a>00257   this-&gt;<a class="code" href="classSystem.php#af92311614385b58e619b19c958acf6c9">restrict_vectors</a>();
<a name="l00258"></a>00258 <span class="preprocessor">#endif</span>
<a name="l00259"></a>00259 <span class="preprocessor"></span>}
<a name="l00260"></a>00260 
<a name="l00261"></a>00261 
<a name="l00262"></a>00262 
<a name="l00263"></a><a class="code" href="classSystem.php#a60f6078e475e01e19aad618766f2cd7b">00263</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a60f6078e475e01e19aad618766f2cd7b">System::reinit</a> ()
<a name="l00264"></a>00264 {
<a name="l00265"></a>00265 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00266"></a>00266 <span class="preprocessor"></span>  <span class="comment">//If no variables have been added to this system</span>
<a name="l00267"></a>00267   <span class="comment">//don&#39;t do anything</span>
<a name="l00268"></a>00268   <span class="keywordflow">if</span>(!this-&gt;<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>())
<a name="l00269"></a>00269     <span class="keywordflow">return</span>;
<a name="l00270"></a>00270 
<a name="l00271"></a>00271   <span class="comment">// Constraints get handled in EquationSystems::reinit now</span>
<a name="l00272"></a>00272 <span class="comment">//  _dof_map-&gt;create_dof_constraints(this-&gt;get_mesh());</span>
<a name="l00273"></a>00273 
<a name="l00274"></a>00274   <span class="comment">// Update the solution based on the projected</span>
<a name="l00275"></a>00275   <span class="comment">// current_local_solution.</span>
<a name="l00276"></a>00276   <a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;init (this-&gt;<a class="code" href="classSystem.php#aa8f04263eed1eaf253e81041f166408b">n_dofs</a>(), this-&gt;<a class="code" href="classSystem.php#a401d38d088ef9140e51c455387af319d">n_local_dofs</a>(), <span class="keyword">true</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>);
<a name="l00277"></a>00277         
<a name="l00278"></a>00278   libmesh_assert (<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;size() == <a class="code" href="classSystem.php#a47b00cd00684aebe3c095aba010626e5">current_local_solution</a>-&gt;size());
<a name="l00279"></a>00279   <span class="comment">// Not true with ghosted vectors</span>
<a name="l00280"></a>00280   <span class="comment">// libmesh_assert (solution-&gt;size() == current_local_solution-&gt;local_size());</span>
<a name="l00281"></a>00281 
<a name="l00282"></a>00282   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_dof = <a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;first_local_index();
<a name="l00283"></a>00283   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_size      = <a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;local_size();
<a name="l00284"></a>00284       
<a name="l00285"></a>00285   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;local_size; i++)
<a name="l00286"></a>00286     <a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;set(i+first_local_dof,
<a name="l00287"></a>00287                   (*<a class="code" href="classSystem.php#a47b00cd00684aebe3c095aba010626e5">current_local_solution</a>)(i+first_local_dof));
<a name="l00288"></a>00288 <span class="preprocessor">#endif</span>
<a name="l00289"></a>00289 <span class="preprocessor"></span>}
<a name="l00290"></a>00290 
<a name="l00291"></a>00291 
<a name="l00292"></a>00292 
<a name="l00293"></a><a class="code" href="classSystem.php#add4b09ec4fb0679b8623c01218cafa5b">00293</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#add4b09ec4fb0679b8623c01218cafa5b">System::update</a> ()
<a name="l00294"></a>00294 {
<a name="l00295"></a>00295   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list = <a class="code" href="classSystem.php#ad9cb48f6abe7baff3d4a501cd92ee88e">_dof_map</a>-&gt;get_send_list ();
<a name="l00296"></a>00296 
<a name="l00297"></a>00297   <span class="comment">// Check sizes</span>
<a name="l00298"></a>00298   libmesh_assert (<a class="code" href="classSystem.php#a47b00cd00684aebe3c095aba010626e5">current_local_solution</a>-&gt;size() == <a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;size());
<a name="l00299"></a>00299 <span class="comment">// More processors than elements =&gt; empty send_list</span>
<a name="l00300"></a>00300 <span class="comment">//  libmesh_assert (!send_list.empty());</span>
<a name="l00301"></a>00301   libmesh_assert (send_list.size() &lt;= <a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;size());
<a name="l00302"></a>00302 
<a name="l00303"></a>00303   <span class="comment">// Create current_local_solution from solution.  This will</span>
<a name="l00304"></a>00304   <span class="comment">// put a local copy of solution into current_local_solution.</span>
<a name="l00305"></a>00305   <span class="comment">// Only the necessary values (specified by the send_list)</span>
<a name="l00306"></a>00306   <span class="comment">// are copied to minimize communication</span>
<a name="l00307"></a>00307   <a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;localize (*<a class="code" href="classSystem.php#a47b00cd00684aebe3c095aba010626e5">current_local_solution</a>, send_list); 
<a name="l00308"></a>00308 }
<a name="l00309"></a>00309 
<a name="l00310"></a>00310 
<a name="l00311"></a>00311 
<a name="l00312"></a><a class="code" href="classSystem.php#a7bb92857324a079524ac526279edf20c">00312</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a7bb92857324a079524ac526279edf20c">System::re_update</a> ()
<a name="l00313"></a>00313 {
<a name="l00314"></a>00314   <span class="comment">//const std::vector&lt;unsigned int&gt;&amp; send_list = _dof_map-&gt;get_send_list ();</span>
<a name="l00315"></a>00315 
<a name="l00316"></a>00316   <span class="comment">// If this system is empty... don&#39;t do anything!</span>
<a name="l00317"></a>00317   <span class="keywordflow">if</span>(!this-&gt;<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>())
<a name="l00318"></a>00318     <span class="keywordflow">return</span>;
<a name="l00319"></a>00319 
<a name="l00320"></a>00320   <span class="comment">// Explicitly build a send_list</span>
<a name="l00321"></a>00321   std::vector&lt;unsigned int&gt; send_list(<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;size());
<a name="l00322"></a>00322   <a class="code" href="namespaceUtility.php#a7c2b0a25e726200178bc1ec52b132981">Utility::iota</a> (send_list.begin(), send_list.end(), 0);
<a name="l00323"></a>00323   
<a name="l00324"></a>00324   <span class="comment">// Check sizes</span>
<a name="l00325"></a>00325   libmesh_assert (<a class="code" href="classSystem.php#a47b00cd00684aebe3c095aba010626e5">current_local_solution</a>-&gt;size()       == <a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;size());
<a name="l00326"></a>00326   <span class="comment">// Not true with ghosted vectors</span>
<a name="l00327"></a>00327   <span class="comment">// libmesh_assert (current_local_solution-&gt;local_size() == solution-&gt;size());</span>
<a name="l00328"></a>00328   libmesh_assert (!send_list.empty());
<a name="l00329"></a>00329   libmesh_assert (send_list.size() &lt;= <a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;size());
<a name="l00330"></a>00330 
<a name="l00331"></a>00331   <span class="comment">// Create current_local_solution from solution.  This will</span>
<a name="l00332"></a>00332   <span class="comment">// put a local copy of solution into current_local_solution.</span>
<a name="l00333"></a>00333   <a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;localize (*<a class="code" href="classSystem.php#a47b00cd00684aebe3c095aba010626e5">current_local_solution</a>, send_list);
<a name="l00334"></a>00334 }
<a name="l00335"></a>00335 
<a name="l00336"></a>00336 
<a name="l00337"></a>00337 
<a name="l00338"></a><a class="code" href="classSystem.php#abca899f8ae44d10c606fe28b5e8420dd">00338</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#abca899f8ae44d10c606fe28b5e8420dd">System::assemble</a> ()
<a name="l00339"></a>00339 {
<a name="l00340"></a>00340   <span class="comment">// Log how long the user&#39;s matrix assembly code takes</span>
<a name="l00341"></a>00341   START_LOG(<span class="stringliteral">&quot;assemble()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l00342"></a>00342   
<a name="l00343"></a>00343   <span class="comment">// Call the user-specified assembly function</span>
<a name="l00344"></a>00344   this-&gt;<a class="code" href="classSystem.php#a036e30ca724b36d1cb3bb7671abd803b">user_assembly</a>();
<a name="l00345"></a>00345 
<a name="l00346"></a>00346   <span class="comment">// Stop logging the user code</span>
<a name="l00347"></a>00347   STOP_LOG(<span class="stringliteral">&quot;assemble()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l00348"></a>00348 }
<a name="l00349"></a>00349 
<a name="l00350"></a>00350 
<a name="l00351"></a>00351 
<a name="l00352"></a><a class="code" href="classSystem.php#a80a51f5a333e470498740358fac6f959">00352</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a80a51f5a333e470498740358fac6f959">System::assemble_qoi</a> ()
<a name="l00353"></a>00353 {
<a name="l00354"></a>00354   <span class="comment">// Log how long the user&#39;s matrix assembly code takes</span>
<a name="l00355"></a>00355   START_LOG(<span class="stringliteral">&quot;assemble_qoi()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l00356"></a>00356   
<a name="l00357"></a>00357   <span class="comment">// Call the user-specified quantity of interest function</span>
<a name="l00358"></a>00358   this-&gt;<a class="code" href="classSystem.php#a35700e9b9e3ab677b9b68545f8475c31">user_QOI</a>();
<a name="l00359"></a>00359 
<a name="l00360"></a>00360   <span class="comment">// Stop logging the user code</span>
<a name="l00361"></a>00361   STOP_LOG(<span class="stringliteral">&quot;assemble_qoi()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l00362"></a>00362 }
<a name="l00363"></a>00363 
<a name="l00364"></a>00364 
<a name="l00365"></a>00365 
<a name="l00366"></a><a class="code" href="classSystem.php#a70a20011f2bf9131e08fdcac9834e81f">00366</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a70a20011f2bf9131e08fdcac9834e81f">System::assemble_qoi_derivative</a> ()
<a name="l00367"></a>00367 {
<a name="l00368"></a>00368   <span class="comment">// Log how long the user&#39;s matrix assembly code takes</span>
<a name="l00369"></a>00369   START_LOG(<span class="stringliteral">&quot;assemble_qoi_derivative()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l00370"></a>00370   
<a name="l00371"></a>00371   <span class="comment">// Call the user-specified quantity of interest function</span>
<a name="l00372"></a>00372   this-&gt;<a class="code" href="classSystem.php#a47d7cfeebdc12f6a0f2b8465cebc7c11">user_QOI_derivative</a>();
<a name="l00373"></a>00373 
<a name="l00374"></a>00374   <span class="comment">// Stop logging the user code</span>
<a name="l00375"></a>00375   STOP_LOG(<span class="stringliteral">&quot;assemble_qoi_derivative()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l00376"></a>00376 }
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 
<a name="l00379"></a>00379 
<a name="l00380"></a><a class="code" href="classSystem.php#aaf10bae4e91cb13989a0824283c1865e">00380</a> <span class="keywordtype">bool</span> <a class="code" href="classSystem.php#aaf10bae4e91cb13989a0824283c1865e">System::compare</a> (<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; other_system, 
<a name="l00381"></a>00381                       <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> threshold,
<a name="l00382"></a>00382                       <span class="keyword">const</span> <span class="keywordtype">bool</span> verbose)<span class="keyword"> const</span>
<a name="l00383"></a>00383 <span class="keyword"></span>{
<a name="l00384"></a>00384   <span class="comment">// we do not care for matrices, but for vectors</span>
<a name="l00385"></a>00385   libmesh_assert (!<a class="code" href="classSystem.php#ab6e6f8f579140ed6bfe4fe95f4084852">_can_add_vectors</a>);
<a name="l00386"></a>00386   libmesh_assert (!other_system.<a class="code" href="classSystem.php#ab6e6f8f579140ed6bfe4fe95f4084852">_can_add_vectors</a>);
<a name="l00387"></a>00387 
<a name="l00388"></a>00388   <span class="keywordflow">if</span> (verbose)
<a name="l00389"></a>00389     {
<a name="l00390"></a>00390       std::cout &lt;&lt; <span class="stringliteral">&quot;  Systems \&quot;&quot;</span> &lt;&lt; <a class="code" href="classSystem.php#a4b6821843a8c8f11824788d03000416b">_sys_name</a> &lt;&lt; <span class="stringliteral">&quot;\&quot;&quot;</span> &lt;&lt; std::endl;
<a name="l00391"></a>00391       std::cout &lt;&lt; <span class="stringliteral">&quot;   comparing matrices not supported.&quot;</span> &lt;&lt; std::endl;
<a name="l00392"></a>00392       std::cout &lt;&lt; <span class="stringliteral">&quot;   comparing names...&quot;</span>;
<a name="l00393"></a>00393     }
<a name="l00394"></a>00394 
<a name="l00395"></a>00395   <span class="comment">// compare the name: 0 means identical</span>
<a name="l00396"></a>00396   <span class="keyword">const</span> <span class="keywordtype">int</span> name_result = <a class="code" href="classSystem.php#a4b6821843a8c8f11824788d03000416b">_sys_name</a>.compare(other_system.<a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>());
<a name="l00397"></a>00397   <span class="keywordflow">if</span> (verbose)
<a name="l00398"></a>00398     {
<a name="l00399"></a>00399       <span class="keywordflow">if</span> (name_result == 0)
<a name="l00400"></a>00400         std::cout &lt;&lt; <span class="stringliteral">&quot; identical.&quot;</span> &lt;&lt; std::endl;
<a name="l00401"></a>00401       <span class="keywordflow">else</span>
<a name="l00402"></a>00402         std::cout &lt;&lt; <span class="stringliteral">&quot;  names not identical.&quot;</span> &lt;&lt; std::endl;
<a name="l00403"></a>00403       std::cout &lt;&lt; <span class="stringliteral">&quot;   comparing solution vector...&quot;</span>;
<a name="l00404"></a>00404     }
<a name="l00405"></a>00405 
<a name="l00406"></a>00406 
<a name="l00407"></a>00407   <span class="comment">// compare the solution: -1 means identical</span>
<a name="l00408"></a>00408   <span class="keyword">const</span> <span class="keywordtype">int</span> solu_result = <a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;compare (*other_system.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>(),
<a name="l00409"></a>00409                                              threshold);
<a name="l00410"></a>00410 
<a name="l00411"></a>00411   <span class="keywordflow">if</span> (verbose)
<a name="l00412"></a>00412     {
<a name="l00413"></a>00413       <span class="keywordflow">if</span> (solu_result == -1)
<a name="l00414"></a>00414         std::cout &lt;&lt; <span class="stringliteral">&quot; identical up to threshold.&quot;</span> &lt;&lt; std::endl;
<a name="l00415"></a>00415       <span class="keywordflow">else</span>
<a name="l00416"></a>00416         std::cout &lt;&lt; <span class="stringliteral">&quot;  first difference occured at index = &quot;</span> 
<a name="l00417"></a>00417                   &lt;&lt; solu_result &lt;&lt; <span class="stringliteral">&quot;.&quot;</span> &lt;&lt; std::endl;
<a name="l00418"></a>00418     }
<a name="l00419"></a>00419 
<a name="l00420"></a>00420 
<a name="l00421"></a>00421   <span class="comment">// safety check, whether we handle at least the same number</span>
<a name="l00422"></a>00422   <span class="comment">// of vectors</span>
<a name="l00423"></a>00423   std::vector&lt;int&gt; ov_result;
<a name="l00424"></a>00424 
<a name="l00425"></a>00425   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classSystem.php#adf187b75dac8c906b0b27ce25e146305">n_vectors</a>() != other_system.<a class="code" href="classSystem.php#adf187b75dac8c906b0b27ce25e146305">n_vectors</a>())
<a name="l00426"></a>00426     {
<a name="l00427"></a>00427       <span class="keywordflow">if</span> (verbose)
<a name="l00428"></a>00428         {
<a name="l00429"></a>00429           std::cout &lt;&lt; <span class="stringliteral">&quot;   Fatal difference. This system handles &quot;</span> 
<a name="l00430"></a>00430                     &lt;&lt; this-&gt;<a class="code" href="classSystem.php#adf187b75dac8c906b0b27ce25e146305">n_vectors</a>() &lt;&lt; <span class="stringliteral">&quot; add&#39;l vectors,&quot;</span> &lt;&lt; std::endl
<a name="l00431"></a>00431                     &lt;&lt; <span class="stringliteral">&quot;   while the other system handles &quot;</span>
<a name="l00432"></a>00432                     &lt;&lt; other_system.<a class="code" href="classSystem.php#adf187b75dac8c906b0b27ce25e146305">n_vectors</a>() 
<a name="l00433"></a>00433                     &lt;&lt; <span class="stringliteral">&quot; add&#39;l vectors.&quot;</span> &lt;&lt; std::endl
<a name="l00434"></a>00434                     &lt;&lt; <span class="stringliteral">&quot;   Aborting comparison.&quot;</span> &lt;&lt; std::endl;
<a name="l00435"></a>00435         }
<a name="l00436"></a>00436       <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00437"></a>00437     }
<a name="l00438"></a>00438   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classSystem.php#adf187b75dac8c906b0b27ce25e146305">n_vectors</a>() == 0)
<a name="l00439"></a>00439     {
<a name="l00440"></a>00440       <span class="comment">// there are no additional vectors...</span>
<a name="l00441"></a>00441       ov_result.clear ();
<a name="l00442"></a>00442     }
<a name="l00443"></a>00443   <span class="keywordflow">else</span>
<a name="l00444"></a>00444     {
<a name="l00445"></a>00445       <span class="comment">// compare other vectors</span>
<a name="l00446"></a>00446       <span class="keywordflow">for</span> (<a class="code" href="classSystem.php#a85440d8ff0086de5be93ae0922937d0c">const_vectors_iterator</a> pos = <a class="code" href="classSystem.php#af306b03372a5ade33a7569b81af47ef1">_vectors</a>.begin();
<a name="l00447"></a>00447            pos != <a class="code" href="classSystem.php#af306b03372a5ade33a7569b81af47ef1">_vectors</a>.end(); ++pos)
<a name="l00448"></a>00448         {
<a name="l00449"></a>00449           <span class="keywordflow">if</span> (verbose)
<a name="l00450"></a>00450               std::cout &lt;&lt; <span class="stringliteral">&quot;   comparing vector \&quot;&quot;</span>
<a name="l00451"></a>00451                         &lt;&lt; pos-&gt;first &lt;&lt; <span class="stringliteral">&quot;\&quot; ...&quot;</span>;
<a name="l00452"></a>00452 
<a name="l00453"></a>00453           <span class="comment">// assume they have the same name</span>
<a name="l00454"></a>00454           <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp; other_system_vector = 
<a name="l00455"></a>00455               other_system.<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(pos-&gt;first);
<a name="l00456"></a>00456 
<a name="l00457"></a>00457           ov_result.push_back(pos-&gt;second-&gt;compare (other_system_vector,
<a name="l00458"></a>00458                                                     threshold));
<a name="l00459"></a>00459 
<a name="l00460"></a>00460           <span class="keywordflow">if</span> (verbose)
<a name="l00461"></a>00461             {
<a name="l00462"></a>00462               <span class="keywordflow">if</span> (ov_result[ov_result.size()-1] == -1)
<a name="l00463"></a>00463                 std::cout &lt;&lt; <span class="stringliteral">&quot; identical up to threshold.&quot;</span> &lt;&lt; std::endl;
<a name="l00464"></a>00464               <span class="keywordflow">else</span>
<a name="l00465"></a>00465                 std::cout &lt;&lt; <span class="stringliteral">&quot; first difference occured at&quot;</span> &lt;&lt; std::endl
<a name="l00466"></a>00466                           &lt;&lt; <span class="stringliteral">&quot;   index = &quot;</span> &lt;&lt; ov_result[ov_result.size()-1] &lt;&lt; <span class="stringliteral">&quot;.&quot;</span> &lt;&lt; std::endl;
<a name="l00467"></a>00467             }
<a name="l00468"></a>00468 
<a name="l00469"></a>00469         }
<a name="l00470"></a>00470 
<a name="l00471"></a>00471     } <span class="comment">// finished comparing additional vectors</span>
<a name="l00472"></a>00472 
<a name="l00473"></a>00473 
<a name="l00474"></a>00474   <span class="keywordtype">bool</span> overall_result;
<a name="l00475"></a>00475        
<a name="l00476"></a>00476   <span class="comment">// sum up the results</span>
<a name="l00477"></a>00477   <span class="keywordflow">if</span> ((name_result==0) &amp;&amp; (solu_result==-1))
<a name="l00478"></a>00478     {
<a name="l00479"></a>00479       <span class="keywordflow">if</span> (ov_result.size()==0)
<a name="l00480"></a>00480         overall_result = <span class="keyword">true</span>;
<a name="l00481"></a>00481       <span class="keywordflow">else</span>
<a name="l00482"></a>00482         {
<a name="l00483"></a>00483           <span class="keywordtype">bool</span> ov_identical;
<a name="l00484"></a>00484           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n    = 0;
<a name="l00485"></a>00485           <span class="keywordflow">do</span>
<a name="l00486"></a>00486             {
<a name="l00487"></a>00487               ov_identical = (ov_result[n]==-1);
<a name="l00488"></a>00488               n++;
<a name="l00489"></a>00489             }
<a name="l00490"></a>00490           <span class="keywordflow">while</span> (ov_identical &amp;&amp; n&lt;ov_result.size());
<a name="l00491"></a>00491           overall_result = ov_identical;
<a name="l00492"></a>00492         }
<a name="l00493"></a>00493     }
<a name="l00494"></a>00494   <span class="keywordflow">else</span>
<a name="l00495"></a>00495     overall_result = <span class="keyword">false</span>;
<a name="l00496"></a>00496 
<a name="l00497"></a>00497   <span class="keywordflow">if</span> (verbose)
<a name="l00498"></a>00498     {
<a name="l00499"></a>00499       std::cout &lt;&lt; <span class="stringliteral">&quot;   finished comparisons, &quot;</span>;
<a name="l00500"></a>00500       <span class="keywordflow">if</span> (overall_result)
<a name="l00501"></a>00501         std::cout &lt;&lt; <span class="stringliteral">&quot;found no differences.&quot;</span> &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l00502"></a>00502       <span class="keywordflow">else</span> 
<a name="l00503"></a>00503         std::cout &lt;&lt; <span class="stringliteral">&quot;found differences.&quot;</span> &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l00504"></a>00504     }
<a name="l00505"></a>00505           
<a name="l00506"></a>00506   <span class="keywordflow">return</span> overall_result;
<a name="l00507"></a>00507 }
<a name="l00508"></a>00508 
<a name="l00509"></a>00509 
<a name="l00510"></a>00510 
<a name="l00511"></a><a class="code" href="classSystem.php#afb0ea08442d8a71cf040f598f767a396">00511</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#afb0ea08442d8a71cf040f598f767a396">System::update_global_solution</a> (std::vector&lt;Number&gt;&amp; global_soln)<span class="keyword"> const</span>
<a name="l00512"></a>00512 <span class="keyword"></span>{
<a name="l00513"></a>00513   global_soln.resize (<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;size());
<a name="l00514"></a>00514 
<a name="l00515"></a>00515   <a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;localize (global_soln);
<a name="l00516"></a>00516 }
<a name="l00517"></a>00517 
<a name="l00518"></a>00518 
<a name="l00519"></a>00519 
<a name="l00520"></a><a class="code" href="classSystem.php#a754d5dddc335fdfa86ae7587ac87d937">00520</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#afb0ea08442d8a71cf040f598f767a396">System::update_global_solution</a> (std::vector&lt;Number&gt;&amp; global_soln,
<a name="l00521"></a>00521                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>   dest_proc)<span class="keyword"> const</span>
<a name="l00522"></a>00522 <span class="keyword"></span>{
<a name="l00523"></a>00523   global_soln.resize        (<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;size());
<a name="l00524"></a>00524 
<a name="l00525"></a>00525   <a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;localize_to_one (global_soln, dest_proc);
<a name="l00526"></a>00526 }
<a name="l00527"></a>00527 
<a name="l00528"></a>00528 
<a name="l00529"></a>00529 
<a name="l00530"></a><a class="code" href="classSystem.php#abab8a3810cc43d99fe395d449207b786">00530</a> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classSystem.php#abab8a3810cc43d99fe395d449207b786">System::add_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name,
<a name="l00531"></a>00531                                             <span class="keyword">const</span> <span class="keywordtype">bool</span> projections)
<a name="l00532"></a>00532 {
<a name="l00533"></a>00533   <span class="comment">// Return the vector if it is already there.</span>
<a name="l00534"></a>00534   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classSystem.php#a4fb11ff7ba967513144ba6fb1e4d85e6">have_vector</a>(vec_name))
<a name="l00535"></a>00535     <span class="keywordflow">return</span> *(<a class="code" href="classSystem.php#af306b03372a5ade33a7569b81af47ef1">_vectors</a>[vec_name]);
<a name="l00536"></a>00536 
<a name="l00537"></a>00537   <span class="comment">// Otherwise build the vector</span>
<a name="l00538"></a>00538   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* buf = <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;::build</a>().release();
<a name="l00539"></a>00539   <a class="code" href="classSystem.php#af306b03372a5ade33a7569b81af47ef1">_vectors</a>.insert (std::make_pair (vec_name, buf));
<a name="l00540"></a>00540   <a class="code" href="classSystem.php#a6c7fa5761b1ddb3c5fa5689df975e179">_vector_projections</a>.insert (std::make_pair (vec_name, projections));
<a name="l00541"></a>00541 
<a name="l00542"></a>00542   <span class="comment">// Initialize it if necessary</span>
<a name="l00543"></a>00543   <span class="keywordflow">if</span> (!<a class="code" href="classSystem.php#ab6e6f8f579140ed6bfe4fe95f4084852">_can_add_vectors</a>)
<a name="l00544"></a>00544     buf-&gt;<a class="code" href="classNumericVector.php#abbb0c0eb886ba1c6bb835d6275475c6e">init</a> (this-&gt;<a class="code" href="classSystem.php#aa8f04263eed1eaf253e81041f166408b">n_dofs</a>(), this-&gt;<a class="code" href="classSystem.php#a401d38d088ef9140e51c455387af319d">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>);
<a name="l00545"></a>00545 
<a name="l00546"></a>00546   <span class="keywordflow">return</span> *buf;
<a name="l00547"></a>00547 }
<a name="l00548"></a>00548 
<a name="l00549"></a>00549 
<a name="l00550"></a>00550 
<a name="l00551"></a><a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">00551</a> <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">System::get_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name)<span class="keyword"> const</span>
<a name="l00552"></a>00552 <span class="keyword"></span>{
<a name="l00553"></a>00553   <span class="comment">// Make sure the vector exists</span>
<a name="l00554"></a>00554   <a class="code" href="classSystem.php#a85440d8ff0086de5be93ae0922937d0c">const_vectors_iterator</a> pos = <a class="code" href="classSystem.php#af306b03372a5ade33a7569b81af47ef1">_vectors</a>.find(vec_name);
<a name="l00555"></a>00555   
<a name="l00556"></a>00556   <span class="keywordflow">if</span> (pos == <a class="code" href="classSystem.php#af306b03372a5ade33a7569b81af47ef1">_vectors</a>.end())
<a name="l00557"></a>00557     {
<a name="l00558"></a>00558       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: vector &quot;</span>
<a name="l00559"></a>00559                 &lt;&lt; vec_name
<a name="l00560"></a>00560                 &lt;&lt; <span class="stringliteral">&quot; does not exist in this system!&quot;</span>
<a name="l00561"></a>00561                 &lt;&lt; std::endl;      
<a name="l00562"></a>00562       libmesh_error();
<a name="l00563"></a>00563     }
<a name="l00564"></a>00564   
<a name="l00565"></a>00565   <span class="keywordflow">return</span> *(pos-&gt;second);
<a name="l00566"></a>00566 }
<a name="l00567"></a>00567 
<a name="l00568"></a>00568 
<a name="l00569"></a>00569 
<a name="l00570"></a><a class="code" href="classSystem.php#a2c007141d080758e2f9280520dd6f0f3">00570</a> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">System::get_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name)
<a name="l00571"></a>00571 {
<a name="l00572"></a>00572   <span class="comment">// Make sure the vector exists</span>
<a name="l00573"></a>00573   <a class="code" href="classSystem.php#ac1939aeca6473017c8b6a560892e86aa">vectors_iterator</a> pos = <a class="code" href="classSystem.php#af306b03372a5ade33a7569b81af47ef1">_vectors</a>.find(vec_name);
<a name="l00574"></a>00574   
<a name="l00575"></a>00575   <span class="keywordflow">if</span> (pos == <a class="code" href="classSystem.php#af306b03372a5ade33a7569b81af47ef1">_vectors</a>.end())
<a name="l00576"></a>00576     {
<a name="l00577"></a>00577       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: vector &quot;</span>
<a name="l00578"></a>00578                 &lt;&lt; vec_name
<a name="l00579"></a>00579                 &lt;&lt; <span class="stringliteral">&quot; does not exist in this system!&quot;</span>
<a name="l00580"></a>00580                 &lt;&lt; std::endl;      
<a name="l00581"></a>00581       libmesh_error();
<a name="l00582"></a>00582     }
<a name="l00583"></a>00583   
<a name="l00584"></a>00584   <span class="keywordflow">return</span> *(pos-&gt;second);
<a name="l00585"></a>00585 }
<a name="l00586"></a>00586 
<a name="l00587"></a>00587 
<a name="l00588"></a>00588 
<a name="l00589"></a><a class="code" href="classSystem.php#a36372d24c9601ccb0507acbd7a0ca360">00589</a> <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">System::get_vector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vec_num)<span class="keyword"> const</span>
<a name="l00590"></a>00590 <span class="keyword"></span>{
<a name="l00591"></a>00591   <a class="code" href="classSystem.php#a85440d8ff0086de5be93ae0922937d0c">const_vectors_iterator</a> v = <a class="code" href="classSystem.php#aa33cb0639b60f352561646fcce51a06b">vectors_begin</a>();
<a name="l00592"></a>00592   <a class="code" href="classSystem.php#a85440d8ff0086de5be93ae0922937d0c">const_vectors_iterator</a> v_end = <a class="code" href="classSystem.php#a0c1c70cc7f560cda430474eea1702082">vectors_end</a>();
<a name="l00593"></a>00593   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num = 0;
<a name="l00594"></a>00594   <span class="keywordflow">while</span>((num&lt;vec_num) &amp;&amp; (v!=v_end))
<a name="l00595"></a>00595     {
<a name="l00596"></a>00596       num++;
<a name="l00597"></a>00597       ++v;
<a name="l00598"></a>00598     }
<a name="l00599"></a>00599   libmesh_assert(v!=v_end);
<a name="l00600"></a>00600   <span class="keywordflow">return</span> *(v-&gt;second);
<a name="l00601"></a>00601 }
<a name="l00602"></a>00602 
<a name="l00603"></a>00603 
<a name="l00604"></a>00604 
<a name="l00605"></a><a class="code" href="classSystem.php#a57b47f7cff71539589055f2ac9c60790">00605</a> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">System::get_vector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vec_num)
<a name="l00606"></a>00606 {
<a name="l00607"></a>00607   <a class="code" href="classSystem.php#ac1939aeca6473017c8b6a560892e86aa">vectors_iterator</a> v = <a class="code" href="classSystem.php#aa33cb0639b60f352561646fcce51a06b">vectors_begin</a>();
<a name="l00608"></a>00608   <a class="code" href="classSystem.php#ac1939aeca6473017c8b6a560892e86aa">vectors_iterator</a> v_end = <a class="code" href="classSystem.php#a0c1c70cc7f560cda430474eea1702082">vectors_end</a>();
<a name="l00609"></a>00609   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num = 0;
<a name="l00610"></a>00610   <span class="keywordflow">while</span>((num&lt;vec_num) &amp;&amp; (v!=v_end))
<a name="l00611"></a>00611     {
<a name="l00612"></a>00612       num++;
<a name="l00613"></a>00613       ++v;
<a name="l00614"></a>00614     }
<a name="l00615"></a>00615   libmesh_assert(v!=v_end);
<a name="l00616"></a>00616   <span class="keywordflow">return</span> *(v-&gt;second);
<a name="l00617"></a>00617 }
<a name="l00618"></a>00618 
<a name="l00619"></a>00619 
<a name="l00620"></a>00620 
<a name="l00621"></a><a class="code" href="classSystem.php#a79fe01b54b0441fd670b3b092da1e7bd">00621</a> <span class="keyword">const</span> std::string&amp; <a class="code" href="classSystem.php#a79fe01b54b0441fd670b3b092da1e7bd">System::vector_name</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vec_num)
<a name="l00622"></a>00622 {
<a name="l00623"></a>00623   <a class="code" href="classSystem.php#a85440d8ff0086de5be93ae0922937d0c">const_vectors_iterator</a> v = <a class="code" href="classSystem.php#aa33cb0639b60f352561646fcce51a06b">vectors_begin</a>();
<a name="l00624"></a>00624   <a class="code" href="classSystem.php#a85440d8ff0086de5be93ae0922937d0c">const_vectors_iterator</a> v_end = <a class="code" href="classSystem.php#a0c1c70cc7f560cda430474eea1702082">vectors_end</a>();
<a name="l00625"></a>00625   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num = 0;
<a name="l00626"></a>00626   <span class="keywordflow">while</span>((num&lt;vec_num) &amp;&amp; (v!=v_end))
<a name="l00627"></a>00627     {
<a name="l00628"></a>00628       num++;
<a name="l00629"></a>00629       ++v;
<a name="l00630"></a>00630     }
<a name="l00631"></a>00631   libmesh_assert(v!=v_end);
<a name="l00632"></a>00632   <span class="keywordflow">return</span> v-&gt;first;
<a name="l00633"></a>00633 }
<a name="l00634"></a>00634 
<a name="l00635"></a>00635 
<a name="l00636"></a>00636 
<a name="l00637"></a><a class="code" href="classSystem.php#ad86b44047ff7beb018105be1b20cab82">00637</a> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classSystem.php#ad86b44047ff7beb018105be1b20cab82">System::get_adjoint_solution</a> ()
<a name="l00638"></a>00638 {
<a name="l00639"></a>00639   <span class="comment">// Get the adjoint solution using the get_vector function declared above</span>
<a name="l00640"></a>00640   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;adjoint_solution&quot;</span>);
<a name="l00641"></a>00641 }
<a name="l00642"></a>00642 
<a name="l00643"></a>00643 
<a name="l00644"></a>00644 
<a name="l00645"></a><a class="code" href="classSystem.php#a2d42f1cb48d13212dff845c5ad5ebfe0">00645</a> <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classSystem.php#ad86b44047ff7beb018105be1b20cab82">System::get_adjoint_solution</a> ()<span class="keyword"> const</span>
<a name="l00646"></a>00646 <span class="keyword"></span>{
<a name="l00647"></a>00647   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;adjoint_solution&quot;</span>);
<a name="l00648"></a>00648 }
<a name="l00649"></a>00649 
<a name="l00650"></a>00650 
<a name="l00651"></a>00651 
<a name="l00652"></a><a class="code" href="classSystem.php#ae3d0a3c8fe03ce302d6b80fee6d0bd9f">00652</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#ae3d0a3c8fe03ce302d6b80fee6d0bd9f">System::add_variable</a> (<span class="keyword">const</span> std::string&amp; var,
<a name="l00653"></a>00653                                    <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; type,
<a name="l00654"></a>00654                                    <span class="keyword">const</span> std::set&lt;subdomain_id_type&gt; * <span class="keyword">const</span> active_subdomains)
<a name="l00655"></a>00655 {  
<a name="l00656"></a>00656   <span class="comment">// Make sure the variable isn&#39;t there already</span>
<a name="l00657"></a>00657   <span class="comment">// or if it is, that it&#39;s the type we want</span>
<a name="l00658"></a>00658   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;this-&gt;<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>(); v++)
<a name="l00659"></a>00659     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classSystem.php#af3a38b172dd6322eff9f30b3f63d3b63">variable_name</a>(v) == var)
<a name="l00660"></a>00660       {
<a name="l00661"></a>00661         <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classSystem.php#aa917dd59a348a46e9adab63d9767460f">variable_type</a>(v) == type)
<a name="l00662"></a>00662           <span class="keywordflow">return</span> <a class="code" href="classSystem.php#a6937f66076215b9804aecf3983b1c5e8">_variables</a>[v].<a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">number</a>();
<a name="l00663"></a>00663 
<a name="l00664"></a>00664         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: incompatible variable &quot;</span>
<a name="l00665"></a>00665                   &lt;&lt; var
<a name="l00666"></a>00666                   &lt;&lt; <span class="stringliteral">&quot; has already been added for this system!&quot;</span>
<a name="l00667"></a>00667                   &lt;&lt; std::endl;
<a name="l00668"></a>00668         libmesh_error();
<a name="l00669"></a>00669       }
<a name="l00670"></a>00670 
<a name="l00671"></a>00671   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> curr_n_vars = this-&gt;<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>();                                              
<a name="l00672"></a>00672 
<a name="l00673"></a>00673   <span class="comment">// Add the variable to the list</span>
<a name="l00674"></a>00674   <a class="code" href="classSystem.php#a6937f66076215b9804aecf3983b1c5e8">_variables</a>.push_back((active_subdomains == NULL) ?
<a name="l00675"></a>00675                        <a class="code" href="classSystem_1_1Variable.php">Variable</a>(var, curr_n_vars, type) :
<a name="l00676"></a>00676                        <a class="code" href="classSystem_1_1Variable.php">Variable</a>(var, curr_n_vars, type, *active_subdomains));
<a name="l00677"></a>00677 
<a name="l00678"></a>00678   libmesh_assert ((curr_n_vars+1) == this-&gt;<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>());
<a name="l00679"></a>00679 
<a name="l00680"></a>00680   <a class="code" href="classSystem.php#ade03c4f7efd4b1839ff0003971d09d0a">_variable_numbers</a>[var] = curr_n_vars;
<a name="l00681"></a>00681 
<a name="l00682"></a>00682   <span class="comment">// Add the variable to the _dof_map</span>
<a name="l00683"></a>00683   <a class="code" href="classSystem.php#ad9cb48f6abe7baff3d4a501cd92ee88e">_dof_map</a>-&gt;add_variable (<a class="code" href="classSystem.php#a6937f66076215b9804aecf3983b1c5e8">_variables</a>.back());
<a name="l00684"></a>00684 
<a name="l00685"></a>00685   <span class="comment">// Return the number of the new variable</span>
<a name="l00686"></a>00686   <span class="keywordflow">return</span> curr_n_vars;
<a name="l00687"></a>00687 }
<a name="l00688"></a>00688 
<a name="l00689"></a>00689 
<a name="l00690"></a>00690 
<a name="l00691"></a><a class="code" href="classSystem.php#a2892acefaab96252d36a861b1a5eb786">00691</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#ae3d0a3c8fe03ce302d6b80fee6d0bd9f">System::add_variable</a> (<span class="keyword">const</span> std::string&amp; var,
<a name="l00692"></a>00692                                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00693"></a>00693                                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5">FEFamily</a> family,
<a name="l00694"></a>00694                                    <span class="keyword">const</span> std::set&lt;subdomain_id_type&gt; * <span class="keyword">const</span> active_subdomains)
<a name="l00695"></a>00695 {
<a name="l00696"></a>00696   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classSystem.php#ae3d0a3c8fe03ce302d6b80fee6d0bd9f">add_variable</a>(var, 
<a name="l00697"></a>00697                             <a class="code" href="classFEType.php">FEType</a>(order, family), 
<a name="l00698"></a>00698                             active_subdomains);
<a name="l00699"></a>00699 }
<a name="l00700"></a>00700 
<a name="l00701"></a>00701 
<a name="l00702"></a>00702 
<a name="l00703"></a><a class="code" href="classSystem.php#ae4dc616e6d65b6476fb57a643035f59f">00703</a> <span class="keywordtype">bool</span> <a class="code" href="classSystem.php#ae4dc616e6d65b6476fb57a643035f59f">System::has_variable</a> (<span class="keyword">const</span> std::string&amp; var)<span class="keyword"> const</span>
<a name="l00704"></a>00704 <span class="keyword"></span>{
<a name="l00705"></a>00705   <span class="keywordflow">return</span> <a class="code" href="classSystem.php#ade03c4f7efd4b1839ff0003971d09d0a">_variable_numbers</a>.count(var);
<a name="l00706"></a>00706 }
<a name="l00707"></a>00707 
<a name="l00708"></a>00708 
<a name="l00709"></a>00709 
<a name="l00710"></a><a class="code" href="classSystem.php#ace6000ea1d0dc7e3635fe98761f95838">00710</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#ace6000ea1d0dc7e3635fe98761f95838">System::variable_number</a> (<span class="keyword">const</span> std::string&amp; var)<span class="keyword"> const</span>
<a name="l00711"></a>00711 <span class="keyword"></span>{
<a name="l00712"></a>00712   <span class="comment">// Make sure the variable exists</span>
<a name="l00713"></a>00713   std::map&lt;std::string, unsigned short int&gt;::const_iterator
<a name="l00714"></a>00714     pos = <a class="code" href="classSystem.php#ade03c4f7efd4b1839ff0003971d09d0a">_variable_numbers</a>.find(var);
<a name="l00715"></a>00715   
<a name="l00716"></a>00716   <span class="keywordflow">if</span> (pos == <a class="code" href="classSystem.php#ade03c4f7efd4b1839ff0003971d09d0a">_variable_numbers</a>.end())
<a name="l00717"></a>00717     {
<a name="l00718"></a>00718       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: variable &quot;</span>
<a name="l00719"></a>00719                 &lt;&lt; var
<a name="l00720"></a>00720                 &lt;&lt; <span class="stringliteral">&quot; does not exist in this system!&quot;</span>
<a name="l00721"></a>00721                 &lt;&lt; std::endl;      
<a name="l00722"></a>00722       libmesh_error();
<a name="l00723"></a>00723     }
<a name="l00724"></a>00724   libmesh_assert (<a class="code" href="classSystem.php#a6937f66076215b9804aecf3983b1c5e8">_variables</a>[pos-&gt;second].name() == var);
<a name="l00725"></a>00725 
<a name="l00726"></a>00726   <span class="keywordflow">return</span> pos-&gt;second;
<a name="l00727"></a>00727 }
<a name="l00728"></a>00728 
<a name="l00729"></a>00729 
<a name="l00730"></a><a class="code" href="classSystem.php#a5f0763fc42313f9a8cabcc61e99885fe">00730</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a5f0763fc42313f9a8cabcc61e99885fe">System::local_dof_indices</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, std::set&lt;unsigned int&gt; &amp; var_indices)<span class="keyword"> const</span>
<a name="l00731"></a>00731 <span class="keyword"></span>{
<a name="l00732"></a>00732   <span class="comment">// Make sure the set is clear</span>
<a name="l00733"></a>00733   var_indices.clear();
<a name="l00734"></a>00734 
<a name="l00735"></a>00735   std::vector&lt;unsigned int&gt; dof_indices;
<a name="l00736"></a>00736   
<a name="l00737"></a>00737   <span class="comment">// Begin the loop over the elements</span>
<a name="l00738"></a>00738   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     =
<a name="l00739"></a>00739     this-&gt;<a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">get_mesh</a>().<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00740"></a>00740   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el =
<a name="l00741"></a>00741     this-&gt;<a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">get_mesh</a>().<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>();
<a name="l00742"></a>00742 
<a name="l00743"></a>00743   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00744"></a>00744     first_local = this-&gt;<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#a4908535aa4a29e6441c197c8f7cd594e">first_dof</a>(),
<a name="l00745"></a>00745     end_local   = this-&gt;<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#ab838f2e72aaf8614c97fcd47a13781b8">end_dof</a>();
<a name="l00746"></a>00746 
<a name="l00747"></a>00747   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00748"></a>00748     {
<a name="l00749"></a>00749       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *el;      
<a name="l00750"></a>00750       this-&gt;<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#afc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (elem, dof_indices, var);
<a name="l00751"></a>00751 
<a name="l00752"></a>00752       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;dof_indices.size(); i++)
<a name="l00753"></a>00753         {
<a name="l00754"></a>00754           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dof = dof_indices[i];
<a name="l00755"></a>00755 
<a name="l00756"></a>00756           <span class="comment">//If the dof is owned by the local processor</span>
<a name="l00757"></a>00757           <span class="keywordflow">if</span>(first_local &lt;= dof &amp;&amp; dof &lt; end_local)
<a name="l00758"></a>00758             var_indices.insert(dof_indices[i]);
<a name="l00759"></a>00759         }
<a name="l00760"></a>00760     }
<a name="l00761"></a>00761 }
<a name="l00762"></a>00762 
<a name="l00763"></a><a class="code" href="classSystem.php#a46ba137d78257fe4a9e124f100a775f8">00763</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a46ba137d78257fe4a9e124f100a775f8">System::zero_variable</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp; v, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var_num)<span class="keyword"> const</span>
<a name="l00764"></a>00764 <span class="keyword"></span>{
<a name="l00765"></a>00765   <span class="comment">/* Make sure the call makes sense.  */</span>
<a name="l00766"></a>00766   libmesh_assert(var_num&lt;this-&gt;<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>());
<a name="l00767"></a>00767 
<a name="l00768"></a>00768   <span class="comment">/* Get a reference to the mesh.  */</span>
<a name="l00769"></a>00769   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh = this-&gt;<a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">get_mesh</a>();
<a name="l00770"></a>00770 
<a name="l00771"></a>00771   <span class="comment">/* Check which system we are.  */</span>
<a name="l00772"></a>00772   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num = this-&gt;<a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">number</a>();
<a name="l00773"></a>00773 
<a name="l00774"></a>00774   <span class="comment">/* Loop over nodes.  */</span>
<a name="l00775"></a>00775   {
<a name="l00776"></a>00776     <a class="code" href="structMeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> it = mesh.<a class="code" href="classMeshBase.php#a6485de7e7d67f36dec274f512d10fc15">local_nodes_begin</a>();
<a name="l00777"></a>00777     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> end_it = mesh.<a class="code" href="classMeshBase.php#ae23ced52382b7238f9182c8593f5cdd5">local_nodes_end</a>(); 
<a name="l00778"></a>00778     <span class="keywordflow">for</span> ( ; it != end_it; ++it)
<a name="l00779"></a>00779       {    
<a name="l00780"></a>00780         <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node = *it;
<a name="l00781"></a>00781         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_comp = node-&gt;<a class="code" href="classDofObject.php#a9388a06483961ab49a5da79e476bd255">n_comp</a>(sys_num,var_num);
<a name="l00782"></a>00782         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_comp; i++)
<a name="l00783"></a>00783           {
<a name="l00784"></a>00784             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index = node-&gt;<a class="code" href="classDofObject.php#a7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(sys_num,var_num,i);
<a name="l00785"></a>00785             v.<a class="code" href="classNumericVector.php#a95b5839d69e0487019ddc8b49f47de96">set</a>(index,0.0);
<a name="l00786"></a>00786           }
<a name="l00787"></a>00787       }
<a name="l00788"></a>00788   }
<a name="l00789"></a>00789 
<a name="l00790"></a>00790   <span class="comment">/* Loop over elements.  */</span>
<a name="l00791"></a>00791   {
<a name="l00792"></a>00792     <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> it = mesh.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00793"></a>00793     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_it = mesh.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>(); 
<a name="l00794"></a>00794     <span class="keywordflow">for</span> ( ; it != end_it; ++it)
<a name="l00795"></a>00795       {    
<a name="l00796"></a>00796         <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *it;
<a name="l00797"></a>00797         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_comp = elem-&gt;<a class="code" href="classDofObject.php#a9388a06483961ab49a5da79e476bd255">n_comp</a>(sys_num,var_num);
<a name="l00798"></a>00798         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_comp; i++)
<a name="l00799"></a>00799           {
<a name="l00800"></a>00800             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index = elem-&gt;<a class="code" href="classDofObject.php#a7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(sys_num,var_num,i);
<a name="l00801"></a>00801             v.<a class="code" href="classNumericVector.php#a95b5839d69e0487019ddc8b49f47de96">set</a>(index,0.0);
<a name="l00802"></a>00802           }
<a name="l00803"></a>00803       }
<a name="l00804"></a>00804   }
<a name="l00805"></a>00805 }
<a name="l00806"></a>00806 
<a name="l00807"></a><a class="code" href="classSystem.php#ad44c76740f901c5e7559cd1b6f9dfd5a">00807</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classSystem.php#ad44c76740f901c5e7559cd1b6f9dfd5a">System::discrete_var_norm</a>(<a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp; v,
<a name="l00808"></a>00808                                <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00809"></a>00809                                <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a> norm_type)<span class="keyword"> const</span>
<a name="l00810"></a>00810 <span class="keyword"></span>{
<a name="l00811"></a>00811   std::set&lt;unsigned int&gt; var_indices;
<a name="l00812"></a>00812   <a class="code" href="classSystem.php#a5f0763fc42313f9a8cabcc61e99885fe">local_dof_indices</a>(var, var_indices);
<a name="l00813"></a>00813 
<a name="l00814"></a>00814   <span class="keywordflow">if</span>(norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad5b9182056de3e279abd0e8120c1c774">DISCRETE_L1</a>)
<a name="l00815"></a>00815     <span class="keywordflow">return</span> v.<a class="code" href="classNumericVector.php#aa7dd3afd81017c57f980dea9092ffa74">subset_l1_norm</a>(var_indices);
<a name="l00816"></a>00816   <span class="keywordflow">if</span>(norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a482797897c042873f53453795347edb6">DISCRETE_L2</a>)
<a name="l00817"></a>00817     <span class="keywordflow">return</span> v.<a class="code" href="classNumericVector.php#a223c7b1890765ea0a5b6f0d3801d8ba8">subset_l2_norm</a>(var_indices);
<a name="l00818"></a>00818   <span class="keywordflow">if</span>(norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ae354be98c29a8529ca57555180313292">DISCRETE_L_INF</a>)
<a name="l00819"></a>00819     <span class="keywordflow">return</span> v.<a class="code" href="classNumericVector.php#a78d0fb683c0fcb05dff10b47617b0c06">subset_linfty_norm</a>(var_indices);
<a name="l00820"></a>00820   <span class="keywordflow">else</span>
<a name="l00821"></a>00821     libmesh_error();
<a name="l00822"></a>00822 }
<a name="l00823"></a>00823 
<a name="l00824"></a><a class="code" href="classSystem.php#a9b8d41c541d5fba295a6e9989939b443">00824</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classSystem.php#a9b8d41c541d5fba295a6e9989939b443">System::calculate_norm</a>(<a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp; v,
<a name="l00825"></a>00825                             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00826"></a>00826                             <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a> norm_type)<span class="keyword"> const</span>
<a name="l00827"></a>00827 <span class="keyword"></span>{
<a name="l00828"></a>00828   <span class="comment">//short circuit to save time</span>
<a name="l00829"></a>00829   <span class="keywordflow">if</span>(norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad5b9182056de3e279abd0e8120c1c774">DISCRETE_L1</a> ||
<a name="l00830"></a>00830      norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a482797897c042873f53453795347edb6">DISCRETE_L2</a> ||
<a name="l00831"></a>00831      norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ae354be98c29a8529ca57555180313292">DISCRETE_L_INF</a>)
<a name="l00832"></a>00832     <span class="keywordflow">return</span> <a class="code" href="classSystem.php#ad44c76740f901c5e7559cd1b6f9dfd5a">discrete_var_norm</a>(v,var,norm_type);
<a name="l00833"></a>00833 
<a name="l00834"></a>00834   <span class="comment">// Not a discrete norm</span>
<a name="l00835"></a>00835   std::vector&lt;FEMNormType&gt; norms(this-&gt;<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>(), <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a>);
<a name="l00836"></a>00836   std::vector&lt;Real&gt; weights(this-&gt;<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>(), 0.0);
<a name="l00837"></a>00837   norms[var] = norm_type;
<a name="l00838"></a>00838   weights[var] = 1.0;
<a name="l00839"></a>00839   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> val = this-&gt;<a class="code" href="classSystem.php#a9b8d41c541d5fba295a6e9989939b443">calculate_norm</a>(v, <a class="code" href="classSystemNorm.php">SystemNorm</a>(norms, weights));
<a name="l00840"></a>00840   <span class="keywordflow">return</span> val;
<a name="l00841"></a>00841 }
<a name="l00842"></a>00842 
<a name="l00843"></a>00843 
<a name="l00844"></a>00844 
<a name="l00845"></a><a class="code" href="classSystem.php#a148b114a965747b4747768753ca9e947">00845</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classSystem.php#a9b8d41c541d5fba295a6e9989939b443">System::calculate_norm</a>(<a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp; v,
<a name="l00846"></a>00846                             <span class="keyword">const</span> <a class="code" href="classSystemNorm.php">SystemNorm</a> &amp;norm)<span class="keyword"> const</span>
<a name="l00847"></a>00847 <span class="keyword"></span>{
<a name="l00848"></a>00848   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00849"></a>00849   parallel_only();
<a name="l00850"></a>00850 
<a name="l00851"></a>00851   START_LOG (<span class="stringliteral">&quot;calculate_norm()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l00852"></a>00852 
<a name="l00853"></a>00853   <span class="comment">// Zero the norm before summation</span>
<a name="l00854"></a>00854   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> v_norm = 0.;
<a name="l00855"></a>00855 
<a name="l00856"></a>00856   <span class="keywordflow">if</span> (norm.<a class="code" href="classSystemNorm.php#a9de80f3c79788788a192addd2c49bcc6">is_discrete</a>())
<a name="l00857"></a>00857     {
<a name="l00858"></a>00858       STOP_LOG (<span class="stringliteral">&quot;calculate_norm()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l00859"></a>00859       <span class="comment">//Check to see if all weights are 1.0</span>
<a name="l00860"></a>00860       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> check_var = 0;
<a name="l00861"></a>00861       <span class="keywordflow">for</span> (; check_var != this-&gt;<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>(); ++check_var)
<a name="l00862"></a>00862         <span class="keywordflow">if</span>(norm.<a class="code" href="classSystemNorm.php#ae8b33ea25655f66a4acc368c79723fed">weight</a>(check_var) != 1.0)
<a name="l00863"></a>00863           <span class="keywordflow">break</span>;
<a name="l00864"></a>00864 
<a name="l00865"></a>00865       <span class="comment">//All weights were 1.0 so just do the full vector discrete norm</span>
<a name="l00866"></a>00866       <span class="keywordflow">if</span>(check_var == this-&gt;<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>())
<a name="l00867"></a>00867         {
<a name="l00868"></a>00868           <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a> norm_type = norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(0);
<a name="l00869"></a>00869           
<a name="l00870"></a>00870           <span class="keywordflow">if</span>(norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad5b9182056de3e279abd0e8120c1c774">DISCRETE_L1</a>)
<a name="l00871"></a>00871             <span class="keywordflow">return</span> v.<a class="code" href="classNumericVector.php#a32d1eccab710311df6e4e36afb6c9537">l1_norm</a>();
<a name="l00872"></a>00872           <span class="keywordflow">if</span>(norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a482797897c042873f53453795347edb6">DISCRETE_L2</a>)
<a name="l00873"></a>00873             <span class="keywordflow">return</span> v.<a class="code" href="classNumericVector.php#aae40073beefab5ff9d4418f97b2b4517">l2_norm</a>();
<a name="l00874"></a>00874           <span class="keywordflow">if</span>(norm_type == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ae354be98c29a8529ca57555180313292">DISCRETE_L_INF</a>)
<a name="l00875"></a>00875             <span class="keywordflow">return</span> v.<a class="code" href="classNumericVector.php#a38f90cc59a6732636ee71c0b83f2f65c">linfty_norm</a>();
<a name="l00876"></a>00876           <span class="keywordflow">else</span>
<a name="l00877"></a>00877             libmesh_error();
<a name="l00878"></a>00878         }
<a name="l00879"></a>00879 
<a name="l00880"></a>00880       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var != this-&gt;<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>(); ++var)
<a name="l00881"></a>00881         {
<a name="l00882"></a>00882           <span class="comment">// Skip any variables we don&#39;t need to integrate</span>
<a name="l00883"></a>00883           <span class="keywordflow">if</span> (norm.<a class="code" href="classSystemNorm.php#ae8b33ea25655f66a4acc368c79723fed">weight</a>(var) == 0.0)
<a name="l00884"></a>00884             <span class="keywordflow">continue</span>;
<a name="l00885"></a>00885 
<a name="l00886"></a>00886           v_norm += norm.<a class="code" href="classSystemNorm.php#ae8b33ea25655f66a4acc368c79723fed">weight</a>(var) * <a class="code" href="classSystem.php#ad44c76740f901c5e7559cd1b6f9dfd5a">discrete_var_norm</a>(v, var, norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var));
<a name="l00887"></a>00887         }
<a name="l00888"></a>00888 
<a name="l00889"></a>00889       <span class="keywordflow">return</span> v_norm;
<a name="l00890"></a>00890     }
<a name="l00891"></a>00891 
<a name="l00892"></a>00892   <span class="comment">// Localize the potentially parallel vector</span>
<a name="l00893"></a>00893   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; local_v = <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l00894"></a>00894   local_v-&gt;init(v.<a class="code" href="classNumericVector.php#ae21bc89e89e895ac26b851a31926e194">size</a>(), <span class="keyword">true</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>);
<a name="l00895"></a>00895   v.<a class="code" href="classNumericVector.php#ab5d2d505bd3b8c09e6be4207379d901e">localize</a> (*local_v, <a class="code" href="classSystem.php#ad9cb48f6abe7baff3d4a501cd92ee88e">_dof_map</a>-&gt;get_send_list()); 
<a name="l00896"></a>00896 
<a name="l00897"></a>00897   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = this-&gt;<a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">get_mesh</a>().<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>();
<a name="l00898"></a>00898 
<a name="l00899"></a>00899   <span class="comment">// Loop over all variables</span>
<a name="l00900"></a>00900   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var != this-&gt;<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>(); ++var)
<a name="l00901"></a>00901     {
<a name="l00902"></a>00902       <span class="comment">// Skip any variables we don&#39;t need to integrate</span>
<a name="l00903"></a>00903       <span class="keywordflow">if</span> (norm.<a class="code" href="classSystemNorm.php#ae8b33ea25655f66a4acc368c79723fed">weight</a>(var) == 0.0)
<a name="l00904"></a>00904         <span class="keywordflow">continue</span>;
<a name="l00905"></a>00905 
<a name="l00906"></a>00906       <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_type = this-&gt;<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#ae3c63266417020f38af6e5cc40efca76">variable_type</a>(var);
<a name="l00907"></a>00907       <a class="code" href="classAutoPtr.php">AutoPtr&lt;QBase&gt;</a> qrule =
<a name="l00908"></a>00908         fe_type.<a class="code" href="classFEType.php#a33013296ee9643faec0262714ad9163c">default_quadrature_rule</a> (dim);
<a name="l00909"></a>00909       <a class="code" href="classAutoPtr.php">AutoPtr&lt;FEBase&gt;</a> fe
<a name="l00910"></a>00910         (<a class="code" href="classFEBase.php#a3e86219b79ce4f881e9c48f4fd7b860e">FEBase::build</a>(dim, fe_type));
<a name="l00911"></a>00911       fe-&gt;attach_quadrature_rule (qrule.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>());
<a name="l00912"></a>00912 
<a name="l00913"></a>00913       <span class="keyword">const</span> std::vector&lt;Real&gt;&amp;               JxW = fe-&gt;get_JxW();
<a name="l00914"></a>00914       <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;* phi = NULL;
<a name="l00915"></a>00915       <span class="keywordflow">if</span> (norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a7a46908fc35e8855517abd137413214c">H1</a> ||
<a name="l00916"></a>00916           norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a> ||
<a name="l00917"></a>00917           norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a>)
<a name="l00918"></a>00918         phi = &amp;(fe-&gt;get_phi());
<a name="l00919"></a>00919 
<a name="l00920"></a>00920       <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt;* dphi = NULL;
<a name="l00921"></a>00921       <span class="keywordflow">if</span> (norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a7a46908fc35e8855517abd137413214c">H1</a> ||
<a name="l00922"></a>00922           norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a> ||
<a name="l00923"></a>00923           norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a>)
<a name="l00924"></a>00924         dphi = &amp;(fe-&gt;get_dphi());
<a name="l00925"></a>00925 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00926"></a>00926 <span class="preprocessor"></span>      <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealTensor&gt; &gt;*   d2phi = NULL;
<a name="l00927"></a>00927       <span class="keywordflow">if</span> (norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a> ||
<a name="l00928"></a>00928           norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a>)
<a name="l00929"></a>00929         d2phi = &amp;(fe-&gt;get_d2phi());
<a name="l00930"></a>00930 <span class="preprocessor">#endif</span>
<a name="l00931"></a>00931 <span class="preprocessor"></span>
<a name="l00932"></a>00932       std::vector&lt;unsigned int&gt; dof_indices;
<a name="l00933"></a>00933 
<a name="l00934"></a>00934       <span class="comment">// Begin the loop over the elements</span>
<a name="l00935"></a>00935       <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     =
<a name="l00936"></a>00936         this-&gt;<a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">get_mesh</a>().<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00937"></a>00937       <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el =
<a name="l00938"></a>00938         this-&gt;<a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">get_mesh</a>().<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>();
<a name="l00939"></a>00939 
<a name="l00940"></a>00940       <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00941"></a>00941         {
<a name="l00942"></a>00942           <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *el;
<a name="l00943"></a>00943 
<a name="l00944"></a>00944           fe-&gt;reinit (elem);
<a name="l00945"></a>00945 
<a name="l00946"></a>00946           this-&gt;<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#afc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (elem, dof_indices, var);
<a name="l00947"></a>00947 
<a name="l00948"></a>00948           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = qrule-&gt;n_points();
<a name="l00949"></a>00949 
<a name="l00950"></a>00950           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sf = dof_indices.size();
<a name="l00951"></a>00951 
<a name="l00952"></a>00952           <span class="comment">// Begin the loop over the Quadrature points.</span>
<a name="l00953"></a>00953           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;n_qp; qp++)
<a name="l00954"></a>00954             {
<a name="l00955"></a>00955               <span class="keywordflow">if</span> (norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a7a46908fc35e8855517abd137413214c">H1</a> ||
<a name="l00956"></a>00956                   norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a> ||
<a name="l00957"></a>00957                   norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a>)
<a name="l00958"></a>00958                 {
<a name="l00959"></a>00959                   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> u_h = 0.;
<a name="l00960"></a>00960                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_sf; ++i)
<a name="l00961"></a>00961                     u_h += (*phi)[i][qp] * (*local_v)(dof_indices[i]);
<a name="l00962"></a>00962                   v_norm += norm.<a class="code" href="classSystemNorm.php#a5a1f8483b61f9a931014352ca678f684">weight_sq</a>(var) *
<a name="l00963"></a>00963                             JxW[qp] * <a class="code" href="libmesh__common_8h.php#af9cdd07341b53cc644199f6aec5e1420">libmesh_norm</a>(u_h);
<a name="l00964"></a>00964                 }
<a name="l00965"></a>00965 
<a name="l00966"></a>00966               <span class="keywordflow">if</span> (norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a7a46908fc35e8855517abd137413214c">H1</a> ||
<a name="l00967"></a>00967                   norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a> ||
<a name="l00968"></a>00968                   norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a>)
<a name="l00969"></a>00969                 {
<a name="l00970"></a>00970                   <a class="code" href="classVectorValue.php">Gradient</a> grad_u_h;
<a name="l00971"></a>00971                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_sf; ++i)
<a name="l00972"></a>00972                     grad_u_h.<a class="code" href="classTypeVector.php#ac9000695cb19991b893cb79a07249e9c">add_scaled</a>((*dphi)[i][qp], (*local_v)(dof_indices[i]));
<a name="l00973"></a>00973                   v_norm += norm.<a class="code" href="classSystemNorm.php#a5a1f8483b61f9a931014352ca678f684">weight_sq</a>(var) *
<a name="l00974"></a>00974                             JxW[qp] * grad_u_h.<a class="code" href="classTypeVector.php#a099aac580a3a6fce9276cf5443d0c0e9">size_sq</a>();
<a name="l00975"></a>00975                 }
<a name="l00976"></a>00976 
<a name="l00977"></a>00977 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00978"></a>00978 <span class="preprocessor"></span>              <span class="keywordflow">if</span> (norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a> ||
<a name="l00979"></a>00979                   norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a>)
<a name="l00980"></a>00980                 {
<a name="l00981"></a>00981                   <a class="code" href="classTensorValue.php">Tensor</a> hess_u_h;
<a name="l00982"></a>00982                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_sf; ++i)
<a name="l00983"></a>00983                     hess_u_h.<a class="code" href="classTypeTensor.php#ae24569251bc6ea38090165d349fdfc6c">add_scaled</a>((*d2phi)[i][qp], (*local_v)(dof_indices[i]));
<a name="l00984"></a>00984                   v_norm += norm.<a class="code" href="classSystemNorm.php#a5a1f8483b61f9a931014352ca678f684">weight_sq</a>(var) *
<a name="l00985"></a>00985                             JxW[qp] * hess_u_h.<a class="code" href="classTypeTensor.php#a7be64b1de5e558f2de032bde1f881220">size_sq</a>();
<a name="l00986"></a>00986                 }
<a name="l00987"></a>00987 <span class="preprocessor">#endif</span>
<a name="l00988"></a>00988 <span class="preprocessor"></span>            }
<a name="l00989"></a>00989         }
<a name="l00990"></a>00990     }
<a name="l00991"></a>00991 
<a name="l00992"></a>00992   Parallel::sum(v_norm);
<a name="l00993"></a>00993 
<a name="l00994"></a>00994   STOP_LOG (<span class="stringliteral">&quot;calculate_norm()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l00995"></a>00995 
<a name="l00996"></a>00996   <span class="keywordflow">return</span> std::sqrt(v_norm);
<a name="l00997"></a>00997 }
<a name="l00998"></a>00998 
<a name="l00999"></a>00999 
<a name="l01000"></a>01000 
<a name="l01001"></a><a class="code" href="classSystem.php#a5167448ef4851fd0743d21c454a6af13">01001</a> std::string <a class="code" href="classSystem.php#a5167448ef4851fd0743d21c454a6af13">System::get_info</a>()<span class="keyword"> const</span>
<a name="l01002"></a>01002 <span class="keyword"></span>{
<a name="l01003"></a>01003   std::ostringstream out;
<a name="l01004"></a>01004 
<a name="l01005"></a>01005   
<a name="l01006"></a>01006   <span class="keyword">const</span> std::string&amp; sys_name = this-&gt;<a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>();
<a name="l01007"></a>01007       
<a name="l01008"></a>01008   out &lt;&lt; <span class="stringliteral">&quot;   System \&quot;&quot;</span> &lt;&lt; sys_name &lt;&lt; <span class="stringliteral">&quot;\&quot;\n&quot;</span>
<a name="l01009"></a>01009       &lt;&lt; <span class="stringliteral">&quot;    Type \&quot;&quot;</span>  &lt;&lt; this-&gt;<a class="code" href="classSystem.php#a41e917b200f3fc4de01fe649be4315fa">system_type</a>() &lt;&lt; <span class="stringliteral">&quot;\&quot;\n&quot;</span>
<a name="l01010"></a>01010       &lt;&lt; <span class="stringliteral">&quot;    Variables=&quot;</span>;
<a name="l01011"></a>01011   
<a name="l01012"></a>01012   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn=0; vn&lt;this-&gt;<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>(); vn++)
<a name="l01013"></a>01013       out &lt;&lt; <span class="stringliteral">&quot;\&quot;&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classSystem.php#af3a38b172dd6322eff9f30b3f63d3b63">variable_name</a>(vn) &lt;&lt; <span class="stringliteral">&quot;\&quot; &quot;</span>;
<a name="l01014"></a>01014      
<a name="l01015"></a>01015   out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01016"></a>01016 
<a name="l01017"></a>01017   out &lt;&lt; <span class="stringliteral">&quot;    Finite Element Types=&quot;</span>;
<a name="l01018"></a>01018 <span class="preprocessor">#ifndef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l01019"></a>01019 <span class="preprocessor"></span>  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn=0; vn&lt;this-&gt;<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>(); vn++)
<a name="l01020"></a>01020     out &lt;&lt; <span class="stringliteral">&quot;\&quot;&quot;</span>
<a name="l01021"></a>01021         &lt;&lt; <a class="code" href="namespaceUtility.php#ab75b87c9fdd1f9f417fd8c68338fed2f">Utility::enum_to_string&lt;FEFamily&gt;</a>(this-&gt;<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#ae3c63266417020f38af6e5cc40efca76">variable_type</a>(vn).<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l01022"></a>01022         &lt;&lt; <span class="stringliteral">&quot;\&quot; &quot;</span>;  
<a name="l01023"></a>01023 <span class="preprocessor">#else</span>
<a name="l01024"></a>01024 <span class="preprocessor"></span>  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn=0; vn&lt;this-&gt;<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>(); vn++)
<a name="l01025"></a>01025     {
<a name="l01026"></a>01026       out &lt;&lt; <span class="stringliteral">&quot;\&quot;&quot;</span>
<a name="l01027"></a>01027           &lt;&lt; <a class="code" href="namespaceUtility.php#ab75b87c9fdd1f9f417fd8c68338fed2f">Utility::enum_to_string&lt;FEFamily&gt;</a>(this-&gt;<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#ae3c63266417020f38af6e5cc40efca76">variable_type</a>(vn).<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l01028"></a>01028           &lt;&lt; <span class="stringliteral">&quot;\&quot;, \&quot;&quot;</span>
<a name="l01029"></a>01029           &lt;&lt; <a class="code" href="namespaceUtility.php#ab75b87c9fdd1f9f417fd8c68338fed2f">Utility::enum_to_string&lt;FEFamily&gt;</a>(this-&gt;<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#ae3c63266417020f38af6e5cc40efca76">variable_type</a>(vn).<a class="code" href="classFEType.php#a7ed251e481daf9856b6624e97346d3c3">radial_family</a>)
<a name="l01030"></a>01030           &lt;&lt; <span class="stringliteral">&quot;\&quot; &quot;</span>;
<a name="l01031"></a>01031     }
<a name="l01032"></a>01032 
<a name="l01033"></a>01033   out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span> &lt;&lt; <span class="stringliteral">&quot;    Infinite Element Mapping=&quot;</span>;
<a name="l01034"></a>01034   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn=0; vn&lt;this-&gt;<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>(); vn++)
<a name="l01035"></a>01035     out &lt;&lt; <span class="stringliteral">&quot;\&quot;&quot;</span>
<a name="l01036"></a>01036         &lt;&lt; <a class="code" href="namespaceUtility.php#a4c8123de6d43525bc7d07bf445652f96">Utility::enum_to_string&lt;InfMapType&gt;</a>(this-&gt;<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#ae3c63266417020f38af6e5cc40efca76">variable_type</a>(vn).<a class="code" href="classFEType.php#a06a9a69581be9306ae474c256b9ee458">inf_map</a>)
<a name="l01037"></a>01037         &lt;&lt; <span class="stringliteral">&quot;\&quot; &quot;</span>;
<a name="l01038"></a>01038 <span class="preprocessor">#endif      </span>
<a name="l01039"></a>01039 <span class="preprocessor"></span>
<a name="l01040"></a>01040   out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01041"></a>01041       
<a name="l01042"></a>01042   out &lt;&lt; <span class="stringliteral">&quot;    Approximation Orders=&quot;</span>;
<a name="l01043"></a>01043   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn=0; vn&lt;this-&gt;<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>(); vn++)
<a name="l01044"></a>01044     {
<a name="l01045"></a>01045 <span class="preprocessor">#ifndef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l01046"></a>01046 <span class="preprocessor"></span>      out &lt;&lt; <span class="stringliteral">&quot;\&quot;&quot;</span>
<a name="l01047"></a>01047           &lt;&lt; <a class="code" href="namespaceUtility.php#a55df3fbf802e78cc56adacf2af11a817">Utility::enum_to_string&lt;Order&gt;</a>(this-&gt;<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#ae3c63266417020f38af6e5cc40efca76">variable_type</a>(vn).<a class="code" href="classFEType.php#a72c29a6dbf3f2a84728111122cec4742">order</a>)
<a name="l01048"></a>01048           &lt;&lt; <span class="stringliteral">&quot;\&quot; &quot;</span>;
<a name="l01049"></a>01049 <span class="preprocessor">#else</span>
<a name="l01050"></a>01050 <span class="preprocessor"></span>      out &lt;&lt; <span class="stringliteral">&quot;\&quot;&quot;</span>
<a name="l01051"></a>01051           &lt;&lt; <a class="code" href="namespaceUtility.php#a55df3fbf802e78cc56adacf2af11a817">Utility::enum_to_string&lt;Order&gt;</a>(this-&gt;<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#ae3c63266417020f38af6e5cc40efca76">variable_type</a>(vn).<a class="code" href="classFEType.php#a72c29a6dbf3f2a84728111122cec4742">order</a>)
<a name="l01052"></a>01052           &lt;&lt; <span class="stringliteral">&quot;\&quot;, \&quot;&quot;</span>
<a name="l01053"></a>01053           &lt;&lt; <a class="code" href="namespaceUtility.php#a55df3fbf802e78cc56adacf2af11a817">Utility::enum_to_string&lt;Order&gt;</a>(this-&gt;<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#ae3c63266417020f38af6e5cc40efca76">variable_type</a>(vn).<a class="code" href="classFEType.php#ac56fd69c8a341e9df407de175e0c250a">radial_order</a>)
<a name="l01054"></a>01054           &lt;&lt; <span class="stringliteral">&quot;\&quot; &quot;</span>;
<a name="l01055"></a>01055 <span class="preprocessor">#endif</span>
<a name="l01056"></a>01056 <span class="preprocessor"></span>    }
<a name="l01057"></a>01057 
<a name="l01058"></a>01058   out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01059"></a>01059       
<a name="l01060"></a>01060   out &lt;&lt; <span class="stringliteral">&quot;    n_dofs()=&quot;</span>             &lt;&lt; this-&gt;<a class="code" href="classSystem.php#aa8f04263eed1eaf253e81041f166408b">n_dofs</a>()             &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01061"></a>01061   out &lt;&lt; <span class="stringliteral">&quot;    n_local_dofs()=&quot;</span>       &lt;&lt; this-&gt;<a class="code" href="classSystem.php#a401d38d088ef9140e51c455387af319d">n_local_dofs</a>()       &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01062"></a>01062 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01063"></a>01063 <span class="preprocessor"></span>  out &lt;&lt; <span class="stringliteral">&quot;    n_constrained_dofs()=&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classSystem.php#accee8e94a0b050017d77589f0a43fbc8">n_constrained_dofs</a>() &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01064"></a>01064 <span class="preprocessor">#endif</span>
<a name="l01065"></a>01065 <span class="preprocessor"></span>
<a name="l01066"></a>01066   out &lt;&lt; <span class="stringliteral">&quot;    &quot;</span> &lt;&lt; <span class="stringliteral">&quot;n_vectors()=&quot;</span>  &lt;&lt; this-&gt;<a class="code" href="classSystem.php#adf187b75dac8c906b0b27ce25e146305">n_vectors</a>()  &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01067"></a>01067 <span class="comment">//   out &lt;&lt; &quot;    &quot; &lt;&lt; &quot;n_additional_matrices()=&quot; &lt;&lt; this-&gt;n_additional_matrices() &lt;&lt; &#39;\n&#39;;</span>
<a name="l01068"></a>01068   
<a name="l01069"></a>01069   <span class="keywordflow">return</span> out.str();
<a name="l01070"></a>01070 }
<a name="l01071"></a>01071 
<a name="l01072"></a>01072 
<a name="l01073"></a>01073 
<a name="l01074"></a><a class="code" href="classSystem.php#a007baf013114c3b9faaf614227bd6931">01074</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a007baf013114c3b9faaf614227bd6931">System::attach_init_function</a> (<span class="keywordtype">void</span> fptr(<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l01075"></a>01075                                              <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>))
<a name="l01076"></a>01076 {
<a name="l01077"></a>01077   libmesh_assert (fptr != NULL);
<a name="l01078"></a>01078   
<a name="l01079"></a>01079   <a class="code" href="classSystem.php#ad5fcdc621c417276b264a448a129ae69">_init_system</a> = fptr;
<a name="l01080"></a>01080 }
<a name="l01081"></a>01081 
<a name="l01082"></a>01082 
<a name="l01083"></a>01083 
<a name="l01084"></a><a class="code" href="classSystem.php#a9c708aa973c88592bf6a8f23266170c4">01084</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a9c708aa973c88592bf6a8f23266170c4">System::attach_assemble_function</a> (<span class="keywordtype">void</span> fptr(<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l01085"></a>01085                                                  <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>))
<a name="l01086"></a>01086 {
<a name="l01087"></a>01087   libmesh_assert (fptr != NULL);
<a name="l01088"></a>01088   
<a name="l01089"></a>01089   <a class="code" href="classSystem.php#a07099cdef68f5638d6af2ed5be48801d">_assemble_system</a> = fptr;  
<a name="l01090"></a>01090 }
<a name="l01091"></a>01091 
<a name="l01092"></a>01092 
<a name="l01093"></a>01093 
<a name="l01094"></a><a class="code" href="classSystem.php#ade1977e5d82586714acf9a1bf5ad1892">01094</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#ade1977e5d82586714acf9a1bf5ad1892">System::attach_constraint_function</a>(<span class="keywordtype">void</span> fptr(<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l01095"></a>01095                                                   <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>))
<a name="l01096"></a>01096 {
<a name="l01097"></a>01097   libmesh_assert (fptr != NULL);
<a name="l01098"></a>01098   
<a name="l01099"></a>01099   <a class="code" href="classSystem.php#a6a6a319bb3700427fb02d071defd1569">_constrain_system</a> = fptr;  
<a name="l01100"></a>01100 }
<a name="l01101"></a>01101 
<a name="l01102"></a>01102 
<a name="l01103"></a>01103 
<a name="l01104"></a><a class="code" href="classSystem.php#afb5d578ab51691a27cc62c02bf0554f6">01104</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#afb5d578ab51691a27cc62c02bf0554f6">System::attach_QOI_function</a>(<span class="keywordtype">void</span> fptr(<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l01105"></a>01105                                            <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>))
<a name="l01106"></a>01106 {
<a name="l01107"></a>01107   libmesh_assert (fptr != NULL);
<a name="l01108"></a>01108   
<a name="l01109"></a>01109   <a class="code" href="classSystem.php#a8317d0280bf965ad4360c48d683a4c9c">_qoi_evaluate</a> = fptr;  
<a name="l01110"></a>01110 }
<a name="l01111"></a>01111 
<a name="l01112"></a>01112 
<a name="l01113"></a>01113 
<a name="l01114"></a><a class="code" href="classSystem.php#a8d15ac9586e9be99619ff58362ff034e">01114</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a8d15ac9586e9be99619ff58362ff034e">System::attach_QOI_derivative</a>(<span class="keywordtype">void</span> fptr(<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l01115"></a>01115                                              <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>))
<a name="l01116"></a>01116 {
<a name="l01117"></a>01117   libmesh_assert (fptr != NULL);
<a name="l01118"></a>01118   
<a name="l01119"></a>01119   <a class="code" href="classSystem.php#ae622d3546efa4ef0ba40af79987e03ad">_qoi_evaluate_derivative</a> = fptr;  
<a name="l01120"></a>01120 }
<a name="l01121"></a>01121 
<a name="l01122"></a>01122 
<a name="l01123"></a>01123 
<a name="l01124"></a><a class="code" href="classSystem.php#a3f5139f478cc769a89df8d09bb7aa69a">01124</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a3f5139f478cc769a89df8d09bb7aa69a">System::user_initialization</a> ()
<a name="l01125"></a>01125 {
<a name="l01126"></a>01126   <span class="comment">// Call the user-provided intialization function,</span>
<a name="l01127"></a>01127   <span class="comment">// if it was provided</span>
<a name="l01128"></a>01128   <span class="keywordflow">if</span> (<a class="code" href="classSystem.php#ad5fcdc621c417276b264a448a129ae69">_init_system</a> != NULL)
<a name="l01129"></a>01129     this-&gt;<a class="code" href="classSystem.php#ad5fcdc621c417276b264a448a129ae69">_init_system</a> (<a class="code" href="classSystem.php#ad601121641f7ae6dbd4696f8e769e863">_equation_systems</a>, this-&gt;<a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>());
<a name="l01130"></a>01130 }
<a name="l01131"></a>01131 
<a name="l01132"></a>01132 
<a name="l01133"></a><a class="code" href="classSystem.php#a036e30ca724b36d1cb3bb7671abd803b">01133</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a036e30ca724b36d1cb3bb7671abd803b">System::user_assembly</a> ()
<a name="l01134"></a>01134 {
<a name="l01135"></a>01135   <span class="comment">// Call the user-provided assembly function,</span>
<a name="l01136"></a>01136   <span class="comment">// if it was provided</span>
<a name="l01137"></a>01137   <span class="keywordflow">if</span> (<a class="code" href="classSystem.php#a07099cdef68f5638d6af2ed5be48801d">_assemble_system</a> != NULL)
<a name="l01138"></a>01138     this-&gt;<a class="code" href="classSystem.php#a07099cdef68f5638d6af2ed5be48801d">_assemble_system</a> (<a class="code" href="classSystem.php#ad601121641f7ae6dbd4696f8e769e863">_equation_systems</a>, this-&gt;<a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>());
<a name="l01139"></a>01139 }
<a name="l01140"></a>01140 
<a name="l01141"></a>01141 
<a name="l01142"></a>01142 
<a name="l01143"></a><a class="code" href="classSystem.php#a8dd9e548cdc41149155da0a92eefa591">01143</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a8dd9e548cdc41149155da0a92eefa591">System::user_constrain</a> ()
<a name="l01144"></a>01144 {
<a name="l01145"></a>01145   <span class="comment">// Call the user-provided constraint function, </span>
<a name="l01146"></a>01146   <span class="comment">// if it was provided</span>
<a name="l01147"></a>01147   <span class="keywordflow">if</span>(<a class="code" href="classSystem.php#a6a6a319bb3700427fb02d071defd1569">_constrain_system</a>!= NULL)
<a name="l01148"></a>01148     this-&gt;<a class="code" href="classSystem.php#a6a6a319bb3700427fb02d071defd1569">_constrain_system</a>(<a class="code" href="classSystem.php#ad601121641f7ae6dbd4696f8e769e863">_equation_systems</a>, this-&gt;<a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>());
<a name="l01149"></a>01149 }
<a name="l01150"></a>01150 
<a name="l01151"></a>01151 
<a name="l01152"></a>01152 
<a name="l01153"></a><a class="code" href="classSystem.php#a35700e9b9e3ab677b9b68545f8475c31">01153</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a35700e9b9e3ab677b9b68545f8475c31">System::user_QOI</a> ()
<a name="l01154"></a>01154 {
<a name="l01155"></a>01155   <span class="comment">// Call the user-provided quantity of interest function, </span>
<a name="l01156"></a>01156   <span class="comment">// if it was provided</span>
<a name="l01157"></a>01157   <span class="keywordflow">if</span>(<a class="code" href="classSystem.php#a8317d0280bf965ad4360c48d683a4c9c">_qoi_evaluate</a> != NULL)
<a name="l01158"></a>01158     this-&gt;<a class="code" href="classSystem.php#a8317d0280bf965ad4360c48d683a4c9c">_qoi_evaluate</a>(<a class="code" href="classSystem.php#ad601121641f7ae6dbd4696f8e769e863">_equation_systems</a>, this-&gt;<a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>());
<a name="l01159"></a>01159 }
<a name="l01160"></a>01160 
<a name="l01161"></a>01161 
<a name="l01162"></a>01162 
<a name="l01163"></a><a class="code" href="classSystem.php#a47d7cfeebdc12f6a0f2b8465cebc7c11">01163</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a47d7cfeebdc12f6a0f2b8465cebc7c11">System::user_QOI_derivative</a> ()
<a name="l01164"></a>01164 {
<a name="l01165"></a>01165   <span class="comment">// Call the user-provided quantity of interest derivative, </span>
<a name="l01166"></a>01166   <span class="comment">// if it was provided</span>
<a name="l01167"></a>01167   <span class="keywordflow">if</span>(<a class="code" href="classSystem.php#ae622d3546efa4ef0ba40af79987e03ad">_qoi_evaluate_derivative</a> != NULL)
<a name="l01168"></a>01168     this-&gt;<a class="code" href="classSystem.php#ae622d3546efa4ef0ba40af79987e03ad">_qoi_evaluate_derivative</a>(<a class="code" href="classSystem.php#ad601121641f7ae6dbd4696f8e769e863">_equation_systems</a>, this-&gt;<a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>());
<a name="l01169"></a>01169 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
