<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>system.h</h1>  </div>
</div>
<div class="contents">
<a href="system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: system.h 3453 2009-09-03 16:58:44Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __system_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __system_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;auto_ptr.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;enum_xdr_mode.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;fe_type.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;reference_counted_object.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="system__norm_8h.php">system_norm.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;elem_range.h&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// Forward Declarations</span>
<a name="l00039"></a>00039 <span class="keyword">class </span><a class="code" href="classSystem.php">System</a>;
<a name="l00040"></a>00040 <span class="keyword">class </span><a class="code" href="classEquationSystems.php">EquationSystems</a>;
<a name="l00041"></a>00041 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00042"></a>00042 <span class="keyword">class </span><a class="code" href="classXdr.php">Xdr</a>;
<a name="l00043"></a>00043 <span class="keyword">class </span><a class="code" href="classDofMap.php">DofMap</a>;
<a name="l00044"></a>00044 <span class="keyword">class </span><a class="code" href="classParameters.php">Parameters</a>;
<a name="l00045"></a>00045 <span class="keyword">class </span><a class="code" href="classPoint.php">Point</a>;
<a name="l00046"></a>00046 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classNumericVector.php">NumericVector</a>;
<a name="l00047"></a><a class="code" href="system_8h.php#a08d743aadc7b1860846e8aa6dfa7ae41">00047</a> <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classVectorValue.php">VectorValue</a>;
<a name="l00048"></a>00048 <span class="keyword">typedef</span> <a class="code" href="classVectorValue.php">VectorValue&lt;Number&gt;</a> <a class="code" href="exact__error__estimator_8h.php#a08d743aadc7b1860846e8aa6dfa7ae41">NumberVectorValue</a>;
<a name="l00049"></a><a class="code" href="system_8h.php#aff779e61aca326de0c3649ec86a15866">00049</a> <span class="keyword">typedef</span> <a class="code" href="classVectorValue.php">NumberVectorValue</a> <a class="code" href="exact__error__estimator_8h.php#aff779e61aca326de0c3649ec86a15866">Gradient</a>;
<a name="l00050"></a>00050 
<a name="l00063"></a>00063 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00064"></a>00064 <span class="comment">// System class definition</span>
<a name="l00065"></a><a class="code" href="classSystem.php">00065</a> <span class="keyword">class </span><a class="code" href="classSystem.php">System</a> : <span class="keyword">public</span> <a class="code" href="classReferenceCountedObject.php">ReferenceCountedObject</a>&lt;System&gt;
<a name="l00066"></a>00066 {
<a name="l00067"></a>00067 <span class="keyword">protected</span>:
<a name="l00068"></a>00068 
<a name="l00074"></a>00074   <a class="code" href="classSystem.php#af944a5bb4e6a5d3979898b77d63b542b">System</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00075"></a>00075           <span class="keyword">const</span> std::string&amp; <a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>,
<a name="l00076"></a>00076           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">number</a>);
<a name="l00077"></a>00077   
<a name="l00078"></a>00078 <span class="keyword">public</span>:
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   
<a name="l00084"></a>00084   <span class="keyword">virtual</span> <a class="code" href="classSystem.php#a3be70bb338e3f062f821173fd15680d0">~System</a> ();
<a name="l00085"></a>00085 
<a name="l00089"></a><a class="code" href="classSystem.php#aa3d0e2bb663a810fee8445ad7609bc17">00089</a>   <span class="keyword">typedef</span> <a class="code" href="classSystem.php">System</a> <a class="code" href="classSystem.php#aa3d0e2bb663a810fee8445ad7609bc17">sys_type</a>;
<a name="l00090"></a>00090 
<a name="l00094"></a><a class="code" href="classSystem.php#a75efe32ae4d57a5e39df2ec24d95598e">00094</a>   <a class="code" href="classSystem.php">sys_type</a> &amp; <a class="code" href="classSystem.php#a75efe32ae4d57a5e39df2ec24d95598e">system</a> () { <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00095"></a>00095   
<a name="l00100"></a>00100   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a66bdd137db3fc914bbfe9518b6c71017">clear</a> ();
<a name="l00101"></a>00101   
<a name="l00106"></a>00106   <span class="keywordtype">void</span> <a class="code" href="classSystem.php#ae5928a3751d52745b76feca40666c31f">init</a> ();
<a name="l00107"></a>00107   
<a name="l00114"></a>00114   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a60f6078e475e01e19aad618766f2cd7b">reinit</a> ();
<a name="l00115"></a>00115   
<a name="l00120"></a>00120   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#add4b09ec4fb0679b8623c01218cafa5b">update</a> ();
<a name="l00121"></a>00121   
<a name="l00128"></a>00128   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#abca899f8ae44d10c606fe28b5e8420dd">assemble</a> ();
<a name="l00129"></a>00129 
<a name="l00134"></a>00134   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a80a51f5a333e470498740358fac6f959">assemble_qoi</a> ();
<a name="l00135"></a>00135  
<a name="l00140"></a>00140   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a70a20011f2bf9131e08fdcac9834e81f">assemble_qoi_derivative</a> ();
<a name="l00141"></a>00141  
<a name="l00145"></a>00145   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#adf41acbca1705cb6d5ba7ca410b3d2f5">solve</a> () = 0;
<a name="l00146"></a>00146   
<a name="l00150"></a>00150   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#af8a033911a3c5403f68baf10320ef7f1">adjoint_solve</a> () = 0;
<a name="l00151"></a>00151   
<a name="l00158"></a>00158   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a6796b70c6639bec0dff2d372ec8fcf92">qoi_parameter_sensitivity</a> (std::vector&lt;Number *&gt;&amp; parameters, 
<a name="l00159"></a>00159                                           std::vector&lt;Number&gt;&amp; sensitivities) = 0;
<a name="l00160"></a>00160   
<a name="l00166"></a>00166   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classSystem.php#aaf10bae4e91cb13989a0824283c1865e">compare</a> (<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; other_system, 
<a name="l00167"></a>00167                         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> threshold,
<a name="l00168"></a>00168                         <span class="keyword">const</span> <span class="keywordtype">bool</span> verbose) <span class="keyword">const</span>;
<a name="l00169"></a>00169 
<a name="l00173"></a>00173   <span class="keyword">const</span> std::string &amp; <a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a> () <span class="keyword">const</span>;
<a name="l00174"></a>00174 
<a name="l00180"></a><a class="code" href="classSystem.php#a41e917b200f3fc4de01fe649be4315fa">00180</a>   <span class="keyword">virtual</span> std::string <a class="code" href="classSystem.php#a41e917b200f3fc4de01fe649be4315fa">system_type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="stringliteral">&quot;BasicSystem&quot;</span>; }
<a name="l00181"></a>00181 
<a name="l00185"></a>00185   <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a810f69e3181a891a0284cd33ebee1eff">project_solution</a> (<a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> fptr(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00186"></a>00186                                      <span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; parameters,
<a name="l00187"></a>00187                                      <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00188"></a>00188                                      <span class="keyword">const</span> std::string&amp; unknown_name),
<a name="l00189"></a>00189                          <a class="code" href="classVectorValue.php">Gradient</a> gptr(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00190"></a>00190                                        <span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; parameters,
<a name="l00191"></a>00191                                        <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00192"></a>00192                                        <span class="keyword">const</span> std::string&amp; unknown_name),
<a name="l00193"></a>00193                          <a class="code" href="classParameters.php">Parameters</a>&amp; parameters) <span class="keyword">const</span>;
<a name="l00194"></a>00194 
<a name="l00198"></a>00198   <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a7a43c17f7d8fd02835faba1d39204cef">project_vector</a> (<a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> fptr(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00199"></a>00199                                    <span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; parameters,
<a name="l00200"></a>00200                                    <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00201"></a>00201                                    <span class="keyword">const</span> std::string&amp; unknown_name),
<a name="l00202"></a>00202                        <a class="code" href="classVectorValue.php">Gradient</a> gptr(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00203"></a>00203                                      <span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; parameters,
<a name="l00204"></a>00204                                      <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00205"></a>00205                                      <span class="keyword">const</span> std::string&amp; unknown_name),
<a name="l00206"></a>00206                        <a class="code" href="classParameters.php">Parameters</a>&amp; parameters,
<a name="l00207"></a>00207                        <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp; new_vector) <span class="keyword">const</span>;
<a name="l00208"></a>00208   
<a name="l00212"></a>00212   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">number</a> () <span class="keyword">const</span>;
<a name="l00213"></a>00213   
<a name="l00219"></a>00219   <span class="keywordtype">void</span> <a class="code" href="classSystem.php#afb0ea08442d8a71cf040f598f767a396">update_global_solution</a> (std::vector&lt;Number&gt;&amp; global_soln) <span class="keyword">const</span>;
<a name="l00220"></a>00220 
<a name="l00226"></a>00226   <span class="keywordtype">void</span> <a class="code" href="classSystem.php#afb0ea08442d8a71cf040f598f767a396">update_global_solution</a> (std::vector&lt;Number&gt;&amp; global_soln,
<a name="l00227"></a>00227                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_proc) <span class="keyword">const</span>;
<a name="l00228"></a>00228 
<a name="l00232"></a>00232   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp; <a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">get_mesh</a>() <span class="keyword">const</span>;
<a name="l00233"></a>00233   
<a name="l00237"></a>00237   <a class="code" href="classMeshBase.php">MeshBase</a> &amp; <a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">get_mesh</a>();
<a name="l00238"></a>00238   
<a name="l00242"></a>00242   <span class="keyword">const</span> <a class="code" href="classDofMap.php">DofMap</a> &amp; <a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>() <span class="keyword">const</span>;
<a name="l00243"></a>00243   
<a name="l00247"></a>00247   <a class="code" href="classDofMap.php">DofMap</a> &amp; <a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>();
<a name="l00248"></a>00248 
<a name="l00252"></a><a class="code" href="classSystem.php#a51da3ea6211cf1888377c9c4b1554232">00252</a>   <span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a> &amp; <a class="code" href="classSystem.php#a51da3ea6211cf1888377c9c4b1554232">get_equation_systems</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classSystem.php#ad601121641f7ae6dbd4696f8e769e863">_equation_systems</a>; }
<a name="l00253"></a>00253 
<a name="l00257"></a><a class="code" href="classSystem.php#ab43ce486152e8cfb3af16cf8ccdba862">00257</a>   <a class="code" href="classEquationSystems.php">EquationSystems</a> &amp; <a class="code" href="classSystem.php#ab43ce486152e8cfb3af16cf8ccdba862">get_equation_systems</a>() { <span class="keywordflow">return</span> <a class="code" href="classSystem.php#ad601121641f7ae6dbd4696f8e769e863">_equation_systems</a>; }
<a name="l00258"></a>00258 
<a name="l00263"></a>00263   <span class="keywordtype">bool</span> <a class="code" href="classSystem.php#a3fa00ded548bb0392922b9ee37297644">active</a> () <span class="keyword">const</span>;
<a name="l00264"></a>00264 
<a name="l00268"></a>00268   <span class="keywordtype">void</span> <a class="code" href="classSystem.php#aadc59f505a4efd40db91c0866163718a">activate</a> ();
<a name="l00269"></a>00269 
<a name="l00273"></a>00273   <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a7e3d6cb0c259e4543bdb85acf687d411">deactivate</a> ();
<a name="l00274"></a>00274 
<a name="l00278"></a><a class="code" href="classSystem.php#ac1939aeca6473017c8b6a560892e86aa">00278</a>   <span class="keyword">typedef</span> std::map&lt;std::string, NumericVector&lt;Number&gt;* &gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a>       <a class="code" href="classSystem.php#ac1939aeca6473017c8b6a560892e86aa">vectors_iterator</a>;
<a name="l00279"></a><a class="code" href="classSystem.php#a85440d8ff0086de5be93ae0922937d0c">00279</a>   <span class="keyword">typedef</span> std::map&lt;std::string, NumericVector&lt;Number&gt;* &gt;::const_iterator <a class="code" href="classSystem.php#a85440d8ff0086de5be93ae0922937d0c">const_vectors_iterator</a>;
<a name="l00280"></a>00280 
<a name="l00284"></a>00284   <a class="code" href="classSystem.php#ac1939aeca6473017c8b6a560892e86aa">vectors_iterator</a> <a class="code" href="classSystem.php#aa33cb0639b60f352561646fcce51a06b">vectors_begin</a> ();
<a name="l00285"></a>00285 
<a name="l00289"></a>00289   <a class="code" href="classSystem.php#a85440d8ff0086de5be93ae0922937d0c">const_vectors_iterator</a> <a class="code" href="classSystem.php#aa33cb0639b60f352561646fcce51a06b">vectors_begin</a> () <span class="keyword">const</span>;
<a name="l00290"></a>00290 
<a name="l00294"></a>00294   <a class="code" href="classSystem.php#ac1939aeca6473017c8b6a560892e86aa">vectors_iterator</a> <a class="code" href="classSystem.php#a0c1c70cc7f560cda430474eea1702082">vectors_end</a> ();
<a name="l00295"></a>00295 
<a name="l00299"></a>00299   <a class="code" href="classSystem.php#a85440d8ff0086de5be93ae0922937d0c">const_vectors_iterator</a> <a class="code" href="classSystem.php#a0c1c70cc7f560cda430474eea1702082">vectors_end</a> () <span class="keyword">const</span>;
<a name="l00300"></a>00300 
<a name="l00311"></a>00311   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classSystem.php#abab8a3810cc43d99fe395d449207b786">add_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name,
<a name="l00312"></a>00312                                       <span class="keyword">const</span> <span class="keywordtype">bool</span> projections=<span class="keyword">true</span>);
<a name="l00313"></a>00313 
<a name="l00319"></a><a class="code" href="classSystem.php#a7ddea7f6e4a6530a18fcd0932e8bb7b8">00319</a>   <span class="keywordtype">bool</span>&amp; <a class="code" href="classSystem.php#a7ddea7f6e4a6530a18fcd0932e8bb7b8">project_solution_on_reinit</a> (<span class="keywordtype">void</span>)
<a name="l00320"></a>00320     { <span class="keywordflow">return</span> <a class="code" href="classSystem.php#a5c4dc93cbba1fc013ce6023029f30909">_solution_projection</a>; }
<a name="l00321"></a>00321   
<a name="l00326"></a>00326   <span class="keywordtype">bool</span> <a class="code" href="classSystem.php#a4fb11ff7ba967513144ba6fb1e4d85e6">have_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name) <span class="keyword">const</span>;
<a name="l00327"></a>00327   
<a name="l00333"></a>00333   <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name) <span class="keyword">const</span>;
<a name="l00334"></a>00334 
<a name="l00340"></a>00340   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name);
<a name="l00341"></a>00341 
<a name="l00347"></a>00347   <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vec_num) <span class="keyword">const</span>;
<a name="l00348"></a>00348 
<a name="l00354"></a>00354   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vec_num);
<a name="l00355"></a>00355 
<a name="l00360"></a>00360   <span class="keyword">const</span> std::string &amp; <a class="code" href="classSystem.php#a79fe01b54b0441fd670b3b092da1e7bd">vector_name</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vec_num);
<a name="l00361"></a>00361 
<a name="l00366"></a>00366   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classSystem.php#ad86b44047ff7beb018105be1b20cab82">get_adjoint_solution</a>();
<a name="l00367"></a>00367 
<a name="l00372"></a>00372   <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classSystem.php#ad86b44047ff7beb018105be1b20cab82">get_adjoint_solution</a>() <span class="keyword">const</span>;
<a name="l00373"></a>00373 
<a name="l00379"></a>00379   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#adf187b75dac8c906b0b27ce25e146305">n_vectors</a> () <span class="keyword">const</span>;
<a name="l00380"></a>00380 
<a name="l00384"></a>00384   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>() <span class="keyword">const</span>;
<a name="l00385"></a>00385 
<a name="l00389"></a>00389   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#aa8f04263eed1eaf253e81041f166408b">n_dofs</a>() <span class="keyword">const</span>;
<a name="l00390"></a>00390 
<a name="l00395"></a>00395   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#a936fb82a3c815116a42ef9e26bc56481">n_active_dofs</a>() <span class="keyword">const</span>;
<a name="l00396"></a>00396 
<a name="l00401"></a>00401   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#accee8e94a0b050017d77589f0a43fbc8">n_constrained_dofs</a>() <span class="keyword">const</span>;
<a name="l00402"></a>00402   
<a name="l00407"></a>00407   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#a401d38d088ef9140e51c455387af319d">n_local_dofs</a>() <span class="keyword">const</span>;
<a name="l00408"></a>00408 
<a name="l00417"></a><a class="code" href="classSystem_1_1Variable.php">00417</a>   <span class="keyword">class </span><a class="code" href="classSystem_1_1Variable.php">Variable</a>
<a name="l00418"></a>00418   {
<a name="l00419"></a>00419   <span class="keyword">public</span>:
<a name="l00420"></a>00420     
<a name="l00426"></a><a class="code" href="classSystem_1_1Variable.php#a09b65a0cd2af19efc6d7b408e2ba01af">00426</a>     <a class="code" href="classSystem_1_1Variable.php#a09b65a0cd2af19efc6d7b408e2ba01af">Variable</a> (<span class="keyword">const</span> std::string &amp;var_name,
<a name="l00427"></a>00427               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var_number,
<a name="l00428"></a>00428               <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a> &amp;var_type) :
<a name="l00429"></a>00429       <a class="code" href="classSystem_1_1Variable.php#a9dac7594ab026b852a63189bebc454d6">_name</a>(var_name),
<a name="l00430"></a>00430       <a class="code" href="classSystem_1_1Variable.php#a32f7a6d2deed00659b0fd3248b25fd73">_number</a>(var_number),
<a name="l00431"></a>00431       <a class="code" href="classSystem_1_1Variable.php#a5769fedbedc470897240f6507327bdbf">_type</a>(var_type)
<a name="l00432"></a>00432     {}
<a name="l00433"></a>00433     
<a name="l00438"></a><a class="code" href="classSystem_1_1Variable.php#ac2bd021375ca56abf4f96dbeee796a6d">00438</a>     <a class="code" href="classSystem_1_1Variable.php#a09b65a0cd2af19efc6d7b408e2ba01af">Variable</a> (<span class="keyword">const</span> std::string &amp;var_name,
<a name="l00439"></a>00439               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var_number,
<a name="l00440"></a>00440               <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a> &amp;var_type,
<a name="l00441"></a>00441               <span class="keyword">const</span> std::set&lt;subdomain_id_type&gt; &amp;var_active_subdomains) :
<a name="l00442"></a>00442       <a class="code" href="classSystem_1_1Variable.php#a9dac7594ab026b852a63189bebc454d6">_name</a>(var_name),
<a name="l00443"></a>00443       <a class="code" href="classSystem_1_1Variable.php#a32f7a6d2deed00659b0fd3248b25fd73">_number</a>(var_number),
<a name="l00444"></a>00444       <a class="code" href="classSystem_1_1Variable.php#a5769fedbedc470897240f6507327bdbf">_type</a>(var_type),
<a name="l00445"></a>00445       <a class="code" href="classSystem_1_1Variable.php#aa35dcf28b2440e5c83ac85273fe8bb84">_active_subdomains</a>(var_active_subdomains)
<a name="l00446"></a>00446     {}
<a name="l00447"></a>00447     
<a name="l00451"></a><a class="code" href="classSystem_1_1Variable.php#a506e89d8415e6821f6592b6fc95019c4">00451</a>     <span class="keyword">const</span> std::string &amp; <a class="code" href="classSystem_1_1Variable.php#a506e89d8415e6821f6592b6fc95019c4">name</a>()<span class="keyword"> const </span>
<a name="l00452"></a>00452 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classSystem_1_1Variable.php#a9dac7594ab026b852a63189bebc454d6">_name</a>; }
<a name="l00453"></a>00453 
<a name="l00457"></a><a class="code" href="classSystem_1_1Variable.php#a4f68d90bb1421bee95ee8241615b9d0d">00457</a>     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem_1_1Variable.php#a4f68d90bb1421bee95ee8241615b9d0d">number</a>()<span class="keyword"> const </span>
<a name="l00458"></a>00458 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classSystem_1_1Variable.php#a32f7a6d2deed00659b0fd3248b25fd73">_number</a>; }
<a name="l00459"></a>00459 
<a name="l00463"></a><a class="code" href="classSystem_1_1Variable.php#abcdad7a16d98f5884d82583452eccb80">00463</a>     <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a> &amp; <a class="code" href="classSystem_1_1Variable.php#abcdad7a16d98f5884d82583452eccb80">type</a>()<span class="keyword"> const </span>
<a name="l00464"></a>00464 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classSystem_1_1Variable.php#a5769fedbedc470897240f6507327bdbf">_type</a>; }
<a name="l00465"></a>00465 
<a name="l00472"></a><a class="code" href="classSystem_1_1Variable.php#ad6639756dcb5050d014cddb818d13df9">00472</a>     <span class="keywordtype">bool</span> <a class="code" href="classSystem_1_1Variable.php#ad6639756dcb5050d014cddb818d13df9">active_on_subdomain</a> (<span class="keyword">const</span> <a class="code" href="classTestClass.php">subdomain_id_type</a> sid)<span class="keyword"> const</span>
<a name="l00473"></a>00473 <span class="keyword">    </span>{ <span class="keywordflow">return</span> (<a class="code" href="classSystem_1_1Variable.php#aa35dcf28b2440e5c83ac85273fe8bb84">_active_subdomains</a>.empty() || <a class="code" href="classSystem_1_1Variable.php#aa35dcf28b2440e5c83ac85273fe8bb84">_active_subdomains</a>.count(sid));  }
<a name="l00474"></a>00474 
<a name="l00480"></a><a class="code" href="classSystem_1_1Variable.php#a37a8efab345c850b3fa2b4f9ec544f8e">00480</a>     <span class="keywordtype">bool</span> <a class="code" href="classSystem_1_1Variable.php#a37a8efab345c850b3fa2b4f9ec544f8e">implicitly_active</a> ()<span class="keyword"> const</span>
<a name="l00481"></a>00481 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classSystem_1_1Variable.php#aa35dcf28b2440e5c83ac85273fe8bb84">_active_subdomains</a>.empty(); }
<a name="l00482"></a>00482     
<a name="l00483"></a>00483   <span class="keyword">private</span>:
<a name="l00484"></a><a class="code" href="classSystem_1_1Variable.php#a9dac7594ab026b852a63189bebc454d6">00484</a>     std::string             <a class="code" href="classSystem_1_1Variable.php#a9dac7594ab026b852a63189bebc454d6">_name</a>; 
<a name="l00485"></a><a class="code" href="classSystem_1_1Variable.php#a32f7a6d2deed00659b0fd3248b25fd73">00485</a>     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>            <a class="code" href="classSystem_1_1Variable.php#a32f7a6d2deed00659b0fd3248b25fd73">_number</a>;
<a name="l00486"></a><a class="code" href="classSystem_1_1Variable.php#a5769fedbedc470897240f6507327bdbf">00486</a>     <a class="code" href="classFEType.php">FEType</a>                  <a class="code" href="classSystem_1_1Variable.php#a5769fedbedc470897240f6507327bdbf">_type</a>;
<a name="l00487"></a><a class="code" href="classSystem_1_1Variable.php#aa35dcf28b2440e5c83ac85273fe8bb84">00487</a>     std::set&lt;subdomain_id_type&gt; <a class="code" href="classSystem_1_1Variable.php#aa35dcf28b2440e5c83ac85273fe8bb84">_active_subdomains</a>;
<a name="l00488"></a>00488   };
<a name="l00489"></a>00489 
<a name="l00494"></a>00494   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#ae3d0a3c8fe03ce302d6b80fee6d0bd9f">add_variable</a> (<span class="keyword">const</span> std::string&amp; var,
<a name="l00495"></a>00495                              <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; type,
<a name="l00496"></a>00496                              <span class="keyword">const</span> std::set&lt;subdomain_id_type&gt; * <span class="keyword">const</span> active_subdomains = NULL);
<a name="l00497"></a>00497 
<a name="l00503"></a>00503   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#ae3d0a3c8fe03ce302d6b80fee6d0bd9f">add_variable</a> (<span class="keyword">const</span> std::string&amp; var,
<a name="l00504"></a>00504                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order = <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>,
<a name="l00505"></a>00505                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5">FEFamily</a> = <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>,
<a name="l00506"></a>00506                              <span class="keyword">const</span> std::set&lt;subdomain_id_type&gt; * <span class="keyword">const</span> active_subdomains = NULL);
<a name="l00507"></a>00507 
<a name="l00511"></a>00511   <span class="keyword">const</span> <a class="code" href="classSystem_1_1Variable.php">Variable</a> &amp; <a class="code" href="classSystem.php#a8b1d32d0a3a3848906c07107a7f03762">variable</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var) <span class="keyword">const</span>;
<a name="l00512"></a>00512 
<a name="l00516"></a>00516   <span class="keywordtype">bool</span> <a class="code" href="classSystem.php#ae4dc616e6d65b6476fb57a643035f59f">has_variable</a>(<span class="keyword">const</span> std::string&amp; var) <span class="keyword">const</span>;
<a name="l00517"></a>00517   
<a name="l00521"></a>00521   <span class="keyword">const</span> std::string &amp; <a class="code" href="classSystem.php#af3a38b172dd6322eff9f30b3f63d3b63">variable_name</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00522"></a>00522   
<a name="l00527"></a>00527   <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#ace6000ea1d0dc7e3635fe98761f95838">variable_number</a> (<span class="keyword">const</span> std::string&amp; var) <span class="keyword">const</span>;
<a name="l00528"></a>00528 
<a name="l00532"></a>00532   <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a> &amp; <a class="code" href="classSystem.php#aa917dd59a348a46e9adab63d9767460f">variable_type</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00533"></a>00533 
<a name="l00537"></a>00537   <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a> &amp; <a class="code" href="classSystem.php#aa917dd59a348a46e9adab63d9767460f">variable_type</a> (<span class="keyword">const</span> std::string&amp; var) <span class="keyword">const</span>;
<a name="l00538"></a>00538 
<a name="l00543"></a>00543   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classSystem.php#a9b8d41c541d5fba295a6e9989939b443">calculate_norm</a>(<a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp; v,
<a name="l00544"></a>00544                       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = 0,
<a name="l00545"></a>00545                       <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a> norm_type = <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a>) <span class="keyword">const</span>;
<a name="l00546"></a>00546 
<a name="l00551"></a>00551   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classSystem.php#a9b8d41c541d5fba295a6e9989939b443">calculate_norm</a>(<a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp; v,
<a name="l00552"></a>00552                       <span class="keyword">const</span> <a class="code" href="classSystemNorm.php">SystemNorm</a> &amp;norm) <span class="keyword">const</span>;
<a name="l00553"></a>00553 
<a name="l00557"></a>00557   <span class="keywordtype">void</span> <a class="code" href="classSystem.php#ae3c36c4b219562aa809afe928fa68bae">read_header</a> (<a class="code" href="classXdr.php">Xdr</a>&amp; io,
<a name="l00558"></a>00558                     <span class="keyword">const</span> std::string &amp;version,
<a name="l00559"></a>00559                     <span class="keyword">const</span> <span class="keywordtype">bool</span> <a class="code" href="classSystem.php#ae3c36c4b219562aa809afe928fa68bae">read_header</a>=<span class="keyword">true</span>,
<a name="l00560"></a>00560                     <span class="keyword">const</span> <span class="keywordtype">bool</span> read_additional_data=<span class="keyword">true</span>,
<a name="l00561"></a>00561                     <span class="keyword">const</span> <span class="keywordtype">bool</span> read_legacy_format=<span class="keyword">false</span>);
<a name="l00562"></a>00562 
<a name="l00566"></a>00566   <span class="keywordtype">void</span> <a class="code" href="classSystem.php#af5ebd2a5c449acd1d3c1f62a5ba0dc7d">read_legacy_data</a> (<a class="code" href="classXdr.php">Xdr</a>&amp; io,
<a name="l00567"></a>00567                          <span class="keyword">const</span> <span class="keywordtype">bool</span> read_additional_data=<span class="keyword">true</span>);
<a name="l00568"></a>00568 
<a name="l00573"></a>00573   <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a27743d4009b8a4fde7729399b6856632">read_serialized_data</a> (<a class="code" href="classXdr.php">Xdr</a>&amp; io,
<a name="l00574"></a>00574                              <span class="keyword">const</span> <span class="keywordtype">bool</span> read_additional_data=<span class="keyword">true</span>);
<a name="l00575"></a>00575 
<a name="l00582"></a>00582   <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a1c36902a17bfdf78f63815f19fcbb380">read_parallel_data</a> (<a class="code" href="classXdr.php">Xdr</a> &amp;io,
<a name="l00583"></a>00583                            <span class="keyword">const</span> <span class="keywordtype">bool</span> read_additional_data);
<a name="l00587"></a>00587   <span class="keywordtype">void</span> <a class="code" href="classSystem.php#af142d1f5815ae5c1f0293432b8abe3e7">write_header</a> (<a class="code" href="classXdr.php">Xdr</a>&amp; io,
<a name="l00588"></a>00588                      <span class="keyword">const</span> std::string &amp;version,
<a name="l00589"></a>00589                      <span class="keyword">const</span> <span class="keywordtype">bool</span> write_additional_data) <span class="keyword">const</span>;
<a name="l00590"></a>00590 
<a name="l00595"></a>00595   <span class="keywordtype">void</span> <a class="code" href="classSystem.php#acd3a72f865c45fd819222fe400c81f56">write_serialized_data</a> (<a class="code" href="classXdr.php">Xdr</a>&amp; io,
<a name="l00596"></a>00596                               <span class="keyword">const</span> <span class="keywordtype">bool</span> write_additional_data = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00597"></a>00597 
<a name="l00604"></a>00604   <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a014c5eb66377576d5718868fd10c940e">write_parallel_data</a> (<a class="code" href="classXdr.php">Xdr</a> &amp;io,
<a name="l00605"></a>00605                             <span class="keyword">const</span> <span class="keywordtype">bool</span> write_additional_data) <span class="keyword">const</span>;
<a name="l00606"></a>00606   
<a name="l00611"></a>00611   std::string <a class="code" href="classSystem.php#a5167448ef4851fd0743d21c454a6af13">get_info</a> () <span class="keyword">const</span>;
<a name="l00612"></a>00612 
<a name="l00616"></a>00616   <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a007baf013114c3b9faaf614227bd6931">attach_init_function</a> (<span class="keywordtype">void</span> fptr(<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00617"></a>00617                                        <span class="keyword">const</span> std::string&amp; name));
<a name="l00618"></a>00618   
<a name="l00623"></a>00623   <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a9c708aa973c88592bf6a8f23266170c4">attach_assemble_function</a> (<span class="keywordtype">void</span> fptr(<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00624"></a>00624                                            <span class="keyword">const</span> std::string&amp; name));
<a name="l00625"></a>00625   
<a name="l00629"></a>00629   <span class="keywordtype">void</span> <a class="code" href="classSystem.php#ade1977e5d82586714acf9a1bf5ad1892">attach_constraint_function</a> (<span class="keywordtype">void</span> fptr(<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00630"></a>00630                                              <span class="keyword">const</span> std::string&amp; name));
<a name="l00631"></a>00631   
<a name="l00636"></a>00636   <span class="keywordtype">void</span> <a class="code" href="classSystem.php#afb5d578ab51691a27cc62c02bf0554f6">attach_QOI_function</a> (<span class="keywordtype">void</span> fptr(<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00637"></a>00637                                       <span class="keyword">const</span> std::string&amp; name));
<a name="l00638"></a>00638   
<a name="l00644"></a>00644   <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a8d15ac9586e9be99619ff58362ff034e">attach_QOI_derivative</a> (<span class="keywordtype">void</span> fptr(<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00645"></a>00645                                         <span class="keyword">const</span> std::string&amp; name));
<a name="l00646"></a>00646   
<a name="l00651"></a>00651   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a3f5139f478cc769a89df8d09bb7aa69a">user_initialization</a> ();
<a name="l00652"></a>00652   
<a name="l00657"></a>00657   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a036e30ca724b36d1cb3bb7671abd803b">user_assembly</a> ();
<a name="l00658"></a>00658   
<a name="l00663"></a>00663   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a8dd9e548cdc41149155da0a92eefa591">user_constrain</a> ();
<a name="l00664"></a>00664 
<a name="l00669"></a>00669   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a35700e9b9e3ab677b9b68545f8475c31">user_QOI</a> ();
<a name="l00670"></a>00670 
<a name="l00675"></a>00675   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a47d7cfeebdc12f6a0f2b8465cebc7c11">user_QOI_derivative</a> ();
<a name="l00676"></a>00676 
<a name="l00682"></a>00682   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a7bb92857324a079524ac526279edf20c">re_update</a> ();
<a name="l00683"></a>00683 
<a name="l00687"></a>00687   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#af92311614385b58e619b19c958acf6c9">restrict_vectors</a> ();
<a name="l00688"></a>00688 
<a name="l00692"></a>00692   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a557fe073d299e4382e5058644ebf452e">prolong_vectors</a> ();
<a name="l00693"></a>00693 
<a name="l00713"></a><a class="code" href="classSystem.php#ac1684646af433b1cdeb4c97ca1f31216">00713</a>   <span class="keywordtype">bool</span> <a class="code" href="classSystem.php#ac1684646af433b1cdeb4c97ca1f31216">assemble_before_solve</a>;
<a name="l00714"></a>00714 
<a name="l00715"></a>00715 
<a name="l00716"></a>00716   <span class="comment">//--------------------------------------------------</span>
<a name="l00717"></a>00717   <span class="comment">// The solution and solution access members</span>
<a name="l00718"></a>00718   
<a name="l00723"></a>00723   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_dof_number) <span class="keyword">const</span>;
<a name="l00724"></a>00724 
<a name="l00728"></a><a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">00728</a>   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; <a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>;
<a name="l00729"></a>00729 
<a name="l00740"></a><a class="code" href="classSystem.php#a47b00cd00684aebe3c095aba010626e5">00740</a>   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; <a class="code" href="classSystem.php#a47b00cd00684aebe3c095aba010626e5">current_local_solution</a>;
<a name="l00741"></a>00741 
<a name="l00745"></a><a class="code" href="classSystem.php#a49aff017c2708cbddfc91abff099f9cb">00745</a>   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classSystem.php#a49aff017c2708cbddfc91abff099f9cb">qoi</a>;
<a name="l00746"></a>00746 
<a name="l00751"></a>00751   <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a5f0763fc42313f9a8cabcc61e99885fe">local_dof_indices</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00752"></a>00752                           std::set&lt;unsigned int&gt; &amp; var_indices) <span class="keyword">const</span>;
<a name="l00753"></a>00753 
<a name="l00758"></a>00758   <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a46ba137d78257fe4a9e124f100a775f8">zero_variable</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp; v, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var_num) <span class="keyword">const</span>;
<a name="l00759"></a>00759 
<a name="l00760"></a>00760 <span class="keyword">protected</span>:
<a name="l00761"></a>00761 
<a name="l00767"></a>00767   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a1ee0d1111c06a94c271b2830dbc69421">init_data</a> ();
<a name="l00768"></a>00768 
<a name="l00773"></a>00773   <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a7a43c17f7d8fd02835faba1d39204cef">project_vector</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp;) <span class="keyword">const</span>;
<a name="l00774"></a>00774 
<a name="l00780"></a>00780   <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a7a43c17f7d8fd02835faba1d39204cef">project_vector</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp;,
<a name="l00781"></a>00781                        <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp;) <span class="keyword">const</span>;
<a name="l00782"></a>00782   
<a name="l00783"></a>00783 <span class="keyword">private</span>:
<a name="l00784"></a>00784 
<a name="l00789"></a>00789   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classSystem.php#ad44c76740f901c5e7559cd1b6f9dfd5a">discrete_var_norm</a>(<a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp; v,
<a name="l00790"></a>00790                          <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00791"></a>00791                          <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a> norm_type) <span class="keyword">const</span>;
<a name="l00792"></a>00792 
<a name="l00798"></a>00798   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> iterator_type&gt;
<a name="l00799"></a>00799   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#a43647f5609f7a6164d2f23d3ae58812a">read_serialized_blocked_dof_objects</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00800"></a>00800                                                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classReferenceCounter.php#a8cb7e9757c4c1ef049bdf1e11ca65177">n_objects</a>,
<a name="l00801"></a>00801                                                     <span class="keyword">const</span> iterator_type begin,
<a name="l00802"></a>00802                                                     <span class="keyword">const</span> iterator_type end,
<a name="l00803"></a>00803                                                     <a class="code" href="classXdr.php">Xdr</a> &amp;io,
<a name="l00804"></a>00804                                                     <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp;vec) <span class="keyword">const</span>;
<a name="l00805"></a>00805 
<a name="l00810"></a>00810   <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a892bb33549ccda694f038c6e3afac344">read_serialized_vector</a> (<a class="code" href="classXdr.php">Xdr</a>&amp; io,
<a name="l00811"></a>00811                                <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp;vec);
<a name="l00812"></a>00812 
<a name="l00817"></a>00817   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> iterator_type&gt;
<a name="l00818"></a>00818   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#a43e5be04f7cc7fd964fe39aba191d35a">write_serialized_blocked_dof_objects</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp;vec,
<a name="l00819"></a>00819                                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00820"></a>00820                                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classReferenceCounter.php#a8cb7e9757c4c1ef049bdf1e11ca65177">n_objects</a>,
<a name="l00821"></a>00821                                                      <span class="keyword">const</span> iterator_type begin,
<a name="l00822"></a>00822                                                      <span class="keyword">const</span> iterator_type end,
<a name="l00823"></a>00823                                                      <a class="code" href="classXdr.php">Xdr</a> &amp;io) <span class="keyword">const</span>;
<a name="l00824"></a>00824 
<a name="l00829"></a>00829   <span class="keywordtype">void</span> <a class="code" href="classSystem.php#aeab82c2c07a2471f8763efcf6303ab37">write_serialized_vector</a> (<a class="code" href="classXdr.php">Xdr</a>&amp; io,
<a name="l00830"></a>00830                                 <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp;vec) <span class="keyword">const</span>;
<a name="l00831"></a>00831 
<a name="l00835"></a><a class="code" href="classSystem.php#ad5fcdc621c417276b264a448a129ae69">00835</a>   void (* <a class="code" href="classSystem.php#ad5fcdc621c417276b264a448a129ae69">_init_system</a>) (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00836"></a>00836                          <span class="keyword">const</span> std::string&amp; <a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>);
<a name="l00837"></a>00837   
<a name="l00841"></a><a class="code" href="classSystem.php#a07099cdef68f5638d6af2ed5be48801d">00841</a>   void (* <a class="code" href="classSystem.php#a07099cdef68f5638d6af2ed5be48801d">_assemble_system</a>) (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00842"></a>00842                              <span class="keyword">const</span> std::string&amp; <a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>);
<a name="l00843"></a>00843 
<a name="l00847"></a><a class="code" href="classSystem.php#a6a6a319bb3700427fb02d071defd1569">00847</a>   void (* <a class="code" href="classSystem.php#a6a6a319bb3700427fb02d071defd1569">_constrain_system</a>) (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es, 
<a name="l00848"></a>00848                               <span class="keyword">const</span> std::string&amp; <a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>);
<a name="l00849"></a>00849 
<a name="l00853"></a><a class="code" href="classSystem.php#a8317d0280bf965ad4360c48d683a4c9c">00853</a>   void (* <a class="code" href="classSystem.php#a8317d0280bf965ad4360c48d683a4c9c">_qoi_evaluate</a>) (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es, 
<a name="l00854"></a>00854                           <span class="keyword">const</span> std::string&amp; <a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>);
<a name="l00855"></a>00855 
<a name="l00859"></a><a class="code" href="classSystem.php#ae622d3546efa4ef0ba40af79987e03ad">00859</a>   void (* <a class="code" href="classSystem.php#ae622d3546efa4ef0ba40af79987e03ad">_qoi_evaluate_derivative</a>) (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es, 
<a name="l00860"></a>00860                                      <span class="keyword">const</span> std::string&amp; <a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>);
<a name="l00861"></a>00861 
<a name="l00866"></a><a class="code" href="classSystem.php#ad9cb48f6abe7baff3d4a501cd92ee88e">00866</a>   <a class="code" href="classAutoPtr.php">AutoPtr&lt;DofMap&gt;</a> <a class="code" href="classSystem.php#ad9cb48f6abe7baff3d4a501cd92ee88e">_dof_map</a>;
<a name="l00867"></a>00867 
<a name="l00872"></a><a class="code" href="classSystem.php#ad601121641f7ae6dbd4696f8e769e863">00872</a>   <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; <a class="code" href="classSystem.php#ad601121641f7ae6dbd4696f8e769e863">_equation_systems</a>;
<a name="l00873"></a>00873   
<a name="l00878"></a><a class="code" href="classSystem.php#ab0f0e4373f521aec3806b4e3f8e16ad3">00878</a>   <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classSystem.php#ab0f0e4373f521aec3806b4e3f8e16ad3">_mesh</a>;
<a name="l00879"></a>00879   
<a name="l00883"></a><a class="code" href="classSystem.php#a4b6821843a8c8f11824788d03000416b">00883</a>   <span class="keyword">const</span> std::string <a class="code" href="classSystem.php#a4b6821843a8c8f11824788d03000416b">_sys_name</a>;
<a name="l00884"></a>00884 
<a name="l00888"></a><a class="code" href="classSystem.php#a92bea593157b4bdbfffbb66d944f9fe1">00888</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#a92bea593157b4bdbfffbb66d944f9fe1">_sys_number</a>;
<a name="l00889"></a>00889   
<a name="l00893"></a><a class="code" href="classSystem.php#a6937f66076215b9804aecf3983b1c5e8">00893</a>   std::vector&lt;System::Variable&gt; <a class="code" href="classSystem.php#a6937f66076215b9804aecf3983b1c5e8">_variables</a>;
<a name="l00894"></a>00894 
<a name="l00899"></a><a class="code" href="classSystem.php#ade03c4f7efd4b1839ff0003971d09d0a">00899</a>   std::map&lt;std::string, unsigned short int&gt; <a class="code" href="classSystem.php#ade03c4f7efd4b1839ff0003971d09d0a">_variable_numbers</a>;
<a name="l00900"></a>00900 
<a name="l00904"></a><a class="code" href="classSystem.php#afe8c62f6b6fd1f83adbd7e46dbd7af44">00904</a>   <span class="keywordtype">bool</span> <a class="code" href="classSystem.php#afe8c62f6b6fd1f83adbd7e46dbd7af44">_active</a>;
<a name="l00905"></a>00905   
<a name="l00912"></a><a class="code" href="classSystem.php#af306b03372a5ade33a7569b81af47ef1">00912</a>   std::map&lt;std::string, NumericVector&lt;Number&gt;* &gt; <a class="code" href="classSystem.php#af306b03372a5ade33a7569b81af47ef1">_vectors</a>;
<a name="l00913"></a>00913 
<a name="l00918"></a><a class="code" href="classSystem.php#a6c7fa5761b1ddb3c5fa5689df975e179">00918</a>   std::map&lt;std::string, bool&gt; <a class="code" href="classSystem.php#a6c7fa5761b1ddb3c5fa5689df975e179">_vector_projections</a>;
<a name="l00919"></a>00919 
<a name="l00925"></a><a class="code" href="classSystem.php#a5c4dc93cbba1fc013ce6023029f30909">00925</a>   <span class="keywordtype">bool</span> <a class="code" href="classSystem.php#a5c4dc93cbba1fc013ce6023029f30909">_solution_projection</a>;
<a name="l00926"></a>00926 
<a name="l00930"></a><a class="code" href="classSystem.php#ab6e6f8f579140ed6bfe4fe95f4084852">00930</a>   <span class="keywordtype">bool</span> <a class="code" href="classSystem.php#ab6e6f8f579140ed6bfe4fe95f4084852">_can_add_vectors</a>;
<a name="l00931"></a>00931 
<a name="l00937"></a><a class="code" href="classSystem.php#a786fffb041c918f509a3a37bd20fd72f">00937</a>   <span class="keywordtype">bool</span> <a class="code" href="classSystem.php#a786fffb041c918f509a3a37bd20fd72f">_additional_data_written</a>;
<a name="l00938"></a>00938 
<a name="l00939"></a>00939 
<a name="l00945"></a><a class="code" href="classSystem_1_1ProjectVector.php">00945</a>   <span class="keyword">class </span><a class="code" href="classSystem_1_1ProjectVector.php">ProjectVector</a> 
<a name="l00946"></a>00946   {
<a name="l00947"></a>00947   <span class="keyword">private</span>:
<a name="l00948"></a><a class="code" href="classSystem_1_1ProjectVector.php#a977abec7644598dc29f72c2effe11119">00948</a>     <span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>                &amp;<a class="code" href="classSystem_1_1ProjectVector.php#a977abec7644598dc29f72c2effe11119">system</a>;
<a name="l00949"></a><a class="code" href="classSystem_1_1ProjectVector.php#a7be075bb685af138d23b5c34e595d5ec">00949</a>     <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp;<a class="code" href="classSystem_1_1ProjectVector.php#a7be075bb685af138d23b5c34e595d5ec">old_vector</a>;
<a name="l00950"></a><a class="code" href="classSystem_1_1ProjectVector.php#ae8238db1153834ff99bbdafdef7ce14e">00950</a>     <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>       &amp;<a class="code" href="classSystem_1_1ProjectVector.php#ae8238db1153834ff99bbdafdef7ce14e">new_vector</a>;
<a name="l00951"></a>00951 
<a name="l00952"></a>00952   <span class="keyword">public</span>:
<a name="l00953"></a><a class="code" href="classSystem_1_1ProjectVector.php#a758395c9542d495c402e367badcc7aa0">00953</a>     <a class="code" href="classSystem_1_1ProjectVector.php#a758395c9542d495c402e367badcc7aa0">ProjectVector</a> (<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a> &amp;system_in,
<a name="l00954"></a>00954                    <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp;old_v_in,
<a name="l00955"></a>00955                    <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp;new_v_in) :
<a name="l00956"></a>00956     <a class="code" href="classSystem_1_1ProjectVector.php#a977abec7644598dc29f72c2effe11119">system</a>(system_in),
<a name="l00957"></a>00957     <a class="code" href="classSystem_1_1ProjectVector.php#a7be075bb685af138d23b5c34e595d5ec">old_vector</a>(old_v_in),
<a name="l00958"></a>00958     <a class="code" href="classSystem_1_1ProjectVector.php#ae8238db1153834ff99bbdafdef7ce14e">new_vector</a>(new_v_in)
<a name="l00959"></a>00959     {}
<a name="l00960"></a>00960     
<a name="l00961"></a>00961     <span class="keywordtype">void</span> <a class="code" href="classSystem_1_1ProjectVector.php#a1e500841ec64c832a5bc277de3b03543">operator()</a>(<span class="keyword">const</span> <a class="code" href="classStoredRange.php">ConstElemRange</a> &amp;range) <span class="keyword">const</span>;
<a name="l00962"></a>00962   };
<a name="l00963"></a>00963 
<a name="l00964"></a>00964 
<a name="l00974"></a><a class="code" href="classSystem_1_1BuildProjectionList.php">00974</a>   <span class="keyword">class </span><a class="code" href="classSystem_1_1BuildProjectionList.php">BuildProjectionList</a>
<a name="l00975"></a>00975   {
<a name="l00976"></a>00976   <span class="keyword">private</span>:
<a name="l00977"></a><a class="code" href="classSystem_1_1BuildProjectionList.php#acebabd801e7b0e1cdf3fa019df13618b">00977</a>     <span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>              &amp;<a class="code" href="classSystem_1_1BuildProjectionList.php#acebabd801e7b0e1cdf3fa019df13618b">system</a>;
<a name="l00978"></a>00978 
<a name="l00979"></a>00979   <span class="keyword">public</span>:
<a name="l00980"></a><a class="code" href="classSystem_1_1BuildProjectionList.php#a8f4cc3256e89fba8eb9e060e9d3b584e">00980</a>     <a class="code" href="classSystem_1_1BuildProjectionList.php#a8f4cc3256e89fba8eb9e060e9d3b584e">BuildProjectionList</a> (<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a> &amp;system_in) :
<a name="l00981"></a>00981     <a class="code" href="classSystem_1_1BuildProjectionList.php#acebabd801e7b0e1cdf3fa019df13618b">system</a>(system_in)
<a name="l00982"></a>00982     {}
<a name="l00983"></a>00983 
<a name="l00984"></a><a class="code" href="classSystem_1_1BuildProjectionList.php#a93c9ee5b2ce87e54843d9379eaaf6b8c">00984</a>     <a class="code" href="classSystem_1_1BuildProjectionList.php#a8f4cc3256e89fba8eb9e060e9d3b584e">BuildProjectionList</a> (<a class="code" href="classSystem_1_1BuildProjectionList.php">BuildProjectionList</a> &amp;other, <a class="code" href="classThreads_1_1split.php">Threads::split</a>) :
<a name="l00985"></a>00985      <a class="code" href="classSystem_1_1BuildProjectionList.php#acebabd801e7b0e1cdf3fa019df13618b">system</a>(other.<a class="code" href="classSystem_1_1BuildProjectionList.php#acebabd801e7b0e1cdf3fa019df13618b">system</a>)
<a name="l00986"></a>00986     {}
<a name="l00987"></a>00987     
<a name="l00988"></a>00988     <span class="keywordtype">void</span> <a class="code" href="classSystem_1_1BuildProjectionList.php#a904ac8b287f628502e74faadf901d13e">unique</a>();
<a name="l00989"></a>00989     <span class="keywordtype">void</span> <a class="code" href="classSystem_1_1BuildProjectionList.php#a68093bf7d78aff2516287bf0240957bc">operator()</a>(<span class="keyword">const</span> <a class="code" href="classStoredRange.php">ConstElemRange</a> &amp;range);
<a name="l00990"></a>00990     <span class="keywordtype">void</span> <a class="code" href="classSystem_1_1BuildProjectionList.php#a0f804f8b5913f76e2ad0747ad78c782d">join</a> (<span class="keyword">const</span> <a class="code" href="classSystem_1_1BuildProjectionList.php">BuildProjectionList</a> &amp;other);
<a name="l00991"></a><a class="code" href="classSystem_1_1BuildProjectionList.php#a0ed2bf4d9b02a0283c0fe1a89add54a8">00991</a>     std::vector&lt;unsigned int&gt; <a class="code" href="classSystem_1_1BuildProjectionList.php#a0ed2bf4d9b02a0283c0fe1a89add54a8">send_list</a>;
<a name="l00992"></a>00992   };
<a name="l00993"></a>00993 
<a name="l00994"></a>00994 
<a name="l00995"></a>00995 
<a name="l01001"></a><a class="code" href="classSystem_1_1ProjectSolution.php">01001</a>   <span class="keyword">class </span><a class="code" href="classSystem_1_1ProjectSolution.php">ProjectSolution</a>
<a name="l01002"></a>01002   {
<a name="l01003"></a>01003   <span class="keyword">private</span>:
<a name="l01004"></a><a class="code" href="classSystem_1_1ProjectSolution.php#a1dfb0a157d86fdd670da5e7ae27725b2">01004</a>     <span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>                &amp;<a class="code" href="classSystem_1_1ProjectSolution.php#a1dfb0a157d86fdd670da5e7ae27725b2">system</a>;
<a name="l01005"></a>01005 
<a name="l01006"></a><a class="code" href="classSystem_1_1ProjectSolution.php#a6118f1025c5c842d21f3e6d103770bee">01006</a>     <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> (* <a class="code" href="classSystem_1_1ProjectSolution.php#a6118f1025c5c842d21f3e6d103770bee">fptr</a>)(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l01007"></a>01007                     <span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; <a class="code" href="classSystem_1_1ProjectSolution.php#a81b9daa017dba995d283a42ae6ca3da3">parameters</a>,
<a name="l01008"></a>01008                     <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l01009"></a>01009                     <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l01010"></a>01010 
<a name="l01011"></a><a class="code" href="classSystem_1_1ProjectSolution.php#a0d0c18b4ada88ed424d8bc0614aa0bf3">01011</a>     <a class="code" href="exact__error__estimator_8h.php#aff779e61aca326de0c3649ec86a15866">Gradient</a> (* <a class="code" href="classSystem_1_1ProjectSolution.php#a0d0c18b4ada88ed424d8bc0614aa0bf3">gptr</a>)(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l01012"></a>01012                       <span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; <a class="code" href="classSystem_1_1ProjectSolution.php#a81b9daa017dba995d283a42ae6ca3da3">parameters</a>,
<a name="l01013"></a>01013                       <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l01014"></a>01014                       <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l01015"></a>01015 
<a name="l01016"></a><a class="code" href="classSystem_1_1ProjectSolution.php#a81b9daa017dba995d283a42ae6ca3da3">01016</a>     <a class="code" href="classParameters.php">Parameters</a> &amp;<a class="code" href="classSystem_1_1ProjectSolution.php#a81b9daa017dba995d283a42ae6ca3da3">parameters</a>;
<a name="l01017"></a><a class="code" href="classSystem_1_1ProjectSolution.php#a3fd543b718ed8e9204e544053ee64ee5">01017</a>     <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>       &amp;<a class="code" href="classSystem_1_1ProjectSolution.php#a3fd543b718ed8e9204e544053ee64ee5">new_vector</a>;
<a name="l01018"></a>01018 
<a name="l01019"></a>01019   <span class="keyword">public</span>:
<a name="l01020"></a><a class="code" href="classSystem_1_1ProjectSolution.php#ab7f924794f18dc0a98668ca4e16b9a38">01020</a>     <a class="code" href="classSystem_1_1ProjectSolution.php#ab7f924794f18dc0a98668ca4e16b9a38">ProjectSolution</a> (<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a> &amp;system_in,
<a name="l01021"></a>01021                      <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> fptr_in(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l01022"></a>01022                                     <span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; parameters,
<a name="l01023"></a>01023                                     <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l01024"></a>01024                                     <span class="keyword">const</span> std::string&amp; unknown_name),
<a name="l01025"></a>01025                      <a class="code" href="classVectorValue.php">Gradient</a> gptr_in(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l01026"></a>01026                                       <span class="keyword">const</span> <a class="code" href="classParameters.php">Parameters</a>&amp; parameters,
<a name="l01027"></a>01027                                       <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l01028"></a>01028                                       <span class="keyword">const</span> std::string&amp; unknown_name),
<a name="l01029"></a>01029                      <a class="code" href="classParameters.php">Parameters</a> &amp;parameters_in,
<a name="l01030"></a>01030                      <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp;new_v_in) :
<a name="l01031"></a>01031     <a class="code" href="classSystem_1_1ProjectSolution.php#a1dfb0a157d86fdd670da5e7ae27725b2">system</a>(system_in),
<a name="l01032"></a>01032     <a class="code" href="classSystem_1_1ProjectSolution.php#a6118f1025c5c842d21f3e6d103770bee">fptr</a>(fptr_in),
<a name="l01033"></a>01033     <a class="code" href="classSystem_1_1ProjectSolution.php#a0d0c18b4ada88ed424d8bc0614aa0bf3">gptr</a>(gptr_in),
<a name="l01034"></a>01034     parameters(parameters_in),
<a name="l01035"></a>01035     <a class="code" href="classSystem_1_1ProjectSolution.php#a3fd543b718ed8e9204e544053ee64ee5">new_vector</a>(new_v_in)
<a name="l01036"></a>01036     {}
<a name="l01037"></a>01037     
<a name="l01038"></a>01038     <span class="keywordtype">void</span> <a class="code" href="classSystem_1_1ProjectSolution.php#a0a4c85207b6d8f7bd5fb3c87b80737b7">operator()</a>(<span class="keyword">const</span> <a class="code" href="classStoredRange.php">ConstElemRange</a> &amp;range) <span class="keyword">const</span>;
<a name="l01039"></a>01039   };
<a name="l01040"></a>01040 };
<a name="l01041"></a>01041 
<a name="l01042"></a>01042 
<a name="l01043"></a>01043 
<a name="l01044"></a>01044 <span class="comment">// ------------------------------------------------------------</span>
<a name="l01045"></a>01045 <span class="comment">// System inline methods</span>
<a name="l01046"></a>01046 <span class="keyword">inline</span>
<a name="l01047"></a><a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">01047</a> <span class="keyword">const</span> std::string &amp; <a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">System::name</a>()<span class="keyword"> const</span>
<a name="l01048"></a>01048 <span class="keyword"></span>{
<a name="l01049"></a>01049   <span class="keywordflow">return</span> <a class="code" href="classSystem.php#a4b6821843a8c8f11824788d03000416b">_sys_name</a>;
<a name="l01050"></a>01050 }
<a name="l01051"></a>01051 
<a name="l01052"></a>01052 
<a name="l01053"></a>01053 
<a name="l01054"></a>01054 <span class="keyword">inline</span>
<a name="l01055"></a><a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">01055</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#a602bc9f97c563e54bfbace34c741438b">System::number</a>()<span class="keyword"> const</span>
<a name="l01056"></a>01056 <span class="keyword"></span>{
<a name="l01057"></a>01057   <span class="keywordflow">return</span> <a class="code" href="classSystem.php#a92bea593157b4bdbfffbb66d944f9fe1">_sys_number</a>;
<a name="l01058"></a>01058 }
<a name="l01059"></a>01059 
<a name="l01060"></a>01060 
<a name="l01061"></a>01061 
<a name="l01062"></a>01062 <span class="keyword">inline</span>
<a name="l01063"></a><a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">01063</a> <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp; <a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">System::get_mesh</a>()<span class="keyword"> const</span>
<a name="l01064"></a>01064 <span class="keyword"></span>{
<a name="l01065"></a>01065   <span class="keywordflow">return</span> <a class="code" href="classSystem.php#ab0f0e4373f521aec3806b4e3f8e16ad3">_mesh</a>;
<a name="l01066"></a>01066 }
<a name="l01067"></a>01067 
<a name="l01068"></a>01068 
<a name="l01069"></a>01069 
<a name="l01070"></a>01070 <span class="keyword">inline</span>
<a name="l01071"></a><a class="code" href="classSystem.php#aff58d1352df0da846de4f0b190e21645">01071</a> <a class="code" href="classMeshBase.php">MeshBase</a> &amp; <a class="code" href="classSystem.php#a8589c3d5d70df9890532085300a0042c">System::get_mesh</a>()
<a name="l01072"></a>01072 {
<a name="l01073"></a>01073   <span class="keywordflow">return</span> <a class="code" href="classSystem.php#ab0f0e4373f521aec3806b4e3f8e16ad3">_mesh</a>;
<a name="l01074"></a>01074 }
<a name="l01075"></a>01075 
<a name="l01076"></a>01076 
<a name="l01077"></a>01077 
<a name="l01078"></a>01078 <span class="keyword">inline</span>
<a name="l01079"></a><a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">01079</a> <span class="keyword">const</span> <a class="code" href="classDofMap.php">DofMap</a> &amp; <a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">System::get_dof_map</a>()<span class="keyword"> const</span>
<a name="l01080"></a>01080 <span class="keyword"></span>{
<a name="l01081"></a>01081   <span class="keywordflow">return</span> *<a class="code" href="classSystem.php#ad9cb48f6abe7baff3d4a501cd92ee88e">_dof_map</a>;
<a name="l01082"></a>01082 }
<a name="l01083"></a>01083 
<a name="l01084"></a>01084 
<a name="l01085"></a>01085 
<a name="l01086"></a>01086 <span class="keyword">inline</span>
<a name="l01087"></a><a class="code" href="classSystem.php#a84798871e5bbab224f1675a43657d562">01087</a> <a class="code" href="classDofMap.php">DofMap</a> &amp; <a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">System::get_dof_map</a>()
<a name="l01088"></a>01088 {
<a name="l01089"></a>01089   <span class="keywordflow">return</span> *<a class="code" href="classSystem.php#ad9cb48f6abe7baff3d4a501cd92ee88e">_dof_map</a>;
<a name="l01090"></a>01090 }
<a name="l01091"></a>01091 
<a name="l01092"></a>01092 
<a name="l01093"></a>01093 
<a name="l01094"></a>01094 <span class="keyword">inline</span>
<a name="l01095"></a><a class="code" href="classSystem.php#a3fa00ded548bb0392922b9ee37297644">01095</a> <span class="keywordtype">bool</span> <a class="code" href="classSystem.php#a3fa00ded548bb0392922b9ee37297644">System::active</a>()<span class="keyword"> const</span>
<a name="l01096"></a>01096 <span class="keyword"></span>{
<a name="l01097"></a>01097   <span class="keywordflow">return</span> <a class="code" href="classSystem.php#afe8c62f6b6fd1f83adbd7e46dbd7af44">_active</a>;  
<a name="l01098"></a>01098 }
<a name="l01099"></a>01099 
<a name="l01100"></a>01100 
<a name="l01101"></a>01101 
<a name="l01102"></a>01102 <span class="keyword">inline</span>
<a name="l01103"></a><a class="code" href="classSystem.php#aadc59f505a4efd40db91c0866163718a">01103</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#aadc59f505a4efd40db91c0866163718a">System::activate</a> ()
<a name="l01104"></a>01104 {
<a name="l01105"></a>01105   <a class="code" href="classSystem.php#afe8c62f6b6fd1f83adbd7e46dbd7af44">_active</a> = <span class="keyword">true</span>;
<a name="l01106"></a>01106 }
<a name="l01107"></a>01107 
<a name="l01108"></a>01108 
<a name="l01109"></a>01109 
<a name="l01110"></a>01110 <span class="keyword">inline</span>
<a name="l01111"></a><a class="code" href="classSystem.php#a7e3d6cb0c259e4543bdb85acf687d411">01111</a> <span class="keywordtype">void</span> <a class="code" href="classSystem.php#a7e3d6cb0c259e4543bdb85acf687d411">System::deactivate</a> ()
<a name="l01112"></a>01112 {
<a name="l01113"></a>01113   <a class="code" href="classSystem.php#afe8c62f6b6fd1f83adbd7e46dbd7af44">_active</a> = <span class="keyword">false</span>;
<a name="l01114"></a>01114 }
<a name="l01115"></a>01115 
<a name="l01116"></a>01116 
<a name="l01117"></a>01117 
<a name="l01118"></a>01118 <span class="keyword">inline</span>
<a name="l01119"></a><a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">01119</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">System::n_vars</a>()<span class="keyword"> const</span>
<a name="l01120"></a>01120 <span class="keyword"></span>{
<a name="l01121"></a>01121   <span class="keywordflow">return</span> <a class="code" href="classSystem.php#a6937f66076215b9804aecf3983b1c5e8">_variables</a>.size();
<a name="l01122"></a>01122 }
<a name="l01123"></a>01123 
<a name="l01124"></a>01124 
<a name="l01125"></a>01125 
<a name="l01126"></a>01126 <span class="keyword">inline</span>
<a name="l01127"></a><a class="code" href="classSystem.php#a8b1d32d0a3a3848906c07107a7f03762">01127</a> <span class="keyword">const</span> <a class="code" href="classSystem_1_1Variable.php">System::Variable</a> &amp; <a class="code" href="classSystem.php#a8b1d32d0a3a3848906c07107a7f03762">System::variable</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l01128"></a>01128 <span class="keyword"></span>{
<a name="l01129"></a>01129   libmesh_assert (i &lt; <a class="code" href="classSystem.php#a6937f66076215b9804aecf3983b1c5e8">_variables</a>.size());
<a name="l01130"></a>01130 
<a name="l01131"></a>01131   <span class="keywordflow">return</span> <a class="code" href="classSystem.php#a6937f66076215b9804aecf3983b1c5e8">_variables</a>[i];
<a name="l01132"></a>01132 }
<a name="l01133"></a>01133 
<a name="l01134"></a>01134 
<a name="l01135"></a>01135 
<a name="l01136"></a>01136 <span class="keyword">inline</span>
<a name="l01137"></a><a class="code" href="classSystem.php#af3a38b172dd6322eff9f30b3f63d3b63">01137</a> <span class="keyword">const</span> std::string &amp; <a class="code" href="classSystem.php#af3a38b172dd6322eff9f30b3f63d3b63">System::variable_name</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l01138"></a>01138 <span class="keyword"></span>{
<a name="l01139"></a>01139   libmesh_assert (i &lt; <a class="code" href="classSystem.php#a6937f66076215b9804aecf3983b1c5e8">_variables</a>.size());
<a name="l01140"></a>01140 
<a name="l01141"></a>01141   <span class="keywordflow">return</span> <a class="code" href="classSystem.php#a6937f66076215b9804aecf3983b1c5e8">_variables</a>[i].name();
<a name="l01142"></a>01142 }
<a name="l01143"></a>01143 
<a name="l01144"></a>01144 
<a name="l01145"></a>01145 
<a name="l01146"></a>01146 <span class="keyword">inline</span>
<a name="l01147"></a><a class="code" href="classSystem.php#aa917dd59a348a46e9adab63d9767460f">01147</a> <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a> &amp; <a class="code" href="classSystem.php#aa917dd59a348a46e9adab63d9767460f">System::variable_type</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l01148"></a>01148 <span class="keyword"></span>{
<a name="l01149"></a>01149   libmesh_assert (i &lt; <a class="code" href="classSystem.php#a6937f66076215b9804aecf3983b1c5e8">_variables</a>.size());
<a name="l01150"></a>01150   
<a name="l01151"></a>01151   <span class="keywordflow">return</span> <a class="code" href="classSystem.php#a6937f66076215b9804aecf3983b1c5e8">_variables</a>[i].type();
<a name="l01152"></a>01152 }
<a name="l01153"></a>01153 
<a name="l01154"></a>01154 
<a name="l01155"></a>01155 
<a name="l01156"></a>01156 <span class="keyword">inline</span>
<a name="l01157"></a><a class="code" href="classSystem.php#aa323f05b9d961aa991128c9a373906fb">01157</a> <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a> &amp; <a class="code" href="classSystem.php#aa917dd59a348a46e9adab63d9767460f">System::variable_type</a> (<span class="keyword">const</span> std::string&amp; var)<span class="keyword"> const</span>
<a name="l01158"></a>01158 <span class="keyword"></span>{
<a name="l01159"></a>01159   <span class="keywordflow">return</span> <a class="code" href="classSystem.php#a6937f66076215b9804aecf3983b1c5e8">_variables</a>[this-&gt;<a class="code" href="classSystem.php#ace6000ea1d0dc7e3635fe98761f95838">variable_number</a>(var)].type();
<a name="l01160"></a>01160 }
<a name="l01161"></a>01161 
<a name="l01162"></a>01162 
<a name="l01163"></a>01163 
<a name="l01164"></a>01164 <span class="keyword">inline</span>
<a name="l01165"></a><a class="code" href="classSystem.php#a936fb82a3c815116a42ef9e26bc56481">01165</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#a936fb82a3c815116a42ef9e26bc56481">System::n_active_dofs</a>()<span class="keyword"> const</span>
<a name="l01166"></a>01166 <span class="keyword"></span>{
<a name="l01167"></a>01167   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classSystem.php#aa8f04263eed1eaf253e81041f166408b">n_dofs</a>() - this-&gt;<a class="code" href="classSystem.php#accee8e94a0b050017d77589f0a43fbc8">n_constrained_dofs</a>();
<a name="l01168"></a>01168 }
<a name="l01169"></a>01169 
<a name="l01170"></a>01170 
<a name="l01171"></a>01171 
<a name="l01172"></a>01172 <span class="keyword">inline</span>
<a name="l01173"></a><a class="code" href="classSystem.php#a4fb11ff7ba967513144ba6fb1e4d85e6">01173</a> <span class="keywordtype">bool</span> <a class="code" href="classSystem.php#a4fb11ff7ba967513144ba6fb1e4d85e6">System::have_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name)<span class="keyword"> const</span>
<a name="l01174"></a>01174 <span class="keyword"></span>{
<a name="l01175"></a>01175   <span class="keywordflow">return</span> (<a class="code" href="classSystem.php#af306b03372a5ade33a7569b81af47ef1">_vectors</a>.count(vec_name));
<a name="l01176"></a>01176 }
<a name="l01177"></a>01177 
<a name="l01178"></a>01178 
<a name="l01179"></a>01179 
<a name="l01180"></a>01180 <span class="keyword">inline</span>
<a name="l01181"></a><a class="code" href="classSystem.php#adf187b75dac8c906b0b27ce25e146305">01181</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#adf187b75dac8c906b0b27ce25e146305">System::n_vectors</a> ()<span class="keyword"> const</span>
<a name="l01182"></a>01182 <span class="keyword"></span>{
<a name="l01183"></a>01183   <span class="keywordflow">return</span> <a class="code" href="classSystem.php#af306b03372a5ade33a7569b81af47ef1">_vectors</a>.size(); 
<a name="l01184"></a>01184 }
<a name="l01185"></a>01185 
<a name="l01186"></a>01186 <span class="keyword">inline</span>
<a name="l01187"></a><a class="code" href="classSystem.php#aa33cb0639b60f352561646fcce51a06b">01187</a> <a class="code" href="classSystem.php#ac1939aeca6473017c8b6a560892e86aa">System::vectors_iterator</a> <a class="code" href="classSystem.php#aa33cb0639b60f352561646fcce51a06b">System::vectors_begin</a> ()
<a name="l01188"></a>01188 {
<a name="l01189"></a>01189   <span class="keywordflow">return</span> <a class="code" href="classSystem.php#af306b03372a5ade33a7569b81af47ef1">_vectors</a>.begin();
<a name="l01190"></a>01190 }
<a name="l01191"></a>01191 
<a name="l01192"></a>01192 <span class="keyword">inline</span>
<a name="l01193"></a><a class="code" href="classSystem.php#a37502c4fd1d55af73949f96dfd7fa123">01193</a> <a class="code" href="classSystem.php#a85440d8ff0086de5be93ae0922937d0c">System::const_vectors_iterator</a> <a class="code" href="classSystem.php#aa33cb0639b60f352561646fcce51a06b">System::vectors_begin</a> ()<span class="keyword"> const</span>
<a name="l01194"></a>01194 <span class="keyword"></span>{
<a name="l01195"></a>01195   <span class="keywordflow">return</span> <a class="code" href="classSystem.php#af306b03372a5ade33a7569b81af47ef1">_vectors</a>.begin();
<a name="l01196"></a>01196 }
<a name="l01197"></a>01197 
<a name="l01198"></a>01198 <span class="keyword">inline</span>
<a name="l01199"></a><a class="code" href="classSystem.php#a0c1c70cc7f560cda430474eea1702082">01199</a> <a class="code" href="classSystem.php#ac1939aeca6473017c8b6a560892e86aa">System::vectors_iterator</a> <a class="code" href="classSystem.php#a0c1c70cc7f560cda430474eea1702082">System::vectors_end</a> ()
<a name="l01200"></a>01200 {
<a name="l01201"></a>01201   <span class="keywordflow">return</span> <a class="code" href="classSystem.php#af306b03372a5ade33a7569b81af47ef1">_vectors</a>.end();
<a name="l01202"></a>01202 }
<a name="l01203"></a>01203 
<a name="l01204"></a>01204 <span class="keyword">inline</span>
<a name="l01205"></a><a class="code" href="classSystem.php#ad81ff0aa5075477da1ea8a4d286d7350">01205</a> <a class="code" href="classSystem.php#a85440d8ff0086de5be93ae0922937d0c">System::const_vectors_iterator</a> <a class="code" href="classSystem.php#a0c1c70cc7f560cda430474eea1702082">System::vectors_end</a> ()<span class="keyword"> const</span>
<a name="l01206"></a>01206 <span class="keyword"></span>{
<a name="l01207"></a>01207   <span class="keywordflow">return</span> <a class="code" href="classSystem.php#af306b03372a5ade33a7569b81af47ef1">_vectors</a>.end();
<a name="l01208"></a>01208 }
<a name="l01209"></a>01209 
<a name="l01210"></a>01210 
<a name="l01211"></a>01211 
<a name="l01212"></a>01212 <span class="preprocessor">#endif // #define __system_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
