<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>tecplot_io.C</h1>  </div>
</div>
<div class="contents">
<a href="tecplot__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: tecplot_io.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;tecplot_io.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="preprocessor">#ifdef LIBMESH_HAVE_TECPLOT_API</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {
<a name="l00033"></a>00033 <span class="preprocessor"># include &lt;TECIO.h&gt;</span>
<a name="l00034"></a>00034 }
<a name="l00035"></a>00035 <span class="preprocessor">#endif</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">//--------------------------------------------------------</span>
<a name="l00040"></a>00040 <span class="comment">// Macros for handling Tecplot API data</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="preprocessor">#ifdef LIBMESH_HAVE_TECPLOT_API</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span>
<a name="l00044"></a>00044 <span class="keyword">namespace</span>
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046   <span class="keyword">class </span>TecplotMacros
<a name="l00047"></a>00047   {
<a name="l00048"></a>00048   <span class="keyword">public</span>:
<a name="l00049"></a>00049     TecplotMacros(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>,
<a name="l00050"></a>00050                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_vars,
<a name="l00051"></a>00051                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_cells,
<a name="l00052"></a>00052                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_vert);
<a name="l00053"></a>00053     <span class="keywordtype">float</span> &amp; nd(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j);
<a name="l00054"></a>00054     <span class="keywordtype">int</span>   &amp; cd(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j);
<a name="l00055"></a>00055     std::vector&lt;float&gt; nodalData;
<a name="l00056"></a>00056     std::vector&lt;int&gt;   connData;
<a name="l00057"></a>00057     <span class="comment">//float* nodalData;</span>
<a name="l00058"></a>00058     <span class="comment">//int*   connData;</span>
<a name="l00059"></a>00059   <span class="keyword">private</span>:
<a name="l00060"></a>00060     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>;
<a name="l00061"></a>00061     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_vars;
<a name="l00062"></a>00062     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_cells;
<a name="l00063"></a>00063     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_vert;
<a name="l00064"></a>00064   };
<a name="l00065"></a>00065 }
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 <span class="keyword">inline</span>
<a name="l00070"></a>00070 TecplotMacros::TecplotMacros(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00071"></a>00071                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nvar,
<a name="l00072"></a>00072                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc,
<a name="l00073"></a>00073                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nvrt) :
<a name="l00074"></a>00074   <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>(nn),
<a name="l00075"></a>00075   n_vars(nvar),
<a name="l00076"></a>00076   n_cells(nc),
<a name="l00077"></a>00077   n_vert(nvrt)
<a name="l00078"></a>00078 {
<a name="l00079"></a>00079   nodalData.resize(<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>*<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>);
<a name="l00080"></a>00080   connData.resize(n_cells*n_vert);
<a name="l00081"></a>00081 }
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 <span class="keyword">inline</span>
<a name="l00086"></a>00086 <span class="keywordtype">float</span> &amp; TecplotMacros::nd(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)
<a name="l00087"></a>00087 {
<a name="l00088"></a>00088   <span class="keywordflow">return</span> nodalData[(i)*(<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>) + (j)]; 
<a name="l00089"></a>00089 }
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 <span class="keyword">inline</span>
<a name="l00094"></a>00094 <span class="keywordtype">int</span> &amp; TecplotMacros::cd(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)
<a name="l00095"></a>00095 {
<a name="l00096"></a>00096   <span class="keywordflow">return</span> connData[(i) + (j)*(n_vert)]; 
<a name="l00097"></a>00097 }
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 <span class="preprocessor">#endif</span>
<a name="l00100"></a>00100 <span class="preprocessor"></span><span class="comment">//--------------------------------------------------------</span>
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00105"></a>00105 <span class="comment">// TecplotIO  members</span>
<a name="l00106"></a><a class="code" href="classTecplotIO.php#a6a673b9ecb0d5538b161ff0153d69c73">00106</a> <span class="keywordtype">void</span> <a class="code" href="classTecplotIO.php#a6a673b9ecb0d5538b161ff0153d69c73">TecplotIO::write</a> (<span class="keyword">const</span> std::string&amp; fname)
<a name="l00107"></a>00107 {
<a name="l00108"></a>00108   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00109"></a>00109     {
<a name="l00110"></a>00110       <span class="keywordflow">if</span> (this-&gt;binary())
<a name="l00111"></a>00111         this-&gt;write_binary (fname);
<a name="l00112"></a>00112       <span class="keywordflow">else</span>
<a name="l00113"></a>00113         this-&gt;write_ascii  (fname);
<a name="l00114"></a>00114     }
<a name="l00115"></a>00115 }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a><a class="code" href="classTecplotIO.php#a5677240e026f182aefaf10f803d1df65">00119</a> <span class="keywordtype">void</span> <a class="code" href="classTecplotIO.php#a5677240e026f182aefaf10f803d1df65">TecplotIO::write_nodal_data</a> (<span class="keyword">const</span> std::string&amp; fname,
<a name="l00120"></a>00120                                   <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; soln,
<a name="l00121"></a>00121                                   <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; names)
<a name="l00122"></a>00122 {
<a name="l00123"></a>00123   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00124"></a>00124     {
<a name="l00125"></a>00125       <span class="keywordflow">if</span> (this-&gt;binary())
<a name="l00126"></a>00126         this-&gt;write_binary (fname, &amp;soln, &amp;names);
<a name="l00127"></a>00127       <span class="keywordflow">else</span>
<a name="l00128"></a>00128         this-&gt;write_ascii  (fname, &amp;soln, &amp;names);
<a name="l00129"></a>00129     }
<a name="l00130"></a>00130 }
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a><a class="code" href="classTecplotIO.php#a3773b3721db895374e71327d1fce065e">00134</a> <span class="keywordtype">void</span> <a class="code" href="classTecplotIO.php#a3773b3721db895374e71327d1fce065e">TecplotIO::write_ascii</a> (<span class="keyword">const</span> std::string&amp; fname,
<a name="l00135"></a>00135                              <span class="keyword">const</span> std::vector&lt;Number&gt;* v,
<a name="l00136"></a>00136                              <span class="keyword">const</span> std::vector&lt;std::string&gt;* solution_names)
<a name="l00137"></a>00137 {
<a name="l00138"></a>00138   <span class="comment">// Should only do this on processor 0!</span>
<a name="l00139"></a>00139   libmesh_assert (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0);
<a name="l00140"></a>00140   
<a name="l00141"></a>00141   <span class="comment">// Create an output stream</span>
<a name="l00142"></a>00142   std::ofstream out(fname.c_str());
<a name="l00143"></a>00143 
<a name="l00144"></a>00144   <span class="comment">// Make sure it opened correctly</span>
<a name="l00145"></a>00145   <span class="keywordflow">if</span> (!out.good())
<a name="l00146"></a>00146     libmesh_file_error(fname.c_str());
<a name="l00147"></a>00147 
<a name="l00148"></a>00148   <span class="comment">// Get a constant reference to the mesh.</span>
<a name="l00149"></a>00149   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh = <a class="code" href="classMeshOutput.php">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00150"></a>00150   
<a name="l00151"></a>00151   <span class="comment">// Write header to stream</span>
<a name="l00152"></a>00152   {
<a name="l00153"></a>00153     {
<a name="l00154"></a>00154       out &lt;&lt; <span class="stringliteral">&quot;# This file was generated by:\n&quot;</span>
<a name="l00155"></a>00155           &lt;&lt; <span class="stringliteral">&quot;#\n&quot;</span>
<a name="l00156"></a>00156           &lt;&lt; <span class="stringliteral">&quot;# $Id: tecplot_io.C 3391 2009-05-26 03:50:35Z benkirk $\n&quot;</span>
<a name="l00157"></a>00157           &lt;&lt; <span class="stringliteral">&quot;#\n&quot;</span>
<a name="l00158"></a>00158           &lt;&lt; <span class="stringliteral">&quot;# For a description of the Tecplot format see the Tecplot User&#39;s guide.\n&quot;</span>
<a name="l00159"></a>00159           &lt;&lt; <span class="stringliteral">&quot;#\n&quot;</span>;
<a name="l00160"></a>00160     }
<a name="l00161"></a>00161 
<a name="l00162"></a>00162     out &lt;&lt; <span class="stringliteral">&quot;Variables=x,y,z&quot;</span>;
<a name="l00163"></a>00163 
<a name="l00164"></a>00164     <span class="keywordflow">if</span> (solution_names != NULL)
<a name="l00165"></a>00165       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;solution_names-&gt;size(); n++)
<a name="l00166"></a>00166         {
<a name="l00167"></a>00167 <span class="preprocessor">#ifdef LIBMESH_USE_REAL_NUMBERS</span>
<a name="l00168"></a>00168 <span class="preprocessor"></span>          
<a name="l00169"></a>00169           <span class="comment">// Write variable names for real variables</span>
<a name="l00170"></a>00170           out &lt;&lt; <span class="stringliteral">&quot;,&quot;</span> &lt;&lt; (*solution_names)[n];
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 <span class="preprocessor">#else</span>
<a name="l00173"></a>00173 <span class="preprocessor"></span>          
<a name="l00174"></a>00174           <span class="comment">// Write variable names for complex variables</span>
<a name="l00175"></a>00175           out &lt;&lt; <span class="stringliteral">&quot;,&quot;</span> &lt;&lt; <span class="stringliteral">&quot;r_&quot;</span>   &lt;&lt; (*solution_names)[n]
<a name="l00176"></a>00176               &lt;&lt; <span class="stringliteral">&quot;,&quot;</span> &lt;&lt; <span class="stringliteral">&quot;i_&quot;</span>   &lt;&lt; (*solution_names)[n]
<a name="l00177"></a>00177               &lt;&lt; <span class="stringliteral">&quot;,&quot;</span> &lt;&lt; <span class="stringliteral">&quot;a_&quot;</span>   &lt;&lt; (*solution_names)[n];
<a name="l00178"></a>00178           
<a name="l00179"></a>00179 <span class="preprocessor">#endif</span>
<a name="l00180"></a>00180 <span class="preprocessor"></span>        }
<a name="l00181"></a>00181 
<a name="l00182"></a>00182     out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00183"></a>00183     
<a name="l00184"></a>00184     out &lt;&lt; <span class="stringliteral">&quot;Zone f=fepoint, n=&quot;</span> &lt;&lt; mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>() &lt;&lt; <span class="stringliteral">&quot;, e=&quot;</span> &lt;&lt; mesh.<a class="code" href="classMeshBase.php#a488a2249eb1ab6349807a401cb9db44e">n_active_sub_elem</a>();
<a name="l00185"></a>00185         
<a name="l00186"></a>00186     <span class="keywordflow">if</span> (mesh.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>() == 1)
<a name="l00187"></a>00187       out &lt;&lt; <span class="stringliteral">&quot;, et=lineseg&quot;</span>;
<a name="l00188"></a>00188     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (mesh.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>() == 2)
<a name="l00189"></a>00189       out &lt;&lt; <span class="stringliteral">&quot;, et=quadrilateral&quot;</span>;
<a name="l00190"></a>00190     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (mesh.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>() == 3)
<a name="l00191"></a>00191       out &lt;&lt; <span class="stringliteral">&quot;, et=brick&quot;</span>;
<a name="l00192"></a>00192     <span class="keywordflow">else</span>
<a name="l00193"></a>00193       {
<a name="l00194"></a>00194         <span class="comment">// Dimension other than 1, 2, or 3?</span>
<a name="l00195"></a>00195         libmesh_error();
<a name="l00196"></a>00196       }
<a name="l00197"></a>00197     
<a name="l00198"></a>00198     <span class="comment">// Use default mesh color = black</span>
<a name="l00199"></a>00199     out &lt;&lt; <span class="stringliteral">&quot;, c=black\n&quot;</span>;
<a name="l00200"></a>00200     
<a name="l00201"></a>00201   } <span class="comment">// finished writing header</span>
<a name="l00202"></a>00202 
<a name="l00203"></a>00203   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>(); i++)
<a name="l00204"></a>00204     {
<a name="l00205"></a>00205       <span class="comment">// Print the point without a newline</span>
<a name="l00206"></a>00206       mesh.<a class="code" href="classMeshBase.php#a06af1f178519c606d0bdca7857f95ba6">point</a>(i).<a class="code" href="classTypeVector.php#a63b9bdcd6b65a707e9c3f9ac66eb3a1a">write_unformatted</a>(out, <span class="keyword">false</span>);
<a name="l00207"></a>00207 
<a name="l00208"></a>00208       <span class="keywordflow">if</span> ((v != NULL) &amp;&amp; (solution_names != NULL))
<a name="l00209"></a>00209         {
<a name="l00210"></a>00210           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_vars = solution_names-&gt;size();
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 
<a name="l00213"></a>00213           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>; c++)
<a name="l00214"></a>00214             {
<a name="l00215"></a>00215 <span class="preprocessor">#ifdef LIBMESH_USE_REAL_NUMBERS       </span>
<a name="l00216"></a>00216 <span class="preprocessor"></span>              <span class="comment">// Write real data</span>
<a name="l00217"></a>00217               out &lt;&lt; (*v)[i*n_vars + c] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 <span class="preprocessor">#else</span>
<a name="l00220"></a>00220 <span class="preprocessor"></span>              <span class="comment">// Write complex data</span>
<a name="l00221"></a>00221               out &lt;&lt; (*v)[i*n_vars + c].real() &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00222"></a>00222                   &lt;&lt; (*v)[i*n_vars + c].imag() &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00223"></a>00223                   &lt;&lt; std::abs((*v)[i*n_vars + c]) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 <span class="preprocessor">#endif</span>
<a name="l00226"></a>00226 <span class="preprocessor"></span>            }     
<a name="l00227"></a>00227         }
<a name="l00228"></a>00228 
<a name="l00229"></a>00229       <span class="comment">// Write a new line after the data for this node</span>
<a name="l00230"></a>00230       out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;        
<a name="l00231"></a>00231     }
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 <span class="comment">//   const_active_elem_iterator       it (mesh.elements_begin());</span>
<a name="l00234"></a>00234 <span class="comment">//   const const_active_elem_iterator end(mesh.elements_end());</span>
<a name="l00235"></a>00235 
<a name="l00236"></a>00236   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00237"></a>00237   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00238"></a>00238 
<a name="l00239"></a>00239   <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l00240"></a>00240     (*it)-&gt;write_connectivity(out, <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>);
<a name="l00241"></a>00241 }
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 
<a name="l00244"></a>00244 
<a name="l00245"></a><a class="code" href="classTecplotIO.php#a33bbace7c5bf7a1d1c625ed4240c9815">00245</a> <span class="keywordtype">void</span> <a class="code" href="classTecplotIO.php#a33bbace7c5bf7a1d1c625ed4240c9815">TecplotIO::write_binary</a> (<span class="keyword">const</span> std::string&amp; fname,
<a name="l00246"></a>00246                               <span class="keyword">const</span> std::vector&lt;Number&gt;* vec,
<a name="l00247"></a>00247                               <span class="keyword">const</span> std::vector&lt;std::string&gt;* solution_names)
<a name="l00248"></a>00248 {
<a name="l00249"></a>00249   <span class="comment">// Call the ASCII output function if configure did not detect</span>
<a name="l00250"></a>00250   <span class="comment">// the Tecplot binary API</span>
<a name="l00251"></a>00251 <span class="preprocessor">#ifndef LIBMESH_HAVE_TECPLOT_API</span>
<a name="l00252"></a>00252 <span class="preprocessor"></span>  
<a name="l00253"></a>00253     std::cerr &lt;&lt; <span class="stringliteral">&quot;WARNING: Tecplot Binary files require the Tecplot API.&quot;</span> &lt;&lt; std::endl
<a name="l00254"></a>00254               &lt;&lt; <span class="stringliteral">&quot;Continuing with ASCII output.&quot;</span>
<a name="l00255"></a>00255               &lt;&lt; std::endl;
<a name="l00256"></a>00256 
<a name="l00257"></a>00257     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00258"></a>00258       this-&gt;write_ascii (fname, vec, solution_names);
<a name="l00259"></a>00259     <span class="keywordflow">return</span>;
<a name="l00260"></a>00260     
<a name="l00261"></a>00261 <span class="preprocessor">#else</span>
<a name="l00262"></a>00262 <span class="preprocessor"></span>    
<a name="l00263"></a>00263   <span class="comment">// Get a constant reference to the mesh.</span>
<a name="l00264"></a>00264   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh = <a class="code" href="classMeshOutput.php">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00265"></a>00265   
<a name="l00266"></a>00266   <span class="comment">// Tecplot binary output only good for dim=2,3</span>
<a name="l00267"></a>00267   <span class="keywordflow">if</span> (mesh.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>() == 1)
<a name="l00268"></a>00268     {
<a name="l00269"></a>00269       this-&gt;write_ascii (fname, vec, solution_names);
<a name="l00270"></a>00270 
<a name="l00271"></a>00271       <span class="keywordflow">return</span>;
<a name="l00272"></a>00272     }
<a name="l00273"></a>00273 
<a name="l00274"></a>00274   <span class="comment">// Required variables</span>
<a name="l00275"></a>00275   std::string tecplot_variable_names;
<a name="l00276"></a>00276   <span class="keywordtype">int</span> is_double =  0,
<a name="l00277"></a>00277     tec_debug =  0,
<a name="l00278"></a>00278     cell_type = ((mesh.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>()==2) ? (1) : (3));
<a name="l00279"></a>00279 
<a name="l00280"></a>00280   <span class="comment">// Build a string containing all the variable names to pass to Tecplot</span>
<a name="l00281"></a>00281   {
<a name="l00282"></a>00282     tecplot_variable_names += <span class="stringliteral">&quot;x, y, z&quot;</span>;
<a name="l00283"></a>00283     
<a name="l00284"></a>00284     <span class="keywordflow">if</span> (solution_names != NULL)
<a name="l00285"></a>00285       {
<a name="l00286"></a>00286         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>=0; <a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>&lt;solution_names-&gt;size(); <a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>++)
<a name="l00287"></a>00287           {
<a name="l00288"></a>00288 <span class="preprocessor">#ifdef LIBMESH_USE_REAL_NUMBERS</span>
<a name="l00289"></a>00289 <span class="preprocessor"></span>
<a name="l00290"></a>00290             tecplot_variable_names += <span class="stringliteral">&quot;, &quot;</span>;
<a name="l00291"></a>00291             tecplot_variable_names += (*solution_names)[<a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>];
<a name="l00292"></a>00292 
<a name="l00293"></a>00293 <span class="preprocessor">#else</span>
<a name="l00294"></a>00294 <span class="preprocessor"></span>            
<a name="l00295"></a>00295             tecplot_variable_names += <span class="stringliteral">&quot;, &quot;</span>;
<a name="l00296"></a>00296             tecplot_variable_names += <span class="stringliteral">&quot;r_&quot;</span>;
<a name="l00297"></a>00297             tecplot_variable_names += (*solution_names)[<a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>];
<a name="l00298"></a>00298             tecplot_variable_names += <span class="stringliteral">&quot;, &quot;</span>;
<a name="l00299"></a>00299             tecplot_variable_names += <span class="stringliteral">&quot;i_&quot;</span>;
<a name="l00300"></a>00300             tecplot_variable_names += (*solution_names)[<a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>];
<a name="l00301"></a>00301             tecplot_variable_names += <span class="stringliteral">&quot;, &quot;</span>;
<a name="l00302"></a>00302             tecplot_variable_names += <span class="stringliteral">&quot;a_&quot;</span>;
<a name="l00303"></a>00303             tecplot_variable_names += (*solution_names)[<a class="code" href="classSystem.php#a8d698e928829a9ab670a594a451b1520">name</a>];
<a name="l00304"></a>00304 
<a name="l00305"></a>00305 <span class="preprocessor">#endif</span>
<a name="l00306"></a>00306 <span class="preprocessor"></span>          }
<a name="l00307"></a>00307       }
<a name="l00308"></a>00308   }
<a name="l00309"></a>00309 
<a name="l00310"></a>00310   <span class="comment">// Instantiate a TecplotMacros interface.  In 2D the most nodes per</span>
<a name="l00311"></a>00311   <span class="comment">// face should be 4, in 3D it&#39;s 8.</span>
<a name="l00312"></a>00312 
<a name="l00313"></a>00313   
<a name="l00314"></a>00314   TecplotMacros tm(mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>(),
<a name="l00315"></a>00315 <span class="preprocessor">#ifdef LIBMESH_USE_REAL_NUMBERS            </span>
<a name="l00316"></a>00316 <span class="preprocessor"></span>                   (3 + ((solution_names == NULL) ? 0 : solution_names-&gt;size())),
<a name="l00317"></a>00317 <span class="preprocessor">#else</span>
<a name="l00318"></a>00318 <span class="preprocessor"></span>                   (3 + 3*((solution_names == NULL) ? 0 : solution_names-&gt;size())),
<a name="l00319"></a>00319 <span class="preprocessor">#endif</span>
<a name="l00320"></a>00320 <span class="preprocessor"></span>                   mesh.<a class="code" href="classMeshBase.php#a488a2249eb1ab6349807a401cb9db44e">n_active_sub_elem</a>(),
<a name="l00321"></a>00321                    ((mesh.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>() == 2) ? 4 : 8)
<a name="l00322"></a>00322                    );
<a name="l00323"></a>00323 
<a name="l00324"></a>00324 
<a name="l00325"></a>00325   <span class="comment">// Copy the nodes and data to the TecplotMacros class. Note that we store</span>
<a name="l00326"></a>00326   <span class="comment">// everything as a float here since the eye doesn&#39;t require a double to</span>
<a name="l00327"></a>00327   <span class="comment">// understand what is going on</span>
<a name="l00328"></a>00328   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>(); v++)
<a name="l00329"></a>00329     {
<a name="l00330"></a>00330       tm.nd(0,v) = <span class="keyword">static_cast&lt;</span><span class="keywordtype">float</span><span class="keyword">&gt;</span>(mesh.<a class="code" href="classMeshBase.php#a06af1f178519c606d0bdca7857f95ba6">point</a>(v)(0));
<a name="l00331"></a>00331       tm.nd(1,v) = <span class="keyword">static_cast&lt;</span><span class="keywordtype">float</span><span class="keyword">&gt;</span>(mesh.<a class="code" href="classMeshBase.php#a06af1f178519c606d0bdca7857f95ba6">point</a>(v)(1));
<a name="l00332"></a>00332       tm.nd(2,v) = <span class="keyword">static_cast&lt;</span><span class="keywordtype">float</span><span class="keyword">&gt;</span>(mesh.<a class="code" href="classMeshBase.php#a06af1f178519c606d0bdca7857f95ba6">point</a>(v)(2));
<a name="l00333"></a>00333 
<a name="l00334"></a>00334       <span class="keywordflow">if</span> ((vec != NULL) &amp;&amp;
<a name="l00335"></a>00335           (solution_names != NULL))
<a name="l00336"></a>00336         {
<a name="l00337"></a>00337           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_vars = solution_names-&gt;size(); 
<a name="l00338"></a>00338 
<a name="l00339"></a>00339           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>; c++)
<a name="l00340"></a>00340             {
<a name="l00341"></a>00341 <span class="preprocessor">#ifdef LIBMESH_USE_REAL_NUMBERS</span>
<a name="l00342"></a>00342 <span class="preprocessor"></span>              
<a name="l00343"></a>00343               tm.nd((3+c),v)     = <span class="keyword">static_cast&lt;</span><span class="keywordtype">float</span><span class="keyword">&gt;</span>((*vec)[v*n_vars + c]);
<a name="l00344"></a>00344 <span class="preprocessor">#else</span>
<a name="l00345"></a>00345 <span class="preprocessor"></span>              tm.nd((3+3*c),v)   = <span class="keyword">static_cast&lt;</span><span class="keywordtype">float</span><span class="keyword">&gt;</span>((*vec)[v*n_vars + c].real());
<a name="l00346"></a>00346               tm.nd((3+3*c+1),v) = <span class="keyword">static_cast&lt;</span><span class="keywordtype">float</span><span class="keyword">&gt;</span>((*vec)[v*n_vars + c].imag());
<a name="l00347"></a>00347               tm.nd((3+3*c+2),v) = <span class="keyword">static_cast&lt;</span><span class="keywordtype">float</span><span class="keyword">&gt;</span>(std::abs((*vec)[v*n_vars + c]));
<a name="l00348"></a>00348 <span class="preprocessor">#endif</span>
<a name="l00349"></a>00349 <span class="preprocessor"></span>            }
<a name="l00350"></a>00350         }
<a name="l00351"></a>00351     }
<a name="l00352"></a>00352 
<a name="l00353"></a>00353 
<a name="l00354"></a>00354   <span class="comment">// Copy the connectivity</span>
<a name="l00355"></a>00355   {   
<a name="l00356"></a>00356     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> te = 0;
<a name="l00357"></a>00357 
<a name="l00358"></a>00358 <span class="comment">//     const_active_elem_iterator       it (mesh.elements_begin());</span>
<a name="l00359"></a>00359 <span class="comment">//     const const_active_elem_iterator end(mesh.elements_end());</span>
<a name="l00360"></a>00360 
<a name="l00361"></a>00361     <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00362"></a>00362     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00363"></a>00363 
<a name="l00364"></a>00364     <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l00365"></a>00365       {
<a name="l00366"></a>00366         std::vector&lt;unsigned int&gt; conn;
<a name="l00367"></a>00367         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> se=0; se&lt;(*it)-&gt;n_sub_elem(); se++)
<a name="l00368"></a>00368           {
<a name="l00369"></a>00369             (*it)-&gt;connectivity(se, <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>, conn);
<a name="l00370"></a>00370           
<a name="l00371"></a>00371             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node=0; node&lt;conn.size(); node++)
<a name="l00372"></a>00372               tm.cd(node,te) = conn[node];
<a name="l00373"></a>00373           
<a name="l00374"></a>00374             te++;
<a name="l00375"></a>00375           }
<a name="l00376"></a>00376       }
<a name="l00377"></a>00377   }
<a name="l00378"></a>00378   
<a name="l00379"></a>00379   
<a name="l00380"></a>00380   <span class="comment">// Ready to call the Tecplot API</span>
<a name="l00381"></a>00381   {
<a name="l00382"></a>00382     <span class="keywordtype">int</span> ierr = 0,
<a name="l00383"></a>00383       num_nodes = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>()),
<a name="l00384"></a>00384       num_cells = static_cast&lt;int&gt;(mesh.<a class="code" href="classMeshBase.php#a488a2249eb1ab6349807a401cb9db44e">n_active_sub_elem</a>());
<a name="l00385"></a>00385     
<a name="l00386"></a>00386     
<a name="l00387"></a>00387     ierr = TECINI (NULL,
<a name="l00388"></a>00388                    (<span class="keywordtype">char</span>*) tecplot_variable_names.c_str(),
<a name="l00389"></a>00389                    (<span class="keywordtype">char</span>*) fname.c_str(),
<a name="l00390"></a>00390                    (<span class="keywordtype">char</span>*) <span class="stringliteral">&quot;.&quot;</span>,
<a name="l00391"></a>00391                    &amp;tec_debug,
<a name="l00392"></a>00392                    &amp;is_double);
<a name="l00393"></a>00393     
<a name="l00394"></a>00394     libmesh_assert (ierr == 0);
<a name="l00395"></a>00395     
<a name="l00396"></a>00396     ierr = TECZNE (NULL,
<a name="l00397"></a>00397                    &amp;num_nodes,
<a name="l00398"></a>00398                    &amp;num_cells,
<a name="l00399"></a>00399                    &amp;cell_type,
<a name="l00400"></a>00400                    (<span class="keywordtype">char</span>*) <span class="stringliteral">&quot;FEBLOCK&quot;</span>,
<a name="l00401"></a>00401                    NULL);
<a name="l00402"></a>00402     
<a name="l00403"></a>00403     libmesh_assert (ierr == 0);
<a name="l00404"></a>00404 
<a name="l00405"></a>00405     
<a name="l00406"></a>00406     <span class="keywordtype">int</span> total =
<a name="l00407"></a>00407 <span class="preprocessor">#ifdef LIBMESH_USE_REAL_NUMBERS</span>
<a name="l00408"></a>00408 <span class="preprocessor"></span>      ((3 + ((solution_names == NULL) ? 0 : solution_names-&gt;size()))*num_nodes);
<a name="l00409"></a>00409 <span class="preprocessor">#else  </span>
<a name="l00410"></a>00410 <span class="preprocessor"></span>      ((3 + 3*((solution_names == NULL) ? 0 : solution_names-&gt;size()))*num_nodes);
<a name="l00411"></a>00411 <span class="preprocessor">#endif</span>
<a name="l00412"></a>00412 <span class="preprocessor"></span>
<a name="l00413"></a>00413     
<a name="l00414"></a>00414     ierr = TECDAT (&amp;total,
<a name="l00415"></a>00415                    &amp;tm.nodalData[0],
<a name="l00416"></a>00416                    &amp;is_double);
<a name="l00417"></a>00417     
<a name="l00418"></a>00418     libmesh_assert (ierr == 0);
<a name="l00419"></a>00419     
<a name="l00420"></a>00420     ierr = TECNOD (&amp;tm.connData[0]);
<a name="l00421"></a>00421     
<a name="l00422"></a>00422     libmesh_assert (ierr == 0);
<a name="l00423"></a>00423     
<a name="l00424"></a>00424     ierr = TECEND ();
<a name="l00425"></a>00425     
<a name="l00426"></a>00426     libmesh_assert (ierr == 0);
<a name="l00427"></a>00427   }
<a name="l00428"></a>00428       
<a name="l00429"></a>00429 <span class="preprocessor">#endif</span>
<a name="l00430"></a>00430 <span class="preprocessor"></span>}
<a name="l00431"></a>00431 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
