<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>tensor_shell_matrix.h</h1>  </div>
</div>
<div class="contents">
<a href="tensor__shell__matrix_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: tensor_shell_matrix.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __tensor_shell_matrix_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __tensor_shell_matrix_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;reference_counted_object.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="shell__matrix_8h.php">shell_matrix.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00040"></a>00040 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00041"></a><a class="code" href="classTensorShellMatrix.php">00041</a> <span class="keyword">class </span><a class="code" href="classTensorShellMatrix.php">TensorShellMatrix</a> : <span class="keyword">public</span> <a class="code" href="classShellMatrix.php">ShellMatrix</a>&lt;T&gt;
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043 <span class="keyword">public</span>:
<a name="l00048"></a>00048   <a class="code" href="classTensorShellMatrix.php#ae976fbf75aca744c3b5684ef29119c92">TensorShellMatrix</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v,
<a name="l00049"></a>00049                      <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; w);
<a name="l00050"></a>00050 
<a name="l00054"></a>00054   <span class="keyword">virtual</span> <a class="code" href="classTensorShellMatrix.php#ab6ffc469a9394e4c7473b2f4b84d34e4">~TensorShellMatrix</a> ();
<a name="l00055"></a>00055 
<a name="l00060"></a>00060   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTensorShellMatrix.php#ae4785259282fd8f1e6f392694ce3fedd">m</a> () <span class="keyword">const</span>;
<a name="l00061"></a>00061 
<a name="l00066"></a>00066   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTensorShellMatrix.php#abaf7d351a20cd5aeed5d2e01f7afcbe8">n</a> () <span class="keyword">const</span>;
<a name="l00067"></a>00067 
<a name="l00072"></a>00072   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classTensorShellMatrix.php#a0b77916ab0aaddac1df63a278c5f2d95">vector_mult</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest,
<a name="l00073"></a>00073                             <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; arg) <span class="keyword">const</span>;
<a name="l00074"></a>00074 
<a name="l00078"></a>00078   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classTensorShellMatrix.php#a00e6dfa4a019c6c678ba9d6364d530b1">vector_mult_add</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest,
<a name="l00079"></a>00079                                 <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; arg) <span class="keyword">const</span>;
<a name="l00080"></a>00080 
<a name="l00084"></a>00084   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classTensorShellMatrix.php#a98c228a36624ea65b25edfdedfe91daa">get_diagonal</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 <span class="keyword">protected</span>:
<a name="l00090"></a><a class="code" href="classTensorShellMatrix.php#a8dc59f48c25919e64a1e7afb5536deb0">00090</a>   <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; <a class="code" href="classTensorShellMatrix.php#a8dc59f48c25919e64a1e7afb5536deb0">_v</a>;
<a name="l00091"></a>00091 
<a name="l00095"></a><a class="code" href="classTensorShellMatrix.php#aa3c2c4451b2f28f429b9e3a15f3e4770">00095</a>   <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; <a class="code" href="classTensorShellMatrix.php#aa3c2c4451b2f28f429b9e3a15f3e4770">_w</a>;
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 };
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00102"></a>00102 <span class="comment">// TensorShellMatrix inline members</span>
<a name="l00103"></a>00103 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00104"></a>00104 <span class="keyword">inline</span>
<a name="l00105"></a><a class="code" href="classTensorShellMatrix.php#ae976fbf75aca744c3b5684ef29119c92">00105</a> <a class="code" href="classTensorShellMatrix.php#ae976fbf75aca744c3b5684ef29119c92">TensorShellMatrix&lt;T&gt;::TensorShellMatrix</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v,
<a name="l00106"></a>00106                                          <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; w):
<a name="l00107"></a>00107   <a class="code" href="classShellMatrix.php">ShellMatrix</a>&lt;T&gt;(),
<a name="l00108"></a>00108   _v(v),
<a name="l00109"></a>00109   _w(w)
<a name="l00110"></a>00110 {}
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00115"></a>00115 <span class="keyword">inline</span>
<a name="l00116"></a><a class="code" href="classTensorShellMatrix.php#ab6ffc469a9394e4c7473b2f4b84d34e4">00116</a> <a class="code" href="classTensorShellMatrix.php#ab6ffc469a9394e4c7473b2f4b84d34e4">TensorShellMatrix&lt;T&gt;::~TensorShellMatrix</a> ()
<a name="l00117"></a>00117 {}
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00122"></a>00122 <span class="keyword">inline</span>
<a name="l00123"></a><a class="code" href="classTensorShellMatrix.php#ae4785259282fd8f1e6f392694ce3fedd">00123</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTensorShellMatrix.php#ae4785259282fd8f1e6f392694ce3fedd">TensorShellMatrix&lt;T&gt;::m</a> ()<span class="keyword"> const</span>
<a name="l00124"></a>00124 <span class="keyword"></span>{
<a name="l00125"></a>00125   <span class="keywordflow">return</span> _v.size();
<a name="l00126"></a>00126 }
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00131"></a>00131 <span class="keyword">inline</span>
<a name="l00132"></a><a class="code" href="classTensorShellMatrix.php#abaf7d351a20cd5aeed5d2e01f7afcbe8">00132</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTensorShellMatrix.php#abaf7d351a20cd5aeed5d2e01f7afcbe8">TensorShellMatrix&lt;T&gt;::n</a> ()<span class="keyword"> const</span>
<a name="l00133"></a>00133 <span class="keyword"></span>{
<a name="l00134"></a>00134   <span class="keywordflow">return</span> _w.size();
<a name="l00135"></a>00135 }
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 <span class="preprocessor">#endif // #ifndef __tensor_shell_matrix_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
