<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>tetgen_io.C</h1>  </div>
</div>
<div class="contents">
<a href="tetgen__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: tetgen_io.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;tetgen_io.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;cell_tet4.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;cell_tet10.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;mesh_data.h&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00032"></a>00032 <span class="comment">// TetgenIO class members</span>
<a name="l00033"></a><a class="code" href="classTetGenIO.php#ad27081f540e0c173d8556631c82b1ca6">00033</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenIO.php#ad27081f540e0c173d8556631c82b1ca6">TetGenIO::read</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035   <span class="comment">// This is a serial-only process for now;</span>
<a name="l00036"></a>00036   <span class="comment">// the Mesh should be read on processor 0 and</span>
<a name="l00037"></a>00037   <span class="comment">// broadcast later</span>
<a name="l00038"></a>00038   libmesh_assert(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0);
<a name="l00039"></a>00039 
<a name="l00040"></a>00040   std::string name_node, name_ele, dummy;
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   <span class="comment">// tetgen only works in 3D</span>
<a name="l00043"></a>00043   libmesh_assert (<a class="code" href="classMeshInput.php">MeshInput&lt;MeshBase&gt;::mesh</a>().mesh_dimension() == 3);
<a name="l00044"></a>00044 
<a name="l00045"></a>00045   <span class="comment">// Check name for *.node or *.ele extension.</span>
<a name="l00046"></a>00046   <span class="comment">// Set std::istream for node_stream and ele_stream.</span>
<a name="l00047"></a>00047   <span class="comment">//</span>
<a name="l00048"></a>00048   <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.node&quot;</span>) &lt; name.size()) 
<a name="l00049"></a>00049     {
<a name="l00050"></a>00050       name_node = <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>;
<a name="l00051"></a>00051       dummy     = <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>;
<a name="l00052"></a>00052       <span class="keywordtype">int</span> position = dummy.rfind(<span class="stringliteral">&quot;.node&quot;</span>);
<a name="l00053"></a>00053       name_ele     = dummy.replace(position, 5, <span class="stringliteral">&quot;.ele&quot;</span>);
<a name="l00054"></a>00054     }
<a name="l00055"></a>00055   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.ele&quot;</span>) &lt; name.size()) 
<a name="l00056"></a>00056     {
<a name="l00057"></a>00057       name_ele = <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>;
<a name="l00058"></a>00058       dummy    = <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>;
<a name="l00059"></a>00059       <span class="keywordtype">int</span> position = dummy.rfind(<span class="stringliteral">&quot;.ele&quot;</span>);
<a name="l00060"></a>00060       name_node    = dummy.replace(position, 4, <span class="stringliteral">&quot;.node&quot;</span>);
<a name="l00061"></a>00061     }
<a name="l00062"></a>00062   <span class="keywordflow">else</span>
<a name="l00063"></a>00063     {
<a name="l00064"></a>00064       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Unrecognized file name: &quot;</span>
<a name="l00065"></a>00065                 &lt;&lt; name &lt;&lt; std::endl;
<a name="l00066"></a>00066       libmesh_error();
<a name="l00067"></a>00067     }
<a name="l00068"></a>00068         
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   
<a name="l00071"></a>00071   <span class="comment">// Set the streams from which to read in</span>
<a name="l00072"></a>00072   std::ifstream node_stream (name_node.c_str());
<a name="l00073"></a>00073   std::ifstream ele_stream  (name_ele.c_str());
<a name="l00074"></a>00074 
<a name="l00075"></a>00075   <span class="keywordflow">if</span> ( !node_stream.good() || !ele_stream.good() )
<a name="l00076"></a>00076     {
<a name="l00077"></a>00077       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: One or both Input file(s) not good.&quot;</span> &lt;&lt; std::endl
<a name="l00078"></a>00078                 &lt;&lt; <span class="stringliteral">&quot;Error checking files &quot;</span>
<a name="l00079"></a>00079                 &lt;&lt; name_node &lt;&lt; <span class="stringliteral">&quot; and &quot;</span>
<a name="l00080"></a>00080                 &lt;&lt; name_ele  &lt;&lt; std::endl;
<a name="l00081"></a>00081       libmesh_error();
<a name="l00082"></a>00082     }
<a name="l00083"></a>00083   std::cout&lt;&lt; <span class="stringliteral">&quot;found the tetgen files to read &quot;</span> &lt;&lt;std::endl; 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="comment">// Skip the comment lines at the beginning</span>
<a name="l00086"></a>00086   this-&gt;<a class="code" href="classMeshInput.php#a1261f0e7a0d6284c4a1e321d13c3c3ec">skip_comment_lines</a> (node_stream, <span class="charliteral">&#39;#&#39;</span>);
<a name="l00087"></a>00087   this-&gt;<a class="code" href="classMeshInput.php#a1261f0e7a0d6284c4a1e321d13c3c3ec">skip_comment_lines</a> (ele_stream, <span class="charliteral">&#39;#&#39;</span>);
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   <span class="comment">// Read the nodes and elements from the streams</span>
<a name="l00090"></a>00090   this-&gt;<a class="code" href="classTetGenIO.php#a1e9ec8c04c14233cfec4c87d659580b9">read_nodes_and_elem</a> (node_stream, ele_stream);
<a name="l00091"></a>00091   std::cout&lt;&lt; <span class="stringliteral">&quot;read in nodes and elements &quot;</span> &lt;&lt;std::endl; 
<a name="l00092"></a>00092 }
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a><a class="code" href="classTetGenIO.php#a1e9ec8c04c14233cfec4c87d659580b9">00096</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenIO.php#a1e9ec8c04c14233cfec4c87d659580b9">TetGenIO::read_nodes_and_elem</a> (std::istream&amp; node_stream,
<a name="l00097"></a>00097                                     std::istream&amp; ele_stream)
<a name="l00098"></a>00098 {
<a name="l00099"></a>00099   <a class="code" href="classTetGenIO.php#a4c7065d492107a14a855c5b869e112ce">_num_nodes</a>    = 0;
<a name="l00100"></a>00100   <a class="code" href="classTetGenIO.php#ae9426109b256ddba1a676384c6dd1864">_num_elements</a> = 0;
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   <span class="comment">// Read all the datasets.</span>
<a name="l00103"></a>00103   this-&gt;<a class="code" href="classTetGenIO.php#a218128742d2cf04d93faff7063ca8b88">node_in</a>    (node_stream);
<a name="l00104"></a>00104   this-&gt;<a class="code" href="classTetGenIO.php#a6fc65c3f080cd613a514bda30785490e">element_in</a> (ele_stream);
<a name="l00105"></a>00105 
<a name="l00106"></a>00106   <span class="comment">// Tell the MeshData object that we are finished </span>
<a name="l00107"></a>00107   <span class="comment">// reading data.</span>
<a name="l00108"></a>00108   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classTetGenIO.php#a79afeae19549d2d452f7d5161bdbec0a">_mesh_data</a> != NULL)
<a name="l00109"></a>00109     this-&gt;<a class="code" href="classTetGenIO.php#a79afeae19549d2d452f7d5161bdbec0a">_mesh_data</a>-&gt;<a class="code" href="classMeshData.php#a3cec8b434c51b58caec642d978c64ab4">close_foreign_id_maps</a> ();
<a name="l00110"></a>00110 
<a name="l00111"></a>00111   <span class="comment">// some more clean-up</span>
<a name="l00112"></a>00112   <a class="code" href="classTetGenIO.php#a17cfae44233cf84a363779c6cb7e0085">_assign_nodes</a>.clear();
<a name="l00113"></a>00113 }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 <span class="comment">//----------------------------------------------------------------------</span>
<a name="l00118"></a>00118 <span class="comment">// Function to read in the node table.</span>
<a name="l00119"></a><a class="code" href="classTetGenIO.php#a218128742d2cf04d93faff7063ca8b88">00119</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenIO.php#a218128742d2cf04d93faff7063ca8b88">TetGenIO::node_in</a> (std::istream&amp; node_stream)
<a name="l00120"></a>00120 {
<a name="l00121"></a>00121   <span class="comment">// Check input buffer</span>
<a name="l00122"></a>00122   libmesh_assert (node_stream.good());
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <span class="comment">// Get a reference to the mesh</span>
<a name="l00125"></a>00125   <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00126"></a>00126   
<a name="l00127"></a>00127   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dimension=0, nAttributes=0, BoundaryMarkers=0;
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   node_stream &gt;&gt; <a class="code" href="classTetGenIO.php#a4c7065d492107a14a855c5b869e112ce">_num_nodes</a>       <span class="comment">// Read the number of nodes from the stream</span>
<a name="l00130"></a>00130               &gt;&gt; dimension        <span class="comment">// Read the dimension from the stream</span>
<a name="l00131"></a>00131               &gt;&gt; nAttributes      <span class="comment">// Read the number of attributes from stream</span>
<a name="l00132"></a>00132               &gt;&gt; BoundaryMarkers; <span class="comment">// Read if or not boundary markers are included in *.node (0 or 1)</span>
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   <span class="comment">// Read the nodal coordinates from the node_stream (*.node file).</span>
<a name="l00135"></a>00135   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_lab=0;
<a name="l00136"></a>00136   <a class="code" href="classPoint.php">Point</a> xyz;
<a name="l00137"></a>00137   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> dummy;
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classTetGenIO.php#a4c7065d492107a14a855c5b869e112ce">_num_nodes</a>; i++)
<a name="l00140"></a>00140     {
<a name="l00141"></a>00141       <span class="comment">// Check input buffer</span>
<a name="l00142"></a>00142       libmesh_assert (node_stream.good());
<a name="l00143"></a>00143       
<a name="l00144"></a>00144       node_stream &gt;&gt; node_lab  <span class="comment">// node number</span>
<a name="l00145"></a>00145                   &gt;&gt; xyz(0)    <span class="comment">// x-coordinate value</span>
<a name="l00146"></a>00146                   &gt;&gt; xyz(1)    <span class="comment">// y-coordinate value</span>
<a name="l00147"></a>00147                   &gt;&gt; xyz(2);   <span class="comment">// z-coordinate value</span>
<a name="l00148"></a>00148 
<a name="l00149"></a>00149       <span class="comment">// For the number of attributes read all into dummy.</span>
<a name="l00150"></a>00150       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;nAttributes; j++)
<a name="l00151"></a>00151         node_stream &gt;&gt; dummy;
<a name="l00152"></a>00152       
<a name="l00153"></a>00153       <span class="comment">// Read boundary marker if BoundaryMarker=1.</span>
<a name="l00154"></a>00154       <span class="keywordflow">if</span> (BoundaryMarkers == 1)
<a name="l00155"></a>00155         node_stream &gt;&gt; dummy;
<a name="l00156"></a>00156 
<a name="l00157"></a>00157       <span class="comment">// Store the new position of the node under its label.</span>
<a name="l00158"></a>00158       <span class="comment">//_assign_nodes.insert (std::make_pair(node_lab,i));</span>
<a name="l00159"></a>00159       <a class="code" href="classTetGenIO.php#a17cfae44233cf84a363779c6cb7e0085">_assign_nodes</a>[node_lab] = i;
<a name="l00160"></a>00160 
<a name="l00161"></a>00161       <span class="comment">// do this irrespective whether MeshData exists</span>
<a name="l00162"></a>00162       <a class="code" href="classNode.php">Node</a>* newnode = mesh.add_point(xyz, i);
<a name="l00163"></a>00163 
<a name="l00164"></a>00164       <span class="comment">// Add node to the nodes vector &amp;</span>
<a name="l00165"></a>00165       <span class="comment">// tell the MeshData object the foreign node id.</span>
<a name="l00166"></a>00166       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classTetGenIO.php#a79afeae19549d2d452f7d5161bdbec0a">_mesh_data</a> != NULL)
<a name="l00167"></a>00167         this-&gt;<a class="code" href="classTetGenIO.php#a79afeae19549d2d452f7d5161bdbec0a">_mesh_data</a>-&gt;<a class="code" href="classMeshData.php#af408db231805974db975dbdf3c1756f5">add_foreign_node_id</a> (newnode, node_lab);
<a name="l00168"></a>00168     }
<a name="l00169"></a>00169 }
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 <span class="comment">//----------------------------------------------------------------------</span>
<a name="l00174"></a>00174 <span class="comment">// Function to read in the element table.</span>
<a name="l00175"></a><a class="code" href="classTetGenIO.php#a6fc65c3f080cd613a514bda30785490e">00175</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenIO.php#a6fc65c3f080cd613a514bda30785490e">TetGenIO::element_in</a> (std::istream&amp; ele_stream)
<a name="l00176"></a>00176 {
<a name="l00177"></a>00177   <span class="comment">// Check input buffer</span>
<a name="l00178"></a>00178   libmesh_assert (ele_stream.good());
<a name="l00179"></a>00179 
<a name="l00180"></a>00180   <span class="comment">// Get a reference to the mesh</span>
<a name="l00181"></a>00181   <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   <span class="comment">// Read the elements from the ele_stream (*.ele file). </span>
<a name="l00184"></a>00184   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> element_lab=0, <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>=0, nAttri=0;
<a name="l00185"></a>00185   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> dummy=0.0;
<a name="l00186"></a>00186 
<a name="l00187"></a>00187   ele_stream &gt;&gt; <a class="code" href="classTetGenIO.php#ae9426109b256ddba1a676384c6dd1864">_num_elements</a> <span class="comment">// Read the number of tetrahedrons from the stream.</span>
<a name="l00188"></a>00188              &gt;&gt; <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>       <span class="comment">// Read the number of nodes per tetrahedron from the stream (defaults to 4).</span>
<a name="l00189"></a>00189              &gt;&gt; nAttri;       <span class="comment">// Read the number of attributes from stream.</span>
<a name="l00190"></a>00190 
<a name="l00191"></a>00191   <span class="comment">// Vector that assigns element nodes to their correct position.</span>
<a name="l00192"></a>00192   <span class="comment">// TetGen is normaly 0-based</span>
<a name="l00193"></a>00193   <span class="comment">// (right now this is strictly not necessary since it is the identity map,</span>
<a name="l00194"></a>00194   <span class="comment">//  but in the future TetGen could change their numbering scheme.)</span>
<a name="l00195"></a>00195   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> assign_elm_nodes[] = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9};
<a name="l00196"></a>00196 
<a name="l00197"></a>00197   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classTetGenIO.php#ae9426109b256ddba1a676384c6dd1864">_num_elements</a>; i++)
<a name="l00198"></a>00198     {
<a name="l00199"></a>00199       libmesh_assert (ele_stream.good());
<a name="l00200"></a>00200       
<a name="l00201"></a>00201       <span class="comment">// TetGen only supports Tet4 and Tet10 elements.</span>
<a name="l00202"></a>00202       <a class="code" href="classElem.php">Elem</a>* elem;
<a name="l00203"></a>00203       
<a name="l00204"></a>00204       <span class="keywordflow">if</span> (<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>==4)
<a name="l00205"></a>00205         elem = <span class="keyword">new</span> <a class="code" href="classTet4.php">Tet4</a>;
<a name="l00206"></a>00206       
<a name="l00207"></a>00207       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>==10)
<a name="l00208"></a>00208         elem = <span class="keyword">new</span> <a class="code" href="classTet10.php">Tet10</a>;
<a name="l00209"></a>00209       
<a name="l00210"></a>00210       <span class="keywordflow">else</span>
<a name="l00211"></a>00211         {
<a name="l00212"></a>00212           std::cerr &lt;&lt; <span class="stringliteral">&quot;Elements with &quot;</span> &lt;&lt; <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>
<a name="l00213"></a>00213                     &lt;&lt; <span class="stringliteral">&quot; nodes are not supported in the LibMesh tetgen module\n&quot;</span>;
<a name="l00214"></a>00214           libmesh_error();
<a name="l00215"></a>00215         }
<a name="l00216"></a>00216       elem-&gt;set_id(i);
<a name="l00217"></a>00217       mesh.add_elem (elem);
<a name="l00218"></a>00218 
<a name="l00219"></a>00219       libmesh_assert (elem != NULL);
<a name="l00220"></a>00220       libmesh_assert (elem-&gt;n_nodes() == <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>);
<a name="l00221"></a>00221 
<a name="l00222"></a>00222       <span class="comment">// Read the element label</span>
<a name="l00223"></a>00223       ele_stream &gt;&gt; element_lab;
<a name="l00224"></a>00224 
<a name="l00225"></a>00225       <span class="comment">// Add the element to the mesh &amp;</span>
<a name="l00226"></a>00226       <span class="comment">// tell the MeshData object the foreign element id</span>
<a name="l00227"></a>00227       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classTetGenIO.php#a79afeae19549d2d452f7d5161bdbec0a">_mesh_data</a> != NULL)
<a name="l00228"></a>00228         this-&gt;<a class="code" href="classTetGenIO.php#a79afeae19549d2d452f7d5161bdbec0a">_mesh_data</a>-&gt;<a class="code" href="classMeshData.php#acf27873beae104e2109db6c93de7efa9">add_foreign_elem_id</a> (elem, element_lab);
<a name="l00229"></a>00229       
<a name="l00230"></a>00230       <span class="comment">// Read node labels</span>
<a name="l00231"></a>00231       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>; j++)
<a name="l00232"></a>00232         {
<a name="l00233"></a>00233           <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> node_label;
<a name="l00234"></a>00234           ele_stream &gt;&gt; node_label;
<a name="l00235"></a>00235 
<a name="l00236"></a>00236           <span class="comment">// Assign node to element</span>
<a name="l00237"></a>00237           elem-&gt;set_node(assign_elm_nodes[j]) =
<a name="l00238"></a>00238             mesh.node_ptr(<a class="code" href="classTetGenIO.php#a17cfae44233cf84a363779c6cb7e0085">_assign_nodes</a>[node_label]);
<a name="l00239"></a>00239         }
<a name="l00240"></a>00240 
<a name="l00241"></a>00241       <span class="comment">// Read attributes from the stream.</span>
<a name="l00242"></a>00242       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;nAttri; j++)
<a name="l00243"></a>00243         ele_stream &gt;&gt; dummy;
<a name="l00244"></a>00244     }
<a name="l00245"></a>00245 }
<a name="l00246"></a>00246 
<a name="l00247"></a>00247 
<a name="l00252"></a><a class="code" href="classTetGenIO.php#af06d105f3996ab0c51b9e9ea779542cf">00252</a> <span class="keywordtype">void</span> <a class="code" href="classTetGenIO.php#af06d105f3996ab0c51b9e9ea779542cf">TetGenIO::write</a> (<span class="keyword">const</span> std::string&amp; fname)
<a name="l00253"></a>00253 {
<a name="l00254"></a>00254   <span class="comment">// libmesh_assert three dimensions (should be extended later)</span>
<a name="l00255"></a>00255   libmesh_assert (<a class="code" href="classMeshOutput.php">MeshOutput&lt;MeshBase&gt;::mesh</a>().mesh_dimension() == 3);
<a name="l00256"></a>00256 
<a name="l00257"></a>00257   <span class="keywordflow">if</span> (!(fname.rfind(<span class="stringliteral">&quot;.poly&quot;</span>) &lt; fname.size())) 
<a name="l00258"></a>00258     {
<a name="l00259"></a>00259       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Unrecognized file name: &quot;</span>
<a name="l00260"></a>00260                 &lt;&lt; fname &lt;&lt; std::endl;
<a name="l00261"></a>00261       libmesh_error();
<a name="l00262"></a>00262     }
<a name="l00263"></a>00263 
<a name="l00264"></a>00264   <span class="comment">// Open the output file stream</span>
<a name="l00265"></a>00265   std::ofstream out (fname.c_str());
<a name="l00266"></a>00266   
<a name="l00267"></a>00267   <span class="comment">// Make sure it opened correctly</span>
<a name="l00268"></a>00268   <span class="keywordflow">if</span> (!out.good())
<a name="l00269"></a>00269     libmesh_file_error(fname.c_str());
<a name="l00270"></a>00270 
<a name="l00271"></a>00271   <span class="comment">// Get a reference to the mesh</span>
<a name="l00272"></a>00272   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00273"></a>00273   
<a name="l00274"></a>00274   <span class="comment">// Begin interfacing with the .poly file</span>
<a name="l00275"></a>00275   {
<a name="l00276"></a>00276     <span class="comment">// header:</span>
<a name="l00277"></a>00277     out &lt;&lt; <span class="stringliteral">&quot;# poly file output generated by libmesh\n&quot;</span>
<a name="l00278"></a>00278         &lt;&lt; mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>() &lt;&lt; <span class="stringliteral">&quot; 3 0 0\n&quot;</span>;
<a name="l00279"></a>00279 
<a name="l00280"></a>00280     <span class="comment">// write the nodes:</span>
<a name="l00281"></a>00281     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>(); v++)
<a name="l00282"></a>00282       out &lt;&lt; v &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00283"></a>00283           &lt;&lt; mesh.<a class="code" href="classMeshBase.php#a06af1f178519c606d0bdca7857f95ba6">point</a>(v)(0) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00284"></a>00284           &lt;&lt; mesh.<a class="code" href="classMeshBase.php#a06af1f178519c606d0bdca7857f95ba6">point</a>(v)(1) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00285"></a>00285           &lt;&lt; mesh.<a class="code" href="classMeshBase.php#a06af1f178519c606d0bdca7857f95ba6">point</a>(v)(2) &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00286"></a>00286   }
<a name="l00287"></a>00287 
<a name="l00288"></a>00288   {
<a name="l00289"></a>00289     <span class="comment">// write the connectivity:</span>
<a name="l00290"></a>00290     out &lt;&lt; <span class="stringliteral">&quot;# Facets:\n&quot;</span>
<a name="l00291"></a>00291         &lt;&lt; mesh.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>() &lt;&lt; <span class="stringliteral">&quot; 0\n&quot;</span>;
<a name="l00292"></a>00292     
<a name="l00293"></a>00293 <span class="comment">//     const_active_elem_iterator       it (mesh.elements_begin());</span>
<a name="l00294"></a>00294 <span class="comment">//     const const_active_elem_iterator end(mesh.elements_end());</span>
<a name="l00295"></a>00295 
<a name="l00296"></a>00296     <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00297"></a>00297     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00298"></a>00298       
<a name="l00299"></a>00299     <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l00300"></a>00300       out &lt;&lt; <span class="stringliteral">&quot;1\n3 &quot;</span> <span class="comment">// no. of facet polygons</span>
<a name="l00301"></a>00301         <span class="comment">//        &lt;&lt; (*it)-&gt;n_nodes() &lt;&lt; &quot; &quot;</span>
<a name="l00302"></a>00302           &lt;&lt; (*it)-&gt;node(0)   &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00303"></a>00303           &lt;&lt; (*it)-&gt;node(1)   &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00304"></a>00304           &lt;&lt; (*it)-&gt;node(2)   &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00305"></a>00305   }  
<a name="l00306"></a>00306 
<a name="l00307"></a>00307   <span class="comment">// end of the file</span>
<a name="l00308"></a>00308   out &lt;&lt; <span class="stringliteral">&quot;0\n&quot;</span>; <span class="comment">// no holes output!</span>
<a name="l00309"></a>00309   out &lt;&lt; <span class="stringliteral">&quot;\n\n# end of file\n&quot;</span>;
<a name="l00310"></a>00310 }
<a name="l00311"></a>00311 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
