<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>tetgen_io.h</h1>  </div>
</div>
<div class="contents">
<a href="tetgen__io_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: tetgen_io.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __tetgen_io_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __tetgen_io_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="mesh__input_8h.php">mesh_input.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="mesh__output_8h.php">mesh_output.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Forward declarations</span>
<a name="l00034"></a>00034 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00035"></a>00035 <span class="keyword">class </span><a class="code" href="classMeshData.php">MeshData</a>;
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00046"></a>00046 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00047"></a>00047 <span class="comment">// TetGenIO class definition</span>
<a name="l00048"></a><a class="code" href="classTetGenIO.php">00048</a> <span class="keyword">class </span><a class="code" href="classTetGenIO.php">TetGenIO</a> : <span class="keyword">public</span> <a class="code" href="classMeshInput.php">MeshInput</a>&lt;MeshBase&gt;,
<a name="l00049"></a>00049                  <span class="keyword">public</span> <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;MeshBase&gt;
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051  <span class="keyword">public</span>:
<a name="l00052"></a>00052   
<a name="l00057"></a>00057   <a class="code" href="classTetGenIO.php#a38bbbb012a052b92065bce364450f99f">TetGenIO</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a>, <a class="code" href="classMeshData.php">MeshData</a>* mesh_data=NULL);
<a name="l00058"></a>00058   
<a name="l00063"></a>00063   <a class="code" href="classTetGenIO.php#a38bbbb012a052b92065bce364450f99f">TetGenIO</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh, <a class="code" href="classMeshData.php">MeshData</a>* mesh_data=NULL);
<a name="l00064"></a>00064   
<a name="l00069"></a>00069   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classTetGenIO.php#ad27081f540e0c173d8556631c82b1ca6">read</a> (<span class="keyword">const</span> std::string&amp; );
<a name="l00070"></a>00070 
<a name="l00075"></a>00075   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classTetGenIO.php#af06d105f3996ab0c51b9e9ea779542cf">write</a> (<span class="keyword">const</span> std::string&amp; );  
<a name="l00076"></a>00076 
<a name="l00077"></a>00077  <span class="keyword">private</span>:
<a name="l00078"></a>00078  
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00081"></a>00081   <span class="comment">// read support methods</span>
<a name="l00082"></a>00082 
<a name="l00087"></a>00087   <span class="keywordtype">void</span> <a class="code" href="classTetGenIO.php#a1e9ec8c04c14233cfec4c87d659580b9">read_nodes_and_elem</a> (std::istream&amp; node_stream,
<a name="l00088"></a>00088                             std::istream&amp; ele_stream);
<a name="l00089"></a>00089 
<a name="l00099"></a>00099   <span class="keywordtype">void</span> <a class="code" href="classTetGenIO.php#a218128742d2cf04d93faff7063ca8b88">node_in</a> (std::istream&amp; node_stream);
<a name="l00100"></a>00100 
<a name="l00108"></a>00108   <span class="keywordtype">void</span> <a class="code" href="classTetGenIO.php#a6fc65c3f080cd613a514bda30785490e">element_in</a> (std::istream&amp; ele_stream);
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00111"></a>00111   <span class="comment">// local data</span>
<a name="l00112"></a>00112 
<a name="l00116"></a><a class="code" href="classTetGenIO.php#a17cfae44233cf84a363779c6cb7e0085">00116</a>   std::map&lt;unsigned int,unsigned int&gt; <a class="code" href="classTetGenIO.php#a17cfae44233cf84a363779c6cb7e0085">_assign_nodes</a>; 
<a name="l00117"></a>00117 
<a name="l00121"></a><a class="code" href="classTetGenIO.php#a4c7065d492107a14a855c5b869e112ce">00121</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTetGenIO.php#a4c7065d492107a14a855c5b869e112ce">_num_nodes</a>;
<a name="l00122"></a>00122 
<a name="l00126"></a><a class="code" href="classTetGenIO.php#ae9426109b256ddba1a676384c6dd1864">00126</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTetGenIO.php#ae9426109b256ddba1a676384c6dd1864">_num_elements</a>;
<a name="l00127"></a>00127 
<a name="l00132"></a><a class="code" href="classTetGenIO.php#a79afeae19549d2d452f7d5161bdbec0a">00132</a>   <a class="code" href="classMeshData.php">MeshData</a>* <a class="code" href="classTetGenIO.php#a79afeae19549d2d452f7d5161bdbec0a">_mesh_data</a>;
<a name="l00133"></a>00133 };
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00138"></a>00138 <span class="comment">// TetGenIO inline members</span>
<a name="l00139"></a>00139 <span class="keyword">inline</span>
<a name="l00140"></a><a class="code" href="classTetGenIO.php#a38bbbb012a052b92065bce364450f99f">00140</a> <a class="code" href="classTetGenIO.php#a38bbbb012a052b92065bce364450f99f">TetGenIO::TetGenIO</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh, <a class="code" href="classMeshData.php">MeshData</a>* mesh_data) :
<a name="l00141"></a>00141   <a class="code" href="classMeshInput.php">MeshInput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt; (mesh),
<a name="l00142"></a>00142   <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt;(mesh),
<a name="l00143"></a>00143   _mesh_data(mesh_data)
<a name="l00144"></a>00144 {
<a name="l00145"></a>00145 }
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 <span class="keyword">inline</span>
<a name="l00150"></a><a class="code" href="classTetGenIO.php#adafbda74a984a4ec1108663c40ba33e3">00150</a> <a class="code" href="classTetGenIO.php#a38bbbb012a052b92065bce364450f99f">TetGenIO::TetGenIO</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh, <a class="code" href="classMeshData.php">MeshData</a>* mesh_data) :
<a name="l00151"></a>00151   <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt;(mesh),
<a name="l00152"></a>00152   _mesh_data(mesh_data)
<a name="l00153"></a>00153 {
<a name="l00154"></a>00154 }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 <span class="preprocessor">#endif // #define __tetgen_io_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
