<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_68b326994b1686b0c255607250545e3c.php">parallel</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>threads.h</h1>  </div>
</div>
<div class="contents">
<a href="threads_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: threads.h 3448 2009-08-19 16:56:42Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __threads_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __threads_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// System includes</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Threading building blocks includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#ifdef LIBMESH_HAVE_TBB_API</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#  include &quot;libmesh_logging.h&quot;</span> <span class="comment">// only mess with the perflog if we are really multithreaded</span>
<a name="l00032"></a>00032 <span class="preprocessor">#  include &quot;tbb/tbb_stddef.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#  include &quot;tbb/blocked_range.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#  include &quot;tbb/parallel_for.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#  include &quot;tbb/parallel_reduce.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#  include &quot;tbb/task_scheduler_init.h&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#  include &quot;tbb/partitioner.h&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#  include &quot;tbb/spin_mutex.h&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#  include &quot;tbb/atomic.h&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#endif</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span>
<a name="l00042"></a>00042 
<a name="l00047"></a><a class="code" href="namespaceThreads.php">00047</a> <span class="keyword">namespace </span>Threads
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 <span class="preprocessor">#ifdef LIBMESH_HAVE_TBB_API</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span>  <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00055"></a><a class="code" href="namespaceThreads.php#ac48feb4b167306b34ced461abf95d4bf">00055</a> <span class="comment"></span>  <span class="keyword">typedef</span> <a class="code" href="namespaceThreads.php#ac48feb4b167306b34ced461abf95d4bf">tbb::task_scheduler_init</a> <a class="code" href="namespaceThreads.php#ac48feb4b167306b34ced461abf95d4bf">task_scheduler_init</a>;
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 
<a name="l00059"></a>00059   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00064"></a><a class="code" href="namespaceThreads.php#aeae742023033350339ff01e0838d3008">00064</a> <span class="comment"></span>  <span class="keyword">typedef</span> <a class="code" href="namespaceThreads.php#aeae742023033350339ff01e0838d3008">tbb::split</a> <a class="code" href="namespaceThreads.php#aeae742023033350339ff01e0838d3008">split</a>;
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00073"></a>00073 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Range, <span class="keyword">typename</span> Body&gt;
<a name="l00074"></a>00074   <span class="keyword">inline</span>
<a name="l00075"></a><a class="code" href="namespaceThreads.php#a9eb02a1b3f006c37843c907a3b5c0581">00075</a>   <span class="keywordtype">void</span> <a class="code" href="namespaceThreads.php#a9eb02a1b3f006c37843c907a3b5c0581">parallel_for</a> (<span class="keyword">const</span> Range &amp;range, <span class="keyword">const</span> Body &amp;body)
<a name="l00076"></a>00076   {
<a name="l00077"></a>00077 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERFORMANCE_LOGGING</span>
<a name="l00078"></a>00078 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() &gt; 1)
<a name="l00079"></a>00079       <a class="code" href="namespacelibMesh.php#a596320f881a18177dbac88a97bab807e">libMesh::perflog</a>.<a class="code" href="classPerfLog.php#a838a1bbf3549a41d07fd60c2c8e32de4">disable_logging</a>();
<a name="l00080"></a>00080 <span class="preprocessor">#endif   </span>
<a name="l00081"></a>00081 <span class="preprocessor"></span>
<a name="l00082"></a>00082     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() &gt; 1)
<a name="l00083"></a>00083       <a class="code" href="namespaceThreads.php#a9eb02a1b3f006c37843c907a3b5c0581">tbb::parallel_for</a> (range, body, tbb::auto_partitioner());
<a name="l00084"></a>00084 
<a name="l00085"></a>00085     <span class="keywordflow">else</span> 
<a name="l00086"></a>00086       body(range);
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERFORMANCE_LOGGING</span>
<a name="l00089"></a>00089 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() &gt; 1)
<a name="l00090"></a>00090       <a class="code" href="namespacelibMesh.php#a596320f881a18177dbac88a97bab807e">libMesh::perflog</a>.<a class="code" href="classPerfLog.php#aeef4a343213cc476c5750029085f0d4a">enable_logging</a>();
<a name="l00091"></a>00091 <span class="preprocessor">#endif</span>
<a name="l00092"></a>00092 <span class="preprocessor"></span>  }
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00101"></a>00101 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Range, <span class="keyword">typename</span> Body, <span class="keyword">typename</span> Partitioner&gt;
<a name="l00102"></a>00102   <span class="keyword">inline</span>
<a name="l00103"></a><a class="code" href="namespaceThreads.php#a9fd19c2ff7865d822c7678ebb990fda1">00103</a>   <span class="keywordtype">void</span> <a class="code" href="namespaceThreads.php#a9eb02a1b3f006c37843c907a3b5c0581">parallel_for</a> (<span class="keyword">const</span> Range &amp;range, <span class="keyword">const</span> Body &amp;body, <span class="keyword">const</span> <a class="code" href="classPartitioner.php">Partitioner</a> &amp;partitioner)
<a name="l00104"></a>00104   { 
<a name="l00105"></a>00105 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERFORMANCE_LOGGING</span>
<a name="l00106"></a>00106 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() &gt; 1)
<a name="l00107"></a>00107       <a class="code" href="namespacelibMesh.php#a596320f881a18177dbac88a97bab807e">libMesh::perflog</a>.<a class="code" href="classPerfLog.php#a838a1bbf3549a41d07fd60c2c8e32de4">disable_logging</a>();
<a name="l00108"></a>00108 <span class="preprocessor">#endif   </span>
<a name="l00109"></a>00109 <span class="preprocessor"></span>    
<a name="l00110"></a>00110     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() &gt; 1)
<a name="l00111"></a>00111       <a class="code" href="namespaceThreads.php#a9eb02a1b3f006c37843c907a3b5c0581">tbb::parallel_for</a> (range, body, partitioner); 
<a name="l00112"></a>00112 
<a name="l00113"></a>00113     <span class="keywordflow">else</span>
<a name="l00114"></a>00114       body(range);
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERFORMANCE_LOGGING</span>
<a name="l00117"></a>00117 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() &gt; 1)
<a name="l00118"></a>00118       <a class="code" href="namespacelibMesh.php#a596320f881a18177dbac88a97bab807e">libMesh::perflog</a>.<a class="code" href="classPerfLog.php#aeef4a343213cc476c5750029085f0d4a">enable_logging</a>();
<a name="l00119"></a>00119 <span class="preprocessor">#endif</span>
<a name="l00120"></a>00120 <span class="preprocessor"></span>  }
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00129"></a>00129 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Range, <span class="keyword">typename</span> Body&gt;
<a name="l00130"></a>00130   <span class="keyword">inline</span>
<a name="l00131"></a><a class="code" href="namespaceThreads.php#a5957a49c5a5b3a757b655cb6f8a2d933">00131</a>   <span class="keywordtype">void</span> <a class="code" href="namespaceThreads.php#a5957a49c5a5b3a757b655cb6f8a2d933">parallel_reduce</a> (<span class="keyword">const</span> Range &amp;range, Body &amp;body)
<a name="l00132"></a>00132   { 
<a name="l00133"></a>00133 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERFORMANCE_LOGGING</span>
<a name="l00134"></a>00134 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() &gt; 1)
<a name="l00135"></a>00135       <a class="code" href="namespacelibMesh.php#a596320f881a18177dbac88a97bab807e">libMesh::perflog</a>.<a class="code" href="classPerfLog.php#a838a1bbf3549a41d07fd60c2c8e32de4">disable_logging</a>();
<a name="l00136"></a>00136 <span class="preprocessor">#endif   </span>
<a name="l00137"></a>00137 <span class="preprocessor"></span>
<a name="l00138"></a>00138     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() &gt; 1)
<a name="l00139"></a>00139       <a class="code" href="namespaceThreads.php#a5957a49c5a5b3a757b655cb6f8a2d933">tbb::parallel_reduce</a> (range, body, tbb::auto_partitioner()); 
<a name="l00140"></a>00140 
<a name="l00141"></a>00141     <span class="keywordflow">else</span>
<a name="l00142"></a>00142       body(range);
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERFORMANCE_LOGGING</span>
<a name="l00145"></a>00145 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() &gt; 1)
<a name="l00146"></a>00146       <a class="code" href="namespacelibMesh.php#a596320f881a18177dbac88a97bab807e">libMesh::perflog</a>.<a class="code" href="classPerfLog.php#aeef4a343213cc476c5750029085f0d4a">enable_logging</a>();
<a name="l00147"></a>00147 <span class="preprocessor">#endif</span>
<a name="l00148"></a>00148 <span class="preprocessor"></span>  }
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00152"></a>00152   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00157"></a>00157 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Range, <span class="keyword">typename</span> Body, <span class="keyword">typename</span> Partitioner&gt;
<a name="l00158"></a>00158   <span class="keyword">inline</span>
<a name="l00159"></a><a class="code" href="namespaceThreads.php#abab7f883432d528dde16d02a6992e615">00159</a>   <span class="keywordtype">void</span> <a class="code" href="namespaceThreads.php#a5957a49c5a5b3a757b655cb6f8a2d933">parallel_reduce</a> (<span class="keyword">const</span> Range &amp;range, Body &amp;body, <span class="keyword">const</span> <a class="code" href="classPartitioner.php">Partitioner</a> &amp;partitioner)
<a name="l00160"></a>00160   { 
<a name="l00161"></a>00161 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERFORMANCE_LOGGING</span>
<a name="l00162"></a>00162 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() &gt; 1)
<a name="l00163"></a>00163       <a class="code" href="namespacelibMesh.php#a596320f881a18177dbac88a97bab807e">libMesh::perflog</a>.<a class="code" href="classPerfLog.php#a838a1bbf3549a41d07fd60c2c8e32de4">disable_logging</a>();
<a name="l00164"></a>00164 <span class="preprocessor">#endif   </span>
<a name="l00165"></a>00165 <span class="preprocessor"></span>
<a name="l00166"></a>00166        <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() &gt; 1)
<a name="l00167"></a>00167          <a class="code" href="namespaceThreads.php#a5957a49c5a5b3a757b655cb6f8a2d933">tbb::parallel_reduce</a> (range, body); 
<a name="l00168"></a>00168 
<a name="l00169"></a>00169        <span class="keywordflow">else</span>
<a name="l00170"></a>00170          body(range);
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERFORMANCE_LOGGING</span>
<a name="l00173"></a>00173 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() &gt; 1)
<a name="l00174"></a>00174       <a class="code" href="namespacelibMesh.php#a596320f881a18177dbac88a97bab807e">libMesh::perflog</a>.<a class="code" href="classPerfLog.php#aeef4a343213cc476c5750029085f0d4a">enable_logging</a>();
<a name="l00175"></a>00175 <span class="preprocessor">#endif</span>
<a name="l00176"></a>00176 <span class="preprocessor"></span>  }
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 
<a name="l00180"></a>00180   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00185"></a><a class="code" href="namespaceThreads.php#ae15584704f9f23313b761bd42a3e5095">00185</a> <span class="comment"></span>  <span class="keyword">typedef</span> <a class="code" href="namespaceThreads.php#ae15584704f9f23313b761bd42a3e5095">tbb::spin_mutex</a> <a class="code" href="namespaceThreads.php#ae15584704f9f23313b761bd42a3e5095">spin_mutex</a>;
<a name="l00186"></a>00186 
<a name="l00187"></a>00187   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00193"></a>00193 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00194"></a><a class="code" href="classThreads_1_1atomic.php">00194</a>   <span class="keyword">class </span><a class="code" href="classThreads_1_1atomic.php">atomic</a> : <span class="keyword">public</span> tbb::<a class="code" href="classThreads_1_1atomic.php">atomic</a>&lt;T&gt; {};
<a name="l00195"></a>00195 
<a name="l00196"></a>00196   
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 <span class="preprocessor">#else //LIBMESH_HAVE_TBB_API</span>
<a name="l00199"></a>00199 <span class="preprocessor"></span>
<a name="l00200"></a>00200   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00204"></a><a class="code" href="classThreads_1_1task__scheduler__init.php">00204</a> <span class="comment"></span>  <span class="keyword">class </span><a class="code" href="classThreads_1_1task__scheduler__init.php">task_scheduler_init</a>
<a name="l00205"></a>00205   {
<a name="l00206"></a>00206   <span class="keyword">public</span>:
<a name="l00207"></a><a class="code" href="classThreads_1_1task__scheduler__init.php#ac6d229ed0616265e1396245f789277d9">00207</a>     <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classThreads_1_1task__scheduler__init.php#ac6d229ed0616265e1396245f789277d9">automatic</a> = -1;
<a name="l00208"></a><a class="code" href="classThreads_1_1task__scheduler__init.php#ae24203ebde87572acdee1ec9b4ec42a3">00208</a>     <a class="code" href="classThreads_1_1task__scheduler__init.php#ae24203ebde87572acdee1ec9b4ec42a3">task_scheduler_init</a> (<span class="keywordtype">int</span> = <a class="code" href="classThreads_1_1task__scheduler__init.php#ac6d229ed0616265e1396245f789277d9">automatic</a>) {};
<a name="l00209"></a><a class="code" href="classThreads_1_1task__scheduler__init.php#acd88bd4afbd899daecf7cce0ecd56f43">00209</a>     <span class="keywordtype">void</span> <a class="code" href="classThreads_1_1task__scheduler__init.php#acd88bd4afbd899daecf7cce0ecd56f43">initialize</a> (<span class="keywordtype">int</span> = <a class="code" href="classThreads_1_1task__scheduler__init.php#ac6d229ed0616265e1396245f789277d9">automatic</a>) {};
<a name="l00210"></a><a class="code" href="classThreads_1_1task__scheduler__init.php#a24e896939fc6678d18cd8936fa01271d">00210</a>     <span class="keywordtype">void</span> <a class="code" href="classThreads_1_1task__scheduler__init.php#a24e896939fc6678d18cd8936fa01271d">terminate</a> () {};    
<a name="l00211"></a>00211   };
<a name="l00212"></a>00212 
<a name="l00213"></a>00213   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00218"></a><a class="code" href="classThreads_1_1split.php">00218</a> <span class="comment"></span>  <span class="keyword">class </span><a class="code" href="classThreads_1_1split.php">split</a> {};
<a name="l00219"></a>00219 
<a name="l00220"></a>00220   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00225"></a>00225 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Range, <span class="keyword">typename</span> Body&gt;
<a name="l00226"></a>00226   <span class="keyword">inline</span>
<a name="l00227"></a>00227   <span class="keywordtype">void</span> <a class="code" href="namespaceThreads.php#a9eb02a1b3f006c37843c907a3b5c0581">parallel_for</a> (<span class="keyword">const</span> Range &amp;range, <span class="keyword">const</span> Body &amp;body)
<a name="l00228"></a>00228   { body(range); }
<a name="l00229"></a>00229 
<a name="l00230"></a>00230   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00235"></a>00235 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Range, <span class="keyword">typename</span> Body, <span class="keyword">typename</span> Partitioner&gt;
<a name="l00236"></a>00236   <span class="keyword">inline</span>
<a name="l00237"></a>00237   <span class="keywordtype">void</span> <a class="code" href="namespaceThreads.php#a9eb02a1b3f006c37843c907a3b5c0581">parallel_for</a> (<span class="keyword">const</span> Range &amp;range, <span class="keyword">const</span> Body &amp;body, <span class="keyword">const</span> <a class="code" href="classPartitioner.php">Partitioner</a> &amp;)
<a name="l00238"></a>00238   { body(range); }
<a name="l00239"></a>00239 
<a name="l00240"></a>00240   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00245"></a>00245 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Range, <span class="keyword">typename</span> Body&gt;
<a name="l00246"></a>00246   <span class="keyword">inline</span>
<a name="l00247"></a>00247   <span class="keywordtype">void</span> <a class="code" href="namespaceThreads.php#a5957a49c5a5b3a757b655cb6f8a2d933">parallel_reduce</a> (<span class="keyword">const</span> Range &amp;range, Body &amp;body)
<a name="l00248"></a>00248   { body(range); }
<a name="l00249"></a>00249 
<a name="l00250"></a>00250   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00255"></a>00255 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Range, <span class="keyword">typename</span> Body, <span class="keyword">typename</span> Partitioner&gt;
<a name="l00256"></a>00256   <span class="keyword">inline</span>
<a name="l00257"></a>00257   <span class="keywordtype">void</span> <a class="code" href="namespaceThreads.php#a5957a49c5a5b3a757b655cb6f8a2d933">parallel_reduce</a> (<span class="keyword">const</span> Range &amp;range, Body &amp;body, <span class="keyword">const</span> <a class="code" href="classPartitioner.php">Partitioner</a> &amp;)
<a name="l00258"></a>00258   { body(range); }
<a name="l00259"></a>00259 
<a name="l00260"></a>00260   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00265"></a><a class="code" href="classThreads_1_1spin__mutex.php">00265</a> <span class="comment"></span>  <span class="keyword">class </span><a class="code" href="classThreads_1_1spin__mutex.php">spin_mutex</a> 
<a name="l00266"></a>00266   {
<a name="l00267"></a>00267   <span class="keyword">public</span>:
<a name="l00268"></a><a class="code" href="classThreads_1_1spin__mutex.php#a9aa725cca14cf10a42b1d29f06c64213">00268</a>     <a class="code" href="classThreads_1_1spin__mutex.php#a9aa725cca14cf10a42b1d29f06c64213">spin_mutex</a>() {}
<a name="l00269"></a>00269 
<a name="l00270"></a><a class="code" href="classThreads_1_1spin__mutex_1_1scoped__lock.php">00270</a>     <span class="keyword">class </span><a class="code" href="classThreads_1_1spin__mutex_1_1scoped__lock.php">scoped_lock</a> 
<a name="l00271"></a>00271     {
<a name="l00272"></a>00272     <span class="keyword">public</span>:
<a name="l00273"></a><a class="code" href="classThreads_1_1spin__mutex_1_1scoped__lock.php#ab3f803a0aa8b9341757e93158d39f67f">00273</a>       <a class="code" href="classThreads_1_1spin__mutex_1_1scoped__lock.php#ab3f803a0aa8b9341757e93158d39f67f">scoped_lock</a> () {}
<a name="l00274"></a><a class="code" href="classThreads_1_1spin__mutex_1_1scoped__lock.php#a99d8fea90fd66f53b881020e8747b2e4">00274</a>       <a class="code" href="classThreads_1_1spin__mutex_1_1scoped__lock.php#a99d8fea90fd66f53b881020e8747b2e4">scoped_lock</a> ( <a class="code" href="classThreads_1_1spin__mutex.php">spin_mutex</a>&amp;  ) {} 
<a name="l00275"></a><a class="code" href="classThreads_1_1spin__mutex_1_1scoped__lock.php#a0b9943c992f3c9721cbaac38bc39ac91">00275</a>       <span class="keywordtype">void</span> <a class="code" href="classThreads_1_1spin__mutex_1_1scoped__lock.php#a0b9943c992f3c9721cbaac38bc39ac91">acquire</a> ( <a class="code" href="classThreads_1_1spin__mutex.php">spin_mutex</a>&amp; ) {}
<a name="l00276"></a><a class="code" href="classThreads_1_1spin__mutex_1_1scoped__lock.php#aa1ab982fdb435cabb24bdf1da560d907">00276</a>       <span class="keywordtype">void</span> <a class="code" href="classThreads_1_1spin__mutex_1_1scoped__lock.php#aa1ab982fdb435cabb24bdf1da560d907">release</a> () {}
<a name="l00277"></a>00277     };
<a name="l00278"></a>00278   };
<a name="l00279"></a>00279 
<a name="l00280"></a>00280   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00285"></a>00285 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00286"></a>00286   <span class="keyword">class </span><a class="code" href="classtbb_1_1atomic.php">atomic</a>
<a name="l00287"></a>00287   {
<a name="l00288"></a>00288   <span class="keyword">public</span>:
<a name="l00289"></a><a class="code" href="classThreads_1_1atomic.php#ad7fc7cf560f3a037ae8df4393d07c724">00289</a>     <a class="code" href="classThreads_1_1atomic.php#ad7fc7cf560f3a037ae8df4393d07c724">atomic</a> () : <a class="code" href="classThreads_1_1atomic.php#a58bd33ba28e30a0e1ff7d1af98c2aa0b">_val</a>(0) {}
<a name="l00290"></a><a class="code" href="classThreads_1_1atomic.php#a65e70abaef3223191b5d9cb128853b75">00290</a>     <a class="code" href="classThreads_1_1atomic.php#a65e70abaef3223191b5d9cb128853b75">operator T&amp; </a>() { <span class="keywordflow">return</span> <a class="code" href="classThreads_1_1atomic.php#a58bd33ba28e30a0e1ff7d1af98c2aa0b">_val</a>; }
<a name="l00291"></a>00291   <span class="keyword">private</span>:
<a name="l00292"></a><a class="code" href="classThreads_1_1atomic.php#a58bd33ba28e30a0e1ff7d1af98c2aa0b">00292</a>     T <a class="code" href="classThreads_1_1atomic.php#a58bd33ba28e30a0e1ff7d1af98c2aa0b">_val</a>;
<a name="l00293"></a>00293   };
<a name="l00294"></a>00294   
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_TBB_API</span>
<a name="l00297"></a>00297 <span class="preprocessor"></span>
<a name="l00298"></a>00298 
<a name="l00299"></a>00299 
<a name="l00303"></a>00303   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00304"></a><a class="code" href="classThreads_1_1BlockedRange.php">00304</a>   <span class="keyword">class </span><a class="code" href="classThreads_1_1BlockedRange.php">BlockedRange</a> 
<a name="l00305"></a>00305   {
<a name="l00306"></a>00306   <span class="keyword">public</span>:
<a name="l00310"></a><a class="code" href="classThreads_1_1BlockedRange.php#a3d23c8f3dd50fa9b0fc9578695c2fd74">00310</a>     <span class="keyword">typedef</span> T <a class="code" href="classThreads_1_1BlockedRange.php#a3d23c8f3dd50fa9b0fc9578695c2fd74">const_iterator</a>;
<a name="l00311"></a>00311 
<a name="l00317"></a><a class="code" href="classThreads_1_1BlockedRange.php#a55cb962b5ff637929dcddb4fef50b750">00317</a>     <a class="code" href="classThreads_1_1BlockedRange.php#a55cb962b5ff637929dcddb4fef50b750">BlockedRange</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classThreads_1_1BlockedRange.php#a97702bc5d8b1409258c79fa7522d6f1c">grainsize</a> = 1000) :
<a name="l00318"></a>00318       <a class="code" href="classThreads_1_1BlockedRange.php#a2679c61feb7c2de3a7e243ec0f94fcbc">_grainsize</a>(<a class="code" href="classThreads_1_1BlockedRange.php#a97702bc5d8b1409258c79fa7522d6f1c">grainsize</a>)
<a name="l00319"></a>00319     {}
<a name="l00320"></a>00320 
<a name="l00327"></a><a class="code" href="classThreads_1_1BlockedRange.php#ae2ba9756ec2feb4ce868a43dddd844e2">00327</a>     <a class="code" href="classThreads_1_1BlockedRange.php#a55cb962b5ff637929dcddb4fef50b750">BlockedRange</a> (<span class="keyword">const</span> <a class="code" href="classThreads_1_1BlockedRange.php#a3d23c8f3dd50fa9b0fc9578695c2fd74">const_iterator</a> first,
<a name="l00328"></a>00328                   <span class="keyword">const</span> <a class="code" href="classThreads_1_1BlockedRange.php#a3d23c8f3dd50fa9b0fc9578695c2fd74">const_iterator</a> last,
<a name="l00329"></a>00329                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classThreads_1_1BlockedRange.php#a97702bc5d8b1409258c79fa7522d6f1c">grainsize</a> = 1000) :
<a name="l00330"></a>00330       <a class="code" href="classThreads_1_1BlockedRange.php#a2679c61feb7c2de3a7e243ec0f94fcbc">_grainsize</a>(<a class="code" href="classThreads_1_1BlockedRange.php#a97702bc5d8b1409258c79fa7522d6f1c">grainsize</a>)
<a name="l00331"></a>00331     {
<a name="l00332"></a>00332       this-&gt;<a class="code" href="classThreads_1_1BlockedRange.php#a338587fc225d8a020373da27c86d8af1">reset</a>(first, last);
<a name="l00333"></a>00333     }
<a name="l00334"></a>00334 
<a name="l00348"></a><a class="code" href="classThreads_1_1BlockedRange.php#aa9c49b65faac645c3de1eee9bb88e8d7">00348</a>     <a class="code" href="classThreads_1_1BlockedRange.php#a55cb962b5ff637929dcddb4fef50b750">BlockedRange</a> (<span class="keyword">const</span> <a class="code" href="classThreads_1_1BlockedRange.php">BlockedRange&lt;T&gt;</a> &amp;r):
<a name="l00349"></a>00349       <a class="code" href="classThreads_1_1BlockedRange.php#a5d1f4acba9796658c6e157561bd1459b">_end</a>(r.<a class="code" href="classThreads_1_1BlockedRange.php#a5d1f4acba9796658c6e157561bd1459b">_end</a>), 
<a name="l00350"></a>00350       <a class="code" href="classThreads_1_1BlockedRange.php#a717833c95bfe41af70394cd0cff714de">_begin</a>(r.<a class="code" href="classThreads_1_1BlockedRange.php#a717833c95bfe41af70394cd0cff714de">_begin</a>),
<a name="l00351"></a>00351       <a class="code" href="classThreads_1_1BlockedRange.php#a2679c61feb7c2de3a7e243ec0f94fcbc">_grainsize</a>(r.<a class="code" href="classThreads_1_1BlockedRange.php#a2679c61feb7c2de3a7e243ec0f94fcbc">_grainsize</a>)
<a name="l00352"></a>00352     {}
<a name="l00353"></a>00353     
<a name="l00359"></a><a class="code" href="classThreads_1_1BlockedRange.php#a3e531c9691c4b47ed869600ccde85e01">00359</a>     <a class="code" href="classThreads_1_1BlockedRange.php#a55cb962b5ff637929dcddb4fef50b750">BlockedRange</a> (<a class="code" href="classThreads_1_1BlockedRange.php">BlockedRange&lt;T&gt;</a> &amp;r, <a class="code" href="classThreads_1_1split.php">Threads::split</a> ) : 
<a name="l00360"></a>00360       <a class="code" href="classThreads_1_1BlockedRange.php#a5d1f4acba9796658c6e157561bd1459b">_end</a>(r.<a class="code" href="classThreads_1_1BlockedRange.php#a5d1f4acba9796658c6e157561bd1459b">_end</a>),
<a name="l00361"></a>00361       <a class="code" href="classThreads_1_1BlockedRange.php#a717833c95bfe41af70394cd0cff714de">_begin</a>(r.<a class="code" href="classThreads_1_1BlockedRange.php#a717833c95bfe41af70394cd0cff714de">_begin</a>),
<a name="l00362"></a>00362       <a class="code" href="classThreads_1_1BlockedRange.php#a2679c61feb7c2de3a7e243ec0f94fcbc">_grainsize</a>(r.<a class="code" href="classThreads_1_1BlockedRange.php#a2679c61feb7c2de3a7e243ec0f94fcbc">_grainsize</a>)
<a name="l00363"></a>00363     {
<a name="l00364"></a>00364       <a class="code" href="classThreads_1_1BlockedRange.php#a3d23c8f3dd50fa9b0fc9578695c2fd74">const_iterator</a>
<a name="l00365"></a>00365         beginning = r.<a class="code" href="classThreads_1_1BlockedRange.php#a717833c95bfe41af70394cd0cff714de">_begin</a>,
<a name="l00366"></a>00366         ending    = r.<a class="code" href="classThreads_1_1BlockedRange.php#a5d1f4acba9796658c6e157561bd1459b">_end</a>,
<a name="l00367"></a>00367         middle    = beginning + (ending - beginning)/2u;
<a name="l00368"></a>00368     
<a name="l00369"></a>00369       r.<a class="code" href="classThreads_1_1BlockedRange.php#a5d1f4acba9796658c6e157561bd1459b">_end</a> = <a class="code" href="classThreads_1_1BlockedRange.php#a717833c95bfe41af70394cd0cff714de">_begin</a> = middle;
<a name="l00370"></a>00370     }
<a name="l00371"></a>00371     
<a name="l00375"></a><a class="code" href="classThreads_1_1BlockedRange.php#a338587fc225d8a020373da27c86d8af1">00375</a>     <span class="keywordtype">void</span> <a class="code" href="classThreads_1_1BlockedRange.php#a338587fc225d8a020373da27c86d8af1">reset</a> (<span class="keyword">const</span> <a class="code" href="classThreads_1_1BlockedRange.php#a3d23c8f3dd50fa9b0fc9578695c2fd74">const_iterator</a> first,
<a name="l00376"></a>00376                 <span class="keyword">const</span> <a class="code" href="classThreads_1_1BlockedRange.php#a3d23c8f3dd50fa9b0fc9578695c2fd74">const_iterator</a> last)
<a name="l00377"></a>00377     {
<a name="l00378"></a>00378       <a class="code" href="classThreads_1_1BlockedRange.php#a717833c95bfe41af70394cd0cff714de">_begin</a> = first;
<a name="l00379"></a>00379       <a class="code" href="classThreads_1_1BlockedRange.php#a5d1f4acba9796658c6e157561bd1459b">_end</a>   = last;
<a name="l00380"></a>00380     }
<a name="l00381"></a>00381     
<a name="l00385"></a><a class="code" href="classThreads_1_1BlockedRange.php#a0b2e0db63044a36fa6b702650a625fb3">00385</a>     <a class="code" href="classThreads_1_1BlockedRange.php#a3d23c8f3dd50fa9b0fc9578695c2fd74">const_iterator</a> <a class="code" href="classThreads_1_1BlockedRange.php#a0b2e0db63044a36fa6b702650a625fb3">begin</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classThreads_1_1BlockedRange.php#a717833c95bfe41af70394cd0cff714de">_begin</a>; }  
<a name="l00386"></a>00386     
<a name="l00390"></a><a class="code" href="classThreads_1_1BlockedRange.php#a9a9becb78f6c7fd71f4f176acc1f39e7">00390</a>     <a class="code" href="classThreads_1_1BlockedRange.php#a3d23c8f3dd50fa9b0fc9578695c2fd74">const_iterator</a> <a class="code" href="classThreads_1_1BlockedRange.php#a9a9becb78f6c7fd71f4f176acc1f39e7">end</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classThreads_1_1BlockedRange.php#a5d1f4acba9796658c6e157561bd1459b">_end</a>; }
<a name="l00391"></a>00391     
<a name="l00396"></a><a class="code" href="classThreads_1_1BlockedRange.php#a97702bc5d8b1409258c79fa7522d6f1c">00396</a>     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classThreads_1_1BlockedRange.php#a97702bc5d8b1409258c79fa7522d6f1c">grainsize</a> ()<span class="keyword"> const </span>{<span class="keywordflow">return</span> <a class="code" href="classThreads_1_1BlockedRange.php#a2679c61feb7c2de3a7e243ec0f94fcbc">_grainsize</a>;}
<a name="l00397"></a>00397     
<a name="l00401"></a><a class="code" href="classThreads_1_1BlockedRange.php#ad5edfccfa87b2f7ec535c0966c681cf5">00401</a>     <span class="keywordtype">void</span> <a class="code" href="classThreads_1_1BlockedRange.php#ad5edfccfa87b2f7ec535c0966c681cf5">grainsize</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;gs) {<a class="code" href="classThreads_1_1BlockedRange.php#a2679c61feb7c2de3a7e243ec0f94fcbc">_grainsize</a> = gs;}
<a name="l00402"></a>00402     
<a name="l00406"></a><a class="code" href="classThreads_1_1BlockedRange.php#a1530c83ebec2d27646f8972f679cfeaa">00406</a>     <span class="keywordtype">int</span> <a class="code" href="classThreads_1_1BlockedRange.php#a1530c83ebec2d27646f8972f679cfeaa">size</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (<a class="code" href="classThreads_1_1BlockedRange.php#a5d1f4acba9796658c6e157561bd1459b">_end</a> -<a class="code" href="classThreads_1_1BlockedRange.php#a717833c95bfe41af70394cd0cff714de">_begin</a>); }
<a name="l00407"></a>00407 
<a name="l00408"></a>00408     <span class="comment">//------------------------------------------------------------------------</span>
<a name="l00409"></a>00409     <span class="comment">// Methods that implement Range concept</span>
<a name="l00410"></a>00410     <span class="comment">//------------------------------------------------------------------------</span>
<a name="l00411"></a>00411     
<a name="l00415"></a><a class="code" href="classThreads_1_1BlockedRange.php#ac47fd69b48daca074632bfcc7b016861">00415</a>     <span class="keywordtype">bool</span> <a class="code" href="classThreads_1_1BlockedRange.php#ac47fd69b48daca074632bfcc7b016861">empty</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (<a class="code" href="classThreads_1_1BlockedRange.php#a717833c95bfe41af70394cd0cff714de">_begin</a> == <a class="code" href="classThreads_1_1BlockedRange.php#a5d1f4acba9796658c6e157561bd1459b">_end</a>); }
<a name="l00416"></a>00416     
<a name="l00420"></a><a class="code" href="classThreads_1_1BlockedRange.php#a673ef1eb260e56f385fb9a4ad04fc353">00420</a>     <span class="keywordtype">bool</span> <a class="code" href="classThreads_1_1BlockedRange.php#a673ef1eb260e56f385fb9a4ad04fc353">is_divisible</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> ((<a class="code" href="classThreads_1_1BlockedRange.php#a717833c95bfe41af70394cd0cff714de">_begin</a> + this-&gt;<a class="code" href="classThreads_1_1BlockedRange.php#a97702bc5d8b1409258c79fa7522d6f1c">grainsize</a>()) &lt; <a class="code" href="classThreads_1_1BlockedRange.php#a5d1f4acba9796658c6e157561bd1459b">_end</a>); }
<a name="l00421"></a>00421     
<a name="l00422"></a>00422   <span class="keyword">private</span>:
<a name="l00423"></a>00423     
<a name="l00424"></a><a class="code" href="classThreads_1_1BlockedRange.php#a5d1f4acba9796658c6e157561bd1459b">00424</a>     <a class="code" href="classThreads_1_1BlockedRange.php#a3d23c8f3dd50fa9b0fc9578695c2fd74">const_iterator</a> <a class="code" href="classThreads_1_1BlockedRange.php#a5d1f4acba9796658c6e157561bd1459b">_end</a>;
<a name="l00425"></a><a class="code" href="classThreads_1_1BlockedRange.php#a717833c95bfe41af70394cd0cff714de">00425</a>     <a class="code" href="classThreads_1_1BlockedRange.php#a3d23c8f3dd50fa9b0fc9578695c2fd74">const_iterator</a> <a class="code" href="classThreads_1_1BlockedRange.php#a717833c95bfe41af70394cd0cff714de">_begin</a>;
<a name="l00426"></a><a class="code" href="classThreads_1_1BlockedRange.php#a2679c61feb7c2de3a7e243ec0f94fcbc">00426</a>     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classThreads_1_1BlockedRange.php#a2679c61feb7c2de3a7e243ec0f94fcbc">_grainsize</a>;
<a name="l00427"></a>00427   };
<a name="l00428"></a>00428   
<a name="l00429"></a>00429 
<a name="l00430"></a>00430   
<a name="l00434"></a>00434   <span class="keyword">extern</span> <a class="code" href="classThreads_1_1spin__mutex.php">spin_mutex</a> <a class="code" href="namespaceThreads.php#aad3bf7e190fddf12301f3393213aa5a9">spin_mtx</a>;
<a name="l00435"></a>00435 
<a name="l00436"></a>00436 
<a name="l00437"></a>00437 
<a name="l00438"></a>00438 } <span class="comment">// namespace Threads</span>
<a name="l00439"></a>00439 
<a name="l00440"></a>00440 <span class="preprocessor">#endif // #define __threads_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
