<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_68b326994b1686b0c255607250545e3c.php">parallel</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>threads_allocators.h</h1>  </div>
</div>
<div class="contents">
<a href="threads__allocators_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: threads_allocators.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __threads_allocators_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __threads_allocators_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// System includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;memory&gt;</span> <span class="comment">// for std::allocator</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="threads_8h.php">threads.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Threading building blocks includes</span>
<a name="l00032"></a>00032 <span class="preprocessor">#ifdef LIBMESH_HAVE_TBB_API</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span><span class="preprocessor">#  include &quot;tbb/scalable_allocator.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#endif</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span>
<a name="l00036"></a>00036 
<a name="l00041"></a>00041 <span class="keyword">namespace </span>Threads
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043 <span class="preprocessor">#ifdef LIBMESH_HAVE_TBB_API</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span> 
<a name="l00045"></a>00045  <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00051"></a>00051 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00052"></a><a class="code" href="classThreads_1_1scalable__allocator.php">00052</a>   <span class="keyword">class </span><a class="code" href="classThreads_1_1scalable__allocator.php">scalable_allocator</a> : <span class="keyword">public</span> tbb::<a class="code" href="classThreads_1_1scalable__allocator.php">scalable_allocator</a>&lt;T&gt;
<a name="l00053"></a>00053   {
<a name="l00054"></a>00054   <span class="keyword">public</span>:
<a name="l00055"></a><a class="code" href="classThreads_1_1scalable__allocator.php#a3f80d33ea222a762010c8b8846c57a9f">00055</a>     <span class="keyword">typedef</span> T* <a class="code" href="classThreads_1_1scalable__allocator.php#a3f80d33ea222a762010c8b8846c57a9f">pointer</a>;
<a name="l00056"></a><a class="code" href="classThreads_1_1scalable__allocator.php#a3bd99a79a452ddce86370c5d72bd418d">00056</a>     <span class="keyword">typedef</span> <span class="keyword">const</span> T* <a class="code" href="classThreads_1_1scalable__allocator.php#a3bd99a79a452ddce86370c5d72bd418d">const_pointer</a>;
<a name="l00057"></a>00057 <span class="comment">//     typedef T&amp; reference;              // Intel 7.1 tries to instantiate an allocator&lt;void&gt;, </span>
<a name="l00058"></a>00058 <span class="comment">//     typedef const T&amp; const_reference;  // so we can&#39;t typedef a reference to void.</span>
<a name="l00059"></a><a class="code" href="classThreads_1_1scalable__allocator.php#a6a6381394755effff3043b40efb627f4">00059</a>     <span class="keyword">typedef</span> T <a class="code" href="classThreads_1_1scalable__allocator.php#a6a6381394755effff3043b40efb627f4">value_type</a>;
<a name="l00060"></a><a class="code" href="classThreads_1_1scalable__allocator.php#a5a4ede459c35ee9206fc543d74211c98">00060</a>     <span class="keyword">typedef</span> <span class="keywordtype">size_t</span> <a class="code" href="classThreads_1_1scalable__allocator.php#a5a4ede459c35ee9206fc543d74211c98">size_type</a>;
<a name="l00061"></a><a class="code" href="classThreads_1_1scalable__allocator.php#a13afa725ef07b7d1ced6dad6d6d3d454">00061</a>     <span class="keyword">typedef</span> ptrdiff_t <a class="code" href="classThreads_1_1scalable__allocator.php#a13afa725ef07b7d1ced6dad6d6d3d454">difference_type</a>;
<a name="l00062"></a>00062 
<a name="l00063"></a>00063     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> U&gt; 
<a name="l00064"></a><a class="code" href="structThreads_1_1scalable__allocator_1_1rebind.php">00064</a>     <span class="keyword">struct </span><a class="code" href="structThreads_1_1scalable__allocator_1_1rebind.php">rebind</a> 
<a name="l00065"></a>00065     {
<a name="l00066"></a><a class="code" href="structThreads_1_1scalable__allocator_1_1rebind.php#a582b7c6f738e1195715e6f7b2d1e6862">00066</a>       <span class="keyword">typedef</span> <a class="code" href="classThreads_1_1scalable__allocator.php">scalable_allocator&lt;U&gt;</a> <a class="code" href="structThreads_1_1scalable__allocator_1_1rebind.php#a582b7c6f738e1195715e6f7b2d1e6862">other</a>;
<a name="l00067"></a>00067     };
<a name="l00068"></a>00068 
<a name="l00069"></a><a class="code" href="classThreads_1_1scalable__allocator.php#abefd2f87abb2c3450588085172d4ce12">00069</a>     <a class="code" href="classThreads_1_1scalable__allocator.php#abefd2f87abb2c3450588085172d4ce12">scalable_allocator</a> () :
<a name="l00070"></a>00070       tbb::<a class="code" href="classThreads_1_1scalable__allocator.php">scalable_allocator</a>&lt;T&gt;() {}
<a name="l00071"></a>00071 
<a name="l00072"></a><a class="code" href="classThreads_1_1scalable__allocator.php#a99e61078e43279fbf3461326f7d18c88">00072</a>     <a class="code" href="classThreads_1_1scalable__allocator.php#abefd2f87abb2c3450588085172d4ce12">scalable_allocator</a> (<span class="keyword">const</span> <a class="code" href="classThreads_1_1scalable__allocator.php">scalable_allocator</a> &amp;a) :
<a name="l00073"></a>00073       tbb::<a class="code" href="classThreads_1_1scalable__allocator.php">scalable_allocator</a>&lt;T&gt;(a) {}
<a name="l00074"></a>00074 
<a name="l00075"></a>00075     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> U&gt; 
<a name="l00076"></a><a class="code" href="classThreads_1_1scalable__allocator.php#af263e8030db4f8ad4b3f9c1460c44213">00076</a>     <a class="code" href="classThreads_1_1scalable__allocator.php#abefd2f87abb2c3450588085172d4ce12">scalable_allocator</a>(<span class="keyword">const</span> <a class="code" href="classThreads_1_1scalable__allocator.php">scalable_allocator&lt;U&gt;</a> &amp;a) :
<a name="l00077"></a>00077       tbb::<a class="code" href="classThreads_1_1scalable__allocator.php">scalable_allocator</a>&lt;T&gt;(a) {}
<a name="l00078"></a>00078   };
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 <span class="preprocessor">#else //LIBMESH_HAVE_TBB_API</span>
<a name="l00083"></a>00083 <span class="preprocessor"></span>
<a name="l00084"></a>00084 
<a name="l00085"></a>00085  
<a name="l00086"></a>00086  <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00090"></a>00090 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00091"></a>00091   <span class="keyword">class </span>scalable_allocator : <span class="keyword">public</span> std::allocator&lt;T&gt;
<a name="l00092"></a>00092   {
<a name="l00093"></a>00093   <span class="keyword">public</span>:
<a name="l00094"></a><a class="code" href="classThreads_1_1scalable__allocator.php#a3f80d33ea222a762010c8b8846c57a9f">00094</a>     <span class="keyword">typedef</span> T* <a class="code" href="classThreads_1_1scalable__allocator.php#a3f80d33ea222a762010c8b8846c57a9f">pointer</a>;
<a name="l00095"></a><a class="code" href="classThreads_1_1scalable__allocator.php#a3bd99a79a452ddce86370c5d72bd418d">00095</a>     <span class="keyword">typedef</span> <span class="keyword">const</span> T* <a class="code" href="classThreads_1_1scalable__allocator.php#a3bd99a79a452ddce86370c5d72bd418d">const_pointer</a>;
<a name="l00096"></a>00096 <span class="comment">//     typedef T&amp; reference;              // Intel 7.1 tries to instantiate an allocator&lt;void&gt;, </span>
<a name="l00097"></a>00097 <span class="comment">//     typedef const T&amp; const_reference;  // so we can&#39;t typedef a reference to void.</span>
<a name="l00098"></a><a class="code" href="classThreads_1_1scalable__allocator.php#a6a6381394755effff3043b40efb627f4">00098</a>     <span class="keyword">typedef</span> T <a class="code" href="classThreads_1_1scalable__allocator.php#a6a6381394755effff3043b40efb627f4">value_type</a>;
<a name="l00099"></a><a class="code" href="classThreads_1_1scalable__allocator.php#a5a4ede459c35ee9206fc543d74211c98">00099</a>     <span class="keyword">typedef</span> <span class="keywordtype">size_t</span> <a class="code" href="classThreads_1_1scalable__allocator.php#a5a4ede459c35ee9206fc543d74211c98">size_type</a>;
<a name="l00100"></a><a class="code" href="classThreads_1_1scalable__allocator.php#a13afa725ef07b7d1ced6dad6d6d3d454">00100</a>     <span class="keyword">typedef</span> ptrdiff_t <a class="code" href="classThreads_1_1scalable__allocator.php#a13afa725ef07b7d1ced6dad6d6d3d454">difference_type</a>;
<a name="l00101"></a>00101 
<a name="l00102"></a>00102     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> U&gt; 
<a name="l00103"></a>00103     <span class="keyword">struct </span><a class="code" href="structThreads_1_1scalable__allocator_1_1rebind.php">rebind</a> 
<a name="l00104"></a>00104     {
<a name="l00105"></a><a class="code" href="structThreads_1_1scalable__allocator_1_1rebind.php#a582b7c6f738e1195715e6f7b2d1e6862">00105</a>       <span class="keyword">typedef</span> <a class="code" href="classThreads_1_1scalable__allocator.php">scalable_allocator&lt;U&gt;</a> <a class="code" href="structThreads_1_1scalable__allocator_1_1rebind.php#a582b7c6f738e1195715e6f7b2d1e6862">other</a>;
<a name="l00106"></a>00106     };
<a name="l00107"></a>00107 
<a name="l00108"></a><a class="code" href="classThreads_1_1scalable__allocator.php#abefd2f87abb2c3450588085172d4ce12">00108</a>     <a class="code" href="classThreads_1_1scalable__allocator.php#abefd2f87abb2c3450588085172d4ce12">scalable_allocator</a> () :
<a name="l00109"></a>00109       std::allocator&lt;T&gt;() {}
<a name="l00110"></a>00110 
<a name="l00111"></a><a class="code" href="classThreads_1_1scalable__allocator.php#a99e61078e43279fbf3461326f7d18c88">00111</a>     <a class="code" href="classThreads_1_1scalable__allocator.php#abefd2f87abb2c3450588085172d4ce12">scalable_allocator</a> (<span class="keyword">const</span> <a class="code" href="classThreads_1_1scalable__allocator.php">scalable_allocator</a> &amp;a) :
<a name="l00112"></a>00112       std::allocator&lt;T&gt;(a) {}
<a name="l00113"></a>00113 
<a name="l00114"></a>00114     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> U&gt; 
<a name="l00115"></a><a class="code" href="classThreads_1_1scalable__allocator.php#af263e8030db4f8ad4b3f9c1460c44213">00115</a>     <a class="code" href="classThreads_1_1scalable__allocator.php#abefd2f87abb2c3450588085172d4ce12">scalable_allocator</a>(<span class="keyword">const</span> <a class="code" href="classThreads_1_1scalable__allocator.php">scalable_allocator&lt;U&gt;</a> &amp;a) :
<a name="l00116"></a>00116       std::allocator&lt;T&gt;(a) {}
<a name="l00117"></a>00117   };
<a name="l00118"></a>00118   
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_TBB_API</span>
<a name="l00121"></a>00121 <span class="preprocessor"></span>
<a name="l00122"></a>00122 } <span class="comment">// namespace Threads</span>
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 <span class="preprocessor">#endif // #define __threads_allocators_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
