<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_60be1125a39495b698d2d56e8e5b50b1.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>time_solver.C</h1>  </div>
</div>
<div class="contents">
<a href="time__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: time_solver.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;diff_solver.h&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;diff_system.h&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;dof_map.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;time_solver.h&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a><a class="code" href="classTimeSolver.php#abdc2fdecd8bc22bdeba6e2747c6ba443">00029</a> <a class="code" href="classTimeSolver.php#abdc2fdecd8bc22bdeba6e2747c6ba443">TimeSolver::TimeSolver</a> (<a class="code" href="classDifferentiableSystem.php">sys_type</a>&amp; s)
<a name="l00030"></a>00030   : quiet (true),
<a name="l00031"></a>00031     reduce_deltat_on_diffsolver_failure (0),
<a name="l00032"></a>00032     _diff_solver (NULL),
<a name="l00033"></a>00033     _adjoint_solver (NULL),
<a name="l00034"></a>00034     _system (s)
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 }
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a><a class="code" href="classTimeSolver.php#ad85f211e91a2811e9c15cc660c785a1d">00040</a> <a class="code" href="classTimeSolver.php#ad85f211e91a2811e9c15cc660c785a1d">TimeSolver::~TimeSolver</a> ()
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042 }
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a><a class="code" href="classTimeSolver.php#acf6ca908709724100c7a290aba33e818">00046</a> <span class="keywordtype">void</span> <a class="code" href="classTimeSolver.php#acf6ca908709724100c7a290aba33e818">TimeSolver::reinit</a> ()
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048   <a class="code" href="classTimeSolver.php#a44ce324d0ec130de42c1f7f4ac2a57f1">_diff_solver</a>-&gt;reinit();
<a name="l00049"></a>00049   <a class="code" href="classTimeSolver.php#a273baa5a7682b899c6dc15d2cfd0463b">_adjoint_solver</a>-&gt;reinit();
<a name="l00050"></a>00050 }
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a><a class="code" href="classTimeSolver.php#a3621ed24cae9a38978234c7d2992e985">00054</a> <span class="keywordtype">void</span> <a class="code" href="classTimeSolver.php#a3621ed24cae9a38978234c7d2992e985">TimeSolver::init</a> ()
<a name="l00055"></a>00055 {
<a name="l00056"></a>00056   <span class="comment">// If the user hasn&#39;t given us a solver to use,</span>
<a name="l00057"></a>00057   <span class="comment">// just build a default solver</span>
<a name="l00058"></a>00058   <span class="keywordflow">if</span> (<a class="code" href="classTimeSolver.php#a44ce324d0ec130de42c1f7f4ac2a57f1">_diff_solver</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() == NULL)
<a name="l00059"></a>00059     <a class="code" href="classTimeSolver.php#a44ce324d0ec130de42c1f7f4ac2a57f1">_diff_solver</a> = <a class="code" href="classDiffSolver.php#a4329eed9150ced6af7f969015fc14dfb">DiffSolver::build</a>(<a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>);
<a name="l00060"></a>00060 
<a name="l00061"></a>00061   <span class="keywordflow">if</span> (<a class="code" href="classTimeSolver.php#a273baa5a7682b899c6dc15d2cfd0463b">_adjoint_solver</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() == NULL)
<a name="l00062"></a>00062     <a class="code" href="classTimeSolver.php#a273baa5a7682b899c6dc15d2cfd0463b">_adjoint_solver</a> = <a class="code" href="classDiffSolver.php#a4329eed9150ced6af7f969015fc14dfb">DiffSolver::build</a>(<a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>);
<a name="l00063"></a>00063 
<a name="l00064"></a>00064   <a class="code" href="classTimeSolver.php#a44ce324d0ec130de42c1f7f4ac2a57f1">_diff_solver</a>-&gt;init();
<a name="l00065"></a>00065   <a class="code" href="classTimeSolver.php#a273baa5a7682b899c6dc15d2cfd0463b">_adjoint_solver</a>-&gt;init();
<a name="l00066"></a>00066 }
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 
<a name="l00070"></a><a class="code" href="classTimeSolver.php#ac6e5dcfbb8f86a6d63d21381cf72d3b3">00070</a> <span class="keywordtype">void</span> <a class="code" href="classTimeSolver.php#ac6e5dcfbb8f86a6d63d21381cf72d3b3">TimeSolver::solve</a> ()
<a name="l00071"></a>00071 {
<a name="l00072"></a>00072   <a class="code" href="classTimeSolver.php#a44ce324d0ec130de42c1f7f4ac2a57f1">_diff_solver</a>-&gt;solve();
<a name="l00073"></a>00073 }
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
<a name="l00077"></a><a class="code" href="classTimeSolver.php#a0bef498913e2ee5a645f3551dba30bb8">00077</a> <span class="keywordtype">void</span> <a class="code" href="classTimeSolver.php#a0bef498913e2ee5a645f3551dba30bb8">TimeSolver::adjoint_solve</a> ()
<a name="l00078"></a>00078 {
<a name="l00079"></a>00079   <a class="code" href="classTimeSolver.php#a273baa5a7682b899c6dc15d2cfd0463b">_adjoint_solver</a>-&gt;adjoint_solve();
<a name="l00080"></a>00080 }
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00084"></a><a class="code" href="classTimeSolver.php#aa5185e0643fdff3a6d5222cc148ad551">00084</a> <span class="keywordtype">void</span> <a class="code" href="classTimeSolver.php#aa5185e0643fdff3a6d5222cc148ad551">TimeSolver::advance_timestep</a> ()
<a name="l00085"></a>00085 {
<a name="l00086"></a>00086 }
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 
<a name="l00090"></a><a class="code" href="classTimeSolver.php#a403b6f4e919753826d04c9490131e643">00090</a> <span class="keywordtype">void</span> <a class="code" href="classTimeSolver.php#a403b6f4e919753826d04c9490131e643">TimeSolver::adjoint_recede_timestep</a> ()
<a name="l00091"></a>00091 {
<a name="l00092"></a>00092 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
