<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>time_solver.h</h1>  </div>
</div>
<div class="contents">
<a href="time__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: time_solver.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __time_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __time_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;auto_ptr.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="system__norm_8h.php">system_norm.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;reference_counted_object.h&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward Declarations</span>
<a name="l00035"></a>00035 <span class="keyword">class </span><a class="code" href="classDiffContext.php">DiffContext</a>;
<a name="l00036"></a>00036 <span class="keyword">class </span><a class="code" href="classDiffSolver.php">DiffSolver</a>;
<a name="l00037"></a>00037 <span class="keyword">class </span><a class="code" href="classTimeSolver.php">TimeSolver</a>;
<a name="l00038"></a>00038 <span class="keyword">class </span><a class="code" href="classDifferentiableSystem.php">DifferentiableSystem</a>;
<a name="l00039"></a>00039 
<a name="l00054"></a>00054 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00055"></a>00055 <span class="comment">// Solver class definition</span>
<a name="l00056"></a><a class="code" href="classTimeSolver.php">00056</a> <span class="keyword">class </span><a class="code" href="classTimeSolver.php">TimeSolver</a> : <span class="keyword">public</span> <a class="code" href="classReferenceCountedObject.php">ReferenceCountedObject</a>&lt;TimeSolver&gt;
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058 <span class="keyword">public</span>:
<a name="l00062"></a><a class="code" href="classTimeSolver.php#a94835139de4ac8ca90284dbc8848490d">00062</a>   <span class="keyword">typedef</span> <a class="code" href="classDifferentiableSystem.php">DifferentiableSystem</a> <a class="code" href="classTimeSolver.php#a94835139de4ac8ca90284dbc8848490d">sys_type</a>;
<a name="l00063"></a>00063   
<a name="l00068"></a>00068   <a class="code" href="classTimeSolver.php#abdc2fdecd8bc22bdeba6e2747c6ba443">TimeSolver</a> (<a class="code" href="classDifferentiableSystem.php">sys_type</a>&amp; s);
<a name="l00069"></a>00069   
<a name="l00073"></a>00073   <span class="keyword">virtual</span> <a class="code" href="classTimeSolver.php#ad85f211e91a2811e9c15cc660c785a1d">~TimeSolver</a> ();
<a name="l00074"></a>00074 
<a name="l00079"></a>00079   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classTimeSolver.php#a3621ed24cae9a38978234c7d2992e985">init</a> ();
<a name="l00080"></a>00080 
<a name="l00085"></a>00085   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classTimeSolver.php#acf6ca908709724100c7a290aba33e818">reinit</a> ();
<a name="l00086"></a>00086 
<a name="l00093"></a>00093   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classTimeSolver.php#ac6e5dcfbb8f86a6d63d21381cf72d3b3">solve</a> ();
<a name="l00094"></a>00094 
<a name="l00101"></a>00101   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classTimeSolver.php#a0bef498913e2ee5a645f3551dba30bb8">adjoint_solve</a> ();
<a name="l00102"></a>00102 
<a name="l00109"></a>00109   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classTimeSolver.php#aa5185e0643fdff3a6d5222cc148ad551">advance_timestep</a> ();
<a name="l00110"></a>00110 
<a name="l00116"></a>00116   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classTimeSolver.php#a403b6f4e919753826d04c9490131e643">adjoint_recede_timestep</a> ();
<a name="l00117"></a>00117 
<a name="l00125"></a>00125   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classTimeSolver.php#aba9a2410e2bdf6d0b1a6d3a01a501db3">element_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00126"></a>00126                                  <a class="code" href="classDiffContext.php">DiffContext</a> &amp;) = 0;
<a name="l00127"></a>00127 
<a name="l00135"></a>00135   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classTimeSolver.php#ab877eee4ce578637d7e8b4cff01564b2">side_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00136"></a>00136                               <a class="code" href="classDiffContext.php">DiffContext</a> &amp;) = 0;
<a name="l00137"></a>00137 
<a name="l00142"></a><a class="code" href="classTimeSolver.php#a7c1a5126403050e196bd1fb3ed23ce4f">00142</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classTimeSolver.php#a7c1a5126403050e196bd1fb3ed23ce4f">before_timestep</a> () {}
<a name="l00143"></a>00143 
<a name="l00147"></a><a class="code" href="classTimeSolver.php#a67c371a4505ffe389f87bcfbeddeb659">00147</a>   <span class="keyword">const</span> <a class="code" href="classDifferentiableSystem.php">sys_type</a> &amp; <a class="code" href="classTimeSolver.php#a67c371a4505ffe389f87bcfbeddeb659">system</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>; }
<a name="l00148"></a>00148 
<a name="l00152"></a><a class="code" href="classTimeSolver.php#a57e58232353ea49ab8678f989aecbdfc">00152</a>   <span class="keyword">virtual</span> <a class="code" href="classAutoPtr.php">AutoPtr&lt;DiffSolver&gt;</a> &amp;<a class="code" href="classTimeSolver.php#a57e58232353ea49ab8678f989aecbdfc">diff_solver</a>() { <span class="keywordflow">return</span> <a class="code" href="classTimeSolver.php#a44ce324d0ec130de42c1f7f4ac2a57f1">_diff_solver</a>; }
<a name="l00153"></a>00153 
<a name="l00157"></a><a class="code" href="classTimeSolver.php#afb64b4fe90a4437bdbb5ee556d7ede98">00157</a>   <span class="keyword">virtual</span> <a class="code" href="classAutoPtr.php">AutoPtr&lt;DiffSolver&gt;</a> &amp;<a class="code" href="classTimeSolver.php#afb64b4fe90a4437bdbb5ee556d7ede98">adjoint_solver</a>() { <span class="keywordflow">return</span> <a class="code" href="classTimeSolver.php#a273baa5a7682b899c6dc15d2cfd0463b">_adjoint_solver</a>; }
<a name="l00158"></a>00158 
<a name="l00162"></a><a class="code" href="classTimeSolver.php#a89d506f1634a4d0a9578ff3773050a8b">00162</a>   <span class="keywordtype">bool</span> <a class="code" href="classTimeSolver.php#a89d506f1634a4d0a9578ff3773050a8b">quiet</a>;
<a name="l00163"></a>00163 
<a name="l00173"></a>00173   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classTimeSolver.php#a40735c9c9ac6c579ba7d950dfb559a9f">du</a>(<span class="keyword">const</span> <a class="code" href="classSystemNorm.php">SystemNorm</a>&amp; norm) <span class="keyword">const</span> = 0;
<a name="l00174"></a>00174 
<a name="l00185"></a><a class="code" href="classTimeSolver.php#af0c2e219b40a5d9336ad2f81cfb1fbd6">00185</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTimeSolver.php#af0c2e219b40a5d9336ad2f81cfb1fbd6">reduce_deltat_on_diffsolver_failure</a>;
<a name="l00186"></a>00186   
<a name="l00187"></a>00187 <span class="keyword">protected</span>:
<a name="l00188"></a>00188 
<a name="l00192"></a><a class="code" href="classTimeSolver.php#a44ce324d0ec130de42c1f7f4ac2a57f1">00192</a>   <a class="code" href="classAutoPtr.php">AutoPtr&lt;DiffSolver&gt;</a> <a class="code" href="classTimeSolver.php#a44ce324d0ec130de42c1f7f4ac2a57f1">_diff_solver</a>;
<a name="l00193"></a>00193 
<a name="l00197"></a><a class="code" href="classTimeSolver.php#a273baa5a7682b899c6dc15d2cfd0463b">00197</a>   <a class="code" href="classAutoPtr.php">AutoPtr&lt;DiffSolver&gt;</a> <a class="code" href="classTimeSolver.php#a273baa5a7682b899c6dc15d2cfd0463b">_adjoint_solver</a>;
<a name="l00198"></a>00198 
<a name="l00202"></a><a class="code" href="classTimeSolver.php#ae1268be010acbd05ae5a02da057961cd">00202</a>   <a class="code" href="classDifferentiableSystem.php">sys_type</a> &amp; <a class="code" href="classTimeSolver.php#ae1268be010acbd05ae5a02da057961cd">system</a> () { <span class="keywordflow">return</span> <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>; }
<a name="l00203"></a>00203   
<a name="l00207"></a><a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">00207</a>   <a class="code" href="classDifferentiableSystem.php">sys_type</a>&amp; <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>;
<a name="l00208"></a>00208 
<a name="l00213"></a><a class="code" href="classTimeSolver.php#adcb1dbd9b3a35dc6c0bed0f2fe8f6d5a">00213</a>   <span class="keywordtype">bool</span> <a class="code" href="classTimeSolver.php#adcb1dbd9b3a35dc6c0bed0f2fe8f6d5a">first_solve</a>;
<a name="l00214"></a>00214 
<a name="l00218"></a><a class="code" href="classTimeSolver.php#a329801587263540e2524281dfb314a32">00218</a>   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; <a class="code" href="classTimeSolver.php#a329801587263540e2524281dfb314a32">old_local_nonlinear_solution</a>;
<a name="l00219"></a>00219 };
<a name="l00220"></a>00220 
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 <span class="preprocessor">#endif // #define __time_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
