<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>transient.h</h1>  </div>
</div>
<div class="contents">
<a href="transient_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: transient.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __transient_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __transient_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="linear_8h.php">linear.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00040"></a>00040 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00041"></a>00041 <span class="comment">// Transient class definition</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T = Linear&lt;&gt; &gt;
<a name="l00044"></a><a class="code" href="classTransient.php">00044</a> <span class="keyword">class </span><a class="code" href="classTransient.php">Transient</a> : <span class="keyword">public</span> T
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046 <span class="keyword">public</span>:
<a name="l00047"></a>00047   
<a name="l00051"></a>00051   <a class="code" href="classTransient.php#a714fb0bb10c96087c974fc3499d4409d">Transient</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es);
<a name="l00052"></a>00052 
<a name="l00056"></a>00056   <a class="code" href="classTransient.php#a714fb0bb10c96087c974fc3499d4409d">Transient</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00057"></a>00057              <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00058"></a>00058              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number);
<a name="l00059"></a>00059 
<a name="l00063"></a>00063   <a class="code" href="classTransient.php#adb9303d2fba1e8e4b86336af89b5fc50">~Transient</a> ();
<a name="l00064"></a>00064 
<a name="l00068"></a>00068   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classTransient.php#a7d78caf1ff7403be777a89d0fbfeed80">solve</a> ();
<a name="l00069"></a>00069 
<a name="l00073"></a><a class="code" href="classTransient.php#a1b448d14688dc7f18f8a93402fcd6d13">00073</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classTransient.php#a1b448d14688dc7f18f8a93402fcd6d13">time</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classTransient.php#a80bc55a0f53b83cfc3c3939d8dc0f05b">_time</a>; }
<a name="l00074"></a>00074 
<a name="l00078"></a><a class="code" href="classTransient.php#a0a1737df7c31a72b370a13c6ff93b178">00078</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classTransient.php#a0a1737df7c31a72b370a13c6ff93b178">t_end</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classTransient.php#a046804f6ca5e70460c3a0eee593e8744">_t_end</a>; }
<a name="l00079"></a>00079 
<a name="l00083"></a><a class="code" href="classTransient.php#a389114f29367606ae932d672bf60f464">00083</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> &amp; <a class="code" href="classTransient.php#a389114f29367606ae932d672bf60f464">t_end</a> () { <span class="keywordflow">return</span> <a class="code" href="classTransient.php#a046804f6ca5e70460c3a0eee593e8744">_t_end</a>; }
<a name="l00084"></a>00084   
<a name="l00088"></a><a class="code" href="classTransient.php#ac2d65b1ea8bf0ee84b37d38452ea11b4">00088</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classTransient.php#ac2d65b1ea8bf0ee84b37d38452ea11b4">dt</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classTransient.php#a3e8b6e643b5c5a32216978aa17f3d86f">_dt</a>; }
<a name="l00089"></a>00089 
<a name="l00093"></a><a class="code" href="classTransient.php#abe15c25a7e330b2262ecaffcec96a4e3">00093</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> &amp; <a class="code" href="classTransient.php#abe15c25a7e330b2262ecaffcec96a4e3">dt</a> () { <span class="keywordflow">return</span> <a class="code" href="classTransient.php#a3e8b6e643b5c5a32216978aa17f3d86f">_dt</a>; }
<a name="l00094"></a>00094 
<a name="l00098"></a><a class="code" href="classTransient.php#a5d86b124f7e17061f44e42f24684ff48">00098</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTransient.php#a5d86b124f7e17061f44e42f24684ff48">time_step</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classTransient.php#a7b8ec8e3112f558f0ed02e08d535d009">_time_step</a>; }
<a name="l00099"></a>00099 
<a name="l00103"></a><a class="code" href="classTransient.php#a8f057208559a7a3de037f046f0f91b00">00103</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTransient.php#a8f057208559a7a3de037f046f0f91b00">max_time_steps</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classTransient.php#a88b987fc58069e35028c9ccb435d2ce4">_max_time_steps</a>; }
<a name="l00104"></a>00104 
<a name="l00108"></a><a class="code" href="classTransient.php#a1545a10e343212af517b23011032379e">00108</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp; <a class="code" href="classTransient.php#a1545a10e343212af517b23011032379e">max_time_steps</a> () { <span class="keywordflow">return</span> <a class="code" href="classTransient.php#a88b987fc58069e35028c9ccb435d2ce4">_max_time_steps</a>; }
<a name="l00109"></a>00109 
<a name="l00110"></a>00110  
<a name="l00111"></a>00111 <span class="keyword">protected</span>:
<a name="l00112"></a>00112 
<a name="l00117"></a><a class="code" href="classTransient.php#aff64b3f58bbb80e4d805bbe70e114de2">00117</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> &amp; <a class="code" href="classTransient.php#aff64b3f58bbb80e4d805bbe70e114de2">time</a> () { <span class="keywordflow">return</span> <a class="code" href="classTransient.php#a80bc55a0f53b83cfc3c3939d8dc0f05b">_time</a>; }
<a name="l00118"></a>00118 
<a name="l00123"></a><a class="code" href="classTransient.php#a5857d27b3367c0030f3cb9e7fe6542cf">00123</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp; <a class="code" href="classTransient.php#a5857d27b3367c0030f3cb9e7fe6542cf">time_step</a> () { <span class="keywordflow">return</span> <a class="code" href="classTransient.php#a7b8ec8e3112f558f0ed02e08d535d009">_time_step</a>; }
<a name="l00124"></a>00124 
<a name="l00125"></a>00125   
<a name="l00126"></a>00126 <span class="keyword">private</span>:
<a name="l00127"></a>00127 
<a name="l00131"></a><a class="code" href="classTransient.php#a80bc55a0f53b83cfc3c3939d8dc0f05b">00131</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classTransient.php#a80bc55a0f53b83cfc3c3939d8dc0f05b">_time</a>;
<a name="l00132"></a>00132 
<a name="l00136"></a><a class="code" href="classTransient.php#a046804f6ca5e70460c3a0eee593e8744">00136</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classTransient.php#a046804f6ca5e70460c3a0eee593e8744">_t_end</a>;
<a name="l00137"></a>00137 
<a name="l00141"></a><a class="code" href="classTransient.php#a3e8b6e643b5c5a32216978aa17f3d86f">00141</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classTransient.php#a3e8b6e643b5c5a32216978aa17f3d86f">_dt</a>;
<a name="l00142"></a>00142 
<a name="l00146"></a><a class="code" href="classTransient.php#a7b8ec8e3112f558f0ed02e08d535d009">00146</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTransient.php#a7b8ec8e3112f558f0ed02e08d535d009">_time_step</a>;
<a name="l00147"></a>00147   
<a name="l00151"></a><a class="code" href="classTransient.php#a88b987fc58069e35028c9ccb435d2ce4">00151</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTransient.php#a88b987fc58069e35028c9ccb435d2ce4">_max_time_steps</a>;
<a name="l00152"></a>00152 };
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00157"></a>00157 <span class="comment">// Transient inline members</span>
<a name="l00158"></a>00158 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00159"></a>00159 <span class="keyword">inline</span>
<a name="l00160"></a><a class="code" href="classTransient.php#a714fb0bb10c96087c974fc3499d4409d">00160</a> <a class="code" href="classTransient.php#a714fb0bb10c96087c974fc3499d4409d">Transient&lt;T&gt;::Transient</a>(<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es) :
<a name="l00161"></a>00161   T               (es),   <span class="comment">// Call the base class constructor</span>
<a name="l00162"></a>00162   _time           (0.),   <span class="comment">// Default solver attributes</span>
<a name="l00163"></a>00163   _t_end          (1.e20),
<a name="l00164"></a>00164   _dt             (1.e-2),
<a name="l00165"></a>00165   _time_step      (0),
<a name="l00166"></a>00166   _max_time_steps (5)
<a name="l00167"></a>00167 {
<a name="l00168"></a>00168 }
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00173"></a>00173 <span class="keyword">inline</span>
<a name="l00174"></a><a class="code" href="classTransient.php#a527f4e407da1e809a76de59ab3487e3a">00174</a> <a class="code" href="classTransient.php#a714fb0bb10c96087c974fc3499d4409d">Transient&lt;T&gt;::Transient</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00175"></a>00175                          <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00176"></a>00176                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :
<a name="l00177"></a>00177   <a class="code" href="classTransient.php">Transient</a> (es),
<a name="l00178"></a>00178   T         (es, name, number)
<a name="l00179"></a>00179 {
<a name="l00180"></a>00180 }
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00185"></a>00185 <span class="keyword">inline</span>
<a name="l00186"></a><a class="code" href="classTransient.php#adb9303d2fba1e8e4b86336af89b5fc50">00186</a> <a class="code" href="classTransient.php#adb9303d2fba1e8e4b86336af89b5fc50">Transient&lt;T&gt;::~Transient</a> ()
<a name="l00187"></a>00187 {
<a name="l00188"></a>00188 }
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00193"></a>00193 <span class="keyword">inline</span>
<a name="l00194"></a><a class="code" href="classTransient.php#a7d78caf1ff7403be777a89d0fbfeed80">00194</a> <span class="keywordtype">void</span> <a class="code" href="classTransient.php#a7d78caf1ff7403be777a89d0fbfeed80">Transient&lt;T&gt;::solve</a> ()
<a name="l00195"></a>00195 {
<a name="l00196"></a>00196   <span class="keywordflow">do</span>
<a name="l00197"></a>00197     {
<a name="l00198"></a>00198       <span class="comment">// Incriment the time step counter</span>
<a name="l00199"></a>00199       this-&gt;time_step()++;
<a name="l00200"></a>00200 
<a name="l00201"></a>00201       <span class="comment">// Incriment the time counter</span>
<a name="l00202"></a>00202       this-&gt;time() += this-&gt;dt();
<a name="l00203"></a>00203       
<a name="l00204"></a>00204       std::cout &lt;&lt; <span class="stringliteral">&quot;Solving time step &quot;</span>
<a name="l00205"></a>00205                 &lt;&lt; this-&gt;time_step()
<a name="l00206"></a>00206                 &lt;&lt; std::endl;
<a name="l00207"></a>00207 
<a name="l00208"></a>00208       <span class="comment">// Call the base class solver</span>
<a name="l00209"></a>00209       T::solve ();      
<a name="l00210"></a>00210     }
<a name="l00211"></a>00211   <span class="keywordflow">while</span> ((this-&gt;time_step() &lt; this-&gt;max_time_steps()) &amp;&amp;
<a name="l00212"></a>00212          (this-&gt;time()      &lt; this-&gt;t_end()));
<a name="l00213"></a>00213 }
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 
<a name="l00216"></a>00216 <span class="preprocessor">#endif // #define __transient_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
