<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_60be1125a39495b698d2d56e8e5b50b1.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>transient_system.C</h1>  </div>
</div>
<div class="contents">
<a href="transient__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: transient_system.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;transient_system.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;explicit_system.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;linear_implicit_system.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;nonlinear_implicit_system.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;utility.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;dof_map.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00035"></a>00035 <span class="comment">// TransientSystem implementation</span>
<a name="l00036"></a>00036 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00037"></a><a class="code" href="classTransientSystem.php#ab303f8af41e0a0b744a15a4c555d3a1f">00037</a> <a class="code" href="classTransientSystem.php#ab303f8af41e0a0b744a15a4c555d3a1f">TransientSystem&lt;Base&gt;::TransientSystem</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00038"></a>00038                                         <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00039"></a>00039                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :
<a name="l00040"></a>00040   
<a name="l00041"></a>00041   Base                 (es, name, number)
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043   <a class="code" href="classTransientSystem.php#a7fabe829836ac47e2997d7355af4869a">old_local_solution</a> =
<a name="l00044"></a>00044     <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt;
<a name="l00045"></a>00045       (&amp;(this-&gt;add_vector(<span class="stringliteral">&quot;_transient_old_local_solution&quot;</span>)));
<a name="l00046"></a>00046   <a class="code" href="classTransientSystem.php#aba32e63818d3fdd0f47a9469074e7fad">older_local_solution</a> =
<a name="l00047"></a>00047     <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt;
<a name="l00048"></a>00048       (&amp;(this-&gt;add_vector(<span class="stringliteral">&quot;_transient_older_local_solution&quot;</span>)));
<a name="l00049"></a>00049 }
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00054"></a><a class="code" href="classTransientSystem.php#a472a3a0cfb38fa64f45c1ff64f38afbe">00054</a> <a class="code" href="classTransientSystem.php#a472a3a0cfb38fa64f45c1ff64f38afbe">TransientSystem&lt;Base&gt;::~TransientSystem</a> ()
<a name="l00055"></a>00055 {
<a name="l00056"></a>00056   this-&gt;clear();
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <span class="comment">// We still have AutoPtrs for API compatibility, but</span>
<a name="l00059"></a>00059   <span class="comment">// now that we&#39;re System::add_vector()ing these, we can trust</span>
<a name="l00060"></a>00060   <span class="comment">// the base class to handle memory management</span>
<a name="l00061"></a>00061   old_local_solution.release();  
<a name="l00062"></a>00062   older_local_solution.release();  
<a name="l00063"></a>00063 }
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00068"></a><a class="code" href="classTransientSystem.php#a21eb4874da1853a991d6b5a3813f78fc">00068</a> <span class="keywordtype">void</span> <a class="code" href="classTransientSystem.php#a21eb4874da1853a991d6b5a3813f78fc">TransientSystem&lt;Base&gt;::clear</a> ()
<a name="l00069"></a>00069 {
<a name="l00070"></a>00070   <span class="comment">// clear the parent data</span>
<a name="l00071"></a>00071   Base::clear();
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   <span class="comment">// the old &amp; older local solutions</span>
<a name="l00074"></a>00074   <span class="comment">// are now deleted by System!</span>
<a name="l00075"></a>00075   <span class="comment">// old_local_solution-&gt;clear();</span>
<a name="l00076"></a>00076   <span class="comment">// older_local_solution-&gt;clear();  </span>
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   <span class="comment">// FIXME: This preserves maximum backwards compatibility,</span>
<a name="l00079"></a>00079   <span class="comment">// but is probably grossly unnecessary:</span>
<a name="l00080"></a>00080   old_local_solution.release();  
<a name="l00081"></a>00081   older_local_solution.release();  
<a name="l00082"></a>00082 
<a name="l00083"></a>00083   old_local_solution =
<a name="l00084"></a>00084     <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt;
<a name="l00085"></a>00085       (&amp;(this-&gt;add_vector(<span class="stringliteral">&quot;_transient_old_local_solution&quot;</span>)));
<a name="l00086"></a>00086   older_local_solution =
<a name="l00087"></a>00087     <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt;
<a name="l00088"></a>00088       (&amp;(this-&gt;add_vector(<span class="stringliteral">&quot;_transient_older_local_solution&quot;</span>)));
<a name="l00089"></a>00089 }
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00095"></a><a class="code" href="classTransientSystem.php#af3c6e96477c0b4791d7adae4e78f8068">00095</a> <span class="keywordtype">void</span> <a class="code" href="classTransientSystem.php#af3c6e96477c0b4791d7adae4e78f8068">TransientSystem&lt;Base&gt;::init_data</a> ()
<a name="l00096"></a>00096 {
<a name="l00097"></a>00097   <span class="comment">// initialize parent data</span>
<a name="l00098"></a>00098   Base::init_data();
<a name="l00099"></a>00099 
<a name="l00100"></a>00100   <span class="comment">// Initialize the old &amp; older solutions</span>
<a name="l00101"></a>00101   <span class="comment">// Using new ghosted vectors if enabled</span>
<a name="l00102"></a>00102 <span class="preprocessor">#ifdef LIBMESH_ENABLE_GHOSTED</span>
<a name="l00103"></a>00103 <span class="preprocessor"></span>  old_local_solution-&gt;init   (this-&gt;n_dofs(), this-&gt;n_local_dofs(),
<a name="l00104"></a>00104                               this-&gt;get_dof_map().get_send_list(), <span class="keyword">false</span>,
<a name="l00105"></a>00105                               <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>);
<a name="l00106"></a>00106   older_local_solution-&gt;init (this-&gt;n_dofs(), this-&gt;n_local_dofs(),
<a name="l00107"></a>00107                               this-&gt;get_dof_map().get_send_list(), <span class="keyword">false</span>,
<a name="l00108"></a>00108                               <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>);
<a name="l00109"></a>00109 <span class="preprocessor">#else</span>
<a name="l00110"></a>00110 <span class="preprocessor"></span>  old_local_solution-&gt;init   (this-&gt;n_dofs(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>);
<a name="l00111"></a>00111   older_local_solution-&gt;init (this-&gt;n_dofs(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>);
<a name="l00112"></a>00112 <span class="preprocessor">#endif</span>
<a name="l00113"></a>00113 <span class="preprocessor"></span>}
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00118"></a><a class="code" href="classTransientSystem.php#a43cee26f8ae37b1dd09b0d61c8cb9fbe">00118</a> <span class="keywordtype">void</span> <a class="code" href="classTransientSystem.php#a43cee26f8ae37b1dd09b0d61c8cb9fbe">TransientSystem&lt;Base&gt;::reinit</a> ()
<a name="l00119"></a>00119 {
<a name="l00120"></a>00120   <span class="comment">// initialize parent data</span>
<a name="l00121"></a>00121   Base::reinit();
<a name="l00122"></a>00122     
<a name="l00123"></a>00123   <span class="comment">// Project the old &amp; older vectors to the new mesh</span>
<a name="l00124"></a>00124   <span class="comment">// The System::reinit handles this now</span>
<a name="l00125"></a>00125   <span class="comment">// this-&gt;project_vector (*old_local_solution);</span>
<a name="l00126"></a>00126   <span class="comment">// this-&gt;project_vector (*older_local_solution);</span>
<a name="l00127"></a>00127 }
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00132"></a><a class="code" href="classTransientSystem.php#a631264179dea883f16429f5e8e83df91">00132</a> <span class="keywordtype">void</span> <a class="code" href="classTransientSystem.php#a631264179dea883f16429f5e8e83df91">TransientSystem&lt;Base&gt;::re_update</a> ()
<a name="l00133"></a>00133 {
<a name="l00134"></a>00134   <span class="comment">// re_update the parent system</span>
<a name="l00135"></a>00135   Base::re_update ();
<a name="l00136"></a>00136   
<a name="l00137"></a>00137   <span class="comment">//const std::vector&lt;unsigned int&gt;&amp; send_list = Base::_dof_map.get_send_list ();</span>
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   <span class="comment">// Explicitly build a send_list</span>
<a name="l00140"></a>00140   std::vector&lt;unsigned int&gt; send_list(Base::solution-&gt;size());
<a name="l00141"></a>00141   <a class="code" href="namespaceUtility.php#a7c2b0a25e726200178bc1ec52b132981">Utility::iota</a> (send_list.begin(), send_list.end(), 0);
<a name="l00142"></a>00142   
<a name="l00143"></a>00143   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_dof = Base::get_dof_map().first_dof();
<a name="l00144"></a>00144   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> end_local_dof  = Base::get_dof_map().end_dof();
<a name="l00145"></a>00145 
<a name="l00146"></a>00146   <span class="comment">// Check sizes</span>
<a name="l00147"></a>00147   libmesh_assert (end_local_dof &gt;= first_local_dof);
<a name="l00148"></a>00148   libmesh_assert (send_list.size() &gt;= end_local_dof - first_local_dof);
<a name="l00149"></a>00149   libmesh_assert (older_local_solution-&gt;size() &gt;= send_list.size());
<a name="l00150"></a>00150   libmesh_assert (old_local_solution-&gt;size()   &gt;= send_list.size());
<a name="l00151"></a>00151 
<a name="l00152"></a>00152   <span class="comment">// Make sure we have something to do</span>
<a name="l00153"></a>00153   <span class="keywordflow">if</span> (first_local_dof == end_local_dof)
<a name="l00154"></a>00154     <span class="keywordflow">return</span>;
<a name="l00155"></a>00155   
<a name="l00156"></a>00156   <span class="comment">// Update the old &amp; older solutions with the send_list,</span>
<a name="l00157"></a>00157   <span class="comment">// which may have changed since their last update.</span>
<a name="l00158"></a>00158   older_local_solution-&gt;localize (first_local_dof,
<a name="l00159"></a>00159                                   end_local_dof-1,
<a name="l00160"></a>00160                                   send_list);
<a name="l00161"></a>00161   
<a name="l00162"></a>00162   old_local_solution-&gt;localize (first_local_dof,
<a name="l00163"></a>00163                                 end_local_dof-1,
<a name="l00164"></a>00164                                 send_list);  
<a name="l00165"></a>00165 }
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00171"></a><a class="code" href="classTransientSystem.php#a726b958d5a36cef75b3f1b016152de4a">00171</a> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classTransientSystem.php#a726b958d5a36cef75b3f1b016152de4a">TransientSystem&lt;Base&gt;::old_solution</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_dof_number)<span class="keyword"> const</span>
<a name="l00172"></a>00172 <span class="keyword"></span>{
<a name="l00173"></a>00173   <span class="comment">// Check the sizes</span>
<a name="l00174"></a>00174   libmesh_assert (global_dof_number &lt; this-&gt;get_dof_map().n_dofs());
<a name="l00175"></a>00175   libmesh_assert (global_dof_number &lt; old_local_solution-&gt;size());
<a name="l00176"></a>00176    
<a name="l00177"></a>00177   <span class="keywordflow">return</span> (*old_local_solution)(global_dof_number);
<a name="l00178"></a>00178 }
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00183"></a><a class="code" href="classTransientSystem.php#abac9d432cdaf4395cc19cbb86211290e">00183</a> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classTransientSystem.php#abac9d432cdaf4395cc19cbb86211290e">TransientSystem&lt;Base&gt;::older_solution</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_dof_number)<span class="keyword"> const</span>
<a name="l00184"></a>00184 <span class="keyword"></span>{
<a name="l00185"></a>00185   <span class="comment">// Check the sizes</span>
<a name="l00186"></a>00186   libmesh_assert (global_dof_number &lt; this-&gt;get_dof_map().n_dofs());
<a name="l00187"></a>00187   libmesh_assert (global_dof_number &lt; older_local_solution-&gt;size());
<a name="l00188"></a>00188    
<a name="l00189"></a>00189   <span class="keywordflow">return</span> (*older_local_solution)(global_dof_number);
<a name="l00190"></a>00190 }
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00196"></a>00196 <span class="comment">// TransientSystem instantiations</span>
<a name="l00197"></a>00197 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classTransientSystem.php">TransientSystem&lt;LinearImplicitSystem&gt;</a>;
<a name="l00198"></a>00198 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classTransientSystem.php">TransientSystem&lt;NonlinearImplicitSystem&gt;</a>;
<a name="l00199"></a>00199 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classTransientSystem.php">TransientSystem&lt;ExplicitSystem&gt;</a>;
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
