<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>transient_system.h</h1>  </div>
</div>
<div class="contents">
<a href="transient__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: transient_system.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __transient_system_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __transient_system_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Forward declarations</span>
<a name="l00032"></a>00032 <span class="keyword">class </span><a class="code" href="classLinearImplicitSystem.php">LinearImplicitSystem</a>;
<a name="l00033"></a>00033 <span class="keyword">class </span><a class="code" href="classNonlinearImplicitSystem.php">NonlinearImplicitSystem</a>;
<a name="l00034"></a>00034 <span class="keyword">class </span><a class="code" href="classExplicitSystem.php">ExplicitSystem</a>;
<a name="l00035"></a>00035 
<a name="l00044"></a>00044 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00045"></a>00045 <span class="comment">// TransientSystem class definition</span>
<a name="l00046"></a>00046 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00047"></a><a class="code" href="classTransientSystem.php">00047</a> <span class="keyword">class </span><a class="code" href="classTransientSystem.php">TransientSystem</a> : <span class="keyword">public</span> Base
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049 <span class="keyword">public</span>:
<a name="l00050"></a>00050 
<a name="l00055"></a>00055   <a class="code" href="classTransientSystem.php#ab303f8af41e0a0b744a15a4c555d3a1f">TransientSystem</a> (<a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00056"></a>00056                    <span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00057"></a>00057                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number);
<a name="l00058"></a>00058 
<a name="l00062"></a>00062   <span class="keyword">virtual</span> <a class="code" href="classTransientSystem.php#a472a3a0cfb38fa64f45c1ff64f38afbe">~TransientSystem</a> ();
<a name="l00063"></a>00063   
<a name="l00067"></a><a class="code" href="classTransientSystem.php#afbb8f011b5517d5a64006507d8fd198d">00067</a>   <span class="keyword">typedef</span> <a class="code" href="classTransientSystem.php">TransientSystem&lt;Base&gt;</a> <a class="code" href="classTransientSystem.php#afbb8f011b5517d5a64006507d8fd198d">sys_type</a>;
<a name="l00068"></a>00068 
<a name="l00072"></a><a class="code" href="classTransientSystem.php#af7d871b0cb056bf2f51db8cfd7e2157d">00072</a>   <a class="code" href="classTransientSystem.php">sys_type</a> &amp; <a class="code" href="classTransientSystem.php#af7d871b0cb056bf2f51db8cfd7e2157d">system</a> () { <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00073"></a>00073 
<a name="l00078"></a>00078   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classTransientSystem.php#a21eb4874da1853a991d6b5a3813f78fc">clear</a> ();
<a name="l00079"></a>00079 
<a name="l00084"></a>00084   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classTransientSystem.php#a43cee26f8ae37b1dd09b0d61c8cb9fbe">reinit</a> ();
<a name="l00085"></a>00085   
<a name="l00091"></a>00091   <span class="keyword">virtual</span> std::string <a class="code" href="classTransientSystem.php#ab3c6e97ca22c33f1fc94abcf88bf89cc">system_type</a> () <span class="keyword">const</span>;
<a name="l00092"></a>00092 
<a name="l00093"></a>00093   
<a name="l00094"></a>00094   <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00095"></a>00095   <span class="comment">// access to the solution data fields</span>
<a name="l00096"></a>00096   
<a name="l00101"></a>00101   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classTransientSystem.php#a726b958d5a36cef75b3f1b016152de4a">old_solution</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_dof_number) <span class="keyword">const</span>;
<a name="l00102"></a>00102 
<a name="l00107"></a>00107   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classTransientSystem.php#abac9d432cdaf4395cc19cbb86211290e">older_solution</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_dof_number) <span class="keyword">const</span>;
<a name="l00108"></a>00108 
<a name="l00115"></a><a class="code" href="classTransientSystem.php#a7fabe829836ac47e2997d7355af4869a">00115</a>   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; <a class="code" href="classTransientSystem.php#a7fabe829836ac47e2997d7355af4869a">old_local_solution</a>;
<a name="l00116"></a>00116 
<a name="l00123"></a><a class="code" href="classTransientSystem.php#aba32e63818d3fdd0f47a9469074e7fad">00123</a>   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; <a class="code" href="classTransientSystem.php#aba32e63818d3fdd0f47a9469074e7fad">older_local_solution</a>;
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 <span class="keyword">protected</span>:
<a name="l00127"></a>00127   
<a name="l00128"></a>00128 
<a name="l00133"></a>00133   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classTransientSystem.php#af3c6e96477c0b4791d7adae4e78f8068">init_data</a> ();
<a name="l00134"></a>00134 
<a name="l00140"></a>00140   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classTransientSystem.php#a631264179dea883f16429f5e8e83df91">re_update</a> ();
<a name="l00141"></a>00141 };
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 <span class="comment">// -----------------------------------------------------------</span>
<a name="l00146"></a>00146 <span class="comment">// Useful typedefs</span>
<a name="l00147"></a><a class="code" href="transient__system_8h.php#ab4891fba992f1baeb819769d3233b2b8">00147</a> <span class="keyword">typedef</span> <a class="code" href="classTransientSystem.php">TransientSystem&lt;LinearImplicitSystem&gt;</a> <a class="code" href="transient__system_8h.php#ab4891fba992f1baeb819769d3233b2b8">TransientImplicitSystem</a>;
<a name="l00148"></a><a class="code" href="transient__system_8h.php#a064b4a433771ed673725e38ec312e732">00148</a> <span class="keyword">typedef</span> <a class="code" href="classTransientSystem.php">TransientSystem&lt;LinearImplicitSystem&gt;</a> <a class="code" href="transient__system_8h.php#a064b4a433771ed673725e38ec312e732">TransientLinearImplicitSystem</a>;
<a name="l00149"></a><a class="code" href="transient__system_8h.php#a3967e304b522e54ac4c678f542ad745a">00149</a> <span class="keyword">typedef</span> <a class="code" href="classTransientSystem.php">TransientSystem&lt;NonlinearImplicitSystem&gt;</a> <a class="code" href="transient__system_8h.php#a3967e304b522e54ac4c678f542ad745a">TransientNonlinearImplicitSystem</a>;
<a name="l00150"></a><a class="code" href="transient__system_8h.php#a4622599d78d36e975d025ae9fedfb285">00150</a> <span class="keyword">typedef</span> <a class="code" href="classTransientSystem.php">TransientSystem&lt;ExplicitSystem&gt;</a> <a class="code" href="transient__system_8h.php#a4622599d78d36e975d025ae9fedfb285">TransientExplicitSystem</a>;
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00155"></a>00155 <span class="comment">// TransientSystem inline methods</span>
<a name="l00156"></a>00156 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00157"></a>00157 <span class="keyword">inline</span>
<a name="l00158"></a><a class="code" href="classTransientSystem.php#ab3c6e97ca22c33f1fc94abcf88bf89cc">00158</a> std::string <a class="code" href="classTransientSystem.php#ab3c6e97ca22c33f1fc94abcf88bf89cc">TransientSystem&lt;Base&gt;::system_type</a> ()<span class="keyword"> const</span>
<a name="l00159"></a>00159 <span class="keyword"></span>{
<a name="l00160"></a>00160   std::string type = <span class="stringliteral">&quot;Transient&quot;</span>;
<a name="l00161"></a>00161   type += Base::system_type ();
<a name="l00162"></a>00162   
<a name="l00163"></a>00163   <span class="keywordflow">return</span> type;
<a name="l00164"></a>00164 }
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
