<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_c2e5aa429b9110fa734bdc9647d91e10.php">utils</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>tree.C</h1>  </div>
</div>
<div class="contents">
<a href="tree_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: tree.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;tree.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;mesh_tools.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00032"></a>00032 <span class="comment">// Tree class method</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// constructor</span>
<a name="l00035"></a>00035 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00036"></a><a class="code" href="classTree.php#a924b6ac586de554e790d68e28ba8ac7d">00036</a> <a class="code" href="classTree.php#a924b6ac586de554e790d68e28ba8ac7d">Tree&lt;N&gt;::Tree</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; m,
<a name="l00037"></a>00037                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level,
<a name="l00038"></a>00038                <span class="keyword">const</span> <a class="code" href="namespaceTrees.php#a8fb02eb8a700b646d106718a2d0ca3ef">Trees::BuildType</a> bt) :
<a name="l00039"></a>00039   <a class="code" href="classTreeBase.php">TreeBase</a>(m),
<a name="l00040"></a>00040   root(m,level),
<a name="l00041"></a>00041   build_type(bt)
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043   <span class="comment">// Set the root node bounding box equal to the bounding</span>
<a name="l00044"></a>00044   <span class="comment">// box for the entire domain.</span>
<a name="l00045"></a>00045   <a class="code" href="classTree.php#aaf5c3379430f8260a27c2a93f2267194">root</a>.set_bounding_box (<a class="code" href="namespaceMeshTools.php#ad533681876e9809cfe5e2114886b1c03">MeshTools::bounding_box</a>(<a class="code" href="classTreeBase.php#a7e068025b3494a36c184d721adfc5b8c">mesh</a>));
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   <span class="keywordflow">if</span> (<a class="code" href="classTree.php#a750a1c8d19da5d1279a7cc90a83d630f">build_type</a> == <a class="code" href="namespaceTrees.php#a8fb02eb8a700b646d106718a2d0ca3efa6ec2eeb88ab0a36caf9a31d79c3da8cb">Trees::NODES</a>)
<a name="l00049"></a>00049     {
<a name="l00050"></a>00050       <span class="comment">// Add all the nodes to the root node.  It will </span>
<a name="l00051"></a>00051       <span class="comment">// automagically build the tree for us.</span>
<a name="l00052"></a>00052       <a class="code" href="structMeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a>       it  = <a class="code" href="classTreeBase.php#a7e068025b3494a36c184d721adfc5b8c">mesh</a>.<a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
<a name="l00053"></a>00053       <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> end = <a class="code" href="classTreeBase.php#a7e068025b3494a36c184d721adfc5b8c">mesh</a>.<a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
<a name="l00054"></a>00054 
<a name="l00055"></a>00055       <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00056"></a>00056         <a class="code" href="classTree.php#aaf5c3379430f8260a27c2a93f2267194">root</a>.insert (*it);
<a name="l00057"></a>00057       
<a name="l00058"></a>00058       <span class="comment">// Now the tree contains the nodes.</span>
<a name="l00059"></a>00059       <span class="comment">// However, we want element pointers, so here we</span>
<a name="l00060"></a>00060       <span class="comment">// convert between the two.</span>
<a name="l00061"></a>00061       std::vector&lt;std::vector&lt;const Elem*&gt; &gt; nodes_to_elem;
<a name="l00062"></a>00062       
<a name="l00063"></a>00063       <a class="code" href="namespaceMeshTools.php#a632cfcd7fcbda25f0450b52f3d75942f">MeshTools::build_nodes_to_elem_map</a> (<a class="code" href="classTreeBase.php#a7e068025b3494a36c184d721adfc5b8c">mesh</a>, nodes_to_elem);      
<a name="l00064"></a>00064       <a class="code" href="classTree.php#aaf5c3379430f8260a27c2a93f2267194">root</a>.transform_nodes_to_elements (nodes_to_elem);
<a name="l00065"></a>00065     }
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classTree.php#a750a1c8d19da5d1279a7cc90a83d630f">build_type</a> == <a class="code" href="namespaceTrees.php#a8fb02eb8a700b646d106718a2d0ca3efac26fb03063d7ed0c6588164e9a29d2cc">Trees::ELEMENTS</a>)
<a name="l00068"></a>00068     {
<a name="l00069"></a>00069       <span class="comment">// Add all active elements to the root node.  It will</span>
<a name="l00070"></a>00070       <span class="comment">// automatically build the tree for us.</span>
<a name="l00071"></a>00071       <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = <a class="code" href="classTreeBase.php#a7e068025b3494a36c184d721adfc5b8c">mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00072"></a>00072       <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = <a class="code" href="classTreeBase.php#a7e068025b3494a36c184d721adfc5b8c">mesh</a>.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>();
<a name="l00073"></a>00073 
<a name="l00074"></a>00074       
<a name="l00075"></a>00075       <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00076"></a>00076         <a class="code" href="classTree.php#aaf5c3379430f8260a27c2a93f2267194">root</a>.insert (*it);
<a name="l00077"></a>00077     }
<a name="l00078"></a>00078 }
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00083"></a><a class="code" href="classTree.php#a081fe093bd5672370155debc6166c217">00083</a> <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classTree.php#a081fe093bd5672370155debc6166c217">Tree&lt;N&gt;::find_element</a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p)<span class="keyword"> const</span>
<a name="l00084"></a>00084 <span class="keyword"></span>{
<a name="l00085"></a>00085   <span class="keywordflow">return</span> root.find_element(p);
<a name="l00086"></a>00086 }
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00090"></a>00090 <span class="comment">// Explicit Instantiations</span>
<a name="l00091"></a>00091 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classTree.php">Tree&lt;4&gt;</a>;
<a name="l00092"></a>00092 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classTree.php">Tree&lt;8&gt;</a>;
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
