<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_4f64d75cac7489d141591c33108e86ff.php">utils</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>tree.h</h1>  </div>
</div>
<div class="contents">
<a href="tree_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: tree.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __tree_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __tree_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="tree__node_8h.php">tree_node.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="tree__base_8h.php">tree_base.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Forward Declarations</span>
<a name="l00032"></a>00032 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00033"></a>00033 
<a name="l00041"></a>00041 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00042"></a>00042 <span class="comment">// Tree class definition</span>
<a name="l00043"></a>00043 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00044"></a><a class="code" href="classTree.php">00044</a> <span class="keyword">class </span><a class="code" href="classTree.php">Tree</a> : <span class="keyword">public</span> <a class="code" href="classTreeBase.php">TreeBase</a>
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046 <span class="keyword">public</span>:
<a name="l00047"></a>00047   
<a name="l00051"></a>00051   <a class="code" href="classTree.php#a924b6ac586de554e790d68e28ba8ac7d">Tree</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; m, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level, <a class="code" href="namespaceTrees.php#a8fb02eb8a700b646d106718a2d0ca3ef">Trees::BuildType</a> bt=<a class="code" href="namespaceTrees.php#a8fb02eb8a700b646d106718a2d0ca3efa6ec2eeb88ab0a36caf9a31d79c3da8cb">Trees::NODES</a>);
<a name="l00052"></a>00052 
<a name="l00056"></a>00056   <a class="code" href="classTree.php#a924b6ac586de554e790d68e28ba8ac7d">Tree</a> (<span class="keyword">const</span> <a class="code" href="classTree.php">Tree&lt;N&gt;</a>&amp; other_tree);
<a name="l00057"></a>00057 
<a name="l00061"></a><a class="code" href="classTree.php#af128fde55aa5753a2bf16e6f17dbb13c">00061</a>   <a class="code" href="classTree.php#af128fde55aa5753a2bf16e6f17dbb13c">~Tree</a>() {}
<a name="l00062"></a>00062   
<a name="l00066"></a><a class="code" href="classTree.php#a2c427aac69ce797ff7948702c94335a8">00066</a>   <span class="keywordtype">void</span> <a class="code" href="classTree.php#a2c427aac69ce797ff7948702c94335a8">print_nodes</a>()<span class="keyword"> const</span>
<a name="l00067"></a>00067 <span class="keyword">  </span>{ std::cout &lt;&lt; <span class="stringliteral">&quot;Printing nodes...\n&quot;</span>; <a class="code" href="classTree.php#aaf5c3379430f8260a27c2a93f2267194">root</a>.print_nodes(); }
<a name="l00068"></a>00068 
<a name="l00072"></a><a class="code" href="classTree.php#a8a468697954b73b74822804a0717df63">00072</a>   <span class="keywordtype">void</span> <a class="code" href="classTree.php#a8a468697954b73b74822804a0717df63">print_elements</a>()<span class="keyword"> const</span>
<a name="l00073"></a>00073 <span class="keyword">  </span>{ std::cout &lt;&lt; <span class="stringliteral">&quot;Printing elements...\n&quot;</span>; <a class="code" href="classTree.php#aaf5c3379430f8260a27c2a93f2267194">root</a>.print_elements(); }
<a name="l00074"></a>00074   
<a name="l00078"></a><a class="code" href="classTree.php#a59f38aa97e9939a766213ab9ab10cf7b">00078</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTree.php#a59f38aa97e9939a766213ab9ab10cf7b">n_active_bins</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classTree.php#aaf5c3379430f8260a27c2a93f2267194">root</a>.n_active_bins(); }
<a name="l00079"></a>00079 
<a name="l00083"></a>00083   <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classTree.php#a081fe093bd5672370155debc6166c217">find_element</a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00084"></a>00084 
<a name="l00088"></a>00088   <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classTree.php#a6b8e93c89061d4d98d6002fc93c80c0f">operator() </a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00089"></a>00089   
<a name="l00090"></a>00090   
<a name="l00091"></a>00091 <span class="keyword">private</span>:
<a name="l00092"></a>00092 
<a name="l00093"></a>00093   
<a name="l00097"></a><a class="code" href="classTree.php#aaf5c3379430f8260a27c2a93f2267194">00097</a>   <a class="code" href="classTreeNode.php">TreeNode&lt;N&gt;</a> <a class="code" href="classTree.php#aaf5c3379430f8260a27c2a93f2267194">root</a>;
<a name="l00098"></a>00098 
<a name="l00102"></a><a class="code" href="classTree.php#a750a1c8d19da5d1279a7cc90a83d630f">00102</a>   <span class="keyword">const</span> <a class="code" href="namespaceTrees.php#a8fb02eb8a700b646d106718a2d0ca3ef">Trees::BuildType</a> <a class="code" href="classTree.php#a750a1c8d19da5d1279a7cc90a83d630f">build_type</a>;
<a name="l00103"></a>00103   
<a name="l00104"></a>00104 };
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 
<a name="l00112"></a><a class="code" href="namespaceTrees.php">00112</a> <span class="keyword">namespace </span>Trees
<a name="l00113"></a>00113 {
<a name="l00118"></a><a class="code" href="namespaceTrees.php#aa31e55d7a4d60fa095885778b546d623">00118</a>   <span class="keyword">typedef</span> <a class="code" href="classTree.php">Tree&lt;4&gt;</a> <a class="code" href="namespaceTrees.php#aa31e55d7a4d60fa095885778b546d623">QuadTree</a>;
<a name="l00119"></a>00119 
<a name="l00124"></a><a class="code" href="namespaceTrees.php#a5d5e8a484b5dac1ba377b8d53bcf5da9">00124</a>   <span class="keyword">typedef</span> <a class="code" href="classTree.php">Tree&lt;8&gt;</a> <a class="code" href="namespaceTrees.php#a5d5e8a484b5dac1ba377b8d53bcf5da9">OctTree</a>;
<a name="l00125"></a>00125 }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00130"></a>00130 <span class="comment">// Tree class inline methods</span>
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 <span class="comment">// copy-constructor</span>
<a name="l00135"></a>00135 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00136"></a>00136 <span class="keyword">inline</span>
<a name="l00137"></a><a class="code" href="classTree.php#a0f836e13f44817744f6e8e42a1baa7ed">00137</a> <a class="code" href="classTree.php#a924b6ac586de554e790d68e28ba8ac7d">Tree&lt;N&gt;::Tree</a> (<span class="keyword">const</span> <a class="code" href="classTree.php">Tree&lt;N&gt;</a>&amp; other_tree) :
<a name="l00138"></a>00138   <a class="code" href="classTreeBase.php">TreeBase</a>   (other_tree),
<a name="l00139"></a>00139   root       (other_tree.root),
<a name="l00140"></a>00140   build_type (other_tree.build_type)
<a name="l00141"></a>00141 {
<a name="l00142"></a>00142   libmesh_error();
<a name="l00143"></a>00143 }
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00148"></a>00148 <span class="keyword">inline</span>
<a name="l00149"></a><a class="code" href="classTree.php#a6b8e93c89061d4d98d6002fc93c80c0f">00149</a> <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classTree.php#a6b8e93c89061d4d98d6002fc93c80c0f">Tree&lt;N&gt;::operator() </a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p)<span class="keyword"> const</span>
<a name="l00150"></a>00150 <span class="keyword"></span>{
<a name="l00151"></a>00151   <span class="keywordflow">return</span> this-&gt;find_element(p);
<a name="l00152"></a>00152 }
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
