<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_4f64d75cac7489d141591c33108e86ff.php">utils</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>tree_base.h</h1>  </div>
</div>
<div class="contents">
<a href="tree__base_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: tree_base.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __tree_base_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __tree_base_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;reference_counted_object.h&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Forward Declarations</span>
<a name="l00032"></a>00032 <span class="keyword">class </span><a class="code" href="classTreeBase.php">TreeBase</a>;
<a name="l00033"></a>00033 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00034"></a>00034 <span class="keyword">class </span><a class="code" href="classPoint.php">Point</a>;
<a name="l00035"></a>00035 <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Trees
<a name="l00039"></a>00039 {
<a name="l00046"></a><a class="code" href="namespaceTrees.php#a8fb02eb8a700b646d106718a2d0ca3efa6ec2eeb88ab0a36caf9a31d79c3da8cb">00046</a>   <span class="keyword">enum</span> <a class="code" href="namespaceTrees.php#a8fb02eb8a700b646d106718a2d0ca3ef">BuildType</a> {<a class="code" href="namespaceTrees.php#a8fb02eb8a700b646d106718a2d0ca3efa6ec2eeb88ab0a36caf9a31d79c3da8cb">NODES</a>=0,
<a name="l00047"></a><a class="code" href="namespaceTrees.php#a8fb02eb8a700b646d106718a2d0ca3efac26fb03063d7ed0c6588164e9a29d2cc">00047</a>                   <a class="code" href="namespaceTrees.php#a8fb02eb8a700b646d106718a2d0ca3efac26fb03063d7ed0c6588164e9a29d2cc">ELEMENTS</a>,
<a name="l00048"></a><a class="code" href="namespaceTrees.php#a8fb02eb8a700b646d106718a2d0ca3efae8812d2a55ba399d7ec6b8898ce98cef">00048</a>                   <a class="code" href="namespaceTrees.php#a8fb02eb8a700b646d106718a2d0ca3efae8812d2a55ba399d7ec6b8898ce98cef">INVALID_BUILD_TYPE</a> };
<a name="l00049"></a>00049 }
<a name="l00050"></a>00050 
<a name="l00056"></a>00056 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00057"></a>00057 <span class="comment">// TreeBase class definition</span>
<a name="l00058"></a><a class="code" href="classTreeBase.php">00058</a> <span class="keyword">class </span><a class="code" href="classTreeBase.php">TreeBase</a> : <span class="keyword">public</span> <a class="code" href="classReferenceCountedObject.php">ReferenceCountedObject</a>&lt;TreeBase&gt;
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060 <span class="keyword">protected</span>:  
<a name="l00061"></a>00061 
<a name="l00065"></a>00065   <a class="code" href="classTreeBase.php#a939fe4178d85eda00021f7b458906b6c">TreeBase</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; m);
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 <span class="keyword">public</span>:
<a name="l00069"></a>00069   
<a name="l00073"></a><a class="code" href="classTreeBase.php#a9e69e9a51c2f73112a3c979366bafd52">00073</a>   <span class="keyword">virtual</span> <a class="code" href="classTreeBase.php#a9e69e9a51c2f73112a3c979366bafd52">~TreeBase</a>() {}
<a name="l00074"></a>00074 
<a name="l00078"></a>00078   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classTreeBase.php#ae908f5800b8fa090cf9b098a38d03cf3">print_nodes</a>() <span class="keyword">const</span> = 0;
<a name="l00079"></a>00079 
<a name="l00083"></a>00083   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classTreeBase.php#a677612330f2b6593e18fea50f175eb98">print_elements</a>() <span class="keyword">const</span> = 0;
<a name="l00084"></a>00084   
<a name="l00088"></a>00088   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTreeBase.php#a62d1caa93fea957ecf3e2ca7f27d04d9">n_active_bins</a>() <span class="keyword">const</span> = 0;
<a name="l00089"></a>00089 
<a name="l00093"></a>00093   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classTreeBase.php#ae4e3287db3cd08bf5a19dccab92d1371">find_element</a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p) <span class="keyword">const</span> = 0;
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 <span class="keyword">protected</span>:
<a name="l00096"></a>00096 
<a name="l00101"></a><a class="code" href="classTreeBase.php#a7e068025b3494a36c184d721adfc5b8c">00101</a>   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classTreeBase.php#a7e068025b3494a36c184d721adfc5b8c">mesh</a>;
<a name="l00102"></a>00102   
<a name="l00103"></a>00103 };
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00107"></a>00107 <span class="comment">// TreeBase class inline methods</span>
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 <span class="comment">// constructor</span>
<a name="l00110"></a>00110 <span class="keyword">inline</span>
<a name="l00111"></a><a class="code" href="classTreeBase.php#a939fe4178d85eda00021f7b458906b6c">00111</a> <a class="code" href="classTreeBase.php#a939fe4178d85eda00021f7b458906b6c">TreeBase::TreeBase</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; m) :
<a name="l00112"></a>00112   mesh(m)
<a name="l00113"></a>00113 {
<a name="l00114"></a>00114 }
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
