<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_c2e5aa429b9110fa734bdc9647d91e10.php">utils</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>tree_node.C</h1>  </div>
</div>
<div class="contents">
<a href="tree__node_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: tree_node.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;tree_node.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00032"></a>00032 <span class="comment">// TreeNode class methods</span>
<a name="l00033"></a>00033 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00034"></a><a class="code" href="classTreeNode.php#a576434e6b1e773b00cf300e555bbb6d0">00034</a> <span class="keywordtype">void</span> <a class="code" href="classTreeNode.php#a576434e6b1e773b00cf300e555bbb6d0">TreeNode&lt;N&gt;::insert</a> (<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* nd)
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036   libmesh_assert (nd != NULL);
<a name="l00037"></a>00037   libmesh_assert (nd-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() &lt; mesh.n_nodes());
<a name="l00038"></a>00038 
<a name="l00039"></a>00039   <span class="comment">// Return if we don&#39;t bound the node</span>
<a name="l00040"></a>00040   <span class="keywordflow">if</span> (!this-&gt;bounds_node(nd))
<a name="l00041"></a>00041     <span class="keywordflow">return</span>;
<a name="l00042"></a>00042   
<a name="l00043"></a>00043   <span class="comment">// Only add the node if we are active</span>
<a name="l00044"></a>00044   <span class="keywordflow">if</span> (this-&gt;active())
<a name="l00045"></a>00045     {
<a name="l00046"></a>00046       nodes.push_back (nd);
<a name="l00047"></a>00047 
<a name="l00048"></a>00048       <span class="comment">// Refine ourself if we reach the target bin size for a TreeNode.</span>
<a name="l00049"></a>00049       <span class="keywordflow">if</span> (nodes.size() == tgt_bin_size)
<a name="l00050"></a>00050         this-&gt;refine();
<a name="l00051"></a>00051     }
<a name="l00052"></a>00052   
<a name="l00053"></a>00053   <span class="comment">// If we are not active simply pass the node along to</span>
<a name="l00054"></a>00054   <span class="comment">// our children</span>
<a name="l00055"></a>00055   <span class="keywordflow">else</span>
<a name="l00056"></a>00056     {
<a name="l00057"></a>00057       libmesh_assert (children.size() == N);
<a name="l00058"></a>00058       
<a name="l00059"></a>00059       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;N; c++)
<a name="l00060"></a>00060         children[c]-&gt;insert (nd);
<a name="l00061"></a>00061     }
<a name="l00062"></a>00062 }
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00067"></a><a class="code" href="classTreeNode.php#a40d11a57096e2191f060f1a827634fba">00067</a> <span class="keywordtype">void</span> <a class="code" href="classTreeNode.php#a576434e6b1e773b00cf300e555bbb6d0">TreeNode&lt;N&gt;::insert</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem)
<a name="l00068"></a>00068 {
<a name="l00069"></a>00069   libmesh_assert (elem != NULL);
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   <span class="comment">/* We first want to find the corners of the cuboid surrounding the</span>
<a name="l00072"></a>00072 <span class="comment">     cell.  */</span>
<a name="l00073"></a>00073   <a class="code" href="classPoint.php">Point</a> minCoord = elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(0);
<a name="l00074"></a>00074   <a class="code" href="classPoint.php">Point</a> maxCoord = minCoord;
<a name="l00075"></a>00075   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = elem-&gt;<a class="code" href="classElem.php#a72c710c9b4ebbbdebb707e74165d9625">dim</a>();
<a name="l00076"></a>00076   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>()-1; i&gt;0; i--)
<a name="l00077"></a>00077     {
<a name="l00078"></a>00078       <a class="code" href="classPoint.php">Point</a> p = elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(i);
<a name="l00079"></a>00079       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d=0; d&lt;dim; d++)
<a name="l00080"></a>00080         {
<a name="l00081"></a>00081           <span class="keywordflow">if</span>(minCoord(d)&gt;p(d)) minCoord(d) = p(d);
<a name="l00082"></a>00082           <span class="keywordflow">if</span>(maxCoord(d)&lt;p(d)) maxCoord(d) = p(d);
<a name="l00083"></a>00083         }
<a name="l00084"></a>00084     }
<a name="l00085"></a>00085 
<a name="l00086"></a>00086   <span class="comment">/* Next, find out whether this cuboid has got non-empty intersection</span>
<a name="l00087"></a>00087 <span class="comment">     with the bounding box of the current tree node.  */</span>
<a name="l00088"></a>00088   <span class="keywordtype">bool</span> intersects = <span class="keyword">true</span>;
<a name="l00089"></a>00089   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d=0; d&lt;dim; d++)
<a name="l00090"></a>00090     {
<a name="l00091"></a>00091       <span class="keywordflow">if</span>(maxCoord(d)&lt;this-&gt;<a class="code" href="namespaceMeshTools.php#ad533681876e9809cfe5e2114886b1c03">bounding_box</a>.first(d) ||
<a name="l00092"></a>00092          minCoord(d)&gt;this-&gt;<a class="code" href="namespaceMeshTools.php#ad533681876e9809cfe5e2114886b1c03">bounding_box</a>.second(d))
<a name="l00093"></a>00093         {
<a name="l00094"></a>00094           intersects = <span class="keyword">false</span>;
<a name="l00095"></a>00095         }
<a name="l00096"></a>00096     }
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   <span class="comment">/* If not, we should not care about this element.  */</span>
<a name="l00099"></a>00099   <span class="keywordflow">if</span>(!intersects)
<a name="l00100"></a>00100     {
<a name="l00101"></a>00101       <span class="keywordflow">return</span>;
<a name="l00102"></a>00102     }
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="comment">// Only add the element if we are active</span>
<a name="l00105"></a>00105   <span class="keywordflow">if</span> (this-&gt;active())
<a name="l00106"></a>00106     {
<a name="l00107"></a>00107       elements.push_back (elem);
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00110"></a>00110 <span class="preprocessor"></span>
<a name="l00111"></a>00111       <span class="comment">// flag indicating this node contains</span>
<a name="l00112"></a>00112       <span class="comment">// infinite elements</span>
<a name="l00113"></a>00113       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#ab552f89411c1786564c63daec764d47a">infinite</a>())     
<a name="l00114"></a>00114         this-&gt;contains_ifems = <span class="keyword">true</span>;
<a name="l00115"></a>00115       
<a name="l00116"></a>00116 <span class="preprocessor">#endif</span>
<a name="l00117"></a>00117 <span class="preprocessor"></span>      
<a name="l00118"></a>00118       <span class="comment">// Refine ourself if we reach the target bin size for a TreeNode.</span>
<a name="l00119"></a>00119       <span class="keywordflow">if</span> (elements.size() == tgt_bin_size)
<a name="l00120"></a>00120         this-&gt;refine();
<a name="l00121"></a>00121     }
<a name="l00122"></a>00122   
<a name="l00123"></a>00123   <span class="comment">// If we are not active simply pass the element along to</span>
<a name="l00124"></a>00124   <span class="comment">// our children</span>
<a name="l00125"></a>00125   <span class="keywordflow">else</span>
<a name="l00126"></a>00126     {
<a name="l00127"></a>00127       libmesh_assert (children.size() == N);
<a name="l00128"></a>00128       
<a name="l00129"></a>00129       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;N; c++)
<a name="l00130"></a>00130         children[c]-&gt;insert (elem);
<a name="l00131"></a>00131     }
<a name="l00132"></a>00132 }
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00137"></a><a class="code" href="classTreeNode.php#ab455205b0d416893edf37d671b4fa853">00137</a> <span class="keywordtype">void</span> <a class="code" href="classTreeNode.php#ab455205b0d416893edf37d671b4fa853">TreeNode&lt;N&gt;::refine</a> ()
<a name="l00138"></a>00138 {
<a name="l00139"></a>00139   <span class="comment">// Huh?  better be active...</span>
<a name="l00140"></a>00140   libmesh_assert (this-&gt;active());
<a name="l00141"></a>00141   libmesh_assert (children.empty());
<a name="l00142"></a>00142   
<a name="l00143"></a>00143   <span class="comment">// A TreeNode&lt;N&gt; has by definition N children</span>
<a name="l00144"></a>00144   children.resize(N);
<a name="l00145"></a>00145 
<a name="l00146"></a>00146   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;N; c++)
<a name="l00147"></a>00147     {
<a name="l00148"></a>00148       <span class="comment">// Create the child and set its bounding box.</span>
<a name="l00149"></a>00149       children[c] = <span class="keyword">new</span> <a class="code" href="classTreeNode.php">TreeNode&lt;N&gt;</a> (mesh, tgt_bin_size, <span class="keyword">this</span>);
<a name="l00150"></a>00150       children[c]-&gt;<a class="code" href="classTreeNode.php#abc9fb65ebd3fec45a8efd7cf6508be5d">set_bounding_box</a>(this-&gt;create_bounding_box(c));
<a name="l00151"></a>00151 
<a name="l00152"></a>00152       <span class="comment">// Pass off our nodes to our children</span>
<a name="l00153"></a>00153       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;nodes.size(); n++)
<a name="l00154"></a>00154         children[c]-&gt;insert(nodes[n]);
<a name="l00155"></a>00155 
<a name="l00156"></a>00156       <span class="comment">// Pass off our elements to our children</span>
<a name="l00157"></a>00157       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;elements.size(); e++)
<a name="l00158"></a>00158         children[c]-&gt;insert(elements[e]);
<a name="l00159"></a>00159     }
<a name="l00160"></a>00160 
<a name="l00161"></a>00161   <span class="comment">// We don&#39;t need to store nodes or elements any more,</span>
<a name="l00162"></a>00162   <span class="comment">// they have been added to the children.</span>
<a name="l00163"></a>00163   <span class="comment">// Note that we cannot use std::vector&lt;&gt;::clear() here</span>
<a name="l00164"></a>00164   <span class="comment">// since that in general does not reduce capacity!!</span>
<a name="l00165"></a>00165   <span class="comment">// That would be a bad, bad thing.</span>
<a name="l00166"></a>00166   std::vector&lt;const Node*&gt;().swap(nodes);
<a name="l00167"></a>00167   std::vector&lt;const Elem*&gt;().swap(elements);
<a name="l00168"></a>00168 
<a name="l00169"></a>00169   libmesh_assert (nodes.capacity()    == 0);
<a name="l00170"></a>00170   libmesh_assert (elements.capacity() == 0);
<a name="l00171"></a>00171 }
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00176"></a><a class="code" href="classTreeNode.php#abc9fb65ebd3fec45a8efd7cf6508be5d">00176</a> <span class="keywordtype">void</span> <a class="code" href="classTreeNode.php#abc9fb65ebd3fec45a8efd7cf6508be5d">TreeNode&lt;N&gt;::set_bounding_box</a> (<span class="keyword">const</span> std::pair&lt;Point, Point&gt;&amp; bbox)
<a name="l00177"></a>00177 {
<a name="l00178"></a>00178   <a class="code" href="namespaceMeshTools.php#ad533681876e9809cfe5e2114886b1c03">bounding_box</a> = bbox;
<a name="l00179"></a>00179 }
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00184"></a><a class="code" href="classTreeNode.php#abada899f335015b4642cdd95c0c231d6">00184</a> <span class="keywordtype">bool</span> <a class="code" href="classTreeNode.php#abada899f335015b4642cdd95c0c231d6">TreeNode&lt;N&gt;::bounds_point</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p)<span class="keyword"> const</span>
<a name="l00185"></a>00185 <span class="keyword"></span>{
<a name="l00186"></a>00186   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a> = <a class="code" href="namespaceMeshTools.php#ad533681876e9809cfe5e2114886b1c03">bounding_box</a>.first;
<a name="l00187"></a>00187   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a> = <a class="code" href="namespaceMeshTools.php#ad533681876e9809cfe5e2114886b1c03">bounding_box</a>.second;
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 
<a name="l00190"></a>00190   <span class="keywordflow">if</span> ((p(0) &gt;= <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(0)) &amp;&amp;
<a name="l00191"></a>00191       (p(1) &gt;= <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(1)) &amp;&amp;
<a name="l00192"></a>00192       (p(2) &gt;= <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(2)) &amp;&amp;
<a name="l00193"></a>00193       
<a name="l00194"></a>00194       (p(0) &lt;= <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(0)) &amp;&amp;
<a name="l00195"></a>00195       (p(1) &lt;= <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(1)) &amp;&amp;
<a name="l00196"></a>00196       (p(2) &lt;= <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(2)))
<a name="l00197"></a>00197     <span class="keywordflow">return</span> <span class="keyword">true</span>;   
<a name="l00198"></a>00198 
<a name="l00199"></a>00199   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00200"></a>00200 }
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00205"></a>00205 std::pair&lt;Point, Point&gt; 
<a name="l00206"></a><a class="code" href="classTreeNode.php#adecdf642492d7d01917a8e7601002177">00206</a> <a class="code" href="classTreeNode.php#adecdf642492d7d01917a8e7601002177">TreeNode&lt;N&gt;::create_bounding_box</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c)<span class="keyword"> const</span>
<a name="l00207"></a>00207 <span class="keyword"></span>{
<a name="l00208"></a>00208   <span class="keywordflow">switch</span> (N)
<a name="l00209"></a>00209     {
<a name="l00210"></a>00210 
<a name="l00211"></a>00211       <span class="comment">// How to refine an OctTree Node</span>
<a name="l00212"></a>00212     <span class="keywordflow">case</span> 8:
<a name="l00213"></a>00213       {
<a name="l00214"></a>00214         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xmin = <a class="code" href="namespaceMeshTools.php#ad533681876e9809cfe5e2114886b1c03">bounding_box</a>.first(0);
<a name="l00215"></a>00215         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> ymin = <a class="code" href="namespaceMeshTools.php#ad533681876e9809cfe5e2114886b1c03">bounding_box</a>.first(1);
<a name="l00216"></a>00216         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> zmin = <a class="code" href="namespaceMeshTools.php#ad533681876e9809cfe5e2114886b1c03">bounding_box</a>.first(2);
<a name="l00217"></a>00217 
<a name="l00218"></a>00218         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xmax = <a class="code" href="namespaceMeshTools.php#ad533681876e9809cfe5e2114886b1c03">bounding_box</a>.second(0);
<a name="l00219"></a>00219         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> ymax = <a class="code" href="namespaceMeshTools.php#ad533681876e9809cfe5e2114886b1c03">bounding_box</a>.second(1);
<a name="l00220"></a>00220         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> zmax = <a class="code" href="namespaceMeshTools.php#ad533681876e9809cfe5e2114886b1c03">bounding_box</a>.second(2);
<a name="l00221"></a>00221 
<a name="l00222"></a>00222         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xc = xmin + .5*(xmax - xmin);
<a name="l00223"></a>00223         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> yc = ymin + .5*(ymax - ymin);
<a name="l00224"></a>00224         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> zc = zmin + .5*(zmax - zmin);
<a name="l00225"></a>00225 
<a name="l00226"></a>00226         
<a name="l00227"></a>00227         <span class="keywordflow">switch</span> (c)
<a name="l00228"></a>00228           {
<a name="l00229"></a>00229 
<a name="l00230"></a>00230           <span class="keywordflow">case</span> 0:
<a name="l00231"></a>00231             {
<a name="l00232"></a>00232               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(xmin, ymin, zmin);
<a name="l00233"></a>00233               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(xc,   yc,   zc);
<a name="l00234"></a>00234               <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00235"></a>00235               <span class="keywordflow">break</span>;
<a name="l00236"></a>00236             }
<a name="l00237"></a>00237 
<a name="l00238"></a>00238           <span class="keywordflow">case</span> 1:
<a name="l00239"></a>00239             {
<a name="l00240"></a>00240               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(xc,   ymin, zmin);
<a name="l00241"></a>00241               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(xmax, yc,   zc);
<a name="l00242"></a>00242               <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00243"></a>00243               <span class="keywordflow">break</span>;
<a name="l00244"></a>00244             }
<a name="l00245"></a>00245 
<a name="l00246"></a>00246           <span class="keywordflow">case</span> 2:
<a name="l00247"></a>00247             {
<a name="l00248"></a>00248               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(xmin, yc,   zmin);
<a name="l00249"></a>00249               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(xc,   ymax, zc);
<a name="l00250"></a>00250               <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00251"></a>00251               <span class="keywordflow">break</span>;
<a name="l00252"></a>00252             }
<a name="l00253"></a>00253 
<a name="l00254"></a>00254           <span class="keywordflow">case</span> 3:
<a name="l00255"></a>00255             {
<a name="l00256"></a>00256               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(xc,   yc,   zmin);
<a name="l00257"></a>00257               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(xmax, ymax, zc);
<a name="l00258"></a>00258               <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00259"></a>00259               <span class="keywordflow">break</span>;
<a name="l00260"></a>00260             }
<a name="l00261"></a>00261 
<a name="l00262"></a>00262           <span class="keywordflow">case</span> 4:
<a name="l00263"></a>00263             {
<a name="l00264"></a>00264               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(xmin, ymin, zc);
<a name="l00265"></a>00265               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(xc,   yc,   zmax);
<a name="l00266"></a>00266               <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00267"></a>00267               <span class="keywordflow">break</span>;
<a name="l00268"></a>00268             }
<a name="l00269"></a>00269 
<a name="l00270"></a>00270           <span class="keywordflow">case</span> 5:
<a name="l00271"></a>00271             {
<a name="l00272"></a>00272               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(xc,   ymin, zc);
<a name="l00273"></a>00273               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(xmax, yc,   zmax);
<a name="l00274"></a>00274               <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00275"></a>00275               <span class="keywordflow">break</span>;
<a name="l00276"></a>00276             }
<a name="l00277"></a>00277 
<a name="l00278"></a>00278           <span class="keywordflow">case</span> 6:
<a name="l00279"></a>00279             {
<a name="l00280"></a>00280               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(xmin, yc,   zc);
<a name="l00281"></a>00281               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(xc,   ymax, zmax);
<a name="l00282"></a>00282               <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00283"></a>00283               <span class="keywordflow">break</span>;
<a name="l00284"></a>00284             }
<a name="l00285"></a>00285 
<a name="l00286"></a>00286           <span class="keywordflow">case</span> 7:
<a name="l00287"></a>00287             {
<a name="l00288"></a>00288               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(xc,   yc,   zc);
<a name="l00289"></a>00289               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(xmax, ymax, zmax);
<a name="l00290"></a>00290               <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00291"></a>00291               <span class="keywordflow">break</span>;
<a name="l00292"></a>00292             }
<a name="l00293"></a>00293     
<a name="l00294"></a>00294           <span class="keywordflow">default</span>:
<a name="l00295"></a>00295             std::cerr &lt;&lt; <span class="stringliteral">&quot;c &gt;= N! : &quot;</span> &lt;&lt; c
<a name="l00296"></a>00296                       &lt;&lt; std::endl;
<a name="l00297"></a>00297             libmesh_error();
<a name="l00298"></a>00298           }
<a name="l00299"></a>00299 
<a name="l00300"></a>00300 
<a name="l00301"></a>00301 
<a name="l00302"></a>00302         <span class="keywordflow">break</span>;
<a name="l00303"></a>00303       } <span class="comment">// case 8</span>
<a name="l00304"></a>00304 
<a name="l00305"></a>00305       <span class="comment">// How to refine an QuadTree Node</span>
<a name="l00306"></a>00306     <span class="keywordflow">case</span> 4:
<a name="l00307"></a>00307       {
<a name="l00308"></a>00308         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xmin = <a class="code" href="namespaceMeshTools.php#ad533681876e9809cfe5e2114886b1c03">bounding_box</a>.first(0);
<a name="l00309"></a>00309         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> ymin = <a class="code" href="namespaceMeshTools.php#ad533681876e9809cfe5e2114886b1c03">bounding_box</a>.first(1);
<a name="l00310"></a>00310 
<a name="l00311"></a>00311         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xmax = <a class="code" href="namespaceMeshTools.php#ad533681876e9809cfe5e2114886b1c03">bounding_box</a>.second(0);
<a name="l00312"></a>00312         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> ymax = <a class="code" href="namespaceMeshTools.php#ad533681876e9809cfe5e2114886b1c03">bounding_box</a>.second(1);
<a name="l00313"></a>00313 
<a name="l00314"></a>00314         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xc = xmin + .5*(xmax - xmin);
<a name="l00315"></a>00315         <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> yc = ymin + .5*(ymax - ymin);
<a name="l00316"></a>00316 
<a name="l00317"></a>00317         <span class="keywordflow">switch</span> (c)
<a name="l00318"></a>00318           {
<a name="l00319"></a>00319           <span class="keywordflow">case</span> 0:
<a name="l00320"></a>00320             {
<a name="l00321"></a>00321               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(xmin, ymin);
<a name="l00322"></a>00322               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(xc,   yc);
<a name="l00323"></a>00323               <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00324"></a>00324               <span class="keywordflow">break</span>;
<a name="l00325"></a>00325             }
<a name="l00326"></a>00326 
<a name="l00327"></a>00327           <span class="keywordflow">case</span> 1:
<a name="l00328"></a>00328             {
<a name="l00329"></a>00329               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(xc,   ymin);
<a name="l00330"></a>00330               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(xmax, yc);
<a name="l00331"></a>00331               <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00332"></a>00332               <span class="keywordflow">break</span>;
<a name="l00333"></a>00333             }
<a name="l00334"></a>00334 
<a name="l00335"></a>00335           <span class="keywordflow">case</span> 2:
<a name="l00336"></a>00336             {
<a name="l00337"></a>00337               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(xmin, yc);
<a name="l00338"></a>00338               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(xc,   ymax);
<a name="l00339"></a>00339               <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00340"></a>00340               <span class="keywordflow">break</span>;
<a name="l00341"></a>00341             }
<a name="l00342"></a>00342 
<a name="l00343"></a>00343           <span class="keywordflow">case</span> 3:
<a name="l00344"></a>00344             {
<a name="l00345"></a>00345               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(xc,   yc);
<a name="l00346"></a>00346               <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(xmax, ymax);
<a name="l00347"></a>00347               <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00348"></a>00348               <span class="keywordflow">break</span>;
<a name="l00349"></a>00349             }
<a name="l00350"></a>00350             
<a name="l00351"></a>00351           <span class="keywordflow">default</span>:
<a name="l00352"></a>00352             std::cerr &lt;&lt; <span class="stringliteral">&quot;c &gt;= N!&quot;</span> &lt;&lt; std::endl;
<a name="l00353"></a>00353             libmesh_error();
<a name="l00354"></a>00354             
<a name="l00355"></a>00355           }
<a name="l00356"></a>00356 
<a name="l00357"></a>00357         <span class="keywordflow">break</span>;
<a name="l00358"></a>00358       } <span class="comment">// case 4</span>
<a name="l00359"></a>00359 
<a name="l00360"></a>00360     <span class="keywordflow">default</span>:
<a name="l00361"></a>00361       std::cerr &lt;&lt; <span class="stringliteral">&quot;Only implemented for Octrees and QuadTrees!&quot;</span> &lt;&lt; std::endl;
<a name="l00362"></a>00362       libmesh_error();
<a name="l00363"></a>00363 
<a name="l00364"></a>00364     }
<a name="l00365"></a>00365 
<a name="l00366"></a>00366   <span class="comment">// How did we get here?</span>
<a name="l00367"></a>00367   libmesh_error();
<a name="l00368"></a>00368 
<a name="l00369"></a>00369   <a class="code" href="classPoint.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>, <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>;  
<a name="l00370"></a>00370   <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00371"></a>00371 }
<a name="l00372"></a>00372 
<a name="l00373"></a>00373 
<a name="l00374"></a>00374 
<a name="l00375"></a>00375 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00376"></a><a class="code" href="classTreeNode.php#aa0c38c7f8f98e6c506f623da0ead7b70">00376</a> <span class="keywordtype">void</span> <a class="code" href="classTreeNode.php#aa0c38c7f8f98e6c506f623da0ead7b70">TreeNode&lt;N&gt;::print_nodes</a>()<span class="keyword"> const</span>
<a name="l00377"></a>00377 <span class="keyword"></span>{
<a name="l00378"></a>00378   <span class="keywordflow">if</span> (this-&gt;active())
<a name="l00379"></a>00379     {
<a name="l00380"></a>00380       std::cout &lt;&lt; <span class="stringliteral">&quot;TreeNode Level: &quot;</span> &lt;&lt; this-&gt;level() &lt;&lt; std::endl;
<a name="l00381"></a>00381       
<a name="l00382"></a>00382       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;nodes.size(); n++)
<a name="l00383"></a>00383         std::cout &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; nodes[n]-&gt;<span class="keywordtype">id</span>();
<a name="l00384"></a>00384       
<a name="l00385"></a>00385       std::cout &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l00386"></a>00386         
<a name="l00387"></a>00387     }
<a name="l00388"></a>00388   <span class="keywordflow">else</span>
<a name="l00389"></a>00389     {
<a name="l00390"></a>00390       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> child=0; child&lt;children.size(); child++)
<a name="l00391"></a>00391         children[child]-&gt;print_nodes();
<a name="l00392"></a>00392     }
<a name="l00393"></a>00393 }
<a name="l00394"></a>00394 
<a name="l00395"></a>00395 
<a name="l00396"></a>00396 
<a name="l00397"></a>00397 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00398"></a><a class="code" href="classTreeNode.php#a8182d2220e7208942d35ff263d72705f">00398</a> <span class="keywordtype">void</span> <a class="code" href="classTreeNode.php#a8182d2220e7208942d35ff263d72705f">TreeNode&lt;N&gt;::print_elements</a>()<span class="keyword"> const</span>
<a name="l00399"></a>00399 <span class="keyword"></span>{
<a name="l00400"></a>00400   <span class="keywordflow">if</span> (this-&gt;active())
<a name="l00401"></a>00401     {
<a name="l00402"></a>00402       std::cout &lt;&lt; <span class="stringliteral">&quot;TreeNode Level: &quot;</span> &lt;&lt; this-&gt;level() &lt;&lt; std::endl;
<a name="l00403"></a>00403      
<a name="l00404"></a>00404       <span class="keywordflow">for</span> (std::vector&lt;const Elem*&gt;::const_iterator pos=elements.begin();
<a name="l00405"></a>00405            pos != elements.end(); ++pos)
<a name="l00406"></a>00406         std::cout &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; *pos;
<a name="l00407"></a>00407 
<a name="l00408"></a>00408       std::cout &lt;&lt; std::endl &lt;&lt; std::endl;      
<a name="l00409"></a>00409     }
<a name="l00410"></a>00410   <span class="keywordflow">else</span>
<a name="l00411"></a>00411     {
<a name="l00412"></a>00412       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> child=0; child&lt;children.size(); child++)
<a name="l00413"></a>00413         children[child]-&gt;print_elements();
<a name="l00414"></a>00414     }
<a name="l00415"></a>00415 }
<a name="l00416"></a>00416 
<a name="l00417"></a>00417 
<a name="l00418"></a>00418 
<a name="l00419"></a>00419 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00420"></a><a class="code" href="classTreeNode.php#a81cc59e0196f7c478b354ee46550c3aa">00420</a> <span class="keywordtype">void</span> <a class="code" href="classTreeNode.php#a81cc59e0196f7c478b354ee46550c3aa">TreeNode&lt;N&gt;::transform_nodes_to_elements</a> (std::vector&lt;std::vector&lt;const Elem*&gt; &gt;&amp; nodes_to_elem)
<a name="l00421"></a>00421 {
<a name="l00422"></a>00422    <span class="keywordflow">if</span> (this-&gt;active())
<a name="l00423"></a>00423     {
<a name="l00424"></a>00424       elements.clear();
<a name="l00425"></a>00425 
<a name="l00426"></a>00426       <span class="comment">// Temporarily use a set. Since multiple nodes</span>
<a name="l00427"></a>00427       <span class="comment">// will likely map to the same element we use a</span>
<a name="l00428"></a>00428       <span class="comment">// set to eliminate the duplication.</span>
<a name="l00429"></a>00429       std::set&lt;const Elem*&gt; elements_set;
<a name="l00430"></a>00430       
<a name="l00431"></a>00431       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;nodes.size(); n++)
<a name="l00432"></a>00432         {
<a name="l00433"></a>00433           <span class="comment">// the actual global node number we are replacing</span>
<a name="l00434"></a>00434           <span class="comment">// with the connected elements</span>
<a name="l00435"></a>00435           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_number = nodes[n]-&gt;id();
<a name="l00436"></a>00436 
<a name="l00437"></a>00437           libmesh_assert (node_number &lt; mesh.n_nodes());
<a name="l00438"></a>00438           libmesh_assert (node_number &lt; nodes_to_elem.size());
<a name="l00439"></a>00439           
<a name="l00440"></a>00440           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;nodes_to_elem[node_number].size(); e++)
<a name="l00441"></a>00441             elements_set.insert(nodes_to_elem[node_number][e]);
<a name="l00442"></a>00442         }
<a name="l00443"></a>00443 
<a name="l00444"></a>00444       <span class="comment">// Done with the nodes.</span>
<a name="l00445"></a>00445       std::vector&lt;const Node*&gt;().swap(nodes);
<a name="l00446"></a>00446 
<a name="l00447"></a>00447       <span class="comment">// Now the set is built.  We can copy this to the</span>
<a name="l00448"></a>00448       <span class="comment">// vector.  Note that the resulting vector will </span>
<a name="l00449"></a>00449       <span class="comment">// already be sorted, and will require less memory</span>
<a name="l00450"></a>00450       <span class="comment">// than the set.</span>
<a name="l00451"></a>00451       elements.reserve(elements_set.size());
<a name="l00452"></a>00452 
<a name="l00453"></a>00453       <span class="keywordflow">for</span> (std::set&lt;const Elem*&gt;::iterator pos=elements_set.begin();
<a name="l00454"></a>00454            pos != elements_set.end(); ++pos)
<a name="l00455"></a>00455         {
<a name="l00456"></a>00456           elements.push_back(*pos);
<a name="l00457"></a>00457           
<a name="l00458"></a>00458 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00459"></a>00459 <span class="preprocessor"></span>
<a name="l00460"></a>00460           <span class="comment">// flag indicating this node contains</span>
<a name="l00461"></a>00461           <span class="comment">// infinite elements</span>
<a name="l00462"></a>00462           <span class="keywordflow">if</span> ((*pos)-&gt;infinite())
<a name="l00463"></a>00463             this-&gt;contains_ifems = <span class="keyword">true</span>;
<a name="l00464"></a>00464           
<a name="l00465"></a>00465 <span class="preprocessor">#endif</span>
<a name="l00466"></a>00466 <span class="preprocessor"></span>        }
<a name="l00467"></a>00467     }
<a name="l00468"></a>00468   <span class="keywordflow">else</span>
<a name="l00469"></a>00469     {
<a name="l00470"></a>00470       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> child=0; child&lt;children.size(); child++)
<a name="l00471"></a>00471         children[child]-&gt;transform_nodes_to_elements (nodes_to_elem);
<a name="l00472"></a>00472     }
<a name="l00473"></a>00473  
<a name="l00474"></a>00474 }
<a name="l00475"></a>00475 
<a name="l00476"></a>00476 
<a name="l00477"></a>00477 
<a name="l00478"></a>00478 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00479"></a><a class="code" href="classTreeNode.php#a61004c4e026d29719642f68686833699">00479</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTreeNode.php#a61004c4e026d29719642f68686833699">TreeNode&lt;N&gt;::n_active_bins</a>()<span class="keyword"> const</span>
<a name="l00480"></a>00480 <span class="keyword"></span>{
<a name="l00481"></a>00481   <span class="keywordflow">if</span> (this-&gt;active())
<a name="l00482"></a>00482     <span class="keywordflow">return</span> 1;
<a name="l00483"></a>00483   
<a name="l00484"></a>00484   <span class="keywordflow">else</span>
<a name="l00485"></a>00485     {
<a name="l00486"></a>00486       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sum=0;
<a name="l00487"></a>00487 
<a name="l00488"></a>00488       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;children.size(); c++)
<a name="l00489"></a>00489         sum += children[c]-&gt;n_active_bins();
<a name="l00490"></a>00490 
<a name="l00491"></a>00491       <span class="keywordflow">return</span> sum;
<a name="l00492"></a>00492     }
<a name="l00493"></a>00493 }
<a name="l00494"></a>00494 
<a name="l00495"></a>00495 
<a name="l00496"></a>00496 
<a name="l00497"></a>00497 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00498"></a><a class="code" href="classTreeNode.php#aa67121249cf70f3e5bebb8110600b5b8">00498</a> <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classTreeNode.php#aa67121249cf70f3e5bebb8110600b5b8">TreeNode&lt;N&gt;::find_element</a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p)<span class="keyword"> const</span>
<a name="l00499"></a>00499 <span class="keyword"></span>{
<a name="l00500"></a>00500   <span class="keywordflow">if</span> (this-&gt;active())
<a name="l00501"></a>00501     {
<a name="l00502"></a>00502       <span class="comment">// Only check our children if the point is in our bounding box</span>
<a name="l00503"></a>00503       <span class="comment">// or if the node contains infinite elements</span>
<a name="l00504"></a>00504       <span class="keywordflow">if</span> (this-&gt;bounds_point(p) || this-&gt;contains_ifems)
<a name="l00505"></a>00505         <span class="comment">// Search the active elements in the active TreeNode.</span>
<a name="l00506"></a>00506         <span class="keywordflow">for</span> (std::vector&lt;const Elem*&gt;::const_iterator pos=elements.begin();
<a name="l00507"></a>00507              pos != elements.end(); ++pos)
<a name="l00508"></a>00508           <span class="keywordflow">if</span> ((*pos)-&gt;active())
<a name="l00509"></a>00509             <span class="keywordflow">if</span> ((*pos)-&gt;contains_point(p))
<a name="l00510"></a>00510               <span class="keywordflow">return</span> *pos;
<a name="l00511"></a>00511       
<a name="l00512"></a>00512       <span class="comment">// The point was not found in any element</span>
<a name="l00513"></a>00513       <span class="keywordflow">return</span> NULL;          
<a name="l00514"></a>00514     }
<a name="l00515"></a>00515   <span class="keywordflow">else</span>
<a name="l00516"></a>00516     <span class="keywordflow">return</span> this-&gt;find_element_in_children(p);
<a name="l00517"></a>00517   
<a name="l00518"></a>00518     
<a name="l00519"></a>00519 
<a name="l00520"></a>00520   <span class="comment">// Should never get here.  See if-else structure</span>
<a name="l00521"></a>00521   <span class="comment">// above with return statements that must get executed.</span>
<a name="l00522"></a>00522   libmesh_error();
<a name="l00523"></a>00523   
<a name="l00524"></a>00524   <span class="keywordflow">return</span> NULL;
<a name="l00525"></a>00525 }
<a name="l00526"></a>00526 
<a name="l00527"></a>00527 
<a name="l00528"></a>00528 
<a name="l00529"></a>00529 
<a name="l00530"></a>00530 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00531"></a><a class="code" href="classTreeNode.php#afcfa90940617fac194387f0eefb3283e">00531</a> <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classTreeNode.php#afcfa90940617fac194387f0eefb3283e">TreeNode&lt;N&gt;::find_element_in_children</a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p)<span class="keyword"> const</span>
<a name="l00532"></a>00532 <span class="keyword"></span>{
<a name="l00533"></a>00533   libmesh_assert (!this-&gt;active());
<a name="l00534"></a>00534 
<a name="l00535"></a>00535   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> excluded_child = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00536"></a>00536   
<a name="l00537"></a>00537   <span class="comment">// First only look in the children whose bounding box</span>
<a name="l00538"></a>00538   <span class="comment">// contain the point p.  Note that only one child will</span>
<a name="l00539"></a>00539   <span class="comment">// bound the point since the bounding boxes are not</span>
<a name="l00540"></a>00540   <span class="comment">// overlapping</span>
<a name="l00541"></a>00541   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;children.size(); c++)
<a name="l00542"></a>00542     <span class="keywordflow">if</span> (children[c]-&gt;bounds_point(p))
<a name="l00543"></a>00543       {
<a name="l00544"></a>00544         <span class="keywordflow">if</span> (children[c]-&gt;active())
<a name="l00545"></a>00545           {
<a name="l00546"></a>00546             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* e = children[c]-&gt;find_element(p);
<a name="l00547"></a>00547             
<a name="l00548"></a>00548             <span class="keywordflow">if</span> (e != NULL)
<a name="l00549"></a>00549               <span class="keywordflow">return</span> e;   
<a name="l00550"></a>00550           }
<a name="l00551"></a>00551         <span class="keywordflow">else</span>
<a name="l00552"></a>00552           {
<a name="l00553"></a>00553             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* e = children[c]-&gt;find_element_in_children(p);
<a name="l00554"></a>00554 
<a name="l00555"></a>00555             <span class="keywordflow">if</span> (e != NULL)
<a name="l00556"></a>00556               <span class="keywordflow">return</span> e;
<a name="l00557"></a>00557           }
<a name="l00558"></a>00558 
<a name="l00559"></a>00559         <span class="comment">// If we get here than the child that bounds the</span>
<a name="l00560"></a>00560         <span class="comment">// point does not have any elements that contain</span>
<a name="l00561"></a>00561         <span class="comment">// the point.  So, we will search all our children.</span>
<a name="l00562"></a>00562         <span class="comment">// However, we have already searched child c so there</span>
<a name="l00563"></a>00563         <span class="comment">// is no use searching her again.</span>
<a name="l00564"></a>00564         excluded_child = c;
<a name="l00565"></a>00565       }
<a name="l00566"></a>00566          
<a name="l00567"></a>00567 
<a name="l00568"></a>00568   <span class="comment">// If we get here then our child whose bounding box</span>
<a name="l00569"></a>00569   <span class="comment">// was searched and did not find any elements containing</span>
<a name="l00570"></a>00570   <span class="comment">// the point p.  So, let&#39;s look at the other children</span>
<a name="l00571"></a>00571   <span class="comment">// but exclude the one we have already searched.</span>
<a name="l00572"></a>00572   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;children.size(); c++)
<a name="l00573"></a>00573     <span class="keywordflow">if</span> (c != excluded_child)    
<a name="l00574"></a>00574       {
<a name="l00575"></a>00575         <span class="keywordflow">if</span> (children[c]-&gt;active())
<a name="l00576"></a>00576           {
<a name="l00577"></a>00577             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* e = children[c]-&gt;find_element(p);
<a name="l00578"></a>00578             
<a name="l00579"></a>00579             <span class="keywordflow">if</span> (e != NULL)
<a name="l00580"></a>00580               <span class="keywordflow">return</span> e;   
<a name="l00581"></a>00581           }
<a name="l00582"></a>00582         <span class="keywordflow">else</span>
<a name="l00583"></a>00583           {
<a name="l00584"></a>00584             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* e = children[c]-&gt;find_element_in_children(p);
<a name="l00585"></a>00585             
<a name="l00586"></a>00586             <span class="keywordflow">if</span> (e != NULL)
<a name="l00587"></a>00587               <span class="keywordflow">return</span> e;
<a name="l00588"></a>00588           }
<a name="l00589"></a>00589       }
<a name="l00590"></a>00590 
<a name="l00591"></a>00591   <span class="comment">// If we get here we have searched all our children.</span>
<a name="l00592"></a>00592   <span class="comment">// Since this process was started at the root node then</span>
<a name="l00593"></a>00593   <span class="comment">// we have searched all the elements in the tree without</span>
<a name="l00594"></a>00594   <span class="comment">// success.  So, we should return NULL since at this point</span>
<a name="l00595"></a>00595   <span class="comment">// _no_ elements in the tree claim to contain point p.</span>
<a name="l00596"></a>00596   
<a name="l00597"></a>00597   <span class="keywordflow">return</span> NULL;     
<a name="l00598"></a>00598 }
<a name="l00599"></a>00599 
<a name="l00600"></a>00600 
<a name="l00601"></a>00601 
<a name="l00602"></a>00602 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00603"></a>00603 <span class="comment">// Explicit Instantiations</span>
<a name="l00604"></a>00604 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classTreeNode.php">TreeNode&lt;4&gt;</a>;
<a name="l00605"></a>00605 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classTreeNode.php">TreeNode&lt;8&gt;</a>;
<a name="l00606"></a>00606 
<a name="l00607"></a>00607 
<a name="l00608"></a>00608 
<a name="l00609"></a>00609 
<a name="l00610"></a>00610 
<a name="l00611"></a>00611 
<a name="l00612"></a>00612 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
