<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_4f64d75cac7489d141591c33108e86ff.php">utils</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>tree_node.h</h1>  </div>
</div>
<div class="contents">
<a href="tree__node_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: tree_node.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __tree_node_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __tree_node_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;point.h&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Forward Declarations</span>
<a name="l00033"></a>00033 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00034"></a>00034 <span class="keyword">class </span><a class="code" href="classNode.php">Node</a>;
<a name="l00035"></a>00035 <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00036"></a>00036 
<a name="l00043"></a>00043 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00044"></a><a class="code" href="classTreeNode.php">00044</a> <span class="keyword">class </span><a class="code" href="classTreeNode.php">TreeNode</a>
<a name="l00045"></a>00045 {  
<a name="l00046"></a>00046 <span class="keyword">public</span>:
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 
<a name="l00054"></a>00054   <a class="code" href="classTreeNode.php#ab34a67db78b7ea368c5f6e4e1706f34f">TreeNode</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; m, 
<a name="l00055"></a>00055             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tbs,         
<a name="l00056"></a>00056             <span class="keyword">const</span> <a class="code" href="classTreeNode.php">TreeNode&lt;N&gt;</a> *p = NULL);
<a name="l00057"></a>00057 
<a name="l00063"></a>00063   <a class="code" href="classTreeNode.php#a379f84ac3ada5e07cb516c6dabe9fe29">~TreeNode</a> ();
<a name="l00064"></a>00064 
<a name="l00069"></a><a class="code" href="classTreeNode.php#a5fc7b776eea0823c8ddc4bf36451953c">00069</a>   <span class="keywordtype">bool</span> <a class="code" href="classTreeNode.php#a5fc7b776eea0823c8ddc4bf36451953c">is_root</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (<a class="code" href="classTreeNode.php#a56060e907118c92f427b237c46245661">parent</a> == NULL); }
<a name="l00070"></a>00070 
<a name="l00075"></a><a class="code" href="classTreeNode.php#a0679f3627ca64d1425cf8f7a8dd221fc">00075</a>   <span class="keywordtype">bool</span> <a class="code" href="classTreeNode.php#a0679f3627ca64d1425cf8f7a8dd221fc">active</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classTreeNode.php#a5680127b6f4ba3523f48efd2c6197d24">children</a>.empty(); }
<a name="l00076"></a>00076 
<a name="l00080"></a>00080   <span class="keywordtype">void</span> <a class="code" href="classTreeNode.php#a576434e6b1e773b00cf300e555bbb6d0">insert</a> (<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* nd);
<a name="l00081"></a>00081 
<a name="l00085"></a>00085   <span class="keywordtype">void</span> <a class="code" href="classTreeNode.php#a576434e6b1e773b00cf300e555bbb6d0">insert</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* nd);
<a name="l00086"></a>00086 
<a name="l00091"></a>00091   <span class="keywordtype">void</span> <a class="code" href="classTreeNode.php#ab455205b0d416893edf37d671b4fa853">refine</a> (); 
<a name="l00092"></a>00092 
<a name="l00096"></a>00096   <span class="keywordtype">void</span> <a class="code" href="classTreeNode.php#abc9fb65ebd3fec45a8efd7cf6508be5d">set_bounding_box</a> (<span class="keyword">const</span> std::pair&lt;Point, Point&gt;&amp; bbox);
<a name="l00097"></a>00097 
<a name="l00102"></a><a class="code" href="classTreeNode.php#aed819f41304b7036c5d9a0ed15f683cc">00102</a>   <span class="keywordtype">bool</span> <a class="code" href="classTreeNode.php#aed819f41304b7036c5d9a0ed15f683cc">bounds_node</a> (<span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* nd)<span class="keyword"> const</span>
<a name="l00103"></a>00103 <span class="keyword">  </span>{ libmesh_assert (nd != NULL); <span class="keywordflow">return</span> <a class="code" href="classTreeNode.php#abada899f335015b4642cdd95c0c231d6">bounds_point</a>(*nd); }
<a name="l00104"></a>00104 
<a name="l00109"></a>00109   <span class="keywordtype">bool</span> <a class="code" href="classTreeNode.php#abada899f335015b4642cdd95c0c231d6">bounds_point</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> &amp;p) <span class="keyword">const</span>;
<a name="l00110"></a>00110 
<a name="l00114"></a>00114   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTreeNode.php#a3074fb50607adbdba139f2b7b4d77b21">level</a> () <span class="keyword">const</span>; 
<a name="l00115"></a>00115     
<a name="l00120"></a>00120   <span class="keywordtype">void</span> <a class="code" href="classTreeNode.php#aa0c38c7f8f98e6c506f623da0ead7b70">print_nodes</a>() <span class="keyword">const</span>;
<a name="l00121"></a>00121     
<a name="l00126"></a>00126   <span class="keywordtype">void</span> <a class="code" href="classTreeNode.php#a8182d2220e7208942d35ff263d72705f">print_elements</a>() <span class="keyword">const</span>;
<a name="l00127"></a>00127 
<a name="l00131"></a>00131   <span class="keywordtype">void</span> <a class="code" href="classTreeNode.php#a81cc59e0196f7c478b354ee46550c3aa">transform_nodes_to_elements</a> (std::vector&lt;std::vector&lt;const Elem*&gt; &gt;&amp; 
<a name="l00132"></a>00132                                     nodes_to_elem);
<a name="l00133"></a>00133 
<a name="l00138"></a>00138   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTreeNode.php#a61004c4e026d29719642f68686833699">n_active_bins</a>() <span class="keyword">const</span>;
<a name="l00139"></a>00139 
<a name="l00143"></a>00143   <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classTreeNode.php#aa67121249cf70f3e5bebb8110600b5b8">find_element</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00144"></a>00144 
<a name="l00145"></a>00145   
<a name="l00146"></a>00146 <span class="keyword">private</span>:
<a name="l00147"></a>00147 
<a name="l00148"></a>00148   
<a name="l00152"></a>00152   <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classTreeNode.php#afcfa90940617fac194387f0eefb3283e">find_element_in_children</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00153"></a>00153 
<a name="l00157"></a>00157   std::pair&lt;Point, Point&gt; <a class="code" href="classTreeNode.php#adecdf642492d7d01917a8e7601002177">create_bounding_box</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c) <span class="keyword">const</span>;
<a name="l00158"></a>00158 
<a name="l00162"></a><a class="code" href="classTreeNode.php#aea105d149adc88c5278bb48d692db114">00162</a>   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classTreeNode.php#aea105d149adc88c5278bb48d692db114">mesh</a>;
<a name="l00163"></a>00163 
<a name="l00168"></a><a class="code" href="classTreeNode.php#aed4a5b14dce4d5e4b61bed3449be34f7">00168</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTreeNode.php#aed4a5b14dce4d5e4b61bed3449be34f7">tgt_bin_size</a>;
<a name="l00169"></a>00169 
<a name="l00173"></a><a class="code" href="classTreeNode.php#a56060e907118c92f427b237c46245661">00173</a>   <span class="keyword">const</span> <a class="code" href="classTreeNode.php">TreeNode&lt;N&gt;</a> *<a class="code" href="classTreeNode.php#a56060e907118c92f427b237c46245661">parent</a>;
<a name="l00174"></a>00174 
<a name="l00179"></a><a class="code" href="classTreeNode.php#a5680127b6f4ba3523f48efd2c6197d24">00179</a>   std::vector&lt;TreeNode&lt;N&gt;* &gt; <a class="code" href="classTreeNode.php#a5680127b6f4ba3523f48efd2c6197d24">children</a>;
<a name="l00180"></a>00180 
<a name="l00186"></a><a class="code" href="classTreeNode.php#a81af342ad3571c20c58598011321d56b">00186</a>   std::pair&lt;Point, Point&gt; <a class="code" href="classTreeNode.php#a81af342ad3571c20c58598011321d56b">bounding_box</a>;
<a name="l00187"></a>00187 
<a name="l00191"></a><a class="code" href="classTreeNode.php#a6a5e82bca29d698378300f6c8a189fe7">00191</a>   std::vector&lt;const Elem*&gt; <a class="code" href="classTreeNode.php#a6a5e82bca29d698378300f6c8a189fe7">elements</a>;
<a name="l00192"></a>00192 
<a name="l00196"></a><a class="code" href="classTreeNode.php#a545073d8e560d8a458507a7efb02718d">00196</a>   std::vector&lt;const Node*&gt; <a class="code" href="classTreeNode.php#a545073d8e560d8a458507a7efb02718d">nodes</a>;
<a name="l00197"></a>00197 
<a name="l00201"></a><a class="code" href="classTreeNode.php#a5875415042ba082541984db01f5352f2">00201</a>   <span class="keywordtype">bool</span> <a class="code" href="classTreeNode.php#a5875415042ba082541984db01f5352f2">contains_ifems</a>;
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 };
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00210"></a>00210 <span class="comment">// TreeNode class inline methods</span>
<a name="l00211"></a>00211 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00212"></a>00212 <span class="keyword">inline</span>
<a name="l00213"></a><a class="code" href="classTreeNode.php#ab34a67db78b7ea368c5f6e4e1706f34f">00213</a> <a class="code" href="classTreeNode.php#ab34a67db78b7ea368c5f6e4e1706f34f">TreeNode&lt;N&gt;::TreeNode</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; m, 
<a name="l00214"></a>00214                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tbs,
<a name="l00215"></a>00215                        <span class="keyword">const</span> <a class="code" href="classTreeNode.php">TreeNode&lt;N&gt;</a>* p) :
<a name="l00216"></a>00216   mesh           (m),
<a name="l00217"></a>00217   tgt_bin_size   (tbs),
<a name="l00218"></a>00218   parent         (p),
<a name="l00219"></a>00219   contains_ifems (false)
<a name="l00220"></a>00220 {
<a name="l00221"></a>00221   <span class="comment">// libmesh_assert our children are empty, thus we are active.</span>
<a name="l00222"></a>00222   libmesh_assert (<a class="code" href="classTreeNode.php#a5680127b6f4ba3523f48efd2c6197d24">children</a>.empty());
<a name="l00223"></a>00223   libmesh_assert (this-&gt;<a class="code" href="classTreeNode.php#a0679f3627ca64d1425cf8f7a8dd221fc">active</a>());
<a name="l00224"></a>00224   
<a name="l00225"></a>00225   <span class="comment">// Reserve space for the nodes &amp; elements</span>
<a name="l00226"></a>00226   <a class="code" href="classTreeNode.php#a545073d8e560d8a458507a7efb02718d">nodes</a>.reserve    (<a class="code" href="classTreeNode.php#aed4a5b14dce4d5e4b61bed3449be34f7">tgt_bin_size</a>);
<a name="l00227"></a>00227   <a class="code" href="classTreeNode.php#a6a5e82bca29d698378300f6c8a189fe7">elements</a>.reserve (<a class="code" href="classTreeNode.php#aed4a5b14dce4d5e4b61bed3449be34f7">tgt_bin_size</a>);
<a name="l00228"></a>00228 }
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00233"></a>00233 <span class="keyword">inline</span>
<a name="l00234"></a><a class="code" href="classTreeNode.php#a379f84ac3ada5e07cb516c6dabe9fe29">00234</a> <a class="code" href="classTreeNode.php#a379f84ac3ada5e07cb516c6dabe9fe29">TreeNode&lt;N&gt;::~TreeNode</a> ()
<a name="l00235"></a>00235 {
<a name="l00236"></a>00236   <span class="comment">// When we are destructed we must delete all of our</span>
<a name="l00237"></a>00237   <span class="comment">// children.  They will this delete their children,</span>
<a name="l00238"></a>00238   <span class="comment">// All the way down the line...</span>
<a name="l00239"></a>00239   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;children.size(); c++)
<a name="l00240"></a>00240     <span class="keyword">delete</span> children[c];
<a name="l00241"></a>00241 }
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00246"></a>00246 <span class="keyword">inline</span>
<a name="l00247"></a><a class="code" href="classTreeNode.php#a3074fb50607adbdba139f2b7b4d77b21">00247</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classTreeNode.php#a3074fb50607adbdba139f2b7b4d77b21">TreeNode&lt;N&gt;::level</a> ()<span class="keyword"> const </span>
<a name="l00248"></a>00248 <span class="keyword"></span>{ 
<a name="l00249"></a>00249   <span class="keywordflow">if</span> (parent != NULL)
<a name="l00250"></a>00250     <span class="keywordflow">return</span> parent-&gt;level()+1;
<a name="l00251"></a>00251 
<a name="l00252"></a>00252   <span class="comment">// if we have no parent, we are a level-0 box</span>
<a name="l00253"></a>00253   <span class="keywordflow">return</span> 0;
<a name="l00254"></a>00254 }
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 
<a name="l00257"></a>00257 
<a name="l00258"></a>00258 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
