<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>trilinos_aztec_linear_solver.h</h1>  </div>
</div>
<div class="contents">
<a href="trilinos__aztec__linear__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: trilinos_aztec_linear_solver.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __trilinos_azec_linear_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __trilinos_azec_linear_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="linear__solver_8h.php">linear_solver.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00034"></a>00034 <span class="preprocessor">#ifdef LIBMESH_HAVE_TRILINOS</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span><span class="preprocessor">#include &lt;Epetra_LinearProblem.h&gt;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &lt;AztecOO.h&gt;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// C++ includes</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00040"></a>00040 
<a name="l00049"></a>00049 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00050"></a><a class="code" href="classAztecLinearSolver.php">00050</a> <span class="keyword">class </span><a class="code" href="classAztecLinearSolver.php">AztecLinearSolver</a> : <span class="keyword">public</span> <a class="code" href="classLinearSolver.php">LinearSolver</a>&lt;T&gt;
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052 <span class="keyword">public</span>:
<a name="l00056"></a>00056   <a class="code" href="classAztecLinearSolver.php#a26b3e06de383c9427219daf8c0bd06e6">AztecLinearSolver</a> ();
<a name="l00057"></a>00057     
<a name="l00061"></a>00061   <a class="code" href="classAztecLinearSolver.php#a874261c6a469d6693c189fde8c4106d2">~AztecLinearSolver</a> ();
<a name="l00062"></a>00062   
<a name="l00066"></a>00066   <span class="keywordtype">void</span> <a class="code" href="classAztecLinearSolver.php#a4600cd11877bbe81cba951fd5f458189">clear</a> ();
<a name="l00067"></a>00067 
<a name="l00071"></a>00071   <span class="keywordtype">void</span> <a class="code" href="classAztecLinearSolver.php#a5729445b917d8637df2e21362c1277aa">init</a> ();
<a name="l00072"></a>00072 
<a name="l00077"></a>00077   std::pair&lt;unsigned int, Real&gt; 
<a name="l00078"></a><a class="code" href="classAztecLinearSolver.php#a6c16d5174f8ee37c9c54694aa70a177f">00078</a>   <a class="code" href="classAztecLinearSolver.php#a6c16d5174f8ee37c9c54694aa70a177f">solve</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>  &amp;matrix_in,
<a name="l00079"></a>00079          <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;solution_in,
<a name="l00080"></a>00080          <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;rhs_in,
<a name="l00081"></a>00081          <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00082"></a>00082          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its)
<a name="l00083"></a>00083   {
<a name="l00084"></a>00084     <span class="keywordflow">return</span> this-&gt;<a class="code" href="classAztecLinearSolver.php#a6c16d5174f8ee37c9c54694aa70a177f">solve</a>(matrix_in, matrix_in, solution_in, rhs_in, tol, m_its);
<a name="l00085"></a>00085   }
<a name="l00086"></a>00086 
<a name="l00093"></a>00093   std::pair&lt;unsigned int, Real&gt; 
<a name="l00094"></a>00094   <a class="code" href="classAztecLinearSolver.php#a6c16d5174f8ee37c9c54694aa70a177f">solve</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>  &amp;matrix,
<a name="l00095"></a>00095          <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>  &amp;preconditioner,
<a name="l00096"></a>00096          <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;solution,
<a name="l00097"></a>00097          <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;rhs,
<a name="l00098"></a>00098          <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00099"></a>00099          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00100"></a>00100 
<a name="l00104"></a>00104   std::pair&lt;unsigned int, Real&gt;
<a name="l00105"></a>00105   <a class="code" href="classAztecLinearSolver.php#a6c16d5174f8ee37c9c54694aa70a177f">solve</a> (<span class="keyword">const</span> <a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix,
<a name="l00106"></a>00106          <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; solution_in,
<a name="l00107"></a>00107          <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; rhs_in,
<a name="l00108"></a>00108          <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00109"></a>00109          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00110"></a>00110 
<a name="l00116"></a>00116   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt;
<a name="l00117"></a>00117     <a class="code" href="classAztecLinearSolver.php#a6c16d5174f8ee37c9c54694aa70a177f">solve</a> (<span class="keyword">const</span> <a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix,
<a name="l00118"></a>00118            <span class="keyword">const</span> <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; precond_matrix,
<a name="l00119"></a>00119            <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; solution_in,
<a name="l00120"></a>00120            <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; rhs_in,
<a name="l00121"></a>00121            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00122"></a>00122            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00123"></a>00123 
<a name="l00128"></a>00128   <span class="keywordtype">void</span> <a class="code" href="classAztecLinearSolver.php#ad4919993f014d09dc269d5d2d2067039">get_residual_history</a>(std::vector&lt;double&gt;&amp; hist);
<a name="l00129"></a>00129 
<a name="l00136"></a>00136   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classAztecLinearSolver.php#a3aa1ccea65bcf28f3ff8d077041be896">get_initial_residual</a>();
<a name="l00137"></a>00137 
<a name="l00142"></a>00142   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classAztecLinearSolver.php#a7786943b740eca42a6725392e355e2b2">print_converged_reason</a>();
<a name="l00143"></a>00143   
<a name="l00144"></a>00144 <span class="keyword">private</span>:
<a name="l00145"></a>00145 
<a name="l00149"></a><a class="code" href="classAztecLinearSolver.php#a26df9caf2d3ad2b87ffdbdd5e9798137">00149</a>   Epetra_LinearProblem * <a class="code" href="classAztecLinearSolver.php#a26df9caf2d3ad2b87ffdbdd5e9798137">_linear_problem</a>;
<a name="l00150"></a>00150 
<a name="l00154"></a><a class="code" href="classAztecLinearSolver.php#aec539fb81c7c8464b2892a8220f545fb">00154</a>   AztecOO * <a class="code" href="classAztecLinearSolver.php#aec539fb81c7c8464b2892a8220f545fb">_linear_solver</a>;
<a name="l00155"></a>00155 };
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 <span class="comment">/*----------------------- functions ----------------------------------*/</span>
<a name="l00159"></a>00159 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00160"></a>00160 <span class="keyword">inline</span>
<a name="l00161"></a><a class="code" href="classAztecLinearSolver.php#a26b3e06de383c9427219daf8c0bd06e6">00161</a> <a class="code" href="classAztecLinearSolver.php#a26b3e06de383c9427219daf8c0bd06e6">AztecLinearSolver&lt;T&gt;::AztecLinearSolver</a> ()
<a name="l00162"></a>00162 {
<a name="l00163"></a>00163   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l00164"></a>00164     this-&gt;_preconditioner_type = <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4af54549e0e69fbdd4ddd199ee316527f3">ILU_PRECOND</a>;
<a name="l00165"></a>00165   <span class="keywordflow">else</span>
<a name="l00166"></a>00166     this-&gt;_preconditioner_type = <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a8f036d61e96c69b14d585f04235613d2">BLOCK_JACOBI_PRECOND</a>;
<a name="l00167"></a>00167 }
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00172"></a>00172 <span class="keyword">inline</span>
<a name="l00173"></a><a class="code" href="classAztecLinearSolver.php#a874261c6a469d6693c189fde8c4106d2">00173</a> <a class="code" href="classAztecLinearSolver.php#a874261c6a469d6693c189fde8c4106d2">AztecLinearSolver&lt;T&gt;::~AztecLinearSolver</a> ()
<a name="l00174"></a>00174 {
<a name="l00175"></a>00175   this-&gt;clear ();
<a name="l00176"></a>00176 }
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_TRILINOS</span>
<a name="l00181"></a>00181 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __trilinos_azec_linear_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
