<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_f10759d5ac6297fe611079c3c15b8f2c.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>trilinos_epetra_matrix.C</h1>  </div>
</div>
<div class="contents">
<a href="trilinos__epetra__matrix_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: trilinos_epetra_matrix.C 3424 2009-07-16 16:33:03Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="preprocessor">#ifdef LIBMESH_HAVE_TRILINOS</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;trilinos_epetra_matrix.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;trilinos_epetra_vector.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;dof_map.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;dense_matrix.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;parallel.h&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00036"></a>00036 <span class="comment">//EpetraMatrix members</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00039"></a><a class="code" href="classEpetraMatrix.php#a1a07a88fd125a7b6beaf7ba8cb1d3c2e">00039</a> <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#a1a07a88fd125a7b6beaf7ba8cb1d3c2e">EpetraMatrix&lt;T&gt;::update_sparsity_pattern</a> (<span class="keyword">const</span> <a class="code" href="classSparsityPattern_1_1Graph.php">SparsityPattern::Graph</a> &amp;sparsity_pattern)
<a name="l00040"></a>00040 {  
<a name="l00041"></a>00041   <span class="comment">// clear data, start over</span>
<a name="l00042"></a>00042   this-&gt;clear ();    
<a name="l00043"></a>00043 
<a name="l00044"></a>00044   <span class="comment">// big trouble if this fails!</span>
<a name="l00045"></a>00045   libmesh_assert (this-&gt;_dof_map != NULL);
<a name="l00046"></a>00046   
<a name="l00047"></a>00047   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_rows = sparsity_pattern.size();
<a name="l00048"></a>00048 
<a name="l00049"></a>00049   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m   = this-&gt;_dof_map-&gt;n_dofs();
<a name="l00050"></a>00050   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n   = m;
<a name="l00051"></a>00051   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_l = this-&gt;_dof_map-&gt;n_dofs_on_processor(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()); 
<a name="l00052"></a>00052   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_l = n_l;
<a name="l00053"></a>00053 
<a name="l00054"></a>00054   <span class="comment">// error checking</span>
<a name="l00055"></a>00055 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span>  {
<a name="l00057"></a>00057     libmesh_assert (n == m);
<a name="l00058"></a>00058     libmesh_assert (n_l == m_l);
<a name="l00059"></a>00059 
<a name="l00060"></a>00060     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00061"></a>00061       summed_m_l = m_l,
<a name="l00062"></a>00062       summed_n_l = n_l;
<a name="l00063"></a>00063 
<a name="l00064"></a>00064     Parallel::sum (summed_m_l);
<a name="l00065"></a>00065     Parallel::sum (summed_n_l);
<a name="l00066"></a>00066 
<a name="l00067"></a>00067     libmesh_assert (m == summed_m_l);
<a name="l00068"></a>00068     libmesh_assert (n == summed_n_l);
<a name="l00069"></a>00069   }
<a name="l00070"></a>00070 <span class="preprocessor">#endif</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span>  
<a name="l00072"></a>00072   <span class="comment">// build a map defining the data distribution</span>
<a name="l00073"></a>00073   _map = <span class="keyword">new</span> Epetra_Map (m, 
<a name="l00074"></a>00074                          m_l,
<a name="l00075"></a>00075                          0,
<a name="l00076"></a>00076                          Epetra_MpiComm (<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>));
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   libmesh_assert (static_cast&lt;unsigned int&gt;(_map-&gt;NumGlobalPoints()) == m);
<a name="l00079"></a>00079   libmesh_assert (static_cast&lt;unsigned int&gt;(_map-&gt;MaxAllGID()+1) == m);
<a name="l00080"></a>00080   
<a name="l00081"></a>00081   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; n_nz = this-&gt;_dof_map-&gt;get_n_nz();
<a name="l00082"></a>00082   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; n_oz = this-&gt;_dof_map-&gt;get_n_oz();
<a name="l00083"></a>00083   
<a name="l00084"></a>00084    <span class="comment">// Make sure the sparsity pattern isn&#39;t empty</span>
<a name="l00085"></a>00085   libmesh_assert (n_nz.size() == n_l);
<a name="l00086"></a>00086   libmesh_assert (n_oz.size() == n_l);
<a name="l00087"></a>00087 
<a name="l00088"></a>00088   <span class="comment">// Epetra wants the total number of nonzeros, both local and remote.</span>
<a name="l00089"></a>00089   std::vector&lt;int&gt; n_nz_tot;  n_nz_tot.reserve(n_nz.size());
<a name="l00090"></a>00090   
<a name="l00091"></a>00091   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_nz.size(); i++)    
<a name="l00092"></a>00092     n_nz_tot.push_back(<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(n_nz[i] + n_oz[i], n));
<a name="l00093"></a>00093   
<a name="l00094"></a>00094   <span class="keywordflow">if</span> (m==0)
<a name="l00095"></a>00095     <span class="keywordflow">return</span>;
<a name="l00096"></a>00096 
<a name="l00097"></a>00097   _graph = <span class="keyword">new</span> Epetra_CrsGraph(Copy, *_map, &amp;n_nz_tot[0]);
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   <span class="comment">// Tell the matrix about its structure.  Initialize it</span>
<a name="l00100"></a>00100   <span class="comment">// to zero.</span>
<a name="l00101"></a>00101   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_rows; i++)
<a name="l00102"></a>00102     _graph-&gt;InsertGlobalIndices(_graph-&gt;GRID(i),
<a name="l00103"></a>00103                                 sparsity_pattern[i].size(),
<a name="l00104"></a>00104                                 <span class="keyword">const_cast&lt;</span><span class="keywordtype">int</span> *<span class="keyword">&gt;</span>((<span class="keyword">const</span> <span class="keywordtype">int</span> *)&amp;sparsity_pattern[i][0]));
<a name="l00105"></a>00105 
<a name="l00106"></a>00106   _graph-&gt;FillComplete();
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   <span class="comment">//Initialize the matrix</span>
<a name="l00109"></a>00109   libmesh_assert (!this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00110"></a>00110   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> ();
<a name="l00111"></a>00111   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00112"></a>00112 }
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00117"></a><a class="code" href="classEpetraMatrix.php#a1ccb93e5819b0ebd08db5745b1b30c7f">00117</a> <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#a70035b29c755f208ee1c50a61083a3fd">EpetraMatrix&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m,
<a name="l00118"></a>00118                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00119"></a>00119                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_l,
<a name="l00120"></a>00120                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_l,
<a name="l00121"></a>00121                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nnz,
<a name="l00122"></a>00122                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> noz)
<a name="l00123"></a>00123 {
<a name="l00124"></a>00124   <span class="keywordflow">if</span> ((m==0) || (n==0))
<a name="l00125"></a>00125     <span class="keywordflow">return</span>;
<a name="l00126"></a>00126 
<a name="l00127"></a>00127   {
<a name="l00128"></a>00128     <span class="comment">// Clear initialized matrices</span>
<a name="l00129"></a>00129     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00130"></a>00130       this-&gt;clear();
<a name="l00131"></a>00131 
<a name="l00132"></a>00132     libmesh_assert (this-&gt;_mat == NULL);
<a name="l00133"></a>00133     libmesh_assert (this-&gt;_map == NULL);
<a name="l00134"></a>00134 
<a name="l00135"></a>00135     this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00136"></a>00136   }
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <span class="comment">// error checking</span>
<a name="l00139"></a>00139 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00140"></a>00140 <span class="preprocessor"></span>  {
<a name="l00141"></a>00141     libmesh_assert (n == m);
<a name="l00142"></a>00142     libmesh_assert (n_l == m_l);
<a name="l00143"></a>00143 
<a name="l00144"></a>00144     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00145"></a>00145       summed_m_l = m_l,
<a name="l00146"></a>00146       summed_n_l = n_l;
<a name="l00147"></a>00147 
<a name="l00148"></a>00148     Parallel::sum (summed_m_l);
<a name="l00149"></a>00149     Parallel::sum (summed_n_l);
<a name="l00150"></a>00150 
<a name="l00151"></a>00151     libmesh_assert (m == summed_m_l);
<a name="l00152"></a>00152     libmesh_assert (n == summed_n_l);
<a name="l00153"></a>00153   }
<a name="l00154"></a>00154 <span class="preprocessor">#endif</span>
<a name="l00155"></a>00155 <span class="preprocessor"></span>
<a name="l00156"></a>00156   <span class="comment">// build a map defining the data distribution</span>
<a name="l00157"></a>00157   _map = <span class="keyword">new</span> Epetra_Map (m, 
<a name="l00158"></a>00158                          m_l,
<a name="l00159"></a>00159                          0,
<a name="l00160"></a>00160                          Epetra_MpiComm (<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>));
<a name="l00161"></a>00161   
<a name="l00162"></a>00162   libmesh_assert (static_cast&lt;unsigned int&gt;(_map-&gt;NumGlobalPoints()) == m);
<a name="l00163"></a>00163   libmesh_assert (static_cast&lt;unsigned int&gt;(_map-&gt;MaxAllGID()+1) == m);
<a name="l00164"></a>00164 
<a name="l00165"></a>00165   _mat = <span class="keyword">new</span> Epetra_FECrsMatrix (Copy, *_map, nnz + noz);
<a name="l00166"></a>00166 }
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00172"></a><a class="code" href="classEpetraMatrix.php#a70035b29c755f208ee1c50a61083a3fd">00172</a> <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#a70035b29c755f208ee1c50a61083a3fd">EpetraMatrix&lt;T&gt;::init</a> ()
<a name="l00173"></a>00173 {
<a name="l00174"></a>00174   libmesh_assert (this-&gt;_dof_map != NULL);
<a name="l00175"></a>00175   
<a name="l00176"></a>00176   {
<a name="l00177"></a>00177     <span class="comment">// Clear initialized matrices</span>
<a name="l00178"></a>00178     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00179"></a>00179       this-&gt;clear();
<a name="l00180"></a>00180 
<a name="l00181"></a>00181     this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00182"></a>00182   }
<a name="l00183"></a>00183   
<a name="l00184"></a>00184 
<a name="l00185"></a>00185   _mat = <span class="keyword">new</span> Epetra_FECrsMatrix (Copy, *_graph);
<a name="l00186"></a>00186 }
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00191"></a><a class="code" href="classEpetraMatrix.php#a81247bb686fc37f83ea007750b240617">00191</a> <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#a81247bb686fc37f83ea007750b240617">EpetraMatrix&lt;T&gt;::zero</a> ()
<a name="l00192"></a>00192 {
<a name="l00193"></a>00193   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00194"></a>00194   
<a name="l00195"></a>00195   _mat-&gt;Scale(0.0);
<a name="l00196"></a>00196 }
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00201"></a><a class="code" href="classEpetraMatrix.php#a730a29208ef5a243451acc8b7851fb12">00201</a> <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#a730a29208ef5a243451acc8b7851fb12">EpetraMatrix&lt;T&gt;::clear</a> ()
<a name="l00202"></a>00202 {
<a name="l00203"></a>00203 <span class="comment">//  delete _mat;</span>
<a name="l00204"></a>00204 <span class="comment">//  delete _map;</span>
<a name="l00205"></a>00205 
<a name="l00206"></a>00206   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00207"></a>00207   
<a name="l00208"></a>00208   libmesh_assert (!this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00209"></a>00209 }
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00214"></a><a class="code" href="classEpetraMatrix.php#a43fd346b419f7f3bc1ec367c55bb77c4">00214</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classEpetraMatrix.php#a43fd346b419f7f3bc1ec367c55bb77c4">EpetraMatrix&lt;T&gt;::l1_norm</a> ()<span class="keyword"> const</span>
<a name="l00215"></a>00215 <span class="keyword"></span>{
<a name="l00216"></a>00216   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00217"></a>00217   
<a name="l00218"></a>00218   libmesh_assert (_mat != NULL);
<a name="l00219"></a>00219 
<a name="l00220"></a>00220   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a><span class="keyword">&gt;</span>(_mat-&gt;NormOne());
<a name="l00221"></a>00221 }
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00226"></a><a class="code" href="classEpetraMatrix.php#af2bcf80a30c47e8a17c514de5b197f1c">00226</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classEpetraMatrix.php#af2bcf80a30c47e8a17c514de5b197f1c">EpetraMatrix&lt;T&gt;::linfty_norm</a> ()<span class="keyword"> const</span>
<a name="l00227"></a>00227 <span class="keyword"></span>{
<a name="l00228"></a>00228   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00229"></a>00229   
<a name="l00230"></a>00230   
<a name="l00231"></a>00231   libmesh_assert (_mat != NULL);
<a name="l00232"></a>00232 
<a name="l00233"></a>00233   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a><span class="keyword">&gt;</span>(_mat-&gt;NormInf());
<a name="l00234"></a>00234 }
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 
<a name="l00238"></a>00238 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00239"></a>00239 <span class="comment">//void EpetraMatrix&lt;T&gt;::print_matlab (const std::string name) const</span>
<a name="l00240"></a><a class="code" href="classEpetraMatrix.php#a7bb9855f47ddd813ef275f9440e76bf1">00240</a> <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#a7bb9855f47ddd813ef275f9440e76bf1">EpetraMatrix&lt;T&gt;::print_matlab</a> (<span class="keyword">const</span> std::string)<span class="keyword"> const</span>
<a name="l00241"></a>00241 <span class="keyword"></span>{
<a name="l00242"></a>00242   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00243"></a>00243 
<a name="l00244"></a>00244   <span class="comment">// libmesh_assert (this-&gt;closed());</span>
<a name="l00245"></a>00245   this-&gt;<a class="code" href="namespacelibMesh.php#a6e41d4c43a417f7b9e20302af9736247">close</a>();
<a name="l00246"></a>00246   
<a name="l00247"></a>00247   libmesh_not_implemented();
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 <span class="comment">//   int ierr=0; </span>
<a name="l00250"></a>00250 <span class="comment">//   PetscViewer petsc_viewer;</span>
<a name="l00251"></a>00251 
<a name="l00252"></a>00252 
<a name="l00253"></a>00253 <span class="comment">//   ierr = PetscViewerCreate (libMesh::COMM_WORLD,</span>
<a name="l00254"></a>00254 <span class="comment">//                          &amp;petsc_viewer);</span>
<a name="l00255"></a>00255 <span class="comment">//          CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00256"></a>00256 
<a name="l00257"></a>00257 <span class="comment">//   /**</span>
<a name="l00258"></a>00258 <span class="comment">//    * Create an ASCII file containing the matrix</span>
<a name="l00259"></a>00259 <span class="comment">//    * if a filename was provided.  </span>
<a name="l00260"></a>00260 <span class="comment">//    */</span>
<a name="l00261"></a>00261 <span class="comment">//   if (name != &quot;NULL&quot;)</span>
<a name="l00262"></a>00262 <span class="comment">//     {</span>
<a name="l00263"></a>00263 <span class="comment">//       ierr = PetscViewerASCIIOpen( libMesh::COMM_WORLD,</span>
<a name="l00264"></a>00264 <span class="comment">//                                 name.c_str(),</span>
<a name="l00265"></a>00265 <span class="comment">//                                 &amp;petsc_viewer);</span>
<a name="l00266"></a>00266 <span class="comment">//              CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00267"></a>00267       
<a name="l00268"></a>00268 <span class="comment">//       ierr = PetscViewerSetFormat (petsc_viewer,</span>
<a name="l00269"></a>00269 <span class="comment">//                                 PETSC_VIEWER_ASCII_MATLAB);</span>
<a name="l00270"></a>00270 <span class="comment">//              CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00271"></a>00271   
<a name="l00272"></a>00272 <span class="comment">//       ierr = MatView (_mat, petsc_viewer);</span>
<a name="l00273"></a>00273 <span class="comment">//              CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00274"></a>00274 <span class="comment">//     }</span>
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 <span class="comment">//   /**</span>
<a name="l00277"></a>00277 <span class="comment">//    * Otherwise the matrix will be dumped to the screen.</span>
<a name="l00278"></a>00278 <span class="comment">//    */</span>
<a name="l00279"></a>00279 <span class="comment">//   else</span>
<a name="l00280"></a>00280 <span class="comment">//     {</span>
<a name="l00281"></a>00281 <span class="comment">//       ierr = PetscViewerSetFormat (PETSC_VIEWER_STDOUT_WORLD,</span>
<a name="l00282"></a>00282 <span class="comment">//                                 PETSC_VIEWER_ASCII_MATLAB);</span>
<a name="l00283"></a>00283 <span class="comment">//              CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00284"></a>00284   
<a name="l00285"></a>00285 <span class="comment">//       ierr = MatView (_mat, PETSC_VIEWER_STDOUT_WORLD);</span>
<a name="l00286"></a>00286 <span class="comment">//              CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00287"></a>00287 <span class="comment">//     }</span>
<a name="l00288"></a>00288 
<a name="l00289"></a>00289 
<a name="l00290"></a>00290 <span class="comment">//   /**</span>
<a name="l00291"></a>00291 <span class="comment">//    * Destroy the viewer.</span>
<a name="l00292"></a>00292 <span class="comment">//    */</span>
<a name="l00293"></a>00293 <span class="comment">//   ierr = PetscViewerDestroy (petsc_viewer);</span>
<a name="l00294"></a>00294 <span class="comment">//          CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00295"></a>00295 }
<a name="l00296"></a>00296 
<a name="l00297"></a>00297 
<a name="l00298"></a>00298 
<a name="l00299"></a>00299 
<a name="l00300"></a>00300 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00301"></a><a class="code" href="classEpetraMatrix.php#a353f009f4da476ae1323d75e92d6bef5">00301</a> <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#a353f009f4da476ae1323d75e92d6bef5">EpetraMatrix&lt;T&gt;::add_matrix</a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dm,
<a name="l00302"></a>00302                                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; rows,
<a name="l00303"></a>00303                                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; cols)
<a name="l00304"></a>00304 {
<a name="l00305"></a>00305   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00306"></a>00306 
<a name="l00307"></a>00307   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m = dm.<a class="code" href="classDenseMatrixBase.php#a38c8f3c669b291931e3d26a0213ba554">m</a>();
<a name="l00308"></a>00308   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = dm.<a class="code" href="classDenseMatrixBase.php#a9e2309c94c840b4570283c63634f11e1">n</a>();
<a name="l00309"></a>00309 
<a name="l00310"></a>00310   libmesh_assert (rows.size() == m);
<a name="l00311"></a>00311   libmesh_assert (cols.size() == n);
<a name="l00312"></a>00312 
<a name="l00313"></a>00313   _mat-&gt;SumIntoGlobalValues(m, (<span class="keywordtype">int</span> *)&amp;rows[0], n, (<span class="keywordtype">int</span> *)&amp;cols[0], &amp;dm.<a class="code" href="classDenseMatrix.php#a528bde8c704176e220f23b79acdb11ec">get_values</a>()[0]);
<a name="l00314"></a>00314 }
<a name="l00315"></a>00315 
<a name="l00316"></a>00316 
<a name="l00317"></a>00317 
<a name="l00318"></a>00318 
<a name="l00319"></a>00319 
<a name="l00320"></a>00320 <span class="comment">// template &lt;typename T&gt;</span>
<a name="l00321"></a>00321 <span class="comment">// void EpetraMatrix&lt;T&gt;::_get_submatrix(SparseMatrix&lt;T&gt;&amp; submatrix,</span>
<a name="l00322"></a>00322 <span class="comment">//                                   const std::vector&lt;unsigned int&gt; &amp;rows,</span>
<a name="l00323"></a>00323 <span class="comment">//                                   const std::vector&lt;unsigned int&gt; &amp;cols,</span>
<a name="l00324"></a>00324 <span class="comment">//                                   const bool reuse_submatrix) const</span>
<a name="l00325"></a>00325 <span class="comment">// {</span>
<a name="l00326"></a>00326 <span class="comment">//   // Can only extract submatrices from closed matrices</span>
<a name="l00327"></a>00327 <span class="comment">//   this-&gt;close();</span>
<a name="l00328"></a>00328   
<a name="l00329"></a>00329 <span class="comment">//   libmesh_not_implemented();</span>
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 <span class="comment">// //   // Attempt to cast the input matrix to a EpetraMatrix*</span>
<a name="l00332"></a>00332 <span class="comment">// //   EpetraMatrix&lt;T&gt;* petsc_submatrix = libmesh_cast_ptr&lt;EpetraMatrix&lt;T&gt;*&gt;(&amp;submatrix);</span>
<a name="l00333"></a>00333 
<a name="l00334"></a>00334 <span class="comment">// //   // Construct row and column index sets.</span>
<a name="l00335"></a>00335 <span class="comment">// //   int ierr=0;</span>
<a name="l00336"></a>00336 <span class="comment">// //   IS isrow, iscol;</span>
<a name="l00337"></a>00337 
<a name="l00338"></a>00338 <span class="comment">// //   ierr = ISCreateGeneral(libMesh::COMM_WORLD,</span>
<a name="l00339"></a>00339 <span class="comment">// //                    rows.size(),</span>
<a name="l00340"></a>00340 <span class="comment">// //                    (int*) &amp;rows[0],</span>
<a name="l00341"></a>00341 <span class="comment">// //                    &amp;isrow); CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00342"></a>00342 
<a name="l00343"></a>00343 <span class="comment">// //   ierr = ISCreateGeneral(libMesh::COMM_WORLD,</span>
<a name="l00344"></a>00344 <span class="comment">// //                    cols.size(),</span>
<a name="l00345"></a>00345 <span class="comment">// //                    (int*) &amp;cols[0],</span>
<a name="l00346"></a>00346 <span class="comment">// //                    &amp;iscol); CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00347"></a>00347 
<a name="l00348"></a>00348 <span class="comment">// //   // Extract submatrix</span>
<a name="l00349"></a>00349 <span class="comment">// //   ierr = MatGetSubMatrix(_mat,</span>
<a name="l00350"></a>00350 <span class="comment">// //                    isrow,</span>
<a name="l00351"></a>00351 <span class="comment">// //                    iscol,</span>
<a name="l00352"></a>00352 <span class="comment">// //                    PETSC_DECIDE,</span>
<a name="l00353"></a>00353 <span class="comment">// //                    (reuse_submatrix ? MAT_RELIBMESH_USE_MATRIX : MAT_INITIAL_MATRIX),</span>
<a name="l00354"></a>00354 <span class="comment">// //                    &amp;(petsc_submatrix-&gt;_mat));  CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00355"></a>00355 
<a name="l00356"></a>00356 <span class="comment">// //   // Specify that the new submatrix is initialized and close it.</span>
<a name="l00357"></a>00357 <span class="comment">// //   petsc_submatrix-&gt;_is_initialized = true;</span>
<a name="l00358"></a>00358 <span class="comment">// //   petsc_submatrix-&gt;close();</span>
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 <span class="comment">// //   // Clean up PETSc data structures</span>
<a name="l00361"></a>00361 <span class="comment">// //   ierr = ISDestroy(isrow); CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00362"></a>00362 <span class="comment">// //   ierr = ISDestroy(iscol); CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00363"></a>00363 <span class="comment">// }</span>
<a name="l00364"></a>00364 
<a name="l00365"></a>00365 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00366"></a><a class="code" href="classEpetraMatrix.php#ae7f79d4318bf6b54da2d723f5936d4ce">00366</a> <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#ae7f79d4318bf6b54da2d723f5936d4ce">EpetraMatrix&lt;T&gt;::get_diagonal</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest)<span class="keyword"> const</span>
<a name="l00367"></a>00367 <span class="keyword"></span>{
<a name="l00368"></a>00368   <span class="comment">// Convert vector to EpetraVector.</span>
<a name="l00369"></a>00369   <a class="code" href="classEpetraVector.php">EpetraVector&lt;T&gt;</a>* epetra_dest = libmesh_cast_ptr&lt;EpetraVector&lt;T&gt;*&gt;(&amp;dest);
<a name="l00370"></a>00370 
<a name="l00371"></a>00371   <span class="comment">// Call Epetra function.</span>
<a name="l00372"></a>00372   _mat-&gt;ExtractDiagonalCopy(*(epetra_dest-&gt;<a class="code" href="classEpetraVector.php#a6450f0433271c9bb4a3637e4e2092f61">vec</a>()));
<a name="l00373"></a>00373 }
<a name="l00374"></a>00374 
<a name="l00375"></a>00375 
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00378"></a><a class="code" href="classEpetraMatrix.php#ad31d9b802799dd0367c816453b58b67d">00378</a> <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#ad31d9b802799dd0367c816453b58b67d">EpetraMatrix&lt;T&gt;::get_transpose</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;)<span class="keyword"> const</span>
<a name="l00379"></a>00379 <span class="keyword"></span>{
<a name="l00380"></a>00380   libmesh_not_implemented();
<a name="l00381"></a>00381 }
<a name="l00382"></a>00382 
<a name="l00383"></a>00383 
<a name="l00384"></a>00384 
<a name="l00385"></a>00385 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00386"></a>00386 <span class="comment">// Explicit instantiations</span>
<a name="l00387"></a>00387 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classEpetraMatrix.php">EpetraMatrix&lt;Number&gt;</a>;
<a name="l00388"></a>00388 
<a name="l00389"></a>00389 
<a name="l00390"></a>00390 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_TRILINOS</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
