<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>trilinos_epetra_matrix.h</h1>  </div>
</div>
<div class="contents">
<a href="trilinos__epetra__matrix_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: trilinos_epetra_matrix.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __trilinos_epetra_matrix_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __trilinos_epetra_matrix_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#ifdef LIBMESH_HAVE_TRILINOS</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="comment">// Trilinos includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;Epetra_FECrsMatrix.h&gt;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &lt;Epetra_Map.h&gt;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &lt;Epetra_MpiComm.h&gt;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// C++ includes</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Local includes</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>&quot;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="comment">// Forward Declarations</span>
<a name="l00041"></a>00041 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classDenseMatrix.php">DenseMatrix</a>;
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00053"></a>00053 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00054"></a><a class="code" href="classEpetraMatrix.php">00054</a> <span class="keyword">class </span><a class="code" href="classEpetraMatrix.php">EpetraMatrix</a> : <span class="keyword">public</span> <a class="code" href="classSparseMatrix.php">SparseMatrix</a>&lt;T&gt;
<a name="l00055"></a>00055 {
<a name="l00056"></a>00056 <span class="keyword">public</span>:
<a name="l00072"></a>00072   <a class="code" href="classEpetraMatrix.php#a5a0feeb5897b66f3188544fc25915950">EpetraMatrix</a> ();
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 <span class="comment">//   /**</span>
<a name="l00075"></a>00075 <span class="comment">//    * Constructor.  Creates a EpetraMatrix assuming you already</span>
<a name="l00076"></a>00076 <span class="comment">//    * have a valid Mat object.  In this case, m is NOT destroyed</span>
<a name="l00077"></a>00077 <span class="comment">//    * by the EpetraMatrix destructor when this object goes out of scope.</span>
<a name="l00078"></a>00078 <span class="comment">//    * This allows ownership of m to remain with the original creator,</span>
<a name="l00079"></a>00079 <span class="comment">//    * and to simply provide additional functionality with the EpetraMatrix.</span>
<a name="l00080"></a>00080 <span class="comment">//    */</span>
<a name="l00081"></a>00081 <span class="comment">//   EpetraMatrix (Mat m);</span>
<a name="l00082"></a>00082   
<a name="l00088"></a>00088   <a class="code" href="classEpetraMatrix.php#aa7bed4b34b15a9e41b645da2391ef03d">~EpetraMatrix</a> ();
<a name="l00089"></a>00089  
<a name="l00090"></a>00090 <span class="comment">//   /**</span>
<a name="l00091"></a>00091 <span class="comment">//    * The \p EpetraMatrix needs the full sparsity pattern.</span>
<a name="l00092"></a>00092 <span class="comment">//    */ </span>
<a name="l00093"></a><a class="code" href="classEpetraMatrix.php#a1a47fa9fe152c43786e39939b9eb31d9">00093</a>   <span class="keywordtype">bool</span> <a class="code" href="classEpetraMatrix.php#a1a47fa9fe152c43786e39939b9eb31d9">need_full_sparsity_pattern</a> ()<span class="keyword"> const </span>
<a name="l00094"></a>00094 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 <span class="comment">//   /**</span>
<a name="l00097"></a>00097 <span class="comment">//    * Updates the matrix sparsity pattern.  This will</span>
<a name="l00098"></a>00098 <span class="comment">//    * tell the underlying matrix storage scheme how</span>
<a name="l00099"></a>00099 <span class="comment">//    * to map the \f$ (i,j) \f$ elements.</span>
<a name="l00100"></a>00100 <span class="comment">//    */</span>
<a name="l00101"></a>00101   <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#a1a07a88fd125a7b6beaf7ba8cb1d3c2e">update_sparsity_pattern</a> (<span class="keyword">const</span> <a class="code" href="classSparsityPattern_1_1Graph.php">SparsityPattern::Graph</a> &amp;);
<a name="l00102"></a>00102 
<a name="l00111"></a>00111   <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#a70035b29c755f208ee1c50a61083a3fd">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEpetraMatrix.php#ac0a95ae11097c89155bbd2e52a2b1da6">m</a>,
<a name="l00112"></a>00112              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEpetraMatrix.php#aa7497e81988d6a6e6a02900c7a36943b">n</a>,
<a name="l00113"></a>00113              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_l,
<a name="l00114"></a>00114              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_l,
<a name="l00115"></a>00115              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nnz=30,
<a name="l00116"></a>00116              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> noz=10);
<a name="l00117"></a>00117 
<a name="l00121"></a>00121   <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#a70035b29c755f208ee1c50a61083a3fd">init</a> ();
<a name="l00122"></a>00122   
<a name="l00129"></a>00129   <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#a730a29208ef5a243451acc8b7851fb12">clear</a> ();
<a name="l00130"></a>00130 
<a name="l00135"></a>00135   <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#a81247bb686fc37f83ea007750b240617">zero</a> ();
<a name="l00136"></a>00136   
<a name="l00142"></a>00142   <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#a747592334500dc1be61061679f942f1d">close</a> () <span class="keyword">const</span>;
<a name="l00143"></a>00143   
<a name="l00148"></a>00148   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEpetraMatrix.php#ac0a95ae11097c89155bbd2e52a2b1da6">m</a> () <span class="keyword">const</span>;
<a name="l00149"></a>00149 
<a name="l00154"></a>00154   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEpetraMatrix.php#aa7497e81988d6a6e6a02900c7a36943b">n</a> () <span class="keyword">const</span>;
<a name="l00155"></a>00155 
<a name="l00160"></a>00160   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEpetraMatrix.php#adff20d626076d7ea432b7769cd5fec45">row_start</a> () <span class="keyword">const</span>;
<a name="l00161"></a>00161 
<a name="l00166"></a>00166   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEpetraMatrix.php#a75ee9742806ec0aa255d747a63dae330">row_stop</a> () <span class="keyword">const</span>;
<a name="l00167"></a>00167 
<a name="l00174"></a>00174   <span class="keywordtype">void</span> <span class="keyword">set</span> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00175"></a>00175             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00176"></a>00176             <span class="keyword">const</span> T value);
<a name="l00177"></a>00177     
<a name="l00186"></a>00186   <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#aa9ee18302fecbc421078edc71e8a87d3">add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00187"></a>00187             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00188"></a>00188             <span class="keyword">const</span> T value);
<a name="l00189"></a>00189 
<a name="l00197"></a>00197   <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#a353f009f4da476ae1323d75e92d6bef5">add_matrix</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;dm,
<a name="l00198"></a>00198                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;rows,
<a name="l00199"></a>00199                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;cols);           
<a name="l00200"></a>00200 
<a name="l00205"></a>00205   <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#a353f009f4da476ae1323d75e92d6bef5">add_matrix</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;dm,
<a name="l00206"></a>00206                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;dof_indices);            
<a name="l00207"></a>00207       
<a name="l00219"></a>00219   <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#aa9ee18302fecbc421078edc71e8a87d3">add</a> (<span class="keyword">const</span> T a, <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;X);
<a name="l00220"></a>00220     
<a name="l00239"></a>00239   T <a class="code" href="classEpetraMatrix.php#a986ca4e8f807491ed4f01d449d144e3c">operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00240"></a>00240                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span>;
<a name="l00241"></a>00241 
<a name="l00253"></a>00253   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classEpetraMatrix.php#a43fd346b419f7f3bc1ec367c55bb77c4">l1_norm</a> () <span class="keyword">const</span>;
<a name="l00254"></a>00254 
<a name="l00267"></a>00267   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classEpetraMatrix.php#af2bcf80a30c47e8a17c514de5b197f1c">linfty_norm</a> () <span class="keyword">const</span>;
<a name="l00268"></a>00268 
<a name="l00273"></a>00273   <span class="keywordtype">bool</span> <a class="code" href="classEpetraMatrix.php#a04ec73396cb4ae1b0f2f396d83be3ac8">closed</a>() <span class="keyword">const</span>;
<a name="l00274"></a>00274   
<a name="l00278"></a>00278   <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#ac28e9063016e76d3d61f9258e3f39b7d">print_personal</a>(std::ostream&amp; os=std::cout) <span class="keyword">const</span>;
<a name="l00279"></a>00279 
<a name="l00286"></a>00286   <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#a7bb9855f47ddd813ef275f9440e76bf1">print_matlab</a>(<span class="keyword">const</span> std::string <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>=<span class="stringliteral">&quot;NULL&quot;</span>) <span class="keyword">const</span>;
<a name="l00287"></a>00287 
<a name="l00291"></a>00291   <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#ae7f79d4318bf6b54da2d723f5936d4ce">get_diagonal</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00292"></a>00292 
<a name="l00297"></a>00297   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#ad31d9b802799dd0367c816453b58b67d">get_transpose</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00298"></a>00298 
<a name="l00302"></a>00302   <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#a7d168758974b67f39c8b80d0b219b179">swap</a> (<a class="code" href="classEpetraMatrix.php">EpetraMatrix&lt;T&gt;</a> &amp;);
<a name="l00303"></a>00303 
<a name="l00309"></a><a class="code" href="classEpetraMatrix.php#ae9b7a8f81f318e5977e59711f11899dd">00309</a>   Epetra_FECrsMatrix * <a class="code" href="classEpetraMatrix.php#ae9b7a8f81f318e5977e59711f11899dd">mat</a> () { libmesh_assert (<a class="code" href="classEpetraMatrix.php#ad54199356b60d45a8df68d78561f901f">_mat</a> != NULL); <span class="keywordflow">return</span> <a class="code" href="classEpetraMatrix.php#ad54199356b60d45a8df68d78561f901f">_mat</a>; }
<a name="l00310"></a>00310 
<a name="l00311"></a>00311   
<a name="l00312"></a>00312 <span class="keyword">protected</span>:
<a name="l00313"></a>00313 
<a name="l00314"></a>00314 <span class="comment">//   /**</span>
<a name="l00315"></a>00315 <span class="comment">//    * This function either creates or re-initializes</span>
<a name="l00316"></a>00316 <span class="comment">//    * a matrix called &quot;submatrix&quot; which is defined</span>
<a name="l00317"></a>00317 <span class="comment">//    * by the row and column indices given in the &quot;rows&quot; and &quot;cols&quot; entries.</span>
<a name="l00318"></a>00318 <span class="comment">//    * This function is implemented in terms of the MatGetSubMatrix()</span>
<a name="l00319"></a>00319 <span class="comment">//    * routine of PETSc.  The boolean reuse_submatrix parameter determines</span>
<a name="l00320"></a>00320 <span class="comment">//    * whether or not PETSc will treat &quot;submatrix&quot; as one which has already</span>
<a name="l00321"></a>00321 <span class="comment">//    * been used (had memory allocated) or as a new matrix.</span>
<a name="l00322"></a>00322 <span class="comment">//    */</span>
<a name="l00323"></a>00323 <span class="comment">//   virtual void _get_submatrix(SparseMatrix&lt;T&gt;&amp; submatrix,</span>
<a name="l00324"></a>00324 <span class="comment">//                            const std::vector&lt;unsigned int&gt;&amp; rows,</span>
<a name="l00325"></a>00325 <span class="comment">//                            const std::vector&lt;unsigned int&gt;&amp; cols,</span>
<a name="l00326"></a>00326 <span class="comment">//                            const bool reuse_submatrix) const;</span>
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 <span class="keyword">private</span>:
<a name="l00329"></a>00329   
<a name="l00334"></a><a class="code" href="classEpetraMatrix.php#ad54199356b60d45a8df68d78561f901f">00334</a>   Epetra_FECrsMatrix * <a class="code" href="classEpetraMatrix.php#ad54199356b60d45a8df68d78561f901f">_mat</a>;
<a name="l00335"></a>00335 
<a name="l00339"></a><a class="code" href="classEpetraMatrix.php#af587f0356d3284bc9a93731bdc5b4d21">00339</a>   Epetra_Map * <a class="code" href="classEpetraMatrix.php#af587f0356d3284bc9a93731bdc5b4d21">_map</a>;
<a name="l00340"></a>00340 
<a name="l00344"></a><a class="code" href="classEpetraMatrix.php#adfc6e89d0bb813b08663f43480bbb9d1">00344</a>   Epetra_CrsGraph * <a class="code" href="classEpetraMatrix.php#adfc6e89d0bb813b08663f43480bbb9d1">_graph</a>;
<a name="l00345"></a>00345 
<a name="l00350"></a><a class="code" href="classEpetraMatrix.php#a4fafbeac23313c3d1f3081ca7fa0689b">00350</a>   <span class="keywordtype">bool</span> <a class="code" href="classEpetraMatrix.php#a4fafbeac23313c3d1f3081ca7fa0689b">_destroy_mat_on_exit</a>;
<a name="l00351"></a>00351 };
<a name="l00352"></a>00352 
<a name="l00353"></a>00353 
<a name="l00354"></a>00354 
<a name="l00355"></a>00355 
<a name="l00356"></a>00356 <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00357"></a>00357 <span class="comment">// EpetraMatrix inline members</span>
<a name="l00358"></a>00358 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00359"></a>00359 <span class="keyword">inline</span>
<a name="l00360"></a><a class="code" href="classEpetraMatrix.php#a5a0feeb5897b66f3188544fc25915950">00360</a> <a class="code" href="classEpetraMatrix.php#a5a0feeb5897b66f3188544fc25915950">EpetraMatrix&lt;T&gt;::EpetraMatrix</a>()
<a name="l00361"></a>00361   : _destroy_mat_on_exit(true)
<a name="l00362"></a>00362 {}
<a name="l00363"></a>00363 
<a name="l00364"></a>00364 
<a name="l00365"></a>00365 
<a name="l00366"></a>00366 
<a name="l00367"></a>00367 <span class="comment">// template &lt;typename T&gt;</span>
<a name="l00368"></a>00368 <span class="comment">// inline</span>
<a name="l00369"></a>00369 <span class="comment">// EpetraMatrix&lt;T&gt;::EpetraMatrix(Mat m)</span>
<a name="l00370"></a>00370 <span class="comment">//   : _destroy_mat_on_exit(false)</span>
<a name="l00371"></a>00371 <span class="comment">// {</span>
<a name="l00372"></a>00372 <span class="comment">//   this-&gt;_mat = m;</span>
<a name="l00373"></a>00373 <span class="comment">//   this-&gt;_is_initialized = true;</span>
<a name="l00374"></a>00374 <span class="comment">// }</span>
<a name="l00375"></a>00375 
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 
<a name="l00379"></a>00379 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00380"></a>00380 <span class="keyword">inline</span>
<a name="l00381"></a><a class="code" href="classEpetraMatrix.php#aa7bed4b34b15a9e41b645da2391ef03d">00381</a> <a class="code" href="classEpetraMatrix.php#aa7bed4b34b15a9e41b645da2391ef03d">EpetraMatrix&lt;T&gt;::~EpetraMatrix</a>()
<a name="l00382"></a>00382 {
<a name="l00383"></a>00383   this-&gt;clear();
<a name="l00384"></a>00384 }
<a name="l00385"></a>00385 
<a name="l00386"></a>00386 
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00389"></a>00389 <span class="keyword">inline</span>
<a name="l00390"></a><a class="code" href="classEpetraMatrix.php#a747592334500dc1be61061679f942f1d">00390</a> <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#a747592334500dc1be61061679f942f1d">EpetraMatrix&lt;T&gt;::close</a> ()<span class="keyword"> const</span>
<a name="l00391"></a>00391 <span class="keyword"></span>{
<a name="l00392"></a>00392   libmesh_assert (_mat != NULL);
<a name="l00393"></a>00393   
<a name="l00394"></a>00394   _mat-&gt;GlobalAssemble();
<a name="l00395"></a>00395 }
<a name="l00396"></a>00396 
<a name="l00397"></a>00397 
<a name="l00398"></a>00398 
<a name="l00399"></a>00399 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00400"></a>00400 <span class="keyword">inline</span>
<a name="l00401"></a><a class="code" href="classEpetraMatrix.php#ac0a95ae11097c89155bbd2e52a2b1da6">00401</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEpetraMatrix.php#ac0a95ae11097c89155bbd2e52a2b1da6">EpetraMatrix&lt;T&gt;::m</a> ()<span class="keyword"> const</span>
<a name="l00402"></a>00402 <span class="keyword"></span>{
<a name="l00403"></a>00403   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00404"></a>00404   
<a name="l00405"></a>00405   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(_mat-&gt;NumGlobalRows());
<a name="l00406"></a>00406 }
<a name="l00407"></a>00407 
<a name="l00408"></a>00408 
<a name="l00409"></a>00409 
<a name="l00410"></a>00410 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00411"></a>00411 <span class="keyword">inline</span>
<a name="l00412"></a><a class="code" href="classEpetraMatrix.php#aa7497e81988d6a6e6a02900c7a36943b">00412</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEpetraMatrix.php#aa7497e81988d6a6e6a02900c7a36943b">EpetraMatrix&lt;T&gt;::n</a> ()<span class="keyword"> const</span>
<a name="l00413"></a>00413 <span class="keyword"></span>{
<a name="l00414"></a>00414   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00415"></a>00415   
<a name="l00416"></a>00416   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(_mat-&gt;NumGlobalCols());
<a name="l00417"></a>00417 }
<a name="l00418"></a>00418 
<a name="l00419"></a>00419 
<a name="l00420"></a>00420 
<a name="l00421"></a>00421 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00422"></a>00422 <span class="keyword">inline</span>
<a name="l00423"></a><a class="code" href="classEpetraMatrix.php#adff20d626076d7ea432b7769cd5fec45">00423</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEpetraMatrix.php#adff20d626076d7ea432b7769cd5fec45">EpetraMatrix&lt;T&gt;::row_start</a> ()<span class="keyword"> const</span>
<a name="l00424"></a>00424 <span class="keyword"></span>{
<a name="l00425"></a>00425   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00426"></a>00426   libmesh_assert (_map != NULL);
<a name="l00427"></a>00427 
<a name="l00428"></a>00428   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(_map-&gt;MinMyGID());
<a name="l00429"></a>00429 }
<a name="l00430"></a>00430 
<a name="l00431"></a>00431 
<a name="l00432"></a>00432 
<a name="l00433"></a>00433 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00434"></a>00434 <span class="keyword">inline</span>
<a name="l00435"></a><a class="code" href="classEpetraMatrix.php#a75ee9742806ec0aa255d747a63dae330">00435</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEpetraMatrix.php#a75ee9742806ec0aa255d747a63dae330">EpetraMatrix&lt;T&gt;::row_stop</a> ()<span class="keyword"> const</span>
<a name="l00436"></a>00436 <span class="keyword"></span>{
<a name="l00437"></a>00437   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00438"></a>00438   libmesh_assert (_map != NULL);
<a name="l00439"></a>00439 
<a name="l00440"></a>00440   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(_map-&gt;MaxMyGID())+1;
<a name="l00441"></a>00441 }
<a name="l00442"></a>00442 
<a name="l00443"></a>00443 
<a name="l00444"></a>00444 
<a name="l00445"></a>00445 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00446"></a>00446 <span class="keyword">inline</span>
<a name="l00447"></a><a class="code" href="classEpetraMatrix.php#a6d93cb2f3d798741704fb79017c4cf60">00447</a> <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#a6d93cb2f3d798741704fb79017c4cf60">EpetraMatrix&lt;T&gt;::set</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00448"></a>00448                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00449"></a>00449                            <span class="keyword">const</span> T value)
<a name="l00450"></a>00450 {  
<a name="l00451"></a>00451   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00452"></a>00452 
<a name="l00453"></a>00453   <span class="keywordtype">int</span> 
<a name="l00454"></a>00454     epetra_i = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(i),
<a name="l00455"></a>00455     epetra_j = static_cast&lt;int&gt;(j);
<a name="l00456"></a>00456 
<a name="l00457"></a>00457   T epetra_value = value;
<a name="l00458"></a>00458 
<a name="l00459"></a>00459   <span class="keywordflow">if</span> (_mat-&gt;Filled())    
<a name="l00460"></a>00460     _mat-&gt;ReplaceGlobalValues (epetra_i, 1, &amp;epetra_value, &amp;epetra_j);
<a name="l00461"></a>00461   <span class="keywordflow">else</span>    
<a name="l00462"></a>00462     _mat-&gt;InsertGlobalValues (epetra_i, 1, &amp;epetra_value, &amp;epetra_j);
<a name="l00463"></a>00463 }
<a name="l00464"></a>00464 
<a name="l00465"></a>00465 
<a name="l00466"></a>00466 
<a name="l00467"></a>00467 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00468"></a>00468 <span class="keyword">inline</span>
<a name="l00469"></a><a class="code" href="classEpetraMatrix.php#aa9ee18302fecbc421078edc71e8a87d3">00469</a> <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#aa9ee18302fecbc421078edc71e8a87d3">EpetraMatrix&lt;T&gt;::add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00470"></a>00470                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00471"></a>00471                            <span class="keyword">const</span> T value)
<a name="l00472"></a>00472 {
<a name="l00473"></a>00473   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00474"></a>00474   
<a name="l00475"></a>00475   <span class="keywordtype">int</span> 
<a name="l00476"></a>00476     epetra_i = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(i),
<a name="l00477"></a>00477     epetra_j = static_cast&lt;int&gt;(j);
<a name="l00478"></a>00478 
<a name="l00479"></a>00479   T epetra_value = value;
<a name="l00480"></a>00480   
<a name="l00481"></a>00481   _mat-&gt;SumIntoGlobalValues (epetra_i, 1, &amp;epetra_value, &amp;epetra_j);
<a name="l00482"></a>00482 }
<a name="l00483"></a>00483 
<a name="l00484"></a>00484 
<a name="l00485"></a>00485 
<a name="l00486"></a>00486 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00487"></a>00487 <span class="keyword">inline</span>
<a name="l00488"></a><a class="code" href="classEpetraMatrix.php#a52d9053cd2627f43ac7d34d5a969ad7a">00488</a> <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#a353f009f4da476ae1323d75e92d6bef5">EpetraMatrix&lt;T&gt;::add_matrix</a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dm,
<a name="l00489"></a>00489                                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00490"></a>00490 {
<a name="l00491"></a>00491   this-&gt;add_matrix (dm, dof_indices, dof_indices);
<a name="l00492"></a>00492 }
<a name="l00493"></a>00493 
<a name="l00494"></a>00494 
<a name="l00495"></a>00495 
<a name="l00496"></a>00496 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00497"></a>00497 <span class="keyword">inline</span>
<a name="l00498"></a><a class="code" href="classEpetraMatrix.php#a8f959777a9c68f91bde524ed5258abd5">00498</a> <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#aa9ee18302fecbc421078edc71e8a87d3">EpetraMatrix&lt;T&gt;::add</a> (<span class="keyword">const</span> T, <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;X_in)
<a name="l00499"></a>00499 {
<a name="l00500"></a>00500   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00501"></a>00501 
<a name="l00502"></a>00502   <span class="comment">// sanity check. but this cannot avoid </span>
<a name="l00503"></a>00503   <span class="comment">// crash due to incompatible sparsity structure...</span>
<a name="l00504"></a>00504   libmesh_assert (this-&gt;m() == X_in.<a class="code" href="classSparseMatrix.php#af2f0d62994782f324c59bd4203b9d1d2">m</a>());
<a name="l00505"></a>00505   libmesh_assert (this-&gt;n() == X_in.<a class="code" href="classSparseMatrix.php#af540f97c67ca77cf3a6dc7a4f1551c19">n</a>());
<a name="l00506"></a>00506 
<a name="l00507"></a>00507   libmesh_not_implemented();
<a name="l00508"></a>00508 
<a name="l00509"></a>00509 <span class="comment">//   PetscScalar     a = static_cast&lt;PetscScalar&gt;      (a_in);</span>
<a name="l00510"></a>00510 <span class="comment">//   EpetraMatrix&lt;T&gt;* X = dynamic_cast&lt;EpetraMatrix&lt;T&gt;*&gt; (&amp;X_in);</span>
<a name="l00511"></a>00511 
<a name="l00512"></a>00512 <span class="comment">//   libmesh_assert (X != NULL);</span>
<a name="l00513"></a>00513   
<a name="l00514"></a>00514 <span class="comment">//   int ierr=0;</span>
<a name="l00515"></a>00515 
<a name="l00516"></a>00516 <span class="comment">//   // the matrix from which we copy the values has to be assembled/closed</span>
<a name="l00517"></a>00517 <span class="comment">//   X-&gt;close ();</span>
<a name="l00518"></a>00518 
<a name="l00519"></a>00519 <span class="comment">// // 2.2.x &amp; earlier style</span>
<a name="l00520"></a>00520 <span class="comment">// #if PETSC_VERSION_LESS_THAN(2,3,0)  </span>
<a name="l00521"></a>00521   
<a name="l00522"></a>00522 <span class="comment">//   ierr = MatAXPY(&amp;a,  X-&gt;_mat, _mat, SAME_NONZERO_PATTERN);</span>
<a name="l00523"></a>00523 <span class="comment">//          CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00524"></a>00524          
<a name="l00525"></a>00525 <span class="comment">// // 2.3.x &amp; newer</span>
<a name="l00526"></a>00526 <span class="comment">// #else</span>
<a name="l00527"></a>00527   
<a name="l00528"></a>00528 <span class="comment">//   ierr = MatAXPY(_mat, a, X-&gt;_mat, DIFFERENT_NONZERO_PATTERN);</span>
<a name="l00529"></a>00529 <span class="comment">//          CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00530"></a>00530          
<a name="l00531"></a>00531 <span class="comment">// #endif</span>
<a name="l00532"></a>00532 }
<a name="l00533"></a>00533 
<a name="l00534"></a>00534 
<a name="l00535"></a>00535 
<a name="l00536"></a>00536 
<a name="l00537"></a>00537 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00538"></a>00538 <span class="keyword">inline</span>
<a name="l00539"></a><a class="code" href="classEpetraMatrix.php#a986ca4e8f807491ed4f01d449d144e3c">00539</a> T <a class="code" href="classEpetraMatrix.php#a986ca4e8f807491ed4f01d449d144e3c">EpetraMatrix&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00540"></a>00540                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const</span>
<a name="l00541"></a>00541 <span class="keyword"></span>{
<a name="l00542"></a>00542   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00543"></a>00543   libmesh_assert (this-&gt;_mat != NULL);
<a name="l00544"></a>00544   libmesh_assert (this-&gt;_mat-&gt;MyGlobalRow(i));
<a name="l00545"></a>00545   libmesh_assert (i &gt;= this-&gt;row_start());
<a name="l00546"></a>00546   libmesh_assert (i &lt; this-&gt;row_stop());
<a name="l00547"></a>00547 
<a name="l00548"></a>00548 
<a name="l00549"></a>00549   <span class="keywordtype">int</span> row_length, *row_indices;
<a name="l00550"></a>00550   <span class="keywordtype">double</span> *values;
<a name="l00551"></a>00551 
<a name="l00552"></a>00552   _mat-&gt;ExtractMyRowView (i-this-&gt;row_start(),
<a name="l00553"></a>00553                           row_length,
<a name="l00554"></a>00554                           values,
<a name="l00555"></a>00555                           row_indices);
<a name="l00556"></a>00556 
<a name="l00557"></a>00557   <span class="comment">//std::cout &lt;&lt; &quot;row_length=&quot; &lt;&lt; row_length &lt;&lt; std::endl;</span>
<a name="l00558"></a>00558 
<a name="l00559"></a>00559   <span class="keywordtype">int</span> *index = std::lower_bound (row_indices, row_indices+row_length, j);
<a name="l00560"></a>00560 
<a name="l00561"></a>00561   libmesh_assert (*index &lt; row_length);
<a name="l00562"></a>00562   libmesh_assert (static_cast&lt;unsigned int&gt;(row_indices[*index]) == j);
<a name="l00563"></a>00563 
<a name="l00564"></a>00564   <span class="comment">//std::cout &lt;&lt; &quot;val=&quot; &lt;&lt; values[*index] &lt;&lt; std::endl;</span>
<a name="l00565"></a>00565   
<a name="l00566"></a>00566   <span class="keywordflow">return</span> values[*index];
<a name="l00567"></a>00567 }
<a name="l00568"></a>00568 
<a name="l00569"></a>00569 
<a name="l00570"></a>00570 
<a name="l00571"></a>00571 
<a name="l00572"></a>00572 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00573"></a>00573 <span class="keyword">inline</span>
<a name="l00574"></a><a class="code" href="classEpetraMatrix.php#a04ec73396cb4ae1b0f2f396d83be3ac8">00574</a> <span class="keywordtype">bool</span> <a class="code" href="classEpetraMatrix.php#a04ec73396cb4ae1b0f2f396d83be3ac8">EpetraMatrix&lt;T&gt;::closed</a>()<span class="keyword"> const</span>
<a name="l00575"></a>00575 <span class="keyword"></span>{
<a name="l00576"></a>00576   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00577"></a>00577   libmesh_assert (this-&gt;_mat != NULL);
<a name="l00578"></a>00578   
<a name="l00579"></a>00579   <span class="keywordflow">return</span> this-&gt;_mat-&gt;Filled();
<a name="l00580"></a>00580 }
<a name="l00581"></a>00581 
<a name="l00582"></a>00582 
<a name="l00583"></a>00583 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00584"></a>00584 <span class="keyword">inline</span>
<a name="l00585"></a>00585 <span class="comment">//void EpetraMatrix&lt;T&gt;::swap(EpetraMatrix&lt;T&gt; &amp;m) </span>
<a name="l00586"></a><a class="code" href="classEpetraMatrix.php#a7d168758974b67f39c8b80d0b219b179">00586</a> <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#a7d168758974b67f39c8b80d0b219b179">EpetraMatrix&lt;T&gt;::swap</a>(<a class="code" href="classEpetraMatrix.php">EpetraMatrix&lt;T&gt;</a> &amp;) 
<a name="l00587"></a>00587 {
<a name="l00588"></a>00588   libmesh_not_implemented();
<a name="l00589"></a>00589 
<a name="l00590"></a>00590 <span class="comment">//   std::swap(_mat, m._mat);</span>
<a name="l00591"></a>00591 <span class="comment">//   std::swap(_destroy_mat_on_exit, m._destroy_mat_on_exit);</span>
<a name="l00592"></a>00592 }
<a name="l00593"></a>00593 
<a name="l00594"></a>00594 
<a name="l00595"></a>00595 
<a name="l00596"></a>00596 
<a name="l00597"></a>00597 
<a name="l00598"></a>00598 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00599"></a>00599 <span class="keyword">inline</span>
<a name="l00600"></a><a class="code" href="classEpetraMatrix.php#ac28e9063016e76d3d61f9258e3f39b7d">00600</a> <span class="keywordtype">void</span> <a class="code" href="classEpetraMatrix.php#ac28e9063016e76d3d61f9258e3f39b7d">EpetraMatrix&lt;T&gt;::print_personal</a>(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00601"></a>00601 <span class="keyword"></span>{
<a name="l00602"></a>00602   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00603"></a>00603   libmesh_assert (_mat != NULL);
<a name="l00604"></a>00604 
<a name="l00605"></a>00605   os &lt;&lt; *_mat;
<a name="l00606"></a>00606 }
<a name="l00607"></a>00607 
<a name="l00608"></a>00608 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_TRILINOS</span>
<a name="l00609"></a>00609 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __trilinos_epetra_matrix_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
