<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>trilinos_epetra_vector.h</h1>  </div>
</div>
<div class="contents">
<a href="trilinos__epetra__vector_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: trilinos_epetra_vector.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __trilinos_epetra_vector_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __trilinos_epetra_vector_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#ifdef LIBMESH_HAVE_TRILINOS</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="comment">// C++ includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Local includes</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Trilinos includes</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &lt;Epetra_CombineMode.h&gt;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &lt;Epetra_Map.h&gt;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &lt;Epetra_MultiVector.h&gt;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &lt;Epetra_Vector.h&gt;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &lt;Epetra_MpiComm.h&gt;</span>
<a name="l00041"></a>00041 <span class="keyword">class </span>Epetra_IntSerialDenseVector;
<a name="l00042"></a>00042 <span class="keyword">class </span>Epetra_SerialDenseVector;
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="comment">// forward declarations</span>
<a name="l00045"></a>00045 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classSparseMatrix.php">SparseMatrix</a>;
<a name="l00046"></a>00046 
<a name="l00054"></a>00054 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00055"></a><a class="code" href="classEpetraVector.php">00055</a> <span class="keyword">class </span><a class="code" href="classEpetraVector.php">EpetraVector</a> : <span class="keyword">public</span> <a class="code" href="classNumericVector.php">NumericVector</a>&lt;T&gt;
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057 <span class="keyword">public</span>:
<a name="l00058"></a>00058 
<a name="l00062"></a>00062   <span class="keyword">explicit</span>
<a name="l00063"></a>00063   <a class="code" href="classEpetraVector.php#abc5a328d5da1c17c4c4a719579dc9349">EpetraVector</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00064"></a>00064   
<a name="l00068"></a>00068   <span class="keyword">explicit</span>
<a name="l00069"></a>00069   <a class="code" href="classEpetraVector.php#abc5a328d5da1c17c4c4a719579dc9349">EpetraVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00070"></a>00070                 <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00071"></a>00071     
<a name="l00076"></a>00076   <a class="code" href="classEpetraVector.php#abc5a328d5da1c17c4c4a719579dc9349">EpetraVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00077"></a>00077                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00078"></a>00078                 <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00079"></a>00079 
<a name="l00085"></a>00085   <a class="code" href="classEpetraVector.php#abc5a328d5da1c17c4c4a719579dc9349">EpetraVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00086"></a>00086                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00087"></a>00087                 <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ghost,
<a name="l00088"></a>00088                 <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00089"></a>00089 
<a name="l00097"></a>00097   <a class="code" href="classEpetraVector.php#abc5a328d5da1c17c4c4a719579dc9349">EpetraVector</a>(Epetra_Vector &amp; v);
<a name="l00098"></a>00098   
<a name="l00103"></a>00103   <a class="code" href="classEpetraVector.php#ada79e30f1ea85b0f0df34548c4cf0280">~EpetraVector</a> ();
<a name="l00104"></a>00104 
<a name="l00108"></a>00108   <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a43705b37c77227d571b18088d5cafcd3">close</a> (); 
<a name="l00109"></a>00109 
<a name="l00113"></a>00113   <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#ae9ffda7db7eac14162e4aeb0f7a33d8a">clear</a> ();
<a name="l00114"></a>00114   
<a name="l00119"></a>00119   <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a689954a2f42e1e35b9c2f4a6a282da52">zero</a> ();    
<a name="l00120"></a>00120 
<a name="l00124"></a>00124   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classEpetraVector.php#a81434c432371dd2d07d238a7811440f6">clone</a> () <span class="keyword">const</span>;
<a name="l00125"></a>00125   
<a name="l00139"></a>00139   <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a100adb95b2abc9b98ac8a3799c1382e3">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00140"></a>00140              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00141"></a>00141              <span class="keyword">const</span> <span class="keywordtype">bool</span>         fast=<span class="keyword">false</span>,
<a name="l00142"></a>00142              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a>=<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00143"></a>00143     
<a name="l00147"></a>00147   <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a100adb95b2abc9b98ac8a3799c1382e3">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00148"></a>00148              <span class="keyword">const</span> <span class="keywordtype">bool</span>         fast=<span class="keyword">false</span>,
<a name="l00149"></a>00149              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a>=<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00150"></a>00150 
<a name="l00155"></a>00155   <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a100adb95b2abc9b98ac8a3799c1382e3">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*N*/</span>,
<a name="l00156"></a>00156              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*n_local*/</span>,
<a name="l00157"></a>00157              <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <span class="comment">/*ghost*/</span>,
<a name="l00158"></a>00158              <span class="keyword">const</span> <span class="keywordtype">bool</span> <span class="comment">/*fast*/</span> = <span class="keyword">false</span>,
<a name="l00159"></a>00159              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00160"></a>00160 
<a name="l00165"></a>00165   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a100adb95b2abc9b98ac8a3799c1382e3">init</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; other,
<a name="l00166"></a>00166                      <span class="keyword">const</span> <span class="keywordtype">bool</span> fast = <span class="keyword">false</span>);
<a name="l00167"></a>00167 
<a name="l00168"></a>00168   <span class="comment">//   /**</span>
<a name="l00169"></a>00169   <span class="comment">//    * Change the dimension to that of the</span>
<a name="l00170"></a>00170   <span class="comment">//    * vector \p V. The same applies as for</span>
<a name="l00171"></a>00171   <span class="comment">//    * the other \p init function.</span>
<a name="l00172"></a>00172   <span class="comment">//    *</span>
<a name="l00173"></a>00173   <span class="comment">//    * The elements of \p V are not copied, i.e.</span>
<a name="l00174"></a>00174   <span class="comment">//    * this function is the same as calling</span>
<a name="l00175"></a>00175   <span class="comment">//    * \p init(V.size(),fast).</span>
<a name="l00176"></a>00176   <span class="comment">//    */</span>
<a name="l00177"></a>00177   <span class="comment">//   void init (const NumericVector&lt;T&gt;&amp; V,</span>
<a name="l00178"></a>00178   <span class="comment">//         const bool fast=false);</span>
<a name="l00179"></a>00179 
<a name="l00183"></a>00183   <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classEpetraVector.php#aaceb3c86e3849d550477117ecf0db3c1">operator= </a>(<span class="keyword">const</span> T s);
<a name="l00184"></a>00184     
<a name="l00188"></a>00188   <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classEpetraVector.php#aaceb3c86e3849d550477117ecf0db3c1">operator= </a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00189"></a>00189 
<a name="l00193"></a>00193   <a class="code" href="classEpetraVector.php">EpetraVector&lt;T&gt;</a> &amp; <a class="code" href="classEpetraVector.php#aaceb3c86e3849d550477117ecf0db3c1">operator= </a>(<span class="keyword">const</span> <a class="code" href="classEpetraVector.php">EpetraVector&lt;T&gt;</a> &amp;V);
<a name="l00194"></a>00194 
<a name="l00198"></a>00198   <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classEpetraVector.php#aaceb3c86e3849d550477117ecf0db3c1">operator= </a>(<span class="keyword">const</span> std::vector&lt;T&gt; &amp;v);
<a name="l00199"></a>00199 
<a name="l00205"></a>00205   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classEpetraVector.php#aea0f37ee3fcb7dfa61ce21d31b663508">min</a> () <span class="keyword">const</span>;
<a name="l00206"></a>00206   
<a name="l00212"></a>00212   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classEpetraVector.php#a9c858cc09fba3fb368a5e2d030681108">max</a> () <span class="keyword">const</span>;
<a name="l00213"></a>00213 
<a name="l00217"></a>00217   T <a class="code" href="classEpetraVector.php#a8142e784df8901313d06d5e03e664cc2">sum</a> () <span class="keyword">const</span>;
<a name="l00218"></a>00218 
<a name="l00223"></a>00223   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classEpetraVector.php#a7a708a56e92586e58ae78a5b4cff032f">l1_norm</a> () <span class="keyword">const</span>;
<a name="l00224"></a>00224 
<a name="l00230"></a>00230   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classEpetraVector.php#aadedce96550c0ef8c09ebd1cc6af89c9">l2_norm</a> () <span class="keyword">const</span>;
<a name="l00231"></a>00231 
<a name="l00237"></a>00237   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classEpetraVector.php#aa6b0a386433af591bce2601c39d368c4">linfty_norm</a> () <span class="keyword">const</span>;
<a name="l00238"></a>00238 
<a name="l00246"></a>00246   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEpetraVector.php#adb6e300ac9fc54dd123ed6337c9e054f">size</a> () <span class="keyword">const</span>;
<a name="l00247"></a>00247 
<a name="l00252"></a>00252   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEpetraVector.php#ac57d0cb2a93c9a08fe9e30681120cb6a">local_size</a>() <span class="keyword">const</span>;
<a name="l00253"></a>00253 
<a name="l00258"></a>00258   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEpetraVector.php#aca7656b4da462b84702270d32d6037eb">first_local_index</a>() <span class="keyword">const</span>;
<a name="l00259"></a>00259 
<a name="l00264"></a>00264   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEpetraVector.php#a999b490ed2d3d6d544fed9ce5a204891">last_local_index</a>() <span class="keyword">const</span>;
<a name="l00265"></a>00265     
<a name="l00269"></a>00269   T <a class="code" href="classEpetraVector.php#af1e0daa4009c1b6a55764a0de464384a">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00270"></a>00270     
<a name="l00275"></a>00275   <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classEpetraVector.php#a12fc1168af7742f4af3291021ff21e0b">operator += </a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00276"></a>00276 
<a name="l00281"></a>00281   <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classEpetraVector.php#a4db6c8ccc09e67110a85d36d876431df">operator -= </a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00282"></a>00282     
<a name="l00286"></a>00286   <span class="keywordtype">void</span> <span class="keyword">set</span> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value);
<a name="l00287"></a>00287     
<a name="l00291"></a>00291   <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#ad8e95bfe6b058dfd8d628e2edde9ebec">add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value);
<a name="l00292"></a>00292     
<a name="l00298"></a>00298   <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#ad8e95bfe6b058dfd8d628e2edde9ebec">add</a> (<span class="keyword">const</span> T s);
<a name="l00299"></a>00299     
<a name="l00305"></a>00305   <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#ad8e95bfe6b058dfd8d628e2edde9ebec">add</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; V);
<a name="l00306"></a>00306 
<a name="l00312"></a>00312   <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#ad8e95bfe6b058dfd8d628e2edde9ebec">add</a> (<span class="keyword">const</span> T a, <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v);
<a name="l00313"></a>00313   
<a name="l00319"></a>00319   <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a73dfb129e6135b8da1be7f401661fcf5">add_vector</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00320"></a>00320                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00321"></a>00321 
<a name="l00328"></a>00328   <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a73dfb129e6135b8da1be7f401661fcf5">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00329"></a>00329                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 
<a name="l00336"></a>00336   <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a73dfb129e6135b8da1be7f401661fcf5">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;V,
<a name="l00337"></a>00337                    <span class="keyword">const</span> <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;A);
<a name="l00338"></a>00338      
<a name="l00345"></a>00345   <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a73dfb129e6135b8da1be7f401661fcf5">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00346"></a>00346                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00347"></a>00347   
<a name="l00352"></a>00352   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a69b30cf8bfeb59c50ee1e2331273a8bb">insert</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00353"></a>00353                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00354"></a>00354 
<a name="l00361"></a>00361   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a69b30cf8bfeb59c50ee1e2331273a8bb">insert</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00362"></a>00362                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00363"></a>00363       
<a name="l00369"></a>00369   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a69b30cf8bfeb59c50ee1e2331273a8bb">insert</a> (<span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00370"></a>00370                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00371"></a>00371     
<a name="l00377"></a>00377   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a69b30cf8bfeb59c50ee1e2331273a8bb">insert</a> (<span class="keyword">const</span> <a class="code" href="classDenseSubVector.php">DenseSubVector&lt;T&gt;</a>&amp; V,
<a name="l00378"></a>00378                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00379"></a>00379   
<a name="l00384"></a>00384   <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a491671f509371d8aa6cf7e2c9171cc2e">scale</a> (<span class="keyword">const</span> T factor);
<a name="l00385"></a>00385 
<a name="l00390"></a>00390   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a32dc3b6f29537de3ea780cd85ce6e07c">abs</a>();
<a name="l00391"></a>00391 
<a name="l00392"></a>00392 
<a name="l00396"></a>00396   <span class="keyword">virtual</span> T <a class="code" href="classEpetraVector.php#a80bf6f2b1573e8e68c4b02af9f2c661e">dot</a>(<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; V) <span class="keyword">const</span>;
<a name="l00397"></a>00397   
<a name="l00402"></a>00402   <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a93c839c4cc930455f5adba7fb249fe12">localize</a> (std::vector&lt;T&gt;&amp; v_local) <span class="keyword">const</span>;
<a name="l00403"></a>00403 
<a name="l00408"></a>00408   <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a93c839c4cc930455f5adba7fb249fe12">localize</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local) <span class="keyword">const</span>;
<a name="l00409"></a>00409 
<a name="l00415"></a>00415   <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a93c839c4cc930455f5adba7fb249fe12">localize</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local,
<a name="l00416"></a>00416                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list) <span class="keyword">const</span>;
<a name="l00417"></a>00417   
<a name="l00422"></a>00422   <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a93c839c4cc930455f5adba7fb249fe12">localize</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_idx,
<a name="l00423"></a>00423                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> last_local_idx,
<a name="l00424"></a>00424                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list);
<a name="l00425"></a>00425   
<a name="l00432"></a>00432   <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a71e3dd8afa2d5fcf9069e6cafd0703c2">localize_to_one</a> (std::vector&lt;T&gt;&amp; v_local,
<a name="l00433"></a>00433                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id=0) <span class="keyword">const</span>;
<a name="l00434"></a>00434   
<a name="l00439"></a>00439   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a7a54c773f2691fdcc529c82e92c1d229">pointwise_mult</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec1,
<a name="l00440"></a>00440                                <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec2);
<a name="l00441"></a>00441 
<a name="l00448"></a>00448   <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a2ed1d0157147787b4b911ccd5cc772bb">print_matlab</a> (<span class="keyword">const</span> std::string <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>=<span class="stringliteral">&quot;NULL&quot;</span>) <span class="keyword">const</span>;
<a name="l00449"></a>00449 
<a name="l00454"></a>00454   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#ac08564569e6866071c4dd2a3b3ef8a70">create_subvector</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; subvector,
<a name="l00455"></a>00455                                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; rows) <span class="keyword">const</span>;
<a name="l00456"></a>00456 
<a name="l00460"></a>00460   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#afeb977425164e722fc80f53497224b5c">swap</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;v);
<a name="l00461"></a>00461 
<a name="l00467"></a><a class="code" href="classEpetraVector.php#a6450f0433271c9bb4a3637e4e2092f61">00467</a>   Epetra_Vector * <a class="code" href="classEpetraVector.php#a6450f0433271c9bb4a3637e4e2092f61">vec</a> () { libmesh_assert (<a class="code" href="classEpetraVector.php#a1aba50131cd5f5cad27159132c7edd56">_vec</a> != NULL); <span class="keywordflow">return</span> <a class="code" href="classEpetraVector.php#a1aba50131cd5f5cad27159132c7edd56">_vec</a>; }
<a name="l00468"></a>00468 
<a name="l00469"></a>00469 <span class="keyword">private</span>:
<a name="l00470"></a>00470 
<a name="l00475"></a><a class="code" href="classEpetraVector.php#a1aba50131cd5f5cad27159132c7edd56">00475</a>   Epetra_Vector * <a class="code" href="classEpetraVector.php#a1aba50131cd5f5cad27159132c7edd56">_vec</a>;
<a name="l00476"></a>00476 
<a name="l00480"></a><a class="code" href="classEpetraVector.php#adc295c727399ef2a650c4bdb260d2571">00480</a>   Epetra_Map * <a class="code" href="classEpetraVector.php#adc295c727399ef2a650c4bdb260d2571">_map</a>;
<a name="l00481"></a>00481 
<a name="l00486"></a><a class="code" href="classEpetraVector.php#a82b72f0060be39c91da4f4e1f0ff6f1c">00486</a>   <span class="keywordtype">bool</span> <a class="code" href="classEpetraVector.php#a82b72f0060be39c91da4f4e1f0ff6f1c">_destroy_vec_on_exit</a>;
<a name="l00487"></a>00487 
<a name="l00488"></a>00488 
<a name="l00489"></a>00489   
<a name="l00490"></a>00490   <span class="comment">/*********************************************************************</span>
<a name="l00491"></a>00491 <span class="comment">   * The following were copied (and slightly modified) from</span>
<a name="l00492"></a>00492 <span class="comment">   * Epetra_FEVector.h in order to allow us to use a standard</span>
<a name="l00493"></a>00493 <span class="comment">   * Epetra_Vector... which is more compatible with other Trilinos</span>
<a name="l00494"></a>00494 <span class="comment">   * packages such as NOX.  All of this code is originally under LGPL</span>
<a name="l00495"></a>00495 <span class="comment">   *********************************************************************/</span>
<a name="l00496"></a>00496 
<a name="l00500"></a>00500   <span class="keywordtype">int</span> <a class="code" href="classEpetraVector.php#a20d7dde0228645b56ab8bf2125970025">SumIntoGlobalValues</a>(<span class="keywordtype">int</span> numIDs, <span class="keyword">const</span> <span class="keywordtype">int</span>* GIDs, <span class="keyword">const</span> <span class="keywordtype">double</span>* values);
<a name="l00501"></a>00501 
<a name="l00511"></a>00511   <span class="keywordtype">int</span> <a class="code" href="classEpetraVector.php#a20d7dde0228645b56ab8bf2125970025">SumIntoGlobalValues</a>(<span class="keyword">const</span> Epetra_IntSerialDenseVector&amp; GIDs,
<a name="l00512"></a>00512                           <span class="keyword">const</span> Epetra_SerialDenseVector&amp; values);
<a name="l00513"></a>00513 
<a name="l00517"></a>00517   <span class="keywordtype">int</span> <a class="code" href="classEpetraVector.php#a00b3bed0c7f77d53d207407cbec2f65c">ReplaceGlobalValues</a>(<span class="keywordtype">int</span> numIDs, <span class="keyword">const</span> <span class="keywordtype">int</span>* GIDs, <span class="keyword">const</span> <span class="keywordtype">double</span>* values);
<a name="l00518"></a>00518 
<a name="l00528"></a>00528   <span class="keywordtype">int</span> <a class="code" href="classEpetraVector.php#a00b3bed0c7f77d53d207407cbec2f65c">ReplaceGlobalValues</a>(<span class="keyword">const</span> Epetra_IntSerialDenseVector&amp; GIDs,
<a name="l00529"></a>00529                           <span class="keyword">const</span> Epetra_SerialDenseVector&amp; values);
<a name="l00530"></a>00530 
<a name="l00531"></a>00531   <span class="keywordtype">int</span> <a class="code" href="classEpetraVector.php#a20d7dde0228645b56ab8bf2125970025">SumIntoGlobalValues</a>(<span class="keywordtype">int</span> numIDs, <span class="keyword">const</span> <span class="keywordtype">int</span>* GIDs,
<a name="l00532"></a>00532                           <span class="keyword">const</span> <span class="keywordtype">int</span>* numValuesPerID,
<a name="l00533"></a>00533                           <span class="keyword">const</span> <span class="keywordtype">double</span>* values);
<a name="l00534"></a>00534 
<a name="l00535"></a>00535   <span class="keywordtype">int</span> <a class="code" href="classEpetraVector.php#a00b3bed0c7f77d53d207407cbec2f65c">ReplaceGlobalValues</a>(<span class="keywordtype">int</span> numIDs, <span class="keyword">const</span> <span class="keywordtype">int</span>* GIDs,
<a name="l00536"></a>00536                           <span class="keyword">const</span> <span class="keywordtype">int</span>* numValuesPerID,
<a name="l00537"></a>00537                           <span class="keyword">const</span> <span class="keywordtype">double</span>* values);
<a name="l00538"></a>00538 
<a name="l00546"></a>00546   <span class="keywordtype">int</span> <a class="code" href="classEpetraVector.php#af253099a82b2a97f1e9ea242929a68a6">GlobalAssemble</a>(Epetra_CombineMode mode = Add);
<a name="l00547"></a>00547 
<a name="l00550"></a><a class="code" href="classEpetraVector.php#ad3f54d4099dab5c3ed071e51164689e2">00550</a>   <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#ad3f54d4099dab5c3ed071e51164689e2">setIgnoreNonLocalEntries</a>(<span class="keywordtype">bool</span> flag) {
<a name="l00551"></a>00551     <a class="code" href="classEpetraVector.php#a7fed7ac1f2f00d2aff18dff3941e186f">ignoreNonLocalEntries_</a> = flag;
<a name="l00552"></a>00552   }
<a name="l00553"></a>00553 
<a name="l00554"></a>00554   <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a5b0241e7bddcbaa57217d7816d974680">FEoperatorequals</a>(<span class="keyword">const</span> <a class="code" href="classEpetraVector.php">EpetraVector</a>&amp; source);
<a name="l00555"></a>00555 
<a name="l00556"></a>00556   <span class="keywordtype">int</span> <a class="code" href="classEpetraVector.php#a94ea56737c7b2b75bafd9c2f9c4ba682">inputValues</a>(<span class="keywordtype">int</span> numIDs,
<a name="l00557"></a>00557                   <span class="keyword">const</span> <span class="keywordtype">int</span>* GIDs, <span class="keyword">const</span> <span class="keywordtype">double</span>* values,
<a name="l00558"></a>00558                   <span class="keywordtype">bool</span> accumulate);
<a name="l00559"></a>00559 
<a name="l00560"></a>00560   <span class="keywordtype">int</span> <a class="code" href="classEpetraVector.php#a94ea56737c7b2b75bafd9c2f9c4ba682">inputValues</a>(<span class="keywordtype">int</span> numIDs,
<a name="l00561"></a>00561                   <span class="keyword">const</span> <span class="keywordtype">int</span>* GIDs, <span class="keyword">const</span> <span class="keywordtype">int</span>* numValuesPerID,
<a name="l00562"></a>00562                   <span class="keyword">const</span> <span class="keywordtype">double</span>* values,
<a name="l00563"></a>00563                   <span class="keywordtype">bool</span> accumulate);
<a name="l00564"></a>00564 
<a name="l00565"></a>00565   <span class="keywordtype">int</span> <a class="code" href="classEpetraVector.php#a50123a0fb4b2c1ec63656c6cb0a9e445">inputNonlocalValue</a>(<span class="keywordtype">int</span> GID, <span class="keywordtype">double</span> value, <span class="keywordtype">bool</span> accumulate);
<a name="l00566"></a>00566 
<a name="l00567"></a>00567   <span class="keywordtype">int</span> <a class="code" href="classEpetraVector.php#a7330793733247c6247c7f3dd9d045828">inputNonlocalValues</a>(<span class="keywordtype">int</span> GID, <span class="keywordtype">int</span> numValues, <span class="keyword">const</span> <span class="keywordtype">double</span>* values,
<a name="l00568"></a>00568                           <span class="keywordtype">bool</span> accumulate);
<a name="l00569"></a>00569 
<a name="l00570"></a>00570   <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a4b528a0c535aae44a4c6632e92b0b2ef">destroyNonlocalData</a>();
<a name="l00571"></a>00571 
<a name="l00572"></a><a class="code" href="classEpetraVector.php#a8d1bb3edca67f8fddbd771180d40b624">00572</a>   <span class="keywordtype">int</span> <a class="code" href="classEpetraVector.php#a8d1bb3edca67f8fddbd771180d40b624">myFirstID_</a>;
<a name="l00573"></a><a class="code" href="classEpetraVector.php#a8766430ba2d92462931e0a4cc682a4be">00573</a>   <span class="keywordtype">int</span> <a class="code" href="classEpetraVector.php#a8766430ba2d92462931e0a4cc682a4be">myNumIDs_</a>;
<a name="l00574"></a><a class="code" href="classEpetraVector.php#aaa9c787d5a4ef43533a0cdefadfd5c00">00574</a>   <span class="keywordtype">double</span>* <a class="code" href="classEpetraVector.php#aaa9c787d5a4ef43533a0cdefadfd5c00">myCoefs_</a>;
<a name="l00575"></a>00575 
<a name="l00576"></a><a class="code" href="classEpetraVector.php#a27e615d598fb5345d2ccaf317ed43432">00576</a>   <span class="keywordtype">int</span>* <a class="code" href="classEpetraVector.php#a27e615d598fb5345d2ccaf317ed43432">nonlocalIDs_</a>;
<a name="l00577"></a><a class="code" href="classEpetraVector.php#a41b740273460d8124214d8207e120483">00577</a>   <span class="keywordtype">int</span>* <a class="code" href="classEpetraVector.php#a41b740273460d8124214d8207e120483">nonlocalElementSize_</a>;
<a name="l00578"></a><a class="code" href="classEpetraVector.php#afb0a24b5471ebd91b22fe39e2155b04e">00578</a>   <span class="keywordtype">int</span> <a class="code" href="classEpetraVector.php#afb0a24b5471ebd91b22fe39e2155b04e">numNonlocalIDs_</a>;
<a name="l00579"></a><a class="code" href="classEpetraVector.php#a65cdb9197cd43126f73302ef2edde3d4">00579</a>   <span class="keywordtype">int</span> <a class="code" href="classEpetraVector.php#a65cdb9197cd43126f73302ef2edde3d4">allocatedNonlocalLength_</a>;
<a name="l00580"></a><a class="code" href="classEpetraVector.php#a96a741935e9bea66b7d159e0c4ba0803">00580</a>   <span class="keywordtype">double</span>** <a class="code" href="classEpetraVector.php#a96a741935e9bea66b7d159e0c4ba0803">nonlocalCoefs_</a>;
<a name="l00581"></a>00581 
<a name="l00582"></a><a class="code" href="classEpetraVector.php#a7fed7ac1f2f00d2aff18dff3941e186f">00582</a>   <span class="keywordtype">bool</span> <a class="code" href="classEpetraVector.php#a7fed7ac1f2f00d2aff18dff3941e186f">ignoreNonLocalEntries_</a>;
<a name="l00583"></a>00583 };
<a name="l00584"></a>00584 
<a name="l00585"></a>00585 
<a name="l00586"></a>00586 <span class="comment">/*----------------------- Inline functions ----------------------------------*/</span>
<a name="l00587"></a>00587 
<a name="l00588"></a>00588 
<a name="l00589"></a>00589 
<a name="l00590"></a>00590 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00591"></a>00591 <span class="keyword">inline</span>
<a name="l00592"></a><a class="code" href="classEpetraVector.php#abc5a328d5da1c17c4c4a719579dc9349">00592</a> <a class="code" href="classEpetraVector.php#abc5a328d5da1c17c4c4a719579dc9349">EpetraVector&lt;T&gt;::EpetraVector</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00593"></a>00593 : _destroy_vec_on_exit(true),
<a name="l00594"></a>00594   myFirstID_(0),
<a name="l00595"></a>00595   myNumIDs_(0),
<a name="l00596"></a>00596   myCoefs_(NULL),
<a name="l00597"></a>00597   nonlocalIDs_(NULL),
<a name="l00598"></a>00598   nonlocalElementSize_(NULL),
<a name="l00599"></a>00599   numNonlocalIDs_(0),
<a name="l00600"></a>00600   allocatedNonlocalLength_(0),
<a name="l00601"></a>00601   nonlocalCoefs_(NULL),
<a name="l00602"></a>00602   ignoreNonLocalEntries_(false)
<a name="l00603"></a>00603 {
<a name="l00604"></a>00604   this-&gt;<a class="code" href="classNumericVector.php#a26410625410635a53bf754077ff88173">_type</a> = <a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a>;
<a name="l00605"></a>00605 }
<a name="l00606"></a>00606 
<a name="l00607"></a>00607 
<a name="l00608"></a>00608 
<a name="l00609"></a>00609 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00610"></a>00610 <span class="keyword">inline</span>
<a name="l00611"></a><a class="code" href="classEpetraVector.php#a929f6c542482ba451805134d26b5b7fd">00611</a> <a class="code" href="classEpetraVector.php#abc5a328d5da1c17c4c4a719579dc9349">EpetraVector&lt;T&gt;::EpetraVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00612"></a>00612                                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00613"></a>00613 : _destroy_vec_on_exit(true),
<a name="l00614"></a>00614   myFirstID_(0),
<a name="l00615"></a>00615   myNumIDs_(0),
<a name="l00616"></a>00616   myCoefs_(NULL),
<a name="l00617"></a>00617   nonlocalIDs_(NULL),
<a name="l00618"></a>00618   nonlocalElementSize_(NULL),
<a name="l00619"></a>00619   numNonlocalIDs_(0),
<a name="l00620"></a>00620   allocatedNonlocalLength_(0),
<a name="l00621"></a>00621   nonlocalCoefs_(NULL),
<a name="l00622"></a>00622   ignoreNonLocalEntries_(false)
<a name="l00623"></a>00623 
<a name="l00624"></a>00624 {
<a name="l00625"></a>00625   this-&gt;<a class="code" href="classEpetraVector.php#a100adb95b2abc9b98ac8a3799c1382e3">init</a>(n, n, <span class="keyword">false</span>, type);
<a name="l00626"></a>00626 }
<a name="l00627"></a>00627 
<a name="l00628"></a>00628 
<a name="l00629"></a>00629 
<a name="l00630"></a>00630 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00631"></a>00631 <span class="keyword">inline</span>
<a name="l00632"></a><a class="code" href="classEpetraVector.php#a7aa737b0952de7d6fb5de64a8dfea8f2">00632</a> <a class="code" href="classEpetraVector.php#abc5a328d5da1c17c4c4a719579dc9349">EpetraVector&lt;T&gt;::EpetraVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00633"></a>00633                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00634"></a>00634                                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00635"></a>00635 : _destroy_vec_on_exit(true),
<a name="l00636"></a>00636   myFirstID_(0),
<a name="l00637"></a>00637   myNumIDs_(0),
<a name="l00638"></a>00638   myCoefs_(NULL),
<a name="l00639"></a>00639   nonlocalIDs_(NULL),
<a name="l00640"></a>00640   nonlocalElementSize_(NULL),
<a name="l00641"></a>00641   numNonlocalIDs_(0),
<a name="l00642"></a>00642   allocatedNonlocalLength_(0),
<a name="l00643"></a>00643   nonlocalCoefs_(NULL),
<a name="l00644"></a>00644   ignoreNonLocalEntries_(false)
<a name="l00645"></a>00645 {
<a name="l00646"></a>00646   this-&gt;<a class="code" href="classEpetraVector.php#a100adb95b2abc9b98ac8a3799c1382e3">init</a>(n, n_local, <span class="keyword">false</span>, type);
<a name="l00647"></a>00647 }
<a name="l00648"></a>00648 
<a name="l00649"></a>00649 
<a name="l00650"></a>00650 
<a name="l00651"></a>00651 
<a name="l00652"></a>00652 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00653"></a>00653 <span class="keyword">inline</span>
<a name="l00654"></a><a class="code" href="classEpetraVector.php#ab0657ecb35dcd703a6170f66b027c815">00654</a> <a class="code" href="classEpetraVector.php#abc5a328d5da1c17c4c4a719579dc9349">EpetraVector&lt;T&gt;::EpetraVector</a>(Epetra_Vector &amp; v)
<a name="l00655"></a>00655 : _destroy_vec_on_exit(false),
<a name="l00656"></a>00656   myFirstID_(0),
<a name="l00657"></a>00657   myNumIDs_(0),
<a name="l00658"></a>00658   myCoefs_(NULL),
<a name="l00659"></a>00659   nonlocalIDs_(NULL),
<a name="l00660"></a>00660   nonlocalElementSize_(NULL),
<a name="l00661"></a>00661   numNonlocalIDs_(0),
<a name="l00662"></a>00662   allocatedNonlocalLength_(0),
<a name="l00663"></a>00663   nonlocalCoefs_(NULL),
<a name="l00664"></a>00664   ignoreNonLocalEntries_(false)
<a name="l00665"></a>00665 {
<a name="l00666"></a>00666   <a class="code" href="classEpetraVector.php#a1aba50131cd5f5cad27159132c7edd56">_vec</a> = &amp;v;
<a name="l00667"></a>00667 
<a name="l00668"></a>00668   this-&gt;<a class="code" href="classNumericVector.php#a26410625410635a53bf754077ff88173">_type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>; <span class="comment">// FIXME - need to determine this from v!</span>
<a name="l00669"></a>00669 
<a name="l00670"></a>00670   <a class="code" href="classEpetraVector.php#a8d1bb3edca67f8fddbd771180d40b624">myFirstID_</a> = <a class="code" href="classEpetraVector.php#a1aba50131cd5f5cad27159132c7edd56">_vec</a>-&gt;Map().MinMyGID();
<a name="l00671"></a>00671   <a class="code" href="classEpetraVector.php#a8766430ba2d92462931e0a4cc682a4be">myNumIDs_</a> = <a class="code" href="classEpetraVector.php#a1aba50131cd5f5cad27159132c7edd56">_vec</a>-&gt;Map().NumMyElements();
<a name="l00672"></a>00672 
<a name="l00673"></a>00673   <span class="comment">//Currently we impose the restriction that NumVectors==1, so we won&#39;t</span>
<a name="l00674"></a>00674   <span class="comment">//need the LDA argument when calling ExtractView. Hence the &quot;dummy&quot; arg.</span>
<a name="l00675"></a>00675   <span class="keywordtype">int</span> dummy;
<a name="l00676"></a>00676   <a class="code" href="classEpetraVector.php#a1aba50131cd5f5cad27159132c7edd56">_vec</a>-&gt;ExtractView(&amp;<a class="code" href="classEpetraVector.php#aaa9c787d5a4ef43533a0cdefadfd5c00">myCoefs_</a>, &amp;dummy);
<a name="l00677"></a>00677 
<a name="l00678"></a>00678   this-&gt;<a class="code" href="classNumericVector.php#ac4a667077b6ec42b9a35a9aed43fc92e">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00679"></a>00679 }
<a name="l00680"></a>00680 
<a name="l00681"></a>00681 
<a name="l00682"></a>00682 
<a name="l00683"></a>00683 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00684"></a>00684 <span class="keyword">inline</span>
<a name="l00685"></a><a class="code" href="classEpetraVector.php#ab40c0bc776960b465bb6bd8d22de0409">00685</a> <a class="code" href="classEpetraVector.php#abc5a328d5da1c17c4c4a719579dc9349">EpetraVector&lt;T&gt;::EpetraVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00686"></a>00686                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00687"></a>00687                                <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ghost,
<a name="l00688"></a>00688                                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00689"></a>00689 : _destroy_vec_on_exit(true),
<a name="l00690"></a>00690   myFirstID_(0),
<a name="l00691"></a>00691   myNumIDs_(0),
<a name="l00692"></a>00692   myCoefs_(NULL),
<a name="l00693"></a>00693   nonlocalIDs_(NULL),
<a name="l00694"></a>00694   nonlocalElementSize_(NULL),
<a name="l00695"></a>00695   numNonlocalIDs_(0),
<a name="l00696"></a>00696   allocatedNonlocalLength_(0),
<a name="l00697"></a>00697   nonlocalCoefs_(NULL),
<a name="l00698"></a>00698   ignoreNonLocalEntries_(false)
<a name="l00699"></a>00699 {
<a name="l00700"></a>00700   this-&gt;<a class="code" href="classEpetraVector.php#a100adb95b2abc9b98ac8a3799c1382e3">init</a>(n, n_local, ghost, <span class="keyword">false</span>, type);
<a name="l00701"></a>00701 }
<a name="l00702"></a>00702 
<a name="l00703"></a>00703 
<a name="l00704"></a>00704 
<a name="l00705"></a>00705 <span class="comment">/* Default implementation for solver packages for which ghosted</span>
<a name="l00706"></a>00706 <span class="comment">   vectors are not yet implemented.  */</span>
<a name="l00707"></a>00707 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00708"></a><a class="code" href="classEpetraVector.php#abfa5f05ccd1cbc39b2748a98cf11d487">00708</a> <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a100adb95b2abc9b98ac8a3799c1382e3">EpetraVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; other,
<a name="l00709"></a>00709                             <span class="keyword">const</span> <span class="keywordtype">bool</span> fast)
<a name="l00710"></a>00710 {
<a name="l00711"></a>00711   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(other.<a class="code" href="classNumericVector.php#ae21bc89e89e895ac26b851a31926e194">size</a>(),other.<a class="code" href="classNumericVector.php#a400307e324862d460ff6b3b83a72e867">local_size</a>(),fast,other.<a class="code" href="classNumericVector.php#a60d2f0e6762784a313be56dcf258cbe5">type</a>());
<a name="l00712"></a>00712 }
<a name="l00713"></a>00713 
<a name="l00714"></a>00714 
<a name="l00715"></a>00715 
<a name="l00716"></a>00716 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00717"></a>00717 <span class="keyword">inline</span>
<a name="l00718"></a><a class="code" href="classEpetraVector.php#ada79e30f1ea85b0f0df34548c4cf0280">00718</a> <a class="code" href="classEpetraVector.php#ada79e30f1ea85b0f0df34548c4cf0280">EpetraVector&lt;T&gt;::~EpetraVector</a> ()
<a name="l00719"></a>00719 {
<a name="l00720"></a>00720   this-&gt;clear ();
<a name="l00721"></a>00721 }
<a name="l00722"></a>00722 
<a name="l00723"></a>00723 
<a name="l00724"></a>00724 
<a name="l00725"></a>00725 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00726"></a>00726 <span class="keyword">inline</span>
<a name="l00727"></a><a class="code" href="classEpetraVector.php#a100adb95b2abc9b98ac8a3799c1382e3">00727</a> <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a100adb95b2abc9b98ac8a3799c1382e3">EpetraVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00728"></a>00728                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00729"></a>00729                             <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00730"></a>00730                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00731"></a>00731 {
<a name="l00732"></a>00732   <span class="keywordflow">if</span> (type == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>)
<a name="l00733"></a>00733     {
<a name="l00734"></a>00734       <span class="keywordflow">if</span> (n == n_local)
<a name="l00735"></a>00735         this-&gt;_type = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>;
<a name="l00736"></a>00736       <span class="keywordflow">else</span>
<a name="l00737"></a>00737         this-&gt;_type = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>;
<a name="l00738"></a>00738     }
<a name="l00739"></a>00739   <span class="keywordflow">else</span>
<a name="l00740"></a>00740     this-&gt;_type = type;
<a name="l00741"></a>00741 
<a name="l00742"></a>00742   libmesh_assert ((this-&gt;_type==<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a> &amp;&amp; n==n_local) ||
<a name="l00743"></a>00743                   this-&gt;_type==<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>);
<a name="l00744"></a>00744 
<a name="l00745"></a>00745   _map = <span class="keyword">new</span> Epetra_Map(n, 
<a name="l00746"></a>00746                         n_local, 
<a name="l00747"></a>00747                         0, 
<a name="l00748"></a>00748                         Epetra_MpiComm (<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>));
<a name="l00749"></a>00749               
<a name="l00750"></a>00750   _vec = <span class="keyword">new</span> Epetra_Vector(*_map);
<a name="l00751"></a>00751 
<a name="l00752"></a>00752   myFirstID_ = _vec-&gt;Map().MinMyGID();
<a name="l00753"></a>00753   myNumIDs_ = _vec-&gt;Map().NumMyElements();
<a name="l00754"></a>00754 
<a name="l00755"></a>00755   <span class="comment">//Currently we impose the restriction that NumVectors==1, so we won&#39;t</span>
<a name="l00756"></a>00756   <span class="comment">//need the LDA argument when calling ExtractView. Hence the &quot;dummy&quot; arg.</span>
<a name="l00757"></a>00757   <span class="keywordtype">int</span> dummy;
<a name="l00758"></a>00758   _vec-&gt;ExtractView(&amp;myCoefs_, &amp;dummy);
<a name="l00759"></a>00759   
<a name="l00760"></a>00760   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00761"></a>00761   
<a name="l00762"></a>00762   <span class="keywordflow">if</span> (fast == <span class="keyword">false</span>)
<a name="l00763"></a>00763     this-&gt;<a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a> ();
<a name="l00764"></a>00764 }
<a name="l00765"></a>00765 
<a name="l00766"></a>00766 
<a name="l00767"></a>00767 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00768"></a>00768 <span class="keyword">inline</span>
<a name="l00769"></a><a class="code" href="classEpetraVector.php#aa7f4b65d4d29d5efe3eae53d6b1c86e7">00769</a> <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a100adb95b2abc9b98ac8a3799c1382e3">EpetraVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00770"></a>00770                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00771"></a>00771                             <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <span class="comment">/*ghost*/</span>,
<a name="l00772"></a>00772                             <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00773"></a>00773                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00774"></a>00774 {
<a name="l00775"></a>00775   <span class="comment">// TODO: we shouldn&#39;t ignore the ghost sparsity pattern</span>
<a name="l00776"></a>00776   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(n, n_local, fast, type);
<a name="l00777"></a>00777 }
<a name="l00778"></a>00778 
<a name="l00779"></a>00779 
<a name="l00780"></a>00780 
<a name="l00781"></a>00781 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00782"></a>00782 <span class="keyword">inline</span>
<a name="l00783"></a><a class="code" href="classEpetraVector.php#a7253c1e90c0190a76113f5a54723d6e4">00783</a> <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a100adb95b2abc9b98ac8a3799c1382e3">EpetraVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00784"></a>00784                             <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00785"></a>00785                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00786"></a>00786 {
<a name="l00787"></a>00787   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(n,n,fast,type);
<a name="l00788"></a>00788 }
<a name="l00789"></a>00789 
<a name="l00790"></a>00790 
<a name="l00791"></a>00791 
<a name="l00792"></a>00792 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00793"></a>00793 <span class="keyword">inline</span>
<a name="l00794"></a><a class="code" href="classEpetraVector.php#a43705b37c77227d571b18088d5cafcd3">00794</a> <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a43705b37c77227d571b18088d5cafcd3">EpetraVector&lt;T&gt;::close</a> ()
<a name="l00795"></a>00795 {
<a name="l00796"></a>00796   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00797"></a>00797 
<a name="l00798"></a>00798   this-&gt;GlobalAssemble();
<a name="l00799"></a>00799 
<a name="l00800"></a>00800   this-&gt;_is_closed = <span class="keyword">true</span>;
<a name="l00801"></a>00801 }
<a name="l00802"></a>00802 
<a name="l00803"></a>00803 
<a name="l00804"></a>00804 
<a name="l00805"></a>00805 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00806"></a>00806 <span class="keyword">inline</span>
<a name="l00807"></a><a class="code" href="classEpetraVector.php#ae9ffda7db7eac14162e4aeb0f7a33d8a">00807</a> <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#ae9ffda7db7eac14162e4aeb0f7a33d8a">EpetraVector&lt;T&gt;::clear</a> ()
<a name="l00808"></a>00808 {
<a name="l00809"></a>00809   <span class="keywordflow">if</span> ((this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>()) &amp;&amp; (this-&gt;_destroy_vec_on_exit))
<a name="l00810"></a>00810     <span class="keyword">delete</span> _vec;
<a name="l00811"></a>00811 
<a name="l00812"></a>00812   this-&gt;_is_closed = this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00813"></a>00813 }
<a name="l00814"></a>00814 
<a name="l00815"></a>00815 
<a name="l00816"></a>00816 
<a name="l00817"></a>00817 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00818"></a>00818 <span class="keyword">inline</span>
<a name="l00819"></a><a class="code" href="classEpetraVector.php#a689954a2f42e1e35b9c2f4a6a282da52">00819</a> <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#a689954a2f42e1e35b9c2f4a6a282da52">EpetraVector&lt;T&gt;::zero</a> ()
<a name="l00820"></a>00820 {
<a name="l00821"></a>00821   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00822"></a>00822 
<a name="l00823"></a>00823   _vec-&gt;PutScalar(0.0);
<a name="l00824"></a>00824 }
<a name="l00825"></a>00825 
<a name="l00826"></a>00826 
<a name="l00827"></a>00827 
<a name="l00828"></a>00828 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00829"></a>00829 <span class="keyword">inline</span>
<a name="l00830"></a><a class="code" href="classEpetraVector.php#a81434c432371dd2d07d238a7811440f6">00830</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classEpetraVector.php#a81434c432371dd2d07d238a7811440f6">EpetraVector&lt;T&gt;::clone</a> ()<span class="keyword"> const</span>
<a name="l00831"></a>00831 <span class="keyword"></span>{
<a name="l00832"></a>00832   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; cloned_vector (<span class="keyword">new</span> <a class="code" href="classEpetraVector.php">EpetraVector&lt;T&gt;</a>);
<a name="l00833"></a>00833 
<a name="l00834"></a>00834   cloned_vector-&gt;init(*<span class="keyword">this</span>, <span class="keyword">true</span>);
<a name="l00835"></a>00835 
<a name="l00836"></a>00836   *cloned_vector = *<span class="keyword">this</span>;
<a name="l00837"></a>00837 
<a name="l00838"></a>00838   <span class="keywordflow">return</span> cloned_vector;
<a name="l00839"></a>00839 }
<a name="l00840"></a>00840 
<a name="l00841"></a>00841 
<a name="l00842"></a>00842 
<a name="l00843"></a>00843 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00844"></a>00844 <span class="keyword">inline</span>
<a name="l00845"></a><a class="code" href="classEpetraVector.php#adb6e300ac9fc54dd123ed6337c9e054f">00845</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEpetraVector.php#adb6e300ac9fc54dd123ed6337c9e054f">EpetraVector&lt;T&gt;::size</a> ()<span class="keyword"> const</span>
<a name="l00846"></a>00846 <span class="keyword"></span>{
<a name="l00847"></a>00847   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());  
<a name="l00848"></a>00848 
<a name="l00849"></a>00849   <span class="keywordflow">return</span> _vec-&gt;GlobalLength();
<a name="l00850"></a>00850 }
<a name="l00851"></a>00851 
<a name="l00852"></a>00852 
<a name="l00853"></a>00853 
<a name="l00854"></a>00854 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00855"></a>00855 <span class="keyword">inline</span>
<a name="l00856"></a><a class="code" href="classEpetraVector.php#ac57d0cb2a93c9a08fe9e30681120cb6a">00856</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEpetraVector.php#ac57d0cb2a93c9a08fe9e30681120cb6a">EpetraVector&lt;T&gt;::local_size</a> ()<span class="keyword"> const</span>
<a name="l00857"></a>00857 <span class="keyword"></span>{
<a name="l00858"></a>00858   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00859"></a>00859   
<a name="l00860"></a>00860   <span class="keywordflow">return</span> _vec-&gt;MyLength();
<a name="l00861"></a>00861 }
<a name="l00862"></a>00862 
<a name="l00863"></a>00863 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00864"></a>00864 <span class="keyword">inline</span>
<a name="l00865"></a><a class="code" href="classEpetraVector.php#aca7656b4da462b84702270d32d6037eb">00865</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEpetraVector.php#aca7656b4da462b84702270d32d6037eb">EpetraVector&lt;T&gt;::first_local_index</a> ()<span class="keyword"> const</span>
<a name="l00866"></a>00866 <span class="keyword"></span>{
<a name="l00867"></a>00867   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00868"></a>00868   
<a name="l00869"></a>00869   <span class="keywordflow">return</span> _vec-&gt;Map().MinMyGID();
<a name="l00870"></a>00870 }
<a name="l00871"></a>00871 
<a name="l00872"></a>00872 
<a name="l00873"></a>00873 
<a name="l00874"></a>00874 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00875"></a>00875 <span class="keyword">inline</span>
<a name="l00876"></a><a class="code" href="classEpetraVector.php#a999b490ed2d3d6d544fed9ce5a204891">00876</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classEpetraVector.php#a999b490ed2d3d6d544fed9ce5a204891">EpetraVector&lt;T&gt;::last_local_index</a> ()<span class="keyword"> const</span>
<a name="l00877"></a>00877 <span class="keyword"></span>{
<a name="l00878"></a>00878   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00879"></a>00879   
<a name="l00880"></a>00880   <span class="keywordflow">return</span> _vec-&gt;Map().MaxMyGID()+1;
<a name="l00881"></a>00881 }
<a name="l00882"></a>00882 
<a name="l00883"></a>00883 
<a name="l00884"></a>00884 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00885"></a>00885 <span class="keyword">inline</span>
<a name="l00886"></a><a class="code" href="classEpetraVector.php#af1e0daa4009c1b6a55764a0de464384a">00886</a> T <a class="code" href="classEpetraVector.php#af1e0daa4009c1b6a55764a0de464384a">EpetraVector&lt;T&gt;::operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00887"></a>00887 <span class="keyword"></span>{
<a name="l00888"></a>00888   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00889"></a>00889   libmesh_assert ( ((i &gt;= this-&gt;first_local_index()) &amp;&amp;
<a name="l00890"></a>00890                     (i &lt;  this-&gt;last_local_index())) );
<a name="l00891"></a>00891 
<a name="l00892"></a>00892   <span class="keywordflow">return</span> (*_vec)[i-this-&gt;first_local_index()];
<a name="l00893"></a>00893 }
<a name="l00894"></a>00894 
<a name="l00895"></a>00895 
<a name="l00896"></a>00896 
<a name="l00897"></a>00897 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00898"></a>00898 <span class="keyword">inline</span>
<a name="l00899"></a><a class="code" href="classEpetraVector.php#aea0f37ee3fcb7dfa61ce21d31b663508">00899</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classEpetraVector.php#aea0f37ee3fcb7dfa61ce21d31b663508">EpetraVector&lt;T&gt;::min</a> ()<span class="keyword"> const</span>
<a name="l00900"></a>00900 <span class="keyword"></span>{
<a name="l00901"></a>00901   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00902"></a>00902 
<a name="l00903"></a>00903   T value;
<a name="l00904"></a>00904 
<a name="l00905"></a>00905   _vec-&gt;MinValue(&amp;value);
<a name="l00906"></a>00906 
<a name="l00907"></a>00907   <span class="keywordflow">return</span> value;
<a name="l00908"></a>00908 }
<a name="l00909"></a>00909 
<a name="l00910"></a>00910 
<a name="l00911"></a>00911 
<a name="l00912"></a>00912 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00913"></a>00913 <span class="keyword">inline</span>
<a name="l00914"></a><a class="code" href="classEpetraVector.php#a9c858cc09fba3fb368a5e2d030681108">00914</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classEpetraVector.php#a9c858cc09fba3fb368a5e2d030681108">EpetraVector&lt;T&gt;::max</a>()<span class="keyword"> const</span>
<a name="l00915"></a>00915 <span class="keyword"></span>{
<a name="l00916"></a>00916   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00917"></a>00917 
<a name="l00918"></a>00918   T value;
<a name="l00919"></a>00919 
<a name="l00920"></a>00920   _vec-&gt;MaxValue(&amp;value);
<a name="l00921"></a>00921 
<a name="l00922"></a>00922   <span class="keywordflow">return</span> value;
<a name="l00923"></a>00923 }
<a name="l00924"></a>00924 
<a name="l00925"></a>00925 
<a name="l00926"></a>00926 
<a name="l00927"></a>00927 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00928"></a>00928 <span class="keyword">inline</span>
<a name="l00929"></a><a class="code" href="classEpetraVector.php#afeb977425164e722fc80f53497224b5c">00929</a> <span class="keywordtype">void</span> <a class="code" href="classEpetraVector.php#afeb977425164e722fc80f53497224b5c">EpetraVector&lt;T&gt;::swap</a> (<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;other)
<a name="l00930"></a>00930 {
<a name="l00931"></a>00931   <a class="code" href="classEpetraVector.php">EpetraVector&lt;T&gt;</a>&amp; v = libmesh_cast_ref&lt;EpetraVector&lt;T&gt;&amp;&gt;(other);
<a name="l00932"></a>00932 
<a name="l00933"></a>00933   std::swap(_vec, v.<a class="code" href="classEpetraVector.php#a1aba50131cd5f5cad27159132c7edd56">_vec</a>);
<a name="l00934"></a>00934   std::swap(_destroy_vec_on_exit, v.<a class="code" href="classEpetraVector.php#a82b72f0060be39c91da4f4e1f0ff6f1c">_destroy_vec_on_exit</a>);
<a name="l00935"></a>00935 }
<a name="l00936"></a>00936 
<a name="l00937"></a>00937 
<a name="l00938"></a>00938 <span class="preprocessor">#endif // #ifdef HAVE_EPETRA</span>
<a name="l00939"></a>00939 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __trilinos_epetra_vector_h__</span>
<a name="l00940"></a>00940 <span class="preprocessor"></span>
<a name="l00941"></a>00941 
<a name="l00942"></a>00942 
<a name="l00943"></a>00943 
<a name="l00944"></a>00944 
<a name="l00945"></a>00945 
<a name="l00946"></a>00946 
<a name="l00947"></a>00947 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
