<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>trilinos_nox_nonlinear_solver.h</h1>  </div>
</div>
<div class="contents">
<a href="trilinos__nox__nonlinear__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: trilinos_nox_nonlinear_solver.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __trilinos_nox_nonlinear_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __trilinos_nox_nonlinear_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="preprocessor">#ifdef LIBMESH_HAVE_NOX</span>
<a name="l00026"></a>00026 <span class="preprocessor"></span>
<a name="l00027"></a>00027 <span class="comment">// C++ includes</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="nonlinear__solver_8h.php">nonlinear_solver.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">//trilinos includes</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;Epetra_Vector.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;Epetra_Operator.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;Epetra_RowMatrix.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;NOX_Epetra_Interface_Required.H&quot;</span> <span class="comment">// base class</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;NOX_Epetra_Interface_Jacobian.H&quot;</span> <span class="comment">// base class</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;NOX_Epetra_Interface_Preconditioner.H&quot;</span> <span class="comment">// base class  </span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;NOX.H&quot;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">// Forward declarations</span>
<a name="l00042"></a>00042 <span class="keyword">class </span><a class="code" href="classProblem__Interface.php">Problem_Interface</a>;
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00053"></a>00053 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00054"></a><a class="code" href="classNoxNonlinearSolver.php">00054</a> <span class="keyword">class </span><a class="code" href="classNoxNonlinearSolver.php">NoxNonlinearSolver</a> : <span class="keyword">public</span> <a class="code" href="classNonlinearSolver.php">NonlinearSolver</a>&lt;T&gt;
<a name="l00055"></a>00055 {
<a name="l00056"></a>00056 <span class="keyword">public</span>:
<a name="l00060"></a><a class="code" href="classNoxNonlinearSolver.php#ac6f2fa5cea8ad40c810d4281d00bf92a">00060</a>   <span class="keyword">typedef</span> <a class="code" href="classNonlinearImplicitSystem.php">NonlinearImplicitSystem</a> <a class="code" href="classNoxNonlinearSolver.php#ac6f2fa5cea8ad40c810d4281d00bf92a">sys_type</a>;
<a name="l00061"></a>00061 
<a name="l00065"></a>00065   <a class="code" href="classNoxNonlinearSolver.php#a312e54dbc815e5ec34c421e0291ff63e">NoxNonlinearSolver</a> (<a class="code" href="classNonlinearImplicitSystem.php">sys_type</a>&amp; <a class="code" href="classNonlinearSolver.php#acb0c621b2fe80e2c4b7e2b8114b349cb">system</a>);
<a name="l00066"></a>00066     
<a name="l00070"></a>00070   <a class="code" href="classNoxNonlinearSolver.php#ac1b58712f2068c693a102f79a2cc6711">~NoxNonlinearSolver</a> ();
<a name="l00071"></a>00071   
<a name="l00075"></a>00075   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNoxNonlinearSolver.php#a899596a91cd5bdf34c3ea38688bd5ebe">clear</a> ();
<a name="l00076"></a>00076 
<a name="l00080"></a>00080   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classNoxNonlinearSolver.php#aa8824bdb079e99190dd3295ec0211e7b">init</a> ();
<a name="l00081"></a>00081   
<a name="l00086"></a>00086   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt; <a class="code" href="classNoxNonlinearSolver.php#ac9845ba4af09822b6b5ee4e3573bb5d3">solve</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;,    <span class="comment">// System Jacobian Matrix</span>
<a name="l00087"></a>00087                                                <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;,   <span class="comment">// Solution vector</span>
<a name="l00088"></a>00088                                                <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp;,   <span class="comment">// Residual vector</span>
<a name="l00089"></a>00089                                                <span class="keyword">const</span> <span class="keywordtype">double</span>,        <span class="comment">// Stopping tolerance</span>
<a name="l00090"></a>00090                                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>); <span class="comment">// N. Iterations</span>
<a name="l00091"></a>00091 <span class="keyword">private</span>:
<a name="l00092"></a>00092 
<a name="l00096"></a><a class="code" href="classNoxNonlinearSolver.php#ab672e860a86696d0a80cd4457e76b599">00096</a>   NOX::Solver::Generic * <a class="code" href="classNoxNonlinearSolver.php#ab672e860a86696d0a80cd4457e76b599">_solver</a>;
<a name="l00097"></a>00097   
<a name="l00101"></a><a class="code" href="classNoxNonlinearSolver.php#a54007ec9a0bed526fbe2c167e4ef404d">00101</a>   <a class="code" href="classProblem__Interface.php">Problem_Interface</a> * <a class="code" href="classNoxNonlinearSolver.php#a54007ec9a0bed526fbe2c167e4ef404d">_interface</a>;
<a name="l00102"></a>00102   
<a name="l00103"></a>00103 };
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 <span class="comment">/*----------------------- functions ----------------------------------*/</span>
<a name="l00107"></a>00107 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00108"></a>00108 <span class="keyword">inline</span>
<a name="l00109"></a><a class="code" href="classNoxNonlinearSolver.php#a312e54dbc815e5ec34c421e0291ff63e">00109</a> <a class="code" href="classNoxNonlinearSolver.php#a312e54dbc815e5ec34c421e0291ff63e">NoxNonlinearSolver&lt;T&gt;::NoxNonlinearSolver</a> (<a class="code" href="classNonlinearImplicitSystem.php">sys_type</a>&amp; system) :
<a name="l00110"></a>00110   <a class="code" href="classNonlinearSolver.php">NonlinearSolver</a>&lt;T&gt;(system)
<a name="l00111"></a>00111 {
<a name="l00112"></a>00112 }
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00117"></a>00117 <span class="keyword">inline</span>
<a name="l00118"></a><a class="code" href="classNoxNonlinearSolver.php#ac1b58712f2068c693a102f79a2cc6711">00118</a> <a class="code" href="classNoxNonlinearSolver.php#ac1b58712f2068c693a102f79a2cc6711">NoxNonlinearSolver&lt;T&gt;::~NoxNonlinearSolver</a> ()
<a name="l00119"></a>00119 {
<a name="l00120"></a>00120   this-&gt;clear ();
<a name="l00121"></a>00121 }
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_NOX</span>
<a name="l00126"></a>00126 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __trilinos_nox_nonlinear_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
