<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_60be1125a39495b698d2d56e8e5b50b1.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>twostep_time_solver.C</h1>  </div>
</div>
<div class="contents">
<a href="twostep__time__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: twostep_time_solver.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;twostep_time_solver.h&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;diff_system.h&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;euler_solver.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a><a class="code" href="classTwostepTimeSolver.php#a06fd40ab76383c4507132613c84e738a">00028</a> <a class="code" href="classTwostepTimeSolver.php#a06fd40ab76383c4507132613c84e738a">TwostepTimeSolver::TwostepTimeSolver</a> (<a class="code" href="classDifferentiableSystem.php">sys_type</a>&amp; s)
<a name="l00029"></a>00029   : <a class="code" href="classAdaptiveTimeSolver.php">AdaptiveTimeSolver</a>(s)
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032   <span class="comment">// We start with a reasonable time solver: implicit Euler</span>
<a name="l00033"></a>00033   <a class="code" href="classAdaptiveTimeSolver.php#a149f07022abd7c6130f6f8647f1f9eb9">core_time_solver</a>.<a class="code" href="classAutoPtr.php#afba95dd5fca7f83ababa4eaf6a57c511" title="Forcibly deletes the managed object.">reset</a>(<span class="keyword">new</span> <a class="code" href="classEulerSolver.php">EulerSolver</a>(s));
<a name="l00034"></a>00034 }
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a><a class="code" href="classTwostepTimeSolver.php#a216b687af069fe910fc05021f348776f">00038</a> <a class="code" href="classTwostepTimeSolver.php#a216b687af069fe910fc05021f348776f">TwostepTimeSolver::~TwostepTimeSolver</a> ()
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040 }
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a><a class="code" href="classTwostepTimeSolver.php#aa8a976a2644c3d3ae8a167bfb44cce88">00044</a> <span class="keywordtype">void</span> <a class="code" href="classTwostepTimeSolver.php#aa8a976a2644c3d3ae8a167bfb44cce88">TwostepTimeSolver::solve</a>()
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046   libmesh_assert(<a class="code" href="classAdaptiveTimeSolver.php#a149f07022abd7c6130f6f8647f1f9eb9">core_time_solver</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>());
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   <span class="comment">// The core_time_solver will handle any first_solve actions</span>
<a name="l00049"></a>00049   <a class="code" href="classUnsteadySolver.php#a7b5693645b13d3556af0a88dab40edee">first_solve</a> = <span class="keyword">false</span>;
<a name="l00050"></a>00050 
<a name="l00051"></a>00051   <span class="comment">// We may have to repeat timesteps entirely if our error is bad</span>
<a name="l00052"></a>00052   <span class="comment">// enough</span>
<a name="l00053"></a>00053   <span class="keywordtype">bool</span> max_tolerance_met = <span class="keyword">false</span>;
<a name="l00054"></a>00054 
<a name="l00055"></a>00055   <span class="comment">// Calculating error values each time</span>
<a name="l00056"></a>00056   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> single_norm(0.), double_norm(0.), error_norm(0.),
<a name="l00057"></a>00057        relative_error(0.);
<a name="l00058"></a>00058  
<a name="l00059"></a>00059   <span class="keywordflow">while</span> (!max_tolerance_met)
<a name="l00060"></a>00060     {
<a name="l00061"></a>00061       <span class="comment">// If we&#39;ve been asked to reduce deltat if necessary, make sure</span>
<a name="l00062"></a>00062       <span class="comment">// the core timesolver does so</span>
<a name="l00063"></a>00063       <a class="code" href="classAdaptiveTimeSolver.php#a149f07022abd7c6130f6f8647f1f9eb9">core_time_solver</a>-&gt;reduce_deltat_on_diffsolver_failure =
<a name="l00064"></a>00064         this-&gt;<a class="code" href="classTimeSolver.php#af0c2e219b40a5d9336ad2f81cfb1fbd6">reduce_deltat_on_diffsolver_failure</a>;
<a name="l00065"></a>00065 
<a name="l00066"></a>00066       <span class="keywordflow">if</span> (!<a class="code" href="classTimeSolver.php#a89d506f1634a4d0a9578ff3773050a8b">quiet</a>)
<a name="l00067"></a>00067         {
<a name="l00068"></a>00068           std::cout &lt;&lt; <span class="stringliteral">&quot;\n === Computing adaptive timestep === &quot;</span> 
<a name="l00069"></a>00069                     &lt;&lt; std::endl;
<a name="l00070"></a>00070         }
<a name="l00071"></a>00071 
<a name="l00072"></a>00072       <span class="comment">// Use the double-length timestep first (so the</span>
<a name="l00073"></a>00073       <span class="comment">// old_nonlinear_solution won&#39;t have to change)</span>
<a name="l00074"></a>00074       <a class="code" href="classAdaptiveTimeSolver.php#a149f07022abd7c6130f6f8647f1f9eb9">core_time_solver</a>-&gt;solve();
<a name="l00075"></a>00075 
<a name="l00076"></a>00076       <span class="comment">// Save a copy of the double-length nonlinear solution</span>
<a name="l00077"></a>00077       <span class="comment">// and the old nonlinear solution</span>
<a name="l00078"></a>00078       <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; double_solution =
<a name="l00079"></a>00079         <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;clone();
<a name="l00080"></a>00080       <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; old_solution =
<a name="l00081"></a>00081         <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;_old_nonlinear_solution&quot;</span>).<a class="code" href="classNumericVector.php#a5ac7af0a31b15c7f13c6fa85a5048e45">clone</a>();
<a name="l00082"></a>00082 
<a name="l00083"></a>00083       double_norm = <a class="code" href="classAdaptiveTimeSolver.php#a7a8452001ba8eec730fa8d6917f7e846">calculate_norm</a>(<a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>, *double_solution);
<a name="l00084"></a>00084       <span class="keywordflow">if</span> (!<a class="code" href="classTimeSolver.php#a89d506f1634a4d0a9578ff3773050a8b">quiet</a>)
<a name="l00085"></a>00085         {
<a name="l00086"></a>00086           std::cout &lt;&lt; <span class="stringliteral">&quot;Double norm = &quot;</span> &lt;&lt; double_norm &lt;&lt; std::endl;
<a name="l00087"></a>00087         }
<a name="l00088"></a>00088 
<a name="l00089"></a>00089       <span class="comment">// Then reset the initial guess for our single-length calcs</span>
<a name="l00090"></a>00090       *(<a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>) = <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;_old_nonlinear_solution&quot;</span>);
<a name="l00091"></a>00091 
<a name="l00092"></a>00092       <span class="comment">// Call two single-length timesteps</span>
<a name="l00093"></a>00093       <span class="comment">// Be sure that the core_time_solver does not change the</span>
<a name="l00094"></a>00094       <span class="comment">// timestep here.  (This is unlikely because it just succeeded</span>
<a name="l00095"></a>00095       <span class="comment">// with a timestep twice as large!)</span>
<a name="l00096"></a>00096       <span class="comment">// FIXME: even if diffsolver failure is unlikely, we ought to</span>
<a name="l00097"></a>00097       <span class="comment">// do *something* if it happens</span>
<a name="l00098"></a>00098       <a class="code" href="classAdaptiveTimeSolver.php#a149f07022abd7c6130f6f8647f1f9eb9">core_time_solver</a>-&gt;reduce_deltat_on_diffsolver_failure = 0;
<a name="l00099"></a>00099   
<a name="l00100"></a>00100       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> old_time = <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a011fade55c7e62bea01e1e195a9d78b1">time</a>;
<a name="l00101"></a>00101       <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> old_deltat = <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a>;
<a name="l00102"></a>00102       <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a> *= 0.5;
<a name="l00103"></a>00103       <a class="code" href="classAdaptiveTimeSolver.php#a149f07022abd7c6130f6f8647f1f9eb9">core_time_solver</a>-&gt;solve();
<a name="l00104"></a>00104       <a class="code" href="classAdaptiveTimeSolver.php#a149f07022abd7c6130f6f8647f1f9eb9">core_time_solver</a>-&gt;advance_timestep();
<a name="l00105"></a>00105       <a class="code" href="classAdaptiveTimeSolver.php#a149f07022abd7c6130f6f8647f1f9eb9">core_time_solver</a>-&gt;solve();
<a name="l00106"></a>00106 
<a name="l00107"></a>00107       single_norm = <a class="code" href="classAdaptiveTimeSolver.php#a7a8452001ba8eec730fa8d6917f7e846">calculate_norm</a>(<a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>, *<a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>);
<a name="l00108"></a>00108       <span class="keywordflow">if</span> (!<a class="code" href="classTimeSolver.php#a89d506f1634a4d0a9578ff3773050a8b">quiet</a>)
<a name="l00109"></a>00109         {
<a name="l00110"></a>00110           std::cout &lt;&lt; <span class="stringliteral">&quot;Single norm = &quot;</span> &lt;&lt; single_norm &lt;&lt; std::endl;
<a name="l00111"></a>00111         }
<a name="l00112"></a>00112 
<a name="l00113"></a>00113       <span class="comment">// Reset the core_time_solver&#39;s reduce_deltat... value.</span>
<a name="l00114"></a>00114       <a class="code" href="classAdaptiveTimeSolver.php#a149f07022abd7c6130f6f8647f1f9eb9">core_time_solver</a>-&gt;reduce_deltat_on_diffsolver_failure =
<a name="l00115"></a>00115         this-&gt;<a class="code" href="classTimeSolver.php#af0c2e219b40a5d9336ad2f81cfb1fbd6">reduce_deltat_on_diffsolver_failure</a>;
<a name="l00116"></a>00116   
<a name="l00117"></a>00117       <span class="comment">// But then back off just in case our advance_timestep() isn&#39;t</span>
<a name="l00118"></a>00118       <span class="comment">// called.</span>
<a name="l00119"></a>00119       <span class="comment">// FIXME: this probably doesn&#39;t work with multistep methods</span>
<a name="l00120"></a>00120       <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;_old_nonlinear_solution&quot;</span>) = *old_solution;
<a name="l00121"></a>00121       <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a011fade55c7e62bea01e1e195a9d78b1">time</a> = old_time;
<a name="l00122"></a>00122       <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a> = old_deltat;
<a name="l00123"></a>00123 
<a name="l00124"></a>00124       <span class="comment">// Find the relative error</span>
<a name="l00125"></a>00125       *double_solution -= *(<a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>);
<a name="l00126"></a>00126       error_norm  = <a class="code" href="classAdaptiveTimeSolver.php#a7a8452001ba8eec730fa8d6917f7e846">calculate_norm</a>(<a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>, *double_solution);
<a name="l00127"></a>00127       relative_error = error_norm / <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a> /
<a name="l00128"></a>00128         <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(double_norm, single_norm);
<a name="l00129"></a>00129 
<a name="l00130"></a>00130       <span class="comment">// If the relative error makes no sense, we&#39;re done</span>
<a name="l00131"></a>00131       <span class="keywordflow">if</span> (!double_norm &amp;&amp; !single_norm)
<a name="l00132"></a>00132         <span class="keywordflow">return</span>;
<a name="l00133"></a>00133 
<a name="l00134"></a>00134       <span class="keywordflow">if</span> (!<a class="code" href="classTimeSolver.php#a89d506f1634a4d0a9578ff3773050a8b">quiet</a>)
<a name="l00135"></a>00135         {
<a name="l00136"></a>00136           std::cout &lt;&lt; <span class="stringliteral">&quot;Error norm = &quot;</span> &lt;&lt; error_norm &lt;&lt; std::endl;
<a name="l00137"></a>00137           std::cout &lt;&lt; <span class="stringliteral">&quot;Local relative error = &quot;</span>
<a name="l00138"></a>00138                     &lt;&lt; (error_norm /
<a name="l00139"></a>00139                         <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(double_norm, single_norm))
<a name="l00140"></a>00140                     &lt;&lt; std::endl;
<a name="l00141"></a>00141           std::cout &lt;&lt; <span class="stringliteral">&quot;Global relative error = &quot;</span>
<a name="l00142"></a>00142                     &lt;&lt; (error_norm / <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a> / 
<a name="l00143"></a>00143                         <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(double_norm, single_norm)) 
<a name="l00144"></a>00144                     &lt;&lt; std::endl;
<a name="l00145"></a>00145           std::cout &lt;&lt; <span class="stringliteral">&quot;old delta t = &quot;</span> &lt;&lt; <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a> &lt;&lt; std::endl;
<a name="l00146"></a>00146         }
<a name="l00147"></a>00147 
<a name="l00148"></a>00148       <span class="comment">// If we haven&#39;t met our upper error tolerance, we&#39;ll have to</span>
<a name="l00149"></a>00149       <span class="comment">// repeat this timestep entirely</span>
<a name="l00150"></a>00150       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classAdaptiveTimeSolver.php#a36ef788a194a1eafd46776213ecd6816">upper_tolerance</a> &amp;&amp; relative_error &gt; this-&gt;<a class="code" href="classAdaptiveTimeSolver.php#a36ef788a194a1eafd46776213ecd6816">upper_tolerance</a>)
<a name="l00151"></a>00151         {
<a name="l00152"></a>00152           <span class="comment">// Reset the initial guess for our next try</span>
<a name="l00153"></a>00153           *(<a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>) =
<a name="l00154"></a>00154             <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;_old_nonlinear_solution&quot;</span>);
<a name="l00155"></a>00155 
<a name="l00156"></a>00156           <span class="comment">// Chop delta t in half</span>
<a name="l00157"></a>00157           <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a> /= 2.;
<a name="l00158"></a>00158 
<a name="l00159"></a>00159           <span class="keywordflow">if</span> (!<a class="code" href="classTimeSolver.php#a89d506f1634a4d0a9578ff3773050a8b">quiet</a>)
<a name="l00160"></a>00160             {
<a name="l00161"></a>00161               std::cout &lt;&lt; <span class="stringliteral">&quot;Failed to meet upper error tolerance&quot;</span> 
<a name="l00162"></a>00162                         &lt;&lt; std::endl;
<a name="l00163"></a>00163               std::cout &lt;&lt; <span class="stringliteral">&quot;Retrying with delta t = &quot;</span>
<a name="l00164"></a>00164                         &lt;&lt; <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a> &lt;&lt; std::endl;
<a name="l00165"></a>00165             }
<a name="l00166"></a>00166         }
<a name="l00167"></a>00167       <span class="keywordflow">else</span>
<a name="l00168"></a>00168         max_tolerance_met = <span class="keyword">true</span>;
<a name="l00169"></a>00169     }
<a name="l00170"></a>00170 
<a name="l00171"></a>00171   
<a name="l00172"></a>00172   <span class="comment">// Otherwise, compare the relative error to the tolerance</span>
<a name="l00173"></a>00173   <span class="comment">// and adjust deltat</span>
<a name="l00174"></a>00174   <a class="code" href="classAdaptiveTimeSolver.php#aca1f6df28e288b850e4121e111b846c4">last_deltat</a> = <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a>;
<a name="l00175"></a>00175 
<a name="l00176"></a>00176   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> global_shrink_or_growth_factor =
<a name="l00177"></a>00177     <a class="code" href="namespaceUtility.php#aa31a2ff44b735ae86eea0446796a3b42">std::pow</a>(this-&gt;<a class="code" href="classAdaptiveTimeSolver.php#a3110c951714fc646d215fc85469397ad">target_tolerance</a> / relative_error,
<a name="l00178"></a>00178              1. / <a class="code" href="classAdaptiveTimeSolver.php#a149f07022abd7c6130f6f8647f1f9eb9">core_time_solver</a>-&gt;error_order());
<a name="l00179"></a>00179 
<a name="l00180"></a>00180   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> local_shrink_or_growth_factor =
<a name="l00181"></a>00181     <a class="code" href="namespaceUtility.php#aa31a2ff44b735ae86eea0446796a3b42">std::pow</a>(this-&gt;<a class="code" href="classAdaptiveTimeSolver.php#a3110c951714fc646d215fc85469397ad">target_tolerance</a> /
<a name="l00182"></a>00182              (error_norm/<a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(double_norm, single_norm)),
<a name="l00183"></a>00183              1. / (<a class="code" href="classAdaptiveTimeSolver.php#a149f07022abd7c6130f6f8647f1f9eb9">core_time_solver</a>-&gt;error_order()+1.));
<a name="l00184"></a>00184 
<a name="l00185"></a>00185   <span class="keywordflow">if</span> (!<a class="code" href="classTimeSolver.php#a89d506f1634a4d0a9578ff3773050a8b">quiet</a>)
<a name="l00186"></a>00186     {
<a name="l00187"></a>00187       std::cout &lt;&lt; <span class="stringliteral">&quot;The global growth/shrink factor is: &quot;</span>
<a name="l00188"></a>00188                 &lt;&lt; global_shrink_or_growth_factor &lt;&lt; std::endl;
<a name="l00189"></a>00189       std::cout &lt;&lt; <span class="stringliteral">&quot;The local growth/shrink factor is: &quot;</span>
<a name="l00190"></a>00190                 &lt;&lt; local_shrink_or_growth_factor &lt;&lt; std::endl;
<a name="l00191"></a>00191     }
<a name="l00192"></a>00192 
<a name="l00193"></a>00193   <span class="comment">// The local s.o.g. factor is based on the expected **local**</span>
<a name="l00194"></a>00194   <span class="comment">// truncation error for the timestepping method, the global</span>
<a name="l00195"></a>00195   <span class="comment">// s.o.g. factor is based on the method&#39;s **global** truncation</span>
<a name="l00196"></a>00196   <span class="comment">// error.  You can shrink/grow the timestep to attempt to satisfy</span>
<a name="l00197"></a>00197   <span class="comment">// either a global or local time-discretization error tolerance.</span>
<a name="l00198"></a>00198  
<a name="l00199"></a>00199   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> shrink_or_growth_factor =
<a name="l00200"></a>00200     this-&gt;<a class="code" href="classAdaptiveTimeSolver.php#a62231a112593811d4b3f251001660974">global_tolerance</a> ? global_shrink_or_growth_factor :
<a name="l00201"></a>00201                              local_shrink_or_growth_factor;
<a name="l00202"></a>00202 
<a name="l00203"></a>00203   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classAdaptiveTimeSolver.php#a00e6c3f8c3076ad6da5aff808f5bd5c5">max_growth</a> &amp;&amp; this-&gt;<a class="code" href="classAdaptiveTimeSolver.php#a00e6c3f8c3076ad6da5aff808f5bd5c5">max_growth</a> &lt; shrink_or_growth_factor)
<a name="l00204"></a>00204     {
<a name="l00205"></a>00205       <span class="keywordflow">if</span> (!<a class="code" href="classTimeSolver.php#a89d506f1634a4d0a9578ff3773050a8b">quiet</a> &amp;&amp; this-&gt;<a class="code" href="classAdaptiveTimeSolver.php#a62231a112593811d4b3f251001660974">global_tolerance</a>)
<a name="l00206"></a>00206         {
<a name="l00207"></a>00207           std::cout &lt;&lt; <span class="stringliteral">&quot;delta t is constrained by max_growth&quot;</span> &lt;&lt; std::endl;
<a name="l00208"></a>00208         }
<a name="l00209"></a>00209         shrink_or_growth_factor = this-&gt;<a class="code" href="classAdaptiveTimeSolver.php#a00e6c3f8c3076ad6da5aff808f5bd5c5">max_growth</a>;
<a name="l00210"></a>00210     }
<a name="l00211"></a>00211 
<a name="l00212"></a>00212   <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a> *= shrink_or_growth_factor;
<a name="l00213"></a>00213   
<a name="l00214"></a>00214   <span class="comment">// Restrict deltat to max-allowable value if necessary</span>
<a name="l00215"></a>00215   <span class="keywordflow">if</span> ((this-&gt;<a class="code" href="classAdaptiveTimeSolver.php#a3651c373f66a89f02942aaffff8ea7bd">max_deltat</a> != 0.0) &amp;&amp; (<a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a> &gt; this-&gt;<a class="code" href="classAdaptiveTimeSolver.php#a3651c373f66a89f02942aaffff8ea7bd">max_deltat</a>))
<a name="l00216"></a>00216     {
<a name="l00217"></a>00217       <span class="keywordflow">if</span> (!<a class="code" href="classTimeSolver.php#a89d506f1634a4d0a9578ff3773050a8b">quiet</a>)
<a name="l00218"></a>00218         {
<a name="l00219"></a>00219           std::cout &lt;&lt; <span class="stringliteral">&quot;delta t is constrained by maximum-allowable delta t.&quot;</span>
<a name="l00220"></a>00220                     &lt;&lt; std::endl;
<a name="l00221"></a>00221         }
<a name="l00222"></a>00222       <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a> = this-&gt;<a class="code" href="classAdaptiveTimeSolver.php#a3651c373f66a89f02942aaffff8ea7bd">max_deltat</a>;
<a name="l00223"></a>00223     }
<a name="l00224"></a>00224 
<a name="l00225"></a>00225   <span class="comment">// Restrict deltat to min-allowable value if necessary</span>
<a name="l00226"></a>00226   <span class="keywordflow">if</span> ((this-&gt;<a class="code" href="classAdaptiveTimeSolver.php#a368823c5f0a3856313ca907b324474bb">min_deltat</a> != 0.0) &amp;&amp; (<a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a> &lt; this-&gt;<a class="code" href="classAdaptiveTimeSolver.php#a368823c5f0a3856313ca907b324474bb">min_deltat</a>))
<a name="l00227"></a>00227     {
<a name="l00228"></a>00228       <span class="keywordflow">if</span> (!<a class="code" href="classTimeSolver.php#a89d506f1634a4d0a9578ff3773050a8b">quiet</a>)
<a name="l00229"></a>00229         {
<a name="l00230"></a>00230           std::cout &lt;&lt; <span class="stringliteral">&quot;delta t is constrained by minimum-allowable delta t.&quot;</span>
<a name="l00231"></a>00231                     &lt;&lt; std::endl;
<a name="l00232"></a>00232         }
<a name="l00233"></a>00233       <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a> = this-&gt;<a class="code" href="classAdaptiveTimeSolver.php#a368823c5f0a3856313ca907b324474bb">min_deltat</a>;
<a name="l00234"></a>00234     }
<a name="l00235"></a>00235   
<a name="l00236"></a>00236   <span class="keywordflow">if</span> (!<a class="code" href="classTimeSolver.php#a89d506f1634a4d0a9578ff3773050a8b">quiet</a>)
<a name="l00237"></a>00237     {
<a name="l00238"></a>00238       std::cout &lt;&lt; <span class="stringliteral">&quot;new delta t = &quot;</span> &lt;&lt; <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a> &lt;&lt; std::endl;
<a name="l00239"></a>00239     }
<a name="l00240"></a>00240 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
