<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>twostep_time_solver.h</h1>  </div>
</div>
<div class="contents">
<a href="twostep__time__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: twostep_time_solver.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __twostep_time_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __twostep_time_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="adaptive__time__solver_8h.php">adaptive_time_solver.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Forward declarations</span>
<a name="l00031"></a>00031 <span class="keyword">class </span><a class="code" href="classSystem.php">System</a>;
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// UPDATE THIS DESCRIPTION</span>
<a name="l00034"></a>00034 
<a name="l00049"></a>00049 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00050"></a>00050 <span class="comment">// Solver class definition</span>
<a name="l00051"></a><a class="code" href="classTwostepTimeSolver.php">00051</a> <span class="keyword">class </span><a class="code" href="classTwostepTimeSolver.php">TwostepTimeSolver</a> : <span class="keyword">public</span> <a class="code" href="classAdaptiveTimeSolver.php">AdaptiveTimeSolver</a>
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053 <span class="keyword">public</span>:
<a name="l00057"></a><a class="code" href="classTwostepTimeSolver.php#a0786bdab1e4ca6709f133cafcef5848b">00057</a>   <span class="keyword">typedef</span> <a class="code" href="classAdaptiveTimeSolver.php">AdaptiveTimeSolver</a> <a class="code" href="classTwostepTimeSolver.php#a0786bdab1e4ca6709f133cafcef5848b">Parent</a>;
<a name="l00058"></a>00058   
<a name="l00063"></a>00063   <a class="code" href="classTwostepTimeSolver.php#a06fd40ab76383c4507132613c84e738a">TwostepTimeSolver</a> (<a class="code" href="classDifferentiableSystem.php">sys_type</a>&amp; s);
<a name="l00064"></a>00064   
<a name="l00068"></a>00068   <a class="code" href="classTwostepTimeSolver.php#a216b687af069fe910fc05021f348776f">~TwostepTimeSolver</a> ();
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="keywordtype">void</span> <a class="code" href="classTwostepTimeSolver.php#aa8a976a2644c3d3ae8a167bfb44cce88">solve</a>();
<a name="l00071"></a>00071 };
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 <span class="preprocessor">#endif // #define __twostep_time_solver_</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
