<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>type_tensor.h</h1>  </div>
</div>
<div class="contents">
<a href="type__tensor_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: type_tensor.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __type_tensor_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __type_tensor_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;cmath&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="type__vector_8h.php">type_vector.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00044"></a>00044 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00045"></a><a class="code" href="classTypeTensor.php">00045</a> <span class="keyword">class </span><a class="code" href="classTypeTensor.php">TypeTensor</a>
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00048"></a><a class="code" href="classTypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">00048</a> <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classTypeTensor.php">TypeTensor</a>;
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 <span class="keyword">protected</span>:
<a name="l00051"></a>00051 
<a name="l00058"></a>00058   <a class="code" href="classTypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor</a>  (<span class="keyword">const</span> T xx=0.,
<a name="l00059"></a>00059                <span class="keyword">const</span> T xy=0.,
<a name="l00060"></a>00060                <span class="keyword">const</span> T xz=0.,
<a name="l00061"></a>00061                <span class="keyword">const</span> T yx=0.,
<a name="l00062"></a>00062                <span class="keyword">const</span> T yy=0.,
<a name="l00063"></a>00063                <span class="keyword">const</span> T yz=0.,
<a name="l00064"></a>00064                <span class="keyword">const</span> T zx=0.,
<a name="l00065"></a>00065                <span class="keyword">const</span> T zy=0.,
<a name="l00066"></a>00066                <span class="keyword">const</span> T zz=0.);
<a name="l00067"></a>00067 
<a name="l00073"></a>00073   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00074"></a>00074   <a class="code" href="classTypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor</a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a>&amp; vx);
<a name="l00075"></a>00075   
<a name="l00076"></a>00076   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00077"></a>00077   <a class="code" href="classTypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor</a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a>&amp; vx, <span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;vy);
<a name="l00078"></a>00078 
<a name="l00079"></a>00079   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00080"></a>00080   <a class="code" href="classTypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor</a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a>&amp; vx, <span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;vy, <span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;vz);
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 <span class="keyword">public</span>:
<a name="l00083"></a>00083 
<a name="l00087"></a>00087   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00088"></a>00088   <a class="code" href="classTypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor</a>(<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T2&gt;</a>&amp; p);
<a name="l00089"></a>00089   
<a name="l00093"></a>00093   <a class="code" href="classTypeTensor.php#a910b09e592431a8ee46bd67f0f9ec10b">~TypeTensor</a>();
<a name="l00094"></a>00094 
<a name="l00098"></a>00098   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00099"></a>00099   <span class="keywordtype">void</span> <a class="code" href="classTypeTensor.php#ad6f93968705953d928a01001d1b065d3">assign</a> (<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;);
<a name="l00100"></a>00100 
<a name="l00104"></a>00104   T <a class="code" href="classTypeTensor.php#a69f83060fd5b908a7b43ecc0f86a596c">operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span>;
<a name="l00105"></a>00105 
<a name="l00110"></a>00110   T &amp; <a class="code" href="classTypeTensor.php#a69f83060fd5b908a7b43ecc0f86a596c">operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j);
<a name="l00111"></a>00111 
<a name="l00115"></a>00115   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00116"></a>00116   <a class="code" href="classTypeTensor.php">TypeTensor&lt;typename CompareTypes&lt;T, T2&gt;::supertype</a>&gt;
<a name="l00117"></a>00117   <a class="code" href="classTypeTensor.php#adef4d5469b85d777c1f41cb501b1e893">operator + </a>(<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;) <span class="keyword">const</span>;
<a name="l00118"></a>00118 
<a name="l00122"></a>00122   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00123"></a>00123   <span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T&gt;</a> &amp; <a class="code" href="classTypeTensor.php#a407cf89e232393fd7b505980e5174baf">operator += </a>(<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;);
<a name="l00124"></a>00124   
<a name="l00128"></a>00128   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00129"></a>00129   <span class="keywordtype">void</span> <a class="code" href="classTypeTensor.php#ac926eb12156c30a8475d1a6565fdaefb">add</a> (<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;); 
<a name="l00130"></a>00130   
<a name="l00135"></a>00135   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00136"></a>00136   <span class="keywordtype">void</span> <a class="code" href="classTypeTensor.php#ae24569251bc6ea38090165d349fdfc6c">add_scaled</a> (<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;, <span class="keyword">const</span> T); 
<a name="l00137"></a>00137 
<a name="l00141"></a>00141   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00142"></a>00142   <a class="code" href="classTypeTensor.php">TypeTensor&lt;typename CompareTypes&lt;T, T2&gt;::supertype</a>&gt;
<a name="l00143"></a>00143   <a class="code" href="classTypeTensor.php#af32663cc52df74821cd48ef5a993413a">operator - </a>(<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;) <span class="keyword">const</span>;
<a name="l00144"></a>00144 
<a name="l00148"></a>00148   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00149"></a>00149   <span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T&gt;</a> &amp; <a class="code" href="classTypeTensor.php#a71922f58a1bf00407ef29bd409e4ecd0">operator -= </a>(<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;);
<a name="l00150"></a>00150 
<a name="l00154"></a>00154   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00155"></a>00155   <span class="keywordtype">void</span> <a class="code" href="classTypeTensor.php#ac38c3b5489ef76fe4aa152a6f435c3e2">subtract</a> (<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;); 
<a name="l00156"></a>00156   
<a name="l00161"></a>00161   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00162"></a>00162   <span class="keywordtype">void</span> <a class="code" href="classTypeTensor.php#a704df2f185a1d7f8db1650680e462eea">subtract_scaled</a> (<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;, <span class="keyword">const</span> T); 
<a name="l00163"></a>00163   
<a name="l00167"></a>00167   <a class="code" href="classTypeTensor.php">TypeTensor&lt;T&gt;</a> <a class="code" href="classTypeTensor.php#af32663cc52df74821cd48ef5a993413a">operator - </a>() <span class="keyword">const</span>;
<a name="l00168"></a>00168   
<a name="l00172"></a>00172   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Scalar&gt;
<a name="l00173"></a>00173   <span class="keyword">typename</span> <a class="code" href="structboostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00174"></a>00174     <a class="code" href="structScalarTraits.php">ScalarTraits&lt;Scalar&gt;::value</a>,
<a name="l00175"></a>00175     <a class="code" href="classTypeTensor.php">TypeTensor&lt;typename CompareTypes&lt;T, Scalar&gt;::supertype</a>&gt; &gt;::type
<a name="l00176"></a>00176   <a class="code" href="classTypeTensor.php#aa13aeb1295822cf536494c92a3c3b0e6">operator * </a>(<span class="keyword">const</span> Scalar) <span class="keyword">const</span>;
<a name="l00177"></a>00177   
<a name="l00181"></a>00181   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Scalar&gt;
<a name="l00182"></a>00182   <span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T&gt;</a> &amp; <a class="code" href="classTypeTensor.php#a1612ca1ec22651a6961a26ac9deec96d">operator *= </a>(<span class="keyword">const</span> Scalar);
<a name="l00183"></a>00183   
<a name="l00187"></a>00187   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Scalar&gt;
<a name="l00188"></a>00188   <span class="keyword">typename</span> <a class="code" href="structboostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00189"></a>00189     <a class="code" href="structScalarTraits.php">ScalarTraits&lt;Scalar&gt;::value</a>,
<a name="l00190"></a>00190     <a class="code" href="classTypeTensor.php">TypeTensor&lt;typename CompareTypes&lt;T, Scalar&gt;::supertype</a>&gt; &gt;::type
<a name="l00191"></a>00191   <a class="code" href="classTypeTensor.php#a29ccf64d35fc190250ebd5e5ca0b788b">operator / </a>(<span class="keyword">const</span> Scalar) <span class="keyword">const</span>;
<a name="l00192"></a>00192 
<a name="l00196"></a>00196   <span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T&gt;</a> &amp; <a class="code" href="classTypeTensor.php#abd05c3462a122824cad88545931832dc">operator /= </a>(<span class="keyword">const</span> T);
<a name="l00197"></a>00197 
<a name="l00202"></a>00202   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00203"></a>00203   <a class="code" href="classTypeTensor.php">TypeTensor&lt;T&gt;</a> <a class="code" href="classTypeTensor.php#aa13aeb1295822cf536494c92a3c3b0e6">operator * </a>(<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;) <span class="keyword">const</span>;
<a name="l00204"></a>00204 
<a name="l00209"></a>00209   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00210"></a>00210   <span class="keyword">typename</span> <a class="code" href="structCompareTypes.php#a84d86a45868b9861ae413d884c0bedc2">CompareTypes&lt;T,T2&gt;::supertype</a>
<a name="l00211"></a>00211   <a class="code" href="classTypeTensor.php#a1c322fe55bdd9e7eab8d9ead033f5e19">contract</a> (<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;) <span class="keyword">const</span>;
<a name="l00212"></a>00212 
<a name="l00217"></a>00217   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00218"></a>00218   <a class="code" href="classTypeVector.php">TypeVector&lt;typename CompareTypes&lt;T,T2&gt;::supertype</a>&gt;
<a name="l00219"></a>00219   <a class="code" href="classTypeTensor.php#aa13aeb1295822cf536494c92a3c3b0e6">operator * </a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;) <span class="keyword">const</span>;
<a name="l00220"></a>00220 
<a name="l00224"></a>00224   <a class="code" href="classTypeTensor.php">TypeTensor&lt;T&gt;</a> <a class="code" href="classTypeTensor.php#a10e89eb5aea4bb557f458523891e3f5a">transpose</a>() <span class="keyword">const</span>;
<a name="l00225"></a>00225 
<a name="l00230"></a>00230   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classTypeTensor.php#a43743b02ea196afa5301db69835c95a2">size</a>() <span class="keyword">const</span>;
<a name="l00231"></a>00231 
<a name="l00236"></a>00236   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classTypeTensor.php#a7be64b1de5e558f2de032bde1f881220">size_sq</a>() <span class="keyword">const</span>;
<a name="l00237"></a>00237 
<a name="l00243"></a>00243   T <a class="code" href="classTypeTensor.php#a4e8ef88336d54773e974a50bb567c3a3">det</a>() <span class="keyword">const</span>;
<a name="l00244"></a>00244 
<a name="l00248"></a>00248   T <a class="code" href="classTypeTensor.php#ab45c6a8b907860bdf0b504a4a581db92">tr</a>() <span class="keyword">const</span>;
<a name="l00249"></a>00249 
<a name="l00253"></a>00253   <span class="keywordtype">void</span> <a class="code" href="classTypeTensor.php#a616e4871685124fd810c17f557b6193e">zero</a>();
<a name="l00254"></a>00254 
<a name="l00258"></a>00258   <span class="keywordtype">bool</span> <a class="code" href="classTypeTensor.php#ab79ed166251f11176c7d57c58e2e284c">operator == </a>(<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T&gt;</a>&amp; rhs) <span class="keyword">const</span>;
<a name="l00259"></a>00259   
<a name="l00264"></a>00264   <span class="keywordtype">bool</span> operator &lt; (const TypeTensor&lt;T&gt;&amp; rhs) <span class="keyword">const</span>;
<a name="l00265"></a>00265   
<a name="l00270"></a>00270   <span class="keywordtype">bool</span> <a class="code" href="classTypeTensor.php#aafceb8007a9fd4c4238963a15d103303">operator &gt; </a>(<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T&gt;</a>&amp; rhs) <span class="keyword">const</span>;
<a name="l00271"></a>00271   
<a name="l00275"></a>00275   <span class="keywordtype">void</span> <a class="code" href="classTypeTensor.php#a7ff3d1cef5ca3a8a117ea85595ef5065">print</a>(std::ostream&amp; os) <span class="keyword">const</span>;
<a name="l00276"></a>00276 
<a name="l00281"></a><a class="code" href="classTypeTensor.php#aeddb9e754cdb6049b74cd4da88bf2476">00281</a>   <span class="keyword">friend</span> std::ostream&amp; operator &lt;&lt; (std::ostream&amp; os, const TypeTensor&lt;T&gt;&amp; t)
<a name="l00282"></a>00282   {
<a name="l00283"></a>00283     t.print(os);
<a name="l00284"></a>00284     <span class="keywordflow">return</span> os;
<a name="l00285"></a>00285   }
<a name="l00286"></a>00286   
<a name="l00291"></a>00291   <span class="keywordtype">void</span> <a class="code" href="classTypeTensor.php#ac91dd43042e037d9882b57b00ceabfa2">write_unformatted</a> (std::ostream &amp;out, <span class="keyword">const</span> <span class="keywordtype">bool</span> newline = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00292"></a>00292     
<a name="l00293"></a>00293   <span class="comment">// protected:</span>
<a name="l00294"></a>00294 
<a name="l00298"></a><a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">00298</a>   T <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[LIBMESH_DIM*LIBMESH_DIM];
<a name="l00299"></a>00299 };
<a name="l00300"></a>00300 
<a name="l00301"></a>00301 
<a name="l00302"></a>00302 
<a name="l00303"></a>00303 <span class="comment">//------------------------------------------------------</span>
<a name="l00304"></a>00304 <span class="comment">// Inline functions</span>
<a name="l00305"></a>00305 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00306"></a>00306 <span class="keyword">inline</span>
<a name="l00307"></a><a class="code" href="classTypeTensor.php#ab1f558bd7b58d121313908329e9a0aca">00307</a> <a class="code" href="classTypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor&lt;T&gt;::TypeTensor</a> (<span class="keyword">const</span> T xx,
<a name="l00308"></a>00308                            <span class="keyword">const</span> T xy,
<a name="l00309"></a>00309                            <span class="keyword">const</span> T xz,
<a name="l00310"></a>00310                            <span class="keyword">const</span> T yx,
<a name="l00311"></a>00311                            <span class="keyword">const</span> T yy,
<a name="l00312"></a>00312                            <span class="keyword">const</span> T yz,
<a name="l00313"></a>00313                            <span class="keyword">const</span> T zx,
<a name="l00314"></a>00314                            <span class="keyword">const</span> T zy,
<a name="l00315"></a>00315                            <span class="keyword">const</span> T zz)
<a name="l00316"></a>00316 {
<a name="l00317"></a>00317   <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] = xx;
<a name="l00318"></a>00318 
<a name="l00319"></a>00319   <span class="keywordflow">if</span> (LIBMESH_DIM == 2)
<a name="l00320"></a>00320     {
<a name="l00321"></a>00321       <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] = xy;
<a name="l00322"></a>00322       <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2] = yx;
<a name="l00323"></a>00323       <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3] = yy;
<a name="l00324"></a>00324     }
<a name="l00325"></a>00325 
<a name="l00326"></a>00326   <span class="keywordflow">if</span> (LIBMESH_DIM == 3)
<a name="l00327"></a>00327     {
<a name="l00328"></a>00328       <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] = xy;
<a name="l00329"></a>00329       <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2] = xz;
<a name="l00330"></a>00330       <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3] = yx;
<a name="l00331"></a>00331       <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[4] = yy;
<a name="l00332"></a>00332       <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[5] = yz;
<a name="l00333"></a>00333       <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[6] = zx;
<a name="l00334"></a>00334       <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[7] = zy;
<a name="l00335"></a>00335       <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[8] = zz;
<a name="l00336"></a>00336     }
<a name="l00337"></a>00337 }
<a name="l00338"></a>00338 
<a name="l00339"></a>00339 
<a name="l00340"></a>00340 
<a name="l00341"></a>00341 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00342"></a>00342 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00343"></a>00343 <span class="keyword">inline</span>
<a name="l00344"></a><a class="code" href="classTypeTensor.php#a66a8737c4d8d96e14e3ea51f45b1a128">00344</a> <a class="code" href="classTypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor&lt;T&gt;::TypeTensor</a> (<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor &lt;T2&gt;</a> &amp;p)
<a name="l00345"></a>00345 {
<a name="l00346"></a>00346   <span class="comment">// copy the nodes from vector p to me</span>
<a name="l00347"></a>00347   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM*LIBMESH_DIM; i++)
<a name="l00348"></a>00348     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i] = p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i];
<a name="l00349"></a>00349 }
<a name="l00350"></a>00350 
<a name="l00351"></a>00351 
<a name="l00352"></a>00352 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00353"></a>00353 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00354"></a><a class="code" href="classTypeTensor.php#a3cb3ccc07d044b3068bdbc45895f0a6b">00354</a> <a class="code" href="classTypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor&lt;T&gt;::TypeTensor</a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a>&amp; vx)
<a name="l00355"></a>00355 {
<a name="l00356"></a>00356   libmesh_assert(LIBMESH_DIM == 1);
<a name="l00357"></a>00357   <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] = vx(0);
<a name="l00358"></a>00358 }
<a name="l00359"></a>00359   
<a name="l00360"></a>00360 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00361"></a>00361 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00362"></a><a class="code" href="classTypeTensor.php#a19e1e8902a53e6692ab600cf84843e89">00362</a> <a class="code" href="classTypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor&lt;T&gt;::TypeTensor</a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a>&amp; vx, <span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;vy)
<a name="l00363"></a>00363 {
<a name="l00364"></a>00364   libmesh_assert(LIBMESH_DIM == 2);
<a name="l00365"></a>00365   <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] = vx(0);
<a name="l00366"></a>00366   <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] = vx(1);
<a name="l00367"></a>00367   <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2] = vy(0);
<a name="l00368"></a>00368   <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3] = vy(1);
<a name="l00369"></a>00369 }
<a name="l00370"></a>00370 
<a name="l00371"></a>00371 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00372"></a>00372 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00373"></a><a class="code" href="classTypeTensor.php#a10ce9c7dfe3f58fb0ec10bcea583eda6">00373</a> <a class="code" href="classTypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor&lt;T&gt;::TypeTensor</a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a>&amp; vx, <span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;vy, <span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;vz)
<a name="l00374"></a>00374 {
<a name="l00375"></a>00375   libmesh_assert(LIBMESH_DIM == 3);
<a name="l00376"></a>00376   <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] = vx(0);
<a name="l00377"></a>00377   <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] = vx(1);
<a name="l00378"></a>00378   <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2] = vx(2);
<a name="l00379"></a>00379   <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3] = vy(0);
<a name="l00380"></a>00380   <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[4] = vy(1);
<a name="l00381"></a>00381   <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[5] = vy(2);
<a name="l00382"></a>00382   <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[6] = vz(0);
<a name="l00383"></a>00383   <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[7] = vz(1);
<a name="l00384"></a>00384   <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[8] = vz(2);
<a name="l00385"></a>00385 }
<a name="l00386"></a>00386 
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 
<a name="l00389"></a>00389 
<a name="l00390"></a>00390 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00391"></a>00391 <span class="keyword">inline</span>
<a name="l00392"></a><a class="code" href="classTypeTensor.php#a910b09e592431a8ee46bd67f0f9ec10b">00392</a> <a class="code" href="classTypeTensor.php#a910b09e592431a8ee46bd67f0f9ec10b">TypeTensor&lt;T&gt;::~TypeTensor</a> ()
<a name="l00393"></a>00393 {
<a name="l00394"></a>00394 }
<a name="l00395"></a>00395 
<a name="l00396"></a>00396 
<a name="l00397"></a>00397 
<a name="l00398"></a>00398 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00399"></a>00399 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00400"></a>00400 <span class="keyword">inline</span>
<a name="l00401"></a><a class="code" href="classTypeTensor.php#ad6f93968705953d928a01001d1b065d3">00401</a> <span class="keywordtype">void</span> <a class="code" href="classTypeTensor.php#ad6f93968705953d928a01001d1b065d3">TypeTensor&lt;T&gt;::assign</a> (<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;p)
<a name="l00402"></a>00402 {
<a name="l00403"></a>00403   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00404"></a>00404     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i] = p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i];
<a name="l00405"></a>00405 }
<a name="l00406"></a>00406 
<a name="l00407"></a>00407 
<a name="l00408"></a>00408 
<a name="l00409"></a>00409 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00410"></a>00410 <span class="keyword">inline</span>
<a name="l00411"></a><a class="code" href="classTypeTensor.php#a69f83060fd5b908a7b43ecc0f86a596c">00411</a> T <a class="code" href="classTypeTensor.php#a69f83060fd5b908a7b43ecc0f86a596c">TypeTensor&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00412"></a>00412                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const</span>
<a name="l00413"></a>00413 <span class="keyword"></span>{
<a name="l00414"></a>00414   libmesh_assert (i&lt;3);
<a name="l00415"></a>00415   libmesh_assert (j&lt;3);
<a name="l00416"></a>00416 
<a name="l00417"></a>00417 <span class="preprocessor">#if LIBMESH_DIM &lt; 3</span>
<a name="l00418"></a>00418 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (i &gt;= LIBMESH_DIM || j &gt;= LIBMESH_DIM)
<a name="l00419"></a>00419     <span class="keywordflow">return</span> 0.;
<a name="l00420"></a>00420 <span class="preprocessor">#endif</span>
<a name="l00421"></a>00421 <span class="preprocessor"></span>  
<a name="l00422"></a>00422   <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i*LIBMESH_DIM+j];
<a name="l00423"></a>00423 }
<a name="l00424"></a>00424 
<a name="l00425"></a>00425 
<a name="l00426"></a>00426 
<a name="l00427"></a>00427 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00428"></a>00428 <span class="keyword">inline</span>
<a name="l00429"></a><a class="code" href="classTypeTensor.php#a6eff81b63a5dd363a4b419bdddd488e3">00429</a> T &amp; <a class="code" href="classTypeTensor.php#a69f83060fd5b908a7b43ecc0f86a596c">TypeTensor&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00430"></a>00430                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)
<a name="l00431"></a>00431 {
<a name="l00432"></a>00432 <span class="preprocessor">#if LIBMESH_DIM &lt; 3</span>
<a name="l00433"></a>00433 <span class="preprocessor"></span>
<a name="l00434"></a>00434   <span class="keywordflow">if</span> (i &gt;= LIBMESH_DIM || j &gt;= LIBMESH_DIM)
<a name="l00435"></a>00435     {
<a name="l00436"></a>00436 <span class="comment">//       std::cerr &lt;&lt; &quot;ERROR:  You are assigning to a tensor component&quot; &lt;&lt; std::endl</span>
<a name="l00437"></a>00437 <span class="comment">//              &lt;&lt; &quot;that is out of range for the compiled LIBMESH_DIM!&quot;      &lt;&lt; std::endl</span>
<a name="l00438"></a>00438 <span class="comment">//              &lt;&lt; &quot; LIBMESH_DIM=&quot; &lt;&lt; LIBMESH_DIM &lt;&lt; &quot; , i=&quot; &lt;&lt; i &lt;&lt; &quot; , j=&quot; &lt;&lt; j &lt;&lt; std::endl;</span>
<a name="l00439"></a>00439       libmesh_error();
<a name="l00440"></a>00440     }
<a name="l00441"></a>00441   
<a name="l00442"></a>00442 <span class="preprocessor">#endif</span>
<a name="l00443"></a>00443 <span class="preprocessor"></span>  
<a name="l00444"></a>00444   libmesh_assert (i&lt;LIBMESH_DIM);
<a name="l00445"></a>00445   libmesh_assert (j&lt;LIBMESH_DIM);
<a name="l00446"></a>00446   
<a name="l00447"></a>00447   <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i*LIBMESH_DIM+j];
<a name="l00448"></a>00448 }
<a name="l00449"></a>00449 
<a name="l00450"></a>00450 
<a name="l00451"></a>00451 
<a name="l00452"></a>00452 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00453"></a>00453 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00454"></a>00454 <span class="keyword">inline</span>
<a name="l00455"></a>00455 <a class="code" href="classTypeTensor.php">TypeTensor&lt;typename CompareTypes&lt;T, T2&gt;::supertype</a>&gt;
<a name="l00456"></a><a class="code" href="classTypeTensor.php#adef4d5469b85d777c1f41cb501b1e893">00456</a> <a class="code" href="classTypeTensor.php#adef4d5469b85d777c1f41cb501b1e893">TypeTensor&lt;T&gt;::operator + </a>(<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;p)<span class="keyword"> const</span>
<a name="l00457"></a>00457 <span class="keyword"></span>{
<a name="l00458"></a>00458  
<a name="l00459"></a>00459 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00460"></a>00460 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] + p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]);
<a name="l00461"></a>00461 <span class="preprocessor">#endif</span>
<a name="l00462"></a>00462 <span class="preprocessor"></span>
<a name="l00463"></a>00463 <span class="preprocessor">#if LIBMESH_DIM == 2 </span>
<a name="l00464"></a>00464 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] + p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0],
<a name="l00465"></a>00465                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] + p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1],
<a name="l00466"></a>00466                     0.,
<a name="l00467"></a>00467                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2] + p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2],
<a name="l00468"></a>00468                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3] + p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3]);
<a name="l00469"></a>00469 <span class="preprocessor">#endif</span>
<a name="l00470"></a>00470 <span class="preprocessor"></span>
<a name="l00471"></a>00471 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00472"></a>00472 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] + p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0],
<a name="l00473"></a>00473                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] + p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1],
<a name="l00474"></a>00474                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2] + p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2],
<a name="l00475"></a>00475                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3] + p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3],
<a name="l00476"></a>00476                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[4] + p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[4],
<a name="l00477"></a>00477                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[5] + p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[5],
<a name="l00478"></a>00478                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[6] + p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[6],
<a name="l00479"></a>00479                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[7] + p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[7],
<a name="l00480"></a>00480                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[8] + p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[8]);
<a name="l00481"></a>00481 <span class="preprocessor">#endif</span>
<a name="l00482"></a>00482 <span class="preprocessor"></span>               
<a name="l00483"></a>00483 }
<a name="l00484"></a>00484 
<a name="l00485"></a>00485 
<a name="l00486"></a>00486 
<a name="l00487"></a>00487 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00488"></a>00488 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00489"></a>00489 <span class="keyword">inline</span>
<a name="l00490"></a><a class="code" href="classTypeTensor.php#a407cf89e232393fd7b505980e5174baf">00490</a> <span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T&gt;</a> &amp; <a class="code" href="classTypeTensor.php#a407cf89e232393fd7b505980e5174baf">TypeTensor&lt;T&gt;::operator += </a>(<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;p)
<a name="l00491"></a>00491 {
<a name="l00492"></a>00492   this-&gt;<a class="code" href="classTypeTensor.php#ac926eb12156c30a8475d1a6565fdaefb">add</a> (p);
<a name="l00493"></a>00493 
<a name="l00494"></a>00494   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00495"></a>00495 }
<a name="l00496"></a>00496 
<a name="l00497"></a>00497 
<a name="l00498"></a>00498 
<a name="l00499"></a>00499 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00500"></a>00500 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00501"></a>00501 <span class="keyword">inline</span>
<a name="l00502"></a><a class="code" href="classTypeTensor.php#ac926eb12156c30a8475d1a6565fdaefb">00502</a> <span class="keywordtype">void</span> <a class="code" href="classTypeTensor.php#ac926eb12156c30a8475d1a6565fdaefb">TypeTensor&lt;T&gt;::add</a> (<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;p)
<a name="l00503"></a>00503 {
<a name="l00504"></a>00504   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM*LIBMESH_DIM; i++)
<a name="l00505"></a>00505     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i] += p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i];
<a name="l00506"></a>00506 }
<a name="l00507"></a>00507 
<a name="l00508"></a>00508 
<a name="l00509"></a>00509 
<a name="l00510"></a>00510 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00511"></a>00511 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00512"></a>00512 <span class="keyword">inline</span>
<a name="l00513"></a><a class="code" href="classTypeTensor.php#ae24569251bc6ea38090165d349fdfc6c">00513</a> <span class="keywordtype">void</span> <a class="code" href="classTypeTensor.php#ae24569251bc6ea38090165d349fdfc6c">TypeTensor&lt;T&gt;::add_scaled</a> (<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;p, <span class="keyword">const</span> T factor)
<a name="l00514"></a>00514 {
<a name="l00515"></a>00515   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM*LIBMESH_DIM; i++)
<a name="l00516"></a>00516     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i] += factor*p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i];
<a name="l00517"></a>00517 
<a name="l00518"></a>00518 }
<a name="l00519"></a>00519 
<a name="l00520"></a>00520 
<a name="l00521"></a>00521 
<a name="l00522"></a>00522 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00523"></a>00523 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00524"></a>00524 <span class="keyword">inline</span>
<a name="l00525"></a>00525 <a class="code" href="classTypeTensor.php">TypeTensor&lt;typename CompareTypes&lt;T, T2&gt;::supertype</a>&gt;
<a name="l00526"></a><a class="code" href="classTypeTensor.php#a4d0226c86bdbdd772260f97fef2fd1eb">00526</a> <a class="code" href="classTypeTensor.php#af32663cc52df74821cd48ef5a993413a">TypeTensor&lt;T&gt;::operator - </a>(<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;p)<span class="keyword"> const</span>
<a name="l00527"></a>00527 <span class="keyword"></span>{
<a name="l00528"></a>00528 
<a name="l00529"></a>00529 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00530"></a>00530 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] - p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]);
<a name="l00531"></a>00531 <span class="preprocessor">#endif</span>
<a name="l00532"></a>00532 <span class="preprocessor"></span>
<a name="l00533"></a>00533 <span class="preprocessor">#if LIBMESH_DIM == 2 </span>
<a name="l00534"></a>00534 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] - p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0],
<a name="l00535"></a>00535                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] - p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1],
<a name="l00536"></a>00536                     0.,
<a name="l00537"></a>00537                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2] - p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2],
<a name="l00538"></a>00538                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3] - p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3]);
<a name="l00539"></a>00539 <span class="preprocessor">#endif</span>
<a name="l00540"></a>00540 <span class="preprocessor"></span>
<a name="l00541"></a>00541 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00542"></a>00542 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] - p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0],
<a name="l00543"></a>00543                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] - p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1],
<a name="l00544"></a>00544                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2] - p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2],
<a name="l00545"></a>00545                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3] - p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3],
<a name="l00546"></a>00546                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[4] - p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[4],
<a name="l00547"></a>00547                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[5] - p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[5],
<a name="l00548"></a>00548                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[6] - p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[6],
<a name="l00549"></a>00549                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[7] - p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[7],
<a name="l00550"></a>00550                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[8] - p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[8]);
<a name="l00551"></a>00551 <span class="preprocessor">#endif</span>
<a name="l00552"></a>00552 <span class="preprocessor"></span>
<a name="l00553"></a>00553 }
<a name="l00554"></a>00554 
<a name="l00555"></a>00555 
<a name="l00556"></a>00556 
<a name="l00557"></a>00557 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00558"></a>00558 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00559"></a>00559 <span class="keyword">inline</span>
<a name="l00560"></a><a class="code" href="classTypeTensor.php#a71922f58a1bf00407ef29bd409e4ecd0">00560</a> <span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T&gt;</a> &amp; <a class="code" href="classTypeTensor.php#a71922f58a1bf00407ef29bd409e4ecd0">TypeTensor&lt;T&gt;::operator -= </a>(<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;p)
<a name="l00561"></a>00561 {
<a name="l00562"></a>00562   this-&gt;<a class="code" href="classTypeTensor.php#ac38c3b5489ef76fe4aa152a6f435c3e2">subtract</a> (p);
<a name="l00563"></a>00563 
<a name="l00564"></a>00564   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00565"></a>00565 }
<a name="l00566"></a>00566 
<a name="l00567"></a>00567 
<a name="l00568"></a>00568 
<a name="l00569"></a>00569 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00570"></a>00570 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00571"></a>00571 <span class="keyword">inline</span>
<a name="l00572"></a><a class="code" href="classTypeTensor.php#ac38c3b5489ef76fe4aa152a6f435c3e2">00572</a> <span class="keywordtype">void</span> <a class="code" href="classTypeTensor.php#ac38c3b5489ef76fe4aa152a6f435c3e2">TypeTensor&lt;T&gt;::subtract</a> (<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T2&gt;</a>&amp; p)
<a name="l00573"></a>00573 {
<a name="l00574"></a>00574   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM*LIBMESH_DIM; i++)
<a name="l00575"></a>00575     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i] -= p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i];
<a name="l00576"></a>00576 }
<a name="l00577"></a>00577 
<a name="l00578"></a>00578 
<a name="l00579"></a>00579 
<a name="l00580"></a>00580 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00581"></a>00581 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00582"></a>00582 <span class="keyword">inline</span>
<a name="l00583"></a><a class="code" href="classTypeTensor.php#a704df2f185a1d7f8db1650680e462eea">00583</a> <span class="keywordtype">void</span> <a class="code" href="classTypeTensor.php#a704df2f185a1d7f8db1650680e462eea">TypeTensor&lt;T&gt;::subtract_scaled</a> (<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;p, <span class="keyword">const</span> T factor)
<a name="l00584"></a>00584 {
<a name="l00585"></a>00585   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM*LIBMESH_DIM; i++)
<a name="l00586"></a>00586     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i] -= factor*p.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i];
<a name="l00587"></a>00587 }
<a name="l00588"></a>00588 
<a name="l00589"></a>00589 
<a name="l00590"></a>00590 
<a name="l00591"></a>00591 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00592"></a>00592 <span class="keyword">inline</span>
<a name="l00593"></a><a class="code" href="classTypeTensor.php#af32663cc52df74821cd48ef5a993413a">00593</a> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T&gt;</a> <a class="code" href="classTypeTensor.php#af32663cc52df74821cd48ef5a993413a">TypeTensor&lt;T&gt;::operator - </a>()<span class="keyword"> const</span>
<a name="l00594"></a>00594 <span class="keyword"></span>{
<a name="l00595"></a>00595   
<a name="l00596"></a>00596 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00597"></a>00597 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor</a>(-<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]);
<a name="l00598"></a>00598 <span class="preprocessor">#endif</span>
<a name="l00599"></a>00599 <span class="preprocessor"></span>
<a name="l00600"></a>00600 <span class="preprocessor">#if LIBMESH_DIM == 2 </span>
<a name="l00601"></a>00601 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor</a>(-<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0],
<a name="l00602"></a>00602                     -<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1],
<a name="l00603"></a>00603                     -<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2],
<a name="l00604"></a>00604                     -<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3]);
<a name="l00605"></a>00605 <span class="preprocessor">#endif</span>
<a name="l00606"></a>00606 <span class="preprocessor"></span>
<a name="l00607"></a>00607 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00608"></a>00608 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor</a>(-<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0],
<a name="l00609"></a>00609                     -<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1], 
<a name="l00610"></a>00610                     -<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2], 
<a name="l00611"></a>00611                     -<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3], 
<a name="l00612"></a>00612                     -<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[4], 
<a name="l00613"></a>00613                     -<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[5], 
<a name="l00614"></a>00614                     -<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[6], 
<a name="l00615"></a>00615                     -<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[7], 
<a name="l00616"></a>00616                     -<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[8]);
<a name="l00617"></a>00617 <span class="preprocessor">#endif</span>
<a name="l00618"></a>00618 <span class="preprocessor"></span>  
<a name="l00619"></a>00619 }
<a name="l00620"></a>00620 
<a name="l00621"></a>00621 
<a name="l00622"></a>00622 
<a name="l00623"></a>00623 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00624"></a>00624 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Scalar&gt;
<a name="l00625"></a>00625 <span class="keyword">inline</span>
<a name="l00626"></a>00626 <span class="keyword">typename</span> <a class="code" href="structboostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00627"></a>00627   <a class="code" href="structScalarTraits.php">ScalarTraits&lt;Scalar&gt;::value</a>,
<a name="l00628"></a>00628   <a class="code" href="classTypeTensor.php">TypeTensor&lt;typename CompareTypes&lt;T, Scalar&gt;::supertype</a>&gt; &gt;::type
<a name="l00629"></a><a class="code" href="classTypeTensor.php#aa13aeb1295822cf536494c92a3c3b0e6">00629</a> <a class="code" href="classTypeTensor.php#aa13aeb1295822cf536494c92a3c3b0e6">TypeTensor&lt;T&gt;::operator * </a>(<span class="keyword">const</span> Scalar factor)<span class="keyword"> const</span>
<a name="l00630"></a>00630 <span class="keyword"></span>{
<a name="l00631"></a>00631   <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="structCompareTypes.php#a84d86a45868b9861ae413d884c0bedc2">CompareTypes&lt;T, Scalar&gt;::supertype</a> TS;
<a name="l00632"></a>00632 
<a name="l00633"></a>00633 
<a name="l00634"></a>00634 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00635"></a>00635 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;TS&gt;</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]*factor);
<a name="l00636"></a>00636 <span class="preprocessor">#endif</span>
<a name="l00637"></a>00637 <span class="preprocessor"></span>  
<a name="l00638"></a>00638 <span class="preprocessor">#if LIBMESH_DIM == 2 </span>
<a name="l00639"></a>00639 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;TS&gt;</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]*factor,
<a name="l00640"></a>00640                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1]*factor,
<a name="l00641"></a>00641                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2]*factor,
<a name="l00642"></a>00642                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3]*factor);
<a name="l00643"></a>00643 <span class="preprocessor">#endif</span>
<a name="l00644"></a>00644 <span class="preprocessor"></span>  
<a name="l00645"></a>00645 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00646"></a>00646 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;TS&gt;</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]*factor,
<a name="l00647"></a>00647                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1]*factor, 
<a name="l00648"></a>00648                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2]*factor, 
<a name="l00649"></a>00649                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3]*factor, 
<a name="l00650"></a>00650                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[4]*factor, 
<a name="l00651"></a>00651                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[5]*factor, 
<a name="l00652"></a>00652                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[6]*factor, 
<a name="l00653"></a>00653                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[7]*factor, 
<a name="l00654"></a>00654                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[8]*factor);
<a name="l00655"></a>00655 <span class="preprocessor">#endif  </span>
<a name="l00656"></a>00656 <span class="preprocessor"></span>}
<a name="l00657"></a>00657 
<a name="l00658"></a>00658 
<a name="l00659"></a>00659 
<a name="l00660"></a>00660 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> Scalar&gt;
<a name="l00661"></a>00661 <span class="keyword">inline</span>
<a name="l00662"></a>00662 <span class="keyword">typename</span> <a class="code" href="structboostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00663"></a>00663   ScalarTraits&lt;Scalar&gt;::value,
<a name="l00664"></a>00664   <a class="code" href="classTypeTensor.php">TypeTensor&lt;typename CompareTypes&lt;T, Scalar&gt;::supertype</a>&gt; &gt;::type
<a name="l00665"></a><a class="code" href="type__tensor_8h.php#a529f0725b8766b811e4681bfd79b124f">00665</a> <a class="code" href="type__tensor_8h.php#a529f0725b8766b811e4681bfd79b124f">operator * </a>(<span class="keyword">const</span> Scalar factor,
<a name="l00666"></a>00666             <span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T&gt;</a> &amp;t)
<a name="l00667"></a>00667 {
<a name="l00668"></a>00668   <span class="keywordflow">return</span> t * factor;
<a name="l00669"></a>00669 }
<a name="l00670"></a>00670 
<a name="l00671"></a>00671 
<a name="l00672"></a>00672 
<a name="l00673"></a>00673 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00674"></a>00674 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Scalar&gt;
<a name="l00675"></a>00675 <span class="keyword">inline</span>
<a name="l00676"></a><a class="code" href="classTypeTensor.php#a1612ca1ec22651a6961a26ac9deec96d">00676</a> <span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T&gt;</a> &amp; <a class="code" href="classTypeTensor.php#a1612ca1ec22651a6961a26ac9deec96d">TypeTensor&lt;T&gt;::operator *= </a>(<span class="keyword">const</span> Scalar factor)
<a name="l00677"></a>00677 {
<a name="l00678"></a>00678   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM*LIBMESH_DIM; i++)
<a name="l00679"></a>00679     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i] *= factor;
<a name="l00680"></a>00680 
<a name="l00681"></a>00681   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00682"></a>00682 }
<a name="l00683"></a>00683 
<a name="l00684"></a>00684 
<a name="l00685"></a>00685 
<a name="l00686"></a>00686 
<a name="l00687"></a>00687 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00688"></a>00688 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Scalar&gt;
<a name="l00689"></a>00689 <span class="keyword">inline</span>
<a name="l00690"></a>00690 <span class="keyword">typename</span> <a class="code" href="structboostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00691"></a>00691   ScalarTraits&lt;Scalar&gt;::value,
<a name="l00692"></a>00692   <a class="code" href="classTypeTensor.php">TypeTensor&lt;typename CompareTypes&lt;T, Scalar&gt;::supertype</a>&gt; &gt;::type
<a name="l00693"></a><a class="code" href="classTypeTensor.php#a29ccf64d35fc190250ebd5e5ca0b788b">00693</a> <a class="code" href="classTypeTensor.php#a29ccf64d35fc190250ebd5e5ca0b788b">TypeTensor&lt;T&gt;::operator / </a>(<span class="keyword">const</span> Scalar factor)<span class="keyword"> const</span>
<a name="l00694"></a>00694 <span class="keyword"></span>{
<a name="l00695"></a>00695   libmesh_assert (factor != static_cast&lt;T&gt;(0.));
<a name="l00696"></a>00696 
<a name="l00697"></a>00697   <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="structCompareTypes.php#a84d86a45868b9861ae413d884c0bedc2">CompareTypes&lt;T, Scalar&gt;::supertype</a> TS;
<a name="l00698"></a>00698   
<a name="l00699"></a>00699 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00700"></a>00700 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;TS&gt;</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]/factor);
<a name="l00701"></a>00701 <span class="preprocessor">#endif</span>
<a name="l00702"></a>00702 <span class="preprocessor"></span>  
<a name="l00703"></a>00703 <span class="preprocessor">#if LIBMESH_DIM == 2 </span>
<a name="l00704"></a>00704 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;TS&gt;</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]/factor,
<a name="l00705"></a>00705                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1]/factor,
<a name="l00706"></a>00706                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2]/factor,
<a name="l00707"></a>00707                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3]/factor);
<a name="l00708"></a>00708 <span class="preprocessor">#endif</span>
<a name="l00709"></a>00709 <span class="preprocessor"></span>  
<a name="l00710"></a>00710 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00711"></a>00711 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;TS&gt;</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]/factor,
<a name="l00712"></a>00712                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1]/factor, 
<a name="l00713"></a>00713                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2]/factor, 
<a name="l00714"></a>00714                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3]/factor, 
<a name="l00715"></a>00715                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[4]/factor, 
<a name="l00716"></a>00716                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[5]/factor, 
<a name="l00717"></a>00717                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[6]/factor, 
<a name="l00718"></a>00718                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[7]/factor, 
<a name="l00719"></a>00719                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[8]/factor);
<a name="l00720"></a>00720 <span class="preprocessor">#endif</span>
<a name="l00721"></a>00721 <span class="preprocessor"></span>  
<a name="l00722"></a>00722 }
<a name="l00723"></a>00723 
<a name="l00724"></a>00724 
<a name="l00725"></a>00725 
<a name="l00726"></a>00726 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00727"></a>00727 <span class="keyword">inline</span>
<a name="l00728"></a><a class="code" href="classTypeTensor.php#a10e89eb5aea4bb557f458523891e3f5a">00728</a> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T&gt;</a> <a class="code" href="classTypeTensor.php#a10e89eb5aea4bb557f458523891e3f5a">TypeTensor&lt;T&gt;::transpose</a>()<span class="keyword"> const</span>
<a name="l00729"></a>00729 <span class="keyword"></span>{
<a name="l00730"></a>00730 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00731"></a>00731 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]);
<a name="l00732"></a>00732 <span class="preprocessor">#endif</span>
<a name="l00733"></a>00733 <span class="preprocessor"></span>  
<a name="l00734"></a>00734 <span class="preprocessor">#if LIBMESH_DIM == 2 </span>
<a name="l00735"></a>00735 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0],
<a name="l00736"></a>00736                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2],
<a name="l00737"></a>00737                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1],
<a name="l00738"></a>00738                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3]);
<a name="l00739"></a>00739 <span class="preprocessor">#endif</span>
<a name="l00740"></a>00740 <span class="preprocessor"></span>  
<a name="l00741"></a>00741 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00742"></a>00742 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0],
<a name="l00743"></a>00743                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3], 
<a name="l00744"></a>00744                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[6], 
<a name="l00745"></a>00745                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1], 
<a name="l00746"></a>00746                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[4], 
<a name="l00747"></a>00747                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[7], 
<a name="l00748"></a>00748                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2], 
<a name="l00749"></a>00749                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[5], 
<a name="l00750"></a>00750                     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[8]);
<a name="l00751"></a>00751 <span class="preprocessor">#endif</span>
<a name="l00752"></a>00752 <span class="preprocessor"></span>}
<a name="l00753"></a>00753 
<a name="l00754"></a>00754 
<a name="l00755"></a>00755 
<a name="l00756"></a>00756 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00757"></a>00757 <span class="keyword">inline</span>
<a name="l00758"></a><a class="code" href="classTypeTensor.php#abd05c3462a122824cad88545931832dc">00758</a> <span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T&gt;</a> &amp; <a class="code" href="classTypeTensor.php#abd05c3462a122824cad88545931832dc">TypeTensor&lt;T&gt;::operator /= </a>(<span class="keyword">const</span> T factor)
<a name="l00759"></a>00759 {
<a name="l00760"></a>00760   libmesh_assert (factor != static_cast&lt;T&gt;(0.));
<a name="l00761"></a>00761   
<a name="l00762"></a>00762   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM*LIBMESH_DIM; i++)
<a name="l00763"></a>00763     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i] /= factor;
<a name="l00764"></a>00764 
<a name="l00765"></a>00765   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00766"></a>00766 }
<a name="l00767"></a>00767 
<a name="l00768"></a>00768 
<a name="l00769"></a>00769 
<a name="l00770"></a>00770 
<a name="l00771"></a>00771 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00772"></a>00772 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00773"></a>00773 <span class="keyword">inline</span>
<a name="l00774"></a>00774 <a class="code" href="classTypeVector.php">TypeVector&lt;typename CompareTypes&lt;T,T2&gt;::supertype</a>&gt;
<a name="l00775"></a><a class="code" href="classTypeTensor.php#a1a6391476276d496e3210cd5626f9077">00775</a> <a class="code" href="classTypeTensor.php#aa13aeb1295822cf536494c92a3c3b0e6">TypeTensor&lt;T&gt;::operator * </a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;p)<span class="keyword"> const</span>
<a name="l00776"></a>00776 <span class="keyword"></span>{
<a name="l00777"></a>00777   <a class="code" href="classTypeVector.php">TypeVector&lt;typename CompareTypes&lt;T,T2&gt;::supertype</a>&gt; returnval;
<a name="l00778"></a>00778   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00779"></a>00779     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;LIBMESH_DIM; j++)
<a name="l00780"></a>00780       returnval(i) += (*this)(i,j)*p(j);
<a name="l00781"></a>00781 
<a name="l00782"></a>00782   <span class="keywordflow">return</span> returnval;
<a name="l00783"></a>00783 }
<a name="l00784"></a>00784 
<a name="l00785"></a>00785 
<a name="l00786"></a>00786 
<a name="l00787"></a>00787 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00788"></a>00788 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00789"></a>00789 <span class="keyword">inline</span>
<a name="l00790"></a><a class="code" href="classTypeTensor.php#aa6b3efd1ac1648d8c2ce017e48db4fab">00790</a> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T&gt;</a> <a class="code" href="classTypeTensor.php#aa13aeb1295822cf536494c92a3c3b0e6">TypeTensor&lt;T&gt;::operator * </a>(<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;p)<span class="keyword"> const</span>
<a name="l00791"></a>00791 <span class="keyword"></span>{
<a name="l00792"></a>00792   <a class="code" href="classTypeTensor.php">TypeTensor&lt;T&gt;</a> returnval;
<a name="l00793"></a>00793   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00794"></a>00794     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;LIBMESH_DIM; j++)
<a name="l00795"></a>00795       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;LIBMESH_DIM; k++)
<a name="l00796"></a>00796         returnval(i,j) += (*this)(i,k)*p(k,j);
<a name="l00797"></a>00797 
<a name="l00798"></a>00798   <span class="keywordflow">return</span> returnval;
<a name="l00799"></a>00799 }
<a name="l00800"></a>00800 
<a name="l00801"></a>00801 
<a name="l00802"></a>00802 
<a name="l00807"></a>00807 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00808"></a>00808 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00809"></a>00809 <span class="keyword">inline</span>
<a name="l00810"></a>00810 <span class="keyword">typename</span> <a class="code" href="structCompareTypes.php#a84d86a45868b9861ae413d884c0bedc2">CompareTypes&lt;T,T2&gt;::supertype</a>
<a name="l00811"></a><a class="code" href="classTypeTensor.php#a1c322fe55bdd9e7eab8d9ead033f5e19">00811</a> <a class="code" href="classTypeTensor.php#a1c322fe55bdd9e7eab8d9ead033f5e19">TypeTensor&lt;T&gt;::contract</a> (<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;t)<span class="keyword"> const</span>
<a name="l00812"></a>00812 <span class="keyword"></span>{
<a name="l00813"></a>00813   <span class="keyword">typename</span> <a class="code" href="structCompareTypes.php#a84d86a45868b9861ae413d884c0bedc2">CompareTypes&lt;T,T2&gt;::supertype</a> sum = 0.;
<a name="l00814"></a>00814   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM*LIBMESH_DIM; i++)
<a name="l00815"></a>00815     sum += <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i]*t.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i];
<a name="l00816"></a>00816   <span class="keywordflow">return</span> sum;
<a name="l00817"></a>00817 }
<a name="l00818"></a>00818 
<a name="l00819"></a>00819 
<a name="l00820"></a>00820 
<a name="l00821"></a>00821 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00822"></a>00822 <span class="keyword">inline</span>
<a name="l00823"></a><a class="code" href="classTypeTensor.php#a43743b02ea196afa5301db69835c95a2">00823</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classTypeTensor.php#a43743b02ea196afa5301db69835c95a2">TypeTensor&lt;T&gt;::size</a>()<span class="keyword"> const</span>
<a name="l00824"></a>00824 <span class="keyword"></span>{
<a name="l00825"></a>00825   <span class="keywordflow">return</span> std::sqrt(this-&gt;<a class="code" href="classTypeTensor.php#a7be64b1de5e558f2de032bde1f881220">size_sq</a>());  
<a name="l00826"></a>00826 }
<a name="l00827"></a>00827 
<a name="l00828"></a>00828 
<a name="l00829"></a>00829 
<a name="l00830"></a>00830 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00831"></a>00831 <span class="keyword">inline</span>
<a name="l00832"></a><a class="code" href="classTypeTensor.php#a4e8ef88336d54773e974a50bb567c3a3">00832</a> T <a class="code" href="classTypeTensor.php#a4e8ef88336d54773e974a50bb567c3a3">TypeTensor&lt;T&gt;::det</a>()<span class="keyword"> const</span>
<a name="l00833"></a>00833 <span class="keyword"></span>{
<a name="l00834"></a>00834 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00835"></a>00835 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0];
<a name="l00836"></a>00836 <span class="preprocessor">#endif</span>
<a name="l00837"></a>00837 <span class="preprocessor"></span>
<a name="l00838"></a>00838 <span class="preprocessor">#if LIBMESH_DIM == 2</span>
<a name="l00839"></a>00839 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] * <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3]
<a name="l00840"></a>00840           - <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] * <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2]);
<a name="l00841"></a>00841 <span class="preprocessor">#endif</span>
<a name="l00842"></a>00842 <span class="preprocessor"></span>
<a name="l00843"></a>00843 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00844"></a>00844 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (_coords[0] * _coords[4] * _coords[8]
<a name="l00845"></a>00845           + _coords[1] * _coords[5] * _coords[6]
<a name="l00846"></a>00846           + _coords[2] * _coords[3] * _coords[7]
<a name="l00847"></a>00847           - _coords[0] * _coords[5] * _coords[7]
<a name="l00848"></a>00848           - _coords[1] * _coords[3] * _coords[8]
<a name="l00849"></a>00849           - _coords[2] * _coords[4] * _coords[6]);
<a name="l00850"></a>00850 <span class="preprocessor">#endif</span>
<a name="l00851"></a>00851 <span class="preprocessor"></span>}
<a name="l00852"></a>00852 
<a name="l00853"></a>00853 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00854"></a>00854 <span class="keyword">inline</span>
<a name="l00855"></a><a class="code" href="classTypeTensor.php#ab45c6a8b907860bdf0b504a4a581db92">00855</a> T <a class="code" href="classTypeTensor.php#ab45c6a8b907860bdf0b504a4a581db92">TypeTensor&lt;T&gt;::tr</a>()<span class="keyword"> const</span>
<a name="l00856"></a>00856 <span class="keyword"></span>{
<a name="l00857"></a>00857 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00858"></a>00858 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0];
<a name="l00859"></a>00859 <span class="preprocessor">#endif</span>
<a name="l00860"></a>00860 <span class="preprocessor"></span>
<a name="l00861"></a>00861 <span class="preprocessor">#if LIBMESH_DIM == 2</span>
<a name="l00862"></a>00862 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] + <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3];
<a name="l00863"></a>00863 <span class="preprocessor">#endif</span>
<a name="l00864"></a>00864 <span class="preprocessor"></span>
<a name="l00865"></a>00865 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00866"></a>00866 <span class="preprocessor"></span>  <span class="keywordflow">return</span> _coords[0] + _coords[4] + _coords[8];
<a name="l00867"></a>00867 <span class="preprocessor">#endif</span>
<a name="l00868"></a>00868 <span class="preprocessor"></span>}
<a name="l00869"></a>00869 
<a name="l00870"></a>00870 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00871"></a>00871 <span class="keyword">inline</span>
<a name="l00872"></a><a class="code" href="classTypeTensor.php#a616e4871685124fd810c17f557b6193e">00872</a> <span class="keywordtype">void</span> <a class="code" href="classTypeTensor.php#a616e4871685124fd810c17f557b6193e">TypeTensor&lt;T&gt;::zero</a>()
<a name="l00873"></a>00873 {
<a name="l00874"></a>00874   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM*LIBMESH_DIM; i++)
<a name="l00875"></a>00875     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i] = 0.;
<a name="l00876"></a>00876 }
<a name="l00877"></a>00877 
<a name="l00878"></a>00878 
<a name="l00879"></a>00879 
<a name="l00880"></a>00880 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00881"></a>00881 <span class="keyword">inline</span>
<a name="l00882"></a><a class="code" href="classTypeTensor.php#a7be64b1de5e558f2de032bde1f881220">00882</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classTypeTensor.php#a7be64b1de5e558f2de032bde1f881220">TypeTensor&lt;T&gt;::size_sq</a> ()<span class="keyword"> const</span>
<a name="l00883"></a>00883 <span class="keyword"></span>{
<a name="l00884"></a>00884   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> sum = 0.;
<a name="l00885"></a>00885   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM*LIBMESH_DIM; i++)
<a name="l00886"></a>00886     sum += <a class="code" href="libmesh__common_8h.php#af9cdd07341b53cc644199f6aec5e1420">libmesh_norm</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i]);
<a name="l00887"></a>00887   <span class="keywordflow">return</span> sum;
<a name="l00888"></a>00888 }
<a name="l00889"></a>00889 
<a name="l00890"></a>00890 
<a name="l00891"></a>00891 
<a name="l00892"></a>00892 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00893"></a>00893 <span class="keyword">inline</span>
<a name="l00894"></a><a class="code" href="classTypeTensor.php#ab79ed166251f11176c7d57c58e2e284c">00894</a> <span class="keywordtype">bool</span> <a class="code" href="classTypeTensor.php#ab79ed166251f11176c7d57c58e2e284c">TypeTensor&lt;T&gt;::operator == </a>(<span class="keyword">const</span> <a class="code" href="classTypeTensor.php">TypeTensor&lt;T&gt;</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00895"></a>00895 <span class="keyword"></span>{
<a name="l00896"></a>00896 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00897"></a>00897 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] - rhs.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0])
<a name="l00898"></a>00898           &lt; TOLERANCE);
<a name="l00899"></a>00899 <span class="preprocessor">#endif</span>
<a name="l00900"></a>00900 <span class="preprocessor"></span>  
<a name="l00901"></a>00901 <span class="preprocessor">#if LIBMESH_DIM == 2</span>
<a name="l00902"></a>00902 <span class="preprocessor"></span>  <span class="keywordflow">return</span> ((std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] - rhs.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]) +
<a name="l00903"></a>00903            std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] - rhs.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1]) +
<a name="l00904"></a>00904            std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2] - rhs.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2]) +
<a name="l00905"></a>00905            std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3] - rhs.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3]))
<a name="l00906"></a>00906           &lt; 4.*TOLERANCE);
<a name="l00907"></a>00907 <span class="preprocessor">#endif</span>
<a name="l00908"></a>00908 <span class="preprocessor"></span>  
<a name="l00909"></a>00909 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00910"></a>00910 <span class="preprocessor"></span>  <span class="keywordflow">return</span> ((std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] - rhs.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]) +
<a name="l00911"></a>00911            std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] - rhs.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1]) +
<a name="l00912"></a>00912            std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2] - rhs.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2]) +
<a name="l00913"></a>00913            std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3] - rhs.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[3]) +
<a name="l00914"></a>00914            std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[4] - rhs.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[4]) +
<a name="l00915"></a>00915            std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[5] - rhs.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[5]) +
<a name="l00916"></a>00916            std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[6] - rhs.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[6]) +
<a name="l00917"></a>00917            std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[7] - rhs.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[7]) +
<a name="l00918"></a>00918            std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[8] - rhs.<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[8]))
<a name="l00919"></a>00919           &lt; 9.*TOLERANCE);
<a name="l00920"></a>00920 <span class="preprocessor">#endif</span>
<a name="l00921"></a>00921 <span class="preprocessor"></span>  
<a name="l00922"></a>00922 }
<a name="l00923"></a>00923 
<a name="l00924"></a>00924 <span class="preprocessor">#endif // #define __type_tensor_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
