<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_f10759d5ac6297fe611079c3c15b8f2c.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>type_vector.C</h1>  </div>
</div>
<div class="contents">
<a href="type__vector_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: type_vector.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// C++ includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;iostream&gt;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;iomanip&gt;</span> <span class="comment">// for std::setw, std::setiosflags</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;type_vector.h&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00034"></a>00034 <span class="comment">// TypeVector&lt;T&gt; class member funcions</span>
<a name="l00035"></a>00035 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00036"></a><a class="code" href="classTypeVector.php#a0415bcc1a523ea5f0224a711b14b3532">00036</a> <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a> <a class="code" href="classTypeVector.php#a0415bcc1a523ea5f0224a711b14b3532">TypeVector&lt;T&gt;::unit</a>()<span class="keyword"> const</span>
<a name="l00037"></a>00037 <span class="keyword"></span>{
<a name="l00038"></a>00038 
<a name="l00039"></a>00039   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> length = <a class="code" href="classTypeTensor.php#a43743b02ea196afa5301db69835c95a2">size</a>();
<a name="l00040"></a>00040   
<a name="l00041"></a>00041   libmesh_assert (length != static_cast&lt;Real&gt;(0.));
<a name="l00042"></a>00042   
<a name="l00043"></a>00043 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]/length);
<a name="l00045"></a>00045 <span class="preprocessor">#endif</span>
<a name="l00046"></a>00046 <span class="preprocessor"></span>  
<a name="l00047"></a>00047 <span class="preprocessor">#if LIBMESH_DIM == 2 </span>
<a name="l00048"></a>00048 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]/length,
<a name="l00049"></a>00049                        <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1]/length);
<a name="l00050"></a>00050 <span class="preprocessor">#endif</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span>  
<a name="l00052"></a>00052 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]/length,
<a name="l00054"></a>00054                        <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1]/length, 
<a name="l00055"></a>00055                        <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2]/length);
<a name="l00056"></a>00056 <span class="preprocessor">#endif</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span>  
<a name="l00058"></a>00058 }
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00063"></a><a class="code" href="classTypeVector.php#a4b2f07c147b33f055941212f40ecbb8d">00063</a> <span class="keywordtype">void</span> <a class="code" href="classTypeVector.php#a4b2f07c147b33f055941212f40ecbb8d">TypeVector&lt;T&gt;::print</a>(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00064"></a>00064 <span class="keyword"></span>{
<a name="l00065"></a>00065 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00066"></a>00066 <span class="preprocessor"></span>  
<a name="l00067"></a>00067   os &lt;&lt; <span class="stringliteral">&quot;x=&quot;</span> &lt;&lt; (*this)(0) &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00068"></a>00068   
<a name="l00069"></a>00069 <span class="preprocessor">#endif</span>
<a name="l00070"></a>00070 <span class="preprocessor"></span><span class="preprocessor">#if LIBMESH_DIM == 2</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span>  
<a name="l00072"></a>00072   os &lt;&lt; <span class="stringliteral">&quot;(x,y)=(&quot;</span>
<a name="l00073"></a>00073      &lt;&lt; std::setw(8) &lt;&lt; (*this)(0) &lt;&lt; <span class="stringliteral">&quot;, &quot;</span>
<a name="l00074"></a>00074      &lt;&lt; std::setw(8) &lt;&lt; (*this)(1) &lt;&lt; <span class="stringliteral">&quot;)&quot;</span>
<a name="l00075"></a>00075      &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 <span class="preprocessor">#endif</span>
<a name="l00078"></a>00078 <span class="preprocessor"></span><span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00079"></a>00079 <span class="preprocessor"></span>  
<a name="l00080"></a>00080   os &lt;&lt;  <span class="stringliteral">&quot;(x,y,z)=(&quot;</span>
<a name="l00081"></a>00081      &lt;&lt; std::setw(8) &lt;&lt; (*this)(0) &lt;&lt; <span class="stringliteral">&quot;, &quot;</span>
<a name="l00082"></a>00082      &lt;&lt; std::setw(8) &lt;&lt; (*this)(1) &lt;&lt; <span class="stringliteral">&quot;, &quot;</span>
<a name="l00083"></a>00083      &lt;&lt; std::setw(8) &lt;&lt; (*this)(2) &lt;&lt; <span class="stringliteral">&quot;)&quot;</span>
<a name="l00084"></a>00084      &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00085"></a>00085 <span class="preprocessor">#endif</span>
<a name="l00086"></a>00086 <span class="preprocessor"></span>}
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00093"></a><a class="code" href="classTypeVector.php#a63b9bdcd6b65a707e9c3f9ac66eb3a1a">00093</a> <span class="keywordtype">void</span> <a class="code" href="classTypeVector.php#a63b9bdcd6b65a707e9c3f9ac66eb3a1a">TypeVector&lt;T&gt;::write_unformatted</a> (std::ostream &amp;out,
<a name="l00094"></a>00094                                        <span class="keyword">const</span> <span class="keywordtype">bool</span> newline)<span class="keyword"> const</span>
<a name="l00095"></a>00095 <span class="keyword"></span>{
<a name="l00096"></a>00096   libmesh_assert (out);
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   out &lt;&lt; std::setiosflags(std::ios::showpoint)
<a name="l00099"></a>00099       &lt;&lt; (*this)(0) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00100"></a>00100       &lt;&lt; (*<span class="keyword">this</span>)(1) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00101"></a>00101       &lt;&lt; (*<span class="keyword">this</span>)(2) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00102"></a>00102 
<a name="l00103"></a>00103   <span class="keywordflow">if</span> (newline)
<a name="l00104"></a>00104     out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;      
<a name="l00105"></a>00105 }
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00110"></a><a class="code" href="classTypeVector.php#a65235d09f5e45ce4400221eaa8690835">00110</a> <span class="keywordtype">bool</span> <a class="code" href="classTypeVector.php#a65235d09f5e45ce4400221eaa8690835">TypeVector&lt;T&gt;::operator &lt; </a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00111"></a>00111 <span class="keyword"></span>{
<a name="l00112"></a>00112   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00113"></a>00113     {
<a name="l00114"></a>00114       <span class="keywordflow">if</span> ((*<span class="keyword">this</span>)(i) &lt; rhs(i))
<a name="l00115"></a>00115         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00116"></a>00116       <span class="keywordflow">if</span> ((*<span class="keyword">this</span>)(i) &gt; rhs(i))
<a name="l00117"></a>00117         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00118"></a>00118     }
<a name="l00119"></a>00119   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00120"></a>00120 }
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00125"></a><a class="code" href="classTypeVector.php#a818b139fbfd0fa20bd8ac5ca0290c3ed">00125</a> <span class="keywordtype">bool</span> <a class="code" href="classTypeVector.php#a818b139fbfd0fa20bd8ac5ca0290c3ed">TypeVector&lt;T&gt;::operator &gt; </a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00126"></a>00126 <span class="keyword"></span>{
<a name="l00127"></a>00127   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00128"></a>00128     {
<a name="l00129"></a>00129       <span class="keywordflow">if</span> ((*<span class="keyword">this</span>)(i) &gt; rhs(i))
<a name="l00130"></a>00130         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00131"></a>00131       <span class="keywordflow">if</span> ((*<span class="keyword">this</span>)(i) &lt; rhs(i))
<a name="l00132"></a>00132         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00133"></a>00133     }
<a name="l00134"></a>00134   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00135"></a>00135 }
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00140"></a>00140 <span class="preprocessor"></span><span class="keyword">template</span> &lt;&gt;
<a name="l00141"></a><a class="code" href="classTypeVector.php#a62cb8512a11bd06328b2b8bb5de53ab5">00141</a> <span class="keywordtype">bool</span> <a class="code" href="classTypeVector.php#a65235d09f5e45ce4400221eaa8690835">TypeVector&lt;Complex&gt;::operator &lt; </a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;Complex&gt;</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00142"></a>00142 <span class="keyword"></span>{
<a name="l00143"></a>00143   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00144"></a>00144     {
<a name="l00145"></a>00145       <span class="keywordflow">if</span> ((*<span class="keyword">this</span>)(i).real() &lt; rhs(i).real())
<a name="l00146"></a>00146         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00147"></a>00147       <span class="keywordflow">if</span> ((*<span class="keyword">this</span>)(i).real() &gt; rhs(i).real())
<a name="l00148"></a>00148         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00149"></a>00149       <span class="keywordflow">if</span> ((*<span class="keyword">this</span>)(i).imag() &lt; rhs(i).imag())
<a name="l00150"></a>00150         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00151"></a>00151       <span class="keywordflow">if</span> ((*<span class="keyword">this</span>)(i).imag() &gt; rhs(i).imag())
<a name="l00152"></a>00152         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00153"></a>00153     }
<a name="l00154"></a>00154   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00155"></a>00155 }
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 <span class="keyword">template</span> &lt;&gt;
<a name="l00160"></a><a class="code" href="classTypeVector.php#ac665700f74c181828faa40ef5a4b29b8">00160</a> <span class="keywordtype">bool</span> <a class="code" href="classTypeVector.php#a818b139fbfd0fa20bd8ac5ca0290c3ed">TypeVector&lt;Complex&gt;::operator &gt; </a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;Complex&gt;</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00161"></a>00161 <span class="keyword"></span>{
<a name="l00162"></a>00162   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00163"></a>00163     {
<a name="l00164"></a>00164       <span class="keywordflow">if</span> ((*<span class="keyword">this</span>)(i).real() &gt; rhs(i).real())
<a name="l00165"></a>00165         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00166"></a>00166       <span class="keywordflow">if</span> ((*<span class="keyword">this</span>)(i).real() &lt; rhs(i).real())
<a name="l00167"></a>00167         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00168"></a>00168       <span class="keywordflow">if</span> ((*<span class="keyword">this</span>)(i).imag() &gt; rhs(i).imag())
<a name="l00169"></a>00169         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00170"></a>00170       <span class="keywordflow">if</span> ((*<span class="keyword">this</span>)(i).imag() &lt; rhs(i).imag())
<a name="l00171"></a>00171         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00172"></a>00172     }
<a name="l00173"></a>00173   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00174"></a>00174 }
<a name="l00175"></a>00175 <span class="preprocessor">#endif</span>
<a name="l00176"></a>00176 <span class="preprocessor"></span>
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00180"></a>00180 <span class="comment">// Explicit instantiations</span>
<a name="l00181"></a>00181 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classTypeVector.php">TypeVector&lt;Real&gt;</a>;
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00184"></a>00184 <span class="preprocessor"></span><span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classTypeVector.php">TypeVector&lt;Complex&gt;</a>;
<a name="l00185"></a>00185 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
