<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>type_vector.h</h1>  </div>
</div>
<div class="contents">
<a href="type__vector_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: type_vector.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __type_vector_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __type_vector_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;cmath&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;compare_types.h&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Forward declaration for friend class</span>
<a name="l00033"></a>00033 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00034"></a>00034 <span class="keyword">class </span><a class="code" href="classTypeTensor.php">TypeTensor</a>;
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00048"></a>00048 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00049"></a><a class="code" href="classTypeVector.php">00049</a> <span class="keyword">class </span><a class="code" href="classTypeVector.php">TypeVector</a>
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00052"></a><a class="code" href="classTypeVector.php#a5b7a6e992ba7ac8e78e558898115964b">00052</a> <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classTypeVector.php">TypeVector</a>;
<a name="l00053"></a>00053 
<a name="l00054"></a><a class="code" href="classTypeVector.php#ae6f59a3f0fe750f907d022512acb66a9">00054</a> <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classTypeTensor.php">TypeTensor</a>&lt;T&gt;;
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 <span class="keyword">protected</span>:
<a name="l00057"></a>00057 
<a name="l00062"></a>00062   <a class="code" href="classTypeVector.php#a5b7a6e992ba7ac8e78e558898115964b">TypeVector</a>  (<span class="keyword">const</span> T x=0.,
<a name="l00063"></a>00063                <span class="keyword">const</span> T y=0.,
<a name="l00064"></a>00064                <span class="keyword">const</span> T z=0.);
<a name="l00065"></a>00065   
<a name="l00066"></a>00066 <span class="keyword">public</span>:
<a name="l00067"></a>00067 
<a name="l00071"></a>00071   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00072"></a>00072   <a class="code" href="classTypeVector.php#a5b7a6e992ba7ac8e78e558898115964b">TypeVector</a> (<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a>&amp; p);
<a name="l00073"></a>00073   
<a name="l00077"></a>00077   <span class="keyword">virtual</span> <a class="code" href="classTypeVector.php#a6153266a6f28c03848303ae76c9d9336">~TypeVector</a> ();
<a name="l00078"></a>00078 
<a name="l00082"></a>00082   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00083"></a>00083   <span class="keywordtype">void</span> <a class="code" href="classTypeVector.php#af806fc7c5366e7f6048451c68a0e0687">assign</a> (<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;);
<a name="l00084"></a>00084 
<a name="l00088"></a>00088   T <a class="code" href="classTypeVector.php#a3fcffe1b3f2cbb044cc86a7f054c1cfc">operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00089"></a>00089 
<a name="l00093"></a>00093   T &amp; <a class="code" href="classTypeVector.php#a3fcffe1b3f2cbb044cc86a7f054c1cfc">operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00094"></a>00094   
<a name="l00098"></a>00098   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00099"></a>00099   <a class="code" href="classTypeVector.php">TypeVector&lt;typename CompareTypes&lt;T, T2&gt;::supertype</a>&gt; 
<a name="l00100"></a>00100   <a class="code" href="classTypeVector.php#ad5ee260f76d8706d17e1e6a9013b810f">operator + </a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;) <span class="keyword">const</span>;
<a name="l00101"></a>00101 
<a name="l00105"></a>00105   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00106"></a>00106   <span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a> &amp; <a class="code" href="classTypeVector.php#a56be7f0511129be1c89859ae75ac9e28">operator += </a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;);
<a name="l00107"></a>00107   
<a name="l00111"></a>00111   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00112"></a>00112   <span class="keywordtype">void</span> <a class="code" href="classTypeVector.php#a5a491e5c665118253b6e2f65141c8922">add</a> (<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;); 
<a name="l00113"></a>00113   
<a name="l00118"></a>00118   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00119"></a>00119   <span class="keywordtype">void</span> <a class="code" href="classTypeVector.php#ac9000695cb19991b893cb79a07249e9c">add_scaled</a> (<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;, <span class="keyword">const</span> T); 
<a name="l00120"></a>00120   
<a name="l00124"></a>00124   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00125"></a>00125   <a class="code" href="classTypeVector.php">TypeVector&lt;typename CompareTypes&lt;T, T2&gt;::supertype</a>&gt; 
<a name="l00126"></a>00126   <a class="code" href="classTypeVector.php#a8d2b0f39d0a3bbc8f7a8f23262ce69f5">operator - </a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;) <span class="keyword">const</span>;
<a name="l00127"></a>00127 
<a name="l00131"></a>00131   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00132"></a>00132   <span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a> &amp; <a class="code" href="classTypeVector.php#adbfd6a05a4a5c2fe7c779587b7678350">operator -= </a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;);
<a name="l00133"></a>00133 
<a name="l00137"></a>00137   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00138"></a>00138   <span class="keywordtype">void</span> <a class="code" href="classTypeVector.php#a5a369299b2cd40554e3d38a1365e0e70">subtract</a> (<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;); 
<a name="l00139"></a>00139   
<a name="l00144"></a>00144   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00145"></a>00145   <span class="keywordtype">void</span> <a class="code" href="classTypeVector.php#a94b16f15ba75d265bf83e9a50d9fd63b">subtract_scaled</a> (<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;, <span class="keyword">const</span> T); 
<a name="l00146"></a>00146   
<a name="l00150"></a>00150   <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a> <a class="code" href="classTypeVector.php#a8d2b0f39d0a3bbc8f7a8f23262ce69f5">operator - </a>() <span class="keyword">const</span>;
<a name="l00151"></a>00151   
<a name="l00155"></a>00155   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Scalar&gt;
<a name="l00156"></a>00156   <span class="keyword">typename</span> <a class="code" href="structboostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00157"></a>00157     <a class="code" href="structScalarTraits.php">ScalarTraits&lt;Scalar&gt;::value</a>,
<a name="l00158"></a>00158     <a class="code" href="classTypeVector.php">TypeVector&lt;typename CompareTypes&lt;T, Scalar&gt;::supertype</a>&gt; &gt;::type
<a name="l00159"></a>00159   <a class="code" href="classTypeVector.php#a6b3e0d1495c5d7e7c58a96af0a93bdd0">operator * </a>(<span class="keyword">const</span> Scalar) <span class="keyword">const</span>;
<a name="l00160"></a>00160 
<a name="l00164"></a>00164   <span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a> &amp; <a class="code" href="classTypeVector.php#accb3ce86415e5b80a2d18453a8a6059d">operator *= </a>(<span class="keyword">const</span> T);
<a name="l00165"></a>00165   
<a name="l00169"></a>00169   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Scalar&gt;
<a name="l00170"></a>00170   <span class="keyword">typename</span> <a class="code" href="structboostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00171"></a>00171     <a class="code" href="structScalarTraits.php">ScalarTraits&lt;Scalar&gt;::value</a>,
<a name="l00172"></a>00172     <a class="code" href="classTypeVector.php">TypeVector&lt;typename CompareTypes&lt;T, Scalar&gt;::supertype</a>&gt; &gt;::type
<a name="l00173"></a>00173   <a class="code" href="classTypeVector.php#ac59d7d2da90b1c5b387d60379e087d6c">operator / </a>(<span class="keyword">const</span> Scalar) <span class="keyword">const</span>;
<a name="l00174"></a>00174 
<a name="l00178"></a>00178   <span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a> &amp; <a class="code" href="classTypeVector.php#a23c5809e93f8fc4adc9965c2db2fe8df">operator /= </a>(<span class="keyword">const</span> T);
<a name="l00179"></a>00179 
<a name="l00184"></a>00184   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00185"></a>00185   <span class="keyword">typename</span> <a class="code" href="structCompareTypes.php#a84d86a45868b9861ae413d884c0bedc2">CompareTypes&lt;T, T2&gt;::supertype</a>
<a name="l00186"></a>00186   <a class="code" href="classTypeVector.php#a6b3e0d1495c5d7e7c58a96af0a93bdd0">operator * </a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;) <span class="keyword">const</span>;
<a name="l00187"></a>00187 
<a name="l00191"></a>00191   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00192"></a>00192   <a class="code" href="classTypeVector.php">TypeVector&lt;typename CompareTypes&lt;T, T2&gt;::supertype</a>&gt;
<a name="l00193"></a>00193   <a class="code" href="classTypeVector.php#a1347e1223f3e31f8a2c0496736e60dc5">cross</a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;) <span class="keyword">const</span>;
<a name="l00194"></a>00194 
<a name="l00199"></a>00199   <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a> <a class="code" href="classTypeVector.php#a0415bcc1a523ea5f0224a711b14b3532">unit</a>() <span class="keyword">const</span>;
<a name="l00200"></a>00200 
<a name="l00205"></a>00205   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classTypeVector.php#a34f47a12e12990aad2910a934bdaac7d">size</a>() <span class="keyword">const</span>;
<a name="l00206"></a>00206 
<a name="l00211"></a>00211   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classTypeVector.php#a099aac580a3a6fce9276cf5443d0c0e9">size_sq</a>() <span class="keyword">const</span>;
<a name="l00212"></a>00212 
<a name="l00216"></a>00216   <span class="keywordtype">void</span> <a class="code" href="classTypeVector.php#a0e8a26593313d8978082ff6f4084fdd5">zero</a>();
<a name="l00217"></a>00217 
<a name="l00222"></a>00222   <span class="keywordtype">bool</span> <a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">relative_fuzzy_equals</a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a>&amp; rhs, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tol = TOLERANCE) <span class="keyword">const</span>;
<a name="l00223"></a>00223   
<a name="l00228"></a>00228   <span class="keywordtype">bool</span> <a class="code" href="classTypeVector.php#af1c18b620df014bd558bc19972613a2b">absolute_fuzzy_equals</a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a>&amp; rhs, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tol = TOLERANCE) <span class="keyword">const</span>;
<a name="l00229"></a>00229   
<a name="l00234"></a>00234   <span class="keywordtype">bool</span> <a class="code" href="classTypeVector.php#ac05e55902795911cd87e7ebe46b3e819">operator == </a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a>&amp; rhs) <span class="keyword">const</span>;
<a name="l00235"></a>00235   
<a name="l00240"></a>00240   <span class="keywordtype">bool</span> <a class="code" href="classTypeVector.php#ac83e3752e1908c64b6e329a7c50d778b">operator != </a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a>&amp; rhs) <span class="keyword">const</span>;
<a name="l00241"></a>00241   
<a name="l00248"></a>00248   <span class="keywordtype">bool</span> operator &lt; (const TypeVector&lt;T&gt;&amp; rhs) <span class="keyword">const</span>;
<a name="l00249"></a>00249   
<a name="l00256"></a>00256   <span class="keywordtype">bool</span> <a class="code" href="classTypeVector.php#a818b139fbfd0fa20bd8ac5ca0290c3ed">operator &gt; </a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a>&amp; rhs) <span class="keyword">const</span>;
<a name="l00257"></a>00257 
<a name="l00261"></a>00261   <span class="keywordtype">void</span> <a class="code" href="classTypeVector.php#a4b2f07c147b33f055941212f40ecbb8d">print</a>(std::ostream&amp; os) <span class="keyword">const</span>;
<a name="l00262"></a>00262 
<a name="l00268"></a><a class="code" href="classTypeVector.php#a7948f665d08fffeeb5e3954f91dd62a6">00268</a>   <span class="keyword">friend</span> std::ostream&amp; operator &lt;&lt; (std::ostream&amp; os, const TypeVector&lt;T&gt;&amp; t)
<a name="l00269"></a>00269   {
<a name="l00270"></a>00270     t.print(os);
<a name="l00271"></a>00271     <span class="keywordflow">return</span> os;
<a name="l00272"></a>00272   }
<a name="l00273"></a>00273   
<a name="l00279"></a>00279   <span class="keywordtype">void</span> <a class="code" href="classTypeVector.php#a63b9bdcd6b65a707e9c3f9ac66eb3a1a">write_unformatted</a> (std::ostream &amp;out, <span class="keyword">const</span> <span class="keywordtype">bool</span> newline = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00280"></a>00280     
<a name="l00281"></a>00281  <span class="keyword">protected</span>:
<a name="l00282"></a>00282 
<a name="l00286"></a><a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">00286</a>   T <a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[LIBMESH_DIM];
<a name="l00287"></a>00287 };
<a name="l00288"></a>00288 
<a name="l00289"></a>00289 
<a name="l00290"></a>00290 
<a name="l00291"></a>00291 <span class="comment">//------------------------------------------------------</span>
<a name="l00292"></a>00292 <span class="comment">// Inline functions</span>
<a name="l00293"></a>00293 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00294"></a>00294 <span class="keyword">inline</span>
<a name="l00295"></a><a class="code" href="classTypeVector.php#ad2d374902c04e7917b9ad8c6a7f75d2f">00295</a> <a class="code" href="classTypeVector.php#a5b7a6e992ba7ac8e78e558898115964b">TypeVector&lt;T&gt;::TypeVector</a> (<span class="keyword">const</span> T x,
<a name="l00296"></a>00296                            <span class="keyword">const</span> T y,
<a name="l00297"></a>00297                            <span class="keyword">const</span> T z)
<a name="l00298"></a>00298 {
<a name="l00299"></a>00299   <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] = x;
<a name="l00300"></a>00300 
<a name="l00301"></a>00301   <span class="keywordflow">if</span> (LIBMESH_DIM &gt; 1)
<a name="l00302"></a>00302     {
<a name="l00303"></a>00303       <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] = y;
<a name="l00304"></a>00304 
<a name="l00305"></a>00305       <span class="keywordflow">if</span> (LIBMESH_DIM == 3)
<a name="l00306"></a>00306         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2] = z;
<a name="l00307"></a>00307     }
<a name="l00308"></a>00308 }
<a name="l00309"></a>00309 
<a name="l00310"></a>00310 
<a name="l00311"></a>00311 
<a name="l00312"></a>00312 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00313"></a>00313 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00314"></a>00314 <span class="keyword">inline</span>
<a name="l00315"></a><a class="code" href="classTypeVector.php#a06d6d46ef620f18d5d7a56e7c7d7d5e7">00315</a> <a class="code" href="classTypeVector.php#a5b7a6e992ba7ac8e78e558898115964b">TypeVector&lt;T&gt;::TypeVector</a> (<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;p)
<a name="l00316"></a>00316 {
<a name="l00317"></a>00317   <span class="comment">// copy the nodes from vector p to me</span>
<a name="l00318"></a>00318   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00319"></a>00319     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i] = p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[i];
<a name="l00320"></a>00320 }
<a name="l00321"></a>00321 
<a name="l00322"></a>00322 
<a name="l00323"></a>00323 
<a name="l00324"></a>00324 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00325"></a>00325 <span class="keyword">inline</span>
<a name="l00326"></a><a class="code" href="classTypeVector.php#a6153266a6f28c03848303ae76c9d9336">00326</a> <a class="code" href="classTypeVector.php#a6153266a6f28c03848303ae76c9d9336">TypeVector&lt;T&gt;::~TypeVector</a> ()
<a name="l00327"></a>00327 {
<a name="l00328"></a>00328 }
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 
<a name="l00332"></a>00332 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00333"></a>00333 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00334"></a>00334 <span class="keyword">inline</span>
<a name="l00335"></a><a class="code" href="classTypeVector.php#af806fc7c5366e7f6048451c68a0e0687">00335</a> <span class="keywordtype">void</span> <a class="code" href="classTypeVector.php#af806fc7c5366e7f6048451c68a0e0687">TypeVector&lt;T&gt;::assign</a> (<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;p)
<a name="l00336"></a>00336 {
<a name="l00337"></a>00337   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00338"></a>00338     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i] = p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[i];
<a name="l00339"></a>00339 }
<a name="l00340"></a>00340 
<a name="l00341"></a>00341 
<a name="l00342"></a>00342 
<a name="l00343"></a>00343 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00344"></a>00344 <span class="keyword">inline</span>
<a name="l00345"></a><a class="code" href="classTypeVector.php#a3fcffe1b3f2cbb044cc86a7f054c1cfc">00345</a> T <a class="code" href="classTypeVector.php#a3fcffe1b3f2cbb044cc86a7f054c1cfc">TypeVector&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00346"></a>00346 <span class="keyword"></span>{
<a name="l00347"></a>00347   libmesh_assert (i&lt;3);
<a name="l00348"></a>00348 
<a name="l00349"></a>00349 <span class="preprocessor">#if LIBMESH_DIM &lt; 3</span>
<a name="l00350"></a>00350 <span class="preprocessor"></span>  
<a name="l00351"></a>00351   <span class="keywordflow">if</span> (i &gt; (LIBMESH_DIM-1))
<a name="l00352"></a>00352     <span class="keywordflow">return</span> 0.;
<a name="l00353"></a>00353   
<a name="l00354"></a>00354 <span class="preprocessor">#endif</span>
<a name="l00355"></a>00355 <span class="preprocessor"></span>  
<a name="l00356"></a>00356   <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i];
<a name="l00357"></a>00357 }
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 
<a name="l00361"></a>00361 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00362"></a>00362 <span class="keyword">inline</span>
<a name="l00363"></a><a class="code" href="classTypeVector.php#a2afe4446ff64af159e05c38b9dbb3966">00363</a> T &amp; <a class="code" href="classTypeVector.php#a3fcffe1b3f2cbb044cc86a7f054c1cfc">TypeVector&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00364"></a>00364 {
<a name="l00365"></a>00365 <span class="preprocessor">#if LIBMESH_DIM &lt; 3</span>
<a name="l00366"></a>00366 <span class="preprocessor"></span>
<a name="l00367"></a>00367   <span class="keywordflow">if</span> (i &gt;= LIBMESH_DIM)
<a name="l00368"></a>00368     {
<a name="l00369"></a>00369 <span class="comment">//       std::cerr &lt;&lt; &quot;ERROR:  You are assigning to a vector component&quot; &lt;&lt; std::endl</span>
<a name="l00370"></a>00370 <span class="comment">//              &lt;&lt; &quot;that is out of range for the compiled LIBMESH_DIM!&quot;      &lt;&lt; std::endl</span>
<a name="l00371"></a>00371 <span class="comment">//              &lt;&lt; &quot; LIBMESH_DIM=&quot; &lt;&lt; LIBMESH_DIM &lt;&lt; &quot; , i=&quot; &lt;&lt; i</span>
<a name="l00372"></a>00372 <span class="comment">//              &lt;&lt; std::endl;</span>
<a name="l00373"></a>00373       libmesh_error();
<a name="l00374"></a>00374     }
<a name="l00375"></a>00375   
<a name="l00376"></a>00376 <span class="preprocessor">#endif</span>
<a name="l00377"></a>00377 <span class="preprocessor"></span>  
<a name="l00378"></a>00378   libmesh_assert (i&lt;LIBMESH_DIM);
<a name="l00379"></a>00379   
<a name="l00380"></a>00380   <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i];
<a name="l00381"></a>00381 }
<a name="l00382"></a>00382 
<a name="l00383"></a>00383 
<a name="l00384"></a>00384 
<a name="l00385"></a>00385 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00386"></a>00386 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00387"></a>00387 <span class="keyword">inline</span>
<a name="l00388"></a>00388 <a class="code" href="classTypeVector.php">TypeVector&lt;typename CompareTypes&lt;T, T2&gt;::supertype</a>&gt; 
<a name="l00389"></a><a class="code" href="classTypeVector.php#ad5ee260f76d8706d17e1e6a9013b810f">00389</a> <a class="code" href="classTypeVector.php#ad5ee260f76d8706d17e1e6a9013b810f">TypeVector&lt;T&gt;::operator + </a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;p)<span class="keyword"> const</span>
<a name="l00390"></a>00390 <span class="keyword"></span>{
<a name="l00391"></a>00391   <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="structCompareTypes.php#a84d86a45868b9861ae413d884c0bedc2">CompareTypes&lt;T, T2&gt;::supertype</a> TS;
<a name="l00392"></a>00392 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00393"></a>00393 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeVector.php">TypeVector&lt;TS&gt;</a> (<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] + p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[0]);
<a name="l00394"></a>00394 <span class="preprocessor">#endif</span>
<a name="l00395"></a>00395 <span class="preprocessor"></span>
<a name="l00396"></a>00396 <span class="preprocessor">#if LIBMESH_DIM == 2 </span>
<a name="l00397"></a>00397 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeVector.php">TypeVector&lt;TS&gt;</a> (<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] + p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[0],
<a name="l00398"></a>00398                          <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] + p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[1]);
<a name="l00399"></a>00399 <span class="preprocessor">#endif</span>
<a name="l00400"></a>00400 <span class="preprocessor"></span>
<a name="l00401"></a>00401 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00402"></a>00402 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeVector.php">TypeVector&lt;TS&gt;</a> (<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] + p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[0],
<a name="l00403"></a>00403                          <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] + p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[1],
<a name="l00404"></a>00404                          <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2] + p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[2]);
<a name="l00405"></a>00405 <span class="preprocessor">#endif</span>
<a name="l00406"></a>00406 <span class="preprocessor"></span>               
<a name="l00407"></a>00407 }
<a name="l00408"></a>00408 
<a name="l00409"></a>00409 
<a name="l00410"></a>00410 
<a name="l00411"></a>00411 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00412"></a>00412 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00413"></a>00413 <span class="keyword">inline</span>
<a name="l00414"></a><a class="code" href="classTypeVector.php#a56be7f0511129be1c89859ae75ac9e28">00414</a> <span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a> &amp; <a class="code" href="classTypeVector.php#a56be7f0511129be1c89859ae75ac9e28">TypeVector&lt;T&gt;::operator += </a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;p)
<a name="l00415"></a>00415 {
<a name="l00416"></a>00416   this-&gt;<a class="code" href="classTypeTensor.php#ac926eb12156c30a8475d1a6565fdaefb">add</a> (p);
<a name="l00417"></a>00417 
<a name="l00418"></a>00418   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00419"></a>00419 }
<a name="l00420"></a>00420 
<a name="l00421"></a>00421 
<a name="l00422"></a>00422 
<a name="l00423"></a>00423 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00424"></a>00424 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00425"></a>00425 <span class="keyword">inline</span>
<a name="l00426"></a><a class="code" href="classTypeVector.php#a5a491e5c665118253b6e2f65141c8922">00426</a> <span class="keywordtype">void</span> <a class="code" href="classTypeVector.php#a5a491e5c665118253b6e2f65141c8922">TypeVector&lt;T&gt;::add</a> (<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;p)
<a name="l00427"></a>00427 {
<a name="l00428"></a>00428 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00429"></a>00429 <span class="preprocessor"></span>  <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] += p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[0];
<a name="l00430"></a>00430 <span class="preprocessor">#endif</span>
<a name="l00431"></a>00431 <span class="preprocessor"></span>  
<a name="l00432"></a>00432 <span class="preprocessor">#if LIBMESH_DIM == 2</span>
<a name="l00433"></a>00433 <span class="preprocessor"></span>  <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] += p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[0];
<a name="l00434"></a>00434   <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] += p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[1];
<a name="l00435"></a>00435 <span class="preprocessor">#endif</span>
<a name="l00436"></a>00436 <span class="preprocessor"></span>  
<a name="l00437"></a>00437 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00438"></a>00438 <span class="preprocessor"></span>  <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] += p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[0];
<a name="l00439"></a>00439   <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] += p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[1];
<a name="l00440"></a>00440   <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2] += p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[2];
<a name="l00441"></a>00441 <span class="preprocessor">#endif</span>
<a name="l00442"></a>00442 <span class="preprocessor"></span>
<a name="l00443"></a>00443 }
<a name="l00444"></a>00444 
<a name="l00445"></a>00445 
<a name="l00446"></a>00446 
<a name="l00447"></a>00447 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00448"></a>00448 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00449"></a>00449 <span class="keyword">inline</span>
<a name="l00450"></a><a class="code" href="classTypeVector.php#ac9000695cb19991b893cb79a07249e9c">00450</a> <span class="keywordtype">void</span> <a class="code" href="classTypeVector.php#ac9000695cb19991b893cb79a07249e9c">TypeVector&lt;T&gt;::add_scaled</a> (<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;p, <span class="keyword">const</span> T factor)
<a name="l00451"></a>00451 {
<a name="l00452"></a>00452 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00453"></a>00453 <span class="preprocessor"></span>  <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] += factor*p(0);
<a name="l00454"></a>00454 <span class="preprocessor">#endif</span>
<a name="l00455"></a>00455 <span class="preprocessor"></span>  
<a name="l00456"></a>00456 <span class="preprocessor">#if LIBMESH_DIM == 2</span>
<a name="l00457"></a>00457 <span class="preprocessor"></span>  <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] += factor*p(0);
<a name="l00458"></a>00458   <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] += factor*p(1);
<a name="l00459"></a>00459 <span class="preprocessor">#endif</span>
<a name="l00460"></a>00460 <span class="preprocessor"></span>  
<a name="l00461"></a>00461 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00462"></a>00462 <span class="preprocessor"></span>  <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] += factor*p(0);
<a name="l00463"></a>00463   <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] += factor*p(1);
<a name="l00464"></a>00464   <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2] += factor*p(2);
<a name="l00465"></a>00465 <span class="preprocessor">#endif</span>
<a name="l00466"></a>00466 <span class="preprocessor"></span>
<a name="l00467"></a>00467 }
<a name="l00468"></a>00468 
<a name="l00469"></a>00469 
<a name="l00470"></a>00470 
<a name="l00471"></a>00471 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00472"></a>00472 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00473"></a>00473 <span class="keyword">inline</span>
<a name="l00474"></a>00474 <a class="code" href="classTypeVector.php">TypeVector&lt;typename CompareTypes&lt;T, T2&gt;::supertype</a>&gt; 
<a name="l00475"></a><a class="code" href="classTypeVector.php#aedaf5b743112436992b29c84dc283062">00475</a> <a class="code" href="classTypeVector.php#a8d2b0f39d0a3bbc8f7a8f23262ce69f5">TypeVector&lt;T&gt;::operator - </a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;p)<span class="keyword"> const</span>
<a name="l00476"></a>00476 <span class="keyword"></span>{
<a name="l00477"></a>00477   <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="structCompareTypes.php#a84d86a45868b9861ae413d884c0bedc2">CompareTypes&lt;T, T2&gt;::supertype</a> TS;
<a name="l00478"></a>00478 
<a name="l00479"></a>00479 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00480"></a>00480 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeVector.php">TypeVector&lt;TS&gt;</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] - p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[0]);
<a name="l00481"></a>00481 <span class="preprocessor">#endif</span>
<a name="l00482"></a>00482 <span class="preprocessor"></span>
<a name="l00483"></a>00483 <span class="preprocessor">#if LIBMESH_DIM == 2 </span>
<a name="l00484"></a>00484 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeVector.php">TypeVector&lt;TS&gt;</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] - p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[0],
<a name="l00485"></a>00485                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] - p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[1]);
<a name="l00486"></a>00486 <span class="preprocessor">#endif</span>
<a name="l00487"></a>00487 <span class="preprocessor"></span>
<a name="l00488"></a>00488 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00489"></a>00489 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeVector.php">TypeVector&lt;TS&gt;</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] - p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[0],
<a name="l00490"></a>00490                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] - p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[1],
<a name="l00491"></a>00491                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2] - p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[2]);
<a name="l00492"></a>00492 <span class="preprocessor">#endif</span>
<a name="l00493"></a>00493 <span class="preprocessor"></span>
<a name="l00494"></a>00494 }
<a name="l00495"></a>00495 
<a name="l00496"></a>00496 
<a name="l00497"></a>00497 
<a name="l00498"></a>00498 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00499"></a>00499 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00500"></a>00500 <span class="keyword">inline</span>
<a name="l00501"></a><a class="code" href="classTypeVector.php#adbfd6a05a4a5c2fe7c779587b7678350">00501</a> <span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a> &amp; <a class="code" href="classTypeVector.php#adbfd6a05a4a5c2fe7c779587b7678350">TypeVector&lt;T&gt;::operator -= </a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;p)
<a name="l00502"></a>00502 {
<a name="l00503"></a>00503   this-&gt;<a class="code" href="classTypeTensor.php#ac38c3b5489ef76fe4aa152a6f435c3e2">subtract</a> (p);
<a name="l00504"></a>00504 
<a name="l00505"></a>00505   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00506"></a>00506 }
<a name="l00507"></a>00507 
<a name="l00508"></a>00508 
<a name="l00509"></a>00509 
<a name="l00510"></a>00510 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00511"></a>00511 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00512"></a>00512 <span class="keyword">inline</span>
<a name="l00513"></a><a class="code" href="classTypeVector.php#a5a369299b2cd40554e3d38a1365e0e70">00513</a> <span class="keywordtype">void</span> <a class="code" href="classTypeVector.php#a5a369299b2cd40554e3d38a1365e0e70">TypeVector&lt;T&gt;::subtract</a> (<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a>&amp; p)
<a name="l00514"></a>00514 {
<a name="l00515"></a>00515   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00516"></a>00516     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i] -= p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[i];
<a name="l00517"></a>00517 }
<a name="l00518"></a>00518 
<a name="l00519"></a>00519 
<a name="l00520"></a>00520 
<a name="l00521"></a>00521 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00522"></a>00522 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00523"></a>00523 <span class="keyword">inline</span>
<a name="l00524"></a><a class="code" href="classTypeVector.php#a94b16f15ba75d265bf83e9a50d9fd63b">00524</a> <span class="keywordtype">void</span> <a class="code" href="classTypeVector.php#a94b16f15ba75d265bf83e9a50d9fd63b">TypeVector&lt;T&gt;::subtract_scaled</a> (<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;p, <span class="keyword">const</span> T factor)
<a name="l00525"></a>00525 {
<a name="l00526"></a>00526   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00527"></a>00527     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i] -= factor*p(i);
<a name="l00528"></a>00528 }
<a name="l00529"></a>00529 
<a name="l00530"></a>00530 
<a name="l00531"></a>00531 
<a name="l00532"></a>00532 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00533"></a>00533 <span class="keyword">inline</span>
<a name="l00534"></a><a class="code" href="classTypeVector.php#a8d2b0f39d0a3bbc8f7a8f23262ce69f5">00534</a> <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a> <a class="code" href="classTypeVector.php#a8d2b0f39d0a3bbc8f7a8f23262ce69f5">TypeVector&lt;T&gt;::operator - </a>()<span class="keyword"> const</span>
<a name="l00535"></a>00535 <span class="keyword"></span>{
<a name="l00536"></a>00536   
<a name="l00537"></a>00537 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00538"></a>00538 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeVector.php">TypeVector</a>(-<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]);
<a name="l00539"></a>00539 <span class="preprocessor">#endif</span>
<a name="l00540"></a>00540 <span class="preprocessor"></span>
<a name="l00541"></a>00541 <span class="preprocessor">#if LIBMESH_DIM == 2 </span>
<a name="l00542"></a>00542 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeVector.php">TypeVector</a>(-<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0],
<a name="l00543"></a>00543                     -<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1]);
<a name="l00544"></a>00544 <span class="preprocessor">#endif</span>
<a name="l00545"></a>00545 <span class="preprocessor"></span>
<a name="l00546"></a>00546 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00547"></a>00547 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeVector.php">TypeVector</a>(-<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0],
<a name="l00548"></a>00548                     -<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1], 
<a name="l00549"></a>00549                     -<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2]);
<a name="l00550"></a>00550 <span class="preprocessor">#endif</span>
<a name="l00551"></a>00551 <span class="preprocessor"></span>  
<a name="l00552"></a>00552 }
<a name="l00553"></a>00553 
<a name="l00554"></a>00554 
<a name="l00555"></a>00555 
<a name="l00556"></a>00556 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00557"></a>00557 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Scalar&gt;
<a name="l00558"></a>00558 <span class="keyword">inline</span>
<a name="l00559"></a>00559 <span class="keyword">typename</span> <a class="code" href="structboostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00560"></a>00560   <a class="code" href="structScalarTraits.php">ScalarTraits&lt;Scalar&gt;::value</a>,
<a name="l00561"></a>00561   <a class="code" href="classTypeVector.php">TypeVector&lt;typename CompareTypes&lt;T, Scalar&gt;::supertype</a>&gt; &gt;::type
<a name="l00562"></a><a class="code" href="classTypeVector.php#a6b3e0d1495c5d7e7c58a96af0a93bdd0">00562</a> <a class="code" href="classTypeVector.php#a6b3e0d1495c5d7e7c58a96af0a93bdd0">TypeVector&lt;T&gt;::operator * </a>(<span class="keyword">const</span> Scalar factor)<span class="keyword"> const</span>
<a name="l00563"></a>00563 <span class="keyword"></span>{
<a name="l00564"></a>00564   <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="structCompareTypes.php#a84d86a45868b9861ae413d884c0bedc2">CompareTypes&lt;T, Scalar&gt;::supertype</a> TS;
<a name="l00565"></a>00565 
<a name="l00566"></a>00566 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00567"></a>00567 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeVector.php">TypeVector&lt;TS&gt;</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]*factor);
<a name="l00568"></a>00568 <span class="preprocessor">#endif</span>
<a name="l00569"></a>00569 <span class="preprocessor"></span>  
<a name="l00570"></a>00570 <span class="preprocessor">#if LIBMESH_DIM == 2 </span>
<a name="l00571"></a>00571 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeVector.php">TypeVector&lt;TS&gt;</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]*factor,
<a name="l00572"></a>00572                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1]*factor);
<a name="l00573"></a>00573 <span class="preprocessor">#endif</span>
<a name="l00574"></a>00574 <span class="preprocessor"></span>  
<a name="l00575"></a>00575 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00576"></a>00576 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeVector.php">TypeVector&lt;TS&gt;</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]*factor,
<a name="l00577"></a>00577                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1]*factor, 
<a name="l00578"></a>00578                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2]*factor);
<a name="l00579"></a>00579 <span class="preprocessor">#endif  </span>
<a name="l00580"></a>00580 <span class="preprocessor"></span>}
<a name="l00581"></a>00581 
<a name="l00582"></a>00582 
<a name="l00583"></a>00583 
<a name="l00584"></a>00584 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> Scalar&gt;
<a name="l00585"></a>00585 <span class="keyword">inline</span>
<a name="l00586"></a>00586 <span class="keyword">typename</span> <a class="code" href="structboostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00587"></a>00587   ScalarTraits&lt;Scalar&gt;::value,
<a name="l00588"></a>00588   <a class="code" href="classTypeVector.php">TypeVector&lt;typename CompareTypes&lt;T, Scalar&gt;::supertype</a>&gt; &gt;::type
<a name="l00589"></a><a class="code" href="type__vector_8h.php#ab6e9ce26544944d7a0d07fb5fdf221e1">00589</a> <a class="code" href="type__tensor_8h.php#a529f0725b8766b811e4681bfd79b124f">operator * </a>(<span class="keyword">const</span> Scalar factor,
<a name="l00590"></a>00590             <span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a> &amp;v)
<a name="l00591"></a>00591 {
<a name="l00592"></a>00592   <span class="keywordflow">return</span> v * factor;
<a name="l00593"></a>00593 }
<a name="l00594"></a>00594 
<a name="l00595"></a>00595 
<a name="l00596"></a>00596 
<a name="l00597"></a>00597 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00598"></a>00598 <span class="keyword">inline</span>
<a name="l00599"></a><a class="code" href="classTypeVector.php#accb3ce86415e5b80a2d18453a8a6059d">00599</a> <span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a> &amp; <a class="code" href="classTypeVector.php#accb3ce86415e5b80a2d18453a8a6059d">TypeVector&lt;T&gt;::operator *= </a>(<span class="keyword">const</span> T factor)
<a name="l00600"></a>00600 {
<a name="l00601"></a>00601 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00602"></a>00602 <span class="preprocessor"></span>  <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] *= factor;
<a name="l00603"></a>00603 <span class="preprocessor">#endif</span>
<a name="l00604"></a>00604 <span class="preprocessor"></span>  
<a name="l00605"></a>00605 <span class="preprocessor">#if LIBMESH_DIM == 2</span>
<a name="l00606"></a>00606 <span class="preprocessor"></span>  <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] *= factor;
<a name="l00607"></a>00607   <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] *= factor;
<a name="l00608"></a>00608 <span class="preprocessor">#endif</span>
<a name="l00609"></a>00609 <span class="preprocessor"></span>  
<a name="l00610"></a>00610 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00611"></a>00611 <span class="preprocessor"></span>  <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] *= factor;
<a name="l00612"></a>00612   <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] *= factor;
<a name="l00613"></a>00613   <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2] *= factor;
<a name="l00614"></a>00614 <span class="preprocessor">#endif</span>
<a name="l00615"></a>00615 <span class="preprocessor"></span>
<a name="l00616"></a>00616   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00617"></a>00617 }
<a name="l00618"></a>00618 
<a name="l00619"></a>00619 
<a name="l00620"></a>00620 
<a name="l00621"></a>00621 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00622"></a>00622 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Scalar&gt;
<a name="l00623"></a>00623 <span class="keyword">inline</span>
<a name="l00624"></a>00624 <span class="keyword">typename</span> <a class="code" href="structboostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00625"></a>00625   ScalarTraits&lt;Scalar&gt;::value,
<a name="l00626"></a>00626   <a class="code" href="classTypeVector.php">TypeVector&lt;typename CompareTypes&lt;T, Scalar&gt;::supertype</a>&gt; &gt;::type
<a name="l00627"></a><a class="code" href="classTypeVector.php#ac59d7d2da90b1c5b387d60379e087d6c">00627</a> <a class="code" href="classTypeVector.php#ac59d7d2da90b1c5b387d60379e087d6c">TypeVector&lt;T&gt;::operator / </a>(<span class="keyword">const</span> Scalar factor)<span class="keyword"> const</span>
<a name="l00628"></a>00628 <span class="keyword"></span>{
<a name="l00629"></a>00629   libmesh_assert (factor != static_cast&lt;T&gt;(0.));
<a name="l00630"></a>00630 
<a name="l00631"></a>00631   <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="structCompareTypes.php#a84d86a45868b9861ae413d884c0bedc2">CompareTypes&lt;T, Scalar&gt;::supertype</a> TS;
<a name="l00632"></a>00632   
<a name="l00633"></a>00633 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00634"></a>00634 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeVector.php">TypeVector&lt;TS&gt;</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]/factor);
<a name="l00635"></a>00635 <span class="preprocessor">#endif</span>
<a name="l00636"></a>00636 <span class="preprocessor"></span>  
<a name="l00637"></a>00637 <span class="preprocessor">#if LIBMESH_DIM == 2 </span>
<a name="l00638"></a>00638 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeVector.php">TypeVector&lt;TS&gt;</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]/factor,
<a name="l00639"></a>00639                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1]/factor);
<a name="l00640"></a>00640 <span class="preprocessor">#endif</span>
<a name="l00641"></a>00641 <span class="preprocessor"></span>  
<a name="l00642"></a>00642 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00643"></a>00643 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeVector.php">TypeVector&lt;TS&gt;</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]/factor,
<a name="l00644"></a>00644                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1]/factor, 
<a name="l00645"></a>00645                         <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2]/factor);
<a name="l00646"></a>00646 <span class="preprocessor">#endif</span>
<a name="l00647"></a>00647 <span class="preprocessor"></span>  
<a name="l00648"></a>00648 }
<a name="l00649"></a>00649 
<a name="l00650"></a>00650 
<a name="l00651"></a>00651 
<a name="l00652"></a>00652 
<a name="l00653"></a>00653 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00654"></a>00654 <span class="keyword">inline</span>
<a name="l00655"></a>00655 <span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a> &amp;
<a name="l00656"></a><a class="code" href="classTypeVector.php#a23c5809e93f8fc4adc9965c2db2fe8df">00656</a> <a class="code" href="classTypeVector.php#a23c5809e93f8fc4adc9965c2db2fe8df">TypeVector&lt;T&gt;::operator /= </a>(<span class="keyword">const</span> T factor)
<a name="l00657"></a>00657 {
<a name="l00658"></a>00658   libmesh_assert (factor != static_cast&lt;T&gt;(0.));
<a name="l00659"></a>00659   
<a name="l00660"></a>00660   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00661"></a>00661     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i] /= factor;
<a name="l00662"></a>00662 
<a name="l00663"></a>00663   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00664"></a>00664 }
<a name="l00665"></a>00665 
<a name="l00666"></a>00666 
<a name="l00667"></a>00667 
<a name="l00668"></a>00668 
<a name="l00669"></a>00669 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00670"></a>00670 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00671"></a>00671 <span class="keyword">inline</span>
<a name="l00672"></a>00672 <span class="keyword">typename</span> <a class="code" href="structCompareTypes.php#a84d86a45868b9861ae413d884c0bedc2">CompareTypes&lt;T, T2&gt;::supertype</a>
<a name="l00673"></a><a class="code" href="classTypeVector.php#a715aff36e4ec64a8466fc35bfbd92c8b">00673</a> <a class="code" href="classTypeVector.php#a6b3e0d1495c5d7e7c58a96af0a93bdd0">TypeVector&lt;T&gt;::operator * </a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a> &amp;p)<span class="keyword"> const</span>
<a name="l00674"></a>00674 <span class="keyword"></span>{
<a name="l00675"></a>00675 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00676"></a>00676 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]*p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[0];
<a name="l00677"></a>00677 <span class="preprocessor">#endif</span>
<a name="l00678"></a>00678 <span class="preprocessor"></span>  
<a name="l00679"></a>00679 <span class="preprocessor">#if LIBMESH_DIM == 2</span>
<a name="l00680"></a>00680 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]*p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[0] +
<a name="l00681"></a>00681           <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1]*p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[1]);
<a name="l00682"></a>00682 <span class="preprocessor">#endif</span>
<a name="l00683"></a>00683 <span class="preprocessor"></span>  
<a name="l00684"></a>00684 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00685"></a>00685 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]*p(0) +
<a name="l00686"></a>00686           <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1]*p(1) +
<a name="l00687"></a>00687           <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2]*p(2));
<a name="l00688"></a>00688 <span class="preprocessor">#endif</span>
<a name="l00689"></a>00689 <span class="preprocessor"></span>}
<a name="l00690"></a>00690 
<a name="l00691"></a>00691 
<a name="l00692"></a>00692 
<a name="l00693"></a>00693 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00694"></a>00694 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00695"></a>00695 <a class="code" href="classTypeVector.php">TypeVector&lt;typename CompareTypes&lt;T, T2&gt;::supertype</a>&gt;
<a name="l00696"></a><a class="code" href="classTypeVector.php#a1347e1223f3e31f8a2c0496736e60dc5">00696</a> <a class="code" href="classTypeVector.php#a1347e1223f3e31f8a2c0496736e60dc5">TypeVector&lt;T&gt;::cross</a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a>&amp; p)<span class="keyword"> const</span>
<a name="l00697"></a>00697 <span class="keyword"></span>{
<a name="l00698"></a>00698   <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="structCompareTypes.php#a84d86a45868b9861ae413d884c0bedc2">CompareTypes&lt;T, T2&gt;::supertype</a> TS;
<a name="l00699"></a>00699   libmesh_assert (LIBMESH_DIM == 3);
<a name="l00700"></a>00700 
<a name="l00701"></a>00701   <span class="comment">// |     i          j          k    |</span>
<a name="l00702"></a>00702   <span class="comment">// |(*this)(0) (*this)(1) (*this)(2)|</span>
<a name="l00703"></a>00703   <span class="comment">// |   p(0)       p(1)       p(2)   |</span>
<a name="l00704"></a>00704 
<a name="l00705"></a>00705   <span class="keywordflow">return</span> <a class="code" href="classTypeVector.php">TypeVector&lt;TS&gt;</a>( <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1]*p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[2] - <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2]*p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[1],
<a name="l00706"></a>00706                         -<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]*p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[2] + <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2]*p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[0],
<a name="l00707"></a>00707                          <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]*p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[1] - <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1]*p.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[0]);
<a name="l00708"></a>00708 }
<a name="l00709"></a>00709 
<a name="l00710"></a>00710 
<a name="l00711"></a>00711 
<a name="l00712"></a>00712 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00713"></a>00713 <span class="keyword">inline</span>
<a name="l00714"></a><a class="code" href="classTypeVector.php#a34f47a12e12990aad2910a934bdaac7d">00714</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classTypeVector.php#a34f47a12e12990aad2910a934bdaac7d">TypeVector&lt;T&gt;::size</a>()<span class="keyword"> const</span>
<a name="l00715"></a>00715 <span class="keyword"></span>{
<a name="l00716"></a>00716   <span class="keywordflow">return</span> std::sqrt(this-&gt;<a class="code" href="classTypeTensor.php#a7be64b1de5e558f2de032bde1f881220">size_sq</a>());  
<a name="l00717"></a>00717 }
<a name="l00718"></a>00718 
<a name="l00719"></a>00719 
<a name="l00720"></a>00720 
<a name="l00721"></a>00721 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00722"></a>00722 <span class="keyword">inline</span>
<a name="l00723"></a><a class="code" href="classTypeVector.php#a0e8a26593313d8978082ff6f4084fdd5">00723</a> <span class="keywordtype">void</span> <a class="code" href="classTypeVector.php#a0e8a26593313d8978082ff6f4084fdd5">TypeVector&lt;T&gt;::zero</a>()
<a name="l00724"></a>00724 {
<a name="l00725"></a>00725   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00726"></a>00726     <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[i] = 0.;
<a name="l00727"></a>00727 }
<a name="l00728"></a>00728 
<a name="l00729"></a>00729 
<a name="l00730"></a>00730 
<a name="l00731"></a>00731 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00732"></a>00732 <span class="keyword">inline</span>
<a name="l00733"></a><a class="code" href="classTypeVector.php#a099aac580a3a6fce9276cf5443d0c0e9">00733</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classTypeVector.php#a099aac580a3a6fce9276cf5443d0c0e9">TypeVector&lt;T&gt;::size_sq</a>()<span class="keyword"> const</span>
<a name="l00734"></a>00734 <span class="keyword"></span>{
<a name="l00735"></a>00735 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00736"></a>00736 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (<a class="code" href="libmesh__common_8h.php#af9cdd07341b53cc644199f6aec5e1420">libmesh_norm</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]));
<a name="l00737"></a>00737 <span class="preprocessor">#endif</span>
<a name="l00738"></a>00738 <span class="preprocessor"></span>  
<a name="l00739"></a>00739 <span class="preprocessor">#if LIBMESH_DIM == 2</span>
<a name="l00740"></a>00740 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (<a class="code" href="libmesh__common_8h.php#af9cdd07341b53cc644199f6aec5e1420">libmesh_norm</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]) +
<a name="l00741"></a>00741           <a class="code" href="libmesh__common_8h.php#af9cdd07341b53cc644199f6aec5e1420">libmesh_norm</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1]));
<a name="l00742"></a>00742 <span class="preprocessor">#endif</span>
<a name="l00743"></a>00743 <span class="preprocessor"></span>  
<a name="l00744"></a>00744 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00745"></a>00745 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (<a class="code" href="libmesh__common_8h.php#af9cdd07341b53cc644199f6aec5e1420">libmesh_norm</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]) +
<a name="l00746"></a>00746           <a class="code" href="libmesh__common_8h.php#af9cdd07341b53cc644199f6aec5e1420">libmesh_norm</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1]) + 
<a name="l00747"></a>00747           <a class="code" href="libmesh__common_8h.php#af9cdd07341b53cc644199f6aec5e1420">libmesh_norm</a>(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2]));
<a name="l00748"></a>00748 <span class="preprocessor">#endif</span>
<a name="l00749"></a>00749 <span class="preprocessor"></span>}
<a name="l00750"></a>00750 
<a name="l00751"></a>00751 
<a name="l00752"></a>00752 
<a name="l00753"></a>00753 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00754"></a>00754 <span class="keyword">inline</span>
<a name="l00755"></a><a class="code" href="classTypeVector.php#af1c18b620df014bd558bc19972613a2b">00755</a> <span class="keywordtype">bool</span> <a class="code" href="classTypeVector.php#af1c18b620df014bd558bc19972613a2b">TypeVector&lt;T&gt;::absolute_fuzzy_equals</a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a>&amp; rhs, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tol)<span class="keyword"> const</span>
<a name="l00756"></a>00756 <span class="keyword"></span>{
<a name="l00757"></a>00757 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00758"></a>00758 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] - rhs.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[0])
<a name="l00759"></a>00759           &lt;= tol);
<a name="l00760"></a>00760 <span class="preprocessor">#endif</span>
<a name="l00761"></a>00761 <span class="preprocessor"></span>
<a name="l00762"></a>00762 <span class="preprocessor">#if LIBMESH_DIM == 2</span>
<a name="l00763"></a>00763 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] - rhs.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[0]) +
<a name="l00764"></a>00764           std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] - rhs.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[1])
<a name="l00765"></a>00765           &lt;= tol);
<a name="l00766"></a>00766 <span class="preprocessor">#endif</span>
<a name="l00767"></a>00767 <span class="preprocessor"></span>
<a name="l00768"></a>00768 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00769"></a>00769 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] - rhs.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[0]) +
<a name="l00770"></a>00770           std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] - rhs.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[1]) +
<a name="l00771"></a>00771           std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2] - rhs.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[2])
<a name="l00772"></a>00772           &lt;= tol);
<a name="l00773"></a>00773 <span class="preprocessor">#endif</span>
<a name="l00774"></a>00774 <span class="preprocessor"></span>}
<a name="l00775"></a>00775 
<a name="l00776"></a>00776 
<a name="l00777"></a>00777 
<a name="l00778"></a>00778 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00779"></a>00779 <span class="keyword">inline</span>
<a name="l00780"></a><a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">00780</a> <span class="keywordtype">bool</span> <a class="code" href="classTypeVector.php#a9e546c43d2ebc072b0e4b788ff53756c">TypeVector&lt;T&gt;::relative_fuzzy_equals</a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a>&amp; rhs, <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tol)<span class="keyword"> const</span>
<a name="l00781"></a>00781 <span class="keyword"></span>{
<a name="l00782"></a>00782 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00783"></a>00783 <span class="preprocessor"></span>  <span class="keywordflow">return</span> this-&gt;absolute_fuzzy_equals(rhs, tol *
<a name="l00784"></a>00784                                      (std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]) + std::abs(rhs.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[0])));
<a name="l00785"></a>00785 <span class="preprocessor">#endif</span>
<a name="l00786"></a>00786 <span class="preprocessor"></span>
<a name="l00787"></a>00787 <span class="preprocessor">#if LIBMESH_DIM == 2</span>
<a name="l00788"></a>00788 <span class="preprocessor"></span>  <span class="keywordflow">return</span> this-&gt;absolute_fuzzy_equals(rhs, tol * 
<a name="l00789"></a>00789                                      (std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]) + std::abs(rhs.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[0]) +
<a name="l00790"></a>00790                                       std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1]) + std::abs(rhs.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[1])));
<a name="l00791"></a>00791 <span class="preprocessor">#endif</span>
<a name="l00792"></a>00792 <span class="preprocessor"></span>
<a name="l00793"></a>00793 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00794"></a>00794 <span class="preprocessor"></span>  <span class="keywordflow">return</span> this-&gt;absolute_fuzzy_equals(rhs, tol *
<a name="l00795"></a>00795                                      (std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0]) + std::abs(rhs.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[0]) +
<a name="l00796"></a>00796                                       std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1]) + std::abs(rhs.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[1]) +
<a name="l00797"></a>00797                                       std::abs(<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2]) + std::abs(rhs.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[2])));
<a name="l00798"></a>00798 <span class="preprocessor">#endif</span>
<a name="l00799"></a>00799 <span class="preprocessor"></span>}
<a name="l00800"></a>00800 
<a name="l00801"></a>00801 
<a name="l00802"></a>00802 
<a name="l00803"></a>00803 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00804"></a>00804 <span class="keyword">inline</span>
<a name="l00805"></a><a class="code" href="classTypeVector.php#ac05e55902795911cd87e7ebe46b3e819">00805</a> <span class="keywordtype">bool</span> <a class="code" href="classTypeVector.php#ac05e55902795911cd87e7ebe46b3e819">TypeVector&lt;T&gt;::operator == </a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T&gt;</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00806"></a>00806 <span class="keyword"></span>{
<a name="l00807"></a>00807 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00808"></a>00808 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] == rhs.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[0]);
<a name="l00809"></a>00809 <span class="preprocessor">#endif</span>
<a name="l00810"></a>00810 <span class="preprocessor"></span>
<a name="l00811"></a>00811 <span class="preprocessor">#if LIBMESH_DIM == 2</span>
<a name="l00812"></a>00812 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] == rhs.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[0] &amp;&amp;
<a name="l00813"></a>00813           <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] == rhs.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[1]);
<a name="l00814"></a>00814 <span class="preprocessor">#endif</span>
<a name="l00815"></a>00815 <span class="preprocessor"></span>
<a name="l00816"></a>00816 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00817"></a>00817 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (<a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[0] == rhs.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[0] &amp;&amp;
<a name="l00818"></a>00818           <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[1] == rhs.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[1] &amp;&amp;
<a name="l00819"></a>00819           <a class="code" href="classTypeTensor.php#aca5a18cd4eaf66a16346de0230bdaff9">_coords</a>[2] == rhs.<a class="code" href="classTypeVector.php#a72ee6444331385ae7a15b8f74b091754">_coords</a>[2]);
<a name="l00820"></a>00820 <span class="preprocessor">#endif</span>
<a name="l00821"></a>00821 <span class="preprocessor"></span>}
<a name="l00822"></a>00822 
<a name="l00823"></a>00823 
<a name="l00824"></a>00824 
<a name="l00825"></a>00825 <span class="keyword">template</span> &lt;&gt;
<a name="l00826"></a>00826 <span class="keyword">inline</span>
<a name="l00827"></a><a class="code" href="classTypeVector.php#ac83e3752e1908c64b6e329a7c50d778b">00827</a> <span class="keywordtype">bool</span> <a class="code" href="classTypeVector.php#ac83e3752e1908c64b6e329a7c50d778b">TypeVector&lt;Real&gt;::operator != </a>(<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;Real&gt;</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00828"></a>00828 <span class="keyword"></span>{
<a name="l00829"></a>00829   <span class="keywordflow">return</span> (!(*<span class="keyword">this</span> == rhs));
<a name="l00830"></a>00830 }
<a name="l00831"></a>00831 
<a name="l00832"></a>00832 <span class="preprocessor">#endif // #define __type_vector_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
