<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_570b8306c88722caf9b7ae131e1a07b6.php">error_estimation</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>uniform_refinement_estimator.C</h1>  </div>
</div>
<div class="contents">
<a href="uniform__refinement__estimator_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: uniform_refinement_estimator.C 3503 2009-10-21 15:31:03Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// C++ includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::fill</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;cmath&gt;</span>    <span class="comment">// for sqrt</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local Includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;dof_map.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;equation_systems.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;error_vector.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;fe.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;fe_interface.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;mesh.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;mesh_refinement.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;quadrature.h&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;system.h&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;uniform_refinement_estimator.h&quot;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span>
<a name="l00043"></a>00043 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00044"></a>00044 <span class="comment">// ErrorEstimator implementations</span>
<a name="l00045"></a><a class="code" href="classUniformRefinementEstimator.php#a359f8eb946eb1d0c07958210db88357e">00045</a> <span class="keywordtype">void</span> <a class="code" href="classUniformRefinementEstimator.php#a359f8eb946eb1d0c07958210db88357e">UniformRefinementEstimator::estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; _system,
<a name="l00046"></a>00046                                                  <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00047"></a>00047                                                  <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector,
<a name="l00048"></a>00048                                                  <span class="keywordtype">bool</span> estimate_parent_error)
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050   START_LOG(<span class="stringliteral">&quot;estimate_error()&quot;</span>, <span class="stringliteral">&quot;UniformRefinementEstimator&quot;</span>);
<a name="l00051"></a>00051   std::map&lt;const System*, const NumericVector&lt;Number&gt;* &gt; solution_vectors;
<a name="l00052"></a>00052   solution_vectors[&amp;_system] = solution_vector;
<a name="l00053"></a>00053   this-&gt;<a class="code" href="classUniformRefinementEstimator.php#af952e291ea60c090873a49156a26f1f7">_estimate_error</a> (NULL, &amp;_system, &amp;error_per_cell, NULL, NULL,
<a name="l00054"></a>00054                          &amp;solution_vectors, estimate_parent_error);
<a name="l00055"></a>00055   STOP_LOG(<span class="stringliteral">&quot;estimate_error()&quot;</span>, <span class="stringliteral">&quot;UniformRefinementEstimator&quot;</span>);
<a name="l00056"></a>00056 }
<a name="l00057"></a>00057 
<a name="l00058"></a><a class="code" href="classUniformRefinementEstimator.php#a62241e99a743dcf9c0918ed405757f30">00058</a> <span class="keywordtype">void</span> <a class="code" href="classUniformRefinementEstimator.php#a62241e99a743dcf9c0918ed405757f30">UniformRefinementEstimator::estimate_errors</a> (<span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; _es,
<a name="l00059"></a>00059                                                  <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00060"></a>00060                                                  <span class="keyword">const</span> std::map&lt;const System*, SystemNorm&gt;&amp; error_norms,
<a name="l00061"></a>00061                                                  <span class="keyword">const</span> std::map&lt;<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>*, <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* &gt;* solution_vectors,
<a name="l00062"></a>00062                                                  <span class="keywordtype">bool</span> estimate_parent_error)
<a name="l00063"></a>00063 {
<a name="l00064"></a>00064   START_LOG(<span class="stringliteral">&quot;estimate_errors()&quot;</span>, <span class="stringliteral">&quot;UniformRefinementEstimator&quot;</span>);
<a name="l00065"></a>00065   this-&gt;<a class="code" href="classUniformRefinementEstimator.php#af952e291ea60c090873a49156a26f1f7">_estimate_error</a> (&amp;_es, NULL, &amp;error_per_cell, NULL,
<a name="l00066"></a>00066                          &amp;error_norms, solution_vectors,
<a name="l00067"></a>00067                          estimate_parent_error);
<a name="l00068"></a>00068   STOP_LOG(<span class="stringliteral">&quot;estimate_errors()&quot;</span>, <span class="stringliteral">&quot;UniformRefinementEstimator&quot;</span>);
<a name="l00069"></a>00069 }
<a name="l00070"></a>00070 
<a name="l00071"></a><a class="code" href="classUniformRefinementEstimator.php#a12bf6fb5f53290a6fa7b2242995bab47">00071</a> <span class="keywordtype">void</span> <a class="code" href="classUniformRefinementEstimator.php#a62241e99a743dcf9c0918ed405757f30">UniformRefinementEstimator::estimate_errors</a> (<span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; _es,
<a name="l00072"></a>00072                                                   <a class="code" href="classErrorEstimator.php#a355a4dd519a02dca211c653b239dc597">ErrorMap</a>&amp; errors_per_cell,
<a name="l00073"></a>00073                                                   <span class="keyword">const</span> std::map&lt;<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>*, <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* &gt;* solution_vectors,
<a name="l00074"></a>00074                                                   <span class="keywordtype">bool</span> estimate_parent_error)
<a name="l00075"></a>00075 {
<a name="l00076"></a>00076   START_LOG(<span class="stringliteral">&quot;estimate_errors()&quot;</span>, <span class="stringliteral">&quot;UniformRefinementEstimator&quot;</span>);
<a name="l00077"></a>00077   this-&gt;<a class="code" href="classUniformRefinementEstimator.php#af952e291ea60c090873a49156a26f1f7">_estimate_error</a> (&amp;_es, NULL, NULL, &amp;errors_per_cell, NULL,
<a name="l00078"></a>00078                          solution_vectors, estimate_parent_error);
<a name="l00079"></a>00079   STOP_LOG(<span class="stringliteral">&quot;estimate_errors()&quot;</span>, <span class="stringliteral">&quot;UniformRefinementEstimator&quot;</span>);
<a name="l00080"></a>00080 }
<a name="l00081"></a>00081 
<a name="l00082"></a><a class="code" href="classUniformRefinementEstimator.php#af952e291ea60c090873a49156a26f1f7">00082</a> <span class="keywordtype">void</span> <a class="code" href="classUniformRefinementEstimator.php#af952e291ea60c090873a49156a26f1f7">UniformRefinementEstimator::_estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>* _es,
<a name="l00083"></a>00083                                                  <span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>* _system,
<a name="l00084"></a>00084                                                  <a class="code" href="classErrorVector.php">ErrorVector</a>* error_per_cell,
<a name="l00085"></a>00085                                                  <a class="code" href="classErrorEstimator.php#a355a4dd519a02dca211c653b239dc597">ErrorMap</a>* errors_per_cell,
<a name="l00086"></a>00086                                                  <span class="keyword">const</span> std::map&lt;const System*, SystemNorm &gt; *_error_norms,
<a name="l00087"></a>00087                                                  <span class="keyword">const</span> std::map&lt;<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>*, <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* &gt;* solution_vectors,
<a name="l00088"></a>00088                                                  <span class="keywordtype">bool</span>)
<a name="l00089"></a>00089 {
<a name="l00090"></a>00090   <span class="comment">// Get a vector of the Systems we&#39;re going to work on,</span>
<a name="l00091"></a>00091   <span class="comment">// and set up a error_norms map if necessary</span>
<a name="l00092"></a>00092   std::vector&lt;System *&gt; system_list;
<a name="l00093"></a>00093   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;std::map&lt;const System*, SystemNorm &gt;</a> &gt; error_norms = 
<a name="l00094"></a>00094     <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;std::map&lt;const System*, SystemNorm &gt;</a> &gt;
<a name="l00095"></a>00095     (<span class="keyword">new</span> std::map&lt;const System*, SystemNorm&gt;);
<a name="l00096"></a>00096 
<a name="l00097"></a>00097   <span class="keywordflow">if</span> (_es)
<a name="l00098"></a>00098     {
<a name="l00099"></a>00099       libmesh_assert(!_system);
<a name="l00100"></a>00100       libmesh_assert(_es-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>());
<a name="l00101"></a>00101       _system = &amp;(_es-&gt;<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(0));
<a name="l00102"></a>00102       libmesh_assert(&amp;(_system-&gt;get_equation_systems()) == _es);
<a name="l00103"></a>00103 
<a name="l00104"></a>00104       libmesh_assert(_es-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>());
<a name="l00105"></a>00105       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != _es-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>(); ++i)
<a name="l00106"></a>00106       <span class="comment">// We have to break the rules here, because we can&#39;t refine a const System</span>
<a name="l00107"></a>00107         system_list.push_back(const_cast&lt;System *&gt;(&amp;(_es-&gt;<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(i))));
<a name="l00108"></a>00108 
<a name="l00109"></a>00109       <span class="comment">// If we&#39;re computing one vector, we need to know how to scale</span>
<a name="l00110"></a>00110       <span class="comment">// each variable&#39;s contributions to it.</span>
<a name="l00111"></a>00111       <span class="keywordflow">if</span> (_error_norms)
<a name="l00112"></a>00112         {
<a name="l00113"></a>00113           libmesh_assert(!errors_per_cell);
<a name="l00114"></a>00114         }
<a name="l00115"></a>00115       <span class="keywordflow">else</span>
<a name="l00116"></a>00116       <span class="comment">// If we&#39;re computing many vectors, we just need to know which</span>
<a name="l00117"></a>00117       <span class="comment">// variables to skip</span>
<a name="l00118"></a>00118         {
<a name="l00119"></a>00119           libmesh_assert (errors_per_cell);
<a name="l00120"></a>00120 
<a name="l00121"></a>00121           _error_norms = error_norms.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>();
<a name="l00122"></a>00122 
<a name="l00123"></a>00123           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!= _es-&gt;<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>(); ++i)
<a name="l00124"></a>00124             {
<a name="l00125"></a>00125               <span class="keyword">const</span> <a class="code" href="classSystem.php">System</a> &amp;sys = _es-&gt;<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(i);
<a name="l00126"></a>00126               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_vars = sys.<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>();
<a name="l00127"></a>00127 
<a name="l00128"></a>00128               std::vector&lt;Real&gt; weights(n_vars, 0.0);
<a name="l00129"></a>00129               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v = 0; v != n_vars; ++v)
<a name="l00130"></a>00130                 {
<a name="l00131"></a>00131                   <span class="keywordflow">if</span> (errors_per_cell-&gt;find(std::make_pair(&amp;sys, v)) ==
<a name="l00132"></a>00132                       errors_per_cell-&gt;end())
<a name="l00133"></a>00133                     <span class="keywordflow">continue</span>;
<a name="l00134"></a>00134 
<a name="l00135"></a>00135                   weights[v] = 1.0;
<a name="l00136"></a>00136                 }
<a name="l00137"></a>00137               (*error_norms)[&amp;sys] =
<a name="l00138"></a>00138                 <a class="code" href="classSystemNorm.php">SystemNorm</a>(std::vector&lt;FEMNormType&gt;(n_vars, <a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(0)),
<a name="l00139"></a>00139                            weights);
<a name="l00140"></a>00140             }
<a name="l00141"></a>00141         }
<a name="l00142"></a>00142     }
<a name="l00143"></a>00143   <span class="keywordflow">else</span>
<a name="l00144"></a>00144     {
<a name="l00145"></a>00145       libmesh_assert(_system);
<a name="l00146"></a>00146       <span class="comment">// We have to break the rules here, because we can&#39;t refine a const System</span>
<a name="l00147"></a>00147       system_list.push_back(const_cast&lt;System *&gt;(_system));
<a name="l00148"></a>00148 
<a name="l00149"></a>00149       libmesh_assert(!_error_norms);
<a name="l00150"></a>00150       (*error_norms)[_system] = <a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a>;
<a name="l00151"></a>00151       _error_norms = error_norms.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>();
<a name="l00152"></a>00152     }
<a name="l00153"></a>00153 
<a name="l00154"></a>00154   <span class="comment">// An EquationSystems reference will be convenient.</span>
<a name="l00155"></a>00155   <span class="comment">// We have to break the rules here, because we can&#39;t refine a const System</span>
<a name="l00156"></a>00156   <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es =
<a name="l00157"></a>00157     <span class="keyword">const_cast&lt;</span><a class="code" href="classEquationSystems.php">EquationSystems</a> &amp;<span class="keyword">&gt;</span>(_system-&gt;<a class="code" href="classSystem.php#a51da3ea6211cf1888377c9c4b1554232">get_equation_systems</a>());
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   <span class="comment">// The current mesh</span>
<a name="l00160"></a>00160   <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh = es.<a class="code" href="classEquationSystems.php#ad8d458ae6a34c460e72b3279373d4a70">get_mesh</a>();
<a name="l00161"></a>00161 
<a name="l00162"></a>00162   <span class="comment">// The dimensionality of the mesh</span>
<a name="l00163"></a>00163   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = mesh.<a class="code" href="classMeshBase.php#a81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>();
<a name="l00164"></a>00164   
<a name="l00165"></a>00165   <span class="comment">// Resize the error_per_cell vectors to be</span>
<a name="l00166"></a>00166   <span class="comment">// the number of elements, initialize them to 0.</span>
<a name="l00167"></a>00167   <span class="keywordflow">if</span> (error_per_cell)
<a name="l00168"></a>00168     {
<a name="l00169"></a>00169       error_per_cell-&gt;clear();
<a name="l00170"></a>00170       error_per_cell-&gt;resize (mesh.<a class="code" href="classMeshBase.php#a05c0414e5c91b36e9698fc4f60cff642">max_elem_id</a>(), 0.);
<a name="l00171"></a>00171     }
<a name="l00172"></a>00172   <span class="keywordflow">else</span>
<a name="l00173"></a>00173     {
<a name="l00174"></a>00174       libmesh_assert(errors_per_cell);
<a name="l00175"></a>00175       <span class="keywordflow">for</span> (ErrorMap::iterator i = errors_per_cell-&gt;begin();
<a name="l00176"></a>00176            i != errors_per_cell-&gt;end(); ++i)
<a name="l00177"></a>00177         {
<a name="l00178"></a>00178           <a class="code" href="classErrorVector.php">ErrorVector</a> *e = i-&gt;second;
<a name="l00179"></a>00179           e-&gt;clear();
<a name="l00180"></a>00180           e-&gt;resize(mesh.<a class="code" href="classMeshBase.php#a05c0414e5c91b36e9698fc4f60cff642">max_elem_id</a>(), 0.);
<a name="l00181"></a>00181         }
<a name="l00182"></a>00182     }
<a name="l00183"></a>00183 
<a name="l00184"></a>00184   <span class="comment">// We&#39;ll want to back up all coarse grid vectors</span>
<a name="l00185"></a>00185   std::vector&lt;std::map&lt;std::string, NumericVector&lt;Number&gt; *&gt; &gt;
<a name="l00186"></a>00186     coarse_vectors(system_list.size());
<a name="l00187"></a>00187   std::vector&lt;NumericVector&lt;Number&gt; *&gt;
<a name="l00188"></a>00188     coarse_solutions(system_list.size());
<a name="l00189"></a>00189   std::vector&lt;NumericVector&lt;Number&gt; *&gt;
<a name="l00190"></a>00190     coarse_local_solutions(system_list.size());
<a name="l00191"></a>00191   <span class="comment">// And make copies of projected solutions</span>
<a name="l00192"></a>00192   std::vector&lt;NumericVector&lt;Number&gt; *&gt;
<a name="l00193"></a>00193     projected_solutions(system_list.size());
<a name="l00194"></a>00194 
<a name="l00195"></a>00195   <span class="comment">// And we&#39;ll need to temporarily change solution projection settings</span>
<a name="l00196"></a>00196   std::vector&lt;bool&gt; old_projection_settings(system_list.size());
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   <span class="comment">// And it&#39;ll be best to avoid any repartitioning</span>
<a name="l00199"></a>00199   <a class="code" href="classAutoPtr.php">AutoPtr&lt;Partitioner&gt;</a> old_partitioner = mesh.<a class="code" href="classMeshBase.php#a4e91618481bb34ffff7e85ab2ee9b78f">partitioner</a>();
<a name="l00200"></a>00200   mesh.<a class="code" href="classMeshBase.php#a4e91618481bb34ffff7e85ab2ee9b78f">partitioner</a>().<a class="code" href="classAutoPtr.php#afba95dd5fca7f83ababa4eaf6a57c511" title="Forcibly deletes the managed object.">reset</a>(NULL);
<a name="l00201"></a>00201 
<a name="l00202"></a>00202   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != system_list.size(); ++i)
<a name="l00203"></a>00203     {
<a name="l00204"></a>00204       <a class="code" href="classSystem.php">System</a> &amp;system = *system_list[i];
<a name="l00205"></a>00205 
<a name="l00206"></a>00206       <span class="comment">// Check for valid error_norms</span>
<a name="l00207"></a>00207       libmesh_assert (_error_norms-&gt;find(&amp;system) !=
<a name="l00208"></a>00208                       _error_norms-&gt;end());
<a name="l00209"></a>00209 
<a name="l00210"></a>00210       <span class="comment">// Back up the solution vector</span>
<a name="l00211"></a>00211       coarse_solutions[i] = system.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;clone().<a class="code" href="classAutoPtr.php#af9d9cdff0aa3e2df96b18b197be2c9ac" title="Bypassing the smart pointer.">release</a>();
<a name="l00212"></a>00212       coarse_local_solutions[i] =
<a name="l00213"></a>00213         system.<a class="code" href="classSystem.php#a47b00cd00684aebe3c095aba010626e5">current_local_solution</a>-&gt;clone().<a class="code" href="classAutoPtr.php#af9d9cdff0aa3e2df96b18b197be2c9ac" title="Bypassing the smart pointer.">release</a>();
<a name="l00214"></a>00214 
<a name="l00215"></a>00215       <span class="comment">// Back up all other coarse grid vectors</span>
<a name="l00216"></a>00216       <span class="keywordflow">for</span> (<a class="code" href="classSystem.php#ac1939aeca6473017c8b6a560892e86aa">System::vectors_iterator</a> vec = system.<a class="code" href="classSystem.php#aa33cb0639b60f352561646fcce51a06b">vectors_begin</a>(); vec !=
<a name="l00217"></a>00217            system.<a class="code" href="classSystem.php#a0c1c70cc7f560cda430474eea1702082">vectors_end</a>(); ++vec)
<a name="l00218"></a>00218         {
<a name="l00219"></a>00219           <span class="comment">// The (string) name of this vector</span>
<a name="l00220"></a>00220           <span class="keyword">const</span> std::string&amp; var_name = vec-&gt;first;
<a name="l00221"></a>00221 
<a name="l00222"></a>00222           coarse_vectors[i][var_name] = vec-&gt;second-&gt;clone().release();
<a name="l00223"></a>00223         }
<a name="l00224"></a>00224 
<a name="l00225"></a>00225       <span class="comment">// Use a non-standard solution vector if necessary</span>
<a name="l00226"></a>00226       <span class="keywordflow">if</span> (solution_vectors &amp;&amp; 
<a name="l00227"></a>00227           solution_vectors-&gt;find(&amp;system) != solution_vectors-&gt;end() &amp;&amp; 
<a name="l00228"></a>00228           solution_vectors-&gt;find(&amp;system)-&gt;second &amp;&amp;
<a name="l00229"></a>00229           solution_vectors-&gt;find(&amp;system)-&gt;second != system.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>())
<a name="l00230"></a>00230         {
<a name="l00231"></a>00231           <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* newsol =
<a name="l00232"></a>00232             <span class="keyword">const_cast&lt;</span><a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>*<span class="keyword">&gt;</span>
<a name="l00233"></a>00233             (solution_vectors-&gt;find(&amp;system)-&gt;second);
<a name="l00234"></a>00234           newsol-&gt;<a class="code" href="classNumericVector.php#a51e2011eeca6faa30e349c1950352eb8">swap</a>(*system.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>);
<a name="l00235"></a>00235           system.<a class="code" href="classSystem.php#add4b09ec4fb0679b8623c01218cafa5b">update</a>();
<a name="l00236"></a>00236         }
<a name="l00237"></a>00237 
<a name="l00238"></a>00238       <span class="comment">// Make sure the solution is projected when we refine the mesh</span>
<a name="l00239"></a>00239       old_projection_settings[i] = system.<a class="code" href="classSystem.php#a7ddea7f6e4a6530a18fcd0932e8bb7b8">project_solution_on_reinit</a>();
<a name="l00240"></a>00240       system.<a class="code" href="classSystem.php#a7ddea7f6e4a6530a18fcd0932e8bb7b8">project_solution_on_reinit</a>() = <span class="keyword">true</span>;
<a name="l00241"></a>00241     }
<a name="l00242"></a>00242 
<a name="l00243"></a>00243   <span class="comment">// Find the number of coarse mesh elements, to make it possible</span>
<a name="l00244"></a>00244   <span class="comment">// to find correct coarse elem ids later</span>
<a name="l00245"></a>00245   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_coarse_elem_id = mesh.<a class="code" href="classMeshBase.php#a05c0414e5c91b36e9698fc4f60cff642">max_elem_id</a>();
<a name="l00246"></a>00246 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00247"></a>00247 <span class="preprocessor"></span>  <span class="comment">// n_coarse_elem is only used in an assertion later so</span>
<a name="l00248"></a>00248   <span class="comment">// avoid declaring it unless asserts are active.</span>
<a name="l00249"></a>00249   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_coarse_elem = mesh.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>();
<a name="l00250"></a>00250 <span class="preprocessor">#endif</span>
<a name="l00251"></a>00251 <span class="preprocessor"></span>  
<a name="l00252"></a>00252   <span class="comment">// Uniformly refine the mesh</span>
<a name="l00253"></a>00253   <a class="code" href="classMeshRefinement.php">MeshRefinement</a> mesh_refinement(mesh);
<a name="l00254"></a>00254 
<a name="l00255"></a>00255   libmesh_assert (<a class="code" href="classUniformRefinementEstimator.php#a6f072582ef4e3b0c96f6b3b3c10e59ba">number_h_refinements</a> &gt; 0 || <a class="code" href="classUniformRefinementEstimator.php#ab57bc89a694285b9be394094be36975f">number_p_refinements</a> &gt; 0);
<a name="l00256"></a>00256 
<a name="l00257"></a>00257   <span class="comment">// FIXME: this may break if there is more than one System</span>
<a name="l00258"></a>00258   <span class="comment">// on this mesh but estimate_error was still called instead of</span>
<a name="l00259"></a>00259   <span class="comment">// estimate_errors</span>
<a name="l00260"></a>00260   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != <a class="code" href="classUniformRefinementEstimator.php#a6f072582ef4e3b0c96f6b3b3c10e59ba">number_h_refinements</a>; ++i)
<a name="l00261"></a>00261     {
<a name="l00262"></a>00262       mesh_refinement.<a class="code" href="classMeshRefinement.php#a9fdd024cd000c1ac0bf52f9c777098c6">uniformly_refine</a>(1);
<a name="l00263"></a>00263       es.<a class="code" href="classEquationSystems.php#a55f8c311a2ff890d0919b3fa4609d9df">reinit</a>();
<a name="l00264"></a>00264     }
<a name="l00265"></a>00265       
<a name="l00266"></a>00266   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != <a class="code" href="classUniformRefinementEstimator.php#ab57bc89a694285b9be394094be36975f">number_p_refinements</a>; ++i)
<a name="l00267"></a>00267     {
<a name="l00268"></a>00268       mesh_refinement.<a class="code" href="classMeshRefinement.php#a9a37541cb84e7ca981c7c4c6a3bc8f0b">uniformly_p_refine</a>(1);
<a name="l00269"></a>00269       es.<a class="code" href="classEquationSystems.php#a55f8c311a2ff890d0919b3fa4609d9df">reinit</a>();
<a name="l00270"></a>00270     }
<a name="l00271"></a>00271 
<a name="l00272"></a>00272   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != system_list.size(); ++i)
<a name="l00273"></a>00273     {
<a name="l00274"></a>00274       <a class="code" href="classSystem.php">System</a> &amp;system = *system_list[i];
<a name="l00275"></a>00275       
<a name="l00276"></a>00276       <span class="comment">// Copy the projected coarse grid solutions, which will be</span>
<a name="l00277"></a>00277       <span class="comment">// overwritten by solve()</span>
<a name="l00278"></a>00278 <span class="comment">//      projected_solutions[i] = system.solution-&gt;clone().release();</span>
<a name="l00279"></a>00279       projected_solutions[i] = <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;::build</a>().release();
<a name="l00280"></a>00280       projected_solutions[i]-&gt;<a class="code" href="classNumericVector.php#abbb0c0eb886ba1c6bb835d6275475c6e">init</a>(system.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;size(), <span class="keyword">true</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>);
<a name="l00281"></a>00281       system.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;localize(*projected_solutions[i],
<a name="l00282"></a>00282                                 system.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#a6c7f0c7286f9f067563e8da24d4f3955">get_send_list</a>());
<a name="l00283"></a>00283     }
<a name="l00284"></a>00284 
<a name="l00285"></a>00285   <span class="comment">// Get the uniformly refined solution.</span>
<a name="l00286"></a>00286 
<a name="l00287"></a>00287   <span class="keywordflow">if</span> (_es)
<a name="l00288"></a>00288     {
<a name="l00289"></a>00289       <span class="comment">// No specified vectors == forward solve</span>
<a name="l00290"></a>00290       <span class="keywordflow">if</span> (!solution_vectors)
<a name="l00291"></a>00291         es.<a class="code" href="classEquationSystems.php#aef3aa48d457508bf35043667dab8bd5b">solve</a>();
<a name="l00292"></a>00292       <span class="keywordflow">else</span>
<a name="l00293"></a>00293         {
<a name="l00294"></a>00294           libmesh_assert(solution_vectors-&gt;size() == es.<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>());
<a name="l00295"></a>00295           libmesh_assert(solution_vectors-&gt;find(system_list[0]) !=
<a name="l00296"></a>00296                          solution_vectors-&gt;end());
<a name="l00297"></a>00297           <span class="keyword">const</span> <span class="keywordtype">bool</span> solve_adjoint = 
<a name="l00298"></a>00298             (system_list[0]-&gt;have_vector(<span class="stringliteral">&quot;adjoint_solution&quot;</span>) &amp;&amp;
<a name="l00299"></a>00299              (solution_vectors-&gt;find(system_list[0])-&gt;second ==
<a name="l00300"></a>00300               &amp;system_list[0]-&gt;get_adjoint_solution()));
<a name="l00301"></a>00301           libmesh_assert(solve_adjoint ||
<a name="l00302"></a>00302             (solution_vectors-&gt;find(system_list[0])-&gt;second ==
<a name="l00303"></a>00303              system_list[0]-&gt;solution.get()) ||
<a name="l00304"></a>00304              !solution_vectors-&gt;find(system_list[0])-&gt;second);
<a name="l00305"></a>00305                          
<a name="l00306"></a>00306 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00307"></a>00307 <span class="preprocessor"></span>          <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != system_list.size(); ++i)
<a name="l00308"></a>00308             {
<a name="l00309"></a>00309               libmesh_assert(solution_vectors-&gt;find(system_list[i]) !=
<a name="l00310"></a>00310                              solution_vectors-&gt;end());
<a name="l00311"></a>00311               libmesh_assert(!solve_adjoint ||
<a name="l00312"></a>00312                              solution_vectors-&gt;find(system_list[i])-&gt;second ==
<a name="l00313"></a>00313                              &amp;system_list[i]-&gt;get_adjoint_solution());
<a name="l00314"></a>00314               libmesh_assert(solve_adjoint ||
<a name="l00315"></a>00315                              solution_vectors-&gt;find(system_list[i])-&gt;second ==
<a name="l00316"></a>00316                              system_list[i]-&gt;solution.get() ||
<a name="l00317"></a>00317                              !solution_vectors-&gt;find(system_list[i])-&gt;second);
<a name="l00318"></a>00318             }
<a name="l00319"></a>00319 <span class="preprocessor">#endif</span>
<a name="l00320"></a>00320 <span class="preprocessor"></span>
<a name="l00321"></a>00321           <span class="keywordflow">if</span> (solve_adjoint)
<a name="l00322"></a>00322             {
<a name="l00323"></a>00323               <span class="comment">// Set up proper initial guesses</span>
<a name="l00324"></a>00324               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != system_list.size(); ++i)
<a name="l00325"></a>00325                 system_list[i]-&gt;get_adjoint_solution() = *system_list[i]-&gt;solution;
<a name="l00326"></a>00326               es.<a class="code" href="classEquationSystems.php#a92d62c14a28b6a0010801da36511ff37">adjoint_solve</a>();
<a name="l00327"></a>00327               <span class="comment">// Put the adjoint_solution into solution for</span>
<a name="l00328"></a>00328               <span class="comment">// comparisons</span>
<a name="l00329"></a>00329               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != system_list.size(); ++i)
<a name="l00330"></a>00330                 {
<a name="l00331"></a>00331                   system_list[i]-&gt;get_adjoint_solution().swap(*system_list[i]-&gt;solution);
<a name="l00332"></a>00332                   system_list[i]-&gt;update();
<a name="l00333"></a>00333                 }
<a name="l00334"></a>00334             }
<a name="l00335"></a>00335           <span class="keywordflow">else</span>
<a name="l00336"></a>00336             es.<a class="code" href="classEquationSystems.php#aef3aa48d457508bf35043667dab8bd5b">solve</a>();
<a name="l00337"></a>00337         }
<a name="l00338"></a>00338     }
<a name="l00339"></a>00339   <span class="keywordflow">else</span>
<a name="l00340"></a>00340     {
<a name="l00341"></a>00341       <span class="comment">// No specified vectors == forward solve</span>
<a name="l00342"></a>00342       <span class="keywordflow">if</span> (!solution_vectors)
<a name="l00343"></a>00343         system_list[0]-&gt;solve();
<a name="l00344"></a>00344       <span class="keywordflow">else</span>
<a name="l00345"></a>00345         {
<a name="l00346"></a>00346           libmesh_assert(solution_vectors-&gt;find(system_list[0]) !=
<a name="l00347"></a>00347                          solution_vectors-&gt;end());
<a name="l00348"></a>00348 
<a name="l00349"></a>00349           <span class="keyword">const</span> <span class="keywordtype">bool</span> solve_adjoint = 
<a name="l00350"></a>00350             (system_list[0]-&gt;have_vector(<span class="stringliteral">&quot;adjoint_solution&quot;</span>) &amp;&amp;
<a name="l00351"></a>00351              (solution_vectors-&gt;find(system_list[0])-&gt;second ==
<a name="l00352"></a>00352               &amp;system_list[0]-&gt;get_adjoint_solution()));
<a name="l00353"></a>00353           libmesh_assert(solve_adjoint ||
<a name="l00354"></a>00354             (solution_vectors-&gt;find(system_list[0])-&gt;second ==
<a name="l00355"></a>00355              system_list[0]-&gt;solution.get()) ||
<a name="l00356"></a>00356             !solution_vectors-&gt;find(system_list[0])-&gt;second);
<a name="l00357"></a>00357 
<a name="l00358"></a>00358           <span class="keywordflow">if</span> (solve_adjoint)
<a name="l00359"></a>00359             {
<a name="l00360"></a>00360               <span class="comment">// Set up proper initial guesses</span>
<a name="l00361"></a>00361               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != system_list.size(); ++i)
<a name="l00362"></a>00362                 system_list[0]-&gt;get_adjoint_solution() = *system_list[0]-&gt;solution;
<a name="l00363"></a>00363               system_list[0]-&gt;adjoint_solve();
<a name="l00364"></a>00364               <span class="comment">// Put the adjoint_solution into solution for</span>
<a name="l00365"></a>00365               <span class="comment">// comparisons</span>
<a name="l00366"></a>00366               system_list[0]-&gt;get_adjoint_solution().swap(*system_list[0]-&gt;solution);
<a name="l00367"></a>00367               system_list[0]-&gt;update();
<a name="l00368"></a>00368             }
<a name="l00369"></a>00369           <span class="keywordflow">else</span>
<a name="l00370"></a>00370             system_list[0]-&gt;solve();
<a name="l00371"></a>00371         }
<a name="l00372"></a>00372     }
<a name="l00373"></a>00373   
<a name="l00374"></a>00374   <span class="comment">// Get the error in the uniformly refined solution(s).</span>
<a name="l00375"></a>00375 
<a name="l00376"></a>00376   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != system_list.size(); ++i)
<a name="l00377"></a>00377     {
<a name="l00378"></a>00378       <a class="code" href="classSystem.php">System</a> &amp;system = *system_list[i];
<a name="l00379"></a>00379 
<a name="l00380"></a>00380       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_vars = system.<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>();
<a name="l00381"></a>00381 
<a name="l00382"></a>00382       <a class="code" href="classDofMap.php">DofMap</a> &amp;dof_map = system.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>();
<a name="l00383"></a>00383 
<a name="l00384"></a>00384       <span class="keyword">const</span> <a class="code" href="classSystemNorm.php">SystemNorm</a> &amp;system_i_norm =
<a name="l00385"></a>00385         _error_norms-&gt;find(&amp;system)-&gt;second;
<a name="l00386"></a>00386 
<a name="l00387"></a>00387       <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> *projected_solution = projected_solutions[i];
<a name="l00388"></a>00388 
<a name="l00389"></a>00389       <span class="comment">// Loop over all the variables in the system</span>
<a name="l00390"></a>00390       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;n_vars; var++)
<a name="l00391"></a>00391         {
<a name="l00392"></a>00392           <span class="comment">// Get the error vector to fill for this system and variable</span>
<a name="l00393"></a>00393           <a class="code" href="classErrorVector.php">ErrorVector</a> *err_vec = error_per_cell;
<a name="l00394"></a>00394           <span class="keywordflow">if</span> (!err_vec)
<a name="l00395"></a>00395             {
<a name="l00396"></a>00396               libmesh_assert(errors_per_cell);
<a name="l00397"></a>00397               err_vec =
<a name="l00398"></a>00398                 (*errors_per_cell)[std::make_pair(&amp;system,var)];
<a name="l00399"></a>00399             }
<a name="l00400"></a>00400 
<a name="l00401"></a>00401           <span class="comment">// The type of finite element to use for this variable</span>
<a name="l00402"></a>00402           <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_type = dof_map.<a class="code" href="classDofMap.php#ae3c63266417020f38af6e5cc40efca76">variable_type</a> (var);
<a name="l00403"></a>00403       
<a name="l00404"></a>00404           <span class="comment">// Finite element object for each fine element</span>
<a name="l00405"></a>00405           <a class="code" href="classAutoPtr.php">AutoPtr&lt;FEBase&gt;</a> fe (<a class="code" href="classFEBase.php#a3e86219b79ce4f881e9c48f4fd7b860e">FEBase::build</a> (dim, fe_type));
<a name="l00406"></a>00406 
<a name="l00407"></a>00407           <span class="comment">// Build and attach an appropriate quadrature rule</span>
<a name="l00408"></a>00408           <a class="code" href="classAutoPtr.php">AutoPtr&lt;QBase&gt;</a> qrule = fe_type.<a class="code" href="classFEType.php#a33013296ee9643faec0262714ad9163c">default_quadrature_rule</a>(dim);
<a name="l00409"></a>00409           fe-&gt;attach_quadrature_rule (qrule.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>());
<a name="l00410"></a>00410       
<a name="l00411"></a>00411           <span class="keyword">const</span> std::vector&lt;Real&gt;&amp;  JxW = fe-&gt;get_JxW();
<a name="l00412"></a>00412           <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; phi = fe-&gt;get_phi();
<a name="l00413"></a>00413           <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt;&amp; dphi =
<a name="l00414"></a>00414             fe-&gt;get_dphi();
<a name="l00415"></a>00415 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00416"></a>00416 <span class="preprocessor"></span>          <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealTensor&gt; &gt;&amp; d2phi =
<a name="l00417"></a>00417             fe-&gt;get_d2phi();
<a name="l00418"></a>00418 <span class="preprocessor">#endif</span>
<a name="l00419"></a>00419 <span class="preprocessor"></span>
<a name="l00420"></a>00420           <span class="comment">// The global DOF indices for the fine element</span>
<a name="l00421"></a>00421           std::vector&lt;unsigned int&gt; dof_indices;
<a name="l00422"></a>00422       
<a name="l00423"></a>00423           <span class="comment">// Iterate over all the active elements in the fine mesh</span>
<a name="l00424"></a>00424           <span class="comment">// that live on this processor.</span>
<a name="l00425"></a>00425           <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       elem_it  = mesh.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00426"></a>00426           <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> elem_end = mesh.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>(); 
<a name="l00427"></a>00427 
<a name="l00428"></a>00428           <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00429"></a>00429             {
<a name="l00430"></a>00430               <span class="comment">// e is necessarily an active element on the local processor</span>
<a name="l00431"></a>00431               <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *elem_it;
<a name="l00432"></a>00432 
<a name="l00433"></a>00433               <span class="comment">// Find the element id for the corresponding coarse grid element</span>
<a name="l00434"></a>00434               <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* coarse = elem;
<a name="l00435"></a>00435               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e_id = coarse-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l00436"></a>00436               <span class="keywordflow">while</span> (e_id &gt;= max_coarse_elem_id)
<a name="l00437"></a>00437                 {
<a name="l00438"></a>00438                   libmesh_assert (coarse-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>());
<a name="l00439"></a>00439                   coarse = coarse-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>();
<a name="l00440"></a>00440                   e_id = coarse-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l00441"></a>00441                 }
<a name="l00442"></a>00442           
<a name="l00443"></a>00443               <span class="keywordtype">double</span> L2normsq = 0., H1seminormsq = 0., H2seminormsq = 0.;
<a name="l00444"></a>00444 
<a name="l00445"></a>00445               <span class="comment">// reinitialize the element-specific data</span>
<a name="l00446"></a>00446               <span class="comment">// for the current element</span>
<a name="l00447"></a>00447               fe-&gt;reinit (elem);
<a name="l00448"></a>00448 
<a name="l00449"></a>00449               <span class="comment">// Get the local to global degree of freedom maps</span>
<a name="l00450"></a>00450               dof_map.<a class="code" href="classDofMap.php#afc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (elem, dof_indices, var);
<a name="l00451"></a>00451 
<a name="l00452"></a>00452               <span class="comment">// The number of quadrature points</span>
<a name="l00453"></a>00453               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = qrule-&gt;n_points();
<a name="l00454"></a>00454 
<a name="l00455"></a>00455               <span class="comment">// The number of shape functions</span>
<a name="l00456"></a>00456               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sf = dof_indices.size();
<a name="l00457"></a>00457 
<a name="l00458"></a>00458               <span class="comment">//</span>
<a name="l00459"></a>00459               <span class="comment">// Begin the loop over the Quadrature points.</span>
<a name="l00460"></a>00460               <span class="comment">//</span>
<a name="l00461"></a>00461               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;n_qp; qp++)
<a name="l00462"></a>00462                 {
<a name="l00463"></a>00463                   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> u_fine = 0., u_coarse = 0.;
<a name="l00464"></a>00464 
<a name="l00465"></a>00465                   <a class="code" href="classVectorValue.php">Gradient</a> grad_u_fine, grad_u_coarse;
<a name="l00466"></a>00466 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00467"></a>00467 <span class="preprocessor"></span>                  <a class="code" href="classTensorValue.php">Tensor</a> grad2_u_fine, grad2_u_coarse;
<a name="l00468"></a>00468 <span class="preprocessor">#endif</span>
<a name="l00469"></a>00469 <span class="preprocessor"></span>
<a name="l00470"></a>00470                   <span class="comment">// Compute solution values at the current</span>
<a name="l00471"></a>00471                   <span class="comment">// quadrature point.  This reqiures a sum</span>
<a name="l00472"></a>00472                   <span class="comment">// over all the shape functions evaluated</span>
<a name="l00473"></a>00473                   <span class="comment">// at the quadrature point.</span>
<a name="l00474"></a>00474                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_sf; i++)
<a name="l00475"></a>00475                     {
<a name="l00476"></a>00476                       u_fine            += phi[i][qp]*system.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a> (dof_indices[i]);
<a name="l00477"></a>00477                       u_coarse          += phi[i][qp]*(*projected_solution) (dof_indices[i]);
<a name="l00478"></a>00478                       grad_u_fine       += dphi[i][qp]*system.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a> (dof_indices[i]);
<a name="l00479"></a>00479                       grad_u_coarse     += dphi[i][qp]*(*projected_solution) (dof_indices[i]);
<a name="l00480"></a>00480 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00481"></a>00481 <span class="preprocessor"></span>                      grad2_u_fine      += d2phi[i][qp]*system.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a> (dof_indices[i]);
<a name="l00482"></a>00482                       grad2_u_coarse    += d2phi[i][qp]*(*projected_solution) (dof_indices[i]);
<a name="l00483"></a>00483 <span class="preprocessor">#endif</span>
<a name="l00484"></a>00484 <span class="preprocessor"></span>                    }
<a name="l00485"></a>00485 
<a name="l00486"></a>00486                   <span class="comment">// Compute the value of the error at this quadrature point</span>
<a name="l00487"></a>00487                   <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> val_error = u_fine - u_coarse;
<a name="l00488"></a>00488 
<a name="l00489"></a>00489                   <span class="comment">// Add the squares of the error to each contribution</span>
<a name="l00490"></a>00490                   <span class="keywordflow">if</span> (system_i_norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a> ||
<a name="l00491"></a>00491                       system_i_norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a7a46908fc35e8855517abd137413214c">H1</a> ||
<a name="l00492"></a>00492                       system_i_norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a>)
<a name="l00493"></a>00493                     {
<a name="l00494"></a>00494                       L2normsq += JxW[qp] * system_i_norm.<a class="code" href="classSystemNorm.php#a5a1f8483b61f9a931014352ca678f684">weight_sq</a>(var) *
<a name="l00495"></a>00495                                   <a class="code" href="libmesh__common_8h.php#af9cdd07341b53cc644199f6aec5e1420">libmesh_norm</a>(val_error);
<a name="l00496"></a>00496                       libmesh_assert (L2normsq     &gt;= 0.);
<a name="l00497"></a>00497                     }
<a name="l00498"></a>00498 
<a name="l00499"></a>00499 
<a name="l00500"></a>00500                   <span class="comment">// Compute the value of the error in the gradient at this</span>
<a name="l00501"></a>00501                   <span class="comment">// quadrature point</span>
<a name="l00502"></a>00502                   <span class="keywordflow">if</span> (system_i_norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a7a46908fc35e8855517abd137413214c">H1</a> ||
<a name="l00503"></a>00503                       system_i_norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a> ||
<a name="l00504"></a>00504                       system_i_norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a>)
<a name="l00505"></a>00505                     {
<a name="l00506"></a>00506                       <a class="code" href="classVectorValue.php">Gradient</a> grad_error = grad_u_fine - grad_u_coarse;
<a name="l00507"></a>00507 
<a name="l00508"></a>00508                       H1seminormsq += JxW[qp] * system_i_norm.<a class="code" href="classSystemNorm.php#a5a1f8483b61f9a931014352ca678f684">weight_sq</a>(var) *
<a name="l00509"></a>00509                         grad_error.<a class="code" href="classTypeVector.php#a099aac580a3a6fce9276cf5443d0c0e9">size_sq</a>();
<a name="l00510"></a>00510                       libmesh_assert (H1seminormsq &gt;= 0.);
<a name="l00511"></a>00511                     }
<a name="l00512"></a>00512 
<a name="l00513"></a>00513 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00514"></a>00514 <span class="preprocessor"></span>                  <span class="comment">// Compute the value of the error in the hessian at this</span>
<a name="l00515"></a>00515                   <span class="comment">// quadrature point</span>
<a name="l00516"></a>00516                   <span class="keywordflow">if</span> (system_i_norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a> ||
<a name="l00517"></a>00517                       system_i_norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a>)
<a name="l00518"></a>00518                     {
<a name="l00519"></a>00519                       <a class="code" href="classTensorValue.php">Tensor</a> grad2_error = grad2_u_fine - grad2_u_coarse;
<a name="l00520"></a>00520 
<a name="l00521"></a>00521                       H2seminormsq += JxW[qp] * system_i_norm.<a class="code" href="classSystemNorm.php#a5a1f8483b61f9a931014352ca678f684">weight_sq</a>(var) *
<a name="l00522"></a>00522                         grad2_error.<a class="code" href="classTypeTensor.php#a7be64b1de5e558f2de032bde1f881220">size_sq</a>();
<a name="l00523"></a>00523                       libmesh_assert (H2seminormsq &gt;= 0.);
<a name="l00524"></a>00524                     }
<a name="l00525"></a>00525 <span class="preprocessor">#endif</span>
<a name="l00526"></a>00526 <span class="preprocessor"></span>                } <span class="comment">// end qp loop</span>
<a name="l00527"></a>00527 
<a name="l00528"></a>00528               <span class="keywordflow">if</span> (system_i_norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a> ||
<a name="l00529"></a>00529                   system_i_norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a7a46908fc35e8855517abd137413214c">H1</a> ||
<a name="l00530"></a>00530                   system_i_norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a>)
<a name="l00531"></a>00531                 (*err_vec)[e_id] += L2normsq;
<a name="l00532"></a>00532               <span class="keywordflow">if</span> (system_i_norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a7a46908fc35e8855517abd137413214c">H1</a> ||
<a name="l00533"></a>00533                   system_i_norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a> ||
<a name="l00534"></a>00534                   system_i_norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a>)
<a name="l00535"></a>00535                 (*err_vec)[e_id] += H1seminormsq;
<a name="l00536"></a>00536               
<a name="l00537"></a>00537               <span class="keywordflow">if</span> (system_i_norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a> ||
<a name="l00538"></a>00538                   system_i_norm.<a class="code" href="classSystemNorm.php#a486740c4dbb868404a39d1c315daa2df">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a>)
<a name="l00539"></a>00539                 (*err_vec)[e_id] += H2seminormsq;
<a name="l00540"></a>00540             } <span class="comment">// End loop over active local elements</span>
<a name="l00541"></a>00541         } <span class="comment">// End loop over variables</span>
<a name="l00542"></a>00542 
<a name="l00543"></a>00543       <span class="comment">// Don&#39;t bother projecting the solution; we&#39;ll restore from backup</span>
<a name="l00544"></a>00544       <span class="comment">// after coarsening</span>
<a name="l00545"></a>00545       system.<a class="code" href="classSystem.php#a7ddea7f6e4a6530a18fcd0932e8bb7b8">project_solution_on_reinit</a>() = <span class="keyword">false</span>;
<a name="l00546"></a>00546     }
<a name="l00547"></a>00547 
<a name="l00548"></a>00548 
<a name="l00549"></a>00549   <span class="comment">// Uniformly coarsen the mesh, without projecting the solution</span>
<a name="l00550"></a>00550   libmesh_assert (<a class="code" href="classUniformRefinementEstimator.php#a6f072582ef4e3b0c96f6b3b3c10e59ba">number_h_refinements</a> &gt; 0 || <a class="code" href="classUniformRefinementEstimator.php#ab57bc89a694285b9be394094be36975f">number_p_refinements</a> &gt; 0);
<a name="l00551"></a>00551 
<a name="l00552"></a>00552   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != <a class="code" href="classUniformRefinementEstimator.php#a6f072582ef4e3b0c96f6b3b3c10e59ba">number_h_refinements</a>; ++i)
<a name="l00553"></a>00553     {
<a name="l00554"></a>00554       mesh_refinement.<a class="code" href="classMeshRefinement.php#ab1c27c47f0c680e97e3ef33c09312278">uniformly_coarsen</a>(1);
<a name="l00555"></a>00555       <span class="comment">// FIXME - should the reinits here be necessary? - RHS</span>
<a name="l00556"></a>00556       es.<a class="code" href="classEquationSystems.php#a55f8c311a2ff890d0919b3fa4609d9df">reinit</a>();
<a name="l00557"></a>00557     }
<a name="l00558"></a>00558       
<a name="l00559"></a>00559   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != <a class="code" href="classUniformRefinementEstimator.php#ab57bc89a694285b9be394094be36975f">number_p_refinements</a>; ++i)
<a name="l00560"></a>00560     {
<a name="l00561"></a>00561       mesh_refinement.<a class="code" href="classMeshRefinement.php#a03c0e4cc5b36b95c8044950c50b6745e">uniformly_p_coarsen</a>(1);
<a name="l00562"></a>00562       es.<a class="code" href="classEquationSystems.php#a55f8c311a2ff890d0919b3fa4609d9df">reinit</a>();
<a name="l00563"></a>00563     }
<a name="l00564"></a>00564 
<a name="l00565"></a>00565   <span class="comment">// We should be back where we started</span>
<a name="l00566"></a>00566   libmesh_assert(n_coarse_elem == mesh.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>());
<a name="l00567"></a>00567 
<a name="l00568"></a>00568   <span class="comment">// Each processor has now computed the error contribuions</span>
<a name="l00569"></a>00569   <span class="comment">// for its local elements.  We need to sum the vector</span>
<a name="l00570"></a>00570   <span class="comment">// and then take the square-root of each component.  Note</span>
<a name="l00571"></a>00571   <span class="comment">// that we only need to sum if we are running on multiple</span>
<a name="l00572"></a>00572   <span class="comment">// processors, and we only need to take the square-root</span>
<a name="l00573"></a>00573   <span class="comment">// if the value is nonzero.  There will in general be many</span>
<a name="l00574"></a>00574   <span class="comment">// zeros for the inactive elements.</span>
<a name="l00575"></a>00575 
<a name="l00576"></a>00576   <span class="keywordflow">if</span> (error_per_cell)
<a name="l00577"></a>00577     {
<a name="l00578"></a>00578       <span class="comment">// First sum the vector of estimated error values</span>
<a name="l00579"></a>00579       this-&gt;<a class="code" href="classErrorEstimator.php#a6b108b6e9e10fd97df826209c15c8618">reduce_error</a>(*error_per_cell);
<a name="l00580"></a>00580 
<a name="l00581"></a>00581       <span class="comment">// Compute the square-root of each component.</span>
<a name="l00582"></a>00582       START_LOG(<span class="stringliteral">&quot;std::sqrt()&quot;</span>, <span class="stringliteral">&quot;UniformRefinementEstimator&quot;</span>);
<a name="l00583"></a>00583       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;error_per_cell-&gt;size(); i++)
<a name="l00584"></a>00584         <span class="keywordflow">if</span> ((*error_per_cell)[i] != 0.)
<a name="l00585"></a>00585           (*error_per_cell)[i] = std::sqrt((*error_per_cell)[i]);
<a name="l00586"></a>00586       STOP_LOG(<span class="stringliteral">&quot;std::sqrt()&quot;</span>, <span class="stringliteral">&quot;UniformRefinementEstimator&quot;</span>);
<a name="l00587"></a>00587     }
<a name="l00588"></a>00588   <span class="keywordflow">else</span>
<a name="l00589"></a>00589     {
<a name="l00590"></a>00590       <span class="keywordflow">for</span> (ErrorMap::iterator i = errors_per_cell-&gt;begin();
<a name="l00591"></a>00591            i != errors_per_cell-&gt;end(); ++i)
<a name="l00592"></a>00592         {
<a name="l00593"></a>00593           <a class="code" href="classErrorVector.php">ErrorVector</a> *e = i-&gt;second;
<a name="l00594"></a>00594           <span class="comment">// First sum the vector of estimated error values</span>
<a name="l00595"></a>00595           this-&gt;<a class="code" href="classErrorEstimator.php#a6b108b6e9e10fd97df826209c15c8618">reduce_error</a>(*e);
<a name="l00596"></a>00596 
<a name="l00597"></a>00597           <span class="comment">// Compute the square-root of each component.</span>
<a name="l00598"></a>00598           START_LOG(<span class="stringliteral">&quot;std::sqrt()&quot;</span>, <span class="stringliteral">&quot;UniformRefinementEstimator&quot;</span>);
<a name="l00599"></a>00599           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;e-&gt;size(); i++)
<a name="l00600"></a>00600             <span class="keywordflow">if</span> ((*e)[i] != 0.)
<a name="l00601"></a>00601               (*e)[i] = std::sqrt((*e)[i]);
<a name="l00602"></a>00602           STOP_LOG(<span class="stringliteral">&quot;std::sqrt()&quot;</span>, <span class="stringliteral">&quot;UniformRefinementEstimator&quot;</span>);
<a name="l00603"></a>00603         }
<a name="l00604"></a>00604     }
<a name="l00605"></a>00605 
<a name="l00606"></a>00606   <span class="comment">// Restore old solutions and clean up the heap</span>
<a name="l00607"></a>00607   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != system_list.size(); ++i)
<a name="l00608"></a>00608     {
<a name="l00609"></a>00609       <a class="code" href="classSystem.php">System</a> &amp;system = *system_list[i];
<a name="l00610"></a>00610 
<a name="l00611"></a>00611       system.<a class="code" href="classSystem.php#a7ddea7f6e4a6530a18fcd0932e8bb7b8">project_solution_on_reinit</a>() = old_projection_settings[i];
<a name="l00612"></a>00612   
<a name="l00613"></a>00613       <span class="comment">// Restore the coarse solution vectors and delete their copies</span>
<a name="l00614"></a>00614       *system.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a> = *coarse_solutions[i];
<a name="l00615"></a>00615       <span class="keyword">delete</span> coarse_solutions[i];
<a name="l00616"></a>00616       *system.<a class="code" href="classSystem.php#a47b00cd00684aebe3c095aba010626e5">current_local_solution</a> = *coarse_local_solutions[i];
<a name="l00617"></a>00617       <span class="keyword">delete</span> coarse_local_solutions[i];
<a name="l00618"></a>00618       <span class="keyword">delete</span> projected_solutions[i];
<a name="l00619"></a>00619 
<a name="l00620"></a>00620       <span class="keywordflow">for</span> (<a class="code" href="classSystem.php#ac1939aeca6473017c8b6a560892e86aa">System::vectors_iterator</a> vec = system.<a class="code" href="classSystem.php#aa33cb0639b60f352561646fcce51a06b">vectors_begin</a>(); vec !=
<a name="l00621"></a>00621            system.<a class="code" href="classSystem.php#a0c1c70cc7f560cda430474eea1702082">vectors_end</a>(); ++vec)
<a name="l00622"></a>00622         {
<a name="l00623"></a>00623           <span class="comment">// The (string) name of this vector</span>
<a name="l00624"></a>00624           <span class="keyword">const</span> std::string&amp; var_name = vec-&gt;first;
<a name="l00625"></a>00625 
<a name="l00626"></a>00626           system.<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(var_name) = *coarse_vectors[i][var_name];
<a name="l00627"></a>00627 
<a name="l00628"></a>00628           coarse_vectors[i][var_name]-&gt;<a class="code" href="classNumericVector.php#a00f9162aaeaaf8658d3fc95408a778b6">clear</a>();
<a name="l00629"></a>00629           <span class="keyword">delete</span> coarse_vectors[i][var_name];
<a name="l00630"></a>00630         }
<a name="l00631"></a>00631     }
<a name="l00632"></a>00632 
<a name="l00633"></a>00633   <span class="comment">// Restore old partitioner settings</span>
<a name="l00634"></a>00634   mesh.<a class="code" href="classMeshBase.php#a4e91618481bb34ffff7e85ab2ee9b78f">partitioner</a>() = old_partitioner;
<a name="l00635"></a>00635 }
<a name="l00636"></a>00636 
<a name="l00637"></a>00637 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
