<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c8cf73965feff5280e8b0581da1a9d14.php">error_estimation</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>uniform_refinement_estimator.h</h1>  </div>
</div>
<div class="contents">
<a href="uniform__refinement__estimator_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: uniform_refinement_estimator.h 3435 2009-07-17 22:25:28Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __uniform_refinement_estimator_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __uniform_refinement_estimator_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="error__estimator_8h.php">error_estimator.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;libmesh.h&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span>
<a name="l00042"></a><a class="code" href="classUniformRefinementEstimator.php">00042</a> <span class="keyword">class </span><a class="code" href="classUniformRefinementEstimator.php">UniformRefinementEstimator</a> : <span class="keyword">public</span> <a class="code" href="classErrorEstimator.php">ErrorEstimator</a>
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044 <span class="keyword">public</span>:
<a name="l00045"></a>00045 
<a name="l00049"></a><a class="code" href="classUniformRefinementEstimator.php#a9e2282388b952dd276a7e1e3dc172020">00049</a>   <a class="code" href="classUniformRefinementEstimator.php#a9e2282388b952dd276a7e1e3dc172020">UniformRefinementEstimator</a>() : <a class="code" href="classUniformRefinementEstimator.php#a6f072582ef4e3b0c96f6b3b3c10e59ba">number_h_refinements</a>(1),
<a name="l00050"></a>00050                                  <a class="code" href="classUniformRefinementEstimator.php#ab57bc89a694285b9be394094be36975f">number_p_refinements</a>(0)
<a name="l00051"></a>00051   { <a class="code" href="classErrorEstimator.php#ac62239bfce2ba4a26d30910a120c876e">error_norm</a> = <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a7a46908fc35e8855517abd137413214c">H1</a>; }
<a name="l00052"></a>00052   
<a name="l00056"></a><a class="code" href="classUniformRefinementEstimator.php#a9252f5ad662316b347746d66f9e32f62">00056</a>   <a class="code" href="classUniformRefinementEstimator.php#a9252f5ad662316b347746d66f9e32f62">~UniformRefinementEstimator</a>() {}
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 
<a name="l00075"></a>00075   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classUniformRefinementEstimator.php#a359f8eb946eb1d0c07958210db88357e">estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; system,
<a name="l00076"></a>00076                                <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00077"></a>00077                                <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector = NULL,
<a name="l00078"></a>00078                                <span class="keywordtype">bool</span> estimate_parent_error = <span class="keyword">false</span>);
<a name="l00079"></a>00079 
<a name="l00087"></a>00087   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classUniformRefinementEstimator.php#a62241e99a743dcf9c0918ed405757f30">estimate_errors</a> (<span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; equation_systems,
<a name="l00088"></a>00088                                 <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00089"></a>00089                                 <span class="keyword">const</span> std::map&lt;const System*, SystemNorm&gt;&amp; error_norms,
<a name="l00090"></a>00090                                 <span class="keyword">const</span> std::map&lt;<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>*, <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* &gt;* solution_vectors = NULL,
<a name="l00091"></a>00091                                 <span class="keywordtype">bool</span> estimate_parent_error = <span class="keyword">false</span>);
<a name="l00092"></a>00092 
<a name="l00101"></a>00101   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classUniformRefinementEstimator.php#a62241e99a743dcf9c0918ed405757f30">estimate_errors</a> (<span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; equation_systems,
<a name="l00102"></a>00102                                 <a class="code" href="classErrorEstimator.php#a355a4dd519a02dca211c653b239dc597">ErrorMap</a>&amp; errors_per_cell,
<a name="l00103"></a>00103                                 <span class="keyword">const</span> std::map&lt;<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>*, <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* &gt;* solution_vectors = NULL,
<a name="l00104"></a>00104                                 <span class="keywordtype">bool</span> estimate_parent_error = <span class="keyword">false</span>);
<a name="l00105"></a>00105 
<a name="l00109"></a><a class="code" href="classUniformRefinementEstimator.php#a6f072582ef4e3b0c96f6b3b3c10e59ba">00109</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="classUniformRefinementEstimator.php#a6f072582ef4e3b0c96f6b3b3c10e59ba">number_h_refinements</a>;
<a name="l00110"></a>00110   
<a name="l00114"></a><a class="code" href="classUniformRefinementEstimator.php#ab57bc89a694285b9be394094be36975f">00114</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="classUniformRefinementEstimator.php#ab57bc89a694285b9be394094be36975f">number_p_refinements</a>;
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 <span class="keyword">protected</span>:
<a name="l00121"></a>00121   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classUniformRefinementEstimator.php#af952e291ea60c090873a49156a26f1f7">_estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a> *equation_systems,
<a name="l00122"></a>00122                                 <span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>* system,
<a name="l00123"></a>00123                                 <a class="code" href="classErrorVector.php">ErrorVector</a>* error_per_cell,
<a name="l00124"></a>00124                                 std::map&lt;std::pair&lt;const System*, unsigned int&gt;, <a class="code" href="classErrorVector.php">ErrorVector</a>*&gt;* errors_per_cell,
<a name="l00125"></a>00125                                 <span class="keyword">const</span> std::map&lt;const System*, SystemNorm &gt;* error_norms,
<a name="l00126"></a>00126                                 <span class="keyword">const</span> std::map&lt;<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>*, <span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>* &gt;* solution_vectors = NULL,
<a name="l00127"></a>00127                                 <span class="keywordtype">bool</span> estimate_parent_error = <span class="keyword">false</span>);
<a name="l00128"></a>00128 };
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00131"></a>00131 <span class="preprocessor"></span>
<a name="l00132"></a>00132 <span class="preprocessor">#endif</span>
<a name="l00133"></a>00133 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
