<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_60be1125a39495b698d2d56e8e5b50b1.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>unsteady_solver.C</h1>  </div>
</div>
<div class="contents">
<a href="unsteady__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: unsteady_solver.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;diff_solver.h&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;diff_system.h&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;dof_map.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;unsteady_solver.h&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a><a class="code" href="classUnsteadySolver.php#a59454633f646201dcddeb538f2ad16ef">00029</a> <a class="code" href="classUnsteadySolver.php#a59454633f646201dcddeb538f2ad16ef">UnsteadySolver::UnsteadySolver</a> (<a class="code" href="classDifferentiableSystem.php">sys_type</a>&amp; s)
<a name="l00030"></a>00030   : <a class="code" href="classTimeSolver.php">TimeSolver</a>(s),
<a name="l00031"></a>00031     old_local_nonlinear_solution (<a class="code" href="classNumericVector.php">NumericVector</a>&lt;<a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>&gt;::build()),
<a name="l00032"></a>00032     first_solve                  (true)
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 }
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a><a class="code" href="classUnsteadySolver.php#a5239c11bd418c85cf90713d82b4ab27f">00038</a> <a class="code" href="classUnsteadySolver.php#a5239c11bd418c85cf90713d82b4ab27f">UnsteadySolver::~UnsteadySolver</a> ()
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040 }
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a><a class="code" href="classUnsteadySolver.php#a4db65d76e91ab1808992307929f61728">00044</a> <span class="keywordtype">void</span> <a class="code" href="classUnsteadySolver.php#a4db65d76e91ab1808992307929f61728">UnsteadySolver::init</a> ()
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046   <a class="code" href="classUnsteadySolver.php#a4db65d76e91ab1808992307929f61728">TimeSolver::init</a>();
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classSystem.php#abab8a3810cc43d99fe395d449207b786">add_vector</a>(<span class="stringliteral">&quot;_old_nonlinear_solution&quot;</span>);
<a name="l00049"></a>00049 }
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a><a class="code" href="classUnsteadySolver.php#a7d22223ef7ea212e2f5d23612e992e18">00053</a> <span class="keywordtype">void</span> <a class="code" href="classUnsteadySolver.php#a7d22223ef7ea212e2f5d23612e992e18">UnsteadySolver::solve</a> ()
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055   <span class="keywordflow">if</span> (<a class="code" href="classUnsteadySolver.php#a7b5693645b13d3556af0a88dab40edee">first_solve</a>)
<a name="l00056"></a>00056     {
<a name="l00057"></a>00057       <a class="code" href="classUnsteadySolver.php#a356bfbfaa8a56bce1f67c92005c5de9a">advance_timestep</a>();
<a name="l00058"></a>00058       <a class="code" href="classUnsteadySolver.php#a7b5693645b13d3556af0a88dab40edee">first_solve</a> = <span class="keyword">false</span>;
<a name="l00059"></a>00059     }
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 <span class="preprocessor">#ifdef LIBMESH_ENABLE_GHOSTED</span>
<a name="l00062"></a>00062 <span class="preprocessor"></span>  <a class="code" href="classUnsteadySolver.php#a6375bafc6aac07ec0937feb5b732fc98">old_local_nonlinear_solution</a>-&gt;init (<a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classSystem.php#aa8f04263eed1eaf253e81041f166408b">n_dofs</a>(), <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classSystem.php#a401d38d088ef9140e51c455387af319d">n_local_dofs</a>(),
<a name="l00063"></a>00063                                       <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#a6c7f0c7286f9f067563e8da24d4f3955">get_send_list</a>(), <span class="keyword">false</span>,
<a name="l00064"></a>00064                                       <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>);
<a name="l00065"></a>00065 <span class="preprocessor">#else</span>
<a name="l00066"></a>00066 <span class="preprocessor"></span>  <a class="code" href="classUnsteadySolver.php#a6375bafc6aac07ec0937feb5b732fc98">old_local_nonlinear_solution</a>-&gt;init (<a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classSystem.php#aa8f04263eed1eaf253e81041f166408b">n_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>);
<a name="l00067"></a>00067 <span class="preprocessor">#endif</span>
<a name="l00068"></a>00068 <span class="preprocessor"></span>
<a name="l00069"></a>00069   <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;_old_nonlinear_solution&quot;</span>).<a class="code" href="classNumericVector.php#ab5d2d505bd3b8c09e6be4207379d901e">localize</a>
<a name="l00070"></a>00070     (*<a class="code" href="classUnsteadySolver.php#a6375bafc6aac07ec0937feb5b732fc98">old_local_nonlinear_solution</a>,
<a name="l00071"></a>00071      <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#a6c7f0c7286f9f067563e8da24d4f3955">get_send_list</a>());
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> solve_result = <a class="code" href="classTimeSolver.php#a44ce324d0ec130de42c1f7f4ac2a57f1">_diff_solver</a>-&gt;solve();
<a name="l00074"></a>00074 
<a name="l00075"></a>00075   <span class="comment">// If we requested the UnsteadySolver to attempt reducing dt after a</span>
<a name="l00076"></a>00076   <span class="comment">// failed DiffSolver solve, check the results of the solve now.</span>
<a name="l00077"></a>00077   <span class="keywordflow">if</span> (<a class="code" href="classTimeSolver.php#af0c2e219b40a5d9336ad2f81cfb1fbd6">reduce_deltat_on_diffsolver_failure</a>)
<a name="l00078"></a>00078     {
<a name="l00079"></a>00079       <span class="keywordtype">bool</span> backtracking_failed =
<a name="l00080"></a>00080         solve_result &amp; <a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eea130376f697142abacfd339d3f8d28edc">DiffSolver::DIVERGED_BACKTRACKING_FAILURE</a>;
<a name="l00081"></a>00081 
<a name="l00082"></a>00082       <span class="keywordtype">bool</span> max_iterations =
<a name="l00083"></a>00083         solve_result &amp; <a class="code" href="classDiffSolver.php#a53b19ea21f16ad97e89858bff63071eeabe4e5d049d7a788b52deae9ce8865b34">DiffSolver::DIVERGED_MAX_NONLINEAR_ITERATIONS</a>;
<a name="l00084"></a>00084         
<a name="l00085"></a>00085       <span class="keywordflow">if</span> (backtracking_failed || max_iterations)
<a name="l00086"></a>00086         {
<a name="l00087"></a>00087           <span class="comment">// Cut timestep in half</span>
<a name="l00088"></a>00088           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nr=0; nr&lt;<a class="code" href="classTimeSolver.php#af0c2e219b40a5d9336ad2f81cfb1fbd6">reduce_deltat_on_diffsolver_failure</a>; ++nr)
<a name="l00089"></a>00089             {
<a name="l00090"></a>00090               <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a> *= 0.5;
<a name="l00091"></a>00091               std::cout &lt;&lt; <span class="stringliteral">&quot;Newton backtracking failed.  Trying with smaller timestep, dt=&quot;</span>
<a name="l00092"></a>00092                         &lt;&lt; <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a> &lt;&lt; std::endl;
<a name="l00093"></a>00093 
<a name="l00094"></a>00094               solve_result = <a class="code" href="classTimeSolver.php#a44ce324d0ec130de42c1f7f4ac2a57f1">_diff_solver</a>-&gt;solve();
<a name="l00095"></a>00095 
<a name="l00096"></a>00096               <span class="comment">// Check solve results with reduced timestep</span>
<a name="l00097"></a>00097               <span class="keywordtype">bool</span> backtracking_failed =
<a name="l00098"></a>00098                 solve_result &amp; DiffSolver::DIVERGED_BACKTRACKING_FAILURE;
<a name="l00099"></a>00099               
<a name="l00100"></a>00100               <span class="keywordtype">bool</span> max_iterations =
<a name="l00101"></a>00101                 solve_result &amp; DiffSolver::DIVERGED_MAX_NONLINEAR_ITERATIONS;
<a name="l00102"></a>00102 
<a name="l00103"></a>00103               <span class="keywordflow">if</span> (!backtracking_failed &amp;&amp; !max_iterations)
<a name="l00104"></a>00104                 {
<a name="l00105"></a>00105                   <span class="keywordflow">if</span> (!<a class="code" href="classTimeSolver.php#a89d506f1634a4d0a9578ff3773050a8b">quiet</a>)
<a name="l00106"></a>00106                     std::cout &lt;&lt; <span class="stringliteral">&quot;Reduced dt solve succeeded.&quot;</span> &lt;&lt; std::endl;
<a name="l00107"></a>00107                   <span class="keywordflow">return</span>;
<a name="l00108"></a>00108                 }
<a name="l00109"></a>00109             }
<a name="l00110"></a>00110 
<a name="l00111"></a>00111           <span class="comment">// If we made it here, we still couldn&#39;t converge the solve after</span>
<a name="l00112"></a>00112           <span class="comment">// reducing deltat</span>
<a name="l00113"></a>00113           std::cout &lt;&lt; <span class="stringliteral">&quot;DiffSolver::solve() did not succeed after &quot;</span>
<a name="l00114"></a>00114                     &lt;&lt; reduce_deltat_on_diffsolver_failure
<a name="l00115"></a>00115                     &lt;&lt; <span class="stringliteral">&quot; attempts.&quot;</span> &lt;&lt; std::endl;
<a name="l00116"></a>00116           libmesh_convergence_failure();
<a name="l00117"></a>00117           
<a name="l00118"></a>00118         } <span class="comment">// end if (backtracking_failed || max_iterations)</span>
<a name="l00119"></a>00119     } <span class="comment">// end if (reduce_deltat_on_diffsolver_failure)</span>
<a name="l00120"></a>00120 }
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 
<a name="l00124"></a><a class="code" href="classUnsteadySolver.php#a356bfbfaa8a56bce1f67c92005c5de9a">00124</a> <span class="keywordtype">void</span> <a class="code" href="classUnsteadySolver.php#a356bfbfaa8a56bce1f67c92005c5de9a">UnsteadySolver::advance_timestep</a> ()
<a name="l00125"></a>00125 {
<a name="l00126"></a>00126   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp;<a class="code" href="classUnsteadySolver.php#ad14f2816697932209a6996937dd8ff18">old_nonlinear_solution</a> =
<a name="l00127"></a>00127   <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;_old_nonlinear_solution&quot;</span>);
<a name="l00128"></a>00128   <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a> &amp;nonlinear_solution =
<a name="l00129"></a>00129     *(<a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>);
<a name="l00130"></a>00130 
<a name="l00131"></a>00131   old_nonlinear_solution = nonlinear_solution;
<a name="l00132"></a>00132 
<a name="l00133"></a>00133   <span class="keywordflow">if</span> (!<a class="code" href="classUnsteadySolver.php#a7b5693645b13d3556af0a88dab40edee">first_solve</a>)
<a name="l00134"></a>00134     <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a011fade55c7e62bea01e1e195a9d78b1">time</a> += <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#a740cd32c708afacaf9fbb70ea57a0596">deltat</a>;
<a name="l00135"></a>00135 }
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00139"></a><a class="code" href="classUnsteadySolver.php#ad14f2816697932209a6996937dd8ff18">00139</a> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classUnsteadySolver.php#ad14f2816697932209a6996937dd8ff18">UnsteadySolver::old_nonlinear_solution</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_dof_number)<span class="keyword"></span>
<a name="l00140"></a>00140 <span class="keyword">const</span>
<a name="l00141"></a>00141 <span class="keyword"></span>{
<a name="l00142"></a>00142   libmesh_assert (global_dof_number &lt; <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classSystem.php#af5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#ae7db3f0773e85ababc4f9db1cfa24d3e">n_dofs</a>());
<a name="l00143"></a>00143   libmesh_assert (global_dof_number &lt; old_local_nonlinear_solution-&gt;size());
<a name="l00144"></a>00144 
<a name="l00145"></a>00145   <span class="keywordflow">return</span> (*<a class="code" href="classUnsteadySolver.php#a6375bafc6aac07ec0937feb5b732fc98">old_local_nonlinear_solution</a>)(global_dof_number);
<a name="l00146"></a>00146 }
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00150"></a><a class="code" href="classUnsteadySolver.php#aa5c0dec04573708e713f465da01a9fa0">00150</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classUnsteadySolver.php#aa5c0dec04573708e713f465da01a9fa0">UnsteadySolver::du</a>(<span class="keyword">const</span> <a class="code" href="classSystemNorm.php">SystemNorm</a> &amp;norm)<span class="keyword"> const</span>
<a name="l00151"></a>00151 <span class="keyword"></span>{
<a name="l00152"></a>00152 
<a name="l00153"></a>00153   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; solution_copy =
<a name="l00154"></a>00154     <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;clone();
<a name="l00155"></a>00155 
<a name="l00156"></a>00156   solution_copy-&gt;add(-1., <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classSystem.php#a5aa65d8fbe93201345cc41c8dca54c22">get_vector</a>(<span class="stringliteral">&quot;_old_nonlinear_solution&quot;</span>));
<a name="l00157"></a>00157 
<a name="l00158"></a>00158   solution_copy-&gt;close();
<a name="l00159"></a>00159 
<a name="l00160"></a>00160   <span class="keywordflow">return</span> <a class="code" href="classTimeSolver.php#a6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classSystem.php#a9b8d41c541d5fba295a6e9989939b443">calculate_norm</a>(*solution_copy, norm);
<a name="l00161"></a>00161 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
