<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_e008012082c29ebdf960c09cd3fd2542.php">solvers</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>unsteady_solver.h</h1>  </div>
</div>
<div class="contents">
<a href="unsteady__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: unsteady_solver.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __unsteady_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __unsteady_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;auto_ptr.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="time__solver_8h.php">time_solver.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Forward Declarations</span>
<a name="l00034"></a>00034 <span class="keyword">class </span><a class="code" href="classUnsteadySolver.php">UnsteadySolver</a>;
<a name="l00035"></a>00035 
<a name="l00050"></a>00050 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00051"></a>00051 <span class="comment">// UnsteadySolver class definition</span>
<a name="l00052"></a><a class="code" href="classUnsteadySolver.php">00052</a> <span class="keyword">class </span><a class="code" href="classUnsteadySolver.php">UnsteadySolver</a> : <span class="keyword">public</span> <a class="code" href="classTimeSolver.php">TimeSolver</a>
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054 <span class="keyword">public</span>:
<a name="l00059"></a>00059   <a class="code" href="classUnsteadySolver.php#a59454633f646201dcddeb538f2ad16ef">UnsteadySolver</a> (<a class="code" href="classDifferentiableSystem.php">sys_type</a>&amp; s);
<a name="l00060"></a>00060   
<a name="l00064"></a>00064   <span class="keyword">virtual</span> <a class="code" href="classUnsteadySolver.php#a5239c11bd418c85cf90713d82b4ab27f">~UnsteadySolver</a> ();
<a name="l00065"></a>00065 
<a name="l00070"></a>00070   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classUnsteadySolver.php#a4db65d76e91ab1808992307929f61728">init</a> ();
<a name="l00071"></a>00071 
<a name="l00077"></a>00077   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classUnsteadySolver.php#a7d22223ef7ea212e2f5d23612e992e18">solve</a> ();
<a name="l00078"></a>00078 
<a name="l00085"></a>00085   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classUnsteadySolver.php#a356bfbfaa8a56bce1f67c92005c5de9a">advance_timestep</a> ();
<a name="l00086"></a>00086 
<a name="l00094"></a>00094   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classUnsteadySolver.php#aaa3850b3d1f4b361c4f48bbfee21dc95">error_order</a> () <span class="keyword">const</span> = 0;
<a name="l00095"></a>00095 
<a name="l00100"></a>00100   <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a> <a class="code" href="classUnsteadySolver.php#ad14f2816697932209a6996937dd8ff18">old_nonlinear_solution</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_dof_number) <span class="keyword">const</span>;
<a name="l00101"></a>00101 
<a name="l00105"></a><a class="code" href="classUnsteadySolver.php#a6375bafc6aac07ec0937feb5b732fc98">00105</a>   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; <a class="code" href="classUnsteadySolver.php#a6375bafc6aac07ec0937feb5b732fc98">old_local_nonlinear_solution</a>;
<a name="l00106"></a>00106 
<a name="l00116"></a>00116   <span class="keyword">virtual</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classUnsteadySolver.php#aa5c0dec04573708e713f465da01a9fa0">du</a>(<span class="keyword">const</span> <a class="code" href="classSystemNorm.php">SystemNorm</a>&amp; norm) <span class="keyword">const</span>;
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 <span class="keyword">protected</span>:
<a name="l00119"></a>00119 
<a name="l00124"></a><a class="code" href="classUnsteadySolver.php#a7b5693645b13d3556af0a88dab40edee">00124</a>   <span class="keywordtype">bool</span> <a class="code" href="classUnsteadySolver.php#a7b5693645b13d3556af0a88dab40edee">first_solve</a>;
<a name="l00125"></a>00125 };
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 <span class="preprocessor">#endif // #define __time_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
