<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>unstructured_mesh.C</h1>  </div>
</div>
<div class="contents">
<a href="unstructured__mesh_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: unstructured_mesh.C 3475 2009-09-28 16:20:59Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// C includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;unistd.h&gt;</span>  <span class="comment">// for unlink()</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;boundary_info.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;unstructured_mesh.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;mesh_communication.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;mesh_tools.h&quot;</span> <span class="comment">// For n_levels</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;parallel.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;remote_elem.h&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;diva_io.h&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;exodusII_io.h&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;gmv_io.h&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;tecplot_io.h&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &quot;tetgen_io.h&quot;</span>
<a name="l00043"></a>00043 <span class="preprocessor">#include &quot;ucd_io.h&quot;</span>
<a name="l00044"></a>00044 <span class="preprocessor">#include &quot;unv_io.h&quot;</span>
<a name="l00045"></a>00045 <span class="preprocessor">#include &quot;matlab_io.h&quot;</span>
<a name="l00046"></a>00046 <span class="preprocessor">#include &quot;off_io.h&quot;</span>
<a name="l00047"></a>00047 <span class="preprocessor">#include &quot;medit_io.h&quot;</span>
<a name="l00048"></a>00048 <span class="preprocessor">#include &quot;gmsh_io.h&quot;</span>
<a name="l00049"></a>00049 <span class="preprocessor">#include &quot;fro_io.h&quot;</span>
<a name="l00050"></a>00050 <span class="preprocessor">#include &quot;xdr_io.h&quot;</span>
<a name="l00051"></a>00051 <span class="preprocessor">#include &quot;legacy_xdr_io.h&quot;</span>
<a name="l00052"></a>00052 <span class="preprocessor">#include &quot;vtk_io.h&quot;</span>
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 <span class="preprocessor">#if   defined(LIBMESH_HAVE_TR1_UNORDERED_MAP)</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span><span class="preprocessor"># include &lt;tr1/unordered_map&gt;</span>
<a name="l00056"></a>00056 <span class="preprocessor">#elif defined(LIBMESH_HAVE_UNORDERED_MAP)</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span><span class="preprocessor"># include &lt;unordered_map&gt;</span>
<a name="l00058"></a>00058 <span class="preprocessor">#elif defined(LIBMESH_HAVE_HASH_MAP)</span>
<a name="l00059"></a>00059 <span class="preprocessor"></span><span class="preprocessor"># include &lt;hash_map&gt;</span>
<a name="l00060"></a>00060 <span class="preprocessor">#elif defined(LIBMESH_HAVE_EXT_HASH_MAP)</span>
<a name="l00061"></a>00061 <span class="preprocessor"></span><span class="preprocessor"># include &lt;ext/hash_map&gt;</span>
<a name="l00062"></a>00062 <span class="preprocessor">#else</span>
<a name="l00063"></a>00063 <span class="preprocessor"></span><span class="preprocessor"># include &lt;map&gt;</span>
<a name="l00064"></a>00064 <span class="preprocessor">#endif</span>
<a name="l00065"></a>00065 <span class="preprocessor"></span>
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00069"></a>00069 <span class="comment">// Anonymous namespace for implementation details</span>
<a name="l00070"></a>00070 <span class="keyword">namespace </span>{
<a name="l00071"></a>00071   <span class="keywordtype">bool</span> is_parallel_file_format (<span class="keyword">const</span> std::string &amp;<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00072"></a>00072   {
<a name="l00073"></a>00073     <span class="comment">// Certain mesh formats support parallel I/O, including the</span>
<a name="l00074"></a>00074     <span class="comment">// &quot;new&quot; Xdr format.</span>
<a name="l00075"></a>00075     <span class="keywordflow">return</span> ((name.rfind(<span class="stringliteral">&quot;.xda&quot;</span>) &lt; name.size()) ||
<a name="l00076"></a>00076             (name.rfind(<span class="stringliteral">&quot;.xdr&quot;</span>) &lt; name.size())
<a name="l00077"></a>00077             );
<a name="l00078"></a>00078   }
<a name="l00079"></a>00079 }
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00084"></a>00084 <span class="comment">// UnstructuredMesh class member functions</span>
<a name="l00085"></a><a class="code" href="classUnstructuredMesh.php#ab9f99e6f8588059a7e2ad8c76d9c9ff4">00085</a> <a class="code" href="classUnstructuredMesh.php#ab9f99e6f8588059a7e2ad8c76d9c9ff4">UnstructuredMesh::UnstructuredMesh</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d) :
<a name="l00086"></a>00086   <a class="code" href="classMeshBase.php">MeshBase</a> (d)
<a name="l00087"></a>00087 {
<a name="l00088"></a>00088   libmesh_assert (<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">libMesh::initialized</a>());
<a name="l00089"></a>00089 }
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 <span class="keywordtype">void</span> <a class="code" href="classUnstructuredMesh.php#afecc40762dc88b1ef471a9d4a3938f4c">UnstructuredMesh::copy_nodes_and_elements</a> 
<a name="l00094"></a><a class="code" href="classUnstructuredMesh.php#afecc40762dc88b1ef471a9d4a3938f4c">00094</a>   (<span class="keyword">const</span> <a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; other_mesh)
<a name="l00095"></a>00095 {
<a name="l00096"></a>00096   <span class="comment">// We&#39;re assuming our subclass data needs no copy</span>
<a name="l00097"></a>00097   libmesh_assert(_n_sbd == other_mesh.<a class="code" href="classMeshBase.php#af28478381f2803a30aaf1d925df4c673">_n_sbd</a>);
<a name="l00098"></a>00098   libmesh_assert(_n_parts == other_mesh.<a class="code" href="classMeshBase.php#ad6717b5155fa3c20c3fa5a419ea307bd">_n_parts</a>);
<a name="l00099"></a>00099   libmesh_assert(_dim == other_mesh.<a class="code" href="classMeshBase.php#a9a02b0f83c0debf7395aa48edb030c39">_dim</a>);
<a name="l00100"></a>00100   libmesh_assert(_is_prepared == other_mesh.<a class="code" href="classMeshBase.php#a1322dbb0d67f763b24ea50fc872cb4f2">_is_prepared</a>);
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   <span class="comment">//Copy in Nodes</span>
<a name="l00103"></a>00103   {
<a name="l00104"></a>00104     <span class="comment">//Preallocate Memory if necessary</span>
<a name="l00105"></a>00105     this-&gt;reserve_nodes(other_mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l00106"></a>00106     
<a name="l00107"></a>00107     <a class="code" href="structMeshBase_1_1const__node__iterator.php">const_node_iterator</a> it = other_mesh.<a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
<a name="l00108"></a>00108     <a class="code" href="structMeshBase_1_1const__node__iterator.php">const_node_iterator</a> end = other_mesh.<a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
<a name="l00109"></a>00109 
<a name="l00110"></a>00110     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00111"></a>00111       {
<a name="l00112"></a>00112         <a class="code" href="classNode.php">Node</a> *oldn = *it;
<a name="l00113"></a>00113 
<a name="l00114"></a>00114         <span class="comment">// Add new nodes in old node Point locations</span>
<a name="l00115"></a>00115         <a class="code" href="classNode.php">Node</a> *newn = this-&gt;add_point(*oldn);
<a name="l00116"></a>00116 
<a name="l00117"></a>00117         <span class="comment">// And start them off in the same subdomain</span>
<a name="l00118"></a>00118         newn-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() = oldn-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>();
<a name="l00119"></a>00119       }
<a name="l00120"></a>00120   }
<a name="l00121"></a>00121   
<a name="l00122"></a>00122   <span class="comment">//Copy in Elements</span>
<a name="l00123"></a>00123   {
<a name="l00124"></a>00124     <span class="comment">//Preallocate Memory if necessary</span>
<a name="l00125"></a>00125     this-&gt;reserve_elem(other_mesh.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>());
<a name="l00126"></a>00126     
<a name="l00127"></a>00127     <span class="comment">// Loop over the elements</span>
<a name="l00128"></a>00128     <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> it = other_mesh.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00129"></a>00129     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = other_mesh.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00130"></a>00130 
<a name="l00131"></a>00131     <span class="comment">// FIXME: Where do we set element IDs??</span>
<a name="l00132"></a>00132     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00133"></a>00133     {
<a name="l00134"></a>00134       <span class="comment">//Look at the old element</span>
<a name="l00135"></a>00135       <a class="code" href="classElem.php">Elem</a> *old = *it;
<a name="l00136"></a>00136       <span class="comment">//Build a new element</span>
<a name="l00137"></a>00137       <a class="code" href="classElem.php">Elem</a> *newparent = old-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>() ?
<a name="l00138"></a>00138           this-&gt;elem(old-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>()-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()) : NULL;
<a name="l00139"></a>00139       <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap = <a class="code" href="classElem.php#a7f46524fbd44a76f940435d6a1434a9d">Elem::build</a>(old-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>(), newparent);
<a name="l00140"></a>00140       <a class="code" href="classElem.php">Elem</a> * elem = ap.release();
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00143"></a>00143 <span class="preprocessor"></span>      <span class="comment">//Create the parent&#39;s child pointers if necessary</span>
<a name="l00144"></a>00144       <span class="keywordflow">if</span> (newparent)
<a name="l00145"></a>00145         {
<a name="l00146"></a>00146           <span class="comment">// Make sure we have space for those child pointers</span>
<a name="l00147"></a>00147           newparent-&gt;<a class="code" href="classElem.php#a791ed16f88c661c7ed22e10e0cf8d8ff">add_child</a>(elem);
<a name="l00148"></a>00148 
<a name="l00149"></a>00149           <span class="comment">// We&#39;d better be adding these in the correct order</span>
<a name="l00150"></a>00150           libmesh_assert (newparent-&gt;<a class="code" href="classElem.php#a72cd45e535e8bebac68a57a362a60fef">which_child_am_i</a>(elem) ==
<a name="l00151"></a>00151                   old-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>()-&gt;<a class="code" href="classElem.php#a72cd45e535e8bebac68a57a362a60fef">which_child_am_i</a>(old));
<a name="l00152"></a>00152         }
<a name="l00153"></a>00153       
<a name="l00154"></a>00154       <span class="comment">// Copy the refinement flags</span>
<a name="l00155"></a>00155       elem-&gt;set_refinement_flag(old-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>());
<a name="l00156"></a>00156       elem-&gt;set_p_refinement_flag(old-&gt;<a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>());
<a name="l00157"></a>00157 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00158"></a>00158 <span class="preprocessor"></span>
<a name="l00159"></a>00159       <span class="comment">//Assign all the nodes</span>
<a name="l00160"></a>00160       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0;i&lt;elem-&gt;n_nodes();i++)
<a name="l00161"></a>00161         elem-&gt;set_node(i) = &amp;this-&gt;node(old-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(i));
<a name="l00162"></a>00162       
<a name="l00163"></a>00163       <span class="comment">//Hold onto it</span>
<a name="l00164"></a>00164       this-&gt;add_elem(elem);
<a name="l00165"></a>00165 
<a name="l00166"></a>00166       <span class="comment">// And start it off in the same subdomain</span>
<a name="l00167"></a>00167       elem-&gt;processor_id() = old-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>();
<a name="l00168"></a>00168     }
<a name="l00169"></a>00169   }
<a name="l00170"></a>00170   
<a name="l00171"></a>00171   <span class="comment">//Finally prepare the Mesh for use</span>
<a name="l00172"></a>00172   this-&gt;prepare_for_use();
<a name="l00173"></a>00173 }
<a name="l00174"></a>00174  
<a name="l00175"></a>00175  
<a name="l00176"></a>00176 
<a name="l00177"></a><a class="code" href="classUnstructuredMesh.php#a9fb8afbacf4616b15adc57dc9596ea8a">00177</a> <a class="code" href="classUnstructuredMesh.php#a9fb8afbacf4616b15adc57dc9596ea8a">UnstructuredMesh::~UnstructuredMesh</a> ()
<a name="l00178"></a>00178 {
<a name="l00179"></a>00179 <span class="comment">//  this-&gt;clear ();  // Nothing to clear at this level</span>
<a name="l00180"></a>00180   
<a name="l00181"></a>00181   libmesh_assert (!<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">libMesh::closed</a>());
<a name="l00182"></a>00182 }
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 
<a name="l00186"></a><a class="code" href="classUnstructuredMesh.php#a98c765606a6c53e090c2595b739201ff">00186</a> <span class="keywordtype">void</span> <a class="code" href="classUnstructuredMesh.php#a98c765606a6c53e090c2595b739201ff">UnstructuredMesh::find_neighbors</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> reset_remote_elements,
<a name="l00187"></a>00187                                        <span class="keyword">const</span> <span class="keywordtype">bool</span> reset_current_list)
<a name="l00188"></a>00188 {
<a name="l00189"></a>00189   <span class="comment">// We might actually want to run this on an empty mesh</span>
<a name="l00190"></a>00190   <span class="comment">// (e.g. the boundary mesh for a nonexistant bcid!)</span>
<a name="l00191"></a>00191   <span class="comment">// libmesh_assert(this-&gt;n_nodes() != 0);</span>
<a name="l00192"></a>00192   <span class="comment">// libmesh_assert(this-&gt;n_elem()  != 0);</span>
<a name="l00193"></a>00193 
<a name="l00194"></a>00194   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00195"></a>00195   parallel_only();
<a name="l00196"></a>00196 
<a name="l00197"></a>00197   START_LOG(<span class="stringliteral">&quot;find_neighbors()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00198"></a>00198   
<a name="l00199"></a>00199   
<a name="l00200"></a>00200   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> el_end = this-&gt;<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00201"></a>00201       
<a name="l00202"></a>00202   <span class="comment">//TODO:[BSK] This should be removed later?!</span>
<a name="l00203"></a>00203   <span class="keywordflow">if</span> (reset_current_list)
<a name="l00204"></a>00204     <span class="keywordflow">for</span> (<a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> el = this-&gt;<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>(); el != el_end; ++el)
<a name="l00205"></a>00205       {
<a name="l00206"></a>00206         <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a> = *el;
<a name="l00207"></a>00207         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); s++)
<a name="l00208"></a>00208           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s) != <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a> ||
<a name="l00209"></a>00209               reset_remote_elements)
<a name="l00210"></a>00210             elem-&gt;<a class="code" href="classElem.php#a88d676b002db35d70e0915d10c606f7f">set_neighbor</a>(s,NULL);
<a name="l00211"></a>00211       }
<a name="l00212"></a>00212   
<a name="l00213"></a>00213   <span class="comment">// Find neighboring elements by first finding elements</span>
<a name="l00214"></a>00214   <span class="comment">// with identical side keys and then check to see if they</span>
<a name="l00215"></a>00215   <span class="comment">// are neighbors</span>
<a name="l00216"></a>00216   {
<a name="l00217"></a>00217     <span class="comment">// data structures -- Use the hash_multimap if available</span>
<a name="l00218"></a>00218     <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>                    key_type;
<a name="l00219"></a>00219     <span class="keyword">typedef</span> std::pair&lt;Elem*, unsigned char&gt; val_type;
<a name="l00220"></a>00220     <span class="keyword">typedef</span> std::pair&lt;key_type, val_type&gt;   key_val_pair;
<a name="l00221"></a>00221     
<a name="l00222"></a>00222 <span class="preprocessor">#if   defined(LIBMESH_HAVE_UNORDERED_MAP)</span>
<a name="l00223"></a>00223 <span class="preprocessor"></span>    <span class="keyword">typedef</span> std::unordered_multimap&lt;key_type, val_type&gt; map_type;    
<a name="l00224"></a>00224 <span class="preprocessor">#elif defined(LIBMESH_HAVE_TR1_UNORDERED_MAP)</span>
<a name="l00225"></a>00225 <span class="preprocessor"></span>    <span class="keyword">typedef</span> std::tr1::unordered_multimap&lt;key_type, val_type&gt; map_type;    
<a name="l00226"></a>00226 <span class="preprocessor">#elif defined(LIBMESH_HAVE_HASH_MAP)    </span>
<a name="l00227"></a>00227 <span class="preprocessor"></span>    <span class="keyword">typedef</span> std::hash_multimap&lt;key_type, val_type&gt; map_type;    
<a name="l00228"></a>00228 <span class="preprocessor">#elif defined(LIBMESH_HAVE_EXT_HASH_MAP)</span>
<a name="l00229"></a>00229 <span class="preprocessor"></span><span class="preprocessor"># if    (__GNUC__ == 3) &amp;&amp; (__GNUC_MINOR__ == 0) // gcc 3.0   </span>
<a name="l00230"></a>00230 <span class="preprocessor"></span>    <span class="keyword">typedef</span> std::hash_multimap&lt;key_type, val_type&gt; map_type;
<a name="l00231"></a>00231 <span class="preprocessor"># elif (__GNUC__ &gt;= 3)                          // gcc 3.1 &amp; newer</span>
<a name="l00232"></a>00232 <span class="preprocessor"></span>    <span class="keyword">typedef</span> __gnu_cxx::hash_multimap&lt;key_type, val_type&gt; map_type;
<a name="l00233"></a>00233 <span class="preprocessor"># else</span>
<a name="l00234"></a>00234 <span class="preprocessor"></span><span class="comment">// XLC and who knows what other compilers get here.</span>
<a name="l00235"></a>00235 <span class="comment">// Try the most standard thing we can:</span>
<a name="l00236"></a>00236     <span class="keyword">typedef</span> std::multimap&lt;key_type, val_type&gt;  map_type;
<a name="l00237"></a>00237 <span class="preprocessor"># endif</span>
<a name="l00238"></a>00238 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00239"></a>00239 <span class="preprocessor"></span>    <span class="keyword">typedef</span> std::multimap&lt;key_type, val_type&gt;  map_type;
<a name="l00240"></a>00240 <span class="preprocessor">#endif</span>
<a name="l00241"></a>00241 <span class="preprocessor"></span>    
<a name="l00242"></a>00242     <span class="comment">// A map from side keys to corresponding elements &amp; side numbers  </span>
<a name="l00243"></a>00243     map_type side_to_elem_map;
<a name="l00244"></a>00244   
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 
<a name="l00247"></a>00247     <span class="keywordflow">for</span> (<a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> el = this-&gt;<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>(); el != el_end; ++el)
<a name="l00248"></a>00248       {
<a name="l00249"></a>00249         <a class="code" href="classElem.php">Elem</a>* element = *el;
<a name="l00250"></a>00250 
<a name="l00251"></a>00251         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ms=0; ms&lt;element-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); ms++)
<a name="l00252"></a>00252           {
<a name="l00253"></a>00253           next_side:
<a name="l00254"></a>00254             <span class="comment">// If we haven&#39;t yet found a neighbor on this side, try.</span>
<a name="l00255"></a>00255             <span class="comment">// Even if we think our neighbor is remote, that</span>
<a name="l00256"></a>00256             <span class="comment">// information may be out of date.</span>
<a name="l00257"></a>00257             <span class="keywordflow">if</span> (element-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(ms) == NULL ||
<a name="l00258"></a>00258                 element-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(ms) == <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>)
<a name="l00259"></a>00259               {
<a name="l00260"></a>00260                 <span class="comment">// Get the key for the side of this element</span>
<a name="l00261"></a>00261                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> key = element-&gt;<a class="code" href="classElem.php#af52fd4fdab067f6ba696257af8d3992a">key</a>(ms);
<a name="l00262"></a>00262                 
<a name="l00263"></a>00263                 <span class="comment">// Look for elements that have an identical side key</span>
<a name="l00264"></a>00264                 std::pair &lt;map_type::iterator, map_type::iterator&gt;
<a name="l00265"></a>00265                   bounds = side_to_elem_map.equal_range(key);
<a name="l00266"></a>00266                 
<a name="l00267"></a>00267                 <span class="comment">// May be multiple keys, check all the possible</span>
<a name="l00268"></a>00268                 <span class="comment">// elements which _might_ be neighbors.</span>
<a name="l00269"></a>00269                 <span class="keywordflow">if</span> (bounds.first != bounds.second)
<a name="l00270"></a>00270                   {
<a name="l00271"></a>00271                     <span class="comment">// Get the side for this element</span>
<a name="l00272"></a>00272                     <span class="keyword">const</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> my_side(element-&gt;<a class="code" href="classElem.php#a1688266bb86a98ef253c70807fb94fc5">side</a>(ms));
<a name="l00273"></a>00273 
<a name="l00274"></a>00274                     <span class="comment">// Look at all the entries with an equivalent key</span>
<a name="l00275"></a>00275                     <span class="keywordflow">while</span> (bounds.first != bounds.second)
<a name="l00276"></a>00276                       {
<a name="l00277"></a>00277                         <span class="comment">// Get the potential element</span>
<a name="l00278"></a>00278                         <a class="code" href="classElem.php">Elem</a>* neighbor = bounds.first-&gt;second.first;
<a name="l00279"></a>00279                         
<a name="l00280"></a>00280                         <span class="comment">// Get the side for the neighboring element</span>
<a name="l00281"></a>00281                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns = bounds.first-&gt;second.second;
<a name="l00282"></a>00282                         <span class="keyword">const</span> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DofObject&gt;</a> their_side(neighbor-&gt;<a class="code" href="classElem.php#a1688266bb86a98ef253c70807fb94fc5">side</a>(ns));
<a name="l00283"></a>00283                         <span class="comment">//libmesh_assert (my_side.get() != NULL);</span>
<a name="l00284"></a>00284                         <span class="comment">//libmesh_assert (their_side.get() != NULL);                    </span>
<a name="l00285"></a>00285 
<a name="l00286"></a>00286                         <span class="comment">// If found a match with my side</span>
<a name="l00287"></a>00287                         <span class="comment">//</span>
<a name="l00288"></a>00288                         <span class="comment">// We need special tests here for 1D:</span>
<a name="l00289"></a>00289                         <span class="comment">// since parents and children have an equal</span>
<a name="l00290"></a>00290                         <span class="comment">// side (i.e. a node), we need to check </span>
<a name="l00291"></a>00291                         <span class="comment">// ns != ms, and we also check level() to</span>
<a name="l00292"></a>00292                         <span class="comment">// avoid setting our neighbor pointer to</span>
<a name="l00293"></a>00293                         <span class="comment">// any of our neighbor&#39;s descendants</span>
<a name="l00294"></a>00294                         <span class="keywordflow">if</span>( (*my_side == *their_side) &amp;&amp; 
<a name="l00295"></a>00295                             (element-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() == neighbor-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>()) &amp;&amp;
<a name="l00296"></a>00296                             ((<a class="code" href="classMeshBase.php#a9a02b0f83c0debf7395aa48edb030c39">_dim</a> != 1) || (ns != ms)) )
<a name="l00297"></a>00297                           {
<a name="l00298"></a>00298                             <span class="comment">// So share a side.  Is this a mixed pair</span>
<a name="l00299"></a>00299                             <span class="comment">// of subactive and active/ancestor</span>
<a name="l00300"></a>00300                             <span class="comment">// elements?</span>
<a name="l00301"></a>00301                             <span class="comment">// If not, then we&#39;re neighbors.</span>
<a name="l00302"></a>00302                             <span class="comment">// If so, then the subactive&#39;s neighbor is </span>
<a name="l00303"></a>00303 
<a name="l00304"></a>00304                               <span class="keywordflow">if</span> (element-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>() ==
<a name="l00305"></a>00305                                   neighbor-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>())
<a name="l00306"></a>00306                               {
<a name="l00307"></a>00307                               <span class="comment">// an element is only subactive if it has</span>
<a name="l00308"></a>00308                               <span class="comment">// been coarsened but not deleted</span>
<a name="l00309"></a>00309                                 element-&gt;<a class="code" href="classElem.php#a88d676b002db35d70e0915d10c606f7f">set_neighbor</a> (ms,neighbor);
<a name="l00310"></a>00310                                 neighbor-&gt;<a class="code" href="classElem.php#a88d676b002db35d70e0915d10c606f7f">set_neighbor</a>(ns,element);
<a name="l00311"></a>00311                               }
<a name="l00312"></a>00312                               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (element-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>())
<a name="l00313"></a>00313                               {
<a name="l00314"></a>00314                                 element-&gt;<a class="code" href="classElem.php#a88d676b002db35d70e0915d10c606f7f">set_neighbor</a>(ms,neighbor);
<a name="l00315"></a>00315                               }
<a name="l00316"></a>00316                               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>())
<a name="l00317"></a>00317                               {
<a name="l00318"></a>00318                                 neighbor-&gt;<a class="code" href="classElem.php#a88d676b002db35d70e0915d10c606f7f">set_neighbor</a>(ns,element);
<a name="l00319"></a>00319                               }
<a name="l00320"></a>00320                               side_to_elem_map.erase (bounds.first);
<a name="l00321"></a>00321 
<a name="l00322"></a>00322                               <span class="comment">// get out of this nested crap</span>
<a name="l00323"></a>00323                               <span class="keywordflow">goto</span> next_side; 
<a name="l00324"></a>00324                           }
<a name="l00325"></a>00325 
<a name="l00326"></a>00326                         ++bounds.first;
<a name="l00327"></a>00327                       }
<a name="l00328"></a>00328                   }
<a name="l00329"></a>00329                     
<a name="l00330"></a>00330                 <span class="comment">// didn&#39;t find a match...</span>
<a name="l00331"></a>00331                 <span class="comment">// Build the map entry for this element</span>
<a name="l00332"></a>00332                 key_val_pair kvp;
<a name="l00333"></a>00333                 
<a name="l00334"></a>00334                 kvp.first         = key;
<a name="l00335"></a>00335                 kvp.second.first  = element;
<a name="l00336"></a>00336                 kvp.second.second = ms;
<a name="l00337"></a>00337                 
<a name="l00338"></a>00338                 <span class="comment">// use the lower bound as a hint for</span>
<a name="l00339"></a>00339                 <span class="comment">// where to put it.</span>
<a name="l00340"></a>00340 <span class="preprocessor">#if defined(LIBMESH_HAVE_UNORDERED_MAP) || defined(LIBMESH_HAVE_TR1_UNORDERED_MAP) || defined(LIBMESH_HAVE_HASH_MAP) || defined(LIBMESH_HAVE_EXT_HASH_MAP)</span>
<a name="l00341"></a>00341 <span class="preprocessor"></span>                side_to_elem_map.insert (kvp);
<a name="l00342"></a>00342 <span class="preprocessor">#else</span>
<a name="l00343"></a>00343 <span class="preprocessor"></span>                side_to_elem_map.insert (bounds.first,kvp);
<a name="l00344"></a>00344 <span class="preprocessor">#endif</span>
<a name="l00345"></a>00345 <span class="preprocessor"></span>              }
<a name="l00346"></a>00346           }
<a name="l00347"></a>00347       }
<a name="l00348"></a>00348   }
<a name="l00349"></a>00349 
<a name="l00350"></a>00350   
<a name="l00351"></a>00351   
<a name="l00352"></a>00352 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00353"></a>00353 <span class="preprocessor"></span>
<a name="l00372"></a>00372   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a467cd3c96ff9a03c0918d4df6ef16301">n_levels</a> = <a class="code" href="namespaceMeshTools.php#a467cd3c96ff9a03c0918d4df6ef16301">MeshTools::n_levels</a>(*<span class="keyword">this</span>);
<a name="l00373"></a>00373   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level = 1; level &lt; <a class="code" href="namespaceMeshTools.php#a467cd3c96ff9a03c0918d4df6ef16301">n_levels</a>; ++level)
<a name="l00374"></a>00374     {
<a name="l00375"></a>00375       <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> end = this-&gt;<a class="code" href="classMeshBase.php#a724dcfe5c7d4ad16f3ee09e22d6f1372">level_elements_end</a>(level);
<a name="l00376"></a>00376       <span class="keywordflow">for</span> (<a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> el = this-&gt;<a class="code" href="classMeshBase.php#a534079bde46c7d86cb976db76c697804">level_elements_begin</a>(level);
<a name="l00377"></a>00377            el != end; ++el)
<a name="l00378"></a>00378         {
<a name="l00379"></a>00379           <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a> = *el;
<a name="l00380"></a>00380           libmesh_assert(elem);
<a name="l00381"></a>00381           libmesh_assert(elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>());
<a name="l00382"></a>00382 
<a name="l00383"></a>00383           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s &lt; elem-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); s++)
<a name="l00384"></a>00384             <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s) == NULL)
<a name="l00385"></a>00385 <span class="comment">// This currently leads to an infinite loop in ex10?</span>
<a name="l00386"></a>00386 <span class="comment">//            if (elem-&gt;neighbor(s) == NULL ||</span>
<a name="l00387"></a>00387 <span class="comment">//              (elem-&gt;neighbor(s) == remote_elem &amp;&amp;</span>
<a name="l00388"></a>00388 <span class="comment">//               parent-&gt;is_child_on_side(parent-&gt;which_child_am_i(elem), s)))</span>
<a name="l00389"></a>00389             {       
<a name="l00390"></a>00390               <a class="code" href="classElem.php">Elem</a> *neigh = elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>()-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s);
<a name="l00391"></a>00391 
<a name="l00392"></a>00392               <span class="comment">// If neigh was refined and had non-subactive children</span>
<a name="l00393"></a>00393               <span class="comment">// made remote earlier, then a non-subactive elem should</span>
<a name="l00394"></a>00394               <span class="comment">// actually have one of those remote children as a</span>
<a name="l00395"></a>00395               <span class="comment">// neighbor</span>
<a name="l00396"></a>00396               <span class="keywordflow">if</span> (neigh &amp;&amp; (neigh-&gt;<a class="code" href="classElem.php#a3ad156b66b45310da85b653c791bd790">ancestor</a>()) &amp;&amp; (!elem-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>()))
<a name="l00397"></a>00397                 {
<a name="l00398"></a>00398 <span class="preprocessor">#ifdef DEBUG        </span>
<a name="l00399"></a>00399 <span class="preprocessor"></span>                  <span class="comment">// Let&#39;s make sure that &quot;had children made remote&quot;</span>
<a name="l00400"></a>00400                   <span class="comment">// situation is actually the case</span>
<a name="l00401"></a>00401                   libmesh_assert(neigh-&gt;<a class="code" href="classElem.php#a2ff2cfd3b4b05b8f091ba91eb068f81c">has_children</a>());
<a name="l00402"></a>00402                   <span class="keywordtype">bool</span> neigh_has_remote_children = <span class="keyword">false</span>;
<a name="l00403"></a>00403                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c = 0; c != neigh-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); ++c)
<a name="l00404"></a>00404                     {
<a name="l00405"></a>00405                       <span class="keywordflow">if</span> (neigh-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c) == <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>)
<a name="l00406"></a>00406                         neigh_has_remote_children = <span class="keyword">true</span>;
<a name="l00407"></a>00407                     }
<a name="l00408"></a>00408                   libmesh_assert(neigh_has_remote_children);
<a name="l00409"></a>00409 
<a name="l00410"></a>00410                   <span class="comment">// And let&#39;s double-check that we don&#39;t have</span>
<a name="l00411"></a>00411                   <span class="comment">// a remote_elem neighboring a local element</span>
<a name="l00412"></a>00412                   libmesh_assert(elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() !=
<a name="l00413"></a>00413                                  <a class="code" href="classMeshBase.php#aba369b64ee6185d86a6b60089ba5af60">libMesh::processor_id</a>());
<a name="l00414"></a>00414 <span class="preprocessor">#endif // DEBUG</span>
<a name="l00415"></a>00415 <span class="preprocessor"></span>                  neigh = <span class="keyword">const_cast&lt;</span><a class="code" href="classRemoteElem.php">RemoteElem</a>*<span class="keyword">&gt;</span>(<a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>);
<a name="l00416"></a>00416                 }
<a name="l00417"></a>00417 
<a name="l00418"></a>00418               elem-&gt;<a class="code" href="classElem.php#a88d676b002db35d70e0915d10c606f7f">set_neighbor</a>(s, neigh);
<a name="l00419"></a>00419 <span class="preprocessor">#ifdef DEBUG        </span>
<a name="l00420"></a>00420 <span class="preprocessor"></span>              <span class="keywordflow">if</span> (neigh != NULL &amp;&amp; neigh != <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>)
<a name="l00421"></a>00421                 <span class="comment">// We ignore subactive elements here because</span>
<a name="l00422"></a>00422                 <span class="comment">// we don&#39;t care about neighbors of subactive element.</span>
<a name="l00423"></a>00423                 <span class="keywordflow">if</span> ((!neigh-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>()) &amp;&amp; (!elem-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>()))
<a name="l00424"></a>00424                 {
<a name="l00425"></a>00425                   std::cerr &lt;&lt; <span class="stringliteral">&quot;On processor &quot;</span> &lt;&lt; <a class="code" href="classMeshBase.php#aba369b64ee6185d86a6b60089ba5af60">libMesh::processor_id</a>() 
<a name="l00426"></a>00426                             &lt;&lt; std::endl;
<a name="l00427"></a>00427                   std::cerr &lt;&lt; <span class="stringliteral">&quot;Bad element ID = &quot;</span> &lt;&lt; elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() 
<a name="l00428"></a>00428                     &lt;&lt; <span class="stringliteral">&quot;, Side &quot;</span> &lt;&lt; s &lt;&lt; <span class="stringliteral">&quot;, Bad neighbor ID = &quot;</span> &lt;&lt; neigh-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() &lt;&lt; std::endl;
<a name="l00429"></a>00429                   std::cerr &lt;&lt; <span class="stringliteral">&quot;Bad element proc_ID = &quot;</span> &lt;&lt; elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() 
<a name="l00430"></a>00430                     &lt;&lt; <span class="stringliteral">&quot;, Bad neighbor proc_ID = &quot;</span> &lt;&lt; neigh-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() &lt;&lt; std::endl;
<a name="l00431"></a>00431                   std::cerr &lt;&lt; <span class="stringliteral">&quot;Bad element size = &quot;</span> &lt;&lt; elem-&gt;<a class="code" href="classElem.php#a8483eb75ec4ccc49b41596557a3a367b">hmin</a>() 
<a name="l00432"></a>00432                     &lt;&lt; <span class="stringliteral">&quot;, Bad neighbor size = &quot;</span> &lt;&lt; neigh-&gt;<a class="code" href="classElem.php#a8483eb75ec4ccc49b41596557a3a367b">hmin</a>() &lt;&lt; std::endl;
<a name="l00433"></a>00433                   std::cerr &lt;&lt; <span class="stringliteral">&quot;Bad element center = &quot;</span> &lt;&lt; elem-&gt;<a class="code" href="classElem.php#a46ce080150f08ce9d367b69f16dd0452">centroid</a>() 
<a name="l00434"></a>00434                     &lt;&lt; <span class="stringliteral">&quot;, Bad neighbor center = &quot;</span> &lt;&lt; neigh-&gt;<a class="code" href="classElem.php#a46ce080150f08ce9d367b69f16dd0452">centroid</a>() &lt;&lt; std::endl;
<a name="l00435"></a>00435                   std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: &quot;</span> 
<a name="l00436"></a>00436                     &lt;&lt; (elem-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>()?<span class="stringliteral">&quot;Active&quot;</span>:<span class="stringliteral">&quot;Ancestor&quot;</span>)
<a name="l00437"></a>00437                     &lt;&lt; <span class="stringliteral">&quot; Element at level &quot;</span>
<a name="l00438"></a>00438                     &lt;&lt; elem-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() &lt;&lt; std::endl;
<a name="l00439"></a>00439                   std::cerr &lt;&lt; <span class="stringliteral">&quot;with &quot;</span>
<a name="l00440"></a>00440                     &lt;&lt; (elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>()-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>()?<span class="stringliteral">&quot;active&quot;</span>:
<a name="l00441"></a>00441                         (elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>()-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>()?<span class="stringliteral">&quot;subactive&quot;</span>:<span class="stringliteral">&quot;ancestor&quot;</span>))
<a name="l00442"></a>00442                     &lt;&lt; <span class="stringliteral">&quot; parent share &quot;</span>
<a name="l00443"></a>00443                     &lt;&lt; (neigh-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>()?<span class="stringliteral">&quot;subactive&quot;</span>:<span class="stringliteral">&quot;ancestor&quot;</span>)
<a name="l00444"></a>00444                     &lt;&lt; <span class="stringliteral">&quot; neighbor at level &quot;</span> &lt;&lt; neigh-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>()
<a name="l00445"></a>00445                     &lt;&lt; std::endl;
<a name="l00446"></a>00446                   <a class="code" href="classGMVIO.php">GMVIO</a>(*this).<a class="code" href="classGMVIO.php#a15c045764aae56e3b7827a6015f7d20e">write</a> (<span class="stringliteral">&quot;bad_mesh.gmv&quot;</span>);
<a name="l00447"></a>00447                   libmesh_error();
<a name="l00448"></a>00448                 }
<a name="l00449"></a>00449 <span class="preprocessor">#endif // DEBUG</span>
<a name="l00450"></a>00450 <span class="preprocessor"></span>            }
<a name="l00451"></a>00451         }
<a name="l00452"></a>00452     }
<a name="l00453"></a>00453   
<a name="l00454"></a>00454 <span class="preprocessor">#endif // AMR</span>
<a name="l00455"></a>00455 <span class="preprocessor"></span>
<a name="l00456"></a>00456 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00457"></a>00457 <span class="preprocessor"></span><a class="code" href="namespaceMeshTools.php#a55d1315fac6f245f3873626808d8a377">MeshTools::libmesh_assert_valid_neighbors</a>(*<span class="keyword">this</span>);
<a name="l00458"></a>00458 <span class="preprocessor">#endif</span>
<a name="l00459"></a>00459 <span class="preprocessor"></span>
<a name="l00460"></a>00460   STOP_LOG(<span class="stringliteral">&quot;find_neighbors()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00461"></a>00461 }
<a name="l00462"></a>00462 
<a name="l00463"></a>00463 
<a name="l00464"></a>00464 
<a name="l00465"></a><a class="code" href="classUnstructuredMesh.php#ac1b63b160430d8e3ec8403bcda8b9276">00465</a> <span class="keywordtype">void</span> <a class="code" href="classUnstructuredMesh.php#ac1b63b160430d8e3ec8403bcda8b9276">UnstructuredMesh::read</a> (<span class="keyword">const</span> std::string&amp; name,
<a name="l00466"></a>00466                              <a class="code" href="classMeshData.php">MeshData</a>* mesh_data,
<a name="l00467"></a>00467                              <span class="keywordtype">bool</span> skip_renumber_nodes_and_elements)
<a name="l00468"></a>00468 {
<a name="l00469"></a>00469   <span class="comment">// See if the file exists.  Perform this check on all processors</span>
<a name="l00470"></a>00470   <span class="comment">// so that the code is terminated properly in the case that the</span>
<a name="l00471"></a>00471   <span class="comment">// file does not exist.</span>
<a name="l00472"></a>00472   {
<a name="l00473"></a>00473     std::ifstream in (name.c_str());
<a name="l00474"></a>00474     
<a name="l00475"></a>00475     <span class="keywordflow">if</span> (!in.good())
<a name="l00476"></a>00476       {
<a name="l00477"></a>00477         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: cannot locate specified file:\n\t&quot;</span>
<a name="l00478"></a>00478                   &lt;&lt; name
<a name="l00479"></a>00479                   &lt;&lt; std::endl;
<a name="l00480"></a>00480         libmesh_error();
<a name="l00481"></a>00481       }
<a name="l00482"></a>00482   }
<a name="l00483"></a>00483 
<a name="l00484"></a>00484   <span class="comment">// Set the skip_renumber_nodes_and_elements flag on all processors.</span>
<a name="l00485"></a>00485   <span class="comment">// This ensures that renumber_nodes_and_elements is *not* called</span>
<a name="l00486"></a>00486   <span class="comment">// during prepare_for_use() for certain types of mesh files.</span>
<a name="l00487"></a>00487   <span class="comment">// This is required in cases where there is an associated solution</span>
<a name="l00488"></a>00488   <span class="comment">// file which expects a certain ordering of the nodes.</span>
<a name="l00489"></a>00489   <span class="keywordflow">if</span>(name.rfind(<span class="stringliteral">&quot;.gmv&quot;</span>)+4==name.size())
<a name="l00490"></a>00490     {
<a name="l00491"></a>00491       skip_renumber_nodes_and_elements =  <span class="keyword">true</span>;
<a name="l00492"></a>00492     }
<a name="l00493"></a>00493   
<a name="l00494"></a>00494   <span class="comment">// Look for parallel formats first</span>
<a name="l00495"></a>00495   <span class="keywordflow">if</span> (is_parallel_file_format(name))
<a name="l00496"></a>00496     {      
<a name="l00497"></a>00497       <span class="comment">// no need to handling bz2 files here -- the Xdr class does that.</span>
<a name="l00498"></a>00498       <span class="keywordflow">if</span> ((name.rfind(<span class="stringliteral">&quot;.xda&quot;</span>) &lt; name.size()) ||
<a name="l00499"></a>00499           (name.rfind(<span class="stringliteral">&quot;.xdr&quot;</span>) &lt; name.size()))
<a name="l00500"></a>00500         {
<a name="l00501"></a>00501           <a class="code" href="classXdrIO.php">XdrIO</a> xdr_io(*<span class="keyword">this</span>);
<a name="l00502"></a>00502 
<a name="l00503"></a>00503           <span class="comment">// .xda* ==&gt; bzip2/gzip/ASCII flavors</span>
<a name="l00504"></a>00504           <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.xda&quot;</span>) &lt; name.size())
<a name="l00505"></a>00505             {
<a name="l00506"></a>00506               xdr_io.<a class="code" href="classXdrIO.php#adb181910c1820f41d8528b11ee92e6d0">binary</a>() = <span class="keyword">false</span>;
<a name="l00507"></a>00507               xdr_io.<a class="code" href="classXdrIO.php#a6e77c8d1f5d2bfb2702ba8fe1b1fc217">read</a> (name);
<a name="l00508"></a>00508             }
<a name="l00509"></a>00509           <span class="keywordflow">else</span> <span class="comment">// .xdr* ==&gt; true binary XDR file</span>
<a name="l00510"></a>00510             {
<a name="l00511"></a>00511               xdr_io.<a class="code" href="classXdrIO.php#adb181910c1820f41d8528b11ee92e6d0">binary</a>() = <span class="keyword">true</span>;
<a name="l00512"></a>00512               xdr_io.<a class="code" href="classXdrIO.php#a6e77c8d1f5d2bfb2702ba8fe1b1fc217">read</a> (name);
<a name="l00513"></a>00513             }
<a name="l00514"></a>00514 
<a name="l00515"></a>00515           <span class="comment">// The xdr_io object gets constructed with legacy() == false.</span>
<a name="l00516"></a>00516           <span class="comment">// if legacy() == true then it means that a legacy file was detected and</span>
<a name="l00517"></a>00517           <span class="comment">// thus processor 0 performed the read. We therefore need to broadcast the</span>
<a name="l00518"></a>00518           <span class="comment">// mesh.  Further, for this flavor of mesh solution data ordering is tied</span>
<a name="l00519"></a>00519           <span class="comment">// to the node ordering, so we better not reorder the nodes!</span>
<a name="l00520"></a>00520           <span class="keywordflow">if</span> (xdr_io.<a class="code" href="classXdrIO.php#a3b61626fc0c3b9781262ea0f8d7f985b">legacy</a>())
<a name="l00521"></a>00521             {
<a name="l00522"></a>00522               skip_renumber_nodes_and_elements = <span class="keyword">true</span>;
<a name="l00523"></a>00523               <a class="code" href="classMeshCommunication.php">MeshCommunication</a>().<a class="code" href="classMeshCommunication.php#af47e26c3e42077ed8389a4faf1b52570">broadcast</a>(*<span class="keyword">this</span>);
<a name="l00524"></a>00524             }
<a name="l00525"></a>00525         }      
<a name="l00526"></a>00526     }
<a name="l00527"></a>00527 
<a name="l00528"></a>00528   <span class="comment">// Serial mesh formats</span>
<a name="l00529"></a>00529   <span class="keywordflow">else</span>
<a name="l00530"></a>00530     {
<a name="l00531"></a>00531       START_LOG(<span class="stringliteral">&quot;read()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);  
<a name="l00532"></a>00532   
<a name="l00533"></a>00533       <span class="comment">// Read the file based on extension.  Only processor 0</span>
<a name="l00534"></a>00534       <span class="comment">// needs to read the mesh.  It will then broadcast it and</span>
<a name="l00535"></a>00535       <span class="comment">// the other processors will pick it up</span>
<a name="l00536"></a>00536       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00537"></a>00537         {
<a name="l00538"></a>00538           <span class="comment">// Nasty hack for reading/writing zipped files</span>
<a name="l00539"></a>00539           std::string new_name = <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>;
<a name="l00540"></a>00540           <span class="keywordflow">if</span> (name.size() - name.rfind(<span class="stringliteral">&quot;.bz2&quot;</span>) == 4)
<a name="l00541"></a>00541             {
<a name="l00542"></a>00542               new_name.erase(new_name.end() - 4, new_name.end());
<a name="l00543"></a>00543               std::string system_string = <span class="stringliteral">&quot;bunzip2 -f -k &quot;</span>;
<a name="l00544"></a>00544               system_string += <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>;
<a name="l00545"></a>00545               START_LOG(<span class="stringliteral">&quot;system(bunzip2)&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00546"></a>00546               <span class="keywordflow">if</span> (std::system(system_string.c_str()))
<a name="l00547"></a>00547                 libmesh_file_error(system_string);
<a name="l00548"></a>00548               STOP_LOG(<span class="stringliteral">&quot;system(bunzip2)&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00549"></a>00549             }
<a name="l00550"></a>00550 
<a name="l00551"></a>00551           <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.mat&quot;</span>) &lt; new_name.size())
<a name="l00552"></a>00552             <a class="code" href="classMatlabIO.php">MatlabIO</a>(*this).<a class="code" href="classMatlabIO.php#a3a6ccb2025cb0c6e64c6813acdada143">read</a>(new_name);
<a name="l00553"></a>00553           
<a name="l00554"></a>00554           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.ucd&quot;</span>) &lt; new_name.size())
<a name="l00555"></a>00555             <a class="code" href="classUCDIO.php">UCDIO</a>(*this).<a class="code" href="classUCDIO.php#ae304b16c48b457c722d1c1584596a163">read</a> (new_name);
<a name="l00556"></a>00556           
<a name="l00557"></a>00557           <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((new_name.rfind(<span class="stringliteral">&quot;.off&quot;</span>)  &lt; new_name.size()) ||
<a name="l00558"></a>00558                    (new_name.rfind(<span class="stringliteral">&quot;.ogl&quot;</span>)  &lt; new_name.size()) ||
<a name="l00559"></a>00559                    (new_name.rfind(<span class="stringliteral">&quot;.oogl&quot;</span>) &lt; new_name.size()))
<a name="l00560"></a>00560             <a class="code" href="classOFFIO.php">OFFIO</a>(*this).<a class="code" href="classOFFIO.php#a6de28e47f2c15d9fe2c6397cc2907340">read</a> (new_name);
<a name="l00561"></a>00561      
<a name="l00562"></a>00562           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.mgf&quot;</span>) &lt; new_name.size())
<a name="l00563"></a>00563             <a class="code" href="classLegacyXdrIO.php">LegacyXdrIO</a>(*<span class="keyword">this</span>,<span class="keyword">true</span>).<a class="code" href="classLegacyXdrIO.php#ac4fde91354bab98a9a551c029ce51e0d">read_mgf</a> (new_name);
<a name="l00564"></a>00564       
<a name="l00565"></a>00565           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.unv&quot;</span>) &lt; new_name.size())
<a name="l00566"></a>00566             {
<a name="l00567"></a>00567               <span class="keywordflow">if</span> (mesh_data == NULL)
<a name="l00568"></a>00568                 {
<a name="l00569"></a>00569                   std::cerr &lt;&lt; <span class="stringliteral">&quot;Error! You must pass a &quot;</span>
<a name="l00570"></a>00570                             &lt;&lt; <span class="stringliteral">&quot;valid MeshData pointer to &quot;</span>
<a name="l00571"></a>00571                             &lt;&lt; <span class="stringliteral">&quot;read UNV files!&quot;</span> &lt;&lt; std::endl;
<a name="l00572"></a>00572                   libmesh_error();
<a name="l00573"></a>00573                 }
<a name="l00574"></a>00574               <a class="code" href="classUNVIO.php">UNVIO</a>(*<span class="keyword">this</span>, *mesh_data).<a class="code" href="classUNVIO.php#a40a24f88a4f993af6bc8e36fb3f44de1">read</a> (new_name);
<a name="l00575"></a>00575             }
<a name="l00576"></a>00576       
<a name="l00577"></a>00577           <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((new_name.rfind(<span class="stringliteral">&quot;.node&quot;</span>)  &lt; new_name.size()) ||
<a name="l00578"></a>00578                    (new_name.rfind(<span class="stringliteral">&quot;.ele&quot;</span>)   &lt; new_name.size()))
<a name="l00579"></a>00579             <a class="code" href="classTetGenIO.php">TetGenIO</a>(*<span class="keyword">this</span>,mesh_data).<a class="code" href="classTetGenIO.php#ad27081f540e0c173d8556631c82b1ca6">read</a> (new_name);
<a name="l00580"></a>00580 
<a name="l00581"></a>00581           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.exd&quot;</span>) &lt; new_name.size() ||
<a name="l00582"></a>00582                    new_name.rfind(<span class="stringliteral">&quot;.e&quot;</span>) &lt; new_name.size())
<a name="l00583"></a>00583             <a class="code" href="classExodusII__IO.php">ExodusII_IO</a>(*this).<a class="code" href="classExodusII__IO.php#a71cded634eaffef4c0f2441ef65d5860">read</a> (new_name);
<a name="l00584"></a>00584           
<a name="l00585"></a>00585           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.msh&quot;</span>) &lt; new_name.size())
<a name="l00586"></a>00586             <a class="code" href="classGmshIO.php">GmshIO</a>(*this).<a class="code" href="classGmshIO.php#ae650f0cd736ab71bbd2dc0459606676d">read</a> (new_name);
<a name="l00587"></a>00587 
<a name="l00588"></a>00588           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.gmv&quot;</span>) &lt; new_name.size())
<a name="l00589"></a>00589             <a class="code" href="classGMVIO.php">GMVIO</a>(*this).<a class="code" href="classGMVIO.php#ae8334c0cb906df1a659a17f712084aa0">read</a> (new_name);
<a name="l00590"></a>00590 
<a name="l00591"></a>00591           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.vtu&quot;</span>) &lt; new_name.size())
<a name="l00592"></a>00592             <a class="code" href="classVTKIO.php">VTKIO</a>(*this).<a class="code" href="classVTKIO.php#a1db43589e83b2c8e358bdb858e43651b">read</a>(new_name);
<a name="l00593"></a>00593       
<a name="l00594"></a>00594           <span class="keywordflow">else</span>
<a name="l00595"></a>00595             {
<a name="l00596"></a>00596               std::cerr &lt;&lt; <span class="stringliteral">&quot; ERROR: Unrecognized file extension: &quot;</span> &lt;&lt; name
<a name="l00597"></a>00597                         &lt;&lt; <span class="stringliteral">&quot;\n   I understand the following:\n\n&quot;</span>
<a name="l00598"></a>00598                         &lt;&lt; <span class="stringliteral">&quot;     *.e    -- Sandia&#39;s ExodusII format\n&quot;</span>
<a name="l00599"></a>00599                         &lt;&lt; <span class="stringliteral">&quot;     *.exd  -- Sandia&#39;s ExodusII format\n&quot;</span>
<a name="l00600"></a>00600                         &lt;&lt; <span class="stringliteral">&quot;     *.gmv  -- LANL&#39;s General Mesh Viewer format\n&quot;</span>
<a name="l00601"></a>00601                         &lt;&lt; <span class="stringliteral">&quot;     *.mat  -- Matlab triangular ASCII file\n&quot;</span>
<a name="l00602"></a>00602                         &lt;&lt; <span class="stringliteral">&quot;     *.off  -- OOGL OFF surface format\n&quot;</span>
<a name="l00603"></a>00603                         &lt;&lt; <span class="stringliteral">&quot;     *.ucd  -- AVS&#39;s ASCII UCD format\n&quot;</span>
<a name="l00604"></a>00604                         &lt;&lt; <span class="stringliteral">&quot;     *.unv  -- I-deas Universal format\n&quot;</span>
<a name="l00605"></a>00605                         &lt;&lt; <span class="stringliteral">&quot;     *.vtu  -- Paraview VTK format\n&quot;</span>
<a name="l00606"></a>00606                         &lt;&lt; <span class="stringliteral">&quot;     *.xda  -- libMesh ASCII format\n&quot;</span>
<a name="l00607"></a>00607                         &lt;&lt; <span class="stringliteral">&quot;     *.xdr  -- libMesh binary format\n&quot;</span>
<a name="l00608"></a>00608                         &lt;&lt; <span class="stringliteral">&quot;     *.gz   -- any above format gzipped\n&quot;</span>
<a name="l00609"></a>00609                         &lt;&lt; <span class="stringliteral">&quot;     *.bz2  -- any above format bzip2&#39;ed\n&quot;</span>
<a name="l00610"></a>00610 
<a name="l00611"></a>00611                         &lt;&lt; std::endl;
<a name="l00612"></a>00612               libmesh_error();    
<a name="l00613"></a>00613             }    
<a name="l00614"></a>00614           
<a name="l00615"></a>00615           <span class="comment">// If we temporarily decompressed a .bz2 file, remove the</span>
<a name="l00616"></a>00616           <span class="comment">// uncompressed version</span>
<a name="l00617"></a>00617           <span class="keywordflow">if</span> (name.size() - name.rfind(<span class="stringliteral">&quot;.bz2&quot;</span>) == 4)
<a name="l00618"></a>00618             std::remove(new_name.c_str());
<a name="l00619"></a>00619         }
<a name="l00620"></a>00620       
<a name="l00621"></a>00621   
<a name="l00622"></a>00622       STOP_LOG(<span class="stringliteral">&quot;read()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00623"></a>00623 
<a name="l00624"></a>00624       <span class="comment">// Send the mesh &amp; bcs (which are now only on processor 0) to the other</span>
<a name="l00625"></a>00625       <span class="comment">// processors</span>
<a name="l00626"></a>00626       <a class="code" href="classMeshCommunication.php">MeshCommunication</a>().<a class="code" href="classMeshCommunication.php#af47e26c3e42077ed8389a4faf1b52570">broadcast</a> (*<span class="keyword">this</span>);
<a name="l00627"></a>00627     }
<a name="l00628"></a>00628 
<a name="l00629"></a>00629   
<a name="l00630"></a>00630   <span class="comment">// Done reading the mesh.  Now prepare it for use.</span>
<a name="l00631"></a>00631   this-&gt;<a class="code" href="classMeshBase.php#a7c79bc3b9a75a580ed1ef91195eb77e5">prepare_for_use</a>(skip_renumber_nodes_and_elements);
<a name="l00632"></a>00632 
<a name="l00633"></a>00633 }
<a name="l00634"></a>00634 
<a name="l00635"></a>00635 
<a name="l00636"></a>00636 
<a name="l00637"></a><a class="code" href="classUnstructuredMesh.php#a42193c99593ef551f261ae292b6126a6">00637</a> <span class="keywordtype">void</span> <a class="code" href="classUnstructuredMesh.php#a42193c99593ef551f261ae292b6126a6">UnstructuredMesh::write</a> (<span class="keyword">const</span> std::string&amp; name,
<a name="l00638"></a>00638                               <a class="code" href="classMeshData.php">MeshData</a>* mesh_data)
<a name="l00639"></a>00639 {
<a name="l00640"></a>00640   <span class="comment">// parallel formats are special -- they may choose to write</span>
<a name="l00641"></a>00641   <span class="comment">// separate files, let&#39;s not try to handle the zipping here.</span>
<a name="l00642"></a>00642   <span class="keywordflow">if</span> (is_parallel_file_format(name))
<a name="l00643"></a>00643     {   
<a name="l00644"></a>00644       <span class="comment">// no need to handling bz2 files here -- the Xdr class does that.</span>
<a name="l00645"></a>00645       <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.xda&quot;</span>) &lt; name.size())
<a name="l00646"></a>00646         <a class="code" href="classXdrIO.php">XdrIO</a>(*this).<a class="code" href="classXdrIO.php#ad291a0b4cd3338da79e625474f192e5c">write</a>(name);
<a name="l00647"></a>00647         
<a name="l00648"></a>00648       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.xdr&quot;</span>) &lt; name.size())
<a name="l00649"></a>00649         <a class="code" href="classXdrIO.php">XdrIO</a>(*<span class="keyword">this</span>,<span class="keyword">true</span>).<a class="code" href="classXdrIO.php#ad291a0b4cd3338da79e625474f192e5c">write</a>(name);
<a name="l00650"></a>00650     }
<a name="l00651"></a>00651 
<a name="l00652"></a>00652   <span class="comment">// serial file formats</span>
<a name="l00653"></a>00653   <span class="keywordflow">else</span>
<a name="l00654"></a>00654     {
<a name="l00655"></a>00655       START_LOG(<span class="stringliteral">&quot;write()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00656"></a>00656 
<a name="l00657"></a>00657       <span class="comment">// Nasty hack for reading/writing zipped files</span>
<a name="l00658"></a>00658       std::string new_name = <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>;
<a name="l00659"></a>00659       <span class="keywordflow">if</span> (name.size() - name.rfind(<span class="stringliteral">&quot;.bz2&quot;</span>) == 4)
<a name="l00660"></a>00660         new_name.erase(new_name.end() - 4, new_name.end());
<a name="l00661"></a>00661   
<a name="l00662"></a>00662       <span class="comment">// New scope so that io will close before we try to zip the file</span>
<a name="l00663"></a>00663       {
<a name="l00664"></a>00664         <span class="comment">// Write the file based on extension</span>
<a name="l00665"></a>00665         <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.dat&quot;</span>) &lt; new_name.size())
<a name="l00666"></a>00666           <a class="code" href="classTecplotIO.php">TecplotIO</a>(*this).<a class="code" href="classTecplotIO.php#a6a673b9ecb0d5538b161ff0153d69c73">write</a> (new_name);
<a name="l00667"></a>00667         
<a name="l00668"></a>00668         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.plt&quot;</span>) &lt; new_name.size())
<a name="l00669"></a>00669           <a class="code" href="classTecplotIO.php">TecplotIO</a>(*<span class="keyword">this</span>,<span class="keyword">true</span>).<a class="code" href="classTecplotIO.php#a6a673b9ecb0d5538b161ff0153d69c73">write</a> (new_name);
<a name="l00670"></a>00670         
<a name="l00671"></a>00671         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.ucd&quot;</span>) &lt; new_name.size())
<a name="l00672"></a>00672           <a class="code" href="classUCDIO.php">UCDIO</a> (*this).<a class="code" href="classUCDIO.php#adb13dd6b6926b42eefde3d817b95523e">write</a> (new_name);
<a name="l00673"></a>00673         
<a name="l00674"></a>00674         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.gmv&quot;</span>) &lt; new_name.size())
<a name="l00675"></a>00675           <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classMeshBase.php#ac0228a08dd00ee27d137a89fa831ab0f">n_partitions</a>() &gt; 1)
<a name="l00676"></a>00676             <a class="code" href="classGMVIO.php">GMVIO</a>(*this).<a class="code" href="classGMVIO.php#a15c045764aae56e3b7827a6015f7d20e">write</a> (new_name);
<a name="l00677"></a>00677           <span class="keywordflow">else</span>
<a name="l00678"></a>00678             {
<a name="l00679"></a>00679               <a class="code" href="classGMVIO.php">GMVIO</a> io(*<span class="keyword">this</span>);
<a name="l00680"></a>00680               io.<a class="code" href="classGMVIO.php#a6aa37d92f28d5c0328f5d850a8f34146">partitioning</a>() = <span class="keyword">false</span>;
<a name="l00681"></a>00681               io.<a class="code" href="classGMVIO.php#a15c045764aae56e3b7827a6015f7d20e">write</a> (new_name);
<a name="l00682"></a>00682             }
<a name="l00683"></a>00683         
<a name="l00684"></a>00684         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.ugrid&quot;</span>) &lt; new_name.size())
<a name="l00685"></a>00685           <a class="code" href="classDivaIO.php">DivaIO</a>(*this).<a class="code" href="classDivaIO.php#add86954e5f8443c52f2e2d4f9db25c4e">write</a>(new_name);
<a name="l00686"></a>00686         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.exd&quot;</span>) &lt; new_name.size() ||
<a name="l00687"></a>00687                  new_name.rfind(<span class="stringliteral">&quot;.e&quot;</span>) &lt; new_name.size())
<a name="l00688"></a>00688           <a class="code" href="classExodusII__IO.php">ExodusII_IO</a>(*this).<a class="code" href="classExodusII__IO.php#ac2302f2c4760c5f7297208fe51eec14a">write</a>(new_name);
<a name="l00689"></a>00689         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.mgf&quot;</span>)  &lt; new_name.size())
<a name="l00690"></a>00690           <a class="code" href="classLegacyXdrIO.php">LegacyXdrIO</a>(*<span class="keyword">this</span>,<span class="keyword">true</span>).<a class="code" href="classLegacyXdrIO.php#ab5369cabc6b2cc585e679efb89fad931">write_mgf</a>(new_name);
<a name="l00691"></a>00691         
<a name="l00692"></a>00692         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.unv&quot;</span>) &lt; new_name.size())
<a name="l00693"></a>00693           {
<a name="l00694"></a>00694             <span class="keywordflow">if</span> (mesh_data == NULL)
<a name="l00695"></a>00695               {
<a name="l00696"></a>00696                 std::cerr &lt;&lt; <span class="stringliteral">&quot;Error! You must pass a &quot;</span>
<a name="l00697"></a>00697                           &lt;&lt; <span class="stringliteral">&quot;valid MeshData pointer to &quot;</span>
<a name="l00698"></a>00698                           &lt;&lt; <span class="stringliteral">&quot;write UNV files!&quot;</span> &lt;&lt; std::endl;
<a name="l00699"></a>00699                 libmesh_error();
<a name="l00700"></a>00700               }
<a name="l00701"></a>00701             <a class="code" href="classUNVIO.php">UNVIO</a>(*<span class="keyword">this</span>, *mesh_data).<a class="code" href="classUNVIO.php#a5104c54df79a6fbc4ec7c617c1d72b35">write</a> (new_name);
<a name="l00702"></a>00702           }
<a name="l00703"></a>00703         
<a name="l00704"></a>00704         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.mesh&quot;</span>) &lt; new_name.size())
<a name="l00705"></a>00705           <a class="code" href="classMEDITIO.php">MEDITIO</a>(*this).<a class="code" href="classMEDITIO.php#a06408f59e30e825892d65ba668801aa1">write</a> (new_name);
<a name="l00706"></a>00706         
<a name="l00707"></a>00707         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.poly&quot;</span>) &lt; new_name.size())
<a name="l00708"></a>00708           <a class="code" href="classTetGenIO.php">TetGenIO</a>(*this).<a class="code" href="classTetGenIO.php#af06d105f3996ab0c51b9e9ea779542cf">write</a> (new_name);
<a name="l00709"></a>00709         
<a name="l00710"></a>00710         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.msh&quot;</span>) &lt; new_name.size())
<a name="l00711"></a>00711           <a class="code" href="classGmshIO.php">GmshIO</a>(*this).<a class="code" href="classGmshIO.php#adc25c81852d64962f3e4eac2353534c9">write</a> (new_name);
<a name="l00712"></a>00712         
<a name="l00713"></a>00713         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.fro&quot;</span>) &lt; new_name.size())
<a name="l00714"></a>00714           <a class="code" href="classFroIO.php">FroIO</a>(*this).<a class="code" href="classFroIO.php#aae64762a1ea4411677d4a1e8231e37f0">write</a> (new_name);
<a name="l00715"></a>00715         
<a name="l00716"></a>00716         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (new_name.rfind(<span class="stringliteral">&quot;.vtu&quot;</span>) &lt; new_name.size())
<a name="l00717"></a>00717           <a class="code" href="classVTKIO.php">VTKIO</a>(*this).<a class="code" href="classVTKIO.php#ae6bc5c06157bb86a7500c455254b1e00">write</a> (new_name);
<a name="l00718"></a>00718         
<a name="l00719"></a>00719         <span class="keywordflow">else</span>
<a name="l00720"></a>00720           {
<a name="l00721"></a>00721             std::cerr &lt;&lt; <span class="stringliteral">&quot; ERROR: Unrecognized file extension: &quot;</span> &lt;&lt; name
<a name="l00722"></a>00722                       &lt;&lt; <span class="stringliteral">&quot;\n   I understand the following:\n\n&quot;</span>
<a name="l00723"></a>00723                       &lt;&lt; <span class="stringliteral">&quot;     *.dat   -- Tecplot ASCII file\n&quot;</span>
<a name="l00724"></a>00724                       &lt;&lt; <span class="stringliteral">&quot;     *.e     -- Sandia&#39;s ExodusII format\n&quot;</span>
<a name="l00725"></a>00725                       &lt;&lt; <span class="stringliteral">&quot;     *.exd   -- Sandia&#39;s ExodusII format\n&quot;</span>
<a name="l00726"></a>00726                       &lt;&lt; <span class="stringliteral">&quot;     *.fro   -- ACDL&#39;s surface triangulation file\n&quot;</span>
<a name="l00727"></a>00727                       &lt;&lt; <span class="stringliteral">&quot;     *.gmv   -- LANL&#39;s GMV (General Mesh Viewer) format\n&quot;</span>
<a name="l00728"></a>00728                       &lt;&lt; <span class="stringliteral">&quot;     *.mesh  -- MEdit mesh format\n&quot;</span>
<a name="l00729"></a>00729                       &lt;&lt; <span class="stringliteral">&quot;     *.mgf   -- MGF binary mesh format\n&quot;</span>
<a name="l00730"></a>00730                       &lt;&lt; <span class="stringliteral">&quot;     *.msh   -- GMSH ASCII file\n&quot;</span>
<a name="l00731"></a>00731                       &lt;&lt; <span class="stringliteral">&quot;     *.plt   -- Tecplot binary file\n&quot;</span>
<a name="l00732"></a>00732                       &lt;&lt; <span class="stringliteral">&quot;     *.poly  -- TetGen ASCII file\n&quot;</span>
<a name="l00733"></a>00733                       &lt;&lt; <span class="stringliteral">&quot;     *.ucd   -- AVS&#39;s ASCII UCD format\n&quot;</span>
<a name="l00734"></a>00734                       &lt;&lt; <span class="stringliteral">&quot;     *.ugrid -- Kelly&#39;s DIVA ASCII format\n&quot;</span>
<a name="l00735"></a>00735                       &lt;&lt; <span class="stringliteral">&quot;     *.unv   -- I-deas Universal format\n&quot;</span>
<a name="l00736"></a>00736                       &lt;&lt; <span class="stringliteral">&quot;     *.xda   -- libMesh ASCII format\n&quot;</span>
<a name="l00737"></a>00737                       &lt;&lt; <span class="stringliteral">&quot;     *.xdr   -- libMesh binary format,\n&quot;</span>
<a name="l00738"></a>00738                       &lt;&lt; std::endl
<a name="l00739"></a>00739                       &lt;&lt; <span class="stringliteral">&quot;\n Exiting without writing output\n&quot;</span>;
<a name="l00740"></a>00740           }    
<a name="l00741"></a>00741       }
<a name="l00742"></a>00742   
<a name="l00743"></a>00743       <span class="comment">// Nasty hack for reading/writing zipped files</span>
<a name="l00744"></a>00744       <span class="keywordflow">if</span> (name.size() - name.rfind(<span class="stringliteral">&quot;.bz2&quot;</span>) == 4)
<a name="l00745"></a>00745         {
<a name="l00746"></a>00746           START_LOG(<span class="stringliteral">&quot;system(bzip2)&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00747"></a>00747           <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00748"></a>00748             {
<a name="l00749"></a>00749               std::string system_string = <span class="stringliteral">&quot;bzip2 -f &quot;</span>;
<a name="l00750"></a>00750               system_string += new_name;
<a name="l00751"></a>00751               <span class="keywordflow">if</span> (std::system(system_string.c_str()))
<a name="l00752"></a>00752                 libmesh_file_error(system_string);
<a name="l00753"></a>00753             }
<a name="l00754"></a>00754           Parallel::barrier();
<a name="l00755"></a>00755           STOP_LOG(<span class="stringliteral">&quot;system(bzip2)&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00756"></a>00756         }
<a name="l00757"></a>00757       
<a name="l00758"></a>00758       STOP_LOG(<span class="stringliteral">&quot;write()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00759"></a>00759     }  
<a name="l00760"></a>00760 }
<a name="l00761"></a>00761 
<a name="l00762"></a>00762 
<a name="l00763"></a>00763 
<a name="l00764"></a><a class="code" href="classUnstructuredMesh.php#a28e913f480e0357db9e4c69d69756028">00764</a> <span class="keywordtype">void</span> <a class="code" href="classUnstructuredMesh.php#a42193c99593ef551f261ae292b6126a6">UnstructuredMesh::write</a> (<span class="keyword">const</span> std::string&amp; name,
<a name="l00765"></a>00765                   <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; v,
<a name="l00766"></a>00766                   <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; vn)
<a name="l00767"></a>00767 {
<a name="l00768"></a>00768   START_LOG(<span class="stringliteral">&quot;write()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00769"></a>00769 
<a name="l00770"></a>00770   <span class="comment">// Write the file based on extension</span>
<a name="l00771"></a>00771   <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.dat&quot;</span>) &lt; name.size())
<a name="l00772"></a>00772     <a class="code" href="classTecplotIO.php">TecplotIO</a>(*this).<a class="code" href="classTecplotIO.php#a5677240e026f182aefaf10f803d1df65">write_nodal_data</a> (name, v, vn);
<a name="l00773"></a>00773   
<a name="l00774"></a>00774   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.plt&quot;</span>) &lt; name.size())
<a name="l00775"></a>00775     <a class="code" href="classTecplotIO.php">TecplotIO</a>(*<span class="keyword">this</span>,<span class="keyword">true</span>).<a class="code" href="classTecplotIO.php#a5677240e026f182aefaf10f803d1df65">write_nodal_data</a> (name, v, vn);
<a name="l00776"></a>00776   
<a name="l00777"></a>00777   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.gmv&quot;</span>) &lt; name.size())
<a name="l00778"></a>00778     {
<a name="l00779"></a>00779       <span class="keywordflow">if</span> (<a class="code" href="classMeshBase.php#a1f288668ce5a732f9946f08c73166d73">n_subdomains</a>() &gt; 1)
<a name="l00780"></a>00780         <a class="code" href="classGMVIO.php">GMVIO</a>(*this).<a class="code" href="classGMVIO.php#afcadf7ebf7bded1774d490ea06365d83">write_nodal_data</a> (name, v, vn);
<a name="l00781"></a>00781       <span class="keywordflow">else</span>
<a name="l00782"></a>00782         {
<a name="l00783"></a>00783           <a class="code" href="classGMVIO.php">GMVIO</a> io(*<span class="keyword">this</span>);
<a name="l00784"></a>00784           io.<a class="code" href="classGMVIO.php#a6aa37d92f28d5c0328f5d850a8f34146">partitioning</a>() = <span class="keyword">false</span>;
<a name="l00785"></a>00785           io.<a class="code" href="classGMVIO.php#afcadf7ebf7bded1774d490ea06365d83">write_nodal_data</a> (name, v, vn);
<a name="l00786"></a>00786         }
<a name="l00787"></a>00787     }    
<a name="l00788"></a>00788   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.pvtu&quot;</span>) &lt; name.size())
<a name="l00789"></a>00789     {
<a name="l00790"></a>00790       <a class="code" href="classVTKIO.php">VTKIO</a>(*this).<a class="code" href="classMeshOutput.php#a8365780c326915d5da092628a3e85038">write_nodal_data</a> (name, v, vn);
<a name="l00791"></a>00791     }
<a name="l00792"></a>00792   <span class="keywordflow">else</span>
<a name="l00793"></a>00793     {
<a name="l00794"></a>00794       std::cerr &lt;&lt; <span class="stringliteral">&quot; ERROR: Unrecognized file extension: &quot;</span> &lt;&lt; name
<a name="l00795"></a>00795                 &lt;&lt; <span class="stringliteral">&quot;\n   I understand the following:\n\n&quot;</span>
<a name="l00796"></a>00796                 &lt;&lt; <span class="stringliteral">&quot;     *.dat  -- Tecplot ASCII file\n&quot;</span>
<a name="l00797"></a>00797                 &lt;&lt; <span class="stringliteral">&quot;     *.gmv  -- LANL&#39;s GMV (General Mesh Viewer) format\n&quot;</span>
<a name="l00798"></a>00798                 &lt;&lt; <span class="stringliteral">&quot;     *.plt  -- Tecplot binary file\n&quot;</span>
<a name="l00799"></a>00799                 &lt;&lt; <span class="stringliteral">&quot;     *.pvtu -- Paraview VTK file\n&quot;</span>
<a name="l00800"></a>00800                 &lt;&lt; <span class="stringliteral">&quot;\n Exiting without writing output\n&quot;</span>;
<a name="l00801"></a>00801     }
<a name="l00802"></a>00802 
<a name="l00803"></a>00803   STOP_LOG(<span class="stringliteral">&quot;write()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00804"></a>00804 }
<a name="l00805"></a>00805 
<a name="l00806"></a>00806 
<a name="l00807"></a>00807 
<a name="l00808"></a>00808 
<a name="l00809"></a>00809 
<a name="l00810"></a><a class="code" href="classUnstructuredMesh.php#a072f782f164adc1e747cf8c570fa2dd1">00810</a> <span class="keywordtype">void</span> <a class="code" href="classUnstructuredMesh.php#a072f782f164adc1e747cf8c570fa2dd1">UnstructuredMesh::create_pid_mesh</a>(<a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; pid_mesh,
<a name="l00811"></a>00811                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid)<span class="keyword"> const</span>
<a name="l00812"></a>00812 <span class="keyword"></span>{
<a name="l00813"></a>00813 
<a name="l00814"></a>00814   <span class="comment">// Issue a warning if the number the number of processors</span>
<a name="l00815"></a>00815   <span class="comment">// currently available is less that that requested for</span>
<a name="l00816"></a>00816   <span class="comment">// partitioning.  This is not necessarily an error since</span>
<a name="l00817"></a>00817   <span class="comment">// you may run on one processor and still partition the</span>
<a name="l00818"></a>00818   <span class="comment">// mesh into several partitions.</span>
<a name="l00819"></a>00819 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00820"></a>00820 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classMeshBase.php#a2399e70af69cf24f3add6c5a860edaa7">n_processors</a>() &lt; pid)
<a name="l00821"></a>00821     {
<a name="l00822"></a>00822       std::cout &lt;&lt; <span class="stringliteral">&quot;WARNING:  You are creating a &quot;</span>
<a name="l00823"></a>00823                 &lt;&lt; <span class="stringliteral">&quot;mesh for a processor id (=&quot;</span>
<a name="l00824"></a>00824                 &lt;&lt; pid
<a name="l00825"></a>00825                 &lt;&lt; <span class="stringliteral">&quot;) greater than &quot;</span>
<a name="l00826"></a>00826                 &lt;&lt; <span class="stringliteral">&quot;the number of processors available for &quot;</span>
<a name="l00827"></a>00827                 &lt;&lt; <span class="stringliteral">&quot;the calculation. (=&quot;</span>
<a name="l00828"></a>00828                 &lt;&lt; <a class="code" href="classMeshBase.php#a2399e70af69cf24f3add6c5a860edaa7">libMesh::n_processors</a>()
<a name="l00829"></a>00829                 &lt;&lt; <span class="stringliteral">&quot;).&quot;</span>
<a name="l00830"></a>00830                 &lt;&lt; std::endl;
<a name="l00831"></a>00831     }
<a name="l00832"></a>00832 <span class="preprocessor">#endif</span>
<a name="l00833"></a>00833 <span class="preprocessor"></span>  
<a name="l00834"></a>00834   <span class="comment">// Create iterators to loop over the list of elements</span>
<a name="l00835"></a>00835 <span class="comment">//   const_active_pid_elem_iterator       it(this-&gt;elements_begin(),   pid);</span>
<a name="l00836"></a>00836 <span class="comment">//   const const_active_pid_elem_iterator it_end(this-&gt;elements_end(), pid);</span>
<a name="l00837"></a>00837 
<a name="l00838"></a>00838   <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>       it     = this-&gt;<a class="code" href="classMeshBase.php#ac0e09837e3ba3077c14015ea4b73ec08">active_pid_elements_begin</a>(pid);
<a name="l00839"></a>00839   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a> it_end = this-&gt;<a class="code" href="classMeshBase.php#a44926338045dcfee9dae93975aeafe9a">active_pid_elements_end</a>(pid);
<a name="l00840"></a>00840     
<a name="l00841"></a>00841   this-&gt;<a class="code" href="classUnstructuredMesh.php#abf1f5754fc6aeaa91ad6f0f04ad10097">create_submesh</a> (pid_mesh, it, it_end);
<a name="l00842"></a>00842 }
<a name="l00843"></a>00843 
<a name="l00844"></a>00844 
<a name="l00845"></a>00845 
<a name="l00846"></a>00846 
<a name="l00847"></a>00847 
<a name="l00848"></a>00848 
<a name="l00849"></a>00849 
<a name="l00850"></a><a class="code" href="classUnstructuredMesh.php#abf1f5754fc6aeaa91ad6f0f04ad10097">00850</a> <span class="keywordtype">void</span> <a class="code" href="classUnstructuredMesh.php#abf1f5754fc6aeaa91ad6f0f04ad10097">UnstructuredMesh::create_submesh</a> (<a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; new_mesh,
<a name="l00851"></a>00851                            <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>&amp; it,
<a name="l00852"></a>00852                            <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>&amp; it_end)<span class="keyword"> const</span>
<a name="l00853"></a>00853 <span class="keyword"></span>{
<a name="l00854"></a>00854   <span class="comment">// Just in case the subdomain_mesh already has some information</span>
<a name="l00855"></a>00855   <span class="comment">// in it, get rid of it.</span>
<a name="l00856"></a>00856   new_mesh.<a class="code" href="classMeshBase.php#aefd56c4c29285d5e845f8869112b2b67">clear</a>();
<a name="l00857"></a>00857 
<a name="l00858"></a>00858   <span class="comment">// Fail if (*this == new_mesh), we cannot create a submesh inside ourself!</span>
<a name="l00859"></a>00859   <span class="comment">// This may happen if the user accidently passes the original mesh into</span>
<a name="l00860"></a>00860   <span class="comment">// this function!  We will check this by making sure we did not just</span>
<a name="l00861"></a>00861   <span class="comment">// clear ourself.</span>
<a name="l00862"></a>00862   libmesh_assert (this-&gt;<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>() != 0);
<a name="l00863"></a>00863   libmesh_assert (this-&gt;<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>()  != 0); 
<a name="l00864"></a>00864 
<a name="l00865"></a>00865   <span class="comment">// How the nodes on this mesh will be renumbered to nodes</span>
<a name="l00866"></a>00866   <span class="comment">// on the new_mesh.  </span>
<a name="l00867"></a>00867   std::vector&lt;unsigned int&gt; new_node_numbers (this-&gt;<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l00868"></a>00868 
<a name="l00869"></a>00869   std::fill (new_node_numbers.begin(),
<a name="l00870"></a>00870              new_node_numbers.end(),
<a name="l00871"></a>00871              <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>);
<a name="l00872"></a>00872 
<a name="l00873"></a>00873   
<a name="l00874"></a>00874   
<a name="l00875"></a>00875   <span class="comment">// the number of nodes on the new mesh, will be incremented</span>
<a name="l00876"></a>00876   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_new_nodes = 0;
<a name="l00877"></a>00877   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_new_elem  = 0;
<a name="l00878"></a>00878     
<a name="l00879"></a>00879   <span class="keywordflow">for</span> (; it != it_end; ++it)
<a name="l00880"></a>00880     {
<a name="l00881"></a>00881       <span class="comment">// increment the new element counter</span>
<a name="l00882"></a>00882       n_new_elem++;
<a name="l00883"></a>00883         
<a name="l00884"></a>00884       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* old_elem = *it;
<a name="l00885"></a>00885 
<a name="l00886"></a>00886       <span class="comment">// Add an equivalent element type to the new_mesh</span>
<a name="l00887"></a>00887       <a class="code" href="classElem.php">Elem</a>* new_elem = 
<a name="l00888"></a>00888         new_mesh.<a class="code" href="classMeshBase.php#a0f6974cf3e413cfe9caa1fcb4ce8153e">add_elem</a> (<a class="code" href="classElem.php#a7f46524fbd44a76f940435d6a1434a9d">Elem::build</a>(old_elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>()).release());
<a name="l00889"></a>00889 
<a name="l00890"></a>00890       libmesh_assert (new_elem != NULL);
<a name="l00891"></a>00891         
<a name="l00892"></a>00892       <span class="comment">// Loop over the nodes on this element.  </span>
<a name="l00893"></a>00893       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;old_elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); n++)
<a name="l00894"></a>00894         {
<a name="l00895"></a>00895           libmesh_assert (old_elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n) &lt; new_node_numbers.size());
<a name="l00896"></a>00896 
<a name="l00897"></a>00897           <span class="keywordflow">if</span> (new_node_numbers[old_elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n)] == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00898"></a>00898             {
<a name="l00899"></a>00899               new_node_numbers[old_elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n)] = n_new_nodes;
<a name="l00900"></a>00900 
<a name="l00901"></a>00901               <span class="comment">// Add this node to the new mesh</span>
<a name="l00902"></a>00902               new_mesh.<a class="code" href="classMeshBase.php#a01b66468d3e9d8b5db82c6f3d9131f5e">add_point</a> (old_elem-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(n));
<a name="l00903"></a>00903 
<a name="l00904"></a>00904               <span class="comment">// Increment the new node counter</span>
<a name="l00905"></a>00905               n_new_nodes++;
<a name="l00906"></a>00906             }
<a name="l00907"></a>00907 
<a name="l00908"></a>00908           <span class="comment">// Define this element&#39;s connectivity on the new mesh</span>
<a name="l00909"></a>00909           libmesh_assert (new_node_numbers[old_elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n)] &lt; new_mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l00910"></a>00910             
<a name="l00911"></a>00911           new_elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(n) = new_mesh.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a> (new_node_numbers[old_elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n)]);
<a name="l00912"></a>00912         }
<a name="l00913"></a>00913 
<a name="l00914"></a>00914       <span class="comment">// Copy ids for this element</span>
<a name="l00915"></a>00915       new_elem-&gt;<a class="code" href="classElem.php#acc4746605aad9169ad38cfd0b9b97123">subdomain_id</a>() = old_elem-&gt;<a class="code" href="classElem.php#acc4746605aad9169ad38cfd0b9b97123">subdomain_id</a>();
<a name="l00916"></a>00916       new_elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() = old_elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>();
<a name="l00917"></a>00917       
<a name="l00918"></a>00918       <span class="comment">// Maybe add boundary conditions for this element</span>
<a name="l00919"></a>00919       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;old_elem-&gt;<a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>(); s++)
<a name="l00920"></a>00920         <span class="keywordflow">if</span> (old_elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s) == NULL)
<a name="l00921"></a>00921           <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;boundary_id (old_elem, s) !=
<a name="l00922"></a>00922               this-&gt;<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;invalid_id)
<a name="l00923"></a>00923             new_mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;add_side (new_elem,
<a name="l00924"></a>00924                                              s,
<a name="l00925"></a>00925                                              this-&gt;boundary_info-&gt;boundary_id (old_elem, s));
<a name="l00926"></a>00926     } <span class="comment">// end loop over elements</span>
<a name="l00927"></a>00927   
<a name="l00928"></a>00928 
<a name="l00929"></a>00929   <span class="comment">// Prepare the new_mesh for use</span>
<a name="l00930"></a>00930   new_mesh.<a class="code" href="classMeshBase.php#a7c79bc3b9a75a580ed1ef91195eb77e5">prepare_for_use</a>();
<a name="l00931"></a>00931   
<a name="l00932"></a>00932 }
<a name="l00933"></a>00933 
<a name="l00934"></a>00934 
<a name="l00935"></a>00935 
<a name="l00936"></a>00936 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00937"></a><a class="code" href="classUnstructuredMesh.php#ad0b588e3115f79b579d600f244159705">00937</a> <span class="preprocessor"></span><span class="keywordtype">bool</span> <a class="code" href="classUnstructuredMesh.php#ad0b588e3115f79b579d600f244159705">UnstructuredMesh::contract</a> ()
<a name="l00938"></a>00938 {
<a name="l00939"></a>00939   START_LOG (<span class="stringliteral">&quot;contract()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00940"></a>00940 
<a name="l00941"></a>00941   <span class="comment">// Flag indicating if this call actually changes the mesh</span>
<a name="l00942"></a>00942   <span class="keywordtype">bool</span> mesh_changed = <span class="keyword">false</span>;
<a name="l00943"></a>00943 
<a name="l00944"></a>00944   <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> in        = <a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00945"></a>00945   <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> out       = <a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00946"></a>00946   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">element_iterator</a> end = <a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00947"></a>00947 
<a name="l00948"></a>00948 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00949"></a>00949 <span class="preprocessor"></span>  <span class="keywordflow">for</span> ( ; in != end; ++in)
<a name="l00950"></a>00950     <span class="keywordflow">if</span> (*in != NULL)
<a name="l00951"></a>00951       {
<a name="l00952"></a>00952         <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a> = *in;
<a name="l00953"></a>00953         libmesh_assert(elem-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>() || elem-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>() || elem-&gt;<a class="code" href="classElem.php#a3ad156b66b45310da85b653c791bd790">ancestor</a>());
<a name="l00954"></a>00954       }
<a name="l00955"></a>00955   in = <a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00956"></a>00956 <span class="preprocessor">#endif</span>
<a name="l00957"></a>00957 <span class="preprocessor"></span>  
<a name="l00958"></a>00958   <span class="comment">// Loop over the elements.   </span>
<a name="l00959"></a>00959   <span class="keywordflow">for</span> ( ; in != end; ++in)
<a name="l00960"></a>00960     <span class="keywordflow">if</span> (*in != NULL)
<a name="l00961"></a>00961       {
<a name="l00962"></a>00962         <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a> = *in;
<a name="l00963"></a>00963 
<a name="l00964"></a>00964         <span class="comment">// Delete all the subactive ones</span>
<a name="l00965"></a>00965         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>())
<a name="l00966"></a>00966           {
<a name="l00967"></a>00967             <span class="comment">// No level-0 element should be subactive.</span>
<a name="l00968"></a>00968             <span class="comment">// Note that we CAN&#39;T test elem-&gt;level(), as that </span>
<a name="l00969"></a>00969             <span class="comment">// touches elem-&gt;parent()-&gt;dim(), and elem-&gt;parent()</span>
<a name="l00970"></a>00970             <span class="comment">// might have already been deleted!</span>
<a name="l00971"></a>00971             libmesh_assert (elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>() != NULL);
<a name="l00972"></a>00972 
<a name="l00973"></a>00973             <span class="comment">// Delete the element</span>
<a name="l00974"></a>00974             <span class="comment">// This just sets a pointer to NULL, and doesn&#39;t</span>
<a name="l00975"></a>00975             <span class="comment">// invalidate any iterators</span>
<a name="l00976"></a>00976             this-&gt;<a class="code" href="classMeshBase.php#abafee5e4c20eb6866d66e78c35589857">delete_elem</a>(elem);
<a name="l00977"></a>00977             
<a name="l00978"></a>00978             <span class="comment">// the mesh has certainly changed</span>
<a name="l00979"></a>00979             mesh_changed = <span class="keyword">true</span>;
<a name="l00980"></a>00980           }
<a name="l00981"></a>00981         <span class="keywordflow">else</span>
<a name="l00982"></a>00982           {
<a name="l00983"></a>00983             <span class="comment">// Compress all the active ones</span>
<a name="l00984"></a>00984             <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l00985"></a>00985               elem-&gt;<a class="code" href="classElem.php#a0d3684188ff7e647bb565e3de3439e7d">contract</a>();
<a name="l00986"></a>00986             <span class="keywordflow">else</span>
<a name="l00987"></a>00987               libmesh_assert (elem-&gt;<a class="code" href="classElem.php#a3ad156b66b45310da85b653c791bd790">ancestor</a>());
<a name="l00988"></a>00988           }
<a name="l00989"></a>00989       }
<a name="l00990"></a>00990 
<a name="l00991"></a>00991   <span class="comment">// Strip any newly-created NULL voids out of the element array</span>
<a name="l00992"></a>00992   this-&gt;<a class="code" href="classMeshBase.php#a9cffd189f76fa2393fa5c5426f408aed">renumber_nodes_and_elements</a>();
<a name="l00993"></a>00993 
<a name="l00994"></a>00994   STOP_LOG (<span class="stringliteral">&quot;contract()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00995"></a>00995   
<a name="l00996"></a>00996   <span class="keywordflow">return</span> mesh_changed;
<a name="l00997"></a>00997 }
<a name="l00998"></a>00998 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00999"></a>00999 <span class="preprocessor"></span>
<a name="l01000"></a>01000 
<a name="l01001"></a>01001 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
