<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>unstructured_mesh.h</h1>  </div>
</div>
<div class="contents">
<a href="unstructured__mesh_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: unstructured_mesh.h 3454 2009-09-03 16:59:40Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __unstructured_mesh_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __unstructured_mesh_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Forward Declarations</span>
<a name="l00031"></a>00031 <span class="keyword">class </span><a class="code" href="classMeshData.php">MeshData</a>;
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00047"></a>00047 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00048"></a>00048 <span class="comment">// UnstructuredMesh class definition</span>
<a name="l00049"></a><a class="code" href="classUnstructuredMesh.php">00049</a> <span class="keyword">class </span><a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a> : <span class="keyword">public</span> <a class="code" href="classMeshBase.php">MeshBase</a>
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051  <span class="keyword">public</span>:
<a name="l00052"></a>00052 
<a name="l00058"></a>00058   <a class="code" href="classUnstructuredMesh.php#ab9f99e6f8588059a7e2ad8c76d9c9ff4">UnstructuredMesh</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d);
<a name="l00059"></a>00059 
<a name="l00063"></a>00063   <span class="keyword">virtual</span> <a class="code" href="classUnstructuredMesh.php#a9fb8afbacf4616b15adc57dc9596ea8a">~UnstructuredMesh</a>();
<a name="l00064"></a>00064 
<a name="l00075"></a>00075   <span class="keywordtype">void</span> <a class="code" href="classUnstructuredMesh.php#ac1b63b160430d8e3ec8403bcda8b9276">read</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>,
<a name="l00076"></a>00076              <a class="code" href="classMeshData.php">MeshData</a>* mesh_data=NULL,
<a name="l00077"></a>00077              <span class="keywordtype">bool</span> skip_renumber_nodes_and_elements=<span class="keyword">false</span>);
<a name="l00086"></a>00086   <span class="keywordtype">void</span> <a class="code" href="classUnstructuredMesh.php#a42193c99593ef551f261ae292b6126a6">write</a> (<span class="keyword">const</span> std::string&amp; name,
<a name="l00087"></a>00087               <a class="code" href="classMeshData.php">MeshData</a>* mesh_data=NULL);
<a name="l00088"></a>00088   
<a name="l00093"></a>00093   <span class="keywordtype">void</span> <a class="code" href="classUnstructuredMesh.php#a42193c99593ef551f261ae292b6126a6">write</a> (<span class="keyword">const</span> std::string&amp; name,
<a name="l00094"></a>00094               <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; values,
<a name="l00095"></a>00095               <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; variable_names);
<a name="l00096"></a>00096 
<a name="l00103"></a>00103   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classUnstructuredMesh.php#a14688d6378bdb35020a8490422c8dab6">all_first_order</a> ();
<a name="l00104"></a>00104 
<a name="l00116"></a>00116   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classUnstructuredMesh.php#aac5dd90794ebf089ad9711c5822b9072">all_second_order</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> full_ordered=<span class="keyword">true</span>);
<a name="l00117"></a>00117   
<a name="l00124"></a>00124   <span class="keywordtype">void</span> <a class="code" href="classUnstructuredMesh.php#a072f782f164adc1e747cf8c570fa2dd1">create_pid_mesh</a> (<a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; pid_mesh,
<a name="l00125"></a>00125                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid) <span class="keyword">const</span>;
<a name="l00126"></a>00126   
<a name="l00132"></a>00132   <span class="keywordtype">void</span> <a class="code" href="classUnstructuredMesh.php#abf1f5754fc6aeaa91ad6f0f04ad10097">create_submesh</a> (<a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; new_mesh,
<a name="l00133"></a>00133                        <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>&amp; it,
<a name="l00134"></a>00134                        <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">const_element_iterator</a>&amp; it_end) <span class="keyword">const</span>;
<a name="l00135"></a>00135   
<a name="l00136"></a>00136 
<a name="l00141"></a>00141   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classUnstructuredMesh.php#afecc40762dc88b1ef471a9d4a3938f4c">copy_nodes_and_elements</a>(<span class="keyword">const</span> <a class="code" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; other_mesh);  
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00147"></a>00147   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classUnstructuredMesh.php#a98c765606a6c53e090c2595b739201ff">find_neighbors</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> reset_remote_elements = <span class="keyword">false</span>,
<a name="l00148"></a>00148                                <span class="keyword">const</span> <span class="keywordtype">bool</span> reset_current_list    = <span class="keyword">true</span>);
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00151"></a>00151 <span class="preprocessor"></span>
<a name="l00156"></a>00156   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classUnstructuredMesh.php#ad0b588e3115f79b579d600f244159705">contract</a> ();
<a name="l00157"></a>00157 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00158"></a>00158 <span class="preprocessor"></span>
<a name="l00159"></a>00159 };
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
