<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>unv_io.C</h1>  </div>
</div>
<div class="contents">
<a href="unv__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: unv_io.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;iomanip&gt;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;cstdio&gt;</span>   <span class="comment">// for std::sprintf</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::sort</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;unv_io.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;mesh_data.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;face_quad4.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;face_tri3.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;face_tri6.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;face_quad8.h&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;face_quad9.h&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;cell_tet4.h&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;cell_hex8.h&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;cell_hex20.h&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;cell_tet10.h&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &quot;cell_prism6.h&quot;</span>
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="preprocessor">#ifdef LIBMESH_HAVE_GZSTREAM</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span><span class="preprocessor"># include &quot;gzstream.h&quot;</span> <span class="comment">// For reading/writing compressed streams</span>
<a name="l00046"></a>00046 <span class="preprocessor">#endif</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span>
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 <span class="comment">//-----------------------------------------------------------------------------</span>
<a name="l00053"></a>00053 <span class="comment">// UNVIO class static members</span>
<a name="l00054"></a>00054 <span class="keyword">const</span> std::string <a class="code" href="classUNVIO.php#a6b7fa514960a93fe3778f86ad26dedb0">UNVIO::_label_dataset_nodes</a>    = <span class="stringliteral">&quot;2411&quot;</span>;
<a name="l00055"></a>00055 <span class="keyword">const</span> std::string <a class="code" href="classUNVIO.php#ac77599b563ab3eb28c344085e2937059">UNVIO::_label_dataset_elements</a> = <span class="stringliteral">&quot;2412&quot;</span>;
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00060"></a>00060 <span class="comment">// UNVIO class members</span>
<a name="l00061"></a><a class="code" href="classUNVIO.php#a09a85205e7afa776b2bad647d06b01b9">00061</a> <span class="keywordtype">void</span> <a class="code" href="classUNVIO.php#a09a85205e7afa776b2bad647d06b01b9">UNVIO::clear</a> ()
<a name="l00062"></a>00062 {
<a name="l00063"></a>00063   <span class="comment">/*</span>
<a name="l00064"></a>00064 <span class="comment">   * Initialize these to dummy values</span>
<a name="l00065"></a>00065 <span class="comment">   */</span>
<a name="l00066"></a>00066   this-&gt;<a class="code" href="classUNVIO.php#a26ec56cf191f525f0f00c12014c76e88">_n_nodes</a>     = 0;
<a name="l00067"></a>00067   this-&gt;<a class="code" href="classUNVIO.php#a90edacdb984a8c6dd6be96a636a56f96">_n_elements</a>  = 0;
<a name="l00068"></a>00068   this-&gt;<a class="code" href="classUNVIO.php#ae6fb40cfcf52a48c8ccd9cdecedf8b9f">_need_D_to_e</a> = <span class="keyword">true</span>;
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   this-&gt;<a class="code" href="classUNVIO.php#a80192cd817475ee4e6894e71317587b1">_assign_nodes</a>.clear();
<a name="l00071"></a>00071   this-&gt;<a class="code" href="classUNVIO.php#ace408490a726e8e75622a252824ac100">_ds_position</a>.clear();
<a name="l00072"></a>00072 }
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00078"></a><a class="code" href="classUNVIO.php#a40a24f88a4f993af6bc8e36fb3f44de1">00078</a> <span class="keywordtype">void</span> <a class="code" href="classUNVIO.php#a40a24f88a4f993af6bc8e36fb3f44de1">UNVIO::read</a> (<span class="keyword">const</span> std::string&amp; file_name)
<a name="l00079"></a>00079 {
<a name="l00080"></a>00080   <span class="keywordflow">if</span> (file_name.rfind(<span class="stringliteral">&quot;.gz&quot;</span>) &lt; file_name.size())
<a name="l00081"></a>00081     {
<a name="l00082"></a>00082 <span class="preprocessor">#ifdef LIBMESH_HAVE_GZSTREAM</span>
<a name="l00083"></a>00083 <span class="preprocessor"></span>      
<a name="l00084"></a>00084       igzstream in_stream (file_name.c_str());
<a name="l00085"></a>00085       this-&gt;<a class="code" href="classUNVIO.php#ae413b484259e51836731399c8fbb3265">read_implementation</a> (in_stream);
<a name="l00086"></a>00086       
<a name="l00087"></a>00087 <span class="preprocessor">#else</span>
<a name="l00088"></a>00088 <span class="preprocessor"></span>      
<a name="l00089"></a>00089       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR:  You must have the zlib.h header &quot;</span>
<a name="l00090"></a>00090                 &lt;&lt; <span class="stringliteral">&quot;files and libraries to read and write &quot;</span>
<a name="l00091"></a>00091                 &lt;&lt; <span class="stringliteral">&quot;compressed streams.&quot;</span>
<a name="l00092"></a>00092                 &lt;&lt; std::endl;
<a name="l00093"></a>00093       libmesh_error();
<a name="l00094"></a>00094       
<a name="l00095"></a>00095 <span class="preprocessor">#endif</span>
<a name="l00096"></a>00096 <span class="preprocessor"></span>      <span class="keywordflow">return</span>;      
<a name="l00097"></a>00097     }
<a name="l00098"></a>00098   
<a name="l00099"></a>00099   <span class="keywordflow">else</span>
<a name="l00100"></a>00100     {
<a name="l00101"></a>00101       std::ifstream in_stream (file_name.c_str());
<a name="l00102"></a>00102       this-&gt;<a class="code" href="classUNVIO.php#ae413b484259e51836731399c8fbb3265">read_implementation</a> (in_stream);
<a name="l00103"></a>00103       <span class="keywordflow">return</span>;
<a name="l00104"></a>00104     }
<a name="l00105"></a>00105 }
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 
<a name="l00108"></a><a class="code" href="classUNVIO.php#ae413b484259e51836731399c8fbb3265">00108</a> <span class="keywordtype">void</span> <a class="code" href="classUNVIO.php#ae413b484259e51836731399c8fbb3265">UNVIO::read_implementation</a> (std::istream&amp; in_stream)
<a name="l00109"></a>00109 {
<a name="l00110"></a>00110   <span class="comment">// clear everything, so that</span>
<a name="l00111"></a>00111   <span class="comment">// we can start from scratch</span>
<a name="l00112"></a>00112   this-&gt;<a class="code" href="classUNVIO.php#a09a85205e7afa776b2bad647d06b01b9">clear</a> ();
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115    <span class="comment">// Note that we read this file</span>
<a name="l00116"></a>00116    <span class="comment">// @e twice.  First time to</span>
<a name="l00117"></a>00117    <span class="comment">// detect the number of nodes</span>
<a name="l00118"></a>00118    <span class="comment">// and elements (and possible</span>
<a name="l00119"></a>00119    <span class="comment">// conversion tasks like D_to_e)</span>
<a name="l00120"></a>00120    <span class="comment">// and the order of datasets</span>
<a name="l00121"></a>00121    <span class="comment">// (nodes first, then elements,</span>
<a name="l00122"></a>00122    <span class="comment">// or the other way around),</span>
<a name="l00123"></a>00123    <span class="comment">// and second to do the actual</span>
<a name="l00124"></a>00124    <span class="comment">// read.</span>
<a name="l00125"></a>00125   std::vector&lt;std::string&gt; order_of_datasets;
<a name="l00126"></a>00126   order_of_datasets.reserve(2);
<a name="l00127"></a>00127   
<a name="l00128"></a>00128   {
<a name="l00129"></a>00129     <span class="comment">// the first time we read the file,</span>
<a name="l00130"></a>00130     <span class="comment">// merely to obtain overall info</span>
<a name="l00131"></a>00131     <span class="keywordflow">if</span> ( !in_stream.good() )
<a name="l00132"></a>00132       {
<a name="l00133"></a>00133         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Input file not good.&quot;</span> 
<a name="l00134"></a>00134                   &lt;&lt; std::endl;
<a name="l00135"></a>00135         libmesh_error();
<a name="l00136"></a>00136       }
<a name="l00137"></a>00137 
<a name="l00138"></a>00138     
<a name="l00139"></a>00139     <span class="comment">// Count nodes and elements, then let </span>
<a name="l00140"></a>00140     <span class="comment">// other methods read the element and </span>
<a name="l00141"></a>00141     <span class="comment">// node data.  Also remember which</span>
<a name="l00142"></a>00142     <span class="comment">// dataset comes first: nodes or elements</span>
<a name="l00143"></a>00143     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classUNVIO.php#ac6095c3fa3e67769a0084172628d5f3e">verbose</a>())
<a name="l00144"></a>00144       std::cout &lt;&lt; <span class="stringliteral">&quot;  Counting nodes and elements&quot;</span> &lt;&lt; std::endl;
<a name="l00145"></a>00145     
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 <span class="comment">//    bool reached_eof = false;</span>
<a name="l00148"></a>00148     <span class="keywordtype">bool</span> found_node  = <span class="keyword">false</span>;
<a name="l00149"></a>00149     <span class="keywordtype">bool</span> found_elem  = <span class="keyword">false</span>;
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00152"></a>00152     std::string olds, news;
<a name="l00153"></a>00153 
<a name="l00154"></a>00154     <span class="keywordflow">while</span> (in_stream.good())
<a name="l00155"></a>00155       {
<a name="l00156"></a>00156         in_stream &gt;&gt; olds &gt;&gt; news;
<a name="l00157"></a>00157         
<a name="l00158"></a>00158         <span class="comment">// a &quot;-1&quot; followed by a number means the beginning of a dataset</span>
<a name="l00159"></a>00159         <span class="comment">// stop combing at the end of the file</span>
<a name="l00160"></a>00160         <span class="keywordflow">while</span> ( ((olds != <span class="stringliteral">&quot;-1&quot;</span>) || (news == <span class="stringliteral">&quot;-1&quot;</span>) ) &amp;&amp; !in_stream.eof() )
<a name="l00161"></a>00161           {       
<a name="l00162"></a>00162             olds = news;
<a name="l00163"></a>00163             in_stream &gt;&gt; news;
<a name="l00164"></a>00164           }
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 <span class="comment">//      if (in_stream.eof())</span>
<a name="l00167"></a>00167 <span class="comment">//        {</span>
<a name="l00168"></a>00168 <span class="comment">//          reached_eof = true;</span>
<a name="l00169"></a>00169 <span class="comment">//          break;</span>
<a name="l00170"></a>00170 <span class="comment">//        }</span>
<a name="l00171"></a>00171 
<a name="l00172"></a>00172         
<a name="l00173"></a>00173         <span class="comment">// if beginning of dataset, buffer it in</span>
<a name="l00174"></a>00174         <span class="comment">// temp_buffer, if desired</span>
<a name="l00175"></a>00175         <span class="keywordflow">if</span> (news == <a class="code" href="classUNVIO.php#a6b7fa514960a93fe3778f86ad26dedb0">_label_dataset_nodes</a>)
<a name="l00176"></a>00176           {
<a name="l00177"></a>00177             found_node = <span class="keyword">true</span>;
<a name="l00178"></a>00178             order_of_datasets.push_back (<a class="code" href="classUNVIO.php#a6b7fa514960a93fe3778f86ad26dedb0">_label_dataset_nodes</a>);
<a name="l00179"></a>00179             this-&gt;<a class="code" href="classUNVIO.php#a81183897fdd5814dcc70a9a09a593e2f">count_nodes</a> (in_stream);
<a name="l00180"></a>00180 
<a name="l00181"></a>00181             <span class="comment">// we can save some time scanning the file</span>
<a name="l00182"></a>00182             <span class="comment">// when we know we already have everything</span>
<a name="l00183"></a>00183             <span class="comment">// we want</span>
<a name="l00184"></a>00184             <span class="keywordflow">if</span> (found_elem)
<a name="l00185"></a>00185               <span class="keywordflow">break</span>;
<a name="l00186"></a>00186           }
<a name="l00187"></a>00187 
<a name="l00188"></a>00188         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (news == <a class="code" href="classUNVIO.php#ac77599b563ab3eb28c344085e2937059">_label_dataset_elements</a>)
<a name="l00189"></a>00189           {
<a name="l00190"></a>00190             found_elem = <span class="keyword">true</span>;
<a name="l00191"></a>00191             order_of_datasets.push_back (<a class="code" href="classUNVIO.php#ac77599b563ab3eb28c344085e2937059">_label_dataset_elements</a>);
<a name="l00192"></a>00192             this-&gt;<a class="code" href="classUNVIO.php#a4b910b386669e8437948b223fd98316f">count_elements</a> (in_stream);
<a name="l00193"></a>00193 
<a name="l00194"></a>00194             <span class="comment">// we can save some time scanning the file</span>
<a name="l00195"></a>00195             <span class="comment">// when we know we already have everything</span>
<a name="l00196"></a>00196             <span class="comment">// we want</span>
<a name="l00197"></a>00197             <span class="keywordflow">if</span> (found_node)
<a name="l00198"></a>00198               <span class="keywordflow">break</span>;
<a name="l00199"></a>00199           }
<a name="l00200"></a>00200       }
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 
<a name="l00203"></a>00203     <span class="comment">// Here we should better have found</span>
<a name="l00204"></a>00204     <span class="comment">// the datasets for nodes and elements,</span>
<a name="l00205"></a>00205     <span class="comment">// otherwise the unv files is bad!</span>
<a name="l00206"></a>00206     <span class="keywordflow">if</span> (!found_elem)
<a name="l00207"></a>00207       {
<a name="l00208"></a>00208         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Could not find elements!&quot;</span> &lt;&lt; std::endl;
<a name="l00209"></a>00209         libmesh_error();
<a name="l00210"></a>00210       }
<a name="l00211"></a>00211 
<a name="l00212"></a>00212     <span class="keywordflow">if</span> (!found_node)
<a name="l00213"></a>00213       {
<a name="l00214"></a>00214         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Could not find nodes!&quot;</span> &lt;&lt; std::endl;
<a name="l00215"></a>00215         libmesh_error();
<a name="l00216"></a>00216       }
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 
<a name="l00219"></a>00219     <span class="comment">// Don&#39;t close, just seek to the beginning</span>
<a name="l00220"></a>00220     in_stream.seekg(0, std::ios::beg);
<a name="l00221"></a>00221     
<a name="l00222"></a>00222     <span class="keywordflow">if</span> (!in_stream.good() )
<a name="l00223"></a>00223       {
<a name="l00224"></a>00224         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Cannot re-read input file.&quot;</span> 
<a name="l00225"></a>00225                   &lt;&lt; std::endl;
<a name="l00226"></a>00226         libmesh_error();
<a name="l00227"></a>00227       }
<a name="l00228"></a>00228   }
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 
<a name="l00234"></a>00234   <span class="comment">// We finished scanning the file,</span>
<a name="l00235"></a>00235   <span class="comment">// and our member data </span>
<a name="l00236"></a>00236   <span class="comment">// \p this-&gt;_n_nodes,</span>
<a name="l00237"></a>00237   <span class="comment">// \p this-&gt;_n_elements,</span>
<a name="l00238"></a>00238   <span class="comment">// \p this-&gt;_need_D_to_e</span>
<a name="l00239"></a>00239   <span class="comment">// should be properly initialized.</span>
<a name="l00240"></a>00240   {
<a name="l00241"></a>00241     <span class="comment">// Read the datasets in the order that</span>
<a name="l00242"></a>00242     <span class="comment">// we already know</span>
<a name="l00243"></a>00243     libmesh_assert (order_of_datasets.size()==2);
<a name="l00244"></a>00244 
<a name="l00245"></a>00245     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ds=0; ds &lt; order_of_datasets.size(); ds++)
<a name="l00246"></a>00246       {
<a name="l00247"></a>00247         <span class="keywordflow">if</span> (order_of_datasets[ds] == <a class="code" href="classUNVIO.php#a6b7fa514960a93fe3778f86ad26dedb0">_label_dataset_nodes</a>)
<a name="l00248"></a>00248           this-&gt;<a class="code" href="classUNVIO.php#a2923e755e639db970e2f0c8c7beb9a9e">node_in</a>    (in_stream);
<a name="l00249"></a>00249 
<a name="l00250"></a>00250         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (order_of_datasets[ds] == <a class="code" href="classUNVIO.php#ac77599b563ab3eb28c344085e2937059">_label_dataset_elements</a>)
<a name="l00251"></a>00251           this-&gt;<a class="code" href="classUNVIO.php#a1632bd719dc3a2261a2cf8cd86cd42ee">element_in</a> (in_stream);
<a name="l00252"></a>00252 
<a name="l00253"></a>00253         <span class="keywordflow">else</span>
<a name="l00254"></a>00254           libmesh_error();
<a name="l00255"></a>00255       }
<a name="l00256"></a>00256 
<a name="l00257"></a>00257 
<a name="l00258"></a>00258     <span class="comment">// tell the MeshData object that we are finished </span>
<a name="l00259"></a>00259     <span class="comment">// reading data</span>
<a name="l00260"></a>00260     this-&gt;<a class="code" href="classUNVIO.php#a6e6228ac83245ac0d89c98cad6556124">_mesh_data</a>.<a class="code" href="classMeshData.php#a3cec8b434c51b58caec642d978c64ab4">close_foreign_id_maps</a> ();
<a name="l00261"></a>00261 
<a name="l00262"></a>00262     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classUNVIO.php#ac6095c3fa3e67769a0084172628d5f3e">verbose</a>())
<a name="l00263"></a>00263       std::cout &lt;&lt; <span class="stringliteral">&quot;  Finished.&quot;</span> &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l00264"></a>00264   }
<a name="l00265"></a>00265   
<a name="l00266"></a>00266   <span class="comment">// save memory</span>
<a name="l00267"></a>00267   this-&gt;<a class="code" href="classUNVIO.php#a80192cd817475ee4e6894e71317587b1">_assign_nodes</a>.clear();
<a name="l00268"></a>00268   this-&gt;<a class="code" href="classUNVIO.php#ace408490a726e8e75622a252824ac100">_ds_position</a>.clear();
<a name="l00269"></a>00269 }
<a name="l00270"></a>00270 
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 
<a name="l00273"></a>00273 
<a name="l00274"></a>00274 
<a name="l00275"></a><a class="code" href="classUNVIO.php#a5104c54df79a6fbc4ec7c617c1d72b35">00275</a> <span class="keywordtype">void</span> <a class="code" href="classUNVIO.php#a5104c54df79a6fbc4ec7c617c1d72b35">UNVIO::write</a> (<span class="keyword">const</span> std::string&amp; file_name)
<a name="l00276"></a>00276 {
<a name="l00277"></a>00277   <span class="keywordflow">if</span> (file_name.rfind(<span class="stringliteral">&quot;.gz&quot;</span>) &lt; file_name.size())
<a name="l00278"></a>00278     {
<a name="l00279"></a>00279 <span class="preprocessor">#ifdef LIBMESH_HAVE_GZSTREAM</span>
<a name="l00280"></a>00280 <span class="preprocessor"></span>      
<a name="l00281"></a>00281       ogzstream out_stream(file_name.c_str());
<a name="l00282"></a>00282       this-&gt;<a class="code" href="classUNVIO.php#a3cf0cbd9b944fed2a91b758eefc50373">write_implementation</a> (out_stream);
<a name="l00283"></a>00283       
<a name="l00284"></a>00284 <span class="preprocessor">#else</span>
<a name="l00285"></a>00285 <span class="preprocessor"></span>      
<a name="l00286"></a>00286       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR:  You must have the zlib.h header &quot;</span>
<a name="l00287"></a>00287                 &lt;&lt; <span class="stringliteral">&quot;files and libraries to read and write &quot;</span>
<a name="l00288"></a>00288                 &lt;&lt; <span class="stringliteral">&quot;compressed streams.&quot;</span>
<a name="l00289"></a>00289                 &lt;&lt; std::endl;
<a name="l00290"></a>00290       libmesh_error();
<a name="l00291"></a>00291       
<a name="l00292"></a>00292 <span class="preprocessor">#endif</span>
<a name="l00293"></a>00293 <span class="preprocessor"></span>      
<a name="l00294"></a>00294       <span class="keywordflow">return</span>;      
<a name="l00295"></a>00295     }
<a name="l00296"></a>00296   
<a name="l00297"></a>00297   <span class="keywordflow">else</span>
<a name="l00298"></a>00298     {
<a name="l00299"></a>00299       std::ofstream out_stream (file_name.c_str());
<a name="l00300"></a>00300       this-&gt;<a class="code" href="classUNVIO.php#a3cf0cbd9b944fed2a91b758eefc50373">write_implementation</a> (out_stream);
<a name="l00301"></a>00301       <span class="keywordflow">return</span>;
<a name="l00302"></a>00302     }
<a name="l00303"></a>00303 }
<a name="l00304"></a>00304 
<a name="l00305"></a>00305 
<a name="l00306"></a>00306 
<a name="l00307"></a>00307 
<a name="l00308"></a><a class="code" href="classUNVIO.php#a3cf0cbd9b944fed2a91b758eefc50373">00308</a> <span class="keywordtype">void</span> <a class="code" href="classUNVIO.php#a3cf0cbd9b944fed2a91b758eefc50373">UNVIO::write_implementation</a> (std::ostream&amp; out_file)
<a name="l00309"></a>00309 {
<a name="l00310"></a>00310   <span class="keywordflow">if</span> ( !out_file.good() )
<a name="l00311"></a>00311     {
<a name="l00312"></a>00312       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Output file not good.&quot;</span> 
<a name="l00313"></a>00313                 &lt;&lt; std::endl;
<a name="l00314"></a>00314       libmesh_error();
<a name="l00315"></a>00315     }
<a name="l00316"></a>00316 
<a name="l00317"></a>00317 
<a name="l00318"></a>00318   <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00319"></a>00319   
<a name="l00320"></a>00320   <span class="comment">// already know these data, so initialize</span>
<a name="l00321"></a>00321   <span class="comment">// them.  Does not hurt.</span>
<a name="l00322"></a>00322   this-&gt;<a class="code" href="classUNVIO.php#a26ec56cf191f525f0f00c12014c76e88">_n_nodes</a>      = mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>();
<a name="l00323"></a>00323   this-&gt;<a class="code" href="classUNVIO.php#a90edacdb984a8c6dd6be96a636a56f96">_n_elements</a>   = mesh.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>();
<a name="l00324"></a>00324   this-&gt;<a class="code" href="classUNVIO.php#ae6fb40cfcf52a48c8ccd9cdecedf8b9f">_need_D_to_e</a>  = <span class="keyword">false</span>;
<a name="l00325"></a>00325 
<a name="l00326"></a>00326 
<a name="l00327"></a>00327  
<a name="l00328"></a>00328   <span class="comment">// we need the MeshData, otherwise we do not</span>
<a name="l00329"></a>00329   <span class="comment">// know the foreign node id</span>
<a name="l00330"></a>00330   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classUNVIO.php#a6e6228ac83245ac0d89c98cad6556124">_mesh_data</a>.<a class="code" href="classMeshData.php#a4d99efe5fb30d203afdd520d213c6233">active</a>())
<a name="l00331"></a>00331     <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classUNVIO.php#a6e6228ac83245ac0d89c98cad6556124">_mesh_data</a>.<a class="code" href="classMeshData.php#af448a633cf06236e8ebcb5cf73d3d2eb">compatibility_mode</a>())
<a name="l00332"></a>00332       {
<a name="l00333"></a>00333         std::cerr &lt;&lt; std::endl
<a name="l00334"></a>00334                   &lt;&lt; <span class="stringliteral">&quot;*************************************************************************&quot;</span> &lt;&lt; std::endl
<a name="l00335"></a>00335                   &lt;&lt; <span class="stringliteral">&quot;* WARNING: MeshData neither active nor in compatibility mode.           *&quot;</span> &lt;&lt; std::endl
<a name="l00336"></a>00336                   &lt;&lt; <span class="stringliteral">&quot;*          Enable compatibility mode for MeshData.  Use this Universal  *&quot;</span> &lt;&lt; std::endl
<a name="l00337"></a>00337                   &lt;&lt; <span class="stringliteral">&quot;*          file with caution: libMesh node and element ids are used.    *&quot;</span> &lt;&lt; std::endl
<a name="l00338"></a>00338                   &lt;&lt; <span class="stringliteral">&quot;*************************************************************************&quot;</span> &lt;&lt; std::endl
<a name="l00339"></a>00339                   &lt;&lt; std::endl;
<a name="l00340"></a>00340         this-&gt;<a class="code" href="classUNVIO.php#a6e6228ac83245ac0d89c98cad6556124">_mesh_data</a>.<a class="code" href="classMeshData.php#a39e9c138f115d45a44e7718f7efc79fc">enable_compatibility_mode</a>();
<a name="l00341"></a>00341       }
<a name="l00342"></a>00342 
<a name="l00343"></a>00343 
<a name="l00344"></a>00344 
<a name="l00345"></a>00345   <span class="comment">// write the nodes,  then the elements</span>
<a name="l00346"></a>00346   this-&gt;<a class="code" href="classUNVIO.php#ab01b5e4a6eefbec7f0c8ca121071e6bd">node_out</a>    (out_file);
<a name="l00347"></a>00347   this-&gt;<a class="code" href="classUNVIO.php#ac693037f9e6a48b02bc7b5018448b42b">element_out</a> (out_file);
<a name="l00348"></a>00348 }
<a name="l00349"></a>00349 
<a name="l00350"></a>00350 
<a name="l00351"></a>00351 
<a name="l00352"></a>00352 
<a name="l00353"></a>00353 
<a name="l00354"></a><a class="code" href="classUNVIO.php#a81183897fdd5814dcc70a9a09a593e2f">00354</a> <span class="keywordtype">void</span> <a class="code" href="classUNVIO.php#a81183897fdd5814dcc70a9a09a593e2f">UNVIO::count_nodes</a> (std::istream&amp; in_file)
<a name="l00355"></a>00355 {
<a name="l00356"></a>00356   START_LOG(<span class="stringliteral">&quot;count_nodes()&quot;</span>,<span class="stringliteral">&quot;UNVIO&quot;</span>);
<a name="l00357"></a>00357 
<a name="l00358"></a>00358   <span class="comment">// if this-&gt;_n_nodes is not 0 the dataset </span>
<a name="l00359"></a>00359   <span class="comment">// has already been scanned</span>
<a name="l00360"></a>00360   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classUNVIO.php#a26ec56cf191f525f0f00c12014c76e88">_n_nodes</a> != 0)
<a name="l00361"></a>00361     {
<a name="l00362"></a>00362       std::cerr &lt;&lt; <span class="stringliteral">&quot;Error: Trying to scan nodes twice!&quot;</span> 
<a name="l00363"></a>00363                 &lt;&lt; std::endl;
<a name="l00364"></a>00364       libmesh_error();
<a name="l00365"></a>00365     }
<a name="l00366"></a>00366 
<a name="l00367"></a>00367 
<a name="l00368"></a>00368   <span class="comment">// Read from file, count nodes,</span>
<a name="l00369"></a>00369   <span class="comment">// check if floats have to be converted</span>
<a name="l00370"></a>00370   std::string data;
<a name="l00371"></a>00371 
<a name="l00372"></a>00372   in_file &gt;&gt; data; <span class="comment">// read the first node label</span>
<a name="l00373"></a>00373 
<a name="l00374"></a>00374 
<a name="l00375"></a>00375   <span class="keywordflow">if</span> (data == <span class="stringliteral">&quot;-1&quot;</span>)
<a name="l00376"></a>00376     {
<a name="l00377"></a>00377       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad, already reached end of dataset before even starting to read nodes!&quot;</span>
<a name="l00378"></a>00378                 &lt;&lt; std::endl;
<a name="l00379"></a>00379       libmesh_error();
<a name="l00380"></a>00380     }
<a name="l00381"></a>00381 
<a name="l00382"></a>00382  
<a name="l00383"></a>00383   <span class="comment">// ignore the misc data for this node</span>
<a name="l00384"></a>00384   in_file.ignore(256,<span class="charliteral">&#39;\n&#39;</span>);           
<a name="l00385"></a>00385 
<a name="l00386"></a>00386 
<a name="l00387"></a>00387   
<a name="l00388"></a>00388   <span class="comment">// Now we are there to verify whether we need</span>
<a name="l00389"></a>00389   <span class="comment">// to convert from D to e or not</span>
<a name="l00390"></a>00390   in_file &gt;&gt; data;
<a name="l00391"></a>00391 
<a name="l00392"></a>00392   <span class="comment">// When this &quot;data&quot; contains a &quot;D&quot;, then</span>
<a name="l00393"></a>00393   <span class="comment">// we have to convert each and every float...</span>
<a name="l00394"></a>00394   <span class="comment">// But also assume when _this_ specific</span>
<a name="l00395"></a>00395   <span class="comment">// line does not contain a &quot;D&quot;, then the</span>
<a name="l00396"></a>00396   <span class="comment">// other lines won&#39;t, too.</span>
<a name="l00397"></a>00397   {
<a name="l00398"></a>00398 <span class="comment">// #ifdef __HP_aCC</span>
<a name="l00399"></a>00399 <span class="comment">//     // Use an &quot;int&quot; instead of unsigned int,</span>
<a name="l00400"></a>00400 <span class="comment">//     // otherwise HP aCC may crash!</span>
<a name="l00401"></a>00401 <span class="comment">//     const int position          = data.find(&quot;D&quot;,6);</span>
<a name="l00402"></a>00402 <span class="comment">// #else</span>
<a name="l00403"></a>00403 <span class="comment">//     const unsigned int position = data.find(&quot;D&quot;,6);</span>
<a name="l00404"></a>00404 <span class="comment">// #endif</span>
<a name="l00405"></a>00405     std::string::size_type position = data.find(<span class="stringliteral">&quot;D&quot;</span>,6);
<a name="l00406"></a>00406 
<a name="l00407"></a>00407     <span class="keywordflow">if</span> (position!=std::string::npos) <span class="comment">// npos means no position</span>
<a name="l00408"></a>00408       {
<a name="l00409"></a>00409         this-&gt;<a class="code" href="classUNVIO.php#ae6fb40cfcf52a48c8ccd9cdecedf8b9f">_need_D_to_e</a> = <span class="keyword">true</span>;
<a name="l00410"></a>00410         
<a name="l00411"></a>00411         <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classUNVIO.php#ac6095c3fa3e67769a0084172628d5f3e">verbose</a>())
<a name="l00412"></a>00412           std::cout &lt;&lt; <span class="stringliteral">&quot;  Convert from \&quot;D\&quot; to \&quot;e\&quot;&quot;</span> &lt;&lt; std::endl;
<a name="l00413"></a>00413       }
<a name="l00414"></a>00414     <span class="keywordflow">else</span>
<a name="l00415"></a>00415       this-&gt;<a class="code" href="classUNVIO.php#ae6fb40cfcf52a48c8ccd9cdecedf8b9f">_need_D_to_e</a> = <span class="keyword">false</span>;
<a name="l00416"></a>00416   }
<a name="l00417"></a>00417 
<a name="l00418"></a>00418   <span class="comment">// read the remaining two coordinates</span>
<a name="l00419"></a>00419   in_file &gt;&gt; data;
<a name="l00420"></a>00420   in_file &gt;&gt; data;
<a name="l00421"></a>00421 
<a name="l00422"></a>00422 
<a name="l00423"></a>00423   <span class="comment">// this was our first node</span>
<a name="l00424"></a>00424   this-&gt;<a class="code" href="classUNVIO.php#a26ec56cf191f525f0f00c12014c76e88">_n_nodes</a>++;
<a name="l00425"></a>00425 
<a name="l00426"></a>00426 
<a name="l00427"></a>00427 
<a name="l00428"></a>00428   <span class="comment">// proceed _counting_ the remaining</span>
<a name="l00429"></a>00429   <span class="comment">// nodes.</span>
<a name="l00430"></a>00430   <span class="keywordflow">while</span> (in_file.good())
<a name="l00431"></a>00431     {
<a name="l00432"></a>00432       <span class="comment">// read the node label</span>
<a name="l00433"></a>00433       in_file &gt;&gt; data; 
<a name="l00434"></a>00434                 
<a name="l00435"></a>00435       <span class="keywordflow">if</span> (data == <span class="stringliteral">&quot;-1&quot;</span>)
<a name="l00436"></a>00436         <span class="comment">// end of dataset is reached</span>
<a name="l00437"></a>00437         <span class="keywordflow">break</span>;
<a name="l00438"></a>00438       
<a name="l00439"></a>00439       <span class="comment">// ignore the remaining data (coord_sys_label, color etc)</span>
<a name="l00440"></a>00440       in_file.ignore (256, <span class="charliteral">&#39;\n&#39;</span>);
<a name="l00441"></a>00441       <span class="comment">// ignore the coordinates</span>
<a name="l00442"></a>00442       in_file.ignore (256, <span class="charliteral">&#39;\n&#39;</span>);
<a name="l00443"></a>00443 
<a name="l00444"></a>00444       this-&gt;<a class="code" href="classUNVIO.php#a26ec56cf191f525f0f00c12014c76e88">_n_nodes</a>++;
<a name="l00445"></a>00445     }
<a name="l00446"></a>00446 
<a name="l00447"></a>00447 
<a name="l00448"></a>00448   <span class="keywordflow">if</span> (in_file.eof())
<a name="l00449"></a>00449     {
<a name="l00450"></a>00450       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: File ended before end of node dataset!&quot;</span>
<a name="l00451"></a>00451                 &lt;&lt; std::endl;
<a name="l00452"></a>00452       libmesh_error();
<a name="l00453"></a>00453     }
<a name="l00454"></a>00454 
<a name="l00455"></a>00455   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classUNVIO.php#ac6095c3fa3e67769a0084172628d5f3e">verbose</a>())
<a name="l00456"></a>00456     std::cout &lt;&lt; <span class="stringliteral">&quot;  Nodes   : &quot;</span> &lt;&lt; this-&gt;<a class="code" href="classUNVIO.php#a26ec56cf191f525f0f00c12014c76e88">_n_nodes</a> &lt;&lt; std::endl;
<a name="l00457"></a>00457 
<a name="l00458"></a>00458   STOP_LOG(<span class="stringliteral">&quot;count_nodes()&quot;</span>,<span class="stringliteral">&quot;UNVIO&quot;</span>);
<a name="l00459"></a>00459 }
<a name="l00460"></a>00460 
<a name="l00461"></a>00461 
<a name="l00462"></a>00462 
<a name="l00463"></a>00463 
<a name="l00464"></a>00464 
<a name="l00465"></a>00465 
<a name="l00466"></a><a class="code" href="classUNVIO.php#a4b910b386669e8437948b223fd98316f">00466</a> <span class="keywordtype">void</span> <a class="code" href="classUNVIO.php#a4b910b386669e8437948b223fd98316f">UNVIO::count_elements</a> (std::istream&amp; in_file)
<a name="l00467"></a>00467 {
<a name="l00468"></a>00468   START_LOG(<span class="stringliteral">&quot;count_elements()&quot;</span>,<span class="stringliteral">&quot;UNVIO&quot;</span>);
<a name="l00469"></a>00469 
<a name="l00470"></a>00470   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classUNVIO.php#a90edacdb984a8c6dd6be96a636a56f96">_n_elements</a> != 0)
<a name="l00471"></a>00471     {
<a name="l00472"></a>00472       std::cerr &lt;&lt; <span class="stringliteral">&quot;Error: Trying to scan elements twice!&quot;</span> 
<a name="l00473"></a>00473                 &lt;&lt; std::endl;
<a name="l00474"></a>00474       libmesh_error();
<a name="l00475"></a>00475     }
<a name="l00476"></a>00476 
<a name="l00477"></a>00477 
<a name="l00478"></a>00478   <span class="comment">// Simply read the element</span>
<a name="l00479"></a>00479   <span class="comment">// dataset for the @e only</span>
<a name="l00480"></a>00480   <span class="comment">// purpose to count nodes!</span>
<a name="l00481"></a>00481   
<a name="l00482"></a>00482   std::string data;
<a name="l00483"></a>00483   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> fe_id;
<a name="l00484"></a>00484 
<a name="l00485"></a>00485   <span class="keywordflow">while</span> (!in_file.eof())
<a name="l00486"></a>00486     {
<a name="l00487"></a>00487       <span class="comment">// read element label</span>
<a name="l00488"></a>00488       in_file &gt;&gt; data;
<a name="l00489"></a>00489       
<a name="l00490"></a>00490       <span class="comment">// end of dataset?</span>
<a name="l00491"></a>00491       <span class="keywordflow">if</span> (data == <span class="stringliteral">&quot;-1&quot;</span>) 
<a name="l00492"></a>00492         <span class="keywordflow">break</span>;
<a name="l00493"></a>00493         
<a name="l00494"></a>00494       <span class="comment">// read fe_id</span>
<a name="l00495"></a>00495       in_file &gt;&gt; fe_id;
<a name="l00496"></a>00496 
<a name="l00497"></a>00497       <span class="comment">// Skip related data,</span>
<a name="l00498"></a>00498       <span class="comment">// and node number list</span>
<a name="l00499"></a>00499       in_file.ignore (256,<span class="charliteral">&#39;\n&#39;</span>);
<a name="l00500"></a>00500       in_file.ignore (256,<span class="charliteral">&#39;\n&#39;</span>);
<a name="l00501"></a>00501 
<a name="l00502"></a>00502       <span class="comment">// For some elements the node numbers</span>
<a name="l00503"></a>00503       <span class="comment">// are given more than one record</span>
<a name="l00504"></a>00504 
<a name="l00505"></a>00505       <span class="comment">// TET10 or QUAD9</span>
<a name="l00506"></a>00506       <span class="keywordflow">if</span> (fe_id == 118 || fe_id == 300)
<a name="l00507"></a>00507           in_file.ignore (256,<span class="charliteral">&#39;\n&#39;</span>);
<a name="l00508"></a>00508 
<a name="l00509"></a>00509       <span class="comment">// HEX20</span>
<a name="l00510"></a>00510       <span class="keywordflow">if</span> (fe_id == 116)
<a name="l00511"></a>00511         {
<a name="l00512"></a>00512           in_file.ignore (256,<span class="charliteral">&#39;\n&#39;</span>);
<a name="l00513"></a>00513           in_file.ignore (256,<span class="charliteral">&#39;\n&#39;</span>);
<a name="l00514"></a>00514         }
<a name="l00515"></a>00515      
<a name="l00516"></a>00516       this-&gt;<a class="code" href="classUNVIO.php#a90edacdb984a8c6dd6be96a636a56f96">_n_elements</a>++;
<a name="l00517"></a>00517     }
<a name="l00518"></a>00518 
<a name="l00519"></a>00519 
<a name="l00520"></a>00520   <span class="keywordflow">if</span> (in_file.eof())
<a name="l00521"></a>00521     {
<a name="l00522"></a>00522       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: File ended before end of element dataset!&quot;</span>
<a name="l00523"></a>00523                 &lt;&lt; std::endl;
<a name="l00524"></a>00524       libmesh_error();
<a name="l00525"></a>00525     }
<a name="l00526"></a>00526 
<a name="l00527"></a>00527   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classUNVIO.php#ac6095c3fa3e67769a0084172628d5f3e">verbose</a>())
<a name="l00528"></a>00528     std::cout &lt;&lt; <span class="stringliteral">&quot;  Elements: &quot;</span> &lt;&lt; this-&gt;<a class="code" href="classUNVIO.php#a90edacdb984a8c6dd6be96a636a56f96">_n_elements</a> &lt;&lt; std::endl;
<a name="l00529"></a>00529 
<a name="l00530"></a>00530   STOP_LOG(<span class="stringliteral">&quot;count_elements()&quot;</span>,<span class="stringliteral">&quot;UNVIO&quot;</span>);
<a name="l00531"></a>00531 }
<a name="l00532"></a>00532 
<a name="l00533"></a>00533 
<a name="l00534"></a>00534 
<a name="l00535"></a><a class="code" href="classUNVIO.php#a2923e755e639db970e2f0c8c7beb9a9e">00535</a> <span class="keywordtype">void</span> <a class="code" href="classUNVIO.php#a2923e755e639db970e2f0c8c7beb9a9e">UNVIO::node_in</a> (std::istream&amp; in_file)
<a name="l00536"></a>00536 {
<a name="l00537"></a>00537   START_LOG(<span class="stringliteral">&quot;node_in()&quot;</span>,<span class="stringliteral">&quot;UNVIO&quot;</span>);
<a name="l00538"></a>00538 
<a name="l00539"></a>00539   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classUNVIO.php#ac6095c3fa3e67769a0084172628d5f3e">verbose</a>())
<a name="l00540"></a>00540     std::cout &lt;&lt; <span class="stringliteral">&quot;  Reading nodes&quot;</span> &lt;&lt; std::endl;
<a name="l00541"></a>00541 
<a name="l00542"></a>00542   <span class="comment">// adjust the \p istream to our position</span>
<a name="l00543"></a>00543   <span class="keyword">const</span> <span class="keywordtype">bool</span> ok = this-&gt;<a class="code" href="classUNVIO.php#a0eede436f9709971c5270f0fd8b62725">beginning_of_dataset</a>(in_file, <a class="code" href="classUNVIO.php#a6b7fa514960a93fe3778f86ad26dedb0">_label_dataset_nodes</a>);
<a name="l00544"></a>00544 
<a name="l00545"></a>00545   <span class="keywordflow">if</span> (!ok)
<a name="l00546"></a>00546     {
<a name="l00547"></a>00547       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Could not find node dataset!&quot;</span> &lt;&lt; std::endl;
<a name="l00548"></a>00548       libmesh_error();
<a name="l00549"></a>00549     }
<a name="l00550"></a>00550 
<a name="l00551"></a>00551   <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00552"></a>00552   
<a name="l00553"></a>00553   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_lab;           <span class="comment">// label of the node</span>
<a name="l00554"></a>00554   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> exp_coord_sys_num,  <span class="comment">// export coordinate system number       (not supported yet)</span>
<a name="l00555"></a>00555                disp_coord_sys_num, <span class="comment">// displacement coordinate system number (not supported yet)</span>
<a name="l00556"></a>00556                color;              <span class="comment">// color                                 (not supported yet)</span>
<a name="l00557"></a>00557 
<a name="l00558"></a>00558   <span class="comment">// allocate the correct amount </span>
<a name="l00559"></a>00559   <span class="comment">// of memory for the node vector</span>
<a name="l00560"></a>00560   this-&gt;<a class="code" href="classUNVIO.php#a80192cd817475ee4e6894e71317587b1">_assign_nodes</a>.reserve (this-&gt;<a class="code" href="classUNVIO.php#a26ec56cf191f525f0f00c12014c76e88">_n_nodes</a>);
<a name="l00561"></a>00561 
<a name="l00562"></a>00562 
<a name="l00563"></a>00563   <span class="comment">// always 3 coordinates in the UNV file, no matter</span>
<a name="l00564"></a>00564   <span class="comment">// which dimensionality libMesh is in</span>
<a name="l00565"></a>00565   <span class="comment">//std::vector&lt;Real&gt; xyz (3);</span>
<a name="l00566"></a>00566   <a class="code" href="classPoint.php">Point</a> xyz;
<a name="l00567"></a>00567       
<a name="l00568"></a>00568   <span class="comment">// depending on whether we have to convert each</span>
<a name="l00569"></a>00569   <span class="comment">// coordinate (float), we offer two versions.</span>
<a name="l00570"></a>00570   <span class="comment">// Note that \p count_nodes() already verified</span>
<a name="l00571"></a>00571   <span class="comment">// whether this file uses &quot;D&quot; of &quot;e&quot;</span>
<a name="l00572"></a>00572   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classUNVIO.php#ae6fb40cfcf52a48c8ccd9cdecedf8b9f">_need_D_to_e</a>)
<a name="l00573"></a>00573     {
<a name="l00574"></a>00574       <span class="comment">// ok, convert...</span>
<a name="l00575"></a>00575       std::string num_buf;
<a name="l00576"></a>00576 
<a name="l00577"></a>00577       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;<a class="code" href="classUNVIO.php#a26ec56cf191f525f0f00c12014c76e88">_n_nodes</a>; i++)
<a name="l00578"></a>00578         {
<a name="l00579"></a>00579           libmesh_assert (!in_file.eof());
<a name="l00580"></a>00580 
<a name="l00581"></a>00581           in_file &gt;&gt; node_lab                <span class="comment">// read the node label</span>
<a name="l00582"></a>00582                   &gt;&gt; exp_coord_sys_num       <span class="comment">// (not supported yet)</span>
<a name="l00583"></a>00583                   &gt;&gt; disp_coord_sys_num      <span class="comment">// (not supported yet)</span>
<a name="l00584"></a>00584                   &gt;&gt; color;                  <span class="comment">// (not supported yet)</span>
<a name="l00585"></a>00585 
<a name="l00586"></a>00586           <span class="comment">// take care of the</span>
<a name="l00587"></a>00587           <span class="comment">// floating-point data</span>
<a name="l00588"></a>00588           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d=0; d&lt;3; d++)
<a name="l00589"></a>00589             {
<a name="l00590"></a>00590               in_file &gt;&gt; num_buf;
<a name="l00591"></a>00591               xyz(d) = this-&gt;<a class="code" href="classUNVIO.php#a5caa80966b5492eaa947d3dbff410e25">D_to_e</a> (num_buf);
<a name="l00592"></a>00592             }
<a name="l00593"></a>00593 
<a name="l00594"></a>00594           <span class="comment">// set up the id map</span>
<a name="l00595"></a>00595           this-&gt;<a class="code" href="classUNVIO.php#a80192cd817475ee4e6894e71317587b1">_assign_nodes</a>.push_back (node_lab);
<a name="l00596"></a>00596           
<a name="l00597"></a>00597           <span class="comment">// add node to the Mesh &amp; </span>
<a name="l00598"></a>00598           <span class="comment">// tell the MeshData object the foreign node id</span>
<a name="l00599"></a>00599           <span class="comment">// (note that mesh.add_point() returns a pointer to the new node)</span>
<a name="l00600"></a>00600           this-&gt;<a class="code" href="classUNVIO.php#a6e6228ac83245ac0d89c98cad6556124">_mesh_data</a>.<a class="code" href="classMeshData.php#af408db231805974db975dbdf3c1756f5">add_foreign_node_id</a> (mesh.<a class="code" href="classMeshBase.php#a01b66468d3e9d8b5db82c6f3d9131f5e">add_point</a>(xyz,i), node_lab);
<a name="l00601"></a>00601         }
<a name="l00602"></a>00602     }
<a name="l00603"></a>00603 
<a name="l00604"></a>00604   <span class="keywordflow">else</span>
<a name="l00605"></a>00605     {
<a name="l00606"></a>00606       <span class="comment">// very well, no need to convert anything,</span>
<a name="l00607"></a>00607       <span class="comment">// just plain import.</span>
<a name="l00608"></a>00608       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0;i&lt;this-&gt;<a class="code" href="classUNVIO.php#a26ec56cf191f525f0f00c12014c76e88">_n_nodes</a>;i++)
<a name="l00609"></a>00609         {
<a name="l00610"></a>00610           libmesh_assert (!in_file.eof());
<a name="l00611"></a>00611 
<a name="l00612"></a>00612           in_file &gt;&gt; node_lab                <span class="comment">// read the node label</span>
<a name="l00613"></a>00613                   &gt;&gt; exp_coord_sys_num       <span class="comment">// (not supported yet)</span>
<a name="l00614"></a>00614                   &gt;&gt; disp_coord_sys_num      <span class="comment">// (not supported yet)</span>
<a name="l00615"></a>00615                   &gt;&gt; color                   <span class="comment">// (not supported yet)</span>
<a name="l00616"></a>00616                   &gt;&gt; xyz(0)                  <span class="comment">// read x-coordinate</span>
<a name="l00617"></a>00617                   &gt;&gt; xyz(1)                  <span class="comment">// read y-coordinate</span>
<a name="l00618"></a>00618                   &gt;&gt; xyz(2);                 <span class="comment">// read z-coordinate</span>
<a name="l00619"></a>00619 
<a name="l00620"></a>00620           <span class="comment">// set up the id map</span>
<a name="l00621"></a>00621           this-&gt;<a class="code" href="classUNVIO.php#a80192cd817475ee4e6894e71317587b1">_assign_nodes</a>.push_back (node_lab);
<a name="l00622"></a>00622           
<a name="l00623"></a>00623           <span class="comment">// add node to the Mesh &amp; </span>
<a name="l00624"></a>00624           <span class="comment">// tell the MeshData object the foreign node id</span>
<a name="l00625"></a>00625           <span class="comment">// (note that mesh.add_point() returns a pointer to the new node)</span>
<a name="l00626"></a>00626           this-&gt;<a class="code" href="classUNVIO.php#a6e6228ac83245ac0d89c98cad6556124">_mesh_data</a>.<a class="code" href="classMeshData.php#af408db231805974db975dbdf3c1756f5">add_foreign_node_id</a> (mesh.<a class="code" href="classMeshBase.php#a01b66468d3e9d8b5db82c6f3d9131f5e">add_point</a>(xyz,i), node_lab);
<a name="l00627"></a>00627         }
<a name="l00628"></a>00628     }
<a name="l00629"></a>00629 
<a name="l00630"></a>00630   <span class="comment">// now we need to sort the _assign_nodes vector so we can</span>
<a name="l00631"></a>00631   <span class="comment">// search it efficiently like a map</span>
<a name="l00632"></a>00632   std::sort (this-&gt;<a class="code" href="classUNVIO.php#a80192cd817475ee4e6894e71317587b1">_assign_nodes</a>.begin(),
<a name="l00633"></a>00633              this-&gt;<a class="code" href="classUNVIO.php#a80192cd817475ee4e6894e71317587b1">_assign_nodes</a>.end());
<a name="l00634"></a>00634 
<a name="l00635"></a>00635   STOP_LOG(<span class="stringliteral">&quot;node_in()&quot;</span>,<span class="stringliteral">&quot;UNVIO&quot;</span>);
<a name="l00636"></a>00636 }
<a name="l00637"></a>00637 
<a name="l00638"></a>00638 
<a name="l00639"></a>00639 
<a name="l00640"></a>00640 
<a name="l00641"></a>00641 
<a name="l00642"></a><a class="code" href="classUNVIO.php#a1632bd719dc3a2261a2cf8cd86cd42ee">00642</a> <span class="keywordtype">void</span> <a class="code" href="classUNVIO.php#a1632bd719dc3a2261a2cf8cd86cd42ee">UNVIO::element_in</a> (std::istream&amp; in_file)
<a name="l00643"></a>00643 {
<a name="l00644"></a>00644   START_LOG(<span class="stringliteral">&quot;element_in()&quot;</span>,<span class="stringliteral">&quot;UNVIO&quot;</span>);
<a name="l00645"></a>00645 
<a name="l00646"></a>00646   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classUNVIO.php#ac6095c3fa3e67769a0084172628d5f3e">verbose</a>())
<a name="l00647"></a>00647     std::cout &lt;&lt; <span class="stringliteral">&quot;  Reading elements&quot;</span> &lt;&lt; std::endl;
<a name="l00648"></a>00648 
<a name="l00649"></a>00649   <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00650"></a>00650 
<a name="l00651"></a>00651   <span class="comment">// adjust the \p istream to our</span>
<a name="l00652"></a>00652   <span class="comment">// position</span>
<a name="l00653"></a>00653   <span class="keyword">const</span> <span class="keywordtype">bool</span> ok = this-&gt;<a class="code" href="classUNVIO.php#a0eede436f9709971c5270f0fd8b62725">beginning_of_dataset</a>(in_file, <a class="code" href="classUNVIO.php#ac77599b563ab3eb28c344085e2937059">_label_dataset_elements</a>);
<a name="l00654"></a>00654 
<a name="l00655"></a>00655   <span class="keywordflow">if</span> (!ok)
<a name="l00656"></a>00656     {
<a name="l00657"></a>00657       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Could not find element dataset!&quot;</span> &lt;&lt; std::endl;
<a name="l00658"></a>00658       libmesh_error();
<a name="l00659"></a>00659     }
<a name="l00660"></a>00660 
<a name="l00661"></a>00661 
<a name="l00662"></a>00662   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>      element_lab,       <span class="comment">// element label (not supported yet)</span>
<a name="l00663"></a>00663                     <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>;           <span class="comment">// number of nodes on element</span>
<a name="l00664"></a>00664   <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> fe_descriptor_id,  <span class="comment">// FE descriptor id</span>
<a name="l00665"></a>00665                     phys_prop_tab_num, <span class="comment">// physical property table number (not supported yet)</span>
<a name="l00666"></a>00666                     mat_prop_tab_num,  <span class="comment">// material property table number (not supported yet)</span>
<a name="l00667"></a>00667                     color;             <span class="comment">// color (not supported yet)</span>
<a name="l00668"></a>00668 
<a name="l00669"></a>00669 
<a name="l00670"></a>00670   <span class="comment">// vector that temporarily holds the node labels defining element</span>
<a name="l00671"></a>00671   std::vector&lt;unsigned int&gt; node_labels (21);
<a name="l00672"></a>00672 
<a name="l00673"></a>00673 
<a name="l00674"></a>00674   <span class="comment">// vector that assigns element nodes to their correct position</span>
<a name="l00675"></a>00675   <span class="comment">// for example:</span>
<a name="l00676"></a>00676   <span class="comment">// 44:plane stress      | QUAD4</span>
<a name="l00677"></a>00677   <span class="comment">// linear quadrilateral |</span>
<a name="l00678"></a>00678   <span class="comment">// position in UNV-file | position in libmesh</span>
<a name="l00679"></a>00679   <span class="comment">// assign_elem_node[1]   = 0</span>
<a name="l00680"></a>00680   <span class="comment">// assign_elem_node[2]   = 3</span>
<a name="l00681"></a>00681   <span class="comment">// assign_elem_node[3]   = 2</span>
<a name="l00682"></a>00682   <span class="comment">// assign_elem_node[4]   = 1</span>
<a name="l00683"></a>00683   <span class="comment">//</span>
<a name="l00684"></a>00684   <span class="comment">// UNV is 1-based, we leave the 0th element of the vectors unused in order</span>
<a name="l00685"></a>00685   <span class="comment">// to prevent confusion, this way we can store elements with up to 20 nodes</span>
<a name="l00686"></a>00686   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> assign_elem_nodes[21];
<a name="l00687"></a>00687   
<a name="l00688"></a>00688 
<a name="l00689"></a>00689   <span class="comment">// Get the beginning and end of the _assign_nodes vector</span>
<a name="l00690"></a>00690   <span class="comment">// to eliminate repeated function calls</span>
<a name="l00691"></a>00691   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;::const_iterator it_begin =
<a name="l00692"></a>00692     this-&gt;<a class="code" href="classUNVIO.php#a80192cd817475ee4e6894e71317587b1">_assign_nodes</a>.begin();
<a name="l00693"></a>00693   
<a name="l00694"></a>00694   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;::const_iterator it_end   =
<a name="l00695"></a>00695     this-&gt;<a class="code" href="classUNVIO.php#a80192cd817475ee4e6894e71317587b1">_assign_nodes</a>.end();
<a name="l00696"></a>00696 
<a name="l00697"></a>00697 
<a name="l00698"></a>00698       
<a name="l00699"></a>00699   <span class="comment">// read from the virtual file</span>
<a name="l00700"></a>00700   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;<a class="code" href="classUNVIO.php#a90edacdb984a8c6dd6be96a636a56f96">_n_elements</a>; i++)
<a name="l00701"></a>00701     {
<a name="l00702"></a>00702       in_file &gt;&gt; element_lab             <span class="comment">// read element label</span>
<a name="l00703"></a>00703               &gt;&gt; fe_descriptor_id        <span class="comment">// read FE descriptor id</span>
<a name="l00704"></a>00704               &gt;&gt; phys_prop_tab_num       <span class="comment">// (not supported yet)</span>
<a name="l00705"></a>00705               &gt;&gt; mat_prop_tab_num        <span class="comment">// (not supported yet)</span>
<a name="l00706"></a>00706               &gt;&gt; color                   <span class="comment">// (not supported yet)</span>
<a name="l00707"></a>00707               &gt;&gt; <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>;                <span class="comment">// read number of nodes on element</span>
<a name="l00708"></a>00708 
<a name="l00709"></a>00709       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=1; j&lt;=<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>; j++)
<a name="l00710"></a>00710         in_file &gt;&gt; node_labels[j];       <span class="comment">// read node labels</span>
<a name="l00711"></a>00711 
<a name="l00712"></a>00712       <a class="code" href="classElem.php">Elem</a>* elem = NULL;                 <span class="comment">// element pointer</span>
<a name="l00713"></a>00713       
<a name="l00714"></a>00714       <span class="keywordflow">switch</span> (fe_descriptor_id)
<a name="l00715"></a>00715         {
<a name="l00716"></a>00716         
<a name="l00717"></a>00717         <span class="keywordflow">case</span> 41: <span class="comment">// Plane Stress Linear Triangle</span>
<a name="l00718"></a>00718         <span class="keywordflow">case</span> 91: <span class="comment">// Thin Shell   Linear Triangle</span>
<a name="l00719"></a>00719           {
<a name="l00720"></a>00720             elem = <span class="keyword">new</span> <a class="code" href="classTri3.php">Tri3</a>;  <span class="comment">// create new element</span>
<a name="l00721"></a>00721             
<a name="l00722"></a>00722             assign_elem_nodes[1]=0;
<a name="l00723"></a>00723             assign_elem_nodes[2]=2;
<a name="l00724"></a>00724             assign_elem_nodes[3]=1;
<a name="l00725"></a>00725             <span class="keywordflow">break</span>;
<a name="l00726"></a>00726           }
<a name="l00727"></a>00727         
<a name="l00728"></a>00728         <span class="keywordflow">case</span> 42: <span class="comment">// Plane Stress Quadratic Triangle</span>
<a name="l00729"></a>00729         <span class="keywordflow">case</span> 92: <span class="comment">// Thin Shell   Quadratic Triangle</span>
<a name="l00730"></a>00730           {
<a name="l00731"></a>00731             elem = <span class="keyword">new</span> <a class="code" href="classTri6.php">Tri6</a>;  <span class="comment">// create new element</span>
<a name="l00732"></a>00732             
<a name="l00733"></a>00733             assign_elem_nodes[1]=0;
<a name="l00734"></a>00734             assign_elem_nodes[2]=5;
<a name="l00735"></a>00735             assign_elem_nodes[3]=2;
<a name="l00736"></a>00736             assign_elem_nodes[4]=4;
<a name="l00737"></a>00737             assign_elem_nodes[5]=1;
<a name="l00738"></a>00738             assign_elem_nodes[6]=3;
<a name="l00739"></a>00739             <span class="keywordflow">break</span>;
<a name="l00740"></a>00740           }
<a name="l00741"></a>00741         
<a name="l00742"></a>00742         <span class="keywordflow">case</span> 43: <span class="comment">// Plane Stress Cubic Triangle</span>
<a name="l00743"></a>00743           {
<a name="l00744"></a>00744             std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: UNV-element type 43: Plane Stress Cubic Triangle&quot;</span>
<a name="l00745"></a>00745                       &lt;&lt; <span class="stringliteral">&quot; not supported.&quot;</span> 
<a name="l00746"></a>00746                       &lt;&lt; std::endl;
<a name="l00747"></a>00747             libmesh_error();        
<a name="l00748"></a>00748             <span class="keywordflow">break</span>;
<a name="l00749"></a>00749           }
<a name="l00750"></a>00750         
<a name="l00751"></a>00751         <span class="keywordflow">case</span> 44: <span class="comment">// Plane Stress Linear Quadrilateral</span>
<a name="l00752"></a>00752         <span class="keywordflow">case</span> 94: <span class="comment">// Thin Shell   Linear Quadrilateral</span>
<a name="l00753"></a>00753           {
<a name="l00754"></a>00754             elem = <span class="keyword">new</span> <a class="code" href="classQuad4.php">Quad4</a>; <span class="comment">// create new element</span>
<a name="l00755"></a>00755             
<a name="l00756"></a>00756             assign_elem_nodes[1]=0;
<a name="l00757"></a>00757             assign_elem_nodes[2]=3;
<a name="l00758"></a>00758             assign_elem_nodes[3]=2;
<a name="l00759"></a>00759             assign_elem_nodes[4]=1;
<a name="l00760"></a>00760             <span class="keywordflow">break</span>;
<a name="l00761"></a>00761           }
<a name="l00762"></a>00762         
<a name="l00763"></a>00763         <span class="keywordflow">case</span> 45: <span class="comment">// Plane Stress Quadratic Quadrilateral</span>
<a name="l00764"></a>00764         <span class="keywordflow">case</span> 95: <span class="comment">// Thin Shell   Quadratic Quadrilateral</span>
<a name="l00765"></a>00765           {
<a name="l00766"></a>00766             elem = <span class="keyword">new</span> <a class="code" href="classQuad8.php">Quad8</a>; <span class="comment">// create new element</span>
<a name="l00767"></a>00767             
<a name="l00768"></a>00768             assign_elem_nodes[1]=0;
<a name="l00769"></a>00769             assign_elem_nodes[2]=7;
<a name="l00770"></a>00770             assign_elem_nodes[3]=3;
<a name="l00771"></a>00771             assign_elem_nodes[4]=6;
<a name="l00772"></a>00772             assign_elem_nodes[5]=2;
<a name="l00773"></a>00773             assign_elem_nodes[6]=5;
<a name="l00774"></a>00774             assign_elem_nodes[7]=1;
<a name="l00775"></a>00775             assign_elem_nodes[8]=4;
<a name="l00776"></a>00776             <span class="keywordflow">break</span>;
<a name="l00777"></a>00777           }
<a name="l00778"></a>00778         
<a name="l00779"></a>00779         <span class="keywordflow">case</span> 300: <span class="comment">// Thin Shell   Quadratic Quadrilateral (nine nodes)</span>
<a name="l00780"></a>00780           {
<a name="l00781"></a>00781             elem = <span class="keyword">new</span> <a class="code" href="classQuad9.php">Quad9</a>; <span class="comment">// create new element</span>
<a name="l00782"></a>00782             
<a name="l00783"></a>00783             assign_elem_nodes[1]=0;
<a name="l00784"></a>00784             assign_elem_nodes[2]=7;
<a name="l00785"></a>00785             assign_elem_nodes[3]=3;
<a name="l00786"></a>00786             assign_elem_nodes[4]=6;
<a name="l00787"></a>00787             assign_elem_nodes[5]=2;
<a name="l00788"></a>00788             assign_elem_nodes[6]=5;
<a name="l00789"></a>00789             assign_elem_nodes[7]=1;
<a name="l00790"></a>00790             assign_elem_nodes[8]=4;
<a name="l00791"></a>00791             assign_elem_nodes[9]=8;
<a name="l00792"></a>00792             <span class="keywordflow">break</span>;
<a name="l00793"></a>00793           }
<a name="l00794"></a>00794         
<a name="l00795"></a>00795         <span class="keywordflow">case</span> 46: <span class="comment">// Plane Stress Cubic Quadrilateral</span>
<a name="l00796"></a>00796           {
<a name="l00797"></a>00797             std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: UNV-element type 46: Plane Stress Cubic Quadrilateral&quot;</span>
<a name="l00798"></a>00798                       &lt;&lt; <span class="stringliteral">&quot; not supported.&quot;</span> 
<a name="l00799"></a>00799                       &lt;&lt; std::endl;
<a name="l00800"></a>00800             libmesh_error();
<a name="l00801"></a>00801             <span class="keywordflow">break</span>;
<a name="l00802"></a>00802           }
<a name="l00803"></a>00803         
<a name="l00804"></a>00804         <span class="keywordflow">case</span> 111: <span class="comment">// Solid Linear Tetrahedron</span>
<a name="l00805"></a>00805           {
<a name="l00806"></a>00806             elem = <span class="keyword">new</span> <a class="code" href="classTet4.php">Tet4</a>;  <span class="comment">// create new element</span>
<a name="l00807"></a>00807             
<a name="l00808"></a>00808             assign_elem_nodes[1]=0;
<a name="l00809"></a>00809             assign_elem_nodes[2]=1;
<a name="l00810"></a>00810             assign_elem_nodes[3]=2;
<a name="l00811"></a>00811             assign_elem_nodes[4]=3;
<a name="l00812"></a>00812             <span class="keywordflow">break</span>;
<a name="l00813"></a>00813           }
<a name="l00814"></a>00814 
<a name="l00815"></a>00815         <span class="keywordflow">case</span> 112: <span class="comment">// Solid Linear Prism</span>
<a name="l00816"></a>00816           {
<a name="l00817"></a>00817             elem = <span class="keyword">new</span> <a class="code" href="classPrism6.php">Prism6</a>;  <span class="comment">// create new element</span>
<a name="l00818"></a>00818             
<a name="l00819"></a>00819             assign_elem_nodes[1]=0;
<a name="l00820"></a>00820             assign_elem_nodes[2]=1;
<a name="l00821"></a>00821             assign_elem_nodes[3]=2;
<a name="l00822"></a>00822             assign_elem_nodes[4]=3;
<a name="l00823"></a>00823             assign_elem_nodes[5]=4;
<a name="l00824"></a>00824             assign_elem_nodes[6]=5;
<a name="l00825"></a>00825             <span class="keywordflow">break</span>;
<a name="l00826"></a>00826           }
<a name="l00827"></a>00827         
<a name="l00828"></a>00828         <span class="keywordflow">case</span> 115: <span class="comment">// Solid Linear Brick</span>
<a name="l00829"></a>00829           {
<a name="l00830"></a>00830             elem = <span class="keyword">new</span> <a class="code" href="classHex8.php">Hex8</a>;  <span class="comment">// create new element</span>
<a name="l00831"></a>00831             
<a name="l00832"></a>00832             assign_elem_nodes[1]=0;
<a name="l00833"></a>00833             assign_elem_nodes[2]=4;
<a name="l00834"></a>00834             assign_elem_nodes[3]=5;
<a name="l00835"></a>00835             assign_elem_nodes[4]=1;
<a name="l00836"></a>00836             assign_elem_nodes[5]=3;
<a name="l00837"></a>00837             assign_elem_nodes[6]=7;
<a name="l00838"></a>00838             assign_elem_nodes[7]=6;
<a name="l00839"></a>00839             assign_elem_nodes[8]=2;
<a name="l00840"></a>00840             <span class="keywordflow">break</span>;
<a name="l00841"></a>00841           }
<a name="l00842"></a>00842                 
<a name="l00843"></a>00843         <span class="keywordflow">case</span> 116: <span class="comment">// Solid Quadratic Brick</span>
<a name="l00844"></a>00844           {
<a name="l00845"></a>00845             elem = <span class="keyword">new</span> <a class="code" href="classHex20.php">Hex20</a>; <span class="comment">// create new element</span>
<a name="l00846"></a>00846             
<a name="l00847"></a>00847             assign_elem_nodes[1]=0;
<a name="l00848"></a>00848             assign_elem_nodes[2]=12;
<a name="l00849"></a>00849             assign_elem_nodes[3]=4;
<a name="l00850"></a>00850             assign_elem_nodes[4]=16;
<a name="l00851"></a>00851             assign_elem_nodes[5]=5;
<a name="l00852"></a>00852             assign_elem_nodes[6]=13;
<a name="l00853"></a>00853             assign_elem_nodes[7]=1;
<a name="l00854"></a>00854             assign_elem_nodes[8]=8;
<a name="l00855"></a>00855 
<a name="l00856"></a>00856             assign_elem_nodes[9]=11;
<a name="l00857"></a>00857             assign_elem_nodes[10]=19;
<a name="l00858"></a>00858             assign_elem_nodes[11]=17;
<a name="l00859"></a>00859             assign_elem_nodes[12]=9;
<a name="l00860"></a>00860 
<a name="l00861"></a>00861             assign_elem_nodes[13]=3;
<a name="l00862"></a>00862             assign_elem_nodes[14]=15;
<a name="l00863"></a>00863             assign_elem_nodes[15]=7;
<a name="l00864"></a>00864             assign_elem_nodes[16]=18;
<a name="l00865"></a>00865             assign_elem_nodes[17]=6;
<a name="l00866"></a>00866             assign_elem_nodes[18]=14;
<a name="l00867"></a>00867             assign_elem_nodes[19]=2;
<a name="l00868"></a>00868             assign_elem_nodes[20]=10;
<a name="l00869"></a>00869             <span class="keywordflow">break</span>;
<a name="l00870"></a>00870           }     
<a name="l00871"></a>00871         
<a name="l00872"></a>00872         <span class="keywordflow">case</span> 117: <span class="comment">// Solid Cubic Brick</span>
<a name="l00873"></a>00873           {
<a name="l00874"></a>00874             std::cerr &lt;&lt; <span class="stringliteral">&quot;Error: UNV-element type 117: Solid Cubic Brick&quot;</span>
<a name="l00875"></a>00875                       &lt;&lt; <span class="stringliteral">&quot; not supported.&quot;</span> 
<a name="l00876"></a>00876                       &lt;&lt; std::endl;
<a name="l00877"></a>00877             libmesh_error();        
<a name="l00878"></a>00878             <span class="keywordflow">break</span>;
<a name="l00879"></a>00879           }
<a name="l00880"></a>00880         
<a name="l00881"></a>00881         <span class="keywordflow">case</span> 118: <span class="comment">// Solid Quadratic Tetrahedron</span>
<a name="l00882"></a>00882           {
<a name="l00883"></a>00883             elem = <span class="keyword">new</span> <a class="code" href="classTet10.php">Tet10</a>; <span class="comment">// create new element</span>
<a name="l00884"></a>00884             
<a name="l00885"></a>00885             assign_elem_nodes[1]=0;
<a name="l00886"></a>00886             assign_elem_nodes[2]=4;
<a name="l00887"></a>00887             assign_elem_nodes[3]=1;
<a name="l00888"></a>00888             assign_elem_nodes[4]=5;
<a name="l00889"></a>00889             assign_elem_nodes[5]=2;
<a name="l00890"></a>00890             assign_elem_nodes[6]=6;
<a name="l00891"></a>00891             assign_elem_nodes[7]=7;
<a name="l00892"></a>00892             assign_elem_nodes[8]=8;
<a name="l00893"></a>00893             assign_elem_nodes[9]=9;
<a name="l00894"></a>00894             assign_elem_nodes[10]=3;
<a name="l00895"></a>00895             <span class="keywordflow">break</span>;
<a name="l00896"></a>00896           }     
<a name="l00897"></a>00897         
<a name="l00898"></a>00898         <span class="keywordflow">default</span>: <span class="comment">// Unrecognized element type</span>
<a name="l00899"></a>00899           {
<a name="l00900"></a>00900             std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: UNV-element type &quot;</span> 
<a name="l00901"></a>00901                       &lt;&lt; fe_descriptor_id
<a name="l00902"></a>00902                       &lt;&lt; <span class="stringliteral">&quot; not supported.&quot;</span> 
<a name="l00903"></a>00903                       &lt;&lt; std::endl;
<a name="l00904"></a>00904             libmesh_error();        
<a name="l00905"></a>00905             <span class="keywordflow">break</span>;
<a name="l00906"></a>00906           }
<a name="l00907"></a>00907         }
<a name="l00908"></a>00908 
<a name="l00909"></a>00909       <span class="comment">// nodes are being stored in element</span>
<a name="l00910"></a>00910       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=1; j&lt;=<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>; j++)
<a name="l00911"></a>00911         {
<a name="l00912"></a>00912           <span class="comment">// Find the position of node_labels[j] in the _assign_nodes vector.</span>
<a name="l00913"></a>00913           <span class="keyword">const</span> std::pair&lt;std::vector&lt;unsigned int&gt;::const_iterator,
<a name="l00914"></a>00914                           std::vector&lt;unsigned int&gt;::const_iterator&gt;        
<a name="l00915"></a>00915             it = std::equal_range (it_begin,
<a name="l00916"></a>00916                                    it_end,
<a name="l00917"></a>00917                                    node_labels[j]);
<a name="l00918"></a>00918 
<a name="l00919"></a>00919           <span class="comment">// it better be there, so libmesh_assert that it was found.</span>
<a name="l00920"></a>00920           libmesh_assert (it.first  != it.second);
<a name="l00921"></a>00921           libmesh_assert (*(it.first) == node_labels[j]);
<a name="l00922"></a>00922 
<a name="l00923"></a>00923           <span class="comment">// Now, the distance between this UNV id and the beginning of</span>
<a name="l00924"></a>00924           <span class="comment">// the _assign_nodes vector will give us a unique id in the</span>
<a name="l00925"></a>00925           <span class="comment">// range [0,n_nodes) that we can use for defining a contiguous</span>
<a name="l00926"></a>00926           <span class="comment">// connectivity.</span>
<a name="l00927"></a>00927           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> assigned_node = std::distance (it_begin,
<a name="l00928"></a>00928                                                             it.first);
<a name="l00929"></a>00929 
<a name="l00930"></a>00930           <span class="comment">// Make sure we didn&#39;t get an out-of-bounds id</span>
<a name="l00931"></a>00931           libmesh_assert (assigned_node &lt; this-&gt;<a class="code" href="classUNVIO.php#a26ec56cf191f525f0f00c12014c76e88">_n_nodes</a>);
<a name="l00932"></a>00932           
<a name="l00933"></a>00933           elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(assign_elem_nodes[j]) =
<a name="l00934"></a>00934             mesh.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(assigned_node);
<a name="l00935"></a>00935         }
<a name="l00936"></a>00936       
<a name="l00937"></a>00937       <span class="comment">// add elem to the Mesh &amp; </span>
<a name="l00938"></a>00938       <span class="comment">// tell the MeshData object the foreign elem id</span>
<a name="l00939"></a>00939       <span class="comment">// (note that mesh.add_elem() returns a pointer to the new element)</span>
<a name="l00940"></a>00940       elem-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a>(i);
<a name="l00941"></a>00941       this-&gt;<a class="code" href="classUNVIO.php#a6e6228ac83245ac0d89c98cad6556124">_mesh_data</a>.<a class="code" href="classMeshData.php#acf27873beae104e2109db6c93de7efa9">add_foreign_elem_id</a> (mesh.<a class="code" href="classMeshBase.php#a0f6974cf3e413cfe9caa1fcb4ce8153e">add_elem</a>(elem), element_lab);
<a name="l00942"></a>00942     }
<a name="l00943"></a>00943 
<a name="l00944"></a>00944   STOP_LOG(<span class="stringliteral">&quot;element_in()&quot;</span>,<span class="stringliteral">&quot;UNVIO&quot;</span>);
<a name="l00945"></a>00945 }
<a name="l00946"></a>00946 
<a name="l00947"></a>00947 
<a name="l00948"></a>00948 
<a name="l00949"></a>00949 
<a name="l00950"></a>00950 
<a name="l00951"></a>00951 
<a name="l00952"></a><a class="code" href="classUNVIO.php#ab01b5e4a6eefbec7f0c8ca121071e6bd">00952</a> <span class="keywordtype">void</span> <a class="code" href="classUNVIO.php#ab01b5e4a6eefbec7f0c8ca121071e6bd">UNVIO::node_out</a> (std::ostream&amp; out_file)
<a name="l00953"></a>00953 {
<a name="l00954"></a>00954   
<a name="l00955"></a>00955   libmesh_assert (this-&gt;<a class="code" href="classUNVIO.php#a6e6228ac83245ac0d89c98cad6556124">_mesh_data</a>.<a class="code" href="classMeshData.php#a4d99efe5fb30d203afdd520d213c6233">active</a>() ||
<a name="l00956"></a>00956           this-&gt;<a class="code" href="classUNVIO.php#a6e6228ac83245ac0d89c98cad6556124">_mesh_data</a>.<a class="code" href="classMeshData.php#af448a633cf06236e8ebcb5cf73d3d2eb">compatibility_mode</a>());
<a name="l00957"></a>00957 
<a name="l00958"></a>00958 
<a name="l00959"></a>00959   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classUNVIO.php#ac6095c3fa3e67769a0084172628d5f3e">verbose</a>())
<a name="l00960"></a>00960     std::cout &lt;&lt; <span class="stringliteral">&quot;  Writing &quot;</span> &lt;&lt; this-&gt;<a class="code" href="classUNVIO.php#a26ec56cf191f525f0f00c12014c76e88">_n_nodes</a> &lt;&lt; <span class="stringliteral">&quot; nodes&quot;</span> &lt;&lt; std::endl;
<a name="l00961"></a>00961 
<a name="l00962"></a>00962   <span class="comment">// Write beginning of dataset</span>
<a name="l00963"></a>00963   out_file &lt;&lt; <span class="stringliteral">&quot;    -1\n&quot;</span>
<a name="l00964"></a>00964            &lt;&lt; <span class="stringliteral">&quot;  &quot;</span> 
<a name="l00965"></a>00965            &lt;&lt; <a class="code" href="classUNVIO.php#a6b7fa514960a93fe3778f86ad26dedb0">_label_dataset_nodes</a>
<a name="l00966"></a>00966            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00967"></a>00967 
<a name="l00968"></a>00968 
<a name="l00969"></a>00969   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> exp_coord_sys_dummy  = 0; <span class="comment">// export coordinate sys. (not supported yet)</span>
<a name="l00970"></a>00970   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> disp_coord_sys_dummy = 0; <span class="comment">// displacement coordinate sys. (not supp. yet)</span>
<a name="l00971"></a>00971   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> color_dummy          = 0; <span class="comment">// color(not supported yet)</span>
<a name="l00972"></a>00972 
<a name="l00973"></a>00973   <span class="comment">// A reference to the parent class&#39;s mesh</span>
<a name="l00974"></a>00974   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00975"></a>00975 
<a name="l00976"></a>00976   <a class="code" href="structMeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a>       nd  = mesh.<a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
<a name="l00977"></a>00977   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
<a name="l00978"></a>00978 
<a name="l00979"></a>00979   <span class="keywordflow">for</span> (; nd != end; ++nd)
<a name="l00980"></a>00980     {
<a name="l00981"></a>00981       <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* current_node = *nd;
<a name="l00982"></a>00982       
<a name="l00983"></a>00983       <span class="keywordtype">char</span> buf[78];
<a name="l00984"></a>00984       std::sprintf(buf, <span class="stringliteral">&quot;%10d%10d%10d%10d\n&quot;</span>, 
<a name="l00985"></a>00985                    this-&gt;<a class="code" href="classUNVIO.php#a6e6228ac83245ac0d89c98cad6556124">_mesh_data</a>.<a class="code" href="classMeshData.php#a64280d5ec57b031bcba08f216af20973">node_to_foreign_id</a>(current_node),
<a name="l00986"></a>00986                    exp_coord_sys_dummy,
<a name="l00987"></a>00987                    disp_coord_sys_dummy,
<a name="l00988"></a>00988                    color_dummy);
<a name="l00989"></a>00989       out_file &lt;&lt; buf;
<a name="l00990"></a>00990 
<a name="l00991"></a>00991       <span class="comment">// the coordinates</span>
<a name="l00992"></a>00992       <span class="keywordflow">if</span> (mesh.<a class="code" href="classMeshBase.php#acaf87bde8c96b91d8f355dc9ebb72f5f">spatial_dimension</a>() == 3)
<a name="l00993"></a>00993         std::sprintf(buf, <span class="stringliteral">&quot;%25.16E%25.16E%25.16E\n&quot;</span>, 
<a name="l00994"></a>00994                      static_cast&lt;double&gt;((*current_node)(0)),
<a name="l00995"></a>00995                      <span class="keyword">static_cast&lt;</span><span class="keywordtype">double</span><span class="keyword">&gt;</span>((*current_node)(1)),
<a name="l00996"></a>00996                      <span class="keyword">static_cast&lt;</span><span class="keywordtype">double</span><span class="keyword">&gt;</span>((*current_node)(2)));
<a name="l00997"></a>00997       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (mesh.<a class="code" href="classMeshBase.php#acaf87bde8c96b91d8f355dc9ebb72f5f">spatial_dimension</a>() == 2)
<a name="l00998"></a>00998         std::sprintf(buf, <span class="stringliteral">&quot;%25.16E%25.16E\n&quot;</span>, 
<a name="l00999"></a>00999                      static_cast&lt;double&gt;((*current_node)(0)),
<a name="l01000"></a>01000                      <span class="keyword">static_cast&lt;</span><span class="keywordtype">double</span><span class="keyword">&gt;</span>((*current_node)(1)));
<a name="l01001"></a>01001       <span class="keywordflow">else</span>
<a name="l01002"></a>01002         std::sprintf(buf, <span class="stringliteral">&quot;%25.16E\n&quot;</span>, 
<a name="l01003"></a>01003                      static_cast&lt;double&gt;((*current_node)(0)));
<a name="l01004"></a>01004       
<a name="l01005"></a>01005       out_file &lt;&lt; buf;
<a name="l01006"></a>01006     }
<a name="l01007"></a>01007   
<a name="l01008"></a>01008   
<a name="l01009"></a>01009   <span class="comment">// Write end of dataset</span>
<a name="l01010"></a>01010   out_file &lt;&lt; <span class="stringliteral">&quot;    -1\n&quot;</span>;
<a name="l01011"></a>01011 }
<a name="l01012"></a>01012 
<a name="l01013"></a>01013 
<a name="l01014"></a>01014 
<a name="l01015"></a>01015 
<a name="l01016"></a>01016 
<a name="l01017"></a>01017 
<a name="l01018"></a><a class="code" href="classUNVIO.php#ac693037f9e6a48b02bc7b5018448b42b">01018</a> <span class="keywordtype">void</span> <a class="code" href="classUNVIO.php#ac693037f9e6a48b02bc7b5018448b42b">UNVIO::element_out</a>(std::ostream&amp; out_file)
<a name="l01019"></a>01019 {
<a name="l01020"></a>01020   libmesh_assert (this-&gt;<a class="code" href="classUNVIO.php#a6e6228ac83245ac0d89c98cad6556124">_mesh_data</a>.<a class="code" href="classMeshData.php#a4d99efe5fb30d203afdd520d213c6233">active</a>() ||
<a name="l01021"></a>01021           this-&gt;<a class="code" href="classUNVIO.php#a6e6228ac83245ac0d89c98cad6556124">_mesh_data</a>.<a class="code" href="classMeshData.php#af448a633cf06236e8ebcb5cf73d3d2eb">compatibility_mode</a>());
<a name="l01022"></a>01022 
<a name="l01023"></a>01023   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classUNVIO.php#ac6095c3fa3e67769a0084172628d5f3e">verbose</a>())
<a name="l01024"></a>01024     std::cout &lt;&lt; <span class="stringliteral">&quot;  Writing elements&quot;</span> &lt;&lt; std::endl;
<a name="l01025"></a>01025   
<a name="l01026"></a>01026   <span class="comment">// Write beginning of dataset</span>
<a name="l01027"></a>01027   out_file &lt;&lt; <span class="stringliteral">&quot;    -1\n&quot;</span>
<a name="l01028"></a>01028            &lt;&lt; <span class="stringliteral">&quot;  &quot;</span> 
<a name="l01029"></a>01029            &lt;&lt; <a class="code" href="classUNVIO.php#ac77599b563ab3eb28c344085e2937059">_label_dataset_elements</a>
<a name="l01030"></a>01030            &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l01031"></a>01031 
<a name="l01032"></a>01032   <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> fe_descriptor_id = 0;    <span class="comment">// FE descriptor id </span>
<a name="l01033"></a>01033   <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> phys_prop_tab_dummy = 2; <span class="comment">// physical property (not supported yet)</span>
<a name="l01034"></a>01034   <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> mat_prop_tab_dummy = 1;  <span class="comment">// material property (not supported yet)</span>
<a name="l01035"></a>01035   <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> color_dummy = 7;         <span class="comment">// color (not supported yet)</span>
<a name="l01036"></a>01036 
<a name="l01037"></a>01037 
<a name="l01038"></a>01038   <span class="comment">// vector that assigns element nodes to their correct position</span>
<a name="l01039"></a>01039   <span class="comment">// currently only elements with up to 20 nodes</span>
<a name="l01040"></a>01040   <span class="comment">//  </span>
<a name="l01041"></a>01041   <span class="comment">// Example:</span>
<a name="l01042"></a>01042   <span class="comment">// QUAD4               | 44:plane stress</span>
<a name="l01043"></a>01043   <span class="comment">//                     | linear quad</span>
<a name="l01044"></a>01044   <span class="comment">// position in libMesh | UNV numbering</span>
<a name="l01045"></a>01045   <span class="comment">// (note: 0-based)     | (note: 1-based)</span>
<a name="l01046"></a>01046   <span class="comment">//     </span>
<a name="l01047"></a>01047   <span class="comment">// assign_elem_node[0]  = 0</span>
<a name="l01048"></a>01048   <span class="comment">// assign_elem_node[1]  = 3</span>
<a name="l01049"></a>01049   <span class="comment">// assign_elem_node[2]  = 2</span>
<a name="l01050"></a>01050   <span class="comment">// assign_elem_node[3]  = 1</span>
<a name="l01051"></a>01051   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> assign_elem_nodes[20];
<a name="l01052"></a>01052 
<a name="l01053"></a>01053   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_elem_written=0;
<a name="l01054"></a>01054 
<a name="l01055"></a>01055   <span class="comment">// A reference to the parent class&#39;s mesh</span>
<a name="l01056"></a>01056   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l01057"></a>01057 
<a name="l01058"></a>01058   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> it  = mesh.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l01059"></a>01059   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l01060"></a>01060 
<a name="l01061"></a>01061   <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l01062"></a>01062     {
<a name="l01063"></a>01063       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *it;
<a name="l01064"></a>01064 
<a name="l01065"></a>01065       elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>();
<a name="l01066"></a>01066       
<a name="l01067"></a>01067       <span class="keywordflow">switch</span> (elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>())
<a name="l01068"></a>01068         {
<a name="l01069"></a>01069         
<a name="l01070"></a>01070         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l01071"></a>01071           {
<a name="l01072"></a>01072             fe_descriptor_id = 41; <span class="comment">// Plane Stress Linear Triangle</span>
<a name="l01073"></a>01073             assign_elem_nodes[0] = 0;
<a name="l01074"></a>01074             assign_elem_nodes[1] = 2;
<a name="l01075"></a>01075             assign_elem_nodes[2] = 1;
<a name="l01076"></a>01076             <span class="keywordflow">break</span>;
<a name="l01077"></a>01077           }
<a name="l01078"></a>01078 
<a name="l01079"></a>01079         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l01080"></a>01080           {
<a name="l01081"></a>01081             fe_descriptor_id = 42; <span class="comment">// Plane Stress Quadratic Triangle</span>
<a name="l01082"></a>01082             assign_elem_nodes[0] = 0;
<a name="l01083"></a>01083             assign_elem_nodes[1] = 5;
<a name="l01084"></a>01084             assign_elem_nodes[2] = 2;
<a name="l01085"></a>01085             assign_elem_nodes[3] = 4;
<a name="l01086"></a>01086             assign_elem_nodes[4] = 1;
<a name="l01087"></a>01087             assign_elem_nodes[5] = 3;
<a name="l01088"></a>01088             <span class="keywordflow">break</span>;
<a name="l01089"></a>01089           }
<a name="l01090"></a>01090           
<a name="l01091"></a>01091         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l01092"></a>01092           {
<a name="l01093"></a>01093             fe_descriptor_id = 44; <span class="comment">// Plane Stress Linear Quadrilateral</span>
<a name="l01094"></a>01094             assign_elem_nodes[0] = 0;
<a name="l01095"></a>01095             assign_elem_nodes[1] = 3;
<a name="l01096"></a>01096             assign_elem_nodes[2] = 2;
<a name="l01097"></a>01097             assign_elem_nodes[3] = 1;
<a name="l01098"></a>01098             <span class="keywordflow">break</span>;
<a name="l01099"></a>01099           }
<a name="l01100"></a>01100         
<a name="l01101"></a>01101         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l01102"></a>01102           {
<a name="l01103"></a>01103             fe_descriptor_id = 45; <span class="comment">// Plane Stress Quadratic Quadrilateral</span>
<a name="l01104"></a>01104             assign_elem_nodes[0] = 0;
<a name="l01105"></a>01105             assign_elem_nodes[1] = 7;
<a name="l01106"></a>01106             assign_elem_nodes[2] = 3;
<a name="l01107"></a>01107             assign_elem_nodes[3] = 6;
<a name="l01108"></a>01108             assign_elem_nodes[4] = 2;
<a name="l01109"></a>01109             assign_elem_nodes[5] = 5;
<a name="l01110"></a>01110             assign_elem_nodes[6] = 1;
<a name="l01111"></a>01111             assign_elem_nodes[7] = 4;
<a name="l01112"></a>01112             <span class="keywordflow">break</span>;
<a name="l01113"></a>01113           }
<a name="l01114"></a>01114         
<a name="l01115"></a>01115         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l01116"></a>01116           {
<a name="l01117"></a>01117             fe_descriptor_id = 300; <span class="comment">// Plane Stress Quadratic Quadrilateral</span>
<a name="l01118"></a>01118             assign_elem_nodes[0] = 0;
<a name="l01119"></a>01119             assign_elem_nodes[1] = 7;
<a name="l01120"></a>01120             assign_elem_nodes[2] = 3;
<a name="l01121"></a>01121             assign_elem_nodes[3] = 6;
<a name="l01122"></a>01122             assign_elem_nodes[4] = 2;
<a name="l01123"></a>01123             assign_elem_nodes[5] = 5;
<a name="l01124"></a>01124             assign_elem_nodes[6] = 1;
<a name="l01125"></a>01125             assign_elem_nodes[7] = 4;
<a name="l01126"></a>01126             assign_elem_nodes[8] = 8;
<a name="l01127"></a>01127             <span class="keywordflow">break</span>;
<a name="l01128"></a>01128           }
<a name="l01129"></a>01129         
<a name="l01130"></a>01130         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l01131"></a>01131           {
<a name="l01132"></a>01132             fe_descriptor_id = 111; <span class="comment">// Solid Linear Tetrahedron</span>
<a name="l01133"></a>01133             assign_elem_nodes[0] = 0;
<a name="l01134"></a>01134             assign_elem_nodes[1] = 1;
<a name="l01135"></a>01135             assign_elem_nodes[2] = 2;
<a name="l01136"></a>01136             assign_elem_nodes[3] = 3;
<a name="l01137"></a>01137             <span class="keywordflow">break</span>;
<a name="l01138"></a>01138           }
<a name="l01139"></a>01139 
<a name="l01140"></a>01140         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l01141"></a>01141           {
<a name="l01142"></a>01142             fe_descriptor_id = 112; <span class="comment">// Solid Linear Prism</span>
<a name="l01143"></a>01143             assign_elem_nodes[0] = 0;
<a name="l01144"></a>01144             assign_elem_nodes[1] = 1;
<a name="l01145"></a>01145             assign_elem_nodes[2] = 2;
<a name="l01146"></a>01146             assign_elem_nodes[3] = 3;
<a name="l01147"></a>01147             assign_elem_nodes[4] = 4;
<a name="l01148"></a>01148             assign_elem_nodes[5] = 5;
<a name="l01149"></a>01149             <span class="keywordflow">break</span>;
<a name="l01150"></a>01150           }
<a name="l01151"></a>01151 
<a name="l01152"></a>01152         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l01153"></a>01153           {
<a name="l01154"></a>01154             fe_descriptor_id = 115; <span class="comment">// Solid Linear Brick</span>
<a name="l01155"></a>01155             assign_elem_nodes[0] = 0;
<a name="l01156"></a>01156             assign_elem_nodes[1] = 4;
<a name="l01157"></a>01157             assign_elem_nodes[2] = 5;
<a name="l01158"></a>01158             assign_elem_nodes[3] = 1;
<a name="l01159"></a>01159             assign_elem_nodes[4] = 3;
<a name="l01160"></a>01160             assign_elem_nodes[5] = 7;
<a name="l01161"></a>01161             assign_elem_nodes[6] = 6;
<a name="l01162"></a>01162             assign_elem_nodes[7] = 2;
<a name="l01163"></a>01163             <span class="keywordflow">break</span>;
<a name="l01164"></a>01164           }
<a name="l01165"></a>01165         
<a name="l01166"></a>01166         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l01167"></a>01167           {
<a name="l01168"></a>01168             fe_descriptor_id = 116; <span class="comment">// Solid Quadratic Brick</span>
<a name="l01169"></a>01169             assign_elem_nodes[ 0] = 0;
<a name="l01170"></a>01170             assign_elem_nodes[ 1] = 12;
<a name="l01171"></a>01171             assign_elem_nodes[ 2] = 4;
<a name="l01172"></a>01172             assign_elem_nodes[ 3] = 16;
<a name="l01173"></a>01173             assign_elem_nodes[ 4] = 5;
<a name="l01174"></a>01174             assign_elem_nodes[ 5] = 13;
<a name="l01175"></a>01175             assign_elem_nodes[ 6] = 1;
<a name="l01176"></a>01176             assign_elem_nodes[ 7] = 8;
<a name="l01177"></a>01177 
<a name="l01178"></a>01178             assign_elem_nodes[ 8] = 11;
<a name="l01179"></a>01179             assign_elem_nodes[ 9] = 19;
<a name="l01180"></a>01180             assign_elem_nodes[10] = 17;
<a name="l01181"></a>01181             assign_elem_nodes[11] = 9;
<a name="l01182"></a>01182 
<a name="l01183"></a>01183             assign_elem_nodes[12] = 3;
<a name="l01184"></a>01184             assign_elem_nodes[13] = 15;
<a name="l01185"></a>01185             assign_elem_nodes[14] = 7;
<a name="l01186"></a>01186             assign_elem_nodes[15] = 18;
<a name="l01187"></a>01187             assign_elem_nodes[16] = 6;
<a name="l01188"></a>01188             assign_elem_nodes[17] = 14;
<a name="l01189"></a>01189             assign_elem_nodes[18] = 2;
<a name="l01190"></a>01190             assign_elem_nodes[19] = 10;
<a name="l01191"></a>01191 
<a name="l01192"></a>01192 
<a name="l01193"></a>01193             <span class="keywordflow">break</span>;
<a name="l01194"></a>01194           }
<a name="l01195"></a>01195                 
<a name="l01196"></a>01196         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l01197"></a>01197           {
<a name="l01198"></a>01198             fe_descriptor_id = 118; <span class="comment">// Solid Quadratic Tetrahedron</span>
<a name="l01199"></a>01199             assign_elem_nodes[0] = 0;
<a name="l01200"></a>01200             assign_elem_nodes[1] = 4;
<a name="l01201"></a>01201             assign_elem_nodes[2] = 1;
<a name="l01202"></a>01202             assign_elem_nodes[3] = 5;
<a name="l01203"></a>01203             assign_elem_nodes[4] = 2;
<a name="l01204"></a>01204             assign_elem_nodes[5] = 6;
<a name="l01205"></a>01205             assign_elem_nodes[6] = 7;
<a name="l01206"></a>01206             assign_elem_nodes[7] = 8;
<a name="l01207"></a>01207             assign_elem_nodes[8] = 9;
<a name="l01208"></a>01208             assign_elem_nodes[9] = 3;
<a name="l01209"></a>01209             <span class="keywordflow">break</span>;
<a name="l01210"></a>01210           }
<a name="l01211"></a>01211                 
<a name="l01212"></a>01212         <span class="keywordflow">default</span>:
<a name="l01213"></a>01213           {
<a name="l01214"></a>01214             std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Element type = &quot;</span> 
<a name="l01215"></a>01215                       &lt;&lt; elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>() 
<a name="l01216"></a>01216                       &lt;&lt; <span class="stringliteral">&quot; not supported in &quot;</span>
<a name="l01217"></a>01217                       &lt;&lt; <span class="stringliteral">&quot;UNVIO!&quot;</span>
<a name="l01218"></a>01218                       &lt;&lt; std::endl;
<a name="l01219"></a>01219             libmesh_error();    
<a name="l01220"></a>01220             <span class="keywordflow">break</span>;
<a name="l01221"></a>01221           }
<a name="l01222"></a>01222         }
<a name="l01223"></a>01223 
<a name="l01224"></a>01224 
<a name="l01225"></a>01225       out_file &lt;&lt; std::setw(10) &lt;&lt; this-&gt;<a class="code" href="classUNVIO.php#a6e6228ac83245ac0d89c98cad6556124">_mesh_data</a>.<a class="code" href="classMeshData.php#a42f4bc27f920ebacc677fe43613d81b5">elem_to_foreign_id</a>(elem)  <span class="comment">// element ID</span>
<a name="l01226"></a>01226                &lt;&lt; std::setw(10) &lt;&lt; fe_descriptor_id                           <span class="comment">// type of element</span>
<a name="l01227"></a>01227                &lt;&lt; std::setw(10) &lt;&lt; phys_prop_tab_dummy                        <span class="comment">// not supported </span>
<a name="l01228"></a>01228                &lt;&lt; std::setw(10) &lt;&lt; mat_prop_tab_dummy                         <span class="comment">// not supported </span>
<a name="l01229"></a>01229                &lt;&lt; std::setw(10) &lt;&lt; color_dummy                                <span class="comment">// not supported </span>
<a name="l01230"></a>01230                &lt;&lt; std::setw(10) &lt;&lt; elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>()                            <span class="comment">// No. of nodes per element</span>
<a name="l01231"></a>01231                &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01232"></a>01232 
<a name="l01233"></a>01233       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); j++)
<a name="l01234"></a>01234         {
<a name="l01235"></a>01235           <span class="comment">// assign_elem_nodes[j]-th node: i.e., j loops over the</span>
<a name="l01236"></a>01236           <span class="comment">// libMesh numbering, and assign_elem_nodes[j] over the</span>
<a name="l01237"></a>01237           <span class="comment">// UNV numbering.</span>
<a name="l01238"></a>01238           <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node_in_unv_order = elem-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(assign_elem_nodes[j]);
<a name="l01239"></a>01239 
<a name="l01240"></a>01240           <span class="comment">// new record after 8 id entries</span>
<a name="l01241"></a>01241           <span class="keywordflow">if</span> (j==8 || j==16)
<a name="l01242"></a>01242             out_file &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01243"></a>01243 
<a name="l01244"></a>01244           <span class="comment">// write foreign label for this node</span>
<a name="l01245"></a>01245           out_file &lt;&lt; std::setw(10) &lt;&lt; this-&gt;<a class="code" href="classUNVIO.php#a6e6228ac83245ac0d89c98cad6556124">_mesh_data</a>.<a class="code" href="classMeshData.php#a64280d5ec57b031bcba08f216af20973">node_to_foreign_id</a>(node_in_unv_order);
<a name="l01246"></a>01246 
<a name="l01247"></a>01247 
<a name="l01248"></a>01248         }
<a name="l01249"></a>01249 
<a name="l01250"></a>01250       out_file &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01251"></a>01251 
<a name="l01252"></a>01252       n_elem_written++;
<a name="l01253"></a>01253     }
<a name="l01254"></a>01254 
<a name="l01255"></a>01255   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classUNVIO.php#ac6095c3fa3e67769a0084172628d5f3e">verbose</a>())
<a name="l01256"></a>01256     std::cout &lt;&lt; <span class="stringliteral">&quot;  Finished writing &quot;</span> &lt;&lt; n_elem_written &lt;&lt; <span class="stringliteral">&quot; elements&quot;</span> &lt;&lt; std::endl;
<a name="l01257"></a>01257 
<a name="l01258"></a>01258   <span class="comment">// Write end of dataset</span>
<a name="l01259"></a>01259   out_file &lt;&lt; <span class="stringliteral">&quot;    -1\n&quot;</span>;
<a name="l01260"></a>01260 }
<a name="l01261"></a>01261 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
