<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>unv_io.h</h1>  </div>
</div>
<div class="contents">
<a href="unv__io_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: unv_io.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __unv_io_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __unv_io_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ inludes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Local includes</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="mesh__input_8h.php">mesh_input.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="mesh__output_8h.php">mesh_output.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Forward declarations</span>
<a name="l00036"></a>00036 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00037"></a>00037 <span class="keyword">class </span><a class="code" href="classMeshData.php">MeshData</a>;
<a name="l00038"></a>00038 
<a name="l00045"></a>00045 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00046"></a>00046 <span class="comment">// UNVIO class definition</span>
<a name="l00047"></a><a class="code" href="classUNVIO.php">00047</a> <span class="keyword">class </span><a class="code" href="classUNVIO.php">UNVIO</a> : <span class="keyword">public</span> <a class="code" href="classMeshInput.php">MeshInput</a>&lt;MeshBase&gt;,
<a name="l00048"></a>00048               <span class="keyword">public</span> <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;MeshBase&gt;
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050 
<a name="l00051"></a>00051  <span class="keyword">public</span>:
<a name="l00052"></a>00052   
<a name="l00057"></a>00057   <a class="code" href="classUNVIO.php#ace644303c94d9fa16f07478c6d80f0ef">UNVIO</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a>, <a class="code" href="classMeshData.php">MeshData</a>&amp; mesh_data);
<a name="l00058"></a>00058 
<a name="l00063"></a>00063   <a class="code" href="classUNVIO.php#ace644303c94d9fa16f07478c6d80f0ef">UNVIO</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh, <a class="code" href="classMeshData.php">MeshData</a>&amp; mesh_data);
<a name="l00064"></a>00064   
<a name="l00068"></a>00068   <span class="keyword">virtual</span> <a class="code" href="classUNVIO.php#a08ba65887f0ff0a59c3f51ac918f0f7f">~UNVIO</a> ();
<a name="l00069"></a>00069   
<a name="l00073"></a>00073   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classUNVIO.php#a40a24f88a4f993af6bc8e36fb3f44de1">read</a> (<span class="keyword">const</span> std::string&amp; );
<a name="l00074"></a>00074   
<a name="l00078"></a>00078   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classUNVIO.php#a5104c54df79a6fbc4ec7c617c1d72b35">write</a> (<span class="keyword">const</span> std::string&amp; );
<a name="l00079"></a>00079 
<a name="l00083"></a>00083   <span class="keywordtype">bool</span> &amp; <a class="code" href="classUNVIO.php#ac6095c3fa3e67769a0084172628d5f3e">verbose</a> ();
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   
<a name="l00086"></a>00086  <span class="keyword">private</span>:
<a name="l00087"></a>00087   
<a name="l00088"></a>00088 
<a name="l00094"></a>00094   <span class="keywordtype">void</span> <a class="code" href="classUNVIO.php#ae413b484259e51836731399c8fbb3265">read_implementation</a> (std::istream&amp; in_stream);
<a name="l00095"></a>00095 
<a name="l00101"></a>00101   <span class="keywordtype">void</span> <a class="code" href="classUNVIO.php#a3cf0cbd9b944fed2a91b758eefc50373">write_implementation</a> (std::ostream&amp; out_stream);
<a name="l00102"></a>00102   
<a name="l00107"></a>00107   <span class="keywordtype">void</span> <a class="code" href="classUNVIO.php#a09a85205e7afa776b2bad647d06b01b9">clear</a>();
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00111"></a>00111   <span class="comment">// read support methods</span>
<a name="l00117"></a>00117 <span class="comment"></span>  <span class="keywordtype">void</span> <a class="code" href="classUNVIO.php#a81183897fdd5814dcc70a9a09a593e2f">count_nodes</a> (std::istream&amp; in_file);
<a name="l00118"></a>00118   
<a name="l00128"></a>00128   <span class="keywordtype">void</span> <a class="code" href="classUNVIO.php#a2923e755e639db970e2f0c8c7beb9a9e">node_in</a> (std::istream&amp; in_file);
<a name="l00129"></a>00129 
<a name="l00134"></a>00134   <span class="keywordtype">void</span> <a class="code" href="classUNVIO.php#a4b910b386669e8437948b223fd98316f">count_elements</a> (std::istream&amp; in_file);
<a name="l00135"></a>00135 
<a name="l00143"></a>00143   <span class="keywordtype">void</span> <a class="code" href="classUNVIO.php#a1632bd719dc3a2261a2cf8cd86cd42ee">element_in</a> (std::istream&amp; in_file);
<a name="l00144"></a>00144 
<a name="l00150"></a>00150   <span class="keywordtype">bool</span> <a class="code" href="classUNVIO.php#a0eede436f9709971c5270f0fd8b62725">beginning_of_dataset</a> (std::istream&amp; in_file, 
<a name="l00151"></a>00151                              <span class="keyword">const</span> std::string&amp; ds_name) <span class="keyword">const</span>;
<a name="l00152"></a>00152 
<a name="l00159"></a>00159   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classUNVIO.php#a5caa80966b5492eaa947d3dbff410e25">D_to_e</a> (std::string&amp; number) <span class="keyword">const</span>;
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00163"></a>00163   <span class="comment">// write support methods</span>
<a name="l00170"></a>00170 <span class="comment"></span>  <span class="keywordtype">void</span> <a class="code" href="classUNVIO.php#ab01b5e4a6eefbec7f0c8ca121071e6bd">node_out</a> (std::ostream&amp; out_file);
<a name="l00171"></a>00171 
<a name="l00178"></a>00178   <span class="keywordtype">void</span> <a class="code" href="classUNVIO.php#ac693037f9e6a48b02bc7b5018448b42b">element_out</a> (std::ostream&amp; out_file);
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 
<a name="l00181"></a>00181   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00182"></a>00182   <span class="comment">// local data</span>
<a name="l00183"></a>00183 
<a name="l00187"></a><a class="code" href="classUNVIO.php#abbea44f2a449b0fdba33ac2b4c6f6e00">00187</a>   <span class="keywordtype">bool</span> <a class="code" href="classUNVIO.php#abbea44f2a449b0fdba33ac2b4c6f6e00">_verbose</a>;
<a name="l00188"></a>00188 
<a name="l00192"></a><a class="code" href="classUNVIO.php#a80192cd817475ee4e6894e71317587b1">00192</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classUNVIO.php#a80192cd817475ee4e6894e71317587b1">_assign_nodes</a>;
<a name="l00193"></a>00193 
<a name="l00198"></a><a class="code" href="classUNVIO.php#ace408490a726e8e75622a252824ac100">00198</a>   std::map&lt;std::string,std::streampos&gt; <a class="code" href="classUNVIO.php#ace408490a726e8e75622a252824ac100">_ds_position</a>;
<a name="l00199"></a>00199 
<a name="l00204"></a><a class="code" href="classUNVIO.php#a26ec56cf191f525f0f00c12014c76e88">00204</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classUNVIO.php#a26ec56cf191f525f0f00c12014c76e88">_n_nodes</a>;
<a name="l00205"></a>00205 
<a name="l00210"></a><a class="code" href="classUNVIO.php#a90edacdb984a8c6dd6be96a636a56f96">00210</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classUNVIO.php#a90edacdb984a8c6dd6be96a636a56f96">_n_elements</a>;
<a name="l00211"></a>00211 
<a name="l00215"></a><a class="code" href="classUNVIO.php#a6b7fa514960a93fe3778f86ad26dedb0">00215</a>   <span class="keyword">static</span> <span class="keyword">const</span> std::string <a class="code" href="classUNVIO.php#a6b7fa514960a93fe3778f86ad26dedb0">_label_dataset_nodes</a>;
<a name="l00216"></a>00216 
<a name="l00220"></a><a class="code" href="classUNVIO.php#ac77599b563ab3eb28c344085e2937059">00220</a>   <span class="keyword">static</span> <span class="keyword">const</span> std::string <a class="code" href="classUNVIO.php#ac77599b563ab3eb28c344085e2937059">_label_dataset_elements</a>;
<a name="l00221"></a>00221 
<a name="l00226"></a><a class="code" href="classUNVIO.php#ae6fb40cfcf52a48c8ccd9cdecedf8b9f">00226</a>   <span class="keywordtype">bool</span> <a class="code" href="classUNVIO.php#ae6fb40cfcf52a48c8ccd9cdecedf8b9f">_need_D_to_e</a>;
<a name="l00227"></a>00227 
<a name="l00232"></a><a class="code" href="classUNVIO.php#a6e6228ac83245ac0d89c98cad6556124">00232</a>   <a class="code" href="classMeshData.php">MeshData</a>&amp; <a class="code" href="classUNVIO.php#a6e6228ac83245ac0d89c98cad6556124">_mesh_data</a>;
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 };
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 
<a name="l00238"></a>00238 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00239"></a>00239 <span class="comment">// MeshIO inline members</span>
<a name="l00240"></a>00240 <span class="keyword">inline</span>
<a name="l00241"></a><a class="code" href="classUNVIO.php#ace644303c94d9fa16f07478c6d80f0ef">00241</a> <a class="code" href="classUNVIO.php#ace644303c94d9fa16f07478c6d80f0ef">UNVIO::UNVIO</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh, <a class="code" href="classMeshData.php">MeshData</a>&amp; mesh_data) :
<a name="l00242"></a>00242   <a class="code" href="classMeshInput.php">MeshInput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt; (mesh),
<a name="l00243"></a>00243   <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt;(mesh),
<a name="l00244"></a>00244   _verbose (false),
<a name="l00245"></a>00245   _mesh_data (mesh_data)
<a name="l00246"></a>00246 {
<a name="l00247"></a>00247 }
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 
<a name="l00250"></a>00250 
<a name="l00251"></a>00251 <span class="keyword">inline</span>
<a name="l00252"></a><a class="code" href="classUNVIO.php#a5cb1421b6610c85897701f198b634534">00252</a> <a class="code" href="classUNVIO.php#ace644303c94d9fa16f07478c6d80f0ef">UNVIO::UNVIO</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh, <a class="code" href="classMeshData.php">MeshData</a>&amp; mesh_data) :
<a name="l00253"></a>00253   <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt; (mesh),
<a name="l00254"></a>00254   _verbose (false),
<a name="l00255"></a>00255   _mesh_data (mesh_data)
<a name="l00256"></a>00256 {
<a name="l00257"></a>00257 }
<a name="l00258"></a>00258 
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 
<a name="l00261"></a>00261 <span class="keyword">inline</span>
<a name="l00262"></a><a class="code" href="classUNVIO.php#a08ba65887f0ff0a59c3f51ac918f0f7f">00262</a> <a class="code" href="classUNVIO.php#a08ba65887f0ff0a59c3f51ac918f0f7f">UNVIO::~UNVIO</a> ()
<a name="l00263"></a>00263 {
<a name="l00264"></a>00264   this-&gt;<a class="code" href="classUNVIO.php#a09a85205e7afa776b2bad647d06b01b9">clear</a> ();
<a name="l00265"></a>00265 }
<a name="l00266"></a>00266 
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 
<a name="l00269"></a>00269 <span class="keyword">inline</span>
<a name="l00270"></a><a class="code" href="classUNVIO.php#ac6095c3fa3e67769a0084172628d5f3e">00270</a> <span class="keywordtype">bool</span> &amp; <a class="code" href="classUNVIO.php#ac6095c3fa3e67769a0084172628d5f3e">UNVIO::verbose</a> ()
<a name="l00271"></a>00271 {
<a name="l00272"></a>00272   <span class="keywordflow">return</span> <a class="code" href="classUNVIO.php#abbea44f2a449b0fdba33ac2b4c6f6e00">_verbose</a>;
<a name="l00273"></a>00273 }
<a name="l00274"></a>00274 
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 <span class="keyword">inline</span>
<a name="l00278"></a><a class="code" href="classUNVIO.php#a0eede436f9709971c5270f0fd8b62725">00278</a> <span class="keywordtype">bool</span> <a class="code" href="classUNVIO.php#a0eede436f9709971c5270f0fd8b62725">UNVIO::beginning_of_dataset</a> (std::istream&amp; in_file, 
<a name="l00279"></a>00279                                   <span class="keyword">const</span> std::string&amp; ds_name)<span class="keyword"> const</span>
<a name="l00280"></a>00280 <span class="keyword"></span>{
<a name="l00281"></a>00281   libmesh_assert (in_file.good());
<a name="l00282"></a>00282   libmesh_assert (!ds_name.empty());
<a name="l00283"></a>00283 
<a name="l00284"></a>00284   std::string olds, news;
<a name="l00285"></a>00285 
<a name="l00286"></a>00286   <span class="keywordflow">while</span> (<span class="keyword">true</span>)
<a name="l00287"></a>00287     {
<a name="l00288"></a>00288       in_file &gt;&gt; olds &gt;&gt; news;
<a name="l00289"></a>00289 
<a name="l00290"></a>00290       <span class="comment">/*</span>
<a name="l00291"></a>00291 <span class="comment">       * a &quot;-1&quot; followed by a number means the beginning of a dataset</span>
<a name="l00292"></a>00292 <span class="comment">       * stop combing at the end of the file</span>
<a name="l00293"></a>00293 <span class="comment">       */</span>
<a name="l00294"></a>00294       <span class="keywordflow">while</span>( ((olds != <span class="stringliteral">&quot;-1&quot;</span>) || (news == <span class="stringliteral">&quot;-1&quot;</span>) ) &amp;&amp; !in_file.eof() )
<a name="l00295"></a>00295         {         
<a name="l00296"></a>00296           olds = news;
<a name="l00297"></a>00297           in_file &gt;&gt; news;
<a name="l00298"></a>00298         }
<a name="l00299"></a>00299 
<a name="l00300"></a>00300       <span class="keywordflow">if</span> (in_file.eof())
<a name="l00301"></a>00301         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00302"></a>00302       
<a name="l00303"></a>00303       <span class="keywordflow">if</span> (news == ds_name)
<a name="l00304"></a>00304         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00305"></a>00305     }
<a name="l00306"></a>00306 
<a name="l00307"></a>00307   <span class="comment">// should never end up here</span>
<a name="l00308"></a>00308   libmesh_error();
<a name="l00309"></a>00309   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00310"></a>00310 }
<a name="l00311"></a>00311 
<a name="l00312"></a>00312 
<a name="l00313"></a>00313 
<a name="l00314"></a>00314 <span class="keyword">inline</span>
<a name="l00315"></a><a class="code" href="classUNVIO.php#a5caa80966b5492eaa947d3dbff410e25">00315</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classUNVIO.php#a5caa80966b5492eaa947d3dbff410e25">UNVIO::D_to_e</a> (std::string&amp; number)<span class="keyword"> const</span>
<a name="l00316"></a>00316 <span class="keyword"></span>{
<a name="l00317"></a>00317   <span class="comment">/* find &quot;D&quot; in string, start looking at </span>
<a name="l00318"></a>00318 <span class="comment">   * 6th element, to improve speed.</span>
<a name="l00319"></a>00319 <span class="comment">   * We dont expect a &quot;D&quot; earlier</span>
<a name="l00320"></a>00320 <span class="comment">   */</span>
<a name="l00321"></a>00321 
<a name="l00322"></a>00322 <span class="preprocessor">#ifdef __HP_aCC</span>
<a name="l00323"></a>00323 <span class="preprocessor"></span>  <span class="comment">// Use an int instead of an unsigned int,</span>
<a name="l00324"></a>00324   <span class="comment">// otherwise HP aCC may crash!</span>
<a name="l00325"></a>00325   <span class="keyword">const</span> <span class="keywordtype">int</span> position = number.find(<span class="stringliteral">&quot;D&quot;</span>,6);
<a name="l00326"></a>00326 <span class="preprocessor">#else</span>
<a name="l00327"></a>00327 <span class="preprocessor"></span>  <span class="keyword">const</span> std::string::size_type position = number.find(<span class="stringliteral">&quot;D&quot;</span>,6);
<a name="l00328"></a>00328 <span class="preprocessor">#endif</span>
<a name="l00329"></a>00329 <span class="preprocessor"></span>
<a name="l00330"></a>00330   libmesh_assert (position != std::string::npos);
<a name="l00331"></a>00331   number.replace(position, 1, <span class="stringliteral">&quot;e&quot;</span>); 
<a name="l00332"></a>00332 
<a name="l00333"></a>00333   <span class="keywordflow">return</span> std::atof (number.c_str());
<a name="l00334"></a>00334 }
<a name="l00335"></a>00335 
<a name="l00336"></a>00336 
<a name="l00337"></a>00337 
<a name="l00338"></a>00338 <span class="preprocessor">#endif // #define __unv_io_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
