<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_4f64d75cac7489d141591c33108e86ff.php">utils</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>utility.h</h1>  </div>
</div>
<div class="contents">
<a href="utility_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: utility.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __utility_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __utility_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// System includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;cmath&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::lower_bound</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span> <span class="comment">// for Real</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00035"></a>00035 <span class="comment">// The Utility namespace is for functions</span>
<a name="l00036"></a>00036 <span class="comment">// which are useful but don&#39;t necessarily belong anywhere else.</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Utility
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00045"></a>00045 <span class="comment"></span>  std::string <a class="code" href="namespaceUtility.php#a8a7ff0040a2e21a019563f2d27a9b1bb">system_info</a>();
<a name="l00046"></a>00046 
<a name="l00047"></a>00047   
<a name="l00048"></a>00048 
<a name="l00049"></a>00049   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00057"></a>00057 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> ForwardIter, <span class="keyword">typename</span> T&gt;
<a name="l00058"></a><a class="code" href="namespaceUtility.php#a7c2b0a25e726200178bc1ec52b132981">00058</a>   <span class="keywordtype">void</span> <a class="code" href="namespaceUtility.php#a7c2b0a25e726200178bc1ec52b132981">iota</a> (ForwardIter first, ForwardIter last, T value)
<a name="l00059"></a>00059   {
<a name="l00060"></a>00060     <span class="keywordflow">while</span> (first != last)
<a name="l00061"></a>00061       {
<a name="l00062"></a>00062         *first = value++;
<a name="l00063"></a>00063         ++first;
<a name="l00064"></a>00064       }
<a name="l00065"></a>00065   }
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00074"></a>00074   <span class="keyword">template</span>&lt; <span class="keyword">class</span> InputIterator &gt;
<a name="l00075"></a><a class="code" href="namespaceUtility.php#af70a8d85faa2f91d507cf6fc38fe1b6f">00075</a>   <span class="keywordtype">bool</span> <a class="code" href="namespaceUtility.php#af70a8d85faa2f91d507cf6fc38fe1b6f">is_sorted</a>(InputIterator first, InputIterator last)
<a name="l00076"></a>00076   {
<a name="l00077"></a>00077     <span class="keywordflow">if</span> ( first == last )
<a name="l00078"></a>00078       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00079"></a>00079 
<a name="l00080"></a>00080     <span class="comment">// &quot;prev&quot; always points to the entry just to the left of &quot;first&quot;</span>
<a name="l00081"></a>00081     <span class="comment">//  [-    -    -    -    -    -]</span>
<a name="l00082"></a>00082     <span class="comment">//   ^    ^</span>
<a name="l00083"></a>00083     <span class="comment">// prev first</span>
<a name="l00084"></a>00084     <span class="comment">//</span>
<a name="l00085"></a>00085     <span class="comment">//  [-    -    -    -    -    -]</span>
<a name="l00086"></a>00086     <span class="comment">//        ^    ^</span>
<a name="l00087"></a>00087     <span class="comment">//      prev first</span>
<a name="l00088"></a>00088     <span class="comment">//</span>
<a name="l00089"></a>00089     <span class="comment">//  [-    -    -    -    -    -]</span>
<a name="l00090"></a>00090     <span class="comment">//             ^    ^</span>
<a name="l00091"></a>00091     <span class="comment">//           prev first</span>
<a name="l00092"></a>00092     InputIterator prev( first );
<a name="l00093"></a>00093     <span class="keywordflow">for</span> ( ++first; first != last; ++prev, ++first ) 
<a name="l00094"></a>00094       <span class="keywordflow">if</span> ( *first &lt; *prev  )    <span class="comment">// Note: this is the same as *prev &gt; *first,</span>
<a name="l00095"></a>00095            <span class="keywordflow">return</span> <span class="keyword">false</span>;        <span class="comment">// but we only require op&lt; to be defined.</span>
<a name="l00096"></a>00096 
<a name="l00097"></a>00097     <span class="comment">// If we haven&#39;t returned yet, it&#39;s sorted!</span>
<a name="l00098"></a>00098     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00099"></a>00099     
<a name="l00100"></a>00100     
<a name="l00101"></a>00101     <span class="comment">// A one-liner version using adjacent_find.  This doesn&#39;t work for</span>
<a name="l00102"></a>00102     <span class="comment">// C-style arrays, since their pointers do not have a value_type.</span>
<a name="l00103"></a>00103     <span class="comment">//</span>
<a name="l00104"></a>00104     <span class="comment">// Works by checking to see if adjacent entries satisfy *i &gt;</span>
<a name="l00105"></a>00105     <span class="comment">// *(i+1) and returns the first one which does.  If &quot;last&quot; is</span>
<a name="l00106"></a>00106     <span class="comment">// returned, no such pair was found, and therefore the range must</span>
<a name="l00107"></a>00107     <span class="comment">// be in non-decreasing order.</span>
<a name="l00108"></a>00108     <span class="comment">//</span>
<a name="l00109"></a>00109     <span class="comment">// return (last ==</span>
<a name="l00110"></a>00110     <span class="comment">// std::adjacent_find(first, last,</span>
<a name="l00111"></a>00111     <span class="comment">// std::greater&lt; typename InputIterator::value_type &gt;()));</span>
<a name="l00112"></a>00112     
<a name="l00113"></a>00113     <span class="comment">// A second one-linear attempt.  This one checks for a **strictly</span>
<a name="l00114"></a>00114     <span class="comment">// increasing** (no duplicate entries) range.  Also doesn&#39;t work</span>
<a name="l00115"></a>00115     <span class="comment">// with C-style arrays.</span>
<a name="l00116"></a>00116     <span class="comment">//</span>
<a name="l00117"></a>00117     <span class="comment">// return (last ==</span>
<a name="l00118"></a>00118     <span class="comment">// std::adjacent_find(first, last,</span>
<a name="l00119"></a>00119     <span class="comment">// std::not2(std::less&lt;typename InputIterator::value_type&gt;())));</span>
<a name="l00120"></a>00120   }
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00129"></a>00129   <span class="keyword">template</span>&lt;<span class="keyword">class</span> ForwardIterator, <span class="keyword">class</span> T&gt;
<a name="l00130"></a><a class="code" href="namespaceUtility.php#a217250aebb663fd741070093ead96bf9">00130</a>   ForwardIterator <a class="code" href="namespaceUtility.php#a217250aebb663fd741070093ead96bf9">binary_find</a>(ForwardIterator first, ForwardIterator last, <span class="keyword">const</span> T&amp; value)
<a name="l00131"></a>00131   {
<a name="l00132"></a>00132     ForwardIterator it = std::lower_bound(first, last, value);
<a name="l00133"></a>00133     <span class="keywordflow">return</span> (it == last || value &lt; *it) ? last : it;
<a name="l00134"></a>00134   }
<a name="l00135"></a>00135     
<a name="l00136"></a>00136       
<a name="l00137"></a>00137   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00142"></a>00142 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keywordtype">int</span> N&gt;
<a name="l00143"></a>00143   <span class="keyword">inline</span>
<a name="l00144"></a><a class="code" href="namespaceUtility.php#aa31a2ff44b735ae86eea0446796a3b42">00144</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="namespaceUtility.php#aa31a2ff44b735ae86eea0446796a3b42">pow</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> x) 
<a name="l00145"></a>00145   { 
<a name="l00146"></a>00146     libmesh_assert(N&gt;1); 
<a name="l00147"></a>00147     
<a name="l00148"></a>00148     <span class="keywordflow">if</span> (N%2) <span class="comment">// odd exponent</span>
<a name="l00149"></a>00149       <span class="keywordflow">return</span> x * <a class="code" href="namespaceUtility.php#aa31a2ff44b735ae86eea0446796a3b42">pow</a>&lt;N-1&gt;(x); 
<a name="l00150"></a>00150     
<a name="l00151"></a>00151     <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> xNover2 = <a class="code" href="namespaceUtility.php#aa31a2ff44b735ae86eea0446796a3b42">pow</a>&lt;N/2&gt;(x);
<a name="l00152"></a>00152 
<a name="l00153"></a>00153     <span class="keywordflow">return</span> xNover2*xNover2;
<a name="l00154"></a>00154   }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156   <span class="keyword">template</span> &lt;&gt;
<a name="l00157"></a>00157   <span class="keyword">inline</span>
<a name="l00158"></a><a class="code" href="namespaceUtility.php#a44012c435fc64e44f5dc8b768ff7bbd9">00158</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="namespaceUtility.php#a44012c435fc64e44f5dc8b768ff7bbd9">pow&lt;8&gt;</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> x) 
<a name="l00159"></a>00159   {
<a name="l00160"></a>00160     <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> 
<a name="l00161"></a>00161       x2 = x*x,
<a name="l00162"></a>00162       x4 = x2*x2,
<a name="l00163"></a>00163       x8 = x4*x4;
<a name="l00164"></a>00164 
<a name="l00165"></a>00165     <span class="keywordflow">return</span> x8; 
<a name="l00166"></a>00166   }
<a name="l00167"></a>00167 
<a name="l00168"></a>00168   <span class="keyword">template</span> &lt;&gt;
<a name="l00169"></a>00169   <span class="keyword">inline</span>
<a name="l00170"></a><a class="code" href="namespaceUtility.php#abbfa763995cc963befa2d0e8923a1ab8">00170</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="namespaceUtility.php#abbfa763995cc963befa2d0e8923a1ab8">pow&lt;6&gt;</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> x) 
<a name="l00171"></a>00171   {
<a name="l00172"></a>00172     <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> 
<a name="l00173"></a>00173       x2 = x*x,
<a name="l00174"></a>00174       x4 = x2*x2,
<a name="l00175"></a>00175       x6 = x4*x2;
<a name="l00176"></a>00176 
<a name="l00177"></a>00177     <span class="keywordflow">return</span> x6; 
<a name="l00178"></a>00178   }
<a name="l00179"></a>00179 
<a name="l00180"></a>00180   <span class="keyword">template</span> &lt;&gt;
<a name="l00181"></a>00181   <span class="keyword">inline</span>
<a name="l00182"></a><a class="code" href="namespaceUtility.php#ad43f6ee9f8a1b0dc3ff72c000dafaaca">00182</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="namespaceUtility.php#ad43f6ee9f8a1b0dc3ff72c000dafaaca">pow&lt;4&gt;</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> x) 
<a name="l00183"></a>00183   {
<a name="l00184"></a>00184     <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> 
<a name="l00185"></a>00185       x2 = x*x,
<a name="l00186"></a>00186       x4 = x2*x2;
<a name="l00187"></a>00187     <span class="keywordflow">return</span> x4; 
<a name="l00188"></a>00188   }
<a name="l00189"></a>00189 
<a name="l00190"></a>00190   <span class="keyword">template</span> &lt;&gt;
<a name="l00191"></a>00191   <span class="keyword">inline</span>
<a name="l00192"></a><a class="code" href="namespaceUtility.php#af4ab5b8fbb769395be82d741e6ccb627">00192</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="namespaceUtility.php#af4ab5b8fbb769395be82d741e6ccb627">pow&lt;3&gt;</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> x) { <span class="keywordflow">return</span> x*x*x; }
<a name="l00193"></a>00193 
<a name="l00194"></a>00194   <span class="keyword">template</span> &lt;&gt;
<a name="l00195"></a>00195   <span class="keyword">inline</span>
<a name="l00196"></a><a class="code" href="namespaceUtility.php#af9eeb1ce1bd05f49f92735d841556876">00196</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="namespaceUtility.php#af9eeb1ce1bd05f49f92735d841556876">pow&lt;2&gt;</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> x) { <span class="keywordflow">return</span> x*x; }
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   <span class="keyword">template</span> &lt;&gt;
<a name="l00199"></a>00199   <span class="keyword">inline</span>
<a name="l00200"></a><a class="code" href="namespaceUtility.php#a86c6919869fe0dd1a5ad1859bd5d586c">00200</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="namespaceUtility.php#a86c6919869fe0dd1a5ad1859bd5d586c">pow&lt;1&gt;</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> x) { <span class="keywordflow">return</span> x; }
<a name="l00201"></a>00201 
<a name="l00202"></a>00202   <span class="keyword">template</span> &lt;&gt;
<a name="l00203"></a>00203   <span class="keyword">inline</span>
<a name="l00204"></a><a class="code" href="namespaceUtility.php#a9ddd30f0347ebf0cb9a691ef1ba54652">00204</a>   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="namespaceUtility.php#a9ddd30f0347ebf0cb9a691ef1ba54652">pow&lt;0&gt;</a>(<span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>) { <span class="keywordflow">return</span> 1.; }
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 
<a name="l00207"></a>00207   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00211"></a>00211 <span class="comment"></span>  <span class="keyword">inline</span>
<a name="l00212"></a><a class="code" href="namespaceUtility.php#a606c384cb71b6aa8de2d8c48dead0962">00212</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceUtility.php#a606c384cb71b6aa8de2d8c48dead0962">factorial</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00213"></a>00213     {
<a name="l00214"></a>00214 
<a name="l00215"></a>00215       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> factorial_n = 1;
<a name="l00216"></a>00216 
<a name="l00217"></a>00217       <span class="keywordflow">if</span> (n==0)
<a name="l00218"></a>00218         <span class="keywordflow">return</span> factorial_n;
<a name="l00219"></a>00219       
<a name="l00220"></a>00220       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i&lt;n; i++)
<a name="l00221"></a>00221         factorial_n *= i+1;
<a name="l00222"></a>00222 
<a name="l00223"></a>00223       <span class="keywordflow">return</span> factorial_n;
<a name="l00224"></a>00224     }
<a name="l00225"></a>00225 
<a name="l00226"></a>00226   
<a name="l00227"></a>00227   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00231"></a>00231 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00232"></a><a class="code" href="namespaceUtility.php#a87eab2b9d265355c6c62b945c15bdf9f">00232</a>   <span class="keywordtype">void</span> <a class="code" href="namespaceUtility.php#a87eab2b9d265355c6c62b945c15bdf9f">deallocate</a> (std::vector&lt;T&gt; &amp;vec)
<a name="l00233"></a>00233   {
<a name="l00234"></a>00234     std::vector&lt;T&gt;().swap(vec);
<a name="l00235"></a>00235   }
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 
<a name="l00238"></a>00238   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00239"></a>00239   <span class="comment">// Utility functions useful when dealing with complex numbers.</span>
<a name="l00240"></a>00240  
<a name="l00241"></a>00241 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00242"></a>00242 <span class="preprocessor"></span>
<a name="l00248"></a>00248   std::string <a class="code" href="namespaceUtility.php#a45028c8d57f427908f52bc792734bd9e">complex_filename</a> (<span class="keyword">const</span> std::string&amp; basename,
<a name="l00249"></a>00249                                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> r_o_c=0);
<a name="l00250"></a>00250 
<a name="l00254"></a>00254   <span class="keywordtype">void</span> <a class="code" href="namespaceUtility.php#ab91b2ad61e7d474fd28ca7e29e394a61">prepare_complex_data</a> (<span class="keyword">const</span> std::vector&lt;Complex&gt;&amp; source,
<a name="l00255"></a>00255                              std::vector&lt;Real&gt;&amp; real_part,
<a name="l00256"></a>00256                              std::vector&lt;Real&gt;&amp; imag_part);
<a name="l00257"></a>00257 
<a name="l00258"></a>00258 <span class="preprocessor">#endif // #ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00259"></a>00259 <span class="preprocessor"></span>
<a name="l00260"></a>00260 
<a name="l00261"></a>00261   
<a name="l00262"></a>00262   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00271"></a><a class="code" href="classUtility_1_1ReverseBytes.php">00271</a> <span class="comment"></span>  <span class="keyword">class </span><a class="code" href="classUtility_1_1ReverseBytes.php">ReverseBytes</a>
<a name="l00272"></a>00272   {
<a name="l00273"></a>00273   <span class="keyword">public</span>:
<a name="l00274"></a>00274     
<a name="l00279"></a>00279     <a class="code" href="classUtility_1_1ReverseBytes.php#a9deeaf11499d7258fe9883418d1d27a2">ReverseBytes</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> dr);
<a name="l00280"></a>00280 
<a name="l00285"></a>00285     <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00286"></a>00286     T <a class="code" href="classUtility_1_1ReverseBytes.php#ae27ccb4360a9a6440c36164e5c6e33a3">operator () </a>(T&amp; data) <span class="keyword">const</span>;
<a name="l00287"></a>00287   
<a name="l00288"></a>00288   <span class="keyword">private</span>:
<a name="l00289"></a>00289   
<a name="l00293"></a><a class="code" href="classUtility_1_1ReverseBytes.php#a1b307a88e82e7db1e91c7a9f58f6eb99">00293</a>     <span class="keywordtype">bool</span> <a class="code" href="classUtility_1_1ReverseBytes.php#a1b307a88e82e7db1e91c7a9f58f6eb99">reverse</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classUtility_1_1ReverseBytes.php#a6b1725b572c7e38b697ed024fce311f3">_do_reverse</a>; };
<a name="l00294"></a>00294 
<a name="l00298"></a>00298     <span class="keyword">const</span> <span class="keywordtype">bool</span> <a class="code" href="classUtility_1_1ReverseBytes.php#a6b1725b572c7e38b697ed024fce311f3">_do_reverse</a>;  
<a name="l00299"></a>00299   };
<a name="l00300"></a>00300 
<a name="l00301"></a>00301 
<a name="l00302"></a>00302 
<a name="l00303"></a>00303   <span class="comment">//---------------------------------------------------------</span>
<a name="l00304"></a>00304   <span class="comment">// ReverseBytes inline members</span>
<a name="l00305"></a>00305   <span class="keyword">inline</span>
<a name="l00306"></a><a class="code" href="classUtility_1_1ReverseBytes.php#a9deeaf11499d7258fe9883418d1d27a2">00306</a>   <a class="code" href="classUtility_1_1ReverseBytes.php#a9deeaf11499d7258fe9883418d1d27a2">ReverseBytes::ReverseBytes</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> rb) :
<a name="l00307"></a>00307     _do_reverse (rb)
<a name="l00308"></a>00308   {}
<a name="l00309"></a>00309 
<a name="l00310"></a>00310 
<a name="l00311"></a>00311   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00312"></a>00312   <span class="keyword">inline</span>
<a name="l00313"></a><a class="code" href="classUtility_1_1ReverseBytes.php#ae27ccb4360a9a6440c36164e5c6e33a3">00313</a>   T <a class="code" href="classUtility_1_1ReverseBytes.php#ae27ccb4360a9a6440c36164e5c6e33a3">ReverseBytes::operator() </a>(T&amp; data)<span class="keyword"> const</span>
<a name="l00314"></a>00314 <span class="keyword">  </span>{
<a name="l00315"></a>00315     <span class="comment">// Possibly reverse the byte ordering</span>
<a name="l00316"></a>00316     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classUtility_1_1ReverseBytes.php#a1b307a88e82e7db1e91c7a9f58f6eb99">reverse</a>())
<a name="l00317"></a>00317       {
<a name="l00318"></a>00318         <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>* b = (<span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>*) &amp;data;
<a name="l00319"></a>00319         
<a name="l00320"></a>00320         <span class="keyword">register</span> <span class="keywordtype">int</span> i=0;
<a name="l00321"></a>00321         <span class="keyword">register</span> <span class="keywordtype">int</span> j=(<span class="keyword">sizeof</span>(T) - 1);
<a name="l00322"></a>00322         
<a name="l00323"></a>00323         <span class="keywordflow">while</span> (i &lt; j)
<a name="l00324"></a>00324           {
<a name="l00325"></a>00325             std::swap (b[i], b[j]);
<a name="l00326"></a>00326             i++; j--;
<a name="l00327"></a>00327           }
<a name="l00328"></a>00328       }
<a name="l00329"></a>00329 
<a name="l00330"></a>00330     <span class="keywordflow">return</span> data;
<a name="l00331"></a>00331   }
<a name="l00332"></a>00332 
<a name="l00333"></a>00333   
<a name="l00334"></a>00334 }
<a name="l00335"></a>00335 
<a name="l00336"></a>00336 <span class="preprocessor">#endif // #define __utility_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
