<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_332ee7db517b8350403df5b9dd6d8d12.php">numerics</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>vector_value.h</h1>  </div>
</div>
<div class="contents">
<a href="vector__value_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: vector_value.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __vector_value_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __vector_value_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="type__vector_8h.php">type_vector.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00041"></a>00041 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00042"></a><a class="code" href="classVectorValue.php">00042</a> <span class="keyword">class </span><a class="code" href="classVectorValue.php">VectorValue</a> : <span class="keyword">public</span> <a class="code" href="classTypeVector.php">TypeVector</a>&lt;T&gt;
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044 <span class="keyword">public</span>:
<a name="l00045"></a>00045 
<a name="l00050"></a>00050   <a class="code" href="classVectorValue.php#a2199d222363f32b82e33d9e82a5fc564">VectorValue</a>  (<span class="keyword">const</span> T x=0.,
<a name="l00051"></a>00051                 <span class="keyword">const</span> T y=0.,
<a name="l00052"></a>00052                 <span class="keyword">const</span> T z=0.);
<a name="l00053"></a>00053   
<a name="l00057"></a>00057   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00058"></a>00058   <a class="code" href="classVectorValue.php#a2199d222363f32b82e33d9e82a5fc564">VectorValue</a> (<span class="keyword">const</span> <a class="code" href="classVectorValue.php">VectorValue&lt;T2&gt;</a>&amp; p);
<a name="l00059"></a>00059 
<a name="l00063"></a>00063   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00064"></a>00064   <a class="code" href="classVectorValue.php#a2199d222363f32b82e33d9e82a5fc564">VectorValue</a> (<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a>&amp; p);
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00068"></a>00068 <span class="preprocessor"></span>
<a name="l00073"></a>00073   <a class="code" href="classVectorValue.php#a2199d222363f32b82e33d9e82a5fc564">VectorValue</a> (<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;Real&gt;</a>&amp; p_re,
<a name="l00074"></a>00074                <span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;Real&gt;</a>&amp; p_im);
<a name="l00075"></a>00075 <span class="preprocessor">#endif</span>
<a name="l00076"></a>00076 <span class="preprocessor"></span>
<a name="l00077"></a>00077   
<a name="l00078"></a>00078 <span class="keyword">private</span>:
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   
<a name="l00081"></a>00081 };
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00089"></a><a class="code" href="vector__value_8h.php#a70438a9d2ae50d73d33da5b97391d6f9">00089</a> <span class="keyword">typedef</span> <a class="code" href="classVectorValue.php">VectorValue&lt;Real&gt;</a>   <a class="code" href="hp__coarsentest_8h.php#a70438a9d2ae50d73d33da5b97391d6f9">RealVectorValue</a>;
<a name="l00090"></a><a class="code" href="vector__value_8h.php#a08d743aadc7b1860846e8aa6dfa7ae41">00090</a> <span class="keyword">typedef</span> <a class="code" href="classVectorValue.php">VectorValue&lt;Number&gt;</a> <a class="code" href="exact__error__estimator_8h.php#a08d743aadc7b1860846e8aa6dfa7ae41">NumberVectorValue</a>;
<a name="l00091"></a><a class="code" href="vector__value_8h.php#ac658ced7e2c274a1648a3d903bc3868b">00091</a> <span class="keyword">typedef</span> <a class="code" href="classVectorValue.php">RealVectorValue</a>     <a class="code" href="hp__coarsentest_8h.php#ac658ced7e2c274a1648a3d903bc3868b">RealGradient</a>;
<a name="l00092"></a><a class="code" href="vector__value_8h.php#aff779e61aca326de0c3649ec86a15866">00092</a> <span class="keyword">typedef</span> <a class="code" href="classVectorValue.php">NumberVectorValue</a>   <a class="code" href="exact__error__estimator_8h.php#aff779e61aca326de0c3649ec86a15866">Gradient</a>;
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 <span class="comment">//------------------------------------------------------</span>
<a name="l00097"></a>00097 <span class="comment">// Inline functions</span>
<a name="l00098"></a>00098 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00099"></a>00099 <span class="keyword">inline</span>
<a name="l00100"></a><a class="code" href="classVectorValue.php#a2199d222363f32b82e33d9e82a5fc564">00100</a> <a class="code" href="classVectorValue.php#a2199d222363f32b82e33d9e82a5fc564">VectorValue&lt;T&gt;::VectorValue</a> (<span class="keyword">const</span> T x,
<a name="l00101"></a>00101                              <span class="keyword">const</span> T y,
<a name="l00102"></a>00102                              <span class="keyword">const</span> T z) :
<a name="l00103"></a>00103   <a class="code" href="classTypeVector.php">TypeVector</a>&lt;T&gt; (x,y,z)
<a name="l00104"></a>00104 {
<a name="l00105"></a>00105 }
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00110"></a>00110 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00111"></a>00111 <span class="keyword">inline</span>
<a name="l00112"></a><a class="code" href="classVectorValue.php#a6bdb025179d766978c35b4a884a5db8f">00112</a> <a class="code" href="classVectorValue.php#a2199d222363f32b82e33d9e82a5fc564">VectorValue&lt;T&gt;::VectorValue</a> (<span class="keyword">const</span> <a class="code" href="classVectorValue.php">VectorValue&lt;T2&gt;</a>&amp; p) :
<a name="l00113"></a>00113   <a class="code" href="classTypeVector.php">TypeVector</a>&lt;T&gt; (p)
<a name="l00114"></a>00114 {
<a name="l00115"></a>00115 }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00120"></a>00120 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00121"></a>00121 <span class="keyword">inline</span>
<a name="l00122"></a><a class="code" href="classVectorValue.php#a30d36a864c1f3462711a74c108dd21f7">00122</a> <a class="code" href="classVectorValue.php#a2199d222363f32b82e33d9e82a5fc564">VectorValue&lt;T&gt;::VectorValue</a> (<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;T2&gt;</a>&amp; p) :
<a name="l00123"></a>00123   <a class="code" href="classTypeVector.php">TypeVector</a>&lt;T&gt; (p)
<a name="l00124"></a>00124 {
<a name="l00125"></a>00125 }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00129"></a>00129 <span class="preprocessor"></span><span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00130"></a>00130 <span class="keyword">inline</span>
<a name="l00131"></a><a class="code" href="classVectorValue.php#ad9ee238cc5433833d5e8badfc16eb009">00131</a> <a class="code" href="classVectorValue.php#a2199d222363f32b82e33d9e82a5fc564">VectorValue&lt;T&gt;::VectorValue</a> (<span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;Real&gt;</a>&amp; p_re,
<a name="l00132"></a>00132                              <span class="keyword">const</span> <a class="code" href="classTypeVector.php">TypeVector&lt;Real&gt;</a>&amp; p_im) :
<a name="l00133"></a>00133   <a class="code" href="classTypeVector.php">TypeVector</a>&lt;T&gt; (<a class="code" href="libmesh__common_8h.php#a400479783e355a94cc961fb30b81b31f">Complex</a> (p_re(0), p_im(0)),
<a name="l00134"></a>00134                  <a class="code" href="libmesh__common_8h.php#a400479783e355a94cc961fb30b81b31f">Complex</a> (p_re(1), p_im(1)),
<a name="l00135"></a>00135                  <a class="code" href="libmesh__common_8h.php#a400479783e355a94cc961fb30b81b31f">Complex</a> (p_re(2), p_im(2)))
<a name="l00136"></a>00136 {
<a name="l00137"></a>00137 }
<a name="l00138"></a>00138 <span class="preprocessor">#endif</span>
<a name="l00139"></a>00139 <span class="preprocessor"></span>
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 <span class="preprocessor">#endif // #define __vector_value_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
