<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>vtk_io.C</h1>  </div>
</div>
<div class="contents">
<a href="vtk__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: vtk_io.C 3407 2009-06-19 14:49:54Z jwpeterson $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;vtk_io.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;mesh.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;equation_systems.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;cell_tet4.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;cell_tet10.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;cell_prism6.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;cell_pyramid5.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;cell_hex8.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;cell_hex20.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;numeric_vector.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;system.h&quot;</span>
<a name="l00037"></a>00037 <span class="comment">//#include &quot;cell_inf.h&quot;</span>
<a name="l00038"></a>00038 <span class="comment">//#include &quot;cell_inf_prism12.h&quot;</span>
<a name="l00039"></a>00039 <span class="comment">//#include &quot;cell_prism6.h&quot;</span>
<a name="l00040"></a>00040 <span class="comment">//#include &quot;cell_tet4.h&quot;</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="comment">//#include &quot;cell_inf_hex16.h&quot;</span>
<a name="l00043"></a>00043 <span class="comment">//#include &quot;cell_inf_prism6.h&quot;</span>
<a name="l00044"></a>00044 <span class="comment">//#include &quot;cell_prism.h&quot;</span>
<a name="l00045"></a>00045 <span class="comment">//#include &quot;cell_tet.h&quot;</span>
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 <span class="comment">//#include &quot;cell_hex27.h&quot;</span>
<a name="l00048"></a>00048 <span class="comment">//#include &quot;cell_inf_hex18.h&quot;</span>
<a name="l00049"></a>00049 <span class="comment">//#include &quot;cell_inf_prism.h&quot;</span>
<a name="l00050"></a>00050 <span class="comment">//#include &quot;cell_pyramid5.h&quot;</span>
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 <span class="comment">//#include &quot;cell_hex8.h&quot;</span>
<a name="l00053"></a>00053 <span class="comment">//#include &quot;cell_inf_hex8.h&quot;</span>
<a name="l00054"></a>00054 <span class="comment">//#include &quot;cell_prism15.h&quot;</span>
<a name="l00055"></a>00055 <span class="comment">//#include &quot;cell_pyramid.h&quot;</span>
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 <span class="comment">//#include &quot;cell_hex.h&quot;</span>
<a name="l00058"></a>00058 <span class="comment">//#include &quot;cell_inf_hex.h&quot;</span>
<a name="l00059"></a>00059 <span class="comment">//#include &quot;cell_prism18.h&quot;</span>
<a name="l00060"></a>00060 <span class="comment">//#include &quot;cell_tet10.h&quot;</span>
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 <span class="preprocessor">#include &quot;mesh_data.h&quot;</span>
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 <span class="preprocessor">#ifdef LIBMESH_HAVE_VTK</span>
<a name="l00067"></a>00067 <span class="preprocessor"></span>
<a name="l00068"></a>00068 <span class="preprocessor">#include &quot;vtkXMLUnstructuredGridReader.h&quot;</span>
<a name="l00069"></a>00069 <span class="preprocessor">#include &quot;vtkXMLUnstructuredGridWriter.h&quot;</span>
<a name="l00070"></a>00070 <span class="preprocessor">#include &quot;vtkXMLPUnstructuredGridWriter.h&quot;</span>
<a name="l00071"></a>00071 <span class="preprocessor">#include &quot;vtkUnstructuredGrid.h&quot;</span>
<a name="l00072"></a>00072 <span class="preprocessor">#include &quot;vtkGenericGeometryFilter.h&quot;</span>
<a name="l00073"></a>00073 <span class="preprocessor">#include &quot;vtkCellArray.h&quot;</span>
<a name="l00074"></a>00074 <span class="preprocessor">#include &quot;vtkConfigure.h&quot;</span>
<a name="l00075"></a>00075 <span class="comment">/*</span>
<a name="l00076"></a>00076 <span class="comment">#include &quot;vtkTetra.h&quot;</span>
<a name="l00077"></a>00077 <span class="comment">#include &quot;vtkTriangle.h&quot;</span>
<a name="l00078"></a>00078 <span class="comment">#include &quot;vtkWedge.h&quot;</span>
<a name="l00079"></a>00079 <span class="comment">#include &quot;vtkPyramid.h&quot;</span>
<a name="l00080"></a>00080 <span class="comment">#include &quot;vtkQuad.h&quot;</span>
<a name="l00081"></a>00081 <span class="comment">#include &quot;vtkHexahedron.h&quot;</span>
<a name="l00082"></a>00082 <span class="comment">#include &quot;vtkQuadraticTriangle.h&quot;</span>
<a name="l00083"></a>00083 <span class="comment">#include &quot;vtkQuadraticQuad.h&quot;</span>
<a name="l00084"></a>00084 <span class="comment">#include &quot;vtkQuadraticHexahedron.h&quot;</span>
<a name="l00085"></a>00085 <span class="comment">#include &quot;vtkQuadraticWedge.h&quot;</span>
<a name="l00086"></a>00086 <span class="comment">#include &quot;vtkQuadraticTetra.h&quot;</span>
<a name="l00087"></a>00087 <span class="comment">#include &quot;vtkBiQuadraticQuad.h&quot;</span>
<a name="l00088"></a>00088 <span class="comment">*/</span>
<a name="l00089"></a>00089 <span class="preprocessor">#include &quot;vtkFloatArray.h&quot;</span>
<a name="l00090"></a>00090 <span class="preprocessor">#include &quot;vtkDoubleArray.h&quot;</span>
<a name="l00091"></a>00091 <span class="preprocessor">#include &quot;vtkPointData.h&quot;</span>
<a name="l00092"></a>00092 <span class="preprocessor">#include &quot;vtkPoints.h&quot;</span>
<a name="l00093"></a>00093 <span class="preprocessor">#endif //LIBMESH_HAVE_VTK</span>
<a name="l00094"></a>00094 <span class="preprocessor"></span>
<a name="l00095"></a>00095 <span class="comment">//static unsigned int vtk_tet4_mapping[4]= {0,1,2,3};</span>
<a name="l00096"></a>00096 <span class="comment">//static unsigned int vtk_pyramid5_mapping[5]= {0,3,2,1,4};</span>
<a name="l00097"></a>00097 <span class="comment">//static unsigned int vtk_wedge6_mapping[6]= {0,2,1,3,5,4};</span>
<a name="l00098"></a>00098 <span class="comment">//static unsigned int vtk_hex8_mapping[8]= {0,1,2,3,4,5,6,7};</span>
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 <span class="preprocessor">#ifdef LIBMESH_HAVE_VTK // private functions</span>
<a name="l00101"></a><a class="code" href="classVTKIO.php#a822857bc72efb86042257690a04a6598">00101</a> <span class="preprocessor"></span>vtkPoints* <a class="code" href="classVTKIO.php#a822857bc72efb86042257690a04a6598">VTKIO::nodes_to_vtk</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh){
<a name="l00102"></a>00102         <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00103"></a>00103                 {
<a name="l00104"></a>00104 
<a name="l00105"></a>00105                         vtkPoints* points = vtkPoints::New();
<a name="l00106"></a>00106                         vtkDoubleArray* pcoords = vtkDoubleArray::New();
<a name="l00107"></a>00107                         pcoords-&gt;SetNumberOfComponents(3);
<a name="l00108"></a>00108                         pcoords-&gt;SetNumberOfTuples(mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l00109"></a>00109 
<a name="l00110"></a>00110                         <span class="comment">// FIXME change to local iterators when I&#39;ve figured out how to write in parallel</span>
<a name="l00111"></a>00111                         <span class="comment">//  MeshBase::const_node_iterator nd = mesh.local_nodes_begin();</span>
<a name="l00112"></a>00112                         <span class="comment">//  MeshBase::const_node_iterator nd_end = mesh.local_nodes_end();</span>
<a name="l00113"></a>00113                         <span class="comment">//  points-&gt;SetNumberOfPoints(mesh.n_local_nodes()); // it seems that it needs this to prevent a segfault</span>
<a name="l00114"></a>00114                         <a class="code" href="structMeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> nd = mesh.<a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
<a name="l00115"></a>00115                         <a class="code" href="structMeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> nd_end = mesh.<a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
<a name="l00116"></a>00116                         <span class="comment">// write out nodal data</span>
<a name="l00117"></a>00117                         <span class="keywordflow">for</span> (;nd!=nd_end;++nd)
<a name="l00118"></a>00118                         {
<a name="l00119"></a>00119                                 <a class="code" href="classNode.php">Node</a>* node = (*nd);
<a name="l00120"></a>00120                                 <span class="keywordtype">float</span>* pnt = <span class="keyword">new</span> <span class="keywordtype">float</span>[3];
<a name="l00121"></a>00121                                 <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0;i&lt;3;++i){
<a name="l00122"></a>00122                                         pnt[i] = (*node)(i);
<a name="l00123"></a>00123                                 } 
<a name="l00124"></a>00124                                 <span class="comment">//     pcoords-&gt;InsertNextTuple(pnt);</span>
<a name="l00125"></a>00125                                 pcoords-&gt;SetTuple(node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>(),pnt);
<a name="l00126"></a>00126                                 <span class="comment">//     std::cout&lt;&lt;&quot;pnt &quot;&lt;&lt;pnt[0]&lt;&lt;&quot; &quot;&lt;&lt;pnt[1]&lt;&lt;&quot; &quot;&lt;&lt;pcoords-&gt;&lt;&lt;std::endl;  </span>
<a name="l00127"></a>00127                                 <span class="comment">//     points-&gt;InsertPoint(node-&gt;id(),pnt);</span>
<a name="l00128"></a>00128                                 <span class="comment">//     std::cout&lt;&lt;&quot;point &quot;&lt;&lt;node-&gt;id()&lt;&lt;&quot; &quot;&lt;&lt;(*node)(0)&lt;&lt;&quot; &quot;&lt;&lt;(*node)(1)&lt;&lt;std::endl;  </span>
<a name="l00129"></a>00129                                 <span class="keyword">delete</span> [] pnt;
<a name="l00130"></a>00130                         }
<a name="l00131"></a>00131                         points-&gt;SetData(pcoords);
<a name="l00132"></a>00132                         pcoords-&gt;Delete();
<a name="l00133"></a>00133                         <span class="keywordflow">return</span> points;
<a name="l00134"></a>00134         }
<a name="l00135"></a>00135         <span class="keywordflow">return</span> NULL;
<a name="l00136"></a>00136 }
<a name="l00137"></a>00137 
<a name="l00138"></a><a class="code" href="classVTKIO.php#a0a04e7c3c7e3c51270e932ff8e5db6d2">00138</a> vtkCellArray* <a class="code" href="classVTKIO.php#a0a04e7c3c7e3c51270e932ff8e5db6d2">VTKIO::cells_to_vtk</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh, <span class="keywordtype">int</span>*&amp; types){
<a name="l00139"></a>00139         <span class="comment">//, vtkUnstructuredGrid*&amp; grid){</span>
<a name="l00140"></a>00140         <span class="comment">//  MeshBase::const_element_iterator       it  = mesh.active_local_elements_begin();</span>
<a name="l00141"></a>00141         <span class="comment">//  const MeshBase::const_element_iterator end = mesh.active_local_elements_end(); </span>
<a name="l00142"></a>00142         <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00143"></a>00143         {
<a name="l00144"></a>00144 
<a name="l00145"></a>00145                 vtkCellArray* cells = vtkCellArray::New();
<a name="l00146"></a>00146                 <span class="comment">//     cells-&gt;Allocate(100000);</span>
<a name="l00147"></a>00147                 vtkIdList *pts = vtkIdList::New();
<a name="l00148"></a>00148 
<a name="l00149"></a>00149                 <span class="comment">// for some reason the iterator variant of this code throws an error</span>
<a name="l00150"></a>00150                 <span class="comment">//     MeshBase::const_element_iterator       it  = mesh.active_elements_begin();</span>
<a name="l00151"></a>00151                 <span class="comment">//     MeshBase::const_element_iterator end = mesh.active_elements_end(); </span>
<a name="l00152"></a>00152 
<a name="l00153"></a>00153                 <span class="comment">//     for ( ; it != end; ++it)</span>
<a name="l00154"></a>00154                 <span class="comment">//     {</span>
<a name="l00155"></a>00155                 <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> el_nr =0; el_nr&lt; mesh.<a class="code" href="classMeshBase.php#a246697678d5d14a986cee2b6fbdbae6b">n_active_elem</a>(); ++el_nr){
<a name="l00156"></a>00156                         <a class="code" href="classElem.php">Elem</a> *elem  = mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(el_nr);
<a name="l00157"></a>00157                         <span class="comment">//         if(elem-&gt;active()){ </span>
<a name="l00158"></a>00158                         <span class="comment">//       std::cout&lt;&lt;&quot;sub elem &quot;&lt;&lt;elem-&gt;has_children()&lt;&lt;std::endl;  </span>
<a name="l00159"></a>00159                         <span class="comment">//       (*it);</span>
<a name="l00160"></a>00160                         vtkIdType celltype = VTK_EMPTY_CELL; <span class="comment">// initialize to something to avoid compiler warning</span>
<a name="l00161"></a>00161 
<a name="l00162"></a>00162                         <span class="keywordflow">switch</span>(elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>())
<a name="l00163"></a>00163                         {
<a name="l00164"></a>00164                                 <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:                             
<a name="l00165"></a>00165                                         celltype = VTK_LINE;
<a name="l00166"></a>00166                                         <span class="keywordflow">break</span>;
<a name="l00167"></a>00167                                 <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:      
<a name="l00168"></a>00168                                         celltype = VTK_QUADRATIC_EDGE;
<a name="l00169"></a>00169                                         <span class="keywordflow">break</span>;<span class="comment">// 1</span>
<a name="l00170"></a>00170                                 <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:       
<a name="l00171"></a>00171                                         celltype = VTK_TRIANGLE;
<a name="l00172"></a>00172                                         <span class="keywordflow">break</span>;<span class="comment">// 3</span>
<a name="l00173"></a>00173                                 <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:       
<a name="l00174"></a>00174                                         celltype = VTK_QUADRATIC_TRIANGLE;
<a name="l00175"></a>00175                                         <span class="keywordflow">break</span>;<span class="comment">// 4</span>
<a name="l00176"></a>00176                                 <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:      
<a name="l00177"></a>00177                                         celltype = VTK_QUAD;
<a name="l00178"></a>00178                                         <span class="keywordflow">break</span>;<span class="comment">// 5</span>
<a name="l00179"></a>00179                                 <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:      
<a name="l00180"></a>00180                                         celltype = VTK_QUADRATIC_QUAD;
<a name="l00181"></a>00181                                         <span class="keywordflow">break</span>;<span class="comment">// 6</span>
<a name="l00182"></a>00182                                 <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:      
<a name="l00183"></a>00183                                         celltype = VTK_TETRA;
<a name="l00184"></a>00184                                         <span class="keywordflow">break</span>;<span class="comment">// 8</span>
<a name="l00185"></a>00185                                 <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:      
<a name="l00186"></a>00186                                         celltype = VTK_QUADRATIC_TETRA;
<a name="l00187"></a>00187                                         <span class="keywordflow">break</span>;<span class="comment">// 9</span>
<a name="l00188"></a>00188                                 <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:    
<a name="l00189"></a>00189                                         celltype = VTK_HEXAHEDRON;
<a name="l00190"></a>00190                                         <span class="keywordflow">break</span>;<span class="comment">// 10</span>
<a name="l00191"></a>00191                                 <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:      
<a name="l00192"></a>00192                                         celltype = VTK_QUADRATIC_HEXAHEDRON;
<a name="l00193"></a>00193                                         <span class="keywordflow">break</span>;<span class="comment">// 12</span>
<a name="l00194"></a>00194                                 <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:     
<a name="l00195"></a>00195                                         celltype = VTK_WEDGE;
<a name="l00196"></a>00196                                         <span class="keywordflow">break</span>;<span class="comment">// 13</span>
<a name="l00197"></a>00197                                 <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:   
<a name="l00198"></a>00198                                         celltype = VTK_HIGHER_ORDER_WEDGE;
<a name="l00199"></a>00199                                         <span class="keywordflow">break</span>;<span class="comment">// 14</span>
<a name="l00200"></a>00200                                 <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:    
<a name="l00201"></a>00201                                         <span class="keywordflow">break</span>;<span class="comment">// 15</span>
<a name="l00202"></a>00202                                 <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l00203"></a>00203                                         celltype = VTK_PYRAMID;
<a name="l00204"></a>00204                                         <span class="keywordflow">break</span>;<span class="comment">// 16</span>
<a name="l00205"></a>00205 <span class="preprocessor">#if VTK_MAJOR_VERSION &gt; 5 || (VTK_MAJOR_VERSION == 5 &amp;&amp; VTK_MINOR_VERSION &gt; 0)</span>
<a name="l00206"></a>00206 <span class="preprocessor"></span>                                <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:      
<a name="l00207"></a>00207                                         celltype = VTK_BIQUADRATIC_QUAD;
<a name="l00208"></a>00208                                         <span class="keywordflow">break</span>;
<a name="l00209"></a>00209 <span class="preprocessor">#else</span>
<a name="l00210"></a>00210 <span class="preprocessor"></span>                                <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00211"></a>00211 <span class="preprocessor">#endif </span>
<a name="l00212"></a>00212 <span class="preprocessor"></span>                                <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:      
<a name="l00213"></a>00213                                 <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:      
<a name="l00214"></a>00214                                 <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a278476b80069e0630827235779c82c47">INFEDGE2</a>:   
<a name="l00215"></a>00215                                 <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a23d0ae825ee3f493b6504b71f28e2aef">INFQUAD4</a>:   
<a name="l00216"></a>00216                                 <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a669ef57bb0d4c72fd22fa0f4febe6ac1">INFQUAD6</a>:   
<a name="l00217"></a>00217                                 <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a54cedbd05931dd2cb7dcabf0109bddcb">INFHEX8</a>:    
<a name="l00218"></a>00218                                 <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a583e72df1b20e339d9f8fcea6a94c1d4">INFHEX16</a>:   
<a name="l00219"></a>00219                                 <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4e68f53177cc7d1366225dfc8f7bbbed">INFHEX18</a>:   
<a name="l00220"></a>00220                                 <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac6743a9a04524105e37159e924c4a33b">INFPRISM6</a>:  
<a name="l00221"></a>00221                                 <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a89630f5af6a58aaa9ae731d924139c61">INFPRISM12</a>: 
<a name="l00222"></a>00222                                 <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:   
<a name="l00223"></a>00223                                 <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>:
<a name="l00224"></a>00224                                 <span class="keywordflow">default</span>:
<a name="l00225"></a>00225                                         {
<a name="l00226"></a>00226                                                 std::cerr&lt;&lt;<span class="stringliteral">&quot;element type &quot;</span>&lt;&lt;elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>()&lt;&lt;<span class="stringliteral">&quot; not implemented&quot;</span>&lt;&lt;std::endl;
<a name="l00227"></a>00227                                                 libmesh_error();
<a name="l00228"></a>00228                                         }
<a name="l00229"></a>00229                         }
<a name="l00230"></a>00230                         <span class="comment">//        std::cout&lt;&lt;&quot;elem &quot;&lt;&lt;elem-&gt;n_nodes()&lt;&lt;&quot; &quot;&lt;&lt;elem-&gt;n_sub_elem()&lt;&lt;std::endl;  </span>
<a name="l00231"></a>00231                         <span class="comment">//        std::cout&lt;&lt;&quot;type &quot;&lt;&lt;celltype&lt;&lt;&quot; &quot;&lt;&lt;VTK_BIQUADRATIC_QUAD&lt;&lt;std::endl;  </span>
<a name="l00232"></a>00232                         types[elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] = celltype;
<a name="l00233"></a>00233                         pts-&gt;SetNumberOfIds(elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>());
<a name="l00234"></a>00234                         <span class="comment">// get the connectivity for this element</span>
<a name="l00235"></a>00235                         std::vector&lt;unsigned int&gt; conn;
<a name="l00236"></a>00236                         elem-&gt;<a class="code" href="classElem.php#a7bef5c7f5ff5cc734c3d27c42da78ed9">connectivity</a>(0,<a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa1affb8987f83b5e4acb22d9401dd44ef">VTK</a>,conn);
<a name="l00237"></a>00237                         <span class="comment">//        std::cout&lt;&lt;&quot;conn size &quot;&lt;&lt;conn.size()&lt;&lt;std::endl;  </span>
<a name="l00238"></a>00238                         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0;i&lt;conn.size();++i)
<a name="l00239"></a>00239                         {
<a name="l00240"></a>00240                                 <span class="comment">//           std::cout&lt;&lt;&quot; sz &quot;&lt;&lt;pts-&gt;GetNumberOfIds()&lt;&lt;std::endl;  </span>
<a name="l00241"></a>00241                                 pts-&gt;InsertId(i,conn[i]);
<a name="l00242"></a>00242                         } 
<a name="l00243"></a>00243                         <span class="comment">//        std::cout&lt;&lt;&quot;set cell&quot;&lt;&lt;std::endl;  </span>
<a name="l00244"></a>00244                         cells-&gt;InsertNextCell(pts);
<a name="l00245"></a>00245                         <span class="comment">//         }</span>
<a name="l00246"></a>00246                         <span class="comment">//         std::cout&lt;&lt;&quot;finish set cell&quot;&lt;&lt;std::endl;  </span>
<a name="l00247"></a>00247                 } <span class="comment">// end loop over active elements</span>
<a name="l00248"></a>00248                 pts-&gt;Delete();
<a name="l00249"></a>00249 
<a name="l00250"></a>00250                 <span class="keywordflow">return</span> cells;
<a name="l00251"></a>00251         }
<a name="l00252"></a>00252         <span class="keywordflow">return</span> NULL;
<a name="l00253"></a>00253 }
<a name="l00254"></a>00254 
<a name="l00255"></a>00255 <span class="comment">/*</span>
<a name="l00256"></a>00256 <span class="comment"> * single processor implementation, this can be done in parallel, but requires a</span>
<a name="l00257"></a>00257 <span class="comment"> * bit more thinking on how to deal with overlapping local solution vectors</span>
<a name="l00258"></a>00258 <span class="comment"> */</span>
<a name="l00259"></a>00259 <span class="comment">/*</span>
<a name="l00260"></a>00260 <span class="comment">void VTKIO::solution_to_vtk(const EquationSystems&amp; es,vtkUnstructuredGrid*&amp; grid){</span>
<a name="l00261"></a>00261 <span class="comment">//   if (libMesh::processor_id() == 0)</span>
<a name="l00262"></a>00262 <span class="comment">//      {</span>
<a name="l00263"></a>00263 <span class="comment">//   std::vector&lt;Number&gt; soln;</span>
<a name="l00264"></a>00264 <span class="comment">//   std::cout&lt;&lt;&quot;build&quot;&lt;&lt;std::endl;  </span>
<a name="l00265"></a>00265 <span class="comment">//   es.build_solution_vector(soln);</span>
<a name="l00266"></a>00266 <span class="comment">//   std::cout&lt;&lt;&quot;add solution &quot;&lt;&lt;soln.size()&lt;&lt;std::endl;  </span>
<a name="l00267"></a>00267 <span class="comment"></span>
<a name="l00268"></a>00268 <span class="comment">        if(libMesh::processor_id()==0){</span>
<a name="l00269"></a>00269 <span class="comment">                const MeshBase&amp; mesh = (MeshBase&amp;)es.get_mesh();</span>
<a name="l00270"></a>00270 <span class="comment">                const unsigned int n_nodes = es.get_mesh().n_nodes();</span>
<a name="l00271"></a>00271 <span class="comment">                const unsigned int n_vars = es.n_vars();</span>
<a name="l00272"></a>00272 <span class="comment">                        // write the solutions belonging to the system</span>
<a name="l00273"></a>00273 <span class="comment">                        for(unsigned int i=0;i&lt;es.n_systems();++i){ // for all systems, regardless of whether they are active or not</span>
<a name="l00274"></a>00274 <span class="comment">                                for(unsigned int j=0;j&lt;n_vars;++j){</span>
<a name="l00275"></a>00275 <span class="comment">                                        const System&amp; sys = es.get_system(i);</span>
<a name="l00276"></a>00276 <span class="comment">                                        const std::string&amp; varname = sys.variable_name(j); </span>
<a name="l00277"></a>00277 <span class="comment">                                        vtkFloatArray *data = vtkFloatArray::New(); </span>
<a name="l00278"></a>00278 <span class="comment">                                        data-&gt;SetName(varname.c_str());</span>
<a name="l00279"></a>00279 <span class="comment">                                        data-&gt;SetNumberOfValues(n_nodes);</span>
<a name="l00280"></a>00280 <span class="comment">                                        MeshBase::const_node_iterator it = mesh.nodes_begin();</span>
<a name="l00281"></a>00281 <span class="comment">                                        const MeshBase::const_node_iterator n_end = mesh.nodes_end();</span>
<a name="l00282"></a>00282 <span class="comment">                                        for(;it!=n_end;++it){</span>
<a name="l00283"></a>00283 <span class="comment">                                                if((*it)-&gt;n_comp(i,j)&gt;0){</span>
<a name="l00284"></a>00284 <span class="comment">                                                        const unsigned int nd_id = (*it)-&gt;id();</span>
<a name="l00285"></a>00285 <span class="comment">        //                  const unsigned int dof_nr = (*it)-&gt;dof_number(i,j,0);</span>
<a name="l00286"></a>00286 <span class="comment">        //                  data-&gt;InsertValue((*it)-&gt;id(),sys.current_solution(count++));</span>
<a name="l00287"></a>00287 <span class="comment">                                                        data-&gt;InsertValue(nd_id,libmesh_real(13.0));</span>
<a name="l00288"></a>00288 <span class="comment">//                     soln[nd_id*n_vars+j]));</span>
<a name="l00289"></a>00289 <span class="comment">        //               data-&gt;InsertValue((*it)-&gt;id(),sys.current_solution(dof_nr));</span>
<a name="l00290"></a>00290 <span class="comment">                                                }else{</span>
<a name="l00291"></a>00291 <span class="comment">                                                        data-&gt;InsertValue((*it)-&gt;id(),0);</span>
<a name="l00292"></a>00292 <span class="comment">                                                }</span>
<a name="l00293"></a>00293 <span class="comment">                                        } </span>
<a name="l00294"></a>00294 <span class="comment">                                        grid-&gt;GetPointData()-&gt;AddArray(data);</span>
<a name="l00295"></a>00295 <span class="comment">                                } </span>
<a name="l00296"></a>00296 <span class="comment">                        } </span>
<a name="l00297"></a>00297 <span class="comment">   }</span>
<a name="l00298"></a>00298 <span class="comment">}*/</span>
<a name="l00299"></a>00299 
<a name="l00300"></a><a class="code" href="classVTKIO.php#ab63533eff3c5721345dbe75413dc127e">00300</a> <span class="keywordtype">void</span> <a class="code" href="classVTKIO.php#ab63533eff3c5721345dbe75413dc127e">VTKIO::solution_to_vtk</a>(<span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es, vtkUnstructuredGrid*&amp; grid){
<a name="l00301"></a>00301         <span class="comment">// write only single processor</span>
<a name="l00302"></a>00302         <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()==0){
<a name="l00303"></a>00303 
<a name="l00304"></a>00304                 <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = (<a class="code" href="classMeshBase.php">MeshBase</a>&amp;)es.<a class="code" href="classEquationSystems.php#ad8d458ae6a34c460e72b3279373d4a70">get_mesh</a>();
<a name="l00305"></a>00305 
<a name="l00306"></a>00306                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a> = es.<a class="code" href="classEquationSystems.php#ad8d458ae6a34c460e72b3279373d4a70">get_mesh</a>().<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>();
<a name="l00307"></a>00307                 <span class="comment">// loop over the systems</span>
<a name="l00308"></a>00308                 <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0;i&lt;es.<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>();++i){ <span class="comment">// for all systems, regardless of whether they are active or not</span>
<a name="l00309"></a>00309                         
<a name="l00310"></a>00310                         <span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; sys = es.<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(i);
<a name="l00311"></a>00311 
<a name="l00312"></a>00312                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_vars = sys.<a class="code" href="classSystem.php#a7a937f7acc89f6a7f37cbbcea24ca333">n_vars</a>();
<a name="l00313"></a>00313                         <span class="comment">// loop over variables</span>
<a name="l00314"></a>00314                         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0;j&lt;n_vars;++j){
<a name="l00315"></a>00315 
<a name="l00316"></a>00316                                 std::string <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a> = sys.<a class="code" href="classSystem.php#af3a38b172dd6322eff9f30b3f63d3b63">variable_name</a>(j);
<a name="l00317"></a>00317 
<a name="l00318"></a>00318                                 vtkFloatArray *data = vtkFloatArray::New(); 
<a name="l00319"></a>00319 
<a name="l00320"></a>00320                                 data-&gt;SetName(name.c_str());
<a name="l00321"></a>00321 
<a name="l00322"></a>00322                                 data-&gt;SetNumberOfValues(sys.<a class="code" href="classSystem.php#ad679ef41b83fdefc3fe649e99672a941">solution</a>-&gt;size());
<a name="l00323"></a>00323 
<a name="l00324"></a>00324                                 <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0;k&lt;<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>;++k){
<a name="l00325"></a>00325 
<a name="l00326"></a>00326                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dof_nr = mesh.<a class="code" href="classMeshBase.php#a298477f2d67d6a85f6c7fb5a640e2b64">node</a>(k).<a class="code" href="classDofObject.php#a7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(i,j,0);
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00329"></a>00329 <span class="preprocessor"></span>                                        data-&gt;SetValue(k,sys.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(dof_nr).real());
<a name="l00330"></a>00330 <span class="preprocessor">#else</span>
<a name="l00331"></a>00331 <span class="preprocessor"></span>                                        data-&gt;SetValue(k,sys.<a class="code" href="classSystem.php#a92fba5e188c9437be33fca84e7738447">current_solution</a>(dof_nr));
<a name="l00332"></a>00332 <span class="preprocessor">#endif</span>
<a name="l00333"></a>00333 <span class="preprocessor"></span>
<a name="l00334"></a>00334                                 } 
<a name="l00335"></a>00335                                 grid-&gt;GetPointData()-&gt;AddArray(data);
<a name="l00336"></a>00336                                 data-&gt;Delete();
<a name="l00337"></a>00337                         } 
<a name="l00338"></a>00338                         
<a name="l00339"></a>00339                 }
<a name="l00340"></a>00340         }
<a name="l00341"></a>00341 }
<a name="l00342"></a>00342 
<a name="l00343"></a>00343 <span class="comment">/*</span>
<a name="l00344"></a>00344 <span class="comment"> * FIXME now this is known to write nonsense on AMR meshes</span>
<a name="l00345"></a>00345 <span class="comment"> * and it strips the imaginary parts of complex Numbers</span>
<a name="l00346"></a>00346 <span class="comment"> */</span>
<a name="l00347"></a><a class="code" href="classVTKIO.php#a58c2b1148b9acdab1225d929b743c39e">00347</a> <span class="keywordtype">void</span> <a class="code" href="classVTKIO.php#a58c2b1148b9acdab1225d929b743c39e">VTKIO::system_vectors_to_vtk</a>(<span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,vtkUnstructuredGrid*&amp; grid){
<a name="l00348"></a>00348         <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0){
<a name="l00349"></a>00349 
<a name="l00350"></a>00350                 std::map&lt;std::string,std::vector&lt;Number&gt; &gt; vecs; 
<a name="l00351"></a>00351                 <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0;i&lt;es.<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>();++i){
<a name="l00352"></a>00352                         <span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; sys = es.<a class="code" href="classEquationSystems.php#a3c92d4131577abbad949ff850fa73203">get_system</a>(i);
<a name="l00353"></a>00353                         <a class="code" href="classSystem.php#a85440d8ff0086de5be93ae0922937d0c">System::const_vectors_iterator</a> v_end = sys.<a class="code" href="classSystem.php#a0c1c70cc7f560cda430474eea1702082">vectors_end</a>();
<a name="l00354"></a>00354                         <a class="code" href="classSystem.php#a85440d8ff0086de5be93ae0922937d0c">System::const_vectors_iterator</a> it = sys.<a class="code" href="classSystem.php#aa33cb0639b60f352561646fcce51a06b">vectors_begin</a>();
<a name="l00355"></a>00355                         <span class="keywordflow">for</span>(;it!= v_end;++it){ <span class="comment">// for all vectors on this system</span>
<a name="l00356"></a>00356                                 std::vector&lt;Number&gt; values;     
<a name="l00357"></a>00357                                 std::cout&lt;&lt;<span class="stringliteral">&quot;it &quot;</span>&lt;&lt;it-&gt;first&lt;&lt;std::endl;  
<a name="l00358"></a>00358 
<a name="l00359"></a>00359                                 it-&gt;second-&gt;localize_to_one(values,0);
<a name="l00360"></a>00360                                 std::cout&lt;&lt;<span class="stringliteral">&quot;finish localize&quot;</span>&lt;&lt;std::endl;  
<a name="l00361"></a>00361                                 vecs[it-&gt;first] = values;
<a name="l00362"></a>00362                         }
<a name="l00363"></a>00363                 }
<a name="l00364"></a>00364 
<a name="l00365"></a>00365 
<a name="l00366"></a>00366                 std::map&lt;std::string,std::vector&lt;Number&gt; &gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a> it = vecs.begin(); 
<a name="l00367"></a>00367 
<a name="l00368"></a>00368                 <span class="keywordflow">for</span>(;it!=vecs.end();++it){
<a name="l00369"></a>00369 
<a name="l00370"></a>00370                         vtkFloatArray *data = vtkFloatArray::New(); 
<a name="l00371"></a>00371 
<a name="l00372"></a>00372                         data-&gt;SetName(it-&gt;first.c_str());
<a name="l00373"></a>00373 
<a name="l00374"></a>00374                         libmesh_assert(it-&gt;second.size()==es.<a class="code" href="classEquationSystems.php#ad8d458ae6a34c460e72b3279373d4a70">get_mesh</a>().<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l00375"></a>00375 
<a name="l00376"></a>00376                         data-&gt;SetNumberOfValues(it-&gt;second.size());
<a name="l00377"></a>00377 
<a name="l00378"></a>00378                         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0;i&lt;it-&gt;second.size();++i){
<a name="l00379"></a>00379 
<a name="l00380"></a>00380 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00381"></a>00381 <span class="preprocessor"></span>                                data-&gt;SetValue(i,it-&gt;second[i].real());
<a name="l00382"></a>00382 <span class="preprocessor">#else</span>
<a name="l00383"></a>00383 <span class="preprocessor"></span>                                data-&gt;SetValue(i,it-&gt;second[i]);
<a name="l00384"></a>00384 <span class="preprocessor">#endif</span>
<a name="l00385"></a>00385 <span class="preprocessor"></span>
<a name="l00386"></a>00386                         }
<a name="l00387"></a>00387 
<a name="l00388"></a>00388                         grid-&gt;GetPointData()-&gt;AddArray(data);
<a name="l00389"></a>00389                         data-&gt;Delete();
<a name="l00390"></a>00390                 } 
<a name="l00391"></a>00391 
<a name="l00392"></a>00392         }
<a name="l00393"></a>00393 
<a name="l00394"></a>00394 <span class="comment">/*</span>
<a name="l00395"></a>00395 <span class="comment">        // write out the vectors added to the systems</span>
<a name="l00396"></a>00396 <span class="comment">        if (libMesh::processor_id() == 0)</span>
<a name="l00397"></a>00397 <span class="comment">                {</span>
<a name="l00398"></a>00398 <span class="comment">                        std::cout&lt;&lt;&quot;write system vectors&quot;&lt;&lt;std::endl;  </span>
<a name="l00399"></a>00399 <span class="comment">                const MeshBase&amp; mesh = (MeshBase&amp;)es.get_mesh();</span>
<a name="l00400"></a>00400 <span class="comment">                const unsigned int n_nodes = mesh.n_nodes();</span>
<a name="l00401"></a>00401 <span class="comment">                for(unsigned int i=0;i&lt;es.n_systems();++i){ // for all systems, regardless of whether they are active or not</span>
<a name="l00402"></a>00402 <span class="comment">                        const System&amp; sys = es.get_system(i);</span>
<a name="l00403"></a>00403 <span class="comment">                        std::cout&lt;&lt;&quot;i &quot;&lt;&lt;i&lt;&lt;std::endl;  </span>
<a name="l00404"></a>00404 <span class="comment">                        System::const_vectors_iterator v_end = sys.vectors_end();</span>
<a name="l00405"></a>00405 <span class="comment">                        System::const_vectors_iterator it = sys.vectors_begin();</span>
<a name="l00406"></a>00406 <span class="comment">                        for(;it!= v_end;++it){ // for all vectors on this system</span>
<a name="l00407"></a>00407 <span class="comment">                                std::cout&lt;&lt;&quot;it- &quot;&lt;&lt;it-&gt;second-&gt;size()&lt;&lt;&quot; &quot;&lt;&lt;n_nodes&lt;&lt;&quot; &quot;&lt;&lt;it-&gt;first&lt;&lt;std::endl;  </span>
<a name="l00408"></a>00408 <span class="comment">                                vtkFloatArray *data = vtkFloatArray::New(); </span>
<a name="l00409"></a>00409 <span class="comment">                                data-&gt;SetName(it-&gt;first.c_str());</span>
<a name="l00410"></a>00410 <span class="comment">                                std::vector&lt;Number&gt; values;     </span>
<a name="l00411"></a>00411 <span class="comment">                                it-&gt;second-&gt;localize(values);</span>
<a name="l00412"></a>00412 <span class="comment">                                data-&gt;SetNumberOfValues(n_nodes);</span>
<a name="l00413"></a>00413 <span class="comment"></span>
<a name="l00414"></a>00414 <span class="comment"></span>
<a name="l00415"></a>00415 <span class="comment">        //         MeshBase::const_node_iterator it = mesh.active_nodes_begin();</span>
<a name="l00416"></a>00416 <span class="comment">        //         const MeshBase::const_node_iterator n_end = mesh.nodes_end();</span>
<a name="l00417"></a>00417 <span class="comment">        //         for(unsigned int count=0;it!=n_end;++it,++count){                    </span>
<a name="l00418"></a>00418 <span class="comment">                                for(unsigned int j=0;j&lt;n_nodes;++j){</span>
<a name="l00419"></a>00419 <span class="comment">                                        std::cout&lt;&lt;&quot;j &quot;&lt;&lt;j&lt;&lt;&quot; &quot;&lt;&lt;(*it-&gt;second).size()&lt;&lt;std::endl;  </span>
<a name="l00420"></a>00420 <span class="comment">//               const unsigned int dof_nr = mesh.node(j).dof_number(i,0,0);</span>
<a name="l00421"></a>00421 <span class="comment">                                        data-&gt;SetValue(j,values[j]);</span>
<a name="l00422"></a>00422 <span class="comment">        //            it++;</span>
<a name="l00423"></a>00423 <span class="comment">                                } </span>
<a name="l00424"></a>00424 <span class="comment">                                grid-&gt;GetPointData()-&gt;AddArray(data);           </span>
<a name="l00425"></a>00425 <span class="comment">                        } </span>
<a name="l00426"></a>00426 <span class="comment">                } </span>
<a name="l00427"></a>00427 <span class="comment">        }*/</span>
<a name="l00428"></a>00428 }
<a name="l00429"></a>00429 
<a name="l00430"></a>00430 <span class="comment">/*</span>
<a name="l00431"></a>00431 <span class="comment">// write out mesh data to the VTK file, this might come in handy to display</span>
<a name="l00432"></a>00432 <span class="comment">// boundary conditions and material data</span>
<a name="l00433"></a>00433 <span class="comment">inline void meshdata_to_vtk(const MeshData&amp; meshdata,</span>
<a name="l00434"></a>00434 <span class="comment">                                                                                vtkUnstructuredGrid* grid){</span>
<a name="l00435"></a>00435 <span class="comment">        vtkPointData* pointdata = vtkPointData::New();</span>
<a name="l00436"></a>00436 <span class="comment">        </span>
<a name="l00437"></a>00437 <span class="comment">        const unsigned int n_vn = meshdata.n_val_per_node();</span>
<a name="l00438"></a>00438 <span class="comment">        const unsigned int n_dat = meshdata.n_node_data();</span>
<a name="l00439"></a>00439 <span class="comment"></span>
<a name="l00440"></a>00440 <span class="comment">        pointdata-&gt;SetNumberOfTuples(n_dat);</span>
<a name="l00441"></a>00441 <span class="comment">}*/</span>
<a name="l00442"></a>00442 
<a name="l00443"></a>00443 <span class="preprocessor">#endif</span>
<a name="l00444"></a>00444 <span class="preprocessor"></span>
<a name="l00445"></a>00445 
<a name="l00446"></a>00446 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00447"></a>00447 <span class="comment">// vtkIO class members</span>
<a name="l00448"></a>00448 <span class="comment">//</span>
<a name="l00449"></a><a class="code" href="classVTKIO.php#a1db43589e83b2c8e358bdb858e43651b">00449</a> <span class="keywordtype">void</span> <a class="code" href="classVTKIO.php#a1db43589e83b2c8e358bdb858e43651b">VTKIO::read</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00450"></a>00450 {
<a name="l00451"></a>00451   <span class="comment">// This is a serial-only process for now;</span>
<a name="l00452"></a>00452   <span class="comment">// the Mesh should be read on processor 0 and</span>
<a name="l00453"></a>00453   <span class="comment">// broadcast later</span>
<a name="l00454"></a>00454   libmesh_assert(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0);
<a name="l00455"></a>00455 
<a name="l00456"></a>00456 <span class="preprocessor">#ifndef LIBMESH_HAVE_VTK</span>
<a name="l00457"></a>00457 <span class="preprocessor"></span>  std::cerr &lt;&lt; <span class="stringliteral">&quot;Cannot read VTK file: &quot;</span> &lt;&lt; name
<a name="l00458"></a>00458             &lt;&lt; <span class="stringliteral">&quot;\nYou must have VTK installed and correctly configured to read VTK meshes.&quot;</span>
<a name="l00459"></a>00459             &lt;&lt; std::endl;
<a name="l00460"></a>00460   libmesh_error();
<a name="l00461"></a>00461 
<a name="l00462"></a>00462 <span class="preprocessor">#else</span>
<a name="l00463"></a>00463 <span class="preprocessor"></span><span class="comment">//  std::cout&lt;&lt;&quot;read &quot;&lt;&lt;name &lt;&lt;std::endl;  </span>
<a name="l00464"></a>00464   vtkXMLUnstructuredGridReader *reader = vtkXMLUnstructuredGridReader::New();
<a name="l00465"></a>00465   reader-&gt;SetFileName( name.c_str() );
<a name="l00466"></a>00466   <span class="comment">//std::cout&lt;&lt;&quot;force read&quot;&lt;&lt;std::endl;  </span>
<a name="l00467"></a>00467   <span class="comment">// Force reading</span>
<a name="l00468"></a>00468   reader-&gt;Update();
<a name="l00469"></a>00469 
<a name="l00470"></a>00470   <span class="comment">// read in the grid   </span>
<a name="l00471"></a>00471 <span class="comment">//  vtkUnstructuredGrid *grid = reader-&gt;GetOutput();</span>
<a name="l00472"></a>00472   <a class="code" href="classVTKIO.php#a9b06986ff2559eb7914239d45cdad677">_vtk_grid</a> = reader-&gt;GetOutput();
<a name="l00473"></a>00473   <a class="code" href="classVTKIO.php#a9b06986ff2559eb7914239d45cdad677">_vtk_grid</a>-&gt;Update();
<a name="l00474"></a>00474   reader-&gt;Delete();
<a name="l00475"></a>00475 
<a name="l00476"></a>00476   <span class="comment">// Get a reference to the mesh</span>
<a name="l00477"></a>00477   <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00478"></a>00478 
<a name="l00479"></a>00479   <span class="comment">// Clear out any pre-existing data from the Mesh</span>
<a name="l00480"></a>00480   mesh.<a class="code" href="classMeshBase.php#aefd56c4c29285d5e845f8869112b2b67">clear</a>();
<a name="l00481"></a>00481         
<a name="l00482"></a>00482   <span class="comment">// always numbered nicely??, so we can loop like this</span>
<a name="l00483"></a>00483   <span class="comment">// I&#39;m pretty sure it is numbered nicely</span>
<a name="l00484"></a>00484   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i &lt; static_cast&lt;unsigned int&gt;(<a class="code" href="classVTKIO.php#a9b06986ff2559eb7914239d45cdad677">_vtk_grid</a>-&gt;GetNumberOfPoints()); ++i)
<a name="l00485"></a>00485     {
<a name="l00486"></a>00486       <span class="comment">// add to the id map</span>
<a name="l00487"></a>00487       <span class="comment">// and add the actual point</span>
<a name="l00488"></a>00488       <span class="keywordtype">double</span> * pnt = <a class="code" href="classVTKIO.php#a9b06986ff2559eb7914239d45cdad677">_vtk_grid</a>-&gt;GetPoint(static_cast&lt;vtkIdType&gt;(i));
<a name="l00489"></a>00489       <a class="code" href="classPoint.php">Point</a> xyz(pnt[0],pnt[1],pnt[2]);
<a name="l00490"></a>00490       <a class="code" href="classNode.php">Node</a>* newnode = mesh.<a class="code" href="classMeshBase.php#a01b66468d3e9d8b5db82c6f3d9131f5e">add_point</a>(xyz,i);
<a name="l00491"></a>00491 
<a name="l00492"></a>00492       <span class="comment">// Add node to the nodes vector &amp;</span>
<a name="l00493"></a>00493       <span class="comment">// tell the MeshData object the foreign node id.</span>
<a name="l00494"></a>00494       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classVTKIO.php#a35f0823d8b42f17c7a5bea9893cc0e6a">_mesh_data</a> != NULL)
<a name="l00495"></a>00495         this-&gt;<a class="code" href="classVTKIO.php#a35f0823d8b42f17c7a5bea9893cc0e6a">_mesh_data</a>-&gt;<a class="code" href="classMeshData.php#af408db231805974db975dbdf3c1756f5">add_foreign_node_id</a> (newnode, i);
<a name="l00496"></a>00496     }
<a name="l00497"></a>00497         
<a name="l00498"></a>00498   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i &lt; static_cast&lt;unsigned int&gt;(<a class="code" href="classVTKIO.php#a9b06986ff2559eb7914239d45cdad677">_vtk_grid</a>-&gt;GetNumberOfCells()); ++i)
<a name="l00499"></a>00499     {
<a name="l00500"></a>00500       vtkCell* cell = <a class="code" href="classVTKIO.php#a9b06986ff2559eb7914239d45cdad677">_vtk_grid</a>-&gt;GetCell(i);
<a name="l00501"></a>00501       <a class="code" href="classElem.php">Elem</a>* elem = NULL;  <span class="comment">// Initialize to avoid compiler warning</span>
<a name="l00502"></a>00502       <span class="keywordflow">switch</span>(cell-&gt;GetCellType())
<a name="l00503"></a>00503         {
<a name="l00504"></a>00504         <span class="keywordflow">case</span> VTK_TETRA:
<a name="l00505"></a>00505           elem = <span class="keyword">new</span> <a class="code" href="classTet4.php">Tet4</a>();
<a name="l00506"></a>00506           <span class="keywordflow">break</span>;
<a name="l00507"></a>00507         <span class="keywordflow">case</span> VTK_WEDGE:
<a name="l00508"></a>00508           elem = <span class="keyword">new</span> <a class="code" href="classPrism6.php">Prism6</a>();
<a name="l00509"></a>00509           <span class="keywordflow">break</span>;
<a name="l00510"></a>00510         <span class="keywordflow">case</span> VTK_HEXAHEDRON:
<a name="l00511"></a>00511           elem = <span class="keyword">new</span> <a class="code" href="classHex8.php">Hex8</a>();
<a name="l00512"></a>00512           <span class="keywordflow">break</span>;
<a name="l00513"></a>00513         <span class="keywordflow">case</span> VTK_PYRAMID:       
<a name="l00514"></a>00514           elem = <span class="keyword">new</span> <a class="code" href="classPyramid5.php">Pyramid5</a>();                                        
<a name="l00515"></a>00515           <span class="keywordflow">break</span>;
<a name="l00516"></a>00516         <span class="keywordflow">case</span> VTK_QUADRATIC_HEXAHEDRON:
<a name="l00517"></a>00517           elem = <span class="keyword">new</span> <a class="code" href="classHex20.php">Hex20</a>();
<a name="l00518"></a>00518           <span class="keywordflow">break</span>;
<a name="l00519"></a>00519         <span class="keywordflow">case</span> VTK_QUADRATIC_TETRA:
<a name="l00520"></a>00520           elem = <span class="keyword">new</span> <a class="code" href="classTet10.php">Tet10</a>();
<a name="l00521"></a>00521           <span class="keywordflow">break</span>;
<a name="l00522"></a>00522         <span class="keywordflow">default</span>:
<a name="l00523"></a>00523           std::cerr &lt;&lt; <span class="stringliteral">&quot;element type not implemented in vtkinterface &quot;</span> &lt;&lt; cell-&gt;GetCellType() &lt;&lt; std::endl;
<a name="l00524"></a>00524           libmesh_error();
<a name="l00525"></a>00525         }
<a name="l00526"></a>00526 
<a name="l00527"></a>00527   <span class="comment">// get the straightforward numbering from the VTK cells</span>
<a name="l00528"></a>00528   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0;j&lt;elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>();++j){
<a name="l00529"></a>00529           elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(j) = mesh.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(cell-&gt;GetPointId(j));
<a name="l00530"></a>00530   } 
<a name="l00531"></a>00531   <span class="comment">// then get the connectivity </span>
<a name="l00532"></a>00532   std::vector&lt;unsigned int&gt; conn;
<a name="l00533"></a>00533   elem-&gt;<a class="code" href="classElem.php#a7bef5c7f5ff5cc734c3d27c42da78ed9">connectivity</a>(0,<a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa1affb8987f83b5e4acb22d9401dd44ef">VTK</a>,conn);
<a name="l00534"></a>00534   <span class="comment">// then reshuffle the nodes according to the connectivity, this</span>
<a name="l00535"></a>00535   <span class="comment">// two-time-assign would evade the definition of the vtk_mapping</span>
<a name="l00536"></a>00536   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0;j&lt;conn.size();++j){
<a name="l00537"></a>00537           elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(j) = mesh.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(conn[j]);
<a name="l00538"></a>00538   } 
<a name="l00539"></a>00539   elem-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a>(i);
<a name="l00540"></a>00540   mesh.<a class="code" href="classMeshBase.php#a0f6974cf3e413cfe9caa1fcb4ce8153e">add_elem</a>(elem);
<a name="l00541"></a>00541   } <span class="comment">// end loop over VTK cells</span>
<a name="l00542"></a>00542   <a class="code" href="classVTKIO.php#a9b06986ff2559eb7914239d45cdad677">_vtk_grid</a>-&gt;Delete();
<a name="l00543"></a>00543 <span class="preprocessor">#endif // LIBMESH_HAVE_VTK</span>
<a name="l00544"></a>00544 <span class="preprocessor"></span>}
<a name="l00545"></a>00545 
<a name="l00546"></a>00546 <span class="comment">/*</span>
<a name="l00547"></a>00547 <span class="comment"> * FIXME this operates on the mesh it &quot;gets&quot; from the ES only, this would</span>
<a name="l00548"></a>00548 <span class="comment"> * prevent passing in a mesh that doesn&#39;t belong to the ES</span>
<a name="l00549"></a>00549 <span class="comment"> */</span>
<a name="l00554"></a><a class="code" href="classVTKIO.php#aad1651ac3d6b53bd48923e30dd50f243">00554</a> <span class="keywordtype">void</span> <a class="code" href="classVTKIO.php#aad1651ac3d6b53bd48923e30dd50f243">VTKIO::write_equation_systems</a>(<span class="keyword">const</span> std::string&amp; fname, <span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es)
<a name="l00555"></a>00555 {
<a name="l00556"></a>00556 <span class="preprocessor">#ifndef LIBMESH_HAVE_VTK</span>
<a name="l00557"></a>00557 <span class="preprocessor"></span>
<a name="l00558"></a>00558   <span class="comment">// Do something with the es to avoid a compiler warning.</span>
<a name="l00559"></a>00559   es.<a class="code" href="classEquationSystems.php#ab407d67f99c50b1d0a35fd8952d9847c">n_systems</a>();
<a name="l00560"></a>00560   
<a name="l00561"></a>00561   std::cerr &lt;&lt; <span class="stringliteral">&quot;Cannot write VTK file: &quot;</span> &lt;&lt; fname
<a name="l00562"></a>00562             &lt;&lt; <span class="stringliteral">&quot;\nYou must have VTK installed and correctly configured to read VTK meshes.&quot;</span>
<a name="l00563"></a>00563             &lt;&lt; std::endl;
<a name="l00564"></a>00564   libmesh_error();
<a name="l00565"></a>00565   
<a name="l00566"></a>00566 <span class="preprocessor">#else</span>
<a name="l00567"></a>00567 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00568"></a>00568                 {
<a name="l00569"></a>00569 
<a name="l00570"></a>00570           <span class="comment">// check if the filename extension is pvtu</span>
<a name="l00571"></a>00571           libmesh_assert(fname.substr(fname.rfind(<span class="stringliteral">&quot;.&quot;</span>),fname.size())==<span class="stringliteral">&quot;.pvtu&quot;</span>);
<a name="l00572"></a>00572           <span class="comment">/*</span>
<a name="l00573"></a>00573 <span class="comment">                * we only use Unstructured grids</span>
<a name="l00574"></a>00574 <span class="comment">                */</span>
<a name="l00575"></a>00575           <a class="code" href="classVTKIO.php#a9b06986ff2559eb7914239d45cdad677">_vtk_grid</a> = vtkUnstructuredGrid::New();
<a name="l00576"></a>00576           vtkXMLPUnstructuredGridWriter* writer= vtkXMLPUnstructuredGridWriter::New();
<a name="l00577"></a>00577           std::cout&lt;&lt;<span class="stringliteral">&quot;get points &quot;</span>&lt;&lt;std::endl;  
<a name="l00578"></a>00578           vtkPoints* pnts = <a class="code" href="classVTKIO.php#a822857bc72efb86042257690a04a6598">nodes_to_vtk</a>((<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp;)es.<a class="code" href="classEquationSystems.php#ad8d458ae6a34c460e72b3279373d4a70">get_mesh</a>());
<a name="l00579"></a>00579           <a class="code" href="classVTKIO.php#a9b06986ff2559eb7914239d45cdad677">_vtk_grid</a>-&gt;SetPoints(pnts);
<a name="l00580"></a>00580          
<a name="l00581"></a>00581           <span class="keywordtype">int</span> * types = <span class="keyword">new</span> <span class="keywordtype">int</span>[es.<a class="code" href="classEquationSystems.php#ad8d458ae6a34c460e72b3279373d4a70">get_mesh</a>().<a class="code" href="classMeshBase.php#a246697678d5d14a986cee2b6fbdbae6b">n_active_elem</a>()];
<a name="l00582"></a>00582           std::cout&lt;&lt;<span class="stringliteral">&quot;get cells&quot;</span>&lt;&lt;std::endl;  
<a name="l00583"></a>00583           vtkCellArray* cells = <a class="code" href="classVTKIO.php#a0a04e7c3c7e3c51270e932ff8e5db6d2">cells_to_vtk</a>((<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp;)es.<a class="code" href="classEquationSystems.php#ad8d458ae6a34c460e72b3279373d4a70">get_mesh</a>(), types);
<a name="l00584"></a>00584 
<a name="l00585"></a>00585           std::cout&lt;&lt;<span class="stringliteral">&quot;set cells&quot;</span>&lt;&lt;std::endl;  
<a name="l00586"></a>00586           <a class="code" href="classVTKIO.php#a9b06986ff2559eb7914239d45cdad677">_vtk_grid</a>-&gt;SetCells(types,cells);
<a name="l00587"></a>00587           
<a name="l00588"></a>00588           <span class="comment">// I&#39;d like to write out meshdata, but this requires some coding, in</span>
<a name="l00589"></a>00589           <span class="comment">// particular, non_const meshdata iterators</span>
<a name="l00590"></a>00590           <span class="comment">//   const MeshData&amp; md = es.get_mesh_data();</span>
<a name="l00591"></a>00591           <span class="comment">//   if(es.has_mesh_data())</span>
<a name="l00592"></a>00592           <span class="comment">//      meshdata_to_vtk(md,_vtk_grid);</span>
<a name="l00593"></a>00593           <span class="comment">//   libmesh_assert (soln.size() ==mesh.n_nodes()*names.size());</span>
<a name="l00594"></a>00594           std::cout&lt;&lt;<span class="stringliteral">&quot;write solution&quot;</span>&lt;&lt;std::endl;  
<a name="l00595"></a>00595           <a class="code" href="classVTKIO.php#ab63533eff3c5721345dbe75413dc127e">solution_to_vtk</a>(es,<a class="code" href="classVTKIO.php#a9b06986ff2559eb7914239d45cdad677">_vtk_grid</a>);
<a name="l00596"></a>00596 
<a name="l00597"></a>00597 <span class="comment">//#ifdef DEBUG</span>
<a name="l00598"></a>00598 <span class="comment">//     if(true) // add some condition here, although maybe it is more sensible to give each vector a flag on whether it is to be written out or not</span>
<a name="l00599"></a>00599 <span class="comment">//       system_vectors_to_vtk(es,_vtk_grid);</span>
<a name="l00600"></a>00600 <span class="comment">//#endif</span>
<a name="l00601"></a>00601           writer-&gt;SetInput(<a class="code" href="classVTKIO.php#a9b06986ff2559eb7914239d45cdad677">_vtk_grid</a>);
<a name="l00602"></a>00602           writer-&gt;SetFileName(fname.c_str());
<a name="l00603"></a>00603           writer-&gt;SetDataModeToAscii();
<a name="l00604"></a>00604           writer-&gt;Write();
<a name="l00605"></a>00605 
<a name="l00606"></a>00606           <span class="keyword">delete</span> [] types;
<a name="l00607"></a>00607           pnts-&gt;Delete();
<a name="l00608"></a>00608           cells-&gt;Delete();
<a name="l00609"></a>00609           <a class="code" href="classVTKIO.php#a9b06986ff2559eb7914239d45cdad677">_vtk_grid</a>-&gt;Delete();
<a name="l00610"></a>00610           writer-&gt;Delete();
<a name="l00611"></a>00611         }
<a name="l00612"></a>00612 <span class="preprocessor">#endif</span>
<a name="l00613"></a>00613 <span class="preprocessor"></span>}
<a name="l00614"></a>00614 
<a name="l00619"></a><a class="code" href="classVTKIO.php#ae6bc5c06157bb86a7500c455254b1e00">00619</a> <span class="keywordtype">void</span> <a class="code" href="classVTKIO.php#ae6bc5c06157bb86a7500c455254b1e00">VTKIO::write</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00620"></a>00620 {       
<a name="l00621"></a>00621 <span class="preprocessor">#ifndef LIBMESH_HAVE_VTK</span>
<a name="l00622"></a>00622 <span class="preprocessor"></span>  std::cerr &lt;&lt; <span class="stringliteral">&quot;Cannot write VTK file: &quot;</span> &lt;&lt; name
<a name="l00623"></a>00623             &lt;&lt; <span class="stringliteral">&quot;\nYou must have VTK installed and correctly configured to write VTK meshes.&quot;</span>
<a name="l00624"></a>00624             &lt;&lt; std::endl;
<a name="l00625"></a>00625   libmesh_error();
<a name="l00626"></a>00626 
<a name="l00627"></a>00627 <span class="preprocessor">#else</span>
<a name="l00628"></a>00628 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00629"></a>00629   {
<a name="l00630"></a>00630 
<a name="l00631"></a>00631           <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00632"></a>00632           <a class="code" href="classVTKIO.php#a9b06986ff2559eb7914239d45cdad677">_vtk_grid</a> = vtkUnstructuredGrid::New();
<a name="l00633"></a>00633           vtkXMLUnstructuredGridWriter* writer = vtkXMLUnstructuredGridWriter::New();
<a name="l00634"></a>00634           std::cout&lt;&lt;<span class="stringliteral">&quot;write nodes &quot;</span>&lt;&lt;std::endl;  
<a name="l00635"></a>00635           vtkPoints* pnts = <a class="code" href="classVTKIO.php#a822857bc72efb86042257690a04a6598">nodes_to_vtk</a>(mesh);
<a name="l00636"></a>00636           <a class="code" href="classVTKIO.php#a9b06986ff2559eb7914239d45cdad677">_vtk_grid</a>-&gt;SetPoints(pnts);
<a name="l00637"></a>00637 
<a name="l00638"></a>00638           std::cout&lt;&lt;<span class="stringliteral">&quot;write elements &quot;</span>&lt;&lt;std::endl;  
<a name="l00639"></a>00639           <span class="keywordtype">int</span> * types = <span class="keyword">new</span> <span class="keywordtype">int</span>[mesh.<a class="code" href="classMeshBase.php#a246697678d5d14a986cee2b6fbdbae6b">n_active_elem</a>()];
<a name="l00640"></a>00640           vtkCellArray* cells = <a class="code" href="classVTKIO.php#a0a04e7c3c7e3c51270e932ff8e5db6d2">cells_to_vtk</a>(mesh,types);
<a name="l00641"></a>00641           <a class="code" href="classVTKIO.php#a9b06986ff2559eb7914239d45cdad677">_vtk_grid</a>-&gt;SetCells(types,cells);
<a name="l00642"></a>00642           <span class="comment">//  , _vtk_grid);</span>
<a name="l00643"></a>00643           writer-&gt;SetInput(<a class="code" href="classVTKIO.php#a9b06986ff2559eb7914239d45cdad677">_vtk_grid</a>);
<a name="l00644"></a>00644           writer-&gt;SetDataModeToAscii();
<a name="l00645"></a>00645           writer-&gt;SetFileName(name.c_str());
<a name="l00646"></a>00646           writer-&gt;Write();
<a name="l00647"></a>00647           writer-&gt;Delete();
<a name="l00648"></a>00648           <a class="code" href="classVTKIO.php#a9b06986ff2559eb7914239d45cdad677">_vtk_grid</a>-&gt;Delete();
<a name="l00649"></a>00649   }
<a name="l00650"></a>00650 <span class="preprocessor">#endif // LIBMESH_HAVE_VTK</span>
<a name="l00651"></a>00651 <span class="preprocessor"></span>}
<a name="l00652"></a>00652 
<a name="l00653"></a>00653 <span class="comment">//  vim: sw=3 ts=3  </span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
