<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>vtk_io.h</h1>  </div>
</div>
<div class="contents">
<a href="vtk__io_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: vtk_io.h 3502 2009-10-20 18:06:50Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __vtk_io_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __vtk_io_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// C++ includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="mesh__input_8h.php">mesh_input.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="mesh__output_8h.php">mesh_output.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Forward declarations</span>
<a name="l00034"></a>00034 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00035"></a>00035 <span class="keyword">class </span><a class="code" href="classMeshData.php">MeshData</a>;
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">class </span>vtkUnstructuredGrid;
<a name="l00038"></a>00038 <span class="keyword">class </span>vtkPoints;
<a name="l00039"></a>00039 <span class="keyword">class </span>vtkCellArray;
<a name="l00040"></a>00040 
<a name="l00053"></a>00053 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00054"></a>00054 <span class="comment">// VTKIO class definition</span>
<a name="l00055"></a><a class="code" href="classVTKIO.php">00055</a> <span class="keyword">class </span><a class="code" href="classVTKIO.php">VTKIO</a> : <span class="keyword">public</span> <a class="code" href="classMeshInput.php">MeshInput</a>&lt;MeshBase&gt;,
<a name="l00056"></a>00056               <span class="keyword">public</span> <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;MeshBase&gt;
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058 <span class="keyword">public</span>:
<a name="l00063"></a>00063   <a class="code" href="classVTKIO.php#ab7e5191943dda86605584ffce2a51575">VTKIO</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a>, <a class="code" href="classMeshData.php">MeshData</a>* mesh_data=NULL);
<a name="l00064"></a>00064 
<a name="l00069"></a>00069   <a class="code" href="classVTKIO.php#ab7e5191943dda86605584ffce2a51575">VTKIO</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh, <a class="code" href="classMeshData.php">MeshData</a>* mesh_data=NULL);
<a name="l00070"></a>00070 
<a name="l00075"></a>00075 <span class="comment">//  virtual void write_nodal_data (const std::string&amp;,</span>
<a name="l00076"></a>00076 <span class="comment">//             const std::vector&lt;Number&gt;&amp;,</span>
<a name="l00077"></a>00077 <span class="comment">//             const std::vector&lt;std::string&gt;&amp;);</span>
<a name="l00078"></a>00078 
<a name="l00084"></a>00084   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classVTKIO.php#aad1651ac3d6b53bd48923e30dd50f243">write_equation_systems</a>(<span class="keyword">const</span> std::string&amp; fname, <span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es); 
<a name="l00085"></a>00085 
<a name="l00090"></a>00090   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classVTKIO.php#a1db43589e83b2c8e358bdb858e43651b">read</a> (<span class="keyword">const</span> std::string&amp; );
<a name="l00091"></a>00091 
<a name="l00096"></a>00096   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classVTKIO.php#ae6bc5c06157bb86a7500c455254b1e00">write</a> (<span class="keyword">const</span> std::string&amp; );  
<a name="l00097"></a>00097 
<a name="l00101"></a><a class="code" href="classVTKIO.php#af3dfed122018ac105ca7f62127285c06">00101</a>    vtkUnstructuredGrid* <a class="code" href="classVTKIO.php#af3dfed122018ac105ca7f62127285c06">get_vtk_grid</a>(){<span class="keywordflow">return</span> <a class="code" href="classVTKIO.php#a9b06986ff2559eb7914239d45cdad677">_vtk_grid</a>;}
<a name="l00102"></a>00102         
<a name="l00103"></a>00103 <span class="keyword">private</span>:
<a name="l00104"></a>00104 
<a name="l00108"></a>00108   vtkPoints* <a class="code" href="classVTKIO.php#a822857bc72efb86042257690a04a6598">nodes_to_vtk</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00109"></a>00109 <span class="comment">//  , vtkUnstructuredGrid*&amp; grid);</span>
<a name="l00110"></a>00110 
<a name="l00114"></a>00114   vtkCellArray* <a class="code" href="classVTKIO.php#a0a04e7c3c7e3c51270e932ff8e5db6d2">cells_to_vtk</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh, <span class="keywordtype">int</span>*&amp; types);
<a name="l00115"></a>00115 <span class="comment">//  , vtkUnstructuredGrid*&amp; grid);</span>
<a name="l00116"></a>00116 
<a name="l00120"></a>00120   <span class="keywordtype">void</span> <a class="code" href="classVTKIO.php#ab63533eff3c5721345dbe75413dc127e">solution_to_vtk</a>(<span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,vtkUnstructuredGrid*&amp; grid);
<a name="l00121"></a>00121 
<a name="l00125"></a>00125   <span class="keywordtype">void</span> <a class="code" href="classVTKIO.php#a58c2b1148b9acdab1225d929b743c39e">system_vectors_to_vtk</a>(<span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,vtkUnstructuredGrid*&amp; grid);
<a name="l00126"></a>00126 
<a name="l00130"></a><a class="code" href="classVTKIO.php#a9b06986ff2559eb7914239d45cdad677">00130</a>    vtkUnstructuredGrid* <a class="code" href="classVTKIO.php#a9b06986ff2559eb7914239d45cdad677">_vtk_grid</a>;
<a name="l00131"></a>00131   
<a name="l00136"></a><a class="code" href="classVTKIO.php#a35f0823d8b42f17c7a5bea9893cc0e6a">00136</a>   <a class="code" href="classMeshData.php">MeshData</a>* <a class="code" href="classVTKIO.php#a35f0823d8b42f17c7a5bea9893cc0e6a">_mesh_data</a>;
<a name="l00137"></a>00137 };
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00142"></a>00142 <span class="comment">// VTKIO inline members</span>
<a name="l00143"></a>00143 <span class="keyword">inline</span>
<a name="l00144"></a><a class="code" href="classVTKIO.php#ab7e5191943dda86605584ffce2a51575">00144</a> <a class="code" href="classVTKIO.php#ab7e5191943dda86605584ffce2a51575">VTKIO::VTKIO</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh, <a class="code" href="classMeshData.php">MeshData</a>* mesh_data) :
<a name="l00145"></a>00145         <a class="code" href="classMeshInput.php">MeshInput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt; (mesh),
<a name="l00146"></a>00146         <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt;(mesh),
<a name="l00147"></a>00147         _mesh_data(mesh_data)
<a name="l00148"></a>00148 {
<a name="l00149"></a>00149   <a class="code" href="classVTKIO.php#a9b06986ff2559eb7914239d45cdad677">_vtk_grid</a> = NULL;     
<a name="l00150"></a>00150   libmesh_experimental();
<a name="l00151"></a>00151 }
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 <span class="keyword">inline</span>
<a name="l00156"></a><a class="code" href="classVTKIO.php#adaddc5312cdbb966ef8c260936f6b686">00156</a> <a class="code" href="classVTKIO.php#ab7e5191943dda86605584ffce2a51575">VTKIO::VTKIO</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh, <a class="code" href="classMeshData.php">MeshData</a>* mesh_data) :
<a name="l00157"></a>00157         <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt;(mesh),
<a name="l00158"></a>00158         _mesh_data(mesh_data)
<a name="l00159"></a>00159 {
<a name="l00160"></a>00160   <a class="code" href="classVTKIO.php#a9b06986ff2559eb7914239d45cdad677">_vtk_grid</a> = NULL;     
<a name="l00161"></a>00161   libmesh_experimental();
<a name="l00162"></a>00162 }
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 <span class="preprocessor">#endif // #define __vtk_io_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
