<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_4f64d75cac7489d141591c33108e86ff.php">utils</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>xdr_cxx.h</h1>  </div>
</div>
<div class="contents">
<a href="xdr__cxx_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: xdr_cxx.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __xdr_cxx_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __xdr_cxx_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;libmesh.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;enum_xdr_mode.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;auto_ptr.h&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// C++ includes</span>
<a name="l00032"></a>00032 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span><span class="preprocessor">#  include &lt;rpc/rpc.h&gt;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#endif</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &lt;iosfwd&gt;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span><span class="preprocessor"># include &lt;complex&gt;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#endif</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span>
<a name="l00043"></a>00043 <span class="preprocessor">#define xdr_MAX_STRING_LENGTH 256</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span>
<a name="l00045"></a>00045 <span class="preprocessor">#ifndef SINGLE_PRECISION</span>
<a name="l00046"></a>00046 <span class="preprocessor"></span><span class="preprocessor">#define xdr_REAL xdr_double</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span><span class="preprocessor">#define xdr_REAL xdr_float</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span>
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 <span class="comment">//--------------------------------------------------------------</span>
<a name="l00054"></a>00054 <span class="comment">// Xdr class definition</span>
<a name="l00055"></a>00055 
<a name="l00064"></a><a class="code" href="classXdr.php">00064</a> <span class="keyword">class </span><a class="code" href="classXdr.php">Xdr</a>
<a name="l00065"></a>00065 {
<a name="l00066"></a>00066   
<a name="l00067"></a>00067 <span class="keyword">public</span>:
<a name="l00068"></a>00068 
<a name="l00073"></a>00073   <a class="code" href="classXdr.php#a71201e933ce19bbd66d1f1cdc7ba0a48">Xdr</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>=<span class="stringliteral">&quot;&quot;</span>, <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">libMeshEnums::XdrMODE</a> m=<a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a9e4c21571990496ef66e6212465b5760">UNKNOWN</a>);
<a name="l00074"></a>00074 
<a name="l00078"></a>00078   <a class="code" href="classXdr.php#a67fc8bd3cd8a85b04e43655a60dffdec">~Xdr</a> ();
<a name="l00079"></a>00079 
<a name="l00083"></a>00083   <span class="keywordtype">void</span> <a class="code" href="classXdr.php#ac8622354e4d5395d4c777fb4062dc334">open</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>);
<a name="l00084"></a>00084 
<a name="l00088"></a>00088   <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a68dc02dd44f5f69b76813967d1d611cf">close</a>();
<a name="l00089"></a>00089 
<a name="l00094"></a>00094   <span class="keywordtype">bool</span> <a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>() <span class="keyword">const</span>;
<a name="l00095"></a>00095 
<a name="l00100"></a><a class="code" href="classXdr.php#a7092df3f10040c5a39a14385cc4888af">00100</a>   <span class="keywordtype">bool</span> <a class="code" href="classXdr.php#a7092df3f10040c5a39a14385cc4888af">reading</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> ((<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a> == <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>) || (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a> == <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>)); }
<a name="l00101"></a>00101 
<a name="l00106"></a><a class="code" href="classXdr.php#a697f12c5036ad61caae2ef98b6a480f1">00106</a>   <span class="keywordtype">bool</span> <a class="code" href="classXdr.php#a697f12c5036ad61caae2ef98b6a480f1">writing</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> ((<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a> == <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>) || (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a> == <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>)); }
<a name="l00107"></a>00107 
<a name="l00112"></a><a class="code" href="classXdr.php#a64db0524f8d88622b617146b99f23f3a">00112</a>   <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">XdrMODE</a> <a class="code" href="classXdr.php#a64db0524f8d88622b617146b99f23f3a">access_mode</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a>; }
<a name="l00113"></a>00113 
<a name="l00114"></a>00114   <span class="comment">// Data access methods</span>
<a name="l00115"></a>00115 
<a name="l00119"></a>00119   <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(<span class="keywordtype">int</span>&amp; a, <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classXdr.php#ae207fb366547ff14903d254281b535d6">comment</a>=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00120"></a>00120 
<a name="l00124"></a><a class="code" href="classXdr.php#adc075a4d9a9b7adde31a7affc7b65342">00124</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#adc075a4d9a9b7adde31a7affc7b65342">operator &lt;&lt; </a>(<span class="keywordtype">int</span>&amp; a) { libmesh_assert (<a class="code" href="classXdr.php#a697f12c5036ad61caae2ef98b6a480f1">writing</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(a); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00125"></a>00125 
<a name="l00129"></a><a class="code" href="classXdr.php#a420d4c71de5c0afe70f93a9d531f3f6c">00129</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#a420d4c71de5c0afe70f93a9d531f3f6c">operator &gt;&gt; </a>(<span class="keywordtype">int</span>&amp; a) { libmesh_assert (<a class="code" href="classXdr.php#a7092df3f10040c5a39a14385cc4888af">reading</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(a); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00130"></a>00130   
<a name="l00134"></a>00134   <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; a, <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classXdr.php#ae207fb366547ff14903d254281b535d6">comment</a>=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00135"></a>00135 
<a name="l00139"></a><a class="code" href="classXdr.php#ae11300d931cb1f3b4d236d04c92f37ea">00139</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#adc075a4d9a9b7adde31a7affc7b65342">operator &lt;&lt; </a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; a) { libmesh_assert (<a class="code" href="classXdr.php#a697f12c5036ad61caae2ef98b6a480f1">writing</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(a); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00140"></a>00140 
<a name="l00144"></a><a class="code" href="classXdr.php#a7f4bb915f3760b9653a2515a328d6205">00144</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#a420d4c71de5c0afe70f93a9d531f3f6c">operator &gt;&gt; </a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; a) { libmesh_assert (<a class="code" href="classXdr.php#a7092df3f10040c5a39a14385cc4888af">reading</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(a); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00145"></a>00145 
<a name="l00149"></a>00149   <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(<span class="keywordtype">short</span> <span class="keywordtype">int</span>&amp; a, <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classXdr.php#ae207fb366547ff14903d254281b535d6">comment</a>=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00150"></a>00150 
<a name="l00154"></a><a class="code" href="classXdr.php#a6aaa6d8e97a583973490acba6c69117b">00154</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#adc075a4d9a9b7adde31a7affc7b65342">operator &lt;&lt; </a>(<span class="keywordtype">short</span> <span class="keywordtype">int</span>&amp; a) { libmesh_assert (<a class="code" href="classXdr.php#a697f12c5036ad61caae2ef98b6a480f1">writing</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(a); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00155"></a>00155 
<a name="l00159"></a><a class="code" href="classXdr.php#ab9ad216ae8e198f867f5e582cedd5b88">00159</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#a420d4c71de5c0afe70f93a9d531f3f6c">operator &gt;&gt; </a>(<span class="keywordtype">short</span> <span class="keywordtype">int</span>&amp; a) { libmesh_assert (<a class="code" href="classXdr.php#a7092df3f10040c5a39a14385cc4888af">reading</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(a); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00160"></a>00160 
<a name="l00164"></a>00164   <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span>&amp; a, <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classXdr.php#ae207fb366547ff14903d254281b535d6">comment</a>=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00165"></a>00165 
<a name="l00169"></a><a class="code" href="classXdr.php#a6f2c6a9e4cd3024194fe1dd6bde094ec">00169</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#adc075a4d9a9b7adde31a7affc7b65342">operator &lt;&lt; </a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span>&amp; a) { libmesh_assert (<a class="code" href="classXdr.php#a697f12c5036ad61caae2ef98b6a480f1">writing</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(a); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00170"></a>00170 
<a name="l00174"></a><a class="code" href="classXdr.php#a0d3126607e252c69325145795146f8c5">00174</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#a420d4c71de5c0afe70f93a9d531f3f6c">operator &gt;&gt; </a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span>&amp; a) { libmesh_assert (<a class="code" href="classXdr.php#a7092df3f10040c5a39a14385cc4888af">reading</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(a); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00175"></a>00175 
<a name="l00179"></a>00179   <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(<span class="keywordtype">float</span>&amp; a, <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classXdr.php#ae207fb366547ff14903d254281b535d6">comment</a>=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00180"></a>00180 
<a name="l00184"></a><a class="code" href="classXdr.php#af01f34e9bd4a5d3e2f24819cb6b5bd41">00184</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#adc075a4d9a9b7adde31a7affc7b65342">operator &lt;&lt; </a>(<span class="keywordtype">float</span>&amp; a) { libmesh_assert (<a class="code" href="classXdr.php#a697f12c5036ad61caae2ef98b6a480f1">writing</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(a); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00185"></a>00185 
<a name="l00189"></a><a class="code" href="classXdr.php#a6e520e82d372e0c7feb7f28de5a0af25">00189</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#a420d4c71de5c0afe70f93a9d531f3f6c">operator &gt;&gt; </a>(<span class="keywordtype">float</span>&amp; a) { libmesh_assert (<a class="code" href="classXdr.php#a7092df3f10040c5a39a14385cc4888af">reading</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(a); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00190"></a>00190 
<a name="l00194"></a>00194   <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(<span class="keywordtype">double</span>&amp; a, <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classXdr.php#ae207fb366547ff14903d254281b535d6">comment</a>=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00195"></a>00195 
<a name="l00199"></a><a class="code" href="classXdr.php#a319fec6f4081515cba08fe9aa786eaed">00199</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#adc075a4d9a9b7adde31a7affc7b65342">operator &lt;&lt; </a>(<span class="keywordtype">double</span>&amp; a) { libmesh_assert (<a class="code" href="classXdr.php#a697f12c5036ad61caae2ef98b6a480f1">writing</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(a); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00200"></a>00200 
<a name="l00204"></a><a class="code" href="classXdr.php#af2ef6cd3afff41a24890c8711f262860">00204</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#a420d4c71de5c0afe70f93a9d531f3f6c">operator &gt;&gt; </a>(<span class="keywordtype">double</span>&amp; a) { libmesh_assert (<a class="code" href="classXdr.php#a7092df3f10040c5a39a14385cc4888af">reading</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(a); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00205"></a>00205 
<a name="l00209"></a><a class="code" href="classXdr.php#a8a75feb766941781be401deefcbb621e">00209</a>   <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(<span class="keywordtype">long</span> <span class="keywordtype">double</span>&amp; a, <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classXdr.php#ae207fb366547ff14903d254281b535d6">comment</a>=<span class="stringliteral">&quot;&quot;</span>) 
<a name="l00210"></a>00210     { <span class="keywordtype">double</span> ad = a;
<a name="l00211"></a>00211       <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(ad, <a class="code" href="classXdr.php#ae207fb366547ff14903d254281b535d6">comment</a>); }
<a name="l00212"></a>00212 
<a name="l00216"></a><a class="code" href="classXdr.php#afcb61c934e28c1bf509c002eb8874e88">00216</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#adc075a4d9a9b7adde31a7affc7b65342">operator &lt;&lt; </a>(<span class="keywordtype">long</span> <span class="keywordtype">double</span>&amp; a) { libmesh_assert (<a class="code" href="classXdr.php#a697f12c5036ad61caae2ef98b6a480f1">writing</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(a); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00217"></a>00217 
<a name="l00221"></a><a class="code" href="classXdr.php#acfb881bbc17c23421563f577272deb50">00221</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#a420d4c71de5c0afe70f93a9d531f3f6c">operator &gt;&gt; </a>(<span class="keywordtype">long</span> <span class="keywordtype">double</span>&amp; a) { libmesh_assert (<a class="code" href="classXdr.php#a7092df3f10040c5a39a14385cc4888af">reading</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(a); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00225"></a>00225 <span class="preprocessor"></span>
<a name="l00229"></a>00229   <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(std::complex&lt;double&gt;&amp; a, <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classXdr.php#ae207fb366547ff14903d254281b535d6">comment</a>=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00230"></a>00230 
<a name="l00234"></a><a class="code" href="classXdr.php#ac6ffec822c92e816178a7893e4097e20">00234</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; operator &lt;&lt; (std::complex&lt;double&gt;&amp; a) { libmesh_assert (<a class="code" href="classXdr.php#a697f12c5036ad61caae2ef98b6a480f1">writing</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(a); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00235"></a>00235 
<a name="l00239"></a><a class="code" href="classXdr.php#a98a3748713743039004e463c11df1fd9">00239</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#a420d4c71de5c0afe70f93a9d531f3f6c">operator &gt;&gt; </a>(std::complex&lt;double&gt;&amp; a) { libmesh_assert (<a class="code" href="classXdr.php#a7092df3f10040c5a39a14385cc4888af">reading</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(a); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00240"></a>00240 
<a name="l00245"></a><a class="code" href="classXdr.php#a7f282cf3507c28f77ee7c59f4cfc45cf">00245</a>   <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(std::complex&lt;long double&gt;&amp; a, <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classXdr.php#ae207fb366547ff14903d254281b535d6">comment</a>=<span class="stringliteral">&quot;&quot;</span>)
<a name="l00246"></a>00246     { std::complex&lt;double&gt; ad (a);
<a name="l00247"></a>00247       <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(ad, <a class="code" href="classXdr.php#ae207fb366547ff14903d254281b535d6">comment</a>); }
<a name="l00248"></a>00248 
<a name="l00252"></a><a class="code" href="classXdr.php#aac8f9f126fcf353b379d8322321cc385">00252</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; operator &lt;&lt; (std::complex&lt;long double&gt;&amp; a) { libmesh_assert (<a class="code" href="classXdr.php#a697f12c5036ad61caae2ef98b6a480f1">writing</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(a); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00253"></a>00253 
<a name="l00257"></a><a class="code" href="classXdr.php#a0329ef076099789160d19b3d67d20009">00257</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#a420d4c71de5c0afe70f93a9d531f3f6c">operator &gt;&gt; </a>(std::complex&lt;long double&gt;&amp; a) { libmesh_assert (<a class="code" href="classXdr.php#a7092df3f10040c5a39a14385cc4888af">reading</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(a); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00258"></a>00258 
<a name="l00259"></a>00259 <span class="preprocessor">#endif</span>
<a name="l00260"></a>00260 <span class="preprocessor"></span>
<a name="l00261"></a>00261 
<a name="l00265"></a>00265   <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(std::vector&lt;int&gt;&amp; v, <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classXdr.php#ae207fb366547ff14903d254281b535d6">comment</a>=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00266"></a>00266 
<a name="l00270"></a><a class="code" href="classXdr.php#a8e9be4ae13347552dfdfaa80eb1d15a3">00270</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; operator &lt;&lt; (std::vector&lt;int&gt;&amp; v) { libmesh_assert (<a class="code" href="classXdr.php#a697f12c5036ad61caae2ef98b6a480f1">writing</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(v); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00271"></a>00271 
<a name="l00275"></a><a class="code" href="classXdr.php#a809d9d59a074154ca827eaecf8f5560d">00275</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#a420d4c71de5c0afe70f93a9d531f3f6c">operator &gt;&gt; </a>(std::vector&lt;int&gt;&amp; v) { libmesh_assert (<a class="code" href="classXdr.php#a7092df3f10040c5a39a14385cc4888af">reading</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(v); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00276"></a>00276 
<a name="l00280"></a>00280   <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(std::vector&lt;unsigned int&gt;&amp; v, <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classXdr.php#ae207fb366547ff14903d254281b535d6">comment</a>=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00281"></a>00281 
<a name="l00285"></a><a class="code" href="classXdr.php#adceaad4a9b45965adc1f5e44fbf6043f">00285</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; operator &lt;&lt; (std::vector&lt;unsigned int&gt;&amp; v) { libmesh_assert (<a class="code" href="classXdr.php#a697f12c5036ad61caae2ef98b6a480f1">writing</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(v); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00286"></a>00286 
<a name="l00290"></a><a class="code" href="classXdr.php#ac17a4b9d642feeede5b3b66a121ded34">00290</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#a420d4c71de5c0afe70f93a9d531f3f6c">operator &gt;&gt; </a>(std::vector&lt;unsigned int&gt;&amp; v) { libmesh_assert (<a class="code" href="classXdr.php#a7092df3f10040c5a39a14385cc4888af">reading</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(v); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00291"></a>00291 
<a name="l00295"></a>00295   <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(std::vector&lt;short int&gt;&amp; v, <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classXdr.php#ae207fb366547ff14903d254281b535d6">comment</a>=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00296"></a>00296 
<a name="l00300"></a><a class="code" href="classXdr.php#af76a156c469f0253a9905be3814baac3">00300</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; operator &lt;&lt; (std::vector&lt;short int&gt;&amp; v) { libmesh_assert (<a class="code" href="classXdr.php#a697f12c5036ad61caae2ef98b6a480f1">writing</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(v); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00301"></a>00301 
<a name="l00305"></a><a class="code" href="classXdr.php#a33ae771e727bf02929afee1e5119440a">00305</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#a420d4c71de5c0afe70f93a9d531f3f6c">operator &gt;&gt; </a>(std::vector&lt;short int&gt;&amp; v) { libmesh_assert (<a class="code" href="classXdr.php#a7092df3f10040c5a39a14385cc4888af">reading</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(v); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00306"></a>00306 
<a name="l00310"></a>00310   <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(std::vector&lt;unsigned short int&gt;&amp; v, <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classXdr.php#ae207fb366547ff14903d254281b535d6">comment</a>=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00311"></a>00311 
<a name="l00315"></a><a class="code" href="classXdr.php#af9cc80db02c1bb62bcc80affe0d600d9">00315</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; operator &lt;&lt; (std::vector&lt;unsigned short int&gt;&amp; v) { libmesh_assert (<a class="code" href="classXdr.php#a697f12c5036ad61caae2ef98b6a480f1">writing</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(v); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00316"></a>00316 
<a name="l00320"></a><a class="code" href="classXdr.php#ac653c6e0db670158383a46ce3488cd78">00320</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#a420d4c71de5c0afe70f93a9d531f3f6c">operator &gt;&gt; </a>(std::vector&lt;unsigned short int&gt;&amp; v) { libmesh_assert (<a class="code" href="classXdr.php#a7092df3f10040c5a39a14385cc4888af">reading</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(v); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00321"></a>00321 
<a name="l00325"></a>00325   <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(std::vector&lt;float&gt;&amp; v, <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classXdr.php#ae207fb366547ff14903d254281b535d6">comment</a>=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00326"></a>00326 
<a name="l00330"></a><a class="code" href="classXdr.php#aab960570242c9f23467f7fd3cc34fcd9">00330</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; operator &lt;&lt; (std::vector&lt;float&gt;&amp; v) { libmesh_assert (<a class="code" href="classXdr.php#a697f12c5036ad61caae2ef98b6a480f1">writing</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(v); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00331"></a>00331 
<a name="l00335"></a><a class="code" href="classXdr.php#aaf07618454ba35b32c548d62d65ab08d">00335</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#a420d4c71de5c0afe70f93a9d531f3f6c">operator &gt;&gt; </a>(std::vector&lt;float&gt;&amp; v) { libmesh_assert (<a class="code" href="classXdr.php#a7092df3f10040c5a39a14385cc4888af">reading</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(v); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00336"></a>00336 
<a name="l00340"></a>00340   <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(std::vector&lt;double&gt;&amp; v, <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classXdr.php#ae207fb366547ff14903d254281b535d6">comment</a>=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00341"></a>00341 
<a name="l00345"></a><a class="code" href="classXdr.php#adec841206310628ebcc5363cba6239b6">00345</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; operator &lt;&lt; (std::vector&lt;double&gt;&amp; v) { libmesh_assert (<a class="code" href="classXdr.php#a697f12c5036ad61caae2ef98b6a480f1">writing</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(v); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00346"></a>00346 
<a name="l00350"></a><a class="code" href="classXdr.php#ab0bf126bbedbf5b5cebd8f606dd7f101">00350</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#a420d4c71de5c0afe70f93a9d531f3f6c">operator &gt;&gt; </a>(std::vector&lt;double&gt;&amp; v) { libmesh_assert (<a class="code" href="classXdr.php#a7092df3f10040c5a39a14385cc4888af">reading</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(v); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00351"></a>00351 
<a name="l00356"></a><a class="code" href="classXdr.php#ab436d468597efe7b19ddffdc3f813286">00356</a>   <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(std::vector&lt;long double&gt;&amp; v, <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classXdr.php#ae207fb366547ff14903d254281b535d6">comment</a>=<span class="stringliteral">&quot;&quot;</span>)
<a name="l00357"></a>00357     { std::vector&lt;double&gt; vd(v.size());
<a name="l00358"></a>00358       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != v.size(); ++i)
<a name="l00359"></a>00359         vd[i] = static_cast&lt;double&gt;(v[i]);
<a name="l00360"></a>00360       <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(vd, <a class="code" href="classXdr.php#ae207fb366547ff14903d254281b535d6">comment</a>);
<a name="l00361"></a>00361       v.resize(vd.size());
<a name="l00362"></a>00362       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != vd.size(); ++i)
<a name="l00363"></a>00363         v[i] = static_cast&lt;long double&gt;(vd[i]);
<a name="l00364"></a>00364     }
<a name="l00365"></a>00365 
<a name="l00369"></a><a class="code" href="classXdr.php#a97ece939dcb3db7dcecb5bc1592234ef">00369</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; operator &lt;&lt; (std::vector&lt;long double&gt;&amp; v) { libmesh_assert (<a class="code" href="classXdr.php#a697f12c5036ad61caae2ef98b6a480f1">writing</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(v); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00370"></a>00370 
<a name="l00374"></a><a class="code" href="classXdr.php#a7d8a19ebe18ee0530285836e1eb30fbb">00374</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#a420d4c71de5c0afe70f93a9d531f3f6c">operator &gt;&gt; </a>(std::vector&lt;long double&gt;&amp; v) { libmesh_assert (<a class="code" href="classXdr.php#a7092df3f10040c5a39a14385cc4888af">reading</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(v); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00375"></a>00375 
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00378"></a>00378 <span class="preprocessor"></span>
<a name="l00382"></a>00382   <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(std::vector&lt; std::complex&lt;double&gt; &gt;&amp; v, <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classXdr.php#ae207fb366547ff14903d254281b535d6">comment</a>=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00383"></a>00383 
<a name="l00387"></a><a class="code" href="classXdr.php#ae13b43ab99c31588b44d17cfd2065a2b">00387</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; operator &lt;&lt; (std::vector&lt; std::complex&lt;double&gt; &gt;&amp; v) { libmesh_assert (<a class="code" href="classXdr.php#a697f12c5036ad61caae2ef98b6a480f1">writing</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(v); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00388"></a>00388 
<a name="l00392"></a><a class="code" href="classXdr.php#a3d8510d4f57a64baea7ddb7d0e526c26">00392</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#a420d4c71de5c0afe70f93a9d531f3f6c">operator &gt;&gt; </a>(std::vector&lt; std::complex&lt;double&gt; &gt;&amp; v) { libmesh_assert (<a class="code" href="classXdr.php#a7092df3f10040c5a39a14385cc4888af">reading</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(v); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00393"></a>00393 
<a name="l00394"></a>00394 <span class="preprocessor">#endif</span>
<a name="l00395"></a>00395 <span class="preprocessor"></span>
<a name="l00396"></a>00396 
<a name="l00400"></a>00400   <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(std::string&amp; s, <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classXdr.php#ae207fb366547ff14903d254281b535d6">comment</a>=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00401"></a>00401 
<a name="l00405"></a><a class="code" href="classXdr.php#a92232e634c3a2d2c166cd86baaba55e7">00405</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#adc075a4d9a9b7adde31a7affc7b65342">operator &lt;&lt; </a>(std::string&amp; v) { libmesh_assert (<a class="code" href="classXdr.php#a697f12c5036ad61caae2ef98b6a480f1">writing</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(v); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00406"></a>00406 
<a name="l00410"></a><a class="code" href="classXdr.php#a7e49829123a9b7dad72e98c826b00fb4">00410</a>   <a class="code" href="classXdr.php">Xdr</a>&amp; <a class="code" href="classXdr.php#a420d4c71de5c0afe70f93a9d531f3f6c">operator &gt;&gt; </a>(std::string&amp; v) { libmesh_assert (<a class="code" href="classXdr.php#a7092df3f10040c5a39a14385cc4888af">reading</a>()); <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(v); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00411"></a>00411 
<a name="l00412"></a>00412 
<a name="l00416"></a>00416   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00417"></a>00417   <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a4078d136e6c78973c278ff3e073a8e7a">data_stream</a> (T *val, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> line_break=<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>);
<a name="l00418"></a>00418 
<a name="l00422"></a>00422   <span class="keywordtype">void</span> <a class="code" href="classXdr.php#ae207fb366547ff14903d254281b535d6">comment</a> (std::string &amp;);
<a name="l00423"></a>00423   
<a name="l00424"></a>00424 
<a name="l00425"></a>00425 <span class="keyword">private</span>:
<a name="l00426"></a>00426 
<a name="l00430"></a><a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">00430</a>   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">XdrMODE</a> <a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a>;
<a name="l00431"></a>00431 
<a name="l00435"></a><a class="code" href="classXdr.php#a991eb4c2747e6cf24ddaf32ff053d35c">00435</a>   std::string <a class="code" href="classXdr.php#a991eb4c2747e6cf24ddaf32ff053d35c">file_name</a>;
<a name="l00436"></a>00436 
<a name="l00437"></a>00437 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00438"></a>00438 <span class="preprocessor"></span>  
<a name="l00445"></a><a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">00445</a>   XDR* <a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>;
<a name="l00446"></a>00446 
<a name="l00450"></a><a class="code" href="classXdr.php#ab3197bdc430b239a1c65e5d656e591d1">00450</a>   FILE* <a class="code" href="classXdr.php#ab3197bdc430b239a1c65e5d656e591d1">fp</a>;
<a name="l00451"></a>00451   
<a name="l00452"></a>00452 <span class="preprocessor">#endif</span>
<a name="l00453"></a>00453 <span class="preprocessor"></span>
<a name="l00457"></a><a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">00457</a>   <a class="code" href="classAutoPtr.php">AutoPtr&lt;std::istream&gt;</a> <a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>;
<a name="l00458"></a>00458 
<a name="l00462"></a><a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">00462</a>   <a class="code" href="classAutoPtr.php">AutoPtr&lt;std::ostream&gt;</a> <a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>;
<a name="l00463"></a>00463 
<a name="l00467"></a><a class="code" href="classXdr.php#a4165407163334f62a2c3f6996bac9285">00467</a>   <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classXdr.php#a4165407163334f62a2c3f6996bac9285">comm_len</a>;
<a name="l00468"></a><a class="code" href="classXdr.php#a81450b392666e82559afab3676c1adda">00468</a>   <span class="keywordtype">char</span> <a class="code" href="classXdr.php#a81450b392666e82559afab3676c1adda">comm</a>[xdr_MAX_STRING_LENGTH];  
<a name="l00469"></a>00469 
<a name="l00473"></a><a class="code" href="classXdr.php#a64c209ad9346d907ee753635a7480d3f">00473</a>   <span class="keywordtype">bool</span> <a class="code" href="classXdr.php#a64c209ad9346d907ee753635a7480d3f">gzipped_file</a>;
<a name="l00474"></a><a class="code" href="classXdr.php#a38d1340ec83b8ea9be03b83fe09b92d1">00474</a>   <span class="keywordtype">bool</span> <a class="code" href="classXdr.php#a38d1340ec83b8ea9be03b83fe09b92d1">bzipped_file</a>;
<a name="l00475"></a>00475 };
<a name="l00476"></a>00476 
<a name="l00477"></a>00477 
<a name="l00478"></a>00478 
<a name="l00479"></a>00479 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
