<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>xdr_head.C</h1>  </div>
</div>
<div class="contents">
<a href="xdr__head_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: xdr_head.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// Local includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;xdr_head.h&quot;</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00024"></a>00024 <span class="comment">// XdrHEAD members</span>
<a name="l00025"></a><a class="code" href="classXdrHEAD.php#a0c52e2889eb8675d8a2ea117e599201a">00025</a> <a class="code" href="classXdrHEAD.php#a0c52e2889eb8675d8a2ea117e599201a">XdrHEAD::XdrHEAD</a>() 
<a name="l00026"></a>00026 {
<a name="l00027"></a>00027   <a class="code" href="classXdrHEAD.php#a1a2f50716aecde404db9d86103d91a2d">m_wrtVar</a> = 0;
<a name="l00028"></a>00028   <a class="code" href="classXdrHEAD.php#a3ffced6b091b8c588c5be66e48982aa7">m_numvar</a> = 0;
<a name="l00029"></a>00029   
<a name="l00030"></a>00030   <a class="code" href="classXdrHEAD.php#a0b9bef29b079e2d65bed8e618d9b00fb">m_meshCnt</a> = 0;
<a name="l00031"></a>00031   <a class="code" href="classXdrHEAD.php#a7566f85e92e2aa921e1876bf3138520e">m_kstep</a> = 0;
<a name="l00032"></a>00032   
<a name="l00033"></a>00033   <a class="code" href="classXdrHEAD.php#aa6614145e5a33854a3be764445085a93">m_numel</a> = 0;
<a name="l00034"></a>00034   <a class="code" href="classXdrHEAD.php#a1f0eb297b78a331b02c95bb9269243f1">m_numNodes</a> = 0;
<a name="l00035"></a>00035   <a class="code" href="classXdrHEAD.php#a9e6fb8f20c89ee79c3f340f8d6b38df2">m_sumWghts</a> = 0;
<a name="l00036"></a>00036   <a class="code" href="classXdrHEAD.php#acc1c4c5f2b0bdb02c0dcd4053e9f7c1e">m_numBCs</a> = 0;
<a name="l00037"></a>00037   <a class="code" href="classXdrHEAD.php#a60cd9ef0718761d4398c058b067f4d33">m_strSize</a> = 0;
<a name="l00038"></a>00038   <a class="code" href="classXdrHEAD.php#ab035b1f627467cb2596ff33241d23066">mp_id</a> = 0;
<a name="l00039"></a>00039   <a class="code" href="classXdrHEAD.php#afdd2b89c79ace9409cb86fb5c13bbcab">mp_title</a> = 0;
<a name="l00040"></a>00040   <a class="code" href="classXdrHEAD.php#a5ec0f7dbd17dca2a040810979c035dba">mp_userTitle</a> = 0;
<a name="l00041"></a>00041   <a class="code" href="classXdrHEAD.php#a86d8da1ba890a36171317ab3208b7b43">mp_varTitle</a> = 0;
<a name="l00042"></a>00042   
<a name="l00043"></a>00043   <a class="code" href="classXdrHEAD.php#ad31ef084953312f6d47d26f9ba63f44c">m_time</a> = 0;
<a name="l00044"></a>00044 }
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00048"></a><a class="code" href="classXdrHEAD.php#ac4ff6f0729508297e58b90b8c0865616">00048</a> <a class="code" href="classXdrHEAD.php#ac4ff6f0729508297e58b90b8c0865616">XdrHEAD::~XdrHEAD</a>()
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050   <span class="keyword">delete</span> [] <a class="code" href="classXdrHEAD.php#ab035b1f627467cb2596ff33241d23066">mp_id</a>;
<a name="l00051"></a>00051   <span class="keyword">delete</span> [] <a class="code" href="classXdrHEAD.php#afdd2b89c79ace9409cb86fb5c13bbcab">mp_title</a>;
<a name="l00052"></a>00052   <span class="keyword">delete</span> [] <a class="code" href="classXdrHEAD.php#a5ec0f7dbd17dca2a040810979c035dba">mp_userTitle</a>;
<a name="l00053"></a>00053   <span class="keyword">delete</span> [] <a class="code" href="classXdrHEAD.php#a86d8da1ba890a36171317ab3208b7b43">mp_varTitle</a>; 
<a name="l00054"></a>00054 }
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a><a class="code" href="classXdrHEAD.php#af3f2516d6140aa889be32be392d7433d">00058</a> <span class="keywordtype">char</span>* <a class="code" href="classXdrHEAD.php#af3f2516d6140aa889be32be392d7433d">XdrHEAD::cpyString</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* src, <span class="keywordtype">int</span> len)
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060   <span class="keywordtype">char</span>* temp = NULL;
<a name="l00061"></a>00061   <span class="keywordtype">int</span> myLen = len;
<a name="l00062"></a>00062   <span class="keywordflow">if</span>(src)
<a name="l00063"></a>00063     {
<a name="l00064"></a>00064       <span class="keywordflow">if</span> (myLen == -1)
<a name="l00065"></a>00065         myLen = std::strlen(src)+1;
<a name="l00066"></a>00066       temp = <span class="keyword">new</span> <span class="keywordtype">char</span>[myLen];
<a name="l00067"></a>00067       temp = (<span class="keywordtype">char</span> *) std::memcpy(temp, (<span class="keywordtype">char</span> *) src, (myLen)*<span class="keyword">sizeof</span>(<span class="keywordtype">char</span>));
<a name="l00068"></a>00068     }
<a name="l00069"></a>00069   <span class="keywordflow">return</span> temp;
<a name="l00070"></a>00070 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
