<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>xdr_head.h</h1>  </div>
</div>
<div class="contents">
<a href="xdr__head_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: xdr_head.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __xdr_head_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __xdr_head_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="xdr__mgf_8h.php">xdr_mgf.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00033"></a><a class="code" href="classXdrHEAD.php">00033</a> <span class="keyword">class </span><a class="code" href="classXdrHEAD.php">XdrHEAD</a>
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 <span class="keyword">public</span>:
<a name="l00039"></a>00039   <a class="code" href="classXdrHEAD.php#a0c52e2889eb8675d8a2ea117e599201a">XdrHEAD</a>();
<a name="l00040"></a>00040 
<a name="l00044"></a>00044   <span class="keyword">virtual</span> <a class="code" href="classXdrHEAD.php#ac4ff6f0729508297e58b90b8c0865616">~XdrHEAD</a>();
<a name="l00045"></a>00045 
<a name="l00049"></a><a class="code" href="classXdrHEAD.php#aeb16debcad0ecb4eb73111d3b9094acf">00049</a>   <span class="keywordtype">void</span> <a class="code" href="classXdrHEAD.php#aeb16debcad0ecb4eb73111d3b9094acf">setId</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* <span class="keywordtype">id</span>)           { <span class="keyword">delete</span> [] <a class="code" href="classXdrHEAD.php#ab035b1f627467cb2596ff33241d23066">mp_id</a>; <a class="code" href="classXdrHEAD.php#ab035b1f627467cb2596ff33241d23066">mp_id</a> = <a class="code" href="classXdrHEAD.php#af3f2516d6140aa889be32be392d7433d">cpyString</a>(<span class="keywordtype">id</span>); }
<a name="l00050"></a>00050 
<a name="l00054"></a><a class="code" href="classXdrHEAD.php#a9a6f09b86d6727193f188388a3163ff2">00054</a>   <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classXdrHEAD.php#a9a6f09b86d6727193f188388a3163ff2">getId</a>()<span class="keyword"> const            </span>{ <span class="keywordflow">return</span> <a class="code" href="classXdrHEAD.php#ab035b1f627467cb2596ff33241d23066">mp_id</a>; }
<a name="l00055"></a>00055 
<a name="l00059"></a><a class="code" href="classXdrHEAD.php#afb33d2828af0a74f460e0042cf5dc685">00059</a>   <span class="keywordtype">void</span> <a class="code" href="classXdrHEAD.php#afb33d2828af0a74f460e0042cf5dc685">setTitle</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* title)     { <span class="keyword">delete</span> [] <a class="code" href="classXdrHEAD.php#afdd2b89c79ace9409cb86fb5c13bbcab">mp_title</a>; <a class="code" href="classXdrHEAD.php#afdd2b89c79ace9409cb86fb5c13bbcab">mp_title</a> = <a class="code" href="classXdrHEAD.php#af3f2516d6140aa889be32be392d7433d">cpyString</a>(title); }
<a name="l00060"></a>00060 
<a name="l00064"></a><a class="code" href="classXdrHEAD.php#a6bbf612bfea8cfacfa2a80da0bbb2bb4">00064</a>   <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classXdrHEAD.php#a6bbf612bfea8cfacfa2a80da0bbb2bb4">getTitle</a>()<span class="keyword"> const         </span>{ <span class="keywordflow">return</span> <a class="code" href="classXdrHEAD.php#afdd2b89c79ace9409cb86fb5c13bbcab">mp_title</a>; }
<a name="l00065"></a>00065 
<a name="l00070"></a><a class="code" href="classXdrHEAD.php#a8433d0be6562374a41a361bb58e147d0">00070</a>   <span class="keywordtype">void</span> <a class="code" href="classXdrHEAD.php#a8433d0be6562374a41a361bb58e147d0">setNumNodes</a>(<span class="keywordtype">int</span> numNodes)       { <a class="code" href="classXdrHEAD.php#a1f0eb297b78a331b02c95bb9269243f1">m_numNodes</a> = numNodes; }
<a name="l00071"></a>00071 
<a name="l00076"></a><a class="code" href="classXdrHEAD.php#a2aa8f41b3f519596a0b5755aceb5956a">00076</a>   <span class="keywordtype">int</span>  <a class="code" href="classXdrHEAD.php#a2aa8f41b3f519596a0b5755aceb5956a">getNumNodes</a>()<span class="keyword"> const             </span>{ <span class="keywordflow">return</span> <a class="code" href="classXdrHEAD.php#a1f0eb297b78a331b02c95bb9269243f1">m_numNodes</a>; }
<a name="l00077"></a>00077 
<a name="l00083"></a><a class="code" href="classXdrHEAD.php#a2cdfac4576a940c9536e21e4a78b204c">00083</a>   <span class="keywordtype">void</span> <a class="code" href="classXdrHEAD.php#a2cdfac4576a940c9536e21e4a78b204c">setNumBCs</a>(<span class="keywordtype">int</span> numBCs)           { <a class="code" href="classXdrHEAD.php#acc1c4c5f2b0bdb02c0dcd4053e9f7c1e">m_numBCs</a> = numBCs; }
<a name="l00084"></a>00084 
<a name="l00090"></a><a class="code" href="classXdrHEAD.php#a6fb33c2762528f301d785e0bd5d0ea45">00090</a>   <span class="keywordtype">int</span>  <a class="code" href="classXdrHEAD.php#a6fb33c2762528f301d785e0bd5d0ea45">getNumBCs</a>()<span class="keyword"> const               </span>{ <span class="keywordflow">return</span> <a class="code" href="classXdrHEAD.php#acc1c4c5f2b0bdb02c0dcd4053e9f7c1e">m_numBCs</a>; }
<a name="l00091"></a>00091 
<a name="l00096"></a><a class="code" href="classXdrHEAD.php#aa4234fc2655312231e1596822b756bda">00096</a>   <span class="keywordtype">void</span> <a class="code" href="classXdrHEAD.php#aa4234fc2655312231e1596822b756bda">setStrSize</a>(<span class="keywordtype">int</span> strSize)         { <a class="code" href="classXdrHEAD.php#a60cd9ef0718761d4398c058b067f4d33">m_strSize</a> = strSize; }
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   <span class="comment">//     /**</span>
<a name="l00099"></a>00099   <span class="comment">//      * Set the string size of the</span>
<a name="l00100"></a>00100   <span class="comment">//      * mesh /solutionfile. (?)</span>
<a name="l00101"></a>00101   <span class="comment">//      */</span>
<a name="l00102"></a>00102   <span class="comment">//     int  getStrSize() const              { return m_strSize; }</span>
<a name="l00103"></a>00103   
<a name="l00104"></a>00104 <span class="keyword">protected</span>:
<a name="l00105"></a>00105        
<a name="l00110"></a><a class="code" href="classXdrHEAD.php#a1a2f50716aecde404db9d86103d91a2d">00110</a>   <span class="keywordtype">int</span> <a class="code" href="classXdrHEAD.php#a1a2f50716aecde404db9d86103d91a2d">m_wrtVar</a>;
<a name="l00111"></a>00111 
<a name="l00118"></a><a class="code" href="classXdrHEAD.php#a3ffced6b091b8c588c5be66e48982aa7">00118</a>   <span class="keywordtype">int</span> <a class="code" href="classXdrHEAD.php#a3ffced6b091b8c588c5be66e48982aa7">m_numvar</a>;
<a name="l00119"></a>00119 
<a name="l00125"></a><a class="code" href="classXdrHEAD.php#a0b9bef29b079e2d65bed8e618d9b00fb">00125</a>   <span class="keywordtype">int</span> <a class="code" href="classXdrHEAD.php#a0b9bef29b079e2d65bed8e618d9b00fb">m_meshCnt</a>;
<a name="l00126"></a>00126 
<a name="l00130"></a><a class="code" href="classXdrHEAD.php#a7566f85e92e2aa921e1876bf3138520e">00130</a>   <span class="keywordtype">int</span> <a class="code" href="classXdrHEAD.php#a7566f85e92e2aa921e1876bf3138520e">m_kstep</a>;
<a name="l00131"></a>00131 
<a name="l00136"></a><a class="code" href="classXdrHEAD.php#aa6614145e5a33854a3be764445085a93">00136</a>   <span class="keywordtype">int</span> <a class="code" href="classXdrHEAD.php#aa6614145e5a33854a3be764445085a93">m_numel</a>;
<a name="l00137"></a>00137 
<a name="l00142"></a><a class="code" href="classXdrHEAD.php#a1f0eb297b78a331b02c95bb9269243f1">00142</a>   <span class="keywordtype">int</span> <a class="code" href="classXdrHEAD.php#a1f0eb297b78a331b02c95bb9269243f1">m_numNodes</a>;
<a name="l00143"></a>00143 
<a name="l00149"></a><a class="code" href="classXdrHEAD.php#a9e6fb8f20c89ee79c3f340f8d6b38df2">00149</a>   <span class="keywordtype">int</span> <a class="code" href="classXdrHEAD.php#a9e6fb8f20c89ee79c3f340f8d6b38df2">m_sumWghts</a>;
<a name="l00150"></a>00150 
<a name="l00155"></a><a class="code" href="classXdrHEAD.php#acc1c4c5f2b0bdb02c0dcd4053e9f7c1e">00155</a>   <span class="keywordtype">int</span> <a class="code" href="classXdrHEAD.php#acc1c4c5f2b0bdb02c0dcd4053e9f7c1e">m_numBCs</a>;
<a name="l00156"></a>00156 
<a name="l00160"></a><a class="code" href="classXdrHEAD.php#a60cd9ef0718761d4398c058b067f4d33">00160</a>   <span class="keywordtype">int</span> <a class="code" href="classXdrHEAD.php#a60cd9ef0718761d4398c058b067f4d33">m_strSize</a>;
<a name="l00161"></a>00161 
<a name="l00165"></a><a class="code" href="classXdrHEAD.php#ab035b1f627467cb2596ff33241d23066">00165</a>   <span class="keywordtype">char</span>* <a class="code" href="classXdrHEAD.php#ab035b1f627467cb2596ff33241d23066">mp_id</a>;
<a name="l00166"></a>00166 
<a name="l00170"></a><a class="code" href="classXdrHEAD.php#afdd2b89c79ace9409cb86fb5c13bbcab">00170</a>   <span class="keywordtype">char</span>* <a class="code" href="classXdrHEAD.php#afdd2b89c79ace9409cb86fb5c13bbcab">mp_title</a>;
<a name="l00171"></a>00171 
<a name="l00175"></a><a class="code" href="classXdrHEAD.php#a5ec0f7dbd17dca2a040810979c035dba">00175</a>   <span class="keywordtype">char</span>* <a class="code" href="classXdrHEAD.php#a5ec0f7dbd17dca2a040810979c035dba">mp_userTitle</a>;
<a name="l00176"></a>00176 
<a name="l00180"></a><a class="code" href="classXdrHEAD.php#a86d8da1ba890a36171317ab3208b7b43">00180</a>   <span class="keywordtype">char</span>* <a class="code" href="classXdrHEAD.php#a86d8da1ba890a36171317ab3208b7b43">mp_varTitle</a>;
<a name="l00181"></a>00181 
<a name="l00185"></a><a class="code" href="classXdrHEAD.php#ad31ef084953312f6d47d26f9ba63f44c">00185</a>   xdr_Real <a class="code" href="classXdrHEAD.php#ad31ef084953312f6d47d26f9ba63f44c">m_time</a>;
<a name="l00186"></a>00186 
<a name="l00196"></a>00196   <span class="keywordtype">char</span>* <a class="code" href="classXdrHEAD.php#af3f2516d6140aa889be32be392d7433d">cpyString</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* src, <span class="keywordtype">int</span> len = -1);
<a name="l00197"></a>00197   
<a name="l00198"></a>00198 <span class="keyword">private</span>:
<a name="l00199"></a>00199   <a class="code" href="classXdrHEAD.php#a0c52e2889eb8675d8a2ea117e599201a">XdrHEAD</a>(<span class="keyword">const</span> <a class="code" href="classXdrHEAD.php">XdrHEAD</a>&amp;);
<a name="l00200"></a>00200   <span class="keyword">const</span> <a class="code" href="classXdrHEAD.php">XdrHEAD</a>&amp; <a class="code" href="classXdrHEAD.php#a3140be07953fab2671fded2522354958">operator=</a>(<span class="keyword">const</span> <a class="code" href="classXdrHEAD.php">XdrHEAD</a>&amp;);
<a name="l00201"></a>00201 };
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 <span class="preprocessor">#endif // #ifndef __xdr_head_h__</span>
<a name="l00206"></a>00206 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
